         TITLE 'IEFAB427 -ALLOCATE SUBSYSTEM DATASETS                  *
                        '
IEFAB427 CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(24)                                          01S0001
         DC    C'IEFAB427 78108  UZ18216 '                      01S0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01S0001
         BALR  @12,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@12                                      01S0001
         L     @00,@SIZDATD                                     01S0001
         MODESET EXTKEY=SCHED,SAVEKEY=(2)
         GSPACE   R,LV=(0)
         LR    @11,@01                                          01S0001
         USING @DATD,@11                                        01S0001
         ST    @13,@SA00001+4                                   01S0001
         STC   @02,@OLDKEY                                      01S0001
         MODESET KEYADDR=(2)
         LM    @00,@02,20(@13)                                  01S0001
         ST    @11,8(,@13)                                      01S0001
         LR    @13,@11                                          01S0001
         MODESET EXTKEY=ZERO
         MVC   @PC00001(4),0(@01)                               01S0001
         MODESET EXTKEY=SCHED
*RETCODE = ZERO;                       /*CLEAR RETURN CODE   @G29AN2F*/
         SLR   RETCODE,RETCODE                                  01S0082
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - BILDSSOB                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - BUILD SUBSYSTEM INTERFACE COMMON BLOCK        */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THE PURPOSE OF THIS ROUTINE IS TO BUILD THE SSOB BLOCK,        */
*/*   WHICH IS PART OF THS SUBSYSTEM INTERFACE, (ALLOCATE SUBSYSTEM  */
*/*   REQUESTS). IT ALSO FILLS IN CANCEL AND WAIT INDICATOR FIELDS   */
*/*   IN THE SSAL BLOCK.                                             */
*/*                                                                  */
*/* ENTRY - INLINE SUBROUTINE                                        */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/* IN LINE SUBROUTINES -                                            */
*/*    BILDSSOB  INITIALIZE SUBSYSTEM INTERFACE COMMON  BLOCK        */
*/*    BILDSSAL  BUILD SSAL BLOCK                                    */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*     FMAPPTR  - POINTER TO FUNCTION MAP                           */
*/*     ALCWAPTR - POINTER TO ALLOCATION WORK AREA                   */
*/*     SIOTPTR  - POINTER TO SIOT                                   */
*/*                                                                  */
*/*                                                                  */
*/* EXIT - INLINE                                                    */
*/*                                                                  */
*/*   CONDITON - SSOB BLOCK CONSTRUCTED                              */
*/*              SSAL PARTIALLY CONSTRUCTED                          */
*/*                                                                  */
*/*     OUTPUT -                                                     */
*/*       SSOB BLOCK                                                 */
*/*       SSALCNCL,SSALWAIT,SSALDYNM SET                             */
*/*                                                                  */
*/*     RETURN CODE - (NONE)                                         */
*/*                                                                  */
*/*                                                                  */
*/********************************************************************/
*SSOB = SSOB && SSOB;                  /*CLEAR SSOB                  */
         XC    SSOB(20),SSOB                                    02S0083
*SSAL = SSAL && SSAL;                  /*CLEAR SSAL                  */
         XC    SSAL(64),SSAL                                    02S0084
*SSOBID   = CNSTSSOB;                  /*CNTRL BLOCK IDENTIFIER      */
         MVC   SSOBID(4),CNSTSSOB                               02S0085
*SSOBLEN  = LENGTH(SSOB);              /*LENGTH OF SSOB HEADER       */
         MVC   SSOBLEN(2),@CH01157                              02S0086
*SSOBFUNC = SSOBALOC;                  /*FUNCTION IS ALLOCATION      */
         MVC   SSOBFUNC(2),@CH01038                             02S0087
*SSOBINDV = ADDR(SSAL);                /*POINT TO SSAL BLOCK         */
         LA    @08,SSAL                                         02S0088
         ST    @08,SSOBINDV                                     02S0088
*SSALLEN = LENGTH(SSAL);               /*BUILD SSAL                  */
         MVC   SSALLEN(2),@CH01575                              02S0089
*IF WAITOKSW = ON THEN                 /*CHECK FUNCTION MAP          */
         L     @08,@PC00001                                     02S0090
         L     @08,ALCWAPTR(,@08)                               02S0090
         L     @01,FMAPPTR(,@08)                                02S0090
         TM    WAITOKSW(@01),B'00000100'                        02S0090
         BNO   @RF00090                                         02S0090
*  DO;                                 /*OK TO WAIT FOR SS DATA SET  */
*    SSALCNCL = CANCELP;               /*PTR TO ADDRESS OF CANCEL ECB*/
         MVC   SSALCNCL(4),CANCELP(@08)                         02S0092
*    SSALWAIT = ON;                    /*OK TO WAIT FOR DEVICES      */
         OI    SSALWAIT,B'00010000'                             02S0093
*  END;                                                         02S0094
*ELSE;                                                          02S0095
@RF00090 DS    0H                                               02S0096
*SSIBPTR = ADDR(LSSIB);                /*SET SSIB BASE PTR   @G29AN2F*/
         LA    @08,LSSIB                                        01S0096
         ST    @08,SSIBPTR                                      01S0096
*IF SU29BIT ^= ON THEN                 /*IF NEW FUNCTION SU  @G29AN2F*/
         L     @08,CVTPTR                                       01S0097
         L     @08,CVTIHASU(,@08)                               01S0097
         TM    SU29BIT(@08),B'00000100'                         01S0097
         BO    @RF00097                                         01S0097
*  DO;                                 /*NOT INSTALLED DO AS    01S0098
*                                        BEFORE              @G29AN2F*/
*    SIOTPTR = SIOT1P;                 /*POINT TO FIRST SIOT         */
         L     @15,@PC00001                                     01S0099
         L     @01,ALCWAPTR(,@15)                               01S0099
         L     SIOTPTR,SIOT1P(,@01)                             01S0099
*    DO WHILE SIOTPTR ^= ZERO          /*PROCESS ALL SIOTS           */
*           & SUBSREQS^= ZERO          /*PROCESS ALL SUBSYS REQUESTS */
*             & RETCODE= ZERO;         /*WHILE NO ERROR OCCURS       */
         B     @DE00100                                         01S0100
@DL00100 DS    0H                                               01S0101
*      IF SIOTSSDS = ON THEN           /*IS THIS A SUBSYSTEM REQUEST?*/
         TM    SIOTSSDS(SIOTPTR),B'10000000'                    01S0101
         BNO   @RF00101                                         01S0101
*        CALL ALOCNGRP;                /*ALLOCATE REQUESTS   @G29AN2F*/
         BAL   @14,ALOCNGRP                                     01S0102
*      ELSE;                                                    01S0103
@RF00101 DS    0H                                               01S0104
*      SIOTPTR = SIOTNPTR;             /*POINT TO NEXT SIOT          */
         L     SIOTPTR,SIOTNPTR(,SIOTPTR)                       01S0104
*    END;                                                       01S0105
@DE00100 SLR   @09,@09                                          01S0105
         CR    SIOTPTR,@09                                      01S0105
         BE    @DC00100                                         01S0105
         L     @15,@PC00001                                     01S0105
         L     @01,ALCWAPTR(,@15)                               01S0105
         C     @09,SUBSREQS(,@01)                               01S0105
         BE    @DC00100                                         01S0105
         CR    RETCODE,@09                                      01S0105
         BE    @DL00100                                         01S0105
@DC00100 DS    0H                                               01S0106
*  END;                                /*END NON-SU PROCESS  @G29AN2F*/
*ELSE                                  /*SU IS INSTALLED     @G29AN2F*/
*  DO;                                 /*DO SU PROCESSING    @G29AN2F*/
         B     @RC00097                                         01S0107
@RF00097 DS    0H                                               01S0108
*/********************************************************************/
*/*                                                          @G29AN2F*/
*/* SEGMENT NAME - BLDTBLS                                   @G29AN2F*/
*/*                                                          @G29AN2F*/
*/* DESCRIPTIVE NAME - BUILD SUBSYSTEM ALLOCATION SEQUENCE   @G29AN2F*/
*/*                    TABLE AND REQUEST BLOCK AREA          @G29AN2F*/
*/*                                                          @G29AN2F*/
*/* FUNCTION -                                               @G29AN2F*/
*/*   THE PURPOSE OF THIS SEGMENT IS TO: 1) BUILD AND        @G29AN2F*/
*/*   INITIALIZE A LOCAL COPY OF THE ALLOCATION SEQUENCE     @G29AN2F*/
*/*   TABLE AND 2) DYNAMICALLY ACQUIRE STORAGE NEEDED TO     @G29AN2F*/
*/*   PROCESS GROUP REQUESTS - AN AREA FOR GROUP REQUEST     @G29AN2F*/
*/*   BLOCKS AND IF ERROR MESSAGES ARE TO BE RETURNED BY     @G29AN2F*/
*/*   THE SUBSYSTEM, THE SUBSYSTEM MESSAGE BLOCK.            @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*   ENOUGH STORAGE IS OBTAINED FOR THE GROUP REQUEST       @G29AN2F*/
*/*   BLOCKS TO ACCOMODATE THE SUBSYSTEM WITH THE HIGHEST    @G29AN2F*/
*/*   NUMBER OF REQUESTS. LIKEWISE, THE AMOUNT OF STORAGE    @G29AN2F*/
*/*   OBTAINED FOR THE SUBSYSTEM MESSAGE BLOCK IS ENOUGH     @G29AN2F*/
*/*   TO ACCOMODATE A MESSAGE FOR EACH REQUEST FOR THE SUB-  @G29AN2F*/
*/*   SYSTEM WITH THE LARGEST NUMBER OF REQUESTS. (THESE     @G29AN2F*/
*/*   AMOUNTS ARE SUFFICIENT BECAUSE THE STORAGE IS REUSED   @G29AN2F*/
*/*   BY EACH SUBSYSTEM IN TURN.)                            @G29AN2F*/
*/*                                                          @G29AN2F*/
*/* ENTRY - IN LINE SUBROUTINE                               @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*   PURPOSE - SEE FUNCTION                                 @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*   INPUT -                                                @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*     SIOT1P    - PTR TO FIRST SIOT                        @G29AN2F*/
*/*     SUBSREQS  - COUNT OF TOTAL SUBSYSTEM REQUESTS        @G29AN2F*/
*/*     LOFJSSNM  - NAME OF THE DEFAULT SUBSYSTEM            @G29AN2F*/
*/*     JSAST     - SUBSYSTEM ALLOCATION SEQUENCE TABLE      @G29AN2F*/
*/*                 BUILT DURING SYSTEM INITIALIZATION       @G29AN2F*/
*/*                                                          @G29AN2F*/
*/* EXIT - IN LINE                                           @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*   CONDITION - LOCAL COPY OF SAST COMPLETED               @G29AN2F*/
*/*               REQUEST BLOCK AREA OBTAINED IF GROUP       @G29AN2F*/
*/*                REQUESTS EXIST                            @G29AN2F*/
*/*               SUBSYSTEM MESSAGE BLOCK OBTAINED IF        @G29AN2F*/
*/*                GROUP REQUESTS EXIST AND THE FUNCTION     @G29AN2F*/
*/*                MAP INDICATES THAT ERROR MESSAGES ARE     @G29AN2F*/
*/*                TO BE GENERATED BY THE SUBSYSTEM          @G29AN2F*/
*/*     OUTPUT -                                             @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*       LCLSASTP - PTR TO COMPLETED LOCAL COPY OF THE SAST @G29AN2F*/
*/*       NUMSUBS  - NUMBER OF SUBSYSTEMS IN SAST            @G29AN2F*/
*/*       MAXGPCT  - MAXIMUM NUMBER OF GROUP REQUEST FOR     @G29AN2F*/
*/*                   A SUBSYSTEM                            @G29AN2F*/
*/*       RBAREAP  - PTR TO REQUEST BLOCK AREA               @G29AN2F*/
*/*       SSMSGBKP - PTR TO SUBSYSTEM MESSAGE BLOCK AREA     @G29AN2F*/
*/*       MSGIDX   - MESSAGE INDEX SET TO FIRST MESSAGE      @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*     RETURN CODE - NONE                                   @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*   CONDITION - ERROR  SUBSYSTEM NAMED IN SIOT DOES NOT    @G29AN2F*/
*/*               EXIST                                      @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*     OUTPUT -                                             @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*       LCLSASTP - PTR TO PARTIALLY COMPLETED SAST         @G29AN2F*/
*/*       SIOTRSNC - SIOT REASON CODE OF REQUEST IN ERROR    @G29AN2F*/
*/*                  SET TO INDICATE THE ERROR               @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*     RETURN CODE - RETCODE=ERROR                          @G29AN2F*/
*/*                                                          @G29AN2F*/
*/********************************************************************/
*MAXGPCT = ZERO;                       /*INIT GROUP COUNT    @G29AN2F*/
         SLR   @08,@08                                          02S0108
         ST    @08,MAXGPCT                                      02S0108
*IF SUBSREQS > ONE THEN                /*IS THERE MORE THAN ONE 02S0109
*                                        SUBSYSTEM REQUEST?  @G29AN2F*/
         L     @08,@PC00001                                     02S0109
         L     @08,ALCWAPTR(,@08)                               02S0109
         L     @08,SUBSREQS(,@08)                               02S0109
         CH    @08,@CH00040                                     02S0109
         BNH   @RF00109                                         02S0109
*  DO;                                 /*YES, SORT REQUESTS  @G29AN2F*/
*    RFY REG1 RSTD;                    /*RESTRICT REG 1      @G29AN2F*/
*    DO; /*GETMAIN (R) LV(JSASTTBS)SP(SPNUM)*/                  02S0112
*    RESPECIFY (GPR01F,GPR00F) RESTRICTED;                      02S0113
*    GPR00F = JSASTTBS; /* LENGTH REQUESTED*/                   02S0114
         L     @15,CVTPTR                                       02S0114
         L     @15,CVTJESCT(,@15)                               02S0114
         L     @15,JESSASTA(,@15)                               02S0114
         LH    GPR00F,JSASTTBS(,@15)                            02S0114
*    GPR01F = SPNUM; /* SP IN REG 1 */                          02S0115
         LA    GPR01F,230                                       02S0115
*    GEN   (SLL   GPR01F,24)                                    02S0116
*    NODEFS NOREFS NOSETS NOEXIT NOFLOWS SEQFLOW;               02S0116
         SLL   GPR01F,24
*    GPR00F = GPR00F | GPR01F; /* SP IN HIGH BYTE */            02S0117
         OR    GPR00F,GPR01F                                    02S0117
*    GPR01F = -1; /* INDICATE A GETMAIN REQUEST */              02S0118
         SLR   GPR01F,GPR01F                                    02S0118
         BCTR  GPR01F,0                                         02S0118
*    SVC(10); /* R-FORM OF GETMAIN*/                            02S0119
         SVC   10                                               02S0119
*    RESPECIFY (GPR01F,GPR00F) UNRESTRICTED;                    02S0120
*    END; /*GETMAIN (R) LV(JSASTTBS)SP(SPNUM)*//* GET SAST CORE     @G2
*AN2F*/                                                         02S0121
*    LCLSASTP = REG1;                  /*SET PTR TO AREA     @G29AN2F*/
         ST    REG1,LCLSASTP                                    02S0122
*    RFY REG1 UNRSTD;                  /*RELEASE REG 1       @G29AN2F*/
*    RFY (REG2,REG3,REG4,REG5) RSTD;   /*RESTRICT MVCL REGS  @G29AN2F*/
*    REG2 = LCLSASTP;                  /*PTR TO LCL SAST     @G29AN2F*/
         L     @15,LCLSASTP                                     02S0125
         LR    REG2,@15                                         02S0125
*    REG3 = JSASTTBS;                  /*LENGTH OF SAST      @G29AN2F*/
         L     @01,CVTPTR                                       02S0126
         L     @01,CVTJESCT(,@01)                               02S0126
         L     @15,JESSASTA(,@01)                               02S0126
         LH    REG3,JSASTTBS(,@15)                              02S0126
*    REG4 = ADDR(JSASTTBL);            /*PTR TO SYSTEM SAST  @G29AN2F*/
         LA    REG4,JSASTTBL(,@15)                              02S0127
*    REG5 = REG3;                      /*USE SAME LENGTH     @G29AN2F*/
         LR    REG5,REG3                                        02S0128
*    MVCL(REG2,REG4);                  /*MAKE COPY OF SAST   @G29AN2F*/
         MVCL  REG2,REG4                                        02S0129
*    RFY (REG2,REG3,REG4,REG5) UNRSTD; /*RELEASE MVCL REGS   @G29AN2F*/
*    RFY SASTTBLE BASED(LCLSASTP);     /*SET SAST MAP BASE   @G29AN2F*/
*    LCLSSCNT = SUBSREQS;              /*GET COUNT OF REQUESTS  02S0132
*                                        FOR SUBSYSTEMS      @G29AN2F*/
         L     @15,@PC00001                                     02S0132
         L     @15,ALCWAPTR(,@15)                               02S0132
         MVC   LCLSSCNT(4),SUBSREQS(@15)                        02S0132
*    SIOTPTR = SIOT1P;                 /*GET PTR TO SIOTS    @G29AN2F*/
         L     SIOTPTR,SIOT1P(,@15)                             02S0133
*    DO WHILE LCLSSCNT ^= ZERO         /*PROCESS ALL RQSTS   @G29AN2F*/
*           & SIOTPTR  ^= ZERO         /*AND ALL SIOTS       @G29AN2F*/
*           & RETCODE   = ZERO;        /*WHILE NO ERRORS     @G29AN2F*/
         B     @DE00134                                         02S0134
@DL00134 DS    0H                                               02S0135
*      IF SIOTSSDS = ON THEN           /*IS SIOT A SUBSYSTEM    02S0135
*                                        REQUEST?            @G29AN2F*/
         TM    SIOTSSDS(SIOTPTR),B'10000000'                    02S0135
         BNO   @RF00135                                         02S0135
*        DO;                           /*YES, PROCESS IT     @G29AN2F*/
*          IF SIOTSSNM = NOSSNM THEN   /*IS SUBSYSTEM NAME      02S0137
*                                        NOT SPECIFIED?      @G29AN2F*/
         CLC   SIOTSSNM(4,SIOTPTR),NOSSNM                       02S0137
         BNE   @RF00137                                         02S0137
*            SUBSYSNM = LOFJSSNM;      /*YES, USE DEFAULT    @G29AN2F*/
         L     @15,@PC00001                                     02S0138
         L     @01,ALCWAPTR(,@15)                               02S0138
         L     @01,LOJSSNMP(,@01)                               02S0138
         MVC   SUBSYSNM(4),LOFJSSNM(@01)                        02S0138
*          ELSE                        /*NAME IS SPECIFIED   @G29AN2F*/
*            SUBSYSNM = SIOTSSNM;      /*USE SPECIFIED NAME  @G29AN2F*/
         B     @RC00137                                         02S0139
@RF00137 MVC   SUBSYSNM(4),SIOTSSNM(SIOTPTR)                    02S0139
*          DO I = 1 TO JSASTTCT        /*SCAN TO LAST ENTRY  @G29AN2F*/
*             WHILE SASTSSNM(I)^=SUBSYSNM;/*UNTIL SUBSYSTEM NAME
*                                          IS FOUND          @G29AN2F*/
@RC00137 LA    I,1                                              02S0140
         B     @DE00140                                         02S0140
@DL00140 LR    @03,I                                            02S0140
         MH    @03,@CH00959                                     02S0140
         L     @01,LCLSASTP                                     02S0140
         ALR   @01,@03                                          02S0140
         AL    @01,@CF01581                                     02S0140
         CLC   SASTSSNM(4,@01),SUBSYSNM                         02S0140
         BE    @DC00140                                         02S0140
*          END;                        /*                    @G29AN2F*/
         AH    I,@CH00040                                       02S0141
@DE00140 L     @03,CVTPTR                                       02S0141
         L     @03,CVTJESCT(,@03)                               02S0141
         L     @03,JESSASTA(,@03)                               02S0141
         CH    I,JSASTTCT(,@03)                                 02S0141
         BNH   @DL00140                                         02S0141
@DC00140 DS    0H                                               02S0142
*          IF I > JSASTTCT THEN        /*WAS END OF TABLE REACHED
*                                        WITHOUT A MATCH?    @G29AN2F*/
         L     @03,CVTPTR                                       02S0142
         L     @03,CVTJESCT(,@03)                               02S0142
         L     @03,JESSASTA(,@03)                               02S0142
         CH    I,JSASTTCT(,@03)                                 02S0142
         BNH   @RF00142                                         02S0142
*            DO;                       /*YES, ERROR          @G29AN2F*/
*              SIOTRSNC = SUBSIFEC(SSRTNOSS/4);/*TREAT AS IF SSREQ
*                                        RETURN FOR NO NAME  @G29AN2F*/
         MVC   SIOTRSNC(2,SIOTPTR),SUBSIFEC+4                   02S0144
*              RETCODE = ERROR;        /*INDICATE ERROR      @G29AN2F*/
         LA    RETCODE,4                                        02S0145
*            END;                      /*                    @G29AN2F*/
*          ELSE                        /*MATCH WAS FOUND     @G29AN2F*/
*            DO;                       /*THEN PROCESS SIOT   @G29AN2F*/
         B     @RC00142                                         02S0147
@RF00142 DS    0H                                               02S0148
*              SASTNORQ(I) = SASTNORQ(I)+ONE;/*UP COUNT OF REQUESTS
*                                             FOR SUBSYSTEM  @G29AN2F*/
         L     @03,LCLSASTP                                     02S0148
         LR    @15,I                                            02S0148
         MH    @15,@CH00959                                     02S0148
         LA    @14,1                                            02S0148
         LA    @01,0(@15,@03)                                   02S0148
         AL    @01,@CF01582                                     02S0148
         LH    @07,SASTNORQ-8(,@01)                             02S0148
         ALR   @07,@14                                          02S0148
         LA    @06,0(@15,@03)                                   02S0148
         AL    @06,@CF01582                                     02S0148
         STH   @07,SASTNORQ-8(,@06)                             02S0148
*              IF SIOTSSGP = ON THEN   /*IS SIOT A GROUP        02S0149
*                                        REQUEST?            @G29AN2F*/
         TM    SIOTSSGP(SIOTPTR),B'00010000'                    02S0149
         BNO   @RF00149                                         02S0149
*                DO;                   /*YES                 @G29AN2F*/
*                  SASTNOGP(I)=SASTNOGP(I)+ONE;/*INCREMENT CNT  02S0151
*                                          OF GROUP REQUESTS @G29AN2F*/
         LA    @01,0(@15,@03)                                   02S0151
         BCTR  @01,0                                            02S0151
         BCTR  @01,0                                            02S0151
         AH    @14,SASTNOGP-10(,@01)                            02S0151
         BCTR  @03,0                                            02S0151
         BCTR  @03,0                                            02S0151
         STH   @14,SASTNOGP-10(@15,@03)                         02S0151
*                  MAXGPCT = MAX(SASTNOGP(I),MAXGPCT);/*SAVE LARGEST
*                                              NUMBER OF GROUP  02S0152
*                                              REQUESTS      @G29AN2F*/
         L     @03,MAXGPCT                                      02S0152
         CR    @14,@03                                          02S0152
         BNL   *+6
         LR    @14,@03                                          02S0152
         ST    @14,MAXGPCT                                      02S0152
*                END;                  /*                    @G29AN2F*/
*              IF SASTNORQ(I) =ONE THEN/*IS THIS FIRST REQUEST  02S0154
*                                        FOR THE SUBSYSTEM ? @G29AN2F*/
@RF00149 L     @03,LCLSASTP                                     02S0154
         LR    @15,I                                            02S0154
         MH    @15,@CH00959                                     02S0154
         LA    @01,0(@15,@03)                                   02S0154
         AL    @01,@CF01582                                     02S0154
         LH    @14,SASTNORQ-8(,@01)                             02S0154
         CH    @14,@CH00040                                     02S0154
         BNE   @RF00154                                         02S0154
*                SASTSPTR(I) = SIOTPTR;/*YES, SAVE SIOT PTR  @G29AN2F*/
         AL    @03,@CF01583                                     02S0155
         ST    SIOTPTR,SASTSPTR-4(@15,@03)                      02S0155
*              LCLSSCNT = LCLSSCNT-ONE;/*DECREMENT COUNT     @G29AN2F*/
@RF00154 L     @15,LCLSSCNT                                     02S0156
         BCTR  @15,0                                            02S0156
         ST    @15,LCLSSCNT                                     02S0156
*            END;                      /*                    @G29AN2F*/
*        END;                          /*END SUBSYSTEM SIOT  @G29AN2F*/
@RC00142 DS    0H                                               02S0159
*      SIOTPTR = SIOTNPTR;             /*POINT TO NEXT SIOT  @G29AN2F*/
@RF00135 L     SIOTPTR,SIOTNPTR(,SIOTPTR)                       02S0159
*    END;                              /*PROCESS NEXT SIOT   @G29AN2F*/
@DE00134 SLR   @15,@15                                          02S0160
         C     @15,LCLSSCNT                                     02S0160
         BE    @DC00134                                         02S0160
         CR    SIOTPTR,@15                                      02S0160
         BE    @DC00134                                         02S0160
         CR    RETCODE,@15                                      02S0160
         BE    @DL00134                                         02S0160
@DC00134 DS    0H                                               02S0161
*    NUMSUBS = JSASTTCT;               /*SET NUMBER OF SUBSYSTEMS
*                                        IN TABLE            @G29AN2F*/
         L     @08,CVTPTR                                       02S0161
         L     @08,CVTJESCT(,@08)                               02S0161
         L     @08,JESSASTA(,@08)                               02S0161
         LH    NUMSUBS,JSASTTCT(,@08)                           02S0161
*  END;                                /*                    @G29AN2F*/
*ELSE                                  /*ONE REQUEST - BUILD @G29AN2F*/
*  DO;                                 /*SAST OF ONE ENTRY   @G29AN2F*/
         B     @RC00109                                         02S0163
@RF00109 DS    0H                                               02S0164
*    LCLSASTP = ADDR(LCLSAST);         /*SET PTR TO SAST     @G29AN2F*/
         LA    @15,LCLSAST                                      02S0164
         ST    @15,LCLSASTP                                     02S0164
*    SASTNORQ(1) = ONE;                /*SET CNT TO ONE      @G29AN2F*/
         MVC   SASTNORQ(2,@15),@CH00040                         02S0165
*    SIOTPTR = SIOT1P;                 /*GET FIRST SIOT      @G29AN2F*/
         L     @15,@PC00001                                     02S0166
         L     @01,ALCWAPTR(,@15)                               02S0166
         L     SIOTPTR,SIOT1P(,@01)                             02S0166
*    DO WHILE SIOTPTR ^= ZERO          /*SCAN ALL SIOTS      @G29AN2F*/
*           & SIOTSSDS^= ON;           /*UNTIL FIRST SUBSYSTEM  02S0167
*                                        REQUEST IS FOUND    @G29AN2F*/
         B     @DE00167                                         02S0167
@DL00167 DS    0H                                               02S0168
*      SIOTPTR = SIOTNPTR;             /*GET NEXT SIOT       @G29AN2F*/
         L     SIOTPTR,SIOTNPTR(,SIOTPTR)                       02S0168
*    END;                              /*                    @G29AN2F*/
@DE00167 LTR   SIOTPTR,SIOTPTR                                  02S0169
         BZ    @DC00167                                         02S0169
         TM    SIOTSSDS(SIOTPTR),B'10000000'                    02S0169
         BNO   @DL00167                                         02S0169
@DC00167 DS    0H                                               02S0170
*    SASTSPTR(1) = SIOTPTR;            /*SAVE PTR TO SIOT    @G29AN2F*/
         L     @15,LCLSASTP                                     02S0170
         ST    SIOTPTR,SASTSPTR(,@15)                           02S0170
*    IF SIOTSSGP = ON THEN             /*IS THIS A GROUP        02S0171
*                                        REQUEST ?           @G29AN2F*/
         TM    SIOTSSGP(SIOTPTR),B'00010000'                    02S0171
         BNO   @RF00171                                         02S0171
*      DO;                             /*YES, SET INDICATORS @G29AN2F*/
*        MAXGPCT = ONE;                /*SET MAX COUNT       @G29AN2F*/
         LA    @14,1                                            02S0173
         ST    @14,MAXGPCT                                      02S0173
*        SASTNOGP(1) = ONE;            /*SET GROUP COUNT     @G29AN2F*/
         STH   @14,SASTNOGP(,@15)                               02S0174
*      END;                            /*END GROUP REQUEST   @G29AN2F*/
*    ELSE                              /*NO GROUP REQUESTS   @G29AN2F*/
*      SASTNOGP(1) = ZERO;             /*SET CNTS TO ZERO    @G29AN2F*/
         B     @RC00171                                         02S0176
@RF00171 L     @01,LCLSASTP                                     02S0176
         SLR   @00,@00                                          02S0176
         STH   @00,SASTNOGP(,@01)                               02S0176
*    IF SIOTSSNM = NOSSNM THEN         /*IS DEFAULT SUBSYSTEM   02S0177
*                                        TO BE USED?         @G29AN2F*/
@RC00171 CLC   SIOTSSNM(4,SIOTPTR),NOSSNM                       02S0177
         BNE   @RF00177                                         02S0177
*      SASTSSNM(1) = LOFJSSNM;         /*YES, GET DEFAULT    @G29AN2F*/
         L     @08,LCLSASTP                                     02S0178
         L     @15,@PC00001                                     02S0178
         L     @01,ALCWAPTR(,@15)                               02S0178
         L     @01,LOJSSNMP(,@01)                               02S0178
         MVC   SASTSSNM(4,@08),LOFJSSNM(@01)                    02S0178
*    ELSE                              /*NOT DEFAULT         @G29AN2F*/
*      SASTSSNM(1) = SIOTSSNM;         /*USE SPECIFIED NAME  @G29AN2F*/
         B     @RC00177                                         02S0179
@RF00177 L     @01,LCLSASTP                                     02S0179
         MVC   SASTSSNM(4,@01),SIOTSSNM(SIOTPTR)                02S0179
*    NUMSUBS = ONE;                    /*SET NUMBER OF SUBSYSTEMS
*                                        IN TABLE TO ONE     @G29AN2F*/
@RC00177 LA    NUMSUBS,1                                        02S0180
*  END;                                /*END ONE REQUEST     @G29AN2F*/
*IF MAXGPCT > ZERO                     /*ARE THERE ANY GROUP    02S0182
*                                        REQUESTS ?          @G29AN2F*/
*   & RETCODE = ZERO THEN              /*AND NO ERRORS ?     @G29AN2F*/
@RC00109 L     @08,MAXGPCT                                      02S0182
         SLR   @02,@02                                          02S0182
         CR    @08,@02                                          02S0182
         BNH   @RF00182                                         02S0182
         CR    RETCODE,@02                                      02S0182
         BNE   @RF00182                                         02S0182
*  DO;                                 /*YES, SET UP RB AREA @G29AN2F*/
*    PSARBPTR = ZERO;                  /*ZERO PTR            @G29AN2F*/
         ST    @02,PSARBPTR                                     02S0184
*    RBAREASZ = MAXGPCT * LENGTH(SARBAREA);/*CALCULATE SIZE OF MAX
*                                            RB AREA NEEDED  @G29AN2F*/
         SLA   @08,6                                            02S0185
         ST    @08,RBAREASZ                                     02S0185
*    RFY REG1 RSTD;                    /*RESTRICT REG1       @G29AN2F*/
*    DO; /*GETMAIN (R) LV(RBAREASZ)SP(SPNUM)*/                  02S0187
*    RESPECIFY (GPR01F,GPR00F) RESTRICTED;                      02S0188
*    GPR00F = RBAREASZ; /* LENGTH REQUESTED*/                   02S0189
         LR    GPR00F,@08                                       02S0189
*    GPR01F = SPNUM; /* SP IN REG 1 */                          02S0190
         LA    GPR01F,230                                       02S0190
*    GEN   (SLL   GPR01F,24)                                    02S0191
*    NODEFS NOREFS NOSETS NOEXIT NOFLOWS SEQFLOW;               02S0191
         SLL   GPR01F,24
*    GPR00F = GPR00F | GPR01F; /* SP IN HIGH BYTE */            02S0192
         OR    GPR00F,GPR01F                                    02S0192
*    GPR01F = -1; /* INDICATE A GETMAIN REQUEST */              02S0193
         SLR   GPR01F,GPR01F                                    02S0193
         BCTR  GPR01F,0                                         02S0193
*    SVC(10); /* R-FORM OF GETMAIN*/                            02S0194
         SVC   10                                               02S0194
*    RESPECIFY (GPR01F,GPR00F) UNRESTRICTED;                    02S0195
*    END; /*GETMAIN (R) LV(RBAREASZ)SP(SPNUM)*/ /*GET AREA          @G2
*AN2F*/                                                         02S0196
*    RBAREAP = REG1;                   /*SET PTR TO AREA     @G29AN2F*/
         ST    REG1,RBAREAP                                     02S0197
*    RFY REG1 UNRSTD;                  /*RELEASE REG1        @G29AN2F*/
*    SSARBPTR = RBAREAP;               /*SET PTR FOR 1ST RB  @G29AN2F*/
         L     @02,RBAREAP                                      02S0199
         LR    SSARBPTR,@02                                     02S0199
*    IF SSEMSGSW = ON THEN             /*IS SUBSYSTEM TO RETURN 02S0200
*                                        ERROR MESSAGES ?    @G29AN2F*/
         L     @08,@PC00001                                     02S0200
         L     @08,ALCWAPTR(,@08)                               02S0200
         L     @08,FMAPPTR(,@08)                                02S0200
         TM    SSEMSGSW(@08),B'10000000'                        02S0200
         BNO   @RF00200                                         02S0200
*      DO;                             /*YES, GET MSG BLK    @G29AN2F*/
*        MSGBLKSZ = (MAXGPCT + 1)* LENGTH(SSMBKELM);/*CALCULATE 02S0202
*                                               SIZE OF AREA @G29AN2F*/
         LA    @08,1                                            02S0202
         AL    @08,MAXGPCT                                      02S0202
         MH    @08,@CH01576                                     02S0202
         ST    @08,MSGBLKSZ                                     02S0202
*        MSGBLKSZ = MSGBLKSZ + LENGTH(SSMBKHDR);/*ADD HDR SZ @G29AN2F*/
         AH    @08,@CH00109                                     02S0203
         ST    @08,MSGBLKSZ                                     02S0203
*        RFY REG1 RSTD;                /*RESTRICT REG1       @G29AN2F*/
*        DO; /*GETMAIN (R) LV(MSGBLKSZ)SP(SPNUM)*/              02S0205
*        RESPECIFY (GPR01F,GPR00F) RESTRICTED;                  02S0206
*        GPR00F = MSGBLKSZ; /* LENGTH REQUESTED*/               02S0207
         LR    GPR00F,@08                                       02S0207
*        GPR01F = SPNUM; /* SP IN REG 1 */                      02S0208
         LA    GPR01F,230                                       02S0208
*        GEN   (SLL   GPR01F,24)                                02S0209
*        NODEFS NOREFS NOSETS NOEXIT NOFLOWS SEQFLOW;           02S0209
         SLL   GPR01F,24
*        GPR00F = GPR00F | GPR01F; /* SP IN HIGH BYTE */        02S0210
         OR    GPR00F,GPR01F                                    02S0210
*        GPR01F = -1; /* INDICATE A GETMAIN REQUEST */          02S0211
         SLR   GPR01F,GPR01F                                    02S0211
         BCTR  GPR01F,0                                         02S0211
*        SVC(10); /* R-FORM OF GETMAIN*/                        02S0212
         SVC   10                                               02S0212
*        RESPECIFY (GPR01F,GPR00F) UNRESTRICTED;                02S0213
*        END; /*GETMAIN (R) LV(MSGBLKSZ)SP(SPNUM)*//*GET AREA       @G2
*AN2F*/                                                         02S0214
*        SSMSGBKP = REG1;              /*SET PTR TO AREA     @G29AN2F*/
         ST    REG1,SSMSGBKP                                    02S0215
*        RFY REG1 UNRSTD;              /*RELEASE REG1        @G29AN2F*/
*        MSGIDX = ONE;                 /*SET MESSAGE INDEX TO   02S0217
*                                        BEGINNING           @G29AN2F*/
         MVC   MSGIDX(4),@CF00040                               02S0217
*        SSMBSUBP = SPNUM;             /*SET BLOCK SUBPOOL   @G29AN2F*/
         L     @08,SSMSGBKP                                     02S0218
         MVC   SSMBSUBP(2,@08),@CH00034                         02S0218
*        SSMBKSZE = MSGBLKSZ;          /*SET BLOCK SIZE      @G29AN2F*/
         MVC   SSMBKSZE(4,@08),MSGBLKSZ                         02S0219
*        SSMBADIM = ZERO;              /*CLEAR DIMENSION     @G29AN2F*/
         SLR   @02,@02                                          02S0220
         STH   @02,SSMBADIM(,@08)                               02S0220
*      END;                            /*                    @G29AN2F*/
*  END;                                /*END GROUP REQ.      @G29AN2F*/
@RF00200 DS    0H                                               02S0223
*    IF RETCODE = ZERO THEN            /*IF NO ERRORS SO FAR @G29AN2F*/
@RF00182 LTR   RETCODE,RETCODE                                  01S0223
         BNZ   @RF00223                                         01S0223
*      DO;                             /*PROCESS REQUESTS    @G29AN2F*/
*        DO I = 1 TO NUMSUBS           /*FOR ALL SUBSYSTEMS  @G29AN2F*/
*            WHILE SUBSREQS ^= ZERO    /*PROCESS ALL REQUEST @G29AN2F*/
*                  & RETCODE = ZERO;   /*WHILE NO ERRORS     @G29AN2F*/
         LA    I,1                                              01S0225
         B     @DE00225                                         01S0225
@DL00225 SLR   @08,@08                                          01S0225
         L     @15,@PC00001                                     01S0225
         L     @15,ALCWAPTR(,@15)                               01S0225
         C     @08,SUBSREQS(,@15)                               01S0225
         BE    @DC00225                                         01S0225
         CR    RETCODE,@08                                      01S0225
         BNE   @DC00225                                         01S0225
*          IF SASTNORQ(I) > ZERO THEN  /*ARE THERE REQUESTS FOR 01S0226
*                                        THIS SUBSYSTEM ?    @G29AN2F*/
         L     @14,LCLSASTP                                     01S0226
         LR    @07,I                                            01S0226
         MH    @07,@CH00959                                     01S0226
         LA    @01,0(@07,@14)                                   01S0226
         AL    @01,@CF01582                                     01S0226
         CH    @08,SASTNORQ-8(,@01)                             01S0226
         BNL   @RF00226                                         01S0226
*            DO;                       /*YES, ALLOCATE THEM  @G29AN2F*/
*              SUBSYSNM = SASTSSNM(I); /*GET SSNAME          @G29AN2F*/
         ALR   @14,@07                                          01S0228
         AL    @14,@CF01581                                     01S0228
         MVC   SUBSYSNM(4),SASTSSNM(@14)                        01S0228
*              IF SUBSYSNM = LOFJSSNM THEN/*IS THIS SUBSYSTEM THE
*                                        DEFAULT SUBSYSTEM ? @G29AN2F*/
         L     @08,LOJSSNMP(,@15)                               01S0229
         CLC   SUBSYSNM(4),LOFJSSNM(@08)                        01S0229
         BNE   @RF00229                                         01S0229
*                DSSNMSW = ON;         /*YES, SET INDICATOR  @G29AN2F*/
         OI    DSSNMSW,B'10000000'                              01S0230
*              ELSE                    /*NOT DEFAULT NAME    @G29AN2F*/
*                DSSNMSW = OFF;        /*SET INDICATOR OFF   @G29AN2F*/
         B     @RC00229                                         01S0231
@RF00229 NI    DSSNMSW,B'01111111'                              01S0231
*              SIOTPTR = SASTSPTR(I);  /*SET PTR TO 1ST SIOT @G29AN2F*/
@RC00229 LR    @15,I                                            01S0232
         MH    @15,@CH00959                                     01S0232
         L     @01,LCLSASTP                                     01S0232
         AL    @01,@CF01583                                     01S0232
         L     SIOTPTR,SASTSPTR-4(@15,@01)                      01S0232
*              DO WHILE SIOTPTR ^= ZERO /*PROCESS ALL SIOTS  @G29AN2F*/
*                 & SASTNORQ(I) ^= ZERO /*AND ALL REQUESTS   @G29AN2F*/
*                      & RETCODE = ZERO; /*WHILE NO ERRORS   @G29AN2F*/
         B     @DE00233                                         01S0233
@DL00233 DS    0H                                               01S0234
*                IF SIOTSSDS = ON      /*IS THE REQUEST FOR A   01S0234
*                                        SUBSYSTEM AND       @G29AN2F*/
*                   &((DSSNMSW = ON &  /*IF DEFAULT SW IS ON @G29AN2F*/
*                     SIOTSSNM = NOSSNM) /*AND NO NAME IS       01S0234
*                                          PRESENT OR        @G29AN2F*/
*                    | SIOTSSNM = SUBSYSNM) THEN /*NAMES =   @G29AN2F*/
         TM    SIOTSSDS(SIOTPTR),B'10000000'                    01S0234
         BNO   @RF00234                                         01S0234
         TM    DSSNMSW,B'10000000'                              01S0234
         BNO   @GL00009                                         01S0234
         CLC   SIOTSSNM(4,SIOTPTR),NOSSNM                       01S0234
         BE    @RT00234                                         01S0234
@GL00009 CLC   SIOTSSNM(4,SIOTPTR),SUBSYSNM                     01S0234
         BNE   @RF00234                                         01S0234
@RT00234 DS    0H                                               01S0235
*                  DO;                     /*PROCESS REQUEST @G29AN2F*/
*                    IF SIOTSSGP = ON THEN /*IS THIS A GROUP    01S0236
*                                            REQUEST ?       @G29AN2F*/
         TM    SIOTSSGP(SIOTPTR),B'00010000'                    01S0236
         BNO   @RF00236                                         01S0236
*                      DO;                 /*YES             @G29AN2F*/
*/********************************************************************/
*/*                                                          @G29AN2F*/
*/* SEGMENT NAME - BLDGPRB                                   @G29AN2F*/
*/*                                                          @G29AN2F*/
*/* DESCRIPTIVE NAME - BUILD SUBSYSTEM ALLOCATION GROUP      @G29AN2F*/
*/*                    REQUEST BLOCK (SSAGRBLK)              @G29AN2F*/
*/*                                                          @G29AN2F*/
*/* FUNCTION -                                               @G29AN2F*/
*/*   THE PURPOSE OF THIS ROUTINE IS TO BUILD THE SSAGARB,   @G29AN2F*/
*/*   WHICH IS PART OF THE SUBSYSTEM INTERACE, ALLOCATE      @G29AN2F*/
*/*   GROUP REQUEST FOR A SUBSYSTEM.                         @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*   SINCE THE REQUEST BLOCK MUST CONTAIN THE VIRTUAL       @G29AN2F*/
*/*   ADDRESS OF THE SUBSYSTEM WORK AREA(SSWA) CONTAINING    @G29AN2F*/
*/*   SUBSYSTEM PARAMETERS, THE SSWA MUST BE READ FROM SWA   @G29AN2F*/
*/*   TO GET ITS VIRTUAL ADDRESS.                            @G29AN2F*/
*/*                                                          @G29AN2F*/
*/* ENTRY - INLINE SUBROUTINE                                @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*   PURPOSE - SEE FUNCTION                                 @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*   INPUT -                                                @G29AN2F*/
*/*     SSARBPTR - POINTER TO SUBSYSTEM ALLOCATION REQUEST   @G29AN2F*/
*/*                BLOCK                                     @G29AN2F*/
*/*     SIOTPTR  - POINTER TO SIOT FOR REQUEST TO BE         @G29AN2F*/
*/*                ALLOCATED                                 @G29AN2F*/
*/*     FMAPPTR  - POINTER TO FUNCTION MAP                   @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*  EXIT - INLINE                                           @G29AN2F*/
*/*    CONDITION - SUBSYSTEM ALLOCATION REQUEST BLOCK        @G29AN2F*/
*/*                CONSTRUCTED AND CHAINED                   @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*    OUTPUT -                                              @G29AN2F*/
*/*      SSAGARBK BUILT                                      @G29AN2F*/
*/*      SSARBPTR UPDATED TO NEXT REQUEST BLOCK AREA         @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*    RETURN CODE - NONE                                    @G29AN2F*/
*/*                                                          @G29AN2F*/
*/********************************************************************/
*SARBAREA = SARBAREA && SARBAREA;      /*CLEAR AREA FOR SARB @G29AN2F*/
         XC    SARBAREA(64,SSARBPTR),SARBAREA(SSARBPTR)         02S0238
*SSAGRBLN = LENGTH(SSAGARBK);          /*SET SARB LENGTH     @G29AN2F*/
         MVC   SSAGRBLN(2,SSARBPTR),@CH01577                    02S0239
*SSAGDDNM = ADDR(SCTDDNAM);            /*PTR TO DDNAME       @G29AN2F*/
         LA    @15,SCTDDNAM(,SIOTPTR)                           02S0240
         ST    @15,SSAGDDNM(,SSARBPTR)                          02S0240
*SSAGDISP = ADDR(SCTSDISP);            /*PTR TO SIOT DISP    @G29AN2F*/
         LA    @15,SCTSDISP(,SIOTPTR)                           02S0241
         ST    @15,SSAGDISP(,SSARBPTR)                          02S0241
*SSAGDUMY = ADDR(SCTSBYT1);            /*PTR TO DUMMY/SYSIN     02S0242
*                                        FLAGS               @G29AN2F*/
         LA    @15,SCTSBYT1(,SIOTPTR)                           02S0242
         ST    @15,SSAGDUMY(,SSARBPTR)                          02S0242
*SSAGSOUT = ADDR(SCTSBYT3);            /*PTR TO SYSOUT FLAGS @G29AN2F*/
         LA    @15,SCTSBYT3(,SIOTPTR)                           02S0243
         ST    @15,SSAGSOUT(,SSARBPTR)                          02S0243
*SSAGUNIT = ADDR(SCTUTYPE);            /*PTR TO UNIT TYPE    @G29AN2F*/
         LA    @15,SCTUTYPE(,SIOTPTR)                           02S0244
         ST    @15,SSAGUNIT(,SSARBPTR)                          02S0244
*SSAGADSP = ADDR(SIOTALTD);            /*PTR TO ALTERNATE       02S0245
*                                        DISP FIELDS         @G29AN2F*/
         LA    @15,SIOTALTD(,SIOTPTR)                           02S0245
         ST    @15,SSAGADSP(,SSARBPTR)                          02S0245
*SSAGSSNM = ADDR(SIOTSSNM);            /*PTR TO SUBSYSTEM       02S0246
*                                        NAME                @G29AN2F*/
         LA    @15,SIOTSSNM(,SIOTPTR)                           02S0246
         ST    @15,SSAGSSNM(,SSARBPTR)                          02S0246
*SSAGJFCB = SJFCBPTR;                  /*PTR TO JFCB         @G29AN2F*/
         MVC   SSAGJFCB(4,SSARBPTR),SJFCBPTR(SIOTPTR)           02S0247
*IF SIOTSSWA ^= ZERO THEN              /*DOES AN SSWA EXIST? @G29AN2F*/
         SLR   @15,@15                                          02S0248
         ICM   @15,7,SIOTSSWA(SIOTPTR)                          02S0248
         LTR   @15,@15                                          02S0248
         BZ    @RF00248                                         02S0248
*  DO;                                 /*YES, GET IT         @G29AN2F*/
*    SWACTLS = SWACTLS && SWACTLS;     /*CLEAR SWA I/F MAP   @G29AN2F*/
         SLR   @14,@14                                          02S0250
         ICM   @14,3,SWACTLS                                    02S0250
         LR    @07,@14                                          02S0250
         XR    @07,@14                                          02S0250
         STH   @07,SWACTLS                                      02S0250
*    SWREAD = ON;                      /*READ FUNCTION       @G29AN2F*/
*    SWMOD = ON;                       /*USE EXISTING EPA    @G29AN2F*/
         OI    SWREAD,B'00100010'                               02S0252
*    SWCHNPTR = ZERO;                  /*CLEAR CHAIN POINTER @G29AN2F*/
         LA    @14,LCLEPA                                       02S0253
         SLR   @07,@07                                          02S0253
         ST    @07,SWCHNPTR(,@14)                               02S0253
*    SMISVA = SIOTSSWA;                /*SVA OF SSWA TO READ @G29AN2F*/
         STCM  @15,7,SMISVA                                     02S0254
*    CALL IEFAB4F7(SWACTLS,ADDR(LCLEPA),0,                      02S0255
*                  ADDR(SMISVA),ADDR(SSWAPTR),                  02S0255
*                  0,1);               /*READ SSWA           @G29AN2F*/
         LA    @15,SWACTLS                                      02S0255
         ST    @15,@AL00001                                     02S0255
         ST    @14,@TF00001                                     02S0255
         LA    @15,@TF00001                                     02S0255
         ST    @15,@AL00001+4                                   02S0255
         LA    @15,@CF00111                                     02S0255
         ST    @15,@AL00001+8                                   02S0255
         LA    @15,SMISVA                                       02S0255
         ST    @15,@TF00002                                     02S0255
         LA    @15,@TF00002                                     02S0255
         ST    @15,@AL00001+12                                  02S0255
         LA    @15,SSWAPTR                                      02S0255
         ST    @15,@TF00003                                     02S0255
         LA    @15,@TF00003                                     02S0255
         ST    @15,@AL00001+16                                  02S0255
         LA    @15,@CF00111                                     02S0255
         ST    @15,@AL00001+20                                  02S0255
         LA    @15,@CF00040                                     02S0255
         ST    @15,@AL00001+24                                  02S0255
         L     @15,@CV01428                                     02S0255
         LA    @01,@AL00001                                     02S0255
         BALR  @14,@15                                          02S0255
*  END;                                /*                    @G29AN2F*/
*ELSE                                  /*NO SSWA SVA         @G29AN2F*/
*  SSWAPTR = ZERO;                     /*INDICATE NO SSWA    @G29AN2F*/
         B     @RC00248                                         02S0257
@RF00248 SLR   @15,@15                                          02S0257
         ST    @15,SSWAPTR                                      02S0257
*SSAGSSWA = SSWAPTR;                   /*PTR TO SSWA         @G29AN2F*/
@RC00248 MVC   SSAGSSWA(4,SSARBPTR),SSWAPTR                     02S0258
*IF SSEMSGSW = ON THEN                 /*IS SUBSYSTEM TO RETURN 02S0259
*                                        ERROR MESSAGES ?    @G29AN2F*/
         L     @15,@PC00001                                     02S0259
         L     @01,ALCWAPTR(,@15)                               02S0259
         L     @01,FMAPPTR(,@01)                                02S0259
         TM    SSEMSGSW(@01),B'10000000'                        02S0259
         BNO   @RF00259                                         02S0259
*  DO;                                 /*YES, SET UP FOR MSG @G29AN2F*/
*    SSAGDMLN = LENGTH(SSMSGTXT);      /*SET MAX LENGTH OF MESSAGE
*                                        ALLOWED             @G29AN2F*/
         MVC   SSAGDMLN(2,SSARBPTR),@CH01397                    02S0261
*    SSMDDNUM(MSGIDX) = SCTDDINO;      /*SAVE INTERNAL DD NUMBER
*                                        FOR LATER USE       @G29AN2F*/
         L     @15,SSMSGBKP                                     02S0262
         L     @14,MSGIDX                                       02S0262
         LR    @07,@14                                          02S0262
         MH    @07,@CH01576                                     02S0262
         LH    @06,SCTDDINO(,SIOTPTR)                           02S0262
         LA    @01,0(@07,@15)                                   02S0262
         AL    @01,@CF01586                                     02S0262
         STH   @06,SSMDDNUM-8(,@01)                             02S0262
*    SSAGDMGP = ADDR(SSMSGLEN(MSGIDX));/*PTR TO MESSAGE AREA FOR
*                                        THIS REQUEST        @G29AN2F*/
         AL    @15,@CF01587                                     02S0263
         LA    @15,SSMSGLEN-10(@07,@15)                         02S0263
         ST    @15,SSAGDMGP(,SSARBPTR)                          02S0263
*    MSGIDX = MSGIDX + ONE;            /*INCREMENT MESSAGE AREA 02S0264
*                                        INDEX               @G29AN2F*/
         AL    @14,@CF00040                                     02S0264
         ST    @14,MSGIDX                                       02S0264
*  END;                                /*                    @G29AN2F*/
*SARBSPTR = SIOTPTR;                   /*SAVE PTR TO SIOT FOR   02S0266
*                                        LATER USE           @G29AN2F*/
@RF00259 ST    SIOTPTR,SARBSPTR(,SSARBPTR)                      02S0266
*IF PSARBPTR ^= ZERO THEN              /*DOES A PREVIOUS RB     02S0267
*                                        EXIST?              @G29AN2F*/
         L     @15,PSARBPTR                                     02S0267
         LTR   @15,@15                                          02S0267
         BZ    @RF00267                                         02S0267
*  PSARBPTR->SSAGNRBP = SSARBPTR;      /*YES, CHAIN RB TO PREVIOUS
*                                        REQUEST BLOCK       @G29AN2F*/
         ST    SSARBPTR,SSAGNRBP(,@15)                          02S0268
*PSARBPTR = SSARBPTR;                  /*SAVE ADDRESS OF RB  @G29AN2F*/
@RF00267 ST    SSARBPTR,PSARBPTR                                02S0269
*SSARBPTR = SSARBPTR + LENGTH(SARBAREA);/*POINT TO NEXT RB   @G29AN2F*/
         AH    SSARBPTR,@CH01575                                02S0270
*                        SASTNORQ(I) = SASTNORQ(I)-ONE;/*DECREMENT
*                                        SUBSYSTEM'S COUNT   @G29AN2F*/
         L     @15,LCLSASTP                                     01S0271
         LR    @14,I                                            01S0271
         MH    @14,@CH00959                                     01S0271
         LA    @01,0(@14,@15)                                   01S0271
         AL    @01,@CF01582                                     01S0271
         LH    @07,SASTNORQ-8(,@01)                             01S0271
         BCTR  @07,0                                            01S0271
         AL    @15,@CF01582                                     01S0271
         STH   @07,SASTNORQ-8(@14,@15)                          01S0271
*                      END;            /*                    @G29AN2F*/
*                    ELSE              /*NOT GROUP REQUEST   @G29AN2F*/
*                      DO;             /*DO SYSIN/SYSOUT     @G29AN2F*/
         B     @RC00236                                         01S0273
@RF00236 DS    0H                                               01S0274
*                        CALL ALOCNGRP;/*ALLOCATE NON-GROUP REQUESTS
*                                        (I.E. SYSIN/SYSOUT) @G29AN2F*/
         BAL   @14,ALOCNGRP                                     01S0274
*                        SASTNORQ(I) = SASTNORQ(I)-ONE;/*DECREMENT
*                                        SUBSYSTEM'S COUNT   @G29AN2F*/
         L     @15,LCLSASTP                                     01S0275
         LR    @14,I                                            01S0275
         MH    @14,@CH00959                                     01S0275
         LA    @01,0(@14,@15)                                   01S0275
         AL    @01,@CF01582                                     01S0275
         LH    @07,SASTNORQ-8(,@01)                             01S0275
         BCTR  @07,0                                            01S0275
         AL    @15,@CF01582                                     01S0275
         STH   @07,SASTNORQ-8(@14,@15)                          01S0275
*                      END;            /*                    @G29AN2F*/
*                  END;                /*END OF REQUEST      @G29AN2F*/
*                ELSE;                 /*NOT A SUBSYSTEM        01S0278
*                                        REQUEST             @G29AN2F*/
@RF00234 DS    0H                                               01S0279
*                SIOTPTR = SIOTNPTR;   /*GET NEXT SIOT       @G29AN2F*/
@RC00234 L     SIOTPTR,SIOTNPTR(,SIOTPTR)                       01S0279
*              END;                    /*END SIOT LOOP       @G29AN2F*/
@DE00233 SLR   @15,@15                                          01S0280
         CR    SIOTPTR,@15                                      01S0280
         BE    @DC00233                                         01S0280
         LR    @14,I                                            01S0280
         MH    @14,@CH00959                                     01S0280
         L     @01,LCLSASTP                                     01S0280
         AL    @01,@CF01582                                     01S0280
         CH    @15,SASTNORQ-8(@14,@01)                          01S0280
         BE    @DC00233                                         01S0280
         CR    RETCODE,@15                                      01S0280
         BE    @DL00233                                         01S0280
@DC00233 DS    0H                                               01S0281
*              IF RETCODE = ZERO       /*IF NO ERROR AND     @G29AN2F*/
*                & SASTNOGP(I) > ZERO THEN /*GROUP REQUESTS? @G29AN2F*/
         SLR   @08,@08                                          01S0281
         CR    RETCODE,@08                                      01S0281
         BNE   @RF00281                                         01S0281
         LR    @15,I                                            01S0281
         MH    @15,@CH00959                                     01S0281
         L     @01,LCLSASTP                                     01S0281
         BCTR  @01,0                                            01S0281
         BCTR  @01,0                                            01S0281
         CH    @08,SASTNOGP-10(@15,@01)                         01S0281
         BNL   @RF00281                                         01S0281
*                DO;                   /*YES, HAVE SUBSYSTEM @G29AN2F*/
*/********************************************************************/
*/*                                                          @G29AN2F*/
*/* SEGMENT NAME - ALOCGPRQ                                  @G29AN2F*/
*/*                                                          @G29AN2F*/
*/* DESCRIPTIVE NAME - CALL SUBSYSTEM TO ALLOCATE GROUP      @G29AN2F*/
*/*                    REQUESTS                              @G29AN2F*/
*/*                                                          @G29AN2F*/
*/* FUNCTION -                                               @G29AN2F*/
*/*   THE PURPOSE OF THIS SEGMENT IS TO INVOKE A SUBSYSTEM   @G29AN2F*/
*/*   TO ALLOCATE ALL OF ITS GROUP REQUESTS. IF THE SUB-     @G29AN2F*/
*/*   SYSTEM SUCCESSFULLY ALLOCATES THE REQUESTS THEN A CALL @G29AN2F*/
*/*   IS MADE TO THE BLDTIOT ROUTINE, FOR EACH OF THE        @G29AN2F*/
*/*   REQUESTS, TO BUILD A DSAB AND TIOT ENTRY, MARK THE     @G29AN2F*/
*/*   SIOT ALLOCATED AND TO DECREMENT THE COUNT OF SUBSYSTEM @G29AN2F*/
*/*   REQUESTS AND THE TOTAL COUNT OF ALLOCATION REQUESTS    @G29AN2F*/
*/*   (CONTAINED IN THE ALCWA).                              @G29AN2F*/
*/*                                                          @G29AN2F*/
*/* ENTRY - IN LINE SUBROUTINE                               @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*  PURPOSE - SEE FUNCTION                                  @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*  INPUT -                                                 @G29AN2F*/
*/*    SSOB - SUBSYSTEM OPTIONS BLOCK HEADER                 @G29AN2F*/
*/*    SUBSNAME - SUBSYSTEM NAME TO BE CALLED                @G29AN2F*/
*/*    RBAREAP - PTR TO REQUEST BLOCK CHAIN                  @G29AN2F*/
*/*                                                          @G29AN2F*/
*/* EXIT - NORMAL                                            @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*   CONDITION - SUBSYSTEM REQUESTS SUCCESSFULLY ALLOCATED  @G29AN2F*/
*/*     OUTPUT -                                             @G29AN2F*/
*/*       ONE DSAB BUILT PER GROUP REQUEST                   @G29AN2F*/
*/*       ONE TIOT ENTRY BUILT PER GROUP REQUEST             @G29AN2F*/
*/*                                                          @G29AN2F*/
*/* EXIT - ERROR                                             @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*   CONDITION - ONE OR MORE OF THE REQUESTS WAS NOT        @G29AN2F*/
*/*               SUCCESSFULLY ALLOCATED.                    @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*     OUTPUT - NONE                                        @G29AN2F*/
*/*     RETURN CODES -                                       @G29AN2F*/
*/*       SEE SEGMENT SPEC FOR SEGMENT 'GPRQERR' FOR A       @G29AN2F*/
*/*       DESCRIPTION OF THIS SEGMENT'S ERROR CODES.         @G29AN2F*/
*/*       'GPRQERR' IS INVOKED TO PROCESS ERRORS.            @G29AN2F*/
*/*                                                          @G29AN2F*/
*/********************************************************************/
*SSAG = SSAG && SSAG;                  /*CLEAR THE SSAG      @G29AN2F*/
         XC    SSAG(28),SSAG                                    02S0283
*SSAGLEN = LENGTH(SSAG);               /*SET SSAG LENGTH     @G29AN2F*/
         MVC   SSAGLEN(2),@CH00128                              02S0284
*SSAGARBP = RBAREAP;                   /*SET PTR TO 1ST RB   @G29AN2F*/
         MVC   SSAGARBP(4),RBAREAP                              02S0285
*PSARBPTR = ZERO;                      /*CLEAR PREVIOUS REQUEST 02S0286
*                                        BLOCK POINTER       @G29AN2F*/
         ST    @08,PSARBPTR                                     02S0286
*IF WAITOKSW = ON THEN                 /*IS THE SUBSYSTEM TO WAIT
*                                        FOR SUBSYSTEM D.S.? @G29AN2F*/
         L     @10,@PC00001                                     02S0287
         L     @10,ALCWAPTR(,@10)                               02S0287
         L     @08,FMAPPTR(,@10)                                02S0287
         TM    WAITOKSW(@08),B'00000100'                        02S0287
         BNO   @RF00287                                         02S0287
*  DO;                                 /*YES, SET FIELDS     @G29AN2F*/
*    SSAGWAIT = ON;                    /*SET SSAG WAIT SWITCH@G29AN2F*/
         OI    SSAGWAIT,B'10000000'                             02S0289
*    SSAGCNCL = CANCELP;               /*PTR TO CANCEL ECB   @G29AN2F*/
         MVC   SSAGCNCL(4),CANCELP(@10)                         02S0290
*  END;                                /*                    @G29AN2F*/
*SSAGJBNM = ADDR(ALCJOBN);             /*PTR TO JOB NAME     @G29AN2F*/
@RF00287 L     @10,@PC00001                                     02S0292
         L     @10,ALCWAPTR(,@10)                               02S0292
         MVC   SSAGJBNM(4),TIOTHDRP(@10)                        02S0292
*IF SSEMSGSW = ON THEN                 /*IS SUBSYSTEM TO RETURN 02S0293
*                                        ERROR MESSAGES ?    @G29AN2F*/
         L     @10,FMAPPTR(,@10)                                02S0293
         TM    SSEMSGSW(@10),B'10000000'                        02S0293
         BNO   @RF00293                                         02S0293
*  DO;                                 /*YES, SET UP FOR MSG @G29AN2F*/
*    SSAGSMSG=ON;                      /*TELL SUBSYSTEM TO RETURN
*                                        MESSAGES            @G29AN2F*/
         OI    SSAGSMSG,B'01000000'                             02S0295
*    SSAGGMLN = LENGTH(SSMSGTXT);      /*SET MAX LENGTH OF MESSAGE
*                                        TO BE RETURNED      @G29AN2F*/
         MVC   SSAGGMLN(4),@CF01397                             02S0296
*    SSAGGMGP = ADDR(SSMSGLEN(MSGIDX));/*PTR TO GROUP MESSAGE AREA
*                                                            @G29AN2F*/
         L     @10,SSMSGBKP                                     02S0297
         L     @08,MSGIDX                                       02S0297
         LR    @15,@08                                          02S0297
         MH    @15,@CH01576                                     02S0297
         LA    @01,0(@15,@10)                                   02S0297
         AL    @01,@CF01587                                     02S0297
         ST    @01,SSAGGMGP                                     02S0297
*    SSMDDNUM(MSGIDX) = ZERO;          /*CLEAR DD NUMBER     @G29AN2F*/
         SLR   @14,@14                                          02S0298
         AL    @10,@CF01586                                     02S0298
         STH   @14,SSMDDNUM-8(@15,@10)                          02S0298
*    GPMSGI = MSGIDX;                  /*SAVE MESSAGE INDEX  @G29AN2F*/
         STH   @08,GPMSGI                                       02S0299
*  END;                                /*END MSG SET UP      @G29AN2F*/
*SSOBFUNC = SSOBAGRP;                  /*SET SSOB FOR GROUP     02S0301
*                                        REQUESTS            @G29AN2F*/
@RF00293 MVC   SSOBFUNC(2),@CH01194                             02S0301
*SSOBINDV = ADDR(SSAG);                /*POINT TO SSAG       @G29AN2F*/
         LA    @10,SSAG                                         02S0302
         ST    @10,SSOBINDV                                     02S0302
*SSIB = SSIB && SSIB;                  /*CLEAR SSIB AREA     @G29AN2F*/
         L     @10,SSIBPTR                                      02S0303
         XC    SSIB(36,@10),SSIB(@10)                           02S0303
*SSIBID = CNSTSSIB;                    /*SET SSIB ID         @G29AN2F*/
         MVC   SSIBID(4,@10),CNSTSSIB                           02S0304
*SSIBLEN = LENGTH(SSIB);               /*SET SSIB LENGTH     @G29AN2F*/
         MVC   SSIBLEN(2,@10),@CH01578                          02S0305
*SSIBSSNM = SUBSYSNM;                  /*INSERT NAME OF THE SUBSYSTEM
*                                        TO PROCESS REQUEST  @G29AN2F*/
         MVC   SSIBSSNM(4,@10),SUBSYSNM                         02S0306
*SSOBSSIB = ADDR(SSIB);                /*CONNECT SSIB TO SSOB@G29AN2F*/
*                                                               02S0307
         ST    @10,SSOBSSIB                                     02S0307
* /* ? IEFSSREQ  (SSOB);*/                                      02S0308
*/*                                           */                02S0308
*/*  PASS CONTROL TO JOB ENTRY SUBSYSTEM TO   */                02S0308
*/*  PROCESS REQUEST -                        */                02S0308
*/*                                           */                02S0308
*/*    INPUT - REGISTER 1 POINTS TO A ONE-    */                02S0308
*/*            WORD PARAMETER LIST WHICH      */                02S0308
*/*            POINTS TO THE SSOB             */                02S0308
*/*                                           */                02S0308
*CALL SSREQ(SSOB);                     /*INVOKE SUBSYSTEM    @G29AN2F*/
         LA    @10,SSOB                                         02S0308
         ST    @10,@AL00001                                     02S0308
         MVI   @AL00001,X'80'                                   02S0308
         L     @10,CVTPTR                                       02S0308
         L     @10,CVTJESCT(,@10)                               02S0308
         L     @15,JESSSREQ(,@10)                               02S0308
         LA    @01,@AL00001                                     02S0308
         BALR  @14,@15                                          02S0308
*RETCODE = REG15;                      /*SAVE RETURN CODE    @G29AN2F*/
         LR    RETCODE,REG15                                    02S0309
*IF RETCODE = SSRTOK &                 /*FUNCTION RETURN OK  @G29AN2F*/
*   SSOBRETN = SSAGRTOK THEN           /*AND SSOB RETURN OK  @G29AN2F*/
         SLR   @08,@08                                          02S0310
         CR    RETCODE,@08                                      02S0310
         BNE   @RF00310                                         02S0310
         C     @08,SSOBRETN                                     02S0310
         BNE   @RF00310                                         02S0310
*  DO;                                 /*                    @G29AN2F*/
*    SSARBPTR = SSAGARBP;              /*SET PTR TO FIRST RB @G29AN2F*/
         L     SSARBPTR,SSAGARBP                                02S0312
*    DO WHILE SSARBPTR ^= ZERO         /*PROCESS ALL RB'S    @G29AN2F*/
*           & RETCODE = ZERO;          /*WHILE NO ERROR      @G29AN2F*/
         B     @DE00313                                         02S0313
@DL00313 DS    0H                                               02S0314
*      SIOTPTR = SARBSPTR;             /*GET PTR TO SIOT     @G29AN2F*/
         L     SIOTPTR,SARBSPTR(,SSARBPTR)                      02S0314
*      SSDATAP = SSAGSSCM;             /*GET SUBSYSTEM DATA  @G29AN2F*/
         L     SSDATAP,SSAGSSCM(,SSARBPTR)                      02S0315
*      SSNAMEP = SSAGSSNM;             /*PTR TO SUBSYSTEM NM @G29AN2F*/
         L     SSNAMEP,SSAGSSNM(,SSARBPTR)                      02S0316
*      CALL BLDTIOT;                   /*BUILD DSAB & TIOT   @G29AN2F*/
         BAL   @14,BLDTIOT                                      02S0317
*      SSARBPTR = SSAGNRBP;            /*POINT TO NEXT RB    @G29AN2F*/
         L     SSARBPTR,SSAGNRBP(,SSARBPTR)                     02S0318
*    END;                              /*                    @G29AN2F*/
@DE00313 SLR   @08,@08                                          02S0319
         CR    SSARBPTR,@08                                     02S0319
         BE    @DC00313                                         02S0319
         CR    RETCODE,@08                                      02S0319
         BE    @DL00313                                         02S0319
@DC00313 DS    0H                                               02S0320
*    MSGIDX = ONE;                     /*RESET MESSAGE INDEX @G29AN2F*/
         MVC   MSGIDX(4),@CF00040                               02S0320
*    SSARBPTR = RBAREAP;               /*RESET RB PTR        @G29AN2F*/
         L     SSARBPTR,RBAREAP                                 02S0321
*  END;                                /*                    @G29AN2F*/
*ELSE                                  /*ERROR IN SUBSYSTEM     02S0323
*                                        PROCESSING          @G29AN2F*/
*  DO;                                 /*                    @G29AN2F*/
         B     @RC00310                                         02S0323
@RF00310 DS    0H                                               02S0324
*/********************************************************************/
*/*                                                          @G29AN2F*/
*/* SEGMENT NAME - GPRQERR                                   @G29AN2F*/
*/*                                                          @G29AN2F*/
*/* DESCRIPTIVE NAME - GROUP REQUEST ERROR PROCESSING        @G29AN2F*/
*/* FUNCTION -                                               @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*   THIS SEGMENT PROCESSES SUBSYSTEM RETURN CODES          @G29AN2F*/
*/*   RESULTING FROM AN UNSUCCESSFUL CALL TO THE SUBSYSTEM.  @G29AN2F*/
*/*   THE SUBSYSTEM CALL WAS FOR THE 'GROUP ALLOCATION'      @G29AN2F*/
*/*   SUBSYSTEM FUNCTION, SO MULTIPLE REQUEST-ORIENTED       @G29AN2F*/
*/*   REASON CODES MAY BE PROCESSED -- AS MANY AS ONE PER    @G29AN2F*/
*/*   REQUEST BLOCK.                                         @G29AN2F*/
*/*                                                          @G29AN2F*/
*/* OPERATION -                                              @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*   1. IF A GROUP-RELATED ERROR OCCURRED, INFORMATION      @G29AN2F*/
*/*      ABOUT THE ERROR IS PLACED INTO THE SUBSYSTEM        @G29AN2F*/
*/*      ERROR BLOCK AND SUBSYSTEM MSG BLOCK, AND A          @G29AN2F*/
*/*      SUBSYSTEM REASON CODE IS SET.                       @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*   2. IF A GROUP OR DD/REQUEST-RELATED ERROR OCCURRED,    @G29AN2F*/
*/*      ALL REQUEST BLOCKS ARE SEARCHED FOR ERROR           @G29AN2F*/
*/*      INFORMATION. ONE OR MORE REQUESTS MAY HAVE ERROR    @G29AN2F*/
*/*      INFORMATION, EVEN IF A GROUP-RELATED ERROR          @G29AN2F*/
*/*      OCCURRED. FOR AN RB WHICH HAS ERROR INFORMATION,    @G29AN2F*/
*/*      ITS ERROR INFORMATION IS PLACED IN THE CORRESPOND-  @G29AN2F*/
*/*      ING SIOT.                                           @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*   3. IF SUBSYSTEM ERROR MESSAGES ARE TO BE RETURNED      @G29AN2F*/
*/*      TO ALLOCATION'S CALLER, THE POINTER TO THE BLOCK    @G29AN2F*/
*/*      CONTAINING THE SUBSYSTEM-GENERATED MSGS IS PLACED   @G29AN2F*/
*/*      INTO THE SUBSYSTEM ERROR BLOCK, AS IS THE NUMBER    @G29AN2F*/
*/*      OF MSGS IN THE BLOCK.                               @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*   4. WHENEVER AN ERROR CODE IS ENCOUNTERED WHICH IS      @G29AN2F*/
*/*      UNDEFINED, A 'SUBSYSTEM LOGIC ERROR' CODE IS SET.   @G29AN2F*/
*/*      WHEN SSOBRETN INDICATES NEITHER GROUP NOR REQUEST-  @G29AN2F*/
*/*      RELATED ERROR, THIS 'LOGIC ERROR' CODE IS SET IN    @G29AN2F*/
*/*      THE SIOT FOR THE FIRST RB IN THE GROUP.             @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*   5. IF AN ERROR OCCURRED IN SUBSYSTEM INTERFACE         @G29AN2F*/
*/*      PROCESSING, THE APPROPRIATE ERROR CODE IS SET       @G29AN2F*/
*/*      IN THE SIOT FOR THE FIRST RB IN THE GROUP.          @G29AN2F*/
*/*                                                          @G29AN2F*/
*/* NOTE: REFER TO THE CONSTANTS REASCDE AND SSYSIFEC FOR    @G29AN2F*/
*/*       THE MAPPING OF GROUP/REQUEST RELATED ERROR CODES   @G29AN2F*/
*/*       AND SUBSYSTEM INTERFACE RETURN CODES INTO SIOT     @G29AN2F*/
*/*       AND STEP RELATED RETURN CODES.                     @G29AN2F*/
*/*                                                          @G29AN2F*/
*/* ENTRY - IN-LINE                                          @G29AN2F*/
*/*   PURPOSE - SEE FUNCTION                                 @G29AN2F*/
*/*     INPUT -                                              @G29AN2F*/
*/*       RETCODE - 0 INDICATES SUBSYSTEM ERROR              @G29AN2F*/
*/*                 NON-ZERO INDICATES SUBSYSTEM             @G29AN2F*/
*/*                 INTERFACE ERROR.                         @G29AN2F*/
*/*       SSOBRETN - INDICATES WHETHER ERROR WAS GROUP       @G29AN2F*/
*/*                  OR REQUEST RELATED.                     @G29AN2F*/
*/*       SSAG -                                             @G29AN2F*/
*/*         SSAGGPEC - GROUP-RELATED ERROR CODE              @G29AN2F*/
*/*         SSAGGPIC - GROUP-RELATED INFO CODE               @G29AN2F*/
*/*         SSAGARBK - GROUP-ALLOCATION REQUEST BLOCK        @G29AN2F*/
*/*           SSAGRBEC - REQUEST-RELATED ERROR CODE          @G29AN2F*/
*/*           SSAGRBIC - REQUEST-RELATED INFO CODE           @G29AN2F*/
*/*           SARBSPTR - SIOT POINTER                        @G29AN2F*/
*/*       SSEMSGSW - IF ON, INDICATES SUBSYSTEM MSGS ARE     @G29AN2F*/
*/*                  TO BE RETURNED TO CALLER OF ALLOCATION  @G29AN2F*/
*/*                                                          @G29AN2F*/
*/* EXIT - NORMAL                                            @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*    CONDITION - ERROR INFORMATION FOR 'GROUP' SUBSYSTEM   @G29AN2F*/
*/*                ALLOCATION PROCESSED.                     @G29AN2F*/
*/*      OUTPUT -                                            @G29AN2F*/
*/*        SSERRBLK - SUBSYSTEM ERROR BLOCK                  @G29AN2F*/
*/*          SSEINCDE - GROUP INFO CODE(IF ANY)              @G29AN2F*/
*/*          SSESMSGI - INDEX (INTO SSMSGBLK) OF GROUP ERROR @G29AN2F*/
*/*                     MSG(IF ANY)                          @G29AN2F*/
*/*        SSMSGBLK - SUBSYSTEM MSG BLOCK                    @G29AN2F*/
*/*          SSMBADIM - NUMBER OF MSGS IN BLOCK              @G29AN2F*/
*/*        SIOT -                                            @G29AN2F*/
*/*          SIOTSSIC - REQUEST-RELATED INFO CODE            @G29AN2F*/
*/*          SIOTRSNC - REQUEST-RELATED ERROR CODE           @G29AN2F*/
*/*                              OR                          @G29AN2F*/
*/*                     'LOGIC ERROR' CODE(IN FIRST REQUEST'S@G29AN2F*/
*/*                     SIOT) IF SUBSYSTEM ERROR NEITHER     @G29AN2F*/
*/*                     GROUP NOR REQUEST RELATED            @G29AN2F*/
*/*                              OR                          @G29AN2F*/
*/*                     SUBSYSTEM INTERFACE ERROR CODE (IN   @G29AN2F*/
*/*                     FIRST REQUEST'S SIOT) IF RETCODE     @G29AN2F*/
*/*                     NON-ZERO                             @G29AN2F*/
*/*                                                          @G29AN2F*/
*/********************************************************************/
*IF RETCODE = SSRTOK THEN              /*IS INTERFACE RETURN CODE
*                                        OK ?                @G29AN2F*/
         LTR   RETCODE,RETCODE                                  03S0324
         BNZ   @RF00324                                         03S0324
*  DO;                                 /*YES, THEN SUBSYSTEM RETURNED
*                                        AN ERROR INDICATION @G29AN2F*/
*    IF SSOBRETN = SSAGGPER THEN       /*WAS GROUP LEVEL ERROR  03S0326
*                                        INDICATED ?         @G29AN2F*/
         CLC   SSOBRETN(4),@CF00109                             03S0326
         BNE   @RF00326                                         03S0326
*      DO;                             /*YES                 @G29AN2F*/
*        SSEINCDE = SSAGGPIC;          /*SET INFO CODE IN       03S0328
*                                        ERROR BLOCK         @G29AN2F*/
         L     @10,@PC00001                                     03S0328
         L     @10,ALCWAPTR(,@10)                               03S0328
         L     @08,SSERBLKP(,@10)                               03S0328
         MVC   SSEINCDE(2,@08),SSAGGPIC                         03S0328
*        IF SSEMSGSW = ON THEN         /*IF SUBSYSTEM TO RETURN 03S0329
*                                        ERROR MESSAGES      @G29AN2F*/
         L     @10,FMAPPTR(,@10)                                03S0329
         TM    SSEMSGSW(@10),B'10000000'                        03S0329
         BNO   @RF00329                                         03S0329
*          SSESMSGI = GPMSGI;          /*SET INDEX TO GROUP MESSAGE
*                                        IN ERROR BLOCK      @G29AN2F*/
         MVC   SSESMSGI(2,@08),GPMSGI                           03S0330
*        IF SSAGGPEC > SSAGRQOK &      /*IS ERROR CODE IN    @G29AN2F*/
*           SSAGGPEC <= SSAGSSER THEN  /*VALID RANGE ?       @G29AN2F*/
@RF00329 LH    @10,SSAGGPEC                                     03S0331
         LTR   @10,@10                                          03S0331
         BNP   @RF00331                                         03S0331
         CH    @10,@CH00187                                     03S0331
         BH    @RF00331                                         03S0331
*          SSRSNC = STEPCDE(SSAGGPEC/4);/*YES, CONVERT       @G29AN2F*/
         L     @08,@PC00001                                     03S0332
         L     @08,ALCWAPTR(,@08)                               03S0332
         L     @08,FAILRSCP(,@08)                               03S0332
         LR    @00,@10                                          03S0332
         SRDA  @00,32                                           03S0332
         D     @00,@CF00047                                     03S0332
         SLA   @01,2                                            03S0332
         LH    @10,STEPCDE-4(@01)                               03S0332
         STH   @10,SSRSNC(,@08)                                 03S0332
*        ELSE                          /*NOT IN VALID RANGE  @G29AN2F*/
*          SSRSNC = STEPCDE(SSAGSSER/4);/*SET TO LOGIC ERROR @G29AN2F*/
         B     @RC00331                                         03S0333
@RF00331 L     @10,@PC00001                                     03S0333
         L     @10,ALCWAPTR(,@10)                               03S0333
         L     @10,FAILRSCP(,@10)                               03S0333
         MVC   SSRSNC(2,@10),STEPCDE+20                         03S0333
*      END;                            /*                    @G29AN2F*/
@RC00331 DS    0H                                               03S0335
*    IF SSOBRETN = SSAGDDER |          /*WERE THERE DD ERRS  @G29AN2F*/
*       SSOBRETN = SSAGGPER THEN       /*OR GROUP ERRORS ?   @G29AN2F*/
@RF00326 L     @10,SSOBRETN                                     03S0335
         CH    @10,@CH00047                                     03S0335
         BE    @RT00335                                         03S0335
         CH    @10,@CH00109                                     03S0335
         BNE   @RF00335                                         03S0335
@RT00335 DS    0H                                               03S0336
*      DO;                             /*YES, SCAN RBS       @G29AN2F*/
*        SSARBPTR = SSAGARBP;          /*SET PTR TO FIRST RB @G29AN2F*/
         L     SSARBPTR,SSAGARBP                                03S0337
*        DO WHILE SSARBPTR ^= ZERO;    /*SCAN ALL REQUESTS   @G29AN2F*/
         B     @DE00338                                         03S0338
@DL00338 DS    0H                                               03S0339
*          IF SSAGRBEC ^= SSAGRQOK THEN /*WAS REQUEST IN        03S0339
*                                           ERROR ?          @G29AN2F*/
         LH    @10,SSAGRBEC(,SSARBPTR)                          03S0339
         LTR   @10,@10                                          03S0339
         BZ    @RF00339                                         03S0339
*            DO;                       /*YES, SET SIOT REASON   03S0340
*                                        CODE                @G29AN2F*/
*              SIOTPTR = SARBSPTR;     /*GET SIOT PTR        @G29AN2F*/
         L     SIOTPTR,SARBSPTR(,SSARBPTR)                      03S0341
*              SIOTSSIC = SSAGRBIC;    /*SET INFO CODE       @G29AN2F*/
         MVC   SIOTSSIC(2,SIOTPTR),SSAGRBIC(SSARBPTR)           03S0342
*              IF SSAGRBEC <= SSAGSSER THEN /*IS ERROR CODE IN VALID
*                                               RANGE ?      @G29AN2F*/
         CH    @10,@CH00187                                     03S0343
         BH    @RF00343                                         03S0343
*                SIOTRSNC = SIOTCDE(SSAGRBEC/4);/*YES           03S0344
*                                                 SET CODE   @G29AN2F*/
         LR    @00,@10                                          03S0344
         SRDA  @00,32                                           03S0344
         D     @00,@CF00047                                     03S0344
         SLA   @01,2                                            03S0344
         LH    @10,SIOTCDE-4(@01)                               03S0344
         STH   @10,SIOTRSNC(,SIOTPTR)                           03S0344
*              ELSE                    /*INVALID RANGE       @G29AN2F*/
*                SIOTRSNC = SIOTCDE(SSAGSSER/4);/*SET TO LOGIC  03S0345
*                                                     ERROR  @G29AN2F*/
         B     @RC00343                                         03S0345
@RF00343 MVC   SIOTRSNC(2,SIOTPTR),SIOTCDE+20                   03S0345
*              IF SSEMSGSW = ON THEN   /*WERE MSG'S TO BE RETURNED BY
*                                        THE SUBSYSTEM?      @G29AN2F*/
@RC00343 L     @10,@PC00001                                     03S0346
         L     @10,ALCWAPTR(,@10)                               03S0346
         L     @10,FMAPPTR(,@10)                                03S0346
         TM    SSEMSGSW(@10),B'10000000'                        03S0346
         BNO   @RF00346                                         03S0346
*                SIOTSSMG = ON;        /*YES, INDICATE MSG   @G29AN2F*/
         OI    SIOTSSMG(SIOTPTR),B'00001000'                    03S0347
*            END;                      /*END RB IN ERROR     @G29AN2F*/
@RF00346 DS    0H                                               03S0349
*          SSARBPTR = SSAGNRBP;        /*GET PTR TO NEXT RB  @G29AN2F*/
@RF00339 L     SSARBPTR,SSAGNRBP(,SSARBPTR)                     03S0349
*        END;                          /*GET NEXT RB         @G29AN2F*/
@DE00338 LTR   SSARBPTR,SSARBPTR                                03S0350
         BNZ   @DL00338                                         03S0350
*      END;                            /*END GP/DD ERRORS    @G29AN2F*/
*    IF SSEMSGSW = ON THEN             /*ERROR MSG'S TO BE      03S0352
*                                        RETURNED?           @G29AN2F*/
@RF00335 L     @10,@PC00001                                     03S0352
         L     @10,ALCWAPTR(,@10)                               03S0352
         L     @08,FMAPPTR(,@10)                                03S0352
         TM    SSEMSGSW(@08),B'10000000'                        03S0352
         BNO   @RF00352                                         03S0352
*      DO;                             /*YES,                @G29AN2F*/
*        SSEMBPTR = ADDR(SSMSGBLK);    /*POINT TO ERROR         03S0354
*                                        MESSAGE BLOCK       @G29AN2F*/
         L     @08,SSMSGBKP                                     03S0354
         L     @10,SSERBLKP(,@10)                               03S0354
         ST    @08,SSEMBPTR(,@10)                               03S0354
*        SSMBADIM = GPMSGI;            /*SET MSG ARRAY DIMENSION
*                                                            @G29AN2F*/
         MVC   SSMBADIM(2,@08),GPMSGI                           03S0355
*      END;                            /*END ERROR MSG       @G29AN2F*/
*    IF SSOBRETN > SSAGGPER THEN       /*IS R.C. UNKNOWN?    @G29AN2F*/
@RF00352 CLC   SSOBRETN(4),@CF00109                             03S0357
         BNH   @RF00357                                         03S0357
*      DO;                             /*YES, RETURN AS LOGIC ERROR
*                                        IN FIRST REQUEST    @G29AN2F*/
*        SSARBPTR = SSAGARBP;          /*PTR TO FIRST RB     @G29AN2F*/
         L     SSARBPTR,SSAGARBP                                03S0359
*        SIOTPTR = SARBSPTR;           /*GET SIOT PTR        @G29AN2F*/
         L     SIOTPTR,SARBSPTR(,SSARBPTR)                      03S0360
*        SIOTRSNC = SIOTCDE(SSAGSSER/4);/*SET R.C.           @G29AN2F*/
         MVC   SIOTRSNC(2,SIOTPTR),SIOTCDE+20                   03S0361
*      END;                            /*                    @G29AN2F*/
*    RETCODE = ERROR;                  /*SET ERROR RETURN    @G29AN2F*/
@RF00357 LA    RETCODE,4                                        03S0363
*  END;                                /*END SUBSYS ERROR    @G29AN2F*/
*ELSE                                  /*SS INTERFACE ERROR  @G29AN2F*/
*  DO;                                 /*RETURNED AS DD ERR  @G29AN2F*/
         B     @RC00324                                         03S0365
@RF00324 DS    0H                                               03S0366
*    SSARBPTR = SSAGARBP;              /*PTR TO FIRST RB     @G29AN2F*/
         L     SSARBPTR,SSAGARBP                                03S0366
*    SIOTPTR = SARBSPTR;               /*PTR TO CORRESPONDING   03S0367
*                                        SIOT                @G29AN2F*/
         L     SIOTPTR,SARBSPTR(,SSARBPTR)                      03S0367
*    IF RETCODE <= SSRTLERR THEN       /*IS RETURN CODE IN VALID
*                                        RANGE ?             @G29AN2F*/
         CH    RETCODE,@CH01157                                 03S0368
         BH    @RF00368                                         03S0368
*      SIOTRSNC = SUBSIFEC(RETCODE/4); /*SET RETURN CODE        03S0369
*                                        FROM TABLE          @G29AN2F*/
         LR    @00,RETCODE                                      03S0369
         SRDA  @00,32                                           03S0369
         D     @00,@CF00047                                     03S0369
         ALR   @01,@01                                          03S0369
         LH    @15,SUBSIFEC-2(@01)                              03S0369
         STH   @15,SIOTRSNC(,SIOTPTR)                           03S0369
*    ELSE                              /*NOT IN VALID RANGE  @G29AN2F*/
*      SIOTRSNC = SUBSIFEC(SSRTLERR/4);/*RETURN AS A            03S0370
*                                        LOGIC ERROR         @G29AN2F*/
         B     @RC00368                                         03S0370
@RF00368 MVC   SIOTRSNC(2,SIOTPTR),SUBSIFEC+8                   03S0370
*    RETCODE = ERROR;                  /*SET RETURN CODE     @G29AN2F*/
@RC00368 LA    RETCODE,4                                        03S0371
*  END;                                /*END SS I/F ERRORS   @G29AN2F*/
*  END;                                /*                    @G29AN2F*/
*                END;                  /*                    @G29AN2F*/
*            END;                      /*END SUBSYSTEM          01S0375
*                                        ALLOCATION          @G29AN2F*/
*          ELSE;                       /*NO REQUESTS         @G29AN2F*/
@RF00226 DS    0H                                               01S0377
*        END;                          /*END PROCESSING FOR     01S0377
*                                        THIS SUBSYSTEM      @G29AN2F*/
@RC00226 AL    I,@CF00040                                       01S0377
@DE00225 CR    I,NUMSUBS                                        01S0377
         BNH   @DL00225                                         01S0377
@DC00225 DS    0H                                               01S0378
*        IF MAXGPCT > ZERO THEN        /*IF GROUP REQUESTS   @G29AN2F*/
         ICM   @02,15,MAXGPCT                                   01S0378
         BNP   @RF00378                                         01S0378
*          DO;                         /*THEN FREE AREAS     @G29AN2F*/
*              DO; /*FREEMAIN(R) LV(RBAREASZ)SP(SPNUM)A(RBAREA)*/
*              RESPECIFY (GPR01F,GPR00F) RESTRICTED;            01S0381
*              GPR00F = RBAREASZ; /* LENGTH REQUESTED*/         01S0382
         L     GPR00F,RBAREASZ                                  01S0382
*              GPR01F = SPNUM; /* SP IN REG 1 */                01S0383
         LA    GPR01F,230                                       01S0383
*              GEN   (SLL   GPR01F,24)                          01S0384
*              NODEFS NOREFS NOSETS NOEXIT NOFLOWS SEQFLOW;     01S0384
         SLL   GPR01F,24
*              GPR00F = GPR00F | GPR01F; /* SP IN HI BYTE */    01S0385
         OR    GPR00F,GPR01F                                    01S0385
*              GPR01F=ADDR(RBAREA); /*SET REGISTER ONE*/        01S0386
         L     GPR01F,RBAREAP                                   01S0386
*              SVC(10); /* R-FORM OF GETMAIN*/                  01S0387
         SVC   10                                               01S0387
*              RESPECIFY (GPR01F,GPR00F) UNRESTRICTED;          01S0388
*              END; /*FREEMAIN(R) LV(RBAREASZ)SP(SPNUM)A(RBAREA)*//*
*                                             RETURN RB AREA      @G29A
*2F*/                                                           01S0389
*            IF SSEMSGSW = ON          /*CHECK IF THE        @G29AN2F*/
*               & RETCODE = ZERO       /*MESSAGE AREA MAY    @G29AN2F*/
*               & SSEMBPTR = ZERO THEN /*BE RETURNED         @G29AN2F*/
         L     @02,@PC00001                                     01S0390
         L     @02,ALCWAPTR(,@02)                               01S0390
         L     @01,FMAPPTR(,@02)                                01S0390
         TM    SSEMSGSW(@01),B'10000000'                        01S0390
         BNO   @RF00390                                         01S0390
         SLR   @15,@15                                          01S0390
         CR    RETCODE,@15                                      01S0390
         BNE   @RF00390                                         01S0390
         L     @02,SSERBLKP(,@02)                               01S0390
         C     @15,SSEMBPTR(,@02)                               01S0390
         BNE   @RF00390                                         01S0390
*                DO; /*FREEMAIN(R) LV(MSGBLKSZ)SP(SPNUM)A(SSMSGBLK)*/
*                RESPECIFY (GPR01F,GPR00F) RESTRICTED;          01S0392
*                GPR00F = MSGBLKSZ; /* LENGTH REQUESTED*/       01S0393
         L     GPR00F,MSGBLKSZ                                  01S0393
*                GPR01F = SPNUM; /* SP IN REG 1 */              01S0394
         LA    GPR01F,230                                       01S0394
*                GEN   (SLL   GPR01F,24)                        01S0395
*                NODEFS NOREFS NOSETS NOEXIT NOFLOWS SEQFLOW;   01S0395
         SLL   GPR01F,24
*                GPR00F = GPR00F | GPR01F; /* SP IN HI BYTE */  01S0396
         OR    GPR00F,GPR01F                                    01S0396
*                GPR01F=ADDR(SSMSGBLK); /*SET REGISTER ONE*/    01S0397
         L     GPR01F,SSMSGBKP                                  01S0397
*                SVC(10); /* R-FORM OF GETMAIN*/                01S0398
         SVC   10                                               01S0398
*                RESPECIFY (GPR01F,GPR00F) UNRESTRICTED;        01S0399
*                END; /*FREEMAIN(R) LV(MSGBLKSZ)SP(SPNUM)A(SSMSGBLK)*//
*                                             RETURN MSG AREA     @G29A
*2F*/                                                           01S0400
*          END;                        /*END FREE AREAS      @G29AN2F*/
*      END;                            /*                    @G29AN2F*/
*    ELSE;                             /*TABLE ERROR         @G29AN2F*/
@RF00223 DS    0H                                               01S0404
*    IF NUMSUBS > ONE THEN             /*SAST GETMAINED?     @G29AN2F*/
@RC00223 CH    NUMSUBS,@CH00040                                 01S0404
         BNH   @RF00404                                         01S0404
*        DO; /*FREEMAIN(R) LV(JSASTTBS)SP(SPNUM)A(SASTTBLE)*/   01S0405
*        RESPECIFY (GPR01F,GPR00F) RESTRICTED;                  01S0406
*        GPR00F = JSASTTBS; /* LENGTH REQUESTED*/               01S0407
         L     @15,CVTPTR                                       01S0407
         L     @15,CVTJESCT(,@15)                               01S0407
         L     @15,JESSASTA(,@15)                               01S0407
         LH    GPR00F,JSASTTBS(,@15)                            01S0407
*        GPR01F = SPNUM; /* SP IN REG 1 */                      01S0408
         LA    GPR01F,230                                       01S0408
*        GEN   (SLL   GPR01F,24)                                01S0409
*        NODEFS NOREFS NOSETS NOEXIT NOFLOWS SEQFLOW;           01S0409
         SLL   GPR01F,24
*        GPR00F = GPR00F | GPR01F; /* SP IN HI BYTE */          01S0410
         OR    GPR00F,GPR01F                                    01S0410
*        GPR01F=ADDR(SASTTBLE); /*SET REGISTER ONE*/            01S0411
         L     GPR01F,LCLSASTP                                  01S0411
*        SVC(10); /* R-FORM OF GETMAIN*/                        01S0412
         SVC   10                                               01S0412
*        RESPECIFY (GPR01F,GPR00F) UNRESTRICTED;                01S0413
*        END; /*FREEMAIN(R) LV(JSASTTBS)SP(SPNUM)A(SASTTBLE)*//*YES,
*                                             FREE IT             @G29A
*2F*/                                                           01S0414
*  END;                                /*END SU PROCESSING   @G29AN2F*/
@RF00404 DS    0H                                               01S0416
*RETURN CODE(RETCODE);                 /*RETURN WITH CODE            */
@RC00097 IC    @02,@OLDKEY                                      01S0416
         L     @13,4(,@13)                                      01S0416
         L     @00,@SIZDATD                                     01S0416
         LR    @01,@11                                          01S0416
         FSPACE   R,LV=(0),A=(1)
         MODESET KEYADDR=(2)
         LR    @15,@10                                          01S0416
         L     @14,12(,@13)                                     01S0416
         LM    @00,@12,20(@13)                                  01S0416
         BR    @14                                              01S0416
*/********************************************************************/
*/*                                                          @G29AN2F*/
*/* SEGMENT NAME - ALOCNGRP                                  @G29AN2F*/
*/*                                                          @G29AN2F*/
*/* DESCRIPTIVE NAME - NON-GROUP SUBSYSTEM REQUEST           @G29AN2F*/
*/*                    ALLOCATION                            @G29AN2F*/
*/*                                                          @G29AN2F*/
*/* FUNCTION -                                               @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*   THIS ROUTINE ALLOCATES A NON-GROUP SUBSYSTEM REQUEST.  @G29AN2F*/
*/*                                                          @G29AN2F*/
*/* OPERATION -                                              @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*   THE FOLLOWING OPERATIONS ARE PERFORMED:                @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*     1. A ROUTINE, BILDSSAL, IS INCLUDED TO COMPLETE      @G29AN2F*/
*/*        THE SUBSYSTEM INTERFACE BLOCK, THE SSAL.          @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*     2. THE SUBSYSTEM INTERFACE IS INVOKED BY CALLING     @G29AN2F*/
*/*        MODULE SSREQ. SSREQ CALLS THE SUBSYSTEM. THE      @G29AN2F*/
*/*        SUBSYSTEM RETURNS DIRECTLY TO THIS MODULE.        @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*     3. ON RETURN FROM THE SUBSYSTEM, IF THE SUBSYSTEM    @G29AN2F*/
*/*        WAS SUCCESSFUL, ROUTINE BLDTIOT IS CALLED.        @G29AN2F*/
*/*        BLDTIOT BUILDS A DSAB AND TIOT ENTRY, MARKS       @G29AN2F*/
*/*        THE SIOT ALLOCATED, AND DECREMENTS THE COUNT      @G29AN2F*/
*/*        OF SUBSYSTEM REQUESTS AND THE TOTAL COUNT OF      @G29AN2F*/
*/*        ALLOCATION REQUESTS (BOTH CONTAINED IN THE        @G29AN2F*/
*/*        ALCWA).                                           @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*     4. IF THE SUBSYSTEM WAS NOT SUCCESSFUL, THE ERROR    @G29AN2F*/
*/*        RETURN CODE IS CONVERTED INTO AN ALLOCATION       @G29AN2F*/
*/*        RETURN CODE.                                      @G29AN2F*/
*/*                                                          @G29AN2F*/
*/* ENTRY - ALOCNGRP                                         @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*   PURPOSE - SEE FUNCTION                                 @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*   INPUT -                                                @G29AN2F*/
*/*     SSOB    - PARTIALLY INITIALIZED                      @G29AN2F*/
*/*     SSAL    - PARTIALLY INITIALIZED                      @G29AN2F*/
*/*                                                          @G29AN2F*/
*/* EXIT - NORMAL                                            @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*   CONDITION - NO ERROR                                   @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*     OUTPUT -                                             @G29AN2F*/
*/*       DSAB BUILT                                         @G29AN2F*/
*/*       TIOT ENTRY BUILT                                   @G29AN2F*/
*/*                                                          @G29AN2F*/
*/* EXIT - ERROR                                             @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*   CONDITION - ERROR RETURN FROM SUBSYSTEM CALL           @G29AN2F*/
*/*     OUTPUT - NONE                                        @G29AN2F*/
*/*     RETURN CODES                                         @G29AN2F*/
*/*        RETCODE  - NON-ZERO                               @G29AN2F*/
*/*        SSRSNC   - SET TO APPROPRIATE STEP-RELATED ERROR  @G29AN2F*/
*/*                   IF ONE OCCURRED                        @G29AN2F*/
*/*        SIOTRSNC - SET TO REQUEST/DD RELATED ERROR IF     @G29AN2F*/
*/*                   ONE OCCURRED                           @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*   CONDITION - ERROR RETURN FROM ROUTINE BLDTIOT          @G29AN2F*/
*/*     OUTPUT - NONE                                        @G29AN2F*/
*/*     RETURN CODES -                                       @G29AN2F*/
*/*        RETCODE - NON-ZERO                                @G29AN2F*/
*/*        SSRSNC -  SET TO APPROPRIATE STEP-RELATED         @G29AN2F*/
*/*                  REASON CODE                             @G29AN2F*/
*/*                                                          @G29AN2F*/
*/********************************************************************/
*ALOCNGRP: PROC;                       /*PROCESS SIOTS HAVING   02S0417
*                                        SIOTSSGP NOT ON     @G29AN2F*/
ALOCNGRP STM   @14,@09,@SA00002                                 02S0417
         STM   @11,@12,@SA00002+48                              02S0417
*/********************************************************************/
*/* SEGMENT NAME - BILDSSAL                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - BUILD SUBSYSTEM INTERFACE FUNCTIONAL          */
*/*                    DEPENDENT AREA.                               */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THE PURPOSE OF THIS ROUTINE IS TO BUILD THE SSAL BLOCK,        */
*/*   WHICH IS PART OF THE SUBSYSTEM INTERFACE, (ALLOCATE SUBSYSTEM  */
*/*   REQUESTS).                                                     */
*/*                                                          @G29AN2F*/
*/*   ADDITIONALLY WHEN A SUBSYSTEM NAME IS SPECIFIED IN THE @G29AN2F*/
*/*   SIOT(SIOTSSNM) A SSIB IS BUILT FOR THE NAME AND        @G29AN2F*/
*/*   CONNECTED TO THE SSOB                                  @G29AN2F*/
*/*                                                                  */
*/* ENTRY - INLINE SUBROUTINE                                        */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*     FMAPPTR  - POINTER TO FUNCTION MAP                           */
*/*     ALCWAPTR - POINTER TO ALLOCATION WORK AREA                   */
*/*     SIOTPTR  - POINTER TO SIOT                                   */
*/*                                                                  */
*/* EXIT - INLINE                                                    */
*/*                                                                  */
*/*   CONDITON - SSAL BLOCK CONSTRUCTED                              */
*/*                                                                  */
*/*     OUTPUT -                                                     */
*/*       SSAL BLOCK                                                 */
*/*                                                                  */
*/*     RETURN CODE - (NONE)                                         */
*/*                                                                  */
*/********************************************************************/
*SSOBFUNC = SSOBALOC;                  /*SET ALOC FUNCTION   @G29AN2F*/
         MVC   SSOBFUNC(2),@CH01038                             03S0418
*SSOBINDV = ADDR(SSAL);                /*POINT TO SSAL       @G29AN2F*/
         LA    @10,SSAL                                         03S0419
         ST    @10,SSOBINDV                                     03S0419
*SSALDDNM = ADDR(SCTDDNAM);            /*PTR TO DDNAME               */
         LA    @10,SCTDDNAM(,SIOTPTR)                           03S0420
         ST    @10,SSALDDNM                                     03S0420
*SSALDEST = ADDR(SIOTDEST);            /*PTR TO DESTINATION FIELD    */
         LA    @10,SIOTDEST(,SIOTPTR)                           03S0421
         ST    @10,SSALDEST                                     03S0421
*SSALDISP = ADDR(SCTSDISP);            /*PTR TO SIOT DISP FIELD      */
         LA    @10,SCTSDISP(,SIOTPTR)                           03S0422
         ST    @10,SSALDISP                                     03S0422
*SSALDUMY = ADDR(SCTSBYT1);            /*PTR TO DUMMY / SYSIN FLAGS  */
         LA    @10,SCTSBYT1(,SIOTPTR)                           03S0423
         ST    @10,SSALDUMY                                     03S0423
*SSALSOUT = ADDR(SCTSBYT3);            /*PTR TO SYSOUT FLAGS         */
         LA    @10,SCTSBYT3(,SIOTPTR)                           03S0424
         ST    @10,SSALSOUT                                     03S0424
*SSALUNIT = ADDR(SCTUTYPE);            /*PTR TO UNIT TYPE FIELD      */
         LA    @10,SCTUTYPE(,SIOTPTR)                           03S0425
         ST    @10,SSALUNIT                                     03S0425
*SSALPGMN = ADDR(SCTOUTNM);            /*PTR TO PROGRAM NAME         */
         LA    @10,SCTOUTNM(,SIOTPTR)                           03S0426
         ST    @10,SSALPGMN                                     03S0426
*SSALFORM = ADDR(SCTOUTNO);            /*PTR TO SYS OUTPUT FORM NUMBR*/
         LA    @10,SCTOUTNO(,SIOTPTR)                           03S0427
         ST    @10,SSALFORM                                     03S0427
*SSALCLAS = ADDR(SCTOUTPN);            /*PTR TO SYSOUT CLASS         */
         LA    @10,SCTOUTPN(,SIOTPTR)                           03S0428
         ST    @10,SSALCLAS                                     03S0428
*SSALADSP = ADDR(SIOTALTD);            /*PTR TO ALTERNATE DISPOSITION*/
         LA    @10,SIOTALTD(,SIOTPTR)                           03S0429
         ST    @10,SSALADSP                                     03S0429
*SSALCOPY = ADDR(SIOTOUTC);            /*PTR TO NUMBER OF COPIES     */
         LA    @10,SIOTOUTC(,SIOTPTR)                           03S0430
         ST    @10,SSALCOPY                                     03S0430
*SSALSSNM = ADDR(SIOTSSNM);            /*SUB SYSTEM NAME             */
         LA    @10,SIOTSSNM(,SIOTPTR)                           03S0431
         ST    @10,SSALSSNM                                     03S0431
*SSALJFCB = SJFCBPTR;                  /*PTR TO JFCB                 */
         MVC   SSALJFCB(4),SJFCBPTR(SIOTPTR)                    03S0432
*IF SCTSYSOU = ON &                    /*SYSOUT DATA SET?            */
*  (SIOCLUNL = ON |                    /*WILL DATA SET BE DYNAMICALLY
*                                        UNALLOCATED BY CLOSE?       */
*   SIOTTRKM = ON |                    /*C/R DYNAMIC SYSOUT  @ZA06466*/
*  TRKMSW = ON) THEN                   /*NEW TRACK MASK TO BE   03S0433
*                                        ASSIGNED BY SUBSYSTEM?      */
         TM    SCTSYSOU(SIOTPTR),B'00001000'                    03S0433
         BNO   @RF00433                                         03S0433
         TM    SIOCLUNL(SIOTPTR),B'10000000'                    03S0433
         BO    @RT00433                                         03S0433
         TM    SIOTTRKM(SIOTPTR),B'00000100'                    03S0433
         BO    @RT00433                                         03S0433
         L     @10,@PC00001                                     03S0433
         L     @10,ALCWAPTR(,@10)                               03S0433
         L     @10,FMAPPTR(,@10)                                03S0433
         TM    TRKMSW(@10),B'00001000'                          03S0433
         BNO   @RF00433                                         03S0433
@RT00433 DS    0H                                               03S0434
*    SSALTRKM = ON;                    /*TELL SUBSYSTEM TO ASSIGN
*                                        NEW TRACK MASK              */
         OI    SSALTRKM,B'00001000'                             03S0434
*ELSE                                  /*NO NEW TRACK MASK   @ZA29515*/
*  SSALTRKM = OFF;                     /*                    @ZA29515*/
         B     @RC00433                                         03S0435
@RF00433 NI    SSALTRKM,B'11110111'                             03S0435
*IF ASNMSW = ON |                      /*DSN TO BE ASSIGNED? @ZA06466*/
*   SIOTDSNM = ON THEN                 /*C/R DYNAMIC SYSOUT  @ZA06466*/
@RC00433 L     @10,@PC00001                                     03S0436
         L     @10,ALCWAPTR(,@10)                               03S0436
         L     @10,FMAPPTR(,@10)                                03S0436
         TM    ASNMSW(@10),B'00000010'                          03S0436
         BO    @RT00436                                         03S0436
         TM    SIOTDSNM(SIOTPTR),B'00000010'                    03S0436
         BNO   @RF00436                                         03S0436
@RT00436 DS    0H                                               03S0437
*  SSALASNM = ON;                      /*TELL SUBSYSTEM TO ASSIGN
*                                        DATA SET NAME               */
         OI    SSALASNM,B'00000010'                             03S0437
*ELSE                                  /*DO NOT ASSIGN       @ZA29515*/
*  SSALASNM = OFF;                     /*DATA SET NAME       @ZA29515*/
         B     @RC00436                                         03S0438
@RF00436 NI    SSALASNM,B'11111101'                             03S0438
*RFY SSIB BASED(ADDR(LSSIB));                                   03S0439
@RC00436 DS    0H                                               03S0440
*IF SIOTSSNM ^= NOSSNM THEN            /*IF A SUBSYSTEM NAME @G29AN2F*/
         CLC   SIOTSSNM(4,SIOTPTR),NOSSNM                       03S0440
         BE    @RF00440                                         03S0440
*  DO;                                 /*THEN CONSTRUCT SSIB @G29AN2F*/
*    SSIB = SSIB && SSIB;              /*CLEAR OUT SSIB      @G29AN2F*/
         LA    @10,LSSIB                                        03S0442
         XC    SSIB(36,@10),SSIB(@10)                           03S0442
*    SSIBID = CNSTSSIB;                /*IDENTIFY AS SSIB    @G29AN2F*/
         MVC   SSIBID(4,@10),CNSTSSIB                           03S0443
*    SSIBLEN= LENGTH(SSIB);            /*INIT LENGTH         @G29AN2F*/
         MVC   SSIBLEN(2,@10),@CH01578                          03S0444
*    SSIBSSNM = SIOTSSNM;              /*INSERT THE NAME     @G29AN2F*/
         MVC   SSIBSSNM(4,@10),SIOTSSNM(SIOTPTR)                03S0445
*    SSOBSSIB = ADDR(SSIB);            /*LINK SSIB TO SSOB   @G29AN2F*/
         ST    @10,SSOBSSIB                                     03S0446
*  END;                                /*                    @G29AN2F*/
*ELSE                                  /*NO NAME SPECIFIED   @G29AN2F*/
*  SSOBSSIB = SSOBSSIB && SSOBSSIB;    /*DEFAULT TO THE LIFE    03S0448
*                                        OF JOB SSIB         @G29AN2F*/
         B     @RC00440                                         03S0448
@RF00440 L     @10,SSOBSSIB                                     03S0448
         LR    @09,@10                                          03S0448
         XR    @09,@10                                          03S0448
         ST    @09,SSOBSSIB                                     03S0448
*                                                               02S0449
* /* ? IEFSSREQ  (SSOB);*/                                      02S0449
*/*                                           */                02S0449
*/*  PASS CONTROL TO JOB ENTRY SUBSYSTEM TO   */                02S0449
*/*  PROCESS REQUEST -                        */                02S0449
*/*                                           */                02S0449
*/*    INPUT - REGISTER 1 POINTS TO A ONE-    */                02S0449
*/*            WORD PARAMETER LIST WHICH      */                02S0449
*/*            POINTS TO THE SSOB             */                02S0449
*/*                                           */                02S0449
*CALL SSREQ(SSOB);                     /*INVOKE SUBSYSTEM            */
@RC00440 LA    @10,SSOB                                         02S0449
         ST    @10,@AL00001                                     02S0449
         MVI   @AL00001,X'80'                                   02S0449
         L     @10,CVTPTR                                       02S0449
         L     @10,CVTJESCT(,@10)                               02S0449
         L     @15,JESSSREQ(,@10)                               02S0449
         LA    @01,@AL00001                                     02S0449
         BALR  @14,@15                                          02S0449
*RETCODE = REG15;                      /*SAVE RETURN CODE            */
         LR    RETCODE,REG15                                    02S0450
*IF RETCODE = SSRTOK &                 /*FUNCTION RETURN CODE OK     */
*   SSOBRETN =SSALRTOK THEN            /*SSOB RETURN CODE OK         */
         SLR   @09,@09                                          02S0451
         CR    RETCODE,@09                                      02S0451
         BNE   @RF00451                                         02S0451
         C     @09,SSOBRETN                                     02S0451
         BNE   @RF00451                                         02S0451
*  DO;                                                          02S0452
*    SSDATAP = SSALSSCM;               /*SUBSYSTEM DATA      @G29AN2F*/
         L     SSDATAP,SSALSSCM                                 02S0453
*    SSNAMEP = SSALSSNM;               /*PTR TO SUBSYSTEM NM @G29AN2F*/
         L     SSNAMEP,SSALSSNM                                 02S0454
*    CALL BLDTIOT;                     /*BUILD TIOT & DSAB   @G29AN2F*/
         BAL   @14,BLDTIOT                                      02S0455
*  END;                                                         02S0456
*ELSE                                                           02S0457
*  DO;                                                          02S0457
         B     @RC00451                                         02S0457
@RF00451 DS    0H                                               02S0458
*    IF RETCODE = SSRTOK THEN          /*SSOB RTN CODE ^= ZERO       */
         LTR   RETCODE,RETCODE                                  02S0458
         BNZ   @RF00458                                         02S0458
*      DO;                                                      02S0459
*        IF SSOBRETN = SSALWTFL THEN   /*WAIT FAILED,NO WAIT    02S0460
*                                                      REQUESTED     */
         CLC   SSOBRETN(4),@CF00047                             02S0460
         BNE   @RF00460                                         02S0460
*           SIOTRSNC= NOWAITCD;       /*WAITING FOR UNITS NOT ALLOWED*/
         MVC   SIOTRSNC(2,SIOTPTR),@CH00102                     02S0461
*        ELSE                                                   02S0462
*          IF SSOBRETN = SSALCREQ THEN /*CANCEL REQUESTED            */
         B     @RC00460                                         02S0462
@RF00460 CLC   SSOBRETN(4),@CF00109                             02S0462
         BNE   @RF00462                                         02S0462
*            SSRSNC   = CANCELCD;      /*JOB CANCELED                */
         L     @10,@PC00001                                     02S0463
         L     @10,ALCWAPTR(,@10)                               02S0463
         L     @10,FAILRSCP(,@10)                               02S0463
         MVC   SSRSNC(2,@10),@CH00091                           02S0463
*          ELSE                                                 02S0464
*            IF SSOBRETN = SSALIDST THEN /*INVALID DESTINATION       */
         B     @RC00462                                         02S0464
@RF00462 CLC   SSOBRETN(4),@CF00959                             02S0464
         BNE   @RF00464                                         02S0464
*               SIOTRSNC = BADDEST;      /*BAD DESTINATION REQUESTED */
         MVC   SIOTRSNC(2,SIOTPTR),@CH00089                     02S0465
*            ELSE                                               02S0466
*              IF SSOBRETN = SSALNAUT THEN /*AUTHORIZER         02S0466
*                                            REQUESTOR OF SUBSYSTEM  */
         B     @RC00464                                         02S0466
@RF00464 CLC   SSOBRETN(4),@CF00071                             02S0466
         BNE   @RF00466                                         02S0466
*                SIOTRSNC = BADAUTH;   /*SET DD RELATED RSN CODE     */
         MVC   SIOTRSNC(2,SIOTPTR),@CH00087                     02S0467
*              ELSE                                             02S0468
*                SSRSNC = NOALLOC;     /*UNABLE TO ALLOC SUBSYSTEM
*                                        DATA SET.                   */
         B     @RC00466                                         02S0468
@RF00466 L     @10,@PC00001                                     02S0468
         L     @10,ALCWAPTR(,@10)                               02S0468
         L     @10,FAILRSCP(,@10)                               02S0468
         MVC   SSRSNC(2,@10),@CH00042                           02S0468
*      END;                                                     02S0469
*    ELSE                                                       02S0470
*      SSRSNC = NOALLOC;               /*UNABLE TO ALLOCATE SUB-
*                                           SYSTEM DATA SETS         */
         B     @RC00458                                         02S0470
@RF00458 L     @10,@PC00001                                     02S0470
         L     @10,ALCWAPTR(,@10)                               02S0470
         L     @10,FAILRSCP(,@10)                               02S0470
         MVC   SSRSNC(2,@10),@CH00042                           02S0470
*    RETCODE = ERROR;                  /*ERROR RETURN CODE           */
@RC00458 LA    RETCODE,4                                        02S0471
*  END;                                /*                    @G29AN2F*/
*RETURN;                               /*RETURN TO CALLER    @G29AN2F*/
@EL00002 DS    0H                                               02S0473
@EF00002 DS    0H                                               02S0473
@ER00002 LM    @14,@09,@SA00002                                 02S0473
         LM    @11,@12,@SA00002+48                              02S0473
         BR    @14                                              02S0473
*END ALOCNGRP;                         /*END NON GROUP REQUEST  02S0474
*                                        PROCESSING          @G29AN2F*/
         B     @EL00002                                         02S0474
*/********************************************************************/
*/*                                                          @G29AN2F*/
*/* SEGMENT NAME - BLDTIOT                                   @G29AN2F*/
*/*                                                          @G29AN2F*/
*/* DESCRIPTIVE NAME - BUILD DSAB & TIOT ENTRIES COMMON      @G29AN2F*/
*/*                    ROUTINE                               @G29AN2F*/
*/*                                                          @G29AN2F*/
*/* FUNCTION -                                               @G29AN2F*/
*/*   THE PURPOSE OF THIS ROUTINE IS TO BUILD A REQUEST      @G29AN2F*/
*/*   BLOCK FOR INPUT TO THE BUILD DSAB/TIOT ENTRY ROUTINE   @G29AN2F*/
*/*   IEFAB428, CALL IEFAB428 AND UPDATE THE DSAB, TIOT,     @G29AN2F*/
*/*   AND SIOT INDICATORS TO COMPLETE THE ALLOCATION AND TO  @G29AN2F*/
*/*   DECREMENT THE COMMON ALLOCATION COUNTERS.              @G29AN2F*/
*/*                                                          @G29AN2F*/
*/* ENTRY - BLDTIOT                                          @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*   PURPOSE - SEE FUNCTION                                 @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*   INPUT -                                                @G29AN2F*/
*/*     SIOTPTR - POINTER TO SIOT                            @G29AN2F*/
*/*                                                          @G29AN2F*/
*/* EXIT - RETURN                                            @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*  CONDITION - NO ERROR                                    @G29AN2F*/
*/*    OUTPUT -                                              @G29AN2F*/
*/*      DSAB CONSTRUCTED AND MARKED AS A SUBSYSTEM REQUEST  @G29AN2F*/
*/*      TIOT ENTRY MADE AND MARKED AS A SUBSYSTEM REQUEST   @G29AN2F*/
*/*      SIOT MARKED AS ALLOCATED                            @G29AN2F*/
*/*      COUNT FIELDS (TOTREQ AND SUBSREQS) IN ALCWA         @G29AN2F*/
*/*       DECREMENTED                                        @G29AN2F*/
*/*    RETURN CODE - ZERO                                    @G29AN2F*/
*/*                                                          @G29AN2F*/
*/*   CONDITION - ERROR                                      @G29AN2F*/
*/*     ERROR IN BUILDING DSAB/TIOT ENTRY                    @G29AN2F*/
*/*     OUTPUT -                                             @G29AN2F*/
*/*       STEP REASON CODE SET                               @G29AN2F*/
*/*       RETCODE SET                                        @G29AN2F*/
*/*                                                          @G29AN2F*/
*/********************************************************************/
*BLDTIOT: PROC;                        /*BUILD DSAB & TIOT   @G29AN2F*/
BLDTIOT  STM   @14,@09,@SA00003                                 02S0475
         STM   @11,@12,@SA00003+48                              02S0475
*EREQPTR=ADDR(EREQCORE);               /*BUILD REQUEST BLOCK         */
         LA    @10,EREQCORE                                     02S0476
         ST    @10,EREQPTR                                      02S0476
*ETIOTREQ =ETIOTREQ && ETIOTREQ;       /*ZERO OUT REQUEST BLOCK      */
         XC    ETIOTREQ(42,@10),ETIOTREQ(@10)                   02S0477
*EREQBLD  =ON;                         /*INDICATE BUILD FUNCTION     */
         OI    EREQBLD(@10),B'10000000'                         02S0478
*EREQDDNM =SCTDDNAM;                   /*PUT DDNAME IN RB            */
         MVC   EREQDDNM(8,@10),SCTDDNAM(SIOTPTR)                02S0479
*EREQDEVS =ONE;                        /*SET NO OF DEVICES TO ONE    */
         LA    @09,1                                            02S0480
         STH   @09,EREQDEVS(,@10)                               02S0480
*EREQRPOS =ONE;                        /*SET REL POS TO ONE          */
         STH   @09,EREQRPOS(,@10)                               02S0481
*EREQSIOT = SIOTPTR;                   /*POINT TO SIOT               */
         ST    SIOTPTR,EREQSIOT(,@10)                           02S0482
*EREQJSVA =SCTPJFCB;                   /*JFCB SWA VIRTUAL ADDRESS    */
         MVC   EREQJSVA(3,@10),SCTPJFCB(SIOTPTR)                02S0483
*EREQSSVA =SIOTDSKA;                   /*SIOT SWA VIRTUAL ADDRESS    */
         MVC   EREQSSVA(3,@10),SIOTDSKA(SIOTPTR)                02S0484
*EREQJSCB =JSCBPTR;                    /*JSCB PTR                    */
         L     @09,@PC00001                                     02S0485
         L     @09,ALCWAPTR(,@09)                               02S0485
         MVC   EREQJSCB(4,@10),JSCBPTR(@09)                     02S0485
*IF SIOTPASS = ON THEN                 /*DATA SET DISP = PASS?       */
         TM    SIOTPASS(SIOTPTR),B'00010000'                    02S0486
         BNO   @RF00486                                         02S0486
*  EREQPASS  =ON;                      /*SET BIT IN RB               */
         OI    EREQPASS(@10),B'00001000'                        02S0487
*IF SIOCLUNL = ON THEN                 /*SHOULD CLOSE UNALLOC THE
*                                        D.S ?                       */
@RF00486 TM    SIOCLUNL(SIOTPTR),B'10000000'                    02S0488
         BNO   @RF00488                                         02S0488
*  EREQUNAL = ON;                      /*YES, SET CORRESPONDING 02S0489
*                                        INDICATOR IN R.B            */
         L     @10,EREQPTR                                      02S0489
         OI    EREQUNAL(@10),B'00010000'                        02S0489
*CALL IEFAB428 (EREQPTR,JSCBPTR,EXITPRMP); /*CALL ETIOT         02S0490
*                                                      BUILD RTN     */
@RF00488 LA    @09,EREQPTR                                      02S0490
         ST    @09,@AL00001                                     02S0490
         L     @09,@PC00001                                     02S0490
         L     @09,ALCWAPTR(,@09)                               02S0490
         LA    @15,JSCBPTR(,@09)                                02S0490
         ST    @15,@AL00001+4                                   02S0490
         LA    @09,EXITPRMP(,@09)                               02S0490
         ST    @09,@AL00001+8                                   02S0490
         L     @15,@CV01429                                     02S0490
         LA    @01,@AL00001                                     02S0490
         BALR  @14,@15                                          02S0490
*RETCODE = REG15;                      /*SAVE RETURN CODE            */
         LR    RETCODE,REG15                                    02S0491
*IF RETCODE = ZERO THEN                /*WAS BUILD SUCCESSFUL?       */
         LTR   RETCODE,RETCODE                                  02S0492
         BNZ   @RF00492                                         02S0492
*  DO;                                 /*YES                         */
*    DSABPTR = SIOTETIO;               /*POINT TO DSAB               */
         L     DSABPTR,SIOTETIO(,SIOTPTR)                       02S0494
*    DSABSSCM = SSDATAP;               /*SET  FIELD          @G29AN2F*/
         ST    SSDATAP,DSABSSCM(,DSABPTR)                       02S0495
*    DSABSSNM = SSNAMEP->SSNM;         /*SET NAME FLD IN DSAB@G29AN2F*/
         MVC   DSABSSNM(4,DSABPTR),SSNM(SSNAMEP)                02S0496
*    TIOESSDS = ON;                    /*SET SUBSYS IN TIOT  @YM02438*/
         L     @09,DSABTIOT(,DSABPTR)                           02S0497
         OI    TIOESSDS(@09),B'00000010'                        02S0497
*    SIOTALCD = ON;                    /*MARK SIOT ALLOCATED         */
         OI    SIOTALCD(SIOTPTR),B'00000010'                    02S0498
*    SUBSREQS = SUBSREQS - ONE;        /*DECREMENT SUBSYS REQUESTS   */
         L     @09,@PC00001                                     02S0499
         L     @09,ALCWAPTR(,@09)                               02S0499
         L     @15,SUBSREQS(,@09)                               02S0499
         BCTR  @15,0                                            02S0499
         ST    @15,SUBSREQS(,@09)                               02S0499
*    TOTREQS  = TOTREQS - ONE;         /*DECREMENT TOTAL REQUESTS  */
         L     @15,TOTREQS(,@09)                                02S0500
         BCTR  @15,0                                            02S0500
         ST    @15,TOTREQS(,@09)                                02S0500
*  END;                                                         02S0501
*ELSE                                                           02S0502
*  SSRSNC = EREQCODE;                  /*SET FAIL REASON CODE       */
         B     @RC00492                                         02S0502
@RF00492 L     @09,@PC00001                                     02S0502
         L     @09,ALCWAPTR(,@09)                               02S0502
         L     @09,FAILRSCP(,@09)                               02S0502
         L     @01,EREQPTR                                      02S0502
         MVC   SSRSNC(2,@09),EREQCODE(@01)                      02S0502
*RETURN;                               /*RETURN TO CALLER    @G29AN2F*/
@EL00003 DS    0H                                               02S0503
@EF00003 DS    0H                                               02S0503
@ER00003 LM    @14,@09,@SA00003                                 02S0503
         LM    @11,@12,@SA00003+48                              02S0503
         BR    @14                                              02S0503
*END BLDTIOT;                          /*END PROC            @G29AN2F*/
         B     @EL00003                                         02S0504
*                                                               01S0505
*                                                               01S0505
*  DECLARE /*GENERAL PURPOSE REGISTERS */                       01S0505
*    GPR00F FIXED(31) REG(0),                                   01S0505
*    GPR01F FIXED(31) REG(1);                                   01S0505
*                                                               01S0505
*  DECLARE /* COMMON VARIABLES */                               01S0506
*    I256C CHAR(256) BASED,                                     01S0506
*    I031F FIXED(31) BASED,                                     01S0506
*    I031P PTR(31)   BASED,                                     01S0506
*    I015F FIXED(15) BASED,                                     01S0506
*    I015P PTR(15)   BASED,                                     01S0506
*    I008P PTR(8)    BASED,                                     01S0506
*    I001C CHAR(1)   BASED;                             /*      01S0506
*      @G29AN2F*/                                               01S0506
*END IEFAB427                                                   01S0507
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (A427SPEC)                                        *
*/*%INCLUDE SYSLIB  (A427DATA)                                        *
*/*%INCLUDE SYSLIB  (CVT     )                                        *
*/*%INCLUDE SYSLIB  (IEFASIOT)                                        *
*/*%INCLUDE SYSLIB  (IHADSAB )                                        *
*/*%INCLUDE SYSLIB  (IEFTIOT1)                                        *
*/*%INCLUDE SYSLIB  (IEFJSAST)                                        *
*/*%INCLUDE SYSLIB  (IEFJSSIB)                                        *
*/*%INCLUDE SYSLIB  (IEFJSSOB)                                        *
*/*%INCLUDE SYSLIB  (IEFSSARB)                                        *
*/*%INCLUDE SYSLIB  (IEFZB425)                                        *
*/*%INCLUDE SYSLIB  (IEFZB428)                                        *
*/*%INCLUDE SYSLIB  (IEFZB430)                                        *
*/*%INCLUDE SYSLIB  (IEFZB436)                                        *
*/*%INCLUDE SYSLIB  (IEFZB454)                                        *
*/*%INCLUDE SYSLIB  (IEFZB455)                                        *
*/*%INCLUDE SYSLIB  (IEFZB505)                                        *
*/*%INCLUDE SYSLIB  (IEFJESCT)                                        *
*/*%INCLUDE SYSLIB  (IHASUBIT)                                        *
*/*%INCLUDE SYSLIB  (BILDSSOB)                                        *
*/*%INCLUDE SYSLIB  (BSSOBSPC)                                        *
*/*%INCLUDE SYSLIB  (BLDTBLS )                                        *
*/*%INCLUDE SYSLIB  (BTBLSPEC)                                        *
*/*%INCLUDE SYSLIB  (BLDGPRB )                                        *
*/*%INCLUDE SYSLIB  (GPRBSPEC)                                        *
*/*%INCLUDE SYSLIB  (ALOCGPRQ)                                        *
*/*%INCLUDE SYSLIB  (GPRQSPEC)                                        *
*/*%INCLUDE SYSLIB  (GPRQERR )                                        *
*/*%INCLUDE SYSLIB  (GPERRSPC)                                        *
*/*%INCLUDE SYSLIB  (ALOCNGRP)                                        *
*/*%INCLUDE SYSLIB  (NGPSPEC )                                        *
*/*%INCLUDE SYSLIB  (BILDSSAL)                                        *
*/*%INCLUDE SYSLIB  (BSSALSPC)                                        *
*/*%INCLUDE SYSLIB  (BLDTIOT )                                        *
*/*%INCLUDE SYSLIB  (BLDTSPEC)                                        *
*;                                                              01S0507
@DATA    DS    0H
@CH00091 DC    H'5'
@CH01038 DC    H'6'
@CH00042 DC    H'15'
@CH01157 DC    H'20'
@CH00187 DC    H'24'
@CH00128 DC    H'28'
@CH01578 DC    H'36'
@CH01194 DC    H'39'
@CH00102 DC    H'59'
@CH01577 DC    H'60'
@CH01575 DC    H'64'
@CH00087 DC    H'78'
@CH00089 DC    H'79'
@CH01576 DC    H'124'
@CH00034 DC    H'230'
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    1F
@SA00002 DS    14F
@SA00003 DS    0F
         DS    14F
@AL00001 DS    7A
@TF00001 DS    F
@TF00002 DS    F
@TF00003 DS    F
IEFAB427 CSECT
         DS    0F
@CF00111 DC    F'0'
@CF00040 DC    F'1'
@CH00040 EQU   @CF00040+2
@CF00047 DC    F'4'
@CH00047 EQU   @CF00047+2
@CF00109 DC    F'8'
@CH00109 EQU   @CF00109+2
@CF00959 DC    F'12'
@CH00959 EQU   @CF00959+2
@CF00071 DC    F'16'
@CF01397 DC    F'120'
@CH01397 EQU   @CF01397+2
@CF01586 DC    F'-116'
@CF01587 DC    F'-114'
@CF01581 DC    F'-12'
@CF01583 DC    F'-8'
@CF01582 DC    F'-4'
@DATD    DSECT
         DS    0D
LCLSASTP DS    A
LCLSSCNT DS    F
MAXGPCT  DS    F
MSGBLKSZ DS    F
MSGIDX   DS    F
RBAREAP  DS    A
RBAREASZ DS    F
SMISVAID DS    FL4
         ORG   SMISVAID
SMISVA   DS    CL3
SMIID    DS    CL1
         ORG   SMISVAID+4
PSARBPTR DS    A
SSIBPTR  DS    A
SSMSGBKP DS    A
SSWAPTR  DS    A
TIOTPTR  DS    A
EREQPTR  DS    A
SWEPAPTR DS    A
GPMSGI   DS    H
SWACTLS  DS    FL2
         ORG   SWACTLS
SWASN    DS    BL1
SWDEL    EQU   SWACTLS+0
SWREAD   EQU   SWACTLS+0
SWWRT    EQU   SWACTLS+0
SWNEW    EQU   SWACTLS+0
SWFREE   EQU   SWACTLS+0
SWMOD    EQU   SWACTLS+0
SWOLD    EQU   SWACTLS+0
SWCHN    DS    BL1
@NM00057 EQU   SWACTLS+1
         ORG   SWACTLS+2
DSSNMSW  DS    BL1
SUBSYSNM DS    CL4
         DS    CL3
LCLSAST  DS    CL12
LSSIB    DS    CL36
SSOB     DS    CL20
         ORG   SSOB
SSOBID   DS    CL4
SSOBLEN  DS    FL2
SSOBFUNC DS    FL2
SSOBSSIB DS    AL4
SSOBRETN DS    AL4
SSOBINDV DS    AL4
         ORG   SSOB+20
SSAL     DS    CL64
         ORG   SSAL
SSALLEN  DS    FL2
SSALFLG1 DS    BL1
         ORG   SSALFLG1
SSALDELT DS    BL1
SSALHOLD EQU   SSALFLG1+0
SSALNHLD EQU   SSALFLG1+0
SSALWAIT EQU   SSALFLG1+0
SSALTRKM EQU   SSALFLG1+0
SSALSPIN EQU   SSALFLG1+0
SSALASNM EQU   SSALFLG1+0
SSALKEEP EQU   SSALFLG1+0
         ORG   SSAL+3
@NM00047 DS    AL1
SSALDDNM DS    AL4
SSALDEST DS    AL4
SSALDISP DS    AL4
SSALDUMY DS    AL4
SSALSOUT DS    AL4
SSALUNIT DS    AL4
SSALPGMN DS    AL4
SSALFORM DS    AL4
SSALCLAS DS    AL4
SSALADSP DS    AL4
SSALCOPY DS    AL4
SSALSSNM DS    AL4
SSALJFCB DS    AL4
SSALSSCM DS    AL4
SSALCNCL DS    AL4
         ORG   SSAL+64
SSAG     DS    CL28
         ORG   SSAG
SSAGEHDR DS    CL28
         ORG   SSAGEHDR
SSAGLEN  DS    FL2
SSAGFLGS DS    BL2
         ORG   SSAGFLGS
SSAGWAIT DS    BL1
SSAGSMSG EQU   SSAGFLGS+0
@NM00048 EQU   SSAGFLGS+0
         ORG   SSAGEHDR+4
SSAGGPEC DS    FL2
SSAGGPIC DS    FL2
SSAGARBP DS    AL4
SSAGCNCL DS    AL4
SSAGJBNM DS    AL4
SSAGGMLN DS    FL4
SSAGGMGP DS    AL4
         ORG   SSAG+28
LCLEPA   DS    CL16
EREQCORE DS    CL42
@OLDKEY  DS    AL1
IEFAB427 CSECT
         DS    0F
@SIZDATD DC    AL1(230)
         DC    AL3(@ENDDATD-@DATD)
@CV01428 DC    V(IEFAB4F7)
@CV01429 DC    V(IEFAB428)
         DS    0D
CNSTSSIB DC    CL4'SSIB'
CNSTSSOB DC    CL4'SSOB'
NOSSNM   DC    CL4'    '
REASCDE  DS    CL24
         ORG   REASCDE
@NM00001 DS    CL4
         ORG   @NM00001
@NM00002 DC    H'26'
@NM00003 DC    H'84'
         ORG   REASCDE+4
@NM00004 DS    CL4
         ORG   @NM00004
@NM00005 DC    H'27'
@NM00006 DC    H'85'
         ORG   REASCDE+8
@NM00007 DS    CL4
         ORG   @NM00007
@NM00008 DC    H'28'
@NM00009 DC    H'86'
         ORG   REASCDE+12
@NM00010 DS    CL4
         ORG   @NM00010
@NM00011 DC    H'29'
@NM00012 DC    H'87'
         ORG   REASCDE+16
@NM00013 DS    CL4
         ORG   @NM00013
@NM00014 DC    H'5'
@NM00015 DC    H'88'
         ORG   REASCDE+20
@NM00016 DS    CL4
         ORG   @NM00016
@NM00017 DC    H'30'
@NM00018 DC    H'89'
         ORG   REASCDE+24
SSYSIFEC DS    CL10
         ORG   SSYSIFEC
@NM00019 DC    H'90'
@NM00020 DC    H'91'
@NM00021 DC    H'92'
@NM00022 DC    H'93'
@NM00023 DC    H'93'
         ORG   SSYSIFEC+10
IEFAB427 CSECT
         DS   0H
A427PTCH DC ((@DATA-@PSTART)/20)X'00'
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEFAB427 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
SSNAMEP  EQU   @05
SSDATAP  EQU   @04
SSARBPTR EQU   @09
SIOTPTR  EQU   @08
DSABPTR  EQU   @02
RETCODE  EQU   @10
NUMSUBS  EQU   @03
I        EQU   @02
REG1     EQU   @01
REG2     EQU   @02
REG3     EQU   @03
REG4     EQU   @04
REG5     EQU   @05
REG15    EQU   @15
GPR01F   EQU   @01
GPR00F   EQU   @00
CVTPTR   EQU   16
LOFJSSNM EQU   0
RBAREA   EQU   0
SSNM     EQU   0
SSRSNC   EQU   0
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTJESCT EQU   CVTMAP+296
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
INDMSIOT EQU   0
SIOTDSKA EQU   INDMSIOT
SCTDDNAM EQU   INDMSIOT+4
SIOTDEST EQU   INDMSIOT+12
SCTUSADD EQU   INDMSIOT+20
SCTPJFCB EQU   INDMSIOT+32
SIOTBYT1 EQU   INDMSIOT+43
SIOTALCD EQU   SIOTBYT1
SCTDDINO EQU   INDMSIOT+44
SIOTBYT3 EQU   INDMSIOT+46
SIOTTSTC EQU   INDMSIOT+47
SIOTSSGP EQU   SIOTTSTC
SIOTSSMG EQU   SIOTTSTC
SIOTTRKM EQU   SIOTTSTC
SIOTDSNM EQU   SIOTTSTC
SIOTBYT0 EQU   INDMSIOT+52
SIOTSSDS EQU   SIOTBYT0
SCTSDISP EQU   INDMSIOT+55
SIOTPASS EQU   SCTSDISP
SCTSBYT1 EQU   INDMSIOT+56
SCTSBYT2 EQU   INDMSIOT+57
SIOCLUNL EQU   SCTSBYT2
SCTSBYT3 EQU   INDMSIOT+58
SCTSYSOU EQU   SCTSBYT3
SCTSBYT4 EQU   INDMSIOT+59
SCTUTYPE EQU   INDMSIOT+60
SIOTDEVT EQU   SCTUTYPE
SIOUBYT3 EQU   SIOTDEVT+2
SCTOUTNM EQU   INDMSIOT+68
SCTOUTNO EQU   INDMSIOT+76
SCTOUTPN EQU   INDMSIOT+80
SIOTBYT4 EQU   INDMSIOT+81
SIOTALTD EQU   INDMSIOT+92
SIOTSSWA EQU   INDMSIOT+93
SIOTOUTC EQU   INDMSIOT+96
SIOTBYT2 EQU   INDMSIOT+103
SIOTSSNM EQU   INDMSIOT+104
SIOTSSIC EQU   INDMSIOT+120
SIOTRSNC EQU   INDMSIOT+130
SIOTETIO EQU   INDMSIOT+148
SIOTNPTR EQU   INDMSIOT+152
SJFCBPTR EQU   INDMSIOT+156
DSAB     EQU   0
DSABTIOT EQU   DSAB+16
DSABGIDP EQU   DSAB+24
DSABANMP EQU   DSAB+28
DSABORG  EQU   DSAB+32
DSABORG1 EQU   DSABORG
DSABORG2 EQU   DSABORG+1
DSABFLG1 EQU   DSAB+34
DSABFLG2 EQU   DSAB+35
DSABFLG3 EQU   DSAB+36
DSABFLG4 EQU   DSAB+37
DSABSSNM EQU   DSAB+48
DSABSSCM EQU   DSAB+52
DSABANMI EQU   0
DSABGIDL EQU   0
TIOT1    EQU   0
TIOENTRY EQU   0
TIOESTTA EQU   TIOENTRY+1
TIOERLOC EQU   TIOENTRY+2
TIOELINK EQU   TIOERLOC+1
TIOESYOT EQU   TIOELINK
TIOESSDS EQU   TIOESYOT
TIOESTTC EQU   TIOENTRY+15
TIOESTTB EQU   TIOENTRY+16
POOLSTAR EQU   TIOENTRY+20
SASTTBLE EQU   0
SASTENRY EQU   SASTTBLE
SASTSSNM EQU   SASTENRY
SASTSPTR EQU   SASTENRY+4
SASTNORQ EQU   SASTENRY+8
SASTNOGP EQU   SASTENRY+10
JSAST    EQU   0
JSASTHDR EQU   JSAST
JSASTTBS EQU   JSASTHDR+4
JSASTTCT EQU   JSASTHDR+6
JSASTTBL EQU   JSAST+8
SSIB     EQU   0
SSIBID   EQU   SSIB
SSIBLEN  EQU   SSIB+4
SSIBFLG1 EQU   SSIB+6
SSIBSSNM EQU   SSIB+8
SSAGARBK EQU   0
SSAGRBLN EQU   SSAGARBK
SSAGRBEC EQU   SSAGARBK+4
SSAGRBIC EQU   SSAGARBK+6
SSAGDMLN EQU   SSAGARBK+8
SSAGNRBP EQU   SSAGARBK+12
SSAGDDNM EQU   SSAGARBK+16
SSAGDISP EQU   SSAGARBK+20
SSAGDUMY EQU   SSAGARBK+24
SSAGSOUT EQU   SSAGARBK+28
SSAGUNIT EQU   SSAGARBK+32
SSAGADSP EQU   SSAGARBK+36
SSAGSSNM EQU   SSAGARBK+40
SSAGJFCB EQU   SSAGARBK+44
SSAGSSWA EQU   SSAGARBK+48
SSAGSSCM EQU   SSAGARBK+52
SSAGDMGP EQU   SSAGARBK+56
SSAGDMBK EQU   0
SSAGGMBK EQU   0
SARBAREA EQU   0
SARBSPTR EQU   SARBAREA+60
ALCWA    EQU   0
FMAPPTR  EQU   ALCWA+4
SIOT1P   EQU   ALCWA+8
JSCBPTR  EQU   ALCWA+12
FAILRSCP EQU   ALCWA+20
CNTABLE  EQU   ALCWA+28
SUBSREQS EQU   CNTABLE+28
TOTREQS  EQU   CNTABLE+36
INDICATE EQU   ALCWA+112
@NM00051 EQU   ALCWA+113
TIOTHDRP EQU   ALCWA+120
CANCELP  EQU   ALCWA+140
EXITPRMP EQU   ALCWA+144
SSERBLKP EQU   ALCWA+160
LOJSSNMP EQU   ALCWA+164
NAMES    EQU   0
ALCJOBN  EQU   NAMES
FUNCMAP  EQU   0
VOLMNTSW EQU   FUNCMAP
WRTMSGSW EQU   FUNCMAP
UWAITSW  EQU   FUNCMAP
VWAITSW  EQU   FUNCMAP
MSSTRMSW EQU   FUNCMAP
OFFDEVSW EQU   FUNCMAP
CCLMNTSW EQU   FUNCMAP
GENLOKSW EQU   FUNCMAP
SSEMSGSW EQU   FUNCMAP+1
HDRMSGSW EQU   FUNCMAP+1
MTRJOBSW EQU   FUNCMAP+1
NOTIOTNQ EQU   FUNCMAP+1
TRKMSW   EQU   FUNCMAP+1
WAITOKSW EQU   FUNCMAP+1
ASNMSW   EQU   FUNCMAP+1
ETIOTREQ EQU   0
EREQMAP  EQU   ETIOTREQ
EREQBLD  EQU   EREQMAP
EREQSTAT EQU   ETIOTREQ+2
EREQUNAL EQU   EREQSTAT
EREQPASS EQU   EREQSTAT
EREQDDNM EQU   ETIOTREQ+4
EREQJSVA EQU   ETIOTREQ+12
EREQSSVA EQU   ETIOTREQ+16
EREQSIOT EQU   ETIOTREQ+20
EREQRPOS EQU   ETIOTREQ+28
EREQDEVS EQU   ETIOTREQ+30
EREQJSCB EQU   ETIOTREQ+36
EREQCODE EQU   ETIOTREQ+40
SSERRBLK EQU   0
SSEINCDE EQU   SSERRBLK
SSESMSGI EQU   SSERRBLK+2
SSEMBPTR EQU   SSERRBLK+4
SSMSGBLK EQU   0
SSMBKHDR EQU   SSMSGBLK
SSMBSUBP EQU   SSMBKHDR
SSMBADIM EQU   SSMBKHDR+2
SSMBKSZE EQU   SSMBKHDR+4
SSMBKARY EQU   SSMSGBLK+8
SSMBKELM EQU   SSMBKARY
SSMDDNUM EQU   SSMBKELM
SSMSGLEN EQU   SSMBKELM+2
SSMSGTXT EQU   SSMBKELM+4
SWAEPA   EQU   0
SWVAFW   EQU   SWAEPA+4
SWCHNPTR EQU   SWAEPA+12
JESCT    EQU   0
JESWAA   EQU   JESCT+8
JESSSREQ EQU   JESCT+20
JESALLOC EQU   JESCT+32
JESUNALC EQU   JESCT+36
JESCATL  EQU   JESCT+40
JESSASTA EQU   JESCT+48
SSREQ    EQU   0
SUBITS   EQU   0
SUBYTE1  EQU   SUBITS
SUBYTE2  EQU   SUBITS+1
SUBYTE3  EQU   SUBITS+2
SUBYTE4  EQU   SUBITS+3
SU29BIT  EQU   SUBYTE4
SUBYTE5  EQU   SUBITS+4
SUBYTE6  EQU   SUBITS+5
SUBYTE7  EQU   SUBITS+6
SUBYTE8  EQU   SUBITS+7
SUBYTE9  EQU   SUBITS+8
SUBYTE10 EQU   SUBITS+9
SUBYTE11 EQU   SUBITS+10
SUBYTE12 EQU   SUBITS+11
SUBYTE13 EQU   SUBITS+12
IEFAB4F5 EQU   0
IEFBB410 EQU   0
IEFW21SD EQU   0
I001C    EQU   0
I008P    EQU   0
I015F    EQU   0
I015P    EQU   0
I031F    EQU   0
I031P    EQU   0
I256C    EQU   0
SSCM     EQU   0
SWAMGR   EQU   0
ALCWAPTR EQU   0
RSNCODE  EQU   REASCDE
STEPCDE  EQU   RSNCODE
SIOTCDE  EQU   RSNCODE+2
SUBSIFEC EQU   SSYSIFEC
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
CVTIHASU EQU   CVTS01+696
TIOEDEVE EQU   TIOESTTB
TIOSTTB  EQU   TIOEDEVE
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
TIOUCBP  EQU   TIOEDEVE+1
TIOVERF  EQU   TIOSTTB
TIOUNLD  EQU   TIOSTTB
TIOMNTD  EQU   TIOSTTB
TIOSETU  EQU   TIOSTTB
TIOVLSR  EQU   TIOSTTB
TIOPVIO  EQU   TIOSTTB
TIOREQD  EQU   TIOSTTB
TIOUSED  EQU   TIOSTTB
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTHSM   EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
SURV104  EQU   SUBITS+13
SURV103  EQU   SUBYTE13
SURV102  EQU   SUBYTE13
SURV101  EQU   SUBYTE13
SU100BT  EQU   SUBYTE13
SU99BIT  EQU   SUBYTE13
SU98BIT  EQU   SUBYTE13
SU97BIT  EQU   SUBYTE13
SU96BIT  EQU   SUBYTE13
SU95BIT  EQU   SUBYTE12
SU94BIT  EQU   SUBYTE12
SU93BIT  EQU   SUBYTE12
SU92BIT  EQU   SUBYTE12
SU91BIT  EQU   SUBYTE12
SU90BIT  EQU   SUBYTE12
SU89BIT  EQU   SUBYTE12
SU88BIT  EQU   SUBYTE12
SU87BIT  EQU   SUBYTE11
SU86BIT  EQU   SUBYTE11
SU85BIT  EQU   SUBYTE11
SU84BIT  EQU   SUBYTE11
SU83BIT  EQU   SUBYTE11
SU82BIT  EQU   SUBYTE11
SU81BIT  EQU   SUBYTE11
SU80BIT  EQU   SUBYTE11
SU79BIT  EQU   SUBYTE10
SU78BIT  EQU   SUBYTE10
SU77BIT  EQU   SUBYTE10
SU76BIT  EQU   SUBYTE10
SU75BIT  EQU   SUBYTE10
SU74BIT  EQU   SUBYTE10
SU73BIT  EQU   SUBYTE10
SU72BIT  EQU   SUBYTE10
SU71BIT  EQU   SUBYTE9
SU70BIT  EQU   SUBYTE9
SU69BIT  EQU   SUBYTE9
SU68BIT  EQU   SUBYTE9
SU67BIT  EQU   SUBYTE9
SU66BIT  EQU   SUBYTE9
SU65BIT  EQU   SUBYTE9
SU64BIT  EQU   SUBYTE9
SU63BIT  EQU   SUBYTE8
SU62BIT  EQU   SUBYTE8
SU61BIT  EQU   SUBYTE8
SU60BIT  EQU   SUBYTE8
SU59BIT  EQU   SUBYTE8
SU58BIT  EQU   SUBYTE8
SU57BIT  EQU   SUBYTE8
SU56BIT  EQU   SUBYTE8
SU55BIT  EQU   SUBYTE7
SU54BIT  EQU   SUBYTE7
SU53BIT  EQU   SUBYTE7
SU52BIT  EQU   SUBYTE7
SU51BIT  EQU   SUBYTE7
SU50BIT  EQU   SUBYTE7
SU49BIT  EQU   SUBYTE7
SU48BIT  EQU   SUBYTE7
SU47BIT  EQU   SUBYTE6
SU46BIT  EQU   SUBYTE6
SU45BIT  EQU   SUBYTE6
SU44BIT  EQU   SUBYTE6
SU43BIT  EQU   SUBYTE6
SU42BIT  EQU   SUBYTE6
SU41BIT  EQU   SUBYTE6
SU40BIT  EQU   SUBYTE6
SU39BIT  EQU   SUBYTE5
SU38BIT  EQU   SUBYTE5
SU37BIT  EQU   SUBYTE5
SU36BIT  EQU   SUBYTE5
SU35BIT  EQU   SUBYTE5
SU34BIT  EQU   SUBYTE5
SU33BIT  EQU   SUBYTE5
SU32BIT  EQU   SUBYTE5
SU31BIT  EQU   SUBYTE4
SU30BIT  EQU   SUBYTE4
SU28BIT  EQU   SUBYTE4
SU27BIT  EQU   SUBYTE4
SU26BIT  EQU   SUBYTE4
SU25BIT  EQU   SUBYTE4
SU24BIT  EQU   SUBYTE4
SU23BIT  EQU   SUBYTE3
SU22BIT  EQU   SUBYTE3
SU21BIT  EQU   SUBYTE3
SU20BIT  EQU   SUBYTE3
SU19BIT  EQU   SUBYTE3
SU18BIT  EQU   SUBYTE3
SU17BIT  EQU   SUBYTE3
SU16BIT  EQU   SUBYTE3
SU15BIT  EQU   SUBYTE2
SU14BIT  EQU   SUBYTE2
SU13BIT  EQU   SUBYTE2
SU12BIT  EQU   SUBYTE2
SU11BIT  EQU   SUBYTE2
SU10BIT  EQU   SUBYTE2
SU9BIT   EQU   SUBYTE2
SU8BIT   EQU   SUBYTE2
SU7BIT   EQU   SUBYTE1
SU6BIT   EQU   SUBYTE1
SU5BIT   EQU   SUBYTE1
SU4BIT   EQU   SUBYTE1
SU3BIT   EQU   SUBYTE1
SU2BIT   EQU   SUBYTE1
SU1BIT   EQU   SUBYTE1
SU0BIT   EQU   SUBYTE1
JESNUCBS EQU   JESCT+44
JESPJESN EQU   JESCT+28
JESSSCT  EQU   JESCT+24
JESRESQM EQU   JESCT+16
JESQMGR  EQU   JESCT+12
JESUNITS EQU   JESCT+4
@NM00058 EQU   JESCT
SWLNGTH  EQU   SWAEPA+8
SWBLKID  EQU   SWVAFW+3
SWVA     EQU   SWVAFW
SWBLKPTR EQU   SWAEPA
EREQGRID EQU   ETIOTREQ+32
EREQUCB  EQU   ETIOTREQ+24
@NM00056 EQU   ETIOTREQ+19
@NM00055 EQU   ETIOTREQ+15
@NM00054 EQU   EREQSTAT
EREQCATL EQU   EREQSTAT
EREQJSCT EQU   EREQSTAT
EREQVAM  EQU   EREQSTAT
EREQQNM  EQU   EREQSTAT
EREQTERM EQU   EREQSTAT
@NM00053 EQU   EREQMAP
EREQMOVE EQU   EREQMAP
EREQUPD  EQU   EREQMAP
EXTRACAL EQU   FUNCMAP+1
ALCASDSN EQU   ASNMSW
ALCSUBWT EQU   WAITOKSW
ALCATRKM EQU   TRKMSW
ALCNOENQ EQU   NOTIOTNQ
ALCJOBNM EQU   MTRJOBSW
ALCHDMSG EQU   HDRMSGSW
ALCSSMSG EQU   SSEMSGSW
ALCGENER EQU   GENLOKSW
ALCCANCL EQU   CCLMNTSW
ALCOFFDV EQU   OFFDEVSW
ALCMSSTM EQU   MSSTRMSW
ALCWTVOL EQU   VWAITSW
ALCWTUNT EQU   UWAITSW
ALCMSGLV EQU   WRTMSGSW
ALCMOUNT EQU   VOLMNTSW
ALCPROCN EQU   NAMES+16
ALCSTEPN EQU   NAMES+8
GROUPSZ  EQU   ALCWA+156
GRIDPTR  EQU   ALCWA+152
ALCNUCBS EQU   ALCWA+148
WORK3MP  EQU   ALCWA+136
WMASK2P  EQU   ALCWA+132
WMASKPTR EQU   ALCWA+128
LGENLOCK EQU   ALCWA+124
TCBP     EQU   ALCWA+116
ALCWASID EQU   ALCWA+114
@NM00052 EQU   @NM00051
NODEVERR EQU   @NM00051
NEEDRCVY EQU   @NM00051
ALCWAREC EQU   @NM00051
WAITIGEN EQU   @NM00051
UNITRECS EQU   @NM00051
ALCWADUL EQU   INDICATE
ALCWISAM EQU   INDICATE
DSSUNIT  EQU   INDICATE
DSSTAPE  EQU   INDICATE
PRIVASUM EQU   INDICATE
INDREQU  EQU   INDICATE
INDRETRY EQU   INDICATE
INDWAIT  EQU   INDICATE
QMGRRBP  EQU   ALCWA+108
RIMTABCT EQU   ALCWA+104
RIMTABLN EQU   ALCWA+100
RIMTABP  EQU   ALCWA+96
ALGTABSZ EQU   ALCWA+92
ALGTABP  EQU   ALCWA+88
VOLUNSZE EQU   ALCWA+84
VOLUNPTR EQU   ALCWA+80
@NM00050 EQU   ALCWA+78
LTUNITID EQU   ALCWA+76
TOTVOLUN EQU   CNTABLE+44
NUMREQS  EQU   CNTABLE+40
OTHEREQS EQU   CNTABLE+32
STRGREQS EQU   CNTABLE+24
PUBLREQS EQU   CNTABLE+20
PVTNREQS EQU   CNTABLE+16
SPECREQS EQU   CNTABLE+12
TPREQS   EQU   CNTABLE+8
VAMREQS  EQU   CNTABLE+4
DMYREQS  EQU   CNTABLE
EDTABPTR EQU   ALCWA+24
IOSLUTP  EQU   ALCWA+16
WASIZE   EQU   ALCWA
SARBKLAR EQU   SARBAREA
SSAGGMSG EQU   SSAGGMBK+2
SSAGGMGL EQU   SSAGGMBK
SSAGDMSG EQU   SSAGDMBK+2
SSAGDMGL EQU   SSAGDMBK
@NM00049 EQU   SSAGARBK+10
SSAGRBFL EQU   SSAGARBK+2
SSIBSUSE EQU   SSIB+32
SSIBRSV1 EQU   SSIB+28
SSIBDEST EQU   SSIB+20
SSIBJBID EQU   SSIB+12
SSIBRESV EQU   SSIB+7
@NM00046 EQU   SSIBFLG1
SSIBPJES EQU   SSIBFLG1
JSASTID  EQU   JSASTHDR
TIOTFEND EQU   POOLSTAR+16
TIOPSLOT EQU   POOLSTAR+13
TIOPSTTB EQU   POOLSTAR+12
TIOPPOOL EQU   POOLSTAR+4
TIOPNSRT EQU   POOLSTAR+3
@NM00045 EQU   POOLSTAR+2
TIOPNSLT EQU   POOLSTAR+1
@NM00044 EQU   POOLSTAR
TIOEFSRT EQU   TIOENTRY+17
TIOSVERF EQU   TIOESTTB
TIOSUNLD EQU   TIOESTTB
TIOSMNTD EQU   TIOESTTB
TIOSSETU EQU   TIOESTTB
TIOSVLSR EQU   TIOESTTB
TIOSPVIO EQU   TIOESTTB
TIOSREQD EQU   TIOESTTB
TIOSUSED EQU   TIOESTTB
TIOSBALS EQU   TIOESTTC
TIOSBALP EQU   TIOESTTC
TIOSVOLS EQU   TIOESTTC
TIOSVOLP EQU   TIOESTTC
TIOSAFFS EQU   TIOESTTC
TIOSAFFP EQU   TIOESTTC
TIOSDEFR EQU   TIOESTTC
TIOSDKCR EQU   TIOESTTC
TIOEJFCB EQU   TIOENTRY+12
TIOEDDNM EQU   TIOENTRY+4
TIOTREM  EQU   TIOELINK
TIOESYIN EQU   TIOELINK
TIOEQNAM EQU   TIOELINK
TIOEDYNM EQU   TIOELINK
TIOTTERM EQU   TIOELINK
TIOTRV01 EQU   TIOELINK
TIOSYOUT EQU   TIOELINK
TIOEWTCT EQU   TIOERLOC
TIOSDSP2 EQU   TIOESTTA
TIOSDSP1 EQU   TIOESTTA
TIOSLABL EQU   TIOESTTA
TIOSDADS EQU   TIOESTTA
TIOSJBLB EQU   TIOESTTA
TIOSPLTS EQU   TIOESTTA
TIOSPLTP EQU   TIOESTTA
TIOSLTYP EQU   TIOESTTA
TIOELNGH EQU   TIOENTRY
TIOCSTEP EQU   TIOT1+8
TIOCNJOB EQU   TIOT1
DSABGRID EQU   DSABGIDL+4
DSABLLEN EQU   DSABGIDL
DSABANAM EQU   DSABANMI+1
DSABANML EQU   DSABANMI
DSABRS04 EQU   DSAB+68
DSABSIOT EQU   DSAB+64
DSABRS03 EQU   DSAB+62
DSABDCBM EQU   DSAB+56
DSABPTTR EQU   DSAB+44
DSABTCBP EQU   DSAB+40
DSABRS02 EQU   DSAB+38
@NM00043 EQU   DSABFLG4
DSABCKSI EQU   DSABFLG4
DSABCKVL EQU   DSABFLG4
DSABCKDS EQU   DSABFLG4
@NM00042 EQU   DSABFLG3
DSABJSCT EQU   DSABFLG3
DSABCATL EQU   DSABFLG3
DSABVMSC EQU   DSABFLG3
DSABVAM  EQU   DSABFLG3
DSABPASS EQU   DSABFLG3
DSABDEFR EQU   DSABFLG3
@NM00041 EQU   DSABFLG2
DSABUNAL EQU   DSABFLG2
DSABIRM  EQU   DSABFLG2
DSABOPEN EQU   DSABFLG2
DSABNUSE EQU   DSABFLG1
DSABCATM EQU   DSABFLG1
DSABPCAT EQU   DSABFLG1
DSABDCAT EQU   DSABFLG1
DSABCONV EQU   DSABFLG1
DSABDCNV EQU   DSABFLG1
DSABPALC EQU   DSABFLG1
DSABDALC EQU   DSABFLG1
@NM00040 EQU   DSABORG2
DSABTR   EQU   DSABORG2
DSABAM   EQU   DSABORG2
@NM00039 EQU   DSABORG2
DSABTQ   EQU   DSABORG2
DSABTX   EQU   DSABORG2
DSABGS   EQU   DSABORG2
DSABU    EQU   DSABORG1
DSABPO   EQU   DSABORG1
DSABMQ   EQU   DSABORG1
DSABCQ   EQU   DSABORG1
DSABCX   EQU   DSABORG1
DSABDA   EQU   DSABORG1
DSABPS   EQU   DSABORG1
DSABIS   EQU   DSABORG1
DSABSSVA EQU   DSAB+21
DSABRS01 EQU   DSAB+20
DSABOPCT EQU   DSAB+14
DSABLNTH EQU   DSAB+12
DSABBCHN EQU   DSAB+8
DSABFCHN EQU   DSAB+4
DSABID   EQU   DSAB
SIODDSNL EQU   INDMSIOT+173
SIOVDSNL EQU   INDMSIOT+172
SIOVDSNT EQU   INDMSIOT+170
SVOLUNNO EQU   INDMSIOT+168
SIOTVMVP EQU   INDMSIOT+164
SIOTJFX  EQU   INDMSIOT+160
SIOTATE  EQU   INDMSIOT+144
SVOLUNAD EQU   INDMSIOT+140
SIOTEDLP EQU   INDMSIOT+136
SIOTEDLS EQU   INDMSIOT+132
SCTANAME EQU   INDMSIOT+122
@NM00038 EQU   INDMSIOT+108
@NM00037 EQU   SIOTBYT2
SIOTCVOL EQU   SIOTBYT2
SIOTCNEW EQU   SIOTBYT2
SIOTCALC EQU   SIOTBYT2
SIOTGALL EQU   SIOTBYT2
SIOTDSPD EQU   SIOTBYT2
SIOTDMND EQU   SIOTBYT2
SIOTOPUC EQU   INDMSIOT+99
SIOTOUTR EQU   INDMSIOT+97
SIOTAUNC EQU   SIOTALTD
SIOTACAT EQU   SIOTALTD
SIOTADEL EQU   SIOTALTD
SIOTAKEP EQU   SIOTALTD
SIOTNPRV EQU   SIOTALTD
SIOJCATS EQU   SIOTALTD
@NM00036 EQU   SIOTALTD
@NM00035 EQU   SIOTALTD
@NM00034 EQU   INDMSIOT+91
SIOTNDSB EQU   INDMSIOT+88
@NM00033 EQU   INDMSIOT+84
SIOTDPCD EQU   INDMSIOT+82
@NM00032 EQU   SIOTBYT4
SIOTRACT EQU   SIOTBYT4
SIOTRACD EQU   SIOTBYT4
SIOTPROT EQU   SIOTBYT4
SIOUCBAD EQU   SCTUTYPE+5
SIOUCNVT EQU   SCTUTYPE+4
SIOUBYT4 EQU   SIOTDEVT+3
@NM00031 EQU   SIOUBYT3
SIO3UREC EQU   SIOUBYT3
SIO3DISP EQU   SIOUBYT3
SIO3DACC EQU   SIOUBYT3
SIO3COMM EQU   SIOUBYT3
SIO3TAPE EQU   SIOUBYT3
SIOUBYT2 EQU   SIOTDEVT+1
SIOUBYT1 EQU   SIOTDEVT
SIOTOMN  EQU   SCTSBYT4
SIOTIPDI EQU   SCTSBYT4
SIOTVAFF EQU   SCTSBYT4
SIOTSTEP EQU   SCTSBYT4
SIOTASCI EQU   SCTSBYT4
@NM00030 EQU   SCTSBYT4
SIOTGDGA EQU   SCTSBYT4
SCTSGDGS EQU   SCTSBYT4
SCTSOLD  EQU   SCTSBYT3
SCTSMOD  EQU   SCTSBYT3
SCTSNEW  EQU   SCTSBYT3
SCTVREF  EQU   SCTSBYT3
SCTALCHK EQU   SCTSBYT3
SCTSYSNE EQU   SCTSBYT3
SCTDSNRF EQU   SCTSBYT3
SCTRECVD EQU   SCTSBYT2
SCTDEFER EQU   SCTSBYT2
SCTLABEL EQU   SCTSBYT2
SCTUNLBD EQU   SCTSBYT2
SCTJOBLB EQU   SCTSBYT2
SCTVOLAF EQU   SCTSBYT2
SIOTCATL EQU   SCTSBYT2
SIOTJSCT EQU   SCTSBYT1
SCTUNAFF EQU   SCTSBYT1
SCTPARLM EQU   SCTSBYT1
SIOTQDSN EQU   SCTSBYT1
SIOTGDSN EQU   SCTSBYT1
SIOTCCAT EQU   SCTSBYT1
SCTSYSIN EQU   SCTSBYT1
SCTDUMMY EQU   SCTSBYT1
SIOTUNCT EQU   SCTSDISP
SIOTCTLG EQU   SCTSDISP
SIOTDLET EQU   SCTSDISP
SIOTKEEP EQU   SCTSDISP
SIOTPRIV EQU   SCTSDISP
S3400DSP EQU   SCTSDISP
SIOTRETN EQU   SCTSDISP
SIOTVLCT EQU   INDMSIOT+54
SCTNMBUT EQU   INDMSIOT+53
SIOTRTRY EQU   SIOTBYT0
SIOTPUPV EQU   SIOTBYT0
SIOTNOPV EQU   SIOTBYT0
SIOTGIGN EQU   SIOTBYT0
SPVTAMSG EQU   SIOTBYT0
SIOTFUDA EQU   SIOTBYT0
SIOTDYAL EQU   SIOTBYT0
SIOTGIID EQU   INDMSIOT+50
SCTVOLCT EQU   INDMSIOT+49
SCTSPOOL EQU   INDMSIOT+48
SIOTQNAM EQU   SIOTTSTC
@NM00029 EQU   SIOTTSTC
SIOTTERM EQU   SIOTTSTC
SIOTINFC EQU   SIOTTSTC
@NM00028 EQU   SIOTBYT3
SIOTDSID EQU   SIOTBYT3
S3400OFF EQU   SIOTBYT3
SIOTJES3 EQU   SIOTBYT3
SIOCDEVT EQU   SIOTBYT3
SIOALIAS EQU   SIOTBYT3
SIOTDDNT EQU   SIOTBYT1
SIODADSM EQU   SIOTBYT1
SIOTDADR EQU   SIOTBYT1
SIODUNAL EQU   SIOTBYT1
SIOVAMDS EQU   SIOTBYT1
SIOTHOLD EQU   SIOTBYT1
SIOTOCKP EQU   SIOTBYT1
SIOPSCNT EQU   INDMSIOT+42
SIOTREFN EQU   INDMSIOT+40
SIOTOTUN EQU   INDMSIOT+39
SIOTVRSB EQU   INDMSIOT+36
@NM00027 EQU   INDMSIOT+35
@NM00026 EQU   INDMSIOT+31
SCTPSIOT EQU   INDMSIOT+28
SIOTAFID EQU   INDMSIOT+26
SIOTVLSP EQU   INDMSIOT+24
SIODSNTE EQU   INDMSIOT+22
SIOTUNAF EQU   SCTUSADD
SIOTTYPE EQU   INDMSIOT+3
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00025 EQU   CVTFIX+248
@NM00024 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTCCVT  EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00236 EQU   @RC00234
@RF00281 EQU   @RC00226
@RC00310 EQU   @RC00226
@RC00324 EQU   @RC00226
@RF00378 EQU   @RC00223
@RF00390 EQU   @RC00223
@RC00466 EQU   @RC00458
@RC00464 EQU   @RC00458
@RC00462 EQU   @RC00458
@RC00460 EQU   @RC00458
@RC00451 EQU   @EL00002
@RC00492 EQU   @EL00003
@ENDDATA EQU   *
         END   IEFAB427,(C'PLS0940',0701,78108)
