         TITLE 'IEFAB434 - ALLOCATE REQUEST TO UNIT                    *
                        '
IEFAB434 CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(24)                                          01S0001
         DC    C'IEFAB434 77087  UZ08782 '                      01S0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01S0001
         BALR  @10,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@10                                      01S0001
         L     @00,@SIZDATD                                     01S0001
         GSPACE   R,LV=(0)
         LR    @09,@01                                          01S0001
         USING @DATD,@09                                        01S0001
         ST    @13,@SA00001+4                                   01S0001
         LM    @00,@01,20(@13)                                  01S0001
         ST    @09,8(,@13)                                      01S0001
         LR    @13,@09                                          01S0001
         MVC   @PC00001(32),0(@01)                              01S0001
*ERRWORD = ZERO;                       /*INIT LOCAL RETURN CODE FIELD*/
         SLR   ERRWORD,ERRWORD                                  01S0079
*RETCODE = ZERO;                       /*CLEAR 4F2 RETURN CODE       */
         SLR   @12,@12                                          01S0080
         ST    @12,RETCODE                                      01S0080
*/********************************************************************/
*/*                                                          @G32HPPJ*/
*/*  SEGMENT NAME - PROTTEST                                 @G32HPPJ*/
*/*                                                          @G32HPPJ*/
*/*  DESCRIPTIVE NAME - RACF PROTECT VALIDITY TEST           @G32HPPJ*/
*/*                                                          @G32HPPJ*/
*/*  FUNCTION -                                              @G32HPPJ*/
*/*    THIS ROUTINE WILL DETERMINE IF THE RACF PROTECT SWITCH@G32HPPJ*/
*/*    SHOULD BE SET IN THE JFCB(JFCBPROT).                  @G32HPPJ*/
*/*                                                          @G32HPPJ*/
*/*  ENTRY - INLINE SEGMENT OF IEFAB434.                     @G32HPPJ*/
*/*    PURPOSE - SEE FUNCTION.                               @G32HPPJ*/
*/*                                                          @G32HPPJ*/
*/*    INPUT - UCBPTR - POINTER TO THE UCB CHOSEN TO SATISFY @G32HPPJ*/
*/*                     THIS REQUEST                         @G32HPPJ*/
*/*            SIOTPTR - POINTER TO THE SIOT BEING ALLOCATED @G32HPPJ*/
*/*            CVTPTR - CVT IS USED TO LOCATE THE RACF CVT   @G32HPPJ*/
*/*            RACF CVT - USED TO DETERMINE IF RACF IS ACTIVE@G32HPPJ*/
*/*            IHASUBIT - CHECKED TO SEE IF SU32 INSTALLED   @G32HPPJ*/
*/*                                                          @G32HPPJ*/
*/*   EXITS -                                                @G32HPPJ*/
*/*     CONDITION - PROTECT VALID FOR REQUEST JOB ALLOCATED  @G32HPPJ*/
*/*                                                          @G32HPPJ*/
*/*      OUTPUT - JFCBPROT SET IN JFCB FOR THIS REQUEST      @G32HPPJ*/
*/*                                                          @G32HPPJ*/
*/*      RETURN CODE - ERRWORD = ZERO                        @G32HPPJ*/
*/*                                                          @G32HPPJ*/
*/*      CONDITION - PROTECT NOT VALID FOR FOR THIS REQUEST  @G32HPPJ*/
*/*                                                          @G32HPPJ*/
*/*      OUTPUT - SIOT REASON CODE SET TO DENOTE CAUSE OF    @G32HPPJ*/
*/*              FAILURE                                     @G32HPPJ*/
*/*             RC=95 RACF NOT ACTIVE                        @G32HPPJ*/
*/*             RC=96 PROTECT NOT VALID BECAUSE OF KEYWORD   @G32HPPJ*/
*/*                   CONFLICTS                              @G32HPPJ*/
*/*      RETURN CODE - ERRWORD = FOUR                        @G32HPPJ*/
*/*                                                          @G32HPPJ*/
*/********************************************************************/
*IF SIOTPROT = ON THEN                 /*WAS RACF PROTECT    @G32HPPJ*/
         L     @11,@PC00001                                     02S0081
         L     @11,SIOTPTR(,@11)                                02S0081
         TM    SIOTPROT(@11),B'10000000'                        02S0081
         BNO   @RF00081                                         02S0081
*  DO;                                 /*REQUESTED, YES      @G32HPPJ*/
*    IF CVTRAC ^= ZERO &               /*VALID ONLY IF RACF  @G32HPPJ*/
*       RCVTROFF = OFF &               /*PROGRAM PRODUCT     @G32HPPJ*/
*       RCVTRNA = OFF THEN             /*IS ACTIVE           @G32HPPJ*/
         L     @08,CVTPTR                                       02S0083
         L     @08,CVTRAC(,@08)                                 02S0083
         CR    @08,@12                                          02S0083
         BE    @RF00083                                         02S0083
         TM    RCVTROFF(@08),B'10000000'                        02S0083
         BNZ   @RF00083                                         02S0083
         TM    RCVTRNA(@08),B'10000000'                         02S0083
         BNZ   @RF00083                                         02S0083
*      DO;                                                      02S0084
*        IF (SIOTRACD = ON &           /*REQUEST SATISFIED      02S0085
*                                        TESTS FOR DA        @G32HPPJ*/
*           UCB3DACC = ON) THEN        /*AND A DA DEVICE WAS    02S0085
*                                        ALLOCATED           @G32HPPJ*/
         TM    SIOTRACD(@11),B'01000000'                        02S0085
         BNO   @RF00085                                         02S0085
         L     @12,@PC00001+8                                   02S0085
         L     @12,UCBPTR(,@12)                                 02S0085
         TM    UCB3DACC(@12),B'00100000'                        02S0085
         BNO   @RF00085                                         02S0085
*             SJFCBPTR->JFCBADSP = ON; /*NOTIFY DADSM OF PROTECT
*                                                            @G32HPPJ*/
         L     @12,SJFCBPTR(,@11)                               02S0086
         OI    JFCBADSP(@12),B'00100000'                        02S0086
*        ELSE                                                   02S0087
*          IF (SIOTRACT = ON &         /*OR REQUEST SATISFIED   02S0087
*                                        TAPE TESTS          @G32HPPJ*/
*             UCB3TAPE = ON) THEN      /*AND WAS ALLOCATED      02S0087
*                                        TO A TAPE DEVICE    @G32HPPJ*/
         B     @RC00085                                         02S0087
@RF00085 L     @12,@PC00001                                     02S0087
         L     @12,SIOTPTR(,@12)                                02S0087
         TM    SIOTRACT(@12),B'00100000'                        02S0087
         BNO   @RF00087                                         02S0087
         L     @11,@PC00001+8                                   02S0087
         L     @11,UCBPTR(,@11)                                 02S0087
         TM    UCB3TAPE(@11),B'10000000'                        02S0087
         BNO   @RF00087                                         02S0087
*            SJFCBPTR->JFCBPROT = ON;  /*INDICATE TO OPEN THAT  02S0088
*                                        RACF PROTECT IS TO BE  02S0088
*                                        DONE                @G32HPPJ*/
         L     @12,SJFCBPTR(,@12)                               02S0088
         OI    JFCBPROT(@12),B'00010000'                        02S0088
*          ELSE                        /*                    @G32HPPJ*/
*            SIOTRSNC = PROTFAIL;      /*PROTECT FAILED FOR TAPE
*                                                            @G32HPPJ*/
         B     @RC00087                                         02S0089
@RF00087 L     @12,@PC00001                                     02S0089
         L     @12,SIOTPTR(,@12)                                02S0089
         MVC   SIOTRSNC(2,@12),@CH00135                         02S0089
*       IF SIOTRSNC = PROTFAIL THEN    /*SET RETURN CODE     @G32HPPJ*/
@RC00087 DS    0H                                               02S0090
@RC00085 L     @12,@PC00001                                     02S0090
         L     @12,SIOTPTR(,@12)                                02S0090
         CLC   SIOTRSNC(2,@12),@CH00135                         02S0090
         BNE   @RF00090                                         02S0090
*          ERRWORD = FOUR;             /*SIGNIFY JOB SHOULD     02S0091
*                                        FAIL                @G32HPPJ*/
         LA    ERRWORD,4                                        02S0091
*       ELSE;                                                   02S0092
@RF00090 DS    0H                                               02S0093
*     END;                                                      02S0093
*   ELSE                              /*RACF NOT INSTALLED   @G32HPPJ*/
*     DO;                             /*OR NOT ACTIVE        @G32HPPJ*/
         B     @RC00083                                         02S0094
@RF00083 DS    0H                                               02S0095
*       SIOTRSNC = RACFNACT;          /*SET RACF NOT ACTIVE  @G32HPPJ*/
         L     @12,@PC00001                                     02S0095
         L     @12,SIOTPTR(,@12)                                02S0095
         MVC   SIOTRSNC(2,@12),@CH00137                         02S0095
*       ERRWORD = FOUR;               /*SET FAIL RETCODE     @G32HPPJ*/
         LA    ERRWORD,4                                        02S0096
*     END;                                                      02S0097
*  END;                                                         02S0098
*ELSE;                                /*PROTECT NOT SPECIFIED@G32HPPJ*/
@RF00081 DS    0H                                               02S0100
*IF ERRWORD = ZERO THEN                /*CHECK FOR PROTECT FAILURE
*                                                            @G32HPPJ*/
@RC00081 LTR   ERRWORD,ERRWORD                                  01S0100
         BNZ   @RF00100                                         01S0100
*  DO;                                                          01S0101
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - BETIOREQ                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - BUILD ETIOT REQUEST BLOCK                     */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE CREATES THE REQUEST BLOCK NECESSARY FOR THE       */
*/*   ETIOT BUILD ROUTINE. THEN IT CALLS IEFAB428 TO BUILD THE       */
*/*   ENTRY                                                  @G32HPPJ*/
*/*                                                                  */
*/* ENTRY POINT - INLINE SEGMENT OF IEFAB434                         */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*     ETIOFLAG - INDICATES IF ETIOT IS TO BE BUILT OR UPDATED      */
*/*     RELDEVNO - RELATIVE POSITION OF THIS DEVICE ENTRY            */
*/*     NUMDEVS  - TOTAL NUMBER OF DEVICES FOR THIS ETIOT ENTRY      */
*/*     SCTDDNAM - DDNAME OF REQUEST                                 */
*/*     UCBPTR   - PTR TO UCB ALLOCATED TO THIS REQUEST              */
*/*     SIOTPTR  - PTR TO SIOT FOR THIS REQUEST                      */
*/*     GROUPID  - GROUP IDENTIFIER FROM EDL                         */
*/*     JSCBPTR  - PTR TO JSCB FOR THIS REQUEST                      */
*/*     SIOTDSKA - SIOT SVA                                          */
*/*     SCTPJFCB - JFCB SVA                                          */
*/*                                                                  */
*/* EXITS -                                                          */
*/*   CONDITION - ETIOREQ BLOCK BUILT                                */
*/*                                                                  */
*/*     OUTPUT - ETIOREQ BLOCK INITIALIZED                           */
*/*                                                                  */
*/*     RETURN CODE - NONE                                           */
*/*                                                                  */
*/********************************************************************/
*IF RELDEVNO = ONE                     /*DUAL AS FIRST DEV ENTRY?    */
*  & SIOTOTUN > ONE                                             02S0102
*  & UCB3TAPE = ON                                              02S0102
*  & (UCB2OPT2 = ON                                             02S0102
*  | UCB2OPT3 = ON) THEN                                        02S0102
         L     @12,@PC00001+16                                  02S0102
         CLC   RELDEVNO(2,@12),@CH00057                         02S0102
         BNE   @RF00102                                         02S0102
         L     @12,@PC00001                                     02S0102
         L     @12,SIOTPTR(,@12)                                02S0102
         CLI   SIOTOTUN(@12),1                                  02S0102
         BNH   @RF00102                                         02S0102
         L     @12,@PC00001+8                                   02S0102
         L     @12,UCBPTR(,@12)                                 02S0102
         TM    UCB3TAPE(@12),B'10000000'                        02S0102
         BNO   @RF00102                                         02S0102
         TM    UCB2OPT2(@12),B'00110000'                        02S0102
         BZ    @RF00102                                         02S0102
*    ALCWADUL = ON;                    /*YES, INDICATE               */
         L     @12,@PC00001+20                                  02S0103
         L     @12,ALCWAPTR(,@12)                               02S0103
         OI    ALCWADUL(@12),B'00000001'                        02S0103
*ELSE;                                 /*FIRST TAPE ENTRY NOT DUAL   */
@RF00102 DS    0H                                               02S0105
*EREQPTR = ADDR(ETIOTBLK);             /*SET POINTER TO ETIOT REQUEST
*                                        BLOCK                       */
         LA    @12,ETIOTBLK                                     02S0105
         ST    @12,EREQPTR                                      02S0105
*ETIOTBLK = ETIOTBLK && ETIOTBLK;      /*CLEAR THE REQUEST BLOCK     */
         XC    ETIOTBLK(42),ETIOTBLK                            02S0106
*IF SIOTCCAT = ON THEN                 /*IF SIOT IS FOR CONCAT DD    */
         L     @11,@PC00001                                     02S0107
         L     @11,SIOTPTR(,@11)                                02S0107
         TM    SIOTCCAT(@11),B'00100000'                        02S0107
         BNO   @RF00107                                         02S0107
*  EREQDDNM = BLANKS;                  /*THEN DDNAME FIELD IS BLANKS */
         MVC   EREQDDNM(8,@12),BLANKS                           02S0108
*ELSE                                                           02S0109
*  EREQDDNM = SCTDDNAM;                /*SET DDNAME                  */
         B     @RC00107                                         02S0109
@RF00107 L     @12,EREQPTR                                      02S0109
         L     @11,@PC00001                                     02S0109
         L     @11,SIOTPTR(,@11)                                02S0109
         MVC   EREQDDNM(8,@12),SCTDDNAM(@11)                    02S0109
*EREQRPOS = RELDEVNO;                  /*SET RELATIVE DEVICE POSITION*/
@RC00107 L     @12,EREQPTR                                      02S0110
         L     @11,@PC00001+16                                  02S0110
         MVC   EREQRPOS(2,@12),RELDEVNO(@11)                    02S0110
*EREQDEVS = NUMDEVS;                   /*SET NUMBER DEVICE ENTRIES   */
         MVC   EREQDEVS(2,@12),NUMDEVS(@11)                     02S0111
*IF SIOCLUNL = ON THEN                 /*SET UNALLOC AT CLOSE IF
*                                        RELEASE=CLOSE SPECIFIED     */
         L     @11,@PC00001                                     02S0112
         L     @11,SIOTPTR(,@11)                                02S0112
         TM    SIOCLUNL(@11),B'10000000'                        02S0112
         BNO   @RF00112                                         02S0112
*  EREQUNAL = ON;                                               02S0113
         OI    EREQUNAL(@12),B'00010000'                        02S0113
*IF ETIOFLAG = ON THEN                 /*DOES ETIOT ENTRY EXIST?     */
@RF00112 L     @12,@PC00001+12                                  02S0114
         TM    ETIOFLAG(@12),B'10000000'                        02S0114
         BNO   @RF00114                                         02S0114
*  EREQUPD = ON;                       /*YES THEN JUST UPDATE IT     */
         L     @12,EREQPTR                                      02S0115
         OI    EREQUPD(@12),B'01000000'                         02S0115
*ELSE                                                           02S0116
*  EREQBLD = ON;                       /*SET IND. TO CREATE ETIOT ENT*/
         B     @RC00114                                         02S0116
@RF00114 L     @12,EREQPTR                                      02S0116
         OI    EREQBLD(@12),B'10000000'                         02S0116
*EREQSIOT = SIOTPTR;                   /*SET PTR TO SIOT             */
@RC00114 L     @12,EREQPTR                                      02S0117
         L     @11,@PC00001                                     02S0117
         L     @11,SIOTPTR(,@11)                                02S0117
         ST    @11,EREQSIOT(,@12)                               02S0117
*EREQUCB = UCBPTR;                     /*SET PTR TO UCB ALLOC'D      */
         L     @08,@PC00001+8                                   02S0118
         L     @08,UCBPTR(,@08)                                 02S0118
         ST    @08,EREQUCB(,@12)                                02S0118
*EREQGRID = GROUPID;                   /*SET GROUPID OF UCB ALLOC'D  */
         L     @15,@PC00001+24                                  02S0119
         MVC   EREQGRID(4,@12),GROUPID(@15)                     02S0119
*EREQJSCB = JSCBPTR;                   /*SET PTR TO JFCB             */
         L     @15,@PC00001+20                                  02S0120
         L     @01,ALCWAPTR(,@15)                               02S0120
         MVC   EREQJSCB(4,@12),JSCBPTR(@01)                     02S0120
*EREQSSVA = SIOTDSKA;                  /*SET SIOT SVA                */
         MVC   EREQSSVA(3,@12),SIOTDSKA(@11)                    02S0121
*EREQJSVA = SCTPJFCB;                  /*SET JFCB SVA                */
         MVC   EREQJSVA(3,@12),SCTPJFCB(@11)                    02S0122
*IF SIOTPASS = ON |                    /* PASSED DATA SET    @ZD03010*/
*   (SIOTRETN = ON &                   /* VOL=RETAIN         @ZD03010*/
*    UCB3TAPE = ON) THEN               /* TAPE               @ZD03010*/
         TM    SIOTPASS(@11),B'00010000'                        02S0123
         BO    @RT00123                                         02S0123
         TM    SIOTRETN(@11),B'10000000'                        02S0123
         BNO   @RF00123                                         02S0123
         TM    UCB3TAPE(@08),B'10000000'                        02S0123
         BNO   @RF00123                                         02S0123
@RT00123 DS    0H                                               02S0124
*  EREQPASS = ON;                      /*REQ BLK PASS/RETAIN BIT
*                                                            @ZD03010*/
         L     @12,EREQPTR                                      02S0124
         OI    EREQPASS(@12),B'00001000'                        02S0124
*ELSE;                                                          02S0125
@RF00123 DS    0H                                               02S0126
*IF SIOTJSCT = ON THEN                 /*JOBCAT OR STEPCAT ?         */
         L     @12,@PC00001                                     02S0126
         L     @12,SIOTPTR(,@12)                                02S0126
         TM    SIOTJSCT(@12),B'00000001'                        02S0126
         BNO   @RF00126                                         02S0126
*  EREQJSCT = ON;                      /*SET REQ BLK FIELD           */
         L     @12,EREQPTR                                      02S0127
         OI    EREQJSCT(@12),B'00000100'                        02S0127
*ELSE;                                                          02S0128
@RF00126 DS    0H                                               02S0129
*IF SIOTCATL = ON THEN                 /*IS DATA SET A CATALOG       */
         L     @12,@PC00001                                     02S0129
         L     @12,SIOTPTR(,@12)                                02S0129
         TM    SIOTCATL(@12),B'01000000'                        02S0129
         BNO   @RF00129                                         02S0129
*  EREQCATL = ON;                      /*SET REQ BLK FIELD           */
         L     @12,EREQPTR                                      02S0130
         OI    EREQCATL(@12),B'00000010'                        02S0130
*ELSE;                                                          02S0131
@RF00129 DS    0H                                               02S0132
*CALL IEFAB428(EREQPTR,JSCBPTR,EXITPRMP);/*BUILD ETIOT ENTRY @G32HPPJ*/
         LA    @12,EREQPTR                                      02S0132
         ST    @12,@AL00001                                     02S0132
         L     @12,@PC00001+20                                  02S0132
         L     @12,ALCWAPTR(,@12)                               02S0132
         LA    @11,JSCBPTR(,@12)                                02S0132
         ST    @11,@AL00001+4                                   02S0132
         LA    @12,EXITPRMP(,@12)                               02S0132
         ST    @12,@AL00001+8                                   02S0132
         L     @15,@CV00086                                     02S0132
         LA    @01,@AL00001                                     02S0132
         BALR  @14,@15                                          02S0132
*ERRWORD = REG15;                        /*SAVE RETURN CODE  @G32HPPJ*/
         LR    ERRWORD,REG15                                    02S0133
*FAILRSCP->FAILCODE = EREQCODE;          /*SET STEP ERROR REASON
*                                          CODE IF ANY       @G32HPPJ*/
         L     @12,@PC00001+20                                  02S0134
         L     @12,ALCWAPTR(,@12)                               02S0134
         L     @12,FAILRSCP(,@12)                               02S0134
         L     @11,EREQPTR                                      02S0134
         MVC   FAILCODE(2,@12),EREQCODE(@11)                    02S0134
*  END;                                /*                    @G32HPPJ*/
*ELSE;                                 /*RACF PROTECT FAILED @G32HPPJ*/
@RF00100 DS    0H                                               01S0137
*IF ERRWORD = ZERO THEN                /*ANY ERRORS?                 */
         LTR   ERRWORD,ERRWORD                                  01S0137
         BNZ   @RF00137                                         01S0137
*  DO;                                 /*NO CONTINUE                 */
*    PRMUCBP = UCBPTR;                 /*PTR TO UCB TO ESTAE PARMS   */
         L     @12,@PC00001+20                                  01S0139
         L     @12,ALCWAPTR(,@12)                               01S0139
         L     @12,EXITPRMP(,@12)                               01S0139
         L     @11,@PC00001+8                                   01S0139
         MVC   PRMUCBP(4,@12),UCBPTR(@11)                       01S0139
*    PRMSIOTP = SIOTPTR;               /*PTR TO SIOT TO ESTAE PARMS  */
         L     @11,@PC00001                                     01S0140
         MVC   PRMSIOTP(4,@12),SIOTPTR(@11)                     01S0140
*    TIOTBLT = ON;                     /*INDICATE TIOT BUILT         */
         OI    TIOTBLT(@12),B'00010000'                         01S0141
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - BUCBPARM                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - BUILD UPDATE UCB PARMLIST                     */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*    THIS ROUTINE CLEARS AND BUILDS THE PARAMETER LIST FOR UPDATE  */
*/*    UCB RTN (IEFAB435).                                           */
*/*                                                                  */
*/* ENTRY - INLINE SEGMENT OF IEFAB434.                              */
*/*                                                                  */
*/*    PURPOSE - SEE FUNCTION                                        */
*/*                                                                  */
*/*    INPUT -                                                       */
*/*      INDICATOR FLAGS DESCRIBING WHICH FUNCTIONS IEFAB435 IS TO   */
*/*        PERFORM.                                                  */
*/*      VUPTR - POINTER TO VOLUNIT ENTRY.                           */
*/*                                                                  */
*/* EXITS -                                                          */
*/*    CONDITION - UPDATE UCB PARMLIST BUILT                         */
*/*                                                                  */
*/*      OUTPUT -                                                    */
*/*         THE FOLLOWING FIELDS SET IN UCBPARML:                    */
*/*           UPUSEAT  - SET IF USE ATTRIBUTE IS TO BE UPDATED.      */
*/*           UPUSECNT - SET IF USE COUNT IS TO BE UPDATED.          */
*/*           VALIDCHK - SET IF UCB'S ARE TO BE VALIDITY CHECKED.    */
*/*           VOLUMEID - VOLID OF REQUEST, SET BY CALLER             */
*/*           VOLSWOK  - SET IF WHOLE GENERIC IS LOCKED              */
*/*                                                                  */
*/*      RETURN CODE - NONE                                          */
*/*                                                                  */
*/********************************************************************/
*IFLAGS = FLAGSOFF;                    /*CLEAR FLAG FIELD            */
         L     @12,@PC00001+28                                  02S0142
         L     @12,UCBDATAP(,@12)                               02S0142
         MVI   IFLAGS(@12),B'00000000'                          02S0142
*IF USEFLAG = ON THEN                  /*INCREMENT USE COUNT?        */
         L     @11,@PC00001+12                                  02S0143
         TM    USEFLAG(@11),B'01000000'                         02S0143
         BNO   @RF00143                                         02S0143
*  UPUSECNT = ON;                      /*YES, SET PARM               */
         OI    UPUSECNT(@12),B'01000000'                        02S0144
*IF USEATFLG = ON THEN                 /*UPDATE USE ATTRIBUTE        */
@RF00143 L     @12,@PC00001+12                                  02S0145
         TM    USEATFLG(@12),B'00001000'                        02S0145
         BNO   @RF00145                                         02S0145
*  UPUSEAT = ON;                                                02S0146
         L     @12,@PC00001+28                                  02S0146
         L     @12,UCBDATAP(,@12)                               02S0146
         OI    UPUSEAT(@12),B'00100000'                         02S0146
*IF VLDFLAG = ON THEN                  /*VALIDITY CHECK UCB'S?       */
@RF00145 L     @12,@PC00001+12                                  02S0147
         TM    VLDFLAG(@12),B'00010000'                         02S0147
         BNO   @RF00147                                         02S0147
*  VALIDCHK =ON;                       /*YES, SET PARM               */
         L     @12,@PC00001+28                                  02S0148
         L     @12,UCBDATAP(,@12)                               02S0148
         OI    VALIDCHK(@12),B'10000000'                        02S0148
*IF OKVOLSW = ON THEN                  /*WHOLE GENERIC LOCKED?       */
@RF00147 L     @12,@PC00001+12                                  02S0149
         TM    OKVOLSW(@12),B'00000010'                         02S0149
         BNO   @RF00149                                         02S0149
*  VOLSWOK = ON;                       /*YES, SET PARM               */
         L     @12,@PC00001+28                                  02S0150
         L     @12,UCBDATAP(,@12)                               02S0150
         OI    VOLSWOK(@12),B'00001000'                         02S0150
*UCBAD=UCBPTR;                         /*PT TO UCB TO BE ALLOCATED   */
@RF00149 L     @12,@PC00001+28                                  02S0151
         L     @12,UCBDATAP(,@12)                               02S0151
         L     @11,@PC00001+8                                   02S0151
         L     @11,UCBPTR(,@11)                                 02S0151
         STH   @11,UCBAD(,@12)                                  02S0151
*STATUCB = ZERO;                       /*CLEAR SAVE AREA FOR UCB
*                                        STATUS                      */
         MVI   STATUCB,X'00'                                    02S0152
*IF VOLSPEC = ON &                     /*SPECIFIC REQ FOR THIS VOL   */
*    UCBNSRCH = OFF THEN               /*FIRST SETTING OF NON-SCRATCH
*                                        INDICATOR                   */
         L     @12,@PC00001+4                                   02S0153
         L     @12,VUPTR(,@12)                                  02S0153
         TM    VOLSPEC(@12),B'00100000'                         02S0153
         BNO   @RF00153                                         02S0153
         L     @12,UCBEXTPT(,@11)                               02S0153
         TM    UCBNSRCH(@12),B'10000000'                        02S0153
         BNZ   @RF00153                                         02S0153
*  NSRCHUCB = ON;                      /*STATUS TO BE RESET IF  02S0154
*                                        DADSM ERROR                 */
         OI    NSRCHUCB,B'10000000'                             02S0154
*    CALL IEFAB435(UCBPARML,SIOTPTR,ALCWAPTR,VUPTR,GROUPID); /*UP UCB*/
@RF00153 L     @12,@PC00001+28                                  01S0155
         L     @12,UCBDATAP(,@12)                               01S0155
         ST    @12,@AL00001                                     01S0155
         L     @12,@PC00001                                     01S0155
         ST    @12,@AL00001+4                                   01S0155
         L     @12,@PC00001+20                                  01S0155
         ST    @12,@AL00001+8                                   01S0155
         L     @12,@PC00001+4                                   01S0155
         ST    @12,@AL00001+12                                  01S0155
         L     @12,@PC00001+24                                  01S0155
         ST    @12,@AL00001+16                                  01S0155
         L     @15,@CV00088                                     01S0155
         LA    @01,@AL00001                                     01S0155
         BALR  @14,@15                                          01S0155
*    ERRWORD = REG15;                  /*SAVE RETURN CODE            */
         LR    ERRWORD,REG15                                    01S0156
*    IF ERRWORD = ZERO THEN            /*ANY ERRORS BUILDING ETIOT?  */
         LTR   ERRWORD,ERRWORD                                  01S0157
         BNZ   @RF00157                                         01S0157
*      DO;                             /*NO, SEE IF DADSM REQUIRED   */
*        DSABPTR = SIOTETIO;           /*SET PTR TO DSAB ENTRY       */
         L     @12,@PC00001                                     01S0159
         L     @12,SIOTPTR(,@12)                                01S0159
         L     DSABPTR,SIOTETIO(,@12)                           01S0159
*        IF PUBPRV = ON THEN           /*UCB SWITCHED FROM PUB TO PRV*/
         L     @12,@PC00001+28                                  01S0160
         L     @12,UCBDATAP(,@12)                               01S0160
         TM    PUBPRV(@12),B'00000100'                          01S0160
         BNO   @RF00160                                         01S0160
*          TIOPUBPV(EREQRPOS) = ON;    /*INDICATE SO IN TIOT DEV ENT */
         L     @12,EREQPTR                                      01S0161
         LH    @12,EREQRPOS(,@12)                               01S0161
         SLA   @12,2                                            01S0161
         L     @11,DSABTIOT(,DSABPTR)                           01S0161
         ALR   @11,@12                                          01S0161
         OI    TIOPUBPV-4(@11),B'00001000'                      01S0161
*        ELSE                                                   01S0162
*          IF NOTHPRV = ON THEN        /*UCB SWITCHED TO PRIVATE     */
         B     @RC00160                                         01S0162
@RF00160 L     @12,@PC00001+28                                  01S0162
         L     @12,UCBDATAP(,@12)                               01S0162
         TM    NOTHPRV(@12),B'00000010'                         01S0162
         BNO   @RF00162                                         01S0162
*            TIONOPV(EREQRPOS) = ON;   /*INDICATE SO IN TIOT DEV ENT */
         L     @12,EREQPTR                                      01S0163
         LH    @12,EREQRPOS(,@12)                               01S0163
         SLA   @12,2                                            01S0163
         L     @11,DSABTIOT(,DSABPTR)                           01S0163
         ALR   @11,@12                                          01S0163
         OI    TIONOPV-4(@11),B'00000100'                       01S0163
*          ELSE;                                                01S0164
@RF00162 DS    0H                                               01S0165
*        IF NSRCHUCB = ON THEN          /*NON-SCRTCH INDIC SET IN UCB*/
@RC00160 TM    NSRCHUCB,B'10000000'                             01S0165
         BNO   @RF00165                                         01S0165
*          TIONSRCH(EREQRPOS) = ON;     /*INDIC IN TIOT DEV ENTRY    */
         L     @12,EREQPTR                                      01S0166
         LH    @12,EREQRPOS(,@12)                               01S0166
         SLA   @12,2                                            01S0166
         L     @11,DSABTIOT(,DSABPTR)                           01S0166
         ALR   @11,@12                                          01S0166
         OI    TIONSRCH-4(@11),B'00010000'                      01S0166
*        IF SJFCBPTR->JFCORGIS = ON THEN /*ISAM REQ?                 */
@RF00165 L     @12,@PC00001                                     01S0167
         L     @12,SIOTPTR(,@12)                                01S0167
         L     @12,SJFCBPTR(,@12)                               01S0167
         TM    JFCORGIS(@12),B'10000000'                        01S0167
         BNO   @RF00167                                         01S0167
*            ALCWISAM = ON;            /*YES, INDICATE               */
         L     @12,@PC00001+20                                  01S0168
         L     @12,ALCWAPTR(,@12)                               01S0168
         OI    ALCWISAM(@12),B'00000010'                        01S0168
*        ELSE;                         /*NOT AN ISAM SPACE REQ       */
@RF00167 DS    0H                                               01S0170
*        IF VUDADSM = ON &             /*SPACE NEEDED ON THIS VOL ?  */
*           SJFCBPTR->JFCORGIS ^= ON &                          01S0170
*           UCB3DACC = ON &                                     01S0170
*           UCBMOUNT = OFF THEN                                 01S0170
         L     @12,@PC00001+4                                   01S0170
         L     @12,VUPTR(,@12)                                  01S0170
         TM    VUDADSM(@12),B'00000010'                         01S0170
         BNO   @RF00170                                         01S0170
         L     @12,@PC00001                                     01S0170
         L     @12,SIOTPTR(,@12)                                01S0170
         L     @12,SJFCBPTR(,@12)                               01S0170
         TM    JFCORGIS(@12),B'10000000'                        01S0170
         BO    @RF00170                                         01S0170
         L     @11,@PC00001+8                                   01S0170
         L     @11,UCBPTR(,@11)                                 01S0170
         TM    UCB3DACC(@11),B'00100000'                        01S0170
         BNO   @RF00170                                         01S0170
         TM    UCBMOUNT(@11),B'10000000'                        01S0170
         BNZ   @RF00170                                         01S0170
*          DO;                         /*YES,SET UP DADSM INTERFACE  */
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - DADSMINT                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - DADSM INTERFACE ROUTINE.                      */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE INTERFACES WITH DIRECT ACCESS DEVICE SPACE        */
*/*   MANAGEMENT (DADSM) TO ACQUIRE SPACE ON A DIRECT ACCESS VOLUME  */
*/*   FOR NEW DATA SETS. DADSM REQUIRES THE FOLLOWING INPUT:         */
*/*       .REG0 - POINTER TO JFCB FOR THE DATA SET.                  */
*/*       .REG1 - POINTER TO A FULL WORD CONTAINING THE ADDRESS OF   */
*/*               THE UCB ON WHICH THE VOLUME IS MOUNTED.            */
*/*       .THE SERIAL NUMBER OF THE VOLUME MUST BE IN THE JFCB.      */
*/*                                                                  */
*/* ENTRY - INLINE SEGMENT OF IEFAB434.                              */
*/*   PURPOSE  - SEE FUNCTION.                                       */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*     SIOTPTR - POINTER TO SIOT OF REQUEST; SIOT CONTAINS THE      */
*/*               POINTER TO THE JFCB.                               */
*/*     UCBPTR - POINTER TO UCB ALLOCATED TO REQUEST.                */
*/*                                                                  */
*/* EXITS -                                                          */
*/*   CONDITION - SPACE OBTAINED ON VOLUME.                          */
*/*                                                                  */
*/*     OUTPUT -                                                     */
*/*       UPDATED JFCB                                               */
*/*                                                                  */
*/*     RETURN CODE -                                                */
*/*       REG15  - 0, TO INDICATE SPACE GOTTEN.                      */
*/*                                                                  */
*/*   CONDITION - UNABLE TO OBTAIN SPACE ON VOLUME SPECIFIED.        */
*/*                                                                  */
*/*     OUTPUT -                                                     */
*/*                                                                  */
*/*     RETURN CODE -                                                */
*/*       ERRWORD  - 12,      TO INDICATE SPACE FAILURE.             */
*/*       SIOTRSNC - DADSM ERROR RETURN CODE INDICATING SPACE FAILURE*/
*/*                                                                  */
*/*                                                                  */
*/********************************************************************/
*JFCBPTR = SJFCBPTR;                   /* GET JFCB POINTER FROM SIOT */
         LR    JFCBPTR,@12                                      02S0172
*JFCBVOLS(1:6) = UCBVOLI;              /* PUT VOLSER INTO JFCB       */
         MVC   JFCBVOLS(6,JFCBPTR),UCBVOLI(@11)                 02S0173
*IF JFCBNVOL = ZERO THEN               /* IF NON-SPECIFIC REQUEST    */
         CLI   JFCBNVOL(JFCBPTR),0                              02S0174
         BNE   @RF00174                                         02S0174
*  JFCBNVOL = ONE;                     /* SET NUMBER OF VOLUMES      */
         MVI   JFCBNVOL(JFCBPTR),X'01'                          02S0175
*DADSPARM = UCBPTR;                    /* STORE POINTER TO UCB FOR
*                                         DADSM.                     */
@RF00174 L     @12,@PC00001+8                                   02S0176
         MVC   DADSPARM(4),UCBPTR(@12)                          02S0176
*REG0 = JFCBPTR;                                                02S0177
         LR    REG0,JFCBPTR                                     02S0177
*REG1 = ADDR(DADSPARM);                                         02S0178
         LA    REG1,DADSPARM                                    02S0178
*GEN(SVC 32);                          /* INVOKE DADSM TO GET SPACE  */
         SVC 32
*ERRWORD = REG15;                      /*SAVE RETURN CODE            */
         LR    ERRWORD,REG15                                    02S0180
*            IF ERRWORD ^= ZERO THEN   /*SPACE OBTAINED?             */
         SLR   @12,@12                                          01S0181
         CR    ERRWORD,@12                                      01S0181
         BE    @RF00181                                         01S0181
*              DO;                     /*NO, 'UNALLOCATE' REQUEST    */
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - DADSMERR                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME -  DADSM ERROR HANDLER                          */
*/*                                                                  */
*/* FUNCTION - THIS ROUTINE IS RESPONSIBLE FOR 'UNALLOCATING' A      */
*/*            REQUEST FOR A UNIT WHICH CANNOT BE HONORED BECAUSE    */
*/*            OF A DADSM FAILURE.                                   */
*/*            THIS ROUTINE WILL PERFORM THE FOLLOWING FUNCTIONS:    */
*/*             . DESCREMENT THE USE COUNT IN THE UCB. WHEN THE USE  */
*/*               COUNT BECOMES ZERO, THE UCB IS UNALLOCATED.        */
*/*             . REMOVE (ZERO) THE DEVICE ENTRY FOR THIS UCB FROM   */
*/*               THE ETIOT ENTRY FOR THIS REQUEST.                  */
*/*             . FOR A NON-SPECIFIC REQUEST REMOVE THE      @ZA08847*/
*/*               VOLUME SERIAL FROM THE JFCB BY SETTING     @ZA08847*/
*/*               JFCBNVOL TO ZERO AND THE FIRST VOLUME      @ZA08847*/
*/*               SERIAL SLOT TO BLANKS.                     @ZA08847*/
*/*                                                                  */
*/*            ALL REFERENCES TO THE UCB ARE MADE WHILE IN POSSESSION*/
*/*            OF THE LOCAL AND CMS LOCKS.                           */
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT -      UCBPTR - PTR TO UCB ALLOCATED TO THE REQUEST.     */
*/*                SIOTETIO - PTR TO ETIOT ENTRY FOR THE REQUEST.    */
*/*                EREQPOS - RELATIVE POSITION OF THE DEVICE ENTRY   */
*/*                          IN THE ETIOT.                           */
*/*                STATUCB - ATTRIBUTE OF VOLUME ON THIS UNIT PRIOR  */
*/*                          TO ALLOCATION OF FAILING REQUEST.       */
*/*                                                                  */
*/* EXITS -                                                          */
*/*   CONDITION - UNALLOCATION SUCCESSFUL.                           */
*/*                                                                  */
*/*   OUTPUT DATA - UPDATED UCB - USE COUNT DECREMENTED OR IF ZERO   */
*/*                               UCB UNALLOCATED VOLUME.            */
*/*                               ATTRIBUTE RESET TO STATUS IT HAD   */
*/*                               PRIOR TO ALLOCATION OF THIS REQUEST*/
*/*                 UPDATED DEVICE ENTRY IN ETIOT OF THE REQUEST.    */
*/*                 REASON CODE IN SIOT                              */
*/*                                                                  */
*/*   RETURN CODE - IN REG15 ONE OF THE FOLLOWING                    */
*/*                 12, ERROR RECOVERABLE                            */
*/*                 16, ERROR NOT RECOVERABLE                        */
*/*                                                                  */
*/********************************************************************/
* DO; /*MODESET  KEYADDR(ZERO)*/                                02S0183
*   SPKA (ZERO); /*SET PSW KEY*/                                02S0184
         SPKA  0(@12)                                           02S0184
* END; /*MODESET  KEYADDR(ZERO)*/                               02S0185
* DO; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(LOCAL) REGS(USE) RELATED(UC
*,IEFAB434(DADSMERR)) */                                        02S0186
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                     02S0187
*   RFY (GPR15P,GPR00P,GPR01P) RSTD;                            02S0188
*   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */             02S0189
         LR    GPR15P,GPR11P                                    02S0189
*   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */              02S0190
         LR    GPR00P,GPR12P                                    02S0190
*   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */              02S0191
         LR    GPR01P,GPR13P                                    02S0191
*   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */    02S0192
         L     GPR13P,PSALITA                                   02S0192
*   GEN(LM GPR11P,GPR13P,576(GPR13P)); /* LOAD LOCKWORD, CLHT AND ENTRY
*ADRS. */                                                       02S0193
         LM GPR11P,GPR13P,576(GPR13P)
*   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */         02S0194
         BALR GPR14P,GPR13P
*   GPR11P = GPR15P; /* RESTORE REG. 11. */                     02S0195
         LR    GPR11P,GPR15P                                    02S0195
*   GPR15P = GPR13P; /* SAVE RETURN CODE. */                    02S0196
         LR    GPR15P,GPR13P                                    02S0196
*   GPR12P = GPR00P; /* RESTORE REG. 12 */                      02S0197
         LR    GPR12P,GPR00P                                    02S0197
*   GPR13P = GPR01P; /* RESTORE REG. 13. */                     02S0198
         LR    GPR13P,GPR01P                                    02S0198
*   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                           02S0199
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;                   02S0200
* END; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(LOCAL) REGS(USE) RELATED(U
*B,IEFAB434(DADSMERR)) */                                       02S0201
* DO; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(CMS) REGS(USE) RELATED(UCB,
*EFAB434(DADSMERR)) */                                          02S0202
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                     02S0203
*   RFY (GPR15P,GPR00P,GPR01P) RSTD;                            02S0204
*   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */             02S0205
         LR    GPR15P,GPR11P                                    02S0205
*   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */              02S0206
         LR    GPR00P,GPR12P                                    02S0206
*   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */              02S0207
         LR    GPR01P,GPR13P                                    02S0207
*   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */    02S0208
         L     GPR13P,PSALITA                                   02S0208
*   GEN(LM GPR11P,GPR13P,540(GPR13P)); /* LOAD LOCKWORD, CLHT AND ENTRY
*ADRS. */                                                       02S0209
         LM GPR11P,GPR13P,540(GPR13P)
*   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */         02S0210
         BALR GPR14P,GPR13P
*   GPR11P = GPR15P; /* RESTORE REG. 11. */                     02S0211
         LR    GPR11P,GPR15P                                    02S0211
*   GPR15P = GPR13P; /* SAVE RETURN CODE. */                    02S0212
         LR    GPR15P,GPR13P                                    02S0212
*   GPR12P = GPR00P; /* RESTORE REG. 12 */                      02S0213
         LR    GPR12P,GPR00P                                    02S0213
*   GPR13P = GPR01P; /* RESTORE REG. 13. */                     02S0214
         LR    GPR13P,GPR01P                                    02S0214
*   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                           02S0215
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;                   02S0216
* END; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(CMS) REGS(USE) RELATED(UCB
*IEFAB434(DADSMERR)) */                                         02S0217
*UCBUSER = UCBUSER - ONE;              /*DECREMENT USE COUNT         */
         L     @12,@PC00001+8                                   02S0218
         L     @12,UCBPTR(,@12)                                 02S0218
         SLR   @11,@11                                          02S0218
         IC    @11,UCBUSER(,@12)                                02S0218
         BCTR  @11,0                                            02S0218
         STC   @11,UCBUSER(,@12)                                02S0218
*IF TIONSRCH(EREQRPOS) = ON THEN       /*NON-SCRTCH INDIC WAS SET    */
         L     @11,EREQPTR                                      02S0219
         LH    @11,EREQRPOS(,@11)                               02S0219
         SLA   @11,2                                            02S0219
         L     @01,DSABTIOT(,DSABPTR)                           02S0219
         ALR   @01,@11                                          02S0219
         TM    TIONSRCH-4(@01),B'00010000'                      02S0219
         BNO   @RF00219                                         02S0219
*  UCBNSRCH = OFF;                     /*CLEAR INDICATOR IN UCB      */
         L     @12,UCBEXTPT(,@12)                               02S0220
         NI    UCBNSRCH(@12),B'01111111'                        02S0220
*IF UCBUSER = ZERO THEN                /*IF USE COUNT ZERO           */
@RF00219 L     @12,@PC00001+8                                   02S0221
         L     @12,UCBPTR(,@12)                                 02S0221
         CLI   UCBUSER(@12),0                                   02S0221
         BNE   @RF00221                                         02S0221
*  DO;                                 /*CLEAN-UP UCB                */
*    UCBALOC = OFF;                    /*UNALLOCATE DEVICE           */
         NI    UCBALOC(@12),B'11110111'                         02S0223
*    UCBASID = ZERO;                                            02S0224
         L     @11,UCBEXTPT(,@12)                               02S0224
         SLR   @15,@15                                          02S0224
         STH   @15,UCBASID(,@11)                                02S0224
*    UCBBSVL = OFF;                                             02S0225
*    UCBSHAR = OFF;                                             02S0226
         NI    UCBBSVL(@12),B'01111101'                         02S0226
*    IF TIOPUBPV(EREQRPOS) = ON THEN   /*UCB SWITCHED FROM PUB TO PRI*/
         L     @11,EREQPTR                                      02S0227
         LH    @11,EREQRPOS(,@11)                               02S0227
         SLA   @11,2                                            02S0227
         L     @01,DSABTIOT(,DSABPTR)                           02S0227
         ALR   @01,@11                                          02S0227
         TM    TIOPUBPV-4(@01),B'00001000'                      02S0227
         BNO   @RF00227                                         02S0227
*      DO;                                                      02S0228
*        UCBBPRV = OFF;                                         02S0229
*        UCBBPUB = ON;                                          02S0230
         OI    UCBBPUB(@12),B'00001000'                         02S0230
         NI    UCBBPRV(@12),B'11101111'                         02S0230
*      END;                                                     02S0231
*    ELSE                                                       02S0232
*      IF TIONOPV(EREQRPOS) = ON THEN  /*UCB CHANGED TO PRIVATE      */
         B     @RC00227                                         02S0232
@RF00227 L     @12,EREQPTR                                      02S0232
         LH    @12,EREQRPOS(,@12)                               02S0232
         SLA   @12,2                                            02S0232
         L     @11,DSABTIOT(,DSABPTR)                           02S0232
         ALR   @11,@12                                          02S0232
         TM    TIONOPV-4(@11),B'00000100'                       02S0232
         BNO   @RF00232                                         02S0232
*        UCBBPRV = OFF;                                         02S0233
         L     @12,@PC00001+8                                   02S0233
         L     @12,UCBPTR(,@12)                                 02S0233
         NI    UCBBPRV(@12),B'11101111'                         02S0233
*  END;                                                         02S0234
@RF00232 DS    0H                                               02S0234
@RC00227 DS    0H                                               02S0235
* DO; /* SETLOCK (RELEASE) TYPE(CMS) REGS(USE) RELATED(UCB,IEFAB434(DAD
*MERR)) */                                                      02S0235
@RF00221 DS    0H                                               02S0236
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                     02S0236
*   RFY (GPR15P,GPR00P,GPR01P) RSTD;                            02S0237
*   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */             02S0238
         LR    GPR15P,GPR11P                                    02S0238
*   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */              02S0239
         LR    GPR00P,GPR12P                                    02S0239
*   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */              02S0240
         LR    GPR01P,GPR13P                                    02S0240
*   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */    02S0241
         L     GPR13P,PSALITA                                   02S0241
*   GEN(LM GPR11P,GPR13P,552(GPR13P)); /* LOAD LOCKWORD, CLHT AND ENTRY
*ADRS. */                                                       02S0242
         LM GPR11P,GPR13P,552(GPR13P)
*   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */         02S0243
         BALR GPR14P,GPR13P
*   GPR11P = GPR15P; /* RESTORE REG. 11. */                     02S0244
         LR    GPR11P,GPR15P                                    02S0244
*   GPR15P = GPR13P; /* SAVE RETURN CODE. */                    02S0245
         LR    GPR15P,GPR13P                                    02S0245
*   GPR12P = GPR00P; /* RESTORE REG. 12 */                      02S0246
         LR    GPR12P,GPR00P                                    02S0246
*   GPR13P = GPR01P; /* RESTORE REG. 13. */                     02S0247
         LR    GPR13P,GPR01P                                    02S0247
*   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                           02S0248
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;                   02S0249
* END; /* SETLOCK (RELEASE) TYPE(CMS) REGS(USE) RELATED(UCB,IEFAB434(DA
*SMERR)) */                                                     02S0250
* DO; /* SETLOCK (RELEASE) TYPE(LOCAL) REGS(USE) RELATED(UCB,IEFAB434(D
*DSMERR)) */                                                    02S0251
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                     02S0252
*   RFY (GPR15P,GPR00P,GPR01P) RSTD;                            02S0253
*   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */             02S0254
         LR    GPR15P,GPR11P                                    02S0254
*   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */              02S0255
         LR    GPR00P,GPR12P                                    02S0255
*   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */              02S0256
         LR    GPR01P,GPR13P                                    02S0256
*   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */    02S0257
         L     GPR13P,PSALITA                                   02S0257
*   GEN(LM GPR11P,GPR13P,588(GPR13P)); /* LOAD LOCKWORD, CLHT AND ENTRY
*ADRS. */                                                       02S0258
         LM GPR11P,GPR13P,588(GPR13P)
*   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */         02S0259
         BALR GPR14P,GPR13P
*   GPR11P = GPR15P; /* RESTORE REG. 11. */                     02S0260
         LR    GPR11P,GPR15P                                    02S0260
*   GPR15P = GPR13P; /* SAVE RETURN CODE. */                    02S0261
         LR    GPR15P,GPR13P                                    02S0261
*   GPR12P = GPR00P; /* RESTORE REG. 12 */                      02S0262
         LR    GPR12P,GPR00P                                    02S0262
*   GPR13P = GPR01P; /* RESTORE REG. 13. */                     02S0263
         LR    GPR13P,GPR01P                                    02S0263
*   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                           02S0264
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;                   02S0265
* END; /* SETLOCK (RELEASE) TYPE(LOCAL) REGS(USE) RELATED(UCB,IEFAB434(
*ADSMERR)) */                                                   02S0266
* DO; /*MODESET  EXTKEY(SCHED)*/                                02S0267
*   SPKA (16); /*SET PSW KEY*/                                  02S0268
         LA    @12,16                                           02S0268
         SPKA  0(@12)                                           02S0268
* END; /*MODESET  EXTKEY(SCHED)*/                               02S0269
*DSABPTR = SIOTETIO;                   /*GET POINTER TO DSAB ENTRY   */
         L     @11,@PC00001                                     02S0270
         L     @11,SIOTPTR(,@11)                                02S0270
         L     DSABPTR,SIOTETIO(,@11)                           02S0270
*TIOEDEVE(EREQRPOS) = ZERO;            /*ZERO DEVICE ENTRY           */
         L     @03,EREQPTR                                      02S0271
         LH    @03,EREQRPOS(,@03)                               02S0271
         SLA   @03,2                                            02S0271
         L     @01,DSABTIOT(,DSABPTR)                           02S0271
         SLR   @00,@00                                          02S0271
         ST    @00,TIOEDEVE-4(@03,@01)                          02S0271
*INDEX = ERRWORD/FOUR;                 /*CALCULATE INDEX INTO ARRAY  */
         LR    @00,ERRWORD                                      02S0272
         SRDA  @00,32                                           02S0272
         D     @00,@CF00085                                     02S0272
         LR    INDEX,@01                                        02S0272
*SIOTRSNC = ERORCODE(INDEX);           /*PLACE REASON CODE IN SIOT   */
         LR    @03,INDEX                                        02S0273
         ALR   @03,@03                                          02S0273
         LH    @03,ERORCODE-2(@03)                              02S0273
         STH   @03,SIOTRSNC(,@11)                               02S0273
*IF ERORCODE(INDEX) = NORECOV1 |       /*CHECK TO SEE IF RECOVERABLE */
*   ERORCODE(INDEX) = NORECOV2 |                                02S0274
*   ERORCODE(INDEX) = NORECOV3 |                                02S0274
*   ERORCODE(INDEX) = NORECOV4 |                                02S0274
*   ERORCODE(INDEX) = NORECOV5 |       /*NOT AUTHORIZED      @Z40RPPE*/
*   (ERORCODE(INDEX) = NORECOV6 &      /*DS ALREADY DEFINED  @ZA16820*/
*    RCVTVERS = ZERO)  |               /*AND RACF 1 IS ON    @ZA16820*/
*   (ERORCODE(INDEX) = NORECOV6 &      /*DS ALREADY DEFINED  @ZA16820*/
*    RCVTVERS ^= ZERO  &               /*AND NOT RACF1       @ZA16820*/
*    RCVTNDUP = ON) THEN               /*BUT INSTALLATION DOES NOT
*                                        WANT DUPE NAMES DEFINED IN
*                                        RACF                @ZA16820*/
         CH    @03,@CH00200                                     02S0274
         BE    @RT00274                                         02S0274
         CH    @03,@CH00202                                     02S0274
         BE    @RT00274                                         02S0274
         CH    @03,@CH00204                                     02S0274
         BE    @RT00274                                         02S0274
         CH    @03,@CH00206                                     02S0274
         BE    @RT00274                                         02S0274
         CH    @03,@CH00208                                     02S0274
         BE    @RT00274                                         02S0274
         CR    @03,@12                                          02S0274
         BNE   @GL00014                                         02S0274
         L     @12,CVTPTR                                       02S0274
         L     @12,CVTRAC(,@12)                                 02S0274
         CLI   RCVTVERS(@12),0                                  02S0274
         BE    @RT00274                                         02S0274
@GL00014 LR    @12,INDEX                                        02S0274
         ALR   @12,@12                                          02S0274
         LH    @12,ERORCODE-2(@12)                              02S0274
         CH    @12,@CH00067                                     02S0274
         BNE   @RF00274                                         02S0274
         L     @12,CVTPTR                                       02S0274
         L     @12,CVTRAC(,@12)                                 02S0274
         CLI   RCVTVERS(@12),0                                  02S0274
         BE    @RF00274                                         02S0274
         TM    RCVTNDUP(@12),B'00010000'                        02S0274
         BNO   @RF00274                                         02S0274
@RT00274 DS    0H                                               02S0275
*  ERRWORD = FAIL;                     /*IF NOT RECOV SET RETURN CODE*/
         LA    ERRWORD,16                                       02S0275
*ELSE                                  /*RECOVER RETURN CODE @ZA08847*/
*  ERRWORD=RECOVER;                    /* SET RETURN CODE    @ZA08847*/
         B     @RC00274                                         02S0276
@RF00274 LA    ERRWORD,12                                       02S0276
*IF VOLSPEC = OFF THEN                 /*NON SPECIFIC REQ.   @ZA08847*/
@RC00274 L     @12,@PC00001+4                                   02S0277
         L     @12,VUPTR(,@12)                                  02S0277
         TM    VOLSPEC(@12),B'00100000'                         02S0277
         BNZ   @RF00277                                         02S0277
*  DO;                                 /*RESET THE JFCB      @ZA08847*/
*    JFCBNVOL = ZERO;                  /*RESET TO NONSPECIFIC@ZA08847*/
         MVI   JFCBNVOL(JFCBPTR),X'00'                          02S0279
*    JFCBVOLS(1:6)= '';                /*RESET VOLS TO BLANK @ZA08847*/
         MVI   JFCBVOLS(JFCBPTR),C' '                           02S0280
         MVC   JFCBVOLS+1(5,JFCBPTR),JFCBVOLS(JFCBPTR)          02S0280
*  END;                                /*END RESET THE JFCB  @ZA08847*/
*              END;                                             01S0282
*            ELSE                                               01S0283
*              DO;                                              01S0283
         B     @RC00181                                         01S0283
@RF00181 DS    0H                                               01S0284
*                SIODADSM = ON;        /*INDICATE DADSM SUCCESSFUL   */
         L     @12,@PC00001                                     01S0284
         L     @12,SIOTPTR(,@12)                                01S0284
         OI    SIODADSM(@12),B'00000100'                        01S0284
*                SIOUCBAD = UCBPTR;    /*PLACE UCB ADDRESS IN SIOT   */
         L     @11,@PC00001+8                                   01S0285
         MVC   SIOUCBAD(3,@12),UCBPTR+1(@11)                    01S0285
*              END;                                             01S0286
*          END;                                                 01S0287
*        ELSE                          /*DADSM NOT REQUIRED  @YM02425*/
*          IF UCB3DACC = ON &          /*DA REQUEST          @YM02425*/
*             VOLSPEC = OFF &          /*NON-SPECIFIC REQUEST@YM05489*/
*             UCBVOLI ^= NOUCBVOL &    /*UCB CONTAINS NON-ZERO  01S0288
*                                        VOL SER             @YM05464*/
*             EREQRPOS = ONE THEN      /*FOR 1ST VOL?        @YM02425*/
         B     @RC00170                                         01S0288
@RF00170 L     @12,@PC00001+8                                   01S0288
         L     @12,UCBPTR(,@12)                                 01S0288
         TM    UCB3DACC(@12),B'00100000'                        01S0288
         BNO   @RF00288                                         01S0288
         L     @11,@PC00001+4                                   01S0288
         L     @11,VUPTR(,@11)                                  01S0288
         TM    VOLSPEC(@11),B'00100000'                         01S0288
         BNZ   @RF00288                                         01S0288
         CLC   UCBVOLI(6,@12),NOUCBVOL                          01S0288
         BE    @RF00288                                         01S0288
         L     @11,EREQPTR                                      01S0288
         CLC   EREQRPOS(2,@11),@CH00057                         01S0288
         BNE   @RF00288                                         01S0288
*            DO;                       /*YES,FILL IN VOLSER  @YM02425*/
*              SJFCBPTR->JFCBVOLS(1:6)= UCBVOLI; /*PUT VOLSER IN JFCB
*                                                            @YM02425*/
         L     @11,@PC00001                                     01S0290
         L     @11,SIOTPTR(,@11)                                01S0290
         L     @11,SJFCBPTR(,@11)                               01S0290
         MVC   JFCBVOLS(6,@11),UCBVOLI(@12)                     01S0290
*              IF SJFCBPTR->JFCBNVOL = ZERO THEN /*IF NON SPECIFIC REQ
*                                                            @YM02425*/
         CLI   JFCBNVOL(@11),0                                  01S0291
         BNE   @RF00291                                         01S0291
*                SJFCBPTR->JFCBNVOL =ONE; /*SET # OF VOLS    @YM02425*/
         MVI   JFCBNVOL(@11),X'01'                              01S0292
*            END;                      /*                    @YM02425*/
@RF00291 DS    0H                                               01S0294
*        IF ERRWORD = ZERO &                                    01S0294
*           UPDALGTB=ON THEN                                    01S0294
@RF00288 DS    0H                                               01S0294
@RC00170 LTR   ERRWORD,ERRWORD                                  01S0294
         BNZ   @RF00294                                         01S0294
         L     @12,@PC00001+12                                  01S0294
         TM    UPDALGTB(@12),B'00000100'                        01S0294
         BNO   @RF00294                                         01S0294
*          DO;                                                  01S0295
*            FUNCS = FLAGSOFF;         /*ZERO 4F2 FUNCTION MAP       */
         MVI   FUNCS,B'00000000'                                01S0296
*            ARUFUNC = ON;             /*INDICATE DEVICE ALLOCATED   */
         OI    ARUFUNC,B'01000000'                              01S0297
*            CALL IEFAB4F2(FUNCS,VUPTR,UCBPTR,ALCWAPTR,GROUPID);
         LA    @12,FUNCS                                        01S0298
         ST    @12,@AL00001                                     01S0298
         L     @12,@PC00001+4                                   01S0298
         ST    @12,@AL00001+4                                   01S0298
         L     @12,@PC00001+8                                   01S0298
         ST    @12,@AL00001+8                                   01S0298
         L     @12,@PC00001+20                                  01S0298
         ST    @12,@AL00001+12                                  01S0298
         L     @12,@PC00001+24                                  01S0298
         ST    @12,@AL00001+16                                  01S0298
         L     @15,@CV00089                                     01S0298
         LA    @01,@AL00001                                     01S0298
         BALR  @14,@15                                          01S0298
*            RETCODE = REG15;                                   01S0299
         ST    REG15,RETCODE                                    01S0299
*          END;                                                 01S0300
*        IF ERRWORD = ZERO  THEN       /*HAVE ANY ERRS OCCURRED?     */
@RF00294 LTR   ERRWORD,ERRWORD                                  01S0301
         BNZ   @RF00301                                         01S0301
*          DO;                         /*NO, CONTINUE                */
*            IF SIOUCBAD = ZERO |                               01S0303
*               SIOUCBAD->UCB3DACC = OFF |                      01S0303
*               (SIOUCBAD->UCB3DACC = ON &                      01S0303
*               SIOUCBAD->UCBBSVL = OFF) THEN                   01S0303
         L     @12,@PC00001                                     01S0303
         L     @12,SIOTPTR(,@12)                                01S0303
         SLR   @11,@11                                          01S0303
         ICM   @11,7,SIOUCBAD(@12)                              01S0303
         LTR   @11,@11                                          01S0303
         BZ    @RT00303                                         01S0303
         TM    UCB3DACC(@11),B'00100000'                        01S0303
         BZ    @RT00303                                         01S0303
         TM    UCB3DACC(@11),B'00100000'                        01S0303
         BNO   @RF00303                                         01S0303
         TM    UCBBSVL(@11),B'10000000'                         01S0303
         BNZ   @RF00303                                         01S0303
@RT00303 DS    0H                                               01S0304
*               SIOUCBAD = UCBPTR;     /*UCB ADDR SAVED IN SIOT      */
         L     @12,@PC00001                                     01S0304
         L     @12,SIOTPTR(,@12)                                01S0304
         L     @11,@PC00001+8                                   01S0304
         MVC   SIOUCBAD(3,@12),UCBPTR+1(@11)                    01S0304
*            VUAFFWRK = ON;            /*INDICATE ENTRY ALLOCATED    */
@RF00303 L     @12,@PC00001+4                                   01S0305
         L     @12,VUPTR(,@12)                                  01S0305
         OI    VUAFFWRK(@12),B'00000001'                        01S0305
*            IF SIOPSCNT ^= ZERO THEN  /*PUBLIC/STORAGE COUNT EXISTS?*/
         L     @12,@PC00001                                     01S0306
         L     @12,SIOTPTR(,@12)                                01S0306
         CLI   SIOPSCNT(@12),0                                  01S0306
         BE    @RF00306                                         01S0306
*              SIOPSCNT = SIOPSCNT - ONE;/*DECR. # TO BE ALLOC'D     */
         SLR   @11,@11                                          01S0307
         IC    @11,SIOPSCNT(,@12)                               01S0307
         BCTR  @11,0                                            01S0307
         STC   @11,SIOPSCNT(,@12)                               01S0307
*            IF AFFFLAG = ON THEN      /*NO,ARE AFF'S TO BE ALLOCATED*/
@RF00306 L     @12,@PC00001+12                                  01S0308
         TM    AFFFLAG(@12),B'00100000'                         01S0308
         BNO   @RF00308                                         01S0308
*             DO;                      /*YES, CONTINUE               */
*               AFUNCMAP = FLAGSOFF;   /*INIT IEFAB432 FUNC MAP      */
         MVI   AFUNCMAP,B'00000000'                             01S0310
*               IF OKVOLSW = ON THEN   /*WHOLE GENERIC LOCKED        */
         TM    OKVOLSW(@12),B'00000010'                         01S0311
         BNO   @RF00311                                         01S0311
*                 VOLSWTCH = ON;       /*VOLUME SWITCHING ALLOWED    */
         OI    VOLSWTCH,B'10000000'                             01S0312
*               IF UPDALGTB = ON THEN  /*UPDATE ALG TABLES WANTED    */
@RF00311 L     @12,@PC00001+12                                  01S0313
         TM    UPDALGTB(@12),B'00000100'                        01S0313
         BNO   @RF00313                                         01S0313
*                 UPALOK = ON;         /*INDICATE UPDATA ALG TABLES  */
         OI    UPALOK,B'01000000'                               01S0314
*               CALL IEFAB432(SIOTPTR,VUPTR,UCBPTR,ALCWAPTR,AFUNCMAP);
@RF00313 L     @12,@PC00001                                     01S0315
         ST    @12,@AL00001                                     01S0315
         L     @12,@PC00001+4                                   01S0315
         ST    @12,@AL00001+4                                   01S0315
         L     @12,@PC00001+8                                   01S0315
         ST    @12,@AL00001+8                                   01S0315
         L     @12,@PC00001+20                                  01S0315
         ST    @12,@AL00001+12                                  01S0315
         LA    @12,AFUNCMAP                                     01S0315
         ST    @12,@AL00001+16                                  01S0315
         L     @15,@CV00087                                     01S0315
         LA    @01,@AL00001                                     01S0315
         BALR  @14,@15                                          01S0315
*                                      /*PROCESS VOL AFFINITIES      */
*               ERRWORD = REG15;       /*SAVE RETURN CODE            */
         LR    ERRWORD,REG15                                    01S0316
*               IF ERRWORD = ZERO &    /*432 OK                      */
*                  RETCODE ^= ZERO THEN /*4F2 ERROR                  */
         SLR   @12,@12                                          01S0317
         CR    ERRWORD,@12                                      01S0317
         BNE   @RF00317                                         01S0317
         C     @12,RETCODE                                      01S0317
         BE    @RF00317                                         01S0317
*                    DO;               /*RECALL IEFAB4F2             */
*                      AFFOK = ON;     /*AFFINITY PROCESSED          */
         OI    AFFOK,B'00010000'                                01S0319
*                      CALL IEFAB4F2(FUNCS,VUPTR,UCBPTR,ALCWAPTR,
*                           GROUPID);                           01S0320
         LA    @12,FUNCS                                        01S0320
         ST    @12,@AL00001                                     01S0320
         L     @12,@PC00001+4                                   01S0320
         ST    @12,@AL00001+4                                   01S0320
         L     @12,@PC00001+8                                   01S0320
         ST    @12,@AL00001+8                                   01S0320
         L     @12,@PC00001+20                                  01S0320
         ST    @12,@AL00001+12                                  01S0320
         L     @12,@PC00001+24                                  01S0320
         ST    @12,@AL00001+16                                  01S0320
         L     @15,@CV00089                                     01S0320
         LA    @01,@AL00001                                     01S0320
         BALR  @14,@15                                          01S0320
*                    END;                                       01S0321
*               IF ERRWORD = MTDINELG THEN /*VOL ON INELGIBLE UNIT   */
@RF00317 CH    ERRWORD,@CH00125                                 01S0322
         BNE   @RF00322                                         01S0322
*                 INDRETRY = ON;       /*INDICATE RETRY NEEDED       */
         L     @12,@PC00001+20                                  01S0323
         L     @12,ALCWAPTR(,@12)                               01S0323
         OI    INDRETRY(@12),B'01000000'                        01S0323
*             END;                                              01S0324
*            ELSE;                     /*AFFINITY PROCESSING BYPASSED*/
@RF00308 DS    0H                                               01S0326
*          END;                                                 01S0326
*        ELSE;                                                  01S0327
@RF00301 DS    0H                                               01S0328
*      END;                                                     01S0328
*    ELSE                              /*ERROR UPDATING UCB          */
*      DO;                                                      01S0329
         B     @RC00157                                         01S0329
@RF00157 DS    0H                                               01S0330
*       IF ERRWORD = MTDINELG THEN     /*RETRY OF ALLOCATION NEEDED  */
         CH    ERRWORD,@CH00125                                 01S0330
         BNE   @RF00330                                         01S0330
*         INDRETRY = ON;               /*INDICATE SO IN ALCWA        */
         L     @12,@PC00001+20                                  01S0331
         L     @12,ALCWAPTR(,@12)                               01S0331
         OI    INDRETRY(@12),B'01000000'                        01S0331
*       DSABPTR = SIOTETIO;            /*GET PTR TO DSAB             */
@RF00330 L     @12,@PC00001                                     01S0332
         L     @12,SIOTPTR(,@12)                                01S0332
         L     DSABPTR,SIOTETIO(,@12)                           01S0332
*       TIOEDEVE(EREQRPOS) = ZERO;     /*ZERO DEVICE ENTRY           */
         L     @12,EREQPTR                                      01S0333
         LH    @12,EREQRPOS(,@12)                               01S0333
         SLA   @12,2                                            01S0333
         L     @11,DSABTIOT(,DSABPTR)                           01S0333
         SLR   @08,@08                                          01S0333
         ST    @08,TIOEDEVE-4(@12,@11)                          01S0333
*      END;                                                     01S0334
*  END;                                                         01S0335
*ELSE;                                 /*ERROR BUILDING ETIOT        */
@RF00137 DS    0H                                               01S0337
*IF SU18BIT=ON&                        /*SU 18 IN SYSTEM AND @G18MP21*/
*   VUUCBP^=ZERO &                     /*JES3 CHOSE UNIT     @G18MP21*/
*   ERRWORD=ZERO THEN                  /*UCB ALLOC'D?        @G18MP21*/
@RC00137 L     @12,CVTPTR                                       01S0337
         L     @12,CVTIHASU(,@12)                               01S0337
         TM    SU18BIT(@12),B'00100000'                         01S0337
         BNO   @RF00337                                         01S0337
         SLR   @12,@12                                          01S0337
         L     @11,@PC00001+4                                   01S0337
         L     @11,VUPTR(,@11)                                  01S0337
         C     @12,VUUCBP(,@11)                                 01S0337
         BE    @RF00337                                         01S0337
         CR    ERRWORD,@12                                      01S0337
         BNE   @RF00337                                         01S0337
*  DO;                                 /*PROCESS SU 18       @G18MP21*/
*    DO I=1 TO VUPOOL#                 /*SCAN UCB POOL       @G18MP21*/
*       WHILE UCBPTR^=VUCBS(I);        /*MATCH FOUND?        @G18MP21*/
         LA    I,1                                              01S0339
         B     @DE00339                                         01S0339
@DL00339 L     @12,@PC00001+8                                   01S0339
         LR    @11,I                                            01S0339
         SLA   @11,2                                            01S0339
         L     @08,@PC00001+4                                   01S0339
         L     @08,VUPTR(,@08)                                  01S0339
         L     @08,VUUCBP(,@08)                                 01S0339
         L     @12,UCBPTR(,@12)                                 01S0339
         C     @12,VUCBS-4(@11,@08)                             01S0339
         BE    @DC00339                                         01S0339
*    END;                              /*END SCAN OF UCBS    @G18MP21*/
         AH    I,@CH00057                                       01S0340
@DE00339 L     @12,@PC00001+4                                   01S0340
         L     @12,VUPTR(,@12)                                  01S0340
         L     @12,VUUCBP(,@12)                                 01S0340
         C     I,VUPOOL#(,@12)                                  01S0340
         BNH   @DL00339                                         01S0340
@DC00339 DS    0H                                               01S0341
*    VUGRALCD(I)=ON;                   /*MARK GROUP ID OF UCB   01S0341
*                                        ALLOCATED           @G18MP21*/
         LR    @12,I                                            01S0341
         SLA   @12,3                                            01S0341
         L     @11,@PC00001+4                                   01S0341
         L     @11,VUPTR(,@11)                                  01S0341
         L     @11,VUGRID(,@11)                                 01S0341
         ALR   @11,@12                                          01S0341
         AL    @11,@CF02503                                     01S0341
         OI    VUGRALCD-4(@11),B'10000000'                      01S0341
*  END;                                /*END SU 18 PROCESSING@G18MP21*/
*RETURN CODE(ERRWORD);                 /*PASS RETURN CODE TO CALLER  */
@RF00337 L     @13,4(,@13)                                      01S0343
         L     @00,@SIZDATD                                     01S0343
         LR    @01,@09                                          01S0343
         FSPACE   R,LV=(0),A=(1)
         LR    @15,@06                                          01S0343
         L     @14,12(,@13)                                     01S0343
         LM    @00,@12,20(@13)                                  01S0343
         BR    @14                                              01S0343
*END                                                            01S0344
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (A434SPEC)                                        *
*/*%INCLUDE SYSLIB  (A434DATA)                                        *
*/*%INCLUDE SYSLIB  (BETIODAT)                                        *
*/*%INCLUDE SYSLIB  (IEFZB430)                                        *
*/*%INCLUDE SYSLIB  (BUCBDATA)                                        *
*/*%INCLUDE SYSLIB  (DADSMDAT)                                        *
*/*%INCLUDE SYSLIB  (DAERRDAT)                                        *
*/*%INCLUDE SYSLIB  (IEFZB448)                                        *
*/*%INCLUDE SYSLIB  (IHADSAB )                                        *
*/*%INCLUDE SYSLIB  (IEFTIOT1)                                        *
*/*%INCLUDE SYSLIB  (IEFJFCBN)                                        *
*/*%INCLUDE SYSLIB  (ICHPRCVT)                                        *
*/*%INCLUDE SYSLIB  (CVT     )                                        *
*/*%INCLUDE SYSLIB  (IHASUBIT)                                        *
*/*%INCLUDE SYSLIB  (IHAPSA  )                                        *
*/*%INCLUDE SYSLIB  (IEFASIOT)                                        *
*/*%INCLUDE SYSLIB  (IEFUCBOB)                                        *
*/*%INCLUDE SYSLIB  (IEFZB423)                                        *
*/*%INCLUDE SYSLIB  (IEFZB425)                                        *
*/*%INCLUDE SYSLIB  (IEFZB449)                                        *
*/*%INCLUDE SYSLIB  (IEFZB447)                                        *
*/*%INCLUDE SYSLIB  (PROTTEST)                                        *
*/*%INCLUDE SYSLIB  (PROTSPEC)                                        *
*/*%INCLUDE SYSLIB  (BETIOREQ)                                        *
*/*%INCLUDE SYSLIB  (BETIOSPC)                                        *
*/*%INCLUDE SYSLIB  (BUCBPARM)                                        *
*/*%INCLUDE SYSLIB  (BUCBSPC )                                        *
*/*%INCLUDE SYSLIB  (DADSMINT)                                        *
*/*%INCLUDE SYSLIB  (DADSMSPC)                                        *
*/*%INCLUDE SYSLIB  (DADSMERR)                                        *
*/*%INCLUDE SYSLIB  (DAERRSPC)                                        *
*;                                                              01S0344
@DATA    DS    0H
@CH00057 DC    H'1'
@CH00067 DC    H'16'
@CH00208 DC    H'17'
@CH00125 DC    H'20'
@CH00200 DC    H'33'
@CH00202 DC    H'36'
@CH00204 DC    H'38'
@CH00206 DC    H'48'
@CH00137 DC    H'95'
@CH00135 DC    H'96'
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    8F
@AL00001 DS    5A
IEFAB434 CSECT
         DS    0F
@CF00085 DC    F'4'
@CF02503 DC    F'-4'
@DATD    DSECT
         DS    0D
EREQPTR  DS    A
RETCODE  DS    F
DADSPARM DS    A
TIOTPTR  DS    A
RBSIZE   DS    F
AFUNCMAP DS    BL1
         ORG   AFUNCMAP
VOLSWTCH DS    BL1
UPALOK   EQU   AFUNCMAP+0
@NM00002 EQU   AFUNCMAP+0
         ORG   AFUNCMAP+1
FUNCS    DS    BL1
         ORG   FUNCS
NEWDEV   DS    BL1
ARUFUNC  EQU   FUNCS+0
AFFBIT   EQU   FUNCS+0
AFFOK    EQU   FUNCS+0
@NM00003 EQU   FUNCS+0
         ORG   FUNCS+1
STATUCB  DS    BL1
         ORG   STATUCB
NSRCHUCB DS    BL1
@NM00004 EQU   STATUCB+0
         ORG   STATUCB+1
ETIOTBLK DS    CL42
IEFAB434 CSECT
         DS    0F
@SIZDATD DC    AL1(230)
         DC    AL3(@ENDDATD-@DATD)
@CV00086 DC    V(IEFAB428)
@CV00087 DC    V(IEFAB432)
@CV00088 DC    V(IEFAB435)
@CV00089 DC    V(IEFAB4F2)
         DS    0D
NOUCBVOL DC    X'000000000000'
BLANKS   DC    CL8' '
ERORCODE DC    H'22'
         DC    H'23'
         DC    H'24'
         DC    H'25'
         DC    H'26'
         DC    H'27'
         DC    H'28'
         DC    H'29'
         DC    H'30'
         DC    H'31'
         DC    H'32'
         DC    H'0'
         DC    H'33'
         DC    H'34'
         DC    H'35'
         DC    H'36'
         DC    H'0'
         DC    H'0'
         DC    H'38'
         DC    H'39'
         DC    H'40'
         DC    H'41'
         DC    H'42'
         DC    H'43'
         DC    H'44'
         DC    H'45'
         DC    H'46'
         DC    H'47'
         DC    H'0'
         DC    H'0'
         DC    H'0'
         DC    H'48'
         DC    H'49'
         DC    H'0'
         DC    H'50'
         DC    H'51'
         DC    H'61'
         DC    H'62'
         DC    H'63'
         DC    H'64'
         DC    H'69'
         DC    H'16'
         DC    H'17'
IEFAB434 CSECT
         DS   0H
A434PTCH DC ((@DATA-@PSTART)/20)X'00'
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEFAB434 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
INDEX    EQU   @02
DSABPTR  EQU   @07
I        EQU   @02
ERRWORD  EQU   @06
JFCBPTR  EQU   @08
REG0     EQU   @00
REG1     EQU   @01
REG15    EQU   @15
GPR00P   EQU   @00
GPR01P   EQU   @01
GPR14P   EQU   @14
GPR15P   EQU   @15
GPR13P   EQU   @13
GPR12P   EQU   @12
GPR11P   EQU   @11
GPR00F   EQU   @00
GPR01F   EQU   @01
GPR11F   EQU   @11
GPR12F   EQU   @12
GPR13F   EQU   @13
GPR14F   EQU   @14
GPR15F   EQU   @15
CVTPTR   EQU   16
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSALITA  EQU   PSA+764
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
FAILCODE EQU   0
ETIOTREQ EQU   0
EREQMAP  EQU   ETIOTREQ
EREQBLD  EQU   EREQMAP
EREQUPD  EQU   EREQMAP
EREQSTAT EQU   ETIOTREQ+2
EREQUNAL EQU   EREQSTAT
EREQPASS EQU   EREQSTAT
EREQJSCT EQU   EREQSTAT
EREQCATL EQU   EREQSTAT
EREQDDNM EQU   ETIOTREQ+4
EREQJSVA EQU   ETIOTREQ+12
EREQSSVA EQU   ETIOTREQ+16
EREQSIOT EQU   ETIOTREQ+20
EREQUCB  EQU   ETIOTREQ+24
EREQRPOS EQU   ETIOTREQ+28
EREQDEVS EQU   ETIOTREQ+30
EREQGRID EQU   ETIOTREQ+32
EREQJSCB EQU   ETIOTREQ+36
EREQCODE EQU   ETIOTREQ+40
UCBPARML EQU   0
UCBAD    EQU   UCBPARML
IFLAGS   EQU   UCBPARML+8
VALIDCHK EQU   IFLAGS
UPUSECNT EQU   IFLAGS
UPUSEAT  EQU   IFLAGS
VOLSWOK  EQU   IFLAGS
PUBPRV   EQU   IFLAGS
NOTHPRV  EQU   IFLAGS
DSAB     EQU   0
DSABTIOT EQU   DSAB+16
DSABGIDP EQU   DSAB+24
DSABANMP EQU   DSAB+28
DSABORG  EQU   DSAB+32
DSABORG1 EQU   DSABORG
DSABORG2 EQU   DSABORG+1
DSABFLG1 EQU   DSAB+34
DSABFLG2 EQU   DSAB+35
DSABFLG3 EQU   DSAB+36
DSABFLG4 EQU   DSAB+37
DSABANMI EQU   0
DSABGIDL EQU   0
TIOT1    EQU   0
TIOENTRY EQU   0
TIOESTTA EQU   TIOENTRY+1
TIOERLOC EQU   TIOENTRY+2
TIOELINK EQU   TIOERLOC+1
TIOESYOT EQU   TIOELINK
TIOESTTC EQU   TIOENTRY+15
TIOESTTB EQU   TIOENTRY+16
POOLSTAR EQU   TIOENTRY+20
INFMJFCB EQU   0
JFCBDSNM EQU   INFMJFCB
JFCBELNM EQU   INFMJFCB+44
JFCBTSDM EQU   INFMJFCB+52
JFCFCBID EQU   INFMJFCB+56
JFCBFRID EQU   JFCFCBID
JFCBLTYP EQU   INFMJFCB+66
JFCBOTTR EQU   INFMJFCB+67
JFCBUFOF EQU   JFCBOTTR
JFCBFLSQ EQU   JFCBOTTR+1
JFCFUNC  EQU   JFCBFLSQ
JFCBMASK EQU   INFMJFCB+72
JFCBFLG1 EQU   JFCBMASK+5
JFCOPEN  EQU   JFCBFLG1
JFCBFLG2 EQU   JFCBMASK+6
JFCDEFER EQU   JFCBFLG2
JFCBIND1 EQU   INFMJFCB+86
JFCBIND2 EQU   INFMJFCB+87
JFCAMPTR EQU   INFMJFCB+88
JFCBUFRQ EQU   JFCAMPTR
JFCBUFNO EQU   JFCBUFRQ
JFCBGNCP EQU   JFCAMPTR+1
JFCBHIAR EQU   JFCBGNCP
JFCBFALN EQU   JFCBHIAR
JFCBFTEK EQU   JFCBFALN
JFCBBFTA EQU   JFCBFTEK
JFCEROPT EQU   INFMJFCB+92
JFCTRTCH EQU   INFMJFCB+93
RCVT     EQU   0
RCVTSTAT EQU   RCVT+53
RCVTRNA  EQU   RCVTSTAT
RCVTSTA1 EQU   RCVT+150
RCVTAUOP EQU   RCVT+151
RCVTFLGS EQU   RCVT+153
RCVTROFF EQU   RCVTFLGS
RCVTNDUP EQU   RCVTFLGS
RCVTEROP EQU   RCVT+154
RCVTVERS EQU   RCVT+172
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
SUBITS   EQU   0
SUBYTE1  EQU   SUBITS
SUBYTE2  EQU   SUBITS+1
SUBYTE3  EQU   SUBITS+2
SU18BIT  EQU   SUBYTE3
SUBYTE4  EQU   SUBITS+3
SUBYTE5  EQU   SUBITS+4
SUBYTE6  EQU   SUBITS+5
SUBYTE7  EQU   SUBITS+6
SUBYTE8  EQU   SUBITS+7
SUBYTE9  EQU   SUBITS+8
SUBYTE10 EQU   SUBITS+9
SUBYTE11 EQU   SUBITS+10
SUBYTE12 EQU   SUBITS+11
SUBYTE13 EQU   SUBITS+12
INDMSIOT EQU   0
SIOTDSKA EQU   INDMSIOT
SCTDDNAM EQU   INDMSIOT+4
SCTUSADD EQU   INDMSIOT+20
SCTPJFCB EQU   INDMSIOT+32
SIOTOTUN EQU   INDMSIOT+39
SIOPSCNT EQU   INDMSIOT+42
SIOTBYT1 EQU   INDMSIOT+43
SIODADSM EQU   SIOTBYT1
SIOTBYT3 EQU   INDMSIOT+46
SIOTTSTC EQU   INDMSIOT+47
SIOTBYT0 EQU   INDMSIOT+52
SCTSDISP EQU   INDMSIOT+55
SIOTRETN EQU   SCTSDISP
SIOTPASS EQU   SCTSDISP
SCTSBYT1 EQU   INDMSIOT+56
SIOTCCAT EQU   SCTSBYT1
SIOTJSCT EQU   SCTSBYT1
SCTSBYT2 EQU   INDMSIOT+57
SIOCLUNL EQU   SCTSBYT2
SIOTCATL EQU   SCTSBYT2
SCTSBYT3 EQU   INDMSIOT+58
SCTSBYT4 EQU   INDMSIOT+59
SCTUTYPE EQU   INDMSIOT+60
SIOTDEVT EQU   SCTUTYPE
SIOUBYT3 EQU   SIOTDEVT+2
SIOUCBAD EQU   SCTUTYPE+5
SIOTBYT4 EQU   INDMSIOT+81
SIOTPROT EQU   SIOTBYT4
SIOTRACD EQU   SIOTBYT4
SIOTRACT EQU   SIOTBYT4
SIOTALTD EQU   INDMSIOT+92
SIOTBYT2 EQU   INDMSIOT+103
SIOTRSNC EQU   INDMSIOT+130
SIOTETIO EQU   INDMSIOT+148
SJFCBPTR EQU   INDMSIOT+156
UCB      EQU   0
UCBOB    EQU   0
UCBJBNR  EQU   UCBOB
UCBFL5   EQU   UCBOB+1
UCBAF    EQU   UCBFL5
UCBSTAT  EQU   UCBOB+3
UCBALOC  EQU   UCBSTAT
UCBCHAN  EQU   UCBOB+4
UCBSFLS  EQU   UCBOB+6
UCBFLA   EQU   UCBSFLS
UCBFL1   EQU   UCBFLA
UCBBSY   EQU   UCBFL1
UCBNRY   EQU   UCBFL1
UCBPST   EQU   UCBFL1
UCBCUB   EQU   UCBFL1
UCBFLB   EQU   UCBSFLS+1
UCBCHM   EQU   UCBOB+8
UCBCHM1  EQU   UCBCHM
UCBPTH0  EQU   UCBCHM1
UCBPTH1  EQU   UCBCHM1
UCBWGT   EQU   UCBOB+12
UCBTYP   EQU   UCBOB+16
UCBTBYT1 EQU   UCBTYP
UCB1FEA5 EQU   UCBTBYT1
UCB1FEA6 EQU   UCBTBYT1
UCBTBYT2 EQU   UCBTYP+1
UCB2OPT2 EQU   UCBTBYT2
UCBDUDN1 EQU   UCB2OPT2
UCB2OPT3 EQU   UCBTBYT2
UCBDUDN2 EQU   UCB2OPT3
UCB2OPT4 EQU   UCBTBYT2
UCBRWTAU EQU   UCB2OPT4
UCB2OPT6 EQU   UCBTBYT2
UCB2OPT7 EQU   UCBTBYT2
UCBTBYT3 EQU   UCBTYP+2
UCBDVCLS EQU   UCBTBYT3
UCB3TAPE EQU   UCBDVCLS
UCB3DACC EQU   UCBDVCLS
UCBTBYT4 EQU   UCBTYP+3
UCBEXTPT EQU   UCBOB+20
UCBFLC   EQU   UCBEXTPT
UCBDEV   EQU   UCBOB+24
UCBCMEXT EQU   0
UCBATI   EQU   UCBCMEXT+3
@NM00067 EQU   UCBATI
UCBFLP1  EQU   UCBCMEXT+5
UCBNSRCH EQU   UCBFLP1
UCBASID  EQU   UCBCMEXT+14
UCBMT    EQU   0
UCBOCR   EQU   0
UCB3540X EQU   0
UCBDKBYT EQU   UCB3540X+6
UCB3800X EQU   0
UCBOPTNS EQU   UCB3800X
UCBACTIV EQU   UCB3800X+3
UCBMDRBF EQU   UCB3800X+36
UCBUCS   EQU   0
UCBUCSOP EQU   UCBUCS+4
UCBFCBOP EQU   UCBUCS+5
VOLUNTAB EQU   0
VOLSTAT  EQU   VOLUNTAB+6
VOLSTATA EQU   VOLSTAT
VOLSPEC  EQU   VOLSTATA
VUDADSM  EQU   VOLSTATA
VOLSTATB EQU   VOLSTAT+1
VUAFFWRK EQU   VOLSTATB
VOLSTATC EQU   VOLSTAT+2
VOLSTATD EQU   VOLSTAT+3
VUUCBP   EQU   VOLUNTAB+20
VUGRID   EQU   VOLUNTAB+24
VUPOOL   EQU   0
VUPOOL#  EQU   VUPOOL
VUCBS    EQU   VUPOOL+4
VUGRLST  EQU   0
VUGRLENT EQU   VUGRLST
VUGRLFLG EQU   VUGRLENT+4
VUGRALCD EQU   VUGRLFLG
ALCWA    EQU   0
JSCBPTR  EQU   ALCWA+12
FAILRSCP EQU   ALCWA+20
CNTABLE  EQU   ALCWA+28
INDICATE EQU   ALCWA+112
INDRETRY EQU   INDICATE
ALCWISAM EQU   INDICATE
ALCWADUL EQU   INDICATE
@NM00073 EQU   ALCWA+113
TIOTHDRP EQU   ALCWA+120
EXITPRMP EQU   ALCWA+144
NAMES    EQU   0
PRMESTAE EQU   0
PRMRESC  EQU   PRMESTAE+252
PRMFUNC  EQU   PRMESTAE+253
TIOTBLT  EQU   PRMFUNC
PRMSIOTP EQU   PRMESTAE+256
PRMUCBP  EQU   PRMESTAE+260
IKEBC    EQU   0
IKEBF15  EQU   0
IKEBF31  EQU   0
IKEBP15  EQU   0
IKEBP31  EQU   0
IKEBP8   EQU   0
UCBBGN   EQU   0
SIOTPTR  EQU   0
VUPTR    EQU   0
UCBPTR   EQU   0
INDFLAGS EQU   0
ETIOFLAG EQU   INDFLAGS
USEFLAG  EQU   INDFLAGS
AFFFLAG  EQU   INDFLAGS
VLDFLAG  EQU   INDFLAGS
USEATFLG EQU   INDFLAGS
UPDALGTB EQU   INDFLAGS
OKVOLSW  EQU   INDFLAGS
ETIODATA EQU   0
RELDEVNO EQU   ETIODATA
NUMDEVS  EQU   ETIODATA+2
ALCWAPTR EQU   0
GROUPID  EQU   0
UCBDATAP EQU   0
TIOEDEVE EQU   TIOESTTB
TIOSTTB  EQU   TIOEDEVE
JFCKEYLE EQU   JFCTRTCH
JFCCODE  EQU   JFCKEYLE
JFCSTACK EQU   JFCTRTCH
JFCMODE  EQU   JFCSTACK
JFCSPPRT EQU   JFCTRTCH
JFCBABFS EQU   JFCSPPRT+2
JFCLIMCT EQU   JFCBABFS
JFCDSORG EQU   JFCSPPRT+5
JFCDSRG1 EQU   JFCDSORG
JFCORGIS EQU   JFCDSRG1
JFCDSRG2 EQU   JFCDSORG+1
JFCRECFM EQU   JFCSPPRT+7
JFCRCFM  EQU   JFCRECFM
JFCOPTCD EQU   JFCSPPRT+8
JFCWVCSP EQU   JFCOPTCD
JFCWVCIS EQU   JFCWVCSP
JFCWVCBD EQU   JFCWVCIS
JFCALLOW EQU   JFCOPTCD
JFCRSV17 EQU   JFCALLOW
JFCOVER  EQU   JFCRSV17
JFCPCIBT EQU   JFCOPTCD
JFCMAST  EQU   JFCPCIBT
JFCEXT   EQU   JFCMAST
JFCBCKPT EQU   JFCOPTCD
JFCIND   EQU   JFCBCKPT
JFCRSV18 EQU   JFCOPTCD
JFCCYL   EQU   JFCRSV18
JFCACT   EQU   JFCCYL
JFCREDUC EQU   JFCOPTCD
JFCRSV19 EQU   JFCREDUC
JFCRSV20 EQU   JFCRSV19
JFCRSV21 EQU   JFCOPTCD
JFCDEL   EQU   JFCRSV21
JFCOPTJ  EQU   JFCOPTCD
JFCREORG EQU   JFCOPTJ
JFCBLKSI EQU   JFCSPPRT+9
JFCBUFSI EQU   JFCBLKSI
JFCAMSYN EQU   JFCSPPRT+11
JFCNCP   EQU   JFCAMSYN+2
JFCNTM   EQU   JFCAMSYN+3
JFCBFSEQ EQU   JFCNTM
JFCPCI   EQU   JFCBFSEQ
JFCRESRV EQU   JFCAMSYN+4
JFCUCSEG EQU   JFCRESRV
JFCUCSOP EQU   JFCUCSEG+4
JFCOUTLI EQU   JFCUCSEG+5
JFCTHRSH EQU   JFCOUTLI
JFCCPRI  EQU   JFCTHRSH
JFCBNVOL EQU   JFCUCSEG+9
JFCBVOLS EQU   JFCUCSEG+10
JFCBS001 EQU   JFCBVOLS
JFCBPQTY EQU   JFCBS001+34
JFCBCTRI EQU   JFCBS001+37
JFCBSQTY EQU   JFCBS001+38
JFCFLGS1 EQU   JFCBS001+41
JFCBADSP EQU   JFCFLGS1
JFCBPROT EQU   JFCFLGS1
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
CVTRAC   EQU   CVTS01+644
CVTIHASU EQU   CVTS01+696
PSARSVTE EQU   PSARSVT
UCBOBS01 EQU   UCBDEV
UCBVOLI  EQU   UCBOBS01+4
UCBSTAB  EQU   UCBOBS01+10
UCBBSVL  EQU   UCBSTAB
UCBPRSRS EQU   UCBSTAB
UCBBPRV  EQU   UCBSTAB
UCBBPUB  EQU   UCBSTAB
UCBSHAR  EQU   UCBSTAB
UCBDMCT  EQU   UCBOBS01+11
UCBMOUNT EQU   UCBDMCT
UCBFL4   EQU   UCBOBS01+13
UCBUSER  EQU   UCBOBS01+14
UCBOBS02 EQU   UCBDEV
UCBTFL1  EQU   UCBOBS02+19
UCBXTN   EQU   UCBOBS02+20
UCBVOPT  EQU   UCBXTN
UCBOBS03 EQU   UCBDEV
UCBXTADR EQU   UCBOBS03
UCBOBS04 EQU   UCBDEV
UCBBTA   EQU   UCBOBS04+12
UCBOBS06 EQU   UCBDEV
UCBAOF   EQU   UCBOBS06
UCBAOF1  EQU   UCBAOF
UCBAOF2  EQU   UCBAOF+1
@NM00066 EQU   UCBOBS06+3
UCBIRB   EQU   UCBOBS06+4
UCBGRAF  EQU   UCBIRB
UCBLDNCA EQU   UCBOBS06+8
UCBRDYQ  EQU   UCBLDNCA
UCBIRLN  EQU   UCBRDYQ
UCBLDNCB EQU   UCBRDYQ+1
UCBCTLNK EQU   UCBOBS06+12
UCBOBS07 EQU   UCBDEV
UCBOBS08 EQU   UCBDEV
UCBCTCAD EQU   UCBOBS08
UCBCTCF1 EQU   UCBOBS08+4
UCBOBS09 EQU   UCBDEV
TUNALFLG EQU   TIOESTTB
TIONSRCH EQU   TUNALFLG
TIOPUBPV EQU   TUNALFLG
TIONOPV  EQU   TUNALFLG
FLC      EQU   PSA
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00078 EQU   TUNALFLG+1
TIOUNAL  EQU   TUNALFLG
TIORWND  EQU   TUNALFLG
@NM00077 EQU   TUNALFLG
@NM00076 EQU   TUNALFLG
@NM00075 EQU   TUNALFLG
UCBRV066 EQU   UCBOBS09+4
UCBIOSBA EQU   UCBOBS09
UCBRV042 EQU   UCBOBS08+5
UCBRV082 EQU   UCBCTCF1
UCBRV081 EQU   UCBCTCF1
UCBRV080 EQU   UCBCTCF1
UCBRV079 EQU   UCBCTCF1
UCBRV078 EQU   UCBCTCF1
UCBRV077 EQU   UCBCTCF1
UCBRV076 EQU   UCBCTCF1
UCBCTC80 EQU   UCBCTCF1
UCBCTCAL EQU   UCBCTCAD
UCBICNCB EQU   UCBOBS07+4
UCBRV040 EQU   UCBOBS07
UCBCTLNA EQU   UCBCTLNK+1
UCBRLN   EQU   UCBCTLNK
UCBRDYQA EQU   UCBLDNCB
UCBINRLN EQU   UCBIRLN
UCBIRBA  EQU   UCBIRB+1
UCBRV039 EQU   UCBGRAF
UCBDWNR  EQU   UCBGRAF
UCBRPND  EQU   UCBGRAF
UCBUPM   EQU   UCBGRAF
UCBBTAM  EQU   UCBGRAF
UCBDRNO  EQU   UCBGRAF
UCBDRO   EQU   UCBGRAF
UCBOIP   EQU   UCBGRAF
UCBATRCD EQU   @NM00066
UCBSKPFG EQU   @NM00066
UCBRIPND EQU   @NM00066
UCBRTIAC EQU   @NM00066
UCBRSV79 EQU   @NM00066
UCBRSV78 EQU   @NM00066
UCBRSV77 EQU   @NM00066
UCBOLTEP EQU   @NM00066
UCBATNCT EQU   UCBOBS06+2
UCBRSV76 EQU   UCBAOF2
UCBRSV75 EQU   UCBAOF2
UCBRSV74 EQU   UCBAOF2
UCBRSV73 EQU   UCBAOF2
UCBRSV72 EQU   UCBAOF2
UCBRSV71 EQU   UCBAOF2
UCBRSV70 EQU   UCBAOF2
UCBRSV69 EQU   UCBAOF2
UCBRSV68 EQU   UCBAOF1
UCBRSV67 EQU   UCBAOF1
UCBRSV66 EQU   UCBAOF1
UCBRSV65 EQU   UCBAOF1
UCBRSV64 EQU   UCBAOF1
UCBOFNL  EQU   UCBAOF1
UCBOFSP  EQU   UCBAOF1
UCBOFMCR EQU   UCBAOF1
UCBBTB   EQU   UCBBTA+1
UCBDI    EQU   UCBBTA
UCBSNS   EQU   UCBOBS04+8
UCBTEB   EQU   UCBOBS04+4
UCBGCB   EQU   UCBOBS04+3
UCBOPEN  EQU   UCBOBS04+2
UCBSTART EQU   UCBOBS04
UCBXTNB  EQU   UCBXTN+1
UCBRSV22 EQU   UCBVOPT
UCBRSV21 EQU   UCBVOPT
UCBRSV20 EQU   UCBVOPT
UCBESVE  EQU   UCBVOPT
UCBERPC  EQU   UCBVOPT
UCBESVC  EQU   UCBVOPT
UCBEVA   EQU   UCBVOPT
UCBESV   EQU   UCBVOPT
UCBRV009 EQU   UCBTFL1
UCBRV008 EQU   UCBTFL1
UCBRV007 EQU   UCBTFL1
UCBRV006 EQU   UCBTFL1
UCBRV005 EQU   UCBTFL1
UCBRV038 EQU   UCBTFL1
UCBNSLTP EQU   UCBTFL1
UCBNLTP  EQU   UCBTFL1
UCBRES1B EQU   UCBOBS02+18
UCBFSER  EQU   UCBOBS02+12
@NM00065 EQU   UCBOBS02+4
UCBFSEQ  EQU   UCBOBS02+2
UCBFSCT  EQU   UCBOBS02
UCBNEXP  EQU   UCBOBS01+20
UCBBASE  EQU   UCBOBS01+16
UCBRES1A EQU   UCBOBS01+15
UCBFL47  EQU   UCBFL4
UCBMAT   EQU   UCBFL4
UCBHOLD  EQU   UCBFL4
UCBATTN  EQU   UCBFL4
UCBDSS   EQU   UCBFL4
UCBRESVP EQU   UCBFL4
UCBWDAV  EQU   UCBFL4
UCBDAVV  EQU   UCBFL4
UCBSQC   EQU   UCBOBS01+12
UCBDATP  EQU   UCBOBS01+12
UCBDMC   EQU   UCBDMCT
UCBBNUL  EQU   UCBSTAB
UCBBSTR  EQU   UCBSTAB
UCBBALB  EQU   UCBPRSRS
UCBPGFL  EQU   UCBSTAB
UCBDVSHR EQU   UCBBSVL
UCBVTOC  EQU   UCBOBS01
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
JFCBEND  EQU   JFCBS001+58
JFCBSPTN EQU   JFCBS001+57
JFCBVLCT EQU   JFCBS001+56
JFCBDRLH EQU   JFCBS001+53
JFCBSBNM EQU   JFCBS001+50
JFCBABST EQU   JFCBS001+48
JFCBSPNM EQU   JFCBS001+45
JFCBDQTY EQU   JFCBS001+42
JFCBUAFF EQU   JFCFLGS1
JFCRSV45 EQU   JFCFLGS1
JFCVRDS  EQU   JFCFLGS1
JFCBCEOV EQU   JFCFLGS1
JFCTOPEN EQU   JFCFLGS1
JFCBDLET EQU   JFCFLGS1
JFCRQID  EQU   JFCBSQTY
JFCROUND EQU   JFCBCTRI
JFCALX   EQU   JFCBCTRI
JFCMIXG  EQU   JFCBCTRI
JFCONTIG EQU   JFCBCTRI
JFCRSV29 EQU   JFCBCTRI
JFCBMSGP EQU   JFCBCTRI
JFCBSPAC EQU   JFCBCTRI
JFCRUNIT EQU   JFCBPQTY
JFCBEXAD EQU   JFCBS001+31
JFCBEXTL EQU   JFCBS001+30
JFCMSVGP EQU   JFCBS001+22
@NM00020 EQU   JFCBS001
JFCAVOLS EQU   JFCBVOLS
JFCBNTCS EQU   JFCUCSEG+8
JFCSOWA  EQU   JFCOUTLI+1
JFCSEND  EQU   JFCCPRI
JFCEQUAL EQU   JFCCPRI
JFCRECV  EQU   JFCCPRI
JFCRSV34 EQU   JFCCPRI
JFCRSV33 EQU   JFCCPRI
JFCRSV55 EQU   JFCCPRI
JFCRSV54 EQU   JFCCPRI
JFCRSV53 EQU   JFCCPRI
JFCRSV27 EQU   JFCUCSOP
JFCRSV26 EQU   JFCUCSOP
JFCFCBVR EQU   JFCUCSOP
JFCFCBAL EQU   JFCUCSOP
JFCVER   EQU   JFCUCSOP
JFCRSV25 EQU   JFCUCSOP
JFCFOLD  EQU   JFCUCSOP
JFCBEXTP EQU   JFCUCSOP
JFCUCSID EQU   JFCUCSEG
JFCINTVL EQU   JFCSPPRT+19
JFCDBUFN EQU   JFCRESRV+3
JFCCYLOF EQU   JFCRESRV+2
JFCRKP   EQU   JFCRESRV
JFCPCIR2 EQU   JFCPCI
JFCPCIR1 EQU   JFCPCI
JFCPCIN2 EQU   JFCPCI
JFCPCIN1 EQU   JFCPCI
JFCPCIA2 EQU   JFCPCI
JFCPCIA1 EQU   JFCPCI
JFCPCIX2 EQU   JFCPCI
JFCPCIX1 EQU   JFCPCI
JFCBUFMX EQU   JFCNCP
JFCLRECL EQU   JFCAMSYN
JFCBAXBF EQU   JFCBUFSI
JFCREL   EQU   JFCREORG
JFCRSV22 EQU   JFCDEL
JFCSRCHD EQU   JFCRSV20
JFCOPTQ  EQU   JFCACT
JFCFEED  EQU   JFCIND
JFCCBWU  EQU   JFCEXT
JFCWUMSG EQU   JFCOVER
JFCSDNAM EQU   JFCWVCBD
@NM00019 EQU   JFCRECFM
JFCCHAR  EQU   JFCRECFM
JFCRFS   EQU   JFCRECFM
JFCRFB   EQU   JFCRECFM
JFCRFO   EQU   JFCRCFM
JFCFMREC EQU   JFCRCFM
JFCRSV16 EQU   JFCDSRG2
JFCRSV15 EQU   JFCDSRG2
JFCORGTR EQU   JFCDSRG2
JFCORGAM EQU   JFCDSRG2
JFCRSV13 EQU   JFCDSRG2
JFCORGTQ EQU   JFCDSRG2
JFCORGTX EQU   JFCDSRG2
JFCORGGS EQU   JFCDSRG2
JFCORGU  EQU   JFCDSRG1
JFCORGPO EQU   JFCDSRG1
JFCORGMQ EQU   JFCDSRG1
JFCORGCQ EQU   JFCDSRG1
JFCORGCX EQU   JFCDSRG1
JFCORGDA EQU   JFCDSRG1
JFCORGPS EQU   JFCDSRG1
JFCTRKBL EQU   JFCLIMCT+1
@NM00018 EQU   JFCLIMCT
JFCDEN   EQU   JFCSPPRT+1
JFCPRTSP EQU   JFCSPPRT
JFCONE   EQU   JFCMODE
JFCTWO   EQU   JFCMODE
JFCRSV07 EQU   JFCMODE
JFCRSV06 EQU   JFCMODE
JFCMODER EQU   JFCMODE
JFCMODEO EQU   JFCMODE
JFCEBCD  EQU   JFCMODE
JFCBIN   EQU   JFCMODE
JFCRSV32 EQU   JFCCODE
JFCTTY   EQU   JFCCODE
JFCASCII EQU   JFCCODE
JFCNCR   EQU   JFCCODE
JFCBUR   EQU   JFCCODE
JFCFRI   EQU   JFCCODE
JFCBCD   EQU   JFCCODE
JFCNOCON EQU   JFCCODE
TIOUCBP  EQU   TIOEDEVE+1
TIOVERF  EQU   TIOSTTB
TIOUNLD  EQU   TIOSTTB
TIOMNTD  EQU   TIOSTTB
TIOSETU  EQU   TIOSTTB
TIOVLSR  EQU   TIOSTTB
TIOPVIO  EQU   TIOSTTB
TIOREQD  EQU   TIOSTTB
TIOUSED  EQU   TIOSTTB
@NM00001 EQU   INDFLAGS
PRMNELM  EQU   PRMESTAE+288
PRMDSQF  EQU   PRMESTAE+284
PRMDSQL  EQU   PRMESTAE+280
PRMQDBP  EQU   PRMESTAE+276
PRMQMBP  EQU   PRMESTAE+272
PRMQMBLN EQU   PRMESTAE+268
PRMQMGP  EQU   PRMESTAE+264
PRMASID  EQU   PRMESTAE+254
@NM00081 EQU   PRMFUNC
VMVCALL  EQU   PRMFUNC
FREECORE EQU   PRMFUNC
DUMPOK   EQU   PRMFUNC
DSABCHN  EQU   PRMFUNC
UPDSABCK EQU   PRMFUNC
GENCLNUP EQU   PRMFUNC
@NM00080 EQU   PRMRESC
TPQ      EQU   PRMRESC
DSSUNREC EQU   PRMRESC
DSSTAP   EQU   PRMRESC
CHNGQ    EQU   PRMRESC
DDRQ     EQU   PRMRESC
ENQQ4    EQU   PRMRESC
@NM00079 EQU   PRMESTAE
ALCPROCN EQU   NAMES+16
ALCSTEPN EQU   NAMES+8
ALCJOBN  EQU   NAMES
LOJSSNMP EQU   ALCWA+164
SSERBLKP EQU   ALCWA+160
GROUPSZ  EQU   ALCWA+156
GRIDPTR  EQU   ALCWA+152
ALCNUCBS EQU   ALCWA+148
CANCELP  EQU   ALCWA+140
WORK3MP  EQU   ALCWA+136
WMASK2P  EQU   ALCWA+132
WMASKPTR EQU   ALCWA+128
LGENLOCK EQU   ALCWA+124
TCBP     EQU   ALCWA+116
ALCWASID EQU   ALCWA+114
@NM00074 EQU   @NM00073
NODEVERR EQU   @NM00073
NEEDRCVY EQU   @NM00073
ALCWAREC EQU   @NM00073
WAITIGEN EQU   @NM00073
UNITRECS EQU   @NM00073
DSSUNIT  EQU   INDICATE
DSSTAPE  EQU   INDICATE
PRIVASUM EQU   INDICATE
INDREQU  EQU   INDICATE
INDWAIT  EQU   INDICATE
QMGRRBP  EQU   ALCWA+108
RIMTABCT EQU   ALCWA+104
RIMTABLN EQU   ALCWA+100
RIMTABP  EQU   ALCWA+96
ALGTABSZ EQU   ALCWA+92
ALGTABP  EQU   ALCWA+88
VOLUNSZE EQU   ALCWA+84
VOLUNPTR EQU   ALCWA+80
@NM00072 EQU   ALCWA+78
LTUNITID EQU   ALCWA+76
TOTVOLUN EQU   CNTABLE+44
NUMREQS  EQU   CNTABLE+40
TOTREQS  EQU   CNTABLE+36
OTHEREQS EQU   CNTABLE+32
SUBSREQS EQU   CNTABLE+28
STRGREQS EQU   CNTABLE+24
PUBLREQS EQU   CNTABLE+20
PVTNREQS EQU   CNTABLE+16
SPECREQS EQU   CNTABLE+12
TPREQS   EQU   CNTABLE+8
VAMREQS  EQU   CNTABLE+4
DMYREQS  EQU   CNTABLE
EDTABPTR EQU   ALCWA+24
IOSLUTP  EQU   ALCWA+16
SIOT1P   EQU   ALCWA+8
FMAPPTR  EQU   ALCWA+4
WASIZE   EQU   ALCWA
@NM00071 EQU   VUGRLENT+5
@NM00070 EQU   VUGRLFLG
VUGRLIDS EQU   VUGRLENT
VOLSIOTP EQU   VOLUNTAB+16
VOLALGTP EQU   VOLUNTAB+12
VOLUNTID EQU   VOLUNTAB+10
VURCVYPR EQU   VOLSTATD
VUVLUNIQ EQU   VOLSTATD
VUDMUNIQ EQU   VOLSTATD
VUUNALSW EQU   VOLSTATD
VUDMNDAL EQU   VOLSTATD
VUDMNDOF EQU   VOLSTATD
VUREALOC EQU   VOLSTATD
VUMUGDON EQU   VOLSTATD
@NM00069 EQU   VOLSTATC
@NM00068 EQU   VOLSTATC
VURECVRY EQU   VOLSTATC
VOLURREQ EQU   VOLSTATC
VOLGRREQ EQU   VOLSTATC
VOLDAREQ EQU   VOLSTATC
VOLCOREQ EQU   VOLSTATC
VOLTAREQ EQU   VOLSTATC
VUVINELG EQU   VOLSTATB
VUDADSME EQU   VOLSTATB
VUDNALOC EQU   VOLSTATB
VUPROCED EQU   VOLSTATB
VDEVREQD EQU   VOLSTATB
VOLMNTD  EQU   VOLSTATB
VOLALOC  EQU   VOLSTATB
VOLDEFER EQU   VOLSTATA
VOLRESVE EQU   VOLSTATA
VOLNSHR  EQU   VOLSTATA
VOLSTG   EQU   VOLSTATA
VOLPRV   EQU   VOLSTATA
VOLPUB   EQU   VOLSTATA
VOLID    EQU   VOLUNTAB
UCBERADR EQU   UCBUCS+12
UCBFCBID EQU   UCBUCS+8
UCBERCNT EQU   UCBUCS+7
UCBRSV51 EQU   UCBUCS+6
UCBRSV50 EQU   UCBFCBOP
UCBRSV49 EQU   UCBFCBOP
UCBRSV48 EQU   UCBFCBOP
UCBRSV47 EQU   UCBFCBOP
UCBRSV46 EQU   UCBFCBOP
UCBRSV45 EQU   UCBFCBOP
UCBRSV44 EQU   UCBFCBOP
UCBFCBO1 EQU   UCBFCBOP
UCBUCSPE EQU   UCBUCSOP
UCBRSV43 EQU   UCBUCSOP
UCBRSV42 EQU   UCBUCSOP
UCBRSV41 EQU   UCBUCSOP
UCBRSV40 EQU   UCBUCSOP
UCBRSV39 EQU   UCBUCSOP
UCBUCSO2 EQU   UCBUCSOP
UCBUCSO1 EQU   UCBUCSOP
UCBUCSID EQU   UCBUCS
UCBMDRBA EQU   UCBMDRBF+1
UCBRV075 EQU   UCBMDRBF
UCBRV074 EQU   UCB3800X+32
UCBIMAGE EQU   UCB3800X+28
UCBFCBNM EQU   UCB3800X+24
UCBCHAR4 EQU   UCB3800X+20
UCBCHAR3 EQU   UCB3800X+16
UCBCHAR2 EQU   UCB3800X+12
UCBCHAR1 EQU   UCB3800X+8
UCBCGMID EQU   UCB3800X+4
UCBBRSTA EQU   UCBACTIV
UCBRV063 EQU   UCBACTIV
UCBRV062 EQU   UCBACTIV
UCBRV061 EQU   UCBACTIV
UCBRV060 EQU   UCBACTIV
UCBRV059 EQU   UCBACTIV
UCBRV058 EQU   UCBACTIV
UCBRV057 EQU   UCBACTIV
UCBRV050 EQU   UCB3800X+2
UCBCGMNO EQU   UCB3800X+1
UCBRV083 EQU   UCBOPTNS
UCBBRSTR EQU   UCBOPTNS
UCBRV056 EQU   UCBOPTNS
UCBRV055 EQU   UCBOPTNS
UCBRV054 EQU   UCBOPTNS
UCBRV053 EQU   UCBOPTNS
UCBRV052 EQU   UCBOPTNS
UCBRV051 EQU   UCBOPTNS
UCBRV073 EQU   UCB3540X+7
UCBRV072 EQU   UCBDKBYT
UCBRV071 EQU   UCBDKBYT
UCBRV070 EQU   UCBDKBYT
UCBRV069 EQU   UCBDKBYT
UCBRV068 EQU   UCBDKBYT
UCBRV067 EQU   UCBDKBYT
UCBVLVER EQU   UCBDKBYT
UCBDKAMX EQU   UCBDKBYT
UCBVLSER EQU   UCB3540X
UCBRDATA EQU   UCBOCR+4
UCBFRID  EQU   UCBOCR
UCBCLN   EQU   UCBMT+14
UCBERG   EQU   UCBMT+12
UCBMS    EQU   UCBMT+11
UCBNB    EQU   UCBMT+10
UCBPW    EQU   UCBMT+9
UCBPR    EQU   UCBMT+8
UCBSIO   EQU   UCBMT+6
UCBTW    EQU   UCBMT+5
UCBTR    EQU   UCBMT+4
UCBTWT   EQU   UCBMT+3
UCBTRT   EQU   UCBMT+2
UCBCTD   EQU   UCBMT
UCBWTOID EQU   UCBCMEXT+17
UCBMIHTI EQU   UCBCMEXT+16
UCBMFCNT EQU   UCBCMEXT+12
UCBPMSK  EQU   UCBCMEXT+10
UCBCCWOF EQU   UCBCMEXT+8
UCBRV041 EQU   UCBCMEXT+6
UCBRV036 EQU   UCBFLP1
UCBRV035 EQU   UCBFLP1
UCBERLOG EQU   UCBFLP1
UCBRV033 EQU   UCBFLP1
UCBINHIO EQU   UCBFLP1
UCBNSWAP EQU   UCBFLP1
UCBSHRUP EQU   UCBFLP1
UCBSNSCT EQU   UCBCMEXT+4
UCBHPDV  EQU   @NM00067
UCBHALI  EQU   @NM00067
UCBRSV09 EQU   @NM00067
UCBRSV08 EQU   @NM00067
UCBRSV07 EQU   @NM00067
UCBRSV06 EQU   @NM00067
UCBRSV05 EQU   @NM00067
UCBRSV04 EQU   @NM00067
UCBDTI   EQU   UCBCMEXT+2
UCBSTI   EQU   UCBCMEXT+1
UCBETI   EQU   UCBCMEXT
UCBEXTP  EQU   UCBEXTPT+1
UCBDDRSW EQU   UCBFLC
UCBTICBT EQU   UCBFLC
UCBIVRR  EQU   UCBFLC
UCBIVRS  EQU   UCBFLC
UCBITF   EQU   UCBFLC
UCBUDE   EQU   UCBFLC
UCBWAA   EQU   UCBFLC
UCBATTP  EQU   UCBFLC
UCBUNTYP EQU   UCBTBYT4
UCBRSV11 EQU   UCBDVCLS
UCBRSV10 EQU   UCBDVCLS
UCB3CHAR EQU   UCBDVCLS
UCB3UREC EQU   UCBDVCLS
UCB3DISP EQU   UCBDVCLS
UCB3COMM EQU   UCBDVCLS
UCBDVPWR EQU   UCB2OPT7
UCBVLPWR EQU   UCB2OPT6
UCB2OPT5 EQU   UCBTBYT2
UCBRVDEV EQU   UCBRWTAU
UCBRPS   EQU   UCBDUDN2
UCBRR    EQU   UCBDUDN1
UCB2OPT1 EQU   UCBTBYT2
UCB2OPT0 EQU   UCBTBYT2
UCB1FEA7 EQU   UCBTBYT1
UCBD6250 EQU   UCB1FEA6
UCBD1600 EQU   UCB1FEA5
UCB1FEA4 EQU   UCBTBYT1
UCB1FEA3 EQU   UCBTBYT1
UCB1FEA2 EQU   UCBTBYT1
UCB1FEA1 EQU   UCBTBYT1
UCB1FEA0 EQU   UCBTBYT1
UCBNAME  EQU   UCBOB+13
UCBRV029 EQU   UCBWGT
UCBVHRSN EQU   UCBWGT
UCBVORSN EQU   UCBWGT
UCBMTPXP EQU   UCBWGT
UCBREW   EQU   UCBWGT
UCBPUB   EQU   UCBWGT
UCBOUT   EQU   UCBWGT
UCBIN    EQU   UCBWGT
UCBCPU   EQU   UCBOB+11
UCBLCI   EQU   UCBOB+10
UCBCNT   EQU   UCBOB+9
UCBRV017 EQU   UCBCHM1
UCBRV016 EQU   UCBCHM1
UCBRV015 EQU   UCBCHM1
UCBRV014 EQU   UCBCHM1
UCBSPB   EQU   UCBPTH1
UCBPPB   EQU   UCBPTH1
UCBSPA   EQU   UCBPTH0
UCBPPA   EQU   UCBPTH0
UCBSIGP  EQU   UCBFLB
UCBVALPH EQU   UCBFLB
UCBCRHSN EQU   UCBFLB
UCBCRHRV EQU   UCBFLB
UCBRESVH EQU   UCBFLB
UCBSPST  EQU   UCBFLB
UCBASNS  EQU   UCBFLB
UCBIORST EQU   UCBFLB
UCBQISCE EQU   UCBFL1
UCBACTV  EQU   UCBFL1
UCBSAP   EQU   UCBFL1
UCBNOTRC EQU   UCBCUB
UCBPSNS  EQU   UCBFL1
UCBUSING EQU   UCBPST
UCBNOTRD EQU   UCBNRY
UCBBUSYD EQU   UCBBSY
UCBUA    EQU   UCBCHAN+1
UCBCHA   EQU   UCBCHAN
UCBDADI  EQU   UCBSTAT
UCBSYSR  EQU   UCBSTAT
UCBPRES  EQU   UCBSTAT
UCBUNLD  EQU   UCBSTAT
UCBRESV  EQU   UCBSTAT
UCBCHGS  EQU   UCBSTAT
UCBONLI  EQU   UCBSTAT
UCBID    EQU   UCBOB+2
UCBALTPH EQU   UCBFL5
UCBALTCU EQU   UCBFL5
UCBNALOC EQU   UCBFL5
UCBENVRD EQU   UCBFL5
UCBVSDR  EQU   UCBFL5
UCBSASK  EQU   UCBFL5
UCBAMV   EQU   UCBAF
UCBDCC   EQU   UCBFL5
UCBMONT  EQU   UCBJBNR
UCBRV011 EQU   UCBJBNR
UCBMMSGP EQU   UCBJBNR
UCBOLDSM EQU   UCBJBNR
UCBRV003 EQU   UCBJBNR
UCBDUC   EQU   UCBJBNR
UCBJES3  EQU   UCBJBNR
UCBVRDEV EQU   UCBJBNR
UCBCMSEG EQU   UCBOB
UCBPFXND EQU   UCB+512
UCBIOQ   EQU   UCB+508
UCBLOCK  EQU   UCB+504
UCBPXST  EQU   UCB+504
@NM00064 EQU   UCB
SIODDSNL EQU   INDMSIOT+173
SIOVDSNL EQU   INDMSIOT+172
SIOVDSNT EQU   INDMSIOT+170
SVOLUNNO EQU   INDMSIOT+168
SIOTVMVP EQU   INDMSIOT+164
SIOTJFX  EQU   INDMSIOT+160
SIOTNPTR EQU   INDMSIOT+152
SIOTATE  EQU   INDMSIOT+144
SVOLUNAD EQU   INDMSIOT+140
SIOTEDLP EQU   INDMSIOT+136
SIOTEDLS EQU   INDMSIOT+132
SCTANAME EQU   INDMSIOT+122
SIOTSSIC EQU   INDMSIOT+120
@NM00063 EQU   INDMSIOT+108
SIOTSSNM EQU   INDMSIOT+104
@NM00062 EQU   SIOTBYT2
SIOTCVOL EQU   SIOTBYT2
SIOTCNEW EQU   SIOTBYT2
SIOTCALC EQU   SIOTBYT2
SIOTGALL EQU   SIOTBYT2
SIOTDSPD EQU   SIOTBYT2
SIOTDMND EQU   SIOTBYT2
SIOTOPUC EQU   INDMSIOT+99
SIOTOUTR EQU   INDMSIOT+97
SIOTOUTC EQU   INDMSIOT+96
SIOTSSWA EQU   INDMSIOT+93
SIOTAUNC EQU   SIOTALTD
SIOTACAT EQU   SIOTALTD
SIOTADEL EQU   SIOTALTD
SIOTAKEP EQU   SIOTALTD
SIOTNPRV EQU   SIOTALTD
SIOJCATS EQU   SIOTALTD
@NM00061 EQU   SIOTALTD
@NM00060 EQU   SIOTALTD
@NM00059 EQU   INDMSIOT+91
SIOTNDSB EQU   INDMSIOT+88
@NM00058 EQU   INDMSIOT+84
SIOTDPCD EQU   INDMSIOT+82
@NM00057 EQU   SIOTBYT4
SCTOUTPN EQU   INDMSIOT+80
SCTOUTNO EQU   INDMSIOT+76
SCTOUTNM EQU   INDMSIOT+68
SIOUCNVT EQU   SCTUTYPE+4
SIOUBYT4 EQU   SIOTDEVT+3
@NM00056 EQU   SIOUBYT3
SIO3UREC EQU   SIOUBYT3
SIO3DISP EQU   SIOUBYT3
SIO3DACC EQU   SIOUBYT3
SIO3COMM EQU   SIOUBYT3
SIO3TAPE EQU   SIOUBYT3
SIOUBYT2 EQU   SIOTDEVT+1
SIOUBYT1 EQU   SIOTDEVT
SIOTOMN  EQU   SCTSBYT4
SIOTIPDI EQU   SCTSBYT4
SIOTVAFF EQU   SCTSBYT4
SIOTSTEP EQU   SCTSBYT4
SIOTASCI EQU   SCTSBYT4
@NM00055 EQU   SCTSBYT4
SIOTGDGA EQU   SCTSBYT4
SCTSGDGS EQU   SCTSBYT4
SCTSOLD  EQU   SCTSBYT3
SCTSMOD  EQU   SCTSBYT3
SCTSNEW  EQU   SCTSBYT3
SCTSYSOU EQU   SCTSBYT3
SCTVREF  EQU   SCTSBYT3
SCTALCHK EQU   SCTSBYT3
SCTSYSNE EQU   SCTSBYT3
SCTDSNRF EQU   SCTSBYT3
SCTRECVD EQU   SCTSBYT2
SCTDEFER EQU   SCTSBYT2
SCTLABEL EQU   SCTSBYT2
SCTUNLBD EQU   SCTSBYT2
SCTJOBLB EQU   SCTSBYT2
SCTVOLAF EQU   SCTSBYT2
SCTUNAFF EQU   SCTSBYT1
SCTPARLM EQU   SCTSBYT1
SIOTQDSN EQU   SCTSBYT1
SIOTGDSN EQU   SCTSBYT1
SCTSYSIN EQU   SCTSBYT1
SCTDUMMY EQU   SCTSBYT1
SIOTUNCT EQU   SCTSDISP
SIOTCTLG EQU   SCTSDISP
SIOTDLET EQU   SCTSDISP
SIOTKEEP EQU   SCTSDISP
SIOTPRIV EQU   SCTSDISP
S3400DSP EQU   SCTSDISP
SIOTVLCT EQU   INDMSIOT+54
SCTNMBUT EQU   INDMSIOT+53
SIOTRTRY EQU   SIOTBYT0
SIOTPUPV EQU   SIOTBYT0
SIOTNOPV EQU   SIOTBYT0
SIOTGIGN EQU   SIOTBYT0
SPVTAMSG EQU   SIOTBYT0
SIOTFUDA EQU   SIOTBYT0
SIOTDYAL EQU   SIOTBYT0
SIOTSSDS EQU   SIOTBYT0
SIOTGIID EQU   INDMSIOT+50
SCTVOLCT EQU   INDMSIOT+49
SCTSPOOL EQU   INDMSIOT+48
SIOTQNAM EQU   SIOTTSTC
SIOTDSNM EQU   SIOTTSTC
SIOTTRKM EQU   SIOTTSTC
SIOTSSMG EQU   SIOTTSTC
SIOTSSGP EQU   SIOTTSTC
@NM00054 EQU   SIOTTSTC
SIOTTERM EQU   SIOTTSTC
SIOTINFC EQU   SIOTTSTC
@NM00053 EQU   SIOTBYT3
S3400OFF EQU   SIOTBYT3
SIOTJES3 EQU   SIOTBYT3
SIOCDEVT EQU   SIOTBYT3
SIOALIAS EQU   SIOTBYT3
SCTDDINO EQU   INDMSIOT+44
SIOTDDNT EQU   SIOTBYT1
SIOTALCD EQU   SIOTBYT1
SIOTDADR EQU   SIOTBYT1
SIODUNAL EQU   SIOTBYT1
SIOVAMDS EQU   SIOTBYT1
SIOTHOLD EQU   SIOTBYT1
SIOTOCKP EQU   SIOTBYT1
SIOTREFN EQU   INDMSIOT+40
SIOTVRSB EQU   INDMSIOT+36
@NM00052 EQU   INDMSIOT+35
@NM00051 EQU   INDMSIOT+31
SCTPSIOT EQU   INDMSIOT+28
SIOTAFID EQU   INDMSIOT+26
SIOTVLSP EQU   INDMSIOT+24
SIODSNTE EQU   INDMSIOT+22
SIOTUNAF EQU   SCTUSADD
SIOTDEST EQU   INDMSIOT+12
SIOTTYPE EQU   INDMSIOT+3
SURV104  EQU   SUBITS+13
SURV103  EQU   SUBYTE13
SURV102  EQU   SUBYTE13
SURV101  EQU   SUBYTE13
SU100BT  EQU   SUBYTE13
SU99BIT  EQU   SUBYTE13
SU98BIT  EQU   SUBYTE13
SU97BIT  EQU   SUBYTE13
SU96BIT  EQU   SUBYTE13
SU95BIT  EQU   SUBYTE12
SU94BIT  EQU   SUBYTE12
SU93BIT  EQU   SUBYTE12
SU92BIT  EQU   SUBYTE12
SU91BIT  EQU   SUBYTE12
SU90BIT  EQU   SUBYTE12
SU89BIT  EQU   SUBYTE12
SU88BIT  EQU   SUBYTE12
SU87BIT  EQU   SUBYTE11
SU86BIT  EQU   SUBYTE11
SU85BIT  EQU   SUBYTE11
SU84BIT  EQU   SUBYTE11
SU83BIT  EQU   SUBYTE11
SU82BIT  EQU   SUBYTE11
SU81BIT  EQU   SUBYTE11
SU80BIT  EQU   SUBYTE11
SU79BIT  EQU   SUBYTE10
SU78BIT  EQU   SUBYTE10
SU77BIT  EQU   SUBYTE10
SU76BIT  EQU   SUBYTE10
SU75BIT  EQU   SUBYTE10
SU74BIT  EQU   SUBYTE10
SU73BIT  EQU   SUBYTE10
SU72BIT  EQU   SUBYTE10
SU71BIT  EQU   SUBYTE9
SU70BIT  EQU   SUBYTE9
SU69BIT  EQU   SUBYTE9
SU68BIT  EQU   SUBYTE9
SU67BIT  EQU   SUBYTE9
SU66BIT  EQU   SUBYTE9
SU65BIT  EQU   SUBYTE9
SU64BIT  EQU   SUBYTE9
SU63BIT  EQU   SUBYTE8
SU62BIT  EQU   SUBYTE8
SU61BIT  EQU   SUBYTE8
SU60BIT  EQU   SUBYTE8
SU59BIT  EQU   SUBYTE8
SU58BIT  EQU   SUBYTE8
SU57BIT  EQU   SUBYTE8
SU56BIT  EQU   SUBYTE8
SU55BIT  EQU   SUBYTE7
SU54BIT  EQU   SUBYTE7
SU53BIT  EQU   SUBYTE7
SU52BIT  EQU   SUBYTE7
SU51BIT  EQU   SUBYTE7
SU50BIT  EQU   SUBYTE7
SU49BIT  EQU   SUBYTE7
SU48BIT  EQU   SUBYTE7
SU47BIT  EQU   SUBYTE6
SU46BIT  EQU   SUBYTE6
SU45BIT  EQU   SUBYTE6
SU44BIT  EQU   SUBYTE6
SU43BIT  EQU   SUBYTE6
SU42BIT  EQU   SUBYTE6
SU41BIT  EQU   SUBYTE6
SU40BIT  EQU   SUBYTE6
SU39BIT  EQU   SUBYTE5
SU38BIT  EQU   SUBYTE5
SU37BIT  EQU   SUBYTE5
SU36BIT  EQU   SUBYTE5
SU35BIT  EQU   SUBYTE5
SU34BIT  EQU   SUBYTE5
SU33BIT  EQU   SUBYTE5
SU32BIT  EQU   SUBYTE5
SU31BIT  EQU   SUBYTE4
SU30BIT  EQU   SUBYTE4
SU29BIT  EQU   SUBYTE4
SU28BIT  EQU   SUBYTE4
SU27BIT  EQU   SUBYTE4
SU26BIT  EQU   SUBYTE4
SU25BIT  EQU   SUBYTE4
SU24BIT  EQU   SUBYTE4
SU23BIT  EQU   SUBYTE3
SU22BIT  EQU   SUBYTE3
SU21BIT  EQU   SUBYTE3
SU20BIT  EQU   SUBYTE3
SU19BIT  EQU   SUBYTE3
SU17BIT  EQU   SUBYTE3
SU16BIT  EQU   SUBYTE3
SU15BIT  EQU   SUBYTE2
SU14BIT  EQU   SUBYTE2
SU13BIT  EQU   SUBYTE2
SU12BIT  EQU   SUBYTE2
SU11BIT  EQU   SUBYTE2
SU10BIT  EQU   SUBYTE2
SU9BIT   EQU   SUBYTE2
SU8BIT   EQU   SUBYTE2
SU7BIT   EQU   SUBYTE1
SU6BIT   EQU   SUBYTE1
SU5BIT   EQU   SUBYTE1
SU4BIT   EQU   SUBYTE1
SU3BIT   EQU   SUBYTE1
SU2BIT   EQU   SUBYTE1
SU1BIT   EQU   SUBYTE1
SU0BIT   EQU   SUBYTE1
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00026 EQU   CVTFIX+248
@NM00025 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
RCVTEXTA EQU   RCVT+173
RCVTRID0 EQU   RCVT+168
RCVTRCXP EQU   RCVT+164
RCVTRIXP EQU   RCVT+160
RCVTRAU0 EQU   RCVT+156
RCVTPINV EQU   RCVT+155
@NM00024 EQU   RCVTEROP
RCVTSAUD EQU   RCVTEROP
RCVTAVIO EQU   RCVTEROP
RCVTTUAC EQU   RCVTEROP
RCVTTERP EQU   RCVTEROP
RCVTSHR  EQU   RCVTFLGS
RCVTRDHD EQU   RCVTFLGS
RCVTAXTA EQU   RCVT+152
RCVTATER EQU   RCVTAUOP
RCVTATAP EQU   RCVTAUOP
RCVTADAS EQU   RCVTAUOP
RCVTADAT EQU   RCVTAUOP
RCVTAUSE EQU   RCVTAUOP
RCVTAGRO EQU   RCVTAUOP
@NM00023 EQU   RCVTAUOP
@NM00022 EQU   RCVTSTA1
RCVTTAPE EQU   RCVTSTA1
RCVTUVOL EQU   RCVT+144
RCVTUADS EQU   RCVT+100
RCVTDSN  EQU   RCVT+56
RCVTNREC EQU   RCVT+54
@NM00021 EQU   RCVTSTAT
RCVTNTMS EQU   RCVTSTAT
RCVTNDVS EQU   RCVTSTAT
RCVTNTVS EQU   RCVTSTAT
RCVTNDSS EQU   RCVTSTAT
RCVTNLS  EQU   RCVTSTAT
RCVTDSNL EQU   RCVT+52
RCVTISTL EQU   RCVT+48
RCVTBAM  EQU   RCVT+44
RCVTXLEN EQU   RCVT+40
RCVTRUCB EQU   RCVT+36
RCVTRDX  EQU   RCVT+32
RCVTRCX  EQU   RCVT+28
RCVTRIX  EQU   RCVT+24
RCVTHDR  EQU   RCVT+20
RCVTTEMP EQU   RCVT+16
RCVTINDX EQU   RCVT+12
RCVTDEB  EQU   RCVT+8
RCVTDCB  EQU   RCVT+4
RCVTID   EQU   RCVT
JFCRSV05 EQU   JFCEROPT
JFCRSV04 EQU   JFCEROPT
JFCRSV03 EQU   JFCEROPT
JFCRSV02 EQU   JFCEROPT
JFCTOPT  EQU   JFCEROPT
JFCABN   EQU   JFCEROPT
JFCSKP   EQU   JFCEROPT
JFCACC   EQU   JFCEROPT
JFCBUFL  EQU   JFCAMPTR+2
JFCFWORD EQU   JFCBFTEK
JFCDWORD EQU   JFCBFTEK
JFCHIER1 EQU   JFCBFTEK
JFCDYN   EQU   JFCBFTEK
JFCEXC   EQU   JFCBFTEK
JFCBBFTR EQU   JFCBBFTA
JFCSIM   EQU   JFCBBFTA
JFCHIER  EQU   JFCBFTEK
JFCBFOUT EQU   JFCBUFNO
JFCBUFIN EQU   JFCBUFNO
JFCTEMP  EQU   JFCBIND2
JFCREQ   EQU   JFCBIND2
JFCENT   EQU   JFCBIND2
JFCSHARE EQU   JFCBIND2
JFCSECUR EQU   JFCBIND2
JFCDISP  EQU   JFCBIND2
JFCPDS   EQU   JFCBIND1
JFCGDG   EQU   JFCBIND1
JFCADDED EQU   JFCBIND1
JFCLOC   EQU   JFCBIND1
JFCRLSE  EQU   JFCBIND1
JFCBXPDT EQU   INFMJFCB+83
JFCBCRDT EQU   INFMJFCB+80
JFCBOPS2 EQU   JFCBMASK+7
JFCRCTLG EQU   JFCBFLG2
JFCBBUFF EQU   JFCBFLG2
JFCTRACE EQU   JFCBFLG2
JFCSDRPS EQU   JFCBFLG2
JFCMODNW EQU   JFCBFLG2
JFCNRPS  EQU   JFCDEFER
JFCOUTOP EQU   JFCBFLG2
JFCINOP  EQU   JFCBFLG2
JFCBPWBP EQU   JFCOPEN
@NM00017 EQU   JFCOPEN
JFCDUAL  EQU   JFCBFLG1
JFCSLDES EQU   JFCBFLG1
JFCSLCRE EQU   JFCBFLG1
JFCSTAND EQU   JFCBFLG1
JFCBOPS1 EQU   JFCBMASK
JFCBVLSQ EQU   INFMJFCB+70
JFCRSV31 EQU   JFCFUNC
JFCFNCBT EQU   JFCFUNC
JFCFNCBX EQU   JFCFUNC
JFCFNCBD EQU   JFCFUNC
JFCFNCBW EQU   JFCFUNC
JFCFNCBP EQU   JFCFUNC
JFCFNCBR EQU   JFCFUNC
JFCFNCBI EQU   JFCFUNC
JFCBFOFL EQU   JFCBUFOF
JFCNL    EQU   JFCBLTYP
JFCSL    EQU   JFCBLTYP
JFCNSL   EQU   JFCBLTYP
JFCSUL   EQU   JFCBLTYP
JFCBLP   EQU   JFCBLTYP
JFCBLTM  EQU   JFCBLTYP
JFCBAL   EQU   JFCBLTYP
JFCRSV38 EQU   JFCBLTYP
JFCVINDX EQU   INFMJFCB+64
JFCNLREC EQU   INFMJFCB+62
JFCBADBF EQU   INFMJFCB+60
JFCAMSTR EQU   JFCBFRID+2
JFCAMCRO EQU   JFCBFRID
JFCBDSCB EQU   INFMJFCB+53
JFCPAT   EQU   JFCBTSDM
JFCNDCB  EQU   JFCBTSDM
JFCNDSCB EQU   JFCBTSDM
JFCNWRIT EQU   JFCBTSDM
JFCTTR   EQU   JFCBTSDM
JFCSDS   EQU   JFCBTSDM
JFCVSL   EQU   JFCBTSDM
JFCCAT   EQU   JFCBTSDM
JFCIPLTX EQU   JFCBELNM
JFCBQNAM EQU   JFCBDSNM
TIOTFEND EQU   POOLSTAR+16
TIOPSLOT EQU   POOLSTAR+13
TIOPSTTB EQU   POOLSTAR+12
TIOPPOOL EQU   POOLSTAR+4
TIOPNSRT EQU   POOLSTAR+3
@NM00016 EQU   POOLSTAR+2
TIOPNSLT EQU   POOLSTAR+1
@NM00015 EQU   POOLSTAR
TIOEFSRT EQU   TIOENTRY+17
TIOSVERF EQU   TIOESTTB
TIOSUNLD EQU   TIOESTTB
TIOSMNTD EQU   TIOESTTB
TIOSSETU EQU   TIOESTTB
TIOSVLSR EQU   TIOESTTB
TIOSPVIO EQU   TIOESTTB
TIOSREQD EQU   TIOESTTB
TIOSUSED EQU   TIOESTTB
TIOSBALS EQU   TIOESTTC
TIOSBALP EQU   TIOESTTC
TIOSVOLS EQU   TIOESTTC
TIOSVOLP EQU   TIOESTTC
TIOSAFFS EQU   TIOESTTC
TIOSAFFP EQU   TIOESTTC
TIOSDEFR EQU   TIOESTTC
TIOSDKCR EQU   TIOESTTC
TIOEJFCB EQU   TIOENTRY+12
TIOEDDNM EQU   TIOENTRY+4
TIOTREM  EQU   TIOELINK
TIOESSDS EQU   TIOESYOT
TIOESYIN EQU   TIOELINK
TIOEQNAM EQU   TIOELINK
TIOEDYNM EQU   TIOELINK
TIOTTERM EQU   TIOELINK
TIOTRV01 EQU   TIOELINK
TIOSYOUT EQU   TIOELINK
TIOEWTCT EQU   TIOERLOC
TIOSDSP2 EQU   TIOESTTA
TIOSDSP1 EQU   TIOESTTA
TIOSLABL EQU   TIOESTTA
TIOSDADS EQU   TIOESTTA
TIOSJBLB EQU   TIOESTTA
TIOSPLTS EQU   TIOESTTA
TIOSPLTP EQU   TIOESTTA
TIOSLTYP EQU   TIOESTTA
TIOELNGH EQU   TIOENTRY
TIOCSTEP EQU   TIOT1+8
TIOCNJOB EQU   TIOT1
DSABGRID EQU   DSABGIDL+4
DSABLLEN EQU   DSABGIDL
DSABANAM EQU   DSABANMI+1
DSABANML EQU   DSABANMI
DSABRS04 EQU   DSAB+68
DSABSIOT EQU   DSAB+64
DSABRS03 EQU   DSAB+62
DSABDCBM EQU   DSAB+56
DSABSSCM EQU   DSAB+52
DSABSSNM EQU   DSAB+48
DSABPTTR EQU   DSAB+44
DSABTCBP EQU   DSAB+40
DSABRS02 EQU   DSAB+38
@NM00014 EQU   DSABFLG4
DSABCKSI EQU   DSABFLG4
DSABCKVL EQU   DSABFLG4
DSABCKDS EQU   DSABFLG4
@NM00013 EQU   DSABFLG3
DSABJSCT EQU   DSABFLG3
DSABCATL EQU   DSABFLG3
DSABVMSC EQU   DSABFLG3
DSABVAM  EQU   DSABFLG3
DSABPASS EQU   DSABFLG3
DSABDEFR EQU   DSABFLG3
@NM00012 EQU   DSABFLG2
DSABUNAL EQU   DSABFLG2
DSABIRM  EQU   DSABFLG2
DSABOPEN EQU   DSABFLG2
DSABNUSE EQU   DSABFLG1
DSABCATM EQU   DSABFLG1
DSABPCAT EQU   DSABFLG1
DSABDCAT EQU   DSABFLG1
DSABCONV EQU   DSABFLG1
DSABDCNV EQU   DSABFLG1
DSABPALC EQU   DSABFLG1
DSABDALC EQU   DSABFLG1
@NM00011 EQU   DSABORG2
DSABTR   EQU   DSABORG2
DSABAM   EQU   DSABORG2
@NM00010 EQU   DSABORG2
DSABTQ   EQU   DSABORG2
DSABTX   EQU   DSABORG2
DSABGS   EQU   DSABORG2
DSABU    EQU   DSABORG1
DSABPO   EQU   DSABORG1
DSABMQ   EQU   DSABORG1
DSABCQ   EQU   DSABORG1
DSABCX   EQU   DSABORG1
DSABDA   EQU   DSABORG1
DSABPS   EQU   DSABORG1
DSABIS   EQU   DSABORG1
DSABSSVA EQU   DSAB+21
DSABRS01 EQU   DSAB+20
DSABOPCT EQU   DSAB+14
DSABLNTH EQU   DSAB+12
DSABBCHN EQU   DSAB+8
DSABFCHN EQU   DSAB+4
DSABID   EQU   DSAB
@NM00009 EQU   IFLAGS
PASSDS   EQU   IFLAGS
VOLUMEID EQU   UCBPARML+2
@NM00008 EQU   ETIOTREQ+19
@NM00007 EQU   ETIOTREQ+15
@NM00006 EQU   EREQSTAT
EREQVAM  EQU   EREQSTAT
EREQQNM  EQU   EREQSTAT
EREQTERM EQU   EREQSTAT
@NM00005 EQU   EREQMAP
EREQMOVE EQU   EREQMAP
@NM00050 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00049 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00048 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00047 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00046 EQU   FLCFSA
@NM00045 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00044 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00043 EQU   FLCIOA
@NM00042 EQU   FLCMCLA+15
@NM00041 EQU   FLCMCLA+14
@NM00040 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00039 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00038 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00037 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00036 EQU   FLCPER
@NM00035 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00034 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00033 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00032 EQU   FLCPIILC
@NM00031 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00030 EQU   FLCSVILC
@NM00029 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00028 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00027 EQU   FLCICCW2+4
FLCCVT   EQU   FLCICCW2
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00083 EQU   @RC00081
@RC00181 EQU   @RC00170
@RC00157 EQU   @RC00137
@RF00277 EQU   @RC00181
@RC00301 EQU   @RC00157
@RC00308 EQU   @RC00301
@RF00322 EQU   @RC00308
@ENDDATA EQU   *
         END   IEFAB434,(C'PLS1315',0701,77087)
