         TITLE 'IEFAB489 - ALLOCATE ONLINE DEVICES                     *
                        '
IEFAB489 CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(24)                                          01S0001
         DC    C'IEFAB489 78054  UZ16857 '                      01S0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01S0001
         BALR  @12,0                                            01S0001
@PSTART  LA    @11,4095(,@12)                                   01S0001
         USING @PSTART,@12                                      01S0001
         USING @PSTART+4095,@11                                 01S0001
         L     @00,@SIZDATD                                     01S0001
         GSPACE   R,LV=(0)
         LR    @10,@01                                          01S0001
         USING @DATD,@10                                        01S0001
         ST    @13,@SA00001+4                                   01S0001
         LM    @00,@01,20(@13)                                  01S0001
         ST    @10,8(,@13)                                      01S0001
         LR    @13,@10                                          01S0001
         MVC   @PC00001(8),0(@01)                               01S0001
*RETCODE = ZERO;                       /*INIT RETURN CODE FIELD      */
         SLR   @15,@15                                          01S0076
         ST    @15,RETCODE                                      01S0076
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - CHKDMNDS                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - CHECK FOR DEMAND REQUESTS TO ALLOCATE         */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE SCANS THE SIOT CHAIN FOR DEMAND REQUESTS WHICH    */
*/*   REQUIRE AN OFFLINE UNIT FROM THE GROUP CURRENTLY               */
*/*   BEING PROCESSED. FOR EACH SUCH REQUEST FOUND, THE              */
*/*   'ALOCREQ' SUBROUTINE IS INVOKED TO ATTEMPT TO ALLOCATE.        */
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*   PURPOSE - ALLOCATE DEMAND REQUESTS TO AVAILABLE UNITS          */
*/*   INPUT -                                                        */
*/*     SIOT1P - PTR TO FIRST SIOT IN STEP                           */
*/*       SIOTALCD - IF ON, SIOT HAS BEEN ALLOCATED                  */
*/*       SIOTDMND - ON FOR ALL DEMAND REQUESTS                      */
*/*       SIOTEDLP - PTR TO EDL FOR SIOT                             */
*/*       SVOLUNAD - PTR TO VOLUNIT ENTRY                            */
*/*     GRPIDENT - GROUP ID OF DEVICE GROUP BEING PROCESSED          */
*/*                                                                  */
*/* EXITS -                                                          */
*/*   CONDITION - NO REQUESTS TO ALLOCATE                            */
*/*     OUTPUT - NONE                                                */
*/*     RETURN CODES -                                               */
*/*       RETCODE = ZERO                                             */
*/*   CONDITION - AT LEAST ONE REQUEST ALLOCATED SUCCESSFULLY        */
*/*     OUTPUT                                                       */
*/*       SIOT/VOLUNIT ENTRY UPDATED                                 */
*/*       UCB/JFCB/PSAB/TIOT UPDATED                                 */
*/*       TOTREQS DECREMENTED                                        */
*/*     RETURN CODES -                                               */
*/*       RETCODE = ZERO                                             */
*/********************************************************************/
*SIOTPTR = SIOT1P;                     /*POINT TO FIRST SIOT         */
         L     @15,@PC00001                                     02S0077
         L     @01,ALCWAPTR(,@15)                               02S0077
         MVC   SIOTPTR(4),SIOT1P(@01)                           02S0077
*DO WHILE(SIOTPTR ^= ZERO &            /*SCAN ALL SIOTS ...          */
*    RETCODE = ZERO &                  /*... UNTIL ERROR OCCURS ...  */
*    TOTREQS > ZERO);                  /*... OR ALL REQS ARE ALLOC'D */
         B     @DE00078                                         02S0078
@DL00078 DS    0H                                               02S0079
*  VUPTR = SVOLUNAD;                   /*SET PTR TO VOLUNIT ENTRY    */
         L     @15,SIOTPTR                                      02S0079
         L     @14,SVOLUNAD(,@15)                               02S0079
         ST    @14,VUPTR                                        02S0079
*  IF SIOTDMND = YES &                 /*UNALLOCATED DEMAND REQUEST  */
*      SIOTALCD = NO &                                          02S0080
*      VUDMNDOF = YES THEN             /*NEEDED OFFLINE UNIT         */
         TM    SIOTDMND(@15),B'10000000'                        02S0080
         BNO   @RF00080                                         02S0080
         TM    SIOTALCD(@15),B'00000010'                        02S0080
         BNZ   @RF00080                                         02S0080
         TM    VUDMNDOF(@14),B'00100000'                        02S0080
         BNO   @RF00080                                         02S0080
*    DO;                                                        02S0081
*      EDLPTR = EDLFGENP;              /*POINT TO EDL GENERIC ENTRY  */
         L     @01,SIOTEDLP(,@15)                               02S0082
         L     EDLPTR,EDLFGENP(,@01)                            02S0082
*      EDLGNTP = EDLGRPTR;             /*GET PTR TO GROUP ENTRY      */
         L     @08,EDLGRPTR(,EDLPTR)                            02S0083
         ST    @08,EDLGNTP                                      02S0083
*      ARUGRPID = EDLGRID;             /*SET ID OF GROUP BEING PROC'D*/
         MVC   ARUGRPID(4),EDLGRID(@08)                         02S0084
*      RQLSTPTR = VOLALGTP;            /*SET PTR TO REQ LIST ENTRY   */
         MVC   RQLSTPTR(4),VOLALGTP(@14)                        02S0085
*      CALL ALOCREQ;                   /*TRY TO ALLOCATE THIS REQUEST*/
         BAL   @14,ALOCREQ                                      02S0086
*      IF VOLALOC = YES &              /*ENTRY WAS ALLOCATED         */
*          SIOTALCD = NO THEN                                   02S0087
         L     @01,VUPTR                                        02S0087
         TM    VOLALOC(@01),B'10000000'                         02S0087
         BNO   @RF00087                                         02S0087
         L     @15,SIOTPTR                                      02S0087
         TM    SIOTALCD(@15),B'00000010'                        02S0087
         BNZ   @RF00087                                         02S0087
*        DO;                           /*INDIC REQUEST WAS ALLOCATED */
*          SIOTALCD = ON;              /*SET INDICATOR IN SIOT       */
         OI    SIOTALCD(@15),B'00000010'                        02S0089
*          TOTREQS = TOTREQS - ONE;    /*DECR. REQS LEFT TO ALLOC    */
         L     @15,@PC00001                                     02S0090
         L     @15,ALCWAPTR(,@15)                               02S0090
         L     @14,TOTREQS(,@15)                                02S0090
         BCTR  @14,0                                            02S0090
         ST    @14,TOTREQS(,@15)                                02S0090
*        END;                                                   02S0091
*      ELSE;                           /*ENTRY WASN'T ALLOCATED      */
@RF00087 DS    0H                                               02S0093
*    END;                                                       02S0093
*  ELSE;                               /*NOT UNALLOC'D DEMAND REQUEST*/
@RF00080 DS    0H                                               02S0095
*  SIOTPTR = SIOTNPTR;                 /*POINT TO NEXT SIOT          */
         L     @01,SIOTPTR                                      02S0095
         L     @15,SIOTNPTR(,@01)                               02S0095
         ST    @15,SIOTPTR                                      02S0095
*END;                                                           02S0096
@DE00078 SLR   @15,@15                                          02S0096
         C     @15,SIOTPTR                                      02S0096
         BE    @DC00078                                         02S0096
         C     @15,RETCODE                                      02S0096
         BNE   @DC00078                                         02S0096
         L     @14,@PC00001                                     02S0096
         L     @01,ALCWAPTR(,@14)                               02S0096
         C     @15,TOTREQS(,@01)                                02S0096
         BL    @DL00078                                         02S0096
@DC00078 DS    0H                                               02S0097
*NOVUENTS = (VOLUNSZE -                /*NO. VU ENTRIES TO PROCESS   */
*   (FVUPTR - VOLUNPTR))/LENGTH(VOLUNTAB);                      01S0097
         L     @06,@PC00001                                     01S0097
         L     @06,ALCWAPTR(,@06)                               01S0097
         L     @02,@PC00001+4                                   01S0097
         L     NOVUENTS,FVUPTR(,@02)                            01S0097
         SL    NOVUENTS,VOLUNPTR(,@06)                          01S0097
         LCR   NOVUENTS,NOVUENTS                                01S0097
         AL    NOVUENTS,VOLUNSZE(,@06)                          01S0097
         SRDA  NOVUENTS,32                                      01S0097
         D     NOVUENTS,@CF00085                                01S0097
         LR    NOVUENTS,@09                                     01S0097
*GPCNTPTR = ALGGCNTP;                  /*POINT TO FIRST GROUP COUNT
*                                        ENTRY IN ALGORITHM TABLES   */
         L     @09,ALGTABP(,@06)                                01S0098
         L     GPCNTPTR,ALGGCNTP(,@09)                          01S0098
*NUMGRPS = GRPENTNO;                   /*NUMBER OF GROUPS TO SCAN    */
         L     @09,EDTABPTR(,@06)                               01S0099
         L     @09,EDTGRPSP(,@09)                               01S0099
         L     NUMGRPS,GRPENTNO(,@09)                           01S0099
*DO GRPCTR = 1 TO NUMGRPS              /*CHECK ALL GROUPS IN SYSTEM  */
*    WHILE(RETCODE = ZERO &                                     01S0100
*    TOTREQS > ZERO);                                           01S0100
         LA    @09,1                                            01S0100
         B     @DE00100                                         01S0100
@DL00100 SLR   @06,@06                                          01S0100
         C     @06,RETCODE                                      01S0100
         BNE   @DC00100                                         01S0100
         L     @02,@PC00001                                     01S0100
         L     @02,ALCWAPTR(,@02)                               01S0100
         C     @06,TOTREQS(,@02)                                01S0100
         BNL   @DC00100                                         01S0100
*  GRPPTR = EDTGRPSP + LENGTH(GRPHDR)  /*SET PTR TO EDT GROUP ENTRY  */
*      + (GRPCTR - 1) * GRPENTLN;                               01S0101
         L     @05,EDTABPTR(,@02)                               01S0101
         L     @05,EDTGRPSP(,@05)                               01S0101
         LA    GRPPTR,8                                         01S0101
         ALR   GRPPTR,@05                                       01S0101
         LR    @01,@09                                          01S0101
         BCTR  @01,0                                            01S0101
         M     @00,GRPENTLN(,@05)                               01S0101
         ALR   GRPPTR,@01                                       01S0101
*  OFFLNCT = ZERO;                     /*INIT COUNT OF OFFLINE UNITS */
         SLR   OFFLNCT,OFFLNCT                                  01S0102
*  DO DEVCTR = 1 TO GRPUCBNO;          /*CHECK ALL UCB'S IN THIS GRP */
         LA    DEVCTR,1                                         01S0103
         B     @DE00103                                         01S0103
@DL00103 DS    0H                                               01S0104
*    UCBPTR = IOSLUT(EUCBTPOS(DEVCTR) + 1); /*POINT TO UCB           */
         LR    @09,DEVCTR                                       01S0104
         ALR   @09,@09                                          01S0104
         L     @02,GRPUCBP(,GRPPTR)                             01S0104
         BCTR  @02,0                                            01S0104
         BCTR  @02,0                                            01S0104
         LH    @09,EUCBTPOS(@09,@02)                            01S0104
         ALR   @09,@09                                          01S0104
         L     @02,@PC00001                                     01S0104
         L     @02,ALCWAPTR(,@02)                               01S0104
         L     @02,IOSLUTP(,@02)                                01S0104
         ALR   @02,@09                                          01S0104
         SLR   @09,@09                                          01S0104
         ICM   @09,3,IOSLUT(@02)                                01S0104
         ST    @09,UCBPTR                                       01S0104
*    IF (UCBNALOC = NO) &              /*UNIT IS ALLOCATABLE...      */
*       ((UCB3DACC = YES &             /*NOT FIXED DASD              */
*       (UCBPRES = NO &                                         01S0105
*       UCBRESV = NO)) |                                        01S0105
*       (UCB3DACC=YES &                /*PERMRES DA          @YM05583*/
*       UCBPRES=YES &                  /*                    @YM05583*/
*       UCBALOC = NO &                 /*WITH NO VOL NOUNTED @YM05583*/
*       (UCBONLI = NO |                /*                    @YM05583*/
*       UCBVOLI = NOVOLSER |           /*                    @YM05583*/
*       UCBMOUNT = ON)) |              /*                    @YM05583*/
*       (UCB3TAPE = YES &              /*NOT RESERVED TAPE           */
*       UCBRESV = NO) |                                         01S0105
*       (UCB3DACC = NO &               /*NOT D.A., TAPE, ...         */
*       UCB3TAPE = NO &                                         01S0105
*       UCBSYSR = NO)) THEN            /*... NOR PRIMARY CONSOLE     */
         TM    UCBNALOC(@09),B'00000100'                        01S0105
         BNZ   @RF00105                                         01S0105
         TM    UCB3DACC(@09),B'00100000'                        01S0105
         BNO   @GL00010                                         01S0105
         TM    UCBPRES(@09),B'00100100'                         01S0105
         BZ    @RT00105                                         01S0105
@GL00010 L     @09,UCBPTR                                       01S0105
         TM    UCB3DACC(@09),B'00100000'                        01S0105
         BNO   @GL00009                                         01S0105
         TM    UCBPRES(@09),B'00000100'                         01S0105
         BNO   @GL00009                                         01S0105
         TM    UCBALOC(@09),B'00001000'                         01S0105
         BNZ   @GL00009                                         01S0105
         TM    UCBONLI(@09),B'10000000'                         01S0105
         BZ    @RT00105                                         01S0105
         CLC   UCBVOLI(6,@09),NOVOLSER                          01S0105
         BE    @RT00105                                         01S0105
         TM    UCBMOUNT(@09),B'10000000'                        01S0105
         BO    @RT00105                                         01S0105
@GL00009 L     @09,UCBPTR                                       01S0105
         TM    UCB3TAPE(@09),B'10000000'                        01S0105
         BNO   @GL00008                                         01S0105
         TM    UCBRESV(@09),B'00100000'                         01S0105
         BZ    @RT00105                                         01S0105
@GL00008 L     @09,UCBPTR                                       01S0105
         TM    UCB3DACC(@09),B'10100000'                        01S0105
         BNZ   @RF00105                                         01S0105
         TM    UCBSYSR(@09),B'00000010'                         01S0105
         BNZ   @RF00105                                         01S0105
@RT00105 DS    0H                                               01S0106
*      IF UCBONLI = NO THEN            /*UNIT IS OFFLINE             */
         L     @09,UCBPTR                                       01S0106
         TM    UCBONLI(@09),B'10000000'                         01S0106
         BNZ   @RF00106                                         01S0106
*        DO;                                                    01S0107
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - DMNDNEED                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - TEST IF UCB IS DEMANDED                       */
*/*                                                                  */
*/* FUNCTION - THIS ROUTINE DETERMINES IF THE INPUT UCB IS           */
*/*            NEEDED BY A DEMAND REQUEST (E.G. UNIT=190).           */
*/*                                                                  */
*/*   OPERATION - THE SIOT CHAIN IS SCANNED TO LOCATE EACH           */
*/*               DEMAND REQUEST.                                    */
*/*                                                                  */
*/* ENTRY - (INLINE SUBROUTINE)                                      */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*      SIOT1P - PTR TO THE FIRST SIOT IN THE CHAIN                 */
*/*        SIOTDMND - 1 FOR DEMAND REQUESTS                          */
*/*        SIOUCBAD - FOR DEMAND REQUEST, ADDRESS OF THE             */
*/*                   DEMANDED UCB                                   */
*/*        SIOTNPTR - PTR TO THE NEXT SIOT                           */
*/*      UCBPTR - PTR TO UCB                                         */
*/*                                                                  */
*/* EXIT - NORMAL - INLINE SUBROUTINE                                */
*/*                                                                  */
*/*   CONDITIONS - FUNCTION COMPLETED                                */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*       USEUCB - 1 = NO DEMAND REQ NEEDS THIS UCB                  */
*/*              - 0 = A DEMAND REQ NEEDS THIS UCB                   */
*/*                                                                  */
*/********************************************************************/
*USEUCB = ON;                          /*ASSUME UCB NOT DEMANDED     */
         OI    USEUCB,B'00000100'                               02S0108
*RFY INDMSIOT BASED(SPTR);                                      02S0109
*SPTR = SIOT1P;                        /*POINT TO THE FIRST SIOT     */
         L     @09,@PC00001                                     02S0110
         L     @09,ALCWAPTR(,@09)                               02S0110
         L     SPTR,SIOT1P(,@09)                                02S0110
*DO WHILE (SPTR ^= ZERO                /*SCAN ALL SIOTS ..           */
*    & USEUCB = ON);                   /*..UNTIL UCB FOUND DEMANDED  */
         B     @DE00111                                         02S0111
@DL00111 DS    0H                                               02S0112
*  IF SIOTDMND = ON                    /*DEMAND REQ FOR THIS UCB ?   */
*      & SIOUCBAD = UCBPTR THEN                                 02S0112
         TM    SIOTDMND(SPTR),B'10000000'                       02S0112
         BNO   @RF00112                                         02S0112
         SLR   @09,@09                                          02S0112
         ICM   @09,7,SIOUCBAD(SPTR)                             02S0112
         C     @09,UCBPTR                                       02S0112
         BNE   @RF00112                                         02S0112
*    DO;                               /*YES,INDICATE UCB IS DEMANDED*/
*      USEUCB = OFF;                                            02S0114
         NI    USEUCB,B'11111011'                               02S0114
*    END;                                                       02S0115
*  ELSE;                               /*NOT DEMAND REQ FOR THIS UCB */
@RF00112 DS    0H                                               02S0117
*  SPTR = SIOTNPTR;                    /*POINT TO THE NEXT SIOT      */
         L     SPTR,SIOTNPTR(,SPTR)                             02S0117
*END;                                                           02S0118
@DE00111 LTR   SPTR,SPTR                                        02S0118
         BZ    @DC00111                                         02S0118
         TM    USEUCB,B'00000100'                               02S0118
         BO    @DL00111                                         02S0118
@DC00111 DS    0H                                               02S0119
*RFY INDMSIOT BASED(SIOTPTR);                                   02S0119
*          IF USEUCB = YES THEN        /*UNIT USEABLE BY NON-DMNDS   */
         TM    USEUCB,B'00000100'                               01S0120
         BNO   @RF00120                                         01S0120
*            OFFLNCT = OFFLNCT + ONE;  /*INCREMENT OFFLINES COUNT    */
         AH    OFFLNCT,@CH00066                                 01S0121
*        END;                                                   01S0122
*      ELSE;                           /*UNIT IS ONLINE              */
@RF00106 DS    0H                                               01S0124
*  END;                                                         01S0124
@RC00106 DS    0H                                               01S0124
@RF00105 AH    DEVCTR,@CH00066                                  01S0124
@DE00103 C     DEVCTR,GRPUCBNO(,GRPPTR)                         01S0124
         BNH   @DL00103                                         01S0124
*  IF OFFLNCT < GRPOFFLN THEN          /*FEWER OFFLINE UNITS IN GROUP*/
         LH    @09,GRPOFFLN(,GPCNTPTR)                          01S0125
         CR    OFFLNCT,@09                                      01S0125
         BNL   @RF00125                                         01S0125
*    DO;                               /*UPDATE COUNT TABLE ENTRY &
*                                        SEE IF CAN ALLOCATE WITH ANY
*                                        OF THE UNITS NOW ONLINE     */
*      NEWONS = GRPOFFLN - OFFLNCT;    /*NUMBER OF NEW OFFLINE  01S0127
*                                        DEVICES             @ZA10805*/
         SLR   @09,OFFLNCT                                      01S0127
         ST    @09,NEWONS                                       01S0127
*      GRPAVAIL = GRPAVAIL+(GRPOFFLN - OFFLNCT);/*UPDATE NO. UNITS
*                                        AVAILABLE                   */
         AH    @09,GRPAVAIL(,GPCNTPTR)                          01S0128
         STH   @09,GRPAVAIL(,GPCNTPTR)                          01S0128
*      GRPOFFLN = OFFLNCT;             /*PUT NEW COUNT IN ALG TABLE  */
         STH   OFFLNCT,GRPOFFLN(,GPCNTPTR)                      01S0129
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - CHKNDMND                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - CHECK FOR NON-DEMAND REQUESTS TO ALLOCATE     */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE DETERMINES IF ANY OF THE UNALLOCATED VOLUNIT      */
*/*   ENTRIES CAN BE ALLOCATED FROM THE DEVICE GROUP CURRENTLY       */
*/*   BEING PROCESSED. FOR ANY ENTRIES FOUND THE 'ALOCREQ' SUB-      */
*/*   ROUTINE IS INVOKED TO ATTEMPT TO ALLOCATE A UNIT FOR THE       */
*/*   VU ENTRY.                                                      */
*/*                                                                  */
*/*   OPERATION -                                                    */
*/*     THE ROUTINE WILL SCAN THE VOLUNIT TABLE, STARTING WITH       */
*/*     THE ENTRY POINTED TO BY THE INPUT PARAMETER 'FVUPTR'.        */
*/*     FOR EACH UNALLOCATED ENTRY WHICH REQUIRES A DEVICE THE       */
*/*     ROUTINE WILL DETERMINE IF THE GROUP BEING PROCESSED IS       */
*/*     ELIGIBLE TO THE REQUEST. IF IT IS, THE POINTER TO THE        */
*/*     CORRESPONDING EDL GROUP ENTRY IS OBTAINED AND THE 'ALOCREQ'  */
*/*     SUBROUTINE IS INVOKED.                                       */
*/*     IF THE ENTRY IS SUCCESSFULLY ALLOCATED, SEGMENT 'CHKSIOT'    */
*/*     WILL DETERMINE IF THIS REQUEST IS NOW COMPLETELY ALLOCATED.  */
*/*                                                                  */
*/* ENTRY -                                                          */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*   INPUT -                                                        */
*/*     FVUPTR - PTR TO FIRST VOLUNIT ENTRY TO SCAN                  */
*/*     GRPIDENT - ID OF GROUP BEING PROCESSED                       */
*/*                                                                  */
*/* EXITS -                                                          */
*/*   CONDITION - NO ENTRIES TO ALLOCATE                             */
*/*     OUTPUT - NONE                                                */
*/*     RETURN CODES -                                               */
*/*       RETCODE = ZERO                                             */
*/*   CONDITION - AT LEAST ONE VOLUNIT ENTRY ALLOCATED SUCCESSFULLY  */
*/*     OUTPUT -                                                     */
*/*       VOLALOC - ON FOR EACH ENTRY ALLOCATED                      */
*/*       SIOTALCD - ON IF ENTIRE REQUEST ALLOCATED                  */
*/*       TOTREQS - DECREMENTED FOR EACH COMPLETELY ALLOCATED REQUEST*/
*/*       UCB/JFCB/DSAB/TIOT UPDATED                                 */
*/*       VM&V REQUEST BLOCKS BUILT IF REQUIRED                      */
*/*     RETURN CODES -                                               */
*/*       RETCODE = ZERO                                             */
*/*   CONDITION - TERMINATING ERROR ALLOCATING AN ENTRY              */
*/*     OUTPUT -                                                     */
*/*       RSNCODE = 2, IF GETMAIN ERROR                              */
*/*     RETURN CODES -                                               */
*/*       RETCODE = 4                                                */
*/********************************************************************/
*VUPTR = FVUPTR;                       /*POINT TO FIRST VU ENTRY TO
*                                        PROCESS                     */
         L     @09,@PC00001+4                                   02S0130
         MVC   VUPTR(4),FVUPTR(@09)                             02S0130
*DO VUCTR = 1 TO NOVUENTS              /*SCAN VOLUNIT TABLE          */
*    WHILE(RETCODE = ZERO &            /*STOP IF ERROR ...           */
*    TOTREQS > ZERO);                  /*... OR ALL REQS ALLOCATED   */
         LA    @09,1                                            02S0131
         B     @DE00131                                         02S0131
@DL00131 SLR   @09,@09                                          02S0131
         C     @09,RETCODE                                      02S0131
         BNE   @DC00131                                         02S0131
         L     @06,@PC00001                                     02S0131
         L     @06,ALCWAPTR(,@06)                               02S0131
         C     @09,TOTREQS(,@06)                                02S0131
         BNL   @DC00131                                         02S0131
*  RQLSTPTR = VOLALGTP;                /*POINT TO REQUEST LIST ENTRY */
         L     @06,VUPTR                                        02S0132
         L     @02,VOLALGTP(,@06)                               02S0132
         ST    @02,RQLSTPTR                                     02S0132
*  GPLSTPTR = CVRGRPPT;                /*POINT TO FIRST GROUP LIST   */
         MVC   GPLSTPTR(4),CVRGRPPT(@02)                        02S0133
*  GRPFOUND = OFF;                     /*ASSUME GROUP NOT IN LIST    */
         NI    GRPFOUND,B'11101111'                             02S0134
*  IF VOLALOC = NO &                   /*ENTRY NOT ALLOCATED ...     */
*      VDEVREQD = YES &                /*...REQUIRES A UNIT....      */
*      CVRALLCT = ZERO &               /*...NOT REDUCED YET....      */
*      CVRSKFLG = NO THEN              /*...IS CONSIDERED BY ALG.    */
         TM    VDEVREQD(@06),B'00100000'                        02S0135
         BNO   @RF00135                                         02S0135
         TM    VOLALOC(@06),B'10000000'                         02S0135
         BNZ   @RF00135                                         02S0135
         CH    @09,CVRALLCT(,@02)                               02S0135
         BNE   @RF00135                                         02S0135
         TM    CVRSKFLG(@02),B'10000000'                        02S0135
         BNZ   @RF00135                                         02S0135
*    DO GRPLCTR = 1 TO CVRNGRP         /*SCAN REQS ELIGIBLE GROUPS ..*/
*        WHILE (GRPFOUND = OFF);       /*... FOR GROUP JUST UPDATED  */
         LA    GRPLCTR,1                                        02S0136
         B     @DE00136                                         02S0136
@DL00136 TM    GRPFOUND,B'00010000'                             02S0136
         BNZ   @DC00136                                         02S0136
*      IF CVRGRPID = GRPIDENT THEN     /*LIST ENT IS FOR CURRENT GRP */
         L     @09,GPLSTPTR                                     02S0137
         LH    @02,CVRGRPID(,@09)                               02S0137
         CH    @02,GRPIDENT(,GPCNTPTR)                          02S0137
         BNE   @RF00137                                         02S0137
*        DO;                                                    02S0138
*          GRPFOUND = ON;              /*INDICATE GROUP FOUND        */
         OI    GRPFOUND,B'00010000'                             02S0139
*          IF CVRGSKP = NO &           /*GROUP IS ELIGIBLE TO REQUEST*/
*              CVRGALL => ZERO THEN    /*GROUP HAS POSSIBLE SOLUTION */
         TM    CVRGSKP(@09),B'10000000'                         02S0140
         BNZ   @RF00140                                         02S0140
         ICM   @15,3,CVRGALL(@09)                               02S0140
         BM    @RF00140                                         02S0140
*            DO;                       /*TRY TO ALLOCATE FROM GROUP  */
*              SIOTPTR = VOLSIOTP;     /*SET PTR TO SIOT FOR VU ENT  */
         L     @01,VUPTR                                        02S0142
         L     @15,VOLSIOTP(,@01)                               02S0142
         ST    @15,SIOTPTR                                      02S0142
*              ARUGRPID = CVRGRPID;    /*SET GROUP ID                */
         ST    @02,ARUGRPID                                     02S0143
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - FINDEDL                                           */
*/*                                                                  */
*/* DESCRIPTIVE NAME - FIND EDL GROUP ENTRY                          */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE SCANS THE EDL FOR THE GROUP ENTRY WITH THE INPUT  */
*/*   GROUP ID.                                                      */
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*   INPUT -                                                        */
*/*     ARUGRPID - ID OF GROUP BEING PROCESSED                       */
*/*     EDLFGENP - POINTER TO FIRST GENERIC ENTRY                    */
*/*       EDLGENNO - NUMBER OF GENERIC ENTRIES                       */
*/*       EINDEVTP - IF ON, GENERIC IS INELIGIBLE TO REQUEST         */
*/*       EDLGRPTR - PTR TO FIRST GROUP ENTRY FOR GENERIC            */
*/*         EDLGRPNO - NUMBER OF GROUP ENTRIES                       */
*/*         EDLGRID - GROUP ID                                       */
*/*                                                                  */
*/* EXIT -                                                           */
*/*   CONDITION - FUNCTION COMPLETED                                 */
*/*     OUTPUT -                                                     */
*/*       EDLENTP - POINTER TO REQUIRED GROUP ENTRY                  */
*/*     RETURN CODES - NONE                                          */
*/********************************************************************/
*EDLPTR = EDLFGENP;                    /*GET PTR TO FIRST GENERIC ENT*/
         L     @02,SIOTEDLP(,@15)                               03S0144
         L     EDLPTR,EDLFGENP(,@02)                            03S0144
*FOUNDEDL = OFF;                       /*INIT SCAN CONTROL SWITCH    */
         NI    FOUNDEDL,B'10111111'                             03S0145
*DO GENCTR = 1 TO EDLGENNO             /*SCAN GENRIC ENTS FOR GROUP  */
*    WHILE(FOUNDEDL = OFF);                                     03S0146
         LA    GENCTR,1                                         03S0146
         B     @DE00146                                         03S0146
@DL00146 TM    FOUNDEDL,B'01000000'                             03S0146
         BNZ   @DC00146                                         03S0146
*  IF EINDEVTP = NO THEN               /*ELIGIBLE GENERIC            */
         TM    EINDEVTP(EDLPTR),B'10000000'                     03S0147
         BNZ   @RF00147                                         03S0147
*    DO;                               /*SCAN GROUP ENTRIES          */
*      EDLGNTP = EDLGRPTR;             /*POINT TO FIRST GROUP ENTRY  */
         MVC   EDLGNTP(4),EDLGRPTR(EDLPTR)                      03S0149
*      DO EGRPCTR = 1 TO EDLGRPNO      /*SCAN FOR GROUP ID MATCH     */
*          WHILE(FOUNDEDL = OFF);                               03S0150
         LA    EGRPCTR,1                                        03S0150
         B     @DE00150                                         03S0150
@DL00150 TM    FOUNDEDL,B'01000000'                             03S0150
         BNZ   @DC00150                                         03S0150
*        IF ARUGRPID = EDLGRID THEN    /*GROUP ID'S MATCH            */
         L     @05,EDLGNTP                                      03S0151
         CLC   ARUGRPID(4),EDLGRID(@05)                         03S0151
         BNE   @RF00151                                         03S0151
*          FOUNDEDL = ON;              /*SET EXIT INDICATOR          */
         OI    FOUNDEDL,B'01000000'                             03S0152
*        ELSE                          /*NOT INPUT GROUP             */
*          EDLGNTP = EDLNXGRP;         /*POINT TO NEXT GROUP ENTRY   */
         B     @RC00151                                         03S0153
@RF00151 L     @05,EDLGNTP                                      03S0153
         L     @05,EDLNXGRP(,@05)                               03S0153
         ST    @05,EDLGNTP                                      03S0153
*      END;                                                     03S0154
@RC00151 AH    EGRPCTR,@CH00066                                 03S0154
@DE00150 C     EGRPCTR,EDLGRPNO(,EDLPTR)                        03S0154
         BNH   @DL00150                                         03S0154
@DC00150 DS    0H                                               03S0155
*    END;                                                       03S0155
* ELSE;                                /*GENERIC NOT ELIGIBLE TO REQ */
@RF00147 DS    0H                                               03S0157
* IF FOUNDEDL = NO THEN                /*GROUP NOT FOUND YET         */
         TM    FOUNDEDL,B'01000000'                             03S0157
         BNZ   @RF00157                                         03S0157
*   EDLPTR = EDLNXTNT;                 /*POINT TO NEXT GENERIC ENTRY */
         L     EDLPTR,EDLNXTNT(,EDLPTR)                         03S0158
*END;                                                           03S0159
@RF00157 AH    GENCTR,@CH00066                                  03S0159
@DE00146 L     @01,SIOTPTR                                      03S0159
         L     @01,SIOTEDLP(,@01)                               03S0159
         C     GENCTR,EDLGENNO(,@01)                            03S0159
         BNH   @DL00146                                         03S0159
@DC00146 DS    0H                                               03S0160
*              CALL ALOCREQ;           /*TRY TO ALLOCATE THE VU ENTRY*/
         BAL   @14,ALOCREQ                                      02S0160
*              IF VOLALOC = YES THEN   /*ENTRY WAS ALLOCATED         */
         L     @09,VUPTR                                        02S0161
         TM    VOLALOC(@09),B'10000000'                         02S0161
         BNO   @RF00161                                         02S0161
*                DO;                                            02S0162
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - CHKSIOT                                           */
*/*                                                                  */
*/* DESCRIPTIVE NAME - CHECK TO SEE IF SIOT ALLOCATED                */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE CHECKS ALL THE VOLUNIT ENTRIES FOR THE INPUT      */
*/*   SIOT. IF ALL THE ENTRIES WHICH REQUIRE A DEVICE HAVE BEEN      */
*/*   ALLOCATED THEN THE SIOT IS MARKED ALLOCATED AND THE NUMBER     */
*/*   OF UNALLOCATED REQUESTS IS DECREMENTED.                        */
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*   PURPOSE - MARK SIOT IF ALLOCATED                               */
*/*   INPUT -                                                        */
*/*     SIOTPTR - PTR TO SIOT OF THE ENTRY JUST ALLOCATED            */
*/*     TOTREQS - NUMBER OF UNALLOCATED REQUESTS                     */
*/* EXITS -                                                          */
*/*   CONDITION - FUNCTION COMPLETED                                 */
*/*     OUTPUT -                                                     */
*/*       SIOTALCD - ON IF ALLOCATION COMPLETE FOR THE REQUEST       */
*/*       TOTREQS - DECRMENTED BY ONE IF SIOT IS ALLOCATED           */
*/*     RETURN CODES - NONE                                          */
*/********************************************************************/
*AVUPTR = SVOLUNAD;                    /*POINT TO FIRST VU ENTRY     */
         L     @09,SIOTPTR                                      03S0163
         L     AVUPTR,SVOLUNAD(,@09)                            03S0163
*REQALCD = ON;                         /*ASSUME REQUEST IS ALLOCATED */
         OI    REQALCD,B'00001000'                              03S0164
*RFY VOLUNTAB BASED(AVUPTR);                                    03S0165
*DO AVUCTR = 1 TO SVOLUNNO             /*SCAN ALL ENTRIES ...        */
*    WHILE(REQALCD = ON);              /*... STOP IF ANY NOT ALLOC'D */
         LA    AVUCTR,1                                         03S0166
         B     @DE00166                                         03S0166
@DL00166 TM    REQALCD,B'00001000'                              03S0166
         BNO   @DC00166                                         03S0166
*  IF VOLALOC = NO &                   /*ENTRY NOT ALLOC'D AND ...   */
*      VDEVREQD = YES THEN             /*... NEEDS A DEVICE          */
         TM    VDEVREQD(AVUPTR),B'00100000'                     03S0167
         BNO   @RF00167                                         03S0167
         TM    VOLALOC(AVUPTR),B'10000000'                      03S0167
         BNZ   @RF00167                                         03S0167
*    REQALCD = OFF;                    /*INDICATE REQ NOT ALLOCATED  */
         NI    REQALCD,B'11110111'                              03S0168
*  ELSE;                                                        03S0169
@RF00167 DS    0H                                               03S0170
*  AVUPTR = AVUPTR + LENGTH(VOLUNTAB); /*POINT TO NEXT VU ENTRY      */
         AL    AVUPTR,@CF00085                                  03S0170
*END;                                                           03S0171
         AH    AVUCTR,@CH00066                                  03S0171
@DE00166 L     @09,SIOTPTR                                      03S0171
         CH    AVUCTR,SVOLUNNO(,@09)                            03S0171
         BNH   @DL00166                                         03S0171
@DC00166 DS    0H                                               03S0172
*IF REQALCD = YES &                    /*ALLOC'N COMPLETE FOR SIOT   */
*    SIOTALCD = NO THEN                                         03S0172
         TM    REQALCD,B'00001000'                              03S0172
         BNO   @RF00172                                         03S0172
         L     @09,SIOTPTR                                      03S0172
         TM    SIOTALCD(@09),B'00000010'                        03S0172
         BNZ   @RF00172                                         03S0172
*  DO;                                 /*UPDATE SIOT & COUNT TABLE   */
*    SIOTALCD = ON;                    /*SET INDIC. IN SIOT          */
         OI    SIOTALCD(@09),B'00000010'                        03S0174
*    TOTREQS = TOTREQS - ONE;          /*DECREMENT # REQS TO PROCESS */
         L     @09,@PC00001                                     03S0175
         L     @09,ALCWAPTR(,@09)                               03S0175
         L     @02,TOTREQS(,@09)                                03S0175
         BCTR  @02,0                                            03S0175
         ST    @02,TOTREQS(,@09)                                03S0175
*  END;                                                         03S0176
*RFY VOLUNTAB BASED(VUPTR);                                     03S0177
@RF00172 DS    0H                                               03S0178
*                  CVRFCALL = OFF;     /*REQUEST ALG REDUCE FCN      */
         L     @09,@PC00001                                     02S0178
         L     @09,ALCWAPTR(,@09)                               02S0178
         L     @09,ALGTABP(,@09)                                02S0178
         L     @02,ALGPARMP(,@09)                               02S0178
         NI    CVRFCALL(@02),B'11101111'                        02S0178
*                  CALL IEFAB480(ALGPARMP); /*INVOKE ALG TO REDUCE
*                                             SOLUTIONS              */
         ST    @09,@AL00001                                     02S0179
         L     @15,@CV00152                                     02S0179
         LA    @01,@AL00001                                     02S0179
         BALR  @14,@15                                          02S0179
*                  IF REG15 ^= ZERO THEN  /*ERROR RETURN CODE        */
         LTR   REG15,REG15                                      02S0180
         BZ    @RF00180                                         02S0180
*                    DO;                                        02S0181
*                      RETCODE = FAILURE; /*SET RETURN CODE TO 4     */
         MVC   RETCODE(4),@CF00138                              02S0182
*                      RSNCODE = GETMNERR; /*SET REASON CODE TO 2    */
         L     @09,@PC00001                                     02S0183
         L     @09,ALCWAPTR(,@09)                               02S0183
         L     @09,FAILRSCP(,@09)                               02S0183
         MVC   RSNCODE(2,@09),@CH00073                          02S0183
*                    END;                                       02S0184
*                END;                                           02S0185
*              ELSE;                   /*ENTRY WASN'T ALLOCATED      */
@RF00161 DS    0H                                               02S0187
*            END;                                               02S0187
*          ELSE;                       /*GROUP NOT ALLOCATABLE TO REQ*/
@RF00140 DS    0H                                               02S0189
*        END;                                                   02S0189
*      ELSE;                           /*NOT GROUP BEING PROCESSED   */
@RF00137 DS    0H                                               02S0191
*      GPLSTPTR = GPLSTPTR +           /*GET NEXT GROUP LIST ENTRY   */
*          LENGTH(CVRGPLST);                                    02S0191
@RC00137 LA    @09,16                                           02S0191
         AL    @09,GPLSTPTR                                     02S0191
         ST    @09,GPLSTPTR                                     02S0191
*    END;                                                       02S0192
         AH    GRPLCTR,@CH00066                                 02S0192
@DE00136 L     @09,RQLSTPTR                                     02S0192
         CH    GRPLCTR,CVRNGRP(,@09)                            02S0192
         BNH   @DL00136                                         02S0192
@DC00136 DS    0H                                               02S0193
*  ELSE;                               /*NO PROC'NG NEEDED FOR VU ENT*/
@RF00135 DS    0H                                               02S0194
*  VUPTR = VUPTR + LENGTH(VOLUNTAB);   /*POINT TO NEXT VU ENTRY      */
         LA    @09,28                                           02S0194
         AL    @09,VUPTR                                        02S0194
         ST    @09,VUPTR                                        02S0194
*END;                                                           02S0195
         LA    @09,1                                            02S0195
         AL    @09,VUCTR                                        02S0195
@DE00131 ST    @09,VUCTR                                        02S0195
         CR    @09,NOVUENTS                                     02S0195
         BNH   @DL00131                                         02S0195
@DC00131 DS    0H                                               02S0196
*    END;                                                       01S0196
*  ELSE;                               /*STATUS HASN'T CHANGED       */
@RF00125 DS    0H                                               01S0198
*  GPCNTPTR = GPCNTPTR + LENGTH(GRPCOUNT); /*POINT TO NEXT GROUP     */
         AH    GPCNTPTR,@CH00047                                01S0198
*END;                                                           01S0199
         LA    @09,1                                            01S0199
         AL    @09,GRPCTR                                       01S0199
@DE00100 ST    @09,GRPCTR                                       01S0199
         CR    @09,NUMGRPS                                      01S0199
         BNH   @DL00100                                         01S0199
@DC00100 DS    0H                                               01S0200
*RETURN CODE(RETCODE);                 /*RETURN TO CALLER            */
         L     @09,RETCODE                                      01S0200
         L     @13,4(,@13)                                      01S0200
         L     @00,@SIZDATD                                     01S0200
         LR    @01,@10                                          01S0200
         FSPACE   R,LV=(0),A=(1)
         LR    @15,@09                                          01S0200
         L     @14,12(,@13)                                     01S0200
         LM    @00,@12,20(@13)                                  01S0200
         BR    @14                                              01S0200
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT - ALOCREQ                                                */
*/*                                                                  */
*/* DESCRIPTIVE NAME - ALLOCATE REQUEST                              */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE ATTEMPTS TO ALLOCATE THE INPUT REQUEST(I.E.,      */
*/*   VOLUNIT ENTRY) TO AN AVAILABLE DEVICE WITHIN THE INPUT         */
*/*   DEVICE GROUP.                                                  */
*/*                                                                  */
*/*   OPERATION -                                                    */
*/*     THE ROUTINE OPERATES AS FOLLOWS:                             */
*/*       .BUILDS A LIST OF ALL THE ONLINE,UNALLOCATED UCBS IN       */
*/*        THE INPUT DEVICE GROUP USING THE EDL UCB LIST FOR THIS    */
*/*        GROUP                                                     */
*/*       .IF A MSS REQUEST, DETERMINE WHETHER TO            @G18MP21*/
*/*        PERFORM MOUNT EQUALIZATION. IT IS NOT PERFORMED   @G18MP21*/
*/*        IF SU18 IS IN THE SYSTEM AND JES3 CHOSE UNITS     @G18MP21*/
*/*        FOR THE REQUEST.                                  @G18MP21*/
*/*       .IF THERE ARE UNITS AVAILABLE WHICH CAN BE ALLOCATED,      */
*/*        SEGMENT 'ALOCENT' WILL PICK THE UNIT TO ALLOCATE (VIA     */
*/*        THE OPTIMIZER) AND INVOKE IEFAB434 TO ALLOCATE THE        */
*/*        UNIT TO THIS VOLUNIT ENTRY.                               */
*/*       .IF NO UNITS ARE AVAILABLE NO FURTHER PROCESSING IS        */
*/*        DONE.                                                     */
*/*                                                                  */
*/* ENTRY - ALOCREQ (INTERNAL PROC)                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*   INPUT -                                                        */
*/*     VUPTR - PTR TO VOLUNIT ENTRY TO ALLOCATE                     */
*/*     EDLGNTP - PTR TO EDL GROUP ENTRY TO USE                      */
*/*       EDLUCBNO - NUMBER OF UCBS IN THIS GROUP                    */
*/*       EDLLISTP - PTR TO UCB LIST                                 */
*/*         EDLUCBAD - ARRAY OF UCB ADDRESSES                        */
*/*     SIOTPTR - PTR TO SIOT FOR VOLUNIT ENTRY                      */
*/*     ARUGRPID - GROUP ID OF DEVICE GROUP BEING PROCESSED          */
*/*     TOTVOLUN - NUMBER OF UNALLOCATED VOLUNIT ENTRIES             */
*/*                                                                  */
*/* EXIT - RETURN TO CALLER                                          */
*/*   CONDITION - ALLOCATION SUCCESSFUL                              */
*/*     OUTPUT -                                                     */
*/*       VOLALOC - ON TO INDICATE ENTRY ALLOCATED                   */
*/*       TOTVOLUN - DECREMENTED BY ONE                              */
*/*       UCB/JFCB/DSAB/TIOT UPDATED                                 */
*/*       VM&V REQUEST BLOCK CREATED IF NECESSARY                    */
*/*     RETURN CODES -                                               */
*/*       RETCODE = ZERO                                             */
*/*   CONDITION - TERMINATING ERROR DURING PROCESSING                */
*/*     OUTPUT -                                                     */
*/*       RSNCODE = 2, IF GETMAIN ERROR                              */
*/*     RETURN CODES -                                               */
*/*       RETCODE = 4                                                */
*/*                                                                  */
*/********************************************************************/
*ALOCREQ:                              /*ATTEMPT TO ALLOCATE REQUEST */
*  PROC;                                                        02S0201
ALOCREQ  STM   @14,@12,@SA00002                                 02S0201
* /* ?GETSTORG (SPLNO,LENGTH(OPTPARMS),OPTPARMP);*/             02S0202
*   /* DEFINITIONS OF GETMAIN PARMS */                          02S0202
*   DCL                                                         02S0202
*     GTSTR0   FIXED(31) REG(0),/*GTMN PARM REG*/               02S0202
*     GTSTR1   FIXED(31) REG(1),/*GTMN PARM REG*/               02S0202
*     GTSTR2   PTR(31)   REG(2),/*GTMN PARM REG*/               02S0202
*     GTSTR15  FIXED(31) REG(15),/*GTMN RET COD*/               02S0202
*     GTSTRTCD FIXED(31); /* GETMAIN RTN CODE  */               02S0202
*   DCL                                                         02S0203
*     GTSTR3   FIXED(31) REG(3),/* CLEARING REG*/               02S0203
*     GTSTR4   FIXED(31) REG(4),/* CLEARING REG*/               02S0203
*     GTSTR5   FIXED(31) REG(5),/* CLEARING REG*/               02S0203
*     GTSTR6   FIXED(31) REG(6),/* CLEARING REG*/               02S0203
*     GTSTR7   FIXED(31) REG(7),/* CLEARING REG*/               02S0203
*     GTSTR8   FIXED(31) REG(8),/* CLEARING REG*/               02S0203
*     GTSTZERO FIXED(31) INIT(0),                               02S0203
*     GTST253  FIXED(31) CONSTANT(253);                         02S0203
*   RFY (GTSTR0,GTSTR1,GTSTR2) RSTD; /*SAVE RGS*/               02S0204
*   GTSTR0 = LENGTH(OPTPARMS); /* SET AMOUNT*/                  02S0205
         LA    GTSTR0,20                                        02S0205
*   GTSTR2 = SPLNO; /* SET SUBPOOL*/                            02S0206
         LA    GTSTR2,253                                       02S0206
*   GENERATE CODE;                                              02S0207
     GETMAIN RC,LV=(0),SP=(2)  DO GETMAIN
*   GTSTRTCD = GTSTR15; /* SAVE GETMAIN RET COD*/               02S0208
         ST    GTSTR15,GTSTRTCD                                 02S0208
*   OPTPARMP = GTSTR1; /* ADDR OF GOTN STORG*/                  02S0209
         ST    GTSTR1,OPTPARMP                                  02S0209
*   RFY (GTSTR0,GTSTR1,GTSTR2) UNRSTD; /*RLSE */                02S0210
*   IF GTSTRTCD = 0 THEN /*GETMAIN SUCCESSFUL? */               02S0211
         L     @08,GTSTRTCD                                     02S0211
         LTR   @08,@08                                          02S0211
         BNZ   @RF00211                                         02S0211
*     DO;               /* YES, CLEAR STORAGE.*/                02S0212
*       RFY (GTSTR2,GTSTR4,GTSTR5,GTSTR6,                       02S0213
*                          GTSTR7,GTSTR8) RSTD;                 02S0213
*       GTSTR4 = OPTPARMP; /*STORG PTR*/                        02S0214
         L     @03,OPTPARMP                                     02S0214
         LR    GTSTR4,@03                                       02S0214
*       GTSTR5 = LENGTH(OPTPARMS); /*STORG AMNT*/               02S0215
         LA    GTSTR5,20                                        02S0215
*       GTSTR7 = '00000000'X; /*PAD CHAR & LNTH*/               02S0216
         SLR   GTSTR7,GTSTR7                                    02S0216
*       IF SPLNO = GTST253 THEN                                 02S0217
*      GEN                                                      02S0218
*   (MODESET KEYADDR=GTSTZERO,SAVEKEY=(2),WORKREG=8);           02S0218
         MODESET KEYADDR=GTSTZERO,SAVEKEY=(2),WORKREG=8
*       GEN REFS(GTSTR4,GTSTR6);                                02S0219
          MVCL  GTSTR4,GTSTR6 CLEAR GOTTEN STORG
*       IF SPLNO = GTST253 THEN                                 02S0220
*         GEN (MODESET KEYADDR=(2));                            02S0221
         MODESET KEYADDR=(2)
*       RFY (GTSTR2,GTSTR4,GTSTR5,GTSTR6,                       02S0222
*                          GTSTR7,GTSTR8) UNRSTD;               02S0222
*     END;       /* STORAGE CLEARING COMPLETED */               02S0223
*   ELSE                                                        02S0224
*   OPTPARMP= 0;   /* CLEAR RETURN ADDR. */                     02S0224
         B     @RC00211                                         02S0224
@RF00211 SLR   @08,@08                                          02S0224
         ST    @08,OPTPARMP                                     02S0224
*   GTSTR15 = GTSTRTCD;    /* GTMN RETURN CODE */               02S0225
@RC00211 L     GTSTR15,GTSTRTCD                                 02S0225
*                                      /* RESTORE LIST PRINT STATUS  */
*RETCODE = REG15;                      /*SAVE RETURN CODE            */
         ST    REG15,RETCODE                                    02S0226
*IF RETCODE = ZERO THEN                /*CORE GOTTEN O.K. FOR PARMS  */
         L     @08,RETCODE                                      02S0227
         LTR   @08,@08                                          02S0227
         BNZ   @RF00227                                         02S0227
*  DO;                                 /*GET CANDIDATE LIST CORE     */
*    CNDLSTLN = (EDLUCBNO * FOUR) + FOUR; /*SET SIZE OF CANDIDATE LST*/
         L     @08,EDLGNTP                                      02S0229
         L     @08,EDLUCBNO(,@08)                               02S0229
         SLA   @08,2                                            02S0229
         AL    @08,@CF00138                                     02S0229
         ST    @08,CNDLSTLN                                     02S0229
*     /* ?GETSTORG (SPLNO,CNDLSTLN,CANDLSTP);*/                 02S0230
*       RFY (GTSTR0,GTSTR1,GTSTR2) RSTD; /*SAVE RGS*/           02S0230
*       GTSTR0 = CNDLSTLN; /* SET AMOUNT*/                      02S0231
         LR    GTSTR0,@08                                       02S0231
*       GTSTR2 = SPLNO; /* SET SUBPOOL*/                        02S0232
         LA    GTSTR2,253                                       02S0232
*       GENERATE CODE;                                          02S0233
         GETMAIN RC,LV=(0),SP=(2)  DO GETMAIN
*       GTSTRTCD = GTSTR15; /* SAVE GETMAIN RET COD*/           02S0234
         ST    GTSTR15,GTSTRTCD                                 02S0234
*       CANDLSTP = GTSTR1; /* ADDR OF GOTN STORG*/              02S0235
         ST    GTSTR1,CANDLSTP                                  02S0235
*       RFY (GTSTR0,GTSTR1,GTSTR2) UNRSTD; /*RLSE */            02S0236
*       IF GTSTRTCD = 0 THEN /*GETMAIN SUCCESSFUL? */           02S0237
         L     @08,GTSTRTCD                                     02S0237
         LTR   @08,@08                                          02S0237
         BNZ   @RF00237                                         02S0237
*         DO;               /* YES, CLEAR STORAGE.*/            02S0238
*           RFY (GTSTR2,GTSTR4,GTSTR5,GTSTR6,                   02S0239
*                              GTSTR7,GTSTR8) RSTD;             02S0239
*           GTSTR4 = CANDLSTP; /*STORG PTR*/                    02S0240
         L     @03,CANDLSTP                                     02S0240
         LR    GTSTR4,@03                                       02S0240
*           GTSTR5 = CNDLSTLN; /*STORG AMNT*/                   02S0241
         L     GTSTR5,CNDLSTLN                                  02S0241
*           GTSTR7 = '00000000'X; /*PAD CHAR & LNTH*/           02S0242
         SLR   GTSTR7,GTSTR7                                    02S0242
*           IF SPLNO = GTST253 THEN                             02S0243
*          GEN                                                  02S0244
*       (MODESET KEYADDR=GTSTZERO,SAVEKEY=(2),WORKREG=8);       02S0244
         MODESET KEYADDR=GTSTZERO,SAVEKEY=(2),WORKREG=8
*           GEN REFS(GTSTR4,GTSTR6);                            02S0245
              MVCL  GTSTR4,GTSTR6 CLEAR GOTTEN STORG
*           IF SPLNO = GTST253 THEN                             02S0246
*             GEN (MODESET KEYADDR=(2));                        02S0247
         MODESET KEYADDR=(2)
*           RFY (GTSTR2,GTSTR4,GTSTR5,GTSTR6,                   02S0248
*                              GTSTR7,GTSTR8) UNRSTD;           02S0248
*         END;       /* STORAGE CLEARING COMPLETED */           02S0249
*       ELSE                                                    02S0250
*       CANDLSTP= 0;   /* CLEAR RETURN ADDR. */                 02S0250
         B     @RC00237                                         02S0250
@RF00237 SLR   @08,@08                                          02S0250
         ST    @08,CANDLSTP                                     02S0250
*       GTSTR15 = GTSTRTCD;    /* GTMN RETURN CODE */           02S0251
@RC00237 L     GTSTR15,GTSTRTCD                                 02S0251
*                                      /* RESTORE LIST PRINT STATUS  */
*   /*GET CORE FOR LIST           */                            02S0252
*    RETCODE = REG15;                  /*SAVE RETURN CODE            */
         ST    REG15,RETCODE                                    02S0252
*    IF RETCODE = ZERO THEN            /*CORE GOTTEN FOR LIST        */
         L     @08,RETCODE                                      02S0253
         SLR   @15,@15                                          02S0253
         CR    @08,@15                                          02S0253
         BNE   @RF00253                                         02S0253
*      DO;                                                      02S0254
*        CANDCTR = ZERO;               /*INIT CANDIDATE CTR/INDEX    */
         ST    @15,CANDCTR                                      02S0255
*        EDLUCBLP = EDLLISTP;          /*SET PTR TO UCB LIST IN EDL  */
         L     @08,EDLGNTP                                      02S0256
         L     EDLUCBLP,EDLLISTP(,@08)                          02S0256
*         DO; /*MODESET  KEYADDR(ZERO)*/                        02S0257
*           SPKA (ZERO); /*SET PSW KEY*/                        02S0258
         SPKA  0(@15)                                           02S0258
*         END; /*MODESET  KEYADDR(ZERO)*/       /*GET KEY 0 TO BUILD LI
*T     */                                                       02S0259
*        CANDLPTR = CANDLSTP;          /*SET PTR TO LIST FOR OPT'ZER */
         L     @08,OPTPARMP                                     02S0260
         MVC   CANDLPTR(4,@08),CANDLSTP                         02S0260
*        DO DEVCTR = 1 TO EDLUCBNO;    /*SCAN ALL UCB'S IN GROUP     */
         LA    DEVCTR,1                                         02S0261
         B     @DE00261                                         02S0261
@DL00261 DS    0H                                               02S0262
*        IF EDLNOJES(DEVCTR)=OFF THEN  /*UCB ELIGIBLE (IF REQUEST
*                                        SELECTED BY JES3)   @ZA03855*/
         LR    @08,DEVCTR                                       02S0262
         SLA   @08,2                                            02S0262
         ST    @08,@TF00001                                     02S0262
         ALR   @08,EDLUCBLP                                     02S0262
         BCTR  @08,0                                            02S0262
         BCTR  @08,0                                            02S0262
         TM    EDLNOJES-2(@08),B'00001000'                      02S0262
         BNZ   @RF00262                                         02S0262
*          DO;                         /*                    @ZA03855*/
*            UCBPTR = EDLUCBAD(DEVCTR);  /*SET PTR TO UCB            */
         LR    @08,EDLUCBLP                                     02S0264
         AL    @08,@TF00001                                     02S0264
         AL    @08,@CF01892                                     02S0264
         SLR   @04,@04                                          02S0264
         ICM   @04,3,EDLUCBAD(@08)                              02S0264
         ST    @04,UCBPTR                                       02S0264
*            IF (UCBNALOC = NO &       /*NOT IN USE BY OLTEP         */
*              UCBONLI = YES &         /*IS ONLINE                   */
*              UCBALOC = NO) &         /*NOT ALLOCATED               */
*              ((UCB3DACC = YES &      /*NOT FIXED DASD              */
*              (UCBPRES = NO &                                  02S0265
*              UCBRESV = NO)) |                                 02S0265
*              (UCB3DACC=YES &         /*PERMRES DA          @YM05583*/
*              UCBPRES=YES &           /*                    @YM05583*/
*              UCBALOC = NO &          /*WITH NO VOL NOUNTED @YM05583*/
*              (UCBONLI = NO |         /*                    @YM05583*/
*              UCBVOLI = NOVOLSER |    /*                    @YM05583*/
*              UCBMOUNT = ON)) |       /*                    @YM05583*/
*              (UCB3TAPE = YES &       /*NOT RESERVED TAPE           */
*              UCBRESV = NO) |                                  02S0265
*              (UCB3DACC = NO &        /*NOT D.A., TAPE, ...         */
*              UCB3TAPE = NO &                                  02S0265
*              UCBSYSR = NO)) THEN     /*... NOR PRIMARY CONSOLE     */
         TM    UCBNALOC(@04),B'00000100'                        02S0265
         BNZ   @RF00265                                         02S0265
         TM    UCBONLI(@04),B'10000000'                         02S0265
         BNO   @RF00265                                         02S0265
         TM    UCBALOC(@04),B'00001000'                         02S0265
         BNZ   @RF00265                                         02S0265
         TM    UCB3DACC(@04),B'00100000'                        02S0265
         BNO   @GL00029                                         02S0265
         TM    UCBPRES(@04),B'00100100'                         02S0265
         BZ    @RT00265                                         02S0265
@GL00029 L     @08,UCBPTR                                       02S0265
         TM    UCB3DACC(@08),B'00100000'                        02S0265
         BNO   @GL00028                                         02S0265
         TM    UCBPRES(@08),B'00000100'                         02S0265
         BNO   @GL00028                                         02S0265
         TM    UCBALOC(@08),B'00001000'                         02S0265
         BNZ   @GL00028                                         02S0265
         TM    UCBONLI(@08),B'10000000'                         02S0265
         BZ    @RT00265                                         02S0265
         CLC   UCBVOLI(6,@08),NOVOLSER                          02S0265
         BE    @RT00265                                         02S0265
         TM    UCBMOUNT(@08),B'10000000'                        02S0265
         BO    @RT00265                                         02S0265
@GL00028 L     @08,UCBPTR                                       02S0265
         TM    UCB3TAPE(@08),B'10000000'                        02S0265
         BNO   @GL00027                                         02S0265
         TM    UCBRESV(@08),B'00100000'                         02S0265
         BZ    @RT00265                                         02S0265
@GL00027 L     @08,UCBPTR                                       02S0265
         TM    UCB3DACC(@08),B'10100000'                        02S0265
         BNZ   @RF00265                                         02S0265
         TM    UCBSYSR(@08),B'00000010'                         02S0265
         BNZ   @RF00265                                         02S0265
@RT00265 DS    0H                                               02S0266
*              DO;                     /*UNIT IS CANDIDATE FOR ALLOCN*/
*                IF SIOTDMND = NO THEN /*NOT A DEMAND REQUEST        */
         L     @08,SIOTPTR                                      02S0267
         TM    SIOTDMND(@08),B'10000000'                        02S0267
         BNZ   @RF00267                                         02S0267
*                  DO;                 /*SEE OF DMND REQ NEEDS UNIT  */
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - DMNDNEED                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - TEST IF UCB IS DEMANDED                       */
*/*                                                                  */
*/* FUNCTION - THIS ROUTINE DETERMINES IF THE INPUT UCB IS           */
*/*            NEEDED BY A DEMAND REQUEST (E.G. UNIT=190).           */
*/*                                                                  */
*/*   OPERATION - THE SIOT CHAIN IS SCANNED TO LOCATE EACH           */
*/*               DEMAND REQUEST.                                    */
*/*                                                                  */
*/* ENTRY - (INLINE SUBROUTINE)                                      */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*      SIOT1P - PTR TO THE FIRST SIOT IN THE CHAIN                 */
*/*        SIOTDMND - 1 FOR DEMAND REQUESTS                          */
*/*        SIOUCBAD - FOR DEMAND REQUEST, ADDRESS OF THE             */
*/*                   DEMANDED UCB                                   */
*/*        SIOTNPTR - PTR TO THE NEXT SIOT                           */
*/*      UCBPTR - PTR TO UCB                                         */
*/*                                                                  */
*/* EXIT - NORMAL - INLINE SUBROUTINE                                */
*/*                                                                  */
*/*   CONDITIONS - FUNCTION COMPLETED                                */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*       USEUCB - 1 = NO DEMAND REQ NEEDS THIS UCB                  */
*/*              - 0 = A DEMAND REQ NEEDS THIS UCB                   */
*/*                                                                  */
*/********************************************************************/
*USEUCB = ON;                          /*ASSUME UCB NOT DEMANDED     */
         OI    USEUCB,B'00000100'                               03S0269
*RFY INDMSIOT BASED(SPTR);                                      03S0270
*SPTR = SIOT1P;                        /*POINT TO THE FIRST SIOT     */
         L     @08,@PC00001                                     03S0271
         L     @08,ALCWAPTR(,@08)                               03S0271
         L     SPTR,SIOT1P(,@08)                                03S0271
*DO WHILE (SPTR ^= ZERO                /*SCAN ALL SIOTS ..           */
*    & USEUCB = ON);                   /*..UNTIL UCB FOUND DEMANDED  */
         B     @DE00272                                         03S0272
@DL00272 DS    0H                                               03S0273
*  IF SIOTDMND = ON                    /*DEMAND REQ FOR THIS UCB ?   */
*      & SIOUCBAD = UCBPTR THEN                                 03S0273
         TM    SIOTDMND(SPTR),B'10000000'                       03S0273
         BNO   @RF00273                                         03S0273
         SLR   @08,@08                                          03S0273
         ICM   @08,7,SIOUCBAD(SPTR)                             03S0273
         C     @08,UCBPTR                                       03S0273
         BNE   @RF00273                                         03S0273
*    DO;                               /*YES,INDICATE UCB IS DEMANDED*/
*      USEUCB = OFF;                                            03S0275
         NI    USEUCB,B'11111011'                               03S0275
*    END;                                                       03S0276
*  ELSE;                               /*NOT DEMAND REQ FOR THIS UCB */
@RF00273 DS    0H                                               03S0278
*  SPTR = SIOTNPTR;                    /*POINT TO THE NEXT SIOT      */
         L     SPTR,SIOTNPTR(,SPTR)                             03S0278
*END;                                                           03S0279
@DE00272 LTR   SPTR,SPTR                                        03S0279
         BZ    @DC00272                                         03S0279
         TM    USEUCB,B'00000100'                               03S0279
         BO    @DL00272                                         03S0279
@DC00272 DS    0H                                               03S0280
*RFY INDMSIOT BASED(SIOTPTR);                                   03S0280
*                  END;                                         02S0281
*                IF SIOTDMND = YES |   /*UNIT CAN BE USED            */
*                    USEUCB = YES THEN                          02S0282
@RF00267 L     @08,SIOTPTR                                      02S0282
         TM    SIOTDMND(@08),B'10000000'                        02S0282
         BO    @RT00282                                         02S0282
         TM    USEUCB,B'00000100'                               02S0282
         BNO   @RF00282                                         02S0282
@RT00282 DS    0H                                               02S0283
*                  DO;                                          02S0283
*                    CANDCTR = CANDCTR + ONE; /*INCR. NO. OF CANDIDATE
*                                           UCBS                     */
         LA    @08,1                                            02S0284
         AL    @08,CANDCTR                                      02S0284
         ST    @08,CANDCTR                                      02S0284
*                    CANDUCB(CANDCTR) = UCBPTR; /*PUT UCB ADDR  02S0285
*                                                 IN LIST            */
         SLA   @08,2                                            02S0285
         L     @04,UCBPTR                                       02S0285
         L     @02,CANDLSTP                                     02S0285
         ST    @04,CANDUCB-4(@08,@02)                           02S0285
*                  END;                                         02S0286
*              END;                                             02S0287
*            ELSE;                     /*UNIT NOT A CANDIDATE        */
@RF00265 DS    0H                                               02S0289
*          END;                        /*                    @ZA03855*/
*            ELSE;                     /*UCB INELIGIBLE BECAUSE OF
*                                        JES3                @ZA03855*/
@RF00262 DS    0H                                               02S0291
*        END;                                                   02S0291
@RC00262 AH    DEVCTR,@CH00066                                  02S0291
@DE00261 L     @08,EDLGNTP                                      02S0291
         C     DEVCTR,EDLUCBNO(,@08)                            02S0291
         BNH   @DL00261                                         02S0291
*         DO; /*MODESET  EXTKEY(SCHED)*/                        02S0292
*           SPKA (16); /*SET PSW KEY*/                          02S0293
         LA    @08,16                                           02S0293
         SPKA  0(@08)                                           02S0293
*         END; /*MODESET  EXTKEY(SCHED)*/       /*RETURN TO SCHEDULER K
*Y     */                                                       02S0294
*        IF CANDCTR > ONE  &           /*MORE THAN ONE CAND  @Y30LPPC*/
*           (EDLDEVT(2) & VIRTTYPE) = VIRTTYPE & /*VIRT DEV  @Y30LPPC*/
*           EDLDEVT(3:4) = THIRY330 THEN /*3330 DEVTYPE      @Y30LPPC*/
         L     @08,CANDCTR                                      02S0295
         CH    @08,@CH00066                                     02S0295
         BNH   @RF00295                                         02S0295
         MVC   @TS00001(1),EDLDEVT+1(EDLPTR)                    02S0295
         NC    @TS00001(1),VIRTTYPE                             02S0295
         CLC   @TS00001(1),VIRTTYPE                             02S0295
         BNE   @RF00295                                         02S0295
         CLC   EDLDEVT+2(2,EDLPTR),THIRY330                     02S0295
         BNE   @RF00295                                         02S0295
*          IF SIOTJES3=OFF|            /*JES3 DID NOT CHOOSE UNITS
*                                        OR                  @G18MP21*/
*             SU18BIT=OFF THEN         /*NON SU18 SYSTEM     @G18MP21*/
         L     @01,SIOTPTR                                      02S0296
         TM    SIOTJES3(@01),B'00100000'                        02S0296
         BZ    @RT00296                                         02S0296
         L     @01,CVTPTR                                       02S0296
         L     @01,CVTIHASU(,@01)                               02S0296
         TM    SU18BIT(@01),B'00100000'                         02S0296
         BNZ   @RF00296                                         02S0296
@RT00296 DS    0H                                               02S0297
*            DO;                       /*PERFORM MOUNT EQUALIZATION
*                                                            @G18MP21*/
*/********************************************************** @Y30LPPC*/
*/*                                                          @Y30LPPC*/
*/* SEGMENT NAME - MONTEQAL                                  @Y30LPPC*/
*/*                                                          @Y30LPPC*/
*/* DESCRIPTIVE NAME - PERFORM MOUNT EQUALIZATION            @Y30LPPC*/
*/*                                                          @Y30LPPC*/
*/* FUNCTION -                                               @Y30LPPC*/
*/*   THIS SEGMENT INTERFACES TO 3330V SOFTWARE TO           @Y30LPPC*/
*/* PERFORM MOUNT EQUALIZATION FOR 3330V REAL SPINDLE        @Y30LPPC*/
*/* GROUPS.  THE PURPOSE OF THIS PROCESSING IS TO BALANCE    @Y30LPPC*/
*/* THE LOAD ACROSS REAL SPINDLE GROUPS.                     @Y30LPPC*/
*/*                                                          @Y30LPPC*/
*/*   OEPRATION -                                            @Y30LPPC*/
*/*     INPUT TO THIS ROUTINE IS A UCB CANDIDATE LIST        @Y30LPPC*/
*/*   PREVIOUSLY BUILT BY THIS MODULE AND THE VOLUME         @Y30LPPC*/
*/*   SERIAL THAT IS BEING ALLOCATED.  THE 3330V SOFTWARE    @Y30LPPC*/
*/*   IS INVOKED VIA A CALL TO ICBME.  THE VOLID AND A       @Y30LPPC*/
*/*   WORKAREA USED BY ICBME ARE PASSED AS PARAMETERS.       @Y30LPPC*/
*/*   FOR THE FIRST CALL ONLY, THE ENTIRE WORKAREA IS        @Y30LPPC*/
*/*   SET TO ZERO.  THIS WORKAREA IS USED TO CONTAIN         @Y30LPPC*/
*/*   INFORMATION USED BY ICBME ON CALLS OTHER THAN          @Y30LPPC*/
*/*   THE FIRST.  ICBME RETURNS A LIST OF UCBS WHICH         @Y30LPPC*/
*/*   IT PREFERS.  THIS SEGMENT THEN TAKES THE INTERSECTION  @Y30LPPC*/
*/*   OF THE CANDIDATE LIST THAT WAS PREVIOUSLY BUILT AND    @Y30LPPC*/
*/*   THE LIST THAT WAS BUILT BY ICBME.  THE OLD             @Y30LPPC*/
*/*   CANDIDATE LIST IS FREED AND REPLACED BY THE NEW        @Y30LPPC*/
*/*   MERGED LIST.  THE NEW LIST WILL BE PASSED TO THE       @Y30LPPC*/
*/*   SYSTEM RESOURCE MANAGER TO SELECT THE OPTIMUM          @Y30LPPC*/
*/*   DEVICE.  IF THE INTERSECTION OF THE TWO LISTS IS NULL, @Y30LPPC*/
*/*   ICBME IS RE-INVOKED WITHOUT ZEROING THE WORKAREA.      @Y30LPPC*/
*/*   IF FOR ANY REASON ICBME CANNOT BUILD ITS UCB LIST,     @Y30LPPC*/
*/*   A ZERO ADDRESS OF THE LIST IS RETURNED AND THIS        @Y30LPPC*/
*/*   PROCESSING IS TERMINATED. IN THIS CASE, THE ORIGINAL   @Y30LPPC*/
*/*   CANDIDATE LIST IS USED.                                @Y30LPPC*/
*/*                                                          @Y30LPPC*/
*/* ENTRY - IN-LINE SUBROUTINE                               @Y30LPPC*/
*/*   PURPOSE - SEE FUNCTION                                 @Y30LPPC*/
*/*   INPUT -                                                @Y30LPPC*/
*/*     VOLID - VOLUME SERIAL PROM THE VOLUNIT TABLE.        @Y30LPPC*/
*/*     CNDLSTLN - LENGTH OF THE UCB CANDIDATE LIST.         @Y30LPPC*/
*/*     CANDLST - THE UCB CANDIDATE LIST.                    @Y30LPPC*/
*/*                                                          @Y30LPPC*/
*/* EXIT-NORMAL - RETURN TO CALLER                           @Y30LPPC*/
*/*   CONDITION - A MERGED UCB LIST HAS BEEN CREATED.        @Y30LPPC*/
*/*   OUTPUT -                                               @Y30LPPC*/
*/*     NEWUCBLS - THE MERGED UCBLIST                        @Y30LPPC*/
*/*     CANDLSTP - ADDR OF THE NEW UCBLIST                   @Y30LPPC*/
*/*     CANDLPTR - ADDR OF THE NEW UCBLIST                   @Y30LPPC*/
*/*     CANDCTR - NUMBER OF ENTRIES IN THE NEW UCB LIST      @Y30LPPC*/
*/*     CANDLST - FREED                                      @Y30LPPC*/
*/*   RETURN CODES - NONE                                    @Y30LPPC*/
*/*                                                          @Y30LPPC*/
*/* EXIT-ERROR - RETURN TO CALLER                            @Y30LPPC*/
*/*   CONDITION - UNABLE TO CREATE A MERGED LIST             @Y30LPPC*/
*/*   OUTPUT - NONE                                          @Y30LPPC*/
*/*   RETURN CODES - NONE                                    @Y30LPPC*/
*/*                                                          @Y30LPPC*/
*/********************************************************** @Y30LPPC*/
*IF CVTICB ^= ZERO &                   /*ADDR OF SSC C.B.    @ZM00427*/
*   ICBMEP ^= ZERO THEN                /*ADDR OF ICBME       @ZM00427*/
         SLR   @15,@15                                          03S0298
         L     @01,CVTPTR                                       03S0298
         L     @01,CVTEXT2(,@01)                                03S0298
         L     @14,CVTICB(,@01)                                 03S0298
         CR    @14,@15                                          03S0298
         BE    @RF00298                                         03S0298
         C     @15,ICBMEP(,@14)                                 03S0298
         BE    @RF00298                                         03S0298
*  DO;                                 /*DO MOUNT EQUAL.     @Y30LPPC*/
*    SSCWKARE = SSCWKARE && SSCWKARE;  /*CLEAR SSC WORK AREA @Y30LPPC*/
         XC    SSCWKARE(244),SSCWKARE                           03S0300
*    SSCVOLID = NOVOLSER;              /*INIT VOLSER TO 0    @Y30LPPC*/
         MVC   SSCVOLID(6),NOVOLSER                             03S0301
*    SSCUCBLP = ZERO;                  /*INIT UCB LIST ADDR  @Y30LPPC*/
         ST    @15,SSCUCBLP                                     03S0302
*    IF VOLID(ONE) ^= NONSPEC &        /*SPECIFIC REQUEST    @YM00427*/
*       VOLID(ONE) ^= NONSPECT THEN    /*                    @ZM00427*/
         L     @15,VUPTR                                        03S0303
         CLC   VOLID(1,@15),NONSPEC                             03S0303
         BE    @RF00303                                         03S0303
         CLC   VOLID(1,@15),NONSPECT                            03S0303
         BE    @RF00303                                         03S0303
*      SSCVOLID = VOLID;               /*VOLID FOR ICBME     @Y30LPPC*/
         MVC   SSCVOLID(6),VOLID(@15)                           03S0304
*    NEWLPTR = ZERO;                   /*INIT NEW LIST ADDR  @Y30LPPC*/
@RF00303 SLR   NEWLPTR,NEWLPTR                                  03S0305
*     /* ?GETSTORG (SPLNO,CNDLSTLN,NEWLPTR);*/                  03S0306
*       RFY (GTSTR0,GTSTR1,GTSTR2) RSTD; /*SAVE RGS*/           03S0306
*       GTSTR0 = CNDLSTLN; /* SET AMOUNT*/                      03S0307
         L     GTSTR0,CNDLSTLN                                  03S0307
*       GTSTR2 = SPLNO; /* SET SUBPOOL*/                        03S0308
         LA    GTSTR2,253                                       03S0308
*       GENERATE CODE;                                          03S0309
         GETMAIN RC,LV=(0),SP=(2)  DO GETMAIN
*       GTSTRTCD = GTSTR15; /* SAVE GETMAIN RET COD*/           03S0310
         ST    GTSTR15,GTSTRTCD                                 03S0310
*       NEWLPTR = GTSTR1; /* ADDR OF GOTN STORG*/               03S0311
         LR    NEWLPTR,GTSTR1                                   03S0311
*       RFY (GTSTR0,GTSTR1,GTSTR2) UNRSTD; /*RLSE */            03S0312
*       IF GTSTRTCD = 0 THEN /*GETMAIN SUCCESSFUL? */           03S0313
         L     @08,GTSTRTCD                                     03S0313
         LTR   @08,@08                                          03S0313
         BNZ   @RF00313                                         03S0313
*         DO;               /* YES, CLEAR STORAGE.*/            03S0314
*           RFY (GTSTR2,GTSTR4,GTSTR5,GTSTR6,                   03S0315
*                              GTSTR7,GTSTR8) RSTD;             03S0315
*           GTSTR4 = NEWLPTR; /*STORG PTR*/                     03S0316
         LR    GTSTR4,NEWLPTR                                   03S0316
*           GTSTR5 = CNDLSTLN; /*STORG AMNT*/                   03S0317
         L     GTSTR5,CNDLSTLN                                  03S0317
*           GTSTR7 = '00000000'X; /*PAD CHAR & LNTH*/           03S0318
         SLR   GTSTR7,GTSTR7                                    03S0318
*           IF SPLNO = GTST253 THEN                             03S0319
*          GEN                                                  03S0320
*       (MODESET KEYADDR=GTSTZERO,SAVEKEY=(2),WORKREG=8);       03S0320
         MODESET KEYADDR=GTSTZERO,SAVEKEY=(2),WORKREG=8
*           GEN REFS(GTSTR4,GTSTR6);                            03S0321
              MVCL  GTSTR4,GTSTR6 CLEAR GOTTEN STORG
*           IF SPLNO = GTST253 THEN                             03S0322
*             GEN (MODESET KEYADDR=(2));                        03S0323
         MODESET KEYADDR=(2)
*           RFY (GTSTR2,GTSTR4,GTSTR5,GTSTR6,                   03S0324
*                              GTSTR7,GTSTR8) UNRSTD;           03S0324
*         END;       /* STORAGE CLEARING COMPLETED */           03S0325
*       ELSE                                                    03S0326
*       NEWLPTR= 0;   /* CLEAR RETURN ADDR. */                  03S0326
         B     @RC00313                                         03S0326
@RF00313 SLR   NEWLPTR,NEWLPTR                                  03S0326
*       GTSTR15 = GTSTRTCD;    /* GTMN RETURN CODE */           03S0327
@RC00313 L     GTSTR15,GTSTRTCD                                 03S0327
*                                      /* RESTORE LIST PRINT STATUS  */
*/*CORE FOR NEW LST  @Y30LPPC*/                                 03S0328
*    IF REG15 = ZERO THEN              /*GETMAIN OK          @Y30LPPC*/
         LTR   REG15,REG15                                      03S0328
         BNZ   @RF00328                                         03S0328
*      DO;                             /*CONTINUE            @Y30LPPC*/
*        DONESW = OFF;                 /*INIT LOOP CONTROL   @Y30LPPC*/
         NI    DONESW,B'01111111'                               03S0330
*        DO WHILE (DONESW = OFF);      /*LOOP UNTIL DONE     @Y30LPPC*/
         B     @DE00331                                         03S0331
@DL00331 DS    0H                                               03S0332
*          CALL ICBME(SSCVOLID,SSCWKARE,SSCUCBLP); /*GET THE    03S0332
*                                        NEW UCB LIST        @Y30LPPC*/
         LA    @08,SSCVOLID                                     03S0332
         ST    @08,@AL00001                                     03S0332
         LA    @08,SSCWKARE                                     03S0332
         ST    @08,@AL00001+4                                   03S0332
         LA    @08,SSCUCBLP                                     03S0332
         ST    @08,@AL00001+8                                   03S0332
         L     @08,CVTPTR                                       03S0332
         L     @08,CVTEXT2(,@08)                                03S0332
         L     @08,CVTICB(,@08)                                 03S0332
         L     @15,ICBMEP(,@08)                                 03S0332
         LA    @01,@AL00001                                     03S0332
         BALR  @14,@15                                          03S0332
*          IF SSCUCBLP ^= ZERO THEN    /*A LIST WAS BUILT    @Y30LPPC*/
         SLR   @08,@08                                          03S0333
         C     @08,SSCUCBLP                                     03S0333
         BE    @RF00333                                         03S0333
*            DO;                       /*MERGE THE LISTS     @Y30LPPC*/
*              NEWLCTR = ONE;          /*INIT NEW LIST ADDR  @Y30LPPC*/
         LA    @15,1                                            03S0335
         LR    NEWLCTR,@15                                      03S0335
*               DO; /*MODESET  KEYADDR(ZERO)*/                  03S0336
*                 SPKA (ZERO); /*SET PSW KEY*/                  03S0337
         SPKA  0(@08)                                           03S0337
*               END; /*MODESET  KEYADDR(ZERO)*/ /*KEY 0 FOR LIST BUILD@
*30LPPC*/                                                       03S0338
*              DO OLDLCTR = ONE TO CANDCTR; /*SCAN OLD LIST  @Y30LPPC*/
         LR    OLDLCTR,@15                                      03S0339
         B     @DE00339                                         03S0339
@DL00339 DS    0H                                               03S0340
*                FOUNDSW = OFF;        /*NO MATCH YET        @Y30LPPC*/
         NI    FOUNDSW,B'11011111'                              03S0340
*                DO SSCLCTR = ONE TO SSCLNUCB  /*SCAN SSC LST@Y30LPPC*/
*                   WHILE (FOUNDSW = OFF); /*STOP IF FOUND   @Y30LPPC*/
         LA    SSCLCTR,1                                        03S0341
         B     @DE00341                                         03S0341
@DL00341 TM    FOUNDSW,B'00100000'                              03S0341
         BNZ   @DC00341                                         03S0341
*                  IF CANDUCB(OLDLCTR) = /*OLD LIST ENTRY    @Y30LPPC*/
*                     SSCLUCBP(SSCLCTR) THEN /*NEW LIST ENT  @Y30LPPC*/
         LR    @08,OLDLCTR                                      03S0342
         SLA   @08,2                                            03S0342
         L     @05,CANDLSTP                                     03S0342
         L     @08,CANDUCB-4(@08,@05)                           03S0342
         LR    @05,SSCLCTR                                      03S0342
         SLA   @05,2                                            03S0342
         L     @01,SSCUCBLP                                     03S0342
         C     @08,SSCLUCBP-4(@05,@01)                          03S0342
         BNE   @RF00342                                         03S0342
*                    DO;               /*ADD UCB TO NEW LIST @Y30LPPC*/
*                      NEWLUCBP(NEWLCTR)= CANDUCB(OLDLCTR);/*@Y30LPPC*/
         LR    @05,NEWLCTR                                      03S0344
         SLA   @05,2                                            03S0344
         ST    @08,NEWLUCBP-4(@05,NEWLPTR)                      03S0344
*                      NEWLCANO = NEWLCTR; /*SET NUM ENTRIES @Y30LPPC*/
         ST    NEWLCTR,NEWLCANO(,NEWLPTR)                       03S0345
*                      NEWLCTR = NEWLCTR + ONE; /*NEXT ENT   @Y30LPPC*/
         AH    NEWLCTR,@CH00066                                 03S0346
*                      DONESW = ON;    /*OK TO QUIT          @Y30LPPC*/
*                      FOUNDSW = ON;   /*A MATCH WAS FOUND   @Y30LPPC*/
         OI    DONESW,B'10100000'                               03S0348
*                    END;              /*END ADD UCB         @Y30LPPC*/
*                END;                  /*END SCAN SSC LIST   @Y30LPPC*/
@RF00342 AH    SSCLCTR,@CH00066                                 03S0350
@DE00341 L     @08,SSCUCBLP                                     03S0350
         C     SSCLCTR,SSCLNUCB(,@08)                           03S0350
         BNH   @DL00341                                         03S0350
@DC00341 DS    0H                                               03S0351
*              END;                    /*END SCAN OLD LIST   @Y30LPPC*/
         AH    OLDLCTR,@CH00066                                 03S0351
@DE00339 C     OLDLCTR,CANDCTR                                  03S0351
         BNH   @DL00339                                         03S0351
*               DO; /*MODESET  EXTKEY(SCHED)*/                  03S0352
*                 SPKA (16); /*SET PSW KEY*/                    03S0353
         LA    @08,16                                           03S0353
         SPKA  0(@08)                                           03S0353
*               END; /*MODESET  EXTKEY(SCHED)*/ /*RESUME SCHED KEY    @
*30LPPC*/                                                       03S0354
*              RFY (REG0,REG1) RSTD;   /*                    @Y30LPPC*/
*              REG0 = SSCLSPLN;        /*SUBPOOL AND LENGTH  @Y30LPPC*/
         L     @08,SSCUCBLP                                     03S0356
         L     REG0,SSCLSPLN(,@08)                              03S0356
*              REG1 = SSCUCBLP;        /*ADDRESS OF LIST     @Y30LPPC*/
         LR    REG1,@08                                         03S0357
*              GEN (FREEMAIN R,LV=(0),A=(1)); /*FREE LIST    @Y30LPPC*/
         FREEMAIN R,LV=(0),A=(1)
*              RFY (REG0,REG1) UNRSTD; /*                    @Y30LPPC*/
*              SSCUCBLP = ZERO;        /*ZERO LIST ADDR      @ZM00427*/
         SLR   @08,@08                                          03S0360
         ST    @08,SSCUCBLP                                     03S0360
*              IF DONESW = ON THEN     /*NEW LIST BUILT      @Y30LPPC*/
         TM    DONESW,B'10000000'                               03S0361
         BNO   @RF00361                                         03S0361
*                DO;                   /*FREE OLD LIST       @Y30LPPC*/
*                  RFY (REG0,REG1) RSTD;/*                   @Y30LPPC*/
*                  REG0 = CNDLSTLN;    /*LENGTH OF OLD LIST  @Y30LPPC*/
         L     REG0,CNDLSTLN                                    03S0364
*                  REG0 = REG0 | FREESPNO; /* OR IN SUBPOOL  @Y30LPPC*/
         O     REG0,@CF00158                                    03S0365
*                  REG1 = CANDLSTP;    /*ADDR OF OLD LIST    @Y30LPPC*/
         L     REG1,CANDLSTP                                    03S0366
*                  GEN (FREEMAIN R,LV=(0),A=(1)); /*FREE LST @Y30LPPC*/
         FREEMAIN R,LV=(0),A=(1)
*                  RFY (REG0,REG1) UNRSTD;/*                 @Y30LPPC*/
*                  CANDLSTP = NEWLPTR; /*POINT TO NEW LIST   @Y30LPPC*/
         ST    NEWLPTR,CANDLSTP                                 03S0369
*                   DO; /*MODESET  KEYADDR(ZERO)*/              03S0370
*                     SPKA (ZERO); /*SET PSW KEY*/              03S0371
         SLR   @08,@08                                          03S0371
         SPKA  0(@08)                                           03S0371
*                   END; /*MODESET  KEYADDR(ZERO)*//*KEY ZERO FOR OPT @
*30LPPC*/                                                       03S0372
*                  CANDLPTR = NEWLPTR; /*POINT OPTPARMS TO      03S0373
*                                        NEW LIST            @Y30LPPC*/
         L     @08,OPTPARMP                                     03S0373
         ST    NEWLPTR,CANDLPTR(,@08)                           03S0373
*                  CANDCTR = NEWLCANO; /*SET TO NEW LIST     @Y30LPPC*/
         MVC   CANDCTR(4),NEWLCANO(NEWLPTR)                     03S0374
*                  NEWLPTR = ZERO;     /*CLEAR NEW LIST ADDR @Y30LPPC*/
         SLR   NEWLPTR,NEWLPTR                                  03S0375
*                   DO; /*MODESET  EXTKEY(SCHED)*/              03S0376
*                     SPKA (16); /*SET PSW KEY*/                03S0377
         LA    @08,16                                           03S0377
         SPKA  0(@08)                                           03S0377
*                   END; /*MODESET  EXTKEY(SCHED)*/ /*RESUME SCHED KEY@
*30LPPC*/                                                       03S0378
*                END;                  /*END FREE OLD LIST   @Y30LPPC*/
*             END;                     /*END MERGE LISTS     @Y30LPPC*/
*           ELSE                       /*NO LIST BUILT BY SSC@Y30LPPC*/
*             DONESW = ON;             /*GIVE UP             @Y30LPPC*/
         B     @RC00333                                         03S0381
@RF00333 OI    DONESW,B'10000000'                               03S0381
*         END;                         /*END LOOP UNTIL OK   @Y30LPPC*/
@RC00333 DS    0H                                               03S0382
@DE00331 TM    DONESW,B'10000000'                               03S0382
         BZ    @DL00331                                         03S0382
*       IF NEWLPTR ^= ZERO THEN        /*NEW LIST MUST BE FREED 03S0383
*                                                            @Y30LPPC*/
         LTR   NEWLPTR,NEWLPTR                                  03S0383
         BZ    @RF00383                                         03S0383
*         DO;                          /*FREE NEW LIST       @Y30LPPC*/
*           RFY (REG0,REG1) RSTD;      /*                    @Y30LPPC*/
*           REG0 = CNDLSTLN;           /*LENGTH TO FREE      @Y30LPPC*/
         L     REG0,CNDLSTLN                                    03S0386
*           REG0 = REG0 | FREESPNO;    /*SUBPOOL TO FREE     @Y30LPPC*/
         O     REG0,@CF00158                                    03S0387
*           REG1 = NEWLPTR;            /*ADDR TO FREE        @Y30LPPC*/
         LR    REG1,NEWLPTR                                     03S0388
*           GEN (FREEMAIN R,LV=(0),A=(1)); /*FREE THE LIST   @Y30LPPC*/
         FREEMAIN R,LV=(0),A=(1)
*           RFY (REG0,REG1) UNRSTD;    /*                    @Y30LPPC*/
*         END;                                                  03S0391
*       END;                           /*END CONTINUE        @Y30LPPC*/
@RF00383 DS    0H                                               03S0393
*  END;                                /*END DO MOUNT EQUAL  @Y30LPPC*/
@RF00328 DS    0H                                               03S0394
*            END;                      /*END MNT. EQUAL.     @G18MP21*/
@RF00298 DS    0H                                               02S0395
*        IF CANDCTR > ZERO THEN        /*LIST IS NOT EMPTY           */
@RF00296 DS    0H                                               02S0395
@RF00295 ICM   @15,15,CANDCTR                                   02S0395
         BNP   @RF00395                                         02S0395
*          DO;                         /*TRY TO ALLOC FROM CANDIDATES*/
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - CHKCANDS                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - CHECK CANDIDATES AGAINST UNITS REQUIRED       */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE DETERMINES WHETHER OR NOT THERE ARE ENOUGH UNITS  */
*/*   IN THE INPUT CANDIDATE LIST TO COVER ALL REQUESTS NEEDING      */
*/*   UNITS FROM THE DEVICE GROUP THE LIST REPRESENTS. IF THERE ARE  */
*/*   ENOUGH UNITS, OR IF THIS IS A DEMAND REQUEST FOR THE UNIT, AN  */
*/*   ATTEMPT IS MADE TO ALLOCATE THE INPUT REQUEST TO ONE OF        */
*/*   THE AVAILABLE UNITS. IF, HOWEVER, THE VOLUNIT ENTRY STILL      */
*/*   MUST WAIT FOR A VOLUME TO BECOME AVAILABLE A UNIT WILL NOT     */
*/*   BE ALLOCATED UNTIL THE VOLUME CAN BE OBTAINED. IN THIS CASE    */
*/*   THE GROUP BEING PROCESSED IS 'ALLOCATED' TO THE REQUEST AND    */
*/*   THE COVER/REDUCE ALGORITHM IS USED TO REDUCE THE SOLUTIONS FOR */
*/*   THE REMAINING REQUESTS.                                        */
*/*                                                                  */
*/*   OPERATION -                                                    */
*/*     IF ANY OF THE DEVICES THAT HAVE COME ONLINE ARE      @ZA10805*/
*/*     LEFT, THE INPUT REQUEST WILL BE ALLOCATED. IF ALL    @ZA10805*/
*/*     ALL OF THESE UNITS HAVE BEEN USED BUT THERE ARE      @ZA10805*/
*/*     ADDITIONAL AVAILABLE UNITS THAT ARE NOT ALREADY      @ZA10805*/
*/*     COMMITTED TO OTHER REQUESTS, THE INPUT REQUEST WILL  @ZA10805*/
*/*     BE ALLOCATED. THESE REQUESTS THAT ARE COMMITTED TO   @ZA10805*/
*/*     TO DEVICES BUT NOT YET ALLOCATED ARE REQUESTS THAT   @ZA10805*/
*/*     THE OPERATOR REPLIED WAIT TO. SINCE SOME OF THE      @ZA10805*/
*/*     DEVICES THAT WERE ALLOCATED TO OTHER JOBS MAY NOW    @ZA10805*/
*/*     HAVE BECOME UNALLOCATED, WE CAN NOT ALLOCATE ANY OF  @ZA10805*/
*/*     AVAILABLE DEVICES HERE UNLESS THERE ARE MORE THAN    @ZA10805*/
*/*     ARE REQUIRED BY THESE WAIT REQUESTS.                 @ZA10805*/
*/*                                                                  */
*/* ENTRY -                                                          */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*   INPUT -                                                        */
*/*     ALCWAPTR - PTR TO ALLOCATION WORK AREA                       */
*/*       VOLUNPTR - PTR TO FIRST VOLUNIT ENTRY                      */
*/*       ALGPARMP - PTR TO ALGORITHM INTERFACE AREA                 */
*/*     CANDCTR   - NUMBER OF UCBS IN CANDIDATE LIST                 */
*/*     CANDLST   - UCB CANDIDATE LIST                               */
*/*     SIOTPTR   - PTR TO SIOT BEING PROCESSED                      */
*/*     VUPTR   - PTR TO VOLUNIT ENTRY BEING PROCESSED               */
*/*     ARUGRPID - ID OF DEVICE GROUP BEING PROCESSED                */
*/*                                                                  */
*/* EXITS -                                                          */
*/*   CONDITION - NOT ENOUGH CANDIDATES TO COVER REQUESTS FOR GROUP  */
*/*     OUTPUT - NONE                                                */
*/*     RETURN CODES - NONE                                          */
*/*   CONDITION - REQUEST CAN BE ALLOCATED FROM CANDIDATES           */
*/*     OUTPUT + RETURN CODES -                                      */
*/*       SEE SPEC FOR SEGMENT 'ALOCENT'                             */
*/*   CONDITION - REQUEST MUST WAIT FOR VOLUME                       */
*/*     OUTPUT -                                                     */
*/*       GROUP LIST ENTRY UPDATED                                   */
*/*       ALGORITHM TABLES UPDATED                                   */
*/*       VU ENTRY UPDATED TO INDICATE RECOVERY PROCESSING DONE      */
*/*     RETURN CODES - NONE                                          */
*/*   CONDITION - GETMAIN ERROR IN COVER/REDUCE ALGORITHM            */
*/*     OUTPUT -                                                     */
*/*       STEP-RELATED REASON CODE (RSNCODE) = 2                     */
*/*     RETURN CODES -                                               */
*/*       RETCODE = 4                                                */
*/*                                                                  */
*/********************************************************************/
*AURQDCTR = ZERO;                      /*INIT # UNITS NEEDED TO COVER*/
         SLR   AURQDCTR,AURQDCTR                                03S0397
*RFY CVRGPLST BASED(AGPLPTR);          /*SET TEMP BASE PTR FOR LIST  */
*RFY VOLUNTAB BASED(AVUPTR);           /*SET TEMP BASE PTR FOR VU'S  */
*AVUPTR = VOLUNPTR;                    /*POINT TO FIRST VU ENTRY     */
         L     @04,@PC00001                                     03S0400
         L     @04,ALCWAPTR(,@04)                               03S0400
         L     AVUPTR,VOLUNPTR(,@04)                            03S0400
*DO AVUCTR = 1 TO VOLUNSZE/LENGTH(VOLUNTAB); /*SCAN VOLUNIT TABLE    */
         LA    AVUCTR,1                                         03S0401
         B     @DE00401                                         03S0401
@DL00401 DS    0H                                               03S0402
*  AGPLPTR = VOLALGTP -> CVRGRPPT;     /*POINT TO GROUP LIST ENTRY   */
         L     @15,VOLALGTP(,AVUPTR)                            03S0402
         L     AGPLPTR,CVRGRPPT(,@15)                           03S0402
*  IF VOLALOC = NO &                   /*ENTRY NOT YET ALLOCATED     */
*      VURCVYPR = YES &                /*ENTRY WILL REQUIRE A UNIT   */
*      VOLALGTP -> CVRSKFLG = NO THEN  /*VU CONSIDERED BY ALGORITHM  */
         TM    VOLALOC(AVUPTR),B'10000000'                      03S0403
         BNZ   @RF00403                                         03S0403
         TM    VURCVYPR(AVUPTR),B'00000001'                     03S0403
         BNO   @RF00403                                         03S0403
         TM    CVRSKFLG(@15),B'10000000'                        03S0403
         BNZ   @RF00403                                         03S0403
*    DO AGRPCTR = 1 TO VOLALGTP -> CVRNGRP; /*SEE IF NEED UNIT IN
*                                        THIS GROUP                  */
         LA    AGRPCTR,1                                        03S0404
         B     @DE00404                                         03S0404
@DL00404 DS    0H                                               03S0405
*      IF CVRGRPID = ARUGRPID &        /*ENTRY IS FOR GRP BEING PRC'D*/
*          CVRGSKP = NO &              /*GROUP IS ELIGIBLE           */
*          CVRGRPAL = ALLOCD THEN      /*GROUP HAS BEEN ALLOC'D      */
         LH    @07,CVRGRPID(,AGPLPTR)                           03S0405
         C     @07,ARUGRPID                                     03S0405
         BNE   @RF00405                                         03S0405
         TM    CVRGSKP(AGPLPTR),B'10000000'                     03S0405
         BNZ   @RF00405                                         03S0405
         LA    @07,1                                            03S0405
         CH    @07,CVRGRPAL(,AGPLPTR)                           03S0405
         BNE   @RF00405                                         03S0405
*        DO;                           /*UNIT REQUIRED FROM THIS GRP */
*          AURQDCTR = AURQDCTR + ONE;  /*INCREMENT NO. UNITS REQ'D   */
         ALR   AURQDCTR,@07                                     03S0407
*        END;                                                   03S0408
*      ELSE;                                                    03S0409
@RF00405 DS    0H                                               03S0410
*      AGPLPTR = AGPLPTR + LENGTH(CVRGPLST); /*PT TO NEXT ENTRY      */
         AH    AGPLPTR,@CH00047                                 03S0410
*    END;                                                       03S0411
         AH    AGRPCTR,@CH00066                                 03S0411
@DE00404 L     @07,VOLALGTP(,AVUPTR)                            03S0411
         CH    AGRPCTR,CVRNGRP(,@07)                            03S0411
         BNH   @DL00404                                         03S0411
*  ELSE;                                                        03S0412
@RF00403 DS    0H                                               03S0413
*  AVUPTR = AVUPTR + LENGTH(VOLUNTAB); /*POINT TO NEXT VU ENTRY      */
         AL    AVUPTR,@CF00085                                  03S0413
*END;                                                           03S0414
         AH    AVUCTR,@CH00066                                  03S0414
@DE00401 L     @03,@PC00001                                     03S0414
         L     @03,ALCWAPTR(,@03)                               03S0414
         L     @00,VOLUNSZE(,@03)                               03S0414
         SRDA  @00,32                                           03S0414
         D     @00,@CF00085                                     03S0414
         CR    AVUCTR,@01                                       03S0414
         BNH   @DL00401                                         03S0414
*RFY VOLUNTAB BASED(VUPTR);                                     03S0415
*RFY CVRGPLST BASED(GPLSTPTR);                                  03S0416
*IF SIOTDMND = YES |                   /*CAN ALLOC WITH CANDIDATES   */
*   (CANDCTR > AURQDCTR |                                       03S0417
*   NEWONS > ZERO) THEN                /*NEW ONLINES LEFT    @ZA10805*/
         L     @04,SIOTPTR                                      03S0417
         TM    SIOTDMND(@04),B'10000000'                        03S0417
         BO    @RT00417                                         03S0417
         C     AURQDCTR,CANDCTR                                 03S0417
         BL    @RT00417                                         03S0417
         ICM   @04,15,NEWONS                                    03S0417
         BNP   @RF00417                                         03S0417
@RT00417 DS    0H                                               03S0418
*  IF CVRWUCBP = ZERO THEN             /*REQ ISN'T WAITING FOR VOL   */
         L     @01,RQLSTPTR                                     03S0418
         ICM   @00,3,CVRWUCBP(@01)                              03S0418
         BNZ   @RF00418                                         03S0418
*    DO;                                                        03S0419
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - ALOCENT                                           */
*/*                                                                  */
*/* DESCRIPTIVE NAME - ALLOC A VOLUNIT ENTRY FROM A CANDIDATE LIST   */
*/*                                                                  */
*/* FUNCTION - THIS ROUTINE IS INVOKED TO ALLOCATE A VOLUNIT ENTRY   */
*/*            TO A DEVICE FROM THE INPUT CANDIDATE LIST.            */
*/*                                                                  */
*/*   OPERATION - THE OPTIMIZER (SYSEVENT) IS CALLED TO PICK A       */
*/*               DEVICE IF THERE IS MORE THAN ONE DEVICE            */
*/*               IN THE CANDIDATE LIST.                             */
*/*                                                                  */
*/*               THE REST OF THE OPERATION IS DOCUMENTED BY THE     */
*/*               CODE ITSELF.                                       */
*/*                                                                  */
*/* ENTRY - (INLINE SUBROUTINE)                                      */
*/*                                                                  */
*/*   PURPOSE - (SEE FUNCTION)                                       */
*/*                                                                  */
*/*   INPUT - CANDCTR - NUMBER OF UCBS IN THE CANDIDATE LIST.        */
*/*         - CANDLST - UCB CANDIDATE LIST                           */
*/*         - SIOTPTR - PTR TO THE SIOT BEING PROCESSED              */
*/*         - VUPTR  - PTR TO THE VOLUNIT ENTRY TO BE ALLOCATED      */
*/*         - ALCWAPTR - PTR TO THE ALLOCATION WORK AREA             */
*/*         - ARUGRPID - ID OF THE DEVICE GROUP TO BE ALLOCATED      */
*/*                                                                  */
*/* EXIT - NORMAL - (INLINE SUBROUTINE)                              */
*/*                                                                  */
*/*   CONDITION - THE VOLUNIT ENTRY WAS SUCCESSFULLY ALLOCATED       */
*/*                                                                  */
*/*   OUTPUT - (NONE FROM THIS SEGMENT. SEE THE SPECS FOR MODULE     */
*/*            IEFAB434 AND SEGMENT PRCRTNC.)                        */
*/*                                                                  */
*/*   RETURN CODES - RETCODE SET TO 0                                */
*/*                                                                  */
*/* EXIT - ERROR - (INLINE SUBROUTINE)                               */
*/*                                                                  */
*/*   CONDITION - ERROR OCCURRED IN EITHER MODULE IEFAB440 OR        */
*/*               SYSEVENT.                                          */
*/*                                                                  */
*/*   OUTPUT - IF THE ERROR OCCURRED IN MODULE IEFAB440, THAT        */
*/*            MODULE WILL SET AN ERROR REASON CODE ITSELF.          */
*/*            IF THE ERROR OCCURRED IN SYSEVENT , AN ERROR          */
*/*            REASON CODE OF 9 IS PUT IN FIELD RSNCODE.             */
*/*                                                                  */
*/*    RETURN CODES - RETCODE SET TO 4                               */
*/*                                                                  */
*/* EXIT - ERROR - (INLINE SUBROUTINE)                               */
*/*                                                                  */
*/*   CONDITION - AN ERROR WAS DETECTED BY MODULE IEFAB434.          */
*/*                                                                  */
*/*   OUTPUT + RETURN CODES - (SEE THE SPEC FOR THE SEGMENT          */
*/*                            'PRCRTNC' WHICH PROCESSES THE INFO    */
*/*                            RETURNED FROM IEFAB434)               */
*/*                                                                  */
*/********************************************************************/
*IF CANDCTR > ONE THEN                 /*MORE THAN ONE CANDIDATE ?   */
         L     @15,CANDCTR                                      04S0420
         CH    @15,@CH00066                                     04S0420
         BNH   @RF00420                                         04S0420
*  DO;                                 /*YES, USE OPTIMIZER          */
*    CALL IEFAB440 (ALCWAPTR,AUCBSP,ALCULEN); /*BUILD ALCD UCB LIST  */
         L     @15,@PC00001                                     04S0422
         ST    @15,@AL00001                                     04S0422
         LA    @15,AUCBSP                                       04S0422
         ST    @15,@AL00001+4                                   04S0422
         LA    @15,ALCULEN                                      04S0422
         ST    @15,@AL00001+8                                   04S0422
         L     @15,@CV00151                                     04S0422
         LA    @01,@AL00001                                     04S0422
         BALR  @14,@15                                          04S0422
*    RETCODE = REG15;                  /*SAVE THE RETURN CODE        */
         ST    REG15,RETCODE                                    04S0423
*    IF RETCODE = ZERO THEN            /*ANY ERROR ?                 */
         L     @15,RETCODE                                      04S0424
         SLR   @14,@14                                          04S0424
         CR    @15,@14                                          04S0424
         BNE   @RF00424                                         04S0424
*      DO;                             /*NO, CONTINUE PROCESSING     */
*         DO; /*MODESET  KEYADDR(ZERO)*/                        04S0426
*           SPKA (ZERO); /*SET PSW KEY*/                        04S0427
         SPKA  0(@14)                                           04S0427
*         END; /*MODESET  KEYADDR(ZERO)*/       /*GET KEY 0 TO BUILD LI
*T     */                                                       04S0428
*        ALCUCBSP = AUCBSP;                                     04S0429
         L     @15,OPTPARMP                                     04S0429
         MVC   ALCUCBSP(4,@15),AUCBSP                           04S0429
*        NUMCANDS = CANDCTR;           /*SET NUMBER OF CANDIDATES    */
         L     @01,CANDLSTP                                     04S0430
         MVC   NUMCANDS(4,@01),CANDCTR                          04S0430
*        RETPARMP = ADDR(RETAREA);                              04S0431
         LA    @14,RETAREA(,@15)                                04S0431
         ST    @14,RETPARMP(,@15)                               04S0431
*        RFY (REG1) RSTD;                                       04S0432
*        REG1 = OPTPARMP;                                       04S0433
         LR    REG1,@15                                         04S0433
*        GEN(SYSEVENT DEVALLOC);       /*CALL OPTIMIZER              */
         SYSEVENT DEVALLOC
*        RFY (REG1) UNRSTD;                                     04S0435
*        IF OPTDEVP ^= ZERO THEN       /*DID OPTIMIZER PICK A DEVICE?*/
         L     @01,OPTPARMP                                     04S0436
         L     @15,OPTDEVP(,@01)                                04S0436
         LTR   @15,@15                                          04S0436
         BZ    @RF00436                                         04S0436
*          DO;                         /*YES,LOCATE LIST ENTRY PICKED*/
*            CANDCTR=((OPTDEVP-CANDLSTP)/FOUR);                 04S0438
         LR    @00,@15                                          04S0438
         SL    @00,CANDLSTP                                     04S0438
         SRDA  @00,32                                           04S0438
         D     @00,@CF00138                                     04S0438
         ST    @01,CANDCTR                                      04S0438
*          END;                                                 04S0439
*        ELSE                          /*OPTIMIZER ERROR             */
*          DO;                                                  04S0440
         B     @RC00436                                         04S0440
@RF00436 DS    0H                                               04S0441
*            RETCODE = FAILURE;        /*SET ERROR RETURN CODE       */
         MVC   RETCODE(4),@CF00138                              04S0441
*            RSNCODE = OPDEVERR;       /*SET REASON CODE             */
         L     @15,@PC00001                                     04S0442
         L     @01,ALCWAPTR(,@15)                               04S0442
         L     @01,FAILRSCP(,@01)                               04S0442
         MVC   RSNCODE(2,@01),@CH00176                          04S0442
*          END;                                                 04S0443
*        RFY (REG0,REG1) RSTD;                                  04S0444
@RC00436 DS    0H                                               04S0445
*        REG0 = ALCULEN;               /*LENGTH OF ALLOC'D UCBS LIST */
         L     REG0,ALCULEN                                     04S0445
*        REG0 = REG0 | FREESPNO;       /*SET SUBPOOL ID              */
         O     REG0,@CF00158                                    04S0446
*        REG1 = AUCBSP;                /*PTR TO ALLOC'D UCBS LIST    */
         L     REG1,AUCBSP                                      04S0447
*        GEN(FREEMAIN R,LV=(0),A=(1));/*FREE ALLOC'D UCBS LIST  04S0448
*                                        SPACE                       */
         FREEMAIN R,LV=(0),A=(1)
*        RFY (REG0,REG1) UNRSTD;                                04S0449
*         DO; /*MODESET  EXTKEY(SCHED)*/                        04S0450
*           SPKA (16); /*SET PSW KEY*/                          04S0451
         LA    @01,16                                           04S0451
         SPKA  0(@01)                                           04S0451
*         END; /*MODESET  EXTKEY(SCHED)*/       /*RETURN TO SCHEDULER K
*Y     */                                                       04S0452
*      END;                                                     04S0453
*    ELSE;                             /*ERROR BUILDING ALC UCB LIST */
@RF00424 DS    0H                                               04S0455
*  END;                                                         04S0455
*ELSE;                                 /*ONLY ONE UCB CANDIDATE      */
@RF00420 DS    0H                                               04S0457
*IF RETCODE = ZERO THEN                /*ANY ERRORS ?                */
         SLR   @15,@15                                          04S0457
         C     @15,RETCODE                                      04S0457
         BNE   @RF00457                                         04S0457
*  DO;                                 /*NO, CONTINUE PROCESSING     */
*    UCBPTR = CANDUCB(CANDCTR);        /*POINT TO UCB TO BE ALLOCATED*/
         L     @14,CANDCTR                                      04S0459
         SLA   @14,2                                            04S0459
         L     @01,CANDLSTP                                     04S0459
         L     @14,CANDUCB-4(@14,@01)                           04S0459
         ST    @14,UCBPTR                                       04S0459
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - SARUPARM                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - SET UP THE INPUT PARAMETERS TO THE ARU ROUTINE*/
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*     THIS ROUTINE IS CALLED TO COMPLETE THE INFORMATION NEEDED    */
*/*     TO INVOKE THE ALLOCATE-REQUEST-TO-UNIT ROUTINE (IEFAB434).   */
*/*                                                                  */
*/*     A POINTER TO A RETURN INFORMATION AREA IS SET UP AND THE     */
*/*     FUNCTION MAP FOR THE ARU ROUTINE IS ALSO SET UP.             */
*/*                                                                  */
*/*   OPERATION - THE OPERATION IS DOCUMENTED BY THE CODE ITSELF.    */
*/*                                                                  */
*/* ENTRY - (INLINE SUBROUTINE)                                      */
*/*                                                                  */
*/*   PURPOSE - (SEE FUNCTION)                                       */
*/*                                                                  */
*/*   INPUT - SIOTPTR - PTR TO THE SIOT BEING PROCESSED              */
*/*         - VUPTR   - PTR TO THE VOLUNIT BEING PROCESSED           */
*/*         - UCBPTR  - PTR TO THE UNIT CONTROL BLOCK TO BE ALLOC'D  */
*/*                                                                  */
*/* EXIT - NORMAL - (INLINE SUBROUTINE)                              */
*/*                                                                  */
*/*   CONDITION - THE FUNCTION HAS COMPLETED WITHOUT AN ERROR        */
*/*                                                                  */
*/*   OUTPUT - UCBPARMP - PTR TO RETURN INFO AREA FOR IEFAB434       */
*/*          - UVOLID   - VOLID FROM THE VOLUNIT ENTRY               */
*/*          - ARUFMAP  - IEFAB434 FUNCTION MAP                      */
*/*          - SIOTDEVS - NUMBER OF UNITS NEED FOR ETIOT ENTRY       */
*/*                                                                  */
*/*   RETURN CODES - (NONE)                                          */
*/*                                                                  */
*/********************************************************************/
*UCBPARMP = ADDR(UCBPARMS);            /*POINT TO VOLUME INFO AREA   */
         LA    @14,UCBPARMS                                     05S0460
         ST    @14,UCBPARMP                                     05S0460
*UVOLID = VOLID;                       /*PASS VOLID FROM VU ENTRY    */
         L     @01,VUPTR                                        05S0461
         MVC   UVOLID(6),VOLID(@01)                             05S0461
*ARUFMAP = INITFMAP;                   /*COPY STANDARD FUNCTION MAP  */
         MVC   ARUFMAP(4),INITFMAP                              05S0462
*IF SIOTETIO = ZERO THEN               /*DOES AN ETIOT ALREADY EXIST?*/
         L     @14,SIOTPTR                                      05S0463
         C     @15,SIOTETIO(,@14)                               05S0463
         BNE   @RF00463                                         05S0463
*  DO;                                 /*NO, CHANGE THE FUNCTION MAP */
*    ARUETUPD = OFF;                   /*INDICATE ETIOT NEEDED       */
         NI    ARUETUPD,B'01111111'                             05S0465
*    DEVSSIOT = SIOTOTUN;              /*SET NUMBER OF UNITS NEEDED  */
         SLR   @15,@15                                          05S0466
         IC    @15,SIOTOTUN(,@14)                               05S0466
         STH   @15,DEVSSIOT                                     05S0466
*  END;                                                         05S0467
*ELSE;                                 /*KEEP STANDARD FUNCTION MAP  */
@RF00463 DS    0H                                               05S0469
*IF UCB3DACC = ON THEN                 /*IS UNIT DIRECT-ACCESS ?     */
         L     @01,UCBPTR                                       05S0469
         TM    UCB3DACC(@01),B'00100000'                        05S0469
         BNO   @RF00469                                         05S0469
* ARUSECTU = ON;                       /* YES,INDICATE UPDATE USE CNT*/
         OI    ARUSECTU,B'01000000'                             05S0470
*ELSE;                                                          05S0471
@RF00469 DS    0H                                               05S0472
*RELDEVNO = ONE;                       /*INIT RELATIVE POS'N OF 05S0472
*                                        DEVICE ENTRY                */
         LA    @03,1                                            05S0472
         STH   @03,RELDEVNO                                     05S0472
*AVUPTR = SVOLUNAD;                    /*PT TO FIRST VU ENTRY        */
         L     @01,SIOTPTR                                      05S0473
         L     AVUPTR,SVOLUNAD(,@01)                            05S0473
*DO AVUCTR = 1 TO SVOLUNNO             /*GET POS'N FOR THIS ENTRY    */
*   WHILE(AVUPTR ^= VUPTR);            /*SCAN TO ENTRY BEING PROC'D  */
         LR    AVUCTR,@03                                       05S0474
         B     @DE00474                                         05S0474
@DL00474 C     AVUPTR,VUPTR                                     05S0474
         BE    @DC00474                                         05S0474
*  IF AVUPTR -> VDEVREQD = YES THEN    /*COUNT DEVICE REQ'D ENTRIES  */
         TM    VDEVREQD(AVUPTR),B'00100000'                     05S0475
         BNO   @RF00475                                         05S0475
*    RELDEVNO = RELDEVNO + ONE;                                 05S0476
         LH    @05,RELDEVNO                                     05S0476
         LA    @05,1(,@05)                                      05S0476
         STH   @05,RELDEVNO                                     05S0476
*  ELSE;                                                        05S0477
@RF00475 DS    0H                                               05S0478
*  AVUPTR = AVUPTR + LENGTH(VOLUNTAB);                          05S0478
         AL    AVUPTR,@CF00085                                  05S0478
*END;                                                           05S0479
         AH    AVUCTR,@CH00066                                  05S0479
@DE00474 L     @05,SIOTPTR                                      05S0479
         CH    AVUCTR,SVOLUNNO(,@05)                            05S0479
         BNH   @DL00474                                         05S0479
@DC00474 DS    0H                                               05S0480
*IF (VOLSPEC = ON                      /*SPECIFIC VOL REQ ?          */
*  & UCB3DACC = ON)                                             05S0480
*  | (UCB3TAPE = ON) THEN              /*OR TAPE REQ ?               */
         L     @01,VUPTR                                        05S0480
         TM    VOLSPEC(@01),B'00100000'                         05S0480
         BNO   @GL00051                                         05S0480
         L     @01,UCBPTR                                       05S0480
         TM    UCB3DACC(@01),B'00100000'                        05S0480
         BO    @RT00480                                         05S0480
@GL00051 L     @01,UCBPTR                                       05S0480
         TM    UCB3TAPE(@01),B'10000000'                        05S0480
         BNO   @RF00480                                         05S0480
@RT00480 DS    0H                                               05S0481
*  DO;                                 /*YES, 434 SHOULD VALIDITY CHK*/
*    ARUVCHEK = ON;                                             05S0482
         OI    ARUVCHEK,B'00010000'                             05S0482
*  END;                                /*NOT A SPEC VOL REQ          */
*ELSE;                                                          05S0484
@RF00480 DS    0H                                               05S0485
*    CALL IEFAB434 (SIOTPTR,VUPTR,UCBPTR,ARUFMAP,ETIODATA,      04S0485
*        ALCWAPTR,ARUGRPID,UCBPARMP);  /*ALLOC REQUEST TO UNIT       */
         LA    @15,SIOTPTR                                      04S0485
         ST    @15,@AL00001                                     04S0485
         LA    @15,VUPTR                                        04S0485
         ST    @15,@AL00001+4                                   04S0485
         LA    @15,UCBPTR                                       04S0485
         ST    @15,@AL00001+8                                   04S0485
         LA    @15,ARUFMAP                                      04S0485
         ST    @15,@AL00001+12                                  04S0485
         LA    @15,ETIODATA                                     04S0485
         ST    @15,@AL00001+16                                  04S0485
         L     @15,@PC00001                                     04S0485
         ST    @15,@AL00001+20                                  04S0485
         LA    @15,ARUGRPID                                     04S0485
         ST    @15,@AL00001+24                                  04S0485
         LA    @15,UCBPARMP                                     04S0485
         ST    @15,@AL00001+28                                  04S0485
         L     @15,@CV00150                                     04S0485
         LA    @01,@AL00001                                     04S0485
         BALR  @14,@15                                          04S0485
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - PRCRTNC                                           */
*/*                                                                  */
*/* DESCRIPTIVE NAME - PROCESS RETURN FROM ARU MODULE (IEFAB434)     */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*     THIS ROUTINE PROCESSES THE RETURN FROM MODULE IEFAB434       */
*/*     WHICH WAS INVOKED TO ALLOCATE A PARTICULAR VOLUNIT ENTRY     */
*/*     TO A CHOSEN DEVICE.                                          */
*/*                                                                  */
*/*     THIS ROUTINE DOES THE FOLLOWING PROCESSING:                  */
*/*                                                                  */
*/*       .IF THE VOLUNIT ENTRY WAS SUCCESSFULLY ALLOCATED, THE      */
*/*        VOLUNIT ENTRY IS MARKED ALLOCATED AND THE NUMBER OF       */
*/*        STILL UNALLOCATED VOLUNIT ENTRIES IS DECREASED BY ONE.    */
*/*                                                                  */
*/*       .IF A NON-FAILING 'ERROR' CONDITION WAS DETECTED BY        */
*/*        MODULE IEFAB434, THEN INDICATORS OF THIS CONDITIONS ARE   */
*/*        SET. THE POSSIBLE NON-FAILING ERRORS RESULT WHEN          */
*/*        THE REQUESTED VOLUME IS LOCATED ON ANOTHER DEVICE,        */
*/*        BUT THE VOLUME CANNOT BE MOVED TO THE DEVICE IT IS        */
*/*        TO BE ALLOCATED ON BECAUSE VOLUME SWITCHING IS NOT        */
*/*        ALLOWED. THE ALLOCATION PROCESSING WILL HAVE TO           */
*/*        BE 'RETRIED' WITH THIS REQUEST LOCKING UP THE             */
*/*        ENTIRE GENERIC DEVICE TYPE SO THAT VOLUME SWITCHING       */
*/*        WILL BE ALLOWED.                                          */
*/*                                                                  */
*/*       .AN ERROR RETURN CODE IS SET IF MODULE IEFAB434 DETECTED   */
*/*        A FAILING ERROR CONDITION.                                */
*/*                                                                  */
*/*   OPERATION - THE OPERATION IS DOCUMENTED BY THE CODE ITSELF.    */
*/*                                                                  */
*/* ENTRY - (INLINE SUBROUTINE)                                      */
*/*                                                                  */
*/*   PURPOSE - (SEE FUNCTION)                                       */
*/*                                                                  */
*/*   INPUT - REGISTER 15 - RETURN CODE FROM IEFAB434                */
*/*                                                                  */
*/* EXIT - NORMAL - (INLINE SUBROUTINE)                              */
*/*                                                                  */
*/*   CONDITION - THE VOLUNIT ENTRY WAS SUCCESSFULLY ALLOCATED       */
*/*                                                                  */
*/*   OUTPUT - VOLALOC=1                                             */
*/*         - TOTVOLUN DECREMENTED                                   */
*/*                                                                  */
*/*   RETURN CODES - RTNCODE SET TO 0                                */
*/*                                                                  */
*/* EXIT - ERROR - (INLINE SUBROUTINE)                               */
*/*                                                                  */
*/*   CONDITION - RETRY NEEDED                                       */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*     INDRETRY BIT IN ALCWA SET                                    */
*/*     SIOTRTRY BIT SET IF VOL WAS ALLOCATED                        */
*/*                                                                  */
*/*   RETURN CODE - 20                                               */
*/*                                                                  */
*/*   CONDITION - FAILURE RETURN CODE FROM IEFAB434                  */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*     REASON CODE SET BY IEFAB434 (SEE A434SPEC)                   */
*/*                                                                  */
*/*   RETURN CODE - 4                                                */
*/*                                                                  */
*/********************************************************************/
*RFY REG15 RSTD;                                                05S0486
*IF REG15 = ZERO THEN                  /*ANY ERROR ?                 */
         SLR   @14,@14                                          05S0487
         CR    REG15,@14                                        05S0487
         BNE   @RF00487                                         05S0487
*  DO;                                 /*NO, INDICATE ALLOC DONE OK  */
*    RETCODE = ZERO;                                            05S0489
         ST    @14,RETCODE                                      05S0489
*    VOLALOC = ON;                     /*SET INDIC IN VU ENTRY       */
         L     @14,VUPTR                                        05S0490
         OI    VOLALOC(@14),B'10000000'                         05S0490
*    TOTVOLUN = TOTVOLUN - ONE;        /*DECREMENT CT OF UNALLOC VU'S*/
         L     @14,@PC00001                                     05S0491
         L     @14,ALCWAPTR(,@14)                               05S0491
         L     @09,TOTVOLUN(,@14)                               05S0491
         BCTR  @09,0                                            05S0491
         ST    @09,TOTVOLUN(,@14)                               05S0491
*    NEWONS = NEWONS - ONE;            /*DECREMENT NEW ONLINE@ZA10805*/
         L     @14,NEWONS                                       05S0492
         BCTR  @14,0                                            05S0492
         ST    @14,NEWONS                                       05S0492
*  END;                                                         05S0493
*ELSE                                  /*ARU ERROR, PROCESS          */
*  IF REG15 = RC20 |                   /*POSSIBLE RETRY RETURN CODES */
*      REG15 = RC24 |                                           05S0494
*      REG15 = RC28 |                                           05S0494
*      REG15 = RC40 THEN                                        05S0494
         B     @RC00487                                         05S0494
@RF00487 CH    REG15,@CH00178                                   05S0494
         BE    @RT00494                                         05S0494
         CH    REG15,@CH00141                                   05S0494
         BE    @RT00494                                         05S0494
         CH    REG15,@CH00085                                   05S0494
         BE    @RT00494                                         05S0494
         CH    REG15,@CH00182                                   05S0494
         BNE   @RF00494                                         05S0494
@RT00494 DS    0H                                               05S0495
*    DO;                                                        05S0495
*      RETCODE = RC20;                 /*SET EXIT RETRY RETURN CODE  */
         MVC   RETCODE(4),@CF00178                              05S0496
*      INDRETRY = ON;                  /*SET INDICATOR IN ALCWA      */
         L     @14,@PC00001                                     05S0497
         L     @14,ALCWAPTR(,@14)                               05S0497
         OI    INDRETRY(@14),B'01000000'                        05S0497
*      IF REG15 = RC28 THEN            /*REQUESTED VOL IS ALLOC'D    */
         CH    REG15,@CH00085                                   05S0498
         BNE   @RF00498                                         05S0498
*        SIOTRTRY = ON;                /*MUST RETRY THIS REQUEST     */
         L     @14,SIOTPTR                                      05S0499
         OI    SIOTRTRY(@14),B'00000001'                        05S0499
*    END;                                                       05S0500
*  ELSE                                /*FAILURE                     */
*    DO;                                                        05S0501
         B     @RC00494                                         05S0501
@RF00494 DS    0H                                               05S0502
*      RETCODE = FAILURE;              /*SET AN ERROR RETURN CODE    */
         MVC   RETCODE(4),@CF00138                              05S0502
*    END;                                                       05S0503
*RFY REG15 UNRSTD;                                              05S0504
@RC00494 DS    0H                                               05S0504
@RC00487 DS    0H                                               05S0505
*  END;                                                         04S0505
*ELSE;                                 /*ERROR                       */
@RF00457 DS    0H                                               04S0507
*    END;                                                       03S0507
*  ELSE                                /*REQ IS WAITING FOR VOL      */
*    DO;                                                        03S0508
         B     @RC00418                                         03S0508
@RF00418 DS    0H                                               03S0509
*      VURCVYPR = ON;                  /*INDICATE UNIT NOT NEEDED    */
         L     @01,VUPTR                                        03S0509
         OI    VURCVYPR(@01),B'00000001'                        03S0509
*      IF CVRSKFLG = NO THEN           /*REQ CONSIDERED BY ALG       */
         L     @15,RQLSTPTR                                     03S0510
         TM    CVRSKFLG(@15),B'10000000'                        03S0510
         BNZ   @RF00510                                         03S0510
*        DO;                           /*INVOKE ALG TO REDUCE        */
*          CVRFCALL = ON;              /*INDICATE REDUCE FCN         */
         L     @14,@PC00001                                     03S0512
         L     @01,ALCWAPTR(,@14)                               03S0512
         L     @14,ALGTABP(,@01)                                03S0512
         L     @01,ALGPARMP(,@14)                               03S0512
         OI    CVRFCALL(@01),B'00010000'                        03S0512
*          CVRGRPAL = ALLOCD;          /*INDICATE GROUP PICKED       */
         LA    @09,1                                            03S0513
         L     @08,GPLSTPTR                                     03S0513
         STH   @09,CVRGRPAL(,@08)                               03S0513
*          CVRALLCT = ONE;             /*SET NO. UNITS ALLOCATED     */
         STH   @09,CVRALLCT(,@15)                               03S0514
*          CALL IEFAB480(ALGPARMP);    /*INVOKE COVER/REDUCE         */
         ST    @14,@AL00001                                     03S0515
         L     @15,@CV00152                                     03S0515
         LA    @01,@AL00001                                     03S0515
         BALR  @14,@15                                          03S0515
*          IF REG15 ^= ZERO THEN       /*ALG ERROR                   */
         LTR   REG15,REG15                                      03S0516
         BZ    @RF00516                                         03S0516
*            DO;                                                03S0517
*              RETCODE = FAILURE;                               03S0518
         MVC   RETCODE(4),@CF00138                              03S0518
*              RSNCODE = GETMNERR;                              03S0519
         L     @15,@PC00001                                     03S0519
         L     @01,ALCWAPTR(,@15)                               03S0519
         L     @01,FAILRSCP(,@01)                               03S0519
         MVC   RSNCODE(2,@01),@CH00073                          03S0519
*            END;                                               03S0520
*          ELSE;                       /*NO ERROR IN ALGORITHM       */
@RF00516 DS    0H                                               03S0522
*        END;                                                   03S0522
*      ELSE;                           /*REQ NOT CONSIDERED BY ALG   */
@RF00510 DS    0H                                               03S0524
*    END;                                                       03S0524
*  ELSE;                               /*NOT ENOUGH UNITS IN GROUP
*                                        TO COVER                    */
@RF00417 DS    0H                                               03S0526
*          END;                                                 02S0526
*        ELSE;                         /*NO CANDIDATES TO ALLOCATE   */
@RF00395 DS    0H                                               02S0528
*        RFY (REG0,REG1) RSTD;                                  02S0528
@RC00395 DS    0H                                               02S0529
*        REG0 = CNDLSTLN;              /*SET LENGTH OF CORE TO FREE  */
         L     REG0,CNDLSTLN                                    02S0529
*        REG0 = REG0 | FREESPNO;       /*PUT S.P. NO. INTO REG       */
         O     REG0,@CF00158                                    02S0530
*        REG1 = CANDLSTP;              /*PT TO GOTTEN CORE           */
         L     REG1,CANDLSTP                                    02S0531
*        GEN(FREEMAIN R,LV=(0),A=(1)); /*FREE CANDIDATE LIST CORE    */
         FREEMAIN R,LV=(0),A=(1)
*        RFY (REG0,REG1) UNRSTD;                                02S0533
*      END;                                                     02S0534
*    ELSE                              /*CORE NOT AVAILABLE FOR LIST */
*      RSNCODE = GETMNERR;             /*SET REASON CODE TO 2        */
         B     @RC00253                                         02S0535
@RF00253 L     @15,@PC00001                                     02S0535
         L     @01,ALCWAPTR(,@15)                               02S0535
         L     @01,FAILRSCP(,@01)                               02S0535
         MVC   RSNCODE(2,@01),@CH00073                          02S0535
*    RFY (REG0,REG1) RSTD;                                      02S0536
@RC00253 DS    0H                                               02S0537
*    REG0 = LENGTH(OPTPARMS);          /*SET LENGTH OF PARMS         */
         LA    REG0,20                                          02S0537
*    REG0 = REG0 | FREESPNO;           /*PUT SUBPOOL NUMBER IN       */
         O     REG0,@CF00158                                    02S0538
*    REG1 = OPTPARMP;                  /*POINT TO CORE TO FREE       */
         L     REG1,OPTPARMP                                    02S0539
*    GEN(FREEMAIN R,LV=(0),A=(1));     /*FREE OPTIMIZER PARMS CORE   */
         FREEMAIN R,LV=(0),A=(1)
*    RFY (REG0,REG1) UNRSTD;                                    02S0541
*  END;                                                         02S0542
*ELSE                                  /*CORE NOT AVAILABLE FOR PARMS*/
*  RSNCODE = GETMNERR;                 /*SET REASON CODE TO 2        */
         B     @RC00227                                         02S0543
@RF00227 L     @15,@PC00001                                     02S0543
         L     @01,ALCWAPTR(,@15)                               02S0543
         L     @01,FAILRSCP(,@01)                               02S0543
         MVC   RSNCODE(2,@01),@CH00073                          02S0543
*RETURN;                               /*RETURN TO CALLER            */
@EL00002 DS    0H                                               02S0544
@EF00002 DS    0H                                               02S0544
@ER00002 LM    @14,@12,@SA00002                                 02S0544
         BR    @14                                              02S0544
*END ALOCREQ;                                                   02S0545
         B     @EL00002                                         02S0545
*END IEFAB489                                                   01S0546
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (A489SPEC)                                        *
*/*%INCLUDE SYSLIB  (A489DATA)                                        *
*/*%INCLUDE SYSLIB  (CVT     )                                        *
*/*%INCLUDE SYSLIB  (IEFASIOT)                                        *
*/*%INCLUDE SYSLIB  (IEFUCBOB)                                        *
*/*%INCLUDE SYSLIB  (IEFZB421)                                        *
*/*%INCLUDE SYSLIB  (IEFZB422)                                        *
*/*%INCLUDE SYSLIB  (IEFZB423)                                        *
*/*%INCLUDE SYSLIB  (IEFZB425)                                        *
*/*%INCLUDE SYSLIB  (IEFZB426)                                        *
*/*%INCLUDE SYSLIB  (IHASUBIT)                                        *
*/*%INCLUDE SYSLIB  (IEZSSC  )                                        *
*/*%INCLUDE SYSLIB  (CHKDMNDS)                                        *
*/*%INCLUDE SYSLIB  (DMNDSPEC)                                        *
*/*%INCLUDE SYSLIB  (DMNDNEED)                                        *
*/*%INCLUDE SYSLIB  (DMNDNEED)                                        *
*/*%INCLUDE SYSLIB  (DNEDSPEC)                                        *
*/*%INCLUDE SYSLIB  (DNEDSPEC)                                        *
*/*%INCLUDE SYSLIB  (CHKNDMND)                                        *
*/*%INCLUDE SYSLIB  (NDMDSPEC)                                        *
*/*%INCLUDE SYSLIB  (FINDEDL )                                        *
*/*%INCLUDE SYSLIB  (FEDLSPEC)                                        *
*/*%INCLUDE SYSLIB  (CHKSIOT )                                        *
*/*%INCLUDE SYSLIB  (CSIOSPEC)                                        *
*/*%INCLUDE SYSLIB  (ALOCREQ )                                        *
*/*%INCLUDE SYSLIB  (ALRQSPEC)                                        *
*/*%INCLUDE SYSLIB  (MONTEQAL)                                        *
*/*%INCLUDE SYSLIB  (MONTSPEC)                                        *
*/*%INCLUDE SYSLIB  (CHKCANDS)                                        *
*/*%INCLUDE SYSLIB  (CANDSPEC)                                        *
*/*%INCLUDE SYSLIB  (ALOCENT )                                        *
*/*%INCLUDE SYSLIB  (ALOCSPEC)                                        *
*/*%INCLUDE SYSLIB  (SARUPARM)                                        *
*/*%INCLUDE SYSLIB  (SARPSPEC)                                        *
*/*%INCLUDE SYSLIB  (PRCRTNC )                                        *
*/*%INCLUDE SYSLIB  (PRTNSPEC)                                        *
*;                                                              01S0546
@DATA    DS    0H
@CH00066 DC    H'1'
@CH00073 DC    H'2'
@CH00176 DC    H'9'
@CH00047 DC    H'16'
@CH00141 DC    H'24'
@CH00182 DC    H'40'
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    2F
@SA00002 DS    15F
@AL00001 DS    8A
@TF00001 DS    F
IEFAB489 CSECT
         DS    0F
@CF00138 DC    F'4'
@CF00178 DC    F'20'
@CH00178 EQU   @CF00178+2
@CF00085 DC    F'28'
@CH00085 EQU   @CF00085+2
@CF01892 DC    F'-4'
@CF00158 DC    XL4'FD000000'
@DATD    DSECT
         DS    0D
AUCBSP   DS    A
CANDLSTP DS    A
EDLGNTP  DS    A
GPLSTPTR DS    A
OPTPARMP DS    A
RQLSTPTR DS    A
SIOTPTR  DS    A
SSCUCBLP DS    A
UCBPTR   DS    A
VUPTR    DS    A
ALCULEN  DS    F
CANDCTR  DS    F
CNDLSTLN DS    F
GRPCTR   DS    F
NEWONS   DS    F
RETCODE  DS    F
VUCTR    DS    F
EDTPTR   DS    A
LUVPTR   DS    A
GENPTR   DS    A
GRPTABP  DS    A
GTSTRTCD DS    F
@TS00001 DS    CL1
A489SWS  DS    BL1
         ORG   A489SWS
DONESW   DS    BL1
FOUNDEDL EQU   A489SWS+0
FOUNDSW  EQU   A489SWS+0
GRPFOUND EQU   A489SWS+0
REQALCD  EQU   A489SWS+0
USEUCB   EQU   A489SWS+0
@NM00001 EQU   A489SWS+0
         ORG   A489SWS+1
         DS    CL2
ARUDATA  DS    CL28
         ORG   ARUDATA
ARUFMAP  DS    BL4
         ORG   ARUFMAP
ARUETUPD DS    BL1
ARUSECTU EQU   ARUFMAP+0
@NM00002 EQU   ARUFMAP+0
ARUVCHEK EQU   ARUFMAP+0
@NM00003 EQU   ARUFMAP+0
         ORG   ARUDATA+4
ARUGRPID DS    FL4
ETIODATA DS    FL4
         ORG   ETIODATA
RELDEVNO DS    FL2
DEVSSIOT DS    FL2
         ORG   ARUDATA+12
UCBPARMP DS    AL4
UCBPARMS DS    CL12
         ORG   UCBPARMS
UCBAD    DS    AL2
UVOLID   DS    CL6
VOLATTRB DS    BL1
IFLAGS   DS    BL1
IOFLAGS  DS    BL1
@NM00004 DS    BL1
         ORG   ARUDATA+28
SSCVOLID DS    CL6
SSCWKARE DS    CL244
IEFAB489 CSECT
         DS    0F
@SIZDATD DC    AL1(230)
         DC    AL3(@ENDDATD-@DATD)
@CV00150 DC    V(IEFAB434)
@CV00151 DC    V(IEFAB440)
@CV00152 DC    V(IEFAB480)
         DS    0D
GTSTZERO DC    F'0'
INITFMAP DC    B'10101100'
         DC    XL3'0'
NONSPEC  DC    X'FE'
NONSPECT DC    X'FF'
NOVOLSER DC    X'000000000000'
THIRY330 DC    X'2009'
VIRTTYPE DC    X'08'
IEFAB489 CSECT
         DS   0H
A489PTCH DC ((@DATA-@PSTART)/20)X'00'
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEFAB489 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
SSCLCTR  EQU   @04
OLDLCTR  EQU   @03
OFFLNCT  EQU   @04
NUMGRPS  EQU   @07
NOVUENTS EQU   @08
NEWLCTR  EQU   @02
GRPLCTR  EQU   @06
GENCTR   EQU   @02
EGRPCTR  EQU   @04
DEVCTR   EQU   @05
AVUCTR   EQU   @04
AURQDCTR EQU   @05
AGRPCTR  EQU   @06
SPTR     EQU   @02
NEWLPTR  EQU   @09
GRPPTR   EQU   @06
GPCNTPTR EQU   @03
EDLUCBLP EQU   @03
EDLPTR   EQU   @09
AVUPTR   EQU   @02
AGPLPTR  EQU   @03
REG0     EQU   @00
REG1     EQU   @01
REG15    EQU   @15
GTSTR0   EQU   @00
GTSTR1   EQU   @01
GTSTR2   EQU   @02
GTSTR15  EQU   @15
GTSTR4   EQU   @04
GTSTR5   EQU   @05
GTSTR6   EQU   @06
GTSTR7   EQU   @07
GTSTR8   EQU   @08
GTSTR3   EQU   @03
CVTPTR   EQU   16
CANDLST  EQU   0
NUMCANDS EQU   CANDLST
CANDUCB  EQU   CANDLST+4
IOSLUT   EQU   0
NEWUCBLS EQU   0
NEWLCANO EQU   NEWUCBLS
NEWLUCBP EQU   NEWUCBLS+4
OPTPARMS EQU   0
CANDLPTR EQU   OPTPARMS
ALCUCBSP EQU   OPTPARMS+4
RETPARMP EQU   OPTPARMS+8
RETAREA  EQU   OPTPARMS+12
OPTDEVP  EQU   RETAREA
RSNCODE  EQU   0
SSCUCBLS EQU   0
SSCLSPLN EQU   SSCUCBLS
SSCLNUCB EQU   SSCUCBLS+4
SSCLUCBP EQU   SSCUCBLS+8
ICBME    EQU   0
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTICB   EQU   CVTXTNT2+48
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
INDMSIOT EQU   0
SCTUSADD EQU   INDMSIOT+20
SIOTOTUN EQU   INDMSIOT+39
SIOTBYT1 EQU   INDMSIOT+43
SIOTALCD EQU   SIOTBYT1
SIOTBYT3 EQU   INDMSIOT+46
SIOTJES3 EQU   SIOTBYT3
SIOTTSTC EQU   INDMSIOT+47
SIOTBYT0 EQU   INDMSIOT+52
SIOTRTRY EQU   SIOTBYT0
SCTSDISP EQU   INDMSIOT+55
SCTSBYT1 EQU   INDMSIOT+56
SCTSBYT2 EQU   INDMSIOT+57
SCTSBYT3 EQU   INDMSIOT+58
SCTSBYT4 EQU   INDMSIOT+59
SCTUTYPE EQU   INDMSIOT+60
SIOTDEVT EQU   SCTUTYPE
SIOUBYT3 EQU   SIOTDEVT+2
SIOUCBAD EQU   SCTUTYPE+5
SIOTBYT4 EQU   INDMSIOT+81
SIOTALTD EQU   INDMSIOT+92
SIOTBYT2 EQU   INDMSIOT+103
SIOTDMND EQU   SIOTBYT2
SIOTEDLP EQU   INDMSIOT+136
SVOLUNAD EQU   INDMSIOT+140
SIOTETIO EQU   INDMSIOT+148
SIOTNPTR EQU   INDMSIOT+152
SVOLUNNO EQU   INDMSIOT+168
UCB      EQU   0
UCBOB    EQU   0
UCBJBNR  EQU   UCBOB
UCBFL5   EQU   UCBOB+1
UCBAF    EQU   UCBFL5
UCBNALOC EQU   UCBFL5
UCBSTAT  EQU   UCBOB+3
UCBONLI  EQU   UCBSTAT
UCBRESV  EQU   UCBSTAT
UCBALOC  EQU   UCBSTAT
UCBPRES  EQU   UCBSTAT
UCBSYSR  EQU   UCBSTAT
UCBCHAN  EQU   UCBOB+4
UCBSFLS  EQU   UCBOB+6
UCBFLA   EQU   UCBSFLS
UCBFL1   EQU   UCBFLA
UCBBSY   EQU   UCBFL1
UCBNRY   EQU   UCBFL1
UCBPST   EQU   UCBFL1
UCBCUB   EQU   UCBFL1
UCBFLB   EQU   UCBSFLS+1
UCBCHM   EQU   UCBOB+8
UCBCHM1  EQU   UCBCHM
UCBPTH0  EQU   UCBCHM1
UCBPTH1  EQU   UCBCHM1
UCBWGT   EQU   UCBOB+12
UCBTYP   EQU   UCBOB+16
UCBTBYT1 EQU   UCBTYP
UCB1FEA5 EQU   UCBTBYT1
UCB1FEA6 EQU   UCBTBYT1
UCBTBYT2 EQU   UCBTYP+1
UCB2OPT2 EQU   UCBTBYT2
UCBDUDN1 EQU   UCB2OPT2
UCB2OPT3 EQU   UCBTBYT2
UCBDUDN2 EQU   UCB2OPT3
UCB2OPT4 EQU   UCBTBYT2
UCBRWTAU EQU   UCB2OPT4
UCB2OPT6 EQU   UCBTBYT2
UCB2OPT7 EQU   UCBTBYT2
UCBTBYT3 EQU   UCBTYP+2
UCBDVCLS EQU   UCBTBYT3
UCB3TAPE EQU   UCBDVCLS
UCB3DACC EQU   UCBDVCLS
UCBTBYT4 EQU   UCBTYP+3
UCBEXTPT EQU   UCBOB+20
UCBFLC   EQU   UCBEXTPT
UCBDEV   EQU   UCBOB+24
UCBCMEXT EQU   0
UCBATI   EQU   UCBCMEXT+3
@NM00024 EQU   UCBATI
UCBFLP1  EQU   UCBCMEXT+5
UCBMT    EQU   0
UCBOCR   EQU   0
UCB3540X EQU   0
UCBDKBYT EQU   UCB3540X+6
UCB3800X EQU   0
UCBOPTNS EQU   UCB3800X
UCBACTIV EQU   UCB3800X+3
UCBMDRBF EQU   UCB3800X+36
UCBUCS   EQU   0
UCBUCSOP EQU   UCBUCS+4
UCBFCBOP EQU   UCBUCS+5
EDTHDR   EQU   0
EDTLUVSP EQU   EDTHDR
EDTGENSP EQU   EDTHDR+4
EDTGRPSP EQU   EDTHDR+8
EDTUCBSP EQU   EDTHDR+12
EDTMSKTP EQU   EDTHDR+16
LUVSECT  EQU   0
LUVHDR   EQU   LUVSECT
LUVENTRY EQU   0
LUVGMTP  EQU   LUVENTRY+12
LUVFLAGS EQU   LUVENTRY+24
GENSECT  EQU   0
GENHDR   EQU   GENSECT
GENENTRY EQU   0
GRPTRTAB EQU   0
GRPSECT  EQU   0
GRPHDR   EQU   GRPSECT
GRPENTNO EQU   GRPHDR
GRPENTLN EQU   GRPHDR+4
GRPENTRY EQU   0
GRPUCBNO EQU   GRPENTRY+4
GRPUCBP  EQU   GRPENTRY+8
EUCBSECT EQU   0
EUCBHDR  EQU   EUCBSECT
EUCBENTY EQU   0
EUCBTPOS EQU   EUCBENTY
GRMSKTAB EQU   0
GMTHDR   EQU   GRMSKTAB
GMTENTRY EQU   0
IEFEDL   EQU   0
EDLHDR   EQU   IEFEDL
EDLGENNO EQU   EDLHDR+4
EDLFGENP EQU   EDLHDR+8
EDLUVFLG EQU   EDLHDR+16
EDLENTRY EQU   0
EDLNXTNT EQU   EDLENTRY
EDLDEVT  EQU   EDLENTRY+4
EDLGRPNO EQU   EDLENTRY+8
EDLGRPTR EQU   EDLENTRY+12
EDLDTFLG EQU   EDLENTRY+20
EINDEVTP EQU   EDLDTFLG
EDLGNTRY EQU   0
EDLNXGRP EQU   EDLGNTRY
EDLUCBNO EQU   EDLGNTRY+4
EDLLISTP EQU   EDLGNTRY+8
EDLGRID  EQU   EDLGNTRY+12
EDLGRFLG EQU   EDLGNTRY+16
EDLUCBL  EQU   0
EDLUCBAD EQU   EDLUCBL
EDLINDIC EQU   EDLUCBL+2
EDLNOJES EQU   EDLINDIC
VOLUNTAB EQU   0
VOLID    EQU   VOLUNTAB
VOLSTAT  EQU   VOLUNTAB+6
VOLSTATA EQU   VOLSTAT
VOLSPEC  EQU   VOLSTATA
VOLSTATB EQU   VOLSTAT+1
VOLALOC  EQU   VOLSTATB
VDEVREQD EQU   VOLSTATB
VOLSTATC EQU   VOLSTAT+2
VOLSTATD EQU   VOLSTAT+3
VUDMNDOF EQU   VOLSTATD
VURCVYPR EQU   VOLSTATD
VOLALGTP EQU   VOLUNTAB+12
VOLSIOTP EQU   VOLUNTAB+16
VUUCBP   EQU   VOLUNTAB+20
VUGRID   EQU   VOLUNTAB+24
VUPOOL   EQU   0
VUGRLST  EQU   0
VUGRLENT EQU   VUGRLST
VUGRLFLG EQU   VUGRLENT+4
ALCWA    EQU   0
SIOT1P   EQU   ALCWA+8
IOSLUTP  EQU   ALCWA+16
FAILRSCP EQU   ALCWA+20
EDTABPTR EQU   ALCWA+24
CNTABLE  EQU   ALCWA+28
TOTREQS  EQU   CNTABLE+36
TOTVOLUN EQU   CNTABLE+44
VOLUNPTR EQU   ALCWA+80
VOLUNSZE EQU   ALCWA+84
ALGTABP  EQU   ALCWA+88
INDICATE EQU   ALCWA+112
INDRETRY EQU   INDICATE
@NM00032 EQU   ALCWA+113
TIOTHDRP EQU   ALCWA+120
NAMES    EQU   0
ALGPTRS  EQU   0
ALGPARMP EQU   ALGPTRS
ALGGCNTP EQU   ALGPTRS+12
CVRPARM  EQU   0
CVRFLG1  EQU   CVRPARM+8
CVRFCALL EQU   CVRFLG1
CVRRQLST EQU   0
CVRALLCT EQU   CVRRQLST+6
CVRMIN   EQU   CVRRQLST+10
CVRFLG2  EQU   CVRRQLST+16
CVRSKFLG EQU   CVRFLG2
CVRNGRP  EQU   CVRRQLST+18
CVRGRPPT EQU   CVRRQLST+20
CVRWUCBP EQU   CVRRQLST+24
CVRGPLST EQU   0
CVRGRPID EQU   CVRGPLST+4
CVRGRPAL EQU   CVRGPLST+6
CVRGALL  EQU   CVRGPLST+8
CVRFLG3  EQU   CVRGPLST+12
CVRGSKP  EQU   CVRFLG3
GRPCOUNT EQU   0
GRPAVAIL EQU   GRPCOUNT
GRPOFFLN EQU   GRPCOUNT+4
GRPIDENT EQU   GRPCOUNT+10
SUBITS   EQU   0
SUBYTE1  EQU   SUBITS
SUBYTE2  EQU   SUBITS+1
SUBYTE3  EQU   SUBITS+2
SU18BIT  EQU   SUBYTE3
SUBYTE4  EQU   SUBITS+3
SUBYTE5  EQU   SUBITS+4
SUBYTE6  EQU   SUBITS+5
SUBYTE7  EQU   SUBITS+6
SUBYTE8  EQU   SUBITS+7
SUBYTE9  EQU   SUBITS+8
SUBYTE10 EQU   SUBITS+9
SUBYTE11 EQU   SUBITS+10
SUBYTE12 EQU   SUBITS+11
SUBYTE13 EQU   SUBITS+12
ICB2SSCB EQU   0
ICBOPT   EQU   ICB2SSCB+48
ICBFLG   EQU   ICB2SSCB+52
ICBFG1   EQU   ICBFLG
ICBMEP   EQU   ICB2SSCB+64
ICBTRACE EQU   ICB2SSCB+112
ALCUCBL  EQU   0
UCBBGN   EQU   0
ALCWAPTR EQU   0
FVUPTR   EQU   0
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
CVTIHASU EQU   CVTS01+696
UCBOBS01 EQU   UCBDEV
UCBVOLI  EQU   UCBOBS01+4
UCBSTAB  EQU   UCBOBS01+10
UCBBSVL  EQU   UCBSTAB
UCBPRSRS EQU   UCBSTAB
UCBDMCT  EQU   UCBOBS01+11
UCBMOUNT EQU   UCBDMCT
UCBFL4   EQU   UCBOBS01+13
UCBOBS02 EQU   UCBDEV
UCBTFL1  EQU   UCBOBS02+19
UCBXTN   EQU   UCBOBS02+20
UCBVOPT  EQU   UCBXTN
UCBOBS03 EQU   UCBDEV
UCBXTADR EQU   UCBOBS03
UCBOBS04 EQU   UCBDEV
UCBBTA   EQU   UCBOBS04+12
UCBOBS06 EQU   UCBDEV
UCBAOF   EQU   UCBOBS06
UCBAOF1  EQU   UCBAOF
UCBAOF2  EQU   UCBAOF+1
@NM00023 EQU   UCBOBS06+3
UCBIRB   EQU   UCBOBS06+4
UCBGRAF  EQU   UCBIRB
UCBLDNCA EQU   UCBOBS06+8
UCBRDYQ  EQU   UCBLDNCA
UCBIRLN  EQU   UCBRDYQ
UCBLDNCB EQU   UCBRDYQ+1
UCBCTLNK EQU   UCBOBS06+12
UCBOBS07 EQU   UCBDEV
UCBOBS08 EQU   UCBDEV
UCBCTCAD EQU   UCBOBS08
UCBCTCF1 EQU   UCBOBS08+4
UCBOBS09 EQU   UCBDEV
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
UCBRV066 EQU   UCBOBS09+4
UCBIOSBA EQU   UCBOBS09
UCBRV042 EQU   UCBOBS08+5
UCBRV082 EQU   UCBCTCF1
UCBRV081 EQU   UCBCTCF1
UCBRV080 EQU   UCBCTCF1
UCBRV079 EQU   UCBCTCF1
UCBRV078 EQU   UCBCTCF1
UCBRV077 EQU   UCBCTCF1
UCBRV076 EQU   UCBCTCF1
UCBCTC80 EQU   UCBCTCF1
UCBCTCAL EQU   UCBCTCAD
UCBICNCB EQU   UCBOBS07+4
UCBRV040 EQU   UCBOBS07
UCBCTLNA EQU   UCBCTLNK+1
UCBRLN   EQU   UCBCTLNK
UCBRDYQA EQU   UCBLDNCB
UCBINRLN EQU   UCBIRLN
UCBIRBA  EQU   UCBIRB+1
UCBRV039 EQU   UCBGRAF
UCBDWNR  EQU   UCBGRAF
UCBRPND  EQU   UCBGRAF
UCBUPM   EQU   UCBGRAF
UCBBTAM  EQU   UCBGRAF
UCBDRNO  EQU   UCBGRAF
UCBDRO   EQU   UCBGRAF
UCBOIP   EQU   UCBGRAF
UCBATRCD EQU   @NM00023
UCBSKPFG EQU   @NM00023
UCBRIPND EQU   @NM00023
UCBRTIAC EQU   @NM00023
UCBRSV79 EQU   @NM00023
UCBRSV78 EQU   @NM00023
UCBRSV77 EQU   @NM00023
UCBOLTEP EQU   @NM00023
UCBATNCT EQU   UCBOBS06+2
UCBRSV76 EQU   UCBAOF2
UCBRSV75 EQU   UCBAOF2
UCBRSV74 EQU   UCBAOF2
UCBRSV73 EQU   UCBAOF2
UCBRSV72 EQU   UCBAOF2
UCBRSV71 EQU   UCBAOF2
UCBRSV70 EQU   UCBAOF2
UCBRSV69 EQU   UCBAOF2
UCBRSV68 EQU   UCBAOF1
UCBRSV67 EQU   UCBAOF1
UCBRSV66 EQU   UCBAOF1
UCBRSV65 EQU   UCBAOF1
UCBRSV64 EQU   UCBAOF1
UCBOFNL  EQU   UCBAOF1
UCBOFSP  EQU   UCBAOF1
UCBOFMCR EQU   UCBAOF1
UCBBTB   EQU   UCBBTA+1
UCBDI    EQU   UCBBTA
UCBSNS   EQU   UCBOBS04+8
UCBTEB   EQU   UCBOBS04+4
UCBGCB   EQU   UCBOBS04+3
UCBOPEN  EQU   UCBOBS04+2
UCBSTART EQU   UCBOBS04
UCBXTNB  EQU   UCBXTN+1
UCBRSV22 EQU   UCBVOPT
UCBRSV21 EQU   UCBVOPT
UCBRSV20 EQU   UCBVOPT
UCBESVE  EQU   UCBVOPT
UCBERPC  EQU   UCBVOPT
UCBESVC  EQU   UCBVOPT
UCBEVA   EQU   UCBVOPT
UCBESV   EQU   UCBVOPT
UCBRV009 EQU   UCBTFL1
UCBRV008 EQU   UCBTFL1
UCBRV007 EQU   UCBTFL1
UCBRV006 EQU   UCBTFL1
UCBRV005 EQU   UCBTFL1
UCBDQDSP EQU   UCBTFL1
UCBNSLTP EQU   UCBTFL1
UCBNLTP  EQU   UCBTFL1
UCBRES1B EQU   UCBOBS02+18
UCBFSER  EQU   UCBOBS02+12
@NM00022 EQU   UCBOBS02+4
UCBFSEQ  EQU   UCBOBS02+2
UCBFSCT  EQU   UCBOBS02
UCBNEXP  EQU   UCBOBS01+20
UCBBASE  EQU   UCBOBS01+16
UCBRES1A EQU   UCBOBS01+15
UCBUSER  EQU   UCBOBS01+14
UCBFL47  EQU   UCBFL4
UCBFL46  EQU   UCBFL4
UCBFL45  EQU   UCBFL4
UCBRV065 EQU   UCBFL4
UCBDSS   EQU   UCBFL4
UCBRESVP EQU   UCBFL4
UCBWDAV  EQU   UCBFL4
UCBDAVV  EQU   UCBFL4
UCBSQC   EQU   UCBOBS01+12
UCBDATP  EQU   UCBOBS01+12
UCBDMC   EQU   UCBDMCT
UCBBNUL  EQU   UCBSTAB
UCBSHAR  EQU   UCBSTAB
UCBBSTR  EQU   UCBSTAB
UCBBPUB  EQU   UCBSTAB
UCBBPRV  EQU   UCBSTAB
UCBBALB  EQU   UCBPRSRS
UCBPGFL  EQU   UCBSTAB
UCBDVSHR EQU   UCBBSVL
UCBVTOC  EQU   UCBOBS01
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTHSM   EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
ICBCPUID EQU   ICB2SSCB+496
ICBLORD  EQU   ICBTRACE+256
ICBOTRC  EQU   ICBTRACE
ICBFAB   EQU   ICB2SSCB+108
ICBMSSC  EQU   ICB2SSCB+104
ICBRSVP  EQU   ICB2SSCB+100
ICBAEAP  EQU   ICB2SSCB+96
ICBSIOBP EQU   ICB2SSCB+92
ICBIATNA EQU   ICB2SSCB+88
ICBIPRGA EQU   ICB2SSCB+84
ICBSRBP  EQU   ICB2SSCB+80
ICBVVICB EQU   ICB2SSCB+76
ICBVVIC  EQU   ICB2SSCB+72
ICBSIOP  EQU   ICB2SSCB+68
ICBIORCI EQU   ICB2SSCB+60
ICB2ACTP EQU   ICB2SSCB+56
ICBSAMP  EQU   ICBFLG+2
ICBFG2   EQU   ICBFLG+1
@NM00040 EQU   ICBFG1
ICBMSCA  EQU   ICBFG1
ICBMSCMP EQU   ICBFG1
ICBS     EQU   ICBFG1
ICBB     EQU   ICBFG1
ICBV     EQU   ICBFG1
ICBR     EQU   ICBFG1
ICBI     EQU   ICBFG1
ICBNVT   EQU   ICBOPT
ICBVN02P EQU   ICB2SSCB+44
ICBTCB   EQU   ICB2SSCB+40
ICBQHEAD EQU   ICB2SSCB+36
ICBAUCB  EQU   ICB2SSCB+32
ICBPUCB  EQU   ICB2SSCB+28
ICBCOMQ  EQU   ICB2SSCB+24
ICBIOR   EQU   ICB2SSCB+20
ICBCOM   EQU   ICB2SSCB+16
ICBACTV  EQU   ICB2SSCB+12
ICBECB   EQU   ICB2SSCB+8
ICBSSNAM EQU   ICB2SSCB
SURV104  EQU   SUBITS+13
SURV103  EQU   SUBYTE13
SURV102  EQU   SUBYTE13
SURV101  EQU   SUBYTE13
SU100BT  EQU   SUBYTE13
SU99BIT  EQU   SUBYTE13
SU98BIT  EQU   SUBYTE13
SU97BIT  EQU   SUBYTE13
SU96BIT  EQU   SUBYTE13
SU95BIT  EQU   SUBYTE12
SU94BIT  EQU   SUBYTE12
SU93BIT  EQU   SUBYTE12
SU92BIT  EQU   SUBYTE12
SU91BIT  EQU   SUBYTE12
SU90BIT  EQU   SUBYTE12
SU89BIT  EQU   SUBYTE12
SU88BIT  EQU   SUBYTE12
SU87BIT  EQU   SUBYTE11
SU86BIT  EQU   SUBYTE11
SU85BIT  EQU   SUBYTE11
SU84BIT  EQU   SUBYTE11
SU83BIT  EQU   SUBYTE11
SU82BIT  EQU   SUBYTE11
SU81BIT  EQU   SUBYTE11
SU80BIT  EQU   SUBYTE11
SU79BIT  EQU   SUBYTE10
SU78BIT  EQU   SUBYTE10
SU77BIT  EQU   SUBYTE10
SU76BIT  EQU   SUBYTE10
SU75BIT  EQU   SUBYTE10
SU74BIT  EQU   SUBYTE10
SU73BIT  EQU   SUBYTE10
SU72BIT  EQU   SUBYTE10
SU71BIT  EQU   SUBYTE9
SU70BIT  EQU   SUBYTE9
SU69BIT  EQU   SUBYTE9
SU68BIT  EQU   SUBYTE9
SU67BIT  EQU   SUBYTE9
SU66BIT  EQU   SUBYTE9
SU65BIT  EQU   SUBYTE9
SU64BIT  EQU   SUBYTE9
SU63BIT  EQU   SUBYTE8
SU62BIT  EQU   SUBYTE8
SU61BIT  EQU   SUBYTE8
SU60BIT  EQU   SUBYTE8
SU59BIT  EQU   SUBYTE8
SU58BIT  EQU   SUBYTE8
SU57BIT  EQU   SUBYTE8
SU56BIT  EQU   SUBYTE8
SU55BIT  EQU   SUBYTE7
SU54BIT  EQU   SUBYTE7
SU53BIT  EQU   SUBYTE7
SU52BIT  EQU   SUBYTE7
SU51BIT  EQU   SUBYTE7
SU50BIT  EQU   SUBYTE7
SU49BIT  EQU   SUBYTE7
SU48BIT  EQU   SUBYTE7
SU47BIT  EQU   SUBYTE6
SU46BIT  EQU   SUBYTE6
SU45BIT  EQU   SUBYTE6
SU44BIT  EQU   SUBYTE6
SU43BIT  EQU   SUBYTE6
SU42BIT  EQU   SUBYTE6
SU41BIT  EQU   SUBYTE6
SU40BIT  EQU   SUBYTE6
SU39BIT  EQU   SUBYTE5
SU38BIT  EQU   SUBYTE5
SU37BIT  EQU   SUBYTE5
SU36BIT  EQU   SUBYTE5
SU35BIT  EQU   SUBYTE5
SU34BIT  EQU   SUBYTE5
SU33BIT  EQU   SUBYTE5
SU32BIT  EQU   SUBYTE5
SU31BIT  EQU   SUBYTE4
SU30BIT  EQU   SUBYTE4
SU29BIT  EQU   SUBYTE4
SU28BIT  EQU   SUBYTE4
SU27BIT  EQU   SUBYTE4
SU26BIT  EQU   SUBYTE4
SU25BIT  EQU   SUBYTE4
SU24BIT  EQU   SUBYTE4
SU23BIT  EQU   SUBYTE3
SU22BIT  EQU   SUBYTE3
SU21BIT  EQU   SUBYTE3
SU20BIT  EQU   SUBYTE3
SU19BIT  EQU   SUBYTE3
SU17BIT  EQU   SUBYTE3
SU16BIT  EQU   SUBYTE3
SU15BIT  EQU   SUBYTE2
SU14BIT  EQU   SUBYTE2
SU13BIT  EQU   SUBYTE2
SU12BIT  EQU   SUBYTE2
SU11BIT  EQU   SUBYTE2
SU10BIT  EQU   SUBYTE2
SU9BIT   EQU   SUBYTE2
SU8BIT   EQU   SUBYTE2
SU7BIT   EQU   SUBYTE1
SU6BIT   EQU   SUBYTE1
SU5BIT   EQU   SUBYTE1
SU4BIT   EQU   SUBYTE1
SU3BIT   EQU   SUBYTE1
SU2BIT   EQU   SUBYTE1
SU1BIT   EQU   SUBYTE1
SU0BIT   EQU   SUBYTE1
GRPWPTR  EQU   GRPCOUNT+12
GRPEXCS  EQU   GRPCOUNT+8
GRPTOTAL EQU   GRPCOUNT+6
GRPALLCT EQU   GRPCOUNT+2
@NM00039 EQU   CVRGPLST+13
@NM00038 EQU   CVRFLG3
CVRFORCI EQU   CVRFLG3
CVRBOUND EQU   CVRGPLST+10
CVRGCPTR EQU   CVRGPLST
@NM00037 EQU   CVRRQLST+26
@NM00036 EQU   CVRFLG2+1
CVRDUPLI EQU   CVRFLG2+1
CVRWMOVE EQU   CVRFLG2
CVRIGNOR EQU   CVRFLG2
CVRMULTI EQU   CVRFLG2
CVRSCRTH EQU   CVRFLG2
CVRFULL  EQU   CVRFLG2
CVRREACH EQU   CVRFLG2
CVRRUSED EQU   CVRFLG2
CVRGNEXT EQU   CVRRQLST+12
CVRPTS   EQU   CVRMIN
CVRNEED  EQU   CVRRQLST+8
CVRREQ1  EQU   CVRRQLST+4
CVRVUPTR EQU   CVRRQLST
@NM00035 EQU   CVRPARM+9
@NM00034 EQU   CVRFLG1
CVROFFLG EQU   CVRFLG1
CVRALFLG EQU   CVRFLG1
CVRAVFLG EQU   CVRFLG1
CVRGRPLK EQU   CVRPARM+6
CVRNREQ  EQU   CVRPARM+4
CVRRQPTR EQU   CVRPARM
ALGGLSTP EQU   ALGPTRS+8
ALGRQLTP EQU   ALGPTRS+4
ALCPROCN EQU   NAMES+16
ALCSTEPN EQU   NAMES+8
ALCJOBN  EQU   NAMES
LOJSSNMP EQU   ALCWA+164
SSERBLKP EQU   ALCWA+160
GROUPSZ  EQU   ALCWA+156
GRIDPTR  EQU   ALCWA+152
ALCNUCBS EQU   ALCWA+148
EXITPRMP EQU   ALCWA+144
CANCELP  EQU   ALCWA+140
WORK3MP  EQU   ALCWA+136
WMASK2P  EQU   ALCWA+132
WMASKPTR EQU   ALCWA+128
LGENLOCK EQU   ALCWA+124
TCBP     EQU   ALCWA+116
ALCWASID EQU   ALCWA+114
@NM00033 EQU   @NM00032
NODEVERR EQU   @NM00032
NEEDRCVY EQU   @NM00032
ALCWAREC EQU   @NM00032
WAITIGEN EQU   @NM00032
UNITRECS EQU   @NM00032
ALCWADUL EQU   INDICATE
ALCWISAM EQU   INDICATE
DSSUNIT  EQU   INDICATE
DSSTAPE  EQU   INDICATE
PRIVASUM EQU   INDICATE
INDREQU  EQU   INDICATE
INDWAIT  EQU   INDICATE
QMGRRBP  EQU   ALCWA+108
RIMTABCT EQU   ALCWA+104
RIMTABLN EQU   ALCWA+100
RIMTABP  EQU   ALCWA+96
ALGTABSZ EQU   ALCWA+92
@NM00031 EQU   ALCWA+78
LTUNITID EQU   ALCWA+76
NUMREQS  EQU   CNTABLE+40
OTHEREQS EQU   CNTABLE+32
SUBSREQS EQU   CNTABLE+28
STRGREQS EQU   CNTABLE+24
PUBLREQS EQU   CNTABLE+20
PVTNREQS EQU   CNTABLE+16
SPECREQS EQU   CNTABLE+12
TPREQS   EQU   CNTABLE+8
VAMREQS  EQU   CNTABLE+4
DMYREQS  EQU   CNTABLE
JSCBPTR  EQU   ALCWA+12
FMAPPTR  EQU   ALCWA+4
WASIZE   EQU   ALCWA
@NM00030 EQU   VUGRLENT+5
@NM00029 EQU   VUGRLFLG
VUGRALCD EQU   VUGRLFLG
VUGRLIDS EQU   VUGRLENT
VUCBS    EQU   VUPOOL+4
VUPOOL#  EQU   VUPOOL
VOLUNTID EQU   VOLUNTAB+10
VUVLUNIQ EQU   VOLSTATD
VUDMUNIQ EQU   VOLSTATD
VUUNALSW EQU   VOLSTATD
VUDMNDAL EQU   VOLSTATD
VUREALOC EQU   VOLSTATD
VUMUGDON EQU   VOLSTATD
@NM00028 EQU   VOLSTATC
@NM00027 EQU   VOLSTATC
VURECVRY EQU   VOLSTATC
VOLURREQ EQU   VOLSTATC
VOLGRREQ EQU   VOLSTATC
VOLDAREQ EQU   VOLSTATC
VOLCOREQ EQU   VOLSTATC
VOLTAREQ EQU   VOLSTATC
VUAFFWRK EQU   VOLSTATB
VUVINELG EQU   VOLSTATB
VUDADSME EQU   VOLSTATB
VUDNALOC EQU   VOLSTATB
VUPROCED EQU   VOLSTATB
VOLMNTD  EQU   VOLSTATB
VOLDEFER EQU   VOLSTATA
VUDADSM  EQU   VOLSTATA
VOLRESVE EQU   VOLSTATA
VOLNSHR  EQU   VOLSTATA
VOLSTG   EQU   VOLSTATA
VOLPRV   EQU   VOLSTATA
VOLPUB   EQU   VOLSTATA
EDLVOLAF EQU   EDLINDIC
EDLENQ   EQU   EDLINDIC
EDLDADSM EQU   EDLINDIC
EDLALCD  EQU   EDLINDIC
EDLJINEL EQU   EDLGRFLG
@NM00026 EQU   EDLENTRY+18
EDLNSCNT EQU   EDLENTRY+16
EDLMGENS EQU   EDLUVFLG
EDLVAM   EQU   EDLUVFLG
EDLGMTP  EQU   EDLHDR+12
EDLLUV   EQU   EDLHDR
GRPMASK  EQU   GMTENTRY
GMTENTLN EQU   GMTHDR+4
GMTENTNO EQU   GMTHDR
EUCBENLN EQU   EUCBHDR+4
EUCBENNO EQU   EUCBHDR
GRPID    EQU   GRPENTRY
GRPTR    EQU   GRPTRTAB
GENGRPTR EQU   GENENTRY+8
GENGRPNO EQU   GENENTRY+4
GENDEVT  EQU   GENENTRY
GENENTLN EQU   GENHDR+4
GENENTNO EQU   GENHDR
LUVAGMTP EQU   LUVENTRY+28
@NM00025 EQU   LUVFLAGS
LUVMGENS EQU   LUVFLAGS
LUVAGMSK EQU   LUVFLAGS
LUVVAM   EQU   LUVFLAGS
LUVGENP  EQU   LUVENTRY+20
LUVGENNO EQU   LUVENTRY+16
LUVALUE  EQU   LUVENTRY+8
UNITNAME EQU   LUVENTRY
LUVENTLN EQU   LUVHDR+4
LUVENTNO EQU   LUVHDR
UCBERADR EQU   UCBUCS+12
UCBFCBID EQU   UCBUCS+8
UCBERCNT EQU   UCBUCS+7
UCBRSV51 EQU   UCBUCS+6
UCBFCBPE EQU   UCBFCBOP
UCBRSV49 EQU   UCBFCBOP
UCBRSV48 EQU   UCBFCBOP
UCBRSV47 EQU   UCBFCBOP
UCBRSV46 EQU   UCBFCBOP
UCBRSV45 EQU   UCBFCBOP
UCBRSV44 EQU   UCBFCBOP
UCBFCBO1 EQU   UCBFCBOP
UCBUCSPE EQU   UCBUCSOP
UCBRSV43 EQU   UCBUCSOP
UCBRSV42 EQU   UCBUCSOP
UCBRSV41 EQU   UCBUCSOP
UCBRSV40 EQU   UCBUCSOP
UCBRSV39 EQU   UCBUCSOP
UCBUCSO2 EQU   UCBUCSOP
UCBUCSO1 EQU   UCBUCSOP
UCBUCSID EQU   UCBUCS
UCBMDRBA EQU   UCBMDRBF+1
UCBRV075 EQU   UCBMDRBF
UCBRV074 EQU   UCB3800X+32
UCBIMAGE EQU   UCB3800X+28
UCBFCBNM EQU   UCB3800X+24
UCBCHAR4 EQU   UCB3800X+20
UCBCHAR3 EQU   UCB3800X+16
UCBCHAR2 EQU   UCB3800X+12
UCBCHAR1 EQU   UCB3800X+8
UCBCGMID EQU   UCB3800X+4
UCBBRSTA EQU   UCBACTIV
UCBRV063 EQU   UCBACTIV
UCBRV062 EQU   UCBACTIV
UCBRV061 EQU   UCBACTIV
UCBRV060 EQU   UCBACTIV
UCBRV059 EQU   UCBACTIV
UCBRV058 EQU   UCBACTIV
UCBRV057 EQU   UCBACTIV
UCBRV050 EQU   UCB3800X+2
UCBCGMNO EQU   UCB3800X+1
UCBRV083 EQU   UCBOPTNS
UCBBRSTR EQU   UCBOPTNS
UCBRV056 EQU   UCBOPTNS
UCBRV055 EQU   UCBOPTNS
UCBRV054 EQU   UCBOPTNS
UCBRV053 EQU   UCBOPTNS
UCBRV052 EQU   UCBOPTNS
UCBRV051 EQU   UCBOPTNS
UCBRV073 EQU   UCB3540X+7
UCBRV072 EQU   UCBDKBYT
UCBRV071 EQU   UCBDKBYT
UCBRV070 EQU   UCBDKBYT
UCBRV069 EQU   UCBDKBYT
UCBRV068 EQU   UCBDKBYT
UCBRV067 EQU   UCBDKBYT
UCBVLVER EQU   UCBDKBYT
UCBDKAMX EQU   UCBDKBYT
UCBVLSER EQU   UCB3540X
UCBRDATA EQU   UCBOCR+4
UCBFRID  EQU   UCBOCR
UCBCLN   EQU   UCBMT+14
UCBERG   EQU   UCBMT+12
UCBMS    EQU   UCBMT+11
UCBNB    EQU   UCBMT+10
UCBPW    EQU   UCBMT+9
UCBPR    EQU   UCBMT+8
UCBSIO   EQU   UCBMT+6
UCBTW    EQU   UCBMT+5
UCBTR    EQU   UCBMT+4
UCBTWT   EQU   UCBMT+3
UCBTRT   EQU   UCBMT+2
UCBCTD   EQU   UCBMT
UCBWTOID EQU   UCBCMEXT+17
UCBRV043 EQU   UCBCMEXT+16
UCBASID  EQU   UCBCMEXT+14
UCBMFCNT EQU   UCBCMEXT+12
UCBPMSK  EQU   UCBCMEXT+10
UCBCCWOF EQU   UCBCMEXT+8
UCBRV041 EQU   UCBCMEXT+6
UCBRV036 EQU   UCBFLP1
UCBRV035 EQU   UCBFLP1
UCBERLOG EQU   UCBFLP1
UCBRV033 EQU   UCBFLP1
UCBINHIO EQU   UCBFLP1
UCBNSWAP EQU   UCBFLP1
UCBSHRUP EQU   UCBFLP1
UCBNSRCH EQU   UCBFLP1
UCBSNSCT EQU   UCBCMEXT+4
UCBHPDV  EQU   @NM00024
UCBHALI  EQU   @NM00024
UCBRSV09 EQU   @NM00024
UCBRSV08 EQU   @NM00024
UCBRSV07 EQU   @NM00024
UCBRSV06 EQU   @NM00024
UCBRSV05 EQU   @NM00024
UCBRSV04 EQU   @NM00024
UCBDTI   EQU   UCBCMEXT+2
UCBSTI   EQU   UCBCMEXT+1
UCBETI   EQU   UCBCMEXT
UCBEXTP  EQU   UCBEXTPT+1
UCBDDRSW EQU   UCBFLC
UCBTICBT EQU   UCBFLC
UCBIVRR  EQU   UCBFLC
UCBIVRS  EQU   UCBFLC
UCBITF   EQU   UCBFLC
UCBUDE   EQU   UCBFLC
UCBWAA   EQU   UCBFLC
UCBATTP  EQU   UCBFLC
UCBUNTYP EQU   UCBTBYT4
UCBRSV11 EQU   UCBDVCLS
UCBRSV10 EQU   UCBDVCLS
UCB3CHAR EQU   UCBDVCLS
UCB3UREC EQU   UCBDVCLS
UCB3DISP EQU   UCBDVCLS
UCB3COMM EQU   UCBDVCLS
UCBDVPWR EQU   UCB2OPT7
UCBVLPWR EQU   UCB2OPT6
UCB2OPT5 EQU   UCBTBYT2
UCBRVDEV EQU   UCBRWTAU
UCBRPS   EQU   UCBDUDN2
UCBRR    EQU   UCBDUDN1
UCB2OPT1 EQU   UCBTBYT2
UCB2OPT0 EQU   UCBTBYT2
UCB1FEA7 EQU   UCBTBYT1
UCBD6250 EQU   UCB1FEA6
UCBD1600 EQU   UCB1FEA5
UCB1FEA4 EQU   UCBTBYT1
UCB1FEA3 EQU   UCBTBYT1
UCB1FEA2 EQU   UCBTBYT1
UCB1FEA1 EQU   UCBTBYT1
UCB1FEA0 EQU   UCBTBYT1
UCBNAME  EQU   UCBOB+13
UCBRV029 EQU   UCBWGT
UCBVHRSN EQU   UCBWGT
UCBVORSN EQU   UCBWGT
UCBMTPXP EQU   UCBWGT
UCBREW   EQU   UCBWGT
UCBPUB   EQU   UCBWGT
UCBOUT   EQU   UCBWGT
UCBIN    EQU   UCBWGT
UCBCPU   EQU   UCBOB+11
UCBLCI   EQU   UCBOB+10
UCBCNT   EQU   UCBOB+9
UCBRV017 EQU   UCBCHM1
UCBRV016 EQU   UCBCHM1
UCBRV015 EQU   UCBCHM1
UCBRV014 EQU   UCBCHM1
UCBSPB   EQU   UCBPTH1
UCBPPB   EQU   UCBPTH1
UCBSPA   EQU   UCBPTH0
UCBPPA   EQU   UCBPTH0
UCBSIGP  EQU   UCBFLB
UCBVALPH EQU   UCBFLB
UCBCRHSN EQU   UCBFLB
UCBCRHRV EQU   UCBFLB
UCBRESVH EQU   UCBFLB
UCBSPST  EQU   UCBFLB
UCBASNS  EQU   UCBFLB
UCBIORST EQU   UCBFLB
UCBQISCE EQU   UCBFL1
UCBACTV  EQU   UCBFL1
UCBSAP   EQU   UCBFL1
UCBNOTRC EQU   UCBCUB
UCBPSNS  EQU   UCBFL1
UCBUSING EQU   UCBPST
UCBNOTRD EQU   UCBNRY
UCBBUSYD EQU   UCBBSY
UCBUA    EQU   UCBCHAN+1
UCBCHA   EQU   UCBCHAN
UCBDADI  EQU   UCBSTAT
UCBUNLD  EQU   UCBSTAT
UCBCHGS  EQU   UCBSTAT
UCBID    EQU   UCBOB+2
UCBALTPH EQU   UCBFL5
UCBALTCU EQU   UCBFL5
UCBENVRD EQU   UCBFL5
UCBVSDR  EQU   UCBFL5
UCBSASK  EQU   UCBFL5
UCBAMV   EQU   UCBAF
UCBDCC   EQU   UCBFL5
UCBMONT  EQU   UCBJBNR
UCBRV011 EQU   UCBJBNR
UCBMMSGP EQU   UCBJBNR
UCBOLDSM EQU   UCBJBNR
UCBRV003 EQU   UCBJBNR
UCBDUC   EQU   UCBJBNR
UCBJES3  EQU   UCBJBNR
UCBVRDEV EQU   UCBJBNR
UCBCMSEG EQU   UCBOB
UCBPFXND EQU   UCB+512
UCBIOQ   EQU   UCB+508
UCBLOCK  EQU   UCB+504
UCBPXST  EQU   UCB+504
@NM00021 EQU   UCB
SIODDSNL EQU   INDMSIOT+173
SIOVDSNL EQU   INDMSIOT+172
SIOVDSNT EQU   INDMSIOT+170
SIOTVMVP EQU   INDMSIOT+164
SIOTJFX  EQU   INDMSIOT+160
SJFCBPTR EQU   INDMSIOT+156
SIOTATE  EQU   INDMSIOT+144
SIOTEDLS EQU   INDMSIOT+132
SIOTRSNC EQU   INDMSIOT+130
SCTANAME EQU   INDMSIOT+122
SIOTSSIC EQU   INDMSIOT+120
@NM00020 EQU   INDMSIOT+108
SIOTSSNM EQU   INDMSIOT+104
@NM00019 EQU   SIOTBYT2
SIOTCVOL EQU   SIOTBYT2
SIOTCNEW EQU   SIOTBYT2
SIOTCALC EQU   SIOTBYT2
SIOTGALL EQU   SIOTBYT2
SIOTDSPD EQU   SIOTBYT2
SIOTOPUC EQU   INDMSIOT+99
SIOTOUTR EQU   INDMSIOT+97
SIOTOUTC EQU   INDMSIOT+96
SIOTSSWA EQU   INDMSIOT+93
SIOTAUNC EQU   SIOTALTD
SIOTACAT EQU   SIOTALTD
SIOTADEL EQU   SIOTALTD
SIOTAKEP EQU   SIOTALTD
SIOTNPRV EQU   SIOTALTD
SIOJCATS EQU   SIOTALTD
@NM00018 EQU   SIOTALTD
@NM00017 EQU   SIOTALTD
@NM00016 EQU   INDMSIOT+91
SIOTNDSB EQU   INDMSIOT+88
@NM00015 EQU   INDMSIOT+84
SIOTDPCD EQU   INDMSIOT+82
@NM00014 EQU   SIOTBYT4
SIOTRACT EQU   SIOTBYT4
SIOTRACD EQU   SIOTBYT4
SIOTPROT EQU   SIOTBYT4
SCTOUTPN EQU   INDMSIOT+80
SCTOUTNO EQU   INDMSIOT+76
SCTOUTNM EQU   INDMSIOT+68
SIOUCNVT EQU   SCTUTYPE+4
SIOUBYT4 EQU   SIOTDEVT+3
@NM00013 EQU   SIOUBYT3
SIO3UREC EQU   SIOUBYT3
SIO3DISP EQU   SIOUBYT3
SIO3DACC EQU   SIOUBYT3
SIO3COMM EQU   SIOUBYT3
SIO3TAPE EQU   SIOUBYT3
SIOUBYT2 EQU   SIOTDEVT+1
SIOUBYT1 EQU   SIOTDEVT
SIOTOMN  EQU   SCTSBYT4
SIOTIPDI EQU   SCTSBYT4
SIOTVAFF EQU   SCTSBYT4
SIOTSTEP EQU   SCTSBYT4
SIOTASCI EQU   SCTSBYT4
@NM00012 EQU   SCTSBYT4
SIOTGDGA EQU   SCTSBYT4
SCTSGDGS EQU   SCTSBYT4
SCTSOLD  EQU   SCTSBYT3
SCTSMOD  EQU   SCTSBYT3
SCTSNEW  EQU   SCTSBYT3
SCTSYSOU EQU   SCTSBYT3
SCTVREF  EQU   SCTSBYT3
SCTALCHK EQU   SCTSBYT3
SCTSYSNE EQU   SCTSBYT3
SCTDSNRF EQU   SCTSBYT3
SCTRECVD EQU   SCTSBYT2
SCTDEFER EQU   SCTSBYT2
SCTLABEL EQU   SCTSBYT2
SCTUNLBD EQU   SCTSBYT2
SCTJOBLB EQU   SCTSBYT2
SCTVOLAF EQU   SCTSBYT2
SIOTCATL EQU   SCTSBYT2
SIOCLUNL EQU   SCTSBYT2
SIOTJSCT EQU   SCTSBYT1
SCTUNAFF EQU   SCTSBYT1
SCTPARLM EQU   SCTSBYT1
SIOTQDSN EQU   SCTSBYT1
SIOTGDSN EQU   SCTSBYT1
SIOTCCAT EQU   SCTSBYT1
SCTSYSIN EQU   SCTSBYT1
SCTDUMMY EQU   SCTSBYT1
SIOTUNCT EQU   SCTSDISP
SIOTCTLG EQU   SCTSDISP
SIOTDLET EQU   SCTSDISP
SIOTKEEP EQU   SCTSDISP
SIOTPASS EQU   SCTSDISP
SIOTPRIV EQU   SCTSDISP
S3400DSP EQU   SCTSDISP
SIOTRETN EQU   SCTSDISP
SIOTVLCT EQU   INDMSIOT+54
SCTNMBUT EQU   INDMSIOT+53
SIOTPUPV EQU   SIOTBYT0
SIOTNOPV EQU   SIOTBYT0
SIOTGIGN EQU   SIOTBYT0
SPVTAMSG EQU   SIOTBYT0
SIOTFUDA EQU   SIOTBYT0
SIOTDYAL EQU   SIOTBYT0
SIOTSSDS EQU   SIOTBYT0
SIOTGIID EQU   INDMSIOT+50
SCTVOLCT EQU   INDMSIOT+49
SCTSPOOL EQU   INDMSIOT+48
SIOTQNAM EQU   SIOTTSTC
SIOTDSNM EQU   SIOTTSTC
SIOTTRKM EQU   SIOTTSTC
SIOTSSMG EQU   SIOTTSTC
SIOTSSGP EQU   SIOTTSTC
@NM00011 EQU   SIOTTSTC
SIOTTERM EQU   SIOTTSTC
SIOTINFC EQU   SIOTTSTC
@NM00010 EQU   SIOTBYT3
SIOTDSID EQU   SIOTBYT3
S3400OFF EQU   SIOTBYT3
SIOCDEVT EQU   SIOTBYT3
SIOALIAS EQU   SIOTBYT3
SCTDDINO EQU   INDMSIOT+44
SIOTDDNT EQU   SIOTBYT1
SIODADSM EQU   SIOTBYT1
SIOTDADR EQU   SIOTBYT1
SIODUNAL EQU   SIOTBYT1
SIOVAMDS EQU   SIOTBYT1
SIOTHOLD EQU   SIOTBYT1
SIOTOCKP EQU   SIOTBYT1
SIOPSCNT EQU   INDMSIOT+42
SIOTREFN EQU   INDMSIOT+40
SIOTVRSB EQU   INDMSIOT+36
@NM00009 EQU   INDMSIOT+35
SCTPJFCB EQU   INDMSIOT+32
@NM00008 EQU   INDMSIOT+31
SCTPSIOT EQU   INDMSIOT+28
SIOTAFID EQU   INDMSIOT+26
SIOTVLSP EQU   INDMSIOT+24
SIODSNTE EQU   INDMSIOT+22
SIOTUNAF EQU   SCTUSADD
SIOTDEST EQU   INDMSIOT+12
SCTDDNAM EQU   INDMSIOT+4
SIOTTYPE EQU   INDMSIOT+3
SIOTDSKA EQU   INDMSIOT
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00007 EQU   CVTFIX+248
@NM00006 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTSKTA  EQU   CVTXTNT2+44
CVTCCVT  EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
SSCLLEN  EQU   SSCLSPLN+1
SSCLSUBP EQU   SSCLSPLN
@NM00005 EQU   RETAREA+4
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RF00120 EQU   @RC00106
@RC00140 EQU   @RC00137
@RC00265 EQU   @RC00262
@RF00361 EQU   @RC00333
@RF00498 EQU   @RC00494
@RC00417 EQU   @RC00395
@RC00227 EQU   @EL00002
@RC00161 EQU   @RC00140
@RF00282 EQU   @RC00265
@RC00418 EQU   @RC00417
@RF00180 EQU   @RC00161
@ENDDATA EQU   *
         END   IEFAB489,(C'PLS2107',0701,78054)
