         TITLE 'IEFAB492 - HANDLE VM&&V REQUESTS                       *
                         '
IEFAB492 CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(24)                                          01S0001
         DC    C'IEFAB492 78089  UZ17548 '                      01S0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01S0001
         BALR  @12,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@12                                      01S0001
         L     @00,@SIZDATD                                     01S0001
         MODESET EXTKEY=SCHED,SAVEKEY=(2)
         GSPACE   R,LV=(0)
         LR    @11,@01                                          01S0001
         USING @DATD,@11                                        01S0001
         ST    @13,@SA00001+4                                   01S0001
         STC   @02,@OLDKEY                                      01S0001
         MODESET KEYADDR=(2)
         LM    @00,@02,20(@13)                                  01S0001
         ST    @11,8(,@13)                                      01S0001
         LR    @13,@11                                          01S0001
         MODESET EXTKEY=ZERO
         MVC   @PC00001(40),0(@01)                              01S0001
         MODESET EXTKEY=SCHED
JSCBDISP EQU 188
JSCBAOS1 EQU  72
JSCBAOS2 EQU 192
*ERRWORD=NOERROR;                      /*INITIALIZE RETURN CODE      */
         SLR   ERRWORD,ERRWORD                                  01S0076
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - VMVCHAIN                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - VM&V REQUEST BLOCK CHAINING ROUTINE           */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE CHAINS TOGETHER VM&V REQUEST BLOCKS FOR INPUT     */
*/*   TO VOLUME MOUNT AND VERIFY CONTROL ROUTINE.                    */
*/*                                                                  */
*/* OPERATION                                                        */
*/*   THIS ROUTINE SEARCHES DOWN THE SIOT CHAIN LOOKING FOR VM&V     */
*/*   REQUEST BLOCKS.                                                */
*/*   THE POINTER TO THE FIRST VM&V REQUEST BLOCK IS PLACED IN       */
*/*   FRSTVMVP. ALL SUBSEQUENT REQUEST BLOCKS ARE CHAINED TOGETHER.  */
*/*   ALL SIOT POINTERS TO VM&V REQUEST BLOCKS ARE ZEROED.           */
*/*                                                                  */
*/* ENTRY - INLINE SEGMENT OF IEFAB492.                              */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*                                                                  */
*/*     FSIOTPTR - POINTER TO FIRST SIOT IN CHAIN.                   */
*/*                                                                  */
*/*                                                                  */
*/* EXIT - NORMAL -                                                  */
*/*                                                                  */
*/*   CONDITION - ALL REQUEST BLOCKS CHAINED FOR INPUT TO VM&V       */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*                                                                  */
*/*     FRSTVMVP - POINTER TO FIRST VM&V REQUEST BLOCK.              */
*/*                                                                  */
*/*     VMVNREQP - IN VMVRQBLK,SET TO POINT TO NEXT REQUEST BLOCK ON */
*/*                CHAIN. ZERO IF LAST.                              */
*/*                                                                  */
*/*     SIOTVMVP - SET TO 0 (FOR ANY SIOTS WHICH HAD POINTED TO VM&V */
*/*                REQUEST BLOCKS.                                   */
*/*                                                                  */
*/*     RETURN CODE - NONE                                           */
*/*                                                                  */
*/*                                                                  */
*/********************************************************************/
*FRSTVMVP = ZERO;                      /*INIT PTR TO FIRST VMV RB    */
         SLR   @10,@10                                          02S0077
         ST    @10,FRSTVMVP                                     02S0077
*FREQBLSW= OFF;                        /*INIT FIRST VMV REQ BLK SW   */
         NI    FREQBLSW,B'01111111'                             02S0078
*SIOTPTR=FSIOTPTR;                     /*POINT TO FIRST SIOT         */
         L     @10,@PC00001                                     02S0079
         L     SIOTPTR,FSIOTPTR(,@10)                           02S0079
*DO WHILE SIOTPTR ^= ZERO;             /*LOOP THRU ALL SIOTS         */
         B     @DE00080                                         02S0080
@DL00080 DS    0H                                               02S0081
*  IF SIOTVMVP ^= ZERO THEN            /*ANY VMV REQS FOR THIS SIOT? */
         L     @10,SIOTVMVP(,SIOTPTR)                           02S0081
         LTR   @10,@10                                          02S0081
         BZ    @RF00081                                         02S0081
*    DO;                                                        02S0082
*      VMVREQBP = SIOTVMVP;            /*SET PTR TO FIRST VMV REQ    */
         ST    @10,VMVREQBP                                     02S0083
*      DO WHILE VMVREQBP ^= ZERO;      /*LOOP THRU ALL VMV REQ BLKS  */
         B     @DE00084                                         02S0084
@DL00084 DS    0H                                               02S0085
*        SAVEREQP = VMVNREQP;          /*SAVE PTR TO NEXT RB         */
         L     @10,VMVREQBP                                     02S0085
         L     SAVEREQP,VMVNREQP(,@10)                          02S0085
*        VMVNREQP = ZERO;              /*CLEAR NEXT PTR IN VMVRB     */
         SLR   @09,@09                                          02S0086
         ST    @09,VMVNREQP(,@10)                               02S0086
*        IF FREQBLSW = OFF THEN        /*IS THIS FIRST REQUEST?      */
         TM    FREQBLSW,B'10000000'                             02S0087
         BNZ   @RF00087                                         02S0087
*          DO;                                                  02S0088
*            FRSTVMVP = VMVREQBP;      /*SAVE PTR TO FIRST BLOCK     */
         ST    @10,FRSTVMVP                                     02S0089
*            PREVVMVP = VMVREQBP;      /*SET BACKWARD POINTER        */
         LR    PREVVMVP,@10                                     02S0090
*            FREQBLSW = ON;            /*INDICATE FIRST ENTRY MADE   */
         OI    FREQBLSW,B'10000000'                             02S0091
*          END;                                                 02S0092
*        ELSE                          /*THIS NOT FIRST BLK ON CHAIN */
*          DO;                                                  02S0093
         B     @RC00087                                         02S0093
@RF00087 DS    0H                                               02S0094
*            PREVVMVP->VMVNREQP=VMVREQBP; /*CHAIN TO PREVIOUS REQ    */
         L     @10,VMVREQBP                                     02S0094
         ST    @10,VMVNREQP(,PREVVMVP)                          02S0094
*            PREVVMVP = VMVREQBP;      /*SET BACKWARD POINTER        */
         LR    PREVVMVP,@10                                     02S0095
*          END;                                                 02S0096
*        VMVREQBP = SAVEREQP;          /*POINT TO NEXT VMV REQ BLK   */
@RC00087 ST    SAVEREQP,VMVREQBP                                02S0097
*      END;                                                     02S0098
@DE00084 SLR   @10,@10                                          02S0098
         C     @10,VMVREQBP                                     02S0098
         BNE   @DL00084                                         02S0098
*      SIOTVMVP = ZERO;                /*ZERO POINTER TO VMV REQ BLK */
         ST    @10,SIOTVMVP(,SIOTPTR)                           02S0099
*    END;                                                       02S0100
*  ELSE;                               /*NO VMV REQS FOR THIS SIOT   */
@RF00081 DS    0H                                               02S0102
*  SIOTPTR = SIOTNPTR;                 /*POINT TO NEXT SIOT          */
         L     SIOTPTR,SIOTNPTR(,SIOTPTR)                       02S0102
*END;                                                           02S0103
@DE00080 LTR   SIOTPTR,SIOTPTR                                  02S0103
         BNZ   @DL00080                                         02S0103
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - VMVDUPCK                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - DUPLICATE VM&V RB CHECKER                     */
*/*                                                                  */
*/* FUNCTION - THIS ROUTINE SCANS THE VM&V REQUEST BLOCK CHAIN       */
*/*            AND MARKS MOUNT ENTRIES FOR THE SAME VOLUME AS        */
*/*            DUPLICATES.                                           */
*/*                                                                  */
*/* ENTRY - INLINE SEGMENT OF IEFAB492.                              */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION.                                        */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*     FRSTVMVP - POINTER TO FIRST VM&V RB.                         */
*/*                                                                  */
*/* EXIT -                                                           */
*/*                                                                  */
*/*   CONDITION - ALL DUPLICATE VM&V ENTRIES LOCATED AND MARKED AS   */
*/*               SUCH.                                              */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*     VMVDUPVL - IN VMVRQBLK, SET ON IN ALL BUT THE FIRST VM&V RB  */
*/*                FOR A PARTICULAR VOLUME.                          */
*/*                                                                  */
*/*   RETURN CODE -                                                  */
*/*     NONE                                                         */
*/*                                                                  */
*/********************************************************************/
*VMVREQBP = FRSTVMVP;                  /*POINT TO FIRST VM&V RB      */
         MVC   VMVREQBP(4),FRSTVMVP                             02S0104
*DO WHILE VMVREQBP ^= ZERO;            /*LOOP THRU VM&V REQUEST BLOCK*/
         B     @DE00105                                         02S0105
@DL00105 DS    0H                                               02S0106
*  AVMVRBP = VMVNREQP;                 /*INIT ALTERNATE VM&V RB PTR  */
         L     @10,VMVREQBP                                     02S0106
         L     AVMVRBP,VMVNREQP(,@10)                           02S0106
*  DO WHILE AVMVRBP ^= ZERO;           /*LOOP THRU REMAINING VM&V RBS*/
         B     @DE00107                                         02S0107
@DL00107 DS    0H                                               02S0108
*    IF AVMVRBP-> VMVDUPVL = OFF THEN  /*IF THIS NOT DUP             */
         TM    VMVDUPVL(AVMVRBP),B'10000000'                    02S0108
         BNZ   @RF00108                                         02S0108
*      DO;                                                      02S0109
*        IF VMVUCBP=AVMVRBP->VMVUCBP THEN /*SAME VOL?                */
         L     @10,VMVREQBP                                     02S0110
         CLC   VMVUCBP(3,@10),VMVUCBP(AVMVRBP)                  02S0110
         BNE   @RF00110                                         02S0110
*          DO;                                                  02S0111
*            AVMVRBP->VMVDUPVL = ON;   /*SET DUP SWITCH              */
         OI    VMVDUPVL(AVMVRBP),B'10000000'                    02S0112
*            IF (VMVDSNMP= ZERO & AVMVRBP->VMVDSNMP^=ZERO) THEN /*1ST
*                                        NON TEMPORARY DSNAME MUST
*                                        APPEAR IN MOUNT MESSAGE     */
         SLR   @09,@09                                          02S0113
         C     @09,VMVDSNMP(,@10)                               02S0113
         BNE   @RF00113                                         02S0113
         L     @07,VMVDSNMP(,AVMVRBP)                           02S0113
         CR    @07,@09                                          02S0113
         BE    @RF00113                                         02S0113
*              VMVDSNMP = AVMVRBP -> VMVDSNMP;                  02S0114
         ST    @07,VMVDSNMP(,@10)                               02S0114
*            ELSE;                                              02S0115
@RF00113 DS    0H                                               02S0116
*          END;                                                 02S0116
*        ELSE;                                                  02S0117
@RF00110 DS    0H                                               02S0118
*      END;                                                     02S0118
*    ELSE;                                                      02S0119
@RF00108 DS    0H                                               02S0120
*    AVMVRBP = AVMVRBP-> VMVNREQP;     /*UPDATE POINTER TO NEXT VMVRB*/
         L     AVMVRBP,VMVNREQP(,AVMVRBP)                       02S0120
*  END;                                                         02S0121
@DE00107 LTR   AVMVRBP,AVMVRBP                                  02S0121
         BNZ   @DL00107                                         02S0121
*  DO WHILE(VMVNREQP ^= ZERO &         /*LOOP TO FIND NEXT NON-DUP   */
*    VMVNREQP -> VMVDUPVL = ON);                                02S0122
         B     @DE00122                                         02S0122
@DL00122 DS    0H                                               02S0123
*    VMVREQBP = VMVNREQP;              /*POINT TO NEXT VM&V RB       */
         L     @10,VMVREQBP                                     02S0123
         L     @10,VMVNREQP(,@10)                               02S0123
         ST    @10,VMVREQBP                                     02S0123
*  END;                                                         02S0124
@DE00122 L     @10,VMVREQBP                                     02S0124
         L     @10,VMVNREQP(,@10)                               02S0124
         LTR   @10,@10                                          02S0124
         BZ    @DC00122                                         02S0124
         TM    VMVDUPVL(@10),B'10000000'                        02S0124
         BO    @DL00122                                         02S0124
@DC00122 DS    0H                                               02S0125
*  VMVREQBP = VMVNREQP;                /*POINT TO NEXT VM&V RB       */
         L     @10,VMVREQBP                                     02S0125
         L     @10,VMVNREQP(,@10)                               02S0125
         ST    @10,VMVREQBP                                     02S0125
*END;                                                           02S0126
@DE00105 SLR   @10,@10                                          02S0126
         C     @10,VMVREQBP                                     02S0126
         BNE   @DL00105                                         02S0126
*IF FRSTVMVP ^= ZERO THEN              /*ANY VMV REQUESTS ?          */
         C     @10,FRSTVMVP                                     01S0127
         BE    @RF00127                                         01S0127
*  DO;                                                          01S0128
*    VMVCALL = ON;                     /*INDICATE 1ST CALL IN ESTAE
*                                                            @YM07266*/
         L     @10,@PC00001+36                                  01S0129
         L     @10,EXITPRMP(,@10)                               01S0129
         OI    VMVCALL(@10),B'00000010'                         01S0129
*    CALL IEFAB493(FRSTVMVP,ASID,CNECB); /*INVOKE VOLUME MOUNT  01S0130
*                                            AND VERIFY              */
         LA    @10,FRSTVMVP                                     01S0130
         ST    @10,@AL00001                                     01S0130
         L     @10,@PC00001+16                                  01S0130
         ST    @10,@AL00001+4                                   01S0130
         L     @10,@PC00001+4                                   01S0130
         ST    @10,@AL00001+8                                   01S0130
         L     @15,@CV01144                                     01S0130
         LA    @01,@AL00001                                     01S0130
         BALR  @14,@15                                          01S0130
*    ERRWORD=REG15;                    /*SAVE RETURN CODE            */
         LR    ERRWORD,REG15                                    01S0131
*    IF ERRWORD=OPRCANCL |             /*OPERATOR CANCEL             */
*      ERRWORD = OPRSAYNO THEN         /*OR REPLY NO?                */
         CH    ERRWORD,@CH00098                                 01S0132
         BE    @RT00132                                         01S0132
         CH    ERRWORD,@CH00120                                 01S0132
         BNE   @RF00132                                         01S0132
@RT00132 DS    0H                                               01S0133
*      FAILRSCP->STRSNCDE = STCANCEL;  /*SHOW OPERATOR CANCELED STEP */
         L     @10,@PC00001+20                                  01S0133
         L     @10,FAILRSCP(,@10)                               01S0133
         MVC   STRSNCDE(2,@10),@CH00122                         01S0133
*    ELSE;                                                      01S0134
@RF00132 DS    0H                                               01S0135
*    IF ERRWORD = GETFAIL THEN         /*WAS THERE A GETMAIN FAILURE?*/
         CH    ERRWORD,@CH00096                                 01S0135
         BNE   @RF00135                                         01S0135
*      FAILRSCP -> STRSNCDE = GETMFAIL; /*GETMAIN FAIL REASON CODE   */
         L     @10,@PC00001+20                                  01S0136
         L     @10,FAILRSCP(,@10)                               01S0136
         MVC   STRSNCDE(2,@10),@CH00082                         01S0136
*    ELSE;                                                      01S0137
@RF00135 DS    0H                                               01S0138
*    IF ERRWORD = NOESTAE THEN         /*ESTAE ERROR                 */
         CH    ERRWORD,@CH00102                                 01S0138
         BNE   @RF00138                                         01S0138
*      FAILRSCP -> STRSNCDE = ESTFAIL;                          01S0139
         L     @10,@PC00001+20                                  01S0139
         L     @10,FAILRSCP(,@10)                               01S0139
         MVC   STRSNCDE(2,@10),@CH00098                         01S0139
*    ELSE;                                                      01S0140
@RF00138 DS    0H                                               01S0141
*    IF ERRWORD=NOTDEFND THEN          /*IF MSS VOLUME IS NOT DEFINED
*                                                            @Y30LPPE*/
         CH    ERRWORD,@CH00107                                 01S0141
         BNE   @RF00141                                         01S0141
*      FAILRSCP->STRSNCDE=NTDEFNDR;    /*SET REASON CODE TO 8@Y30LPPE*/
         L     @10,@PC00001+20                                  01S0142
         L     @10,FAILRSCP(,@10)                               01S0142
         MVC   STRSNCDE(2,@10),@CH00094                         01S0142
*    ELSE                              /*ELSE                @Y30LPPE*/
*      IF ERRWORD=NOTAVAIL THEN        /*IF MSS VOLUME IS NOT AVAILABLE
*                                                            @Y30LPPD*/
         B     @RC00141                                         01S0143
@RF00141 CH    ERRWORD,@CH00094                                 01S0143
         BNE   @RF00143                                         01S0143
*        FAILRSCP->STRSNCDE=NTAVAILR;  /*SET REASON CODE TO 3@Y30LPPE*/
         L     @10,@PC00001+20                                  01S0144
         L     @10,FAILRSCP(,@10)                               01S0144
         MVC   STRSNCDE(2,@10),@CH00111                         01S0144
*      ELSE                            /*ELSE                @Y30LPPE*/
*        IF ERRWORD=UNABTOMT THEN      /*IF MSS VOLUME CANNOT BE
*                                        MOUNTED             @Y30LPPD*/
         B     @RC00143                                         01S0145
@RF00143 CH    ERRWORD,@CH00127                                 01S0145
         BNE   @RF00145                                         01S0145
*          FAILRSCP->STRSNCDE=UNABTMTR;/*SET REASON CDE TO 10@Y30LPPE*/
         L     @10,@PC00001+20                                  01S0146
         L     @10,FAILRSCP(,@10)                               01S0146
         MVC   STRSNCDE(2,@10),@CH00129                         01S0146
*        ELSE                          /*ELSE                @Y30LPPE*/
*          IF ERRWORD=NOTACESS THEN    /*IF MSS VOLUME IS NOT   01S0147
*                                        ACCESSIBLE          @Y30LPPE*/
         B     @RC00145                                         01S0147
@RF00145 CH    ERRWORD,@CH00104                                 01S0147
         BNE   @RF00147                                         01S0147
*            FAILRSCP->STRSNCDE=NTACESSR;/*SET REASON CODE TO 23
*                                                            @Y30LPPE*/
         L     @10,@PC00001+20                                  01S0148
         L     @10,FAILRSCP(,@10)                               01S0148
         MVC   STRSNCDE(2,@10),@CH00109                         01S0148
*          ELSE                                                 01S0149
*            IF ERRWORD = MSGPINV THEN /*IF MSVGP NAME IS INVALID
*                                                            @Y30LPPE*/
         B     @RC00147                                         01S0149
@RF00147 CH    ERRWORD,@CH00071                                 01S0149
         BNE   @RF00149                                         01S0149
*              FAILRSCP->STRSNCDE=MSGPINVR; /*SET REASON CODE TO 24
*                                                            @Y30LPPE*/
         L     @10,@PC00001+20                                  01S0150
         L     @10,FAILRSCP(,@10)                               01S0150
         MVC   STRSNCDE(2,@10),@CH00127                         01S0150
*            ELSE                                               01S0151
*              IF ERRWORD = MSGPSPCE THEN /*IF SPACE OR MSVGP KEYWORDS
*                                         ARE MISSING        @Y30LPPE*/
         B     @RC00149                                         01S0151
@RF00149 CH    ERRWORD,@CH00133                                 01S0151
         BNE   @RF00151                                         01S0151
*                FAILRSCP->STRSNCDE = MSGPSPCR; /*SET REASON CODE TO 25
*                                                            @Y30LPPE*/
         L     @10,@PC00001+20                                  01S0152
         L     @10,FAILRSCP(,@10)                               01S0152
         MVC   STRSNCDE(2,@10),@CH00135                         01S0152
*    IF ERRWORD = NOERROR THEN         /*ANY ERRORS                  */
@RF00151 DS    0H                                               01S0153
@RC00149 DS    0H                                               01S0153
@RC00147 DS    0H                                               01S0153
@RC00145 DS    0H                                               01S0153
@RC00143 DS    0H                                               01S0153
@RC00141 LTR   ERRWORD,ERRWORD                                  01S0153
         BNZ   @RF00153                                         01S0153
*      DO;                                                      01S0154
*/********************************************************************/
*/*                                                                  */
*/*  SEGMENT NAME - NSPDACTL                                         */
*/*                                                                  */
*/*  DESCRIPTIVE NAME -  NON-SPECIFIC DIRECT ACCESS VOLUME CONTROLLER*/
*/*                                                                  */
*/*  FUNCTION - THIS ROUTINE SEARCHES THE VM&V RB CHAIN FOR REQUEST  */
*/*    BLOCKS OF NON-SPECIFIC DIRECT ACCESS VOLUMES. WHEN ONE IS     */
*/*    FOUND THE VOLUME SERIAL IS ENQ'D AND SPACE IS GOTTEN ON THE   */
*/*    VOLUME IF REQUESTED. WHEN ALL SUCH VM&V REQUEST BLOCKS HAVE   */
*/*    BEEN PROCESSED THEY ARE REMOVED FROM THE CHAIN. ALL DEVICE    */
*/*    GROUPS STILL SERIALIZED ARE RELEASED.                         */
*/*                                                                  */
*/*  ENTRY - INLINE SEGMENT OF IEFAB492.                             */
*/*                                                                  */
*/*    PURPOSE - SEE FUNCTION.                                       */
*/*                                                                  */
*/*    INPUT -                                                       */
*/*      FRSTVMVP - POINTER TO FIRST VM&V REQUEST BLOCK.             */
*/*      QMPARMP  - POINTER TO ALLOC QMGR PARM BLOCK OR ZERO @ZA10458*/
*/*                                                                  */
*/*  EXIT -                                                          */
*/*                                                                  */
*/*    CONDITION - PROCESSING SUCCESSFULLY COMPLETED.                */
*/*                                                                  */
*/*      OUTPUT -                                                    */
*/*        SIODADSM - IN SIOT, ON IF DADSM SUCCESSFUL                */
*/*        SPACE OBTAINED ON VOLUMES FOR NEW DATA SETS               */
*/*        NEW VM&V REQUEST LIST CONTAINING ONLY SPECIFIC DA AND     */
*/*        TAPE MOUNT REQUESTS.                                      */
*/*        ALL DEVICE GROUPS RELEASED.                               */
*/*                                                                  */
*/*      RETURN CODE -                                               */
*/*        ERRWORD - ZERO                                            */
*/*                                                                  */
*/*    CONDITION - VM&V FAILS TO MOUNT ANOTHER VOLUME AFTER A        */
*/*                   RECOVERABLE DADSM FAILURE DETECTED BY SEGMENT  */
*/*                   NSPDAVOL                                       */
*/*                                                                  */
*/*      OUTPUT -                                                    */
*/*        SAME AS ABOVE FOR ANY VM&V REQUEST BLOCK ALREADY          */
*/*        PROCESSED.                                                */
*/*                                                                  */
*/*      RETURN CODE -                                               */
*/*        ERRWORD - 20,TO INDICATE VM&V FAILURE.                    */
*/*                                                                  */
*/*    CONDITION - NON-RECOVERABLE DADSM FAILURE                     */
*/*                                                                  */
*/*      OUTPUT -                                                    */
*/*        SIOTRSNC - IN SIOT, WILL CONTAIN A REASON CODE GIVING     */
*/*                   THE SPECIFIC CAUSE OF FAILURE.                 */
*/*                   (SEE SEGMENT DADSEDAT FOR A LIST OF THESE      */
*/*                    REASON CODES)                                 */
*/*                                                                  */
*/*      RETURN CODE -                                               */
*/*        ERRWORD - 16, TO INDICATE NON-RECOVERABLE DADSM ERROR     */
*/*                                                                  */
*/********************************************************************/
*FNMAP = FNMAP && FNMAP;               /*CLEAR ENQ/DEQ FUNCTION MAP  */
         XC    FNMAP(1),FNMAP                                   02S0155
*FREQBLSW = OFF;                       /*SET CHAIN BEGUN SWITCH OFF  */
         NI    FREQBLSW,B'01111111'                             02S0156
*VMVREQBP = FRSTVMVP;                  /*POINT TO FIRST VM&V RB      */
         MVC   VMVREQBP(4),FRSTVMVP                             02S0157
*DO WHILE (ERRWORD = NOERROR &         /*LOOP THRU ALL VM&V RB'S     */
*  VMVREQBP ^= ZERO);                                           02S0158
         B     @DE00158                                         02S0158
@DL00158 DS    0H                                               02S0159
*  SAVEREQP = VMVNREQP;                /*SAVE PTR TO NEXT VM&V RB    */
         L     @10,VMVREQBP                                     02S0159
         L     SAVEREQP,VMVNREQP(,@10)                          02S0159
*  IF VMVVRLBL = ON &                  /*THIS REQUEST FOR NONSPEC DA?*/
*     VMVPROCD = OFF THEN              /*AND NOT ALREADY PROCESSED   */
         TM    VMVVRLBL(@10),B'00000010'                        02S0160
         BNO   @RF00160                                         02S0160
         TM    VMVPROCD(@10),B'10000000'                        02S0160
         BNZ   @RF00160                                         02S0160
*    DO;                                                        02S0161
*/********************************************************************/
*/*                                                                  */
*/*  SEGMENT NAME - NSPDAVOL                                         */
*/*                                                                  */
*/*  DESCRIPTIVE NAME - PROCESS NON-SPECIFIC DA VOLUMES MOUNTED      */
*/*                                                                  */
*/*  FUNCTION - FOR EACH NON-SPECIFIC DIRECT ACCESS VOLUME MOUNTED   */
*/*             BY VM&V THIS ROUTINE WILL ATTEMPT TO ENQUEUE ON THE  */
*/*             VOLUME SERIAL. IF SUCCESSFUL IT WILL PLACE THE VOLSER*/
*/*             IN THE JFCB OF EACH REQUEST WHICH REQUIRES           */
*/*             THIS VOLUME. SPACE FOR NEW DATA SETS IS THEN OBTAINED*/
*/*             IF INSUFFICIENT SPACE IS AVAILABLE ON THE VOLUME TO  */
*/*             CONTAIN ALL OF THE DATA SETS, ANY DATA SETS ALREADY  */
*/*             GOTTEN ARE SCRATCHED, AND THE VOLUME SERIAL IS DEQ'D */
*/*             IF THE VOLUME ENQ FAILED OR DADSM FAILED A NEW       */
*/*             VM&V REQUEST BLOCK IS CREATED. A CALL TO VOLUME      */
*/*             MOUNT AND VERIFY IS MADE TO UNLOAD THIS VOLUME AND   */
*/*             TO MOUNT AND VERIFY A NEW ONE. THIS VOLUME IS THEN   */
*/*             PROCESSED. THE REQUEST BLOCKS FOR THE NON-SPECIFIC   */
*/*             VOLUMES PROCESSED ARE FREED.                         */
*/*                                                                  */
*/*  ENTRY - INLINE SEGMENT OF IEFAB492                              */
*/*                                                                  */
*/*    PURPOSE - SEE FUNCTION.                                       */
*/*                                                                  */
*/*    INPUT -                                                       */
*/*                                                                  */
*/*       FRSTVMVP - POINTER TO FIRST VM&V REQUEST BLOCK             */
*/*       QMPARMP - POINTER TO ALLOC QMGR PARM BLOCK                 */
*/*                                                                  */
*/* EXIT -                                                           */
*/*                                                                  */
*/*    CONDITION - ALL NON-SPECIFIC DIRECT ACCESS VOLUMES PROCESSED  */
*/*                                                                  */
*/*      OUTPUT -                                                    */
*/*                                                                  */
*/*         SIODADSM - IN SIOT, ON IF DADSM SUCCESSFUL               */
*/*         SPACE OBTAINED ON VOLUMES FOR NEW DATA SETS              */
*/*         NEW VM&V REQUEST LIST WITH ALL REQUEST BLOCKS FOR NON-   */
*/*         SPECIFIC DIRECT ACCESS VOLUMES ELIMINATED.               */
*/*                                                                  */
*/*      RETURN CODE -                                               */
*/*                                                                  */
*/*          ERRWORD - ZERO,INDICATING NO ERRORS                     */
*/*                                                                  */
*/*    CONDITION - VM&V FAILS TO MOUNT ANOTHER VOLUME.               */
*/*                                                                  */
*/*      OUTPUT -                                                    */
*/*        SAME AS ABOVE FOR ANY VM&V REQUEST BLOCKS ALLREADY        */
*/*        PROCESSED.                                                */
*/*                                                                  */
*/*      RETURN CODE -                                               */
*/*                                                                  */
*/*        ERRWORD -20,TO INDICATE VM&V FAILURE                      */
*/*                                                                  */
*/*    CONDITION - MOUNT FAILED FOR VIRTUAL VOLUME           @Y30LPPE*/
*/*                                                          @Y30LPPE*/
*/*    OUTPUT -                                              @Y30LPPE*/
*/*      STRSNCDE- CONTAINS A REASONCODE INDICATING NATURE OF@Y30LPPE*/
*/*                FAILURE. THIS REASONCODE IS DETERMINED BY @Y30LPPE*/
*/*                THE REASONCODE RETURNED FROM VM&V.        @Y30LPPE*/
*/*      *************************************************** @Y30LPPE*/
*/*      *VM&V       *  FAILURE                 * STRSNCDE * @Y30LPPE*/
*/*      *REASONCODE *                          *          * @Y30LPPE*/
*/*      *************************************************** @Y30LPPE*/
*/*      *    8      *VIRT VOL NOT AVAILABLE    *     3    * @Y30LPPE*/
*/*      *    24     *UNABLE TO MOUNT VIRT VOL  *     10   * @Y30LPPE*/
*/*      *    28     *VIRT VOL NOT ACCESSIBLE   *     23   * @Y30LPPE*/
*/*      *************************************************** @Y30LPPE*/
*/*                                                          @Y30LPPE*/
*/*    RETURN CODE - 4 IN GPR 15                             @Y30LPPE*/
*/*                                                                  */
*/********************************************************************/
*ENQERROR = OFF;                       /*INIT ERROR SWITCH           */
         NI    ENQERROR,B'01111111'                             03S0162
*IF VMVDUPVL = OFF THEN                /*IF NOT DUPLICATE DO VOL ENQ */
         TM    VMVDUPVL(@10),B'10000000'                        03S0163
         BNZ   @RF00163                                         03S0163
*  DO;                                                          03S0164
*    VOLUMENQ = ON;                    /*SIGNIFY ENQ REQUESTED       */
         OI    VOLUMENQ,B'10000000'                             03S0165
*    IF VMVVUNTP -> VOLNSHR = ON THEN  /*EXCLUSIVE ENQ               */
         L     @10,VMVVUNTP(,@10)                               03S0166
         TM    VOLNSHR(@10),B'00001000'                         03S0166
         BNO   @RF00166                                         03S0166
*      VOLEXCLU = ON;                  /*REQUEST EXCLUSIVE ENQ       */
         OI    VOLEXCLU,B'00100000'                             03S0167
*    ELSE;                                                      03S0168
@RF00166 DS    0H                                               03S0169
*    UCBPTR = VMVUCBP;                 /*SET PTR TO UCB              */
         L     @10,VMVREQBP                                     03S0169
         SLR   UCBPTR,UCBPTR                                    03S0169
         ICM   UCBPTR,7,VMVUCBP(@10)                            03S0169
*    VOLSERP = ADDR(UCBVOLI);          /*POINT TO VOLUME SERIAL      */
         LA    @10,UCBVOLI(,UCBPTR)                             03S0170
         ST    @10,VOLSERP                                      03S0170
*    TCBP = JSCBPTR -> JSCBTCBP;       /*POINT TO TCB                */
         L     @10,@PC00001+24                                  03S0171
         L     @10,JSCBPTR(,@10)                                03S0171
         MVC   TCBP(4),JSCBTCBP(@10)                            03S0171
*    ERRWORD = NOERROR;                /*SET ZERO RETURN CODE@YM05583*/
         SLR   ERRWORD,ERRWORD                                  03S0172
*    IF UCBPRES = OFF THEN             /*FIXED DEVICE?       @YM05583*/
         TM    UCBPRES(UCBPTR),B'00000100'                      03S0173
         BNZ   @RF00173                                         03S0173
*      DO;                             /*NO, DO ENQ          @YM05583*/
*        CALL IEFAB4F0(FNMAP,VOLSERP,TCBP,VUTABPTR,VUTABLTH); /*ENQ
*                                        THE VOLUME SERIAL           */
         LA    @10,FNMAP                                        03S0175
         ST    @10,@AL00001                                     03S0175
         LA    @10,VOLSERP                                      03S0175
         ST    @10,@AL00001+4                                   03S0175
         LA    @10,TCBP                                         03S0175
         ST    @10,@AL00001+8                                   03S0175
         L     @10,@PC00001+8                                   03S0175
         ST    @10,@AL00001+12                                  03S0175
         L     @10,@PC00001+12                                  03S0175
         ST    @10,@AL00001+16                                  03S0175
         L     @15,@CV01149                                     03S0175
         LA    @01,@AL00001                                     03S0175
         BALR  @14,@15                                          03S0175
*        ERRWORD = REG15;              /*SAVE RETURN CODE            */
         LR    ERRWORD,REG15                                    03S0176
*      END;                            /*                    @YM05583*/
*    ELSE;                             /*FIXED DEV, DONT ENQ @YM05583*/
@RF00173 DS    0H                                               03S0179
*    IF ERRWORD ^=NOERROR THEN         /*WAS THERE AN ENQ ERROR ?    */
         LTR   ERRWORD,ERRWORD                                  03S0179
         BZ    @RF00179                                         03S0179
*      ENQERROR = ON;                  /*SET BIT TO INDICATE         */
         OI    ENQERROR,B'10000000'                             03S0180
*    ELSE;                                                      03S0181
@RF00179 DS    0H                                               03S0182
*    VOLUMENQ = OFF;                   /*CLEAR ENQ INDICATOR         */
*    VOLEXCLU = OFF;                   /*CLEAR EXCLUSIVE REQ INDIC.  */
         NI    VOLUMENQ,B'01011111'                             03S0183
*  END;                                                         03S0184
*ELSE;                                                          03S0185
@RF00163 DS    0H                                               03S0186
*IF ERRWORD = NOERROR THEN             /*ANY ERRORS ?                */
         LTR   ERRWORD,ERRWORD                                  03S0186
         BNZ   @RF00186                                         03S0186
*  DO;                                                          03S0187
*    SIOTPTR= VMVVUNTP->VOLSIOTP;      /*GET SIOT PTR                */
         L     @10,VMVREQBP                                     03S0188
         L     @09,VMVVUNTP(,@10)                               03S0188
         L     SIOTPTR,VOLSIOTP(,@09)                           03S0188
*    UCBPTR = VMVUCBP;                 /*POINT TO UCB        @YM02425*/
         SLR   UCBPTR,UCBPTR                                    03S0189
         ICM   UCBPTR,7,VMVUCBP(@10)                            03S0189
*    IF VMVVUNTP = SVOLUNAD            /*1ST VU FOR SIOT     @YM02425*/
*      & VMVVUNTP->VUDADSM = OFF THEN  /*DADSM REQ'D?        @YM02425*/
         C     @09,SVOLUNAD(,SIOTPTR)                           03S0190
         BNE   @RF00190                                         03S0190
         TM    VUDADSM(@09),B'00000010'                         03S0190
         BNZ   @RF00190                                         03S0190
*      DO;                             /*NO,FILL IN VOLSER   @YM02425*/
*        SJFCBPTR->JFCBVOLS(1:6)=UCBVOLI; /*PUT VOLSER N JFCB@YM05014*/
         L     @10,SJFCBPTR(,SIOTPTR)                           03S0192
         MVC   JFCBVOLS(6,@10),UCBVOLI(UCBPTR)                  03S0192
*        IF SJFCBPTR->JFCBNVOL = ZERO THEN /*IF NON SPECIFIC @YM02425*/
         CLI   JFCBNVOL(@10),0                                  03S0193
         BNE   @RF00193                                         03S0193
*          SJFCBPTR->JFCBNVOL=ONE;     /*SET # OF VOLS       @YM05014*/
         MVI   JFCBNVOL(@10),X'01'                              03S0194
*    END;                              /*                    @YM02425*/
@RF00193 DS    0H                                               03S0196
*    IF VMVVUNTP -> VUDADSM = ON &     /*DADSM REQUIRED?             */
*       SJFCBPTR -> JFCORGIS ^= ON THEN /*AND NOT ISAM?              */
@RF00190 L     @10,VMVREQBP                                     03S0196
         L     @10,VMVVUNTP(,@10)                               03S0196
         TM    VUDADSM(@10),B'00000010'                         03S0196
         BNO   @RF00196                                         03S0196
         L     @10,SJFCBPTR(,SIOTPTR)                           03S0196
         TM    JFCORGIS(@10),B'10000000'                        03S0196
         BO    @RF00196                                         03S0196
*      DO;                                                      03S0197
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - DADSMINT                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - DADSM INTERFACE ROUTINE.                      */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE INTERFACES WITH DIRECT ACCESS DEVICE SPACE        */
*/*   MANAGEMENT (DADSM) TO ACQUIRE SPACE ON A DIRECT ACCESS VOLUME  */
*/*   FOR NEW DATA SETS. DADSM REQUIRES THE FOLLOWING INPUT:         */
*/*       .REG0 - POINTER TO JFCB FOR THE DATA SET.                  */
*/*       .REG1 - POINTER TO A FULL WORD CONTAINING THE ADDRESS OF   */
*/*               THE UCB ON WHICH THE VOLUME IS MOUNTED.            */
*/*       .THE SERIAL NUMBER OF THE VOLUME MUST BE IN THE JFCB.      */
*/*                                                                  */
*/* ENTRY - INLINE SEGMENT OF IEFAB492.                              */
*/*   PURPOSE  - SEE FUNCTION.                                       */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*     SIOTPTR - POINTER TO SIOT OF REQUEST, SIOT CONTAINS THE      */
*/*               POINTER TO THE JFCB.                               */
*/*     UCBPTR - POINTER TO UCB ALLOCATED TO REQUEST.                */
*/*                                                                  */
*/* EXITS -                                                          */
*/*   CONDITION - SPACE OBTAINED ON VOLUME.                          */
*/*                                                                  */
*/*     OUTPUT - NONE.                                               */
*/*       UPDATED JFCB                                               */
*/*                                                                  */
*/*     RETURN CODE -                                                */
*/*       REG15  - 0, TO INDICATE SPACE GOTTEN.                      */
*/*                                                                  */
*/*   CONDITION - UNABLE TO OBTAIN SPACE ON VOLUME SPECIFIED.        */
*/*                                                                  */
*/*     OUTPUT - NONE.                                               */
*/*                                                                  */
*/*     RETURN CODE -                                                */
*/*       ERRWORD  - RETURN CODE FROM DADSM TO INDICATE SPACE        */
*/*                  FAILURE.                                        */
*/*                                                                  */
*/*                                                                  */
*/********************************************************************/
*JFCBPTR = SJFCBPTR;                   /* GET JFCB POINTER FROM SIOT */
         LR    JFCBPTR,@10                                      04S0198
*JFCBVOLS(1:6) = UCBVOLI;              /* PUT VOLSER INTO JFCB       */
         MVC   JFCBVOLS(6,JFCBPTR),UCBVOLI(UCBPTR)              04S0199
*IF JFCBNVOL = ZERO THEN               /* IF NON-SPECIFIC REQUEST    */
         CLI   JFCBNVOL(JFCBPTR),0                              04S0200
         BNE   @RF00200                                         04S0200
*  JFCBNVOL = ONE;                     /* SET NUMBER OF VOLUMES      */
         MVI   JFCBNVOL(JFCBPTR),X'01'                          04S0201
*DADSPARM = UCBPTR;                    /* STORE POINTER TO UCB FOR
*                                         DADSM.                     */
@RF00200 ST    UCBPTR,DADSPARM                                  04S0202
*REG0 = JFCBPTR;                                                04S0203
         LR    REG0,JFCBPTR                                     04S0203
*REG1 = ADDR(DADSPARM);                                         04S0204
         LA    REG1,DADSPARM                                    04S0204
*GEN(SVC 32);                          /* INVOKE DADSM TO GET SPACE  */
         SVC 32
*ERRWORD = REG15;                      /*SAVE RETURN CODE            */
         LR    ERRWORD,REG15                                    04S0206
*        IF ERRWORD ^= NOERROR THEN    /*ANY DADSM ERRORS ?          */
         LTR   ERRWORD,ERRWORD                                  03S0207
         BZ    @RF00207                                         03S0207
*          DO;                                                  03S0208
*/********************************************************************/
*/*                                                                  */
*/*  SEGMENT NAME - DADSERR3                                         */
*/*                                                                  */
*/*  DESCRIPTIVE NAME - NON-SPECIFIC DA VOLUME DADSM ERROR RTN       */
*/*                                                                  */
*/*  FUNCTION - CLEANUP AFTER DADSM ERRORS ON A VOLUME MOUNTED TO    */
*/*    SATISFY A NON-SPECIFIC VOLUME REQUEST. SCRATCH ALL DATA       */
*/*    SETS JUST ALLOCATED TO THIS VOLUME.                           */
*/*                                                                  */
*/*                                                                  */
*/*  ENTRY - INLINE SEGMENT OF IEFAB492.                             */
*/*                                                                  */
*/*    PURPOSE - SEE FUNCTION                                        */
*/*                                                                  */
*/*    INPUT -                                                       */
*/*      FRSTVMVP -  POINTER TO FIRST VM&V REQUEST BLOCK.            */
*/*      VMVREQBP -  POINTER TO VM&V RB WHICH REQUESTED THE MOUNT    */
*/*                    OF THE VOLUME ON WHICH THE FAILURE OCCURED.   */
*/*                                                                  */
*/*  EXIT -                                                          */
*/*                                                                  */
*/*    CONDITION - ALL DATA JUST GOTTEN ON THIS VOLUME SCRATCHED     */
*/*                                                                  */
*/*      OUTPUT -                                                    */
*/*        DATA SETS JUST GOTTEN REMOVED FROM VOLUME.                */
*/*                                                                  */
*/*      RETURN CODE                                                 */
*/*        ERRWORD - 12, TO INDICATE A RECOVERABLE DADSM ERROR       */
*/*                                                                  */
*/*    CONDITION - NON-RECOVERABLE DADSM ERROR                       */
*/*                                                                  */
*/*      OUTPUT -                                                    */
*/*        DATA SETS JUST GOTTEN REMOVED FROM VOLUME.                */
*/*        SIOTRSNC - IN SIOT,REASON CODE GIVING CAUSE OF FAILURE    */
*/*                                                                  */
*/*      RETURN CODE -                                               */
*/*        ERRWORD - 16, TO INDICATE ERROR RECOVERY NOT POSSIBLE     */
*/*                                                                  */
*/*    CONDITION - ERROR DURING SCRATCH PROCESSING                   */
*/*                                                                  */
*/*      OUTPUT -                                                    */
*/*        DATA SETS JUST GOTTEN REMOVED FROM VOLUME IF POSSIBLE     */
*/*        SIOTRSNC - 55, TO INDICATE SCRATCH ERROR                  */
*/*                                                                  */
*/*      RETURN CODE -                                               */
*/*        ERRWORD - 16, TO INDICATE ERROR RECOVERY NOT POSSIBLE     */
*/*                                                                  */
*/********************************************************************/
*AVMVRBP = FRSTVMVP;                   /*POINT TO FIRST VM&V REQ BLK */
         L     AVMVRBP,FRSTVMVP                                 04S0209
*SCRERRSW = OFF;                       /*SET ERROR SWITCH OFF        */
         NI    SCRERRSW,B'01111111'                             04S0210
*DO WHILE AVMVRBP^= ZERO;              /*LOOP THRU ALL REQUEST BLOCKS*/
         B     @DE00211                                         04S0211
@DL00211 DS    0H                                               04S0212
*  IF VMVVUNTP -> VOLID = AVMVRBP -> VMVVUNTP-> VOLID & /*VOLID MATCH*/
*    AVMVRBP-> VMVVUNTP-> VOLSIOTP-> SIODADSM =ON THEN /*AND DADSM
*                                                        SUCCESSFUL ?*/
         L     @10,VMVREQBP                                     04S0212
         L     @10,VMVVUNTP(,@10)                               04S0212
         L     @09,VMVVUNTP(,AVMVRBP)                           04S0212
         CLC   VOLID(6,@10),VOLID(@09)                          04S0212
         BNE   @RF00212                                         04S0212
         L     @10,VOLSIOTP(,@09)                               04S0212
         TM    SIODADSM(@10),B'00000100'                        04S0212
         BNO   @RF00212                                         04S0212
*      DO;                                                      04S0213
*        DISPRB = DISPRB && DISPRB;    /*CLEAR REQUEST BLOCK FOR
*                                        DELETE PROCESSING           */
         XC    DISPRB(16),DISPRB                                04S0214
*        FMAP = FMAP && FMAP;          /* CLEAR UNALOC FNC MAP       */
         XC    FMAP(4),FMAP                                     04S0215
*        CFMAPTR = ADDR(FMAP);         /* POINT TO UNALOC FMAP       */
         LA    CFMAPTR,FMAP                                     04S0216
*        CMDISPRC = ON;                /* DO DISP PROCESSING         */
         OI    CMDISPRC(CFMAPTR),B'00100000'                    04S0217
*        CMNOPOST = ON;                /* BYPASS QMNGR POST          */
*        CMNOVUT = ON;                 /* NO VUT PROCESSING          */
*        CMPURGE = ON;                 /*REQUEST PURGE OPTION        */
         OI    CMNOPOST(CFMAPTR),B'11000010'                    04S0220
*        IF NOTIOTNQ = ON THEN         /*HAS TIOT BEEN ENQ'ED ON?    */
         L     @10,@PC00001+32                                  04S0221
         L     @10,FMAPPTR(,@10)                                04S0221
         TM    NOTIOTNQ(@10),B'00010000'                        04S0221
         BNO   @RF00221                                         04S0221
*          CMTIOTNQ = ON;              /*YES, INDICATE               */
         OI    CMTIOTNQ(CFMAPTR),B'00000001'                    04S0222
*        CMNOSMF = ON;                 /*NO SMF RECORD               */
@RF00221 OI    CMNOSMF(CFMAPTR),B'01000000'                     04S0223
*        CMRBPTR=ADDR(DISPRB);         /*POINT TO UNALLOC RB         */
         LA    @10,DISPRB                                       04S0224
         ST    @10,CMRBPTR                                      04S0224
*        CMSIOPTR = AVMVRBP-> VMVVUNTP-> VOLSIOTP; /*SET PTR TO SIOT */
         L     @09,VMVVUNTP(,AVMVRBP)                           04S0225
         MVC   CMSIOPTR(4,@10),VOLSIOTP(@09)                    04S0225
*        CMORDISP = ON;                /*SET SWITCH TO OVERRIDE DISP */
         OI    CMORDISP(@10),B'00010000'                        04S0226
*        CMODEL = ON;                  /*REQUEST DELETE PROCESSING   */
         OI    CMODEL(@10),B'00000100'                          04S0227
*        CALL IEFAB4A0(FMAP,CMRBPTR,JSCBPTR,ZERO,ZERO,ZERO,ZERO,
*            URCODES,0);               /*DELETE DATA SET     @ZD03010*/
         MVC   @AL00001+12(24),@AL00228                         04S0228
         LA    @10,FMAP                                         04S0228
         ST    @10,@AL00001                                     04S0228
         LA    @10,CMRBPTR                                      04S0228
         ST    @10,@AL00001+4                                   04S0228
         L     @10,@PC00001+24                                  04S0228
         ST    @10,@AL00001+8                                   04S0228
         LA    @10,URCODES                                      04S0228
         ST    @10,@AL00001+28                                  04S0228
         L     @15,@CV01146                                     04S0228
         LA    @01,@AL00001                                     04S0228
         BALR  @14,@15                                          04S0228
*        IF CMRETCDE^= ZERO | REG15 ^= ZERO THEN                04S0229
         SLR   @14,@14                                          04S0229
         L     @10,CMRBPTR                                      04S0229
         CH    @14,CMRETCDE(,@10)                               04S0229
         BNE   @RT00229                                         04S0229
         CR    REG15,@14                                        04S0229
         BE    @RF00229                                         04S0229
@RT00229 DS    0H                                               04S0230
*          DO;                         /*PUT CODE IN SIOT AND        */
*            AVMVRBP -> VMVVUNTP -> VOLSIOTP -> SIOTRSNC = SCRTCHER;
         L     @10,VMVVUNTP(,AVMVRBP)                           04S0231
         L     @10,VOLSIOTP(,@10)                               04S0231
         MVC   SIOTRSNC(2,@10),@CH00318                         04S0231
*            AVMVRBP -> VMVVUNTP -> VOLSIOTP -> SIOTALCD=OFF;   04S0232
         NI    SIOTALCD(@10),B'11111101'                        04S0232
*            SCRERRSW = ON;            /*INDICATE SCRATCH ERROR      */
         OI    SCRERRSW,B'10000000'                             04S0233
*          END;                                                 04S0234
*        ELSE                                                   04S0235
*          DO;                                                  04S0235
         B     @RC00229                                         04S0235
@RF00229 DS    0H                                               04S0236
*            AVMVRBP->VMVVUNTP->VOLSIOTP->SIODADSM=OFF; /*CLEAR DADSM
*                                        SUCCESSFUL INDICATOR        */
         L     @10,VMVVUNTP(,AVMVRBP)                           04S0236
         L     @10,VOLSIOTP(,@10)                               04S0236
         NI    SIODADSM(@10),B'11111011'                        04S0236
*            AVMVRBP->VMVPROCD=OFF;    /*SHOW VMVRB NOT PROCESSED    */
         NI    VMVPROCD(AVMVRBP),B'01111111'                    04S0237
*          END;                                                 04S0238
*          AVMVRBP -> VMVVUNTP -> VOLSIOTP -> SIOTDSPD = OFF;   04S0239
@RC00229 L     @10,VMVVUNTP(,AVMVRBP)                           04S0239
         L     @10,VOLSIOTP(,@10)                               04S0239
         NI    SIOTDSPD(@10),B'10111111'                        04S0239
*      END;                                                     04S0240
*  ELSE;                               /*SCRATCH NOT REQUIRED        */
@RF00212 DS    0H                                               04S0242
*  AVMVRBP = AVMVRBP -> VMVNREQP;      /*POINT TO NEXT VM&V RB       */
         L     AVMVRBP,VMVNREQP(,AVMVRBP)                       04S0242
*END;                                                           04S0243
@DE00211 LTR   AVMVRBP,AVMVRBP                                  04S0243
         BNZ   @DL00211                                         04S0243
*INDEX = ERRWORD/FOUR;                 /*CALC INDEX IN ERROR ARRAY   */
         LR    @00,ERRWORD                                      04S0244
         SRDA  @00,32                                           04S0244
         D     @00,@CF00096                                     04S0244
         LR    INDEX,@01                                        04S0244
*VMVVUNTP -> VOLSIOTP -> SIOTRSNC = ERORCODE(INDEX); /*YES,SHOW CAUSE
*                                        OF FAILURE                  */
         L     @10,VMVREQBP                                     04S0245
         L     @10,VMVVUNTP(,@10)                               04S0245
         L     @10,VOLSIOTP(,@10)                               04S0245
         LR    @09,INDEX                                        04S0245
         ALR   @09,@09                                          04S0245
         LH    @09,ERORCODE-2(@09)                              04S0245
         STH   @09,SIOTRSNC(,@10)                               04S0245
*VMVVUNTP -> VOLSIOTP -> SIOTALCD = OFF; /*SHOW ALLOC NOT SUCCESSFUL */
         NI    SIOTALCD(@10),B'11111101'                        04S0246
*IF ERORCODE(INDEX) = NORECOV1  |      /*INVALID JFCB ERROR          */
*   ERORCODE(INDEX) = NORECOV2  |      /*INVALID USER LABEL          */
*   ERORCODE(INDEX) = NORECOV3  |      /*NO SPACE PARM               */
*   ERORCODE(INDEX) = NORECOV4 |       /*TOO LARGE DIRECTORY SPACE   */
*   ERORCODE(INDEX) = NORECOV5 |       /*NOT AUTHORIZED      @ZA16820*/
*   (ERORCODE(INDEX) = NORECOV6 &      /*DATA SET ALREADY DEF@ZA16820*/
*    RCVTVERS = ZERO) |                /*AND THIS IS RACF 1  @ZA16820*/
*   (ERORCODE(INDEX) = NORECOV6 &      /*DS ALREADY DEFINED  @ZA16820*/
*    RCVTVERS ^= ZERO &                /*IS RACF 2 SYSTEM    @ZA16820*/
*    RCVTNDUP = ON) |                  /*BUT INSTALLATION DOES NOT
*                                        ALLOW DUP NAMES DEFINED
*                                        TO RACF             @ZA16820*/
*   UCBPRES = ON THEN                  /*OR FIXED DEVICE             */
         CH    @09,@CH00301                                     04S0247
         BE    @RT00247                                         04S0247
         CH    @09,@CH00133                                     04S0247
         BE    @RT00247                                         04S0247
         CH    @09,@CH00304                                     04S0247
         BE    @RT00247                                         04S0247
         CH    @09,@CH00306                                     04S0247
         BE    @RT00247                                         04S0247
         CH    @09,@CH00308                                     04S0247
         BE    @RT00247                                         04S0247
         CH    @09,@CH00098                                     04S0247
         BNE   @GL00010                                         04S0247
         L     @10,CVTPTR                                       04S0247
         L     @10,CVTRAC(,@10)                                 04S0247
         CLI   RCVTVERS(@10),0                                  04S0247
         BE    @RT00247                                         04S0247
@GL00010 LR    @10,INDEX                                        04S0247
         ALR   @10,@10                                          04S0247
         LH    @10,ERORCODE-2(@10)                              04S0247
         CH    @10,@CH00098                                     04S0247
         BNE   @GL00009                                         04S0247
         L     @10,CVTPTR                                       04S0247
         L     @10,CVTRAC(,@10)                                 04S0247
         CLI   RCVTVERS(@10),0                                  04S0247
         BE    @GL00009                                         04S0247
         TM    RCVTNDUP(@10),B'00010000'                        04S0247
         BO    @RT00247                                         04S0247
@GL00009 TM    UCBPRES(UCBPTR),B'00000100'                      04S0247
         BNO   @RF00247                                         04S0247
@RT00247 DS    0H                                               04S0248
*     ERRWORD = NORECOVR;              /*FAIL TASK                   */
         LA    ERRWORD,16                                       04S0248
*ELSE                                                           04S0249
*  ERRWORD = RECOVER;                  /*ERROR RECOVERABLE           */
         B     @RC00247                                         04S0249
@RF00247 LA    ERRWORD,12                                       04S0249
*IF SCRERRSW = ON THEN                 /*IF SCRATCH ERROR            */
@RC00247 TM    SCRERRSW,B'10000000'                             04S0250
         BNO   @RF00250                                         04S0250
*  ERRWORD = NORECOVR;                 /*SET NONRECOVERABLE INDICATOR*/
         LA    ERRWORD,16                                       04S0251
*ELSE;                                                          04S0252
@RF00250 DS    0H                                               04S0253
*            VOLUMDEQ = ON;            /*SET TO DEQ VOLUME           */
         OI    VOLUMDEQ,B'01000000'                             03S0253
*            VOLSERP = ADDR(UCBVOLI);  /*VOLSER POINTER              */
         LA    @10,UCBVOLI(,UCBPTR)                             03S0254
         ST    @10,VOLSERP                                      03S0254
*            TCBP = JSCBPTR ->JSCBTCBP; /*POINT TO TCB               */
         L     @10,@PC00001+24                                  03S0255
         L     @10,JSCBPTR(,@10)                                03S0255
         MVC   TCBP(4),JSCBTCBP(@10)                            03S0255
*            IF UCBPRES=OFF THEN       /*FIXED DEVICE?       @YM05583*/
         TM    UCBPRES(UCBPTR),B'00000100'                      03S0256
         BNZ   @RF00256                                         03S0256
*              CALL IEFAB4F0(FNMAP,VOLSERP,TCBP,VUTABPTR,VUTABLTH);/*
*                                        NO, DEQ THIS VOLUME @YM05583*/
         LA    @10,FNMAP                                        03S0257
         ST    @10,@AL00001                                     03S0257
         LA    @10,VOLSERP                                      03S0257
         ST    @10,@AL00001+4                                   03S0257
         LA    @10,TCBP                                         03S0257
         ST    @10,@AL00001+8                                   03S0257
         L     @10,@PC00001+8                                   03S0257
         ST    @10,@AL00001+12                                  03S0257
         L     @10,@PC00001+12                                  03S0257
         ST    @10,@AL00001+16                                  03S0257
         L     @15,@CV01149                                     03S0257
         LA    @01,@AL00001                                     03S0257
         BALR  @14,@15                                          03S0257
*            ELSE;                     /*FIXED DEV NO ENQ NEEDED
*                                                            @YM05583*/
@RF00256 DS    0H                                               03S0259
*            VOLUMDEQ = OFF;           /*CLEAR DEQ INDICATOR         */
         NI    VOLUMDEQ,B'10111111'                             03S0259
*          END;                                                 03S0260
*        ELSE                          /*DADSM OK                    */
*          DO;                                                  03S0261
         B     @RC00207                                         03S0261
@RF00207 DS    0H                                               03S0262
*            SIODADSM = ON;            /*SHOW DADSM SUCCESSFUL       */
         OI    SIODADSM(SIOTPTR),B'00000100'                    03S0262
*            JFCVINDX=JFCVINDX&&JFCVINDX; /*CLEAR JFCBINDX WHEN DADSM
*                                        SUCCESSFUL SO VVIC WON'T CHOSE
*                                        THIS VOLUME AGAIN   @Y30LPPE*/
         LH    @10,JFCVINDX(,JFCBPTR)                           03S0263
         LR    @09,@10                                          03S0263
         XR    @09,@10                                          03S0263
         STH   @09,JFCVINDX(,JFCBPTR)                           03S0263
*            JFCMSVGP(1:8)=BLANKS;     /*CLEAR MSVC NAME FIELD  03S0264
*                                                            @ZA08174*/
         MVC   JFCMSVGP(8,JFCBPTR),BLANKS                       03S0264
*            SIOTALCD = ON;            /*SHOW ALLOC SUCCESSFUL       */
         OI    SIOTALCD(SIOTPTR),B'00000010'                    03S0265
*          END;                                                 03S0266
*      END;                                                     03S0267
*    ELSE;                                                      03S0268
@RF00196 DS    0H                                               03S0269
*  END;                                /*INDICATE REQUEST PROCESSED  */
*ELSE;                                                          03S0270
@RF00186 DS    0H                                               03S0271
*IF ENQERROR = OFF & ERRWORD=NOERROR THEN                       03S0271
@RC00186 TM    ENQERROR,B'10000000'                             03S0271
         BNZ   @RF00271                                         03S0271
         LTR   ERRWORD,ERRWORD                                  03S0271
         BNZ   @RF00271                                         03S0271
*  VMVPROCD = ON;                                               03S0272
         L     @10,VMVREQBP                                     03S0272
         OI    VMVPROCD(@10),B'10000000'                        03S0272
*IF ENQERROR = ON |                    /*ANY ENQ ERRORS ?            */
*  (ERRWORD^=NOERROR &                 /*SOME ERROR HAS OCCURED      */
*  ERRWORD ^= NORECOVR) THEN           /*OR IS DADSM ERR RECOVERABLE */
@RF00271 TM    ENQERROR,B'10000000'                             03S0273
         BO    @RT00273                                         03S0273
         LTR   ERRWORD,ERRWORD                                  03S0273
         BZ    @RF00273                                         03S0273
         CH    ERRWORD,@CH00098                                 03S0273
         BE    @RF00273                                         03S0273
@RT00273 DS    0H                                               03S0274
*  DO;                                 /*YES                         */
*/********************************************************************/
*/*                                                                  */
*/*  SEGMENT NAME - VMVRQBLD                                         */
*/*                                                                  */
*/*  DESCRIPTIVE NAME - VM&V REQUEST BLOCK BUILD ROUTINE             */
*/*                                                                  */
*/*  FUNCTION - THIS ROUTINE FILLS IN AN EXISTING VM&V REQUEST BLOCK */
*/*             TO CAUSE VM&V TO UNLOAD A VOLUME AND TO MOUNT AND    */
*/*             VERIFY A NEW VOLUME.                                 */
*/*                                                                  */
*/*    OPERATION - THE FUNCTION MAP IN THE VM&V REQUEST BLOCK IS     */
*/*             SET TO REQUEST THE FOLLOWING                         */
*/*             FUNCTIONS:                                           */
*/*               1.  UNLOAD VOLUME                                  */
*/*               2.  MOUNT ANOTHER VOLUME                           */
*/*               3.  ISSUE MOUNT MESSAGE                            */
*/*             THE MOUNT VOLSER IS SET TO BLANKS THE RETURN CODE    */
*/*             FIELD IS SET TO ZERO. MESSAGE INFORMATION IS FILLED  */
*/*             IN REQUESTING AN IMMEDIATE DISMOUNT MESSAGE.         */
*/*                                                                  */
*/*  ENTRY - INLINE SEGMENT OF IEFAB492.                             */
*/*                                                                  */
*/*    PURPOSE - SEE FUNCTION.                                       */
*/*                                                                  */
*/*    INPUT -                                                       */
*/*                                                                  */
*/*       VMVREQBP - POINTER TO A VM&V REQUEST BLOCK                 */
*/*                                                                  */
*/*                                                                  */
*/*  EXIT -                                                          */
*/*                                                                  */
*/*    CONDITION - REQUEST BLOCK SUCCESSFULLY FILLED IN              */
*/*                                                                  */
*/*      OUTPUT -                                                    */
*/*                                                                  */
*/*          VM&V REQUEST BLOCK FILLED IN REQUESTING UNLOAD,MOUNT    */
*/*          AND VERIFY FUNCTIONS OF VM&V.                           */
*/*                                                                  */
*/*      RETURN CODE -                                               */
*/*          NONE                                                    */
*/*                                                                  */
*/*                                                                  */
*/********************************************************************/
*VMVCUVOL = ON;                        /*CLEAR VOLSER IN UCB         */
         L     @10,VMVREQBP                                     04S0275
         OI    VMVCUVOL(@10),B'01000000'                        04S0275
*VMVUVLSR = UCBVOLI;                   /*PUT VOLSER IN REQUEST BLOCK */
         MVC   VMVUVLSR(6,@10),UCBVOLI(UCBPTR)                  04S0276
*VMVUNLOD = ON;                        /*INDICATE UNLOAD REQUIRED    */
*VMVMOUNT = ON;                        /*INDICATE MOUNT  REQUIRED    */
*VMVMTMSG = ON;                        /*ISSUE MOUNT MESSAGE         */
         OI    VMVUNLOD(@10),B'10011000'                        04S0279
*VMVRETCD = ZERO;                      /*CLEAR RETURN CODE           */
         SLR   @09,@09                                          04S0280
         ST    @09,VMVRETCD(,@10)                               04S0280
*VMVDSMT = ON;                         /*ACTION CODE IS FOR DISMOUNT */
         OI    VMVDSMT(@10),B'01000000'                         04S0281
*VMVMVLSR(1:6) = BLANKS;               /*CLEAR MOUNT VOLSER  @ZA08174*/
         MVC   VMVMVLSR(6,@10),BLANKS                           04S0282
*    VMVNREQP = ZERO;                  /*CLEAR POINTER TO NEXT RB    */
         ST    @09,VMVNREQP(,@10)                               03S0283
*    DUPSAVE = VMVOPTB3;               /*SAVE DUPLICATE REQ. STATUS  */
         MVC   DUPSAVE(1),VMVOPTB3(@10)                         03S0284
*    VMVDUPVL = OFF;                   /*INSURE MOUNT DONE           */
         NI    VMVDUPVL(@10),B'01111111'                        03S0285
*    CALL IEFAB493(VMVREQBP,ASID,CNECB); /*CALL VOL MOUNT & VERIFY   */
         LA    @10,VMVREQBP                                     03S0286
         ST    @10,@AL00001                                     03S0286
         L     @10,@PC00001+16                                  03S0286
         ST    @10,@AL00001+4                                   03S0286
         L     @10,@PC00001+4                                   03S0286
         ST    @10,@AL00001+8                                   03S0286
         L     @15,@CV01144                                     03S0286
         LA    @01,@AL00001                                     03S0286
         BALR  @14,@15                                          03S0286
*    ERRWORD = REG15;                  /*SAVE RETURN CODE            */
         LR    ERRWORD,REG15                                    03S0287
*    VMVOPTB3 = DUPSAVE;               /*RESTORE DUPLICATE STATUS    */
         L     @10,VMVREQBP                                     03S0288
         MVC   VMVOPTB3(1,@10),DUPSAVE                          03S0288
*    IF ERRWORD = OPRCANCL |           /*DID OPERATOR CANCEL?        */
*      ERRWORD = OPRSAYNO THEN         /*OR REPLY NO?                */
         CH    ERRWORD,@CH00098                                 03S0289
         BE    @RT00289                                         03S0289
         CH    ERRWORD,@CH00120                                 03S0289
         BNE   @RF00289                                         03S0289
@RT00289 DS    0H                                               03S0290
*      FAILRSCP -> STRSNCDE = STCANCEL;/*SET CANCEL REASON CODE      */
         L     @10,@PC00001+20                                  03S0290
         L     @10,FAILRSCP(,@10)                               03S0290
         MVC   STRSNCDE(2,@10),@CH00122                         03S0290
*    IF ERRWORD = GETFAIL THEN         /*WAS THERE A GETMAIN FAILURE?*/
@RF00289 CH    ERRWORD,@CH00096                                 03S0291
         BNE   @RF00291                                         03S0291
*      FAILRSCP -> STRSNCDE = GETMFAIL;/*GETMAIN FAIL REASON CODE    */
         L     @10,@PC00001+20                                  03S0292
         L     @10,FAILRSCP(,@10)                               03S0292
         MVC   STRSNCDE(2,@10),@CH00082                         03S0292
*    IF ERRWORD = NOESTAE THEN         /*ESTAE ERROR                 */
@RF00291 CH    ERRWORD,@CH00102                                 03S0293
         BNE   @RF00293                                         03S0293
*      FAILRSCP->STRSNCDE = ESTFAIL;   /*SET ESTAE ERR REASON CODE   */
         L     @10,@PC00001+20                                  03S0294
         L     @10,FAILRSCP(,@10)                               03S0294
         MVC   STRSNCDE(2,@10),@CH00098                         03S0294
*    IF ERRWORD=NOTAVAIL THEN          /*IF MSS VOLUME IS NOT AVAILABLE
*                                                            @Y30LPPE*/
@RF00293 CH    ERRWORD,@CH00094                                 03S0295
         BNE   @RF00295                                         03S0295
*      FAILRSCP->STRSNCDE=NTAVAILR;    /*SET REASON CODE TO 3@Y30LPPE*/
         L     @10,@PC00001+20                                  03S0296
         L     @10,FAILRSCP(,@10)                               03S0296
         MVC   STRSNCDE(2,@10),@CH00111                         03S0296
*    ELSE                              /*ELSE                @Y30LPPE*/
*      IF ERRWORD=UNABTOMT THEN        /*IF MSS VOLUME CANNOT BE
*                                        MOUNTED             @Y30LPPE*/
         B     @RC00295                                         03S0297
@RF00295 CH    ERRWORD,@CH00127                                 03S0297
         BNE   @RF00297                                         03S0297
*        FAILRSCP->STRSNCDE=UNABTMTR;  /*SET REASON CDE TO 10@Y30LPPE*/
         L     @10,@PC00001+20                                  03S0298
         L     @10,FAILRSCP(,@10)                               03S0298
         MVC   STRSNCDE(2,@10),@CH00129                         03S0298
*      ELSE                            /*ELSE                @Y30LPPE*/
*        IF ERRWORD=NOTACESS THEN      /*IF MSS VOLUME IS NOT ACCESS-
*                                        IBLE                @Y30LPPE*/
         B     @RC00297                                         03S0299
@RF00297 CH    ERRWORD,@CH00104                                 03S0299
         BNE   @RF00299                                         03S0299
*          FAILRSCP->STRSNCDE=NTACESSR; /*SET REASON CDE 23  @Y30LPPE*/
         L     @10,@PC00001+20                                  03S0300
         L     @10,FAILRSCP(,@10)                               03S0300
         MVC   STRSNCDE(2,@10),@CH00109                         03S0300
*    VMVNREQP = SAVEREQP;              /*SET PTR TO NEXT VM&V RB     */
@RF00299 DS    0H                                               03S0301
@RC00297 DS    0H                                               03S0301
@RC00295 L     @10,VMVREQBP                                     03S0301
         ST    SAVEREQP,VMVNREQP(,@10)                          03S0301
*    SAVEREQP = FRSTVMVP;              /*SETUP TO PROCESS FROM START */
         L     SAVEREQP,FRSTVMVP                                03S0302
*  END;                                                         03S0303
*ELSE;                                                          03S0304
@RF00273 DS    0H                                               03S0305
*    END;                                                       02S0305
*  ELSE;                               /*NOT NONSPECIFIC OR DUP      */
@RF00160 DS    0H                                               02S0307
*  VMVREQBP = SAVEREQP;                /*POINT TO NEXT VM&V RB       */
         ST    SAVEREQP,VMVREQBP                                02S0307
*END;                                                           02S0308
@DE00158 SLR   @10,@10                                          02S0308
         CR    ERRWORD,@10                                      02S0308
         BNE   @DC00158                                         02S0308
         C     @10,VMVREQBP                                     02S0308
         BNE   @DL00158                                         02S0308
@DC00158 DS    0H                                               02S0309
*IF ERRWORD = NOERROR THEN             /*ANY ERRORS                  */
         SLR   @10,@10                                          02S0309
         CR    ERRWORD,@10                                      02S0309
         BNE   @RF00309                                         02S0309
*  DO;                                                          02S0310
*    VMVREQBP = FRSTVMVP;              /*POINT TO FIRST VM&V RB      */
         MVC   VMVREQBP(4),FRSTVMVP                             02S0311
*    FRSTVMVP = ZERO;                  /*CLEAR PTR TO FIRST RB       */
         ST    @10,FRSTVMVP                                     02S0312
*    DO WHILE VMVREQBP ^= ZERO;        /*LOOP THRU ALL VMV REQ BLOCKS*/
         B     @DE00313                                         02S0313
@DL00313 DS    0H                                               02S0314
*      SAVEREQP = VMVNREQP;            /*SAVE PTR TO NEXT VM&V RB    */
         L     @10,VMVREQBP                                     02S0314
         L     SAVEREQP,VMVNREQP(,@10)                          02S0314
*      IF VMVVRLBL = ON |              /*NONSPECIFIC DA REQUEST ?    */
*        VMVMOUNT = OFF THEN           /*OR A NONMOUNT REQUEST?      */
         TM    VMVVRLBL(@10),B'00000010'                        02S0315
         BNZ   @RT00315                                         02S0315
         TM    VMVMOUNT(@10),B'00010000'                        02S0315
         BO    @RF00315                                         02S0315
@RT00315 DS    0H                                               02S0316
*        DO;                                                    02S0316
*          RFY(REG0,REG1) RSTD;                                 02S0317
*          REG0 = VMVRBLEN;            /*LENGTH TO FREE              */
         L     REG0,VMVRBLEN                                    02S0318
*          REG0 = REG0 | SUBPL230;     /* FREE FROM SUBPOOL 230.     */
         O     REG0,@CF00124                                    02S0319
*          REG1 = VMVREQBP;            /*ADDRESS OF RB TO FREE       */
         L     REG1,VMVREQBP                                    02S0320
*          GEN (FREEMAIN R,LV=(0),A=(1)); /*FREE THIS VM&V RB        */
         FREEMAIN R,LV=(0),A=(1)
*          RFY (REG0,REG1) UNRSTD;                              02S0322
*        END;                                                   02S0323
*      ELSE                            /*THIS RB NOT NONSPECIFIC DA  */
*        DO;                                                    02S0324
         B     @RC00315                                         02S0324
@RF00315 DS    0H                                               02S0325
*          IF FREQBLSW = OFF THEN      /*IS THIS FIRST RB ON CHAIN ? */
         TM    FREQBLSW,B'10000000'                             02S0325
         BNZ   @RF00325                                         02S0325
*            DO;                       /*YES                         */
*              FREQBLSW = ON;          /*SHOW FIRST ENTRY MADE       */
         OI    FREQBLSW,B'10000000'                             02S0327
*              FRSTVMVP = VMVREQBP;    /*SAVE PTR TO FIRST RB IN LIST*/
         L     @10,VMVREQBP                                     02S0328
         ST    @10,FRSTVMVP                                     02S0328
*              PREVVMVP = VMVREQBP;    /*SAVE PTR TO LAST RB ON CHAIN*/
         LR    PREVVMVP,@10                                     02S0329
*              VMVNREQP = ZERO;        /*CLEAR PTR TO NEXT RB        */
         SLR   @09,@09                                          02S0330
         ST    @09,VMVNREQP(,@10)                               02S0330
*            END;                                               02S0331
*          ELSE                        /*NOT FIRST RB ON CHAIN       */
*            DO;                                                02S0332
         B     @RC00325                                         02S0332
@RF00325 DS    0H                                               02S0333
*              PREVVMVP->VMVNREQP = VMVREQBP; /*CHAIN TO PREVIOUS RB */
         L     @10,VMVREQBP                                     02S0333
         ST    @10,VMVNREQP(,PREVVMVP)                          02S0333
*              PREVVMVP = VMVREQBP;    /*SAVE PTR TO LAST RB ON CHAIN*/
         LR    PREVVMVP,@10                                     02S0334
*              VMVNREQP = ZERO;        /*CLEAR POINTER TO NEXT RB    */
         SLR   @09,@09                                          02S0335
         ST    @09,VMVNREQP(,@10)                               02S0335
*            END;                                               02S0336
*        END;                                                   02S0337
@RC00325 DS    0H                                               02S0338
*      VMVREQBP = SAVEREQP;            /*POINT TO NEXT VM&V REQ BLOCK*/
@RC00315 ST    SAVEREQP,VMVREQBP                                02S0338
*    END;                                                       02S0339
@DE00313 ICM   @10,15,VMVREQBP                                  02S0339
         BNZ   @DL00313                                         02S0339
*  END;                                                         02S0340
*ELSE;                                                          02S0341
@RF00309 DS    0H                                               02S0342
*RFY AQMPARAM BASED(QMPARMP);                                   02S0342
*IF QMPARMP ^= ZERO THEN               /*DO QMGR PARMS EXIST @ZA10458*/
         L     @10,@PC00001+28                                  02S0343
         L     @09,QMPARMP(,@10)                                02S0343
         LTR   @09,@09                                          02S0343
         BZ    @RF00343                                         02S0343
*  DO;                                 /*YES, FREE GROUPS    @ZA10458*/
*    AQMECODE = TERMFUNC;              /*REQUEST TERMINATION FUNCTION*/
         MVC   AQMECODE(2,@09),@CH00082                         02S0345
*    CALL IEFAB4FA(QMPARMP,EXITPRMP);  /*FREE DEVICE GRPS SERIALIZED */
         ST    @10,@AL00001                                     02S0346
         L     @10,@PC00001+36                                  02S0346
         ST    @10,@AL00001+4                                   02S0346
         L     @15,@CV01147                                     02S0346
         LA    @01,@AL00001                                     02S0346
         BALR  @14,@15                                          02S0346
*  END;                                /*END FREE GROUPS     @ZA10458*/
*        IF ERRWORD = NOERROR THEN     /*IF ALL IS WELL,CONTINUE     */
@RF00343 LTR   ERRWORD,ERRWORD                                  01S0348
         BNZ   @RF00348                                         01S0348
*          DO;                         /*UPDATE VM&V REQUEST LIST    */
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - UPDCHAIN                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - UPDATE VM&V RB CHAIN.                         */
*/*                                                                  */
*/* FUNCTION - UPDATE VM&V REQUEST BLOCKS SO THAT THE CHAIN CONSISTS */
*/*   OF ONLY SPECIFIC DIRECT ACCESS REQUESTS AND WTOR TAPE MOUNTS.  */
*/*                                                                  */
*/*   OPERATION - NO SPECIAL ALGORITHMS ARE USED. THE OPERATION IS   */
*/*     DOCUMENTED BY THE CODE ITSELF.                               */
*/*                                                                  */
*/* ENTRY - INLINE SEGMENT.                                          */
*/*                                                                  */
*/*   PURPOSE - (SEE FUNCTION);                                      */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*     FRSTVMVP - POINTER TO FIRST VM&V RB.                         */
*/*                                                                  */
*/* EXIT -                                                           */
*/*   CONDITION - CHAIN UPDATED TO CONTAIN SPECIFIC DIRECT ACCESS AND*/
*/*     WTOR TAPE MOUNTS.                                            */
*/*                                                                  */
*/*     OUTPUT -                                                     */
*/*       UPDATED CHAIN OF VM&V REQUEST BLOCKS.                      */
*/*                                                                  */
*/*     RETURN CODES - NONE                                          */
*/********************************************************************/
*VMVREQBP=FRSTVMVP;                    /*POINT TO FIRST REQUEST BLOCK*/
         MVC   VMVREQBP(4),FRSTVMVP                             02S0350
*DO WHILE VMVREQBP^= ZERO;             /*LOOP THRU ALL REQUESTS      */
         B     @DE00351                                         02S0351
@DL00351 DS    0H                                               02S0352
*  SAVEREQP = VMVNREQP;                /*SAVE PTR TO NEXT RB         */
         L     @10,VMVREQBP                                     02S0352
         L     SAVEREQP,VMVNREQP(,@10)                          02S0352
*  VMVMOUNT = ON;                      /*INDICATE MOUNT FN REQUIRED  */
*  VMVMTMSG = OFF;                     /*NO MOUNT MESSAGE NEEDED     */
         OI    VMVMOUNT(@10),B'00010000'                        02S0354
         NI    VMVMTMSG(@10),B'11110111'                        02S0354
*  UCBPTR=VMVUCBP;                     /*POINT TO UCB WHERE MOUNTED  */
         SLR   UCBPTR,UCBPTR                                    02S0355
         ICM   UCBPTR,7,VMVUCBP(@10)                            02S0355
*  IF UCB3DACC = ON THEN               /*IS THIS A DIRECT ACCESS UNIT*/
         TM    UCB3DACC(UCBPTR),B'00100000'                     02S0356
         BNO   @RF00356                                         02S0356
*    DO;                                                        02S0357
*      VMVVRLBL = ON;                  /*YES, REQUEST LABEL VERIFY   */
         OI    VMVVRLBL(@10),B'00000010'                        02S0358
*      PREVVMVP = VMVREQBP;            /*SET PTR TO LAST ELE ON CHAIN*/
         LR    PREVVMVP,@10                                     02S0359
*    END;                                                       02S0360
*  ELSE                                /*NO, THEN MUST BE TAPE       */
*    DO;                                                        02S0361
         B     @RC00356                                         02S0361
@RF00356 DS    0H                                               02S0362
*      IF VMVDWTOR = ON THEN           /*WAS VERIFY DEVICE END REQ'D */
         L     @10,VMVREQBP                                     02S0362
         TM    VMVDWTOR(@10),B'00000100'                        02S0362
         BNO   @RF00362                                         02S0362
*        DO;                                                    02S0363
*          VMVVDEND = ON;              /*REQUEST DEVICE END VERIFY   */
         OI    VMVVDEND(@10),B'00000001'                        02S0364
*          PREVVMVP = VMVREQBP;        /*SET PTR TO LAST ELE ON CHAIN*/
         LR    PREVVMVP,@10                                     02S0365
*        END;                                                   02S0366
*      ELSE                                                     02S0367
*        DO;                                                    02S0367
         B     @RC00362                                         02S0367
@RF00362 DS    0H                                               02S0368
*          IF FRSTVMVP = VMVREQBP THEN /*THIS FIRST RB ?             */
         L     @10,VMVREQBP                                     02S0368
         C     @10,FRSTVMVP                                     02S0368
         BNE   @RF00368                                         02S0368
*            FRSTVMVP = VMVNREQP;      /*SET PTR TO FRST RB          */
         MVC   FRSTVMVP(4),VMVNREQP(@10)                        02S0369
*          ELSE                                                 02S0370
*            PREVVMVP->VMVNREQP = VMVNREQP; /*SET PTR TO NEXT        */
         B     @RC00368                                         02S0370
@RF00368 L     @10,VMVREQBP                                     02S0370
         MVC   VMVNREQP(4,PREVVMVP),VMVNREQP(@10)               02S0370
*          RFY (REG0,REG1) RSTD;       /*FREE THE REQUEST BLOCK      */
@RC00368 DS    0H                                               02S0372
*          REG0 = VMVRBLEN;            /*LENGTH TO FREE              */
         L     REG0,VMVRBLEN                                    02S0372
*          REG0 = REG0 | SUBPL230;     /* FREE FROM SUBPOOL 230.     */
         O     REG0,@CF00124                                    02S0373
*          REG1 = VMVREQBP;            /*ADDRESS TO FREE             */
         L     REG1,VMVREQBP                                    02S0374
*          GEN(FREEMAIN R,LV=(0),A=(1));                        02S0375
         FREEMAIN R,LV=(0),A=(1)
*          RFY (REG0,REG1) UNRSTD;                              02S0376
*        END;                                                   02S0377
*    END;                                                       02S0378
@RC00362 DS    0H                                               02S0379
*  VMVREQBP = SAVEREQP;                /*POINT TO NEXT REQ BLOCK     */
@RC00356 ST    SAVEREQP,VMVREQBP                                02S0379
*END;                                                           02S0380
@DE00351 SLR   @10,@10                                          02S0380
         C     @10,VMVREQBP                                     02S0380
         BNE   @DL00351                                         02S0380
*            IF FRSTVMVP ^= ZERO THEN  /*ANY REQUESTS LEFT ?         */
         C     @10,FRSTVMVP                                     01S0381
         BE    @RF00381                                         01S0381
*              DO;                                              01S0382
*                CALL IEFAB493(FRSTVMVP,ASID,CNECB); /*INVOKE VM&V TO
*                                        MT SPECIFIC DA OR TAPE VOLS */
         LA    @10,FRSTVMVP                                     01S0383
         ST    @10,@AL00001                                     01S0383
         L     @10,@PC00001+16                                  01S0383
         ST    @10,@AL00001+4                                   01S0383
         L     @10,@PC00001+4                                   01S0383
         ST    @10,@AL00001+8                                   01S0383
         L     @15,@CV01144                                     01S0383
         LA    @01,@AL00001                                     01S0383
         BALR  @14,@15                                          01S0383
*                ERRWORD = REG15;      /*SAVE RETURN CODE            */
         LR    ERRWORD,REG15                                    01S0384
*                VMVCALL = OFF;        /*2ND CALL COMPLETE           */
         L     @10,@PC00001+36                                  01S0385
         L     @10,EXITPRMP(,@10)                               01S0385
         NI    VMVCALL(@10),B'11111101'                         01S0385
*                IF ERRWORD=OPRCANCL | /*OPERATOR CANCEL             */
*                  ERRWORD = OPRSAYNO THEN /*OR REPLY NO?            */
         CH    ERRWORD,@CH00098                                 01S0386
         BE    @RT00386                                         01S0386
         CH    ERRWORD,@CH00120                                 01S0386
         BNE   @RF00386                                         01S0386
@RT00386 DS    0H                                               01S0387
*                  FAILRSCP->STRSNCDE=STCANCEL; /*SHOW OPERATOR CANC */
         L     @10,@PC00001+20                                  01S0387
         L     @10,FAILRSCP(,@10)                               01S0387
         MVC   STRSNCDE(2,@10),@CH00122                         01S0387
*                ELSE;                                          01S0388
@RF00386 DS    0H                                               01S0389
*                IF ERRWORD = GETFAIL THEN /*DID A GETMAIN FAIL?     */
         CH    ERRWORD,@CH00096                                 01S0389
         BNE   @RF00389                                         01S0389
*                  FAILRSCP -> STRSNCDE = GETMFAIL; /*SET GETMN CODE */
         L     @10,@PC00001+20                                  01S0390
         L     @10,FAILRSCP(,@10)                               01S0390
         MVC   STRSNCDE(2,@10),@CH00082                         01S0390
*                ELSE;                                          01S0391
@RF00389 DS    0H                                               01S0392
*                IF ERRWORD = NOESTAE THEN /*ESTAE ERROR             */
         CH    ERRWORD,@CH00102                                 01S0392
         BNE   @RF00392                                         01S0392
*                  FAILRSCP -> STRSNCDE = ESTFAIL;              01S0393
         L     @10,@PC00001+20                                  01S0393
         L     @10,FAILRSCP(,@10)                               01S0393
         MVC   STRSNCDE(2,@10),@CH00098                         01S0393
*                ELSE;                                          01S0394
@RF00392 DS    0H                                               01S0395
*                IF ERRWORD=UNABTOMT THEN /*IF UNABLE TO MNT @Y30LPPE*/
         CH    ERRWORD,@CH00127                                 01S0395
         BNE   @RF00395                                         01S0395
*                  FAILRSCP->STRSNCDE=UNABTMTR; /*MSSVOL, SET REASON
*                                                 CODE       @Y30LPPE*/
         L     @10,@PC00001+20                                  01S0396
         L     @10,FAILRSCP(,@10)                               01S0396
         MVC   STRSNCDE(2,@10),@CH00129                         01S0396
*                ELSE;                          /*           @Y30LPPE*/
@RF00395 DS    0H                                               01S0398
*                VMVREQBP = FRSTVMVP;  /*POINT TO FIRST REQUEST BLOCK*/
         MVC   VMVREQBP(4),FRSTVMVP                             01S0398
*                DO WHILE(ERRWORD = NOERROR &  /*LOOP THRU REQ BLKS  */
*                  VMVREQBP ^= ZERO);                           01S0399
         B     @DE00399                                         01S0399
@DL00399 DS    0H                                               01S0400
*                  VUPTR=VMVVUNTP;     /*GET POINTER TO VUENTRY      */
         L     @10,VMVREQBP                                     01S0400
         L     VUPTR,VMVVUNTP(,@10)                             01S0400
*                  SIOTPTR = VOLSIOTP; /*GET POINTER TO SIOT         */
         L     SIOTPTR,VOLSIOTP(,VUPTR)                         01S0401
*                  IF VUDADSM = ON &   /*IS DADSM REQUIRED           */
*                     SJFCBPTR -> JFCORGIS ^= ON THEN /*AND NOT ISAM?*/
         TM    VUDADSM(VUPTR),B'00000010'                       01S0402
         BNO   @RF00402                                         01S0402
         L     @03,SJFCBPTR(,SIOTPTR)                           01S0402
         TM    JFCORGIS(@03),B'10000000'                        01S0402
         BO    @RF00402                                         01S0402
*                    DO;               /*YES                         */
*                      UCBPTR = VMVUCBP; /*GET UCB POINTER           */
         SLR   UCBPTR,UCBPTR                                    01S0404
         ICM   UCBPTR,7,VMVUCBP(@10)                            01S0404
*                      IF UCB3DACC = ON THEN                    01S0405
         TM    UCB3DACC(UCBPTR),B'00100000'                     01S0405
         BNO   @RF00405                                         01S0405
*                        DO;                                    01S0406
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - DADSMINT                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - DADSM INTERFACE ROUTINE.                      */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE INTERFACES WITH DIRECT ACCESS DEVICE SPACE        */
*/*   MANAGEMENT (DADSM) TO ACQUIRE SPACE ON A DIRECT ACCESS VOLUME  */
*/*   FOR NEW DATA SETS. DADSM REQUIRES THE FOLLOWING INPUT:         */
*/*       .REG0 - POINTER TO JFCB FOR THE DATA SET.                  */
*/*       .REG1 - POINTER TO A FULL WORD CONTAINING THE ADDRESS OF   */
*/*               THE UCB ON WHICH THE VOLUME IS MOUNTED.            */
*/*       .THE SERIAL NUMBER OF THE VOLUME MUST BE IN THE JFCB.      */
*/*                                                                  */
*/* ENTRY - INLINE SEGMENT OF IEFAB492.                              */
*/*   PURPOSE  - SEE FUNCTION.                                       */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*     SIOTPTR - POINTER TO SIOT OF REQUEST, SIOT CONTAINS THE      */
*/*               POINTER TO THE JFCB.                               */
*/*     UCBPTR - POINTER TO UCB ALLOCATED TO REQUEST.                */
*/*                                                                  */
*/* EXITS -                                                          */
*/*   CONDITION - SPACE OBTAINED ON VOLUME.                          */
*/*                                                                  */
*/*     OUTPUT - NONE.                                               */
*/*       UPDATED JFCB                                               */
*/*                                                                  */
*/*     RETURN CODE -                                                */
*/*       REG15  - 0, TO INDICATE SPACE GOTTEN.                      */
*/*                                                                  */
*/*   CONDITION - UNABLE TO OBTAIN SPACE ON VOLUME SPECIFIED.        */
*/*                                                                  */
*/*     OUTPUT - NONE.                                               */
*/*                                                                  */
*/*     RETURN CODE -                                                */
*/*       ERRWORD  - RETURN CODE FROM DADSM TO INDICATE SPACE        */
*/*                  FAILURE.                                        */
*/*                                                                  */
*/*                                                                  */
*/********************************************************************/
*JFCBPTR = SJFCBPTR;                   /* GET JFCB POINTER FROM SIOT */
         LR    JFCBPTR,@03                                      02S0407
*JFCBVOLS(1:6) = UCBVOLI;              /* PUT VOLSER INTO JFCB       */
         MVC   JFCBVOLS(6,JFCBPTR),UCBVOLI(UCBPTR)              02S0408
*IF JFCBNVOL = ZERO THEN               /* IF NON-SPECIFIC REQUEST    */
         CLI   JFCBNVOL(JFCBPTR),0                              02S0409
         BNE   @RF00409                                         02S0409
*  JFCBNVOL = ONE;                     /* SET NUMBER OF VOLUMES      */
         MVI   JFCBNVOL(JFCBPTR),X'01'                          02S0410
*DADSPARM = UCBPTR;                    /* STORE POINTER TO UCB FOR
*                                         DADSM.                     */
@RF00409 ST    UCBPTR,DADSPARM                                  02S0411
*REG0 = JFCBPTR;                                                02S0412
         LR    REG0,JFCBPTR                                     02S0412
*REG1 = ADDR(DADSPARM);                                         02S0413
         LA    REG1,DADSPARM                                    02S0413
*GEN(SVC 32);                          /* INVOKE DADSM TO GET SPACE  */
         SVC 32
*ERRWORD = REG15;                      /*SAVE RETURN CODE            */
         LR    ERRWORD,REG15                                    02S0415
*                          IF ERRWORD ^= NOERROR THEN /*IF DADSM ERR */
         LTR   ERRWORD,ERRWORD                                  01S0416
         BZ    @RF00416                                         01S0416
*                            DO;       /*CLEANUP                     */
*/********************************************************************/
*/*                                                                  */
*/*  SEGMENT NAME - DADSERR2                                         */
*/*                                                                  */
*/*  DESCRIPTIVE NAME - DADSM ERROR HANDLER                          */
*/*                                                                  */
*/*  FUNCTION -  SET A REASON CODE TO INDICATE THE                   */
*/*              NATURE OF THE FAILURE                               */
*/*                                                                  */
*/*    OPERATION -                                                   */
*/*                 A REASON CODE IS PLACED IN THE SIOT GIVING       */
*/*                 THE CAUSE OF THE FAILURE.                        */
*/*                                                                  */
*/*                                                                  */
*/*                                                                  */
*/*  ENTRY - IN LINE SEGMENT OF IEFAB492.                            */
*/*    PURPOSE - SEE FUNCTION.                                       */
*/*                                                                  */
*/*    INPUT -                                                       */
*/*      ERRWORD - RETURN CODE FROM DADSM.                           */
*/*      SIOTPTR - POINTER TO SIOT TO WHICH THIS UNIT WAS ALLOCATED  */
*/*                                                                  */
*/*  EXIT -                                                          */
*/*                                                                  */
*/*    CONDITION - DADSM ERRORS PROCESSED.                           */
*/*                                                                  */
*/*    OUTPUT -                                                      */
*/*      SIOTRSNC - WILL CONTAIN A REASON CODE DESCRIBING THE        */
*/*                 SPECIFIC NATURE OF THE FAILURE                   */
*/*      SIOTALCD - SET OFF TO SHOW ALLOC NOT SUCCESSFUL             */
*/*                                                                  */
*/*    RETURN CODE -                                                 */
*/*      ERRWORD - 16, TO INDICATE DADSM FAILURE ON A SPECIFIC VOLUME*/
*/*                                                                  */
*/********************************************************************/
*INDEX = ERRWORD/FOUR;                 /*CALCULATE INDEX INTO ERROR
*                                        REASON CODE ARRAY           */
         LR    @00,ERRWORD                                      02S0418
         SRDA  @00,32                                           02S0418
         D     @00,@CF00096                                     02S0418
         LR    INDEX,@01                                        02S0418
*SIOTRSNC = ERORCODE(INDEX);           /*PLACE REASON CODE IN SIOT   */
         LR    @10,INDEX                                        02S0419
         ALR   @10,@10                                          02S0419
         LH    @10,ERORCODE-2(@10)                              02S0419
         STH   @10,SIOTRSNC(,SIOTPTR)                           02S0419
*SIOTALCD = OFF;                       /*SHOW ALLOC NOT SUCCESSFUL   */
         NI    SIOTALCD(SIOTPTR),B'11111101'                    02S0420
*ERRWORD = FAIL2;                      /*SET FAILURE RETURN CODE     */
         LA    ERRWORD,16                                       02S0421
*                            END;                               01S0422
*                          ELSE        /*DADSM SUCCESSFUL            */
*                            DO;                                01S0423
         B     @RC00416                                         01S0423
@RF00416 DS    0H                                               01S0424
*                              SIODADSM = ON; /*SHOW DADSM DONE      */
*                              SIOTALCD = ON; /*SHOW ALLOC SUCCESSFUL*/
         OI    SIODADSM(SIOTPTR),B'00000110'                    01S0425
*                            END;                               01S0426
*                        END;                                   01S0427
*                      ELSE;           /*NOT DIRECT ACCESS REQUEST   */
@RF00405 DS    0H                                               01S0429
*                    END;                                       01S0429
*                  ELSE;                                        01S0430
@RF00402 DS    0H                                               01S0431
*                  VMVREQBP = VMVNREQP; /*POINT TO NEXT VM&V REQ BLK */
@RC00402 L     @10,VMVREQBP                                     01S0431
         L     @10,VMVNREQP(,@10)                               01S0431
         ST    @10,VMVREQBP                                     01S0431
*                END;                                           01S0432
@DE00399 SLR   @10,@10                                          01S0432
         CR    ERRWORD,@10                                      01S0432
         BNE   @DC00399                                         01S0432
         C     @10,VMVREQBP                                     01S0432
         BNE   @DL00399                                         01S0432
@DC00399 DS    0H                                               01S0433
*              END;                                             01S0433
*            ELSE;                     /*NO SPECIFIC MOUNT REQUESTS  */
@RF00381 DS    0H                                               01S0435
*          END;                                                 01S0435
*        ELSE;                         /*ERROR HANDLING NON-SPECIFICS*/
@RF00348 DS    0H                                               01S0437
*      END;                                                     01S0437
*    ELSE;                             /*VM&V ERROR MOUNTING NSPECIF */
@RF00153 DS    0H                                               01S0439
*  END;                                                         01S0439
*ELSE;                                 /*NO VMVRB'S TO PROCESS       */
@RF00127 DS    0H                                               01S0441
*IF ERRWORD ^= NOERROR THEN            /*IF ERROR OCCURED            */
         LTR   ERRWORD,ERRWORD                                  01S0441
         BZ    @RF00441                                         01S0441
*  DO;                                 /*                    @Y30LPPD*/
*    ERRWORD = FAIL;                   /*SET FAILURE RETURN CODE     */
         LA    ERRWORD,4                                        01S0443
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - CLNMVCA                                           */
*/*                                                                  */
*/* DESCRIPTIVE NAME - CLEAN UP(FREE AND DE-CHAIN) THIS MEMORY'S     */
*/*                      MOUNT VERIFICATION CONTROL AREA             */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*                                                                  */
*/*   THIS SEGMENT IS EXECUTED WHENEVER A NON-RECOVERABLE ERROR      */
*/*   OCCURRED WHILE PROCESSING NON-SPECIFIC D.A. REQUESTS.          */
*/*                                                                  */
*/*   THE FUNCTION OF THE SEGMENT IS TO CLEAN UP THE MOUNT VERIFI-   */
*/*   CATION INTERFACE CONSTRUCTED FOR ANY SPECIFIC DIRECT ACCESS    */
*/*   OR WTOR MOUNTS REQUESTED.                                      */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*                                                                  */
*/*   THE MVCA CHAIN PROCESSOR MODULE, IEFAB498, IS CALLED TO        */
*/*   OBTAIN A POINTER TO THE MVCA FOR THIS ALLOCATION.  THIS MVCA   */
*/*   POINTER IS USED AS INPUT TO THE DOMR AND CLEANUP ROUTINE,      */
*/*   IEFAB49A.  IEFAB49A IS CALLED WITH PARAMETERS REQUESTING THAT  */
*/*   ALL OUTSTANDING MESSAGES BE DOM'D AND THAT THE MOUNT VERI-     */
*/*   FICATION INTERFACE CONTROL BLOCKS BE FREED AND DE-CHAINED.     */
*/*   THE DOMR AND CLEANUP ROUTINE IS CALLED ONLY IF A NON-ZERO      */
*/*   MVCA POINTER IS RETURNED BY THE MVCA CHAIN PROCESSOR.          */
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*   INPUT -                                                        */
*/*     ASID - THIS MEMORY'S IDENTIFIER                              */
*/*                                                                  */
*/* EXIT -                                                           */
*/*                                                                  */
*/*   CONDITION - NORMAL                                             */
*/*     OUTPUT -                                                     */
*/*       ANY OUTSTANDING MOUNT MESSAGES DOM'D                       */
*/*       MOUNT VERIFICATION CONTROL BLOCKS - IF ANY EXISTED AT      */
*/*         ENTRY - FREED AND DE-CHAINED.  CONTROL BLOCKS INVOLVED   */
*/*         INCLUDE:  MVCA, MVCAX, AND MOUNT ENTRIES.                */
*/*     RETURN CODE - SAME AS ON ENTRY                               */
*/*                                                                  */
*/********************************************************************/
*PRMSMVCA = PRMSMVCA && PRMSMVCA;      /* CLEAR MVCA CHAIN PRCR PARMS*/
         XC    PRMSMVCA(8),PRMSMVCA                             02S0444
*SRCHINDC = ON;                        /* FIND THIS MEMORY'S MVCA.   */
         OI    SRCHINDC,B'00100000'                             02S0445
*MMRYID = ASID;                        /* USE THIS MEMORY'S ID       */
         L     @10,@PC00001+16                                  02S0446
         MVC   MMRYID(2),ASID(@10)                              02S0446
*PRMMVCAP = ADDR(PRMSMVCA);            /* SET PARM PTR.              */
         LA    @10,PRMSMVCA                                     02S0447
         ST    @10,PRMMVCAP                                     02S0447
*CALL IEFAB498(PRMMVCAP);              /* CALL MVCA CHAIN PROCESSOR. */
         LA    @10,PRMMVCAP                                     02S0448
         ST    @10,@AL00001                                     02S0448
         L     @15,@CV01148                                     02S0448
         LA    @01,@AL00001                                     02S0448
         BALR  @14,@15                                          02S0448
*IF MMRYMVCA ^= ZERO THEN              /* MVCA EXIST FOR THIS MEMORY?*/
         L     @10,MMRYMVCA                                     02S0449
         LTR   @10,@10                                          02S0449
         BZ    @RF00449                                         02S0449
*  DO;                                                          02S0450
*    PRMSCLNP = PRMSCLNP && PRMSCLNP;  /* CLEAR CLEANUP PARMS.       */
         XC    PRMSCLNP(16),PRMSCLNP                            02S0451
*    DOMALL = ON;                      /* DOM ALL THIS ALLOC'S MOUNTS*/
*    FRMVCACR = ON;                    /* FREE MOUNT VER CNTL BLKS.  */
         OI    DOMALL,B'01100000'                               02S0453
*    MCAPTR = MMRYMVCA;                /* PTR TO MVCA                */
         ST    @10,MCAPTR                                       02S0454
*    CALL IEFAB49A(PRMSCLNP);          /* CALL DOMR & CLEANUP RTN    */
         LA    @10,PRMSCLNP                                     02S0455
         ST    @10,@AL00001                                     02S0455
         L     @15,@CV01145                                     02S0455
         LA    @01,@AL00001                                     02S0455
         BALR  @14,@15                                          02S0455
*  END;                                                         02S0456
*ELSE;                                                          02S0457
@RF00449 DS    0H                                               02S0458
*  END;                                /*                    @Y30LPPD*/
*ELSE;                                                          01S0459
@RF00441 DS    0H                                               01S0460
*VMVREQBP= FRSTVMVP;                   /*POINT TO FIRST VMV REQ BLK  */
         MVC   VMVREQBP(4),FRSTVMVP                             01S0460
*DO WHILE VMVREQBP ^= ZERO;            /*FREE UP ANY REMAINING BLOCKS*/
         B     @DE00461                                         01S0461
@DL00461 DS    0H                                               01S0462
*  RFY (REG0,REG1) RSTD;                                        01S0462
*  REG0 = VMVRBLEN;                    /*SET LENGTH TO FREE          */
         L     REG0,VMVRBLEN                                    01S0463
*  REG0 = REG0 | SUBPL230;             /* FREE FROM SUBPOOL 230.     */
         O     REG0,@CF00124                                    01S0464
*  REG1 = VMVREQBP;                    /*LOCATION OF BLOCK TO FREE   */
         L     @10,VMVREQBP                                     01S0465
         LR    REG1,@10                                         01S0465
*  VMVREQBP=VMVNREQP;                  /*POINT TO NEXT BLOCK         */
         L     @10,VMVNREQP(,@10)                               01S0466
         ST    @10,VMVREQBP                                     01S0466
*  GEN(FREEMAIN R,LV=(0),A=(1));       /*FREE ONE VM&V REQUEST BLOCK */
         FREEMAIN R,LV=(0),A=(1)
*  RFY (REG0,REG1) UNRSTD;                                      01S0468
*END;                                                           01S0469
@DE00461 ICM   @10,15,VMVREQBP                                  01S0469
         BNZ   @DL00461                                         01S0469
*RETURN CODE(ERRWORD);                 /*RETURN TO CALLER            */
         IC    @02,@OLDKEY                                      01S0470
         L     @13,4(,@13)                                      01S0470
         L     @00,@SIZDATD                                     01S0470
         LR    @01,@11                                          01S0470
         FSPACE   R,LV=(0),A=(1)
         MODESET KEYADDR=(2)
         LR    @15,@04                                          01S0470
         L     @14,12(,@13)                                     01S0470
         LM    @00,@12,20(@13)                                  01S0470
         BR    @14                                              01S0470
*END                                                            01S0471
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (A492SPEC)                                        *
*/*%INCLUDE SYSLIB  (A492DATA)                                        *
*/*%INCLUDE SYSLIB  (VMVCHDAT)                                        *
*/*%INCLUDE SYSLIB  (NDACTDAT)                                        *
*/*%INCLUDE SYSLIB  (IEFZB427)                                        *
*/*%INCLUDE SYSLIB  (NSPDADAT)                                        *
*/*%INCLUDE SYSLIB  (IEZJSCB )                                        *
*/*%INCLUDE SYSLIB  (DADS3DAT)                                        *
*/*%INCLUDE SYSLIB  (CVT     )                                        *
*/*%INCLUDE SYSLIB  (ICHPRCVT)                                        *
*/*%INCLUDE SYSLIB  (IEFZB439)                                        *
*/*%INCLUDE SYSLIB  (VMVRBDAT)                                        *
*/*%INCLUDE SYSLIB  (DADSMDAT)                                        *
*/*%INCLUDE SYSLIB  (DADSEDAT)                                        *
*/*%INCLUDE SYSLIB  (IEFZB448)                                        *
*/*%INCLUDE SYSLIB  (IEFZB423)                                        *
*/*%INCLUDE SYSLIB  (IEFZB431)                                        *
*/*%INCLUDE SYSLIB  (IEFJFCBN)                                        *
*/*%INCLUDE SYSLIB  (IEFUCBOB)                                        *
*/*%INCLUDE SYSLIB  (IEFASIOT)                                        *
*/*%INCLUDE SYSLIB  (IEFZB428)                                        *
*/*%INCLUDE SYSLIB  (IEFZB447)                                        *
*/*%INCLUDE SYSLIB  (VMVCHAIN)                                        *
*/*%INCLUDE SYSLIB  (VMVCHSPC)                                        *
*/*%INCLUDE SYSLIB  (VMVDUPCK)                                        *
*/*%INCLUDE SYSLIB  (VMVDPSPC)                                        *
*/*%INCLUDE SYSLIB  (NSPDACTL)                                        *
*/*%INCLUDE SYSLIB  (NDACTSPC)                                        *
*/*%INCLUDE SYSLIB  (NSPDAVOL)                                        *
*/*%INCLUDE SYSLIB  (NSPDASPC)                                        *
*/*%INCLUDE SYSLIB  (DADSMINT)                                        *
*/*%INCLUDE SYSLIB  (DADSMINT)                                        *
*/*%INCLUDE SYSLIB  (DADSMSPC)                                        *
*/*%INCLUDE SYSLIB  (DADSMSPC)                                        *
*/*%INCLUDE SYSLIB  (DADSERR3)                                        *
*/*%INCLUDE SYSLIB  (DADS3SPC)                                        *
*/*%INCLUDE SYSLIB  (VMVRQBLD)                                        *
*/*%INCLUDE SYSLIB  (VMVRBSPC)                                        *
*/*%INCLUDE SYSLIB  (UPDCHAIN)                                        *
*/*%INCLUDE SYSLIB  (UPDCHSPC)                                        *
*/*%INCLUDE SYSLIB  (DADSERR2)                                        *
*/*%INCLUDE SYSLIB  (DADSESPC)                                        *
*/*%INCLUDE SYSLIB  (CLNMVCA )                                        *
*/*%INCLUDE SYSLIB  (CLNSPEC )                                        *
*;                                                              01S0471
@DATA    DS    0H
@CH00082 DC    H'2'
@CH00111 DC    H'3'
@CH00122 DC    H'5'
@CH00094 DC    H'8'
@CH00129 DC    H'10'
@CH00120 DC    H'12'
@CH00098 DC    H'16'
@CH00308 DC    H'17'
@CH00107 DC    H'20'
@CH00109 DC    H'23'
@CH00127 DC    H'24'
@CH00135 DC    H'25'
@CH00104 DC    H'28'
@CH00071 DC    H'32'
@CH00301 DC    H'33'
@CH00133 DC    H'36'
@CH00304 DC    H'38'
@CH00102 DC    H'44'
@CH00306 DC    H'48'
@CH00318 DC    H'55'
         DS    0F
@AL00228 DC    A(@CF00100)             LIST WITH   6 ARGUMENT(S)
         DC    A(@CF00100)
         DC    A(@CF00100)
         DC    A(@CF00100)
         DS    F
         DC    A(@CF00100)
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    10F
@AL00001 DS    9A
IEFAB492 CSECT
         DS    0F
@CF00100 DC    F'0'
@CF00096 DC    F'4'
@CH00096 EQU   @CF00096+2
@CF00124 DC    XL4'E6000000'
@DATD    DSECT
         DS    0D
FRSTVMVP DS    A
PRMMVCAP DS    A
VMVREQBP DS    A
TCBP     DS    A
VOLSERP  DS    A
TCBJSCB  DS    A
CMRBPTR  DS    A
DADSPARM DS    A
RETCODE  DS    F
DUPSAVE  DS    CL1
         DS    CL3
PRMSCLNP DS    CL16
         ORG   PRMSCLNP
FMAPCLNP DS    BL4
         ORG   FMAPCLNP
@NM00001 DS    BL1
DOMALL   EQU   FMAPCLNP+0
FRMVCACR EQU   FMAPCLNP+0
@NM00002 EQU   FMAPCLNP+0
         ORG   PRMSCLNP+4
MCAPTR   DS    AL4
@NM00003 DS    AL4
@NM00004 DS    AL4
         ORG   PRMSCLNP+16
PRMSMVCA DS    CL8
         ORG   PRMSMVCA
FMAPMVCA DS    CL2
         ORG   FMAPMVCA
@NM00005 DS    BL1
SRCHINDC EQU   FMAPMVCA+0
@NM00006 EQU   FMAPMVCA+0
         ORG   PRMSMVCA+2
MMRYID   DS    CL2
MMRYMVCA DS    AL4
         ORG   PRMSMVCA+8
URCODES  DS    CL8
FREQBLSW DS    BL1
FNMAP    DS    BL1
         ORG   FNMAP
VOLUMENQ DS    BL1
VOLUMDEQ EQU   FNMAP+0
VOLEXCLU EQU   FNMAP+0
@NM00007 EQU   FNMAP+0
         ORG   FNMAP+1
ENQERROR DS    BL1
SCRERRSW DS    BL1
DISPRB   DS    CL16
FMAP     DS    CL4
@OLDKEY  DS    AL1
IEFAB492 CSECT
         DS    0F
@SIZDATD DC    AL1(230)
         DC    AL3(@ENDDATD-@DATD)
@CV01144 DC    V(IEFAB493)
@CV01145 DC    V(IEFAB49A)
@CV01146 DC    V(IEFAB4A0)
@CV01147 DC    V(IEFAB4FA)
@CV01148 DC    V(IEFAB498)
@CV01149 DC    V(IEFAB4F0)
         DS    0D
VUENTLEN DC    AL4(28)
VMVRBLEN DC    AL4(52)
BLANKS   DC    CL8' '
ERORCODE DC    H'22'
         DC    H'23'
         DC    H'24'
         DC    H'25'
         DC    H'26'
         DC    H'27'
         DC    H'28'
         DC    H'29'
         DC    H'30'
         DC    H'31'
         DC    H'32'
         DC    H'0'
         DC    H'33'
         DC    H'34'
         DC    H'35'
         DC    H'36'
         DC    H'0'
         DC    H'0'
         DC    H'38'
         DC    H'39'
         DC    H'40'
         DC    H'41'
         DC    H'42'
         DC    H'43'
         DC    H'44'
         DC    H'45'
         DC    H'46'
         DC    H'47'
         DC    H'0'
         DC    H'0'
         DC    H'0'
         DC    H'48'
         DC    H'49'
         DC    H'0'
         DC    H'50'
         DC    H'51'
         DC    H'61'
         DC    H'62'
         DC    H'63'
         DC    H'64'
         DC    H'69'
         DC    H'16'
         DC    H'17'
IEFAB492 CSECT
         DS   0H
A492PTCH DC ((@DATA-@PSTART)/20)X'00'
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEFAB492 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
AVMVRBP  EQU   @02
INDEX    EQU   @02
CFMAPTR  EQU   @03
PREVVMVP EQU   @08
ERRWORD  EQU   @04
VUPTR    EQU   @02
UCBPTR   EQU   @06
SIOTPTR  EQU   @05
SAVEREQP EQU   @07
JFCBPTR  EQU   @02
REG0     EQU   @00
REG1     EQU   @01
REG15    EQU   @15
CVTPTR   EQU   16
STRSNCDE EQU   0
AQMPARAM EQU   0
AQMECODE EQU   AQMPARAM
AQMNORMP EQU   AQMPARAM+20
IEZJSCB  EQU   0
JSCBSEC1 EQU   IEZJSCB+188
JSCHPCE  EQU   JSCBSEC1+4
JSCBTCBP EQU   JSCBSEC1+20
JSCBDCB  EQU   JSCBSEC1+36
JSCBOPTS EQU   JSCBSEC1+48
JSCBSWT1 EQU   JSCBSEC1+55
JSCBWTP  EQU   JSCBSEC1+64
JSCBWTFG EQU   JSCBWTP
JSCBEND1 EQU   IEZJSCB+260
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
RCVT     EQU   0
RCVTSTAT EQU   RCVT+53
RCVTSTA1 EQU   RCVT+150
RCVTAUOP EQU   RCVT+151
RCVTFLGS EQU   RCVT+153
RCVTNDUP EQU   RCVTFLGS
RCVTEROP EQU   RCVT+154
RCVTVERS EQU   RCVT+172
CMUNFMAP EQU   0
CMFMBYT1 EQU   CMUNFMAP
CMDISPRC EQU   CMFMBYT1
CMFMBYT2 EQU   CMUNFMAP+1
CMNOPOST EQU   CMFMBYT2
CMNOVUT  EQU   CMFMBYT2
CMPURGE  EQU   CMFMBYT2
CMTIOTNQ EQU   CMFMBYT2
CMFMBYT3 EQU   CMUNFMAP+2
CMNOSMF  EQU   CMFMBYT3
CMFMBYT4 EQU   CMUNFMAP+3
CMUNRB   EQU   0
CMSIOPTR EQU   CMUNRB+4
CMINDIC  EQU   CMUNRB+8
CMRBBYT1 EQU   CMINDIC
CMORDISP EQU   CMRBBYT1
CMRBBYT2 EQU   CMINDIC+1
CMRBBYT3 EQU   CMINDIC+2
CMRBBYT4 EQU   CMINDIC+3
CMODISP  EQU   CMUNRB+12
CMODEL   EQU   CMODISP
CMRETCDE EQU   CMUNRB+14
CMOPTFLD EQU   CMUNRB+16
VOLUNTAB EQU   0
VOLID    EQU   VOLUNTAB
VOLSTAT  EQU   VOLUNTAB+6
VOLSTATA EQU   VOLSTAT
VOLNSHR  EQU   VOLSTATA
VUDADSM  EQU   VOLSTATA
VOLSTATB EQU   VOLSTAT+1
VOLSTATC EQU   VOLSTAT+2
VOLSTATD EQU   VOLSTAT+3
VOLSIOTP EQU   VOLUNTAB+16
VUUCBP   EQU   VOLUNTAB+20
VUGRID   EQU   VOLUNTAB+24
VUPOOL   EQU   0
VUGRLST  EQU   0
VUGRLENT EQU   VUGRLST
VUGRLFLG EQU   VUGRLENT+4
VMVRQBLK EQU   0
VMVFNMAP EQU   VMVRQBLK
VMVOPTB1 EQU   VMVFNMAP
VMVUNLOD EQU   VMVOPTB1
VMVMOUNT EQU   VMVOPTB1
VMVMTMSG EQU   VMVOPTB1
VMVDWTOR EQU   VMVOPTB1
VMVVRLBL EQU   VMVOPTB1
VMVVDEND EQU   VMVOPTB1
VMVOPTB2 EQU   VMVFNMAP+1
VMVOPTB3 EQU   VMVFNMAP+2
VMVDUPVL EQU   VMVOPTB3
VMVCUVOL EQU   VMVOPTB3
VMVNREQP EQU   VMVRQBLK+4
VMVUCBP  EQU   VMVRQBLK+9
VMVUVLSR EQU   VMVRQBLK+12
VMVMVLSR EQU   VMVRQBLK+18
VMVDSNMP EQU   VMVRQBLK+28
VMVRETCD EQU   VMVRQBLK+36
VMVMINFO EQU   VMVRQBLK+40
VMVACTON EQU   VMVMINFO
VMVDSMT  EQU   VMVACTON
VMVVUNTP EQU   VMVRQBLK+44
VMVUSER  EQU   VMVRQBLK+48
VMVPROCD EQU   VMVUSER
INFMJFCB EQU   0
JFCBDSNM EQU   INFMJFCB
JFCBELNM EQU   INFMJFCB+44
JFCBTSDM EQU   INFMJFCB+52
JFCFCBID EQU   INFMJFCB+56
JFCBFRID EQU   JFCFCBID
JFCVINDX EQU   INFMJFCB+64
JFCBLTYP EQU   INFMJFCB+66
JFCBOTTR EQU   INFMJFCB+67
JFCBUFOF EQU   JFCBOTTR
JFCBFLSQ EQU   JFCBOTTR+1
JFCFUNC  EQU   JFCBFLSQ
JFCBMASK EQU   INFMJFCB+72
JFCBFLG1 EQU   JFCBMASK+5
JFCOPEN  EQU   JFCBFLG1
JFCBFLG2 EQU   JFCBMASK+6
JFCDEFER EQU   JFCBFLG2
JFCBIND1 EQU   INFMJFCB+86
JFCBIND2 EQU   INFMJFCB+87
JFCAMPTR EQU   INFMJFCB+88
JFCBUFRQ EQU   JFCAMPTR
JFCBUFNO EQU   JFCBUFRQ
JFCBGNCP EQU   JFCAMPTR+1
JFCBHIAR EQU   JFCBGNCP
JFCBFALN EQU   JFCBHIAR
JFCBFTEK EQU   JFCBFALN
JFCBBFTA EQU   JFCBFTEK
JFCEROPT EQU   INFMJFCB+92
JFCTRTCH EQU   INFMJFCB+93
UCB      EQU   0
UCBOB    EQU   0
UCBJBNR  EQU   UCBOB
UCBFL5   EQU   UCBOB+1
UCBAF    EQU   UCBFL5
UCBSTAT  EQU   UCBOB+3
UCBPRES  EQU   UCBSTAT
UCBCHAN  EQU   UCBOB+4
UCBSFLS  EQU   UCBOB+6
UCBFLA   EQU   UCBSFLS
UCBFL1   EQU   UCBFLA
UCBBSY   EQU   UCBFL1
UCBNRY   EQU   UCBFL1
UCBPST   EQU   UCBFL1
UCBCUB   EQU   UCBFL1
UCBFLB   EQU   UCBSFLS+1
UCBCHM   EQU   UCBOB+8
UCBCHM1  EQU   UCBCHM
UCBPTH0  EQU   UCBCHM1
UCBPTH1  EQU   UCBCHM1
UCBWGT   EQU   UCBOB+12
UCBTYP   EQU   UCBOB+16
UCBTBYT1 EQU   UCBTYP
UCB1FEA5 EQU   UCBTBYT1
UCB1FEA6 EQU   UCBTBYT1
UCBTBYT2 EQU   UCBTYP+1
UCB2OPT2 EQU   UCBTBYT2
UCBDUDN1 EQU   UCB2OPT2
UCB2OPT3 EQU   UCBTBYT2
UCBDUDN2 EQU   UCB2OPT3
UCB2OPT4 EQU   UCBTBYT2
UCBRWTAU EQU   UCB2OPT4
UCB2OPT6 EQU   UCBTBYT2
UCB2OPT7 EQU   UCBTBYT2
UCBTBYT3 EQU   UCBTYP+2
UCBDVCLS EQU   UCBTBYT3
UCB3DACC EQU   UCBDVCLS
UCBTBYT4 EQU   UCBTYP+3
UCBEXTPT EQU   UCBOB+20
UCBFLC   EQU   UCBEXTPT
UCBDEV   EQU   UCBOB+24
UCBCMEXT EQU   0
UCBATI   EQU   UCBCMEXT+3
@NM00050 EQU   UCBATI
UCBFLP1  EQU   UCBCMEXT+5
UCBMT    EQU   0
UCBOCR   EQU   0
UCB3540X EQU   0
UCBDKBYT EQU   UCB3540X+6
UCB3800X EQU   0
UCBOPTNS EQU   UCB3800X
UCBACTIV EQU   UCB3800X+3
UCBMDRBF EQU   UCB3800X+36
UCBUCS   EQU   0
UCBUCSOP EQU   UCBUCS+4
UCBFCBOP EQU   UCBUCS+5
INDMSIOT EQU   0
SCTUSADD EQU   INDMSIOT+20
SIOTBYT1 EQU   INDMSIOT+43
SIODADSM EQU   SIOTBYT1
SIOTALCD EQU   SIOTBYT1
SIOTBYT3 EQU   INDMSIOT+46
SIOTTSTC EQU   INDMSIOT+47
SIOTBYT0 EQU   INDMSIOT+52
SCTSDISP EQU   INDMSIOT+55
SCTSBYT1 EQU   INDMSIOT+56
SCTSBYT2 EQU   INDMSIOT+57
SCTSBYT3 EQU   INDMSIOT+58
SCTSBYT4 EQU   INDMSIOT+59
SCTUTYPE EQU   INDMSIOT+60
SIOTDEVT EQU   SCTUTYPE
SIOUBYT3 EQU   SIOTDEVT+2
SIOTBYT4 EQU   INDMSIOT+81
SIOTALTD EQU   INDMSIOT+92
SIOTBYT2 EQU   INDMSIOT+103
SIOTDSPD EQU   SIOTBYT2
SIOTRSNC EQU   INDMSIOT+130
SVOLUNAD EQU   INDMSIOT+140
SIOTNPTR EQU   INDMSIOT+152
SJFCBPTR EQU   INDMSIOT+156
SIOTVMVP EQU   INDMSIOT+164
FUNCMAP  EQU   0
VOLMNTSW EQU   FUNCMAP
WRTMSGSW EQU   FUNCMAP
UWAITSW  EQU   FUNCMAP
VWAITSW  EQU   FUNCMAP
MSSTRMSW EQU   FUNCMAP
OFFDEVSW EQU   FUNCMAP
CCLMNTSW EQU   FUNCMAP
GENLOKSW EQU   FUNCMAP
SSEMSGSW EQU   FUNCMAP+1
HDRMSGSW EQU   FUNCMAP+1
MTRJOBSW EQU   FUNCMAP+1
NOTIOTNQ EQU   FUNCMAP+1
TRKMSW   EQU   FUNCMAP+1
WAITOKSW EQU   FUNCMAP+1
ASNMSW   EQU   FUNCMAP+1
PRMESTAE EQU   0
PRMRESC  EQU   PRMESTAE+252
PRMFUNC  EQU   PRMESTAE+253
VMVCALL  EQU   PRMFUNC
UCBBGN   EQU   0
FSIOTPTR EQU   0
CNECB    EQU   0
VUTABPTR EQU   0
VUTABLTH EQU   0
ASID     EQU   0
FAILRSCP EQU   0
JSCBPTR  EQU   0
QMPARMP  EQU   0
FMAPPTR  EQU   0
EXITPRMP EQU   0
JSCBSEC2 EQU   JSCBEND1
JSCBSEC3 EQU   JSCBEND1
JSCBJCT  EQU   JSCBSEC3
JSCBJCTA EQU   JSCBJCT+1
JSCBASID EQU   JSCBSEC3+8
JSCBFBYT EQU   JSCBSEC3+10
JSCBJNL  EQU   JSCBSEC3+28
JSCBJJSB EQU   JSCBJNL
JSCBSUB  EQU   JSCBSEC3+40
JSCSCT   EQU   JSCBSEC3+68
JSCRSV45 EQU   JSCBSEC3+112
JSCRSV46 EQU   JSCRSV45
JSCRSV47 EQU   JSCRSV45+2
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
CVTRAC   EQU   CVTS01+644
JFCKEYLE EQU   JFCTRTCH
JFCCODE  EQU   JFCKEYLE
JFCSTACK EQU   JFCTRTCH
JFCMODE  EQU   JFCSTACK
JFCSPPRT EQU   JFCTRTCH
JFCBABFS EQU   JFCSPPRT+2
JFCLIMCT EQU   JFCBABFS
JFCDSORG EQU   JFCSPPRT+5
JFCDSRG1 EQU   JFCDSORG
JFCORGIS EQU   JFCDSRG1
JFCDSRG2 EQU   JFCDSORG+1
JFCRECFM EQU   JFCSPPRT+7
JFCRCFM  EQU   JFCRECFM
JFCOPTCD EQU   JFCSPPRT+8
JFCWVCSP EQU   JFCOPTCD
JFCWVCIS EQU   JFCWVCSP
JFCWVCBD EQU   JFCWVCIS
JFCALLOW EQU   JFCOPTCD
JFCRSV17 EQU   JFCALLOW
JFCOVER  EQU   JFCRSV17
JFCPCIBT EQU   JFCOPTCD
JFCMAST  EQU   JFCPCIBT
JFCEXT   EQU   JFCMAST
JFCBCKPT EQU   JFCOPTCD
JFCIND   EQU   JFCBCKPT
JFCRSV18 EQU   JFCOPTCD
JFCCYL   EQU   JFCRSV18
JFCACT   EQU   JFCCYL
JFCREDUC EQU   JFCOPTCD
JFCRSV19 EQU   JFCREDUC
JFCRSV20 EQU   JFCRSV19
JFCRSV21 EQU   JFCOPTCD
JFCDEL   EQU   JFCRSV21
JFCOPTJ  EQU   JFCOPTCD
JFCREORG EQU   JFCOPTJ
JFCBLKSI EQU   JFCSPPRT+9
JFCBUFSI EQU   JFCBLKSI
JFCAMSYN EQU   JFCSPPRT+11
JFCNCP   EQU   JFCAMSYN+2
JFCNTM   EQU   JFCAMSYN+3
JFCBFSEQ EQU   JFCNTM
JFCPCI   EQU   JFCBFSEQ
JFCRESRV EQU   JFCAMSYN+4
JFCUCSEG EQU   JFCRESRV
JFCUCSOP EQU   JFCUCSEG+4
JFCOUTLI EQU   JFCUCSEG+5
JFCTHRSH EQU   JFCOUTLI
JFCCPRI  EQU   JFCTHRSH
JFCBNVOL EQU   JFCUCSEG+9
JFCBVOLS EQU   JFCUCSEG+10
JFCBS001 EQU   JFCBVOLS
JFCMSVGP EQU   JFCBS001+22
JFCBPQTY EQU   JFCBS001+34
JFCBCTRI EQU   JFCBS001+37
JFCBSQTY EQU   JFCBS001+38
JFCFLGS1 EQU   JFCBS001+41
JFCBSPNM EQU   JFCBS001+45
JFCBFLG3 EQU   JFCBSPNM
UCBOBS01 EQU   UCBDEV
UCBVOLI  EQU   UCBOBS01+4
UCBSTAB  EQU   UCBOBS01+10
UCBBSVL  EQU   UCBSTAB
UCBPRSRS EQU   UCBSTAB
UCBDMCT  EQU   UCBOBS01+11
UCBFL4   EQU   UCBOBS01+13
UCBOBS02 EQU   UCBDEV
UCBTFL1  EQU   UCBOBS02+19
UCBXTN   EQU   UCBOBS02+20
UCBVOPT  EQU   UCBXTN
UCBOBS03 EQU   UCBDEV
UCBXTADR EQU   UCBOBS03
UCBOBS04 EQU   UCBDEV
UCBBTA   EQU   UCBOBS04+12
UCBOBS06 EQU   UCBDEV
UCBAOF   EQU   UCBOBS06
UCBAOF1  EQU   UCBAOF
UCBAOF2  EQU   UCBAOF+1
@NM00049 EQU   UCBOBS06+3
UCBIRB   EQU   UCBOBS06+4
UCBGRAF  EQU   UCBIRB
UCBLDNCA EQU   UCBOBS06+8
UCBRDYQ  EQU   UCBLDNCA
UCBIRLN  EQU   UCBRDYQ
UCBLDNCB EQU   UCBRDYQ+1
UCBCTLNK EQU   UCBOBS06+12
UCBOBS07 EQU   UCBDEV
UCBOBS08 EQU   UCBDEV
UCBCTCAD EQU   UCBOBS08
UCBCTCF1 EQU   UCBOBS08+4
UCBOBS09 EQU   UCBDEV
CMUIDPTR EQU   CMOPTFLD
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
UCBRV066 EQU   UCBOBS09+4
UCBIOSBA EQU   UCBOBS09
UCBRV042 EQU   UCBOBS08+5
UCBRV082 EQU   UCBCTCF1
UCBRV081 EQU   UCBCTCF1
UCBRV080 EQU   UCBCTCF1
UCBRV079 EQU   UCBCTCF1
UCBRV078 EQU   UCBCTCF1
UCBRV077 EQU   UCBCTCF1
UCBRV076 EQU   UCBCTCF1
UCBCTC80 EQU   UCBCTCF1
UCBCTCAL EQU   UCBCTCAD
UCBICNCB EQU   UCBOBS07+4
UCBRV040 EQU   UCBOBS07
UCBCTLNA EQU   UCBCTLNK+1
UCBRLN   EQU   UCBCTLNK
UCBRDYQA EQU   UCBLDNCB
UCBINRLN EQU   UCBIRLN
UCBIRBA  EQU   UCBIRB+1
UCBRV039 EQU   UCBGRAF
UCBDWNR  EQU   UCBGRAF
UCBRPND  EQU   UCBGRAF
UCBUPM   EQU   UCBGRAF
UCBBTAM  EQU   UCBGRAF
UCBDRNO  EQU   UCBGRAF
UCBDRO   EQU   UCBGRAF
UCBOIP   EQU   UCBGRAF
UCBATRCD EQU   @NM00049
UCBSKPFG EQU   @NM00049
UCBRIPND EQU   @NM00049
UCBRTIAC EQU   @NM00049
UCBRSV79 EQU   @NM00049
UCBRSV78 EQU   @NM00049
UCBRSV77 EQU   @NM00049
UCBOLTEP EQU   @NM00049
UCBATNCT EQU   UCBOBS06+2
UCBRSV76 EQU   UCBAOF2
UCBRSV75 EQU   UCBAOF2
UCBRSV74 EQU   UCBAOF2
UCBRSV73 EQU   UCBAOF2
UCBRSV72 EQU   UCBAOF2
UCBRSV71 EQU   UCBAOF2
UCBRSV70 EQU   UCBAOF2
UCBRSV69 EQU   UCBAOF2
UCBRSV68 EQU   UCBAOF1
UCBRSV67 EQU   UCBAOF1
UCBRSV66 EQU   UCBAOF1
UCBRSV65 EQU   UCBAOF1
UCBRSV64 EQU   UCBAOF1
UCBOFNL  EQU   UCBAOF1
UCBOFSP  EQU   UCBAOF1
UCBOFMCR EQU   UCBAOF1
UCBBTB   EQU   UCBBTA+1
UCBDI    EQU   UCBBTA
UCBSNS   EQU   UCBOBS04+8
UCBTEB   EQU   UCBOBS04+4
UCBGCB   EQU   UCBOBS04+3
UCBOPEN  EQU   UCBOBS04+2
UCBSTART EQU   UCBOBS04
UCBXTNB  EQU   UCBXTN+1
UCBRSV22 EQU   UCBVOPT
UCBRSV21 EQU   UCBVOPT
UCBRSV20 EQU   UCBVOPT
UCBESVE  EQU   UCBVOPT
UCBERPC  EQU   UCBVOPT
UCBESVC  EQU   UCBVOPT
UCBEVA   EQU   UCBVOPT
UCBESV   EQU   UCBVOPT
UCBRV009 EQU   UCBTFL1
UCBRV008 EQU   UCBTFL1
UCBRV007 EQU   UCBTFL1
UCBRV006 EQU   UCBTFL1
UCBRV005 EQU   UCBTFL1
UCBDQDSP EQU   UCBTFL1
UCBNSLTP EQU   UCBTFL1
UCBNLTP  EQU   UCBTFL1
UCBRES1B EQU   UCBOBS02+18
UCBFSER  EQU   UCBOBS02+12
@NM00048 EQU   UCBOBS02+4
UCBFSEQ  EQU   UCBOBS02+2
UCBFSCT  EQU   UCBOBS02
UCBNEXP  EQU   UCBOBS01+20
UCBBASE  EQU   UCBOBS01+16
UCBRES1A EQU   UCBOBS01+15
UCBUSER  EQU   UCBOBS01+14
UCBFL47  EQU   UCBFL4
UCBFL46  EQU   UCBFL4
UCBFL45  EQU   UCBFL4
UCBRV065 EQU   UCBFL4
UCBDSS   EQU   UCBFL4
UCBRESVP EQU   UCBFL4
UCBWDAV  EQU   UCBFL4
UCBDAVV  EQU   UCBFL4
UCBSQC   EQU   UCBOBS01+12
UCBDATP  EQU   UCBOBS01+12
UCBDMC   EQU   UCBDMCT
UCBMOUNT EQU   UCBDMCT
UCBBNUL  EQU   UCBSTAB
UCBSHAR  EQU   UCBSTAB
UCBBSTR  EQU   UCBSTAB
UCBBPUB  EQU   UCBSTAB
UCBBPRV  EQU   UCBSTAB
UCBBALB  EQU   UCBPRSRS
UCBPGFL  EQU   UCBSTAB
UCBDVSHR EQU   UCBBSVL
UCBVTOC  EQU   UCBOBS01
JFCBEND  EQU   JFCBS001+58
JFCBSPTN EQU   JFCBS001+57
JFCBVLCT EQU   JFCBS001+56
JFCBDRLH EQU   JFCBS001+53
JFCBSBNM EQU   JFCBS001+50
JFCBABST EQU   JFCBS001+48
JFCBRV08 EQU   JFCBSPNM+1
JFCBRV07 EQU   JFCBFLG3
JFCBRV06 EQU   JFCBFLG3
JFCBRV05 EQU   JFCBFLG3
JFCBRV04 EQU   JFCBFLG3
JFCBRV03 EQU   JFCBFLG3
JFCBRV02 EQU   JFCBFLG3
JFCBEXP  EQU   JFCBFLG3
JFCDQDSP EQU   JFCBFLG3
JFCBDQTY EQU   JFCBS001+42
JFCBUAFF EQU   JFCFLGS1
JFCRSV45 EQU   JFCFLGS1
JFCVRDS  EQU   JFCFLGS1
JFCBCEOV EQU   JFCFLGS1
JFCRSV42 EQU   JFCFLGS1
JFCBADSP EQU   JFCFLGS1
JFCTOPEN EQU   JFCFLGS1
JFCBDLET EQU   JFCFLGS1
JFCRQID  EQU   JFCBSQTY
JFCROUND EQU   JFCBCTRI
JFCALX   EQU   JFCBCTRI
JFCMIXG  EQU   JFCBCTRI
JFCONTIG EQU   JFCBCTRI
JFCRSV29 EQU   JFCBCTRI
JFCBMSGP EQU   JFCBCTRI
JFCBSPAC EQU   JFCBCTRI
JFCRUNIT EQU   JFCBPQTY
JFCBEXAD EQU   JFCBS001+31
JFCBEXTL EQU   JFCBS001+30
@NM00046 EQU   JFCBS001
JFCAVOLS EQU   JFCBVOLS
JFCBNTCS EQU   JFCUCSEG+8
JFCSOWA  EQU   JFCOUTLI+1
JFCSEND  EQU   JFCCPRI
JFCEQUAL EQU   JFCCPRI
JFCRECV  EQU   JFCCPRI
JFCRSV34 EQU   JFCCPRI
JFCRSV33 EQU   JFCCPRI
JFCRSV55 EQU   JFCCPRI
JFCRSV54 EQU   JFCCPRI
JFCRSV53 EQU   JFCCPRI
JFCRSV27 EQU   JFCUCSOP
JFCRSV26 EQU   JFCUCSOP
JFCFCBVR EQU   JFCUCSOP
JFCFCBAL EQU   JFCUCSOP
JFCVER   EQU   JFCUCSOP
JFCRSV25 EQU   JFCUCSOP
JFCFOLD  EQU   JFCUCSOP
JFCBEXTP EQU   JFCUCSOP
JFCUCSID EQU   JFCUCSEG
JFCINTVL EQU   JFCSPPRT+19
JFCDBUFN EQU   JFCRESRV+3
JFCCYLOF EQU   JFCRESRV+2
JFCRKP   EQU   JFCRESRV
JFCPCIR2 EQU   JFCPCI
JFCPCIR1 EQU   JFCPCI
JFCPCIN2 EQU   JFCPCI
JFCPCIN1 EQU   JFCPCI
JFCPCIA2 EQU   JFCPCI
JFCPCIA1 EQU   JFCPCI
JFCPCIX2 EQU   JFCPCI
JFCPCIX1 EQU   JFCPCI
JFCBUFMX EQU   JFCNCP
JFCLRECL EQU   JFCAMSYN
JFCBAXBF EQU   JFCBUFSI
JFCREL   EQU   JFCREORG
JFCRSV22 EQU   JFCDEL
JFCSRCHD EQU   JFCRSV20
JFCOPTQ  EQU   JFCACT
JFCFEED  EQU   JFCIND
JFCCBWU  EQU   JFCEXT
JFCWUMSG EQU   JFCOVER
JFCSDNAM EQU   JFCWVCBD
@NM00045 EQU   JFCRECFM
JFCCHAR  EQU   JFCRECFM
JFCRFS   EQU   JFCRECFM
JFCRFB   EQU   JFCRECFM
JFCRFO   EQU   JFCRCFM
JFCFMREC EQU   JFCRCFM
JFCRSV16 EQU   JFCDSRG2
JFCRSV15 EQU   JFCDSRG2
JFCORGTR EQU   JFCDSRG2
JFCORGAM EQU   JFCDSRG2
JFCRSV13 EQU   JFCDSRG2
JFCORGTQ EQU   JFCDSRG2
JFCORGTX EQU   JFCDSRG2
JFCORGGS EQU   JFCDSRG2
JFCORGU  EQU   JFCDSRG1
JFCORGPO EQU   JFCDSRG1
JFCORGMQ EQU   JFCDSRG1
JFCORGCQ EQU   JFCDSRG1
JFCORGCX EQU   JFCDSRG1
JFCORGDA EQU   JFCDSRG1
JFCORGPS EQU   JFCDSRG1
JFCTRKBL EQU   JFCLIMCT+1
@NM00044 EQU   JFCLIMCT
JFCDEN   EQU   JFCSPPRT+1
JFCPRTSP EQU   JFCSPPRT
JFCONE   EQU   JFCMODE
JFCTWO   EQU   JFCMODE
JFCRSV07 EQU   JFCMODE
JFCRSV06 EQU   JFCMODE
JFCMODER EQU   JFCMODE
JFCMODEO EQU   JFCMODE
JFCEBCD  EQU   JFCMODE
JFCBIN   EQU   JFCMODE
JFCRSV32 EQU   JFCCODE
JFCTTY   EQU   JFCCODE
JFCASCII EQU   JFCCODE
JFCNCR   EQU   JFCCODE
JFCBUR   EQU   JFCCODE
JFCFRI   EQU   JFCCODE
JFCBCD   EQU   JFCCODE
JFCNOCON EQU   JFCCODE
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTHSM   EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
JSCBEND3 EQU   JSCBSEC3+120
JSCRSV52 EQU   JSCBSEC3+116
JSCRSV51 EQU   JSCRSV47+1
JSCRSV50 EQU   JSCRSV47
JSCRSV49 EQU   JSCRSV46+1
JSCRSV48 EQU   JSCRSV46
JSCRSV44 EQU   JSCBSEC3+108
JSCRSV43 EQU   JSCBSEC3+104
JSCRSV42 EQU   JSCBSEC3+100
JSCBASWA EQU   JSCBSEC3+96
JSCBUFPT EQU   JSCBSEC3+92
JSCBACT  EQU   JSCBSEC3+88
JSCBSWSP EQU   JSCBSEC3+87
JSCRSV33 EQU   JSCBSEC3+86
JSCDDNUM EQU   JSCBSEC3+84
JSCRSV53 EQU   JSCBSEC3+82
JSCDDNNO EQU   JSCBSEC3+80
JSCBVATA EQU   JSCBSEC3+76
JSCTMCOR EQU   JSCBSEC3+72
JSCSCTP  EQU   JSCSCT+1
JSCRSV55 EQU   JSCSCT
JSCRSV54 EQU   JSCBSEC3+64
JSCDSABQ EQU   JSCBSEC3+60
JSCBSSIB EQU   JSCBSEC3+56
JSCBFRBA EQU   JSCBSEC3+48
JSCRSV28 EQU   JSCBSEC3+46
JSCBSONO EQU   JSCBSEC3+44
JSCBSUBA EQU   JSCBSUB+1
JSCRSV31 EQU   JSCBSUB
JSCBSMLR EQU   JSCBSEC3+36
JSCBJNLR EQU   JSCBSEC3+32
JSCBJNLA EQU   JSCBJNL+1
JSCBJSBT EQU   JSCBJJSB
JSCBJSBX EQU   JSCBJJSB
JSCBJSBA EQU   JSCBJJSB
JSCBJSBI EQU   JSCBJJSB
@NM00011 EQU   JSCBJJSB
JSCBJNLE EQU   JSCBJJSB
JSCBJNLF EQU   JSCBJJSB
JSCBJNLN EQU   JSCBJJSB
@NM00010 EQU   JSCBSEC3+24
JSCBJRBA EQU   JSCBSEC3+16
JSCBIECB EQU   JSCBSEC3+12
JSCBRV08 EQU   JSCBSEC3+11
JSCBRV07 EQU   JSCBFBYT
JSCBRV06 EQU   JSCBFBYT
JSCBRV05 EQU   JSCBFBYT
JSCBRV04 EQU   JSCBFBYT
JSCBRV03 EQU   JSCBFBYT
JSCBRV02 EQU   JSCBFBYT
JSCBADSP EQU   JSCBFBYT
JSCBRV01 EQU   JSCBFBYT
JSCBTJID EQU   JSCBASID
JSCBPSCB EQU   JSCBSEC3+4
JSCJCTP  EQU   JSCBJCTA
JSCRSV24 EQU   JSCBJCT
JSCBEND2 EQU   JSCBSEC2
PRMWTOID EQU   PRMESTAE+292
PRMNELM  EQU   PRMESTAE+288
PRMDSQF  EQU   PRMESTAE+284
PRMDSQL  EQU   PRMESTAE+280
PRMQDBP  EQU   PRMESTAE+276
PRMQMBP  EQU   PRMESTAE+272
PRMQMBLN EQU   PRMESTAE+268
PRMQMGP  EQU   PRMESTAE+264
PRMUCBP  EQU   PRMESTAE+260
PRMSIOTP EQU   PRMESTAE+256
PRMASID  EQU   PRMESTAE+254
@NM00066 EQU   PRMFUNC
FREECORE EQU   PRMFUNC
DUMPOK   EQU   PRMFUNC
TIOTBLT  EQU   PRMFUNC
DSABCHN  EQU   PRMFUNC
UPDSABCK EQU   PRMFUNC
GENCLNUP EQU   PRMFUNC
@NM00065 EQU   PRMRESC
MLWTO    EQU   PRMRESC
TPQ      EQU   PRMRESC
DSSUNREC EQU   PRMRESC
DSSTAP   EQU   PRMRESC
CHNGQ    EQU   PRMRESC
DDRQ     EQU   PRMRESC
ENQQ4    EQU   PRMRESC
@NM00064 EQU   PRMESTAE
EXTRACAL EQU   FUNCMAP+1
ALCASDSN EQU   ASNMSW
ALCSUBWT EQU   WAITOKSW
ALCATRKM EQU   TRKMSW
ALCNOENQ EQU   NOTIOTNQ
ALCJOBNM EQU   MTRJOBSW
ALCHDMSG EQU   HDRMSGSW
ALCSSMSG EQU   SSEMSGSW
ALCGENER EQU   GENLOKSW
ALCCANCL EQU   CCLMNTSW
ALCOFFDV EQU   OFFDEVSW
ALCMSSTM EQU   MSSTRMSW
ALCWTVOL EQU   VWAITSW
ALCWTUNT EQU   UWAITSW
ALCMSGLV EQU   WRTMSGSW
ALCMOUNT EQU   VOLMNTSW
SIODDSNL EQU   INDMSIOT+173
SIOVDSNL EQU   INDMSIOT+172
SIOVDSNT EQU   INDMSIOT+170
SVOLUNNO EQU   INDMSIOT+168
SIOTJFX  EQU   INDMSIOT+160
SIOTETIO EQU   INDMSIOT+148
SIOTATE  EQU   INDMSIOT+144
SIOTEDLP EQU   INDMSIOT+136
SIOTEDLS EQU   INDMSIOT+132
SCTANAME EQU   INDMSIOT+122
SIOTSSIC EQU   INDMSIOT+120
@NM00063 EQU   INDMSIOT+108
SIOTSSNM EQU   INDMSIOT+104
@NM00062 EQU   SIOTBYT2
SIOTCVOL EQU   SIOTBYT2
SIOTCNEW EQU   SIOTBYT2
SIOTCALC EQU   SIOTBYT2
SIOTGALL EQU   SIOTBYT2
SIOTDMND EQU   SIOTBYT2
SIOTOPUC EQU   INDMSIOT+99
SIOTOUTR EQU   INDMSIOT+97
SIOTOUTC EQU   INDMSIOT+96
SIOTSSWA EQU   INDMSIOT+93
SIOTAUNC EQU   SIOTALTD
SIOTACAT EQU   SIOTALTD
SIOTADEL EQU   SIOTALTD
SIOTAKEP EQU   SIOTALTD
SIOTNPRV EQU   SIOTALTD
SIOJCATS EQU   SIOTALTD
@NM00061 EQU   SIOTALTD
@NM00060 EQU   SIOTALTD
@NM00059 EQU   INDMSIOT+91
SIOTNDSB EQU   INDMSIOT+88
@NM00058 EQU   INDMSIOT+84
SIOTDPCD EQU   INDMSIOT+82
@NM00057 EQU   SIOTBYT4
SIOTRACT EQU   SIOTBYT4
SIOTRACD EQU   SIOTBYT4
SIOTPROT EQU   SIOTBYT4
SCTOUTPN EQU   INDMSIOT+80
SCTOUTNO EQU   INDMSIOT+76
SCTOUTNM EQU   INDMSIOT+68
SIOUCBAD EQU   SCTUTYPE+5
SIOUCNVT EQU   SCTUTYPE+4
SIOUBYT4 EQU   SIOTDEVT+3
@NM00056 EQU   SIOUBYT3
SIO3UREC EQU   SIOUBYT3
SIO3DISP EQU   SIOUBYT3
SIO3DACC EQU   SIOUBYT3
SIO3COMM EQU   SIOUBYT3
SIO3TAPE EQU   SIOUBYT3
SIOUBYT2 EQU   SIOTDEVT+1
SIOUBYT1 EQU   SIOTDEVT
SIOTOMN  EQU   SCTSBYT4
SIOTIPDI EQU   SCTSBYT4
SIOTVAFF EQU   SCTSBYT4
SIOTSTEP EQU   SCTSBYT4
SIOTASCI EQU   SCTSBYT4
@NM00055 EQU   SCTSBYT4
SIOTGDGA EQU   SCTSBYT4
SCTSGDGS EQU   SCTSBYT4
SCTSOLD  EQU   SCTSBYT3
SCTSMOD  EQU   SCTSBYT3
SCTSNEW  EQU   SCTSBYT3
SCTSYSOU EQU   SCTSBYT3
SCTVREF  EQU   SCTSBYT3
SCTALCHK EQU   SCTSBYT3
SCTSYSNE EQU   SCTSBYT3
SCTDSNRF EQU   SCTSBYT3
SCTRECVD EQU   SCTSBYT2
SCTDEFER EQU   SCTSBYT2
SCTLABEL EQU   SCTSBYT2
SCTUNLBD EQU   SCTSBYT2
SCTJOBLB EQU   SCTSBYT2
SCTVOLAF EQU   SCTSBYT2
SIOTCATL EQU   SCTSBYT2
SIOCLUNL EQU   SCTSBYT2
SIOTJSCT EQU   SCTSBYT1
SCTUNAFF EQU   SCTSBYT1
SCTPARLM EQU   SCTSBYT1
SIOTQDSN EQU   SCTSBYT1
SIOTGDSN EQU   SCTSBYT1
SIOTCCAT EQU   SCTSBYT1
SCTSYSIN EQU   SCTSBYT1
SCTDUMMY EQU   SCTSBYT1
SIOTUNCT EQU   SCTSDISP
SIOTCTLG EQU   SCTSDISP
SIOTDLET EQU   SCTSDISP
SIOTKEEP EQU   SCTSDISP
SIOTPASS EQU   SCTSDISP
SIOTPRIV EQU   SCTSDISP
S3400DSP EQU   SCTSDISP
SIOTRETN EQU   SCTSDISP
SIOTVLCT EQU   INDMSIOT+54
SCTNMBUT EQU   INDMSIOT+53
SIOTRTRY EQU   SIOTBYT0
SIOTPUPV EQU   SIOTBYT0
SIOTNOPV EQU   SIOTBYT0
SIOTGIGN EQU   SIOTBYT0
SPVTAMSG EQU   SIOTBYT0
SIOTFUDA EQU   SIOTBYT0
SIOTDYAL EQU   SIOTBYT0
SIOTSSDS EQU   SIOTBYT0
SIOTGIID EQU   INDMSIOT+50
SCTVOLCT EQU   INDMSIOT+49
SCTSPOOL EQU   INDMSIOT+48
SIOTQNAM EQU   SIOTTSTC
SIOTDSNM EQU   SIOTTSTC
SIOTTRKM EQU   SIOTTSTC
SIOTSSMG EQU   SIOTTSTC
SIOTSSGP EQU   SIOTTSTC
@NM00054 EQU   SIOTTSTC
SIOTTERM EQU   SIOTTSTC
SIOTINFC EQU   SIOTTSTC
@NM00053 EQU   SIOTBYT3
SIOTDSID EQU   SIOTBYT3
S3400OFF EQU   SIOTBYT3
SIOTJES3 EQU   SIOTBYT3
SIOCDEVT EQU   SIOTBYT3
SIOALIAS EQU   SIOTBYT3
SCTDDINO EQU   INDMSIOT+44
SIOTDDNT EQU   SIOTBYT1
SIOTDADR EQU   SIOTBYT1
SIODUNAL EQU   SIOTBYT1
SIOVAMDS EQU   SIOTBYT1
SIOTHOLD EQU   SIOTBYT1
SIOTOCKP EQU   SIOTBYT1
SIOPSCNT EQU   INDMSIOT+42
SIOTREFN EQU   INDMSIOT+40
SIOTOTUN EQU   INDMSIOT+39
SIOTVRSB EQU   INDMSIOT+36
@NM00052 EQU   INDMSIOT+35
SCTPJFCB EQU   INDMSIOT+32
@NM00051 EQU   INDMSIOT+31
SCTPSIOT EQU   INDMSIOT+28
SIOTAFID EQU   INDMSIOT+26
SIOTVLSP EQU   INDMSIOT+24
SIODSNTE EQU   INDMSIOT+22
SIOTUNAF EQU   SCTUSADD
SIOTDEST EQU   INDMSIOT+12
SCTDDNAM EQU   INDMSIOT+4
SIOTTYPE EQU   INDMSIOT+3
SIOTDSKA EQU   INDMSIOT
UCBERADR EQU   UCBUCS+12
UCBFCBID EQU   UCBUCS+8
UCBERCNT EQU   UCBUCS+7
UCBRSV51 EQU   UCBUCS+6
UCBFCBPE EQU   UCBFCBOP
UCBRSV49 EQU   UCBFCBOP
UCBRSV48 EQU   UCBFCBOP
UCBRSV47 EQU   UCBFCBOP
UCBRSV46 EQU   UCBFCBOP
UCBRSV45 EQU   UCBFCBOP
UCBRSV44 EQU   UCBFCBOP
UCBFCBO1 EQU   UCBFCBOP
UCBUCSPE EQU   UCBUCSOP
UCBRSV43 EQU   UCBUCSOP
UCBRSV42 EQU   UCBUCSOP
UCBRSV41 EQU   UCBUCSOP
UCBRSV40 EQU   UCBUCSOP
UCBRSV39 EQU   UCBUCSOP
UCBUCSO2 EQU   UCBUCSOP
UCBUCSO1 EQU   UCBUCSOP
UCBUCSID EQU   UCBUCS
UCBMDRBA EQU   UCBMDRBF+1
UCBRV075 EQU   UCBMDRBF
UCBRV074 EQU   UCB3800X+32
UCBIMAGE EQU   UCB3800X+28
UCBFCBNM EQU   UCB3800X+24
UCBCHAR4 EQU   UCB3800X+20
UCBCHAR3 EQU   UCB3800X+16
UCBCHAR2 EQU   UCB3800X+12
UCBCHAR1 EQU   UCB3800X+8
UCBCGMID EQU   UCB3800X+4
UCBBRSTA EQU   UCBACTIV
UCBRV063 EQU   UCBACTIV
UCBRV062 EQU   UCBACTIV
UCBRV061 EQU   UCBACTIV
UCBRV060 EQU   UCBACTIV
UCBRV059 EQU   UCBACTIV
UCBRV058 EQU   UCBACTIV
UCBRV057 EQU   UCBACTIV
UCBRV050 EQU   UCB3800X+2
UCBCGMNO EQU   UCB3800X+1
UCBRV083 EQU   UCBOPTNS
UCBBRSTR EQU   UCBOPTNS
UCBRV056 EQU   UCBOPTNS
UCBRV055 EQU   UCBOPTNS
UCBRV054 EQU   UCBOPTNS
UCBRV053 EQU   UCBOPTNS
UCBRV052 EQU   UCBOPTNS
UCBRV051 EQU   UCBOPTNS
UCBRV073 EQU   UCB3540X+7
UCBRV072 EQU   UCBDKBYT
UCBRV071 EQU   UCBDKBYT
UCBRV070 EQU   UCBDKBYT
UCBRV069 EQU   UCBDKBYT
UCBRV068 EQU   UCBDKBYT
UCBRV067 EQU   UCBDKBYT
UCBVLVER EQU   UCBDKBYT
UCBDKAMX EQU   UCBDKBYT
UCBVLSER EQU   UCB3540X
UCBRDATA EQU   UCBOCR+4
UCBFRID  EQU   UCBOCR
UCBCLN   EQU   UCBMT+14
UCBERG   EQU   UCBMT+12
UCBMS    EQU   UCBMT+11
UCBNB    EQU   UCBMT+10
UCBPW    EQU   UCBMT+9
UCBPR    EQU   UCBMT+8
UCBSIO   EQU   UCBMT+6
UCBTW    EQU   UCBMT+5
UCBTR    EQU   UCBMT+4
UCBTWT   EQU   UCBMT+3
UCBTRT   EQU   UCBMT+2
UCBCTD   EQU   UCBMT
UCBWTOID EQU   UCBCMEXT+17
UCBRV043 EQU   UCBCMEXT+16
UCBASID  EQU   UCBCMEXT+14
UCBMFCNT EQU   UCBCMEXT+12
UCBPMSK  EQU   UCBCMEXT+10
UCBCCWOF EQU   UCBCMEXT+8
UCBRV041 EQU   UCBCMEXT+6
UCBRV036 EQU   UCBFLP1
UCBRV035 EQU   UCBFLP1
UCBERLOG EQU   UCBFLP1
UCBRV033 EQU   UCBFLP1
UCBINHIO EQU   UCBFLP1
UCBNSWAP EQU   UCBFLP1
UCBSHRUP EQU   UCBFLP1
UCBNSRCH EQU   UCBFLP1
UCBSNSCT EQU   UCBCMEXT+4
UCBHPDV  EQU   @NM00050
UCBHALI  EQU   @NM00050
UCBRSV09 EQU   @NM00050
UCBRSV08 EQU   @NM00050
UCBRSV07 EQU   @NM00050
UCBRSV06 EQU   @NM00050
UCBRSV05 EQU   @NM00050
UCBRSV04 EQU   @NM00050
UCBDTI   EQU   UCBCMEXT+2
UCBSTI   EQU   UCBCMEXT+1
UCBETI   EQU   UCBCMEXT
UCBEXTP  EQU   UCBEXTPT+1
UCBDDRSW EQU   UCBFLC
UCBTICBT EQU   UCBFLC
UCBIVRR  EQU   UCBFLC
UCBIVRS  EQU   UCBFLC
UCBITF   EQU   UCBFLC
UCBUDE   EQU   UCBFLC
UCBWAA   EQU   UCBFLC
UCBATTP  EQU   UCBFLC
UCBUNTYP EQU   UCBTBYT4
UCBRSV11 EQU   UCBDVCLS
UCBRSV10 EQU   UCBDVCLS
UCB3CHAR EQU   UCBDVCLS
UCB3UREC EQU   UCBDVCLS
UCB3DISP EQU   UCBDVCLS
UCB3COMM EQU   UCBDVCLS
UCB3TAPE EQU   UCBDVCLS
UCBDVPWR EQU   UCB2OPT7
UCBVLPWR EQU   UCB2OPT6
UCB2OPT5 EQU   UCBTBYT2
UCBRVDEV EQU   UCBRWTAU
UCBRPS   EQU   UCBDUDN2
UCBRR    EQU   UCBDUDN1
UCB2OPT1 EQU   UCBTBYT2
UCB2OPT0 EQU   UCBTBYT2
UCB1FEA7 EQU   UCBTBYT1
UCBD6250 EQU   UCB1FEA6
UCBD1600 EQU   UCB1FEA5
UCB1FEA4 EQU   UCBTBYT1
UCB1FEA3 EQU   UCBTBYT1
UCB1FEA2 EQU   UCBTBYT1
UCB1FEA1 EQU   UCBTBYT1
UCB1FEA0 EQU   UCBTBYT1
UCBNAME  EQU   UCBOB+13
UCBRV029 EQU   UCBWGT
UCBVHRSN EQU   UCBWGT
UCBVORSN EQU   UCBWGT
UCBMTPXP EQU   UCBWGT
UCBREW   EQU   UCBWGT
UCBPUB   EQU   UCBWGT
UCBOUT   EQU   UCBWGT
UCBIN    EQU   UCBWGT
UCBCPU   EQU   UCBOB+11
UCBLCI   EQU   UCBOB+10
UCBCNT   EQU   UCBOB+9
UCBRV017 EQU   UCBCHM1
UCBRV016 EQU   UCBCHM1
UCBRV015 EQU   UCBCHM1
UCBRV014 EQU   UCBCHM1
UCBSPB   EQU   UCBPTH1
UCBPPB   EQU   UCBPTH1
UCBSPA   EQU   UCBPTH0
UCBPPA   EQU   UCBPTH0
UCBSIGP  EQU   UCBFLB
UCBVALPH EQU   UCBFLB
UCBCRHSN EQU   UCBFLB
UCBCRHRV EQU   UCBFLB
UCBRESVH EQU   UCBFLB
UCBSPST  EQU   UCBFLB
UCBASNS  EQU   UCBFLB
UCBIORST EQU   UCBFLB
UCBQISCE EQU   UCBFL1
UCBACTV  EQU   UCBFL1
UCBSAP   EQU   UCBFL1
UCBNOTRC EQU   UCBCUB
UCBPSNS  EQU   UCBFL1
UCBUSING EQU   UCBPST
UCBNOTRD EQU   UCBNRY
UCBBUSYD EQU   UCBBSY
UCBUA    EQU   UCBCHAN+1
UCBCHA   EQU   UCBCHAN
UCBDADI  EQU   UCBSTAT
UCBSYSR  EQU   UCBSTAT
UCBALOC  EQU   UCBSTAT
UCBUNLD  EQU   UCBSTAT
UCBRESV  EQU   UCBSTAT
UCBCHGS  EQU   UCBSTAT
UCBONLI  EQU   UCBSTAT
UCBID    EQU   UCBOB+2
UCBALTPH EQU   UCBFL5
UCBALTCU EQU   UCBFL5
UCBNALOC EQU   UCBFL5
UCBENVRD EQU   UCBFL5
UCBVSDR  EQU   UCBFL5
UCBSASK  EQU   UCBFL5
UCBAMV   EQU   UCBAF
UCBDCC   EQU   UCBFL5
UCBMONT  EQU   UCBJBNR
UCBRV011 EQU   UCBJBNR
UCBMMSGP EQU   UCBJBNR
UCBOLDSM EQU   UCBJBNR
UCBRV003 EQU   UCBJBNR
UCBDUC   EQU   UCBJBNR
UCBJES3  EQU   UCBJBNR
UCBVRDEV EQU   UCBJBNR
UCBCMSEG EQU   UCBOB
UCBPFXND EQU   UCB+512
UCBIOQ   EQU   UCB+508
UCBLOCK  EQU   UCB+504
UCBPXST  EQU   UCB+504
@NM00047 EQU   UCB
JFCRSV05 EQU   JFCEROPT
JFCRSV04 EQU   JFCEROPT
JFCRSV03 EQU   JFCEROPT
JFCRSV02 EQU   JFCEROPT
JFCTOPT  EQU   JFCEROPT
JFCABN   EQU   JFCEROPT
JFCSKP   EQU   JFCEROPT
JFCACC   EQU   JFCEROPT
JFCBUFL  EQU   JFCAMPTR+2
JFCFWORD EQU   JFCBFTEK
JFCDWORD EQU   JFCBFTEK
JFCHIER1 EQU   JFCBFTEK
JFCDYN   EQU   JFCBFTEK
JFCEXC   EQU   JFCBFTEK
JFCBBFTR EQU   JFCBBFTA
JFCSIM   EQU   JFCBBFTA
JFCHIER  EQU   JFCBFTEK
JFCBFOUT EQU   JFCBUFNO
JFCBUFIN EQU   JFCBUFNO
JFCTEMP  EQU   JFCBIND2
JFCREQ   EQU   JFCBIND2
JFCENT   EQU   JFCBIND2
JFCSHARE EQU   JFCBIND2
JFCSECUR EQU   JFCBIND2
JFCDISP  EQU   JFCBIND2
JFCPDS   EQU   JFCBIND1
JFCGDG   EQU   JFCBIND1
JFCADDED EQU   JFCBIND1
JFCLOC   EQU   JFCBIND1
JFCRLSE  EQU   JFCBIND1
JFCBXPDT EQU   INFMJFCB+83
JFCBCRDT EQU   INFMJFCB+80
JFCBOPS2 EQU   JFCBMASK+7
JFCRCTLG EQU   JFCBFLG2
JFCBBUFF EQU   JFCBFLG2
JFCTRACE EQU   JFCBFLG2
JFCSDRPS EQU   JFCBFLG2
JFCMODNW EQU   JFCBFLG2
JFCNRPS  EQU   JFCDEFER
JFCOUTOP EQU   JFCBFLG2
JFCINOP  EQU   JFCBFLG2
JFCBPWBP EQU   JFCOPEN
@NM00043 EQU   JFCOPEN
JFCDUAL  EQU   JFCBFLG1
JFCSLDES EQU   JFCBFLG1
JFCSLCRE EQU   JFCBFLG1
JFCSTAND EQU   JFCBFLG1
JFCBOPS1 EQU   JFCBMASK
JFCBVLSQ EQU   INFMJFCB+70
JFCRSV31 EQU   JFCFUNC
JFCFNCBT EQU   JFCFUNC
JFCFNCBX EQU   JFCFUNC
JFCFNCBD EQU   JFCFUNC
JFCFNCBW EQU   JFCFUNC
JFCFNCBP EQU   JFCFUNC
JFCFNCBR EQU   JFCFUNC
JFCFNCBI EQU   JFCFUNC
JFCBFOFL EQU   JFCBUFOF
JFCNL    EQU   JFCBLTYP
JFCSL    EQU   JFCBLTYP
JFCNSL   EQU   JFCBLTYP
JFCSUL   EQU   JFCBLTYP
JFCBLP   EQU   JFCBLTYP
JFCBLTM  EQU   JFCBLTYP
JFCBAL   EQU   JFCBLTYP
JFCRSV38 EQU   JFCBLTYP
JFCNLREC EQU   INFMJFCB+62
JFCBADBF EQU   INFMJFCB+60
JFCAMSTR EQU   JFCBFRID+2
JFCAMCRO EQU   JFCBFRID
JFCBDSCB EQU   INFMJFCB+53
JFCPAT   EQU   JFCBTSDM
JFCNDCB  EQU   JFCBTSDM
JFCNDSCB EQU   JFCBTSDM
JFCNWRIT EQU   JFCBTSDM
JFCTTR   EQU   JFCBTSDM
JFCSDS   EQU   JFCBTSDM
JFCVSL   EQU   JFCBTSDM
JFCCAT   EQU   JFCBTSDM
JFCIPLTX EQU   JFCBELNM
JFCBQNAM EQU   JFCBDSNM
@NM00042 EQU   VMVUSER
@NM00041 EQU   VMVMINFO+1
@NM00040 EQU   VMVACTON
VMVRTAIN EQU   VMVACTON
VMVKEEP  EQU   VMVACTON
VMVJSNMP EQU   VMVRQBLK+32
VMVJBNMP EQU   VMVRQBLK+24
@NM00039 EQU   VMVRQBLK+8
VMVOPTB4 EQU   VMVFNMAP+3
@NM00038 EQU   VMVOPTB3
VMVNUMSG EQU   VMVOPTB3
VMVNSPVT EQU   VMVOPTB2
VMVNSLTP EQU   VMVOPTB2
VMVSLTAP EQU   VMVOPTB2
VMVNLTAP EQU   VMVOPTB2
VMVALTAP EQU   VMVOPTB2
VMVSTRG  EQU   VMVOPTB2
VMVPUBLC EQU   VMVOPTB2
VMVPRIVT EQU   VMVOPTB2
VMVREWND EQU   VMVOPTB1
VMVUCB   EQU   VMVOPTB1
@NM00037 EQU   VUGRLENT+5
@NM00036 EQU   VUGRLFLG
VUGRALCD EQU   VUGRLFLG
VUGRLIDS EQU   VUGRLENT
VUCBS    EQU   VUPOOL+4
VUPOOL#  EQU   VUPOOL
VOLALGTP EQU   VOLUNTAB+12
VOLUNTID EQU   VOLUNTAB+10
VURCVYPR EQU   VOLSTATD
VUVLUNIQ EQU   VOLSTATD
VUDMUNIQ EQU   VOLSTATD
VUUNALSW EQU   VOLSTATD
VUDMNDAL EQU   VOLSTATD
VUDMNDOF EQU   VOLSTATD
VUREALOC EQU   VOLSTATD
VUMUGDON EQU   VOLSTATD
@NM00035 EQU   VOLSTATC
@NM00034 EQU   VOLSTATC
VURECVRY EQU   VOLSTATC
VOLURREQ EQU   VOLSTATC
VOLGRREQ EQU   VOLSTATC
VOLDAREQ EQU   VOLSTATC
VOLCOREQ EQU   VOLSTATC
VOLTAREQ EQU   VOLSTATC
VUAFFWRK EQU   VOLSTATB
VUVINELG EQU   VOLSTATB
VUDADSME EQU   VOLSTATB
VUDNALOC EQU   VOLSTATB
VUPROCED EQU   VOLSTATB
VDEVREQD EQU   VOLSTATB
VOLMNTD  EQU   VOLSTATB
VOLALOC  EQU   VOLSTATB
VOLDEFER EQU   VOLSTATA
VOLRESVE EQU   VOLSTATA
VOLSTG   EQU   VOLSTATA
VOLSPEC  EQU   VOLSTATA
VOLPRV   EQU   VOLSTATA
VOLPUB   EQU   VOLSTATA
CMOSYOUT EQU   CMUNRB+13
CMOUNCAT EQU   CMODISP
CMOCATLG EQU   CMODISP
CMOKEEP  EQU   CMODISP
@NM00033 EQU   CMODISP
@NM00032 EQU   CMRBBYT4
@NM00031 EQU   CMRBBYT4
CMNODEN  EQU   CMRBBYT4
CMSSERR  EQU   CMRBBYT4
CMINTERR EQU   CMRBBYT4
CMSSIERR EQU   CMRBBYT4
CMCATERR EQU   CMRBBYT4
CMSCRERR EQU   CMRBBYT4
@NM00030 EQU   CMRBBYT3
CMSSKEEP EQU   CMRBBYT3
CMNOHOLD EQU   CMRBBYT3
CMOVSYOT EQU   CMRBBYT3
CMWAIT   EQU   CMRBBYT3
CMDYNUNA EQU   CMRBBYT3
CMHOLD   EQU   CMRBBYT3
CMDEL    EQU   CMRBBYT3
@NM00029 EQU   CMRBBYT2
@NM00028 EQU   CMRBBYT2
@NM00027 EQU   CMRBBYT2
CMSETPRV EQU   CMRBBYT2
CMCKDAVL EQU   CMRBBYT2
CMCKAVOL EQU   CMRBBYT2
CMCHKUN  EQU   CMRBBYT2
CMNODSR  EQU   CMRBBYT2
@NM00026 EQU   CMRBBYT1
CMINVUCB EQU   CMRBBYT1
CMOUSRID EQU   CMRBBYT1
CMCNDISP EQU   CMRBBYT1
CMNMDISP EQU   CMRBBYT1
CMNODISP EQU   CMRBBYT1
CMNRBPTR EQU   CMUNRB
@NM00025 EQU   CMFMBYT4
@NM00024 EQU   CMFMBYT4
@NM00023 EQU   CMFMBYT4
@NM00022 EQU   CMFMBYT4
@NM00021 EQU   CMFMBYT4
@NM00020 EQU   CMFMBYT4
CMALSTCT EQU   CMFMBYT4
CMLSTCJS EQU   CMFMBYT4
CMJES3   EQU   CMFMBYT3
@NM00019 EQU   CMFMBYT3
@NM00018 EQU   CMFMBYT3
CMSPSCR  EQU   CMFMBYT3
CMPUBPRV EQU   CMFMBYT3
CMSCRVL1 EQU   CMFMBYT3
CMDSRALL EQU   CMFMBYT3
CMNERMSG EQU   CMFMBYT2
CMRDDENT EQU   CMFMBYT2
CMGENDEQ EQU   CMFMBYT2
CMCHATTR EQU   CMFMBYT2
CMFDSABS EQU   CMFMBYT1
CMVLRLSE EQU   CMFMBYT1
CMUNUNIT EQU   CMFMBYT1
CMDSRLSE EQU   CMFMBYT1
CMDPCATS EQU   CMFMBYT1
CMMNSTAT EQU   CMFMBYT1
CMDMSGS  EQU   CMFMBYT1
RCVTEXTA EQU   RCVT+173
RCVTRID0 EQU   RCVT+168
RCVTRCXP EQU   RCVT+164
RCVTRIXP EQU   RCVT+160
RCVTRAU0 EQU   RCVT+156
RCVTPINV EQU   RCVT+155
@NM00017 EQU   RCVTEROP
RCVTSAUD EQU   RCVTEROP
RCVTAVIO EQU   RCVTEROP
RCVTTUAC EQU   RCVTEROP
RCVTTERP EQU   RCVTEROP
RCVTSHR  EQU   RCVTFLGS
RCVTRDHD EQU   RCVTFLGS
RCVTROFF EQU   RCVTFLGS
RCVTAXTA EQU   RCVT+152
RCVTATER EQU   RCVTAUOP
RCVTATAP EQU   RCVTAUOP
RCVTADAS EQU   RCVTAUOP
RCVTADAT EQU   RCVTAUOP
RCVTAUSE EQU   RCVTAUOP
RCVTAGRO EQU   RCVTAUOP
@NM00016 EQU   RCVTAUOP
@NM00015 EQU   RCVTSTA1
RCVTDASD EQU   RCVTSTA1
RCVTTAPE EQU   RCVTSTA1
RCVTUVOL EQU   RCVT+144
RCVTUADS EQU   RCVT+100
RCVTDSN  EQU   RCVT+56
RCVTNREC EQU   RCVT+54
@NM00014 EQU   RCVTSTAT
RCVTNTMS EQU   RCVTSTAT
RCVTNDVS EQU   RCVTSTAT
RCVTNTVS EQU   RCVTSTAT
RCVTNDSS EQU   RCVTSTAT
RCVTNLS  EQU   RCVTSTAT
RCVTRNA  EQU   RCVTSTAT
RCVTDSNL EQU   RCVT+52
RCVTISTL EQU   RCVT+48
RCVTBAM  EQU   RCVT+44
RCVTXLEN EQU   RCVT+40
RCVTRUCB EQU   RCVT+36
RCVTRDX  EQU   RCVT+32
RCVTRCX  EQU   RCVT+28
RCVTRIX  EQU   RCVT+24
RCVTHDR  EQU   RCVT+20
RCVTTEMP EQU   RCVT+16
RCVTINDX EQU   RCVT+12
RCVTDEB  EQU   RCVT+8
RCVTDCB  EQU   RCVT+4
RCVTID   EQU   RCVT
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00013 EQU   CVTFIX+248
@NM00012 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTCCVT  EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
JSCBCSCB EQU   JSCBSEC1+68
JSCBPMG  EQU   JSCBWTP+2
JSCBWTSP EQU   JSCBWTP+1
JSCRSV23 EQU   JSCBWTFG
JSCRSV22 EQU   JSCBWTFG
JSCRSV21 EQU   JSCBWTFG
JSCRSV20 EQU   JSCBWTFG
JSCRSV19 EQU   JSCBWTFG
JSCRSV18 EQU   JSCBWTFG
JSCBRET  EQU   JSCBWTFG
JSCBIOFG EQU   JSCBWTFG
@NM00009 EQU   JSCBSEC1+60
JSCBQMPI EQU   JSCBSEC1+56
JSCBPMSG EQU   JSCBSWT1
JSCRSV16 EQU   JSCBSWT1
JSCRSV15 EQU   JSCBSWT1
JSCRSV14 EQU   JSCBSWT1
JSCRSV13 EQU   JSCBSWT1
JSCRSV12 EQU   JSCBSWT1
JSCRSV11 EQU   JSCBSWT1
JSCBPASS EQU   JSCBSWT1
JSCBTTTR EQU   JSCBSEC1+52
JSCRSV10 EQU   JSCBSEC1+49
JSCBAUTH EQU   JSCBOPTS
JSCSIOTS EQU   JSCBOPTS
JSCRSV08 EQU   JSCBOPTS
JSCRSV07 EQU   JSCBOPTS
JSCRSV06 EQU   JSCBOPTS
JSCBLONG EQU   JSCBOPTS
JSCRSV05 EQU   JSCBOPTS
JSCRSV04 EQU   JSCBOPTS
JSCBSECB EQU   JSCBSEC1+44
JSCRSV03 EQU   JSCBSEC1+41
JSCBSTEP EQU   JSCBSEC1+40
JSCBDCBA EQU   JSCBDCB+1
JSCRSV02 EQU   JSCBDCB
JSCBID   EQU   JSCBSEC1+32
JSCBDBTB EQU   JSCBSEC1+28
JSCBIJSC EQU   JSCBSEC1+24
JSCBPCC  EQU   JSCBSEC1+16
JSCBTCP  EQU   JSCBSEC1+12
JSCBSHR  EQU   JSCBSEC1+8
JSCHPCEA EQU   JSCHPCE+1
JSCRSV32 EQU   JSCHPCE
JSCRSV01 EQU   JSCBSEC1
@NM00008 EQU   IEZJSCB
AQMQBPTR EQU   AQMPARAM+24
AQMPFLG  EQU   AQMNORMP
AQMCANCP EQU   AQMPARAM+16
AQMLENGT EQU   AQMPARAM+12
AQMASID  EQU   AQMPARAM+8
AQMMASKP EQU   AQMPARAM+4
AQMQCODE EQU   AQMPARAM+2
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00196 EQU   @RC00186
@RC00405 EQU   @RC00402
@RC00207 EQU   @RC00196
@RC00416 EQU   @RC00405
@ENDDATA EQU   *
         END   IEFAB492,(C'PLS1235',0701,78089)
