         TITLE 'IEFAB495 - MOUNT CONTROL RTN                           *
                        '
IEFAB495 CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(24)                                          01S0001
         DC    C'IEFAB495 78150  UZ19122 '                      01S0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01S0001
         BALR  @10,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@10                                      01S0001
         L     @00,@SIZDATD                                     01S0001
         MODESET EXTKEY=SCHED,SAVEKEY=(2)
         GSPACE   R,LV=(0)
         LR    @09,@01                                          01S0001
         USING @DATD,@09                                        01S0001
         ST    @13,@SA00001+4                                   01S0001
         STC   @02,@OLDKEY                                      01S0001
         MODESET KEYADDR=(2)
         LM    @00,@02,20(@13)                                  01S0001
         ST    @09,8(,@13)                                      01S0001
         LR    @13,@09                                          01S0001
         MODESET EXTKEY=ZERO
         MVC   @PC00001(20),0(@01)                              01S0001
         MODESET EXTKEY=SCHED
JSCBDISP EQU 188
JSCBAOS1 EQU  72
JSCBAOS2 EQU 192
*RETCODE = SUCCESS;                    /*INITIALIZE RETURN CODE      */
         SLR   RETCODE,RETCODE                                  01S0086
*VMVREQBP = REQUESTP;                  /*PTR TO FIRST REQUEST BLOCK  */
         L     @12,@PC00001                                     01S0087
         MVC   VMVREQBP(4),REQUESTP(@12)                        01S0087
*IF DOMCNT ^= ZERO THEN                /*ANY DA OR WTOR REQUESTS. IF
*                                        YES MOUNT CONTROL BLOCKS
*                                        WILL HAVE TO BE OBTAINED    */
         L     @12,@PC00001+12                                  01S0088
         ICM   @11,15,DOMCNT(@12)                               01S0088
         BZ    @RF00088                                         01S0088
*  DO;                                                          01S0089
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - B495MSPC                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - OBTAIN INITIALIZE MOUNT CONTROL BLOCKS        */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS SEGMENT IS INVOKED TO CALCULATE AND OBTAIN THE SPACE      */
*/*   NEEDED FOR MOUNT CONTROL BLOCKS AND TO CONTROL THE ADDITION    */
*/*   OF THESE BLOCKS TO THE MVCA CHAIN.                             */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*   THE MVCA CHAIN PROCESSOR(IEFAB498) IS INVOKED TO SEARCH THE    */
*/*   MVCA CHAIN FOR AN MVCA WITH THIS TASK'S ASID.                  */
*/*   IF A MATCH IS NOT FOUND A NEW MVCA,MVCAX AND MOUNT ENTRY ARE   */
*/*   OBTAINED AND THE MVCA CHAIN PROCESSOR IS INVOKED TO ADD THE    */
*/*   NEW BLOCKS TO THE MVCA CHAIN.                                  */
*/*   IF AN ASID MATCH IS FOUND BY THE MVCA CHAIN PROCESSOR WHEN IT  */
*/*   SEARCHES THE MVCA CHAIN THEN IT WILL RETURN A POINTER TO THE   */
*/*   MVCA CONTAINING THE MATCHING ASID.IN THIS CASE THIS SEGMENT    */
*/*   WILL OBTAIN ONLY A NEW MOUNT ENTRY AND CHAIN IT INTO THE       */
*/*   EXISTING MVCA/MVCAX CONTROL BLOCKS                             */
*/*                                                                  */
*/* ENTRY POINT - (INLINE SUBROUTINE - ENTERED AT TOP)               */
*/*                                                                  */
*/*   PURPOSE - TO OBTAIN/INITIALIZE MOUNT CONTROL BLOCKS            */
*/*                                                                  */
*/* INPUT -                                                          */
*/*   MOUNTCNT - COUNT OF MOUNT REQUESTS                             */
*/*   ASID - ADDRESS SPACE IDENTIFIER                                */
*/*                                                                  */
*/* EXIT - NORMAL - (IN-LINE SUBROUTINE).                            */
*/*                                                                  */
*/*   CONDITION - FUNCTION COMPLETED.THAT IS SPACE FOR MOUNT CONTROL */
*/*               BLOCKS OBTAINED AND BLOCKS CHAINED IN.             */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*     MVCA - IF ASID NOT ON CHAIN                                  */
*/*     MVCAX - IF ASID NOT ON CHAIN                                 */
*/*     MOUNT ENTRY                                                  */
*/*                                                                  */
*/*   RETURN CODES - NONE                                            */
*/*                                                                  */
*/* EXIT - ERROR - (IN-LINE SUBROUTINE).                             */
*/*                                                                  */
*/*   CONDITION - GETMAIN ERROR                                      */
*/*                                                                  */
*/*   OUTPUT - NONE                                                  */
*/*                                                                  */
*/*   RETURN CODES -                                                 */
*/*     RETCODE - 4                                                  */
*/*                                                                  */
*/********************************************************************/
*PARMAREA = PARMAREA && PARMAREA;      /*CLEAR PARM AREA             */
         XC    PARMAREA(8),PARMAREA                             02S0090
*SRCHINDC = ON;                        /*INDICATE SEARCH MVCA CHAIN  */
         OI    SRCHINDC,B'00100000'                             02S0091
*INPTASID = ASID;                      /*ASSIGN ASID                 */
         L     @11,@PC00001+4                                   02S0092
         MVC   INPTASID(2),ASID(@11)                            02S0092
*PARMPTR = ADDR(PARMAREA);             /*PARAMETER AREA              */
         LA    @11,PARMAREA                                     02S0093
         ST    @11,PARMPTR                                      02S0093
*CALL IEFAB498(PARMPTR,VMVEXITP);      /*CALL MVCA CHAIN PROCESSOR
*                                        TO SEARCH FOR ASID          */
         LA    @11,PARMPTR                                      02S0094
         ST    @11,@AL00001                                     02S0094
         L     @11,@PC00001+16                                  02S0094
         ST    @11,@AL00001+4                                   02S0094
         L     @15,@CV02458                                     02S0094
         LA    @01,@AL00001                                     02S0094
         BALR  @14,@15                                          02S0094
*RETURNC = REG15;                      /*PICK UP RETURN CODE         */
         STH   REG15,RETURNC                                    02S0095
*GETLENTH = LENGTH(MTENBASE)           /*LENGTH MOUNT ENTRY BASE     */
*      + ((LENGTH(MTDEVENT)            /*PLUS LEN DEVICE ENTRIES     */
*      + LENGTH(MTDOMIDS))             /*PLUS LENGTH DOM ENTRIES     */
*        *  DOMCNT);                   /*TIMES NO. OF DOM ENTRIES    */
         L     @11,@PC00001+12                                  02S0096
         L     GETLENTH,DOMCNT(,@11)                            02S0096
         SLA   GETLENTH,4                                       02S0096
         AH    GETLENTH,@CH00170                                02S0096
*IF RETURNC = NOMATCH THEN             /*IF NO MVCAX FOR THIS ASID   */
         LH    @11,RETURNC                                      02S0097
         CH    @11,@CH01558                                     02S0097
         BNE   @RF00097                                         02S0097
*  DO;                                                          02S0098
*    GETLENTH = GETLENTH + LENGTH(MVCAX); /*ADD SPACE FOR MVCAX      */
         AH    GETLENTH,@CH00176                                02S0099
*  END;                                                         02S0100
*ELSE;                                 /*MVCAX EXISTS FOR THIS TASK  */
@RF00097 DS    0H                                               02S0102
* /* ?GETSTORG (SUBP230,GETLENTH,SPACEADD);*/                   02S0102
*   /* DEFINITIONS OF GETMAIN PARMS */                          02S0102
*   DCL                                                         02S0102
*     GTSTR0   FIXED(31) REG(0),/*GTMN PARM REG*/               02S0102
*     GTSTR1   FIXED(31) REG(1),/*GTMN PARM REG*/               02S0102
*     GTSTR2   PTR(31)   REG(2),/*GTMN PARM REG*/               02S0102
*     GTSTR15  FIXED(31) REG(15),/*GTMN RET COD*/               02S0102
*     GTSTRTCD FIXED(31); /* GETMAIN RTN CODE  */               02S0102
*   DCL                                                         02S0103
*     GTSTR3   FIXED(31) REG(3),/* CLEARING REG*/               02S0103
*     GTSTR4   FIXED(31) REG(4),/* CLEARING REG*/               02S0103
*     GTSTR5   FIXED(31) REG(5),/* CLEARING REG*/               02S0103
*     GTSTR6   FIXED(31) REG(6),/* CLEARING REG*/               02S0103
*     GTSTR7   FIXED(31) REG(7),/* CLEARING REG*/               02S0103
*     GTSTR8   FIXED(31) REG(8),/* CLEARING REG*/               02S0103
*     GTSTZERO FIXED(31) INIT(0),                               02S0103
*     GTST253  FIXED(31) CONSTANT(253);                         02S0103
*   RFY (GTSTR0,GTSTR1,GTSTR2) RSTD; /*SAVE RGS*/               02S0104
*   GTSTR0 = GETLENTH; /* SET AMOUNT*/                          02S0105
         LR    GTSTR0,GETLENTH                                  02S0105
*   GTSTR2 = SUBP230; /* SET SUBPOOL*/                          02S0106
         LA    GTSTR2,230                                       02S0106
*   GENERATE CODE;                                              02S0107
     GETMAIN RC,LV=(0),SP=(2)  DO GETMAIN
*   GTSTRTCD = GTSTR15; /* SAVE GETMAIN RET COD*/               02S0108
         ST    GTSTR15,GTSTRTCD                                 02S0108
*   SPACEADD = GTSTR1; /* ADDR OF GOTN STORG*/                  02S0109
         LR    SPACEADD,GTSTR1                                  02S0109
*   RFY (GTSTR0,GTSTR1,GTSTR2) UNRSTD; /*RLSE */                02S0110
*   IF GTSTRTCD = 0 THEN /*GETMAIN SUCCESSFUL? */               02S0111
         L     @08,GTSTRTCD                                     02S0111
         LTR   @08,@08                                          02S0111
         BNZ   @RF00111                                         02S0111
*     DO;               /* YES, CLEAR STORAGE.*/                02S0112
*       RFY (GTSTR2,GTSTR4,GTSTR5,GTSTR6,                       02S0113
*                          GTSTR7,GTSTR8) RSTD;                 02S0113
*       GTSTR4 = SPACEADD; /*STORG PTR*/                        02S0114
         LR    GTSTR4,SPACEADD                                  02S0114
*       GTSTR5 = GETLENTH; /*STORG AMNT*/                       02S0115
         LR    GTSTR5,GETLENTH                                  02S0115
*       GTSTR7 = '00000000'X; /*PAD CHAR & LNTH*/               02S0116
         SLR   GTSTR7,GTSTR7                                    02S0116
*       IF SUBP230 = GTST253 THEN                               02S0117
         B     @RF00117                                         02S0117
*      GEN                                                      02S0118
*   (MODESET KEYADDR=GTSTZERO,SAVEKEY=(2),WORKREG=8);           02S0118
         MODESET KEYADDR=GTSTZERO,SAVEKEY=(2),WORKREG=8
*       GEN REFS(GTSTR4,GTSTR6);                                02S0119
@RF00117 DS    0H                                               02S0119
          MVCL  GTSTR4,GTSTR6 CLEAR GOTTEN STORG
*       IF SUBP230 = GTST253 THEN                               02S0120
         B     @RF00120                                         02S0120
*         GEN (MODESET KEYADDR=(2));                            02S0121
         MODESET KEYADDR=(2)
*       RFY (GTSTR2,GTSTR4,GTSTR5,GTSTR6,                       02S0122
*                          GTSTR7,GTSTR8) UNRSTD;               02S0122
@RF00120 DS    0H                                               02S0123
*     END;       /* STORAGE CLEARING COMPLETED */               02S0123
*   ELSE                                                        02S0124
*   SPACEADD= 0;   /* CLEAR RETURN ADDR. */                     02S0124
         B     @RC00111                                         02S0124
@RF00111 SLR   SPACEADD,SPACEADD                                02S0124
*   GTSTR15 = GTSTRTCD;    /* GTMN RETURN CODE */               02S0125
@RC00111 L     GTSTR15,GTSTRTCD                                 02S0125
*                                      /* RESTORE LIST PRINT STATUS  */
*/*GET SPACE                   */                               02S0126
*RETCODE = REG15;                      /*SAVE RETURN CODE            */
         LR    RETCODE,REG15                                    02S0126
*IF RETCODE = SUCCESS THEN             /*WAS GETMAIN SUCCESSFUL ?    */
         LTR   RETCODE,RETCODE                                  02S0127
         BNZ   @RF00127                                         02S0127
*  DO;                                                          02S0128
*    IF RETURNC = NOMATCH THEN         /*IF  NO MVCA FOR THIS ASID   */
         CLC   RETURNC(2),@CH01558                              02S0129
         BNE   @RF00129                                         02S0129
*      DO;                                                      02S0130
*        GETLENTH = LENGTH(MVCA);      /*SIZE OF MVCA                */
         LA    GETLENTH,16                                      02S0131
*         /* ?GETSTORG (SUBPSQA,GETLENTH,MVCAPTR);*/            02S0132
*           RFY (GTSTR0,GTSTR1,GTSTR2) RSTD; /*SAVE RGS*/       02S0132
*           GTSTR0 = GETLENTH; /* SET AMOUNT*/                  02S0133
         LR    GTSTR0,GETLENTH                                  02S0133
*           GTSTR2 = SUBPSQA; /* SET SUBPOOL*/                  02S0134
         LA    GTSTR2,241                                       02S0134
*           GENERATE CODE;                                      02S0135
             GETMAIN RC,LV=(0),SP=(2)  DO GETMAIN
*           GTSTRTCD = GTSTR15; /* SAVE GETMAIN RET COD*/       02S0136
         ST    GTSTR15,GTSTRTCD                                 02S0136
*           MVCAPTR = GTSTR1; /* ADDR OF GOTN STORG*/           02S0137
         ST    GTSTR1,MVCAPTR                                   02S0137
*           RFY (GTSTR0,GTSTR1,GTSTR2) UNRSTD; /*RLSE */        02S0138
*           IF GTSTRTCD = 0 THEN /*GETMAIN SUCCESSFUL? */       02S0139
         L     @08,GTSTRTCD                                     02S0139
         LTR   @08,@08                                          02S0139
         BNZ   @RF00139                                         02S0139
*             DO;               /* YES, CLEAR STORAGE.*/        02S0140
*               RFY (GTSTR2,GTSTR4,GTSTR5,GTSTR6,               02S0141
*                                  GTSTR7,GTSTR8) RSTD;         02S0141
*               GTSTR4 = MVCAPTR; /*STORG PTR*/                 02S0142
         L     @03,MVCAPTR                                      02S0142
         LR    GTSTR4,@03                                       02S0142
*               GTSTR5 = GETLENTH; /*STORG AMNT*/               02S0143
         LR    GTSTR5,GETLENTH                                  02S0143
*               GTSTR7 = '00000000'X; /*PAD CHAR & LNTH*/       02S0144
         SLR   GTSTR7,GTSTR7                                    02S0144
*               IF SUBPSQA = GTST253 THEN                       02S0145
         B     @RF00145                                         02S0145
*              GEN                                              02S0146
*           (MODESET KEYADDR=GTSTZERO,SAVEKEY=(2),WORKREG=8);   02S0146
         MODESET KEYADDR=GTSTZERO,SAVEKEY=(2),WORKREG=8
*               GEN REFS(GTSTR4,GTSTR6);                        02S0147
@RF00145 DS    0H                                               02S0147
                  MVCL  GTSTR4,GTSTR6 CLEAR GOTTEN STORG
*               IF SUBPSQA = GTST253 THEN                       02S0148
         B     @RF00148                                         02S0148
*                 GEN (MODESET KEYADDR=(2));                    02S0149
         MODESET KEYADDR=(2)
*               RFY (GTSTR2,GTSTR4,GTSTR5,GTSTR6,               02S0150
*                                  GTSTR7,GTSTR8) UNRSTD;       02S0150
@RF00148 DS    0H                                               02S0151
*             END;       /* STORAGE CLEARING COMPLETED */       02S0151
*           ELSE                                                02S0152
*           MVCAPTR= 0;   /* CLEAR RETURN ADDR. */              02S0152
         B     @RC00139                                         02S0152
@RF00139 SLR   @08,@08                                          02S0152
         ST    @08,MVCAPTR                                      02S0152
*           GTSTR15 = GTSTRTCD;    /* GTMN RETURN CODE */       02S0153
@RC00139 L     GTSTR15,GTSTRTCD                                 02S0153
*                                      /* RESTORE LIST PRINT STATUS  */
*/*GET SPACE MVCA       */                                      02S0154
*        RETCODE = REG15;              /*SAVE RETURN CODE            */
         LR    RETCODE,REG15                                    02S0154
*        IF RETCODE = SUCCESS THEN     /*WAS GETMAIN SUCCESSFUL      */
         LTR   RETCODE,RETCODE                                  02S0155
         BNZ   @RF00155                                         02S0155
*          DO;                                                  02S0156
*            PARMAREA = PARMAREA && PARMAREA; /*CLEAR PARM AREA      */
         XC    PARMAREA(8),PARMAREA                             02S0157
*            MVCAMPTR = MVCAPTR;       /*PUT MVCA PTR IN PARMLIST    */
         L     @12,MVCAPTR                                      02S0158
         ST    @12,MVCAMPTR                                     02S0158
*            ADDINDC = ON;             /*INDICATE ADD MVCA           */
         OI    ADDINDC,B'10000000'                              02S0159
*            MVCAASID = ASID;          /*ASSIGN ASID                 */
         L     @08,@PC00001+4                                   02S0160
         MVC   MVCAASID(2,@12),ASID(@08)                        02S0160
*            MVCAXPTR = SPACEADD;      /*PTR TO MVCAX                */
         ST    SPACEADD,MVCAXPTR(,@12)                          02S0161
*            MVENTRYP = SPACEADD + LENGTH(MVCAX); /*PTR TO MNT ENTRY */
         L     @12,MVCAPTR                                      02S0162
         L     @12,MVCAXPTR(,@12)                               02S0162
         LA    @08,24                                           02S0162
         ALR   @08,SPACEADD                                     02S0162
         ST    @08,MVENTRYP(,@12)                               02S0162
*            MTENTPTR = MVENTRYP;      /*PROVIDE POINTER  NEW ENTRY  */
         ST    @08,MTENTPTR                                     02S0163
*            CALL IEFAB498(PARMPTR,VMVEXITP); /*CALL MVCA CHAIN PROC.
*                                        ADD MVCA,MVCAX,MOUNT ENTRY  */
         LA    @12,PARMPTR                                      02S0164
         ST    @12,@AL00001                                     02S0164
         L     @12,@PC00001+16                                  02S0164
         ST    @12,@AL00001+4                                   02S0164
         L     @15,@CV02458                                     02S0164
         LA    @01,@AL00001                                     02S0164
         BALR  @14,@15                                          02S0164
*          END;                                                 02S0165
*        ELSE                          /*MVCA GETMAIN FAILED         */
*          DO;                                                  02S0166
         B     @RC00155                                         02S0166
@RF00155 DS    0H                                               02S0167
*            RFY (REG0,REG1) RSTD;                              02S0167
*            REG1 = SPACEADD;          /*ADDR OF MVCAX & MT. ENTRY   */
         LR    REG1,SPACEADD                                    02S0168
*            REG0 = GETLENTH;          /*LNTH OF MVCAX & MT. ENTRY   */
         LR    REG0,GETLENTH                                    02S0169
*            REG0 = REG0 | SUBPL230;   /* FREE FROM SUBPOOL 230.     */
         O     REG0,@CF01645                                    02S0170
*            GEN(FREEMAIN R,LV=(0),A=(1)); /*FREE SPACE              */
         FREEMAIN R,LV=(0),A=(1)
*            RFY (REG0,REG1) UNRSTD;                            02S0172
*          END;                                                 02S0173
*      END;                                                     02S0174
*    ELSE                              /*MVCA/MVCAX EXIST            */
*      DO;                                                      02S0175
         B     @RC00129                                         02S0175
@RF00129 DS    0H                                               02S0176
*        MVCAPTR = MVCAMPTR;           /*PTR TO MVCA FOR THIS TASK   */
         L     @12,MVCAMPTR                                     02S0176
         ST    @12,MVCAPTR                                      02S0176
*        MTENTPTR = MVENTRYP;          /*PTR TO FIRST MOUNT ENTRY    */
         L     @12,MVCAXPTR(,@12)                               02S0177
         MVC   MTENTPTR(4),MVENTRYP(@12)                        02S0177
*        LASTINDC = OFF;               /*INITIALIZE SWITCH           */
         NI    LASTINDC,B'01111111'                             02S0178
*        DO WHILE(LASTINDC = OFF);     /*DO UNTIL LAST MOUNT ENTRY   */
         B     @DE00179                                         02S0179
@DL00179 DS    0H                                               02S0180
*          IF MTNXTPTR = ZERO THEN     /*IF LAST MOUNT ENTRY ON CHAIN*/
         L     @12,MTENTPTR                                     02S0180
         ICM   @08,15,MTNXTPTR(@12)                             02S0180
         BNZ   @RF00180                                         02S0180
*            DO;                                                02S0181
*              LASTINDC = ON;          /*INDICATE LAST MOUNT ENTRY   */
         OI    LASTINDC,B'10000000'                             02S0182
*              MTNXTPTR = SPACEADD;    /*CHAIN IN NEW MOUNT ENTRY    */
         ST    SPACEADD,MTNXTPTR(,@12)                          02S0183
*              SPACEADD -> MTPRVPTR = MTENTPTR;  /*BACK CHAIN PTR    */
         ST    @12,MTPRVPTR(,SPACEADD)                          02S0184
*            END;                                               02S0185
*          ELSE;                       /* NOT LAST MOUNT ENTRY       */
@RF00180 DS    0H                                               02S0187
*          MTENTPTR = MTNXTPTR;        /*PTR TO NEXT MOUNT ENTRY OR
*                                        NEW MOUNT ENTRY(IF CHAINED) */
         L     @12,MTENTPTR                                     02S0187
         L     @12,MTNXTPTR(,@12)                               02S0187
         ST    @12,MTENTPTR                                     02S0187
*        END;                                                   02S0188
@DE00179 TM    LASTINDC,B'10000000'                             02S0188
         BZ    @DL00179                                         02S0188
*      END;                                                     02S0189
*    IF RETCODE = SUCCESS THEN         /*GETMAIN SUCCESS             */
@RC00129 LTR   RETCODE,RETCODE                                  02S0190
         BNZ   @RF00190                                         02S0190
*      DO;                                                      02S0191
*        MTDEVPTR = MTENTPTR + LENGTH(MTENBASE); /*PTR DEV ENTRY SECT*/
         L     @12,MTENTPTR                                     02S0192
         LA    @11,20                                           02S0192
         LR    @08,@12                                          02S0192
         ALR   @08,@11                                          02S0192
         ST    @08,MTDEVPTR(,@12)                               02S0192
*        MTDOMPTR = MTDEVPTR +         /*PTR TO DOM ID SECTION       */
*        (LENGTH(MTDEVENT) * DOMCNT);                           02S0193
         L     @06,@PC00001+12                                  02S0193
         L     @06,DOMCNT(,@06)                                 02S0193
         LR    @15,@06                                          02S0193
         MH    @15,@CH01558                                     02S0193
         ALR   @08,@15                                          02S0193
         ST    @08,MTDOMPTR(,@12)                               02S0193
*        MTLENGTH = LENGTH(MTENBASE) + /*LNTH OF MOUNT ENTRY         */
*        ((LENGTH(MTDEVENT) + LENGTH(MTDOMIDS)) * DOMCNT);      02S0194
         SLA   @06,4                                            02S0194
         ALR   @06,@11                                          02S0194
         STH   @06,MTLENGTH(,@12)                               02S0194
*      END;                                                     02S0195
*    ELSE;                             /*GETMAIN MNT ENRY NOT SUCCESS*/
@RF00190 DS    0H                                               02S0197
*  END;                                                         02S0197
*ELSE;                                 /*GETMAIN NOT SUCCESSFUL      */
@RF00127 DS    0H                                               02S0199
*  END;                                                         01S0199
*IF RETCODE = SUCCESS THEN             /*IF RETURN INDICATES SUCCESS */
@RF00088 LTR   RETCODE,RETCODE                                  01S0200
         BNZ   @RF00200                                         01S0200
*  DO;                                                          01S0201
*    OFFSET=ONE;                       /*INIT MOUNT ENTRY OFFSET     */
         LA    OFFSET,1                                         01S0202
*    DO WHILE(VMVREQBP ^= ZERO         /*SCAN REQUEST BLOCKS         */
*         & MOUNTCNT ^= ZERO           /*UNTIL ALL MOUNTS PROCESSED  */
*         & RETCODE = SUCCESS);        /*OR UNTIL FAILING RETURN CODE*/
         B     @DE00203                                         01S0203
@DL00203 DS    0H                                               01S0204
*      IF VMVMOUNT = ON THEN           /*IF MOUNT REQUEST            */
         L     @12,VMVREQBP                                     01S0204
         TM    VMVMOUNT(@12),B'00010000'                        01S0204
         BNO   @RF00204                                         01S0204
*        DO;                                                    01S0205
*          IF VMVDUPVL = OFF THEN      /*IF NOT DUPLICATE            */
         TM    VMVDUPVL(@12),B'10000000'                        01S0206
         BNZ   @RF00206                                         01S0206
*            DO;                                                01S0207
*              UCBPTR = VMVUCBP;                                01S0208
         SLR   @11,@11                                          01S0208
         ICM   @11,7,VMVUCBP(@12)                               01S0208
         ST    @11,UCBPTR                                       01S0208
*              IF (UCB3DACC = ON |     /*DIRECT ACCESS               */
*                 VMVDWTOR = ON) &     /*OR WTOR                     */
*                 DOMCNT ^= ZERO THEN  /*MUST UPDATE MT ENTRY        */
         TM    UCB3DACC(@11),B'00100000'                        01S0209
         BO    @GL00001                                         01S0209
         TM    VMVDWTOR(@12),B'00000100'                        01S0209
         BNO   @RF00209                                         01S0209
@GL00001 L     @12,@PC00001+12                                  01S0209
         ICM   @11,15,DOMCNT(@12)                               01S0209
         BZ    @RF00209                                         01S0209
*                DO;                                            01S0210
*                  IF VMVDWTOR = ON THEN /*                  @YM06077*/
         L     @12,VMVREQBP                                     01S0211
         TM    VMVDWTOR(@12),B'00000100'                        01S0211
         BNO   @RF00211                                         01S0211
*                    MVWTORSW = ON;    /*INDIC WTOR IN MVCAX @YM06077*/
         L     @12,MVCAPTR                                      01S0212
         L     @12,MVCAXPTR(,@12)                               01S0212
         OI    MVWTORSW(@12),B'01000000'                        01S0212
*                  MTUCBPTR(OFFSET)=VMVUCBP;/*PUT UCB IN MT ENTRY    */
@RF00211 LR    @12,OFFSET                                       01S0213
         MH    @12,@CH01558                                     01S0213
         L     @11,MTENTPTR                                     01S0213
         L     @11,MTDEVPTR(,@11)                               01S0213
         L     @06,VMVREQBP                                     01S0213
         ST    @12,@TF00001                                     01S0213
         ALR   @12,@11                                          01S0213
         AL    @12,@CF02489                                     01S0213
         MVC   MTUCBPTR-1(3,@12),VMVUCBP(@06)                   01S0213
*                  MTDSNMP(OFFSET)=VMVDSNMP;/*PUT DSN PTR IN MOUNT
*                                         ENTRY                      */
         L     @12,VMVDSNMP(,@06)                               01S0214
         L     @01,@TF00001                                     01S0214
         AL    @01,@CF02490                                     01S0214
         ST    @12,MTDSNMP-4(@01,@11)                           01S0214
*                  MTDVUPTR(OFFSET)=VMVVUNTP; /*SET THE MOUNT ENTRY
*                                                VOLUNIT PTR @ZA13809*/
         L     @12,VMVVUNTP(,@06)                               01S0215
         AL    @11,@TF00001                                     01S0215
         AL    @11,@CF02491                                     01S0215
         STCM  @12,7,MTDVUPTR-9(@11)                            01S0215
*                  MVNODEVE=MVNODEVE+ONE;/*UPDATE NO. OF DEV ENTRIES */
         L     @12,MVCAPTR                                      01S0216
         L     @12,MVCAXPTR(,@12)                               01S0216
         LA    @11,1                                            01S0216
         AH    @11,MVNODEVE(,@12)                               01S0216
         STH   @11,MVNODEVE(,@12)                               01S0216
*                END;                                           01S0217
*              IF UCBNOTRD = OFF THEN  /*DEVICE APPEARS NOT READY    */
@RF00209 L     @12,UCBPTR                                       01S0218
         TM    UCBNOTRD(@12),B'01000000'                        01S0218
         BNZ   @RF00218                                         01S0218
*                CALL IEFAB4E0(UCBPTR); /*INSURE RDY OR NRDY STATUS  */
         LA    @12,UCBPTR                                       01S0219
         ST    @12,@AL00001                                     01S0219
         L     @15,@CV02460                                     01S0219
         LA    @01,@AL00001                                     01S0219
         BALR  @14,@15                                          01S0219
*              IF VMVMTMSG = ON &      /*MT MSG WANTED               */
*                 (UCBNOTRD=ON |       /*DEVICE IS NOT READY         */
*                 (UCB3DACC=OFF &      /*NOT DIR. ACCESS             */
*                  UCBNOTRD=OFF &      /*READY                       */
*                  VMVDWTOR=OFF)) THEN /*NOT WTOR                    */
@RF00218 L     @12,VMVREQBP                                     01S0220
         TM    VMVMTMSG(@12),B'00001000'                        01S0220
         BNO   @RF00220                                         01S0220
         L     @11,UCBPTR                                       01S0220
         TM    UCBNOTRD(@11),B'01000000'                        01S0220
         BO    @RT00220                                         01S0220
         TM    UCB3DACC(@11),B'00100000'                        01S0220
         BNZ   @RF00220                                         01S0220
         TM    UCBNOTRD(@11),B'01000000'                        01S0220
         BNZ   @RF00220                                         01S0220
         TM    VMVDWTOR(@12),B'00000100'                        01S0220
         BNZ   @RF00220                                         01S0220
@RT00220 DS    0H                                               01S0221
*                DO;                                            01S0221
*                  IF UCBRVDEV = ON &  /*DETERMINE IF DEVICE @Y30LPPD*/
*                     UCBTYP(3:4) = COMP3330 THEN /*IS 3330V @Y30LPPD*/
         L     @12,UCBPTR                                       01S0222
         TM    UCBRVDEV(@12),B'00001000'                        01S0222
         BNO   @RF00222                                         01S0222
         CLC   UCBTYP+2(2,@12),@CB00100                         01S0222
         BNE   @RF00222                                         01S0222
*                    DO;               /*MOUNT VIRTUAL VOLS  @Y30LPPD*/
*/***********************************************************@Y30LPPD*/
*/*                                                          @Y30LPPD*/
*/* SEGMENT NAME - VIRTMONT                                  @Y30LPPD*/
*/*                                                          @Y30LPPD*/
*/* DESCRIPTIVE NAME - MOUNT VIRTUAL VOLUMES                 @Y30LPPD*/
*/*                                                          @Y30LPPD*/
*/* FUNCTION - THIS SEGMENT IS INVOKED TO PROCESS VMVRB'S FOR@Y30LPPD*/
*/*   3330V VOLUMES.                                         @Y30LPPD*/
*/*                                                          @Y30LPPD*/
*/* OPERATION - SETUP TO ISSUE MOUNT MACRO. OBTAIN THE VUA   @Y30LPPD*/
*/*   FROM THE UCB AND THE VOLSER FROM THE VMVRB. IF THE     @Y30LPPD*/
*/*   VOLSER IS BLANK, SET THE FLAGS FOR MOUNT SCRATCH.      @Y30LPPD*/
*/*   OTHERWISE, SET THE FLAGS TO ZERO. THE MOUNT EXTENSION  @G18MP21*/
*/*   IS BUILT WITH THE STEP NUMBER TAKEN FROM THE JSCB AND  @G18MP21*/
*/*   THE JOBNAME TAKEN FROM THE VMVRB. ISSUE THE MOUNT      @G18MP21*/
*/*   MACRO. IF REGISTER 15 IS NON-ZERO, THEN THE MOUNT      @Y30LPPD*/
*/*   FAILED. REGISTER 0 CONTAINS THE REASON CODE. IF REG 0  @Y30LPPD*/
*/*   IS 5 OR 6, THE VOLUME IS NOT AVAILABLE--SET RETCODE TO @Y30LPPD*/
*/*   8. IF REG 0 IS 7, THE VOLUME IS NOT DEFINED-- SET      @Y30LPPD*/
*/*   RETCODE TO 20. IF REG 0 IS 8,'10'X,OR '12'X,           @Y30LPPD*/
*/*   THE VOLUME IS NOT ACCESSIBLE-- SET RETCODE TO 28.      @Y30LPPD*/
*/*   IF REG 0 IS '207'X, THEN THE SPECIFIED MSVGP NAME DOES @Y30LPPD*/
*/*   NOT EXIST-- SET RETCODE TO 32. IF REG 0 IS '255'X,     @Y30LPPD*/
*/*   THEN SPACE OR MSVGP IS MISSING ON A NON-SPECIFIC REQ.  @Y30LPPD*/
*/*   FOR ALL OTHER REASON CODES, SET RETCODE                @Y30LPPD*/
*/*   TO 24. SETUP AND ISSUE ERROR MESSAGE IEF710I.          @Y30LPPD*/
*/*   IF REG 15 IS ZERO, THEN INDICATE MOUNT PENDING IN THE  @Y30LPPD*/
*/*   JOB AND PUT THE VOLSER IN THE UCB FOR A SPECIFIC       @Y30LPPD*/
*/*   REQUEST.                                               @Y30LPPD*/
*/*                                                          @Y30LPPD*/
*/* ENTRY POINT - INLINE SUBROUTINE                          @Y30LPPD*/
*/*                                                          @Y30LPPD*/
*/*   PURPOSE - TO MOUNT VIRTUAL VOLUMES                     @Y30LPPD*/
*/*                                                          @Y30LPPD*/
*/* INPUT -                                                  @Y30LPPD*/
*/*   UCBCHAN  - VIRTUAL UNIT ADDRESS                        @Y30LPPD*/
*/*   VMVMVLSR - MOUNT VOLUME SERIAL                         @Y30LPPD*/
*/*   VMVJBNMP - POINTER TO JOBNAME                          @G18MP21*/
*/*   JSCBSTEP - ACTIVE JSCB STEP NUMBER                     @G18MP21*/
*/*                                                          @Y30LPPD*/
*/* EXIT - NORMAL - INLINE SUBROUTINE                        @Y30LPPD*/
*/*                                                          @Y30LPPD*/
*/*   CONDITION - FUNCTION COMPLETE. VIRTUAL VOLUME MOUNTED  @Y30LPPD*/
*/*                                                          @Y30LPPD*/
*/*   OUTPUT - NONE                                          @Y30LPPD*/
*/*                                                          @Y30LPPD*/
*/*   RETURN CODE - 0 IN REGISTER 15                         @Y30LPPD*/
*/*                                                          @Y30LPPD*/
*/* EXIT - ERROR - INLINE SUBROUTINE                         @Y30LPPD*/
*/*                                                          @Y30LPPD*/
*/*   CONDITION - MOUNT FAILED FOR VIRTUAL VOLUME            @Y30LPPD*/
*/*                                                          @Y30LPPD*/
*/*   OUTPUT - ERROR MESSAGE IEF710I                         @Y30LPPD*/
*/*                                                          @Y30LPPD*/
*/*   RETURN CODE - DEPENDS ON REASON CODE RETURNED FROM MNT @Y30LPPD*/
*/*     REASON CODE=     REGISTER 15=                        @Y30LPPD*/
*/*     5,6              8                                   @Y30LPPD*/
*/*     7                20                                  @Y30LPPD*/
*/*     8,'10'X,'12'X    28                                  @Y30LPPD*/
*/*     '207'X           32                                  @Y30LPPD*/
*/*     '225'X           36                                  @Y30LPPD*/
*/*     ALL OTHERS       24                                  @Y30LPPD*/
*/***********************************************************@Y30LPPD*/
*VIRTVLSR = VMVMVLSR;                  /*OBTAIN VOLUME SERIAL@Y30LPPD*/
         L     @11,VMVREQBP                                     02S0224
         MVC   VIRTVLSR(6),VMVMVLSR(@11)                        02S0224
*VIRTUA = UCBCHAN;                     /*OBTAIN VUA          @Y30LPPD*/
         MVC   VIRTUA(2),UCBCHAN(@12)                           02S0225
*VIRTFLAG = ZERO;                      /*ZERO MOUNT FLAGS    @Y30LPPD*/
         SLR   @12,@12                                          02S0226
         STH   @12,VIRTFLAG                                     02S0226
*IF VMVMVLSR = BLANKS THEN             /*IF VOLSER IS BLANK  @Y30LPPD*/
         CLC   VMVMVLSR(6,@11),BLANKS                           02S0227
         BNE   @RF00227                                         02S0227
*  MNTSCR = ON;                        /*INDICATE SCRATCH    @Y30LPPD*/
         OI    MNTSCR,B'00010000'                               02S0228
*ELSE;                                 /*VOLSER NOT BLANK    @Y30LPPD*/
@RF00227 DS    0H                                               02S0230
*VUPTR = VMVVUNTP;                     /*ADDRESS OF VOLUNIT     02S0230
*                                        TABLE               @Y30LPPD*/
         L     @12,VMVREQBP                                     02S0230
         L     VUPTR,VMVVUNTP(,@12)                             02S0230
*IF VUDADSM ^= ON THEN                 /*DADSM REQUIRED?     @ZA32026*/
         TM    VUDADSM(VUPTR),B'00000010'                       02S0231
         BO    @RF00231                                         02S0231
*  MNTSVLR = ON;                       /*NO, PRIMARY SPACE      02S0232
*                                        NOT NEEDED ON VOLUME@ZA32026*/
         OI    MNTSVLR,B'00100000'                              02S0232
*ELSE;                                 /*PRIMARY SPACE NEEDED@ZA32026*/
@RF00231 DS    0H                                               02S0234
*SIOTPTR = VOLSIOTP;                   /*ADDRESS OF SIOT     @Y30LPPD*/
         L     SIOTPTR,VOLSIOTP(,VUPTR)                         02S0234
*MEXT=MEXT&&MEXT;                      /*ZERO MOUNT EXT. CORE@G18MP21*/
         XC    MEXT(16),MEXT                                    02S0235
*MNTXJFCB=SJFCBPTR;                    /*PTR TO JFCB         @G18MP21*/
         LA    @12,MEXT                                         02S0236
         MVC   MNTXJFCB(4,@12),SJFCBPTR(SIOTPTR)                02S0236
*MNTXJOBN=VMVJBNMP;                    /*PTR TO JOB NAME     @G18MP21*/
         L     @11,VMVREQBP                                     02S0237
         MVC   MNTXJOBN(4,@12),VMVJBNMP(@11)                    02S0237
*TCBPTR=CURTCB;                        /*ADDR. OF TCB        @G18MP21*/
         L     @11,CVTPTR                                       02S0238
         L     @11,CVTTCBP(,@11)                                02S0238
         L     TCBPTR,CURTCB(,@11)                              02S0238
*JSCBPTR=JSCBACT;                      /*GET  ACTIVE JSCB    @G18MP21*/
         L     @11,TCBJSCB(,TCBPTR)                             02S0239
         L     JSCBPTR,JSCBACT(,@11)                            02S0239
*RFY IEZJSCB BASED(JSCBPTR);           /*BASE JSCB           @G18MP21*/
*MNTXSTEP=ADDR(JSCBSTEP);              /*STEP NUMBER         @G18MP21*/
*                                                               02S0241
         LA    @11,JSCBSTEP(,JSCBPTR)                           02S0241
         ST    @11,MNTXSTEP(,@12)                               02S0241
* /********************************************************* @Y30LB02*/
* /*MACMEAN  MSSC MOUNT/DEMOUNT MACRO                        @Y30LB02*/
* /*VS2-3 VERSION-- 02/06/76                                 @G18MB04*/
* /*THIS IS THE OUTPUT FOR THE EXECUTE FORM.                 @Y30LB02*/
* /*THE LIST FORM OF THIS MACRO SHOULD BE                    @Y30LB02*/
* /*INVOKED FIRST IN ORDER TO SET UP NECESSARY               @Y30LB02*/
* /*DECLARES.  IF THE COMPLETE ARGUMENT IS                   @Y30LB02*/
* /*SPECIFIED THE REQ BLOCK WILL BE ZEROED.                  @Y30LB02*/
* /********************************************************* @Y30LB02*/
* RFY  MDREG1 RSTD;/*RESTRICT REG 1 @Y30LB02*/                  02S0242
* MDREG1= ADDR(MNTLST); /*R1 PTR TO REQ BLOCK @Y30LB02*/        02S0243
         LA    MDREG1,MNTLST                                    02S0243
*  MNTLST=MNTLST&&MNTLST;/*ZERO OUT BLOCK @Y30LB02*/            02S0244
         XC    MNTLST(28),MNTLST                                02S0244
* MDLEN='1C'X;/*LENGTH OF MOUNT REQUEST BLOCK @Y30LB02*/        02S0245
         LA    @11,28                                           02S0245
         ST    @11,MDLEN                                        02S0245
* MDOPCD='08'X;/*MOUNT OPCODE @Y30LB02*/                        02S0246
         MVI   MDOPCD,X'08'                                     02S0246
* MDFLG=(VIRTFLAG); /*VALUE OF FLAGS @Y30LB02*/                 02S0247
         MVC   MDFLG(2),VIRTFLAG                                02S0247
* MDVOL=(VIRTVLSR);/*VALUE OF VOLID @Y30LB02*/                  02S0248
         MVC   MDVOL(6),VIRTVLSR                                02S0248
* MDVUA=(VIRTUA); /*VALUE OF VUA    @Y30LB02*/                  02S0249
         MVC   MDVUA(2),VIRTUA                                  02S0249
* MNTEXTP=ADDR(MEXT);/*FILL IN MEXTN @G18MB04*/                 02S0250
         ST    @12,MNTEXTP                                      02S0250
* MDMEXT='1'B;/* OR ON THE MOUNT EXT PROVIDED BIT @G18MB04*/    02S0251
         OI    MDMEXT,B'00001000'                               02S0251
* SVC  (126);/*INVOKE THE SSC SVC  @Y30LB02*/                   02S0252
         SVC   126                                              02S0252
* RFY  MDREG1 UNRSTD;/*UNREST REG 1 @Y30LB02*/                  02S0253
*                                      /*ISSUE MOUNT MACRO   @ZA03529*/
*RFY (REG0,REG15) RSTD;                /*                    @Y30LPPD*/
*                                                               02S0254
*IF REG15 ^= SUCCESS THEN              /*TEST RETURN CODE    @Y30LPPD*/
         LTR   REG15,REG15                                      02S0255
         BZ    @RF00255                                         02S0255
*  DO;                                 /*NON-ZERO            @Y30LPPD*/
*    MNTRSN = REG0;                    /*MOVE REG0           @Y30LPPD*/
         ST    REG0,MNTRSN                                      02S0257
*    RFY (REG0,REG15) UNRSTD;          /*                    @Y30LPPD*/
*    IF MNTRSN = MNTRSN5 |             /*IF REASON CODE IS 5 @Y30LPPD*/
*       MNTRSN = MNTRSN6 THEN          /*OR 6 THEN INDICATE  @Y30LPPD*/
         L     @12,MNTRSN                                       02S0259
         CH    @12,@CH00146                                     02S0259
         BE    @RT00259                                         02S0259
         CH    @12,@CH00125                                     02S0259
         BNE   @RF00259                                         02S0259
@RT00259 DS    0H                                               02S0260
*      RETCODE  = NOTAVAIL;            /*VOL NOT AVAILABLE   @Y30LPPD*/
         LA    RETCODE,8                                        02S0260
*    ELSE                              /*OTHERWISE,          @Y30LPPD*/
*      IF MNTRSN = MNTRSN7 THEN        /*IF REASON CODE IS 7 @Y30LPPD*/
         B     @RC00259                                         02S0261
@RF00259 CLC   MNTRSN(4),@CF00158                               02S0261
         BNE   @RF00261                                         02S0261
*        RETCODE = NOTDEFD;            /*IND VOL NOT DEFINED @Y30LPPD*/
         LA    RETCODE,20                                       02S0262
*      ELSE                            /*OTHERWISE,          @Y30LPPD*/
*        IF MNTRSN = MNTRSN8 |         /*IF CODE IS 8        @Y30LPPD*/
*           MNTRSN = MNTRSN10 |        /*OR 10               @Y30LPPD*/
*           MNTRSN = MNTRSN12 THEN     /*OR 12, INDICATE VOL @Y30LPPD*/
         B     @RC00261                                         02S0263
@RF00261 L     @12,MNTRSN                                       02S0263
         CH    @12,@CH00088                                     02S0263
         BE    @RT00263                                         02S0263
         CH    @12,@CH00054                                     02S0263
         BE    @RT00263                                         02S0263
         CH    @12,@CH00162                                     02S0263
         BNE   @RF00263                                         02S0263
@RT00263 DS    0H                                               02S0264
*          RETCODE = NOTACCES;         /*NOT ACCESSIBLE      @Y30LPPD*/
         LA    RETCODE,28                                       02S0264
*        ELSE                          /*OTHERWISE,          @Y30LPPD*/
*          IF MNTRSN = MNTRS207 THEN   /*IF REASON CODE = 207@Y30LPPD*/
         B     @RC00263                                         02S0265
@RF00263 CLC   MNTRSN(4),@CF00164                               02S0265
         BNE   @RF00265                                         02S0265
*            RETCODE = MSVGPINV;       /*IND INVALID MSVGP   @Y30LPPD*/
         LA    RETCODE,32                                       02S0266
*          ELSE                        /*OTHERWISE,          @Y30LPPD*/
*            IF MNTRSN = MNTRS225 THEN /*IF REASON CODE = 225@Y30LPPD*/
         B     @RC00265                                         02S0267
@RF00265 CLC   MNTRSN(4),@CF00166                               02S0267
         BNE   @RF00267                                         02S0267
*              RETCODE = SPCMSVGP;     /*IND SPACE OR MSVGP  @Y30LPPD*/
         LA    RETCODE,36                                       02S0268
*            ELSE                      /*REQUIRED, OTHERWISE @Y30LPPD*/
*              RETCODE = UNABTOMT;     /*UNABLE TO MOUNT     @Y30LPPD*/
         B     @RC00267                                         02S0269
@RF00267 LA    RETCODE,24                                       02S0269
*    UNPK (UNPKAR,RSN(3:5));           /*UNPACK REASON CODE  @Y30LPPD*/
@RC00267 DS    0H                                               02S0270
@RC00265 DS    0H                                               02S0270
@RC00263 DS    0H                                               02S0270
@RC00261 DS    0H                                               02S0270
@RC00259 UNPK  UNPKAR(5),RSN+2(3)                               02S0270
*    TR (UNPKAR(1:4),TRANSTAB);        /*CONVERT TO PRINTABLE@Y30LPPD*/
         LA    @12,TRPATN                                       02S0271
         AL    @12,@CF02494                                     02S0271
         TR    UNPKAR(4),TRANSTAB(@12)                          02S0271
*                                      /*FOR INCLUSION IN MSG@Y30LPPD*/
*    MNTERMSG = VVMNTMSG;              /*PUT MSG TEXT IN BUF @Y30LPPD*/
         L     @12,@CA00179                                     02S0272
         MVC   MNTERMSG(79),VVMNTMSG-VVMNTMSG(@12)              02S0272
*    MNTJNAM = VMVJBNMP -> NAME;       /*FILL IN JOBNAME     @Y30LPPD*/
         L     @12,VMVREQBP                                     02S0273
         L     @11,VMVJBNMP(,@12)                               02S0273
         MVC   MNTJNAM(8),NAME(@11)                             02S0273
*    MNTSNAM = VMVJSNMP -> NAME;       /*FILL IN STEPNAME    @Y30LPPD*/
         L     @12,VMVJSNMP(,@12)                               02S0274
         MVC   MNTSNAM(8),NAME(@12)                             02S0274
*    IF VIRTVLSR = BLANKS THEN         /*SCRATCH SPECIFIED?  @Y30LPPD*/
         CLC   VIRTVLSR(6),BLANKS                               02S0275
         BNE   @RF00275                                         02S0275
*      MNTVLSR = SCRSER;               /*YES - MOVE IN SCRTCH@Y30LPPD*/
         MVC   MNTVLSR(6),@CC00172                              02S0276
*    ELSE                              /*SCRATCH NOT SPEC'D. @Y30LPPD*/
*      MNTVLSR = VIRTVLSR;             /*MOVE IN VOLSER.     @Y30LPPD*/
         B     @RC00275                                         02S0277
@RF00275 MVC   MNTVLSR(6),VIRTVLSR                              02S0277
*    MNTVUA  = UCBNAME;                /*FILL IN VUA         @Y30LPPD*/
@RC00275 L     @12,UCBPTR                                       02S0278
         MVC   MNTVUA(3),UCBNAME(@12)                           02S0278
*    MNTRET  = UNPKAR(2:4);            /*FILL IN REASON CODE @Y30LPPD*/
         MVC   MNTRET(3),UNPKAR+1                               02S0279
*    BUFFPTR = ADDR(MNTPT1);           /*POINT TO MSG FOR    @Y30LPPD*/
         LA    @12,MNTPT1                                       02S0280
         ST    @12,BUFFPTR                                      02S0280
*                                      /*COMPRESSION ROUTINE @Y30LPPD*/
*    TEXTLEN = LENGTH(MNTPT1);         /*OBTAIN LENGTH       @Y30LPPD*/
         MVC   TEXTLEN(4),@CF02484                              02S0281
*    CALL IEFAB4F3(BUFFPTR,TEXTLEN,NEWLEN);/*COMPRESS BLANKS    02S0282
*                                                            @Y30LPPD*/
         LA    @12,BUFFPTR                                      02S0282
         ST    @12,@AL00001                                     02S0282
         LA    @12,TEXTLEN                                      02S0282
         ST    @12,@AL00001+4                                   02S0282
         LA    @12,NEWLEN                                       02S0282
         ST    @12,@AL00001+8                                   02S0282
         L     @15,@CV00180                                     02S0282
         LA    @01,@AL00001                                     02S0282
         BALR  @14,@15                                          02S0282
*    MNTLEN = MNTLEN-(TEXTLEN-NEWLEN); /*ADJUST MSG LENGTH   @Y30LPPD*/
         L     @12,NEWLEN                                       02S0283
         LR    @11,@12                                          02S0283
         SL    @11,TEXTLEN                                      02S0283
         AH    @11,MNTLEN                                       02S0283
         STH   @11,MNTLEN                                       02S0283
*    PART2 = MNTPT2;                   /*MOVE REST OF MSG    @Y30LPPD*/
         LA    @11,MNTPT1                                       02S0284
         ALR   @11,@12                                          02S0284
         MVC   PART2(50,@11),MNTPT2                             02S0284
*    GEN REFS(MNTERMSG,REG1);          /*ISSUE MESSAGE       @Y30LPPD*/
          WTO MF=(E,MNTERMSG)                               @Y30LPPD
*  END;                                /*                    @Y30LPPD*/
*ELSE;                                 /*MOUNT SUCCESSFUL    @ZA18110*/
@RF00255 DS    0H                                               02S0288
*    /*GET KEY ZERO AND LOCK                                 @Y30LPPD*/
* DO; /*MODESET  KEYADDR(ZERO)*/                                02S0288
*   SPKA (ZERO); /*SET PSW KEY*/                                02S0289
         SLR   @12,@12                                          02S0289
         SPKA  0(@12)                                           02S0289
* END; /*MODESET  KEYADDR(ZERO)*/               /*GET KEY ZERO        @
*30LPPD*/                                                       02S0290
* DO; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(LOCAL) REGS(USE) RELATED(UC
*,IEFAB495(VIRTMONT)) */                                        02S0291
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                     02S0292
*   RFY (GPR15P,GPR00P,GPR01P) RSTD;                            02S0293
*   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */             02S0294
         LR    GPR15P,GPR11P                                    02S0294
*   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */              02S0295
         LR    GPR00P,GPR12P                                    02S0295
*   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */              02S0296
         LR    GPR01P,GPR13P                                    02S0296
*   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */    02S0297
         L     GPR13P,PSALITA                                   02S0297
*   GEN(LM GPR11P,GPR13P,576(GPR13P)); /* LOAD LOCKWORD, CLHT AND ENTRY
*ADRS. */                                                       02S0298
         LM GPR11P,GPR13P,576(GPR13P)
*   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */         02S0299
         BALR GPR14P,GPR13P
*   GPR11P = GPR15P; /* RESTORE REG. 11. */                     02S0300
         LR    GPR11P,GPR15P                                    02S0300
*   GPR15P = GPR13P; /* SAVE RETURN CODE. */                    02S0301
         LR    GPR15P,GPR13P                                    02S0301
*   GPR12P = GPR00P; /* RESTORE REG. 12 */                      02S0302
         LR    GPR12P,GPR00P                                    02S0302
*   GPR13P = GPR01P; /* RESTORE REG. 13. */                     02S0303
         LR    GPR13P,GPR01P                                    02S0303
*   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                           02S0304
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;                   02S0305
* END; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(LOCAL) REGS(USE) RELATED(U
*B,IEFAB495(VIRTMONT)) */     /*GET LOCAL LOCKS     @Y30LPPD*/  02S0306
* DO; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(CMS) REGS(USE) RELATED(UCB,
*EFAB495(VIRTMONT)) */                                          02S0307
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                     02S0308
*   RFY (GPR15P,GPR00P,GPR01P) RSTD;                            02S0309
*   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */             02S0310
         LR    GPR15P,GPR11P                                    02S0310
*   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */              02S0311
         LR    GPR00P,GPR12P                                    02S0311
*   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */              02S0312
         LR    GPR01P,GPR13P                                    02S0312
*   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */    02S0313
         L     GPR13P,PSALITA                                   02S0313
*   GEN(LM GPR11P,GPR13P,540(GPR13P)); /* LOAD LOCKWORD, CLHT AND ENTRY
*ADRS. */                                                       02S0314
         LM GPR11P,GPR13P,540(GPR13P)
*   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */         02S0315
         BALR GPR14P,GPR13P
*   GPR11P = GPR15P; /* RESTORE REG. 11. */                     02S0316
         LR    GPR11P,GPR15P                                    02S0316
*   GPR15P = GPR13P; /* SAVE RETURN CODE. */                    02S0317
         LR    GPR15P,GPR13P                                    02S0317
*   GPR12P = GPR00P; /* RESTORE REG. 12 */                      02S0318
         LR    GPR12P,GPR00P                                    02S0318
*   GPR13P = GPR01P; /* RESTORE REG. 13. */                     02S0319
         LR    GPR13P,GPR01P                                    02S0319
*   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                           02S0320
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;                   02S0321
* END; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(CMS) REGS(USE) RELATED(UCB
*IEFAB495(VIRTMONT)) */     /*GET CMS LOCKS       @Y30LPPD*/    02S0322
*IF RETCODE= SUCCESS THEN              /*MOUNT OK            @ZA18110*/
         LTR   RETCODE,RETCODE                                  02S0323
         BNZ   @RF00323                                         02S0323
*  DO;                                 /*SET UP UCB FIELDS   @ZA18110*/
*    UCBMOUNT = ON;                    /*SET MOUNT PENDNG BIT@Y30LPPD*/
         L     @12,UCBPTR                                       02S0325
         OI    UCBMOUNT(@12),B'10000000'                        02S0325
*    IF VMVMVLSR ^= BLANKS THEN        /*IF VOLSER SPECIFIC  @Y30LPPD*/
         L     @11,VMVREQBP                                     02S0326
         CLC   VMVMVLSR(6,@11),BLANKS                           02S0326
         BE    @RF00326                                         02S0326
*      DO;                                                      02S0327
*        UCBVOLI = VMVMVLSR;           /*MOVE REQ.BLK.VOLSER TO UCB
*                                                            @Y30LPPD*/
         MVC   UCBVOLI(6,@12),VMVMVLSR(@11)                     02S0328
*      END;                                                     02S0329
*    ELSE;                             /*NON-SPECIFIC VOLSER @Y30LPPD*/
@RF00326 DS    0H                                               02S0331
*  END;                                /*                    @ZA18110*/
*ELSE;                                 /*                    @ZA18110*/
@RF00323 DS    0H                                               02S0333
*UCBMMSGP = OFF;                       /*RESET MOUNT MESSAGE/   02S0333
*                                        MACRO PENDING BIT   @ZA18110*/
         L     @12,UCBPTR                                       02S0333
         NI    UCBMMSGP(@12),B'11111011'                        02S0333
*    /*FREE LOCK AND RESTORE KEY                                     */
* DO; /* SETLOCK (RELEASE) TYPE(CMS) REGS(USE) RELATED(UCB,IEFAB495(VIR
*MONT)) */                                                      02S0334
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                     02S0335
*   RFY (GPR15P,GPR00P,GPR01P) RSTD;                            02S0336
*   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */             02S0337
         LR    GPR15P,GPR11P                                    02S0337
*   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */              02S0338
         LR    GPR00P,GPR12P                                    02S0338
*   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */              02S0339
         LR    GPR01P,GPR13P                                    02S0339
*   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */    02S0340
         L     GPR13P,PSALITA                                   02S0340
*   GEN(LM GPR11P,GPR13P,552(GPR13P)); /* LOAD LOCKWORD, CLHT AND ENTRY
*ADRS. */                                                       02S0341
         LM GPR11P,GPR13P,552(GPR13P)
*   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */         02S0342
         BALR GPR14P,GPR13P
*   GPR11P = GPR15P; /* RESTORE REG. 11. */                     02S0343
         LR    GPR11P,GPR15P                                    02S0343
*   GPR15P = GPR13P; /* SAVE RETURN CODE. */                    02S0344
         LR    GPR15P,GPR13P                                    02S0344
*   GPR12P = GPR00P; /* RESTORE REG. 12 */                      02S0345
         LR    GPR12P,GPR00P                                    02S0345
*   GPR13P = GPR01P; /* RESTORE REG. 13. */                     02S0346
         LR    GPR13P,GPR01P                                    02S0346
*   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                           02S0347
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;                   02S0348
* END; /* SETLOCK (RELEASE) TYPE(CMS) REGS(USE) RELATED(UCB,IEFAB495(VI
*TMONT)) */     /*RELEASE CMS LOCK    @Y30LPPD*/                02S0349
*     DO; /* SETLOCK (RELEASE) TYPE(LOCAL) REGS(USE) RELATED(UCB,IEFAB4
*5(VIRTMONT)) */                                                02S0350
*       RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                 02S0351
*       RFY (GPR15P,GPR00P,GPR01P) RSTD;                        02S0352
*       GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */         02S0353
         LR    GPR15P,GPR11P                                    02S0353
*       GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */          02S0354
         LR    GPR00P,GPR12P                                    02S0354
*       GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */          02S0355
         LR    GPR01P,GPR13P                                    02S0355
*       GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */
         L     GPR13P,PSALITA                                   02S0356
*       GEN(LM GPR11P,GPR13P,588(GPR13P)); /* LOAD LOCKWORD, CLHT AND E
*TRY ADRS. */                                                   02S0357
         LM GPR11P,GPR13P,588(GPR13P)
*       GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */     02S0358
         BALR GPR14P,GPR13P
*       GPR11P = GPR15P; /* RESTORE REG. 11. */                 02S0359
         LR    GPR11P,GPR15P                                    02S0359
*       GPR15P = GPR13P; /* SAVE RETURN CODE. */                02S0360
         LR    GPR15P,GPR13P                                    02S0360
*       GPR12P = GPR00P; /* RESTORE REG. 12 */                  02S0361
         LR    GPR12P,GPR00P                                    02S0361
*       GPR13P = GPR01P; /* RESTORE REG. 13. */                 02S0362
         LR    GPR13P,GPR01P                                    02S0362
*       RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                       02S0363
*       RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;               02S0364
*     END; /* SETLOCK (RELEASE) TYPE(LOCAL) REGS(USE) RELATED(UCB,IEFAB
*95(VIRTMONT)) */     /*RELEASE LOCAL LOCK  @Y30LPPD*/          02S0365
* DO; /*MODESET  EXTKEY(SCHED)*/                                02S0366
*   SPKA (16); /*SET PSW KEY*/                                  02S0367
         LA    @12,16                                           02S0367
         SPKA  0(@12)                                           02S0367
* END; /*MODESET  EXTKEY(SCHED)*/               /*GET SCHED KEY       @
*30LPPD*/                                                       02S0368
*                    END;                                 /* @Y30LPPD*/
*                  ELSE                /*NOT 3330V           @Y30LPPD*/
*                    DO;                                  /* @Y30LPPD*/
         B     @RC00222                                         01S0370
@RF00222 DS    0H                                               01S0371
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - MSGSETUP                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - SET-UP FOR VM&V WTO/R FORMAT RTN. IEFAB499    */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   TO SET UP THE PARAMETER LIST AND CALL THE ROUTINE(IEFAB499)    */
*/*   WHICH GENERATES A WTO/WTOR CONTROL PGM PARM LIST.              */
*/*                                                                  */
*/*                                                                  */
*/*                                                                  */
*/*   OPERATION -                                                    */
*/*     THIS SEGMENT WILL INVOKE IEFAB499 TO BUILD EITHER A WTO OR A */
*/*     WTOR CONTROL PROGRAM PARAMETER LIST TO BE USED TO ISSUE A    */
*/*     MOUNT MESSAGE. IF A VM&V REQUEST BLOCK TO A VOLSER OF BLANKS */
*/*     THIS IS CONSIDERED TO BE A NON-SPECIFIC REQUEST. IN THIS CASE*/
*/*     THE VOLID PASSED TO IEFAB499 FOR INCLUSION IN THE WTO/WTOR   */
*/*     PARAMETER LIST WILL BE THE CHARACTERS 'SCRTCH' UNLESS THIS IS*/
*/*     A NON-SPECIFIC PRIVATE REQUEST IN WHICH CASE THE CHARACTERS  */
*/*     'PRIVAT' WILL BE USED AS A VOLID.                            */
*/*                                                                  */
*/*                                                                  */
*/*                                                                  */
*/* ENTRY POINT -(INLINE SUBROUTINE - ENTERED AT THE TOP)            */
*/*                                                                  */
*/*   PURPOSE - TO SET-UP FOR AND CALL THE MESSAGE FORMAT RTN.       */
*/*                                                                  */
*/*                                                                  */
*/* INPUT -                                                          */
*/*             VM&V REQUEST BLOCK                                   */
*/*                  - VMVUCBP - UCB PTR                             */
*/*                  - VMVDWTOR - WTOR INDICATOR                     */
*/*                  - VMVMVLSR - VOLSER                             */
*/*                  - VMVNSPVT - NON-SPECIFIC PRIVATE INDICATOR     */
*/*                  - VMVSLTAP - SL TAPE INDICATOR                  */
*/*                  - VMVALTAP - AL TAPE INDICATOR                  */
*/*                  - VMVNLTAP - NL TAPE INDICATOR                  */
*/*                  - VMVNSLTP - NSL TAPE INDICATOR                 */
*/*                                                                  */
*/*                                                                  */
*/*                                                                  */
*/* EXIT - NORMAL - (INLINE SUBROUTINE - EXITS AT BOTTOM)            */
*/*                                                                  */
*/*   CONDITION - PROCESSING COMPLETE                                */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*                WTO/WTOR CONTROL PGM PARM LIST SET UP             */
*/*                                                                  */
*/*   RETURN CODE - ZERO                                             */
*/*                                                                  */
*/* EXIT - ERROR -(INLINE SUBROUTINE - EXITS AT BOTTOM)              */
*/*                                                                  */
*/*   CONDITION - IEFAB499 HAS A GETMAIN ERROR                       */
*/*                                                                  */
*/*   OUTPUT - NONE                                                  */
*/*                                                                  */
*/*   RETURN CODE - FOUR                                             */
*/*                                                                  */
*/*                                                                  */
*/********************************************************************/
*PARMLSTP = ADDR(PARMLIST);            /*ADDRESS PARAMETER AREA      */
         LA    PARMLSTP,PARMLIST                                02S0371
*PARMLIST = PARMLIST && PARMLIST;      /*CLEAR PARAMETER AREA        */
         XC    PARMLIST(20),PARMLIST                            02S0372
*UCBPTR = VMVUCBP;                     /*ADDRESS UCB                 */
         L     @12,VMVREQBP                                     02S0373
         SLR   @11,@11                                          02S0373
         ICM   @11,7,VMVUCBP(@12)                               02S0373
         ST    @11,UCBPTR                                       02S0373
*IF UCB3DACC = ON THEN                 /*IF D.A.                     */
         TM    UCB3DACC(@11),B'00100000'                        02S0374
         BNO   @RF00374                                         02S0374
*  DO;                                                          02S0375
*    DAUNIT = ON;                      /*INDICATE D.A. IN PARMLIST   */
         OI    DAUNIT,B'00100000'                               02S0376
*  END;                                                         02S0377
*ELSE                                  /*MUST BE TAPE                */
*  DO;                                                          02S0378
         B     @RC00374                                         02S0378
@RF00374 DS    0H                                               02S0379
*    TAPEUNIT = ON;                    /*INDICATE TAPE IN PARMLIST   */
         OI    TAPEUNIT,B'00010000'                             02S0379
*  END;                                                         02S0380
*IF VMVDWTOR = ON THEN                 /*IF WTOR REQUEST             */
@RC00374 L     @12,VMVREQBP                                     02S0381
         TM    VMVDWTOR(@12),B'00000100'                        02S0381
         BNO   @RF00381                                         02S0381
*  DO;                                                          02S0382
*    IF UCB3DACC = ON THEN             /*IF D.A.                     */
         L     @12,UCBPTR                                       02S0383
         TM    UCB3DACC(@12),B'00100000'                        02S0383
         BNO   @RF00383                                         02S0383
*      DO;                                                      02S0384
*        MWTOREBP = ADDR(MVDAECB);     /*DA WTOR ECB PTR             */
         L     @12,MVCAPTR                                      02S0385
         L     @12,MVCAXPTR(,@12)                               02S0385
         LA    @12,MVDAECB(,@12)                                02S0385
         ST    @12,MWTOREBP                                     02S0385
*      END;                                                     02S0386
*    ELSE                              /*MUST BE TAPE                */
*      DO;                                                      02S0387
         B     @RC00383                                         02S0387
@RF00383 DS    0H                                               02S0388
*        MWTOREBP = ADDR(MVTPECB);     /*TAPE WTOR ECB PTR           */
         L     @12,MVCAPTR                                      02S0388
         L     @12,MVCAXPTR(,@12)                               02S0388
         LA    @12,MVTPECB(,@12)                                02S0388
         ST    @12,MWTOREBP                                     02S0388
*      END;                                                     02S0389
*    MSGID = WTORMGID;                 /*MESSAGE ID(WTOR)            */
@RC00383 MVI   MSGID,X'03'                                      02S0390
*    WTORINDC = ON;                    /*INDICATE WTOR               */
         OI    WTORINDC,B'10000000'                             02S0391
*    ADDINFOP = ADDR(MTREPLY);         /*ADDITIONAL MSG. INFO.       */
         L     @12,@CA01676                                     02S0392
         LA    @11,MTREPLY-MTREPLYM(,@12)                       02S0392
         ST    @11,ADDINFOP                                     02S0392
*    ADDLILEN = MTRPLYLN;              /*LEN ADD'L INF               */
         MVC   ADDLILEN(2),MTRPLYLN-MTREPLYM(@12)               02S0393
*  END;                                                         02S0394
*ELSE                                  /*MUST BE WTO                 */
*  DO;                                                          02S0395
         B     @RC00381                                         02S0395
@RF00381 DS    0H                                               02S0396
*    MSGID = WTOMSGID;                 /*MESSAGE ID(WTO)             */
         MVI   MSGID,X'01'                                      02S0396
*    WTOINDC = ON;                     /*INDICATE WTO                */
         OI    WTOINDC,B'01000000'                              02S0397
*  END;                                                         02S0398
*IF VMVMVLSR = BLANKS THEN             /*IF REQUESTED VOLSER BLANK   */
@RC00381 L     @12,VMVREQBP                                     02S0399
         CLC   VMVMVLSR(6,@12),BLANKS                           02S0399
         BNE   @RF00399                                         02S0399
*  DO;                                                          02S0400
*    IF VMVNSPVT = ON THEN             /* NON-SPECIFIC PRIVATE       */
         TM    VMVNSPVT(@12),B'00000001'                        02S0401
         BNO   @RF00401                                         02S0401
*      DO;                                                      02S0402
*        VOLIDPTR = ADDR(PRIVAT);      /*ASSIGN PRIVAT TO VOLSER     */
         L     @12,@CA01681                                     02S0403
         ST    @12,VOLIDPTR                                     02S0403
*      END;                                                     02S0404
*    ELSE                              /*NOT NON-SPECIFIC PRIVATE    */
*      DO;                                                      02S0405
         B     @RC00401                                         02S0405
@RF00401 DS    0H                                               02S0406
*        VOLIDPTR = ADDR(SCRTCH);      /*ASSIGN SCRTCH TO VOLSER     */
         L     @12,@CA01684                                     02S0406
         ST    @12,VOLIDPTR                                     02S0406
*      END;                                                     02S0407
*    IF VMVSLTAP = ON THEN             /*IF SL INDICATED             */
@RC00401 L     @12,VMVREQBP                                     02S0408
         TM    VMVSLTAP(@12),B'00000100'                        02S0408
         BNO   @RF00408                                         02S0408
*      DO;                                                      02S0409
*        LABELTYP = SL;                /*SET LABEL TYPE TO SL        */
         MVI   LABELTYP,X'06'                                   02S0410
*      END;                                                     02S0411
*    ELSE                              /*NOT SL                      */
*      DO;                                                      02S0412
         B     @RC00408                                         02S0412
@RF00408 DS    0H                                               02S0413
*        IF VMVALTAP = ON THEN         /*IF AL INDICATED             */
         L     @12,VMVREQBP                                     02S0413
         TM    VMVALTAP(@12),B'00010000'                        02S0413
         BNO   @RF00413                                         02S0413
*          LABELTYP = AL;              /*SET TO AL                   */
         MVI   LABELTYP,X'05'                                   02S0414
*        ELSE                          /*NOT AL                      */
*          DO;                                                  02S0415
         B     @RC00413                                         02S0415
@RF00413 DS    0H                                               02S0416
*            IF VMVNLTAP = ON THEN     /*IF NL INDICATED             */
         L     @12,VMVREQBP                                     02S0416
         TM    VMVNLTAP(@12),B'00001000'                        02S0416
         BNO   @RF00416                                         02S0416
*              LABELTYP = NL;          /*SET TO NL                   */
         MVI   LABELTYP,X'04'                                   02S0417
*            ELSE                      /*LABEL TYPE NOT SPECIFIED    */
*              DO;                                              02S0418
         B     @RC00416                                         02S0418
@RF00416 DS    0H                                               02S0419
*                IF VMVNSLTP = ON THEN                          02S0419
         L     @12,VMVREQBP                                     02S0419
         TM    VMVNSLTP(@12),B'00000010'                        02S0419
         BNO   @RF00419                                         02S0419
*                   LABELTYP = NSL;    /*SET TO NSL                  */
         MVI   LABELTYP,X'07'                                   02S0420
*                ELSE;                 /*MUST BE DA                  */
@RF00419 DS    0H                                               02S0422
*                END;                                           02S0422
*        END;                                                   02S0423
*      END;                                                     02S0424
*  END;                                                         02S0425
*ELSE                                  /*MUST BE SPECIFIC VOLSER     */
*  VOLIDPTR = ADDR(VMVMVLSR);          /*ASSIGN VOLSER PTR.          */
         B     @RC00399                                         02S0426
@RF00399 L     @12,VMVREQBP                                     02S0426
         LA    @12,VMVMVLSR(,@12)                               02S0426
         ST    @12,VOLIDPTR                                     02S0426
*UNITADD = UCBNAME;                    /*EBCDIC UNIT NAME            */
@RC00399 L     @12,UCBPTR                                       02S0427
         MVC   UNITADD(3),UCBNAME(@12)                          02S0427
*ACTCODE = MOUNTCD;                    /*ACTION CODE                 */
         MVI   ACTCODE,X'01'                                    02S0428
*CALL IEFAB499(PARMLIST,VOLIDPTR,VMVJBNMP,VMVJSNMP,VMVDSNMP);   02S0429
         LA    @12,PARMLIST                                     02S0429
         ST    @12,@AL00001                                     02S0429
         LA    @12,VOLIDPTR                                     02S0429
         ST    @12,@AL00001+4                                   02S0429
         L     @12,VMVREQBP                                     02S0429
         LA    @11,VMVJBNMP(,@12)                               02S0429
         ST    @11,@AL00001+8                                   02S0429
         LA    @11,VMVJSNMP(,@12)                               02S0429
         ST    @11,@AL00001+12                                  02S0429
         LA    @12,VMVDSNMP(,@12)                               02S0429
         ST    @12,@AL00001+16                                  02S0429
         L     @15,@CV02459                                     02S0429
         LA    @01,@AL00001                                     02S0429
         BALR  @14,@15                                          02S0429
*RETCODE=REG15;                        /*PICK UP RETURN CODE         */
         LR    RETCODE,REG15                                    02S0430
*                                      /*WTO/WTOR PARMLIST   @Y30LPPD*/
*                      IF RETCODE = SUCCESS THEN          /* @Y30LPPD*/
         LTR   RETCODE,RETCODE                                  01S0431
         BNZ   @RF00431                                         01S0431
*                                      /*IF WTO SETUP SUCCESS@Y30LPPD*/
*                        DO;                              /* @Y30LPPD*/
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - B495IWTO                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - ISSUE WTO/WTOR AND UPDATE CONTROL BLOCKS.     */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   ISSUES MOUNT WTO OR WTOR AND UPDATES CONTROL BLOCKS AS FOLLOWS:*/
*/*     1.IF TAPE WTOR OR DA REQUEST PUTS UCB PTR AND DOM ID IN MOUNT*/
*/*       ENTRY AND UPDATES DEVICE ENTRY COUNT.                      */
*/*     2.IF TAPE WTO PUTS DOM ID IN UCB.                            */
*/*     3.IF SPECIFIC REQUEST PUTS VOLSER IN UCB.                    */
*/*     4.FREES WTO/R CONTROL PROG. PARM LIST.                       */
*/*     5.LOCKS WHEN UPDATING UCB.                                   */
*/*     6.TURN THE MOUNT MESSAGE PENDING BIT OFF(UCBMMSGP)   @ZA15006*/
*/*                                                                  */
*/*   OPERATION - SEE FUNCTION                                       */
*/*                                                                  */
*/* ENTRY POINT -(INLINE SUBROUTINE - ENTERED AT THE TOP)            */
*/*                                                                  */
*/*   PURPOSE - TO ISSUE MOUNT WTO/WTOR AND UPDATE CONTROL BLOCKS    */
*/*             WITH DOM ID                                          */
*/*                                                                  */
*/* INPUT -                                                          */
*/*   WTOLISTP - PTR TO WTO/WTOR CONTROL PGM PARM LIST               */
*/*   VM&V REQ.BLOCK -CONTAINS WTO/WTOR INDICATORS                   */
*/*   WTOLSTLN - LEN.OF WTO/WTOR CONTROL PGM PARM LIST               */
*/*                                                                  */
*/* EXIT - NORMAL - (INLINE SUBROUTINE - EXITS AT BOTTOM)            */
*/*                                                                  */
*/*   CONDITION - WTO/WTOR ISSUED AND CONTROL BLOCKS UPDATED.        */
*/*                                                                  */
*/*   OUTPUT -      IF TAPE WTO UCB UPDATED WITH DOM ID              */
*/*                 IF TAPE WTOR OR DA REQUEST MOUNT ENTRY UPDATED   */
*/*                 WITH DOM ID                                      */
*/*   RETURN CODE - N/A                                              */
*/*                                                                  */
*/********************************************************************/
*IF VMVDWTOR = ON THEN                 /*IF WTOR REQUEST             */
         L     @12,VMVREQBP                                     02S0433
         TM    VMVDWTOR(@12),B'00000100'                        02S0433
         BNO   @RF00433                                         02S0433
*  DO;                                                          02S0434
*    RFY (REG0,REG1,REG2,REG3,REG4) RSTD;                       02S0435
*    REG0 = ZERO;                      /*ZERO REG0                   */
         SLR   REG0,REG0                                        02S0436
*    REG1 = WTOLISTP;                  /*ADDR OF CNTRL PROG PARM LIST*/
         L     REG1,WTOLISTP                                    02S0437
*    REG2 = REPLYLEN;                  /*LEN OF REPLY                */
         LH    REG2,REPLYLEN                                    02S0438
*    REG3 = MWTOREBP;                  /*ADDRESS OF WTOR REPLY ECB   */
         L     REG3,MWTOREBP                                    02S0439
*    REG4 = ADDR(MVWTORRA);            /*REPLY AREA                  */
         L     @12,MVCAPTR                                      02S0440
         L     REG4,MVCAXPTR(,@12)                              02S0440
         LA    REG4,MVWTORRA(,REG4)                             02S0440
*                                      /*ISSUE WTOR                  */
*    GENERATE REFS(REG4,REG2,REG3);                             02S0441
           WTOR ,(REG4),(REG2),(REG3),MF=(E,(1))
*    DOMIDVAL = REG1;                  /*PICK UP DOM ID              */
         ST    REG1,DOMIDVAL                                    02S0442
*    RFY (REG0,REG1,REG2,REG3,REG4) UNRSTD;                     02S0443
*  END;                                                         02S0444
*ELSE                                  /*MUST BE WTO                 */
*  DO;                                                          02S0445
         B     @RC00433                                         02S0445
@RF00433 DS    0H                                               02S0446
*    RFY (REG0,REG1) RSTD;                                      02S0446
*    REG0 = ZERO;                      /*ZERO REG0                   */
         SLR   REG0,REG0                                        02S0447
*    REG1 = WTOLISTP;                  /*ADDR OF CNTRL PROG PARM LIST*/
         L     REG1,WTOLISTP                                    02S0448
*    GEN (WTO MF=(E,(1)));             /*ISSUE MESSAGE               */
         WTO MF=(E,(1))
*    DOMIDVAL = REG1;                  /*PICK UP DOM ID              */
         ST    REG1,DOMIDVAL                                    02S0450
*    RFY (REG0,REG1) UNRSTD;                                    02S0451
*  END;                                                         02S0452
*RFY (REG0,REG1) RSTD;                                          02S0453
@RC00433 DS    0H                                               02S0454
*REG1=WTOLISTP;                        /*WTO CONTROL PROG LIST       */
         L     REG1,WTOLISTP                                    02S0454
*REG0=WTOLSTLN;                        /*LEN OF CONTROL PROG LIST    */
         LH    REG0,WTOLSTLN                                    02S0455
*REG0 = REG0 | SUBPL230;               /*FREE FROM SUBPOOL 230.      */
         O     REG0,@CF01645                                    02S0456
*GEN(FREEMAIN R,LV=(0),A=(1));         /*FREESPACE                   */
         FREEMAIN R,LV=(0),A=(1)
*RFY (REG0,REG1) UNRSTD;                                        02S0458
*IF UCB3DACC = ON                      /*IS THIS DIRECT ACCESS       */
*  | VMVDWTOR = ON THEN                /*OR WTOR REQUEST             */
         L     @12,UCBPTR                                       02S0459
         TM    UCB3DACC(@12),B'00100000'                        02S0459
         BO    @RT00459                                         02S0459
         L     @12,VMVREQBP                                     02S0459
         TM    VMVDWTOR(@12),B'00000100'                        02S0459
         BNO   @RF00459                                         02S0459
@RT00459 DS    0H                                               02S0460
*  DO;                                                          02S0460
*    MTDOMIDS(OFFSET) = DOMIDVAL;      /*PUT DOM ID IN MOUNT ENTRY   */
         LR    @12,OFFSET                                       02S0461
         SLA   @12,2                                            02S0461
         L     @11,MTENTPTR                                     02S0461
         L     @11,MTDOMPTR(,@11)                               02S0461
         L     @06,DOMIDVAL                                     02S0461
         AL    @11,@CF02496                                     02S0461
         ST    @06,MTDOMIDS(@12,@11)                            02S0461
*  END;                                                         02S0462
*ELSE;                                 /*MUST BE TAPE                */
@RF00459 DS    0H                                               02S0464
*/*GET KEY ZERO AND LOCK                                             */
* DO; /*MODESET  KEYADDR(ZERO)*/                                02S0464
*   SPKA (ZERO); /*SET PSW KEY*/                                02S0465
         SLR   @12,@12                                          02S0465
         SPKA  0(@12)                                           02S0465
* END; /*MODESET  KEYADDR(ZERO)*/               /*GET KEY ZERO  02S0466
*      */                                                       02S0466
* DO; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(LOCAL) REGS(USE) RELATED(UC
*,IEFAB495(B495IWTO)) */                                        02S0467
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                     02S0468
*   RFY (GPR15P,GPR00P,GPR01P) RSTD;                            02S0469
*   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */             02S0470
         LR    GPR15P,GPR11P                                    02S0470
*   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */              02S0471
         LR    GPR00P,GPR12P                                    02S0471
*   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */              02S0472
         LR    GPR01P,GPR13P                                    02S0472
*   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */    02S0473
         L     GPR13P,PSALITA                                   02S0473
*   GEN(LM GPR11P,GPR13P,576(GPR13P)); /* LOAD LOCKWORD, CLHT AND ENTRY
*ADRS. */                                                       02S0474
         LM GPR11P,GPR13P,576(GPR13P)
*   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */         02S0475
         BALR GPR14P,GPR13P
*   GPR11P = GPR15P; /* RESTORE REG. 11. */                     02S0476
         LR    GPR11P,GPR15P                                    02S0476
*   GPR15P = GPR13P; /* SAVE RETURN CODE. */                    02S0477
         LR    GPR15P,GPR13P                                    02S0477
*   GPR12P = GPR00P; /* RESTORE REG. 12 */                      02S0478
         LR    GPR12P,GPR00P                                    02S0478
*   GPR13P = GPR01P; /* RESTORE REG. 13. */                     02S0479
         LR    GPR13P,GPR01P                                    02S0479
*   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                           02S0480
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;                   02S0481
* END; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(LOCAL) REGS(USE) RELATED(U
*B,IEFAB495(B495IWTO)) */     /*GET LOCAL LOCKS             */  02S0482
* DO; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(CMS) REGS(USE) RELATED(UCB,
*EFAB495(B495IWTO)) */                                          02S0483
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                     02S0484
*   RFY (GPR15P,GPR00P,GPR01P) RSTD;                            02S0485
*   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */             02S0486
         LR    GPR15P,GPR11P                                    02S0486
*   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */              02S0487
         LR    GPR00P,GPR12P                                    02S0487
*   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */              02S0488
         LR    GPR01P,GPR13P                                    02S0488
*   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */    02S0489
         L     GPR13P,PSALITA                                   02S0489
*   GEN(LM GPR11P,GPR13P,540(GPR13P)); /* LOAD LOCKWORD, CLHT AND ENTRY
*ADRS. */                                                       02S0490
         LM GPR11P,GPR13P,540(GPR13P)
*   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */         02S0491
         BALR GPR14P,GPR13P
*   GPR11P = GPR15P; /* RESTORE REG. 11. */                     02S0492
         LR    GPR11P,GPR15P                                    02S0492
*   GPR15P = GPR13P; /* SAVE RETURN CODE. */                    02S0493
         LR    GPR15P,GPR13P                                    02S0493
*   GPR12P = GPR00P; /* RESTORE REG. 12 */                      02S0494
         LR    GPR12P,GPR00P                                    02S0494
*   GPR13P = GPR01P; /* RESTORE REG. 13. */                     02S0495
         LR    GPR13P,GPR01P                                    02S0495
*   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                           02S0496
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;                   02S0497
* END; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(CMS) REGS(USE) RELATED(UCB
*IEFAB495(B495IWTO)) */     /*GET CMS LOCKS               */    02S0498
*UCBMOUNT = ON;                        /*SET MOUNT PENDING BIT       */
         L     @12,UCBPTR                                       02S0499
         OI    UCBMOUNT(@12),B'10000000'                        02S0499
*UCBMMSGP = OFF;                       /*TURN OFF MOUNT MESSAGE 02S0500
*                                        PENDING INDICATOR   @ZA15006*/
         NI    UCBMMSGP(@12),B'11111011'                        02S0500
*IF VMVMVLSR ^= BLANKS THEN            /*IF VOLSER SPECIFIC          */
         L     @11,VMVREQBP                                     02S0501
         CLC   VMVMVLSR(6,@11),BLANKS                           02S0501
         BE    @RF00501                                         02S0501
*  DO;                                                          02S0502
*    UCBVOLI = VMVMVLSR;               /*MOVE REQ.BLK.VOLSER TO UCB  */
         MVC   UCBVOLI(6,@12),VMVMVLSR(@11)                     02S0503
*  END;                                                         02S0504
*ELSE;                                 /*NON-SPECIFIC VOLSER         */
@RF00501 DS    0H                                               02S0506
*IF UCB3DACC = OFF                     /*IF NOT DIRECT ACCESS        */
*  & VMVDWTOR = OFF THEN               /*OR WTOR REQUEST             */
         L     @12,UCBPTR                                       02S0506
         TM    UCB3DACC(@12),B'00100000'                        02S0506
         BNZ   @RF00506                                         02S0506
         L     @11,VMVREQBP                                     02S0506
         TM    VMVDWTOR(@11),B'00000100'                        02S0506
         BNZ   @RF00506                                         02S0506
*  DO;                                                          02S0507
*    UCBFSER(1:3) = DOMIDVAL(2:4);     /*PUT DOM ID IN UCB           */
         MVC   UCBFSER(3,@12),DOMIDVAL+1                        02S0508
*    UCBBNUL = ON;                     /*INDICATE DOM ID IN UCB      */
         OI    UCBBNUL(@12),B'00000001'                         02S0509
*  END;                                                         02S0510
*ELSE;                                 /*DA OR WTOR                  */
@RF00506 DS    0H                                               02S0512
*/*FREE LOCK AND RESTORE KEY                                         */
* DO; /* SETLOCK (RELEASE) TYPE(CMS) REGS(USE) RELATED(UCB,IEFAB495(B49
*IWTO)) */                                                      02S0512
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                     02S0513
*   RFY (GPR15P,GPR00P,GPR01P) RSTD;                            02S0514
*   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */             02S0515
         LR    GPR15P,GPR11P                                    02S0515
*   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */              02S0516
         LR    GPR00P,GPR12P                                    02S0516
*   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */              02S0517
         LR    GPR01P,GPR13P                                    02S0517
*   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */    02S0518
         L     GPR13P,PSALITA                                   02S0518
*   GEN(LM GPR11P,GPR13P,552(GPR13P)); /* LOAD LOCKWORD, CLHT AND ENTRY
*ADRS. */                                                       02S0519
         LM GPR11P,GPR13P,552(GPR13P)
*   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */         02S0520
         BALR GPR14P,GPR13P
*   GPR11P = GPR15P; /* RESTORE REG. 11. */                     02S0521
         LR    GPR11P,GPR15P                                    02S0521
*   GPR15P = GPR13P; /* SAVE RETURN CODE. */                    02S0522
         LR    GPR15P,GPR13P                                    02S0522
*   GPR12P = GPR00P; /* RESTORE REG. 12 */                      02S0523
         LR    GPR12P,GPR00P                                    02S0523
*   GPR13P = GPR01P; /* RESTORE REG. 13. */                     02S0524
         LR    GPR13P,GPR01P                                    02S0524
*   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                           02S0525
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;                   02S0526
* END; /* SETLOCK (RELEASE) TYPE(CMS) REGS(USE) RELATED(UCB,IEFAB495(B4
*5IWTO)) */     /*RELEASE CMS LOCK            */                02S0527
* DO; /* SETLOCK (RELEASE) TYPE(LOCAL) REGS(USE) RELATED(UCB,IEFAB495(B
*95IWTO)) */                                                    02S0528
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                     02S0529
*   RFY (GPR15P,GPR00P,GPR01P) RSTD;                            02S0530
*   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */             02S0531
         LR    GPR15P,GPR11P                                    02S0531
*   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */              02S0532
         LR    GPR00P,GPR12P                                    02S0532
*   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */              02S0533
         LR    GPR01P,GPR13P                                    02S0533
*   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */    02S0534
         L     GPR13P,PSALITA                                   02S0534
*   GEN(LM GPR11P,GPR13P,588(GPR13P)); /* LOAD LOCKWORD, CLHT AND ENTRY
*ADRS. */                                                       02S0535
         LM GPR11P,GPR13P,588(GPR13P)
*   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */         02S0536
         BALR GPR14P,GPR13P
*   GPR11P = GPR15P; /* RESTORE REG. 11. */                     02S0537
         LR    GPR11P,GPR15P                                    02S0537
*   GPR15P = GPR13P; /* SAVE RETURN CODE. */                    02S0538
         LR    GPR15P,GPR13P                                    02S0538
*   GPR12P = GPR00P; /* RESTORE REG. 12 */                      02S0539
         LR    GPR12P,GPR00P                                    02S0539
*   GPR13P = GPR01P; /* RESTORE REG. 13. */                     02S0540
         LR    GPR13P,GPR01P                                    02S0540
*   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                           02S0541
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;                   02S0542
* END; /* SETLOCK (RELEASE) TYPE(LOCAL) REGS(USE) RELATED(UCB,IEFAB495(
*495IWTO)) */     /*RELEASE LOCAL LOCK          */              02S0543
* DO; /*MODESET  EXTKEY(SCHED)*/                                02S0544
*   SPKA (16); /*SET PSW KEY*/                                  02S0545
         LA    @12,16                                           02S0545
         SPKA  0(@12)                                           02S0545
* END; /*MODESET  EXTKEY(SCHED)*/               /*GET SCHED KEY 02S0546
*      */                                                       02S0546
*                                      /*ISSUE WTO/WTOR      @Y30LPPD*/
*                        END;                             /* @Y30LPPD*/
*                      ELSE;           /*WTO SETUP FAILURE   @Y30LPPD*/
@RF00431 DS    0H                                               01S0549
*                    END;                                 /* @Y30LPPD*/
*                END;                                           01S0550
@RC00222 DS    0H                                               01S0551
*              IF UCB3DACC = ON |      /*DIRECT ACCESS               */
*                VMVDWTOR = ON THEN    /*OR WTOR                     */
@RF00220 L     @12,UCBPTR                                       01S0551
         TM    UCB3DACC(@12),B'00100000'                        01S0551
         BO    @RT00551                                         01S0551
         L     @12,VMVREQBP                                     01S0551
         TM    VMVDWTOR(@12),B'00000100'                        01S0551
         BNO   @RF00551                                         01S0551
@RT00551 DS    0H                                               01S0552
*                OFFSET = OFFSET + ONE; /*BUMP MT ENTRY INDEX        */
         AH    OFFSET,@CH00102                                  01S0552
*            END;                                               01S0553
*          ELSE;                       /*NO MESSAGE ISSUED           */
@RF00206 DS    0H                                               01S0555
*          MOUNTCNT = MOUNTCNT - ONE;  /*DECREMENT MOUNT REQUEST CNT.*/
@RC00206 L     @12,@PC00001+12                                  01S0555
         L     @11,MOUNTCNT(,@12)                               01S0555
         BCTR  @11,0                                            01S0555
         ST    @11,MOUNTCNT(,@12)                               01S0555
*        END;                                                   01S0556
*      ELSE;                           /*NOT MOUNT REQUEST           */
@RF00204 DS    0H                                               01S0558
*      VMVREQBP = VMVNREQP;            /*PTR TO NEXT REQUEST         */
         L     @12,VMVREQBP                                     01S0558
         L     @12,VMVNREQP(,@12)                               01S0558
         ST    @12,VMVREQBP                                     01S0558
*    END;                                                       01S0559
@DE00203 SLR   @12,@12                                          01S0559
         C     @12,VMVREQBP                                     01S0559
         BE    @DC00203                                         01S0559
         L     @11,@PC00001+12                                  01S0559
         C     @12,MOUNTCNT(,@11)                               01S0559
         BE    @DC00203                                         01S0559
         CR    RETCODE,@12                                      01S0559
         BE    @DL00203                                         01S0559
@DC00203 DS    0H                                               01S0560
*END;                                                           01S0560
*RETURN CODE(RETCODE);                 /*RETURN CODE PASSED TO  01S0561
*                                        CALLER IN REG. 15           */
@RF00200 IC    @02,@OLDKEY                                      01S0561
         L     @13,4(,@13)                                      01S0561
         L     @00,@SIZDATD                                     01S0561
         LR    @01,@09                                          01S0561
         FSPACE   R,LV=(0),A=(1)
         MODESET KEYADDR=(2)
         LR    @15,@07                                          01S0561
         L     @14,12(,@13)                                     01S0561
         LM    @00,@12,20(@13)                                  01S0561
         BR    @14                                              01S0561
*END IEFAB495                                                   01S0562
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (B495SPEC)                                        *
*/*%INCLUDE SYSLIB  (B495DATA)                                        *
*/*%INCLUDE SYSLIB  (VIRTDATA)                                        *
*/*%INCLUDE SYSLIB  (IEZMNTXT)                                        *
*/*%INCLUDE SYSLIB  (CVT     )                                        *
*/*%INCLUDE SYSLIB  (IKJTCB  )                                        *
*/*%INCLUDE SYSLIB  (IEZJSCB )                                        *
*/*%INCLUDE SYSLIB  (IEFASIOT)                                        *
*/*%INCLUDE SYSLIB  (IEFZB423)                                        *
*/*%INCLUDE SYSLIB  (MSPCDATA)                                        *
*/*%INCLUDE SYSLIB  (MSGSDATA)                                        *
*/*%INCLUDE SYSLIB  (IEFUCBOB)                                        *
*/*%INCLUDE SYSLIB  (IEFZB431)                                        *
*/*%INCLUDE SYSLIB  (IEFZB433)                                        *
*/*%INCLUDE SYSLIB  (IHAPSA  )                                        *
*/*%INCLUDE SYSLIB  (B495MSPC)                                        *
*/*%INCLUDE SYSLIB  (MSPCSPEC)                                        *
*/*%INCLUDE SYSLIB  (VIRTMONT)                                        *
*/*%INCLUDE SYSLIB  (VIRTSPEC)                                        *
*/*%INCLUDE SYSLIB  (MSGSETUP)                                        *
*/*%INCLUDE SYSLIB  (MSGSSPEC)                                        *
*/*%INCLUDE SYSLIB  (B495IWTO)                                        *
*/*%INCLUDE SYSLIB  (IWTOSPEC)                                        *
*;                                                              01S0562
@DATA    DS    0H
@CH00102 DC    H'1'
@CH00146 DC    H'5'
@CH00125 DC    H'6'
@CH00088 DC    H'8'
@CH01558 DC    H'12'
@CH00054 DC    H'16'
@CH00162 DC    H'18'
@CH00170 DC    H'20'
@CH00176 DC    H'24'
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    5F
@AL00001 DS    5A
@TF00001 DS    F
IEFAB495 CSECT
         DS    0F
@CF00158 DC    F'7'
@CF02484 DC    F'25'
@CF00164 DC    F'519'
@CF00166 DC    F'549'
@CF02494 DC    F'-240'
@CF02489 DC    F'-11'
@CF02490 DC    F'-8'
@CF02496 DC    F'-4'
@CF02491 DC    F'-3'
@CF01645 DC    XL4'E6000000'
@DATD    DSECT
         DS    0D
MTENTPTR DS    A
MVCAPTR  DS    A
UCBPTR   DS    A
VMVREQBP DS    A
BUFFPTR  DS    A
NEWLEN   DS    F
TEXTLEN  DS    F
PARMPTR  DS    A
MWTOREBP DS    A
VOLIDPTR DS    A
GTSTRTCD DS    F
RETURNC  DS    H
         DS    CL2
MEXT     DS    CL16
MNTERMSG DS    CL79
         ORG   MNTERMSG
MNTLEN   DS    FL2
@NM00004 DS    CL2
MNTPT1   DS    CL25
         ORG   MNTPT1
@NM00005 DS    CL8
MNTJNAM  DS    CL8
@NM00006 DS    CL1
MNTSNAM  DS    CL8
         ORG   MNTERMSG+29
MNTPT2   DS    CL50
         ORG   MNTPT2
@NM00007 DS    CL28
MNTVLSR  DS    CL6
@NM00008 DS    CL4
MNTVUA   DS    CL3
@NM00009 DS    CL2
MNTRET   DS    CL3
@NM00010 DS    CL4
         ORG   MNTERMSG+79
UNPKAR   DS    CL5
VIRTUA   DS    CL2
VIRTVLSR DS    CL6
RSN      DS    CL5
         ORG   RSN
MNTRSN   DS    FL4
         ORG   RSN+5
VIRTFLAG DS    BL2
         ORG   VIRTFLAG
@NM00011 DS    BL1
MNTSVLR  EQU   VIRTFLAG+0
MNTSCR   EQU   VIRTFLAG+0
         ORG   VIRTFLAG+2
         DS    CL1
MNTLST   DS    CL28
         ORG   MNTLST
MDLEN    DS    FL4
MDOPCD   DS    FL1
@NM00012 DS    CL1
MDFLG    DS    BL2
         ORG   MDFLG
@NM00013 DS    BL1
MDVISMNT EQU   MDFLG+0
MDVSVRQ  EQU   MDFLG+0
MDSRTCH  EQU   MDFLG+0
MDMEXT   EQU   MDFLG+0
@NM00014 EQU   MDFLG+0
         ORG   MNTLST+8
MDVOL    DS    CL6
MDVUA    DS    FL2
MDHOST   DS    CL5
@NM00015 DS    CL3
MNTEXTP  DS    AL4
         ORG   MNTEXTP
MDJFCB   DS    FL4
         ORG   MNTLST+28
LASTINDC DS    BL1
         DS    CL3
PARMAREA DS    CL8
         ORG   PARMAREA
FUNCMAP  DS    CL2
         ORG   FUNCMAP
ADDINDC  DS    BL1
DELTINDC EQU   FUNCMAP+0
SRCHINDC EQU   FUNCMAP+0
@NM00043 EQU   FUNCMAP+0
         ORG   PARMAREA+2
INPTASID DS    CL2
MVCAMPTR DS    AL4
         ORG   PARMAREA+8
DOMIDVAL DS    CL4
PARMLIST DS    CL20
         ORG   PARMLIST
MSGID    DS    FL1
ACTCODE  DS    CL1
UNITADD  DS    CL3
LABELTYP DS    CL1
INDICATS DS    CL2
         ORG   INDICATS
WTORINDC DS    BL1
WTOINDC  EQU   INDICATS+0
DAUNIT   EQU   INDICATS+0
TAPEUNIT EQU   INDICATS+0
@NM00044 EQU   INDICATS+0
         ORG   PARMLIST+8
ADDINFOP DS    AL4
ADDLILEN DS    FL2
WTOLSTLN DS    FL2
WTOLISTP DS    AL4
         ORG   PARMLIST+20
@OLDKEY  DS    AL1
IEFAB495 CSECT
         DS    0F
@SIZDATD DC    AL1(230)
         DC    AL3(@ENDDATD-@DATD)
@CA00179 DC    A(VVMNTMSG)
@CV00180 DC    V(IEFAB4F3)
@CA01676 DC    A(MTREPLYM)
@CA01681 DC    A(PRIVAT)
@CA01684 DC    A(SCRTCH)
@CV02458 DC    V(IEFAB498)
@CV02459 DC    V(IEFAB499)
@CV02460 DC    V(IEFAB4E0)
         DS    0D
GTSTZERO DC    F'0'
ADDINLEN DC    AL2(11)
REPLYLEN DC    AL2(2)
@CC00172 DC    C'SCRTCH'
@CB00100 DC    X'2009'
TRPATN   DC    CL16'0123456789ABCDEF'
BLANKS   DC    CL6' '
IEFAB495 CSECT
         DS   0H
PATCHLOC DC ((@DATA-@PSTART)/20)X'00'
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEFAB495 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
PARMLSTP EQU   @02
GETLENTH EQU   @12
SPACEADD EQU   @11
VUPTR    EQU   @02
SIOTPTR  EQU   @03
RETCODE  EQU   @07
OFFSET   EQU   @08
TCBPTR   EQU   @03
JSCBPTR  EQU   @02
REG0     EQU   @00
REG1     EQU   @01
REG2     EQU   @02
REG3     EQU   @03
REG4     EQU   @04
REG15    EQU   @15
GPR00P   EQU   @00
GPR01P   EQU   @01
GPR14P   EQU   @14
GPR15P   EQU   @15
GPR13P   EQU   @13
GPR12P   EQU   @12
GPR11P   EQU   @11
MDREG1   EQU   @01
GTSTR0   EQU   @00
GTSTR1   EQU   @01
GTSTR2   EQU   @02
GTSTR15  EQU   @15
GTSTR4   EQU   @04
GTSTR5   EQU   @05
GTSTR6   EQU   @06
GTSTR7   EQU   @07
GTSTR8   EQU   @08
GPR00F   EQU   @00
GPR01F   EQU   @01
GPR11F   EQU   @11
GPR12F   EQU   @12
GPR13F   EQU   @13
GPR14F   EQU   @14
GPR15F   EQU   @15
GTSTR3   EQU   @03
         EXTRN VVMNTMSG
         EXTRN MTREPLYM
         EXTRN PRIVAT
         EXTRN SCRTCH
CVTPTR   EQU   16
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSALITA  EQU   PSA+764
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
TCBS     EQU   0
CURTCB   EQU   TCBS+4
NAME     EQU   0
PART2    EQU   0
TRANSTAB EQU   0
MNTXT    EQU   0
MNTXJFCB EQU   MNTXT
MNTXJOBN EQU   MNTXT+4
MNTXSTEP EQU   MNTXT+8
CVTMAP   EQU   0
CVTTCBP  EQU   CVTMAP
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBJPQ   EQU   TCB+44
TCBPURGE EQU   TCBJPQ
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTME   EQU   TCB+120
TCBJSTCB EQU   TCB+124
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBXSCT  EQU   TCB+240
TCBXSCT1 EQU   TCBXSCT
TCBFOE   EQU   TCB+244
TCBESTAE EQU   TCB+264
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCB+276
TCBFBYT2 EQU   TCB+277
TCBRV124 EQU   TCB+278
TCBRV133 EQU   TCB+279
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
IEZJSCB  EQU   0
JSCBSEC1 EQU   IEZJSCB+188
JSCHPCE  EQU   JSCBSEC1+4
JSCBDCB  EQU   JSCBSEC1+36
JSCBSTEP EQU   JSCBSEC1+40
JSCBOPTS EQU   JSCBSEC1+48
JSCBSWT1 EQU   JSCBSEC1+55
JSCBWTP  EQU   JSCBSEC1+64
JSCBWTFG EQU   JSCBWTP
JSCBEND1 EQU   IEZJSCB+260
INDMSIOT EQU   0
SCTUSADD EQU   INDMSIOT+20
SIOTBYT1 EQU   INDMSIOT+43
SIOTBYT3 EQU   INDMSIOT+46
SIOTTSTC EQU   INDMSIOT+47
SIOTBYT0 EQU   INDMSIOT+52
SCTSDISP EQU   INDMSIOT+55
SCTSBYT1 EQU   INDMSIOT+56
SCTSBYT2 EQU   INDMSIOT+57
SCTSBYT3 EQU   INDMSIOT+58
SCTSBYT4 EQU   INDMSIOT+59
SCTUTYPE EQU   INDMSIOT+60
SIOTDEVT EQU   SCTUTYPE
SIOUBYT3 EQU   SIOTDEVT+2
SIOTBYT4 EQU   INDMSIOT+81
SIOTALTD EQU   INDMSIOT+92
SIOTBYT2 EQU   INDMSIOT+103
SJFCBPTR EQU   INDMSIOT+156
VOLUNTAB EQU   0
VOLSTAT  EQU   VOLUNTAB+6
VOLSTATA EQU   VOLSTAT
VUDADSM  EQU   VOLSTATA
VOLSTATB EQU   VOLSTAT+1
VOLSTATC EQU   VOLSTAT+2
VOLSTATD EQU   VOLSTAT+3
VOLSIOTP EQU   VOLUNTAB+16
VUUCBP   EQU   VOLUNTAB+20
VUGRID   EQU   VOLUNTAB+24
VUPOOL   EQU   0
VUGRLST  EQU   0
VUGRLENT EQU   VUGRLST
VUGRLFLG EQU   VUGRLENT+4
UCB      EQU   0
UCBOB    EQU   0
UCBJBNR  EQU   UCBOB
UCBMMSGP EQU   UCBJBNR
UCBFL5   EQU   UCBOB+1
UCBAF    EQU   UCBFL5
UCBSTAT  EQU   UCBOB+3
UCBCHAN  EQU   UCBOB+4
UCBSFLS  EQU   UCBOB+6
UCBFLA   EQU   UCBSFLS
UCBFL1   EQU   UCBFLA
UCBBSY   EQU   UCBFL1
UCBNRY   EQU   UCBFL1
UCBNOTRD EQU   UCBNRY
UCBPST   EQU   UCBFL1
UCBCUB   EQU   UCBFL1
UCBFLB   EQU   UCBSFLS+1
UCBCHM   EQU   UCBOB+8
UCBCHM1  EQU   UCBCHM
UCBPTH0  EQU   UCBCHM1
UCBPTH1  EQU   UCBCHM1
UCBWGT   EQU   UCBOB+12
UCBNAME  EQU   UCBOB+13
UCBTYP   EQU   UCBOB+16
UCBTBYT1 EQU   UCBTYP
UCB1FEA5 EQU   UCBTBYT1
UCB1FEA6 EQU   UCBTBYT1
UCBTBYT2 EQU   UCBTYP+1
UCB2OPT2 EQU   UCBTBYT2
UCBDUDN1 EQU   UCB2OPT2
UCB2OPT3 EQU   UCBTBYT2
UCBDUDN2 EQU   UCB2OPT3
UCB2OPT4 EQU   UCBTBYT2
UCBRWTAU EQU   UCB2OPT4
UCBRVDEV EQU   UCBRWTAU
UCB2OPT6 EQU   UCBTBYT2
UCB2OPT7 EQU   UCBTBYT2
UCBTBYT3 EQU   UCBTYP+2
UCBDVCLS EQU   UCBTBYT3
UCB3DACC EQU   UCBDVCLS
UCBTBYT4 EQU   UCBTYP+3
UCBEXTPT EQU   UCBOB+20
UCBFLC   EQU   UCBEXTPT
UCBDEV   EQU   UCBOB+24
UCBCMEXT EQU   0
UCBATI   EQU   UCBCMEXT+3
@NM00048 EQU   UCBATI
UCBFLP1  EQU   UCBCMEXT+5
UCBMIHBY EQU   UCBCMEXT+16
UCBMT    EQU   0
UCBOCR   EQU   0
UCB3540X EQU   0
UCBDKBYT EQU   UCB3540X+6
UCB3800X EQU   0
UCBOPTNS EQU   UCB3800X
UCBACTIV EQU   UCB3800X+3
UCBMDRBF EQU   UCB3800X+36
UCBUCS   EQU   0
UCBUCSOP EQU   UCBUCS+4
UCBFCBOP EQU   UCBUCS+5
VMVRQBLK EQU   0
VMVFNMAP EQU   VMVRQBLK
VMVOPTB1 EQU   VMVFNMAP
VMVMOUNT EQU   VMVOPTB1
VMVMTMSG EQU   VMVOPTB1
VMVDWTOR EQU   VMVOPTB1
VMVOPTB2 EQU   VMVFNMAP+1
VMVALTAP EQU   VMVOPTB2
VMVNLTAP EQU   VMVOPTB2
VMVSLTAP EQU   VMVOPTB2
VMVNSLTP EQU   VMVOPTB2
VMVNSPVT EQU   VMVOPTB2
VMVOPTB3 EQU   VMVFNMAP+2
VMVDUPVL EQU   VMVOPTB3
VMVNREQP EQU   VMVRQBLK+4
VMVUCBP  EQU   VMVRQBLK+9
VMVMVLSR EQU   VMVRQBLK+18
VMVJBNMP EQU   VMVRQBLK+24
VMVDSNMP EQU   VMVRQBLK+28
VMVJSNMP EQU   VMVRQBLK+32
VMVMINFO EQU   VMVRQBLK+40
VMVACTON EQU   VMVMINFO
VMVVUNTP EQU   VMVRQBLK+44
VMVUSER  EQU   VMVRQBLK+48
MVCA     EQU   0
MVCAASID EQU   MVCA+2
MVCAXPTR EQU   MVCA+12
MVCAX    EQU   0
MVSWITCH EQU   MVCAX+4
MVWTORSW EQU   MVSWITCH
MVENTRYP EQU   MVCAX+8
MVWTORRA EQU   MVCAX+12
MVNODEVE EQU   MVCAX+14
MVDAECB  EQU   MVCAX+16
MVTPECB  EQU   MVCAX+20
MTENTRY  EQU   0
MTENBASE EQU   MTENTRY
MTLENGTH EQU   MTENBASE
MTPRVPTR EQU   MTENBASE+4
MTNXTPTR EQU   MTENBASE+8
MTDEVPTR EQU   MTENBASE+12
MTDOMPTR EQU   MTENBASE+16
MTDEVENT EQU   0
MTSTATUS EQU   MTDEVENT
MTUCBPTR EQU   MTDEVENT+1
MTDSNMP  EQU   MTDEVENT+4
MTDVUPTR EQU   MTDEVENT+9
MTDOMIDS EQU   0
IKEBC    EQU   0
IKEBF15  EQU   0
IKEBF31  EQU   0
IKEBP15  EQU   0
IKEBP31  EQU   0
IKEBP8   EQU   0
MSSJFCB  EQU   0
UCBBGN   EQU   0
MTRPLYLN EQU   MTREPLYM
MTREPLY  EQU   MTREPLYM+2
REQUESTP EQU   0
ASID     EQU   0
CANCLECB EQU   0
CNTTAB   EQU   0
MOUNTCNT EQU   CNTTAB+4
DOMCNT   EQU   CNTTAB+12
VMVEXITP EQU   0
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
JSCBSEC2 EQU   JSCBEND1
JSCBSEC3 EQU   JSCBEND1
JSCBJCT  EQU   JSCBSEC3
JSCBJCTA EQU   JSCBJCT+1
JSCBASID EQU   JSCBSEC3+8
JSCBFBYT EQU   JSCBSEC3+10
JSCBJNL  EQU   JSCBSEC3+28
JSCBJJSB EQU   JSCBJNL
JSCBSUB  EQU   JSCBSEC3+40
JSCSCT   EQU   JSCBSEC3+68
JSCBACT  EQU   JSCBSEC3+88
JSCRSV45 EQU   JSCBSEC3+112
JSCRSV46 EQU   JSCRSV45
JSCRSV47 EQU   JSCRSV45+2
UCBOBS01 EQU   UCBDEV
UCBVOLI  EQU   UCBOBS01+4
UCBSTAB  EQU   UCBOBS01+10
UCBBSVL  EQU   UCBSTAB
UCBPRSRS EQU   UCBSTAB
UCBBNUL  EQU   UCBSTAB
UCBDMCT  EQU   UCBOBS01+11
UCBMOUNT EQU   UCBDMCT
UCBFL4   EQU   UCBOBS01+13
UCBOBS02 EQU   UCBDEV
UCBFSER  EQU   UCBOBS02+12
UCBTFL1  EQU   UCBOBS02+19
UCBXTN   EQU   UCBOBS02+20
UCBVOPT  EQU   UCBXTN
UCBOBS03 EQU   UCBDEV
UCBXTADR EQU   UCBOBS03
UCBOBS04 EQU   UCBDEV
UCBBTA   EQU   UCBOBS04+12
UCBOBS06 EQU   UCBDEV
UCBAOF   EQU   UCBOBS06
UCBAOF1  EQU   UCBAOF
UCBAOF2  EQU   UCBAOF+1
@NM00047 EQU   UCBOBS06+3
UCBIRB   EQU   UCBOBS06+4
UCBGRAF  EQU   UCBIRB
UCBLDNCA EQU   UCBOBS06+8
UCBRDYQ  EQU   UCBLDNCA
UCBIRLN  EQU   UCBRDYQ
UCBLDNCB EQU   UCBRDYQ+1
UCBCTLNK EQU   UCBOBS06+12
UCBOBS07 EQU   UCBDEV
UCBOBS08 EQU   UCBDEV
UCBCTCAD EQU   UCBOBS08
UCBCTCF1 EQU   UCBOBS08+4
UCBOBS09 EQU   UCBDEV
PSARSVTE EQU   PSARSVT
FLC      EQU   PSA
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
UCBRV066 EQU   UCBOBS09+4
UCBIOSBA EQU   UCBOBS09
UCBRV042 EQU   UCBOBS08+5
UCBRV082 EQU   UCBCTCF1
UCBRV081 EQU   UCBCTCF1
UCBRV080 EQU   UCBCTCF1
UCBRV079 EQU   UCBCTCF1
UCBRV078 EQU   UCBCTCF1
UCBRV077 EQU   UCBCTCF1
UCBRV076 EQU   UCBCTCF1
UCBCTC80 EQU   UCBCTCF1
UCBCTCAL EQU   UCBCTCAD
UCBICNCB EQU   UCBOBS07+4
UCBRV040 EQU   UCBOBS07
UCBCTLNA EQU   UCBCTLNK+1
UCBRLN   EQU   UCBCTLNK
UCBRDYQA EQU   UCBLDNCB
UCBINRLN EQU   UCBIRLN
UCBIRBA  EQU   UCBIRB+1
UCBRV039 EQU   UCBGRAF
UCBDWNR  EQU   UCBGRAF
UCBRPND  EQU   UCBGRAF
UCBUPM   EQU   UCBGRAF
UCBBTAM  EQU   UCBGRAF
UCBDRNO  EQU   UCBGRAF
UCBDRO   EQU   UCBGRAF
UCBOIP   EQU   UCBGRAF
UCBATRCD EQU   @NM00047
UCBSKPFG EQU   @NM00047
UCBRIPND EQU   @NM00047
UCBRTIAC EQU   @NM00047
UCBRSV79 EQU   @NM00047
UCBRSV78 EQU   @NM00047
UCBRSV77 EQU   @NM00047
UCBOLTEP EQU   @NM00047
UCBATNCT EQU   UCBOBS06+2
UCBRSV76 EQU   UCBAOF2
UCBRSV75 EQU   UCBAOF2
UCBRSV74 EQU   UCBAOF2
UCBRSV73 EQU   UCBAOF2
UCBRSV72 EQU   UCBAOF2
UCBRSV71 EQU   UCBAOF2
UCBRSV70 EQU   UCBAOF2
UCBRSV69 EQU   UCBAOF2
UCBRSV68 EQU   UCBAOF1
UCBRSV67 EQU   UCBAOF1
UCBRSV66 EQU   UCBAOF1
UCBRSV65 EQU   UCBAOF1
UCBRSV64 EQU   UCBAOF1
UCBOFNL  EQU   UCBAOF1
UCBOFSP  EQU   UCBAOF1
UCBOFMCR EQU   UCBAOF1
UCBBTB   EQU   UCBBTA+1
UCBDI    EQU   UCBBTA
UCBSNS   EQU   UCBOBS04+8
UCBTEB   EQU   UCBOBS04+4
UCBGCB   EQU   UCBOBS04+3
UCBOPEN  EQU   UCBOBS04+2
UCBSTART EQU   UCBOBS04
UCBXTNB  EQU   UCBXTN+1
UCBRSV22 EQU   UCBVOPT
UCBRSV21 EQU   UCBVOPT
UCBRSV20 EQU   UCBVOPT
UCBESVE  EQU   UCBVOPT
UCBERPC  EQU   UCBVOPT
UCBESVC  EQU   UCBVOPT
UCBEVA   EQU   UCBVOPT
UCBESV   EQU   UCBVOPT
UCBRV009 EQU   UCBTFL1
UCBRV008 EQU   UCBTFL1
UCBRV007 EQU   UCBTFL1
UCBRV006 EQU   UCBTFL1
UCBRV005 EQU   UCBTFL1
UCBDQDSP EQU   UCBTFL1
UCBNSLTP EQU   UCBTFL1
UCBNLTP  EQU   UCBTFL1
UCBRES1B EQU   UCBOBS02+18
@NM00046 EQU   UCBOBS02+4
UCBFSEQ  EQU   UCBOBS02+2
UCBFSCT  EQU   UCBOBS02
UCBNEXP  EQU   UCBOBS01+20
UCBBASE  EQU   UCBOBS01+16
UCBRES1A EQU   UCBOBS01+15
UCBUSER  EQU   UCBOBS01+14
UCBFL47  EQU   UCBFL4
UCBMAT   EQU   UCBFL4
UCBHOLD  EQU   UCBFL4
UCBATTN  EQU   UCBFL4
UCBDSS   EQU   UCBFL4
UCBRESVP EQU   UCBFL4
UCBWDAV  EQU   UCBFL4
UCBDAVV  EQU   UCBFL4
UCBSQC   EQU   UCBOBS01+12
UCBDATP  EQU   UCBOBS01+12
UCBDMC   EQU   UCBDMCT
UCBSHAR  EQU   UCBSTAB
UCBBSTR  EQU   UCBSTAB
UCBBPUB  EQU   UCBSTAB
UCBBPRV  EQU   UCBSTAB
UCBBALB  EQU   UCBPRSRS
UCBPGFL  EQU   UCBSTAB
UCBDVSHR EQU   UCBBSVL
UCBVTOC  EQU   UCBOBS01
JSCBEND3 EQU   JSCBSEC3+120
JSCRSV52 EQU   JSCBSEC3+116
JSCRSV51 EQU   JSCRSV47+1
JSCRSV50 EQU   JSCRSV47
JSCRSV49 EQU   JSCRSV46+1
JSCRSV48 EQU   JSCRSV46
JSCRSV44 EQU   JSCBSEC3+108
JSCRSV43 EQU   JSCBSEC3+104
JSCRSV42 EQU   JSCBSEC3+100
JSCBASWA EQU   JSCBSEC3+96
JSCBUFPT EQU   JSCBSEC3+92
JSCBSWSP EQU   JSCBSEC3+87
JSCRSV33 EQU   JSCBSEC3+86
JSCDDNUM EQU   JSCBSEC3+84
JSCRSV53 EQU   JSCBSEC3+82
JSCDDNNO EQU   JSCBSEC3+80
JSCBVATA EQU   JSCBSEC3+76
JSCTMCOR EQU   JSCBSEC3+72
JSCSCTP  EQU   JSCSCT+1
JSCRSV55 EQU   JSCSCT
JSCRSV54 EQU   JSCBSEC3+64
JSCDSABQ EQU   JSCBSEC3+60
JSCBSSIB EQU   JSCBSEC3+56
JSCBFRBA EQU   JSCBSEC3+48
JSCRSV28 EQU   JSCBSEC3+46
JSCBSONO EQU   JSCBSEC3+44
JSCBSUBA EQU   JSCBSUB+1
JSCRSV31 EQU   JSCBSUB
JSCBSMLR EQU   JSCBSEC3+36
JSCBJNLR EQU   JSCBSEC3+32
JSCBJNLA EQU   JSCBJNL+1
JSCBJSBT EQU   JSCBJJSB
JSCBJSBX EQU   JSCBJJSB
JSCBJSBA EQU   JSCBJJSB
JSCBJSBI EQU   JSCBJJSB
@NM00025 EQU   JSCBJJSB
JSCBJNLE EQU   JSCBJJSB
JSCBJNLF EQU   JSCBJJSB
JSCBJNLN EQU   JSCBJJSB
@NM00024 EQU   JSCBSEC3+24
JSCBJRBA EQU   JSCBSEC3+16
JSCBIECB EQU   JSCBSEC3+12
JSCBRV08 EQU   JSCBSEC3+11
JSCBRV07 EQU   JSCBFBYT
JSCBRV06 EQU   JSCBFBYT
JSCBRV05 EQU   JSCBFBYT
JSCBRV04 EQU   JSCBFBYT
JSCBRV03 EQU   JSCBFBYT
JSCBRV02 EQU   JSCBFBYT
JSCBADSP EQU   JSCBFBYT
JSCBRV01 EQU   JSCBFBYT
JSCBTJID EQU   JSCBASID
JSCBPSCB EQU   JSCBSEC3+4
JSCJCTP  EQU   JSCBJCTA
JSCRSV24 EQU   JSCBJCT
JSCBEND2 EQU   JSCBSEC2
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTHSM   EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
@NM00002 EQU   CNTTAB+8
@NM00001 EQU   CNTTAB
MTSAVNDX EQU   MTDEVENT+8
MTVRSVRD EQU   MTSTATUS
MTVRYVFY EQU   MTSTATUS
MTVRYLBL EQU   MTSTATUS
MTVRYPND EQU   MTSTATUS
@NM00055 EQU   MTENBASE+2
MVNUMWTS EQU   MVCAX+6
MVDISDSN EQU   MVSWITCH
MVDEVECB EQU   MVCAX
MVCANXTP EQU   MVCA+8
MVCAPRVP EQU   MVCA+4
@NM00054 EQU   MVCA
@NM00053 EQU   VMVUSER
VMVPROCD EQU   VMVUSER
@NM00052 EQU   VMVMINFO+1
@NM00051 EQU   VMVACTON
VMVRTAIN EQU   VMVACTON
VMVDSMT  EQU   VMVACTON
VMVKEEP  EQU   VMVACTON
VMVRETCD EQU   VMVRQBLK+36
VMVUVLSR EQU   VMVRQBLK+12
@NM00050 EQU   VMVRQBLK+8
VMVOPTB4 EQU   VMVFNMAP+3
@NM00049 EQU   VMVOPTB3
VMVNUMSG EQU   VMVOPTB3
VMVCUVOL EQU   VMVOPTB3
VMVSTRG  EQU   VMVOPTB2
VMVPUBLC EQU   VMVOPTB2
VMVPRIVT EQU   VMVOPTB2
VMVVDEND EQU   VMVOPTB1
VMVVRLBL EQU   VMVOPTB1
VMVREWND EQU   VMVOPTB1
VMVUCB   EQU   VMVOPTB1
VMVUNLOD EQU   VMVOPTB1
UCBERADR EQU   UCBUCS+12
UCBFCBID EQU   UCBUCS+8
UCBERCNT EQU   UCBUCS+7
UCBRSV51 EQU   UCBUCS+6
UCBFCBPE EQU   UCBFCBOP
UCBRSV49 EQU   UCBFCBOP
UCBRSV48 EQU   UCBFCBOP
UCBRSV47 EQU   UCBFCBOP
UCBRSV46 EQU   UCBFCBOP
UCBRSV45 EQU   UCBFCBOP
UCBRSV44 EQU   UCBFCBOP
UCBFCBO1 EQU   UCBFCBOP
UCBUCSPE EQU   UCBUCSOP
UCBRSV43 EQU   UCBUCSOP
UCBRSV42 EQU   UCBUCSOP
UCBRSV41 EQU   UCBUCSOP
UCBRSV40 EQU   UCBUCSOP
UCBRSV39 EQU   UCBUCSOP
UCBUCSO2 EQU   UCBUCSOP
UCBUCSO1 EQU   UCBUCSOP
UCBUCSID EQU   UCBUCS
UCBMDRBA EQU   UCBMDRBF+1
UCBRV075 EQU   UCBMDRBF
UCBRV074 EQU   UCB3800X+32
UCBIMAGE EQU   UCB3800X+28
UCBFCBNM EQU   UCB3800X+24
UCBCHAR4 EQU   UCB3800X+20
UCBCHAR3 EQU   UCB3800X+16
UCBCHAR2 EQU   UCB3800X+12
UCBCHAR1 EQU   UCB3800X+8
UCBCGMID EQU   UCB3800X+4
UCBBRSTA EQU   UCBACTIV
UCBRV063 EQU   UCBACTIV
UCBRV062 EQU   UCBACTIV
UCBRV061 EQU   UCBACTIV
UCBRV060 EQU   UCBACTIV
UCBRV059 EQU   UCBACTIV
UCBRV058 EQU   UCBACTIV
UCBRV057 EQU   UCBACTIV
UCBRV050 EQU   UCB3800X+2
UCBCGMNO EQU   UCB3800X+1
UCBRV083 EQU   UCBOPTNS
UCBBRSTR EQU   UCBOPTNS
UCBRV056 EQU   UCBOPTNS
UCBRV055 EQU   UCBOPTNS
UCBRV054 EQU   UCBOPTNS
UCBRV053 EQU   UCBOPTNS
UCBRV052 EQU   UCBOPTNS
UCBRV051 EQU   UCBOPTNS
UCBRV073 EQU   UCB3540X+7
UCBRV072 EQU   UCBDKBYT
UCBRV071 EQU   UCBDKBYT
UCBRV070 EQU   UCBDKBYT
UCBRV069 EQU   UCBDKBYT
UCBRV068 EQU   UCBDKBYT
UCBRV067 EQU   UCBDKBYT
UCBVLVER EQU   UCBDKBYT
UCBDKAMX EQU   UCBDKBYT
UCBVLSER EQU   UCB3540X
UCBRDATA EQU   UCBOCR+4
UCBFRID  EQU   UCBOCR
UCBCLN   EQU   UCBMT+14
UCBERG   EQU   UCBMT+12
UCBMS    EQU   UCBMT+11
UCBNB    EQU   UCBMT+10
UCBPW    EQU   UCBMT+9
UCBPR    EQU   UCBMT+8
UCBSIO   EQU   UCBMT+6
UCBTW    EQU   UCBMT+5
UCBTR    EQU   UCBMT+4
UCBTWT   EQU   UCBMT+3
UCBTRT   EQU   UCBMT+2
UCBCTD   EQU   UCBMT
UCBWTOID EQU   UCBCMEXT+17
UCBMIHTI EQU   UCBMIHBY
UCBMIHT2 EQU   UCBMIHBY
UCBMIHT1 EQU   UCBMIHBY
UCBMIHPB EQU   UCBMIHBY
UCBMIHSF EQU   UCBMIHBY
UCBASID  EQU   UCBCMEXT+14
UCBMFCNT EQU   UCBCMEXT+12
UCBPMSK  EQU   UCBCMEXT+10
UCBCCWOF EQU   UCBCMEXT+8
UCBRV041 EQU   UCBCMEXT+6
UCBRV036 EQU   UCBFLP1
UCBRV035 EQU   UCBFLP1
UCBERLOG EQU   UCBFLP1
UCBSWAPF EQU   UCBFLP1
UCBINHIO EQU   UCBFLP1
UCBNSWAP EQU   UCBFLP1
UCBSHRUP EQU   UCBFLP1
UCBNSRCH EQU   UCBFLP1
UCBSNSCT EQU   UCBCMEXT+4
UCBHPDV  EQU   @NM00048
UCBHALI  EQU   @NM00048
UCBRSV09 EQU   @NM00048
UCBRSV08 EQU   @NM00048
UCBRSV07 EQU   @NM00048
UCBRSV06 EQU   @NM00048
UCBRSV05 EQU   @NM00048
UCBRSV04 EQU   @NM00048
UCBDTI   EQU   UCBCMEXT+2
UCBSTI   EQU   UCBCMEXT+1
UCBETI   EQU   UCBCMEXT
UCBEXTP  EQU   UCBEXTPT+1
UCBDDRSW EQU   UCBFLC
UCBTICBT EQU   UCBFLC
UCBIVRR  EQU   UCBFLC
UCBIVRS  EQU   UCBFLC
UCBITF   EQU   UCBFLC
UCBUDE   EQU   UCBFLC
UCBWAA   EQU   UCBFLC
UCBATTP  EQU   UCBFLC
UCBUNTYP EQU   UCBTBYT4
UCBRSV11 EQU   UCBDVCLS
UCBRSV10 EQU   UCBDVCLS
UCB3CHAR EQU   UCBDVCLS
UCB3UREC EQU   UCBDVCLS
UCB3DISP EQU   UCBDVCLS
UCB3COMM EQU   UCBDVCLS
UCB3TAPE EQU   UCBDVCLS
UCBDVPWR EQU   UCB2OPT7
UCBVLPWR EQU   UCB2OPT6
UCB2OPT5 EQU   UCBTBYT2
UCBRPS   EQU   UCBDUDN2
UCBRR    EQU   UCBDUDN1
UCB2OPT1 EQU   UCBTBYT2
UCB2OPT0 EQU   UCBTBYT2
UCB1FEA7 EQU   UCBTBYT1
UCBD6250 EQU   UCB1FEA6
UCBD1600 EQU   UCB1FEA5
UCB1FEA4 EQU   UCBTBYT1
UCB1FEA3 EQU   UCBTBYT1
UCB1FEA2 EQU   UCBTBYT1
UCB1FEA1 EQU   UCBTBYT1
UCB1FEA0 EQU   UCBTBYT1
UCBRV029 EQU   UCBWGT
UCBVHRSN EQU   UCBWGT
UCBVORSN EQU   UCBWGT
UCBMTPXP EQU   UCBWGT
UCBREW   EQU   UCBWGT
UCBPUB   EQU   UCBWGT
UCBOUT   EQU   UCBWGT
UCBIN    EQU   UCBWGT
UCBCPU   EQU   UCBOB+11
UCBLCI   EQU   UCBOB+10
UCBCNT   EQU   UCBOB+9
UCBRV017 EQU   UCBCHM1
UCBRV016 EQU   UCBCHM1
UCBRV015 EQU   UCBCHM1
UCBRV014 EQU   UCBCHM1
UCBSPB   EQU   UCBPTH1
UCBPPB   EQU   UCBPTH1
UCBSPA   EQU   UCBPTH0
UCBPPA   EQU   UCBPTH0
UCBSIGP  EQU   UCBFLB
UCBVALPH EQU   UCBFLB
UCBCRHSN EQU   UCBFLB
UCBCRHRV EQU   UCBFLB
UCBRESVH EQU   UCBFLB
UCBSPST  EQU   UCBFLB
UCBASNS  EQU   UCBFLB
UCBIORST EQU   UCBFLB
UCBQISCE EQU   UCBFL1
UCBACTV  EQU   UCBFL1
UCBSAP   EQU   UCBFL1
UCBNOTRC EQU   UCBCUB
UCBPSNS  EQU   UCBFL1
UCBUSING EQU   UCBPST
UCBBUSYD EQU   UCBBSY
UCBUA    EQU   UCBCHAN+1
UCBCHA   EQU   UCBCHAN
UCBDADI  EQU   UCBSTAT
UCBSYSR  EQU   UCBSTAT
UCBPRES  EQU   UCBSTAT
UCBALOC  EQU   UCBSTAT
UCBUNLD  EQU   UCBSTAT
UCBRESV  EQU   UCBSTAT
UCBCHGS  EQU   UCBSTAT
UCBONLI  EQU   UCBSTAT
UCBID    EQU   UCBOB+2
UCBALTPH EQU   UCBFL5
UCBALTCU EQU   UCBFL5
UCBNALOC EQU   UCBFL5
UCBENVRD EQU   UCBFL5
UCBVSDR  EQU   UCBFL5
UCBSASK  EQU   UCBFL5
UCBAMV   EQU   UCBAF
UCBDCC   EQU   UCBFL5
UCBMONT  EQU   UCBJBNR
UCBRV011 EQU   UCBJBNR
UCBOLDSM EQU   UCBJBNR
UCBRV003 EQU   UCBJBNR
UCBDUC   EQU   UCBJBNR
UCBJES3  EQU   UCBJBNR
UCBVRDEV EQU   UCBJBNR
UCBCMSEG EQU   UCBOB
UCBPFXND EQU   UCB+512
UCBIOQ   EQU   UCB+508
UCBLOCK  EQU   UCB+504
UCBPXST  EQU   UCB+504
@NM00045 EQU   UCB
@NM00042 EQU   VUGRLENT+5
@NM00041 EQU   VUGRLFLG
VUGRALCD EQU   VUGRLFLG
VUGRLIDS EQU   VUGRLENT
VUCBS    EQU   VUPOOL+4
VUPOOL#  EQU   VUPOOL
VOLALGTP EQU   VOLUNTAB+12
VOLUNTID EQU   VOLUNTAB+10
VURCVYPR EQU   VOLSTATD
VUVLUNIQ EQU   VOLSTATD
VUDMUNIQ EQU   VOLSTATD
VUUNALSW EQU   VOLSTATD
VUDMNDAL EQU   VOLSTATD
VUDMNDOF EQU   VOLSTATD
VUREALOC EQU   VOLSTATD
VUMUGDON EQU   VOLSTATD
@NM00040 EQU   VOLSTATC
@NM00039 EQU   VOLSTATC
VURECVRY EQU   VOLSTATC
VOLURREQ EQU   VOLSTATC
VOLGRREQ EQU   VOLSTATC
VOLDAREQ EQU   VOLSTATC
VOLCOREQ EQU   VOLSTATC
VOLTAREQ EQU   VOLSTATC
VUAFFWRK EQU   VOLSTATB
VUVINELG EQU   VOLSTATB
VUDADSME EQU   VOLSTATB
VUDNALOC EQU   VOLSTATB
VUPROCED EQU   VOLSTATB
VDEVREQD EQU   VOLSTATB
VOLMNTD  EQU   VOLSTATB
VOLALOC  EQU   VOLSTATB
VOLDEFER EQU   VOLSTATA
VOLRESVE EQU   VOLSTATA
VOLNSHR  EQU   VOLSTATA
VOLSTG   EQU   VOLSTATA
VOLSPEC  EQU   VOLSTATA
VOLPRV   EQU   VOLSTATA
VOLPUB   EQU   VOLSTATA
VOLID    EQU   VOLUNTAB
SIODDSNL EQU   INDMSIOT+173
SIOVDSNL EQU   INDMSIOT+172
SIOVDSNT EQU   INDMSIOT+170
SVOLUNNO EQU   INDMSIOT+168
SIOTVMVP EQU   INDMSIOT+164
SIOTJFX  EQU   INDMSIOT+160
SIOTNPTR EQU   INDMSIOT+152
SIOTETIO EQU   INDMSIOT+148
SIOTATE  EQU   INDMSIOT+144
SVOLUNAD EQU   INDMSIOT+140
SIOTEDLP EQU   INDMSIOT+136
SIOTEDLS EQU   INDMSIOT+132
SIOTRSNC EQU   INDMSIOT+130
SCTANAME EQU   INDMSIOT+122
SIOTSSIC EQU   INDMSIOT+120
@NM00038 EQU   INDMSIOT+108
SIOTSSNM EQU   INDMSIOT+104
@NM00037 EQU   SIOTBYT2
SIOTCVOL EQU   SIOTBYT2
SIOTCNEW EQU   SIOTBYT2
SIOTCALC EQU   SIOTBYT2
SIOTGALL EQU   SIOTBYT2
SIOTDSPD EQU   SIOTBYT2
SIOTDMND EQU   SIOTBYT2
SIOTOPUC EQU   INDMSIOT+99
SIOTOUTR EQU   INDMSIOT+97
SIOTOUTC EQU   INDMSIOT+96
SIOTSSWA EQU   INDMSIOT+93
SIOTAUNC EQU   SIOTALTD
SIOTACAT EQU   SIOTALTD
SIOTADEL EQU   SIOTALTD
SIOTAKEP EQU   SIOTALTD
SIOTNPRV EQU   SIOTALTD
SIOJCATS EQU   SIOTALTD
@NM00036 EQU   SIOTALTD
@NM00035 EQU   SIOTALTD
@NM00034 EQU   INDMSIOT+91
SIOTNDSB EQU   INDMSIOT+88
@NM00033 EQU   INDMSIOT+84
SIOTDPCD EQU   INDMSIOT+82
@NM00032 EQU   SIOTBYT4
SIOTRACT EQU   SIOTBYT4
SIOTRACD EQU   SIOTBYT4
SIOTPROT EQU   SIOTBYT4
SCTOUTPN EQU   INDMSIOT+80
SCTOUTNO EQU   INDMSIOT+76
SCTOUTNM EQU   INDMSIOT+68
SIOUCBAD EQU   SCTUTYPE+5
SIOUCNVT EQU   SCTUTYPE+4
SIOUBYT4 EQU   SIOTDEVT+3
@NM00031 EQU   SIOUBYT3
SIO3UREC EQU   SIOUBYT3
SIO3DISP EQU   SIOUBYT3
SIO3DACC EQU   SIOUBYT3
SIO3COMM EQU   SIOUBYT3
SIO3TAPE EQU   SIOUBYT3
SIOUBYT2 EQU   SIOTDEVT+1
SIOUBYT1 EQU   SIOTDEVT
SIOTOMN  EQU   SCTSBYT4
SIOTIPDI EQU   SCTSBYT4
SIOTVAFF EQU   SCTSBYT4
SIOTSTEP EQU   SCTSBYT4
SIOTASCI EQU   SCTSBYT4
@NM00030 EQU   SCTSBYT4
SIOTGDGA EQU   SCTSBYT4
SCTSGDGS EQU   SCTSBYT4
SCTSOLD  EQU   SCTSBYT3
SCTSMOD  EQU   SCTSBYT3
SCTSNEW  EQU   SCTSBYT3
SCTSYSOU EQU   SCTSBYT3
SCTVREF  EQU   SCTSBYT3
SCTALCHK EQU   SCTSBYT3
SCTSYSNE EQU   SCTSBYT3
SCTDSNRF EQU   SCTSBYT3
SCTRECVD EQU   SCTSBYT2
SCTDEFER EQU   SCTSBYT2
SCTLABEL EQU   SCTSBYT2
SCTUNLBD EQU   SCTSBYT2
SCTJOBLB EQU   SCTSBYT2
SCTVOLAF EQU   SCTSBYT2
SIOTCATL EQU   SCTSBYT2
SIOCLUNL EQU   SCTSBYT2
SIOTJSCT EQU   SCTSBYT1
SCTUNAFF EQU   SCTSBYT1
SCTPARLM EQU   SCTSBYT1
SIOTQDSN EQU   SCTSBYT1
SIOTGDSN EQU   SCTSBYT1
SIOTCCAT EQU   SCTSBYT1
SCTSYSIN EQU   SCTSBYT1
SCTDUMMY EQU   SCTSBYT1
SIOTUNCT EQU   SCTSDISP
SIOTCTLG EQU   SCTSDISP
SIOTDLET EQU   SCTSDISP
SIOTKEEP EQU   SCTSDISP
SIOTPASS EQU   SCTSDISP
SIOTPRIV EQU   SCTSDISP
S3400DSP EQU   SCTSDISP
SIOTRETN EQU   SCTSDISP
SIOTVLCT EQU   INDMSIOT+54
SCTNMBUT EQU   INDMSIOT+53
SIOTRTRY EQU   SIOTBYT0
SIOTPUPV EQU   SIOTBYT0
SIOTNOPV EQU   SIOTBYT0
SIOTGIGN EQU   SIOTBYT0
SPVTAMSG EQU   SIOTBYT0
SIOTFUDA EQU   SIOTBYT0
SIOTDYAL EQU   SIOTBYT0
SIOTSSDS EQU   SIOTBYT0
SIOTGIID EQU   INDMSIOT+50
SCTVOLCT EQU   INDMSIOT+49
SCTSPOOL EQU   INDMSIOT+48
SIOTQNAM EQU   SIOTTSTC
SIOTDSNM EQU   SIOTTSTC
SIOTTRKM EQU   SIOTTSTC
SIOTSSMG EQU   SIOTTSTC
SIOTSSGP EQU   SIOTTSTC
@NM00029 EQU   SIOTTSTC
SIOTTERM EQU   SIOTTSTC
SIOTINFC EQU   SIOTTSTC
@NM00028 EQU   SIOTBYT3
SIOTDSID EQU   SIOTBYT3
S3400OFF EQU   SIOTBYT3
SIOTJES3 EQU   SIOTBYT3
SIOCDEVT EQU   SIOTBYT3
SIOALIAS EQU   SIOTBYT3
SCTDDINO EQU   INDMSIOT+44
SIOTDDNT EQU   SIOTBYT1
SIOTALCD EQU   SIOTBYT1
SIODADSM EQU   SIOTBYT1
SIOTDADR EQU   SIOTBYT1
SIODUNAL EQU   SIOTBYT1
SIOVAMDS EQU   SIOTBYT1
SIOTHOLD EQU   SIOTBYT1
SIOTOCKP EQU   SIOTBYT1
SIOPSCNT EQU   INDMSIOT+42
SIOTREFN EQU   INDMSIOT+40
SIOTOTUN EQU   INDMSIOT+39
SIOTVRSB EQU   INDMSIOT+36
@NM00027 EQU   INDMSIOT+35
SCTPJFCB EQU   INDMSIOT+32
@NM00026 EQU   INDMSIOT+31
SCTPSIOT EQU   INDMSIOT+28
SIOTAFID EQU   INDMSIOT+26
SIOTVLSP EQU   INDMSIOT+24
SIODSNTE EQU   INDMSIOT+22
SIOTUNAF EQU   SCTUSADD
SIOTDEST EQU   INDMSIOT+12
SCTDDNAM EQU   INDMSIOT+4
SIOTTYPE EQU   INDMSIOT+3
SIOTDSKA EQU   INDMSIOT
JSCBCSCB EQU   JSCBSEC1+68
JSCBPMG  EQU   JSCBWTP+2
JSCBWTSP EQU   JSCBWTP+1
JSCRSV23 EQU   JSCBWTFG
JSCRSV22 EQU   JSCBWTFG
JSCRSV21 EQU   JSCBWTFG
JSCRSV20 EQU   JSCBWTFG
JSCRSV19 EQU   JSCBWTFG
JSCRSV18 EQU   JSCBWTFG
JSCBRET  EQU   JSCBWTFG
JSCBIOFG EQU   JSCBWTFG
@NM00023 EQU   JSCBSEC1+60
JSCBQMPI EQU   JSCBSEC1+56
JSCBPMSG EQU   JSCBSWT1
JSCRSV16 EQU   JSCBSWT1
JSCRSV15 EQU   JSCBSWT1
JSCRSV14 EQU   JSCBSWT1
JSCRSV13 EQU   JSCBSWT1
JSCRSV12 EQU   JSCBSWT1
JSCRSV11 EQU   JSCBSWT1
JSCBPASS EQU   JSCBSWT1
JSCBTTTR EQU   JSCBSEC1+52
JSCRSV10 EQU   JSCBSEC1+49
JSCBAUTH EQU   JSCBOPTS
JSCSIOTS EQU   JSCBOPTS
JSCRSV08 EQU   JSCBOPTS
JSCRSV07 EQU   JSCBOPTS
JSCRSV06 EQU   JSCBOPTS
JSCBLONG EQU   JSCBOPTS
JSCRSV05 EQU   JSCBOPTS
JSCRSV04 EQU   JSCBOPTS
JSCBSECB EQU   JSCBSEC1+44
JSCRSV03 EQU   JSCBSEC1+41
JSCBDCBA EQU   JSCBDCB+1
JSCRSV02 EQU   JSCBDCB
JSCBID   EQU   JSCBSEC1+32
JSCBDBTB EQU   JSCBSEC1+28
JSCBIJSC EQU   JSCBSEC1+24
JSCBTCBP EQU   JSCBSEC1+20
JSCBPCC  EQU   JSCBSEC1+16
JSCBTCP  EQU   JSCBSEC1+12
JSCBSHR  EQU   JSCBSEC1+8
JSCHPCEA EQU   JSCHPCE+1
JSCRSV32 EQU   JSCHPCE
JSCRSV01 EQU   JSCBSEC1
@NM00022 EQU   IEZJSCB
@NM00021 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBCAUF  EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00020 EQU   TCB+296
TCBSVCA2 EQU   TCB+292
TCBSWASA EQU   TCB+288
TCBDBTB  EQU   TCB+284
TCBRPT   EQU   TCB+280
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBRV327 EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCB+274
TCBRV326 EQU   TCB+272
TCBUKYSP EQU   TCB+268
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBSTAFX EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCB+260
TCBTCBID EQU   TCB+256
TCBSTAWA EQU   TCB+252
TCBSWA   EQU   TCB+248
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBCCPVI EQU   TCBXSCT+2
TCBRV325 EQU   TCBXSCT+1
TCBRV324 EQU   TCBXSCT1
TCBRV323 EQU   TCBXSCT1
TCBRV322 EQU   TCBXSCT1
TCBRV321 EQU   TCBXSCT1
TCBRV320 EQU   TCBXSCT1
TCBRV319 EQU   TCBXSCT1
TCBS3A   EQU   TCBXSCT1
TCBACTIV EQU   TCBXSCT1
TCBRSV41 EQU   TCB+239
TCBTID   EQU   TCB+238
TCBRSVAA EQU   TCB+237
TCBABCUR EQU   TCB+236
TCBTMSAV EQU   TCB+232
TCBIOTIM EQU   TCB+228
TCBRTWA  EQU   TCB+224
TCBBACK  EQU   TCB+220
TCBTIRB  EQU   TCB+216
TCBAECB  EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBSVCS  EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBGPECB EQU   TCBFLGS7
TCBNTJS  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBCPU   EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBRSV95 EQU   TCBNDSP5
TCBRSV94 EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00019 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBNDINT EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBLJSND EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBSTCUR EQU   TCBNSTAE
TCBRV301 EQU   TCBNSTAE
TCBSYNCH EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBNSTAE
TCB33E   EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBAQE   EQU   TCB+156
TCBPQE   EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBJSTCA EQU   TCBJSTCB+1
TCBRSV16 EQU   TCBJSTCB
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBFSA
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBJPQ+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBDWSTA EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBADINP EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBFLGS2
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBNONPR EQU   TCBFLGS1
TCBFERA  EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBTIO   EQU   TCB+12
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00018 EQU   TCBPMASK
TCBRBP   EQU   TCB
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00017 EQU   CVTFIX+248
@NM00016 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTCCVT  EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVT      EQU   CVTMAP
MNTXREJT EQU   MNTXT+12
@NM00003 EQU   TCBS
@NM00079 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00078 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00077 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00076 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSAULCMS EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00075 EQU   FLCFSA
@NM00074 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00073 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00072 EQU   FLCIOA
@NM00071 EQU   FLCMCLA+15
@NM00070 EQU   FLCMCLA+14
@NM00069 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00068 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00067 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00066 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00065 EQU   FLCPER
@NM00064 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00063 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00062 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00061 EQU   FLCPIILC
@NM00060 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00059 EQU   FLCSVILC
@NM00058 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00057 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00056 EQU   FLCICCW2+4
FLCCVT   EQU   FLCICCW2
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00155 EQU   @RC00129
@RC00408 EQU   @RC00399
@RC00413 EQU   @RC00399
@RC00416 EQU   @RC00399
@RF00551 EQU   @RC00206
@ENDDATA EQU   *
         END   IEFAB495,(C'PLS1449',0701,78150)
