         TITLE 'IEFAB4A4 - UNIT UNALLOCATION CONTROL ROUTINE           *
                        '
IEFAB4A4 CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(24)                                          01S0001
         DC    C'IEFAB4A4 78089  UZ17548 '                      01S0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01S0001
         BALR  @10,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@10                                      01S0001
         L     @00,@SIZDATD                                     01S0001
         GSPACE   R,LV=(0)
         LR    @09,@01                                          01S0001
         USING @DATD,@09                                        01S0001
         ST    @13,@SA00001+4                                   01S0001
         LM    @00,@01,20(@13)                                  01S0001
         ST    @09,8(,@13)                                      01S0001
         LR    @13,@09                                          01S0001
         MVC   @PC00001(24),0(@01)                              01S0001
*CMESLP1 = ON;                         /*FIRST LOOP PROCESSING       */
         L     @12,@PC00001+16                                  01S0058
         L     @12,CMESPAP(,@12)                                01S0058
         OI    CMESLP1(@12),B'00000010'                         01S0058
*RETCODE = ZERO;                       /*INIT RETURN CODE AREA       */
         SLR   @12,@12                                          01S0059
         ST    @12,RETCODE                                      01S0059
*UNALUSWS = ZERO;                      /*CLEAR ALL LOCAL SWITCHES    */
         MVI   UNALUSWS,X'00'                                   01S0060
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - A4A4INIT                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - IEFAB4A4 INITIALIZATION                       */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE PERFORMS THE FOLLOWING INITIALIZATION FUNCTIONS:  */
*/*     .OBTAINING A USEABLE BLOCK OF THE VOLUME UNLOAD TABLE        */
*/*     .INITIALIZING THE ALLOCATION Q-MGR REQUEST BLOCK             */
*/*     .ESTABLISHING ADDRESSABILITY TO THE VM&V REQUEST BLOCK       */
*/*                                                                  */
*/*   OPERATION -                                                    */
*/*     IF A VOLUME UNLOAD BLOCK IS REQUIRED, ONE IS EITHER READ     */
*/*     FROM SWA OR ASSIGNED AND INITIALIZED. IF THE INPUT SVA IS    */
*/*     ZERO OR IF ALL EXISTING BLOCKS ARE FULL A NEW ONE MUST BE    */
*/*     CREATED. OTHERWISE THE INDEX INTO AN EXISTING BLOCK IS SET   */
*/*     FOR THE NEXT AVAILABLE ENTRY.                                */
*/*                                                                  */
*/*     IF WAITING ALLOCATIONS ARE TO BE POSTED, A Q-MGR REQUEST     */
*/*     BLOCK IS INITIALIZED WITH A POINTER TO THE GROUP MASK, THE   */
*/*     UNALLOCATION ENTRY CODE AND THE ASID.                        */
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*   PURPOSE - INITIALIZATION FOR IEFAB4A4                          */
*/*   INPUT -                                                        */
*/*     VUTSVA - SVA OF FIRST VUT BLOCK OR ZERO                      */
*/*     UNALNVUT - IF ON NO VUT PROCESSING IS REQUIRED               */
*/*     UNALNPST - IF ON THE POST FUNCTION IS NOT REQUIRED           */
*/*                                                                  */
*/* EXIT -                                                           */
*/*   CONDITION - USEABLE VUT BLOCK AVAILABLE                        */
*/*     OUTPUT -                                                     */
*/*       VUTPTR - PTR TO VUT BLOCK TO USE                           */
*/*       VUCTR - INDEX OF NEXT AVAILABLE ENTRY IN VUT               */
*/*       FEPAPTR - PTR TO FIRST EPA ON CHAIN                        */
*/*       LEPAPTR - PTR TO LAST EPA ON CHAINE                        */
*/*       EPA CHAIN - CHAIN OF EPAS FOR VUT BLOCKS                   */
*/*       QMGRRB - INITIALIZED Q-MGR REQUEST BLOCK                   */
*/*       VMVREQBP - PTR TO VM&V REQUEST BLOCK                       */
*/*     RETURN CODE -                                                */
*/*       RETCODE = 0                                                */
*/********************************************************************/
*VUTPTR  = ZERO;                       /*INIT TABLE PTR              */
         ST    @12,VUTPTR                                       02S0061
*FEPAPTR = ZERO;                       /*INIT FIRST EPA PTR          */
         ST    @12,FEPAPTR                                      02S0062
*LEPAPTR = ZERO;                       /*INIT LAST EPA PTR           */
         ST    @12,LEPAPTR                                      02S0063
*FSTVUTSV = ZERO;                      /*INIT 1ST ASGN'D BLK SVA
*                                                            @YM08200*/
         STCM  @12,7,FSTVUTSV                                   02S0064
*OLDLSTVP = ZERO;                      /*INIT PTR TO OLD LAST BLK
*                                                            @YM08200*/
         ST    @12,OLDLSTVP                                     02S0065
*IF UNALNVUT = NO THEN                 /*VUT PROCESSING REQUIRED     */
         L     @12,@PC00001                                     02S0066
         TM    UNALNVUT(@12),B'01000000'                        02S0066
         BNZ   @RF00066                                         02S0066
*  DO;                                 /*FIND/CREATE VUT BLK TO USE  */
*    VUTINSW = OFF;                    /*INIT VUT READ-IN SWITCH     */
*    VUTENDSW = OFF;                   /*INIT END-OF-TABLE INDICATOR */
         NI    VUTINSW,B'10011111'                              02S0069
*    SMISVA = VUTSVA;                  /*SET SVA FOR READ            */
         L     @12,@PC00001+12                                  02S0070
         MVC   SMISVA(3),VUTSVA(@12)                            02S0070
*    SMIBLKID = 38;                    /*SET ID OF VUT               */
         MVI   SMIBLKID,X'26'                                   02S0071
*    SWACTLS = SWACTLS && SWACTLS;     /*CLEAR FCN MAP               */
         SLR   @11,@11                                          02S0072
         ICM   @11,3,SWACTLS                                    02S0072
         LR    @08,@11                                          02S0072
         XR    @08,@11                                          02S0072
         STH   @08,SWACTLS                                      02S0072
*    SWREAD = ON;                      /*SET FCN MAP FOR READ        */
*    SWNEW = ON;                       /*CREATE NEW EPA              */
         OI    SWREAD,B'00101000'                               02S0074
*    IF VUTSVA ^= ZERO THEN            /*VUT CURRENTLY EXISTS        */
         ICM   @11,7,VUTSVA(@12)                                02S0075
         BZ    @RF00075                                         02S0075
*      DO WHILE((VUTINSW = OFF &          /*NO USERABLE BLOCK READ
**/              VUTENDSW = OFF));/*                            02S0076
*                                        GET A USEABLE BLOCK OF TAB  */
         B     @DE00076                                         02S0076
@DL00076 DS    0H                                               02S0077
*        CALL IEFAB4F7                 /*SWA MANAGER INTERFACE RTN   */
*            (SWACTLS,FEPAPTR,DMYPARM,ADDR(SMIDATA),ADDR(VUTPTR),
*             TBLLNTH,NUMVBLKS);                                02S0077
         LA    @12,SWACTLS                                      02S0077
         ST    @12,@AL00001                                     02S0077
         LA    @12,FEPAPTR                                      02S0077
         ST    @12,@AL00001+4                                   02S0077
         LA    @12,@CF00107                                     02S0077
         ST    @12,@AL00001+8                                   02S0077
         LA    @12,SMIDATA                                      02S0077
         ST    @12,@TF00001                                     02S0077
         LA    @12,@TF00001                                     02S0077
         ST    @12,@AL00001+12                                  02S0077
         LA    @12,VUTPTR                                       02S0077
         ST    @12,@TF00002                                     02S0077
         LA    @12,@TF00002                                     02S0077
         ST    @12,@AL00001+16                                  02S0077
         LA    @12,TBLLNTH                                      02S0077
         ST    @12,@AL00001+20                                  02S0077
         LA    @12,@CF00051                                     02S0077
         ST    @12,@AL00001+24                                  02S0077
         L     @15,@CV00071                                     02S0077
         LA    @01,@AL00001                                     02S0077
         BALR  @14,@15                                          02S0077
*            SWNEW = OFF;              /*CLEAR REQ FOR NEW EPA       */
         NI    SWNEW,B'11110111'                                02S0078
*            IF VUTENTNO < DIM(VUTENTRY) THEN /*BLOCK NOT FULL       */
         L     @12,VUTPTR                                       02S0079
         CLI   VUTENTNO(@12),24                                 02S0079
         BNL   @RF00079                                         02S0079
*              DO;                                              02S0080
*                VUTINSW = ON;         /*CAN USE THIS BLK - EXIT LOOP*/
         OI    VUTINSW,B'01000000'                              02S0081
*                VUTCTR = VUTENTNO+ONE;/*SET INDEX TO AVAILABLE ENTRY*/
         IC    @11,VUTENTNO(,@12)                               02S0082
         LA    @11,1(,@11)                                      02S0082
         STC   @11,VUTCTR                                       02S0082
*              END;                                             02S0083
*            ELSE                      /*BLOCK FULL                  */
*              IF VUTNSVA ^= ZERO THEN /*MORE BLOCKS                 */
         B     @RC00079                                         02S0084
@RF00079 L     @12,VUTPTR                                       02S0084
         ICM   @11,7,VUTNSVA(@12)                               02S0084
         BZ    @RF00084                                         02S0084
*                DO;                   /*SET UP TO READ NEXT ONE     */
*                  SMISVA = VUTNSVA;   /*SVA OF NEXT BLOCK           */
         MVC   SMISVA(3),VUTNSVA(@12)                           02S0086
*                  SWMOD = ON;         /*READ USING SAME EPA         */
         OI    SWMOD,B'00000010'                                02S0087
*                END;                                           02S0088
*              ELSE                    /*NO MORE BLOCKS              */
*                VUTENDSW = ON;        /*END OF TABLE- NO USEABLE BLK*/
         B     @RC00084                                         02S0089
@RF00084 OI    VUTENDSW,B'00100000'                             02S0089
*      END;                                                     02S0090
@RC00084 DS    0H                                               02S0090
@RC00079 DS    0H                                               02S0090
@DE00076 TM    VUTINSW,B'01100000'                              02S0090
         BZ    @DL00076                                         02S0090
*    LEPAPTR = FEPAPTR;                /*SET PTR TO LAST EPA         */
@RF00075 MVC   LEPAPTR(4),FEPAPTR                               02S0091
*    IF VUTINSW = NO THEN              /*NO BLK TO USE-ASSIGN NEW BLK*/
         TM    VUTINSW,B'01000000'                              02S0092
         BNZ   @RF00092                                         02S0092
*      CALL CRVUTAB;                   /*GET/INIT NEW BLOCK          */
         BAL   @14,CRVUTAB                                      02S0093
*  END;                                                         02S0094
@RF00092 DS    0H                                               02S0095
*IF UNALNPST = NO THEN                 /*POST FUNCTION REQUIRED      */
@RF00066 L     @12,@PC00001                                     02S0095
         TM    UNALNPST(@12),B'10000000'                        02S0095
         BNZ   @RF00095                                         02S0095
*  DO;                                 /*INIT ALLOC. Q-MGR INTERFACE */
*    QMGRRB = QMGRRB && QMGRRB;        /*CLEAR REQUEST BLOCK         */
         XC    QMGRRB(28),QMGRRB                                02S0097
*    QMGRBPTR = ADDR(QMGRRB);          /*SET PTR TO REQ BLK          */
         LA    @12,QMGRRB                                       02S0098
         ST    @12,QMGRBPTR                                     02S0098
*    AQMECODE = QMGRECDE;              /*SET ENTRY CODE              */
         MVC   AQMECODE(2,@12),@CH00122                         02S0099
*    IF CMESGRMP=ZERO THEN             /*GROUP MASK EXIST?   @Z40FPPG*/
         L     @12,@PC00001+16                                  02S0100
         L     @12,CMESPAP(,@12)                                02S0100
         ICM   @11,15,CMESGRMP(@12)                             02S0100
         BNZ   @RF00100                                         02S0100
*      DO;                             /*NO, SET ONE UP      @Z40FPPG*/
*        GRPMSKP=ADDR(GRMSKCOR);       /*SET UP BASE PTR     @Z40FPPG*/
         LA    @11,GRMSKCOR                                     02S0102
         ST    @11,GRPMSKP                                      02S0102
*        CMESGRMP=ADDR(GRMSKCOR);      /*SAVE IN ESTAE PARMS @Z40FPPG*/
         ST    @11,CMESGRMP(,@12)                               02S0103
*        DO CTR1 = DIM(GRPMSK) TO 1 BY-1;  /*CLEAR REQUEST BLOCK     */
         LA    CTR1,240                                         02S0104
@DL00104 DS    0H                                               02S0105
*          GRPMSK(CTR1) = ZERO;            /*CLEAR GROUP ID MASK     */
         SLR   @12,@12                                          02S0105
         L     @11,GRPMSKP                                      02S0105
         BCTR  @11,0                                            02S0105
         STC   @12,GRPMSK(CTR1,@11)                             02S0105
*        END;                                                   02S0106
         BCTR  CTR1,0                                           02S0106
         LTR   CTR1,CTR1                                        02S0106
         BP    @DL00104                                         02S0106
*      END;                            /*END IF NONE EXISTED @Z40FPPG*/
*    ELSE                              /*ONE EXISTS ALREADY  @Z40FPPG*/
*      GRPMSKP=CMESGRMP;               /*USE AS BASE PTR     @Z40FPPG*/
         B     @RC00100                                         02S0108
@RF00100 L     @12,@PC00001+16                                  02S0108
         L     @12,CMESPAP(,@12)                                02S0108
         MVC   GRPMSKP(4),CMESGRMP(@12)                         02S0108
*    AQMMASKP = ADDR(GRPMSK);          /*SET PTR TO GROUP MASK       */
@RC00100 L     @12,QMGRBPTR                                     02S0109
         MVC   AQMMASKP(4,@12),GRPMSKP                          02S0109
*    AQMASID(3:4) = ASCBASID;          /*SET ASID IN Q-MGR RB@Z40FPPD*/
         L     @11,PSAAOLD                                      02S0110
         MVC   AQMASID+2(2,@12),ASCBASID(@11)                   02S0110
*  END;                                                         02S0111
*VMVREQBP = ADDR(RWNDRB);              /*SET PTR TO VM&V REQ BLK     */
@RF00095 LA    @12,RWNDRB                                       02S0112
         ST    @12,VMVREQBP                                     02S0112
*IF UNAL2LP = OFF THEN                 /*ONLY DO SECOND LOOP OFF     */
         L     @12,@PC00001                                     01S0113
         TM    UNAL2LP(@12),B'00010000'                         01S0113
         BNZ   @RF00113                                         01S0113
*  DO;                                                          01S0114
*    CMRBPTR = FRBPTR;                 /*PTR TO FIRST REQ BLOCK      */
         L     @12,@PC00001+4                                   01S0115
         MVC   CMRBPTR(4),FRBPTR(@12)                           01S0115
*    DO WHILE (CMRBPTR ^= ZERO);       /*DEL MSGS/VUT PRC'NG LOOP    */
         B     @DE00116                                         01S0116
@DL00116 DS    0H                                               01S0117
*      SIOTPTR = CMSIOPTR;             /*PT TO SIOT OF REQUEST       */
         L     @12,CMRBPTR                                      01S0117
         L     SIOTPTR,CMSIOPTR(,@12)                           01S0117
*      IF SIOTETIO ^= ZERO THEN        /*DSAB EXISTS                 */
         L     @12,SIOTETIO(,SIOTPTR)                           01S0118
         LTR   @12,@12                                          01S0118
         BZ    @RF00118                                         01S0118
*        DO;                           /*SCAN TIOT DEVICE ENTRIES    */
*          DSABPTR = SIOTETIO;         /*SET PTR TO DSAB             */
         LR    DSABPTR,@12                                      01S0120
*            DO UNITCTR = 1 TO TIOEWTCT; /*PROCESS ALLOCATED UNITS   */
         LA    @12,1                                            01S0121
         B     @DE00121                                         01S0121
@DL00121 DS    0H                                               01S0122
*              UCBPTR = TIOUCBP(UNITCTR);  /*GET UCB PTR FROM TIOT   */
         SLA   @12,2                                            01S0122
         L     @11,DSABTIOT(,DSABPTR)                           01S0122
         L     UCBPTR,TIOUCBP-5(@12,@11)                        01S0122
         LA    UCBPTR,0(,UCBPTR)                                01S0122
*              IF UCBPTR ^= ZERO THEN      /*UNIT WAS ALLOCATED      */
         SLR   @12,@12                                          01S0123
         CR    UCBPTR,@12                                       01S0123
         BE    @RF00123                                         01S0123
*                DO;                                            01S0124
*                  IF UCB3TAPE = YES &           /*TAPE DEVICE  01S0125
*       */            UCBBNUL = YES THEN/*                      01S0125
*                                        MOUNT MSG PENDING FOR TAPE  */
         TM    UCB3TAPE(UCBPTR),B'10000000'                     01S0125
         BNO   @RF00125                                         01S0125
         TM    UCBBNUL(UCBPTR),B'00000001'                      01S0125
         BNO   @RF00125                                         01S0125
*                    DO;                                        01S0126
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - DOMMSG                                            */
*/*                                                                  */
*/* DESCRIPTIVE NAME - DELETE OPERATOR MESSAGE                       */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE ISSUES A DELETE OPERATOR MESSAGE MACRO (DOM) FOR  */
*/*   THE OUTSTANDING MOUNT MESSAGE AGAINST THE INPUT UNIT. THE      */
*/*   ID OF THE MESSAGE IS CONTAINED IN THE UCB (UCBFSER).           */
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*   PURPOSE - TO DELETE PENDING MOUNT MESSAGES FOR TAPE DATA SETS  */
*/*   INPUT -                                                        */
*/*     UCBPTR - PTR TO UCB TO PROCESS                               */
*/*       UCBFSER - MESSAGE ID OF OUTSTANDING MESSAGE                */
*/*       UCBBNUL - MOUNT INDICATOR                                  */
*/* EXIT -                                                           */
*/*   CONDITION - MESSAGE DELETED                                    */
*/*     OUTPUT - MESSAGE ID FIELD AND PENDING MOUNT BIT OF UCB       */
*/*              CLEARED                                             */
*/*     RETURN CODE - NONE                                           */
*/********************************************************************/
*IF UCBFSER(1:3) ^= ZERO THEN          /*MSG HAS NOT BEEN DELETED    */
         SLR   @11,@11                                          02S0127
         ICM   @11,7,UCBFSER(UCBPTR)                            02S0127
         CR    @12,@11                                          02S0127
         BE    @RF00127                                         02S0127
*  DO;                                 /*DELETE MSG AND UPDATE UCB   */
*    MSGID = UCBFSER(1:3);             /*GET MSG ID FOR DOM          */
         MVC   MSGID(3),UCBFSER(UCBPTR)                         02S0129
*     DO; /*MODESET  KEYADDR(ZERO)*/                            02S0130
*       SPKA (ZERO); /*SET PSW KEY*/                            02S0131
         SPKA  0(@12)                                           02S0131
*     END; /*MODESET  KEYADDR(ZERO)*/           /*GET IN KEY 0  02S0132
*      */                                                       02S0132
*     DO; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(LOCAL) REGS(USE) RELATE
*(UCB,IEFAB4A4(DOMMSG)) */                                      02S0133
*       RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                 02S0134
*       RFY (GPR15P,GPR00P,GPR01P) RSTD;                        02S0135
*       GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */         02S0136
         LR    GPR15P,GPR11P                                    02S0136
*       GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */          02S0137
         LR    GPR00P,GPR12P                                    02S0137
*       GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */          02S0138
         LR    GPR01P,GPR13P                                    02S0138
*       GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */
         L     GPR13P,PSALITA                                   02S0139
*       GEN(LM GPR11P,GPR13P,576(GPR13P)); /* LOAD LOCKWORD, CLHT AND E
*TRY ADRS. */                                                   02S0140
         LM GPR11P,GPR13P,576(GPR13P)
*       GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */     02S0141
         BALR GPR14P,GPR13P
*       GPR11P = GPR15P; /* RESTORE REG. 11. */                 02S0142
         LR    GPR11P,GPR15P                                    02S0142
*       GPR15P = GPR13P; /* SAVE RETURN CODE. */                02S0143
         LR    GPR15P,GPR13P                                    02S0143
*       GPR12P = GPR00P; /* RESTORE REG. 12 */                  02S0144
         LR    GPR12P,GPR00P                                    02S0144
*       GPR13P = GPR01P; /* RESTORE REG. 13. */                 02S0145
         LR    GPR13P,GPR01P                                    02S0145
*       RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                       02S0146
*       RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;               02S0147
*     END; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(LOCAL) REGS(USE) RELAT
*D(UCB,IEFAB4A4(DOMMSG)) */                                     02S0148
*     DO; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(CMS) REGS(USE) RELATED(
*CB,IEFAB4A4(DOMMSG)) */                                        02S0149
*       RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                 02S0150
*       RFY (GPR15P,GPR00P,GPR01P) RSTD;                        02S0151
*       GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */         02S0152
         LR    GPR15P,GPR11P                                    02S0152
*       GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */          02S0153
         LR    GPR00P,GPR12P                                    02S0153
*       GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */          02S0154
         LR    GPR01P,GPR13P                                    02S0154
*       GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */
         L     GPR13P,PSALITA                                   02S0155
*       GEN(LM GPR11P,GPR13P,540(GPR13P)); /* LOAD LOCKWORD, CLHT AND E
*TRY ADRS. */                                                   02S0156
         LM GPR11P,GPR13P,540(GPR13P)
*       GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */     02S0157
         BALR GPR14P,GPR13P
*       GPR11P = GPR15P; /* RESTORE REG. 11. */                 02S0158
         LR    GPR11P,GPR15P                                    02S0158
*       GPR15P = GPR13P; /* SAVE RETURN CODE. */                02S0159
         LR    GPR15P,GPR13P                                    02S0159
*       GPR12P = GPR00P; /* RESTORE REG. 12 */                  02S0160
         LR    GPR12P,GPR00P                                    02S0160
*       GPR13P = GPR01P; /* RESTORE REG. 13. */                 02S0161
         LR    GPR13P,GPR01P                                    02S0161
*       RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                       02S0162
*       RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;               02S0163
*     END; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(CMS) REGS(USE) RELATED
*UCB,IEFAB4A4(DOMMSG)) */                                       02S0164
*    UCBFSER(1:3) =ZERO;               /*CLEAR MSG ID FIELD OF UCB   */
         SLR   @12,@12                                          02S0165
         STCM  @12,7,UCBFSER(UCBPTR)                            02S0165
*    UCBBNUL = OFF;                    /*RESET PENDING MSG INDICATOR */
         NI    UCBBNUL(UCBPTR),B'11111110'                      02S0166
*     DO; /* SETLOCK (RELEASE) TYPE(CMS) REGS(USE) RELATED(UCB,IEFAB4A4
*DOMMSG)) */                                                    02S0167
*       RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                 02S0168
*       RFY (GPR15P,GPR00P,GPR01P) RSTD;                        02S0169
*       GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */         02S0170
         LR    GPR15P,GPR11P                                    02S0170
*       GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */          02S0171
         LR    GPR00P,GPR12P                                    02S0171
*       GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */          02S0172
         LR    GPR01P,GPR13P                                    02S0172
*       GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */
         L     GPR13P,PSALITA                                   02S0173
*       GEN(LM GPR11P,GPR13P,552(GPR13P)); /* LOAD LOCKWORD, CLHT AND E
*TRY ADRS. */                                                   02S0174
         LM GPR11P,GPR13P,552(GPR13P)
*       GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */     02S0175
         BALR GPR14P,GPR13P
*       GPR11P = GPR15P; /* RESTORE REG. 11. */                 02S0176
         LR    GPR11P,GPR15P                                    02S0176
*       GPR15P = GPR13P; /* SAVE RETURN CODE. */                02S0177
         LR    GPR15P,GPR13P                                    02S0177
*       GPR12P = GPR00P; /* RESTORE REG. 12 */                  02S0178
         LR    GPR12P,GPR00P                                    02S0178
*       GPR13P = GPR01P; /* RESTORE REG. 13. */                 02S0179
         LR    GPR13P,GPR01P                                    02S0179
*       RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                       02S0180
*       RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;               02S0181
*     END; /* SETLOCK (RELEASE) TYPE(CMS) REGS(USE) RELATED(UCB,IEFAB4A
*(DOMMSG)) */                                                   02S0182
*     DO; /* SETLOCK (RELEASE) TYPE(LOCAL) REGS(USE) RELATED(UCB,IEFAB4
*4(DOMMSG)) */                                                  02S0183
*       RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                 02S0184
*       RFY (GPR15P,GPR00P,GPR01P) RSTD;                        02S0185
*       GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */         02S0186
         LR    GPR15P,GPR11P                                    02S0186
*       GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */          02S0187
         LR    GPR00P,GPR12P                                    02S0187
*       GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */          02S0188
         LR    GPR01P,GPR13P                                    02S0188
*       GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */
         L     GPR13P,PSALITA                                   02S0189
*       GEN(LM GPR11P,GPR13P,588(GPR13P)); /* LOAD LOCKWORD, CLHT AND E
*TRY ADRS. */                                                   02S0190
         LM GPR11P,GPR13P,588(GPR13P)
*       GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */     02S0191
         BALR GPR14P,GPR13P
*       GPR11P = GPR15P; /* RESTORE REG. 11. */                 02S0192
         LR    GPR11P,GPR15P                                    02S0192
*       GPR15P = GPR13P; /* SAVE RETURN CODE. */                02S0193
         LR    GPR15P,GPR13P                                    02S0193
*       GPR12P = GPR00P; /* RESTORE REG. 12 */                  02S0194
         LR    GPR12P,GPR00P                                    02S0194
*       GPR13P = GPR01P; /* RESTORE REG. 13. */                 02S0195
         LR    GPR13P,GPR01P                                    02S0195
*       RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                       02S0196
*       RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;               02S0197
*     END; /* SETLOCK (RELEASE) TYPE(LOCAL) REGS(USE) RELATED(UCB,IEFAB
*A4(DOMMSG)) */                                                 02S0198
*     DO; /*MODESET  EXTKEY(SCHED)*/                            02S0199
*       SPKA (16); /*SET PSW KEY*/                              02S0200
         LA    @12,16                                           02S0200
         SPKA  0(@12)                                           02S0200
*     END; /*MODESET  EXTKEY(SCHED)*/           /*RETURN TO SCHEDULER K
*Y     */                                                       02S0201
*                                                               02S0201
*      DO; /* DOM MSG(MSGID)*/                                  02S0202
*        RFY (GPR00F,GPR01F) RSTD; /*RESTRICT REGISTERS*/       02S0203
*        GPR01F = MSGID; /* MOVE IN MESSAGE ID */               02S0204
         SLR   GPR01F,GPR01F                                    02S0204
         ICM   GPR01F,7,MSGID                                   02S0204
*        GPR00F = 0; /* SHOW MSG SPECIFIED*/                    02S0205
         SLR   GPR00F,GPR00F                                    02S0205
*        SVC (87); /* ISSUE DOM SVC */                          02S0206
         SVC   87                                               02S0206
*        RFY (GPR00F,GPR01F) UNRSTD; /* RELEASE REGISTERS */    02S0207
*      END; /* DOM MSG(MSGID)*/                /*DELETE OPERATOR MESSAG
*     */                                                        02S0208
*  END;                                                         02S0209
*                    END;                                       01S0210
@RF00127 DS    0H                                               01S0211
*                    IF UNALNVUT = NO &          /*VUT PROCESSING REQUE
*TED    */              SIOVAMDS = OFF &         /*NOT VAM      01S0211
*YM06117*/              ((UCB3DACC = YES |       /*D.A. OR ...  01S0211
*       */               UCB3TAPE = YES) &       /*...TAPE DEVICE WITH
*       */               UCBVOLI ^= ZEROVLSR) &  /*NON-ZERO VOL SER IN
*CB     */              (UCBBPRV = YES |         /*UNIT HAS PRIVATE VOL
*ME OR  */               CMSETPRV = YES |        /*VOL CHANGING TO PRIV
*TE?    */              (UCB3TAPE = YES &        /*TAPE         01S0211
*ZD03010*/               SIOTRETN = YES) |       /*RETAIN       01S0211
*ZD03010*/              (UCBTYP(3:4)=DEV3330 &   /*OR IS 3330   01S0211
*Z40LPPE*/               UCBRVDEV=ON &           /*VIRTUAL DEVICE
*Z40LPPE*/               UCBBPUB=ON) |           /*WITH PUBLIC VOLUME
*Z40LPPE*/              (CMNMDISP = YES &        /*IF USE NORMAL DISP A
*D      */               SIOTPASS = YES)) THEN/*                01S0211
*                                        NEED TO MAKE VUT ENTRY      */
@RF00125 L     @12,@PC00001                                     01S0211
         TM    UNALNVUT(@12),B'01000000'                        01S0211
         BNZ   @RF00211                                         01S0211
         TM    SIOVAMDS(SIOTPTR),B'00100000'                    01S0211
         BNZ   @RF00211                                         01S0211
         TM    UCB3DACC(UCBPTR),B'10100000'                     01S0211
         BZ    @RF00211                                         01S0211
         CLC   UCBVOLI(6,UCBPTR),ZEROVLSR                       01S0211
         BE    @RF00211                                         01S0211
         TM    UCBBPRV(UCBPTR),B'00010000'                      01S0211
         BO    @RT00211                                         01S0211
         L     @12,CMRBPTR                                      01S0211
         TM    CMSETPRV(@12),B'00001000'                        01S0211
         BO    @RT00211                                         01S0211
         TM    UCB3TAPE(UCBPTR),B'10000000'                     01S0211
         BNO   @GL00007                                         01S0211
         TM    SIOTRETN(SIOTPTR),B'10000000'                    01S0211
         BO    @RT00211                                         01S0211
@GL00007 CLC   UCBTYP+2(2,UCBPTR),DEV3330                       01S0211
         BNE   @GL00006                                         01S0211
         TM    UCBRVDEV(UCBPTR),B'00001000'                     01S0211
         BNO   @GL00006                                         01S0211
         TM    UCBBPUB(UCBPTR),B'00001000'                      01S0211
         BO    @RT00211                                         01S0211
@GL00006 L     @12,CMRBPTR                                      01S0211
         TM    CMNMDISP(@12),B'01000000'                        01S0211
         BNO   @RF00211                                         01S0211
         TM    SIOTPASS(SIOTPTR),B'00010000'                    01S0211
         BNO   @RF00211                                         01S0211
@RT00211 DS    0H                                               01S0212
*                      DO;                                      01S0212
*                        IF VUTENTNO=DIM(VUTENTRY) THEN /*NO SPACE   */
         L     @12,VUTPTR                                       01S0213
         CLI   VUTENTNO(@12),24                                 01S0213
         BNE   @RF00213                                         01S0213
*                          CALL CRVUTAB;   /*GET/INIT NEW VUT BLOCK  */
         BAL   @14,CRVUTAB                                      01S0214
*                        VUTENVOL(VUTCTR)=UCBVOLI; /*INPUT VOLSER
*                                                            @Y30LPPG*/
@RF00213 L     @12,VUTPTR                                       01S0215
         SLR   @11,@11                                          01S0215
         IC    @11,VUTCTR                                       01S0215
         MH    @11,@CH00104                                     01S0215
         ST    @11,@TF00001                                     01S0215
         ALR   @11,@12                                          01S0215
         MVC   VUTENVOL-7(6,@11),UCBVOLI(UCBPTR)                01S0215
*                        IF UCBTYP(3:4)=DEV3330 & /*IF A 3330@Y30LPPG*/
*                           UCBRVDEV = ON THEN /*VIRTUAL DEVICE?
*                                                            @Y30LPPG*/
         CLC   UCBTYP+2(2,UCBPTR),DEV3330                       01S0216
         BNE   @RF00216                                         01S0216
         TM    UCBRVDEV(UCBPTR),B'00001000'                     01S0216
         BNO   @RF00216                                         01S0216
*                          VUTENVIR(VUTCTR) = ON; /*YES, SAY MSS VOL
*                                                            @Y30LPPG*/
         AL    @12,@TF00001                                     01S0217
         OI    VUTENVIR-7(@12),B'10000000'                      01S0217
*                        VUTENTNO = VUTCTR; /*UPDATE # ENTRIES IN BLK*/
@RF00216 SLR   @12,@12                                          01S0218
         IC    @12,VUTCTR                                       01S0218
         L     @11,VUTPTR                                       01S0218
         STC   @12,VUTENTNO(,@11)                               01S0218
*                        VUTCTR = VUTCTR + ONE; /*INCREMENT INDEX TO
*                                        NEXT ENTRY                  */
         LA    @12,1(,@12)                                      01S0219
         STC   @12,VUTCTR                                       01S0219
*                      END;                                     01S0220
*                END;                                           01S0221
@RF00211 DS    0H                                               01S0222
*            END;                                               01S0222
@RF00123 SLR   @12,@12                                          01S0222
         IC    @12,UNITCTR                                      01S0222
         AL    @12,@CF00051                                     01S0222
@DE00121 STC   @12,UNITCTR                                      01S0222
         L     @11,DSABTIOT(,DSABPTR)                           01S0222
         SLR   @06,@06                                          01S0222
         IC    @06,TIOEWTCT(,@11)                               01S0222
         CR    @12,@06                                          01S0222
         BNH   @DL00121                                         01S0222
*        END;                                                   01S0223
*      CMRBPTR = CMNRBPTR;             /*GET NEXT REQ BLOCK          */
@RF00118 L     @12,CMRBPTR                                      01S0224
         L     @12,CMNRBPTR(,@12)                               01S0224
         ST    @12,CMRBPTR                                      01S0224
*    END;                                                       01S0225
@DE00116 ICM   @12,15,CMRBPTR                                   01S0225
         BNZ   @DL00116                                         01S0225
*  END;                                                         01S0226
*ELSE;                                 /*ONLY DO SECOND LOOP ON      */
@RF00113 DS    0H                                               01S0228
*CMESLP1 = OFF;                        /*FIRST LOOP COMPLETED        */
         L     @12,@PC00001+16                                  01S0228
         L     @12,CMESPAP(,@12)                                01S0228
         NI    CMESLP1(@12),B'11111101'                         01S0228
* DO; /*MODESET  KEYADDR(ZERO)*/                                01S0229
*   SPKA (ZERO); /*SET PSW KEY*/                                01S0230
         SLR   @12,@12                                          01S0230
         SPKA  0(@12)                                           01S0230
* END; /*MODESET  KEYADDR(ZERO)*/               /*GET KEY 0 TO GET LOCK
*      */                                                       01S0231
* DO; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(LOCAL) REGS(USE) RELATED(UC
*,IEFAB4A4(IEFAB4A4,CHKMALCD,UNALUNIT)) */                      01S0232
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                     01S0233
*   RFY (GPR15P,GPR00P,GPR01P) RSTD;                            01S0234
*   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */             01S0235
         LR    GPR15P,GPR11P                                    01S0235
*   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */              01S0236
         LR    GPR00P,GPR12P                                    01S0236
*   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */              01S0237
         LR    GPR01P,GPR13P                                    01S0237
*   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */    01S0238
         L     GPR13P,PSALITA                                   01S0238
*   GEN(LM GPR11P,GPR13P,576(GPR13P)); /* LOAD LOCKWORD, CLHT AND ENTRY
*ADRS. */                                                       01S0239
         LM GPR11P,GPR13P,576(GPR13P)
*   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */         01S0240
         BALR GPR14P,GPR13P
*   GPR11P = GPR15P; /* RESTORE REG. 11. */                     01S0241
         LR    GPR11P,GPR15P                                    01S0241
*   GPR15P = GPR13P; /* SAVE RETURN CODE. */                    01S0242
         LR    GPR15P,GPR13P                                    01S0242
*   GPR12P = GPR00P; /* RESTORE REG. 12 */                      01S0243
         LR    GPR12P,GPR00P                                    01S0243
*   GPR13P = GPR01P; /* RESTORE REG. 13. */                     01S0244
         LR    GPR13P,GPR01P                                    01S0244
*   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                           01S0245
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;                   01S0246
* END; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(LOCAL) REGS(USE) RELATED(U
*B,IEFAB4A4(IEFAB4A4,CHKMALCD,UNALUNIT)) */                     01S0247
* DO; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(CMS) REGS(USE) RELATED(UCB,
*EFAB4A4(IEFAB4A4,CHKMALCD,UNALUNIT)) */                        01S0248
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                     01S0249
*   RFY (GPR15P,GPR00P,GPR01P) RSTD;                            01S0250
*   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */             01S0251
         LR    GPR15P,GPR11P                                    01S0251
*   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */              01S0252
         LR    GPR00P,GPR12P                                    01S0252
*   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */              01S0253
         LR    GPR01P,GPR13P                                    01S0253
*   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */    01S0254
         L     GPR13P,PSALITA                                   01S0254
*   GEN(LM GPR11P,GPR13P,540(GPR13P)); /* LOAD LOCKWORD, CLHT AND ENTRY
*ADRS. */                                                       01S0255
         LM GPR11P,GPR13P,540(GPR13P)
*   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */         01S0256
         BALR GPR14P,GPR13P
*   GPR11P = GPR15P; /* RESTORE REG. 11. */                     01S0257
         LR    GPR11P,GPR15P                                    01S0257
*   GPR15P = GPR13P; /* SAVE RETURN CODE. */                    01S0258
         LR    GPR15P,GPR13P                                    01S0258
*   GPR12P = GPR00P; /* RESTORE REG. 12 */                      01S0259
         LR    GPR12P,GPR00P                                    01S0259
*   GPR13P = GPR01P; /* RESTORE REG. 13. */                     01S0260
         LR    GPR13P,GPR01P                                    01S0260
*   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                           01S0261
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;                   01S0262
* END; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(CMS) REGS(USE) RELATED(UCB
*IEFAB4A4(IEFAB4A4,CHKMALCD,UNALUNIT)) */                       01S0263
* DO; /*MODESET  EXTKEY(SCHED)*/                                01S0264
*   SPKA (16); /*SET PSW KEY*/                                  01S0265
         LA    @12,16                                           01S0265
         SPKA  0(@12)                                           01S0265
* END; /*MODESET  EXTKEY(SCHED)*/               /*RETURN TO SCHEDULER K
*Y     */                                                       01S0266
*CMRBPTR = FRBPTR;                     /*POINT TO FIRST REQUEST BLK  */
         L     @12,@PC00001+4                                   01S0267
         MVC   CMRBPTR(4),FRBPTR(@12)                           01S0267
*DO WHILE (CMRBPTR ^= ZERO);           /*PROCESS ENTIRE REQ BLK CHAIN*/
         B     @DE00268                                         01S0268
@DL00268 DS    0H                                               01S0269
*  CMESRBNP = CMNRBPTR;                /*PT TO NEXT BLK IN ESTAE PARM*/
         L     @12,@PC00001+16                                  01S0269
         L     @12,CMESPAP(,@12)                                01S0269
         L     @11,CMRBPTR                                      01S0269
         MVC   CMESRBNP(4,@12),CMNRBPTR(@11)                    01S0269
*  SIOTPTR = CMSIOPTR;                 /*PTR TO SIOT OF REQUEST      */
         L     SIOTPTR,CMSIOPTR(,@11)                           01S0270
*  IF SIOTETIO ^= ZERO THEN            /*DSAB EXISTS FOR REQUEST     */
         L     @12,SIOTETIO(,SIOTPTR)                           01S0271
         LTR   @12,@12                                          01S0271
         BZ    @RF00271                                         01S0271
*    DO;                                                        01S0272
*      DSABPTR = SIOTETIO;             /*PTR TO DSAB                 */
         LR    DSABPTR,@12                                      01S0273
*      DO UNITCTR = 1 TO TIOEWTCT;     /*PROCESS ALL UNITS ALLOC'D   */
         LA    @12,1                                            01S0274
         B     @DE00274                                         01S0274
@DL00274 DS    0H                                               01S0275
*        UCBPTR = TIOUCBP(UNITCTR);    /*UCB ADDR FROM TIOT          */
         SLA   @12,2                                            01S0275
         L     @11,DSABTIOT(,DSABPTR)                           01S0275
         L     UCBPTR,TIOUCBP-5(@12,@11)                        01S0275
         LA    UCBPTR,0(,UCBPTR)                                01S0275
*        IF UCBPTR ^= ZERO THEN        /*UNIT WAS ALLOCATED          */
         SLR   @15,@15                                          01S0276
         CR    UCBPTR,@15                                       01S0276
         BE    @RF00276                                         01S0276
*          DO;                                                  01S0277
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - UNALUNIT                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - UNALLOCATE UNITS                              */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE PERFORMS THE FOLLOWING FUNCTIONS:                 */
*/*     .UPDATES A UCB WHEN IT IS NO LONGER NEEDED BY THE STEP       */
*/*     .REWINDS TAPE VOLUMES, IF REQUIRED                           */
*/*     .CREATES A GROUP MASK ENTRY FOR THE UNIT UNALLOCATED         */
*/*                                                                  */
*/*   OPERATION -                                                    */
*/*     IF THE UNIT IS DIRECT ACCESS, THE USER COUNT IS DECREMENTED  */
*/*     AND WHEN ZERO, THE ALLOCATED BIT IS TURNED OFF. FOR OTHER    */
*/*     DEVICE TYPES THE ALLOCATED BIT IS TURNED OFF UNLESS THE      */
*/*     'CHECK MULTIPLY ALLOCATED UNITS' BIT IS ON. IN THIS CASE     */
*/*     THE UNIT IS ONLY UNALLOCATED IF IT IS NOT ALLOCATED TO       */
*/*     ANOTHER REQUEST. TO DETERMINE IF THE UNIT CAN BE UNALLOCATED */
*/*     THE ENTIRE TIOT IS SCANNED TO SEE IF THE UCB ADDRESS EXISTS  */
*/*     IN AN ENTRY WHICH IS STILL ALLOCATED. WHEN A UNIT IS UN-     */
*/*     ALLOCATED AN INDICATOR IS SET IN THE TIOT DEVICE ENTRY.      */
*/*     WHEN A TAPE UNIT IS TO BE UNALLOCATED, A VM&V REQUEST BLOCK  */
*/*     IS CREATED IF THE VOLUME MUST BE REWOUND OR UNLOADED.@ZD03010*/
*/*     THE UNLOAD IS DONE IF TAPE UNLOADING  IS REQUESTED   @ZD03010*/
*/*     AND THE TAPE IS PRIVATE.  IF THE TAPE IS UNLOADED,   @ZD03010*/
*/*     A VUT ENTRY IS MADE INDICATING SO (THIS IS DONE TO   @ZD03010*/
*/*     PREVENT JOB UNALLOCATION FROM ERRONEOUSLY PUTTING    @ZD03010*/
*/*     THE TAPE'S VOLSER INTO MSG IEF471E. THE 'RETAINED    @ZD03010*/
*/*     VOLS NO LONGER NEEDED' MSG.).  THE REWIND IS         @ZD03010*/
*/*     DONE IF THE REWIND INDICATOR IS ON IN THE TIOT DEVICE ENTRY  */
*/*     OF THE REQUEST BEING PROCESSED AND IF THE VOLUME DOES NOT    */
*/*     CONTAIN A PASSED DATA SET AND DOES NOT HAVE THE RESERVED     */
*/*     MOUNT ATTRIBUTE.                                             */
*/*     TAPE UNIT UCB'S MAY HAVE THEIR VOLUME                        */
*/*     USE ATTRIBUTES CHANGED, DEPENDING ON                         */
*/*     INDICATORS IN THE SIOT AND COMMON                            */
*/*     UNALLOCATION REQUEST BLOCK.                                  */
*/*     THE PASS/RETAIN INDICATOR IN THE UCB IS TURNED OFF   @ZD03010*/
*/*     IF THE UNIT CONTAINS A PRIVATE TAPE VOLUME, OR A     @ZD03010*/
*/*     NON-PASS/RETAIN PUBLIC TAPE VOLUME                   @ZD03010*/
*/*     WHEN AN ENTRY IS TO BE MADE IN THE GROUP MASK, THE GROUP ID  */
*/*     OF THE UNALLOCATED UNIT IS OBTAINED FROM THE DSAB GROUP ID   */
*/*     LIST. THE GROUP ID IS THEN USED TO DETERMINE WHICH BYTE OF   */
*/*     THE GROUP MASK IS TO BE SET AND THE BIT POSITION WITHIN THAT */
*/*     BYTE. THE BIT IS THEN SET ON BY OR'ING IT WITH A MASK WHICH  */
*/*     HAS THE PROPER BIT ON. THE MASKS ARE CONTAINED IN A TABLE    */
*/*     INDEXED BY THE BIT POSITION VARIABLE, GRMSKBIT. A SWITCH IS  */
*/*     SET TO INDICATE THAT AN ENTRY HAS BEEN MADE IN THE GROUP     */
*/*     MASK AND THAT THE ALLOCATION Q-MGR MUST BE INVOKED.          */
*/*     NOTE:                                                        */
*/*       IF THE VOLUME SERIAL FIELD OF EITHER A DIRECT ACCESS       */
*/*       OR TAPE UNIT'S UCB IS ZERO, THE VOLUME TARGETTED           */
*/*       FOR THE UNIT WAS NOT MOUNTED. IN THIS CASE; ATTRIBUTE      */
*/*       INDICATORS AND THE PENDING MOUNT INDICATOR ARE TURNED OFF. */
*/*       SEGMENT VIRTUNLD IS CALLED TO UNLOAD MSS UNITS     @ZA16381*/
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*   INPUT -                                                        */
*/*     CMUNRE - COMMON UNALLOC REQUEST BLOCK                        */
*/*       CMSETPRV - REQUESTS VOLS TO BE TREATED AS PRIVATE          */
*/*     DSABPTR - PTR TO DSAB FOR REQUEST                            */
*/*       DSABTIOT - PTR TO TIOT DD ENTRY                            */
*/*         SIO3DACC - IF ON, DIRECT ACCESS DEVICE                   */
*/*     UCBPTR - PTR TO UCB OF UNIT BEING PROCESSED                  */
*/*     UNITCTR - INDEX INTO TIOT DEVICE ENTRY AND DSAB GROUP ID LIST*/
*/*     SIOTPTR - PTR TO SIOT BEING PROCESSED                        */
*/*       SIOTNPRV - REQUEST'S VOLS TO BE TREATED AS PUBLIC          */
*/*     CMCHKUN - CHECK MULTIPLY ALLOCATED UNIT INDICATOR            */
*/*     UNALNVUT - OFF IF TAPE VOL UNLOADING REQUESTED       @ZD03010*/
*/*                                                                  */
*/* EXIT -                                                           */
*/*   CONDITION - PROCESSING COMPLETED                               */
*/*   OUTPUT -                                                       */
*/*     UPDATED UCB                                                  */
*/*     UPDATED GROUP MASK                                           */
*/*     GRENTSW - INDICATES ALLOC Q-MGR TO BE INVOKED,IF REQUESTED   */
*/*   RETURN CODE - NONE                                             */
*/*                                                                  */
*/********************************************************************/
*IF SIO3DACC = YES THEN                /*DIRECT ACCESS DEVICE        */
         TM    SIO3DACC(SIOTPTR),B'00100000'                    02S0278
         BNO   @RF00278                                         02S0278
*  DO;                                                          02S0279
*    TIOUNAL(UNITCTR) = ON;            /*INDIC. DEV ENTRY UNALLOCATED*/
         ALR   @11,@12                                          02S0280
         OI    TIOUNAL-4(@11),B'00000001'                       02S0280
*     DO; /*MODESET  KEYADDR(ZERO)*/                            02S0281
*       SPKA (ZERO); /*SET PSW KEY*/                            02S0282
         SPKA  0(@15)                                           02S0282
*     END; /*MODESET  KEYADDR(ZERO)*/           /*GET KEY 0 TO UPDATE U
*B     */                                                       02S0283
*    UCBUSER = UCBUSER - ONE;          /*DECREMENT USER COUNT        */
         SLR   @12,@12                                          02S0284
         IC    @12,UCBUSER(,UCBPTR)                             02S0284
         BCTR  @12,0                                            02S0284
         STC   @12,UCBUSER(,UCBPTR)                             02S0284
*    IF UCBUSER = ZERO THEN            /*NO MORE USERS ON DEVICE     */
         CLI   UCBUSER(UCBPTR),0                                02S0285
         BNE   @RF00285                                         02S0285
*      DO;                                                      02S0286
*        UCBASID = ZERO;               /*CLEAR ASID          @ZA05164*/
         L     @12,UCBEXTPT(,UCBPTR)                            02S0287
         STH   @15,UCBASID(,@12)                                02S0287
*        IF UCBATI = UATISKED THEN     /*IF SCHED INDEX      @ZA04550*/
         CLI   UCBATI(@12),12                                   02S0288
         BNE   @RF00288                                         02S0288
*          UCBATI = ZERO;              /*CLEAR ATTN TAB INDEX        */
         MVI   UCBATI(@12),X'00'                                02S0289
*        UCBBSVL = OFF;                /*CLEAR NON-SHAREABLE INDIC   */
@RF00288 NI    UCBBSVL(UCBPTR),B'01111111'                      02S0290
*        UCBDMC = CLRDMCT;             /*CLEAR DATA MGMNT COUNT FIELD*/
         NI    UCBDMC(UCBPTR),B'10000000'                       02S0291
*        UCBNSRCH = OFF;               /*CLEAR NON-SCRATCH VOL INDIC */
         L     @12,UCBEXTPT(,UCBPTR)                            02S0292
         NI    UCBNSRCH(@12),B'01111111'                        02S0292
*        UCBSHAR = OFF;                /*CLEAR NON-SHAREABLE BIT     */
         NI    UCBSHAR(UCBPTR),B'11111101'                      02S0293
*        IF UCBPRES = NO THEN          /*VOL ON UNIT NOT PERMRES
*                                                            @YM07613*/
         TM    UCBPRES(UCBPTR),B'00000100'                      02S0294
         BNZ   @RF00294                                         02S0294
*          SGRPMSW = ON;               /*NEED TO MAKE GROUP MASK ENT.*/
         OI    SGRPMSW,B'00010000'                              02S0295
*        IF UCBVOLI = ZEROVLSR THEN    /*VOLID IN UCB ZERO?          */
@RF00294 CLC   UCBVOLI(6,UCBPTR),ZEROVLSR                       02S0296
         BNE   @RF00296                                         02S0296
*          DO;                         /*YES, VOL NEVER MOUNTED      */
*            IF UCBTYP(3:4) = DEV3330 & /* IF 3330           @ZA16381*/
*               UCBRVDEV = ON &        /* VIRTUAL DEVICE AND @ZA16381*/
*               UCBMMSGP = OFF &       /* MOUNT ISSUED AND   @ZA16381*/
*               UNALNVUT = NO THEN     /* UNLOAD PROCESSING     02S0298
*                                         NEEDED             @ZA16381*/
         CLC   UCBTYP+2(2,UCBPTR),DEV3330                       02S0298
         BNE   @RF00298                                         02S0298
         TM    UCBRVDEV(UCBPTR),B'00001000'                     02S0298
         BNO   @RF00298                                         02S0298
         TM    UCBMMSGP(UCBPTR),B'00000100'                     02S0298
         BNZ   @RF00298                                         02S0298
         L     @12,@PC00001                                     02S0298
         TM    UNALNVUT(@12),B'01000000'                        02S0298
         BNZ   @RF00298                                         02S0298
*              DO;                     /* UNLOAD MSS DEVICE  @ZA16381*/
*/***********************************************************@ZA16381*/
*/*                                                                  */
*/* SEGMENT NAME - VIRTUNLD                                  @ZA16381*/
*/*                                                                  */
*/* DESCRIPTIVE NAME - VIRTUAL UNIT UNLOAD                   @ZA16381*/
*/*                                                                  */
*/* FUNCTION -                                               @ZA16381*/
*/*   THIS ROUTINE BUILDS THE VM&V REQUEST BLOCK FOR VIRTUAL @ZA16381*/
*/*   MSS UNITS.  THIS ROUTINE UNLOADS UNITS FOR NON -       @ZA16381*/
*/*   SPECIFIC VOLUME REQUESTS IN WHICH THE MOUNT WAS ISSUED @ZA16381*/
*/*   BUT THE VOLSER WAS NEVER PLACED IN THE UCB BECAUSE     @ZA16381*/
*/*   PROCESSING WAS TERMINATED BEFORE THE MOUNT COMPLETED   @ZA16381*/
*/*   OR BECAUSE AN ERROR WAS DETECTED BEFORE THE VOLSER     @ZA16381*/
*/*   WAS PLACED IN THE UCB.                                 @ZA16381*/
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                  @ZA16381*/
*/*   PURPOSE - SEE FUNCTION                                 @ZA16381*/
*/*   INPUT -                                                @ZA16381*/
*/*     UCBPTR - UCB TO UNLOAD                               @ZA16381*/
*/*     JOBNM  - JOBNAME                                     @ZA16381*/
*/*     STPNM  - STEPNAME                                    @ZA16381*/
*/*                                                                  */
*/* EXIT -                                                   @ZA16381*/
*/*   CONDITION - UNIT UNLOADED                              @ZA16381*/
*/*     OUTPUT - NONE                                        @ZA16381*/
*/*     RETURN CODE - NONE                                   @ZA16381*/
*/*                                                                  */
*/***********************************************************@ZA16381*/
*VMVRQBLK = VMVRQBLK && VMVRQBLK;      /*ZERO REQUEST BLOCK  @ZA16381*/
         L     @12,VMVREQBP                                     03S0300
         XC    VMVRQBLK(52,@12),VMVRQBLK(@12)                   03S0300
*VMVUCBP=UCBPTR;                       /*UCB TO BE UNLOADED  @ZA16381*/
         STCM  UCBPTR,7,VMVUCBP(@12)                            03S0301
*VMVUNLOD = ON;                        /*INDICATE UNLOAD     @ZA16381*/
         OI    VMVUNLOD(@12),B'10000000'                        03S0302
*VMVJBNMP = ADDR(JOBNM);               /*SET JOBNAME         @ZA16381*/
         L     @11,@PC00001+20                                  03S0303
         L     @11,NAMESPTR(,@11)                               03S0303
         ST    @11,VMVJBNMP(,@12)                               03S0303
*VMVJSNMP = ADDR(STPNM);               /*SET STEPNAME        @ZA16381*/
         LA    @11,STPNM(,@11)                                  03S0304
         ST    @11,VMVJSNMP(,@12)                               03S0304
* DO; /* SETLOCK (RELEASE) TYPE(CMS) REGS(USE) RELATED(UCB,IEFAB4A4(IEF
*B4A4,CHKMALCD)) */                                             03S0305
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                     03S0306
*   RFY (GPR15P,GPR00P,GPR01P) RSTD;                            03S0307
*   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */             03S0308
         LR    GPR15P,GPR11P                                    03S0308
*   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */              03S0309
         LR    GPR00P,GPR12P                                    03S0309
*   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */              03S0310
         LR    GPR01P,GPR13P                                    03S0310
*   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */    03S0311
         L     GPR13P,PSALITA                                   03S0311
*   GEN(LM GPR11P,GPR13P,552(GPR13P)); /* LOAD LOCKWORD, CLHT AND ENTRY
*ADRS. */                                                       03S0312
         LM GPR11P,GPR13P,552(GPR13P)
*   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */         03S0313
         BALR GPR14P,GPR13P
*   GPR11P = GPR15P; /* RESTORE REG. 11. */                     03S0314
         LR    GPR11P,GPR15P                                    03S0314
*   GPR15P = GPR13P; /* SAVE RETURN CODE. */                    03S0315
         LR    GPR15P,GPR13P                                    03S0315
*   GPR12P = GPR00P; /* RESTORE REG. 12 */                      03S0316
         LR    GPR12P,GPR00P                                    03S0316
*   GPR13P = GPR01P; /* RESTORE REG. 13. */                     03S0317
         LR    GPR13P,GPR01P                                    03S0317
*   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                           03S0318
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;                   03S0319
* END; /* SETLOCK (RELEASE) TYPE(CMS) REGS(USE) RELATED(UCB,IEFAB4A4(IE
*AB4A4,CHKMALCD)) */                                            03S0320
* DO; /* SETLOCK (RELEASE) TYPE(LOCAL) REGS(USE) RELATED(UCB,IEFAB4A4(I
*FAB4A4,CHKMALCD);) */                                          03S0321
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                     03S0322
*   RFY (GPR15P,GPR00P,GPR01P) RSTD;                            03S0323
*   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */             03S0324
         LR    GPR15P,GPR11P                                    03S0324
*   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */              03S0325
         LR    GPR00P,GPR12P                                    03S0325
*   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */              03S0326
         LR    GPR01P,GPR13P                                    03S0326
*   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */    03S0327
         L     GPR13P,PSALITA                                   03S0327
*   GEN(LM GPR11P,GPR13P,588(GPR13P)); /* LOAD LOCKWORD, CLHT AND ENTRY
*ADRS. */                                                       03S0328
         LM GPR11P,GPR13P,588(GPR13P)
*   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */         03S0329
         BALR GPR14P,GPR13P
*   GPR11P = GPR15P; /* RESTORE REG. 11. */                     03S0330
         LR    GPR11P,GPR15P                                    03S0330
*   GPR15P = GPR13P; /* SAVE RETURN CODE. */                    03S0331
         LR    GPR15P,GPR13P                                    03S0331
*   GPR12P = GPR00P; /* RESTORE REG. 12 */                      03S0332
         LR    GPR12P,GPR00P                                    03S0332
*   GPR13P = GPR01P; /* RESTORE REG. 13. */                     03S0333
         LR    GPR13P,GPR01P                                    03S0333
*   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                           03S0334
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;                   03S0335
* END; /* SETLOCK (RELEASE) TYPE(LOCAL) REGS(USE) RELATED(UCB,IEFAB4A4(
*EFAB4A4,CHKMALCD);) */;                                        03S0336
* DO; /*MODESET  EXTKEY(SCHED)*/                                03S0338
*   SPKA (16); /*SET PSW KEY*/                                  03S0339
         LA    @12,16                                           03S0339
         SPKA  0(@12)                                           03S0339
* END; /*MODESET  EXTKEY(SCHED)*/               /*GET INTO SCHED KEY  @
*A16381*/                                                       03S0340
*CALL IEFAB49C (VMVREQBP,ZERO,ZERO);   /*CALL VM&V TO UNLOAD @ZA16381*/
         MVC   @AL00001+4(8),@AL00341                           03S0341
         LA    @12,VMVREQBP                                     03S0341
         ST    @12,@AL00001                                     03S0341
         L     @15,@CV00069                                     03S0341
         LA    @01,@AL00001                                     03S0341
         BALR  @14,@15                                          03S0341
* DO; /*MODESET  KEYADDR(ZERO)*/                                03S0342
*   SPKA (ZERO); /*SET PSW KEY*/                                03S0343
         SLR   @12,@12                                          03S0343
         SPKA  0(@12)                                           03S0343
* END; /*MODESET  KEYADDR(ZERO)*/               /*GET INTO KEY ZERO   @
*A16381*/                                                       03S0344
* DO; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(LOCAL) REGS(USE) RELATED(UC
*,IEFAB4A4(IEFAB4A4)) */                                        03S0345
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                     03S0346
*   RFY (GPR15P,GPR00P,GPR01P) RSTD;                            03S0347
*   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */             03S0348
         LR    GPR15P,GPR11P                                    03S0348
*   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */              03S0349
         LR    GPR00P,GPR12P                                    03S0349
*   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */              03S0350
         LR    GPR01P,GPR13P                                    03S0350
*   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */    03S0351
         L     GPR13P,PSALITA                                   03S0351
*   GEN(LM GPR11P,GPR13P,576(GPR13P)); /* LOAD LOCKWORD, CLHT AND ENTRY
*ADRS. */                                                       03S0352
         LM GPR11P,GPR13P,576(GPR13P)
*   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */         03S0353
         BALR GPR14P,GPR13P
*   GPR11P = GPR15P; /* RESTORE REG. 11. */                     03S0354
         LR    GPR11P,GPR15P                                    03S0354
*   GPR15P = GPR13P; /* SAVE RETURN CODE. */                    03S0355
         LR    GPR15P,GPR13P                                    03S0355
*   GPR12P = GPR00P; /* RESTORE REG. 12 */                      03S0356
         LR    GPR12P,GPR00P                                    03S0356
*   GPR13P = GPR01P; /* RESTORE REG. 13. */                     03S0357
         LR    GPR13P,GPR01P                                    03S0357
*   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                           03S0358
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;                   03S0359
* END; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(LOCAL) REGS(USE) RELATED(U
*B,IEFAB4A4(IEFAB4A4)) */                                       03S0360
* DO; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(CMS) REGS(USE) RELATED(UCB,
*EFAB4A4(IEFAB4A4)) */                                          03S0361
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                     03S0362
*   RFY (GPR15P,GPR00P,GPR01P) RSTD;                            03S0363
*   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */             03S0364
         LR    GPR15P,GPR11P                                    03S0364
*   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */              03S0365
         LR    GPR00P,GPR12P                                    03S0365
*   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */              03S0366
         LR    GPR01P,GPR13P                                    03S0366
*   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */    03S0367
         L     GPR13P,PSALITA                                   03S0367
*   GEN(LM GPR11P,GPR13P,540(GPR13P)); /* LOAD LOCKWORD, CLHT AND ENTRY
*ADRS. */                                                       03S0368
         LM GPR11P,GPR13P,540(GPR13P)
*   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */         03S0369
         BALR GPR14P,GPR13P
*   GPR11P = GPR15P; /* RESTORE REG. 11. */                     03S0370
         LR    GPR11P,GPR15P                                    03S0370
*   GPR15P = GPR13P; /* SAVE RETURN CODE. */                    03S0371
         LR    GPR15P,GPR13P                                    03S0371
*   GPR12P = GPR00P; /* RESTORE REG. 12 */                      03S0372
         LR    GPR12P,GPR00P                                    03S0372
*   GPR13P = GPR01P; /* RESTORE REG. 13. */                     03S0373
         LR    GPR13P,GPR01P                                    03S0373
*   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                           03S0374
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;                   03S0375
* END; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(CMS) REGS(USE) RELATED(UCB
*IEFAB4A4(IEFAB4A4)) */                                         03S0376
*              END;                    /* END MSS UNLOAD     @ZA16381*/
*            UCBMOUNT = OFF;           /*TURN OFF MOUNT PENDING      */
@RF00298 NI    UCBMOUNT(UCBPTR),B'01111111'                     02S0378
*            UCBMMSGP = OFF;           /*TURN OFF MOUNT MSG     02S0379
*                                       PENDING              @ZA18110*/
         NI    UCBMMSGP(UCBPTR),B'11111011'                     02S0379
*            UCBBPRV = OFF;            /*TURN OFF PRIVATE            */
*            UCBBPUB = OFF;            /*TURN OFF PUBLIC             */
*            UCBBSTR = OFF;            /*TURN OFF STORAGE            */
         NI    UCBBPRV(UCBPTR),B'11100011'                      02S0382
*          END;                                                 02S0383
*        UCBALOC = OFF;                /*UNALLOCATE UNIT             */
@RF00296 NI    UCBALOC(UCBPTR),B'11110111'                      02S0384
*      END;                                                     02S0385
*     DO; /*MODESET  EXTKEY(SCHED)*/                            02S0386
@RF00285 DS    0H                                               02S0387
*       SPKA (16); /*SET PSW KEY*/                              02S0387
         LA    @12,16                                           02S0387
         SPKA  0(@12)                                           02S0387
*     END; /*MODESET  EXTKEY(SCHED)*/           /*RETURN TO SCHEDULER K
*Y     */                                                       02S0388
*  END;                                                         02S0389
*ELSE                                  /*NON- DA DEVICE TYPE         */
*  DO;                                                          02S0390
         B     @RC00278                                         02S0390
@RF00278 DS    0H                                               02S0391
*    UNALUNSW = ON;                    /*ASSUME CAN UNALLOCATE       */
         OI    UNALUNSW,B'00001000'                             02S0391
*    TIOUNAL(UNITCTR) = ON;            /*INDIC. DEV ENTRY UNALLOCATED*/
         SLR   @12,@12                                          02S0392
         IC    @12,UNITCTR                                      02S0392
         SLA   @12,2                                            02S0392
         L     @11,DSABTIOT(,DSABPTR)                           02S0392
         ALR   @11,@12                                          02S0392
         OI    TIOUNAL-4(@11),B'00000001'                       02S0392
*    IF CMCHKUN = YES THEN             /*MUST SEE IF OTHER USERS     */
         L     @12,CMRBPTR                                      02S0393
         TM    CMCHKUN(@12),B'01000000'                         02S0393
         BNO   @RF00393                                         02S0393
*      DO;                                                      02S0394
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - CHKMALCD                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - CHECK MULTIPLY ALLOCATED UNITS                */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE DETERMINES WHETHER OR NOT THE UCB RECEIVED AS     */
*/*   INPUT REPRESENTS A DEVICE THAT IS NO LONGER NEEDED BY THE      */
*/*   JOB STEP. THE ROUTINE MUST EXAMINE ALL THE TIOT DEVICE ENTRIES */
*/*   FOR THIS STEP WHICH ARE STILL ALLOCATED TO INSURE THAT THE     */
*/*   INPUT UCB DOES NOT EXIST IN ANOTHER ENTRY. IF IT DOES THE      */
*/*   UNIT CAN NOT BE UNALLOCATED AND AN INDICATOR IS SET TO REFLECT */
*/*   THIS SITUATION. LOCAL AND CMS LOCKS ARE RELEASED FOR THE       */
*/*   DURATION OF THIS PROCESSING.                                   */
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*   PURPOSE - DETERMINE WHETHER OR NOT UNIT CAN BE UNALLOCATED     */
*/*   INPUT -                                                        */
*/*     DSABPTR - PTR TO DSAB FOR REQUEST BEING PROCESSED            */
*/*     DSABQDBP - PTR TO DSAB QDB                                   */
*/*       DSAB QDB CONTAINS PTR TO FIRST DSAB (QDBFELMP)             */
*/*         DSAB CONTAINS POINTER TO TIOT DD ENTRY (DSABTIOT)        */
*/*           TIOT DD ENTRY CONTAINS A DEVICE ENTRY WITH UCB         */
*/*           ADDRESSES OF EACH UNIT ALLOCATED TO A REQUEST (TIOUCBP)*/
*/*     UNITCTR - CURRENT TIOT DEVICE ENTRY INDEX                    */
*/*     UNALUNSW - UNIT CAN BE UNALLOCATED INDICATOR (ON AT ENTRY)   */
*/*                                                                  */
*/* EXIT -                                                           */
*/*   CONDITION - UNIT CAN BE UNALLOCATED                            */
*/*     OUTPUT -                                                     */
*/*       UNALUNSW - ON (SAME AS AT ENTRY)                           */
*/*     RETURN CODE - NONE                                           */
*/*   CONDITION - UNIT CANNOT BE UNALLOCATED                         */
*/*     OUTPUT -                                                     */
*/*       UNALUNSW - OFF                                             */
*/*     RETURN CODE - NONE                                           */
*/********************************************************************/
* DO; /*MODESET  KEYADDR(ZERO)*/                                03S0395
*   SPKA (ZERO); /*SET PSW KEY*/                                03S0396
         SLR   @12,@12                                          03S0396
         SPKA  0(@12)                                           03S0396
* END; /*MODESET  KEYADDR(ZERO)*/               /*GET INTO KEY 0
*      */                                                       03S0397
* DO; /* SETLOCK (RELEASE) TYPE(CMS) REGS(USE) RELATED(UCB,IEFAB4A4(IEF
*B4A4)) */                                                      03S0398
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                     03S0399
*   RFY (GPR15P,GPR00P,GPR01P) RSTD;                            03S0400
*   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */             03S0401
         LR    GPR15P,GPR11P                                    03S0401
*   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */              03S0402
         LR    GPR00P,GPR12P                                    03S0402
*   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */              03S0403
         LR    GPR01P,GPR13P                                    03S0403
*   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */    03S0404
         L     GPR13P,PSALITA                                   03S0404
*   GEN(LM GPR11P,GPR13P,552(GPR13P)); /* LOAD LOCKWORD, CLHT AND ENTRY
*ADRS. */                                                       03S0405
         LM GPR11P,GPR13P,552(GPR13P)
*   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */         03S0406
         BALR GPR14P,GPR13P
*   GPR11P = GPR15P; /* RESTORE REG. 11. */                     03S0407
         LR    GPR11P,GPR15P                                    03S0407
*   GPR15P = GPR13P; /* SAVE RETURN CODE. */                    03S0408
         LR    GPR15P,GPR13P                                    03S0408
*   GPR12P = GPR00P; /* RESTORE REG. 12 */                      03S0409
         LR    GPR12P,GPR00P                                    03S0409
*   GPR13P = GPR01P; /* RESTORE REG. 13. */                     03S0410
         LR    GPR13P,GPR01P                                    03S0410
*   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                           03S0411
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;                   03S0412
* END; /* SETLOCK (RELEASE) TYPE(CMS) REGS(USE) RELATED(UCB,IEFAB4A4(IE
*AB4A4)) */                                                     03S0413
* DO; /* SETLOCK (RELEASE) TYPE(LOCAL) REGS(USE) RELATED(UCB,IEFAB4A4(I
*FAB4A4)) */                                                    03S0414
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                     03S0415
*   RFY (GPR15P,GPR00P,GPR01P) RSTD;                            03S0416
*   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */             03S0417
         LR    GPR15P,GPR11P                                    03S0417
*   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */              03S0418
         LR    GPR00P,GPR12P                                    03S0418
*   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */              03S0419
         LR    GPR01P,GPR13P                                    03S0419
*   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */    03S0420
         L     GPR13P,PSALITA                                   03S0420
*   GEN(LM GPR11P,GPR13P,588(GPR13P)); /* LOAD LOCKWORD, CLHT AND ENTRY
*ADRS. */                                                       03S0421
         LM GPR11P,GPR13P,588(GPR13P)
*   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */         03S0422
         BALR GPR14P,GPR13P
*   GPR11P = GPR15P; /* RESTORE REG. 11. */                     03S0423
         LR    GPR11P,GPR15P                                    03S0423
*   GPR15P = GPR13P; /* SAVE RETURN CODE. */                    03S0424
         LR    GPR15P,GPR13P                                    03S0424
*   GPR12P = GPR00P; /* RESTORE REG. 12 */                      03S0425
         LR    GPR12P,GPR00P                                    03S0425
*   GPR13P = GPR01P; /* RESTORE REG. 13. */                     03S0426
         LR    GPR13P,GPR01P                                    03S0426
*   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                           03S0427
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;                   03S0428
* END; /* SETLOCK (RELEASE) TYPE(LOCAL) REGS(USE) RELATED(UCB,IEFAB4A4(
*EFAB4A4)) */                                                   03S0429
* DO; /*MODESET  EXTKEY(SCHED)*/                                03S0430
*   SPKA (16); /*SET PSW KEY*/                                  03S0431
         LA    @12,16                                           03S0431
         SPKA  0(@12)                                           03S0431
* END; /*MODESET  EXTKEY(SCHED)*/               /*RETURN TO SCHEDULER K
*Y     */                                                       03S0432
*RFY DSAB BASED(TEMPDSAP);             /*USE TEMP BASE FOR DSAB      */
*TEMPDSAP = QDBFELMP;                  /*POINT TO FIRST DSAB ON CHAIN*/
         L     @12,@PC00001+8                                   03S0434
         L     @12,DSABQDBP(,@12)                               03S0434
         L     TEMPDSAP,QDBFELMP(,@12)                          03S0434
*DO WHILE(TEMPDSAP ^= ZERO &           /*SCAN ALL TIOT DD ENTRIES    */
*    UNALUNSW = ON);                   /*SCAN TO END OR UNIT IS STILL
*                                        NEEDED IN STEP              */
         B     @DE00435                                         03S0435
@DL00435 DS    0H                                               03S0436
*  IF TEMPDSAP ^= DSABPTR THEN         /*NOT REQUEST BEING PROCESSED */
         CR    TEMPDSAP,DSABPTR                                 03S0436
         BE    @RF00436                                         03S0436
*    DO DEVCTR = 1 TO TIOEWTCT         /*SCAN DEVICE ENTRIES FOR REQ.*/
*        WHILE(UNALUNSW = ON);         /*TERM. SCAN IF UNIT STILL
*                                        NEEDED IN STEP              */
         LA    DEVCTR,1                                         03S0437
         B     @DE00437                                         03S0437
@DL00437 TM    UNALUNSW,B'00001000'                             03S0437
         BNO   @DC00437                                         03S0437
*       IF TIOUNAL(DEVCTR) = NO &      /*UNIT STILL ALLOCATED TO REQ */
*           TIOUCBP(DEVCTR) =          /*UNIT SAME AS                */
*               UCBPTR THEN            /*                INPUT UNIT? */
         LR    @12,DEVCTR                                       03S0438
         SLA   @12,2                                            03S0438
         L     @11,DSABTIOT(,TEMPDSAP)                          03S0438
         ST    @12,@TF00001                                     03S0438
         ALR   @12,@11                                          03S0438
         TM    TIOUNAL-4(@12),B'00000001'                       03S0438
         BNZ   @RF00438                                         03S0438
         L     @12,@TF00001                                     03S0438
         L     @12,TIOUCBP-5(@12,@11)                           03S0438
         LA    @12,0(,@12)                                      03S0438
         CR    UCBPTR,@12                                       03S0438
         BNE   @RF00438                                         03S0438
*           UNALUNSW = OFF;            /*INDICATE UNIT CANNOT BE
*                                        UNALLOCATED                 */
         NI    UNALUNSW,B'11110111'                             03S0439
*    END;                                                       03S0440
@RF00438 AL    DEVCTR,@CF00051                                  03S0440
@DE00437 L     @12,DSABTIOT(,TEMPDSAP)                          03S0440
         SLR   @11,@11                                          03S0440
         IC    @11,TIOEWTCT(,@12)                               03S0440
         CR    DEVCTR,@11                                       03S0440
         BNH   @DL00437                                         03S0440
@DC00437 DS    0H                                               03S0441
*  ELSE;                               /*REQUEST PROCD               */
@RF00436 DS    0H                                               03S0442
*  TEMPDSAP = DSABFCHN;                /*POINT TO NEXT DSAB          */
         L     TEMPDSAP,DSABFCHN(,TEMPDSAP)                     03S0442
*END;                                                           03S0443
@DE00435 LTR   TEMPDSAP,TEMPDSAP                                03S0443
         BZ    @DC00435                                         03S0443
         TM    UNALUNSW,B'00001000'                             03S0443
         BO    @DL00435                                         03S0443
@DC00435 DS    0H                                               03S0444
*RFY DSAB BASED(DSABPTR);                                       03S0444
* DO; /*MODESET  KEYADDR(ZERO)*/                                03S0445
*   SPKA (ZERO); /*SET PSW KEY*/                                03S0446
         SLR   @12,@12                                          03S0446
         SPKA  0(@12)                                           03S0446
* END; /*MODESET  KEYADDR(ZERO)*/               /*GET INTO KEY 0
*      */                                                       03S0447
* DO; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(LOCAL) REGS(USE) RELATED(UC
*,IEFAB4A4(IEFAB4A4,UNALUNIT)) */                               03S0448
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                     03S0449
*   RFY (GPR15P,GPR00P,GPR01P) RSTD;                            03S0450
*   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */             03S0451
         LR    GPR15P,GPR11P                                    03S0451
*   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */              03S0452
         LR    GPR00P,GPR12P                                    03S0452
*   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */              03S0453
         LR    GPR01P,GPR13P                                    03S0453
*   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */    03S0454
         L     GPR13P,PSALITA                                   03S0454
*   GEN(LM GPR11P,GPR13P,576(GPR13P)); /* LOAD LOCKWORD, CLHT AND ENTRY
*ADRS. */                                                       03S0455
         LM GPR11P,GPR13P,576(GPR13P)
*   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */         03S0456
         BALR GPR14P,GPR13P
*   GPR11P = GPR15P; /* RESTORE REG. 11. */                     03S0457
         LR    GPR11P,GPR15P                                    03S0457
*   GPR15P = GPR13P; /* SAVE RETURN CODE. */                    03S0458
         LR    GPR15P,GPR13P                                    03S0458
*   GPR12P = GPR00P; /* RESTORE REG. 12 */                      03S0459
         LR    GPR12P,GPR00P                                    03S0459
*   GPR13P = GPR01P; /* RESTORE REG. 13. */                     03S0460
         LR    GPR13P,GPR01P                                    03S0460
*   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                           03S0461
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;                   03S0462
* END; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(LOCAL) REGS(USE) RELATED(U
*B,IEFAB4A4(IEFAB4A4,UNALUNIT)) */                              03S0463
* DO; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(CMS) REGS(USE) RELATED(UCB,
*EFAB4A4(IEFAB4A4,UNALUNIT)) */                                 03S0464
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                     03S0465
*   RFY (GPR15P,GPR00P,GPR01P) RSTD;                            03S0466
*   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */             03S0467
         LR    GPR15P,GPR11P                                    03S0467
*   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */              03S0468
         LR    GPR00P,GPR12P                                    03S0468
*   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */              03S0469
         LR    GPR01P,GPR13P                                    03S0469
*   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */    03S0470
         L     GPR13P,PSALITA                                   03S0470
*   GEN(LM GPR11P,GPR13P,540(GPR13P)); /* LOAD LOCKWORD, CLHT AND ENTRY
*ADRS. */                                                       03S0471
         LM GPR11P,GPR13P,540(GPR13P)
*   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */         03S0472
         BALR GPR14P,GPR13P
*   GPR11P = GPR15P; /* RESTORE REG. 11. */                     03S0473
         LR    GPR11P,GPR15P                                    03S0473
*   GPR15P = GPR13P; /* SAVE RETURN CODE. */                    03S0474
         LR    GPR15P,GPR13P                                    03S0474
*   GPR12P = GPR00P; /* RESTORE REG. 12 */                      03S0475
         LR    GPR12P,GPR00P                                    03S0475
*   GPR13P = GPR01P; /* RESTORE REG. 13. */                     03S0476
         LR    GPR13P,GPR01P                                    03S0476
*   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                           03S0477
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;                   03S0478
* END; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(CMS) REGS(USE) RELATED(UCB
*IEFAB4A4(IEFAB4A4,UNALUNIT)) */                                03S0479
* DO; /*MODESET  EXTKEY(SCHED)*/                                03S0480
*   SPKA (16); /*SET PSW KEY*/                                  03S0481
         LA    @12,16                                           03S0481
         SPKA  0(@12)                                           03S0481
* END; /*MODESET  EXTKEY(SCHED)*/               /*RETURN TO SCHEDULER K
*Y     */                                                       03S0482
*      END;                                                     02S0483
*    IF UNALUNSW = YES THEN            /*CAN UNALLOCATE UNIT         */
@RF00393 TM    UNALUNSW,B'00001000'                             02S0484
         BNO   @RF00484                                         02S0484
*      DO;                                                      02S0485
*        IF SIO3TAPE = YES THEN        /*TAPE DEVICE                 */
         TM    SIO3TAPE(SIOTPTR),B'10000000'                    02S0486
         BNO   @RF00486                                         02S0486
*          DO;                                                  02S0487
*            IF (TIORWND(UNITCTR) = YES &  /*REWIND REQUESTED    @ZD030
*0*/             UCBMONT = NO &            /*NO PASSED D.S. ON VOL
* */             UCBRESV = NO) |/*                              02S0488
*                                        NEED TO REWIND      @ZD03010*/
*               (UCBBPRV=ON   & /*PRIVATE VOL         @ZD03010*/
*                SIOTNPRV=OFF & /*NOT CHNGNG TO PUB   @ZD03010*/
*                UNALNVUT=OFF & /*VOL UNLDNG REQUESTD @ZD03010*/
*                UCBRESV=OFF  & /*NOT RESERVED VOL    @ZD03010*/
*                UCBALOC = ON & /*UNIT ALLOCATED      @ZA06790*/
*                UCBMONT=OFF &  /*NOT PASS/RETAIN     @ZA09206*/
*                UCBJES3=OFF)   /*NOT JES MANAGED     @ZA09206*/
*                             THEN/*                            02S0488
*                                        NEED TO UNLOAD      @ZD03010*/
         SLR   @12,@12                                          02S0488
         IC    @12,UNITCTR                                      02S0488
         SLA   @12,2                                            02S0488
         L     @11,DSABTIOT(,DSABPTR)                           02S0488
         ALR   @11,@12                                          02S0488
         TM    TIORWND-4(@11),B'00000010'                       02S0488
         BNO   @GL00020                                         02S0488
         TM    UCBMONT(UCBPTR),B'00000001'                      02S0488
         BNZ   @GL00020                                         02S0488
         TM    UCBRESV(UCBPTR),B'00100000'                      02S0488
         BZ    @RT00488                                         02S0488
@GL00020 TM    UCBBPRV(UCBPTR),B'00010000'                      02S0488
         BNO   @RF00488                                         02S0488
         TM    SIOTNPRV(SIOTPTR),B'00010000'                    02S0488
         BNZ   @RF00488                                         02S0488
         L     @12,@PC00001                                     02S0488
         TM    UNALNVUT(@12),B'01000000'                        02S0488
         BNZ   @RF00488                                         02S0488
         TM    UCBALOC(UCBPTR),B'00001000'                      02S0488
         BNO   @RF00488                                         02S0488
         TM    UCBRESV(UCBPTR),B'00100000'                      02S0488
         BNZ   @RF00488                                         02S0488
         TM    UCBMONT(UCBPTR),B'01000001'                      02S0488
         BNZ   @RF00488                                         02S0488
@RT00488 DS    0H                                               02S0489
*              DO;                                              02S0489
*                 DO; /*MODESET  KEYADDR(ZERO)*/                02S0490
*                   SPKA (ZERO); /*SET PSW KEY*/                02S0491
         SLR   @12,@12                                          02S0491
         SPKA  0(@12)                                           02S0491
*                 END; /*MODESET  KEYADDR(ZERO)*//*GET INTO KEY 0
*      */                                                       02S0492
*                 DO; /* SETLOCK (RELEASE) TYPE(CMS) REGS(USE) RELATED(
*CB,IEFAB4A4(IEFAB4A4,CHKMALCD)) */                             02S0493
*                   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;     02S0494
*                   RFY (GPR15P,GPR00P,GPR01P) RSTD;            02S0495
*                   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */
         LR    GPR15P,GPR11P                                    02S0496
*                   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */
         LR    GPR00P,GPR12P                                    02S0497
*                   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */
         LR    GPR01P,GPR13P                                    02S0498
*                   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABL
*. */               GEN(LM GPR11P,GPR13P,552(GPR13P)); /* LOAD LOCKWORD
* CLHT AND ENTRY ADRS. */                                       02S0499
         L     GPR13P,PSALITA                                   02S0499
         LM GPR11P,GPR13P,552(GPR13P)
*                   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */
         BALR GPR14P,GPR13P
*                   GPR11P = GPR15P; /* RESTORE REG. 11. */     02S0502
         LR    GPR11P,GPR15P                                    02S0502
*                   GPR15P = GPR13P; /* SAVE RETURN CODE. */    02S0503
         LR    GPR15P,GPR13P                                    02S0503
*                   GPR12P = GPR00P; /* RESTORE REG. 12 */      02S0504
         LR    GPR12P,GPR00P                                    02S0504
*                   GPR13P = GPR01P; /* RESTORE REG. 13. */     02S0505
         LR    GPR13P,GPR01P                                    02S0505
*                   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;           02S0506
*                   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;   02S0507
*                 END; /* SETLOCK (RELEASE) TYPE(CMS) REGS(USE) RELATED
*UCB,IEFAB4A4(IEFAB4A4,CHKMALCD)) */                            02S0508
*                 DO; /* SETLOCK (RELEASE) TYPE(LOCAL) REGS(USE) RELATE
*(UCB,IEFAB4A4(IEFAB4A4,CHKMALCD)) */                           02S0509
*                   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;     02S0510
*                   RFY (GPR15P,GPR00P,GPR01P) RSTD;            02S0511
*                   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */
         LR    GPR15P,GPR11P                                    02S0512
*                   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */
         LR    GPR00P,GPR12P                                    02S0513
*                   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */
         LR    GPR01P,GPR13P                                    02S0514
*                   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABL
*. */               GEN(LM GPR11P,GPR13P,588(GPR13P)); /* LOAD LOCKWORD
* CLHT AND ENTRY ADRS. */                                       02S0515
         L     GPR13P,PSALITA                                   02S0515
         LM GPR11P,GPR13P,588(GPR13P)
*                   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */
         BALR GPR14P,GPR13P
*                   GPR11P = GPR15P; /* RESTORE REG. 11. */     02S0518
         LR    GPR11P,GPR15P                                    02S0518
*                   GPR15P = GPR13P; /* SAVE RETURN CODE. */    02S0519
         LR    GPR15P,GPR13P                                    02S0519
*                   GPR12P = GPR00P; /* RESTORE REG. 12 */      02S0520
         LR    GPR12P,GPR00P                                    02S0520
*                   GPR13P = GPR01P; /* RESTORE REG. 13. */     02S0521
         LR    GPR13P,GPR01P                                    02S0521
*                   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;           02S0522
*                   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;   02S0523
*                 END; /* SETLOCK (RELEASE) TYPE(LOCAL) REGS(USE) RELAT
*D(UCB,IEFAB4A4(IEFAB4A4,CHKMALCD)) */                          02S0524
*                 DO; /*MODESET  EXTKEY(SCHED)*/                02S0525
*                   SPKA (16); /*SET PSW KEY*/                  02S0526
         LA    @12,16                                           02S0526
         SPKA  0(@12)                                           02S0526
*                 END; /*MODESET  EXTKEY(SCHED)*//*RETURN TO SCHEDULER
*EY    */                                                       02S0527
*                VMVRQBLK = VMVRQBLK && VMVRQBLK; /*CLEAR REQUEST BLK*/
         L     @12,VMVREQBP                                     02S0528
         XC    VMVRQBLK(52,@12),VMVRQBLK(@12)                   02S0528
*                VMVUCBP = UCBPTR;     /*SET PTR TO UCB OF VOLUME    */
         STCM  UCBPTR,7,VMVUCBP(@12)                            02S0529
*                VMVUCB = ON;          /*VOLSER IS IN UCB.   @ZD03010*/
         OI    VMVUCB(@12),B'01000000'                          02S0530
*                IF (UCBBPRV=ON   & /*PRIVATE VOL         @ZD03010*/
*                    SIOTNPRV=OFF & /*NOT CHNGNG TO PUB   @ZD03010*/
*                    UNALNVUT=OFF & /*VOL UNLDNG REQUESTD @ZD03010*/
*                    UCBRESV=OFF  & /*NOT RESERVED VOL    @ZD03010*/
*                    UCBALOC = ON & /*UNIT ALLOCATED      @ZA06790*/
*                    UCBMONT=OFF &  /*NOT PASS/RETAIN     @ZA09206*/
*                    UCBJES3=OFF)   /*NOT JES MANAGED     @ZA09206*/
*                                 THEN/*                        02S0531
*                                        NEED TO UNLOAD.     @ZD03010*/
         TM    UCBBPRV(UCBPTR),B'00010000'                      02S0531
         BNO   @RF00531                                         02S0531
         TM    SIOTNPRV(SIOTPTR),B'00010000'                    02S0531
         BNZ   @RF00531                                         02S0531
         L     @11,@PC00001                                     02S0531
         TM    UNALNVUT(@11),B'01000000'                        02S0531
         BNZ   @RF00531                                         02S0531
         TM    UCBALOC(UCBPTR),B'00001000'                      02S0531
         BNO   @RF00531                                         02S0531
         TM    UCBRESV(UCBPTR),B'00100000'                      02S0531
         BNZ   @RF00531                                         02S0531
         TM    UCBMONT(UCBPTR),B'01000001'                      02S0531
         BNZ   @RF00531                                         02S0531
*                  DO;                 /*DO UNLOAD STUFF.    @ZD03010*/
*                    VMVUNLOD = ON;    /*REQUEST UNLOAD.     @ZD03010*/
         OI    VMVUNLOD(@12),B'10000000'                        02S0533
*                    VMVKEEP = ON;     /*REQUEST KEEP MSG.   @ZD03010*/
         OI    VMVKEEP(@12),B'10000000'                         02S0534
*                    VMVJBNMP=ADDR(JOBNM); /*JOBNAME FOR MSG @ZD03010*/
         L     @11,@PC00001+20                                  02S0535
         L     @11,NAMESPTR(,@11)                               02S0535
         ST    @11,VMVJBNMP(,@12)                               02S0535
*                    VMVJSNMP=ADDR(STPNM); /*STPNAME FOR MSG @ZD03010*/
         LA    @11,STPNM(,@11)                                  02S0536
         ST    @11,VMVJSNMP(,@12)                               02S0536
*                    IF VUTENTNO=DIM(VUTENTRY) THEN /*NO SPACE FOR
*                                                     ENTRY  @ZD03010*/
         L     @12,VUTPTR                                       02S0537
         CLI   VUTENTNO(@12),24                                 02S0537
         BNE   @RF00537                                         02S0537
*                      CALL CRVUTAB;   /*GET NEW VUT BLOCK   @ZD03010*/
         BAL   @14,CRVUTAB                                      02S0538
*                    VUTENVOL(VUTCTR)=UCBVOLI; /*VOLSER->VUT @ZD03010*/
@RF00537 L     @12,VUTPTR                                       02S0539
         SLR   @11,@11                                          02S0539
         IC    @11,VUTCTR                                       02S0539
         LR    @15,@11                                          02S0539
         MH    @15,@CH00104                                     02S0539
         ST    @15,@TF00001                                     02S0539
         ALR   @15,@12                                          02S0539
         MVC   VUTENVOL-7(6,@15),UCBVOLI(UCBPTR)                02S0539
*                    VUTUNLOD(VUTCTR)=ON; /*VOL UNLOADED     @ZD03010*/
         LR    @01,@12                                          02S0540
         AL    @01,@TF00001                                     02S0540
         OI    VUTUNLOD-7(@01),B'01000000'                      02S0540
*                    VUTENTNO = VUTCTR; /*UPDATE # ENTRIES IN VUT
*                                         BLOCK              @ZD03010*/
         STC   @11,VUTENTNO(,@12)                               02S0541
*                    VUTCTR=VUTCTR+ONE; /*BUMP ENTRY INDEX   @ZD03010*/
         LA    @11,1(,@11)                                      02S0542
         STC   @11,VUTCTR                                       02S0542
*                  END;                /*END UNLOAD STUFF.   @ZD03010*/
*                ELSE                  /*REWIND NEEDED.      @ZD03010*/
*                  VMVREWND = ON;      /*REQUEST REWIND.     @ZD03010*/
         B     @RC00531                                         02S0544
@RF00531 L     @12,VMVREQBP                                     02S0544
         OI    VMVREWND(@12),B'00100000'                        02S0544
*                CALL IEFAB49C         /*INVOKE VOLUME MOUNT & VERIFY*/
*                     (VMVREQBP,ZERO,ZERO);                     02S0545
@RC00531 MVC   @AL00001+4(8),@AL00545                           02S0545
         LA    @12,VMVREQBP                                     02S0545
         ST    @12,@AL00001                                     02S0545
         L     @15,@CV00069                                     02S0545
         LA    @01,@AL00001                                     02S0545
         BALR  @14,@15                                          02S0545
*                 DO; /*MODESET  KEYADDR(ZERO)*/                02S0546
*                   SPKA (ZERO); /*SET PSW KEY*/                02S0547
         SLR   @12,@12                                          02S0547
         SPKA  0(@12)                                           02S0547
*                 END; /*MODESET  KEYADDR(ZERO)*//*GET INTO KEY 0
*      */                                                       02S0548
*                 DO; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(LOCAL) REGS
*USE) RELATED(UCB,IEFAB4A4(IEFAB4A4)) */                        02S0549
*                   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;     02S0550
*                   RFY (GPR15P,GPR00P,GPR01P) RSTD;            02S0551
*                   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */
         LR    GPR15P,GPR11P                                    02S0552
*                   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */
         LR    GPR00P,GPR12P                                    02S0553
*                   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */
         LR    GPR01P,GPR13P                                    02S0554
*                   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABL
*. */               GEN(LM GPR11P,GPR13P,576(GPR13P)); /* LOAD LOCKWORD
* CLHT AND ENTRY ADRS. */                                       02S0555
         L     GPR13P,PSALITA                                   02S0555
         LM GPR11P,GPR13P,576(GPR13P)
*                   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */
         BALR GPR14P,GPR13P
*                   GPR11P = GPR15P; /* RESTORE REG. 11. */     02S0558
         LR    GPR11P,GPR15P                                    02S0558
*                   GPR15P = GPR13P; /* SAVE RETURN CODE. */    02S0559
         LR    GPR15P,GPR13P                                    02S0559
*                   GPR12P = GPR00P; /* RESTORE REG. 12 */      02S0560
         LR    GPR12P,GPR00P                                    02S0560
*                   GPR13P = GPR01P; /* RESTORE REG. 13. */     02S0561
         LR    GPR13P,GPR01P                                    02S0561
*                   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;           02S0562
*                   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;   02S0563
*                 END; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(LOCAL) REG
*(USE) RELATED(UCB,IEFAB4A4(IEFAB4A4)) */                       02S0564
*                 DO; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(CMS) REGS(U
*E) RELATED(UCB,IEFAB4A4(IEFAB4A4)) */                          02S0565
*                   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;     02S0566
*                   RFY (GPR15P,GPR00P,GPR01P) RSTD;            02S0567
*                   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */
         LR    GPR15P,GPR11P                                    02S0568
*                   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */
         LR    GPR00P,GPR12P                                    02S0569
*                   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */
         LR    GPR01P,GPR13P                                    02S0570
*                   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABL
*. */               GEN(LM GPR11P,GPR13P,540(GPR13P)); /* LOAD LOCKWORD
* CLHT AND ENTRY ADRS. */                                       02S0571
         L     GPR13P,PSALITA                                   02S0571
         LM GPR11P,GPR13P,540(GPR13P)
*                   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */
         BALR GPR14P,GPR13P
*                   GPR11P = GPR15P; /* RESTORE REG. 11. */     02S0574
         LR    GPR11P,GPR15P                                    02S0574
*                   GPR15P = GPR13P; /* SAVE RETURN CODE. */    02S0575
         LR    GPR15P,GPR13P                                    02S0575
*                   GPR12P = GPR00P; /* RESTORE REG. 12 */      02S0576
         LR    GPR12P,GPR00P                                    02S0576
*                   GPR13P = GPR01P; /* RESTORE REG. 13. */     02S0577
         LR    GPR13P,GPR01P                                    02S0577
*                   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;           02S0578
*                   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;   02S0579
*                 END; /* SETLOCK (OBTAIN) MODE(UNCOND) TYPE(CMS) REGS(
*SE) RELATED(UCB,IEFAB4A4(IEFAB4A4)) */                         02S0580
*                 DO; /*MODESET  EXTKEY(SCHED)*/                02S0581
*                   SPKA (16); /*SET PSW KEY*/                  02S0582
         LA    @12,16                                           02S0582
         SPKA  0(@12)                                           02S0582
*                 END; /*MODESET  EXTKEY(SCHED)*//*RETURN TO SCHEDULER
*EY    */                                                       02S0583
*              END;                                             02S0584
*             DO; /*MODESET  KEYADDR(ZERO)*/                    02S0585
@RF00488 DS    0H                                               02S0586
*               SPKA (ZERO); /*SET PSW KEY*/                    02S0586
         SLR   @12,@12                                          02S0586
         SPKA  0(@12)                                           02S0586
*             END; /*MODESET  KEYADDR(ZERO)*/   /*GET KEY 0 TO UPDATE U
*B     */                                                       02S0587
*            IF UCBATI = UATISKED THEN /*IF SCHEDULER INDEX  @ZA04550*/
         L     @12,UCBEXTPT(,UCBPTR)                            02S0588
         CLI   UCBATI(@12),12                                   02S0588
         BNE   @RF00588                                         02S0588
*              UCBATI = ZERO;          /*CLEAR ATTN TAB INDEX        */
         MVI   UCBATI(@12),X'00'                                02S0589
*            UCBDMC = CLRDMCT;         /*CLEAR DATA MGMT COUNT       */
@RF00588 NI    UCBDMC(UCBPTR),B'10000000'                       02S0590
*            UCBNSRCH = OFF;           /*CLEAR NON-SCRATCH VOL INDIC */
         L     @12,UCBEXTPT(,UCBPTR)                            02S0591
         NI    UCBNSRCH(@12),B'01111111'                        02S0591
*            UCBREW = OFF;             /*CLEAR REWIND INDICATOR      */
         NI    UCBREW(UCBPTR),B'11101111'                       02S0592
*            IF SIOTNPRV = YES THEN    /*VOL TO BE TREATED AS PUBLIC */
         TM    SIOTNPRV(SIOTPTR),B'00010000'                    02S0593
         BNO   @RF00593                                         02S0593
*              DO;                                              02S0594
*                UCBBPRV = OFF;        /*SET PRIVATE OFF.            */
*                UCBBPUB = ON;         /*SET PUBLIC ON.              */
         OI    UCBBPUB(UCBPTR),B'00001000'                      02S0596
         NI    UCBBPRV(UCBPTR),B'11101111'                      02S0596
*              END;                                             02S0597
*            IF CMSETPRV = YES THEN    /*VOL TO BE TREATED AS PRIVATE*/
@RF00593 L     @12,CMRBPTR                                      02S0598
         TM    CMSETPRV(@12),B'00001000'                        02S0598
         BNO   @RF00598                                         02S0598
*              DO;                     /*YES, SET PRIVATE IN UCB.    */
*                UCBBPRV = ON;         /*SET PRIVATE ON              */
*                UCBBPUB = OFF;        /*SET PUBLIC OFF              */
         OI    UCBBPRV(UCBPTR),B'00010000'                      02S0601
         NI    UCBBPUB(UCBPTR),B'11110111'                      02S0601
*              END;                                             02S0602
*            IF UCBBPRV = ON |         /*PRIVATE VOLUME?     @ZD03010*/
*               (SIOTPASS = OFF &      /*PUBLIC VOL,NOT PASS @ZD03010*/
*                SIOTRETN = OFF) THEN  /*NOT RETAIN          @ZD03010*/
@RF00598 TM    UCBBPRV(UCBPTR),B'00010000'                      02S0603
         BO    @RT00603                                         02S0603
         TM    SIOTPASS(SIOTPTR),B'10010000'                    02S0603
         BNZ   @RF00603                                         02S0603
@RT00603 DS    0H                                               02S0604
*              UCBMONT = OFF;          /*SET PASS/RETAIN INDICATOR
*                                        OFF                 @ZD03010*/
         NI    UCBMONT(UCBPTR),B'11111110'                      02S0604
*        IF UCBVOLI = ZEROVLSR THEN    /*VOLID IN UCB ZERO?          */
@RF00603 CLC   UCBVOLI(6,UCBPTR),ZEROVLSR                       02S0605
         BNE   @RF00605                                         02S0605
*          DO;                         /*YES, VOL NEVER MOUNTED      */
*            UCBMOUNT = OFF;           /*TURN OFF MOUNT PENDING      */
         NI    UCBMOUNT(UCBPTR),B'01111111'                     02S0607
*            UCBMMSGP = OFF;           /*TURN OFF MOUNT MSG     02S0608
*                                        PENDING INDICATOR   @ZA18110*/
         NI    UCBMMSGP(UCBPTR),B'11111011'                     02S0608
*            UCBBPRV = OFF;            /*TURN OFF PRIVATE            */
*            UCBBPUB = OFF;            /*TURN OFF PUBLIC             */
         NI    UCBBPRV(UCBPTR),B'11100111'                      02S0610
*          END;                                                 02S0611
*          END;                                                 02S0612
@RF00605 DS    0H                                               02S0613
*         DO; /*MODESET  KEYADDR(ZERO)*/                        02S0613
@RF00486 DS    0H                                               02S0614
*           SPKA (ZERO); /*SET PSW KEY*/                        02S0614
         SLR   @12,@12                                          02S0614
         SPKA  0(@12)                                           02S0614
*         END; /*MODESET  KEYADDR(ZERO)*/       /*GET INTO KEY ZERO
*      */                                                       02S0615
*        UCBALOC = OFF;                /*INDICATE UNIT UNALLOCATED   */
         NI    UCBALOC(UCBPTR),B'11110111'                      02S0616
*        IF UCB3TAPE = OFF THEN        /*NON-TAPE DEVICE     @ZA05164*/
         TM    UCB3TAPE(UCBPTR),B'10000000'                     02S0617
         BNZ   @RF00617                                         02S0617
*          UCBASID = ZERO;             /*ZERO ASID.          @ZA05164*/
         L     @11,UCBEXTPT(,UCBPTR)                            02S0618
         STH   @12,UCBASID(,@11)                                02S0618
*         DO; /*MODESET  EXTKEY(SCHED)*/                        02S0619
@RF00617 DS    0H                                               02S0620
*           SPKA (16); /*SET PSW KEY*/                          02S0620
         LA    @12,16                                           02S0620
         SPKA  0(@12)                                           02S0620
*         END; /*MODESET  EXTKEY(SCHED)*/       /*RETURN TO SCHEDULER K
*Y     */                                                       02S0621
*        IF SIO3COMM = NO THEN         /*NOT COMMUNICATIONS DEV      */
         TM    SIO3COMM(SIOTPTR),B'01000000'                    02S0622
         BNZ   @RF00622                                         02S0622
*          SGRPMSW = ON;               /*NEED GROUP MASK ENTRY       */
         OI    SGRPMSW,B'00010000'                              02S0623
*      END;                                                     02S0624
@RF00622 DS    0H                                               02S0625
*  END;                                                         02S0625
@RF00484 DS    0H                                               02S0626
*IF UNALNPST = NO &                    /*POST FUNCTION REQUESTED     */
*    SGRPMSW = YES &                   /*NEED GROUP MASK ENTRY       */
*    DSABGIDP ^= ZERO &                /*GROUP ID LIST EXISTS        */
*    DSABGRID(UNITCTR) ^= ZERO THEN    /*NECESSARY LIST ENTRY EXISTS */
@RC00278 L     @12,@PC00001                                     02S0626
         TM    UNALNPST(@12),B'10000000'                        02S0626
         BNZ   @RF00626                                         02S0626
         TM    SGRPMSW,B'00010000'                              02S0626
         BNO   @RF00626                                         02S0626
         SLR   @12,@12                                          02S0626
         L     @11,DSABGIDP(,DSABPTR)                           02S0626
         CR    @11,@12                                          02S0626
         BE    @RF00626                                         02S0626
         SLR   @15,@15                                          02S0626
         IC    @15,UNITCTR                                      02S0626
         SLA   @15,2                                            02S0626
         L     @11,DSABGRID-4(@15,@11)                          02S0626
         CLR   @11,@12                                          02S0626
         BE    @RF00626                                         02S0626
*  DO;                                                          02S0627
*    GRMSKBYT =                                                 02S0628
*        DSABGRID(UNITCTR)/LENGTH(GRPMSK); /*GET BYTE POS'N IN MASK  */
         LR    GRMSKBYT,@11                                     02S0628
         SRL   GRMSKBYT,3                                       02S0628
*    GRMSKBIT =                                                 02S0629
*        DSABGRID(UNITCTR)//LENGTH(GRPMSK); /*GET BIT POS'N IN BYTE  */
         N     @11,@CF00104                                     02S0629
         LR    GRMSKBIT,@11                                     02S0629
*    IF GRMSKBIT = ZERO THEN           /*BIT POSITION ZERO IS LAST   */
         CR    GRMSKBIT,@12                                     02S0630
         BNE   @RF00630                                         02S0630
*      GRMSKBIT = LENGTH(GRPMSK);      /*SET FOR LAST BIT POSITION   */
         LA    GRMSKBIT,8                                       02S0631
*    ELSE                              /*BIT POS 0 NOT LAST          */
*      GRMSKBYT = GRMSKBYT + ONE;      /*ADJUST BYTE POSITION        */
         B     @RC00630                                         02S0632
@RF00630 LA    GRMSKBYT,1(,GRMSKBYT)                            02S0632
*    GRPMSK(GRMSKBYT) =                /*SET PROPER BYTE IN MASK     */
*        GRPMSK(GRMSKBYT) | MASKTAB(GRMSKBIT); /*SET PROPER BIT OF
*                                        MASK BYTE                   */
@RC00630 L     @12,GRPMSKP                                      02S0633
         ALR   @12,GRMSKBYT                                     02S0633
         BCTR  @12,0                                            02S0633
         LA    @11,MASKTAB-1(GRMSKBIT)                          02S0633
         OC    GRPMSK(1,@12),0(@11)                             02S0633
*    GRENTSW = ON;                     /*INDICATE NEED TO DO POST    */
         OI    GRENTSW,B'10000000'                              02S0634
*  END;                                                         02S0635
*SGRPMSW = OFF;                        /*RE-INIT 'NEED ENTRY' SWITCH */
@RF00626 NI    SGRPMSW,B'11101111'                              02S0636
*            IF UNALCHAT = YES &         /*REQUESTED TO CHANGE ATTRS
*/             (TIONOPV(UNITCTR) = YES | /*VOL HAD NO USE ATTRIBUTE
*/             TIOPUBPV(UNITCTR) = YES) THEN/*                  01S0637
*                                        CHANGE USE ATTRIBUTE IN UCB */
         L     @12,@PC00001                                     01S0637
         TM    UNALCHAT(@12),B'00100000'                        01S0637
         BNO   @RF00637                                         01S0637
         SLR   @12,@12                                          01S0637
         IC    @12,UNITCTR                                      01S0637
         SLA   @12,2                                            01S0637
         L     @11,DSABTIOT(,DSABPTR)                           01S0637
         ST    @12,@TF00001                                     01S0637
         ALR   @12,@11                                          01S0637
         TM    TIONOPV-4(@12),B'00001100'                       01S0637
         BZ    @RF00637                                         01S0637
*              DO;                                              01S0638
*                 DO; /*MODESET  KEYADDR(ZERO)*/                01S0639
*                   SPKA (ZERO); /*SET PSW KEY*/                01S0640
         SLR   @12,@12                                          01S0640
         SPKA  0(@12)                                           01S0640
*                 END; /*MODESET  KEYADDR(ZERO)*/ /*GET KEY 0 TO UPDATE
*UCB   */                                                       01S0641
*                UCBBPRV = OFF;        /*VOL IS NO LONGER PRIVATE    */
         NI    UCBBPRV(UCBPTR),B'11101111'                      01S0642
*                IF TIOPUBPV(UNITCTR) = YES THEN /*VOL CHANGED FROM
*                                        PUBLIC                      */
         AL    @11,@TF00001                                     01S0643
         TM    TIOPUBPV-4(@11),B'00001000'                      01S0643
         BNO   @RF00643                                         01S0643
*                  UCBBPUB = ON;       /*SET USE ATTRIBUTE TO PUBLIC */
         OI    UCBBPUB(UCBPTR),B'00001000'                      01S0644
*                 DO; /*MODESET  EXTKEY(SCHED)*/                01S0645
@RF00643 DS    0H                                               01S0646
*                   SPKA (16); /*SET PSW KEY*/                  01S0646
         LA    @12,16                                           01S0646
         SPKA  0(@12)                                           01S0646
*                 END; /*MODESET  EXTKEY(SCHED)*/ /*RETURN TO SCHEDULER
*KEY   */                                                       01S0647
*              END;                                             01S0648
*          END;                                                 01S0649
@RF00637 DS    0H                                               01S0650
*      END;                                                     01S0650
@RF00276 LA    @12,1                                            01S0650
         SLR   @11,@11                                          01S0650
         IC    @11,UNITCTR                                      01S0650
         ALR   @12,@11                                          01S0650
@DE00274 STC   @12,UNITCTR                                      01S0650
         L     @11,DSABTIOT(,DSABPTR)                           01S0650
         SLR   @06,@06                                          01S0650
         IC    @06,TIOEWTCT(,@11)                               01S0650
         CR    @12,@06                                          01S0650
         BNH   @DL00274                                         01S0650
*    END;                                                       01S0651
*  SIOTSTEP = ON;                      /*INDICATE REQUEST PROCESSED  */
@RF00271 OI    SIOTSTEP(SIOTPTR),B'00001000'                    01S0652
*  CMRBPTR = CMNRBPTR;                 /*PROCESS NEXT REQUEST BLOCK  */
         L     @12,CMRBPTR                                      01S0653
         L     @12,CMNRBPTR(,@12)                               01S0653
         ST    @12,CMRBPTR                                      01S0653
*END;                                                           01S0654
@DE00268 SLR   @12,@12                                          01S0654
         C     @12,CMRBPTR                                      01S0654
         BNE   @DL00268                                         01S0654
* DO; /*MODESET  KEYADDR(ZERO)*/                                01S0655
*   SPKA (ZERO); /*SET PSW KEY*/                                01S0656
         SPKA  0(@12)                                           01S0656
* END; /*MODESET  KEYADDR(ZERO)*/               /*GET INTO KEY 0
*      */                                                       01S0657
* DO; /* SETLOCK (RELEASE) TYPE(CMS) REGS(USE) RELATED(UCB,IEFAB4A4(IEF
*B4A4,CHKMALCD,UNALUNIT)) */                                    01S0658
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                     01S0659
*   RFY (GPR15P,GPR00P,GPR01P) RSTD;                            01S0660
*   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */             01S0661
         LR    GPR15P,GPR11P                                    01S0661
*   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */              01S0662
         LR    GPR00P,GPR12P                                    01S0662
*   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */              01S0663
         LR    GPR01P,GPR13P                                    01S0663
*   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */    01S0664
         L     GPR13P,PSALITA                                   01S0664
*   GEN(LM GPR11P,GPR13P,552(GPR13P)); /* LOAD LOCKWORD, CLHT AND ENTRY
*ADRS. */                                                       01S0665
         LM GPR11P,GPR13P,552(GPR13P)
*   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */         01S0666
         BALR GPR14P,GPR13P
*   GPR11P = GPR15P; /* RESTORE REG. 11. */                     01S0667
         LR    GPR11P,GPR15P                                    01S0667
*   GPR15P = GPR13P; /* SAVE RETURN CODE. */                    01S0668
         LR    GPR15P,GPR13P                                    01S0668
*   GPR12P = GPR00P; /* RESTORE REG. 12 */                      01S0669
         LR    GPR12P,GPR00P                                    01S0669
*   GPR13P = GPR01P; /* RESTORE REG. 13. */                     01S0670
         LR    GPR13P,GPR01P                                    01S0670
*   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                           01S0671
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;                   01S0672
* END; /* SETLOCK (RELEASE) TYPE(CMS) REGS(USE) RELATED(UCB,IEFAB4A4(IE
*AB4A4,CHKMALCD,UNALUNIT)) */                                   01S0673
* DO; /* SETLOCK (RELEASE) TYPE(LOCAL) REGS(USE) RELATED(UCB,IEFAB4A4(I
*FAB4A4,CHKMALCD,UNALUNIT)) */                                  01S0674
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) RSTD;                     01S0675
*   RFY (GPR15P,GPR00P,GPR01P) RSTD;                            01S0676
*   GPR15P = GPR11P; /* SAVE REG. 11 IN REG. 15. */             01S0677
         LR    GPR15P,GPR11P                                    01S0677
*   GPR00P = GPR12P; /* SAVE REG. 12 IN REG. 0. */              01S0678
         LR    GPR00P,GPR12P                                    01S0678
*   GPR01P = GPR13P; /* SAVE REG. 13 IN REG. 1. */              01S0679
         LR    GPR01P,GPR13P                                    01S0679
*   GPR13P = PSALITA; /* ADDRESS OF LOCK INTERFACE TABLE. */    01S0680
         L     GPR13P,PSALITA                                   01S0680
*   GEN(LM GPR11P,GPR13P,588(GPR13P)); /* LOAD LOCKWORD, CLHT AND ENTRY
*ADRS. */                                                       01S0681
         LM GPR11P,GPR13P,588(GPR13P)
*   GEN(BALR GPR14P,GPR13P); /* BALR TO SETLOCK RTN. */         01S0682
         BALR GPR14P,GPR13P
*   GPR11P = GPR15P; /* RESTORE REG. 11. */                     01S0683
         LR    GPR11P,GPR15P                                    01S0683
*   GPR15P = GPR13P; /* SAVE RETURN CODE. */                    01S0684
         LR    GPR15P,GPR13P                                    01S0684
*   GPR12P = GPR00P; /* RESTORE REG. 12 */                      01S0685
         LR    GPR12P,GPR00P                                    01S0685
*   GPR13P = GPR01P; /* RESTORE REG. 13. */                     01S0686
         LR    GPR13P,GPR01P                                    01S0686
*   RFY(GPR15P,GPR00P,GPR01P) UNRSTD;                           01S0687
*   RFY (GPR11P,GPR12P,GPR13P,GPR14P) UNRSTD;                   01S0688
* END; /* SETLOCK (RELEASE) TYPE(LOCAL) REGS(USE) RELATED(UCB,IEFAB4A4(
*EFAB4A4,CHKMALCD,UNALUNIT)) */                                 01S0689
* DO; /*MODESET  EXTKEY(SCHED)*/                                01S0690
*   SPKA (16); /*SET PSW KEY*/                                  01S0691
         LA    @12,16                                           01S0691
         SPKA  0(@12)                                           01S0691
* END; /*MODESET  EXTKEY(SCHED)*/               /*RETURN TO SCHEDULER K
*Y     */                                                       01S0692
*IF UNALNPST = NO &          /*POST REQUESTED              */   01S0693
*   GRENTSW = YES THEN/*                                        01S0693
*                                        NEED TO POST WAITING ALOC'NS*/
         L     @12,@PC00001                                     01S0693
         TM    UNALNPST(@12),B'10000000'                        01S0693
         BNZ   @RF00693                                         01S0693
         TM    GRENTSW,B'10000000'                              01S0693
         BNO   @RF00693                                         01S0693
*  CALL IEFAB4FA(QMGRBPTR,0);          /*INVOKE ALLOCATION Q-MGR     */
         LA    @12,QMGRBPTR                                     01S0694
         ST    @12,@AL00001                                     01S0694
         LA    @12,@CF00107                                     01S0694
         ST    @12,@AL00001+4                                   01S0694
         L     @15,@CV00070                                     01S0694
         LA    @01,@AL00001                                     01S0694
         BALR  @14,@15                                          01S0694
*CMESGRMP = ZERO;                      /*ZERO ESTAE GROUP MASK  01S0695
*                                        POINTER             @Z40FPPG*/
@RF00693 SLR   @12,@12                                          01S0695
         L     @11,@PC00001+16                                  01S0695
         L     @11,CMESPAP(,@11)                                01S0695
         ST    @12,CMESGRMP(,@11)                               01S0695
*IF FEPAPTR ^= ZERO THEN               /*EPA(S) EXIST-VUT BLK READ   */
         C     @12,FEPAPTR                                      01S0696
         BE    @RF00696                                         01S0696
*  DO;                                 /*WRITE VUT BLK/FREE EPAS     */
*    IF VUTASGND = YES &               /*VUT BLK ASSIGNED AND@YM08200*/
*       VUTSVA ^= ZERO THEN            /* VUT BLK(S) EXISTED @YM08200*/
         TM    VUTASGND,B'00000100'                             01S0698
         BNO   @RF00698                                         01S0698
         L     @12,@PC00001+12                                  01S0698
         ICM   @11,7,VUTSVA(@12)                                01S0698
         BZ    @RF00698                                         01S0698
*      OLDLSTVP -> VUTNSVA = FSTVUTSV; /*CHAIN 1ST NEW BLK INTO OLD
*                                        LAST BLK            @YM08200*/
         L     @12,OLDLSTVP                                     01S0699
         MVC   VUTNSVA(3,@12),FSTVUTSV                          01S0699
*    SWACTLS = SWACTLS && SWACTLS;     /*CLEAR FCN MAP               */
@RF00698 SLR   @12,@12                                          01S0700
         ICM   @12,3,SWACTLS                                    01S0700
         LR    @11,@12                                          01S0700
         XR    @11,@12                                          01S0700
         STH   @11,SWACTLS                                      01S0700
*    SWWRT = ON;                       /*WRITE BLOCK(S)              */
*    SWFREE = ON;                      /*FREE EPAS                   */
         OI    SWWRT,B'00010100'                                01S0702
*    CALL IEFAB4F7                     /*SWA MANAGER INTERFACE RTN   */
*        (SWACTLS,FEPAPTR,LEPAPTR,DMYPARM,DMYPARM,TBLLNTH,NUMVBLKS);
         MVC   @AL00001+12(16),@AL00703                         01S0703
         LA    @12,SWACTLS                                      01S0703
         ST    @12,@AL00001                                     01S0703
         LA    @12,FEPAPTR                                      01S0703
         ST    @12,@AL00001+4                                   01S0703
         LA    @12,LEPAPTR                                      01S0703
         ST    @12,@AL00001+8                                   01S0703
         L     @15,@CV00071                                     01S0703
         LA    @01,@AL00001                                     01S0703
         BALR  @14,@15                                          01S0703
*  END;                                                         01S0704
*IF VUTASGND = YES  &                  /*VUT BLK ASSIGNED AND@YM08200*/
*   VUTSVA = ZERO THEN                 /*IF NO PRIOR VUT BLKS@YM08200*/
@RF00696 TM    VUTASGND,B'00000100'                             01S0705
         BNO   @RF00705                                         01S0705
         L     @12,@PC00001+12                                  01S0705
         ICM   @11,7,VUTSVA(@12)                                01S0705
         BNZ   @RF00705                                         01S0705
*  VUTSVA = FSTVUTSV;                  /*RETURN SVA OF 1ST   @YM08200*/
         MVC   VUTSVA(3,@12),FSTVUTSV                           01S0706
*RETURN CODE(RETCODE);                 /*RETURN TO CALLER            */
@RF00705 L     @12,RETCODE                                      01S0707
         L     @13,4(,@13)                                      01S0707
         L     @00,@SIZDATD                                     01S0707
         LR    @01,@09                                          01S0707
         FSPACE   R,LV=(0),A=(1)
         LR    @15,@12                                          01S0707
         L     @14,12(,@13)                                     01S0707
         LM    @00,@12,20(@13)                                  01S0707
         BR    @14                                              01S0707
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - CRVUTAB                                           */
*/*                                                                  */
*/* DESCRIPTIVE NAME - CREATE VOLUME UNLOAD TABLE BLOCK              */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS ROUTINE CREATES AND INITIALIZES A VOLUME UNLOAD TABLE     */
*/*   AND MAINTAINS THE CHAIN OF VUT BLOCKS AND ASSOCIATED EPAS.     */
*/*                                                                  */
*/*   OPERATION -                                                    */
*/*     THE SWA MANAGER INTERFACE ROUTINE IS INVOKED TO ASSIGN A     */
*/*     BLOCK OF SWA FOR A VUT BLOCK.  THE EPA CREATED IS            */
*/*     CHAINED TO ANY EXISTING EPA'S. IF THIS IS NOT THE    @YM08200*/
*/*     FIRST VUT BLOCK TO BE ASSIGNED ON THIS ENTRY TO THE  @YM08200*/
*/*     MODULE, IT IS CHAINED TO THE PREVIOUS BLOCK. IF IT   @YM08200*/
*/*     IS THE FIRST, ITS SVA IS SAVED, TO BE USED LATER TO  @YM08200*/
*/*     CHAIN NEWLY ASSIGNED VUT RECORD(S) INTO EITHER THE   @YM08200*/
*/*     ANCHOR VUTSVA (IF NO VUT BLOCKS EXISTED PREVIOUSLY), @YM08200*/
*/*     OR INTO THE PREVIOUSLY LAST VUT BLOCK WHOSE ADDRESS  @YM08200*/
*/*     IS ALSO SAVED. THIS CHAINING WILL BE DONE AFTER THE  @YM08200*/
*/*     RECORDS ARE WRITTEN, TO PREVENT ANY PROBLEMS IN      @YM08200*/
*/*     READING THE VUT CHAIN WHILE RECOVERING FROM ANY      @YM08200*/
*/*     ERROR. THE INDEX FOR THE NEXT AVAILABLE ENTRY, VUCTR,        */
*/*     IS SET TO ONE.                                               */
*/*                                                                  */
*/* ENTRY - CRVUTAB (INTERNAL PROC)                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*   INPUT -                                                        */
*/*     VUTPTR - PTR TO CURRENT VUT BLOCK IF ANY                     */
*/*     VUTSVA - SVA OF FIRST VUT BLOCK OR ZERO IF NONE              */
*/*     FEPAPTR - PTR TO FIRST EPA ON CHAIN                          */
*/*     LEPAPTR - PTR TO LAST EPA ON CHAIN                           */
*/*     VUTASGND - BIT SET ON IF A VUT BLK ALREADY ASSIGNED  @YM08200*/
*/*                BY THIS MODULE                            @YM08200*/
*/*                                                                  */
*/* EXIT - RETURN TO CALLER                                          */
*/*   CONDITION - VUT BLOCK CREATED                                  */
*/*     OUTPUT -                                                     */
*/*       VUTPTR - PTR TO NEW BLOCK                                  */
*/*       VUCTR - INDEX TO NEXT AVAILABLE ENTRY (=1)                 */
*/*       FEPAPTR - PTR TO THIS EPA IF FIRST                         */
*/*       LEPAPTR - PTR TO NEW LAST EPA                              */
*/*       VUNLDTAB - VUT BLOCK CLEARED TO ZEROS                      */
*/*       VUTNSVA - SVA OF NEXT (THE NEW) VUT BLOCK                  */
*/*       VUTASGND - SET ON IF BLK IS THE 1ST ASSIGNED       @YM08200*/
*/*                  DURING THIS ENTRY OF THE MODULE         @YM08200*/
*/*       FSTVUTSV - SAVED SVA IF 1ST ASSIGNED               @YM08200*/
*/*       OLDLSTVP - SAVED PTR TO PREVIOUSLY LAST VUT BLK    @YM08200*/
*/*     RETURN CODE -                                                */
*/*       RETCODE = 0                                                */
*/********************************************************************/
*CRVUTAB:                              /*GET/INIT VOL UNLOAD TABLE   */
*  PROC;                                                        02S0708
CRVUTAB  STM   @14,@12,@SA00002                                 02S0708
*LVUTPTR = VUTPTR;                     /*SAVE CURRENT PTR            */
         L     LVUTPTR,VUTPTR                                   02S0709
*SWACTLS = SWACTLS && SWACTLS;         /*CLEAR FCN MAP               */
         SLR   @12,@12                                          02S0710
         ICM   @12,3,SWACTLS                                    02S0710
         LR    @11,@12                                          02S0710
         XR    @11,@12                                          02S0710
         STH   @11,SWACTLS                                      02S0710
*SWASN = ON;                           /*FCN MAP = ASSIGN TABLE      */
*SWNEW = ON;                           /*CREATE NEW EPA              */
         OI    SWASN,B'10001000'                                02S0712
*IF LEPAPTR ^= ZERO THEN               /*EPA ALREADY GOTTEN? @Z40FPPD*/
         ICM   @12,15,LEPAPTR                                   02S0713
         BZ    @RF00713                                         02S0713
*  SWCHN = ON;                         /*CHAIN EPAS                  */
         OI    SWCHN,B'10000000'                                02S0714
*CALL IEFAB4F7                         /*SWA MGR INTERFACE RTN       */
*    (SWACTLS,FEPAPTR,LEPAPTR,ADDR(SMIDATA),ADDR(VUTPTR),TBLLNTH,
*     NUMVBLKS);                                                02S0715
@RF00713 LA    @12,SWACTLS                                      02S0715
         ST    @12,@AL00001                                     02S0715
         LA    @12,FEPAPTR                                      02S0715
         ST    @12,@AL00001+4                                   02S0715
         LA    @12,LEPAPTR                                      02S0715
         ST    @12,@AL00001+8                                   02S0715
         LA    @12,SMIDATA                                      02S0715
         ST    @12,@TF00001                                     02S0715
         LA    @12,@TF00001                                     02S0715
         ST    @12,@AL00001+12                                  02S0715
         LA    @12,VUTPTR                                       02S0715
         ST    @12,@TF00002                                     02S0715
         LA    @12,@TF00002                                     02S0715
         ST    @12,@AL00001+16                                  02S0715
         LA    @12,TBLLNTH                                      02S0715
         ST    @12,@AL00001+20                                  02S0715
         LA    @12,@CF00051                                     02S0715
         ST    @12,@AL00001+24                                  02S0715
         L     @15,@CV00071                                     02S0715
         LA    @01,@AL00001                                     02S0715
         BALR  @14,@15                                          02S0715
*IF LEPAPTR = ZERO THEN                /*FIRST EPA CREATED   @Z40FPPD*/
         ICM   @12,15,LEPAPTR                                   02S0716
         BNZ   @RF00716                                         02S0716
*  LEPAPTR = FEPAPTR;                  /*SET PTR TO LAST EPA @Z40FPPD*/
         MVC   LEPAPTR(4),FEPAPTR                               02S0717
*IF VUTASGND = NO THEN                 /*IF NO VUT BLK ASSGN'D YET
*                                        ON THIS ENTRY       @YM08200*/
@RF00716 TM    VUTASGND,B'00000100'                             02S0718
         BNZ   @RF00718                                         02S0718
*  DO;                                                          02S0719
*    FSTVUTSV = SMISVA;                /*SAVE SVA OF FIRST   @YM08200*/
         MVC   FSTVUTSV(3),SMISVA                               02S0720
*    VUTASGND = YES;                   /*SAY BLK ASSIGNED    @YM08200*/
         OI    VUTASGND,B'00000100'                             02S0721
*    IF VUTSVA ^= ZERO THEN            /*OTHR VUT BLKS EXIST?@YM08200*/
         L     @12,@PC00001+12                                  02S0722
         ICM   @11,7,VUTSVA(@12)                                02S0722
         BZ    @RF00722                                         02S0722
*      OLDLSTVP = LVUTPTR;             /*SAVE ADDR OF LAST   @YM08200*/
         ST    LVUTPTR,OLDLSTVP                                 02S0723
*  END;                                /*END OF 1ST ASSIGNED @YM08200*/
*ELSE                                  /*FIRST BLOCK NOT CREATED     */
*  LVUTPTR -> VUTNSVA = SMISVA;        /*CHAIN TO PREVIOUS BLOCK     */
         B     @RC00718                                         02S0725
@RF00718 MVC   VUTNSVA(3,LVUTPTR),SMISVA                        02S0725
*VUTCTR = ONE;                         /*SET INDEX FOR FIRST ENTRY   */
@RC00718 MVI   VUTCTR,X'01'                                     02S0726
*RETURN;                               /*RETURN TO CALLER            */
@EL00002 DS    0H                                               02S0727
@EF00002 DS    0H                                               02S0727
@ER00002 LM    @14,@12,@SA00002                                 02S0727
         BR    @14                                              02S0727
*END CRVUTAB;                                                   02S0728
*                                                               01S0729
*                                                               01S0729
* DECLARE /*GENERAL PURPOSE REGISTERS */                        01S0729
*   GPR00F FIXED(31) REG(0),                                    01S0729
*   GPR01F FIXED(31) REG(1),                                    01S0729
*   GPR00P PTR(31) REG(0),                                      01S0729
*   GPR01P PTR(31) REG(1),                                      01S0729
*   GPR11P PTR(31) REG(11),                                     01S0729
*   GPR12P PTR(31) REG(12),                                     01S0729
*   GPR13P PTR(31) REG(13),                                     01S0729
*   GPR14P PTR(31) REG(14),                                     01S0729
*   GPR15P PTR(31) REG(15);                                     01S0729
*                                                               01S0729
* DECLARE /* COMMON VARIABLES */                                01S0730
*   I256C CHAR(256) BASED,                                      01S0730
*   I031F FIXED(31) BASED,                                      01S0730
*   I031P PTR(31)   BASED,                                      01S0730
*   I015F FIXED(15) BASED,                                      01S0730
*   I015P PTR(15)   BASED,                                      01S0730
*   I008P PTR(8)    BASED,                                      01S0730
*   I001C CHAR(1)   BASED;                              /*SYSTEM MACRO
*EG DEFS       */                                               01S0730
*END IEFAB4A4                                                   01S0731
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (A4A4SPEC)                                        *
*/*%INCLUDE SYSLIB  (A4A4DATA)                                        *
*/*%INCLUDE SYSLIB  (IEFASIOT)                                        *
*/*%INCLUDE SYSLIB  (IEFTIOT1)                                        *
*/*%INCLUDE SYSLIB  (IEFUCBOB)                                        *
*/*%INCLUDE SYSLIB  (IEFZB427)                                        *
*/*%INCLUDE SYSLIB  (IEFZB431)                                        *
*/*%INCLUDE SYSLIB  (IEFZB436)                                        *
*/*%INCLUDE SYSLIB  (IEFZB438)                                        *
*/*%INCLUDE SYSLIB  (IEFZB439)                                        *
*/*%INCLUDE SYSLIB  (IEFZB441)                                        *
*/*%INCLUDE SYSLIB  (IEFZB449)                                        *
*/*%INCLUDE SYSLIB  (IHADSAB )                                        *
*/*%INCLUDE SYSLIB  (IHAPSA  )                                        *
*/*%INCLUDE SYSLIB  (IHAQDB  )                                        *
*/*%INCLUDE SYSLIB  (IHAASCB )                                        *
*/*%INCLUDE SYSLIB  (A4A4INIT)                                        *
*/*%INCLUDE SYSLIB  (A4INTSPC)                                        *
*/*%INCLUDE SYSLIB  (DOMMSG  )                                        *
*/*%INCLUDE SYSLIB  (DMSGSPEC)                                        *
*/*%INCLUDE SYSLIB  (UNALUNIT)                                        *
*/*%INCLUDE SYSLIB  (UNALUSPC)                                        *
*/*%INCLUDE SYSLIB  (VIRTUNLD)                                        *
*/*%INCLUDE SYSLIB  (VIRTSPEC)                                        *
*/*%INCLUDE SYSLIB  (CHKMALCD)                                        *
*/*%INCLUDE SYSLIB  (CMAUSPEC)                                        *
*/*%INCLUDE SYSLIB  (CRVUTAB )                                        *
*/*%INCLUDE SYSLIB  (CVUTSPEC)                                        *
*;                                                              01S0731
@DATA    DS    0H
@CH00122 DC    H'6'
         DS    0F
@AL00703 EQU   *                       LIST WITH   4 ARGUMENT(S)
@AL00341 EQU   *                       LIST WITH   2 ARGUMENT(S)
@AL00545 DC    A(@CF00107)             LIST WITH   2 ARGUMENT(S)
         DC    A(@CF00107)
         DC    A(TBLLNTH)
         DC    A(@CF00051)
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    6F
@SA00002 DS    0F
         DS    15F
@AL00001 DS    7A
@TF00001 DS    F
@TF00002 DS    F
IEFAB4A4 CSECT
         DS    0F
@CF00107 DC    F'0'
@CF00051 DC    F'1'
@CF00104 DC    F'7'
@CH00104 EQU   @CF00104+2
@DATD    DSECT
         DS    0D
CMRBPTR  DS    A
FEPAPTR  DS    A
GRPMSKP  DS    A
LEPAPTR  DS    A
OLDLSTVP DS    A
QMGRBPTR DS    A
VMVREQBP DS    A
VUTPTR   DS    A
RETCODE  DS    F
SMIDATA  DS    FL4
         ORG   SMIDATA
SMISVA   DS    FL3
SMIBLKID DS    FL1
         ORG   SMIDATA+4
TIOTPTR  DS    A
CFMAPTR  DS    A
QDBPTR   DS    A
ASCBPTR  DS    A
SWACTLS  DS    FL2
         ORG   SWACTLS
SWASN    DS    BL1
SWDEL    EQU   SWACTLS+0
SWREAD   EQU   SWACTLS+0
SWWRT    EQU   SWACTLS+0
SWNEW    EQU   SWACTLS+0
SWFREE   EQU   SWACTLS+0
SWMOD    EQU   SWACTLS+0
SWOLD    EQU   SWACTLS+0
SWCHN    DS    BL1
@NM00027 EQU   SWACTLS+1
         ORG   SWACTLS+2
         DS    CL2
FSTVUTSV DS    FL3
UNITCTR  DS    FL1
VUTCTR   DS    FL1
MSGID    DS    CL3
UNALUSWS DS    BL1
         ORG   UNALUSWS
GRENTSW  DS    BL1
VUTINSW  EQU   UNALUSWS+0
VUTENDSW EQU   UNALUSWS+0
SGRPMSW  EQU   UNALUSWS+0
UNALUNSW EQU   UNALUSWS+0
VUTASGND EQU   UNALUSWS+0
@NM00001 EQU   UNALUSWS+0
@NM00002 EQU   UNALUSWS+0
         ORG   UNALUSWS+1
         DS    CL3
QMGRRB   DS    CL28
RWNDRB   DS    CL52
GRMSKCOR DS    240BL1
IEFAB4A4 CSECT
         DS    0F
@SIZDATD DC    AL1(230)
         DC    AL3(@ENDDATD-@DATD)
@CV00069 DC    V(IEFAB49C)
@CV00070 DC    V(IEFAB4FA)
@CV00071 DC    V(IEFAB4F7)
         DS    0D
TBLLNTH  DC    AL4(176)
DEV3330  DC    X'2009'
ZEROVLSR DC    X'000000000000'
MASKTAB  DC    X'80'
         DC    X'40'
         DC    X'20'
         DC    X'10'
         DC    X'08'
         DC    X'04'
         DC    X'02'
         DC    X'01'
IEFAB4A4 CSECT
         DS   0H
A4A4PTCH DC ((@DATA-@PSTART)/20)X'00'
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEFAB4A4 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
GRMSKBYT EQU   @02
GRMSKBIT EQU   @03
DEVCTR   EQU   @03
CTR1     EQU   @02
UCBPTR   EQU   @06
TEMPDSAP EQU   @02
SIOTPTR  EQU   @08
LVUTPTR  EQU   @02
DSABPTR  EQU   @07
GPR11P   EQU   @11
GPR12P   EQU   @12
GPR13P   EQU   @13
GPR14P   EQU   @14
GPR15P   EQU   @15
GPR00P   EQU   @00
GPR01P   EQU   @01
GPR00F   EQU   @00
GPR01F   EQU   @01
REG0     EQU   @00
REG1     EQU   @01
REG15    EQU   @15
REG2     EQU   @02
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSAAOLD  EQU   PSA+548
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSALITA  EQU   PSA+764
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
GRPMSK   EQU   0
NAMES    EQU   0
JOBNM    EQU   NAMES
STPNM    EQU   NAMES+8
INDMSIOT EQU   0
SCTUSADD EQU   INDMSIOT+20
SIOTBYT1 EQU   INDMSIOT+43
SIOVAMDS EQU   SIOTBYT1
SIOTBYT3 EQU   INDMSIOT+46
SIOTTSTC EQU   INDMSIOT+47
SIOTBYT0 EQU   INDMSIOT+52
SCTSDISP EQU   INDMSIOT+55
SIOTRETN EQU   SCTSDISP
SIOTPASS EQU   SCTSDISP
SCTSBYT1 EQU   INDMSIOT+56
SCTSBYT2 EQU   INDMSIOT+57
SCTSBYT3 EQU   INDMSIOT+58
SCTSBYT4 EQU   INDMSIOT+59
SIOTSTEP EQU   SCTSBYT4
SCTUTYPE EQU   INDMSIOT+60
SIOTDEVT EQU   SCTUTYPE
SIOUBYT3 EQU   SIOTDEVT+2
SIO3TAPE EQU   SIOUBYT3
SIO3COMM EQU   SIOUBYT3
SIO3DACC EQU   SIOUBYT3
SIOTBYT4 EQU   INDMSIOT+81
SIOTALTD EQU   INDMSIOT+92
SIOTNPRV EQU   SIOTALTD
SIOTBYT2 EQU   INDMSIOT+103
SIOTETIO EQU   INDMSIOT+148
TIOT1    EQU   0
TIOENTRY EQU   0
TIOESTTA EQU   TIOENTRY+1
TIOERLOC EQU   TIOENTRY+2
TIOEWTCT EQU   TIOERLOC
TIOELINK EQU   TIOERLOC+1
TIOESYOT EQU   TIOELINK
TIOESTTC EQU   TIOENTRY+15
TIOESTTB EQU   TIOENTRY+16
POOLSTAR EQU   TIOENTRY+20
UCB      EQU   0
UCBOB    EQU   0
UCBJBNR  EQU   UCBOB
UCBJES3  EQU   UCBJBNR
UCBMMSGP EQU   UCBJBNR
UCBMONT  EQU   UCBJBNR
UCBFL5   EQU   UCBOB+1
UCBAF    EQU   UCBFL5
UCBSTAT  EQU   UCBOB+3
UCBRESV  EQU   UCBSTAT
UCBALOC  EQU   UCBSTAT
UCBPRES  EQU   UCBSTAT
UCBCHAN  EQU   UCBOB+4
UCBSFLS  EQU   UCBOB+6
UCBFLA   EQU   UCBSFLS
UCBFL1   EQU   UCBFLA
UCBBSY   EQU   UCBFL1
UCBNRY   EQU   UCBFL1
UCBPST   EQU   UCBFL1
UCBCUB   EQU   UCBFL1
UCBFLB   EQU   UCBSFLS+1
UCBCHM   EQU   UCBOB+8
UCBCHM1  EQU   UCBCHM
UCBPTH0  EQU   UCBCHM1
UCBPTH1  EQU   UCBCHM1
UCBWGT   EQU   UCBOB+12
UCBREW   EQU   UCBWGT
UCBTYP   EQU   UCBOB+16
UCBTBYT1 EQU   UCBTYP
UCB1FEA5 EQU   UCBTBYT1
UCB1FEA6 EQU   UCBTBYT1
UCBTBYT2 EQU   UCBTYP+1
UCB2OPT2 EQU   UCBTBYT2
UCBDUDN1 EQU   UCB2OPT2
UCB2OPT3 EQU   UCBTBYT2
UCBDUDN2 EQU   UCB2OPT3
UCB2OPT4 EQU   UCBTBYT2
UCBRWTAU EQU   UCB2OPT4
UCBRVDEV EQU   UCBRWTAU
UCB2OPT6 EQU   UCBTBYT2
UCB2OPT7 EQU   UCBTBYT2
UCBTBYT3 EQU   UCBTYP+2
UCBDVCLS EQU   UCBTBYT3
UCB3TAPE EQU   UCBDVCLS
UCB3DACC EQU   UCBDVCLS
UCBTBYT4 EQU   UCBTYP+3
UCBEXTPT EQU   UCBOB+20
UCBFLC   EQU   UCBEXTPT
UCBDEV   EQU   UCBOB+24
UCBCMEXT EQU   0
UCBATI   EQU   UCBCMEXT+3
@NM00021 EQU   UCBATI
UCBFLP1  EQU   UCBCMEXT+5
UCBNSRCH EQU   UCBFLP1
UCBASID  EQU   UCBCMEXT+14
UCBMT    EQU   0
UCBOCR   EQU   0
UCB3540X EQU   0
UCBDKBYT EQU   UCB3540X+6
UCB3800X EQU   0
UCBOPTNS EQU   UCB3800X
UCBACTIV EQU   UCB3800X+3
UCBMDRBF EQU   UCB3800X+36
UCBUCS   EQU   0
UCBUCSOP EQU   UCBUCS+4
UCBFCBOP EQU   UCBUCS+5
AQMPARAM EQU   0
AQMECODE EQU   AQMPARAM
AQMMASKP EQU   AQMPARAM+4
AQMASID  EQU   AQMPARAM+8
AQMNORMP EQU   AQMPARAM+20
VMVRQBLK EQU   0
VMVFNMAP EQU   VMVRQBLK
VMVOPTB1 EQU   VMVFNMAP
VMVUNLOD EQU   VMVOPTB1
VMVUCB   EQU   VMVOPTB1
VMVREWND EQU   VMVOPTB1
VMVOPTB2 EQU   VMVFNMAP+1
VMVOPTB3 EQU   VMVFNMAP+2
VMVUCBP  EQU   VMVRQBLK+9
VMVJBNMP EQU   VMVRQBLK+24
VMVJSNMP EQU   VMVRQBLK+32
VMVMINFO EQU   VMVRQBLK+40
VMVACTON EQU   VMVMINFO
VMVKEEP  EQU   VMVACTON
VMVUSER  EQU   VMVRQBLK+48
VUNLDTAB EQU   0
VUTNSVA  EQU   VUNLDTAB
VUTENTNO EQU   VUNLDTAB+3
VUTENTRY EQU   VUNLDTAB+8
VUTENFLG EQU   VUTENTRY
VUTENVIR EQU   VUTENFLG
VUTUNLOD EQU   VUTENFLG
VUTENVOL EQU   VUTENTRY+1
CMUNFMAP EQU   0
CMFMBYT1 EQU   CMUNFMAP
CMFMBYT2 EQU   CMUNFMAP+1
CMFMBYT3 EQU   CMUNFMAP+2
CMFMBYT4 EQU   CMUNFMAP+3
CMUNRB   EQU   0
CMNRBPTR EQU   CMUNRB
CMSIOPTR EQU   CMUNRB+4
CMINDIC  EQU   CMUNRB+8
CMRBBYT1 EQU   CMINDIC
CMNMDISP EQU   CMRBBYT1
CMRBBYT2 EQU   CMINDIC+1
CMCHKUN  EQU   CMRBBYT2
CMSETPRV EQU   CMRBBYT2
CMRBBYT3 EQU   CMINDIC+2
CMRBBYT4 EQU   CMINDIC+3
CMODISP  EQU   CMUNRB+12
CMOPTFLD EQU   CMUNRB+16
CMESPA   EQU   0
CMESPARM EQU   CMESPA+756
CMESRBNP EQU   CMESPARM+12
CMESGRMP EQU   CMESPARM+20
CMESFLAG EQU   CMESPARM+24
CMESLP1  EQU   CMESFLAG
DSAB     EQU   0
DSABFCHN EQU   DSAB+4
DSABTIOT EQU   DSAB+16
DSABGIDP EQU   DSAB+24
DSABANMP EQU   DSAB+28
DSABORG  EQU   DSAB+32
DSABORG1 EQU   DSABORG
DSABORG2 EQU   DSABORG+1
DSABFLG1 EQU   DSAB+34
DSABFLG2 EQU   DSAB+35
DSABFLG3 EQU   DSAB+36
DSABFLG4 EQU   DSAB+37
DSABANMI EQU   0
DSABGIDL EQU   0
DSABGRID EQU   DSABGIDL+4
QDB      EQU   0
QDBFELMP EQU   QDB+12
ASCB     EQU   0
ASCBASID EQU   ASCB+36
ASCBFW1  EQU   ASCB+100
ASCBRCTF EQU   ASCBFW1+2
ASCBFLG1 EQU   ASCBFW1+3
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
I001C    EQU   0
I008P    EQU   0
I015F    EQU   0
I015P    EQU   0
I031F    EQU   0
I031P    EQU   0
I256C    EQU   0
UCBBGN   EQU   0
UNALUFMP EQU   0
UNALNPST EQU   UNALUFMP
UNALNVUT EQU   UNALUFMP
UNALCHAT EQU   UNALUFMP
UNAL2LP  EQU   UNALUFMP
FRBPTR   EQU   0
DSABQDBP EQU   0
VUTSVA   EQU   0
CMESPAP  EQU   0
NAMESPTR EQU   0
TIOEDEVE EQU   TIOESTTB
TIOSTTB  EQU   TIOEDEVE
TIOUCBP  EQU   TIOEDEVE+1
UCBOBS01 EQU   UCBDEV
UCBVOLI  EQU   UCBOBS01+4
UCBSTAB  EQU   UCBOBS01+10
UCBBSVL  EQU   UCBSTAB
UCBPRSRS EQU   UCBSTAB
UCBBPRV  EQU   UCBSTAB
UCBBPUB  EQU   UCBSTAB
UCBBSTR  EQU   UCBSTAB
UCBSHAR  EQU   UCBSTAB
UCBBNUL  EQU   UCBSTAB
UCBDMCT  EQU   UCBOBS01+11
UCBMOUNT EQU   UCBDMCT
UCBDMC   EQU   UCBDMCT
UCBFL4   EQU   UCBOBS01+13
UCBUSER  EQU   UCBOBS01+14
UCBOBS02 EQU   UCBDEV
UCBFSER  EQU   UCBOBS02+12
UCBTFL1  EQU   UCBOBS02+19
UCBXTN   EQU   UCBOBS02+20
UCBVOPT  EQU   UCBXTN
UCBOBS03 EQU   UCBDEV
UCBXTADR EQU   UCBOBS03
UCBOBS04 EQU   UCBDEV
UCBBTA   EQU   UCBOBS04+12
UCBOBS06 EQU   UCBDEV
UCBAOF   EQU   UCBOBS06
UCBAOF1  EQU   UCBAOF
UCBAOF2  EQU   UCBAOF+1
@NM00020 EQU   UCBOBS06+3
UCBIRB   EQU   UCBOBS06+4
UCBGRAF  EQU   UCBIRB
UCBLDNCA EQU   UCBOBS06+8
UCBRDYQ  EQU   UCBLDNCA
UCBIRLN  EQU   UCBRDYQ
UCBLDNCB EQU   UCBRDYQ+1
UCBCTLNK EQU   UCBOBS06+12
UCBOBS07 EQU   UCBDEV
UCBOBS08 EQU   UCBDEV
UCBCTCAD EQU   UCBOBS08
UCBCTCF1 EQU   UCBOBS08+4
UCBOBS09 EQU   UCBDEV
TUNALFLG EQU   TIOESTTB
TIOPUBPV EQU   TUNALFLG
TIONOPV  EQU   TUNALFLG
TIORWND  EQU   TUNALFLG
TIOUNAL  EQU   TUNALFLG
PSARSVTE EQU   PSARSVT
CMUIDPTR EQU   CMOPTFLD
FLC      EQU   PSA
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
@NM00049 EQU   TUNALFLG+1
TIONSRCH EQU   TUNALFLG
@NM00048 EQU   TUNALFLG
@NM00047 EQU   TUNALFLG
@NM00046 EQU   TUNALFLG
UCBRV066 EQU   UCBOBS09+4
UCBIOSBA EQU   UCBOBS09
UCBRV042 EQU   UCBOBS08+5
UCBRV082 EQU   UCBCTCF1
UCBRV081 EQU   UCBCTCF1
UCBRV080 EQU   UCBCTCF1
UCBRV079 EQU   UCBCTCF1
UCBRV078 EQU   UCBCTCF1
UCBRV077 EQU   UCBCTCF1
UCBRV076 EQU   UCBCTCF1
UCBCTC80 EQU   UCBCTCF1
UCBCTCAL EQU   UCBCTCAD
UCBICNCB EQU   UCBOBS07+4
UCBRV040 EQU   UCBOBS07
UCBCTLNA EQU   UCBCTLNK+1
UCBRLN   EQU   UCBCTLNK
UCBRDYQA EQU   UCBLDNCB
UCBINRLN EQU   UCBIRLN
UCBIRBA  EQU   UCBIRB+1
UCBRV039 EQU   UCBGRAF
UCBDWNR  EQU   UCBGRAF
UCBRPND  EQU   UCBGRAF
UCBUPM   EQU   UCBGRAF
UCBBTAM  EQU   UCBGRAF
UCBDRNO  EQU   UCBGRAF
UCBDRO   EQU   UCBGRAF
UCBOIP   EQU   UCBGRAF
UCBATRCD EQU   @NM00020
UCBSKPFG EQU   @NM00020
UCBRIPND EQU   @NM00020
UCBRTIAC EQU   @NM00020
UCBRSV79 EQU   @NM00020
UCBRSV78 EQU   @NM00020
UCBRSV77 EQU   @NM00020
UCBOLTEP EQU   @NM00020
UCBATNCT EQU   UCBOBS06+2
UCBRSV76 EQU   UCBAOF2
UCBRSV75 EQU   UCBAOF2
UCBRSV74 EQU   UCBAOF2
UCBRSV73 EQU   UCBAOF2
UCBRSV72 EQU   UCBAOF2
UCBRSV71 EQU   UCBAOF2
UCBRSV70 EQU   UCBAOF2
UCBRSV69 EQU   UCBAOF2
UCBRSV68 EQU   UCBAOF1
UCBRSV67 EQU   UCBAOF1
UCBRSV66 EQU   UCBAOF1
UCBRSV65 EQU   UCBAOF1
UCBRSV64 EQU   UCBAOF1
UCBOFNL  EQU   UCBAOF1
UCBOFSP  EQU   UCBAOF1
UCBOFMCR EQU   UCBAOF1
UCBBTB   EQU   UCBBTA+1
UCBDI    EQU   UCBBTA
UCBSNS   EQU   UCBOBS04+8
UCBTEB   EQU   UCBOBS04+4
UCBGCB   EQU   UCBOBS04+3
UCBOPEN  EQU   UCBOBS04+2
UCBSTART EQU   UCBOBS04
UCBXTNB  EQU   UCBXTN+1
UCBRSV22 EQU   UCBVOPT
UCBRSV21 EQU   UCBVOPT
UCBRSV20 EQU   UCBVOPT
UCBESVE  EQU   UCBVOPT
UCBERPC  EQU   UCBVOPT
UCBESVC  EQU   UCBVOPT
UCBEVA   EQU   UCBVOPT
UCBESV   EQU   UCBVOPT
UCBRV009 EQU   UCBTFL1
UCBRV008 EQU   UCBTFL1
UCBRV007 EQU   UCBTFL1
UCBRV006 EQU   UCBTFL1
UCBRV005 EQU   UCBTFL1
UCBDQDSP EQU   UCBTFL1
UCBNSLTP EQU   UCBTFL1
UCBNLTP  EQU   UCBTFL1
UCBRES1B EQU   UCBOBS02+18
@NM00019 EQU   UCBOBS02+4
UCBFSEQ  EQU   UCBOBS02+2
UCBFSCT  EQU   UCBOBS02
UCBNEXP  EQU   UCBOBS01+20
UCBBASE  EQU   UCBOBS01+16
UCBRES1A EQU   UCBOBS01+15
UCBFL47  EQU   UCBFL4
UCBFL46  EQU   UCBFL4
UCBFL45  EQU   UCBFL4
UCBRV065 EQU   UCBFL4
UCBDSS   EQU   UCBFL4
UCBRESVP EQU   UCBFL4
UCBWDAV  EQU   UCBFL4
UCBDAVV  EQU   UCBFL4
UCBSQC   EQU   UCBOBS01+12
UCBDATP  EQU   UCBOBS01+12
UCBBALB  EQU   UCBPRSRS
UCBPGFL  EQU   UCBSTAB
UCBDVSHR EQU   UCBBSVL
UCBVTOC  EQU   UCBOBS01
TIOVERF  EQU   TIOSTTB
TIOUNLD  EQU   TIOSTTB
TIOMNTD  EQU   TIOSTTB
TIOSETU  EQU   TIOSTTB
TIOVLSR  EQU   TIOSTTB
TIOPVIO  EQU   TIOSTTB
TIOREQD  EQU   TIOSTTB
TIOUSED  EQU   TIOSTTB
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBLGCB EQU   ASCB+180
ASCBJBNS EQU   ASCB+176
ASCBJBNI EQU   ASCB+172
ASCBMCC  EQU   ASCB+168
ASCBRTWA EQU   ASCB+164
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUXB EQU   ASCB+148
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBQECB EQU   ASCB+136
ASCBCMSB EQU   ASCB+132
ASCBCMSF EQU   ASCB+128
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSRBS EQU   ASCB+118
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBS2S  EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBASXB EQU   ASCB+108
ASCBTMCH EQU   ASCB+104
ASCBNSWP EQU   ASCBFLG1
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBABNT EQU   ASCBFLG1
ASCBTERM EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBWAIT EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBAFFN EQU   ASCBFW1
ASCBDUMP EQU   ASCB+96
ASCBQSVC EQU   ASCB+92
ASCBUBET EQU   ASCB+88
ASCBECB  EQU   ASCB+84
ASCBJSTL EQU   ASCB+80
ASCBEWST EQU   ASCB+72
ASCBEJST EQU   ASCB+64
ASCBTSB  EQU   ASCB+60
ASCBCSCB EQU   ASCB+56
ASCBRSM  EQU   ASCB+52
ASCBLDA  EQU   ASCB+48
ASCBSTOR EQU   ASCB+44
ASCBDP   EQU   ASCB+43
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBCPUS EQU   ASCB+32
ASCBSPL  EQU   ASCB+28
ASCBLSLQ EQU   ASCB+24
ASCBFSLQ EQU   ASCB+20
ASCBIOSP EQU   ASCB+16
ASCBLOCK EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBFWDP EQU   ASCB+4
ASCBASCB EQU   ASCB
ASCBEGIN EQU   ASCB
QDBRV002 EQU   QDB+28
QDBPRDS  EQU   QDB+26
QDBPRSZ  EQU   QDB+24
QDBBPTDS EQU   QDB+22
QDBFPTDS EQU   QDB+20
QDBLELMP EQU   QDB+16
QDBNELMS EQU   QDB+8
QDBRV001 EQU   QDB+6
QDBATTR  EQU   QDB+4
QDBQDB   EQU   QDB
DSABLLEN EQU   DSABGIDL
DSABANAM EQU   DSABANMI+1
DSABANML EQU   DSABANMI
DSABRS04 EQU   DSAB+68
DSABSIOT EQU   DSAB+64
DSABRS03 EQU   DSAB+62
DSABDCBM EQU   DSAB+56
DSABSSCM EQU   DSAB+52
DSABSSNM EQU   DSAB+48
DSABPTTR EQU   DSAB+44
DSABTCBP EQU   DSAB+40
DSABRS02 EQU   DSAB+38
@NM00054 EQU   DSABFLG4
DSABCKSI EQU   DSABFLG4
DSABCKVL EQU   DSABFLG4
DSABCKDS EQU   DSABFLG4
@NM00053 EQU   DSABFLG3
DSABJSCT EQU   DSABFLG3
DSABCATL EQU   DSABFLG3
DSABVMSC EQU   DSABFLG3
DSABVAM  EQU   DSABFLG3
DSABPASS EQU   DSABFLG3
DSABDEFR EQU   DSABFLG3
@NM00052 EQU   DSABFLG2
DSABUNAL EQU   DSABFLG2
DSABIRM  EQU   DSABFLG2
DSABOPEN EQU   DSABFLG2
DSABNUSE EQU   DSABFLG1
DSABCATM EQU   DSABFLG1
DSABPCAT EQU   DSABFLG1
DSABDCAT EQU   DSABFLG1
DSABCONV EQU   DSABFLG1
DSABDCNV EQU   DSABFLG1
DSABPALC EQU   DSABFLG1
DSABDALC EQU   DSABFLG1
@NM00051 EQU   DSABORG2
DSABTR   EQU   DSABORG2
DSABAM   EQU   DSABORG2
@NM00050 EQU   DSABORG2
DSABTQ   EQU   DSABORG2
DSABTX   EQU   DSABORG2
DSABGS   EQU   DSABORG2
DSABU    EQU   DSABORG1
DSABPO   EQU   DSABORG1
DSABMQ   EQU   DSABORG1
DSABCQ   EQU   DSABORG1
DSABCX   EQU   DSABORG1
DSABDA   EQU   DSABORG1
DSABPS   EQU   DSABORG1
DSABIS   EQU   DSABORG1
DSABSSVA EQU   DSAB+21
DSABRS01 EQU   DSAB+20
DSABOPCT EQU   DSAB+14
DSABLNTH EQU   DSAB+12
DSABBCHN EQU   DSAB+8
DSABID   EQU   DSAB
CMESNAMS EQU   CMESPARM+36
CMESVUTP EQU   CMESPARM+33
CMESSNUM EQU   CMESPARM+32
CMESDSEN EQU   CMESPARM+29
@NM00045 EQU   CMESFLAG+1
CMESVREL EQU   CMESFLAG
CMESRCUR EQU   CMESFLAG
CMESUNAL EQU   CMESFLAG
CMESVOLB EQU   CMESFLAG
CMESDREL EQU   CMESFLAG
CMESCATL EQU   CMESFLAG
CMESDISP EQU   CMESFLAG
CMESSIOP EQU   CMESPARM+16
CMESRB1P EQU   CMESPARM+8
CMESJSCB EQU   CMESPARM+4
CMESFMAP EQU   CMESPARM
CMESAUTO EQU   CMESPA
CMRETCDE EQU   CMUNRB+14
CMOSYOUT EQU   CMUNRB+13
CMOUNCAT EQU   CMODISP
CMOCATLG EQU   CMODISP
CMODEL   EQU   CMODISP
CMOKEEP  EQU   CMODISP
@NM00044 EQU   CMODISP
@NM00043 EQU   CMRBBYT4
@NM00042 EQU   CMRBBYT4
CMNODEN  EQU   CMRBBYT4
CMSSERR  EQU   CMRBBYT4
CMINTERR EQU   CMRBBYT4
CMSSIERR EQU   CMRBBYT4
CMCATERR EQU   CMRBBYT4
CMSCRERR EQU   CMRBBYT4
@NM00041 EQU   CMRBBYT3
CMSSKEEP EQU   CMRBBYT3
CMNOHOLD EQU   CMRBBYT3
CMOVSYOT EQU   CMRBBYT3
CMWAIT   EQU   CMRBBYT3
CMDYNUNA EQU   CMRBBYT3
CMHOLD   EQU   CMRBBYT3
CMDEL    EQU   CMRBBYT3
@NM00040 EQU   CMRBBYT2
@NM00039 EQU   CMRBBYT2
@NM00038 EQU   CMRBBYT2
CMCKDAVL EQU   CMRBBYT2
CMCKAVOL EQU   CMRBBYT2
CMNODSR  EQU   CMRBBYT2
@NM00037 EQU   CMRBBYT1
CMINVUCB EQU   CMRBBYT1
CMOUSRID EQU   CMRBBYT1
CMORDISP EQU   CMRBBYT1
CMCNDISP EQU   CMRBBYT1
CMNODISP EQU   CMRBBYT1
@NM00036 EQU   CMFMBYT4
@NM00035 EQU   CMFMBYT4
@NM00034 EQU   CMFMBYT4
@NM00033 EQU   CMFMBYT4
@NM00032 EQU   CMFMBYT4
@NM00031 EQU   CMFMBYT4
CMALSTCT EQU   CMFMBYT4
CMLSTCJS EQU   CMFMBYT4
CMJES3   EQU   CMFMBYT3
@NM00030 EQU   CMFMBYT3
@NM00029 EQU   CMFMBYT3
CMSPSCR  EQU   CMFMBYT3
CMPUBPRV EQU   CMFMBYT3
CMSCRVL1 EQU   CMFMBYT3
CMNOSMF  EQU   CMFMBYT3
CMDSRALL EQU   CMFMBYT3
CMTIOTNQ EQU   CMFMBYT2
CMPURGE  EQU   CMFMBYT2
CMNERMSG EQU   CMFMBYT2
CMRDDENT EQU   CMFMBYT2
CMGENDEQ EQU   CMFMBYT2
CMCHATTR EQU   CMFMBYT2
CMNOVUT  EQU   CMFMBYT2
CMNOPOST EQU   CMFMBYT2
CMFDSABS EQU   CMFMBYT1
CMVLRLSE EQU   CMFMBYT1
CMUNUNIT EQU   CMFMBYT1
CMDSRLSE EQU   CMFMBYT1
CMDPCATS EQU   CMFMBYT1
CMDISPRC EQU   CMFMBYT1
CMMNSTAT EQU   CMFMBYT1
CMDMSGS  EQU   CMFMBYT1
@NM00028 EQU   VUTENFLG
VUTNPTR  EQU   VUNLDTAB+4
@NM00026 EQU   VMVUSER
VMVPROCD EQU   VMVUSER
VMVVUNTP EQU   VMVRQBLK+44
@NM00025 EQU   VMVMINFO+1
@NM00024 EQU   VMVACTON
VMVRTAIN EQU   VMVACTON
VMVDSMT  EQU   VMVACTON
VMVRETCD EQU   VMVRQBLK+36
VMVDSNMP EQU   VMVRQBLK+28
VMVMVLSR EQU   VMVRQBLK+18
VMVUVLSR EQU   VMVRQBLK+12
@NM00023 EQU   VMVRQBLK+8
VMVNREQP EQU   VMVRQBLK+4
VMVOPTB4 EQU   VMVFNMAP+3
@NM00022 EQU   VMVOPTB3
VMVNUMSG EQU   VMVOPTB3
VMVCUVOL EQU   VMVOPTB3
VMVDUPVL EQU   VMVOPTB3
VMVNSPVT EQU   VMVOPTB2
VMVNSLTP EQU   VMVOPTB2
VMVSLTAP EQU   VMVOPTB2
VMVNLTAP EQU   VMVOPTB2
VMVALTAP EQU   VMVOPTB2
VMVSTRG  EQU   VMVOPTB2
VMVPUBLC EQU   VMVOPTB2
VMVPRIVT EQU   VMVOPTB2
VMVVDEND EQU   VMVOPTB1
VMVVRLBL EQU   VMVOPTB1
VMVDWTOR EQU   VMVOPTB1
VMVMTMSG EQU   VMVOPTB1
VMVMOUNT EQU   VMVOPTB1
AQMQBPTR EQU   AQMPARAM+24
AQMPFLG  EQU   AQMNORMP
AQMCANCP EQU   AQMPARAM+16
AQMLENGT EQU   AQMPARAM+12
AQMQCODE EQU   AQMPARAM+2
UCBERADR EQU   UCBUCS+12
UCBFCBID EQU   UCBUCS+8
UCBERCNT EQU   UCBUCS+7
UCBRSV51 EQU   UCBUCS+6
UCBFCBPE EQU   UCBFCBOP
UCBRSV49 EQU   UCBFCBOP
UCBRSV48 EQU   UCBFCBOP
UCBRSV47 EQU   UCBFCBOP
UCBRSV46 EQU   UCBFCBOP
UCBRSV45 EQU   UCBFCBOP
UCBRSV44 EQU   UCBFCBOP
UCBFCBO1 EQU   UCBFCBOP
UCBUCSPE EQU   UCBUCSOP
UCBRSV43 EQU   UCBUCSOP
UCBRSV42 EQU   UCBUCSOP
UCBRSV41 EQU   UCBUCSOP
UCBRSV40 EQU   UCBUCSOP
UCBRSV39 EQU   UCBUCSOP
UCBUCSO2 EQU   UCBUCSOP
UCBUCSO1 EQU   UCBUCSOP
UCBUCSID EQU   UCBUCS
UCBMDRBA EQU   UCBMDRBF+1
UCBRV075 EQU   UCBMDRBF
UCBRV074 EQU   UCB3800X+32
UCBIMAGE EQU   UCB3800X+28
UCBFCBNM EQU   UCB3800X+24
UCBCHAR4 EQU   UCB3800X+20
UCBCHAR3 EQU   UCB3800X+16
UCBCHAR2 EQU   UCB3800X+12
UCBCHAR1 EQU   UCB3800X+8
UCBCGMID EQU   UCB3800X+4
UCBBRSTA EQU   UCBACTIV
UCBRV063 EQU   UCBACTIV
UCBRV062 EQU   UCBACTIV
UCBRV061 EQU   UCBACTIV
UCBRV060 EQU   UCBACTIV
UCBRV059 EQU   UCBACTIV
UCBRV058 EQU   UCBACTIV
UCBRV057 EQU   UCBACTIV
UCBRV050 EQU   UCB3800X+2
UCBCGMNO EQU   UCB3800X+1
UCBRV083 EQU   UCBOPTNS
UCBBRSTR EQU   UCBOPTNS
UCBRV056 EQU   UCBOPTNS
UCBRV055 EQU   UCBOPTNS
UCBRV054 EQU   UCBOPTNS
UCBRV053 EQU   UCBOPTNS
UCBRV052 EQU   UCBOPTNS
UCBRV051 EQU   UCBOPTNS
UCBRV073 EQU   UCB3540X+7
UCBRV072 EQU   UCBDKBYT
UCBRV071 EQU   UCBDKBYT
UCBRV070 EQU   UCBDKBYT
UCBRV069 EQU   UCBDKBYT
UCBRV068 EQU   UCBDKBYT
UCBRV067 EQU   UCBDKBYT
UCBVLVER EQU   UCBDKBYT
UCBDKAMX EQU   UCBDKBYT
UCBVLSER EQU   UCB3540X
UCBRDATA EQU   UCBOCR+4
UCBFRID  EQU   UCBOCR
UCBCLN   EQU   UCBMT+14
UCBERG   EQU   UCBMT+12
UCBMS    EQU   UCBMT+11
UCBNB    EQU   UCBMT+10
UCBPW    EQU   UCBMT+9
UCBPR    EQU   UCBMT+8
UCBSIO   EQU   UCBMT+6
UCBTW    EQU   UCBMT+5
UCBTR    EQU   UCBMT+4
UCBTWT   EQU   UCBMT+3
UCBTRT   EQU   UCBMT+2
UCBCTD   EQU   UCBMT
UCBWTOID EQU   UCBCMEXT+17
UCBRV043 EQU   UCBCMEXT+16
UCBMFCNT EQU   UCBCMEXT+12
UCBPMSK  EQU   UCBCMEXT+10
UCBCCWOF EQU   UCBCMEXT+8
UCBRV041 EQU   UCBCMEXT+6
UCBRV036 EQU   UCBFLP1
UCBRV035 EQU   UCBFLP1
UCBERLOG EQU   UCBFLP1
UCBRV033 EQU   UCBFLP1
UCBINHIO EQU   UCBFLP1
UCBNSWAP EQU   UCBFLP1
UCBSHRUP EQU   UCBFLP1
UCBSNSCT EQU   UCBCMEXT+4
UCBHPDV  EQU   @NM00021
UCBHALI  EQU   @NM00021
UCBRSV09 EQU   @NM00021
UCBRSV08 EQU   @NM00021
UCBRSV07 EQU   @NM00021
UCBRSV06 EQU   @NM00021
UCBRSV05 EQU   @NM00021
UCBRSV04 EQU   @NM00021
UCBDTI   EQU   UCBCMEXT+2
UCBSTI   EQU   UCBCMEXT+1
UCBETI   EQU   UCBCMEXT
UCBEXTP  EQU   UCBEXTPT+1
UCBDDRSW EQU   UCBFLC
UCBTICBT EQU   UCBFLC
UCBIVRR  EQU   UCBFLC
UCBIVRS  EQU   UCBFLC
UCBITF   EQU   UCBFLC
UCBUDE   EQU   UCBFLC
UCBWAA   EQU   UCBFLC
UCBATTP  EQU   UCBFLC
UCBUNTYP EQU   UCBTBYT4
UCBRSV11 EQU   UCBDVCLS
UCBRSV10 EQU   UCBDVCLS
UCB3CHAR EQU   UCBDVCLS
UCB3UREC EQU   UCBDVCLS
UCB3DISP EQU   UCBDVCLS
UCB3COMM EQU   UCBDVCLS
UCBDVPWR EQU   UCB2OPT7
UCBVLPWR EQU   UCB2OPT6
UCB2OPT5 EQU   UCBTBYT2
UCBRPS   EQU   UCBDUDN2
UCBRR    EQU   UCBDUDN1
UCB2OPT1 EQU   UCBTBYT2
UCB2OPT0 EQU   UCBTBYT2
UCB1FEA7 EQU   UCBTBYT1
UCBD6250 EQU   UCB1FEA6
UCBD1600 EQU   UCB1FEA5
UCB1FEA4 EQU   UCBTBYT1
UCB1FEA3 EQU   UCBTBYT1
UCB1FEA2 EQU   UCBTBYT1
UCB1FEA1 EQU   UCBTBYT1
UCB1FEA0 EQU   UCBTBYT1
UCBNAME  EQU   UCBOB+13
UCBRV029 EQU   UCBWGT
UCBVHRSN EQU   UCBWGT
UCBVORSN EQU   UCBWGT
UCBMTPXP EQU   UCBWGT
UCBPUB   EQU   UCBWGT
UCBOUT   EQU   UCBWGT
UCBIN    EQU   UCBWGT
UCBCPU   EQU   UCBOB+11
UCBLCI   EQU   UCBOB+10
UCBCNT   EQU   UCBOB+9
UCBRV017 EQU   UCBCHM1
UCBRV016 EQU   UCBCHM1
UCBRV015 EQU   UCBCHM1
UCBRV014 EQU   UCBCHM1
UCBSPB   EQU   UCBPTH1
UCBPPB   EQU   UCBPTH1
UCBSPA   EQU   UCBPTH0
UCBPPA   EQU   UCBPTH0
UCBSIGP  EQU   UCBFLB
UCBVALPH EQU   UCBFLB
UCBCRHSN EQU   UCBFLB
UCBCRHRV EQU   UCBFLB
UCBRESVH EQU   UCBFLB
UCBSPST  EQU   UCBFLB
UCBASNS  EQU   UCBFLB
UCBIORST EQU   UCBFLB
UCBQISCE EQU   UCBFL1
UCBACTV  EQU   UCBFL1
UCBSAP   EQU   UCBFL1
UCBNOTRC EQU   UCBCUB
UCBPSNS  EQU   UCBFL1
UCBUSING EQU   UCBPST
UCBNOTRD EQU   UCBNRY
UCBBUSYD EQU   UCBBSY
UCBUA    EQU   UCBCHAN+1
UCBCHA   EQU   UCBCHAN
UCBDADI  EQU   UCBSTAT
UCBSYSR  EQU   UCBSTAT
UCBUNLD  EQU   UCBSTAT
UCBCHGS  EQU   UCBSTAT
UCBONLI  EQU   UCBSTAT
UCBID    EQU   UCBOB+2
UCBALTPH EQU   UCBFL5
UCBALTCU EQU   UCBFL5
UCBNALOC EQU   UCBFL5
UCBENVRD EQU   UCBFL5
UCBVSDR  EQU   UCBFL5
UCBSASK  EQU   UCBFL5
UCBAMV   EQU   UCBAF
UCBDCC   EQU   UCBFL5
UCBRV011 EQU   UCBJBNR
UCBOLDSM EQU   UCBJBNR
UCBRV003 EQU   UCBJBNR
UCBDUC   EQU   UCBJBNR
UCBVRDEV EQU   UCBJBNR
UCBCMSEG EQU   UCBOB
UCBPFXND EQU   UCB+512
UCBIOQ   EQU   UCB+508
UCBLOCK  EQU   UCB+504
UCBPXST  EQU   UCB+504
@NM00018 EQU   UCB
TIOTFEND EQU   POOLSTAR+16
TIOPSLOT EQU   POOLSTAR+13
TIOPSTTB EQU   POOLSTAR+12
TIOPPOOL EQU   POOLSTAR+4
TIOPNSRT EQU   POOLSTAR+3
@NM00017 EQU   POOLSTAR+2
TIOPNSLT EQU   POOLSTAR+1
@NM00016 EQU   POOLSTAR
TIOEFSRT EQU   TIOENTRY+17
TIOSVERF EQU   TIOESTTB
TIOSUNLD EQU   TIOESTTB
TIOSMNTD EQU   TIOESTTB
TIOSSETU EQU   TIOESTTB
TIOSVLSR EQU   TIOESTTB
TIOSPVIO EQU   TIOESTTB
TIOSREQD EQU   TIOESTTB
TIOSUSED EQU   TIOESTTB
TIOSBALS EQU   TIOESTTC
TIOSBALP EQU   TIOESTTC
TIOSVOLS EQU   TIOESTTC
TIOSVOLP EQU   TIOESTTC
TIOSAFFS EQU   TIOESTTC
TIOSAFFP EQU   TIOESTTC
TIOSDEFR EQU   TIOESTTC
TIOSDKCR EQU   TIOESTTC
TIOEJFCB EQU   TIOENTRY+12
TIOEDDNM EQU   TIOENTRY+4
TIOTREM  EQU   TIOELINK
TIOESSDS EQU   TIOESYOT
TIOESYIN EQU   TIOELINK
TIOEQNAM EQU   TIOELINK
TIOEDYNM EQU   TIOELINK
TIOTTERM EQU   TIOELINK
TIOTRV01 EQU   TIOELINK
TIOSYOUT EQU   TIOELINK
TIOSDSP2 EQU   TIOESTTA
TIOSDSP1 EQU   TIOESTTA
TIOSLABL EQU   TIOESTTA
TIOSDADS EQU   TIOESTTA
TIOSJBLB EQU   TIOESTTA
TIOSPLTS EQU   TIOESTTA
TIOSPLTP EQU   TIOESTTA
TIOSLTYP EQU   TIOESTTA
TIOELNGH EQU   TIOENTRY
TIOCSTEP EQU   TIOT1+8
TIOCNJOB EQU   TIOT1
SIODDSNL EQU   INDMSIOT+173
SIOVDSNL EQU   INDMSIOT+172
SIOVDSNT EQU   INDMSIOT+170
SVOLUNNO EQU   INDMSIOT+168
SIOTVMVP EQU   INDMSIOT+164
SIOTJFX  EQU   INDMSIOT+160
SJFCBPTR EQU   INDMSIOT+156
SIOTNPTR EQU   INDMSIOT+152
SIOTATE  EQU   INDMSIOT+144
SVOLUNAD EQU   INDMSIOT+140
SIOTEDLP EQU   INDMSIOT+136
SIOTEDLS EQU   INDMSIOT+132
SIOTRSNC EQU   INDMSIOT+130
SCTANAME EQU   INDMSIOT+122
SIOTSSIC EQU   INDMSIOT+120
@NM00015 EQU   INDMSIOT+108
SIOTSSNM EQU   INDMSIOT+104
@NM00014 EQU   SIOTBYT2
SIOTCVOL EQU   SIOTBYT2
SIOTCNEW EQU   SIOTBYT2
SIOTCALC EQU   SIOTBYT2
SIOTGALL EQU   SIOTBYT2
SIOTDSPD EQU   SIOTBYT2
SIOTDMND EQU   SIOTBYT2
SIOTOPUC EQU   INDMSIOT+99
SIOTOUTR EQU   INDMSIOT+97
SIOTOUTC EQU   INDMSIOT+96
SIOTSSWA EQU   INDMSIOT+93
SIOTAUNC EQU   SIOTALTD
SIOTACAT EQU   SIOTALTD
SIOTADEL EQU   SIOTALTD
SIOTAKEP EQU   SIOTALTD
SIOJCATS EQU   SIOTALTD
@NM00013 EQU   SIOTALTD
@NM00012 EQU   SIOTALTD
@NM00011 EQU   INDMSIOT+91
SIOTNDSB EQU   INDMSIOT+88
@NM00010 EQU   INDMSIOT+84
SIOTDPCD EQU   INDMSIOT+82
@NM00009 EQU   SIOTBYT4
SIOTRACT EQU   SIOTBYT4
SIOTRACD EQU   SIOTBYT4
SIOTPROT EQU   SIOTBYT4
SCTOUTPN EQU   INDMSIOT+80
SCTOUTNO EQU   INDMSIOT+76
SCTOUTNM EQU   INDMSIOT+68
SIOUCBAD EQU   SCTUTYPE+5
SIOUCNVT EQU   SCTUTYPE+4
SIOUBYT4 EQU   SIOTDEVT+3
@NM00008 EQU   SIOUBYT3
SIO3UREC EQU   SIOUBYT3
SIO3DISP EQU   SIOUBYT3
SIOUBYT2 EQU   SIOTDEVT+1
SIOUBYT1 EQU   SIOTDEVT
SIOTOMN  EQU   SCTSBYT4
SIOTIPDI EQU   SCTSBYT4
SIOTVAFF EQU   SCTSBYT4
SIOTASCI EQU   SCTSBYT4
@NM00007 EQU   SCTSBYT4
SIOTGDGA EQU   SCTSBYT4
SCTSGDGS EQU   SCTSBYT4
SCTSOLD  EQU   SCTSBYT3
SCTSMOD  EQU   SCTSBYT3
SCTSNEW  EQU   SCTSBYT3
SCTSYSOU EQU   SCTSBYT3
SCTVREF  EQU   SCTSBYT3
SCTALCHK EQU   SCTSBYT3
SCTSYSNE EQU   SCTSBYT3
SCTDSNRF EQU   SCTSBYT3
SCTRECVD EQU   SCTSBYT2
SCTDEFER EQU   SCTSBYT2
SCTLABEL EQU   SCTSBYT2
SCTUNLBD EQU   SCTSBYT2
SCTJOBLB EQU   SCTSBYT2
SCTVOLAF EQU   SCTSBYT2
SIOTCATL EQU   SCTSBYT2
SIOCLUNL EQU   SCTSBYT2
SIOTJSCT EQU   SCTSBYT1
SCTUNAFF EQU   SCTSBYT1
SCTPARLM EQU   SCTSBYT1
SIOTQDSN EQU   SCTSBYT1
SIOTGDSN EQU   SCTSBYT1
SIOTCCAT EQU   SCTSBYT1
SCTSYSIN EQU   SCTSBYT1
SCTDUMMY EQU   SCTSBYT1
SIOTUNCT EQU   SCTSDISP
SIOTCTLG EQU   SCTSDISP
SIOTDLET EQU   SCTSDISP
SIOTKEEP EQU   SCTSDISP
SIOTPRIV EQU   SCTSDISP
S3400DSP EQU   SCTSDISP
SIOTVLCT EQU   INDMSIOT+54
SCTNMBUT EQU   INDMSIOT+53
SIOTRTRY EQU   SIOTBYT0
SIOTPUPV EQU   SIOTBYT0
SIOTNOPV EQU   SIOTBYT0
SIOTGIGN EQU   SIOTBYT0
SPVTAMSG EQU   SIOTBYT0
SIOTFUDA EQU   SIOTBYT0
SIOTDYAL EQU   SIOTBYT0
SIOTSSDS EQU   SIOTBYT0
SIOTGIID EQU   INDMSIOT+50
SCTVOLCT EQU   INDMSIOT+49
SCTSPOOL EQU   INDMSIOT+48
SIOTQNAM EQU   SIOTTSTC
SIOTDSNM EQU   SIOTTSTC
SIOTTRKM EQU   SIOTTSTC
SIOTSSMG EQU   SIOTTSTC
SIOTSSGP EQU   SIOTTSTC
@NM00006 EQU   SIOTTSTC
SIOTTERM EQU   SIOTTSTC
SIOTINFC EQU   SIOTTSTC
@NM00005 EQU   SIOTBYT3
SIOTDSID EQU   SIOTBYT3
S3400OFF EQU   SIOTBYT3
SIOTJES3 EQU   SIOTBYT3
SIOCDEVT EQU   SIOTBYT3
SIOALIAS EQU   SIOTBYT3
SCTDDINO EQU   INDMSIOT+44
SIOTDDNT EQU   SIOTBYT1
SIOTALCD EQU   SIOTBYT1
SIODADSM EQU   SIOTBYT1
SIOTDADR EQU   SIOTBYT1
SIODUNAL EQU   SIOTBYT1
SIOTHOLD EQU   SIOTBYT1
SIOTOCKP EQU   SIOTBYT1
SIOPSCNT EQU   INDMSIOT+42
SIOTREFN EQU   INDMSIOT+40
SIOTOTUN EQU   INDMSIOT+39
SIOTVRSB EQU   INDMSIOT+36
@NM00004 EQU   INDMSIOT+35
SCTPJFCB EQU   INDMSIOT+32
@NM00003 EQU   INDMSIOT+31
SCTPSIOT EQU   INDMSIOT+28
SIOTAFID EQU   INDMSIOT+26
SIOTVLSP EQU   INDMSIOT+24
SIODSNTE EQU   INDMSIOT+22
SIOTUNAF EQU   SCTUSADD
SIOTDEST EQU   INDMSIOT+12
SCTDDNAM EQU   INDMSIOT+4
SIOTTYPE EQU   INDMSIOT+3
SIOTDSKA EQU   INDMSIOT
@NM00078 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00077 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00076 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00075 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSAULCMS EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00074 EQU   FLCFSA
@NM00073 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00072 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00071 EQU   FLCIOA
@NM00070 EQU   FLCMCLA+15
@NM00069 EQU   FLCMCLA+14
@NM00068 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00067 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00066 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00065 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00064 EQU   FLCPER
@NM00063 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00062 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00061 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00060 EQU   FLCPIILC
@NM00059 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00058 EQU   FLCSVILC
@NM00057 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00056 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00055 EQU   FLCICCW2+4
FLCCVT   EQU   FLCICCW2
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RF00722 EQU   @RC00718
@ENDDATA EQU   *
         END   IEFAB4A4,(C'PLS1207',0701,78089)
