         TITLE 'IEFAB4FA - ALLOCATION Q-MGR                            *
                        '
IEFAB4FA CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(16)                                          01S0001
         DC    C'IEFAB4FA  76.342'                              01S0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01S0001
         BALR  @09,0                                            01S0001
@PSTART  LA    @10,4095(,@09)                                   01S0001
         USING @PSTART,@09                                      01S0001
         USING @PSTART+4095,@10                                 01S0001
         L     @00,@SIZDATD                                     01S0001
         GSPACE   R,LV=(0)
         LR    @03,@01                                          01S0001
         USING @DATD,@03                                        01S0001
         ST    @13,@SA00001+4                                   01S0001
         LM    @00,@01,20(@13)                                  01S0001
         ST    @03,8(,@13)                                      01S0001
         LR    @13,@03                                          01S0001
         MVC   @PC00001(8),0(@01)                               01S0001
*   ;                                                           01S0013
*   DCL                                                         01S0014
*     TEMPAREA CHAR(480),              /* TEMP WORK FIELD    @ZA15759*/
*     PARA PTR(31),                    /* PARAM FOR MAIN PROC        */
*     EXITPRMP PTR(31);                /* PTR TO ESTAE PARMS         */
*/********************************************************************/
*/*                                                                  */
*/* NAME - IEFZB447                                                  */
*/*                                                                  */
*/* DESCRIPTIVE NAME - MAPPING MACRO FOR COMMON ALLOCATION ESTAE     */
*/*                    PARMS                                         */
*/*                                                                  */
*/* SUPPORT CODE - YO2670                                            */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THIS PARAMETER LIST IS CREATED AND INITIALIZED BY IEFAB421,    */
*/*   AND SUBSEQUENTLY, UPDATED BY VARIOUS ALLOCATION MODULES.       */
*/*   THE LIST SERVES AS INPUT TO THE COMMON ALLOCATION ESTAE ROUTINE*/
*/*   (IEFAB4E8) IF AN ABEND OCCURS DURING COMMON ALLOCATION         */
*/*   PROCESSING. IT ALSO SUPPLIES SOME INFORMATION TO THE UPDATE UCB*/
*/*   FRR ROUTINE (IEFAB4E6). THIS LIST CONTAINS FLAGS INDICATING    */
*/*   WHAT RESOURCES ARE HELD AT THE TIME OF THE ABEND AND WHAT      */
*/*   CLEANUP FUNCTIONS ARE TO BE PERFORMED. IT ALSO SUPPLIES PTRS   */
*/*   AND OTHER INFORMATION NEEDED TO PERFORM THE CLEANUP. THE       */
*/*   AUTOMATIC DATA AREA SUPPLIED IN THIS LIST IS USED BY IEFAB4E8. */
*/*                                                                  */
*/* METHOD OF ACCESS                                                 */
*/*   PL/S - DCL EXITPRMP PTR(31)                                    */
*/*   NOTE: EXITPRMP IS DECLARED IN THE ALLOCATION WORK AREA(ALCWA)  */
*/*                                                                  */
*/********************************************************************/
*DCL                                                            01S0015
*  1 PRMESTAE BASED(EXITPRMP),         /*ESTAE PARAMETER LIST        */
*   2 * CHAR(252),                     /*AUTODATA AREA FOR EXIT RTN  */
*   2 PRMRESC BIT(8),                  /*RESOURCES HELD              */
*    3 ENQQ4 BIT(1),                   /*ENQUEUED ON Q4              */
*    3 DDRQ  BIT(1),                   /*ENQUEUED ON DDR QUEUE       */
*    3 CHNGQ BIT(1),                   /*ENQUEUED ON CHANGE QUEUE    */
*    3 DSSTAP BIT(1),                  /*DSS TAPE BIT                */
*    3 DSSUNREC BIT(1),                /*DSS UNIT RECORD BIT         */
*    3 TPQ BIT(1),                     /*ENQUEUED ON TP QUEUE        */
*    3 * BIT(2),                       /*RESERVED                    */
*   2 PRMFUNC BIT(8),                  /*FUNCTIONS NEEDED            */
*    3 GENCLNUP BIT(1),                /*CALL GENERIC CLEANUP RTN    */
*    3 UPDSABCK BIT(1),                /*ZERO SIOT DSAB PTR          */
*    3 DSABCHN BIT(1),                 /*FIX UP DSAB CHAIN           */
*    3 TIOTBLT BIT(1),                 /*TIOT ENTRY BUILT            */
*    3 DUMPOK BIT(1),                                           01S0015
*    3 FREECORE BIT(1),                /*FREE QUEUE MANAGER BLOCK    */
*    3 VMVCALL BIT(1),                 /*CALL VM&V CLEANUP RTN       */
*    3 * BIT(1),                                                01S0015
*   2 PRMASID FIXED(15),               /*ASID                        */
*   2 PRMSIOTP PTR(31),                /*SIOT PTR                    */
*   2 PRMUCBP PTR(31),                 /*UCB PTR                     */
*   2 PRMQMGP PTR(31),                 /*PTR TO Q-MGR PARMS          */
*   2 PRMQMBLN FIXED(31),              /*LENGTH OF Q-MGR BLOCK       */
*   2 PRMQMBP PTR(31),                 /*PTR TO Q-MGR BLOCK TO FREE  */
*   2 PRMQDBP PTR(31),                 /*PTR TO DSAB QDB             */
*   2 PRMDSQL PTR(31),                 /*PTR TO LAST DSAB IN QUEUE   */
*   2 PRMDSQF PTR(31),                 /*PTR OT FIRST DSAB IN QUEUE  */
*   2 PRMNELM FIXED(31);               /*NO, ELEMENTS IN DSAB QUEUE  */
*   DCL                                                         01S0016
*     ON BIT(1) CONSTANT('1'B),                                 01S0016
*     OFF BIT(1) CONSTANT('0'B);                                01S0016
*                                                               01S0016
*   /*****************************************************************/
*   /*                                                               */
*   /* QMGR INFORMATION BLOCK IN COMMON AREA                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0017
*   DCL                                                         01S0017
*     1 QMQBLK BASED,                                           01S0017
*      2 QMFLD1,                    /* FIXED-LENGTH PORTION          */
*       3 QMNXTF PTR(31),           /* NXT BLOCK                     */
*       3 QMNXTB PTR(31),           /* PREV BLOCK                    */
*       3 QMNXTQF PTR(31),          /* NXT ON QUEUE                  */
*       3 QMNXTQB PTR(31),          /* PREV ON QUEUE                 */
*       3 QMECB FIXED(31),          /* ECB                           */
*        4 QMECBFLG BIT(1),         /*                               */
*       3 QMASID CHAR(4),           /* ADDR-SPACE ID                 */
*       3 QM2PTR PTR(31),           /* PTR TO 2ND MASK               */
*       3 QMSTAT CHAR(1),           /* STATUS FIELD                  */
*      2 QMASKOWN CHAR(480);        /* VAR LNG MASKS (2)     @ZA15759*/
*                                                               01S0017
*   /*****************************************************************/
*   /*                                                               */
*   /* THE FOLLOWING IS JUST BEHIND QMASKOWN, DUE TO WAY PGM         */
*   /* INITALIZES QM2PTR. QMASKOWN RECORDS OWNERSHIP OF GRPS, QMSKTRY*/
*   /* IS SAME-LENGTH MASK FOR STORING TRIAL MASKS.                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0018
*   DCL                                                         01S0018
*     QMSKTRY CHAR(480)BASED(QM2PTR);  /*                    @ZA15759*/
*                                                               01S0018
*   /*****************************************************************/
*   /*                                                               */
*   /* LOCAL DEFINITION OF THE QUEUE-ROOT STRUCTURE IN THE NUCLEUS.  */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0019
*   DCL                                                         01S0019
*     1 ROOTS BASED(CVTAQTOP),                                  01S0019
*      2 MAINF PTR(31),             /* MAIN FWRD ROOT                */
*      2 MAINB PTR(31),             /* MAIN BKWD ROOT                */
*      2 QAF PTR(31),               /* A WAIT FWD                    */
*      2 QAB PTR(31),               /* A WAIT BKWD                   */
*      2 QBF PTR(31),               /* AB WAIT FWD                   */
*      2 QBB PTR(31),               /* AB WAIT BKWD                  */
*      2 QCF PTR(31),               /* WFD WAIT FWD                  */
*      2 QCB PTR(31),               /* WFD WAIT BKWD                 */
*      2 MASKS CHAR(480);           /* GBL GRP LOCKS         @ZA15759*/
*   DCL                                                         01S0020
*     ASCBADDR PTR(31) BASED(ASCBENTP),/*ASCB PTR                    */
*     ASCBENTP PTR(31),                /*PTR TO ASCB PTR             */
*     ASVTPTR PTR(31),                 /*ASVT PTR                    */
*     CVTPTR PTR(31)LOCATION(16);                               01S0020
*                                                               01S0020
*/*                                                                  */
*/*      COMMUNICATION VECTOR TABLE                                  */
*/*                                                                  */
*/*      OS/VS1 RELEASE 5, OS/VS2 RELEASE 4, 12/05/75, LEVEL=16      */
*/*                                                                  */
*/*  METHOD OF ACCESS                                                */
*/*      PL/S - DCL CVTPTR PTR                                       */
*/*      BAL  - DSECT=YES SHOULD BE SPECIFIED ON MACRO CALL EXCEPT   */
*/*             WHEN CALLED DURING SYSGEN TO CREATE CSECT.  CVT FOR  */
*/*             OS/VS2 IS MAPPED UNLESS SYS=AOS1 IS SPECIFIED.  THE  */
*/*             PREFIX IS NOT MAPPED UNLESS PREFIX=YES IS SPECIFIED. */
*/*             A USING ON CVTMAP OR DSECT NAME WILL ESTABLISH       */
*/*             ADDRESSABILITY FOR ALL SYMBOLS EXCEPT IN THE 2       */
*/*             EXTENSIONS.  TO ESTABLISH ADDRESSABILITY FOR THE     */
*/*             OS - OS/VS COMMON EXTENSION, YOU SHOULD CODE         */
*/*                                                                  */
*/*             L     REG,CVTEXT1                                    */
*/*             USING CVTXTNT1,REG                                   */
*/*                                                                  */
*/*             TO ESTABLISH ADDRESSABILITY FOR THE OS/VS1 - OS/VS2  */
*/*             COMMON EXTENSION, YOU SHOULD CODE                    */
*/*                                                                  */
*/*             L     REG,CVTEXT2                                    */
*/*             USING CVTXTNT2,REG                                   */
*/*                                                                  */
*/*             WHERE REG IN EITHER CASE IS ANY REGISTER OTHER       */
*/*             THAN ZERO.                                           */
*/*                                                                  */
*/*             WHEN LISTING IS SUPPRESSED, YOU CAN DETERMINE WHICH  */
*/*             DSECT A SYMBOL IS IN BY USING THE STATEMENT NUMBER   */
*/*             IN THE DEFN COLUMN IN THE CROSS REFERENCE LISTING.   */
*/*             FOR EXAMPLE, ANY SYMBOL DEFINED BETWEEN THE          */
*/*             STATEMENT NUMBERS FOR CVTXTNT1 AND CVTXTNT2 IS IN    */
*/*             THE OS - OS/VS COMMON EXTENSION.                     */
*/*                                                                  */
*/*  F.E.'S                                                          */
*/*      MICROFICHE LISTING - CVT                                    */
*/*                                                                  */
*/*  DEVELOPERS                                                      */
*/*      BAL LISTING  - SPECIFY LIST=YES ON MACRO CALL               */
*/*      PL/S LISTING - SPECIFY %IHALIST='YES' BEFORE INCLUDE        */
*/*                                                                  */
*/*      FOR INTEGRATION, A LISTING MUST NOT BE REQUESTED UNLESS     */
*/*      YOUR MODULE CREATES THE CSECT.                              */
*                                                               01S0021
* /*                   CVT PROPER                                    */
*                                                               01S0021
* DECLARE                                                       01S0021
*   1 CVTMAP   BASED(CVTPTR) BDY(WORD),                         01S0021
*    2 CVT      CHAR(0) BDY(WORD),   /* BEGINNING OF CVT       MDC150*/
*    2 CVTTCBP  PTR(31),             /* ADDRESS OF A DOUBLE WORD, THE
*                                       FIRST CONTAINING THE NEXT-TO-
*                                       BE-DISPATCHED TCB ADDRESS.
*                                       THE SECOND CONTAINING THE
*                                       LAST (CURRENT) TCB ADDRESS.
*                                       BOTH WORDS ARE IDENTICAL
*                                       UNLESS THE TASK GOES INTO A
*                                       WAIT STATE.  WHEN IN A WAIT
*                                       STATE, THE FIRST WORD IS SET
*                                       TO ZERO UNTIL THE WAITING IS
*                                       OVER AND THEN BOTH WORDS ARE
*                                       ONCE AGAIN IDENTICAL.   01S0021
*                                       (OS/VS1)                01S0021
*                                       ADDRESS OF 4-WORD LIST OF
*                                       ADDRESSES - THE NEXT TCB, THE
*                                       CURRENT TCB, THE NEXT ASCB
*                                       AND THE CURRENT ASCB, IN THAT
*                                       ORDER (OS/VS2)         MDC026*/
*    2 CVT0EF00 PTR(31),             /* ADDRESS OF ROUTINE TO SCHEDULE
*                                       ASYNCHRONOUS EXITS           */
*    2 CVTLINK  PTR(31),             /* ADDRESS OF DCB FOR      01S0021
*                                       SYS1.LINKLIB DATA SET        */
*    2 CVTJOB   PTR(31),             /* ADDRESS OF QUEUE MANAGER
*                                       RESIDENT DATA AREA (QMRES)
*                                       (OS/VS1) (MDC083)      XM4042*/
*    2 CVTBUF   PTR(31),             /* ADDRESS OF THE BUFFER OF THE
*                                       RESIDENT CONSOLE INTERRUPT
*                                       ROUTINE                      */
*    2 CVTXAPG  PTR(31),             /* ADDRESS OF I/O SUPERVISOR
*                                       APPENDAGE VECTOR TABLE       */
*    2 CVT0VL00 PTR(31),             /* ADDRESS OF ENTRY POINT OF THE
*                                       TASK SUPERVISOR'S ADDRESS
*                                       VALIDITY CHECKING ROUTINE    */
*    2 CVTPCNVT PTR(31),             /* ADDRESS OF ENTRY POINT OF THE
*                                       ROUTINE WHICH CONVERTS A
*                                       RELATIVE TRACK ADDRESS (TTR)
*                                       TO AN ABSOLUTE TRACK ADDRESS
*                                       (MBBCCHHR)                   */
*    2 CVTPRLTV PTR(31),             /* ADDRESS OF ENTRY POINT OF THE
*                                       ROUTINE WHICH CONVERTS AN
*                                       ABSOLUTE TRACK ADDRESS  01S0021
*                                       (MBBCCHHR) TO A RELATIVE
*                                       TRACK ADDRESS (TTR)          */
*    2 CVTILK1  PTR(31),             /* ADDRESS OF THE CHANNEL AND
*                                       CONTROL UNIT PORTION OF THE
*                                       UCB LOOKUP TABLE             */
*    2 CVTILK2  PTR(31),             /* ADDRESS OF THE UCB HALFWORD
*                                       ADDRESS LIST PORTION OF THE
*                                       UCB LOOKUP TABLE             */
*    2 CVTXTLER PTR(31),             /* ADDRESS OF ERROR RECOVERY
*                                       PROCEDURE (ERP) LOADER  01S0021
*                                       (IECVERPL) ENTRY POINT  01S0021
*                                       IECXTLER  (MDC349)   @Z40AQ9A*/
*    2 CVTSYSAD PTR(31),             /* ADDRESS OF THE SYSTEM   01S0021
*                                       RESIDENCE VOLUME ENTRY IN THE
*                                       UCB LOOKUP TABLE             */
*    2 CVTBTERM PTR(31),             /* ADDRESS OF ENTRY POINT OF THE
*                                       ABTERM ROUTINE               */
*    2 CVTDATE  CHAR(4) BDY(WORD),   /* CURRENT DATE IN PACKED  01S0021
*                                       DECIMAL                      */
*    2 CVTMSLT  PTR(31),             /* ADDRESS OF THE MASTER COMMON
*                                       AREA IN MASTER SCHEDULER
*                                       RESIDENT DATA AREA.     01S0021
*                                         NOTE - USE CVTMSER INSTEAD
*                                         TO ADDRESS MASTER SCHEDULER
*                                         RESIDENT DATA AREA.        */
*    2 CVTZDTAB PTR(31),             /* ADDRESS OF I/O DEVICE   01S0021
*                                       CHARACTERISTIC TABLE         */
*    2 CVTXITP  PTR(31),             /* ADDRESS OF ERROR INTERPRETER
*                                       ROUTINE                      */
*    2 CVTDAR   PTR(31),             /* SAME AS CVTDARA BELOW   01S0021
*                                       (OS/VS1)               MDC029*/
*     3 CVTFLGS1 BIT(8),             /* FLAG BYTE (OS/VS1)     MDC030*/
*      4 CVTDMPLK BIT(1),            /* SVC DUMP IS IN PROGRESS 01S0021
*                                       (OS/VS1)               MDC030*/
*      4 CVTRSV01 BIT(1),            /* RESERVED                     */
*      4 CVTRSV02 BIT(1),            /* RESERVED                     */
*      4 CVTRSV03 BIT(1),            /* RESERVED                     */
*      4 CVTRSV04 BIT(1),            /* RESERVED                     */
*      4 CVTRSV05 BIT(1),            /* RESERVED                     */
*      4 CVTRSV06 BIT(1),            /* RESERVED                     */
*      4 CVTRSV07 BIT(1),            /* RESERVED                     */
*     3 CVTDARA  PTR(24),            /* ADDRESS OF THE SYS1.DUMP I/O
*                                       CONTROL BLOCKS NEEDED BY
*                                       ABEND'S DAMAGE ASSESSMENT
*                                       ROUTINE (DAR) (OS/VS1) MDC029*/
*    2 CVT0FN00 PTR(31),             /* ADDRESS OF ENTRY POINT OF THE
*                                       FINCH ROUTINE (OS/VS1)       */
*    2 CVTEXIT  CHAR(2) BDY(WORD),   /* AN SVC 3 INSTRUCTION.  EXIT
*                                       TO DISPATCHER.               */
*    2 CVTBRET  CHAR(2) BDY(WORD,3), /* A BCR 15,14 INSTRUCTION.
*                                       RETURN TO CALLER (USED BY
*                                       DATA MANAGEMENT ROUTINES)    */
*    2 CVTSVDCB PTR(31),             /* ADDRESS OF THE DCB FOR THE
*                                       SYS1.SVCLIB DATA SET         */
*    2 CVTTPC   PTR(31),             /* ADDRESS OF THE TIMER    01S0021
*                                       SUPERVISOR WORK AREA         */
*    2 CVTPBLDL PTR(31),             /* ADDRESS OF BRANCH AND LINK
*                                       (BALR) ENTRY POINT OF THE
*                                       BLDL ROUTINE (OS/VS1)  MDC103*/
*    2 CVTSJQ   PTR(31),             /* ADDRESS OF THE SELECTED JOB
*                                       QUEUE (OS/VS1)               */
*    2 CVTCUCB  PTR(31),             /* ADDRESS OF THE TABLE THAT
*                                       CONTAINS THE CURRENT CONSOLE
*                                       UCB ADDRESSES                */
*    2 CVTQTE00 PTR(31),             /* ADDRESS OF THE TIMER ENQUEUE
*                                       ROUTINE FOR INTERVAL TIMER   */
*    2 CVTQTD00 PTR(31),             /* ADDRESS OF THE TIMER DEQUEUE
*                                       ROUTINE FOR INTERVAL TIMER   */
*    2 CVTSTB   PTR(31),             /* ADDRESS OF THE I/O DEVICE
*                                       STATISTICS TABLE             */
*    2 CVTDCB   CHAR(1) BDY(WORD),   /* OPERATING SYSTEM        01S0021
*                                       CONFIGURATION                */
*      4 CVTRSV08 BIT(1),            /* RESERVED                     */
*      4 CVT1SSS  BIT(1),            /* PCP                          */
*      4 CVT2SPS  BIT(1),            /* MFT, OS/VS1                  */
*      4 CVT4MS1  BIT(1),            /* MVT, OS/VS2                  */
*      4 CVTRSV09 BIT(1),            /* RESERVED                     */
*      4 CVT4MPS  BIT(1),            /* MODEL 65 MULTIPROCESSING     */
*      4 CVT6DAT  BIT(1),            /* DYNAMIC ADDRESS TRANSLATION
*                                       BY CPU (OS/VS1, OS/VS2)      */
*      4 CVTMVS2  BIT(1),            /* MULTIPLE MEMORY OPTION OF
*                                       OS/VS2 IS PRESENT      MDC131*/
*    2 CVTDCBA  PTR(24),             /* ADDRESS OF THE DCB FOR THE
*                                       SYS1.LOGREC (OUTBOARD   01S0021
*                                       RECORDER) DATA SET FOR SYSTEM
*                                       ENVIRONMENT RECORDING (SER)  */
*    2 CVTIOQET PTR(31),             /* ADDRESS OF IOS REQUEST ELEMENT
*                                       TABLE (OS/VS1)         MDC020*/
*    2 CVTIXAVL PTR(31),             /* ADDRESS OF THE I/O      01S0021
*                                       SUPERVISOR'S FREELIST POINTER
*                                       WHICH CONTAINS THE ADDRESS OF
*                                       THE NEXT REQUEST ELEMENT
*                                       (OS/VS1)                01S0021
*                                       ADDRESS OF THE I/O      01S0021
*                                       SUPERVISOR'S COMMUNICATION
*                                       AREA (IOCOM)  (OS/VS2)       */
*    2 CVTNUCB  PTR(31),             /* LOWEST ADDRESS NOT IN THE
*                                       NUCLEUS (ON PAGE BOUNDARY FOR
*                                       OS/VS1)  (ON SEGMENT BOUNDARY
*                                       FOR OS/VS2) (MDC318) @Z30AQ9A*/
*    2 CVTFBOSV PTR(31),             /* ADDRESS OF PROGRAM FETCH
*                                       ROUTINE                      */
*    2 CVT0DS   PTR(31),             /* ADDRESS OF ENTRY POINT OF THE
*                                       DISPATCHER                   */
*    2 CVTILCH  PTR(31),             /* ADDRESS OF THE LOGICAL  01S0021
*                                       CHANNEL WORD TABLE           */
*    2 CVTIERLC PTR(31),             /* ADDRESS OF THE ASYNCHRONOUS
*                                       EXIT QUEUE (OS/VS1)     01S0021
*                                       (MDC218)               YM4043*/
*     3 CVTRV516 PTR(31),            /* ** CVTIERLC FIELD UNUSED IN
*                                       MVS **  (MDC218)       YM4043*/
*    2 CVTMSER  PTR(31),             /* ADDRESS OF DATA AREA OF 01S0021
*                                       MASTER SCHEDULER RESIDENT
*                                       DATA AREA                    */
*    2 CVT0PT01 PTR(31),             /* ADDRESS OF BRANCH ENTRY POINT
*                                       OF POST ROUTINE              */
*    2 CVTRSV11 PTR(31),             /* ** CVTTRMTB FIELD UNUSED
*                                       IN OS/VS **                  */
*    2 CVTHEAD  PTR(31),             /* ADDRESS OF THE HIGHEST  01S0021
*                                       PRIORITY TCB IN THE READY
*                                       QUEUE (OS/VS1)         MDC025*/
*    2 CVTMZ00  PTR(31),             /* HIGHEST ADDRESS IN VIRTUAL
*                                       STORAGE FOR THE MACHINE      */
*    2 CVT1EF00 PTR(31),             /* ADDRESS OF ROUTINE WHICH
*                                       CREATES IRB'S FOR EXITS      */
*    2 CVTQOCR  PTR(31),             /* GRAPHICS INTERFACE TASK (GFX)
*                                       FIELD.  ADDRESS OF SEVENTH
*                                       WORD OF GFX PARAMETER LIST,
*                                       IF GFX IS ACTIVE.  ZERO IF
*                                       GFX IS NOT ACTIVE.           */
*    2 CVTQMWR  PTR(31),             /* ADDRESS OF QUEUE MANAGER'S
*                                       SYSTEM OUTPUT COMMUNICATIONS-
*                                       DATA-AREA (CDA), WHICH IS
*                                       STORED ON AN EXTERNAL DEVICE */
*    2 CVTSNCTR FIXED(15),           /* SERIAL NUMBER COUNTER FOR
*                                       ASSIGNING SERIAL NUMBERS TO
*                                       NON-SPECIFIC, UNLABELED 01S0021
*                                       MAGNETIC TAPE VOLUMES        */
*    2 CVTOPTA  CHAR(1),             /* OPTION INDICATORS            */
*     3 CVTCCH   BIT(1),             /* CHANNEL CHECK HANDLER (CCH)
*                                       OPTION PRESENT - RECOVERY
*                                       MANAGEMENT SUPPORT (RMS)
*                                                              XM4686*/
*     3 CVTAPR   BIT(1),             /* ALTERNATE PATH RETRY (APR)
*                                       OPTION PRESENT - RECOVERY
*                                       MANAGEMENT SUPPORT (RMS)     */
*     3 CVTDDR   BIT(1),             /* DYNAMIC DEVICE          01S0021
*                                       RECONFIGURATION (DDR) OPTION
*                                       PRESENT - RECOVERY MANAGEMENT
*                                       SUPPORT (RMS) (OS/VS1)  01S0021
*                                       DDR SYSTEM-INITIATED SWAP
*                                       ACTIVE (OS/VS2)        MDC126*/
*     3 CVTNIP   BIT(1),             /* NIP IS EXECUTING             */
*     3 CVTRSV12 BIT(1),             /* RESERVED                     */
*     3 CVTRSV13 BIT(1),             /* RESERVED                     */
*     3 CVTASCII BIT(1),             /* ASCII TAPE PROCESSING IS
*                                       GENERATED IN THIS SYSTEM     */
*     3 CVTXPFP  BIT(1),             /* CPU HAS EXTENDED PRECISION
*                                       FLOATING POINT FEATURE       */
*    2 CVTOPTB  CHAR(1),             /* MISCELLANEOUS FLAGS          */
*     3 CVTPROT  BIT(1),             /* CPU HAS STORE PROTECTION
*                                       FEATURE (OS/VS1)             */
*     3 CVTCTIMS BIT(1),             /* IF ON, HARDWARE HAS THE CLOCK
*                                       COMPARATOR AND CPU TIMER
*                                       FEATURE INSTALLED, AND OS/VS1
*                                       SYSGEN HAS SPECIFIED THIS
*                                       FEATURE (OS/VS1)       MDC127*/
*     3 CVTTOD   BIT(1),             /* CPU HAS TIME-OF-DAY CLOCK
*                                       FEATURE                      */
*     3 CVTNLOG  BIT(1),             /* SYS1.LOGREC IS UNAVAILABLE
*                                       FOR ERROR RECORDING.  ALWAYS
*                                       SET TO ZERO FOR OS/VS1 ICB382*/
*     3 CVTAPTHR BIT(1),             /* NIP SETS THIS BIT TO 1 WHEN
*                                       DEVICE TESTING IS COMPLETE.
*                                       IF 1, I/O SUPERVISOR USES AN
*                                       ALTERNATE PATH TO A DEVICE
*                                       WHEN A CONDITION CODE OF 3
*                                       EXISTS.  THIS BIT IS RESET BY
*                                       NIP TO 0 AFTER THE LINK PACK
*                                       AREA IS INITIALIZED.   YM2670*/
*     3 CVTFP    BIT(1),             /* CPU HAS FETCH PROTECTION
*                                       FEATURE (OS/VS1)       ICB427*/
*     3 CVTRSV16 BIT(1),             /* RESERVED                     */
*     3 CVTRSV17 BIT(1),             /* RESERVED                     */
*    2 CVTQCDSR PTR(31),             /* CDE SEARCH ROUTINE ADDRESS
*                                       (OS/VS2)                01S0021
*                                       ADDRESS OF THE ROUTINE THAT
*                                       SEARCHES THE REENTERABLE LOAD
*                                       MODULE QUEUE (OS/VS1)        */
*    2 CVTQLPAQ PTR(31),             /* ADDRESS OF POINTER TO MOST
*                                       RECENT ENTRY ON LINK PACK
*                                       AREA CDE QUEUE (OS/VS2) 01S0021
*                                       ADDRESS OF THE REENTERABLE
*                                       LOAD MODULE QUEUE (OS/VS1)   */
*    2 CVTRSV18 PTR(31),             /* ** CVTMPCVT FIELD UNUSED IN
*                                       OS/VS **                     */
*    2 CVTSMCA  PTR(31),             /* ADDRESS OF THE SYSTEM   01S0021
*                                       MANAGEMENT CONTROL AREA 01S0021
*                                       (SMCA) IF THE SYSTEM    01S0021
*                                       MANAGEMENT FACILITIES (SMF)
*                                       OPTION IS PRESENT IN THE
*                                       SYSTEM.  OTHERWISE, ZERO.    */
*    2 CVTABEND PTR(31),             /* ADDRESS OF SECONDARY CVT FOR
*                                       ABEND IN EOT (OS/VS2)   01S0021
*                                       USED BY AN INTERNAL ABEND
*                                       TRACE ROUTINE FOR DEBUG 01S0021
*                                       PURPOSES (OS/VS1)      XM0615*/
*    2 CVTUSER  PTR(31),             /* A WORD AVAILABLE TO THE USER */
*    2 CVTMDLDS PTR(31),             /* RESERVED FOR MODEL-DEPENDENT
*                                       SUPPORT                      */
*    2 CVTQABST CHAR(2) BDY(WORD),   /* AN SVC 13 (ABEND) INSTRUCTION
*                                       (OS/VS2)  RESERVED (OS/VS1)  */
*    2 CVTLNKSC CHAR(2) BDY(WORD,3), /* AN SVC 6 (LINK) INSTRUCTION
*                                                              ICB369*/
*    2 CVTTSCE  PTR(31),             /* ADDRESS OF THE FIRST TIME
*                                       SLICE CONTROL ELEMENT (TSCE) */
*    2 CVTPATCH PTR(31),             /* ADDRESS OF A 200-BYTE FE
*                                       PATCH AREA                   */
*    2 CVTRMS   PTR(31),             /* RECOVERY MANAGEMENT SUPPORT
*                                       (RMS) COMMUNICATIONS VECTOR.
*                                       ADDRESS OF A MACHINE STATUS
*                                       BLOCK.                       */
*    2 CVTRV515 PTR(31),             /* ** CVTTSCVT FIELD UNUSED IN
*                                       MVS **  (MDC037)     @Z40AQ9A*/
*    2 CVT0SCR1 PTR(31),             /* ADDRESS OF THE SECTOR   01S0021
*                                       CALCULATION ROUTINE FOR 01S0021
*                                       ROTATIONAL POSITION SENSING
*                                       (RPS)                        */
*    2 CVTGTF   PTR(31),             /* GENERALIZED TRACE FACILITY
*                                       (GTF) CONTROL WORD     ICB312*/
*     3 CVTGTFST BIT(8),             /* GTF FLAG BYTE          ICB312*/
*      4 CVTGTFS  BIT(2),            /* GTF STATUS (OS/VS1)    MDC088*/
*       5 CVTGTFAV BIT(1),           /* IF ZERO, GTF NOT ACTIVE.
*                                       IF ONE, GTF ACTIVE.     01S0021
*                                       (OS/VS2)               MDC098*/
*       5 CVTRV315 BIT(1),           /* RESERVED (OS/VS2)            */
*      4 CVTSTATE BIT(1),            /* GTF IS IN CONTROL PROCESSING
*                                       A HOOK (OS/VS1)        MDC093*/
*       5 CVTRV316 BIT(1),           /* RESERVED (OS/VS2)            */
*      4 CVTTMODE BIT(1),            /* IF 0, MODE=INT SPECIFIED.
*                                       IF 1, MODE=EXT SPECIFIED
*                                       WHICH MEANS TRACE DATA IS TO
*                                       BE WRITTEN TO AN EXTERNAL
*                                       DEVICE.  (OS/VS1)      MDC094*/
*       5 CVTRV317 BIT(1),           /* RESERVED (OS/VS2)            */
*      4 CVTFORM  BIT(1),            /* TRACE DATA IS TO BE FORMATTED
*                                       ON ABNORMAL TERMINATION 01S0021
*                                       (OS/VS1)               MDC095*/
*       5 CVTRV318 BIT(1),           /* RESERVED (OS/VS2)            */
*      4 CVTUSR   BIT(1),            /* TRACE=USR SPECIFIED.    01S0021
*                                       USER-REQUESTED TRACE DATA IS
*                                       TO BE INCLUDED IN THE TRACE
*                                       DATA SET.  (MDC317)  @Z30AP9A*/
*      4 CVTRNIO  BIT(1),            /* GTF IS ACTIVE AND TRACING
*                                       RNIO EVENTS            MDC187*/
*      4 CVTRSV27 BIT(1),            /* RESERVED                     */
*     3 CVTGTFA  PTR(24),            /* ADDRESS OF THE MONITOR CALL
*                                       VECTOR TABLE (OS/VS1)   01S0021
*                                       ADDRESS OF MAIN MONITOR CALL
*                                       ROUTING TABLE, MCHEAD   01S0021
*                                       (OS/VS2)               MDC156*/
*    2 CVTAQAVT PTR(31),             /* ADDRESS OF THE FIRST WORD OF
*                                       THE TCAM DISPATCHER WHICH
*                                       CONTAINS THE ADDRESS OF THE
*                                       ADDRESS VECTOR TABLE (AVT).
*                                       IF ZERO, TCAM IS NOT STARTED */
*     3 CVTTCMFG CHAR(1),            /* TCAM FLAGS                   */
*      4 CVTTCRDY BIT(1),            /* TCAM IS READY TO ACCEPT USERS*/
*      4 CVTRSV28 BIT(1),            /* RESERVED                     */
*      4 CVTRSV29 BIT(1),            /* RESERVED                     */
*      4 CVTRSV30 BIT(1),            /* RESERVED                     */
*      4 CVTRSV31 BIT(1),            /* RESERVED                     */
*      4 CVTRSV32 BIT(1),            /* RESERVED                     */
*      4 CVTRSV33 BIT(1),            /* RESERVED                     */
*      4 CVTRSV34 BIT(1),            /* RESERVED                     */
*     3 CVTAQAVB PTR(24),            /* SAME AS CVTAQAVT ABOVE       */
*    2 CVTVOLM2 PTR(31),             /* ADDRESS OF TABLE FOR POWER
*                                       WARNING FEATURE (PWF)   01S0021
*                                       (OS/VS2)  (MDC308)   @Z30AQ9A*/
*     3 CVTTATA  PTR(31),            /* ADDRESS OF THE FIRST ENTRY IN
*                                       THE TCB ADDRESS TABLE.  THE
*                                       FIRST ENTRY IS FOR PARTITION
*                                       0.  (OS/VS1)                 */
*      4 CVTTSKS  PTR(8),            /* MAXIMUM ALLOWABLE NUMBER OF
*                                       ENTRIES IN THE TCB ADDRESS
*                                       TABLE  (OS/VS1)              */
*       5 CVTVOLF2 BIT(8),           /* PWF FLAG BYTE.  THIS BYTE IS
*                                       OVERLAID BY CVTVOLM2 AFTER
*                                       PWF INITIALIZATION.     01S0021
*                                       (OS/VS2)  (MDC309)   @Z30AQ9A*/
*        6 CVTVOLI2 BIT(1),          /* PWF INITIALIZATION HAS NOT
*                                       OCCURRED (OS/VS2)       01S0021
*                                       (MDC310)             @Z30AQ9A*/
*      4 CVTTAT   PTR(24),           /* SAME AS CVTTATA ABOVE        */
*       5 CVTVOLT2 PTR(24),          /* PWF RECHECK TIME DELAY. 01S0021
*                                       THIS VALUE IS OVERLAID BY
*                                       CVTVOLM2 AFTER PWF      01S0021
*                                       INITIALIZATION.  (OS/VS2)
*                                       (MDC311)             @Z30AQ9A*/
*    2 CVTATER  PTR(31),             /* ADDRESS OF THE SYSTEM ERROR
*                                       TCB.  THE PURGE ROUTINE USES
*                                       THIS FIELD TO ACCESS THE
*                                       SIRB.  (OS/VS1)        ICB346*/
*     3 CVTSYST  PTR(8),             /* NUMBER OF ENTRIES IN THE TCB
*                                       ADDRESS TABLE FOR TCB'S 01S0021
*                                       CREATED DURING SYSTEM   01S0021
*                                       GENERATION  (OS/VS1)         */
*     3 CVTATERA PTR(24),            /* SAME AS CVTATER ABOVE        */
*    2 CVTEXT1  PTR(31),             /* ADDRESS OF OS - OS/VS COMMON
*                                       EXTENSION              ICB421*/
*    2 CVTCBSP  PTR(31),             /* ADDRESS OF ACCESS METHOD
*                                       CONTROL BLOCK STRUCTURE 01S0021
*                                                              MDC195*/
*    2 CVTPURG  PTR(31),             /* ADDRESS OF SUBSYSTEM PURGE
*                                       ROUTINE                ICB330*/
*     3 CVTRSV35 PTR(8),             /* RESERVED               ICB330*/
*     3 CVTPURGA PTR(24),            /* ADDRESS OF SUBSYSTEM PURGE
*                                       ROUTINE                ICB330*/
*    2 CVTAMFF  CHAR(4),             /* RESERVED FOR ACCESS METHOD
*                                       FLAGS                  ICB436*/
*    2 CVTQMSG  PTR(31),             /* ADDRESS OF INFORMATION TO BE
*                                       PRINTED BY ABEND       ICB307*/
*     3 CVTRSV36 PTR(8),             /* RESERVED               ICB307*/
*     3 CVTQMSGA PTR(24),            /* ADDRESS OF INFORMATION TO BE
*                                       PRINTED BY ABEND       ICB307*/
*    2 CVTDMSR  PTR(31),             /* SAME AS CVTDMSRA BELOW ICB346*/
*     3 CVTRSV37 PTR(8),             /* RESERVED (OS/VS1)      ICB346*/
*      4 CVTDMSRF BIT(8),            /* OPEN/CLOSE/EOV FLAG BYTE.
*                                       SETTING BOTH BIT 0 AND BIT 1
*                                       ON WILL CAUSE BOTH KINDS OF
*                                       DUMPS TO BE TAKEN.  THESE
*                                       BITS ARE USED DURING TESTING
*                                       AND DEBUGGING WHEN OTHER
*                                       DEBUG METHODS ARE INEFFECTIVE.
*                                       (OS/VS2)  (MDC350)   @Z40AQ9A*/
*       5 CVTSDUMP BIT(1),           /* SET BY COREZAP.  WILL CAUSE
*                                       AN SDUMP TO BE TAKEN AND
*                                       IEC999I MESSAGE ISSUED FOR
*                                       EVERY ABEND ISSUED WITHIN AN
*                                       OPEN/CLOSE/EOV OR DADSM 01S0021
*                                       FUNCTION.  (OS/VS2)     01S0021
*                                       (MDC351)             @Z40AQ9A*/
*       5 CVTUDUMP BIT(1),           /* SET BY COREZAP.  WILL CAUSE
*                                       AN ABEND DUMP TO BE TAKEN FOR
*                                       EVERY ABEND ISSUED WITHIN AN
*                                       OPEN/CLOSE/EOV OR DADSM 01S0021
*                                       FUNCTION.  (OS/VS2)     01S0021
*                                       (MDC352)             @Z40AQ9A*/
*       5 CVTRV629 BIT(1),           /* RESERVED  (OS/VS2)   @Z40AQ9A*/
*       5 CVTRV630 BIT(1),           /* RESERVED  (OS/VS2)   @Z40AQ9A*/
*       5 CVTRV631 BIT(1),           /* RESERVED  (OS/VS2)   @Z40AQ9A*/
*       5 CVTRV632 BIT(1),           /* RESERVED  (OS/VS2)   @Z40AQ9A*/
*       5 CVTRV633 BIT(1),           /* RESERVED  (OS/VS2)   @Z40AQ9A*/
*       5 CVTRV634 BIT(1),           /* RESERVED  (OS/VS2)   @Z40AQ9A*/
*     3 CVTDMSRA PTR(24),            /* ADDRESS OF THE OPEN/CLOSE/EOV
*                                       SUPERVISORY ROUTINE IN THE
*                                       NUCLEUS.  THIS ROUTINE  01S0021
*                                       HANDLES THE ROUTING OF  01S0021
*                                       CONTROL AMONG THE I/O SUPPORT
*                                       ROUTINES.              ICB346*/
*    2 CVTRSV38 PTR(31),             /* RESERVED                     */
*    2 CVTRSV39 PTR(31),             /* RESERVED                     */
*                                                               01S0021
* /*           OS/VS1 - OS/VS2 COMMON SECTION                        */
*                                                               01S0021
*    2 CVTREAL  PTR(31),             /* ADDRESS OF THE VIRTUAL  01S0021
*                                       STORAGE BYTE FOLLOWING THE
*                                       HIGHEST VIRTUAL=REAL STORAGE
*                                       ADDRESS                ICB368*/
*    2 CVTPTRV  PTR(31),             /* ADDRESS OF PAGING SUPERVISOR
*                                       GENERAL ROUTINE TO TRANSLATE
*                                       REAL ADDRESSES TO VIRTUAL
*                                       ADDRESSES                    */
*    2 CVTMODE  PTR(31),             /* ADDRESS OF ROUTINE TO CHANGE
*                                       SYSTEM MASK (OS/VS1)    01S0021
*                                       (MDC217)               YM4244*/
*    2 CVTJESCT PTR(31),             /* ADDRESS OF JOB ENTRY    01S0021
*                                       SUBSYSTEM (JES) CONTROL TABLE*/
*    2 CVTJEPS  PTR(31),             /* ADDRESS OF JOB ENTRY    01S0021
*                                       PERIPHERAL SERVICES (JEPS)
*                                       MONITOR TCB (OS/VS1)   YM2702*/
*    2 CVTTZ    FIXED(31),           /* DIFFERENCE BETWEEN LOCAL TIME
*                                       AND GREENWICH MEAN TIME IN
*                                       BINARY UNITS OF 1.048576
*                                       SECONDS                      */
*    2 CVTMCHPR PTR(31),             /* ADDRESS OF MACHINE CHECK
*                                       PARAMETER LIST               */
*    2 CVTEORM  PTR(31),             /* HIGHEST REAL ADDRESS IN MAIN
*                                       STORAGE (OS/VS1)  POTENTIAL
*                                       REAL HIGH STORAGE ADDRESS
*                                       (OS/VS2)               MDC087*/
*    2 CVTERPV  PTR(31),             /* ADDRESS OF I/O SUPERVISOR
*                                       SUBROUTINE TO CONVERT CCW
*                                       DATA ADDRESSES TO VIRTUAL
*                                       ADDRESSES (OS/VS1)      01S0021
*                                       (MDC219)               YM4043*/
*     3 CVTRV517 PTR(31),            /* ** CVTERPV FIELD UNUSED IN
*                                       MVS **  (MDC219)       YM4043*/
*    2 CVTINTLA PTR(31),             /* ADDRESS OF A TIME INTERVAL.
*                                       I/O LOAD BALANCING COUNTS THE
*                                       NUMBER OF EXCP'S ISSUED 01S0021
*                                       DURING THIS TIME INTERVAL AND
*                                       USES THE VALUE IN DETERMINING
*                                       THE AMOUNT OF I/O ACTIVITY IN
*                                       THE SYSTEM.  (OS/VS1)   01S0021
*                                       (MDC220)               YM4043*/
*     3 CVTRV518 PTR(31),            /* ** CVTINTLA FIELD UNUSED IN
*                                       MVS **  (MDC220)       YM4043*/
*    2 CVTAPF   PTR(31),             /* SAME AS CVTAPFA BELOW  ICB360*/
*     3 CVTRSV40 PTR(8),             /* RESERVED               ICB360*/
*     3 CVTAPFA  PTR(24),            /* ADDRESS OF BRANCH ENTRY POINT
*                                       IN AUTHORIZED PROGRAM FACILITY
*                                       (APF) ROUTINE                */
*    2 CVTEXT2  PTR(31),             /* ADDRESS OF OS/VS1 - OS/VS2
*                                       COMMON EXTENSION       ICB330*/
*     3 CVTRSV41 PTR(8),             /* RESERVED               ICB330*/
*     3 CVTEXT2A PTR(24),            /* SAME AS CVTEXT2 ABOVE  ICB330*/
*    2 CVTHJES  PTR(31),             /* SAME AS CVTHJESA BELOW ICB454*/
*     3 CVTRSV42 PTR(8),             /* RESERVED               ICB454*/
*     3 CVTHJESA PTR(24),            /* ADDRESS OF OPTIONAL JOB ENTRY
*                                       SUBSYSTEM (JES) COMMUNICATION
*                                       VECTOR TABLE           ICB454*/
*    2 CVTRSV43 FIXED(15),           /* RESERVED                     */
*    2 CVTRSV44 FIXED(15),           /* RESERVED                     */
*    2 CVTRSV45 PTR(31),             /* RESERVED                     */
*    2 CVTRSV46 PTR(31),             /* RESERVED                     */
*                                                               01S0021
* /*           OS/VS1 OVERLAY                                        */
*                                                               01S0021
*    2 CVTPGSIA PTR(31),             /* ADDRESS OF PAGING SUPERVISOR
*                                       INFORMATION AREA             */
*    2 CVTPCVT  PTR(31),             /* ADDRESS OF PAGED CVT    01S0021
*                                       EXTENSION                    */
*    2 CVTA1F1  CHAR(1),             /* PAGE FAULT FLAGS             */
*     3 CVTPFSW  BIT(1),             /* ONLY THE PAGING TASK MAY BE
*                                       DISPATCHED                   */
*     3 CVTSRSW  BIT(1),             /* NO TASK EXCEPT THE PAGING TASK
*                                       MAY EXECUTE DISABLED CODE    */
*     3 CVTRSV47 BIT(1),             /* RESERVED                     */
*     3 CVTRSV48 BIT(1),             /* RESERVED                     */
*     3 CVTRSV49 BIT(1),             /* RESERVED                     */
*     3 CVTRSV50 BIT(1),             /* RESERVED                     */
*     3 CVTRSV51 BIT(1),             /* RESERVED                     */
*     3 CVTRSV52 BIT(1),             /* RESERVED                     */
*    2 CVTSYSK  CHAR(1),             /* SYSTEM LOCK.  IF NOT ZERO,
*                                       ONLY THE PAGING TASK MAY BE
*                                       DISPATCHED                   */
*     3 CVTRSV53 BIT(1),             /* RESERVED                     */
*     3 CVTRSV54 BIT(1),             /* RESERVED                     */
*     3 CVTRSV55 BIT(1),             /* RESERVED                     */
*     3 CVTRSV56 BIT(1),             /* RESERVED                     */
*     3 CVTSLKR  BIT(1),             /* MACHINE CHECK HANDLING IS IN
*                                       PROGRESS               ICB320*/
*     3 CVTSLKQ  BIT(1),             /* SYSTEM QUEUE AREA (SQA) HAS
*                                       BEEN EXHAUSTED               */
*     3 CVTSLKP  BIT(1),             /* LAST PAGING CONTROL BLOCK
*                                       (PCB) HAS BEEN USED          */
*     3 CVTSLKO  BIT(1),             /* A ROUTINE RUNNING DISABLED
*                                       HAS PRODUCED A PAGE FAULT    */
*    2 CVTSULK  FIXED(15),           /* SUPERVISOR LOCK.  NUMBER OF
*                                       TASKS ATTEMPTING TO EXECUTE
*                                       DISABLED ROUTINES.  IF NOT
*                                       ZERO, ONLY ENABLED TASKS MAY
*                                       RUN.                         */
*    2 CVTSMF   PTR(31),             /* ADDRESS OF SYSTEM MANAGEMENT
*                                       FACILITIES (SMF) TCB   ICB395*/
*    2 CVTPNWFR PTR(31),             /* ADDRESS OF ROUTINE WHICH
*                                       FREES THE 'EMERGENCY' WORK
*                                       AREA (ICB413)          XM2452*/
*    2 CVTDDCE  PTR(31),             /* ADDRESS OF DYNAMIC DISPATCHING
*                                       CONTROL ELEMENT        ICB466*/
*    2 CVTRSV57 FIXED(15),           /* RESERVED                     */
*    2 CVTRSV58 FIXED(15),           /* RESERVED                     */
*    2 CVTSTOA  FIXED(31),           /* SAVE AREA FOR THE REAL  01S0021
*                                       STORAGE ADDRESS OF THE  01S0021
*                                       SEGMENT TABLE ORIGIN   ICB496*/
*    2 CVTVOLM1 PTR(31),             /* ADDRESS OF TABLE FOR POWER
*                                       WARNING FEATURE (PWF)   01S0021
*                                       (MDC312)             @X04AQ9A*/
*     3 CVTVOLF1 BIT(8),             /* PWF FLAG BYTE.  THIS BYTE IS
*                                       OVERLAID BY CVTVOLM1 AFTER
*                                       PWF INITIALIZATION.     01S0021
*                                       (MDC313)             @X04AQ9A*/
*      4 CVTVOLI1 BIT(1),            /* PWF INITIALIZATION HAS NOT
*                                       OCCURRED  (MDC314)   @X04AQ9A*/
*     3 CVTVOLT1 PTR(24),            /* PWF RECHECK TIME DELAY. 01S0021
*                                       THIS VALUE IS OVERLAID BY
*                                       CVTVOLM1 AFTER PWF      01S0021
*                                       INITIALIZATION.         01S0021
*                                       (MDC315)             @X04AQ9A*/
*    2 CVTRSV61 PTR(31),             /* RESERVED                     */
*    2 CVTATMCT PTR(31),             /* POINTER TO VTAM CONTROL 01S0021
*                                       TABLE                  MDC082*/
*     3 CVTATMST CHAR(1),            /* VTAM START STATUS      MDC135*/
*     3 CVTATMCA PTR(24),            /* POINTER TO VTAM CONTROL 01S0021
*                                       TABLE                  MDC138*/
*    2 CVTAUTH  PTR(31),             /* POINTER TO AUTHORIZED LIBRARY
*                                       TABLE                  MDC188*/
*    2 CVTACTAP PTR(31),             /* ADDRESS OF BRANCH ENTRY TO
*                                       VTAM'S SVC ROUTINE ISTAPC42
*                                       (MDC216)             @X31BH9A*/
*    2 CVTRV485 PTR(31),             /* RESERVED               MDC106*/
*    2 CVTRV486 PTR(31),             /* RESERVED               MDC106*/
*    2 CVTRV487 PTR(31),             /* RESERVED               MDC106*/
*    2 CVTRV488 PTR(31);             /* RESERVED               MDC106*/
*                                                               01S0021
* /*           OS/VS2 OVERLAY                                        */
*                                                               01S0022
* DECLARE                                                       01S0022
*   1 CVTS01   DEF(CVTPGSIA) BDY(WORD),                         01S0022
*    2 CVTGETL  PTR(31),             /* ADDRESS OF IKJGETL, TSO GET
*                                       LINE ROUTINE (MDC206)  YM2225*/
*    2 CVTLPDSR PTR(31),             /* ADDRESS OF LINK PACK AREA
*                                       (LPA) DIRECTORY SEARCH  01S0022
*                                       ROUTINE                      */
*    2 CVTPVTP  PTR(31),             /* ADDRESS OF PAGE VECTOR TABLE */
*    2 CVTLPDIA PTR(31),             /* ADDRESS OF LINK PACK AREA
*                                       (LPA) DIRECTORY (ON PAGE
*                                       BOUNDARY)                    */
*     3 CVTDIRST CHAR(1),            /* FLAG BYTE                    */
*      4 CVTDICOM BIT(1),            /* LPA DIRECTORY HAS BEEN  01S0022
*                                       INITIALIZED BY NIP           */
*      4 CVTRSV63 BIT(1),            /* RESERVED                     */
*      4 CVTRSV64 BIT(1),            /* RESERVED                     */
*      4 CVTRSV65 BIT(1),            /* RESERVED                     */
*      4 CVTRSV66 BIT(1),            /* RESERVED                     */
*      4 CVTRSV67 BIT(1),            /* RESERVED                     */
*      4 CVTRSV68 BIT(1),            /* RESERVED                     */
*      4 CVTRSV69 BIT(1),            /* RESERVED                     */
*     3 CVTLPDIR PTR(24),            /* ADDRESS OF LPA DIRECTORY.
*                                       ON PAGE BOUNDARY             */
*    2 CVTRV320 PTR(31),             /* ** CVTPAGE1 FIELD UNUSED IN
*                                       MVS **  (MDC112)     @Z40AQ9A*/
*    2 CVTRV321 PTR(31),             /* ** CVTPGSUP FIELD UNUSED IN
*                                       MVS **  (MDC113)     @Z40AQ9A*/
*    2 CVTSLIDA CHAR(4) BDY(WORD),   /* IDENTITY OF TCB CAUSING 01S0022
*                                       SUPERVISOR LOCK BYTE (CVTSYLK)
*                                       TO BE SET OR IDENTITY OF TCB
*                                       THAT SECOND EXIT PROCESSING
*                                       IS FOR WHEN CVTSEIC=1        */
*     3 CVTSYLK  CHAR(1),            /* SUPERVISOR LOCK.  ONLY  01S0022
*                                       ENABLED TASKS MAY BE    01S0022
*                                       DISPATCHED                   */
*     3 CVTSLID  CHAR(3),            /* SAME AS CVTSLIDA ABOVE       */
*    2 CVTRV322 PTR(31),             /* RESERVED FOR FUTURE USE 01S0022
*                                       (MDC343)             @Z40AQ9A*/
*    2 CVTRV328 PTR(31),             /* ** CVTSEG AND CVTSEGA FIELDS
*                                       UNUSED IN MVS **        01S0022
*                                       (MDC139)             @Z40AQ9A*/
*    2 CVTRV329 PTR(31),             /* ** CVTSEGB FIELD UNUSED IN
*                                       MVS **  (MDC141)     @Z40AQ9A*/
*    2 CVTRV330 PTR(31),             /* ** CVTSEGC AND SUBFIELDS
*                                       UNUSED IN MVS **        01S0022
*                                       (MDC142)             @Z40AQ9A*/
*    2 CVTRV331 PTR(31),             /* ** CVTSEGD AND SUBFIELDS
*                                       UNUSED IN MVS **        01S0022
*                                       (MDC145)             @Z40AQ9A*/
*    2 CVTRSV77 PTR(8),              /* RESERVED                     */
*    2 CVTSPVLK PTR(8),              /* NUMBER OF TASKS WHICH HAVE
*                                       TERMINATED WHILE OWNING 01S0022
*                                       SUPERVISOR LOCK WITHOUT 01S0022
*                                       OPERATOR HAVING YET BEEN
*                                       NOTIFIED                     */
*    2 CVTCTLFG CHAR(1),             /* SYSTEM CONTROL FLAGS         */
*     3 CVTRV323 BIT(1),             /* ** CVTPSIC BIT UNUSED IN
*                                       MVS **  (MDC118)     @Z40AQ9A*/
*     3 CVTRV333 BIT(1),             /* ** CVTAPGB BIT UNUSED IN
*                                       MVS **  (MDC151)     @Z40AQ9A*/
*     3 CVTRSV78 BIT(1),             /* RESERVED               ICB382*/
*     3 CVTDSTAT BIT(1),             /* DEVSTAT OPTION IN EFFECT.
*                                       DEVICE ADDRESS FOR 2319,
*                                       3330, 2314, 3330-1, 3340 CAN
*                                       VARY ACROSS SYSTEMS    MDC189*/
*     3 CVTRSV79 BIT(1),             /* RESERVED                     */
*     3 CVTNOMP  BIT(1),             /* MULTIPROCESSING CODE IS NOT
*                                       IN THE SYSTEM          MDC176*/
*     3 CVTGTRCE BIT(1),             /* GENERALIZED TRACE FACILITY
*                                       (GTF) HAS SUPPRESSED    01S0022
*                                       SUPERVISOR TRACE       ICB446*/
*     3 CVTSDTRC BIT(1),             /* SVC DUMP HAS SUPPRESSED 01S0022
*                                       SUPERVISOR TRACE       ICB446*/
*    2 CVTAPG   CHAR(1),             /* DISPATCHING PRIORITY OF 01S0022
*                                       AUTOMATIC PRIORITY GROUP
*                                       (APG)                  ICB339*/
*    2 CVTTRACE CHAR(2) BDY(WORD),   /* BRANCH ON REGISTER      01S0022
*                                       INSTRUCTION.  SET BY NIP.
*                                       REGISTER TEN FOR TRACE. 01S0022
*                                       REGISTER ELEVEN FOR NO TRACE.*/
*    2 CVTTRAC2 CHAR(2) BDY(WORD,3), /* BRANCH ON REGISTER 11   01S0022
*                                       INSTRUCTION.  THIS ALLOWS FOR
*                                       SUPPRESSING TRACE DYNAMICALLY
*                                       BY SETTING CONDITION CODE
*                                       MASK TO ZERO IN FIRST   01S0022
*                                       INSTRUCTION  (CVTTRACE)      */
*    2 CVTRSCN  PTR(31),             /* ADDRESS OF ROUTINE TO SCAN
*                                       TCB TREE                     */
*    2 CVTTAS   PTR(31),             /* ADDRESS OF ROUTINE TO   01S0022
*                                       TRANSFER ADDRESS SPACE       */
*    2 CVTRV332 PTR(31),             /* ** CVTPVALD FIELD UNUSED IN
*                                       MVS **  (MDC148)     @Z40AQ9A*/
*    2 CVTSHRVM PTR(31),             /* LOWEST ADDRESS OF SHARED
*                                       VIRTUAL STORAGE AREA.  THIS
*                                       ADDRESS WILL BE THE     01S0022
*                                       BEGINNING OF THE COMMON 01S0022
*                                       SERVICE AREA (CSA)      01S0022
*                                       (MDC324)             @Z30AQ9A*/
*    2 CVT0VL01 PTR(31),             /* ENTRY POINT ADDRESS OF  01S0022
*                                       VALIDITY CHECK ROUTINE  01S0022
*                                       (IEA0VL01) USED TO COMPARE
*                                       PROTECT KEY OF AN ADDRESS
*                                       WITH TCB PROTECT KEY.        */
*    2 CVTRV324 PTR(31),             /* ** CVTPFIXQ FIELD UNUSED IN
*                                       MVS **  (MDC119)     @Z40AQ9A*/
*    2 CVTRV325 PTR(31),             /* ** CVTPFIXR FIELD UNUSED IN
*                                       MVS **  (MDC120)     @Z40AQ9A*/
*    2 CVTRV326 PTR(31),             /* ** CVTPFIXP FIELD UNUSED IN
*                                       MVS **  (MDC121)     @Z40AQ9A*/
*    2 CVTASCRF PTR(31),             /* CREATED ASCB QUEUE HEADER
*                                       (MDC337)             @ZA04120*/
*    2 CVTASCRL PTR(31),             /* CREATED ASCB QUEUE TRAILER
*                                       (MDC338)             @ZA04120*/
*    2 CVTPUTL  PTR(31),             /* ADDRESS OF IKJPUTL, TSO PUT
*                                       LINE ROUTINE (MDC207)  YM2225*/
*    2 CVTSRBRT PTR(31),             /* DISPATCHER RETURN ADDRESS FOR
*                                       SRB ROUTINES           MDC130*/
*    2 CVTOLT0A PTR(31),             /* BRANCH ENTRY TO OLTEP MEMORY
*                                       TERMINATION RESOURCE MANAGER
*                                                              MDC129*/
*    2 CVTSMFEX PTR(31),             /* BRANCH ENTRY TO SYSTEM  01S0022
*                                       MANAGEMENT FACILITIES (SMF)
*                                       EXCP COUNTING ROUTINE FOR
*                                       VAM WINDOW INTERCEPT   MDC133*/
*    2 CVTCSPIE PTR(31),             /* FOR CHECKPOINT/RESTART, BRANCH
*                                       ENTRY TO SPIE          MDC149*/
*    2 CVTPTGT  PTR(31),             /* ADDRESS OF IKJPTGT, TSO 01S0022
*                                       PUTGET ROUTINE  (MDC208)
*                                                              YM2225*/
*    2 CVTIOSPL PTR(8),              /* PRIORITY LEVEL OF I/O   01S0022
*                                       SUPERVISOR CHANNEL SCHEDULER
*                                                              MDC019*/
*    2 CVTRV513 CHAR(1),             /* RESERVED               MDC165*/
*    2 CVTDSSAC CHAR(1),             /* DYNAMIC SUPPORT SYSTEM (DSS)
*                                       ACTIVATED FLAG - USED BY
*                                       RESTART FLIH.  IF X'00', DSS
*                                       NOT INITIALIZED.  IF X'FF',
*                                       DSS HAS BEEN INITIALIZED.
*                                                              MDC163*/
*    2 CVTRV139 PTR(8),              /* RESERVED                     */
*    2 CVTSTCK  PTR(31),             /* ADDRESS OF IKJSTCK, TSO STACK
*                                       ROUTINE  (MDC209)      YM2225*/
*    2 CVTMAXMP PTR(15),             /* FOR MEASUREMENT FACILITY
*                                       (MF/1), MAXIMUM PHYSICAL
*                                       CPU ADDRESS SUPPORTED BY
*                                       THIS RELEASE           MDC165*/
*    2 CVTRV144 FIXED(15),           /* RESERVED                     */
*    2 CVTSCAN  PTR(31),             /* ADDRESS OF IKJSCAN, TSO SCAN
*                                       ROUTINE  (MDC210)      YM2225*/
*    2 CVTAUTHL PTR(31),             /* POINTER TO AUTHORIZED   01S0022
*                                       LIBRARY TABLE          MDC001*/
*    2 CVTBLDCP PTR(31),             /* BRANCH ENTRY TO BUILD POOL
*                                                              MDC003*/
*    2 CVTGETCL PTR(31),             /* BRANCH ENTRY TO GET CELL
*                                                              MDC004*/
*    2 CVTFRECL PTR(31),             /* BRANCH ENTRY TO FREE CELL
*                                                              MDC005*/
*    2 CVTDELCP PTR(31),             /* BRANCH ENTRY TO DELETE POOL
*                                                              MDC006*/
*    2 CVTCRMN  PTR(31),             /* BRANCH ENTRY TO SVC 120 01S0022
*                                       (GETMAIN/FREEMAIN:CRBRANCH)
*                                                              MDC007*/
*    2 CVTCRAS  PTR(31),             /* BRANCH ENTRY TO 'CREATE 01S0022
*                                       ADDRESS SPACE'         MDC008*/
*    2 CVTQSAS  PTR(31),             /* BRANCH ENTRY TO TASK    01S0022
*                                       TERMINATION            MDC009*/
*    2 CVTFRAS  PTR(31),             /* BRANCH ENTRY TO FREE    01S0022
*                                       ADDRESS SPACE          MDC010*/
*    2 CVTS1EE  PTR(31),             /* BRANCH ENTRY TO STAGE 1 EXIT
*                                       EFFECTOR               MDC011*/
*    2 CVTPARS  PTR(31),             /* ADDRESS OF IKJPARS, TSO PARSE
*                                       ROUTINE  (MDC211)      YM2225*/
*    2 CVTQUIS  PTR(31),             /* BRANCH ENTRY TO QUIESCE 01S0022
*                                                              MDC013*/
*    2 CVTSTXU  PTR(31),             /* BRANCH ENTRY TO ATTENTION
*                                       EXIT EPILOGUE          MDC014*/
*    2 CVTOPTE  PTR(31),             /* BRANCH ENTRY ADDRESS TO 01S0022
*                                       SYSEVENT               MDC015*/
*    2 CVTSDRM  PTR(31),             /* BRNACH ENTRY ADDRESS OF THE
*                                       RESOURCE MANAGER ROUTINE FOR
*                                       SVC DUMP.  THIS ROUTINE CAN
*                                       BE INVOKED BY MEMORY    01S0022
*                                       TERMINATION            MDC077*/
*    2 CVTIOSCS PTR(31),             /* ENTRY POINT OF I/O SUPERVISOR
*                                       CHANNEL SCHEDULER      MDC018*/
*    2 CVTAQTOP PTR(31),             /* POINTER TO AREA CONTAINING
*                                       QUIESCE DESCRIPTOR BLOCK
*                                       (QDB'S) FOR DEVICE ALLOCATION
*                                                              MDC021*/
*    2 CVTVVMDI PTR(31),             /* CONSTANT USED BY PAGED LINK
*                                       PACK AREA (LPA) DIRECTORY
*                                       SEARCH ALGORITHM       MDC022*/
*    2 CVTASVT  PTR(31),             /* POINTER TO ADDRESS SPACE
*                                       VECTOR TABLE (ASVT)    MDC070*/
*    2 CVTGDA   PTR(31),             /* POINTER TO GLOBAL DATA AREA
*                                       (GDA) IN SQA           MDC024*/
*    2 CVTASCBH PTR(31),             /* POINTER TO HIGHEST PRIORITY
*                                       ADDRESS SPACE CONTROL BLOCK
*                                       (ASCB) ON THE ASCB      01S0022
*                                       DISPATCHING QUEUE (HEAD OF
*                                       ASCB QUEUE)           MDC027*/
*    2 CVTASCBL PTR(31),             /* POINTER TO LOWEST PRIORITY
*                                       ASCB ON ASCB DISPATCHING QUEUE
*                                                              MDC028*/
*    2 CVTRTMCT PTR(31),             /* POINTER TO RECOVERY/TERMINATION
*                                       CONTROL TABLE          MDC031*/
*    2 CVTSV60  PTR(31),             /* ADDRESS OF SVC 60 BRANCH ENTRY
*                                       POINT  (MDC354)      @Z40FP9A*/
*    2 CVTSDMP  PTR(31),             /* ADDRESS OF SVC DUMP BRANCH
*                                       ENTRY POINT            MDC033*/
*    2 CVTSCBP  PTR(31),             /* ADDRESS OF SCB PURGE RESOURCE
*                                       MANAGER                MDC034*/
*    2 CVTSDBF  PTR(31),             /* ADDRESS OF 4K SQA BUFFER USED
*                                       BY SVC DUMP.  HIGH ORDER BIT
*                                       OF THIS CVT WORD IS USED AS
*                                       LOCK TO INDICATE BUFFER IS IN
*                                       USE                    MDC035*/
*    2 CVTRTMS  PTR(31),             /* RTM1 INTERNAL SERVICABILITY
*                                       LEVEL INDICATOR        MDC036*/
*    2 CVTTPIOS PTR(31),             /* ADDRESS OF THE TELEPROCESSING
*                                       I/O SUPERV1SOR ROUTINE  01S0022
*                                       (TPIOS)                MDC078*/
*    2 CVTSIC   PTR(31),             /* BRANCH ENTRY ADDRESS OF THE
*                                       ROUTINE TO SCHEDULE SYSTEM
*                                       INITIALIZED CANCEL     MDC042*/
*    2 CVTOPCTP PTR(31),             /* ADDRESS OF SYSTEM RESOURCES
*                                       MANAGER (SRM) CONTROL TABLE
*                                                              MDC043*/
*    2 CVTEXPRO PTR(31),             /* ADDRESS OF EXIT PROLOGUE/TYPE
*                                       1 EXIT                 MDC044*/
*    2 CVTGSMQ  PTR(31),             /* ADDRESS OF GLOBAL SERVICE
*                                       MANAGER QUEUE          MDC045*/
*    2 CVTLSMQ  PTR(31),             /* ADDRESS OF LOCAL SERVICE
*                                       MANAGER QUEUE          MDC046*/
*    2 CVTGSPL  PTR(31),             /* ADDRESS OF GLOBAL SYSTEM
*                                       PRIORITY LIST QUEUE    MDC047*/
*    2 CVTVWAIT PTR(31),             /* ADDRESS OF WAIT ROUTINE 01S0022
*                                                              MDC048*/
*    2 CVTPARRL PTR(31),             /* ADDRESS OF PARTIALLY LOADED
*                                       DELETE QUEUE           MDC049*/
*    2 CVTAPFT  PTR(31),             /* ADDRESS OF AUTHORIZED PROGRAM
*                                       FACILITY (APF) TABLE.   01S0022
*                                       INITIALIZED BY NIP.    MDC050*/
*    2 CVTQCS01 PTR(31),             /* BRANCH ENTRY ADDRESS TO 01S0022
*                                       PROGRAM MANAGER USED BY 01S0022
*                                       ATTACH                 MDC051*/
*    2 CVTFQCB  PTR(31),             /* POINTER TO FIRST MAJOR QCB
*                                       FOR ENQ                MDC052*/
*    2 CVTLQCB  PTR(31),             /* POINTER TO LAST MAJOR QCB
*                                       FOR ENQ                MDC053*/
*    2 CVTRENQ  PTR(31),             /* RESOURCE MANAGER ADDRESS
*                                       FOR ENQ                MDC054*/
*    2 CVTRSPIE PTR(31),             /* RESOURCE MANAGER FOR SPIE
*                                                              MDC055*/
*    2 CVTLKRMA PTR(31),             /* RESOURCE MANAGER ADDRESS FOR
*                                       LOCK MANAGER           MDC056*/
*    2 CVTCSD   PTR(31),             /* VIRTUAL ADDRESS OF COMMON
*                                       SYSTEM DATA AREA (CSD). 01S0022
*                                       INITIALIZED BY NIP.    MDC057*/
*    2 CVTDQIQE PTR(31),             /* RESOURCE MANAGER FOR EXIT
*                                       EFFECTORS              MDC058*/
*    2 CVTRPOST PTR(31),             /* RESOURCE MANAGER FOR POST
*                                                              MDC059*/
*    2 CVT062R1 PTR(31),             /* BRANCH ENTRY TO DETACH MDC060*/
*    2 CVTVEAC0 PTR(31),             /* ASCBCHAP BRANCH ENTRY  MDC061*/
*    2 CVTGLMN  PTR(31),             /* GLOBAL BRANCH ENTRY ADDRESS
*                                       FOR GETMAIN/FREEMAIN   MDC062*/
*    2 CVTSPSA  PTR(31),             /* POINTER TO GLOBAL WORK/SAVE
*                                       AREA VECTOR TABLE (WSAG)
*                                                              MDC071*/
*    2 CVTWSAL  PTR(31),             /* ADDRESS OF TABLE OF LENGTHS
*                                       OF LOCAL WORK/SAVE AREAS
*                                                              MDC072*/
*    2 CVTRV149 PTR(31),             /* RESERVED  (MDC073)     YM4043*/
*    2 CVTWSAC  PTR(31),             /* ADDRESS OF TABLE OF LENGTHS
*                                       OF CPU WORK/SAVE AREAS MDC074*/
*    2 CVTRECRQ PTR(31),             /* ADDRESS OF THE RECORDING
*                                       REQUEST FACILITY  (PART OF
*                                       RTM1 - CALLED BY RTM2 AND
*                                       RMS)                   MDC075*/
*    2 CVTASMVT PTR(31),             /* POINTER TO AUXILIARY STORAGE
*                                       MANAGEMENT VECTOR TABLE 01S0022
*                                       (AMVT)                 MDC076*/
*    2 CVTIOBP  PTR(31),             /* ADDRESS OF THE BLOCK PROCESSOR
*                                       CVT                    MDC079*/
*    2 CVTSPOST PTR(31),             /* POST RESOURCE MANAGER   01S0022
*                                       TERMINATION ROUTINE (RMTR)
*                                       ENTRY POINT            MDC085*/
*    2 CVTRSTWD FIXED(31),           /* RESTART RESOURCE MANAGEMENT
*                                       WORD - CONTAINS IDENTIFIER OF
*                                       USER IF RESTART IS IN USE.
*                                       OTHERWISE, ZERO.       MDC161*/
*    2 CVTFETCH PTR(31),             /* ADDRESS OF ENTRY POINT FOR
*                                       BASIC FETCH            MDC196*/
*    2 CVT044R2 PTR(31),             /* ADDRESS OF IGC044R2 IN CHAP
*                                       SERVICE ROUTINE        MDC197*/
*    2 CVTPERFM PTR(31),             /* ADDRESS OF THE PERFORMANCE
*                                       WORK AREA.  SET BY IGX00018.
*                                                              MDC205*/
*    2 CVTDAIR  PTR(31),             /* ADDRESS OF IKJDAIR, TSO 01S0022
*                                       DYNAMIC ALLOCATION INTERFACE
*                                       ROUTINE  (MDC212)      YM2225*/
*    2 CVTEHDEF PTR(31),             /* ADDRESS OF IKJEHDEF, TSO
*                                       DEFAULT SERVICE ROUTINE 01S0022
*                                       (MDC213)               YM2225*/
*    2 CVTEHCIR PTR(31),             /* ADDRESS OF IKJEHCIR, TSO
*                                       CATALOG INFORMATION ROUTINE
*                                       (MDC214)               YM2225*/
*    2 CVTSSAP  PTR(31),             /* ADDRESS OF SYSTEM SAVE AREA
*                                                              MDC063*/
*    2 CVTAIDVT PTR(31),             /* POINTER TO APPENDAGE ID 01S0022
*                                       VECTOR TABLE           MDC064*/
*    2 CVTIPCDS PTR(31),             /* BRANCH ENTRY FOR DIRECT 01S0022
*                                       SIGNAL SERVICE ROUTINE MDC065*/
*    2 CVTIPCRI PTR(31),             /* BRANCH ENTRY FOR REMOTE 01S0022
*                                       IMMEDIATE SIGNAL SERVICE
*                                       ROUTINE                MDC066*/
*    2 CVTIPCRP PTR(31),             /* BRANCH ENTRY FOR REMOTE 01S0022
*                                       PENDABLE SIGNAL SERVICE 01S0022
*                                       ROUTINE                MDC067*/
*    2 CVTPCCAT PTR(31),             /* POINTER TO PHYSICAL CCA VECTOR
*                                       TABLE                  MDC068*/
*    2 CVTLCCAT PTR(31),             /* POINTER TO LOGICAL CCA VECTOR
*                                       TABLE                  MDC069*/
*    2 CVTRV210 BIT(8),              /* RESERVED                     */
*     3 CVTRV211 BIT(1),             /* RESERVED                     */
*     3 CVTRV212 BIT(1),             /* RESERVED                     */
*     3 CVTRV213 BIT(1),             /* RESERVED                     */
*     3 CVTRV214 BIT(1),             /* RESERVED                     */
*     3 CVTRV215 BIT(1),             /* RESERVED                     */
*     3 CVTRV216 BIT(1),             /* RESERVED                     */
*     3 CVTRV217 BIT(1),             /* RESERVED                     */
*     3 CVTRV218 BIT(1),             /* RESERVED                     */
*    2 CVTRV219 BIT(8),              /* RESERVED                     */
*     3 CVTRV220 BIT(1),             /* RESERVED                     */
*     3 CVTRV221 BIT(1),             /* RESERVED                     */
*     3 CVTRV222 BIT(1),             /* RESERVED                     */
*     3 CVTRV223 BIT(1),             /* RESERVED                     */
*     3 CVTRV224 BIT(1),             /* RESERVED                     */
*     3 CVTRV225 BIT(1),             /* RESERVED                     */
*     3 CVTRV226 BIT(1),             /* RESERVED                     */
*     3 CVTRV227 BIT(1),             /* RESERVED                     */
*    2 CVTRV228 BIT(8),              /* RESERVED                     */
*     3 CVTRV229 BIT(1),             /* RESERVED                     */
*     3 CVTRV230 BIT(1),             /* RESERVED                     */
*     3 CVTRV231 BIT(1),             /* RESERVED                     */
*     3 CVTRV232 BIT(1),             /* RESERVED                     */
*     3 CVTRV233 BIT(1),             /* RESERVED                     */
*     3 CVTRV234 BIT(1),             /* RESERVED                     */
*     3 CVTRV235 BIT(1),             /* RESERVED                     */
*     3 CVTRV236 BIT(1),             /* RESERVED                     */
*    2 CVTRV237 BIT(8),              /* RESERVED                     */
*     3 CVTRV238 BIT(1),             /* RESERVED                     */
*     3 CVTRV239 BIT(1),             /* RESERVED                     */
*     3 CVTRV240 BIT(1),             /* RESERVED                     */
*     3 CVTRV241 BIT(1),             /* RESERVED                     */
*     3 CVTRV242 BIT(1),             /* RESERVED                     */
*     3 CVTRV243 BIT(1),             /* RESERVED                     */
*     3 CVTRV244 BIT(1),             /* RESERVED                     */
*     3 CVTRV245 BIT(1),             /* RESERVED                     */
*    2 CVTRV246 PTR(8),              /* RESERVED                     */
*    2 CVTRV247 PTR(8),              /* RESERVED                     */
*    2 CVTRV248 PTR(8),              /* RESERVED                     */
*    2 CVTRV249 PTR(8),              /* RESERVED                     */
*    2 CVTRV250 PTR(8),              /* RESERVED                     */
*    2 CVTRV251 PTR(8),              /* RESERVED                     */
*    2 CVTRV252 PTR(15),             /* RESERVED                     */
*    2 CVTRV253 FIXED(15),           /* RESERVED                     */
*    2 CVTRV254 FIXED(15),           /* RESERVED                     */
*    2 CVTPWI   PTR(31),             /* ADDRESS OF THE WINDOW   01S0022
*                                       INTERCEPT ROUTINE      MDC104*/
*    2 CVTPVBP  PTR(31),             /* ADDRESS OF THE VIRTUAL BLOCK
*                                       PROCESSOR              MDC105*/
*    2 CVTMFCTL PTR(31),             /* POINTER TO MEASUREMENT  01S0022
*                                       FACILITY CONTROL BLOCK MDC100*/
*    2 CVTMFRTR PTR(31),             /* IF MEASUREMENT FACILITY IS
*                                       ACTIVE, CONTAINS ADDRESS OF
*                                       MEASUREMENT FACILITY ROUTER.
*                                       OTHERWISE, ADDRESS OF   01S0022
*                                       CVTBRET.               MDC101*/
*     3 CVTMFACT BIT(1),             /* IF ONE, I/O SUPERVISOR AND
*                                       TIMER SECOND LEVEL INTERRUPT
*                                       HANDLER HOOKS BRANCH TO 01S0022
*                                       MEASUREMENT FACILITY ROUTER
*                                                              MDC102*/
*    2 CVTVPSIB PTR(31),             /* BRANCH ENTRY TO PAGE SERVICES
*                                                              MDC108*/
*    2 CVTVSI   PTR(31),             /* BRANCH ENTRY TO VAM SERVICES
*                                                              MDC109*/
*    2 CVTVFP   PTR(31),             /* BRANCH ENTRY TO FINDPAGE
*                                                              MDC110*/
*    2 CVTRV262 BIT(8),              /* RESERVED                     */
*     3 CVTRV263 BIT(1),             /* RESERVED                     */
*     3 CVTRV264 BIT(1),             /* RESERVED                     */
*     3 CVTRV265 BIT(1),             /* RESERVED                     */
*     3 CVTRV266 BIT(1),             /* RESERVED                     */
*     3 CVTRV267 BIT(1),             /* RESERVED                     */
*     3 CVTRV268 BIT(1),             /* RESERVED                     */
*     3 CVTRV269 BIT(1),             /* RESERVED                     */
*     3 CVTRV270 BIT(1),             /* RESERVED                     */
*    2 CVTRV271 BIT(8),              /* RESERVED                     */
*     3 CVTRV272 BIT(1),             /* RESERVED                     */
*     3 CVTRV273 BIT(1),             /* RESERVED                     */
*     3 CVTRV274 BIT(1),             /* RESERVED                     */
*     3 CVTRV275 BIT(1),             /* RESERVED                     */
*     3 CVTRV276 BIT(1),             /* RESERVED                     */
*     3 CVTRV277 BIT(1),             /* RESERVED                     */
*     3 CVTRV278 BIT(1),             /* RESERVED                     */
*     3 CVTRV279 BIT(1),             /* RESERVED                     */
*    2 CVTRV280 BIT(8),              /* RESERVED                     */
*     3 CVTRV281 BIT(1),             /* RESERVED                     */
*     3 CVTRV282 BIT(1),             /* RESERVED                     */
*     3 CVTRV283 BIT(1),             /* RESERVED                     */
*     3 CVTRV284 BIT(1),             /* RESERVED                     */
*     3 CVTRV285 BIT(1),             /* RESERVED                     */
*     3 CVTRV286 BIT(1),             /* RESERVED                     */
*     3 CVTRV287 BIT(1),             /* RESERVED                     */
*     3 CVTRV288 BIT(1),             /* RESERVED                     */
*    2 CVTRV289 BIT(8),              /* RESERVED                     */
*     3 CVTRV290 BIT(1),             /* RESERVED                     */
*     3 CVTRV291 BIT(1),             /* RESERVED                     */
*     3 CVTRV292 BIT(1),             /* RESERVED                     */
*     3 CVTRV293 BIT(1),             /* RESERVED                     */
*     3 CVTRV294 BIT(1),             /* RESERVED                     */
*     3 CVTRV295 BIT(1),             /* RESERVED                     */
*     3 CVTRV296 BIT(1),             /* RESERVED                     */
*     3 CVTRV297 BIT(1),             /* RESERVED                     */
*    2 CVTTRCA  PTR(31),             /* ADDRESS OF TRACE TABLE  01S0022
*                                       HEADER  (MDC327)     @ZA02352*/
*    2 CVTRV302 PTR(15),             /* RESERVED                     */
*    2 CVTRV303 PTR(15),             /* RESERVED                     */
*    2 CVTRV304 FIXED(15),           /* RESERVED                     */
*    2 CVTRV305 FIXED(15),           /* RESERVED                     */
*    2 CVTRV306 FIXED(15),           /* RESERVED                     */
*    2 CVTRV307 FIXED(15),           /* RESERVED                     */
*    2 CVTVIOP  PTR(31),             /* ENTRY POINT OF PAGE I/O POST
*                                                              MDC111*/
*    2 CVTRMBR  PTR(31),             /* ADDRESS OF REGMAIN BRANCH
*                                       ENTRY                  MDC123*/
*    2 CVTLFRM  PTR(31),             /* LIST FORMAT FREEMAIN BRANCH
*                                       ENTRY POINT            MDC124*/
*    2 CVTGMBR  PTR(31),             /* LIST FORMAT GETMAIN BRANCH
*                                       ENTRY POINT            MDC125*/
*    2 CVT0TC0A PTR(31),             /* ADDRESS OF TASK CLOSE MODULE
*                                       IFG0TC0A               MDC128*/
*    2 CVTRLSTG FIXED(31),           /* SIZE OF ACTUAL REAL STORAGE
*                                       ONLINE AT IPL TIME IN 'K'.
*                                       VALUE PLACED HERE BY IEAVNIP0.
*                                                              MDC153*/
*    2 CVTSPFRR PTR(31),             /* 'SUPER FRR' ADDRESS (ADDRESS
*                                       OF FUNCTIONAL RECOVERY  01S0022
*                                       ROUTINE ESTABLISHED AT NIP0
*                                       TIME TO PROTECT SUPERVISOR
*                                       CONTROL PROGRAM)       MDC154*/
*    2 CVTVEMS0 PTR(31),             /* ADDRESS OF MEMORY SWITCH
*                                       ROUTINE                MDC155*/
*    2 CVTJRECM PTR(31),             /* ADDRESS OF SUBSYSTEM    01S0022
*                                       INTERFACE RESOURCE MANAGER
*                                                              MDC157*/
*    2 CVTIRECM PTR(31),             /* ADDRESS OF INITIATOR    01S0022
*                                       RESOURCE MANAGER       MDC158*/
*    2 CVTDARCM PTR(31),             /* ADDRESS OF DEVICE ALLOCATION
*                                       RESOURCE MANAGER       MDC159*/
*    2 CVT0PT02 PTR(31),             /* ADDRESS OF POST ENTRY POINT
*                                       IEA0PT02               MDC160*/
*    2 CVTSTPRS PTR(31),             /* ENTRY POINT OF STOP AND 01S0022
*                                       RESTART SUBROUTINE     MDC162*/
*    2 CVTWTCB  PTR(31),             /* ADDRESS OF WAIT STATE TCB
*                                                              MDC164*/
*    2 CVTVACR  PTR(31),             /* ACR/VARY CPU CHANNEL RECOVERY
*                                       ROUTINE ADDRESS.  ADDRESS
*                                       FILLED IN BY VARY CPU   01S0022
*                                       PROCESSOR.             MDC178*/
*    2 CVTQUIT  PTR(31),             /* VARY CPU SHUTDOWN ROUTINE
*                                       ADDRESS.  ADDRESS FILLED IN
*                                       BY VARY CPU PROCESSOR. MDC179*/
*    2 CVTGTFR8 PTR(31),             /* GENERALIZED TRACE FACILITY
*                                       (GTF) CONTROL REGISTER 8
*                                       INITIALIZATION ROUTINE  01S0022
*                                       ADDRESS                MDC180*/
*    2 CVTVSTOP PTR(31),             /* ADDRESS OF VARY CPU STOP CPU
*                                       ROUTINE                MDC169*/
*    2 CVTVPSA  PTR(31),             /* ADDRESS OF COPY OF SYSGEN'ED
*                                       PSA - PLACED HERE BY NIP
*                                                              MDC170*/
*    2 CVTRMPTT PTR(31),             /* ADDRESS OF ISTRAMA1, THE VTAM
*                                       RESOURCE MANAGER FOR NORMAL
*                                       AND ABNORMAL TASK TERMINATION
*                                       (MDC322)             @Z30AP9A*/
*    2 CVTRMPMT PTR(31),             /* ADDRESS OF ISTRAMA2, THE VTAM
*                                       RESOURCE MANAGER FOR NORMAL
*                                       AND ABNORMAL MEMORY     01S0022
*                                       TERMINATION (MDC323) @Z30AP9A*/
*    2 CVTEXP1  PTR(31),             /* ADDRESS OF EXIT PROLOGUE
*                                       WHICH RETURNS TO THE    01S0022
*                                       DISPATCHER             MDC173*/
*    2 CVTCSDRL PTR(31),             /* REAL ADDRESS OF COMMON SYSTEM
*                                       DATA AREA (CSD).  INITIALIZED
*                                       BY NIP.                MDC174*/
*    2 CVTSSRB  PTR(31),             /* STATUS STOP SRB ENTRY  MDC175*/
*    2 CVTRPT   PTR(31),             /* ADDRESS OF IGARPT01 MODULE OF
*                                       RADIX PARTITION TREE SERVICES.
*                                       INITIALIZED BY NIP.    MDC177*/
*    2 CVTQV1   PTR(31),             /* ADDRESS OF QUEUE VERIFICATION
*                                       FOR SINGLE THREADED QUEUES
*                                       WITH HEADERS ONLY      MDC181*/
*    2 CVTQV2   PTR(31),             /* ADDRESS OF QUEUE VERIFICATION
*                                       FOR SINGLE THREADED QUEUES
*                                       WITH HEADER AND TRAILER 01S0022
*                                                              MDC182*/
*    2 CVTQV3   PTR(31),             /* ADDRESS OF QUEUE VERIFICATION
*                                       FOR DOUBLE THREADED QUEUES
*                                                              MDC183*/
*    2 CVTGSDA  PTR(31),             /* ADDRESS OF GLOBAL SYSTEM
*                                       DUPLEX AREA.  ADDRESS FILLED
*                                       IN BY NIP0.            MDC184*/
*     3 CVTGSDAB BIT(1),             /* IF HIGH-ORDER BIT IS ONE,
*                                       THERE IS A VALID VALUE IN
*                                       FOLLOWING 31 BITS      MDC185*/
*    2 CVTADV   PTR(31),             /* ADDRESS OF ADDRESS      01S0022
*                                       VERIFICATION ROUTINE   MDC186*/
*    2 CVTTPIO  PTR(31),             /* ADDRESS OF VTAM TPIO (SVC
*                                       124) ROUTINE           MDC193*/
*    2 CVTCRCA  PTR(31),             /* WHEN CHANNEL RECONFIGURATION
*                                       HARDWARE (CRH) IS ACTIVE,
*                                       ADDRESS OF CRH COMMUNICATION
*                                       AREA IECVCRCA.  OTHERWISE,
*                                       ZERO.  (MDC306)      @Z30CQ9A*/
*    2 CVTEVENT PTR(31),             /* BRANCH ENTRY ADDRESS TO 01S0022
*                                       EVENTS (FAST MULTIPLE WAIT
*                                       ROUTINE)  (MDC316)   @Z30HP9A*/
*    2 CVTSSCR  PTR(31),             /* ADDRESS OF STORAGE SYSTEM
*                                       CONTROLLER RECOVERY MANAGER
*                                       CLEANUP ROUTINE (SSC RMCR)
*                                       (MDC319)             @Z30LP9A*/
*    2 CVTCBBR  PTR(31),             /* BRANCH ENTRY ADDRESS TO 01S0022
*                                       GETMAIN/FREEMAIN        01S0022
*                                       (MDC325)             @Z30EN9A*/
*    2 CVTEFF02 PTR(31),             /* ADDRESS OF IKJEFF02, TSO
*                                       MESSAGE ISSUER SERVICE  01S0022
*                                       ROUTINE  (MDC326)    @ZM30972*/
*    2 CVTRV604 PTR(31),             /* RESERVED  (MDC307)   @Z30AQ9A*/
*    2 CVTRV605 PTR(31),             /* RESERVED  (MDC307)   @Z30AQ9A*/
*    2 CVTRV606 PTR(31),             /* RESERVED  (MDC307)   @Z30AQ9A*/
*    2 CVTRAC   PTR(31),             /* ADDRESS OF ACCESS CONTROL CVT
*                                       (MDC320)             @Z40RP9A*/
*    2 CVTCGK   PTR(31),             /* ADDRESS OF ROUTINE USED TO
*                                       CHANGE THE KEY OF VIRTUAL
*                                       PAGES  (MDC331)      @Z40EP9A*/
*    2 CVTRV609 PTR(31),             /* RESERVED  (MDC332)   @Z40AQ9A*/
*    2 CVT0PT0E PTR(31),             /* ENTRY POINT TO IDENTIFY POST
*                                       EXIT ROUTINES           01S0022
*                                       (MDC334)             @Z40EP9A*/
*    2 CVT0PT03 PTR(31),             /* POST REINVOCATION ENTRY POINT
*                                       FROM POST EXIT ROUTINES 01S0022
*                                       (MDC335)             @Z40EP9A*/
*    2 CVTTCASP PTR(31),             /* RESERVED FOR FUTURE USE 01S0022
*                                       (MDC336)             @Z40DQ9A*/
*    2 CVTRV613 PTR(31),             /* RESERVED  (MDC307)   @Z30AQ9A*/
*    2 CVTRV614 PTR(31),             /* RESERVED  (MDC307)   @Z30AQ9A*/
*    2 CVTRV615 PTR(31),             /* RESERVED  (MDC307)   @Z30AQ9A*/
*    2 CVTRV616 PTR(31),             /* RESERVED  (MDC307)   @Z30AQ9A*/
*    2 CVTRV617 PTR(31),             /* RESERVED  (MDC307)   @Z30AQ9A*/
*    2 CVTRV618 PTR(31),             /* RESERVED  (MDC307)   @Z30AQ9A*/
*    2 CVTRV619 PTR(31),             /* RESERVED  (MDC307)   @Z30AQ9A*/
*    2 CVTIHASU PTR(31),             /* ADDRESS OF BIT STRING   01S0022
*                                       (MDC355)             @Z404P9A*/
*    2 CVTRV621 PTR(31),             /* RESERVED  (MDC307)   @Z30AQ9A*/
*    2 CVTRV622 PTR(31),             /* RESERVED  (MDC307)   @Z30AQ9A*/
*    2 CVTRV623 PTR(31),             /* RESERVED  (MDC307)   @Z30AQ9A*/
*    2 CVTRV624 PTR(31),             /* RESERVED  (MDC307)   @Z30AQ9A*/
*    2 CVTRV625 PTR(31),             /* RESERVED  (MDC307)   @Z30AQ9A*/
*    2 CVTRV626 PTR(31),             /* RESERVED  (MDC307)   @Z30AQ9A*/
*    2 CVTRV627 PTR(31),             /* RESERVED  (MDC307)   @Z30AQ9A*/
*    2 CVTRV628 PTR(31);             /* RESERVED  (MDC307)   @Z30AQ9A*/
*                                                               01S0022
* /*                                                                 */
* /*           OS - OS/VS COMMON EXTENSION                           */
* /*                                                                 */
*                                                               01S0023
* DECLARE                                                       01S0023
*   1 CVTXTNT1 BASED(CVTEXT1),       /* START OF OS - OS/VS COMMON
*                                       EXTENSION              ICB421*/
*    2 CVTFACHN PTR(31),             /* ADDRESS OF CHAIN OF DCB FIELD
*                                       AREAS (ISAM)           ICB421*/
*    2 CVTRSV87 PTR(31),             /* RESERVED                     */
*    2 CVTRSV88 PTR(31);             /* RESERVED                     */
*                                                               01S0023
* /*                                                                 */
* /*           OS/VS1 - OS/VS2 COMMON EXTENSION                      */
* /*                                                                 */
*                                                               01S0024
* DECLARE                                                       01S0024
*   1 CVTXTNT2 BASED(CVTEXT2),       /* START OF OS/VS1 - OS/VS2
*                                       EXTENSION                    */
*    2 CVTDSSV  PTR(31),             /* ADDRESS OF THE DYNAMIC  01S0024
*                                       SUPPORT SYSTEM (DSS) VECTOR
*                                       TABLE                  ICB313*/
*     3 CVTRSV89 PTR(8),             /* RESERVED               ICB313*/
*     3 CVTDSSVA PTR(24),            /* ADDRESS OF THE DSS VECTOR
*                                       TABLE                  ICB313*/
*    2 CVTNUCLS CHAR(1),             /* IDENTIFICATION OF THE NUCLEUS
*                                       MEMBER NAME            ICB322*/
*    2 CVTFLGBT BIT(8),              /* FLAG BYTE  (OS/VS1)     01S0024
*                                       (MDC301)             @X04EP9A*/
*     3 CVTNPE   BIT(1),             /* INDICATES NON-PAGING    01S0024
*                                       ENVIRONMENT (VM HANDSHAKING)
*                                       (OS/VS1)  (MDC302)   @X04EP9A*/
*     3 CVTVME   BIT(1),             /* INDICATES MACHINE IS    01S0024
*                                       OPERATING IN VM ENVIRONMENT
*                                       (OS/VS1)  (MDC303)   @X04EP9A*/
*     3 CVTRSV9C BIT(1),             /* RESERVED                     */
*     3 CVTRSV9D BIT(1),             /* RESERVED                     */
*     3 CVTRSV9E BIT(1),             /* RESERVED                     */
*     3 CVTRSV9F BIT(1),             /* RESERVED                     */
*     3 CVTRSV9G BIT(1),             /* RESERVED                     */
*     3 CVTRSV9H BIT(1),             /* RESERVED                     */
*    2 CVTRSV91 FIXED(15),           /* RESERVED                     */
*    2 CVTDEBVR PTR(31),             /* ADDRESS OF BRANCH ENTRY POINT
*                                       OF DEB VALIDITY CHECK ROUTINE
*                                       (ICB380)               XM9028*/
*    2 CVTRSV92 PTR(31),             /* RESERVED  (MDC190)     YM2278*/
*    2 CVTRSV93 PTR(31),             /* RESERVED                     */
*    2 CVTRSV94 PTR(31),             /* RESERVED                     */
*    2 CVTQID   PTR(31),             /* SAVE AS CVTQIDA BELOW  ICB381*/
*     3 CVTRSV95 PTR(8),             /* RESERVED               ICB381*/
*     3 CVTQIDA  PTR(24),            /* ADDRESS OF QUEUE        01S0024
*                                       IDENTIFICATION (QID) TABLE
*                                       PREFIX                 ICB381*/
*    2 CVTOLTEP PTR(31),             /* POINTER TO CONTROL BLOCK
*                                       CREATED BY SVC 59 TO POINT TO
*                                       PSEUDO-DEB'S           ICB423*/
*    2 CVTRSV96 FIXED(15),           /* RESERVED                     */
*    2 CVTRSV97 FIXED(15),           /* RESERVED                     */
*    2 CVTRSV98 PTR(31),             /* RESERVED                     */
*    2 CVTRSV99 PTR(31),             /* RESERVED  (MDC329)   @Z40AQ9A*/
*    2 CVTSKTA  PTR(31),             /* ADDRESS OF STORAGE KEY TABLE
*                                       (VM HANDSHAKING)  (OS/VS1)
*                                       (MDC304)             @X04EP9A*/
*    2 CVTICB   PTR(31),             /* ADDRESS OF MASS STORAGE 01S0024
*                                       SYSTEM (MSS) CONTROL BLOCK
*                                       (MDC305)             @Z30LP9A*/
*    2 CVTRV400 BIT(8),              /* RESERVED                     */
*     3 CVTRV401 BIT(1),             /* RESERVED                     */
*     3 CVTRV402 BIT(1),             /* RESERVED                     */
*     3 CVTRV403 BIT(1),             /* RESERVED                     */
*     3 CVTRV404 BIT(1),             /* RESERVED                     */
*     3 CVTRV405 BIT(1),             /* RESERVED                     */
*     3 CVTRV406 BIT(1),             /* RESERVED                     */
*     3 CVTRV407 BIT(1),             /* RESERVED                     */
*     3 CVTRV408 BIT(1),             /* RESERVED                     */
*    2 CVTRV409 BIT(8),              /* RESERVED                     */
*     3 CVTRV410 BIT(1),             /* RESERVED                     */
*     3 CVTRV411 BIT(1),             /* RESERVED                     */
*     3 CVTRV412 BIT(1),             /* RESERVED                     */
*     3 CVTRV413 BIT(1),             /* RESERVED                     */
*     3 CVTRV414 BIT(1),             /* RESERVED                     */
*     3 CVTRV415 BIT(1),             /* RESERVED                     */
*     3 CVTRV416 BIT(1),             /* RESERVED                     */
*     3 CVTRV417 BIT(1),             /* RESERVED                     */
*    2 CVTRV418 PTR(8),              /* RESERVED                     */
*    2 CVTRV419 PTR(8),              /* RESERVED                     */
*    2 CVTRV420 PTR(15),             /* RESERVED                     */
*    2 CVTRV421 FIXED(15),           /* RESERVED                     */
*    2 CVTRV422 FIXED(15),           /* RESERVED                     */
*    2 CVTRV423 FIXED(15),           /* RESERVED                     */
*    2 CVTATCVT PTR(31),             /* POINTER TO VTAM'S CVT  MDC080*/
*     3 CVTATACT BIT(1),             /* IF ON, VTAM IS ACTIVE  MDC081*/
*    2 CVTRV425 PTR(31),             /* RESERVED                     */
*    2 CVTRV426 PTR(31),             /* RESERVED                     */
*    2 CVTRV427 PTR(31),             /* RESERVED                     */
*    2 CVTRV428 FIXED(31),           /* RESERVED                     */
*    2 CVTRV429 BIT(8),              /* RESERVED                     */
*     3 CVTRV430 BIT(1),             /* RESERVED                     */
*     3 CVTRV431 BIT(1),             /* RESERVED                     */
*     3 CVTRV432 BIT(1),             /* RESERVED                     */
*     3 CVTRV433 BIT(1),             /* RESERVED                     */
*     3 CVTRV434 BIT(1),             /* RESERVED                     */
*     3 CVTRV435 BIT(1),             /* RESERVED                     */
*     3 CVTRV436 BIT(1),             /* RESERVED                     */
*     3 CVTRV437 BIT(1),             /* RESERVED                     */
*    2 CVTRV438 BIT(8),              /* RESERVED                     */
*     3 CVTRV439 BIT(1),             /* RESERVED                     */
*     3 CVTRV440 BIT(1),             /* RESERVED                     */
*     3 CVTRV441 BIT(1),             /* RESERVED                     */
*     3 CVTRV442 BIT(1),             /* RESERVED                     */
*     3 CVTRV443 BIT(1),             /* RESERVED                     */
*     3 CVTRV444 BIT(1),             /* RESERVED                     */
*     3 CVTRV445 BIT(1),             /* RESERVED                     */
*     3 CVTRV446 BIT(1),             /* RESERVED                     */
*    2 CVTRV447 PTR(8),              /* RESERVED                     */
*    2 CVTRV448 PTR(8),              /* RESERVED                     */
*    2 CVTRV449 PTR(15),             /* RESERVED                     */
*    2 CVTRV450 FIXED(15),           /* RESERVED                     */
*    2 CVTRV451 FIXED(15),           /* RESERVED                     */
*    2 CVTRV452 FIXED(15),           /* RESERVED                     */
*    2 CVTRV453 PTR(31),             /* RESERVED                     */
*    2 CVTRV454 PTR(31),             /* RESERVED                     */
*    2 CVTRV455 PTR(31),             /* RESERVED                     */
*    2 CVTRV456 PTR(31),             /* RESERVED                     */
*    2 CVTRV457 BIT(8),              /* RESERVED                     */
*     3 CVTRV458 BIT(1),             /* RESERVED                     */
*     3 CVTRV459 BIT(1),             /* RESERVED                     */
*     3 CVTRV460 BIT(1),             /* RESERVED                     */
*     3 CVTRV461 BIT(1),             /* RESERVED                     */
*     3 CVTRV462 BIT(1),             /* RESERVED                     */
*     3 CVTRV463 BIT(1),             /* RESERVED                     */
*     3 CVTRV464 BIT(1),             /* RESERVED                     */
*     3 CVTRV465 BIT(1),             /* RESERVED                     */
*    2 CVTRV466 BIT(8),              /* RESERVED                     */
*     3 CVTRV467 BIT(1),             /* RESERVED                     */
*     3 CVTRV468 BIT(1),             /* RESERVED                     */
*     3 CVTRV469 BIT(1),             /* RESERVED                     */
*     3 CVTRV470 BIT(1),             /* RESERVED                     */
*     3 CVTRV471 BIT(1),             /* RESERVED                     */
*     3 CVTRV472 BIT(1),             /* RESERVED                     */
*     3 CVTRV473 BIT(1),             /* RESERVED                     */
*     3 CVTRV474 BIT(1),             /* RESERVED                     */
*    2 CVTRV475 PTR(8),              /* RESERVED                     */
*    2 CVTRV476 PTR(8),              /* RESERVED                     */
*    2 CVTRV477 PTR(8),              /* RESERVED                     */
*    2 CVTRV478 PTR(8),              /* RESERVED                     */
*    2 CVTRV479 FIXED(15),           /* RESERVED                     */
*    2 CVTRV480 PTR(31),             /* RESERVED                     */
*    2 CVTRV481 PTR(31),             /* RESERVED                     */
*    2 CVTRV482 PTR(31);             /* RESERVED                     */
*                                                               01S0024
* /*                      CVT PREFIX                                 */
*                                                               01S0025
*    DCL 1 CVTFIX BASED(CVTPTR-256) BDY(WORD),                  01S0025
*    2 *        CHAR(248) BDY(WORD), /* RESERVED                     */
*    2 *        CHAR(2) BDY(WORD),   /* RESERVED                     */
*    2 CVTMDL   CHAR(2) BDY(WORD,3), /* CPU MODEL NUMBER IN SIGNLESS
*                                       PACKED DECIMAL, I.E., A MODEL
*                                       145 WOULD BE REPRESENTED AS
*                                       0145 HEX                     */
*    2 CVTRELNO CHAR(4) BDY(WORD),   /* RELEASE NUMBER (EBCDIC)      */
*     3 CVTNUMB  CHAR(2) BDY(WORD),  /* RELEASE NUMBER               */
*     3 CVTLEVL  CHAR(2) BDY(WORD,3);/* LEVEL NUMBER OF THIS RELEASE */
*                                                               01S0025
* /*                   END OF CVT MACRO                              */
*                                                               01S0026
*                                                               01S0026
*                                                               01S0026
*/* **************************************************************** */
*/*                                                                  */
*/*            ADDRESS SPACE VECTOR TABLE                            */
*/*                                                                  */
*/*  OS/VS2 RELEASE 4, 04/22/75, LEVEL=1                             */
*/*                                                                  */
*/*  METHOD OF ACCESS                                                */
*/*      BAL  - DSECT IS PRODUCED UNLESS DSECT=NO IS SPECIFIED.      */
*/*             USING ON ASVT GIVES ADDRESSABILITY FOR ALL SYMBOLS.  */
*/*      PL/S - DCL ASVTPTR PTR                                      */
*/*                                                                  */
*/* **************************************************************** */
*                                                               01S0026
*DCL 1 ASVT     BASED(ASVTPTR) BDY(DWORD),                      01S0026
*      2 * CHAR(512),             /* RESERVED FOR FUTURE EXPANSION   */
*      2 ASVTBEGN CHAR(0)         /* BEGINNING OF ASVT               */
*        BDY (DWORD),                                           01S0026
*      2 ASVTASVT CHAR(4),        /* ACRONYM IN EBCDIC -ASVT-        */
*      2 ASVTMAXU FIXED (31),     /* MAXIMUM NUMBER OF ADDRESS SPACES*/
*      2 ASVTRS00 FIXED(31),      /* RESERVED                        */
*      2 ASVTFRST PTR (31),       /* ADDRESS OF FIRST AVAILABLE ASVT
*                                    ENTRY  (MDC300)         @Z40AQ9A*/
*        3 ASVTAVAI BIT(1),       /* BIT ONE IF ASID IS AVAILABLE AND
*                                    ZERO IF ASID IS ASSIGNED  MDC002*/
*      2 ASVTENTY (*) PTR (31),   /* ENTRY FOR EACH POSSIBLE ASID.
*                                    IF ADDRESS SPACE ASSIGNED, ENTRY
*                                    CONTAINS ADDRESS OF ASCB. IF NOT
*                                    ASSIGNED, ENTRY CONTAINS EITHER
*                                    ADDRESS OF NEXT AVAILABLE ASID
*                                    OR ZEROS WITH HIGH-ORDER BIT ON
*                                    IF LAST ENTRY.             01S0026
*                                    (MDC301)                @Z40AQ9A*/
*        3 ASVTAVAL BIT(1),       /* BIT ONE IF ASID IS AVAILABLE AND
*                                    ZERO IF ASID IS ASSIGNED        */
*      2 ASVTEND  CHAR(0) BDY(WORD); /* END OF ASVT            MDC003*/
*                                                               01S0026
*   DCL TEMP FIXED(31);                                         01S0027
*                                                               01S0027
*   /*****************************************************************/
*   /*                                                               */
*   /* RETURN CODE                                                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0028
*   DCL                                                         01S0028
*     RETCODE FIXED(31);                                        01S0028
*                                                               01S0028
*   /*****************************************************************/
*   /*                                                               */
*   /* RETURN CODE REGISTER DECLARATION                              */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0029
*   DCL                                                         01S0029
*     CODEREG REG(15);                                          01S0029
*                                                               01S0029
*   /*****************************************************************/
*   /*                                                               */
*   /* RETURN CODE VALUE FOR 'NO ERROR DETECTED'                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0030
*   DCL                                                         01S0030
*     ZERO FIXED(31) CONSTANT(0),                               01S0030
*     OK CONSTANT(0);                                           01S0030
*                                                               01S0030
*   /*****************************************************************/
*   /*                                                               */
*   /* POINTER FOR COMMON-AREA BASING                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0031
*   DCL                                                         01S0031
*     PQPTR PTR(31);                                            01S0031
*                                                               01S0031
*   /*****************************************************************/
*   /*                                                               */
*   /* PTR FOR COMMON AREA BASING.                                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0032
*   DCL                                                         01S0032
*     SQPTR PTR(31);                                            01S0032
*                                                               01S0032
*   /*****************************************************************/
*   /*                                                               */
*   /* PARAMETER MASK FROM CALLER                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0033
*   DCL                                                         01S0033
*     ENTMASK CHAR(*)BASED(AQMMASKP);                           01S0033
*                                                               01S0033
*   /*****************************************************************/
*   /*                                                               */
*   /* MASK FOR COMPARING LOGICAL OPERATION RESULTS - BINARY 0       */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0034
*   DCL                                                         01S0034
*     1 ZMASK CHAR(480)STATIC LOCAL,      /*                 @ZA15759*/
*      2 * BIT(3840)INIT('0'B);           /*                 @ZA15759*/
*                                                               01S0034
*   /*****************************************************************/
*   /*                                                               */
*   /* FLAG VALUES FOR COMMON-BLOCK STATUS BYTE POSTED WHILE IN      */
*   /* ACTIVE STATUS ( AND STILL ACTIVE )                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0035
*   DCL                                                         01S0035
*     POSTED CHAR(1)CONSTANT('P');                              01S0035
*                                                               01S0035
*   /*****************************************************************/
*   /*                                                               */
*   /* ACTIVE (NOT WAITING ON ANY OF OUR QUEUES)                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0036
*   DCL                                                         01S0036
*     ACTIVE CHAR(1)CONSTANT('E');                              01S0036
*                                                               01S0036
*   /*****************************************************************/
*   /*                                                               */
*   /* ON WAIT-FOR-DEVICE QUEUE IN WAIT STATE                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0037
*   DCL                                                         01S0037
*     WFD CHAR(1)CONSTANT('W');                                 01S0037
*                                                               01S0037
*   /*****************************************************************/
*   /*                                                               */
*   /* ON AB WAIT-FOR GROUPS QUEUE IN WAIT STATE                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0038
*   DCL                                                         01S0038
*     B CHAR(1)CONSTANT('B');                                   01S0038
*                                                               01S0038
*   /*****************************************************************/
*   /*                                                               */
*   /* ON A WAIT-F-GROUP QUEUE IN WAIT STATE                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0039
*   DCL                                                         01S0039
*     A CHAR(1)CONSTANT('A');                                   01S0039
*                                                               01S0039
*   /*****************************************************************/
*   /*                                                               */
*   /* THE ABOVE ARE ALL THE MEANINGFUL Q-ELEMENT STATES.            */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0040
*   ;                                                           01S0040
*                                                               01S0040
*   /*****************************************************************/
*   /*                                                               */
*   /* TEMP SAVE FOR 13 ACROSS SETLOCK                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0041
*   DCL                                                         01S0041
*     SV13 FIXED(31);                                           01S0041
*                                                               01S0041
*   /*****************************************************************/
*   /*                                                               */
*   /* WRKAREA TO BUILD FREEMAIN PARAMS PRIOR TO REG LOAD.           */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0042
*   DCL                                                         01S0042
*     1 TEMPS FIXED(31) BDY(WORD),                              01S0042
*      2 TEMP2 FIXED(8);            /* HOLDS POOLID FOR RO HIGH END  */
*                                                               01S0042
*   /*****************************************************************/
*   /*                                                               */
*   /* HOLDER FOR RETCODE FROM SETLOCK OBTAIN                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0043
*   DCL                                                         01S0043
*     LOCKCODE FIXED(31);                                       01S0043
*   DCL                                                         01S0044
*    (R0 REG(0),                                                01S0044
*     R1 REG(1));                                               01S0044
*   DCL                                                         01S0045
*     R11 REG(11);                                              01S0045
*   DCL                                                         01S0046
*     R12 REG(12);                                              01S0046
*   DCL                                                         01S0047
*     R13 REG(13);                                              01S0047
*   DCL                                                         01S0048
*     R14 REG(14);                                              01S0048
*                                                               01S0048
*   /*****************************************************************/
*   /*                                                               */
*   /* DCL TO ALLOW TESTING IF CANCEL ECB HAS BEEN POSTED.           */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0049
*   DCL                                                         01S0049
*     1 * BIT(8)BASED(AQMCANCP),                                01S0049
*      2 * BIT(1),                                              01S0049
*      2 CANCFLAG BIT(1);                                       01S0049
*                                                               01S0049
*   /*****************************************************************/
*   /*                                                               */
*   /* RETURN CODE VALUE FOR 'CANCEL ECB WAS POSTED'                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0050
*   DCL                                                         01S0050
*     CANCEL FIXED(8)CONSTANT(16);                              01S0050
*  DCL PATCHLOC FIXED(31) STATIC;                               01S0051
* GEN DATA DEFS(PATCHLOC);                                      01S0052
*   PARA=RPARA;                                                 01S0053
         L     @12,@PC00001                                     01S0053
         L     @12,RPARA(,@12)                                  01S0053
         ST    @12,PARA                                         01S0053
*   RFY                                                         01S0054
*     AQMPARAM BASED(PARA);                                     01S0054
*                                                               01S0054
*   /*****************************************************************/
*   /*                                                               */
*   /* ROUTINE SELECTOR TABLE                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0055
*   DCL                                                         01S0055
*     ROUTINE(6)PTR(31)STATIC LOCAL INIT(ADDR(INITL),/* INITIALIZER
*                                      ROUTINE - CODE 1              */
*         ADDR(TERML),              /* TERMINATOR ROUTINE - CODE 2   */
*         ADDR(ACQUR),              /* GROUP ACQUISITION - CODE 3    */
*         ADDR(RELSE),              /* RELEASE GROUPS - CODE 4       */
*         ADDR(WAITD),              /* WAIT FOR DEVICES - CODE 5     */
*         ADDR(POSTD));             /* POST DEV AVAILABILITY - CODE 6*/
*                                                               01S0055
*   /*****************************************************************/
*   /*                                                               */
*   /* SELECT APPROPRIATE ROUTINE BASED ON ENTRY CODE                */
*   /*                                                               */
*   /*****************************************************************/
* DO; /*MODESET  KEYADDR(ZERO)*/                                01S0056
*   SPKA (ZERO); /*SET PSW KEY*/                                01S0057
         SLR   @11,@11                                          01S0057
         SPKA  0(@11)                                           01S0057
* END; /*MODESET  KEYADDR(ZERO)*/                               01S0058
*                                                               01S0058
*   GOTO ROUTINE(AQMECODE);                                     01S0059
         LH    @12,AQMECODE(,@12)                               01S0059
         SLA   @12,2                                            01S0059
         L     @12,ROUTINE-4(@12)                               01S0059
         BR    @12                                              01S0059
*                                                               01S0060
*   /*****************************************************************/
*   /*                                                               */
*   /* ATTEMPT TO ACQUIRE GROUPS SPECED IN ENTMASK FROM A LOCKS (AND */
*   /* ALSO B LOCKS IF SPECED IN AQMQCODE). IF SUCCESSFUL, MARK COMM */
*   /* BLOCK ACTIVE & RETURN. IF NOT, QUEUE UP ON A OR AB QUEUE AND  */
*   /* ISSUE WAIT. (WAIT WILL BE POSTED BY OWNER TASK WHEN ASSIGNMENT*/
*   /* IS TRANSFERRED BY RELSE.)                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0060
*ACQUR:                                                         01S0060
*   RETCODE=OK;                                                 01S0060
*                                                               01S0060
ACQUR    SLR   RETCODE,RETCODE                                  01S0060
*   /*****************************************************************/
*   /*                                                               */
*   /* BASE QUEUE BLOCK ON CALLERS PARAM BLOCK.                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0061
*   RFY                                                         01S0061
*     QMQBLK BASED(AQMQBPTR);                                   01S0061
*    RFY (R11,R12,R13,R14) RSTD;SV13=R13;GEN REFS(PSALITA);     01S0062
         LR    SV13,R13                                         01S0063
     SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,                           XX
               REGS=USE,RELATED=(ALLOC-QMGR,IEFAB4FA(UNLOCK))
     SETLOCK OBTAIN,TYPE=CMS,MODE=UNCOND,                             XX
               REGS=USE,RELATED=(ALLOC-QMGR,IEFAB4FA(UNLOCK))
*    R13=SV13;RFY (R11,R12,R13,R14) UNRSTD;                     01S0065
*                                                               01S0065
         LR    R13,SV13                                         01S0065
*   /*****************************************************************/
*   /*                                                               */
*   /* INITALIZE STATUS BYTE IN QUEUE ELEMENT TO VALUE OF SECOND BYTE*/
*   /* OF QUEUE CODE REQUESTED - A IF QCODE WAS AA, B IF QCODE WAS   */
*   /* AB. ( B RESULT ONLY IF BOTH AB REQUESTED)                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0067
*   QMSTAT=AQMQCODE(2);                                         01S0067
*                                                               01S0067
         L     @12,PARA                                         01S0067
         L     @11,AQMQBPTR(,@12)                               01S0067
         MVC   QMSTAT(1,@11),AQMQCODE+1(@12)                    01S0067
*   /*****************************************************************/
*   /*                                                               */
*   /* INIT TRIAL MASK TO ZERO.                                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0068
*   QMSKTRY(1:AQMLENGT)=ZMASK(1:AQMLENGT);/*                    01S0068
*                                                            @ZA15759*/
         L     @08,QM2PTR(,@11)                                 01S0068
         L     @07,AQMLENGT(,@12)                               01S0068
         LR    @02,@07                                          01S0068
         BCTR  @02,0                                            01S0068
         EX    @02,@SM01210                                     01S0068
*   QMSKTRY(AQMLENGT+1:2*AQMLENGT)=ZMASK(AQMLENGT+1:2*AQMLENGT);/*
*                                                            @ZA15759*/
         ALR   @07,@08                                          01S0069
         L     @01,PARA                                         01S0069
         L     @15,AQMLENGT(,@01)                               01S0069
         LR    @14,@15                                          01S0069
         ALR   @14,@14                                          01S0069
         SLR   @14,@15                                          01S0069
         BCTR  @14,0                                            01S0069
         LA    @01,ZMASK(@15)                                   01S0069
         EX    @14,@SM01212                                     01S0069
*   /*****************************************************************/
*   /*                                                               */
*   /* PRIME 'A' PORTION OF TRIAL MASK, BECAUSE A ALWAYS ACQUIRED.   */
*   /* (QCODE MUST BE AA OR AB).                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0070
*   QMSKTRY(1:AQMLENGT)=ENTMASK(1:AQMLENGT);                    01S0070
         L     @12,AQMMASKP(,@12)                               01S0070
         EX    @02,@SM01214                                     01S0070
*   IF QMSTAT=B THEN                                            01S0071
*                                                               01S0071
         CLI   QMSTAT(@11),C'B'                                 01S0071
         BNE   @RF00071                                         01S0071
*     /***************************************************************/
*     /*                                                             */
*     /* CALLER REQUESTED 'B' OWNERSHIP, PRIME 'B' PORTION OF MASK.  */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0072
*     QMSKTRY(AQMLENGT+1:2*AQMLENGT)=ENTMASK(1:AQMLENGT);       01S0072
         ALR   @08,@15                                          01S0072
         EX    @14,@SM01214                                     01S0072
*   ELSE                                                        01S0073
*     ;                                                         01S0073
*                                                               01S0073
@RF00071 DS    0H                                               01S0074
*   /*****************************************************************/
*   /*                                                               */
*   /* AND REQUEST TO EXISTING LOCK STATE, CHECK FOR ALL ZERO.       */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0074
*   TEMPAREA(1:AQMLENGT)=(QMSKTRY(1:AQMLENGT)&MASKS(1:AQMLENGT));/*
*                                                            @ZA15759*/
         L     @12,PARA                                         01S0074
         L     @11,AQMLENGT(,@12)                               01S0074
         LR    @08,@11                                          01S0074
         BCTR  @08,0                                            01S0074
         L     @12,AQMQBPTR(,@12)                               01S0074
         L     @12,QM2PTR(,@12)                                 01S0074
         L     @07,CVTPTR                                       01S0074
         L     @07,CVTAQTOP(,@07)                               01S0074
         EX    @08,@SM01216                                     01S0074
         EX    @08,@SN01218                                     01S0074
*   TEMPAREA(AQMLENGT+1:2*AQMLENGT)=(QMSKTRY(AQMLENGT+1:2*AQMLENGT) & M
*SKS(AQMLENGT+1:2*AQMLENGT));               /*               @ZA15759*/
         LA    @02,TEMPAREA(@11)                                01S0075
         LR    @15,@11                                          01S0075
         ALR   @15,@15                                          01S0075
         SLR   @15,@11                                          01S0075
         BCTR  @15,0                                            01S0075
         ALR   @12,@11                                          01S0075
         EX    @15,@SM01220                                     01S0075
         ALR   @07,@11                                          01S0075
         EX    @15,@SN01222                                     01S0075
*   IF ZMASK(1:AQMLENGT)^=TEMPAREA(1:AQMLENGT) |/*              01S0076
*                                                            @ZA15759*/
*      ZMASK(AQMLENGT+1:2*AQMLENGT)^=TEMPAREA(AQMLENGT+1:2*AQMLENGT) TH
*N                                  /*                       @ZA15759*/
*                                                               01S0076
         EX    @08,@SC01224                                     01S0076
         BNE   @RT00076                                         01S0076
         LA    @12,ZMASK(@11)                                   01S0076
         LA    @08,TEMPAREA(@11)                                01S0076
         EX    @15,@SC01226                                     01S0076
         BE    @RF00076                                         01S0076
@RT00076 DS    0H                                               01S0077
*     /***************************************************************/
*     /*                                                             */
*     /* NONZERO RESULT INDICATES SOME GROUP NOT AVAILABLE, QUEUE UP */
*     /* REQUEST AND WAIT.                                           */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0077
*     DO;                                                       01S0077
*       IF QMSTAT=B THEN                                        01S0078
*                                                               01S0078
         L     @12,PARA                                         01S0078
         L     @11,AQMQBPTR(,@12)                               01S0078
         CLI   QMSTAT(@11),C'B'                                 01S0078
         BNE   @RF00078                                         01S0078
*         /***********************************************************/
*         /*                                                         */
*         /*   WE HAVE A NON-INTERACTIVE TASK WHICH IS REQUIRED      */
*         /*   TO WAIT TO ACQUIRE GROUPS. IT IS NOT PERMITTED TO     */
*         /*   HOLD 'A' OWNERSHIP WHILE WAITING, THEREBY LOCKING     */
*         /*   OUT INTERACTIVE TASKS. THE FOLLOWING DO-GROUP         */
*         /*   PROCESSES THE REQUEST IF THE TASK IS SUCCESSFUL.      */
*         /*                                                         */
*         /*   THE PROCESSING IN THE INNER DO-GROUP RELEASES PRIOR   */
*         /*   'A'-OWNERSHIP, FORMS A MODIFIED REQUEST TO ACQUIRE    */
*         /*   THE UNION OF THE ACTUAL REQUEST WITH THE PRIOR        */
*         /*   OWNERSHIP, AND PROCESSES THE 'A' WAIT QUEUE.          */
*         /*                                                         */
*         /***********************************************************/
*                                                               01S0079
*         DO;                                                   01S0079
*           IF ZMASK(1:AQMLENGT)^=QMASKOWN(1:AQMLENGT) THEN/*   01S0080
*                                             ANY 'A' OWNERSHIP ?    */
         L     @12,AQMLENGT(,@12)                               01S0080
         BCTR  @12,0                                            01S0080
         EX    @12,@SC01228                                     01S0080
         BE    @RF00080                                         01S0080
*             DO;                                               01S0081
*               QMASKOWN(1:AQMLENGT)=QMASKOWN(1:AQMLENGT) & MASKS(1:AQM
*ENGT);                                                         01S0082
         L     @08,CVTPTR                                       01S0082
         L     @08,CVTAQTOP(,@08)                               01S0082
         EX    @12,@SN01230                                     01S0082
*               MASKS(1:AQMLENGT)=MASKS(1:AQMLENGT) && QMASKOWN(1:AQMLE
*GT);                                                /*RELEASE GROUPS*/
         EX    @12,@SX01232                                     01S0083
*               QMSKTRY(1:AQMLENGT)=QMSKTRY(1:AQMLENGT) | QMASKOWN(1:AQ
*LENGT);                                                /*AMEND MASK
*                                        OF GROUPS REQUESTED         */
         L     @02,QM2PTR(,@11)                                 01S0084
         EX    @12,@SO01234                                     01S0084
*               QMASKOWN(1:AQMLENGT) = ZMASK(1:AQMLENGT);/*     01S0085
*                                           AMEND OWNERSHIP MASK     */
         EX    @12,@SM01236                                     01S0085
*               CALL QSCAN (QAF);      /*PROCESS 'A' WAIT QUEUE      */
         LA    @12,QAF(,@08)                                    01S0086
         ST    @12,@AL00001                                     01S0086
         LA    @01,@AL00001                                     01S0086
         BAL   @14,QSCAN                                        01S0086
*             END;                                              01S0087
*           ELSE;                      /*NO 'A' OWNERSHIP            */
@RF00080 DS    0H                                               01S0089
*         CALL QINSRT(QBB->QMNXTQF,QMNXTQF,QBB,QMQBLK);/*INSERT ON
*                                                        'AB' Q      */
         L     @12,CVTPTR                                       01S0089
         L     @12,CVTAQTOP(,@12)                               01S0089
         L     @11,QBB(,@12)                                    01S0089
         LA    @11,QMNXTQF(,@11)                                01S0089
         ST    @11,@AL00001                                     01S0089
         L     @11,PARA                                         01S0089
         L     @11,AQMQBPTR(,@11)                               01S0089
         LA    @08,QMNXTQF(,@11)                                01S0089
         ST    @08,@AL00001+4                                   01S0089
         LA    @12,QBB(,@12)                                    01S0089
         ST    @12,@AL00001+8                                   01S0089
         ST    @11,@AL00001+12                                  01S0089
         LA    @01,@AL00001                                     01S0089
         BAL   @14,QINSRT                                       01S0089
*         END;                                                  01S0090
*       ELSE                                                    01S0091
*                                                               01S0091
*         /***********************************************************/
*         /*                                                         */
*         /* REQUEST IS FOR 'A' LOCK, INSERT ON 'A' QUEUE.           */
*         /*                                                         */
*         /***********************************************************/
*                                                               01S0091
*         CALL QINSRT(QAB->QMNXTQF,QMNXTQF,QAB,QMQBLK);         01S0091
         B     @RC00078                                         01S0091
@RF00078 L     @12,CVTPTR                                       01S0091
         L     @12,CVTAQTOP(,@12)                               01S0091
         L     @11,QAB(,@12)                                    01S0091
         LA    @11,QMNXTQF(,@11)                                01S0091
         ST    @11,@AL00001                                     01S0091
         L     @11,PARA                                         01S0091
         L     @11,AQMQBPTR(,@11)                               01S0091
         LA    @08,QMNXTQF(,@11)                                01S0091
         ST    @08,@AL00001+4                                   01S0091
         LA    @12,QAB(,@12)                                    01S0091
         ST    @12,@AL00001+8                                   01S0091
         ST    @11,@AL00001+12                                  01S0091
         LA    @01,@AL00001                                     01S0091
         BAL   @14,QINSRT                                       01S0091
*        RFY (R11,R12,R13,R14) RSTD;SV13=R13;GEN;               01S0092
@RC00078 DS    0H                                               01S0093
         LR    SV13,R13                                         01S0093
         SETLOCK RELEASE,TYPE=CMS,                                    XX
               REGS=USE,RELATED=(ALLOC-QMGR,IEFAB4FA(LOCK))
         SETLOCK RELEASE,TYPE=LOCAL,                                  XX
               REGS=USE,RELATED=(ALLOC-QMGR,IEFAB4FA(LOCK))
*        R13=SV13;RFY (R11,R12,R13,R14) UNRSTD;                 01S0095
         LR    R13,SV13                                         01S0095
*         R10=ADDR(AQMCANCP);GEN                                01S0097
         L     R10,PARA                                         01S0097
         LA    R10,AQMCANCP(,R10)                               01S0097
*   ( WAIT 1,ECBLIST=(R10),LONG=YES);IF CANCFLAG='1'B THEN RETCODE=CANC
*L;ELSE RETCODE=OK;QMECB=ZERO;                                  01S0098
          WAIT 1,ECBLIST=(R10),LONG=YES
         L     @12,PARA                                         01S0099
         L     @12,AQMCANCP(,@12)                               01S0099
         TM    CANCFLAG(@12),B'01000000'                        01S0099
         BNO   @RF00099                                         01S0099
         LA    RETCODE,16                                       01S0100
         B     @RC00099                                         01S0101
@RF00099 SLR   RETCODE,RETCODE                                  01S0101
@RC00099 L     @12,PARA                                         01S0102
         L     @12,AQMQBPTR(,@12)                               01S0102
         SLR   @11,@11                                          01S0102
         ST    @11,QMECB(,@12)                                  01S0102
*     END;                                                      01S0103
*   ELSE                                                        01S0104
*                                                               01S0104
*     /***************************************************************/
*     /*                                                             */
*     /* REQUEST IS SATISFIABLE, MAKE THE ASSIGNMENT AND RETURN      */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0104
*     DO;                                                       01S0104
*                                                               01S0104
         B     @RC00076                                         01S0104
@RF00076 DS    0H                                               01S0105
*       /*************************************************************/
*       /*                                                           */
*       /* RECORD ASSIGNMENT IN GLOBAL LOCK (MASKS).                 */
*       /*                                                           */
*       /*************************************************************/
*                                                               01S0105
*       MASKS(1:AQMLENGT)=MASKS(1:AQMLENGT)|QMSKTRY(1:AQMLENGT);/*
*                                                            @ZA15759*/
         L     @12,CVTPTR                                       01S0105
         L     @12,CVTAQTOP(,@12)                               01S0105
         L     @11,PARA                                         01S0105
         L     @08,AQMLENGT(,@11)                               01S0105
         LR    @07,@08                                          01S0105
         BCTR  @07,0                                            01S0105
         L     @11,AQMQBPTR(,@11)                               01S0105
         L     @05,QM2PTR(,@11)                                 01S0105
         EX    @07,@SO01238                                     01S0105
*       MASKS(AQMLENGT+1:2*AQMLENGT)=MASKS(AQMLENGT+1:2*AQMLENGT)|QMSKT
*Y(AQMLENGT+1:2*AQMLENGT);                /*                 @ZA15759*/
         ALR   @12,@08                                          01S0106
         LR    @02,@08                                          01S0106
         ALR   @02,@02                                          01S0106
         SLR   @02,@08                                          01S0106
         BCTR  @02,0                                            01S0106
         ALR   @08,@05                                          01S0106
         EX    @02,@SO01240                                     01S0106
*       /*************************************************************/
*       /*                                                           */
*       /* RECORD ASSIGNMENT IN USER RECORD QUEUE ELEMENT (QMASKOWN) */
*       /*                                                           */
*       /*************************************************************/
*                                                               01S0107
*       QMASKOWN(1:AQMLENGT)=QMASKOWN(1:AQMLENGT)|QMSKTRY(1:AQMLENGT);
         EX    @07,@SO01242                                     01S0107
*                                              /*            @ZA15759*/
*       QMASKOWN(AQMLENGT+1:2*AQMLENGT)=QMASKOWN(AQMLENGT+1:2*AQMLENGT)
*| QMSKTRY(AQMLENGT+1:2*AQMLENGT);               /*          @ZA15759*/
         L     @12,PARA                                         01S0108
         L     @12,AQMLENGT(,@12)                               01S0108
         ALR   @12,@11                                          01S0108
         L     @08,PARA                                         01S0108
         L     @08,AQMLENGT(,@08)                               01S0108
         ALR   @05,@08                                          01S0108
         EX    @02,@SO01244                                     01S0108
*       /*************************************************************/
*       /*                                                           */
*       /* RESET STATUS BYTE TO ACTIVE STATE FOR THIS TASK.          */
*       /*                                                           */
*       /*************************************************************/
*                                                               01S0109
*       QMSTAT=ACTIVE;                                          01S0109
         MVI   QMSTAT(@11),C'E'                                 01S0109
*        RFY (R11,R12,R13,R14) RSTD;SV13=R13;GEN;               01S0110
         LR    SV13,R13                                         01S0111
         SETLOCK RELEASE,TYPE=CMS,                                    XX
               REGS=USE,RELATED=(ALLOC-QMGR,IEFAB4FA(LOCK))
         SETLOCK RELEASE,TYPE=LOCAL,                                  XX
               REGS=USE,RELATED=(ALLOC-QMGR,IEFAB4FA(LOCK))
*        R13=SV13;RFY (R11,R12,R13,R14) UNRSTD;                 01S0113
         LR    R13,SV13                                         01S0113
*     END;                                                      01S0115
* DO; /*MODESET  EXTKEY(SCHED)*/                                01S0116
@RC00076 DS    0H                                               01S0117
*   SPKA (16); /*SET PSW KEY*/                                  01S0117
         LA    @12,16                                           01S0117
         SPKA  0(@12)                                           01S0117
* END; /*MODESET  EXTKEY(SCHED)*/                               01S0118
*   RETURN CODE(RETCODE);                                       01S0119
         L     @13,4(,@13)                                      01S0119
         L     @00,@SIZDATD                                     01S0119
         LR    @01,@03                                          01S0119
         FSPACE   R,LV=(0),A=(1)
         LR    @15,@06                                          01S0119
         L     @14,12(,@13)                                     01S0119
         LM    @00,@12,20(@13)                                  01S0119
         BR    @14                                              01S0119
*                                                               01S0120
*   /*****************************************************************/
*   /*                                                               */
*   /* ACQUIRE A BLOCK OF COMMON FOR QMQBLK, INITIALIZE IT, AND      */
*   /* INITIALIZE POINTERS IN AQMPARAM RETURN CODE 0 IF SUCCESSFUL, 4*/
*   /* IF STORAGE NOT AVAILABLE                                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0120
*INITL:                                                         01S0120
*                                                               01S0120
*   /*****************************************************************/
*   /*                                                               */
*   /* ACQUIRE STORAGE FOR QUEUE BLOCK.                              */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0120
*    /* ?GETSTORG (241,LENGTH(QMFLD1)+4*AQMLENGT,AQMQBPTR);*/   01S0120
*      /* DEFINITIONS OF GETMAIN PARMS */                       01S0120
*      DCL                                                      01S0120
*        GTSTR0   FIXED(31) REG(0),/*GTMN PARM REG*/            01S0120
*        GTSTR1   FIXED(31) REG(1),/*GTMN PARM REG*/            01S0120
*        GTSTR2   PTR(31)   REG(2),/*GTMN PARM REG*/            01S0120
*        GTSTR15  FIXED(31) REG(15),/*GTMN RET COD*/            01S0120
*        GTSTRTCD FIXED(31); /* GETMAIN RTN CODE  */            01S0120
INITL    DS    0H                                               01S0121
*      DCL                                                      01S0121
*        GTSTR3   FIXED(31) REG(3),/* CLEARING REG*/            01S0121
*        GTSTR4   FIXED(31) REG(4),/* CLEARING REG*/            01S0121
*        GTSTR5   FIXED(31) REG(5),/* CLEARING REG*/            01S0121
*        GTSTR6   FIXED(31) REG(6),/* CLEARING REG*/            01S0121
*        GTSTR7   FIXED(31) REG(7),/* CLEARING REG*/            01S0121
*        GTSTR8   FIXED(31) REG(8),/* CLEARING REG*/            01S0121
*        GTSTZERO FIXED(31) INIT(0),                            01S0121
*        GTST253  FIXED(31) CONSTANT(253);                      01S0121
*      RFY (GTSTR0,GTSTR1,GTSTR2) RSTD; /*SAVE RGS*/            01S0122
*      GTSTR0 = LENGTH(QMFLD1)+4*AQMLENGT; /* SET AMOUNT*/      01S0123
         L     @11,PARA                                         01S0123
         L     GTSTR0,AQMLENGT(,@11)                            01S0123
         SLA   GTSTR0,2                                         01S0123
         AH    GTSTR0,@CH01208                                  01S0123
*      GTSTR2 = 241; /* SET SUBPOOL*/                           01S0124
         LA    GTSTR2,241                                       01S0124
*      GENERATE CODE;                                           01S0125
        GETMAIN RC,LV=(0),SP=(2)  DO GETMAIN
*      GTSTRTCD = GTSTR15; /* SAVE GETMAIN RET COD*/            01S0126
         LR    GTSTRTCD,GTSTR15                                 01S0126
*      AQMQBPTR = GTSTR1; /* ADDR OF GOTN STORG*/               01S0127
         L     @11,PARA                                         01S0127
         ST    GTSTR1,AQMQBPTR(,@11)                            01S0127
*      RFY (GTSTR0,GTSTR1,GTSTR2) UNRSTD; /*RLSE */             01S0128
*      IF GTSTRTCD = 0 THEN /*GETMAIN SUCCESSFUL? */            01S0129
         LTR   GTSTRTCD,GTSTRTCD                                01S0129
         BNZ   @RF00129                                         01S0129
*        DO;               /* YES, CLEAR STORAGE.*/             01S0130
*          RFY (GTSTR2,GTSTR4,GTSTR5,GTSTR6,                    01S0131
*                             GTSTR7,GTSTR8) RSTD;              01S0131
*          GTSTR4 = AQMQBPTR; /*STORG PTR*/                     01S0132
         L     @01,PARA                                         01S0132
         L     @15,AQMQBPTR(,@01)                               01S0132
         LR    GTSTR4,@15                                       01S0132
*          GTSTR5 = LENGTH(QMFLD1)+4*AQMLENGT; /*STORG AMNT*/   01S0133
         L     GTSTR5,AQMLENGT(,@11)                            01S0133
         SLA   GTSTR5,2                                         01S0133
         AH    GTSTR5,@CH01208                                  01S0133
*          GTSTR7 = '00000000'X; /*PAD CHAR & LNTH*/            01S0134
         SLR   GTSTR7,GTSTR7                                    01S0134
*          IF 241 = GTST253 THEN                                01S0135
         B     @RF00135                                         01S0135
*         GEN                                                   01S0136
*      (MODESET KEYADDR=GTSTZERO,SAVEKEY=(2),WORKREG=8);        01S0136
         MODESET KEYADDR=GTSTZERO,SAVEKEY=(2),WORKREG=8
*          GEN REFS(GTSTR4,GTSTR6);                             01S0137
@RF00135 DS    0H                                               01S0137
             MVCL  GTSTR4,GTSTR6 CLEAR GOTTEN STORG
*          IF 241 = GTST253 THEN                                01S0138
         B     @RF00138                                         01S0138
*            GEN (MODESET KEYADDR=(2));                         01S0139
         MODESET KEYADDR=(2)
*          RFY (GTSTR2,GTSTR4,GTSTR5,GTSTR6,                    01S0140
*                             GTSTR7,GTSTR8) UNRSTD;            01S0140
@RF00138 DS    0H                                               01S0141
*        END;       /* STORAGE CLEARING COMPLETED */            01S0141
*      ELSE                                                     01S0142
*      AQMQBPTR= 0;   /* CLEAR RETURN ADDR. */                  01S0142
         B     @RC00129                                         01S0142
@RF00129 L     @11,PARA                                         01S0142
         SLR   @08,@08                                          01S0142
         ST    @08,AQMQBPTR(,@11)                               01S0142
*      GTSTR15 = GTSTRTCD;    /* GTMN RETURN CODE */            01S0143
@RC00129 LR    GTSTR15,GTSTRTCD                                 01S0143
*                                      /* RESTORE LIST PRINT STATUS  */
*                                                               01S0144
*   /*****************************************************************/
*   /*                                                               */
*   /* TEST RTRN CODE FROM STORAGE ACQUIRER.                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0144
*   IF CODEREG^=OK THEN                                         01S0144
*                                                               01S0144
         LTR   CODEREG,CODEREG                                  01S0144
         BZ    @RF00144                                         01S0144
*     /***************************************************************/
*     /*                                                             */
*     /* STORAGE NOT AVAILABLE, PASS RETURN CODE BACK TO CALLER.     */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0145
*     RETCODE=CODEREG;                                          01S0145
         LR    RETCODE,CODEREG                                  01S0145
*   ELSE                                                        01S0146
*                                                               01S0146
*     /***************************************************************/
*     /*                                                             */
*     /* STORAGE ACQUIRED, PERFORM INITIALIZATIONS.                  */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0146
*     DO;                                                       01S0146
         B     @RC00144                                         01S0146
@RF00144 DS    0H                                               01S0147
*       RFY                                                     01S0147
*         QMQBLK BASED(AQMQBPTR);                               01S0147
*       IF EXITPRMP ^= ZERO THEN       /*ESTAE PARMS SUPPLIED        */
         L     @12,@PC00001+4                                   01S0148
         L     @12,EXITPRMP(,@12)                               01S0148
         LTR   @12,@12                                          01S0148
         BZ    @RF00148                                         01S0148
*         DO;                                                   01S0149
*           PRMQMBLN = LENGTH(QMFLD1)+4*AQMLENGT;/*             01S0150
*                                        LENGTH OF Q-MGR CORE        */
         L     @11,PARA                                         01S0150
         L     @08,AQMLENGT(,@11)                               01S0150
         SLA   @08,2                                            01S0150
         AH    @08,@CH01208                                     01S0150
         ST    @08,PRMQMBLN(,@12)                               01S0150
*           PRMQMBP = AQMQBPTR;        /*PTR TO Q-MGR REQ BLK        */
         MVC   PRMQMBP(4,@12),AQMQBPTR(@11)                     01S0151
*           FREECORE = ON;             /*LENGTH OF CORE TO FREE      */
         OI    FREECORE(@12),B'00000100'                        01S0152
*         END;                                                  01S0153
*                                                               01S0153
*       /*************************************************************/
*       /*                                                           */
*       /* STORE PTR IN PARAM BLK TO ECB IN QUEUE ELEMENT.           */
*       /*                                                           */
*       /*************************************************************/
*                                                               01S0154
*       AQMNORMP=ADDR(QMECB);                                   01S0154
*                                                               01S0154
@RF00148 L     @12,PARA                                         01S0154
         L     @11,AQMQBPTR(,@12)                               01S0154
         LA    @08,QMECB(,@11)                                  01S0154
         ST    @08,AQMNORMP(,@12)                               01S0154
*       /*************************************************************/
*       /*                                                           */
*       /* SET END-OF-ECBLIST MARKER.                                */
*       /*                                                           */
*       /*************************************************************/
*                                                               01S0155
*       AQMPFLG='1'B;                                           01S0155
*                                                               01S0155
         OI    AQMPFLG(@12),B'10000000'                         01S0155
*       /*************************************************************/
*       /*                                                           */
*       /* INIT ADDR OF TRIAL MASK IN VAR LNG MASK FIELD IN Q        */
*       /* ELEMENT.                                                  */
*       /*                                                           */
*       /*************************************************************/
*                                                               01S0156
*       QM2PTR=ADDR(QMASKOWN)+2*AQMLENGT;                       01S0156
*                                                               01S0156
         LA    @08,QMASKOWN(,@11)                               01S0156
         L     @05,AQMLENGT(,@12)                               01S0156
         ALR   @05,@05                                          01S0156
         ALR   @08,@05                                          01S0156
         ST    @08,QM2PTR(,@11)                                 01S0156
*       /*************************************************************/
*       /*                                                           */
*       /* TRANSFER ASCB ADDRESS TO Q-ELEM FRM PARAM AREA            */
*       /*                                                           */
*       /*************************************************************/
*                                                               01S0157
*       QMASID=AQMASID;             /* THIS USED IN XMPOST OPERATION */
         MVC   QMASID(4,@11),AQMASID(@12)                       01S0157
*        RFY (R11,R12,R13,R14) RSTD;SV13=R13;GEN REFS(PSALITA); 01S0158
         LR    SV13,R13                                         01S0159
         SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,                       XX
               REGS=USE,RELATED=(ALLOC-QMGR,IEFAB4FA(UNLOCK))
         SETLOCK OBTAIN,TYPE=CMS,MODE=UNCOND,                         XX
               REGS=USE,RELATED=(ALLOC-QMGR,IEFAB4FA(UNLOCK))
*        R13=SV13;RFY (R11,R12,R13,R14) UNRSTD;                 01S0161
*                                                               01S0161
         LR    R13,SV13                                         01S0161
*       /*************************************************************/
*       /*                                                           */
*       /* INSERT BLOCK ON COMPREHENSIVE LIST OF Q ELEMENTS.         */
*       /*                                                           */
*       /*************************************************************/
*                                                               01S0163
*       CALL QINSRT(MAINB->QMNXTF,QMNXTF,MAINB,QMQBLK);         01S0163
*                                                               01S0163
         L     @12,CVTPTR                                       01S0163
         L     @12,CVTAQTOP(,@12)                               01S0163
         L     @11,MAINB(,@12)                                  01S0163
         ST    @11,@AL00001                                     01S0163
         L     @11,PARA                                         01S0163
         L     @11,AQMQBPTR(,@11)                               01S0163
         ST    @11,@AL00001+4                                   01S0163
         LA    @12,MAINB(,@12)                                  01S0163
         ST    @12,@AL00001+8                                   01S0163
         ST    @11,@AL00001+12                                  01S0163
         LA    @01,@AL00001                                     01S0163
         BAL   @14,QINSRT                                       01S0163
*       /*************************************************************/
*       /*                                                           */
*       /* MARK BLOCK ACTIVE INITIALLY.                              */
*       /*                                                           */
*       /*************************************************************/
*                                                               01S0164
*       QMSTAT=ACTIVE;                                          01S0164
         L     @12,PARA                                         01S0164
         L     @12,AQMQBPTR(,@12)                               01S0164
         MVI   QMSTAT(@12),C'E'                                 01S0164
*        RFY (R11,R12,R13,R14) RSTD;SV13=R13;GEN;               01S0165
         LR    SV13,R13                                         01S0166
         SETLOCK RELEASE,TYPE=CMS,                                    XX
               REGS=USE,RELATED=(ALLOC-QMGR,IEFAB4FA(LOCK))
         SETLOCK RELEASE,TYPE=LOCAL,                                  XX
               REGS=USE,RELATED=(ALLOC-QMGR,IEFAB4FA(LOCK))
*        R13=SV13;RFY (R11,R12,R13,R14) UNRSTD;                 01S0168
         LR    R13,SV13                                         01S0168
*       RETCODE=OK;                                             01S0170
         SLR   RETCODE,RETCODE                                  01S0170
*        DO; /*MODESET  EXTKEY(SCHED)*/                         01S0171
*          SPKA (16); /*SET PSW KEY*/                           01S0172
         LA    @12,16                                           01S0172
         SPKA  0(@12)                                           01S0172
*        END; /*MODESET  EXTKEY(SCHED)*/                        01S0173
*     END;                                                      01S0174
*   RETURN CODE(RETCODE);                                       01S0175
@RC00144 L     @13,4(,@13)                                      01S0175
         L     @00,@SIZDATD                                     01S0175
         LR    @01,@03                                          01S0175
         FSPACE   R,LV=(0),A=(1)
         LR    @15,@06                                          01S0175
         L     @14,12(,@13)                                     01S0175
         LM    @00,@12,20(@13)                                  01S0175
         BR    @14                                              01S0175
*                                                               01S0176
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS ROUTINE ACCEPTS NOTIFICATION OF UNALLOCATIONS THAT MAKE  */
*   /* DEVICES AVAILABLE FOR REALLOCATION AND CAUSES TASKS WAITING   */
*   /* FOR THE EVENT TO BE REACTIVATED. BECAUSE UNALLOCATIONS DO NOT */
*   /* USE SERVICES OF THE QUEUE MANAGER FACILITY TO GET EXCLUSIVE   */
*   /* ACCESS TO UCB'S WHILE CHANGING USE COUNTS, A SIGNAL COULD BE  */
*   /* POTENTIALLY LOST. TO AVOID THIS, THIS ROUTINE ALSO FLAGS      */
*   /* CURRENT OWNERS OF UCB'S WHO ARE POTENTIAL WAITERS. THE WAIT   */
*   /* ROUTINE CHECKS THIS FLAG BEFORE WAITING.                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0176
*POSTD:                                                         01S0176
*                                                               01S0176
*   /*****************************************************************/
*   /*                                                               */
*   /* BASE Q ELEMENT ON PTR LOCAL TO THIS ROUTINE.                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0176
*   RFY                                                         01S0176
*     QMQBLK BASED(PQPTR);                                      01S0176
POSTD    DS    0H                                               01S0177
*   RETCODE=OK;                                                 01S0177
         SLR   RETCODE,RETCODE                                  01S0177
*    RFY (R11,R12,R13,R14) RSTD;SV13=R13;GEN REFS(PSALITA);     01S0178
         LR    SV13,R13                                         01S0179
     SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,                           XX
               REGS=USE,RELATED=(ALLOC-QMGR,IEFAB4FA(UNLOCK))
     SETLOCK OBTAIN,TYPE=CMS,MODE=UNCOND,                             XX
               REGS=USE,RELATED=(ALLOC-QMGR,IEFAB4FA(UNLOCK))
*    R13=SV13;RFY (R11,R12,R13,R14) UNRSTD;                     01S0181
*                                                               01S0181
         LR    R13,SV13                                         01S0181
*   /*****************************************************************/
*   /*                                                               */
*   /* START Q ELEMENT PTR AT HEAD OF COMPREHENSIVE LIST.            */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0183
*   PQPTR=MAINF;                                                01S0183
*                                                               01S0183
         L     @12,CVTPTR                                       01S0183
         L     @12,CVTAQTOP(,@12)                               01S0183
         L     PQPTR,MAINF(,@12)                                01S0183
*   /*****************************************************************/
*   /*                                                               */
*   /* COMPUTE LENGTH OF A SINGLE MASK FIELD. (USED IN SUBSTRING     */
*   /* EXPRESSIONS BELOW).                                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0184
*   TEMP=(ADDR(QMSKTRY)-ADDR(QMASKOWN))/2;                      01S0184
*                                                               01S0184
         LA    TEMP,QMASKOWN(,PQPTR)                            01S0184
         LR    @00,TEMP                                         01S0184
         LCR   @00,@00                                          01S0184
         AL    @00,QM2PTR(,PQPTR)                               01S0184
         SRDA  @00,32                                           01S0184
         D     @00,@CF00114                                     01S0184
         LR    TEMP,@01                                         01S0184
*   /*****************************************************************/
*   /*                                                               */
*   /* SCAN COMPREHENSIVE LIST FOR ACTIVE ELEMENTS WHOSE OWNERSHIP IN*/
*   /* 'B' CLASS INTERSECTS GROUPS SPECIFIED IN PARAMETER MASK. MARK */
*   /* THESE 'POSTED'.                                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0185
*   DO WHILE(ADDR(QMNXTF)^=ADDR(MAINF));                        01S0185
         B     @DE00185                                         01S0185
@DL00185 DS    0H                                               01S0186
*     IF QMSTAT=ACTIVE & AQMASID ^= QMASID THEN                 01S0186
*                                                               01S0186
         CLI   QMSTAT(PQPTR),C'E'                               01S0186
         BNE   @RF00186                                         01S0186
         L     @12,PARA                                         01S0186
         CLC   AQMASID(4,@12),QMASID(PQPTR)                     01S0186
         BE    @RF00186                                         01S0186
*       DO;                            /*                    @YM06797*/
*           /*********************************************************/
*           /*                                                       */
*           /* AN 'ACTIVE' ELEMENT WAS FOUND, TEST OWNERSHIP         */
*           /*                                                       */
*           /*********************************************************/
*                                                               01S0188
*           TEMPAREA(1:TEMP)=(QMASKOWN(TEMP+1:2*TEMP)&ENTMASK(1:TEMP));
         LR    @11,TEMP                                         01S0188
         BCTR  @11,0                                            01S0188
         L     @12,AQMMASKP(,@12)                               01S0188
         LR    @07,PQPTR                                        01S0188
         ALR   @07,TEMP                                         01S0188
         EX    @11,@SM01248                                     01S0188
         EX    @11,@SN01250                                     01S0188
*                                                       /*   @YM06797*/
*           IF ZMASK(1:TEMP)^=TEMPAREA(1:TEMP) THEN/*           01S0189
*                                                            @YM06797*/
*                                                               01S0189
         EX    @11,@SC01224                                     01S0189
         BE    @RF00189                                         01S0189
*             /*******************************************************/
*             /*                                                     */
*             /* OWNERSHIP INTERSECTS, MARK ELEMENT 'POSTED'.        */
*             /*                                                     */
*             /*******************************************************/
*                                                               01S0190
*             DO;                                               01S0190
*               QMSTAT=POSTED;                                  01S0191
         MVI   QMSTAT(PQPTR),C'P'                               01S0191
*             END;                                              01S0192
*           ELSE                                                01S0193
*             ;                                                 01S0193
@RF00189 DS    0H                                               01S0194
*       END;                           /*                    @YM06797*/
*     ELSE                                                      01S0195
*       ;                                                       01S0195
*                                                               01S0195
@RF00186 DS    0H                                               01S0196
*     /***************************************************************/
*     /*                                                             */
*     /* STEP Q ELEMENT PTR FWD THRU CHAIN FOR NEXT DO ITERATION.    */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0196
*     PQPTR=QMNXTF;                                             01S0196
         L     PQPTR,QMNXTF(,PQPTR)                             01S0196
*   END;                                                        01S0197
*                                                               01S0197
@DE00185 L     @12,CVTPTR                                       01S0197
         L     @12,CVTAQTOP(,@12)                               01S0197
         CR    PQPTR,@12                                        01S0197
         BNE   @DL00185                                         01S0197
*   /*****************************************************************/
*   /*                                                               */
*   /* START Q ELEMENT PTR AT HEAD OF WFD QUEUE.                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0198
*   PQPTR=QCF;                                                  01S0198
*                                                               01S0198
         L     PQPTR,QCF(,@12)                                  01S0198
*   /*****************************************************************/
*   /*                                                               */
*   /* SCAN 'WFD' QUEUE FOR ELEMENTS AWAITING ANY GROUPS SPECIFIED IN*/
*   /* PARAMETER MASK. DETACH THEM FROM CHAIN AND REINSTATE THEM TO  */
*   /* ACTIVE STATUS.                                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0199
*   DO WHILE(ADDR(QMNXTQF)^=ADDR(QCF));                         01S0199
*                                                               01S0199
         B     @DE00199                                         01S0199
@DL00199 DS    0H                                               01S0200
*     /***************************************************************/
*     /*                                                             */
*     /* TEST WAITERS TRIAL MASK AGAINST CALLERS POSTING MASK.       */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0200
*     TEMPAREA(1:TEMP)=(QMSKTRY(1:TEMP)&ENTMASK(1:TEMP));/*     01S0200
*                                                            @YM06797*/
         LR    @12,TEMP                                         01S0200
         BCTR  @12,0                                            01S0200
         L     @11,QM2PTR(,PQPTR)                               01S0200
         L     @07,PARA                                         01S0200
         L     @07,AQMMASKP(,@07)                               01S0200
         EX    @12,@SM01252                                     01S0200
         EX    @12,@SN01254                                     01S0200
*     IF ZMASK(1:TEMP)^=TEMPAREA(1:TEMP) THEN/*                 01S0201
*                                                            @YM06797*/
*                                                               01S0201
         EX    @12,@SC01224                                     01S0201
         BE    @RF00201                                         01S0201
*       /*************************************************************/
*       /*                                                           */
*       /* AN INTERSECTION WAS FOUND, PERFORM REINSTATEMENT.         */
*       /*                                                           */
*       /*************************************************************/
*                                                               01S0202
*       DO;                                                     01S0202
*                                                               01S0202
*         /***********************************************************/
*         /*                                                         */
*         /* DETACH ELEMENT FROM WFD QUEUE.                          */
*         /*                                                         */
*         /***********************************************************/
*                                                               01S0203
*         CALL QMDELETQ(QMQBLK);                                01S0203
*                                                               01S0203
         ST    PQPTR,@AL00001                                   01S0203
         LA    @01,@AL00001                                     01S0203
         BAL   @14,QMDELETQ                                     01S0203
*         /***********************************************************/
*         /*                                                         */
*         /* POST ASSOCIATED TASK VIA XMPOST.                        */
*         /*                                                         */
*         /***********************************************************/
*                                                               01S0204
*          RFY (R10,R11,R12,R4) RSTD;POSTWRK=ADDR(QMECB);XMFLG='1'B;
         LA    @15,QMECB(,PQPTR)                                01S0205
         ST    @15,POSTWRK                                      01S0205
         OI    XMFLG,B'10000000'                                01S0206
*          GEN( STM 14,12,12(13));R4=R13;R10=OK;R11=POSTWRK;R12=POSTERA
*;ASVTPTR = CVTASVT;ASCBENTP = ADDR(ASVTENTY)+(LENGTH(ASVTENTY)*(QMASID
*1));R13=ASCBADDR;CALL IEA0PT01;R13=R4;                         01S0207
          STM 14,12,12(13)
         LR    R4,R13                                           01S0208
         SLR   R10,R10                                          01S0209
         L     R11,POSTWRK                                      01S0210
         L     R12,POSTERAD                                     01S0211
         L     @15,CVTPTR                                       01S0212
         L     ASVTPTR,CVTASVT(,@15)                            01S0212
         LA    ASCBENTP,ASVTENTY(,ASVTPTR)                      01S0213
         L     @14,QMASID(,PQPTR)                               01S0213
         BCTR  @14,0                                            01S0213
         SLL   @14,2                                            01S0213
         ALR   ASCBENTP,@14                                     01S0213
         L     R13,ASCBADDR(,ASCBENTP)                          01S0214
         L     @15,CVT0PT01(,@15)                               01S0215
         BALR  @14,@15                                          01S0215
         LR    R13,R4                                           01S0216
*          GEN( LM 14,12,12(13));RFY (R10,R11,R12,R4) UNRSTD;   01S0217
*                                                               01S0217
          LM 14,12,12(13)
*         /***********************************************************/
*         /*                                                         */
*         /* RESET STATUS OF TASK QUEUE ELEMENT TO ACTIVE.           */
*         /*                                                         */
*         /***********************************************************/
*                                                               01S0219
*         QMSTAT=ACTIVE;                                        01S0219
         MVI   QMSTAT(PQPTR),C'E'                               01S0219
*       END;                                                    01S0220
*     ELSE                                                      01S0221
*       ;                                                       01S0221
*                                                               01S0221
@RF00201 DS    0H                                               01S0222
*     /***************************************************************/
*     /*                                                             */
*     /* STEP Q ELEMENT PTR FWD THRU WFD CHAIN FOR NXT DO ITERATION. */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0222
*     PQPTR=QMNXTQF;                                            01S0222
         L     PQPTR,QMNXTQF(,PQPTR)                            01S0222
*   END;                                                        01S0223
@DE00199 LA    @12,QMNXTQF(,PQPTR)                              01S0223
         L     @11,CVTPTR                                       01S0223
         L     @11,CVTAQTOP(,@11)                               01S0223
         LA    @11,QCF(,@11)                                    01S0223
         CR    @12,@11                                          01S0223
         BNE   @DL00199                                         01S0223
*    RFY (R11,R12,R13,R14) RSTD;SV13=R13;GEN;                   01S0224
         LR    SV13,R13                                         01S0225
     SETLOCK RELEASE,TYPE=CMS,                                        XX
               REGS=USE,RELATED=(ALLOC-QMGR,IEFAB4FA(LOCK))
     SETLOCK RELEASE,TYPE=LOCAL,                                      XX
               REGS=USE,RELATED=(ALLOC-QMGR,IEFAB4FA(LOCK))
*    R13=SV13;RFY (R11,R12,R13,R14) UNRSTD;                     01S0227
         LR    R13,SV13                                         01S0227
*    DO; /*MODESET  EXTKEY(SCHED)*/                             01S0229
*      SPKA (16); /*SET PSW KEY*/                               01S0230
         LA    @12,16                                           01S0230
         SPKA  0(@12)                                           01S0230
*    END; /*MODESET  EXTKEY(SCHED)*/                            01S0231
*   RETURN CODE(RETCODE);                                       01S0232
         L     @13,4(,@13)                                      01S0232
         L     @00,@SIZDATD                                     01S0232
         LR    @01,@03                                          01S0232
         FSPACE   R,LV=(0),A=(1)
         LR    @15,@06                                          01S0232
         L     @14,12(,@13)                                     01S0232
         LM    @00,@12,20(@13)                                  01S0232
         BR    @14                                              01S0232
*    POSTERR: GEN                                               01S0233
*     ( BR 14);                                                 01S0233
POSTERR   BR 14
*                                                               01S0234
*   /*****************************************************************/
*   /*                                                               */
*   /* FREE GROUPS INDICATED IN ENTMASK UNDER SCOPE INDICATED BY     */
*   /* AQMQCODE AND REASSIGN GROUPS TO A WAITING TASK, IF CALLED FOR.*/
*   /* 'A' QUEUE IS PROCESSED BEFORE 'AB' QUEUE IF BOTH ARE PROCESSED*/
*   /* IN THIS PASS. THIS EFFECTIVELY GIVES DYNAMIC ALLOCATION TASKS */
*   /* PRIORITY OVER STEP ALLOCATIONS,IF BOTH COULD POTENTIALLY BE   */
*   /* SATISFIED. ( THE QPROC PROCEDURE DOES THE QUEUE PROCESSING).  */
*   /* AQMQCODE LEGAL VALUES ARE AA,AB,BB, MEANING A-ONLY, BOTH, OR  */
*   /* B-ONLY RELEASE, RESPECTIVELY.                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0234
*RELSE:                                                         01S0234
*   RETCODE=OK;                                                 01S0234
*                                                               01S0234
RELSE    SLR   RETCODE,RETCODE                                  01S0234
*   /*****************************************************************/
*   /*                                                               */
*   /* BASE Q ELEMENT ON CALLERS PARAM BLOCK.                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0235
*   RFY                                                         01S0235
*     QMQBLK BASED(AQMQBPTR);                                   01S0235
*                                                               01S0235
*   /*****************************************************************/
*   /*                                                               */
*   /* INIT RELEASE MASK TO ZERO.                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0236
*   QMSKTRY(1:AQMLENGT)=ZMASK(1:AQMLENGT);/*                    01S0236
*                                                            @ZA15759*/
         L     @12,PARA                                         01S0236
         L     @11,AQMQBPTR(,@12)                               01S0236
         L     @11,QM2PTR(,@11)                                 01S0236
         L     @08,AQMLENGT(,@12)                               01S0236
         LR    @07,@08                                          01S0236
         BCTR  @07,0                                            01S0236
         EX    @07,@SM01256                                     01S0236
*   QMSKTRY(AQMLENGT+1:2*AQMLENGT)=ZMASK(AQMLENGT+1:2*AQMLENGT);/*
*                                                            @ZA15759*/
         ALR   @08,@11                                          01S0237
         L     @02,PARA                                         01S0237
         L     @02,AQMLENGT(,@02)                               01S0237
         LR    @15,@02                                          01S0237
         ALR   @15,@15                                          01S0237
         SLR   @15,@02                                          01S0237
         BCTR  @15,0                                            01S0237
         LA    @01,ZMASK(@02)                                   01S0237
         EX    @15,@SM01258                                     01S0237
*   IF AQMQCODE(1)=A THEN                                       01S0238
         CLI   AQMQCODE(@12),C'A'                               01S0238
         BNE   @RF00238                                         01S0238
*     /***************************************************************/
*     /*                                                             */
*     /* 'A'RELEASE WAS REQUESTED, PRIME 'A' SECTION OF RELEASE MASK.*/
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0239
*     QMSKTRY(1:AQMLENGT)=ENTMASK(1:AQMLENGT);                  01S0239
         L     @12,AQMMASKP(,@12)                               01S0239
         EX    @07,@SM01260                                     01S0239
*   ELSE                                                        01S0240
*     ;                                                         01S0240
@RF00238 DS    0H                                               01S0241
*   IF AQMQCODE(2)=B THEN                                       01S0241
*                                                               01S0241
         L     @12,PARA                                         01S0241
         CLI   AQMQCODE+1(@12),C'B'                             01S0241
         BNE   @RF00241                                         01S0241
*     /***************************************************************/
*     /*                                                             */
*     /* 'B' RELE SE WAS REQUESTED, PRIME 'B' SECTION OF A RELEASE   */
*     /* MASK.                                                       */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0242
*     QMSKTRY(AQMLENGT+1:2*AQMLENGT)=ENTMASK(1:AQMLENGT);       01S0242
         L     @11,AQMLENGT(,@12)                               01S0242
         L     @08,AQMQBPTR(,@12)                               01S0242
         L     @08,QM2PTR(,@08)                                 01S0242
         ALR   @08,@11                                          01S0242
         LR    @07,@11                                          01S0242
         ALR   @07,@07                                          01S0242
         SLR   @07,@11                                          01S0242
         BCTR  @07,0                                            01S0242
         L     @12,AQMMASKP(,@12)                               01S0242
         EX    @07,@SM01214                                     01S0242
*   ELSE                                                        01S0243
*     ;                                                         01S0243
*                                                               01S0243
@RF00241 DS    0H                                               01S0244
*   /*****************************************************************/
*   /*                                                               */
*   /* INSURE THAT RELEASE PATTERN CONTAINS ONLY GROUPS ACTUALLY     */
*   /* OWNED BY THE REQUESTOR BY ANDING MASKS TOGETHER. (THIS ALLOWS */
*   /* A CALLER OF THE ROUTINE TO REQUEST FULL RELEASE OF ALL HE OWNS*/
*   /* BY REQUESTING A RELEASE EVERYTHING.)                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0244
*   QMSKTRY(1:AQMLENGT)=QMSKTRY(1:AQMLENGT)&QMASKOWN(1:AQMLENGT);/*
*                                                            @ZA15759*/
         L     @12,PARA                                         01S0244
         L     @11,AQMQBPTR(,@12)                               01S0244
         L     @08,QM2PTR(,@11)                                 01S0244
         L     @12,AQMLENGT(,@12)                               01S0244
         LR    @07,@12                                          01S0244
         BCTR  @07,0                                            01S0244
         EX    @07,@SN01262                                     01S0244
*   QMSKTRY(AQMLENGT+1:2*AQMLENGT)=QMSKTRY(AQMLENGT+1:2*AQMLENGT)&QMASK
*WN(AQMLENGT+1:2*AQMLENGT);               /*                 @ZA15759*/
         ALR   @12,@08                                          01S0245
         L     @05,PARA                                         01S0245
         L     @05,AQMLENGT(,@05)                               01S0245
         LR    @02,@05                                          01S0245
         ALR   @02,@02                                          01S0245
         SLR   @02,@05                                          01S0245
         BCTR  @02,0                                            01S0245
         ALR   @11,@05                                          01S0245
         EX    @02,@SN01264                                     01S0245
*   QMSKTRY(1:AQMLENGT)=QMSKTRY(1:AQMLENGT)&MASKS(1:AQMLENGT);/*
*                                                            @ZA15759*/
         L     @12,CVTPTR                                       01S0246
         L     @12,CVTAQTOP(,@12)                               01S0246
         EX    @07,@SN01266                                     01S0246
*   QMSKTRY(AQMLENGT+1:2*AQMLENGT)=QMSKTRY(AQMLENGT+1:2*AQMLENGT)&MASKS
*AQMLENGT+1:2*AQMLENGT);               /*                    @ZA15759*/
         ALR   @08,@05                                          01S0247
         ALR   @12,@05                                          01S0247
         EX    @02,@SN01266                                     01S0247
*    RFY (R11,R12,R13,R14) RSTD;SV13=R13;GEN REFS(PSALITA);     01S0248
         LR    SV13,R13                                         01S0249
     SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,                           XX
               REGS=USE,RELATED=(ALLOC-QMGR,IEFAB4FA(UNLOCK))
     SETLOCK OBTAIN,TYPE=CMS,MODE=UNCOND,                             XX
               REGS=USE,RELATED=(ALLOC-QMGR,IEFAB4FA(UNLOCK))
*    R13=SV13;RFY (R11,R12,R13,R14) UNRSTD;                     01S0251
*                                                               01S0251
         LR    R13,SV13                                         01S0251
*   /*****************************************************************/
*   /*                                                               */
*   /* CLEAR LOCKS STILL SPECIFIED IN RELEASE MASK.                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0253
*   MASKS(1:AQMLENGT)=MASKS(1:AQMLENGT)&&QMSKTRY(1:AQMLENGT);/* 01S0253
*                                                            @ZA15759*/
         L     @12,CVTPTR                                       01S0253
         L     @12,CVTAQTOP(,@12)                               01S0253
         L     @11,PARA                                         01S0253
         L     @08,AQMLENGT(,@11)                               01S0253
         LR    @07,@08                                          01S0253
         BCTR  @07,0                                            01S0253
         L     @11,AQMQBPTR(,@11)                               01S0253
         L     @02,QM2PTR(,@11)                                 01S0253
         EX    @07,@SX01268                                     01S0253
*   MASKS(AQMLENGT+1:2*AQMLENGT)=MASKS(AQMLENGT+1:2*AQMLENGT)&&QMSKTRY(
*QMLENGT+1:2*AQMLENGT);               /*                     @ZA15759*/
         ALR   @08,@12                                          01S0254
         L     @01,PARA                                         01S0254
         L     @15,AQMLENGT(,@01)                               01S0254
         LR    @14,@15                                          01S0254
         ALR   @14,@14                                          01S0254
         SLR   @14,@15                                          01S0254
         BCTR  @14,0                                            01S0254
         ALR   @02,@15                                          01S0254
         EX    @14,@SX01270                                     01S0254
*   /*****************************************************************/
*   /*                                                               */
*   /* RECORD OWNERSHIP CHANGE IN CALLERS DATA.                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0255
*   QMASKOWN(1:AQMLENGT)=QMASKOWN(1:AQMLENGT)&MASKS(1:AQMLENGT);/*
*                                                            @ZA15759*/
         EX    @07,@SN01272                                     01S0255
*   QMASKOWN(AQMLENGT+1:2*AQMLENGT)=QMASKOWN(AQMLENGT+1:2*AQMLENGT)&MAS
*S(AQMLENGT+1:2*AQMLENGT);               /*                  @ZA15759*/
         ALR   @11,@15                                          01S0256
         ALR   @12,@15                                          01S0256
         EX    @14,@SN01272                                     01S0256
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS QUEUE OF TASKS WAITING FOR GROUPS ACCESS.             */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0257
*   CALL QPROC;                                                 01S0257
         BAL   @14,QPROC                                        01S0257
*    RFY (R11,R12,R13,R14) RSTD;SV13=R13;GEN;                   01S0258
         LR    SV13,R13                                         01S0259
     SETLOCK RELEASE,TYPE=CMS,                                        XX
               REGS=USE,RELATED=(ALLOC-QMGR,IEFAB4FA(LOCK))
     SETLOCK RELEASE,TYPE=LOCAL,                                      XX
               REGS=USE,RELATED=(ALLOC-QMGR,IEFAB4FA(LOCK))
*    R13=SV13;RFY (R11,R12,R13,R14) UNRSTD;                     01S0261
         LR    R13,SV13                                         01S0261
*    DO; /*MODESET  EXTKEY(SCHED)*/                             01S0263
*      SPKA (16); /*SET PSW KEY*/                               01S0264
         LA    @12,16                                           01S0264
         SPKA  0(@12)                                           01S0264
*    END; /*MODESET  EXTKEY(SCHED)*/                            01S0265
*   RETURN CODE(RETCODE);                                       01S0266
         L     @13,4(,@13)                                      01S0266
         L     @00,@SIZDATD                                     01S0266
         LR    @01,@03                                          01S0266
         FSPACE   R,LV=(0),A=(1)
         LR    @15,@06                                          01S0266
         L     @14,12(,@13)                                     01S0266
         LM    @00,@12,20(@13)                                  01S0266
         BR    @14                                              01S0266
*                                                               01S0267
*   /*****************************************************************/
*   /*                                                               */
*   /* THE TERMINATION ROUTINE FREES THE BLOCK IN COMMON OWNED BY THE*/
*   /* CALLER. TO ALLOW THIS ROUTINE TO BE USED UNDER ABNORMAL       */
*   /* TERMINATION CIRCUMSTANCES, PRIOR TO FREEING THE BLOCK ACTIONS */
*   /* ARE TAKEN TO INSURE CONTINUOUS INTEGRITY OF ALL QUEUES AND THE*/
*   /* GROUP-LOCK MASKS.                                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0267
*   ;                                                           01S0267
*                                                               01S0267
*   /*****************************************************************/
*   /*                                                               */
*   /* IF ANY GROUPS ARE STILL OWNED, THEY ARE RELEASED. IF THE BLOCK*/
*   /* IS CHAINED ON ANY QUEUES, IT IS DELETED FROM THOSE QUEUES.    */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0268
*TERML:                                                         01S0268
*    RFY (R11,R12,R13,R14) RSTD;SV13=R13;GEN REFS(PSALITA);     01S0268
TERML    DS    0H                                               01S0269
         LR    SV13,R13                                         01S0269
     SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,                           XX
               REGS=USE,RELATED=(ALLOC-QMGR,IEFAB4FA(UNLOCK))
     SETLOCK OBTAIN,TYPE=CMS,MODE=UNCOND,                             XX
               REGS=USE,RELATED=(ALLOC-QMGR,IEFAB4FA(UNLOCK))
*    R13=SV13;RFY (R11,R12,R13,R14) UNRSTD;                     01S0271
         LR    R13,SV13                                         01S0271
*   IF EXITPRMP ^= ZERO THEN           /*ESATE PARM LIST SUPPLIED    */
         L     @12,@PC00001+4                                   01S0273
         L     @12,EXITPRMP(,@12)                               01S0273
         LTR   @12,@12                                          01S0273
         BZ    @RF00273                                         01S0273
*     GENCLNUP = OFF;                  /*ESTAE WON'T DO GEN CLEANUP  */
         NI    GENCLNUP(@12),B'01111111'                        01S0274
*   RFY                                                         01S0275
*     QMQBLK BASED(AQMQBPTR);                                   01S0275
@RF00273 DS    0H                                               01S0276
*   IF(QMSTAT=A)|(QMSTAT=B)|(QMSTAT=WFD)THEN                    01S0276
*                                                               01S0276
         L     @12,PARA                                         01S0276
         L     @12,AQMQBPTR(,@12)                               01S0276
         CLI   QMSTAT(@12),C'A'                                 01S0276
         BE    @RT00276                                         01S0276
         CLI   QMSTAT(@12),C'B'                                 01S0276
         BE    @RT00276                                         01S0276
         CLI   QMSTAT(@12),C'W'                                 01S0276
         BNE   @RF00276                                         01S0276
@RT00276 DS    0H                                               01S0277
*     /***************************************************************/
*     /*                                                             */
*     /* CALLER IS ON ONE OF THE WAIT QUEUES, DETACH FROM QUEUE.     */
*     /* (OUT-OF-CORE ABEND COULD BE CAUSE OF THIS SITUATION         */
*     /* ARISING.)                                                   */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0277
*     CALL QMDELETQ(QMQBLK);                                    01S0277
         L     @12,PARA                                         01S0277
         L     @12,AQMQBPTR(,@12)                               01S0277
         ST    @12,@AL00001                                     01S0277
         LA    @01,@AL00001                                     01S0277
         BAL   @14,QMDELETQ                                     01S0277
*   ELSE                                                        01S0278
*     ;                                                         01S0278
@RF00276 DS    0H                                               01S0279
*   IF ZMASK(1:AQMLENGT)^=QMASKOWN(1:AQMLENGT)|/*               01S0279
*                                                            @ZA15759*/
*      ZMASK(AQMLENGT+1:2*AQMLENGT)^=QMASKOWN(AQMLENGT+1:2*AQMLENGT) TH
*N                                     /*                    @ZA15759*/
         L     @12,PARA                                         01S0279
         L     @11,AQMQBPTR(,@12)                               01S0279
         L     @12,AQMLENGT(,@12)                               01S0279
         LR    @08,@12                                          01S0279
         BCTR  @08,0                                            01S0279
         EX    @08,@SC01228                                     01S0279
         BNE   @RT00279                                         01S0279
         LR    @08,@12                                          01S0279
         ALR   @08,@08                                          01S0279
         SLR   @08,@12                                          01S0279
         BCTR  @08,0                                            01S0279
         LA    @02,ZMASK(@12)                                   01S0279
         ALR   @11,@12                                          01S0279
         EX    @08,@SC01275                                     01S0279
         BE    @RF00279                                         01S0279
@RT00279 DS    0H                                               01S0280
*     /***************************************************************/
*     /*                                                             */
*     /* CALLER STILL OWNS SOME GROUP(S), RELEASE WHATEVER HE OWNS   */
*     /* AND INVOKE THE QUEUE PROCESSOR FOR BOTH QUEUES.             */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0280
*     DO;                                                       01S0280
*       QMASKOWN(1:AQMLENGT)=(QMASKOWN(1:AQMLENGT)&MASKS(1:AQMLENGT));
         L     @12,PARA                                         01S0281
         L     @11,AQMQBPTR(,@12)                               01S0281
         L     @12,AQMLENGT(,@12)                               01S0281
         LR    @08,@12                                          01S0281
         BCTR  @08,0                                            01S0281
         L     @02,CVTPTR                                       01S0281
         L     @02,CVTAQTOP(,@02)                               01S0281
         EX    @08,@SN01277                                     01S0281
*                                              /*            @ZA15759*/
*       QMASKOWN(AQMLENGT+1:2*AQMLENGT)=(QMASKOWN(AQMLENGT+1:2*AQMLENGT
*&MASKS(AQMLENGT+1:2*AQMLENGT));               /*            @ZA15759*/
         ALR   @12,@11                                          01S0282
         L     @01,PARA                                         01S0282
         L     @15,AQMLENGT(,@01)                               01S0282
         LR    @14,@15                                          01S0282
         ALR   @14,@14                                          01S0282
         SLR   @14,@15                                          01S0282
         BCTR  @14,0                                            01S0282
         ALR   @15,@02                                          01S0282
         EX    @14,@SN01279                                     01S0282
*       MASKS(1:AQMLENGT)=(MASKS(1:AQMLENGT)&&QMASKOWN(1:AQMLENGT));
         EX    @08,@SX01281                                     01S0283
*                                              /*            @ZA15759*/
*       MASKS(AQMLENGT+1:2*AQMLENGT)=(MASKS(AQMLENGT+1:2*AQMLENGT)&&QMA
*KOWN(AQMLENGT+1:2*AQMLENGT));                 /*            @ZA15759*/
         L     @12,PARA                                         01S0284
         L     @12,AQMLENGT(,@12)                               01S0284
         ALR   @12,@02                                          01S0284
         L     @08,PARA                                         01S0284
         L     @08,AQMLENGT(,@08)                               01S0284
         ALR   @11,@08                                          01S0284
         EX    @14,@SX01283                                     01S0284
*       CALL QSCAN(QAF);                                        01S0285
         LA    @12,QAF(,@02)                                    01S0285
         ST    @12,@AL00001                                     01S0285
         LA    @01,@AL00001                                     01S0285
         BAL   @14,QSCAN                                        01S0285
*       CALL QSCAN(QBF);                                        01S0286
         L     @12,CVTPTR                                       01S0286
         L     @12,CVTAQTOP(,@12)                               01S0286
         LA    @12,QBF(,@12)                                    01S0286
         ST    @12,@AL00001                                     01S0286
         LA    @01,@AL00001                                     01S0286
         BAL   @14,QSCAN                                        01S0286
*     END;                                                      01S0287
*   ELSE                                                        01S0288
*     ;                                                         01S0288
*                                                               01S0288
@RF00279 DS    0H                                               01S0289
*   /*****************************************************************/
*   /*                                                               */
*   /* DETACH ELEMENT FROM COMPREHENSIVE LIST.                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0289
*   CALL QMDELETM(QMQBLK);                                      01S0289
*                                                               01S0289
         L     @12,PARA                                         01S0289
         L     @12,AQMQBPTR(,@12)                               01S0289
         ST    @12,@AL00001                                     01S0289
         LA    @01,@AL00001                                     01S0289
         BAL   @14,QMDELETM                                     01S0289
*   /*****************************************************************/
*   /*                                                               */
*   /* RELEASE CORE OCCUPIED BY THIS CALLERS QUEUE ELEMENT.          */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0290
*    RFY (R11,R12,R13,R14) RSTD;SV13=R13;GEN;                   01S0290
         LR    SV13,R13                                         01S0291
     SETLOCK RELEASE,TYPE=CMS,                                        XX
               REGS=USE,RELATED=(ALLOC-QMGR,IEFAB4FA(LOCK))
     SETLOCK RELEASE,TYPE=LOCAL,                                      XX
               REGS=USE,RELATED=(ALLOC-QMGR,IEFAB4FA(LOCK))
*    R13=SV13;RFY (R11,R12,R13,R14) UNRSTD;                     01S0293
         LR    R13,SV13                                         01S0293
*    RFY (R0,R1) RSTD;TEMPS=LENGTH(QMFLD1)+4*AQMLENGT;TEMP2=241;R0=TEMP
*;R1=AQMQBPTR;GEN                                               01S0295
         L     @12,PARA                                         01S0296
         L     @11,AQMLENGT(,@12)                               01S0296
         SLA   @11,2                                            01S0296
         AH    @11,@CH01208                                     01S0296
         ST    @11,TEMPS                                        01S0296
         MVI   TEMP2,X'F1'                                      01S0297
         L     R0,TEMPS                                         01S0298
         L     R1,AQMQBPTR(,@12)                                01S0299
*   ( FREEMAIN R,LV=(0),A=(1)); RFY (R0,R1) UNRSTD;             01S0300
          FREEMAIN R,LV=(0),A=(1)
*    DO; /*MODESET  EXTKEY(SCHED)*/                             01S0302
*      SPKA (16); /*SET PSW KEY*/                               01S0303
         LA    @12,16                                           01S0303
         SPKA  0(@12)                                           01S0303
*    END; /*MODESET  EXTKEY(SCHED)*/                            01S0304
*   RETURN CODE(OK);                                            01S0305
         L     @13,4(,@13)                                      01S0305
         L     @00,@SIZDATD                                     01S0305
         LR    @01,@03                                          01S0305
         FSPACE   R,LV=(0),A=(1)
         SLR   @15,@15                                          01S0305
         L     @14,12(,@13)                                     01S0305
         LM    @00,@12,20(@13)                                  01S0305
         BR    @14                                              01S0305
*                                                               01S0306
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS ROUTINE WAITS FOR DEVICES UNLESS GROUPS OWNED BY THE     */
*   /* CURRENT TASK HAD BEEN POSTED WHILE THE TASK WAS ACTIVE. (THIS */
*   /* IS NECESSARY BECAUSE UNALLOCATIONS ARE NOT INTERLOCKED WITH   */
*   /* ALLOCATIONS ON UCBS.)                                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0306
*WAITD:                                                         01S0306
*   RETCODE=OK;                                                 01S0306
WAITD    SLR   RETCODE,RETCODE                                  01S0306
*    RFY (R11,R12,R13,R14) RSTD;SV13=R13;GEN REFS(PSALITA);     01S0307
         LR    SV13,R13                                         01S0308
     SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,                           XX
               REGS=USE,RELATED=(ALLOC-QMGR,IEFAB4FA(UNLOCK))
     SETLOCK OBTAIN,TYPE=CMS,MODE=UNCOND,                             XX
               REGS=USE,RELATED=(ALLOC-QMGR,IEFAB4FA(UNLOCK))
*    R13=SV13;RFY (R11,R12,R13,R14) UNRSTD;                     01S0310
         LR    R13,SV13                                         01S0310
*   RFY                                                         01S0312
*     QMQBLK BASED(AQMQBPTR);                                   01S0312
*   IF QMSTAT=POSTED THEN                                       01S0313
*                                                               01S0313
         L     @12,PARA                                         01S0313
         L     @12,AQMQBPTR(,@12)                               01S0313
         CLI   QMSTAT(@12),C'P'                                 01S0313
         BNE   @RF00313                                         01S0313
*     /***************************************************************/
*     /*                                                             */
*     /* TASK WAS POSTED WHILE ACTIVE, RETURN IT TO ACTIVE STATUS AND*/
*     /* EXIT.                                                       */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0314
*     DO;                                                       01S0314
*       QMSTAT=ACTIVE;                                          01S0315
         MVI   QMSTAT(@12),C'E'                                 01S0315
*        RFY (R11,R12,R13,R14) RSTD;SV13=R13;GEN;               01S0316
         LR    SV13,R13                                         01S0317
         SETLOCK RELEASE,TYPE=CMS,                                    XX
               REGS=USE,RELATED=(ALLOC-QMGR,IEFAB4FA(LOCK))
         SETLOCK RELEASE,TYPE=LOCAL,                                  XX
               REGS=USE,RELATED=(ALLOC-QMGR,IEFAB4FA(LOCK))
*        R13=SV13;RFY (R11,R12,R13,R14) UNRSTD;                 01S0319
         LR    R13,SV13                                         01S0319
*     END;                                                      01S0321
*   ELSE                                                        01S0322
*                                                               01S0322
*     /***************************************************************/
*     /*                                                             */
*     /* TASK WAS NOT POSTED, PERFORM WAIT AS REQUESTED BY CALLER.   */
*     /* STATUS IS MARKED 'WAITING FOR DEVICE', THE PARAMETER MASK   */
*     /* INDICATING AWAIT GROUPS IS TRANSFERRED TO CALLERS QUEUE     */
*     /* ELEMENT, THE ELEMENT IS INSERTED ON 'WFD'QUEUE, AND WAIT    */
*     /* MACRO ISSUED.                                               */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0322
*     DO;                                                       01S0322
         B     @RC00313                                         01S0322
@RF00313 DS    0H                                               01S0323
*       QMSTAT=WFD;                                             01S0323
*                                                               01S0323
         L     @12,PARA                                         01S0323
         L     @11,AQMQBPTR(,@12)                               01S0323
         MVI   QMSTAT(@11),C'W'                                 01S0323
*       /*************************************************************/
*       /*                                                           */
*       /* SAVE GROUP-WAIT MASK IN CALLERS QUEUE ELEMENT.            */
*       /*                                                           */
*       /*************************************************************/
*                                                               01S0324
*       QMSKTRY(1:AQMLENGT)=ENTMASK(1:AQMLENGT);                01S0324
*                                                               01S0324
         L     @08,QM2PTR(,@11)                                 01S0324
         L     @02,AQMLENGT(,@12)                               01S0324
         BCTR  @02,0                                            01S0324
         L     @12,AQMMASKP(,@12)                               01S0324
         EX    @02,@SM01214                                     01S0324
*       /*************************************************************/
*       /*                                                           */
*       /* INSERT ON WFD QUEUE                                       */
*       /*                                                           */
*       /*************************************************************/
*                                                               01S0325
*       CALL QINSRT(QCB->QMNXTQF,QMNXTQF,QCB,QMQBLK);           01S0325
         L     @12,CVTPTR                                       01S0325
         L     @12,CVTAQTOP(,@12)                               01S0325
         L     @08,QCB(,@12)                                    01S0325
         LA    @08,QMNXTQF(,@08)                                01S0325
         ST    @08,@AL00001                                     01S0325
         LA    @08,QMNXTQF(,@11)                                01S0325
         ST    @08,@AL00001+4                                   01S0325
         LA    @12,QCB(,@12)                                    01S0325
         ST    @12,@AL00001+8                                   01S0325
         ST    @11,@AL00001+12                                  01S0325
         LA    @01,@AL00001                                     01S0325
         BAL   @14,QINSRT                                       01S0325
*        RFY (R11,R12,R13,R14) RSTD;SV13=R13;GEN;               01S0326
         LR    SV13,R13                                         01S0327
         SETLOCK RELEASE,TYPE=CMS,                                    XX
               REGS=USE,RELATED=(ALLOC-QMGR,IEFAB4FA(LOCK))
         SETLOCK RELEASE,TYPE=LOCAL,                                  XX
               REGS=USE,RELATED=(ALLOC-QMGR,IEFAB4FA(LOCK))
*        R13=SV13;RFY (R11,R12,R13,R14) UNRSTD;                 01S0329
         LR    R13,SV13                                         01S0329
*         R10=ADDR(AQMCANCP);GEN                                01S0331
         L     R10,PARA                                         01S0331
         LA    R10,AQMCANCP(,R10)                               01S0331
*   ( WAIT 1,ECBLIST=(R10),LONG=YES);IF CANCFLAG='1'B THEN RETCODE=CANC
*L;ELSE RETCODE=OK;QMECB=ZERO;                                  01S0332
          WAIT 1,ECBLIST=(R10),LONG=YES
         L     @12,PARA                                         01S0333
         L     @12,AQMCANCP(,@12)                               01S0333
         TM    CANCFLAG(@12),B'01000000'                        01S0333
         BNO   @RF00333                                         01S0333
         LA    RETCODE,16                                       01S0334
         B     @RC00333                                         01S0335
@RF00333 SLR   RETCODE,RETCODE                                  01S0335
@RC00333 L     @12,PARA                                         01S0336
         L     @12,AQMQBPTR(,@12)                               01S0336
         SLR   @11,@11                                          01S0336
         ST    @11,QMECB(,@12)                                  01S0336
*     END;                                                      01S0337
*    DO; /*MODESET  EXTKEY(SCHED)*/                             01S0338
@RC00313 DS    0H                                               01S0339
*      SPKA (16); /*SET PSW KEY*/                               01S0339
         LA    @12,16                                           01S0339
         SPKA  0(@12)                                           01S0339
*    END; /*MODESET  EXTKEY(SCHED)*/                            01S0340
*   RETURN CODE(RETCODE);                                       01S0341
         L     @13,4(,@13)                                      01S0341
         L     @00,@SIZDATD                                     01S0341
         LR    @01,@03                                          01S0341
         FSPACE   R,LV=(0),A=(1)
         LR    @15,@06                                          01S0341
         L     @14,12(,@13)                                     01S0341
         LM    @00,@12,20(@13)                                  01S0341
         BR    @14                                              01S0341
*                                                               01S0342
*   /*****************************************************************/
*   /*                                                               */
*   /* CALLED WHEN GROUPS HAVE BEEN RELEASED. PROCESSES EITHER A OR B*/
*   /* QUEUES OR BOTH DEPENDING ON SCOPE OF RELEASE.                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0342
*QPROC:                                                         01S0342
*   PROC;                                                       01S0342
QPROC    STM   @14,@12,@SA00002                                 01S0342
*   IF AQMQCODE(1)=A THEN                                       01S0343
*                                                               01S0343
         L     @12,PARA                                         01S0343
         CLI   AQMQCODE(@12),C'A'                               01S0343
         BNE   @RF00343                                         01S0343
*     /***************************************************************/
*     /*                                                             */
*     /* CALLER RELEASED 'A' CLASS OF OWNERSHIP, PROCESS THE 'A' WAIT*/
*     /* QUEUE.                                                      */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0344
*     CALL QSCAN(QAF);                                          01S0344
*                                                               01S0344
         L     @12,CVTPTR                                       01S0344
         L     @12,CVTAQTOP(,@12)                               01S0344
         LA    @12,QAF(,@12)                                    01S0344
         ST    @12,@AL00001                                     01S0344
         LA    @01,@AL00001                                     01S0344
         BAL   @14,QSCAN                                        01S0344
*   /*****************************************************************/
*   /*                                                               */
*   /* ALWAYS PROCESS THE 'B' WAIT QUEUE BECAUSE IT WAITS FOR ACCESS */
*   /* TO BOTH LOCKS.                                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0345
*   CALL QSCAN(QBF);                                            01S0345
@RF00343 L     @12,CVTPTR                                       01S0345
         L     @12,CVTAQTOP(,@12)                               01S0345
         LA    @12,QBF(,@12)                                    01S0345
         ST    @12,@AL00001                                     01S0345
         LA    @01,@AL00001                                     01S0345
         BAL   @14,QSCAN                                        01S0345
*   RETURN;                                                     01S0346
@EL00002 DS    0H                                               01S0346
@EF00002 DS    0H                                               01S0346
@ER00002 LM    @14,@12,@SA00002                                 01S0346
         BR    @14                                              01S0346
*   END;                                                        01S0347
*                                                               01S0348
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS INNER PROC SCANS ONE OF THE TWO GROUP WAIT QUEUES AND    */
*   /* MAKES ANY POSSIBLE GROUP ASSIGNMENTS ON FIRST-COME            */
*   /* FIRST-SERVED BASIS. THE APPROPRIATE TASK IS POSTED.           */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0348
*QSCAN:                                                         01S0348
*   PROC(IQ);                                                   01S0348
*                                                               01S0348
QSCAN    STM   @14,@12,@SA00003                                 01S0348
         MVC   @PC00003(4),0(@01)                               01S0348
*   /*****************************************************************/
*   /*                                                               */
*   /* IQ IS MERELY CONVENIENCE LABEL FOR Q HEAD PASSED BY CALLER.   */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0349
*   DCL                                                         01S0349
*     IQ PTR(31);                                               01S0349
*                                                               01S0349
*   /*****************************************************************/
*   /*                                                               */
*   /* START Q ELEMENT BASE AT Q HEAD.                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0350
*   SQPTR=IQ;                                                   01S0350
*                                                               01S0350
         L     @12,@PC00003                                     01S0350
         L     SQPTR,IQ(,@12)                                   01S0350
*   /*****************************************************************/
*   /*                                                               */
*   /* BASE Q ELEMENT ON LOCAL.                                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0351
*   RFY                                                         01S0351
*     QMQBLK BASED(SQPTR);                                      01S0351
*                                                               01S0351
*   /*****************************************************************/
*   /*                                                               */
*   /* SCAN ENTIRE QUEUE, PROCESSING ONLY MEMBERS WHICH ARE ELIGIBLE */
*   /* FOR ASSIGNMENT.                                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0352
*   DO WHILE(ADDR(QMNXTQF)^=ADDR(IQ));                          01S0352
         B     @DE00352                                         01S0352
@DL00352 DS    0H                                               01S0353
*     TEMPAREA(1:AQMLENGT)=(QMSKTRY(1:AQMLENGT)&MASKS(1:AQMLENGT));/*
*                                                            @ZA15759*/
         L     @12,PARA                                         01S0353
         L     @12,AQMLENGT(,@12)                               01S0353
         LR    @11,@12                                          01S0353
         BCTR  @11,0                                            01S0353
         L     @08,QM2PTR(,SQPTR)                               01S0353
         L     @04,CVTPTR                                       01S0353
         L     @04,CVTAQTOP(,@04)                               01S0353
         EX    @11,@SM01285                                     01S0353
         EX    @11,@SN01287                                     01S0353
*     TEMPAREA(AQMLENGT+1:2*AQMLENGT)=(QMSKTRY(AQMLENGT+1:2*AQMLENGT) &
*MASKS(AQMLENGT+1:2*AQMLENGT));               /*             @ZA15759*/
         LA    @02,TEMPAREA(@12)                                01S0354
         LR    @15,@12                                          01S0354
         ALR   @15,@15                                          01S0354
         SLR   @15,@12                                          01S0354
         BCTR  @15,0                                            01S0354
         ALR   @08,@12                                          01S0354
         EX    @15,@SM01289                                     01S0354
         ALR   @04,@12                                          01S0354
         EX    @15,@SN01291                                     01S0354
*     IF ZMASK(1:AQMLENGT)=TEMPAREA(1:AQMLENGT) &/*             01S0355
*                                                            @ZA15759*/
*        ZMASK(AQMLENGT+1:2*AQMLENGT)=TEMPAREA(AQMLENGT+1:2*AQMLENGT) T
*EN                                    /*                    @ZA15759*/
         EX    @11,@SC01224                                     01S0355
         BNE   @RF00355                                         01S0355
         LA    @11,ZMASK(@12)                                   01S0355
         LA    @08,TEMPAREA(@12)                                01S0355
         EX    @15,@SC01293                                     01S0355
         BNE   @RF00355                                         01S0355
*       /*************************************************************/
*       /*                                                           */
*       /* CURRENT ELEMENT IS ELIGIBLE, PERFORM ASSIGNMENT AND       */
*       /* REINSTATE THE ASSOCIATED TASK TO ACTIVE STATE.            */
*       /*                                                           */
*       /*************************************************************/
*                                                               01S0356
*       DO;                                                     01S0356
*                                                               01S0356
*         /***********************************************************/
*         /*                                                         */
*         /* DETACH CURRENT ELEMENT FROM Q IT IS ON.                 */
*         /*                                                         */
*         /***********************************************************/
*                                                               01S0357
*         CALL QMDELETQ(QMQBLK);                                01S0357
*                                                               01S0357
         ST    SQPTR,@AL00001                                   01S0357
         LA    @01,@AL00001                                     01S0357
         BAL   @14,QMDELETQ                                     01S0357
*         /***********************************************************/
*         /*                                                         */
*         /* MARK OWNERSHIP IN GLOBAL GROUP LOCKS                    */
*         /*                                                         */
*         /***********************************************************/
*                                                               01S0358
*         MASKS(1:AQMLENGT)=MASKS(1:AQMLENGT)|QMSKTRY(1:AQMLENGT);/*
*                                                            @ZA15759*/
         L     @12,CVTPTR                                       01S0358
         L     @12,CVTAQTOP(,@12)                               01S0358
         L     @11,PARA                                         01S0358
         L     @11,AQMLENGT(,@11)                               01S0358
         LR    @08,@11                                          01S0358
         BCTR  @08,0                                            01S0358
         L     @06,QM2PTR(,SQPTR)                               01S0358
         EX    @08,@SO01295                                     01S0358
*         MASKS(AQMLENGT+1:2*AQMLENGT)=MASKS(AQMLENGT+1:2*AQMLENGT)|QMS
*TRY(AQMLENGT+1:2*AQMLENGT);               /*                @ZA15759*/
         ALR   @12,@11                                          01S0359
         LR    @04,@11                                          01S0359
         ALR   @04,@04                                          01S0359
         SLR   @04,@11                                          01S0359
         BCTR  @04,0                                            01S0359
         ALR   @11,@06                                          01S0359
         EX    @04,@SO01297                                     01S0359
*         /***********************************************************/
*         /*                                                         */
*         /* ALSO MARK OWNERSHIP IN THAT TASKS Q ELEMENT.            */
*         /*                                                         */
*         /***********************************************************/
*                                                               01S0360
*         QMASKOWN(1:AQMLENGT)=QMASKOWN(1:AQMLENGT)|QMSKTRY(1:AQMLENGT)
         EX    @08,@SO01299                                     01S0360
*                                                /*          @ZA15759*/
*         QMASKOWN(AQMLENGT+1:2*AQMLENGT)=QMASKOWN(AQMLENGT+1:2*AQMLENG
*)|QMSKTRY(AQMLENGT+1:2*AQMLENGT);               /*          @ZA15759*/
         L     @12,PARA                                         01S0361
         L     @12,AQMLENGT(,@12)                               01S0361
         ALR   @12,SQPTR                                        01S0361
         L     @11,PARA                                         01S0361
         L     @11,AQMLENGT(,@11)                               01S0361
         ALR   @06,@11                                          01S0361
         EX    @04,@SO01301                                     01S0361
*         /***********************************************************/
*         /*                                                         */
*         /* MARK IT ACTIVE.                                         */
*         /*                                                         */
*         /***********************************************************/
*                                                               01S0362
*         QMSTAT=ACTIVE;                                        01S0362
*                                                               01S0362
         MVI   QMSTAT(SQPTR),C'E'                               01S0362
*         /***********************************************************/
*         /*                                                         */
*         /* AND POST THE TASK.                                      */
*         /*                                                         */
*         /***********************************************************/
*                                                               01S0363
*          RFY (R10,R11,R12,R4) RSTD;POSTWRK=ADDR(QMECB);XMFLG='1'B;
         LA    @08,QMECB(,SQPTR)                                01S0364
         ST    @08,POSTWRK                                      01S0364
         OI    XMFLG,B'10000000'                                01S0365
*          GEN( STM 14,12,12(13));R4=R13;R10=OK;R11=POSTWRK;R12=POSTERA
*;ASVTPTR = CVTASVT;ASCBENTP = ADDR(ASVTENTY)+(LENGTH(ASVTENTY)*(QMASID
*1));R13=ASCBADDR;CALL IEA0PT01;R13=R4;                         01S0366
          STM 14,12,12(13)
         LR    R4,R13                                           01S0367
         SLR   R10,R10                                          01S0368
         L     R11,POSTWRK                                      01S0369
         L     R12,POSTERAD                                     01S0370
         L     @08,CVTPTR                                       01S0371
         L     ASVTPTR,CVTASVT(,@08)                            01S0371
         LA    ASCBENTP,ASVTENTY(,ASVTPTR)                      01S0372
         L     @06,QMASID(,SQPTR)                               01S0372
         BCTR  @06,0                                            01S0372
         SLL   @06,2                                            01S0372
         ALR   ASCBENTP,@06                                     01S0372
         L     R13,ASCBADDR(,ASCBENTP)                          01S0373
         L     @15,CVT0PT01(,@08)                               01S0374
         BALR  @14,@15                                          01S0374
         LR    R13,R4                                           01S0375
*          GEN( LM 14,12,12(13));RFY (R10,R11,R12,R4) UNRSTD;   01S0376
          LM 14,12,12(13)
*       END;                                                    01S0378
*     ELSE                                                      01S0379
*       ;                                                       01S0379
*                                                               01S0379
@RF00355 DS    0H                                               01S0380
*     /***************************************************************/
*     /*                                                             */
*     /* STEP Q ELEMENT PTR THRU CHAIN FOR NXT DO ITERATION.         */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0380
*     SQPTR=QMNXTQF;                                            01S0380
         L     SQPTR,QMNXTQF(,SQPTR)                            01S0380
*   END;                                                        01S0381
@DE00352 LA    @12,QMNXTQF(,SQPTR)                              01S0381
         L     @11,@PC00003                                     01S0381
         CR    @12,@11                                          01S0381
         BNE   @DL00352                                         01S0381
*   RETURN;                                                     01S0382
@EL00003 DS    0H                                               01S0382
@EF00003 DS    0H                                               01S0382
@ER00003 LM    @14,@12,@SA00003                                 01S0382
         BR    @14                                              01S0382
*   END;                                                        01S0383
*                                                               01S0384
*   /*****************************************************************/
*   /*                                                               */
*   /* DELETE AN ELEMENT FROM A WAIT QUEUE                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0384
*   ;                                                           01S0384
*                                                               01S0384
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS FUNCTION TRANSFERS THE FORWARD AND BACKWARD POINTERS FROM*/
*   /* THE BLOCK INDICATED BY THE PARAMETER TO ITS NEIGHBORING       */
*   /* BLOCKS, THUS DETACHING THE BLOCK FROM THE CHAIN. DUE TO THE   */
*   /* METHOD OF CHAINING, THE ROUTINE IS EQUALLY APPLICABLE WHEN    */
*   /* EITHER OR BOTH NEIGHBOR BLOCKS IS THE QUEUE ROOT. THE CHAINS  */
*   /* ARE ALWAYS CIRCULAR, SO WHEN 'NEXT ELEMENT' IN EITHER         */
*   /* DIRECTION IS THE Q HEAD, THE QUEUE HEAD ITSELF IS THE ACTUAL  */
*   /* HEAD BEING MODIFIED.HOWEVER, NOTE THAT PTRS TO THE Q HEAD     */
*   /* POINT ACTUALLY TO A LOC WHICH WHEN ADDED TO THE OFFSET OF THE */
*   /* CHAIN FIELDS IN A Q ELEMENT YIELDS THE LOC OF THE Q HEAD. NOTE*/
*   /* ALSO THAT ALL WAIT QUEUES USE SAME CHAIN FIELDS IN THE Q      */
*   /* ELEMENT BUT ARE ROOTED IN DIFFERENT Q HEADS.                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0385
*QMDELETQ:                                                      01S0385
*   PROC(QDPTR);                                                01S0385
QMDELETQ STM   @14,@12,12(@13)                                  01S0385
         MVC   @PC00004(4),0(@01)                               01S0385
*   RFY                                                         01S0386
*     QMQBLK BASED(ADDR(QDPTR));                                01S0386
*                                                               01S0386
*   /*****************************************************************/
*   /*                                                               */
*   /* MOVE BKWD PTR FROM THIS BLOCK TO ITS NEXT FWD NEIGHBOR BLOCK. */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0387
*   QMNXTQF->QMNXTQB=QMNXTQB;                                   01S0387
*                                                               01S0387
         L     @12,@PC00004                                     01S0387
         L     @11,QMNXTQF(,@12)                                01S0387
         L     @12,QMNXTQB(,@12)                                01S0387
         ST    @12,QMNXTQB(,@11)                                01S0387
*   /*****************************************************************/
*   /*                                                               */
*   /* MOVE FWD PTR FROM THIS BLK TO ITS NEXT BKWD NEIGHBOR BLOCK.   */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0388
*   QMNXTQB->QMNXTQF=QMNXTQF;                                   01S0388
         ST    @11,QMNXTQF(,@12)                                01S0388
*   RETURN;                                                     01S0389
@EL00004 DS    0H                                               01S0389
@EF00004 DS    0H                                               01S0389
@ER00004 LM    @14,@12,12(@13)                                  01S0389
         BR    @14                                              01S0389
*   END;                                                        01S0390
*                                                               01S0391
*   /*****************************************************************/
*   /*                                                               */
*   /* DELETE AN ELEMENT FROM THE MASTER LIST                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0391
*   ;                                                           01S0391
*                                                               01S0391
*   /*****************************************************************/
*   /*                                                               */
*   /* IDENTICAL TO THE QMDELETQ PROCEDURE, EXCEPT THIS PROCEDURE    */
*   /* USES THE SYMBOLS FOR THE MAIN QUEUE POINTERS.                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0392
*QMDELETM:                                                      01S0392
*   PROC(QEPTR);                                                01S0392
QMDELETM STM   @14,@12,12(@13)                                  01S0392
         MVC   @PC00005(4),0(@01)                               01S0392
*   RFY                                                         01S0393
*     QMQBLK BASED(ADDR(QEPTR));                                01S0393
*                                                               01S0393
*   /*****************************************************************/
*   /*                                                               */
*   /* MOVE BKWD PTR OUT OF CURRENT BLK TO ITS NXT FWD NEIGHBOR.     */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0394
*   QMNXTF->QMNXTB=QMNXTB;                                      01S0394
*                                                               01S0394
         L     @12,@PC00005                                     01S0394
         L     @11,QMNXTF(,@12)                                 01S0394
         L     @12,QMNXTB(,@12)                                 01S0394
         ST    @12,QMNXTB(,@11)                                 01S0394
*   /*****************************************************************/
*   /*                                                               */
*   /* MOVE FWD PTR OUT OF CURRENT BLK TO ITS NXT BKWD NEIGHBOR.     */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0395
*   QMNXTB->QMNXTF=QMNXTF;                                      01S0395
         ST    @11,QMNXTF(,@12)                                 01S0395
*   RETURN;                                                     01S0396
@EL00005 DS    0H                                               01S0396
@EF00005 DS    0H                                               01S0396
@ER00005 LM    @14,@12,12(@13)                                  01S0396
         BR    @14                                              01S0396
*   END;                                                        01S0397
*                                                               01S0398
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS ROUTINE WILL INSERT AN ELEMENT ON ANY QUEUE, INCLUDING   */
*   /* THE MAIN QUEUE. PARAMETERS ARE: BLOCK BEING INSERTED (NEW),   */
*   /* ITS AFFECTED CHAINING FIELDS (CHAINS), AND THE AFFECTED       */
*   /* CHAINING FIELDS OF BOTH OF ITS INTENDED NEIGHBOR BLOCKS       */
*   /* (OLDL,OLDR). IN ACTUAL USE IN THIS MODULE, NXT FWD NEIGHBOR IS*/
*   /* ALWAYS THE Q HEAD. HOWEVER ROUTINE AS IMPLEMENTED WILL INSERT */
*   /* ANYWHERE ON A CHAIN OF THIS TYPE.                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0398
*QINSRT:                                                        01S0398
*   PROC(OLDL,CHAINS,OLDR,NEW);                                 01S0398
QINSRT   STM   @14,@12,12(@13)                                  01S0398
         MVC   @PC00006(16),0(@01)                              01S0398
*   DCL                                                         01S0399
*     1 CHAINS,                                                 01S0399
*      2 LEFT PTR(31),                                          01S0399
*      2 RIGHT PTR(31);                                         01S0399
*   DCL                                                         01S0400
*     OLDL PTR(31);                                             01S0400
*   DCL                                                         01S0401
*     OLDR PTR(31);                                             01S0401
*   DCL                                                         01S0402
*     NEW CHAR(*);                                              01S0402
*                                                               01S0402
*   /*****************************************************************/
*   /*                                                               */
*   /* COPY FWD PTR FROM LEFT NEIGHBOR.                              */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0403
*   LEFT=OLDL;                                                  01S0403
*                                                               01S0403
         L     @12,@PC00006+4                                   01S0403
         L     @11,@PC00006                                     01S0403
         MVC   LEFT(4,@12),OLDL(@11)                            01S0403
*   /*****************************************************************/
*   /*                                                               */
*   /* COPY BKWD PTR FROM RIGHT NEIGHBOR. (ALWAYS ROOT)              */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0404
*   RIGHT=OLDR;                                                 01S0404
*                                                               01S0404
         L     @08,@PC00006+8                                   01S0404
         MVC   RIGHT(4,@12),OLDR(@08)                           01S0404
*   /*****************************************************************/
*   /*                                                               */
*   /* CHANGE BOTH PTRS JUST COPIED TO POINT TO BLK JUST INSERTED.   */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0405
*   OLDL=ADDR(NEW);                                             01S0405
         L     @12,@PC00006+12                                  01S0405
         ST    @12,OLDL(,@11)                                   01S0405
*   OLDR=ADDR(NEW);                                             01S0406
         ST    @12,OLDR(,@08)                                   01S0406
*   IF EXITPRMP ^= ZERO THEN           /*ESTAE PARM LIST SUPPLIED    */
         L     @12,@PC00001+4                                   01S0407
         L     @12,EXITPRMP(,@12)                               01S0407
         LTR   @12,@12                                          01S0407
         BZ    @RF00407                                         01S0407
*     DO;                                                       01S0408
*       FREECORE = OFF;                /*ESTAE WON'T FREE Q-MGR CORE */
*       GENCLNUP = ON;                 /*DO GENERIC CLEANUP IF ABEND */
         OI    GENCLNUP(@12),B'10000000'                        01S0410
         NI    FREECORE(@12),B'11111011'                        01S0410
*     END;                                                      01S0411
*   RETURN;                                                     01S0412
@EL00006 DS    0H                                               01S0412
@EF00006 DS    0H                                               01S0412
@ER00006 LM    @14,@12,12(@13)                                  01S0412
         BR    @14                                              01S0412
*   END;                                                        01S0413
         B     @EL00006                                         01S0413
*   END                                                         01S0414
*                                                               01S0414
*   /*****************************************************************/
*   /*                                                               */
*   /* END OF PROCEDURE IEFAB4FA.                                    */
*   /*                                                               */
*   /*****************************************************************/
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (A4FASPEC)                                        *
*/*%INCLUDE SYSLIB  (A4FADATA)                                        *
*/*%INCLUDE SYSLIB  (IHAPSA  )                                        *
*/*%INCLUDE SYSLIB  (IEFZB427)                                        *
*/*%INCLUDE SYSLIB  (IEFZB447)                                        *
*/*%INCLUDE SYSLIB  (CVT     )                                        *
*/*%INCLUDE SYSLIB  (IHAASVT )                                        *
*;                                                              01S0414
@DATA    DS    0H
@CH01208 DC    H'29'
@SM01210 MVC   QMSKTRY(0,@08),ZMASK
@SM01212 MVC   QMSKTRY(0,@07),0(@01)
@SM01214 MVC   QMSKTRY(0,@08),ENTMASK(@12)
@SM01216 MVC   TEMPAREA(0),QMSKTRY(@12)
@SN01218 NC    TEMPAREA(0),MASKS(@07)
@SM01220 MVC   0(0,@02),QMSKTRY(@12)
@SN01222 NC    0(0,@02),MASKS(@07)
@SC01224 CLC   ZMASK(0),TEMPAREA
@SC01226 CLC   0(0,@12),0(@08)
@SC01228 CLC   ZMASK(0),QMASKOWN(@11)
@SN01230 NC    QMASKOWN(0,@11),MASKS(@08)
@SX01232 XC    MASKS(0,@08),QMASKOWN(@11)
@SO01234 OC    QMSKTRY(0,@02),QMASKOWN(@11)
@SM01236 MVC   QMASKOWN(0,@11),ZMASK
@SO01238 OC    MASKS(0,@12),QMSKTRY(@05)
@SO01240 OC    MASKS(0,@12),QMSKTRY(@08)
@SO01242 OC    QMASKOWN(0,@11),QMSKTRY(@05)
@SO01244 OC    QMASKOWN(0,@12),QMSKTRY(@05)
@SM01248 MVC   TEMPAREA(0),QMASKOWN(@07)
@SN01250 NC    TEMPAREA(0),ENTMASK(@12)
@SM01252 MVC   TEMPAREA(0),QMSKTRY(@11)
@SN01254 NC    TEMPAREA(0),ENTMASK(@07)
@SM01256 MVC   QMSKTRY(0,@11),ZMASK
@SM01258 MVC   QMSKTRY(0,@08),0(@01)
@SM01260 MVC   QMSKTRY(0,@11),ENTMASK(@12)
@SN01262 NC    QMSKTRY(0,@08),QMASKOWN(@11)
@SN01264 NC    QMSKTRY(0,@12),QMASKOWN(@11)
@SN01266 NC    QMSKTRY(0,@08),MASKS(@12)
@SX01268 XC    MASKS(0,@12),QMSKTRY(@02)
@SX01270 XC    MASKS(0,@08),QMSKTRY(@02)
@SN01272 NC    QMASKOWN(0,@11),MASKS(@12)
@SC01275 CLC   0(0,@02),QMASKOWN(@11)
@SN01277 NC    QMASKOWN(0,@11),MASKS(@02)
@SN01279 NC    QMASKOWN(0,@12),MASKS(@15)
@SX01281 XC    MASKS(0,@02),QMASKOWN(@11)
@SX01283 XC    MASKS(0,@12),QMASKOWN(@11)
@SM01285 MVC   TEMPAREA(0),QMSKTRY(@08)
@SN01287 NC    TEMPAREA(0),MASKS(@04)
@SM01289 MVC   0(0,@02),QMSKTRY(@08)
@SN01291 NC    0(0,@02),MASKS(@04)
@SC01293 CLC   0(0,@11),0(@08)
@SO01295 OC    MASKS(0,@12),QMSKTRY(@06)
@SO01297 OC    MASKS(0,@12),QMSKTRY(@11)
@SO01299 OC    QMASKOWN(0,SQPTR),QMSKTRY(@06)
@SO01301 OC    QMASKOWN(0,@12),QMSKTRY(@06)
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    2F
@SA00003 DS    15F
@PC00003 DS    1F
@PC00006 DS    4F
@PC00004 DS    1F
@SA00002 DS    15F
@PC00005 DS    1F
@AL00001 DS    4A
IEFAB4FA CSECT
         DS    0F
@CF00114 DC    F'2'
@DATD    DSECT
         DS    0D
POSTWRK  DS    AL4
         ORG   POSTWRK
XMFLG    DS    BL1
         ORG   POSTWRK+4
PARA     DS    A
TEMPS    DS    FL4
         ORG   TEMPS
TEMP2    DS    FL1
         ORG   TEMPS+4
LOCKCODE DS    F
TEMPAREA DS    CL480
IEFAB4FA CSECT
         DS    0F
@SIZDATD DC    AL1(230)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
POSTERAD DC    AL4(POSTERR)
GTSTZERO DC    F'0'
ZMASK    DS    CL480
         ORG   ZMASK
@NM00031 DC    B'00000000'
         DC    XL256'0'
         DC    XL223'0'
         ORG   ZMASK+480
ROUTINE  DC    AL4(INITL)
         DC    AL4(TERML)
         DC    AL4(ACQUR)
         DC    AL4(RELSE)
         DC    AL4(WAITD)
         DC    AL4(POSTD)
IEFAB4FA CSECT
         DS   0H
PATCHLOC DC ((@DATA-@PSTART)/20)X'00'
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEFAB4FA CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
GTSTRTCD EQU   @12
SV13     EQU   @04
SQPTR    EQU   @05
PQPTR    EQU   @05
RETCODE  EQU   @06
TEMP     EQU   @08
ASVTPTR  EQU   @02
ASCBENTP EQU   @07
R4       EQU   @04
R10      EQU   @10
CODEREG  EQU   @15
R0       EQU   @00
R1       EQU   @01
R11      EQU   @11
R12      EQU   @12
R13      EQU   @13
R14      EQU   @14
GTSTR0   EQU   @00
GTSTR1   EQU   @01
GTSTR2   EQU   @02
GTSTR15  EQU   @15
GTSTR4   EQU   @04
GTSTR5   EQU   @05
GTSTR6   EQU   @06
GTSTR7   EQU   @07
GTSTR8   EQU   @08
GPR00F   EQU   @00
GPR00P   EQU   @00
GPR01F   EQU   @01
GPR01P   EQU   @01
GPR14F   EQU   @14
GPR14P   EQU   @14
GPR15F   EQU   @15
GPR15P   EQU   @15
GTSTR3   EQU   @03
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSALITA  EQU   PSA+764
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
CVTPTR   EQU   16
IEA0PT01 EQU   0
AQMPARAM EQU   0
AQMECODE EQU   AQMPARAM
AQMQCODE EQU   AQMPARAM+2
AQMMASKP EQU   AQMPARAM+4
AQMASID  EQU   AQMPARAM+8
AQMLENGT EQU   AQMPARAM+12
AQMCANCP EQU   AQMPARAM+16
AQMNORMP EQU   AQMPARAM+20
AQMPFLG  EQU   AQMNORMP
AQMQBPTR EQU   AQMPARAM+24
PRMESTAE EQU   0
PRMRESC  EQU   PRMESTAE+252
PRMFUNC  EQU   PRMESTAE+253
GENCLNUP EQU   PRMFUNC
FREECORE EQU   PRMFUNC
PRMQMBLN EQU   PRMESTAE+268
PRMQMBP  EQU   PRMESTAE+272
QMQBLK   EQU   0
QMFLD1   EQU   QMQBLK
QMNXTF   EQU   QMFLD1
QMNXTB   EQU   QMFLD1+4
QMNXTQF  EQU   QMFLD1+8
QMNXTQB  EQU   QMFLD1+12
QMECB    EQU   QMFLD1+16
QMASID   EQU   QMFLD1+20
QM2PTR   EQU   QMFLD1+24
QMSTAT   EQU   QMFLD1+28
QMASKOWN EQU   QMQBLK+29
QMSKTRY  EQU   0
ROOTS    EQU   0
MAINF    EQU   ROOTS
MAINB    EQU   ROOTS+4
QAF      EQU   ROOTS+8
QAB      EQU   ROOTS+12
QBF      EQU   ROOTS+16
QBB      EQU   ROOTS+20
QCF      EQU   ROOTS+24
QCB      EQU   ROOTS+28
MASKS    EQU   ROOTS+32
ASCBADDR EQU   0
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVT0PT01 EQU   CVTMAP+152
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
ASVT     EQU   0
ASVTFRST EQU   ASVT+524
ASVTENTY EQU   ASVT+528
ENTMASK  EQU   0
@NM00032 EQU   0
CANCFLAG EQU   @NM00032
IKEBC    EQU   0
IKEBF15  EQU   0
IKEBF31  EQU   0
IKEBP15  EQU   0
IKEBP31  EQU   0
IKEBP8   EQU   0
RPARA    EQU   0
EXITPRMP EQU   0
IQ       EQU   0
QDPTR    EQU   0
QEPTR    EQU   0
OLDL     EQU   0
CHAINS   EQU   0
LEFT     EQU   CHAINS
RIGHT    EQU   CHAINS+4
OLDR     EQU   0
NEW      EQU   0
PSARSVTE EQU   PSARSVT
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTAQTOP EQU   CVTS01+200
CVTASVT  EQU   CVTS01+208
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
FLC      EQU   PSA
*                                      START UNREFERENCED COMPONENTS
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTVVMDI EQU   CVTS01+204
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
@NM00033 EQU   @NM00032
ASVTEND  EQU   ASVT+528
ASVTAVAL EQU   ASVTENTY
ASVTAVAI EQU   ASVTFRST
ASVTRS00 EQU   ASVT+520
ASVTMAXU EQU   ASVT+516
ASVTASVT EQU   ASVT+512
ASVTBEGN EQU   ASVT+512
@NM00030 EQU   ASVT
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00029 EQU   CVTFIX+248
@NM00028 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
QMECBFLG EQU   QMECB
PRMNELM  EQU   PRMESTAE+288
PRMDSQF  EQU   PRMESTAE+284
PRMDSQL  EQU   PRMESTAE+280
PRMQDBP  EQU   PRMESTAE+276
PRMQMGP  EQU   PRMESTAE+264
PRMUCBP  EQU   PRMESTAE+260
PRMSIOTP EQU   PRMESTAE+256
PRMASID  EQU   PRMESTAE+254
@NM00027 EQU   PRMFUNC
VMVCALL  EQU   PRMFUNC
DUMPOK   EQU   PRMFUNC
TIOTBLT  EQU   PRMFUNC
DSABCHN  EQU   PRMFUNC
UPDSABCK EQU   PRMFUNC
@NM00026 EQU   PRMRESC
TPQ      EQU   PRMRESC
DSSUNREC EQU   PRMRESC
DSSTAP   EQU   PRMRESC
CHNGQ    EQU   PRMRESC
DDRQ     EQU   PRMRESC
ENQQ4    EQU   PRMRESC
@NM00025 EQU   PRMESTAE
@NM00024 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00023 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00022 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00021 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00020 EQU   FLCFSA
@NM00019 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00018 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00017 EQU   FLCIOA
@NM00016 EQU   FLCMCLA+15
@NM00015 EQU   FLCMCLA+14
@NM00014 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00013 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00012 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00011 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00010 EQU   FLCPER
@NM00009 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00008 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00007 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00006 EQU   FLCPIILC
@NM00005 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00004 EQU   FLCSVILC
@NM00003 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00002 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00001 EQU   FLCICCW2+4
FLCCVT   EQU   FLCICCW2
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
*                                      END UNREFERENCED COMPONENTS
@RF00407 EQU   @EL00006
@ENDDATA EQU   *
         END   IEFAB4FA,(C'PLS1345',0701,76342)
