         TITLE 'IEFBB410 - INITIATOR/UNALLOCATION INTERFACE            *
                        '
IEFBB410 CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(24)                                          01S0001
         DC    C'IEFBB410 77089  UZ09944 '                      01S0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01S0001
         BALR  @11,0                                            01S0001
@PSTART  LA    @12,4095(,@11)                                   01S0001
         USING @PSTART,@11                                      01S0001
         USING @PSTART+4095,@12                                 01S0001
         L     @00,@SIZDATD                                     01S0001
         MODESET EXTKEY=SCHED,SAVEKEY=(2)
         GSPACE   R,LV=(0)
         LR    @10,@01                                          01S0001
         USING @DATD,@10                                        01S0001
         ST    @13,@SA00001+4                                   01S0001
         STC   @02,@OLDKEY                                      01S0001
         MODESET KEYADDR=(2)
         LM    @00,@02,20(@13)                                  01S0001
         ST    @10,8(,@13)                                      01S0001
         LR    @13,@10                                          01S0001
         MODESET EXTKEY=ZERO
         MVC   @PC00001(4),0(@01)                               01S0001
         MODESET EXTKEY=SCHED
JSCBDISP EQU 188
JSCBAOS1 EQU  72
JSCBAOS2 EQU 192
*PARMPTR = REG1;                       /* SET PARAMETER LIST BASE    */
         ST    REG1,PARMPTR                                     01S0112
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - B410INIT                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - INITIALIZE FOR IEFBB410                       */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THE FUNCTION OF THIS SEGMENT IS TO INITIALIZE FOR THE          */
*/*   INITIATOR/UNALLOCATION ROUTINE AND FOR FURTHER UNALLOCATION    */
*/*   PROCESSING. THE FUNCTIONS PERFORMED ARE:                       */
*/*                                                                  */
*/*   1. ESTABLISH AN ESTAE ENVIRONMENT                      @Z40FPPG*/
*/*                                                                  */
*/*   2. SET LCT AND JSCB FIELDS -                           @ZA00061*/
*/*      THE JCT AND SCT POINTERS IN THE LCT ARE SET TO THE JCT AND  */
*/*      SCT ADDRESS THAT WERE PASSED AS INPUT. THESE FIELD WILL BE  */
*/*      USED BY IEFRPREP. THE SCT SVA IN THE JSCB IS USED   @ZA00061*/
*/*      BY DYNAMIC ALLOC, WHICH MAY BE INVOKED DURING       @ZA00061*/
*/*      UNALLOCATION.                                       @ZA00061*/
*/*                                                                  */
*/*   3. READ IN SWA CONTROL BLOCKS -                                */
*/*      THE SWA READER ROUTINE IS INVOKED TO READ IN AND CHAIN ALL  */
*/*      SIOTS, JFCBS, AND JFCBXS FOR THE STEP. IF THE ENVIRONMENT   */
*/*      IS WARM START OR NO DATA SETS HAVE BEEN ALLOCATED,  @ZA02992*/
*/*      THE SCT WILL BE USED TO READ THESE BLOCKS.          @ZA02992*/
*/*      OTHERWISE THE DSABS WILL BE USED. THE SIOTS ARE READ@ZA02992*/
*/*      EVEN WHEN NO DATA SETS HAVE BEEN ALLOCATED SO THAT  @ZA02992*/
*/*      THERE WILL BE A VALID CHAIN FOR SCRATCH PROCESSING  @ZA02992*/
*/*      DURING JOB UNALLOCATION. IF THE DSABS ARE           @ZA02992*/
*/*      USED, THE 'LAST SIOT PTR' IN THE SCT IS UPDATED     @ZA01873*/
*/*      TO POINT TO THE SIOT POINTED TO BY THE LAST DSAB ON @ZA01873*/
*/*      THE CHAIN.                                          @ZA01873*/
*/*      TO CUT DOWN ON THE USE OF GETMAIN FOR EPA'S, A      @ZM41392*/
*/*      BLOCK OF CORE IS OBTAINED AND PASSED TO THE SWA     @ZM41392*/
*/*      BLOCK READ ROUTINE.  ENOUGH CORE FOR 3 EPA'S PER    @ZM41392*/
*/*      REQUEST (SIOT) IS OBTAINED.  IF THAT'S NOT ENOUGH,  @ZM41392*/
*/*      MORE WILL BE OBTAINED BY THE SIOT READER AND        @ZM41392*/
*/*      CHAINED TO THE FIRST BLOCK.                         @ZM41392*/
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*     LCT -                                                        */
*/*       LCTJSCB - JSCB PTR                                         */
*/*                                                                  */
*/*     JCTPTR - JCT ADDRESS                                         */
*/*     SCTPTR - SCT ADDRESS                                         */
*/*                                                                  */
*/* EXITS -                                                          */
*/* 1 CONDITION - NORMAL                                             */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*     STEP ESTAE PARAMETER AREA                                    */
*/*                                                                  */
*/*     LCT                                                          */
*/*       LCTJCTAD - JCT ADDRESS                                     */
*/*       LCTSCTAD - SCT ADDRESS                                     */
*/*                                                                  */
*/*     FSIOTP - ADDRESS OF THE FIRST SIOT OR 0                      */
*/*     FEPAPTR - ADDRESS OF THE FIRST EPA OR 0                      */
*/*     LEPAPTR - ADDRESS OF THE LAST EPA OR 0                       */
*/*                                                                  */
*/*   RETURN CODE - 0                                                */
*/*                                                                  */
*/* 2 CONDITION - UNABLE TO ESTABLISH ESTAE ENVIRONMENT              */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*     FEPAPTR - SET TO ZERO TO INDICATE SWA BLOCKS NOT READ        */
*/*     ESTAE ERROR REASON CODE SET                                  */
*/*                                                                  */
*/*   RETURN CODE - 4                                                */
*/*                                                                  */
*/********************************************************************/
*CONDFAIL = OFF;                       /* INIT COND FAIL SW          */
         NI    CONDFAIL,B'11101111'                             02S0113
*RETCODE = ZERO;                                                02S0114
         SLR   @15,@15                                          02S0114
         ST    @15,RETCODE                                      02S0114
*FUNC4FD = FUNC4FD && FUNC4FD;         /* CLEAR IEFAB4FD FUNCTION MAP*/
         XC    FUNC4FD(1),FUNC4FD                               02S0115
*WTPONLY = ON;                         /* INIT FUNC MAP FOR WTP FUNC */
         OI    WTPONLY,B'00100000'                              02S0116
*DO MSGCTR = ONE TO DIM(RESNCODE);     /* ZERO ALL RESN CODES        */
         LA    MSGCTR,1                                         02S0117
@DL00117 DS    0H                                               02S0118
*  RESNCODE(MSGCTR) = ZERO;                                     02S0118
         LR    @03,MSGCTR                                       02S0118
         ALR   @03,@03                                          02S0118
         SLR   @15,@15                                          02S0118
         STH   @15,RESNCODE-2(@03)                              02S0118
*END;                                                           02S0119
         AH    MSGCTR,@CH00070                                  02S0119
         CH    MSGCTR,@CH00137                                  02S0119
         BNH   @DL00117                                         02S0119
*ESTAPTR = ADDR(ESTPARMS);             /* ADDR OF ESTAE PARM LIST    */
         LA    @15,ESTPARMS                                     02S0120
         ST    @15,ESTAPTR                                      02S0120
*ESTUSERP = ESTUSERP && ESTUSERP;      /* CLEAR USER PARMS FIELD     */
         XC    ESTUSERP(24,@15),ESTUSERP(@15)                   02S0121
*ESTALCTP = LCTPTR;                    /* ADDR OF LCT TO ESTAE PARMS */
         L     @14,PARMPTR                                      02S0122
         L     @09,LCTPTR(,@14)                                 02S0122
         ST    @09,ESTALCTP(,@15)                               02S0122
*ESTAJCTP = JCTPTR;                    /* ADDR OF JCT TO ESTAE PARMS */
         L     @08,JCTPTR(,@14)                                 02S0123
         ST    @08,ESTAJCTP(,@15)                               02S0123
*ESTASCTP = SCTPTR;                    /* ADDR OF SCT TO ESTAE PARMS */
         L     @14,SCTPTR(,@14)                                 02S0124
         ST    @14,ESTASCTP(,@15)                               02S0124
*LCTJCTAD = JCTPTR;                    /* PUT JCT ADDRESS IN LCT     */
         ST    @08,LCTJCTAD(,@09)                               02S0125
*LCTSCTAD = SCTPTR;                    /* PUT SCT ADDRESS IN LCT     */
         ST    @14,LCTSCTAD(,@09)                               02S0126
*LCTSCTVA = SCTDISKA;                  /* SET LCT TTR OF SCT         */
         SLR   @08,@08                                          02S0127
         ICM   @08,7,SCTDISKA(@14)                              02S0127
         STCM  @08,7,LCTSCTVA(@09)                              02S0127
* DO; /*MODESET  KEYADDR(ZERO)*/                                02S0128
*   SPKA (ZERO); /*SET PSW KEY*/                                02S0129
         SLR   @01,@01                                          02S0129
         SPKA  0(@01)                                           02S0129
* END; /*MODESET  KEYADDR(ZERO)*/               /* TO CHANGE JSCB     @
*A00061*/                                                       02S0130
*JSCSCTP = SCTDISKA;                   /* SCT SVA INTO JSCB  @ZA00061*/
         L     @09,LCTJSCB(,@09)                                02S0131
         STCM  @08,7,JSCSCTP(@09)                               02S0131
* DO; /*MODESET  EXTKEY(SCHED)*/                                02S0132
*   SPKA (16); /*SET PSW KEY*/                                  02S0133
         LA    @05,16                                           02S0133
         SPKA  0(@05)                                           02S0133
* END; /*MODESET  EXTKEY(SCHED)*/               /* BACK TO SCHED KEY  @
*A00061*/                                                       02S0134
*FEPBLKP = ZERO;                       /* INIT EPA BLK PTR   @ZM41392*/
         ST    @01,FEPBLKP                                      02S0135
*SWARDRET = SWARDRET && SWARDRET;      /* ZERO OUT SWA RETURN INFO   */
         XC    SWARDRET(12),SWARDRET                            02S0136
*/********************************************************************/
*/*                                                                  */
*/* THIS SEGMENT IS ADDED FOR REL4 ALLOCATION PERFORMANCE _  @Z40FPPG*/
*/* ESTAE                                                    @Z40FPPG*/
*/*                                                                  */
*/* SEGMENT NAME - ESTAECOD                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - ESTAE CODE                                    */
*/*                                                                  */
*/* FUNCTION - SET UP THE APPROPRIATE ESTAE ENVIRONMENT              */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*          . AN ALLOCATION STAE WORK AREA (ASWA) IS FILLED         */
*/*            IN. THIS ALLOWS THE ALLOCATION COMMON ESTAE           */
*/*            EXIT (IEFAB4ED) TO ROUTE CONTROL TO THE OTHER         */
*/*            APPROPRIATE EXIT ROUTINES FOR SPECIFIC                */
*/*            RECOVERY PROCESSING.                                  */
*/*          . ESTAE IS ISSUED, THE ASWA BUILT BECOMES THE FIRST     */
*/*            BY THE COMMON ESTAE EXIT, AND MUST PROVIDE THE        */
*/*            AUTOMATIC CORE FOR THE DATA THAT ROUTINE USES.        */
*/*            NOTE THAT THE STAE CONTROL BLOCK                      */
*/*            ADDRESS IN THE ASWA IS NOT UPDATED UNTIL              */
*/*            AFTER THE ESTAE IS ISSUED SO THAT IT REFLECTS         */
*/*            THE CURRENT ONE.                                      */
*/*          . THE ADDRESS OF THE NEW ASWA IS PLACED IN              */
*/*            THE JSCB AS THE LAST ONE IN THE CHAIN FOR THE         */
*/*            CURRENT ALLOCATION ESTAE                              */
*/*                                                                  */
*/* ENTRY - INLINE SUBROUTINE ENTERED AT THE TOP                     */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*        .RETCODE - RETURN CODE - ZERO ON ENTRY                    */
*/*        .ESTPARMS - STEP UNALLOC ESTAE PARMS                      */
*/*                                                                  */
*/* EXIT - INLINE SUBROUTINE THAT EXITS AT THE BOTTOM                */
*/*                                                                  */
*/*   CONDITION - ESTAE SETUP COMPLETED                              */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*           .ASWA - FILLED IN AND PLACED ON THE CHAIN              */
*/*           .JSCBASWA - POINTS TO ASWA AS LAST ON CHAIN            */
*/*                                                                  */
*/*   RETURN CODES - RETCODE HAS ESTAE RETURN CODE                   */
*/*                                                                  */
*/********************************************************************/
*ASWAPTR = ADDR(ASWACORE);             /*ADDRESS ASWA CORE   @Z40FPPG*/
         LA    ASWAPTR,ASWACORE                                 03S0137
*ASWA = ASWA && ASWA;                  /*ZERO OUT ASWA       @Z40FPPG*/
         XC    ASWA(40,ASWAPTR),ASWA(ASWAPTR)                   03S0138
*ASWAID =CHARASWA;                     /*FILL IN BLOCK ID    @Z40FPPG*/
         MVC   ASWAID(4,ASWAPTR),@CC00237                       03S0139
*ASWACSCT = EXITCSCT;                  /*CSECT NAME OF EXIT  @Z40FPPG*/
         MVC   ASWACSCT(8,ASWAPTR),@CC00245                     03S0140
*ASWARTNP = ADDR(IEFAB4DD);            /*ADDRESS OF EXIT RTN @Z40FPPG*/
         L     @05,@CV00283                                     03S0141
         ST    @05,ASWARTNP(,ASWAPTR)                           03S0141
*ASWAPRMS = ESTAPTR;                   /*PARMS FOR THIS EXIT @Z40FPPG*/
         ST    @15,ASWAPRMS(,ASWAPTR)                           03S0142
*ASWAAUTO = ADDR(AB4EDPMS);            /*1ST ASWA GIVES W/A  @Z40FPPG*/
         LA    @05,AB4EDPMS                                     03S0143
         ST    @05,ASWAAUTO(,ASWAPTR)                           03S0143
*ASWAOLDP = JSCBASWA;                  /*OLD LAST IF ANY     @Z40FPPG*/
         MVC   ASWAOLDP(4,ASWAPTR),JSCBASWA(@09)                03S0144
*RFY (EXITADDR,PARMADDR) RSTD;         /*RESTRICT WORK REGS  @Z40FPPG*/
*EXITADDR = ADDR(IEFAB4ED);            /*COMMON ESTAE EXIT   @Z40FPPG*/
         L     EXITADDR,@CV00284                                03S0146
*PARMADDR = ASWAPTR;                   /*ASWA IS EXIT PARMS  @Z40FPPG*/
         LR    PARMADDR,ASWAPTR                                 03S0147
*ESTAEL(1:ESTAELTH) = ESTAEP(1:ESTAELTH);                       03S0148
         L     @05,ESTAELTH                                     03S0148
         BCTR  @05,0                                            03S0148
         EX    @05,@SM02994                                     03S0148
*                                      /*MOVE TO AUTO CORE   @Z40FPPG*/
*GEN REFS(ESTAEL) SETS(REG15,TCBSTABB);                         03S0149
  ESTAE (EXITADDR),TERM=YES,RECORD=YES,PARAM=(PARMADDR),MF=(E,ESTAEL)
*RFY (EXITADDR,PARMADDR) UNRSTD;                                03S0150
*RETCODE = REG15;                      /*SAVE RETURN CODE    @Z40FPPG*/
         ST    REG15,RETCODE                                    03S0151
*IF RETCODE = ZERO THEN                /*IF NO ERROR         @Z40FPPG*/
         L     @05,RETCODE                                      03S0152
         SLR   @15,@15                                          03S0152
         CR    @05,@15                                          03S0152
         BNE   @RF00152                                         03S0152
*  DO;                                 /*PUT ASWA ONTO CHAIN @Z40FPPG*/
*    ASWASCBP = TCBPTR->TCBSTABB;      /*CURRENT SCB ADDRESS @Z40FPPG*/
         L     @05,CVTPTR                                       03S0154
         L     @05,CVTTCBP(,@05)                                03S0154
         L     @05,TCBPTR(,@05)                                 03S0154
         SLR   @14,@14                                          03S0154
         ICM   @14,7,TCBSTABB(@05)                              03S0154
         ST    @14,ASWASCBP(,ASWAPTR)                           03S0154
*     DO; /*MODESET  KEYADDR(ZERO)*/                            03S0155
*       SPKA (ZERO); /*SET PSW KEY*/                            03S0156
         SPKA  0(@15)                                           03S0156
*     END; /*MODESET  KEYADDR(ZERO)*/           /*KEY TO UPDATE JSCB  @
*40FPPG*/                                                       03S0157
*    JSCBASWA = ASWAPTR;               /*NEW LAST ASWA PTR   @Z40FPPG*/
         L     @05,PARMPTR                                      03S0158
         L     @05,LCTPTR(,@05)                                 03S0158
         L     @05,LCTJSCB(,@05)                                03S0158
         ST    ASWAPTR,JSCBASWA(,@05)                           03S0158
*     DO; /*MODESET  EXTKEY(SCHED)*/                            03S0159
*       SPKA (16); /*SET PSW KEY*/                              03S0160
         LA    @01,16                                           03S0160
         SPKA  0(@01)                                           03S0160
*     END; /*MODESET  EXTKEY(SCHED)*/           /*BACK TO SCHED KEY   @
*40FPPG*/                                                       03S0161
*  END;                                /*END IF NO ERROR     @Z40FPPG*/
*IF RETCODE = ZERO THEN                /* ESTAE SUCCESSFUL           */
@RF00152 ICM   @15,15,RETCODE                                   02S0163
         BNZ   @RF00163                                         02S0163
*  DO;                                                          02S0164
*    IF LCTPALCD = ON | LCTSALCD = ON THEN /* JOB UNALLOC IF ABEND
*                                             OCCURS         @YM08146*/
         L     @01,PARMPTR                                      02S0165
         L     @01,LCTPTR(,@01)                                 02S0165
         TM    LCTPALCD(@01),B'01100000'                        02S0165
         BZ    @RF00165                                         02S0165
*      ESTAJOB = ON;                   /* INDICATOR TO ESTAE    02S0166
*                                         PARMS              @YM08146*/
         L     @01,ESTAPTR                                      02S0166
         OI    ESTAJOB(@01),B'00010000'                         02S0166
*    IF SCTLSIOT ^= ZERO THEN          /* ANY DD'S           @ZM41392*/
@RF00165 L     @01,PARMPTR                                      02S0167
         L     @15,SCTPTR(,@01)                                 02S0167
         ICM   @14,7,SCTLSIOT(@15)                              02S0167
         BZ    @RF00167                                         02S0167
*      DO;                             /* GET SPACE FOR EPAS @ZM41392*/
*        SIZEEPAB =                    /* AMNT TO GET FOR EPAS TO BE
*                                         READ IN BY IEFAB4FE@ZM41392*/
*          LENGTH(EPABHDR)        +    /* BLOCK HEADER SIZE  @ZM41392*/
*          (3 * SCTLALOC *             /* 3 EPAS PER DD      @ZM41392*/
*             LENGTH(SWAEPA));         /* LENGTH OF AN EPA   @ZM41392*/
         LH    SIZEEPAB,SCTLALOC(,@15)                          02S0169
         MH    SIZEEPAB,@CH02964                                02S0169
         AH    SIZEEPAB,@CH00054                                02S0169
*        RFY (REG0,REG1) RSTD;         /*RESTRICT REGS 0 & 1 @ZA17379*/
*        REG0 = SIZEEPAB | SUBPL230;   /*SET SIZE AND SUBPOOL@ZA17379*/
         LR    REG0,SIZEEPAB                                    02S0171
         O     REG0,@CF00271                                    02S0171
*        GEN(GETMAIN R,LV=(0));        /*GET CORE FOR EPAS   @ZA17379*/
         GETMAIN R,LV=(0)
*        FEPBLKP = REG1;               /*SET CORE ADDRESS    @ZA17379*/
         ST    REG1,FEPBLKP                                     02S0173
*        RFY (REG0,REG1) UNRSTD;       /*UNRESTRICT REGS 0&1 @ZA17379*/
*        RFY (REG4,REG5,REG6,REG7) RSTD; /*RESTRICT REGS FOR MVCL TO
*                                          ZERO CORE         @ZA17379*/
*        REG4 = FEPBLKP;               /*ADDR OF CORE        @ZA17379*/
         L     @15,FEPBLKP                                      02S0176
         LR    REG4,@15                                         02S0176
*        REG5 = SIZEEPAB;              /*SIZE OF CORE        @ZA17379*/
         LR    REG5,SIZEEPAB                                    02S0177
*        REG6 = ZERO;                  /*PADDING CHAR        @ZA17379*/
         SLR   REG6,REG6                                        02S0178
*        REG7 = ZERO;                  /*LENGTH              @ZA17379*/
         SLR   REG7,REG7                                        02S0179
*        GEN REFS(REG4,REG6);          /*                    @ZA17379*/
          MVCL  REG4,REG6               ZERO CORE             @ZA17379
*        RFY (REG4,REG5,REG6,REG7) UNRSTD; /*FREE REGS       @ZA17379*/
*        EPBLKPTR = FEPBLKP;           /* BASE OF EPA BLK    @ZM41392*/
         L     EPBLKPTR,FEPBLKP                                 02S0182
*        EPABSIZE = SIZEEPAB;          /* PUT SIZE IN BLOCK  @ZM41392*/
         ST    SIZEEPAB,EPABSIZE(,EPBLKPTR)                     02S0183
*        EPABCNT = SCTLALOC * 3;       /* # OF EPA'S WHICH WILL FIT
*                                         IN THE BLOCK       @ZM41392*/
         L     @03,PARMPTR                                      02S0184
         L     @03,SCTPTR(,@03)                                 02S0184
         LH    @03,SCTLALOC(,@03)                               02S0184
         MH    @03,@CH00115                                     02S0184
         ST    @03,EPABCNT(,EPBLKPTR)                           02S0184
*      END;                            /* EPA SPACE GOTTEN   @ZM41392*/
*    A4FEFMAP = A4FEFMAP && A4FEFMAP;      /* ZERO SWA RDR FUNC MAP  */
@RF00167 XC    A4FEFMAP(1),A4FEFMAP                             02S0186
*    EPASGOTN = ON;                    /* TELL IEFAB4FE THAT SPACE
*                                         FOR EPA'S EXISTS.  @ZM41392*/
         OI    EPASGOTN,B'00000010'                             02S0187
*    IF JCTWARMS = ON |                /* WARM START, NO DSAB@ZA02992*/
*       LCTPALCD=OFF THEN              /*NO DATA SETS ALLOCED@ZA02992*/
         L     @15,PARMPTR                                      02S0188
         L     @01,JCTPTR(,@15)                                 02S0188
         TM    JCTWARMS(@01),B'10000000'                        02S0188
         BO    @RT00188                                         02S0188
         L     @01,LCTPTR(,@15)                                 02S0188
         TM    LCTPALCD(@01),B'00100000'                        02S0188
         BNZ   @RF00188                                         02S0188
@RT00188 DS    0H                                               02S0189
*      SCANSCT = ON;                   /* USE SCT SIOT CHAIN         */
         OI    SCANSCT,B'10000000'                              02S0189
*    ELSE                              /*DSABS EXIST         @ZA02992*/
*      SCANDSAB = ON;                  /* USE DSAB CHAIN TO READ SIOT*/
         B     @RC00188                                         02S0190
@RF00188 OI    SCANDSAB,B'01000000'                             02S0190
*    CALL IEFAB4FE(A4FEFMAP,SCTPTR,LCTJSCB,SWARDRET,FEPBLKP); /* READ
*                                         SIOTS,JFCBS,JFCBXS @ZM41392*/
@RC00188 LA    @15,A4FEFMAP                                     02S0191
         ST    @15,@AL00001                                     02S0191
         L     @15,PARMPTR                                      02S0191
         LA    @14,SCTPTR(,@15)                                 02S0191
         ST    @14,@AL00001+4                                   02S0191
         L     @01,LCTPTR(,@15)                                 02S0191
         LA    @15,LCTJSCB(,@01)                                02S0191
         ST    @15,@AL00001+8                                   02S0191
         LA    @15,SWARDRET                                     02S0191
         ST    @15,@AL00001+12                                  02S0191
         LA    @15,FEPBLKP                                      02S0191
         ST    @15,@AL00001+16                                  02S0191
         L     @15,@CV00287                                     02S0191
         LA    @01,@AL00001                                     02S0191
         BALR  @14,@15                                          02S0191
*    IF JSCDSABQ ^= ZERO &             /* DSAB QDB EXISTS.   @ZA01873*/
*       DSQLASTP ^= ZERO THEN          /* LAST DSAB EXISTS.  @ZA01873*/
         SLR   @15,@15                                          02S0192
         L     @14,PARMPTR                                      02S0192
         L     @01,LCTPTR(,@14)                                 02S0192
         L     @01,LCTJSCB(,@01)                                02S0192
         L     @09,JSCDSABQ(,@01)                               02S0192
         CR    @09,@15                                          02S0192
         BE    @RF00192                                         02S0192
         L     @09,DSQLASTP(,@09)                               02S0192
         CR    @09,@15                                          02S0192
         BE    @RF00192                                         02S0192
*      DO;                             /* FILL IN SCT'S SVA OF LAST
*                                         SIOT READ IN.      @ZA01873*/
*        DSABPTR = DSQLASTP;           /* GET LAST DSAB.     @ZA01873*/
         LR    DSABPTR,@09                                      02S0194
*        SCTLSIOT = DSABSSVA;          /* PUT SIOT SVA IN SCT@ZA01873*/
         L     @03,SCTPTR(,@14)                                 02S0195
         MVC   SCTLSIOT(3,@03),DSABSSVA(DSABPTR)                02S0195
*      END;                            /* END SCT FILL-IN.   @ZA01873*/
*    ELSE;                             /* NO DSABS           @ZA01873*/
@RF00192 DS    0H                                               02S0198
*    ESTLEPAP = LEPAPTR;               /* PTR TO LAST EPA TO ESTAE PR*/
         L     @15,ESTAPTR                                      02S0198
         MVC   ESTLEPAP(4,@15),LEPAPTR                          02S0198
*    ESTSIOTP = FSIOTP;                /* PTR TO 1ST SIOT TO ESTAE PR*/
         L     @14,FSIOTP                                       02S0199
         ST    @14,ESTSIOTP(,@15)                               02S0199
*    IF FSIOTP ^= ZERO THEN            /* STEP UNALLOC NEEDED@YM08146*/
         LTR   @14,@14                                          02S0200
         BZ    @RF00200                                         02S0200
*      ESTASTEP = ON;                  /* INDICATOR TO ESTAE PARMS   */
*                                                               02S0201
         OI    ESTASTEP(@15),B'10000000'                        02S0201
*  END;                                                         02S0202
*ELSE                                  /* ESTAE ERROR                */
*  DO;                                                          02S0203
         B     @RC00163                                         02S0203
@RF00163 DS    0H                                               02S0204
*    FEPAPTR = ZERO;                   /* NO SWA RECORDS READ        */
         SLR   @15,@15                                          02S0204
         ST    @15,FEPAPTR                                      02S0204
*    RESNCODE(1) = ESTAERR;            /* ESTAE ERROR REASON CODE    */
         LA    @15,4                                            02S0205
         STH   @15,RESNCODE                                     02S0205
*    RETCODE = ERROR;                  /* ERROR RETURN CODE          */
         ST    @15,RETCODE                                      02S0206
*  END;                                                         02S0207
*IF RETCODE = ZERO THEN                /* NO ERROR OCURRED           */
@RC00163 ICM   @15,15,RETCODE                                   01S0208
         BNZ   @RF00208                                         01S0208
*  DO;                                 /* CONTINUE                   */
*/********************************************************************/
*/* SEGMENT NAME - ISSUMSGS                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - ISSUE END OF STEP MESSAGES                    */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THE FUNCTION OF THIS SEGMENT IS TO PERFORM THE FOLLOWING       */
*/*   FUNCTIONS AT THE END OF EACH STEP:                             */
*/*                                                                  */
*/*   1. ISSUE MESSAGES - MESSAGES ARE ISSUED ACCORDING TO THE       */
*/*      FOLLOWING RULES:                                            */
*/*                                                                  */
*/*      . STEP TERMINATED NORMALLY                                  */
*/*        THE STEP WAS EXECUTED MESSAGE IS ISSUED TO THE            */
*/*        PROGRAMMER. THE RETURN CODE FROM THE STEP IS INCLUDED     */
*/*        IN THIS MESSAGE.                                          */
*/*                                                                  */
*/*      . STEP ABNORMALLY TERMINATED                                */
*/*        THE STEP ABENDED MESSAGE IS ISSUED TO THE OPERATOR AND    */
*/*        THE COMPLETION CODE MESSAGE IS ISSUED TO THE PROGRAMMER.  */
*/*                                                                  */
*/*      . STEP WAS NOT EXECUTED                                     */
*/*        THE STEP WAS NOT EXECUTED MESSAGE IS ISSUED TO THE        */
*/*        PROGRAMMER. IF THE STEP IS IN ALLOCATION WHEN THE @ZA08480*/
*/*        SYSTEM RESTART IS REQUIRED, ANOTHER MESSAGE IS    @ZA08480*/
*/*        ISSUED TO NOTIFY THE PROGRAMMER.                  @ZA08480*/
*/*                                                                  */
*/*    OPERATION -                                                   */
*/*      MESSAGES ARE KEPT IN EXTERNAL PROCS. THESE PROCS ALSO       */
*/*      CONTAIN DESCRIPTIVE INFORMATION ABOUT THE MESSAGE. THE      */
*/*      LENGTH OF ALL MESSAGES IS KEPT. IN ADDITION, ANY MESSAGES   */
*/*      WHICH CONTAIN VARIABLE FIELDS OTHER THAN JOB NAME,STEP      */
*/*      NAME, AND PROC STEP NAME (E.G. COMPLETION CODE), HAVE AN    */
*/*      OFFSET WITHIN THE MESSAGE WHERE THE VARIABLE INFORMATION    */
*/*      GOES. SEE B410DATA FOR MORE DETAIL ON THE USE OF THESE      */
*/*      FIELDS.                                                     */
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*                                                                  */
*/*     LCT -                                                        */
*/*       LCTJFAIL - JOB FAILED BIT                                  */
*/*       LCTSFAIL - STEP BYPASSED BIT                               */
*/*       LCTJSCB - P/P JSCB ADDRESS                                 */
*/*                                                                  */
*/*     JCT -                                                        */
*/*       JCTSTEPR - STEP WILL AUTOMATICALLY RESTART FROM THE        */
*/*         BEGINNING                                                */
*/*       JCTCKPTR - STEP WILL AUTOMATICALLY RESTART FROM A          */
*/*         CHECK POINT.                                             */
*/*       JCTSWSM - SUPRESS ALL MESSAGES                             */
*/*                                                                  */
*/*     TCB -                                                        */
*/*       TCBFA - ABEND BIT                                          */
*/*                                                                  */
*/* EXIT -                                                           */
*/* 1 CONDITION - NORMAL                                             */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*                                                                  */
*/*     MESSAGES TO PROGRAMMER AND OPERATOR                          */
*/*                                                                  */
*/*    RETURN CODE - NONE                                            */
*/*                                                                  */
*/********************************************************************/
*WTOSW = OFF;                          /* INIT MSG TO OPER SWITCH    */
*TIMESW = OFF;                         /* INIT TIME SWITCH           */
         NI    WTOSW,B'01110111'                                02S0211
*IF JCTWARMS = OFF |                   /* NOT WARM START             */
*    (JCTWARMS = ON & JCTSWSM = OFF) THEN /*WARMSTART,MSG NOT SUPRESD*/
         L     @01,PARMPTR                                      02S0212
         L     @15,JCTPTR(,@01)                                 02S0212
         TM    JCTWARMS(@15),B'10000000'                        02S0212
         BZ    @RT00212                                         02S0212
         TM    JCTWARMS(@15),B'10000000'                        02S0212
         BNO   @RF00212                                         02S0212
         TM    JCTSWSM(@15),B'00010000'                         02S0212
         BNZ   @RF00212                                         02S0212
@RT00212 DS    0H                                               02S0213
*  DO;                                 /* ISSUE END OF STEP MESSAGES */
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - SETCODES                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - SET UP COMPLETION CODES AND TIME              */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THE FUNCTION OF THIS SEGMENT IS TO SET UP THE SYSTEM AND USER  */
*/*   ABEND CODES, THE RETURN CODE FROM THE STEP, AND THE TIME       */
*/*   FOR LATER INSERTION INTO A MESSAGE.                            */
*/*                                                                  */
*/*   OPERATION -                                                    */
*/*   . CONVERT THE ABEND CODE - (DONE ONLY IF THE STEP ABENDED)     */
*/*     THE SYSTEM ABEND CODE IS CONVERTED TO EBCDIC. IF THE SYSTEM  */
*/*     ABEND CODE IS NOT 0C0, D0D, OR E0D, THE USER ABEND CODE IS   */
*/*     CONVERTED TO DECIMAL AND THEN TO EBCDIC. IF THE SYSTEM       */
*/*     ABEND CODE IS 0C0, THE USER ABEND CODE IS SET TO ZERO.       */
*/*     IF THE SYSTEM ABEND CODE IS D0D OR E0D, AN INVALID RECURSION */
*/*     THROUGH ABEND HAS OCCURRED AND THE ORIGINAL SYSTEM           */
*/*     COMPLETION CODE IS IN THE USER CODE FIELD. THEREFORE, IN     */
*/*     THIS CASE THE USER ABEND CODE IS JUST CONVERTED TO EBCDIC.   */
*/*                                                                  */
*/*   . CONVERT THE STEP RETURN CODE - (DONE IF STEP DID NOT ABEND)  */
*/*     THE STEP RETURN CODE IS CONVERTED TO DECIMAL AND THEN TO     */
*/*     EBCDIC.                                                      */
*/*                                                                  */
*/*   . SET UP THE TIME -                                            */
*/*     A TIME MACRO IS ISSUED AND THE TIME IS CONVERTED TO EBCDIC   */
*/*     IF THE OPERATOR ISSUED THE MONITOR COMMAND WITH THE TIME     */
*/*     OPTION.                                                      */
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*     TCB -                                                        */
*/*       TCBCMP - STEP COMPLETION CODE IF ABEND, OTHERWISE STEP     */
*/*         RETURN CODE.                                             */
*/*                                                                  */
*/*     CSCB -                                                       */
*/*       CHCLD - CANCELLED BIT                                      */
*/*                                                                  */
*/*     MASTER SCHEDULER RESIDENT DATA AREA -                        */
*/*       MSTN - MN ,T ISSUED                                        */
*/*                                                                  */
*/* EXIT -                                                           */
*/*   CONDITION - NORMAL                                             */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*     SYSABCDE - SYSTEM ABEND CODE (IN EBCDIC)                     */
*/*     USRABCDE - USER ABEND CODE (IN EBCDIC)                       */
*/*     COMPCODE - STEP RETURN CODE                                  */
*/*     TIME - THE TIME IN THE FORM HHMMSS (IN EBCDIC)               */
*/*     TIMESW - SET ON IF MN ,T REQUESTED                           */
*/*                                                                  */
*/*   RETURN CODE - NONE                                             */
*/*                                                                  */
*/********************************************************************/
*IF TCBFA = ON | CHCLD = ON THEN       /* STEP WAS ABENDED           */
         L     @01,PARMPTR                                      03S0214
         L     @15,LCTPTR(,@01)                                 03S0214
         L     @01,LCTTCBAD(,@15)                               03S0214
         TM    TCBFA(@01),B'10000000'                           03S0214
         BO    @RT00214                                         03S0214
         L     @01,LCTQDRTY(,@15)                               03S0214
         TM    CHCLD(@01),B'00000100'                           03S0214
         BNO   @RF00214                                         03S0214
@RT00214 DS    0H                                               03S0215
*  DO;                                                          03S0215
*    UNPK (BCDCCODE(1:5),TCBCMPCH(1:3)); /* UNPK SYS ABEND CODE      */
         L     @01,PARMPTR                                      03S0216
         L     @01,LCTPTR(,@01)                                 03S0216
         L     @15,LCTTCBAD(,@01)                               03S0216
         UNPK  BCDCCODE(5),TCBCMPCH(3,@15)                      03S0216
*    TR (BCDCCODE(1:3),TRTABLE);       /* TRANSLATE TO EBCDIC        */
         LA    @14,@CC00272                                     03S0217
         SH    @14,@CH00185                                     03S0217
         TR    BCDCCODE(3),TRTABLE(@14)                         03S0217
*    SYSABCDE = BCDCCODE(1:3);         /* MOVE TO OUTPUT AREA        */
         MVC   SYSABCDE(3),BCDCCODE                             03S0218
*    IF SYSABCDE(2:3) = ABNDABND THEN  /* USER ABEND FIELD HAS SYSTEM
*                                         ABEND CODE                 */
         CLC   SYSABCDE+1(2),@CC00233                           03S0219
         BNE   @RF00219                                         03S0219
*      DO;                                                      03S0220
*        UNPK (BCDCCODE(1:5),TCBCMPCH(2:4)); /* UNPK ABEND CODE      */
         UNPK  BCDCCODE(5),TCBCMPCH+1(3,@15)                    03S0221
*        TR (BCDCCODE(2:4),TRTABLE);   /* TRANSLATE TO EBCDIC        */
         TR    BCDCCODE+1(3),TRTABLE(@14)                       03S0222
*        USRABCDE = BCDCCODE(2:4);     /* SET USR CODE IN OUTPUT AREA*/
         MVI   USRABCDE+3,C' '                                  03S0223
         MVC   USRABCDE(3),BCDCCODE+1                           03S0223
*      END;                                                     03S0224
*    ELSE                              /* NOT D0D OR E0D             */
*      IF SYSABCDE = IMPRCISE THEN     /* 0C0 ABEND                  */
         B     @RC00219                                         03S0225
@RF00219 CLC   SYSABCDE(3),@CC00250                             03S0225
         BNE   @RF00225                                         03S0225
*        USRABCDE = CHARZERO;          /* SET USER CODE TO ZERO      */
         MVC   USRABCDE(4),@CC00239                             03S0226
*      ELSE                            /* CONVERT USER ABEND FIELD   */
*        DO;                                                    03S0227
         B     @RC00225                                         03S0227
@RF00225 DS    0H                                               03S0228
*          USERCODE = TCBCMPC(2:3);    /* MOVE USER CODE TO LCL AREA */
         L     @01,PARMPTR                                      03S0228
         L     @01,LCTPTR(,@01)                                 03S0228
         L     @01,LCTTCBAD(,@01)                               03S0228
         SLR   USERCODE,USERCODE                                03S0228
         ICM   USERCODE,3,TCBCMPC+1(@01)                        03S0228
*          USERCODE = USERCODE & HIZERO; /* ZERO FIRST HALF BYTE     */
         N     USERCODE,@CF00248                                03S0229
*          CVD (USERCODE,DECUSRCD);    /* CONVERT TO DECIMAL         */
         CVD   USERCODE,DECUSRCD                                03S0230
*          MVN (DECUSRCD(8),ZEROFOX);  /* INSURE CORRECT ZONE        */
         MVN   DECUSRCD+7(1),@CB00278                           03S0231
*          UNPK (DECUSRCD(1:5),DECUSRCD(6:8)); /* CONVERT TO EBCDIC  */
         UNPK  DECUSRCD(5),DECUSRCD+5(3)                        03S0232
*          USRABCDE = DECUSRCD(2:5);   /* MOVE TO OUTPUT AREA        */
         MVC   USRABCDE(4),DECUSRCD+1                           03S0233
*        END;                                                   03S0234
*  END;                                                         03S0235
*ELSE                                  /* STEP DID NOT ABEND         */
*  DO;                                 /* SET UP STEP RETURN CODE    */
         B     @RC00214                                         03S0236
@RF00214 DS    0H                                               03S0237
*    CVD (TCBCMPFW,DECCODE);           /* CONVERT RETURN CODE TO DEC */
         L     @01,PARMPTR                                      03S0237
         L     @01,LCTPTR(,@01)                                 03S0237
         L     @01,LCTTCBAD(,@01)                               03S0237
         L     @15,TCBCMPFW(,@01)                               03S0237
         CVD   @15,DECCODE                                      03S0237
*    MVN (DECCODE(8),ZEROFOX);         /* INSURE CORRECT ZONE        */
         MVN   DECCODE+7(1),@CB00278                            03S0238
*    UNPK (DECCODE(1:5),DECCODE(6:8)); /* CONVERT TO EBCDIC          */
         UNPK  DECCODE(5),DECCODE+5(3)                          03S0239
*    COMPCODE = DECCODE(2:5);          /* MOVE TO OUTPUT AREA        */
         MVC   COMPCODE(4),DECCODE+1                            03S0240
*  END;                                                         03S0241
*IF MSTN = ON THEN                     /* MN ,T ISSUED               */
@RC00214 L     @01,CVTPTR                                       03S0242
         L     @01,CVTMSER(,@01)                                03S0242
         TM    MSTN+136(@01),B'00000010'                        03S0242
         BNO   @RF00242                                         03S0242
*  DO;                                 /* SET UP THE TIME            */
*    TIMESW = ON;                      /* TIME NEEDED IN MSG         */
         OI    TIMESW,B'00001000'                               03S0244
*    RFY (REG0,REG1) RSTD;             /* RESERVE REGISTERS          */
*    GEN (TIME DEC);                   /* GET THE TIME               */
         TIME DEC
*    DECTIME = REG0;                   /* MOVE TIME OUT OF REG0      */
         ST    REG0,DECTIME                                     03S0247
*    RFY (REG0,REG1) UNRSTD;           /* RELEASE REGISTERS          */
*    UNPK (TIME(1:7),DECTIME);         /* CONVERT TO EBCDIC          */
         UNPK  TIME(7),DECTIME(4)                               03S0249
*  END;                                                         03S0250
*    IF LCTJFAIL = OFF & LCTSFAIL = OFF | /* STEP WAS EXECUTED       */
*        CHCLD = ON THEN               /* JOB CANCELED               */
@RF00242 L     @01,PARMPTR                                      02S0251
         L     @01,LCTPTR(,@01)                                 02S0251
         TM    LCTJFAIL(@01),B'10010000'                        02S0251
         BZ    @RT00251                                         02S0251
         L     @01,PARMPTR                                      02S0251
         L     @01,LCTPTR(,@01)                                 02S0251
         L     @01,LCTQDRTY(,@01)                               02S0251
         TM    CHCLD(@01),B'00000100'                           02S0251
         BNO   @RF00251                                         02S0251
@RT00251 DS    0H                                               02S0252
*      IF TCBFA = ON | CHCLD = ON THEN /* STEP ABENDED OR CANCELED   */
         L     @01,PARMPTR                                      02S0252
         L     @15,LCTPTR(,@01)                                 02S0252
         L     @01,LCTTCBAD(,@15)                               02S0252
         TM    TCBFA(@01),B'10000000'                           02S0252
         BO    @RT00252                                         02S0252
         L     @01,LCTQDRTY(,@15)                               02S0252
         TM    CHCLD(@01),B'00000100'                           02S0252
         BNO   @RF00252                                         02S0252
@RT00252 DS    0H                                               02S0253
*          DO;                                                  02S0253
*            WTOSW = ON;               /* ISSUE A WTO                */
         OI    WTOSW,B'10000000'                                02S0254
*            WTOL = WTOL && WTOL;      /* ZERO WTO PARM LIST         */
         XC    WTOL(138),WTOL                                   02S0255
*            MSG ='';                  /* BLANK OUT PGMR MESSAGE     */
         MVI   MSG,C' '                                         02S0256
         MVC   MSG+1(119),MSG                                   02S0256
*            WPLTXT(1:WTOABNDL) = WTOABNDM(1:WTOABNDL); /* MOVE MSG
*                                         TO WTO PARM LIST           */
         LA    @15,WTOL                                         02S0257
         L     @14,@CA00332                                     02S0257
         LH    @09,WTOABNDL-WTOABEND(,@14)                      02S0257
         LR    @08,@09                                          02S0257
         BCTR  @08,0                                            02S0257
         EX    @08,@SM03000                                     02S0257
*            WMSGLNTH = WTOABNDL;      /* MOVE LENGTH TO LOCAL AREA  */
         ST    @09,WMSGLNTH                                     02S0258
*            WTOSYSCD(2:4) = SYSABCDE; /* MOVE ABEND CODE TO MSG
*                                                            @ZA01930*/
         LA    @15,WPLTXT(,@15)                                 02S0259
         LH    @09,WTOSDISP-WTOABEND(,@14)                      02S0259
         ALR   @09,@15                                          02S0259
         MVC   WTOSYSCD+1(3,@09),SYSABCDE                       02S0259
*            WTOUSRCD(2:5) = USRABCDE; /* MOVE ABEND CODE TO MSG
*                                                            @ZA01930*/
         AH    @15,WTOUDISP-WTOABEND(,@14)                      02S0260
         MVC   WTOUSRCD+1(4,@15),USRABCDE                       02S0260
*            MSG(1:PGMABNDL) = PGMABNDM(1:PGMABNDL); /* MOVE MSG
*                                         TO LOCAL AREA              */
         L     @15,@CA00314                                     02S0261
         LH    @14,PGMABNDL-PGMABEND(,@15)                      02S0261
         LR    @09,@14                                          02S0261
         BCTR  @09,0                                            02S0261
         EX    @09,@SM03002                                     02S0261
*            LMSGLNTH = PGMABNDL;      /* MOVE LENGTH TO LCL AREA    */
         ST    @14,LMSGLNTH                                     02S0262
*            MSGSYSCD = SYSABCDE;      /* MOVE SYS CODE TO MESSAGE   */
         LA    @14,MSG                                          02S0263
         LH    @09,PGMSDISP-PGMABEND(,@15)                      02S0263
         ALR   @09,@14                                          02S0263
         MVC   MSGSYSCD(3,@09),SYSABCDE                         02S0263
*            MSGUSRCD = USRABCDE;      /* MOVE USER CODE TO MESSAGE  */
         AH    @14,PGMUDISP-PGMABEND(,@15)                      02S0264
         MVC   MSGUSRCD(4,@14),USRABCDE                         02S0264
*          END;                                                 02S0265
*      ELSE                            /* STEP DID NOT ABEND         */
*        DO;                           /* ISSUE STEP WAS RUN MSG     */
         B     @RC00252                                         02S0266
@RF00252 DS    0H                                               02S0267
*          MSG(1:STEPRUNL) = STEPRUNM(1:STEPRUNL); /* MOVE IN MSG    */
         L     @15,@CA00320                                     02S0267
         LH    @14,STEPRUNL-STEPRUN(,@15)                       02S0267
         LR    @09,@14                                          02S0267
         BCTR  @09,0                                            02S0267
         EX    @09,@SM03004                                     02S0267
*          MSGCCODE = COMPCODE;        /* MOVE COMP CODE TO MSG      */
         LA    @09,MSG                                          02S0268
         AH    @09,STPCDISP-STEPRUN(,@15)                       02S0268
         MVC   MSGCCODE(4,@09),COMPCODE                         02S0268
*          LMSGLNTH = STEPRUNL;        /* MOVE LENGTH TO LCL AREA    */
         ST    @14,LMSGLNTH                                     02S0269
*        END;                                                   02S0270
*    ELSE                              /* STEP DID NOT EXECUTE       */
*      DO;                                                      02S0271
         B     @RC00251                                         02S0271
@RF00251 DS    0H                                               02S0272
*        MSG(1:STNOTRNL) = STNOTRNM(1:STNOTRNL); /* MOVE IN MSG      */
         L     @15,@CA00323                                     02S0272
         LH    @14,STNOTRNL-STNOTRUN(,@15)                      02S0272
         LR    @09,@14                                          02S0272
         BCTR  @09,0                                            02S0272
         EX    @09,@SM03006                                     02S0272
*        LMSGLNTH = STNOTRNL;          /* SET LENGTH OF MSG          */
         ST    @14,LMSGLNTH                                     02S0273
*        IF JCTJSBAL = ON &            /* WAS STEP IN ALLOC  @ZA08480*/
*           JCTWARMS = ON THEN         /* IS THIS WARMSTART? @ZA08480*/
         L     @01,PARMPTR                                      02S0274
         L     @15,JCTPTR(,@01)                                 02S0274
         TM    JCTJSBAL(@15),B'00000100'                        02S0274
         BNO   @RF00274                                         02S0274
         TM    JCTWARMS(@15),B'10000000'                        02S0274
         BNO   @RF00274                                         02S0274
*          DO;                         /*                    @ZA08480*/
*            CALL ENDSMSG;             /* WRITE STEP NOT EXECUTED MSG
*                                                            @ZA08480*/
         BAL   @14,ENDSMSG                                      02S0276
*            MSG(1:STNOATOL) = STNOATOM(1:STNOATOL); /*      @ZA08480*/
         L     @15,@CA00326                                     02S0277
         LH    @14,STNOATOL-STNOAUTO(,@15)                      02S0277
         LR    @09,@14                                          02S0277
         BCTR  @09,0                                            02S0277
         EX    @09,@SM03008                                     02S0277
*            LMSGLNTH = STNOATOL;      /* SET LENGTH OF MSG  @ZA08480*/
         ST    @14,LMSGLNTH                                     02S0278
*          END;                        /*                    @ZA08480*/
*      END;                                                     02S0280
@RF00274 DS    0H                                               02S0281
*    CALL ENDSMSG;                     /* ISSUE THE MESSAGES @ZA08480*/
@RC00251 BAL   @14,ENDSMSG                                      02S0281
*  END;                                                         02S0282
*    IF TCBFA = ON & CHCLD = OFF THEN  /* STEP ABENDED BUT NOT CANCEL*/
@RF00212 L     @01,PARMPTR                                      01S0283
         L     @15,LCTPTR(,@01)                                 01S0283
         L     @01,LCTTCBAD(,@15)                               01S0283
         TM    TCBFA(@01),B'10000000'                           01S0283
         BNO   @RF00283                                         01S0283
         L     @01,LCTQDRTY(,@15)                               01S0283
         TM    CHCLD(@01),B'00000100'                           01S0283
         BNZ   @RF00283                                         01S0283
*      DO;                                                      01S0284
*        RFY REG1 RSTD;                                         01S0285
*        REG1 = LCTPTR;                /* SET REG1 FOR IEFRPREP      */
         LR    REG1,@15                                         01S0286
*        CALL IEFRPREP;                /* INVOKE RESTART PREPARATION */
         L     @15,@CV00295                                     01S0287
         BALR  @14,@15                                          01S0287
*        RFY REG1 UNRSTD;                                       01S0288
*      END;                                                     01S0289
*    IF JCTWARMS = ON &                /* WARMSTART                  */
*         (JCTSTEPR = OFF & JCTCKPTR = OFF & JCTCONTR = OFF) THEN /* NO
*                                         RESTART                    */
@RF00283 L     @01,PARMPTR                                      01S0290
         L     @01,JCTPTR(,@01)                                 01S0290
         TM    JCTWARMS(@01),B'10000000'                        01S0290
         BNO   @RF00290                                         01S0290
         TM    JCTSTEPR(@01),B'00101100'                        01S0290
         BNZ   @RF00290                                         01S0290
*      RETCODE = ERROR;                /* INDIC JOB IS FAILED        */
         MVC   RETCODE(4),@CF00089                              01S0291
*    IF ((LCTSFAIL = OFF &      /* STEP NOT BYPASSED          */
*       LCTJFAIL = ON &         /* JOB FAILED                 */
*       LCTPALCD = ON) |        /* SOME DATA SETS ALLOCED     */
*       (LCTSFAIL = OFF &                                       01S0292
*       LCTJFAIL = OFF)) &                                      01S0292
*       FSIOTP ^= ZERO THEN/*                                   01S0292
*                                         MUST DO STEP UNALLOCATION  */
@RF00290 L     @01,PARMPTR                                      01S0292
         L     @01,LCTPTR(,@01)                                 01S0292
         TM    LCTJFAIL(@01),B'10100000'                        01S0292
         BNO   @GL00011                                         01S0292
         TM    LCTSFAIL(@01),B'00010000'                        01S0292
         BZ    @GL00010                                         01S0292
@GL00011 L     @01,PARMPTR                                      01S0292
         L     @01,LCTPTR(,@01)                                 01S0292
         TM    LCTSFAIL(@01),B'10010000'                        01S0292
         BNZ   @RF00292                                         01S0292
@GL00010 SLR   @15,@15                                          01S0292
         C     @15,FSIOTP                                       01S0292
         BE    @RF00292                                         01S0292
*      DO;                                                      01S0293
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - CALLUNAL                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - SET UP FOR AND INVOKE STEP UNALLOCATION       */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THE FUNCTION OF THIS SEGMENT IS TO SET UP FOR AND INVOKE       */
*/*   STEP UNALLOCATION CONTROL.                                     */
*/*                                                                  */
*/*   OPERATION -                                                    */
*/*   1. SET UP THE UNALLOCATION FUNCTION MAP -                      */
*/*      EACH BIT IN THE UNALLOCATION FUNCTION MAP IS SET AS         */
*/*      REQUIRED (SEE THE CODE FOR DETAILS) .                       */
*/*                                                                  */
*/*   2. MESSAGE INFORMATION (JOB NAME, STEP NAME, PROC STEP NAME)   */
*/*      IS SET UP.                                                  */
*/*                                                                  */
*/*   3. STEP UNALLOCATION IS INVOKED TO UNALLOCATE FOR THE          */
*/*      STEP. IF A NON-ZERO RETURN CODE IS RECEIVED, THE RETURN     */
*/*      CODE FROM THIS SEGMENT IS SET.                              */
*/*                                                          @ZA06981*/
*/*   4. IF THIS IS A WARM START, THEN CHECK FOR STEPCATS.   @ZA06981*/
*/*      IF STEPCATS EXIST, BUILD A TABLE OF PTRS. TO DATA   @ZA06981*/
*/*      SET NAMES FOR ALL SIOTS THAT HAVE THE SIOTJSCT BIT  @ZA06981*/
*/*      ON.  TURN ON A BIT IN THE FUNCTION MAP TO BE PASSED @ZA06981*/
*/*      TO STEP UNALLOCATION TO INDICATE THAT STEPCATS MAY  @ZA06981*/
*/*      BE ALLOCATED AND CATALOG MANAGEMENT MAY DYNAMICALLY @ZA06981*/
*/*      ALLOCATE PRIVATE CATALOGS.                          @ZA06981*/
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*     LCT -                                                        */
*/*       LCTERROR -                                                 */
*/*         LCTJFAIL - JOB HAS FAILED                                */
*/*                                                                  */
*/*     JCT -                                                        */
*/*       JCTSTEPR - STEP WILL RESTART AUTOMATICALLY FROM THE        */
*/*                  BEGINNING                                       */
*/*       JCTCKPTR - STEP WILL RESTART AUTOMATICALLY FROM A          */
*/*                  CHECKPOINT                                      */
*/*       JCTWARMS - A WARM START IS IN PROGRESS                     */
*/*       INCMALL - MSGLEVEL                                         */
*/*       JCTJNAME - JOB NAME                                        */
*/*     TCB -                                                        */
*/*        TCBFA - STEP ABENDED                                      */
*/*                                                                  */
*/*     SCT -                                                        */
*/*       SCTSNAME - STEP NAME                                       */
*/*       SCTSCLPC - PROC STEP NAME                                  */
*/*                                                                  */
*/*     MASTER SCHEDULER RESIDENT DATA AREA                          */
*/*       MSDISPST - MONITOR STATUS IS ACTIVE                        */
*/*                                                                  */
*/* EXITS -                                                          */
*/* 1 CONDITION - NORMAL                                             */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*     REQUESTS UNALLOCATED                                         */
*/*                                                                  */
*/*     STEP ESTAE PARAMETER AREA UPDATED                            */
*/*                                                                  */
*/*   RETURN CODE - 0                                                */
*/*                                                                  */
*/* 2 CONDITION - ERROR IN STEP UNALLOCATION                         */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*     SOME REQUESTS (OR NONE) UNALLOCATED                          */
*/*                                                                  */
*/*     STEP ESTAE PARAMETER AREA UPDATED                            */
*/*                                                                  */
*/*   RETURN CODE - 4                                                */
*/********************************************************************/
*STUFMAP = STUFMAP && STUFMAP;         /* INIT. STEP UNAL FUNC. MAP  */
         XC    STUFMAP(3),STUFMAP                               02S0294
*STDISPRC = ON;                        /* PROCESS DISPOSITIONS       */
         OI    STDISPRC,B'10000000'                             02S0295
*CATDSNSZ = ZERO;                      /* CLEAR THE POINTER  @ZA06981*/
         ST    @15,CATDSNSZ                                     02S0296
*IF TCBFA = ON & INCMALL = OFF & JCTWARMS = OFF THEN /* ABEND AND
*                                         MSGLEVEL=0                 */
         L     @15,PARMPTR                                      02S0297
         L     @01,LCTPTR(,@15)                                 02S0297
         L     @01,LCTTCBAD(,@01)                               02S0297
         TM    TCBFA(@01),B'10000000'                           02S0297
         BNO   @RF00297                                         02S0297
         L     @15,JCTPTR(,@15)                                 02S0297
         TM    INCMALL(@15),B'10000000'                         02S0297
         BNZ   @RF00297                                         02S0297
         TM    JCTWARMS(@15),B'10000000'                        02S0297
         BNZ   @RF00297                                         02S0297
*  STALCMSG = ON;                      /* ISSUE ALLOCATION MSGS.     */
         OI    STALCMSG,B'01000000'                             02S0298
*IF INCMALL = ON | TCBFA = ON THEN     /* MSGLEVEL=1 OR ABEND        */
@RF00297 L     @15,PARMPTR                                      02S0299
         L     @01,JCTPTR(,@15)                                 02S0299
         TM    INCMALL(@01),B'10000000'                         02S0299
         BO    @RT00299                                         02S0299
         L     @01,LCTPTR(,@15)                                 02S0299
         L     @01,LCTTCBAD(,@01)                               02S0299
         TM    TCBFA(@01),B'10000000'                           02S0299
         BNO   @RF00299                                         02S0299
@RT00299 DS    0H                                               02S0300
*  STDSPMSG = ON;                      /* ISSUE DISP MESSAGES        */
         OI    STDSPMSG,B'00100000'                             02S0300
*IF JCTWARMS = ON THEN                 /* WARM START IN PROGRESS     */
@RF00299 L     @15,PARMPTR                                      02S0301
         L     @01,JCTPTR(,@15)                                 02S0301
         TM    JCTWARMS(@01),B'10000000'                        02S0301
         BNO   @RF00301                                         02S0301
*  DO;                                                          02S0302
*    STSPSCR = ON;                     /* SPECIAL SCRATCH PROCESSING */
         OI    STSPSCR,B'00100000'                              02S0303
*    STINVUCB = ON;                    /* UCBS IN SIOTS ARE INVALID  */
         OI    STINVUCB,B'00001000'                             02S0304
*    STNOSSDS = ON;                    /* DON'T PROCESS SUBSYSTEM
*                                         DATA SETS          @YM02473*/
         OI    STNOSSDS,B'00010000'                             02S0305
*    IF SCTPCAT ^= ZERO &              /* DO STEPCATS EXIST? @ZA06981*/
*       FSIOTP ^= ZERO &               /* ARE THERE ANY SIOT @ZA06981*/
*       SCTCATCT ^= ZERO THEN          /* IS THE NUMBER ZERO @ZA06981*/
         SLR   @14,@14                                          02S0306
         L     @15,SCTPTR(,@15)                                 02S0306
         CL    @14,SCTPCAT(,@15)                                02S0306
         BE    @RF00306                                         02S0306
         C     @14,FSIOTP                                       02S0306
         BE    @RF00306                                         02S0306
         SLR   @09,@09                                          02S0306
         ICM   @09,3,SCTCATCT(@15)                              02S0306
         CR    @09,@14                                          02S0306
         BE    @RF00306                                         02S0306
*      DO;                             /*                    @ZA06981*/
*        CATDSNSZ = LENGTH(CATHDR) +   /*                    @ZA06981*/
*                   SCTCATCT * LENGTH(CATDSNP); /* SIZE CORE @ZA06981*/
         SLA   @09,2                                            02S0308
         AL    @09,@CF00089                                     02S0308
         ST    @09,CATDSNSZ                                     02S0308
*         /* ?GETSTORG (SPID,CATDSNSZ,CATALDSN);*/              02S0309
*           /* DEFINITIONS OF GETMAIN PARMS */                  02S0309
*           DCL                                                 02S0309
*             GTSTR0   FIXED(31) REG(0),/*GTMN PARM REG*/       02S0309
*             GTSTR1   FIXED(31) REG(1),/*GTMN PARM REG*/       02S0309
*             GTSTR2   PTR(31)   REG(2),/*GTMN PARM REG*/       02S0309
*             GTSTR15  FIXED(31) REG(15),/*GTMN RET COD*/       02S0309
*             GTSTRTCD FIXED(31); /* GETMAIN RTN CODE  */       02S0309
*           DCL                                                 02S0310
*             GTSTR3   FIXED(31) REG(3),/* CLEARING REG*/       02S0310
*             GTSTR4   FIXED(31) REG(4),/* CLEARING REG*/       02S0310
*             GTSTR5   FIXED(31) REG(5),/* CLEARING REG*/       02S0310
*             GTSTR6   FIXED(31) REG(6),/* CLEARING REG*/       02S0310
*             GTSTR7   FIXED(31) REG(7),/* CLEARING REG*/       02S0310
*             GTSTR8   FIXED(31) REG(8),/* CLEARING REG*/       02S0310
*             GTSTZERO FIXED(31) INIT(0),                       02S0310
*             GTST253  FIXED(31) CONSTANT(253);                 02S0310
*           RFY (GTSTR0,GTSTR1,GTSTR2) RSTD; /*SAVE RGS*/       02S0311
*           GTSTR0 = CATDSNSZ; /* SET AMOUNT*/                  02S0312
         LR    GTSTR0,@09                                       02S0312
*           GTSTR2 = SPID; /* SET SUBPOOL*/                     02S0313
         LA    GTSTR2,230                                       02S0313
*           GENERATE CODE;                                      02S0314
             GETMAIN RC,LV=(0),SP=(2)  DO GETMAIN
*           GTSTRTCD = GTSTR15; /* SAVE GETMAIN RET COD*/       02S0315
         ST    GTSTR15,GTSTRTCD                                 02S0315
*           CATALDSN = GTSTR1; /* ADDR OF GOTN STORG*/          02S0316
         ST    GTSTR1,CATALDSN                                  02S0316
*           RFY (GTSTR0,GTSTR1,GTSTR2) UNRSTD; /*RLSE */        02S0317
*           IF GTSTRTCD = 0 THEN /*GETMAIN SUCCESSFUL? */       02S0318
         L     @15,GTSTRTCD                                     02S0318
         LTR   @15,@15                                          02S0318
         BNZ   @RF00318                                         02S0318
*             DO;               /* YES, CLEAR STORAGE.*/        02S0319
*               RFY (GTSTR2,GTSTR4,GTSTR5,GTSTR6,               02S0320
*                                  GTSTR7,GTSTR8) RSTD;         02S0320
*               GTSTR4 = CATALDSN; /*STORG PTR*/                02S0321
         L     @09,CATALDSN                                     02S0321
         LR    GTSTR4,@09                                       02S0321
*               GTSTR5 = CATDSNSZ; /*STORG AMNT*/               02S0322
         L     GTSTR5,CATDSNSZ                                  02S0322
*               GTSTR7 = '00000000'X; /*PAD CHAR & LNTH*/       02S0323
         SLR   GTSTR7,GTSTR7                                    02S0323
*               IF SPID = GTST253 THEN                          02S0324
         B     @RF00324                                         02S0324
*              GEN                                              02S0325
*           (MODESET KEYADDR=GTSTZERO,SAVEKEY=(2),WORKREG=8);   02S0325
         MODESET KEYADDR=GTSTZERO,SAVEKEY=(2),WORKREG=8
*               GEN REFS(GTSTR4,GTSTR6);                        02S0326
@RF00324 DS    0H                                               02S0326
                  MVCL  GTSTR4,GTSTR6 CLEAR GOTTEN STORG
*               IF SPID = GTST253 THEN                          02S0327
         B     @RF00327                                         02S0327
*                 GEN (MODESET KEYADDR=(2));                    02S0328
         MODESET KEYADDR=(2)
*               RFY (GTSTR2,GTSTR4,GTSTR5,GTSTR6,               02S0329
*                                  GTSTR7,GTSTR8) UNRSTD;       02S0329
@RF00327 DS    0H                                               02S0330
*             END;       /* STORAGE CLEARING COMPLETED */       02S0330
*           ELSE                                                02S0331
*           CATALDSN= 0;   /* CLEAR RETURN ADDR. */             02S0331
         B     @RC00318                                         02S0331
@RF00318 SLR   @15,@15                                          02S0331
         ST    @15,CATALDSN                                     02S0331
*           GTSTR15 = GTSTRTCD;    /* GTMN RETURN CODE */       02S0332
@RC00318 L     GTSTR15,GTSTRTCD                                 02S0332
*                                      /* RESTORE LIST PRINT STATUS  */
*/* GET CATDSNT   @ZA06981*/                                    02S0333
*        RFY REG15 RSTD;               /* RESERVE REGISTER   @ZA06981*/
*        IF REG15 = ZERO THEN          /* WAS GETMAIN OKAY?  @ZA06981*/
         LTR   REG15,REG15                                      02S0334
         BNZ   @RF00334                                         02S0334
*          DO;                         /*                    @ZA06981*/
*            SIOTPTR = FSIOTP;         /* SET SIOT BASE PTR  @ZA06981*/
         L     SIOTPTR,FSIOTP                                   02S0336
*            DO WHILE (SIOTDSKA ^= SCTPCAT(1:3)); /*FIND PCAT@ZA06981*/
         B     @DE00337                                         02S0337
@DL00337 DS    0H                                               02S0338
*              SIOTPTR = SIOTNPTR;     /* UPDATE             @ZA06981*/
         L     SIOTPTR,SIOTNPTR(,SIOTPTR)                       02S0338
*            END;                      /*                    @ZA06981*/
@DE00337 L     @14,PARMPTR                                      02S0339
         L     @14,SCTPTR(,@14)                                 02S0339
         CLC   SIOTDSKA(3,SIOTPTR),SCTPCAT(@14)                 02S0339
         BNE   @DL00337                                         02S0339
*            CATNUM = SCTCATCT;        /* SET NUMBER STEPCAT @ZA06981*/
         SLR   @09,@09                                          02S0340
         ICM   @09,3,SCTCATCT(@14)                              02S0340
         L     @14,CATALDSN                                     02S0340
         ST    @09,CATNUM(,@14)                                 02S0340
*            INDEX1 = 1;               /* SET CATDSNP INDEX  @ZA06981*/
         LA    @14,1                                            02S0341
         LR    INDEX1,@14                                       02S0341
*            DO INDEX = 1 TO SCTCATCT; /* STEPCAT LOOP CNTRL @ZA06981*/
         LR    INDEX,@14                                        02S0342
         B     @DE00342                                         02S0342
@DL00342 DS    0H                                               02S0343
*              IF SIOTJSCT = ON THEN   /* DID HSKP TURN OFF? @ZA06981*/
         TM    SIOTJSCT(SIOTPTR),B'00000001'                    02S0343
         BNO   @RF00343                                         02S0343
*                DO;                   /* NO                 @ZA06981*/
*                  CATDSNP(INDEX1)=SJFCBPTR; /* PUT IN TABLE @ZA06981*/
         LR    @14,INDEX1                                       02S0345
         SLA   @14,2                                            02S0345
         L     @05,SJFCBPTR(,SIOTPTR)                           02S0345
         L     @01,CATALDSN                                     02S0345
         ST    @05,CATDSNP-4(@14,@01)                           02S0345
*                  INDEX1 = INDEX1 + 1;/* UPDATE CATDSNP PTR @ZA06981*/
         AH    INDEX1,@CH00070                                  02S0346
*                END;                  /*                    @ZA06981*/
*              ELSE                    /* YES                @ZA06981*/
*                CATNUM = CATNUM - 1;  /* DECREASE STEPCATS  @ZA06981*/
         B     @RC00343                                         02S0348
@RF00343 L     @14,CATALDSN                                     02S0348
         L     @05,CATNUM(,@14)                                 02S0348
         BCTR  @05,0                                            02S0348
         ST    @05,CATNUM(,@14)                                 02S0348
*              SIOTPTR = SIOTNPTR;     /* POINT TO NEXT SIOT @ZA06981*/
@RC00343 L     SIOTPTR,SIOTNPTR(,SIOTPTR)                       02S0349
*            END;                      /* LOOP               @ZA06981*/
         AH    INDEX,@CH00070                                   02S0350
@DE00342 L     @14,PARMPTR                                      02S0350
         L     @14,SCTPTR(,@14)                                 02S0350
         SLR   @05,@05                                          02S0350
         ICM   @05,3,SCTCATCT(@14)                              02S0350
         CR    INDEX,@05                                        02S0350
         BNH   @DL00342                                         02S0350
*            STALSTCT = ON;            /* ALLOCATE STEPCATS  @ZA06981*/
         OI    STALSTCT,B'00001000'                             02S0351
*          END;                        /*                    @ZA06981*/
*        ELSE                          /* GET STORG FAILED   @ZA06981*/
*          DO;                         /* GETMAIN ERROR      @ZA06981*/
         B     @RC00334                                         02S0353
@RF00334 DS    0H                                               02S0354
*            CATDSNSZ = ZERO;          /* MAKE SIZE ZERO     @ZA06981*/
         SLR   @14,@14                                          02S0354
         ST    @14,CATDSNSZ                                     02S0354
*            RETCODE = REG15;          /* SAVE RETURN CODE   @ZA06981*/
         ST    REG15,RETCODE                                    02S0355
*            RESNCODE(1) = GETMAIN;    /* SET REASON CODE    @ZA06981*/
         MVC   RESNCODE(2),@CH00070                             02S0356
*            RFY REG15 UNRSTD;         /* RELEASE REGISTER   @ZA06981*/
*          END;                        /* END GETMAIN ERROR  @ZA06981*/
*      END;                            /*                    @ZA06981*/
*    ELSE                              /*                    @ZA06981*/
*      IF SCTPCAT = ZERO &             /* IF PCAT PTR = ZERO @ZA06981*/
*         SCTCATCT = ZERO THEN         /* AND COUNT IS ZERO  @ZA06981*/
         B     @RC00306                                         02S0360
@RF00306 SLR   @15,@15                                          02S0360
         L     @01,PARMPTR                                      02S0360
         L     @14,SCTPTR(,@01)                                 02S0360
         CL    @15,SCTPCAT(,@14)                                02S0360
         BNE   @RF00360                                         02S0360
         SLR   @09,@09                                          02S0360
         ICM   @09,3,SCTCATCT(@14)                              02S0360
         CR    @15,@09                                          02S0360
         BNE   @RF00360                                         02S0360
*        DO;                           /*                    @ZA06981*/
*          CATALDSN = ZERO;            /* NO PCATS TO ALLOC  @ZA06981*/
         ST    @15,CATALDSN                                     02S0362
*          STALSTCT = ON;              /* ALLOW CAT MGT ALOC @ZA06981*/
         OI    STALSTCT,B'00001000'                             02S0363
*        END;                          /*                    @ZA06981*/
*      ELSE                            /* IF PCAT UNLIKE CNT @ZA06981*/
*        CATALDSN = ZERO;              /* DONT ALLOC OR ALOW @ZA06981*/
         B     @RC00360                                         02S0365
@RF00360 SLR   @15,@15                                          02S0365
         ST    @15,CATALDSN                                     02S0365
*  END;                                                         02S0366
*ELSE                                  /* NOT WARM START             */
*  DO;                                                          02S0367
         B     @RC00301                                         02S0367
@RF00301 DS    0H                                               02S0368
*    STFRDSAB = ON;                    /* FREE DSABS                 */
*    STUNUNIT = ON;                    /* UNALLOCATE UNITS           */
*    STJES3 = ON;                      /* DO INVOKE JES3     @Y30QPPB*/
         OI    STFRDSAB,B'00010011'                             02S0370
*    STPPCATS = ON;                    /* PROCESS PRIV. CATS @ZA06981*/
         OI    STPPCATS,B'00000100'                             02S0371
*  END;                                                         02S0372
*IF BASTCNT > ZERO THEN                /* MN STATUS ISSUED           */
@RC00301 L     @01,CVTPTR                                       02S0373
         L     @01,CVTMSER(,@01)                                02S0373
         ICM   @00,3,BASTCNT(@01)                               02S0373
         BNP   @RF00373                                         02S0373
*  STMNSTAT = ON;                      /* ISSUE MN STATUS MESSAGES   */
         OI    STMNSTAT,B'00001000'                             02S0374
*IF TCBFA = ON THEN                    /* STEP HAS ABENDED           */
@RF00373 L     @15,PARMPTR                                      02S0375
         L     @01,LCTPTR(,@15)                                 02S0375
         L     @01,LCTTCBAD(,@01)                               02S0375
         TM    TCBFA(@01),B'10000000'                           02S0375
         BNO   @RF00375                                         02S0375
*  IF JCTSTEPR = ON THEN               /* STEP WILL RESTART FROM
*                                         THE BEGINNING              */
         L     @01,JCTPTR(,@15)                                 02S0376
         TM    JCTSTEPR(@01),B'00000100'                        02S0376
         BNO   @RF00376                                         02S0376
*    DO;                                                        02S0377
*      STKPDEL = ON;                   /* KEEP OLD, DELETE NEW       */
         OI    STKPDEL,B'00010000'                              02S0378
*      STUPJFCB = ON;                  /* UPDATE MOD JFCBS           */
         OI    STUPJFCB,B'00000100'                             02S0379
*      STPURGE = ON;                   /* USE OVRD FOR SCRATCH       */
         OI    STPURGE,B'00000010'                              02S0380
*    END;                                                       02S0381
*  ELSE                                /* NO STEP RESTART            */
*    IF JCTCKPTR = ON THEN             /* RESTART FROM A CHECKPOINT  */
         B     @RC00376                                         02S0382
@RF00376 L     @01,PARMPTR                                      02S0382
         L     @01,JCTPTR(,@01)                                 02S0382
         TM    JCTCKPTR(@01),B'00001000'                        02S0382
         BNO   @RF00382                                         02S0382
*      DO;                                                      02S0383
*        STNOVUT = ON;                 /* DON'T DO VUT PROCESSING    */
*        STPUBPRV = ON;                /* CHANGE OPENED PUB TAPES TO
*                                         PRIVATE SO OTHER JOBS WON'T
*                                         ALLOCATE THEM FOR PUBLIC
*                                         USE                        */
         OI    STNOVUT,B'11000000'                              02S0385
*        STKEEP = ON;                  /* KEEP ALL DATA SETS         */
         OI    STKEEP,B'01000000'                               02S0386
*      END;                                                     02S0387
*    ELSE                              /* NO RESTART                 */
*      DO;                                                      02S0388
         B     @RC00382                                         02S0388
@RF00382 DS    0H                                               02S0389
*        STPASS = ON;                  /* ALWAYS DO PASS AS PASS     */
*        STCNDISP = ON;                /* USE CONDITIONAL DISP       */
         OI    STPASS,B'00100100'                               02S0390
*      END;                                                     02S0391
*ELSE                                  /* STEP DID NOT ABEND         */
*  IF LCTJFAIL = ON THEN               /* JOB FAILED IN ALLOCATION   */
         B     @RC00375                                         02S0392
@RF00375 L     @01,PARMPTR                                      02S0392
         L     @01,LCTPTR(,@01)                                 02S0392
         TM    LCTJFAIL(@01),B'10000000'                        02S0392
         BNO   @RF00392                                         02S0392
*    DO;                                                        02S0393
*      STPASS = ON;                    /* ALWAYS DO PASS AS PASS     */
*      STKPDEL = ON;                   /* KEEP OLD, DELETE NEW       */
*      STPURGE = ON;                   /* USE OVRD ON SCRATCH        */
*      STCHKPAS = ON;                  /* CHECK FOR DATA SET IN PDI  */
         OI    STPASS,B'00010111'                               02S0397
*    END;                                                       02S0398
*  ELSE                                /* JOB HAS NOT FAILED         */
*    STNMDISP = ON;                    /* USE NORMAL DISPOSITION     */
         B     @RC00392                                         02S0399
@RF00392 OI    STNMDISP,B'10000000'                             02S0399
*MSGJNAME = JCTJNAME;                  /* JOB NAME TO MSG HDR AREA   */
@RC00392 DS    0H                                               02S0400
@RC00375 L     @15,PARMPTR                                      02S0400
         L     @14,JCTPTR(,@15)                                 02S0400
         MVC   MSGJNAME(8),JCTJNAME(@14)                        02S0400
*MSGSNAME = SCTSNAME;                  /* STEP NAME TO MSG HDR AREA  */
         L     @09,SCTPTR(,@15)                                 02S0401
         MVC   MSGSNAME(8),SCTSNAME(@09)                        02S0401
*MSGPSNAM = SCTSCLPC;                  /* PROC NAME TO MSG HDR AREA  */
         MVC   MSGPSNAM(8),SCTSCLPC(@09)                        02S0402
*ESTASTEP = OFF;                       /* STEP UNALOC TRIED INDICATOR*/
         L     @01,ESTAPTR                                      02S0403
         NI    ESTASTEP(@01),B'01111111'                        02S0403
*CALL IEFBB414                         /* INVOKE STEP UNALLOCATION   */
*   (STUFMAP,LCTJSCB,FSIOTP,JCTDETDA,MSGINFO,SCTSNUMB,          02S0404
*    JCTVULDP,RESNCODE(3),CATALDSN);   /* PASS CATDSNT PTR   @ZA06981*/
         LA    @08,STUFMAP                                      02S0404
         ST    @08,@AL00001                                     02S0404
         L     @01,LCTPTR(,@15)                                 02S0404
         LA    @15,LCTJSCB(,@01)                                02S0404
         ST    @15,@AL00001+4                                   02S0404
         LA    @15,FSIOTP                                       02S0404
         ST    @15,@AL00001+8                                   02S0404
         LA    @15,JCTDETDA(,@14)                               02S0404
         ST    @15,@AL00001+12                                  02S0404
         LA    @15,MSGINFO                                      02S0404
         ST    @15,@AL00001+16                                  02S0404
         LA    @15,SCTSNUMB(,@09)                               02S0404
         ST    @15,@AL00001+20                                  02S0404
         LA    @15,JCTVULDP(,@14)                               02S0404
         ST    @15,@AL00001+24                                  02S0404
         LA    @15,RESNCODE+4                                   02S0404
         ST    @15,@AL00001+28                                  02S0404
         LA    @15,CATALDSN                                     02S0404
         ST    @15,@AL00001+32                                  02S0404
         L     @15,@CV00293                                     02S0404
         LA    @01,@AL00001                                     02S0404
         BALR  @14,@15                                          02S0404
*RFY REG15 RSTD;                       /* RESERVE REGISTER           */
*IF REG15 ^= ZERO THEN                 /* ERROR IN STEP UNALLOCATION */
         LTR   REG15,REG15                                      02S0406
         BZ    @RF00406                                         02S0406
*  RETCODE = ERROR;                    /* SET BAD RETURN CODE        */
         MVC   RETCODE(4),@CF00089                              02S0407
*RFY REG15 UNRSTD;                     /* RELEASE REGISTER           */
@RF00406 DS    0H                                               02S0409
*IF CATDSNSZ ^= ZERO THEN              /* WAS GETMAIN OKAY?  @ZA06981*/
         L     @15,CATDSNSZ                                     02S0409
         LTR   @15,@15                                          02S0409
         BZ    @RF00409                                         02S0409
*  DO;                                 /* YES                @ZA06981*/
*    RFY (REG0,REG1) RSTD;             /* RESTRICT REGISTERS @ZA06981*/
*    REG0 = CATDSNSZ;                  /* GET SIZE TO FREE   @ZA06981*/
         LR    REG0,@15                                         02S0412
*    REG0 = REG0 | SUBPL230;           /* SUBPOOL ID TO FREE @ZA06981*/
         O     REG0,@CF00271                                    02S0413
*    REG1 = CATALDSN;                  /* ADDRESS TO FREE    @ZA06981*/
         L     REG1,CATALDSN                                    02S0414
*    GEN(FREEMAIN R,LV=(0),A=(1));     /* FREEMAIN CATDSNT   @ZA06981*/
         FREEMAIN R,LV=(0),A=(1)
*    RFY (REG0,REG1) UNRSTD;           /* RELEASE THE REGS   @ZA06981*/
*  END;                                /*                    @ZA06981*/
*ELSE;                                 /* GET FAILED NO FREE @ZA06981*/
@RF00409 DS    0H                                               02S0419
*      END;                                                     01S0419
*    ELSE                              /* INSURE CATALOGS    @YM04224*/
*      DO;                             /* ARE CLOSED AND     @YM04224*/
         B     @RC00292                                         01S0420
@RF00292 DS    0H                                               01S0421
*        UCCNTRLS = ZERO;              /* THEIR PCCBS FREE'D @YM04224*/
         SLR   @15,@15                                          01S0421
         STH   @15,UCCNTRLS                                     01S0421
*        UCALLACB = ON;                /* IF STEP UNALOC     @YM04224*/
*        UCALPCCB = ON;                /* IS BYPASSED.       @YM04224*/
         OI    UCALLACB,B'00000101'                             01S0423
*        UNCATRTN = ZERO;              /* DUMMY RETURN INFO  @YM04224*/
         ST    @15,UNCATRTN                                     01S0424
*        CALL IEFAB4F4(UCCNTRLS,ADDR(UNCATRTN),ZERO,ZERO,ZERO,LCTJSCB);
         LA    @15,UCCNTRLS                                     01S0425
         ST    @15,@AL00001                                     01S0425
         LA    @15,UNCATRTN                                     01S0425
         ST    @15,@TF00001                                     01S0425
         LA    @15,@TF00001                                     01S0425
         ST    @15,@AL00001+4                                   01S0425
         LA    @15,@CF00276                                     01S0425
         ST    @15,@AL00001+8                                   01S0425
         LA    @15,@CF00276                                     01S0425
         ST    @15,@AL00001+12                                  01S0425
         LA    @15,@CF00276                                     01S0425
         ST    @15,@AL00001+16                                  01S0425
         L     @01,PARMPTR                                      01S0425
         L     @01,LCTPTR(,@01)                                 01S0425
         LA    @15,LCTJSCB(,@01)                                01S0425
         ST    @15,@AL00001+20                                  01S0425
         L     @15,@CV00289                                     01S0425
         LA    @01,@AL00001                                     01S0425
         BALR  @14,@15                                          01S0425
*      END;                                                     01S0426
*/********************************************************************/
*/* SEGMENT NAME - ENDOSTEP                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - END OF STEP PROCESSING                        */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THE FUNCTION OF THIS SEGMENT IS TO PERFORM THE FOLLOWING       */
*/*   FUNCTIONS AT THE END OF EACH STEP:                             */
*/*                                                                  */
*/*    1. INVOKE THE SMF/USER ACCOUNTING ROUTINE                     */
*/*       THE SMF ACCOUNTING ROUTINE IS INVOKED TO WRITE THE         */
*/*       END OF STEP RECORD AND INVOKE THE USER ACCOUNTING          */
*/*       ROUTINE. THE USER ACCOUNTING ROUTINE MAY FAIL THE          */
*/*       JOB AT THIS TIME.                                          */
*/*                                                                  */
*/*    2. FREE THE TIOT AND DSAB QDB                                 */
*/*       THE TIOT MANAGER IS INVOKED TO FREE THE TIOT AND           */
*/*       THE DSAB QDB FOR THIS STEP.                                */
*/*                                                                  */
*/*    3. SET END OF STEP INFORMATION - THE FOLLOWING FIELDS AND     */
*/*       INDICATORS ARE SET:                                        */
*/*                                                                  */
*/*       SCT STEP ABEND BIT - IF THE STEP ABENDED                   */
*/*       JCT STEP ABEND BIT - IF THE STEP ABENDED                   */
*/*       SCT STEP ENDED BIT - ALWAYS SET ON                         */
*/*       JSCB JSCSIOTS BIT - INDICATES THAT A CHECKPOINT TAKEN IN A */
*/*                           SUBSEQUENT STEP SHOULD NOT SCAN THE    */
*/*                           SIOT CHAIN FOR DYNAMICALLY UNALLOCATED */
*/*                           SIOTS                                  */
*/*       JCT CHECKPOINT - TAKEN BIT - SET OFF IF THIS       @YM08130*/
*/*         STEP WILL NOT AUTOMATICALLY RESTART. THIS        @YM08130*/
*/*         MUST BE DONE TO PREVENT SUBSEQUENT STEPS         @YM08130*/
*/*         FROM APPEARING TO HAVE TAKEN A CHECKPOINT        @YM08130*/
*/*         WITHOUT HAVING DONE SO.                          @YM08130*/
*/*                                                          @G24LPSJ*/
*/*    4. IF THE LCTVTERM FLAG IS ON, MSS SELECTS WERE       @G24LPSJ*/
*/*       DONE AND AN MSS TERMINATE IS REQUIRED. THE         @G24LPSJ*/
*/*       MSS TERMINATE IS ISSUED.                           @G24LPSJ*/
*/*                                                                  */
*/*    OPERATION -                                                   */
*/*      OPERATION IS DOCUMENTED IN THE CODE                         */
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*                                                                  */
*/*     LCT -                                                        */
*/*       LCTJFAIL - JOB FAILED BIT                                  */
*/*       LCTSFAIL - STEP BYPASSED BIT                               */
*/*       LCTJSCB - P/P JSCB ADDRESS                                 */
*/*       LCTVTERM - MSS TERMINATE REQUIRED IF ON            @G24LPSJ*/
*/*                                                                  */
*/*     JCT -                                                        */
*/*       JCTSTEPR - STEP WILL AUTOMATICALLY RESTART FROM THE        */
*/*         BEGINNING                                                */
*/*       JCTCKPTR - STEP WILL AUTOMATICALLY RESTART FROM A          */
*/*         CHECK POINT.                                             */
*/*       JCTSWSM - SUPRESS ALL MESSAGES                             */
*/*                                                                  */
*/*     TCB -                                                        */
*/*       TCBFA - ABEND BIT                                          */
*/*                                                                  */
*/* EXIT -                                                           */
*/* 1 CONDITION - NORMAL                                             */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*                                                                  */
*/*     TIOT AND DSAB QDB FREED                                      */
*/*                                                                  */
*/*     SCT -                                                        */
*/*       SCTABCND - EIGHTH CONDITION CODE                           */
*/*       SCTABEND - SCT ABEND BIT                                   */
*/*       SCTSTPND - STEP ENDED BIT                                  */
*/*                                                                  */
*/*     JCT -                                                        */
*/*       JCTABEND - JCT ABEND BIT                                   */
*/*       JCTCKFT - CHECKPOINT TAKEN                         @YM08130*/
*/*                                                                  */
*/*    RETURN CODE - 0                                               */
*/*                                                                  */
*/* 2 CONDITION - JOB FAILED BY USER ACCOUNTING ROUTINE OR JOB       */
*/*               CANCELLED                                          */
*/*                                                                  */
*/*   OUTPUT - SAME AS ABOVE                                         */
*/*                                                                  */
*/*   RETURN CODE - 4                                                */
*/*                                                                  */
*/********************************************************************/
*LCTPARM1 = SMFEOS;                    /* SET EOS CODE FOR SMF       */
@RC00292 L     @15,PARMPTR                                      02S0427
         L     @01,LCTPTR(,@15)                                 02S0427
         MVC   LCTPARM1(4,@01),@CF00034                         02S0427
*CALL IEFTB721(LCTPTR,TIOTPTR);        /* SET UP FOR USER ACCT RTN   */
         ST    @15,@AL00001                                     02S0428
         L     @01,TIOTLP(,@15)                                 02S0428
         ST    @01,@AL00001+4                                   02S0428
         L     @15,@CV00291                                     02S0428
         LA    @01,@AL00001                                     02S0428
         BALR  @14,@15                                          02S0428
*RFY REG15 RSTD;                       /* RESERVE REGISTER           */
*IF REG15 ^= ZERO THEN                 /* JOB FAILED BY ACCT RTN     */
         LTR   REG15,REG15                                      02S0430
         BZ    @RF00430                                         02S0430
*  RETCODE = ERROR;                    /* INDIC JOB FAILED           */
         MVC   RETCODE(4),@CF00089                              02S0431
*RFY REG15 UNRSTD;                     /* RELEASE REGISTER           */
@RF00430 DS    0H                                               02S0433
*TIOMGRRB = TIOMGRRB && TIOMGRRB;      /* ZERO TIOT MGR RB           */
         LA    @15,TMCORE                                       02S0433
         XC    TIOMGRRB(38,@15),TIOMGRRB(@15)                   02S0433
*TIOMFREE = ON;                        /* FREE TIOT AND DSAB QDB     */
         OI    TIOMFREE(@15),B'00000001'                        02S0434
*TIOMJSCP = LCTJSCB;                   /* SET JSCB PTR               */
         L     @01,PARMPTR                                      02S0435
         L     @01,LCTPTR(,@01)                                 02S0435
         MVC   TIOMJSCP(4,@15),LCTJSCB(@01)                     02S0435
*CALL IEFAB4FC(ADDR(TIOMGRRB));        /* FREE TIOT & QDB            */
         ST    @15,@TF00001                                     02S0436
         LA    @15,@TF00001                                     02S0436
         ST    @15,@AL00001                                     02S0436
         L     @15,@CV00285                                     02S0436
         LA    @01,@AL00001                                     02S0436
         BALR  @14,@15                                          02S0436
* DO; /*MODESET  KEYADDR(ZERO)*/                                02S0437
*   SPKA (ZERO); /*SET PSW KEY*/                                02S0438
         SLR   @01,@01                                          02S0438
         SPKA  0(@01)                                           02S0438
* END; /*MODESET  KEYADDR(ZERO)*/                               02S0439
*JSCSIOTS = OFF;                       /* CHKPT MUST NOT SCAN SIOTS  */
         L     @15,PARMPTR                                      02S0440
         L     @14,LCTPTR(,@15)                                 02S0440
         L     @09,LCTJSCB(,@14)                                02S0440
         NI    JSCSIOTS(@09),B'11111101'                        02S0440
*TIOTLP = ZERO;                        /* TIOT IS GONE               */
         ST    @01,TIOTLP(,@15)                                 02S0441
* DO; /*MODESET  EXTKEY(SCHED)*/                                02S0442
*   SPKA (16); /*SET PSW KEY*/                                  02S0443
         LA    @01,16                                           02S0443
         SPKA  0(@01)                                           02S0443
* END; /*MODESET  EXTKEY(SCHED)*/                               02S0444
*SCTCDENT(8) = SCTCDENT(8) && SCTCDENT(8); /*0 8TH COND CODE @YM04230*/
         L     @09,SCTPTR(,@15)                                 02S0445
         XC    SCTCDENT+42(6,@09),SCTCDENT+42(@09)              02S0445
*IF TCBFA = ON &                       /* STEP ABENDED               */
*    (JCTSTEPR = OFF & JCTCKPTR = OFF) THEN /* NO RESTART            */
         L     @01,LCTTCBAD(,@14)                               02S0446
         TM    TCBFA(@01),B'10000000'                           02S0446
         BNO   @RF00446                                         02S0446
         L     @15,JCTPTR(,@15)                                 02S0446
         TM    JCTSTEPR(@15),B'00001100'                        02S0446
         BNZ   @RF00446                                         02S0446
*  DO;                                                          02S0447
*    SCTABEND = ON;                    /* SCT STEP ABEND BIT         */
         LA    @14,SCTCDENT(,@09)                               02S0448
         OI    SCTABEND+42(@14),B'00000100'                     02S0448
*    JCTABEND = ON;                    /* JCT ABEND BIT              */
         OI    JCTABEND(@15),B'00001000'                        02S0449
*  END;                                                         02S0450
*IF JCTSTEPR = OFF &                   /* NO STEP RESTART    @YM08130*/
*   JCTCKPTR = OFF THEN                /* NO CKPT RESTART    @YM08130*/
@RF00446 L     @01,PARMPTR                                      02S0451
         L     @15,JCTPTR(,@01)                                 02S0451
         TM    JCTSTEPR(@15),B'00001100'                        02S0451
         BNZ   @RF00451                                         02S0451
*  JCTCKFT = OFF;                      /* RESET 'CHECKPOINT     02S0452
*                                         TAKEN' INDICATOR.  @YM08130*/
         NI    JCTCKFT(@15),B'11101111'                         02S0452
*IF CHCLD = ON THEN                    /* JOB WAS CANCELLED          */
@RF00451 L     @01,PARMPTR                                      02S0453
         L     @01,LCTPTR(,@01)                                 02S0453
         L     @01,LCTQDRTY(,@01)                               02S0453
         TM    CHCLD(@01),B'00000100'                           02S0453
         BNO   @RF00453                                         02S0453
*  RETCODE = ERROR;                    /* INDIC JOB FAILED           */
         MVC   RETCODE(4),@CF00089                              02S0454
*SCTSTPND = ON;                        /* STEP HAS ENDED             */
@RF00453 L     @15,PARMPTR                                      02S0455
         L     @01,SCTPTR(,@15)                                 02S0455
         OI    SCTSTPND(@01),B'01000000'                        02S0455
*IF LCTVTERM = ON THEN                 /* IF MSS TERMINATE   @G24LPSJ*/
         L     @15,LCTPTR(,@15)                                 02S0456
         TM    LCTVTERM(@15),B'00000010'                        02S0456
         BNO   @RF00456                                         02S0456
*  DO;                                 /* REQUIRED THEN      @G24LPSJ*/
*/********************************************************** @G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/* SEGMENT NAME - TERMCALL                                  @G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/* DESCRIPTIVE NAME - MSS TERMINATE PROCESSOR               @G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/* FUNCTION -                                               @G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/*     THIS SEGMENT ISSUES THE MSS TERMINATE IF THERE       @G24LPSJ*/
*/*     WAS A COMMON ALLOCATION FAILURE.                     @G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/* OPERATION -                                              @G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/*      THE TERMINATE CONTROL BLOCK AREA IS CLEARED AND     @G24LPSJ*/
*/*      INITIALIZED. THE ADDRESS OF THIS AREA IS PASSED     @G24LPSJ*/
*/*      TO THE MSSC IN REGISTER 1 VIA SVC 126. NO RETURN    @G24LPSJ*/
*/*      CODES ARE PROCESSED UPON RETURN.                    @G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/* ENTRY - IN-LINE SEGMENT                                  @G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/*   PURPOSE - SEE FUNCTION                                 @G24LPSJ*/
*/*   INPUT   - ASCBASID                                     @G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/* EXIT -                                                   @G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/*   CONDITION - MSS TERMINATE ISSUED                       @G24LPSJ*/
*/*       OUTPUT       - NONE                                @G24LPSJ*/
*/*       RETURN CODES - NONE                                @G24LPSJ*/
*/*                                                          @G24LPSJ*/
*/********************************************************** @G24LPSJ*/
*RFY TRMRB BASED(ADDR(TERMAREA)); /* SET ADDR FOR TERMINATE     03S0458
*                                    REQUEST BLOCK           @G24LPSJ*/
*TRMRB = TRMRB && TRMRB;          /* CLEAR BLOCK             @G24LPSJ*/
         LA    @03,TERMAREA                                     03S0459
         XC    TRMRB(16,@03),TRMRB(@03)                         03S0459
*TRMRBLEN = LENGTH(TRMRB);        /* SET TERM LENGTH         @G24LPSJ*/
         MVC   TRMRBLEN(4,@03),@CF00054                         03S0460
*TRMRBOPC = TRMOPCD;              /* SET TERM OP CODE        @G24LPSJ*/
         MVI   TRMRBOPC(@03),X'8A'                              03S0461
*ASCBPTR = LCTASCBA;              /* SET ASCB ADDRESS        @G24LPSJ*/
         L     ASCBPTR,LCTASCBA(,@15)                           03S0462
*TRMJOBID = ASCBASID;             /* SET ASID OF STEP        @G24LPSJ*/
         SLR   @15,@15                                          03S0463
         ICM   @15,3,ASCBASID(ASCBPTR)                          03S0463
         ST    @15,TRMJOBID(,@03)                               03S0463
*RFY REG1 RSTD;                   /* RESTRICT REG 1          @G24LPSJ*/
*REG1 = ADDR(TRMRB);              /* LOAD ADDR TRMTRB        @G24LPSJ*/
         LR    REG1,@03                                         03S0465
*SVC (126);                       /* CALL MSSC               @G24LPSJ*/
         SVC   126                                              03S0466
*RFY REG1 UNRSTD;                 /* RELEASE REG 1TH         @G24LPSJ*/
*  END;                                /*                    @G24LPSJ*/
*    IF RETCODE ^= ZERO THEN           /* JOB NEEDS TO BE FAILED     */
@RF00456 ICM   @15,15,RETCODE                                   01S0469
         BZ    @RF00469                                         01S0469
*      LCTJFAIL = ON;                  /* FAIL THE JOB               */
         L     @01,PARMPTR                                      01S0470
         L     @01,LCTPTR(,@01)                                 01S0470
         OI    LCTJFAIL(@01),B'10000000'                        01S0470
*    IF LCTJFAIL = OFF &        /* JOB HAS NOT FAILED         */
*      SCTANSCT ^= ZERO &       /* NOT THE LAST STEP          */
*      (JCTSTEPR = OFF & JCTCKPTR = OFF) & /* NO RESTART      */
*      JCTWARMS = OFF &         /* NOT WARM START             */
*      TCBFA = OFF THEN/*                                       01S0471
*                                         CHECK JOB COND CODE        */
@RF00469 L     @15,PARMPTR                                      01S0471
         L     @14,LCTPTR(,@15)                                 01S0471
         TM    LCTJFAIL(@14),B'10000000'                        01S0471
         BNZ   @RF00471                                         01S0471
         L     @01,SCTPTR(,@15)                                 01S0471
         ICM   @00,7,SCTANSCT(@01)                              01S0471
         BZ    @RF00471                                         01S0471
         L     @01,JCTPTR(,@15)                                 01S0471
         TM    JCTSTEPR(@01),B'10001100'                        01S0471
         BNZ   @RF00471                                         01S0471
         L     @01,LCTTCBAD(,@14)                               01S0471
         TM    TCBFA(@01),B'10000000'                           01S0471
         BNZ   @RF00471                                         01S0471
*      DO;                                                      01S0472
*        CALL IEFBB412                 /* PROCESS JOB COND CODES     */
*            (JCTPTR,SCTPTR);                                   01S0473
         LA    @14,JCTPTR(,@15)                                 01S0473
         ST    @14,@AL00001                                     01S0473
         LA    @15,SCTPTR(,@15)                                 01S0473
         ST    @15,@AL00001+4                                   01S0473
         L     @15,@CV00292                                     01S0473
         LA    @01,@AL00001                                     01S0473
         BALR  @14,@15                                          01S0473
*        RFY REG15 RSTD;               /* RESERVE REGISTER           */
*        IF REG15 ^= ZERO THEN         /* PROCESSING FAILED          */
         LTR   REG15,REG15                                      01S0475
         BZ    @RF00475                                         01S0475
*          DO;                                                  01S0476
*            LCTJFAIL = ON;            /* MARK JOB AS FAILED         */
         L     @14,PARMPTR                                      01S0477
         L     @14,LCTPTR(,@14)                                 01S0477
         OI    LCTJFAIL(@14),B'10000000'                        01S0477
*            CONDFAIL = ON;            /* SET COND FAIL              */
         OI    CONDFAIL,B'00010000'                             01S0478
*          END;                                                 01S0479
*        RFY REG15 UNRSTD;             /* RELEASE REGISTER           */
@RF00475 DS    0H                                               01S0481
*      END;                                                     01S0481
*    IF (JCTSTEPR = ON | JCTCKPTR = ON) /* STEP WILL RESTART         */
*      | LCTJFAIL = ON                 /* JOB IS FAILED              */
*      | SCTANSCT = ZERO THEN          /* JOB IS ENDING              */
@RF00471 L     @15,PARMPTR                                      01S0482
         L     @01,JCTPTR(,@15)                                 01S0482
         TM    JCTSTEPR(@01),B'00001100'                        01S0482
         BNZ   @RT00482                                         01S0482
         L     @01,LCTPTR(,@15)                                 01S0482
         TM    LCTJFAIL(@01),B'10000000'                        01S0482
         BO    @RT00482                                         01S0482
         L     @01,SCTPTR(,@15)                                 01S0482
         ICM   @00,7,SCTANSCT(@01)                              01S0482
         BNZ   @RF00482                                         01S0482
@RT00482 DS    0H                                               01S0483
*      DO;                                                      01S0483
*        DEQLIST(1:DEQENTLN) =         /*MOVE DEQ LIST SKELETON      */
*           DEQFMT(1:DEQENTLN);                                 01S0484
         L     @15,DEQENTLN                                     01S0484
         BCTR  @15,0                                            01S0484
         EX    @15,@SM03014                                     01S0484
*        GEN REFS(DEQLIST,VOLUMES,DATASETS,OPENJ); /*DEQ'S   @ZA13820*/
          DEQ (VOLUMES,,,SYSTEM),MF=(E,DEQLIST),RET=HAVE,GENERIC=YES
          DEQ (DATASETS,,,SYSTEM),MF=(E,DEQLIST),RET=HAVE,GENERIC=YES
          DEQ (OPENJ,,,SYSTEM),MF=(E,DEQLIST),RET=HAVE,GENERIC=YES
*                                      DEQ ON OPENJ RESOURCE @ZA13820
*      END;                                                     01S0486
*    IF (SCTANSCT = ZERO &      /* LAST STEP                  */
*       (JCTSTEPR = OFF & JCTCKPTR = OFF)) | /* NO RESTART    */
*       LCTJFAIL = ON & LCTSALCD = ON THEN/*                    01S0487
*                                         INVOKE JOB UNALLOCATION    */
@RF00482 L     @15,PARMPTR                                      01S0487
         L     @01,SCTPTR(,@15)                                 01S0487
         ICM   @00,7,SCTANSCT(@01)                              01S0487
         BNZ   @GL00024                                         01S0487
         L     @01,JCTPTR(,@15)                                 01S0487
         TM    JCTSTEPR(@01),B'00001100'                        01S0487
         BZ    @RT00487                                         01S0487
@GL00024 L     @01,PARMPTR                                      01S0487
         L     @01,LCTPTR(,@01)                                 01S0487
         TM    LCTJFAIL(@01),B'11000000'                        01S0487
         BNO   @RF00487                                         01S0487
@RT00487 DS    0H                                               01S0488
*      DO;                                                      01S0488
*        JOBFNMAP = JOBFNMAP && JOBFNMAP;/* INIT JOB UNALOC FUNC. MAP*/
         XC    JOBFNMAP(1),JOBFNMAP                             01S0489
*        IF JCTABEND = ON THEN         /* AN ABEND HAS OCCURRED      */
         L     @01,PARMPTR                                      01S0490
         L     @01,JCTPTR(,@01)                                 01S0490
         TM    JCTABEND(@01),B'00001000'                        01S0490
         BNO   @RF00490                                         01S0490
*          DO;                                                  01S0491
*            JOBCNDSP = ON;            /* USE CONDITIONAL DISPS      */
*            JOBMSGS = ON;             /* ISSUE DISP. MESSAGES       */
         OI    JOBCNDSP,B'11000000'                             01S0493
*          END;                                                 01S0494
*        IF BASTCNT > ZERO THEN        /* MONITOR STATUS REQUESTED   */
@RF00490 L     @01,CVTPTR                                       01S0495
         L     @01,CVTMSER(,@01)                                01S0495
         ICM   @00,3,BASTCNT(@01)                               01S0495
         BNP   @RF00495                                         01S0495
*          JOBMSTAT = ON;              /* ISSUE MN STATUS MESSAGES   */
         OI    JOBMSTAT,B'00010000'                             01S0496
*        IF INCMALL = ON THEN          /* MSGLEVEL=1                 */
@RF00495 L     @01,PARMPTR                                      01S0497
         L     @01,JCTPTR(,@01)                                 01S0497
         TM    INCMALL(@01),B'10000000'                         01S0497
         BNO   @RF00497                                         01S0497
*          JOBMSGS = ON;               /* ISSUE DISP MESSAGES        */
         OI    JOBMSGS,B'01000000'                              01S0498
*        JOBDSPRC = ON;                /* DO DISPOSITION PROCESSING  */
@RF00497 OI    JOBDSPRC,B'00100000'                             01S0499
*        CALL IEFBB416                 /* INVOKE JOB UNALLOCATION    */
*           (JOBFNMAP,LCTJSCB,JCTPTR,ESTAPTR,LEPAPTR,RESNCODE(2),
*             CVTILK2);                                         01S0500
         LA    @15,JOBFNMAP                                     01S0500
         ST    @15,@AL00001                                     01S0500
         L     @15,PARMPTR                                      01S0500
         L     @01,LCTPTR(,@15)                                 01S0500
         LA    @14,LCTJSCB(,@01)                                01S0500
         ST    @14,@AL00001+4                                   01S0500
         LA    @15,JCTPTR(,@15)                                 01S0500
         ST    @15,@AL00001+8                                   01S0500
         LA    @15,ESTAPTR                                      01S0500
         ST    @15,@AL00001+12                                  01S0500
         LA    @15,LEPAPTR                                      01S0500
         ST    @15,@AL00001+16                                  01S0500
         LA    @15,RESNCODE+2                                   01S0500
         ST    @15,@AL00001+20                                  01S0500
         L     @01,CVTPTR                                       01S0500
         LA    @15,CVTILK2(,@01)                                01S0500
         ST    @15,@AL00001+24                                  01S0500
         L     @15,@CV00294                                     01S0500
         LA    @01,@AL00001                                     01S0500
         BALR  @14,@15                                          01S0500
*      END;                                                     01S0501
*    IF (SCTANSCT = ZERO &      /* LAST STEP                  */
*       (JCTSTEPR = OFF & JCTCKPTR = OFF)) | /* NO RESTART    */
*       LCTJFAIL = ON THEN/*                                    01S0502
*                                         PROCESS END OF JOB         */
@RF00487 L     @15,PARMPTR                                      01S0502
         L     @01,SCTPTR(,@15)                                 01S0502
         ICM   @00,7,SCTANSCT(@01)                              01S0502
         BNZ   @GL00026                                         01S0502
         L     @01,JCTPTR(,@15)                                 01S0502
         TM    JCTSTEPR(@01),B'00001100'                        01S0502
         BZ    @RT00502                                         01S0502
@GL00026 L     @01,PARMPTR                                      01S0502
         L     @01,LCTPTR(,@01)                                 01S0502
         TM    LCTJFAIL(@01),B'10000000'                        01S0502
         BNO   @RF00502                                         01S0502
@RT00502 DS    0H                                               01S0503
*      DO;                                                      01S0503
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - ENDOFJOB                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - END OF JOB PROCESSING                         */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THE FOLLOWING FUNCTIONS ARE PERFORMED IN THIS SEGMENT:         */
*/*                                                                  */
*/*   1. ISSUE END OF JOB STATUS MESSAGES -                          */
*/*      END OF JOB STATUS MESSAGES ARE ISSUED ACCORDING TO THE      */
*/*      FOLLOWING RULES:                                            */
*/*                                                                  */
*/*      . THE JOB IS NOT FAILED -                                   */
*/*        IF THE JOB IS A BACKGROUND JOB AND MN JOBNAMES WAS        */
*/*        REQUESTED BY AN OPERATOR, THE JOB ENDED MESSAGE IS        */
*/*        ISSUED. IF THE JOB IS FOREGROUND AND MN JOBNAMES OR       */
*/*        MN SESSIONS WAS REQUESTED BY AN OPERATOR, THE LOGGED OFF  */
*/*        MESSAGE IS ISSUED. IF MN TIME IS ACTIVE THE TIME IS       */
*/*        PUT IN THE MESSAGE.                                       */
*/*                                                                  */
*/*      . THE JOB IS FAILED -                                       */
*/*                                                                  */
*/*        . THE JOB FAILED BECAUSE OF JOB CONDITION CODES -         */
*/*          THE JOB ENDED BY CC MESSAGE IS ISSUED TO THE PROGRAMMER */
*/*          AND THE OPERATOR. IF THE MN TIME IS ACTIVE              */
*/*          THE TIME IS INCLUDED IN THE MESSAGE TO THE OPERATOR.    */
*/*          LCTJCFAL IS SET ON TO INDICATE JOB FAILED DUE   @Z30CPPD*/
*/*          TO COND CODES.                                  @Z30CPPD*/
*/*                                                                  */
*/*        . THE JOB DID NOT FAIL BECAUSE OF JOB CONDITION CODES -   */
*/*          IF THE END-OF-JOB-STATUS-MESSAGE-ISSUED BIT IS NOT ON,  */
*/*          THE JOB FAILED MESSAGE IS ISSUED TO THE OEPRATOR.       */
*/*          IF MN TIME IS ACTIVE, THE TIME IS INCLUDED IN THE       */
*/*          MESSAGE.                                                */
*/*                                                                  */
*/*   2. INVOKE THE SMF/USER ACCOUNTING ROUTINE -                    */
*/*      THE SMF/USER ACCOUNTING ROUTINE IS INVOKED AND A PARAMETER  */
*/*      PASSED INDICATING THAT THIS IS THE END OF THE JOB.          */
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*                                                                  */
*/*     LCT -                                                        */
*/*       LCTJFAIL - JOB FAILED BIT                                  */
*/*       LCTENQU - FOREGROUND JOB                                   */
*/*       LCTERRM - END-OF-JOB-STATUS-MESSAGE-ISSUED BIT             */
*/*                                                                  */
*/*      MASTER SCHEDULER RESIDENT DATA AREA -                       */
*/*        BAJN - MN JOBNAMES BIT                                    */
*/*        BAMSESSC - MN SESSIONS BIT                                */
*/*        MSTN - MN TIME BIT                                        */
*/*                                                                  */
*/* EXIT -                                                           */
*/*   CONDITION - NORMAL                                             */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*     MESSAGES TO OPERATOR AND PROGRAMMER                  @Z30CPPD*/
*/*     LCT -                                                        */
*/*       LCTERRM - SET OFF (IN CASE LCT IS USED FOR NEXT JOB)       */
*/*       LCTJCFAL - SET ON IF JOB FAILED DUE TO COND CODES  @Z30CPPD*/
*/*                                                                  */
*/*   RETURN CODE - NONE                                             */
*/********************************************************************/
*WTOL = WTOL && WTOL;                  /* CLEAR WTO PARM LIST        */
         XC    WTOL(138),WTOL                                   02S0504
*WTOSW = OFF;                          /* INIT WTO SWITCH            */
*MSGSW = OFF;                          /* INIT PGMR MSG SWITCH       */
*JOBNSW = OFF;                         /* INIT MSGTYP=JOBNAMES SW    */
         NI    WTOSW,B'00011111'                                02S0507
*IF JCTWARMS = OFF |                   /* NOT WARM START             */
*    (JCTWARMS = ON & JCTSWSM = OFF) THEN /* ISSUE MSGS              */
         L     @01,PARMPTR                                      02S0508
         L     @15,JCTPTR(,@01)                                 02S0508
         TM    JCTWARMS(@15),B'10000000'                        02S0508
         BZ    @RT00508                                         02S0508
         TM    JCTWARMS(@15),B'10000000'                        02S0508
         BNO   @RF00508                                         02S0508
         TM    JCTSWSM(@15),B'00010000'                         02S0508
         BNZ   @RF00508                                         02S0508
@RT00508 DS    0H                                               02S0509
*  DO;                                 /* SET UP THE MESSAGES        */
*    IF LCTJFAIL = OFF THEN            /* JOB NOT FAILED             */
         L     @01,PARMPTR                                      02S0510
         L     @15,LCTPTR(,@01)                                 02S0510
         TM    LCTJFAIL(@15),B'10000000'                        02S0510
         BNZ   @RF00510                                         02S0510
*      DO;                                                      02S0511
*        IF BAJNCNT > ZERO &           /* MN JOBNAMES        @Z30CPPD*/
*           CHTRKID ^= '01'X THEN      /* NOT TSO JOB                */
         L     @01,CVTPTR                                       02S0512
         L     @01,CVTMSER(,@01)                                02S0512
         ICM   @00,3,BAJNCNT(@01)                               02S0512
         BNP   @RF00512                                         02S0512
         L     @01,LCTQDRTY(,@15)                               02S0512
         CLI   CHTRKID(@01),X'01'                               02S0512
         BE    @RF00512                                         02S0512
*          DO;                         /* SET UP ENDED MESSAGE       */
*            WTOSW = ON;               /* ISSUE WTO MESSAGE          */
*            JOBNSW = ON;              /* MSGTYP = JOBNAMES          */
         OI    WTOSW,B'10100000'                                02S0515
*            WMSGLNTH = ENDEDLN;       /* SET WTO MESSAGE LENGTH     */
         L     @15,@CA00302                                     02S0516
         LH    @14,ENDEDLN-JOBENDED(,@15)                       02S0516
         ST    @14,WMSGLNTH                                     02S0516
*            WPLTXT(1:ENDEDLN) = ENDEDM(1:ENDEDLN); /* MOVE MSG      */
         LA    @09,WTOL                                         02S0517
         BCTR  @14,0                                            02S0517
         EX    @14,@SM03016                                     02S0517
*          END;                                                 02S0518
*        IF (BASESCT > ZERO | BAJNCNT > ZERO) & /*MN JOBNAMES OR SESS*/
*            CHTRKID = '01'X THEN      /* FOREGROUND JOB             */
@RF00512 SLR   @15,@15                                          02S0519
         L     @01,CVTPTR                                       02S0519
         L     @14,CVTMSER(,@01)                                02S0519
         CH    @15,BASESCT(,@14)                                02S0519
         BL    @GL00031                                         02S0519
         CH    @15,BAJNCNT(,@14)                                02S0519
         BNL   @RF00519                                         02S0519
@GL00031 L     @01,PARMPTR                                      02S0519
         L     @01,LCTPTR(,@01)                                 02S0519
         L     @01,LCTQDRTY(,@01)                               02S0519
         CLI   CHTRKID(@01),X'01'                               02S0519
         BNE   @RF00519                                         02S0519
*          DO;                                                  02S0520
*            WTOSW = ON;               /* ISSUE WTO MESSAGE          */
         OI    WTOSW,B'10000000'                                02S0521
*            WMSGLNTH = LOGOFFLN;      /* SET WTO MESSAGE LENGTH     */
         L     @15,@CA00310                                     02S0522
         LH    @14,LOGOFFLN-LOGGDOFF(,@15)                      02S0522
         ST    @14,WMSGLNTH                                     02S0522
*            WPLTXT(1:LOGOFFLN) = LOGOFFM(1:LOGOFFLN); /* MOVE MSG   */
         LA    @09,WTOL                                         02S0523
         BCTR  @14,0                                            02S0523
         EX    @14,@SM03018                                     02S0523
*            IF BAJNCNT > ZERO THEN    /* MN JOBNAMES REQUESTED      */
         L     @01,CVTPTR                                       02S0524
         L     @01,CVTMSER(,@01)                                02S0524
         ICM   @00,3,BAJNCNT(@01)                               02S0524
         BNP   @RF00524                                         02S0524
*              JOBNSW = ON;            /* MSGTYP = JOBNAMES          */
         OI    JOBNSW,B'00100000'                               02S0525
*          END;                                                 02S0526
*      END;                                                     02S0527
*    ELSE                              /* JOB IS FAILED              */
*      IF CONDFAIL = ON THEN           /* JOB COND CODE FAILURE      */
         B     @RC00510                                         02S0528
@RF00510 TM    CONDFAIL,B'00010000'                             02S0528
         BNO   @RF00528                                         02S0528
*        DO;                           /* SET UP COND FAIL MESSAGES  */
*          LCTJCFAL = ON;              /*INDICATE THAT JOB COND CODES
*                                        CAUSED JOB TO FAIL  @Z30CPPD*/
         L     @01,PARMPTR                                      02S0530
         L     @01,LCTPTR(,@01)                                 02S0530
         OI    LCTJCFAL(@01),B'00000100'                        02S0530
*          JOBNSW = ON;                /* MSGTYP = JOBNAMES          */
*          WTOSW = ON;                 /* ISSUE WTO MESSAGE          */
         OI    JOBNSW,B'10100000'                               02S0532
*          WMSGLNTH = CCFAILLN;        /* SET WTO LENGTH             */
         L     @15,@CA00298                                     02S0533
         LH    @14,CCFAILLN-CCFAIL(,@15)                        02S0533
         ST    @14,WMSGLNTH                                     02S0533
*          WPLTXT(1:CCFAILLN) = CCFAILM(1:CCFAILLN); /* MOVE MSG     */
         LA    @09,WTOL                                         02S0534
         BCTR  @14,0                                            02S0534
         EX    @14,@SM03020                                     02S0534
*          MSGSW = ON;                 /* ISSUE MESSAGE TO PGMR      */
         OI    MSGSW,B'01000000'                                02S0535
*          LMSGLNTH = PGMCLNTH;        /* SET MSG LENGTH             */
         L     @15,@CA00317                                     02S0536
         LH    @14,PGMCLNTH-PGMCFAIL(,@15)                      02S0536
         ST    @14,LMSGLNTH                                     02S0536
*          MSG(1:PGMCLNTH) = PGMCTEXT(1:PGMCLNTH); /* MOVE MSG       */
         BCTR  @14,0                                            02S0537
         EX    @14,@SM03022                                     02S0537
*        END;                                                   02S0538
*      ELSE                            /* NOT COND CODE FAILURE      */
*        IF LCTERRM = OFF THEN         /* MESSAGE MUST BE SENT TO
*                                         OPERATOR           @Z30CPPD*/
         B     @RC00528                                         02S0539
@RF00528 L     @01,PARMPTR                                      02S0539
         L     @01,LCTPTR(,@01)                                 02S0539
         TM    LCTERRM(@01),B'00000001'                         02S0539
         BNZ   @RF00539                                         02S0539
*          DO;                         /* SET UP MESSAGE             */
*            WTOSW = ON;               /* ISSUE WTO MESSAGE          */
*            JOBNSW = ON;              /* MSGTYP = JOBNAMES          */
         OI    WTOSW,B'10100000'                                02S0542
*            WMSGLNTH = JOBFAILL;      /* SET LENGTH OF MSG          */
         L     @15,@CA00306                                     02S0543
         LH    @14,JOBFAILL-JOBFAILD(,@15)                      02S0543
         ST    @14,WMSGLNTH                                     02S0543
*            WPLTXT(1:JOBFAILL) = JOBFAILM(1:JOBFAILL); /* MOVE MSG  */
         LA    @09,WTOL                                         02S0544
         BCTR  @14,0                                            02S0544
         EX    @14,@SM03024                                     02S0544
*          END;                                                 02S0545
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - ENDJMSG                                           */
*/*                                                                  */
*/* DESCRIPTIVE NAME - ISSUE END OF JOB STATUS MESSAGES              */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THE FUNCTION OF THIS SEGMENT IS TO ISSUE END OF JOB STATUS     */
*/*   MESSAGES.                                                      */
*/*                                                                  */
*/*   OPERATION -                                                    */
*/*   1. COMPLETE THE MESSAGE(S) -                                   */
*/*      IF MN TIME IS ACTIVE, THE TIME IS PUT IN THE OPERATOR       */
*/*      MESSAGE .  IF THE MESSAGE IS A CONDITION CODE       @Z30CPPD*/
*/*      FAILURE MESSAGE, THE CONDITION CODE IS PUT IN THE           */
*/*      MESSAGE. THE JOBNAME IS INSERTED IN ALL MESSAGES.           */
*/*                                                                  */
*/*   2. ISSUE THE MESSAGE(S) -                                      */
*/*      IF A WTO IS REQUESTED THE MESSAGE IS ISSUED TO THE          */
*/*      OPERATOR. IF A MESSAGE TO THE PROGRAMMER IS REQUESTED       */
*/*      THE MESSAGE IS ISSUED TO THE PROGRAMMER.                    */
*/*                                                                  */
*/*    NOTES -                                                       */
*/*                                                                  */
*/*         MESSAGES ARE KEPT IN EXTERNAL PROCEDURES. THE LENGTH     */
*/*         OF EACH MESSAGE IS KEPT WITH THE MESSAGE AND FOR MESSAGES*/
*/*         THAT HAVE VARIABLE INFORMATION (E.G. THE TIME), A        */
*/*         DISPLACEMENT WITHIN THE MESSAGE WHERE THE VARIABLE       */
*/*         INFORMATION GOES IS KEPT. THESE LENGTHS AND DISPLACEMENTS*/
*/*         ARE USED WHEN CONSTRUCTING THE MESSAGES: SEE B410DATA    */
*/*         FOR MORE DETAIL.                                         */
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*                                                                  */
*/*     LCT -                                                        */
*/*       LCTJFAIL - JOB FAILED BIT                                  */
*/*       LCTENQU - FOREGROUND JOB                                   */
*/*                                                                  */
*/*     JCT -                                                        */
*/*       JCTJNAME - JOB NAME                                        */
*/*                                                                  */
*/*     SCT -                                                        */
*/*       SCTSNAME - STEP NAME                                       */
*/*       SCTSCLPC - PROC STEP NAME                                  */
*/*                                                                  */
*/*     MASTER SCHEDULER RESIDENT DATA AREA -                        */
*/*        MSTN - MN TIME IS ACTIVE                                  */
*/*                                                                  */
*/*     WTOSW - ISSUE A MESSAGE TO THE OPERATOR                      */
*/*                                                                  */
*/*     MSGSW - ISSUE A MESSAGE TO THE PROGRAMMER                    */
*/*                                                                  */
*/*     CONDFAIL - JOB FAILED BECAUSE OF CONDITION CODES             */
*/*                                                                  */
*/*     COMPCODE - CONDITION CODE THAT CAUSED THE JOB TO FAIL        */
*/*                                                                  */
*/* EXIT -                                                           */
*/*   CONDITION - NORMAL                                             */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*     MESSAGES ISSUED                                              */
*/*                                                                  */
*/*   RETURN CODE - NONE                                             */
*/*                                                                  */
*/********************************************************************/
*IF WTOSW = ON THEN                    /* ISSUE WTO          @Z30CPPD*/
@RF00539 DS    0H                                               03S0546
@RC00528 DS    0H                                               03S0546
@RC00510 TM    WTOSW,B'10000000'                                03S0546
         BNO   @RF00546                                         03S0546
*  DO;                                                          03S0547
*    WTOJNAME = JCTJNAME;              /* MOVE JOB NAME TO MSG       */
         LA    @15,WTOL                                         03S0548
         LA    @14,4                                            03S0548
         ALR   @14,@15                                          03S0548
         L     @09,PARMPTR                                      03S0548
         L     @01,JCTPTR(,@09)                                 03S0548
         MVC   WTOJNAME(8,@14),JCTJNAME(@01)                    03S0548
*    IF CONDFAIL = ON THEN             /* COND CODE FAILURE          */
         TM    CONDFAIL,B'00010000'                             03S0549
         BNO   @RF00549                                         03S0549
*      DO;                             /* MOVE IN MORE NAMES         */
*        WTOSNAME = SCTSNAME;          /* MOVE IN STEP NAME          */
         L     @09,SCTPTR(,@09)                                 03S0551
         MVC   WTOSNAME(8,@14),SCTSNAME(@09)                    03S0551
*        WTOPSNAM = SCTSCLPC;          /* MOVE IN PROC STEP NAME     */
         MVC   WTOPSNAM(8,@14),SCTSCLPC(@09)                    03S0552
*        WTOJCOND = COMPCODE;          /* MOVE COND CODE TO MESSAGE  */
         LA    @15,WPLTXT(,@15)                                 03S0553
         L     @14,@CA00298                                     03S0553
         AH    @15,CCFLCDSP-CCFAIL(,@14)                        03S0553
         MVC   WTOJCOND(4,@15),COMPCODE                         03S0553
*      END;                                                     03S0554
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - SETTIME                                           */
*/*                                                                  */
*/* DESCRIPTIVE NAME - PUT THE TIME IN THE END OF JOB MSG            */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THE FUNCTION OF THIS SEGMENT IS TO OBTAIN THE CURRENT TIME,    */
*/*   CONVERT IT TO PRINTABLE FORM AND INSERT IT INTO THE            */
*/*   WTO MESSAGE OR, IF MN TIME WAS NOT SPECIFIED, BLANK OUT        */
*/*   THE TIME FIELD IN THE MESSAGE.                                 */
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*                                                                  */
*/*     LCT -                                                        */
*/*       LCTJFAIL - JOB IS FAILED                                   */
*/*       LCTENQU - FOREGROUND JOB                                   */
*/*                                                                  */
*/*     MASTER SCHEDULER RESIDENT DATA AREA -                        */
*/*       MSTN - MN TIME IS ACTIVE                                   */
*/*                                                                  */
*/*     WTOSW - WTO MUST BE ISSUED                                   */
*/*                                                                  */
*/* EXIT -                                                           */
*/*                                                                  */
*/*   CONDITION - NORMAL                                             */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*                                                                  */
*/*     TIME - FIELD TO CONTAIN THE TIME IN WPLTXT                   */
*/*                                                                  */
*/*   RETURN CODE - NONE                                             */
*/*                                                                  */
*/********************************************************************/
*IF LCTJFAIL = OFF THEN                /* JOB NOT FAILED             */
@RF00549 L     @01,PARMPTR                                      04S0555
         L     @15,LCTPTR(,@01)                                 04S0555
         TM    LCTJFAIL(@15),B'10000000'                        04S0555
         BNZ   @RF00555                                         04S0555
*  IF CHTRKID = '01'X THEN             /* FOREGROUND JOB             */
         L     @01,LCTQDRTY(,@15)                               04S0556
         CLI   CHTRKID(@01),X'01'                               04S0556
         BNE   @RF00556                                         04S0556
*    TIMEPTR = ADDR(WPLTXT)+LOGTDISP;  /* SET LENGTH OF MSG          */
         LA    TIMEPTR,WTOL                                     04S0557
         LA    TIMEPTR,WPLTXT(,TIMEPTR)                         04S0557
         L     @03,@CA00310                                     04S0557
         AH    TIMEPTR,LOGTDISP-LOGGDOFF(,@03)                  04S0557
*  ELSE                                /* BACKGROUND JOB             */
*    TIMEPTR = ADDR(WPLTXT)+ENDTDISP;  /* SET TIME POINTER           */
         B     @RC00556                                         04S0558
@RF00556 LA    TIMEPTR,WTOL                                     04S0558
         LA    TIMEPTR,WPLTXT(,TIMEPTR)                         04S0558
         L     @03,@CA00302                                     04S0558
         AH    TIMEPTR,ENDTDISP-JOBENDED(,@03)                  04S0558
*ELSE                                  /* JOB WAS FAILED             */
*  IF CONDFAIL = ON THEN               /* COND CODE FAILURE          */
         B     @RC00555                                         04S0559
@RF00555 TM    CONDFAIL,B'00010000'                             04S0559
         BNO   @RF00559                                         04S0559
*    TIMEPTR = ADDR(WPLTXT)+CCFLTDSP;  /* SET TIME POINTER           */
         LA    TIMEPTR,WTOL                                     04S0560
         LA    TIMEPTR,WPLTXT(,TIMEPTR)                         04S0560
         L     @03,@CA00298                                     04S0560
         AH    TIMEPTR,CCFLTDSP-CCFAIL(,@03)                    04S0560
*  ELSE                                /* NOT COND CODE FAILURE      */
*    TIMEPTR = ADDR(WPLTXT)+JOBFTDSP;  /* SET TIME POINTER           */
         B     @RC00559                                         04S0561
@RF00559 LA    TIMEPTR,WTOL                                     04S0561
         LA    TIMEPTR,WPLTXT(,TIMEPTR)                         04S0561
         L     @03,@CA00306                                     04S0561
         AH    TIMEPTR,JOBFTDSP-JOBFAILD(,@03)                  04S0561
*IF MSTN = ON & WTOSW = ON THEN        /* PUT TIME IN WTO MSG        */
@RC00559 DS    0H                                               04S0562
@RC00555 L     @03,CVTPTR                                       04S0562
         L     @03,CVTMSER(,@03)                                04S0562
         TM    MSTN+136(@03),B'00000010'                        04S0562
         BNO   @RF00562                                         04S0562
         TM    WTOSW,B'10000000'                                04S0562
         BNO   @RF00562                                         04S0562
*  DO;                                                          04S0563
*    RFY (REG0,REG1) RSTD;             /* RESERVE REGISTERS          */
*    GEN (TIME DEC);                   /* GET THE TIME               */
         TIME DEC
*    DECTIME = REG0;                   /* MOVE TIME TO LCL AREA      */
         ST    REG0,DECTIME                                     04S0566
*    RFY (REG0,REG1) UNRSTD;           /* RELEASE REGISTERS          */
*    UNPK (TIME(1:7),DECTIME);         /* CONVERT TIME TO EBCDIC     */
         UNPK  TIME(7),DECTIME(4)                               04S0568
*    WTOHH = HOURS;                    /* MOVE HOURS TO MESSAGE      */
         MVC   WTOHH(2,TIMEPTR),HOURS                           04S0569
*    WTOMM = MINUTES;                  /* MOVE MINUTES TO MESSAGE    */
         MVC   WTOMM(2,TIMEPTR),MINUTES                         04S0570
*    WTOSS = SECONDS;                  /* MOVE SECONDS TO MESSAGE    */
         MVC   WTOSS(2,TIMEPTR),SECONDS                         04S0571
*  END;                                                         04S0572
*ELSE                                  /* TIME NOT WANTED            */
*  WTOTIME = '';                       /* BLANK OUT THE TIME         */
         B     @RC00562                                         04S0573
@RF00562 MVI   WTOTIME(TIMEPTR),C' '                            04S0573
         MVC   WTOTIME+1(14,TIMEPTR),WTOTIME(TIMEPTR)           04S0573
*    CALL IEFAB4F3(ADDR(WPLTXT),WMSGLNTH,CMSGLNTH); /* COMPRESS BLNKS*/
@RC00562 LA    @15,WTOL                                         03S0574
         LA    @15,WPLTXT(,@15)                                 03S0574
         ST    @15,@TF00001                                     03S0574
         LA    @15,@TF00001                                     03S0574
         ST    @15,@AL00001                                     03S0574
         LA    @15,WMSGLNTH                                     03S0574
         ST    @15,@AL00001+4                                   03S0574
         LA    @15,CMSGLNTH                                     03S0574
         ST    @15,@AL00001+8                                   03S0574
         L     @15,@CV00288                                     03S0574
         LA    @01,@AL00001                                     03S0574
         BALR  @14,@15                                          03S0574
*    IF WTOSW = ON THEN                /* WRITE MSG TO OPERATOR      */
         TM    WTOSW,B'10000000'                                03S0575
         BNO   @RF00575                                         03S0575
*      DO;                                                      03S0576
*        WPLLGH = CMSGLNTH + LWTOBYTE; /* SET WTO LIST LENGTH        */
         LA    @15,WTOL                                         03S0577
         L     @14,CMSGLNTH                                     03S0577
         AL    @14,LWTOBYTE                                     03S0577
         STH   @14,WPLLGH(,@15)                                 03S0577
*        RFY WPLFLGS BASED(ADDR(WPL)+WPLLGH);                   03S0578
*        WPLFLGS = WPLFLGS && WPLFLGS; /* CLEAR WTO FLAG BITS        */
         ALR   @14,@15                                          03S0579
         XC    WPLFLGS(8,@14),WPLFLGS(@14)                      03S0579
*        WPLMCSFA = ON;                /* ROUT/DESC CODES PRESENT    */
*        WPLMCSFC = ON;                /* COMMAND RESPONSE           */
*        WPLMCSFD = ON;                /* MSGTYP FIELD PRESENT       */
         OI    WPLMCSFA(@15),B'10110000'                        03S0582
*        WPLDESCF = ON;                /* DESC CODE = JOB STATUS     */
         OI    WPLDESCF(@14),B'00000100'                        03S0583
*        WPLROUTB = ON;                /* ROUTCODE=MSTR CNSL INFO
*                                                            @ZA03525*/
         OI    WPLROUTB(@14),B'01000000'                        03S0584
*        IF JOBNSW = ON THEN           /* MSGTYP JOBNAMES REQUESTED  */
         TM    JOBNSW,B'00100000'                               03S0585
         BNO   @RF00585                                         03S0585
*          WPLMSGTA = ON;              /* MSGTYP = JOBNAMES          */
         OI    WPLMSGTA(@14),B'10000000'                        03S0586
*        IF CHTRKID = '01'X THEN       /* FOREGROUND JOB             */
@RF00585 L     @01,PARMPTR                                      03S0587
         L     @01,LCTPTR(,@01)                                 03S0587
         L     @01,LCTQDRTY(,@01)                               03S0587
         CLI   CHTRKID(@01),X'01'                               03S0587
         BNE   @RF00587                                         03S0587
*          WPLMSGTF = ON;              /* MSGTYPE = SESSIONS         */
         LA    @15,WTOL                                         03S0588
         LH    @14,WPLLGH(,@15)                                 03S0588
         ALR   @14,@15                                          03S0588
         OI    WPLMSGTF(@14),B'00000100'                        03S0588
*        GEN REFS(WTOL)                /* ISSUE WTO                  */
*           (WTO MF=(E,WTOL));                                  03S0589
@RF00587 DS    0H                                               03S0589
         WTO MF=(E,WTOL)
*      END;                                                     03S0590
*  END;                                                         03S0591
@RF00575 DS    0H                                               03S0592
*IF MSGSW = ON THEN                    /* ISSUE MSG TO PROGRAMMER    */
@RF00546 TM    MSGSW,B'01000000'                                03S0592
         BNO   @RF00592                                         03S0592
*  DO;                                                          03S0593
*    MS1JNAME = JCTJNAME;              /* MOVE JOBNAME TO MSG        */
         L     @15,PARMPTR                                      03S0594
         L     @01,JCTPTR(,@15)                                 03S0594
         MVC   MS1JNAME(8),JCTJNAME(@01)                        03S0594
*    MS1SNAME = SCTSNAME;              /* PUT IN STEP NAME           */
         L     @15,SCTPTR(,@15)                                 03S0595
         MVC   MS1SNAME(8),SCTSNAME(@15)                        03S0595
*    MS1PSNAM = SCTSCLPC;              /* PUT IN PROC STEP NAME      */
         MVC   MS1PSNAM(8),SCTSCLPC(@15)                        03S0596
*    CALL IEFAB4F3(ADDR(MSG),LMSGLNTH,CMSGLNTH); /*COMPRESS BLANKS   */
         LA    @15,MSG                                          03S0597
         ST    @15,@TF00001                                     03S0597
         LA    @15,@TF00001                                     03S0597
         ST    @15,@AL00001                                     03S0597
         LA    @15,LMSGLNTH                                     03S0597
         ST    @15,@AL00001+4                                   03S0597
         LA    @15,CMSGLNTH                                     03S0597
         ST    @15,@AL00001+8                                   03S0597
         L     @15,@CV00288                                     03S0597
         LA    @01,@AL00001                                     03S0597
         BALR  @14,@15                                          03S0597
*    CALL IEFAB4FD                     /* ISSUE MSG TO PGMR          */
*       (FUNC4FD,ADDR(MSG),CMSGLNTH,0,LCTJSCB);                 03S0598
         LA    @15,FUNC4FD                                      03S0598
         ST    @15,@AL00001                                     03S0598
         LA    @15,MSG                                          03S0598
         ST    @15,@TF00001                                     03S0598
         LA    @15,@TF00001                                     03S0598
         ST    @15,@AL00001+4                                   03S0598
         LA    @15,CMSGLNTH                                     03S0598
         ST    @15,@AL00001+8                                   03S0598
         LA    @15,@CF00276                                     03S0598
         ST    @15,@AL00001+12                                  03S0598
         L     @01,PARMPTR                                      03S0598
         L     @01,LCTPTR(,@01)                                 03S0598
         LA    @15,LCTJSCB(,@01)                                03S0598
         ST    @15,@AL00001+16                                  03S0598
         L     @15,@CV00286                                     03S0598
         LA    @01,@AL00001                                     03S0598
         BALR  @14,@15                                          03S0598
*  END;                                                         03S0599
*  END;                                                         02S0600
@RF00592 DS    0H                                               02S0601
*LCTPARM1 = SMFEOJ;                    /* SET PARM FOR SMF           */
@RF00508 L     @15,PARMPTR                                      02S0601
         L     @01,LCTPTR(,@15)                                 02S0601
         MVC   LCTPARM1(4,@01),@CF00054                         02S0601
*CALL IEFTB721(LCTPTR,ZERO);           /* INVOKE SMF/USER ACCT RTN   */
         ST    @15,@AL00001                                     02S0602
         LA    @15,@CF00276                                     02S0602
         ST    @15,@AL00001+4                                   02S0602
         L     @15,@CV00291                                     02S0602
         LA    @01,@AL00001                                     02S0602
         BALR  @14,@15                                          02S0602
*LCTERRM = OFF;                        /* RESET EOJ MSG INDICATOR    */
         L     @01,PARMPTR                                      02S0603
         L     @01,LCTPTR(,@01)                                 02S0603
         NI    LCTERRM(@01),B'11111110'                         02S0603
*      END;                                                     01S0604
*  END;                                                         01S0605
*ELSE                                  /* INITIALIZATION FAILED      */
*  DO;                                                          01S0606
         B     @RC00208                                         01S0606
@RF00208 DS    0H                                               01S0607
*    DEQLIST(1:DEQENTLN) = DEQFMT(1:DEQENTLN); /*MOVE LIST SKELETON  */
         L     @15,DEQENTLN                                     01S0607
         BCTR  @15,0                                            01S0607
         EX    @15,@SM03014                                     01S0607
*    GEN REFS(DEQLIST,VOLUMES,DATASETS,OPENJ); /*DEQ'S       @ZA13820*/
      DEQ (VOLUMES,,,SYSTEM),MF=(E,DEQLIST),RET=HAVE,GENERIC=YES
      DEQ (DATASETS,,,SYSTEM),MF=(E,DEQLIST),RET=HAVE,GENERIC=YES
      DEQ (OPENJ,,,SYSTEM),MF=(E,DEQLIST),RET=HAVE,GENERIC=YES
*                                      DEQ ON OPENJ RESOURCE @ZA13820
*    LCTJFAIL = ON;                    /* FAIL THE JOB               */
         L     @01,PARMPTR                                      01S0609
         L     @01,LCTPTR(,@01)                                 01S0609
         OI    LCTJFAIL(@01),B'10000000'                        01S0609
*  END;                                                         01S0610
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - B410CLNP                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - CLEANUP PROCESSING FOR IEFBB410               */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THE FUNCTION OF THIS SEGMENT IS TO CLEAN UP FOR IEFBB410.      */
*/*                                                                  */
*/*   OPERATION -                                                    */
*/*   . WRITE SWA CONTROL BLOCKS / FREE EPAS                         */
*/*     THE SWA MANAGER INTERFACE ROUTINE IS INVOKED TO ISSUE A      */
*/*     WRITE LOCATE FOR ALL EPAS ON THE CHAIN               @ZM41392*/
*/*                                                          @ZMF1392*/
*/*   . FREE EPA CORE                                        @ZM41392*/
*/*     IF ANY BLOCKS OF CORE WERE OBTAINED FOR EPA'S IN     @ZM41392*/
*/*     THIS MODULE OR THE SIOT READER, THEY ARE FREED HERE. @ZM41392*/
*/*                                                                  */
*/*   . ISSUE ERROR MESSAGES -                                       */
*/*     IF ANY NON-ZERO REASON CODES EXIST, A MESSAGE IS ISSUED      */
*/*     TO THE PROGRAMMER. THE REASON CODE DETERMINES WHICH          */
*/*     MESSAGE WILL BE ISSUED. IF ANY NON-ZERO REASON CODE IS       */
*/*     ENCOUNTERED, A MESSAGE IS SENT TO THE OPERATOR INFORMING     */
*/*     HIM THAT UNALLOCATION FOR THIS STEP WAS NOT COMPLETE AND     */
*/*     SOME RESOURCES MAY NOT HAVE BEEN RELEASED.                   */
*/*                                                                  */
*/*   . THE ESATE ENVIRONMENT IS CANCELLED -                         */
*/*     AN ESTAE MACRO SPECIFYING CANCEL IS ISSUED.                  */
*/*                                                                  */
*/*   . THE LCT SCT SVA FIELD IS UPDATED TO THE NEXT STEP'S SCT      */
*/*     SVA (ZERO IF THIS WAS THE LAST STEP).                        */
*/*                                                                  */
*/*   . INSURE WTP MESSAGES ARE WRITTEN -                            */
*/*     IEEAB401 IS INVOKED TO WRITE ANY MESSAGES TO THE PROGRAMMER  */
*/*     WHICH MAY STILL IN BUFFERS.                                  */
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*                                                                  */
*/*   PURPOSE - SEE FUNCTION                                         */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*     RESNCODE - ARRAY OF REASON CODES                             */
*/*                                                                  */
*/*     FEPAPTR - ADDRESS OF THE FIRST EPA                           */
*/*                                                                  */
*/*     EPA -                                                        */
*/*       SWCHNPTR - ADDRESS OF THE NEXT EPA                         */
*/*                                                                  */
*/*     JCT -                                                        */
*/*       JCTJNAME - JOB NAME                                        */
*/*                                                                  */
*/*     SCT -                                                        */
*/*       SCTSNAME - STEP NAME                                       */
*/*       SCTSCLPC - PROC STEP NAME                                  */
*/*                                                                  */
*/* EXIT -                                                           */
*/*                                                                  */
*/*   CONDITION - NORMAL                                             */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*                                                                  */
*/*     MESSAGE TO PROGRAMMER AND OPERATOR                           */
*/*                                                                  */
*/*     SWA BLOCKS WRITTEN                                           */
*/*                                                                  */
*/*     EPAS FREED                                                   */
*/*                                                                  */
*/*   RETURN CODE - NONE                                             */
*/********************************************************************/
*IF FEPAPTR ^= ZERO THEN               /* EPA CHAIN EXISTS           */
@RC00208 ICM   @15,15,FEPAPTR                                   02S0611
         BZ    @RF00611                                         02S0611
*  DO;                                                          02S0612
*    SWACTLS = SWACTLS && SWACTLS;     /* CLEAR SWA MGR INTF CONTROLS*/
         SLR   @15,@15                                          02S0613
         ICM   @15,3,SWACTLS                                    02S0613
         LR    @14,@15                                          02S0613
         XR    @14,@15                                          02S0613
         STH   @14,SWACTLS                                      02S0613
*    SWWRT = ON;                       /* INDICATE WRITE FUNCTION    */
*    SWOLD = ON;                       /* INDICATE TO USE OLD EPAS   */
         OI    SWWRT,B'00010001'                                02S0615
*    CALL IEFAB4F7(SWACTLS,FEPAPTR,0,0,0,0,0); /* WRITE TABLES, FREE
*                                         EPAS VIA SWA MSG INTF. RTN */
         MVC   @AL00001+8(20),@AL00616                          02S0616
         LA    @15,SWACTLS                                      02S0616
         ST    @15,@AL00001                                     02S0616
         LA    @15,FEPAPTR                                      02S0616
         ST    @15,@AL00001+4                                   02S0616
         L     @15,@CV00290                                     02S0616
         LA    @01,@AL00001                                     02S0616
         BALR  @14,@15                                          02S0616
*  END;                                                         02S0617
*EPBLKPTR = FEPBLKP;                   /* SET BLK BASE       @ZM41392*/
@RF00611 L     EPBLKPTR,FEPBLKP                                 02S0618
*DO WHILE EPBLKPTR ^= ZERO;            /* FREE ALL BLOCKS    @ZM41392*/
         B     @DE00619                                         02S0619
@DL00619 DS    0H                                               02S0620
*  SAVNEXTP = EPABNXTP;                /* SAVE NEXT BLK PTR  @ZM41392*/
         L     SAVNEXTP,EPABNXTP(,EPBLKPTR)                     02S0620
*  RFY (REG0,REG1) RSTD;               /* RESERVE SVC REGS   @ZM41392*/
*  REG1 = EPBLKPTR;                    /* BLK TO FREE        @ZM41392*/
         LR    REG1,EPBLKPTR                                    02S0622
*  REG0 = EPABSIZE;                    /* SIZE OF BLK        @ZM41392*/
         L     REG0,EPABSIZE(,EPBLKPTR)                         02S0623
*  REG0 = REG0 | SUBPL230;             /* INDICATE SUBPOOL   @ZM41392*/
         O     REG0,@CF00271                                    02S0624
*  GEN (FREEMAIN R,LV=(0),A=(1));      /* FREE EPA BLOCK     @ZM41392*/
         FREEMAIN R,LV=(0),A=(1)
*  RFY (REG0,REG1) UNRSTD;             /* RELEASE SVC REGS   @ZM41392*/
*  EPBLKPTR = SAVNEXTP;                /* GET NEXT BLOCK     @ZM41392*/
         LR    EPBLKPTR,SAVNEXTP                                02S0627
*END;                                  /* END FREE EPA BLKS  @ZM41392*/
@DE00619 LTR   EPBLKPTR,EPBLKPTR                                02S0628
         BNZ   @DL00619                                         02S0628
*WTOSW = OFF;                          /* WTO NOT ISSUED YET         */
         NI    WTOSW,B'01111111'                                02S0629
*DO MSGCTR = ONE TO DIM(RESNCODE);     /* LOOK AT ALL REASON CODES   */
         LA    MSGCTR,1                                         02S0630
@DL00630 DS    0H                                               02S0631
*  IF RESNCODE(MSGCTR) ^= ZERO THEN    /* VALID REASON CODE          */
         LR    @03,MSGCTR                                       02S0631
         ALR   @03,@03                                          02S0631
         LH    @03,RESNCODE-2(@03)                              02S0631
         LTR   @03,@03                                          02S0631
         BZ    @RF00631                                         02S0631
*    DO;                                                        02S0632
*      MSG(1:MSGLNTH) = STEPMSG(1:MSGLNTH); /* MOVE MSG TO LCL AREA  */
         SLA   @03,2                                            02S0633
         L     @15,@CA00296                                     02S0633
         LA    @01,0(@03,@15)                                   02S0633
         BCTR  @01,0                                            02S0633
         BCTR  @01,0                                            02S0633
         LH    @14,MSGLNTH(,@01)                                02S0633
         LR    @09,@14                                          02S0633
         BCTR  @09,0                                            02S0633
         L     @08,@CA00142                                     02S0633
         AL    @15,@CF03027                                     02S0633
         AH    @08,MOTOFFST-B410MOFT(@03,@15)                   02S0633
         EX    @09,@SM03028                                     02S0633
*      MS1JNAME = JCTJNAME;            /* MOVE JOB NAME TO MSG       */
         L     @03,PARMPTR                                      02S0634
         L     @01,JCTPTR(,@03)                                 02S0634
         MVC   MS1JNAME(8),JCTJNAME(@01)                        02S0634
*      MS1SNAME = SCTSNAME;            /* MOVE STEP NAME TO MSG      */
         L     @03,SCTPTR(,@03)                                 02S0635
         MVC   MS1SNAME(8),SCTSNAME(@03)                        02S0635
*      MS1PSNAM = SCTSCLPC;            /* MOVE PROC NAME TO MESSAGE  */
         MVC   MS1PSNAM(8),SCTSCLPC(@03)                        02S0636
*      LMSGLNTH = MSGLNTH;             /* MOVE LENGTH TO LCL AREA    */
         ST    @14,LMSGLNTH                                     02S0637
*      CALL IEFAB4F3(ADDR(MSG),LMSGLNTH,CMSGLNTH); /* COMPRESS BLANKS*/
         LA    @03,MSG                                          02S0638
         ST    @03,@TF00001                                     02S0638
         LA    @03,@TF00001                                     02S0638
         ST    @03,@AL00001                                     02S0638
         LA    @03,LMSGLNTH                                     02S0638
         ST    @03,@AL00001+4                                   02S0638
         LA    @03,CMSGLNTH                                     02S0638
         ST    @03,@AL00001+8                                   02S0638
         L     @15,@CV00288                                     02S0638
         LA    @01,@AL00001                                     02S0638
         BALR  @14,@15                                          02S0638
*      CALL IEFAB4FD                   /* ISSUE THE MESSAGE          */
*        (FUNC4FD,ADDR(MSG),CMSGLNTH,0,LCTJSCB);                02S0639
         LA    @03,FUNC4FD                                      02S0639
         ST    @03,@AL00001                                     02S0639
         LA    @03,MSG                                          02S0639
         ST    @03,@TF00001                                     02S0639
         LA    @03,@TF00001                                     02S0639
         ST    @03,@AL00001+4                                   02S0639
         LA    @03,CMSGLNTH                                     02S0639
         ST    @03,@AL00001+8                                   02S0639
         LA    @03,@CF00276                                     02S0639
         ST    @03,@AL00001+12                                  02S0639
         L     @03,PARMPTR                                      02S0639
         L     @03,LCTPTR(,@03)                                 02S0639
         LA    @03,LCTJSCB(,@03)                                02S0639
         ST    @03,@AL00001+16                                  02S0639
         L     @15,@CV00286                                     02S0639
         LA    @01,@AL00001                                     02S0639
         BALR  @14,@15                                          02S0639
*      IF WTOSW = OFF THEN             /* WTO NOT YET ISSUED         */
         TM    WTOSW,B'10000000'                                02S0640
         BNZ   @RF00640                                         02S0640
*        DO;                                                    02S0641
*          WTOL = WTOL && WTOL;        /* ZERO WTO LIST              */
         XC    WTOL(138),WTOL                                   02S0642
*          WPLMCSFA = ON;              /* ROUT/DESC CODES PRESENT    */
         LA    @03,WTOL                                         02S0643
         OI    WPLMCSFA(@03),B'10000000'                        02S0643
*          WPLTXT(1:UNERMSGL) = UNERMSGT(1:UNERMSGL); /* MOVE TEXT   */
         L     @15,@CA00329                                     02S0644
         LH    @14,UNERMSGL-UNERRMSG(,@15)                      02S0644
         LR    @09,@14                                          02S0644
         BCTR  @09,0                                            02S0644
         EX    @09,@SM03030                                     02S0644
*          LMSGLNTH = UNERMSGL;        /* MOVE LENGTH TO LCL AREA    */
         ST    @14,LMSGLNTH                                     02S0645
*          WTOJNAME = JCTJNAME;        /* MOVE JOB NAME TO MSG       */
         LA    @15,4                                            02S0646
         ALR   @15,@03                                          02S0646
         L     @14,PARMPTR                                      02S0646
         L     @01,JCTPTR(,@14)                                 02S0646
         MVC   WTOJNAME(8,@15),JCTJNAME(@01)                    02S0646
*          WTOSNAME = SCTSNAME;        /* MOVE STEP NAME TO MSG      */
         L     @14,SCTPTR(,@14)                                 02S0647
         MVC   WTOSNAME(8,@15),SCTSNAME(@14)                    02S0647
*          WTOPSNAM = SCTSCLPC;        /* MOVE PROC NAME TO MSG      */
         MVC   WTOPSNAM(8,@15),SCTSCLPC(@14)                    02S0648
*          CALL IEFAB4F3               /* COMPRESS BLANKS            */
*             (ADDR(WPLTXT),LMSGLNTH,CMSGLNTH);                 02S0649
         LA    @03,WPLTXT(,@03)                                 02S0649
         ST    @03,@TF00001                                     02S0649
         LA    @03,@TF00001                                     02S0649
         ST    @03,@AL00001                                     02S0649
         LA    @03,LMSGLNTH                                     02S0649
         ST    @03,@AL00001+4                                   02S0649
         LA    @03,CMSGLNTH                                     02S0649
         ST    @03,@AL00001+8                                   02S0649
         L     @15,@CV00288                                     02S0649
         LA    @01,@AL00001                                     02S0649
         BALR  @14,@15                                          02S0649
*          WPLLGH = CMSGLNTH + LWTOBYTE; /* SET LENGTH IN WTO LIST   */
         LA    @03,WTOL                                         02S0650
         L     @15,CMSGLNTH                                     02S0650
         AL    @15,LWTOBYTE                                     02S0650
         STH   @15,WPLLGH(,@03)                                 02S0650
*          RFY WPLFLGS BASED(ADDR(WPL)+WPLLGH);                 02S0651
*          WPLFLGS = WPLFLGS && WPLFLGS; /* ZERO OUT WPL FLAGS       */
         ALR   @03,@15                                          02S0652
         XC    WPLFLGS(8,@03),WPLFLGS(@03)                      02S0652
*          WPLDESCD = ON;              /* DESC CODE = SYS STATUS MSG */
         OI    WPLDESCD(@03),B'00010000'                        02S0653
*          WPLROUTB = ON;              /* ROUT CODE = MASTER CONSOLE */
         OI    WPLROUTB(@03),B'01000000'                        02S0654
*          GEN REFS(WTOL)              /* ISSUE MESSAGE TO OPERATOR  */
*             (WTO MF=(E,WTOL));                                02S0655
         WTO MF=(E,WTOL)
*          WTOSW = ON;                 /* WTO HAS BEEN ISSUED        */
         OI    WTOSW,B'10000000'                                02S0656
*        END;                                                   02S0657
*    END;                                                       02S0658
@RF00640 DS    0H                                               02S0659
*END;                                                           02S0659
@RF00631 AH    MSGCTR,@CH00070                                  02S0659
         CH    MSGCTR,@CH00137                                  02S0659
         BNH   @DL00630                                         02S0659
*IF RESNCODE(1) ^= ESTAERR THEN        /* ESTAE WAS ISSUED           */
         CLC   RESNCODE(2),@CH00089                             02S0660
         BE    @RF00660                                         02S0660
*  DO;                                                          02S0661
*     DO; /*MODESET  KEYADDR(ZERO)*/                            02S0662
*       SPKA (ZERO); /*SET PSW KEY*/                            02S0663
         SLR   @01,@01                                          02S0663
         SPKA  0(@01)                                           02S0663
*     END; /*MODESET  KEYADDR(ZERO)*/           /* KEY TO UPDATE JSCB @
*40FPPG*/                                                       02S0664
*    JSCBASWA = ZERO;                  /* RESET TO ZERO      @Z40FPPG*/
         L     @15,PARMPTR                                      02S0665
         L     @15,LCTPTR(,@15)                                 02S0665
         L     @15,LCTJSCB(,@15)                                02S0665
         ST    @01,JSCBASWA(,@15)                               02S0665
*     DO; /*MODESET  EXTKEY(SCHED)*/                            02S0666
*       SPKA (16); /*SET PSW KEY*/                              02S0667
         LA    @01,16                                           02S0667
         SPKA  0(@01)                                           02S0667
*     END; /*MODESET  EXTKEY(SCHED)*/           /* BACK TO SCHED KEY  @
*40FPPG*/                                                       02S0668
*    GEN REFS(ESTAEL)                  /* CANCEL ESTAE               */
*     (ESTAE 0,MF=(E,ESTAEL));                                  02S0669
         ESTAE 0,MF=(E,ESTAEL)
*  END;                                                         02S0670
*LCTSCTVA = SCTANSCT;                  /* SET SVA OF NEXT SCT        */
@RF00660 L     @15,PARMPTR                                      02S0671
         L     @14,LCTPTR(,@15)                                 02S0671
         L     @15,SCTPTR(,@15)                                 02S0671
         MVC   LCTSCTVA(3,@14),SCTANSCT(@15)                    02S0671
* DO; /*MODESET  KEYADDR(ZERO)*/                                02S0672
*   SPKA (ZERO); /*SET PSW KEY*/                                02S0673
         SLR   @01,@01                                          02S0673
         SPKA  0(@01)                                           02S0673
* END; /*MODESET  KEYADDR(ZERO)*/               /* KEY ZERO TO ALTER TC
*      */                                                       02S0674
*TCBCMP = TCBCMP && TCBCMP;            /* RESET TCB COMP. FIELD      */
         L     @01,LCTTCBAD(,@14)                               02S0675
         XC    TCBCMP(4,@01),TCBCMP(@01)                        02S0675
* DO; /*MODESET  EXTKEY(SCHED)*/                                02S0676
*   SPKA (16); /*SET PSW KEY*/                                  02S0677
         LA    @01,16                                           02S0677
         SPKA  0(@01)                                           02S0677
* END; /*MODESET  EXTKEY(SCHED)*/               /* BACK TO SCHED KEY
*      */                                                       02S0678
*RFY (REG1) RSTD;                                               02S0679
*REG1 = LCTJSCB;                       /* PARM FOR WTP PUT ROUTINE   */
         L     REG1,LCTJSCB(,@14)                               02S0680
*CALL IEEAB401;                        /* WTP PPUT ROUTINE           */
         L     @15,@CV00282                                     02S0681
         BALR  @14,@15                                          02S0681
*RFY (REG1) UNRSTD;                                             02S0682
*IF (JCTSTEPR = ON | JCTCKPTR = ON) & LCTJFAIL = OFF THEN /* STEP
*                                         WILL RESTART               */
         L     @15,PARMPTR                                      01S0683
         L     @01,JCTPTR(,@15)                                 01S0683
         TM    JCTSTEPR(@01),B'00001100'                        01S0683
         BZ    @RF00683                                         01S0683
         L     @01,LCTPTR(,@15)                                 01S0683
         TM    LCTJFAIL(@01),B'10000000'                        01S0683
         BNZ   @RF00683                                         01S0683
*  RETCODE = RESTART;                  /* RESTART RETURN CODE        */
         MVC   RETCODE(4),@CF00066                              01S0684
*ELSE                                                           01S0685
*  IF SCTANSCT = ZERO | LCTJFAIL = ON THEN /* END OF JOB HAS OCCURRED*/
         B     @RC00683                                         01S0685
@RF00683 L     @15,PARMPTR                                      01S0685
         L     @01,SCTPTR(,@15)                                 01S0685
         ICM   @00,7,SCTANSCT(@01)                              01S0685
         BZ    @RT00685                                         01S0685
         L     @01,LCTPTR(,@15)                                 01S0685
         TM    LCTJFAIL(@01),B'10000000'                        01S0685
         BNO   @RF00685                                         01S0685
@RT00685 DS    0H                                               01S0686
*    RETCODE = JOBEND;                 /* JOB END RETURN CODE        */
         MVC   RETCODE(4),@CF00089                              01S0686
*  ELSE                                /* NOT END OF JOB             */
*    RETCODE = ZERO;                   /* NORMAL RETURN CODE         */
         B     @RC00685                                         01S0687
@RF00685 SLR   @15,@15                                          01S0687
         ST    @15,RETCODE                                      01S0687
*RETURN CODE(RETCODE);                                          01S0688
@RC00685 DS    0H                                               01S0688
@RC00683 L     @03,RETCODE                                      01S0688
         IC    @02,@OLDKEY                                      01S0688
         L     @13,4(,@13)                                      01S0688
         L     @00,@SIZDATD                                     01S0688
         LR    @01,@10                                          01S0688
         FSPACE   R,LV=(0),A=(1)
         MODESET KEYADDR=(2)
         LR    @15,@03                                          01S0688
         L     @14,12(,@13)                                     01S0688
         LM    @00,@12,20(@13)                                  01S0688
         BR    @14                                              01S0688
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - ENDSMSG                                           */
*/*                                                                  */
*/* DESCRIPTIVE NAME - ISSUE END OF STEP MESSAGES                    */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*   THE FUNCTION OF THIS SEGMENT IS TO ISSUE END OF STEP STATUS    */
*/*   MESSAGES TO THE OPERATOR AND THE PROGRAMMER.                   */
*/*                                                                  */
*/*   OPERATION -                                                    */
*/*   1. COMPLETE THE MESSAGE -                                      */
*/*      THE JOB NAME, STEP NAME, AND PROC STEP NAME ARE PUT IN      */
*/*      THE MESSAGES. IN ADDITION IF THE MESSAGE IS TO BE SENT TO   */
*/*      THE OPERATOR AND TIME IS REQUESTED, THE TIME IS INSERTED    */
*/*      INTO THE MESSAGE.                                           */
*/*                                                                  */
*/*   2. ISSUE THE MESSAGE(S) -                                      */
*/*      THE MESSAGE IS ISSUED TO THE PROGRAMMER. IN ADDITION        */
*/*      A MESSAGE IS ISSUED TO THE OPERATOR IF REQUESTED.           */
*/*                                                                  */
*/* ENTRY - IN-LINE SEGMENT                                          */
*/*                                                                  */
*/*   INPUT -                                                        */
*/*                                                                  */
*/*     WPL - WTO PARAMETER LIST                                     */
*/*       WPLTXT - TEXT OF MESSAGE                                   */
*/*                                                                  */
*/*     WTOSW - ISSUE WTO IF ON                                      */
*/*                                                                  */
*/*     TIMESW - PUT TIME IN THE MESSAGE                             */
*/*                                                                  */
*/*     TIME - STRUCTURE CONTAINING:                                 */
*/*       HOURS - HOUR OF THE DAY                                    */
*/*       MINUTES - MINUTE OF THE HOUR                               */
*/*       SECONDS - SECOND OF THE MINUTE                             */
*/*                                                                  */
*/*     WMSGLNTH - LENGTH OF WTO MESSAGE TEXT                        */
*/*                                                                  */
*/*     LMSGLNTH - LENGTH OF PROGRAMMER MESSAGE TEXT                 */
*/*                                                                  */
*/*     JCT -                                                        */
*/*       JCTJNAME - JOB NAME                                        */
*/*                                                                  */
*/*     SCT -                                                        */
*/*       SCTSNAME - STEP NAME                                       */
*/*       SCTSCLPC - PROC STEP NAME                                  */
*/*                                                                  */
*/* EXIT -                                                           */
*/*   CONDITION - NORMAL                                             */
*/*                                                                  */
*/*   OUTPUT -                                                       */
*/*     MESSAGE(S) ISSUED                                            */
*/*     LCT                                                          */
*/*       LCTERRM - SET ON IF JOB ABENDED MSG ISSUED                 */
*/*                                                                  */
*/*     RETURN CODE - NONE                                           */
*/*                                                                  */
*/********************************************************************/
*ENDSMSG: PROC;                        /* MAKE ENDSMSG A PROCEDURE
*                                         SINCE IT IS CALLED TWICE
*                                         FROM ISSUMSGS SEG  @ZA08480*/
ENDSMSG  STM   @14,@12,@SA00002                                 02S0689
*IF WTOSW = ON THEN                    /* ISSUE A WTO                */
         TM    WTOSW,B'10000000'                                02S0690
         BNO   @RF00690                                         02S0690
*  DO;                                                          02S0691
*    WTOJNAME = JCTJNAME;              /* PUT JOB NAME IN MESSAGE    */
         LA    @03,WTOL                                         02S0692
         LA    @15,4                                            02S0692
         ALR   @15,@03                                          02S0692
         L     @14,PARMPTR                                      02S0692
         L     @01,JCTPTR(,@14)                                 02S0692
         MVC   WTOJNAME(8,@15),JCTJNAME(@01)                    02S0692
*    WTOSNAME = SCTSNAME;              /* PUT STEP NAME IN MESSAGE   */
         L     @14,SCTPTR(,@14)                                 02S0693
         MVC   WTOSNAME(8,@15),SCTSNAME(@14)                    02S0693
*    WTOPSNAM = SCTSCLPC;              /* PUT PROC STEP IN MESSAGE   */
         MVC   WTOPSNAM(8,@15),SCTSCLPC(@14)                    02S0694
*    TIMEPTR = ADDR(WPLTXT)+WTOTDISP;  /* SET TIME POINTER           */
*                                                               02S0695
         LA    TIMEPTR,WPLTXT(,@03)                             02S0695
         L     @03,@CA00332                                     02S0695
         AH    TIMEPTR,WTOTDISP-WTOABEND(,@03)                  02S0695
*    IF TIMESW = ON THEN               /* TIME REQUESTED             */
         TM    TIMESW,B'00001000'                               02S0696
         BNO   @RF00696                                         02S0696
*      DO;                             /* PUT TIME IN MESSAGE        */
*        WTOHH = HOURS;                /* HOURS IN MESSAGE           */
         MVC   WTOHH(2,TIMEPTR),HOURS                           02S0698
*        WTOMM = MINUTES;              /* MINUTES IN MESSAGE         */
         MVC   WTOMM(2,TIMEPTR),MINUTES                         02S0699
*        WTOSS = SECONDS;              /* SECONDS IN MESSAGE         */
         MVC   WTOSS(2,TIMEPTR),SECONDS                         02S0700
*      END;                                                     02S0701
*    ELSE                              /* TIME NOT WANTED            */
*      WTOTIME = '';                   /* BLANK OUT TIME             */
         B     @RC00696                                         02S0702
@RF00696 MVI   WTOTIME(TIMEPTR),C' '                            02S0702
         MVC   WTOTIME+1(14,TIMEPTR),WTOTIME(TIMEPTR)           02S0702
*    CALL IEFAB4F3(ADDR(WPLTXT),WMSGLNTH,CMSGLNTH); /*COMPRESS BLANKS*/
@RC00696 LA    @15,WTOL                                         02S0703
         LA    @15,WPLTXT(,@15)                                 02S0703
         ST    @15,@TF00001                                     02S0703
         LA    @15,@TF00001                                     02S0703
         ST    @15,@AL00001                                     02S0703
         LA    @15,WMSGLNTH                                     02S0703
         ST    @15,@AL00001+4                                   02S0703
         LA    @15,CMSGLNTH                                     02S0703
         ST    @15,@AL00001+8                                   02S0703
         L     @15,@CV00288                                     02S0703
         LA    @01,@AL00001                                     02S0703
         BALR  @14,@15                                          02S0703
*    WPLLGH = CMSGLNTH + LWTOBYTE;     /* SET LENGTH IN WTO PARM LIST*/
         LA    @15,WTOL                                         02S0704
         L     @14,CMSGLNTH                                     02S0704
         AL    @14,LWTOBYTE                                     02S0704
         STH   @14,WPLLGH(,@15)                                 02S0704
*    WPLMCSFA = ON;                    /* ROUT/DESC CODES PRESENT    */
*    WPLMCSFC = ON;                    /* COMMAND RESPONSE           */
         OI    WPLMCSFA(@15),B'10100000'                        02S0706
*    RFY WPLFLGS BASED(ADDR(WPL)+WPLLGH);                       02S0707
*    WPLFLGS = WPLFLGS && WPLFLGS;     /* CLEAR FLAGS                */
         ALR   @15,@14                                          02S0708
         XC    WPLFLGS(8,@15),WPLFLGS(@15)                      02S0708
*    WPLDESCF = ON;                    /* DESC CODE = JOB STATUS     */
         OI    WPLDESCF(@15),B'00000100'                        02S0709
*    WPLROUTB = ON;                    /* ROUT CODE = MSTR CNSL INFO */
         OI    WPLROUTB(@15),B'01000000'                        02S0710
*    GEN REFS(WTOL)                    /* WRITE TO THE OPERATOR      */
*       (WTO MF=(E,WTOL));                                      02S0711
         WTO MF=(E,WTOL)
*  END;                                                         02S0712
*IF CHCLD = ON THEN                    /* JOB CANCELLED              */
@RF00690 L     @01,PARMPTR                                      02S0713
         L     @15,LCTPTR(,@01)                                 02S0713
         L     @01,LCTQDRTY(,@15)                               02S0713
         TM    CHCLD(@01),B'00000100'                           02S0713
         BNO   @RF00713                                         02S0713
*  LCTERRM = ON;                       /* SET EOJ MSG ISSUED         */
         OI    LCTERRM(@15),B'00000001'                         02S0714
*MS1JNAME = JCTJNAME;                  /* JOB NAME IN MESSAGE        */
@RF00713 L     @15,PARMPTR                                      02S0715
         L     @01,JCTPTR(,@15)                                 02S0715
         MVC   MS1JNAME(8),JCTJNAME(@01)                        02S0715
*MS1SNAME = SCTSNAME;                  /* STEP NAME TO MESSAGE       */
         L     @15,SCTPTR(,@15)                                 02S0716
         MVC   MS1SNAME(8),SCTSNAME(@15)                        02S0716
*MS1PSNAM = SCTSCLPC;                  /* PROC NAME TO MESSAGE       */
         MVC   MS1PSNAM(8),SCTSCLPC(@15)                        02S0717
*CALL IEFAB4F3(ADDR(MSG),LMSGLNTH,CMSGLNTH); /* COMPRESS BLANKS      */
         LA    @15,MSG                                          02S0718
         ST    @15,@TF00001                                     02S0718
         LA    @15,@TF00001                                     02S0718
         ST    @15,@AL00001                                     02S0718
         LA    @15,LMSGLNTH                                     02S0718
         ST    @15,@AL00001+4                                   02S0718
         LA    @15,CMSGLNTH                                     02S0718
         ST    @15,@AL00001+8                                   02S0718
         L     @15,@CV00288                                     02S0718
         LA    @01,@AL00001                                     02S0718
         BALR  @14,@15                                          02S0718
*CALL IEFAB4FD                         /* SEND MESSAGE TO PGMR       */
*  (FUNC4FD,ADDR(MSG),CMSGLNTH,0,LCTJSCB);                      02S0719
         LA    @15,FUNC4FD                                      02S0719
         ST    @15,@AL00001                                     02S0719
         LA    @15,MSG                                          02S0719
         ST    @15,@TF00001                                     02S0719
         LA    @15,@TF00001                                     02S0719
         ST    @15,@AL00001+4                                   02S0719
         LA    @15,CMSGLNTH                                     02S0719
         ST    @15,@AL00001+8                                   02S0719
         LA    @15,@CF00276                                     02S0719
         ST    @15,@AL00001+12                                  02S0719
         L     @01,PARMPTR                                      02S0719
         L     @01,LCTPTR(,@01)                                 02S0719
         LA    @15,LCTJSCB(,@01)                                02S0719
         ST    @15,@AL00001+16                                  02S0719
         L     @15,@CV00286                                     02S0719
         LA    @01,@AL00001                                     02S0719
         BALR  @14,@15                                          02S0719
*END ENDSMSG;                          /* PROCEDURE END      @ZA08480*/
@EL00002 DS    0H                                               02S0720
@EF00002 DS    0H                                               02S0720
@ER00002 LM    @14,@12,@SA00002                                 02S0720
         BR    @14                                              02S0720
*END IEFBB410                                                   01S0721
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (B410SPEC)                                        *
*/*%INCLUDE SYSLIB  (B410DATA)                                        *
*/*%INCLUDE SYSLIB  (IEFZB505)                                        *
*/*%INCLUDE SYSLIB  (CVT     )                                        *
*/*%INCLUDE SYSLIB  (IEEBASEA)                                        *
*/*%INCLUDE SYSLIB  (IEECHAIN)                                        *
*/*%INCLUDE SYSLIB  (IEFAJCTB)                                        *
*/*%INCLUDE SYSLIB  (IEFALLCT)                                        *
*/*%INCLUDE SYSLIB  (IEFASCTB)                                        *
*/*%INCLUDE SYSLIB  (IEFASIOT)                                        *
*/*%INCLUDE SYSLIB  (IEFZB424)                                        *
*/*%INCLUDE SYSLIB  (IEFZB440)                                        *
*/*%INCLUDE SYSLIB  (IEFZB436)                                        *
*/*%INCLUDE SYSLIB  (IEFZB443)                                        *
*/*%INCLUDE SYSLIB  (IEZWPL  )                                        *
*/*%INCLUDE SYSLIB  (IEZJSCB )                                        *
*/*%INCLUDE SYSLIB  (IHADSAB )                                        *
*/*%INCLUDE SYSLIB  (IHAQDB  )                                        *
*/*%INCLUDE SYSLIB  (IEFZB4D5)                                        *
*/*%INCLUDE SYSLIB  (IEFZB453)                                        *
*/*%INCLUDE SYSLIB  (IKJTCB  )                                        *
*/*%INCLUDE SYSLIB  (IHAASCB )                                        *
*/*%INCLUDE SYSLIB  (B410INIT)                                        *
*/*%INCLUDE SYSLIB  (INTUSPEC)                                        *
*/*%INCLUDE SYSLIB  (ESTAECOD)                                        *
*/*%INCLUDE SYSLIB  (ESTAESPC)                                        *
*/*%INCLUDE SYSLIB  (ISSUMSGS)                                        *
*/*%INCLUDE SYSLIB  (ISSUSPEC)                                        *
*/*%INCLUDE SYSLIB  (SETCODES)                                        *
*/*%INCLUDE SYSLIB  (SETCSPEC)                                        *
*/*%INCLUDE SYSLIB  (CALLUNAL)                                        *
*/*%INCLUDE SYSLIB  (CALUSPEC)                                        *
*/*%INCLUDE SYSLIB  (ENDOSTEP)                                        *
*/*%INCLUDE SYSLIB  (ENDSSPEC)                                        *
*/*%INCLUDE SYSLIB  (TERMCALL)                                        *
*/*%INCLUDE SYSLIB  (TERMSPEC)                                        *
*/*%INCLUDE SYSLIB  (ENDOFJOB)                                        *
*/*%INCLUDE SYSLIB  (JENDSPEC)                                        *
*/*%INCLUDE SYSLIB  (ENDJMSG )                                        *
*/*%INCLUDE SYSLIB  (ENDJMSPC)                                        *
*/*%INCLUDE SYSLIB  (SETTIME )                                        *
*/*%INCLUDE SYSLIB  (SETTSPEC)                                        *
*/*%INCLUDE SYSLIB  (B410CLNP)                                        *
*/*%INCLUDE SYSLIB  (CLNUSPEC)                                        *
*/*%INCLUDE SYSLIB  (ENDSMSG )                                        *
*/*%INCLUDE SYSLIB  (ENDMSPEC)                                        *
*;                                                              01S0721
@DATA    DS    0H
@CH00070 DC    H'1'
@CH00115 DC    H'3'
@CH00137 DC    H'6'
@CH02964 DC    H'48'
@CH00185 DC    H'240'
@SM02994 MVC   ESTAEL(0),ESTAEP
@SM03000 MVC   WPLTXT(0,@15),WTOABNDM-WTOABEND(@14)
@SM03002 MVC   MSG(0),PGMABNDM-PGMABEND(@15)
@SM03004 MVC   MSG(0),STEPRUNM-STEPRUN(@15)
@SM03006 MVC   MSG(0),STNOTRNM-STNOTRUN(@15)
@SM03008 MVC   MSG(0),STNOATOM-STNOAUTO(@15)
@SM03014 MVC   DEQLIST(0),DEQFMT
@SM03016 MVC   WPLTXT(0,@09),ENDEDM-JOBENDED(@15)
@SM03018 MVC   WPLTXT(0,@09),LOGOFFM-LOGGDOFF(@15)
@SM03020 MVC   WPLTXT(0,@09),CCFAILM-CCFAIL(@15)
@SM03022 MVC   MSG(0),PGMCTEXT-PGMCFAIL(@15)
@SM03024 MVC   WPLTXT(0,@09),JOBFAILM-JOBFAILD(@15)
@SM03028 MVC   MSG(0),STEPMSG(@08)
@SM03030 MVC   WPLTXT(0,@03),UNERMSGT-UNERRMSG(@15)
         DS    0F
@AL00616 DC    A(@CF00276)             LIST WITH   5 ARGUMENT(S)
         DC    A(@CF00276)
         DC    A(@CF00276)
         DC    A(@CF00276)
         DC    A(@CF00276)
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    1F
@SA00002 DS    15F
@AL00001 DS    9A
@TF00001 DS    F
IEFBB410 CSECT
         DS    0F
@CF00276 DC    F'0'
@CF00089 DC    F'4'
@CH00089 EQU   @CF00089+2
@CF00066 DC    F'8'
@CF00034 DC    F'12'
@CF00054 DC    F'16'
@CH00054 EQU   @CF00054+2
@CF03027 DC    F'-4'
@CF00271 DC    XL4'E6000000'
@CF00248 DC    XL4'0FFF'
@DATD    DSECT
         DS    0D
PARMPTR  DS    A
CSCBPTR  DS    A
ESTAPTR  DS    A
FEPBLKP  DS    A
QDBPTR   DS    A
SWEPAPTR DS    A
TIORBPTR DS    A
WPLPTR   DS    A
CMSGLNTH DS    F
LMSGLNTH DS    F
UNCATRTN DS    F
RETCODE  DS    F
WMSGLNTH DS    F
CATDSNSZ DS    F
CATALDSN DS    A
GTSTRTCD DS    F
SWACTLS  DS    FL2
         ORG   SWACTLS
SWASN    DS    BL1
SWDEL    EQU   SWACTLS+0
SWREAD   EQU   SWACTLS+0
SWWRT    EQU   SWACTLS+0
SWNEW    EQU   SWACTLS+0
SWFREE   EQU   SWACTLS+0
SWMOD    EQU   SWACTLS+0
SWOLD    EQU   SWACTLS+0
SWCHN    DS    BL1
@NM00204 EQU   SWACTLS+1
         ORG   SWACTLS+2
UCCNTRLS DS    FL2
         ORG   UCCNTRLS
UCCAJSCB DS    BL1
UCNTIONQ EQU   UCCNTRLS+0
UCONECAT EQU   UCCNTRLS+0
UCALLCAT EQU   UCCNTRLS+0
UCONEACB EQU   UCCNTRLS+0
UCALLACB EQU   UCCNTRLS+0
UCONPCCB EQU   UCCNTRLS+0
UCALPCCB EQU   UCCNTRLS+0
UCTEMP   DS    BL1
UCSWTIOT EQU   UCCNTRLS+1
@NM00205 EQU   UCCNTRLS+1
         ORG   UCCNTRLS+2
FUNC4FD  DS    BL1
         ORG   FUNC4FD
@NM00001 DS    BL1
WTPONLY  EQU   FUNC4FD+0
         ORG   FUNC4FD+1
         DS    CL3
SWARDRET DS    CL12
         ORG   SWARDRET
FSIOTP   DS    AL4
FEPAPTR  DS    AL4
LEPAPTR  DS    AL4
         ORG   SWARDRET+12
ASWACORE DS    CL40
A4FEFMAP DS    BL1
         ORG   A4FEFMAP
SCANSCT  DS    BL1
SCANDSAB EQU   A4FEFMAP+0
@NM00003 EQU   A4FEFMAP+0
EPASGOTN EQU   A4FEFMAP+0
@NM00004 EQU   A4FEFMAP+0
         ORG   A4FEFMAP+1
BCDCCODE DS    CL5
COMPCODE DS    CL4
DECCODE  DS    CL8
DECTIME  DS    CL4
DECUSRCD DS    CL8
JOBFNMAP DS    BL1
         ORG   JOBFNMAP
JOBCNDSP DS    BL1
JOBMSGS  EQU   JOBFNMAP+0
JOBDSPRC EQU   JOBFNMAP+0
JOBMSTAT EQU   JOBFNMAP+0
         ORG   JOBFNMAP+1
MSG      DS    CL120
         ORG   MSG
@NM00005 DS    CL8
MS1JNAME DS    CL8
@NM00006 DS    CL1
MS1SNAME DS    CL8
@NM00007 DS    CL1
MS1PSNAM DS    CL8
         ORG   MSG+120
MSGINFO  DS    CL24
         ORG   MSGINFO
MSGJNAME DS    CL8
MSGSNAME DS    CL8
MSGPSNAM DS    CL8
         ORG   MSGINFO+24
STUFMAP  DS    CL3
         ORG   STUFMAP
STFMBYT1 DS    BL1
         ORG   STFMBYT1
STDISPRC DS    BL1
STALCMSG EQU   STFMBYT1+0
STDSPMSG EQU   STFMBYT1+0
STUNUNIT EQU   STFMBYT1+0
STMNSTAT EQU   STFMBYT1+0
STUPJFCB EQU   STFMBYT1+0
STFRDSAB EQU   STFMBYT1+0
STJES3   EQU   STFMBYT1+0
         ORG   STUFMAP+1
STFMBYT2 DS    BL1
         ORG   STFMBYT2
STNMDISP DS    BL1
STKEEP   EQU   STFMBYT2+0
STCNDISP EQU   STFMBYT2+0
STKPDEL  EQU   STFMBYT2+0
STINVUCB EQU   STFMBYT2+0
STPASS   EQU   STFMBYT2+0
STPURGE  EQU   STFMBYT2+0
STCHKPAS EQU   STFMBYT2+0
         ORG   STUFMAP+2
STFMBYT3 DS    BL1
         ORG   STFMBYT3
STNOVUT  DS    BL1
STPUBPRV EQU   STFMBYT3+0
STSPSCR  EQU   STFMBYT3+0
STNOSSDS EQU   STFMBYT3+0
STALSTCT EQU   STFMBYT3+0
STPPCATS EQU   STFMBYT3+0
@NM00008 EQU   STFMBYT3+0
         ORG   STUFMAP+3
SWITCHES DS    BL1
         ORG   SWITCHES
WTOSW    DS    BL1
MSGSW    EQU   SWITCHES+0
JOBNSW   EQU   SWITCHES+0
CONDFAIL EQU   SWITCHES+0
TIMESW   EQU   SWITCHES+0
         ORG   SWITCHES+1
SYSABCDE DS    CL3
TIME     DS    CL7
         ORG   TIME
HOURS    DS    CL2
MINUTES  DS    CL2
SECONDS  DS    CL2
         ORG   TIME+7
USRABCDE DS    CL4
         DS    CL3
TMCORE   DS    CL38
ESTPARMS DS    CL272
         DS    CL2
WTOL     DS    CL138
         ORG   WTOL
@NM00207 DS    CL130
@NM00208 DS    CL8
         ORG   WTOL+138
AB4EDPMS DS    CL500
TERMAREA DS    CL16
RESNCODE DS    6H
@OLDKEY  DS    AL1
IEFBB410 CSECT
         DS    0F
@SIZDATD DC    AL1(230)
         DC    AL3(@ENDDATD-@DATD)
@CA00142 DC    A(B410MSGT)
@CV00282 DC    V(IEEAB401)
@CV00283 DC    V(IEFAB4DD)
@CV00284 DC    V(IEFAB4ED)
@CV00285 DC    V(IEFAB4FC)
@CV00286 DC    V(IEFAB4FD)
@CV00287 DC    V(IEFAB4FE)
@CV00288 DC    V(IEFAB4F3)
@CV00289 DC    V(IEFAB4F4)
@CV00290 DC    V(IEFAB4F7)
@CV00291 DC    V(IEFTB721)
@CV00292 DC    V(IEFBB412)
@CV00293 DC    V(IEFBB414)
@CV00294 DC    V(IEFBB416)
@CV00295 DC    V(IEFRPREP)
@CA00296 DC    A(B410MOFT)
@CA00298 DC    A(CCFAIL)
@CA00302 DC    A(JOBENDED)
@CA00306 DC    A(JOBFAILD)
@CA00310 DC    A(LOGGDOFF)
@CA00314 DC    A(PGMABEND)
@CA00317 DC    A(PGMCFAIL)
@CA00320 DC    A(STEPRUN)
@CA00323 DC    A(STNOTRUN)
@CA00326 DC    A(STNOAUTO)
@CA00329 DC    A(UNERRMSG)
@CA00332 DC    A(WTOABEND)
@CV00281 DC    V(IEEAB400)
         DS    0D
LWTOBYTE DC    AL4(2+2)
GTSTZERO DC    F'0'
@CC00272 DC    C'0123456789ABCDEF'
@CC00245 DC    C'IEFAB4DD'
@CC00237 DC    C'ASWA'
@CC00239 DC    C'0000'
@CC00250 DC    C'0C0'
@CC00233 DC    C'0D'
@CB00278 DC    X'0F'
VOLUMES  DC    CL8'SYSZVOLS'
DATASETS DC    CL8'SYSDSN  '
OPENJ    DC    CL8'SYSZOPEN'
IEFBB410 CSECT
DEQFMT DEQ (VOLUMES,,,SYSTEM),MF=L,RET=HAVE,GENERIC=YES
DEQENTLN DC A(*-DEQFMT)
ESTAEP  ESTAE TERM=YES,RECORD=YES,MF=L
ESTAELTH DC   A(*-ESTAEP)
@DATD    DSECT
DEQLIST DEQ (VOLUMES,,,SYSTEM),MF=L,RET=HAVE,GENERIC=YES
ESTAEL ESTAE TERM=YES,RECORD=YES,MF=L
IEFBB410 CSECT
         DS   0H
B410PTCH DC ((@DATA-@PSTART)/20)X'00'
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEFBB410 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
INDEX    EQU   @04
INDEX1   EQU   @03
USERCODE EQU   @02
SIZEEPAB EQU   @03
MSGCTR   EQU   @02
TIMEPTR  EQU   @02
SAVNEXTP EQU   @03
SIOTPTR  EQU   @02
EPBLKPTR EQU   @02
DSABPTR  EQU   @02
ASCBPTR  EQU   @02
ASWAPTR  EQU   @04
EXITADDR EQU   @02
PARMADDR EQU   @03
REG0     EQU   @00
REG1     EQU   @01
REG4     EQU   @04
REG5     EQU   @05
REG6     EQU   @06
REG7     EQU   @07
REG15    EQU   @15
GTSTR0   EQU   @00
GTSTR1   EQU   @01
GTSTR2   EQU   @02
GTSTR15  EQU   @15
GTSTR4   EQU   @04
GTSTR5   EQU   @05
GTSTR6   EQU   @06
GTSTR7   EQU   @07
GTSTR8   EQU   @08
GTSTR3   EQU   @03
         EXTRN B410MSGT
         EXTRN B410MOFT
         EXTRN CCFAIL
         EXTRN JOBENDED
         EXTRN JOBFAILD
         EXTRN LOGGDOFF
         EXTRN PGMABEND
         EXTRN PGMCFAIL
         EXTRN STEPRUN
         EXTRN STNOTRUN
         EXTRN STNOAUTO
         EXTRN UNERRMSG
         EXTRN WTOABEND
CVTPTR   EQU   16
PARMS    EQU   0
LCTPTR   EQU   PARMS
JCTPTR   EQU   PARMS+4
SCTPTR   EQU   PARMS+8
TIOTLP   EQU   PARMS+12
TIOTLIST EQU   0
TIOTPTR  EQU   TIOTLIST
TCBPTRS  EQU   0
TCBPTR   EQU   TCBPTRS+4
ASWA     EQU   0
ASWAID   EQU   ASWA
ASWACSCT EQU   ASWA+4
ASWARTNP EQU   ASWA+12
ASWAPRMS EQU   ASWA+16
ASWASCBP EQU   ASWA+20
ASWAOLDP EQU   ASWA+24
ASWAFLGS EQU   ASWA+28
ASWADSWS EQU   ASWAFLGS
ASWAAUTO EQU   ASWA+32
MSGCCODE EQU   0
MSGLNTH  EQU   0
MSGSYSCD EQU   0
MSGUSRCD EQU   0
STEPMSG  EQU   0
TRTABLE  EQU   0
WTOJCOND EQU   0
WTONAMES EQU   0
WTOJNAME EQU   WTONAMES+8
WTOSNAME EQU   WTONAMES+17
WTOPSNAM EQU   WTONAMES+26
WTOSYSCD EQU   0
WTOTIME  EQU   0
WTOHH    EQU   WTOTIME+7
WTOMM    EQU   WTOTIME+10
WTOSS    EQU   WTOTIME+13
WTOUSRCD EQU   0
CATDSNT  EQU   0
CATHDR   EQU   CATDSNT
CATNUM   EQU   CATHDR
CATDSNP  EQU   CATDSNT+4
SWAEPA   EQU   0
SWVAFW   EQU   SWAEPA+4
EPABLK   EQU   0
EPABHDR  EQU   EPABLK
EPABSIZE EQU   EPABHDR
EPABCNT  EQU   EPABHDR+4
EPABNXTP EQU   EPABHDR+8
CVTMAP   EQU   0
CVTTCBP  EQU   CVTMAP
CVTILK2  EQU   CVTMAP+40
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTMSER  EQU   CVTMAP+148
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
BASE     EQU   0
@NM00018 EQU   BASE+13
BALGSTAT EQU   BASE+24
BALOG    EQU   BALGSTAT+4
BASFL    EQU   BASE+36
BARSW    EQU   BASFL
MSLOGST  EQU   BASE+46
BASPBYTE EQU   BASE+47
BAMONITR EQU   BASE+56
BAJNCNT  EQU   BASE+84
BASESCT  EQU   BASE+86
BASTCNT  EQU   BASE+88
@NM00040 EQU   BASE+104
MSLGCLOZ EQU   BASE+108
MSCLOSSW EQU   MSLGCLOZ
MSLGWLOG EQU   BASE+112
MSWLOGSW EQU   MSLGWLOG
MSLGWTR  EQU   BASE+116
MSWTRSW  EQU   MSLGWTR
MSLGSTRT EQU   BASE+120
MSSTRTSW EQU   MSLGSTRT
MS1BASEX EQU   BASE+136
BASES01  EQU   0
MSNTAL   EQU   BASES01
MSSSB    EQU   BASES01+1
MSBTN    EQU   MSSSB
MSTN     EQU   MSBTN
MSPFG    EQU   BASES01+2
MSECBFL  EQU   BASES01+3
MSTUS    EQU   BASES01+4
MSSSA    EQU   MSTUS
MSINLSW  EQU   MSSSA
MSREOF   EQU   MSSSA
MSNWP    EQU   MSSSA
MSFHF    EQU   BASES01+5
CHAIN    EQU   0
CHFLG    EQU   CHAIN+4
CHSTS    EQU   CHFLG+2
CHACT    EQU   CHFLG+3
CHCLD    EQU   CHACT
CHKEY    EQU   CHAIN+8
CHPARM   EQU   CHKEY
CHPKE    EQU   CHAIN+28
CHTRKID  EQU   CHPKE
CHTJID   EQU   CHAIN+30
CHPROCSN EQU   CHAIN+32
CHACT1   EQU   CHPROCSN+3
CHASM    EQU   CHAIN+40
CHCIBP   EQU   CHASM+4
CHRGNSZ  EQU   CHASM+8
CHSTEP   EQU   CHASM+24
CHSWT    EQU   CHSTEP
CHSHORT  EQU   CHASM+32
INJMJCT  EQU   0
JCTJSTAT EQU   INJMJCT+5
JCTABEND EQU   JCTJSTAT
INDMCTLG EQU   JCTJSTAT
JCTJBYTE EQU   INJMJCT+7
JCTJMGLV EQU   JCTJBYTE
INCMALL  EQU   JCTJMGLV
JCTJNAME EQU   INJMJCT+8
JCTCCODE EQU   INJMJCT+54
JCTRSW1  EQU   INJMJCT+86
JCTWARMS EQU   JCTRSW1
JCTCONTR EQU   JCTRSW1
JCTCKFT  EQU   JCTRSW1
JCTCKPTR EQU   JCTRSW1
JCTSTEPR EQU   JCTRSW1
JCTRSW2  EQU   INJMJCT+87
JCTDETDA EQU   INJMJCT+88
JCTJSB   EQU   INJMJCT+111
JCTJSBAL EQU   JCTJSB
JCTSTAT2 EQU   INJMJCT+116
JCTSWSM  EQU   JCTSTAT2
JCTVULDP EQU   INJMJCT+172
IEFAACTB EQU   0
LCT      EQU   0
LCTQDRTY EQU   LCT
LCTSRTAD EQU   LCT+4
LCTTCBAD EQU   LCT+8
LCTQENTY EQU   LCT+12
@NM00085 EQU   LCTQENTY
LCTERRM  EQU   @NM00085
LCTJCTAD EQU   LCT+16
LCTSCTAD EQU   LCT+20
LCTSCTDA EQU   LCT+24
LCTWORKA EQU   LCTSCTDA
LCTSCTVA EQU   LCTWORKA
LCTPSPAR EQU   LCT+28
LCTERROR EQU   LCT+32
LCTERR   EQU   LCTERROR
LCTJFAIL EQU   LCTERR
LCTSALCD EQU   LCTERR
LCTPALCD EQU   LCTERR
LCTSFAIL EQU   LCTERR
LCTJCFAL EQU   LCTERR
LCTVTERM EQU   LCTERR
LCTPARM1 EQU   LCT+36
LCTCMCBA EQU   LCT+52
LCTNSPAD EQU   LCT+56
LCTJFCBH EQU   LCT+57
LCTSMBAD EQU   LCT+60
LCTCOMCD EQU   LCT+68
LCTRTRN  EQU   LCT+72
LCTSREG  EQU   LCTRTRN
@NM00112 EQU   LCT+76
LCTINTSW EQU   @NM00112
LCTPUBYT EQU   @NM00112+1
LCTTMWRK EQU   LCT+80
LCTTJTU4 EQU   LCTTMWRK
LCTTSTL4 EQU   LCTTMWRK+4
LCTTSTR4 EQU   LCTTMWRK+8
LCTSMF   EQU   LCTTSTR4
LCTTMBYT EQU   LCTSMF
LCTTSTU4 EQU   LCTTMWRK+12
LCTJOBLB EQU   LCT+96
LCTATLST EQU   LCT+100
LCTASCBA EQU   LCT+320
LCTECBAD EQU   LCT+328
ECBLIST  EQU   LCTECBAD
LCTIDENT EQU   LCT+332
LCTSPIL  EQU   LCTIDENT+4
LCTALCFG EQU   LCTSPIL+2
LCTTSRB4 EQU   LCT+348
LCTENTR  EQU   LCT+352
LCTEXIT  EQU   LCTENTR
LCTOPSW1 EQU   LCTEXIT
@NM00142 EQU   LCT+356
LCTOPSW2 EQU   @NM00142
LCTJSCB  EQU   LCT+360
LCTOPSW3 EQU   LCTJSCB
LCTJCTDA EQU   LCT+408
LCTSTATA EQU   LCT+416
LCTSTATB EQU   LCT+417
LCTRFB   EQU   LCT+418
@NM00155 EQU   LCT+420
LCTINTS2 EQU   @NM00155+1
INSMSCT  EQU   0
SCTDISKA EQU   INSMSCT
SCTSSTAT EQU   INSMSCT+4
SCTLALOC EQU   INSMSCT+10
SCTANSCT EQU   INSMSCT+20
SCTLSIOT EQU   INSMSCT+24
SCTSCLPC EQU   INSMSCT+44
SCTSNAME EQU   INSMSCT+52
SCTSNUMB EQU   INSMSCT+64
SCTSTYPE EQU   INSMSCT+67
SCTPCAT  EQU   INSMSCT+84
SCTSDPTY EQU   INSMSCT+94
SCTSTAT2 EQU   INSMSCT+104
SCTBCT   EQU   SCTSTAT2
SCTCDENT EQU   INSMSCT+118
SCTCATCT EQU   INSMSCT+166
SCTSTEND EQU   INSMSCT+172
SCTSTPND EQU   SCTSTEND
@NM00179 EQU   0
SCTABCND EQU   @NM00179
SCTABEND EQU   SCTABCND
INDMSIOT EQU   0
SIOTDSKA EQU   INDMSIOT
SCTUSADD EQU   INDMSIOT+20
SIOTBYT1 EQU   INDMSIOT+43
SIOTBYT3 EQU   INDMSIOT+46
SIOTTSTC EQU   INDMSIOT+47
SIOTBYT0 EQU   INDMSIOT+52
SCTSDISP EQU   INDMSIOT+55
SCTSBYT1 EQU   INDMSIOT+56
SIOTJSCT EQU   SCTSBYT1
SCTSBYT2 EQU   INDMSIOT+57
SCTSBYT3 EQU   INDMSIOT+58
SCTSBYT4 EQU   INDMSIOT+59
SCTUTYPE EQU   INDMSIOT+60
SIOTDEVT EQU   SCTUTYPE
SIOUBYT3 EQU   SIOTDEVT+2
SIOTBYT4 EQU   INDMSIOT+81
SIOTALTD EQU   INDMSIOT+92
SIOTBYT2 EQU   INDMSIOT+103
SIOTNPTR EQU   INDMSIOT+152
SJFCBPTR EQU   INDMSIOT+156
TIOMGRRB EQU   0
TIOMFMAP EQU   TIOMGRRB
TIOMFREE EQU   TIOMFMAP
TIOMTSZE EQU   TIOMGRRB+2
TIOMJSCP EQU   TIOMGRRB+4
ESTAPARM EQU   0
ESTUSERP EQU   ESTAPARM+248
ESTAFLGS EQU   ESTUSERP
ESTASTEP EQU   ESTAFLGS
ESTAJOB  EQU   ESTAFLGS
ESTALCTP EQU   ESTUSERP+4
ESTAJCTP EQU   ESTUSERP+8
ESTASCTP EQU   ESTUSERP+12
ESTSIOTP EQU   ESTUSERP+16
ESTLEPAP EQU   ESTUSERP+20
WPLRF    EQU   0
WPLRPTR  EQU   WPLRF
WPL      EQU   0
WPLLGH   EQU   WPL
WPLMCSF  EQU   WPL+2
WPLMCSF1 EQU   WPLMCSF
WPLMCSFA EQU   WPLMCSF1
WPLMCSFC EQU   WPLMCSF1
WPLMCSFD EQU   WPLMCSF1
WPLMCSF2 EQU   WPLMCSF+1
WPLTXT   EQU   WPL+4
WPLFLGS  EQU   0
WPLDESC  EQU   WPLFLGS
WPLDESC1 EQU   WPLDESC
WPLDESCD EQU   WPLDESC1
WPLDESCF EQU   WPLDESC1
WPLDESC2 EQU   WPLDESC+1
WPLROUT  EQU   WPLFLGS+2
WPLROUT1 EQU   WPLROUT
WPLROUTB EQU   WPLROUT1
WPLROUT2 EQU   WPLROUT+1
WPLMSGTY EQU   WPLFLGS+4
WPLMSGT1 EQU   WPLMSGTY
WPLMSGTA EQU   WPLMSGT1
WPLMSGTF EQU   WPLMSGT1
WPLMSGT2 EQU   WPLMSGTY+1
WPLLS01  EQU   0
WPLLTF   EQU   WPLLS01
WPLLTF1  EQU   WPLLTF
WPLML    EQU   0
WPLMLLTF EQU   WPLML+2
WPLMLLT1 EQU   WPLMLLTF
IEZJSCB  EQU   0
JSCBSEC1 EQU   IEZJSCB+188
JSCHPCE  EQU   JSCBSEC1+4
JSCBDCB  EQU   JSCBSEC1+36
JSCBOPTS EQU   JSCBSEC1+48
JSCSIOTS EQU   JSCBOPTS
JSCBSWT1 EQU   JSCBSEC1+55
JSCBWTP  EQU   JSCBSEC1+64
JSCBWTFG EQU   JSCBWTP
JSCBEND1 EQU   IEZJSCB+260
DSAB     EQU   0
DSABSSVA EQU   DSAB+21
DSABGIDP EQU   DSAB+24
DSABANMP EQU   DSAB+28
DSABORG  EQU   DSAB+32
DSABORG1 EQU   DSABORG
DSABORG2 EQU   DSABORG+1
DSABFLG1 EQU   DSAB+34
DSABFLG2 EQU   DSAB+35
DSABFLG3 EQU   DSAB+36
DSABFLG4 EQU   DSAB+37
DSABANMI EQU   0
DSABGIDL EQU   0
QDB      EQU   0
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBCMPC  EQU   TCBCMP+1
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFA    EQU   TCBFLGS1
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBJPQ   EQU   TCB+44
TCBPURGE EQU   TCBJPQ
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTME   EQU   TCB+120
TCBJSTCB EQU   TCB+124
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBSTABB EQU   TCBSTAB+1
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBXSCT  EQU   TCB+240
TCBXSCT1 EQU   TCBXSCT
TCBFOE   EQU   TCB+244
TCBESTAE EQU   TCB+264
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCB+276
TCBFBYT2 EQU   TCB+277
TCBRV124 EQU   TCB+278
TCBRV133 EQU   TCB+279
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
ASCB     EQU   0
ASCBSUPC EQU   ASCB+16
ASCBASID EQU   ASCB+36
ASCBRSM  EQU   ASCB+52
ASCBRSMF EQU   ASCBRSM
ASCBFW1  EQU   ASCB+100
ASCBRCTF EQU   ASCBFW1+2
ASCBFLG1 EQU   ASCBFW1+3
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
ASCBLKGP EQU   ASCB+128
ASCBSRQ  EQU   ASCB+180
ASCBSRQ1 EQU   ASCBSRQ
ASCBSRQ2 EQU   ASCBSRQ+1
ASCBSRQ3 EQU   ASCBSRQ+2
ASCBSRQ4 EQU   ASCBSRQ+3
TRMRB    EQU   0
TRMRBLEN EQU   TRMRB
TRMRBOPC EQU   TRMRB+4
TRMFLAGS EQU   TRMRB+5
TRMJOBID EQU   TRMRB+8
INDMDSNT EQU   0
MOTENTRY EQU   B410MOFT
MOTOFFST EQU   MOTENTRY
MOTLNTH  EQU   MOTENTRY+2
CCFAILLN EQU   CCFAIL
CCFLTDSP EQU   CCFAIL+2
CCFLCDSP EQU   CCFAIL+4
CCFAILM  EQU   CCFAIL+6
ENDEDLN  EQU   JOBENDED
ENDTDISP EQU   JOBENDED+2
ENDEDM   EQU   JOBENDED+4
JOBFAILL EQU   JOBFAILD
JOBFTDSP EQU   JOBFAILD+2
JOBFAILM EQU   JOBFAILD+4
LOGOFFLN EQU   LOGGDOFF
LOGTDISP EQU   LOGGDOFF+2
LOGOFFM  EQU   LOGGDOFF+4
PGMABNDL EQU   PGMABEND
PGMSDISP EQU   PGMABEND+2
PGMUDISP EQU   PGMABEND+4
PGMABNDM EQU   PGMABEND+6
PGMCLNTH EQU   PGMCFAIL
PGMCTEXT EQU   PGMCFAIL+2
STEPRUNL EQU   STEPRUN
STPCDISP EQU   STEPRUN+2
STEPRUNM EQU   STEPRUN+4
STNOTRNL EQU   STNOTRUN
STNOTRNM EQU   STNOTRUN+2
STNOATOL EQU   STNOAUTO
STNOATOM EQU   STNOAUTO+2
UNERMSGL EQU   UNERRMSG
UNERMSGT EQU   UNERRMSG+2
WTOABNDL EQU   WTOABEND
WTOSDISP EQU   WTOABEND+2
WTOUDISP EQU   WTOABEND+4
WTOTDISP EQU   WTOABEND+6
WTOABNDM EQU   WTOABEND+8
DPARMP   EQU   0
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
CHAINS01 EQU   CHASM
CHTYPE   EQU   CHAINS01+124
CHTRSTAT EQU   CHAINS01+125
CHCSYSO  EQU   CHAINS01+134
JSCBSEC2 EQU   JSCBEND1
JSCBSEC3 EQU   JSCBEND1
JSCBJCT  EQU   JSCBSEC3
JSCBJCTA EQU   JSCBJCT+1
JSCBASID EQU   JSCBSEC3+8
JSCBFBYT EQU   JSCBSEC3+10
JSCBJNL  EQU   JSCBSEC3+28
JSCBJJSB EQU   JSCBJNL
JSCBSUB  EQU   JSCBSEC3+40
JSCDSABQ EQU   JSCBSEC3+60
JSCSCT   EQU   JSCBSEC3+68
JSCSCTP  EQU   JSCSCT+1
JSCBASWA EQU   JSCBSEC3+96
JSCRSV45 EQU   JSCBSEC3+112
JSCRSV46 EQU   JSCRSV45
JSCRSV47 EQU   JSCRSV45+2
DSABQDB  EQU   QDB
DSQFRSTP EQU   DSABQDB+12
DSQLASTP EQU   DSABQDB+16
TCBCMPCH EQU   TCBCMPC
TCBCMPFW EQU   TCBCMP
TIOMELEN EQU   TIOMTSZE
TIOMNDSA EQU   TIOMTSZE
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00218 EQU   DSABQDB+24
DSQBDSP  EQU   DSABQDB+22
DSQFDSP  EQU   DSABQDB+20
DSQBADFC EQU   DSQLASTP
DSQBADBC EQU   DSQFRSTP
DSQNELMS EQU   DSABQDB+8
DSQDBLN  EQU   DSABQDB+6
DSQATTRS EQU   DSABQDB+4
DSQDBID  EQU   DSABQDB
JSCBEND3 EQU   JSCBSEC3+120
JSCRSV52 EQU   JSCBSEC3+116
JSCRSV51 EQU   JSCRSV47+1
JSCRSV50 EQU   JSCRSV47
JSCRSV49 EQU   JSCRSV46+1
JSCRSV48 EQU   JSCRSV46
JSCRSV44 EQU   JSCBSEC3+108
JSCRSV43 EQU   JSCBSEC3+104
JSCRSV42 EQU   JSCBSEC3+100
JSCBUFPT EQU   JSCBSEC3+92
JSCBACT  EQU   JSCBSEC3+88
JSCBSWSP EQU   JSCBSEC3+87
JSCRSV33 EQU   JSCBSEC3+86
JSCDDNUM EQU   JSCBSEC3+84
JSCRSV53 EQU   JSCBSEC3+82
JSCDDNNO EQU   JSCBSEC3+80
JSCBVATA EQU   JSCBSEC3+76
JSCTMCOR EQU   JSCBSEC3+72
JSCRSV55 EQU   JSCSCT
JSCRSV54 EQU   JSCBSEC3+64
JSCBSSIB EQU   JSCBSEC3+56
JSCBFRBA EQU   JSCBSEC3+48
JSCRSV28 EQU   JSCBSEC3+46
JSCBSONO EQU   JSCBSEC3+44
JSCBSUBA EQU   JSCBSUB+1
JSCRSV31 EQU   JSCBSUB
JSCBSMLR EQU   JSCBSEC3+36
JSCBJNLR EQU   JSCBSEC3+32
JSCBJNLA EQU   JSCBJNL+1
JSCBJSBT EQU   JSCBJJSB
JSCBJSBX EQU   JSCBJJSB
JSCBJSBA EQU   JSCBJJSB
JSCBJSBI EQU   JSCBJJSB
@NM00212 EQU   JSCBJJSB
JSCBJNLE EQU   JSCBJJSB
JSCBJNLF EQU   JSCBJJSB
JSCBJNLN EQU   JSCBJJSB
@NM00211 EQU   JSCBSEC3+24
JSCBJRBA EQU   JSCBSEC3+16
JSCBIECB EQU   JSCBSEC3+12
JSCBRV08 EQU   JSCBSEC3+11
JSCBRV07 EQU   JSCBFBYT
JSCBRV06 EQU   JSCBFBYT
JSCBRV05 EQU   JSCBFBYT
JSCBRV04 EQU   JSCBFBYT
JSCBRV03 EQU   JSCBFBYT
JSCBRV02 EQU   JSCBFBYT
JSCBADSP EQU   JSCBFBYT
JSCBRV01 EQU   JSCBFBYT
JSCBTJID EQU   JSCBASID
JSCBPSCB EQU   JSCBSEC3+4
JSCJCTP  EQU   JSCBJCTA
JSCRSV24 EQU   JSCBJCT
JSCBEND2 EQU   JSCBSEC2
CHLAST   EQU   CHAINS01+136
CHSPA    EQU   CHAINS01+135
CHUSERID EQU   CHCSYSO
CHJB     EQU   CHCSYSO
CHDUMP   EQU   CHCSYSO
CHQUE    EQU   CHCSYSO
CHHOLD   EQU   CHCSYSO
CHOUT    EQU   CHCSYSO
CHINN    EQU   CHCSYSO
CHALL    EQU   CHCSYSO
CHINC    EQU   CHAINS01+132
CHPEND   EQU   CHAINS01+128
CHARID   EQU   CHAINS01+127
CHCNID   EQU   CHAINS01+126
@NM00060 EQU   CHTRSTAT
CHTSL    EQU   CHTRSTAT
CHTS     EQU   CHTRSTAT
CHINITL  EQU   CHTRSTAT
CHINIT   EQU   CHTRSTAT
CHJOBSL  EQU   CHTRSTAT
CHJOBS   EQU   CHTRSTAT
CHDEF    EQU   CHTYPE
CHHIAR   EQU   CHTYPE
CHARSV29 EQU   CHTYPE
CHARSV28 EQU   CHTYPE
CHARSV27 EQU   CHTYPE
CHARSV26 EQU   CHTYPE
CHARSV25 EQU   CHTYPE
CHDSTAT  EQU   CHTYPE
CHBUF    EQU   CHAINS01
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
TRMSTHDR EQU   TRMRB+12
@NM00224 EQU   TRMRB+6
@NM00223 EQU   TRMFLAGS
TRMSCHAB EQU   TRMFLAGS
TRMALLOK EQU   TRMFLAGS
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBRV43 EQU   ASCBSRQ4
ASCBRV42 EQU   ASCBSRQ4
ASCBRV41 EQU   ASCBSRQ4
ASCBRV40 EQU   ASCBSRQ4
ASCBRV39 EQU   ASCBSRQ4
ASCBRV38 EQU   ASCBSRQ4
ASCBRV37 EQU   ASCBSRQ4
ASCBRV36 EQU   ASCBSRQ4
ASCBRV35 EQU   ASCBSRQ3
ASCBRV34 EQU   ASCBSRQ3
ASCBRV33 EQU   ASCBSRQ3
ASCBRV32 EQU   ASCBSRQ3
ASCBRV31 EQU   ASCBSRQ3
ASCBRV30 EQU   ASCBSRQ3
ASCBRV29 EQU   ASCBSRQ3
ASCBRV28 EQU   ASCBSRQ3
ASCBRV27 EQU   ASCBSRQ2
ASCBRV26 EQU   ASCBSRQ2
ASCBRV25 EQU   ASCBSRQ2
ASCBRV24 EQU   ASCBSRQ2
ASCBRV23 EQU   ASCBSRQ2
ASCBRV22 EQU   ASCBSRQ2
ASCBRV21 EQU   ASCBSRQ2
ASCBRV20 EQU   ASCBSRQ2
ASCBRV19 EQU   ASCBSRQ1
ASCBRV18 EQU   ASCBSRQ1
ASCBRV17 EQU   ASCBSRQ1
ASCBRV16 EQU   ASCBSRQ1
ASCBRV15 EQU   ASCBSRQ1
ASCBRV14 EQU   ASCBSRQ1
ASCBRV13 EQU   ASCBSRQ1
ASCBSTA  EQU   ASCBSRQ1
ASCBJBNS EQU   ASCB+176
ASCBJBNI EQU   ASCB+172
ASCBMCC  EQU   ASCB+168
ASCBRTWA EQU   ASCB+164
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUXB EQU   ASCB+148
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBQECB EQU   ASCB+136
ASCBLSQH EQU   ASCBLKGP+4
ASCBLOCK EQU   ASCBLKGP
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSRBS EQU   ASCB+118
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBS2S  EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBASXB EQU   ASCB+108
ASCBTMCH EQU   ASCB+104
ASCBNSWP EQU   ASCBFLG1
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBABNT EQU   ASCBFLG1
ASCBTERM EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBWAIT EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBAFFN EQU   ASCBFW1
ASCBDUMP EQU   ASCB+96
ASCBRV44 EQU   ASCB+92
ASCBUBET EQU   ASCB+88
ASCBECB  EQU   ASCB+84
ASCBJSTL EQU   ASCB+80
ASCBEWST EQU   ASCB+72
ASCBEJST EQU   ASCB+64
ASCBTSB  EQU   ASCB+60
ASCBCSCB EQU   ASCB+56
ASCBRSMA EQU   ASCBRSM+1
ASCBRV54 EQU   ASCBRSMF
ASCBRV53 EQU   ASCBRSMF
ASCBRV52 EQU   ASCBRSMF
ASCBRV51 EQU   ASCBRSMF
ASCBVEQR EQU   ASCBRSMF
ASCBN2LP EQU   ASCBRSMF
ASCB1LPU EQU   ASCBRSMF
ASCB2LPU EQU   ASCBRSMF
ASCBLDA  EQU   ASCB+48
ASCBSTOR EQU   ASCB+44
ASCBDP   EQU   ASCB+43
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBCPUS EQU   ASCB+32
ASCBSPL  EQU   ASCB+28
ASCBIOSP EQU   ASCB+24
ASCBSYNC EQU   ASCBSUPC+4
ASCBSVRB EQU   ASCBSUPC
ASCBCMSF EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBFWDP EQU   ASCB+4
ASCBASCB EQU   ASCB
ASCBEGIN EQU   ASCB
@NM00222 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBRV143 EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00221 EQU   TCB+296
TCBSVCA2 EQU   TCB+292
TCBSWASA EQU   TCB+288
TCBDBTB  EQU   TCB+284
TCBRPT   EQU   TCB+280
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBRV327 EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCB+274
TCBRV326 EQU   TCB+272
TCBUKYSP EQU   TCB+268
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBRV308 EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCB+260
TCBTCBID EQU   TCB+256
TCBSTAWA EQU   TCB+252
TCBSWA   EQU   TCB+248
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBCCPVI EQU   TCBXSCT+2
TCBRV325 EQU   TCBXSCT+1
TCBRV324 EQU   TCBXSCT1
TCBRV323 EQU   TCBXSCT1
TCBRV322 EQU   TCBXSCT1
TCBRV321 EQU   TCBXSCT1
TCBRV320 EQU   TCBXSCT1
TCBRV319 EQU   TCBXSCT1
TCBS3A   EQU   TCBXSCT1
TCBACTIV EQU   TCBXSCT1
TCBRSV41 EQU   TCB+239
TCBTID   EQU   TCB+238
TCBRSVAA EQU   TCB+237
TCBABCUR EQU   TCB+236
TCBTMSAV EQU   TCB+232
TCBIOTIM EQU   TCB+228
TCBRTWA  EQU   TCB+224
TCBBACK  EQU   TCB+220
TCBTIRB  EQU   TCB+216
TCBAECB  EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBSVCS  EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBGPECB EQU   TCBFLGS7
TCBNTJS  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBCPU   EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBRSV95 EQU   TCBNDSP5
TCBRSV94 EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00220 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBNDINT EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBLJSND EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTCUR EQU   TCBNSTAE
TCBRV301 EQU   TCBNSTAE
TCBSYNCH EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBNSTAE
TCB33E   EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBAQE   EQU   TCB+156
TCBPQE   EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBJSTCA EQU   TCBJSTCB+1
TCBRSV16 EQU   TCBJSTCB
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBFSA
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBJPQ+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBDWSTA EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBADINP EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBFLGS2
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBNONPR EQU   TCBFLGS1
TCBFERA  EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBTIO   EQU   TCB+12
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00219 EQU   TCBPMASK
TCBRBP   EQU   TCB
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
QDBRV002 EQU   QDB+28
QDBPRDS  EQU   QDB+26
QDBPRSZ  EQU   QDB+24
QDBBPTDS EQU   QDB+22
QDBFPTDS EQU   QDB+20
QDBLELMP EQU   QDB+16
QDBFELMP EQU   QDB+12
QDBNELMS EQU   QDB+8
QDBRV001 EQU   QDB+6
QDBATTR  EQU   QDB+4
QDBQDB   EQU   QDB
DSABGRID EQU   DSABGIDL+4
DSABLLEN EQU   DSABGIDL
DSABANAM EQU   DSABANMI+1
DSABANML EQU   DSABANMI
DSABRS04 EQU   DSAB+68
DSABSIOT EQU   DSAB+64
DSABRS03 EQU   DSAB+62
DSABDCBM EQU   DSAB+56
DSABSSCM EQU   DSAB+52
DSABSSNM EQU   DSAB+48
DSABPTTR EQU   DSAB+44
DSABTCBP EQU   DSAB+40
DSABRS02 EQU   DSAB+38
@NM00217 EQU   DSABFLG4
DSABCKSI EQU   DSABFLG4
DSABCKVL EQU   DSABFLG4
DSABCKDS EQU   DSABFLG4
@NM00216 EQU   DSABFLG3
DSABJSCT EQU   DSABFLG3
DSABCATL EQU   DSABFLG3
DSABVMSC EQU   DSABFLG3
DSABVAM  EQU   DSABFLG3
DSABPASS EQU   DSABFLG3
DSABDEFR EQU   DSABFLG3
@NM00215 EQU   DSABFLG2
DSABUNAL EQU   DSABFLG2
DSABIRM  EQU   DSABFLG2
DSABOPEN EQU   DSABFLG2
DSABNUSE EQU   DSABFLG1
DSABCATM EQU   DSABFLG1
DSABPCAT EQU   DSABFLG1
DSABDCAT EQU   DSABFLG1
DSABCONV EQU   DSABFLG1
DSABDCNV EQU   DSABFLG1
DSABPALC EQU   DSABFLG1
DSABDALC EQU   DSABFLG1
@NM00214 EQU   DSABORG2
DSABTR   EQU   DSABORG2
DSABAM   EQU   DSABORG2
@NM00213 EQU   DSABORG2
DSABTQ   EQU   DSABORG2
DSABTX   EQU   DSABORG2
DSABGS   EQU   DSABORG2
DSABU    EQU   DSABORG1
DSABPO   EQU   DSABORG1
DSABMQ   EQU   DSABORG1
DSABCQ   EQU   DSABORG1
DSABCX   EQU   DSABORG1
DSABDA   EQU   DSABORG1
DSABPS   EQU   DSABORG1
DSABIS   EQU   DSABORG1
DSABRS01 EQU   DSAB+20
DSABTIOT EQU   DSAB+16
DSABOPCT EQU   DSAB+14
DSABLNTH EQU   DSAB+12
DSABBCHN EQU   DSAB+8
DSABFCHN EQU   DSAB+4
DSABID   EQU   DSAB
JSCBCSCB EQU   JSCBSEC1+68
JSCBPMG  EQU   JSCBWTP+2
JSCBWTSP EQU   JSCBWTP+1
JSCRSV23 EQU   JSCBWTFG
JSCRSV22 EQU   JSCBWTFG
JSCRSV21 EQU   JSCBWTFG
JSCRSV20 EQU   JSCBWTFG
JSCRSV19 EQU   JSCBWTFG
JSCRSV18 EQU   JSCBWTFG
JSCBRET  EQU   JSCBWTFG
JSCBIOFG EQU   JSCBWTFG
@NM00210 EQU   JSCBSEC1+60
JSCBQMPI EQU   JSCBSEC1+56
JSCBPMSG EQU   JSCBSWT1
JSCRSV16 EQU   JSCBSWT1
JSCRSV15 EQU   JSCBSWT1
JSCRSV14 EQU   JSCBSWT1
JSCRSV13 EQU   JSCBSWT1
JSCRSV12 EQU   JSCBSWT1
JSCRSV11 EQU   JSCBSWT1
JSCBPASS EQU   JSCBSWT1
JSCBTTTR EQU   JSCBSEC1+52
JSCRSV10 EQU   JSCBSEC1+49
JSCBAUTH EQU   JSCBOPTS
JSCRSV08 EQU   JSCBOPTS
JSCRSV07 EQU   JSCBOPTS
JSCRSV06 EQU   JSCBOPTS
JSCBLONG EQU   JSCBOPTS
JSCRSV05 EQU   JSCBOPTS
JSCRSV04 EQU   JSCBOPTS
JSCBSECB EQU   JSCBSEC1+44
JSCRSV03 EQU   JSCBSEC1+41
JSCBSTEP EQU   JSCBSEC1+40
JSCBDCBA EQU   JSCBDCB+1
JSCRSV02 EQU   JSCBDCB
JSCBID   EQU   JSCBSEC1+32
JSCBDBTB EQU   JSCBSEC1+28
JSCBIJSC EQU   JSCBSEC1+24
JSCBTCBP EQU   JSCBSEC1+20
JSCBPCC  EQU   JSCBSEC1+16
JSCBTCP  EQU   JSCBSEC1+12
JSCBSHR  EQU   JSCBSEC1+8
JSCHPCEA EQU   JSCHPCE+1
JSCRSV32 EQU   JSCHPCE
JSCRSV01 EQU   JSCBSEC1
@NM00209 EQU   IEZJSCB
WPLMLTXT EQU   WPLML+4
WPLMLLT2 EQU   WPLMLLTF+1
WPLRSV24 EQU   WPLMLLT1
WPLRSV23 EQU   WPLMLLT1
WPLRSV22 EQU   WPLMLLT1
WPLRSV21 EQU   WPLMLLT1
WPLMLLTD EQU   WPLMLLT1
WPLMLLTC EQU   WPLMLLT1
WPLMLLTB EQU   WPLMLLT1
WPLMLLTA EQU   WPLMLLT1
WPLMLLEN EQU   WPLML+1
WPLML0   EQU   WPLML
WPLLINES EQU   WPLLS01+3
WPLAREA  EQU   WPLLS01+2
WPLLTF2  EQU   WPLLTF+1
WPLRSV20 EQU   WPLLTF1
WPLRSV19 EQU   WPLLTF1
WPLRSV18 EQU   WPLLTF1
WPLRSV17 EQU   WPLLTF1
WPLLTFD  EQU   WPLLTF1
WPLLTFC  EQU   WPLLTF1
WPLLTFB  EQU   WPLLTF1
WPLLTFA  EQU   WPLLTF1
WPLQID   EQU   WPLFLGS+6
WPLRSV32 EQU   WPLMSGT2
WPLRSV31 EQU   WPLMSGT2
WPLRSV30 EQU   WPLMSGT2
WPLRSV29 EQU   WPLMSGT2
WPLRSV28 EQU   WPLMSGT2
WPLRSV27 EQU   WPLMSGT2
WPLRSV26 EQU   WPLMSGT2
WPLRSV25 EQU   WPLMSGT2
WPLRSV16 EQU   WPLMSGT1
WPLRSV15 EQU   WPLMSGT1
WPLRSV14 EQU   WPLMSGT1
WPLMSGTD EQU   WPLMSGT1
WPLMSGTC EQU   WPLMSGT1
WPLMSGTB EQU   WPLMSGT1
WPLRSV13 EQU   WPLROUT2
WPLROUTO EQU   WPLROUT2
WPLROUTN EQU   WPLROUT2
WPLROUTM EQU   WPLROUT2
WPLROUTL EQU   WPLROUT2
WPLROUTK EQU   WPLROUT2
WPLROUTJ EQU   WPLROUT2
WPLROUTI EQU   WPLROUT2
WPLROUTH EQU   WPLROUT1
WPLROUTG EQU   WPLROUT1
WPLROUTF EQU   WPLROUT1
WPLROUTE EQU   WPLROUT1
WPLROUTD EQU   WPLROUT1
WPLROUTC EQU   WPLROUT1
WPLROUTA EQU   WPLROUT1
WPLRSV12 EQU   WPLDESC2
WPLRSV11 EQU   WPLDESC2
WPLRSV10 EQU   WPLDESC2
WPLRSV09 EQU   WPLDESC2
WPLRSV08 EQU   WPLDESC2
WPLRSV07 EQU   WPLDESC2
WPLDESCJ EQU   WPLDESC2
WPLDESCI EQU   WPLDESC2
WPLDESCH EQU   WPLDESC1
WPLDESCG EQU   WPLDESC1
WPLDESCE EQU   WPLDESC1
WPLDESCC EQU   WPLDESC1
WPLDESCB EQU   WPLDESC1
WPLDESCA EQU   WPLDESC1
WPLTXTL  EQU   WPLTXT+125
@NM00206 EQU   WPLTXT
WPLRSV05 EQU   WPLMCSF2
WPLRSV04 EQU   WPLMCSF2
WPLMCSFN EQU   WPLMCSF2
WPLRSV03 EQU   WPLMCSF2
WPLNOWTP EQU   WPLMCSF2
WPLMCSFK EQU   WPLMCSF2
WPLMCSFJ EQU   WPLMCSF2
WPLMCSFI EQU   WPLMCSF2
WPLMCSFH EQU   WPLMCSF1
WPLMCSFG EQU   WPLMCSF1
WPLMCSFF EQU   WPLMCSF1
WPLMCSFE EQU   WPLMCSF1
WPLMCSFB EQU   WPLMCSF1
WPLRECB  EQU   WPLRF+4
WPLRPTRA EQU   WPLRPTR+1
WPLRLN   EQU   WPLRPTR
@NM00203 EQU   ESTAFLGS
ESTRECRD EQU   ESTAFLGS
ESTAJOBU EQU   ESTAFLGS
ESTRECUR EQU   ESTAFLGS
ESTAAUTO EQU   ESTAPARM
TIOMIUSL EQU   TIOMGRRB+36
TIOMPSNP EQU   TIOMGRRB+32
TIOMRETP EQU   TIOMGRRB+28
TIOMSIOP EQU   TIOMGRRB+24
TIOMDSAP EQU   TIOMGRRB+20
TIOMENTP EQU   TIOMGRRB+16
TIOMSNMP EQU   TIOMGRRB+12
TIOMJNMP EQU   TIOMGRRB+8
@NM00202 EQU   TIOMFMAP+1
@NM00201 EQU   TIOMFMAP+1
@NM00200 EQU   TIOMFMAP+1
@NM00199 EQU   TIOMFMAP+1
@NM00198 EQU   TIOMFMAP+1
@NM00197 EQU   TIOMFMAP+1
@NM00196 EQU   TIOMFMAP+1
TIOMRENT EQU   TIOMFMAP+1
TIOMUNAL EQU   TIOMFMAP
TIOMCCAT EQU   TIOMFMAP
TIOMUPD  EQU   TIOMFMAP
TIOMRLSE EQU   TIOMFMAP
TIOMALOC EQU   TIOMFMAP
@NM00195 EQU   TIOMFMAP
TIOMBLD  EQU   TIOMFMAP
SIODDSNL EQU   INDMSIOT+173
SIOVDSNL EQU   INDMSIOT+172
SIOVDSNT EQU   INDMSIOT+170
SVOLUNNO EQU   INDMSIOT+168
SIOTVMVP EQU   INDMSIOT+164
SIOTJFX  EQU   INDMSIOT+160
SIOTETIO EQU   INDMSIOT+148
SIOTATE  EQU   INDMSIOT+144
SVOLUNAD EQU   INDMSIOT+140
SIOTEDLP EQU   INDMSIOT+136
SIOTEDLS EQU   INDMSIOT+132
SIOTRSNC EQU   INDMSIOT+130
SCTANAME EQU   INDMSIOT+122
SIOTSSIC EQU   INDMSIOT+120
@NM00194 EQU   INDMSIOT+108
SIOTSSNM EQU   INDMSIOT+104
@NM00193 EQU   SIOTBYT2
SIOTCVOL EQU   SIOTBYT2
SIOTCNEW EQU   SIOTBYT2
SIOTCALC EQU   SIOTBYT2
SIOTGALL EQU   SIOTBYT2
SIOTDSPD EQU   SIOTBYT2
SIOTDMND EQU   SIOTBYT2
SIOTOPUC EQU   INDMSIOT+99
SIOTOUTR EQU   INDMSIOT+97
SIOTOUTC EQU   INDMSIOT+96
SIOTSSWA EQU   INDMSIOT+93
SIOTAUNC EQU   SIOTALTD
SIOTACAT EQU   SIOTALTD
SIOTADEL EQU   SIOTALTD
SIOTAKEP EQU   SIOTALTD
SIOTNPRV EQU   SIOTALTD
SIOJCATS EQU   SIOTALTD
@NM00192 EQU   SIOTALTD
@NM00191 EQU   SIOTALTD
@NM00190 EQU   INDMSIOT+91
SIOTNDSB EQU   INDMSIOT+88
@NM00189 EQU   INDMSIOT+84
SIOTDPCD EQU   INDMSIOT+82
@NM00188 EQU   SIOTBYT4
SIOTRACT EQU   SIOTBYT4
SIOTRACD EQU   SIOTBYT4
SIOTPROT EQU   SIOTBYT4
SCTOUTPN EQU   INDMSIOT+80
SCTOUTNO EQU   INDMSIOT+76
SCTOUTNM EQU   INDMSIOT+68
SIOUCBAD EQU   SCTUTYPE+5
SIOUCNVT EQU   SCTUTYPE+4
SIOUBYT4 EQU   SIOTDEVT+3
@NM00187 EQU   SIOUBYT3
SIO3UREC EQU   SIOUBYT3
SIO3DISP EQU   SIOUBYT3
SIO3DACC EQU   SIOUBYT3
SIO3COMM EQU   SIOUBYT3
SIO3TAPE EQU   SIOUBYT3
SIOUBYT2 EQU   SIOTDEVT+1
SIOUBYT1 EQU   SIOTDEVT
SIOTOMN  EQU   SCTSBYT4
SIOTIPDI EQU   SCTSBYT4
SIOTVAFF EQU   SCTSBYT4
SIOTSTEP EQU   SCTSBYT4
SIOTASCI EQU   SCTSBYT4
@NM00186 EQU   SCTSBYT4
SIOTGDGA EQU   SCTSBYT4
SCTSGDGS EQU   SCTSBYT4
SCTSOLD  EQU   SCTSBYT3
SCTSMOD  EQU   SCTSBYT3
SCTSNEW  EQU   SCTSBYT3
SCTSYSOU EQU   SCTSBYT3
SCTVREF  EQU   SCTSBYT3
SCTALCHK EQU   SCTSBYT3
SCTSYSNE EQU   SCTSBYT3
SCTDSNRF EQU   SCTSBYT3
SCTRECVD EQU   SCTSBYT2
SCTDEFER EQU   SCTSBYT2
SCTLABEL EQU   SCTSBYT2
SCTUNLBD EQU   SCTSBYT2
SCTJOBLB EQU   SCTSBYT2
SCTVOLAF EQU   SCTSBYT2
SIOTCATL EQU   SCTSBYT2
SIOCLUNL EQU   SCTSBYT2
SCTUNAFF EQU   SCTSBYT1
SCTPARLM EQU   SCTSBYT1
SIOTQDSN EQU   SCTSBYT1
SIOTGDSN EQU   SCTSBYT1
SIOTCCAT EQU   SCTSBYT1
SCTSYSIN EQU   SCTSBYT1
SCTDUMMY EQU   SCTSBYT1
SIOTUNCT EQU   SCTSDISP
SIOTCTLG EQU   SCTSDISP
SIOTDLET EQU   SCTSDISP
SIOTKEEP EQU   SCTSDISP
SIOTPASS EQU   SCTSDISP
SIOTPRIV EQU   SCTSDISP
S3400DSP EQU   SCTSDISP
SIOTRETN EQU   SCTSDISP
SIOTVLCT EQU   INDMSIOT+54
SCTNMBUT EQU   INDMSIOT+53
SIOTRTRY EQU   SIOTBYT0
SIOTPUPV EQU   SIOTBYT0
SIOTNOPV EQU   SIOTBYT0
SIOTGIGN EQU   SIOTBYT0
SPVTAMSG EQU   SIOTBYT0
SIOTFUDA EQU   SIOTBYT0
SIOTDYAL EQU   SIOTBYT0
SIOTSSDS EQU   SIOTBYT0
SIOTGIID EQU   INDMSIOT+50
SCTVOLCT EQU   INDMSIOT+49
SCTSPOOL EQU   INDMSIOT+48
SIOTQNAM EQU   SIOTTSTC
SIOTDSNM EQU   SIOTTSTC
SIOTTRKM EQU   SIOTTSTC
SIOTSSMG EQU   SIOTTSTC
SIOTSSGP EQU   SIOTTSTC
@NM00185 EQU   SIOTTSTC
SIOTTERM EQU   SIOTTSTC
SIOTINFC EQU   SIOTTSTC
@NM00184 EQU   SIOTBYT3
S3400OFF EQU   SIOTBYT3
SIOTJES3 EQU   SIOTBYT3
SIOCDEVT EQU   SIOTBYT3
SIOALIAS EQU   SIOTBYT3
SCTDDINO EQU   INDMSIOT+44
SIOTDDNT EQU   SIOTBYT1
SIOTALCD EQU   SIOTBYT1
SIODADSM EQU   SIOTBYT1
SIOTDADR EQU   SIOTBYT1
SIODUNAL EQU   SIOTBYT1
SIOVAMDS EQU   SIOTBYT1
SIOTHOLD EQU   SIOTBYT1
SIOTOCKP EQU   SIOTBYT1
SIOPSCNT EQU   INDMSIOT+42
SIOTREFN EQU   INDMSIOT+40
SIOTOTUN EQU   INDMSIOT+39
SIOTVRSB EQU   INDMSIOT+36
@NM00183 EQU   INDMSIOT+35
SCTPJFCB EQU   INDMSIOT+32
@NM00182 EQU   INDMSIOT+31
SCTPSIOT EQU   INDMSIOT+28
SIOTAFID EQU   INDMSIOT+26
SIOTVLSP EQU   INDMSIOT+24
SIODSNTE EQU   INDMSIOT+22
SIOTUNAF EQU   SCTUSADD
SIOTDEST EQU   INDMSIOT+12
SCTDDNAM EQU   INDMSIOT+4
SIOTTYPE EQU   INDMSIOT+3
@NM00181 EQU   @NM00179+1
SCTONLY  EQU   SCTABCND
SCTEVEN  EQU   SCTABCND
SCTONLYC EQU   SCTABCND
SCTABCAN EQU   SCTABCND
@NM00180 EQU   SCTABCND
@NM00178 EQU   INSMSCT+173
@NM00177 EQU   SCTSTEND
SCTSYSCK EQU   SCTSTEND
SCTSTSRT EQU   SCTSTEND
@NM00176 EQU   INSMSCT+168
SCTSDPSA EQU   SCTCDENT+3
SCTSDPOP EQU   SCTCDENT+2
SCTSDPCD EQU   SCTCDENT
@NM00175 EQU   INSMSCT+117
SCTPRFMF EQU   INSMSCT+116
SCTPGMNM EQU   INSMSCT+108
SCTTIOT  EQU   INSMSCT+105
@NM00174 EQU   SCTBCT
SCTJBEND EQU   SCTBCT
SCTSPSYS EQU   SCTBCT
SCTSTPLB EQU   SCTBCT
@NM00173 EQU   SCTBCT
SCTMCVOL EQU   SCTBCT
@NM00172 EQU   SCTBCT
SCTGOTTR EQU   INSMSCT+100
SCTSMF   EQU   INSMSCT+96
@NM00171 EQU   SCTSDPTY+1
SCTSDP   EQU   SCTSDPTY
SCTFSTEP EQU   SCTSDPTY
@NM00170 EQU   SCTSDPTY
@NM00169 EQU   SCTSDPTY
SCTNIUSL EQU   INSMSCT+92
@NM00168 EQU   INSMSCT+90
SCTMSSZE EQU   INSMSCT+88
SCTLDSTB EQU   INSMSCT+80
SCTSRBT  EQU   INSMSCT+76
SCTMSADR EQU   INSMSCT+72
@NM00167 EQU   INSMSCT+71
SCTXBTTR EQU   INSMSCT+68
SCTJSCAT EQU   SCTSTYPE
SCTINITB EQU   SCTSTYPE
SCTSJFHK EQU   SCTSTYPE
SCTOUTMC EQU   SCTSTYPE
SCTINPUT EQU   SCTSTYPE
SCTGOSTP EQU   SCTSTYPE
@NM00166 EQU   INSMSCT+66
SCTNSMSG EQU   INSMSCT+65
@NM00165 EQU   INSMSCT+62
SCTRPACT EQU   INSMSCT+60
@NM00164 EQU   INSMSCT+43
SCTADSTB EQU   INSMSCT+40
@NM00163 EQU   INSMSCT+36
@NM00162 EQU   INSMSCT+35
SCTAFACT EQU   INSMSCT+32
SCTDDNT  EQU   INSMSCT+28
@NM00161 EQU   INSMSCT+27
@NM00160 EQU   INSMSCT+23
@NM00159 EQU   INSMSCT+19
SCTAALOC EQU   INSMSCT+16
@NM00158 EQU   INSMSCT+15
SCTFSIOT EQU   INSMSCT+12
SCTSEXEC EQU   INSMSCT+8
SCTSTIME EQU   INSMSCT+5
INCMSSTS EQU   SCTSSTAT
SCTGRPH  EQU   SCTSSTAT
SCTKEY0  EQU   SCTSSTAT
SCTDORST EQU   SCTSSTAT
SCTNOCKP EQU   SCTSSTAT
SCTNORST EQU   SCTSSTAT
EACAUSER EQU   SCTSSTAT
EAADDRBT EQU   SCTSSTAT
SCTTBLID EQU   INSMSCT+3
LCTLABEL EQU   LCT+504
LCTIWORK EQU   LCT+440
@NM00157 EQU   LCT+436
LCTIMSG  EQU   LCT+432
LCTLBWAP EQU   LCT+428
@NM00156 EQU   LCT+424
LCTATTC  EQU   LCTINTS2
LCTTSWPC EQU   LCTINTS2
LCTBPPAS EQU   LCTINTS2
LCTSYS   EQU   LCTINTS2
LCTTSIZ  EQU   @NM00155
LCTRFB1  EQU   LCT+419
@NM00154 EQU   LCTRFB
LCTRFBRP EQU   LCTRFB
LCTRFBEF EQU   LCTRFB
LCTRFBMS EQU   LCTRFB
LCTRFBDC EQU   LCTRFB
LCTRFBRV EQU   LCTRFB
LCTRFBCR EQU   LCTRFB
LCTRFBSM EQU   LCTRFB
LCTMFTIO EQU   LCTSTATB
LCTNPKEY EQU   LCTSTATB
LCTSBPOL EQU   LCTSTATB
LCTNREAD EQU   LCTSTATB
LCTWRITE EQU   LCTSTATB
LCTNOATC EQU   LCTSTATB
LCTNOREG EQU   LCTSTATB
LCTECBPB EQU   LCTSTATB
LCTCPART EQU   LCTSTATA
LCTNOGCB EQU   LCTSTATA
LCTNOSDP EQU   LCTSTATA
LCTJCPIB EQU   LCTSTATA
LCTNECBL EQU   LCTSTATA
LCTBTJOB EQU   LCTSTATA
LCTSNOWK EQU   LCTSTATA
LCTSUSPD EQU   LCTSTATA
LCTTIOTI EQU   LCT+412
@NM00153 EQU   LCTJCTDA+3
LCTJCTVA EQU   LCTJCTDA
LCTSSOBA EQU   LCT+404
LCTSTEPL EQU   LCT+400
@NM00152 EQU   LCT+364
@NM00151 EQU   LCTJSCB+1
@NM00150 EQU   LCTOPSW3
@NM00149 EQU   LCTOPSW3
LCTALERR EQU   LCTOPSW3
LCTJNLF  EQU   LCTOPSW3
@NM00148 EQU   LCTOPSW3
LCTNSYS  EQU   LCTOPSW3
LCTRDER  EQU   LCTOPSW3
@NM00147 EQU   LCTOPSW3
@NM00146 EQU   @NM00142+1
LCTENQU  EQU   LCTOPSW2
LCTNORC  EQU   LCTOPSW2
LCTBPRAC EQU   LCTOPSW2
@NM00145 EQU   LCTOPSW2
@NM00144 EQU   LCTOPSW2
@NM00143 EQU   LCTOPSW2
LCTCRF   EQU   LCTOPSW2
LCTTIMEF EQU   LCTOPSW2
@NM00141 EQU   LCTEXIT+1
@NM00140 EQU   LCTOPSW1
@NM00139 EQU   LCTOPSW1
LCTONEJF EQU   LCTOPSW1
LCTCANF  EQU   LCTOPSW1
@NM00138 EQU   LCTOPSW1
@NM00137 EQU   LCTOPSW1
LCTDWFF  EQU   LCTOPSW1
LCTDPSWA EQU   LCTOPSW1
LCTTSRB3 EQU   LCTTSRB4+1
@NM00136 EQU   LCTTSRB4
@NM00135 EQU   LCT+340
@NM00134 EQU   LCTSPIL+3
@NM00133 EQU   LCTALCFG
@NM00132 EQU   LCTALCFG
@NM00131 EQU   LCTALCFG
@NM00130 EQU   LCTALCFG
@NM00129 EQU   LCTALCFG
@NM00128 EQU   LCTALCFG
LCTMSGWT EQU   LCTALCFG
LCTODSFL EQU   LCTALCFG
LCTDSBCT EQU   LCTSPIL
LCTPIB   EQU   LCTIDENT
@NM00127 EQU   ECBLIST+1
@NM00126 EQU   ECBLIST
LCTJMRAD EQU   LCT+324
@NM00125 EQU   LCT+284
QMGR1    EQU   LCT+248
REGSAVE  EQU   LCT+104
@NM00124 EQU   LCTATLST+1
@NM00123 EQU   LCTATLST
@NM00122 EQU   LCTJOBLB+1
@NM00121 EQU   LCTJOBLB
LCTTSTU3 EQU   LCTTSTU4+1
@NM00120 EQU   LCTTSTU4
LCTTSTR3 EQU   LCTSMF+1
LCTTTIFJ EQU   LCTTMBYT
LCTTSTL3 EQU   LCTTSTL4+1
@NM00119 EQU   LCTTSTL4
LCTTJTU3 EQU   LCTTJTU4+1
@NM00118 EQU   LCTTJTU4
@NM00117 EQU   @NM00112+2
@NM00116 EQU   LCTPUBYT
@NM00115 EQU   LCTPUBYT
@NM00114 EQU   LCTPUBYT
@NM00113 EQU   LCTPUBYT
LCTNSWP  EQU   LCTPUBYT
LCTN2LP  EQU   LCTPUBYT
LCT1LPU  EQU   LCTPUBYT
LCT2LPU  EQU   LCTPUBYT
LCTNDSI  EQU   LCTINTSW
LCTABEND EQU   LCTINTSW
LCTSTOP  EQU   LCTINTSW
LCTSTART EQU   LCTINTSW
LCTMINRG EQU   LCTINTSW
LCTPPAA  EQU   LCTINTSW
LCTPRIV  EQU   LCTINTSW
LCTINPPT EQU   LCTINTSW
@NM00111 EQU   LCTSREG+1
@NM00110 EQU   LCTSREG
LCTCOMD2 EQU   LCTCOMCD+2
LCTCOMD1 EQU   LCTCOMCD
LCTBATMN EQU   LCT+64
@NM00109 EQU   LCTSMBAD+1
@NM00108 EQU   LCTSMBAD
LCTACTON EQU   LCT+59
LCTSNUMB EQU   LCT+58
@NM00107 EQU   LCTJFCBH
@NM00106 EQU   LCTJFCBH
@NM00105 EQU   LCTJFCBH
@NM00104 EQU   LCTJFCBH
@NM00103 EQU   LCTJFCBH
LCTS2FES EQU   LCTJFCBH
LCTS2COP EQU   LCTJFCBH
LCTS2PEM EQU   LCTJFCBH
LCTSTIND EQU   LCTNSPAD
@NM00102 EQU   LCTCMCBA+1
@NM00101 EQU   LCTCMCBA
LCTPARM4 EQU   LCT+48
LCTPARM3 EQU   LCT+44
LCTPARM2 EQU   LCT+40
LCTACOMP EQU   LCTERR
@NM00100 EQU   LCTPSPAR+1
@NM00099 EQU   LCTPSPAR
@NM00098 EQU   LCTWORKA+3
@NM00097 EQU   LCTSCTAD+1
@NM00096 EQU   LCTSCTAD
@NM00095 EQU   LCTJCTAD+1
@NM00094 EQU   LCTJCTAD
@NM00093 EQU   LCTQENTY+1
@NM00092 EQU   @NM00085
@NM00091 EQU   @NM00085
@NM00090 EQU   @NM00085
@NM00089 EQU   @NM00085
@NM00088 EQU   @NM00085
@NM00087 EQU   @NM00085
@NM00086 EQU   @NM00085
@NM00084 EQU   LCTTCBAD+1
@NM00083 EQU   LCTTCBAD
@NM00082 EQU   LCTSRTAD+1
@NM00081 EQU   LCTSRTAD
@NM00080 EQU   LCTQDRTY+1
@NM00079 EQU   LCTQDRTY
ACTACCNT EQU   IEFAACTB+32
ACTJNFLD EQU   IEFAACTB+31
ACTJTIME EQU   IEFAACTB+28
ACTPRGNM EQU   IEFAACTB+8
@NM00078 EQU   IEFAACTB+7
ACTNEXT  EQU   IEFAACTB+4
ACTIDENT EQU   IEFAACTB+3
ACTDSKAD EQU   IEFAACTB
@NM00077 EQU   INJMJCT+175
JCTACODE EQU   INJMJCT+168
JCTPRFMF EQU   INJMJCT+167
JCTUSER  EQU   INJMJCT+160
JCTSSD   EQU   INJMJCT+157
@NM00076 EQU   INJMJCT+156
JCTSRBT  EQU   INJMJCT+152
JCTJMRJD EQU   INJMJCT+149
JCTJMRJT EQU   INJMJCT+146
JCTJMRSS EQU   INJMJCT+143
JCTJMRTL EQU   INJMJCT+140
JCTJMRCL EQU   INJMJCT+139
JCTJMROP EQU   INJMJCT+138
JCTJMRD  EQU   INJMJCT+137
JCTJMR   EQU   INJMJCT+134
JCTCKIDT EQU   INJMJCT+118
JCTCKIDL EQU   INJMJCT+117
@NM00075 EQU   JCTSTAT2
JCTBLP   EQU   JCTSTAT2
JCTPERFM EQU   JCTSTAT2
JCTENDIT EQU   JCTSTAT2
JCTADSPC EQU   JCTSTAT2
JCTSPSYS EQU   JCTSTAT2
@NM00074 EQU   INJMJCT+115
JCTSSTR  EQU   INJMJCT+112
JCTJSBTM EQU   JCTJSB
JCTJSBEX EQU   JCTJSB
JCTJSBIN EQU   JCTJSB
@NM00073 EQU   JCTJSB
JCTVOLSQ EQU   INJMJCT+110
JCTNRCKP EQU   INJMJCT+108
JCTNTRK  EQU   INJMJCT+107
JCTCKTTR EQU   INJMJCT+104
JCTDEVT  EQU   INJMJCT+100
@NM00072 EQU   INJMJCT+99
JCTSTIOT EQU   INJMJCT+96
JCTSNUMB EQU   INJMJCT+95
JCTQIDNT EQU   INJMJCT+94
JCTEQREG EQU   INJMJCT+92
@NM00071 EQU   INJMJCT+91
JCTDSDRA EQU   JCTRSW2
JCTDSOJB EQU   JCTRSW2
JCTDSOCR EQU   JCTRSW2
JCTRESTT EQU   JCTRSW2
JCTNOCKP EQU   JCTRSW2
JCTNORST EQU   JCTRSW2
JCTNARST EQU   JCTRSW2
JCTSYSCK EQU   JCTRSW2
@NM00070 EQU   JCTRSW1
JCTSTERM EQU   JCTRSW1
@NM00069 EQU   JCTCCODE+3
JCTJDPOP EQU   JCTCCODE+2
JCTJDPCD EQU   JCTCCODE
@NM00068 EQU   INJMJCT+53
JCTSCT   EQU   INJMJCT+52
JCTSMRBA EQU   INJMJCT+44
@NM00067 EQU   INJMJCT+43
JCTACTAD EQU   INJMJCT+40
@NM00066 EQU   INJMJCT+39
JCTJCTX  EQU   INJMJCT+36
@NM00065 EQU   INJMJCT+35
JCTSDKAD EQU   INJMJCT+32
JCTJCSMF EQU   INJMJCT+31
JCTGDGNT EQU   INJMJCT+28
@NM00064 EQU   INJMJCT+27
JCTPDIP  EQU   INJMJCT+24
JCTJTPTN EQU   INJMJCT+16
JCTJPRTY EQU   JCTJBYTE
INCMMGL1 EQU   JCTJMGLV
INCMMGL2 EQU   JCTJMGLV
@NM00063 EQU   JCTJMGLV
JCTJMGPO EQU   INJMJCT+6
INCMNSET EQU   JCTJSTAT
INCMCAT  EQU   INDMCTLG
INCMSTS  EQU   JCTJSTAT
@NM00062 EQU   JCTJSTAT
JCTJSTPC EQU   JCTJSTAT
@NM00061 EQU   JCTJSTAT
JCTJBLBS EQU   JCTJSTAT
JCTJSRNO EQU   INJMJCT+4
JCTIDENT EQU   INJMJCT+3
JCTDSKAD EQU   INJMJCT
CHARSV16 EQU   CHSHORT+100
CHARSV15 EQU   CHSHORT+96
CHJSCBVS EQU   CHSHORT+92
CHUSCVS  EQU   CHSHORT+88
@NM00059 EQU   CHSHORT+84
@NM00058 EQU   CHSHORT+80
CHSQA    EQU   CHSHORT+44
CHQPA    EQU   CHSHORT+8
CHJCL    EQU   CHSHORT+4
CHSPC    EQU   CHSHORT
CHSPB    EQU   CHSTEP+4
CHTCB    EQU   CHSTEP+1
CHARSV23 EQU   CHSWT
CHARSV22 EQU   CHSWT
CHARSV21 EQU   CHSWT
CHAC     EQU   CHSWT
CHPSF    EQU   CHSWT
CHPSD    EQU   CHSWT
CHJCT    EQU   CHSWT
CHARSV20 EQU   CHSWT
CHCECB   EQU   CHASM+20
CHECB    EQU   CHASM+16
CHRGNAD  EQU   CHASM+12
CHARSV18 EQU   CHRGNSZ+1
CHRPRTY  EQU   CHRGNSZ
@NM00057 EQU   CHCIBP
CHEND    EQU   CHCIBP
CHECBP   EQU   CHASM
CHDER    EQU   CHPROCSN+4
CHARSV10 EQU   CHACT1
CHARSV09 EQU   CHACT1
CHARSV08 EQU   CHACT1
CHARSV07 EQU   CHACT1
CHARSV06 EQU   CHACT1
CHARSV05 EQU   CHACT1
CHARSV04 EQU   CHACT1
CHRDWTR  EQU   CHACT1
CHARSV30 EQU   CHPROCSN+2
CHQID    EQU   CHPROCSN
CHASID   EQU   CHTJID
CHUCMP   EQU   CHAIN+29
CHCIBCTR EQU   CHAIN+27
CHUNIT   EQU   CHAIN+24
CHCLS    EQU   CHAIN+16
CHPCOI   EQU   CHPARM
CHIFY    EQU   CHACT
CHAIFX   EQU   CHACT
CHCL     EQU   CHACT
CHDSI    EQU   CHACT
CHDISC   EQU   CHACT
CHTERM   EQU   CHACT
CHSWAP   EQU   CHACT
CHABTERM EQU   CHSTS
CHFC     EQU   CHSTS
CHDL     EQU   CHSTS
CHAD     EQU   CHSTS
CHQSPC   EQU   CHSTS
CHSOUT   EQU   CHSTS
CHSYS    EQU   CHSTS
CHAP     EQU   CHSTS
CHSZE    EQU   CHFLG+1
CHVCD    EQU   CHFLG
CHPTR    EQU   CHAIN
MSSPARE  EQU   BASES01+48
MSUCBAL  EQU   BASES01+44
MSUCBPR  EQU   BASES01+40
MSBOBECB EQU   BASES01+36
MSSJQ    EQU   BASES01+32
MSECB    EQU   BASES01+28
MSPBP    EQU   BASES01+24
MSERM    EQU   BASES01+22
MSPASS   EQU   BASES01+14
MSVRB    EQU   BASES01+6
MSQHR    EQU   MSFHF
@NM00056 EQU   MSFHF
MSPSDT   EQU   MSFHF
MSREPLYB EQU   MSFHF
MSFAX    EQU   MSFHF
MSTTT    EQU   MSFHF
MSCSD    EQU   MSFHF
MSNMF    EQU   MSFHF
MSJNF    EQU   MSSSA
MSYOUT   EQU   MSNWP
MSNRP    EQU   MSSSA
MSSRDR   EQU   MSREOF
MSWRLOG  EQU   MSSSA
MSNUPSW  EQU   MSSSA
MSWRPEN  EQU   MSSSA
MSSSSIPL EQU   MSINLSW
MSSUM    EQU   MSECBFL
MSMCR    EQU   MSECBFL
MSYSOUT  EQU   MSECBFL
MSYSIN   EQU   MSECBFL
MSATTN   EQU   MSECBFL
MSWTL    EQU   MSECBFL
MSWTO    EQU   MSECBFL
MSEXT    EQU   MSECBFL
MSCCS    EQU   MSPFG
MSBSP    EQU   MSPFG
MSSYT    EQU   MSPFG
MSSYN    EQU   MSPFG
MSICR    EQU   MSPFG
MSCMC    EQU   MSPFG
MSPNB    EQU   MSPFG
MSDATE   EQU   MSPFG
@NM00055 EQU   MSBTN
@NM00054 EQU   MSBTN
@NM00053 EQU   MSBTN
MSSO     EQU   MSBTN
MSROLFLG EQU   MSBTN
MSCANFLG EQU   MSBTN
MSCONFLG EQU   MSBTN
MSPNIP   EQU   MSNTAL
MSQNIP   EQU   MSNTAL
MSCURE34 EQU   MSNTAL
@NM00052 EQU   MSNTAL
@NM00051 EQU   MSNTAL
@NM00050 EQU   MSNTAL
@NM00049 EQU   MSNTAL
MSNIP    EQU   MSNTAL
@NM00048 EQU   MS1BASEX+40
@NM00047 EQU   MS1BASEX+20
@NM00046 EQU   MS1BASEX
@NM00045 EQU   BASE+128
MSLGJSCB EQU   BASE+124
@NM00044 EQU   MSSTRTSW
MSSTRTP  EQU   MSSTRTSW
MSSTRTW  EQU   MSSTRTSW
@NM00043 EQU   MSWTRSW
MSWTRP   EQU   MSWTRSW
MSWTRW   EQU   MSWTRSW
@NM00042 EQU   MSWLOGSW
MSWLOGP  EQU   MSWLOGSW
MSWLOGW  EQU   MSWLOGSW
@NM00041 EQU   MSCLOSSW
MSCLOSP  EQU   MSCLOSSW
MSCLOSW  EQU   MSCLOSSW
MSLOGLMT EQU   @NM00040+1
MSLOGCLS EQU   @NM00040
BAASCB   EQU   BASE+100
MSSMFPRM EQU   BASE+96
MSCOMMND EQU   BASE+92
BASP12   EQU   BASE+90
BASUBECB EQU   BASE+80
BALOGCOM EQU   BASE+76
BADACNT  EQU   BASE+74
BATACNT  EQU   BASE+72
BAJBNR   EQU   BASE+64
BASP11   EQU   BASE+62
BALCCNT  EQU   BASE+61
BADUMPID EQU   BASE+60
BABCMAX  EQU   BASE+58
BAMONTR2 EQU   BASE+57
@NM00039 EQU   BAMONITR
BAMACTVE EQU   BAMONITR
@NM00038 EQU   BAMONITR
@NM00037 EQU   BAMONITR
@NM00036 EQU   BAMONITR
@NM00035 EQU   BAMONITR
BASPACE  EQU   BAMONITR
BADSN    EQU   BAMONITR
BADSO    EQU   BASE+52
BALOGECB EQU   BASE+48
@NM00034 EQU   BASPBYTE
@NM00033 EQU   BASPBYTE
@NM00032 EQU   BASPBYTE
@NM00031 EQU   BASPBYTE
@NM00030 EQU   BASPBYTE
BAMASCH  EQU   BASPBYTE
BATRACE  EQU   BASPBYTE
BAMSSTAR EQU   BASPBYTE
@NM00029 EQU   MSLOGST
@NM00028 EQU   MSLOGST
MSLOGSTA EQU   MSLOGST
MSLOGIPL EQU   MSLOGST
MSLOGDAR EQU   MSLOGST
MSLOGCOM EQU   MSLOGST
MSLOGTHD EQU   MSLOGST
MSLOGENQ EQU   MSLOGST
BAMIPAR2 EQU   BASE+44
BAMINPAR EQU   BASE+42
BAPKES   EQU   BASE+40
BAICTR   EQU   BASE+38
@NM00027 EQU   BASE+37
BADSET   EQU   BARSW
BANOSET  EQU   BARSW
BAMIDNT  EQU   BARSW
BAHR     EQU   BARSW
BAVU     EQU   BARSW
BAINTSET EQU   BARSW
MSTODWTO EQU   BARSW
BAIN     EQU   BARSW
BACV     EQU   BASE+32
@NM00026 EQU   BALOG
@NM00025 EQU   BALOG
@NM00024 EQU   BALOG
@NM00023 EQU   BALOG
@NM00022 EQU   BALOG
@NM00021 EQU   BALOG
@NM00020 EQU   BALOG
BALOGINT EQU   BALOG
MSLOGSVC EQU   BALGSTAT
BAPRC    EQU   BASE+20
BAQ      EQU   BASE+16
BAIPLCC  EQU   @NM00018+2
@NM00019 EQU   @NM00018
BAIPL    EQU   BASE+12
BALAD    EQU   BASE+8
BATRM    EQU   BASE+4
BACHN    EQU   BASE
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00017 EQU   CVTFIX+248
@NM00016 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVT      EQU   CVTMAP
EPABEPA  EQU   EPABLK+16
EPABSW   EQU   EPABHDR+12
SWCHNPTR EQU   SWAEPA+12
SWLNGTH  EQU   SWAEPA+8
SWBLKID  EQU   SWVAFW+3
SWVA     EQU   SWVAFW
SWBLKPTR EQU   SWAEPA
@NM00015 EQU   WTOTIME+12
@NM00014 EQU   WTOTIME+9
@NM00013 EQU   WTOTIME+2
@NM00012 EQU   WTOTIME
@NM00011 EQU   WTONAMES+25
@NM00010 EQU   WTONAMES+16
@NM00009 EQU   WTONAMES
ASWACHNP EQU   ASWA+36
ASWRSV02 EQU   ASWAFLGS+1
ASWRSV01 EQU   ASWADSWS
ASWADYUE EQU   ASWADSWS
ASWAVMVF EQU   ASWADSWS
ASWACOMF EQU   ASWADSWS
ASWADYNF EQU   ASWADSWS
@NM00002 EQU   TCBPTRS
TIOTLNTH EQU   TIOTLIST+4
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RF00200 EQU   @RC00163
@RC00225 EQU   @RC00214
@RC00219 EQU   @RC00214
@RC00252 EQU   @RC00251
@RC00360 EQU   @RC00301
@RC00306 EQU   @RC00301
@RC00382 EQU   @RC00375
@RC00376 EQU   @RC00375
@RF00519 EQU   @RC00510
@RF00524 EQU   @RC00510
@RC00556 EQU   @RC00555
@RF00502 EQU   @RC00208
@RC00334 EQU   @RC00306
@ENDDATA EQU   *
         END   IEFBB410,(C'PLS2019',0701,77089)
