         TITLE 'IEFDB4A0 - DYNAMIC UNALLOCATION CONTROL RTN.           *
                        '
IEFDB4A0 CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(16)                                          01S0001
         DC    C'IEFDB4A0  75.024'                              01S0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01S0001
         BALR  @12,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@12                                      01S0001
         L     @00,@SIZDATD                                     01S0001
         GSPACE   R,LV=(0)
         LR    @11,@01                                          01S0001
         USING @DATD,@11                                        01S0001
         ST    @13,@SA00001+4                                   01S0001
         LM    @00,@01,20(@13)                                  01S0001
         ST    @11,8(,@13)                                      01S0001
         LR    @13,@11                                          01S0001
         MVC   @PC00001(28),0(@01)                              01S0001
JSCBDISP EQU 188
JSCBAOS1 EQU  72
JSCBAOS2 EQU 192
*RSNCODE = 0;                          /*ZERO ERROR AND INFO CODES   */
         L     @10,@PC00001+4                                   01S0108
         SLR   @15,@15                                          01S0108
         ST    @15,RSNCODE(,@10)                                01S0108
*UNALKEYT = UNALKEYT && UNALKEYT;      /*ZERO UNALLOC KEY TABLE      */
         XC    UNALKEYT(40),UNALKEYT                            01S0109
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - VALIDCHK                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - VALIDITY CHECK OF REQUEST                     */
*/*                                                                  */
*/* FUNCTION  - VALIDITY CHECK THE INPUT REQUEST TO DYNAMIC          */
*/*             UNALLOCATION                                         */
*/*                                                                  */
*/* OPERATION - THE SYNTAX CHECKER (IEFDB4FF) IS INVOKED TO CHECK    */
*/*             THE INPUT REQUEST FOR INVALID, DUPLICATE OR          */
*/*             MUTUALLY EXCLUSIVE KEYS, AND FOR INVALID PARM        */
*/*             NUMBER AND LENGTH SPECIFICATIONS. IF ALL ARE VALID,  */
*/*             THE KEY TABLE WILL HAVE BEEN FILLED IN WITH PTRS     */
*/*             TO THE SPECIFIED TEXT UNITS.                         */
*/*                                                                  */
*/*           - A CHECK IS MADE TO ENSURE THAT EITHER DSNAME OR      */
*/*             DDNAME WAS SPECIFIED, AS THE SPECIFICATION OF AT     */
*/*             LEAST ONE OF THESE KEYS IS REQUIRED.                 */
*/*                                                                  */
*/*           - IF THE DDNAME KEY WAS SPECIFIED, A CHECK IS MADE TO  */
*/*             ENSURE THAT NONE OF THE RESERVED DD NAMES OF JOBLIB, */
*/*             JOBCAT, STEPLIB, OR STEPCAT WERE SPECIFIED AS A PARM */
*/*             ALSO, THE FIRST CHARACTER OF THE DDNAME MAY NOT BE   */
*/*             BLANK, AS AN ERRONEOUS MATCH WITH A CONCATENATED DD  */
*/*             MAY OCCUR IN SEARCHING FOR A DSAB WITH THIS          */
*/*             INVALID DDNAME.                                      */
*/*                                                                  */
*/*           - IF THE MEMBER NAME KEY WAS SPECIFIED, A CHECK IS     */
*/*             MADE TO ENSURE THAT THE DSNAME KEY WAS ALSO SPECIFIED*/
*/*             AS MEMBER NAME REQUIRES DSNAME.                      */
*/*                                                                  */
*/*           - IF AN OVERRIDING DISP WAS SPECIFIED, THE PARM VALUE  */
*/*             IS CHECKED TO BE ONE OF KEEP, DELETE, CATLG,         */
*/*             OR UNCATLG.                                          */
*/*                                                                  */
*/*           - IF AN OVERRIDING SYSOUT CLASS WAS SPECIFIED, THE     */
*/*             PARM VALUE IS CHECKED TO BE IN THE RANGE OF 0 - 9,   */
*/*             OR A - Z.                                            */
*/*                                                                  */
*/*           - IF AN OVERRIDING SYSOUT REMOTE USER IS SPECIFIED,    */
*/*             AN SSOB (HEADER AND SYSOUT DEST VERIFICATION         */
*/*             FUNCTIONAL SECTION) ARE FILLED IN. IEFSSREQ IS       */
*/*             ISSUED AND THE SUBSYSTEM INTERFACE IS INVOKED TO     */
*/*             VALIDATE THE OVERRIDING SYSOUT DESTINATION.          */
*/*                                                                  */
*/*           IF AT ANY TIME ONE OF THE ABOVE VALIDITY CHECKS FAILS, */
*/*           AN APPROPRIATE ERROR CODE (ALONG WITH THE KEY CAUSING  */
*/*           ERROR IF APPROPRIATE) IS PLACED IN THE REASON CODE     */
*/*           FIELD, AND NO FURTHER CHECKS ARE MADE.                 */
*/*                                                                  */
*/* ENTRY -                                                          */
*/*   INPUT DATA - S99TXTPP - PTR TO LIST OF TEXT UNIT PTRS          */
*/*                UNALKEYD - UNALLOC KEY DICTIONARY OF VALID        */
*/*                           KEY INFORMATION                        */
*/*                UNALKEYT - UNALLOC KEY TABLE (ZEROES ON ENTRY)    */
*/*                RSNCODE  - REASON CODE WITH ERROR AND INFO        */
*/*                           CODE FIELDS (ZEROES ON ENTRY)          */
*/*                                                                  */
*/* EXIT -                                                           */
*/*   OUTPUT DATA - UNALKEYT - FILLED IN BY THE SYNTAX CHECKER WITH  */
*/*                            PTRS TO SPECIFIED TEXT UNITS.         */
*/*                 ERRCODE  - RETURN CODE FOR ANY ERROR DETECTED    */
*/*                 INFOCODE - KEY IN ERROR, WHEN APPROPRIATE        */
*/*                                                                  */
*/********************************************************************/
*DUPMASK = DUPMASK && DUPMASK;         /*ZERO DUPLICATE KEY MASK     */
         XC    DUPMASK(12),DUPMASK                              02S0110
*MUTEXMSK = MUTEXMSK && MUTEXMSK;      /*ZERO MUTUALLY EXCLUSIVE MASK*/
         XC    MUTEXMSK(12),MUTEXMSK                            02S0111
*CALL IEFDB4FF(S99TXTPP,ADDR(UNALKEYD),ADDR(DUPMASK),ADDR(MUTEXMSK),
*              ADDR(UNALKEYT),RSNCODE);/*INVOKE SYNTAX CHECKER       */
         L     @15,@PC00001                                     02S0112
         ST    @15,@AL00001                                     02S0112
         LA    @15,UNALKEYD                                     02S0112
         ST    @15,@TF00001                                     02S0112
         LA    @15,@TF00001                                     02S0112
         ST    @15,@AL00001+4                                   02S0112
         LA    @15,DUPMASK                                      02S0112
         ST    @15,@TF00002                                     02S0112
         LA    @15,@TF00002                                     02S0112
         ST    @15,@AL00001+8                                   02S0112
         LA    @15,MUTEXMSK                                     02S0112
         ST    @15,@TF00003                                     02S0112
         LA    @15,@TF00003                                     02S0112
         ST    @15,@AL00001+12                                  02S0112
         LA    @15,UNALKEYT                                     02S0112
         ST    @15,@TF00004                                     02S0112
         LA    @15,@TF00004                                     02S0112
         ST    @15,@AL00001+16                                  02S0112
         ST    @10,@AL00001+20                                  02S0112
         L     @15,@CV00100                                     02S0112
         LA    @01,@AL00001                                     02S0112
         BALR  @14,@15                                          02S0112
*IF (ERRCODE = 0 &                     /*IF NO ERROR IN SYNTAX CHECK */
*    DDNAMTUP = 0 &                    /*BUT NEITHER DDNAME NOR      */
*    DSNAMTUP = 0) THEN                /*DSNAME KEYS WERE SPECIFIED  */
         SLR   @10,@10                                          02S0113
         L     @15,@PC00001+4                                   02S0113
         CH    @10,ERRCODE(,@15)                                02S0113
         BNE   @RF00113                                         02S0113
         C     @10,DDNAMTUP                                     02S0113
         BNE   @RF00113                                         02S0113
         C     @10,DSNAMTUP                                     02S0113
         BNE   @RF00113                                         02S0113
*  ERRCODE = RCKEYREQ;                 /*THEN REQUIRED KEY MISSING   */
*                                                               02S0114
         MVC   ERRCODE(2,@15),@CH01952                          02S0114
*IF (DDNAMTUP ^= 0 &                   /*IF DDNAME WAS SPEC'D AND    */
*    ERRCODE = 0 ) THEN                /*IF NO ERROR THEN            */
@RF00113 L     @10,DDNAMTUP                                     02S0115
         SLR   @15,@15                                          02S0115
         CR    @10,@15                                          02S0115
         BE    @RF00115                                         02S0115
         L     @14,@PC00001+4                                   02S0115
         CH    @15,ERRCODE(,@14)                                02S0115
         BNE   @RF00115                                         02S0115
*  DO;                                 /*CHECK DDNAME                */
*    RFY TEXTUNIT BASED(DDNAMTUP);     /*RESET TEXT UNIT BASE        */
*    IF (TEXTULNG >= 6 & (TEXTUPAR(1:TEXTULNG) = 'JOBLIB  ' |   02S0118
*                          TEXTUPAR(1:TEXTULNG) = 'JOBCAT  '))  |
*        (TEXTULNG >= 7 & (TEXTUPAR(1:TEXTULNG) = 'STEPLIB ' |  02S0118
*                          TEXTUPAR(1:TEXTULNG) = 'STEPCAT ')) THEN
         ICM   @15,12,TEXTULNG(@10)                             02S0118
         SRA   @15,16                                           02S0118
         C     @15,@CF00233                                     02S0118
         BL    @GL00004                                         02S0118
         BCTR  @15,0                                            02S0118
         EX    @15,@SC02180                                     02S0118
         BE    @RT00118                                         02S0118
         EX    @15,@SC02182                                     02S0118
         BE    @RT00118                                         02S0118
@GL00004 L     @10,DDNAMTUP                                     02S0118
         ICM   @15,12,TEXTULNG(@10)                             02S0118
         SRA   @15,16                                           02S0118
         C     @15,@CF00573                                     02S0118
         BL    @RF00118                                         02S0118
         BCTR  @15,0                                            02S0118
         EX    @15,@SC02184                                     02S0118
         BE    @RT00118                                         02S0118
         EX    @15,@SC02186                                     02S0118
         BNE   @RF00118                                         02S0118
@RT00118 DS    0H                                               02S0119
*                                      /*WAS RESERVE DDNAME SPEC'D ? */
*      ERRCODE = RCRSVDDN;             /*YES, SET ERROR RETURN       */
         L     @10,@PC00001+4                                   02S0119
         MVC   ERRCODE(2,@10),@CH01936                          02S0119
*    ELSE                              /*NOT RESERVED DDNAME         */
*      IF TEXTUPAR(1) = ' ' THEN       /*IF 1ST CHAR IS BLANK        */
         B     @RC00118                                         02S0120
@RF00118 L     @10,DDNAMTUP                                     02S0120
         CLI   TEXTUPAR(@10),C' '                               02S0120
         BNE   @RF00120                                         02S0120
*        DO;                           /*INVALID DDNAME PARM         */
*          ERRCODE = RCINPARM;         /*SET INVALID PARM ERROR      */
         L     @10,@PC00001+4                                   02S0122
         MVC   ERRCODE(2,@10),@CH01932                          02S0122
*          INFOCODE = DUNDDNAM;        /*RETURN DDNAME KEY           */
         MVC   INFOCODE(2,@10),@CH00116                         02S0123
*        END;                          /*END IF BLANK DDNAME         */
*      ELSE;                           /*DDNAME NOT BLANK            */
@RF00120 DS    0H                                               02S0126
*  END;                                /*END DDNAME CHECK            */
*                                                               02S0126
@RC00118 DS    0H                                               02S0127
*IF (MEMBRTUP ^= 0 &                   /*IF MEMBER NAME SPEC'D AND   */
*    ERRCODE = 0) THEN                 /*IF NO ERROR THEN            */
@RF00115 SLR   @10,@10                                          02S0127
         C     @10,MEMBRTUP                                     02S0127
         BE    @RF00127                                         02S0127
         L     @15,@PC00001+4                                   02S0127
         CH    @10,ERRCODE(,@15)                                02S0127
         BNE   @RF00127                                         02S0127
*  IF DSNAMTUP = 0 THEN                /*IF DSNAME WAS NOT SPEC'D    */
         C     @10,DSNAMTUP                                     02S0128
         BNE   @RF00128                                         02S0128
*    DO;                               /*THEN INCLUSIVE KEY ERROR    */
*      ERRCODE = RCMINCLU;             /*SET ERROR RETURN            */
         MVC   ERRCODE(2,@15),@CH01950                          02S0130
*      INFOCODE = DUNMEMBR;            /*RETURN KEY OF ERROR         */
         MVC   INFOCODE(2,@15),@CH00276                         02S0131
*    END;                              /*END INCLUSIVE KEY ERROR     */
*                                                               02S0132
*IF (OVDSPTUP ^= 0 &                   /*IF OVERRIDING DISP SPEC'D & */
*    ERRCODE = 0 ) THEN                /*IF NO ERROR THEN            */
@RF00128 DS    0H                                               02S0133
@RF00127 L     @10,OVDSPTUP                                     02S0133
         SLR   @15,@15                                          02S0133
         CR    @10,@15                                          02S0133
         BE    @RF00133                                         02S0133
         L     @14,@PC00001+4                                   02S0133
         CH    @15,ERRCODE(,@14)                                02S0133
         BNE   @RF00133                                         02S0133
*  DO;                                 /*CHECK FOR VALID VALUES      */
*    RFY TEXTUNIT BASED(OVDSPTUP);     /*RESET TEXT UNIT BASE        */
*    IF (TEXTUPAR(1) ^= '08'X &        /*IF THE PARM IS NOT KEEP,    */
*        TEXTUPAR(1) ^= '04'X &        /*AND NOT DELETE,             */
*        TEXTUPAR(1) ^= '02'X &        /*AND NOT CATLG,              */
*        TEXTUPAR(1) ^= '01'X) THEN    /*AND NOT UNCATLG,            */
         CLI   TEXTUPAR(@10),X'08'                              02S0136
         BE    @RF00136                                         02S0136
         CLI   TEXTUPAR(@10),X'04'                              02S0136
         BE    @RF00136                                         02S0136
         CLI   TEXTUPAR(@10),X'02'                              02S0136
         BE    @RF00136                                         02S0136
         CLI   TEXTUPAR(@10),X'01'                              02S0136
         BE    @RF00136                                         02S0136
*      DO;                             /*THEN PARM IS INVALID        */
*        ERRCODE = RCINPARM;           /*SET ERROR RETURN            */
         MVC   ERRCODE(2,@14),@CH01932                          02S0138
*        INFOCODE = DUNOVDSP;          /*RETURN KEY OF ERROR         */
         MVC   INFOCODE(2,@14),@CH00279                         02S0139
*      END;                            /*END IF BAD OVERRIDING DISP  */
*  END;                                /*END OF OVERRIDING DISP CHECK*/
*                                                               02S0141
@RF00136 DS    0H                                               02S0142
*IF (OVCLSTUP ^= 0 &                   /*IF OVERRIDING CLASS SPEC'D. */
*    ERRCODE = 0) THEN                 /*AND IF NO ERROR             */
@RF00133 L     @10,OVCLSTUP                                     02S0142
         SLR   @15,@15                                          02S0142
         CR    @10,@15                                          02S0142
         BE    @RF00142                                         02S0142
         L     @14,@PC00001+4                                   02S0142
         CH    @15,ERRCODE(,@14)                                02S0142
         BNE   @RF00142                                         02S0142
*  DO;                                 /*CHECK OVERRIDING CLASS      */
*    RFY TEXTUNIT BASED(OVCLSTUP);     /*RESET TEXT UNIT BASE        */
*    IF (TEXTUPAR(1) < 'A'    |        /*IS PARM HEX VALUE BELOW 'A',*/
*        (TEXTUPAR(1) > 'I' &          /*OR GREATER THAN 'I' AND     */
*         TEXTUPAR(1) < 'J')  |        /*LESS THAN 'J' OR            */
*        (TEXTUPAR(1) > 'R' &          /*GREATER THAN 'R' AND        */
*         TEXTUPAR(1) < 'S')  |        /*LESS THAN 'S' OR            */
*        (TEXTUPAR(1) > 'Z' &          /*GREATER THAN 'Z' AND        */
*         TEXTUPAR(1) < '0')  |        /*LESS THAN '0' OR            */
*        TEXTUPAR(1) > '9') THEN       /*GREATER THAN '9' ?          */
         CLI   TEXTUPAR(@10),C'A'                               02S0145
         BL    @RT00145                                         02S0145
         CLI   TEXTUPAR(@10),C'I'                               02S0145
         BNH   @GL00017                                         02S0145
         CLI   TEXTUPAR(@10),C'J'                               02S0145
         BL    @RT00145                                         02S0145
@GL00017 L     @10,OVCLSTUP                                     02S0145
         CLI   TEXTUPAR(@10),C'R'                               02S0145
         BNH   @GL00016                                         02S0145
         CLI   TEXTUPAR(@10),C'S'                               02S0145
         BL    @RT00145                                         02S0145
@GL00016 L     @10,OVCLSTUP                                     02S0145
         CLI   TEXTUPAR(@10),C'Z'                               02S0145
         BNH   @GL00015                                         02S0145
         CLI   TEXTUPAR(@10),C'0'                               02S0145
         BL    @RT00145                                         02S0145
@GL00015 L     @10,OVCLSTUP                                     02S0145
         CLI   TEXTUPAR(@10),C'9'                               02S0145
         BNH   @RF00145                                         02S0145
@RT00145 DS    0H                                               02S0146
*      DO;                             /*YES,THEN INVALID CLASS PARM */
*        ERRCODE = RCINPARM;           /*RETURN ERROR CODE           */
         L     @10,@PC00001+4                                   02S0147
         MVC   ERRCODE(2,@10),@CH01932                          02S0147
*        INFOCODE = DUNOVCLS;          /*RETURN KEY OF ERROR         */
         MVC   INFOCODE(2,@10),@CH00184                         02S0148
*      END;                            /*END INVALID SYSOUT CLASS    */
*  END;                                /*END OVERRIDING CLASS CHECK  */
*                                                               02S0150
@RF00145 DS    0H                                               02S0151
*IF (OVSUSTUP ^= 0 &                   /*IF OVERRIDING DEST SPEC'D   */
*    ERRCODE = 0) THEN                 /*AND IF NO ERROR             */
@RF00142 L     @10,OVSUSTUP                                     02S0151
         SLR   @15,@15                                          02S0151
         CR    @10,@15                                          02S0151
         BE    @RF00151                                         02S0151
         L     @14,@PC00001+4                                   02S0151
         CH    @15,ERRCODE(,@14)                                02S0151
         BNE   @RF00151                                         02S0151
*  DO;                                 /*HAVE SUBSYSTEM VALIDATE IT  */
*    RFY TEXTUNIT BASED(OVSUSTUP);     /*RESET TEXT UNIT BASE        */
*    SSOB = SSOB && SSOB;              /*ZERO HEADER OF SSOB         */
         XC    SSOB(20),SSOB                                    02S0154
*    SSOBID = 'SSOB';                  /*INIT SSOB BLOCK ID          */
         MVC   SSOBID(4),@CC02161                               02S0155
*    SSOBLEN = LENGTH(SSOB);           /*INIT LENGTH FIELD           */
         MVC   SSOBLEN(2),@CH01882                              02S0156
*    SSOBFUNC = SSOBUSER;              /*FUNC IS REMOTE USERID VAL CK*/
         MVC   SSOBFUNC(2),@CH01884                             02S0157
*    SSOBINDV = ADDR(SSUS);            /*POINT TO FUNCTION DEPENDENT
*                                        SECTION                     */
         LA    @15,SSUS                                         02S0158
         ST    @15,SSOBINDV                                     02S0158
*    SSUS = SSUS && SSUS;              /*ZERO FUNCTION DEPENDENT
*                                        SECTION FOR SYSOUT DEST
*                                        VERIFICATION                */
         XC    SSUS(16),SSUS                                    02S0159
*    SSUSLEN = LENGTH(SSUS);           /*INIT FUNC. DEPEND. LEN FIELD*/
         MVC   SSUSLEN(2),@CH00067                              02S0160
*    SSUSUSER = '';                    /*BLANK OUT DEST ID FIELD     */
         MVI   SSUSUSER,C' '                                    02S0161
         MVC   SSUSUSER+1(7),SSUSUSER                           02S0161
*    SSUSUSER(1:TEXTULNG) = TEXTUPAR(1:TEXTULNG); /*COPY ID INTO SSOB*/
*                                                               02S0162
         ICM   @15,12,TEXTULNG(@10)                             02S0162
         SRA   @15,16                                           02S0162
         BCTR  @15,0                                            02S0162
         EX    @15,@SM02188                                     02S0162
*     /* ? IEFSSREQ  (SSOB);*/                                  02S0163
*/*                                           */                02S0163
*/*  PASS CONTROL TO JOB ENTRY SUBSYSTEM TO   */                02S0163
*/*  PROCESS REQUEST -                        */                02S0163
*/*                                           */                02S0163
*/*    INPUT - REGISTER 1 POINTS TO A ONE-    */                02S0163
*/*            WORD PARAMETER LIST WHICH      */                02S0163
*/*            POINTS TO THE SSOB             */                02S0163
*/*                                           */                02S0163
*CALL SSREQ(SSOB);                  /*I/F WITH SUBSYSTEM FOR    02S0163
*                                     VERIFY                      */
         LA    @10,SSOB                                         02S0163
         ST    @10,@AL00001                                     02S0163
         MVI   @AL00001,X'80'                                   02S0163
         L     @10,CVTPTR                                       02S0163
         L     @10,CVTJESCT(,@10)                               02S0163
         L     @15,JESSSREQ(,@10)                               02S0163
         LA    @01,@AL00001                                     02S0163
         BALR  @14,@15                                          02S0163
*    IF SSOBRETN = SSUSNOUS THEN       /*IF INVALID SYSOUT DEST      */
         CLC   SSOBRETN(4),@CF00472                             02S0164
         BNE   @RF00164                                         02S0164
*      ERRCODE = RCDESTND;             /*SET INVALID ERROR CODE      */
         L     @10,@PC00001+4                                   02S0165
         MVC   ERRCODE(2,@10),@CH01998                          02S0165
*    ELSE                              /*NOT INVALID DESTINATION     */
*      IF SSOBRETN ^= SSUSRTOK |       /*IF OTHER ERROR FROM SUBSYS. */
*         R15 ^= SSRTOK THEN           /*OR ANY ERROR FROM INTERFACE */
         B     @RC00164                                         02S0166
@RF00164 SLR   @14,@14                                          02S0166
         C     @14,SSOBRETN                                     02S0166
         BNE   @RT00166                                         02S0166
         CR    R15,@14                                          02S0166
         BE    @RF00166                                         02S0166
@RT00166 DS    0H                                               02S0167
*        ERRCODE = RCSSDSER;           /*UNABLE TO PROCESS REQ. ERROR*/
         L     @10,@PC00001+4                                   02S0167
         MVC   ERRCODE(2,@10),@CH02004                          02S0167
*      ELSE;                           /*OVERRIDING DEST IS VALID    */
@RF00166 DS    0H                                               02S0169
*    END;                              /*END SYSOUT DEST VERIFY      */
@RC00164 DS    0H                                               02S0170
*IF ERRCODE = 0 THEN                   /*IF NO VALIDITY ERROR        */
@RF00151 SLR   @10,@10                                          01S0170
         L     @15,@PC00001+4                                   01S0170
         CH    @10,ERRCODE(,@15)                                01S0170
         BNE   @RF00170                                         01S0170
*  DO;                                 /*CONTINUE PROCESSING         */
*    DSABPTR = 0;                      /*INIT SEARCH RTNS. RETURN PTR*/
         ST    @10,DSABPTR                                      01S0172
*    DSABCNT = 0;                      /*INIT GETMAIN DSAB CNT       */
         LR    DSABCNT,@10                                      01S0173
*    UNALCNT = 0;                      /*INIT COUNT OF UNALLOC DSABS */
         ST    @10,UNALCNT                                      01S0174
*    RIUCNT = 0;                       /*INIT COUNT OF RIU DSABS     */
         ST    @10,RIUCNT                                       01S0175
*    RFY TEXTUNIT BASED(DSNAMTUP);     /*RESET TEXT UNIT BASE        */
*                                                               01S0176
*    IF DSNAMTUP ^= 0  &               /*IF DSN WAS SPECIFIED        */
*       TEXTUPAR(1:2) =  '&&' THEN     /*AND BEGINS WITH &&          */
         L     @05,DSNAMTUP                                     01S0177
         CR    @05,@10                                          01S0177
         BE    @RF00177                                         01S0177
         CLC   TEXTUPAR(2,@05),@CC02164                         01S0177
         BNE   @RF00177                                         01S0177
*      DO;                             /*STRIP OFF 1ST AMPERSAND     */
*        AMPDSNTU(1:4) = TEXTUNIT(1:4); /*COPY TEXT KEY-NUMBER FIELDS*/
         MVC   AMPDSNTU(4),TEXTUNIT(@05)                        01S0179
*        AMPDSNLN = TEXTULNG-1;        /*COPY LENGTH LESS ONE        */
         ICM   @10,12,TEXTULNG(@05)                             01S0180
         SRA   @10,16                                           01S0180
         BCTR  @10,0                                            01S0180
         STCM  @10,3,AMPDSNLN                                   01S0180
*        AMPDSNPM(1:AMPDSNLN) = TEXTUPAR(2:TEXTULNG);           01S0181
         BCTR  @10,0                                            01S0181
         EX    @10,@SM02190                                     01S0181
*                                      /*COPY DSN WITH 1 AMPERSAND   */
*        DSNAMTUP = ADDR(AMPDSNTU);    /*PUT DUMMY TUP INTO KEY TABLE*/
         LA    @10,AMPDSNTU                                     01S0182
         ST    @10,DSNAMTUP                                     01S0182
*      END;                            /*END &&DSN PROCESS           */
*                                                               01S0183
*    IF DDNAMTUP ^= 0 THEN             /*IF DDNAME WAS SPECIFIED     */
@RF00177 L     @10,DDNAMTUP                                     01S0184
         LTR   @10,@10                                          01S0184
         BZ    @RF00184                                         01S0184
*      DO;                             /*SEARCH FOR SPEC'D DDN       */
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - DDNPRCSS                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - DDNAME PROCESS                                */
*/*                                                                  */
*/* FUNCTION  - BUILD DSAB PTR LIST FOR DYNAMIC UNALLOCATION         */
*/*             REQUESTS VIA DDNAME                                  */
*/*                                                                  */
*/* OPERATION - THE DDNAME SEARCH RTN (IEFDB4FC) IS INVOKED TO SEARCH*/
*/*             FOR THE DSAB ASSOCIATED WITH THE SPECIFIED DDNAME.   */
*/*             IF IT IS NOT FOUND, A CODE OF RCDDNFND IS PLACED IN  */
*/*             ERRCODE. IF THE DSAB IS FOUND, CHECKS ARE MADE TO    */
*/*             ENSURE THAT IF DSN AND MEMBER NAME WERE ALSO         */
*/*             SPECIFIED, THEY MATCH THAT OF THE RETURNED DSAB, AND */
*/*             THAT THE DSAB IS NOT FOR A QNAME OR FOR A TERMINAL.  */
*/*             OTHERWISE, ERRCODE IS SET TO RCNOUNAL. IF            */
*/*             THE RETURNED DSAB IS CORRECT, IT IS DETERMINED       */
*/*             WHETHER THE DSAB IS FOR UNALLOCATION OR FOR REMOVE   */
*/*             IN-USE PROCESSING AS FOLLOWS:                        */
*/*                                                                  */
*/*           . IF THE UNALLOC OPTION WAS SPECIFIED, THE DSAB        */
*/*             IS FOR UNALLOCATION                                  */
*/*           . IF THE REMOVE IN-USE OPTION WAS SPECIFIED BUT THE    */
*/*             DATA SET IS NOT PERMANENTLY ALLOCATED, HAS A         */
*/*             NON-&DSN, AND HAS A DISP OF DELETE, THE DSAB         */
*/*             IS FOR UNALLOCATION.                                 */
*/*           . IF NEITHER OPTION WAS SPECIFIED AND THE DATA SET     */
*/*             IS NOT PERMANENTLY ALLOCATED, THE DSAB IS FOR        */
*/*             UNALLOCATION.                                        */
*/*           . OTHERWISE, THE DSAB IS FOR REMOVE IN-USE (IF THE     */
*/*             DSAB IS ALREADY NOT IN-USE OR FOR A PRIVATE          */
*/*             CATALOG, REMOVE IN-USE PROCESSING WILL BE            */
*/*             BYPASSED)                                            */
*/*                                                                  */
*/*             THE ADDRESS OF THE DSAB IS THEN PLACED IN THE        */
*/*             APPROPRIATE LIST AND THE CORRESPONDING COUNT IS      */
*/*             SET TO ONE  (ONLY ONE DSAB WILL BE IN THE LIST FOR   */
*/*             A REQUEST VIA DDNAME.)                               */
*/*                                                                  */
*/* ENTRY -                                                          */
*/*   INPUT DATA - DSQFRSTP - PTR TO FIRST DSAB ON CHAIN             */
*/*                DSABPTR  - PTR TO DSAB TO BE PROCESSED            */
*/*                           (ZERO ON ENTRY)                        */
*/*                ERRCODE  - ERROR CODE FIELD - ZERO ON ENTRY       */
*/*                UNALKEYT - KEY TABLE OF TEXT UNIT PTRS            */
*/*                DSNWORK  - WORK AREA FOR DSN AND MEMBER           */
*/*                           NAME COMPARES                          */
*/*                                                                  */
*/* EXIT -                                                           */
*/*   OUTPUT DATA - UNALSTP - POINTS TO DSABPTR IF FOR UNALLOC       */
*/*                 UNALCNT - SET TO 1 IF DSAB IS FOR UNALLOC        */
*/*                 RIULSTP - POINTS TO DSABPTR IF FOR REMOVE IN-USE */
*/*                 RIUCNT  - SET TO 1 IF DSAB IS FOR REMOVE IN-USE  */
*/*                 ERRCODE - SET TO RCDDNFND IF A DSAB WITH THE     */
*/*                           SPECIFIED DDN IS NOT FOUND             */
*/*                         - SET TO RCNOUNAL IF A SPECIFIED DSN OR  */
*/*                           MEMBER NAME IS NOT ASSOCIATED WITH THE */
*/*                           SPECIFIED DDN; OR IF THE DDN WITH A    */
*/*                           SPECIFIED DSN IS FOR A QNAME OR A      */
*/*                           TERMINAL.                              */
*/*                                                                  */
*/********************************************************************/
*RFY TEXTUNIT BASED(DDNAMTUP);         /*RESET TEXT UNIT BASE        */
*DDNWORK = '';                         /*BLANK OUT WORK AREA         */
         MVI   DDNWORK,C' '                                     02S0187
         MVC   DDNWORK+1(7),DDNWORK                             02S0187
*DDNWORK(1:TEXTULNG) = TEXTUPAR(1:TEXTULNG); /*COPY DDN INTO W/A     */
         ICM   @05,12,TEXTULNG(@10)                             02S0188
         SRA   @05,16                                           02S0188
         BCTR  @05,0                                            02S0188
         EX    @05,@SM02192                                     02S0188
*CALL IEFDB4FC(DSQFRSTP,ADDR(DDNWORK),ADDR(DSABPTR));           02S0189
         L     @10,@PC00001+8                                   02S0189
         L     @10,JSCBPTR(,@10)                                02S0189
         L     @10,JSCDSABQ(,@10)                               02S0189
         LA    @10,DSQFRSTP(,@10)                               02S0189
         ST    @10,@AL00001                                     02S0189
         LA    @10,DDNWORK                                      02S0189
         ST    @10,@TF00001                                     02S0189
         LA    @10,@TF00001                                     02S0189
         ST    @10,@AL00001+4                                   02S0189
         LA    @10,DSABPTR                                      02S0189
         ST    @10,@TF00002                                     02S0189
         LA    @10,@TF00002                                     02S0189
         ST    @10,@AL00001+8                                   02S0189
         L     @15,@CV00103                                     02S0189
         LA    @01,@AL00001                                     02S0189
         BALR  @14,@15                                          02S0189
*                                      /*CALL DDNAME SEARCH RTN      */
*IF DSABPTR = 0 THEN                   /*IF SPEC'D DDN WAS NOT FOUND */
         L     @10,DSABPTR                                      02S0190
         LTR   @10,@10                                          02S0190
         BNZ   @RF00190                                         02S0190
*  ERRCODE = RCDDNFND;                 /*DDNAME NOT FOUND ERROR      */
         L     @10,@PC00001+4                                   02S0191
         MVC   ERRCODE(2,@10),@CH01972                          02S0191
*ELSE                                  /*DDNAME WAS FOUND            */
*  DO;                                 /*CONTINUE PROCESSING         */
*                                                               02S0192
         B     @RC00190                                         02S0192
@RF00190 DS    0H                                               02S0193
*    IF DSNAMTUP ^= 0 THEN             /*IF DSNAME WAS ALSO SPEC'D   */
         L     @10,DSNAMTUP                                     02S0193
         LTR   @10,@10                                          02S0193
         BZ    @RF00193                                         02S0193
*      DO;                             /*CHECK IF SPEC'D DSN MATCHES
*                                        DSN ASSOCIATED WITH DDN     */
*        DSNWORK = '';                 /*BLANK OUT WORK AREA         */
         MVI   DSNWORK,C' '                                     02S0195
         MVC   DSNWORK+1(43),DSNWORK                            02S0195
*        RFY TEXTUNIT BASED(DSNAMTUP); /*RESET TEXT UNIT BASE        */
*        DSNWORK(1:TEXTULNG)=TEXTUPAR(1:TEXTULNG);              02S0197
         ICM   @05,12,TEXTULNG(@10)                             02S0197
         SRA   @05,16                                           02S0197
         BCTR  @05,0                                            02S0197
         EX    @05,@SM02194                                     02S0197
*                                      /*COPY SPEC'D DSN INTO W/A    */
*        IF DSNWORK ^= JFCBDSNM THEN   /*IF DSNAMES DON'T MATCH      */
         L     @10,DSABPTR                                      02S0198
         L     @10,DSABSIOT(,@10)                               02S0198
         L     @05,SJFCBPTR(,@10)                               02S0198
         CLC   DSNWORK(44),JFCBDSNM(@05)                        02S0198
         BE    @RF00198                                         02S0198
*          IF SIOALIAS = '0'B |        /*NO ALIAS DSNAME     @YM03581*/
*             DSNWORK ^= JFCBXNAM THEN /*OR ALIAS NAME PRESENT  02S0199
*                                        AND NO MATCH        @YM03581*/
         TM    SIOALIAS(@10),B'10000000'                        02S0199
         BZ    @RT00199                                         02S0199
         L     @10,SIOTJFX(,@10)                                02S0199
         CLC   DSNWORK(44),JFCBXNAM(@10)                        02S0199
         BE    @RF00199                                         02S0199
@RT00199 DS    0H                                               02S0200
*            IF DSABANMP ^= 0 THEN     /*ALTERNATE DSNAME ?  @YM03581*/
         L     @10,DSABPTR                                      02S0200
         L     @10,DSABANMP(,@10)                               02S0200
         LTR   @10,@10                                          02S0200
         BZ    @RF00200                                         02S0200
*              DO;                     /*YES, TEST FOR MATCH @YM03581*/
*                DSNWORK = '';         /*BLANK OUT WORK AREA @YM03581*/
         MVI   DSNWORK,C' '                                     02S0202
         MVC   DSNWORK+1(43),DSNWORK                            02S0202
*                DSNWORK(1:DSABANML) = DSABANAM(1:DSABANML);    02S0203
         SLR   @05,@05                                          02S0203
         IC    @05,DSABANML(,@10)                               02S0203
         LR    @15,@05                                          02S0203
         BCTR  @15,0                                            02S0203
         EX    @15,@SM02196                                     02S0203
*                                      /*COPY ALT DSNAME     @YM03581*/
*                IF DSABANML > TEXTULNG | /*ALT DSN LEN > SPEC'D
*                                           DSN LEN          @YM03581*/
*                   DSNWORK(1:TEXTULNG) ^= TEXTUPAR(1:TEXTULNG) THEN
         L     @10,DSNAMTUP                                     02S0204
         ICM   @15,12,TEXTULNG(@10)                             02S0204
         SRA   @15,16                                           02S0204
         CR    @05,@15                                          02S0204
         BH    @RT00204                                         02S0204
         BCTR  @15,0                                            02S0204
         EX    @15,@SC02198                                     02S0204
         BE    @RF00204                                         02S0204
@RT00204 DS    0H                                               02S0205
*                                      /*DO DSNAMES MATCH ?  @YM03581*/
*                  ERRCODE = RCNOUNAL; /*NO, SET ERROR CODE  @YM03581*/
         L     @10,@PC00001+4                                   02S0205
         MVC   ERRCODE(2,@10),@CH01992                          02S0205
*                ELSE;                 /*NAMES MATCH         @YM03581*/
@RF00204 DS    0H                                               02S0207
*              END;                    /*END ALT NAME TEST   @YM03581*/
*            ELSE                      /*NO ALT OR ALIAS DSNAME 02S0208
*                                        MATCH               @YM03581*/
*              ERRCODE = RCNOUNAL;     /*SET ERROR CODE      @YM03581*/
         B     @RC00200                                         02S0208
@RF00200 L     @10,@PC00001+4                                   02S0208
         MVC   ERRCODE(2,@10),@CH01992                          02S0208
*          ELSE;                       /*ALIAS MATCH FOUND   @YM03581*/
@RF00199 DS    0H                                               02S0210
*        ELSE                          /*MATCH IS MADE ON JFCBDSNM   */
*          IF SIOTQNAM = '1'B  |       /*IF DSAB IS FOR QNAME        */
*             SIOTTERM = '1'B THEN     /*OR A TERMINAL               */
         B     @RC00198                                         02S0210
@RF00198 L     @10,DSABPTR                                      02S0210
         L     @10,DSABSIOT(,@10)                               02S0210
         TM    SIOTQNAM(@10),B'01000001'                        02S0210
         BZ    @RF00210                                         02S0210
*            ERRCODE = RCNOUNAL;       /*SET ERROR RETURN            */
         L     @10,@PC00001+4                                   02S0211
         MVC   ERRCODE(2,@10),@CH01992                          02S0211
*          ELSE;                       /*DSAB IS VALID               */
@RF00210 DS    0H                                               02S0213
*        IF (ERRCODE = 0  &            /*IF NO ERROR AND             */
*            MEMBRTUP ^= 0) THEN       /*MEMBER WAS SPECIFIED        */
@RC00198 SLR   @10,@10                                          02S0213
         L     @05,@PC00001+4                                   02S0213
         CH    @10,ERRCODE(,@05)                                02S0213
         BNE   @RF00213                                         02S0213
         L     @15,MEMBRTUP                                     02S0213
         CR    @15,@10                                          02S0213
         BE    @RF00213                                         02S0213
*         DO;                          /*COMPARE MEMBER NAMES        */
*            DSNWORK(1:8) = '';        /*BLANK OUT 8 BYTES OF W/A    */
         MVI   DSNWORK,C' '                                     02S0215
         MVC   DSNWORK+1(7),DSNWORK                             02S0215
*            RFY TEXTUNIT BASED (MEMBRTUP); /*RESET TEXTUNIT BASE    */
*            DSNWORK(1:TEXTULNG)=TEXTUPAR(1:TEXTULNG);          02S0217
         ICM   @10,12,TEXTULNG(@15)                             02S0217
         SRA   @10,16                                           02S0217
         BCTR  @10,0                                            02S0217
         EX    @10,@SM02200                                     02S0217
*                                      /*COPY MEMBER NAME INTO W/A   */
*            IF DSNWORK(1:8)^= JFCBELNM THEN /*IF NO MATCH FOR MEMBER*/
         L     @10,DSABPTR                                      02S0218
         L     @10,DSABSIOT(,@10)                               02S0218
         L     @10,SJFCBPTR(,@10)                               02S0218
         CLC   DSNWORK(8),JFCBELNM(@10)                         02S0218
         BE    @RF00218                                         02S0218
*              ERRCODE = RCNOUNAL;     /*SET ERROR RETURN            */
         MVC   ERRCODE(2,@05),@CH01992                          02S0219
*            ELSE;                     /*MEMBER NAMES MATCH          */
@RF00218 DS    0H                                               02S0221
*         END;                         /*END MEMBER NAME CHECK       */
*        ELSE;                         /*DSN ERROR OR NO MEMBER NAME */
@RF00213 DS    0H                                               02S0223
*      END;                            /*END IF DSN WAS SPEC'D,      */
*    ELSE;                             /*DSN NOT SPECIFIED           */
*                                                               02S0224
@RF00193 DS    0H                                               02S0225
*    IF ERRCODE = 0 THEN               /*IF NO ERROR ENCOUNTERED     */
         SLR   @10,@10                                          02S0225
         L     @05,@PC00001+4                                   02S0225
         CH    @10,ERRCODE(,@05)                                02S0225
         BNE   @RF00225                                         02S0225
*      DO;                             /*CONTINUE PROCESSING         */
*        DSABLST1 = DSABPTR;           /*PUT DSAB ADDR IN A LIST     */
         L     @05,DSABPTR                                      02S0227
         ST    @05,DSABLST1                                     02S0227
*        IF(UNAOPTUP ^= 0          |   /*IF UNALLOC OPTION WAS SPEC'D*/
*                                                               02S0228
*           (RIUOPTUP = 0 &            /*OR NEITHER UNALLOC OR REMOVE
*                                        IN-USE OPTIONS WERE SPEC'D &*/
*            DSABPALC = '0'B)      |   /*THE D.S. IS NON PERM ALLOC.,*/
*                                                               02S0228
*           (RIUOPTUP ^= 0 &           /*OR REMOVE IN-USE WAS SPEC'D */
*            DSABPALC = '0'B &         /*AND D.S. IS NON PERM ALLOC &*/
*            (DSABANMP = 0 |           /*THERE IS NO ALTERNATE NAME  */
*             DSABANAM(1) ^= '&') &    /*OR THERE IS BUT NON & AND   */
*            SIOTDLET = '1'B))   THEN  /*THE DS HAS A DISP OF DELETE */
*                                                               02S0228
         C     @10,UNAOPTUP                                     02S0228
         BNE   @RT00228                                         02S0228
         C     @10,RIUOPTUP                                     02S0228
         BNE   @GL00028                                         02S0228
         TM    DSABPALC(@05),B'01000000'                        02S0228
         BZ    @RT00228                                         02S0228
@GL00028 SLR   @10,@10                                          02S0228
         C     @10,RIUOPTUP                                     02S0228
         BE    @RF00228                                         02S0228
         L     @05,DSABPTR                                      02S0228
         TM    DSABPALC(@05),B'01000000'                        02S0228
         BNZ   @RF00228                                         02S0228
         L     @05,DSABANMP(,@05)                               02S0228
         CR    @05,@10                                          02S0228
         BE    @GL00031                                         02S0228
         CLI   DSABANAM(@05),C'&&'                              02S0228
         BE    @RF00228                                         02S0228
@GL00031 L     @10,DSABPTR                                      02S0228
         L     @10,DSABSIOT(,@10)                               02S0228
         TM    SIOTDLET(@10),B'00000100'                        02S0228
         BNO   @RF00228                                         02S0228
@RT00228 DS    0H                                               02S0229
*          DO;                         /*THEN DSAB IS FOR UNALLOC.   */
*            UNALSTP = ADDR(DSABLST1); /*POINT LIST PTR TO LIST DSAB */
         LA    @10,DSABLST1                                     02S0230
         ST    @10,UNALSTP                                      02S0230
*            UNALCNT = 1;              /*SET UNALLOC LIST COUNT TO 1 */
         MVC   UNALCNT(4),@CF00230                              02S0231
*          END;                        /*END IF FOR UNALLOCATION     */
*        ELSE                          /*DSAB IS FOR REMOVE IN-USE   */
*          IF (DSABNUSE = '1'B   &     /*IF DSAB IS IN-USE AND       */
*              DSABCATL = '0'B) THEN   /*NOT FOR A PRIVATE CATALOG   */
         B     @RC00228                                         02S0233
@RF00228 L     @10,DSABPTR                                      02S0233
         TM    DSABNUSE(@10),B'00000001'                        02S0233
         BNO   @RF00233                                         02S0233
         TM    DSABCATL(@10),B'00001000'                        02S0233
         BNZ   @RF00233                                         02S0233
*            DO;                       /*SET IT UP FOR REMOVE IN-USE */
*              RIULSTP = ADDR(DSABLST1);/*POINT LIST PTR TO LIST DSAB*/
         LA    @10,DSABLST1                                     02S0235
         ST    @10,RIULSTP                                      02S0235
*              RIUCNT = 1;             /*SET R-I-U COUNT TO 1        */
         MVC   RIUCNT(4),@CF00230                               02S0236
*            END;                      /*END IF FOR REMOVE IN-USE    */
*          ELSE;                       /*DSAB NOT IN-USE OR A CATLG  */
@RF00233 DS    0H                                               02S0239
*      END;                            /*END  NO DSN ERROR           */
*    ELSE;                             /*ERROR IN DSN CHECK          */
@RF00225 DS    0H                                               02S0241
*  END;                                /*END IF DDN WAS FOUND        */
*      END;                            /*END OF REQUEST VIA DDNAME   */
*    ELSE                              /*DDN NOT SPECIFIED;DSN WAS   */
*      DO;                             /*SEARCH FOR SPEC'D DSN       */
         B     @RC00184                                         01S0243
@RF00184 DS    0H                                               01S0244
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - DSNPRCSS                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - DSNAME PROCESS                                */
*/*                                                                  */
*/* FUNCTION  - BUILD LIST OF DSAB PTRS FOR DYNAMIC UNALLOCATION     */
*/*             REQUESTS VIA DSNAME                                  */
*/*                                                                  */
*/* OPERATION - THE DSNAME SEARCH RTN (IEFDB4FA) IS INVOKED TO       */
*/*             SEARCH DOWN FROM THE TOP OF THE DSAB CHAIN FOR AN    */
*/*             ALLOCATION OF THE SPECIFIED DSN. (A BIT IS SET       */
*/*             SAYING LOOK AT BOTH DSAB ALTERNATE NAME AND          */
*/*             JFCBDSNM FIELDS IN THE SEARCH.) IF MEMBER NAME WAS   */
*/*             SPECIFIED, THE DSAB RETURNED IS CHECKED TO SEE IF    */
*/*             IT ALSO CORRESPONDS TO THE SPECIFIED MEMBER NAME.    */
*/*             IF IT DOES, OR IF MEMBER NAME WAS NOT SPECIFIED,     */
*/*             THE DSAB IS ELIGIBLE FOR PROCESSING AND DSABCNT      */
*/*             IS INCREMENTED BY ONE. THE ABOVE PROCESS IS THEN     */
*/*             REPEATED, STARTING THE SEARCH FROM THE DSAB IN THE   */
*/*             CHAIN AFTER THE ONE THAT WAS RETURNED (OR, IF THE    */
*/*             DSAB WAS PERMANENTLY CONCATENATED, AFTER THE END     */
*/*             OF THE PCAT GROUP), UNTIL ALL DSABS HAVE BEEN LOOKED */
*/*             AT, AND DSABCNT HAS THE TOTAL NUMBER OF DSABS        */
*/*             ELIGIBLE FOR PROCESSING.                             */
*/*                                                                  */
*/*             IF THERE ARE NO DSABS ELIGIBLE, AN ERRCODE OF        */
*/*             RCDSNFND IS SET AND NO FURTHER PROCESSING IS DONE.   */
*/*             OTHERWISE, A GETMAIN IS ISSUED FOR CORE FOR A LIST   */
*/*             OF PTRS TO DSABS TO BE PROCESSED (NO GETMAIN IS      */
*/*             NEEDED IF ONLY ONE DSAB WILL BE IN THE LIST), AND    */
*/*             THE ABOVE ELIGIBLE DSAB DETERMINATION IS REPEATED.   */
*/*             THIS TIME HOWEVER, THE DSABS ARE ALSO CHECKED NOT    */
*/*             TO BE ASSOCIATED WITH THE DDNAMES JOBCAT, STEPCAT,   */
*/*             JOBLIB OR STEPLIB. IF ONE IS, AN ERROR CODE          */
*/*             OF RCRSVDDN IS SET & THE DSAB ISN'T ELIGIBLE.        */
*/*             OTHERWISE THE ADDRESSES OF THE ELIGIBLE              */
*/*             DSABS ARE PLACED INTO EITHER THE LIST FOR UN-        */
*/*             ALLOCATION(BUILT DOWN FROM THE TOP OF THE GETMAIN'D  */
*/*             CORE) OR THE LIST FOR REMOVE IN-USE (BUILT UP FROM   */
*/*             THE BOTTOM OF THE GETMAIN'D AREA). THE CORRESPONDING */
*/*             COUNTS OF DSABS IN EACH LIST ARE INCREMENTED         */
*/*             ACCORDINGLY. DETERMINATION OF WHICH LIST A DSAB PTR  */
*/*             GOES INTO IS AS FOLLOWS:                             */
*/*             - IF THE UNALLOC OPTION WAS SPECIFIED, THE DSAB      */
*/*               IS FOR UNALLOCATION                                */
*/*             - IF THE REMOVE IN-USE OPTION WAS SPECIFIED BUT THE  */
*/*               DATA SET IS NON-PERMANENTLY ALLOCATED, HAS A       */
*/*               NON-&DSN, AND HAS A DISP OF DELETE, THE DSAB       */
*/*               IS FOR UNALLOCATION                                */
*/*             - IF NEITHER OPTION WAS SPECIFIED AND THE DATA SET   */
*/*               IS NOT PERMANENTLY ALLOCATED, THE DSAB IS FOR      */
*/*               UNALLOCATION.                                      */
*/*             - OTHERWISE, THE DSAB IS FOR REMOVE IN-USE. (IF THE  */
*/*               DSAB IS ALREADY NOT IN-USE, OR IS FOR A PRIVATE    */
*/*               CATALOG, REMOVE IN-USE PROCESSING WILL BE BYPASSED)*/
*/*               NOTE THAT IF THE DSAB IS A MEMBER OF A CONCATENATED*/
*/*               GROUP, A PTR TO THE FIRST DSAB IN THE GROUP WILL BE*/
*/*               THE ONE PLACED IN THE LIST, CAUSING REMOVE IN-USE  */
*/*               PROCESSING TO BE DONE FOR ALL MEMBERS.             */
*/*                                                                  */
*/* ENTRY -                                                          */
*/*   INPUT DATA - DSQFRSTP - PTR TO FIRST DSAB ON CHAIN             */
*/*                DSABPTR  - ADDR OF DSAB RETURNED FROM SEARCH RTN  */
*/*                           (ZERO ON ENTRY)                        */
*/*                DSABCNT  - COUNT OF DSABPTRS FOR GETMAIN          */
*/*                           (ZERO ON ENTRY)                        */
*/*                ERRCODE  - ERROR CODE FIELD - ZERO ON ENTRY       */
*/*                UNALKEYT - KEY TABLE OF TEXT UNIT PTRS            */
*/*                                                                  */
*/* EXIT -                                                           */
*/*   OUTPUT DATA - UNALSTP - POINTS TO DSAB PTR LIST FOR UNALLOC    */
*/*                 UNALCNT - COUNT OF DSABS FOR UNALLOC             */
*/*                 RIULSTP - POINTS TO DSAB PTR LIST FOR REMOVE     */
*/*                           IN-USE                                 */
*/*                 RIUCNT  - COUNT OF DSABS FOR REMOVE IN-USE       */
*/*                 ERRCODE - SET TO RCDSNFND IF THERE ARE NO        */
*/*                           DSABS TO PROCESS                       */
*/*                         - SET TO RCRSVDDN IF A DSAB FOUND IS PART*/
*/*                           OF A JOBLIB, STEPLIB, JOBCAT OR STEPCAT*/
*/*                           DDNAME                                 */
*/*                                                                  */
*/********************************************************************/
*RFY TEXTUNIT BASED(DSNAMTUP);         /*RESET TEXT UNIT BASE        */
*DSNPRCSW = DSNPRCSW && DSNPRCSW;      /*ZERO OUT CONTROL SWITCHES   */
         XC    DSNPRCSW(1),DSNPRCSW                             02S0245
*STARTPTR = DSQFRSTP;                  /*START FROM 1ST DSAB ON CHAIN*/
         L     @10,@PC00001+8                                   02S0246
         L     @10,JSCBPTR(,@10)                                02S0246
         L     @10,JSCDSABQ(,@10)                               02S0246
         L     @10,DSQFRSTP(,@10)                               02S0246
         ST    @10,STARTPTR                                     02S0246
*DSNSCHMP = DSNSCHMP && DSNSCHMP;      /*ZERO OUT DSN SEARCH FN. MAP */
         XC    DSNSCHMP(2),DSNSCHMP                             02S0247
*JFCBALNM = '1'B;                      /*CHECK JFCB & ALT. NAME FIELD*/
*                                                               02S0248
         OI    JFCBALNM,B'00100000'                             02S0248
*DO WHILE OUT = '0'B;                  /*LOOP DSAB SEARCH BY DSN     */
         B     @DE00249                                         02S0249
@DL00249 DS    0H                                               02S0250
*  CALL IEFDB4FA(STARTPTR,ADDR(TEXTUENT),DSABPTR,DSNSCHMP);     02S0250
         LA    @10,STARTPTR                                     02S0250
         ST    @10,@AL00001                                     02S0250
         L     @10,DSNAMTUP                                     02S0250
         LA    @10,TEXTUENT(,@10)                               02S0250
         ST    @10,@TF00001                                     02S0250
         LA    @10,@TF00001                                     02S0250
         ST    @10,@AL00001+4                                   02S0250
         LA    @10,DSABPTR                                      02S0250
         ST    @10,@AL00001+8                                   02S0250
         LA    @10,DSNSCHMP                                     02S0250
         ST    @10,@AL00001+12                                  02S0250
         L     @15,@CV00104                                     02S0250
         LA    @01,@AL00001                                     02S0250
         BALR  @14,@15                                          02S0250
*                                      /*CALL DSN SEARCH RTN         */
*  IF DSABPTR = 0 THEN                 /*IF NO DSAB FOR DSN WAS FOUND*/
         L     @10,DSABPTR                                      02S0251
         LTR   @10,@10                                          02S0251
         BNZ   @RF00251                                         02S0251
*    OUT = '1'B;                       /*GET OUT OF SEARCH LOOP      */
         OI    OUT,B'10000000'                                  02S0252
*  ELSE                                /*DSAB FOR SPECD DSN WAS FOUND*/
*    DO;                               /*CONTINUE PROCESSING         */
*                                                               02S0253
         B     @RC00251                                         02S0253
@RF00251 DS    0H                                               02S0254
*      IF MEMBRTUP ^= 0 THEN           /*IF MEMBER NAME WAS SPEC'D   */
         L     @10,MEMBRTUP                                     02S0254
         LTR   @10,@10                                          02S0254
         BZ    @RF00254                                         02S0254
*        DO;                           /*CHECK FOR MATCH WITH DSAB'S */
*          DSNWORK(1:8) = '';          /*BLANK OUT 8 BYTES IN W/A    */
         MVI   DSNWORK,C' '                                     02S0256
         MVC   DSNWORK+1(7),DSNWORK                             02S0256
*          RFY TEXTUNIT BASED(MEMBRTUP); /*RESET TEXT UNIT BASE      */
*          DSNWORK(1:TEXTULNG) = TEXTUPAR(1:TEXTULNG);          02S0258
         ICM   @05,12,TEXTULNG(@10)                             02S0258
         SRA   @05,16                                           02S0258
         BCTR  @05,0                                            02S0258
         EX    @05,@SM02194                                     02S0258
*                                      /*COPY MEMBER NAME INTO W/A   */
*          IF DSNWORK(1:8) = JFCBELNM THEN /*IF MEMBER NAMES MATCH   */
         L     @10,DSABPTR                                      02S0259
         L     @05,DSABSIOT(,@10)                               02S0259
         L     @05,SJFCBPTR(,@05)                               02S0259
         CLC   DSNWORK(8),JFCBELNM(@05)                         02S0259
         BNE   @RF00259                                         02S0259
*            DO;                       /*ADJUST DSABPTR AND COUNT    */
*              DSABCNT = DSABCNT + 1;  /*INCREMENT COUNT OF DSABS    */
         AL    DSABCNT,@CF00230                                 02S0261
*              IF DSABPCAT = '1'B THEN /*IF DSAB IS PERM CONCAT      */
         TM    DSABPCAT(@10),B'00000100'                        02S0262
         BNO   @RF00262                                         02S0262
*                DO WHILE (DSABFCHN ^= 0 & /*SKIP TO END OF CHAIN OR */
*                   DSABFCHN->DSABSIOT->SCTDDNAM(1)=' ');       02S0263
         B     @DE00263                                         02S0263
@DL00263 DS    0H                                               02S0264
*                                      /*TO END OF PERM CONCAT GROUP */
*                  DSABPTR = DSABFCHN; /*POINT TO NEXT DSAB          */
         L     @10,DSABPTR                                      02S0264
         L     @10,DSABFCHN(,@10)                               02S0264
         ST    @10,DSABPTR                                      02S0264
*                END;                  /*END IF PERM CONCAT          */
@DE00263 L     @10,DSABPTR                                      02S0265
         L     @10,DSABFCHN(,@10)                               02S0265
         LTR   @10,@10                                          02S0265
         BZ    @DC00263                                         02S0265
         L     @10,DSABSIOT(,@10)                               02S0265
         CLI   SCTDDNAM(@10),C' '                               02S0265
         BE    @DL00263                                         02S0265
@DC00263 DS    0H                                               02S0266
*            END;                      /*END IF MEMBER MATCH         */
*          ELSE;                       /*NO MATCH; DSAB NOT ELIGIBLE */
@RF00259 DS    0H                                               02S0268
*        END;                          /*END MEMBER NAME PROCESS     */
*                                                               02S0268
*      ELSE                            /*MEMBER NAME NOT SPEC'D      */
*        DO;                           /*ADJUST DSABPTR AND COUNT    */
         B     @RC00254                                         02S0269
@RF00254 DS    0H                                               02S0270
*          DSABCNT = DSABCNT + 1;      /*INCREMENT COUNT OF DSABS    */
         AL    DSABCNT,@CF00230                                 02S0270
*          IF DSABPCAT = '1'B THEN     /*IF DSAB IS PERM CONCAT      */
         L     @10,DSABPTR                                      02S0271
         TM    DSABPCAT(@10),B'00000100'                        02S0271
         BNO   @RF00271                                         02S0271
*            DO WHILE (DSABFCHN ^= 0 & /*SKIP TO END OF CHAIN OR     */
*               DSABFCHN->DSABSIOT->SCTDDNAM(1)=' ');           02S0272
         B     @DE00272                                         02S0272
@DL00272 DS    0H                                               02S0273
*                                      /*TO END OF PERM CONCAT GROUP */
*              DSABPTR = DSABFCHN;     /*POINT TO NEXT DSAB          */
         L     @10,DSABPTR                                      02S0273
         L     @10,DSABFCHN(,@10)                               02S0273
         ST    @10,DSABPTR                                      02S0273
*            END;                      /*END IF PERM CONCAT          */
@DE00272 L     @10,DSABPTR                                      02S0274
         L     @10,DSABFCHN(,@10)                               02S0274
         LTR   @10,@10                                          02S0274
         BZ    @DC00272                                         02S0274
         L     @10,DSABSIOT(,@10)                               02S0274
         CLI   SCTDDNAM(@10),C' '                               02S0274
         BE    @DL00272                                         02S0274
@DC00272 DS    0H                                               02S0275
*        END;                          /*END IF MEMBER NOT SPECIFIED */
*                                                               02S0275
@RF00271 DS    0H                                               02S0276
*      IF DSABFCHN ^= 0 THEN           /*IF NOT AT END OF DSAB CHAIN */
@RC00254 SLR   @10,@10                                          02S0276
         L     @05,DSABPTR                                      02S0276
         L     @05,DSABFCHN(,@05)                               02S0276
         CR    @05,@10                                          02S0276
         BE    @RF00276                                         02S0276
*        DO;                           /*THEN SET UP FOR NEXT CALL   */
*          STARTPTR = DSABFCHN;        /*START FROM NEXT DSAB        */
         ST    @05,STARTPTR                                     02S0278
*          DSABPTR = 0;                /*ZERO RETURN DSAB PTR        */
         ST    @10,DSABPTR                                      02S0279
*        END;                          /*END IF MORE DSABS TO SEARCH */
*      ELSE                            /*AT END OF DSAB CHAIN        */
*        OUT = '1'B;                   /*GET OUT OF SEARCH LOOP      */
         B     @RC00276                                         02S0281
@RF00276 OI    OUT,B'10000000'                                  02S0281
*    END;                              /*END IF DSAB OF DSN WAS FOUND*/
@RC00276 DS    0H                                               02S0283
*END;                                  /*END SEARCH LOOP             */
*                                                               02S0283
@RC00251 DS    0H                                               02S0283
@DE00249 TM    OUT,B'10000000'                                  02S0283
         BZ    @DL00249                                         02S0283
*IF DSABCNT = 0 THEN                   /*IF NO DSABS WERE FOUND      */
         LTR   DSABCNT,DSABCNT                                  02S0284
         BNZ   @RF00284                                         02S0284
*  ERRCODE = RCDSNFND;                 /*DSN NOT FOUND ERROR         */
*                                                               02S0285
         L     @10,@PC00001+4                                   02S0285
         MVC   ERRCODE(2,@10),@CH01976                          02S0285
*ELSE                                  /*DSABS WERE FOUND            */
*  DO;                                 /*CONTINUE PROCESSING         */
         B     @RC00284                                         02S0286
@RF00284 DS    0H                                               02S0287
*    RFY TEXTUNIT BASED(DSNAMTUP);     /*RESET TEXT UNIT BASE PTR    */
*    RFY (R0,R1) RSTD;                 /*RESTRICT REG. 0 AND REG 1   */
*    IF DSABCNT > 1 THEN               /*IF MORE THAN 1 DSAB THEN    */
         C     DSABCNT,@CF00230                                 02S0289
         BNH   @RF00289                                         02S0289
*      DO;                             /*NEED CORE FOR LIST          */
*        R0 = DSABCNT * 4;             /*CORE FOR DSAB PTR LIST      */
         LR    R0,DSABCNT                                       02S0291
         SLA   R0,2                                             02S0291
*        R0 = R0 | SUBPOOLN;           /*GET FROM CORRECT SUBPOOL    */
         O     R0,@CF00097                                      02S0292
*        GEN (GETMAIN R,LV=(0));       /*GET CORE NEEDED             */
         GETMAIN R,LV=(0)
*      END;                            /*END GETMAIN PROCESSING      */
*    ELSE                              /*NO GETMAIN NECESSARY        */
*      R1 = ADDR (DSABLST1);           /*USE WORK DSAB LIST OF 1 DSAB*/
         B     @RC00289                                         02S0295
@RF00289 LA    R1,DSABLST1                                      02S0295
*    UNALSTP = R1;                     /*UNALLOC DSABS AT TOP OF LIST*/
@RC00289 ST    R1,UNALSTP                                       02S0296
*    RIULSTP = R1 + DSABCNT * 4;       /*REMOVE IN-USE DSABS AT END  */
         LR    @10,DSABCNT                                      02S0297
         SLA   @10,2                                            02S0297
         ALR   @10,R1                                           02S0297
         ST    @10,RIULSTP                                      02S0297
*    RFY (R0,R1) UNRSTD;               /*RELEASE REGS 0 AND 1        */
*    STARTPTR = DSQFRSTP;              /*START FROM FIRST DSAB       */
         L     @10,@PC00001+8                                   02S0299
         L     @10,JSCBPTR(,@10)                                02S0299
         L     @10,JSCDSABQ(,@10)                               02S0299
         L     @10,DSQFRSTP(,@10)                               02S0299
         ST    @10,STARTPTR                                     02S0299
*    COUNT = DSABCNT;                  /*INIT LOOP CTL COUNT         */
*                                                               02S0300
         LR    COUNT,DSABCNT                                    02S0300
*    DO WHILE COUNT ^= 0;              /*LOOP TO BUILD DSAB PTR LIST */
         B     @DE00301                                         02S0301
@DL00301 DS    0H                                               02S0302
*      CALL IEFDB4FA(STARTPTR,ADDR(TEXTUENT),DSABPTR,DSNSCHMP); 02S0302
         LA    @10,STARTPTR                                     02S0302
         ST    @10,@AL00001                                     02S0302
         L     @10,DSNAMTUP                                     02S0302
         LA    @10,TEXTUENT(,@10)                               02S0302
         ST    @10,@TF00001                                     02S0302
         LA    @10,@TF00001                                     02S0302
         ST    @10,@AL00001+4                                   02S0302
         LA    @10,DSABPTR                                      02S0302
         ST    @10,@AL00001+8                                   02S0302
         LA    @10,DSNSCHMP                                     02S0302
         ST    @10,@AL00001+12                                  02S0302
         L     @15,@CV00104                                     02S0302
         LA    @01,@AL00001                                     02S0302
         BALR  @14,@15                                          02S0302
*                                      /*CALL DSN SEARCH RTN         */
*                                                               02S0303
*      IF MEMBRTUP ^= 0 THEN           /*IF MEMBER NAME WAS SPEC'D   */
         L     @10,MEMBRTUP                                     02S0303
         LTR   @10,@10                                          02S0303
         BZ    @RF00303                                         02S0303
*        DO;                           /*CHECK IF SAME AS DSAB'S     */
*          DSNWORK(1:8) = '';          /*BLANK OUT 8 BYTES IN W/A    */
         MVI   DSNWORK,C' '                                     02S0305
         MVC   DSNWORK+1(7),DSNWORK                             02S0305
*          RFY TEXTUNIT BASED(MEMBRTUP); /*RESET TEXT UNIT BASE      */
*          DSNWORK(1:TEXTULNG) = TEXTUPAR(1:TEXTULNG);          02S0307
         ICM   @15,12,TEXTULNG(@10)                             02S0307
         SRA   @15,16                                           02S0307
         BCTR  @15,0                                            02S0307
         EX    @15,@SM02194                                     02S0307
*                                      /*COPY MEMBER NAME TO W/A     */
*          IF DSNWORK(1:8) = JFCBELNM THEN /*IF MEMBER NAMES MATCH   */
         L     @10,DSABPTR                                      02S0308
         L     @10,DSABSIOT(,@10)                               02S0308
         L     @10,SJFCBPTR(,@10)                               02S0308
         CLC   DSNWORK(8),JFCBELNM(@10)                         02S0308
         BNE   @RF00308                                         02S0308
*            DSABFND = '1'B;           /*DSAB IS ELIGIBLE TO PROCESS */
         OI    DSABFND,B'01000000'                              02S0309
*          ELSE;                       /*NO MATCH;DSAB NOT ELIGIBLE  */
@RF00308 DS    0H                                               02S0311
*        END;                          /*END MEMBER NAME PROCESS     */
*      ELSE                            /*MEMBER NAME NOT SPEC'D      */
*        DSABFND = '1'B;               /*DSAB IS ELIGIBLE TO PROCESS */
*                                                               02S0312
         B     @RC00303                                         02S0312
@RF00303 OI    DSABFND,B'01000000'                              02S0312
*      IF DSABFND = '1'B THEN          /*IF DSAB IS ELIGIBLE         */
@RC00303 TM    DSABFND,B'01000000'                              02S0313
         BNO   @RF00313                                         02S0313
*        DO;                           /*THEN CONTINUE PROCESSING    */
*          RFY DSAB BASED(FRSTCATM);     /*RESET DSAB BASE           */
*          FRSTCATM = DSABPTR;         /*GET RETURNED DSAB ADDR      */
         L     FRSTCATM,DSABPTR                                 02S0316
*          DO WHILE TIOEDDNM(1) = ' '; /*GET 1ST DSAB IF IN CONCAT
*                                        GROUP                       */
         B     @DE00317                                         02S0317
@DL00317 DS    0H                                               02S0318
*            FRSTCATM = DSABBCHN;      /*POINT TO PREVIOUS DSAB      */
         L     FRSTCATM,DSABBCHN(,FRSTCATM)                     02S0318
*          END;                        /*END OF CONCAT GROUP LOOP    */
@DE00317 L     @10,DSABTIOT(,FRSTCATM)                          02S0319
         CLI   TIOEDDNM(@10),C' '                               02S0319
         BE    @DL00317                                         02S0319
*          IF TIOEDDNM(1:8) = 'JOBLIB  ' | /*IF DDN IS JOBLIB OR,    */
*             TIOEDDNM(1:8) = 'STEPLIB ' | /*STEPLIB OR,             */
*             TIOEDDNM(1:8) = 'JOBCAT  ' | /*JOBCAT OR,              */
*             TIOEDDNM(1:8) = 'STEPCAT ' THEN /*STEPCAT THEN         */
         CLC   TIOEDDNM(8,@10),@CC02141                         02S0320
         BE    @RT00320                                         02S0320
         CLC   TIOEDDNM(8,@10),@CC02143                         02S0320
         BE    @RT00320                                         02S0320
         CLC   TIOEDDNM(8,@10),@CC02142                         02S0320
         BE    @RT00320                                         02S0320
         CLC   TIOEDDNM(8,@10),@CC02144                         02S0320
         BNE   @RF00320                                         02S0320
@RT00320 DS    0H                                               02S0321
*            ERRCODE = RCRSVDDN;       /*SET ERROR CODE              */
*                                                               02S0321
         L     @10,@PC00001+4                                   02S0321
         MVC   ERRCODE(2,@10),@CH01936                          02S0321
*          ELSE                        /*NO RESERVED DDN ERROR       */
*            DO;                       /*CONTINUE PROCESSING         */
         B     @RC00320                                         02S0322
@RF00320 DS    0H                                               02S0323
*              RFY DSAB BASED(DSABPTR); /*RESET DSAB BASE            */
*              IF (UNAOPTUP ^= 0 |     /*IF UNALLOC OPTION WAS SPEC'D*/
*                                                               02S0324
*                  (RIUOPTUP = 0 &     /*OR NEITHER UNALLOC OR REMOVE*/
*                                      /*IN-USE OPTIONS WERE SPEC'D &*/
*                   DSABPALC = '0'B) | /*THE D.S. IS NON PERM   02S0324
*                                        ALLOC.,                     */
*                                                               02S0324
*                  (RIUOPTUP ^= 0 &    /*OR REMOVE IN-USE WAS SPEC'D */
*                   DSABPALC = '0'B &  /*AND D.S. IS NON PERM   02S0324
*                                        ALLOC &                     */
*                   (DSABANMP = 0 |    /*THERE IS NO ALTERNATE NAME  */
*                    DSABANAM(1) ^= '&') & /*OR THERE IS, BUT NON-
*                                            & AND                   */
*                   SIOTDLET = '1'B)) THEN /*THE DS HAS A DISP OF
*                                            DELETE                  */
*                                                               02S0324
         SLR   @10,@10                                          02S0324
         C     @10,UNAOPTUP                                     02S0324
         BNE   @RT00324                                         02S0324
         C     @10,RIUOPTUP                                     02S0324
         BNE   @GL00041                                         02S0324
         L     @10,DSABPTR                                      02S0324
         TM    DSABPALC(@10),B'01000000'                        02S0324
         BZ    @RT00324                                         02S0324
@GL00041 SLR   @10,@10                                          02S0324
         C     @10,RIUOPTUP                                     02S0324
         BE    @RF00324                                         02S0324
         L     @03,DSABPTR                                      02S0324
         TM    DSABPALC(@03),B'01000000'                        02S0324
         BNZ   @RF00324                                         02S0324
         L     @03,DSABANMP(,@03)                               02S0324
         CR    @03,@10                                          02S0324
         BE    @GL00044                                         02S0324
         CLI   DSABANAM(@03),C'&&'                              02S0324
         BE    @RF00324                                         02S0324
@GL00044 L     @10,DSABPTR                                      02S0324
         L     @10,DSABSIOT(,@10)                               02S0324
         TM    SIOTDLET(@10),B'00000100'                        02S0324
         BNO   @RF00324                                         02S0324
@RT00324 DS    0H                                               02S0325
*                DO;                   /*THE DSAB IS FOR UNALLOC     */
*                  UNALCNT = UNALCNT + 1; /*INCREMENT UNALLOC DSAB
*                                           COUNT                    */
         LA    @10,1                                            02S0326
         AL    @10,UNALCNT                                      02S0326
         ST    @10,UNALCNT                                      02S0326
*                  UNALIST(UNALCNT) = DSABPTR; /*PUT DSABPTR INTO
*                                                LIST                */
         SLA   @10,2                                            02S0327
         L     @15,DSABPTR                                      02S0327
         L     @14,UNALSTP                                      02S0327
         AL    @14,@CF02205                                     02S0327
         ST    @15,UNALIST(@10,@14)                             02S0327
*                END;                  /*END IF FOR UNALLOC          */
*                                                               02S0328
*              ELSE                    /*DSAB IS NOT FOR UNALLOC     */
*                IF (DSABNUSE = '1'B & /*IF DSAB IS IN-USE AND       */
*                    DSABCATL = '0'B) THEN /*NOT FOR A PRIVATE  02S0329
*                                            CATALOG                 */
         B     @RC00324                                         02S0329
@RF00324 L     @10,DSABPTR                                      02S0329
         TM    DSABNUSE(@10),B'00000001'                        02S0329
         BNO   @RF00329                                         02S0329
         TM    DSABCATL(@10),B'00001000'                        02S0329
         BNZ   @RF00329                                         02S0329
*                  DO;             /*DSAB IS FOR REMOVE IN-USE       */
*                    RIULSTP = RIULSTP-4; /*ADJUST PTR TO LIST  02S0331
*                                           FOR RIU                  */
         L     @10,RIULSTP                                      02S0331
         SL    @10,@CF00472                                     02S0331
         ST    @10,RIULSTP                                      02S0331
*                    RIUDSAB = FRSTCATM; /*COPY PTR TO DSAB INTO
*                                          LIST;1ST OF A CONCAT GROUP*/
         ST    FRSTCATM,RIUDSAB(,@10)                           02S0332
*                    RIUCNT = RIUCNT + 1; /*INCREMENT COUNT OF RIU
*                                           DSABS                    */
         LA    @10,1                                            02S0333
         AL    @10,RIUCNT                                       02S0333
         ST    @10,RIUCNT                                       02S0333
*                  END;                /*END IF DSAB IS FOR R-I-U    */
*                ELSE;                 /*DSAB IS NOT IN-USE OR CATLG */
*                                                               02S0335
@RF00329 DS    0H                                               02S0336
*            END;                      /*END NO RESERVED DDN ERROR   */
@RC00324 DS    0H                                               02S0337
*          DSABFND = '0'B;             /*RESET CONTROL SWITCH        */
@RC00320 NI    DSABFND,B'10111111'                              02S0337
*          COUNT = COUNT - 1;          /*DECREMENT LOOP CONTROL COUNT*/
         BCTR  COUNT,0                                          02S0338
*          IF DSABPCAT = '1'B THEN     /*IF DSAB IS PERM CONCAT      */
         L     @10,DSABPTR                                      02S0339
         TM    DSABPCAT(@10),B'00000100'                        02S0339
         BNO   @RF00339                                         02S0339
*            DO WHILE (DSABFCHN ^= 0 & /*SKIP TO END OF CHAIN OR     */
*              DSABFCHN->DSABSIOT->SCTDDNAM(1)=' ');            02S0340
         B     @DE00340                                         02S0340
@DL00340 DS    0H                                               02S0341
*                                      /*TO END OF PCAT GROUP        */
*              DSABPTR = DSABFCHN;     /*POINT TO NEXT DSAB          */
         L     @10,DSABPTR                                      02S0341
         L     @10,DSABFCHN(,@10)                               02S0341
         ST    @10,DSABPTR                                      02S0341
*            END;                      /*END IF PERM CONCAT          */
@DE00340 L     @10,DSABPTR                                      02S0342
         L     @10,DSABFCHN(,@10)                               02S0342
         LTR   @10,@10                                          02S0342
         BZ    @DC00340                                         02S0342
         L     @10,DSABSIOT(,@10)                               02S0342
         CLI   SCTDDNAM(@10),C' '                               02S0342
         BE    @DL00340                                         02S0342
@DC00340 DS    0H                                               02S0343
*        END;                          /*END IF DSAB IS ELIGIBLE     */
*      ELSE;                           /*DSAB IS NOT ELIGIBLE        */
@RF00313 DS    0H                                               02S0345
*      STARTPTR = DSABFCHN;            /*START SEARCH FROM NEXT DSAB */
@RC00313 L     @10,DSABPTR                                      02S0345
         L     @10,DSABFCHN(,@10)                               02S0345
         ST    @10,STARTPTR                                     02S0345
*    END;                              /*END LOOP TO BUILD LIST      */
@DE00301 LTR   COUNT,COUNT                                      02S0346
         BNZ   @DL00301                                         02S0346
*  END;                                /*END IF DSAB OF DSN WAS FOUND*/
*      END;                            /*END REQUEST VIA DSN         */
*                                                               01S0348
@RC00284 DS    0H                                               01S0349
*    IF (UNALCNT ^= 0  |               /*IF THERE ARE UNALLOC DSABS  */
*        RIUCNT  ^= 0 ) THEN           /*OR DSABS FOR REMOVE IN-USE  */
@RC00184 SLR   @10,@10                                          01S0349
         C     @10,UNALCNT                                      01S0349
         BNE   @RT00349                                         01S0349
         C     @10,RIUCNT                                       01S0349
         BE    @RF00349                                         01S0349
@RT00349 DS    0H                                               01S0350
*      DO;                             /*THEN CONTINUE PROCESSING    */
*        IF RIUCNT ^= 0 THEN           /*IF THERE ARE RIU DSABS      */
         L     @10,RIUCNT                                       01S0351
         LTR   @10,@10                                          01S0351
         BZ    @RF00351                                         01S0351
*         CALL IEFDB481(RIULSTP,RIUCNT,RSNCODE,LASTEPAP,        01S0352
*                       CTLBLKPS,DEPARMS,SMFPARMS);             01S0352
         LA    @10,RIULSTP                                      01S0352
         ST    @10,@AL00001                                     01S0352
         LA    @10,RIUCNT                                       01S0352
         ST    @10,@AL00001+4                                   01S0352
         L     @10,@PC00001+4                                   01S0352
         ST    @10,@AL00001+8                                   01S0352
         L     @10,@PC00001+20                                  01S0352
         ST    @10,@AL00001+12                                  01S0352
         L     @10,@PC00001+8                                   01S0352
         ST    @10,@AL00001+16                                  01S0352
         L     @10,@PC00001+16                                  01S0352
         ST    @10,@AL00001+20                                  01S0352
         L     @10,@PC00001+24                                  01S0352
         ST    @10,@AL00001+24                                  01S0352
         L     @15,@CV00101                                     01S0352
         LA    @01,@AL00001                                     01S0352
         BALR  @14,@15                                          01S0352
*                                      /*CALL REMOVE-IN-USE PROCESSOR
*                                                            @ZA02706*/
*        IF UNALCNT ^= 0 THEN          /*IF THERE ARE UNALLOC DSABS  */
@RF00351 SLR   @10,@10                                          01S0353
         C     @10,UNALCNT                                      01S0353
         BE    @RF00353                                         01S0353
*          DO;                         /*PROCESS LIST FOR UNALLOC    */
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - UNAENVCK                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - UNALLOCATION ENVIRONMENT CHECKS               */
*/*                                                                  */
*/* FUNCTION - PERFORM NECESSARY ENVIRONMENT CHECKS FOR THOSE        */
*/*            DSABS FOR WHICH IT WAS DETERMINED THAT UNALLOCATION   */
*/*            WAS TO BE DONE.                                       */
*/*                                                                  */
*/* OPERATION - THE LIST OF DSABPTRS FOR UNALLOCATION PROCESSING IS  */
*/*            GONE THROUGH, MAKING THE NECESSARY ENVIRONMENT CHECKS */
*/*            OF THE DSABS POINTED TO. IF NO ERROR FOR A DSAB HAS   */
*/*            BEEN FOUND AND THE DSAB IS CONCATENATED, THE FIRST    */
*/*            DSAB IN THE GROUP IS POINTED TO, A TEXT UNIT IS SET   */
*/*            UP, AND DECONCAT (IEFDB460) IS CALLED FOR             */
*/*            DECONCATENTAION PROCESSING. IF THERE IS ANY ERROR     */
*/*            FOR A DSAB, AN APPROPRIATE ERROR CODE IS SET, THE     */
*/*            DSABPTR IS REMOVED FROM THE LIST, AND THE COUNT OF    */
*/*            DSABPTRS DECREMENTED ACCORDINGLY. THE REMOVAL OF A    */
*/*            DSABPTR FROM THE LIST IS DONE BY REBUILDING THE       */
*/*            LIST IN PLACE, OVERLAYING THE DSABPTR FOR WHICH AN    */
*/*            ERROR IS FOUND WITH THE NEXT DSABPTR FOR WHICH NO     */
*/*            ERROR IS FOUND. THE ENVIRONMENT CHECKS MADE AND       */
*/*            THEIR ORDER ARE AS FOLLOWS FOR EACH DSAB:             */
*/*                                                                  */
*/*             .IF A DSAB IS OPEN, AN ERROR CODE OF RCOPENDS IS SET */
*/*                                                                  */
*/*             .IF A DSAB IS A MEMBER OF A PERMANENTLY CONCATENATED */
*/*              GROUP, CERTAIN PCAT CHECKS ARE MADE (SEE PCATCHKS   */
*/*              SEGMENT FOR THESE CHECKS AND THE ERROR RETURNS.)    */
*/*                                                                  */
*/*             .IF A DSAB IS FOR A PRIVATE CATALOG, AN ERROR CODE   */
*/*              OF RCPVTCTL IS SET.                                 */
*/*                                                                  */
*/*             .IF A DSAB IS FOR A DATA SET MARKED SHARE AND AN     */
*/*              OVERRIDING DISP OF DELETE WAS SPECIFIED, AN ERROR   */
*/*              CODE OF RCODSPIN IS SET.(UNLESS IT IS A DUMMY D.S.) */
*/*                                                                  */
*/*            NOTE THAT DETECTING AN ERROR DOES NOT CAUSE EXIT      */
*/*            FROM THIS SEGMENT'S PROCESSING, AND THAT ANY ERROR    */
*/*            CODE RETURNED FROM THIS SEGMENT WILL BE THE LAST      */
*/*            ONE DETECTED.                                         */
*/*                                                                  */
*/* ENTRY -                                                          */
*/*   INPUT DATA  - UNALKEYT - UNALLOC KEY TABLE                     */
*/*                 UNALIST  - LIST OF DSABPTRS FOR UNALLOCATION     */
*/*                 UNALCNT  - COUNT OF DSABPTRS IN LIST             */
*/*                 CTLBLKPS - CONTROL BLOCK PTRS (FOR DECONCAT)     */
*/*                 ALFNCMAP - SVC99 FUNCTION MAP (FOR DECONCAT)     */
*/*                 DEPARMS  - SVC99 ESTAE PARMS (FOR DECONCAT)      */
*/*                                                                  */
*/* EXIT -                                                           */
*/*   OUTPUT DATA - UNALIST - DSABPTRS REMOVED FOR DSABS WITH ERROR  */
*/*                 UNALCNT - UPDATED TO REFLECT REMOVED DSABPTRS    */
*/*                 ERRCODE - FILLED IN FOR ANY ENVIRONMENT ERROR    */
*/*                           OR ANY ERROR RETURNED FROM DECONCAT.   */
*/*                           (SEE ERRCODE SETTINGS ABOVE.)          */
*/*                                                                  */
*/********************************************************************/
*WRKINDEX = 0;                         /*INIT WORK VALID LIST INDEX  */
         LR    WRKINDEX,@10                                     02S0355
*DO COUNT = 1 BY 1 WHILE COUNT <= UNALCNT; /*LOOP THROUGH ENTIRE LIST*/
         LA    COUNT,1                                          02S0356
         B     @DE00356                                         02S0356
@DL00356 DS    0H                                               02S0357
*  DSABPTR = UNALIST(COUNT);           /*PICK UP DSABPTR IN LIST     */
         LR    @10,COUNT                                        02S0357
         SLA   @10,2                                            02S0357
         L     @03,UNALSTP                                      02S0357
         AL    @03,@CF02205                                     02S0357
         L     @10,UNALIST(@10,@03)                             02S0357
         ST    @10,DSABPTR                                      02S0357
*  WRKERROR = 0;                       /*INITIALIZE WORK ERROR CODE  */
         SLR   @03,@03                                          02S0358
         STCM  @03,3,WRKERROR                                   02S0358
*  IF DSABOPCT > 0 THEN                /*IF DSAB IS MARKED OPEN      */
         CH    @03,DSABOPCT(,@10)                               02S0359
         BNL   @RF00359                                         02S0359
*    WRKERROR = RCOPENDS;              /*SET ERROR CODE              */
         MVC   WRKERROR(2),@CB01966                             02S0360
*  ELSE                                /*DSAB IS NOT OPEN            */
*    DO;                               /*CONTINUE ENVIRONMENT CHECKS */
         B     @RC00359                                         02S0361
@RF00359 DS    0H                                               02S0362
*      IF DSABPCAT = '1'B THEN         /*IF DSAB IS PERM. CONCAT.    */
         L     @10,DSABPTR                                      02S0362
         TM    DSABPCAT(@10),B'00000100'                        02S0362
         BNO   @RF00362                                         02S0362
*        DO;                           /*ENTIRE GROUP MUST BE CHECKED*/
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - PCATCHKS                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - PERMANENTLY CONCATENATED CHECKS               */
*/*                                                                  */
*/* FUNCTION  - INCLUDED BY UNAENVCK TO PERFORM NECESSARY            */
*/*             ENVIRONMENT CHECKS FOR PERMANENTLY CONCATENATED      */
*/*             DSABS TO BE UNALLOCATED.                             */
*/*                                                                  */
*/* OPERATION - IF DSN WAS SPECIFIED IN THE REQUEST, THE PERMANENTLY */
*/*             CONCATENATED GROUP MUST BE FOR EITHER A GDG,ALL      */
*/*             GROUP OR A VSAM GROUP SPANNING DEVICE TYPES. IF THIS */
*/*             IS NOT SO, AN ERROR CODE OF RCPRMCAT IS SET. IF THIS */
*/*             IS SO, OR IF THE REQUEST IS VIA DDN ONLY, A SCAN     */
*/*             OF THE PCAT GROUP IS MADE MAKING THE FOLLOWING       */
*/*             ENVIRONMENT CHECKS FOR EACH MEMBER:                  */
*/*                                                                  */
*/*              .IF A DSAB IS FOR A PRIVATE CATALOG, AN ERROR CODE  */
*/*               OF RCPVTCTL IS SET.                                */
*/*                                                                  */
*/*              .IF A DSAB IS FOR A D.S. MARKED SHARE AND AN OVER-  */
*/*               RIDING DISP OF DELETE WAS SPECIFIED, AN ERROR      */
*/*               CODE OF RCODSPIN IS SET.(UNLESS IT IS A DUMMY D.S.)*/
*/*                                                                  */
*/*              .FOR DSN SPECIFIED, EACH PCAT MEMBER IS FURTHER     */
*/*               CHECKED TO ENSURE IT IS A MEMBER OF THE SAME       */
*/*               GDG,ALL OR VSAM GROUP. IF NOT, AN ERROR CODE OF    */
*/*               RCPRMCAT IS SET.                                   */
*/*                                                                  */
*/*             IF AN ERROR IS DETECTED IN THIS PROCESSING, NO       */
*/*             FURTHER CHECKS ARE MADE, AND THE DSABPTR IN THE      */
*/*             LIST FOR UNALLOC IS CONSIDERED INVALID AND WILL      */
*/*             BE REMOVED IN UNAENVCK SEGMENT.                      */
*/*                                                                  */
*/*             NOTE THAT AFTER THIS SEGMENT'S PROCESSING VALID      */
*/*             DSABPTRS IN THE LIST, POINTING TO PERM. CONCAT.      */
*/*             DSABS, WILL BE FOR THE FIRST MEMBERS OF THE          */
*/*             PERMANENTLY CONCATENATED GROUP. THIS IS BECAUSE THE  */
*/*             REQUEST WILL HAVE BEEN BY DDNAME ONLY, OR BY DSNAME  */
*/*             FOR GDG ALL OR VSAM GROUPS. THE FIRST MEMBER OF THE  */
*/*             GROUP WILL HAVE BEEN THE ONE FOUND BY THE SEARCH     */
*/*             ROUTINE.                                             */
*/*                                                                  */
*/* ENTRY -                                                          */
*/*   INPUT DATA - UNALKEYT - UNALLOC KEY TABLE                      */
*/*                DSABPTR  - PTR TO A PERMANENTLY CONCATENATED      */
*/*                           DSAB IN LIST FOR UNALLOC.              */
*/*                                                                  */
*/* EXIT  -                                                          */
*/*   OUTPUT DATA - WRKERROR - FILLED IN WITH FIRST DETECTED         */
*/*                            ENVIRONMENT ERROR. (SEE ERRCODE       */
*/*                            SETTINGS ABOVE)                       */
*/*                                                                  */
*/********************************************************************/
*PCATCKSW = PCATCKSW && PCATCKSW;      /*ZERO OUT SWITCHES           */
         XC    PCATCKSW(1),PCATCKSW                             03S0364
*IF DSNAMTUP ^= 0 THEN                 /*IF DSNAME WAS SPEC'D        */
         L     @03,DSNAMTUP                                     03S0365
         LTR   @03,@03                                          03S0365
         BZ    @RF00365                                         03S0365
*  IF JFCORGAM = '1'B THEN             /*IF DSAB IS FOR VSAM D.S.    */
         L     @10,DSABSIOT(,@10)                               03S0366
         L     @10,SJFCBPTR(,@10)                               03S0366
         TM    JFCORGAM(@10),B'00001000'                        03S0366
         BNO   @RF00366                                         03S0366
*    VSAMGRP = '1'B;                   /*THEN SET VSAM GROUP BIT     */
         OI    VSAMGRP,B'01000000'                              03S0367
*  ELSE                                /*DSAB IS NOT VSAM            */
*    IF SIOTGALL = '1'B THEN           /*IF DSAB IS FOR GDG,ALL      */
         B     @RC00366                                         03S0368
@RF00366 L     @10,DSABPTR                                      03S0368
         L     @10,DSABSIOT(,@10)                               03S0368
         TM    SIOTGALL(@10),B'00100000'                        03S0368
         BNO   @RF00368                                         03S0368
*      GDGGRP = '1'B;                  /*SET GDG,ALL GROUP BIT       */
         OI    GDGGRP,B'00100000'                               03S0369
*    ELSE                              /*DSAB IS NOT FOR GDG,ALL     */
*      WRKERROR =RCPRMCAT;             /*SET ERROR CODE              */
         B     @RC00368                                         03S0370
@RF00368 MVC   WRKERROR(2),@CB01990                             03S0370
*ELSE;                                 /*DSNAME WAS NOT SPECIFIED    */
@RF00365 DS    0H                                               03S0372
*IF WRKERROR = 0 THEN                  /*IF NO ERROR WAS FOUND       */
@RC00365 ICM   @10,3,WRKERROR                                   03S0372
         BNZ   @RF00372                                         03S0372
*  DO;                                 /*CONTINUE PERM. CONCAT CHECKS*/
*    DSABSAVP = DSABPTR;               /*SAVE DSABPTR                */
         L     DSABSAVP,DSABPTR                                 03S0374
*    DO WHILE SCTDDNAM(1) = ' ';       /*LOOP TO 1ST PERM CONCAT DSAB*/
         B     @DE00375                                         03S0375
@DL00375 DS    0H                                               03S0376
*      DSABPTR = DSABBCHN;             /*POINT TO PREVIOUS DSAB      */
         L     @10,DSABPTR                                      03S0376
         L     @10,DSABBCHN(,@10)                               03S0376
         ST    @10,DSABPTR                                      03S0376
*    END;                              /*END LOOP TO 1ST PCAT DSAB   */
@DE00375 L     @10,DSABPTR                                      03S0377
         L     @10,DSABSIOT(,@10)                               03S0377
         CLI   SCTDDNAM(@10),C' '                               03S0377
         BE    @DL00375                                         03S0377
*    DO WHILE (LAST = '0'B  &          /*LOOP WHILE IN PCAT GROUP AND*/
*              WRKERROR = 0 );         /*NO ERROR IS FOUND           */
         B     @DE00378                                         03S0378
@DL00378 DS    0H                                               03S0379
*      IF DSABCATL = '1'B THEN         /*IF DSAB IS FOR A CATALOG    */
         L     @10,DSABPTR                                      03S0379
         TM    DSABCATL(@10),B'00001000'                        03S0379
         BNO   @RF00379                                         03S0379
*        WRKERROR = RCPVTCTL;          /*THEN SET ERROR CODE         */
         MVC   WRKERROR(2),@CB01994                             03S0380
*      ELSE                            /*DSAB IS NOT FOR A CATALOG   */
*        IF OVDSPTUP ^= 0  &           /*IF OVERRIDING DISP WAS SPECD*/
*           OVDSPTUP -> TEXTUPAR(1) = '04'X & /*AND VALUE IS DELETE  */
*           JFCSHARE = '1'B &          /*AND DATA SET STATUS IS SHR  */
*           SCTDUMMY = '0'B THEN       /*AND NOT A DUMMY TYPE DATASET*/
         B     @RC00379                                         03S0381
@RF00379 L     @10,OVDSPTUP                                     03S0381
         LTR   @10,@10                                          03S0381
         BZ    @RF00381                                         03S0381
         CLI   TEXTUPAR(@10),X'04'                              03S0381
         BNE   @RF00381                                         03S0381
         L     @10,DSABPTR                                      03S0381
         L     @10,DSABSIOT(,@10)                               03S0381
         L     @01,SJFCBPTR(,@10)                               03S0381
         TM    JFCSHARE(@01),B'00001000'                        03S0381
         BNO   @RF00381                                         03S0381
         TM    SCTDUMMY(@10),B'10000000'                        03S0381
         BNZ   @RF00381                                         03S0381
*          WRKERROR = RCODSPIN;        /*SET ERROR CODE              */
         MVC   WRKERROR(2),@CB01930                             03S0382
*        ELSE                          /*NO OVERRIDING DISP ERROR    */
*           IF GDGGRP = '1'B THEN      /*IF GDG,ALL GROUP BIT IS ON  */
         B     @RC00381                                         03S0383
@RF00381 TM    GDGGRP,B'00100000'                               03S0383
         BNO   @RF00383                                         03S0383
*             IF SIOTGALL = '0'B THEN  /*IF DSAB IS NOT FOR GDG,ALL  */
         L     @10,DSABPTR                                      03S0384
         L     @10,DSABSIOT(,@10)                               03S0384
         TM    SIOTGALL(@10),B'00100000'                        03S0384
         BNZ   @RF00384                                         03S0384
*               WRKERROR = RCPRMCAT;   /*SET ERROR CODE              */
         MVC   WRKERROR(2),@CB01990                             03S0385
*             ELSE                     /*DSAB IS FOR GDG,ALL MEMBER  */
*               DO;                    /*ENSURE SAME GDG, ALL GROUP  */
         B     @RC00384                                         03S0386
@RF00384 DS    0H                                               03S0387
*                 DSNWORK = '';        /*BLANK OUT WORK AREA         */
         MVI   DSNWORK,C' '                                     03S0387
         MVC   DSNWORK+1(43),DSNWORK                            03S0387
*                 DSNWORK(1:DSABANML)=DSABANAM(1:DSABANML);     03S0388
         L     @10,DSABPTR                                      03S0388
         L     @10,DSABANMP(,@10)                               03S0388
         SLR   @15,@15                                          03S0388
         IC    @15,DSABANML(,@10)                               03S0388
         LR    @14,@15                                          03S0388
         BCTR  @14,0                                            03S0388
         EX    @14,@SM02196                                     03S0388
*                                      /*COPY ALT DSN INTO WORK AREA */
*                 RFY TEXTUNIT BASED(DSNAMTUP); /*RESET TEXTUNIT BASE*/
*                 IF DSABANML > TEXTULNG | /*IF ALT. DSN LEN >  03S0390
*                                            SPECIFIED LENGTH        */
*                    DSNWORK(1:TEXTULNG)^=TEXTUPAR(1:TEXTULNG) THEN
         L     @10,DSNAMTUP                                     03S0390
         ICM   @14,12,TEXTULNG(@10)                             03S0390
         SRA   @14,16                                           03S0390
         CR    @15,@14                                          03S0390
         BH    @RT00390                                         03S0390
         BCTR  @14,0                                            03S0390
         EX    @14,@SC02198                                     03S0390
         BE    @RF00390                                         03S0390
@RT00390 DS    0H                                               03S0391
*                                      /*OR DSN'S DON'T MATCH        */
*                   WRKERROR = RCPRMCAT;/*SET ERROR CODE             */
         MVC   WRKERROR(2),@CB01990                             03S0391
*                 ELSE;                /*SAME GDG, ALL GROUP         */
@RF00390 DS    0H                                               03S0393
*               END;                   /*END IF GDG, ALL MEMBER      */
*           ELSE                       /*GDG,ALL GROUP BIT IS NOT ON */
*             IF VSAMGRP = '1'B THEN   /*IF VSAM GROUP BIT IS ON     */
         B     @RC00383                                         03S0394
@RF00383 TM    VSAMGRP,B'01000000'                              03S0394
         BNO   @RF00394                                         03S0394
*               IF JFCORGAM = '0'B |   /*IF DSAB IS NOT VSAM OR      */
*                  JFCBDSNM(1:TEXTULNG) ^= TEXTUPAR(1:TEXTULNG) |
*                                      /*DSNAMES ARE DIFFERENT OR    */
*                  (TEXTULNG ^= 44 &   /*COMPARE LENGTH IS NOT MAX & */
*                  JFCBDSNM(TEXTULNG+1) ^= ' ') THEN            03S0395
         L     @10,DSABPTR                                      03S0395
         L     @10,DSABSIOT(,@10)                               03S0395
         L     @10,SJFCBPTR(,@10)                               03S0395
         TM    JFCORGAM(@10),B'00001000'                        03S0395
         BZ    @RT00395                                         03S0395
         L     @15,DSNAMTUP                                     03S0395
         ICM   @14,12,TEXTULNG(@15)                             03S0395
         SRA   @14,16                                           03S0395
         LR    @09,@14                                          03S0395
         BCTR  @09,0                                            03S0395
         EX    @09,@SC02207                                     03S0395
         BNE   @RT00395                                         03S0395
         C     @14,@CF00064                                     03S0395
         BE    @RF00395                                         03S0395
         ALR   @10,@14                                          03S0395
         CLI   JFCBDSNM(@10),C' '                               03S0395
         BE    @RF00395                                         03S0395
@RT00395 DS    0H                                               03S0396
*                                      /*NEXT CHAR JFCB IS NOT BLANK */
*                 WRKERROR = RCPRMCAT; /*SET ERROR CODE              */
         MVC   WRKERROR(2),@CB01990                             03S0396
*               ELSE;                  /*NO VSAM GROUP TYPE ERROR    */
@RF00395 DS    0H                                               03S0398
*             ELSE;                    /*VSAM GROUP BIT IS NOT ON    */
@RF00394 DS    0H                                               03S0399
*      IF DSABFCHN ^= 0  &             /*IF NOT AT END OF DSAB CHAIN */
*         DSABFCHN->DSABSIOT->SCTDDNAM(1) = ' ' THEN            03S0399
@RC00383 DS    0H                                               03S0399
@RC00381 DS    0H                                               03S0399
@RC00379 L     @10,DSABPTR                                      03S0399
         L     @10,DSABFCHN(,@10)                               03S0399
         LTR   @10,@10                                          03S0399
         BZ    @RF00399                                         03S0399
         L     @01,DSABSIOT(,@10)                               03S0399
         CLI   SCTDDNAM(@01),C' '                               03S0399
         BNE   @RF00399                                         03S0399
*                                      /*IF NOT AT END OF PCAT GROUP */
*        DSABPTR = DSABFCHN;           /*POINT TO NEXT DSAB IN GROUP */
         ST    @10,DSABPTR                                      03S0400
*      ELSE                            /*AT END OF PCAT GROUP        */
*        LAST = '1'B;                  /*GET OUT OF LOOP             */
         B     @RC00399                                         03S0401
@RF00399 OI    LAST,B'10000000'                                 03S0401
*    END;                              /*END LOOP CHECK OF PCAT GROUP*/
@RC00399 DS    0H                                               03S0402
@DE00378 TM    LAST,B'10000000'                                 03S0402
         BNZ   @DC00378                                         03S0402
         ICM   @10,3,WRKERROR                                   03S0402
         BZ    @DL00378                                         03S0402
@DC00378 DS    0H                                               03S0403
*    DSABPTR = DSABSAVP;               /*RESTORE ORIGINAL DSABPTR    */
         ST    DSABSAVP,DSABPTR                                 03S0403
*  END;                                /*END NO ERROR FOR SPEC'D DSN */
*ELSE;                                 /*NON GDG,ALL OR VSAM DSN     */
@RF00372 DS    0H                                               03S0406
*        END;                          /*END PERM CONCAT ENV. CHECKS */
*      ELSE                            /*DSAB IS NOT PERM CONCAT     */
*        IF DSABCATL = '1'B THEN       /*IF DSAB IS FOR A CATALOG    */
         B     @RC00362                                         02S0407
@RF00362 L     @10,DSABPTR                                      02S0407
         TM    DSABCATL(@10),B'00001000'                        02S0407
         BNO   @RF00407                                         02S0407
*          WRKERROR = RCPVTCTL;        /*SET ERROR CODE              */
         MVC   WRKERROR(2),@CB01994                             02S0408
*        ELSE                          /*DSAB IS NOT FOR A CATALOG   */
*          IF OVDSPTUP ^= 0 &          /*IF OVERRIDING DISP IS SPEC'D*/
*             OVDSPTUP -> TEXTUPAR(1) = '04'X & /*AND VALUE IS DELETE*/
*             JFCSHARE = '1'B &        /*AND DATA SET STATUS IS SHR  */
*             SCTDUMMY = '0'B THEN     /*AND NOT A DUMMY TYPE DATASET*/
         B     @RC00407                                         02S0409
@RF00407 L     @10,OVDSPTUP                                     02S0409
         LTR   @10,@10                                          02S0409
         BZ    @RF00409                                         02S0409
         CLI   TEXTUPAR(@10),X'04'                              02S0409
         BNE   @RF00409                                         02S0409
         L     @10,DSABPTR                                      02S0409
         L     @10,DSABSIOT(,@10)                               02S0409
         L     @03,SJFCBPTR(,@10)                               02S0409
         TM    JFCSHARE(@03),B'00001000'                        02S0409
         BNO   @RF00409                                         02S0409
         TM    SCTDUMMY(@10),B'10000000'                        02S0409
         BNZ   @RF00409                                         02S0409
*            WRKERROR = RCODSPIN;      /*SET ERROR CODE              */
         MVC   WRKERROR(2),@CB01930                             02S0410
*          ELSE;                       /*NO OVERRIDING DISP ERROR    */
@RF00409 DS    0H                                               02S0412
*      IF WRKERROR = 0 THEN            /*IF NO ERROR WAS FOUND       */
@RC00407 DS    0H                                               02S0412
@RC00362 ICM   @10,3,WRKERROR                                   02S0412
         BNZ   @RF00412                                         02S0412
*        IF DSABCATM = '1'B THEN       /*IF DSAB IS CONCATENATED     */
         L     @10,DSABPTR                                      02S0413
         TM    DSABCATM(@10),B'00000010'                        02S0413
         BNO   @RF00413                                         02S0413
*          DO;                         /*DO DECONCAT PROCESSING      */
*            DO WHILE TIOEDDNM(1) = ' '; /*LOOP TO 1ST DSAB IN GROUP */
         B     @DE00415                                         02S0415
@DL00415 DS    0H                                               02S0416
*              DSABPTR = DSABBCHN;     /*POINT TO PREVIOUS DSAB      */
         L     @10,DSABPTR                                      02S0416
         L     @10,DSABBCHN(,@10)                               02S0416
         ST    @10,DSABPTR                                      02S0416
*            END;                      /*END LOOP TO 1ST IN GROUP    */
@DE00415 L     @10,DSABPTR                                      02S0417
         L     @10,DSABTIOT(,@10)                               02S0417
         CLI   TIOEDDNM(@10),C' '                               02S0417
         BE    @DL00415                                         02S0417
*            DECATKEY = '0001'X;       /*PUT DDN KEY IN TEXT UNIT    */
         MVC   DECATKEY(2),@CB00116                             02S0418
*            DECATNUM = '0001'X;       /*NO. OF PARMS INTO TEXT UNIT */
         MVC   DECATNUM(2),@CB00116                             02S0419
*            DECATLEN = '0008'X;       /*PARM LENGTH INTO TEXT UNIT  */
         MVC   DECATLEN(2),@CB00114                             02S0420
*            DECATPRM(1:8) = TIOEDDNM(1:8); /*DDN PARM INTO TEXT UNIT*/
         MVC   DECATPRM(8),TIOEDDNM(@10)                        02S0421
*            DECATTUP = ADDR(DECATXTU) | '80000000'X;           02S0422
         LA    @10,DECATXTU                                     02S0422
         O     @10,@CF02178                                     02S0422
         ST    @10,DECATTUP                                     02S0422
*                                      /*POINT TO ONE &ONLY TEXT UNIT*/
*            CALL IEFDB460(ADDR(DECATTUP),WRKRSNCD,CTLBLKPS,ALFNCMAP,
*                          DEPARMS,LASTEPAP,SMFPARMS);          02S0423
         LA    @10,DECATTUP                                     02S0423
         ST    @10,@TF00001                                     02S0423
         LA    @10,@TF00001                                     02S0423
         ST    @10,@AL00001                                     02S0423
         LA    @10,WRKRSNCD                                     02S0423
         ST    @10,@AL00001+4                                   02S0423
         L     @10,@PC00001+8                                   02S0423
         ST    @10,@AL00001+8                                   02S0423
         L     @10,@PC00001+12                                  02S0423
         ST    @10,@AL00001+12                                  02S0423
         L     @10,@PC00001+16                                  02S0423
         ST    @10,@AL00001+16                                  02S0423
         L     @10,@PC00001+20                                  02S0423
         ST    @10,@AL00001+20                                  02S0423
         L     @10,@PC00001+24                                  02S0423
         ST    @10,@AL00001+24                                  02S0423
         L     @15,@CV00105                                     02S0423
         LA    @01,@AL00001                                     02S0423
         BALR  @14,@15                                          02S0423
*                                      /*DYNAMIC DECONCAT    @ZA02706*/
*          END;                        /*END DECONCAT PROCESS        */
*        ELSE;                         /*DSAB IS NOT CONCATENATED    */
@RF00413 DS    0H                                               02S0426
*      ELSE;                           /*ERROR WAS DETECTED          */
@RF00412 DS    0H                                               02S0427
*    END;                              /*END IF DSAB IS NOT OPEN     */
*  IF WRKERROR = 0 THEN                /*IF NO ERROR HAS BEEN FOUND  */
@RC00359 ICM   @10,3,WRKERROR                                   02S0428
         BNZ   @RF00428                                         02S0428
*    DO;                               /*DSAB IS VALID - UPDATE LIST */
*      WRKINDEX = WRKINDEX +1;         /*UPDATE OVERLAY LIST INDEX   */
         AL    WRKINDEX,@CF00230                                02S0430
*      UNALIST(WRKINDEX) = UNALIST(COUNT); /*OVERLAY DSABPTR IN LIST */
         L     @10,UNALSTP                                      02S0431
         LR    @03,WRKINDEX                                     02S0431
         SLA   @03,2                                            02S0431
         LR    @15,COUNT                                        02S0431
         SLA   @15,2                                            02S0431
         AL    @15,@CF02205                                     02S0431
         L     @15,UNALIST(@15,@10)                             02S0431
         AL    @10,@CF02205                                     02S0431
         ST    @15,UNALIST(@03,@10)                             02S0431
*    END;                              /*END IF DSAB IS VALID        */
*  ELSE                                /*ENVIRONMENT ERROR FOUND     */
*    ERRCODE = WRKERROR;               /*COPY ERRORCODE FROM WORKAREA*/
         B     @RC00428                                         02S0433
@RF00428 L     @10,@PC00001+4                                   02S0433
         MVC   ERRCODE(2,@10),WRKERROR                          02S0433
*END;                                  /*END LOOP THROUGH LIST       */
@RC00428 AL    COUNT,@CF00230                                   02S0434
@DE00356 C     COUNT,UNALCNT                                    02S0434
         BNH   @DL00356                                         02S0434
*UNALCNT = WRKINDEX;                   /*UPDATE COUNT FOR ANY ERRORS */
         ST    WRKINDEX,UNALCNT                                 02S0435
*            IF UNALCNT ^= 0 THEN      /*STILL VALID UNALLOC DSABS?  */
         L     @10,UNALCNT                                      01S0436
         LTR   @10,@10                                          01S0436
         BZ    @RF00436                                         01S0436
*              CALL IEFDB4A1(UNALSTP,UNALCNT,RSNCODE,LASTEPAP,  01S0437
*                            CTLBLKPS,ADDR(UNALKEYT),DEPARMS,SMFPARMS);
         LA    @10,UNALSTP                                      01S0437
         ST    @10,@AL00001                                     01S0437
         LA    @10,UNALCNT                                      01S0437
         ST    @10,@AL00001+4                                   01S0437
         L     @10,@PC00001+4                                   01S0437
         ST    @10,@AL00001+8                                   01S0437
         L     @10,@PC00001+20                                  01S0437
         ST    @10,@AL00001+12                                  01S0437
         L     @10,@PC00001+8                                   01S0437
         ST    @10,@AL00001+16                                  01S0437
         LA    @10,UNALKEYT                                     01S0437
         ST    @10,@TF00001                                     01S0437
         LA    @10,@TF00001                                     01S0437
         ST    @10,@AL00001+20                                  01S0437
         L     @10,@PC00001+16                                  01S0437
         ST    @10,@AL00001+24                                  01S0437
         L     @10,@PC00001+24                                  01S0437
         ST    @10,@AL00001+28                                  01S0437
         L     @15,@CV00102                                     01S0437
         LA    @01,@AL00001                                     01S0437
         BALR  @14,@15                                          01S0437
*                                      /*YES, CALL UNALLOC PROCESSOR
*                                                            @ZA02706*/
*          END;                        /*END UNALLOC PROCESS         */
@RF00436 DS    0H                                               01S0439
*      END;                            /*END PROCESSING OF DSABS     */
*                                                               01S0439
@RF00353 DS    0H                                               01S0440
*    IF DSABCNT > 1 THEN               /*IF CORE WAS GOTTEN FOR LIST */
@RF00349 C     DSABCNT,@CF00230                                 01S0440
         BNH   @RF00440                                         01S0440
*      DO;                             /*THEN FREE IT                */
*        R0 = DSABCNT * 4;             /*DETERMINE AMOUNT OF CORE    */
         LR    R0,DSABCNT                                       01S0442
         SLA   R0,2                                             01S0442
*        R0 = R0 | SUBPOOLN;           /*GET FROM CORRECT SUBPOOL    */
         O     R0,@CF00097                                      01S0443
*        GEN (FREEMAIN R,LV=(0),A=UNALSTP); /*FREEMAIN DSABPTR LIST  */
         FREEMAIN R,LV=(0),A=UNALSTP
*      END;                            /*END IF CORE WAS GOTTEN      */
*  END;                                /*END OF NO VALIDITY ERROR    */
*END IEFDB4A0                                                   01S0447
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (UNALCTLS)                                        *
*/*%INCLUDE SYSLIB  (UNALCTLD)                                        *
*/*%INCLUDE SYSLIB  (UNALKEYD)                                        *
*/*%INCLUDE SYSLIB  (IEFZB4D1)                                        *
*/*%INCLUDE SYSLIB  (IEFZB4D2)                                        *
*/*%INCLUDE SYSLIB  (IHAQDB  )                                        *
*/*%INCLUDE SYSLIB  (IEFZB4D5)                                        *
*/*%INCLUDE SYSLIB  (IHADSAB )                                        *
*/*%INCLUDE SYSLIB  (IEFJFCBN)                                        *
*/*%INCLUDE SYSLIB  (IEFJFCBX)                                        *
*/*%INCLUDE SYSLIB  (IEFASIOT)                                        *
*/*%INCLUDE SYSLIB  (IEZJSCB )                                        *
*/*%INCLUDE SYSLIB  (IEFTIOT1)                                        *
*/*%INCLUDE SYSLIB  (CVT     )                                        *
*/*%INCLUDE SYSLIB  (IEFJESCT)                                        *
*/*%INCLUDE SYSLIB  (IEFJSSOB)                                        *
*/*%INCLUDE SYSLIB  (IEFZB4DA)                                        *
*/*%INCLUDE SYSLIB  (IEFZB4D7)                                        *
*/*%INCLUDE SYSLIB  (IEFZB4D9)                                        *
*/*%INCLUDE SYSLIB  (VALIDCHK)                                        *
*/*%INCLUDE SYSLIB  (VALIDCKS)                                        *
*/*%INCLUDE SYSLIB  (DDNPRCSS)                                        *
*/*%INCLUDE SYSLIB  (DDNPRCSP)                                        *
*/*%INCLUDE SYSLIB  (DSNPRCSS)                                        *
*/*%INCLUDE SYSLIB  (DSNPRCSP)                                        *
*/*%INCLUDE SYSLIB  (UNAENVCK)                                        *
*/*%INCLUDE SYSLIB  (UNAENVSP)                                        *
*/*%INCLUDE SYSLIB  (PCATCHKS)                                        *
*/*%INCLUDE SYSLIB  (PCATCKSP)                                        *
*;                                                              01S0447
@EL00001 L     @13,4(,@13)                                      01S0447
@EF00001 L     @00,@SIZDATD                                     01S0447
         LR    @01,@11                                          01S0447
         FSPACE   R,LV=(0),A=(1)
@ER00001 LM    @14,@12,12(@13)                                  01S0447
         BR    @14                                              01S0447
@DATA    DS    0H
@CH01884 DC    H'11'
@CH00067 DC    H'16'
@CH01882 DC    H'20'
@CH00116 DC    XL2'0001'
@CH00184 DC    XL2'0018'
@CH00276 DC    XL2'0003'
@CH00279 DC    XL2'0005'
@CH01932 DC    XL2'035C'
@CH01936 DC    XL2'0364'
@CH01950 DC    XL2'0384'
@CH01952 DC    XL2'0388'
@CH01972 DC    XL2'0438'
@CH01976 DC    XL2'0440'
@CH01992 DC    XL2'0460'
@CH01998 DC    XL2'046C'
@CH02004 DC    XL2'0478'
@SC02180 CLC   TEXTUPAR(0,@10),@CC02141
@SC02182 CLC   TEXTUPAR(0,@10),@CC02142
@SC02184 CLC   TEXTUPAR(0,@10),@CC02143
@SC02186 CLC   TEXTUPAR(0,@10),@CC02144
@SM02188 MVC   SSUSUSER(0),TEXTUPAR(@10)
@SM02190 MVC   AMPDSNPM(0),TEXTUPAR+1(@05)
@SM02192 MVC   DDNWORK(0),TEXTUPAR(@10)
@SM02194 MVC   DSNWORK(0),TEXTUPAR(@10)
@SM02196 MVC   DSNWORK(0),DSABANAM(@10)
@SC02198 CLC   DSNWORK(0),TEXTUPAR(@10)
@SM02200 MVC   DSNWORK(0),TEXTUPAR(@15)
@SC02207 CLC   JFCBDSNM(0,@10),TEXTUPAR(@15)
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    7F
@AL00001 DS    8A
@TF00001 DS    F
@TF00002 DS    F
@TF00003 DS    F
@TF00004 DS    F
IEFDB4A0 CSECT
         DS    0F
@CF00230 DC    F'1'
@CF00472 DC    F'4'
@CF00233 DC    F'6'
@CF00573 DC    F'7'
@CF00064 DC    F'44'
@CF02205 DC    F'-4'
@CF00097 DC    XL4'E6000000'
@CF02178 DC    XL4'80000000'
@DATD    DSECT
         DS    0D
DSABPTR  DS    A
DSABLST1 DS    A
RIULSTP  DS    A
RIUCNT   DS    F
UNALSTP  DS    A
UNALCNT  DS    F
STARTPTR DS    A
DECATTUP DS    A
TXTUFLDP DS    A
QDBPTR   DS    A
JFCBPTR  DS    A
JFCBXPTR DS    A
SIOTPTR  DS    A
TCBJSCB  DS    A
TIOTPTR  DS    A
AMPDSNTU DS    CL50
         ORG   AMPDSNTU
AMPDSNKY DS    CL2
AMPDSNNO DS    CL2
AMPDSNLN DS    CL2
AMPDSNPM DS    CL44
         ORG   AMPDSNTU+50
DSNWORK  DS    CL44
         DS    CL2
UNALKEYT DS    CL40
         ORG   UNALKEYT
DDNAMTUP DS    AL4
DSNAMTUP DS    AL4
MEMBRTUP DS    AL4
OVDSPTUP DS    AL4
UNAOPTUP DS    AL4
RIUOPTUP DS    AL4
OVSNHTUP DS    AL4
OVCLSTUP DS    AL4
OVSUSTUP DS    AL4
OVSHQTUP DS    AL4
         ORG   UNALKEYT+40
WRKRSNCD DS    CL4
         ORG   WRKRSNCD
WRKERROR DS    CL2
WRKINFO  DS    CL2
         ORG   WRKRSNCD+4
DDNWORK  DS    CL8
DUPMASK  DS    CL12
MUTEXMSK DS    CL12
DSNPRCSW DS    BL1
         ORG   DSNPRCSW
OUT      DS    BL1
DSABFND  EQU   DSNPRCSW+0
@NM00001 EQU   DSNPRCSW+0
         ORG   DSNPRCSW+1
DSNSCHMP DS    CL2
         ORG   DSNSCHMP
JFCBONLY DS    BL1
ALTDSNFD EQU   DSNSCHMP+0
JFCBALNM EQU   DSNSCHMP+0
@NM00002 EQU   DSNSCHMP+0
         ORG   DSNSCHMP+2
DECATXTU DS    CL14
         ORG   DECATXTU
DECATKEY DS    CL2
DECATNUM DS    CL2
DECATLEN DS    CL2
DECATPRM DS    CL8
         ORG   DECATXTU+14
PCATCKSW DS    BL1
         ORG   PCATCKSW
LAST     DS    BL1
VSAMGRP  EQU   PCATCKSW+0
GDGGRP   EQU   PCATCKSW+0
@NM00003 EQU   PCATCKSW+0
         ORG   PCATCKSW+1
         DS    CL2
SSOB     DS    CL20
         ORG   SSOB
SSOBID   DS    CL4
SSOBLEN  DS    FL2
SSOBFUNC DS    FL2
SSOBSSIB DS    AL4
SSOBRETN DS    AL4
SSOBINDV DS    AL4
         ORG   SSOB+20
SSUS     DS    CL16
         ORG   SSUS
SSUSLEN  DS    FL2
@NM00043 DS    FL2
@NM00044 DS    FL4
SSUSUSER DS    CL8
         ORG   SSUS+16
IEFDB4A0 CSECT
         DS    0F
@SIZDATD DC    AL1(230)
         DC    AL3(@ENDDATD-@DATD)
@CV00100 DC    V(IEFDB4FF)
@CV00101 DC    V(IEFDB481)
@CV00102 DC    V(IEFDB4A1)
@CV00103 DC    V(IEFDB4FC)
@CV00104 DC    V(IEFDB4FA)
@CV00105 DC    V(IEFDB460)
         DS    0D
@CC02141 DC    C'JOBLIB  '
@CC02142 DC    C'JOBCAT  '
@CC02143 DC    C'STEPLIB '
@CC02144 DC    C'STEPCAT '
@CC02161 DC    C'SSOB'
@CC02164 DC    C'&&&&'
@CB00114 DC    X'0008'
@CB00116 DC    X'0001'
@CB01930 DC    X'0358'
@CB01966 DC    X'0420'
@CB01990 DC    X'045C'
@CB01994 DC    X'0464'
UNALKEYD DS    CL141
         ORG   UNALKEYD
KYDDNAME DS    CL13
         ORG   KYDDNAME
DDNAMLEN DC    AL1(13)
DDNAMHEX DC    X'0001'
DDNAMMXL DC    X'0008'
DDNAMMNL DC    X'0001'
DDNAMMXN DC    X'0001'
DDNAMMNN DC    X'0001'
DDNAMKTB DC    X'0000'
         ORG   UNALKEYD+13
KYDSNAME DS    CL13
         ORG   KYDSNAME
DSNAMLEN DC    AL1(13)
DSNAMHEX DC    X'0002'
DSNAMMXL DC    X'002C'
DSNAMMNL DC    X'0001'
DSNAMMXN DC    X'0001'
DSNAMMNN DC    X'0001'
DSNAMKTB DC    X'0004'
         ORG   UNALKEYD+26
KYMEMBER DS    CL13
         ORG   KYMEMBER
MEMBRLEN DC    AL1(13)
MEMBRHEX DC    X'0003'
MEMBRMXL DC    X'0008'
MEMBRMNL DC    X'0001'
MEMBRMXN DC    X'0001'
MEMBRMNN DC    X'0001'
MEMBRKTB DC    X'0008'
         ORG   UNALKEYD+39
KYOVDISP DS    CL13
         ORG   KYOVDISP
OVDSPLEN DC    AL1(13)
OVDSPHEX DC    X'0005'
OVDSPMXL DC    X'0001'
OVDSPMNL DC    X'0001'
OVDSPMXN DC    X'0001'
OVDSPMNN DC    X'0001'
OVDSPKTB DC    X'000C'
         ORG   UNALKEYD+52
KYUNALOC DS    CL15
         ORG   KYUNALOC
UNALCLEN DC    AL1(15)
UNALCHEX DC    X'0007'
UNALCMXL DC    X'0000'
UNALCMNL DC    X'0000'
UNALCMXN DC    X'0000'
UNALCMNN DC    X'0000'
UNALCKTB DC    X'0010'
UNALCMEX DS    CL2
         ORG   UNALCMEX
UNALCME1 DC    X'0008'
         ORG   UNALKEYD+67
KYREMOVE DS    CL15
         ORG   KYREMOVE
REMOVLEN DC    AL1(15)
REMOVHEX DC    X'0008'
REMOVMXL DC    X'0000'
REMOVMNL DC    X'0000'
REMOVMXN DC    X'0000'
REMOVMNN DC    X'0000'
REMOVKTB DC    X'0014'
REMOVMEX DS    CL2
         ORG   REMOVMEX
REMOVME1 DC    X'0007'
         ORG   UNALKEYD+82
KYOVSYNH DS    CL15
         ORG   KYOVSYNH
OVSNHLEN DC    AL1(15)
OVSNHHEX DC    X'000A'
OVSNHMXL DC    X'0000'
OVSNHMNL DC    X'0000'
OVSNHMXN DC    X'0000'
OVSNHMNN DC    X'0000'
OVSNHKTB DC    X'0018'
OVSNHMEX DS    CL2
         ORG   OVSNHMEX
OVSNHME1 DC    X'0059'
         ORG   UNALKEYD+97
KYOVSCLS DS    CL13
         ORG   KYOVSCLS
OVCLSLEN DC    AL1(13)
OVCLSHEX DC    X'0018'
OVCLSMXL DC    X'0001'
OVCLSMNL DC    X'0001'
OVCLSMXN DC    X'0001'
OVCLSMNN DC    X'0001'
OVCLSKTB DC    X'001C'
         ORG   UNALKEYD+110
KYOVSYUS DS    CL13
         ORG   KYOVSYUS
OVSUSLEN DC    AL1(13)
OVSUSHEX DC    X'0058'
OVSUSMXL DC    X'0007'
OVSUSMNL DC    X'0001'
OVSUSMXN DC    X'0001'
OVSUSMNN DC    X'0001'
OVSUSKTB DC    X'0020'
         ORG   UNALKEYD+123
KYOVSYHQ DS    CL15
         ORG   KYOVSYHQ
OVSHQLEN DC    AL1(15)
OVSHQHEX DC    X'0059'
OVSHQMXL DC    X'0000'
OVSHQMNL DC    X'0000'
OVSHQMXN DC    X'0000'
OVSHQMNN DC    X'0000'
OVSHQKTB DC    X'0024'
OVSHQMEX DS    CL2
         ORG   OVSHQMEX
OVSHQME1 DC    X'000A'
         ORG   UNALKEYD+138
KYENDDCT DS    CL3
         ORG   KYENDDCT
ENDCLEN  DC    AL1(3)
ENDCHEX  DC    X'FFFF'
         ORG   UNALKEYD+141
IEFDB4A0 CSECT
         DS   0H
PATCHLOC DC ((@DATA-@PSTART)/20)X'00'
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEFDB4A0 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
WRKINDEX EQU   @02
FRSTCATM EQU   @02
DSABSAVP EQU   @03
DSABCNT  EQU   @04
COUNT    EQU   @05
R0       EQU   @00
R1       EQU   @01
R15      EQU   @15
CVTPTR   EQU   16
UNALIST  EQU   0
RIUDSAB  EQU   0
TXTUPLST EQU   0
TXTUNITP EQU   TXTUPLST
TXTUPELM EQU   0
TXTPLENT EQU   TXTUPELM
TEXTUNIT EQU   0
TEXTUENT EQU   TEXTUNIT+4
TEXTULNG EQU   TEXTUENT
TEXTUPAR EQU   TEXTUENT+2
TEXTUFLD EQU   0
QDB      EQU   0
DSAB     EQU   0
DSABFCHN EQU   DSAB+4
DSABBCHN EQU   DSAB+8
DSABOPCT EQU   DSAB+14
DSABTIOT EQU   DSAB+16
DSABGIDP EQU   DSAB+24
DSABANMP EQU   DSAB+28
DSABORG  EQU   DSAB+32
DSABORG1 EQU   DSABORG
DSABORG2 EQU   DSABORG+1
DSABFLG1 EQU   DSAB+34
DSABPALC EQU   DSABFLG1
DSABPCAT EQU   DSABFLG1
DSABCATM EQU   DSABFLG1
DSABNUSE EQU   DSABFLG1
DSABFLG2 EQU   DSAB+35
DSABFLG3 EQU   DSAB+36
DSABCATL EQU   DSABFLG3
DSABFLG4 EQU   DSAB+37
DSABSIOT EQU   DSAB+64
DSABANMI EQU   0
DSABANML EQU   DSABANMI
DSABANAM EQU   DSABANMI+1
DSABGIDL EQU   0
INFMJFCB EQU   0
JFCBDSNM EQU   INFMJFCB
JFCBELNM EQU   INFMJFCB+44
JFCBTSDM EQU   INFMJFCB+52
JFCFCBID EQU   INFMJFCB+56
JFCBFRID EQU   JFCFCBID
JFCBLTYP EQU   INFMJFCB+66
JFCBOTTR EQU   INFMJFCB+67
JFCBUFOF EQU   JFCBOTTR
JFCBFLSQ EQU   JFCBOTTR+1
JFCFUNC  EQU   JFCBFLSQ
JFCBMASK EQU   INFMJFCB+72
JFCBFLG1 EQU   JFCBMASK+5
JFCOPEN  EQU   JFCBFLG1
JFCBFLG2 EQU   JFCBMASK+6
JFCDEFER EQU   JFCBFLG2
JFCBIND1 EQU   INFMJFCB+86
JFCBIND2 EQU   INFMJFCB+87
JFCSHARE EQU   JFCBIND2
JFCAMPTR EQU   INFMJFCB+88
JFCBUFRQ EQU   JFCAMPTR
JFCBUFNO EQU   JFCBUFRQ
JFCBGNCP EQU   JFCAMPTR+1
JFCBHIAR EQU   JFCBGNCP
JFCBFALN EQU   JFCBHIAR
JFCBFTEK EQU   JFCBFALN
JFCBBFTA EQU   JFCBFTEK
JFCEROPT EQU   INFMJFCB+92
JFCTRTCH EQU   INFMJFCB+93
JFCBX    EQU   0
JFCBXNAM EQU   JFCBX+96
INDMSIOT EQU   0
SCTDDNAM EQU   INDMSIOT+4
SCTUSADD EQU   INDMSIOT+20
SIOTBYT1 EQU   INDMSIOT+43
SIOTBYT3 EQU   INDMSIOT+46
SIOALIAS EQU   SIOTBYT3
SIOTTSTC EQU   INDMSIOT+47
SIOTTERM EQU   SIOTTSTC
SIOTQNAM EQU   SIOTTSTC
SIOTBYT0 EQU   INDMSIOT+52
SCTSDISP EQU   INDMSIOT+55
SIOTDLET EQU   SCTSDISP
SCTSBYT1 EQU   INDMSIOT+56
SCTDUMMY EQU   SCTSBYT1
SCTSBYT2 EQU   INDMSIOT+57
SCTSBYT3 EQU   INDMSIOT+58
SCTSBYT4 EQU   INDMSIOT+59
SCTUTYPE EQU   INDMSIOT+60
SIOTDEVT EQU   SCTUTYPE
SIOUBYT3 EQU   SIOTDEVT+2
SIOTALTD EQU   INDMSIOT+92
SIOTBYT2 EQU   INDMSIOT+103
SIOTGALL EQU   SIOTBYT2
SJFCBPTR EQU   INDMSIOT+156
SIOTJFX  EQU   INDMSIOT+160
IEZJSCB  EQU   0
JSCBSEC1 EQU   IEZJSCB+188
JSCHPCE  EQU   JSCBSEC1+4
JSCBDCB  EQU   JSCBSEC1+36
JSCBOPTS EQU   JSCBSEC1+48
JSCBSWT1 EQU   JSCBSEC1+55
JSCBWTP  EQU   JSCBSEC1+64
JSCBWTFG EQU   JSCBWTP
JSCBEND1 EQU   IEZJSCB+260
TIOT1    EQU   0
TIOENTRY EQU   0
TIOESTTA EQU   TIOENTRY+1
TIOERLOC EQU   TIOENTRY+2
TIOELINK EQU   TIOERLOC+1
TIOESYOT EQU   TIOELINK
TIOEDDNM EQU   TIOENTRY+4
TIOESTTC EQU   TIOENTRY+15
TIOESTTB EQU   TIOENTRY+16
POOLSTAR EQU   TIOENTRY+20
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTJESCT EQU   CVTMAP+296
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
JESCT    EQU   0
JESWAA   EQU   JESCT+8
JESSSREQ EQU   JESCT+20
SSREQ    EQU   0
SWAMGR   EQU   0
S99TXTPP EQU   0
RSNCODE  EQU   0
ERRCODE  EQU   RSNCODE
INFOCODE EQU   RSNCODE+2
CTLBLKPS EQU   0
JSCBPTR  EQU   CTLBLKPS
ALFNCMAP EQU   0
INPUTSW  EQU   ALFNCMAP
PROCESSW EQU   ALFNCMAP+6
ERRPROSW EQU   PROCESSW
DEPARMS  EQU   0
DENQRETN EQU   DEPARMS+232
DEDMYEPA EQU   DEPARMS+240
DEDMYAS  EQU   DEPARMS+260
LASTEPAP EQU   0
SMFPARMS EQU   0
DSABQDB  EQU   QDB
DSQFRSTP EQU   DSABQDB+12
DSQLASTP EQU   DSABQDB+16
JFCKEYLE EQU   JFCTRTCH
JFCCODE  EQU   JFCKEYLE
JFCSTACK EQU   JFCTRTCH
JFCMODE  EQU   JFCSTACK
JFCSPPRT EQU   JFCTRTCH
JFCBABFS EQU   JFCSPPRT+2
JFCLIMCT EQU   JFCBABFS
JFCDSORG EQU   JFCSPPRT+5
JFCDSRG1 EQU   JFCDSORG
JFCDSRG2 EQU   JFCDSORG+1
JFCORGAM EQU   JFCDSRG2
JFCRECFM EQU   JFCSPPRT+7
JFCRCFM  EQU   JFCRECFM
JFCOPTCD EQU   JFCSPPRT+8
JFCWVCSP EQU   JFCOPTCD
JFCWVCIS EQU   JFCWVCSP
JFCWVCBD EQU   JFCWVCIS
JFCALLOW EQU   JFCOPTCD
JFCRSV17 EQU   JFCALLOW
JFCOVER  EQU   JFCRSV17
JFCPCIBT EQU   JFCOPTCD
JFCMAST  EQU   JFCPCIBT
JFCEXT   EQU   JFCMAST
JFCBCKPT EQU   JFCOPTCD
JFCIND   EQU   JFCBCKPT
JFCRSV18 EQU   JFCOPTCD
JFCCYL   EQU   JFCRSV18
JFCACT   EQU   JFCCYL
JFCREDUC EQU   JFCOPTCD
JFCRSV19 EQU   JFCREDUC
JFCRSV20 EQU   JFCRSV19
JFCRSV21 EQU   JFCOPTCD
JFCDEL   EQU   JFCRSV21
JFCRSV23 EQU   JFCOPTCD
JFCREORG EQU   JFCRSV23
JFCBLKSI EQU   JFCSPPRT+9
JFCBUFSI EQU   JFCBLKSI
JFCAMSYN EQU   JFCSPPRT+11
JFCNCP   EQU   JFCAMSYN+2
JFCNTM   EQU   JFCAMSYN+3
JFCBFSEQ EQU   JFCNTM
JFCPCI   EQU   JFCBFSEQ
JFCRESRV EQU   JFCAMSYN+4
JFCUCSEG EQU   JFCRESRV
JFCUCSOP EQU   JFCUCSEG+4
JFCOUTLI EQU   JFCUCSEG+5
JFCTHRSH EQU   JFCOUTLI
JFCCPRI  EQU   JFCTHRSH
JFCBVOLS EQU   JFCUCSEG+10
JFCBS001 EQU   JFCBVOLS
JFCBPQTY EQU   JFCBS001+34
JFCBCTRI EQU   JFCBS001+37
JFCBSQTY EQU   JFCBS001+38
JFCFLGS1 EQU   JFCBS001+41
JSCBSEC2 EQU   JSCBEND1
JSCBSEC3 EQU   JSCBEND1
JSCBJCT  EQU   JSCBSEC3
JSCBJCTA EQU   JSCBJCT+1
JSCBASID EQU   JSCBSEC3+8
JSCBJNL  EQU   JSCBSEC3+28
JSCBJJSB EQU   JSCBJNL
JSCBSUB  EQU   JSCBSEC3+40
JSCDSABQ EQU   JSCBSEC3+60
JSCSCT   EQU   JSCBSEC3+68
JSCRSV35 EQU   JSCBSEC3+96
JSCRSV36 EQU   JSCRSV35
JSCRSV37 EQU   JSCRSV35+2
JSCRSV45 EQU   JSCBSEC3+112
JSCRSV46 EQU   JSCRSV45
JSCRSV47 EQU   JSCRSV45+2
TIOEDEVE EQU   TIOESTTB
TIOSTTB  EQU   TIOEDEVE
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTRV620 EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTRV612 EQU   CVTS01+664
CVTRV611 EQU   CVTS01+660
CVTRV610 EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTRV608 EQU   CVTS01+648
CVTRV607 EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTRV519 EQU   CVTS01+92
CVTRV327 EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
TIOUCBP  EQU   TIOEDEVE+1
TIOVERF  EQU   TIOSTTB
TIOUNLD  EQU   TIOSTTB
TIOMNTD  EQU   TIOSTTB
TIOSETU  EQU   TIOSTTB
TIOVLSR  EQU   TIOSTTB
TIOPVIO  EQU   TIOSTTB
TIOREQD  EQU   TIOSTTB
TIOUSED  EQU   TIOSTTB
JSCBEND3 EQU   JSCBSEC3+120
JSCRSV52 EQU   JSCBSEC3+116
JSCRSV51 EQU   JSCRSV47+1
JSCRSV50 EQU   JSCRSV47
JSCRSV49 EQU   JSCRSV46+1
JSCRSV48 EQU   JSCRSV46
JSCRSV44 EQU   JSCBSEC3+108
JSCRSV43 EQU   JSCBSEC3+104
JSCRSV42 EQU   JSCBSEC3+100
JSCRSV41 EQU   JSCRSV37+1
JSCRSV40 EQU   JSCRSV37
JSCRSV39 EQU   JSCRSV36+1
JSCRSV38 EQU   JSCRSV36
JSCBUFPT EQU   JSCBSEC3+92
JSCBACT  EQU   JSCBSEC3+88
JSCBSWSP EQU   JSCBSEC3+87
JSCRSV33 EQU   JSCBSEC3+86
JSCDDNUM EQU   JSCBSEC3+84
JSCRSV53 EQU   JSCBSEC3+82
JSCDDNNO EQU   JSCBSEC3+80
JSCBVATA EQU   JSCBSEC3+76
JSCTMCOR EQU   JSCBSEC3+72
JSCSCTP  EQU   JSCSCT+1
JSCRSV55 EQU   JSCSCT
JSCRSV54 EQU   JSCBSEC3+64
JSCBSSIB EQU   JSCBSEC3+56
JSCBFRBA EQU   JSCBSEC3+48
JSCRSV28 EQU   JSCBSEC3+46
JSCBSONO EQU   JSCBSEC3+44
JSCBSUBA EQU   JSCBSUB+1
JSCRSV31 EQU   JSCBSUB
JSCBSMLR EQU   JSCBSEC3+36
JSCBJNLR EQU   JSCBSEC3+32
JSCBJNLA EQU   JSCBJNL+1
JSCBJSBT EQU   JSCBJJSB
JSCBJSBX EQU   JSCBJJSB
JSCBJSBA EQU   JSCBJJSB
JSCBJSBI EQU   JSCBJJSB
@NM00037 EQU   JSCBJJSB
JSCBJNLE EQU   JSCBJJSB
JSCBJNLF EQU   JSCBJJSB
JSCBJNLN EQU   JSCBJJSB
@NM00036 EQU   JSCBSEC3+24
JSCBJRBA EQU   JSCBSEC3+16
JSCBIECB EQU   JSCBSEC3+12
JSCRSV25 EQU   JSCBSEC3+10
JSCBTJID EQU   JSCBASID
JSCBPSCB EQU   JSCBSEC3+4
JSCJCTP  EQU   JSCBJCTA
JSCRSV24 EQU   JSCBJCT
JSCBEND2 EQU   JSCBSEC2
JFCBEND  EQU   JFCBS001+58
JFCBSPTN EQU   JFCBS001+57
JFCBVLCT EQU   JFCBS001+56
JFCBDRLH EQU   JFCBS001+53
JFCBSBNM EQU   JFCBS001+50
JFCBABST EQU   JFCBS001+48
JFCBSPNM EQU   JFCBS001+45
JFCBDQTY EQU   JFCBS001+42
JFCBUAFF EQU   JFCFLGS1
JFCRSV45 EQU   JFCFLGS1
JFCVRDS  EQU   JFCFLGS1
JFCBCEOV EQU   JFCFLGS1
JFCRSV42 EQU   JFCFLGS1
JFCRSV41 EQU   JFCFLGS1
JFCTOPEN EQU   JFCFLGS1
JFCBDLET EQU   JFCFLGS1
JFCRQID  EQU   JFCBSQTY
JFCROUND EQU   JFCBCTRI
JFCALX   EQU   JFCBCTRI
JFCMIXG  EQU   JFCBCTRI
JFCONTIG EQU   JFCBCTRI
JFCRSV29 EQU   JFCBCTRI
JFCBMSGP EQU   JFCBCTRI
JFCBSPAC EQU   JFCBCTRI
JFCRUNIT EQU   JFCBPQTY
JFCBEXAD EQU   JFCBS001+31
JFCBEXTL EQU   JFCBS001+30
JFCMSVGP EQU   JFCBS001+22
@NM00013 EQU   JFCBS001
JFCAVOLS EQU   JFCBVOLS
JFCBNVOL EQU   JFCUCSEG+9
JFCBNTCS EQU   JFCUCSEG+8
JFCSOWA  EQU   JFCOUTLI+1
JFCSEND  EQU   JFCCPRI
JFCEQUAL EQU   JFCCPRI
JFCRECV  EQU   JFCCPRI
JFCRSV34 EQU   JFCCPRI
JFCRSV33 EQU   JFCCPRI
JFCRSV55 EQU   JFCCPRI
JFCRSV54 EQU   JFCCPRI
JFCRSV53 EQU   JFCCPRI
JFCRSV27 EQU   JFCUCSOP
JFCRSV26 EQU   JFCUCSOP
JFCFCBVR EQU   JFCUCSOP
JFCFCBAL EQU   JFCUCSOP
JFCVER   EQU   JFCUCSOP
JFCRSV25 EQU   JFCUCSOP
JFCFOLD  EQU   JFCUCSOP
JFCRSV24 EQU   JFCUCSOP
JFCUCSID EQU   JFCUCSEG
JFCINTVL EQU   JFCSPPRT+19
JFCDBUFN EQU   JFCRESRV+3
JFCCYLOF EQU   JFCRESRV+2
JFCRKP   EQU   JFCRESRV
JFCPCIR2 EQU   JFCPCI
JFCPCIR1 EQU   JFCPCI
JFCPCIN2 EQU   JFCPCI
JFCPCIN1 EQU   JFCPCI
JFCPCIA2 EQU   JFCPCI
JFCPCIA1 EQU   JFCPCI
JFCPCIX2 EQU   JFCPCI
JFCPCIX1 EQU   JFCPCI
JFCBUFMX EQU   JFCNCP
JFCLRECL EQU   JFCAMSYN
JFCBAXBF EQU   JFCBUFSI
JFCREL   EQU   JFCREORG
JFCRSV22 EQU   JFCDEL
JFCSRCHD EQU   JFCRSV20
JFCOPTQ  EQU   JFCACT
JFCFEED  EQU   JFCIND
JFCCBWU  EQU   JFCEXT
JFCWUMSG EQU   JFCOVER
JFCSDNAM EQU   JFCWVCBD
@NM00012 EQU   JFCRECFM
JFCCHAR  EQU   JFCRECFM
JFCRFS   EQU   JFCRECFM
JFCRFB   EQU   JFCRECFM
JFCRFO   EQU   JFCRCFM
JFCFMREC EQU   JFCRCFM
JFCRSV16 EQU   JFCDSRG2
JFCRSV15 EQU   JFCDSRG2
JFCORGTR EQU   JFCDSRG2
JFCRSV13 EQU   JFCDSRG2
JFCORGTQ EQU   JFCDSRG2
JFCORGTX EQU   JFCDSRG2
JFCORGGS EQU   JFCDSRG2
JFCORGU  EQU   JFCDSRG1
JFCORGPO EQU   JFCDSRG1
JFCORGMQ EQU   JFCDSRG1
JFCORGCQ EQU   JFCDSRG1
JFCORGCX EQU   JFCDSRG1
JFCORGDA EQU   JFCDSRG1
JFCORGPS EQU   JFCDSRG1
JFCORGIS EQU   JFCDSRG1
JFCTRKBL EQU   JFCLIMCT+1
@NM00011 EQU   JFCLIMCT
JFCDEN   EQU   JFCSPPRT+1
JFCPRTSP EQU   JFCSPPRT
JFCONE   EQU   JFCMODE
JFCTWO   EQU   JFCMODE
JFCRSV07 EQU   JFCMODE
JFCRSV06 EQU   JFCMODE
JFCMODER EQU   JFCMODE
JFCMODEO EQU   JFCMODE
JFCEBCD  EQU   JFCMODE
JFCBIN   EQU   JFCMODE
JFCRSV32 EQU   JFCCODE
JFCTTY   EQU   JFCCODE
JFCASCII EQU   JFCCODE
JFCNCR   EQU   JFCCODE
JFCBUR   EQU   JFCCODE
JFCFRI   EQU   JFCCODE
JFCBCD   EQU   JFCCODE
JFCNOCON EQU   JFCCODE
@NM00004 EQU   DSABQDB+24
DSQBDSP  EQU   DSABQDB+22
DSQFDSP  EQU   DSABQDB+20
DSQBADFC EQU   DSQLASTP
DSQBADBC EQU   DSQFRSTP
DSQNELMS EQU   DSABQDB+8
DSQDBLN  EQU   DSABQDB+6
DSQATTRS EQU   DSABQDB+4
DSQDBID  EQU   DSABQDB
SMFBUFLP EQU   SMFPARMS+4
SMFBUF1P EQU   SMFPARMS
@NM00051 EQU   DEPARMS+304
DETCTIOL EQU   DEPARMS+300
DETCTIOP EQU   DEPARMS+296
DETDQLST EQU   DEPARMS+280
DEALASTP EQU   DEPARMS+276
DEASGNP  EQU   DEDMYAS+12
@NM00050 EQU   DEDMYAS
DEWLASTP EQU   DEPARMS+256
DEWRITP  EQU   DEDMYEPA+12
@NM00049 EQU   DEDMYEPA
DEDSNQRC EQU   DENQRETN+4
DEDSNQEN EQU   DENQRETN
DECPYLEN EQU   DEPARMS+228
DECPYLOC EQU   DEPARMS+224
DEJSCB   EQU   DEPARMS+220
DESCT    EQU   DEPARMS+216
DEJCT    EQU   DEPARMS+212
DESIOT   EQU   DEPARMS+208
DETCB    EQU   DEPARMS+204
DEALFMAP EQU   DEPARMS+200
DECORE   EQU   DEPARMS
@NM00048 EQU   PROCESSW+1
HSKPDQSW EQU   PROCESSW+1
DISMSGSW EQU   PROCESSW+1
USERERSW EQU   PROCESSW+1
EPALSISW EQU   PROCESSW+1
EPASCTSW EQU   PROCESSW+1
EPAJCTSW EQU   PROCESSW
FRRPERSW EQU   PROCESSW
DCBSPCSW EQU   PROCESSW
NQEXCLSW EQU   PROCESSW
UNALOCSW EQU   ERRPROSW
DEQDSNSW EQU   ERRPROSW
COPYSW   EQU   PROCESSW
@NM00047 EQU   PROCESSW
@NM00046 EQU   INPUTSW+3
PCATINIT EQU   INPUTSW+3
UNITDEVT EQU   INPUTSW+3
MOUNTSW  EQU   INPUTSW+2
CATLOGSW EQU   INPUTSW+2
TIOTNQSW EQU   INPUTSW+2
OFFLINSW EQU   INPUTSW+2
WTUNTSW  EQU   INPUTSW+2
NORESSW  EQU   INPUTSW+2
WTDSNSW  EQU   INPUTSW+2
WTVOLSW  EQU   INPUTSW+2
@NM00045 EQU   INPUTSW
JOBRLSYS EQU   INPUTSW
NOMONTSW EQU   INPUTSW
NOCNVTSW EQU   INPUTSW
ONCNVTSW EQU   INPUTSW
SCTPTR   EQU   CTLBLKPS+16
JCTPTR   EQU   CTLBLKPS+12
TCBPTR   EQU   CTLBLKPS+8
ASCBPTR  EQU   CTLBLKPS+4
JESPJESN EQU   JESCT+28
JESSSCT  EQU   JESCT+24
JESRESQM EQU   JESCT+16
JESQMGR  EQU   JESCT+12
JESUNITS EQU   JESCT+4
@NM00042 EQU   JESCT
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00041 EQU   CVTFIX+248
@NM00040 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRSV37 EQU   CVTDMSR
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
TIOTFEND EQU   POOLSTAR+16
TIOPSLOT EQU   POOLSTAR+13
TIOPSTTB EQU   POOLSTAR+12
TIOPPOOL EQU   POOLSTAR+4
TIOPNSRT EQU   POOLSTAR+3
@NM00039 EQU   POOLSTAR+2
TIOPNSLT EQU   POOLSTAR+1
@NM00038 EQU   POOLSTAR
TIOEFSRT EQU   TIOENTRY+17
TIOSVERF EQU   TIOESTTB
TIOSUNLD EQU   TIOESTTB
TIOSMNTD EQU   TIOESTTB
TIOSSETU EQU   TIOESTTB
TIOSVLSR EQU   TIOESTTB
TIOSPVIO EQU   TIOESTTB
TIOSREQD EQU   TIOESTTB
TIOSUSED EQU   TIOESTTB
TIOSBALS EQU   TIOESTTC
TIOSBALP EQU   TIOESTTC
TIOSVOLS EQU   TIOESTTC
TIOSVOLP EQU   TIOESTTC
TIOSAFFS EQU   TIOESTTC
TIOSAFFP EQU   TIOESTTC
TIOSDEFR EQU   TIOESTTC
TIOSDKCR EQU   TIOESTTC
TIOEJFCB EQU   TIOENTRY+12
TIOTREM  EQU   TIOELINK
TIOESSDS EQU   TIOESYOT
TIOESYIN EQU   TIOELINK
TIOEQNAM EQU   TIOELINK
TIOEDYNM EQU   TIOELINK
TIOTTERM EQU   TIOELINK
TIOTRV01 EQU   TIOELINK
TIOSYOUT EQU   TIOELINK
TIOEWTCT EQU   TIOERLOC
TIOSDSP2 EQU   TIOESTTA
TIOSDSP1 EQU   TIOESTTA
TIOSLABL EQU   TIOESTTA
TIOSDADS EQU   TIOESTTA
TIOSJBLB EQU   TIOESTTA
TIOSPLTS EQU   TIOESTTA
TIOSPLTP EQU   TIOESTTA
TIOSLTYP EQU   TIOESTTA
TIOELNGH EQU   TIOENTRY
TIOCSTEP EQU   TIOT1+8
TIOCNJOB EQU   TIOT1
JSCBCSCB EQU   JSCBSEC1+68
JSCBPMG  EQU   JSCBWTP+2
JSCBWTSP EQU   JSCBWTP+1
JSCRSV23 EQU   JSCBWTFG
JSCRSV22 EQU   JSCBWTFG
JSCRSV21 EQU   JSCBWTFG
JSCRSV20 EQU   JSCBWTFG
JSCRSV19 EQU   JSCBWTFG
JSCRSV18 EQU   JSCBWTFG
JSCBRET  EQU   JSCBWTFG
JSCBIOFG EQU   JSCBWTFG
@NM00035 EQU   JSCBSEC1+60
JSCBQMPI EQU   JSCBSEC1+56
JSCBPMSG EQU   JSCBSWT1
JSCRSV16 EQU   JSCBSWT1
JSCRSV15 EQU   JSCBSWT1
JSCRSV14 EQU   JSCBSWT1
JSCRSV13 EQU   JSCBSWT1
JSCRSV12 EQU   JSCBSWT1
JSCRSV11 EQU   JSCBSWT1
JSCBPASS EQU   JSCBSWT1
JSCBTTTR EQU   JSCBSEC1+52
JSCRSV10 EQU   JSCBSEC1+49
JSCBAUTH EQU   JSCBOPTS
JSCSIOTS EQU   JSCBOPTS
JSCRSV08 EQU   JSCBOPTS
JSCRSV07 EQU   JSCBOPTS
JSCRSV06 EQU   JSCBOPTS
JSCBLONG EQU   JSCBOPTS
JSCRSV05 EQU   JSCBOPTS
JSCRSV04 EQU   JSCBOPTS
JSCBSECB EQU   JSCBSEC1+44
JSCRSV03 EQU   JSCBSEC1+41
JSCBSTEP EQU   JSCBSEC1+40
JSCBDCBA EQU   JSCBDCB+1
JSCRSV02 EQU   JSCBDCB
JSCBID   EQU   JSCBSEC1+32
JSCBDBTB EQU   JSCBSEC1+28
JSCBIJSC EQU   JSCBSEC1+24
JSCBTCBP EQU   JSCBSEC1+20
JSCBPCC  EQU   JSCBSEC1+16
JSCBTCP  EQU   JSCBSEC1+12
JSCBSHR  EQU   JSCBSEC1+8
JSCHPCEA EQU   JSCHPCE+1
JSCRSV32 EQU   JSCHPCE
JSCRSV01 EQU   JSCBSEC1
@NM00034 EQU   IEZJSCB
SIODDSNL EQU   INDMSIOT+173
SIOVDSNL EQU   INDMSIOT+172
SIOVDSNT EQU   INDMSIOT+170
SVOLUNNO EQU   INDMSIOT+168
SIOTVMVP EQU   INDMSIOT+164
SIOTNPTR EQU   INDMSIOT+152
SIOTETIO EQU   INDMSIOT+148
SIOTATE  EQU   INDMSIOT+144
SVOLUNAD EQU   INDMSIOT+140
SIOTEDLP EQU   INDMSIOT+136
SIOTEDLS EQU   INDMSIOT+132
SIOTRSNC EQU   INDMSIOT+130
SCTANAME EQU   INDMSIOT+122
@NM00033 EQU   INDMSIOT+108
SIOTSSNM EQU   INDMSIOT+104
SIODDQCR EQU   SIOTBYT2
SIOVDQCR EQU   SIOTBYT2
SIOTCVOL EQU   SIOTBYT2
SIOTCNEW EQU   SIOTBYT2
SIOTCALC EQU   SIOTBYT2
SIOTDSPD EQU   SIOTBYT2
SIOTDMND EQU   SIOTBYT2
SIOTOPUC EQU   INDMSIOT+99
SIOTOUTR EQU   INDMSIOT+97
SIOTOUTC EQU   INDMSIOT+96
@NM00032 EQU   INDMSIOT+93
SIOTAUNC EQU   SIOTALTD
SIOTACAT EQU   SIOTALTD
SIOTADEL EQU   SIOTALTD
SIOTAKEP EQU   SIOTALTD
SIOTNPRV EQU   SIOTALTD
SIOJCATS EQU   SIOTALTD
@NM00031 EQU   SIOTALTD
@NM00030 EQU   SIOTALTD
@NM00029 EQU   INDMSIOT+91
SIOTNDSB EQU   INDMSIOT+88
@NM00028 EQU   INDMSIOT+84
SIOTDPCD EQU   INDMSIOT+82
@NM00027 EQU   INDMSIOT+81
SCTOUTPN EQU   INDMSIOT+80
SCTOUTNO EQU   INDMSIOT+76
SCTOUTNM EQU   INDMSIOT+68
SIOUCBAD EQU   SCTUTYPE+5
SIOUCNVT EQU   SCTUTYPE+4
SIOUBYT4 EQU   SIOTDEVT+3
@NM00026 EQU   SIOUBYT3
SIO3UREC EQU   SIOUBYT3
SIO3DISP EQU   SIOUBYT3
SIO3DACC EQU   SIOUBYT3
SIO3COMM EQU   SIOUBYT3
SIO3TAPE EQU   SIOUBYT3
SIOUBYT2 EQU   SIOTDEVT+1
SIOUBYT1 EQU   SIOTDEVT
SIOTOMN  EQU   SCTSBYT4
SIOTIPDI EQU   SCTSBYT4
SIOTVAFF EQU   SCTSBYT4
SIOTSTEP EQU   SCTSBYT4
SIOTASCI EQU   SCTSBYT4
@NM00025 EQU   SCTSBYT4
SIOTGDGA EQU   SCTSBYT4
SCTSGDGS EQU   SCTSBYT4
SCTSOLD  EQU   SCTSBYT3
SCTSMOD  EQU   SCTSBYT3
SCTSNEW  EQU   SCTSBYT3
SCTSYSOU EQU   SCTSBYT3
SCTVREF  EQU   SCTSBYT3
@NM00024 EQU   SCTSBYT3
SCTSYSNE EQU   SCTSBYT3
SCTDSNRF EQU   SCTSBYT3
SCTRECVD EQU   SCTSBYT2
SCTDEFER EQU   SCTSBYT2
SCTLABEL EQU   SCTSBYT2
SCTUNLBD EQU   SCTSBYT2
SCTJOBLB EQU   SCTSBYT2
SCTVOLAF EQU   SCTSBYT2
SIOTCATL EQU   SCTSBYT2
SIOCLUNL EQU   SCTSBYT2
SIOTJSCT EQU   SCTSBYT1
SCTUNAFF EQU   SCTSBYT1
SCTPARLM EQU   SCTSBYT1
SIOTQDSN EQU   SCTSBYT1
SIOTGDSN EQU   SCTSBYT1
SIOTCCAT EQU   SCTSBYT1
SCTSYSIN EQU   SCTSBYT1
SIOTUNCT EQU   SCTSDISP
SIOTCTLG EQU   SCTSDISP
SIOTKEEP EQU   SCTSDISP
SIOTPASS EQU   SCTSDISP
SIOTPRIV EQU   SCTSDISP
S3400DSP EQU   SCTSDISP
@NM00023 EQU   SCTSDISP
SIOTVLCT EQU   INDMSIOT+54
SCTNMBUT EQU   INDMSIOT+53
SIOTRTRY EQU   SIOTBYT0
SIOTPUPV EQU   SIOTBYT0
SIOTNOPV EQU   SIOTBYT0
SIOTGIGN EQU   SIOTBYT0
SPVTAMSG EQU   SIOTBYT0
SIOTFUDA EQU   SIOTBYT0
SIOTDYAL EQU   SIOTBYT0
SIOTSSDS EQU   SIOTBYT0
SIOTGIID EQU   INDMSIOT+50
SCTVOLCT EQU   INDMSIOT+49
SCTSPOOL EQU   INDMSIOT+48
@NM00022 EQU   SIOTTSTC
@NM00021 EQU   SIOTTSTC
@NM00020 EQU   SIOTBYT3
SIOTJES3 EQU   SIOTBYT3
SIOCDEVT EQU   SIOTBYT3
SCTDDINO EQU   INDMSIOT+44
SIOTDDNT EQU   SIOTBYT1
SIOTALCD EQU   SIOTBYT1
SIODADSM EQU   SIOTBYT1
SIOTDADR EQU   SIOTBYT1
SIODUNAL EQU   SIOTBYT1
SIOVAMDS EQU   SIOTBYT1
SIOTHOLD EQU   SIOTBYT1
SIOTOCKP EQU   SIOTBYT1
SIOPSCNT EQU   INDMSIOT+42
SIOTREFN EQU   INDMSIOT+40
SIOTOTUN EQU   INDMSIOT+39
SIOTVRSB EQU   INDMSIOT+36
@NM00019 EQU   INDMSIOT+35
SCTPJFCB EQU   INDMSIOT+32
@NM00018 EQU   INDMSIOT+31
SCTPSIOT EQU   INDMSIOT+28
SIOTAFID EQU   INDMSIOT+26
@NM00017 EQU   INDMSIOT+24
SIODSNTE EQU   INDMSIOT+22
SIOTUNAF EQU   SCTUSADD
SIOTDEST EQU   INDMSIOT+12
SIOTTYPE EQU   INDMSIOT+3
SIOTDSKA EQU   INDMSIOT
JFCBXNXT EQU   JFCBX+172
@NM00016 EQU   JFCBX+144
JFCBXDEV EQU   JFCBX+140
@NM00015 EQU   JFCBX+94
JFCBXVOL EQU   JFCBX+4
@NM00014 EQU   JFCBX+3
JFCBXTTR EQU   JFCBX
JFCRSV05 EQU   JFCEROPT
JFCRSV04 EQU   JFCEROPT
JFCRSV03 EQU   JFCEROPT
JFCRSV02 EQU   JFCEROPT
JFCTOPT  EQU   JFCEROPT
JFCABN   EQU   JFCEROPT
JFCSKP   EQU   JFCEROPT
JFCACC   EQU   JFCEROPT
JFCBUFL  EQU   JFCAMPTR+2
JFCFWORD EQU   JFCBFTEK
JFCDWORD EQU   JFCBFTEK
JFCHIER1 EQU   JFCBFTEK
JFCDYN   EQU   JFCBFTEK
JFCEXC   EQU   JFCBFTEK
JFCBBFTR EQU   JFCBBFTA
JFCSIM   EQU   JFCBBFTA
JFCHIER  EQU   JFCBFTEK
JFCBFOUT EQU   JFCBUFNO
JFCBUFIN EQU   JFCBUFNO
JFCTEMP  EQU   JFCBIND2
JFCREQ   EQU   JFCBIND2
JFCENT   EQU   JFCBIND2
JFCSECUR EQU   JFCBIND2
JFCDISP  EQU   JFCBIND2
JFCPDS   EQU   JFCBIND1
JFCGDG   EQU   JFCBIND1
JFCADDED EQU   JFCBIND1
JFCLOC   EQU   JFCBIND1
JFCRLSE  EQU   JFCBIND1
JFCBXPDT EQU   INFMJFCB+83
JFCBCRDT EQU   INFMJFCB+80
JFCBOPS2 EQU   JFCBMASK+7
JFCRCTLG EQU   JFCBFLG2
JFCBBUFF EQU   JFCBFLG2
JFCTRACE EQU   JFCBFLG2
JFCSDRPS EQU   JFCBFLG2
JFCMODNW EQU   JFCBFLG2
JFCNRPS  EQU   JFCDEFER
JFCOUTOP EQU   JFCBFLG2
JFCINOP  EQU   JFCBFLG2
JFCBPWBP EQU   JFCOPEN
@NM00010 EQU   JFCOPEN
JFCDUAL  EQU   JFCBFLG1
JFCSLDES EQU   JFCBFLG1
JFCSLCRE EQU   JFCBFLG1
JFCSTAND EQU   JFCBFLG1
JFCBOPS1 EQU   JFCBMASK
JFCBVLSQ EQU   INFMJFCB+70
JFCRSV31 EQU   JFCFUNC
JFCFNCBT EQU   JFCFUNC
JFCFNCBX EQU   JFCFUNC
JFCFNCBD EQU   JFCFUNC
JFCFNCBW EQU   JFCFUNC
JFCFNCBP EQU   JFCFUNC
JFCFNCBR EQU   JFCFUNC
JFCFNCBI EQU   JFCFUNC
JFCBFOFL EQU   JFCBUFOF
JFCNL    EQU   JFCBLTYP
JFCSL    EQU   JFCBLTYP
JFCNSL   EQU   JFCBLTYP
JFCSUL   EQU   JFCBLTYP
JFCBLP   EQU   JFCBLTYP
JFCBLTM  EQU   JFCBLTYP
JFCBAL   EQU   JFCBLTYP
JFCRSV38 EQU   JFCBLTYP
JFCVINDX EQU   INFMJFCB+64
JFCNLREC EQU   INFMJFCB+62
JFCBADBF EQU   INFMJFCB+60
JFCAMSTR EQU   JFCBFRID+2
JFCAMCRO EQU   JFCBFRID
JFCBDSCB EQU   INFMJFCB+53
JFCPAT   EQU   JFCBTSDM
JFCNDCB  EQU   JFCBTSDM
JFCNDSCB EQU   JFCBTSDM
JFCNWRIT EQU   JFCBTSDM
JFCTTR   EQU   JFCBTSDM
JFCSDS   EQU   JFCBTSDM
JFCVSL   EQU   JFCBTSDM
JFCCAT   EQU   JFCBTSDM
JFCIPLTX EQU   JFCBELNM
JFCBQNAM EQU   JFCBDSNM
DSABGRID EQU   DSABGIDL+4
DSABLLEN EQU   DSABGIDL
DSABRS04 EQU   DSAB+68
DSABRS03 EQU   DSAB+62
DSABDCBM EQU   DSAB+56
DSABSSCM EQU   DSAB+52
DSABSSNM EQU   DSAB+48
DSABPTTR EQU   DSAB+44
DSABTCBP EQU   DSAB+40
DSABRS02 EQU   DSAB+38
@NM00009 EQU   DSABFLG4
DSABCKSI EQU   DSABFLG4
DSABCKVL EQU   DSABFLG4
DSABCKDS EQU   DSABFLG4
@NM00008 EQU   DSABFLG3
DSABJSCT EQU   DSABFLG3
DSABVMSC EQU   DSABFLG3
DSABVAM  EQU   DSABFLG3
DSABPASS EQU   DSABFLG3
DSABDEFR EQU   DSABFLG3
@NM00007 EQU   DSABFLG2
DSABUNAL EQU   DSABFLG2
DSABIRM  EQU   DSABFLG2
DSABOPEN EQU   DSABFLG2
DSABDCAT EQU   DSABFLG1
DSABCONV EQU   DSABFLG1
DSABDCNV EQU   DSABFLG1
DSABDALC EQU   DSABFLG1
@NM00006 EQU   DSABORG2
DSABTR   EQU   DSABORG2
DSABAM   EQU   DSABORG2
@NM00005 EQU   DSABORG2
DSABTQ   EQU   DSABORG2
DSABTX   EQU   DSABORG2
DSABGS   EQU   DSABORG2
DSABU    EQU   DSABORG1
DSABPO   EQU   DSABORG1
DSABMQ   EQU   DSABORG1
DSABCQ   EQU   DSABORG1
DSABCX   EQU   DSABORG1
DSABDA   EQU   DSABORG1
DSABPS   EQU   DSABORG1
DSABIS   EQU   DSABORG1
DSABSSVA EQU   DSAB+21
DSABRS01 EQU   DSAB+20
DSABLNTH EQU   DSAB+12
DSABID   EQU   DSAB
QDBRV002 EQU   QDB+28
QDBPRDS  EQU   QDB+26
QDBPRSZ  EQU   QDB+24
QDBBPTDS EQU   QDB+22
QDBFPTDS EQU   QDB+20
QDBLELMP EQU   QDB+16
QDBFELMP EQU   QDB+12
QDBNELMS EQU   QDB+8
QDBRV001 EQU   QDB+6
QDBATTR  EQU   QDB+4
QDBQDB   EQU   QDB
TEXTUPRM EQU   TEXTUFLD+2
TEXTULEN EQU   TEXTUFLD
TEXTUNUM EQU   TEXTUNIT+2
TEXTUKEY EQU   TEXTUNIT
TXTPLEND EQU   TXTPLENT
TXTUPEND EQU   TXTUNITP
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00199 EQU   @RC00198
@RC00190 EQU   @RC00184
@RC00225 EQU   @RC00184
@RC00259 EQU   @RC00254
@RF00339 EQU   @RC00313
@RC00368 EQU   @RC00365
@RC00366 EQU   @RC00365
@RC00384 EQU   @RC00383
@RF00170 EQU   @EL00001
@RF00440 EQU   @EL00001
@RC00200 EQU   @RC00199
@RC00228 EQU   @RC00225
@RF00262 EQU   @RC00259
@ENDDATA EQU   *
         END   IEFDB4A0,(C'PLS0323',0603,75024)
