         TITLE 'IEFDB4A1 - DYNAMIC UNALLOCATION PROCESSOR              *
                        '
IEFDB4A1 CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(24)                                          01S0001
         DC    C'IEFDB4A1 78089  UZ17548 '                      01S0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01S0001
         BALR  @11,0                                            01S0001
@PSTART  LA    @12,4095(,@11)                                   01S0001
         USING @PSTART,@11                                      01S0001
         USING @PSTART+4095,@12                                 01S0001
         L     @00,@SIZDATD                                     01S0001
         GSPACE   R,LV=(0)
         LR    @10,@01                                          01S0001
         USING @DATD,@10                                        01S0001
         ST    @13,@SA00001+4                                   01S0001
         LM    @00,@01,20(@13)                                  01S0001
         ST    @10,8(,@13)                                      01S0001
         LR    @13,@10                                          01S0001
         MVC   @PC00001(32),0(@01)                              01S0001
JSCBDISP EQU 188
JSCBAOS1 EQU  72
JSCBAOS2 EQU 192
*CMUNFMAP = CMUNFMAP && CMUNFMAP;      /*ZERO OUT FUNCTION MAP       */
         LA    @15,FNCTMAP                                      01S0134
         XC    CMUNFMAP(4,@15),CMUNFMAP(@15)                    01S0134
*CMDISPRC = '1'B;                      /*PROCESS DISPOSITIONS        */
*CMDSRLSE = '1'B;                      /*RELEASE DATA SETS           */
*CMUNUNIT = '1'B;                      /*UNALLOCATE UNITS            */
*CMVLRLSE = '1'B;                      /*RELEASE VOLUMES             */
*CMFDSABS = '1'B;                      /*FREE DSABS                  */
         OI    CMDISPRC(@15),B'00101111'                        01S0139
*CMRDDENT = '1'B;                      /*RELEASE TIOT DD ENTRIES     */
*CMTIOTNQ = '1'B;                      /*TIOT IS ENQ'D ON            */
         OI    CMRDDENT(@15),B'00001001'                        01S0141
*CMJES3='1'B;                          /*INVOKE JES3         @Y30QPPB*/
         OI    CMJES3(@15),B'00000001'                          01S0142
*IF INCMALL = '1'B THEN                /*IF MSGLEVEL = 1             */
         L     @14,@PC00001+16                                  01S0143
         L     @01,JCTPTR(,@14)                                 01S0143
         TM    INCMALL(@01),B'10000000'                         01S0143
         BNO   @RF00143                                         01S0143
*  CMDMSGS = '1'B;                     /*ISSUE MESSAGES              */
         OI    CMDMSGS(@15),B'10000000'                         01S0144
*IF BASTCNT ^= 0 THEN                  /*IF MONITOR STATUS COUNT ^= 0*/
@RF00143 L     @01,CVTPTR                                       01S0145
         L     @01,CVTMSER(,@01)                                01S0145
         LH    @15,BASTCNT(,@01)                                01S0145
         LTR   @15,@15                                          01S0145
         BZ    @RF00145                                         01S0145
*  CMMNSTAT = '1'B;                    /*SET MONITOR STATUS BIT      */
         LA    @15,FNCTMAP                                      01S0146
         OI    CMMNSTAT(@15),B'01000000'                        01S0146
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - RBBUILD                                           */
*/*                                                                  */
*/* DESCRIPTIVE NAME - REQUEST BLOCK BUILD                           */
*/*                                                                  */
*/* FUNCTION  - ISSUE GETMAIN FOR AND FILL IN REQUEST BLOCKS FOR     */
*/*             COMMON UNALLOCATION, AND SMF PARM LIST ENTRIES.      */
*/*                                                                  */
*/* OPERATION - A SCAN OF THE LIST OF DSABPTRS IS MADE, DETERMINING  */
*/*             THE NUMBER OF ALLOCATIONS TO BE UNALLOCATED,         */
*/*             COUNTING ONE FOR EACH DSABPTR IN THE LIST AND ONE FOR*/
*/*             ANY DSAB THAT IS PERMANENTLY CONCATENATED TO IT.     */
*/*             A GETMAIN IS THEN ISSUED FOR CORE FOR THIS NUMBER    */
*/*             OF COMMON UNALLOCATION REQUEST BLOCKS (INCLUDING     */
*/*             THE OPTIONAL FIELD PTR IF OVERRIDING SYSOUT          */
*/*             USER WAS SPECIFIED), AND FOR SMF PARM LIST           */
*/*             ENTRIES. FOR EACH DSAB TO BE UNALLOCATED, A          */
*/*             REQUEST BLOCK IS FILLED IN AND CHAINED TO THE        */
*/*             PRECEEDING RB. ALSO AN ENTRY IN THE SMF PARM         */
*/*             LIST IS FILLED IN. THIS LIST IS BUILT NOW AS         */
*/*             TIOT ENTRIES ARE FREED DURING UNALLOCATION,          */
*/*             DISALLOWING THE BUILDING OF THE PARM LIST            */
*/*             AFTER INVOKING COMMON UNALLOCATION.                  */
*/*                                                                  */
*/* ENTRY -                                                          */
*/*   INPUT DATA - DSABPLST - LIST OF PTRS TO DSABS FOR UNALLOCATION */
*/*                DSABPCNT - COUNT OF DSABPTRS IN LIST              */
*/*                UNALKEYT - UNALLOCATION KEY TABLE                 */
*/*                                                                  */
*/* EXIT -                                                           */
*/*  OUTPUT DATA - CHAIN OF COMMON UNALLOCATION REQUEST BLOCKS       */
*/*                SMF PARAMETER LIST BUILT                          */
*/*                                                                  */
*/********************************************************************/
*IF OVSUSTUP ^= 0 THEN                 /*IF OVERRIDING USER WAS SPECD*/
@RF00145 L     @15,@PC00001+20                                  02S0147
         L     @01,KEYTABP(,@15)                                02S0147
         L     @15,OVSUSTUP(,@01)                               02S0147
         LTR   @15,@15                                          02S0147
         BZ    @RF00147                                         02S0147
*  DO;                                 /*WILL NEED OPTIONAL RB FLD   */
*    OPTFLDLN = 4;                     /*SET OPTFLDLN FOR RB GETMAIN */
         LA    OPTFLDLN,4                                       02S0149
*    RFY TEXTUNIT BASED(OVSUSTUP);     /*RESET TEXT UNIT BASE PTR    */
*    OVRDNGID = '';                    /*BLANK OUT 8 BYTE WORKAREA   */
         MVI   OVRDNGID,C' '                                    02S0151
         MVC   OVRDNGID+1(7),OVRDNGID                           02S0151
*    OVRDNGID(1:TEXTULNG) = TEXTUPAR(1:TEXTULNG);               02S0152
         ICM   @09,12,TEXTULNG(@15)                             02S0152
         SRA   @09,16                                           02S0152
         BCTR  @09,0                                            02S0152
         EX    @09,@SM02875                                     02S0152
*                                      /*MOVE ID INTO WORKAREA       */
*  END;                                /*END IF SYSOUT USER SPECD    */
*ELSE                                  /*SYSOUT USER NOT SPEC'D      */
*  OPTFLDLN = 0;                       /*DON'T NEED OPTIONAL FIELD   */
         B     @RC00147                                         02S0154
@RF00147 SLR   OPTFLDLN,OPTFLDLN                                02S0154
*COUNT = 0;                            /*INIT TOTAL COUNT OF RBS     */
@RC00147 SLR   COUNT,COUNT                                      02S0155
*DO WRKINDEX = 1 BY 1 WHILE WRKINDEX <= DSABPCNT;               02S0156
         LA    WRKINDEX,1                                       02S0156
         B     @DE00156                                         02S0156
@DL00156 DS    0H                                               02S0157
*                                      /*LOOP THROUGH DSAB PTR LIST  */
*  DSABPTR = DSABPLST(WRKINDEX);       /*POINT TO DSAB IN LIST       */
         LR    @09,WRKINDEX                                     02S0157
         SLA   @09,2                                            02S0157
         L     @06,@PC00001                                     02S0157
         L     @06,DSABPLP(,@06)                                02S0157
         AL    @06,@CF02877                                     02S0157
         L     DSABPTR,DSABPLST(@09,@06)                        02S0157
*  COUNT = COUNT + 1;                  /*INCREMENT TOTAL COUNT OF RBS*/
         AL    COUNT,@CF00088                                   02S0158
*  DO WHILE (DSABFCHN ^= 0  &          /*LOOP TO END OF CHAIN OR     */
*      DSABFCHN->DSABSIOT->SCTDDNAM(1) = ' ');                  02S0159
         B     @DE00159                                         02S0159
@DL00159 DS    0H                                               02S0160
*                                      /*TO END OF PERM. CONCAT GROUP*/
*    COUNT = COUNT + 1;                /*INCREMENT TOTAL COUNT OF RBS*/
         AL    COUNT,@CF00088                                   02S0160
*    DSABPTR = DSABFCHN;               /*POINT TO NEXT DSAB          */
         L     DSABPTR,DSABFCHN(,DSABPTR)                       02S0161
*  END;                                /*END LOOP FOR TOTAL COUNT    */
@DE00159 L     @09,DSABFCHN(,DSABPTR)                           02S0162
         LTR   @09,@09                                          02S0162
         BZ    @DC00159                                         02S0162
         L     @09,DSABSIOT(,@09)                               02S0162
         CLI   SCTDDNAM(@09),C' '                               02S0162
         BE    @DL00159                                         02S0162
@DC00159 DS    0H                                               02S0163
*END;                                  /*END LOOP THROUGH LIST       */
         AL    WRKINDEX,@CF00088                                02S0163
@DE00156 L     @09,@PC00001+4                                   02S0163
         C     WRKINDEX,DSABPCNT(,@09)                          02S0163
         BNH   @DL00156                                         02S0163
*R0 = COUNT * (LENGTH(CMUNRB)+OPTFLDLN+LENGTH(SMFARRAY(1)));    02S0164
         LA    @01,21                                           02S0164
         ALR   @01,OPTFLDLN                                     02S0164
         MR    R0,COUNT                                         02S0164
         LR    R0,@01                                           02S0164
*                                      /*CORE SIZE OF RBS & SMF ARRAY*/
*R0 = R0 |SCHDSUBP;                    /*GET FROM CORRECT SUBPOOL    */
         O     R0,@CF00118                                      02S0165
*GEN (GETMAIN R,LV=(0));               /*GET CORE FOR UNALLOC REQ BLK*/
         GETMAIN R,LV=(0)
*CMRBPTR = R1;                         /*POINT TO FIRST RB           */
         LR    CMRBPTR,R1                                       02S0167
*FSTRBPTR = R1;                        /*INIT PTR TO FIRST RB        */
         ST    R1,FSTRBPTR                                      02S0168
*SMFARYP = R1 + COUNT *(LENGTH(CMUNRB)+OPTFLDLN);               02S0169
         LA    @05,16                                           02S0169
         ALR   @05,OPTFLDLN                                     02S0169
         MR    @04,COUNT                                        02S0169
         ALR   @05,R1                                           02S0169
         ST    @05,SMFARYP                                      02S0169
*                                      /*INIT PTR TO SMF ARRAY       */
*SMFAINDX = 0;                         /*INIT INDEX INTO SMF ARRAY   */
         SLR   SMFAINDX,SMFAINDX                                02S0170
*DO WRKINDEX = 1 BY 1 WHILE WRKINDEX <= DSABPCNT;               02S0171
         LA    WRKINDEX,1                                       02S0171
         B     @DE00171                                         02S0171
@DL00171 DS    0H                                               02S0172
*                                      /*LOOP THROUGH DSABPTR LIST   */
*  DSABPTR = DSABPLST(WRKINDEX);       /*POINT TO DSAB IN LIST       */
         LR    @06,WRKINDEX                                     02S0172
         SLA   @06,2                                            02S0172
         L     @02,@PC00001                                     02S0172
         L     @02,DSABPLP(,@02)                                02S0172
         AL    @02,@CF02877                                     02S0172
         L     DSABPTR,DSABPLST(@06,@02)                        02S0172
*  OUT = '0'B;                         /*INIT LOOP CONTROL SWITCH    */
         NI    OUT,B'01111111'                                  02S0173
*  DO WHILE OUT = '0'B;                /*LOOP TO FILL IN  REQUEST BKS*/
         B     @DE00174                                         02S0174
@DL00174 DS    0H                                               02S0175
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - RBFILLIN                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - COMMON UNALLOCATION REQUEST BLOCK FILL IN     */
*/*                                                                  */
*/* OPERATION - THIS SEGMENT SETS THE APPROPRIATE BITS AND FIELDS    */
*/*             OF THE COMMON UNALLOCATION REQUEST BLOCK AND USES    */
*/*             THE FOLLOWING LOGIC:                                 */
*/*                                                                  */
*/*             .DISPOSITION PROCESSING IS TO BE BYPASSED FOR        */
*/*              DUMMY DATA SETS.                                    */
*/*             .THE NORMAL DISP OF THE SIOT IS TO BE USED IF NO     */
*/*              OVERRIDING DISP WAS SPECIFIED, OR IF ONE WAS,       */
*/*              BUT THE DATA SET IS A PASSED DATA SET,              */
*/*              IS A VSAM D.S., OR IS A NON SUBSYSTEM               */
*/*              D.S. WITH A GENERATED NAME. (IN THESE LATTER CASES, */
*/*              AN INFO CODE OF 8 IS RETURNED SAYING THE OVERRIDE   */
*/*              WAS IGNORED.) OTHERWISE, THE OVERRIDING DISP IS     */
*/*              USED.                                               */
*/*             .A DETERMINATION IS MADE AS TO WHETHER OR NOT        */
*/*              DATA SET RELEASE SHOULD BE PROCESSED FOR THIS SIOT. */
*/*              SEE DSRELCHK SEGMENT FOR THESE CHECKS.              */
*/*             .IF THE D.S. WAS JCL ALLOCATED, MULTIPLY ALLOCATED   */
*/*              UNITS AND VOLUMES MUST BE CHECKED FOR. OTHERWISE,   */
*/*              IT WAS DYNAMICALLY ALLOCATED AND MULTIPLY ALLOCATED */
*/*              VOLUMES MUST BE CHECKED FOR ON DASD ONLY.           */
*/*             .OVERRIDING SYSOUT INFORMATION WILL BE PROCESSED     */
*/*              AS SPECIFIED.                                       */
*/*                                                                  */
*/* ENTRY -                                                          */
*/*   INPUT DATA - COMMON UNALLOCATION REQUEST BLOCK TO BE FILLED IN */
*/*              - SIOT TO BE UNALLOCATED                            */
*/*              - UNALLOCATION KEY TABLE                            */
*/*                                                                  */
*/* EXIT -                                                           */
*/*  OUTPUT DATA - REQUEST BLOCK FILLED IN                           */
*/*              - INFOCODE OF 8 IF OVERRIDING DISP WAS IGNORED      */
*/*                FOR A PARTICULAR ALLOCATION                       */
*/*                                                                  */
*/********************************************************************/
*CMUNRB = CMUNRB && CMUNRB;            /*ZERO OUT REQUEST BLOCK      */
         XC    CMUNRB(16,CMRBPTR),CMUNRB(CMRBPTR)               03S0175
*CMSIOPTR = DSABSIOT;                  /*POINT TO SIOT FOR UNALLOC   */
*                                                               03S0176
         L     @06,DSABSIOT(,DSABPTR)                           03S0176
         ST    @06,CMSIOPTR(,CMRBPTR)                           03S0176
*IF SCTDUMMY = '1'B THEN               /*IF DATA SET IS A DUMMY      */
         TM    SCTDUMMY(@06),B'10000000'                        03S0177
         BNO   @RF00177                                         03S0177
*  CMNODISP = '1'B;                    /*BYPASS DISP PROCESSING      */
         OI    CMNODISP(CMRBPTR),B'10000000'                    03S0178
*ELSE                                  /*DATA SET IS NOT DUMMY       */
*  IF OVDSPTUP = 0 THEN                /*IF NO OVERRIDING DISP SPEC'D*/
         B     @RC00177                                         03S0179
@RF00177 L     @06,@PC00001+20                                  03S0179
         L     @06,KEYTABP(,@06)                                03S0179
         L     @06,OVDSPTUP(,@06)                               03S0179
         LTR   @06,@06                                          03S0179
         BNZ   @RF00179                                         03S0179
*    CMNMDISP = '1'B;                  /*USE NORMAL DISP             */
         OI    CMNMDISP(CMRBPTR),B'01000000'                    03S0180
*  ELSE                                /*OVERRIDING DISP WAS SPEC'D  */
*    IF SIOTPASS = '1'B         |      /*IF DATA SET HAS PASS DISP,  */
*       JFCORGAM = '1'B         |      /*OR IS A VSAM DATA SET       */
*       (SIOTGDSN = '1'B &             /*OR HAS A GENERATED DSN AND  */
*        SIOTSSDS = '0'B) THEN         /*IS NOT A SUBSYSTEM DATA SET */
         B     @RC00179                                         03S0181
@RF00179 L     @06,CMSIOPTR(,CMRBPTR)                           03S0181
         TM    SIOTPASS(@06),B'00010000'                        03S0181
         BO    @RT00181                                         03S0181
         L     @02,SJFCBPTR(,@06)                               03S0181
         TM    JFCORGAM(@02),B'00001000'                        03S0181
         BO    @RT00181                                         03S0181
         TM    SIOTGDSN(@06),B'00010000'                        03S0181
         BNO   @RF00181                                         03S0181
         TM    SIOTSSDS(@06),B'10000000'                        03S0181
         BNZ   @RF00181                                         03S0181
@RT00181 DS    0H                                               03S0182
*      DO;                             /*THEN IGNORE OVERRIDING DISP */
*        INFOCODE = '0008'X;           /*RETURN INFO CODE FOR IGNORE */
         L     @06,@PC00001+8                                   03S0183
         MVC   INFOCODE(2,@06),@CH02825                         03S0183
*        CMNMDISP = '1'B;              /*USE NORMAL DISP             */
         OI    CMNMDISP(CMRBPTR),B'01000000'                    03S0184
*      END;                            /*END IGNORE OVERRIDING DISP  */
*    ELSE                              /*OVERRIDING DISP NOT IGNORED */
*      DO;                             /*HANDLE THE OVERRIDING DISP  */
         B     @RC00181                                         03S0186
@RF00181 DS    0H                                               03S0187
*        CMORDISP = '1'B;              /*USE OVERRIDING DISP         */
         OI    CMORDISP(CMRBPTR),B'00010000'                    03S0187
*        RFY TEXTUNIT BASED(OVDSPTUP); /*RESET TEXT UNIT BASE        */
*        IF TEXTUPAR(1) = '08'X THEN   /*IF DISP SPEC'D IS KEEP      */
         L     @06,@PC00001+20                                  03S0189
         L     @06,KEYTABP(,@06)                                03S0189
         L     @06,OVDSPTUP(,@06)                               03S0189
         CLI   TEXTUPAR(@06),X'08'                              03S0189
         BNE   @RF00189                                         03S0189
*          CMOKEEP = '1'B;             /*OVERRIDE WITH KEEP          */
         OI    CMOKEEP(CMRBPTR),B'00001000'                     03S0190
*        ELSE                          /*KEEP NOT SPECIFIED          */
*          IF TEXTUPAR(1) = '04'X THEN /*IF SPEC'D. DISP IS DELETE   */
         B     @RC00189                                         03S0191
@RF00189 L     @06,@PC00001+20                                  03S0191
         L     @06,KEYTABP(,@06)                                03S0191
         L     @06,OVDSPTUP(,@06)                               03S0191
         CLI   TEXTUPAR(@06),X'04'                              03S0191
         BNE   @RF00191                                         03S0191
*            DO;                       /*HANDLE DELETE               */
*              CMODEL = '1'B;          /*OVERRIDE WITH DELETE        */
         OI    CMODEL(CMRBPTR),B'00000100'                      03S0193
*              CMDEL = '1'B;           /*SET DELETE FOR SUBSYSTEM    */
         OI    CMDEL(CMRBPTR),B'10000000'                       03S0194
*            END;                      /*END IF OVRRDING DELETE SPECD*/
*          ELSE                        /*DELETE OVERRIDE NOT SPEC'D  */
*            IF TEXTUPAR(1) = '02'X THEN /*IF SPEC'D DISP IS CATALOG */
         B     @RC00191                                         03S0196
@RF00191 L     @06,@PC00001+20                                  03S0196
         L     @06,KEYTABP(,@06)                                03S0196
         L     @06,OVDSPTUP(,@06)                               03S0196
         CLI   TEXTUPAR(@06),X'02'                              03S0196
         BNE   @RF00196                                         03S0196
*              CMOCATLG = '1'B;        /*OVERRIDE WITH CATALOG       */
         OI    CMOCATLG(CMRBPTR),B'00000010'                    03S0197
*            ELSE                      /*CATALOG NOT SPEC'D          */
*              CMOUNCAT = '1'B;        /*MUST BE UNCATALOG OVERRIDE  */
         B     @RC00196                                         03S0198
@RF00196 OI    CMOUNCAT(CMRBPTR),B'00000001'                    03S0198
*      END;                            /*END IF USING OVRRIDING DISP */
*                                                               03S0199
@RC00196 DS    0H                                               03S0199
@RC00191 DS    0H                                               03S0199
@RC00189 DS    0H                                               03S0200
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - DSRELCHK                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - DATA SET RELEASE CHECKS                       */
*/*                                                                  */
*/* FUNCTION  - DETERMINE WHETHER OR NOT DATA SET RELEASE SHOULD BE  */
*/*             DONE FOR THE PARTICULAR DSAB BEING UNALLOCATED. IF   */
*/*             RELEASE PROCESSING SHOULD BE BYPASSED, THIS BIT IN   */
*/*             THE RB BEING BUILT FOR THE DSAB IS SET ON.           */
*/*                                                                  */
*/* OPERATION - .IF THE DSAB IS FOR A DUMMY DATA SET, A SUBSYSTEM    */
*/*              DATA SET, OR A VAM DATA SET, THEN RELEASE PROCESSING*/
*/*              IS NOT NECESSARY AND WILL BE BYPASSED.              */
*/*             .OTHERWISE CHECKS ARE MADE TO DETERMINE IF THERE IS  */
*/*              ANOTHER ALLOCATION OF THIS SAME DSN, WHICH IS       */
*/*              NOT GOING TO BE UNALLOCATED AS PART OF THIS REQUEST.*/
*/*              IF THERE IS, THE DSN IS CONSIDERED MULTI-           */
*/*              ALLOCATED AND RELEASE PROCESSING IS BYPASSED FOR IT.*/
*/*             .IF THERE IS MORE THAN ONE ALLOCATION OF THE DSN     */
*/*              BEING UNALLOCATED, BUT ALL OF WHICH ARE ALSO TO     */
*/*              BE UNALLOCATED AS PART OF THIS REQUEST, D.S. RELEASE*/
*/*              WILL NOT BE BYPASSED IF THIS RB IS THE LAST ONE TO  */
*/*              BE BUILT FOR THIS DATA SET. OTHERWISE THE BIT TO    */
*/*              BYPASS IT IS SET IN THE RB.                         */
*/*             .IF THERE IS NO OTHER ALLOCATION OF THIS DSN,        */
*/*              THEN RELEASE PROCESSING SHOULD BE PERFORMED AND THE */
*/*              BIT TO BYPASS IT IN THE RB IS LEFT OFF.             */
*/*             .IF IT HAS BEEN DETERMINED THAT D.S. RELEASE @ZA04136*/
*/*              SHOULD BE PERFORMAED, AN ENQ TEST ON        @ZA04136*/
*/*              SYSZOPEN IS ISSUED TO ENSURE NO DCBS        @ZA04136*/
*/*              ARE OPEN (TYPE=J) TO THE DATA SET WHEN      @ZA04136*/
*/*              IT IS UNALLOCATED AND DEQ'D. (OPENJ WILL    @ZA04136*/
*/*              ENQ ON THIS MAJOR NAME WHEN THE DSN IN      @ZA04136*/
*/*              THE JFCB IS BEING CHANGED.) IF AN OPENJ     @ZA04136*/
*/*              TO THIS DATA SET IS OUTSTANDING, THE BIT    @ZA04136*/
*/*              IN THE RB TO BYPASS D.S. RELEASE FOR IT     @ZA04136*/
*/*              WILL BE SET.                                @ZA04136*/
*/*             .THE DETERMINATIONS MADE ARE AS FOLLOWS:             */
*/*              - A SCAN OF THE DSAB CHAIN IS MADE UNTIL EACH DSAB  */
*/*                IS CHECKED, OR UNTIL A DETERMINATION IS MADE      */
*/*                THAT D.S. RELEASE SHOULD BE BYPASSED FOR THIS     */
*/*                RB BEING BUILT.                                   */
*/*              - IF THERE ARE NO DSABS IN THE CHAIN WITH THE       */
*/*                SAME DSN AS THE ONE BEING PROCESSED, D.S. RELEASE */
*/*                WILL NOT BE BYPASSED AND THE BIT IN THE RB IS     */
*/*                LEFT OFF.(ALIAS/GDG STRUCTURE DSN'S       @YM06112*/
*/*                MUST ALSO BE CONSIDERED HERE, AS THEY     @YM06112*/
*/*                TOO ARE ENQ'D UPON AND APPEAR THE SAME    @YM06112*/
*/*                IN THE DSENQ TABLE)                       @YM06112*/
*/*              - IF ANOTHER DSAB IN THE CHAIN IS FOR THE SAME DSN  */
*/*                (NOT A QNAME) AS THE ONE FOR WHICH THE RB IS BEING*/
*/*                BUILT, THE DSAB LIST FOR UNALLOCATION IS CHECKED. */
*/*              - IF THE OTHER DSAB IN THE CHAIN IS NOT IN THE      */
*/*                UNALLOC LIST, DATA SET RELEASE IS BYPASSED.       */
*/*              - IF THE OTHER DSAB IN THE CHAIN IS ALSO IN THE     */
*/*                UNALLOC LIST, D.S. RESERVATION FOR THE DSAB BEING */
*/*                PROCESSED WILL BE BYPASSED IF THE INDEX INTO THE  */
*/*                UNALLOC LIST OF THE OTHER DSAB IN THE CHAIN IS    */
*/*                GREATER THAN THAT OF THE DSAB BEING PROCESSED (THE*/
*/*                RELEASE FOR THE DATA SET, IF NECESSARY, WILL BE   */
*/*                DONE WHEN THE LATTER DSABPTR IN THE LIST IS       */
*/*                PROCESSED). OTHERWISE D.S. RELEASE IS NOT         */
*/*                BYPASSED, BUT THE SEARCH OF THE DSAB CHAIN        */
*/*                CONTINUES TO SEE IF THERE ARE OTHER DSABS FOR     */
*/*                WHICH THE ABOVE CHECKS SHOULD BE REPEATED.        */
*/*              - WHEN COMPARING WITH A DSAB ON THE DSABPTR LIST,   */
*/*                ALL MEMBERS OF THE GROUP ARE CHECKED, IF THE      */
*/*                DSAB IN THE LIST IS PERMANENTLY CONCATENATED.     */
*/*                THIS IS BECAUSE RB'S WILL BE BUILT FOR EACH       */
*/*                DSAB IN A PERMANENTLY CONCATED GROUP.             */
*/*               -AN ENQUEUE WITH RET=TEST IS ISSUED USING  @ZA04136*/
*/*                SYSZOPEN AS MAJOR AND THE DATA SET NAME AS@ZA04136*/
*/*                A MINOR NAME. IF THE DATA SET NAME IS     @ZA04136*/
*/*                ENQUEUED THEN RELEASE PROCESSING IS NOT   @ZA04136*/
*/*                PERFORMED.                                @ZA04136*/
*/*                                                                  */
*/* ENTRY -                                                          */
*/*    INPUT DATA - DSQFRSTP - PTR TO FIRST DSAB IN CHAIN            */
*/*                 DSABPLST - LIST OF PTRS TO DSABS FOR UNALLOCATION*/
*/*                 DSABPCNT - COUNT OF DSABPTRS IN LIST             */
*/*                 CMUNRB   - UNALLOCATION REQUEST BLOCK BEING BUILT*/
*/*                            WITH CMNODSR BIT ZERO ON ENTRY        */
*/*                 WRKINDEX - INDEX INTO LIST OF DSABPTR BEING      */
*/*                            PROCESSED                             */
*/*                                                                  */
*/* EXIT -                                                           */
*/*    OUTPUT DATA - CMNODSR  - BIT IN RB SET ON IF DATA SET         */
*/*                             RELEASE IS TO BE BYPASSED            */
*/*                                                                  */
*/********************************************************************/
*RFY DSAB BASED(WRKDSABP);             /*RESET DSAB BASE PTR         */
@RC00181 DS    0H                                               04S0200
@RC00179 DS    0H                                               04S0200
@RC00177 DS    0H                                               04S0201
*IF SCTDUMMY = '1'B  |                 /*IF DATA SET IS A DUMMY OR   */
*   SIOTSSDS = '1'B  |                 /*IS A SUBSYSTEM D.S. OR      */
*   SIOVAMDS = '1'B THEN               /*IS A VAM D.S.               */
         L     @06,CMSIOPTR(,CMRBPTR)                           04S0201
         TM    SCTDUMMY(@06),B'10000000'                        04S0201
         BO    @RT00201                                         04S0201
         TM    SIOTSSDS(@06),B'10000000'                        04S0201
         BO    @RT00201                                         04S0201
         TM    SIOVAMDS(@06),B'00100000'                        04S0201
         BNO   @RF00201                                         04S0201
@RT00201 DS    0H                                               04S0202
*  CMNODSR = '1'B;                     /*BYPASS D.S. RELEASE         */
         OI    CMNODSR(CMRBPTR),B'10000000'                     04S0202
*ELSE                                  /*DS IS NOT DUMMY, VAM OR S.S.*/
*  DO;                                 /*CHECK IF MULTI-ALLOCATED    */
         B     @RC00201                                         04S0203
@RF00201 DS    0H                                               04S0204
*    WRKDSABP = DSQFRSTP;              /*POINT TO 1ST DSAB IN CHAIN  */
*                                                               04S0204
         L     @06,@PC00001+16                                  04S0204
         L     @06,JSCBPTR(,@06)                                04S0204
         L     @06,JSCDSABQ(,@06)                               04S0204
         L     WRKDSABP,DSQFRSTP(,@06)                          04S0204
*    DO WHILE (WRKDSABP ^= 0  &        /*LOOP TO END OF CHAIN OR TILL*/
*              CMNODSR = '0'B);        /*CAN DETERMINE TO BYPASS     */
         B     @DE00205                                         04S0205
@DL00205 DS    0H                                               04S0206
*      IF (DSABSIOT->SJFCBPTR->JFCBDSNM = JFCBDSNM &            04S0206
*                                      /*IF DSAB IS FOR SAME DSN     */
*         DSABSIOT->SIOTQNAM = '0'B) | /*AND IS NOT FOR A QNAME, OR  */
*         (DSABSIOT->SIOALIAS = '1'B & /*ALIAS EXISTS        @YM06112*/
*         DSABSIOT->SIOTJFX->JFCBXNAM=JFCBDSNM) | /*AND ALIAS MATCHES
*                                        DSN, OR             @YM06112*/
*         (DSABANMP ^= 0 &             /*AN ALT. NAME EXISTS @YM06112*/
*          DSABANAM(1:DSABANML) = JFCBDSNM(1:DSABANML) & /*  @YM06112*/
*          JFCBDSNM(DSABANML + 1) = ' ') THEN /*AND DSNAMES MATCH
*                                                            @YM06112*/
         L     @06,DSABSIOT(,WRKDSABP)                          04S0206
         L     @01,SJFCBPTR(,@06)                               04S0206
         L     @15,CMSIOPTR(,CMRBPTR)                           04S0206
         L     @15,SJFCBPTR(,@15)                               04S0206
         CLC   JFCBDSNM(44,@01),JFCBDSNM(@15)                   04S0206
         BNE   @GL00008                                         04S0206
         TM    SIOTQNAM(@06),B'00000001'                        04S0206
         BZ    @RT00206                                         04S0206
@GL00008 L     @06,DSABSIOT(,WRKDSABP)                          04S0206
         TM    SIOALIAS(@06),B'10000000'                        04S0206
         BNO   @GL00007                                         04S0206
         L     @06,SIOTJFX(,@06)                                04S0206
         L     @01,CMSIOPTR(,CMRBPTR)                           04S0206
         L     @01,SJFCBPTR(,@01)                               04S0206
         CLC   JFCBXNAM(44,@06),JFCBDSNM(@01)                   04S0206
         BE    @RT00206                                         04S0206
@GL00007 L     @06,DSABANMP(,WRKDSABP)                          04S0206
         LTR   @06,@06                                          04S0206
         BZ    @RF00206                                         04S0206
         L     @01,CMSIOPTR(,CMRBPTR)                           04S0206
         L     @15,SJFCBPTR(,@01)                               04S0206
         SLR   @14,@14                                          04S0206
         IC    @14,DSABANML(,@06)                               04S0206
         LR    @01,@14                                          04S0206
         BCTR  @01,0                                            04S0206
         EX    @01,@SC02883                                     04S0206
         BNE   @RF00206                                         04S0206
         ALR   @15,@14                                          04S0206
         CLI   JFCBDSNM(@15),C' '                               04S0206
         BNE   @RF00206                                         04S0206
@RT00206 DS    0H                                               04S0207
*        DO;                           /*SEE IF DSAB IS ALSO IN LIST */
*          INLIST = '0'B;              /*INIT SW FOR NOT IN LIST     */
         NI    INLIST,B'11011111'                               04S0208
*          INDEXLST = 1;               /*START SEARCH FROM BEGINNING */
*                                                               04S0209
         LA    INDEXLST,1                                       04S0209
*          DO WHILE (INDEXLST <= DSABPCNT  &  /*SEARCH ALL OF LIST OR*/
*                    CMNODSR = '0'B);  /*TILL BYPASS IS DETERMINED   */
         B     @DE00210                                         04S0210
@DL00210 DS    0H                                               04S0211
*            LISTDSAB = DSABPLST(INDEXLST); /*GET DSABPTR FROM LIST  */
         LR    @15,INDEXLST                                     04S0211
         SLA   @15,2                                            04S0211
         L     @14,@PC00001                                     04S0211
         L     @01,DSABPLP(,@14)                                04S0211
         AL    @01,@CF02877                                     04S0211
         L     @15,DSABPLST(@15,@01)                            04S0211
         ST    @15,LISTDSAB                                     04S0211
*            ENDGROUP = '0'B;          /*INIT END OF PCAT GROUP SW   */
*            DSAB2BUN = '0'B;          /*INIT  TO BE UNALLOC'D SW    */
*                                                               04S0213
         NI    ENDGROUP,B'00111111'                             04S0213
*            DO WHILE (DSAB2BUN = '0'B  & /*SEARCH TILL FOUND IN LIST*/
*                      ENDGROUP = '0'B);  /*OR TO END OF PCAT GROUP  */
         B     @DE00214                                         04S0214
@DL00214 DS    0H                                               04S0215
*              IF WRKDSABP = LISTDSAB THEN/*IF DSAB FND IS IN LIST   */
         C     WRKDSABP,LISTDSAB                                04S0215
         BNE   @RF00215                                         04S0215
*                DO;                   /*SET CONTROL SWITCHES        */
*                  INLIST = '1'B;      /*SAY IT IS IN LIST FOR UNAL  */
*                  DSAB2BUN = '1'B;    /*SAY SAME FOR LOOP CONTROL   */
         OI    INLIST,B'01100000'                               04S0218
*                  IF INDEXLST > WRKINDEX THEN  /*IF IN LIST AFTER
*                                        ONE WORKING ON              */
         CR    INDEXLST,WRKINDEX                                04S0219
         BNH   @RF00219                                         04S0219
*                    CMNODSR = '1'B;   /*BYPASS RELEASE FOR THIS ONE */
         OI    CMNODSR(CMRBPTR),B'10000000'                     04S0220
*                  ELSE;               /*DONT BYPASS YET;KEEP LOOKING*/
@RF00219 DS    0H                                               04S0222
*                END;                  /*END IF DSAB IS ALSO IN LIST */
*              ELSE                    /*DSAB FOUND IS NOT THIS  DSAB
*                                        IN UNALLOC LIST             */
*                IF LISTDSAB->DSABFCHN = 0 | /*IF AT END OF DSAB
*                                              CHAIN OR              */
*                   LISTDSAB->DSABFCHN-> /*IF NO MORE IN PCAT GROUP  */
*                   DSABSIOT->SCTDDNAM(1) ^= ' ' THEN           04S0223
         B     @RC00215                                         04S0223
@RF00215 L     @01,LISTDSAB                                     04S0223
         L     @15,DSABFCHN(,@01)                               04S0223
         LTR   @15,@15                                          04S0223
         BZ    @RT00223                                         04S0223
         L     @01,DSABSIOT(,@15)                               04S0223
         CLI   SCTDDNAM(@01),C' '                               04S0223
         BE    @RF00223                                         04S0223
@RT00223 DS    0H                                               04S0224
*                  ENDGROUP = '1'B;    /*SET LOOP CTL SWITCH         */
         OI    ENDGROUP,B'10000000'                             04S0224
*                ELSE                  /*MORE DSABS IN PCAT GROUP    */
*                  LISTDSAB = LISTDSAB->DSABFCHN; /*POINT TO NEXT ONE*/
         B     @RC00223                                         04S0225
@RF00223 L     @01,LISTDSAB                                     04S0225
         L     @15,DSABFCHN(,@01)                               04S0225
         ST    @15,LISTDSAB                                     04S0225
*            END;                      /*END CHK OF DSABPTR IN LIST  */
*                                                               04S0226
@RC00223 DS    0H                                               04S0226
@RC00215 DS    0H                                               04S0226
@DE00214 TM    DSAB2BUN,B'11000000'                             04S0226
         BZ    @DL00214                                         04S0226
*            INDEXLST = INDEXLST +1;   /*POINT TO NEXT PTR IN LIST   */
         AL    INDEXLST,@CF00088                                04S0227
*          END;                        /*END SEARCH THROUGH LIST     */
*                                                               04S0228
@DE00210 L     @15,@PC00001+4                                   04S0228
         C     INDEXLST,DSABPCNT(,@15)                          04S0228
         BH    @DC00210                                         04S0228
         TM    CMNODSR(CMRBPTR),B'10000000'                     04S0228
         BZ    @DL00210                                         04S0228
@DC00210 DS    0H                                               04S0229
*          IF INLIST = '0'B THEN       /*IF DSAB WITH SAME DSN IS NOT
*                                        IN LIST TO BE UNALLOCATED   */
         TM    INLIST,B'00100000'                               04S0229
         BNZ   @RF00229                                         04S0229
*            CMNODSR = '1'B;           /*MULTI-ALLOC.;BYPASS RELEASE */
         OI    CMNODSR(CMRBPTR),B'10000000'                     04S0230
*        END;                          /*END CHAIN DSAB HAS SAME DSN */
*      ELSE;                           /*DSAB IS FOR DIFFERENT DSN   */
@RF00206 DS    0H                                               04S0233
*      WRKDSABP = DSABFCHN;            /*POINT TO NEXT DSAB IN CHAIN */
@RC00206 L     WRKDSABP,DSABFCHN(,WRKDSABP)                     04S0233
*    END;                              /*END BYPASS DETERMINATION    */
@DE00205 LTR   WRKDSABP,WRKDSABP                                04S0234
         BZ    @DC00205                                         04S0234
         TM    CMNODSR(CMRBPTR),B'10000000'                     04S0234
         BZ    @DL00205                                         04S0234
@DC00205 DS    0H                                               04S0235
*    IF CMNODSR = '0'B THEN            /*MARKED FOR BYPASS?  @ZA04136*/
         TM    CMNODSR(CMRBPTR),B'10000000'                     04S0235
         BNZ   @RF00235                                         04S0235
*      DO;                             /*NO -                @ZA04136*/
*        DSNAME = JFCBDSNM;            /*GET DSNAME          @ZA04136*/
         L     @06,CMSIOPTR(,CMRBPTR)                           04S0237
         L     @06,SJFCBPTR(,@06)                               04S0237
         MVC   DSNAME(44),JFCBDSNM(@06)                         04S0237
*        IF JSCBTCBP = 0 THEN          /*IF INIT TCB ZERO    @ZA07748*/
         L     @06,@PC00001+16                                  04S0238
         L     @02,JSCBPTR(,@06)                                04S0238
         L     @02,JSCBTCBP(,@02)                               04S0238
         LTR   @02,@02                                          04S0238
         BNZ   @RF00238                                         04S0238
*          TCBP = TCBPTR;              /*USE CURRENT TCB PTR @ZA07748*/
         L     @06,TCBPTR(,@06)                                 04S0239
         ST    @06,TCBP                                         04S0239
*        ELSE                                                   04S0240
*          TCBP = JSCBTCBP;            /*USE INIT TCB ADDR   @ZA07748*/
         B     @RC00238                                         04S0240
@RF00238 L     @06,@PC00001+16                                  04S0240
         L     @06,JSCBPTR(,@06)                                04S0240
         L     @06,JSCBTCBP(,@06)                               04S0240
         ST    @06,TCBP                                         04S0240
*        ENQBEGIN(1:ENQLEN) = ENQLIST(1:ENQLEN);/*COPY LIST  @ZA04136*/
@RC00238 L     @06,ENQLEN                                       04S0241
         BCTR  @06,0                                            04S0241
         EX    @06,@SM02886                                     04S0241
*        GEN REFS(MAJORNME,DSNAME,ENQCORE,TCBP); /*          @ZA04136*/
        ENQ (MAJORNME,DSNAME,,,STEP),RET=TEST,MF=(E,ENQCORE),TCB=TCBP
*        IF R15 ^= 0 THEN             /*IS RESOURCE ENQUD?   @ZA04136*/
         LTR   R15,R15                                          04S0243
         BZ    @RF00243                                         04S0243
*          CMNODSR = '1'B;            /*YES - BYPASS RELEASE @ZA04136*/
         OI    CMNODSR(CMRBPTR),B'10000000'                     04S0244
*      END;                           /*                     @ZA04136*/
*                                                               04S0245
@RF00243 DS    0H                                               04S0246
*  END;                                /*END IF DS NOT DUMMY,VAM,S.S.*/
@RF00235 DS    0H                                               04S0247
*RFY DSAB BASED(DSABPTR);              /*RESET DSAB BASE PTR         */
@RC00201 DS    0H                                               04S0248
*                                                               03S0248
*IF SIOTDYAL = '0'B THEN               /*IF DS WAS NOT DYNAM. ALLOC. */
         L     @06,CMSIOPTR(,CMRBPTR)                           03S0248
         TM    SIOTDYAL(@06),B'01000000'                        03S0248
         BNZ   @RF00248                                         03S0248
*  DO;                                 /*SET NECESSARY BITS FOR UNAL */
*    CMCHKUN = '1'B;                   /*CHECK FOR MULTI-ALLOC UNITS */
*    CMCKAVOL = '1'B;                  /*CHECK FOR MULTI-ALLOC VOLS  */
         OI    CMCHKUN(CMRBPTR),B'01100000'                     03S0251
*  END;                                /*END IF NON-DYNAMICALLY ALLOC*/
*ELSE                                  /*DS WAS DYNAMICALLY ALLOCATED*/
*  CMCKDAVL = '1'B;                    /*CHECK FOR MULTI-ALLOC VOLS
*                                        ON DASD ONLY                */
*                                                               03S0253
         B     @RC00248                                         03S0253
@RF00248 OI    CMCKDAVL(CMRBPTR),B'00010000'                    03S0253
*IF OVSHQTUP ^= 0       |              /*IF OVERRIDING HOLD Q SPECD, */
*   (SIOTHOLD = '1'B &                 /*OR HOLD ORIGINALLY WAS SPECD*/
*    OVSNHTUP = 0) THEN                /*AND OVRRD NOHOLD NOT SPECD  */
@RC00248 SLR   @06,@06                                          03S0254
         L     @02,@PC00001+20                                  03S0254
         L     @02,KEYTABP(,@02)                                03S0254
         C     @06,OVSHQTUP(,@02)                               03S0254
         BNE   @RT00254                                         03S0254
         L     @01,CMSIOPTR(,CMRBPTR)                           03S0254
         TM    SIOTHOLD(@01),B'01000000'                        03S0254
         BNO   @RF00254                                         03S0254
         C     @06,OVSNHTUP(,@02)                               03S0254
         BNE   @RF00254                                         03S0254
@RT00254 DS    0H                                               03S0255
*  CMHOLD = '1'B;                      /*SET HOLD RB BIT FOR UNALLOC */
         OI    CMHOLD(CMRBPTR),B'01000000'                      03S0255
*IF OVSNHTUP ^= 0 THEN                 /*NOHOLD OVERRIDE     @ZA08726*/
@RF00254 L     @06,@PC00001+20                                  03S0256
         L     @06,KEYTABP(,@06)                                03S0256
         L     @06,OVSNHTUP(,@06)                               03S0256
         LTR   @06,@06                                          03S0256
         BZ    @RF00256                                         03S0256
*  CMNOHOLD = '1'B;                    /*SET NOHOLD FOR UNAL @ZA08726*/
         OI    CMNOHOLD(CMRBPTR),B'00000100'                    03S0257
*CMDYNUNA = '1'B;                      /*MARK AS DYNAMIC UNALLOCATION*/
@RF00256 OI    CMDYNUNA(CMRBPTR),B'00100000'                    03S0258
*IF OVCLSTUP ^= 0 THEN                 /*IF OVRRD. SYSOUT CLASS SPECD*/
         L     @06,@PC00001+20                                  03S0259
         L     @06,KEYTABP(,@06)                                03S0259
         L     @06,OVCLSTUP(,@06)                               03S0259
         LTR   @06,@06                                          03S0259
         BZ    @RF00259                                         03S0259
*  DO;                                 /*HANDLE OVERRIDE             */
*    CMOVSYOT = '1'B;                  /*SAY OVRRD. CLASS SPECIFIED  */
         OI    CMOVSYOT(CMRBPTR),B'00001000'                    03S0261
*    CMOSYOUT = OVCLSTUP->TEXTUPAR(1); /*COPY SPEC'D CLASS INTO RB   */
         MVC   CMOSYOUT(1,CMRBPTR),TEXTUPAR(@06)                03S0262
*  END;                                /*END SYSOUT CLASS OVERRIDE   */
*IF OVSUSTUP ^= 0 THEN                 /*IF OVRRD. SYSOUT USER ID
*                                        SPECIFIED                   */
@RF00259 L     @06,@PC00001+20                                  03S0264
         L     @06,KEYTABP(,@06)                                03S0264
         L     @06,OVSUSTUP(,@06)                               03S0264
         LTR   @06,@06                                          03S0264
         BZ    @RF00264                                         03S0264
*  DO;                                 /*SET USERID INFO IN RB       */
*    CMOUSRID = '1'B;                  /*OVERRIDING USERID SPEC'D    */
         OI    CMOUSRID(CMRBPTR),B'00001000'                    03S0266
*    CMUIDPTR = ADDR(OVRDNGID);        /*POINT TO OVERRIDING ID      */
         LA    @06,OVRDNGID                                     03S0267
         ST    @06,CMUIDPTR(,CMRBPTR)                           03S0267
*  END;                                /*END OVERRIDING USER SPEC'D  */
*ELSE;                                 /*OVERRIDING ID NOT SPECIFIED */
@RF00264 DS    0H                                               03S0270
*    SMFAINDX = SMFAINDX + 1;          /*INCREMENT SMF ARRAY INDEX   */
         AL    SMFAINDX,@CF00088                                02S0270
*    SMFFLAGS(SMFAINDX) = '00'X;       /*INIT ENTRY FLAGS TO ZERO    */
         L     @06,SMFARYP                                      02S0271
         LR    @02,SMFAINDX                                     02S0271
         MH    @02,@CH00085                                     02S0271
         ST    @02,@TF00001                                     02S0271
         ALR   @02,@06                                          02S0271
         BCTR  @02,0                                            02S0271
         MVI   SMFFLAGS-4(@02),X'00'                            02S0271
*    SMFTIOTP(SMFAINDX) = DSABTIOT;    /*PUT TIOT PTR IN ENTRY       */
         L     @02,DSABTIOT(,DSABPTR)                           02S0272
         AL    @06,@TF00001                                     02S0272
         AL    @06,@CF02889                                     02S0272
         STCM  @02,15,SMFTIOTP(@06)                             02S0272
*    CMNRBPTR = CMRBPTR + LENGTH(CMUNRB) + OPTFLDLN;            02S0273
         LA    @06,16                                           02S0273
         ALR   @06,CMRBPTR                                      02S0273
         ALR   @06,OPTFLDLN                                     02S0273
         ST    @06,CMNRBPTR(,CMRBPTR)                           02S0273
*                                      /*FILL IN NEXT PTR FIELD OF RB*/
*    CMRBPTR = CMNRBPTR;               /*SET BASE PTR TO NEW RB      */
         LR    CMRBPTR,@06                                      02S0274
*    IF DSABFCHN ^= 0  &               /*IF NOT AT END OF CHAIN NOR  */
*       DSABFCHN->DSABSIOT->SCTDDNAM(1)=' ' THEN /*AT END OF GROUP   */
         L     @06,DSABFCHN(,DSABPTR)                           02S0275
         LTR   @06,@06                                          02S0275
         BZ    @RF00275                                         02S0275
         L     @02,DSABSIOT(,@06)                               02S0275
         CLI   SCTDDNAM(@02),C' '                               02S0275
         BNE   @RF00275                                         02S0275
*      DSABPTR = DSABFCHN;             /*POINT TO NEXT DSAB          */
         LR    DSABPTR,@06                                      02S0276
*    ELSE                              /*AT END OF CHAIN OR GROUP    */
*      OUT = '1'B;                     /*GET OUT OF INNER LOOP       */
         B     @RC00275                                         02S0277
@RF00275 OI    OUT,B'10000000'                                  02S0277
*  END;                                /*END LOOP TO FILL IN RBS     */
@RC00275 DS    0H                                               02S0278
@DE00174 TM    OUT,B'10000000'                                  02S0278
         BZ    @DL00174                                         02S0278
*END;                                  /*END LOOP THRU DSABPTR LIST  */
         AL    WRKINDEX,@CF00088                                02S0279
@DE00171 L     @06,@PC00001+4                                   02S0279
         C     WRKINDEX,DSABPCNT(,@06)                          02S0279
         BNH   @DL00171                                         02S0279
*CMRBPTR = CMRBPTR - LENGTH(CMUNRB) - OPTFLDLN;                 02S0280
         LR    @06,CMRBPTR                                      02S0280
         SL    @06,@CF00067                                     02S0280
         SLR   @06,OPTFLDLN                                     02S0280
         LR    CMRBPTR,@06                                      02S0280
*                                      /*BACK UP TO LAST RB IN CHAIN */
*CMNRBPTR = 0;                         /*ZERO CHAIN PTR OF LAST RB   */
         SLR   @06,@06                                          02S0281
         ST    @06,CMNRBPTR(,CMRBPTR)                           02S0281
*SMFLAST(SMFAINDX) = '1'B;             /*SET LAST ENTRY BIT          */
         LR    @06,SMFAINDX                                     02S0282
         MH    @06,@CH00085                                     02S0282
         L     @01,SMFARYP                                      02S0282
         ALR   @01,@06                                          02S0282
         BCTR  @01,0                                            02S0282
         OI    SMFLAST-4(@01),B'10000000'                       02S0282
*FSTSIOTP = DSQFRSTP->DSABSIOT;        /*POINT TO 1ST ALLOCATED SIOT */
         L     @09,@PC00001+16                                  01S0283
         L     @06,JSCBPTR(,@09)                                01S0283
         L     @06,JSCDSABQ(,@06)                               01S0283
         L     @06,DSQFRSTP(,@06)                               01S0283
         L     @06,DSABSIOT(,@06)                               01S0283
         ST    @06,FSTSIOTP                                     01S0283
*JOBNM = JCTJNAME;                     /*JOB NAME FOR - 4A0  @ZD03010*/
         L     @06,JCTPTR(,@09)                                 01S0284
         MVC   JOBNM(8),JCTJNAME(@06)                           01S0284
*STPNM = SCTSNAME;                     /*STEP NAME FOR -4A0  @ZD03010*/
         L     @15,SCTPTR(,@09)                                 01S0285
         MVC   STPNM(8),SCTSNAME(@15)                           01S0285
*CMNUNARY = CMNUNARY && CMNUNARY;      /*ZERO REASON CODE ARRAY      */
         XC    CMNUNARY(8),CMNUNARY                             01S0286
*CALL IEFAB4A0                         /*CALL COMMON UNALLOCATION    */
*             (CMUNFMAP,FSTRBPTR,JSCBPTR,FSTSIOTP,              01S0287
*              JCTDETDA,SCTSNUMB,JCTVULDP,CMNUNARY,ADDR(NAMES));
         LA    @14,FNCTMAP                                      01S0287
         ST    @14,@AL00001                                     01S0287
         LA    @14,FSTRBPTR                                     01S0287
         ST    @14,@AL00001+4                                   01S0287
         ST    @09,@AL00001+8                                   01S0287
         LA    @09,FSTSIOTP                                     01S0287
         ST    @09,@AL00001+12                                  01S0287
         LA    @09,JCTDETDA(,@06)                               01S0287
         ST    @09,@AL00001+16                                  01S0287
         LA    @09,SCTSNUMB(,@15)                               01S0287
         ST    @09,@AL00001+20                                  01S0287
         LA    @09,JCTVULDP(,@06)                               01S0287
         ST    @09,@AL00001+24                                  01S0287
         LA    @09,CMNUNARY                                     01S0287
         ST    @09,@AL00001+28                                  01S0287
         LA    @09,NAMES                                        01S0287
         ST    @09,@TF00001                                     01S0287
         LA    @09,@TF00001                                     01S0287
         ST    @09,@AL00001+32                                  01S0287
         L     @15,@CV00124                                     01S0287
         LA    @01,@AL00001                                     01S0287
         BALR  @14,@15                                          01S0287
*                                       /*                   @ZD03010*/
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - UNALWPUP                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - UNALLOCATION WRAP UP                          */
*/*                                                                  */
*/* OPERATION - THIS CODE IS ENTERED AFTER THE CALL TO COMMON        */
*/*             UNALLOCATION TO PERFORM THE NECESSARY WRAP UP WORK   */
*/*             RESULTING FROM THE UNALLOCATION PROCESS. AS LONG AS  */
*/*             COMMON UNALLOCATION CAN CREATE ITS ESTAE ENVIRONMENT */
*/*             IT WILL PERFORM AS MUCH PROCESSING AS POSSIBLE. AT   */
*/*             MINIMUM, THE DSABS, TIOT ENTRIES, AND UNITS WILL ALL */
*/*             BE FREED. THEREFORE IF THERE IS NO ESTAE ERROR, ALL  */
*/*             THE UNALLOCATION WILL BE CONSIDERED A SUCCESS.       */
*/*             HOWEVER, IF THERE IS AN ESTAE ERROR, NO UNALLOCATION */
*/*             WILL HAVE BEEN DONE AND THIS SEGMENT WILL SET AN     */
*/*             ESTAE ERROR CODE, FREE THE RB AND SMF ENTRY CORE,    */
*/*             AND EXIT. NOTE THAT DYNAMIC IGNORES THE FIRST        */
*/*             THREE POSITIONS IN THE COMMON UNALLOCATION REASON    */
*/*             CODE ARRAY, LOOKING ONLY AT THE 4TH FOR AN ESTAE     */
*/*             ERROR.                                               */
*/*                                                                  */
*/*             FOR SUCCESSFUL UNALLOCATION, THE FOLLOWING IS DONE:  */
*/*               . A LOOP SCAN OF THE RBS THAT WERE SENT TO COMMON  */
*/*                 IS MADE, AND THE FOLLOWING PROCESSING IS         */
*/*                 PERFORMED FOR EACH:                              */
*/*                   - IF THE REASON CODE IN THE RB HAS A SCRATCH   */
*/*                     OR CATALOG MANAGEMENT ERROR CODE, AN         */
*/*                     APPROPRIATE INFO CODE WILL BE SET. THIS      */
*/*                     IS DONE ONLY FOR THE FIRST RB THAT HAS       */
*/*                     SUCH AN ERROR. NOTE THAT NOCORE, SUBSYSTEM,  */
*/*                     AND SUBSYSTEM INTERFACE CODES IN AN RB ARE   */
*/*                     IGNORED.                                     */
*/*                   - ALIAS/GDG STRUCTURE DSN DEQ PROCESSING IS    */
*/*                     PERFORMED                            @YM06112*/
*/*                   - NECESSARY CHECKPOINT RESTART PROCESSING IS   */
*/*                     PERFORMED.                                   */
*/*                   - SIOT DELETE AND DECHAINING PROCESSING IS     */
*/*                     PERFORMED FOR THOSE THAT HAD BEEN            */
*/*                     DYNAMICALLY ALLOCATED.                       */
*/*                   - THE COUNT IN THE JSCB OF ALLOCATED SIOTS     */
*/*                     IS DECREMENTED BY 1.                         */
*/*               . IF THE SCT AND/OR JCT WERE UPDATED IN THE ABOVE  */
*/*                 PROCESSING, THE GETEPA SUBROUTINE IS USED TO     */
*/*                 GET CORE FOR EPAS WHICH IT WILL PLACE ON THE     */
*/*                 WRITE EPA CHAIN. THESE EPAS ARE THEN FILLED IN   */
*/*                 FOR THESE CONTROL BLOCKS.                        */
*/*               . IF ANY RBS ARE FOR DYNAMICALLY ALLOCATED SIOTS,  */
*/*                 DELETE EPAS WILL HAVE BEEN CREATED ABOVE AS PART */
*/*                 OF SIOT DELETE PROCESSING. THE SWA MGR. INTERFACE*/
*/*                 (IEFAB4F7) WILL BE CALLED NOW TO DELETE THOSE    */
*/*                 SIOTS, THEIR ASSOCIATED JFCBS AND JFCBXS,        */
*/*                 AND IF THE SIOT IS FOR A SUBSYS REQUEST  @G29AN2F*/
*/*                 THE ASSOCIATED SSWA.                     @G29AN2F*/
*/*               . UNALLOC SMF PROCESSING IS THEN DONE VIA A CALL TO*/
*/*                 IEFDB4F9. THIS INCLUDES BUILDING AND     @ZA02706*/
*/*                 CHAINING AN SMF RECORD 40, AND UPDATING  @ZA02706*/
*/*                 THE TCTIOT.                              @ZA02706*/
*/*               . IF THE ERROR CODE FIELD OF THE REASON CODE IS    */
*/*                 NON-ZERO FROM ANY PRIOR PROCESSING, THE INFO CODE*/
*/*                 FIELD IS SET TO '0004'X TO SAY THAT SOME UNALLO- */
*/*                 CATIONS WERE STILL SUCCESSFULLY DONE.            */
*/*               . THE COMMON UNALLOCATION RB AND SMF ARRAY ENTRY   */
*/*                 CORE IS THEN FREEMAIN'D.                         */
*/*                                                                  */
*/*               NOTE THAT ANY WRITE EPAS CREATED ABOVE ARE FIRST   */
*/*               CHAINED INTO A DUMMY EPA AND THEN CHAINED AT THE   */
*/*               END INTO THE INPUT LAST EPA. THIS IS SO THAT IN    */
*/*               CASE OF ABEND, THE ESTAE EXIT, WHICH WILL WRITE    */
*/*               OUT ANY EPAS ON THE REAL CHAIN, WILL NOT HAVE      */
*/*               ACCESS TO ANY NEW EPAS BEFORE ALL RELATED          */
*/*               PROCESSING IS COMPLETE.                            */
*/*                                                                  */
*/*               NOTE ALSO THAT ANY DELETING OF RECORDS IS DONE     */
*/*               AFTER THE WRITE EPAS ARE PLACED ON THE REAL CHAIN. */
*/*               THIS TOO IS DONE IN CASE OF ABEND, SO THAT THE     */
*/*               ESTAE EXIT WILL WRITE OUT THE UPDATED RECORDS,     */
*/*               CAUSING THE TRUE SIOT CHAIN TO BE REFLECTED, AND   */
*/*               AVOIDING A CHAIN WHERE ONE RECORD POSSIBLY POINTS  */
*/*               TO THE CORE OF A DELETED RECORD.                   */
*/* ENTRY -                                                          */
*/*   INPUT  - RSNCDARY - COMMON UNALLOCATION REASON CODE ARRAY      */
*/*            FSTRBPTR - PTR TO FIRST COMMON UNALLOCATION RB        */
*/*            TCBPTR   - PTR TO TCB FOR SMF                         */
*/*            JSCDSABQ - PTR TO DSAB QDB FOR SMF                    */
*/*            SMFARRAY - SMF ARRAY OF ENTRIES FOR EACH RB           */
*/*            DEPARMS  - SVC99 ESTAE PARMS - FOR SMF ROUTINE        */
*/*                                                                  */
*/* EXIT -                                                           */
*/*  OUTPUT  - JCTNARST - SET ON IF INELIGIBLE FOR RESTART           */
*/*            JSCDDNUM - DECREMENTED BY 1 FOR EACH UNALLOCATED SIOT */
*/*            EPALAST  - UPDATED FOR NEW EPAS ADDED TO THE WRITE    */
*/*                       EPA CHAIN. THESE EPAS MAY BE FOR THE JCT,  */
*/*                       SCT, OR SIOTS UPDATED IN ANY OF THE ABOVE  */
*/*                       PROCESSING                                 */
*/*            SIOTS    - OF THOSE SIOTS JUST PROCESSED, JCL         */
*/*                       ALLOCATED ONES ARE MARKED UNALLOCATED;     */
*/*                       DYNAMICALLY ALLOCATED ONES ARE DECHAINED   */
*/*                       AND DELETED, ALONG WITH THERE ASSOCIATED   */
*/*                       JFCBS + JFCBXS                             */
*/*            SMF      - RECORD 40 WRITTEN AND TCTIOT UPDATED       */
*/*            ERRCODE  - RCESTAER IF ESTAE ERROR                    */
*/*            INFOCODE - '0004'X IF ERRCODE NON-ZERO, BUT SOME      */
*/*                       UNALLOCATIONS DONE                         */
*/*                     - '003Y'X FOR SCRATCH ERROR                  */
*/*                     - '002Z'X FOR CATALOG MNGMNT ERROR           */
*/*                                                                  */
*/********************************************************************/
*IF RSNCDARY(4) ^= 0 THEN              /*IF ESTAE ENVIRONMENT ERROR  */
         LH    @09,RSNCDARY+6                                   02S0288
         LTR   @09,@09                                          02S0288
         BZ    @RF00288                                         02S0288
*  ERRCODE = RCESTAER;                 /*NO UNALLOCS; SET ERROR CODE */
         L     @09,@PC00001+8                                   02S0289
         MVC   ERRCODE(2,@09),@CH02719                          02S0289
*ELSE                                  /*NO ESTAE ERROR              */
*  DO;                                 /*UNALLOCS AT LEAST PARTIALLY
*                                        SUCCESS; CONTINUE WRAP UP   */
         B     @RC00288                                         02S0290
@RF00288 DS    0H                                               02S0291
*    WRPUPSWS = WRPUPSWS && WRPUPSWS;  /*ZERO OUT WRAP UP SWITCHES   */
         XC    WRPUPSWS(1),WRPUPSWS                             02S0291
*    DUMYWEPA = DUMYWEPA && DUMYWEPA;  /*ZERO DUMMY WRITE EPA        */
         XC    DUMYWEPA(16),DUMYWEPA                            02S0292
*    LSTWEPAP = ADDR(DUMYWEPA);        /*POINT LAST WRITE EPA PTR    */
         LA    @09,DUMYWEPA                                     02S0293
         ST    @09,LSTWEPAP                                     02S0293
*    DUMYDEPA = DUMYDEPA && DUMYDEPA;  /*ZERO DUMMY DELETE EPA       */
         XC    DUMYDEPA(16),DUMYDEPA                            02S0294
*    LSTDEPAP = ADDR(DUMYDEPA);        /*POINT LAST DELETE EPA PTR   */
         LA    LSTDEPAP,DUMYDEPA                                02S0295
*    CMRBPTR = FSTRBPTR;               /*POINT TO 1ST  UNALLOC RB    */
         L     CMRBPTR,FSTRBPTR                                 02S0296
*    DO WHILE CMRBPTR ^= 0;            /*PROCESS TILL LAST RB        */
*                                                               02S0297
         B     @DE00297                                         02S0297
@DL00297 DS    0H                                               02S0298
*      IF RSNCDSET = '0'B  &           /*IF NO CODE SET FOR PRIOR RB */
*         CMRETCDE ^= 0   THEN         /*AND THIS RB HAS NON-0 RETCDE*/
         TM    RSNCDSET,B'10000000'                             02S0298
         BNZ   @RF00298                                         02S0298
         LH    @09,CMRETCDE(,CMRBPTR)                           02S0298
         LTR   @09,@09                                          02S0298
         BZ    @RF00298                                         02S0298
*        DO;                           /*DETERMINE RETURN RSNCODE    */
*          IF CMSCRERR = '1'B THEN     /*IF ERROR FROM SCRATCH       */
         TM    CMSCRERR(CMRBPTR),B'10000000'                    02S0300
         BNO   @RF00300                                         02S0300
*            DO;                       /*PROCESS SCRATCH ERROR       */
*              INFOCODE = '0030'X | CMRETCDE; /*SET APPROPRIATE 02S0302
*                                               INFO CODE            */
         L     @02,@PC00001+8                                   02S0302
         O     @09,@CF02599                                     02S0302
         STH   @09,INFOCODE(,@02)                               02S0302
*              RSNCDSET = '1'B;        /*SAY REASON CODE IS SET      */
         OI    RSNCDSET,B'10000000'                             02S0303
*            END;                      /*END IF SCRATCH ERROR        */
*          ELSE                        /*ERROR WAS NOT IN SCRATCH    */
*            IF CMCATERR = '1'B THEN   /*IF ERROR FROM CATALOG MNGMT */
         B     @RC00300                                         02S0305
@RF00300 TM    CMCATERR(CMRBPTR),B'01000000'                    02S0305
         BNO   @RF00305                                         02S0305
*              DO;                     /*PROCESS CATALOG MNGMNT ERROR*/
*                INFOCODE = '0020'X | CATLERRC(CMRETCDE/4);     02S0307
         L     @09,@PC00001+8                                   02S0307
         LH    @00,CMRETCDE(,CMRBPTR)                           02S0307
         SRDA  @00,32                                           02S0307
         D     @00,@CF00072                                     02S0307
         LA    @02,32                                           02S0307
         SLR   @00,@00                                          02S0307
         IC    @00,CATLERRC-1(@01)                              02S0307
         OR    @02,@00                                          02S0307
         STH   @02,INFOCODE(,@09)                               02S0307
*                                      /*TRANSLATE & SET INFO CODE   */
*                RSNCDSET = '1'B;      /*DONT PROCESS OTHER RB RETCDE*/
         OI    RSNCDSET,B'10000000'                             02S0308
*              END;                    /*END IF CATALOG ERROR        */
*            ELSE                      /*NOT A CATALOG MNGMT ERROR   */
*              IF CMINTERR = '1'B THEN /*IF NO CORE FOR SCRATCH/CATLG
*                                        VOLUME LIST                 */
         B     @RC00305                                         02S0310
@RF00305 TM    CMINTERR(CMRBPTR),B'00010000'                    02S0310
         BNO   @RF00310                                         02S0310
*                DO;                   /*PROCESS INTERNAL ERROR      */
*                  IF CMORDISP = '1'B THEN /*IF OVERRIDING DISP WAS
*                                            PROCESSED               */
         TM    CMORDISP(CMRBPTR),B'00010000'                    02S0312
         BNO   @RF00312                                         02S0312
*                    IF CMDEL = '1'B THEN /*IF PROCESSED DISP WAS
*                                           DELETE                   */
         TM    CMDEL(CMRBPTR),B'10000000'                       02S0313
         BNO   @RF00313                                         02S0313
*                      INFOCODE = '0030'X | CMRETCDE; /*SET INFO CODE*/
         L     @09,@PC00001+8                                   02S0314
         LA    @02,48                                           02S0314
         LH    @15,CMRETCDE(,CMRBPTR)                           02S0314
         OR    @02,@15                                          02S0314
         STH   @02,INFOCODE(,@09)                               02S0314
*                    ELSE              /*DISP MUST HAVE BEEN CATALOG */
*                      INFOCODE = '0020'X | CMRETCDE; /*SET INFO CODE*/
         B     @RC00313                                         02S0315
@RF00313 L     @09,@PC00001+8                                   02S0315
         LA    @02,32                                           02S0315
         LH    @15,CMRETCDE(,CMRBPTR)                           02S0315
         OR    @02,@15                                          02S0315
         STH   @02,INFOCODE(,@09)                               02S0315
*                  ELSE                /*NORMAL DISP WAS PROCESSED   */
*                    IF SIOTDLET = '1'B THEN /*IF NORM DISP IS DELETE*/
         B     @RC00312                                         02S0316
@RF00312 L     @09,CMSIOPTR(,CMRBPTR)                           02S0316
         TM    SIOTDLET(@09),B'00000100'                        02S0316
         BNO   @RF00316                                         02S0316
*                      INFOCODE = '0030'X | CMRETCDE; /*SET INFO CODE*/
         L     @09,@PC00001+8                                   02S0317
         LA    @02,48                                           02S0317
         LH    @15,CMRETCDE(,CMRBPTR)                           02S0317
         OR    @02,@15                                          02S0317
         STH   @02,INFOCODE(,@09)                               02S0317
*                    ELSE              /*NORMAL DISP MUST BE CATALOG */
*                      INFOCODE = '0020'X | CMRETCDE; /*SET INFO CODE*/
         B     @RC00316                                         02S0318
@RF00316 L     @09,@PC00001+8                                   02S0318
         LA    @02,32                                           02S0318
         LH    @15,CMRETCDE(,CMRBPTR)                           02S0318
         OR    @02,@15                                          02S0318
         STH   @02,INFOCODE(,@09)                               02S0318
*                  RSNCDSET = '1'B;    /*SAY REASON CODE HAS BEEN SET*/
@RC00316 DS    0H                                               02S0319
@RC00312 OI    RSNCDSET,B'10000000'                             02S0319
*                END;                  /*END IF INTERNAL(NO CORE)
*                                        ERROR                       */
*              ELSE                    /*NOT INTERNAL ERROR          */
*                IF CMNODEN = '1'B THEN /*IF NO TAPE DENSITY FOR
*                                        CATALOG             @YM06419*/
         B     @RC00310                                         02S0321
@RF00310 TM    CMNODEN(CMRBPTR),B'00000100'                     02S0321
         BNO   @RF00321                                         02S0321
*                  DO;                 /*PROCESS ERROR       @YM06419*/
*                    INFOCODE = '0020'X | CMRETCDE; /*SET INFO CODE
*                                                            @YM06419*/
         L     @09,@PC00001+8                                   02S0323
         LA    @02,32                                           02S0323
         LH    @15,CMRETCDE(,CMRBPTR)                           02S0323
         OR    @02,@15                                          02S0323
         STH   @02,INFOCODE(,@09)                               02S0323
*                    RSNCDSET = '1'B;  /*REASON CODE SET     @YM06419*/
         OI    RSNCDSET,B'10000000'                             02S0324
*                  END;                /*END DENSITY ERROR   @YM06419*/
*                ELSE;                 /*IGNORE RET CODE     @YM06419*/
@RF00321 DS    0H                                               02S0327
*        END;                          /*END RB RETCDE PROCESS       */
*                                                               02S0327
@RC00310 DS    0H                                               02S0327
@RC00305 DS    0H                                               02S0327
@RC00300 DS    0H                                               02S0328
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - ANAMEDEQ                                  @YM06112*/
*/*                                                                  */
*/* DESCRIPTIVE NAME - ALIAS/ALTERNATE DSN DEQ PROCESSING            */
*/*                    (SEGMENT ADDED FOR PTM 06112)                 */
*/*                                                                  */
*/* FUNCTION -                                                       */
*/*           DEQ PROCESSING FOR REAL DSNAMES IN THE JFCB WILL       */
*/*           HAVE BEEN DONE BY COMMON UNALLOCATION AS NECESSARY.    */
*/*           ALIAS AND ALTERNATE DSNAMES HOWEVER WILL NOT HAVE      */
*/*           BEEN DEQ'D. THEREFORE IT IS THE PURPOSE OF THIS        */
*/*           SEGMENT TO PERFORM DEQ PROCESSING FOR THESE NAMES      */
*/*           RATHER THAN WAIT UNTIL THE END OF THE STEP             */
*/*           FOR THEM TO BE FREED.                                  */
*/*                                                                  */
*/* OPERATION -                                                      */
*/*           THIS SEGMENT LIES WITHIN A LOOP OF THE COMMON UN-      */
*/*           ALLOCATION RBS, PERFORMING WRAP UP PROCESSING FOR EACH */
*/*           JUST UNALLOCATED SIOT. IF AN ALIAS OR GDG STRUCTURE    */
*/*           DSN IS ASSOCIATED WITH A SIOT, A SCAN OF THE DSAB CHAIN*/
*/*           IS MADE TO SEE IF THE NAME IS ASSOCIATED WITH SOME     */
*/*           OTHER SIOT WHICH IS STILL ALLOCATED. (REAL NAMES,      */
*/*           ALIASES, AND ALTERNATES MUST ALL BE LOOKED AT WHILE    */
*/*           SCANNING THE DSAB CHAIN, BECAUSE A NAME WILL BE ENQ'D  */
*/*           UPON ONLY ONCE, EVEN IF IT IS THE NAME FOR MORE THAN   */
*/*           ONE OF THE ABOVE TYPES OF DATA SETS.)                  */
*/*                                                                  */
*/*           IF THE DSN IS STILL ASSOCIATED WITH SOME OTHER         */
*/*           ALLOCATION, NO DEQ PROCESSING IS DONE FOR IT.          */
*/*                                                                  */
*/*           IF THE DSN IS NOT ASSOCIATED WITH ANY OTHER            */
*/*           CURRENTLY ALLOCATED SIOT, THE DATA SET RESERVATION/    */
*/*           RELEASE SERVICE ROUTINE IS CALLED TO DEQ THE PARTICULAR*/
*/*           DSNAME.                                                */
*/*                                                                  */
*/*           NOTES - A SIOT CANNOT HAVE BOTH AN ALIAS AND AN        */
*/*                   ALTERNATE NAME ASSOCIATED WITH IT.             */
*/*                                                                  */
*/*                 - GDG STRUCTURE NAMES ARE THE ONLY ALTERNATE     */
*/*                   NAMES ENQ'D ON.                                */
*/*                                                                  */
*/*                 - AT THIS POINT DSAB'S HAVE BEEN FREED. THEREFORE*/
*/*                   THE GDG STRUCTURE NAME TO BE DEQ'D IS TAKEN    */
*/*                   FROM THE FIRST PART OF THE REAL NAME IN THE    */
*/*                   JFCB, RATHER THAN THE DSAB ALTERNATE NAME FIELD*/
*/*                                                                  */
*/* ENTRY -                                                          */
*/*    INPUT DATA -                                                  */
*/*                 CMUNRB   - COMMON UNALLOCATION RB WITH PTR TO    */
*/*                            THE SIOT JUST UNALLOCATED.            */
*/*                 DSQFRSTP - PTR TO 1ST DSAB IN THE CHAIN          */
*/*                 DEQCALL1 - IF ON, AT LEAST ONE DSN HAS           */
*/*                            ALREADY BEEN DEQ'D, AND DSRRFMAP AND  */
*/*                            DSENQFP ARE SET UP APPROPRIATELY      */
*/*                                                                  */
*/* EXIT -                                                           */
*/*    OUTPUT DATA -                                                 */
*/*                 DSRRFMAP - OTHER BITS SET AFTER THE 1ST CALL FOR */
*/*                            SUBSEQUENT CALLS TO IEFAB4DC          */
*/*                                                                  */
*/*                 DSENQFP  - PTR TO 1ST DSENQ RECORD, SET AFTER 1ST*/
*/*                            CALL FOR SUBSEQUENT CALLS             */
*/*                                                                  */
*/*                 DEQCALL1 - SET ON AFTER 1ST CALL OF IEFAB4DC,    */
*/*                            USED IN SUBSEQUENT CALLS              */
*/*                                                                  */
*/*                 LSTWEPAP - UPDATED BY IEFAB4DC FOR ANY EPAS      */
*/*                            ADDED TO THE WRITE CHAIN              */
*/*                                                                  */
*/********************************************************************/
*/* THIS CODE SEGMENT WAS ADDED FOR FIXING PTM06112          @YM06112*/
*                                                               03S0328
*RFY DSAB BASED(WRKDSABP);             /*RESET DSAB BASE PTR         */
@RF00298 DS    0H                                               03S0329
*RFY JFCBX BASED(SIOTJFX);             /*RESET JFCBX BASE PTR        */
*DEQDSNAM = '';                        /*BLANK OUT DSN TO BE DEQ'D   */
         MVI   DEQDSNAM,C' '                                    03S0330
         MVC   DEQDSNAM+1(43),DEQDSNAM                          03S0330
*IF SIOALIAS = '1'B THEN               /*IF ALIAS DSN EXISTS         */
         L     @09,CMSIOPTR(,CMRBPTR)                           03S0331
         TM    SIOALIAS(@09),B'10000000'                        03S0331
         BNO   @RF00331                                         03S0331
*  DEQDSNAM = JFCBXNAM;                /*COPY ALIAS FOR DEQ          */
         L     @09,SIOTJFX(,@09)                                03S0332
         MVC   DEQDSNAM(44),JFCBXNAM(@09)                       03S0332
*ELSE                                  /*NO ALIAS DSN                */
*  IF SIOTGALL = '1'B |                /*IF GDG ALL MEMBER           */
*     SCTSGDGS = '1'B THEN             /*OR A GDG SINGLE             */
         B     @RC00331                                         03S0333
@RF00331 L     @09,CMSIOPTR(,CMRBPTR)                           03S0333
         TM    SIOTGALL(@09),B'00100000'                        03S0333
         BO    @RT00333                                         03S0333
         TM    SCTSGDGS(@09),B'10000000'                        03S0333
         BNO   @RF00333                                         03S0333
@RT00333 DS    0H                                               03S0334
*    DO;                               /*GET GDG STRUCTURE NAME      */
*      GDGNMPTR=ADDR(JFCBDSNM) + 43;   /*GOTO END OF DSN FIELD       */
         L     @09,CMSIOPTR(,CMRBPTR)                           03S0335
         LA    GDGNMPTR,43                                      03S0335
         AL    GDGNMPTR,SJFCBPTR(,@09)                          03S0335
*      DO WHILE GDGCHAR = ' ';         /*GET LAST NON-BLANK          */
         B     @DE00336                                         03S0336
@DL00336 DS    0H                                               03S0337
*        GDGNMPTR = GDGNMPTR -1;       /*BACK UP ONE                 */
         BCTR  GDGNMPTR,0                                       03S0337
*      END;                            /*AT LAST NON-BLANK CHAR      */
@DE00336 CLI   GDGCHAR(GDGNMPTR),C' '                           03S0338
         BE    @DL00336                                         03S0338
*      GDGLEN = GDGNMPTR - ADDR(JFCBDSNM)-8; /*GET STRUCTURE NAME LEN*/
         L     @09,CMSIOPTR(,CMRBPTR)                           03S0339
         L     @09,SJFCBPTR(,@09)                               03S0339
         LR    GDGLEN,GDGNMPTR                                  03S0339
         SLR   GDGLEN,@09                                       03S0339
         SL    GDGLEN,@CF00075                                  03S0339
*      DEQDSNAM(1:GDGLEN) = JFCBDSNM(1:GDGLEN); /*COPY NAME FOR DEQ  */
         LR    @05,GDGLEN                                       03S0340
         BCTR  @05,0                                            03S0340
         EX    @05,@SM02890                                     03S0340
*    END;                              /*END IF GDG                  */
*  ELSE;                               /*NO GDG STRUCTURE NAME       */
@RF00333 DS    0H                                               03S0343
*IF DEQDSNAM(1) ^= ' ' THEN            /*IF DSN TO DEQ               */
@RC00331 CLI   DEQDSNAM,C' '                                    03S0343
         BE    @RF00343                                         03S0343
*  DO;                                 /*DEQ PROCESSING              */
*    DODEQSW = '1'B;                   /*ASSUME DEQ TO BE DONE       */
         OI    DODEQSW,B'10000000'                              03S0345
*    WRKDSABP = DSQFRSTP;              /*GET 1ST ALLOCATED DSAB      */
         L     @09,@PC00001+16                                  03S0346
         L     @09,JSCBPTR(,@09)                                03S0346
         L     @09,JSCDSABQ(,@09)                               03S0346
         L     WRKDSABP,DSQFRSTP(,@09)                          03S0346
*    DO WHILE WRKDSABP ^= 0 &          /*PROCESS TO END OF DSAB CHAIN*/
*             DODEQSW = '1'B;          /*OR TILL NO DEQ IS DETERMINED*/
         B     @DE00347                                         03S0347
@DL00347 DS    0H                                               03S0348
*      IF (DSABSIOT->SJFCBPTR->JFCBDSNM = DEQDSNAM & /*IF DSAB DSN
*                                       MATCHES                      */
*          DSABSIOT->SIOTQNAM = '0'B) | /*AND IS NOT A QNAME, OR     */
*          (DSABSIOT->SIOALIAS = '1'B & /*DSAB HAS ALIAS ASSOCIATED  */
*          DSABSIOT->SIOTJFX->JFCBXNAM=DEQDSNAM) |  /*AND       03S0348
*                                        ALIAS DSN FIELD MATCHES, OR */
*          (DSABANMP ^= 0 &            /*AN ALT. NAME EXISTS         */
*          DSABANAM(1:DSABANML)=DEQDSNAM(1:DSABANML) &          03S0348
*          DEQDSNAM(DSABANML+1) = ' ') THEN /*AND ALTERNATE MATCHES  */
         L     @09,DSABSIOT(,WRKDSABP)                          03S0348
         L     @01,SJFCBPTR(,@09)                               03S0348
         CLC   JFCBDSNM(44,@01),DEQDSNAM                        03S0348
         BNE   @GL00022                                         03S0348
         TM    SIOTQNAM(@09),B'00000001'                        03S0348
         BZ    @RT00348                                         03S0348
@GL00022 L     @09,DSABSIOT(,WRKDSABP)                          03S0348
         TM    SIOALIAS(@09),B'10000000'                        03S0348
         BNO   @GL00021                                         03S0348
         L     @09,SIOTJFX(,@09)                                03S0348
         CLC   JFCBXNAM(44,@09),DEQDSNAM                        03S0348
         BE    @RT00348                                         03S0348
@GL00021 L     @09,DSABANMP(,WRKDSABP)                          03S0348
         LTR   @09,@09                                          03S0348
         BZ    @RF00348                                         03S0348
         SLR   @15,@15                                          03S0348
         IC    @15,DSABANML(,@09)                               03S0348
         LR    @14,@15                                          03S0348
         BCTR  @14,0                                            03S0348
         EX    @14,@SC02892                                     03S0348
         BNE   @RF00348                                         03S0348
         LA    @09,DEQDSNAM(@15)                                03S0348
         CLI   0(@09),C' '                                      03S0348
         BNE   @RF00348                                         03S0348
@RT00348 DS    0H                                               03S0349
*        DODEQSW = '0'B;               /*DEQ SHOULD NOT BE DONE      */
         NI    DODEQSW,B'01111111'                              03S0349
*      ELSE                            /*DSN NOT ASSOC'D WITH DSAB   */
*        WRKDSABP = DSABFCHN;          /*CHECK NEXT DSAB IN CHAIN    */
         B     @RC00348                                         03S0350
@RF00348 L     WRKDSABP,DSABFCHN(,WRKDSABP)                     03S0350
*    END;                              /*END CHECK OF DSABS          */
@RC00348 DS    0H                                               03S0351
@DE00347 LTR   WRKDSABP,WRKDSABP                                03S0351
         BZ    @DC00347                                         03S0351
         TM    DODEQSW,B'10000000'                              03S0351
         BO    @DL00347                                         03S0351
@DC00347 DS    0H                                               03S0352
*    IF DODEQSW = '1'B THEN            /*IF STILL TO BE DEQ'D        */
         TM    DODEQSW,B'10000000'                              03S0352
         BNO   @RF00352                                         03S0352
*      DO;                             /*SET UP FOR AND DO DEQ       */
*        IF DEQCALL1 = '0'B THEN       /*IF NOTHING DEQ'D YET        */
         TM    DEQCALL1,B'00010000'                             03S0354
         BNZ   @RF00354                                         03S0354
*          DO;                         /*SET UP FOR 1ST CALL         */
*            DSRRFMAP = DSRRFMAP && DSRRFMAP; /*ZERO OUT FUNCTION MAP*/
         XC    DSRRFMAP(2),DSRRFMAP                             03S0356
*            READALL = '1'B;           /*READ ALL DSENQ RECORDS      */
         OI    READALL,B'00010000'                              03S0357
*            DELEDEQ = '1'B;           /*REQUEST DELETE/DEQ FUNCTION */
         OI    DELEDEQ,B'00001000'                              03S0358
*            DSENQFP = 0;              /*INIT PTR TO 1ST DSENQ RECORD*/
         SLR   @09,@09                                          03S0359
         ST    @09,DSENQFP                                      03S0359
*            DEQDSNLN=LENGTH(DEQDSNAM); /*INIT LEN FIELD OF DSN PARM */
         MVC   DEQDSNLN(2),@CH00141                             03S0360
*          END;                        /*END IF 1ST CALL FOR DEQ     */
*        ELSE;                         /*SERVICE RTN ALREADY CALLED  */
@RF00354 DS    0H                                               03S0363
*        IF JSCBTCBP = 0 THEN          /*IF INIT TCB PTR IS ZERO
*                                                            @ZA12405*/
         L     @09,@PC00001+16                                  03S0363
         L     @02,JSCBPTR(,@09)                                03S0363
         L     @02,JSCBTCBP(,@02)                               03S0363
         LTR   @02,@02                                          03S0363
         BNZ   @RF00363                                         03S0363
*          DEQTCBP = TCBPTR;           /*SET DEQ TCB PTR TO CURRENT  */
         L     @09,TCBPTR(,@09)                                 03S0364
         ST    @09,DEQTCBP                                      03S0364
*        ELSE                          /*USE INITIATOR'S TCB FOR DEQ */
*          DEQTCBP = JSCBTCBP;         /*SET DEQ TCB PTR TO INIT.'S  */
         B     @RC00363                                         03S0365
@RF00363 L     @09,@PC00001+16                                  03S0365
         L     @09,JSCBPTR(,@09)                                03S0365
         L     @09,JSCBTCBP(,@09)                               03S0365
         ST    @09,DEQTCBP                                      03S0365
*        CALL IEFAB4DC                 /*SERVICE RTN FOR DEQ         */
*                     (DSRRFMAP,JCTPTR,DEQDSNPM,LSTWEPAP,       03S0366
*                      DEQTCBP,SCTSNUMB,0,0,DEQDUMRC,DSENQFP,0);
@RC00363 LA    @09,DSRRFMAP                                     03S0366
         ST    @09,@AL00001                                     03S0366
         L     @09,@PC00001+16                                  03S0366
         LA    @02,JCTPTR(,@09)                                 03S0366
         ST    @02,@AL00001+4                                   03S0366
         LA    @02,DEQDSNPM                                     03S0366
         ST    @02,@AL00001+8                                   03S0366
         LA    @02,LSTWEPAP                                     03S0366
         ST    @02,@AL00001+12                                  03S0366
         LA    @02,DEQTCBP                                      03S0366
         ST    @02,@AL00001+16                                  03S0366
         L     @09,SCTPTR(,@09)                                 03S0366
         LA    @09,SCTSNUMB(,@09)                               03S0366
         ST    @09,@AL00001+20                                  03S0366
         LA    @09,@CF00108                                     03S0366
         ST    @09,@AL00001+24                                  03S0366
         LA    @09,@CF00108                                     03S0366
         ST    @09,@AL00001+28                                  03S0366
         LA    @09,DEQDUMRC                                     03S0366
         ST    @09,@AL00001+32                                  03S0366
         LA    @09,DSENQFP                                      03S0366
         ST    @09,@AL00001+36                                  03S0366
         LA    @09,@CF00108                                     03S0366
         ST    @09,@AL00001+40                                  03S0366
         L     @15,@CV00126                                     03S0366
         LA    @01,@AL00001                                     03S0366
         BALR  @14,@15                                          03S0366
*        IF DEQCALL1 = '0'B THEN       /*IF THIS WAS 1ST CALL        */
         TM    DEQCALL1,B'00010000'                             03S0367
         BNZ   @RF00367                                         03S0367
*          DO;                         /*SET UP FOR ANY OTHERS       */
*            DEQCALL1 = '1'B;          /*SAY 1ST CALL WAS MADE       */
         OI    DEQCALL1,B'00010000'                             03S0369
*            READALL = '0'B;           /*DONT READ RECORDS NEXT TIME */
*            INCORREC = '1'B;          /*DSENQ RECORDS ARE IN CORE   */
         OI    INCORREC,B'00001000'                             03S0371
         NI    READALL,B'11101111'                              03S0371
*          END;                        /*END IF 1ST CALL             */
*        ELSE;                         /*THIS WAS NOT 1ST DEQ        */
@RF00367 DS    0H                                               03S0374
*      END;                            /*END DSN DEQ                 */
*    ELSE;                             /*DSN NOT TO BE DEQ'D         */
@RF00352 DS    0H                                               03S0376
*  END;                                /*END DEQ PROCESSING          */
*ELSE;                                 /*NOTHING TO BE DEQ'D         */
@RF00343 DS    0H                                               03S0378
*RFY JFCBX BASED(JFCBXPTR);            /*RESET JFCBX MAPPING BASE PTR*/
*RFY DSAB BASED(DSABPTR);              /*RESET DSAB MAPPING BASE PTR */
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - RSTRTPCS                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - CHECKPOINT RESTART PROCESSING                 */
*/*                                                                  */
*/* OPERATION - THIS CODE IS ENTERED TO DO ANY NECESSARY CHECKPOINT  */
*/*             RESTART PROCESSING FOR THE PERFORMED UNALLOCATION.   */
*/*                                                                  */
*/*             IF AN UNALLOCATION WAS FOR A JCL ALLOCATED SIOT,     */
*/*             A BIT IS SET IN THE JSCB (JSCSIOTS) TELLING CHECK-   */
*/*             POINT TO SEARCH THE SIOTS WHEN CREATING THE DDNAME   */
*/*             TABLE. A BIT IN THE SIOT IS ALSO SET SAYING THAT     */
*/*             THE DDNAME FOR THIS SIOT MUST BE PUT INTO THE TABLE. */
*/*             THIS JCL SIOT IS THEN MARKED DYNAMICALLY UNALLOCATED */
*/*             AND THE WRTEPA SUBROUTINE IS CALLED TO BUILD AND     */
*/*             ENCHAIN A WRITE EPA FOR THIS UPDATED SIOT, IF ONE    */
*/*             DOES NOT ALREADY EXIST. ALL THIS PROCESSING IS       */
*/*             BYPASSED IF THE SIOT HAD BEEN DYNAMICALLY ALLOCATED. */
*/*                                                                  */
*/*             IF THE 'NO RESTART TO BE DONE' BIT IN THE JCT        */
*/*             (JCTNORST) IS OFF, AND IF THE 'NO AUTO RESTART' BIT  */
*/*             IN THE JCT(JCTNARST) IS ALSO OFF, THE FOLLOWING      */
*/*             CHECKS ARE MADE TO DETERMINE IF AUTOMATIC RESTART    */
*/*             SHOULD STILL BE ALLOWED (THE PHILOSOPHY BEHIND THESE */
*/*             CHECKS IS TO PREVENT RESTART ONLY IN THE CASE WHERE  */
*/*             THERE IS NO CHANCE OF RESTARTING CORRECTLY.)         */
*/*                                                                  */
*/*               - IF THE UNALLOCATED SIOT WAS EITHER FOR A SYSOUT  */
*/*                 DATA SET(CAUSING SPINOFF) OR HAD A DISPOSITION   */
*/*                 OF DELETE PROCESSED, THE DATA SET NO LONGER      */
*/*                 EXISTS. THEREFORE IN THESE CASES, IF A CHECKPOINT*/
*/*                 HAD BEEN TAKEN (JCTCKFT ON IN THE JCT), AND THE  */
*/*                 DATA SET WAS OPEN AT THE TIME OF CHECKPOINT      */
*/*                 (SIOTOCKP ON IN THE SIOT - CAUSING A REPOSITION- */
*/*                 ING OF THE READ/WRITE HEADS AT RESTART TIME AND  */
*/*                 GIVING ACCESS TO GARBAGE), NO AUTOMATIC RESTART  */
*/*                 SHOULD BE ALLOWED AND THE JCTNARST BIT IS SET.   */
*/*                 IF THIS IS A VIO DATA SET (SIOVAMDS IS   @ZA09215*/
*/*                 ON) AND IT WAS ALLOCATED AT THE LAST     @ZA09215*/
*/*                 CHECKPOINT (SCTALCHK IS ON) THEN TURN ON @ZA09215*/
*/*                 JCTNARST MAKING THE PROGRAM INELLIGIBLE  @ZA09215*/
*/*                 FOR AUTOMATIC RESTART. IF THIS IS SYSOUT @ZA09215*/
*/*                 DATA SET (SCTSYSOU IS ON) AND IT WAS     @ZA09215*/
*/*                 ALLOCATED AT THE LAST CHECKPOINT         @ZA09215*/
*/*                 (SCTALCHK IS ON) THEN TURN ON JCTNARST   @ZA09215*/
*/*                 MAKING THE PROGRAM INELLIGIBLE FOR AUTO- @ZA09215*/
*/*                 MATIC RESTART.                           @ZA09215*/
*/*                 (IF THE DATA SET WAS NOT OPEN AT THE CHECKPOINT, */
*/*                 AND IT IS NOT ONE OF THE ABOVE DATASETS  @ZA09215*/
*/*                 RESTART IS NOT PROHIBITED AS IT IS POSSIBLE NO   */
*/*                 ATTEMPT WILL BE MADE TO OPEN THE DATA SET. IF ONE*/
*/*                 IS MADE, THE OPEN WOULD FAIL)                    */
*/*                                                                  */
*/*               - IF NO CHECKPOINT HAS BEEN TAKEN BUT THE 'ELIGIBLE*/
*/*                 FOR STEP RESTART' BIT IN THE JCT(JCTRESTT) IS ON,*/
*/*                 THE JCTNARST BIT IS SET IF THE UNALLOCATED SIOT  */
*/*                 IS:                                              */
*/*                 . FOR A NEW JCL ALLOCATED DATA SET WHOSE         */
*/*                   PROCESSED DISPOSITION WAS KEEP, CATLG, OR      */
*/*                   UNCTLG. THIS IS BECAUSE THE STEP WOULD FAIL AT */
*/*                   RESTART TIME DUE TO THE DATA SET ALREADY       */
*/*                   EXISTING. (IF THE DATA SET HAD BEEN DYNAMICALLY*/
*/*                   ALLOCATED, ONLY AN ERROR REASON CODE WOULD BE  */
*/*                   RETURNED FROM WHICH A STEP COULD STILL         */
*/*                   CONTINUE)                                      */
*/*                                                                  */
*/*                 . FOR AN OLD JCL ALLOCATED DATA SET WHERE THE    */
*/*                   CATALOG WAS USED (IE VOL SERS NOT SPECIFIED) AT*/
*/*                   ALLOCATION, AND WHOSE PROCESSED DISPOSITION    */
*/*                   WAS UNCATLG. THIS IS TO PREVENT STEP FAILURE   */
*/*                   AT RESTART TIME DUE TO NOT BEING ABLE TO LOCATE*/
*/*                   THE DATA SET. (IF VOL SERS HAD BEEN SPECIFIED  */
*/*                   ON THE REQUEST, THE CATALOG WOULD NOT BE USED. */
*/*                   IF IT HAD BEEN A DYNAMIC ALLOCATION, ONLY AN   */
*/*                   ERROR REASON CODE WOULD BE RETURNED AT RESTART */
*/*                   WITH WHICH THE STEP COULD STILL CONTINUE.)     */
*/*                                                                  */
*/*                 . FOR AN OLD JCL ALLOCATED DATA SET WHOSE        */
*/*                   PROCESSED DISPOSITION WAS DELETE. THIS IS TO   */
*/*                   PREVENT EITHER STEP FAILURE (IN LOCATING THE   */
*/*                   DATA SET IF NO VOLUME SERIALS WERE SPECIFIED)  */
*/*                   OR OPEN FAILURE. (HERE, AS OPPOSED TO          */
*/*                   CHECKPOINT RESTART, IT IS ASSUMED THAT SOME    */
*/*                   ATTEMPT WILL BE MADE TO OPEN THE DATA SET      */
*/*                   SOMETIME DURING THE STEP)                      */
*/*                                                                  */
*/*                 . FOR AN OLD DYNAMICALLY ALLOCATED DATA SET WITH */
*/*                   VOL SERS SPECIFIED ON THE REQUEST, WHOSE       */
*/*                   PROCESSED DISPOSITION WAS DELETE. THIS IS      */
*/*                   BECAUSE THE RESTART DYNAMIC ALLOCATION IN THIS */
*/*                   CASE WOULD BE SUCESSFUL, CAUSING THE OPEN OF   */
*/*                   THE DATA SET TO FAIL. (IF VOL SERS WERE NOT    */
*/*                   SPECIFIED ON THE REQUEST, THE LOCATE IN THE    */
*/*                   RESTART DYNAMIC ALLOCATION WOULD CAUSE AN      */
*/*                   ERROR TO BE RETURNED WITH WHICH THE STEP COULD */
*/*                   STILL CONTINUE.)                               */
*/*                                                                  */
*/*                 NOTE THAT IN THE ABOVE STATUS CHECKS TO          */
*/*                 DETERMINE WHETHER A DATA SET IS NEW OR OLD, THE  */
*/*                 SIOTCNEW BIT IS USED IN ADDITION TO THE NORMAL   */
*/*                 STATUS BITS, TO DETERMINE THE STATUS OF THE DATA */
*/*                 SET ON ENTRY TO THE STEP.                        */
*/*                                                                  */
*/*             IF THE JCTNARST BIT WAS SET IN THE ABOVE PROCESSING, */
*/*             AN INTERNAL BIT SAYING THE JCT WAS UPDATED IS ALSO   */
*/*             SET. THIS WILL CAUSE THE JCT TO LATER BE WRITTEN OUT */
*/*             TO SWA.                                              */
*/*                                                                  */
*/* ENTRY -                                                          */
*/*   INPUT DATA - CMRBPTR - PTR TO UNALLOCATION RB                  */
*/*                JCTPTR   - PTR TO JCT                             */
*/*                                                                  */
*/* EXIT -                                                           */
*/*  OUTPUT DATA - JSCSIOTS - SET ON IF DATA SET WAS JCL ALLOCATED   */
*/*                SIOTDDNT - SET ON IF JCL ALLOCATION               */
*/*                SIODUNAL - SET ON IF JCL ALLOCATION               */
*/*                SWAEPA   - WRITE EPA ADDED TO CHAIN IF JCL SIOT   */
*/*                           (IF NOT ON ALREADY)                    */
*/*                JCTNARST - ON IF AUTO RESTART NOT TO BE ALLOWED   */
*/*                JCTUPDT  - SET ON IF THE JCT WAS UPDATED          */
*/*                                                                  */
*/********************************************************************/
*IF SIOTDYAL = '0'B  THEN              /*IF D.S. WAS NOT A DYN. ALLOC*/
         L     @09,CMSIOPTR(,CMRBPTR)                           03S0380
         TM    SIOTDYAL(@09),B'01000000'                        03S0380
         BNZ   @RF00380                                         03S0380
*  DO;                                 /*PROCESS JCL ALLOCATION      */
*     DO; /*MODESET  KEYADDR(KEYZERO)*/                         03S0382
*       SPKA (KEYZERO); /*SET PSW KEY*/                         03S0383
         L     @02,KEYZERO                                      03S0383
         SPKA  0(@02)                                           03S0383
*     END; /*MODESET  KEYADDR(KEYZERO)*/        /*KEY 0 TO UPDATE JSCB
*      */                                                       03S0384
*    JSCSIOTS = '1'B;                  /*CHECKPOINT RESTART TO SEARCH
*                                        SIOTS TO CREATE DDN TABLE   */
         L     @02,@PC00001+16                                  03S0385
         L     @02,JSCBPTR(,@02)                                03S0385
         OI    JSCSIOTS(@02),B'00000010'                        03S0385
*     DO; /*MODESET  EXTKEY(SCHED)*/                            03S0386
*       SPKA (16); /*SET PSW KEY*/                              03S0387
         LA    @04,16                                           03S0387
         SPKA  0(@04)                                           03S0387
*     END; /*MODESET  EXTKEY(SCHED)*/           /*RETURN TO SCHEDULER K
*Y     */                                                       03S0388
*    SIOTDDNT = '1'B;                  /*CHECKPOINT RESTART MUST PUT
*                                        THIS DDNAME IN DDN TABLE    */
*    SIODUNAL = '1'B;                  /*MARK D.S. DYNAM. UNALLOCATED*/
         OI    SIOTDDNT(@09),B'00010001'                        03S0390
*    WRKSIOTP = CMSIOPTR;              /*SET SIOTPTR FOR SUBRTN      */
         LR    WRKSIOTP,@09                                     03S0391
*    CALL WRTEPA;                      /*WRITE EPA PRCSS FOR SIOT    */
         BAL   @14,WRTEPA                                       03S0392
*  END;                                /*END IF JCL ALLOCATED        */
*ELSE;                                 /*D.S. WAS DYNAMICALLY ALLOC'D*/
*                                                               03S0394
@RF00380 DS    0H                                               03S0395
*RFY TEXTUNIT BASED(OVDSPTUP);         /*RESET TEXT UNIT BASE        */
*IF JCTNORST = '0'B  &                 /*IF USER IS ELIGIBLE FOR     */
*   JCTNARST = '0'B  THEN              /*RESTART                     */
         L     @09,@PC00001+16                                  03S0396
         L     @09,JCTPTR(,@09)                                 03S0396
         TM    JCTNORST(@09),B'01100000'                        03S0396
         BNZ   @RF00396                                         03S0396
*  DO;                                 /*SEE IF SHOULD STILL BE      */
*                                                               03S0397
*    IF JCTCKFT = '1'B THEN            /*IF A CHECKPOINT WAS TAKEN   */
         TM    JCTCKFT(@09),B'00010000'                         03S0398
         BNO   @RF00398                                         03S0398
*      IF SCTSYSOU = '1'B         |    /*IF D.S. IS SYSOUT OR        */
*         (CMORDISP = '1'B &           /*OVERRIDING DISP WAS USED    */
*          CMODEL = '1'B)  |           /*AND SPEC'D DISP WAS DELETE  */
*         (CMNMDISP = '1'B &           /*OR NORMAL DISP USED AND     */
*          SIOTDLET = '1'B &           /*SIOT DISP HAS DELETE AND    */
*          SIOTPASS = '0'B) THEN       /*NOT PASS ALSO       @YM06101*/
         L     @09,CMSIOPTR(,CMRBPTR)                           03S0399
         TM    SCTSYSOU(@09),B'00001000'                        03S0399
         BO    @RT00399                                         03S0399
         TM    CMORDISP(CMRBPTR),B'00010000'                    03S0399
         BNO   @GL00028                                         03S0399
         TM    CMODEL(CMRBPTR),B'00000100'                      03S0399
         BO    @RT00399                                         03S0399
@GL00028 TM    CMNMDISP(CMRBPTR),B'01000000'                    03S0399
         BNO   @RF00399                                         03S0399
         L     @09,CMSIOPTR(,CMRBPTR)                           03S0399
         TM    SIOTDLET(@09),B'00000100'                        03S0399
         BNO   @RF00399                                         03S0399
         TM    SIOTPASS(@09),B'00010000'                        03S0399
         BNZ   @RF00399                                         03S0399
@RT00399 DS    0H                                               03S0400
*        IF SIOTOCKP = '1'B THEN       /*THEN IF OPEN AT CHECKPOINT  */
         L     @09,CMSIOPTR(,CMRBPTR)                           03S0400
         TM    SIOTOCKP(@09),B'10000000'                        03S0400
         BNO   @RF00400                                         03S0400
*          JCTNARST = '1'B;            /*MAKE INELIGIBLE FOR AUTO
*                                        RESTART                     */
         L     @09,@PC00001+16                                  03S0401
         L     @09,JCTPTR(,@09)                                 03S0401
         OI    JCTNARST(@09),B'01000000'                        03S0401
*        ELSE                          /*ELSE NOT OPEN AT CHECKPOINT */
*          IF (SIOVAMDS = '1'B |       /*IS THIS VIO DATASET @ZA09215*/
*              SCTSYSOU = '1'B) &      /*IS THIS SYSOUT DS   @ZA09215*/
*              SCTALCHK = '1'B THEN    /*ALLOCATED AT LAST CHECKPOINT
*                                                            @ZA09215*/
         B     @RC00400                                         03S0402
@RF00400 L     @09,CMSIOPTR(,CMRBPTR)                           03S0402
         TM    SIOVAMDS(@09),B'00100000'                        03S0402
         BO    @GL00032                                         03S0402
         TM    SCTSYSOU(@09),B'00001000'                        03S0402
         BNO   @RF00402                                         03S0402
@GL00032 L     @09,CMSIOPTR(,CMRBPTR)                           03S0402
         TM    SCTALCHK(@09),B'00100000'                        03S0402
         BNO   @RF00402                                         03S0402
*           JCTNARST = '1'B;           /*SET NO AUTOMATIC RESTART BIT
*                                                            @ZA09215*/
         L     @09,@PC00001+16                                  03S0403
         L     @09,JCTPTR(,@09)                                 03S0403
         OI    JCTNARST(@09),B'01000000'                        03S0403
*         ELSE;                                                 03S0404
@RF00402 DS    0H                                               03S0405
*      ELSE;                           /*ELSE NOT SYSOUT OR DELETED  */
*                                                               03S0405
@RF00399 DS    0H                                               03S0406
*    ELSE                              /*ELSE NO CHECKPOINT TAKEN    */
*      IF JCTRESTT = '1'B THEN         /*IF ELIGIBLE FOR AUTO STEP
*                                        RESTART                     */
         B     @RC00398                                         03S0406
@RF00398 L     @09,@PC00001+16                                  03S0406
         L     @09,JCTPTR(,@09)                                 03S0406
         TM    JCTRESTT(@09),B'00001000'                        03S0406
         BNO   @RF00406                                         03S0406
*        IF (CMORDISP = '1'B &         /*IF OVERRIDING DISP USED     */
*            (CMOKEEP = '1'B |         /*AND DISP WAS KEEP OR        */
*             CMOCATLG = '1'B))  |     /*DISP WAS CATALOG, OR        */
*           (CMNMDISP = '1'B &         /*IF NORMAL DISP USED         */
*            (SIOTKEEP = '1'B |        /*AND ORIGINAL DISP WAS KEEP  */
*             SIOTCTLG = '1'B)) THEN   /*OR DISP WAS CATALOG         */
         TM    CMORDISP(CMRBPTR),B'00010000'                    03S0407
         BNO   @GL00034                                         03S0407
         TM    CMOKEEP(CMRBPTR),B'00001010'                     03S0407
         BNZ   @RT00407                                         03S0407
@GL00034 TM    CMNMDISP(CMRBPTR),B'01000000'                    03S0407
         BNO   @RF00407                                         03S0407
         L     @09,CMSIOPTR(,CMRBPTR)                           03S0407
         TM    SIOTKEEP(@09),B'00001010'                        03S0407
         BZ    @RF00407                                         03S0407
@RT00407 DS    0H                                               03S0408
*          IF (SCTSNEW = '1'B |        /*THEN IF D.S. ALLOCATED NEW  */
*              SIOTCNEW = '1'B) &      /*OR CONVERTED FROM NEW TO OLD*/
*             SIOTDYAL = '0'B THEN     /*AND ALLOCATION WAS JCL      */
         L     @09,CMSIOPTR(,CMRBPTR)                           03S0408
         TM    SCTSNEW(@09),B'00000100'                         03S0408
         BO    @GL00037                                         03S0408
         TM    SIOTCNEW(@09),B'00001000'                        03S0408
         BNO   @RF00408                                         03S0408
@GL00037 L     @09,CMSIOPTR(,CMRBPTR)                           03S0408
         TM    SIOTDYAL(@09),B'01000000'                        03S0408
         BNZ   @RF00408                                         03S0408
*            JCTNARST = '1'B;          /*MAKE INELIGIBLE FOR RESTART */
         L     @09,@PC00001+16                                  03S0409
         L     @09,JCTPTR(,@09)                                 03S0409
         OI    JCTNARST(@09),B'01000000'                        03S0409
*          ELSE;                       /*ELSE NOT A NEW JCL ALLOC.   */
*                                                               03S0410
@RF00408 DS    0H                                               03S0411
*        ELSE                          /*ELSE NOT KEEP OR CATALOG    */
*          IF (CMORDISP = '1'B &       /*IF OVERRIDING DISP USED     */
*              CMOUNCAT = '1'B)  |     /*AND DISP WAS UNCATALOG, OR  */
*             (CMNMDISP = '1'B  &      /*NORMAL DISP USED AND        */
*              SIOTUNCT = '1'B) THEN   /*ORIGINAL DISP WAS UNCATALOG */
         B     @RC00407                                         03S0411
@RF00407 TM    CMORDISP(CMRBPTR),B'00010000'                    03S0411
         BNO   @GL00039                                         03S0411
         TM    CMOUNCAT(CMRBPTR),B'00000001'                    03S0411
         BO    @RT00411                                         03S0411
@GL00039 TM    CMNMDISP(CMRBPTR),B'01000000'                    03S0411
         BNO   @RF00411                                         03S0411
         L     @09,CMSIOPTR(,CMRBPTR)                           03S0411
         TM    SIOTUNCT(@09),B'00000001'                        03S0411
         BNO   @RF00411                                         03S0411
@RT00411 DS    0H                                               03S0412
*            IF SIOTDYAL = '0'B      & /*THEN IF D.S. WAS JCL ALLOC. */
*               (SCTSNEW = '1'B  |     /*AND ALLOCATION IS NEW OR    */
*                SIOTCNEW = '1'B |     /*CONVERTED FROM NEW TO OLD OR*/
*                JFCCAT = '1'B) THEN   /*OLD AND CATALOG WAS USED    */
         L     @09,CMSIOPTR(,CMRBPTR)                           03S0412
         TM    SIOTDYAL(@09),B'01000000'                        03S0412
         BNZ   @RF00412                                         03S0412
         TM    SCTSNEW(@09),B'00000100'                         03S0412
         BO    @RT00412                                         03S0412
         TM    SIOTCNEW(@09),B'00001000'                        03S0412
         BO    @RT00412                                         03S0412
         L     @09,SJFCBPTR(,@09)                               03S0412
         TM    JFCCAT(@09),B'10000000'                          03S0412
         BNO   @RF00412                                         03S0412
@RT00412 DS    0H                                               03S0413
*              JCTNARST = '1'B;        /*MAKE INELIGIBLE FOR RESTART */
         L     @09,@PC00001+16                                  03S0413
         L     @09,JCTPTR(,@09)                                 03S0413
         OI    JCTNARST(@09),B'01000000'                        03S0413
*            ELSE;                     /*ELSE ALLOC WAS OLD W VOLSERS*/
*                                                               03S0414
@RF00412 DS    0H                                               03S0415
*          ELSE                        /*ELSE DISP WAS NOT UNCATALOG */
*            IF (CMORDISP = '1'B &     /*IF OVERRIDING DISP USED     */
*                CMODEL = '1'B) |      /*AND DISP WAS DELETE, OR     */
*               (CMNMDISP = '1'B &     /*NORMAL DISP USED AND        */
*                SIOTDLET = '1'B  &    /*SIOT DISP HAS DELETE AND    */
*                SIOTPASS = '0'B) THEN /*NOT ALSO PASS       @YM06101*/
         B     @RC00411                                         03S0415
@RF00411 TM    CMORDISP(CMRBPTR),B'00010000'                    03S0415
         BNO   @GL00045                                         03S0415
         TM    CMODEL(CMRBPTR),B'00000100'                      03S0415
         BO    @RT00415                                         03S0415
@GL00045 TM    CMNMDISP(CMRBPTR),B'01000000'                    03S0415
         BNO   @RF00415                                         03S0415
         L     @09,CMSIOPTR(,CMRBPTR)                           03S0415
         TM    SIOTDLET(@09),B'00000100'                        03S0415
         BNO   @RF00415                                         03S0415
         TM    SIOTPASS(@09),B'00010000'                        03S0415
         BNZ   @RF00415                                         03S0415
@RT00415 DS    0H                                               03S0416
*              IF SCTSOLD = '1'B &     /*THEN IF D.S. IS OLD AND     */
*                 SIOTCNEW = '0'B THEN /*NOT CONVERTED FROM NEW      */
         L     @09,CMSIOPTR(,CMRBPTR)                           03S0416
         TM    SCTSOLD(@09),B'00000001'                         03S0416
         BNO   @RF00416                                         03S0416
         TM    SIOTCNEW(@09),B'00001000'                        03S0416
         BNZ   @RF00416                                         03S0416
*                IF SIOTDYAL = '0'B  | /*THEN IF ALLOCATION WAS JCL  */
*                   JFCCAT = '0'B THEN /*OR DYNAMIC WITH VOLSERS     */
         TM    SIOTDYAL(@09),B'01000000'                        03S0417
         BZ    @RT00417                                         03S0417
         L     @09,SJFCBPTR(,@09)                               03S0417
         TM    JFCCAT(@09),B'10000000'                          03S0417
         BNZ   @RF00417                                         03S0417
@RT00417 DS    0H                                               03S0418
*                  JCTNARST = '1'B;    /*MAKE INELIGIBLE FOR RESTART */
         L     @09,@PC00001+16                                  03S0418
         L     @09,JCTPTR(,@09)                                 03S0418
         OI    JCTNARST(@09),B'01000000'                        03S0418
*                ELSE;                 /*ALLOC WAS DYNAMIC W/O VOLSER*/
@RF00417 DS    0H                                               03S0420
*              ELSE;                   /*DATA SET IS NOT OLD         */
@RF00416 DS    0H                                               03S0421
*            ELSE;                     /*DISP WAS NOT DELETE         */
@RF00415 DS    0H                                               03S0422
*      ELSE;                           /*NOT ELIGIBLE FOR STEP RESTRT*/
*                                                               03S0422
@RF00406 DS    0H                                               03S0423
*    IF JCTNARST = '1'B THEN           /*WAS NO AUTO RESTART JUST SET*/
@RC00406 DS    0H                                               03S0423
@RC00398 L     @09,@PC00001+16                                  03S0423
         L     @09,JCTPTR(,@09)                                 03S0423
         TM    JCTNARST(@09),B'01000000'                        03S0423
         BNO   @RF00423                                         03S0423
*      JCTUPDT = '1'B;                 /*YES, SET BIT TO WRITE JCT   */
         OI    JCTUPDT,B'00100000'                              03S0424
*  END;                                /*END IF ELIGIBLE FOR RESTART */
*ELSE;                                 /*NOT ELIGIBLE FOR RESTART    */
@RF00396 DS    0H                                               03S0427
*      IF SIOTDYAL = '1'B THEN         /*IF D.S. WAS DYNAMIC ALLOC'D */
@RC00396 L     @09,CMSIOPTR(,CMRBPTR)                           02S0427
         TM    SIOTDYAL(@09),B'01000000'                        02S0427
         BNO   @RF00427                                         02S0427
*        DO;                           /*DELETE SIOT,JFCB,JFCBXS     */
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - SIOTDPCS                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - SIOT DELETE PROCESS                           */
*/*                                                                  */
*/* FUNCTION  - IF A COMMON UNALLOCATION REQUEST BLOCK IS FOR A      */
*/*             DYNAMICALLY ALLOCATED SIOT, THIS CODE IS ENTERED     */
*/*             TO PERFORM DELETE PROCESSING FOR THE NOW UNALLOCATED */
*/*             SIOT, AND ITS CORRESPONDING JFCB AND ANY JFCBX'S.    */
*/*                                                                  */
*/* OPERATION - .THE GETEPA SUBROUTINE IS USED TO GET EPA CORE       */
*/*              FOR THE UNALLOCATED SIOT, ITS CORRESPONDING JFCB,   */
*/*              ANY ASSOCIATED JFCBX'S, AND IF THE SIOT IS  @G29AN2F*/
*/*              FOR A SUBSYS REQUEST THE SSWA.              @G29AN2F*/
*/*              GETEPA WILL ZERO OUT                        @G29AN2F*/
*/*              THIS CORE AND ADD EACH EPA TO THE END OF THE DELETE */
*/*              EPA CHAIN.                                          */
*/*             .THE EPA IS THEN FILLED IN WITH THE APPROPRIATE      */
*/*              INFORMATION FOR THE PARTICULAR CONTROL BLOCK.       */
*/*             .IF FSTSIOTP IS NOT POINTING TO THE FIRST SIOT       */
*/*              IN THE SIOT CHAIN (ON FIRST ENTRY TO THIS CODE,     */
*/*              FSTSIOTPTR POINTS TO THE 1ST 'ALLOCATED' SIOT       */
*/*              WHICH MAY OR MAY NOT BE THE 1ST IN THE CHAIN),      */
*/*              THE SWA MNGR. INTERFACE RTN. (IEFAB4F7) IS CALLED   */
*/*              TO READ IN THE 1ST SIOT. THIS IS NECESSARY FOR      */
*/*              DECHAINING THE DYNAMICALLY ALLOCATED SIOT WHICH     */
*/*              WAS JUST UNALLOCATED. (THE SIOTS THEMSELVES HAVE    */
*/*              ALREADY BEEN READ IN AND CHAINED TOGETHER WITH      */
*/*              IN CORE PTRS BY DYNAMIC ALLOCATION CONTROL)         */
*/*             .THE DECHAINING OF THE SIOT IS THEN PERFORMED.       */
*/*              (SEE SIOTDCHN SEGMENT FOR THIS FUNCTION.)           */
*/*                                                                  */
*/*              NOTE THAT THE GETEPA SUBROUTINE CONTINUALLY (ON EACH*/
*/*              CALL) UPDATES LASTEPAP WHICH IT USED AS THE PTR TO  */
*/*              THE LAST EPA, TO WHICH IT CHAINS NEW EPAS. THEREFORE*/
*/*              THIS VARIABLE IS SET TO LASTEPAP ON THE FIRST CALL  */
*/*              OF GETEPA BY THIS SEGMENT, AND LSTDEPAP NEED ONLY   */
*/*              BE UPDATED AFTER THE LAST CALL OF THIS SUBROUTINE.  */
*/*                                                                  */
*/* ENTRY -                                                          */
*/*   INPUT DATA - LSTDEPAP - PTR TO LAST EPA ON DELETE CHAIN        */
*/*                CMSIOPTR - PTR TO DYNAMICALLY ALLOCATED SIOT      */
*/*                           JUST UNALLOCATED                       */
*/*                FSTSIOTP - CORE PTR TO 1ST SIOT IN CHAIN AND/OR   */
*/*                           1ST ALLOCATED SIOT                     */
*/*                SCTFSIOT - SVA OF FIRST SIOT IN CHAIN             */
*/*                                                                  */
*/* EXIT -                                                           */
*/*  OUTPUT DATA - SWAEPA   - DELETE EPAS FOR SIOT, JFCB AND ANY     */
*/*                           JFCBXS                                 */
*/*                LSTDEPAP - POINTS TO NEW LAST DELETE EPA          */
*/*                FSTSIOTP - WILL BE POINTING TO 1ST SIOT IN CHAIN  */
*/*                           IF NOT SO ALREADY                      */
*/*                SIOT     - UNALLOCATED SIOT WHICH WAS DYNAMICALLY */
*/*                           ALLOCATED IS REMOVED FROM SIOT CHAIN   */
*/*                           (BY SIOTDCHN SEGMENT)                  */
*/*                                                                  */
*/********************************************************************/
*RFY SWAEPA BASED(LASTEPAP);           /*RESET BASE OF EPA MAP       */
*LASTEPAP = LSTDEPAP;                  /*POINT TO LAST DELETE EPA    */
*                                                               03S0430
         LR    LASTEPAP,LSTDEPAP                                03S0430
*CALL GETEPA;                          /*GET NEW EPA FOR SIOT        */
         BAL   @14,GETEPA                                       03S0431
*SWBLKPTR = CMSIOPTR;                  /*POINT EPA TO SIOT           */
         L     @09,CMSIOPTR(,CMRBPTR)                           03S0432
         ST    @09,SWBLKPTR(,LASTEPAP)                          03S0432
*SWVA = SIOTDSKA;                      /*PUT SIOT SVA INTO EPA       */
         MVC   SWVA(3,LASTEPAP),SIOTDSKA(@09)                   03S0433
*SWBLKID = SIOTTYPE;                   /*PUT SIOT BLOCK ID INTO EPA  */
         MVC   SWBLKID(1,LASTEPAP),SIOTTYPE(@09)                03S0434
*SWLNGTH = SIOTBKLN;                   /*PUT SIOT LENGTH INTO EPA    */
*                                                               03S0435
         MVC   SWLNGTH(4,LASTEPAP),@CF00113                     03S0435
*CALL GETEPA;                          /*GET NEW EPA FOR JFCB        */
         BAL   @14,GETEPA                                       03S0436
*SWBLKPTR = SJFCBPTR;                  /*POINT EPA TO JFCB           */
         L     @09,CMSIOPTR(,CMRBPTR)                           03S0437
         L     @06,SJFCBPTR(,@09)                               03S0437
         ST    @06,SWBLKPTR(,LASTEPAP)                          03S0437
*SWVA = SCTPJFCB;                      /*PUTJFCB SVA INTO EPA        */
         MVC   SWVA(3,LASTEPAP),SCTPJFCB(@09)                   03S0438
*SWBLKID = 28;                         /*PUT JFCB BLOCK ID INTO EPA  */
         MVI   SWBLKID(LASTEPAP),X'1C'                          03S0439
*SWLNGTH = JFCBBKLN;                   /*PUT JFCB LENGTH INTO EPA    */
*                                                               03S0440
         MVC   SWLNGTH(4,LASTEPAP),@CF00113                     03S0440
*JFCBXPTR = SIOTJFX;                   /*GET JFCBX CORE ADDR(IF ANY) */
         L     JFCBXPTR,SIOTJFX(,@09)                           03S0441
*SVAJFCBX = SJFCBPTR -> JFCBEXAD;      /*GET JFCBX SVA  (IF ANY)     */
         L     SVAJFCBX,JFCBEXAD-1(,@06)                        03S0442
         LA    SVAJFCBX,0(,SVAJFCBX)                            03S0442
*DO WHILE JFCBXPTR ^= 0;               /*LOOP THROUGH JFCBX(S)       */
         B     @DE00443                                         03S0443
@DL00443 DS    0H                                               03S0444
*  CALL GETEPA;                        /*GET EPA FOR JFCBX           */
         BAL   @14,GETEPA                                       03S0444
*  SWBLKPTR = JFCBXPTR;                /*POINT EPA TO JFCBX          */
         ST    JFCBXPTR,SWBLKPTR(,LASTEPAP)                     03S0445
*  SWVA = SVAJFCBX;                    /*PUT JFCBX SVA INTO EPA      */
         STCM  SVAJFCBX,7,SWVA(LASTEPAP)                        03S0446
*  SWBLKID = JFCBXID;                  /*PUT JFCBX BLOCK ID INTO EPA */
         MVI   SWBLKID(LASTEPAP),X'1D'                          03S0447
*  SWLNGTH = JFCBXLEN;                 /*PUT JFCBX LENGTH INTO EPA   */
         MVC   SWLNGTH(4,LASTEPAP),@CF00113                     03S0448
*  SVAJFCBX = JFCBXTTR;                /*GET SVA OF NEXT JFCBX       */
         SLR   SVAJFCBX,SVAJFCBX                                03S0449
         ICM   SVAJFCBX,7,JFCBXTTR(JFCBXPTR)                    03S0449
*  JFCBXPTR = JFCBXNXT;                /*GET CORE ADDR OF NEXT JFCBX */
         L     JFCBXPTR,JFCBXNXT(,JFCBXPTR)                     03S0450
*END;                                  /*END LOOP THRU JFCBX(S)      */
*                                                               03S0451
@DE00443 LTR   JFCBXPTR,JFCBXPTR                                03S0451
         BNZ   @DL00443                                         03S0451
*IF SIOTSSDS = ON                      /*SUBSYSTEM DATA SET? @G29AN2F*/
*  & SIOTSSGP = ON                     /*AND SUBSYS REQUEST? @G29AN2F*/
*  & SIOTSSWA ^= ZERO THEN             /*AND SSWA EXISTS ?   @G29AN2F*/
         L     @09,CMSIOPTR(,CMRBPTR)                           03S0452
         TM    SIOTSSDS(@09),B'10000000'                        03S0452
         BNO   @RF00452                                         03S0452
         TM    SIOTSSGP(@09),B'00010000'                        03S0452
         BNO   @RF00452                                         03S0452
         L     @09,SIOTSSWA-1(,@09)                             03S0452
         LA    @09,0(,@09)                                      03S0452
         LTR   @09,@09                                          03S0452
         BZ    @RF00452                                         03S0452
*  DO;                                 /*YES, SETUP TO DELETE   03S0453
*                                        SSWA                @G29AN2F*/
*    CALL GETEPA;                      /*GET EPA FOR SSWA    @G29AN2F*/
         BAL   @14,GETEPA                                       03S0454
*    SWBLKPTR = ZERO;                  /*DON'T POINT TO BLK  @G29AN2F*/
         SLR   @09,@09                                          03S0455
         ST    @09,SWBLKPTR(,LASTEPAP)                          03S0455
*    SWVA = SIOTSSWA;                  /*PUT SSWA SVA IN EPA @G29AN2F*/
         L     @06,CMSIOPTR(,CMRBPTR)                           03S0456
         MVC   SWVA(3,LASTEPAP),SIOTSSWA(@06)                   03S0456
*    SWBLKID = '31'X;                  /*PUT SSWA BLK ID IN  @G29AN2F*/
         MVI   SWBLKID(LASTEPAP),X'31'                          03S0457
*    SWLNGTH = ZERO;                   /*INDICATE USE LENGTH    03S0458
*                                        FROM BLOCK HEADER   @G29AN2F*/
         ST    @09,SWLNGTH(,LASTEPAP)                           03S0458
*  END;                                /*END SSWA DELETE     @G29AN2F*/
*LSTDEPAP = LASTEPAP;                  /*POINT TO NEW LAST DELETE EPA*/
@RF00452 LR    LSTDEPAP,LASTEPAP                                03S0460
*IF FSTSIOTP->SIOTDSKA^=SCTFSIOT THEN  /*IF NOT POINTING TO 1ST SIOT
*                                        IN CHAIN                    */
         L     @09,@PC00001+16                                  03S0461
         L     @09,SCTPTR(,@09)                                 03S0461
         L     @02,FSTSIOTP                                     03S0461
         CLC   SIOTDSKA(3,@02),SCTFSIOT(@09)                    03S0461
         BE    @RF00461                                         03S0461
*  DO;                                 /*READ 1ST SIOT TO GET ITS ADDR*
*    SWACTLS = SWACTLS && SWACTLS;     /*ZERO OUT FUNCTION MAP       */
         LH    @02,SWACTLS                                      03S0463
         N     @02,@CF02894                                     03S0463
         LR    @15,@02                                          03S0463
         XR    @15,@02                                          03S0463
         STH   @15,SWACTLS                                      03S0463
*    SWREAD = '1'B;                    /*PERFORM READ FUNCTION       */
*    SWNEW  = '1'B;                    /*CREATE EPA'S                */
*    SWFREE = '1'B;                    /*FREE EPA'S AFTER READ       */
         OI    SWREAD,B'00101100'                               03S0466
*    CALL IEFAB4F7 (SWACTLS,0,0,ADDR(SCTFSIOT),ADDR(FSTSIOTP),0,1);
         MVC   @AL00001+4(24),@AL00467                          03S0467
         LA    @02,SWACTLS                                      03S0467
         ST    @02,@AL00001                                     03S0467
         LA    @09,SCTFSIOT(,@09)                               03S0467
         ST    @09,@TF00001                                     03S0467
         LA    @09,@TF00001                                     03S0467
         ST    @09,@AL00001+12                                  03S0467
         LA    @09,FSTSIOTP                                     03S0467
         ST    @09,@TF00002                                     03S0467
         LA    @09,@TF00002                                     03S0467
         ST    @09,@AL00001+16                                  03S0467
         L     @15,@CV00125                                     03S0467
         LA    @01,@AL00001                                     03S0467
         BALR  @14,@15                                          03S0467
*                                      /*SWA MGR I/F TO READ 1ST SIOT*/
*  END;                                                         03S0468
*ELSE;                                 /*ALREADY POINTING TO 1ST SIOT*/
@RF00461 DS    0H                                               03S0470
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME - SIOTDCHN                                          */
*/*                                                                  */
*/* DESCRIPTIVE NAME - SIOT DECHAINING                               */
*/*                                                                  */
*/* FUNCTION  - DECHAIN A DYNAMICALLY ALLOCATED SIOT THAT HAS        */
*/*             JUST BEEN UNALLOCATED AND THAT IS TO BE DELETED      */
*/*                                                                  */
*/* OPERATION - IF THE SIOT TO BE DECHAINED IS THE FIRST SIOT IN     */
*/*             THE CHAIN, THE SVA OF THE FIRST SIOT IN THE SCT IS   */
*/*             UPDATED WITH THE SVA CHAIN PTR OF THE SIOT BEING     */
*/*             DECHAINED. (THIS WILL BE ZERO IF THE DECHAINED SIOT  */
*/*             IS THE ONLY SIOT IN THE CHAIN.) THE IN-CORE WORK PTR */
*/*             TO THE FIRST SIOT IS ALSO UPDATED WITH THE IN-CORE   */
*/*             CHAIN PTR OF THE SIOT BEING DECHAINED.               */
*/*           - OTHERWISE THE SIOT CHAIN IS SCANNED SEARCHING        */
*/*             FOR THE SIOT THAT IS TO BE DECHAINED. WHEN           */
*/*             FOUND, THE SVA AND IN-CORE CHAIN PTRS OF THE         */
*/*             PRECEEDING SIOT IN THE CHAIN ARE UPDATED WITH        */
*/*             THOSE OF THE DECHAINED SIOT. (THESE ARE ZERO IF      */
*/*             THE DECHAINED SIOT WAS THE LAST ONE.) IF THE         */
*/*             PRECEEDING SIOT WAS EITHER A JCL ALLOCATION,         */
*/*             OR A STILL ALLOCATED DYNAMIC ALLOCATION (I.E. IT     */
*/*             IS NOT GOING TO BE DECHAINED AND DELETED), THE       */
*/*             WRITEPA SUBROUTINE IS CALLED TO BUILD AND            */
*/*             ENCHAIN A WRITE EPA FOR THIS UPDATED SIOT (IF        */
*/*             ONE DOES NOT ALREADY EXIST FOR IT).                  */
*/*           - IF THE SIOT BEING DECHAINED WAS THE LAST SIOT        */
*/*             ON THE CHAIN, THE SVA OF THE LAST SIOT IN THE        */
*/*             SCT IS UPDATED WITH THE SVA OF THE PRECEEDING        */
*/*             SIOT. (OR ZERO IF THE LAST SIOT WAS THE ONLY         */
*/*             SIOT.)                                               */
*/*           - IF THE SCT IS UPDATED AS PART OF THIS DECHAINING,    */
*/*             AN INTERNAL BIT IS SET TO SAY THIS. AS A RESULT      */
*/*             THE UPDATED SCT WILL LATER BE WRITTEN OUT TO SWA.    */
*/*                                                                  */
*/* ENTRY -                                                          */
*/*   INPUT DATA - FSTSIOTP - IN CORE PTR TO FIRST SIOT IN CHAIN     */
*/*                CMSIOPTR - PTR TO SIOT TO BE DECHAINED            */
*/*                SCTLSIOT - SVA OF CURRENT LAST SIOT IN CHAIN      */
*/*                                                                  */
*/*                                                                  */
*/* EXIT -                                                           */
*/*  OUTPUT DATA - FSTSIOTP - UPDATED IF DECHAINED SIOT WAS FIRST    */
*/*                SCTFSIOTP -UPDATED IF DECHAINED SIOT WAS FIRST    */
*/*                SCTLSIOTP -UPDATED IF DECHAINED SIOT WAS LAST     */
*/*                SCTUPDT   -BIT SET ON IF SCT WAS UPDATED          */
*/*                SIOT      -CORE AND SVA CHAIN PTRS OF PRECEEDING  */
*/*                           SIOT UPDATED. WRITE EPA PROCESSING     */
*/*                           DONE IF IT IS JCL ALLOCATED, OR A      */
*/*                           STILL ALLOCATED DYNAMIC ALLOCATION.    */
*/*                                                                  */
*/********************************************************************/
*IF FSTSIOTP = CMSIOPTR THEN           /*IF SIOT IS FIRST ON CHAIN   */
         L     @09,CMSIOPTR(,CMRBPTR)                           04S0470
         C     @09,FSTSIOTP                                     04S0470
         BNE   @RF00470                                         04S0470
*  DO;                                 /*DECHAIN FIRST SIOT          */
*    SCTFSIOT = SCTPSIOT;              /*PUT ITS CHAIN SVA INTO SCT  */
         L     @02,@PC00001+16                                  04S0472
         L     @02,SCTPTR(,@02)                                 04S0472
         MVC   SCTFSIOT(3,@02),SCTPSIOT(@09)                    04S0472
*    FSTSIOTP = SIOTNPTR;              /*CHAIN CORE PTR IS NEW 1ST   */
         L     @15,SIOTNPTR(,@09)                               04S0473
         ST    @15,FSTSIOTP                                     04S0473
*    SCTUPDT = '1'B;                   /*SET INTERNAL SCT UPDATED BIT*/
         OI    SCTUPDT,B'01000000'                              04S0474
*    IF SCTLSIOT = SIOTDSKA THEN       /*IF 1ST SIOT WAS ALSO LAST   */
         CLC   SCTLSIOT(3,@02),SIOTDSKA(@09)                    04S0475
         BNE   @RF00475                                         04S0475
*      SCTLSIOT = 0;                   /*ZERO SCT PTR TO LAST SIOT   */
         SLR   @09,@09                                          04S0476
         STCM  @09,7,SCTLSIOT(@02)                              04S0476
*  END;                                /*END DECHAIN OF IST SIOT     */
*                                                               04S0477
*ELSE                                  /*SIOT IS NOT IST ON CHAIN    */
*  DO;                                 /*FIND SIOT IN CHAIN & DECHAIN*/
         B     @RC00470                                         04S0478
@RF00470 DS    0H                                               04S0479
*    PRESIOTP = FSTSIOTP;              /*INIT PTR TO PRECEEDING SIOT */
         L     @09,FSTSIOTP                                     04S0479
         LR    PRESIOTP,@09                                     04S0479
*    SIOTSAVP = FSTSIOTP -> SIOTNPTR;  /*INIT PTR TO SIOT LOOKING AT */
         L     SIOTSAVP,SIOTNPTR(,@09)                          04S0480
*    SIOTFND = '0'B;                   /*INIT LOOP CONTROL SWITCH    */
         NI    SIOTFND,B'01111111'                              04S0481
*    DO WHILE SIOTFND = '0'B;          /*SEARCH TILL SIOT IS FOUND   */
         B     @DE00482                                         04S0482
@DL00482 DS    0H                                               04S0483
*      IF SIOTSAVP = CMSIOPTR THEN     /*IF THIS IS SIOT TO DECHAIN  */
         L     @09,CMSIOPTR(,CMRBPTR)                           04S0483
         CR    SIOTSAVP,@09                                     04S0483
         BNE   @RF00483                                         04S0483
*        DO;                           /*THEN DECHAIN SIOT           */
*          PRESIOTP -> SIOTNPTR = SIOTNPTR;                     04S0485
         L     @05,SIOTNPTR(,@09)                               04S0485
         ST    @05,SIOTNPTR(,PRESIOTP)                          04S0485
*                                      /*UPDATE PRIOR SIOTS CHAIN PTR*/
*          PRESIOTP -> SCTPSIOT = SCTPSIOT;                     04S0486
         MVC   SCTPSIOT(3,PRESIOTP),SCTPSIOT(@09)               04S0486
*                                      /*UPDATE PRIOR SIOTS CHAIN SVA*/
*          IF SCTLSIOT = SIOTDSKA THEN /*IF DECHAINED SIOT WAS LAST  */
         L     @05,@PC00001+16                                  04S0487
         L     @05,SCTPTR(,@05)                                 04S0487
         CLC   SCTLSIOT(3,@05),SIOTDSKA(@09)                    04S0487
         BNE   @RF00487                                         04S0487
*            DO;                       /*UPDATE SVA OF LAST IN SCT   */
*              SCTLSIOT = PRESIOTP -> SIOTDSKA;                 04S0489
         MVC   SCTLSIOT(3,@05),SIOTDSKA(PRESIOTP)               04S0489
*                                      /*SVA OF NEW LAST SIOT IN SCT */
*              SCTUPDT = '1'B;         /*SET INTERNAL SCT UPDATED BIT*/
         OI    SCTUPDT,B'01000000'                              04S0490
*            END;                      /*END IF DECHAINING LAST SIOT */
*          IF PRESIOTP -> SIOTDYAL = '0'B |                     04S0492
*                                      /*IF PRIOR SIOT IS JCL,OR A   */
*             PRESIOTP -> SIOTSTEP = '0'B THEN                  04S0492
@RF00487 TM    SIOTDYAL(PRESIOTP),B'01000000'                   04S0492
         BZ    @RT00492                                         04S0492
         TM    SIOTSTEP(PRESIOTP),B'00001000'                   04S0492
         BNZ   @RF00492                                         04S0492
@RT00492 DS    0H                                               04S0493
*                                      /*STILL ALLOCATED DYNAMIC SIOT*/
*            DO;                       /*UPDATED SIOT MUST BE WRITTEN*/
*              WRKSIOTP = PRESIOTP;    /*POINT TO SIOT TO BE WRITTEN */
         LR    WRKSIOTP,PRESIOTP                                04S0494
*              CALL WRTEPA;            /*WRITE EPA CHAINING PROCESS  */
         BAL   @14,WRTEPA                                       04S0495
*            END;                      /*END PRIOR SIOT NEEDS WRITE  */
*          SIOTFND = '1'B;             /*SIOT IS FOUND - EXIT LOOP   */
@RF00492 OI    SIOTFND,B'10000000'                              04S0497
*        END;                          /*END IF SIOT IS FOUND        */
*      ELSE                            /*THIS IS NOT SIOT TO DECHAIN */
*        DO;                           /*CONTINUE LOOKING DOWN CHAIN */
         B     @RC00483                                         04S0499
@RF00483 DS    0H                                               04S0500
*          PRESIOTP = SIOTSAVP;        /*UPDATE PRIOR PTR TO THIS PTR*/
         LR    PRESIOTP,SIOTSAVP                                04S0500
*          SIOTSAVP = SIOTSAVP -> SIOTNPTR; /*LOOK AT NEXT ON CHAIN  */
         L     SIOTSAVP,SIOTNPTR(,SIOTSAVP)                     04S0501
*        END;                          /*END IF NOT SIOT LOOKING FOR */
*    END;                              /*END SEARCH FOR SIOT         */
@RC00483 DS    0H                                               04S0503
@DE00482 TM    SIOTFND,B'10000000'                              04S0503
         BZ    @DL00482                                         04S0503
*  END;                                /*END IF SIOT IS NOT IST ONE  */
*        END;                          /*END IF DYNAMICALLY ALLOCATED*/
*      ELSE;                           /*D.S. WAS JCL ALLOCATED      */
@RF00427 DS    0H                                               02S0507
*       DO; /*MODESET  KEYADDR(KEYZERO)*/                       02S0507
@RC00427 DS    0H                                               02S0508
*         SPKA (KEYZERO); /*SET PSW KEY*/                       02S0508
         L     @09,KEYZERO                                      02S0508
         SPKA  0(@09)                                           02S0508
*       END; /*MODESET  KEYADDR(KEYZERO)*/      /*GET INTO KEY 0 TO UPD
*TE                                               JSCB          02S0509
*      */                                                       02S0509
*      JSCDDNUM = JSCDDNUM-1;          /*DECREMENT COUNT OF ALLOCATED
*                                        SIOTS                       */
         L     @09,@PC00001+16                                  02S0510
         L     @09,JSCBPTR(,@09)                                02S0510
         LH    @02,JSCDDNUM(,@09)                               02S0510
         BCTR  @02,0                                            02S0510
         STH   @02,JSCDDNUM(,@09)                               02S0510
*       DO; /*MODESET  EXTKEY(SCHED)*/                          02S0511
*         SPKA (16); /*SET PSW KEY*/                            02S0512
         LA    @09,16                                           02S0512
         SPKA  0(@09)                                           02S0512
*       END; /*MODESET  EXTKEY(SCHED)*/         /*RETURN TO SCHEDULER K
*Y     */                                                       02S0513
*      CMRBPTR = CMNRBPTR;             /*POINT TO NEXT UNALLOC RB    */
         L     CMRBPTR,CMNRBPTR(,CMRBPTR)                       02S0514
*    END;                              /*END LOOP RB PROCESS         */
*                                                               02S0515
@DE00297 LTR   CMRBPTR,CMRBPTR                                  02S0515
         BNZ   @DL00297                                         02S0515
*    RFY SWAEPA BASED(LSTWEPAP);       /*RESET BASE OF EPA MAP TO
*                                        ADDR OF LAST WRITE EPA      */
*    IF SCTUPDT = '1'B THEN            /*IF SCT WAS UPDATED          */
         TM    SCTUPDT,B'01000000'                              02S0517
         BNO   @RF00517                                         02S0517
*      DO;                             /*SCT MUST BE WRITTEN         */
*        LASTEPAP = LSTWEPAP;          /*POINT TO LAST WRITE EPA     */
         L     LASTEPAP,LSTWEPAP                                02S0519
*        CALL GETEPA;                  /*GET NEW EPA FOR SCT         */
         BAL   @14,GETEPA                                       02S0520
*        LSTWEPAP = LASTEPAP;          /*POINT TO EPA FOR SCT        */
         ST    LASTEPAP,LSTWEPAP                                02S0521
*        SWBLKPTR = SCTPTR;            /*POINT EPA TO SCT CTL BLOCK  */
         L     @09,LSTWEPAP                                     02S0522
         L     @06,@PC00001+16                                  02S0522
         L     @06,SCTPTR(,@06)                                 02S0522
         ST    @06,SWBLKPTR(,@09)                               02S0522
*        SWVA = SCTDISKA;              /*PUT IN SVA OF SCT           */
         MVC   SWVA(3,@09),SCTDISKA(@06)                        02S0523
*        SWBLKID = SCTTBLID;           /*PUT IN BLOCKID OF SCT       */
         MVC   SWBLKID(1,@09),SCTTBLID(@06)                     02S0524
*        SWLNGTH = LENGTH(INSMSCT);    /*PUT IN LENGTH OF SCT        */
         MVC   SWLNGTH(4,@09),@CF00113                          02S0525
*      END;                            /*END IF SCT WAS UPDATED      */
*    IF JCTUPDT = '1'B THEN            /*IF JCT WAS UPDATED AND      */
@RF00517 TM    JCTUPDT,B'00100000'                              02S0527
         BNO   @RF00527                                         02S0527
*      DO;                             /*JCT MUST BE WRITTEN         */
*        LASTEPAP = LSTWEPAP;          /*POINT TO LAST WRITE EPA     */
         L     LASTEPAP,LSTWEPAP                                02S0529
*        CALL GETEPA;                  /*GET NEW EPA FOR JCT         */
         BAL   @14,GETEPA                                       02S0530
*        LSTWEPAP = LASTEPAP;          /*POINT TO EPA FOR JCT        */
         ST    LASTEPAP,LSTWEPAP                                02S0531
*        SWBLKPTR = JCTPTR;            /*POINT EPA TO JCT CTL BLOCK  */
         L     @09,LSTWEPAP                                     02S0532
         L     @06,@PC00001+16                                  02S0532
         L     @06,JCTPTR(,@06)                                 02S0532
         ST    @06,SWBLKPTR(,@09)                               02S0532
*        SWVA = JCTDSKAD;              /*PUT IN SVA OF JCT           */
         MVC   SWVA(3,@09),JCTDSKAD(@06)                        02S0533
*        SWBLKID = JCTIDENT;           /*PUT IN BLOCK ID OF JCT      */
         MVC   SWBLKID(1,@09),JCTIDENT(@06)                     02S0534
*        SWLNGTH = LENGTH(INJMJCT);    /*PUT IN LENGTH OF JCT        */
         MVC   SWLNGTH(4,@09),@CF00113                          02S0535
*      END;                            /*END IF JCT WAS UPDATED      */
*    EPALAST -> SWCHNPTR = FSTWEPAP;   /*CHAIN WRITE EPAS INTO INPUT
*                                        LAST EPA                    */
@RF00527 L     @09,@PC00001+12                                  02S0537
         L     @06,EPALAST(,@09)                                02S0537
         L     @15,FSTWEPAP                                     02S0537
         ST    @15,SWCHNPTR(,@06)                               02S0537
*    EPALAST = LSTWEPAP;               /*UPDATE PTR TO LAST EPA      */
         L     @06,LSTWEPAP                                     02S0538
         ST    @06,EPALAST(,@09)                                02S0538
*    IF FSTDEPAP ^= 0 THEN             /*IF THERE ARE DELETE EPAS    */
         L     @09,FSTDEPAP                                     02S0539
         LTR   @09,@09                                          02S0539
         BZ    @RF00539                                         02S0539
*      DO;                             /*DO DELETE PROCESSING        */
*        SWACTLS = SWACTLS && SWACTLS; /*ZERO OUT FUNCTION MAP       */
         LH    @09,SWACTLS                                      02S0541
         N     @09,@CF02894                                     02S0541
         LR    @06,@09                                          02S0541
         XR    @06,@09                                          02S0541
         STH   @06,SWACTLS                                      02S0541
*        SWDEL = '1'B;                 /*DO DELETE FUNCTION          */
*        SWOLD = '1'B;                 /*USE EXISTING INPUT EPAS     */
*        SWFREE = '1'B;                /*FREE EPA CORE AFTER DELETE  */
         OI    SWDEL,B'01000101'                                02S0544
*        CALL IEFAB4F7(SWACTLS,FSTDEPAP,0,0,0,0,0);             02S0545
         MVC   @AL00001+8(20),@AL00545                          02S0545
         LA    @09,SWACTLS                                      02S0545
         ST    @09,@AL00001                                     02S0545
         LA    @09,FSTDEPAP                                     02S0545
         ST    @09,@AL00001+4                                   02S0545
         L     @15,@CV00125                                     02S0545
         LA    @01,@AL00001                                     02S0545
         BALR  @14,@15                                          02S0545
*                                      /*SWA MNGR INTERFACE TO DELETE*/
*      END;                            /*END DELETE PROCESSING       */
*    CALL IEFDB4F9('02'X,TCBPTR,SMFARRAY,DEPARMS,JSCDSABQ,SMFPARMS);
@RF00539 LA    @09,@CB02829                                     02S0547
         ST    @09,@AL00001                                     02S0547
         L     @09,@PC00001+16                                  02S0547
         LA    @06,TCBPTR(,@09)                                 02S0547
         ST    @06,@AL00001+4                                   02S0547
         L     @06,SMFARYP                                      02S0547
         ST    @06,@AL00001+8                                   02S0547
         L     @06,@PC00001+24                                  02S0547
         ST    @06,@AL00001+12                                  02S0547
         L     @09,JSCBPTR(,@09)                                02S0547
         LA    @09,JSCDSABQ(,@09)                               02S0547
         ST    @09,@AL00001+16                                  02S0547
         L     @09,@PC00001+28                                  02S0547
         ST    @09,@AL00001+20                                  02S0547
         L     @15,@CV00127                                     02S0547
         LA    @01,@AL00001                                     02S0547
         BALR  @14,@15                                          02S0547
*                                      /*SMF PROCESS FOR UNALLOC FN.
*                                                            @ZA02706*/
*    IF ERRCODE  ^= 0 THEN             /*IF ANY ERROR HAS BEEN FOUND */
         L     @09,@PC00001+8                                   02S0548
         LH    @06,ERRCODE(,@09)                                02S0548
         LTR   @06,@06                                          02S0548
         BZ    @RF00548                                         02S0548
*      INFOCODE = '0004'X;             /*SAY SOME UNALLOCATION HAS
*                                        BEEN DONE                   */
         MVC   INFOCODE(2,@09),@CH02845                         02S0549
*  END;                                /*END IF NO ESTAE ERROR       */
@RF00548 DS    0H                                               02S0551
*R0 = COUNT * (LENGTH(CMUNRB) + OPTFLDLN + LENGTH(SMFARRAY(1)));
@RC00288 LA    @01,21                                           02S0551
         ALR   @01,OPTFLDLN                                     02S0551
         MR    R0,COUNT                                         02S0551
         LR    R0,@01                                           02S0551
*                                      /*SIZE OF CORE TO FREE        */
*R0 = R0 | SCHDSUBP;                   /*FREE FROM CORRECT SUBPOOL   */
         O     R0,@CF00118                                      02S0552
*GEN (FREEMAIN R,LV=(0),A=FSTRBPTR);   /*FREE UNALLOC RBS & SMF ARRAY*/
         FREEMAIN R,LV=(0),A=FSTRBPTR
*RETURN CODE(0);                       /*REG 15 = 0 & RETURN         */
         L     @13,4(,@13)                                      01S0554
         L     @00,@SIZDATD                                     01S0554
         LR    @01,@10                                          01S0554
         FSPACE   R,LV=(0),A=(1)
         SLR   @15,@15                                          01S0554
         L     @14,12(,@13)                                     01S0554
         LM    @00,@12,20(@13)                                  01S0554
         BR    @14                                              01S0554
*/********************************************************************/
*/*                                                                  */
*/* SUBROUTINE NAME - WRTEPA                                         */
*/*                                                                  */
*/* DESCRIPTIVE NAME - WRITE EPA PROCESSING FOR UPDATED SIOTS        */
*/*                                                                  */
*/* OPERATION - THIS SUBROUTINE IS CALLED BY THE RSTRTPCS AND        */
*/*             SIOTDCHN SEGMENTS TO DO WRITE EPA PROCESSING FOR     */
*/*             AN UPDATED SIOT. A SCAN OF THE WRITE EPA CHAIN       */
*/*             IS MADE, DETERMINING WHETHER OR NOT AN EPA FOR THE   */
*/*             SIOT ALREADY EXISTS ON THE CHAIN. IF THERE IS ONE,   */
*/*             NO EPA IS NEEDED. HOWEVER IF ONE IS NOT ALREADY      */
*/*             ON THE CHAIN, THE GETEPA SUBRTN IS CALLED TO GET     */
*/*             CORE FOR AN EPA, ZERO IT OUT, AND CHAIN IT TO THE END*/
*/*             OF THE WRITE CHAIN. THIS NEW EPA IS THEN FILLED      */
*/*             IN WITH THE APPROPRIATE INFO FOR THE SIOT.           */
*/*                                                                  */
*/* ENTRY -                                                          */
*/*   INPUT DATA - FSTWEPAP - PTR TO FIRST WRITE EPA ON CHAIN        */
*/*                WRKSIOTP - PTR TO UPDATED SIOT                    */
*/*                LSTWEPAP - PTR TO LAST WRITE EPA ON CHAIN         */
*/*                                                                  */
*/* EXIT -                                                           */
*/*   OUTPUT DATA - SWAEPA - EPA BUILT FOR UPDATED SIOT AND ENCHAINED*/
*/*                          (IF ONE DOES NOT ALREADY EXIST)         */
*/*                 LSTWEPAP - POINTS TO NEW EPA CREATED             */
*/*                                                                  */
*/********************************************************************/
*WRTEPA: PROC;                                                  02S0555
WRTEPA   STM   @14,@12,@SA00002                                 02S0555
*RFY SWAEPA BASED(SWEPAPTR);           /*RESET BASE OF EPA MAP       */
*RFY INDMSIOT BASED(WRKSIOTP);         /*RESET BASE OF SIOT MAP      */
*SWEPAPTR = FSTWEPAP;                  /*POINT TO 1ST  WRITE EPA     */
         L     SWEPAPTR,FSTWEPAP                                02S0558
*WRTEPASW = WRTEPASW && WRTEPASW;      /*ZERO OUT PROCESSING SWITCHES*/
         XC    WRTEPASW(1),WRTEPASW                             02S0559
*DO WHILE (SWEPAPTR ^= 0 &             /*LOOP TO END OF EPA CHAIN OR */
*          ONCHAIN = '0'B );           /*TILL EPA FOR SIOT IS FOUND  */
         B     @DE00560                                         02S0560
@DL00560 DS    0H                                               02S0561
*  IF WRKSIOTP = SWBLKPTR THEN         /*IF EPA IS FOR THE SIOT      */
         C     WRKSIOTP,SWBLKPTR(,SWEPAPTR)                     02S0561
         BNE   @RF00561                                         02S0561
*    ONCHAIN = '1'B;                   /*GET OUT OF LOOP SEARCH      */
         OI    ONCHAIN,B'10000000'                              02S0562
*  ELSE                                /*THIS EPA IS NOT FOR THE SIOT*/
*    SWEPAPTR = SWCHNPTR;              /*POINT TO NEXT EPA           */
         B     @RC00561                                         02S0563
@RF00561 L     SWEPAPTR,SWCHNPTR(,SWEPAPTR)                     02S0563
*END;                                  /*END SEARCH LOOP             */
@RC00561 DS    0H                                               02S0564
@DE00560 LTR   SWEPAPTR,SWEPAPTR                                02S0564
         BZ    @DC00560                                         02S0564
         TM    ONCHAIN,B'10000000'                              02S0564
         BZ    @DL00560                                         02S0564
@DC00560 DS    0H                                               02S0565
*IF ONCHAIN = '0'B THEN                /*IF EPA FOR SIOT WASN'T FOUND*/
         TM    ONCHAIN,B'10000000'                              02S0565
         BNZ   @RF00565                                         02S0565
*  DO;                                 /*GET A NEW WRITE EPA FOR IT  */
*    LASTEPAP = LSTWEPAP;              /*POINT TO LAST WRITE EPA     */
         L     LASTEPAP,LSTWEPAP                                02S0567
*    CALL GETEPA;                      /*GET NEW WRITE EPA FOR SIOT  */
         BAL   @14,GETEPA                                       02S0568
*    LSTWEPAP = LASTEPAP;              /*UPDATE PTR TO NEW LAST EPA  */
         ST    LASTEPAP,LSTWEPAP                                02S0569
*    RFY SWAEPA BASED(LSTWEPAP);       /*RESET BASE PTR OF EPA MAP   */
*    SWBLKPTR = WRKSIOTP;              /*POINT EPA TO SIOT           */
         L     @04,LSTWEPAP                                     02S0571
         ST    WRKSIOTP,SWBLKPTR(,@04)                          02S0571
*    SWVA = SIOTDSKA;                  /*PUT SVA OF SIOT INTO EPA    */
         MVC   SWVA(3,@04),SIOTDSKA(WRKSIOTP)                   02S0572
*    SWBLKID = SIOTTYPE;               /*PUT SIOT BLOCK ID INTO EPA  */
         MVC   SWBLKID(1,@04),SIOTTYPE(WRKSIOTP)                02S0573
*    SWLNGTH = SIOTBKLN;               /*PUT SIOT LENGTH INTO EPA    */
         MVC   SWLNGTH(4,@04),@CF00113                          02S0574
*  END;                                /*END WRITE EPA CHAINING      */
*ELSE;                                 /*EPA FOR SIOT ALREADY EXISTS */
@RF00565 DS    0H                                               02S0577
*END WRTEPA;                                                    02S0577
@EL00002 DS    0H                                               02S0577
@EF00002 DS    0H                                               02S0577
@ER00002 LM    @14,@12,@SA00002                                 02S0577
         BR    @14                                              02S0577
*/********************************************************************/
*/*                                                                  */
*/* SUBROUTINE NAME - GETEPA                                         */
*/*                                                                  */
*/* DESCRIPTIVE NAME - GET SPACE FOR AN EPA                          */
*/*                                                                  */
*/* OPERATION - THIS SUBROUTINE IS CALLED BY THE UNALWPUP AND        */
*/*            SIOTDPCS SEGMENTS, AND BY THE WRTEPA SUBROUTINE,      */
*/*            TO GETMAIN CORE FOR AN EPA.  A GETMAIN IS     @ZM41392*/
*/*            ISSUED FOR THIS CORE AND THE EPA IS ADDED     @ZM41392*/
*/*            TO THE END OF THE                             @ZM41392*/
*/*            EPA CHAIN, POINTING THE CHAIN PTR FIELD OF THE        */
*/*            CURRENT LAST EPA TO THIS NEW LAST EPA. LASTEPAP IS    */
*/*            THEN UPDATED TO POINT TO THIS LAST EPA AND THE        */
*/*            EPA CORE IS ZEROED OUT. NOTE THAT THE GOTTEN EPA      */
*/*            IS BEING ADDED TO EITHER A WRITE OR DELETE EPA CHAIN, */
*/*            DEPENDENT UPON HOW THE WORK PTR, LASTEPAP, IS SET     */
*/*            UP BY THE INVOKER.                                    */
*/*                                                                  */
*/* ENTRY -                                                          */
*/*    INPUT DATA - LASTEPAP - PTR TO CURRENT LAST EPA ON            */
*/*                           WRITE OR DELETE CHAIN                  */
*/*                 EPALAST - LAST WRITE EPA(MODULE INPUT)           */
*/*                                                                  */
*/* EXIT -                                                           */
*/*    OUTPUT DATA - LASTEPAP - POINTS TO NEW LAST EPA               */
*/*                  SWCHNPTR - CHAIN PTR OF FORMER LAST EPA POINTS  */
*/*                             TO NEW LAST EPA                      */
*/*                  SWAEPA   - NEW LAST EPA, ZEROED OUT             */
*/*                                                                  */
*/********************************************************************/
*GETEPA: PROC;                                                  02S0578
GETEPA   STM   @14,@03,@SA00003                                 02S0578
         STM   @05,@12,@SA00003+24                              02S0578
*RFY SWAEPA BASED(LASTEPAP);           /*RESET BASE OF EPA MAP       */
*R0 = LENGTH(SWAEPA);                  /*CORE NEEDED FOR EPA         */
         LA    R0,16                                            02S0580
*R0 = R0 | SCHDSUBP;                   /*GET FROM CORRECT SUBPOOL    */
         O     R0,@CF00118                                      02S0581
*GEN (GETMAIN R,LV=(0));               /*GET CORE FOR EPA    @ZM41392*/
         GETMAIN R,LV=(0)
*SWCHNPTR = R1;                        /*UPDATE CHAIN PTR OF FORMER
*                                        LAST EPA                    */
         ST    R1,SWCHNPTR(,LASTEPAP)                           02S0583
*LASTEPAP = SWCHNPTR;                  /*POINT TO NEW LAST EPA       */
         L     @15,SWCHNPTR(,LASTEPAP)                          02S0584
         LR    LASTEPAP,@15                                     02S0584
*SWAEPA = SWAEPA && SWAEPA;            /*ZERO OUT NEW LAST EPA       */
         XC    SWAEPA(16,LASTEPAP),SWAEPA(LASTEPAP)             02S0585
*END GETEPA;                                                    02S0586
@EL00003 DS    0H                                               02S0586
@EF00003 DS    0H                                               02S0586
@ER00003 LM    @14,@03,@SA00003                                 02S0586
         LM    @05,@12,@SA00003+24                              02S0586
         BR    @14                                              02S0586
*END IEFDB4A1                                                   01S0587
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (UNALPRSP)                                        *
*/*%INCLUDE SYSLIB  (UNALPRDT)                                        *
*/*%INCLUDE SYSLIB  (IEFZB4D9)                                        *
*/*%INCLUDE SYSLIB  (IEFZB4D1)                                        *
*/*%INCLUDE SYSLIB  (IEFZB4D6)                                        *
*/*%INCLUDE SYSLIB  (IEFZB436)                                        *
*/*%INCLUDE SYSLIB  (IEFZB439)                                        *
*/*%INCLUDE SYSLIB  (IEFZB446)                                        *
*/*%INCLUDE SYSLIB  (IEFZB505)                                        *
*/*%INCLUDE SYSLIB  (IHAQDB  )                                        *
*/*%INCLUDE SYSLIB  (IEFZB4D5)                                        *
*/*%INCLUDE SYSLIB  (IHADSAB )                                        *
*/*%INCLUDE SYSLIB  (IEFASIOT)                                        *
*/*%INCLUDE SYSLIB  (IEFJFCBN)                                        *
*/*%INCLUDE SYSLIB  (IEFJFCBX)                                        *
*/*%INCLUDE SYSLIB  (IEFJSSWA)                                        *
*/*%INCLUDE SYSLIB  (IEZJSCB )                                        *
*/*%INCLUDE SYSLIB  (IEFAJCTB)                                        *
*/*%INCLUDE SYSLIB  (IEFASCTB)                                        *
*/*%INCLUDE SYSLIB  (IKJTCB  )                                        *
*/*%INCLUDE SYSLIB  (IEFTIOT1)                                        *
*/*%INCLUDE SYSLIB  (CVT     )                                        *
*/*%INCLUDE SYSLIB  (IEEBASEA)                                        *
*/*%INCLUDE SYSLIB  (IEFZB4DA)                                        *
*/*%INCLUDE SYSLIB  (RBBUILD )                                        *
*/*%INCLUDE SYSLIB  (RBBUILDS)                                        *
*/*%INCLUDE SYSLIB  (RBFILLIN)                                        *
*/*%INCLUDE SYSLIB  (RBFILINS)                                        *
*/*%INCLUDE SYSLIB  (DSRELCHK)                                        *
*/*%INCLUDE SYSLIB  (DSRELCKS)                                        *
*/*%INCLUDE SYSLIB  (UNALWPUP)                                        *
*/*%INCLUDE SYSLIB  (UNALWRPS)                                        *
*/*%INCLUDE SYSLIB  (ANAMEDEQ)                                        *
*/*%INCLUDE SYSLIB  (ANAMEDQS)                                        *
*/*%INCLUDE SYSLIB  (RSTRTPCS)                                        *
*/*%INCLUDE SYSLIB  (RSTTPCSS)                                        *
*/*%INCLUDE SYSLIB  (SIOTDPCS)                                        *
*/*%INCLUDE SYSLIB  (SIODPCSP)                                        *
*/*%INCLUDE SYSLIB  (SIOTDCHN)                                        *
*/*%INCLUDE SYSLIB  (SIODCHNS)                                        *
*/*%INCLUDE SYSLIB  (WRTEPA  )                                        *
*/*%INCLUDE SYSLIB  (WRTEPASP)                                        *
*/*%INCLUDE SYSLIB  (GETEPA  )                                        *
*/*%INCLUDE SYSLIB  (GETEPASP)                                        *
*;                                                              01S0587
@DATA    DS    0H
@CH00085 DC    H'5'
@CH00141 DC    H'44'
@CH02719 DC    XL2'047C'
@CH02825 DC    XL2'0008'
@CH02845 DC    XL2'0004'
@SM02875 MVC   OVRDNGID(0),TEXTUPAR(@15)
@SC02883 CLC   DSABANAM(0,@06),JFCBDSNM(@15)
@SM02886 MVC   ENQBEGIN(0),ENQLIST
@SM02890 MVC   DEQDSNAM(0),JFCBDSNM(@09)
@SC02892 CLC   DSABANAM(0,@09),DEQDSNAM
         DS    0F
@AL00467 EQU   *                       LIST WITH   6 ARGUMENT(S)
@AL00545 DC    A(@CF00108)             LIST WITH   5 ARGUMENT(S)
         DC    A(@CF00108)
         DC    A(@CF00108)
         DC    A(@CF00108)
         DC    A(@CF00108)
         DC    A(@CF00088)
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    8F
@SA00002 DS    15F
@SA00003 DS    14F
@AL00001 DS    11A
@TF00001 DS    F
@TF00002 DS    F
IEFDB4A1 CSECT
         DS    0F
@CF00108 DC    F'0'
@CF00088 DC    F'1'
@CF00072 DC    F'4'
@CF00075 DC    F'8'
@CF00067 DC    F'16'
@CF00113 DC    F'176'
@CF02889 DC    F'-5'
@CF02877 DC    F'-4'
@CF00118 DC    XL4'E6000000'
@CF02894 DC    XL4'0000FFFF'
@CF02599 DC    XL4'0030'
@DATD    DSECT
         DS    0D
FSTRBPTR DS    A
FSTSIOTP DS    A
SMFARYP  DS    A
LISTDSAB DS    A
TCBP     DS    A
LSTWEPAP DS    A
DEQDUMRC DS    F
DEQTCBP  DS    A
DSENQFP  DS    A
S99TXTPP DS    A
TXTUFLDP DS    A
CFMAPTR  DS    A
QDBPTR   DS    A
SIOTPTR  DS    A
JFCBPTR  DS    A
SSWAPTR  DS    A
TIOTPTR  DS    A
SWACTLS  DS    FL2
         ORG   SWACTLS
SWASN    DS    BL1
SWDEL    EQU   SWACTLS+0
SWREAD   EQU   SWACTLS+0
SWWRT    EQU   SWACTLS+0
SWNEW    EQU   SWACTLS+0
SWFREE   EQU   SWACTLS+0
SWMOD    EQU   SWACTLS+0
SWOLD    EQU   SWACTLS+0
SWCHN    DS    BL1
@NM00013 EQU   SWACTLS+1
         ORG   SWACTLS+2
FNCTMAP  DS    CL4
NAMES    DS    CL16
         ORG   NAMES
JOBNM    DS    CL8
STPNM    DS    CL8
         ORG   NAMES+16
OVRDNGID DS    CL8
RBBLDSWS DS    BL1
         ORG   RBBLDSWS
OUT      DS    BL1
@NM00002 EQU   RBBLDSWS+0
         ORG   RBBLDSWS+1
DSRELSWS DS    BL1
         ORG   DSRELSWS
ENDGROUP DS    BL1
DSAB2BUN EQU   DSRELSWS+0
INLIST   EQU   DSRELSWS+0
@NM00003 EQU   DSRELSWS+0
         ORG   DSRELSWS+1
DSNAME   DS    CL44
WRPUPSWS DS    CL1
         ORG   WRPUPSWS
RSNCDSET DS    BL1
SCTUPDT  EQU   WRPUPSWS+0
JCTUPDT  EQU   WRPUPSWS+0
DEQCALL1 EQU   WRPUPSWS+0
@NM00004 EQU   WRPUPSWS+0
         ORG   WRPUPSWS+1
         DS    CL3
DUMYWEPA DS    CL16
         ORG   DUMYWEPA
@NM00005 DS    CL12
FSTWEPAP DS    AL4
         ORG   DUMYWEPA+16
DUMYDEPA DS    CL16
         ORG   DUMYDEPA
@NM00006 DS    CL12
FSTDEPAP DS    AL4
         ORG   DUMYDEPA+16
SIODCHSW DS    BL1
         ORG   SIODCHSW
SIOTFND  DS    BL1
@NM00007 EQU   SIODCHSW+0
         ORG   SIODCHSW+1
WRTEPASW DS    BL1
         ORG   WRTEPASW
ONCHAIN  DS    BL1
@NM00008 EQU   WRTEPASW+0
         ORG   WRTEPASW+1
ANAMDQSW DS    BL1
         ORG   ANAMDQSW
DODEQSW  DS    BL1
@NM00009 EQU   ANAMDQSW+0
         ORG   ANAMDQSW+1
         DS    CL1
DEQDSNPM DS    CL46
         ORG   DEQDSNPM
DEQDSNLN DS    FL2
DEQDSNAM DS    CL44
         ORG   DEQDSNPM+46
DSRRFMAP DS    CL2
         ORG   DSRRFMAP
ADDRPASS DS    BL1
ADCHONLY EQU   DSRRFMAP+0
ADCHENQ  EQU   DSRRFMAP+0
DELEONLY EQU   DSRRFMAP+0
DELEDEQ  EQU   DSRRFMAP+0
NOSHRXCL EQU   DSRRFMAP+0
ENQSHR   EQU   DSRRFMAP+0
ENQEXCL  EQU   DSRRFMAP+0
ENQWAIT  DS    BL1
RETADDR  EQU   DSRRFMAP+1
RETINDIC EQU   DSRRFMAP+1
READALL  EQU   DSRRFMAP+1
INCORREC EQU   DSRRFMAP+1
EPAJCTEX EQU   DSRRFMAP+1
SRCHDSNM EQU   DSRRFMAP+1
NEPAPROC EQU   DSRRFMAP+1
         ORG   DSRRFMAP+2
RSNCDARY DS    4H
IEFDB4A1 CSECT
         DS    0F
@SIZDATD DC    AL1(230)
         DC    AL3(@ENDDATD-@DATD)
@CV00124 DC    V(IEFAB4A0)
@CV00125 DC    V(IEFAB4F7)
@CV00126 DC    V(IEFAB4DC)
@CV00127 DC    V(IEFDB4F9)
         DS    0D
KEYZERO  DC    F'0'
@CB02829 DC    X'02'
MAJORNME DC    CL8'SYSZOPEN'
CATLERRC DC    AL1(1)
         DC    AL1(2)
         DC    AL1(0)
         DC    AL1(3)
         DC    AL1(4)
         DC    AL1(6)
         DC    AL1(9)
         DC    10AL1(0)
         DC    XL1'0A'
IEFDB4A1 CSECT
         DS   0H
PATCHLOC DC ((@DATA-@PSTART)/20)X'00'
@DATD    DSECT
ENQBEGIN DS 0F                                              @ZA04136
ENQCORE ENQ (MAJORNME,,,,STEP),RET=TEST,MF=L                @ZA04136
IEFDB4A1 CSECT
ENQLIST DS 0F                                               @ZA04136
 ENQ (MAJORNME,,,44,STEP),RET=TEST,MF=L  TEST ENQ LIST FORM @ZA04136
ENQLEN DC    A(*-ENQLIST)                                   @ZA04136
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEFDB4A1 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
GDGLEN   EQU   @04
GDGNMPTR EQU   @02
WRKSIOTP EQU   @05
SIOTSAVP EQU   @04
PRESIOTP EQU   @02
SVAJFCBX EQU   @05
JFCBXPTR EQU   @02
LSTDEPAP EQU   @06
LASTEPAP EQU   @04
INDEXLST EQU   @06
WRKINDEX EQU   @05
DSABPTR  EQU   @04
WRKDSABP EQU   @02
SWEPAPTR EQU   @02
SMFAINDX EQU   @09
OPTFLDLN EQU   @08
COUNT    EQU   @07
CMRBPTR  EQU   @03
R0       EQU   @00
R1       EQU   @01
R15      EQU   @15
CVTPTR   EQU   16
DSABPLST EQU   0
SMFARRAY EQU   0
SMFTIOTP EQU   SMFARRAY
SMFFLAGS EQU   SMFARRAY+4
SMFLAST  EQU   SMFFLAGS
UNALKEYT EQU   0
OVDSPTUP EQU   UNALKEYT+12
OVSNHTUP EQU   UNALKEYT+24
OVCLSTUP EQU   UNALKEYT+28
OVSUSTUP EQU   UNALKEYT+32
OVSHQTUP EQU   UNALKEYT+36
GDGCHAR  EQU   0
TXTUPLST EQU   0
TXTUNITP EQU   TXTUPLST
TXTUPELM EQU   0
TXTPLENT EQU   TXTUPELM
TEXTUNIT EQU   0
TEXTUENT EQU   TEXTUNIT+4
TEXTULNG EQU   TEXTUENT
TEXTUPAR EQU   TEXTUENT+2
TEXTUFLD EQU   0
CMUNFMAP EQU   0
CMFMBYT1 EQU   CMUNFMAP
CMDMSGS  EQU   CMFMBYT1
CMMNSTAT EQU   CMFMBYT1
CMDISPRC EQU   CMFMBYT1
CMDSRLSE EQU   CMFMBYT1
CMUNUNIT EQU   CMFMBYT1
CMVLRLSE EQU   CMFMBYT1
CMFDSABS EQU   CMFMBYT1
CMFMBYT2 EQU   CMUNFMAP+1
CMRDDENT EQU   CMFMBYT2
CMTIOTNQ EQU   CMFMBYT2
CMFMBYT3 EQU   CMUNFMAP+2
CMJES3   EQU   CMFMBYT3
CMFMBYT4 EQU   CMUNFMAP+3
CMUNRB   EQU   0
CMNRBPTR EQU   CMUNRB
CMSIOPTR EQU   CMUNRB+4
CMINDIC  EQU   CMUNRB+8
CMRBBYT1 EQU   CMINDIC
CMNODISP EQU   CMRBBYT1
CMNMDISP EQU   CMRBBYT1
CMORDISP EQU   CMRBBYT1
CMOUSRID EQU   CMRBBYT1
CMRBBYT2 EQU   CMINDIC+1
CMNODSR  EQU   CMRBBYT2
CMCHKUN  EQU   CMRBBYT2
CMCKAVOL EQU   CMRBBYT2
CMCKDAVL EQU   CMRBBYT2
CMRBBYT3 EQU   CMINDIC+2
CMDEL    EQU   CMRBBYT3
CMHOLD   EQU   CMRBBYT3
CMDYNUNA EQU   CMRBBYT3
CMOVSYOT EQU   CMRBBYT3
CMNOHOLD EQU   CMRBBYT3
CMRBBYT4 EQU   CMINDIC+3
CMSCRERR EQU   CMRBBYT4
CMCATERR EQU   CMRBBYT4
CMINTERR EQU   CMRBBYT4
CMNODEN  EQU   CMRBBYT4
CMODISP  EQU   CMUNRB+12
CMOKEEP  EQU   CMODISP
CMODEL   EQU   CMODISP
CMOCATLG EQU   CMODISP
CMOUNCAT EQU   CMODISP
CMOSYOUT EQU   CMUNRB+13
CMRETCDE EQU   CMUNRB+14
CMOPTFLD EQU   CMUNRB+16
SWAEPA   EQU   0
SWBLKPTR EQU   SWAEPA
SWVAFW   EQU   SWAEPA+4
SWVA     EQU   SWVAFW
SWBLKID  EQU   SWVAFW+3
SWLNGTH  EQU   SWAEPA+8
SWCHNPTR EQU   SWAEPA+12
QDB      EQU   0
DSAB     EQU   0
DSABFCHN EQU   DSAB+4
DSABTIOT EQU   DSAB+16
DSABGIDP EQU   DSAB+24
DSABANMP EQU   DSAB+28
DSABORG  EQU   DSAB+32
DSABORG1 EQU   DSABORG
DSABORG2 EQU   DSABORG+1
DSABFLG1 EQU   DSAB+34
DSABFLG2 EQU   DSAB+35
DSABFLG3 EQU   DSAB+36
DSABFLG4 EQU   DSAB+37
DSABSIOT EQU   DSAB+64
DSABANMI EQU   0
DSABANML EQU   DSABANMI
DSABANAM EQU   DSABANMI+1
DSABGIDL EQU   0
INDMSIOT EQU   0
SIOTDSKA EQU   INDMSIOT
SIOTTYPE EQU   INDMSIOT+3
SCTDDNAM EQU   INDMSIOT+4
SCTUSADD EQU   INDMSIOT+20
SCTPSIOT EQU   INDMSIOT+28
SCTPJFCB EQU   INDMSIOT+32
SIOTBYT1 EQU   INDMSIOT+43
SIOTOCKP EQU   SIOTBYT1
SIOTHOLD EQU   SIOTBYT1
SIOVAMDS EQU   SIOTBYT1
SIODUNAL EQU   SIOTBYT1
SIOTDDNT EQU   SIOTBYT1
SIOTBYT3 EQU   INDMSIOT+46
SIOALIAS EQU   SIOTBYT3
SIOTTSTC EQU   INDMSIOT+47
SIOTSSGP EQU   SIOTTSTC
SIOTQNAM EQU   SIOTTSTC
SIOTBYT0 EQU   INDMSIOT+52
SIOTSSDS EQU   SIOTBYT0
SIOTDYAL EQU   SIOTBYT0
SCTSDISP EQU   INDMSIOT+55
SIOTPASS EQU   SCTSDISP
SIOTKEEP EQU   SCTSDISP
SIOTDLET EQU   SCTSDISP
SIOTCTLG EQU   SCTSDISP
SIOTUNCT EQU   SCTSDISP
SCTSBYT1 EQU   INDMSIOT+56
SCTDUMMY EQU   SCTSBYT1
SIOTGDSN EQU   SCTSBYT1
SCTSBYT2 EQU   INDMSIOT+57
SCTSBYT3 EQU   INDMSIOT+58
SCTALCHK EQU   SCTSBYT3
SCTSYSOU EQU   SCTSBYT3
SCTSNEW  EQU   SCTSBYT3
SCTSOLD  EQU   SCTSBYT3
SCTSBYT4 EQU   INDMSIOT+59
SCTSGDGS EQU   SCTSBYT4
SIOTSTEP EQU   SCTSBYT4
SCTUTYPE EQU   INDMSIOT+60
SIOTDEVT EQU   SCTUTYPE
SIOUBYT3 EQU   SIOTDEVT+2
SIOTBYT4 EQU   INDMSIOT+81
SIOTALTD EQU   INDMSIOT+92
SIOTSSWA EQU   INDMSIOT+93
SIOTBYT2 EQU   INDMSIOT+103
SIOTGALL EQU   SIOTBYT2
SIOTCNEW EQU   SIOTBYT2
SIOTNPTR EQU   INDMSIOT+152
SJFCBPTR EQU   INDMSIOT+156
SIOTJFX  EQU   INDMSIOT+160
INFMJFCB EQU   0
JFCBDSNM EQU   INFMJFCB
JFCBELNM EQU   INFMJFCB+44
JFCBTSDM EQU   INFMJFCB+52
JFCCAT   EQU   JFCBTSDM
JFCFCBID EQU   INFMJFCB+56
JFCBFRID EQU   JFCFCBID
JFCBLTYP EQU   INFMJFCB+66
JFCBOTTR EQU   INFMJFCB+67
JFCBUFOF EQU   JFCBOTTR
JFCBFLSQ EQU   JFCBOTTR+1
JFCFUNC  EQU   JFCBFLSQ
JFCBMASK EQU   INFMJFCB+72
JFCBFLG1 EQU   JFCBMASK+5
JFCOPEN  EQU   JFCBFLG1
JFCBFLG2 EQU   JFCBMASK+6
JFCDEFER EQU   JFCBFLG2
JFCBIND1 EQU   INFMJFCB+86
JFCBIND2 EQU   INFMJFCB+87
JFCAMPTR EQU   INFMJFCB+88
JFCBUFRQ EQU   JFCAMPTR
JFCBUFNO EQU   JFCBUFRQ
JFCBGNCP EQU   JFCAMPTR+1
JFCBHIAR EQU   JFCBGNCP
JFCBFALN EQU   JFCBHIAR
JFCBFTEK EQU   JFCBFALN
JFCBBFTA EQU   JFCBFTEK
JFCEROPT EQU   INFMJFCB+92
JFCTRTCH EQU   INFMJFCB+93
JFCBX    EQU   0
JFCBXTTR EQU   JFCBX
JFCBXNAM EQU   JFCBX+96
JFCBXNXT EQU   JFCBX+172
SSWA     EQU   0
SSWAHDR  EQU   SSWA
SSWAPREN EQU   SSWA+8
SSWAIFLD EQU   0
IEZJSCB  EQU   0
JSCBSEC1 EQU   IEZJSCB+188
JSCHPCE  EQU   JSCBSEC1+4
JSCBTCBP EQU   JSCBSEC1+20
JSCBDCB  EQU   JSCBSEC1+36
JSCBOPTS EQU   JSCBSEC1+48
JSCSIOTS EQU   JSCBOPTS
JSCBSWT1 EQU   JSCBSEC1+55
JSCBWTP  EQU   JSCBSEC1+64
JSCBWTFG EQU   JSCBWTP
JSCBEND1 EQU   IEZJSCB+260
INJMJCT  EQU   0
JCTDSKAD EQU   INJMJCT
JCTIDENT EQU   INJMJCT+3
JCTJSTAT EQU   INJMJCT+5
INDMCTLG EQU   JCTJSTAT
JCTJBYTE EQU   INJMJCT+7
JCTJMGLV EQU   JCTJBYTE
INCMALL  EQU   JCTJMGLV
JCTJNAME EQU   INJMJCT+8
JCTCCODE EQU   INJMJCT+54
JCTRSW1  EQU   INJMJCT+86
JCTCKFT  EQU   JCTRSW1
JCTRSW2  EQU   INJMJCT+87
JCTNARST EQU   JCTRSW2
JCTNORST EQU   JCTRSW2
JCTRESTT EQU   JCTRSW2
JCTDETDA EQU   INJMJCT+88
JCTJSB   EQU   INJMJCT+111
JCTSTAT2 EQU   INJMJCT+116
JCTVULDP EQU   INJMJCT+172
IEFAACTB EQU   0
INSMSCT  EQU   0
SCTDISKA EQU   INSMSCT
SCTTBLID EQU   INSMSCT+3
SCTSSTAT EQU   INSMSCT+4
SCTFSIOT EQU   INSMSCT+12
SCTLSIOT EQU   INSMSCT+24
SCTSNAME EQU   INSMSCT+52
SCTSNUMB EQU   INSMSCT+64
SCTSTYPE EQU   INSMSCT+67
SCTSDPTY EQU   INSMSCT+94
SCTSTAT2 EQU   INSMSCT+104
SCTBCT   EQU   SCTSTAT2
SCTCDENT EQU   INSMSCT+118
SCTSTEND EQU   INSMSCT+172
@NM00099 EQU   0
SCTABCND EQU   @NM00099
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBJPQ   EQU   TCB+44
TCBPURGE EQU   TCBJPQ
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTME   EQU   TCB+120
TCBJSTCB EQU   TCB+124
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBFOE   EQU   TCB+244
TCBESTAE EQU   TCB+264
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCB+276
TCBFBYT2 EQU   TCB+277
TCBRV124 EQU   TCB+278
TCBRV133 EQU   TCB+279
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
TIOT1    EQU   0
TIOENTRY EQU   0
TIOESTTA EQU   TIOENTRY+1
TIOERLOC EQU   TIOENTRY+2
TIOELINK EQU   TIOERLOC+1
TIOESYOT EQU   TIOELINK
TIOESTTC EQU   TIOENTRY+15
TIOESTTB EQU   TIOENTRY+16
POOLSTAR EQU   TIOENTRY+20
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTMSER  EQU   CVTMAP+148
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
BASE     EQU   0
@NM00110 EQU   BASE+13
BALGSTAT EQU   BASE+24
BALOG    EQU   BALGSTAT+4
BASFL    EQU   BASE+36
BARSW    EQU   BASFL
MSLOGST  EQU   BASE+46
BASPBYTE EQU   BASE+47
BAMONITR EQU   BASE+56
BASTCNT  EQU   BASE+88
@NM00132 EQU   BASE+104
MSLGCLOZ EQU   BASE+108
MSCLOSSW EQU   MSLGCLOZ
MSLGWLOG EQU   BASE+112
MSWLOGSW EQU   MSLGWLOG
MSLGWTR  EQU   BASE+116
MSWTRSW  EQU   MSLGWTR
MSLGSTRT EQU   BASE+120
MSSTRTSW EQU   MSLGSTRT
MS1BASEX EQU   BASE+136
BASES01  EQU   0
MSNTAL   EQU   BASES01
MSSSB    EQU   BASES01+1
MSBTN    EQU   MSSSB
MSPFG    EQU   BASES01+2
MSECBFL  EQU   BASES01+3
MSTUS    EQU   BASES01+4
MSSSA    EQU   MSTUS
MSINLSW  EQU   MSSSA
MSREOF   EQU   MSSSA
MSNWP    EQU   MSSSA
MSFHF    EQU   BASES01+5
INDMDSNT EQU   0
DSABPLP  EQU   0
DSABPCNT EQU   0
RSNCODE  EQU   0
ERRCODE  EQU   RSNCODE
INFOCODE EQU   RSNCODE+2
EPALAST  EQU   0
CTLBLKPS EQU   0
JSCBPTR  EQU   CTLBLKPS
TCBPTR   EQU   CTLBLKPS+8
JCTPTR   EQU   CTLBLKPS+12
SCTPTR   EQU   CTLBLKPS+16
KEYTABP  EQU   0
DEPARMS  EQU   0
DENQRETN EQU   DEPARMS+232
DEDMYEPA EQU   DEPARMS+240
DEDMYAS  EQU   DEPARMS+260
SMFPARMS EQU   0
CMNUNARY EQU   RSNCDARY
CMUIDPTR EQU   CMOPTFLD
DSABQDB  EQU   QDB
DSQFRSTP EQU   DSABQDB+12
DSQLASTP EQU   DSABQDB+16
JFCKEYLE EQU   JFCTRTCH
JFCCODE  EQU   JFCKEYLE
JFCSTACK EQU   JFCTRTCH
JFCMODE  EQU   JFCSTACK
JFCSPPRT EQU   JFCTRTCH
JFCBABFS EQU   JFCSPPRT+2
JFCLIMCT EQU   JFCBABFS
JFCDSORG EQU   JFCSPPRT+5
JFCDSRG1 EQU   JFCDSORG
JFCDSRG2 EQU   JFCDSORG+1
JFCORGAM EQU   JFCDSRG2
JFCRECFM EQU   JFCSPPRT+7
JFCRCFM  EQU   JFCRECFM
JFCOPTCD EQU   JFCSPPRT+8
JFCWVCSP EQU   JFCOPTCD
JFCWVCIS EQU   JFCWVCSP
JFCWVCBD EQU   JFCWVCIS
JFCALLOW EQU   JFCOPTCD
JFCRSV17 EQU   JFCALLOW
JFCOVER  EQU   JFCRSV17
JFCPCIBT EQU   JFCOPTCD
JFCMAST  EQU   JFCPCIBT
JFCEXT   EQU   JFCMAST
JFCBCKPT EQU   JFCOPTCD
JFCIND   EQU   JFCBCKPT
JFCRSV18 EQU   JFCOPTCD
JFCCYL   EQU   JFCRSV18
JFCACT   EQU   JFCCYL
JFCREDUC EQU   JFCOPTCD
JFCRSV19 EQU   JFCREDUC
JFCRSV20 EQU   JFCRSV19
JFCRSV21 EQU   JFCOPTCD
JFCDEL   EQU   JFCRSV21
JFCOPTJ  EQU   JFCOPTCD
JFCREORG EQU   JFCOPTJ
JFCBLKSI EQU   JFCSPPRT+9
JFCBUFSI EQU   JFCBLKSI
JFCAMSYN EQU   JFCSPPRT+11
JFCNCP   EQU   JFCAMSYN+2
JFCNTM   EQU   JFCAMSYN+3
JFCBFSEQ EQU   JFCNTM
JFCPCI   EQU   JFCBFSEQ
JFCRESRV EQU   JFCAMSYN+4
JFCUCSEG EQU   JFCRESRV
JFCUCSOP EQU   JFCUCSEG+4
JFCOUTLI EQU   JFCUCSEG+5
JFCTHRSH EQU   JFCOUTLI
JFCCPRI  EQU   JFCTHRSH
JFCBVOLS EQU   JFCUCSEG+10
JFCBS001 EQU   JFCBVOLS
JFCBEXAD EQU   JFCBS001+31
JFCBPQTY EQU   JFCBS001+34
JFCBCTRI EQU   JFCBS001+37
JFCBSQTY EQU   JFCBS001+38
JFCFLGS1 EQU   JFCBS001+41
JFCBSPNM EQU   JFCBS001+45
JFCBFLG3 EQU   JFCBSPNM
JSCBSEC2 EQU   JSCBEND1
JSCBSEC3 EQU   JSCBEND1
JSCBJCT  EQU   JSCBSEC3
JSCBJCTA EQU   JSCBJCT+1
JSCBASID EQU   JSCBSEC3+8
JSCBFBYT EQU   JSCBSEC3+10
JSCBJNL  EQU   JSCBSEC3+28
JSCBJJSB EQU   JSCBJNL
JSCBSUB  EQU   JSCBSEC3+40
JSCDSABQ EQU   JSCBSEC3+60
JSCSCT   EQU   JSCBSEC3+68
JSCDDNUM EQU   JSCBSEC3+84
JSCRSV45 EQU   JSCBSEC3+112
JSCRSV46 EQU   JSCRSV45
JSCRSV47 EQU   JSCRSV45+2
TIOEDEVE EQU   TIOESTTB
TIOSTTB  EQU   TIOEDEVE
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTHSM   EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
TIOUCBP  EQU   TIOEDEVE+1
TIOVERF  EQU   TIOSTTB
TIOUNLD  EQU   TIOSTTB
TIOMNTD  EQU   TIOSTTB
TIOSETU  EQU   TIOSTTB
TIOVLSR  EQU   TIOSTTB
TIOPVIO  EQU   TIOSTTB
TIOREQD  EQU   TIOSTTB
TIOUSED  EQU   TIOSTTB
JSCBEND3 EQU   JSCBSEC3+120
JSCRSV52 EQU   JSCBSEC3+116
JSCRSV51 EQU   JSCRSV47+1
JSCRSV50 EQU   JSCRSV47
JSCRSV49 EQU   JSCRSV46+1
JSCRSV48 EQU   JSCRSV46
JSCRSV44 EQU   JSCBSEC3+108
JSCRSV43 EQU   JSCBSEC3+104
JSCRSV42 EQU   JSCBSEC3+100
JSCBASWA EQU   JSCBSEC3+96
JSCBUFPT EQU   JSCBSEC3+92
JSCBACT  EQU   JSCBSEC3+88
JSCBSWSP EQU   JSCBSEC3+87
JSCRSV33 EQU   JSCBSEC3+86
JSCRSV53 EQU   JSCBSEC3+82
JSCDDNNO EQU   JSCBSEC3+80
JSCBVATA EQU   JSCBSEC3+76
JSCTMCOR EQU   JSCBSEC3+72
JSCSCTP  EQU   JSCSCT+1
JSCRSV55 EQU   JSCSCT
JSCRSV54 EQU   JSCBSEC3+64
JSCBSSIB EQU   JSCBSEC3+56
JSCBFRBA EQU   JSCBSEC3+48
JSCRSV28 EQU   JSCBSEC3+46
JSCBSONO EQU   JSCBSEC3+44
JSCBSUBA EQU   JSCBSUB+1
JSCRSV31 EQU   JSCBSUB
JSCBSMLR EQU   JSCBSEC3+36
JSCBJNLR EQU   JSCBSEC3+32
JSCBJNLA EQU   JSCBJNL+1
JSCBJSBT EQU   JSCBJJSB
JSCBJSBX EQU   JSCBJJSB
JSCBJSBA EQU   JSCBJJSB
JSCBJSBI EQU   JSCBJJSB
@NM00059 EQU   JSCBJJSB
JSCBJNLE EQU   JSCBJJSB
JSCBJNLF EQU   JSCBJJSB
JSCBJNLN EQU   JSCBJJSB
@NM00058 EQU   JSCBSEC3+24
JSCBJRBA EQU   JSCBSEC3+16
JSCBIECB EQU   JSCBSEC3+12
JSCBRV08 EQU   JSCBSEC3+11
JSCBRV07 EQU   JSCBFBYT
JSCBRV06 EQU   JSCBFBYT
JSCBRV05 EQU   JSCBFBYT
JSCBRV04 EQU   JSCBFBYT
JSCBRV03 EQU   JSCBFBYT
JSCBRV02 EQU   JSCBFBYT
JSCBADSP EQU   JSCBFBYT
JSCBRV01 EQU   JSCBFBYT
JSCBTJID EQU   JSCBASID
JSCBPSCB EQU   JSCBSEC3+4
JSCJCTP  EQU   JSCBJCTA
JSCRSV24 EQU   JSCBJCT
JSCBEND2 EQU   JSCBSEC2
JFCBEND  EQU   JFCBS001+58
JFCBSPTN EQU   JFCBS001+57
JFCBVLCT EQU   JFCBS001+56
JFCBDRLH EQU   JFCBS001+53
JFCBSBNM EQU   JFCBS001+50
JFCBABST EQU   JFCBS001+48
JFCBRV08 EQU   JFCBSPNM+1
JFCBRV07 EQU   JFCBFLG3
JFCBRV06 EQU   JFCBFLG3
JFCBRV05 EQU   JFCBFLG3
JFCBRV04 EQU   JFCBFLG3
JFCBRV03 EQU   JFCBFLG3
JFCBRV02 EQU   JFCBFLG3
JFCBEXP  EQU   JFCBFLG3
JFCDQDSP EQU   JFCBFLG3
JFCBDQTY EQU   JFCBS001+42
JFCBUAFF EQU   JFCFLGS1
JFCRSV45 EQU   JFCFLGS1
JFCVRDS  EQU   JFCFLGS1
JFCBCEOV EQU   JFCFLGS1
JFCRSV42 EQU   JFCFLGS1
JFCBADSP EQU   JFCFLGS1
JFCTOPEN EQU   JFCFLGS1
JFCBDLET EQU   JFCFLGS1
JFCRQID  EQU   JFCBSQTY
JFCROUND EQU   JFCBCTRI
JFCALX   EQU   JFCBCTRI
JFCMIXG  EQU   JFCBCTRI
JFCONTIG EQU   JFCBCTRI
JFCRSV29 EQU   JFCBCTRI
JFCBMSGP EQU   JFCBCTRI
JFCBSPAC EQU   JFCBCTRI
JFCRUNIT EQU   JFCBPQTY
JFCBEXTL EQU   JFCBS001+30
JFCMSVGP EQU   JFCBS001+22
@NM00052 EQU   JFCBS001
JFCAVOLS EQU   JFCBVOLS
JFCBNVOL EQU   JFCUCSEG+9
JFCBNTCS EQU   JFCUCSEG+8
JFCSOWA  EQU   JFCOUTLI+1
JFCSEND  EQU   JFCCPRI
JFCEQUAL EQU   JFCCPRI
JFCRECV  EQU   JFCCPRI
JFCRSV34 EQU   JFCCPRI
JFCRSV33 EQU   JFCCPRI
JFCRSV55 EQU   JFCCPRI
JFCRSV54 EQU   JFCCPRI
JFCRSV53 EQU   JFCCPRI
JFCRSV27 EQU   JFCUCSOP
JFCRSV26 EQU   JFCUCSOP
JFCFCBVR EQU   JFCUCSOP
JFCFCBAL EQU   JFCUCSOP
JFCVER   EQU   JFCUCSOP
JFCRSV25 EQU   JFCUCSOP
JFCFOLD  EQU   JFCUCSOP
JFCBEXTP EQU   JFCUCSOP
JFCUCSID EQU   JFCUCSEG
JFCINTVL EQU   JFCSPPRT+19
JFCDBUFN EQU   JFCRESRV+3
JFCCYLOF EQU   JFCRESRV+2
JFCRKP   EQU   JFCRESRV
JFCPCIR2 EQU   JFCPCI
JFCPCIR1 EQU   JFCPCI
JFCPCIN2 EQU   JFCPCI
JFCPCIN1 EQU   JFCPCI
JFCPCIA2 EQU   JFCPCI
JFCPCIA1 EQU   JFCPCI
JFCPCIX2 EQU   JFCPCI
JFCPCIX1 EQU   JFCPCI
JFCBUFMX EQU   JFCNCP
JFCLRECL EQU   JFCAMSYN
JFCBAXBF EQU   JFCBUFSI
JFCREL   EQU   JFCREORG
JFCRSV22 EQU   JFCDEL
JFCSRCHD EQU   JFCRSV20
JFCOPTQ  EQU   JFCACT
JFCFEED  EQU   JFCIND
JFCCBWU  EQU   JFCEXT
JFCWUMSG EQU   JFCOVER
JFCSDNAM EQU   JFCWVCBD
@NM00051 EQU   JFCRECFM
JFCCHAR  EQU   JFCRECFM
JFCRFS   EQU   JFCRECFM
JFCRFB   EQU   JFCRECFM
JFCRFO   EQU   JFCRCFM
JFCFMREC EQU   JFCRCFM
JFCRSV16 EQU   JFCDSRG2
JFCRSV15 EQU   JFCDSRG2
JFCORGTR EQU   JFCDSRG2
JFCRSV13 EQU   JFCDSRG2
JFCORGTQ EQU   JFCDSRG2
JFCORGTX EQU   JFCDSRG2
JFCORGGS EQU   JFCDSRG2
JFCORGU  EQU   JFCDSRG1
JFCORGPO EQU   JFCDSRG1
JFCORGMQ EQU   JFCDSRG1
JFCORGCQ EQU   JFCDSRG1
JFCORGCX EQU   JFCDSRG1
JFCORGDA EQU   JFCDSRG1
JFCORGPS EQU   JFCDSRG1
JFCORGIS EQU   JFCDSRG1
JFCTRKBL EQU   JFCLIMCT+1
@NM00050 EQU   JFCLIMCT
JFCDEN   EQU   JFCSPPRT+1
JFCPRTSP EQU   JFCSPPRT
JFCONE   EQU   JFCMODE
JFCTWO   EQU   JFCMODE
JFCRSV07 EQU   JFCMODE
JFCRSV06 EQU   JFCMODE
JFCMODER EQU   JFCMODE
JFCMODEO EQU   JFCMODE
JFCEBCD  EQU   JFCMODE
JFCBIN   EQU   JFCMODE
JFCRSV32 EQU   JFCCODE
JFCTTY   EQU   JFCCODE
JFCASCII EQU   JFCCODE
JFCNCR   EQU   JFCCODE
JFCBUR   EQU   JFCCODE
JFCFRI   EQU   JFCCODE
JFCBCD   EQU   JFCCODE
JFCNOCON EQU   JFCCODE
@NM00030 EQU   DSABQDB+24
DSQBDSP  EQU   DSABQDB+22
DSQFDSP  EQU   DSABQDB+20
DSQBADFC EQU   DSQLASTP
DSQBADBC EQU   DSQFRSTP
DSQNELMS EQU   DSABQDB+8
DSQDBLN  EQU   DSABQDB+6
DSQATTRS EQU   DSABQDB+4
DSQDBID  EQU   DSABQDB
SMFBUFLP EQU   SMFPARMS+4
SMFBUF1P EQU   SMFPARMS
@NM00012 EQU   DEPARMS+304
DETCTIOL EQU   DEPARMS+300
DETCTIOP EQU   DEPARMS+296
DETDQLST EQU   DEPARMS+280
DEALASTP EQU   DEPARMS+276
DEASGNP  EQU   DEDMYAS+12
@NM00011 EQU   DEDMYAS
DEWLASTP EQU   DEPARMS+256
DEWRITP  EQU   DEDMYEPA+12
@NM00010 EQU   DEDMYEPA
DEDSNQRC EQU   DENQRETN+4
DEDSNQEN EQU   DENQRETN
DECPYLEN EQU   DEPARMS+228
DECPYLOC EQU   DEPARMS+224
DEJSCB   EQU   DEPARMS+220
DESCT    EQU   DEPARMS+216
DEJCT    EQU   DEPARMS+212
DESIOT   EQU   DEPARMS+208
DETCB    EQU   DEPARMS+204
DEALFMAP EQU   DEPARMS+200
DECORE   EQU   DEPARMS
ASCBPTR  EQU   CTLBLKPS+4
MSSPARE  EQU   BASES01+48
MSUCBAL  EQU   BASES01+44
MSUCBPR  EQU   BASES01+40
MSBOBECB EQU   BASES01+36
MSSJQ    EQU   BASES01+32
MSECB    EQU   BASES01+28
MSPBP    EQU   BASES01+24
MSERM    EQU   BASES01+22
MSPASS   EQU   BASES01+14
MSVRB    EQU   BASES01+6
MSQHR    EQU   MSFHF
@NM00148 EQU   MSFHF
MSPSDT   EQU   MSFHF
MSREPLYB EQU   MSFHF
MSFAX    EQU   MSFHF
MSTTT    EQU   MSFHF
MSCSD    EQU   MSFHF
MSNMF    EQU   MSFHF
MSJNF    EQU   MSSSA
MSYOUT   EQU   MSNWP
MSNRP    EQU   MSSSA
MSSRDR   EQU   MSREOF
MSWRLOG  EQU   MSSSA
MSNUPSW  EQU   MSSSA
MSWRPEN  EQU   MSSSA
MSSSSIPL EQU   MSINLSW
MSSUM    EQU   MSECBFL
MSMCR    EQU   MSECBFL
MSYSOUT  EQU   MSECBFL
MSYSIN   EQU   MSECBFL
MSATTN   EQU   MSECBFL
MSWTL    EQU   MSECBFL
MSWTO    EQU   MSECBFL
MSEXT    EQU   MSECBFL
MSCCS    EQU   MSPFG
MSBSP    EQU   MSPFG
MSSYT    EQU   MSPFG
MSSYN    EQU   MSPFG
MSICR    EQU   MSPFG
MSCMC    EQU   MSPFG
MSPNB    EQU   MSPFG
MSDATE   EQU   MSPFG
@NM00147 EQU   MSBTN
MSTN     EQU   MSBTN
@NM00146 EQU   MSBTN
@NM00145 EQU   MSBTN
MSSO     EQU   MSBTN
MSROLFLG EQU   MSBTN
MSCANFLG EQU   MSBTN
MSCONFLG EQU   MSBTN
MSPNIP   EQU   MSNTAL
MSQNIP   EQU   MSNTAL
MSCURE34 EQU   MSNTAL
@NM00144 EQU   MSNTAL
@NM00143 EQU   MSNTAL
@NM00142 EQU   MSNTAL
@NM00141 EQU   MSNTAL
MSNIP    EQU   MSNTAL
@NM00140 EQU   MS1BASEX+40
@NM00139 EQU   MS1BASEX+20
@NM00138 EQU   MS1BASEX
@NM00137 EQU   BASE+128
MSLGJSCB EQU   BASE+124
@NM00136 EQU   MSSTRTSW
MSSTRTP  EQU   MSSTRTSW
MSSTRTW  EQU   MSSTRTSW
@NM00135 EQU   MSWTRSW
MSWTRP   EQU   MSWTRSW
MSWTRW   EQU   MSWTRSW
@NM00134 EQU   MSWLOGSW
MSWLOGP  EQU   MSWLOGSW
MSWLOGW  EQU   MSWLOGSW
@NM00133 EQU   MSCLOSSW
MSCLOSP  EQU   MSCLOSSW
MSCLOSW  EQU   MSCLOSSW
MSLOGLMT EQU   @NM00132+1
MSLOGCLS EQU   @NM00132
BAASCB   EQU   BASE+100
MSSMFPRM EQU   BASE+96
MSCOMMND EQU   BASE+92
BASP12   EQU   BASE+90
BASESCT  EQU   BASE+86
BAJNCNT  EQU   BASE+84
BASUBECB EQU   BASE+80
BALOGCOM EQU   BASE+76
BADACNT  EQU   BASE+74
BATACNT  EQU   BASE+72
BAJBNR   EQU   BASE+64
BASP11   EQU   BASE+62
BALCCNT  EQU   BASE+61
BADUMPID EQU   BASE+60
BABCMAX  EQU   BASE+58
BAMONTR2 EQU   BASE+57
@NM00131 EQU   BAMONITR
BAMACTVE EQU   BAMONITR
@NM00130 EQU   BAMONITR
@NM00129 EQU   BAMONITR
@NM00128 EQU   BAMONITR
@NM00127 EQU   BAMONITR
BASPACE  EQU   BAMONITR
BADSN    EQU   BAMONITR
BADSO    EQU   BASE+52
BALOGECB EQU   BASE+48
@NM00126 EQU   BASPBYTE
@NM00125 EQU   BASPBYTE
@NM00124 EQU   BASPBYTE
@NM00123 EQU   BASPBYTE
@NM00122 EQU   BASPBYTE
BAMASCH  EQU   BASPBYTE
BATRACE  EQU   BASPBYTE
BAMSSTAR EQU   BASPBYTE
@NM00121 EQU   MSLOGST
@NM00120 EQU   MSLOGST
MSLOGSTA EQU   MSLOGST
MSLOGIPL EQU   MSLOGST
MSLOGDAR EQU   MSLOGST
MSLOGCOM EQU   MSLOGST
MSLOGTHD EQU   MSLOGST
MSLOGENQ EQU   MSLOGST
BAMIPAR2 EQU   BASE+44
BAMINPAR EQU   BASE+42
BAPKES   EQU   BASE+40
BAICTR   EQU   BASE+38
@NM00119 EQU   BASE+37
BADSET   EQU   BARSW
BANOSET  EQU   BARSW
BAMIDNT  EQU   BARSW
BAHR     EQU   BARSW
BAVU     EQU   BARSW
BAINTSET EQU   BARSW
MSTODWTO EQU   BARSW
BAIN     EQU   BARSW
BACV     EQU   BASE+32
@NM00118 EQU   BALOG
@NM00117 EQU   BALOG
@NM00116 EQU   BALOG
@NM00115 EQU   BALOG
@NM00114 EQU   BALOG
@NM00113 EQU   BALOG
@NM00112 EQU   BALOG
BALOGINT EQU   BALOG
MSLOGSVC EQU   BALGSTAT
BAPRC    EQU   BASE+20
BAQ      EQU   BASE+16
BAIPLCC  EQU   @NM00110+2
@NM00111 EQU   @NM00110
BAIPL    EQU   BASE+12
BALAD    EQU   BASE+8
BATRM    EQU   BASE+4
BACHN    EQU   BASE
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00109 EQU   CVTFIX+248
@NM00108 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTCCVT  EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
TIOTFEND EQU   POOLSTAR+16
TIOPSLOT EQU   POOLSTAR+13
TIOPSTTB EQU   POOLSTAR+12
TIOPPOOL EQU   POOLSTAR+4
TIOPNSRT EQU   POOLSTAR+3
@NM00107 EQU   POOLSTAR+2
TIOPNSLT EQU   POOLSTAR+1
@NM00106 EQU   POOLSTAR
TIOEFSRT EQU   TIOENTRY+17
TIOSVERF EQU   TIOESTTB
TIOSUNLD EQU   TIOESTTB
TIOSMNTD EQU   TIOESTTB
TIOSSETU EQU   TIOESTTB
TIOSVLSR EQU   TIOESTTB
TIOSPVIO EQU   TIOESTTB
TIOSREQD EQU   TIOESTTB
TIOSUSED EQU   TIOESTTB
TIOSBALS EQU   TIOESTTC
TIOSBALP EQU   TIOESTTC
TIOSVOLS EQU   TIOESTTC
TIOSVOLP EQU   TIOESTTC
TIOSAFFS EQU   TIOESTTC
TIOSAFFP EQU   TIOESTTC
TIOSDEFR EQU   TIOESTTC
TIOSDKCR EQU   TIOESTTC
TIOEJFCB EQU   TIOENTRY+12
TIOEDDNM EQU   TIOENTRY+4
TIOTREM  EQU   TIOELINK
TIOESSDS EQU   TIOESYOT
TIOESYIN EQU   TIOELINK
TIOEQNAM EQU   TIOELINK
TIOEDYNM EQU   TIOELINK
TIOTTERM EQU   TIOELINK
TIOTRV01 EQU   TIOELINK
TIOSYOUT EQU   TIOELINK
TIOEWTCT EQU   TIOERLOC
TIOSDSP2 EQU   TIOESTTA
TIOSDSP1 EQU   TIOESTTA
TIOSLABL EQU   TIOESTTA
TIOSDADS EQU   TIOESTTA
TIOSJBLB EQU   TIOESTTA
TIOSPLTS EQU   TIOESTTA
TIOSPLTP EQU   TIOESTTA
TIOSLTYP EQU   TIOESTTA
TIOELNGH EQU   TIOENTRY
TIOCSTEP EQU   TIOT1+8
TIOCNJOB EQU   TIOT1
@NM00105 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBCAUF  EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00104 EQU   TCB+296
TCBSVCA2 EQU   TCB+292
TCBSWASA EQU   TCB+288
TCBDBTB  EQU   TCB+284
TCBRPT   EQU   TCB+280
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBACTIV EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCB+274
TCBCCPVI EQU   TCB+272
TCBUKYSP EQU   TCB+268
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBRV308 EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCB+260
TCBTCBID EQU   TCB+256
TCBRSV96 EQU   TCB+252
TCBSWA   EQU   TCB+248
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBRV306 EQU   TCB+240
TCBRSV41 EQU   TCB+239
TCBTID   EQU   TCB+238
TCBRSVAA EQU   TCB+237
TCBABCUR EQU   TCB+236
TCBTMSAV EQU   TCB+232
TCBIOTIM EQU   TCB+228
TCBRTWA  EQU   TCB+224
TCBBACK  EQU   TCB+220
TCBTIRB  EQU   TCB+216
TCBAECB  EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBSVCS  EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBGPECB EQU   TCBFLGS7
TCBNTJS  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBCPU   EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBRSV95 EQU   TCBNDSP5
TCBRSV94 EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00103 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBNDINT EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBLJSND EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBSTCUR EQU   TCBNSTAE
TCBRV301 EQU   TCBNSTAE
TCBSYNCH EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBNSTAE
TCB33E   EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBAQE   EQU   TCB+156
TCBPQE   EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBJSTCA EQU   TCBJSTCB+1
TCBRSV16 EQU   TCBJSTCB
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBFSA
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBJPQ+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBDWSTA EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBADINP EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBFLGS2
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBNONPR EQU   TCBFLGS1
TCBFERA  EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBTIO   EQU   TCB+12
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00102 EQU   TCBPMASK
TCBRBP   EQU   TCB
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
@NM00101 EQU   @NM00099+1
SCTONLY  EQU   SCTABCND
SCTEVEN  EQU   SCTABCND
SCTABEND EQU   SCTABCND
SCTONLYC EQU   SCTABCND
SCTABCAN EQU   SCTABCND
@NM00100 EQU   SCTABCND
@NM00098 EQU   INSMSCT+173
@NM00097 EQU   SCTSTEND
SCTSYSCK EQU   SCTSTEND
SCTSTPND EQU   SCTSTEND
SCTSTSRT EQU   SCTSTEND
@NM00096 EQU   INSMSCT+168
SCTCATCT EQU   INSMSCT+166
SCTSDPSA EQU   SCTCDENT+3
SCTSDPOP EQU   SCTCDENT+2
SCTSDPCD EQU   SCTCDENT
@NM00095 EQU   INSMSCT+117
SCTPRFMF EQU   INSMSCT+116
SCTPGMNM EQU   INSMSCT+108
SCTTIOT  EQU   INSMSCT+105
@NM00094 EQU   SCTBCT
SCTJBEND EQU   SCTBCT
SCTSPSYS EQU   SCTBCT
SCTSTPLB EQU   SCTBCT
@NM00093 EQU   SCTBCT
SCTMCVOL EQU   SCTBCT
@NM00092 EQU   SCTBCT
SCTGOTTR EQU   INSMSCT+100
SCTSMF   EQU   INSMSCT+96
@NM00091 EQU   SCTSDPTY+1
SCTSDP   EQU   SCTSDPTY
SCTFSTEP EQU   SCTSDPTY
@NM00090 EQU   SCTSDPTY
@NM00089 EQU   SCTSDPTY
SCTNIUSL EQU   INSMSCT+92
@NM00088 EQU   INSMSCT+90
SCTMSSZE EQU   INSMSCT+88
SCTPCAT  EQU   INSMSCT+84
SCTLDSTB EQU   INSMSCT+80
SCTSRBT  EQU   INSMSCT+76
SCTMSADR EQU   INSMSCT+72
@NM00087 EQU   INSMSCT+71
SCTXBTTR EQU   INSMSCT+68
SCTJSCAT EQU   SCTSTYPE
SCTINITB EQU   SCTSTYPE
SCTSJFHK EQU   SCTSTYPE
SCTOUTMC EQU   SCTSTYPE
SCTINPUT EQU   SCTSTYPE
SCTGOSTP EQU   SCTSTYPE
@NM00086 EQU   INSMSCT+66
SCTNSMSG EQU   INSMSCT+65
@NM00085 EQU   INSMSCT+62
SCTRPACT EQU   INSMSCT+60
SCTSCLPC EQU   INSMSCT+44
@NM00084 EQU   INSMSCT+43
SCTADSTB EQU   INSMSCT+40
@NM00083 EQU   INSMSCT+36
@NM00082 EQU   INSMSCT+35
SCTAFACT EQU   INSMSCT+32
SCTDDNT  EQU   INSMSCT+28
@NM00081 EQU   INSMSCT+27
@NM00080 EQU   INSMSCT+23
SCTANSCT EQU   INSMSCT+20
@NM00079 EQU   INSMSCT+19
SCTAALOC EQU   INSMSCT+16
@NM00078 EQU   INSMSCT+15
SCTLALOC EQU   INSMSCT+10
SCTSEXEC EQU   INSMSCT+8
SCTSTIME EQU   INSMSCT+5
INCMSSTS EQU   SCTSSTAT
SCTGRPH  EQU   SCTSSTAT
SCTKEY0  EQU   SCTSSTAT
SCTDORST EQU   SCTSSTAT
SCTNOCKP EQU   SCTSSTAT
SCTNORST EQU   SCTSSTAT
EACAUSER EQU   SCTSSTAT
EAADDRBT EQU   SCTSSTAT
ACTACCNT EQU   IEFAACTB+32
ACTJNFLD EQU   IEFAACTB+31
ACTJTIME EQU   IEFAACTB+28
ACTPRGNM EQU   IEFAACTB+8
@NM00077 EQU   IEFAACTB+7
ACTNEXT  EQU   IEFAACTB+4
ACTIDENT EQU   IEFAACTB+3
ACTDSKAD EQU   IEFAACTB
@NM00076 EQU   INJMJCT+175
JCTACODE EQU   INJMJCT+168
JCTPRFMF EQU   INJMJCT+167
JCTUSER  EQU   INJMJCT+160
JCTSSD   EQU   INJMJCT+157
@NM00075 EQU   INJMJCT+156
JCTSRBT  EQU   INJMJCT+152
JCTJMRJD EQU   INJMJCT+149
JCTJMRJT EQU   INJMJCT+146
JCTJMRSS EQU   INJMJCT+143
JCTJMRTL EQU   INJMJCT+140
JCTJMRCL EQU   INJMJCT+139
JCTJMROP EQU   INJMJCT+138
JCTJMRD  EQU   INJMJCT+137
JCTJMR   EQU   INJMJCT+134
JCTCKIDT EQU   INJMJCT+118
JCTCKIDL EQU   INJMJCT+117
@NM00074 EQU   JCTSTAT2
JCTBLP   EQU   JCTSTAT2
JCTPERFM EQU   JCTSTAT2
JCTSWSM  EQU   JCTSTAT2
JCTENDIT EQU   JCTSTAT2
JCTADSPC EQU   JCTSTAT2
JCTSPSYS EQU   JCTSTAT2
@NM00073 EQU   INJMJCT+115
JCTSSTR  EQU   INJMJCT+112
JCTJSBTM EQU   JCTJSB
JCTJSBEX EQU   JCTJSB
JCTJSBAL EQU   JCTJSB
JCTJSBIN EQU   JCTJSB
@NM00072 EQU   JCTJSB
JCTVOLSQ EQU   INJMJCT+110
JCTNRCKP EQU   INJMJCT+108
JCTNTRK  EQU   INJMJCT+107
JCTCKTTR EQU   INJMJCT+104
JCTDEVT  EQU   INJMJCT+100
@NM00071 EQU   INJMJCT+99
JCTSTIOT EQU   INJMJCT+96
JCTSNUMB EQU   INJMJCT+95
JCTQIDNT EQU   INJMJCT+94
JCTEQREG EQU   INJMJCT+92
@NM00070 EQU   INJMJCT+91
JCTDSDRA EQU   JCTRSW2
JCTDSOJB EQU   JCTRSW2
JCTDSOCR EQU   JCTRSW2
JCTNOCKP EQU   JCTRSW2
JCTSYSCK EQU   JCTRSW2
@NM00069 EQU   JCTRSW1
JCTSTEPR EQU   JCTRSW1
JCTCKPTR EQU   JCTRSW1
JCTCONTR EQU   JCTRSW1
JCTSTERM EQU   JCTRSW1
JCTWARMS EQU   JCTRSW1
@NM00068 EQU   JCTCCODE+3
JCTJDPOP EQU   JCTCCODE+2
JCTJDPCD EQU   JCTCCODE
@NM00067 EQU   INJMJCT+53
JCTSCT   EQU   INJMJCT+52
JCTSMRBA EQU   INJMJCT+44
@NM00066 EQU   INJMJCT+43
JCTACTAD EQU   INJMJCT+40
@NM00065 EQU   INJMJCT+39
JCTJCTX  EQU   INJMJCT+36
@NM00064 EQU   INJMJCT+35
JCTSDKAD EQU   INJMJCT+32
JCTJCSMF EQU   INJMJCT+31
JCTGDGNT EQU   INJMJCT+28
@NM00063 EQU   INJMJCT+27
JCTPDIP  EQU   INJMJCT+24
JCTJTPTN EQU   INJMJCT+16
JCTJPRTY EQU   JCTJBYTE
INCMMGL1 EQU   JCTJMGLV
INCMMGL2 EQU   JCTJMGLV
@NM00062 EQU   JCTJMGLV
JCTJMGPO EQU   INJMJCT+6
INCMNSET EQU   JCTJSTAT
INCMCAT  EQU   INDMCTLG
INCMSTS  EQU   JCTJSTAT
JCTABEND EQU   JCTJSTAT
@NM00061 EQU   JCTJSTAT
JCTJSTPC EQU   JCTJSTAT
@NM00060 EQU   JCTJSTAT
JCTJBLBS EQU   JCTJSTAT
JCTJSRNO EQU   INJMJCT+4
JSCBCSCB EQU   JSCBSEC1+68
JSCBPMG  EQU   JSCBWTP+2
JSCBWTSP EQU   JSCBWTP+1
JSCRSV23 EQU   JSCBWTFG
JSCRSV22 EQU   JSCBWTFG
JSCRSV21 EQU   JSCBWTFG
JSCRSV20 EQU   JSCBWTFG
JSCRSV19 EQU   JSCBWTFG
JSCRSV18 EQU   JSCBWTFG
JSCBRET  EQU   JSCBWTFG
JSCBIOFG EQU   JSCBWTFG
@NM00057 EQU   JSCBSEC1+60
JSCBQMPI EQU   JSCBSEC1+56
JSCBPMSG EQU   JSCBSWT1
JSCRSV16 EQU   JSCBSWT1
JSCRSV15 EQU   JSCBSWT1
JSCRSV14 EQU   JSCBSWT1
JSCRSV13 EQU   JSCBSWT1
JSCRSV12 EQU   JSCBSWT1
JSCRSV11 EQU   JSCBSWT1
JSCBPASS EQU   JSCBSWT1
JSCBTTTR EQU   JSCBSEC1+52
JSCRSV10 EQU   JSCBSEC1+49
JSCBAUTH EQU   JSCBOPTS
JSCRSV08 EQU   JSCBOPTS
JSCRSV07 EQU   JSCBOPTS
JSCRSV06 EQU   JSCBOPTS
JSCBLONG EQU   JSCBOPTS
JSCRSV05 EQU   JSCBOPTS
JSCRSV04 EQU   JSCBOPTS
JSCBSECB EQU   JSCBSEC1+44
JSCRSV03 EQU   JSCBSEC1+41
JSCBSTEP EQU   JSCBSEC1+40
JSCBDCBA EQU   JSCBDCB+1
JSCRSV02 EQU   JSCBDCB
JSCBID   EQU   JSCBSEC1+32
JSCBDBTB EQU   JSCBSEC1+28
JSCBIJSC EQU   JSCBSEC1+24
JSCBPCC  EQU   JSCBSEC1+16
JSCBTCP  EQU   JSCBSEC1+12
JSCBSHR  EQU   JSCBSEC1+8
JSCHPCEA EQU   JSCHPCE+1
JSCRSV32 EQU   JSCHPCE
JSCRSV01 EQU   JSCBSEC1
@NM00056 EQU   IEZJSCB
SSWAIPRM EQU   SSWAIFLD+1
SSWAILEN EQU   SSWAIFLD
SSWAPVAL EQU   SSWAPREN+1
SSWAPLEN EQU   SSWAPREN
SSWAPRNO EQU   SSWAHDR+6
SSWASSNM EQU   SSWAHDR+2
SSWATYPE EQU   SSWAHDR
@NM00055 EQU   JFCBX+144
JFCBXDEV EQU   JFCBX+140
@NM00054 EQU   JFCBX+94
JFCBXVOL EQU   JFCBX+4
@NM00053 EQU   JFCBX+3
JFCRSV05 EQU   JFCEROPT
JFCRSV04 EQU   JFCEROPT
JFCRSV03 EQU   JFCEROPT
JFCRSV02 EQU   JFCEROPT
JFCTOPT  EQU   JFCEROPT
JFCABN   EQU   JFCEROPT
JFCSKP   EQU   JFCEROPT
JFCACC   EQU   JFCEROPT
JFCBUFL  EQU   JFCAMPTR+2
JFCFWORD EQU   JFCBFTEK
JFCDWORD EQU   JFCBFTEK
JFCHIER1 EQU   JFCBFTEK
JFCDYN   EQU   JFCBFTEK
JFCEXC   EQU   JFCBFTEK
JFCBBFTR EQU   JFCBBFTA
JFCSIM   EQU   JFCBBFTA
JFCHIER  EQU   JFCBFTEK
JFCBFOUT EQU   JFCBUFNO
JFCBUFIN EQU   JFCBUFNO
JFCTEMP  EQU   JFCBIND2
JFCREQ   EQU   JFCBIND2
JFCENT   EQU   JFCBIND2
JFCSHARE EQU   JFCBIND2
JFCSECUR EQU   JFCBIND2
JFCDISP  EQU   JFCBIND2
JFCPDS   EQU   JFCBIND1
JFCGDG   EQU   JFCBIND1
JFCADDED EQU   JFCBIND1
JFCLOC   EQU   JFCBIND1
JFCRLSE  EQU   JFCBIND1
JFCBXPDT EQU   INFMJFCB+83
JFCBCRDT EQU   INFMJFCB+80
JFCBOPS2 EQU   JFCBMASK+7
JFCRCTLG EQU   JFCBFLG2
JFCBBUFF EQU   JFCBFLG2
JFCTRACE EQU   JFCBFLG2
JFCSDRPS EQU   JFCBFLG2
JFCMODNW EQU   JFCBFLG2
JFCNRPS  EQU   JFCDEFER
JFCOUTOP EQU   JFCBFLG2
JFCINOP  EQU   JFCBFLG2
JFCBPWBP EQU   JFCOPEN
@NM00049 EQU   JFCOPEN
JFCDUAL  EQU   JFCBFLG1
JFCSLDES EQU   JFCBFLG1
JFCSLCRE EQU   JFCBFLG1
JFCSTAND EQU   JFCBFLG1
JFCBOPS1 EQU   JFCBMASK
JFCBVLSQ EQU   INFMJFCB+70
JFCRSV31 EQU   JFCFUNC
JFCFNCBT EQU   JFCFUNC
JFCFNCBX EQU   JFCFUNC
JFCFNCBD EQU   JFCFUNC
JFCFNCBW EQU   JFCFUNC
JFCFNCBP EQU   JFCFUNC
JFCFNCBR EQU   JFCFUNC
JFCFNCBI EQU   JFCFUNC
JFCBFOFL EQU   JFCBUFOF
JFCNL    EQU   JFCBLTYP
JFCSL    EQU   JFCBLTYP
JFCNSL   EQU   JFCBLTYP
JFCSUL   EQU   JFCBLTYP
JFCBLP   EQU   JFCBLTYP
JFCBLTM  EQU   JFCBLTYP
JFCBAL   EQU   JFCBLTYP
JFCRSV38 EQU   JFCBLTYP
JFCVINDX EQU   INFMJFCB+64
JFCNLREC EQU   INFMJFCB+62
JFCBADBF EQU   INFMJFCB+60
JFCAMSTR EQU   JFCBFRID+2
JFCAMCRO EQU   JFCBFRID
JFCBDSCB EQU   INFMJFCB+53
JFCPAT   EQU   JFCBTSDM
JFCNDCB  EQU   JFCBTSDM
JFCNDSCB EQU   JFCBTSDM
JFCNWRIT EQU   JFCBTSDM
JFCTTR   EQU   JFCBTSDM
JFCSDS   EQU   JFCBTSDM
JFCVSL   EQU   JFCBTSDM
JFCIPLTX EQU   JFCBELNM
JFCBQNAM EQU   JFCBDSNM
SIODDSNL EQU   INDMSIOT+173
SIOVDSNL EQU   INDMSIOT+172
SIOVDSNT EQU   INDMSIOT+170
SVOLUNNO EQU   INDMSIOT+168
SIOTVMVP EQU   INDMSIOT+164
SIOTETIO EQU   INDMSIOT+148
SIOTATE  EQU   INDMSIOT+144
SVOLUNAD EQU   INDMSIOT+140
SIOTEDLP EQU   INDMSIOT+136
SIOTEDLS EQU   INDMSIOT+132
SIOTRSNC EQU   INDMSIOT+130
SCTANAME EQU   INDMSIOT+122
SIOTSSIC EQU   INDMSIOT+120
@NM00048 EQU   INDMSIOT+108
SIOTSSNM EQU   INDMSIOT+104
@NM00047 EQU   SIOTBYT2
SIOTCVOL EQU   SIOTBYT2
SIOTCALC EQU   SIOTBYT2
SIOTDSPD EQU   SIOTBYT2
SIOTDMND EQU   SIOTBYT2
SIOTOPUC EQU   INDMSIOT+99
SIOTOUTR EQU   INDMSIOT+97
SIOTOUTC EQU   INDMSIOT+96
SIOTAUNC EQU   SIOTALTD
SIOTACAT EQU   SIOTALTD
SIOTADEL EQU   SIOTALTD
SIOTAKEP EQU   SIOTALTD
SIOTNPRV EQU   SIOTALTD
SIOJCATS EQU   SIOTALTD
@NM00046 EQU   SIOTALTD
@NM00045 EQU   SIOTALTD
@NM00044 EQU   INDMSIOT+91
SIOTNDSB EQU   INDMSIOT+88
@NM00043 EQU   INDMSIOT+84
SIOTDPCD EQU   INDMSIOT+82
@NM00042 EQU   SIOTBYT4
SIOTRACT EQU   SIOTBYT4
SIOTRACD EQU   SIOTBYT4
SIOTPROT EQU   SIOTBYT4
SCTOUTPN EQU   INDMSIOT+80
SCTOUTNO EQU   INDMSIOT+76
SCTOUTNM EQU   INDMSIOT+68
SIOUCBAD EQU   SCTUTYPE+5
SIOUCNVT EQU   SCTUTYPE+4
SIOUBYT4 EQU   SIOTDEVT+3
@NM00041 EQU   SIOUBYT3
SIO3UREC EQU   SIOUBYT3
SIO3DISP EQU   SIOUBYT3
SIO3DACC EQU   SIOUBYT3
SIO3COMM EQU   SIOUBYT3
SIO3TAPE EQU   SIOUBYT3
SIOUBYT2 EQU   SIOTDEVT+1
SIOUBYT1 EQU   SIOTDEVT
SIOTOMN  EQU   SCTSBYT4
SIOTIPDI EQU   SCTSBYT4
SIOTVAFF EQU   SCTSBYT4
SIOTASCI EQU   SCTSBYT4
@NM00040 EQU   SCTSBYT4
SIOTGDGA EQU   SCTSBYT4
SCTSMOD  EQU   SCTSBYT3
SCTVREF  EQU   SCTSBYT3
SCTSYSNE EQU   SCTSBYT3
SCTDSNRF EQU   SCTSBYT3
SCTRECVD EQU   SCTSBYT2
SCTDEFER EQU   SCTSBYT2
SCTLABEL EQU   SCTSBYT2
SCTUNLBD EQU   SCTSBYT2
SCTJOBLB EQU   SCTSBYT2
SCTVOLAF EQU   SCTSBYT2
SIOTCATL EQU   SCTSBYT2
SIOCLUNL EQU   SCTSBYT2
SIOTJSCT EQU   SCTSBYT1
SCTUNAFF EQU   SCTSBYT1
SCTPARLM EQU   SCTSBYT1
SIOTQDSN EQU   SCTSBYT1
SIOTCCAT EQU   SCTSBYT1
SCTSYSIN EQU   SCTSBYT1
SIOTPRIV EQU   SCTSDISP
S3400DSP EQU   SCTSDISP
SIOTRETN EQU   SCTSDISP
SIOTVLCT EQU   INDMSIOT+54
SCTNMBUT EQU   INDMSIOT+53
SIOTRTRY EQU   SIOTBYT0
SIOTPUPV EQU   SIOTBYT0
SIOTNOPV EQU   SIOTBYT0
SIOTGIGN EQU   SIOTBYT0
SPVTAMSG EQU   SIOTBYT0
SIOTFUDA EQU   SIOTBYT0
SIOTGIID EQU   INDMSIOT+50
SCTVOLCT EQU   INDMSIOT+49
SCTSPOOL EQU   INDMSIOT+48
SIOTDSNM EQU   SIOTTSTC
SIOTTRKM EQU   SIOTTSTC
SIOTSSMG EQU   SIOTTSTC
@NM00039 EQU   SIOTTSTC
SIOTTERM EQU   SIOTTSTC
SIOTINFC EQU   SIOTTSTC
@NM00038 EQU   SIOTBYT3
SIOTDSID EQU   SIOTBYT3
S3400OFF EQU   SIOTBYT3
SIOTJES3 EQU   SIOTBYT3
SIOCDEVT EQU   SIOTBYT3
SCTDDINO EQU   INDMSIOT+44
SIOTALCD EQU   SIOTBYT1
SIODADSM EQU   SIOTBYT1
SIOTDADR EQU   SIOTBYT1
SIOPSCNT EQU   INDMSIOT+42
SIOTREFN EQU   INDMSIOT+40
SIOTOTUN EQU   INDMSIOT+39
SIOTVRSB EQU   INDMSIOT+36
@NM00037 EQU   INDMSIOT+35
@NM00036 EQU   INDMSIOT+31
SIOTAFID EQU   INDMSIOT+26
SIOTVLSP EQU   INDMSIOT+24
SIODSNTE EQU   INDMSIOT+22
SIOTUNAF EQU   SCTUSADD
SIOTDEST EQU   INDMSIOT+12
DSABGRID EQU   DSABGIDL+4
DSABLLEN EQU   DSABGIDL
DSABRS04 EQU   DSAB+68
DSABRS03 EQU   DSAB+62
DSABDCBM EQU   DSAB+56
DSABSSCM EQU   DSAB+52
DSABSSNM EQU   DSAB+48
DSABPTTR EQU   DSAB+44
DSABTCBP EQU   DSAB+40
DSABRS02 EQU   DSAB+38
@NM00035 EQU   DSABFLG4
DSABCKSI EQU   DSABFLG4
DSABCKVL EQU   DSABFLG4
DSABCKDS EQU   DSABFLG4
@NM00034 EQU   DSABFLG3
DSABJSCT EQU   DSABFLG3
DSABCATL EQU   DSABFLG3
DSABVMSC EQU   DSABFLG3
DSABVAM  EQU   DSABFLG3
DSABPASS EQU   DSABFLG3
DSABDEFR EQU   DSABFLG3
@NM00033 EQU   DSABFLG2
DSABUNAL EQU   DSABFLG2
DSABIRM  EQU   DSABFLG2
DSABOPEN EQU   DSABFLG2
DSABNUSE EQU   DSABFLG1
DSABCATM EQU   DSABFLG1
DSABPCAT EQU   DSABFLG1
DSABDCAT EQU   DSABFLG1
DSABCONV EQU   DSABFLG1
DSABDCNV EQU   DSABFLG1
DSABPALC EQU   DSABFLG1
DSABDALC EQU   DSABFLG1
@NM00032 EQU   DSABORG2
DSABTR   EQU   DSABORG2
DSABAM   EQU   DSABORG2
@NM00031 EQU   DSABORG2
DSABTQ   EQU   DSABORG2
DSABTX   EQU   DSABORG2
DSABGS   EQU   DSABORG2
DSABU    EQU   DSABORG1
DSABPO   EQU   DSABORG1
DSABMQ   EQU   DSABORG1
DSABCQ   EQU   DSABORG1
DSABCX   EQU   DSABORG1
DSABDA   EQU   DSABORG1
DSABPS   EQU   DSABORG1
DSABIS   EQU   DSABORG1
DSABSSVA EQU   DSAB+21
DSABRS01 EQU   DSAB+20
DSABOPCT EQU   DSAB+14
DSABLNTH EQU   DSAB+12
DSABBCHN EQU   DSAB+8
DSABID   EQU   DSAB
QDBRV002 EQU   QDB+28
QDBPRDS  EQU   QDB+26
QDBPRSZ  EQU   QDB+24
QDBBPTDS EQU   QDB+22
QDBFPTDS EQU   QDB+20
QDBLELMP EQU   QDB+16
QDBFELMP EQU   QDB+12
QDBNELMS EQU   QDB+8
QDBRV001 EQU   QDB+6
QDBATTR  EQU   QDB+4
QDBQDB   EQU   QDB
@NM00029 EQU   CMODISP
@NM00028 EQU   CMRBBYT4
@NM00027 EQU   CMRBBYT4
CMSSERR  EQU   CMRBBYT4
CMSSIERR EQU   CMRBBYT4
@NM00026 EQU   CMRBBYT3
CMSSKEEP EQU   CMRBBYT3
CMWAIT   EQU   CMRBBYT3
@NM00025 EQU   CMRBBYT2
@NM00024 EQU   CMRBBYT2
@NM00023 EQU   CMRBBYT2
CMSETPRV EQU   CMRBBYT2
@NM00022 EQU   CMRBBYT1
CMINVUCB EQU   CMRBBYT1
CMCNDISP EQU   CMRBBYT1
@NM00021 EQU   CMFMBYT4
@NM00020 EQU   CMFMBYT4
@NM00019 EQU   CMFMBYT4
@NM00018 EQU   CMFMBYT4
@NM00017 EQU   CMFMBYT4
@NM00016 EQU   CMFMBYT4
CMALSTCT EQU   CMFMBYT4
CMLSTCJS EQU   CMFMBYT4
@NM00015 EQU   CMFMBYT3
@NM00014 EQU   CMFMBYT3
CMSPSCR  EQU   CMFMBYT3
CMPUBPRV EQU   CMFMBYT3
CMSCRVL1 EQU   CMFMBYT3
CMNOSMF  EQU   CMFMBYT3
CMDSRALL EQU   CMFMBYT3
CMPURGE  EQU   CMFMBYT2
CMNERMSG EQU   CMFMBYT2
CMGENDEQ EQU   CMFMBYT2
CMCHATTR EQU   CMFMBYT2
CMNOVUT  EQU   CMFMBYT2
CMNOPOST EQU   CMFMBYT2
CMDPCATS EQU   CMFMBYT1
TEXTUPRM EQU   TEXTUFLD+2
TEXTULEN EQU   TEXTUFLD
TEXTUNUM EQU   TEXTUNIT+2
TEXTUKEY EQU   TEXTUNIT
TXTPLEND EQU   TXTPLENT
TXTUPEND EQU   TXTUNITP
RIUOPTUP EQU   UNALKEYT+20
UNAOPTUP EQU   UNALKEYT+16
MEMBRTUP EQU   UNALKEYT+8
DSNAMTUP EQU   UNALKEYT+4
DDNAMTUP EQU   UNALKEYT
@NM00001 EQU   SMFFLAGS
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RF00229 EQU   @RC00206
@RC00313 EQU   @RC00312
@RC00399 EQU   @RC00398
@RC00411 EQU   @RC00406
@RC00407 EQU   @RC00406
@RF00423 EQU   @RC00396
@RC00470 EQU   @RC00427
@RC00400 EQU   @RC00399
@RF00475 EQU   @RC00470
@ENDDATA EQU   *
         END   IEFDB4A1,(C'PLS1324',0701,78089)
