         TITLE 'ERROR RECOVERY PROCEDURE FOR 2671 PAPER TAPE READER    *
                        '
IEC2671A CSECT
         USING IEC2671A,CODEBASE     ADDRESSABILITY FOR CODE
         USING @DATD,DATABASE        ADDRESSABILITY FOR DATA
*   CODEBASE=RF;                                                   0003
         LR    CODEBASE,RF                                         0003
*   GOTO START;                                                    0004
         B     START                                               0004
*   GEN(DC    C'IGE0002A 02/02/77');/*                       @ZA11096*/
*                                                                  0005
         DC    C'IGE0002A 02/02/77'
*   /*****************************************************************/
*   /*                                                               */
*   /* REGISTERS & POINTERS                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0006
*   DCL                                                            0006
*     R0 PTR REG(0),                /* EXTERNAL LINKAGE              */
*     R1 PTR REG(1) RSTD,           /* EXTERNAL LINKAGE              */
*     R2 PTR REG(2),                /* EXTERNAL LINKAGE              */
*     R3 PTR REG(3),                /* EXTERNAL LINKAGE              */
*     EWAPTR PTR REG(6) RSTD,       /* POINTER TO ERP WORK AREA      */
*     IOSBPTR PTR REG(7) RSTD,      /* POINTER TO IOSB               */
*     DATABASE PTR REG(8) RSTD,     /* BASE REGISTER FOR AUTOMATIC 0006
*                                      DATA (@DATD DSECT)            */
*     R9 PTR REG(9),                /* EXTERNAL LINKAGE              */
*     CODEBASE PTR REG(10) RSTD,    /* BASE REGISTER FOR CODE        */
*     RB PTR REG(11),               /* EXTERNAL LINKAGE              */
*     RC PTR REG(12),               /* EXTERNAL LINKAGE              */
*     RD PTR REG(13),               /* EXTERNAL LINKAGE              */
*     RE PTR REG(14),               /* EXTERNAL LINKAGE              */
*     RF PTR REG(15),               /* EXTERNAL LINKAGE              */
*     CVTPTRXX PTR(31) LOCATION(16),/* POINTER TO CVT                */
*     CVTPTR PTR(31),               /* LOCAL POINTER TO CVT          */
*     CCWPTR PTR(31);               /* POINTER TO CURRENT CCW        */
*                                                                  0006
*   /*****************************************************************/
*   /*                                                               */
*   /* CSW STATUS BITS                                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0007
*   DCL                                                            0007
*     1 * DEF(IOSTATUS) BIT(16),                                   0007
*      2 CSWATN BIT(1),             /* ATTENTION                     */
*      2 CSWSMD BIT(1),             /* STATUS MODIFIER               */
*      2 CSWCUE BIT(1),             /* CONTROL UNIT END              */
*      2 CSWBSY BIT(1),             /* BUSY                          */
*      2 CSWCHE BIT(1),             /* CHANNEL END                   */
*      2 CSWDVE BIT(1),             /* DEVICE END                    */
*      2 CSWUCK BIT(1),             /* UNIT CHECK                    */
*      2 CSWUEX BIT(1),             /* UNIT EXCEPTION                */
*      2 CSWPCI BIT(1),             /* PROGRAM CONTROLED INTERRUPT   */
*      2 CSWIL BIT(1),              /* INCORRECT LENGTH              */
*      2 CSWPC BIT(1),              /* PROGRAM CHECK                 */
*      2 CSWPCK BIT(1),             /* PROTECTION CHECK              */
*      2 CSWCDK BIT(1),             /* CHANNEL DATA CHECK            */
*      2 CSWCTK BIT(1),             /* CHANNEL CONTROL CHECK         */
*      2 CSWICK BIT(1),             /* INTERFACE CONTROL CHECK       */
*      2 CSWCCK BIT(1);             /* CHAINING CHECK                */
*                                                                  0007
*   /*****************************************************************/
*   /*                                                               */
*   /* FIELDS UNIQUE TO THIS ERP                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0008
*   DCL                                                            0008
*     1 * CHAR(4) DEF(EWACNTR1),    /*                       @ZA11096*/
*      2 * CHAR(1),                 /*                       @ZA11096*/
*       3 BUSFLAG BIT(1),           /* A BUSOUT CHECK HAS BEEN     0008
*                                      DETECTED OF A PREVIOUS ENTRY  */
*       3 ENTFLAG BIT(1),           /* ERP HAS BEEN PREVIOUSLY     0008
*                                      ENTERED FOR THIS CHANNEL    0008
*                                      PROGRAM                       */
*       3 * BIT(6),                 /*                       @ZA11096*/
*      2 EQCTR CHAR(1),             /* EQUIPMENT CHECK COUNTER (3  0008
*                                      RETRIES BEFORE PERMANENT    0008
*                                      ERROR)                @ZA11096*/
*      2 * CHAR(2);                 /*                       @ZA11096*/
*                                                                  0008
*   /*****************************************************************/
*   /*                                                               */
*   /* CONSTANTS                                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0009
*   DCL                                                            0009
*     ON BIT(1) CONSTANT('1'B),                                    0009
*     OFF BIT(1) CONSTANT('0'B),                                   0009
*     TIC BIT(8) CONSTANT('08'X),   /* TIC COMMAND CODE              */
*     EREXCP FIXED(15) CONSTANT(15),/* ERROR EXCP SVC CODE           */
*     ERPWTO FIXED(15) CONSTANT(253),/* ID OF WTO MODULE             */
*     STATUP FIXED(15) CONSTANT(254),/* ID OF STATISTICS UPDATE    0009
*                                      MODULE                        */
*     STATMASK BIT(8) CONSTANT('78'X),/* STATISTICS UPDATE MASK      */
*     EXITSVC FIXED(15) CONSTANT(3);/* EXIT SVC CODE                 */
*                                                                  0009
*   /*****************************************************************/
*   /*                                                               */
*   /* CHANNEL COMMAND WORD                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0010
*   DCL                                                            0010
*     1 CCWMAP BDY(DWORD) BASED(CCWPTR),                           0010
*      2 CCWCMD BIT(8),             /* COMMAND CODE                  */
*      2 CCWADDR PTR(24),           /* DATA ADDRESS                  */
*      2 CCWFLAG BIT(8),            /* FLAGS                         */
*       3 CCWCD BIT(1),             /* CHAIN DATA                    */
*       3 CCWCC BIT(1),             /* CHAIN COMMANDS                */
*       3 CCWSLI BIT(1),            /* SUPPRESS INCORRECT LENGTH     */
*       3 CCWSKP BIT(1),            /* SUPPRESS DATA TRANSFER        */
*       3 CCWPCI BIT(1),            /* PROGRAM CONTROLED INTERRUPT   */
*       3 CCWIDA BIT(1),            /* INDIRECT DATA ADDRESS         */
*       3 * BIT(2),                 /* RESERVED                      */
*      2 * CHAR(1),                 /* RESERVED                      */
*      2 CCWCOUNT FIXED(16);        /* COUNT                         */
*                                                                  0011
*/************************************************************       */
*/*                                                                  */
*/*  THIS STRUCTURE DESCRIBES THE CONTROL BLOCK PASSED TO THE        */
*/*  I/O SUPERVISOR  AS A  PARAMETER OF THE SRB.  THE CONTROL        */
*/*  BLOCK CONTAINS ALL INFORMATION NECESSARY TO INITIATE AND        */
*/*  TERMINATE AN I/O OPERATION.  FIELDS OF THE IOSB ARE USED        */
*/*  FOR COMMUNICATION BETWEEN THE:                                  */
*/*                                                                  */
*/*      1. I/O SUPERVISOR AND I/O REQUESTOR                         */
*/*      2. I/O SUPERVISOR AND ERROR RECOVERY PROCEDURES             */
*/*      3. COMPONENTS OF THE I/O SUPERVISOR                         */
*/*      4. SUCCESSIVE ENTRANCES TO THE ERP'S                        */
*/*      5. ERP AND COMMON WTO AND STATISTICS UPDATE MODULES         */
*/*                                                                  */
*/************************************************************       */
*/*                                                                  */
*/*      05/30/72   LEVEL=00                                         */
*/*                                                                  */
*/************************************************************       */
*                                                                  0011
*   DCL                                                            0011
*     1 IOSB BDY(WORD) BASED(IOSBPTR),                             0011
*      2 IOSFLA CHAR(1),            /* FLAG BYTE A                   */
*       3 IOSACHN BIT(2),           /* COMMAND & DATA CHAINING       */
*        4 IOSDCHN BIT(1),          /* DATA CHAINING                 */
*        4 IOSCCHN BIT(1),          /* COMMAND CHAINING              */
*       3 IOSERR BIT(1),            /* ERROR ROUTINE IN CONTROL MUST
*                                      BE ZEROED BY DRIVER IF ERP  0011
*                                      RETURNS WITH THIS BIT ON, A 0011
*                                      RETRY IS ASSUMED. IF THE ERP
*                                      RE- TURNS WITH THIS BIT OFF,
*                                      THE ERROR IS CONSIDERED     0011
*                                      PERMANENT OR CORRECTED      0011
*                                      DEPENDING ON THE SETTING OF 0011
*                                      IOSEX.                        */
*       3 IOSSMDA BIT(1),           /* ERP STATUS MODFR BIT . MUST BE
*                                      ZEROED BY DRIVER TAPE -     0011
*                                      REPOSITION DEVCE 1052 -     0011
*                                      IMMEDIATE OPERA- TION, CCW OP
*                                      CODE IN IOSMDB.               */
*       3 IOSSMDB BIT(1),           /* ERP STATUS MODFR BIT B MUST BE
*                                      ZEROED BY DRIVER SET BY FETCH
*                                      IN APPEN- DAGE FOR POSTING. 0011
*                                      TAPE - CRC NEEDED DASD - PCI
*                                      FETCH STOP FLAG               */
*       3 IOSEX BIT(1),             /* EXCEPTIONAL CONDITION. UPON 0011
*                                      RETURN FROM NORMAL OR ABNORMAL
*                                      EXIT WITH THIS BIT ON, ERP  0011
*                                      PROCES- SING IS INITIATED IF
*                                      IN- ITIAL ERROR CONDITION. IF
*                                      BIT IS OFF, IT IS AS- SUMED 0011
*                                      THAT THE EXIT COR- RECTED THE
*                                      CONDITION OR DID NOT CONSIDER
*                                      IT AN ERROR. WHEN THE ERP RE-
*                                      TURNS WITH THIS BIT ON, AND 0011
*                                      IOSERR OFF,THE ERROR IS     0011
*                                      CONSIDERED PERMANENT. WHEN THE
*                                      ERP RETRNS WITH THIS BIT OFF,
*                                      THE ERROR HAS BEEN CORRECTED. */
*       3 IOSDOM BIT(1),            /* DOM MACRO REQUIRED    @YM06828*/
*       3 IOSIOSB BIT(1),           /* IOSB CREATED BY IOS. MUST BE
*                                      ZEROED BY DRIVER              */
*      2 IOSFLB CHAR(1),            /* FLAG BYTE B                   */
*       3 IOSDIESE BIT(1),          /* SECOND ENTRY TO DIE           */
*       3 IOSSDR BIT(1),            /* ERP DOESNT WANT OBR   @Z40MPLG*/
*       3 IOSFLB2 BIT(1),           /* RESERVED                      */
*       3 IOSFLB3 BIT(1),           /* RESERVED                      */
*       3 IOSFLB4 BIT(1),           /* RESERVED                      */
*       3 IOSMSG BIT(1),            /* MESSAGE INDICATOR 0 = INTRVNTN
*                                      REQURD MSG 1 = I/O ERROR    0011
*                                      MESSAGE                       */
*       3 IOSBDCST BIT(1),          /* BROADCAST BIT                 */
*       3 IOSLOG BIT(1),            /* CREATE AN OBR RECORD          */
*      2 IOSFLC CHAR(1),            /* DEVICE DEP ERP FLAGS          */
*       3 IOSDVMNT BIT(1),          /* DAVV ISSUED MOUNT             */
*       3 IOSDVALT BIT(1),          /* ALTERNATE TRACK PROCES- SING
*                                      BY DAVV                       */
*        4 IOSVERIF BIT(1),         /* UNSOLICITED DEVICE END      0011
*                                      VERIFICATION NEEDED (NON-DA)  */
*       3 IOSCC3WE BIT(1),          /* GDP REQ'RS CC3 POST         0011
*                                      X6D@DCRR054                   */
*       3 IOSTP BIT(1),             /* NO SPECIAL CC3              0011
*                                      HANDLINGTOBEFLGD              */
*       3 IOSRWAIT BIT(2),          /* RESTARTABLE WAIT            0011
*                                      REASON@ZA00904                */
*       3 IOSCTCNR BIT(1),          /* CTC-NO RETRY ALLOWED  @ZA11845*/
*       3 IOSFLC7 BIT(1),           /* RESERVED                      */
*      2 IOSPROC CHAR(1),           /* THIS BYTE INDICATES WHAT TYPE
*                                      OF SPECIAL PROCES- SING IS TO
*                                      BE PERFORMED BY IOS COMPONENTS
*                                      OPER- ATING ASYNCHRONOUS TO 0011
*                                      MAINLINE MUST BE ZEROED BY  0011
*                                      DRIVER DCLS ARE AT END OF IOSB*/
*      2 IOSDVRID CHAR(1),          /* DRIVER ID VALUE VALUES AT END
*                                      OF IOSB                       */
*      2 IOSPRLVL CHAR(1),          /* PRIORITY LEVEL AT WHICH THE 0011
*                                      ADDRESS SPACE IS TO BE      0011
*                                      SCHEDULED, 0 OR 1             */
*      2 IOSASID CHAR(2),           /* ADDR SPACE ID OF MEMORY TO BE
*                                      SCHEDULED AT TERM OF I/O    0011
*                                      REQUEST                       */
*      2 IOSPGAD PTR(31),           /* PGM ADDR TO BE DISPTCHD       */
*      2 IOSPKEY BIT(8),            /* PROTECT KEY OF IOSPGAD        */
*       3 * BIT(4),                 /* PROTECT KEY                   */
*       3 IOSLCL BIT(1),            /* ASID SCHDLD AT LOCAL LVL      */
*       3 IOSIDR BIT(1),            /* ASYNCHRONOUS SCHEDULING SHOULD
*                                      BE USED FOR THIS REQUEST    0011
*                                      (INDIRECT RE- CORDING FOR   0011
*                                      PAGING I/O                    */
*       3 IOSPGDPX BIT(1),          /* THIS REQUEST HAS A BACK UP  0011
*                                      COPY (DUPLEXED PAGE)          */
*       3 IOSPKY7 BIT(1),           /* RESERVED                      */
*      2 IOSCOD CHAR(1),            /* I/O COMPLETION CODE USED AS 0011
*                                      TEMP SAVE FOR SYSTEM MASK BY
*                                      CHAN SCHD VALUES AT END OF  0011
*                                      IOSB                          */
*      2 IOSOPT CHAR(1),            /* OPTIONS BYTE                  */
*       3 IOSBYP BIT(1),            /* BYPSS IOS CHAN PGM PRFX       */
*       3 IOSDEP BIT(1),            /* DEVICE END POST REQUSTD       */
*       3 IOSQISCE BIT(1),          /* THIS REQUEST INITIATED BY   0011
*                                      FUNCTION WHICH HAS QUIESCED 0011
*                                      THE DEVICE                    */
*       3 IOSPSLL BIT(1),           /* ON=LOCAL LOCK NOT WANTED FOR
*                                      POST STATUS PROCSS OFF=LOCAL
*                                      LOCK WANTED                   */
*       3 IOSNERP BIT(1),           /* IBM ERPS NOT TO BE USED       */
*       3 IOSTSLL BIT(1),           /* ON = LOCAL LOCK NOT WANTED BY
*                                      TERMINATION ROUTINE OFF =   0011
*                                      LOCAL LOCK WANTED BY        0011
*                                      TERMINATION ROUTINE IF IOSPSLL
*                                      ALSO ON                       */
*       3 IOSAPR BIT(1),            /* ALT PATH RETRY ACTIVE. MUST BE
*                                      ZEROED BY DRIVER              */
*       3 IOSRELSE BIT(1),          /* STAND-ALONE RELEASE CCW ISSUED
*                                      BY IOS                        */
*      2 IOSOPT2 CHAR(1),           /* OPTION BYTE 2                 */
*       3 IOSHTP BIT(1),            /* ELIGIBLE FOR SHOULDR TAP      */
*       3 IOSOPT2X BIT(7),          /* RESERVED BITS (UNUSED)        */
*      2 IOSUCB PTR(31),            /* UNIT CONTROL BLOCK ADDR       */
*      2 * CHAR(8),                                                0011
*       3 IOSCC BIT(8),             /* SIO CONDITION CODE            */
*       3 IOSCSW CHAR(7),           /* LOW ORDR 7 BYTES OF CSW       */
*        4 IOSCSWCA PTR(24) BDY(BYTE),/* LAST COMMAND ADDRESS        */
*        4 IOSTATUS CHAR(2),        /* CSW STATUS                    */
*         5 IOSTSA BIT(8),          /* DEVICE STATUS                 */
*         5 IOSTSB BIT(8),          /* CHANNEL STATUS                */
*        4 IOSCSWRC PTR(16) BDY(BYTE),/* RISIDUAL COUNT              */
*      2 IOSSRB PTR(31),            /* POINTER BACK TO SRB           */
*      2 IOSUSE PTR(31),            /* USER FIELD                    */
*      2 IOSRES4A PTR(31),          /* RESERVED                      */
*      2 IOSAPMSK CHAR(2),          /* EXCLUSIVE PATH MASK FOR APR 0011
*                                      MUST BE ZEROED BY DRIVER      */
*      2 IOSSNS BIT(16),            /* SENSE DATA                    */
*/*  *********************************************************       */
*/*    END OF COMMON SECTION AND START OF PROCESSING  DEPEN-         */
*/*    DENT SECTIONS WHICH ARE: NORMAL I/O REQUEST, WTO, AND         */
*/*    PCI SCHEDULING.                                               */
*/*  *********************************************************       */
*                                                                  0011
*      2 IOSIPIB PTR(31),           /* IOS/PURGE INTERFACE BLOCK   0011
*                                      ADDRESS MUST BE ZEROED BY   0011
*                                      DRIVER. OR CHAIN PTR FOR PCI
*                                      SRB/IOSBS                     */
*      2 IOSPCHN PTR(31),           /* PTR TO ENDING STATUS IOSB FOR
*                                      PCI SRB/IOSBS. PTR TO FIRST 0011
*                                      PCI SRB/IOSB FOR ENDING STATUS
*                                      IOSB.                         */
*      2 IOSERP PTR(31),            /* ERP DYNAMIC W.A. ADDR. MUST BE
*                                      ZEROED BY DRIVER              */
*      2 IOSPCI PTR(31),            /* PCI EXIT ADDRESS              */
*      2 IOSNRM PTR(31),            /* NORMAL EXIT ADDRESS           */
*      2 IOSABN PTR(31),            /* ABNORMAL EXIT ADDRESS         */
*      2 IOSDIE PTR(31),            /* DISABLED INT. EXIT ADDR       */
*       3 IOSDIEFG CHAR(1),         /* FLAG BYTE IN DIE PTR  @Z40WPLL*/
*        4 IOSNOTRS BIT(1),         /* 1 = DRIVER WANTS NO   @Z40WPLL*/
*                                                                  0011
*     /***************************************************************/
*     /*                                                             */
*     /* TRAS ON ENTRY TO DIE.                               @Z40WPLL*/
*     /* 0 = NORMAL TRAS/DIE                                 @Z40WPLL*/
*     /* LINK.                                               @Z40WPLL*/
*     /* NOTE: THIS BIT MUST BE                              @Z40WPLL*/
*     /* ZERO IF DIE ADDRESS                                 @Z40WPLL*/
*     /* ZERO.                                               @Z40WPLL*/
*     /*                                                             */
*     /***************************************************************/
*                                                                  0011
*      2 IOSRST PTR(31),            /* REAL ADDRESS OF REAL CHANNEL
*                                      PROGRAM                       */
*      2 IOSVST PTR(31),            /* VIRTUAL ADDRESS OF REAL     0011
*                                      CHANNEL PROGRAM               */
*      2 IOSDSID PTR(31),           /* DATA SET ID FOR PURGE         */
*      2 IOSRSS1B CHAR(1),          /* RESERVED                      */
*      2 IOSAFF BIT(8),             /* CPU AFFINITY INDICATOR FOR  0011
*                                      GUARANTEED DEVCE PTH          */
*      2 IOSPATH CHAR(2),           /* PATH SPECIFICATION FOR      0011
*                                      GUARANTEED DEVICE PATH OR   0011
*                                      SPECIFIC EXPOSURE REQUESTS    */
*       3 IOSCHN CHAR(1),                                          0011
*        4 IOSGDP BIT(1),           /* GUARANTEED DEVICE PATH        */
*        4 IOSEXP BIT(1),           /* SPECIFIC EXPOSURE REQST       */
*        4 IOSPATH2 BIT(1),         /* RESERVED                      */
*        4 IOSPATH3 BIT(1),         /* RESERVED                      */
*        4 * BIT(4),                /* CHANNEL NUMBER                */
*       3 IOSCUDEV CHAR(1),         /* CONTRL UNIT/DEVICE ADDR       */
*      2 IOSFMSK CHAR(1),           /* MODE SET/FILE MASK            */
*      2 IOSCKEY BIT(8),            /* PROT. KEY OF CHAN PGM         */
*       3 * BIT(4),                 /* PROTECT KEY                   */
*       3 IOSCKEY4 BIT(1),          /* RESERVED                      */
*       3 IOSCKEY5 BIT(1),          /* RESERVED                      */
*       3 IOSCKEY6 BIT(1),          /* RESERVED                      */
*       3 IOSCKEY7 BIT(1),          /* RESERVED                      */
*      2 IOSMDB CHAR(1),            /* ERP IMMED. CCW OP CODE        */
*      2 IOSMDM CHAR(1),            /* ERP MODIFIER MASK             */
*      2 IOSEEK CHAR(8),            /* STATIC SEEK ADDRESS           */
*      2 IOSEEKA CHAR(8),           /* DYNAMIC SEEK ADDRESS          */
*       3 IOSSKM PTR(8),            /* M                             */
*       3 IOSSKBB PTR(16) BDY(BYTE),/* BB                            */
*       3 IOSCCHH CHAR(4),          /* CCHH                          */
*        4 IOSSKCC PTR(16) BDY(BYTE),/* CC                           */
*        4 IOSSKHH PTR(16) BDY(BYTE),/* HH                           */
*         5 IOSSKH1 PTR(8),         /* H                             */
*         5 IOSSKH2 PTR(8),         /* H                             */
*       3 IOSSKR PTR(8),            /* R                             */
*      2 IOSEND CHAR(0);            /* END OF IOSB                   */
*/*    ATTENTION PROCESSING SECTION                                  */
*                                                                  0012
*   DCL                                                            0012
*     1 IOSATTSC CHAR(64) DEF(IOSIPIB),                            0012
*      2 IOSATTSN CHAR(24),         /* ADDITIONAL SENSE IF ANY       */
*      2 * CHAR(16),                /* ATTN RTN RSVD AREA            */
*      2 IOSATTWA CHAR(24);         /* ATTN RTN WORK AREA            */
*/*    WTO PROCESSING SECTION                                        */
*                                                                  0013
*   DCL                                                            0013
*     1 IOSWTOWA CHAR(64) DEF(IOSIPIB),                            0013
*      2 IOSWTOCH CHAR(2),          /* ADDR CC=3 OCCURRED ON         */
*      2 IOSWTOCP CHAR(1),          /* CPU CC=3 OCCURRED ON          */
*      2 IOSWTOPT CHAR(1),          /* PATH IND. FOR CC=3            */
*      2 IOSWRNDR CHAR(60);         /* REMAINDER OF WTO W.A.         */
*/*    PCI SCHEDULING SECTION                                        */
*                                                                  0014
*   DCL                                                            0014
*     1 IOSPCISC CHAR(64) DEF(IOSIPIB) BDY(WORD),                  0014
*      2 * PTR(31),                 /* SAME AS IOSIPIB. MUST NOT BE
*                                      USED                          */
*      2 * PTR(31),                 /* SAME AS IOSPCHN. MUST NOT BE
*                                      USED                          */
*      2 IOSPCIRS CHAR(36),         /* PCI RSVD SECTION              */
*      2 IOSPCIWA CHAR(20);         /* PCI WORK AREA                 */
*/* **********************************************************       */
*/*                                                                  */
*/*      FOLLOWING ARE THE PLS DECLARES WHICH REPLACE  THE           */
*/*      PREVIOUSLY DEFINED %DCLARES.  THE FIELDS TO WHICH           */
*/*      THE VALUES APPLY ARE REPRODUCED AS A COMMENT. THIS          */
*/*      CHANGE ALLOWS A CROSS REFERENCE OF THE NAMES  USED          */
*/*      AS FIELD VALUES.                                            */
*/*                                                                  */
*/* **********************************************************       */
*                                                                  0015
*   /*****************************************************************/
*   /*                                                               */
*   /* 2 IOSPROC CHAR(1), SEE DCL FOR DESCRIPTION                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0015
*   DCL                                                            0015
*     IOSAPCI BIT(8) CONSTANT('04'X);/* PCI                          */
*   DCL                                                            0016
*     IOSATTN BIT(8) CONSTANT('08'X);/* ATTENTION                    */
*   DCL                                                            0017
*     IOSAPURG BIT(8) CONSTANT('0C'X);/* PURGE                       */
*   DCL                                                            0018
*     IOSADAVV BIT(8) CONSTANT('10'X);/* DAVV                        */
*   DCL                                                            0019
*     IOSAWTO BIT(8) CONSTANT('14'X);/* WTO                          */
*   DCL                                                            0020
*     IOSADDR BIT(8) CONSTANT('18'X);/* DDR                          */
*   DCL                                                            0021
*     IOSACRH BIT(8) CONSTANT('1C'X);/* CRH                   Y30CQLG*/
*                                                                  0021
*   /*****************************************************************/
*   /*                                                               */
*   /* 2 IOSDVRID CHAR(1), SEE DCL FOR DESCRIPTION                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0022
*   DCL                                                            0022
*     IOSIOSID BIT(8) CONSTANT('00'X);/* RESERVED FOR IOS            */
*   DCL                                                            0023
*     IOSMISID BIT(8) CONSTANT('01'X);/* MISCELLANEOUS ID FOR I/O  0023
*                                      REQUESTS THAT CANNOT BE     0023
*                                      PURGED, ASSOCIATED WITH A   0023
*                                      TASK, OR VIOLATE XTNTS        */
*   DCL                                                            0024
*     IOSXCPID BIT(8) CONSTANT('02'X);/* EXCP                        */
*   DCL                                                            0025
*     IOSVSAID BIT(8) CONSTANT('03'X);/* VSAM                        */
*   DCL                                                            0026
*     IOSATMID BIT(8) CONSTANT('04'X);/* VTAM                        */
*   DCL                                                            0027
*     IOSTCMID BIT(8) CONSTANT('05'X);/* TCAM                        */
*   DCL                                                            0028
*     IOSOLTID BIT(8) CONSTANT('06'X);/* OLTEP                       */
*   DCL                                                            0029
*     IOSFCHID BIT(8) CONSTANT('07'X);/* PROGRAM FETCH               */
*   DCL                                                            0030
*     IOSJESID BIT(8) CONSTANT('08'X);/* JES3                        */
*   DCL                                                            0031
*     IOSSS1ID BIT(8) CONSTANT('09'X);/* SS1/DSM                     */
*   DCL                                                            0032
*     IOSPRGID BIT(8) CONSTANT('0A'X);/* IECVIOPM PURGE      @ZA04107*/
*                                                                  0032
*   /*****************************************************************/
*   /*                                                               */
*   /* 2 IOSCOD CHAR(1), SEE DCL FOR DESCRIPTION                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0033
*/* **********************************************************       */
*/*   COMPLETION CODES 41 - 5F ARE RESERVED FOR PERMANENT            */
*/*   ERROR CONDITIONS. THESE CODES WILL ALWAYS BE LAST ENTRY        */
*/*   CODES TO ABNORMAL EXITS.                                       */
*/*   COMPLETION CODES 60 - 73 ARE RESERVED FOR IOS USE.             */
*/*   COMPLETION CODES 74 - 7E DENOTE ABNORMAL CONDITIONS FOR        */
*/*   WHICH CORRECTION MAY BE POSSIBLE. THESE CODES DENOTE           */
*/*   FIRST ENTRY TO ABNORMAL EXITS.                                 */
*/* **********************************************************       */
*                                                                  0033
*   DCL                                                            0033
*     IOSFTCHC BIT(8) CONSTANT('71'X);/* HARDWARE CORRECTED DATA   0033
*                                      CHECK FOR FETCH               */
*   DCL                                                            0034
*     IOSMIHC BIT(8) CONSTANT('74'X);/* THE I/O REQUEST HAS BEEN   0034
*                                      ROUTED TO I/O RESTART BY CCH,
*                                      ALTERNATE CPU RECOV- ERY,   0034
*                                      MISSING INTERRUPT HANDLER.    */
*   DCL                                                            0035
*     IOSFINTC BIT(8) CONSTANT('7E'X);/* INTERCEPT CONDITION BE- FORE
*                                      ENTRANCE TO ERP               */
*   DCL                                                            0036
*     IOSNRMC BIT(8) CONSTANT('7F'X);/* NORMAL COMPLETION            */
*   DCL                                                            0037
*     IOSGDPWE BIT(8) CONSTANT('6D'X);/* IECVPST GOTO ABE & ERP    0037
*                                                            @DCRR054*/
*   DCL                                                            0038
*     IOSERRC BIT(8) CONSTANT('41'X);/* PERMANENT I/O ERROR          */
*   DCL                                                            0039
*     IOSEXTC BIT(8) CONSTANT('42'X);/* EXTENT ERROR                 */
*   DCL                                                            0040
*     IOSDPXC BIT(8) CONSTANT('43'X);/* DUPLEXED I/O REQUEST WAS NOT
*                                      STARTED BECAUSE OF A QUIESCED
*                                      OR NOT READY DEVICE.          */
*   DCL                                                            0041
*     IOSINTC BIT(8) CONSTANT('44'X);/* REQUEST INTERCEPTED BE- CAUSE
*                                      A PERMANENT ERROR OCCURRED THE
*                                      LAST TIME THE DEVICE WAS USED.*/
*   DCL                                                            0042
*     IOSABNC BIT(8) CONSTANT('45'X);/* I/O REQUEST ABNORMALLY     0042
*                                      TERMINATED BECAUSE OF PRO-  0042
*                                      GRAM CHECK, MACHINE CHECK,  0042
*                                      ETC. IN IOS OR AN APPEN- DAGE.*/
*   DCL                                                            0043
*     IOSCD46 BIT(8) CONSTANT('46'X);/* RESERVED                     */
*   DCL                                                            0044
*     IOSCD47 BIT(8) CONSTANT('47'X);/* RESERVED                     */
*   DCL                                                            0045
*     IOSPRGC BIT(8) CONSTANT('48'X);/* REQUEST PURGED               */
*   DCL                                                            0046
*     IOSCD49 BIT(8) CONSTANT('49'X);/* RESERVED                     */
*   DCL                                                            0047
*     IOSTAPEC BIT(8) CONSTANT('4B'X);/* ERR IN TAPE REPOSITIONNG    */
*   DCL                                                            0048
*     IOSIVEXP BIT(8) CONSTANT('4C'X);/* INVALID EXPOSURE NUMBER     */
*   DCL                                                            0049
*     IOSGDPCC BIT(8) CONSTANT('4D'X);/* CC=3 - GDP OR WHILE NIP IN
*                                      CONTROL                       */
*   DCL                                                            0050
*     IOSGDPRD BIT(8) CONSTANT('4E'X);/* GDP - RESERVED DEVICE OR IN
*                                      CONJUNCTION WITH            0050
*                                      IOSRELSE,DEVICE CANNOT BE   0050
*                                      RELEASED.                     */
*   DCL                                                            0051
*     IOSGDPCO BIT(8) CONSTANT('4F'X);/* GDP - CPU OFFLINE           */
*   DCL                                                            0052
*     IOSCD50 BIT(8) CONSTANT('50'X);/* RESERVED                     */
*   DCL                                                            0053
*     IOSMIHCA BIT(8) CONSTANT('51'X);/* THE REQUEST HAS BEEN DE-  0053
*                                      CLARED IN PERMANENT ERROR   0053
*                                      AFTER ERP AND I/O RESTART   0053
*                                      PROCESSING.                   */
*                                                                  0053
*   /*****************************************************************/
*   /*                                                               */
*   /* 3 IOSCUDEV CHAR(1), SEE DCL FOR DESCRIPTION                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0054
*   DCL                                                            0054
*     IOSCU BIT(8) CONSTANT('F0'X); /* CONTROL UNIT                  */
*   DCL                                                            0055
*     IOSDEV BIT(8) CONSTANT('0F'X);/* DEVICE                        */
*   DCL                                                            0056
*     IOSSNSBD BIT(16) CONSTANT('10FE'X);/* VALUE SUPPLIED FOR     0056
*                                      UNSUCCESSFUL SENSE            */
*                                                                  0056
*   /*****************************************************************/
*   /*                                                               */
*   /* 3 IOSCC BIT(8), SEE DCL FOR DESCRIPTION                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0057
*   DCL                                                            0057
*     IOSCC3 BIT(8) CONSTANT('30'X);/* CONDITION CODE 3              */
*   DCL                                                            0058
*     IOSCC2 BIT(8) CONSTANT('20'X);/* CONDITION CODE 2              */
*   DCL                                                            0059
*     IOSCC1 BIT(8) CONSTANT('10'X);/* CONDITION CODE 1              */
*   DCL                                                            0060
*     IOSCC0 BIT(8) CONSTANT('00'X);/* CONDITION CODE 0              */
*                                                                  0060
*   /*****************************************************************/
*   /*                                                               */
*   /* 3 IOSRWAIT BIT(2), RESTARTABLE WAIT REASON            @ZA00904*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0061
*   DCL                                                            0061
*     IOSRWVID BIT(8) CONSTANT('00'X);/* 00--WRONG VOL ID    @ZA00904*/
*   DCL                                                            0062
*     IOSRWIR BIT(8) CONSTANT('04'X);/* 01--INTERVENTION     @ZA00904
*                                      REQUIRED              @ZA00904*/
*   DCL                                                            0063
*     IOSRWCC3 BIT(8) CONSTANT('08'X);/* 10--CONDITION       @ZA00904
*                                      CODE 3                @ZA00904*/
*   DCL                                                            0064
*     IOSRWERR BIT(8) CONSTANT('0C'X);/* 11--READ ERROR      @ZA00904
*                                      FOR LABEL             @ZA00904*/
*                                                                  0065
*/*                                                                  */
*/*      COMMUNICATION VECTOR TABLE                                  */
*/*                                                                  */
*/*      OS/VS1 RELEASE 5, OS/VS2 RELEASE 4, 12/05/75, LEVEL=16      */
*/*                                                                  */
*/*  METHOD OF ACCESS                                                */
*/*      PL/S - DCL CVTPTR PTR                                       */
*/*      BAL  - DSECT=YES SHOULD BE SPECIFIED ON MACRO CALL EXCEPT   */
*/*             WHEN CALLED DURING SYSGEN TO CREATE CSECT.  CVT FOR  */
*/*             OS/VS2 IS MAPPED UNLESS SYS=AOS1 IS SPECIFIED.  THE  */
*/*             PREFIX IS NOT MAPPED UNLESS PREFIX=YES IS SPECIFIED. */
*/*             A USING ON CVTMAP OR DSECT NAME WILL ESTABLISH       */
*/*             ADDRESSABILITY FOR ALL SYMBOLS EXCEPT IN THE 2       */
*/*             EXTENSIONS.  TO ESTABLISH ADDRESSABILITY FOR THE     */
*/*             OS - OS/VS COMMON EXTENSION, YOU SHOULD CODE         */
*/*                                                                  */
*/*             L     REG,CVTEXT1                                    */
*/*             USING CVTXTNT1,REG                                   */
*/*                                                                  */
*/*             TO ESTABLISH ADDRESSABILITY FOR THE OS/VS1 - OS/VS2  */
*/*             COMMON EXTENSION, YOU SHOULD CODE                    */
*/*                                                                  */
*/*             L     REG,CVTEXT2                                    */
*/*             USING CVTXTNT2,REG                                   */
*/*                                                                  */
*/*             WHERE REG IN EITHER CASE IS ANY REGISTER OTHER       */
*/*             THAN ZERO.                                           */
*/*                                                                  */
*/*             WHEN LISTING IS SUPPRESSED, YOU CAN DETERMINE WHICH  */
*/*             DSECT A SYMBOL IS IN BY USING THE STATEMENT NUMBER   */
*/*             IN THE DEFN COLUMN IN THE CROSS REFERENCE LISTING.   */
*/*             FOR EXAMPLE, ANY SYMBOL DEFINED BETWEEN THE          */
*/*             STATEMENT NUMBERS FOR CVTXTNT1 AND CVTXTNT2 IS IN    */
*/*             THE OS - OS/VS COMMON EXTENSION.                     */
*/*                                                                  */
*/*  F.E.'S                                                          */
*/*      MICROFICHE LISTING - CVT                                    */
*/*                                                                  */
*/*  DEVELOPERS                                                      */
*/*      BAL LISTING  - SPECIFY LIST=YES ON MACRO CALL               */
*/*      PL/S LISTING - SPECIFY %IHALIST='YES' BEFORE INCLUDE        */
*/*                                                                  */
*/*      FOR INTEGRATION, A LISTING MUST NOT BE REQUESTED UNLESS     */
*/*      YOUR MODULE CREATES THE CSECT.                              */
*                                                                  0065
*                                                                  0065
*/*                    CVT PROPER                                    */
*                                                                  0065
*   DECLARE                                                        0065
*     1 CVTMAP BASED(CVTPTR) BDY(WORD),                            0065
*      2 CVT CHAR(0) BDY(WORD),     /* BEGINNING OF CVT MDC150       */
*      2 CVTTCBP PTR(31),           /* ADDRESS OF A DOUBLE WORD, THE
*                                      FIRST CONTAINING THE NEXT-TO-
*                                      BE-DISPATCHED TCB ADDRESS. THE
*                                      SECOND CONTAINING THE LAST  0065
*                                      (CURRENT) TCB ADDRESS. BOTH 0065
*                                      WORDS ARE IDENTICAL UNLESS THE
*                                      TASK GOES INTO A WAIT STATE.
*                                      WHEN IN A WAIT STATE, THE   0065
*                                      FIRST WORD IS SET TO ZERO   0065
*                                      UNTIL THE WAITING IS OVER AND
*                                      THEN BOTH WORDS ARE ONCE AGAIN
*                                      IDENTICAL. (OS/VS1) ADDRESS OF
*                                      4-WORD LIST OF ADDRESSES - THE
*                                      NEXT TCB, THE CURRENT TCB, THE
*                                      NEXT ASCB AND THE CURRENT   0065
*                                      ASCB, IN THAT ORDER (OS/VS2)
*                                      MDC026                        */
*      2 CVT0EF00 PTR(31),          /* ADDRESS OF ROUTINE TO SCHEDULE
*                                      ASYNCHRONOUS EXITS            */
*      2 CVTLINK PTR(31),           /* ADDRESS OF DCB FOR          0065
*                                      SYS1.LINKLIB DATA SET         */
*      2 CVTJOB PTR(31),            /* ADDRESS OF QUEUE MANAGER    0065
*                                      RESIDENT DATA AREA (QMRES)  0065
*                                      (OS/VS1) (MDC083)       XM4042*/
*      2 CVTBUF PTR(31),            /* ADDRESS OF THE BUFFER OF THE
*                                      RESIDENT CONSOLE INTERRUPT  0065
*                                      ROUTINE                       */
*      2 CVTXAPG PTR(31),           /* ADDRESS OF I/O SUPERVISOR   0065
*                                      APPENDAGE VECTOR TABLE        */
*      2 CVT0VL00 PTR(31),          /* ADDRESS OF ENTRY POINT OF THE
*                                      TASK SUPERVISOR'S ADDRESS   0065
*                                      VALIDITY CHECKING ROUTINE     */
*      2 CVTPCNVT PTR(31),          /* ADDRESS OF ENTRY POINT OF THE
*                                      ROUTINE WHICH CONVERTS A    0065
*                                      RELATIVE TRACK ADDRESS (TTR)
*                                      TO AN ABSOLUTE TRACK ADDRESS
*                                      (MBBCCHHR)                    */
*      2 CVTPRLTV PTR(31),          /* ADDRESS OF ENTRY POINT OF THE
*                                      ROUTINE WHICH CONVERTS AN   0065
*                                      ABSOLUTE TRACK ADDRESS      0065
*                                      (MBBCCHHR) TO A RELATIVE TRACK
*                                      ADDRESS (TTR)                 */
*      2 CVTILK1 PTR(31),           /* ADDRESS OF THE CHANNEL AND  0065
*                                      CONTROL UNIT PORTION OF THE 0065
*                                      UCB LOOKUP TABLE              */
*      2 CVTILK2 PTR(31),           /* ADDRESS OF THE UCB HALFWORD 0065
*                                      ADDRESS LIST PORTION OF THE 0065
*                                      UCB LOOKUP TABLE              */
*      2 CVTXTLER PTR(31),          /* ADDRESS OF ERROR RECOVERY   0065
*                                      PROCEDURE (ERP) LOADER      0065
*                                      (IECVERPL) ENTRY POINT      0065
*                                      IECXTLER (MDC349)     @Z40AQ9A*/
*      2 CVTSYSAD PTR(31),          /* ADDRESS OF THE SYSTEM       0065
*                                      RESIDENCE VOLUME ENTRY IN THE
*                                      UCB LOOKUP TABLE              */
*      2 CVTBTERM PTR(31),          /* ADDRESS OF ENTRY POINT OF THE
*                                      ABTERM ROUTINE                */
*      2 CVTDATE CHAR(4) BDY(WORD), /* CURRENT DATE IN PACKED DECIMAL*/
*      2 CVTMSLT PTR(31),           /* ADDRESS OF THE MASTER COMMON
*                                      AREA IN MASTER SCHEDULER    0065
*                                      RESIDENT DATA AREA. NOTE - USE
*                                      CVTMSER INSTEAD TO ADDRESS  0065
*                                      MASTER SCHEDULER RESIDENT DATA
*                                      AREA.                         */
*      2 CVTZDTAB PTR(31),          /* ADDRESS OF I/O DEVICE       0065
*                                      CHARACTERISTIC TABLE          */
*      2 CVTXITP PTR(31),           /* ADDRESS OF ERROR INTERPRETER
*                                      ROUTINE                       */
*      2 CVTDAR PTR(31),            /* SAME AS CVTDARA BELOW (OS/VS1)
*                                      MDC029                        */
*       3 CVTFLGS1 BIT(8),          /* FLAG BYTE (OS/VS1) MDC030     */
*        4 CVTDMPLK BIT(1),         /* SVC DUMP IS IN PROGRESS     0065
*                                      (OS/VS1) MDC030               */
*        4 CVTRSV01 BIT(1),         /* RESERVED                      */
*        4 CVTRSV02 BIT(1),         /* RESERVED                      */
*        4 CVTRSV03 BIT(1),         /* RESERVED                      */
*        4 CVTRSV04 BIT(1),         /* RESERVED                      */
*        4 CVTRSV05 BIT(1),         /* RESERVED                      */
*        4 CVTRSV06 BIT(1),         /* RESERVED                      */
*        4 CVTRSV07 BIT(1),         /* RESERVED                      */
*       3 CVTDARA PTR(24),          /* ADDRESS OF THE SYS1.DUMP I/O
*                                      CONTROL BLOCKS NEEDED BY    0065
*                                      ABEND'S DAMAGE ASSESSMENT   0065
*                                      ROUTINE (DAR) (OS/VS1) MDC029 */
*      2 CVT0FN00 PTR(31),          /* ADDRESS OF ENTRY POINT OF THE
*                                      FINCH ROUTINE (OS/VS1)        */
*      2 CVTEXIT CHAR(2) BDY(WORD), /* AN SVC 3 INSTRUCTION. EXIT TO
*                                      DISPATCHER.                   */
*      2 CVTBRET CHAR(2) BDY(WORD,3),/* A BCR 15,14 INSTRUCTION.   0065
*                                      RETURN TO CALLER (USED BY DATA
*                                      MANAGEMENT ROUTINES)          */
*      2 CVTSVDCB PTR(31),          /* ADDRESS OF THE DCB FOR THE  0065
*                                      SYS1.SVCLIB DATA SET          */
*      2 CVTTPC PTR(31),            /* ADDRESS OF THE TIMER        0065
*                                      SUPERVISOR WORK AREA          */
*      2 CVTPBLDL PTR(31),          /* ADDRESS OF BRANCH AND LINK  0065
*                                      (BALR) ENTRY POINT OF THE BLDL
*                                      ROUTINE (OS/VS1) MDC103       */
*      2 CVTSJQ PTR(31),            /* ADDRESS OF THE SELECTED JOB 0065
*                                      QUEUE (OS/VS1)                */
*      2 CVTCUCB PTR(31),           /* ADDRESS OF THE TABLE THAT   0065
*                                      CONTAINS THE CURRENT CONSOLE
*                                      UCB ADDRESSES                 */
*      2 CVTQTE00 PTR(31),          /* ADDRESS OF THE TIMER ENQUEUE
*                                      ROUTINE FOR INTERVAL TIMER    */
*      2 CVTQTD00 PTR(31),          /* ADDRESS OF THE TIMER DEQUEUE
*                                      ROUTINE FOR INTERVAL TIMER    */
*      2 CVTSTB PTR(31),            /* ADDRESS OF THE I/O DEVICE   0065
*                                      STATISTICS TABLE              */
*      2 CVTDCB CHAR(1) BDY(WORD),  /* OPERATING SYSTEM CONFIGURATION*/
*        4 CVTRSV08 BIT(1),         /* RESERVED                      */
*        4 CVT1SSS BIT(1),          /* PCP                           */
*        4 CVT2SPS BIT(1),          /* MFT, OS/VS1                   */
*        4 CVT4MS1 BIT(1),          /* MVT, OS/VS2                   */
*        4 CVTRSV09 BIT(1),         /* RESERVED                      */
*        4 CVT4MPS BIT(1),          /* MODEL 65 MULTIPROCESSING      */
*        4 CVT6DAT BIT(1),          /* DYNAMIC ADDRESS TRANSLATION BY
*                                      CPU (OS/VS1, OS/VS2)          */
*        4 CVTMVS2 BIT(1),          /* MULTIPLE MEMORY OPTION OF   0065
*                                      OS/VS2 IS PRESENT MDC131      */
*      2 CVTDCBA PTR(24),           /* ADDRESS OF THE DCB FOR THE  0065
*                                      SYS1.LOGREC (OUTBOARD       0065
*                                      RECORDER) DATA SET FOR SYSTEM
*                                      ENVIRONMENT RECORDING (SER)   */
*      2 CVTIOQET PTR(31),          /* ADDRESS OF IOS REQUEST ELEMENT
*                                      TABLE (OS/VS1) MDC020         */
*      2 CVTIXAVL PTR(31),          /* ADDRESS OF THE I/O          0065
*                                      SUPERVISOR'S FREELIST POINTER
*                                      WHICH CONTAINS THE ADDRESS OF
*                                      THE NEXT REQUEST ELEMENT    0065
*                                      (OS/VS1) ADDRESS OF THE I/O 0065
*                                      SUPERVISOR'S COMMUNICATION  0065
*                                      AREA (IOCOM) (OS/VS2)         */
*      2 CVTNUCB PTR(31),           /* LOWEST ADDRESS NOT IN THE   0065
*                                      NUCLEUS (ON PAGE BOUNDARY FOR
*                                      OS/VS1) (ON SEGMENT BOUNDARY
*                                      FOR OS/VS2) (MDC318)  @Z30AQ9A*/
*      2 CVTFBOSV PTR(31),          /* ADDRESS OF PROGRAM FETCH    0065
*                                      ROUTINE                       */
*      2 CVT0DS PTR(31),            /* ADDRESS OF ENTRY POINT OF THE
*                                      DISPATCHER                    */
*      2 CVTILCH PTR(31),           /* ADDRESS OF THE LOGICAL CHANNEL
*                                      WORD TABLE                    */
*      2 CVTIERLC PTR(31),          /* ADDRESS OF THE ASYNCHRONOUS 0065
*                                      EXIT QUEUE (OS/VS1) (MDC218)
*                                                              YM4043*/
*       3 CVTRV516 PTR(31),         /* ** CVTIERLC FIELD UNUSED IN 0065
*                                      MVS ** (MDC218)         YM4043*/
*      2 CVTMSER PTR(31),           /* ADDRESS OF DATA AREA OF MASTER
*                                      SCHEDULER RESIDENT DATA AREA  */
*      2 CVT0PT01 PTR(31),          /* ADDRESS OF BRANCH ENTRY POINT
*                                      OF POST ROUTINE               */
*      2 CVTRSV11 PTR(31),          /* ** CVTTRMTB FIELD UNUSED IN 0065
*                                      OS/VS **                      */
*      2 CVTHEAD PTR(31),           /* ADDRESS OF THE HIGHEST      0065
*                                      PRIORITY TCB IN THE READY   0065
*                                      QUEUE (OS/VS1) MDC025         */
*      2 CVTMZ00 PTR(31),           /* HIGHEST ADDRESS IN VIRTUAL  0065
*                                      STORAGE FOR THE MACHINE       */
*      2 CVT1EF00 PTR(31),          /* ADDRESS OF ROUTINE WHICH    0065
*                                      CREATES IRB'S FOR EXITS       */
*      2 CVTQOCR PTR(31),           /* GRAPHICS INTERFACE TASK (GFX)
*                                      FIELD. ADDRESS OF SEVENTH WORD
*                                      OF GFX PARAMETER LIST, IF GFX
*                                      IS ACTIVE. ZERO IF GFX IS NOT
*                                      ACTIVE.                       */
*      2 CVTQMWR PTR(31),           /* ADDRESS OF QUEUE MANAGER'S  0065
*                                      SYSTEM OUTPUT COMMUNICATIONS-
*                                      DATA-AREA (CDA), WHICH IS   0065
*                                      STORED ON AN EXTERNAL DEVICE  */
*      2 CVTSNCTR FIXED(15),        /* SERIAL NUMBER COUNTER FOR   0065
*                                      ASSIGNING SERIAL NUMBERS TO 0065
*                                      NON-SPECIFIC, UNLABELED     0065
*                                      MAGNETIC TAPE VOLUMES         */
*      2 CVTOPTA CHAR(1),           /* OPTION INDICATORS             */
*       3 CVTCCH BIT(1),            /* CHANNEL CHECK HANDLER (CCH) 0065
*                                      OPTION PRESENT - RECOVERY   0065
*                                      MANAGEMENT SUPPORT (RMS)    0065
*                                                              XM4686*/
*       3 CVTAPR BIT(1),            /* ALTERNATE PATH RETRY (APR)  0065
*                                      OPTION PRESENT - RECOVERY   0065
*                                      MANAGEMENT SUPPORT (RMS)      */
*       3 CVTDDR BIT(1),            /* DYNAMIC DEVICE RECONFIGURATION
*                                      (DDR) OPTION PRESENT -      0065
*                                      RECOVERY MANAGEMENT SUPPORT 0065
*                                      (RMS) (OS/VS1) DDR          0065
*                                      SYSTEM-INITIATED SWAP ACTIVE
*                                      (OS/VS2) MDC126               */
*       3 CVTNIP BIT(1),            /* NIP IS EXECUTING              */
*       3 CVTRSV12 BIT(1),          /* RESERVED                      */
*       3 CVTRSV13 BIT(1),          /* RESERVED                      */
*       3 CVTASCII BIT(1),          /* ASCII TAPE PROCESSING IS    0065
*                                      GENERATED IN THIS SYSTEM      */
*       3 CVTXPFP BIT(1),           /* CPU HAS EXTENDED PRECISION  0065
*                                      FLOATING POINT FEATURE        */
*      2 CVTOPTB CHAR(1),           /* MISCELLANEOUS FLAGS           */
*       3 CVTPROT BIT(1),           /* CPU HAS STORE PROTECTION    0065
*                                      FEATURE (OS/VS1)              */
*       3 CVTCTIMS BIT(1),          /* IF ON, HARDWARE HAS THE CLOCK
*                                      COMPARATOR AND CPU TIMER    0065
*                                      FEATURE INSTALLED, AND OS/VS1
*                                      SYSGEN HAS SPECIFIED THIS   0065
*                                      FEATURE (OS/VS1) MDC127       */
*       3 CVTTOD BIT(1),            /* CPU HAS TIME-OF-DAY CLOCK   0065
*                                      FEATURE                       */
*       3 CVTNLOG BIT(1),           /* SYS1.LOGREC IS UNAVAILABLE FOR
*                                      ERROR RECORDING. ALWAYS SET TO
*                                      ZERO FOR OS/VS1 ICB382        */
*       3 CVTAPTHR BIT(1),          /* NIP SETS THIS BIT TO 1 WHEN 0065
*                                      DEVICE TESTING IS COMPLETE. IF
*                                      1, I/O SUPERVISOR USES AN   0065
*                                      ALTERNATE PATH TO A DEVICE  0065
*                                      WHEN A CONDITION CODE OF 3  0065
*                                      EXISTS. THIS BIT IS RESET BY
*                                      NIP TO 0 AFTER THE LINK PACK
*                                      AREA IS INITIALIZED.    YM2670*/
*       3 CVTFP BIT(1),             /* CPU HAS FETCH PROTECTION    0065
*                                      FEATURE (OS/VS1) ICB427       */
*       3 CVTRSV16 BIT(1),          /* RESERVED                      */
*       3 CVTRSV17 BIT(1),          /* RESERVED                      */
*      2 CVTQCDSR PTR(31),          /* CDE SEARCH ROUTINE ADDRESS  0065
*                                      (OS/VS2) ADDRESS OF THE     0065
*                                      ROUTINE THAT SEARCHES THE   0065
*                                      REENTERABLE LOAD MODULE QUEUE
*                                      (OS/VS1)                      */
*      2 CVTQLPAQ PTR(31),          /* ADDRESS OF POINTER TO MOST  0065
*                                      RECENT ENTRY ON LINK PACK AREA
*                                      CDE QUEUE (OS/VS2) ADDRESS OF
*                                      THE REENTERABLE LOAD MODULE 0065
*                                      QUEUE (OS/VS1)                */
*      2 CVTRSV18 PTR(31),          /* ** CVTMPCVT FIELD UNUSED IN 0065
*                                      OS/VS **                      */
*      2 CVTSMCA PTR(31),           /* ADDRESS OF THE SYSTEM       0065
*                                      MANAGEMENT CONTROL AREA (SMCA)
*                                      IF THE SYSTEM MANAGEMENT    0065
*                                      FACILITIES (SMF) OPTION IS  0065
*                                      PRESENT IN THE SYSTEM.      0065
*                                      OTHERWISE, ZERO.              */
*      2 CVTABEND PTR(31),          /* ADDRESS OF SECONDARY CVT FOR
*                                      ABEND IN EOT (OS/VS2) USED BY
*                                      AN INTERNAL ABEND TRACE     0065
*                                      ROUTINE FOR DEBUG PURPOSES  0065
*                                      (OS/VS1)                XM0615*/
*      2 CVTUSER PTR(31),           /* A WORD AVAILABLE TO THE USER  */
*      2 CVTMDLDS PTR(31),          /* RESERVED FOR MODEL-DEPENDENT
*                                      SUPPORT                       */
*      2 CVTQABST CHAR(2) BDY(WORD),/* AN SVC 13 (ABEND) INSTRUCTION
*                                      (OS/VS2) RESERVED (OS/VS1)    */
*      2 CVTLNKSC CHAR(2) BDY(WORD,3),/* AN SVC 6 (LINK) INSTRUCTION
*                                      ICB369                        */
*      2 CVTTSCE PTR(31),           /* ADDRESS OF THE FIRST TIME   0065
*                                      SLICE CONTROL ELEMENT (TSCE)  */
*      2 CVTPATCH PTR(31),          /* ADDRESS OF A 200-BYTE FE PATCH
*                                      AREA                          */
*      2 CVTRMS PTR(31),            /* RECOVERY MANAGEMENT SUPPORT 0065
*                                      (RMS) COMMUNICATIONS VECTOR.
*                                      ADDRESS OF A MACHINE STATUS 0065
*                                      BLOCK.                        */
*      2 CVTRV515 PTR(31),          /* ** CVTTSCVT FIELD UNUSED IN 0065
*                                      MVS ** (MDC037)       @Z40AQ9A*/
*      2 CVT0SCR1 PTR(31),          /* ADDRESS OF THE SECTOR       0065
*                                      CALCULATION ROUTINE FOR     0065
*                                      ROTATIONAL POSITION SENSING 0065
*                                      (RPS)                         */
*      2 CVTGTF PTR(31),            /* GENERALIZED TRACE FACILITY  0065
*                                      (GTF) CONTROL WORD ICB312     */
*       3 CVTGTFST BIT(8),          /* GTF FLAG BYTE ICB312          */
*        4 CVTGTFS BIT(2),          /* GTF STATUS (OS/VS1) MDC088    */
*         5 CVTGTFAV BIT(1),        /* IF ZERO, GTF NOT ACTIVE. IF 0065
*                                      ONE, GTF ACTIVE. (OS/VS2)   0065
*                                      MDC098                        */
*         5 CVTRV315 BIT(1),        /* RESERVED (OS/VS2)             */
*        4 CVTSTATE BIT(1),         /* GTF IS IN CONTROL PROCESSING A
*                                      HOOK (OS/VS1) MDC093          */
*         5 CVTRV316 BIT(1),        /* RESERVED (OS/VS2)             */
*        4 CVTTMODE BIT(1),         /* IF 0, MODE=INT SPECIFIED. IF
*                                      1, MODE=EXT SPECIFIED WHICH 0065
*                                      MEANS TRACE DATA IS TO BE   0065
*                                      WRITTEN TO AN EXTERNAL DEVICE.
*                                      (OS/VS1) MDC094               */
*         5 CVTRV317 BIT(1),        /* RESERVED (OS/VS2)             */
*        4 CVTFORM BIT(1),          /* TRACE DATA IS TO BE FORMATTED
*                                      ON ABNORMAL TERMINATION     0065
*                                      (OS/VS1) MDC095               */
*         5 CVTRV318 BIT(1),        /* RESERVED (OS/VS2)             */
*        4 CVTUSR BIT(1),           /* TRACE=USR SPECIFIED.        0065
*                                      USER-REQUESTED TRACE DATA IS
*                                      TO BE INCLUDED IN THE TRACE 0065
*                                      DATA SET. (MDC317)    @Z30AP9A*/
*        4 CVTRNIO BIT(1),          /* GTF IS ACTIVE AND TRACING RNIO
*                                      EVENTS MDC187                 */
*        4 CVTRSV27 BIT(1),         /* RESERVED                      */
*       3 CVTGTFA PTR(24),          /* ADDRESS OF THE MONITOR CALL 0065
*                                      VECTOR TABLE (OS/VS1) ADDRESS
*                                      OF MAIN MONITOR CALL ROUTING
*                                      TABLE, MCHEAD (OS/VS2) MDC156 */
*      2 CVTAQAVT PTR(31),          /* ADDRESS OF THE FIRST WORD OF
*                                      THE TCAM DISPATCHER WHICH   0065
*                                      CONTAINS THE ADDRESS OF THE 0065
*                                      ADDRESS VECTOR TABLE (AVT). IF
*                                      ZERO, TCAM IS NOT STARTED     */
*       3 CVTTCMFG CHAR(1),         /* TCAM FLAGS                    */
*        4 CVTTCRDY BIT(1),         /* TCAM IS READY TO ACCEPT USERS */
*        4 CVTRSV28 BIT(1),         /* RESERVED                      */
*        4 CVTRSV29 BIT(1),         /* RESERVED                      */
*        4 CVTRSV30 BIT(1),         /* RESERVED                      */
*        4 CVTRSV31 BIT(1),         /* RESERVED                      */
*        4 CVTRSV32 BIT(1),         /* RESERVED                      */
*        4 CVTRSV33 BIT(1),         /* RESERVED                      */
*        4 CVTRSV34 BIT(1),         /* RESERVED                      */
*       3 CVTAQAVB PTR(24),         /* SAME AS CVTAQAVT ABOVE        */
*      2 CVTVOLM2 PTR(31),          /* ADDRESS OF TABLE FOR POWER  0065
*                                      WARNING FEATURE (PWF) (OS/VS2)
*                                      (MDC308)              @Z30AQ9A*/
*       3 CVTTATA PTR(31),          /* ADDRESS OF THE FIRST ENTRY IN
*                                      THE TCB ADDRESS TABLE. THE  0065
*                                      FIRST ENTRY IS FOR PARTITION
*                                      0. (OS/VS1)                   */
*        4 CVTTSKS PTR(8),          /* MAXIMUM ALLOWABLE NUMBER OF 0065
*                                      ENTRIES IN THE TCB ADDRESS  0065
*                                      TABLE (OS/VS1)                */
*         5 CVTVOLF2 BIT(8),        /* PWF FLAG BYTE. THIS BYTE IS 0065
*                                      OVERLAID BY CVTVOLM2 AFTER PWF
*                                      INITIALIZATION. (OS/VS2)    0065
*                                      (MDC309)              @Z30AQ9A*/
*          6 CVTVOLI2 BIT(1),       /* PWF INITIALIZATION HAS NOT  0065
*                                      OCCURRED (OS/VS2) (MDC310)  0065
*                                                            @Z30AQ9A*/
*        4 CVTTAT PTR(24),          /* SAME AS CVTTATA ABOVE         */
*         5 CVTVOLT2 PTR(24),       /* PWF RECHECK TIME DELAY. THIS
*                                      VALUE IS OVERLAID BY CVTVOLM2
*                                      AFTER PWF INITIALIZATION.   0065
*                                      (OS/VS2) (MDC311)     @Z30AQ9A*/
*      2 CVTATER PTR(31),           /* ADDRESS OF THE SYSTEM ERROR 0065
*                                      TCB. THE PURGE ROUTINE USES 0065
*                                      THIS FIELD TO ACCESS THE SIRB.
*                                      (OS/VS1) ICB346               */
*       3 CVTSYST PTR(8),           /* NUMBER OF ENTRIES IN THE TCB
*                                      ADDRESS TABLE FOR TCB'S     0065
*                                      CREATED DURING SYSTEM       0065
*                                      GENERATION (OS/VS1)           */
*       3 CVTATERA PTR(24),         /* SAME AS CVTATER ABOVE         */
*      2 CVTEXT1 PTR(31),           /* ADDRESS OF OS - OS/VS COMMON
*                                      EXTENSION ICB421              */
*      2 CVTCBSP PTR(31),           /* ADDRESS OF ACCESS METHOD    0065
*                                      CONTROL BLOCK STRUCTURE MDC195*/
*      2 CVTPURG PTR(31),           /* ADDRESS OF SUBSYSTEM PURGE  0065
*                                      ROUTINE ICB330                */
*       3 CVTRSV35 PTR(8),          /* RESERVED ICB330               */
*       3 CVTPURGA PTR(24),         /* ADDRESS OF SUBSYSTEM PURGE  0065
*                                      ROUTINE ICB330                */
*      2 CVTAMFF CHAR(4),           /* RESERVED FOR ACCESS METHOD  0065
*                                      FLAGS ICB436                  */
*      2 CVTQMSG PTR(31),           /* ADDRESS OF INFORMATION TO BE
*                                      PRINTED BY ABEND ICB307       */
*       3 CVTRSV36 PTR(8),          /* RESERVED ICB307               */
*       3 CVTQMSGA PTR(24),         /* ADDRESS OF INFORMATION TO BE
*                                      PRINTED BY ABEND ICB307       */
*      2 CVTDMSR PTR(31),           /* SAME AS CVTDMSRA BELOW ICB346 */
*       3 CVTRSV37 PTR(8),          /* RESERVED (OS/VS1) ICB346      */
*        4 CVTDMSRF BIT(8),         /* OPEN/CLOSE/EOV FLAG BYTE.   0065
*                                      SETTING BOTH BIT 0 AND BIT 1
*                                      ON WILL CAUSE BOTH KINDS OF 0065
*                                      DUMPS TO BE TAKEN. THESE BITS
*                                      ARE USED DURING TESTING AND 0065
*                                      DEBUGGING WHEN OTHER DEBUG  0065
*                                      METHODS ARE INEFFECTIVE.    0065
*                                      (OS/VS2) (MDC350)     @Z40AQ9A*/
*         5 CVTSDUMP BIT(1),        /* SET BY COREZAP. WILL CAUSE AN
*                                      SDUMP TO BE TAKEN AND IEC999I
*                                      MESSAGE ISSUED FOR EVERY ABEND
*                                      ISSUED WITHIN AN            0065
*                                      OPEN/CLOSE/EOV OR DADSM     0065
*                                      FUNCTION. (OS/VS2) (MDC351) 0065
*                                                            @Z40AQ9A*/
*         5 CVTUDUMP BIT(1),        /* SET BY COREZAP. WILL CAUSE AN
*                                      ABEND DUMP TO BE TAKEN FOR  0065
*                                      EVERY ABEND ISSUED WITHIN AN
*                                      OPEN/CLOSE/EOV OR DADSM     0065
*                                      FUNCTION. (OS/VS2) (MDC352) 0065
*                                                            @Z40AQ9A*/
*         5 CVTRV629 BIT(1),        /* RESERVED (OS/VS2)     @Z40AQ9A*/
*         5 CVTRV630 BIT(1),        /* RESERVED (OS/VS2)     @Z40AQ9A*/
*         5 CVTRV631 BIT(1),        /* RESERVED (OS/VS2)     @Z40AQ9A*/
*         5 CVTRV632 BIT(1),        /* RESERVED (OS/VS2)     @Z40AQ9A*/
*         5 CVTRV633 BIT(1),        /* RESERVED (OS/VS2)     @Z40AQ9A*/
*         5 CVTRV634 BIT(1),        /* RESERVED (OS/VS2)     @Z40AQ9A*/
*       3 CVTDMSRA PTR(24),         /* ADDRESS OF THE OPEN/CLOSE/EOV
*                                      SUPERVISORY ROUTINE IN THE  0065
*                                      NUCLEUS. THIS ROUTINE HANDLES
*                                      THE ROUTING OF CONTROL AMONG
*                                      THE I/O SUPPORT ROUTINES.   0065
*                                      ICB346                        */
*      2 CVTRSV38 PTR(31),          /* RESERVED                      */
*      2 CVTRSV39 PTR(31),          /* RESERVED                      */
*/*            OS/VS1 - OS/VS2 COMMON SECTION                        */
*                                                                  0065
*      2 CVTREAL PTR(31),           /* ADDRESS OF THE VIRTUAL STORAGE
*                                      BYTE FOLLOWING THE HIGHEST  0065
*                                      VIRTUAL=REAL STORAGE ADDRESS
*                                      ICB368                        */
*      2 CVTPTRV PTR(31),           /* ADDRESS OF PAGING SUPERVISOR
*                                      GENERAL ROUTINE TO TRANSLATE
*                                      REAL ADDRESSES TO VIRTUAL   0065
*                                      ADDRESSES                     */
*      2 CVTMODE PTR(31),           /* ADDRESS OF ROUTINE TO CHANGE
*                                      SYSTEM MASK (OS/VS1) (MDC217)
*                                                              YM4244*/
*      2 CVTJESCT PTR(31),          /* ADDRESS OF JOB ENTRY SUBSYSTEM
*                                      (JES) CONTROL TABLE           */
*      2 CVTJEPS PTR(31),           /* ADDRESS OF JOB ENTRY        0065
*                                      PERIPHERAL SERVICES (JEPS)  0065
*                                      MONITOR TCB (OS/VS1)    YM2702*/
*      2 CVTTZ FIXED(31),           /* DIFFERENCE BETWEEN LOCAL TIME
*                                      AND GREENWICH MEAN TIME IN  0065
*                                      BINARY UNITS OF 1.048576    0065
*                                      SECONDS                       */
*      2 CVTMCHPR PTR(31),          /* ADDRESS OF MACHINE CHECK    0065
*                                      PARAMETER LIST                */
*      2 CVTEORM PTR(31),           /* HIGHEST REAL ADDRESS IN MAIN
*                                      STORAGE (OS/VS1) POTENTIAL  0065
*                                      REAL HIGH STORAGE ADDRESS   0065
*                                      (OS/VS2) MDC087               */
*      2 CVTERPV PTR(31),           /* ADDRESS OF I/O SUPERVISOR   0065
*                                      SUBROUTINE TO CONVERT CCW DATA
*                                      ADDRESSES TO VIRTUAL ADDRESSES
*                                      (OS/VS1) (MDC219)       YM4043*/
*       3 CVTRV517 PTR(31),         /* ** CVTERPV FIELD UNUSED IN MVS
*                                      ** (MDC219)             YM4043*/
*      2 CVTINTLA PTR(31),          /* ADDRESS OF A TIME INTERVAL. 0065
*                                      I/O LOAD BALANCING COUNTS THE
*                                      NUMBER OF EXCP'S ISSUED DURING
*                                      THIS TIME INTERVAL AND USES 0065
*                                      THE VALUE IN DETERMINING THE
*                                      AMOUNT OF I/O ACTIVITY IN THE
*                                      SYSTEM. (OS/VS1) (MDC220)   0065
*                                                              YM4043*/
*       3 CVTRV518 PTR(31),         /* ** CVTINTLA FIELD UNUSED IN 0065
*                                      MVS ** (MDC220)         YM4043*/
*      2 CVTAPF PTR(31),            /* SAME AS CVTAPFA BELOW ICB360  */
*       3 CVTRSV40 PTR(8),          /* RESERVED ICB360               */
*       3 CVTAPFA PTR(24),          /* ADDRESS OF BRANCH ENTRY POINT
*                                      IN AUTHORIZED PROGRAM FACILITY
*                                      (APF) ROUTINE                 */
*      2 CVTEXT2 PTR(31),           /* ADDRESS OF OS/VS1 - OS/VS2  0065
*                                      COMMON EXTENSION ICB330       */
*       3 CVTRSV41 PTR(8),          /* RESERVED ICB330               */
*       3 CVTEXT2A PTR(24),         /* SAME AS CVTEXT2 ABOVE ICB330  */
*      2 CVTHJES PTR(31),           /* SAME AS CVTHJESA BELOW ICB454 */
*       3 CVTRSV42 PTR(8),          /* RESERVED ICB454               */
*       3 CVTHJESA PTR(24),         /* ADDRESS OF OPTIONAL JOB ENTRY
*                                      SUBSYSTEM (JES) COMMUNICATION
*                                      VECTOR TABLE ICB454           */
*      2 CVTRSV43 FIXED(15),        /* RESERVED                      */
*      2 CVTRSV44 FIXED(15),        /* RESERVED                      */
*      2 CVTRSV45 PTR(31),          /* RESERVED                      */
*      2 CVTRSV46 PTR(31),          /* RESERVED                      */
*/*            OS/VS1 OVERLAY                                        */
*                                                                  0065
*      2 CVTPGSIA PTR(31),          /* ADDRESS OF PAGING SUPERVISOR
*                                      INFORMATION AREA              */
*      2 CVTPCVT PTR(31),           /* ADDRESS OF PAGED CVT EXTENSION*/
*      2 CVTA1F1 CHAR(1),           /* PAGE FAULT FLAGS              */
*       3 CVTPFSW BIT(1),           /* ONLY THE PAGING TASK MAY BE 0065
*                                      DISPATCHED                    */
*       3 CVTSRSW BIT(1),           /* NO TASK EXCEPT THE PAGING TASK
*                                      MAY EXECUTE DISABLED CODE     */
*       3 CVTRSV47 BIT(1),          /* RESERVED                      */
*       3 CVTRSV48 BIT(1),          /* RESERVED                      */
*       3 CVTRSV49 BIT(1),          /* RESERVED                      */
*       3 CVTRSV50 BIT(1),          /* RESERVED                      */
*       3 CVTRSV51 BIT(1),          /* RESERVED                      */
*       3 CVTRSV52 BIT(1),          /* RESERVED                      */
*      2 CVTSYSK CHAR(1),           /* SYSTEM LOCK. IF NOT ZERO, ONLY
*                                      THE PAGING TASK MAY BE      0065
*                                      DISPATCHED                    */
*       3 CVTRSV53 BIT(1),          /* RESERVED                      */
*       3 CVTRSV54 BIT(1),          /* RESERVED                      */
*       3 CVTRSV55 BIT(1),          /* RESERVED                      */
*       3 CVTRSV56 BIT(1),          /* RESERVED                      */
*       3 CVTSLKR BIT(1),           /* MACHINE CHECK HANDLING IS IN
*                                      PROGRESS ICB320               */
*       3 CVTSLKQ BIT(1),           /* SYSTEM QUEUE AREA (SQA) HAS 0065
*                                      BEEN EXHAUSTED                */
*       3 CVTSLKP BIT(1),           /* LAST PAGING CONTROL BLOCK   0065
*                                      (PCB) HAS BEEN USED           */
*       3 CVTSLKO BIT(1),           /* A ROUTINE RUNNING DISABLED HAS
*                                      PRODUCED A PAGE FAULT         */
*      2 CVTSULK FIXED(15),         /* SUPERVISOR LOCK. NUMBER OF  0065
*                                      TASKS ATTEMPTING TO EXECUTE 0065
*                                      DISABLED ROUTINES. IF NOT   0065
*                                      ZERO, ONLY ENABLED TASKS MAY
*                                      RUN.                          */
*      2 CVTSMF PTR(31),            /* ADDRESS OF SYSTEM MANAGEMENT
*                                      FACILITIES (SMF) TCB ICB395   */
*      2 CVTPNWFR PTR(31),          /* ADDRESS OF ROUTINE WHICH FREES
*                                      THE 'EMERGENCY' WORK AREA   0065
*                                      (ICB413)                XM2452*/
*      2 CVTDDCE PTR(31),           /* ADDRESS OF DYNAMIC DISPATCHING
*                                      CONTROL ELEMENT ICB466        */
*      2 CVTRSV57 FIXED(15),        /* RESERVED                      */
*      2 CVTRSV58 FIXED(15),        /* RESERVED                      */
*      2 CVTSTOA FIXED(31),         /* SAVE AREA FOR THE REAL STORAGE
*                                      ADDRESS OF THE SEGMENT TABLE
*                                      ORIGIN ICB496                 */
*      2 CVTVOLM1 PTR(31),          /* ADDRESS OF TABLE FOR POWER  0065
*                                      WARNING FEATURE (PWF) (MDC312)
*                                                            @X04AQ9A*/
*       3 CVTVOLF1 BIT(8),          /* PWF FLAG BYTE. THIS BYTE IS 0065
*                                      OVERLAID BY CVTVOLM1 AFTER PWF
*                                      INITIALIZATION. (MDC313)    0065
*                                                            @X04AQ9A*/
*        4 CVTVOLI1 BIT(1),         /* PWF INITIALIZATION HAS NOT  0065
*                                      OCCURRED (MDC314)     @X04AQ9A*/
*       3 CVTVOLT1 PTR(24),         /* PWF RECHECK TIME DELAY. THIS
*                                      VALUE IS OVERLAID BY CVTVOLM1
*                                      AFTER PWF INITIALIZATION.   0065
*                                      (MDC315)              @X04AQ9A*/
*      2 CVTRSV61 PTR(31),          /* RESERVED                      */
*      2 CVTATMCT PTR(31),          /* POINTER TO VTAM CONTROL TABLE
*                                      MDC082                        */
*       3 CVTATMST CHAR(1),         /* VTAM START STATUS MDC135      */
*       3 CVTATMCA PTR(24),         /* POINTER TO VTAM CONTROL TABLE
*                                      MDC138                        */
*      2 CVTAUTH PTR(31),           /* POINTER TO AUTHORIZED LIBRARY
*                                      TABLE MDC188                  */
*      2 CVTACTAP PTR(31),          /* ADDRESS OF BRANCH ENTRY TO  0065
*                                      VTAM'S SVC ROUTINE ISTAPC42 0065
*                                      (MDC216)              @X31BH9A*/
*      2 CVTRV485 PTR(31),          /* RESERVED MDC106               */
*      2 CVTRV486 PTR(31),          /* RESERVED MDC106               */
*      2 CVTRV487 PTR(31),          /* RESERVED MDC106               */
*      2 CVTRV488 PTR(31);          /* RESERVED MDC106               */
*/*            OS/VS2 OVERLAY                                        */
*                                                                  0066
*   DECLARE                                                        0066
*     1 CVTS01 DEF(CVTPGSIA) BDY(WORD),                            0066
*      2 CVTGETL PTR(31),           /* ADDRESS OF IKJGETL, TSO GET 0066
*                                      LINE ROUTINE (MDC206)   YM2225*/
*      2 CVTLPDSR PTR(31),          /* ADDRESS OF LINK PACK AREA   0066
*                                      (LPA) DIRECTORY SEARCH ROUTINE*/
*      2 CVTPVTP PTR(31),           /* ADDRESS OF PAGE VECTOR TABLE  */
*      2 CVTLPDIA PTR(31),          /* ADDRESS OF LINK PACK AREA   0066
*                                      (LPA) DIRECTORY (ON PAGE    0066
*                                      BOUNDARY)                     */
*       3 CVTDIRST CHAR(1),         /* FLAG BYTE                     */
*        4 CVTDICOM BIT(1),         /* LPA DIRECTORY HAS BEEN      0066
*                                      INITIALIZED BY NIP            */
*        4 CVTRSV63 BIT(1),         /* RESERVED                      */
*        4 CVTRSV64 BIT(1),         /* RESERVED                      */
*        4 CVTRSV65 BIT(1),         /* RESERVED                      */
*        4 CVTRSV66 BIT(1),         /* RESERVED                      */
*        4 CVTRSV67 BIT(1),         /* RESERVED                      */
*        4 CVTRSV68 BIT(1),         /* RESERVED                      */
*        4 CVTRSV69 BIT(1),         /* RESERVED                      */
*       3 CVTLPDIR PTR(24),         /* ADDRESS OF LPA DIRECTORY. ON
*                                      PAGE BOUNDARY                 */
*      2 CVTRV320 PTR(31),          /* ** CVTPAGE1 FIELD UNUSED IN 0066
*                                      MVS ** (MDC112)       @Z40AQ9A*/
*      2 CVTRV321 PTR(31),          /* ** CVTPGSUP FIELD UNUSED IN 0066
*                                      MVS ** (MDC113)       @Z40AQ9A*/
*      2 CVTSLIDA CHAR(4) BDY(WORD),/* IDENTITY OF TCB CAUSING     0066
*                                      SUPERVISOR LOCK BYTE (CVTSYLK)
*                                      TO BE SET OR IDENTITY OF TCB
*                                      THAT SECOND EXIT PROCESSING IS
*                                      FOR WHEN CVTSEIC=1            */
*       3 CVTSYLK CHAR(1),          /* SUPERVISOR LOCK. ONLY ENABLED
*                                      TASKS MAY BE DISPATCHED       */
*       3 CVTSLID CHAR(3),          /* SAME AS CVTSLIDA ABOVE        */
*      2 CVTRV322 PTR(31),          /* RESERVED FOR FUTURE USE     0066
*                                      (MDC343)              @Z40AQ9A*/
*      2 CVTRV328 PTR(31),          /* ** CVTSEG AND CVTSEGA FIELDS
*                                      UNUSED IN MVS ** (MDC139)   0066
*                                                            @Z40AQ9A*/
*      2 CVTRV329 PTR(31),          /* ** CVTSEGB FIELD UNUSED IN MVS
*                                      ** (MDC141)           @Z40AQ9A*/
*      2 CVTRV330 PTR(31),          /* ** CVTSEGC AND SUBFIELDS    0066
*                                      UNUSED IN MVS ** (MDC142)   0066
*                                                            @Z40AQ9A*/
*      2 CVTRV331 PTR(31),          /* ** CVTSEGD AND SUBFIELDS    0066
*                                      UNUSED IN MVS ** (MDC145)   0066
*                                                            @Z40AQ9A*/
*      2 CVTRSV77 PTR(8),           /* RESERVED                      */
*      2 CVTSPVLK PTR(8),           /* NUMBER OF TASKS WHICH HAVE  0066
*                                      TERMINATED WHILE OWNING     0066
*                                      SUPERVISOR LOCK WITHOUT     0066
*                                      OPERATOR HAVING YET BEEN    0066
*                                      NOTIFIED                      */
*      2 CVTCTLFG CHAR(1),          /* SYSTEM CONTROL FLAGS          */
*       3 CVTRV323 BIT(1),          /* ** CVTPSIC BIT UNUSED IN MVS
*                                      ** (MDC118)           @Z40AQ9A*/
*       3 CVTRV333 BIT(1),          /* ** CVTAPGB BIT UNUSED IN MVS
*                                      ** (MDC151)           @Z40AQ9A*/
*       3 CVTRSV78 BIT(1),          /* RESERVED ICB382               */
*       3 CVTDSTAT BIT(1),          /* DEVSTAT OPTION IN EFFECT.   0066
*                                      DEVICE ADDRESS FOR 2319, 3330,
*                                      2314, 3330-1, 3340 CAN VARY 0066
*                                      ACROSS SYSTEMS MDC189         */
*       3 CVTRSV79 BIT(1),          /* RESERVED                      */
*       3 CVTNOMP BIT(1),           /* MULTIPROCESSING CODE IS NOT IN
*                                      THE SYSTEM MDC176             */
*       3 CVTGTRCE BIT(1),          /* GENERALIZED TRACE FACILITY  0066
*                                      (GTF) HAS SUPPRESSED        0066
*                                      SUPERVISOR TRACE ICB446       */
*       3 CVTSDTRC BIT(1),          /* SVC DUMP HAS SUPPRESSED     0066
*                                      SUPERVISOR TRACE ICB446       */
*      2 CVTAPG CHAR(1),            /* DISPATCHING PRIORITY OF     0066
*                                      AUTOMATIC PRIORITY GROUP (APG)
*                                      ICB339                        */
*      2 CVTTRACE CHAR(2) BDY(WORD),/* BRANCH ON REGISTER          0066
*                                      INSTRUCTION. SET BY NIP.    0066
*                                      REGISTER TEN FOR TRACE.     0066
*                                      REGISTER ELEVEN FOR NO TRACE. */
*      2 CVTTRAC2 CHAR(2) BDY(WORD,3),/* BRANCH ON REGISTER 11     0066
*                                      INSTRUCTION. THIS ALLOWS FOR
*                                      SUPPRESSING TRACE DYNAMICALLY
*                                      BY SETTING CONDITION CODE MASK
*                                      TO ZERO IN FIRST INSTRUCTION
*                                      (CVTTRACE)                    */
*      2 CVTRSCN PTR(31),           /* ADDRESS OF ROUTINE TO SCAN TCB
*                                      TREE                          */
*      2 CVTTAS PTR(31),            /* ADDRESS OF ROUTINE TO TRANSFER
*                                      ADDRESS SPACE                 */
*      2 CVTRV332 PTR(31),          /* ** CVTPVALD FIELD UNUSED IN 0066
*                                      MVS ** (MDC148)       @Z40AQ9A*/
*      2 CVTSHRVM PTR(31),          /* LOWEST ADDRESS OF SHARED    0066
*                                      VIRTUAL STORAGE AREA. THIS  0066
*                                      ADDRESS WILL BE THE BEGINNING
*                                      OF THE COMMON SERVICE AREA  0066
*                                      (CSA) (MDC324)        @Z30AQ9A*/
*      2 CVT0VL01 PTR(31),          /* ENTRY POINT ADDRESS OF      0066
*                                      VALIDITY CHECK ROUTINE      0066
*                                      (IEA0VL01) USED TO COMPARE  0066
*                                      PROTECT KEY OF AN ADDRESS WITH
*                                      TCB PROTECT KEY.              */
*      2 CVTRV324 PTR(31),          /* ** CVTPFIXQ FIELD UNUSED IN 0066
*                                      MVS ** (MDC119)       @Z40AQ9A*/
*      2 CVTRV325 PTR(31),          /* ** CVTPFIXR FIELD UNUSED IN 0066
*                                      MVS ** (MDC120)       @Z40AQ9A*/
*      2 CVTRV326 PTR(31),          /* ** CVTPFIXP FIELD UNUSED IN 0066
*                                      MVS ** (MDC121)       @Z40AQ9A*/
*      2 CVTASCRF PTR(31),          /* CREATED ASCB QUEUE HEADER   0066
*                                      (MDC337)              @ZA04120*/
*      2 CVTASCRL PTR(31),          /* CREATED ASCB QUEUE TRAILER  0066
*                                      (MDC338)              @ZA04120*/
*      2 CVTPUTL PTR(31),           /* ADDRESS OF IKJPUTL, TSO PUT 0066
*                                      LINE ROUTINE (MDC207)   YM2225*/
*      2 CVTSRBRT PTR(31),          /* DISPATCHER RETURN ADDRESS FOR
*                                      SRB ROUTINES MDC130           */
*      2 CVTOLT0A PTR(31),          /* BRANCH ENTRY TO OLTEP MEMORY
*                                      TERMINATION RESOURCE MANAGER
*                                      MDC129                        */
*      2 CVTSMFEX PTR(31),          /* BRANCH ENTRY TO SYSTEM      0066
*                                      MANAGEMENT FACILITIES (SMF) 0066
*                                      EXCP COUNTING ROUTINE FOR VAM
*                                      WINDOW INTERCEPT MDC133       */
*      2 CVTCSPIE PTR(31),          /* FOR CHECKPOINT/RESTART, BRANCH
*                                      ENTRY TO SPIE MDC149          */
*      2 CVTPTGT PTR(31),           /* ADDRESS OF IKJPTGT, TSO PUTGET
*                                      ROUTINE (MDC208)        YM2225*/
*      2 CVTIOSPL PTR(8),           /* PRIORITY LEVEL OF I/O       0066
*                                      SUPERVISOR CHANNEL SCHEDULER
*                                      MDC019                        */
*      2 CVTRV513 CHAR(1),          /* RESERVED MDC165               */
*      2 CVTDSSAC CHAR(1),          /* DYNAMIC SUPPORT SYSTEM (DSS)
*                                      ACTIVATED FLAG - USED BY    0066
*                                      RESTART FLIH. IF X'00', DSS 0066
*                                      NOT INITIALIZED. IF X'FF', DSS
*                                      HAS BEEN INITIALIZED. MDC163  */
*      2 CVTRV139 PTR(8),           /* RESERVED                      */
*      2 CVTSTCK PTR(31),           /* ADDRESS OF IKJSTCK, TSO STACK
*                                      ROUTINE (MDC209)        YM2225*/
*      2 CVTMAXMP PTR(15),          /* FOR MEASUREMENT FACILITY    0066
*                                      (MF/1), MAXIMUM PHYSICAL CPU
*                                      ADDRESS SUPPORTED BY THIS   0066
*                                      RELEASE MDC165                */
*      2 CVTRV144 FIXED(15),        /* RESERVED                      */
*      2 CVTSCAN PTR(31),           /* ADDRESS OF IKJSCAN, TSO SCAN
*                                      ROUTINE (MDC210)        YM2225*/
*      2 CVTAUTHL PTR(31),          /* POINTER TO AUTHORIZED LIBRARY
*                                      TABLE MDC001                  */
*      2 CVTBLDCP PTR(31),          /* BRANCH ENTRY TO BUILD POOL  0066
*                                      MDC003                        */
*      2 CVTGETCL PTR(31),          /* BRANCH ENTRY TO GET CELL    0066
*                                      MDC004                        */
*      2 CVTFRECL PTR(31),          /* BRANCH ENTRY TO FREE CELL   0066
*                                      MDC005                        */
*      2 CVTDELCP PTR(31),          /* BRANCH ENTRY TO DELETE POOL 0066
*                                      MDC006                        */
*      2 CVTCRMN PTR(31),           /* BRANCH ENTRY TO SVC 120     0066
*                                      (GETMAIN/FREEMAIN:CRBRANCH) 0066
*                                      MDC007                        */
*      2 CVTCRAS PTR(31),           /* BRANCH ENTRY TO 'CREATE     0066
*                                      ADDRESS SPACE' MDC008         */
*      2 CVTQSAS PTR(31),           /* BRANCH ENTRY TO TASK        0066
*                                      TERMINATION MDC009            */
*      2 CVTFRAS PTR(31),           /* BRANCH ENTRY TO FREE ADDRESS
*                                      SPACE MDC010                  */
*      2 CVTS1EE PTR(31),           /* BRANCH ENTRY TO STAGE 1 EXIT
*                                      EFFECTOR MDC011               */
*      2 CVTPARS PTR(31),           /* ADDRESS OF IKJPARS, TSO PARSE
*                                      ROUTINE (MDC211)        YM2225*/
*      2 CVTQUIS PTR(31),           /* BRANCH ENTRY TO QUIESCE MDC013*/
*      2 CVTSTXU PTR(31),           /* BRANCH ENTRY TO ATTENTION EXIT
*                                      EPILOGUE MDC014               */
*      2 CVTOPTE PTR(31),           /* BRANCH ENTRY ADDRESS TO     0066
*                                      SYSEVENT MDC015               */
*      2 CVTSDRM PTR(31),           /* BRNACH ENTRY ADDRESS OF THE 0066
*                                      RESOURCE MANAGER ROUTINE FOR
*                                      SVC DUMP. THIS ROUTINE CAN BE
*                                      INVOKED BY MEMORY TERMINATION
*                                      MDC077                        */
*      2 CVTIOSCS PTR(31),          /* ENTRY POINT OF I/O SUPERVISOR
*                                      CHANNEL SCHEDULER MDC018      */
*      2 CVTAQTOP PTR(31),          /* POINTER TO AREA CONTAINING  0066
*                                      QUIESCE DESCRIPTOR BLOCK    0066
*                                      (QDB'S) FOR DEVICE ALLOCATION
*                                      MDC021                        */
*      2 CVTVVMDI PTR(31),          /* CONSTANT USED BY PAGED LINK 0066
*                                      PACK AREA (LPA) DIRECTORY   0066
*                                      SEARCH ALGORITHM MDC022       */
*      2 CVTASVT PTR(31),           /* POINTER TO ADDRESS SPACE    0066
*                                      VECTOR TABLE (ASVT) MDC070    */
*      2 CVTGDA PTR(31),            /* POINTER TO GLOBAL DATA AREA 0066
*                                      (GDA) IN SQA MDC024           */
*      2 CVTASCBH PTR(31),          /* POINTER TO HIGHEST PRIORITY 0066
*                                      ADDRESS SPACE CONTROL BLOCK 0066
*                                      (ASCB) ON THE ASCB DISPATCHING
*                                      QUEUE (HEAD OF ASCB QUEUE)  0066
*                                      MDC027                        */
*      2 CVTASCBL PTR(31),          /* POINTER TO LOWEST PRIORITY  0066
*                                      ASCB ON ASCB DISPATCHING QUEUE
*                                      MDC028                        */
*      2 CVTRTMCT PTR(31),          /* POINTER TO                  0066
*                                      RECOVERY/TERMINATION CONTROL
*                                      TABLE MDC031                  */
*      2 CVTSV60 PTR(31),           /* ADDRESS OF SVC 60 BRANCH ENTRY
*                                      POINT (MDC354)        @Z40FP9A*/
*      2 CVTSDMP PTR(31),           /* ADDRESS OF SVC DUMP BRANCH  0066
*                                      ENTRY POINT MDC033            */
*      2 CVTSCBP PTR(31),           /* ADDRESS OF SCB PURGE RESOURCE
*                                      MANAGER MDC034                */
*      2 CVTSDBF PTR(31),           /* ADDRESS OF 4K SQA BUFFER USED
*                                      BY SVC DUMP. HIGH ORDER BIT OF
*                                      THIS CVT WORD IS USED AS LOCK
*                                      TO INDICATE BUFFER IS IN USE
*                                      MDC035                        */
*      2 CVTRTMS PTR(31),           /* RTM1 INTERNAL SERVICABILITY 0066
*                                      LEVEL INDICATOR MDC036        */
*      2 CVTTPIOS PTR(31),          /* ADDRESS OF THE TELEPROCESSING
*                                      I/O SUPERV1SOR ROUTINE (TPIOS)
*                                      MDC078                        */
*      2 CVTSIC PTR(31),            /* BRANCH ENTRY ADDRESS OF THE 0066
*                                      ROUTINE TO SCHEDULE SYSTEM  0066
*                                      INITIALIZED CANCEL MDC042     */
*      2 CVTOPCTP PTR(31),          /* ADDRESS OF SYSTEM RESOURCES 0066
*                                      MANAGER (SRM) CONTROL TABLE 0066
*                                      MDC043                        */
*      2 CVTEXPRO PTR(31),          /* ADDRESS OF EXIT PROLOGUE/TYPE
*                                      1 EXIT MDC044                 */
*      2 CVTGSMQ PTR(31),           /* ADDRESS OF GLOBAL SERVICE   0066
*                                      MANAGER QUEUE MDC045          */
*      2 CVTLSMQ PTR(31),           /* ADDRESS OF LOCAL SERVICE    0066
*                                      MANAGER QUEUE MDC046          */
*      2 CVTGSPL PTR(31),           /* ADDRESS OF GLOBAL SYSTEM    0066
*                                      PRIORITY LIST QUEUE MDC047    */
*      2 CVTVWAIT PTR(31),          /* ADDRESS OF WAIT ROUTINE MDC048*/
*      2 CVTPARRL PTR(31),          /* ADDRESS OF PARTIALLY LOADED 0066
*                                      DELETE QUEUE MDC049           */
*      2 CVTAPFT PTR(31),           /* ADDRESS OF AUTHORIZED PROGRAM
*                                      FACILITY (APF) TABLE.       0066
*                                      INITIALIZED BY NIP. MDC050    */
*      2 CVTQCS01 PTR(31),          /* BRANCH ENTRY ADDRESS TO     0066
*                                      PROGRAM MANAGER USED BY ATTACH
*                                      MDC051                        */
*      2 CVTFQCB PTR(31),           /* POINTER TO FIRST MAJOR QCB FOR
*                                      ENQ MDC052                    */
*      2 CVTLQCB PTR(31),           /* POINTER TO LAST MAJOR QCB FOR
*                                      ENQ MDC053                    */
*      2 CVTRENQ PTR(31),           /* RESOURCE MANAGER ADDRESS FOR
*                                      ENQ MDC054                    */
*      2 CVTRSPIE PTR(31),          /* RESOURCE MANAGER FOR SPIE   0066
*                                      MDC055                        */
*      2 CVTLKRMA PTR(31),          /* RESOURCE MANAGER ADDRESS FOR
*                                      LOCK MANAGER MDC056           */
*      2 CVTCSD PTR(31),            /* VIRTUAL ADDRESS OF COMMON   0066
*                                      SYSTEM DATA AREA (CSD).     0066
*                                      INITIALIZED BY NIP. MDC057    */
*      2 CVTDQIQE PTR(31),          /* RESOURCE MANAGER FOR EXIT   0066
*                                      EFFECTORS MDC058              */
*      2 CVTRPOST PTR(31),          /* RESOURCE MANAGER FOR POST   0066
*                                      MDC059                        */
*      2 CVT062R1 PTR(31),          /* BRANCH ENTRY TO DETACH MDC060 */
*      2 CVTVEAC0 PTR(31),          /* ASCBCHAP BRANCH ENTRY MDC061  */
*      2 CVTGLMN PTR(31),           /* GLOBAL BRANCH ENTRY ADDRESS 0066
*                                      FOR GETMAIN/FREEMAIN MDC062   */
*      2 CVTSPSA PTR(31),           /* POINTER TO GLOBAL WORK/SAVE 0066
*                                      AREA VECTOR TABLE (WSAG)    0066
*                                      MDC071                        */
*      2 CVTWSAL PTR(31),           /* ADDRESS OF TABLE OF LENGTHS OF
*                                      LOCAL WORK/SAVE AREAS MDC072  */
*      2 CVTRV149 PTR(31),          /* RESERVED (MDC073)       YM4043*/
*      2 CVTWSAC PTR(31),           /* ADDRESS OF TABLE OF LENGTHS OF
*                                      CPU WORK/SAVE AREAS MDC074    */
*      2 CVTRECRQ PTR(31),          /* ADDRESS OF THE RECORDING    0066
*                                      REQUEST FACILITY (PART OF RTM1
*                                      - CALLED BY RTM2 AND RMS)   0066
*                                      MDC075                        */
*      2 CVTASMVT PTR(31),          /* POINTER TO AUXILIARY STORAGE
*                                      MANAGEMENT VECTOR TABLE (AMVT)
*                                      MDC076                        */
*      2 CVTIOBP PTR(31),           /* ADDRESS OF THE BLOCK PROCESSOR
*                                      CVT MDC079                    */
*      2 CVTSPOST PTR(31),          /* POST RESOURCE MANAGER       0066
*                                      TERMINATION ROUTINE (RMTR)  0066
*                                      ENTRY POINT MDC085            */
*      2 CVTRSTWD FIXED(31),        /* RESTART RESOURCE MANAGEMENT 0066
*                                      WORD - CONTAINS IDENTIFIER OF
*                                      USER IF RESTART IS IN USE.  0066
*                                      OTHERWISE, ZERO. MDC161       */
*      2 CVTFETCH PTR(31),          /* ADDRESS OF ENTRY POINT FOR  0066
*                                      BASIC FETCH MDC196            */
*      2 CVT044R2 PTR(31),          /* ADDRESS OF IGC044R2 IN CHAP 0066
*                                      SERVICE ROUTINE MDC197        */
*      2 CVTPERFM PTR(31),          /* ADDRESS OF THE PERFORMANCE  0066
*                                      WORK AREA. SET BY IGX00018. 0066
*                                      MDC205                        */
*      2 CVTDAIR PTR(31),           /* ADDRESS OF IKJDAIR, TSO     0066
*                                      DYNAMIC ALLOCATION INTERFACE
*                                      ROUTINE (MDC212)        YM2225*/
*      2 CVTEHDEF PTR(31),          /* ADDRESS OF IKJEHDEF, TSO    0066
*                                      DEFAULT SERVICE ROUTINE     0066
*                                      (MDC213)                YM2225*/
*      2 CVTEHCIR PTR(31),          /* ADDRESS OF IKJEHCIR, TSO    0066
*                                      CATALOG INFORMATION ROUTINE 0066
*                                      (MDC214)                YM2225*/
*      2 CVTSSAP PTR(31),           /* ADDRESS OF SYSTEM SAVE AREA 0066
*                                      MDC063                        */
*      2 CVTAIDVT PTR(31),          /* POINTER TO APPENDAGE ID VECTOR
*                                      TABLE MDC064                  */
*      2 CVTIPCDS PTR(31),          /* BRANCH ENTRY FOR DIRECT SIGNAL
*                                      SERVICE ROUTINE MDC065        */
*      2 CVTIPCRI PTR(31),          /* BRANCH ENTRY FOR REMOTE     0066
*                                      IMMEDIATE SIGNAL SERVICE    0066
*                                      ROUTINE MDC066                */
*      2 CVTIPCRP PTR(31),          /* BRANCH ENTRY FOR REMOTE     0066
*                                      PENDABLE SIGNAL SERVICE     0066
*                                      ROUTINE MDC067                */
*      2 CVTPCCAT PTR(31),          /* POINTER TO PHYSICAL CCA VECTOR
*                                      TABLE MDC068                  */
*      2 CVTLCCAT PTR(31),          /* POINTER TO LOGICAL CCA VECTOR
*                                      TABLE MDC069                  */
*      2 CVTRV210 BIT(8),           /* RESERVED                      */
*       3 CVTRV211 BIT(1),          /* RESERVED                      */
*       3 CVTRV212 BIT(1),          /* RESERVED                      */
*       3 CVTRV213 BIT(1),          /* RESERVED                      */
*       3 CVTRV214 BIT(1),          /* RESERVED                      */
*       3 CVTRV215 BIT(1),          /* RESERVED                      */
*       3 CVTRV216 BIT(1),          /* RESERVED                      */
*       3 CVTRV217 BIT(1),          /* RESERVED                      */
*       3 CVTRV218 BIT(1),          /* RESERVED                      */
*      2 CVTRV219 BIT(8),           /* RESERVED                      */
*       3 CVTRV220 BIT(1),          /* RESERVED                      */
*       3 CVTRV221 BIT(1),          /* RESERVED                      */
*       3 CVTRV222 BIT(1),          /* RESERVED                      */
*       3 CVTRV223 BIT(1),          /* RESERVED                      */
*       3 CVTRV224 BIT(1),          /* RESERVED                      */
*       3 CVTRV225 BIT(1),          /* RESERVED                      */
*       3 CVTRV226 BIT(1),          /* RESERVED                      */
*       3 CVTRV227 BIT(1),          /* RESERVED                      */
*      2 CVTRV228 BIT(8),           /* RESERVED                      */
*       3 CVTRV229 BIT(1),          /* RESERVED                      */
*       3 CVTRV230 BIT(1),          /* RESERVED                      */
*       3 CVTRV231 BIT(1),          /* RESERVED                      */
*       3 CVTRV232 BIT(1),          /* RESERVED                      */
*       3 CVTRV233 BIT(1),          /* RESERVED                      */
*       3 CVTRV234 BIT(1),          /* RESERVED                      */
*       3 CVTRV235 BIT(1),          /* RESERVED                      */
*       3 CVTRV236 BIT(1),          /* RESERVED                      */
*      2 CVTRV237 BIT(8),           /* RESERVED                      */
*       3 CVTRV238 BIT(1),          /* RESERVED                      */
*       3 CVTRV239 BIT(1),          /* RESERVED                      */
*       3 CVTRV240 BIT(1),          /* RESERVED                      */
*       3 CVTRV241 BIT(1),          /* RESERVED                      */
*       3 CVTRV242 BIT(1),          /* RESERVED                      */
*       3 CVTRV243 BIT(1),          /* RESERVED                      */
*       3 CVTRV244 BIT(1),          /* RESERVED                      */
*       3 CVTRV245 BIT(1),          /* RESERVED                      */
*      2 CVTRV246 PTR(8),           /* RESERVED                      */
*      2 CVTRV247 PTR(8),           /* RESERVED                      */
*      2 CVTRV248 PTR(8),           /* RESERVED                      */
*      2 CVTRV249 PTR(8),           /* RESERVED                      */
*      2 CVTRV250 PTR(8),           /* RESERVED                      */
*      2 CVTRV251 PTR(8),           /* RESERVED                      */
*      2 CVTRV252 PTR(15),          /* RESERVED                      */
*      2 CVTRV253 FIXED(15),        /* RESERVED                      */
*      2 CVTRV254 FIXED(15),        /* RESERVED                      */
*      2 CVTPWI PTR(31),            /* ADDRESS OF THE WINDOW       0066
*                                      INTERCEPT ROUTINE MDC104      */
*      2 CVTPVBP PTR(31),           /* ADDRESS OF THE VIRTUAL BLOCK
*                                      PROCESSOR MDC105              */
*      2 CVTMFCTL PTR(31),          /* POINTER TO MEASUREMENT      0066
*                                      FACILITY CONTROL BLOCK MDC100 */
*      2 CVTMFRTR PTR(31),          /* IF MEASUREMENT FACILITY IS  0066
*                                      ACTIVE, CONTAINS ADDRESS OF 0066
*                                      MEASUREMENT FACILITY ROUTER.
*                                      OTHERWISE, ADDRESS OF CVTBRET.
*                                      MDC101                        */
*       3 CVTMFACT BIT(1),          /* IF ONE, I/O SUPERVISOR AND  0066
*                                      TIMER SECOND LEVEL INTERRUPT
*                                      HANDLER HOOKS BRANCH TO     0066
*                                      MEASUREMENT FACILITY ROUTER 0066
*                                      MDC102                        */
*      2 CVTVPSIB PTR(31),          /* BRANCH ENTRY TO PAGE SERVICES
*                                      MDC108                        */
*      2 CVTVSI PTR(31),            /* BRANCH ENTRY TO VAM SERVICES
*                                      MDC109                        */
*      2 CVTVFP PTR(31),            /* BRANCH ENTRY TO FINDPAGE    0066
*                                      MDC110                        */
*      2 CVTRV262 BIT(8),           /* RESERVED                      */
*       3 CVTRV263 BIT(1),          /* RESERVED                      */
*       3 CVTRV264 BIT(1),          /* RESERVED                      */
*       3 CVTRV265 BIT(1),          /* RESERVED                      */
*       3 CVTRV266 BIT(1),          /* RESERVED                      */
*       3 CVTRV267 BIT(1),          /* RESERVED                      */
*       3 CVTRV268 BIT(1),          /* RESERVED                      */
*       3 CVTRV269 BIT(1),          /* RESERVED                      */
*       3 CVTRV270 BIT(1),          /* RESERVED                      */
*      2 CVTRV271 BIT(8),           /* RESERVED                      */
*       3 CVTRV272 BIT(1),          /* RESERVED                      */
*       3 CVTRV273 BIT(1),          /* RESERVED                      */
*       3 CVTRV274 BIT(1),          /* RESERVED                      */
*       3 CVTRV275 BIT(1),          /* RESERVED                      */
*       3 CVTRV276 BIT(1),          /* RESERVED                      */
*       3 CVTRV277 BIT(1),          /* RESERVED                      */
*       3 CVTRV278 BIT(1),          /* RESERVED                      */
*       3 CVTRV279 BIT(1),          /* RESERVED                      */
*      2 CVTRV280 BIT(8),           /* RESERVED                      */
*       3 CVTRV281 BIT(1),          /* RESERVED                      */
*       3 CVTRV282 BIT(1),          /* RESERVED                      */
*       3 CVTRV283 BIT(1),          /* RESERVED                      */
*       3 CVTRV284 BIT(1),          /* RESERVED                      */
*       3 CVTRV285 BIT(1),          /* RESERVED                      */
*       3 CVTRV286 BIT(1),          /* RESERVED                      */
*       3 CVTRV287 BIT(1),          /* RESERVED                      */
*       3 CVTRV288 BIT(1),          /* RESERVED                      */
*      2 CVTRV289 BIT(8),           /* RESERVED                      */
*       3 CVTRV290 BIT(1),          /* RESERVED                      */
*       3 CVTRV291 BIT(1),          /* RESERVED                      */
*       3 CVTRV292 BIT(1),          /* RESERVED                      */
*       3 CVTRV293 BIT(1),          /* RESERVED                      */
*       3 CVTRV294 BIT(1),          /* RESERVED                      */
*       3 CVTRV295 BIT(1),          /* RESERVED                      */
*       3 CVTRV296 BIT(1),          /* RESERVED                      */
*       3 CVTRV297 BIT(1),          /* RESERVED                      */
*      2 CVTTRCA PTR(31),           /* ADDRESS OF TRACE TABLE HEADER
*                                      (MDC327)              @ZA02352*/
*      2 CVTRV302 PTR(15),          /* RESERVED                      */
*      2 CVTRV303 PTR(15),          /* RESERVED                      */
*      2 CVTRV304 FIXED(15),        /* RESERVED                      */
*      2 CVTRV305 FIXED(15),        /* RESERVED                      */
*      2 CVTRV306 FIXED(15),        /* RESERVED                      */
*      2 CVTRV307 FIXED(15),        /* RESERVED                      */
*      2 CVTVIOP PTR(31),           /* ENTRY POINT OF PAGE I/O POST
*                                      MDC111                        */
*      2 CVTRMBR PTR(31),           /* ADDRESS OF REGMAIN BRANCH   0066
*                                      ENTRY MDC123                  */
*      2 CVTLFRM PTR(31),           /* LIST FORMAT FREEMAIN BRANCH 0066
*                                      ENTRY POINT MDC124            */
*      2 CVTGMBR PTR(31),           /* LIST FORMAT GETMAIN BRANCH  0066
*                                      ENTRY POINT MDC125            */
*      2 CVT0TC0A PTR(31),          /* ADDRESS OF TASK CLOSE MODULE
*                                      IFG0TC0A MDC128               */
*      2 CVTRLSTG FIXED(31),        /* SIZE OF ACTUAL REAL STORAGE 0066
*                                      ONLINE AT IPL TIME IN 'K'.  0066
*                                      VALUE PLACED HERE BY IEAVNIP0.
*                                      MDC153                        */
*      2 CVTSPFRR PTR(31),          /* 'SUPER FRR' ADDRESS (ADDRESS
*                                      OF FUNCTIONAL RECOVERY ROUTINE
*                                      ESTABLISHED AT NIP0 TIME TO 0066
*                                      PROTECT SUPERVISOR CONTROL  0066
*                                      PROGRAM) MDC154               */
*      2 CVTVEMS0 PTR(31),          /* ADDRESS OF MEMORY SWITCH    0066
*                                      ROUTINE MDC155                */
*      2 CVTJRECM PTR(31),          /* ADDRESS OF SUBSYSTEM INTERFACE
*                                      RESOURCE MANAGER MDC157       */
*      2 CVTIRECM PTR(31),          /* ADDRESS OF INITIATOR RESOURCE
*                                      MANAGER MDC158                */
*      2 CVTDARCM PTR(31),          /* ADDRESS OF DEVICE ALLOCATION
*                                      RESOURCE MANAGER MDC159       */
*      2 CVT0PT02 PTR(31),          /* ADDRESS OF POST ENTRY POINT 0066
*                                      IEA0PT02 MDC160               */
*      2 CVTSTPRS PTR(31),          /* ENTRY POINT OF STOP AND     0066
*                                      RESTART SUBROUTINE MDC162     */
*      2 CVTWTCB PTR(31),           /* ADDRESS OF WAIT STATE TCB   0066
*                                      MDC164                        */
*      2 CVTVACR PTR(31),           /* ACR/VARY CPU CHANNEL RECOVERY
*                                      ROUTINE ADDRESS. ADDRESS    0066
*                                      FILLED IN BY VARY CPU       0066
*                                      PROCESSOR. MDC178             */
*      2 CVTQUIT PTR(31),           /* VARY CPU SHUTDOWN ROUTINE   0066
*                                      ADDRESS. ADDRESS FILLED IN BY
*                                      VARY CPU PROCESSOR. MDC179    */
*      2 CVTGTFR8 PTR(31),          /* GENERALIZED TRACE FACILITY  0066
*                                      (GTF) CONTROL REGISTER 8    0066
*                                      INITIALIZATION ROUTINE ADDRESS
*                                      MDC180                        */
*      2 CVTVSTOP PTR(31),          /* ADDRESS OF VARY CPU STOP CPU
*                                      ROUTINE MDC169                */
*      2 CVTVPSA PTR(31),           /* ADDRESS OF COPY OF SYSGEN'ED
*                                      PSA - PLACED HERE BY NIP    0066
*                                      MDC170                        */
*      2 CVTRMPTT PTR(31),          /* ADDRESS OF ISTRAMA1, THE VTAM
*                                      RESOURCE MANAGER FOR NORMAL 0066
*                                      AND ABNORMAL TASK TERMINATION
*                                      (MDC322)              @Z30AP9A*/
*      2 CVTRMPMT PTR(31),          /* ADDRESS OF ISTRAMA2, THE VTAM
*                                      RESOURCE MANAGER FOR NORMAL 0066
*                                      AND ABNORMAL MEMORY         0066
*                                      TERMINATION (MDC323)  @Z30AP9A*/
*      2 CVTEXP1 PTR(31),           /* ADDRESS OF EXIT PROLOGUE WHICH
*                                      RETURNS TO THE DISPATCHER   0066
*                                      MDC173                        */
*      2 CVTCSDRL PTR(31),          /* REAL ADDRESS OF COMMON SYSTEM
*                                      DATA AREA (CSD). INITIALIZED
*                                      BY NIP. MDC174                */
*      2 CVTSSRB PTR(31),           /* STATUS STOP SRB ENTRY MDC175  */
*      2 CVTRPT PTR(31),            /* ADDRESS OF IGARPT01 MODULE OF
*                                      RADIX PARTITION TREE SERVICES.
*                                      INITIALIZED BY NIP. MDC177    */
*      2 CVTQV1 PTR(31),            /* ADDRESS OF QUEUE VERIFICATION
*                                      FOR SINGLE THREADED QUEUES  0066
*                                      WITH HEADERS ONLY MDC181      */
*      2 CVTQV2 PTR(31),            /* ADDRESS OF QUEUE VERIFICATION
*                                      FOR SINGLE THREADED QUEUES  0066
*                                      WITH HEADER AND TRAILER MDC182*/
*      2 CVTQV3 PTR(31),            /* ADDRESS OF QUEUE VERIFICATION
*                                      FOR DOUBLE THREADED QUEUES  0066
*                                      MDC183                        */
*      2 CVTGSDA PTR(31),           /* ADDRESS OF GLOBAL SYSTEM    0066
*                                      DUPLEX AREA. ADDRESS FILLED IN
*                                      BY NIP0. MDC184               */
*       3 CVTGSDAB BIT(1),          /* IF HIGH-ORDER BIT IS ONE,   0066
*                                      THERE IS A VALID VALUE IN   0066
*                                      FOLLOWING 31 BITS MDC185      */
*      2 CVTADV PTR(31),            /* ADDRESS OF ADDRESS          0066
*                                      VERIFICATION ROUTINE MDC186   */
*      2 CVTTPIO PTR(31),           /* ADDRESS OF VTAM TPIO (SVC 124)
*                                      ROUTINE MDC193                */
*      2 CVTCRCA PTR(31),           /* WHEN CHANNEL RECONFIGURATION
*                                      HARDWARE (CRH) IS ACTIVE,   0066
*                                      ADDRESS OF CRH COMMUNICATION
*                                      AREA IECVCRCA. OTHERWISE,   0066
*                                      ZERO. (MDC306)        @Z30CQ9A*/
*      2 CVTEVENT PTR(31),          /* BRANCH ENTRY ADDRESS TO EVENTS
*                                      (FAST MULTIPLE WAIT ROUTINE)
*                                      (MDC316)              @Z30HP9A*/
*      2 CVTSSCR PTR(31),           /* ADDRESS OF STORAGE SYSTEM   0066
*                                      CONTROLLER RECOVERY MANAGER 0066
*                                      CLEANUP ROUTINE (SSC RMCR)  0066
*                                      (MDC319)              @Z30LP9A*/
*      2 CVTCBBR PTR(31),           /* BRANCH ENTRY ADDRESS TO     0066
*                                      GETMAIN/FREEMAIN (MDC325)   0066
*                                                            @Z30EN9A*/
*      2 CVTEFF02 PTR(31),          /* ADDRESS OF IKJEFF02, TSO    0066
*                                      MESSAGE ISSUER SERVICE ROUTINE
*                                      (MDC326)              @ZM30972*/
*      2 CVTRV604 PTR(31),          /* RESERVED (MDC307)     @Z30AQ9A*/
*      2 CVTRV605 PTR(31),          /* RESERVED (MDC307)     @Z30AQ9A*/
*      2 CVTRV606 PTR(31),          /* RESERVED (MDC307)     @Z30AQ9A*/
*      2 CVTRAC PTR(31),            /* ADDRESS OF ACCESS CONTROL CVT
*                                      (MDC320)              @Z40RP9A*/
*      2 CVTCGK PTR(31),            /* ADDRESS OF ROUTINE USED TO  0066
*                                      CHANGE THE KEY OF VIRTUAL   0066
*                                      PAGES (MDC331)        @Z40EP9A*/
*      2 CVTRV609 PTR(31),          /* RESERVED (MDC332)     @Z40AQ9A*/
*      2 CVT0PT0E PTR(31),          /* ENTRY POINT TO IDENTIFY POST
*                                      EXIT ROUTINES (MDC334)      0066
*                                                            @Z40EP9A*/
*      2 CVT0PT03 PTR(31),          /* POST REINVOCATION ENTRY POINT
*                                      FROM POST EXIT ROUTINES     0066
*                                      (MDC335)              @Z40EP9A*/
*      2 CVTTCASP PTR(31),          /* RESERVED FOR FUTURE USE     0066
*                                      (MDC336)              @Z40DQ9A*/
*      2 CVTRV613 PTR(31),          /* RESERVED (MDC307)     @Z30AQ9A*/
*      2 CVTRV614 PTR(31),          /* RESERVED (MDC307)     @Z30AQ9A*/
*      2 CVTRV615 PTR(31),          /* RESERVED (MDC307)     @Z30AQ9A*/
*      2 CVTRV616 PTR(31),          /* RESERVED (MDC307)     @Z30AQ9A*/
*      2 CVTRV617 PTR(31),          /* RESERVED (MDC307)     @Z30AQ9A*/
*      2 CVTRV618 PTR(31),          /* RESERVED (MDC307)     @Z30AQ9A*/
*      2 CVTRV619 PTR(31),          /* RESERVED (MDC307)     @Z30AQ9A*/
*      2 CVTIHASU PTR(31),          /* ADDRESS OF BIT STRING (MDC355)
*                                                            @Z404P9A*/
*      2 CVTRV621 PTR(31),          /* RESERVED (MDC307)     @Z30AQ9A*/
*      2 CVTRV622 PTR(31),          /* RESERVED (MDC307)     @Z30AQ9A*/
*      2 CVTRV623 PTR(31),          /* RESERVED (MDC307)     @Z30AQ9A*/
*      2 CVTRV624 PTR(31),          /* RESERVED (MDC307)     @Z30AQ9A*/
*      2 CVTRV625 PTR(31),          /* RESERVED (MDC307)     @Z30AQ9A*/
*      2 CVTRV626 PTR(31),          /* RESERVED (MDC307)     @Z30AQ9A*/
*      2 CVTRV627 PTR(31),          /* RESERVED (MDC307)     @Z30AQ9A*/
*      2 CVTRV628 PTR(31);          /* RESERVED (MDC307)     @Z30AQ9A*/
*/*                                                                  */
*/*            OS - OS/VS COMMON EXTENSION                           */
*/*                                                                  */
*                                                                  0067
*   DECLARE                                                        0067
*     1 CVTXTNT1 BASED(CVTEXT1),    /* START OF OS - OS/VS COMMON  0067
*                                      EXTENSION ICB421              */
*      2 CVTFACHN PTR(31),          /* ADDRESS OF CHAIN OF DCB FIELD
*                                      AREAS (ISAM) ICB421           */
*      2 CVTRSV87 PTR(31),          /* RESERVED                      */
*      2 CVTRSV88 PTR(31);          /* RESERVED                      */
*/*                                                                  */
*/*            OS/VS1 - OS/VS2 COMMON EXTENSION                      */
*/*                                                                  */
*                                                                  0068
*   DECLARE                                                        0068
*     1 CVTXTNT2 BASED(CVTEXT2),    /* START OF OS/VS1 - OS/VS2    0068
*                                      EXTENSION                     */
*      2 CVTDSSV PTR(31),           /* ADDRESS OF THE DYNAMIC SUPPORT
*                                      SYSTEM (DSS) VECTOR TABLE   0068
*                                      ICB313                        */
*       3 CVTRSV89 PTR(8),          /* RESERVED ICB313               */
*       3 CVTDSSVA PTR(24),         /* ADDRESS OF THE DSS VECTOR   0068
*                                      TABLE ICB313                  */
*      2 CVTNUCLS CHAR(1),          /* IDENTIFICATION OF THE NUCLEUS
*                                      MEMBER NAME ICB322            */
*      2 CVTFLGBT BIT(8),           /* FLAG BYTE (OS/VS1) (MDC301) 0068
*                                                            @X04EP9A*/
*       3 CVTNPE BIT(1),            /* INDICATES NON-PAGING        0068
*                                      ENVIRONMENT (VM HANDSHAKING)
*                                      (OS/VS1) (MDC302)     @X04EP9A*/
*       3 CVTVME BIT(1),            /* INDICATES MACHINE IS OPERATING
*                                      IN VM ENVIRONMENT (OS/VS1)  0068
*                                      (MDC303)              @X04EP9A*/
*       3 CVTRSV9C BIT(1),          /* RESERVED                      */
*       3 CVTRSV9D BIT(1),          /* RESERVED                      */
*       3 CVTRSV9E BIT(1),          /* RESERVED                      */
*       3 CVTRSV9F BIT(1),          /* RESERVED                      */
*       3 CVTRSV9G BIT(1),          /* RESERVED                      */
*       3 CVTRSV9H BIT(1),          /* RESERVED                      */
*      2 CVTRSV91 FIXED(15),        /* RESERVED                      */
*      2 CVTDEBVR PTR(31),          /* ADDRESS OF BRANCH ENTRY POINT
*                                      OF DEB VALIDITY CHECK ROUTINE
*                                      (ICB380)                XM9028*/
*      2 CVTRSV92 PTR(31),          /* RESERVED (MDC190)       YM2278*/
*      2 CVTRSV93 PTR(31),          /* RESERVED                      */
*      2 CVTRSV94 PTR(31),          /* RESERVED                      */
*      2 CVTQID PTR(31),            /* SAVE AS CVTQIDA BELOW ICB381  */
*       3 CVTRSV95 PTR(8),          /* RESERVED ICB381               */
*       3 CVTQIDA PTR(24),          /* ADDRESS OF QUEUE            0068
*                                      IDENTIFICATION (QID) TABLE  0068
*                                      PREFIX ICB381                 */
*      2 CVTOLTEP PTR(31),          /* POINTER TO CONTROL BLOCK    0068
*                                      CREATED BY SVC 59 TO POINT TO
*                                      PSEUDO-DEB'S ICB423           */
*      2 CVTRSV96 FIXED(15),        /* RESERVED                      */
*      2 CVTRSV97 FIXED(15),        /* RESERVED                      */
*      2 CVTRSV98 PTR(31),          /* RESERVED                      */
*      2 CVTRSV99 PTR(31),          /* RESERVED (MDC329)     @Z40AQ9A*/
*      2 CVTSKTA PTR(31),           /* ADDRESS OF STORAGE KEY TABLE
*                                      (VM HANDSHAKING) (OS/VS1)   0068
*                                      (MDC304)              @X04EP9A*/
*      2 CVTICB PTR(31),            /* ADDRESS OF MASS STORAGE SYSTEM
*                                      (MSS) CONTROL BLOCK (MDC305)
*                                                            @Z30LP9A*/
*      2 CVTRV400 BIT(8),           /* RESERVED                      */
*       3 CVTRV401 BIT(1),          /* RESERVED                      */
*       3 CVTRV402 BIT(1),          /* RESERVED                      */
*       3 CVTRV403 BIT(1),          /* RESERVED                      */
*       3 CVTRV404 BIT(1),          /* RESERVED                      */
*       3 CVTRV405 BIT(1),          /* RESERVED                      */
*       3 CVTRV406 BIT(1),          /* RESERVED                      */
*       3 CVTRV407 BIT(1),          /* RESERVED                      */
*       3 CVTRV408 BIT(1),          /* RESERVED                      */
*      2 CVTRV409 BIT(8),           /* RESERVED                      */
*       3 CVTRV410 BIT(1),          /* RESERVED                      */
*       3 CVTRV411 BIT(1),          /* RESERVED                      */
*       3 CVTRV412 BIT(1),          /* RESERVED                      */
*       3 CVTRV413 BIT(1),          /* RESERVED                      */
*       3 CVTRV414 BIT(1),          /* RESERVED                      */
*       3 CVTRV415 BIT(1),          /* RESERVED                      */
*       3 CVTRV416 BIT(1),          /* RESERVED                      */
*       3 CVTRV417 BIT(1),          /* RESERVED                      */
*      2 CVTRV418 PTR(8),           /* RESERVED                      */
*      2 CVTRV419 PTR(8),           /* RESERVED                      */
*      2 CVTRV420 PTR(15),          /* RESERVED                      */
*      2 CVTRV421 FIXED(15),        /* RESERVED                      */
*      2 CVTRV422 FIXED(15),        /* RESERVED                      */
*      2 CVTRV423 FIXED(15),        /* RESERVED                      */
*      2 CVTATCVT PTR(31),          /* POINTER TO VTAM'S CVT MDC080  */
*       3 CVTATACT BIT(1),          /* IF ON, VTAM IS ACTIVE MDC081  */
*      2 CVTRV425 PTR(31),          /* RESERVED                      */
*      2 CVTRV426 PTR(31),          /* RESERVED                      */
*      2 CVTRV427 PTR(31),          /* RESERVED                      */
*      2 CVTRV428 FIXED(31),        /* RESERVED                      */
*      2 CVTRV429 BIT(8),           /* RESERVED                      */
*       3 CVTRV430 BIT(1),          /* RESERVED                      */
*       3 CVTRV431 BIT(1),          /* RESERVED                      */
*       3 CVTRV432 BIT(1),          /* RESERVED                      */
*       3 CVTRV433 BIT(1),          /* RESERVED                      */
*       3 CVTRV434 BIT(1),          /* RESERVED                      */
*       3 CVTRV435 BIT(1),          /* RESERVED                      */
*       3 CVTRV436 BIT(1),          /* RESERVED                      */
*       3 CVTRV437 BIT(1),          /* RESERVED                      */
*      2 CVTRV438 BIT(8),           /* RESERVED                      */
*       3 CVTRV439 BIT(1),          /* RESERVED                      */
*       3 CVTRV440 BIT(1),          /* RESERVED                      */
*       3 CVTRV441 BIT(1),          /* RESERVED                      */
*       3 CVTRV442 BIT(1),          /* RESERVED                      */
*       3 CVTRV443 BIT(1),          /* RESERVED                      */
*       3 CVTRV444 BIT(1),          /* RESERVED                      */
*       3 CVTRV445 BIT(1),          /* RESERVED                      */
*       3 CVTRV446 BIT(1),          /* RESERVED                      */
*      2 CVTRV447 PTR(8),           /* RESERVED                      */
*      2 CVTRV448 PTR(8),           /* RESERVED                      */
*      2 CVTRV449 PTR(15),          /* RESERVED                      */
*      2 CVTRV450 FIXED(15),        /* RESERVED                      */
*      2 CVTRV451 FIXED(15),        /* RESERVED                      */
*      2 CVTRV452 FIXED(15),        /* RESERVED                      */
*      2 CVTRV453 PTR(31),          /* RESERVED                      */
*      2 CVTRV454 PTR(31),          /* RESERVED                      */
*      2 CVTRV455 PTR(31),          /* RESERVED                      */
*      2 CVTRV456 PTR(31),          /* RESERVED                      */
*      2 CVTRV457 BIT(8),           /* RESERVED                      */
*       3 CVTRV458 BIT(1),          /* RESERVED                      */
*       3 CVTRV459 BIT(1),          /* RESERVED                      */
*       3 CVTRV460 BIT(1),          /* RESERVED                      */
*       3 CVTRV461 BIT(1),          /* RESERVED                      */
*       3 CVTRV462 BIT(1),          /* RESERVED                      */
*       3 CVTRV463 BIT(1),          /* RESERVED                      */
*       3 CVTRV464 BIT(1),          /* RESERVED                      */
*       3 CVTRV465 BIT(1),          /* RESERVED                      */
*      2 CVTRV466 BIT(8),           /* RESERVED                      */
*       3 CVTRV467 BIT(1),          /* RESERVED                      */
*       3 CVTRV468 BIT(1),          /* RESERVED                      */
*       3 CVTRV469 BIT(1),          /* RESERVED                      */
*       3 CVTRV470 BIT(1),          /* RESERVED                      */
*       3 CVTRV471 BIT(1),          /* RESERVED                      */
*       3 CVTRV472 BIT(1),          /* RESERVED                      */
*       3 CVTRV473 BIT(1),          /* RESERVED                      */
*       3 CVTRV474 BIT(1),          /* RESERVED                      */
*      2 CVTRV475 PTR(8),           /* RESERVED                      */
*      2 CVTRV476 PTR(8),           /* RESERVED                      */
*      2 CVTRV477 PTR(8),           /* RESERVED                      */
*      2 CVTRV478 PTR(8),           /* RESERVED                      */
*      2 CVTRV479 FIXED(15),        /* RESERVED                      */
*      2 CVTRV480 PTR(31),          /* RESERVED                      */
*      2 CVTRV481 PTR(31),          /* RESERVED                      */
*      2 CVTRV482 PTR(31);          /* RESERVED                      */
*/*                       CVT PREFIX                                 */
*                                                                  0069
*   DCL                                                            0069
*     1 CVTFIX BASED(CVTPTR-256) BDY(WORD),                        0069
*      2 * CHAR(248) BDY(WORD),     /* RESERVED                      */
*      2 * CHAR(2) BDY(WORD),       /* RESERVED                      */
*      2 CVTMDL CHAR(2) BDY(WORD,3),/* CPU MODEL NUMBER IN SIGNLESS
*                                      PACKED DECIMAL, I.E., A MODEL
*                                      145 WOULD BE REPRESENTED AS 0069
*                                      0145 HEX                      */
*      2 CVTRELNO CHAR(4) BDY(WORD),/* RELEASE NUMBER (EBCDIC)       */
*       3 CVTNUMB CHAR(2) BDY(WORD),/* RELEASE NUMBER                */
*       3 CVTLEVL CHAR(2) BDY(WORD,3);/* LEVEL NUMBER OF THIS RELEASE*/
*/*                    END OF CVT MACRO                              */
*                                                                  0070
* /*                                                               0070
*        MACRO                                                     0070
*        EWAMAP                                                    0070
*WA      DSECT                                                     0070
*        SPACE 1                                                   0070
****************************************************************   0070
*                                                              *   0070
*  THIS DSECT DESCRIBES THE ERROR PROCEDURE WORK AREA COMMON   *   0070
*  SECTION WHICH IS INVOKED BY  IECDERWA  AS AN INNER MACRO.   *   0070
*  IT IS GOTTEN BY THE I/O INTERRUPT HANDLER OR POST STATUS.   *   0070
*  THE WORKAREA CONSISTS OF TWO  SECTIONS:   -   THE  COMMON   *   0070
*  SECTION WHICH CONTAINS INDICATORS,  COUNTERS,  AND  SENSE   *   0070
*  INFORMATION - AND ERP DEPENDENT SECTIONS WHICH ARE AVAIL-   *   0070
*  ABLE FOR ERP USE AS NEEDED.  THE DEPENDENT  SECTIONS  ARE   *   0070
*  INCLUDED BY IECDERWA VIA OPTIONS THROUGH THE MACRO  CALL.   *   0070
*                                                              *   0070
****************************************************************   0070
*        SPACE 1                                                   0070
*WAHDR   DS    0F                                                  0070
*WAEXT   DS    A                   ADDRESS OF WORKAREA EXTENSION   0070
*WAFLG1  DS    XL1                 FLAG BYTE 1                     0070
*WASLIS  EQU   X'80'               W.A. INVOLVED IN RECOVERY SENSE 0070
*        EQU   X'70'               RESERVED                        0070
*WASCCD  EQU   X'0C'               SIO CONDITION CODE              0070
*WASCC3  EQU   X'0C'               CONDITION CODE 3                0070
*WASCC2  EQU   X'08'               CONDITION CODE 2                0070
*WASCC1  EQU   X'04'               CONDITION CODE 1                0070
*WASCC0  EQU   X'00'               CONDITION CODE 0                0070
*WADDMSG EQU   X'02'               ERP DEPENDENT DATA TO BE        0070
*                                  INCLUDED IN I/O ERROR MESSAGE   0070
*WABDSNS EQU   X'01'               SENSE UNSUCCESSFUL              0070
*WAFLG2  DS    XL1                 FLAG BYTE 2                     0070
*WAMDR   EQU   X'80'               IF ON, MDR REQUEST              0070
*                                  IF OFF, OBR REQUEST             0070
*WAWTEMP EQU   X'40'               ON - TEMPORARY WRITE ERROR      0070
*                                  COUNTER TO BE UPDATED IF        0070
*                                  DATA CHECK CONDITION            0070
*                                  OFF - TEMPORARY READ ERROR      0070
*                                  COUNTER TO BE UPDATED           0070
*WACOVF  EQU   X'20'               COUNTER OVERFLOW INDICATOR      0070
*                                  FOR STATISTICS UPDATE           0070
*WADIR   EQU   X'10'               DIR IN PROGRESS                 0070
*        EQU   X'0F'               RESERVED                        0070
*WAFLG3  DS    XL1                 FOR DEVICE DEPENDENT ERP USAGE  0070
*WAJAM   EQU   X'80'               3800 PAPER JAM              @Y40MPLG
*WASNSCT DS    XL1                 LOOP COUNT FOR SENSE FAILURE    0070
*WASCTMX EQU   X'10'               MAX # OF SENSES TRIED           0070
*WASSTAT DS    XL2                 CSW STATUS ON SENSE OPERATION   0070
*                                  IF THIS IS A UNIT CHECK         0070
*WACNTR1 DS    XL1                 COUNTERS FOR ERP USE            0070
*WACNTR2 DS    XL1                                                 0070
*WACNTR3 DS    XL1                                                 0070
*WACNTR4 DS    XL1                                                 0070
*WASTUP  DS    XL2                 STATISTICS INFORMATION FOR      0070
*                                  USE IN STATISTICS UPDATE        0070
*WAERPIB DS    XL8                 ERPIB BUILT BY CCH FOR CHANNEL  0070
*                                  ERRORS TO INDICATE WHETHER      0070
*                                  RETRY IS TO BE ATTEMPTED        0070
*        ORG   EWAERPIB                                            0070
*        DS    XL1                 RESERVED                        0070
*WAUCB   DS    AL3                 UCB ADDRESS                     0070
*WARGFG1 DS    XL1                 FLAG BYTE                       0070
*WACSIO  EQU   X'80'               CSW STORED AFTER SIO            0070
*WACINT  EQU   X'40'               CSW STORED AFTER I/O INTERRUPT  0070
*WACTIO  EQU   X'20'               CSW STORED AFTER TEST I/O       0070
*WACHIO  EQU   X'10'               CSW STORED AFTER HALT I/O       0070
*        EQU   X'08'               RESERVED                        0070
*WACSNS  EQU   X'04'               SENSE DATA WAS STORED           0070
*WACCNT  EQU   X'02'               CSW COUNT IS VALID              0070
*WANORTY EQU   X'01'               NO RETRY INDICATOR              0070
*WARGFG2 DS    XL1                 PROBABLE SOURCE INDICATORS      0070
*WACCPU  EQU   X'80'               CPU ERROR                       0070
*WACCHA  EQU   X'40'               CHANNEL ERROR                   0070
*WACSCU  EQU   X'20'               STORAGE CONTROL UNIT ERROR      0070
*WACSTG  EQU   X'10'               STORAGE ERROR                   0070
*WACCUE  EQU   X'08'               CONTROL UNIT ERROR              0070
*        EQU   X'07'               RESERVED                        0070
*WAXCSW1 DS    XL1                 VALIDITY INDICATORS             0070
*WACITF  EQU   X'80'               INTERFACE ADDR IS VALID         0070
*        EQU   X'60'               RESERVED                        0070
*WACSQV  EQU   X'10'               SEQUENCE CODE IS VALID          0070
*WACUNS  EQU   X'08'               UNIT STATUS IS VALID            0070
*WACCMD  EQU   X'04'               COMMAND ADDRESS IS VALID        0070
*WACCHV  EQU   X'02'               CHANNEL ADDRESS IS VALID        0070
*WACDAV  EQU   X'01'               DEVICE ADDRESS IS VALID         0070
*WAXCSW2 DS    XL1                 TERMINATION & SEQUENCE CODES    0070
*WACTEC  EQU   X'C0'               TERMINATION CODE.               0070
*WATER0  EQU   X'00'               INTERFACE DISCONNECT            0070
*WATER1  EQU   X'04'               STOP, STACK, OR NORMAL TERM     0070
*WATER2  EQU   X'80'               SELECTIVE RESET                 0070
*WATER3  EQU   X'C0'               SYSTEM RESET                    0070
*        EQU   X'30'               RESERVED                        0070
*WACDIN  EQU   X'08'               I/O ERROR ALERT                 0070
*WACSEQ  EQU   X'07'               CHANNEL DEPENDENT SEQ. CODES    0070
*WASEQ0  EQU   X'00'                                               0070
*WASEQ1  EQU   X'01'                                               0070
*WASEQ2  EQU   X'02'                                               0070
*WASEQ3  EQU   X'03'                                               0070
*WASEQ4  EQU   X'04'                                               0070
*WASEQ5  EQU   X'05'                                               0070
*WASEQ6  EQU   X'06'                                               0070
*WASEQ7  EQU   X'07'                                               0070
*        ORG   EWAERPIB+L'EWAERPIB  '                              0070
*WACHA   DS    XL2                 UNIT ADDRESS ON WHICH LAST      0070
*                                   I/O WAS STARTED                0070
*        DS    XL1                 RESERVED                        0070
*WACPU   DS    XL1                 CPUID OF CPU ON WHICH I/O       0070
*                                  ERROR WAS ENCOUNTERED           0070
*WADCNT  DS    XL1                 NUMBER OF BYTES OF OBR INFO     0070
*WADDISP DS    XL3                 ADDRESS OF FIRST BYTE OF OBR    0070
*                                  DEVICE DEPENDENT INFORMATION    0070
*WAIERP  DS    XL128               AREA FOR INDIVIDUAL ERP USE     0070
*        ORG   EWAIERP                                             0070
*        SPACE 1                                                   0070
*  IOS USAGE OF ERP DEPENDENT AREA FOR READING SENSE DATA  AND     0070
*  FOR A TEMPORARY STORAGE BEFORE THE ERP IS INITIALLY ENTERED     0070
*WASNS   EQU   *                   SENSE DATA START                0070
*        DS    XL64                SENSE INFORMATION               0070
*WASCSW  DS    CL7                 SLOT TO SAVE CSW ON INTERCEPT   0070
*WAHL    EQU   32                  HEADER LENGTH                   0070
*        MEND                                                      0070
* */                                                               0070
*                                                                  0070
* /************************************************************/   0070
* /*                                                          */   0070
* /* THIS STRUCTURE DESCRIBES THE ERROR PROCEDURE  WORK AREA  */   0070
* /* COMMON SECTION WHICH IS INVOKED BY IECDERWA AS AN INNER  */   0070
* /* MACRO.  IT IS GOTTEN BY THE I/O  INTERRUPT  HANDLER  OR  */   0070
* /* POST STATUS. THE WORKAREA CONSISTS OF TWO SECTIONS: THE  */   0070
* /* COMMON SECTION WHICH CONTAINS INDICATORS, COUNTERS, AND  */   0070
* /* SENSE INFORMATION - AND  ERP DEPENDENT  SECTIONS  WHICH  */   0070
* /* ARE AVAILABLE FOR ERP USE AS NEEDED. THE DEPENDENT SEC-  */   0070
* /* TIONS ARE INCLUDED BY IECDERWA VIA OPTIONS THROUGH  THE  */   0070
* /* MACRO CALL.                                              */   0070
* /*                                                          */   0070
* /************************************************************/   0070
*                                                                  0070
*   DCL 1 EWA  BDY(DWORD) BASED(EWAPTR),                           0070
*       2  EWAHDR   PTR(31),       /* EWA HEADER              */   0070
*         3 EWAEXT  PTR(31),       /* ADDRESS OF WA EXTENTION */   0070
*       2  EWAFLAGS CHAR(4),       /* FOUR BYTES OF FLAGS     */   0070
*         3 EWAFLG1 BIT(8),        /* FLAG BYTE 1             */   0070
*          4 EWASLIS BIT(1),       /* WORK AREA INVOLVED IN   */   0070
*                                  /* RECOVERY SENSE          */   0070
*          4 *        BIT(3),      /* RESERVED                */   0070
*          4 EWASCCD  BIT(2),      /* SIO CONDITION CODE      */   0070
*           5 EWASCC3 BIT(2),      /* CONDITION CODE 3        */   0070
*            6 EWASCC2 BIT(1),     /* CONDITION CODE 2        */   0070
*            6 EWASCC1 BIT(1),     /* CONDITION CODE 1             0070
*                                     SEE END OF EWA FOR CC 0 */   0070
*          4 EWADDMSG BIT(1),      /* ERP DEPENDENT DATA TO BE     0070
*                                     INCLUDED IN I/O ERROR        0070
*                                     MESSAGE                 */   0070
*          4 EWABDSNS BIT(1),      /* SENSE UNSUCCESSFUL      */   0070
*         3 EWAFLG2 BIT(8),        /* FLAG BYTE 2             */   0070
*          4 EWAMDR BIT(1),        /* IF ON, MDR REQUEST           0070
*                                     IF OFF, OBR REQUEST     */   0070
*          4 EWAWTEMP BIT(1),      /* ON - TEMPORARY WRITE ERR     0070
*                                     COUNTER TO BE UPDATE IF      0070
*                                     DATA CHECK CONDITION         0070
*                                     OFF - TEMPORARY READ ERR     0070
*                                     COUNTER TO BE UPDATED   */   0070
*          4 EWACOVF BIT(1),       /* COUNTER OVERFLOW FOR         0070
*                                     STATISTICS UPDATE       */   0070
*          4 EWADIR  BIT(1),       /* DIR IN PROGRESS         */   0070
*          4 *     BIT(4),         /* RESERVED                */   0070
*         3 EWAFLG3 BIT(8),        /* FOR DEVICE DEPENDENT ERP     0070
*                                     USAGE                   */   0070
*          4 EWAJAM BIT(1),        /* 3800 PAPER JAM         @Y40MPLG*/
*         3 EWASNSCT BIT(8),       /* LOOP COUNT FOR SENSE         0070
*                                     FAILURE                 */   0070
*         4 *        BIT(3),       /* RESERVED                */   0070
*         4 EWASCTMX BIT(1),       /* MAX. # OF SENSES TRIED  */   0070
*       2  EWASSTAT BIT(16),       /* CSW STATUS ON SENSE OP-      0070
*                                     ERATION IF THIS IS A         0070
*                                     UNIT CHECK.             */   0070
*       2  EWACNTRS CHAR(4),       /* COUNTERS FOR ERP USE    */   0070
*         3 EWACNTR1 PTR(8),       /* COUNTER 1               */   0070
*         3 EWACNTR2 PTR(8),       /* COUNTER 2               */   0070
*         3 EWACNTR3 PTR(8),       /* COUNTER 3               */   0070
*         3 EWACNTR4 PTR(8),       /* COUNTER 4               */   0070
*       2  EWASTUP  CHAR(2),       /* STATISTICS INFORMATION       0070
*                                     FOR UPDATING STATISTICS */   0070
*       2  EWAERPIB CHAR(8),       /* ERPIB BUILT BY CCH FOR       0070
*                                     CHANNEL ERRORS TO INDI-      0070
*                                     CATE TO ATTEMPT A RETRY */   0070
*         3 *        CHAR(1),      /* RESERVED                */   0070
*         3 EWAUCB   PTR(24)   BDY(BYTE),                          0070
*                                  /* UCB ADDRESS             */   0070
*         3 EWARGFG1 BIT(8),       /* FLAG BYTE               */   0070
*          4 EWACSIO BIT(1),       /* CSW STORED AFTER SIO    */   0070
*          4 EWACINT BIT(1),       /* CSW STORED AFTER I/O INT*/   0070
*          4 EWACTIO BIT(1),       /* CSW STORED AFTR TEST I/O*/   0070
*          4 EWACHIO BIT(1),       /* CSW STORED AFTR HALT I/O*/   0070
*          4 *       BIT(1),       /* RESERVED                */   0070
*          4 EWACSNS BIT(1),       /* SENSE DATA WAS STORED   */   0070
*          4 EWACCNT BIT(1),       /* CSW COUNT IS VALID      */   0070
*          4 EWANORTY BIT(1),      /* NO RETRY INDICATOR      */   0070
*         3 EWARGFG2 BIT(8),       /* PROBABLE SOURCE INDICTRS*/   0070
*          4 EWACCPU BIT(1),       /* CPU ERROR               */   0070
*          4 EWACCHA BIT(1),       /* CHANNEL ERROR           */   0070
*          4 EWACSCU BIT(1),       /* STORAGE CONTROL UNIT ERR*/   0070
*          4 EWACSTG BIT(1),       /* STORAGE ERROR           */   0070
*          4 EWACCUE BIT(1),       /* CONTROL UNIT ERROR      */   0070
*          4 *       BIT(3),       /* RESERVED                */   0070
*         3 EWAXCSW1 BIT(8),       /* VALIDITY INDICATORS     */   0070
*          4 EWACITF BIT(1),       /* INTERFACE ADDR IS VALID */   0070
*          4 *       BIT(2),       /* RESERVED                */   0070
*          4 EWACSQV BIT(1),       /* SEQUENCE CODE IS VALID  */   0070
*          4 EWACUNS BIT(1),       /* UNIT STATUS IS VALID    */   0070
*          4 EWACCMD BIT(1),       /* COMMAND ADDRESS IS VALID*/   0070
*          4 EWACCHV BIT(1),       /* CHANNEL ADDR IS VALID   */   0070
*          4 EWACDAV BIT(1),       /* DEVICE ADDRESS IS VALID */   0070
*         3 EWAXCSW2 BIT(8),       /* TERMINATN & SEQNCE CODES*/   0070
*          4 EWACTEC BIT(2),       /* TERMINATION CODE             0070
*                                     SEE BELOW FOR VALUES    */   0070
*          4 *       BIT(2),       /* RESERVED                */   0070
*          4 EWACDIN BIT(1),       /* I/O ERROR ALERT         */   0070
*          4 EWACSEQ BIT(3),       /* SEQUENCE CODES - SEE         0070
*                                     BELOW                   */   0070
*       2  EWACHA   CHAR(2),       /* UNIT ADDRESS ON WHICH        0070
*                                     LAST I/O WAS STARTED    */   0070
*       2  *        CHAR(1),       /* RESERVED                */   0070
*       2  EWACPU   CHAR(1),       /* CPUID OF I/O ERROR      */   0070
*       2  EWADCNT  CHAR(1),       /* # OF BYTES OF OBR INFO  */   0070
*       2  EWADDISP PTR(24),       /* ADDRESS OF OBR DEVICE        0070
*                                     DEPENDENT INFORMATION   */   0070
*       2  EWAIERP  CHAR(128)  BDY(DWORD);                         0070
*                                  /* AREA FOR INDIVIDUL ERPS */   0071
*                                                                  0071
*  DCL 1 EWADDIOS CHAR(71) DEF(EWAIERP) BDY(DWORD),                0071
*                                                                  0071
* /*  IOS USAGE OF ERP DEPENDENT AREA FOR READING SENSE DATA  */   0071
* /*  FOR TEMPORARY STORAGE BEFORE ERP IS INITIALLY ENTERED.  */   0071
*                                                                  0071
*       2  EWASNS  CHAR(64),       /* SENSE DATA START        */   0071
*       2  EWASCSW CHAR(7),        /* SLOT TO SAVE CSW ON          0071
*                                     INTERCEPT               */   0071
*       2  EWAEND  CHAR(0);        /* END OF EWA              */   0071
*   DCL EWASCC0 BIT(8) CONSTANT('00'X);  /*                        0072
*                                     CONDITION CODE 0        */   0072
*   DCL EWATER0 BIT(2) CONSTANT('00'B);  /*                        0073
*                                  INTERFACE DISCONNECT       */   0073
*   DCL EWATER1 BIT(2) CONSTANT('01'B);  /*                        0074
*                                  STOP, STACK, NORMAL TERMNTN*/   0074
*   DCL EWATER2 BIT(2) CONSTANT('10'B);  /*                        0075
*                                  SELECTIVE RESET            */   0075
*   DCL EWATER3 BIT(2) CONSTANT('11'B);  /*                        0076
*                                  SYSTEM RESET               */   0076
*   DCL EWACSEQ0 BIT(3) CONSTANT('000'B);                          0077
*   DCL EWACSEQ1 BIT(3) CONSTANT('001'B);                          0078
*   DCL EWACSEQ2 BIT(3) CONSTANT('010'B);                          0079
*   DCL EWACSEQ3 BIT(3) CONSTANT('011'B);                          0080
*   DCL EWACSEQ4 BIT(3) CONSTANT('100'B);                          0081
*   DCL EWACSEQ5 BIT(3) CONSTANT('101'B);                          0082
*   DCL EWACSEQ6 BIT(3) CONSTANT('110'B);                          0083
*   DCL EWACSEQ7 BIT(3) CONSTANT('111'B);                          0084
*/*                                                                0085
*        MACRO                                                     0085
*        EWUMAP                                                    0085
**/                                                                0085
*/********************************************************************/
*/* EWUMAP MAPS THE DEVICE DEPENDENT SECTION OF THE ERP WORK AREA    */
*/*        FOR UNIT RECORD DEVICES. IT IS CALLED AS AN INNER MACRO   */
*/*        FROM IECDERWA.                                            */
*/*        THE FOLLOWING CODES ARE USED TO INDICATE WHICH DEVICES    */
*/*        THE FIELDS APPLY TO:                                      */
*/*        A - 1403,1443                                             */
*/*        B - 3211                                                  */
*/*        C - 1442,2501,2520,2596                                   */
*/*        D - 1402,2540                                             */
*/*        E - 3505,3525                                             */
*/*        F - 2671                                                  */
*/********************************************************************/
*/*                                                                0085
*        ORG   EWAIERP                                             0085
*WUSN0   DS    X                  1ST SENSE BYTE                   0085
*WUCREJ  EQU   X'80'              COMMAND REJECT      (ALL)        0085
*WUINT   EQU   X'40'              INTERVENTION REQD.  (ALL)        0085
*WUBUSO  EQU   X'20'              BUS OUT             (ALL)        0085
*WUEQCK  EQU   X'10'              EQUIPMENT CHECK     (ALL)        0085
*WUDTCK  EQU   X'08'              DATA CHECK          (ALL)        0085
*WUBUFP  EQU   X'04'              BUFFER PARITY       (A,B)        0085
*WUOVRN  EQU   X'04'              OVERRUN             (C)          0085
*WULDCK  EQU   X'02'              LOAD CHECK          (B)          0085
*WUUSEQ  EQU   X'02'              UNUSUAL SEQUENCE    (D)          0085
*WUABFR  EQU   X'02'              ABNORMAL FMT RESET  (E)          0085
*WUCH9   EQU   X'01'              CHANNEL 9           (A,B)        0085
*WUPEK   EQU   X'01'              PERMANENT ERROR KEY (E)          0085
*WUSN1   DS    X                  2ND SENSE BYTE                   0085
*WUCRTRY EQU   X'80'              COMMAND RETRY       (B)          0085
*WUPERM  EQU   X'80'              PERMANENT ERROR     (E)          0085
*WUPCK   EQU   X'40'              PRINT CHECK         (B)          0085
*WUARTRY EQU   X'40'              AUTOMATIC RETRY     (E)          0085
*WUPQ    EQU   X'20'              PRINT QUALITY       (B)          0085
*WUMOT   EQU   X'20'              MOTION ERROR        (E)          0085
*WULNPOS EQU   X'10'              LINE POSITION       (B)          0085
*WUIRTRY EQU   X'10'              RETRY AFTER INT.REQ.(E)          0085
*WUFORM  EQU   X'08'              FORMS CHECK         (B)          0085
*WUSUPR  EQU   X'04'              COMMAND SUPPRESS    (B)          0085
*WUMECMO EQU   X'02'              MECHANICAL MOTION   (B)          0085
*WUSN2   DS    X                  3RD SENSE BYTE                   0085
*WUUCSBP EQU   X'80'              UCS PARITY ERROR    (B)          0085
*WUPLBP  EQU   X'40'              PLB PARITY ERROR    (B)          0085
*WUFCBP  EQU   X'20'              FCB PARITY ERROR    (B)          0085
*WUSN3   DS    X                  4TH SENSE BYTE                   0085
*WUSN4   DS    X                  5TH SENSE BYTE                   0085
*WUSN5   DS    X                  6TH SENSE BYTE                   0085
*        DS    XL2                RESERVED                         0085
*WUWORK  DS    0D,120X            RESERVED FOR COMPILER ASSIGNED TEMPS
*        MEND                                                      0085
**/                                                                0085
* DCL                                                              0085
*  1 EWUMAP CHAR(128)BDY(DWORD)DEF(EWAIERP),                       0085
*   2 EWUSN0 BIT(8),            /*1ST SENSE BYTE                     */
*    3 EWUCREJ BIT(1),          /*COMMAND REJECT      (ALL)          */
*    3 EWUINT  BIT(1),          /*INTERVENTION REQD.  (ALL)          */
*    3 EWUBUSO BIT(1),          /*BUS OUT             (ALL)          */
*    3 EWUEQCK BIT(1),          /*EQUIPMENT CHECK     (ALL)          */
*    3 EWUDTCK BIT(1),          /*DATA CHECK          (ALL)          */
*    3 EWUBUFP BIT(1),          /*BUFFER PARITY       (A,B)          */
*     4 EWUOVRN BIT(1),         /*OVERRUN             (C)            */
*    3 EWULDCK BIT(1),          /*LOAD CHECK          (B)            */
*     4 EWUUSEQ BIT(1),         /*UNUSUAL SEQUENCE    (D)            */
*      5 EWUABFR BIT(1),        /*ABNORMAL FMT RESET  (E)            */
*    3 EWUCH9  BIT(1),          /*CHANNEL 9           (A,B)          */
*     4 EWUPEK  BIT(1),         /*PERMANENT ERROR KEY (E)            */
*   2 EWUSN1 BIT(8),            /*2ND SENSE BYTE                     */
*    3 EWUCRTRY BIT(1),         /*COMMAND RETRY       (B)            */
*     4 EWUPERM BIT(1),         /*PERMANENT ERROR     (E)            */
*    3 EWUPCK BIT(1),           /*PRINT CHECK         (B)            */
*     4 EWUARTRY BIT(1),        /*AUTOMATIC RETRY     (E)            */
*    3 EWUPQ BIT(1),            /*PRINT QUALITY       (B)            */
*     4 EWUMOT BIT(1),          /*MOTION ERROR        (E)            */
*    3 EWULNPOS BIT(1),         /*LINE POSITION       (B)            */
*     4 EWUIRTRY BIT(1),        /*RETRY AFTER INT.REQ.(E)            */
*    3 EWUFORM BIT(1),          /*FORMS CHECK         (B)            */
*    3 EWUSUPR BIT(1),          /*COMMAND SUPPRESS    (B)            */
*    3 EWUMECMO BIT(1),         /*MECHANICAL MOTION   (B)            */
*    3 * BIT(1),                /*RESERVED                           */
*   2 EWUSN2 BIT(8),            /*3RD SENSE BYTE                     */
*    3 EWUUCSBP BIT(1),         /*UCS PARITY ERROR    (B)            */
*    3 EWUPLBP BIT(1),          /*PLB PARITY ERROR    (B)            */
*    3 EWUFCBP BIT(1),          /*FCB PARITY ERROR    (B)            */
*   2 EWUSN3 BIT(8),            /*4TH SENSE BYTE                     */
*   2 EWUSN4 BIT(8),            /*5TH SENSE BYTE                     */
*   2 EWUSN5 BIT(8),            /*6TH SENSE BYTE                     */
*   2 * CHAR(2),                /*RESERVED                           */
*   2 EWUWORK CHAR(120)BDY(DWORD);/*RESERVED FOR COMPILER TEMPS      */
*START:                                                            0086
*   RFY                                                            0086
*     RE RSTD;                                                     0086
START    DS    0H                                                  0087
*   IOSBPTR=R1;                     /* PICKUP POINTER TO IOSB FROM 0087
*                                      LINKAGE REGISTER              */
         LR    IOSBPTR,R1                                          0087
*   EWAPTR=IOSERP;                  /* INITIALIZE POINTER TO ERP WORK
*                                      AREA                          */
         L     EWAPTR,IOSERP(,IOSBPTR)                             0088
*   DATABASE=ADDR(EWUWORK);         /* BASE REG FOR @DATD DSECT      */
         LA    DATABASE,EWUWORK(,EWAPTR)                           0089
*   RFY                                                            0090
*     R1 UNRSTD;                                                   0090
*   RFY                                                            0091
*     RE UNRSTD;                                                   0091
*   CVTPTR=CVTPTRXX;                                               0092
         MVC   CVTPTR(4),CVTPTRXX                                  0092
*   IOSERR=ON;                      /* INDICATE ERP IN CONTROL       */
*   IOSEX=ON;                                                      0094
         OI    IOSERR(IOSBPTR),B'00100100'                         0094
*   IF IOSCCHN=ON&IOSDCHN=ON THEN                                  0095
         TM    IOSCCHN(IOSBPTR),B'11000000'                        0095
         BO    @RT00095                                            0095
*     GOTO MSG;                     /* NO RECOVERY ATTEMPTED FOR   0096
*                                      MIXED CHANNEL PROGS           */
*   IF IOSCCHN=ON THEN                                             0097
         TM    IOSCCHN(IOSBPTR),B'01000000'                        0097
         BNO   @RF00097                                            0097
*     DO;                                                          0098
*       CCWPTR=IOSCSWCA-8;          /* POINT TO FAILING CCW FOR CC   */
         L     @12,IOSCSWCA-1(,IOSBPTR)                            0099
         LA    @12,0(,@12)                                         0099
         SH    @12,@CH00088                                        0099
         ST    @12,CCWPTR                                          0099
*       RFY                                                        0100
*         R3 RSTD;                                                 0100
*       R3=CCWPTR;                                                 0101
         LR    R3,@12                                              0101
*       GEN REFS(R3) SETS(R3)(LRA   R3,0(R3));                     0102
         LRA   R3,0(R3)
*       IF ENTFLAG=ON THEN          /* TEST FOR ERROR ON SAME CCW -
*                                      RESET EQUIP CK CTR IF NOT SAME
*                                                            @ZA11096*/
         TM    ENTFLAG(EWAPTR),B'01000000'                         0103
         BNO   @RF00103                                            0103
*         IF R3^=IOSRST THEN                                       0104
         C     R3,IOSRST(,IOSBPTR)                                 0104
         BE    @RF00104                                            0104
*           EQCTR=0;                                               0105
         MVI   EQCTR(EWAPTR),X'00'                                 0105
*         ELSE                                                     0106
*           ;                                                      0106
@RF00104 DS    0H                                                  0107
*       ELSE                                                       0107
*         ;                                                        0107
@RF00103 DS    0H                                                  0108
*       IOSRST=R3;                                                 0108
         ST    R3,IOSRST(,IOSBPTR)                                 0108
*       RFY                                                        0109
*         R3 UNRSTD;                                               0109
*     END;                                                         0110
*   ELSE                                                           0111
*     CCWPTR=IOSVST;                /* POINT TO FIRST CCW FOR CD     */
         B     @RC00097                                            0111
@RF00097 MVC   CCWPTR(4),IOSVST(IOSBPTR)                           0111
*STATUS:                                                           0112
*   RFY                                                            0112
*    (R0,                                                          0112
*     R1,                                                          0112
*     RE,                                                          0112
*     RB,                                                          0112
*     RC,                                                          0112
*     RF) RSTD;                                                    0112
@RC00097 DS    0H                                                  0112
STATUS   DS    0H                                                  0113
*   R1=IOSBPTR;                                                    0113
         LR    R1,IOSBPTR                                          0113
*   RF=CVTXITP;                     /* ADDRESS OF ERROR INTERPERTER  */
         L     @04,CVTPTR                                          0114
         L     RF,CVTXITP(,@04)                                    0114
*   GEN REFS(RE,RF) FLOWS(LOG$MSG,NOLOGMSG,UEXIL,OK,SENSE);        0115
G1       BALR  RE,RF  CALL INTERPERTER WITH LIST ADDR IN REG 12
         DC    X'1D',AL1(G2-G1-2)   CHANNEL CONTROL CHECK
         DC    X'1E',AL1(G2-G1-4)   INTERFACE CONTROL CHECK
         DC    X'1F',AL1(G2-G1-6)   CHAINING CHECK
         DC    X'16',AL1(SENSE-G1-8) UNIT CHECK
         DC    X'1C',AL1(G2-G1-10)  CHANNEL DATA CHECK
         DC    X'1A',AL1(G4-G1-12)  PROGRAM CHECK
         DC    X'1B',AL1(G4-G1-14)  PROTECTION CHECK
         DC    X'17',AL1(G5-G1-16)  UNIT EXCEPTION
         DC    X'19',AL1(G5-G1-18)  INCORRECT LENGTH
         DC    X'2F',AL1(G6-G1-20)  GOOD STATUS
*SENSE:                                                            0116
*   EWASTUP(1:1)=EWASTUP(1:1)|IOSSNS(1:8)&STATMASK;                0116
SENSE    MVC   @TS00001(1),IOSSNS(IOSBPTR)                         0116
         NI    @TS00001,X'78'                                      0116
         OC    EWASTUP(1,EWAPTR),@TS00001                          0116
*   R1=IOSBPTR;                                                    0117
         LR    R1,IOSBPTR                                          0117
*   RF=CVTXITP;                                                    0118
         L     @04,CVTPTR                                          0118
         L     RF,CVTXITP(,@04)                                    0118
*   GEN REFS(RE,RF) FLOWS(LOG$MSG,INTREQ,RETRY,MSG);               0119
G3       BALR  RE,RF
         DC    X'05',AL1(G2-G3-2)   UNDEFINED
         DC    X'06',AL1(G2-G3-4)   UNDEFINED
         DC    X'07',AL1(G2-G3-6)   UNDEFINED
         DC    X'03',AL1(GA-G3-8)   EQUIPMENT CHECK        /*@ZA11096*/
         DC    X'01',AL1(G7-G3-10)  INTERVENTION REQUIRED
         DC    X'02',AL1(G8-G3-12)  BUSOUT CHECK
         DC    X'04',AL1(G2-G3-14)  DATA CHECK
         DC    X'00',AL1(G9-G3-16)  COMMAND REJECT
         DC    X'2F',AL1(G2-G3-18)  UNIT CHECK & NO SENSE BITS
G2       B     LOG$MSG
G4       B     NOLOGMSG
G5       B     UEXIL
G6       B     OK
G7       B     INTREQ
G8       B     RETRY
G9       B     MSG
GA       B     EQCHECK                                     /*@ZA11096*/
*   RFY                                                            0120
*    (R0,                                                          0120
*     R1,                                                          0120
*     RE,                                                          0120
*     RB,                                                          0120
*     RC,                                                          0120
*     RF) UNRSTD;                                                  0120
*                                                                  0120
*   /*****************************************************************/
*   /*                                                               */
*   /* EQUIPMENT CHECK RETRY CCW 3 TIMES.PRINT INTERVENTION REQ FOR  */
*   /* EACH TRY. IF NOT SUCCESSFUL, GO TO PERMANENT ERROR    @ZA11096*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0121
*EQCHECK:                           /*                       @ZA11096*/
*   IF EQCTR<'03'X THEN             /*                       @ZA11096*/
EQCHECK  CLI   EQCTR(EWAPTR),X'03'                                 0121
         BNL   @RF00121                                            0121
*     DO;                                                          0122
*       EQCTR=EQCTR+1;              /*                       @ZA11096*/
         LA    @12,1                                               0123
         MVC   @ZT00003+3(1),EQCTR(EWAPTR)                         0123
         AL    @12,@ZT00003                                        0123
         STC   @12,EQCTR(,EWAPTR)                                  0123
*       ENTFLAG=ON;                 /*                       @ZA18279*/
         OI    ENTFLAG(EWAPTR),B'01000000'                         0124
*       GOTO WTOXCTL;               /*                       @ZA11096*/
         B     WTOXCTL                                             0125
*     END;                                                         0126
*   ELSE                                                           0127
*     EQCTR='00'X;                  /*                       @ZA11096*/
@RF00121 MVI   EQCTR(EWAPTR),X'00'                                 0127
*LOG$MSG:                           /* PERMANENT ERROR. WTO & RECORD
*                                      ON LOGREC                     */
*   IOSLOG=ON;                                                     0128
LOG$MSG  OI    IOSLOG(IOSBPTR),B'00000001'                         0128
*MSG:                               /* PERMANENT ERROR. WTO          */
*   IOSMSG=ON;                                                     0129
MSG      OI    IOSMSG(IOSBPTR),B'00000100'                         0129
*   IOSERR=OFF;                                                    0130
         NI    IOSERR(IOSBPTR),B'11011111'                         0130
*   RFY                                                            0131
*    (R1,                                                          0131
*     RD,                                                          0131
*     RE) RSTD;                                                    0131
*WTOXCTL:                                                          0132
*   GEN;                                                           0132
WTOXCTL  DS    0H                                                  0132
    L    RD,16(IOSBPTR)         GET UCB ADDRESS                @ZA05436
    LA   RD,0(RD)               CLEAR HI ORDER BYTE            @ZA05436
    MVC  24(2,EWAPTR),4(RD)     MOVE CCUU TO EWA               @ZA05436
*   RD=ERPWTO;                                                     0133
         LA    RD,253                                              0133
*   RE=CVTXTLER;                                                   0134
         L     @12,CVTPTR                                          0134
         L     RE,CVTXTLER(,@12)                                   0134
*   R1=IOSBPTR;                                                    0135
         LR    R1,IOSBPTR                                          0135
*   GEN REFS(RE)(BR    RE);                                        0136
         BR    RE
*   RFY                                                            0137
*    (R1,                                                          0137
*     RD,                                                          0137
*     RE) UNRSTD;                                                  0137
*NOLOGMSG:                          /* PERMANENT ERROR NO WTO OR   0138
*                                      LOGREC                        */
*   ENTFLAG=ON;                     /*                       @ZA18279*/
NOLOGMSG OI    ENTFLAG(EWAPTR),B'01000000'                         0138
*   IOSERR=OFF;                     /* CLEAR ERP IN CONTROL BIT      */
         NI    IOSERR(IOSBPTR),B'11011111'                         0139
*   GOTO STATOR15;                                                 0140
         B     STATOR15                                            0140
*OK:                                /* ERROR CORRECTED               */
*   IOSERR=OFF;                     /* ERP NOT IN CONTROL            */
OK       DS    0H                                                  0142
*   IOSEX=OFF;                      /* NO ERROR                      */
         NI    IOSERR(IOSBPTR),B'11011011'                         0142
*STATOR15:                                                         0143
*   IF EWASTUP='0000'X THEN                                        0143
STATOR15 CLC   EWASTUP(2,EWAPTR),@CB01135                          0143
         BNE   @RF00143                                            0143
*     DO;                                                          0144
*       RFY                                                        0145
*         R1 RSTD;                                                 0145
*       R1=IOSBPTR;                                                0146
         LR    R1,IOSBPTR                                          0146
*       SVC(EREXCP);                                               0147
         SVC   15                                                  0147
*       SVC(EXITSVC);                                              0148
         SVC   3                                                   0148
*       RFY                                                        0149
*         R1 UNRSTD;                                               0149
*     END;                                                         0150
*XCTLSTAT:                                                         0151
*   RFY                                                            0151
*    (R1,                                                          0151
*     RD,                                                          0151
*     RE) RSTD;                                                    0151
@RF00143 DS    0H                                                  0151
XCTLSTAT DS    0H                                                  0152
*   RD=STATUP;                                                     0152
         LA    RD,254                                              0152
*   RE=CVTXTLER;                                                   0153
         L     @12,CVTPTR                                          0153
         L     RE,CVTXTLER(,@12)                                   0153
*   R1=IOSBPTR;                                                    0154
         LR    R1,IOSBPTR                                          0154
*   GEN REFS(RE)(BR    RE);                                        0155
         BR    RE
*   RFY                                                            0156
*    (R1,                                                          0156
*     RD,                                                          0156
*     RE);                                                         0156
*                                                                  0156
*/*  *****************************************************************/
*/*   PROCESS INCORRECT LENGTH OR UNIT EXCEPTION                     */
*/*  *****************************************************************/
*                                                                  0157
*UEXIL:                             /* IF NOT 1ST ENTRY GIVE CHANNEL
*                                      END APPENDAGE A CHANCE TO   0157
*                                      CLEAR IT                      */
*   IF ENTFLAG=ON THEN                                             0157
UEXIL    TM    ENTFLAG(EWAPTR),B'01000000'                         0157
         BNO   @RF00157                                            0157
*     DO;                                                          0158
*       ENTFLAG=OFF;                /*                       @ZA18279*/
         NI    ENTFLAG(EWAPTR),B'10111111'                         0159
*       GOTO OK;                                                   0160
         B     OK                                                  0160
*     END;                                                         0161
*   ELSE                                                           0162
*     GOTO LOG$MSG;                                                0162
*INTREQ:                            /* INTERVENTION REQUIRED         */
*   RFY                                                            0163
*     R3 RSTD;                                                     0163
INTREQ   DS    0H                                                  0164
*   R3=CCWPTR;                                                     0164
         L     R3,CCWPTR                                           0164
*   GEN REFS(R3)(LRA   R3,0(R3));                                  0165
         LRA   R3,0(R3)
*   IOSRST=R3;                                                     0166
         ST    R3,IOSRST(,IOSBPTR)                                 0166
*   RFY                                                            0167
*     R3 UNRSTD;                                                   0167
*   ENTFLAG=ON;                     /*                       @ZA18279*/
         OI    ENTFLAG(EWAPTR),B'01000000'                         0168
*   GO TO WTOXCTL;                                                 0169
         B     WTOXCTL                                             0169
*RETRY:                                                            0170
*   IF BUSFLAG=ON THEN                                             0170
RETRY    TM    BUSFLAG(EWAPTR),B'10000000'                         0170
         BO    @RT00170                                            0170
*     GOTO LOG$MSG;                 /* QUIT IF RETRIED PREVIOUSLY    */
*   BUSFLAG=ON;                                                    0172
*   ENTFLAG=ON;                                                    0173
         OI    BUSFLAG(EWAPTR),B'11000000'                         0173
*   SVC(EREXCP);                                                   0174
         SVC   15                                                  0174
*   SVC(EXITSVC);                                                  0175
*                                                                  0175
         SVC   3                                                   0175
*/* PATCH AREA                                                       */
*                                                                  0176
*PATCH:                                                            0176
*   GEN;                                                           0176
PATCH    DS    0H                                                  0176
         DC    C'IGE0002A ZA18279'                         /*@ZA18279*/
PATCH1   DC    (1024-(PATCH1-IEC2671A))X'00'               /*@ZA11096*/
*   END IEC2671A;                                                  0177
*                                                                  0178
*/*IEC2671A: CHART                                                   */
*/*         HEADER                                                 0178
*/*    ERROR RECOVERY PROCEDURE FOR 2671 PAPER TAPE READER         0178
*/*                                                      #           */
*/*IEC2671A: E IEC2671A IGE0002A                                     */
*/*         P SETUP POINTERS                                         */
*/*         D (YES,LOG$MSG,NO,) MIXED CHANNEL PROGRAM ?              */
*/*         D (YES,%A,NO,) COMMAND CHAINED ?                         */
*/*         D CCWPTR= VIRTUAL START FROM IOSB                        */
*/*STATUS:  S (CTK,LOG$MSG,ICK,LOG$MSG,CCK,LOG$MSG,UCK,SENSE,      0178
*/*            CDK,LOG$MSG,PC,NOLOGMSG,PCK,NOLOGMSG,UEX,UEXIL,     0178
*/*            IL,UEXIL,NONE,OK) IECXITP: ERROR INTERPERTER FOR    0178
*/*            STATUS                                                */
*/*%A:      P (,STATUS) CCWPTR = ADDR OF FAILING CCW                 */
*/*SENSE:   S (BIT5,LOG$MSG,BIT6,LOG$MSG,BIT7,LOG$MSG,EQCK,LOG$MSG,
*/*            INT,INTREQ,BUSO,RETRY,DCK,LOG$MSG,CREJ,MSG,         0178
*/*            NONE,LOG$MSG) IECXITP: ERROR INTERPERTER FOR SENSE    */
*/*LOG$MSG: P TURN ON LOG FLAG IN IOSB                               */
*/*MSG:     P TURN ON MSG FLAG IN IOSB                               */
*/*WTOXCTL: P TURN ON ERP ENTERED FLAG                               */
*/*         R XCTL TO WTO ROUTINE                                    */
*/*NOLOGMSG: P TURN OFF ERP IN CONTROL FLAG                          */
*/*         I ERROR EXCP SVC 15                                      */
*/*         R EXIT VIA SVC 3                                         */
*/*OK:      P TURN OFF ERP IN CONTROL & ERROR FLAGS                  */
*/*         P TURN ON ERP ENTERED FLAG                               */
*/*         I ERROR EXCP SVC 15                                      */
*/*         R EXIT VIA SVC 3                                         */
*/*INTREQ:  P (,WTOXCTL) PUT REAL RESTART ADDRESS IN IOSB            */
*/*RETRY:   D (ON,LOG$MSG,OFF,) TEST BUSFLAG                         */
*/*         P TURN ON BUSFLAG                                        */
*/*         P PUT REAL RESTART ADDRESS IN IOSB                       */
*/*         I ERROR EXCP SVC 15                                      */
*/*         R EXIT VIA SVC 3                                         */
*/*UEXIL:   D (ON,OK,OFF,LOG$MSG) TEST ERP ENTERED FLAG              */
*/*IEC2671A: END                                                     */
@DATA    DS    0H
@CH00088 DC    H'8'
@DATD    DSECT
         DS    0F
@ZTEMPS  DS    0F
@ZT00003 DC    F'0'
@ZTEMPND EQU   *
@ZLEN    EQU   @ZTEMPND-@ZTEMPS
IEC2671A CSECT
         DS    0F
@DATD    DSECT
         DS    0D
CVTPTR   DS    A
CCWPTR   DS    A
@TS00001 DS    CL1
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IEC2671A CSECT
         NOPR  ((@ENDDATD-@DATD)/121*16)
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
@CB01135 DC    X'0000'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
CODEBASE EQU   @10
RF       EQU   @15
R0       EQU   @00
R1       EQU   @01
R3       EQU   @03
EWAPTR   EQU   @06
IOSBPTR  EQU   @07
DATABASE EQU   @08
RB       EQU   @11
RC       EQU   @12
RD       EQU   @13
RE       EQU   @14
R2       EQU   @02
R9       EQU   @09
CVTPTRXX EQU   16
CCWMAP   EQU   0
CCWFLAG  EQU   CCWMAP+4
IOSB     EQU   0
IOSFLA   EQU   IOSB
IOSACHN  EQU   IOSFLA
IOSDCHN  EQU   IOSACHN
IOSCCHN  EQU   IOSACHN
IOSERR   EQU   IOSFLA
IOSEX    EQU   IOSFLA
IOSFLB   EQU   IOSB+1
IOSMSG   EQU   IOSFLB
IOSLOG   EQU   IOSFLB
IOSFLC   EQU   IOSB+2
IOSDVALT EQU   IOSFLC
IOSPKEY  EQU   IOSB+12
IOSOPT   EQU   IOSB+14
IOSOPT2  EQU   IOSB+15
@NM00009 EQU   IOSB+20
IOSCSW   EQU   @NM00009+1
IOSCSWCA EQU   IOSCSW
IOSTATUS EQU   IOSCSW+3
IOSSNS   EQU   IOSB+42
IOSIPIB  EQU   IOSB+44
IOSERP   EQU   IOSB+52
IOSDIE   EQU   IOSB+68
IOSDIEFG EQU   IOSDIE
IOSRST   EQU   IOSB+72
IOSVST   EQU   IOSB+76
IOSPATH  EQU   IOSB+86
IOSCHN   EQU   IOSPATH
IOSCKEY  EQU   IOSB+89
IOSEEKA  EQU   IOSB+100
IOSCCHH  EQU   IOSEEKA+3
IOSSKHH  EQU   IOSCCHH+2
CVTMAP   EQU   0
CVTXTLER EQU   CVTMAP+44
CVTXITP  EQU   CVTMAP+68
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
EWA      EQU   0
EWAHDR   EQU   EWA
EWAFLAGS EQU   EWA+4
EWAFLG1  EQU   EWAFLAGS
EWASCCD  EQU   EWAFLG1
EWASCC3  EQU   EWASCCD
EWAFLG2  EQU   EWAFLAGS+1
EWAFLG3  EQU   EWAFLAGS+2
EWASNSCT EQU   EWAFLAGS+3
EWACNTRS EQU   EWA+10
EWACNTR1 EQU   EWACNTRS
EWASTUP  EQU   EWA+14
EWAERPIB EQU   EWA+16
EWARGFG1 EQU   EWAERPIB+4
EWARGFG2 EQU   EWAERPIB+5
EWAXCSW1 EQU   EWAERPIB+6
EWAXCSW2 EQU   EWAERPIB+7
EWAIERP  EQU   EWA+32
@NM00001 EQU   IOSTATUS
@NM00002 EQU   EWACNTR1
@NM00003 EQU   @NM00002
BUSFLAG  EQU   @NM00003
ENTFLAG  EQU   @NM00003
EQCTR    EQU   @NM00002+1
IOSATTSC EQU   IOSIPIB
IOSWTOWA EQU   IOSIPIB
IOSPCISC EQU   IOSIPIB
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
EWADDIOS EQU   EWAIERP
EWUMAP   EQU   EWAIERP
EWUSN0   EQU   EWUMAP
EWUBUFP  EQU   EWUSN0
EWULDCK  EQU   EWUSN0
EWUUSEQ  EQU   EWULDCK
EWUCH9   EQU   EWUSN0
EWUSN1   EQU   EWUMAP+1
EWUCRTRY EQU   EWUSN1
EWUPCK   EQU   EWUSN1
EWUPQ    EQU   EWUSN1
EWULNPOS EQU   EWUSN1
EWUSN2   EQU   EWUMAP+2
EWUWORK  EQU   EWUMAP+8
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00027 EQU   EWUMAP+6
EWUSN5   EQU   EWUMAP+5
EWUSN4   EQU   EWUMAP+4
EWUSN3   EQU   EWUMAP+3
EWUFCBP  EQU   EWUSN2
EWUPLBP  EQU   EWUSN2
EWUUCSBP EQU   EWUSN2
@NM00026 EQU   EWUSN1
EWUMECMO EQU   EWUSN1
EWUSUPR  EQU   EWUSN1
EWUFORM  EQU   EWUSN1
EWUIRTRY EQU   EWULNPOS
EWUMOT   EQU   EWUPQ
EWUARTRY EQU   EWUPCK
EWUPERM  EQU   EWUCRTRY
EWUPEK   EQU   EWUCH9
EWUABFR  EQU   EWUUSEQ
EWUOVRN  EQU   EWUBUFP
EWUDTCK  EQU   EWUSN0
EWUEQCK  EQU   EWUSN0
EWUBUSO  EQU   EWUSN0
EWUINT   EQU   EWUSN0
EWUCREJ  EQU   EWUSN0
EWAEND   EQU   EWADDIOS+71
EWASCSW  EQU   EWADDIOS+64
EWASNS   EQU   EWADDIOS
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
IOSPCIWA EQU   IOSPCISC+44
IOSPCIRS EQU   IOSPCISC+8
@NM00014 EQU   IOSPCISC+4
@NM00013 EQU   IOSPCISC
IOSWRNDR EQU   IOSWTOWA+4
IOSWTOPT EQU   IOSWTOWA+3
IOSWTOCP EQU   IOSWTOWA+2
IOSWTOCH EQU   IOSWTOWA
IOSATTWA EQU   IOSATTSC+40
@NM00012 EQU   IOSATTSC+24
IOSATTSN EQU   IOSATTSC
@NM00005 EQU   @NM00002+2
@NM00004 EQU   @NM00003
CSWCCK   EQU   @NM00001+1
CSWICK   EQU   @NM00001+1
CSWCTK   EQU   @NM00001+1
CSWCDK   EQU   @NM00001+1
CSWPCK   EQU   @NM00001+1
CSWPC    EQU   @NM00001+1
CSWIL    EQU   @NM00001+1
CSWPCI   EQU   @NM00001+1
CSWUEX   EQU   @NM00001
CSWUCK   EQU   @NM00001
CSWDVE   EQU   @NM00001
CSWCHE   EQU   @NM00001
CSWBSY   EQU   @NM00001
CSWCUE   EQU   @NM00001
CSWSMD   EQU   @NM00001
CSWATN   EQU   @NM00001
EWADDISP EQU   EWA+29
EWADCNT  EQU   EWA+28
EWACPU   EQU   EWA+27
@NM00025 EQU   EWA+26
EWACHA   EQU   EWA+24
EWACSEQ  EQU   EWAXCSW2
EWACDIN  EQU   EWAXCSW2
@NM00024 EQU   EWAXCSW2
EWACTEC  EQU   EWAXCSW2
EWACDAV  EQU   EWAXCSW1
EWACCHV  EQU   EWAXCSW1
EWACCMD  EQU   EWAXCSW1
EWACUNS  EQU   EWAXCSW1
EWACSQV  EQU   EWAXCSW1
@NM00023 EQU   EWAXCSW1
EWACITF  EQU   EWAXCSW1
@NM00022 EQU   EWARGFG2
EWACCUE  EQU   EWARGFG2
EWACSTG  EQU   EWARGFG2
EWACSCU  EQU   EWARGFG2
EWACCHA  EQU   EWARGFG2
EWACCPU  EQU   EWARGFG2
EWANORTY EQU   EWARGFG1
EWACCNT  EQU   EWARGFG1
EWACSNS  EQU   EWARGFG1
@NM00021 EQU   EWARGFG1
EWACHIO  EQU   EWARGFG1
EWACTIO  EQU   EWARGFG1
EWACINT  EQU   EWARGFG1
EWACSIO  EQU   EWARGFG1
EWAUCB   EQU   EWAERPIB+1
@NM00020 EQU   EWAERPIB
EWACNTR4 EQU   EWACNTRS+3
EWACNTR3 EQU   EWACNTRS+2
EWACNTR2 EQU   EWACNTRS+1
EWASSTAT EQU   EWA+8
EWASCTMX EQU   EWASNSCT
@NM00019 EQU   EWASNSCT
EWAJAM   EQU   EWAFLG3
@NM00018 EQU   EWAFLG2
EWADIR   EQU   EWAFLG2
EWACOVF  EQU   EWAFLG2
EWAWTEMP EQU   EWAFLG2
EWAMDR   EQU   EWAFLG2
EWABDSNS EQU   EWAFLG1
EWADDMSG EQU   EWAFLG1
EWASCC1  EQU   EWASCC3
EWASCC2  EQU   EWASCC3
@NM00017 EQU   EWAFLG1
EWASLIS  EQU   EWAFLG1
EWAEXT   EQU   EWAHDR
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00016 EQU   CVTFIX+248
@NM00015 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
IOSEND   EQU   IOSB+108
IOSSKR   EQU   IOSEEKA+7
IOSSKH2  EQU   IOSSKHH+1
IOSSKH1  EQU   IOSSKHH
IOSSKCC  EQU   IOSCCHH
IOSSKBB  EQU   IOSEEKA+1
IOSSKM   EQU   IOSEEKA
IOSEEK   EQU   IOSB+92
IOSMDM   EQU   IOSB+91
IOSMDB   EQU   IOSB+90
IOSCKEY7 EQU   IOSCKEY
IOSCKEY6 EQU   IOSCKEY
IOSCKEY5 EQU   IOSCKEY
IOSCKEY4 EQU   IOSCKEY
@NM00011 EQU   IOSCKEY
IOSFMSK  EQU   IOSB+88
IOSCUDEV EQU   IOSPATH+1
@NM00010 EQU   IOSCHN
IOSPATH3 EQU   IOSCHN
IOSPATH2 EQU   IOSCHN
IOSEXP   EQU   IOSCHN
IOSGDP   EQU   IOSCHN
IOSAFF   EQU   IOSB+85
IOSRSS1B EQU   IOSB+84
IOSDSID  EQU   IOSB+80
IOSNOTRS EQU   IOSDIEFG
IOSABN   EQU   IOSB+64
IOSNRM   EQU   IOSB+60
IOSPCI   EQU   IOSB+56
IOSPCHN  EQU   IOSB+48
IOSAPMSK EQU   IOSB+40
IOSRES4A EQU   IOSB+36
IOSUSE   EQU   IOSB+32
IOSSRB   EQU   IOSB+28
IOSCSWRC EQU   IOSCSW+5
IOSTSB   EQU   IOSTATUS+1
IOSTSA   EQU   IOSTATUS
IOSCC    EQU   @NM00009
IOSUCB   EQU   IOSB+16
IOSOPT2X EQU   IOSOPT2
IOSHTP   EQU   IOSOPT2
IOSRELSE EQU   IOSOPT
IOSAPR   EQU   IOSOPT
IOSTSLL  EQU   IOSOPT
IOSNERP  EQU   IOSOPT
IOSPSLL  EQU   IOSOPT
IOSQISCE EQU   IOSOPT
IOSDEP   EQU   IOSOPT
IOSBYP   EQU   IOSOPT
IOSCOD   EQU   IOSB+13
IOSPKY7  EQU   IOSPKEY
IOSPGDPX EQU   IOSPKEY
IOSIDR   EQU   IOSPKEY
IOSLCL   EQU   IOSPKEY
@NM00008 EQU   IOSPKEY
IOSPGAD  EQU   IOSB+8
IOSASID  EQU   IOSB+6
IOSPRLVL EQU   IOSB+5
IOSDVRID EQU   IOSB+4
IOSPROC  EQU   IOSB+3
IOSFLC7  EQU   IOSFLC
IOSCTCNR EQU   IOSFLC
IOSRWAIT EQU   IOSFLC
IOSTP    EQU   IOSFLC
IOSCC3WE EQU   IOSFLC
IOSVERIF EQU   IOSDVALT
IOSDVMNT EQU   IOSFLC
IOSBDCST EQU   IOSFLB
IOSFLB4  EQU   IOSFLB
IOSFLB3  EQU   IOSFLB
IOSFLB2  EQU   IOSFLB
IOSSDR   EQU   IOSFLB
IOSDIESE EQU   IOSFLB
IOSIOSB  EQU   IOSFLA
IOSDOM   EQU   IOSFLA
IOSSMDB  EQU   IOSFLA
IOSSMDA  EQU   IOSFLA
CCWCOUNT EQU   CCWMAP+6
@NM00007 EQU   CCWMAP+5
@NM00006 EQU   CCWFLAG
CCWIDA   EQU   CCWFLAG
CCWPCI   EQU   CCWFLAG
CCWSKP   EQU   CCWFLAG
CCWSLI   EQU   CCWFLAG
CCWCC    EQU   CCWFLAG
CCWCD    EQU   CCWFLAG
CCWADDR  EQU   CCWMAP+1
CCWCMD   EQU   CCWMAP
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RT00095 EQU   MSG
@RF00157 EQU   LOG$MSG
@RT00170 EQU   LOG$MSG
@ENDDATA EQU   *
         END   IEC2671A,(C'PLS2152',0701,77073)
