003C     TITLE 'IGE0003C - 3838 ERROR RECOVERY PROCEDURE.              *
                        '
*                                 /* DO OWN PROLOG.                  */
IGE0003C CSECT
         USING IGE0003C,CODEBASE     ADDRESSIBILITY FOR CODE.
*   CODEBASE=R15P;                  /* ADDRESS OF PROGRAM.           */
         LR    CODEBASE,R15P                                    01S0175
*   RFY                                                         01S0176
*     R15P UNRSTD;                                              01S0176
*   APIOPTR=R1P;                    /* ADDRESS OF APIO AND IOSB.     */
         LR    APIOPTR,R1P                                      01S0177
*   RFY                                                         01S0178
*     IOSB BASED(APIOPTR);                                      01S0178
*   EWAPTR=IOSERP;                  /* ADDRESS OF ERP WORKAREA.      */
         L     EWAPTR,IOSERP(,APIOPTR)                          01S0179
*   RFY                                                         01S0180
*     APSN BASED(ADDR(EWAIERP));                                01S0180
*   IOSERR=ON;                      /* ERP IN CONTROL.               */
*   IOSEX=ON;                       /* EXCEPTIONAL CONDITION.        */
         OI    IOSERR(APIOPTR),B'00100100'                      01S0182
*   IOSSDR=OFF;                     /* RESET INDICATORS IN THE IOSB  */
*   IOSMSG=OFF;                     /* WHICH MIGHT BE LEFT ON FROM   */
*   IOSBDCST=OFF;                   /* PREVIOUS ENTRIES.             */
*   IOSLOG=OFF;                     /* MORE OF SAME.                 */
         NI    IOSSDR(APIOPTR),B'10111000'                      01S0186
*   RFY                                                         01S0187
*    (R0P,                                                      01S0187
*     R2P,                                                      01S0187
*     R15P) RSTD;                   /* NEED THESE REGS.              */
*   IF KEYSAVED=ON THEN             /* IF THE KEY WAS CHANGED IN THE
*                                      IOSB THEN IT NEEDS TO BE 01S0188
*                                      RESTORD                       */
         TM    KEYSAVED(EWAPTR),B'00010000'                     01S0188
         BNO   @RF00188                                         01S0188
*     DO;                           /* RESTORE THE KEY.              */
*       KEYSAVED=OFF;               /* INDICATE THAT THE KEY IS 01S0190
*                                      RESTORD                       */
         NI    KEYSAVED(EWAPTR),B'11101111'                     01S0190
*       IOSCKEY=SAVEKEY;            /* RESTORE THE KEY.              */
         MVC   IOSCKEY(1,APIOPTR),SAVEKEY(EWAPTR)               01S0191
*     END;                          /* END OF KEY RESTORE.           */
*   GEN SETS(R0P)(L     R0P,@SIZDATD);/* SIZE REQUIRED FOR DYNAMIC
*                                      AREA                          */
@RF00188 DS    0H                                               01S0193
         L     R0P,@SIZDATD
*   SPSIZE=R0P;                     /* SET SIZE FOR POSTERITY-  01S0194
*                                      FREEMAIN                      */
         ST    R0P,SPSIZE(,EWAPTR)                              01S0194
*   DSP=230;                        /* TRY THIS SUBPOOL FIRST.       */
         MVI   DSP(EWAPTR),X'E6'                                01S0195
*   R2P=DSIZE;                      /* SET R2 FOR THE GETMAIN.       */
         L     R2P,DSIZE-1(,EWAPTR)                             01S0196
         LA    R2P,0(,R2P)                                      01S0196
*   GEN SETS(R0P,R1P,R15P)          /* CONTITIONAL GETMAIN.          */
*       (GETMAIN RC,LV=(2),SP=230);                             01S0197
         GETMAIN RC,LV=(2),SP=230
*   IF R15P^=0 THEN                 /* IF STORAGE NOT AVAILABLE 01S0198
*                                      THERE, TRY AGAIN IN CSA.      */
         LTR   R15P,R15P                                        01S0198
         BZ    @RF00198                                         01S0198
*     DO;                                                       01S0199
*       DSP=241;                    /* SUBPOOL FOR CSA.              */
         MVI   DSP(EWAPTR),X'F1'                                01S0200
*       R0P=SPSIZE;                 /* SET R0 FOR THE GETMAIN.       */
         L     R0P,SPSIZE(,EWAPTR)                              01S0201
*       GEN SETS(R1P)(GETMAIN R,LV=(0));/* IF CAN'T GET IT HERE THEN
*                                      ERP WILL ABEND. TOO BAD.      */
         GETMAIN R,LV=(0)
*     END;                                                      01S0203
*   RFY                                                         01S0204
*    (R0P,                                                      01S0204
*     R2P,                                                      01S0204
*     R15P) UNRSTD;                                             01S0204
@RF00198 DS    0H                                               01S0205
*   DYNPTR=R1P;                     /* IF GOT HERE R1 HAS ADDRESS OF
*                                      STORAGE.                      */
         ST    R1P,DYNPTR(,EWAPTR)                              01S0205
*   DATABASE=R1P;                   /* SET THE DYNAMIC AREA PTR.     */
         LR    DATABASE,R1P                                     01S0206
*   GEN(USING @DATD,DATABASE        ADDRESSIBILITY FOR DATA.);  01S0207
         USING @DATD,DATABASE        ADDRESSIBILITY FOR DATA.
*   RFY                                                         01S0208
*     R1P UNRSTD;                                               01S0208
*   STM(R3P,R12P,SAVE312);          /* SAVE REGS FOR RETRY.          */
         STM   R3P,R12P,SAVE312                                 01S0209
*   ESIND=0;                        /* CLEAR THE ESATE INDICATOR
*                                      FIELD.                        */
         SLR   @11,@11                                          01S0210
         ST    @11,ESIND                                        01S0210
*   PARMPTR=ADDR(ESIND);            /* REGS FOR THE ESTAE RETRY 01S0211
*                                      ROUTINE                       */
         LA    @11,ESIND                                        01S0211
         ST    @11,PARMPTR(,EWAPTR)                             01S0211
*   RFY                                                         01S0212
*     R2P RSTD;                                                 01S0212
*   R2P=ADDR(PARMPTR);              /* SET ADDRESS OF THE PARMLIST.  */
         LA    R2P,PARMPTR(,EWAPTR)                             01S0213
*   GEN REFS(DESTAE,XESTAE,PARMPTR) FLOWS(RECOVER);             01S0214
         MVC    DESTAE,XESTAE        MOVE IN THE SKELETON.
         ESTAE  RECOVER,CT,PARAM=(R2P),MF=(E,DESTAE)
*   RFY                                                         01S0215
*     R2P UNRSTD;                   /* COMMENT FOR THE STANDARDS.    */
*   DO;                                                         02S0216
*     IF IOSCOD=IOSFINTC THEN       /* TEST FOR INTERCEPT CONDITION. */
         CLI   IOSCOD(APIOPTR),X'7E'                            02S0217
         BNE   @RF00217                                         02S0217
*       DO;                         /* IT'S AN INTERCEPT ERROR       */
*         IOSCOD='7F'X;             /* WE WANT TO TELL IOS TO RETRY. */
         MVI   IOSCOD(APIOPTR),X'7F'                            02S0219
*         GO TO LOGRTRY;            /* LET THE CALLER FAIL IN HIS OWN
*                                      RIGHT.                        */
         B     LOGRTRY                                          02S0220
*       END;                                                    02S0221
*   END;                                                        02S0222
@RF00217 DS    0H                                               02S0223
*   RETRY=NO;                       /* ASSUME THAT RETRY CAN'T BE
*                                      DONE,                         */
*   RESTART=YES;                    /* * BUT THAT RESTART CAN.       */
         OI    RESTART(EWAPTR),B'00001000'                      01S0224
         NI    RETRY(EWAPTR),B'11111101'                        01S0224
*   IF IOSDVRID=IOSVPSID            /* FOR VPSS SAVE THE CSW FOR THE */
*       &PREV=OFF THEN              /* USER UNLESS ALREADY DONE.     */
         CLI   IOSDVRID(APIOPTR),X'0B'                          01S0225
         BNE   @RF00225                                         01S0225
         TM    PREV(EWAPTR),B'10000000'                         01S0225
         BNZ   @RF00225                                         01S0225
*     DO;                                                       01S0226
*       MVC(SAVEVCSW(1:8),MYCSW);   /* INCLUDE THE SIO CODE.         */
         MVC   SAVEVCSW(8,EWAPTR),MYCSW(APIOPTR)                01S0227
*       APIOVCSW=ADDR(IOSCC);       /* ADDRESS OF THE VIRTUAL CSW.   */
         LA    @11,IOSCC(,APIOPTR)                              01S0228
         ST    @11,APIOVCSW(,APIOPTR)                           01S0228
*     END;                                                      01S0229
*   DO;                                                         02S0230
*                                                               02S0230
@RF00225 DS    0H                                               02S0231
*     /***************************************************************/
*     /*                                                             */
*     /* THIS CODE EXAMINES THE CHAINING INDICATORS IN THE IOSB TO   */
*     /* DETERMINE IF THE CHANNEL PROGRAM MAY BE RESTARTED OR        */
*     /* RETRIED. RESTART MEANS THAT OPERATION BEGINS WITH THE FAILED*/
*     /* CCW. RETRY MEANS THAT CHANNEL PROGRAM IS STARTED AT THE     */
*     /* BEGINNING. IN GENERAL, ALL CHANNEL PROGRAMS ARE RESTARTABLE */
*     /* UNLESS DATA CHAINING IS INVOLVED, WHICH SHOULD OCCUR        */
*     /* INFREQUENTLY. RETRY IS POSSIBLE ONLY IF THE INPUT AND OUTPUT*/
*     /* AREAS DON'T OVERLAP.                                @ZA25369*/
*     /* FOR EXCP CALLERS, NEITHER RESTART NOR RETRY IS      @ZA25369*/
*     /* ATTEMPTED. THE ONLY EXPECTED USER OF EXCP IS THE VPSS       */
*     /* MONITOR AND IT DOES NOT WANT ANY RECOVERY PERFORMED.        */
*     /*                                                     @ZA25369*/
*     /*                                                     @ZA25369*/
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0231
*     IF IOSCSWCA-8=IOSVST THEN     /* IF FAILURE WAS ON FIRST CCW,  */
         L     @11,IOSCSWCA-1(,APIOPTR)                         02S0231
         LA    @11,0(,@11)                                      02S0231
         SL    @11,@CF00059                                     02S0231
         C     @11,IOSVST(,APIOPTR)                             02S0231
         BNE   @RF00231                                         02S0231
*       DO;                         /* ASSUME THAT THE CHANNEL  02S0232
*                                      PROGRAM                       */
*         RETRY=YES;                /* MAY BE RETRIED,               */
*         RESTART=NO;               /* BUT NOT RESTARTED (WHICH 02S0234
*                                      INVOLVES THE RESTART CCW,
*                                      ETC).                         */
         OI    RETRY(EWAPTR),B'00000010'                        02S0234
         NI    RESTART(EWAPTR),B'11110111'                      02S0234
*       END;                        /* END OF FISRT CCW CHECK.       */
*     ELSE                          /* SEE IF OTHER CONDITIONS AFFECT*/
*       DO;                         /* RETRY AND RESTART.            */
         B     @RC00231                                         02S0236
@RF00231 DS    0H                                               02S0237
*         IF IOSDVRID=IOSVPSID      /* IF THE DRIVER IS VPSS,        */
*             &APIOEXCL=OFF THEN    /* * AND THE PORT IS SHARED.     */
         CLI   IOSDVRID(APIOPTR),X'0B'                          02S0237
         BNE   @RF00237                                         02S0237
         TM    APIOEXCL(APIOPTR),B'10000000'                    02S0237
         BNZ   @RF00237                                         02S0237
*           IF IOSACHN='00'B THEN   /* IF NO CHAINING, THEN MAY 02S0238
*                                      RETRY.                        */
         TM    IOSACHN(APIOPTR),B'11000000'                     02S0238
         BNZ   @RF00238                                         02S0238
*             RETRY=YES;                                        02S0239
         OI    RETRY(EWAPTR),B'00000010'                        02S0239
*           ELSE                                                02S0240
*             IF IOSDCHN=ON&        /* IF ONLY DATA CHAINING,        */
*                 IOSCCHN=OFF THEN  /* * MAY RETRY, BUT NOT RESTART. */
         B     @RC00238                                         02S0240
@RF00238 TM    IOSDCHN(APIOPTR),B'10000000'                     02S0240
         BNO   @RF00240                                         02S0240
         TM    IOSCCHN(APIOPTR),B'01000000'                     02S0240
         BNZ   @RF00240                                         02S0240
*               DO;                                             02S0241
*                 RETRY=YES;                                    02S0242
*                 RESTART=NO;                                   02S0243
         OI    RETRY(EWAPTR),B'00000010'                        02S0243
         NI    RESTART(EWAPTR),B'11110111'                      02S0243
*               END;                                            02S0244
*             ELSE                                              02S0245
*               DO;                                             03S0245
*                                                               03S0245
         B     @RC00240                                         03S0245
@RF00240 DS    0H                                               03S0246
*                 /***************************************************/
*                 /*                                                 */
*                 /* DATA CHAINING PRECLUDES A RESTART OF THE CHANNEL*/
*                 /* PROGRAM, BUT A RETRY MIGHT BE IN ORDER. RESTART */
*                 /* IS OUT BECAUSE WE MIGHT BEGIN OVER IN THE       */
*                 /* 'MIDDLE' OF AN I/O THAT HAS BEEN SPLIT INTO TWO */
*                 /* PHYSICAL I/O OPERATIONS. BUT IF NO DATA HAS BEEN*/
*                 /* OVERLAID BY ANY BY ANY READ OPERATIONS, WE CAN  */
*                 /* RETRY THE WHOLE OPERATION.                      */
*                 /*                                                 */
*                 /***************************************************/
*                                                               03S0246
*                 IF IOSCSWCA<ADDR(CCW2)|/* INSURE THAT THE FAILING
*                                      CCW IS NOT IN CCWS THAT WE
*                                      HAVE BUILT AND ARE THEREFORE
*                                      NOT CONTIGUOUS WITH THE CHAIN.*/
*                     IOSCSWCA>ADDR(CCW3) THEN/* IF NOT ONE OF OURS
*                                      THEN CHECK FOR OVERLAP.       */
         L     @11,IOSCSWCA-1(,APIOPTR)                         03S0246
         LA    @11,0(,@11)                                      03S0246
         LA    @09,CCW2(,EWAPTR)                                03S0246
         CR    @11,@09                                          03S0246
         BL    @RT00246                                         03S0246
         LA    @09,CCW3(,EWAPTR)                                03S0246
         CR    @11,@09                                          03S0246
         BNH   @RF00246                                         03S0246
@RT00246 DS    0H                                               03S0247
*                   IF APIOOLAP=0   /* THIS FIELD CONTAINS THE OFFSET
*                                      TO THE FIRST CCW THAT OVERLAYS
*                                      DATA THAT ANOTHER CCW WILL
*                                      USE. IF IT IS ZERO THERE IS NO
*                                      OVERLAP SO MAY RETRY.         */
*                       |APIOOLAP>= /* ELSE MUST SEE IF OVERLAP 03S0247
*                                      OCCURRED.                     */
*                       (IOSCSWCA-IOSVST)/* THIS VALUE IS THE OFFSET
*                                      TO THE CCW THAT FAILED.       */
*                     THEN          /* IF CCW IN SAFE AREA.          */
         LH    @11,APIOOLAP(,APIOPTR)                           03S0247
         LTR   @11,@11                                          03S0247
         BZ    @RT00247                                         03S0247
         L     @09,IOSCSWCA-1(,APIOPTR)                         03S0247
         LA    @09,0(,@09)                                      03S0247
         SL    @09,IOSVST(,APIOPTR)                             03S0247
         CR    @11,@09                                          03S0247
         BL    @RF00247                                         03S0247
@RT00247 DS    0H                                               03S0248
*                     RETRY=YES;    /* SET RETRY = OK.               */
         OI    RETRY(EWAPTR),B'00000010'                        03S0248
*                 IF IOSDCHN=ON     /* IF DATA CHAINING IS ON, THEN
*                                      IT MIGHT STILL BE POSSIBLE TO
*                                      RESTART BUT ONLY IF THE CCW
*                                      THAT FAILED WAS NOT DATA 03S0249
*                                      CHAINED TO.                   */
*                     &(IOSCSWCA<ADDR(CCW2)|/* ENSURE THAT FAILURE
*                                      WAS NOT IN                    */
*                     IOSCSWCA>ADDR(CCW3))/* THE RESTART CCWS   03S0249
*                                      THEMSELVES.                   */
*                     &IOSCSWCA-16>=IOSVST/* ENSURE THAT WE DON'T GO
*                                      TOO FAR.                      */
*                     &(IOSCSWCA-16)->CCWDC=ON/* FINALLY, IS THE CCW
*                                      DATA                          */
*                   THEN            /* CHAINED TO?                   */
@RF00247 DS    0H                                               03S0249
@RF00246 TM    IOSDCHN(APIOPTR),B'10000000'                     03S0249
         BNO   @RF00249                                         03S0249
         L     @11,IOSCSWCA-1(,APIOPTR)                         03S0249
         LA    @11,0(,@11)                                      03S0249
         LA    @09,CCW2(,EWAPTR)                                03S0249
         CR    @11,@09                                          03S0249
         BL    @GL00006                                         03S0249
         LA    @09,CCW3(,EWAPTR)                                03S0249
         CR    @11,@09                                          03S0249
         BNH   @RF00249                                         03S0249
@GL00006 L     @11,IOSCSWCA-1(,APIOPTR)                         03S0249
         LA    @11,0(,@11)                                      03S0249
         SL    @11,@CF00040                                     03S0249
         C     @11,IOSVST(,APIOPTR)                             03S0249
         BL    @RF00249                                         03S0249
         TM    CCWDC(@11),B'10000000'                           03S0249
         BNO   @RF00249                                         03S0249
*                   RESTART=NO;     /* RESTART IS JUST NOT POSSIBLE. */
         NI    RESTART(EWAPTR),B'11110111'                      03S0250
*               END;                                            03S0251
*         ELSE                                                  02S0252
*           IF IOSDCHN=YES THEN     /* DOESNT MAKE ANY DIFFERENCE WHO*/
         B     @RC00237                                         02S0252
@RF00237 TM    IOSDCHN(APIOPTR),B'10000000'                     02S0252
         BNO   @RF00252                                         02S0252
*             RESTART=NO;           /* YOU ARE, IF DATA CHN, NO 02S0253
*                                      RESTRT.                       */
         NI    RESTART(EWAPTR),B'11110111'                      02S0253
*       END;                        /* END OF RETRY/RESTART CHECK.   */
@RF00252 DS    0H                                               02S0254
@RC00237 DS    0H                                               02S0255
*     IF IOSDVRID^=IOSVPSID THEN    /* CHECK FOR EXCP USER.  @ZA25369*/
@RC00231 CLI   IOSDVRID(APIOPTR),X'0B'                          02S0255
         BE    @RF00255                                         02S0255
*       DO;                         /* RESET FLAGS.          @ZA25369*/
*         RETRY=NO;                 /* NO RETRY IS ALLOWED.  @ZA25369*/
*         RESTART=NO;               /* NO RESTART IS ALLOWED.   02S0258
*                                                            @ZA25369*/
         NI    RETRY(EWAPTR),B'11110101'                        02S0258
*       END;                        /* END OF PROCESS EXCP USER.
*                                                            @ZA25369*/
*   END;                                                        02S0260
@RF00255 DS    0H                                               02S0261
*   RFY                                                         01S0261
*    (R0P,                                                      01S0261
*     R1P,                                                      01S0261
*     R9P,                                                      01S0261
*     R11P,                                                     01S0261
*     R12P,                                                     01S0261
*     R14P,                                                     01S0261
*     R15P) RSTD;                   /* USED BY INTERPRETER.          */
*   R1P=ADDR(IOSB);                 /* ADDRESS OF IOSB.              */
         LR    R1P,APIOPTR                                      01S0262
*   R15P=CVTXITP;                   /* ADDR OF INTERPRETER ROUTINE.  */
         L     @03,CVTPTR                                       01S0263
         L     R15P,CVTXITP(,@03)                               01S0263
*   GEN REFS(R15P) SETS(R14P) FLOWS(CHANERR,LOGMSG,UNITCK,ALLCLEAR)
*       NOSEQFLOW;                                              01S0264
*  THIS CODE INVOKES THE ERP BIT ANALYZER TO DETERMINE WHAT TO DO.
T1       BALR  R14P,R15P          CALL ERROR INTERPRETER ROUTINE.
         DC    X'1D',AL1(TCCC-T1-2)     CHAN CONTROL CK
         DC    X'1E',AL1(TCCC-T1-4)     INTERFACE CONTROL CK
         DC    X'1C',AL1(TCCC-T1-6)     CHAN DATA CK
         DC    X'10',AL1(TUNUSED-T1-8)  ATTN (UNUSED)
         DC    X'17',AL1(TUNUSED-T1-10) UNIT EXC (UNUSED)
         DC    X'16',AL1(TUNIT-T1-12)   UNIT CK
         DC    X'1F',AL1(TUSER-T1-14)   CHAIN CK
         DC    X'1A',AL1(TUSER-T1-16)   PROG CK
         DC    X'1B',AL1(TUSER-T1-18)   PROTECT CK
         DC    X'19',AL1(TILEN-T1-20)   INCORRECT LENGTH
         DC    X'2F',AL1(TGOOD-T1-22)   NO ERROR THIS ENTRY TO ERP.
TCCC     B     CHANERR
TUNUSED  B     LOGMSG
TUNIT    B     UNITCK
TUSER    B     PROGERR
TGOOD    B     ALLCLEAR
TILEN    B     ILLEN              GO TO ILLEGAL LENGTH ROUTINE.
*   RFY                                                         01S0265
*    (R0P,                                                      01S0265
*     R1P,                                                      01S0265
*     R9P,                                                      01S0265
*     R11P,                                                     01S0265
*     R12P,                                                     01S0265
*     R14P,                                                     01S0265
*     R15P) UNRSTD;                                             01S0265
*CHANERR:                                                       01S0266
*   ;                               /* ERROR WAS CCC, CDC, OR ICC.   */
CHANERR  DS    0H                                               01S0267
*   DO;                                                         02S0267
*                                                               02S0267
*     /***************************************************************/
*     /*                                                             */
*     /* PROCESS CCC, CDC AND ICC.                                   */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0268
*     RESTART=NO;                   /* RESTART IS NOT POSSIBLE EXCEPT
*                                      * FOR UNIT CHECKS.            */
         NI    RESTART(EWAPTR),B'11110111'                      02S0268
*     IF IOSCOD=IOSMIHC THEN        /* IF MISSING INTERRUPT THE CSW *
*                                      IS MADE UP BY MIH AND SO IS *
*                                      NOT VALID.                    */
         CLI   IOSCOD(APIOPTR),X'74'                            02S0269
         BNE   @RF00269                                         02S0269
*       IF RETRY=YES                /* CHECK TO SEE IF RETRY OK.     */
*           &PREV=OFF THEN          /* BUT ONLY IF NOT TRIED BEFORE. */
         TM    RETRY(EWAPTR),B'00000010'                        02S0270
         BNO   @RF00270                                         02S0270
         TM    PREV(EWAPTR),B'10000000'                         02S0270
         BNZ   @RF00270                                         02S0270
*         DO;                       /* PROCESS RETRY REQUEST.        */
*           PREV=YES;               /* INDICATE THAT IT TRIED ONCE.  */
         OI    PREV(EWAPTR),B'10000000'                         02S0272
*           GO TO DOITOVER;         /* GO TRY AGAIN.                 */
         B     DOITOVER                                         02S0273
*         END;                      /* END OF RETRY PROCESS.         */
*       ELSE                        /* IT CAN'T BE RETRIED.          */
*         GO TO LOGMSG;             /* SO IT IS A PERM ERROR.        */
*     IF EWANORTY=ON THEN           /* IF CCH SAYS NO, THEN FORGET
*                                      IT.                           */
@RF00269 TM    EWANORTY(EWAPTR),B'00000001'                     02S0276
         BO    @RT00276                                         02S0276
*       GO TO LOGMSG;                                           02S0277
*     IF PREV=YES THEN              /* IF BEEN HERE BEFORE, GIVE UP. */
         TM    PREV(EWAPTR),B'10000000'                         02S0278
         BO    @RT00278                                         02S0278
*       GOTO LOGMSG;                                            02S0279
*     ELSE                                                      02S0280
*       DO;                                                     02S0280
*         PREV=YES;                 /* SET HERE NOW.                 */
         OI    PREV(EWAPTR),B'10000000'                         02S0281
*         GOTO DOITOVER;                                        02S0282
         B     DOITOVER                                         02S0282
*       END;                                                    02S0283
*   END;                                                        02S0284
*UNITCK:                                                        01S0285
*   ;                               /* ERROR WAS UNIT CHECK.         */
UNITCK   DS    0H                                               01S0286
*   DO;                                                         02S0286
*     IF((IOSCSWCA-8)->CCWOPCD      /* CHECH THE CCW COMMAND @ZA25442*/
*         ^='02'X) THEN             /* CODE FOR A WRITE.     @ZA25442*/
         L     @11,IOSCSWCA-1(,APIOPTR)                         02S0287
         AL    @11,@CF03261                                     02S0287
         CLI   CCWOPCD(@11),X'02'                               02S0287
         BE    @RF00287                                         02S0287
*       EWAWTEMP=ON;                /* IF NOT READ,THEN INDICATE TO
*                                      STATISTICS UPDATE THAT IT IS A
*                                      WRITE.                @ZA25442*/
         OI    EWAWTEMP(EWAPTR),B'01000000'                     02S0288
*     IF EWABDSNS=OFF THEN          /* IF SENSE OK,                  */
@RF00287 TM    EWABDSNS(EWAPTR),B'00000001'                     02S0289
         BNZ   @RF00289                                         02S0289
*       DO;                                                     02S0290
*         EWASTUP=EWASTUP|APSN(1:2);/* OR IN SENSE FOR STATISTICS.   */
         LA    @11,32                                           02S0291
         ALR   @11,EWAPTR                                       02S0291
         OC    EWASTUP(2,EWAPTR),APSN(@11)                      02S0291
*         EWASTUP=EWASTUP&'7F00'X;  /* TURN OFF NON ESSENSIAL BITS.  */
         NC    EWASTUP(2,EWAPTR),@CB03043                       02S0292
*         IF APSNRQUR=ON THEN       /* IF 3838 SAYS THAT THE ERROR IS
*                                      UNRELATED TO THE CURRENT 02S0293
*                                      REQUEST THEN WE CAN ALWAYS
*                                      RETRY THE CHANNEL PROGRAM.    */
         TM    APSNRQUR(@11),B'01000000'                        02S0293
         BO    @RT00293                                         02S0293
*           GO TO LOGRTRY;          /* GO LOG AND RETRY.             */
*         IF APSNRQRS=OFF THEN      /* CAN BOX TOLERATE         02S0295
*                                      RESTART,1=YES.                */
         TM    APSNRQRS(@11),B'10000000'                        02S0295
         BNZ   @RF00295                                         02S0295
*           IF IOSDVRID=IOSVPSID    /* IF VPSS IS DRIVER, AND IT IS  */
*               &APSNFMT=APSNFUSR THEN/* * A USER ERROR, THEN GET
*                                      REGS                          */
         CLI   IOSDVRID(APIOPTR),X'0B'                          02S0296
         BNE   @RF00296                                         02S0296
         CLI   APSNFMT(@11),2                                   02S0296
         BNE   @RF00296                                         02S0296
*             DO;                                               02S0297
*               MVC(APIOSNSE(1:32),APSN);/* SAVE SENSE FOR DRIVER.   */
         MVC   APIOSNSE(32,APIOPTR),APSN(@11)                   02S0298
*               APIOVSNS=ON;        /* SET VALID SENSE DATA     02S0299
*                                      INDICATOR.                    */
         OI    APIOVSNS(APIOPTR),B'01000000'                    02S0299
*               IF APIODUMP=ON&     /* IF THE USER WANTS A DUMP, AND */
*                   APIODEB->DEBIRBAD->APDXNDMP/* MAX NOT EXCEEDED,  */
*                   <APUBAPCT->APCTNDMP THEN                    02S0300
         TM    APIODUMP(APIOPTR),B'00001000'                    02S0300
         BNO   @RF00300                                         02S0300
         L     @11,APIODEB(,APIOPTR)                            02S0300
         L     @11,DEBIRBAD(,@11)                               02S0300
         LH    @09,APDXNDMP(,@11)                               02S0300
         L     @01,APIOAPUB(,APIOPTR)                           02S0300
         L     @01,APUBAPCT(,@01)                               02S0300
         CH    @09,APCTNDMP(,@01)                               02S0300
         BNL   @RF00300                                         02S0300
*                 DO;               /* SET ABOUT GIVING HIM ONE.     */
*                                                               02S0301
*                   /*************************************************/
*                   /*                                               */
*                   /* INCREMENT THE DUMP COUNT.                     */
*                   /*                                               */
*                   /*************************************************/
*                                                               02S0302
*                   APIODEB->DEBIRBAD->APDXNDMP=APIODEB->DEBIRBAD->
*                       APDXNDMP+1;                             02S0302
         AL    @09,@CF00033                                     02S0302
         STH   @09,APDXNDMP(,@11)                               02S0302
*                   DUMPREQ=ON;     /* INDICATE A DUMP IS REQUIRED.  */
         OI    DUMPREQ(EWAPTR),B'00100000'                      02S0303
*                 END;              /* END OF GIVE DUMP.             */
*               PREVUNIT=ON;        /* INDICATE ORIGINAL ENTRY IS FOR
*                                      A UNIT CHECK.                 */
@RF00300 DS    0H                                               02S0306
*               PREV=ON;            /* INDICATE BEEN HERE.           */
         OI    PREVUNIT(EWAPTR),B'11000000'                     02S0306
*               SAVEKEY=IOSCKEY;    /* SAVE THE KEY OF THE CALLER.   */
         MVC   SAVEKEY(1,EWAPTR),IOSCKEY(APIOPTR)               02S0307
*               IOSCKEY='50'X;      /* SET TO THE KEY OF THE APIO.   */
         MVI   IOSCKEY(APIOPTR),X'50'                           02S0308
*               KEYSAVED=ON;        /* INIDCATE THAT THE KEY IS 02S0309
*                                                              SAVED.*/
         OI    KEYSAVED(EWAPTR),B'00010000'                     02S0309
*               CCW1=CNTLRDRG;      /* BUILD CCW CHAIN TO READ THE   */
         MVC   CCW1(8,EWAPTR),CNTLRDRG                          02S0310
*               CCW2=READREGS;      /* REGS AND DISABLE THE PORT SO  */
         MVC   CCW2(8,EWAPTR),READREGS                          02S0311
*               RFY                                             02S0312
*                 R2P RSTD;         /* THE USER DUMP CAN OCCUR.      */
*               R2P=ADDR(REGS);                                 02S0313
         LA    R2P,REGS(,APIOPTR)                               02S0313
*               GEN SETS(R2P)(LRA R2P,0(,R2P));                 02S0314
         LRA R2P,0(,R2P)
*               CCW2ADDR=R2P;                                   02S0315
         STCM  R2P,7,CCW2ADDR(EWAPTR)                           02S0315
*               CCW3=NOP;           /* NOP CAUSES THE CE AND DE TO
*                                      OCCUR TOGETHER.               */
         MVC   CCW3(8,EWAPTR),NOP                               02S0316
*EXIT1:                                                         02S0317
*               ;                   /* THIS EXIT IS USED TO EXECUTE
*                                      CCWS CONSTRUTED BY THE ERP.   */
EXIT1    DS    0H                                               02S0318
*               R2P=ADDR(CCW1);                                 02S0318
         LA    R2P,CCW1(,EWAPTR)                                02S0318
*               GEN REFS(R2P)(LRA R2P,0(,R2P));                 02S0319
         LRA R2P,0(,R2P)
*               IOSRST=R2P;         /* SET RESTART ADDRESS.          */
         ST    R2P,IOSRST(,APIOPTR)                             02S0320
*               GEN;                                            02S0321
        ESTAE 0                    CANCEL THE ESTAE.
*               RFY                                             02S0322
*                (R1P,                                          02S0322
*                 R0P) RSTD;                                    02S0322
*               R1P=DYNPTR;         /* ADDRESS OF THE DYNAMIC   02S0323
*                                      STORAGE.                      */
         L     R1P,DYNPTR(,EWAPTR)                              02S0323
*               R0P=SPSIZE;         /* SUBPOOL AND SIZE.             */
         L     R0P,SPSIZE(,EWAPTR)                              02S0324
*               GEN REFS(R1P,R0P);                              02S0325
        FREEMAIN R,LV=(0),A=(1)    FREE THE STORAGE.
*               RFY                                             02S0326
*                (R1P,                                          02S0326
*                 R0P) UNRSTD;                                  02S0326
*               RFY                                             02S0327
*                 R1P RSTD;                                     02S0327
*               R1P=ADDR(IOSB);     /* ADDRESS OF THE IOSB.          */
         LR    R1P,APIOPTR                                      02S0328
*               SVC(15);            /* RE ISSUE THE CCW CHAIN.       */
         SVC   15                                               02S0329
*               SVC(3);             /* EXIT.                         */
         SVC   3                                                02S0330
*               RFY                                             02S0331
*                 R1P UNRSTD;                                   02S0331
*             END;                                              02S0332
*           ELSE                                                02S0333
*             IF PREVUNIT=ON THEN   /* BEEN HERE BEFORE? IF SO THE
*                                      REGS NOT VALID BECAUSE THE
*                                      READ OF THE REGS FAILED. RETRY
*                                      OF REGS READ WOULD GO HERE    */
         B     @RC00296                                         02S0333
@RF00296 TM    PREVUNIT(EWAPTR),B'01000000'                     02S0333
         BNO   @RF00333                                         02S0333
*               DO;                                             02S0334
*                 MVC(MYSENSE,APIOSNSE);/* RESTORE THE SENSE DATA.   */
         MVC   MYSENSE+32(32,EWAPTR),APIOSNSE(APIOPTR)          02S0335
*                 MVC(MYCSW(1:8),SAVEVCSW);/* RESTORE THE CSW.       */
         MVC   MYCSW(8,APIOPTR),SAVEVCSW(EWAPTR)                02S0336
*                 GO TO PROGERR;    /* GO TO THE USER PROGRAM ERROR
*                                      EXIT.                         */
         B     PROGERR                                          02S0337
*               END;                                            02S0338
*             ELSE                  /* IT IS NOT A RECURSIVE ERROR.  */
*               DO;                 /* PROCESS NON-RECURSIVE ERRORS. */
@RF00333 DS    0H                                               02S0340
*                 IF IOSDVRID=IOSVPSID/* SEE IF VPSS IS CALLER.      */
*                     &(PREV=OFF    /* SAVE SENSE UNLESS ALREADY
*                                      DONE.                         */
*                     |PREVLEN=ON) THEN/* IF PRELEN ON THEN SENSE NOT
*                                      SAVED BEFORE.         @ZA25369*/
         CLI   IOSDVRID(APIOPTR),X'0B'                          02S0340
         BNE   @RF00340                                         02S0340
         TM    PREVLEN(EWAPTR),B'00000100'                      02S0340
         BNZ   @RT00340                                         02S0340
         TM    PREV(EWAPTR),B'10000000'                         02S0340
         BO    @RF00340                                         02S0340
@RT00340 DS    0H                                               02S0341
*                   DO;             /* PRESENT SENSE TO USER.        */
*                     MVC(APIOSNSE(1:32),APSN);/* MOVE IN SENSE DATA.*/
         MVC   APIOSNSE(32,APIOPTR),APSN+32(EWAPTR)             02S0342
*                     APIOVSNS=ON;  /* INDICATE SENSE IS VALID.      */
         OI    APIOVSNS(APIOPTR),B'01000000'                    02S0343
*                   END;            /* END OF GIVE USER THE SENSE.   */
*                 IF RETRY=YES THEN /* IF RETRY OK, BOX APPROVAL IS
*                                      NOT NEEDED.                   */
@RF00340 TM    RETRY(EWAPTR),B'00000010'                        02S0345
         BNO   @RF00345                                         02S0345
*                   IF IOSDVRID=IOSVPSID/* SEE IF VPSS IS CALLER.    */
*                       &APIOEXCL=ON/* SEE IF USER IS EXCLUSIVE      */
*                       &APSNFMT=APSNFNIN THEN/* SEE IF BOX IS  02S0346
*                                      REIPLED.                      */
         CLI   IOSDVRID(APIOPTR),X'0B'                          02S0346
         BNE   @RF00346                                         02S0346
         TM    APIOEXCL(APIOPTR),B'10000000'                    02S0346
         BNO   @RF00346                                         02S0346
         CLI   APSNFMT+32(EWAPTR),4                             02S0346
         BE    @RT00346                                         02S0346
*                     GOTO LOGMSG;  /* IF ALL THAT IS TRUE THEN THE
*                                      USER MUST BE ABORTED.         */
*                   ELSE            /* OTHERWISE HE MAY BE RESTARTED.*/
*                     IF APSNFMT=APSNFNIN/* CHECK TO SEE IF THIS IS A
*                                      FORMAT 4 SENSE ERROR. IF SO WE
*                                      CAN RETRY THE CHANNEL PROGRAM
*                                      UNLESS THE 3838 BECAME   02S0348
*                                      UNINITIALIZED DUE TO A MACHINE
*                                      CHECK.                        */
*                         &APSNCCPX=OFF THEN/* IF THIS IS ON THE 3838
*                                      HAS JUST BEEN RE-IPLED SO
*                                      RETRYING WILL PROBABLY SOLVE
*                                      THE PROBLEM. IF OFF, A MACHINE
*                                      CHECK OCCURRED.               */
@RF00346 LA    @11,32                                           02S0348
         ALR   @11,EWAPTR                                       02S0348
         CLI   APSNFMT(@11),4                                   02S0348
         BNE   @RF00348                                         02S0348
         TM    APSNCCPX(@11),B'00001000'                        02S0348
         BZ    @RT00348                                         02S0348
*                       GO TO LOGMSG;/* IT IS A PERMANENT ERROR.     */
*                     ELSE          /* IT IS POTENTIALLY RETRYABLE.  */
*                       DO;         /* SET UP THE RETRY ENVIRONMENT. */
@RF00348 DS    0H                                               02S0351
*                         RESTART=OFF;/* WE CAN ONLY GET TO THIS CODE
*                                      IF THE 3838 INDICATED THAT
*                                      RESTART IS NOT POSSIBLE. 02S0351
*                                      THEREFORE ELIMINATE THAT 02S0351
*                                      POSSIBILITY.                  */
         NI    RESTART(EWAPTR),B'11110111'                      02S0351
*                         GO TO AGAIN;/* THIS EXIT WILL ATTEMPT TO
*                                      RETRY THE CHANNEL PROGRAM
*                                      UNLESS SOME OTHER        02S0352
*                                      CONSIDERATION PREVENTS IT.    */
         B     AGAIN                                            02S0352
*                       END;        /* END OF RETRY ENVIRONMENT 02S0353
*                                      SETUP.                        */
*                 ELSE              /* IF RETRY NOT ALLOWED, THEN    */
*                   GO TO LOGMSG;   /* IT IS A NON-RECOVERABLE ERROR,
*                                      SO WE WANT TO LOG THE ERROR
*                                      ETC.                          */
*               END;                /* END OF NON RECURSIVE ERRORS.  */
*         ELSE                                                  02S0356
*                                                               02S0356
*           /*********************************************************/
*           /*                                                       */
*           /* PROCESS A RE-EXECUTABLE ERROR.                        */
*           /*                                                       */
*           /*********************************************************/
*                                                               02S0356
*           DO;                                                 03S0356
         B     @RC00295                                         03S0356
@RF00295 DS    0H                                               03S0357
*             IF IOSDVRID=IOSVPSID  /* FOR VPSS USERS SAVE SENSE IN
*                                      APIO.                         */
*                 &PREV=OFF THEN    /* (UNLESS WE ALREADY DID IT)    */
         CLI   IOSDVRID(APIOPTR),X'0B'                          03S0357
         BNE   @RF00357                                         03S0357
         TM    PREV(EWAPTR),B'10000000'                         03S0357
         BNZ   @RF00357                                         03S0357
*               DO;                 /* PUT THE SENSE DATA IN THE
*                                      APIO.                         */
*                 MVC(APIOSNSE(1:32),APSN);/* SAVE THE SENSE FOR THE
*                                      DRIVER.                       */
         MVC   APIOSNSE(32,APIOPTR),APSN+32(EWAPTR)             03S0359
*                 APIOVSNS=ON;      /* INDICATE VALID SENSE.         */
         OI    APIOVSNS(APIOPTR),B'01000000'                    03S0360
*               END;                /* END OF PUT SENSE DATA.        */
*             RFY                                               03S0362
*              (R0P,                                            03S0362
*               R1P,                                            03S0362
*               R9P,                                            03S0362
*               R11P,                                           03S0362
*               R12P,                                           03S0362
*               R14P,                                           03S0362
*               R15P) RSTD;         /* USED BY INTERPRETER.          */
@RF00357 DS    0H                                               03S0363
*             R1P=ADDR(IOSB);       /* ADDRESS OF IOSB.              */
         LR    R1P,APIOPTR                                      03S0363
*             R15P=CVTXITP;         /* ADDR OF INTERPRETER ROUTINE.  */
         L     @03,CVTPTR                                       03S0364
         L     R15P,CVTXITP(,@03)                               03S0364
*             GEN REFS(R15P) SETS(R14P) FLOWS(LOGMSG,IRMSG,AGAIN)
*                 NOSEQFLOW;                                    03S0365
*  THIS CODE ANALYSES THE SENSE DATA.
U1       BALR  R14P,R15P          CALL ERP INTERPRETER ROUTINE.
         DC    X'03',AL1(URT-U1-2)   EQUIPMENT CHECK
         DC    X'02',AL1(URT-U1-4)   BUS OUT CHECK
         DC    X'04',AL1(URT-U1-6)  DATA CHECK
         DC    X'00',AL1(UCR-U1-8)   COMMAND REJECT
         DC    X'01',AL1(UIR-U1-10)   INTERVENTION REQUIRED
         DC    X'0A',AL1(UBD-U1-12)  DATA DEPENDENT
         DC    X'2F',AL1(UXX-U1-14)  ANY OTHER.
UCR      B     ERRMSG
UIR      B     IRMSG
URT      B     AGAIN
UBD      B     LOGMSG
UXX      B     LOGMSG
*             RFY                                               03S0366
*              (R0P,                                            03S0366
*               R1P,                                            03S0366
*               R9P,                                            03S0366
*               R11P,                                           03S0366
*               R12P,                                           03S0366
*               R14P,                                           03S0366
*               R15P) UNRSTD;                                   03S0366
*           END;                                                03S0367
*       END;                                                    02S0368
*     ELSE                                                      02S0369
*                                                               02S0369
*       /*************************************************************/
*       /*                                                           */
*       /* SENSE DATA IS NO GOOD, SO THERE IS NO CHOICE BUT TO ASSUME*/
*       /* THAT THE ERROR IS PERMANENT.                              */
*       /*                                                           */
*       /*************************************************************/
*                                                               02S0369
*       GOTO LOGMSG;                                            02S0369
*   END;                                                        02S0370
@RC00289 DS    0H                                               02S0371
*ILLEN:                                                         01S0371
*   ;                               /* PROCESS ILLEGAL LENGTH ERROR. */
ILLEN    DS    0H                                               01S0372
*   DO;                             /* THIS SECTION OF CODE HANDLES
*                                      THE CLEARING OF THE COMMAND
*                                      REGISTER IN THE 3838 AFTER AN
*                                      INCORRECT LENGTH PROBLEM.     */
*     PREVLEN=YES;                  /* INDICATE THAT RETURN IS FROM A
*                                      LENGTH CLEAR OPERATION.       */
*     PREV=YES;                     /* INDICATE BEEN HERE BEFORE.    */
         OI    PREVLEN(EWAPTR),B'10000100'                      02S0374
*     CCW1=CLR3838;                 /* THE CLEAR STATUS CCW.         */
         MVC   CCW1(8,EWAPTR),CLR3838                           02S0375
*     CCW2=NOP;                     /* FORCE CE, DE TOGETHER.        */
         MVC   CCW2(8,EWAPTR),NOP                               02S0376
*     GO TO EXIT1;                  /* GO EXECUTE MY CCWS.           */
         B     EXIT1                                            02S0377
*   END;                            /* END OF INCORRECT LENGTH  02S0378
*                                      PROCESS.                      */
*ALLCLEAR:                          /* CHECK TO SEE IF THIS IS A
*                                      RETURN FROM GETTING THE REGS
*                                      FOR THE USER. IF SO, THEN
*                                      INDICATE THAT THE REGS ARE
*                                      VALID IN THE APIO.            */
*   ;                                                           01S0379
ALLCLEAR DS    0H                                               01S0380
*   IF PREVLEN=YES THEN             /* SEE IF THIS IS A RETURN FROM
*                                      CLEARING THE BOX.             */
         TM    PREVLEN(EWAPTR),B'00000100'                      01S0380
         BNO   @RF00380                                         01S0380
*     DO;                           /* PROCESS RETURN                */
*       EWACHA=UCBCHAN;             /* REQUIRED FOR THE MESSAGE 01S0382
*                                      IEA000I.              @ZA25442*/
         L     @11,UCBPTR(,APIOPTR)                             01S0382
         MVC   EWACHA(2,EWAPTR),UCBCHAN(@11)                    01S0382
*       MVC(MYCSW,SAVEVCSW);        /* RESTORE THE ORIGINAL ERROR.   */
         MVC   MYCSW(8,APIOPTR),SAVEVCSW(EWAPTR)                01S0383
*       IF(IOSCSWCA-8)->CCWOPCD     /* IF A PROCESS COMMAND FAILED   */
*           ='0F'X THEN             /* SPECIAL ACTION IS REQUIRED.   */
         L     @11,IOSCSWCA-1(,APIOPTR)                         01S0384
         AL    @11,@CF03261                                     01S0384
         CLI   CCWOPCD(@11),X'0F'                               01S0384
         BNE   @RF00384                                         01S0384
*         DO;                       /* TREAT THE INCORRECT LEN AS IF
*                                      IT NEVER HAPPENED BECAUSE THE
*                                      PROCESS HIT THAT SMALL WINDOW
*                                      WHILE THE 3838 WAS CLEARING
*                                      ITSELF.                       */
*           RETRY=YES;              /* START AT BEGINING.            */
*           RESTART=NO;             /* CANNOT PICK UP IN THE MIDDLE. */
*           PREVLEN=NO;             /* PRETEND INCORRECT LEN WENT
*                                      AWAY                          */
*           PREV=NO;                /* PRETEND FIRST ENTRY TO ERP.   */
         OI    RETRY(EWAPTR),B'00000010'                        01S0389
         NI    RESTART(EWAPTR),B'01110011'                      01S0389
*           GO TO DOITOVER;         /* GO REEXECUTE THE CHANNEL PROG.*/
         B     DOITOVER                                         01S0390
*         END;                      /* END OF SPECIAL ACTION.        */
*       ELSE                        /* NOT PROCESS CMD THEN ABORT
*                                      USER.                         */
*         GO TO PROGERR;            /* GO COMPLAIN ABOUT USER.       */
*     END;                          /* END OF RETURN PROCESSING.     */
*   IF PREVUNIT=ON THEN             /* IS THIS RETURN FROM UNIT CHECK*/
@RF00380 TM    PREVUNIT(EWAPTR),B'01000000'                     01S0394
         BNO   @RF00394                                         01S0394
*     DO;                                                       01S0395
*       APIOVINX=ON;                /* SET REGS ARE VALID.           */
         OI    APIOVINX(APIOPTR),B'00100000'                    01S0396
*       MYSENSE=APIOSNSE;           /* RESTORE ORIGINAL SENSE.       */
         MVC   MYSENSE+32(32,EWAPTR),APIOSNSE(APIOPTR)          01S0397
*       MVC(MYCSW(1:8),SAVEVCSW);   /* RESTORE ORIGINAL CSW.         */
         MVC   MYCSW(8,APIOPTR),SAVEVCSW(EWAPTR)                01S0398
*       GO TO PROGERR;              /* EXIT STAGE LEFT.              */
         B     PROGERR                                          01S0399
*     END;                                                      01S0400
*   ELSE                                                        01S0401
*     GOTO OK;                      /* IF NO, JUST EXIT BECAUSE ERROR
*                                      HAS CLEARED UP.               */
*OK:                                                            01S0402
*   ;                               /* THIS EXIT IS USED AFTER AN
*                                      ERROR HAS BEEN CORRECTED.     */
OK       DS    0H                                               01S0403
*   APIOVSNS=OFF;                   /* ERROR IS CORRECTED. NON-SENSE.
*                                                            @ZA25369*/
         NI    APIOVSNS(APIOPTR),B'10111111'                    01S0403
*   IOSTATUS=''X;                   /* CLEAR THE CSW STATUS.         */
         XC    IOSTATUS(2,APIOPTR),IOSTATUS(APIOPTR)            01S0404
*   IOSEX=OFF;                      /* INDICATE ERROR CORRECTED.     */
*   IOSERR=OFF;                                                 01S0406
         NI    IOSEX(APIOPTR),B'11011011'                       01S0406
*   IOSQISCE=OFF;                   /* RESET IOSB QUIESCE FLAG.      */
         NI    IOSQISCE(APIOPTR),B'11011111'                    01S0407
*   EWACNTRS=''X;                   /* CLEAR CNTRS AND FLAGS.        */
         XC    EWACNTRS(4,EWAPTR),EWACNTRS(EWAPTR)              01S0408
*STATCHK:                                                       01S0409
*   ;                               /* THIS UPDATES THE STATISTICS
*                                      TABLES IF THAT IS REQUIRED.   */
STATCHK  DS    0H                                               01S0410
*   IF EWASTUP='0000'X THEN         /* IS STAT UPDATE NEEDED?        */
         CLC   EWASTUP(2,EWAPTR),@CB03058                       01S0410
         BNE   @RF00410                                         01S0410
*     DO;                           /* NO UPDATE IS REQUIRED.        */
*/*   RESET THE QUIESCE BIT IN THE UCB.                              */
*                                                               01S0412
*       CALL RESETQB;                                           01S0412
         BAL   @14,RESETQB                                      01S0412
*       RFY                                                     01S0413
*         R1P RSTD;                                             01S0413
*       R1P=ADDR(IOSB);             /* IF NO, JUST EXIT              */
         LR    R1P,APIOPTR                                      01S0414
*       SVC(15);                                                01S0415
         SVC   15                                               01S0415
*       SVC(3);                                                 01S0416
         SVC   3                                                01S0416
*       RFY                                                     01S0417
*         R1P UNRSTD;                                           01S0417
*     END;                                                      01S0418
*                                                               01S0418
*   /*****************************************************************/
*   /*                                                               */
*   /* UPDATE THE STATISTICS TABLE.                                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0419
*XCTLSTAT:                                                      01S0419
*   ;                               /* IF YES, GO TO IT.             */
@RF00410 DS    0H                                               01S0419
XCTLSTAT DS    0H                                               01S0420
*   RFY                                                         01S0420
*    (R1P,                                                      01S0420
*     R13P,                                                     01S0420
*     R14P) RSTD;                                               01S0420
*                                                               01S0420
*/*   RESET THE QUIESCE BIT IN THE UCB.                              */
*                                                               01S0421
*   CALL RESETQB;                                               01S0421
         BAL   @14,RESETQB                                      01S0421
*   RFY                                                         01S0422
*    (R1P,                                                      01S0422
*     R13P,                                                     01S0422
*     R14P) RSTD;                                               01S0422
*   R13P=254;                                                   01S0423
         LA    R13P,254                                         01S0423
*   R14P=CVTXTLER;                                              01S0424
         L     @11,CVTPTR                                       01S0424
         L     R14P,CVTXTLER(,@11)                              01S0424
*   R1P=ADDR(IOSB);                                             01S0425
         LR    R1P,APIOPTR                                      01S0425
*   GEN REFS(R14P)( BR    R14P)                                 01S0426
*   NOSEQFLOW EXIT;                                             01S0426
          BR    R14P
*   RFY                                                         01S0427
*    (R1P,                                                      01S0427
*     R13P,                                                     01S0427
*     R14P) UNRSTD;                                             01S0427
*IRMSG:                                                         01S0428
*   ;                               /* THIS EXIT IS USED WHEN   01S0428
*                                      INTERVENTION REQUIRED OCCURS.
*                                      WITH THE 3838, NO OPERATOR
*                                      ACTION WOULD BE BENIFICAL SO
*                                      ONLY THE REGULAR ERROR MESSAGE
*                                      IS ISSUED. IF EVER ANY OTHER
*                                      ACTION SHOULD PROVE USEFUL,
*                                      THE CODE WOULD BE INSERTED
*                                      HERE.                         */
IRMSG    DS    0H                                               01S0429
*LOGMSG:                                                        01S0429
*   ;                               /* THIS EXIT IS USED IF WHEN
*                                      LOGGING OF THE ERROR IS  01S0429
*                                      DESIRED.                      */
LOGMSG   DS    0H                                               01S0430
*   IOSLOG=ON;                      /* INDICATE LOGGING IS REQUIRED. */
         OI    IOSLOG(APIOPTR),B'00000001'                      01S0430
*NOLOG:                                                         01S0431
*   ;                               /* THIS EXIT IS USED IF NO  01S0431
*                                      LOGGING IS DESIRED BUT AN
*                                      ERROR MESSAGE IS USEFUL.      */
NOLOG    DS    0H                                               01S0432
*ERRMSG:                                                        01S0432
*   ;                               /* SAME USE AS NOLOG.            */
ERRMSG   DS    0H                                               01S0433
*   IOSMSG=ON;                      /* ERROR MESSAGE IS REQUIRED.    */
         OI    IOSMSG(APIOPTR),B'00000100'                      01S0433
*   IOSERR=OFF;                     /* ERP GIVES UP.                 */
         NI    IOSERR(APIOPTR),B'11011111'                      01S0434
*   IOSQISCE=OFF;                   /* RESET IOSB QUIESCE FLAG.      */
         NI    IOSQISCE(APIOPTR),B'11011111'                    01S0435
*   RFY                                                         01S0436
*     R1P RSTD;                                                 01S0436
*   R1P=0;                          /* INDICATE PERMINENT ERRORS.    */
         SLR   R1P,R1P                                          01S0437
*   CALL ERRCTR;                    /* UPDATE THE PERMANENT ERROR
*                                      CTRS.                         */
         BAL   @14,ERRCTR                                       01S0438
*   RFY                                                         01S0439
*     R1P UNRSTD;                                               01S0439
*                                                               01S0439
*/*   RESET THE QUIESCE BIT IN THE UCB.                              */
*                                                               01S0440
*   CALL RESETQB;                                               01S0440
         BAL   @14,RESETQB                                      01S0440
*   RFY                                                         01S0441
*    (R1P,                                                      01S0441
*     R13P,                                                     01S0441
*     R14P) RSTD;                                               01S0441
*   R1P=ADDR(IOSB);                 /* EXIT TO THE WTO ROUTINE.      */
         LR    R1P,APIOPTR                                      01S0442
*   R13P=253;                                                   01S0443
         LA    R13P,253                                         01S0443
*   R14P=CVTXTLER;                                              01S0444
         L     @11,CVTPTR                                       01S0444
         L     R14P,CVTXTLER(,@11)                              01S0444
*   GEN REFS(R14P)(BR    R14P)                                  01S0445
*   NOSEQFLOW EXIT;                                             01S0445
         BR    R14P
*DOITOVER:                                                      01S0446
*   ;                               /* RETRY THE CHANNEL PROGRAM, IF
*                                      * POSSIBLE.                   */
DOITOVER DS    0H                                               01S0447
*   IF RESTART=YES THEN                                         01S0447
         TM    RESTART(EWAPTR),B'00001000'                      01S0447
         BNO   @RF00447                                         01S0447
*     DO;                                                       01S0448
*                                                               01S0448
*       /*************************************************************/
*       /*                                                           */
*       /* DETERMINE IF ERROR OCCURRED IN THE RESTART CCWS. IF SO    */
*       /* THEN JUST START THE THING OVER AGAIN.                     */
*       /*                                                           */
*       /*************************************************************/
*                                                               01S0449
*       IF IOSCSWCA<ADDR(CCW2)|     /* IF FAILURE ADDRESS IS NOT
*                                      BETWEEN THE LIMITS OF THE
*                                      FAILING CCWS, .. THEN THE
*                                      FAILURE OCCURRED ELSE .. 01S0449
*                                      WHERE.                        */
*           IOSCSWCA>ADDR(CCW3) THEN/* THE CSW ADDR IS 8 LRGER THAN
*                                      THE REAL CCW ADDRESS.         */
         L     @15,IOSCSWCA-1(,APIOPTR)                         01S0449
         LA    @15,0(,@15)                                      01S0449
         LA    @11,CCW2(,EWAPTR)                                01S0449
         CR    @15,@11                                          01S0449
         BL    @RT00449                                         01S0449
         LA    @11,CCW3(,EWAPTR)                                01S0449
         CR    @15,@11                                          01S0449
         BNH   @RF00449                                         01S0449
@RT00449 DS    0H                                               01S0450
*         DO;                       /* BUILD THE RESTART CCWS.       */
*           CCW1=CCWRST;            /* IF RESTART POSSIBLE, SET UP   */
         MVC   CCW1(8,EWAPTR),CCWRST                            01S0451
*           CCW2=TIC;               /* CONTROL AND TIC CCWS.         */
         MVC   CCW2(8,EWAPTR),TIC                               01S0452
*           RFY                                                 01S0453
*             R2P RSTD;                                         01S0453
*           R2P=IOSCSWCA-8;                                     01S0454
         L     R2P,IOSCSWCA-1(,APIOPTR)                         01S0454
         LA    R2P,0(,R2P)                                      01S0454
         SL    R2P,@CF00059                                     01S0454
*           GEN SETS(R2P)(LRA  R2P,0(,R2P));                    01S0455
         LRA  R2P,0(,R2P)
*           CCW2ADDR=R2P;                                       01S0456
         STCM  R2P,7,CCW2ADDR(EWAPTR)                           01S0456
*         END;                      /* END OF RESTART BUILD.         */
*       R2P=ADDR(CCW1);                                         01S0458
@RF00449 LA    R2P,CCW1(,EWAPTR)                                01S0458
*     END;                                                      01S0459
*   ELSE                                                        01S0460
*     IF RETRY=YES THEN             /* IF RETRY POSSIBLE, START OVER.*/
         B     @RC00447                                         01S0460
@RF00447 TM    RETRY(EWAPTR),B'00000010'                        01S0460
         BNO   @RF00460                                         01S0460
*       R2P=IOSVST;                                             01S0461
         L     R2P,IOSVST(,APIOPTR)                             01S0461
*     ELSE                                                      01S0462
*       GOTO LOGMSG;                                            01S0462
*   GEN SETS(R2P)(LRA   R2P,0(,R2P));                           01S0463
@RC00447 DS    0H                                               01S0463
         LRA   R2P,0(,R2P)
*   IOSRST=R2P;                                                 01S0464
         ST    R2P,IOSRST(,APIOPTR)                             01S0464
*   RFY                                                         01S0465
*     R2P UNRSTD;                                               01S0465
*   RFY                                                         01S0466
*     R1P RSTD;                                                 01S0466
*   R1P=1;                          /* INDICATE TEMPORARY ERRORS.    */
         LA    R1P,1                                            01S0467
*   CALL ERRCTR;                    /* UPDATE TEMPORARY ERROR   01S0468
*                                      COUNTERS.                     */
         BAL   @14,ERRCTR                                       01S0468
*   GEN;                                                        01S0469
        ESTAE 0                    CANCEL THE ESTAE.
*   RFY                                                         01S0470
*     R0P RSTD;                                                 01S0470
*   R1P=DYNPTR;                     /* ADDRESS OF THE DYNAMIC   01S0471
*                                      STORAGE.                      */
         L     R1P,DYNPTR(,EWAPTR)                              01S0471
*   R0P=SPSIZE;                     /* SUBPOOL AND SIZE.             */
         L     R0P,SPSIZE(,EWAPTR)                              01S0472
*   GEN REFS(R1P,R0P);                                          01S0473
        FREEMAIN R,LV=(0),A=(1)    FREE THE STORAGE.
*   RFY                                                         01S0474
*     R0P UNRSTD;                                               01S0474
*   R1P=ADDR(IOSB);                 /* EXIT TO IOS TO START THE CP.  */
         LR    R1P,APIOPTR                                      01S0475
*   SVC(15);                                                    01S0476
         SVC   15                                               01S0476
*   SVC(3);                                                     01S0477
         SVC   3                                                01S0477
*   RFY                                                         01S0478
*     R1P UNRSTD;                                               01S0478
*                                                               01S0479
*/*   THIS EXIT MAY BE USED ONLY AFTER A UNIT CHECK.                 */
*                                                               01S0479
*AGAIN:                             /* THIS EXIT IS USED TO DETERMINE
*                                      WHERE TO BEGIN REEXECUTION OF
*                                      THE CHANNEL PROGRAM, IF INDEED
*                                      REEXECUTION IS POSSIBLE.      */
*   IF APSNRQRS=OFF THEN            /* IF THE 3838 THINKS THAT  01S0479
*                                      RESTART IS NOT POSSIBLE, DON'T
*                                      ARGUE.                        */
AGAIN    TM    APSNRQRS+32(EWAPTR),B'10000000'                  01S0479
         BNZ   @RF00479                                         01S0479
*     RESTART=NO;                                               01S0480
         NI    RESTART(EWAPTR),B'11110111'                      01S0480
*   IF RETRY=NO&                    /* IF NEITHER RETRY OR RESTART IS
*                                      POSSIBLE, THEN SURRENDER.     */
*       RESTART=NO THEN                                         01S0481
@RF00479 TM    RETRY(EWAPTR),B'00001010'                        01S0481
         BZ    @RT00481                                         01S0481
*     GOTO LOGMSG;                                              01S0482
*   EWACNTR2=EWACNTR2+1;                                        01S0483
@RF00481 LA    @15,1                                            01S0483
         SLR   @11,@11                                          01S0483
         IC    @11,EWACNTR2(,EWAPTR)                            01S0483
         ALR   @15,@11                                          01S0483
         STC   @15,EWACNTR2(,EWAPTR)                            01S0483
*   IF EWACNTR2<10 THEN             /* IF WE HAVE NOT ALREADY RETRIED
*                                      OR RESTARTED A REASONABLE
*                                      NUMBER OF TIMES, THEN GO TRY
*                                      AGAIN.                        */
         CLI   EWACNTR2(EWAPTR),10                              01S0484
         BL    @RT00484                                         01S0484
*     GOTO DOITOVER;                                            01S0485
*   ELSE                            /* IF WE HAVE, GIVE UP.          */
*     GOTO LOGMSG;                                              01S0486
         B     LOGMSG                                           01S0486
*LOGRTRY:                           /* THIS EXIT IS USED TO LOG THE
*                                      ERROR AND WRITE A MESSAGE TO
*                                      THE OPERATOR, BUT THEN RETRY
*                                      THE CHANNEL PROGRAM. IT IS
*                                      USED AFTER AN INTERCEPT OR FOR
*                                      AN UNRELATED ERROR, WHERE WE
*                                      WISH TO RECORD THE ERROR BUT
*                                      HAVE THE CURRENT THEN EXECUTE.
*                                      THE PERMANENT ERROR MESSAGE IS
*                                      WRITTEN.                      */
*   IOSLOG=ON;                      /* INDICATE THAT LOGGING IS 01S0487
*                                      REQUIRED.                     */
LOGRTRY  DS    0H                                               01S0488
*   IOSMSG=ON;                      /* INDICATE THAT THE MSG IS 01S0488
*                                      NEEDED.                       */
         OI    IOSLOG(APIOPTR),B'00000101'                      01S0488
*   IOSEX=OFF;                      /* IT IS NOT A PERMANENT ERROR
*                                      BECAUSE TO THIS USER AT LEAST
*                                      IT IS NOT EVEN AN ERROR  01S0489
*                                      BECAUSE IT IS UNRELATED TO ANY
*                                      THING HE IS TRYING TO DO.     */
         NI    IOSEX(APIOPTR),B'11111011'                       01S0489
*   RFY                                                         01S0490
*     R2P RSTD;                     /* USED TO COMPUTE THE REAL 01S0490
*                                      ADDRESS.                      */
*   R2P=IOSVST;                     /* ADDRESS OF THE CHANNEL   01S0491
*                                      PROGRAM.                      */
         L     R2P,IOSVST(,APIOPTR)                             01S0491
*   GEN SETS(R2P)(LRA   R2P,0(,R2P));/* COMPUTE REAL ADDRESS.        */
         LRA   R2P,0(,R2P)
*   IOSRST=R2P;                     /* STORE RESTART THE RESTART
*                                      ADDRESS.                      */
         ST    R2P,IOSRST(,APIOPTR)                             01S0493
*   RFY                                                         01S0494
*     R2P UNRSTD;                   /* DON'T NEED IT ANY MORE.       */
*   RFY                                                         01S0495
*     R1P RSTD;                                                 01S0495
*   R1P=0;                          /* INDICATE PERMANENT ERRORS.    */
         SLR   R1P,R1P                                          01S0496
*   CALL ERRCTR;                    /* UPDATE THE PERMANENT ERROR
*                                      COUNTERS , TREATING PM ERRORS
*                                      AS PERMANENT.                 */
         BAL   @14,ERRCTR                                       01S0497
*   GEN;                                                        01S0498
        ESTAE 0                    CANCEL THE ESTAE.
*   RFY                                                         01S0499
*    (R1P,                                                      01S0499
*     R0P) RSTD;                                                01S0499
*   R1P=DYNPTR;                     /* ADDRESS OF THE DYNAMIC   01S0500
*                                      STORAGE.                      */
         L     R1P,DYNPTR(,EWAPTR)                              01S0500
*   R0P=SPSIZE;                     /* SUBPOOL AND SIZE.             */
         L     R0P,SPSIZE(,EWAPTR)                              01S0501
*   GEN REFS(R1P,R0P);                                          01S0502
        FREEMAIN R,LV=(0),A=(1)    FREE THE STORAGE.
*   RFY                                                         01S0503
*    (R1P,                                                      01S0503
*     R0P) UNRSTD;                                              01S0503
*   R1P=ADDR(IOSB);                 /* IOS REQUIRES THE IOSB ADDR IN
*                                      R1.                           */
         LR    R1P,APIOPTR                                      01S0504
*   R13P=253;                       /* CODE FOR THE WTO ROUTINE.     */
         LA    R13P,253                                         01S0505
*   R14P=CVTXTLER;                  /* ADDR OF THE RESIDENT XCTL
*                                      ROUTINE.                      */
         L     @11,CVTPTR                                       01S0506
         L     R14P,CVTXTLER(,@11)                              01S0506
*   GEN REFS(R14P)(BR  R14P)                                    01S0507
*   NOSEQFLOW EXIT;                 /* GO TO IGE0025C.               */
         BR  R14P
*   RFY                                                         01S0508
*     R1P UNRSTD;                                               01S0508
*PROGERR:                                                       01S0509
*   ;                               /* THIS EXIT IS USED FOR A USER
*                                      PROGRAMMING ERROR.            */
PROGERR  DS    0H                                               01S0510
*   IOSMSG=ON;                      /* ERROR MESSAGE IS REQUIRED.    */
         OI    IOSMSG(APIOPTR),B'00000100'                      01S0510
*   IOSERR=OFF;                     /* ERP GIVES UP.                 */
         NI    IOSERR(APIOPTR),B'11011111'                      01S0511
*   IOSQISCE=OFF;                   /* RESET IOSB QUIESCE FLAG.      */
         NI    IOSQISCE(APIOPTR),B'11011111'                    01S0512
*   IF DUMPREQ=OFF THEN             /* IF A DUMP IS NOT SCHEDULED
*                                      THEN THE QUIESCE BIT MUST BE
*                                      RESET SO OTHER I/O MAY BE
*                                      EXECUTED.                     */
         TM    DUMPREQ(EWAPTR),B'00100000'                      01S0513
         BNZ   @RF00513                                         01S0513
*     DO;                                                       01S0514
*                                                               01S0514
*       /*************************************************************/
*       /*                                                           */
*       /* RESET THE QUIESCE BIT IN THE UCB.                         */
*       /*                                                           */
*       /*************************************************************/
*                                                               01S0515
*       CALL RESETQB;                                           01S0515
         BAL   @14,RESETQB                                      01S0515
*     END;                                                      01S0516
*   ELSE                            /* NOW WE MUST TELL THE VPSS
*                                      MONITOR TO DO A PORT DUMP FOR
*                                      THE USER.                     */
*     DO;                                                       01S0517
         B     @RC00513                                         01S0517
@RF00513 DS    0H                                               01S0518
*       APUBPDMP=ON;                /* INDICATE USER DUMP REQUIRED.  */
         L     @09,APIOAPUB(,APIOPTR)                           01S0518
         L     @15,APUBPDMP(,@09)                               01S0518
@GL00017 LR    @11,@15                                          01S0518
         O     @11,@CF03270                                     01S0518
         CS    @15,@11,APUBPDMP(@09)                            01S0518
         BNE   @GL00017                                         01S0518
*       APIODMPT=ON;                /* INDICATE DUMP TAKEN.          */
         OI    APIODMPT(APIOPTR),B'00000100'                    01S0519
*       APUBJBNM=                   /* GIVE DUMP THE JOBNAME.        */
*           APIODEB->DEBIRBAD->APDXAPDS->APDSJBNM;              01S0520
         L     @15,APIOAPUB(,APIOPTR)                           01S0520
         L     @11,APIODEB(,APIOPTR)                            01S0520
         L     @11,DEBIRBAD(,@11)                               01S0520
         L     @11,APDXAPDS(,@11)                               01S0520
         MVC   APUBJBNM(8,@15),APDSJBNM(@11)                    01S0520
*       APCTPTR=APUBAPCT;           /* GET POINTER TO THE APCT.      */
         L     APCTPTR,APUBAPCT(,@15)                           01S0521
*       RFY                                                     01S0522
*         R13P RSTD;                /* NEED THIS REG.                */
*       R13P=ADDR(SAVE16);          /* ADDRESS OF A SAVE AREA.       */
         LA    R13P,SAVE16                                      01S0523
*       DO;                         /* IGTYPOST                 01S0524
*                                      ECB(APCTEIPL)ASCBLOC(APCTASCB)*/
*         RFY                                                   01S0525
*          (GPR00P,                                             01S0525
*           GPR01P,                                             01S0525
*           GPR14F,                                             01S0525
*           GPR15F) RSTD;           /* REGISTERS USED                */
*         GPR15F=APCTEIPL;          /* CURRENT ECB CONTENTS          */
         L     GPR15F,APCTEIPL(,APCTPTR)                        01S0526
*LTR0013X:                                                      01S0527
*         IF GPR15F<0 THEN          /* IF ECB ALREADY                */
LTR0013X LTR   GPR15F,GPR15F                                    01S0527
         BNM   @RF00527                                         01S0527
*           DO;                     /* WAITED UPON, MUST ISSUE POST  */
*             GPR01P=ADDR(APCTEIPL);/* ADDRESS OF ECB TO POST        */
         LA    GPR01P,APCTEIPL(,APCTPTR)                        01S0529
*             GPR00P=APCTASCB;      /* ADDR OF ASCB FOR MEMORY TO BE
*                                      POSTED                        */
         L     GPR00P,APCTASCB(,APCTPTR)                        01S0530
*             CALL APCVZUBB;        /* ISSUE CROSS-MEMORY POST       */
         L     @15,APCTZUBB(,APCTPTR)                           01S0531
         BALR  @14,@15                                          01S0531
*           END;                    /* ECB POSTED                    */
*         ELSE                      /* ECB NOT YET POSTED            */
*           DO;                     /* SO TRY 'COMPARE-AND-SWAP' POST*/
         B     @RC00527                                         01S0533
@RF00527 DS    0H                                               01S0534
*             GPR14F='40000000'X;   /* POST CODE                     */
         L     GPR14F,@CF03082                                  01S0534
*             CS(GPR15F,GPR14F,APCTEIPL);/* POST THE ECB             */
         CS    GPR15F,@14,APCTEIPL(APCTPTR)                     01S0535
*             BC(7,LTR0013X);       /* RETRY IF 'CS' FAILED          */
         BC    7,LTR0013X                                       01S0536
*           END;                    /* ECB POSTED VIA 'CS'           */
*         RFY                                                   01S0538
*          (GPR00P,                                             01S0538
*           GPR01P,                                             01S0538
*           GPR14F,                                             01S0538
*           GPR15F) UNRSTD;         /* DONE WITH REGS                */
@RC00527 DS    0H                                               01S0539
*       END;                        /* POST LOGIC COMPLETE           */
*       RFY                                                     01S0540
*         R13P UNRSTD;              /* DROP THIS REG.                */
*       GEN;                                                    01S0541
        ESTAE 0                    CANCEL THE ESTAE.
*       RFY                                                     01S0542
*        (R1P,                                                  01S0542
*         R0P) RSTD;                                            01S0542
*       R1P=DYNPTR;                 /* ADDRESS OF THE DYNAMIC   01S0543
*                                      STORAGE.                      */
         L     R1P,DYNPTR(,EWAPTR)                              01S0543
*       R0P=SPSIZE;                 /* SUBPOOL AND SIZE.             */
         L     R0P,SPSIZE(,EWAPTR)                              01S0544
*       GEN REFS(R1P,R0P);                                      01S0545
        FREEMAIN R,LV=(0),A=(1)    FREE THE STORAGE.
*       RFY                                                     01S0546
*        (R1P,                                                  01S0546
*         R0P) UNRSTD;                                          01S0546
*     END;                                                      01S0547
*   RFY                                                         01S0548
*    (R1P,                                                      01S0548
*     R13P,                                                     01S0548
*     R14P) RSTD;                                               01S0548
@RC00513 DS    0H                                               01S0549
*   R1P=ADDR(IOSB);                 /* EXIT TO THE WTO ROUTINE.      */
         LR    R1P,APIOPTR                                      01S0549
*   R13P=253;                                                   01S0550
         LA    R13P,253                                         01S0550
*   R14P=CVTXTLER;                                              01S0551
         L     @11,CVTPTR                                       01S0551
         L     R14P,CVTXTLER(,@11)                              01S0551
*   GEN REFS(R14P)(BR    R14P)                                  01S0552
*   NOSEQFLOW EXIT;                                             01S0552
         BR    R14P
*   RFY                                                         01S0553
*    (R1P,                                                      01S0553
*     R13P,                                                     01S0553
*     R14P) UNRSTD;                                             01S0553
*                                                               01S0554
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS PROCEDURE IS USED TO UPDATE ERROR COUNTERS AND TAKE      */
*   /* APPROPRIATE ACTION. IF A THRESHOLD IS REACHED: FOR TEMPORARY  */
*   /* ERRORS, THE OPERATOR IS NOTIFIED BY MESSAGE IGT300I. FOR      */
*   /* PERMANENT ERRORS, THE MESSAGE IS WRITTEN AND THE 3838 IS      */
*   /* DUMPED FOLLOWED BY A RE-IPL, OR THE PORT IS DISABLED DEPENDING*/
*   /* ON WHETHER THE ERROR IS SUB-CHANNEL RELATED OR BOX RELATED.   */
*   /* BULK STORAGE PARITY ERRORS AND PHYSICAL I/O ERRORS ARE        */
*   /* CONSIDERED SUBCHANNEL ERRORS. USER ERRORS (FORMAT 2 SENSE DATA*/
*   /* ) ARE NOT COUNTED. ALL OTHER ERRORS ARE CONSIDERED BOX, OR    */
*   /* CONTROLLER, ERRORS.                                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0554
*ERRCTR:                                                        01S0554
*   PROC OPTIONS(DONTSAVE,NOSAVEAREA);                          01S0554
ERRCTR   DS    0H                                               01S0555
*   DCL                                                         01S0555
*     1 EBCERR STATIC LOCAL,        /* EBCDIC ERROR FIELDS           */
*      2 TOTAL CHAR(2) INIT('TE'),  /* TOTAL ERRORS.                 */
*      2 BULK CHAR(2) INIT('BS'),   /* BULK STORE.                   */
*      2 TIME CHAR(2) INIT('TO'),   /* TIME OUT.                     */
*      2 IO CHAR(2) INIT('IO'),     /* I/O.                          */
*      2 CONT CHAR(2) INIT('CP');   /* CONTROLLER.                   */
*   DCL                                                         01S0556
*     1 ERRORS BASED(CTRPTR),       /* ERROR COUNTERS.               */
*      2 TOTC FIXED(15),            /* TOTAL NUMBER OF ERRORS.       */
*      2 IOC FIXED(15),             /* I/O COUNT OF ERRORS           */
*      2 CNTLRC FIXED(15),          /* COUNT OF CONTROLLER ERRORS.   */
*      2 PTOC FIXED(15),            /* COUNT OF PERMANENT TIMEOUTS.  */
*      2 BSC FIXED(15);             /* COUNT OF BULK STORAGE ERRORS. */
*   DCL                                                         01S0557
*     1 THRSHLDS BASED(THRSPTR),    /* ERROR THRESHOLDS.             */
*      2 TOTT FIXED(15),            /* THRESHOLD FOR TOTAL ERRORS.   */
*      2 IOT FIXED(15),             /* I/O ERRORS THRESHOLD.         */
*      2 CNTLRT FIXED(15),          /* CONTROLLER ERRORS THRSHOLD.   */
*      2 PTOT FIXED(15),            /* TIME OUT THRESHOLD.           */
*      2 BST FIXED(15);             /* BULK STORAGE THRESHOLD.       */
*   DCL                                                         01S0558
*    (CTRPTR,                       /* POINTER PROPER ERROR COUNTS.  */
*     THRSPTR) PTR(31);             /* POINTER TO PROPER THRESHOLD.  */
*   DCL                                                         01S0559
*     GOBACK PTR(31);               /* SAVE RETURN REG.              */
*   RFY                                                         01S0560
*     R1P RSTD;                     /* CONTAINS PERM/TEMP CODE.      */
*                                                               01S0560
*   /*****************************************************************/
*   /*                                                               */
*   /* R1P = 0 FOR PERMANENT ERRORS. R1P = 1 FOR TEMPORARY ERRORS.   */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0561
*   GOBACK=R14P;                    /* SAVE RETURN.                  */
         LR    GOBACK,R14P                                      01S0561
*   IF IOSDVRID=IOSVPSID THEN       /* SEE IF VPSS IS THE DRIVER.    */
         CLI   IOSDVRID(APIOPTR),X'0B'                          01S0562
         BNE   @RF00562                                         01S0562
*     DO;                                                       01S0563
*       APCTPTR=APUBAPCT;           /* POINTER TO THE APCT.          */
         L     @09,APIOAPUB(,APIOPTR)                           01S0564
         L     APCTPTR,APUBAPCT(,@09)                           01S0564
*       RFY                                                     01S0565
*         R13P RSTD;                                            01S0565
*       R13P=ADDR(SAVE16);          /* SAVE AREA FOR CROSS MEMORY
*                                      POST.                         */
         LA    R13P,SAVE16                                      01S0566
*       DO;                         /* DETERMINE TYPE OF ERROR AND
*                                      UPDATE COUNTERS IF REQUIRED.
*                                      SET RETURN CODE IN CTRPTR: 0 =
*                                      NO THRESHOLD REACHED. ^0 =
*                                      ADDRESS OF THRESHOLD CROSSED (
*                                      = # OF ERRORS), TAKE ACTION.  */
*         IF R1P=0 THEN             /* 0 = PERMANENT ERROR, 1 = TEMP.*/
         LTR   R1P,R1P                                          02S0568
         BNZ   @RF00568                                         02S0568
*           DO;                                                 02S0569
*             CTRPTR=ADDR(APUBERR0);/* ADDRESS OF PERM ERROR    02S0570
*                                      COUNTERS.                     */
         L     @15,APIOAPUB(,APIOPTR)                           02S0570
         LA    CTRPTR,APUBERR0(,@15)                            02S0570
*             THRSPTR=ADDR(APCTERT0);/* ADDRESS OF PERM THRESHOLDS.  */
         LA    THRSPTR,APCTERT0(,APCTPTR)                       02S0571
*           END;                                                02S0572
*         ELSE                      /* R1P = 1.                      */
*           DO;                                                 02S0573
         B     @RC00568                                         02S0573
@RF00568 DS    0H                                               02S0574
*             CTRPTR=ADDR(APUBERRA);/* ADDRESS OF TEMP ERROR    02S0574
*                                      COUNTERS.                     */
         L     CTRPTR,APIOAPUB(,APIOPTR)                        02S0574
         LA    CTRPTR,APUBERRA(,CTRPTR)                         02S0574
*             THRSPTR=ADDR(APCTERTA);/* ADDRESS OF TEMP THRESHOLDS.  */
         LA    THRSPTR,APCTERTA(,APCTPTR)                       02S0575
*           END;                                                02S0576
*         TOTC=TOTC+1;              /* INCREMENT TOTAL ERRORS COUNT. */
@RC00568 LA    @03,1                                            02S0577
         AH    @03,TOTC(,CTRPTR)                                02S0577
         STH   @03,TOTC(,CTRPTR)                                02S0577
*         IF TOTC>=TOTT THEN        /* SEE IF THRESHOLD REACHED.     */
         CH    @03,TOTT(,THRSPTR)                               02S0578
         BL    @RF00578                                         02S0578
*           DO;                     /* PROCESS TOTAL ERRORS     02S0579
*                                      VIOLATION.                    */
*             TOTC=0;               /* ZERO THE COUNTER.             */
         SLR   @03,@03                                          02S0580
         STH   @03,TOTC(,CTRPTR)                                02S0580
*             CTRPTR=ADDR(TOTT);    /* NUMBER OF ERRORS ENCOUNTERED. */
         LR    CTRPTR,THRSPTR                                   02S0581
*             THRSPTR=ADDR(TOTAL);  /* ADDRESS OF ERROR TYPE.        */
         LA    THRSPTR,TOTAL                                    02S0582
*           END;                    /* END OF TOTAL ERRORS.          */
*         ELSE                      /* CHECK SPECIFIC THRESHOLDS.    */
*           DO;                     /* PROCESS SPECIFIC ERROR TYPES. */
         B     @RC00578                                         02S0584
@RF00578 DS    0H                                               02S0585
*             IF IOSCOD=IOSMIHC THEN/* CHECK FOR A MISSING INTERRUPT,
*                                      WHICH IS EQUIVALENT TO A 02S0585
*                                      TIMEOUT                       */
         CLI   IOSCOD(APIOPTR),X'74'                            02S0585
         BNE   @RF00585                                         02S0585
*               DO;                 /* UPDATE THE TIMEOUT COUNTERS.  */
*                 PTOC=PTOC+1;      /* INCREMENT THE COUNTER.        */
         LA    @03,1                                            03S0587
         AH    @03,PTOC(,CTRPTR)                                03S0587
         STH   @03,PTOC(,CTRPTR)                                03S0587
*                 IF PTOC<PTOT THEN /* SEE IF THRESHOLD EXCEEDED.    */
         CH    @03,PTOT(,THRSPTR)                               03S0588
         BNL   @RF00588                                         03S0588
*                   CTRPTR=0;       /* IF NOT, THEN INDICATE THAT
*                                      FACT.                         */
         SLR   CTRPTR,CTRPTR                                    03S0589
*                 ELSE              /* IF SO, THEN MSG WRITER NEEDS  */
*                   DO;             /* THE FOLLOWING DATA.           */
         B     @RC00588                                         03S0590
@RF00588 DS    0H                                               03S0591
*                     PTOC=0;       /* ZERO THE COUNTER.             */
         SLR   @03,@03                                          03S0591
         STH   @03,PTOC(,CTRPTR)                                03S0591
*                     CTRPTR=ADDR(PTOT);/* THE ADDRESS OF THE   03S0592
*                                      THRESHOLD.                    */
         LA    CTRPTR,PTOT(,THRSPTR)                            03S0592
*                     THRSPTR=ADDR(TIME);/* THE ADDRESS OF THE  03S0593
*                                      COMPONENT.                    */
         LA    THRSPTR,TIME                                     03S0593
*                   END;            /* END OF MSG WRITER        03S0594
*                                      INITIALIZATN.                 */
*               END;                /* END OF UPDATE.                */
*             ELSE                                              02S0596
*               IF CSWCDC=ON|       /* TEST FOR A CHANNEL RELATED    */
*                   CSWCCC=ON|      /* ERROR, EITHER CONTROL CHECKS  */
*                   CSWICC=ON|      /* OR DATA CHECKS.               */
*                                                               02S0596
*               /*****************************************************/
*               /*                                                   */
*               /* TEST FOR BUS OUT PARITY OR DATA CHECK, BUT ONLY IF*/
*               /* VALID SENSE DATA IS PRESENT.                      */
*               /*                                                   */
*               /*****************************************************/
*                                                               02S0596
*                   (CSWUCK=ON&     /* ON MEANS UNIT CHECK.          */
*                   EWABDSNS=OFF&   /* OFF MEANS SENSE DATA IS VALID */
*                   (APSNBOP=ON|    /* SEE IF BUS OUT PARITY OR      */
*                   APSNDTCK=ON))   /* DATA CHECK IS ON.             */
*                 THEN              /* IF ANY IS TRUE THEN IT'S A
*                                      CHANNEL ERROR.                */
         B     @RC00585                                         02S0596
@RF00585 TM    CSWCDC(APIOPTR),B'00001110'                      02S0596
         BNZ   @RT00596                                         02S0596
         TM    CSWUCK(APIOPTR),B'00000010'                      02S0596
         BNO   @RF00596                                         02S0596
         TM    EWABDSNS(EWAPTR),B'00000001'                     02S0596
         BNZ   @RF00596                                         02S0596
         TM    APSNBOP+32(EWAPTR),B'00101000'                   02S0596
         BZ    @RF00596                                         02S0596
@RT00596 DS    0H                                               02S0597
*                 DO;               /* UPDATE THE IO ERROR COUNTERS. */
*                   IOC=IOC+1;      /* INCREMENT THE COUNTER.        */
         LA    @03,1                                            03S0598
         AH    @03,IOC(,CTRPTR)                                 03S0598
         STH   @03,IOC(,CTRPTR)                                 03S0598
*                   IF IOC<IOT THEN /* SEE IF THRESHOLD EXCEEDED.    */
         CH    @03,IOT(,THRSPTR)                                03S0599
         BNL   @RF00599                                         03S0599
*                     CTRPTR=0;     /* IF NOT, THEN INDICATE THAT
*                                      FACT.                         */
         SLR   CTRPTR,CTRPTR                                    03S0600
*                   ELSE            /* IF SO, THEN MSG WRITER NEEDS  */
*                     DO;           /* THE FOLLOWING DATA.           */
         B     @RC00599                                         03S0601
@RF00599 DS    0H                                               03S0602
*                       IOC=0;      /* ZERO THE COUNTER.             */
         SLR   @03,@03                                          03S0602
         STH   @03,IOC(,CTRPTR)                                 03S0602
*                       CTRPTR=ADDR(IOT);/* THE ADDRESS OF THE  03S0603
*                                      THRESHOLD.                    */
         LA    CTRPTR,IOT(,THRSPTR)                             03S0603
*                       THRSPTR=ADDR(IO);/* THE ADDRESS OF THE  03S0604
*                                      COMPONENT.                    */
         LA    THRSPTR,IO                                       03S0604
*                     END;          /* END OF MSG WRITER        03S0605
*                                      INITIALIZATN.                 */
*                 END;              /* END OF UPDATE.                */
*               ELSE                                            02S0607
*                 IF CSWUCK=OFF THEN/* THE LAST ERROR OF INTEREST IS */
         B     @RC00596                                         02S0607
@RF00596 TM    CSWUCK(APIOPTR),B'00000010'                      02S0607
         BNZ   @RF00607                                         02S0607
*                   CTRPTR=0;       /* UNIT CHECK. IF OFF, INDICATE
*                                      NO ACTION REQUIRED.           */
         SLR   CTRPTR,CTRPTR                                    02S0608
*                 ELSE                                          02S0609
*                   IF EWABDSNS=ON THEN/* IF SENSE IS NO GOOD, ASSUME
*                                      THAT IT IS A CONTROLLER ERROR.*/
         B     @RC00607                                         02S0609
@RF00607 TM    EWABDSNS(EWAPTR),B'00000001'                     02S0609
         BNO   @RF00609                                         02S0609
*                     DO;           /* UPDATE THE CP COUNTERS.       */
*                       CNTLRC=CNTLRC+1;/* INCREMENT THE COUNTER.    */
         LA    @03,1                                            03S0611
         AH    @03,CNTLRC(,CTRPTR)                              03S0611
         STH   @03,CNTLRC(,CTRPTR)                              03S0611
*                       IF CNTLRC<CNTLRT THEN/* SEE IF THRESHOLD
*                                      EXCEEDED.                     */
         CH    @03,CNTLRT(,THRSPTR)                             03S0612
         BNL   @RF00612                                         03S0612
*                         CTRPTR=0; /* IF NOT, THEN INDICATE THAT
*                                      FACT.                         */
         SLR   CTRPTR,CTRPTR                                    03S0613
*                       ELSE        /* IF SO, THEN MSG WRITER NEEDS  */
*                         DO;       /* THE FOLLOWING DATA.           */
         B     @RC00612                                         03S0614
@RF00612 DS    0H                                               03S0615
*                           CNTLRC=0;/* ZERO THE COUNTER.            */
         SLR   @03,@03                                          03S0615
         STH   @03,CNTLRC(,CTRPTR)                              03S0615
*                           CTRPTR=ADDR(CNTLRT);/* THE ADDRESS OF THE
*                                      THRESHOLD.                    */
         LA    CTRPTR,CNTLRT(,THRSPTR)                          03S0616
*                           THRSPTR=ADDR(CONT);/* THE ADDRESS OF THE
*                                      COMPONENT.                    */
         LA    THRSPTR,CONT                                     03S0617
*                         END;      /* END OF MSG WRITER        03S0618
*                                      INITIALIZATN.                 */
*                     END;          /* END OF UPDATE.                */
*                   ELSE            /* MUST INVESTIGATE TYPE OF 02S0620
*                                      SENSE.                        */
*                     IF APSNFMT=APSNFMCH THEN/* IS IT A HARDWARE
*                                      FORMAT                        */
*                                                               02S0620
         B     @RC00609                                         02S0620
@RF00609 LA    @03,32                                           02S0620
         ALR   @03,EWAPTR                                       02S0620
         CLI   APSNFMT(@03),0                                   02S0620
         BNE   @RF00620                                         02S0620
*                       /*********************************************/
*                       /*                                           */
*                       /* IF SO, THEN DETERMINE COMPONENT.          */
*                       /*                                           */
*                       /*********************************************/
*                                                               02S0621
*                       IF APSNPBS=ON THEN/* IS IT A BULK STORE 02S0621
*                                      FAILURE?                      */
         TM    APSNPBS(@03),B'10000000'                         02S0621
         BNO   @RF00621                                         02S0621
*                         DO;       /* UPDATE THE BS ERROR COUNTERS. */
*                           BSC=BSC+1;/* INCREMENT THE COUNTER.      */
         LA    @03,1                                            03S0623
         AH    @03,BSC(,CTRPTR)                                 03S0623
         STH   @03,BSC(,CTRPTR)                                 03S0623
*                           IF BSC<BST THEN/* SEE IF THRESHOLD  03S0624
*                                      EXCEEDED.                     */
         CH    @03,BST(,THRSPTR)                                03S0624
         BNL   @RF00624                                         03S0624
*                             CTRPTR=0;/* IF NOT, THEN INDICATE THAT
*                                      FACT.                         */
         SLR   CTRPTR,CTRPTR                                    03S0625
*                           ELSE    /* IF SO, THEN MSG WRITER NEEDS  */
*                             DO;   /* THE FOLLOWING DATA.           */
         B     @RC00624                                         03S0626
@RF00624 DS    0H                                               03S0627
*                               BSC=0;/* ZERO THE COUNTER.           */
         SLR   @03,@03                                          03S0627
         STH   @03,BSC(,CTRPTR)                                 03S0627
*                               CTRPTR=ADDR(BST);/* THE ADDRESS OF
*                                      THE THRESHOLD.                */
         LA    CTRPTR,BST(,THRSPTR)                             03S0628
*                               THRSPTR=ADDR(BULK);/* THE ADDRESS OF
*                                      THE COMPONENT.                */
         LA    THRSPTR,BULK                                     03S0629
*                             END;  /* END OF MSG WRITER        03S0630
*                                      INITIALIZATN.                 */
*                         END;      /* END OF UPDATE.                */
*                       ELSE        /* OTHERWISE ASSUME CONTROLLER
*                                      BAD.                          */
*                         DO;       /* UPDATE THE CP COUNTERS.       */
         B     @RC00621                                         03S0632
@RF00621 DS    0H                                               03S0633
*                           CNTLRC=CNTLRC+1;/* INCREMENT THE COUNTER.*/
         LA    @03,1                                            03S0633
         AH    @03,CNTLRC(,CTRPTR)                              03S0633
         STH   @03,CNTLRC(,CTRPTR)                              03S0633
*                           IF CNTLRC<CNTLRT THEN/* SEE IF THRESHOLD
*                                      EXCEEDED.                     */
         CH    @03,CNTLRT(,THRSPTR)                             03S0634
         BNL   @RF00634                                         03S0634
*                             CTRPTR=0;/* IF NOT, THEN INDICATE THAT
*                                      FACT.                         */
         SLR   CTRPTR,CTRPTR                                    03S0635
*                           ELSE    /* IF SO, THEN MSG WRITER NEEDS  */
*                             DO;   /* THE FOLLOWING DATA.           */
         B     @RC00634                                         03S0636
@RF00634 DS    0H                                               03S0637
*                               CNTLRC=0;/* ZERO THE COUNTER.        */
         SLR   @03,@03                                          03S0637
         STH   @03,CNTLRC(,CTRPTR)                              03S0637
*                               CTRPTR=ADDR(CNTLRT);/* THE ADDRESS OF
*                                      THE THRESHOLD.                */
         LA    CTRPTR,CNTLRT(,THRSPTR)                          03S0638
*                               THRSPTR=ADDR(CONT);/* THE ADDRESS OF
*                                      THE COMPONENT.                */
         LA    THRSPTR,CONT                                     03S0639
*                             END;  /* END OF MSG WRITER        03S0640
*                                      INITIALIZATN.                 */
*                         END;      /* END OF UPDATE.                */
*                     ELSE          /* SEE IF IT IS A FORMAT 1.      */
*                       IF APSNFMT=APSNFPM THEN/* FORMAT 1 IS   02S0642
*                                      PERFORMANCE MONITOR.          */
         B     @RC00620                                         02S0642
@RF00620 CLI   APSNFMT+32(EWAPTR),1                             02S0642
         BNE   @RF00642                                         02S0642
*                         DO;       /* UPDATE THE CP COUNTERS.       */
*                           CNTLRC=CNTLRC+1;/* INCREMENT THE COUNTER.*/
         LA    @03,1                                            03S0644
         AH    @03,CNTLRC(,CTRPTR)                              03S0644
         STH   @03,CNTLRC(,CTRPTR)                              03S0644
*                           IF CNTLRC<CNTLRT THEN/* SEE IF THRESHOLD
*                                      EXCEEDED.                     */
         CH    @03,CNTLRT(,THRSPTR)                             03S0645
         BNL   @RF00645                                         03S0645
*                             CTRPTR=0;/* IF NOT, THEN INDICATE THAT
*                                      FACT.                         */
         SLR   CTRPTR,CTRPTR                                    03S0646
*                           ELSE    /* IF SO, THEN MSG WRITER NEEDS  */
*                             DO;   /* THE FOLLOWING DATA.           */
         B     @RC00645                                         03S0647
@RF00645 DS    0H                                               03S0648
*                               CNTLRC=0;/* ZERO THE COUNTER.        */
         SLR   @03,@03                                          03S0648
         STH   @03,CNTLRC(,CTRPTR)                              03S0648
*                               CTRPTR=ADDR(CNTLRT);/* THE ADDRESS OF
*                                      THE THRESHOLD.                */
         LA    CTRPTR,CNTLRT(,THRSPTR)                          03S0649
*                               THRSPTR=ADDR(CONT);/* THE ADDRESS OF
*                                      THE COMPONENT.                */
         LA    THRSPTR,CONT                                     03S0650
*                             END;  /* END OF MSG WRITER        03S0651
*                                      INITIALIZATN.                 */
*                         END;      /* END OF UPDATE.                */
*                       ELSE        /* ALL THAT'S LEFT ARE USER 02S0653
*                                      ERRORS WHICH ARE NOT INCLUDED
*                                      IN THESE COUNTS.              */
*                         CTRPTR=0; /* INDICATE NO ACTION REQUIRED.  */
         B     @RC00642                                         02S0653
@RF00642 SLR   CTRPTR,CTRPTR                                    02S0653
*           END;                    /* END OF SPECIFIC ERROR    02S0654
*                                      PROCESSING                    */
@RC00642 DS    0H                                               02S0654
@RC00620 DS    0H                                               02S0654
@RC00609 DS    0H                                               02S0654
@RC00607 DS    0H                                               02S0654
@RC00596 DS    0H                                               02S0654
@RC00585 DS    0H                                               02S0655
*       END;                                                    02S0655
@RC00578 DS    0H                                               02S0656
*       IF CTRPTR^=0 THEN           /* 0 MEANS NO THRESHOLD REACHED. */
         LTR   CTRPTR,CTRPTR                                    01S0656
         BZ    @RF00656                                         01S0656
*         IF R1P=1 THEN             /* TEST FOR TEMPORARY ERROR.     */
         C     R1P,@CF00033                                     01S0657
         BNE   @RF00657                                         01S0657
*           CALL WRT300I('T');      /* WRITE TEMPORARY ERROR MESSAGE.*/
         LA    @01,@AL00658                                     01S0658
         BAL   @14,WRT300I                                      01S0658
*         ELSE                      /* IT'S A PERMANENT ERROR.       */
*           DO;                                                 01S0659
         B     @RC00657                                         01S0659
@RF00657 DS    0H                                               01S0660
*             IF THRSPTR->I256C(1:2)/* SEE IF ERROR IS BULK STORE    */
*                 =BULK|THRSPTR->I256C(1:2)/* OR AN IO ERROR         */
*                 =IO THEN                                      01S0660
         CLC   I256C(2,THRSPTR),BULK                            01S0660
         BE    @RT00660                                         01S0660
         CLC   I256C(2,THRSPTR),IO                              01S0660
         BNE   @RF00660                                         01S0660
@RT00660 DS    0H                                               01S0661
*               DO;                 /* EITHER OF THESE IS PORT  01S0661
*                                      RELATED.                      */
*                 IF APUBBERR=OFF THEN/* IF DISABLE NOT PENDING THEN */
         L     @03,APIOAPUB(,APIOPTR)                           01S0662
         TM    APUBBERR(@03),B'00010000'                        01S0662
         BNZ   @RF00662                                         01S0662
*                   DO;             /* FORCE ONE.                    */
*                     APUBIERR=ON;  /* PORT IS NOT TO BE USED FOR IO
*                                      IF THERE IS AN ALTERNATE.     */
         L     @00,APUBIERR-1(,@03)                             01S0664
@GL00022 LR    @15,@00                                          01S0664
         O     @15,@CF03273                                     01S0664
         CS    @00,@15,APUBIERR-1(@03)                          01S0664
         BNE   @GL00022                                         01S0664
*                     APUBBERR=ON;  /* DISABLE IS DUE TO EXCESSIVE
*                                      ERRS                          */
*                     APUBDSBP=ON;  /* SO MONITOR WILL CAUSE DISABLE.*/
         L     @15,APIOAPUB(,APIOPTR)                           01S0666
         L     @03,APUBBERR-1(,@15)                             01S0666
@GL00023 LR    @00,@03                                          01S0666
         O     @00,@CF03276                                     01S0666
         CS    @03,@00,APUBBERR-1(@15)                          01S0666
         BNE   @GL00023                                         01S0666
*                     DO;           /* IGTYPOST                 01S0667
*                                      ECB(APCTEULD)ASCBLOC(APCTASCB)*/
*                       RFY                                     01S0668
*                        (GPR00P,                               01S0668
*                         GPR01P,                               01S0668
*                         GPR14F,                               01S0668
*                         GPR15F) RSTD;/* REGISTERS USED             */
*                       GPR15F=APCTEULD;/* CURRENT ECB CONTENTS      */
         L     GPR15F,APCTEULD(,APCTPTR)                        01S0669
*LTR0015X:                                                      01S0670
*                       IF GPR15F<0 THEN/* IF ECB ALREADY            */
LTR0015X LTR   GPR15F,GPR15F                                    01S0670
         BNM   @RF00670                                         01S0670
*                         DO;       /* WAITED UPON, MUST ISSUE POST  */
*                           GPR01P=ADDR(APCTEULD);/* ADDRESS OF ECB
*                                      TO POST                       */
         LA    GPR01P,APCTEULD(,APCTPTR)                        01S0672
*                           GPR00P=APCTASCB;/* ADDR OF ASCB FOR 01S0673
*                                      MEMORY TO BE POSTED           */
         L     GPR00P,APCTASCB(,APCTPTR)                        01S0673
*                           CALL APCVZUBB;/* ISSUE CROSS-MEMORY POST */
         L     @15,APCTZUBB(,APCTPTR)                           01S0674
         BALR  @14,@15                                          01S0674
*                         END;      /* ECB POSTED                    */
*                       ELSE        /* ECB NOT YET POSTED            */
*                         DO;       /* SO TRY 'COMPARE-AND-SWAP' POST*/
         B     @RC00670                                         01S0676
@RF00670 DS    0H                                               01S0677
*                           GPR14F='40000000'X;/* POST CODE          */
         L     GPR14F,@CF03082                                  01S0677
*                           CS(GPR15F,GPR14F,APCTEULD);/* POST THE
*                                      ECB                           */
         CS    GPR15F,@14,APCTEULD(APCTPTR)                     01S0678
*                           BC(7,LTR0015X);/* RETRY IF 'CS' FAILED   */
         BC    7,LTR0015X                                       01S0679
*                         END;      /* ECB POSTED VIA 'CS'           */
*                       RFY                                     01S0681
*                        (GPR00P,                               01S0681
*                         GPR01P,                               01S0681
*                         GPR14F,                               01S0681
*                         GPR15F) UNRSTD;/* DONE WITH REGS           */
@RC00670 DS    0H                                               01S0682
*                     END;          /* POST LOGIC COMPLETE           */
*                   END;            /* END OF DISABLE PENDING.       */
*               END;                                            01S0684
*             ELSE                                              01S0685
*               DO;                 /* NEED A FORCE DUMP AND RE-IPL. */
         B     @RC00660                                         01S0685
@RF00660 DS    0H                                               01S0686
*                 IF APUBIIPL=OFF THEN/* UNLESS REIPL IS PENDING,    */
         L     @03,APIOAPUB(,APIOPTR)                           01S0686
         TM    APUBIIPL(@03),B'01000000'                        01S0686
         BNZ   @RF00686                                         01S0686
*                   DO;             /* FORCE ONE.                    */
*                     IOSQISCE=OFF; /* RESETTING THIS BIT WILL FORCE
*                                      THE REQUESTOR TO BE REQUEUED
*                                      UNTIL THE REIPL TAKES PLACE.  */
         NI    IOSQISCE(APIOPTR),B'11011111'                    01S0688
*                     APUBFDMP=ON;  /* INDICATE FORCE DUMP.          */
         L     @00,APUBFDMP(,@03)                               01S0689
@GL00024 LR    @15,@00                                          01S0689
         O     @15,@CF03279                                     01S0689
         CS    @00,@15,APUBFDMP(@03)                            01S0689
         BNE   @GL00024                                         01S0689
*                     APUBIIPL=ON;  /* WARN I/O DRIVER OF PENDING
*                                      IPL.                          */
         L     @15,APIOAPUB(,APIOPTR)                           01S0690
         L     @03,APUBIIPL-1(,@15)                             01S0690
@GL00025 LR    @00,@03                                          01S0690
         O     @00,@CF03282                                     01S0690
         CS    @03,@00,APUBIIPL-1(@15)                          01S0690
         BNE   @GL00025                                         01S0690
*                     DO;           /* IGTYPOST                 01S0691
*                                      ECB(APCTEIPL)ASCBLOC(APCTASCB)*/
*                       RFY                                     01S0692
*                        (GPR00P,                               01S0692
*                         GPR01P,                               01S0692
*                         GPR14F,                               01S0692
*                         GPR15F) RSTD;/* REGISTERS USED             */
*                       GPR15F=APCTEIPL;/* CURRENT ECB CONTENTS      */
         L     GPR15F,APCTEIPL(,APCTPTR)                        01S0693
*LTR0017X:                                                      01S0694
*                       IF GPR15F<0 THEN/* IF ECB ALREADY            */
LTR0017X LTR   GPR15F,GPR15F                                    01S0694
         BNM   @RF00694                                         01S0694
*                         DO;       /* WAITED UPON, MUST ISSUE POST  */
*                           GPR01P=ADDR(APCTEIPL);/* ADDRESS OF ECB
*                                      TO POST                       */
         LA    GPR01P,APCTEIPL(,APCTPTR)                        01S0696
*                           GPR00P=APCTASCB;/* ADDR OF ASCB FOR 01S0697
*                                      MEMORY TO BE POSTED           */
         L     GPR00P,APCTASCB(,APCTPTR)                        01S0697
*                           CALL APCVZUBB;/* ISSUE CROSS-MEMORY POST */
         L     @15,APCTZUBB(,APCTPTR)                           01S0698
         BALR  @14,@15                                          01S0698
*                         END;      /* ECB POSTED                    */
*                       ELSE        /* ECB NOT YET POSTED            */
*                         DO;       /* SO TRY 'COMPARE-AND-SWAP' POST*/
         B     @RC00694                                         01S0700
@RF00694 DS    0H                                               01S0701
*                           GPR14F='40000000'X;/* POST CODE          */
         L     GPR14F,@CF03082                                  01S0701
*                           CS(GPR15F,GPR14F,APCTEIPL);/* POST THE
*                                      ECB                           */
         CS    GPR15F,@14,APCTEIPL(APCTPTR)                     01S0702
*                           BC(7,LTR0017X);/* RETRY IF 'CS' FAILED   */
         BC    7,LTR0017X                                       01S0703
*                         END;      /* ECB POSTED VIA 'CS'           */
*                       RFY                                     01S0705
*                        (GPR00P,                               01S0705
*                         GPR01P,                               01S0705
*                         GPR14F,                               01S0705
*                         GPR15F) UNRSTD;/* DONE WITH REGS           */
@RC00694 DS    0H                                               01S0706
*                     END;          /* POST LOGIC COMPLETE           */
*                   END;            /* END OF REIPL.                 */
*               END;                                            01S0708
@RF00686 DS    0H                                               01S0709
*             CALL WRT300I('P');    /* OUTPUT ERROR MESSAGE.         */
@RC00660 LA    @01,@AL00709                                     01S0709
         BAL   @14,WRT300I                                      01S0709
*           END;                                                01S0710
*       RFY                                                     01S0711
*         R13P UNRSTD;                                          01S0711
@RC00657 DS    0H                                               01S0711
@RF00656 DS    0H                                               01S0712
*     END;                                                      01S0712
*   R14P=GOBACK;                    /* RESTORE THE RETURN ADDRESS.   */
@RF00562 LR    R14P,GOBACK                                      01S0713
*   RETURN;                         /* RETURN TO CALLER.             */
@EL00002 DS    0H                                               01S0714
@EF00002 DS    0H                                               01S0714
@ER00002 BR    @14                                              01S0714
*   RFY                                                         01S0715
*     R1P UNRSTD;                                               01S0715
*                                                               01S0716
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS PROCEDURE GENERATES ERROR MESSAGE IGT300I WHEN AN ERROR  */
*   /* COUNT REACHES A THRESHOLD LIMIT. INPUT IS : 1. THE INPUT PARM */
*   /* IS P OR T FOR TYPE OF ERROR. 2. CTRPTR POINTS TO THE THRESHOLD*/
*   /* VIOLATED. 3. THRSPTR POINTS TO 2 CHARS FOR FAILING COMPONENT. */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0716
*WRT300I:                                                       01S0716
*   PROC(INCHAR) OPTIONS(DONTSAVE,NOSAVEAREA);                  01S0716
WRT300I  MVC   @PC00003(4),0(@01)                               01S0716
*   DCL                                                         01S0717
*     MSG300S CHAR(*) GEND STATIC LOCAL;/* MSG SKELETON.             */
*   GEN DATA DEFS(MSG300S);                                     01S0718
*   DCL                                                         01S0719
*     1 MSG300 BDY(WORD),           /* IGT300I BUILD AREA.           */
*      2 MSGLEN PTR(15),            /* LENGTH                        */
*      2 MSGFLS BIT(16),            /* FLAGS                         */
*      2 MSGNUM CHAR(9),            /* MSG ID                        */
*      2 MSGSS CHAR(4),             /* SYBSYSTEM                     */
*      2 MSGSP1 CHAR(2),            /* SPACING                       */
*      2 MSGUNT CHAR(3),            /* UNIT                          */
*      2 MSGSP2 CHAR(1),            /* SPACING                       */
*      2 MSGERR CHAR(2),            /* COMPONENT                     */
*      2 MSGSP3 CHAR(1),            /* SPACEING                      */
*      2 MSGTYP CHAR(1),            /* PERM/TEMP.                    */
*      2 MSGSP4 CHAR(1),            /* SPACING                       */
*      2 MSGCNT CHAR(5),            /* COUNT                         */
*      2 MSGRT CHAR(4);             /* ROUTECODES.                   */
*   DCL                                                         01S0720
*     MSGRET PTR(31);               /* RETURN SAVE.                  */
*   DCL                                                         01S0721
*     I PTR(31);                    /* COUNTER                       */
*   DCL                                                         01S0722
*     INCHAR CHAR(1);               /* INDICATES TEMP OR PERM.       */
*   DCL                                                         01S0723
*     TCOUNT CHAR(5);               /* UNPACK AREA.                  */
*   DCL                                                         01S0724
*     PACKED CHAR(3);               /* CONVERT AREA.                 */
*   MSGRET=R14P;                    /* SAVE RETURN ADDRESS.          */
         LR    MSGRET,R14P                                      01S0725
*   MVC(MSG300,MSG300S(1:LENGTH(MSG300)));/* MOVE IN THE SKELETON.   */
         MVC   MSG300(37),MSG300S                               01S0726
*   MSGSS=APCTSSID;                 /* SUBSYS ID.                    */
         MVC   MSGSS(4),APCTSSID(APCTPTR)                       01S0727
*   MSGTYP=INCHAR;                  /* TYPE OF ERROR (TEMP/PERM).    */
         L     @15,@PC00003                                     01S0728
         MVC   MSGTYP(1),INCHAR(@15)                            01S0728
*   MSGUNT=UCBNAME;                 /* FAILING UNIT.                 */
         L     @01,UCBPTR(,APIOPTR)                             01S0729
         MVC   MSGUNT(3),UCBNAME(@01)                           01S0729
*   MSGERR=THRSPTR->I256C(1:2);     /* FAILING COMPONENT.            */
         MVC   MSGERR(2),I256C(THRSPTR)                         01S0730
*   CVD(CTRPTR->I015F,PACKED);      /* CONVERT COUNT TO DECIMAL.     */
         LH    @09,I015F(,CTRPTR)                               01S0731
         CVD   @09,@TS00001                                     01S0731
         MVC   PACKED(3),@TS00001+5                             01S0731
*   UNPK(TCOUNT,PACKED);            /* UNPACK RESULT.                */
         UNPK  TCOUNT(5),PACKED(3)                              01S0732
*   TCOUNT(5)=TCOUNT(5)|'F0'X;      /* GET RID OF SIGN.              */
         OI    TCOUNT+4,X'F0'                                   01S0733
*   DO I=1 TO 5                     /* FIND FIRST NON-ZERO NUMBER.   */
*         WHILE TCOUNT(I)='0';                                  01S0734
         LA    I,1                                              01S0734
@DL00734 LA    @09,TCOUNT-1(I)                                  01S0734
         CLI   0(@09),C'0'                                      01S0734
         BNE   @DC00734                                         01S0734
*   END;                                                        01S0735
         AL    I,@CF00033                                       01S0735
         C     I,@CF01950                                       01S0735
         BNH   @DL00734                                         01S0735
@DC00734 DS    0H                                               01S0736
*   MSGCNT(1:6-I)=TCOUNT(I:5);      /* ELIMINATE LEADING ZEROS.      */
         LA    @09,6                                            01S0736
         SLR   @09,I                                            01S0736
         BCTR  @09,0                                            01S0736
         LA    @01,TCOUNT-1(I)                                  01S0736
         EX    @09,@SM03285                                     01S0736
*   GEN REFS(MSGCNT);                                           01S0737
*                                 /* WRITE THE MESSAGE.              */
         SR    R0P,R0P
         WTO   MF=(E,MSG300)
*   R14P=MSGRET;                    /* RESTORE THE RETURN ADDRESS.   */
         LR    R14P,MSGRET                                      01S0738
*   RETURN;                         /* RETURN TO CALLER.             */
@EL00003 DS    0H                                               01S0739
@EF00003 DS    0H                                               01S0739
@ER00003 BR    @14                                              01S0739
*   END;                            /* END OF WRT300 PROC.           */
*   END;                            /* END OF ERRCTR PROC.           */
*                                                               01S0742
*/*  THIS PROC IS RESPONSIBLE FOR RESETTING THE QUIESCE BIT AND 01S0742
*    SIMULATING AN INTERRUPT SO THAT NEW CHANNEL PROGRAMS MAY BE
*    STARTED ON THE AFFECTED SUBCHANNEL.  IT USES THE IOSGEN MACRO
*    FOR BOTH PURPOSES. IT ALSO CANCELS THE ESTAE AND FREES THE 01S0742
*    DYNAMIC WORK AREA.                                              */
*                                                               01S0742
*RESETQB:                                                       01S0742
*   PROC OPTIONS(DONTSAVE,NOSAVEAREA);/* ENTRY TO THE ROUTINE.       */
*                                                               01S0742
RESETQB  DS    0H                                               01S0743
*   /*****************************************************************/
*   /*                                                               */
*   /* LOCAL DCLS.                                                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0743
*   DCL                                                         01S0743
*     RSQBSAVE PTR(31);             /* SAVE RETURN.                  */
*   RSQBSAVE=R14P;                  /* WHERE TO GO BACK TO.          */
         LR    RSQBSAVE,R14P                                    01S0744
*/*   RESET THE QUIESCE BIT IN THE UCB.                              */
*                                                               01S0745
*   RFY                                                         01S0745
*    (R1P,                                                      01S0745
*     R13P,                                                     01S0745
*     R14P) RSTD;                                               01S0745
*   R13P=ADDR(SAVE16(1));           /* 64 BYTE SAVE AREA             */
         LA    R13P,SAVE16                                      01S0746
*   R1P=IOSUCB;                                                 01S0747
         L     R1P,IOSUCB(,APIOPTR)                             01S0747
*   GEN REFS(UCBFLA,UCBFLB,UCBFLC,CVTPTR,CVTIXAVL,IOCGENA,UCBOB,
*       UCBCCWOF,UCB3TAPE,CVTMAP,IOCOM,UCBCMEXT,UCBEXTPT)       01S0748
*       (IOSGEN UCBFLG,UCB=(R1P),VAR=OFF,TABLE=UCBQISCE  );     01S0748
         IOSGEN UCBFLG,UCB=(R1P),VAR=OFF,TABLE=UCBQISCE
*   R1P=R1P->UCBCHAN;               /* GET DEVICE ADDRESS FOR SIMINT.*/
         LH    @15,UCBCHAN(,R1P)                                01S0749
         N     @15,@CF03287                                     01S0749
         LR    R1P,@15                                          01S0749
*   GEN REFS(CVTPTR,CVTIXAVL,CVTMAP,IOCGENA,IOCOM)/* GEN INTERRUPT.  */
*       (IOSINTRP UCB=R1P,VAR=2,BRANCH=YES);                    01S0750
         IOSINTRP UCB=R1P,VAR=2,BRANCH=YES
*   RFY                                                         01S0751
*    (R1P,                                                      01S0751
*     R13P,                                                     01S0751
*     R14P) UNRSTD;                                             01S0751
*   GEN;                                                        01S0752
        ESTAE 0                    CANCEL THE ESTAE.
*   RFY                                                         01S0753
*    (R1P,                                                      01S0753
*     R0P) RSTD;                                                01S0753
*   R1P=DYNPTR;                     /* ADDRESS OF THE DYNAMIC   01S0754
*                                      STORAGE.                      */
         L     R1P,DYNPTR(,EWAPTR)                              01S0754
*   R0P=SPSIZE;                     /* SUBPOOL AND SIZE.             */
         L     R0P,SPSIZE(,EWAPTR)                              01S0755
*   GEN REFS(R1P,R0P);                                          01S0756
        FREEMAIN R,LV=(0),A=(1)    FREE THE STORAGE.
*   RFY                                                         01S0757
*    (R1P,                                                      01S0757
*     R0P) UNRSTD;                                              01S0757
*   R14P=RSQBSAVE;                  /* RESTORE THE RETURN ADDRESS.   */
         LR    R14P,RSQBSAVE                                    01S0758
*ENDRSTQB:                                                      01S0759
*   RETURN;                                                     01S0759
@EL00004 DS    0H                                               01S0759
@EF00004 DS    0H                                               01S0759
@ER00004 BR    @14                                              01S0759
*   END;                                                        01S0760
         B     @EL00004                                         01S0760
*                                                               01S0761
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS IS THE ROUTINE THAT GETS CONTROL FROM THE ESATE WHEN THE */
*   /* ERP ABENDS. BASICALLY IT ATTEMPTS TO RECOVER BY TREATING THE  */
*   /* I/O ERROR AS PERMANEN, SPECIFYING THE LOGMSG EXIT AS THE RETRY*/
*   /* ROUTINE. IF NO SDWA IS AVAILABLE IT JUST GIVES UP. IF THE     */
*   /* ABEND IS RECURSIVE IT ALSO GIVES UP WITH A DUMP.              */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0761
*RECOVER:                                                       01S0761
*   PROC OPTIONS(NOSAVEAREA,DONTSAVE,PARMREG);                  01S0761
RECOVER  DS    0H                                               01S0762
*   GEN NOFLOWS EXIT;                                           01S0762
        USING *,R15P         ESTABLISH ADDRESSABILITY.
         C     R0P,F12            SEE IF SDWA IS PRESENT
*                            R0P = 12 IF NO SDWA.
        BNE   GOODSDWA       BRANCH IF GOT ONE.
        SR    R15P,R15P      SPECIFY NO RETRY.
        BR    R14P           RETURN TO CALLER.
*
*             PROCESS NORMAL ENTRY.
*
GOODSDWA DS   0H             SDWA IS PRESENT AND VALID.
         SAVE (14,12)        SAVE THE REGS.
         L    R2P,SDWAPARM-SDWA(,R1P) GET THE PARMLIST.
*                    THE PARMLIST IS A POINTER TO THE REGS TO BE USED.
         L     R2P,0(,R2P)      GET POINTER TO THE REGS
         LM    R3P,R12P,4(R2P)  RESTORE THE REGS FOR LOGMSG.
         TM    0(R2P),X'80'     SEE IF THIS IS A RECURSIVE ENTRY.
         BO    RECURSE          IF ZERO THEN NOT.
         OI    0(R2P),X'80'     SET THE RECURSIVE BIT ON.
         DROP  R15P             NOT NEEDED ANY MORE.
         STM   R3P,R12P,SDWASR03-SDWA(R1P) PREPARE FOR EXIT.
         SETRP   WKAREA=(1),DUMP=NO,RC=4,RETADDR=LOGMSG,RETREGS=YES,   X
               FRESDWA=YES,RECORD=YES
         LM    R14P,R12P,12(R13P)  RESTORE THE REGS.
         BR    R14P            RETURN TO CALLER.
RECURSE  DS    0H              RECOVERY HAS BEEN ATTEMPTED ONCE.
         SETRP   WKAREA=(1),DUMP=NO,RC=0,RECORD=YES   **GIVE UP NOW.
         LM    R14P,R12P,12(R13P)  RESTORE THE REGS.
         BR    R14P            RETURN TO CALLER.
F12      DC    F'12'              CONSTANT OF 12
*   END;                                                        01S0763
@EL00005 DS    0H                                               01S0763
@EF00005 DS    0H                                               01S0763
@ER00005 BR    @14                                              01S0763
*                                   /* IGTXEPLG                      */
*                                                               01S0764
*   /*****************************************************************/
*   /*                                                               */
*   /* SYSTEM DECLARES                                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0764
*   DECLARE                         /* GENERAL PURPOSE REGISTERS     */
*     GPR14F FIXED(31) REG(14),                                 01S0764
*     GPR15F FIXED(31) REG(15),                                 01S0764
*     GPR00P PTR(31) REG(0),                                    01S0764
*     GPR01P PTR(31) REG(1);                                    01S0764
*   DECLARE                         /* COMMON VARIABLES              */
*     I256C CHAR(256) BASED,                                    01S0765
*     I031F FIXED(31) BASED,                                    01S0765
*     I031P PTR(31) BASED,                                      01S0765
*     I015F FIXED(15) BASED,                                    01S0765
*     I015P PTR(15) BASED,                                      01S0765
*     I008P PTR(8) BASED,                                       01S0765
*     I001C CHAR(1) BASED;                                      01S0765
*                                                               01S0766
*   /*****************************************************************/
*   /*                                                               */
*   /* MODULE PATCH AREA                                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0766
*   DCL                                                         01S0766
*     APPATCH CHAR(*) INT STATIC LOCAL GEND;                    01S0766
*   GENERATE DATA DEFS(APPATCH);                                01S0767
*                                                               01S0768
*   /*****************************************************************/
*   /*                                                               */
*   /* GENERAL REGISTER DECLARES                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0768
*   DCL                                                         01S0768
*     R0F FIXED(31) REG(0),                                     01S0768
*     R0P PTR(24) REG(0),                                       01S0768
*     R0RSTD PTR(31) REG(0),                                    01S0768
*     R1F FIXED(31) REG(1),                                     01S0768
*     R1P PTR(24) REG(1),                                       01S0768
*     R1RSTD PTR(31) REG(1),                                    01S0768
*     R2F FIXED(31) REG(2),                                     01S0768
*     R2P PTR(24) REG(2),                                       01S0768
*     R2RSTD PTR(31) REG(2),                                    01S0768
*     R3F FIXED(31) REG(3),                                     01S0768
*     R3P PTR(24) REG(3),                                       01S0768
*     R3RSTD PTR(31) REG(3),                                    01S0768
*     R4F FIXED(31) REG(4),                                     01S0768
*     R4P PTR(24) REG(4),                                       01S0768
*     R4RSTD PTR(31) REG(4),                                    01S0768
*     R5F FIXED(31) REG(5),                                     01S0768
*     R5P PTR(24) REG(5),                                       01S0768
*     R5RSTD PTR(31) REG(5),                                    01S0768
*     R6F FIXED(31) REG(6),                                     01S0768
*     R6P PTR(24) REG(6),                                       01S0768
*     R6RSTD PTR(31) REG(6),                                    01S0768
*     R7F FIXED(31) REG(7),                                     01S0768
*     R7P PTR(24) REG(7),                                       01S0768
*     R7RSTD PTR(31) REG(7),                                    01S0768
*     R8F FIXED(31) REG(8),                                     01S0768
*     R8P PTR(24) REG(8),                                       01S0768
*     R8RSTD PTR(31) REG(8),                                    01S0768
*     R9F FIXED(31) REG(9),                                     01S0768
*     R9P PTR(24) REG(9),                                       01S0768
*     R9RSTD PTR(31) REG(9),                                    01S0768
*     R10F FIXED(31) REG(10),                                   01S0768
*     R10P PTR(24) REG(10),                                     01S0768
*     R10RSTD PTR(31) REG(10),                                  01S0768
*     R11F FIXED(31) REG(11),                                   01S0768
*     R11P PTR(24) REG(11),                                     01S0768
*     R11RSTD PTR(31) REG(11),                                  01S0768
*     R12F FIXED(31) REG(12),                                   01S0768
*     R12P PTR(24) REG(12),                                     01S0768
*     R12RSTD PTR(31) REG(12),                                  01S0768
*     R13F FIXED(31) REG(13),                                   01S0768
*     R13P PTR(24) REG(13),                                     01S0768
*     R13RSTD PTR(31) REG(13),                                  01S0768
*     R14F FIXED(31) REG(14),                                   01S0768
*     R14P PTR(24) REG(14),                                     01S0768
*     R14RSTD PTR(31) REG(14),                                  01S0768
*     R15F FIXED(31) REG(15),                                   01S0768
*     R15P PTR(24) REG(15),                                     01S0768
*     R15RSTD PTR(31) REG(15),                                  01S0768
*                                                               01S0768
*     /***************************************************************/
*     /*                                                             */
*     /* VPSS CONTROL BLOCK POINTER DECLARES                         */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0768
*     APSMPTR PTR(24) REG(01),      /* STORAGE MANAGEMENT BLOCK 01S0768
*                                      (SUGGESTED POINTER)           */
*     APSCPTR PTR(24) REG(01),      /* STORAGE MANAGEMENT CONTROL
*                                      WORD (SUGGESTED POINTER)      */
*     APINPTR PTR(24) REG(01),      /* USER'S INPUT PARAMETER LIST
*                                      (SUGGESTED POINTER)           */
*/*                                                                  */
*                                                               01S0768
*     APDATA PTR(24) REG(06),       /* ADDRESS OF DYNAMIC DATA  01S0768
*                                      WORKAREA (DATAREG)            */
*     APCODE PTR(24) REG(07),       /* PROGRAM CODE BASE REGISTER
*                                      (CODEREG)                     */
*     APDEBPTR PTR(24) REG(08),     /* VPSS DEB (SUGGESTED POINTER)  */
*     APNPPTR PTR(24) REG(08),      /* SUBSYSTEM INITIALIZATION 01S0768
*                                      WORKAREA BLOCK (ONLY USED BY
*                                      SUBSYSTEM INITIALIZATION)     */
*     APRLPTR PTR(24) REG(08),      /* VPSS ACB REQUEST LIST    01S0768
*                                      (SUGGESTED POINTER)           */
*     APCIPTR PTR(24) REG(08),      /* 3838 CONTROL TABLE (SUGGESTED
*                                      POINTER)                      */
*     APCWPTR PTR(24) REG(08),      /* CALL INTERFACE WORKAREA  01S0768
*                                      (SUGGESTED POINTER)           */
*     APERPTR PTR(24) REG(08),      /* ERP/IO APPENDAGE WORKAREA
*                                      (SUGGESTED POINTER)           */
*     APACBPTR PTR(24) REG(09),     /* VPSS ACB (SUGGESTED POINTER)  */
*     APCQPTR PTR(24) REG(09),      /* COMMAND QUEUE ELEMENT    01S0768
*                                      (SUGGESTED POINTER)           */
*     APOTPTR PTR(24) REG(09),      /* OPTION TABLE (SUGGESTED  01S0768
*                                      POINTER)                      */
*     APIOPTR PTR(24) REG(10),      /* I/O ELEMENT (SUGGESTED   01S0768
*                                      POINTER)                      */
*     APEXLPTR PTR(24) REG(10),     /* VPSS EXLST (SUGGESTED POINTER)*/
*     APUBPTR PTR(24) REG(10),      /* UNIT BLOCK (SUGGESTED POINTER)*/
*     APAXPTR PTR(24) REG(10),      /* VPSS ACB EXTENSION (SUGGESTED
*                                      POINTER)                      */
*     APCPPTR PTR(24) REG(10),      /* VPSS CALL PROCESSING     01S0768
*                                      INDICATORS (SUGGESTED POINTER)*/
*     APOCPTR PTR(24) REG(10),      /* VPSS OPEN/CLOSE SUBSYSTEM
*                                      WORKAREA (REQUIRED POINTER)   */
*     APATPTR PTR(24) REG(11),      /* VPSS ACB TABLE (SUGGESTED
*                                      POINTER)                      */
*     APLBPTR PTR(24) REG(11),      /* LABEL RESOLUTION TABLE   01S0768
*                                      (SUGGESTED POINTER)           */
*     APUTPTR PTR(24) REG(11),      /* USER TABLE (SUGGESTED POINTER)*/
*     APDSPTR PTR(24) REG(11),      /* VPSS DATASET ENTRY (SUGGESTED
*                                      POINTER)                      */
*     APXLPTR PTR(24) REG(11),      /* TRANSLATION TABLE (SUGGESTED
*                                      POINTER)                      */
*     APDXPTR PTR(24) REG(11),      /* VPSS DEB EXTENSION (SUGGESTED
*                                      POINTER)                      */
*     APCTPTR PTR(24) REG(12) RSTD, /* CONTROL TABLE (REQUIRED  01S0768
*                                      POINTER)                      */
*     APSVPTR PTR(24) REG(13) RSTD, /* OS/VPSS SAVEAREA/WORKAREA
*                                      (REQUIRED POINTER)            */
*     APRETURN PTR(24) REG(14),     /* RETURN ADDRESS FOR SUBROUTINE
*                                      LINKAGE                       */
*     APENTRY PTR(24) REG(15),      /* SUBROUTINE ENTRY POINT LINKAGE*/
*     APRCODE PTR(24) REG(15);      /* CONTAINS SUBROUTINE RETURN
*                                      CODE                          */
*                                                               01S0769
*   /*****************************************************************/
*   /*                                                               */
*   /* USER REGISTER DECLARES                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0769
*   END                                                         01S0769
*                                                               01S0769
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (EWAMAP  )                                       */
*/*%INCLUDE SYSLIB  (IECDIOCM)                                       */
*/*%INCLUDE SYSLIB  (IECDIOSB)                                       */
*/*%INCLUDE SYSLIB  (IEFUCBOB)                                       */
*/*%INCLUDE SYSLIB  (IEZDEB  )                                       */
*/*%INCLUDE SYSLIB  (IGTXAPCT)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPCV)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPDS)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPDX)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPIO)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPSN)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPUB)                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSUT5  (INTRCEPT)                                       */
*/*%INCLUDE SYSUT5  (CHKCHAIN)                                       */
*/*%INCLUDE SYSUT5  (ERP11   )                                       */
*/*%INCLUDE SYSUT5  (ERP12   )                                       */
*/*%INCLUDE SYSUT5  (UNITCK  )                                       */
*/*%INCLUDE SYSUT5  (ERP13   )                                       */
*/*%INCLUDE SYSUT5  (BADLEN  )                                       */
*/*%INCLUDE SYSUT5  (ANALERR )                                       */
*/*%INCLUDE SYSUT5  (TOERR   )                                       */
*/*%INCLUDE SYSUT5  (CHANERR )                                       */
*/*%INCLUDE SYSUT5  (CNTLRERR)                                       */
*/*%INCLUDE SYSUT5  (CNTLRERR)                                       */
*/*%INCLUDE SYSUT5  (CNTLRERR)                                       */
*/*%INCLUDE SYSUT5  (BSERR   )                                       */
*                                                               01S0769
*       ;                                                       01S0769
@DATA    DS    0H
@SM03285 MVC   MSGCNT(0),0(@01)
         DS    0F
@AL00658 DC    A(@CC03115)             LIST WITH   1 ARGUMENT(S)
@AL00709 DC    A(@CC03121)             LIST WITH   1 ARGUMENT(S)
@DATD    DSECT
         DS    0F
@PC00003 DS    1F
IGE0003C CSECT
         DS    0F
@CF00033 DC    F'1'
@CF01950 DC    F'5'
@CF00059 DC    F'8'
@CF00040 DC    F'16'
@CF03261 DC    F'-8'
@CF03082 DC    XL4'40000000'
@CF03287 DC    XL4'0000FFFF'
@CF03270 DC    BL4'00100000000000000000000000000000'
@CF03273 DC    BL4'00000000100000000000000000000000'
@CF03276 DC    BL4'00000000000110000000000000000000'
@CF03279 DC    BL4'01000000000000000000000000000000'
@CF03282 DC    BL4'00000000010000000000000000000000'
@DATD    DSECT
         DS    0D
         DS    0D
@TS00001 DS    CL8
ESTAELST DS    CL44
         ORG   ESTAELST
ESIND    DS    AL4
         ORG   ESIND
ESRECUR  DS    BL1
@NM00011 EQU   ESIND+0
         ORG   ESTAELST+4
SAVE312  DS    CL40
         ORG   ESTAELST+44
MSG300   DS    CL37
         ORG   MSG300
MSGLEN   DS    AL2
MSGFLS   DS    BL2
MSGNUM   DS    CL9
MSGSS    DS    CL4
MSGSP1   DS    CL2
MSGUNT   DS    CL3
MSGSP2   DS    CL1
MSGERR   DS    CL2
MSGSP3   DS    CL1
MSGTYP   DS    CL1
MSGSP4   DS    CL1
MSGCNT   DS    CL5
MSGRT    DS    CL4
         ORG   MSG300+37
TCOUNT   DS    CL5
PACKED   DS    CL3
         DS    CL3
SAVE16   DS    20A
IGE0003C CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
@CC03115 DC    C'T'
@CC03121 DC    C'P'
@CB03043 DC    X'7F00'
@CB03058 DC    X'0000'
CNTLRDRG DC    X'6B0000006000006B'
READREGS DC    X'020000006000003C'
CCWRST   DC    X'0B0000006000000B'
TIC      DC    X'0800000060000001'
NOP      DC    X'0300000020000003'
CLR3838  DC    X'1B0000006000001B'
EBCERR   DS    CL10
         ORG   EBCERR
TOTAL    DC    CL2'TE'
BULK     DC    CL2'BS'
TIME     DC    CL2'TO'
IO       DC    CL2'IO'
CONT     DC    CL2'CP'
         ORG   EBCERR+10
@DATD    DSECT
QESTAE ESTAE *-*,PARAM=*-*,PURGE=NONE,ASYNCH=YES,TERM=YES,MF=L
DESTAE EQU   QESTAE,*-QESTAE,C'C'
IGE0003C CSECT
ZESTAE ESTAE RECOVER,PARAM=*-*,PURGE=NONE,ASYNCH=YES,TERM=YES,MF=L
XESTAE EQU   ZESTAE,*-ZESTAE,C'C'
@DATD    DSECT
         IHASDWA DSECT=YES           DEFINE THE SDWA CONTROL BLOCK.
IGE0003C CSECT                       GET BACK TO OUR CSECT.
IGE0003C CSECT
MSG300X  WTO 'IGT300I  SSSS: UUU,EE,R,N    ',MF=L,ROUTCDE=2,DESC=4
MSG300S  EQU   MSG300X,*-MSG300X,C'C'
IGE0003C CSECT
*                                 /* GENERATE PATCH
         IGTXZAP ,                 GENERATE PATCH AREA
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IGE0003C CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
RSQBSAVE EQU   @02
I        EQU   @02
MSGRET   EQU   @03
GOBACK   EQU   @11
THRSPTR  EQU   @09
CTRPTR   EQU   @02
IOCOMPTR EQU   @00
IOSBPTR  EQU   @00
DEBPTR   EQU   @00
DEBDAPTR EQU   @00
DEBEXPTR EQU   @00
DEBSBPTR EQU   @00
CODEBASE EQU   @07
DATABASE EQU   @06
EWAPTR   EQU   @08
APCTPTR  EQU   @12
APIOPTR  EQU   @10
R1P      EQU   @01
R15P     EQU   @15
R0P      EQU   @00
R2P      EQU   @02
R3P      EQU   @03
R12P     EQU   @12
R9P      EQU   @09
R11P     EQU   @11
R14P     EQU   @14
R13P     EQU   @13
GPR00P   EQU   @00
GPR01P   EQU   @01
GPR14F   EQU   @14
GPR15F   EQU   @15
APSVPTR  EQU   @13
APACBPTR EQU   @09
APATPTR  EQU   @11
APAXPTR  EQU   @10
APCIPTR  EQU   @08
APCODE   EQU   @07
APCPPTR  EQU   @10
APCQPTR  EQU   @09
APCWPTR  EQU   @08
APDATA   EQU   @06
APDEBPTR EQU   @08
APDSPTR  EQU   @11
APDXPTR  EQU   @11
APENTRY  EQU   @15
APERPTR  EQU   @08
APEXLPTR EQU   @10
APINPTR  EQU   @01
APLBPTR  EQU   @11
APNPPTR  EQU   @08
APOCPTR  EQU   @10
APOTPTR  EQU   @09
APRCODE  EQU   @15
APRETURN EQU   @14
APRLPTR  EQU   @08
APSCPTR  EQU   @01
APSMPTR  EQU   @01
APUBPTR  EQU   @10
APUTPTR  EQU   @11
APXLPTR  EQU   @11
R0F      EQU   @00
R0RSTD   EQU   @00
R1F      EQU   @01
R1RSTD   EQU   @01
R10F     EQU   @10
R10P     EQU   @10
R10RSTD  EQU   @10
R11F     EQU   @11
R11RSTD  EQU   @11
R12F     EQU   @12
R12RSTD  EQU   @12
R13F     EQU   @13
R13RSTD  EQU   @13
R14F     EQU   @14
R14RSTD  EQU   @14
R15F     EQU   @15
R15RSTD  EQU   @15
R2F      EQU   @02
R2RSTD   EQU   @02
R3F      EQU   @03
R3RSTD   EQU   @03
R4F      EQU   @04
R4P      EQU   @04
R4RSTD   EQU   @04
R5F      EQU   @05
R5P      EQU   @05
R5RSTD   EQU   @05
R6F      EQU   @06
R6P      EQU   @06
R6RSTD   EQU   @06
R7F      EQU   @07
R7P      EQU   @07
R7RSTD   EQU   @07
R8F      EQU   @08
R8P      EQU   @08
R8RSTD   EQU   @08
R9F      EQU   @09
R9RSTD   EQU   @09
CVTPTR   EQU   16
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
APSN     EQU   0
APSNSTND EQU   APSN
APSNBOP  EQU   APSNSTND
APSNDTCK EQU   APSNSTND
APSNRQST EQU   APSN+1
APSNRQRS EQU   APSNRQST
APSNRQUR EQU   APSNRQST
APSNCMPN EQU   APSN+2
APSNCCPX EQU   APSNCMPN
APSNFMT  EQU   APSN+3
APSNCIOP EQU   APSN+4
APSNFMTD EQU   APSN+8
CCW      EQU   0
CCWOPCD  EQU   CCW
CCWFLAGS EQU   CCW+4
CCWDC    EQU   CCWFLAGS
CVTMAP   EQU   0
CVTXTLER EQU   CVTMAP+44
CVTXITP  EQU   CVTMAP+68
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIXAVL EQU   CVTMAP+124
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
EWA      EQU   0
EWAHDR   EQU   EWA
EWAFLAGS EQU   EWA+4
EWAFLG1  EQU   EWAFLAGS
EWASCCD  EQU   EWAFLG1
EWASCC3  EQU   EWASCCD
EWABDSNS EQU   EWAFLG1
EWAFLG2  EQU   EWAFLAGS+1
EWAWTEMP EQU   EWAFLG2
EWAFLG3  EQU   EWAFLAGS+2
EWASNSCT EQU   EWAFLAGS+3
EWACNTRS EQU   EWA+10
EWACNTR1 EQU   EWACNTRS
EWACNTR2 EQU   EWACNTRS+1
EWASTUP  EQU   EWA+14
EWAERPIB EQU   EWA+16
EWARGFG1 EQU   EWAERPIB+4
EWANORTY EQU   EWARGFG1
EWARGFG2 EQU   EWAERPIB+5
EWAXCSW1 EQU   EWAERPIB+6
EWAXCSW2 EQU   EWAERPIB+7
EWACHA   EQU   EWA+24
EWAIERP  EQU   EWA+32
IOCOM    EQU   0
IOCGENA  EQU   IOCOM+84
IOSB     EQU   0
IOSFLA   EQU   IOSB
IOSACHN  EQU   IOSFLA
IOSDCHN  EQU   IOSACHN
IOSCCHN  EQU   IOSACHN
IOSERR   EQU   IOSFLA
IOSEX    EQU   IOSFLA
IOSFLB   EQU   IOSB+1
IOSSDR   EQU   IOSFLB
IOSMSG   EQU   IOSFLB
IOSBDCST EQU   IOSFLB
IOSLOG   EQU   IOSFLB
IOSFLC   EQU   IOSB+2
IOSDVALT EQU   IOSFLC
IOSDVRID EQU   IOSB+4
IOSPKEY  EQU   IOSB+12
IOSCOD   EQU   IOSB+13
IOSOPT   EQU   IOSB+14
IOSQISCE EQU   IOSOPT
IOSOPT2  EQU   IOSB+15
IOSUCB   EQU   IOSB+16
@NM00024 EQU   IOSB+20
IOSCC    EQU   @NM00024
IOSCSW   EQU   @NM00024+1
IOSCSWCA EQU   IOSCSW
IOSTATUS EQU   IOSCSW+3
IOSIPIB  EQU   IOSB+44
IOSERP   EQU   IOSB+52
IOSRST   EQU   IOSB+72
IOSVST   EQU   IOSB+76
IOSPATH  EQU   IOSB+86
IOSCHN   EQU   IOSPATH
IOSCKEY  EQU   IOSB+89
IOSEEK   EQU   IOSB+100
IOSEEKA  EQU   IOSEEK
IOSCCHH  EQU   IOSEEKA+3
IOSSKHH  EQU   IOSCCHH+2
UCB      EQU   0
UCBOB    EQU   0
UCBJBNR  EQU   UCBOB
UCBFL5   EQU   UCBOB+1
UCBAF    EQU   UCBFL5
UCBSTAT  EQU   UCBOB+3
UCBCHAN  EQU   UCBOB+4
UCBSFLS  EQU   UCBOB+6
UCBFLA   EQU   UCBSFLS
UCBFL1   EQU   UCBFLA
UCBBSY   EQU   UCBFL1
UCBNRY   EQU   UCBFL1
UCBPST   EQU   UCBFL1
UCBCUB   EQU   UCBFL1
UCBFLB   EQU   UCBSFLS+1
UCBCHM   EQU   UCBOB+8
UCBCHM1  EQU   UCBCHM
UCBPTH0  EQU   UCBCHM1
UCBPTH1  EQU   UCBCHM1
UCBWGT   EQU   UCBOB+12
UCBNAME  EQU   UCBOB+13
UCBTYP   EQU   UCBOB+16
UCBTBYT1 EQU   UCBTYP
UCB1FEA5 EQU   UCBTBYT1
UCB1FEA6 EQU   UCBTBYT1
UCBTBYT2 EQU   UCBTYP+1
UCB2OPT2 EQU   UCBTBYT2
UCBDUDN1 EQU   UCB2OPT2
UCB2OPT3 EQU   UCBTBYT2
UCBDUDN2 EQU   UCB2OPT3
UCB2OPT4 EQU   UCBTBYT2
UCBRWTAU EQU   UCB2OPT4
UCB2OPT6 EQU   UCBTBYT2
UCB2OPT7 EQU   UCBTBYT2
UCBTBYT3 EQU   UCBTYP+2
UCBDVCLS EQU   UCBTBYT3
UCB3TAPE EQU   UCBDVCLS
UCBTBYT4 EQU   UCBTYP+3
UCBEXTPT EQU   UCBOB+20
UCBFLC   EQU   UCBEXTPT
UCBDEV   EQU   UCBOB+24
UCBCMEXT EQU   0
UCBATI   EQU   UCBCMEXT+3
@NM00033 EQU   UCBATI
UCBFLP1  EQU   UCBCMEXT+5
UCBCCWOF EQU   UCBCMEXT+8
UCBMT    EQU   0
UCBOCR   EQU   0
UCB3540X EQU   0
UCBDKBYT EQU   UCB3540X+6
UCB3800X EQU   0
UCBOPTNS EQU   UCB3800X
UCBACTIV EQU   UCB3800X+3
UCBMDRBF EQU   UCB3800X+36
UCBUCS   EQU   0
UCBUCSOP EQU   UCBUCS+4
UCBFCBOP EQU   UCBUCS+5
DEBBASIC EQU   0
DEBTCBAD EQU   DEBBASIC
DEBDEBAD EQU   DEBBASIC+4
DEBIRBAD EQU   DEBBASIC+8
DEBOFLGS EQU   DEBIRBAD
DEBOPATB EQU   DEBBASIC+12
DEBFLGS1 EQU   DEBBASIC+14
DEBUSRPG EQU   DEBBASIC+16
DEBRRQ   EQU   DEBBASIC+20
DEBECBAD EQU   DEBRRQ
DEBDCBAD EQU   DEBBASIC+24
DEBPROTG EQU   DEBDCBAD
DEBAPPAD EQU   DEBBASIC+28
DEBBASND EQU   DEBBASIC+32
DEBDASD  EQU   0
DEBUCBAD EQU   DEBDASD
DEBACSMD EQU   0
DEBVOLSQ EQU   DEBACSMD
DEBVOLBT EQU   DEBVOLSQ
DEBDSNM  EQU   DEBACSMD+4
DEBUTSAA EQU   DEBDSNM
DEBACS01 EQU   0
DEBDSNAM EQU   DEBACS01
DEBACS02 EQU   0
DEBDBLK  EQU   DEBACS02
DEBACS03 EQU   0
DEBACS04 EQU   0
DEBTBFRA EQU   DEBACS04
DEBTCCWA EQU   DEBACS04+4
DEBACS05 EQU   0
DEBFUCBA EQU   DEBACS05
DEBLUCBA EQU   DEBACS05+4
DEBACS06 EQU   0
DEBACS07 EQU   0
DEBACS08 EQU   0
DEBSUBNM EQU   0
DEB      EQU   0
DEBAVT   EQU   DEB
DEBEOEA  EQU   DEBAVT
DEBEOEAB EQU   DEBEOEA
DEBSIOA  EQU   DEBAVT+4
DEBSIOAB EQU   DEBSIOA
DEBPCIA  EQU   DEBAVT+8
DEBPCIAB EQU   DEBPCIA
DEBCEA   EQU   DEBAVT+12
DEBCEAB  EQU   DEBCEA
DEBXCEA  EQU   DEBAVT+16
DEBXCEAB EQU   DEBXCEA
DEBPREFX EQU   DEB+20
DEBXTNP  EQU   DEBPREFX+8
DEBXTN   EQU   0
DEBXFLG1 EQU   DEBXTN+2
APCT     EQU   0
APCTENQM EQU   APCT+12
APCTSSID EQU   APCTENQM+4
APCTSMIN EQU   APCT+32
APCTSMAD EQU   APCT+36
APCTZ@@@ EQU   APCT+40
APCTU@@@ EQU   APCT+440
APCTBR14 EQU   APCT+840
APCTERRS EQU   APCT+876
APCTERT0 EQU   APCTERRS+2
APCTERTA EQU   APCTERRS+12
APCTASCB EQU   APCT+920
@NM00049 EQU   APCT+936
APCTSTAT EQU   @NM00049
APCTPRSW EQU   @NM00049+1
APCTAPCQ EQU   APCT+944
APCTCQAQ EQU   APCT+952
APCTEULD EQU   APCT+972
APCTEIPL EQU   APCT+1000
APCTZ@@1 EQU   APCT+1120
APCTNDMP EQU   APCT+1530
APCVZUBB EQU   0
APDS     EQU   0
APDSTD   EQU   APDS+16
APDSFLGS EQU   APDS+64
APDSFLG0 EQU   APDSFLGS
APDSFLG1 EQU   APDSFLGS+1
APDSJBNM EQU   APDS+84
APDX     EQU   0
APDXAPDS EQU   APDX+12
APDX252A EQU   APDX+28
APDXDXL  EQU   APDX+32
APDXNDMP EQU   APDX+48
APDXSWS  EQU   APDX+130
APDXSW0  EQU   APDXSWS
APDXSW1  EQU   APDXSWS+1
APIO     EQU   0
APIOIOCB EQU   APIO
APIOAPUB EQU   APIO+204
APIOVCSW EQU   APIO+208
APIODEB  EQU   APIO+216
APIOOLAP EQU   APIO+244
APIOFLGS EQU   APIO+248
APIOFLGA EQU   APIOFLGS
APIOFLG0 EQU   APIOFLGA
APIOFLG2 EQU   APIOFLGA+2
APIOEXCL EQU   APIOFLG2
APIOVSNS EQU   APIOFLG2
APIOVINX EQU   APIOFLG2
APIODUMP EQU   APIOFLG2
APIODMPT EQU   APIOFLG2
APIOFLG3 EQU   APIOFLGA+3
APIOFLGB EQU   APIOFLGS+4
APIOFLG7 EQU   APIOFLGB+3
APIOSNSE EQU   APIO+256
APIOINDX EQU   APIO+288
APIOSAVE EQU   APIOINDX
APIOTR   EQU   APIO+360
APIOGMSZ EQU   APIO+376
APIONBR  EQU   APIO+384
APUB     EQU   0
APUBAPCT EQU   APUB+20
APUBERRS EQU   APUB+52
APUBERR0 EQU   APUBERRS+2
APUBERRA EQU   APUBERRS+12
APUBALFG EQU   APUB+80
APUBALF0 EQU   APUBALFG
APUBALF1 EQU   APUBALFG+1
APUBBERR EQU   APUBALF1
APUBDSBP EQU   APUBALF1
APUBALF2 EQU   APUBALFG+2
APUBALF3 EQU   APUBALFG+3
APUBSTAT EQU   APUB+84
APUBFDMP EQU   APUBSTAT
APUBPDMP EQU   APUBSTAT
APUBIOFG EQU   APUB+88
APUBIOF0 EQU   APUBIOFG
APUBIOF1 EQU   APUBIOFG+1
APUBIERR EQU   APUBIOF1
APUBIIPL EQU   APUBIOF1
APUBIOF2 EQU   APUBIOFG+2
APUBIOF3 EQU   APUBIOFG+3
APUBDCB  EQU   APUB+96
APUBJBNM EQU   APUB+104
ERRORS   EQU   0
TOTC     EQU   ERRORS
IOC      EQU   ERRORS+2
CNTLRC   EQU   ERRORS+4
PTOC     EQU   ERRORS+6
BSC      EQU   ERRORS+8
THRSHLDS EQU   0
TOTT     EQU   THRSHLDS
IOT      EQU   THRSHLDS+2
CNTLRT   EQU   THRSHLDS+4
PTOT     EQU   THRSHLDS+6
BST      EQU   THRSHLDS+8
I256C    EQU   0
I015F    EQU   0
APCVZDAL EQU   0
APCVZDAP EQU   0
APCVZDBK EQU   0
APCVZDDA EQU   0
APCVZDDQ EQU   0
APCVZDEQ EQU   0
APCVZDID EQU   0
APCVZDIO EQU   0
APCVZDIP EQU   0
APCVZDMD EQU   0
APCVZDMM EQU   0
APCVZDQR EQU   0
APCVZDRI EQU   0
APCVZDUA EQU   0
APCVZDUL EQU   0
APCVZDWI EQU   0
APCVZDWT EQU   0
APCVZDX1 EQU   0
APCVZDX2 EQU   0
APCVZDX3 EQU   0
APCVZDX4 EQU   0
APCVZD10 EQU   0
APCVZD20 EQU   0
APCVZD4E EQU   0
APCVZD40 EQU   0
APCVZD41 EQU   0
APCVZD42 EQU   0
APCVZD43 EQU   0
APCVZD44 EQU   0
APCVZD45 EQU   0
APCVZD46 EQU   0
APCVZD47 EQU   0
APCVZD48 EQU   0
APCVZD49 EQU   0
APCVZD60 EQU   0
APCVZD80 EQU   0
APCVZD81 EQU   0
APCVZD82 EQU   0
APCVZD83 EQU   0
APCVZJAA EQU   0
APCVZJAD EQU   0
APCVZJAG EQU   0
APCVZJAJ EQU   0
APCVZJAM EQU   0
APCVZJAP EQU   0
APCVZJAX EQU   0
APCVZJAY EQU   0
APCVZJBA EQU   0
APCVZJBD EQU   0
APCVZJBG EQU   0
APCVZJBJ EQU   0
APCVZJBM EQU   0
APCVZJDA EQU   0
APCVZJDD EQU   0
APCVZJDG EQU   0
APCVZJDJ EQU   0
APCVZJDM EQU   0
APCVZJHC EQU   0
APCVZJHE EQU   0
APCVZJHF EQU   0
APCVZJHO EQU   0
APCVZJHQ EQU   0
APCVZJHR EQU   0
APCVZJHT EQU   0
APCVZJHW EQU   0
APCVZJH0 EQU   0
APCVZJH6 EQU   0
APCVZJI0 EQU   0
APCVZJI3 EQU   0
APCVZJJ0 EQU   0
APCVZKAA EQU   0
APCVZKBA EQU   0
APCVZKBB EQU   0
APCVZKBC EQU   0
APCVZKBD EQU   0
APCVZKBE EQU   0
APCVZKBF EQU   0
APCVZKCA EQU   0
APCVZKDA EQU   0
APCVZKGA EQU   0
APCVZKGB EQU   0
APCVZKGC EQU   0
APCVZKGD EQU   0
APCVZLCA EQU   0
APCVZLCB EQU   0
APCVZMBA EQU   0
APCVZMBD EQU   0
APCVZMBG EQU   0
APCVZMBH EQU   0
APCVZMBK EQU   0
APCVZMBM EQU   0
APCVZMIB EQU   0
APCVZMIC EQU   0
APCVZMIF EQU   0
APCVZMJB EQU   0
APCVZMJC EQU   0
APCVZMJH EQU   0
APCVZMJI EQU   0
APCVZMMA EQU   0
APCVZUAA EQU   0
APCVZUAB EQU   0
APCVZUAC EQU   0
APCVZUAD EQU   0
APCVZUAE EQU   0
APCVZUAF EQU   0
APCVZUAG EQU   0
APCVZUFA EQU   0
APCVZUHA EQU   0
APCVZUHB EQU   0
APCVZUJA EQU   0
APCVZUKA EQU   0
APCV1CMD EQU   0
APCV1JAA EQU   0
APCV1JBJ EQU   0
APCV1JHC EQU   0
APCV1JHL EQU   0
APCV1JHT EQU   0
APCV1MAB EQU   0
APCV1MBD EQU   0
APCV2JHC EQU   0
APCV2JHL EQU   0
APCV2MBD EQU   0
I001C    EQU   0
I008P    EQU   0
I015P    EQU   0
I031F    EQU   0
I031P    EQU   0
UCBBGN   EQU   0
INCHAR   EQU   0
CSW      EQU   IOSTATUS
CSWUCK   EQU   CSW
CSWCDC   EQU   CSW+1
CSWCCC   EQU   CSW+1
CSWICC   EQU   CSW+1
@NM00001 EQU   EWACNTR1
PREV     EQU   @NM00001
PREVUNIT EQU   @NM00001
DUMPREQ  EQU   @NM00001
KEYSAVED EQU   @NM00001
RESTART  EQU   @NM00001
PREVLEN  EQU   @NM00001
RETRY    EQU   @NM00001
REGS     EQU   APIOINDX
MYCSW    EQU   IOSCC
MYSENSE  EQU   APSN
UCBPTR   EQU   IOSUCB
EWAFAREA EQU   EWAIERP+32
CCWS     EQU   EWAFAREA
CCW1     EQU   CCWS
CCW2     EQU   CCWS+8
CCW2ADDR EQU   CCW2+1
CCW3     EQU   CCWS+16
SAVEVCSW EQU   EWAFAREA+24
DYNPTR   EQU   EWAFAREA+32
SPSIZE   EQU   EWAFAREA+36
DSP      EQU   SPSIZE
DSIZE    EQU   SPSIZE+1
PARMPTR  EQU   EWAFAREA+52
SAVEKEY  EQU   EWAFAREA+56
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
EWADDIOS EQU   EWAIERP
IOSATTSC EQU   IOSIPIB
IOSWTOWA EQU   IOSIPIB
IOSPCISC EQU   IOSIPIB
UCBOBS01 EQU   UCBDEV
UCBSTAB  EQU   UCBOBS01+10
UCBBSVL  EQU   UCBSTAB
UCBPRSRS EQU   UCBSTAB
UCBDMCT  EQU   UCBOBS01+11
UCBFL4   EQU   UCBOBS01+13
UCBOBS02 EQU   UCBDEV
UCBTFL1  EQU   UCBOBS02+19
UCBXTN   EQU   UCBOBS02+20
UCBVOPT  EQU   UCBXTN
UCBOBS03 EQU   UCBDEV
UCBXTADR EQU   UCBOBS03
UCBOBS04 EQU   UCBDEV
UCBBTA   EQU   UCBOBS04+12
UCBOBS06 EQU   UCBDEV
UCBAOF   EQU   UCBOBS06
UCBAOF1  EQU   UCBAOF
UCBAOF2  EQU   UCBAOF+1
@NM00032 EQU   UCBOBS06+3
UCBIRB   EQU   UCBOBS06+4
UCBGRAF  EQU   UCBIRB
UCBLDNCA EQU   UCBOBS06+8
UCBRDYQ  EQU   UCBLDNCA
UCBIRLN  EQU   UCBRDYQ
UCBLDNCB EQU   UCBRDYQ+1
UCBCTLNK EQU   UCBOBS06+12
UCBOBS07 EQU   UCBDEV
UCBOBS08 EQU   UCBDEV
UCBCTCAD EQU   UCBOBS08
UCBCTCF1 EQU   UCBOBS08+4
UCBOBS09 EQU   UCBDEV
DEBBAS02 EQU   DEBBASND
DEBDDS1  EQU   DEBBAS02
DEBSUCBA EQU   DEBDDS1
DEBDEVED EQU   DEBDDS1+4
DEBRDCB  EQU   DEBDDS1+4
DEBPDCB  EQU   DEBDDS1+8
DEBWDCB  EQU   DEBDDS1+12
DEBACS09 EQU   DEBDEVED
DEBASC09 EQU   DEBACS09
DEBEAMFG EQU   DEBASC09+3
DEBDSID  EQU   DEBASC09+4
DEBEOD   EQU   DEBASC09+12
DEBBOE   EQU   DEBEOD
DEBEODRV EQU   DEBBOE
DEBEODTT EQU   DEBBOE+1
DEBEOD0  EQU   DEBBOE+2
DEBEODSS EQU   DEBBOE+3
DEBBAS01 EQU   DEBBASND
DEBISAM  EQU   DEBBAS01
DEBFIEAD EQU   DEBISAM
DEBFPEAD EQU   DEBISAM+4
DEBFOEAD EQU   DEBISAM+8
DEBEXPT  EQU   DEBISAM+12
DEBRPSID EQU   DEBEXPT
APCTZ    EQU   APCTZ@@@
APCTZUAA EQU   APCTZ
APCTZUAB EQU   APCTZ+4
APCTZUAC EQU   APCTZ+8
APCTZUAD EQU   APCTZ+12
APCTZUAE EQU   APCTZ+16
APCTZUBB EQU   APCTZ+24
APCTZD10 EQU   APCTZ+28
APCTZD20 EQU   APCTZ+32
APCTZD40 EQU   APCTZ+36
APCTZD41 EQU   APCTZ+40
APCTZD42 EQU   APCTZ+44
APCTZD43 EQU   APCTZ+48
APCTZD44 EQU   APCTZ+52
APCTZD45 EQU   APCTZ+56
APCTZD46 EQU   APCTZ+60
APCTZD47 EQU   APCTZ+64
APCTZD48 EQU   APCTZ+68
APCTZD49 EQU   APCTZ+72
APCTZD60 EQU   APCTZ+76
APCTZD80 EQU   APCTZ+80
APCTZD4E EQU   APCTZ+84
APCTZMBA EQU   APCTZ+88
APCTZMBD EQU   APCTZ+92
APCTZMBG EQU   APCTZ+96
APCTZDX1 EQU   APCTZ+104
APCTZDX2 EQU   APCTZ+108
APCTZDX3 EQU   APCTZ+112
APCTZDX4 EQU   APCTZ+116
APCTZMBH EQU   APCTZ+120
APCTZMBK EQU   APCTZ+124
APCTZMBM EQU   APCTZ+128
APCTZMJB EQU   APCTZ+132
APCTZMJC EQU   APCTZ+136
APCTZMJH EQU   APCTZ+140
APCTZMMA EQU   APCTZ+144
APCTZDMD EQU   APCTZ+148
APCTZD81 EQU   APCTZ+152
APCTZDID EQU   APCTZ+156
APCTZDRI EQU   APCTZ+160
APCTZMJI EQU   APCTZ+164
APCTZDWT EQU   APCTZ+168
APCTZDMM EQU   APCTZ+172
APCTZDAL EQU   APCTZ+176
APCTZDBK EQU   APCTZ+180
APCTZDIP EQU   APCTZ+184
APCTZDDA EQU   APCTZ+188
APCTZDUL EQU   APCTZ+192
APCTZDEQ EQU   APCTZ+196
APCTZDDQ EQU   APCTZ+200
APCTZDUA EQU   APCTZ+204
APCTZUAF EQU   APCTZ+208
APCTZUAG EQU   APCTZ+212
APCTZDIO EQU   APCTZ+216
APCTZUHA EQU   APCTZ+220
APCTZUHB EQU   APCTZ+224
APCTZJAA EQU   APCTZ+232
APCTZJAD EQU   APCTZ+236
APCTZJAG EQU   APCTZ+240
APCTZJAJ EQU   APCTZ+244
APCTZJAM EQU   APCTZ+248
APCTZJAP EQU   APCTZ+252
APCTZJAY EQU   APCTZ+256
APCTZUFA EQU   APCTZ+260
APCTZUJA EQU   APCTZ+264
APCTZDAP EQU   APCTZ+268
APCTZKAA EQU   APCTZ+272
APCTZD82 EQU   APCTZ+276
APCTZMIB EQU   APCTZ+280
APCTZMIC EQU   APCTZ+284
APCTZD83 EQU   APCTZ+288
APCTZMIF EQU   APCTZ+296
APCTZJH0 EQU   APCTZ+300
APCTZJI0 EQU   APCTZ+304
APCTZJI3 EQU   APCTZ+308
APCTZJJ0 EQU   APCTZ+312
APCTZJBA EQU   APCTZ+316
APCTZJBD EQU   APCTZ+320
APCTZJBG EQU   APCTZ+324
APCTZJBJ EQU   APCTZ+328
APCTZJBM EQU   APCTZ+332
APCTZKCA EQU   APCTZ+340
APCTZKDA EQU   APCTZ+344
APCTZJDA EQU   APCTZ+356
APCTZJDJ EQU   APCTZ+360
APCTZJH6 EQU   APCTZ+364
APCTZJHO EQU   APCTZ+368
APCTZJHF EQU   APCTZ+372
APCTZJHE EQU   APCTZ+376
APCTZDQR EQU   APCTZ+380
APCTZJHR EQU   APCTZ+384
APCTZJHT EQU   APCTZ+388
APCTZJHW EQU   APCTZ+392
APCTZ1   EQU   APCTZ@@1
APCTZKBA EQU   APCTZ1
APCTZKBC EQU   APCTZ1+4
APCTZKBB EQU   APCTZ1+8
APCTZJHC EQU   APCTZ1+20
APCTZJHQ EQU   APCTZ1+24
APCTZKBD EQU   APCTZ1+28
APCTZKBE EQU   APCTZ1+40
APCTZUKA EQU   APCTZ1+56
APCTZKBF EQU   APCTZ1+60
APCTZJDD EQU   APCTZ1+64
APCTZJDG EQU   APCTZ1+68
APCTZJDM EQU   APCTZ1+72
APCTZLCA EQU   APCTZ1+76
APCTZLCB EQU   APCTZ1+80
APCTZDWI EQU   APCTZ1+84
APCTZJAX EQU   APCTZ1+88
APCTZKGA EQU   APCTZ1+92
APCTZKGB EQU   APCTZ1+96
APCTZKGC EQU   APCTZ1+100
APCTZKGD EQU   APCTZ1+104
APCTU    EQU   APCTU@@@
APCT1MAB EQU   APCTU
APCT1MBD EQU   APCTU+4
APCT2MBD EQU   APCTU+8
APCT1CMD EQU   APCTU+12
APCT1JAA EQU   APCTU+20
APCT1JHC EQU   APCTU+24
APCT2JHC EQU   APCTU+28
APCT1JHT EQU   APCTU+32
APCT1JHL EQU   APCTU+36
APCT2JHL EQU   APCTU+40
APCT1JBJ EQU   APCTU+44
@NM00102 EQU   APIOIOCB
@NM00103 EQU   APIOIOCB
APSNFMT0 EQU   APSNFMTD
APSNPRTY EQU   APSNFMT0
APSNPBS  EQU   APSNPRTY
APSNADCK EQU   APSNFMT0+1
APSNCPST EQU   APSNFMT0+2
APSNAEST EQU   APSNFMT0+3
APSNXCPS EQU   APSNFMT0+4
APSNXCP0 EQU   APSNXCPS
APSNXCP1 EQU   APSNXCPS+1
APSNFMT1 EQU   APSNFMTD
APSNPMES EQU   APSNFMT1+2
APSNFMT2 EQU   APSNFMTD
APSNDDST EQU   APSNFMT2
APSNDDS0 EQU   APSNDDST
APSNDDS1 EQU   APSNDDST+1
APSNAECK EQU   APSNFMT2+2
APSNAEC0 EQU   APSNAECK
APSNAEC1 EQU   APSNAECK+1
APSNFMT4 EQU   APSNFMTD
APSN4IOS EQU   APSNFMT4+1
APSN4IO0 EQU   APSN4IOS
APSN4IO1 EQU   APSN4IOS+1
APSN4IO2 EQU   APSN4IOS+2
APSN4CPC EQU   APSNFMT4+4
APSN4CMC EQU   APSNFMT4+6
APSN4CM0 EQU   APSN4CMC
APSN4CM1 EQU   APSN4CMC+1
PSARSVTE EQU   PSARSVT
FLC      EQU   PSA
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
APSN4CIC EQU   APSNFMT4+14
@NM00115 EQU   APSNFMT4+12
APSN4CAR EQU   APSNFMT4+10
APSN4CDA EQU   APSNFMT4+8
@NM00114 EQU   APSN4CM1
APSN4EBT EQU   APSN4CM1
APSN4IAD EQU   APSN4CM1
APSN4IAI EQU   APSN4CM1
@NM00113 EQU   APSN4CM1
APSN4SPD EQU   APSN4CM1
APSN4SPI EQU   APSN4CM1
APSN4CSP EQU   APSN4CM0
APSN4BPW EQU   APSN4CM0
APSN4BPR EQU   APSN4CM0
@NM00112 EQU   APSN4CM0
APSN4CMS EQU   APSNFMT4+5
@NM00111 EQU   APSN4CPC
APSN4IVI EQU   APSN4CPC
APSN4IVA EQU   APSN4CPC
APSN4DVZ EQU   APSN4CPC
APSN4EQC EQU   APSN4CPC
APSN4IMB EQU   APSN4CPC
@NM00110 EQU   APSN4CPC
APSN4ONL EQU   APSN4IO2
APSN4STN EQU   APSN4IO2
APSN4ACK EQU   APSN4IO2
APSN4DCK EQU   APSN4IO2
APSN4STP EQU   APSN4IO2
APSN4SO  EQU   APSN4IO2
APSN4BOP EQU   APSN4IO2
APSN4CR  EQU   APSN4IO2
APSN4IDC EQU   APSN4IO1
APSN4SR  EQU   APSN4IO1
APSN4DI  EQU   APSN4IO1
APSN4CSY EQU   APSN4IO1
APSN4CPR EQU   APSN4IO1
APSN4SNS EQU   APSN4IO1
APSN4WRT EQU   APSN4IO1
APSN4RD  EQU   APSN4IO1
APSN4BSY EQU   APSN4IO0
APSN4SM  EQU   APSN4IO0
APSN4UC  EQU   APSN4IO0
APSN4CE  EQU   APSN4IO0
APSN4IDS EQU   APSN4IO0
@NM00109 EQU   APSN4IO0
APSN4SID EQU   APSNFMT4
APSNBRCT EQU   APSNFMT2+4
APSNAC15 EQU   APSNAEC1
APSNAC14 EQU   APSNAEC1
APSNAC13 EQU   APSNAEC1
APSNAC12 EQU   APSNAEC1
APSNAC11 EQU   APSNAEC1
APSNAC10 EQU   APSNAEC1
APSNAC09 EQU   APSNAEC1
APSNAC08 EQU   APSNAEC1
APSNAC07 EQU   APSNAEC0
APSNAC06 EQU   APSNAEC0
APSNAC05 EQU   APSNAEC0
APSNAC04 EQU   APSNAEC0
APSNAC03 EQU   APSNAEC0
@NM00108 EQU   APSNAEC0
APSNASTP EQU   APSNDDS1
APSNCNVT EQU   APSNDDS1
APSNBSLM EQU   APSNDDS1
APSNXDVZ EQU   APSNDDS1
APSNXOVF EQU   APSNDDS1
APSNXBR  EQU   APSNDDS0
APSNIBR  EQU   APSNDDS0
APSNICPM EQU   APSNDDS0
APSNICOP EQU   APSNDDS0
APSNCILM EQU   APSNDDS0
APSNCIOV EQU   APSNDDS0
APSNIOLN EQU   APSNDDS0
APSNIOLM EQU   APSNDDS0
APSNPMDT EQU   APSNPMES
APSNPMBS EQU   APSNPMES
APSNPMAE EQU   APSNPMES
APSNPMCP EQU   APSNPMES
APSNPMEC EQU   APSNFMT1+1
APSNPMXC EQU   APSNFMT1
APSNIOCW EQU   APSNFMT0+12
APSNCPAR EQU   APSNFMT0+10
APSNCPIC EQU   APSNFMT0+8
APSNPGNR EQU   APSNFMT0+6
@NM00107 EQU   APSNXCP1
APSNXIBS EQU   APSNXCP1
APSNXSIE EQU   APSNXCP1
APSNXIRA EQU   APSNXCP1
APSNXAFC EQU   APSNXCP0
APSNXAEI EQU   APSNXCP0
APSNXTCB EQU   APSNXCP0
APSNXDTI EQU   APSNXCP0
APSNXIOC EQU   APSNXCP0
APSNXIOI EQU   APSNXCP0
APSNXCDZ EQU   APSNXCP0
APSNXINS EQU   APSNXCP0
APSNWSC  EQU   APSNAEST
APSNAINS EQU   APSNAEST
APSNEDBO EQU   APSNCPST
APSNEDBR EQU   APSNCPST
APSNEDBT EQU   APSNCPST
APSNCINS EQU   APSNCPST
APSNACPP EQU   APSNADCK
APSNABS  EQU   APSNADCK
APSNPAWC EQU   APSNPRTY
APSNPAEW EQU   APSNPRTY
APSNPCPC EQU   APSNPRTY
APSNPCPP EQU   APSNPRTY
APIOIOB  EQU   @NM00103+160
@NM00104 EQU   @NM00103
APIOSRB  EQU   @NM00102+128
APIOIOSB EQU   @NM00102
@NM00081 EQU   APCTU+48
APCT1MBM EQU   APCTU+16
@NM00080 EQU   APCTZ1+108
@NM00079 EQU   APCTZ1+52
@NM00078 EQU   APCTZ1+48
@NM00077 EQU   APCTZ1+44
@NM00076 EQU   APCTZ1+36
@NM00075 EQU   APCTZ1+32
@NM00074 EQU   APCTZ1+16
@NM00073 EQU   APCTZ1+12
@NM00072 EQU   APCTZ+396
@NM00071 EQU   APCTZ+352
@NM00070 EQU   APCTZ+348
@NM00069 EQU   APCTZ+336
@NM00068 EQU   APCTZ+292
APCTZJFA EQU   APCTZ+228
APCTZMBR EQU   APCTZ+100
@NM00067 EQU   APCTZ+20
DEBEXPTA EQU   DEBEXPT+1
DEBRSV12 EQU   DEBRPSID
DEBRSV11 EQU   DEBRPSID
DEBRSV10 EQU   DEBRPSID
DEBRSV09 EQU   DEBRPSID
DEBRPSAP EQU   DEBRPSID
DEBRPSO  EQU   DEBRPSID
DEBRPSI  EQU   DEBRPSID
DEBRPSP  EQU   DEBRPSID
DEBFOEB  EQU   DEBFOEAD+1
DEBNOEE  EQU   DEBFOEAD
DEBFPEB  EQU   DEBFPEAD+1
DEBNPEE  EQU   DEBFPEAD
DEBFIEB  EQU   DEBFIEAD+1
DEBNIEE  EQU   DEBFIEAD
DEBBOESS EQU   DEBEODSS
DEBBOE0  EQU   DEBEOD0
DEBBOETT EQU   DEBEODTT
DEBBOERV EQU   DEBEODRV
DEBRV008 EQU   DEBDSID+7
DEBWTPTI EQU   DEBDSID+6
DEBEXDTE EQU   DEBDSID
DEBRV007 EQU   DEBEAMFG
DEBRV006 EQU   DEBEAMFG
DEBRV005 EQU   DEBEAMFG
DEBRV004 EQU   DEBEAMFG
DEBSECVL EQU   DEBEAMFG
DEBVAMSG EQU   DEBEAMFG
DEBDSOPN EQU   DEBEAMFG
DEBMULTI EQU   DEBEAMFG
DEBVSEQU EQU   DEBASC09+2
DEBDSSQL EQU   DEBASC09+1
DEBVOLAC EQU   DEBASC09
DEBWDCBA EQU   DEBWDCB+1
DEBRSV08 EQU   DEBWDCB
DEBPDCBA EQU   DEBPDCB+1
DEBRSV07 EQU   DEBPDCB
DEBRDCBA EQU   DEBRDCB+1
DEBRSV06 EQU   DEBRDCB
DEBSUCBB EQU   DEBSUCBA+1
DEBSDVM  EQU   DEBSUCBA
UCBRV066 EQU   UCBOBS09+4
UCBIOSBA EQU   UCBOBS09
UCBRV042 EQU   UCBOBS08+5
UCBRV082 EQU   UCBCTCF1
UCBRV081 EQU   UCBCTCF1
UCBRV080 EQU   UCBCTCF1
UCBRV079 EQU   UCBCTCF1
UCBRV078 EQU   UCBCTCF1
UCBRV077 EQU   UCBCTCF1
UCBRV076 EQU   UCBCTCF1
UCBCTC80 EQU   UCBCTCF1
UCBCTCAL EQU   UCBCTCAD
UCBICNCB EQU   UCBOBS07+4
UCBRV040 EQU   UCBOBS07
UCBCTLNA EQU   UCBCTLNK+1
UCBRLN   EQU   UCBCTLNK
UCBRDYQA EQU   UCBLDNCB
UCBINRLN EQU   UCBIRLN
UCBIRBA  EQU   UCBIRB+1
UCBRV039 EQU   UCBGRAF
UCBDWNR  EQU   UCBGRAF
UCBRPND  EQU   UCBGRAF
UCBUPM   EQU   UCBGRAF
UCBBTAM  EQU   UCBGRAF
UCBDRNO  EQU   UCBGRAF
UCBDRO   EQU   UCBGRAF
UCBOIP   EQU   UCBGRAF
UCBATRCD EQU   @NM00032
UCBSKPFG EQU   @NM00032
UCBRIPND EQU   @NM00032
UCBRTIAC EQU   @NM00032
UCBRSV79 EQU   @NM00032
UCBRSV78 EQU   @NM00032
UCBRSV77 EQU   @NM00032
UCBOLTEP EQU   @NM00032
UCBATNCT EQU   UCBOBS06+2
UCBRSV76 EQU   UCBAOF2
UCBRSV75 EQU   UCBAOF2
UCBRSV74 EQU   UCBAOF2
UCBRSV73 EQU   UCBAOF2
UCBRSV72 EQU   UCBAOF2
UCBRSV71 EQU   UCBAOF2
UCBRSV70 EQU   UCBAOF2
UCBRSV69 EQU   UCBAOF2
UCBRSV68 EQU   UCBAOF1
UCBRSV67 EQU   UCBAOF1
UCBRSV66 EQU   UCBAOF1
UCBRSV65 EQU   UCBAOF1
UCBRSV64 EQU   UCBAOF1
UCBOFNL  EQU   UCBAOF1
UCBOFSP  EQU   UCBAOF1
UCBOFMCR EQU   UCBAOF1
UCBBTB   EQU   UCBBTA+1
UCBDI    EQU   UCBBTA
UCBSNS   EQU   UCBOBS04+8
UCBTEB   EQU   UCBOBS04+4
UCBGCB   EQU   UCBOBS04+3
UCBOPEN  EQU   UCBOBS04+2
UCBSTART EQU   UCBOBS04
UCBXTNB  EQU   UCBXTN+1
UCBRSV22 EQU   UCBVOPT
UCBRSV21 EQU   UCBVOPT
UCBRSV20 EQU   UCBVOPT
UCBESVE  EQU   UCBVOPT
UCBERPC  EQU   UCBVOPT
UCBESVC  EQU   UCBVOPT
UCBEVA   EQU   UCBVOPT
UCBESV   EQU   UCBVOPT
UCBRV009 EQU   UCBTFL1
UCBRV008 EQU   UCBTFL1
UCBRV007 EQU   UCBTFL1
UCBRV006 EQU   UCBTFL1
UCBRV005 EQU   UCBTFL1
UCBDQDSP EQU   UCBTFL1
UCBNSLTP EQU   UCBTFL1
UCBNLTP  EQU   UCBTFL1
UCBRES1B EQU   UCBOBS02+18
UCBFSER  EQU   UCBOBS02+12
@NM00031 EQU   UCBOBS02+4
UCBFSEQ  EQU   UCBOBS02+2
UCBFSCT  EQU   UCBOBS02
UCBNEXP  EQU   UCBOBS01+20
UCBBASE  EQU   UCBOBS01+16
UCBRES1A EQU   UCBOBS01+15
UCBUSER  EQU   UCBOBS01+14
UCBFL47  EQU   UCBFL4
UCBMAT   EQU   UCBFL4
UCBHOLD  EQU   UCBFL4
UCBATTN  EQU   UCBFL4
UCBDSS   EQU   UCBFL4
UCBRESVP EQU   UCBFL4
UCBWDAV  EQU   UCBFL4
UCBDAVV  EQU   UCBFL4
UCBSQC   EQU   UCBOBS01+12
UCBDATP  EQU   UCBOBS01+12
UCBDMC   EQU   UCBDMCT
UCBMOUNT EQU   UCBDMCT
UCBBNUL  EQU   UCBSTAB
UCBSHAR  EQU   UCBSTAB
UCBBSTR  EQU   UCBSTAB
UCBBPUB  EQU   UCBSTAB
UCBBPRV  EQU   UCBSTAB
UCBBALB  EQU   UCBPRSRS
UCBPGFL  EQU   UCBSTAB
UCBDVSHR EQU   UCBBSVL
UCBVOLI  EQU   UCBOBS01+4
UCBVTOC  EQU   UCBOBS01
IOSPCIWA EQU   IOSPCISC+44
IOSPCIRS EQU   IOSPCISC+8
@NM00029 EQU   IOSPCISC+4
@NM00028 EQU   IOSPCISC
IOSWRNDR EQU   IOSWTOWA+4
IOSWTOPT EQU   IOSWTOWA+3
IOSWTOCP EQU   IOSWTOWA+2
IOSWTOCH EQU   IOSWTOWA
IOSATTWA EQU   IOSATTSC+40
@NM00027 EQU   IOSATTSC+24
IOSATTSN EQU   IOSATTSC
EWAEND   EQU   EWADDIOS+74
EWA2CHA  EQU   EWADDIOS+72
EWA2CPU  EQU   EWADDIOS+71
EWASCSW  EQU   EWADDIOS+64
EWASNS   EQU   EWADDIOS
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
DYNEND   EQU   EWAFAREA+60
@NM00010 EQU   EWAFAREA+57
@NM00009 EQU   EWAFAREA+40
@NM00008 EQU   CCW3+4
CCW3ADDR EQU   CCW3+1
@NM00007 EQU   CCW3
@NM00006 EQU   CCW2+4
@NM00005 EQU   CCW2
@NM00004 EQU   CCW1+4
CCW1ADDR EQU   CCW1+1
@NM00003 EQU   CCW1
CSWCCK   EQU   CSW+1
CSWPCK   EQU   CSW+1
CSWPC    EQU   CSW+1
CSWIL    EQU   CSW+1
CSWPCI   EQU   CSW+1
CSWUEX   EQU   CSW
CSWDVE   EQU   CSW
CSWCHE   EQU   CSW
CSWBSY   EQU   CSW
CSWCUE   EQU   CSW
CSWSMD   EQU   CSW
CSWATN   EQU   CSW
@NM00130 EQU   APUB+120
@NM00129 EQU   APUB+112
APUBSIZE EQU   APUB+102
APUBRSVD EQU   APUB+100
APUBASCB EQU   APUBDCB
@NM00128 EQU   APUBIOFG+4
@NM00127 EQU   APUBIOF3
APUBISHR EQU   APUBIOF3
APUBIRIP EQU   APUBIOF3
@NM00126 EQU   APUBIOF2
APUBIEXC EQU   APUBIOF2
@NM00125 EQU   APUBIOF1
@NM00124 EQU   APUBIOF0
APUBICNL EQU   APUBIOF0
APUBINRG EQU   APUBIOF0
APUBIDAB EQU   APUBIOF0
APUBIDWN EQU   APUBIOF0
@NM00123 EQU   APUB+85
@NM00122 EQU   APUBSTAT
APUBQISC EQU   APUBSTAT
APUBRIPL EQU   APUBSTAT
@NM00121 EQU   APUBALF3
APUBSCAL EQU   APUBALF3
APUBSCAV EQU   APUBALF3
APUBBIST EQU   APUBALF3
APUBBTST EQU   APUBALF3
@NM00120 EQU   APUBALF2
APUBBIER EQU   APUBALF2
APUBBOPT EQU   APUBALF2
APUBBREQ EQU   APUBALF2
APUBBYT1 EQU   APUBALF2
@NM00119 EQU   APUBALF1
APUBUNLP EQU   APUBALF1
APUBUNLD EQU   APUBALF1
APUBDSBL EQU   APUBALF1
APUBZRGN EQU   APUBALF1
@NM00118 EQU   APUBALF0
APUBOWN  EQU   APUBALF0
APUBSBCH EQU   APUBALF0
APUBCPU  EQU   APUB+78
APUBINIT EQU   APUB+76
APUBIPL  EQU   APUB+74
APUBERRJ EQU   APUBERRS+20
APUBERRD EQU   APUBERRS+18
APUBERRC EQU   APUBERRS+16
APUBERRB EQU   APUBERRS+14
APUBERR9 EQU   APUBERRS+10
APUBERR3 EQU   APUBERRS+8
APUBERR2 EQU   APUBERRS+6
APUBERR1 EQU   APUBERRS+4
@NM00117 EQU   APUBERRS
@NM00116 EQU   APUB+50
APUBRGN  EQU   APUB+48
APUBERRT EQU   APUB+44
APUBMSTP EQU   APUB+40
APUBUBAP EQU   APUB+36
APUBAPDS EQU   APUB+32
APUBUCB  EQU   APUB+28
APUBIOCT EQU   APUB+24
APUBUSER EQU   APUB+16
APUBNXIO EQU   APUB+12
APUBMSTR EQU   APUB+8
APUBAPUB EQU   APUB+4
APUBID   EQU   APUB
@NM00101 EQU   APIO+424
@NM00100 EQU   APIO+400
APIOTMEE EQU   APIO+396
APIOTMES EQU   APIO+392
APIOXTME EQU   APIO+388
APIONBRI EQU   APIONBR+2
APIONBRX EQU   APIONBR
APIOAPCT EQU   APIO+380
APIOGMS1 EQU   APIOGMSZ+2
@NM00099 EQU   APIOGMSZ+1
APIOGMSP EQU   APIOGMSZ
APIOGMAD EQU   APIO+372
APIOCISZ EQU   APIO+370
APIOSIZE EQU   APIO+368
APIORB   EQU   APIOTR+4
APIOTCB  EQU   APIOTR
APIOECB  EQU   APIO+356
APIOTERM EQU   APIO+352
APIOASCB EQU   APIO+348
APIOTCSW EQU   APIOSAVE
APIOACTV EQU   APIOFLG7
APIOFLG6 EQU   APIOFLGB+2
APIOFLG5 EQU   APIOFLGB+1
APIOFLG4 EQU   APIOFLGB
@NM00098 EQU   APIOFLG3
APIOPGFS EQU   APIOFLG3
APIOPGIP EQU   APIOFLG3
APIORSME EQU   APIOFLG3
APIORET  EQU   APIOFLG3
APIONPST EQU   APIOFLG3
APIOIOCT EQU   APIOFLG3
@NM00097 EQU   APIOFLG2
APIOCSWT EQU   APIOFLG2
APIOFLG1 EQU   APIOFLGA+1
@NM00096 EQU   APIOFLG0
APIOSU50 EQU   APIOFLG0
APIOSYNC EQU   APIOFLG0
APIOFXED EQU   APIOFLG0
@NM00095 EQU   APIO+246
APIOIOAP EQU   APIO+240
APIORGN  EQU   APIO+236
APIOPGFL EQU   APIO+232
APIOPGFX EQU   APIO+228
APIOAPCI EQU   APIO+224
APIOCCW  EQU   APIO+220
APIOAPXL EQU   APIO+212
APIOAPIO EQU   APIO+200
APIOUSER EQU   APIO+196
APIOID   EQU   APIO+192
APDXAPIO EQU   APDX+136
@NM00094 EQU   APDX+136
@NM00093 EQU   APDX+133
@NM00092 EQU   APDX+132
@NM00091 EQU   APDXSW1
@NM00090 EQU   APDXSW0
APDXSSMF EQU   APDXSW0
APDXSEOT EQU   APDXSW0
APDXSOPN EQU   APDXSW0
APDXIOCT EQU   APDX+128
@NM00089 EQU   APDX+52
@NM00088 EQU   APDX+50
APDXDEB  EQU   APDX+44
APDXAPOC EQU   APDX+40
APDXDXA  EQU   APDX+36
APDXSIZE EQU   APDXDXL+2
@NM00087 EQU   APDXDXL
APDXAPMF EQU   APDX252A
APDX252L EQU   APDX+24
APDX000A EQU   APDX+20
APDX000L EQU   APDX+16
APDXAPCT EQU   APDX+8
APDXUSER EQU   APDX+4
APDXID   EQU   APDX
@NM00086 EQU   APDS+144
@NM00085 EQU   APDS+100
APDSAPEP EQU   APDS+96
@NM00084 EQU   APDS+94
APDSSIZE EQU   APDS+92
APDSITCB EQU   APDS+80
APDSMSK  EQU   APDS+72
@NM00083 EQU   APDS+69
APDSIOFS EQU   APDS+68
APDSDUMP EQU   APDS+67
APDSPGFX EQU   APDS+66
@NM00082 EQU   APDSFLG1
APDSFRST EQU   APDSFLG1
APDSSLPS EQU   APDSFLG0
APDSLSR  EQU   APDSFLG0
APDSIER  EQU   APDSFLG0
APDSARS  EQU   APDSFLG0
APDSVPER EQU   APDSFLG0
APDSVLER EQU   APDSFLG0
APDSTPGM EQU   APDSFLG0
APDSOWN  EQU   APDSFLG0
APDSDSAP EQU   APDS+60
APDSREG  EQU   APDS+56
APDSASCB EQU   APDS+52
APDSAPUB EQU   APDS+48
APDSPERR EQU   APDS+40
APDSLERR EQU   APDS+32
APDSDDNM EQU   APDS+24
APDSDEB  EQU   APDSTD+4
APDSTCB  EQU   APDSTD
APDSAPCT EQU   APDS+12
APDSUSER EQU   APDS+8
APDSAPDS EQU   APDS+4
APDSID   EQU   APDS
@NM00066 EQU   APCT+1556
APCTSVCT EQU   APCT+1552
APCTDAVT EQU   APCT+1548
APCTLOGL EQU   APCT+1544
@NM00065 EQU   APCT+1540
APCTDMPU EQU   APCT+1536
APCTDMPM EQU   APCT+1532
APCTASID EQU   APCT+1528
APCTLGPG EQU   APCT+1526
APCTLGLN EQU   APCT+1524
APCTAPVU EQU   APCT+1520
APCTABR  EQU   APCT+1116
APCTACTR EQU   APCT+1112
APCTLOGD EQU   APCT+1108
APCTDCLD EQU   APCT+1104
APCTIOAP EQU   APCT+1100
@NM00064 EQU   APCT+1080
@NM00063 EQU   APCT+1078
APCTKCAX EQU   APCT+1076
APCTABND EQU   APCT+1072
@NM00062 EQU   APCT+1068
APCTAPIO EQU   APCT+1064
APCTCSCT EQU   APCT+1060
APCTSTDF EQU   APCT+1056
APCTSTMX EQU   APCT+1052
APCTRGMX EQU   APCT+1048
APCTSIZE EQU   APCT+1046
APCTCTUB EQU   APCT+1045
APCTMFID EQU   APCT+1044
APCTMFSZ EQU   APCT+1040
APCTCRTN EQU   APCT+1036
APCTAPCP EQU   APCT+1032
APCTAMNA EQU   APCT+1028
APCTEMNA EQU   APCT+1024
APCTAALP EQU   APCT+1020
APCTEALP EQU   APCT+1016
@NM00061 EQU   APCT+1012
@NM00060 EQU   APCT+1008
@NM00059 EQU   APCT+1004
@NM00058 EQU   APCT+996
@NM00057 EQU   APCT+992
@NM00056 EQU   APCT+988
@NM00055 EQU   APCT+984
@NM00054 EQU   APCT+980
APCTECPW EQU   APCT+976
APCTECPT EQU   APCT+968
APCTEALC EQU   APCT+964
APCTECBL EQU   APCT+960
APCTECIT EQU   APCT+956
APCTCQAF EQU   APCTCQAQ
APCTCQL  EQU   APCTAPCQ+4
APCTCQF  EQU   APCTAPCQ
APCTCQLK EQU   APCT+940
@NM00053 EQU   @NM00049+2
@NM00052 EQU   APCTPRSW
APCTAPST EQU   APCTPRSW
@NM00051 EQU   APCTPRSW
@NM00050 EQU   APCTSTAT
APCTWARM EQU   APCTSTAT
APCTTERM EQU   APCTSTAT
APCTHALT EQU   APCTSTAT
APCTQSCE EQU   APCTSTAT
APCTSTRT EQU   APCTSTAT
APCTACT  EQU   APCTSTAT
APCTVUNX EQU   APCT+935
APCTSOUT EQU   APCT+934
APCTDAID EQU   APCT+933
APCTSV34 EQU   APCT+932
APCTMJOB EQU   APCT+928
APCTTCB  EQU   APCT+924
APCTDCNW EQU   APCT+918
APCTDCNR EQU   APCT+916
@NM00048 EQU   APCT+912
@NM00047 EQU   APCT+908
@NM00046 EQU   APCT+904
@NM00045 EQU   APCT+900
@NM00044 EQU   APCTERRS+22
APCTERTJ EQU   APCTERRS+20
APCTERTD EQU   APCTERRS+18
APCTERTC EQU   APCTERRS+16
APCTERTB EQU   APCTERRS+14
APCTERT9 EQU   APCTERRS+10
APCTERT3 EQU   APCTERRS+8
APCTERT2 EQU   APCTERRS+6
APCTERT1 EQU   APCTERRS+4
APCTERTT EQU   APCTERRS
APCTDSAP EQU   APCT+872
APCTISUB EQU   APCT+868
APCTUBAP EQU   APCT+864
APCTAPDS EQU   APCT+860
APCTUBIC EQU   APCT+856
APCTUBIS EQU   APCT+852
APCTAPUB EQU   APCT+848
APCTUBLK EQU   APCT+844
APCTBR1A EQU   APCTBR14+2
@NM00043 EQU   APCTBR14
APCTSMSZ EQU   APCTSMAD+2
@NM00042 EQU   APCTSMAD+1
@NM00041 EQU   APCTSMAD
APCTSMIS EQU   APCTSMIN+2
@NM00040 EQU   APCTSMIN+1
APCTSMSP EQU   APCTSMIN
@NM00039 EQU   APCT+30
APCTLINE EQU   APCT+28
APCTLBSZ EQU   APCT+24
APCTREG  EQU   APCT+20
@NM00038 EQU   APCTENQM
APCTSSVT EQU   APCT+8
APCTUSER EQU   APCT+4
APCTID   EQU   APCT
DEBXSAMB EQU   DEBXTN+28
DEBXOPNJ EQU   DEBXTN+24
DEBXXARG EQU   DEBXTN+20
DEBXMCF2 EQU   DEBXTN+19
DEBXMCF1 EQU   DEBXTN+18
DEBXDSO2 EQU   DEBXTN+17
DEBXDSO1 EQU   DEBXTN+16
DEBXDBPR EQU   DEBXTN+12
DEBXDCBM EQU   DEBXTN+8
DEBXDSAB EQU   DEBXTN+4
DEBXRV48 EQU   DEBXTN+3
DEBXRV47 EQU   DEBXFLG1
DEBXRV46 EQU   DEBXFLG1
DEBXRV45 EQU   DEBXFLG1
DEBXRV44 EQU   DEBXFLG1
DEBXRV43 EQU   DEBXFLG1
DEBXDSSI EQU   DEBXFLG1
DEBXTSKC EQU   DEBXFLG1
DEBXCDCB EQU   DEBXFLG1
DEBXLNGH EQU   DEBXTN
DEBTBLOF EQU   DEBPREFX+14
DEBAMTYP EQU   DEBPREFX+13
DEBLNGTH EQU   DEBPREFX+12
DEBDCBMK EQU   DEBXTNP
DEBDSCBA EQU   DEBPREFX+1
DEBWKARA EQU   DEBPREFX
DEBXCEAD EQU   DEBXCEA+1
DEBXCENP EQU   DEBXCEAB
DEBRSV35 EQU   DEBXCEAB
DEBRSV34 EQU   DEBXCEAB
DEBRSV33 EQU   DEBXCEAB
DEBRSV32 EQU   DEBXCEAB
DEBCEAD  EQU   DEBCEA+1
DEBCENP  EQU   DEBCEAB
DEBRSV31 EQU   DEBCEAB
DEBRSV30 EQU   DEBCEAB
DEBRSV29 EQU   DEBCEAB
DEBRSV28 EQU   DEBCEAB
DEBPCIAD EQU   DEBPCIA+1
DEBPCINP EQU   DEBPCIAB
DEBRSV27 EQU   DEBPCIAB
DEBRSV26 EQU   DEBPCIAB
DEBRSV25 EQU   DEBPCIAB
DEBRSV24 EQU   DEBPCIAB
DEBSIOAD EQU   DEBSIOA+1
DEBSIONP EQU   DEBSIOAB
DEBFIX   EQU   DEBSIOAB
DEBIOVR  EQU   DEBSIOAB
DEBSIOX  EQU   DEBSIOAB
DEBPGFX  EQU   DEBSIOAB
DEBEOEAD EQU   DEBEOEA+1
DEBEOENP EQU   DEBEOEAB
DEBRSV22 EQU   DEBEOEAB
DEBRSV21 EQU   DEBEOEAB
DEBRSV20 EQU   DEBEOEAB
DEBESMVR EQU   DEBEOEAB
DEBSUBID EQU   DEBSUBNM
DEBSIOA2 EQU   DEBACS08+24
DEBRPSIO EQU   DEBACS08+20
DEBFREED EQU   DEBACS08+16
@NM00037 EQU   DEBACS08+12
@NM00036 EQU   DEBACS08+8
DEBDISAD EQU   DEBACS08+4
@NM00035 EQU   DEBACS08
DEBRPSST EQU   DEBACS07+64
DEBARECK EQU   DEBACS07+60
DEBAREWT EQU   DEBACS07+56
DEBACHK  EQU   DEBACS07+52
DEBAWRIT EQU   DEBACS07+48
DEBASETL EQU   DEBACS07+44
DEBAREAD EQU   DEBACS07+40
DEBCRECK EQU   DEBACS07+36
DEBCREWT EQU   DEBACS07+32
DEBCCHK  EQU   DEBACS07+28
DEBCWRIT EQU   DEBACS07+24
DEBCSETL EQU   DEBACS07+20
DEBCREAD EQU   DEBACS07+16
DEBWKPT5 EQU   DEBACS07+12
DEBWKPT4 EQU   DEBACS07+8
DEBGET   EQU   DEBACS07+4
@NM00034 EQU   DEBACS07
DEBPUT   EQU   DEBACS06+4
DEBDCBFA EQU   DEBACS06
DEBLUCBB EQU   DEBLUCBA+1
DEBRSV18 EQU   DEBLUCBA
DEBFUCBB EQU   DEBFUCBA+1
DEBRSV17 EQU   DEBFUCBA
DEBTCCWB EQU   DEBTCCWA+1
DEBRSV16 EQU   DEBTCCWA
DEBTBFRB EQU   DEBTBFRA+1
DEBRSV15 EQU   DEBTBFRA
DEBDBPEF EQU   DEBACS03+8
DEBDBPP  EQU   DEBACS03+4
DEBDTPP  EQU   DEBACS03
DEBDBPE  EQU   DEBDBLK+1
DEBDBPT  EQU   DEBDBLK
DEBEXTNM EQU   DEBDSNAM
DEBLRECL EQU   DEBACSMD+14
DEBBLKSI EQU   DEBACSMD+12
DEBRSV14 EQU   DEBDSNM+4
DEBUTSAB EQU   DEBUTSAA+1
DEBRSV13 EQU   DEBUTSAA
DEBVOLNM EQU   DEBACSMD+2
DEBVLSEQ EQU   DEBVOLSQ+1
DEBRSV42 EQU   DEBVOLBT
DEBRSV41 EQU   DEBVOLBT
DEBRSV40 EQU   DEBVOLBT
DEBRSV39 EQU   DEBVOLBT
DEBRSV38 EQU   DEBVOLBT
DEBRSV37 EQU   DEBVOLBT
DEBRSV36 EQU   DEBVOLBT
DEBEXFUL EQU   DEBVOLBT
DEBNMTRK EQU   DEBDASD+14
DEBENDHH EQU   DEBDASD+12
DEBENDCC EQU   DEBDASD+10
DEBSTRHH EQU   DEBDASD+8
DEBSTRCC EQU   DEBDASD+6
DEBBINUM EQU   DEBDASD+4
DEBUCBA  EQU   DEBUCBAD+1
DEBDVMOD EQU   DEBUCBAD
DEBAPPB  EQU   DEBAPPAD+1
DEBEXSCL EQU   DEBAPPAD
DEBDCBB  EQU   DEBDCBAD+1
DEBDEBID EQU   DEBPROTG
DEBECBB  EQU   DEBECBAD+1
DEBPRIOR EQU   DEBECBAD
DEBUSRPB EQU   DEBUSRPG+1
DEBNMEXT EQU   DEBUSRPG
DEBRSV05 EQU   DEBBASIC+15
DEBXTNIN EQU   DEBFLGS1
DEBAPFIN EQU   DEBFLGS1
DEBF1CEV EQU   DEBFLGS1
DEBCINDI EQU   DEBFLGS1
DEBRSV02 EQU   DEBFLGS1
DEBRSIOA EQU   DEBFLGS1
DEBEOFDF EQU   DEBFLGS1
DEBPWCKD EQU   DEBFLGS1
DEBQSCNT EQU   DEBBASIC+13
DEBACCS  EQU   DEBOPATB
DEBPOSIT EQU   DEBOPATB
DEBZERO  EQU   DEBOPATB
DEBABEND EQU   DEBOPATB
DEBIRBB  EQU   DEBIRBAD+1
DEBRERR  EQU   DEBOFLGS
DEBLABEL EQU   DEBOFLGS
DEBSPLIT EQU   DEBOFLGS
DEBDCB   EQU   DEBOFLGS
DEBRLSE  EQU   DEBOFLGS
DEBEOF   EQU   DEBOFLGS
DEBDISP  EQU   DEBOFLGS
DEBDEBB  EQU   DEBDEBAD+1
DEBAMLNG EQU   DEBDEBAD
DEBTCBB  EQU   DEBTCBAD+1
DEBNMSUB EQU   DEBTCBAD
UCBERADR EQU   UCBUCS+12
UCBFCBID EQU   UCBUCS+8
UCBERCNT EQU   UCBUCS+7
UCBRSV51 EQU   UCBUCS+6
UCBRSV50 EQU   UCBFCBOP
UCBRSV49 EQU   UCBFCBOP
UCBRSV48 EQU   UCBFCBOP
UCBRSV47 EQU   UCBFCBOP
UCBRSV46 EQU   UCBFCBOP
UCBRSV45 EQU   UCBFCBOP
UCBRSV44 EQU   UCBFCBOP
UCBFCBO1 EQU   UCBFCBOP
UCBUCSPE EQU   UCBUCSOP
UCBRSV43 EQU   UCBUCSOP
UCBRSV42 EQU   UCBUCSOP
UCBRSV41 EQU   UCBUCSOP
UCBRSV40 EQU   UCBUCSOP
UCBRSV39 EQU   UCBUCSOP
UCBUCSO2 EQU   UCBUCSOP
UCBUCSO1 EQU   UCBUCSOP
UCBUCSID EQU   UCBUCS
UCBMDRBA EQU   UCBMDRBF+1
UCBRV075 EQU   UCBMDRBF
UCBRV074 EQU   UCB3800X+32
UCBIMAGE EQU   UCB3800X+28
UCBFCBNM EQU   UCB3800X+24
UCBCHAR4 EQU   UCB3800X+20
UCBCHAR3 EQU   UCB3800X+16
UCBCHAR2 EQU   UCB3800X+12
UCBCHAR1 EQU   UCB3800X+8
UCBCGMID EQU   UCB3800X+4
UCBBRSTA EQU   UCBACTIV
UCBRV063 EQU   UCBACTIV
UCBRV062 EQU   UCBACTIV
UCBRV061 EQU   UCBACTIV
UCBRV060 EQU   UCBACTIV
UCBRV059 EQU   UCBACTIV
UCBRV058 EQU   UCBACTIV
UCBRV057 EQU   UCBACTIV
UCBRV050 EQU   UCB3800X+2
UCBCGMNO EQU   UCB3800X+1
UCBRV083 EQU   UCBOPTNS
UCBBRSTR EQU   UCBOPTNS
UCBRV056 EQU   UCBOPTNS
UCBRV055 EQU   UCBOPTNS
UCBRV054 EQU   UCBOPTNS
UCBRV053 EQU   UCBOPTNS
UCBRV052 EQU   UCBOPTNS
UCBRV051 EQU   UCBOPTNS
UCBRV073 EQU   UCB3540X+7
UCBRV072 EQU   UCBDKBYT
UCBRV071 EQU   UCBDKBYT
UCBRV070 EQU   UCBDKBYT
UCBRV069 EQU   UCBDKBYT
UCBRV068 EQU   UCBDKBYT
UCBRV067 EQU   UCBDKBYT
UCBVLVER EQU   UCBDKBYT
UCBDKAMX EQU   UCBDKBYT
UCBVLSER EQU   UCB3540X
UCBRDATA EQU   UCBOCR+4
UCBFRID  EQU   UCBOCR
UCBCLN   EQU   UCBMT+14
UCBERG   EQU   UCBMT+12
UCBMS    EQU   UCBMT+11
UCBNB    EQU   UCBMT+10
UCBPW    EQU   UCBMT+9
UCBPR    EQU   UCBMT+8
UCBSIO   EQU   UCBMT+6
UCBTW    EQU   UCBMT+5
UCBTR    EQU   UCBMT+4
UCBTWT   EQU   UCBMT+3
UCBTRT   EQU   UCBMT+2
UCBCTD   EQU   UCBMT
UCBWTOID EQU   UCBCMEXT+17
UCBMIHTI EQU   UCBCMEXT+16
UCBASID  EQU   UCBCMEXT+14
UCBMFCNT EQU   UCBCMEXT+12
UCBPMSK  EQU   UCBCMEXT+10
UCBRV041 EQU   UCBCMEXT+6
UCBRV036 EQU   UCBFLP1
UCBRV035 EQU   UCBFLP1
UCBERLOG EQU   UCBFLP1
UCBRV033 EQU   UCBFLP1
UCBINHIO EQU   UCBFLP1
UCBNSWAP EQU   UCBFLP1
UCBSHRUP EQU   UCBFLP1
UCBNSRCH EQU   UCBFLP1
UCBSNSCT EQU   UCBCMEXT+4
UCBHPDV  EQU   @NM00033
UCBHALI  EQU   @NM00033
UCBRSV09 EQU   @NM00033
UCBRSV08 EQU   @NM00033
UCBRSV07 EQU   @NM00033
UCBRSV06 EQU   @NM00033
UCBRSV05 EQU   @NM00033
UCBRSV04 EQU   @NM00033
UCBDTI   EQU   UCBCMEXT+2
UCBSTI   EQU   UCBCMEXT+1
UCBETI   EQU   UCBCMEXT
UCBEXTP  EQU   UCBEXTPT+1
UCBDDRSW EQU   UCBFLC
UCBTICBT EQU   UCBFLC
UCBIVRR  EQU   UCBFLC
UCBIVRS  EQU   UCBFLC
UCBITF   EQU   UCBFLC
UCBUDE   EQU   UCBFLC
UCBWAA   EQU   UCBFLC
UCBATTP  EQU   UCBFLC
UCBUNTYP EQU   UCBTBYT4
UCBRSV11 EQU   UCBDVCLS
UCBRSV10 EQU   UCBDVCLS
UCB3CHAR EQU   UCBDVCLS
UCB3UREC EQU   UCBDVCLS
UCB3DISP EQU   UCBDVCLS
UCB3DACC EQU   UCBDVCLS
UCB3COMM EQU   UCBDVCLS
UCBDVPWR EQU   UCB2OPT7
UCBVLPWR EQU   UCB2OPT6
UCB2OPT5 EQU   UCBTBYT2
UCBRVDEV EQU   UCBRWTAU
UCBRPS   EQU   UCBDUDN2
UCBRR    EQU   UCBDUDN1
UCB2OPT1 EQU   UCBTBYT2
UCB2OPT0 EQU   UCBTBYT2
UCB1FEA7 EQU   UCBTBYT1
UCBD6250 EQU   UCB1FEA6
UCBD1600 EQU   UCB1FEA5
UCB1FEA4 EQU   UCBTBYT1
UCB1FEA3 EQU   UCBTBYT1
UCB1FEA2 EQU   UCBTBYT1
UCB1FEA1 EQU   UCBTBYT1
UCB1FEA0 EQU   UCBTBYT1
UCBRV029 EQU   UCBWGT
UCBVHRSN EQU   UCBWGT
UCBVORSN EQU   UCBWGT
UCBMTPXP EQU   UCBWGT
UCBREW   EQU   UCBWGT
UCBPUB   EQU   UCBWGT
UCBOUT   EQU   UCBWGT
UCBIN    EQU   UCBWGT
UCBCPU   EQU   UCBOB+11
UCBLCI   EQU   UCBOB+10
UCBCNT   EQU   UCBOB+9
UCBRV017 EQU   UCBCHM1
UCBRV016 EQU   UCBCHM1
UCBRV015 EQU   UCBCHM1
UCBRV014 EQU   UCBCHM1
UCBSPB   EQU   UCBPTH1
UCBPPB   EQU   UCBPTH1
UCBSPA   EQU   UCBPTH0
UCBPPA   EQU   UCBPTH0
UCBSIGP  EQU   UCBFLB
UCBVALPH EQU   UCBFLB
UCBCRHSN EQU   UCBFLB
UCBCRHRV EQU   UCBFLB
UCBRESVH EQU   UCBFLB
UCBSPST  EQU   UCBFLB
UCBASNS  EQU   UCBFLB
UCBIORST EQU   UCBFLB
UCBQISCE EQU   UCBFL1
UCBACTV  EQU   UCBFL1
UCBSAP   EQU   UCBFL1
UCBNOTRC EQU   UCBCUB
UCBPSNS  EQU   UCBFL1
UCBUSING EQU   UCBPST
UCBNOTRD EQU   UCBNRY
UCBBUSYD EQU   UCBBSY
UCBUA    EQU   UCBCHAN+1
UCBCHA   EQU   UCBCHAN
UCBDADI  EQU   UCBSTAT
UCBSYSR  EQU   UCBSTAT
UCBPRES  EQU   UCBSTAT
UCBALOC  EQU   UCBSTAT
UCBUNLD  EQU   UCBSTAT
UCBRESV  EQU   UCBSTAT
UCBCHGS  EQU   UCBSTAT
UCBONLI  EQU   UCBSTAT
UCBID    EQU   UCBOB+2
UCBALTPH EQU   UCBFL5
UCBALTCU EQU   UCBFL5
UCBNALOC EQU   UCBFL5
UCBENVRD EQU   UCBFL5
UCBVSDR  EQU   UCBFL5
UCBSASK  EQU   UCBFL5
UCBAMV   EQU   UCBAF
UCBDCC   EQU   UCBFL5
UCBMONT  EQU   UCBJBNR
UCBRV011 EQU   UCBJBNR
UCBMMSGP EQU   UCBJBNR
UCBOLDSM EQU   UCBJBNR
UCBRV003 EQU   UCBJBNR
UCBDUC   EQU   UCBJBNR
UCBJES3  EQU   UCBJBNR
UCBVRDEV EQU   UCBJBNR
UCBCMSEG EQU   UCBOB
UCBPFXND EQU   UCB+512
UCBIOQ   EQU   UCB+508
UCBLOCK  EQU   UCB+504
UCBPXST  EQU   UCB+504
@NM00030 EQU   UCB
IOSEND   EQU   IOSB+108
IOSSKR   EQU   IOSEEK+8
IOSSKH2  EQU   IOSSKHH+1
IOSSKH1  EQU   IOSSKHH
IOSSKCC  EQU   IOSCCHH
IOSSKBB  EQU   IOSEEKA+1
IOSSKM   EQU   IOSEEKA
IOSRES6  EQU   IOSB+96
IOSRES5  EQU   IOSB+92
IOSMDM   EQU   IOSB+91
IOSMDB   EQU   IOSB+90
IOSCKEY7 EQU   IOSCKEY
IOSCKEY6 EQU   IOSCKEY
IOSCKEY5 EQU   IOSCKEY
IOSCKEY4 EQU   IOSCKEY
@NM00026 EQU   IOSCKEY
IOSFMSK  EQU   IOSB+88
IOSCUDEV EQU   IOSPATH+1
@NM00025 EQU   IOSCHN
IOSPATH3 EQU   IOSCHN
IOSPATH2 EQU   IOSCHN
IOSEXP   EQU   IOSCHN
IOSGDP   EQU   IOSCHN
IOSAFF   EQU   IOSB+85
IOSRSS1B EQU   IOSB+84
IOSDSID  EQU   IOSB+80
IOSDIE   EQU   IOSB+68
IOSABN   EQU   IOSB+64
IOSNRM   EQU   IOSB+60
IOSPCI   EQU   IOSB+56
IOSPCHN  EQU   IOSB+48
IOSSNS   EQU   IOSB+42
IOSAPMSK EQU   IOSB+40
IOSRES4A EQU   IOSB+36
IOSUSE   EQU   IOSB+32
IOSSRB   EQU   IOSB+28
IOSCSWRC EQU   IOSCSW+5
IOSTSB   EQU   IOSTATUS+1
IOSTSA   EQU   IOSTATUS
IOSOPT2X EQU   IOSOPT2
IOSIGP   EQU   IOSOPT2
IOSHTP   EQU   IOSOPT2
IOSRELSE EQU   IOSOPT
IOSAPR   EQU   IOSOPT
IOSTSLL  EQU   IOSOPT
IOSNERP  EQU   IOSOPT
IOSPSLL  EQU   IOSOPT
IOSDEP   EQU   IOSOPT
IOSBYP   EQU   IOSOPT
IOSPKY7  EQU   IOSPKEY
IOSPGDPX EQU   IOSPKEY
IOSIDR   EQU   IOSPKEY
IOSLCL   EQU   IOSPKEY
@NM00023 EQU   IOSPKEY
IOSPGAD  EQU   IOSB+8
IOSASID  EQU   IOSB+6
IOSPRLVL EQU   IOSB+5
IOSPROC  EQU   IOSB+3
IOSFLC7  EQU   IOSFLC
IOSCTCNR EQU   IOSFLC
IOSRWAIT EQU   IOSFLC
IOSTP    EQU   IOSFLC
IOSCC3WE EQU   IOSFLC
IOSVERIF EQU   IOSDVALT
IOSDVMNT EQU   IOSFLC
IOSFLB4  EQU   IOSFLB
IOSFLB3  EQU   IOSFLB
IOSNOTRS EQU   IOSFLB
IOSDIESE EQU   IOSFLB
IOSIOSB  EQU   IOSFLA
IOSDOM   EQU   IOSFLA
IOSSMDB  EQU   IOSFLA
IOSSMDA  EQU   IOSFLA
IOCOEND  EQU   IOCOM+128
IOCPATCH EQU   IOCOM+124
IOCUCBBM EQU   IOCOM+120
IOCQCNT  EQU   IOCOM+116
IOCIOSDQ EQU   IOCOM+112
IOCIOSEQ EQU   IOCOM+108
IOCSVCF  EQU   IOCOM+104
IOCTCCW  EQU   IOCOM+100
IOCRSVTB EQU   IOCOM+96
IOCMFCNT EQU   IOCOM+92
IOCMFHK  EQU   IOCOM+88
IOCCCH   EQU   IOCOM+80
IOCASYNQ EQU   IOCOM+76
IOCLCHTB EQU   IOCOM+72
IOCATTBL EQU   IOCOM+68
IOCOMEX  EQU   IOCOM+64
IOCSYNCH EQU   IOCOM+56
IOCCATLK EQU   IOCOM+48
IOCPRGID EQU   IOCOM+44
IOCIOSCP EQU   IOCOM+40
IOCORMGT EQU   IOCOM+36
IOCVOID  EQU   IOCOM+32
IOCSTIO  EQU   IOCOM+28
IOCSCOMP EQU   IOCOM+24
IOCHD160 EQU   IOCOM+20
IOCINT   EQU   IOCOM+16
IOCCTBL  EQU   IOCOM+12
IOCHIO   EQU   IOCOM+8
IOCPST   EQU   IOCOM+4
IOCPGCT  EQU   IOCOM+2
IOCVOICT EQU   IOCOM
EWADDISP EQU   EWA+29
EWADCNT  EQU   EWA+28
EWACPU   EQU   EWA+27
@NM00022 EQU   EWA+26
EWACSEQ  EQU   EWAXCSW2
EWACDIN  EQU   EWAXCSW2
@NM00021 EQU   EWAXCSW2
EWACTEC  EQU   EWAXCSW2
EWACDAV  EQU   EWAXCSW1
EWACCHV  EQU   EWAXCSW1
EWACCMD  EQU   EWAXCSW1
EWACUNS  EQU   EWAXCSW1
EWACSQV  EQU   EWAXCSW1
@NM00020 EQU   EWAXCSW1
EWACITF  EQU   EWAXCSW1
@NM00019 EQU   EWARGFG2
EWACCUE  EQU   EWARGFG2
EWACSTG  EQU   EWARGFG2
EWACSCU  EQU   EWARGFG2
EWACCHA  EQU   EWARGFG2
EWACCPU  EQU   EWARGFG2
EWACCNT  EQU   EWARGFG1
EWACSNS  EQU   EWARGFG1
@NM00018 EQU   EWARGFG1
EWACHIO  EQU   EWARGFG1
EWACTIO  EQU   EWARGFG1
EWACINT  EQU   EWARGFG1
EWACSIO  EQU   EWARGFG1
EWAUCB   EQU   EWAERPIB+1
@NM00017 EQU   EWAERPIB
EWACNTR4 EQU   EWACNTRS+3
EWACNTR3 EQU   EWACNTRS+2
EWASSTAT EQU   EWA+8
EWASCTMX EQU   EWASNSCT
@NM00016 EQU   EWASNSCT
EWAJAM   EQU   EWAFLG3
@NM00015 EQU   EWAFLG2
EWADIR   EQU   EWAFLG2
EWACOVF  EQU   EWAFLG2
EWAMDR   EQU   EWAFLG2
EWADDMSG EQU   EWAFLG1
EWASCC1  EQU   EWASCC3
EWASCC2  EQU   EWASCC3
@NM00014 EQU   EWAFLG1
EWA2SNS  EQU   EWAFLG1
EWASLIS  EQU   EWAFLG1
EWAEXT   EQU   EWAHDR
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00013 EQU   CVTFIX+248
@NM00012 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
CCWCOUNT EQU   CCW+5
@NM00002 EQU   CCWFLAGS
CCWIDA   EQU   CCWFLAGS
CCWPCI   EQU   CCWFLAGS
CCWSKP   EQU   CCWFLAGS
CCWSLI   EQU   CCWFLAGS
CCWCC    EQU   CCWFLAGS
CCWADDR  EQU   CCW+1
APSNCIDS EQU   APSN+6
APSNCIO1 EQU   APSNCIOP+1
APSNCIO0 EQU   APSNCIOP
@NM00106 EQU   APSNCMPN
APSNCPM  EQU   APSNCMPN
APSNCDTC EQU   APSNCMPN
APSNCAE  EQU   APSNCMPN
APSNCIO  EQU   APSNCMPN
APSNCCP  EQU   APSNCMPN
@NM00105 EQU   APSNRQST
APSNINPW EQU   APSNRQST
APSNRQDE EQU   APSNRQST
APSNPRIO EQU   APSNSTND
APSNINIT EQU   APSNSTND
APSNOVRN EQU   APSNSTND
APSNEQCK EQU   APSNSTND
APSNINTV EQU   APSNSTND
APSNCMD  EQU   APSNSTND
@NM00154 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00153 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSALITA  EQU   PSA+764
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00152 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00151 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00150 EQU   FLCFSA
@NM00149 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00148 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00147 EQU   FLCIOA
@NM00146 EQU   FLCMCLA+15
@NM00145 EQU   FLCMCLA+14
@NM00144 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00143 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00142 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00141 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00140 EQU   FLCPER
@NM00139 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00138 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00137 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00136 EQU   FLCPIILC
@NM00135 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00134 EQU   FLCSVILC
@NM00133 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00132 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00131 EQU   FLCICCW2+4
FLCCVT   EQU   FLCICCW2
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00240 EQU   @RC00237
@RC00238 EQU   @RC00237
@RF00249 EQU   @RC00237
@RF00270 EQU   LOGMSG
@RT00276 EQU   LOGMSG
@RT00278 EQU   LOGMSG
@RT00293 EQU   LOGRTRY
@RT00346 EQU   LOGMSG
@RT00348 EQU   LOGMSG
@RF00345 EQU   LOGMSG
@RC00295 EQU   @RC00289
@RF00289 EQU   LOGMSG
@RF00384 EQU   PROGERR
@RF00394 EQU   OK
@RF00460 EQU   LOGMSG
@RT00481 EQU   LOGMSG
@RT00484 EQU   DOITOVER
@RF00484 EQU   LOGMSG
@RC00588 EQU   @RC00585
@RC00599 EQU   @RC00596
@RC00612 EQU   @RC00609
@RC00621 EQU   @RC00620
@RC00634 EQU   @RC00620
@RC00645 EQU   @RC00642
@RF00662 EQU   @RC00660
ENDRSTQB EQU   @EL00004
@RC00296 EQU   @RC00295
@RC00624 EQU   @RC00621
@ENDDATA EQU   *
         END   IGE0003C,(C'PLS0913',0701,77231)
