         TITLE 'IGE0004I, 370X CHANNEL ERP                             *
                        '
IGE0004I CSECT ,                                                01S0001
@PROLOG  DS    0H                                               01S0002
*                                                               02S0280
*   /*****************************************************************/
*   /*                                                               */
*   /* PROLOGUE: THIS SEGMENT COMPLETES THE MODULE PROLOGUE CODE     */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0280
*   RBASE=REG15;                    /* ASSIGN TO THE BASE REGISTER
*                                      THE ENTRY POINT ADDRESS OF THE
*                                      MODULE                        */
         LR    RBASE,REG15                                      02S0280
*   RFY                                                         02S0281
*     REG15 UNRSTD;                                             02S0281
*   GEN CODE NODEFS NOEXIT NOFLOWS REFS(RBASE) SEQFLOW NOSETS;  02S0282
*                                                          /*
         USING IGE0004I,RBASE          INFORM THE ASSEMBLER OF THE
*                                      BASE REGISTER TO BE USED FOR
*                                      ADDRESSING CODE
IGE0004I IEDHJN AFTERHJN,HJN           MODULE IDENTIFICATION MACRO
*                                                               02S0283
*   /*****************************************************************/
*   /*                                                               */
*   /* GPROCESS: THIS IS THE TOP LEVEL SEGMENT OF THE MODULE. IT IS  */
*   /* COMPOSED OF SEGMENTS CONDTEST, PROCCASE, EXITCASE, AND        */
*   /* INTF025C. CONDTEST EVALUATES ERROR CONDITIONS AND DETERMINES  */
*   /* APPROPRIATE ACTION. PROCCASE IS A CASE MACRO WHOSE SUBCASES   */
*   /* SETUP APPROPRIATE ACTION FOR THE VARIOUS ERROR CONDITIONS AND */
*   /* DETERMINE HOW TO EXIT FROM THE MODULE. EXITCASE IS A CASE     */
*   /* MACRO WHOSE SUBCASES EXIT FROM THE MODULE. INTF025C IS A      */
*   /* SUBROUTINE WHICH SETS UP A PERMANENT ERROR EXIT TO IGE0025C   */
*   /* FOR MESSAGE IEA000I AND OBR RECORDING FOR SUBCASES CRETRY AND */
*   /* CPET3 OF PROCCASE.                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0283
*   IOSBPTR=RPARM;                  /* REG 1 CONTAINS IOSB ADDRESS
*                                                            @G36XREB*/
         LR    IOSBPTR,RPARM                                    03S0283
*   RLCB=IOSUSE;                    /* GET LCB ADDRESS FROM IOSB
*                                                            @G36XREB*/
         L     RLCB,IOSUSE(,IOSBPTR)                            03S0284
*/* MAP I/O STATUS FIELDS FROM IOSB INTO LCB(IOB)            @G36XRIB*/
*                                                               03S0285
*   LCBFLAG1=IOSFLA;                /* STATUS BITS           @G36XRIB*/
         MVC   LCBFLAG1(1,RLCB),IOSFLA(IOSBPTR)                 03S0285
*   LCBFLAG2=IOSFLB;                /* STATUS BITS           @G36XRIB*/
         MVC   LCBFLAG2(1,RLCB),IOSFLB(IOSBPTR)                 03S0286
*   LCBECBCC=IOSCOD;                /* ECB COMPLETION CODE   @G36XRIB*/
         MVC   LCBECBCC(1,RLCB),IOSCOD(IOSBPTR)                 03S0287
*   LCBSIOCC=IOSCC;                 /* SIO COMPLETION CODE   @G36XRIB*/
         MVC   LCBSIOCC(1,RLCB),IOSCC(IOSBPTR)                  03S0288
*   LCBCSW=IOSCSW;                  /* CSW                   @G36XRIB*/
         MVC   LCBCSW(7,RLCB),IOSCSW(IOSBPTR)                   03S0289
*   LCBSNS=IOSSNS;                  /* SENSE BYTES           @G36XRIB*/
         MVC   LCBSNS(2,RLCB),IOSSNS(IOSBPTR)                   03S0290
*   IF(LCBSIOC1=RESET&LCBSIOC2=SET) THEN/* SIO COND.CODE 1   @G36XREB*/
         TM    LCBSIOC2(RLCB),B'00010000'                       03S0291
         BNO   @RF00291                                         03S0291
         TM    LCBSIOC1(RLCB),B'00100000'                       03S0291
         BNZ   @RF00291                                         03S0291
*     DO;                           /* YES                   @G36XREB*/
*       LCBCSWCA=LCBSTART+LENGTH(IEDQCCW);/* ..THEN SETUP DUMMY 03S0293
*                                      INTERRUPT ADDRESS     @YM06897*/
         LA    @10,8                                            03S0293
         L     @09,LCBSTART-1(,RLCB)                            03S0293
         LA    @09,0(,@09)                                      03S0293
         ALR   @10,@09                                          03S0293
         STCM  @10,7,LCBCSWCA(RLCB)                             03S0293
*       IOSCSWCA=LCBCSWCA;          /* PUT DUMMY ADDR IN IOSB ALSO
*                                                            @G36XREB*/
         STCM  @10,7,IOSCSWCA(IOSBPTR)                          03S0294
*     END;                          /*                       @G36XREB*/
*   ELSE                                                        03S0296
*     ;                             /*                       @YM06897*/
@RF00291 DS    0H                                               03S0297
*   RPARM=LCBTTCIN;                 /* SETUP PARAMETER FOR IEDQTNT   */
         LH    RPARM,LCBTTCIN(,RLCB)                            03S0297
         N     RPARM,@CF03392                                   03S0297
*   RAVT=TCXAVT;                    /* SET UP AVT POINTER    @YM05691*/
         L     @10,CVTPTR                                       03S0298
         L     @10,TCXPTR(,@10)                                 03S0298
         L     RAVT,TCXAVT(,@10)                                03S0298
*   CALL IEDQTNT;                   /* LINK TO IEDQTNT TO GET NCP TTE
*                                      ADDRESS                       */
         L     @15,AVTRNMPT(,RAVT)                              03S0299
         BALR  @14,@15                                          03S0299
*   RTRM=RPARM-LENGTH(IEDNTRM);     /* BACKUP TTE ADDRESS TO PREFIX
*                                                            @YM04622*/
         LR    RTRM,RPARM                                       03S0300
         SL    RTRM,@CF00035                                    03S0300
*                                                               03S0301
*   /*****************************************************************/
*   /*                                                               */
*   /* GPROCESS.CONDTEST: EVALUATES ERROR CONDITIONS AND DETERMINES  */
*   /* APPROPRIATE ACTION. ASSIGNS AN INDEX TO RPROC FOR CASE        */
*   /* PROCCASE. COMPOSED OF SEGMENTS CONVRV, INITPROC, CONDSIO3, AND*/
*   /* CONDOTHR. CONVRV CONVERTS REAL DATA ADDRESSES TO VIRTUAL ONES */
*   /* IN THE CCWS IN THE CHANNEL PROGRAM. INITPROC DOES INITIAL     */
*   /* PROCESSING-CALLING CHANNEL I/O TRACE OR SAVING ORIGINAL       */
*   /* STATUS. CONDSIO3 HANDLES SIOCC3 STATUS. CONDOTHR HANDLES ALL  */
*   /* OTHER STATUS.                                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                               03S0301
*                                                               04S0301
*   /*****************************************************************/
*   /*                                                               */
*   /* GPROCESS.CONDTEST.CONVRV: CONVERTS REAL DATA ADDRESSES TO     */
*   /* VIRTUAL ADDRESSES IN THE CCWS IN THE INVOKING CHANNEL PROGRAM.*/
*   /*                                                               */
*   /*****************************************************************/
*                                                               04S0301
*   RFY                                                         04S0301
*    (RINT,                                                     04S0301
*     REG10) RSTD;                  /*                       @YM04622*/
*   IF LCBRLAD=SET THEN             /* IF VIRTUAL CHAN PROG THEN
*                                                            @YM04622*/
         TM    LCBRLAD(RLCB),B'00010000'                        04S0302
         BNO   @RF00302                                         04S0302
*     DO;                           /* TRANSLATE REAL TO VIRTUAL
*                                                            @YM04622*/
*       REG10=CVTPTRV;              /* GET ADDRESS OF REAL TO VIRTUAL
*                                      TRANSLATE ROUTINE     @YM04622*/
         L     @07,CVTPTR                                       04S0304
         L     REG10,CVTPTRV(,@07)                              04S0304
*       RINT=LCBCSWCA-LENGTH(IEDQCCW);/* INTERRUPT CCW ADDRESS  04S0305
*                                                            @YM04622*/
         L     RINT,LCBCSWCA-1(,RLCB)                           04S0305
         LA    RINT,0(,RINT)                                    04S0305
         SL    RINT,@CF00045                                    04S0305
*       IF TRMIPLDM=SET|            /* IF IPL/DUMP IN PROGRESS ...
*                                                            @YM04622*/
*           LCBSTAT1=AVTEFF THEN    /* ... OR CLOSE CHAN PROG THEN
*                                                            @YM04622*/
         TM    TRMIPLDM(RTRM),B'10000000'                       04S0306
         BO    @RT00306                                         04S0306
         CLI   LCBSTAT1(RLCB),X'FF'                             04S0306
         BNE   @RF00306                                         04S0306
@RT00306 DS    0H                                               04S0307
*         RCCW=LCBSTART;            /* BEGIN TRANSLATION WITH FIRST
*                                      CCW                   @YM04622*/
         L     RCCW,LCBSTART-1(,RLCB)                           04S0307
         LA    RCCW,0(,RCCW)                                    04S0307
*       ELSE                        /*                       @YM04622*/
*         DO;                       /* ELSE DETERMINE WHICH CCWS NEED
*                                      TRANSLATION           @YM04622*/
         B     @RC00306                                         04S0308
@RF00306 DS    0H                                               04S0309
*           RPARM=RLCB+DCBEIOBX;    /* POINT TO END OF LCB   @YM04622*/
         L     @07,LCBDCBPT(,RLCB)                              04S0309
         LR    RPARM,RLCB                                       04S0309
         SLR   @05,@05                                          04S0309
         IC    @05,DCBEIOBX+20(,@07)                            04S0309
         ALR   RPARM,@05                                        04S0309
*           IF RINT>=RLCB&          /* IF INTERRUPT CCW IS IN THE LCB
*                                                            @YM04622*/
*               RINT<RPARM&         /*                       @YM04622*/
*               RINT^=ADDR(LCBCCW7) THEN/* BUT NOT NOP CCW AFTER
*                                      READS THEN            @YM04622*/
         CR    RINT,RLCB                                        04S0310
         BL    @RF00310                                         04S0310
         CR    RINT,RPARM                                       04S0310
         BNL   @RF00310                                         04S0310
         LA    @07,LCBCCW7(,RLCB)                               04S0310
         CR    RINT,@07                                         04S0310
         BE    @RF00310                                         04S0310
*             RINT=ZERO;            /* THEN INDICATE NO READ CCW
*                                      TRANSLATION           @YM04622*/
         SLR   RINT,RINT                                        04S0311
*           RCCW=ADDR(LCBCCW2);     /* ASSUME SENDING        @YM04622*/
@RF00310 LA    RCCW,LCBCCW2(,RLCB)                              04S0312
*           IF LCBSENDN=RESET THEN  /* IF NOT SENDING THEN ...  04S0313
*                                                            @YM04622*/
         TM    LCBSENDN(RLCB),B'00000001'                       04S0313
         BNZ   @RF00313                                         04S0313
*             RCCW=ADDR(LCBCCW4);   /* ... ASSUME READING    @YM04622*/
         LA    RCCW,LCBCCW4(,RLCB)                              04S0314
*         END;                      /*                       @YM04622*/
@RF00313 DS    0H                                               04S0316
*       DO WHILE LCBRLAD=SET;       /* TRANSLATE CCWS WHILE ANY ARE
*                                      REAL                          */
@RC00306 B     @DE00316                                         04S0316
@DL00316 DS    0H                                               04S0317
*         RPARM=CCWADDR;            /* GET CCW DATA ADDRESS          */
         SLR   RPARM,RPARM                                      04S0317
         ICM   RPARM,7,CCWADDR(RCCW)                            04S0317
*         CALL CONVRV;              /* CALL CONVERT ROUTINE          */
         LR    @15,REG10                                        04S0318
         BALR  @14,@15                                          04S0318
*         RFY                                                   04S0319
*           REG15 RSTD;                                         04S0319
*         IF REG15^=ZERO            /* IF ERROR ON CONVERSION        */
*           THEN                                                04S0320
         LTR   REG15,REG15                                      04S0320
         BZ    @RF00320                                         04S0320
*           GEN CODE( DC    H'0')                               04S0321
*           NODEFS EXIT NOFLOWS NOREFS NOSEQFLOW NOSETS;/*      04S0321
*                                      INTENTIONAL PROGRAM CHECK     */
          DC    H'0'
*         ELSE                                                  04S0322
*           ;                                                   04S0322
@RF00320 DS    0H                                               04S0323
*         RFY                                                   04S0323
*           REG15 UNRSTD;                                       04S0323
*         CCWADDR=RPARM;            /* UPDATE CCW DATA ADDRESS WITH
*                                      VIRTUAL ADDR                  */
         STCM  RPARM,7,CCWADDR(RCCW)                            04S0324
*         IF RCCW=RINT&             /* IF THIS IS THE INTERRUPT CCW
*                                      ...                   @YM04622*/
*             TRMIPLDM^=SET THEN    /* AND NOT IN IPL/DUMP PROCESS
*                                                            @YM04622*/
         CR    RCCW,RINT                                        04S0325
         BNE   @RF00325                                         04S0325
         TM    TRMIPLDM(RTRM),B'10000000'                       04S0325
         BO    @RF00325                                         04S0325
*           RINT=ZERO;              /* SET INDICATION THAT INTERRUPT
*                                      CCW HAS BEEN TRANSLATED  04S0326
*                                                            @YM04622*/
         SLR   RINT,RINT                                        04S0326
*         IF NOTTIC1=RESET&         /* IS COMMAND ...        @YM04622*/
*             NOTTIC2=RESET&        /* ... A ...             @YM04622*/
*             NOTTIC3=RESET THEN    /* ... TIC               @YM04622*/
@RF00325 TM    NOTTIC1(RCCW),B'00000111'                        04S0327
         BNZ   @RF00327                                         04S0327
*           DO;                     /*                       @YM04622*/
*             CCWOPCDE=CCWTIC;      /* INDICATE CCW CONTAINS VIRTUAL
*                                      ADDRESSES             @YM04622*/
         MVI   CCWOPCDE(RCCW),X'08'                             04S0329
*             RCCW=RPARM;           /* THEN GET ADDR OF CCW THAT IS
*                                      TIC'ED TO                     */
         LR    RCCW,RPARM                                       04S0330
*             IF CCWOPCDE=CCWREAD THEN/* IF THIS IS A READ CCW ...
*                                                            @YM04622*/
         CLI   CCWOPCDE(RCCW),X'02'                             04S0331
         BNE   @RF00331                                         04S0331
*               IF RINT=ZERO THEN   /* ... AND THE INTERRUPT CCW HAS
*                                      BEEN TRANSLATED       @YM04622*/
         LTR   RINT,RINT                                        04S0332
         BNZ   @RF00332                                         04S0332
*                 LCBRLAD=RESET;    /* INDICATE TRANSLATION COMPLETE
*                                                            @YM04622*/
         NI    LCBRLAD(RLCB),B'11101111'                        04S0333
*               ELSE                                            04S0334
*                 ;                 /*                       @YM04622*/
@RF00332 DS    0H                                               04S0335
*             ELSE                  /*                       @YM04622*/
*               IF RCCW=ADDR(LCBCCW3) THEN/* IF TIC TO READ START ...
*                                                            @YM06637*/
         B     @RC00331                                         04S0335
@RF00331 LA    @07,LCBCCW3(,RLCB)                               04S0335
         CR    RCCW,@07                                         04S0335
         BNE   @RF00335                                         04S0335
*                 RCCW=ADDR(LCBCCW4);/* ... TRANSLATE TIC TO READ
*                                      BUFFER                @YM06637*/
         LA    RCCW,LCBCCW4(,RLCB)                              04S0336
*               ELSE                /*                       @YM06637*/
*                 IF CCWOPCDE=CCWNOP THEN/* IF TIC TO A NOP, FINISHED
*                                                            @YM04622*/
         B     @RC00335                                         04S0337
@RF00335 CLI   CCWOPCDE(RCCW),X'03'                             04S0337
         BNE   @RF00337                                         04S0337
*                   LCBRLAD=RESET;  /* END OF TRANSLATION    @YM04622*/
         NI    LCBRLAD(RLCB),B'11101111'                        04S0338
*           END;                    /*                       @YM04622*/
*         ELSE                      /*                       @YM06637*/
*           RCCW=RCCW+LENGTH(IEDQCCW);/* NEXT CCW FOLLOWS THIS CCW   */
         B     @RC00327                                         04S0340
@RF00327 AL    RCCW,@CF00045                                    04S0340
*         IF CCWCC=SET|             /* IF COMMAND CHAINING ...  04S0341
*                                                            @YM06637*/
*             CCWCD=SET THEN                                    04S0341
@RC00327 TM    CCWCC(RCCW),B'11000000'                          04S0341
         BNZ   @RT00341                                         04S0341
*           ;                       /* ... OR DATA CHAINING THEN
*                                      TRANSLATE             @YM06637*/
*         ELSE                      /*                       @YM06637*/
*           IF TRMIPLDM=SET|        /* IF IPL/DUMP IN PROGRESS ...
*                                                            @YM06637*/
*               LCBSTAT1=AVTEFF THEN/* ... OR TCAM CLOSEDOWN @YM06637*/
         TM    TRMIPLDM(RTRM),B'10000000'                       04S0343
         BO    @RT00343                                         04S0343
         CLI   LCBSTAT1(RLCB),X'FF'                             04S0343
         BNE   @RF00343                                         04S0343
@RT00343 DS    0H                                               04S0344
*             LCBRLAD=RESET;        /* THEN TRANSLATION IS COMPLETE
*                                                            @YM06637*/
         NI    LCBRLAD(RLCB),B'11101111'                        04S0344
*       END;                                                    04S0345
@RF00343 DS    0H                                               04S0345
@RT00341 DS    0H                                               04S0345
@DE00316 TM    LCBRLAD(RLCB),B'00010000'                        04S0345
         BO    @DL00316                                         04S0345
*     END;                          /*                       @YM04622*/
*                                                               04S0347
*   /*****************************************************************/
*   /*                                                               */
*   /* GPROCESS.CONDTEST.INITPROC: IF SUBSEQUENT ENTRY FOR A CHANNEL */
*   /* PROGRAM, INVOKES CHANNEL I/O TRACE--OTHERWISE SAVES ORIGINAL  */
*   /* STATUS.                                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                               04S0347
*   RPROC=ZERO;                     /* INITIALIZE PROCESS VARIABLE   */
@RF00302 SLR   RPROC,RPROC                                      04S0347
*   IF IOSERR=SET                   /* IS THIS SUBSEQUENT ENTRY FOR
*                                      THE SAME CHANNEL PROGRAM?
*                                                            @G36XREB*/
*     THEN                                                      04S0348
         TM    IOSERR(IOSBPTR),B'00100000'                      04S0348
         BNO   @RF00348                                         04S0348
*     IF AVTIOT^=ZERO               /* IS CHANNEL I/O TRACE IN THE
*                                      SYSTEM?                       */
*       THEN                                                    04S0349
         L     @07,AVTIOT(,RAVT)                                04S0349
         LTR   @07,@07                                          04S0349
         BZ    @RF00349                                         04S0349
*       DO;                         /* YES                   @G36XREB*/
*         IEDRQE=''B;               /* CLEAR DUMMY RQE       @ZM47653*/
         LA    @07,32                                           04S0351
         L     @05,EWAPTR(,IOSBPTR)                             04S0351
         ALR   @05,@07                                          04S0351
         XC    IEDRQE(20,@05),IEDRQE(@05)                       04S0351
*         RQEUCB=DIOSUCBP;          /* GET UCB ADDRESS FROM IOSB
*                                                            @G36XREB*/
         LH    @00,DIOSUCBP(,IOSBPTR)                           04S0352
         N     @00,@CF03392                                     04S0352
         STH   @00,RQEUCB(,@05)                                 04S0352
*         RQEIOB=RLCB+(ADDR(LCBFLAG1)-ADDR(IEDQLCB));/* CALCULATE IOB
*                                      ADDRESS               @G36XREB*/
         ALR   @07,RLCB                                         04S0353
         STCM  @07,7,RQEIOB(@05)                                04S0353
*         GEN REFS(PSALITA,FLC) SETS(REG00,REG01,REG15);        04S0354
*                                   /*
SETERP   SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,REGS=USE,       @ZM47653C
               RELATED=CHANNEL-PROGRAM-IGE0004G(SETERP)-       @ZM47653C
               IGE0004H(SETERP)-IGG019QE(SETERP)-              @ZM47653C
               IEDQGT(SETTRAN)-IEDQGA(SETASSC-SETCONC)-        @ZM47653C
               'PCI,CHANNELEND,AND STARTIO APPENDAGES ARE      @ZM47653C
               LOCKED ON THIS RESOURCE VIA EXCP(270X) OR       @ZM47653C
               IOS(370X) (ERP,BUFFER ASSOCIATION AND CCW BUILD @ZM47653C
               MUST ISSUE OWN SETLOCK)'                        @ZM47653
*         RPARM=ADDR(IEDRQE);       /* ADDRESS OF RQE IN REG 1  04S0355
*                                                            @G36XREB*/
         LA    RPARM,32                                         04S0355
         AL    RPARM,EWAPTR(,IOSBPTR)                           04S0355
*         CALL IGG019Q0;            /* GO DO CHANNEL I/O TRACE  04S0356
*                                                            @G36XREB*/
         L     @15,AVTIOT(,RAVT)                                04S0356
         BALR  @14,@15                                          04S0356
*         GEN REFS(PSALITA,FLC) SETS(REG00,REG01,REG15);        04S0357
*                                   /*
         SETLOCK RELEASE,TYPE=LOCAL,REGS=USE,                  @ZM47653C
               RELATED=CHANNEL-PROGRAM-IGE0004I(SETERP)        @ZM47653
*         IEDRQE=''B;               /* DUMMY RQE IN ERP WORKAREA
*                                                            @ZM47653*/
         L     @07,EWAPTR(,IOSBPTR)                             04S0358
         XC    IEDRQE+32(20,@07),IEDRQE+32(@07)                 04S0358
*       END;                        /*                       @G36XREB*/
*     ELSE                                                      04S0360
*       ;                                                       04S0360
@RF00349 DS    0H                                               04S0361
*   ELSE                                                        04S0361
*     DO;                           /* FIRST ENTRY INTO ERP FOR THIS
*                                      CHANNEL PROGRAM               */
         B     @RC00348                                         04S0361
@RF00348 DS    0H                                               04S0362
*       LCBSTSAV=LCBSTART;          /* SAVE CP START ADDRESS         */
         MVC   LCBSTSAV(3,RLCB),LCBSTART(RLCB)                  04S0362
*       LCBSNSV=LCBSENS0;           /* SAVE ORIGINAL SENSE           */
         MVC   LCBSNSV(1,RLCB),LCBSENS0(RLCB)                   04S0363
*       LCBCSWSV=LCBCSW;            /* SAVE ORIGINAL CSW             */
         MVC   LCBCSWSV(7,RLCB),LCBCSW(RLCB)                    04S0364
*       OPCDESAV=(LCBCSWCA-LENGTH(IEDQCCW))->CCWOPCDE;/* SAVE COMMAND
*                                      ON WHICH ERROR OCCURRED  04S0365
*                                                            @YM08537*/
         L     @07,LCBCSWCA-1(,RLCB)                            04S0365
         AL    @07,@CF03394                                     04S0365
         MVC   OPCDESAV(1,RLCB),CCWOPCDE(@07)                   04S0365
*     END;                                                      04S0366
*   IF LCBSTAT1=AVTEFF THEN         /* IF TCAM CLOSEDOWN ... @YM07000*/
@RC00348 CLI   LCBSTAT1(RLCB),X'FF'                             03S0367
         BNE   @RF00367                                         03S0367
*     RPROC=GRETRY;                 /* ... IGNORE ANY ERRORS, DO MDR
*                                      PROCESSING            @YM07000*/
         LA    RPROC,5                                          03S0368
*   ELSE                            /*                       @YM07000*/
*     IF LCBSIOC1=SET&LCBSIOC2=SET  /* IF SIOCC3                     */
*       THEN                                                    03S0369
         B     @RC00367                                         03S0369
@RF00367 TM    LCBSIOC1(RLCB),B'00110000'                       03S0369
         BNO   @RF00369                                         03S0369
*                                                               04S0370
*       /*************************************************************/
*       /*                                                           */
*       /* GPROCESS.CONDTEST.CONDSIO3: DOES INITIAL PROCESSING FOR   */
*       /* SIO CONDITION CODE 3 STATUS.                              */
*       /*                                                           */
*       /*************************************************************/
*                                                               04S0370
*       DO;                                                     04S0370
*         RTCX=CVTAQAVT;            /* TCX ADDRESS           @G36XREB*/
         L     @07,CVTPTR                                       04S0371
         L     RTCX,CVTAQAVT(,@07)                              04S0371
*         GEN REFS(TCXCC3TS,RTCX,REG13,TCXESAVE,IOSUCB,IOSBPTR,RPARM,
*             TCXERPPM);                                        04S0372
*                       /*                                   @G36XREB*/
CC3LOOP  EQU   *                                               @G36XREB
         TS    TCXCC3TS(RTCX)      RESERVE SAVE AREA IN TCX    @G36XREB
         BNZ   CC3LOOP             LOOP TILL TCX AVAILABLE     @G36XREB
         LA    REG13,TCXESAVE(RTCX) SAVE AREA FOR IECVIOPM     @G36XREB
         L     RPARM,IOSUCB(IOSBPTR) UCB ADDRESS               @G36XREB
         LA    RPARM,0(RPARM)      CLEAR HO BYTE               @G36XREB
         ST    RPARM,TCXERPPM(RTCX) SET PARM LIST              @G36XREB
         LA    RPARM,TCXERPPM(RTCX) PARM LIST ADDR             @G36XREB
         LINK  EP=IECVIOPM,MF=(E,(1)) CHECK AVAIL PATHS        @G36XREB
         MVI   TCXCC3TS(RTCX),0    CLEAR TS LOCK               @G36XREB
*         IF REG15=0 THEN           /* ALTERNATE PATH AVAILABLE 04S0373
*                                                            @G36XREB*/
         LTR   REG15,REG15                                      04S0373
         BNZ   @RF00373                                         04S0373
*           RPROC=RETRY;            /* YES, RETRY I/O        @G36XREB*/
         LA    RPROC,1                                          04S0374
*         ELSE                      /* ALTERNATE PATH NOT AVAILABLE
*                                                            @G36XREB*/
*           DO;                     /*                       @G36XREB*/
         B     @RC00373                                         04S0375
@RF00373 DS    0H                                               04S0376
*             LCBNX064=SET;         /* TELL QNX TO PRINT IED064 MSG
*                                                            @G36XREB*/
         OI    LCBNX064(RLCB),B'10000000'                       04S0376
*             MSG064=MSG064L;       /* MOVE WTO LIST TO WORK AREA TO
*                                      MAKE REENTRENT        @ZM47653*/
         L     @07,EWAPTR(,IOSBPTR)                             04S0377
         MVC   MSG064(49,@07),MSG064L                           04S0377
*             M064CUA=UCBNAME;      /* INSERT UCB NAME IN MSG   04S0378
*                                                            @G36XREB*/
         L     @05,UCBPTR(,IOSBPTR)                             04S0378
         MVC   M064CUA(3,@07),UCBNAME(@05)                      04S0378
*             RPARM=ADDR(MSG064);   /* MSG ADDRESS           @G36XREB*/
         LA    RPARM,MSG064(,@07)                               04S0379
*             GEN(WTO  MF=(E,(1))); /* WRITE MSG IED064 TO SYSTEM
*                                      OPERATOR              @G36XREB*/
         WTO  MF=(E,(1))
*             MSG064=''B;           /* CLEAR WTO IN WORKAREA @ZM47653*/
         L     @07,EWAPTR(,IOSBPTR)                             04S0381
         XC    MSG064(49,@07),MSG064(@07)                       04S0381
*             RPROC=PET2;           /* PERMANENT ERROR PROCESSING
*                                                            @G36XREB*/
         LA    RPROC,3                                          04S0382
*           END;                    /*                       @G36XREB*/
*       END;                                                    04S0384
*     ELSE                                                      03S0385
*                                                               04S0385
*       /*************************************************************/
*       /*                                                           */
*       /* GPROCESS.CONDTEST.CONDOTHR: DOES INITIAL PROCESSING FOR   */
*       /* ALL CONDITIONS EXCEPT SIOCC3.                             */
*       /*                                                           */
*       /*************************************************************/
*                                                               04S0385
*       DO;                                                     04S0385
         B     @RC00369                                         04S0385
@RF00369 DS    0H                                               04S0386
*         IF(LCBSIOC1=RESET&LCBSIOC2=SET&LCBUSUC=SET)|(LCBSIOC1=RESET&
*             LCBSIOC2=RESET)       /* IF SIO CONDITION CODE 1 AND
*                                      UNIT CHECK OR SIO CONDITION
*                                      CODE 0                @YM06897*/
*           THEN                                                04S0386
         TM    LCBSIOC2(RLCB),B'00010000'                       04S0386
         BNO   @GL00006                                         04S0386
         TM    LCBSIOC1(RLCB),B'00100000'                       04S0386
         BNZ   @GL00006                                         04S0386
         TM    LCBUSUC(RLCB),B'00000010'                        04S0386
         BO    @RT00386                                         04S0386
@GL00006 TM    LCBSIOC1(RLCB),B'00110000'                       04S0386
         BNZ   @RF00386                                         04S0386
@RT00386 DS    0H                                               04S0387
*           DO;                     /* ..THEN PROCESS POSSIBLY  04S0387
*                                      RECOVERABLE ERRORS    @YM06897*/
*             IF LCBCSCDC=SET|LCBCSCCC=SET|LCBCSICC=SET/* IF CHANNEL
*                                      DATA CHECK OR CHANNEL CONTROL
*                                      CHECK OR INTERFACE CONTROL
*                                      CHECK                         */
*               THEN                                            04S0388
         TM    LCBCSCDC(RLCB),B'00001110'                       04S0388
         BZ    @RF00388                                         04S0388
*               RPROC=RETRY;        /* SETUP RETRY PROCESSING        */
         LA    RPROC,1                                          04S0389
*             ELSE                                              04S0390
*               IF LCBUSUC=SET      /* IF UNIT CHECK                 */
*                 THEN                                          04S0390
         B     @RC00388                                         04S0390
@RF00388 TM    LCBUSUC(RLCB),B'00000010'                        04S0390
         BNO   @RF00390                                         04S0390
*                 DO;                                           04S0391
*                   IF LCBINTRQ=SET|LCBNOTIN=SET/* IF INTERVENTION
*                                      REQUIRED OR NOT INITIALIZED   */
*                     THEN                                      04S0392
         TM    LCBINTRQ(RLCB),B'01000010'                       04S0392
         BZ    @RF00392                                         04S0392
*                     DO;                                       04S0393
*                       LCBNX142=SET;/* TELL IEDQNX TO WRITE MESSAGE
*                                      IED142                        */
         OI    LCBNX142(RLCB),B'01000000'                       04S0394
*                       RPROC=PET3; /* SETUP PERMANENT ERROR    04S0395
*                                      PROCESSING(TYPE 3)            */
         LA    RPROC,4                                          04S0395
*                     END;                                      04S0396
*                   ELSE                                        04S0397
*                     IF LCBEQUCK=SET|LCBBUSCK=SET|LCBDATCK=SET|
*                         LCBOVRUN=SET|LCBCMDRJ=SET/* IF EQUIPMENT
*                                      CHECK OR BUSOUT CHECK OR DATA
*                                      CHECK OR OVERRUN OR COMMAND
*                                      REJECT                        */
*                       THEN                                    04S0397
         B     @RC00392                                         04S0397
@RF00392 TM    LCBEQUCK(RLCB),B'10111100'                       04S0397
         BZ    @RF00397                                         04S0397
*                       RPROC=RETRY;/* SETUP RETRY PROCESSING        */
         LA    RPROC,1                                          04S0398
*                     ELSE                                      04S0399
*                       RPROC=GRETRY;/* MUST BE UC(ABORT) STATUS-EXIT
*                                      TO IGG019TH WITH NORMAL  04S0399
*                                      COMPLETION INDICATED          */
         B     @RC00397                                         04S0399
@RF00397 LA    RPROC,5                                          04S0399
*                 END;                                          04S0400
*               ELSE                                            04S0401
*                 IF LCBCSPGC=SET|LCBCSPTC=SET|LCBCSCHC=SET|LCBCSPCI=
*                     SET|LCBCSIL=SET/* IF PROGRAM CHECK OR     04S0401
*                                      PROTECTION CHECK OR CHAINING
*                                      CHECK OR PROGRAM-CONTROLLED
*                                      INTERRUPTION OR INCORRECT
*                                      LENGTH                        */
*                   THEN                                        04S0401
         B     @RC00390                                         04S0401
@RF00390 TM    LCBCSPGC(RLCB),B'11110001'                       04S0401
         BZ    @RF00401                                         04S0401
*                   RPROC=RETRY;    /* SETUP RETRY PROCESSING        */
         LA    RPROC,1                                          04S0402
*                 ELSE                                          04S0403
*                   IF IOSERR=SET   /* THERE ARE NO ERRORS ACCORDING
*                                      TO THE VARIOUS STATUS    04S0403
*                                      INDICATORS-IF THIS IS    04S0403
*                                      SUBSEQUENT ENTRY FOR SAME CP
*                                                            @G36XREB*/
*                     THEN                                      04S0403
         B     @RC00401                                         04S0403
@RF00401 TM    IOSERR(IOSBPTR),B'00100000'                      04S0403
         BNO   @RF00403                                         04S0403
*                     RPROC=GRETRY; /* SETUP GOOD RETRY PROCESSING   */
         LA    RPROC,5                                          04S0404
*                   ELSE                                        04S0405
*                     RPROC=MDREXIT;/* BY DEFAULT 4I WAS INVOKED TO
*                                      INVOKE 904I(MDR PROCESSOR) SO
*                                      SETUP MDR EXIT PROCESSING     */
         B     @RC00403                                         04S0405
@RF00403 LA    RPROC,6                                          04S0405
*           END;                    /*                       @YM06897*/
*         ELSE                                                  04S0407
*           DO;                     /* ..ELSE DECLARE PERMANENT ERROR
*                                      BECAUSE THERE MUST HAVE BEEN A
*                                      SOFTWARE ERROR SOMEWHERE 04S0407
*                                                            @YM06897*/
         B     @RC00386                                         04S0407
@RF00386 DS    0H                                               04S0408
*             LCBNX162=SET;         /* TELL IEDQNX THAT WE WANT MSG
*                                      IED162I WRITTEN       @YM06897*/
         OI    LCBNX162(RLCB),B'00100000'                       04S0408
*             RPROC=PET3;           /* SETUP PERMANENT ERROR TYPE 3
*                                      PROCESSING            @YM06897*/
         LA    RPROC,4                                          04S0409
*           END;                    /*                       @YM06897*/
*       END;                                                    04S0411
@RC00386 DS    0H                                               04S0412
*                                                               03S0412
*   /*****************************************************************/
*   /*                                                               */
*   /* GPROCESS.PROCCASE: A CASE MACRO WHOSE SUBCASES SETUP          */
*   /* APPROPRIATE ACTION FOR THE VARIOUS ERROR CONDITIONS AND       */
*   /* DETERMINE HOW TO EXIT FROM THE MODULE. THE SEGMENT IS COMPOSED*/
*   /* OF SUBCASE SEGMENTS. THE SUBCASES ASSIGN AN INDEX TO REXIT FOR*/
*   /* CASE EXITCASE.                                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                               03S0412
*   DO;                             /* CASE(RPROC)NAMES(CRETRY,CPET1,
*                                      CPET2,CPET3,CGRETRY,CMDREXIT) */
@RC00369 DS    0H                                               03S0412
@RC00367 DS    0H                                               03S0413
*     DCL                                                       03S0413
*       CL0001@ LABEL BASED(CP0001@(RPROC)) VALUERANGE(CRETRY,CPET1,
*           CPET2,CPET3,CGRETRY,CMDREXIT);/* BRANCH TARGET           */
*     DCL                                                       03S0414
*       CP0001@(6) PTR(31) INIT(ADDR(CRETRY),ADDR(CPET1),ADDR(CPET2),
*           ADDR(CPET3),ADDR(CGRETRY),ADDR(CMDREXIT));          03S0414
*     GOTO CL0001@;                 /* BRANCH TO SELECTED CASE  03S0415
*                                      PROCESSING CASE               */
         LR    @07,RPROC                                        03S0415
         SLA   @07,2                                            03S0415
         L     @07,CP0001@-4(@07)                               03S0415
         BR    @07                                              03S0415
*                                                               04S0416
*     /***************************************************************/
*     /*                                                             */
*     /* GPROCESS.PROCCASE.CRETRY: SETS UP RETRY ACTION(EXIT VIA     */
*     /* ERROR EXCP) OR PERMANENT ERROR ACTION(EXIT TO IGE0025C FOR  */
*     /* MESSAGE IEA000I AND OBR RECORDING) IF RETRY LIMIT EXCEEDED. */
*     /*                                                             */
*     /***************************************************************/
*                                                               04S0416
*CRETRY:                                                        04S0416
*     DO;                           /* SUBCASE RETRY PROCESSING      */
CRETRY   DS    0H                                               04S0417
*       LCBINCAM=LCBINCAM+1;        /* INCREMENT RETRY COUNTER       */
         LA    @07,1                                            04S0417
         AH    @07,LCBINCAM(,RLCB)                              04S0417
         STH   @07,LCBINCAM(,RLCB)                              04S0417
*       IF LCBINCAM>RETRYLIM        /* IF RETRY HAS BEEN PERFORMED
*                                      THE MAXIMUM NUMBER OF TIMES   */
*         THEN                                                  04S0418
         C     @07,@CF00074                                     04S0418
         BNH   @RF00418                                         04S0418
*         DO;                                                   04S0419
*           LCBNX162=SET;           /* TELL IEDQNX TO WRITE MESSAGE
*                                      IED162                        */
         OI    LCBNX162(RLCB),B'00100000'                       04S0420
*           CALL INTF025C;          /* SETUP PARAMETERS FOR EXIT TO
*                                      IGE0025C                      */
         LA    @15,INTF025C                                     04S0421
         BALR  @14,@15                                          04S0421
*           IOSERR=OFF;             /* INDICATE PERMANENT... @G36XREB*/
*           IOSEX=ON;               /* ...ERROR              @G36XREB*/
         OI    IOSEX(IOSBPTR),B'00000100'                       04S0423
         NI    IOSERR(IOSBPTR),B'11011111'                      04S0423
*           RPARM=IOSBPTR;          /* IOSB ADDRESS          @G36XREB*/
         LR    RPARM,IOSBPTR                                    04S0424
*           REG13=XCTL025C;         /* IGE0025C ID           @G36XREB*/
         LA    REG13,253                                        04S0425
*           REG14=CVTXTLER;         /* XCTL ROUTINE ADDRESS  @G36XREB*/
         L     @07,CVTPTR                                       04S0426
         L     REG14,CVTXTLER(,@07)                             04S0426
*           GEN(BR REG14);          /* XCTL TO MESSAGE WRITER   04S0427
*                                                            @G36XREB*/
         BR REG14
*         END;                                                  04S0428
*       ELSE                                                    04S0429
*         DO;                       /* RETRY LIMIT HAS NOT BEEN 04S0429
*                                      EXCEEDED-RETRY AGAIN          */
         B     @RC00418                                         04S0429
@RF00418 DS    0H                                               04S0430
*           RCCW=LCBCSWCA-LENGTH(IEDQCCW);/* GET ADDRESS OF INTERRUPT
*                                      CCW                           */
         L     RCCW,LCBCSWCA-1(,RLCB)                           04S0430
         LA    RCCW,0(,RCCW)                                    04S0430
         SL    RCCW,@CF00045                                    04S0430
*           IF CCWOPCDE=CCWREAD|CCWOPCDE=CCWRS0|CCWOPCDE=CCWRS1/* IF
*                                      INTERRUPT CCW WAS READ START
*                                      OR READ                       */
*             THEN                                              04S0431
         CLI   CCWOPCDE(RCCW),X'02'                             04S0431
         BE    @RT00431                                         04S0431
         CLI   CCWOPCDE(RCCW),X'32'                             04S0431
         BE    @RT00431                                         04S0431
         CLI   CCWOPCDE(RCCW),X'52'                             04S0431
         BNE   @RF00431                                         04S0431
@RT00431 DS    0H                                               04S0432
*             DO;                                               04S0432
*               IF TRMIPLDM=RESET   /* IF IPL AND DUMP ARE NOT IN
*                                      PROGRESS                      */
*                 THEN                                          04S0433
         TM    TRMIPLDM(RTRM),B'10000000'                       04S0433
         BNZ   @RF00433                                         04S0433
*                 LCBSTART=ADDR(LCBCCW3);/* RESTART ON READ START    */
         LA    @07,LCBCCW3(,RLCB)                               04S0434
         STCM  @07,7,LCBSTART(RLCB)                             04S0434
*               ELSE                                            04S0435
*                 ;                 /* RESTART ON WRITE START        */
@RF00433 DS    0H                                               04S0436
*             END;                                              04S0436
*           ELSE                                                04S0437
*             ;                                                 04S0437
@RF00431 DS    0H                                               04S0438
*           IOSVST=LCBSTART;        /* START OF RETRY CHANNEL PROGRAM
*                                                            @G36XREB*/
         L     @07,LCBSTART-1(,RLCB)                            04S0438
         LA    @07,0(,@07)                                      04S0438
         ST    @07,IOSVST(,IOSBPTR)                             04S0438
*           RPARM=IOSVST;           /* GET REAL ADDRESS OF...   04S0439
*                                                            @ZM47867*/
         LR    RPARM,@07                                        04S0439
*           GEN(LRA   RPARM,0(RPARM));/* ...CHANNEL PROGRAM  @G36XREB*/
         LRA   RPARM,0(RPARM)
*           IOSRST=RPARM;           /* PUT REAL ADDR IN IOSB @G36XREB*/
         ST    RPARM,IOSRST(,IOSBPTR)                           04S0441
*           RPARM=IOSBPTR;          /* IOSB ADDRESS          @G36XREB*/
         LR    RPARM,IOSBPTR                                    04S0442
*           CALL SIOAPNG;           /* CALL START I/O APPENDAGE TO
*                                      CONVERT CHANNEL PROGRAM FROM
*                                      VIETUAL TO REAL       @G36XREB*/
         L     @07,IEDQDPTR(,IOSBPTR)                           04S0443
         L     @15,DEBSIOA(,@07)                                04S0443
         BALR  @14,@15                                          04S0443
*           IOSERR=ON;              /* INDICATE RETRY...     @G36XREB*/
*           IOSEX=ON;               /* ...SITUATION          @G36XREB*/
         OI    IOSERR(IOSBPTR),B'00100100'                      04S0445
*           SVC(15);                /* ISSUE ERROR EXCP      @G36XREB*/
         SVC   15                                               04S0446
*           SVC(3);                 /* EXIT SVC              @G36XREB*/
         SVC   3                                                04S0447
*         END;                                                  04S0448
*       GOTO CE0001@;               /* BRANCH TO END OF CASE         */
         B     CE0001@                                          04S0449
*     END CRETRY;                   /* END OF SUBCASE                */
*                                                               04S0451
*     /***************************************************************/
*     /*                                                             */
*     /* GPROCESS.PROCCASE.CPET1: SETS UP PERMANENT ERROR TYPE 1     */
*     /* ACTION-EXIT TO IGE0025C FOR ALTERNATE PATH RETRY.           */
*     /*                                                             */
*     /***************************************************************/
*                                                               04S0451
*CPET1:                                                         04S0451
*     DO;                           /* SUBCASE PERMANENT ERROR TYPE 1
*                                      PROCESSING                    */
CPET1    DS    0H                                               04S0452
*/*   NO ACTION, CURRENTLY NOT BEING USED                    @G36XREB*/
*                                                               04S0452
*       GOTO CE0001@;               /* BRANCH TO END OF CASE         */
         B     CE0001@                                          04S0452
*     END CPET1;                    /* END OF SUBCASE                */
*                                                               04S0454
*     /***************************************************************/
*     /*                                                             */
*     /* GPROCESS.PROCCASE.CPET2: SETS UP PERMANENT ERROR PROCESSING */
*     /* TYPE 2-EXIT TO IGG019TH VIA ERROR EXCP.                     */
*     /*                                                             */
*     /***************************************************************/
*                                                               04S0454
*CPET2:                                                         04S0454
*     DO;                           /* SUBCASE PERMANENT ERROR TYPE 2
*                                      PROCESSING                    */
CPET2    DS    0H                                               04S0455
*       LCBSENS0=LCBSNSV;           /* RESTORE ORIGINAL SENSE        */
         MVC   LCBSENS0(1,RLCB),LCBSNSV(RLCB)                   04S0455
*       LCBCSW=LCBCSWSV;            /* RESTORE ORIGINAL CSW          */
         MVC   LCBCSW(7,RLCB),LCBCSWSV(RLCB)                    04S0456
*       LCBUNADD=ADDR(UCBNAME);     /* SETUP PARAMETER FOR IGE0025C  */
         L     @07,UCBPTR(,IOSBPTR)                             04S0457
         LA    @07,UCBNAME(,@07)                                04S0457
         STCM  @07,7,LCBUNADD(RLCB)                             04S0457
*       LCBSTART=LCBSTSAV;          /* RESTORE ORIGINAL CP START
*                                      ADDRESS                       */
         MVC   LCBSTART(3,RLCB),LCBSTSAV(RLCB)                  04S0458
*       LCBINCAM=ZERO;              /* RESET RETRY COUNTER           */
         SLR   @07,@07                                          04S0459
         STH   @07,LCBINCAM(,RLCB)                              04S0459
*       LCBECBCC=LCBECB41;          /* SET TCAM PERMANENT ERROR SO
*                                      THAT IGG019TH WILL DETECT IT
*                                                            @OY20613*/
         MVI   LCBECBCC(RLCB),X'41'                             04S0460
*       IOSERR=OFF;                 /* INDICATE PERMANENT... @G36XREB*/
*       IOSEX=ON;                   /* ...ERROR              @G36XREB*/
         OI    IOSEX(IOSBPTR),B'00000100'                       04S0462
         NI    IOSERR(IOSBPTR),B'11011111'                      04S0462
*       RPARM=IOSBPTR;              /* IOSB ADDRESS          @G36XREB*/
         LR    RPARM,IOSBPTR                                    04S0463
*       SVC(15);                    /* ISSUE ERROR EXCP TO RETURN TO
*                                      CHANNEL END APPENDAGE @G36XREB*/
         SVC   15                                               04S0464
*       SVC(3);                     /* EXIT SVC              @G36XREB*/
         SVC   3                                                04S0465
*       GOTO CE0001@;               /* BRANCH TO END OF CASE         */
         B     CE0001@                                          04S0466
*     END CPET2;                    /* END OF SUBCASE                */
*                                                               04S0468
*     /***************************************************************/
*     /*                                                             */
*     /* GPROCESS.PROCCASE.CPET3: SETS UP PERMANENT ERROR TYPE 3     */
*     /* PROCESSING-EXIT TO IGE0025C FOR MESSAGE IEA000I AND OBR     */
*     /* RECORDING.                                                  */
*     /*                                                             */
*     /***************************************************************/
*                                                               04S0468
*CPET3:                                                         04S0468
*     DO;                           /* SUBCASE PERMANENT ERROR TYPE 3
*                                      PROCESSING                    */
CPET3    DS    0H                                               04S0469
*       CALL INTF025C;              /* SETUP PARAMETERS FOR IGE0025C
*                                      INVOCATION                    */
         LA    @15,INTF025C                                     04S0469
         BALR  @14,@15                                          04S0469
*       IOSERR=OFF;                 /* INDICATE PERMANENT... @G36XREB*/
*       IOSEX=ON;                   /* ...ERROR              @G36XREB*/
         OI    IOSEX(IOSBPTR),B'00000100'                       04S0471
         NI    IOSERR(IOSBPTR),B'11011111'                      04S0471
*       RPARM=IOSBPTR;              /* IOSB ADDRESS          @G36XREB*/
         LR    RPARM,IOSBPTR                                    04S0472
*       REG13=XCTL025C;             /* SYSTEM MSG WRITER ID  @G36XREB*/
         LA    REG13,253                                        04S0473
*       REG14=CVTXTLER;             /* SYSTEM XCTL ROUTINE   @G36XREB*/
         L     @07,CVTPTR                                       04S0474
         L     REG14,CVTXTLER(,@07)                             04S0474
*       GEN(BR    REG14);           /* XCTL TO MESSAGE WRITER   04S0475
*                                                            @G36XREB*/
         BR    REG14
*       GOTO CE0001@;               /* BRANCH TO END OF CASE         */
         B     CE0001@                                          04S0476
*     END CPET3;                    /* END OF SUBCASE                */
*                                                               04S0478
*     /***************************************************************/
*     /*                                                             */
*     /* GPROCESS.PROCCASE.CGRETRY: SETS UP GOOD RETRY               */
*     /* PROCESSING-EXIT TO IGG019TH VIA ERRROR EXCP WITH ERROR      */
*     /* CLEARED--OR EXIT TO IGE0904I FOR MDR PROCESSING WITH ERROR  */
*     /* CLEARED.                                                    */
*     /*                                                             */
*     /***************************************************************/
*                                                               04S0478
*CGRETRY:                                                       04S0478
*     DO;                           /* SUBCASE GOOD RETRY PROCESSING */
CGRETRY  DS    0H                                               04S0479
*       LCBINCAM=ZERO;              /* RESET RETRY COUNTER           */
         SLR   @07,@07                                          04S0479
         STH   @07,LCBINCAM(,RLCB)                              04S0479
*       LCBSTART=LCBSTSAV;          /* RESTORE ORIGINAL CP START
*                                      ADDRESS                       */
         MVC   LCBSTART(3,RLCB),LCBSTSAV(RLCB)                  04S0480
*       IOSERR=RESET;               /* RESET ERP IN CONTROL  @G36XREB*/
*       IOSEX=RESET;                /* RESET EXCEPTIONAL CONDITION
*                                                            @G36XREB*/
         NI    IOSERR(IOSBPTR),B'11011011'                      04S0482
*       RPARM=IOSBPTR;              /* IOSB ADDRESS          @G36XREB*/
         LR    RPARM,IOSBPTR                                    04S0483
*       IF LCBOBRCH^=ZERO           /* IF THERE ARE PIUS ON THE OBR
*                                      QUEUE                         */
*         THEN                                                  04S0484
         C     @07,LCBOBRCH(,RLCB)                              04S0484
         BE    @RF00484                                         04S0484
*         DO;                       /* THEN SETUP PROCESSING OF THEM */
*           REG13=XCTL904I;         /* SETUP XCTL TO IGE0904I        */
         L     REG13,@CF03328                                   04S0486
*           REG14=CVTXTLER;         /* SYSTEM XCTL ROUTINE   @G36XREB*/
         L     @07,CVTPTR                                       04S0487
         L     REG14,CVTXTLER(,@07)                             04S0487
*           GEN(BR    REG14);       /* XCTL TO IGE0904I      @G36XREB*/
         BR    REG14
*         END;                                                  04S0489
*       ELSE                                                    04S0490
*         DO;                       /*                       @G36XREB*/
         B     @RC00484                                         04S0490
@RF00484 DS    0H                                               04S0491
*           SVC(15);                /* ERROR EXCP(RETURNS TO CHANNEL
*                                      END WITH ERROR CLEARED)  04S0491
*                                                            @G36XREB*/
         SVC   15                                               04S0491
*           SVC(3);                 /* EXIT SVC              @G36XREB*/
         SVC   3                                                04S0492
*         END;                      /*                       @G36XREB*/
*       GOTO CE0001@;               /* BRANCH TO END OF CASE         */
         B     CE0001@                                          04S0494
*     END CGRETRY;                  /* END OF SUBCASE                */
*                                                               04S0496
*     /***************************************************************/
*     /*                                                             */
*     /* GPROCESS.PROCCASE.CMDREXIT: SETS UP MDR EXIT PROCESSING-EXIT*/
*     /* TO IGE0904I FOR MDR PROCESSING.                             */
*     /*                                                             */
*     /***************************************************************/
*                                                               04S0496
*CMDREXIT:                                                      04S0496
*     DO;                           /* SUBCASE MDR EXIT PROCESSING   */
CMDREXIT DS    0H                                               04S0497
*       IOSEX=RESET;                /* SETUP GOOD RETURN TO IGG019TH
*                                                            @G36XREB*/
         NI    IOSEX(IOSBPTR),B'11111011'                       04S0497
*       REG13=XCTL904I;             /* SETUP XCTL TO IGE0904I        */
         L     REG13,@CF03328                                   04S0498
*       RPARM=IOSBPTR;              /* IOSB ADDRESS          @G36XREB*/
         LR    RPARM,IOSBPTR                                    04S0499
*       REG14=CVTXTLER;             /* SYSTEM XCTL ROUTINE   @G36XREB*/
         L     @07,CVTPTR                                       04S0500
         L     REG14,CVTXTLER(,@07)                             04S0500
*       GEN(BR    REG14);           /* XCTL TO IGE0904I      @G36XREB*/
         BR    REG14
*       GOTO CE0001@;               /* BRANCH TO END OF CASE         */
         B     CE0001@                                          04S0502
*     END CMDREXIT;                 /* END OF SUBCASE                */
*CE0001@:                                                       03S0504
*   END;                            /* END OF CASE                   */
*                                                               03S0505
*   /*****************************************************************/
*   /*                                                               */
*   /* GPROCESS.INTF025C: A SUBROUTINE WHICH SETS UP A PERMANENT     */
*   /* ERROR EXIT TO IGE0025C FOR MESSAGE IEA000I AND OBR RECORDING  */
*   /* FOR SUBCASES CRETRY AND CPET3.                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                               03S0505
*INTF025C:                                                      03S0505
*   PROC OPTIONS(ENTREG,NOPARMREG,RETREG,NOSAVE,NOSAVEAREA);/*  03S0505
*                                      PROCEDURE TO SETUP PARAMETERS
*                                      FOR EXIT TO IGE0025C FOR 03S0505
*                                      MESSAGE IEA000I AND OBR  03S0505
*                                      RECORDING                     */
@EL00001 DS    0H                                               03S0505
@EF00001 DS    0H                                               03S0505
@ER00001 BR    @14                                              03S0505
INTF025C DS    0H                                               03S0506
*   RFY                                                         03S0506
*     DSTINDX RSTD;                 /* DEVICE STATISTICS TABLE INDEX
*                                                            @ZM47653*/
*   LCBUNADD=ADDR(UCBNAME);         /* USED BY IEDQNX FOR MESSAGE
*                                                            @ZM47653*/
         L     @07,UCBPTR(,IOSBPTR)                             03S0507
         LA    @00,UCBNAME(,@07)                                03S0507
         STCM  @00,7,LCBUNADD(RLCB)                             03S0507
*   LCBUASZE=LENGTH(UCBNAME);       /* USED BY IEDQNX        @ZM47653*/
         MVI   LCBUASZE(RLCB),X'03'                             03S0508
*   LCBINCAM=ZERO;                  /* RESET RETRY COUNTER           */
         SLR   @00,@00                                          03S0509
         STH   @00,LCBINCAM(,RLCB)                              03S0509
*   LCBSENS0=LCBSNSV;               /* RESTORE ORIGINAL SENSE DATA   */
         MVC   LCBSENS0(1,RLCB),LCBSNSV(RLCB)                   03S0510
*   LCBCSW=LCBCSWSV;                /* RESTORE ORIGINAL CSW          */
         MVC   LCBCSW(7,RLCB),LCBCSWSV(RLCB)                    03S0511
*   LCBSTART=LCBSTSAV;              /* RESTORE ORIGINAL CP START
*                                      ADDRESS                       */
         MVC   LCBSTART(3,RLCB),LCBSTSAV(RLCB)                  03S0512
*   LCBECBCC=LCBECB41;              /* SET TCAM PERMANENT ERROR SO
*                                      THAT IGG019TH WILL DETECT IT
*                                                            @OY20613*/
         MVI   LCBECBCC(RLCB),X'41'                             03S0513
*   DSTPTR=CVTSTB;                  /* DEVICE STATISTICS TABLE  03S0514
*                                      ADDRESS               @G36XREB*/
         L     @15,CVTPTR                                       03S0514
         L     DSTPTR,CVTSTB(,@15)                              03S0514
*   DSTINDX=UCBETI;                 /* DEVICE STAT TABLE INDEX  03S0515
*                                                            @G36XREB*/
         L     @07,UCBEXTPT(,@07)                               03S0515
         SLR   DSTINDX,DSTINDX                                  03S0515
         IC    DSTINDX,UCBETI(,@07)                             03S0515
*   DO WHILE(UCBPTR<DSTPTR->FIXED15);/* FIND DEVICE STAT TABLE ENTRY
*                                      FOR THIS UCB          @G36XREB*/
         B     @DE00516                                         03S0516
@DL00516 DS    0H                                               03S0517
*     DSTPTR=DSTPTR+2;              /* INCREMENT POINTER     @G36XREB*/
         AL    DSTPTR,@CF00065                                  03S0517
*     DSTINDX=DSTINDX+256;          /* INCREMENT ENTRY INDEX @G36XREB*/
         AL    DSTINDX,@CF01326                                 03S0518
*   END;                            /*                       @G36XREB*/
@DE00516 L     @07,UCBPTR(,IOSBPTR)                             03S0519
         CH    @07,FIXED15(,DSTPTR)                             03S0519
         BL    @DL00516                                         03S0519
*   DSTPTR=DSTPTR+DSTINDX*10;       /* MULTIPLY TO GET ENTRY ADDRESS
*                                                            @G36XREB*/
         LR    @07,DSTINDX                                      03S0520
         MH    @07,@CH03317                                     03S0520
         ALR   DSTPTR,@07                                       03S0520
*   EWTCSIO=DSTPTR->FIXED15;        /* SIO COUNTERS FOR OBR  @G36XREB*/
         L     @07,EWAPTR(,IOSBPTR)                             03S0521
         LH    @00,FIXED15(,DSTPTR)                             03S0521
         STH   @00,EWTCSIO(,@07)                                03S0521
*   EWTCSNL=IOSSNS;                 /* SENSE INFO FOR OBR    @G36XREB*/
         MVC   EWTCSNL(1,@07),IOSSNS(IOSBPTR)                   03S0522
*   EWTCCSW=IOSCSW;                 /* CSW TO OBR            @G36XREB*/
         MVC   EWTCCSW(7,@07),IOSCSW(IOSBPTR)                   03S0523
*   EWTCCCW=LCBCSWCA->CCW;          /* INTERRUPTED CCW       @G36XREB*/
         L     @15,LCBCSWCA-1(,RLCB)                            03S0524
         MVC   EWTCCCW(8,@07),CCW(@15)                          03S0524
*   EWADDISP=ADDR(EWTCSIO);         /* DATA ADDR             @G36XREB*/
         LA    @00,EWTCSIO(,@07)                                03S0525
         STCM  @00,7,EWADDISP(@07)                              03S0525
*   EWADCNT='1C'X;                  /* DATA SIZE TO OBR      @G36XREB*/
         MVI   EWADCNT(@07),X'1C'                               03S0526
*   IOSLOG=ON;                      /* WRITE OBR RECORD      @G36XREB*/
*   IOSMSG=ON;                      /* WRITE I/O ERROR MESSAGE  03S0528
*                                                            @G36XREB*/
         OI    IOSLOG(IOSBPTR),B'00000101'                      03S0528
*   RFY                                                         03S0529
*     DSTINDX UNRSTD;               /*                       @ZM47653*/
*   END INTF025C;                                               03S0530
@EL00002 DS    0H                                               03S0530
@EF00002 DS    0H                                               03S0530
@ER00002 BR    @14                                              03S0530
*   END IGE0004I                                                01S0531
*                                                               01S0531
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (TAVTD   )                                       */
*/*%INCLUDE SYSLIB  (TCCWD   )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHADCBDF)                                       */
*/*%INCLUDE SYSLIB  (IHADCB  )                                       */
*/*%INCLUDE SYSLIB  (TDEBD   )                                       */
*/*%INCLUDE SYSLIB  (IECDIOSB)                                       */
*/*%INCLUDE SYSLIB  (EWAMAP  )                                       */
*/*%INCLUDE SYSLIB  (TLCBD   )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (TRQED   )                                       */
*/*%INCLUDE SYSLIB  (TTCXD   )                                       */
*/*%INCLUDE SYSLIB  (TTRMD   )                                       */
*/*%INCLUDE SYSLIB  (IEFUCBOB)                                       */
*/*%INCLUDE SYSUT5  (RFY     )                                       */
*/*%INCLUDE SYSUT5  (DCL     )                                       */
*/*%INCLUDE SYSUT5  (PROLOGUE)                                       */
*/*%INCLUDE SYSUT5  (GPROCESS)                                       */
*/*%INCLUDE SYSUT5  (GETTTE  )                                       */
*/*%INCLUDE SYSUT5  (CONDTEST)                                       */
*/*%INCLUDE SYSUT5  (CONVRV  )                                       */
*/*%INCLUDE SYSUT5  (INITPROC)                                       */
*/*%INCLUDE SYSUT5  (CONDSIO3)                                       */
*/*%INCLUDE SYSUT5  (CONDOTHR)                                       */
*/*%INCLUDE SYSUT5  (PROCCASE)                                       */
*/*%INCLUDE SYSUT5  (CRETRY  )                                       */
*/*%INCLUDE SYSUT5  (CPET1   )                                       */
*/*%INCLUDE SYSUT5  (CPET2   )                                       */
*/*%INCLUDE SYSUT5  (CPET3   )                                       */
*/*%INCLUDE SYSUT5  (CGRETRY )                                       */
*/*%INCLUDE SYSUT5  (CMDREXIT)                                       */
*/*%INCLUDE SYSUT5  (INTF025C)                                       */
*                                                               01S0531
*       ;                                                       01S0531
@DATA    DS    0H
@CH03317 DC    H'10'
@DATD    DSECT
         DS    0F
IGE0004I CSECT
         DS    0F
@CF00065 DC    F'2'
@CF00074 DC    F'3'
@CF00045 DC    F'8'
@CF00035 DC    F'18'
@CF01326 DC    F'256'
@CF03328 DC    F'9049'
@CF03394 DC    F'-8'
@CF03392 DC    XL4'0000FFFF'
@DATD    DSECT
         DS    0D
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IGE0004I CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
MSG064L  DS    CL49
         ORG   MSG064L
M064LENL DC    AL2(49)
M064FLGL DC    AL2(0)
M064TXTL DC    CL45'IED064I LINE XXX CONTROL UNIT NOT OPERATIONAL'
         ORG   MSG064L+49
         DS    CL3
CP0001@  DC    AL4(CRETRY)
         DC    AL4(CPET1)
         DC    AL4(CPET2)
         DC    AL4(CPET3)
         DC    AL4(CGRETRY)
         DC    AL4(CMDREXIT)
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
IEDQAPTR EQU   @01
DCBPTR   EQU   @02
IOSBPTR  EQU   @06
IEDQLPTR EQU   @01
LCBXPTR  EQU   @05
RTRM     EQU   @08
RAVT     EQU   @13
RLCB     EQU   @04
RCCW     EQU   @11
REG00    EQU   @00
REG01    EQU   @01
RPARM    EQU   @01
RPROC    EQU   @02
DSTPTR   EQU   @02
RTCX     EQU   @03
DSTINDX  EQU   @05
RINT     EQU   @09
REG10    EQU   @10
RBASE    EQU   @12
REG13    EQU   @13
REG14    EQU   @14
REG15    EQU   @15
IEDQTPTR EQU   @01
REG02    EQU   @02
REG03    EQU   @03
REG04    EQU   @04
REG05    EQU   @05
REG06    EQU   @06
REG07    EQU   @07
REG08    EQU   @08
REG09    EQU   @09
REG11    EQU   @11
REG12    EQU   @12
UCBDCPTR EQU   @01
CVTPTR   EQU   16
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSALITA  EQU   PSA+764
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
IEDQAVTD EQU   0
AVTSAVEX EQU   IEDQAVTD+288
AVTREADD EQU   IEDQAVTD+380
AVTBUFSW EQU   IEDQAVTD+384
@NM00004 EQU   IEDQAVTD+388
AVTCKFLG EQU   @NM00004
AVTBASE  EQU   IEDQAVTD+412
AVTPKF   EQU   AVTBASE
AVTRNMPT EQU   IEDQAVTD+424
AVTOSECB EQU   IEDQAVTD+492
AVTECB1  EQU   AVTOSECB
AVTHG02  EQU   IEDQAVTD+528
AVTDISP  EQU   IEDQAVTD+552
AVTHD    EQU   IEDQAVTD+556
AVTSCOPT EQU   AVTHD
AVTSAVTP EQU   IEDQAVTD+612
AVTSAVTF EQU   AVTSAVTP
AVTIOT   EQU   IEDQAVTD+640
AVTCKPEL EQU   IEDQAVTD+652
AVTCKRMV EQU   AVTCKPEL
AVTCKELF EQU   IEDQAVTD+680
AVTCKBYT EQU   IEDQAVTD+691
AVTHG01  EQU   IEDQAVTD+692
AVTCKLNK EQU   IEDQAVTD+696
AVTCRELE EQU   IEDQAVTD+708
AVTCCELE EQU   AVTCRELE
AVTCLRHI EQU   IEDQAVTD+716
AVTADBUF EQU   IEDQAVTD+720
AVTSYSER EQU   IEDQAVTD+728
AVTBFRFG EQU   IEDQAVTD+784
AVTCKPQB EQU   IEDQAVTD+804
AVTCKPTB EQU   AVTCKPQB
AVTCKPEC EQU   AVTCKPQB+4
AVTCKPCC EQU   AVTCKPEC
AVTOPCQB EQU   IEDQAVTD+816
AVTOPCOB EQU   AVTOPCQB
AVTOPCEC EQU   AVTOPCQB+4
AVTOPCCC EQU   AVTOPCEC
AVTOLTQB EQU   IEDQAVTD+828
AVTCWFL1 EQU   IEDQAVTD+924
AVTCWFL2 EQU   IEDQAVTD+925
AVTSUBT  EQU   IEDQAVTD+948
AVTIOTR  EQU   IEDQAVTD+949
AVTBIT1  EQU   IEDQAVTD+1050
AVTBIT2  EQU   IEDQAVTD+1051
AVTBIT3  EQU   IEDQAVTD+1052
AVTBIT4  EQU   IEDQAVTD+1136
@NM00086 EQU   IEDQAVTD+1232
IEDNSVTD EQU   0
SAVTDIAG EQU   IEDNSVTD
SAVTDIAF EQU   SAVTDIAG
SAVTLUSQ EQU   IEDNSVTD+88
SAVTTCPU EQU   IEDNSVTD+238
SAVTZELM EQU   IEDNSVTD+270
SAVTRDRV EQU   IEDNSVTD+284
SAVTCKQB EQU   IEDNSVTD+300
SAVTCKTB EQU   SAVTCKQB
SAVTCKEC EQU   SAVTCKQB+4
SAVTCKCC EQU   SAVTCKEC
SAVTNETF EQU   IEDNSVTD+324
SAVTCDRV EQU   IEDNSVTD+332
IEDQCCW  EQU   0
CCW      EQU   IEDQCCW
CCWOPCDE EQU   CCW
CCWADDR  EQU   CCW+1
CCWFLAGS EQU   CCW+4
CCWCD    EQU   CCWFLAGS
CCWCC    EQU   CCWFLAGS
CVTMAP   EQU   0
CVTXTLER EQU   CVTMAP+44
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTSTB   EQU   CVTMAP+112
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTPTRV  EQU   CVTMAP+288
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
IHADCB   EQU   0
IHADCS1A EQU   0
DCBBCKUP EQU   IHADCS1A+8
IHADCS2K EQU   0
DCBDUMPD EQU   IHADCS2K
DCBTRSTA EQU   IHADCS2K+5
DCBDSORG EQU   IHADCS2K+6
DCBDSRG2 EQU   DCBDSORG+1
DCBRNCKD EQU   IHADCS2K+12
DCBEXLST EQU   IHADCS2K+16
DCBEIOBX EQU   DCBEXLST
IHADCS24 EQU   0
DCBOFLGS EQU   IHADCS24+8
DCBOFLWR EQU   DCBOFLGS
DCBIFLG  EQU   IHADCS24+9
DCBIBPCT EQU   DCBIFLG
DCBMACR  EQU   IHADCS24+10
DCBMACR1 EQU   DCBMACR
DCBMRFE  EQU   DCBMACR1
DCBMRGET EQU   DCBMRFE
DCBMRAPG EQU   DCBMACR1
DCBMRRD  EQU   DCBMRAPG
DCBMRCI  EQU   DCBMACR1
DCBMRMVG EQU   DCBMRCI
DCBMRLCG EQU   DCBMACR1
DCBMRABC EQU   DCBMACR1
DCBMRPT1 EQU   DCBMRABC
DCBMRSBG EQU   DCBMRPT1
DCBMRCRL EQU   DCBMACR1
DCBMRCHK EQU   DCBMRCRL
DCBMRRDX EQU   DCBMRCHK
DCBMRDMG EQU   DCBMACR1
DCBMACR2 EQU   DCBMACR+1
DCBMRPUT EQU   DCBMACR2
DCBMRWRT EQU   DCBMACR2
DCBMRMVP EQU   DCBMACR2
DCBMR5WD EQU   DCBMACR2
DCBMRLDM EQU   DCBMR5WD
DCBMRLCP EQU   DCBMRLDM
DCBMR4WD EQU   DCBMACR2
DCBMRPT2 EQU   DCBMR4WD
DCBMRTMD EQU   DCBMRPT2
DCBMR3WD EQU   DCBMACR2
DCBMRCTL EQU   DCBMR3WD
DCBMRSTK EQU   DCBMRCTL
DCBMR1WD EQU   DCBMACR2
DCBMRSWA EQU   DCBMR1WD
DCBMRDMD EQU   DCBMRSWA
IHADCS25 EQU   0
DCBMACRF EQU   IHADCS25+2
DCBMACF1 EQU   DCBMACRF
DCBMFFE  EQU   DCBMACF1
DCBMFGET EQU   DCBMFFE
DCBMFAPG EQU   DCBMACF1
DCBMFRD  EQU   DCBMFAPG
DCBMFCI  EQU   DCBMACF1
DCBMFMVG EQU   DCBMFCI
DCBMFLCG EQU   DCBMACF1
DCBMFABC EQU   DCBMACF1
DCBMFPT1 EQU   DCBMFABC
DCBMFSBG EQU   DCBMFPT1
DCBMFCRL EQU   DCBMACF1
DCBMFCHK EQU   DCBMFCRL
DCBMFDMG EQU   DCBMACF1
DCBMACF2 EQU   DCBMACRF+1
DCBMFPUT EQU   DCBMACF2
DCBMFWRT EQU   DCBMACF2
DCBMFMVP EQU   DCBMACF2
DCBMF5WD EQU   DCBMACF2
DCBMFLDM EQU   DCBMF5WD
DCBMFLCP EQU   DCBMFLDM
DCBMF4WD EQU   DCBMACF2
DCBMFPT2 EQU   DCBMF4WD
DCBMFTMD EQU   DCBMFPT2
DCBMF3WD EQU   DCBMACF2
DCBMFCTL EQU   DCBMF3WD
DCBMFSTK EQU   DCBMFCTL
DCBMF1WD EQU   DCBMACF2
DCBMFSWA EQU   DCBMF1WD
DCBMFDMD EQU   DCBMFSWA
DCBDEBAD EQU   IHADCS25+4
DCBIFLGS EQU   DCBDEBAD
DCBIFPCT EQU   DCBIFLGS
IHADCS27 EQU   0
DCBGET   EQU   IHADCS27
DCBPUT   EQU   DCBGET
DCBGETA  EQU   DCBPUT+1
IHADCS43 EQU   0
DCBSCTAB EQU   IHADCS43
IEDQDEB  EQU   0
DEBPRF   EQU   IEDQDEB
DEBAPVT  EQU   DEBPRF
DEBSIOA  EQU   DEBAPVT+4
DEBNMEXT EQU   IEDQDEB+52
DEBUCBS  EQU   IEDQDEB+68
IOSB     EQU   0
IOSFLA   EQU   IOSB
IOSACHN  EQU   IOSFLA
IOSERR   EQU   IOSFLA
IOSEX    EQU   IOSFLA
IOSFLB   EQU   IOSB+1
IOSMSG   EQU   IOSFLB
IOSLOG   EQU   IOSFLB
IOSFLC   EQU   IOSB+2
IOSDVALT EQU   IOSFLC
IOSPKEY  EQU   IOSB+12
IOSCOD   EQU   IOSB+13
IOSOPT   EQU   IOSB+14
IOSOPT2  EQU   IOSB+15
IOSUCB   EQU   IOSB+16
@NM00123 EQU   IOSB+20
IOSCC    EQU   @NM00123
IOSCSW   EQU   @NM00123+1
IOSCSWCA EQU   IOSCSW
IOSTATUS EQU   IOSCSW+3
IOSUSE   EQU   IOSB+32
IOSSNS   EQU   IOSB+42
IOSIPIB  EQU   IOSB+44
IOSERP   EQU   IOSB+52
IOSRST   EQU   IOSB+72
IOSVST   EQU   IOSB+76
IOSDSID  EQU   IOSB+80
IOSPATH  EQU   IOSB+86
IOSCHN   EQU   IOSPATH
IOSCKEY  EQU   IOSB+89
IOSEEKA  EQU   IOSB+100
IOSCCHH  EQU   IOSEEKA+3
IOSSKHH  EQU   IOSCCHH+2
EWA      EQU   0
EWAHDR   EQU   EWA
EWAFLAGS EQU   EWA+4
EWAFLG1  EQU   EWAFLAGS
EWASCCD  EQU   EWAFLG1
EWASCC3  EQU   EWASCCD
EWAFLG2  EQU   EWAFLAGS+1
EWAFLG3  EQU   EWAFLAGS+2
EWASNSCT EQU   EWAFLAGS+3
EWACNTRS EQU   EWA+10
EWAERPIB EQU   EWA+16
EWARGFG1 EQU   EWAERPIB+4
EWARGFG2 EQU   EWAERPIB+5
EWAXCSW1 EQU   EWAERPIB+6
EWAXCSW2 EQU   EWAERPIB+7
EWADCNT  EQU   EWA+28
EWADDISP EQU   EWA+29
EWAIERP  EQU   EWA+32
IEDQLCB  EQU   0
LCBRCB   EQU   IEDQLCB
LCBTSOB  EQU   IEDQLCB+19
LCBCHAIN EQU   IEDQLCB+20
LCBSCRNN EQU   LCBCHAIN
LCBTETEN EQU   LCBCHAIN
LCBINSRC EQU   IEDQLCB+21
LCBLKMDE EQU   LCBINSRC+2
LCBNTXT  EQU   IEDQLCB+24
LCBSTAT4 EQU   LCBNTXT
LCBPHASE EQU   LCBSTAT4
LCBSCBDA EQU   IEDQLCB+25
LCBMHA   EQU   IEDQLCB+29
LCBFLAG1 EQU   IEDQLCB+32
LCBIOBSN EQU   IEDQLCB+33
LCBFLAG2 EQU   LCBIOBSN
LCBSNS   EQU   LCBIOBSN+1
LCBSENS0 EQU   LCBSNS
LCBCMDRJ EQU   LCBSENS0
LCBINTRQ EQU   LCBSENS0
LCBBUSCK EQU   LCBSENS0
LCBEQUCK EQU   LCBSENS0
LCBDATCK EQU   LCBSENS0
LCBOVRUN EQU   LCBSENS0
LCBLOSDT EQU   LCBSENS0
LCBNOTIN EQU   LCBLOSDT
LCBTMOUT EQU   LCBSENS0
LCBECBCC EQU   LCBIOBSN+3
LCBFLAG3 EQU   LCBIOBSN+7
LCBRLAD  EQU   LCBFLAG3
LCBCSW   EQU   LCBIOBSN+8
LCBCSWCA EQU   LCBCSW
LCBCSWST EQU   LCBCSW+3
LCBCSWUS EQU   LCBCSWST
LCBUSUC  EQU   LCBCSWUS
LCBCSWCS EQU   LCBCSWST+1
LCBCSPCI EQU   LCBCSWCS
LCBCSIL  EQU   LCBCSWCS
LCBCSPGC EQU   LCBCSWCS
LCBCSPTC EQU   LCBCSWCS
LCBCSCDC EQU   LCBCSWCS
LCBCSCCC EQU   LCBCSWCS
LCBCSICC EQU   LCBCSWCS
LCBCSCHC EQU   LCBCSWCS
LCBSIOCC EQU   LCBIOBSN+15
LCBSIOC1 EQU   LCBSIOCC
LCBSIOC2 EQU   LCBSIOCC
LCBSTART EQU   LCBIOBSN+16
LCBDCBPT EQU   IEDQLCB+52
LCBRCQCB EQU   IEDQLCB+56
LCBRESTR EQU   LCBRCQCB
@NM00147 EQU   IEDQLCB+60
LCBINCAM EQU   @NM00147
LCBERRCT EQU   IEDQLCB+62
LCBLSPCI EQU   IEDQLCB+65
LCBRCBFR EQU   LCBLSPCI
LCBSTATE EQU   IEDQLCB+70
LCBSTAT1 EQU   LCBSTATE
LCBSENDN EQU   LCBSTAT1
LCBSTAT2 EQU   LCBSTATE+1
LCBBEOTN EQU   LCBSTAT2
LCBSYNC  EQU   LCBSTAT2
LCBDIAL  EQU   LCBSTAT2
LCBTSTSW EQU   IEDQLCB+72
LCBERB   EQU   IEDQLCB+76
LCBERBST EQU   IEDQLCB+84
LCBDLNKN EQU   LCBERBST
LCBERBCT EQU   IEDQLCB+88
LCBRBCT2 EQU   LCBERBCT+1
LCBTTCIN EQU   IEDQLCB+90
LCBMSGFM EQU   IEDQLCB+92
LCBOBRCH EQU   IEDQLCB+96
LCBERMSK EQU   LCBOBRCH
LCBNXMOD EQU   LCBERMSK
LCBSTAT7 EQU   LCBNXMOD
LCBINVPT EQU   LCBOBRCH+1
LCBBFRW  EQU   LCBINVPT
LCBTPCD  EQU   IEDQLCB+100
LCBSTAT5 EQU   LCBTPCD
LCBSTAT6 EQU   LCBTPCD+4
LCBRSPSV EQU   LCBTPCD+8
LCBSAVSN EQU   IEDQLCB+112
LCBSNSV  EQU   LCBSAVSN
LCBCSWSV EQU   LCBSAVSN+1
LCBERCCW EQU   IEDQLCB+120
LCBCPA   EQU   IEDQLCB+144
LCBCCW2  EQU   LCBCPA+8
LCBCCW3  EQU   LCBCPA+16
LCBCCW4  EQU   LCBCPA+24
LCBCCW5  EQU   LCBCPA+32
LCBATTEL EQU   LCBCCW5
LCBQEBPL EQU   LCBATTEL
LCBCCW7  EQU   LCBCPA+48
IEDQLCBX EQU   0
LCBXCON  EQU   IEDQLCBX
LCBXFLAG EQU   LCBXCON
LCBXDCT  EQU   LCBXCON+1
LCBXRADR EQU   LCBXCON+4
IEDRQE   EQU   0
RQEUCB   EQU   IEDRQE+2
RQEIOB   EQU   IEDRQE+5
RRQE     EQU   0
IEDQTCXD EQU   0
TCXAVT   EQU   IEDQTCXD
TCXATTEN EQU   IEDQTCXD+4
TCXFLAG1 EQU   IEDQTCXD+34
TCXCC3TS EQU   IEDQTCXD+35
TCXBUFA  EQU   IEDQTCXD+80
TCXDSAVE EQU   IEDQTCXD+104
TCXERPPM EQU   IEDQTCXD+128
TCXESAVE EQU   IEDQTCXD+132
TCXQE8   EQU   IEDQTCXD+216
IEDTRM   EQU   0
IEDNTRM  EQU   IEDTRM
TRMINDEX EQU   IEDNTRM
TRMCOHTG EQU   IEDNTRM+2
TRMBYTE6 EQU   TRMCOHTG
TRMCDF0  EQU   TRMBYTE6
TRMBYTE5 EQU   TRMCOHTG+1
TRMBYTE4 EQU   IEDNTRM+4
TRMBYTE3 EQU   IEDNTRM+5
TRMBYTE2 EQU   IEDNTRM+6
TRMINPG  EQU   TRMBYTE2
TRMBYTE1 EQU   IEDNTRM+7
TRMSCPRQ EQU   TRMBYTE1
TRMBYTE0 EQU   IEDNTRM+10
TRMNOWCD EQU   TRMBYTE0
TRMSIBPT EQU   IEDNTRM+11
TRMLTRAC EQU   TRMSIBPT
TRMRLMCT EQU   IEDNTRM+14
TRMLGBST EQU   TRMRLMCT
IEDQTRM  EQU   IEDTRM+18
TRMSTATE EQU   IEDQTRM
TRMLOG   EQU   TRMSTATE
TRMDESTQ EQU   IEDQTRM+1
TRMRSTRT EQU   TRMDESTQ+2
TRMINSEQ EQU   IEDQTRM+4
TLISTCNT EQU   TRMINSEQ
TRMSESCT EQU   TLISTCNT
TRMOUTSQ EQU   IEDQTRM+6
TLISTEN  EQU   TRMOUTSQ
TRMDSORG EQU   TLISTEN
TRMPLIM  EQU   TLISTEN+1
TRMALTD  EQU   IEDQTRM+8
TRMPRILK EQU   TRMALTD
TRMDEVFL EQU   IEDQTRM+10
TRMADDC  EQU   TRMDEVFL
TRMNCPI  EQU   TRMDEVFL+1
TRMSTAT  EQU   IEDQTRM+12
TRMSIO   EQU   TRMSTAT
TRMOWNER EQU   TRMSIO
UCB      EQU   0
UCBOB    EQU   0
UCBJBNR  EQU   UCBOB
UCBFL5   EQU   UCBOB+1
UCBAF    EQU   UCBFL5
UCBSTAT  EQU   UCBOB+3
UCBCHAN  EQU   UCBOB+4
UCBSFLS  EQU   UCBOB+6
UCBFLA   EQU   UCBSFLS
UCBFL1   EQU   UCBFLA
UCBBSY   EQU   UCBFL1
UCBNRY   EQU   UCBFL1
UCBPST   EQU   UCBFL1
UCBCUB   EQU   UCBFL1
UCBFLB   EQU   UCBSFLS+1
UCBCHM   EQU   UCBOB+8
UCBCHM1  EQU   UCBCHM
UCBPTH0  EQU   UCBCHM1
UCBPTH1  EQU   UCBCHM1
UCBWGT   EQU   UCBOB+12
UCBNAME  EQU   UCBOB+13
UCBTYP   EQU   UCBOB+16
UCBTBYT1 EQU   UCBTYP
UCB1FEA5 EQU   UCBTBYT1
UCB1FEA6 EQU   UCBTBYT1
UCBTBYT2 EQU   UCBTYP+1
UCB2OPT2 EQU   UCBTBYT2
UCBDUDN1 EQU   UCB2OPT2
UCB2OPT3 EQU   UCBTBYT2
UCBDUDN2 EQU   UCB2OPT3
UCB2OPT4 EQU   UCBTBYT2
UCBRWTAU EQU   UCB2OPT4
UCB2OPT6 EQU   UCBTBYT2
UCB2OPT7 EQU   UCBTBYT2
UCBTBYT3 EQU   UCBTYP+2
UCBDVCLS EQU   UCBTBYT3
UCBTBYT4 EQU   UCBTYP+3
UCBEXTPT EQU   UCBOB+20
UCBFLC   EQU   UCBEXTPT
UCBDEV   EQU   UCBOB+24
UCBCMEXT EQU   0
UCBETI   EQU   UCBCMEXT
UCBATI   EQU   UCBCMEXT+3
@NM00234 EQU   UCBATI
UCBFLP1  EQU   UCBCMEXT+5
UCBMT    EQU   0
UCBOCR   EQU   0
UCB3540X EQU   0
UCBDKBYT EQU   UCB3540X+6
UCB3800X EQU   0
UCBOPTNS EQU   UCB3800X
UCBACTIV EQU   UCB3800X+3
UCBMDRBF EQU   UCB3800X+36
UCBUCS   EQU   0
UCBUCSOP EQU   UCBUCS+4
UCBFCBOP EQU   UCBUCS+5
FIXED15  EQU   0
IGG019Q0 EQU   0
IEDQTNT  EQU   0
CONVRV   EQU   0
SIOAPNG  EQU   0
CL0001@  EQU   0
DEBSUBR  EQU   0
DSTSGBEG EQU   0
UCBBGN   EQU   0
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
IEDQDPTR EQU   IOSDSID
DEBUCB   EQU   DEBUCBS
DEBDVMOD EQU   DEBUCB
DEBUCBAD EQU   DEBUCB+1
IOSATTSC EQU   IOSIPIB
IOSWTOWA EQU   IOSIPIB
IOSPCISC EQU   IOSIPIB
EWAPTR   EQU   IOSERP
EWADDIOS EQU   EWAIERP
LCBRSPIN EQU   LCBIOBSN
LCBRHSV  EQU   LCBRSPIN+2
LCBLUSNS EQU   LCBRSPIN+5
LCBSCPRS EQU   LCBRSPIN+9
LCBCSWU1 EQU   LCBSCPRS+2
LCBRSPFG EQU   LCBRSPIN+15
LCBCOREQ EQU   LCBTPCD
@NM00168 EQU   LCBCPA+40
LCBQNX   EQU   LCBERCCW
LCBQNXMN EQU   LCBQNX
LCBNX064 EQU   LCBQNXMN
LCBNX142 EQU   LCBQNXMN
LCBNX162 EQU   LCBQNXMN
LCBSTSAV EQU   LCBQNX+1
LCBUASZE EQU   LCBQNX+20
LCBUNADD EQU   LCBQNX+21
LCBCANCL EQU   LCBSAVSN
LCBCANFG EQU   LCBCANCL
FLC      EQU   PSA
PSARSVTE EQU   PSARSVT
TCXPTR   EQU   CVTAQAVT
TRMDIALQ EQU   TRMPLIM
@NM00213 EQU   TRMSTATE
TRMCDFD0 EQU   TRMBYTE5
TRMPRE1  EQU   TRMBYTE4
TRMNCP1  EQU   TRMBYTE4
TRMLU1   EQU   TRMBYTE4
TRMLINK1 EQU   TRMBYTE4
TRMDCONS EQU   TRMLINK1
TRMPRE   EQU   TRMBYTE3
TRMNCP   EQU   TRMBYTE3
TRMIPLDM EQU   TRMNCP
TRMPU    EQU   TRMBYTE3
TRMLU    EQU   TRMBYTE3
TRMCDMGR EQU   TRMBYTE3
TRMLINK  EQU   TRMBYTE3
UCBPTR   EQU   IOSUCB
UCBOBS01 EQU   UCBDEV
UCBSTAB  EQU   UCBOBS01+10
UCBBSVL  EQU   UCBSTAB
UCBPRSRS EQU   UCBSTAB
UCBDMCT  EQU   UCBOBS01+11
UCBFL4   EQU   UCBOBS01+13
UCBOBS02 EQU   UCBDEV
UCBTFL1  EQU   UCBOBS02+19
UCBXTN   EQU   UCBOBS02+20
UCBVOPT  EQU   UCBXTN
UCBOBS03 EQU   UCBDEV
UCBXTADR EQU   UCBOBS03
UCBOBS04 EQU   UCBDEV
UCBBTA   EQU   UCBOBS04+12
UCBOBS06 EQU   UCBDEV
UCBAOF   EQU   UCBOBS06
UCBAOF1  EQU   UCBAOF
UCBAOF2  EQU   UCBAOF+1
@NM00233 EQU   UCBOBS06+3
UCBIRB   EQU   UCBOBS06+4
UCBGRAF  EQU   UCBIRB
UCBLDNCA EQU   UCBOBS06+8
UCBRDYQ  EQU   UCBLDNCA
UCBIRLN  EQU   UCBRDYQ
UCBLDNCB EQU   UCBRDYQ+1
UCBCTLNK EQU   UCBOBS06+12
UCBOBS07 EQU   UCBDEV
UCBOBS08 EQU   UCBDEV
UCBCTCAD EQU   UCBOBS08
UCBCTCF1 EQU   UCBOBS08+4
UCBOBS09 EQU   UCBDEV
MSG064   EQU   EWAIERP
M064TXT  EQU   MSG064+4
M064CUA  EQU   M064TXT+13
ETW      EQU   EWAIERP
EWTCSIO  EQU   ETW+4
EWTCFLG  EQU   ETW+10
EWTCSNL  EQU   ETW+20
EWTCCSW  EQU   ETW+25
EWTCCCW  EQU   ETW+32
TICCHK   EQU   CCWOPCDE
NOTTIC1  EQU   TICCHK
NOTTIC2  EQU   TICCHK
NOTTIC3  EQU   TICCHK
OPCDESAV EQU   LCBRESTR
DIOSUCB  EQU   IOSUCB
DIOSUCBP EQU   DIOSUCB+2
TRMOPT   EQU   IEDQTRM+20
TRMPOOLP EQU   TRMINSEQ
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00237 EQU   DIOSUCB
@NM00236 EQU   TICCHK
EWTCSAV2 EQU   ETW+48
EWTCSAV1 EQU   ETW+44
EWTCBUFF EQU   ETW+40
EWTCRSV2 EQU   ETW+24
EWTCRSV1 EQU   ETW+22
EWTCSNF  EQU   ETW+21
EWTCTRM  EQU   ETW+12
EWTCGRA  EQU   ETW+11
@NM00235 EQU   EWTCFLG
EWTCSEL  EQU   EWTCFLG
EWTCEOD  EQU   EWTCFLG
EWTCOVF  EQU   EWTCFLG
EWTCTEM  EQU   EWTCFLG
EWTCTPF  EQU   ETW+9
EWTCTPL  EQU   ETW+8
EWTCMSK  EQU   ETW+7
EWTCTMP  EQU   ETW+6
EWTCTID  EQU   ETW+2
EWTCSNS  EQU   ETW
M064FLG  EQU   MSG064+2
M064LEN  EQU   MSG064
UCBRV066 EQU   UCBOBS09+4
UCBIOSBA EQU   UCBOBS09
UCBRV042 EQU   UCBOBS08+5
UCBRV082 EQU   UCBCTCF1
UCBRV081 EQU   UCBCTCF1
UCBRV080 EQU   UCBCTCF1
UCBRV079 EQU   UCBCTCF1
UCBRV078 EQU   UCBCTCF1
UCBRV077 EQU   UCBCTCF1
UCBRV076 EQU   UCBCTCF1
UCBCTC80 EQU   UCBCTCF1
UCBCTCAL EQU   UCBCTCAD
UCBICNCB EQU   UCBOBS07+4
UCBRV040 EQU   UCBOBS07
UCBCTLNA EQU   UCBCTLNK+1
UCBRLN   EQU   UCBCTLNK
UCBRDYQA EQU   UCBLDNCB
UCBINRLN EQU   UCBIRLN
UCBIRBA  EQU   UCBIRB+1
UCBRV039 EQU   UCBGRAF
UCBDWNR  EQU   UCBGRAF
UCBRPND  EQU   UCBGRAF
UCBUPM   EQU   UCBGRAF
UCBBTAM  EQU   UCBGRAF
UCBDRNO  EQU   UCBGRAF
UCBDRO   EQU   UCBGRAF
UCBOIP   EQU   UCBGRAF
UCBATRCD EQU   @NM00233
UCBSKPFG EQU   @NM00233
UCBRIPND EQU   @NM00233
UCBRTIAC EQU   @NM00233
UCBRSV79 EQU   @NM00233
UCBRSV78 EQU   @NM00233
UCBRSV77 EQU   @NM00233
UCBOLTEP EQU   @NM00233
UCBATNCT EQU   UCBOBS06+2
UCBRSV76 EQU   UCBAOF2
UCBRSV75 EQU   UCBAOF2
UCBRSV74 EQU   UCBAOF2
UCBRSV73 EQU   UCBAOF2
UCBRSV72 EQU   UCBAOF2
UCBRSV71 EQU   UCBAOF2
UCBRSV70 EQU   UCBAOF2
UCBRSV69 EQU   UCBAOF2
UCBRSV68 EQU   UCBAOF1
UCBRSV67 EQU   UCBAOF1
UCBRSV66 EQU   UCBAOF1
UCBRSV65 EQU   UCBAOF1
UCBRSV64 EQU   UCBAOF1
UCBOFNL  EQU   UCBAOF1
UCBOFSP  EQU   UCBAOF1
UCBOFMCR EQU   UCBAOF1
UCBBTB   EQU   UCBBTA+1
UCBDI    EQU   UCBBTA
UCBSNS   EQU   UCBOBS04+8
UCBTEB   EQU   UCBOBS04+4
UCBGCB   EQU   UCBOBS04+3
UCBOPEN  EQU   UCBOBS04+2
UCBSTART EQU   UCBOBS04
UCBXTNB  EQU   UCBXTN+1
UCBRSV22 EQU   UCBVOPT
UCBRSV21 EQU   UCBVOPT
UCBRSV20 EQU   UCBVOPT
UCBESVE  EQU   UCBVOPT
UCBERPC  EQU   UCBVOPT
UCBESVC  EQU   UCBVOPT
UCBEVA   EQU   UCBVOPT
UCBESV   EQU   UCBVOPT
UCBRV009 EQU   UCBTFL1
UCBRV008 EQU   UCBTFL1
UCBRV007 EQU   UCBTFL1
UCBRV006 EQU   UCBTFL1
UCBRV005 EQU   UCBTFL1
UCBDQDSP EQU   UCBTFL1
UCBNSLTP EQU   UCBTFL1
UCBNLTP  EQU   UCBTFL1
UCBRES1B EQU   UCBOBS02+18
UCBFSER  EQU   UCBOBS02+12
@NM00232 EQU   UCBOBS02+4
UCBFSEQ  EQU   UCBOBS02+2
UCBFSCT  EQU   UCBOBS02
UCBNEXP  EQU   UCBOBS01+20
UCBBASE  EQU   UCBOBS01+16
UCBRES1A EQU   UCBOBS01+15
UCBUSER  EQU   UCBOBS01+14
UCBFL47  EQU   UCBFL4
UCBFL46  EQU   UCBFL4
UCBFL45  EQU   UCBFL4
UCBRV065 EQU   UCBFL4
UCBDSS   EQU   UCBFL4
UCBRESVP EQU   UCBFL4
UCBWDAV  EQU   UCBFL4
UCBDAVV  EQU   UCBFL4
UCBSQC   EQU   UCBOBS01+12
UCBDATP  EQU   UCBOBS01+12
UCBDMC   EQU   UCBDMCT
UCBMOUNT EQU   UCBDMCT
UCBBNUL  EQU   UCBSTAB
UCBSHAR  EQU   UCBSTAB
UCBBSTR  EQU   UCBSTAB
UCBBPUB  EQU   UCBSTAB
UCBBPRV  EQU   UCBSTAB
UCBBALB  EQU   UCBPRSRS
UCBPGFL  EQU   UCBSTAB
UCBDVSHR EQU   UCBBSVL
UCBVOLI  EQU   UCBOBS01+4
UCBVTOC  EQU   UCBOBS01
TRMLDISC EQU   TRMLINK
@NM00230 EQU   TRMLINK
TRMLALOC EQU   TRMLINK
TRMLSTAT EQU   TRMLINK
TRMLINT  EQU   TRMLINK
TRMEPMOD EQU   TRMLINK
TRMCDLOG EQU   TRMCDMGR
@NM00229 EQU   TRMCDMGR
@NM00228 EQU   TRMCDMGR
@NM00227 EQU   TRMCDMGR
@NM00226 EQU   TRMCDMGR
@NM00225 EQU   TRMCDMGR
TRMBKDUP EQU   TRMCDMGR
TRMLULOG EQU   TRMLU
@NM00224 EQU   TRMLU
@NM00223 EQU   TRMLU
@NM00222 EQU   TRMLU
TRMTDIFF EQU   TRMLU
@NM00221 EQU   TRMLU
@NM00220 EQU   TRMLU
TRMAUTO  EQU   TRMLU
TRMPCONT EQU   TRMPU
TRMPDOCQ EQU   TRMPU
TRMPULOC EQU   TRMPU
TRMPDNAS EQU   TRMPU
TRMPALOC EQU   TRMPU
TRMNCONT EQU   TRMNCP
TRMQUCKN EQU   TRMNCP
TRMSLOWN EQU   TRMNCP
TRMSYGEN EQU   TRMNCP
TRMNCPCL EQU   TRMNCP
TRMINOUT EQU   TRMPRE
TRMRDOUT EQU   TRMPRE
TRMNLOUT EQU   TRMPRE
TRMWROUT EQU   TRMPRE
TRMASNXI EQU   TRMPRE
TRMSTMM  EQU   TRMPRE
TRMCMODE EQU   TRMPRE
TRMSTPND EQU   TRMPRE
TRMNCPLK EQU   TRMLINK1
@NM00219 EQU   TRMLINK1
TRMDCONN EQU   TRMDCONS
TRMDCOP  EQU   TRMDCONS
TRMPMARY EQU   TRMLU1
@NM00218 EQU   TRMLU1
@NM00217 EQU   TRMLU1
TRMCDSRQ EQU   TRMLU1
TRMLSCVP EQU   TRMLU1
@NM00216 EQU   TRMLU1
@NM00215 EQU   TRMNCP1
TRMANS   EQU   TRMNCP1
TRMLINOP EQU   TRMNCP1
TRMINOP  EQU   TRMNCP1
TRMLYNCH EQU   TRMPRE1
TRMSPOUT EQU   TRMPRE1
TRMERLCK EQU   TRMPRE1
TRMQNPL  EQU   TRMPRE1
TRMSPACT EQU   TRMPRE1
TRMOCNI  EQU   TRMPRE1
TRMSESSN EQU   TRMPRE1
TRMCONT  EQU   TRMPRE1
TRMINERR EQU   TRMCDFD0
TRMLUTM  EQU   TRMCDFD0
TRMLUIT  EQU   TRMCDFD0
TRMLUREQ EQU   TRMCDFD0
TRMCDPRE EQU   TRMCDFD0
TRMWASCD EQU   TRMCDFD0
TRMSRPFG EQU   TRMCDFD0
TRMSESRQ EQU   TRMCDFD0
@NM00214 EQU   @NM00213
TRMENTRY EQU   @NM00213
TRMSRPTR EQU   TRMDIALQ
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
@NM00175 EQU   LCBCANCL+3
LCBCANTH EQU   LCBCANCL+1
@NM00174 EQU   LCBCANFG
LCBCANCD EQU   LCBCANFG
@NM00173 EQU   LCBCANFG
LCBCANEB EQU   LCBCANFG
LCBCANXT EQU   LCBCANFG
LCBDSTEA EQU   LCBQNX+16
@NM00172 EQU   LCBQNX+8
LCBIOSBS EQU   LCBQNX+5
@NM00171 EQU   LCBQNX+4
@NM00170 EQU   LCBQNXMN
LCBNX509 EQU   LCBQNXMN
LCBSIBPT EQU   @NM00168+8
LCBSUSPT EQU   @NM00168+4
LCBNCPPT EQU   @NM00168+1
@NM00169 EQU   @NM00168
LCBWRSCH EQU   LCBCOREQ+8
LCBCQLNK EQU   LCBCOREQ+4
LCBCQELE EQU   LCBCOREQ
LCBPAKCH EQU   LCBRSPIN+16
@NM00167 EQU   LCBRSPFG
LCBIMRSP EQU   LCBRSPFG
LCBPRSPO EQU   LCBRSPFG
LCBRSRH  EQU   LCBRSPFG
LCBEXPI  EQU   LCBRSPFG
@NM00166 EQU   LCBRSPIN+12
LCBUSUE1 EQU   LCBCSWU1
@NM00165 EQU   LCBCSWU1
@NM00164 EQU   LCBSCPRS+1
LCBDFCMD EQU   LCBSCPRS
LCBUSER  EQU   LCBLUSNS+2
LCBSMIN  EQU   LCBLUSNS+1
LCBSMAJ  EQU   LCBLUSNS
LCBPACRS EQU   LCBRHSV
@NM00163 EQU   LCBRHSV
LCBSNS0  EQU   LCBRSPIN+1
@NM00162 EQU   LCBRSPIN
EWAEND   EQU   EWADDIOS+71
EWASCSW  EQU   EWADDIOS+64
EWASNS   EQU   EWADDIOS
IOSPCIWA EQU   IOSPCISC+44
IOSPCIRS EQU   IOSPCISC+8
@NM00128 EQU   IOSPCISC+4
@NM00127 EQU   IOSPCISC
IOSWRNDR EQU   IOSWTOWA+4
IOSWTOPT EQU   IOSWTOWA+3
IOSWTOCP EQU   IOSWTOWA+2
IOSWTOCH EQU   IOSWTOWA
IOSATTWA EQU   IOSATTSC+40
@NM00126 EQU   IOSATTSC+24
IOSATTSN EQU   IOSATTSC
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTHSM   EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
UCBERADR EQU   UCBUCS+12
UCBFCBID EQU   UCBUCS+8
UCBERCNT EQU   UCBUCS+7
UCBRSV51 EQU   UCBUCS+6
UCBFCBPE EQU   UCBFCBOP
UCBRSV49 EQU   UCBFCBOP
UCBRSV48 EQU   UCBFCBOP
UCBRSV47 EQU   UCBFCBOP
UCBRSV46 EQU   UCBFCBOP
UCBRSV45 EQU   UCBFCBOP
UCBRSV44 EQU   UCBFCBOP
UCBFCBO1 EQU   UCBFCBOP
UCBUCSPE EQU   UCBUCSOP
UCBRSV43 EQU   UCBUCSOP
UCBRSV42 EQU   UCBUCSOP
UCBRSV41 EQU   UCBUCSOP
UCBRSV40 EQU   UCBUCSOP
UCBRSV39 EQU   UCBUCSOP
UCBUCSO2 EQU   UCBUCSOP
UCBUCSO1 EQU   UCBUCSOP
UCBUCSID EQU   UCBUCS
UCBMDRBA EQU   UCBMDRBF+1
UCBRV075 EQU   UCBMDRBF
UCBRV074 EQU   UCB3800X+32
UCBIMAGE EQU   UCB3800X+28
UCBFCBNM EQU   UCB3800X+24
UCBCHAR4 EQU   UCB3800X+20
UCBCHAR3 EQU   UCB3800X+16
UCBCHAR2 EQU   UCB3800X+12
UCBCHAR1 EQU   UCB3800X+8
UCBCGMID EQU   UCB3800X+4
UCBBRSTA EQU   UCBACTIV
UCBRV063 EQU   UCBACTIV
UCBRV062 EQU   UCBACTIV
UCBRV061 EQU   UCBACTIV
UCBRV060 EQU   UCBACTIV
UCBRV059 EQU   UCBACTIV
UCBRV058 EQU   UCBACTIV
UCBRV057 EQU   UCBACTIV
UCBRV050 EQU   UCB3800X+2
UCBCGMNO EQU   UCB3800X+1
UCBRV083 EQU   UCBOPTNS
UCBBRSTR EQU   UCBOPTNS
UCBRV056 EQU   UCBOPTNS
UCBRV055 EQU   UCBOPTNS
UCBRV054 EQU   UCBOPTNS
UCBRV053 EQU   UCBOPTNS
UCBRV052 EQU   UCBOPTNS
UCBRV051 EQU   UCBOPTNS
UCBRV073 EQU   UCB3540X+7
UCBRV072 EQU   UCBDKBYT
UCBRV071 EQU   UCBDKBYT
UCBRV070 EQU   UCBDKBYT
UCBRV069 EQU   UCBDKBYT
UCBRV068 EQU   UCBDKBYT
UCBRV067 EQU   UCBDKBYT
UCBVLVER EQU   UCBDKBYT
UCBDKAMX EQU   UCBDKBYT
UCBVLSER EQU   UCB3540X
UCBRDATA EQU   UCBOCR+4
UCBFRID  EQU   UCBOCR
UCBCLN   EQU   UCBMT+14
UCBERG   EQU   UCBMT+12
UCBMS    EQU   UCBMT+11
UCBNB    EQU   UCBMT+10
UCBPW    EQU   UCBMT+9
UCBPR    EQU   UCBMT+8
UCBSIO   EQU   UCBMT+6
UCBTW    EQU   UCBMT+5
UCBTR    EQU   UCBMT+4
UCBTWT   EQU   UCBMT+3
UCBTRT   EQU   UCBMT+2
UCBCTD   EQU   UCBMT
UCBWTOID EQU   UCBCMEXT+17
UCBRV043 EQU   UCBCMEXT+16
UCBASID  EQU   UCBCMEXT+14
UCBMFCNT EQU   UCBCMEXT+12
UCBPMSK  EQU   UCBCMEXT+10
UCBCCWOF EQU   UCBCMEXT+8
UCBRV041 EQU   UCBCMEXT+6
UCBRV036 EQU   UCBFLP1
UCBRV035 EQU   UCBFLP1
UCBERLOG EQU   UCBFLP1
UCBRV033 EQU   UCBFLP1
UCBINHIO EQU   UCBFLP1
UCBNSWAP EQU   UCBFLP1
UCBSHRUP EQU   UCBFLP1
UCBNSRCH EQU   UCBFLP1
UCBSNSCT EQU   UCBCMEXT+4
UCBHPDV  EQU   @NM00234
UCBHALI  EQU   @NM00234
UCBRSV09 EQU   @NM00234
UCBRSV08 EQU   @NM00234
UCBRSV07 EQU   @NM00234
UCBRSV06 EQU   @NM00234
UCBRSV05 EQU   @NM00234
UCBRSV04 EQU   @NM00234
UCBDTI   EQU   UCBCMEXT+2
UCBSTI   EQU   UCBCMEXT+1
UCBEXTP  EQU   UCBEXTPT+1
UCBDDRSW EQU   UCBFLC
UCBTICBT EQU   UCBFLC
UCBIVRR  EQU   UCBFLC
UCBIVRS  EQU   UCBFLC
UCBITF   EQU   UCBFLC
UCBUDE   EQU   UCBFLC
UCBWAA   EQU   UCBFLC
UCBATTP  EQU   UCBFLC
UCBUNTYP EQU   UCBTBYT4
UCBRSV11 EQU   UCBDVCLS
UCBRSV10 EQU   UCBDVCLS
UCB3CHAR EQU   UCBDVCLS
UCB3UREC EQU   UCBDVCLS
UCB3DISP EQU   UCBDVCLS
UCB3DACC EQU   UCBDVCLS
UCB3COMM EQU   UCBDVCLS
UCB3TAPE EQU   UCBDVCLS
UCBDVPWR EQU   UCB2OPT7
UCBVLPWR EQU   UCB2OPT6
UCB2OPT5 EQU   UCBTBYT2
UCBRVDEV EQU   UCBRWTAU
UCBRPS   EQU   UCBDUDN2
UCBRR    EQU   UCBDUDN1
UCB2OPT1 EQU   UCBTBYT2
UCB2OPT0 EQU   UCBTBYT2
UCB1FEA7 EQU   UCBTBYT1
UCBD6250 EQU   UCB1FEA6
UCBD1600 EQU   UCB1FEA5
UCB1FEA4 EQU   UCBTBYT1
UCB1FEA3 EQU   UCBTBYT1
UCB1FEA2 EQU   UCBTBYT1
UCB1FEA1 EQU   UCBTBYT1
UCB1FEA0 EQU   UCBTBYT1
UCBRV029 EQU   UCBWGT
UCBVHRSN EQU   UCBWGT
UCBVORSN EQU   UCBWGT
UCBMTPXP EQU   UCBWGT
UCBREW   EQU   UCBWGT
UCBPUB   EQU   UCBWGT
UCBOUT   EQU   UCBWGT
UCBIN    EQU   UCBWGT
UCBCPU   EQU   UCBOB+11
UCBLCI   EQU   UCBOB+10
UCBCNT   EQU   UCBOB+9
UCBRV017 EQU   UCBCHM1
UCBRV016 EQU   UCBCHM1
UCBRV015 EQU   UCBCHM1
UCBRV014 EQU   UCBCHM1
UCBSPB   EQU   UCBPTH1
UCBPPB   EQU   UCBPTH1
UCBSPA   EQU   UCBPTH0
UCBPPA   EQU   UCBPTH0
UCBSIGP  EQU   UCBFLB
UCBVALPH EQU   UCBFLB
UCBCRHSN EQU   UCBFLB
UCBCRHRV EQU   UCBFLB
UCBRESVH EQU   UCBFLB
UCBSPST  EQU   UCBFLB
UCBASNS  EQU   UCBFLB
UCBIORST EQU   UCBFLB
UCBQISCE EQU   UCBFL1
UCBACTV  EQU   UCBFL1
UCBSAP   EQU   UCBFL1
UCBNOTRC EQU   UCBCUB
UCBPSNS  EQU   UCBFL1
UCBUSING EQU   UCBPST
UCBNOTRD EQU   UCBNRY
UCBBUSYD EQU   UCBBSY
UCBUA    EQU   UCBCHAN+1
UCBCHA   EQU   UCBCHAN
UCBDADI  EQU   UCBSTAT
UCBSYSR  EQU   UCBSTAT
UCBPRES  EQU   UCBSTAT
UCBALOC  EQU   UCBSTAT
UCBUNLD  EQU   UCBSTAT
UCBRESV  EQU   UCBSTAT
UCBCHGS  EQU   UCBSTAT
UCBONLI  EQU   UCBSTAT
UCBID    EQU   UCBOB+2
UCBALTPH EQU   UCBFL5
UCBALTCU EQU   UCBFL5
UCBNALOC EQU   UCBFL5
UCBENVRD EQU   UCBFL5
UCBVSDR  EQU   UCBFL5
UCBSASK  EQU   UCBFL5
UCBAMV   EQU   UCBAF
UCBDCC   EQU   UCBFL5
UCBMONT  EQU   UCBJBNR
UCBRV011 EQU   UCBJBNR
UCBMMSGP EQU   UCBJBNR
UCBOLDSM EQU   UCBJBNR
UCBRV003 EQU   UCBJBNR
UCBDUC   EQU   UCBJBNR
UCBJES3  EQU   UCBJBNR
UCBVRDEV EQU   UCBJBNR
UCBCMSEG EQU   UCBOB
UCBPFXND EQU   UCB+512
UCBIOQ   EQU   UCB+508
UCBLOCK  EQU   UCB+504
UCBPXST  EQU   UCB+504
@NM00231 EQU   UCB
TRMOPTBL EQU   IEDQTRM+18
TRMOPNO  EQU   IEDQTRM+17
TRMCHCIN EQU   IEDQTRM+16
TRMSENSE EQU   TRMSTAT+3
TRMTEMPR EQU   TRMSTAT+2
TRMNADDR EQU   TRMOWNER
@NM00212 EQU   TRMDEVFL+1
TRMTPIN  EQU   TRMDEVFL+1
@NM00211 EQU   TRMNCPI
TRMRNTRM EQU   TRMDEVFL+1
@NM00210 EQU   TRMDEVFL+1
TRMLMD   EQU   TRMDEVFL+1
TRMCONC  EQU   TRMDEVFL+1
TRMTSOB  EQU   TRMDEVFL
TRMBFDY  EQU   TRMDEVFL
TRMTBLK  EQU   TRMDEVFL
TRMSBLK  EQU   TRMDEVFL
TRMBLKS  EQU   TRMDEVFL
TRMSCV   EQU   TRMADDC
TRMDDIG  EQU   TRMDEVFL
TRMBUFS  EQU   TRMDEVFL
TRMSTEAL EQU   TRMPRILK
TRMLGB   EQU   TRMDSORG
TRMUTERM EQU   TRMSESCT
TRMVERIF EQU   TRMRSTRT
@NM00209 EQU   TRMRSTRT
@NM00208 EQU   TRMDESTQ
TRMSCNYN EQU   TRMSTATE
TRMOPTFN EQU   TRMSTATE
TRMHELDN EQU   TRMSTATE
TRMACPTN EQU   TRMSTATE
TRMPREF  EQU   TRMSTATE
TRMPROC  EQU   TRMLOG
TRMLIST  EQU   TRMLOG
TRMLINE  EQU   TRMSTATE
TRMSUBST EQU   IEDNTRM+16
TRMTYPE  EQU   IEDNTRM+15
TRMPRIME EQU   TRMLGBST
TRMOWNR  EQU   TRMLTRAC+1
TRMGPCNT EQU   TRMLTRAC
TRMBUFRD EQU   TRMBYTE0
TRMSNA   EQU   TRMBYTE0
TRMGP    EQU   TRMBYTE0
TRMDIAL  EQU   TRMBYTE0
TRMACDC  EQU   TRMNOWCD
TRMOUTPT EQU   TRMBYTE0
TRMINPUT EQU   TRMBYTE0
TRMUDEF  EQU   TRMBYTE0
TRMCOHRT EQU   IEDNTRM+8
TRMSTOTE EQU   TRMBYTE1
TRMCKPRN EQU   TRMBYTE1
TRMTSATN EQU   TRMBYTE1
TRMTRACE EQU   TRMBYTE1
TRMSWBCK EQU   TRMBYTE1
TRMAUTOC EQU   TRMBYTE1
TRMINPTP EQU   TRMBYTE1
TRMWTNEG EQU   TRMSCPRQ
TRMWRBRK EQU   TRMBYTE2
TRMNOSND EQU   TRMBYTE2
TRMPREP  EQU   TRMBYTE2
TRMGPACT EQU   TRMBYTE2
TRMANDL  EQU   TRMBYTE2
TRMCLOSN EQU   TRMINPG
TRMREMB  EQU   TRMBYTE2
TRMRSACT EQU   TRMBYTE2
@NM00207 EQU   TRMCDF0
TRMPURGE EQU   TRMCDF0
TRMCDST  EQU   TRMINDEX
TCXEND   EQU   IEDQTCXD+224
TCXNCPIO EQU   IEDQTCXD+220
TCXACTE8 EQU   TCXQE8
TCXABEPL EQU   IEDQTCXD+212
TCXSRBS  EQU   IEDQTCXD+208
TCXSIOSB EQU   IEDQTCXD+204
TCXERPSV EQU   IEDQTCXD+116
TCXSATTN EQU   IEDQTCXD+112
@NM00206 EQU   TCXDSAVE+4
@NM00205 EQU   TCXDSAVE
TCXPLCB  EQU   IEDQTCXD+100
TCXBITS  EQU   IEDQTCXD+98
TCXSCBSZ EQU   IEDQTCXD+97
TCXBIT1  EQU   IEDQTCXD+96
TCXCOMPT EQU   IEDQTCXD+92
TCXAVAIL EQU   IEDQTCXD+88
TCXBUFL  EQU   IEDQTCXD+84
TCXTOTE  EQU   TCXBUFA
TCXCKPM  EQU   IEDQTCXD+79
TCXNCKPR EQU   IEDQTCXD+78
TCXSZAIB EQU   IEDQTCXD+76
TCXAIBC  EQU   IEDQTCXD+72
TCXPEBC  EQU   IEDQTCXD+68
TCXPEWAC EQU   IEDQTCXD+64
TCXQRQ   EQU   IEDQTCXD+60
TCXOCQ   EQU   IEDQTCXD+56
TCXPNTQ  EQU   IEDQTCXD+52
TCXPUTQ  EQU   IEDQTCXD+48
TCXGETQ  EQU   IEDQTCXD+44
TCXTSI   EQU   IEDQTCXD+40
TCXRPT   EQU   IEDQTCXD+36
TCXAPDMP EQU   TCXFLAG1
TCXAPPL  EQU   TCXFLAG1
TCXRTM   EQU   TCXFLAG1
TCXMCPCD EQU   TCXFLAG1
TCXAUTH  EQU   TCXFLAG1
TCXASID  EQU   IEDQTCXD+32
TCXASCB  EQU   IEDQTCXD+28
TCXREADY EQU   IEDQTCXD+24
TCXPASWD EQU   IEDQTCXD+16
TCXDISP  EQU   IEDQTCXD+12
TCXTCB   EQU   IEDQTCXD+8
TCXATTLN EQU   TCXATTEN
RQEHDR   EQU   IEDRQE+16
RQETCBAD EQU   IEDRQE+13
RQEKEY   EQU   IEDRQE+12
RQEDEB   EQU   IEDRQE+9
RQEPR    EQU   IEDRQE+8
RQETCB   EQU   IEDRQE+4
RQELNK   EQU   IEDRQE
LCBERADR EQU   LCBXRADR+1
LCBPCIRC EQU   LCBXRADR
LCBDCT3  EQU   LCBXDCT+2
LCBDCT2  EQU   LCBXDCT+1
LCBDCT1  EQU   LCBXDCT
@NM00180 EQU   LCBXFLAG
LCBERPND EQU   LCBXFLAG
LCBSRCPF EQU   LCBXFLAG
LCBGPCTV EQU   LCBXFLAG
@NM00179 EQU   LCBXFLAG
@NM00178 EQU   LCBXFLAG
@NM00177 EQU   LCBXFLAG
@NM00176 EQU   LCBXFLAG
LCBCCW10 EQU   LCBCPA+72
LCBCCW9  EQU   LCBCPA+64
LCBCCW8  EQU   LCBCPA+56
LCBCCW6  EQU   LCBCPA+40
LCBCP    EQU   LCBQEBPL+4
LCBIOSB  EQU   LCBQEBPL+1
LCBSIO   EQU   LCBQEBPL
LCBCCW1  EQU   LCBCPA
@NM00161 EQU   LCBERCCW+16
LCBATL05 EQU   LCBERCCW+8
@NM00160 EQU   LCBERCCW
LCBBFSNS EQU   LCBRSPSV
LCBWAITC EQU   LCBTPCD+5
LCBINPAK EQU   LCBSTAT6
LCBMHBID EQU   LCBSTAT6
@NM00159 EQU   LCBSTAT6
LCBHDRPD EQU   LCBSTAT6
LCBCHN   EQU   LCBSTAT6
LCBBFRSV EQU   LCBTPCD+1
@NM00158 EQU   LCBSTAT5
LCBSUSFG EQU   LCBSTAT5
LCBLUS   EQU   LCBSTAT5
LCBLUNIT EQU   LCBSTAT5
LCBPERM  EQU   LCBSTAT5
LCBNXCMD EQU   LCBBFRW
@NM00157 EQU   LCBSTAT7
LCBCDFD0 EQU   LCBSTAT7
LCBSCBA  EQU   IEDQLCB+93
LCBOLT   EQU   LCBMSGFM
LCBEOT   EQU   LCBMSGFM
LCBENQ   EQU   LCBMSGFM
LCBTTD   EQU   LCBMSGFM
LCBRSTRT EQU   LCBMSGFM
LCBVSTRT EQU   LCBMSGFM
LCBACKI  EQU   LCBMSGFM
LCBNAK   EQU   LCBMSGFM
@NM00156 EQU   LCBRBCT2
LCBDCNT  EQU   LCBRBCT2
LCBRBCT1 EQU   LCBERBCT
LCBERBCH EQU   IEDQLCB+85
LCBCOMPL EQU   LCBDLNKN
LCBPRCPG EQU   LCBERBST
LCBERROR EQU   LCBERBST
LCBLOGDV EQU   LCBERBST
LCBINQ   EQU   LCBERBST
LCBRDERR EQU   LCBERBST
LCBEOMSG EQU   LCBERBST
LCBMSG   EQU   LCBERBST
LCBERBLK EQU   IEDQLCB+81
LCBERBPY EQU   IEDQLCB+80
LCBERBQB EQU   LCBERB+1
LCBERBKY EQU   LCBERB
LCBRECAD EQU   IEDQLCB+73
@NM00155 EQU   LCBTSTSW
@NM00154 EQU   LCBTSTSW
@NM00153 EQU   LCBTSTSW
@NM00152 EQU   LCBTSTSW
@NM00151 EQU   LCBTSTSW
@NM00150 EQU   LCBTSTSW
@NM00149 EQU   LCBTSTSW
LCBCONCT EQU   LCBTSTSW
LCBRESP  EQU   LCBSTAT2
LCBBFRAV EQU   LCBDIAL
LCBATTN  EQU   LCBSYNC
LCBNEGRP EQU   LCBSTAT2
LCBSNDPR EQU   LCBSTAT2
LCBCONNN EQU   LCBBEOTN
LCBMSGNN EQU   LCBSTAT2
LCBTRACE EQU   LCBSTAT2
LCBRECVN EQU   LCBSTAT1
LCBFREEN EQU   LCBSTAT1
LCBCONT  EQU   LCBSTAT1
LCBINITN EQU   LCBSTAT1
LCBOCNI  EQU   LCBSTAT1
LCBOCWTN EQU   LCBSTAT1
LCBRCLLN EQU   LCBSTAT1
LCBRECOF EQU   IEDQLCB+68
LCBRDBFR EQU   LCBRCBFR
LCBUCBX  EQU   IEDQLCB+64
LCBTTBIN EQU   LCBERRCT
LCBINTBF EQU   LCBINCAM+1
@NM00148 EQU   LCBINCAM
LCBGETMN EQU   LCBINCAM
@NM00146 EQU   LCBRESTR+1
LCBCMDSV EQU   LCBRESTR
LCBPCILK EQU   LCBDCBPT
LCBAP4OL EQU   LCBSIOCC
LCBAP3OL EQU   LCBSIOCC
LCBAP2OL EQU   LCBSIOCC
LCBAP1OL EQU   LCBSIOCC
@NM00145 EQU   LCBSIOCC
LCBCSWRC EQU   LCBCSW+5
LCBUSUE  EQU   LCBCSWUS
LCBUSDE  EQU   LCBCSWUS
LCBUSCE  EQU   LCBCSWUS
LCBUSBSY EQU   LCBCSWUS
LCBUSCUE EQU   LCBCSWUS
LCBUSSM  EQU   LCBCSWUS
LCBUSAT  EQU   LCBCSWUS
LCBOBR   EQU   LCBFLAG3
LCBOBRRD EQU   LCBFLAG3
LCBIOMSG EQU   LCBFLAG3
LCBSOHC  EQU   LCBFLAG3
LCBSOHR  EQU   LCBFLAG3
@NM00144 EQU   LCBFLAG3
LCBECBPT EQU   LCBIOBSN+4
LCBSENS1 EQU   LCBSNS+1
LCBABORT EQU   LCBTMOUT
@NM00143 EQU   LCBFLAG1
LCBUNREL EQU   LCBFLAG1
LCBEXCPN EQU   LCBFLAG1
@NM00142 EQU   LCBFLAG1
LCBERPIN EQU   LCBFLAG1
@NM00141 EQU   LCBFLAG1
LCBFSBFR EQU   LCBMHA
LCBISZE  EQU   IEDQLCB+28
LCBLNENT EQU   LCBSCBDA+1
@NM00140 EQU   LCBSCBDA
LCBCPGMH EQU   LCBSTAT4
LCBREAL  EQU   LCBPHASE
@NM00139 EQU   LCBSTAT4
LCBACTRQ EQU   LCBSTAT4
LCBIPLRQ EQU   LCBSTAT4
LCBDACRQ EQU   LCBSTAT4
LCBDMPRQ EQU   LCBSTAT4
@NM00138 EQU   LCBLKMDE
LCBLOCKI EQU   LCBLKMDE
LCBLOCKR EQU   LCBLKMDE
LCBHMFLG EQU   LCBLKMDE
LCBBDFLG EQU   LCBLKMDE
LCBLKDST EQU   LCBINSRC
LCBABRTN EQU   LCBCHAIN
LCBCTLMD EQU   LCBTETEN
LCBBFRSZ EQU   LCBCHAIN
LCBUREQN EQU   LCBCHAIN
LCBNORTY EQU   LCBCHAIN
LCBERMSG EQU   LCBCHAIN
LCBEXCP  EQU   LCBCHAIN
LCBINVRQ EQU   LCBSCRNN
LCB2741N EQU   LCBTSOB
LCBINHBN EQU   LCBTSOB
LCBCIRCD EQU   LCBTSOB
LCBPREP  EQU   LCBTSOB
LCBSOPL  EQU   LCBTSOB
LCBSATRD EQU   LCBTSOB
LCBTSBUF EQU   LCBTSOB
LCBWRBRK EQU   LCBTSOB
LCBTDL   EQU   IEDQLCB+18
LCBEOLTD EQU   IEDQLCB+16
LCBRSLNK EQU   IEDQLCB+13
LCBRSPRI EQU   IEDQLCB+12
LCBSTCBA EQU   IEDQLCB+9
LCBRSKEY EQU   IEDQLCB+8
LCBLINK  EQU   LCBRCB+5
LCBPRI   EQU   LCBRCB+4
LCBQCBA  EQU   LCBRCB+1
LCBKEY   EQU   LCBRCB
EWACPU   EQU   EWA+27
@NM00137 EQU   EWA+26
EWACHA   EQU   EWA+24
EWACSEQ  EQU   EWAXCSW2
EWACDIN  EQU   EWAXCSW2
@NM00136 EQU   EWAXCSW2
EWACTEC  EQU   EWAXCSW2
EWACDAV  EQU   EWAXCSW1
EWACCHV  EQU   EWAXCSW1
EWACCMD  EQU   EWAXCSW1
EWACUNS  EQU   EWAXCSW1
EWACSQV  EQU   EWAXCSW1
@NM00135 EQU   EWAXCSW1
EWACITF  EQU   EWAXCSW1
@NM00134 EQU   EWARGFG2
EWACCUE  EQU   EWARGFG2
EWACSTG  EQU   EWARGFG2
EWACSCU  EQU   EWARGFG2
EWACCHA  EQU   EWARGFG2
EWACCPU  EQU   EWARGFG2
EWANORTY EQU   EWARGFG1
EWACCNT  EQU   EWARGFG1
EWACSNS  EQU   EWARGFG1
@NM00133 EQU   EWARGFG1
EWACHIO  EQU   EWARGFG1
EWACTIO  EQU   EWARGFG1
EWACINT  EQU   EWARGFG1
EWACSIO  EQU   EWARGFG1
EWAUCB   EQU   EWAERPIB+1
@NM00132 EQU   EWAERPIB
EWASTUP  EQU   EWA+14
EWACNTR4 EQU   EWACNTRS+3
EWACNTR3 EQU   EWACNTRS+2
EWACNTR2 EQU   EWACNTRS+1
EWACNTR1 EQU   EWACNTRS
EWASSTAT EQU   EWA+8
EWASCTMX EQU   EWASNSCT
@NM00131 EQU   EWASNSCT
EWAJAM   EQU   EWAFLG3
@NM00130 EQU   EWAFLG2
EWADIR   EQU   EWAFLG2
EWACOVF  EQU   EWAFLG2
EWAWTEMP EQU   EWAFLG2
EWAMDR   EQU   EWAFLG2
EWABDSNS EQU   EWAFLG1
EWADDMSG EQU   EWAFLG1
EWASCC1  EQU   EWASCC3
EWASCC2  EQU   EWASCC3
@NM00129 EQU   EWAFLG1
EWASLIS  EQU   EWAFLG1
EWAEXT   EQU   EWAHDR
IOSEND   EQU   IOSB+108
IOSSKR   EQU   IOSEEKA+7
IOSSKH2  EQU   IOSSKHH+1
IOSSKH1  EQU   IOSSKHH
IOSSKCC  EQU   IOSCCHH
IOSSKBB  EQU   IOSEEKA+1
IOSSKM   EQU   IOSEEKA
IOSEEK   EQU   IOSB+92
IOSMDM   EQU   IOSB+91
IOSMDB   EQU   IOSB+90
IOSCKEY7 EQU   IOSCKEY
IOSCKEY6 EQU   IOSCKEY
IOSCKEY5 EQU   IOSCKEY
IOSCKEY4 EQU   IOSCKEY
@NM00125 EQU   IOSCKEY
IOSFMSK  EQU   IOSB+88
IOSCUDEV EQU   IOSPATH+1
@NM00124 EQU   IOSCHN
IOSPATH3 EQU   IOSCHN
IOSPATH2 EQU   IOSCHN
IOSEXP   EQU   IOSCHN
IOSGDP   EQU   IOSCHN
IOSAFF   EQU   IOSB+85
IOSRSS1B EQU   IOSB+84
IOSDIE   EQU   IOSB+68
IOSABN   EQU   IOSB+64
IOSNRM   EQU   IOSB+60
IOSPCI   EQU   IOSB+56
IOSPCHN  EQU   IOSB+48
IOSAPMSK EQU   IOSB+40
IOSRES4A EQU   IOSB+36
IOSSRB   EQU   IOSB+28
IOSCSWRC EQU   IOSCSW+5
IOSTSB   EQU   IOSTATUS+1
IOSTSA   EQU   IOSTATUS
IOSOPT2X EQU   IOSOPT2
IOSIGP   EQU   IOSOPT2
IOSHTP   EQU   IOSOPT2
IOSRELSE EQU   IOSOPT
IOSAPR   EQU   IOSOPT
IOSTSLL  EQU   IOSOPT
IOSNERP  EQU   IOSOPT
IOSPSLL  EQU   IOSOPT
IOSQISCE EQU   IOSOPT
IOSDEP   EQU   IOSOPT
IOSBYP   EQU   IOSOPT
IOSPKY7  EQU   IOSPKEY
IOSPGDPX EQU   IOSPKEY
IOSIDR   EQU   IOSPKEY
IOSLCL   EQU   IOSPKEY
@NM00122 EQU   IOSPKEY
IOSPGAD  EQU   IOSB+8
IOSASID  EQU   IOSB+6
IOSPRLVL EQU   IOSB+5
IOSDVRID EQU   IOSB+4
IOSPROC  EQU   IOSB+3
IOSFLC7  EQU   IOSFLC
IOSCTCNR EQU   IOSFLC
IOSRWAIT EQU   IOSFLC
IOSTP    EQU   IOSFLC
IOSCC3WE EQU   IOSFLC
IOSVERIF EQU   IOSDVALT
IOSDVMNT EQU   IOSFLC
IOSBDCST EQU   IOSFLB
IOSFLB4  EQU   IOSFLB
IOSFLB3  EQU   IOSFLB
IOSNOTRS EQU   IOSFLB
IOSSDR   EQU   IOSFLB
IOSDIESE EQU   IOSFLB
IOSIOSB  EQU   IOSFLA
IOSDOM   EQU   IOSFLA
IOSSMDB  EQU   IOSFLA
IOSSMDA  EQU   IOSFLA
IOSCCHN  EQU   IOSACHN
IOSDCHN  EQU   IOSACHN
DEBAPPAD EQU   IEDQDEB+65
DEBEXSCL EQU   IEDQDEB+64
DEBDCBAD EQU   IEDQDEB+61
DEBPROTG EQU   IEDQDEB+60
DEBECBAD EQU   IEDQDEB+57
DEBPRIOR EQU   IEDQDEB+56
DEBUSRPG EQU   IEDQDEB+53
DEBSYSPG EQU   IEDQDEB+49
DEBOPATB EQU   IEDQDEB+48
DEBIRBAD EQU   IEDQDEB+45
DEBOFLGS EQU   IEDQDEB+44
DEBDEBAD EQU   IEDQDEB+41
DEBAMLNG EQU   IEDQDEB+40
DEBTCBAD EQU   IEDQDEB+37
DEBNMSUB EQU   IEDQDEB+36
@NM00121 EQU   DEBPRF+33
DEBLNGTH EQU   DEBPRF+32
DEBDCBMK EQU   DEBPRF+28
DEBDSCBA EQU   DEBPRF+21
DEBWKARA EQU   DEBPRF+20
DEBXCEA  EQU   DEBAPVT+16
DEBCEA   EQU   DEBAPVT+12
DEBPCIA  EQU   DEBAPVT+8
DEBEOEA  EQU   DEBAPVT
DCBBUFSI EQU   IHADCS43+6
DCBUNTCT EQU   IHADCS43+5
DCBILCT  EQU   IHADCS43+4
DCBSCTAD EQU   DCBSCTAB+1
@NM00120 EQU   DCBSCTAB
DCBPUTA  EQU   DCBGETA
@NM00119 EQU   DCBPUT
DCBDEBA  EQU   DCBDEBAD+1
@NM00118 EQU   DCBIFLGS
DCBIFIOE EQU   DCBIFLGS
DCBCH12  EQU   DCBIFPCT
DCBCH9   EQU   DCBIFPCT
DCBIFEC  EQU   DCBIFLGS
DCBMFSTI EQU   DCBMFDMD
DCBMFAWR EQU   DCBMFSTK
DCBMFUIP EQU   DCBMFTMD
DCBMFIDW EQU   DCBMFLCP
DCBMFWRK EQU   DCBMFMVP
DCBMFRDQ EQU   DCBMFWRT
DCBMFGTQ EQU   DCBMFPUT
DCBMFSTL EQU   DCBMACF2
DCBMFCK  EQU   DCBMFDMG
DCBMFRDX EQU   DCBMFCHK
DCBMFDBF EQU   DCBMFSBG
DCBMFRDI EQU   DCBMFLCG
DCBMFRDK EQU   DCBMFMVG
DCBMFWRQ EQU   DCBMFRD
DCBMFPTQ EQU   DCBMFGET
DCBMFECP EQU   DCBMACF1
DCBTIOT  EQU   IHADCS25
DCBMRSTI EQU   DCBMRDMD
DCBMRAWR EQU   DCBMRSTK
DCBMRUIP EQU   DCBMRTMD
DCBMRIDW EQU   DCBMRLCP
DCBMRWRK EQU   DCBMRMVP
DCBMRRDQ EQU   DCBMRWRT
DCBMRGTQ EQU   DCBMRPUT
DCBMRSTL EQU   DCBMACR2
DCBMRCK  EQU   DCBMRDMG
DCBPGFXA EQU   DCBMRRDX
DCBMRDBF EQU   DCBMRSBG
DCBMRRDI EQU   DCBMRLCG
DCBMRRDK EQU   DCBMRMVG
DCBMRWRQ EQU   DCBMRRD
DCBMRPTQ EQU   DCBMRGET
DCBMRECP EQU   DCBMACR1
@NM00117 EQU   DCBIFLG
DCBIBIOE EQU   DCBIFLG
DCBICH12 EQU   DCBIBPCT
DCBICH9  EQU   DCBIBPCT
DCBIBEC  EQU   DCBIFLG
DCBOFIOF EQU   DCBOFLGS
DCBOFUEX EQU   DCBOFLGS
DCBOFTM  EQU   DCBOFLGS
DCBOFPPC EQU   DCBOFLGS
DCBOFOPN EQU   DCBOFLGS
DCBOFEOV EQU   DCBOFLGS
DCBOFLRB EQU   DCBOFLGS
DCBOFIOD EQU   DCBOFLWR
DCBDDNAM EQU   IHADCS24
DCBEXLSA EQU   DCBEXLST+1
DCBRNCKA EQU   DCBRNCKD+1
@NM00116 EQU   DCBRNCKD
DCBIOBAD EQU   IHADCS2K+8
DCBDSGTR EQU   DCBDSRG2
@NM00115 EQU   DCBDSRG2
DCBDSRG1 EQU   DCBDSORG
DCBCHNGL EQU   DCBTRSTA
DCBNIDLE EQU   DCBTRSTA
DCBBAKUP EQU   DCBTRSTA
DCBIPLED EQU   DCBTRSTA
DCBRSTRT EQU   DCBTRSTA
DCBINITL EQU   DCBTRSTA
DCBAUTOD EQU   DCBTRSTA
DCBAUTOI EQU   DCBTRSTA
@NM00114 EQU   IHADCS2K+4
DCBDUMPA EQU   DCBDUMPD+1
DCBUNITN EQU   DCBDUMPD
DCBBCKUA EQU   DCBBCKUP+1
@NM00113 EQU   DCBBCKUP
DCBIPLTX EQU   IHADCS1A
@NM00112 EQU   IHADCB
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00111 EQU   CVTFIX+248
@NM00110 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTCCVT  EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
CCWCOUNT EQU   CCW+6
CCWRSV   EQU   CCW+5
@NM00109 EQU   CCWFLAGS
CCWIDA   EQU   CCWFLAGS
CCWPCI   EQU   CCWFLAGS
CCWSKIP  EQU   CCWFLAGS
CCWSLI   EQU   CCWFLAGS
SAVTLLCB EQU   IEDNSVTD+380
SAVTSCF0 EQU   IEDNSVTD+376
SAVTLSNY EQU   IEDNSVTD+372
SAVTLSZP EQU   IEDNSVTD+368
SAVTOMSU EQU   IEDNSVTD+364
SAVTGTSB EQU   IEDNSVTD+360
SAVTHIBL EQU   IEDNSVTD+356
SAVTHISY EQU   IEDNSVTD+352
SAVTNAX2 EQU   IEDNSVTD+348
SAVTCDRU EQU   IEDNSVTD+344
SAVTPOLC EQU   IEDNSVTD+342
SAVTPOLM EQU   IEDNSVTD+340
SAVTPOLR EQU   IEDNSVTD+336
SAVTCDRN EQU   SAVTCDRV
SAVTPOLL EQU   IEDNSVTD+328
SAVTPOLN EQU   IEDNSVTD+326
@NM00108 EQU   IEDNSVTD+325
@NM00107 EQU   SAVTNETF
SAVTSDIS EQU   SAVTNETF
SAVTROUT EQU   SAVTNETF
SAVTNETW EQU   SAVTNETF
SAVTDIAL EQU   IEDNSVTD+320
SAVTRQUT EQU   IEDNSVTD+316
SAVTBITN EQU   IEDNSVTD+312
@NM00106 EQU   SAVTCKQB+8
@NM00105 EQU   SAVTCKEC+1
@NM00104 EQU   SAVTCKCC
SAVTCKPO EQU   SAVTCKCC
SAVTCKWA EQU   SAVTCKCC
SAVTCKCH EQU   SAVTCKTB+1
SAVTCKVT EQU   SAVTCKTB
@NM00103 EQU   IEDNSVTD+297
SAVTRDFG EQU   SAVTRDRV+12
@NM00102 EQU   SAVTRDRV+5
SAVTRDPY EQU   SAVTRDRV+4
SAVTRDQB EQU   SAVTRDRV+1
SAVTRDKY EQU   SAVTRDRV
SAVTNID  EQU   IEDNSVTD+280
SAVTDVAS EQU   IEDNSVTD+276
SAVTPLSZ EQU   IEDNSVTD+274
@NM00101 EQU   IEDNSVTD+273
SAVTSUBL EQU   IEDNSVTD+272
@NM00100 EQU   SAVTZELM+1
SAVTSUBM EQU   SAVTZELM
SAVTMHDX EQU   IEDNSVTD+268
SAVTNAT1 EQU   IEDNSVTD+266
SAVTSH20 EQU   IEDNSVTD+264
SAVTLCBS EQU   IEDNSVTD+260
SAVTRNMP EQU   IEDNSVTD+256
SAVTTNTX EQU   IEDNSVTD+252
SAVTNAX  EQU   IEDNSVTD+248
SAVTSUBV EQU   IEDNSVTD+247
SAVTSUBA EQU   IEDNSVTD+246
SAVTSIBC EQU   IEDNSVTD+244
SAVTBSM  EQU   IEDNSVTD+240
SAVTSCPT EQU   SAVTTCPU
SAVTRQTG EQU   IEDNSVTD+236
SAVTRQCH EQU   IEDNSVTD+232
SAVTMAND EQU   IEDNSVTD+228
SAVTSPLN EQU   IEDNSVTD+224
SAVTNADL EQU   IEDNSVTD+222
SAVTNATL EQU   IEDNSVTD+220
SAVTMHTB EQU   IEDNSVTD+216
SAVTSSMH EQU   IEDNSVTD+212
SAVTQRS  EQU   IEDNSVTD+208
SAVTRQIN EQU   IEDNSVTD+204
SAVTDFCO EQU   IEDNSVTD+200
SAVTSAO  EQU   IEDNSVTD+196
SAVTSARI EQU   IEDNSVTD+192
SAVTSAC  EQU   IEDNSVTD+188
SAVTSAI  EQU   IEDNSVTD+184
SAVTCSCI EQU   IEDNSVTD+180
SAVTSSRP EQU   IEDNSVTD+176
SAVTSSRQ EQU   IEDNSVTD+172
SAVTSCLU EQU   IEDNSVTD+168
SAVTXTRQ EQU   IEDNSVTD+164
SAVTMVBF EQU   IEDNSVTD+160
@NM00099 EQU   IEDNSVTD+148
SAVTIPCQ EQU   IEDNSVTD+144
@NM00098 EQU   IEDNSVTD+136
SAVTXFMI EQU   IEDNSVTD+132
@NM00097 EQU   IEDNSVTD+124
SAVTXFMO EQU   IEDNSVTD+120
@NM00096 EQU   IEDNSVTD+116
SAVTSSSR EQU   IEDNSVTD+112
SAVTSCPQ EQU   IEDNSVTD+108
SAVTSLCB EQU   IEDNSVTD+104
SAVTLUSR EQU   IEDNSVTD+100
@NM00095 EQU   SAVTLUSQ+8
SAVTLUSP EQU   SAVTLUSQ+4
SAVTLUSB EQU   SAVTLUSQ
@NM00094 EQU   IEDNSVTD+84
SAVTSAT  EQU   IEDNSVTD+80
SAVTNAT  EQU   IEDNSVTD+76
SAVTCLUP EQU   IEDNSVTD+72
SAVTPIUT EQU   IEDNSVTD+68
SAVTRNTA EQU   IEDNSVTD+64
SAVTDNIR EQU   IEDNSVTD+60
SAVTCNIR EQU   IEDNSVTD+56
SAVTFLDH EQU   IEDNSVTD+52
SAVTSRTN EQU   IEDNSVTD+48
SAVTSREQ EQU   IEDNSVTD+44
SAVTFAIL EQU   IEDNSVTD+42
SAVTSUSE EQU   IEDNSVTD+40
SAVTSIB  EQU   IEDNSVTD+36
SAVTPRTN EQU   IEDNSVTD+32
@NM00093 EQU   IEDNSVTD+28
SAVTWH20 EQU   IEDNSVTD+26
SAVTPWT  EQU   IEDNSVTD+24
SAVTPRTQ EQU   IEDNSVTD+20
SAVTPREQ EQU   IEDNSVTD+16
SAVTPH20 EQU   IEDNSVTD+14
SAVTPUSE EQU   IEDNSVTD+12
SAVTPLCB EQU   IEDNSVTD+8
SAVTPOOL EQU   IEDNSVTD+4
SAVTPRMT EQU   SAVTDIAF
SAVTVIRT EQU   SAVTDIAF
AVTSITS  EQU   IEDQAVTD+1264
AVTMSUHI EQU   IEDQAVTD+1260
AVTSITU  EQU   IEDQAVTD+1256
AVTSITP  EQU   IEDQAVTD+1252
AVTPADDR EQU   IEDQAVTD+1248
@NM00092 EQU   IEDQAVTD+1246
AVTCPBNO EQU   IEDQAVTD+1244
AVTHRESS EQU   IEDQAVTD+1243
@NM00091 EQU   IEDQAVTD+1242
@NM00090 EQU   IEDQAVTD+1241
@NM00089 EQU   IEDQAVTD+1240
@NM00088 EQU   IEDQAVTD+1237
@NM00087 EQU   IEDQAVTD+1236
AVTHRESE EQU   @NM00086
AVTRADDR EQU   IEDQAVTD+1228
AVTNADDR EQU   IEDQAVTD+1224
AVTHRESN EQU   IEDQAVTD+1220
AVTVOLRN EQU   IEDQAVTD+1216
AVTTOTNN EQU   IEDQAVTD+1212
AVTTRCYN EQU   IEDQAVTD+1208
AVTRCTRN EQU   IEDQAVTD+1204
AVTNOVON EQU   IEDQAVTD+1200
AVTADEBN EQU   IEDQAVTD+1196
AVTVOLRR EQU   IEDQAVTD+1192
AVTTOTNR EQU   IEDQAVTD+1188
AVTTRCYR EQU   IEDQAVTD+1184
AVTRCTRR EQU   IEDQAVTD+1180
AVTNOVOR EQU   IEDQAVTD+1176
AVTADEBR EQU   IEDQAVTD+1172
AVTLODPT EQU   IEDQAVTD+1168
AVTIOBN  EQU   IEDQAVTD+1164
AVTIOBR  EQU   IEDQAVTD+1160
AVTCPBPT EQU   IEDQAVTD+1156
AVTFCPB  EQU   IEDQAVTD+1152
@NM00085 EQU   IEDQAVTD+1148
AVTINCPQ EQU   IEDQAVTD+1144
@NM00084 EQU   IEDQAVTD+1140
@NM00083 EQU   IEDQAVTD+1137
@NM00082 EQU   AVTBIT4
@NM00081 EQU   AVTBIT4
@NM00080 EQU   AVTBIT4
@NM00079 EQU   AVTBIT4
@NM00078 EQU   AVTBIT4
@NM00077 EQU   AVTBIT4
@NM00076 EQU   AVTBIT4
AVTRUFTN EQU   AVTBIT4
@NM00075 EQU   IEDQAVTD+1132
AVTNOBFQ EQU   IEDQAVTD+1128
@NM00074 EQU   IEDQAVTD+1124
AVTDKENQ EQU   IEDQAVTD+1120
@NM00073 EQU   IEDQAVTD+1116
AVTDKAPQ EQU   IEDQAVTD+1112
AVTCOPY  EQU   IEDQAVTD+1108
AVTIA    EQU   IEDQAVTD+1104
AVTFL    EQU   IEDQAVTD+1100
@NM00072 EQU   IEDQAVTD+1096
AVTNCPBQ EQU   IEDQAVTD+1092
AVTTOTNC EQU   IEDQAVTD+1088
AVTCMAX  EQU   IEDQAVTD+1084
AVTCMIN  EQU   IEDQAVTD+1080
AVTHM02  EQU   IEDQAVTD+1076
AVTOPCIN EQU   IEDQAVTD+1074
AVTDCTLN EQU   IEDQAVTD+1072
AVTOPMSK EQU   IEDQAVTD+1068
AVTDDFT  EQU   IEDQAVTD+1064
AVTSTEAL EQU   IEDQAVTD+1060
AVTOPTN  EQU   IEDQAVTD+1056
AVTDSKCT EQU   IEDQAVTD+1054
AVTCKRST EQU   IEDQAVTD+1053
AVTSTAN  EQU   AVTBIT3
AVTSTACN EQU   AVTBIT3
AVTSTAIN EQU   AVTBIT3
AVTSTAYN EQU   AVTBIT3
AVTOLTBN EQU   AVTBIT3
AVTTSAB  EQU   AVTBIT3
AVTRFULN EQU   AVTBIT3
AVTRECVN EQU   AVTBIT3
@NM00071 EQU   AVTBIT2
@NM00070 EQU   AVTBIT2
AVTOPEIN EQU   AVTBIT2
AVTSTRTN EQU   AVTBIT2
AVTTOPOL EQU   AVTBIT2
AVTCOPYN EQU   AVTBIT2
AVTREUSN EQU   AVTBIT2
AVTEXTSC EQU   AVTBIT2
AVTDISKN EQU   AVTBIT1
AVTQUCKN EQU   AVTBIT1
AVTCLOSN EQU   AVTBIT1
AVTREADN EQU   AVTBIT1
AVTDLAYN EQU   AVTBIT1
AVTAQTAN EQU   AVTBIT1
AVTTSON  EQU   AVTBIT1
AVTAPLKN EQU   AVTBIT1
AVTDUMBR EQU   IEDQAVTD+1048
AVTDLQX  EQU   IEDQAVTD+1046
AVTINTLV EQU   IEDQAVTD+1044
AVTSMCNT EQU   IEDQAVTD+1042
AVTAVFCT EQU   IEDQAVTD+1040
AVTOPCON EQU   IEDQAVTD+1038
AVTOPCNT EQU   IEDQAVTD+1036
AVTLNCNT EQU   IEDQAVTD+1034
AVTKEYLE EQU   IEDQAVTD+1032
AVTHA16  EQU   IEDQAVTD+1030
AVTHA7   EQU   IEDQAVTD+1028
AVTHA4   EQU   IEDQAVTD+1026
AVTHA3   EQU   IEDQAVTD+1024
AVTHA2   EQU   IEDQAVTD+1022
AVTGETMS EQU   IEDQAVTD+1021
@NM00069 EQU   IEDQAVTD+1020
AVTGETMD EQU   IEDQAVTD+1016
AVTGETMN EQU   IEDQAVTD+1012
AVTCWTOT EQU   IEDQAVTD+1008
AVTCWINT EQU   IEDQAVTD+956
AVTDTRAP EQU   IEDQAVTD+952
@NM00068 EQU   IEDQAVTD+950
@NM00067 EQU   AVTIOTR
AVTIOTRH EQU   AVTIOTR
AVTIOTRE EQU   AVTIOTR
@NM00066 EQU   AVTSUBT
AVTSUBPT EQU   AVTSUBT
AVTSUBON EQU   AVTSUBT
AVTAFE30 EQU   IEDQAVTD+944
AVTAFE20 EQU   IEDQAVTD+940
AVTAFE10 EQU   IEDQAVTD+936
AVTCWEC2 EQU   IEDQAVTD+932
AVTCWPM2 EQU   IEDQAVTD+928
AVTCWTS2 EQU   IEDQAVTD+927
AVTCWTS1 EQU   IEDQAVTD+926
AVTCWCLD EQU   AVTCWFL2
AVTCWRAP EQU   AVTCWFL2
@NM00065 EQU   AVTCWFL2
@NM00064 EQU   AVTCWFL2
@NM00063 EQU   AVTCWFL2
@NM00062 EQU   AVTCWFL2
@NM00061 EQU   AVTCWFL2
AVTCWACT EQU   AVTCWFL2
@NM00060 EQU   AVTCWFL1
@NM00059 EQU   AVTCWFL1
@NM00058 EQU   AVTCWFL1
@NM00057 EQU   AVTCWFL1
@NM00056 EQU   AVTCWFL1
@NM00055 EQU   AVTCWFL1
@NM00054 EQU   AVTCWFL1
AVTCOMWN EQU   AVTCWFL1
AVTCWEC1 EQU   IEDQAVTD+920
AVTCWPM1 EQU   IEDQAVTD+916
AVTCAREA EQU   IEDQAVTD+912
AVTFZERO EQU   IEDQAVTD+908
AVTCADDR EQU   IEDQAVTD+904
AVTCOREC EQU   IEDQAVTD+900
@NM00053 EQU   IEDQAVTD+892
AVTCPBCB EQU   IEDQAVTD+888
@NM00052 EQU   IEDQAVTD+880
AVTDSIOB EQU   IEDQAVTD+876
@NM00051 EQU   IEDQAVTD+868
AVTCPRMB EQU   IEDQAVTD+864
@NM00050 EQU   IEDQAVTD+856
AVTCLOSB EQU   IEDQAVTD+852
@NM00049 EQU   IEDQAVTD+844
AVTACTIB EQU   IEDQAVTD+840
@NM00048 EQU   IEDQAVTD+836
AVTOLTEB EQU   IEDQAVTD+832
AVTOLTCH EQU   AVTOLTQB+1
AVTOLTVT EQU   AVTOLTQB
@NM00047 EQU   AVTOPCQB+8
@NM00046 EQU   AVTOPCEC+1
@NM00045 EQU   AVTOPCCC
AVTOPCPO EQU   AVTOPCCC
AVTOPCWA EQU   AVTOPCCC
AVTOPCCH EQU   AVTOPCOB+1
AVTOPCVT EQU   AVTOPCOB
@NM00044 EQU   AVTCKPQB+9
AVTCKPTS EQU   AVTCKPQB+8
@NM00043 EQU   AVTCKPEC+1
@NM00042 EQU   AVTCKPCC
AVTCKPPO EQU   AVTCKPCC
AVTCKPWA EQU   AVTCKPCC
AVTCKPCH EQU   AVTCKPTB+1
AVTCKPVT EQU   AVTCKPTB
@NM00041 EQU   IEDQAVTD+796
AVTBFRTB EQU   IEDQAVTD+792
@NM00040 EQU   IEDQAVTD+788
AVTSELCH EQU   IEDQAVTD+785
AVTBFRTN EQU   AVTBFRFG
AVTBFREB EQU   IEDQAVTD+780
AVTTIMQ  EQU   IEDQAVTD+776
@NM00039 EQU   IEDQAVTD+772
AVTIMQPS EQU   IEDQAVTD+768
AVTINOUT EQU   IEDQAVTD+766
AVTREFTM EQU   IEDQAVTD+764
@NM00038 EQU   IEDQAVTD+752
AVTDELYB EQU   IEDQAVTD+748
AVTOCQPT EQU   IEDQAVTD+744
AVTTSOPT EQU   IEDQAVTD+740
AVTSUPPT EQU   IEDQAVTD+736
AVTCBQCB EQU   IEDQAVTD+732
AVTMSGS  EQU   IEDQAVTD+729
@NM00037 EQU   AVTSYSER
@NM00036 EQU   AVTSYSER
@NM00035 EQU   AVTSYSER
@NM00034 EQU   AVTSYSER
@NM00033 EQU   AVTSYSER
@NM00032 EQU   AVTSYSER
AVTCMAXN EQU   AVTSYSER
AVTCMINN EQU   AVTSYSER
AVT2260L EQU   IEDQAVTD+724
AVTABEPL EQU   AVTADBUF
AVTHFF   EQU   AVTCLRHI+2
@NM00031 EQU   AVTCLRHI
AVTCCLNK EQU   AVTCRELE+5
AVTCCPRI EQU   AVTCRELE+4
AVTCCQCB EQU   AVTCCELE+1
AVTCCKEY EQU   AVTCCELE
AVTDELAD EQU   IEDQAVTD+704
AVTDELEM EQU   IEDQAVTD+700
AVTBSX   EQU   AVTCKLNK
AVTOPETR EQU   AVTHG01
@NM00030 EQU   AVTCKBYT
AVTCKONQ EQU   AVTCKBYT
@NM00029 EQU   AVTCKBYT
@NM00028 EQU   AVTCKBYT
@NM00027 EQU   AVTCKBYT
@NM00026 EQU   AVTCKBYT
@NM00025 EQU   AVTCKBYT
@NM00024 EQU   AVTCKBYT
AVTOPERT EQU   IEDQAVTD+690
AVTOPXCL EQU   IEDQAVTD+688
AVTOPERL EQU   IEDQAVTD+687
@NM00023 EQU   IEDQAVTD+686
AVTCKTIM EQU   IEDQAVTD+684
AVTCKELV EQU   IEDQAVTD+682
AVTCPRCD EQU   IEDQAVTD+681
AVTWARMN EQU   AVTCKELF
AVTCRTLN EQU   AVTCKELF
AVTCPIPN EQU   AVTCKELF
AVTCCLCN EQU   AVTCKELF
AVTCINCN EQU   AVTCKELF
@NM00022 EQU   AVTCKELF
AVTCMCPN EQU   AVTCKELF
AVTNQBCK EQU   AVTCKELF
AVTCKQAD EQU   IEDQAVTD+677
AVTSCBSZ EQU   IEDQAVTD+676
@NM00021 EQU   IEDQAVTD+672
AVTCKELE EQU   IEDQAVTD+668
@NM00020 EQU   AVTCKPEL+8
AVTCKRLK EQU   AVTCKPEL+5
AVTCKRPR EQU   AVTCKPEL+4
AVTCKRMQ EQU   AVTCKRMV+1
AVTCKRKY EQU   AVTCKRMV
AVTHK    EQU   IEDQAVTD+648
AVTHI    EQU   IEDQAVTD+644
AVTNX    EQU   IEDQAVTD+636
AVTTONE  EQU   IEDQAVTD+632
AVTA3TL  EQU   IEDQAVTD+628
AVTDMECB EQU   IEDQAVTD+624
AVTABEND EQU   IEDQAVTD+618
AVTPLCBN EQU   IEDQAVTD+616
@NM00019 EQU   AVTSAVTP+1
@NM00018 EQU   AVTSAVTF
AVTSNA   EQU   AVTSAVTF
AVTONSNA EQU   AVTSAVTF
AVTVTMCP EQU   AVTSAVTF
@NM00017 EQU   IEDQAVTD+608
AVTCMBSS EQU   IEDQAVTD+604
AVTRCV   EQU   IEDQAVTD+600
AVTSEND  EQU   IEDQAVTD+596
AVTCSCH  EQU   IEDQAVTD+592
AVTQ1    EQU   IEDQAVTD+588
AVTE7    EQU   IEDQAVTD+584
AVTHB    EQU   IEDQAVTD+580
AVTR1    EQU   IEDQAVTD+576
AVTBZ    EQU   IEDQAVTD+572
AVTEZ    EQU   IEDQAVTD+568
AVTEC    EQU   IEDQAVTD+564
AVTEW    EQU   IEDQAVTD+560
AVTNDIAL EQU   AVTSCOPT
AVTN2741 EQU   AVTSCOPT
AVTCONCO EQU   AVTSCOPT
AVTCONC  EQU   AVTSCOPT
AVTCMBUF EQU   AVTSCOPT
AVTAPDMP EQU   AVTSCOPT
@NM00016 EQU   AVTSCOPT
AVTHA    EQU   AVTDISP
AVTEA    EQU   IEDQAVTD+548
AVTAX    EQU   IEDQAVTD+544
AVTA3    EQU   IEDQAVTD+540
AVTGD    EQU   IEDQAVTD+536
AVTAL    EQU   IEDQAVTD+532
AVTOLTST EQU   AVTHG02
AVTE8    EQU   IEDQAVTD+524
AVTUI    EQU   IEDQAVTD+520
AVTCOMPT EQU   IEDQAVTD+516
AVTCRSRF EQU   IEDQAVTD+512
@NM00015 EQU   IEDQAVTD+508
AVTKA02  EQU   IEDQAVTD+504
AVTOPTPT EQU   IEDQAVTD+500
AVTPCBPT EQU   IEDQAVTD+496
@NM00014 EQU   AVTECB1
AVTCOMP  EQU   AVTECB1
@NM00013 EQU   AVTECB1
AVTOPECA EQU   IEDQAVTD+488
AVTOLECA EQU   IEDQAVTD+484
AVTCKECA EQU   IEDQAVTD+480
AVTCWECA EQU   IEDQAVTD+476
AVTCWTCB EQU   IEDQAVTD+472
AVTOLTCB EQU   IEDQAVTD+468
AVTOCTCB EQU   IEDQAVTD+464
AVTCKTCB EQU   IEDQAVTD+460
AVTAS    EQU   IEDQAVTD+456
AVTNOLBF EQU   IEDQAVTD+454
AVTNCKPR EQU   IEDQAVTD+453
AVTCIB   EQU   IEDQAVTD+452
AVTSPLPT EQU   IEDQAVTD+448
AVTMVBFR EQU   IEDQAVTD+444
AVTSBTA  EQU   IEDQAVTD+440
AVTRARTN EQU   IEDQAVTD+436
AVTBSCAN EQU   IEDQAVTD+432
AVTRDYA  EQU   IEDQAVTD+428
AVTDISTR EQU   IEDQAVTD+420
AVTPARM3 EQU   IEDQAVTD+416
@NM00012 EQU   AVTPKF
@NM00011 EQU   AVTPKF
@NM00010 EQU   AVTPKF
AVTFTCHF EQU   AVTPKF
@NM00009 EQU   AVTPKF
@NM00008 EQU   AVTPKF
@NM00007 EQU   AVTPKF
@NM00006 EQU   AVTPKF
AVTPARM  EQU   IEDQAVTD+408
AVTEXS2A EQU   IEDQAVTD+402
AVTEXA2S EQU   IEDQAVTD+396
AVTOCGET EQU   IEDQAVTD+392
AVTCKAVT EQU   @NM00004+1
@NM00005 EQU   AVTCKFLG
AVTCKHLT EQU   AVTCKFLG
AVTCKREQ EQU   AVTCKFLG
AVTCKENV EQU   AVTCKFLG
AVTCKNAC EQU   AVTCKFLG
AVTCKTAC EQU   AVTCKFLG
AVTBUENT EQU   IEDQAVTD+386
@NM00003 EQU   IEDQAVTD+385
AVTFULLT EQU   AVTBUFSW
AVTUNCON EQU   AVTBUFSW
@NM00002 EQU   AVTBUFSW
AVTBUFTR EQU   AVTREADD
AVTREADY EQU   IEDQAVTD+376
AVTRACE  EQU   IEDQAVTD+372
AVTTCB   EQU   IEDQAVTD+368
AVTPASWD EQU   IEDQAVTD+360
AVTCTLCH EQU   IEDQAVTD+352
AVTDOUBL EQU   IEDQAVTD+344
AVTDOUBX EQU   IEDQAVTD+336
AVTDPARM EQU   IEDQAVTD+332
AVTCSTCS EQU   IEDQAVTD+328
AVTDLQ   EQU   AVTSAVEX+32
@NM00001 EQU   AVTSAVEX
AVTSAVE4 EQU   IEDQAVTD+216
AVTSAVE3 EQU   IEDQAVTD+144
AVTSAVE2 EQU   IEDQAVTD+72
AVTSAVE1 EQU   IEDQAVTD
@NM00204 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00203 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00202 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00201 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00200 EQU   FLCFSA
@NM00199 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00198 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00197 EQU   FLCIOA
@NM00196 EQU   FLCMCLA+15
@NM00195 EQU   FLCMCLA+14
@NM00194 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00193 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00192 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00191 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00190 EQU   FLCPER
@NM00189 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00188 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00187 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00186 EQU   FLCPIILC
@NM00185 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00184 EQU   FLCSVILC
@NM00183 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00182 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00181 EQU   FLCICCW2+4
FLCCVT   EQU   FLCICCW2
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RF00337 EQU   @RC00327
@RC00335 EQU   @RC00327
@RC00331 EQU   @RC00327
@RC00373 EQU   @RC00369
@RC00403 EQU   @RC00386
@RC00401 EQU   @RC00386
@RC00390 EQU   @RC00386
@RC00388 EQU   @RC00386
@PB00002 EQU   @EL00001
@RC00397 EQU   @RC00390
@RC00392 EQU   @RC00390
CE0001@  EQU   @PB00002
@RC00418 EQU   CE0001@
@RC00484 EQU   CE0001@
@ENDDATA EQU   *
         END   IGE0004I,(C'PLS1421',0701,78129)
