         TITLE 'IGFTMC00-MISSING INTERRUPT  PROCESSOR (RESIDENT MODULE)*
               )        '
IGFTMC00 CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL2(@EP00001-@MAINENT)
         DC    AL1(16)                                             0001
         DC    C'IGFTMC00  78.073'                                 0001
IGFTMC01 DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL2(@EP00267-IGFTMC01)
         ENTRY IGFTMC01
         DROP  @15
@PROLOG  BALR  @08,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@08                                         0001
         AH    @15,4(,@15)                                         0001
         BR    @15                                                 0001
@EP00001 DS    0H                                                  0002
RBPRFXLN EQU 64
RBPRFLNA EQU 32
PRBLEN   EQU 136
SIRBLEN  EQU 200
TIRBLEN  EQU 136
IRBLEN   EQU 128
SVRBLEN  EQU 224
*   R1=R1+(LENGTH(TQE)+SEVEN)/EIGHT*EIGHT;/* GET SRB ADDRESS         */
         AL    R1,@CF03311                                         0263
*   GEN REFS(CVT,CVTPTR,CVTLSMQ,SRBFLNK,R1)                        0264
*       (SCHEDULE  SRB=(1),SCOPE=LOCAL);                           0264
         SCHEDULE  SRB=(1),SCOPE=LOCAL
*   RETURN;                         /* RETURN TO DISPATCHER          */
@EL00001 DS    0H                                                  0265
@EF00001 DS    0H                                                  0265
@ER00001 BR    @14                                                 0265
*   RFY                                                            0266
*    (R1,                                                          0266
*     R14) UNRSTD;                  /* RELEASE REG1 AND 14           */
*                                                                  0267
*/********************************************************************/
*/*                                                                  */
*/*   IGFTMC01: CHECK UCBS FOR MISSING INTERRUPTION                  */
*/*                                                                  */
*/*   INPUT:    REGISTER 0 WILL CONTAIN THE ADDRESS OF SRB           */
*/*             REGISTER 1 WILL CONTAIN THE ADDRESS OF PARAMETER     */
*/*             LIST:                                                */
*/*                 1.PTR TO DDRCOM                                  */
*/*                 2.PTR TO TQE OR IF INITIALIZATION        @G24LNLC*/
*/*                 3.PTR TO ECB                                     */
*/*                                                                  */
*/*   FUNCTION: IF INITIALIZATION, CHECK EXIT TABLES FOR     @G24LNLC*/
*/*             ZERO ENTRIES AND SET THEM TO BR14 ADDRESS OTHERWISE  */
*/*                                                          @G24LNLC*/
*/*             1.CHECK THE UCB LIST FOR MISSING INTERRUPTION        */
*/*             2.SCHEDULE  I/O RESTART TO CLEAR MISSING             */
*/*               INTERRUPTION FOR CHANNEL END,DEVICE END,CHANNEL    */
*/*               END AND DEVICE END, MOUNT,SWAP,OR DEVICE END       */
*/*               ON A PAGE PACK.                                    */
*/*             3.BUILD MESSAGE QUEUE FOR PENDING CONDITIONS         */
*/*                                                                  */
*/*   OUTPUT:   POST IGFTMCHK FOR OUTAGE RECORD                      */
*/*             MESSAGE QUEUE WILL BE BUILT IF PENDING CONDITION     */
*/*             OCCURRED                                             */
*/*                                                                  */
*/********************************************************************/
*                                                                  0267
*IGFTMC01:                                                         0267
*   ENTRY;                                                         0267
@EP00267 DS    0H                                                  0268
*   RFY                                                            0268
*    (R1,                                                          0268
*     R0,                                                          0268
*     SAVEPTR,                                                     0268
*     R14) RSTD;                    /* RESTRICT REG 1 AND 14         */
*   RFY                                                            0269
*     INPARM BASED(R1);             /* GET INPUT PARAM               */
*   TQEPTR=INTQE;                   /* SET TQE ADDRESSABILITY        */
         L     TQEPTR,INTQE(,R1)                                   0270
*   DDRPTR=INDDRCM;                 /* SET DDRCOM ADDRESSABILITY     */
         L     DDRPTR,INDDRCM(,R1)                                 0271
*   ECBPTR=INECB;                   /* SET ECB ADDRESSABILITY        */
         L     ECBPTR,INECB(,R1)                                   0272
*   RFY                                                            0273
*     R1 UNRSTD;                    /* RELEASE REG 1                 */
*   R14SAVE=R14;                    /* SAVE RETURN ADDRESS           */
         ST    R14,R14SAVE(,DDRPTR)                                0274
*   RFY                                                            0275
*     R14 UNRSTD;                   /* RELEASE REG 14                */
*   SAVEPTR=ADDR(TMC01SAV);         /* REGISTER 13 PTR TO SAVEAREA   */
         LA    SAVEPTR,TMC01SAV(,DDRPTR)                           0276
*   IF TQEPTR=0 THEN                                               0277
         LTR   TQEPTR,TQEPTR                                       0277
         BNZ   @RF00277                                            0277
*     DO;                           /* INITIALIZATION CALL IF NO   0278
*                                      TQEPTR                @G24LNLC*/
*       DO I=1 TO DIM(TMCEXT1);     /* INITIALIZE ONCE FOR MIH EXIT
*                                      TABLE                 @G24LNLC*/
         LA    I,1                                                 0279
@DL00279 DS    0H                                                  0280
*         IF TMCEX1(I)=ZERO THEN                                   0280
         LR    @12,I                                               0280
         SLA   @12,3                                               0280
         L     @11,TMCEX1-8(@12)                                   0280
         LTR   @11,@11                                             0280
         BNZ   @RF00280                                            0280
*           TMCEX1(I)=ADDR(TMCBR14);                               0281
         LA    @11,TMCBR14                                         0281
         ST    @11,TMCEX1-8(@12)                                   0281
*       END;                                                       0282
@RF00280 AL    I,@CF00046                                          0282
         C     I,@CF00046                                          0282
         BNH   @DL00279                                            0282
*       DO I=1 TO DIM(TMCEXT2);     /* INITIALIZE UCB EXIT TABLE   0283
*                                                            @G24LNLC*/
         LA    I,1                                                 0283
@DL00283 DS    0H                                                  0284
*         IF TMCEX2(I)=ZERO THEN                                   0284
         LR    @12,I                                               0284
         SLA   @12,3                                               0284
         L     @11,TMCEX2-8(@12)                                   0284
         LTR   @11,@11                                             0284
         BNZ   @RF00284                                            0284
*           TMCEX2(I)=ADDR(TMCBR14);/* G24LNLC                       */
         LA    @11,TMCBR14                                         0285
         ST    @11,TMCEX2-8(@12)                                   0285
*       END;                                                       0286
*                                                                  0286
@RF00284 AL    I,@CF00046                                          0286
         C     I,@CF00046                                          0286
         BNH   @DL00283                                            0286
*/* RESUME MUST BE ISSUED TO RETURN CONTROL TO IGFTMCHK WHICH IS   0287
*   SUSPENDED @G24LNLC                                               */
*                                                                  0287
*       RFY                                                        0287
*        (R4,                                                      0287
*         R5) RSTD;                 /* RESTRICT REGS FOR INTERFCE TO
*                                      RESUME                @G24LNLC*/
*       R4=R0->SRBPTCB;             /* SET UP TCB ADDRESS    @G24LNLC*/
         LR    @12,R0                                              0288
         L     R4,SRBPTCB(,@12)                                    0288
*       R5=R4->TCBRBP;              /* SET UP RB POINTER     @G24LNLC*/
         L     R5,TCBRBP(,R4)                                      0289
*       GEN REFS(CVTRSUME) EXIT NOSEQFLOW( RESUME RETURN=N);/* RESUME
*                                      IGFTMCHK              @G24LNLC*/
          RESUME RETURN=N
*       RFY                                                        0291
*        (R4,                                                      0291
*         R0,                                                      0291
*         R5) UNRSTD;                                              0291
*     END;                                                         0292
*                                                                  0293
*/********************************************************************/
*/*                                                                  */
*/*   ESTABLISH ERROR RECOVERY: SETFRR                               */
*/*                                                                  */
*/*   INPUT: PTR TO DDRCOM                                           */
*/*          PTR TO TQE                                              */
*/*          PTR TO ECB                                              */
*/*                                                                  */
*/*   FUNCTION: SET UP ERROR RECOVERY FOR IGFTMC01                   */
*/*             RETRY IS ATTEMPTED FOR THREE TIMES.                  */
*/*             IF THE ERROR STILL EXISTS THE MIH FUNCTION           */
*/*             WILL BE TERMINATED                                   */
*/*                                                                  */
*/*   OUTPUT: FRR WILL BE ESTABLISHED                                */
*/*                                                                  */
*/*                                                                  */
*/********************************************************************/
*                                                                  0293
*   RFY                                                            0293
*    (R1,                                                          0293
*     R4,                                                          0293
*     R5) RSTD;                     /* RESTRICT REG1,4,5             */
@RF00277 DS    0H                                                  0294
*   R1=ADDR(IGFTMFRR);              /* ADDRESS OF RECOVERY PROGRAM   */
         LA    R1,IGFTMFRR                                         0294
*   GEN REFS(R1,R4,R5,FRRPARM,FRRSCURR,FRRS,FRRSLAST,PSA,PSALSFCC, 0295
*       FRRSELEN,FRRSFRRA,FRRSENTR,FRRSPARM);                      0295
*                                            /*
 SETFRR  A,FRRAD=(R1),PARMAD=(FRRPARM),WRKREGS=(R4,R5),               **
                RELATED=('IGFTMFRR-FRR EXIT ROUTINE')
*   RFY                                                            0296
*    (R1,                                                          0296
*     R4,                                                          0296
*     R5) UNRSTD;                   /* RELEASE REG 1,4 AND 5         */
*   FRRTQE=TQEPTR;                  /* SET UP TQE ADDRESSABILITY IN
*                                      FRR                           */
         ST    TQEPTR,FRRTQE(,FRRPARM)                             0297
*   FRRECB=ECBPTR;                  /* SET UP ECB ADDRESSABILITY IN
*                                      FRR                           */
         ST    ECBPTR,FRRECB(,FRRPARM)                             0298
*   FRRDDRCM=DDRPTR;                /* SET UP DDRCOM ADDRESSABILITY
*                                      IN FRR                        */
         ST    DDRPTR,FRRDDRCM(,FRRPARM)                           0299
*   TMC01RTY=OFF;                   /* INIT FRR RETRY FLAG           */
         NI    TMC01RTY(DDRPTR),B'11011111'                        0300
*   RFY                                                            0301
*    (R1,                                                          0301
*     R14,                                                         0301
*     R15) RSTD;                                                   0301
*   R1=ADDR(MIHINTVL);              /* SET UP PARM FOR EXIT  @G24LNLC*/
         LA    R1,MIHINTVL(,DDRPTR)                                0302
*   FRROPTI=ON;                     /* INDICATE ONCE PER MIX EXIT TO
*                                      FRR                   @G24LNLC*/
         OI    FRROPTI(FRRPARM),B'10000000'                        0303
*   DO I=1 TO DIM(TMCEXT1);         /* CALL EACH EXIT        @G24LNLC*/
         LA    I,1                                                 0304
@DL00304 DS    0H                                                  0305
*     FRREXITI=I;                   /* SET UP EXIT INDEX FOR FRR   0305
*                                                            @G24LNLC*/
         STCM  I,7,FRREXITI(FRRPARM)                               0305
*     CALL TMCEX1(I);               /* GO TO EXIT            @G24LNLC*/
         LR    @12,I                                               0306
         SLA   @12,3                                               0306
         L     @15,TMCEX1-8(@12)                                   0306
         BALR  @14,@15                                             0306
*   END;                                                           0307
         AL    I,@CF00046                                          0307
         C     I,@CF00046                                          0307
         BNH   @DL00304                                            0307
*   FRREXITI=ZERO;                  /* INDICATE NO EXIT ACTIVE     0308
*                                                            @G24LNLC*/
         SLR   @12,@12                                             0308
         STCM  @12,7,FRREXITI(FRRPARM)                             0308
*   FRROPTI=OFF;                    /* SHOW UCB EXIT TYPE    @G24LNLC*/
         NI    FRROPTI(FRRPARM),B'01111111'                        0309
*   RFY                                                            0310
*    (R1,                                                          0310
*     R14,                                                         0310
*     R15) UNRSTD;                                                 0310
*                                                                  0311
*/********************************************************************/
*/*                                                                  */
*/*   SCAN UCB: CHECK UCBS FOR PENDING CONDITIONS                    */
*/*                                                                  */
*/*   INPUT:  PTR TO DDRCOM                                          */
*/*           PTR TO CVT                                             */
*/*                                                                  */
*/*                                                                  */
*/*   FUNCTION: SCAN UCB IN THE SYSTEM FOR MISSING INTERRUPTIONS     */
*/*             I.E.MOUNTS,SWAPS,CHANNEL ENDS OR DEVICE ENDS.        */
*/*             WHEN ONE IS FOUND THE NECESSARY INFORMATION IS       */
*/*             PUT INTO MIHCODE(LOCAL WORKAREA)TO INDICATE THE TYPE */
*/*             OF PENDING CONDITION. GO TO UCB SPECIFIED    @G24LNLC*/
*/*             MIHEXITS.                                    @G24LNLC*/
*/*                                                                  */
*/*   OUTPUT: MIHCODE IS SET FOR PENDING CONDITION                   */
*/*                                                                  */
*/*                                                                  */
*/********************************************************************/
*                                                                  0311
*   RFY                                                            0311
*     INDEXUCB RSTD;                /* RESTRICT REG FOR UCB INDEX    */
*   INDEXUCB=CVTILK2;               /* GET UCB LOOK UP TAB ADDRESS   */
         L     @12,CVTPTR                                          0312
         L     INDEXUCB,CVTILK2(,@12)                              0312
*   UCBPTR=TMCUCB;                  /* SET FIRST UCB PTR             */
         LH    UCBPTR,TMCUCB(,INDEXUCB)                            0313
         N     UCBPTR,@CF03319                                     0313
*   DO WHILE UCBPTR^=ENDUCB;        /* ALL UCBS ARE SEARCHED? NO - 0314
*                                      CHECK FOR PENDING             */
         B     @DE00314                                            0314
@DL00314 DS    0H                                                  0315
*     IF UCBPTR=ZERO|               /* UCB NOT EXIST?                */
*         UCBDVCLS=TP40|            /* TELEPROCESSING?       @ZA14026*/
*         (UCBONLI=OFF&UCBMTPXP=OFF)|/* OFFLINE AND NOT            0315
*                                      MULTI-EXPOSURE DEVICE?      0315
*                                                            @ZA30660*/
*         (UCBDVCLS=UR3HEX08&UCBUNTYP=UR4HEX1D)/* DON'T TIME 1419 PCU
*                                                            @ZA30660*/
*       THEN                                                       0315
         LTR   UCBPTR,UCBPTR                                       0315
         BZ    @RT00315                                            0315
         CLI   UCBDVCLS(UCBPTR),X'40'                              0315
         BE    @RT00315                                            0315
         TM    UCBONLI(UCBPTR),B'10000000'                         0315
         BNZ   @GL00001                                            0315
         TM    UCBMTPXP(UCBPTR),B'00001000'                        0315
         BZ    @RT00315                                            0315
@GL00001 CLI   UCBDVCLS(UCBPTR),X'08'                              0315
         BNE   @RF00315                                            0315
         CLI   UCBUNTYP(UCBPTR),X'1D'                              0315
         BE    @RT00315                                            0315
*       GOTO NEXTUCB;               /* YES-IGNORE CURRENT UCB        */
*     IF UCBALTPH=ON&(UCBTICBT=ON|UCBMIHTI^=ZERO) THEN/* DEVICE HAS
*                                      ALTERNATE PATHS AND HAS     0317
*                                      PREVIOUS CONDITION FOUND    0317
*                                                            @G24LNLC*/
@RF00315 TM    UCBALTPH(UCBPTR),B'00000001'                        0317
         BNO   @RF00317                                            0317
         TM    UCBTICBT(UCBPTR),B'00000010'                        0317
         BO    @RT00317                                            0317
         L     @12,UCBEXTPT(,UCBPTR)                               0317
         CLI   UCBMIHTI(@12),0                                     0317
         BE    @RF00317                                            0317
@RT00317 DS    0H                                                  0318
*       DO;                         /* YES                   @G24LNLC*/
*                                                                  0318
*         /***********************************************************/
*         /*                                                         */
*         /* IGNORE THE DUPLICATE MIH MESSAGE FOR THE ALTERNATE      */
*         /* PATH@G24LNLC                                            */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0319
*         RFY                                                      0319
*           INDEXALT RSTD;          /* RESTRICT REG 5        @G24LNLC*/
*         INDEXALT=CVTILK2;         /* PTR TO FIRST ENTRY IN UCB LIST
*                                                            @G24LNLC*/
         L     @12,CVTPTR                                          0320
         L     INDEXALT,CVTILK2(,@12)                              0320
*         DO WHILE(INDEXALT^=INDEXUCB);/* SCAN FOR THE ALTERNATH PATH
*                                                            @G24LNLC*/
         B     @DE00321                                            0321
@DL00321 DS    0H                                                  0322
*           IF ALTPHUCB=UCBPTR THEN /* FOUND ALTERNATE PATH? @G24LNLC*/
         LH    @12,ALTPHUCB(,INDEXALT)                             0322
         N     @12,@CF03319                                        0322
         CR    UCBPTR,@12                                          0322
         BE    @RT00322                                            0322
*             GOTO NEXTUCB;         /* CHECK NEXT UCB ON UCB LIST  0323
*                                                            @G24LNLC*/
*           ELSE                                                   0324
*             INDEXALT=INDEXALT+TWO;/* UPDATE TO NEXT UCB    @G24LNLC*/
         AL    INDEXALT,@CF00086                                   0324
*         END;                      /* END OF SEARCH UCB LIST      0325
*                                                            @G24LNLC*/
@DE00321 CR    INDEXALT,INDEXUCB                                   0325
         BNE   @DL00321                                            0325
*         RFY                                                      0326
*           INDEXALT UNRSTD;        /* RELEASE REG 5         @G24LNLC*/
*       END;                        /* END OF PROCESSING ALTERNATE 0327
*                                      PATH                  @G24LNLC*/
*     IF UCBMOUNT=ON&UCBALOC=ON&UCBMMSGP=OFF THEN/* MOUNT AND MESSAGE
*                                      PENDING & DEVICE ALLOCATED  0328
*                                                            @ZA15343*/
@RF00317 TM    UCBMOUNT(UCBPTR),B'10000000'                        0328
         BNO   @RF00328                                            0328
         TM    UCBALOC(UCBPTR),B'00001000'                         0328
         BNO   @RF00328                                            0328
         TM    UCBMMSGP(UCBPTR),B'00000100'                        0328
         BNZ   @RF00328                                            0328
*       IF UCB3DACC=ON|UCBNRY=ON&UCB3TAPE=ON THEN/* DIRECT ACCESS OR
*                                      TAPE IS ALLOCATED BUT NOT   0329
*                                      READY?                        */
         TM    UCB3DACC(UCBPTR),B'00100000'                        0329
         BO    @RT00329                                            0329
         TM    UCBNRY(UCBPTR),B'01000000'                          0329
         BNO   @RF00329                                            0329
         TM    UCB3TAPE(UCBPTR),B'10000000'                        0329
         BNO   @RF00329                                            0329
@RT00329 DS    0H                                                  0330
*         MIHMT=ON;                 /* YES-SET MOUNTING              */
         OI    MIHMT(DDRPTR),B'00000100'                           0330
*     IF UCBDDRSW=ON THEN           /* CHECK FOR SWAP PENDING        */
@RF00329 DS    0H                                                  0331
@RF00328 TM    UCBDDRSW(UCBPTR),B'00000001'                        0331
         BNO   @RF00331                                            0331
*       MIHSW=ON;                   /* YES-SET SWAP PENDING          */
         OI    MIHSW(DDRPTR),B'00001000'                           0332
*     IF UCBBSY=ON THEN             /* DEVICE BUSY?                  */
@RF00331 TM    UCBBSY(UCBPTR),B'10000000'                          0333
         BNO   @RF00333                                            0333
*       MIHDE=ON;                   /* YES-SET DEVICE PENDING        */
         OI    MIHDE(DDRPTR),B'00000001'                           0334
*     IF UCBACTV=ON THEN            /* CHANNEL STILL IS ACTIVE?      */
@RF00333 TM    UCBACTV(UCBPTR),B'00000010'                         0335
         BNO   @RF00335                                            0335
*       MIHCE=ON;                   /* YES-SET CHANNEL PENDING       */
         OI    MIHCE(DDRPTR),B'00000010'                           0336
*     MIHCODE=MIHTAB(MIHCOND+1);    /* SET MIHCODE FOR CONDITION   0337
*                                                            @G24LNLC*/
@RF00335 SLR   @12,@12                                             0337
         IC    @12,MIHCOND(,DDRPTR)                                0337
         LA    @15,MIHTAB(@12)                                     0337
         MVC   MIHCODE(1,DDRPTR),0(@15)                            0337
*     IF MIHCODE=DDRMIHC|MIHCODE=DDRMIHCD|(MIHCODE=DDRMIHD&UCB3DACC=ON&
*         (UCBPGFL=ON|UCBSYSR=ON)) THEN/* DEVICE END ON PAGE PACK OR
*                                      SYSRES DEVICE         @ZA28603*/
         CLI   MIHCODE(DDRPTR),X'03'                               0338
         BE    @RT00338                                            0338
         CLI   MIHCODE(DDRPTR),X'04'                               0338
         BE    @RT00338                                            0338
         CLI   MIHCODE(DDRPTR),X'02'                               0338
         BNE   @RF00338                                            0338
         TM    UCB3DACC(UCBPTR),B'00100000'                        0338
         BNO   @RF00338                                            0338
         TM    UCBPGFL(UCBPTR),B'01000000'                         0338
         BO    @RT00338                                            0338
         TM    UCBSYSR(UCBPTR),B'00000010'                         0338
         BNO   @RF00338                                            0338
@RT00338 DS    0H                                                  0339
*       MIHIOR=ON;                                                 0339
         OI    MIHIOR(DDRPTR),B'10000000'                          0339
*     ELSE                                                         0340
*       MIHIOR=OFF;                 /* INDICATE IF IOE RESTART WOULD
*                                      BE CALLED             @G24LNLC*/
         B     @RC00338                                            0340
@RF00338 NI    MIHIOR(DDRPTR),B'01111111'                          0340
*     IF UCBMIHTI^=ZERO THEN                                       0341
@RC00338 L     @12,UCBEXTPT(,UCBPTR)                               0341
         CLI   UCBMIHTI(@12),0                                     0341
         BE    @RF00341                                            0341
*       DO;                         /* IF EXIT SPECIFIED TOTO IT   0342
*                                                            @G24LNLC*/
*         I=UCBMIHTI;               /* GET INDEX             @G24LNLC*/
         SLR   I,I                                                 0343
         IC    I,UCBMIHTI(,@12)                                    0343
*         RFY                                                      0344
*          (R1,                                                    0344
*           R14,                                                   0344
*           R15) RSTD;              /*                       @G24LNLC*/
*         SAVEPTR=ADDR(TMC01SAV);   /* GIVE EXIT A SAVE AREA @G24LNLC*/
         LA    SAVEPTR,TMC01SAV(,DDRPTR)                           0345
*         R1=ADDR(TMCEXITP);        /* SET UP PARM LIST POINTER IN R1
*                                                            @G24LNLC*/
         LA    R1,TMCEXITP(,DDRPTR)                                0346
*         MIHINTVA=ADDR(MIHINTVL);  /* GET ADDR OF INTVL INFO      0347
*                                                            @G24LNLC*/
         LA    @12,MIHINTVL(,DDRPTR)                               0347
         ST    @12,MIHINTVA(,DDRPTR)                               0347
*         FRREXITI=I;               /* INDICATE EXIT INDEX TO FRR  0348
*                                                            @G24LNLC*/
*                                                                  0348
         STCM  I,7,FRREXITI(FRRPARM)                               0348
*         /***********************************************************/
*         /*                                                         */
*         /* R2 ALREADY POINTS TO UCB                        @G24LNLC*/
*         /*                                                         */
*         /***********************************************************/
*                                                                  0349
*         CALL TMCEX2(I);           /* GO TO EXIT ROUTINE    @G24LNLC*/
         LR    @12,I                                               0349
         SLA   @12,3                                               0349
         L     @15,TMCEX2-8(@12)                                   0349
         BALR  @14,@15                                             0349
*         FRREXITI=ZERO;            /* ZERO EXIT ACTIVE INDICATOR  0350
*                                                            @G24LNLC*/
         SLR   @12,@12                                             0350
         STCM  @12,7,FRREXITI(FRRPARM)                             0350
*         RFY                                                      0351
*          (R1,                                                    0351
*           R14,                                                   0351
*           R15) UNRSTD;                                           0351
*       END;                                                       0352
*     MIHCODE=MIHTAB(MIHCOND+ONE);  /* SET MIH CODE FOR PENDING    0353
*                                      CONDITION                     */
@RF00341 SLR   @12,@12                                             0353
         IC    @12,MIHCOND(,DDRPTR)                                0353
         LA    @15,MIHTAB(@12)                                     0353
         MVC   MIHCODE(1,DDRPTR),0(@15)                            0353
*     IF MIHCODE=NO THEN            /* PENDING CONDITION OCCURRED?   */
         CLI   MIHCODE(DDRPTR),X'00'                               0354
         BE    @RT00354                                            0354
*       GOTO NEXTUCB;               /* NO-CHECK NEXT UCB             */
*     IF UCBIOQ=ZERO|UCBPST=OFF THEN/* ANY I/O REQUEST               */
         LR    @12,UCBPTR                                          0356
         AL    @12,@CF03324                                        0356
         L     @12,UCBIOQ-508(,@12)                                0356
         LTR   @12,@12                                             0356
         BZ    @RT00356                                            0356
         TM    UCBPST(UCBPTR),B'00100000'                          0356
         BNZ   @RF00356                                            0356
@RT00356 DS    0H                                                  0357
*       USERASID=UCBASID;           /* NO I/O REQUEST-SET DEVICE USER
*                                      ASID                          */
         L     @12,UCBEXTPT(,UCBPTR)                               0357
         LH    @12,UCBASID(,@12)                                   0357
         STH   @12,USERASID(,DDRPTR)                               0357
*     ELSE                          /* I/O REQUESTS IS QUEUED        */
*       IF IOSDVRID=IOSOLTID THEN   /* OLTEP?                        */
         B     @RC00356                                            0358
@RF00356 LR    @12,UCBPTR                                          0358
         AL    @12,@CF03324                                        0358
         L     @12,IOQPTR-508(,@12)                                0358
         L     @12,IOSBPTR(,@12)                                   0358
         CLI   IOSDVRID(@12),X'06'                                 0358
         BE    @RT00358                                            0358
*         GOTO NEXTUCB;             /* TO CHECK NEXT UCB             */
*       ELSE                        /* NOT OLTEP                     */
*         USERASID=IOSASID;         /* SET USER ASID AS IOS          */
         LH    @12,IOSASID(,@12)                                   0360
         N     @12,@CF03319                                        0360
         STH   @12,USERASID(,DDRPTR)                               0360
*     IF UCBTICBT=OFF THEN          /* UCB PENDING CONDITION EXIST?  */
@RC00356 TM    UCBTICBT(UCBPTR),B'00000010'                        0361
         BNZ   @RF00361                                            0361
*       DO;                         /* NO                            */
*/*  TURN ON THE UCBTICBT BIT WHICH WILL BE CHECKED AFTER THE TIME   */
*/*  INTERVAL ELAPSED TO DECIDE MISSING INTERRUPT OCCURRED           */
*                                                                  0363
*         GEN REFS(UCBFLA,UCBFLB,UCBFLC,CVTPTR,CVTIXAVL,CVTMAP,IOCOM,
*             IOCGENA,UCBBGN,UCBCCWOF,UCB3TAPE,UCBPTR);            0363
*                                                               /*
            IOSGEN UCBFLG,TABLE=UCBTICBT,UCB=(UCBPTR),VAR=ON
*         GOTO NEXTUCB;             /* END OF SCAN THIS UCB          */
         B     NEXTUCB                                             0364
*       END;                        /* END OF SET UCBTICBT IN UCB    */
*                                                                  0366
*/********************************************************************/
*/*                                                                  */
*/*   SCHEDULE I/O RESTART:  TO SCHEDULE A SRB FOR I/O RESTART       */
*/*                                                                  */
*/*   INPUT: DDRPTR POINTS TO DDRCOM                                 */
*/*                                                                  */
*/*   FUNCTION: WHEN MISSING INTERRUPTION FOUND,AND IT IS A CHANNEL  */
*/*             END,OR DEVICE END ON A PAGE PACK OR SYSRES   @ZA28603*/
*/*             DEVICE, IGFTMC02                             @ZA28603*/
*/*             IS SCHEDULED UNDER A  SRB ON THE CPU THAT ISSUED THE */
*/*             I/O REQUEST. IGFTMC02 CALLS I/O RESTART TO CLEAR THE */
*/*             CHANNEL OR DEVICE THAT IS MISSING INTERRUPTION       */
*/*                                                                  */
*/*   OUTPUT:   THE PENDING CHANNEL OR DEVICE WILL BE CLEARED        */
*/*                                                                  */
*/*                                                                  */
*/********************************************************************/
*                                                                  0366
*     GEN(IOSGEN UCBFLG,TABLE=UCBTICBT,UCB=(UCBPTR),VAR=OFF);/* RESET
*                                      UCBTICBT                      */
@RF00361 DS    0H                                                  0366
         IOSGEN UCBFLG,TABLE=UCBTICBT,UCB=(UCBPTR),VAR=OFF
*     RFY                                                          0367
*      (R6) RSTD;                                                  0367
*     IF MIHIOR=ON                  /* IF CALL TO IORESTART REQUIRED
*                                                            @G24LNLC*/
*       THEN                        /*                       @ZA06064*/
*                                                                  0368
         TM    MIHIOR(DDRPTR),B'10000000'                          0368
         BNO   @RF00368                                            0368
*       /*************************************************************/
*       /*                                                           */
*       /* THE ABOVE CONDITIONS MEET THEN SET I/O RESTART            */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0369
*       R6=(LENGTH(TMC2IN)+SEVEN)/EIGHT*EIGHT;/* SET TMC02 PARM LEN  */
         LA    R6,128                                              0369
*     ELSE                                                         0370
*       R6=ZERO;                    /* NO-IO RESTART NOT REQUIRED    */
         B     @RC00368                                            0370
@RF00368 SLR   R6,R6                                               0370
*     RFY                                                          0371
*      (R0,                                                        0371
*       R1,                                                        0371
*       R2,                                                        0371
*       R15) RSTD;                  /* RESTRICT REG0,1 ,2 AND 15     */
@RC00368 DS    0H                                                  0372
*     R0=R6+LENGTH(MSGBLK);         /* GETMAIN TOTAL ELNGTH          */
         LA    R0,16                                               0372
         ALR   R0,R6                                               0372
*     STM(R2,R15,TMC01SAV);         /* SAVE REGISTERS 2-15           */
         STM   R2,R15,TMC01SAV(DDRPTR)                             0373
*     GEN REFS(FLC,PSALITA);                                       0374
*                             /*
          SETLOCK OBTAIN,TYPE=SALLOC,MODE=UNCOND,                     **
               RELATED=('GETMAIN-SALLOC RELEASED AFTER GETMAIN')
          GETMAIN RU,LV=(0),SP=245,BRANCH=(YES,GLOBAL),               **
               RELATED=('FREEMAIN-WILL BE IN IGFTMC02 OR IGFTMFRR')
          SETLOCK  RELEASE,TYPE=SALLOC,                               **
               RELATED=('GETMAIN-SALLOC OBTAINED BEFORE GETMAIN')
*     LM(R2,R15,TMC01SAV);          /* RESTORE REGISTER 2-15         */
         LM    R2,R15,TMC01SAV(DDRPTR)                             0375
*     RFY                                                          0376
*      (R0,                                                        0376
*       R2,                                                        0376
*       R15) UNRSTD;                /* RELEASE REG0,2 AND 15         */
*     IF R6^=ZERO THEN              /* I/O RESTART REQUIRED?         */
         LTR   R6,R6                                               0377
         BZ    @RF00377                                            0377
*       DO;                         /* YES                           */
*         FRRSQA=R1;                /* SET SQA GETMAIN IN FRR FOR  0379
*                                      TMC02                         */
         ST    R1,FRRSQA(,FRRPARM)                                 0379
*         TMC2IN=''B;               /* ZERO TMC02 PARM LIST          */
         XC    TMC2IN(124,R1),TMC2IN(R1)                           0380
*         MSGPTR=R1+(LENGTH(TMC2IN)+SEVEN)/EIGHT*EIGHT;/* SET MSG PTR*/
         LA    MSGPTR,128                                          0381
         ALR   MSGPTR,R1                                           0381
*         RFY                                                      0382
*           SRBPTR RSTD;            /* RESTRICT REG 2 FOR SRB PTR    */
*         SRBPTR=ADDR(TMC2SRB);     /* SET SRB PTR                   */
         LA    SRBPTR,TMC2SRB(,R1)                                 0383
*         SRBID=CSRBID;             /* SET UP SRB ID                 */
         MVC   SRBID(4,SRBPTR),@CC03158                            0384
*         SRBASCB=ASVTENTY(ONE);    /* SET ADDR OF MASTER SRB        */
         L     @12,CVTPTR                                          0385
         L     @12,ASVTPTR(,@12)                                   0385
         L     @12,ASVTENTY(,@12)                                  0385
         ST    @12,SRBASCB(,SRBPTR)                                0385
*         SRBEP=ADDR(IGFTMC02);     /* SET ENTRY POINT OF IGFTMC02   */
         LA    @12,IGFTMC02                                        0386
         ST    @12,SRBEP(,SRBPTR)                                  0386
*         SRBPARM=R1;               /* ADDR OF PARM LIST             */
         ST    R1,SRBPARM(,SRBPTR)                                 0387
*         RFY                                                      0388
*          (R5,                                                    0388
*           R12) RSTD;              /* RESTRICT REG 5, 12            */
*         R5=UCBCPU;                /* GET CPU NO                    */
         SLR   R5,R5                                               0389
         IC    R5,UCBCPU(,UCBPTR)                                  0389
*         R12=TMC8000;              /* GET CPU MASK SET UP           */
         L     R12,@CF03153                                        0390
*         GEN REFS(R5,R12)(SRL R12,0(R5) SET UP MASK);             0391
         SRL R12,0(R5) SET UP MASK
*         SRBCPAFF=R12;             /* CPU ADDRESS AS A BIT DISP     */
         STH   R12,SRBCPAFF(,SRBPTR)                               0392
*         RFY                                                      0393
*          (R5,                                                    0393
*           R12) UNRSTD;            /* RELEASE REG 5, 12             */
*         TMCUCBAD=UCBPTR;          /* SET UCB ADDR IN PARAM         */
         STCM  UCBPTR,7,TMCUCBAD(R1)                               0394
*         TMCUCBNO=ONEUCB;          /* INDICATE SINGLE UCB RESTART   */
         MVI   TMCUCBNO(R1),X'20'                                  0395
*         GEN REFS(CVTLSMQ,CVTMAP,SRBFLNK,SRBSECT,SRBPTR)          0396
*             (SCHEDULE SRB=(SRBPTR),SCOPE=LOCAL);                 0396
         SCHEDULE SRB=(SRBPTR),SCOPE=LOCAL
*         RFY                                                      0397
*           SRBPTR UNRSTD;          /* RELEASE REG 2                 */
*         FRRSQA=ZERO;              /* ZERO SQA GETMAIN PTR IN FRR   */
         SLR   @12,@12                                             0398
         ST    @12,FRRSQA(,FRRPARM)                                0398
*       END;                        /* END OF I/O RESTART SCHEDULE   */
*     ELSE                          /* I/O RESTART NOT REQUIRED      */
*       MSGPTR=R1;                  /* SET MSG PTR                   */
         B     @RC00377                                            0400
@RF00377 LR    MSGPTR,R1                                           0400
*     RFY                                                          0401
*      (R1,                                                        0401
*       R6) UNRSTD;                 /* RELEASE REG 1 AND REG 6       */
@RC00377 DS    0H                                                  0402
*                                                                  0402
*/********************************************************************/
*/*                                                                  */
*/*   SET UP MESSAGE CHAIN: SET UP MESSAGE CHAIN FOR ISSUE           */
*/*                         PENDING CONDITION                        */
*/*                                                                  */
*/*   INPUT:  PTR TO DDRCOM                                          */
*/*           PTR TO MESSAGE BLOCK                                   */
*/*                                                                  */
*/*   FUNCTION: BUILD MESSAGE BLOCK AND PUT THE MESSAGE BLOCK LIFO   */
*/*             ON THE MESSAGE QUEUE POINTED BY MIHMSGPR FROM DDRCOM */
*/*                                                                  */
*/*   OUTPUT: MESSAGE QUEUE HAS BEEN BUILT                           */
*/*                                                                  */
*/*                                                                  */
*/********************************************************************/
*                                                                  0402
*     MSGBLK=''B;                   /* ZERO MESSAGE BLOCK            */
         XC    MSGBLK(16,MSGPTR),MSGBLK(MSGPTR)                    0402
*     ERRCODE=MIHCODE;              /* SET UP MIH CODE               */
         MVC   ERRCODE(1,MSGPTR),MIHCODE(DDRPTR)                   0403
*     MIHASID=USERASID;             /* SET UP USER ASID              */
         LH    @12,USERASID(,DDRPTR)                               0404
         STH   @12,MIHASID(,MSGPTR)                                0404
*     MIHUCB=UCBPTR;                /* SET UP UCB ADDR               */
         ST    UCBPTR,MIHUCB(,MSGPTR)                              0405
*     RFY                                                          0406
*      (R0,                                                        0406
*       R1) RSTD;                   /* RESTRICT REG 0 AND 1          */
*     R1=MSGPTR;                    /* GET THE NEW MESSAGE ADDR      */
         LR    R1,MSGPTR                                           0407
*     R0=MIHMSGPR;                  /* GET THE CURRENT MSG PTR       */
         L     R0,MIHMSGPR(,DDRPTR)                                0408
*TRYAGN:                                                           0409
*     NEXTMSG=R0;                   /* ADD NEW MSG ON TOP OF CURRENT
*                                      MSG OF THE MSG QUEUE          */
TRYAGN   ST    R0,NEXTMSG(,MSGPTR)                                 0409
*     CS(R0,R1,MIHMSGPR);           /* STORE NEW MSG PTR ON QUEUE    */
         CS    R0,@01,MIHMSGPR(DDRPTR)                             0410
*     BC(NE,TRYAGN);                /* TRY AGAIN IF NOT SUCCESSFUL   */
         BC    7,TRYAGN                                            0411
*     RFY                                                          0412
*      (R0,                                                        0412
*       R1) UNRSTD;                 /* RELEASE REG 0 AND 1           */
*NEXTUCB:                                                          0413
*     TMC1LOCL=''B;                 /* RESET TMC01 LOCAL WORKAREA    */
NEXTUCB  XC    TMC1LOCL(12,DDRPTR),TMC1LOCL(DDRPTR)                0413
*     INDEXUCB=INDEXUCB+TWO;        /* UPDATE TO NEXT UCB PTR        */
         AL    INDEXUCB,@CF00086                                   0414
*     UCBPTR=TMCUCB;                /* SET NEXT UCBPTR               */
         LH    UCBPTR,TMCUCB(,INDEXUCB)                            0415
         N     UCBPTR,@CF03319                                     0415
*   END;                            /* END OF CHECK UCB              */
@DE00314 C     UCBPTR,@CF03156                                     0416
         BNE   @DL00314                                            0416
*   RFY                                                            0417
*     INDEXUCB UNRSTD;              /* RELEASE REG 4 USED FOR UCB  0417
*                                      LIST INDEX                    */
*                                                                  0418
*/********************************************************************/
*/*                                                                  */
*/*  END UCB: END OF SCAN UCBS                                       */
*/*                                                                  */
*/*  INPUT: PTR TO DDRCOM                                            */
*/*         PTR TO TQE                                               */
*/*         PTR TO ECB                                               */
*/*                                                                  */
*/*  FUNCTION: 1.POST ECB FOR IGFTMCHK TO ISSUE MESSAGE              */
*/*            2.ENQUE TQE FOR NEXT TIME TO CHECK UCBS               */
*/*            3.CANCEL FRR AND RETURN TO DISPATCHER                 */
*/*                                                                  */
*/*  OUTPUT: ECB POSTED AND WAIT FOR NEXT TIME INTERVAL              */
*/*                                                                  */
*/********************************************************************/
*                                                                  0418
*   RFY                                                            0418
*    (R0,                                                          0418
*     R15) RSTD;                    /* RESTRICT REG 0 AND 15         */
*   STM(R0,R15,TMC01SAV);           /* STORE REGISTERS 0-15          */
         STM   R0,R15,TMC01SAV(DDRPTR)                             0419
*   GEN REFS(PSALITA,FLC);                                         0420
*                                     /*
    SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,                            **
               RELATED=('POST-LOCAL LOCK RELEASED AFTER POST')
*   RFY                                                            0421
*    (R5,                                                          0421
*     R10,                                                         0421
*     R11) RSTD;                    /* RESTRICT REG 5 10 AND 11      */
*   R5=R10;                         /* SAVE DDRCOM PTR               */
         LR    R5,R10                                              0422
*   R10=ZERO;                       /* ZERO THE COMPLETION CODE      */
         SLR   R10,R10                                             0423
*   R11=ECBPTR;                     /* SET UP PTR TO ECB             */
         LR    R11,ECBPTR                                          0424
*   CALL POSTRTN;                   /* CALL POST ROUTINE             */
         L     @12,CVTPTR                                          0425
         L     @15,CVT0PT01(,@12)                                  0425
         BALR  @14,@15                                             0425
*   R10=R5;                         /* RESTORE DDRCOM PTR            */
         LR    R10,R5                                              0426
*   GEN REFS(PSALITA,FLC);                                         0427
*                                     /*
       SETLOCK RELEASE,TYPE=LOCAL,                                    **
               RELATED=('POST-LOCAL LOCK OBTAINED BEFORE POST')
*   LM(R0,R15,TMC01SAV);            /* RESTORE REGISTERS 0-15        */
         LM    R0,R15,TMC01SAV(DDRPTR)                             0428
*   RFY                                                            0429
*    (R0,                                                          0429
*     R5,                                                          0429
*     R10,                                                         0429
*     R11,                                                         0429
*     R15) UNRSTD;                  /* RELEASE REG 0,5,10,11,15      */
*IGFTMC2R:                          /* IGFTMC02 RETRY ROUTINE        */
*   GEN(STCK MIHTOD(DDRPTR));       /* STORE CURRENT TIME-OF-DAY     */
IGFTMC2R STCK MIHTOD(DDRPTR)
*   BC(EQ,GOODTIME);                /* TIME STORED?                  */
         BC    8,GOODTIME                                          0431
*   MIHTOD=TQEVAL;                  /* SET ORGINAL CLOCK VALUE FOR 0432
*                                      BAD CLOCK                     */
         MVC   MIHTOD(8,DDRPTR),TQEVAL(TQEPTR)                     0432
*GOODTIME:                                                         0433
*   TQEVALLH=MIHTODS+MIHSECND;      /* UPDATE TIME INTERVAL          */
GOODTIME L     @12,MIHTODS(,DDRPTR)                                0433
         AL    @12,MIHSECND(,DDRPTR)                               0433
         ST    @12,TQEVALLH(,TQEPTR)                               0433
*   GEN REFS(FLC,PSALITA);                                         0434
*                                     /*
    SETLOCK  OBTAIN,TYPE=DISP,MODE=UNCOND,                            **
               RELATED=('ENQTQE-RELEASED AFTER ENQTQE COMPLETED')
*   RFY                                                            0435
*    (R1,                                                          0435
*     R2) RSTD;                     /* RESTRICT REG 1,2              */
*   R1=TQEPTR;                      /* SET TQE ADDR                  */
         LR    R1,TQEPTR                                           0436
*   R2=ADDR(ENQRETN);               /* SET RETURN ADDRESS            */
         LA    R2,ENQRETN                                          0437
*   CALL ENQTQE;                    /* REENQUEUE THE TQE             */
         L     @12,CVTPTR                                          0438
         L     @15,CVTQTE00(,@12)                                  0438
         BALR  @14,@15                                             0438
*   RFY                                                            0439
*    (R1,                                                          0439
*     R2) UNRSTD;                   /* RELEASE REG 1,2               */
*ENQRETN:                                                          0440
*   GEN REFS(FLC,PSALITA);                                         0440
ENQRETN  DS    0H                                                  0440
*                                     /*
    SETLOCK  RELEASE,TYPE=DISP,                                       **
               RELATED=('ENQTQE-OBTAINED BEFORE ENQTQE')
*   RFY                                                            0441
*    (R4,                                                          0441
*     R5) RSTD;                     /* RESTRICT REG4 AND REG5        */
*   GEN REFS(R4,R5,PSACSTK,FRRSCURR,FRRS,FRRSEMP,FRRSELEN,FRRSCURR);
  SETFRR  D,WRKREGS=(R4,R5),RELATED=('IGFTMFRR-FRR EXIT ROUTINE')
*   RFY                                                            0443
*    (R4,                                                          0443
*     R5) UNRSTD;                                                  0443
*                                                                  0443
*/*EACH SRB FOR IGFTMC01 WILL BE RETRIED THREE TIMES WHEN ERROR    0444
*   OCCURRED                                                         */
*                                                                  0444
*   IF TMC01RTY=OFF THEN            /* RETRY YET?                    */
         TM    TMC01RTY(DDRPTR),B'00100000'                        0444
         BNZ   @RF00444                                            0444
*     TMC1RETY=ZERO;                /* NO-ZERO RETRY COUNT           */
         SLR   @12,@12                                             0445
         STH   @12,TMC1RETY(,DDRPTR)                               0445
*   RFY                                                            0446
*     R14 RSTD;                     /* RESTRICT REG 14               */
@RF00444 DS    0H                                                  0447
*   R14=R14SAVE;                    /* RESTORE RETURN ADDRESS        */
         L     R14,R14SAVE(,DDRPTR)                                0447
*   RFY                                                            0448
*     R14 UNRSTD;                   /* RELEASE REG 14                */
*   RETURN;                         /* RETURN TO DISPATCHER          */
         B     @EL00001                                            0449
*                                                                  0450
*/********************************************************************/
*/*                                                                  */
*/*   IGFTMC02: TO INVOKE I/O RESTART                                */
*/*                                                                  */
*/*   INPUT: REGISTER 0 WILL CONTAINS THE ADDRESS OF SRB             */
*/*          IN SRB PARM WILL CONTAIN THE NO OF UCB AND UCB          */
*/*          ADDRESS FOR I/O RESTART                                 */
*/*                                                                  */
*/*   FUNCTION: IGFTMC02 IS ENTERED FROM THE SRB DISPATCHER SCHEDULED*/
*/*             BY IGFTMC01. ITS FUNCTION IS TO CALL THE I/O RESTART */
*/*             FACILITY TO CLEAR A LOST CHANNEL END,CHANNEL END AND */
*/*             DEVICE OR DEVICE END ON A PAGE PACK OR       @ZA28603*/
*/*            SYSRES DEVICE.                                @ZA28603*/
*/*                                                                  */
*/*   OUTPUT:   A LOST CHANNEL END OR DEVICE END ON A PAGE PACK      */
*/*             HAS BEEN CLEARED. THE STORAGE AREA HAS BEEN FREED    */
*/*             AFTERWARDS                                           */
*/*                                                                  */
*/********************************************************************/
*                                                                  0450
*IGFTMC02:                                                         0450
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0450
IGFTMC02 DS    0H                                                  0451
*   GEN REFS(CODEBASE,R15,IGFTMC02) SETS(CODEBASE,R15);            0451
*                                 /*
             LR   CODEBASE,R15
             LA   R15,IGFTMC02-@PSTART
             SR   CODEBASE,R15
*   RFY                                                            0452
*    (R0,                                                          0452
*     R1,                                                          0452
*     R2,                                                          0452
*     R5,                                                          0452
*     R6,                                                          0452
*     R14) RSTD;                    /* RESTICT REG0,1,2,5,6 AND 14   */
*   SAVEPTR=ADDR(TMC2SAV);          /* SET SAVE AREA ADDRESS @VM43061*/
         LA    SAVEPTR,TMC2SAV(,R1)                                0453
*   R6=R14;                         /* SAVE REG 14 FOR RETURN        */
         LR    R6,R14                                              0454
*   GEN REFS(TMSTOSM1,R1)(STNSM TMSTOSM1(R1),X'FC');/* DISABLE FOR 0455
*                                      I/O AND EXTERNAL INTERRUPTS   */
         STNSM TMSTOSM1(R1),X'FC'
*   R5=R1;                          /* SAVE INPUT PARAM AREA PTR     */
         LR    R5,R1                                               0456
*   R1=TMC2UCB;                     /* INIT REG1 FOR RESTART         */
         L     R1,TMC2UCB(,R1)                                     0457
*   CALL IECVRSTI;                  /* CALL I/O RESTART              */
         L     @15,@CV03139                                        0458
         BALR  @14,@15                                             0458
*   R1=R5;                          /* RESET INPUT AREA PTR          */
         LR    R1,R5                                               0459
*   RFY                                                            0460
*     R5 UNRSTD;                    /* RELEASE REG 5                 */
*   R2=TMSTOSM1;                    /* GET OLD SYSTEM MASK           */
         SLR   R2,R2                                               0461
         IC    R2,TMSTOSM1(,R1)                                    0461
*   GEN(EX R2,TMCSTNSM);            /* RESET FLAGS                   */
         EX R2,TMCSTNSM
*/*     FREE THE INPUT PARAMETER AREA                                */
*                                                                  0463
*   GEN REFS(FLC,PSALITA);                                         0463
*                                /*
     SETLOCK OBTAIN,TYPE=SALLOC,MODE=UNCOND,                          **
               RELATED=('FREEMAIN-RELEASED AFTER FREEMAIN COMPLETED')
*   R0=LENGTH(TMC2IN);              /* SET LEN FOR FREE              */
         LA    R0,124                                              0464
*   GEN REFS(CVTPTR,CVTMAP,CVTGLMN,CVTSPSA,WSAG,WSAGGMFM);         0465
*                                                          /*
      FREEMAIN  RU,LV=(0),A=(1),SP=245,BRANCH=(YES,GLOBAL)
      SETLOCK   RELEASE,TYPE=SALLOC,                                  **
               RELATED=('FREEMAIN-OBTAINED BEFORE FREEMAIN ISSUED')
*   R14=R6;                         /* RESTORE REGISTER 14 FOR RETURN*/
         LR    R14,R6                                              0466
*   RFY                                                            0467
*    (R0,                                                          0467
*     R2,                                                          0467
*     R6,                                                          0467
*     R14) UNRSTD;                  /* RELEASE REG 0,2,6,14          */
*   RETURN;                         /* RETURN TO DISPATCHER          */
@EL00002 DS    0H                                                  0468
@EF00002 DS    0H                                                  0468
@ER00002 BR    @14                                                 0468
*   GEN REFS(TMSTOSM1,R1);                                         0469
*                            /*
TMCSTNSM  STOSM TMSTOSM1(R1),X'00'     RESET SYSTEM MASK
*   RFY                                                            0470
*     R1 UNRSTD;                    /* RELEASE REG 1                 */
*   END IGFTMC02;                                                  0471
         B     @EL00002                                            0471
*                                                                  0472
*/********************************************************************/
*/*                                                                  */
*/*   IGFTMFRR: IGFTMC01 FRR ROUTINE                                 */
*/*                                                                  */
*/*   INPUT: REG1 PTR TO SDWA                                        */
*/*          IN SDWAPARM : PTR TO DDRCOM                             */
*/*                        PTR TO TQE                                */
*/*                        PTR TO ECB                                */
*/*                        PTR TO GETMAIN IN SQA                     */
*/*                                                                  */
*/*   FUNCTION: IGFTMC01 ERROR RECOVERY ROUTINE. IT WILL RETRY       */
*/*             THREE TIME. IF THE ERROR IS STILL OCCURRED AFTER     */
*/*             THE THIRD TIME RETRY,MIH FUNCTION WILL BE TERMINATED.*/
*/*             A COMPLETION CODE OF 45 WILL BE POSTED TO IGFTMCHK   */
*/*             FOR TERMINATION                                      */
*/*                                                                  */
*/*   OUTPUT: NONE                                                   */
*/*                                                                  */
*/********************************************************************/
*                                                                  0472
*IGFTMFRR:                                                         0472
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0472
IGFTMFRR DS    0H                                                  0473
*   GEN REFS(CODEBASE,R15,IGFTMFRR) SETS(CODEBASE,R15);            0473
*                                      /*
             LR CODEBASE,R15            SET UP ADDRESSABILITY
             LA R15,IGFTMFRR-@PSTART
             SR CODEBASE,R15
*   RFY                                                            0474
*    (R1,                                                          0474
*     R4,                                                          0474
*     R14) RSTD;                    /* RESTRICT REG1,4 AND 14        */
*   R4=R14;                         /* SAVE RETURN ADDRESS           */
         LR    R4,R14                                              0475
*   FRRPARM=SDWAPARM;               /* SET UP ADDRESS OF FRRAREA     */
         L     FRRPARM,SDWAPARM(,SDWAPTR)                          0476
*   DDRPTR=FRRDDRCM;                /* SET ADDRESSABILITY IN DDRCOM  */
         L     DDRPTR,FRRDDRCM(,FRRPARM)                           0477
*   TQEPTR=FRRTQE;                  /* SET UP TQE ADDRESSABILITY     */
         L     TQEPTR,FRRTQE(,FRRPARM)                             0478
*   ECBPTR=FRRECB;                  /* SET UP ECB ADDRESSABILITY     */
         L     ECBPTR,FRRECB(,FRRPARM)                             0479
*   RFY                                                            0480
*    (R0,                                                          0480
*     R15) RSTD;                    /* RESTRICT REG0 AND 15          */
*   STM(R0,R15,TMC01SAV);           /* SAVE REG 0-15                 */
         STM   R0,R15,TMC01SAV(DDRPTR)                             0481
*   IF FRRSQA^=ZERO THEN            /* IO RESTART SRB OBTAINED       */
         L     @12,FRRSQA(,FRRPARM)                                0482
         LTR   @12,@12                                             0482
         BZ    @RF00482                                            0482
*     DO;                           /* YES                           */
*       R1=FRRSQA;                  /* SET GETMAIN SQA PTR           */
         LR    R1,@12                                              0484
*       R0=LENGTH(TMC2IN);          /* SET GETMAIN SQA LENGTH        */
         LA    R0,124                                              0485
*       GEN REFS(FLC,PSALITA,CVTPTR,CVTMAP,CVTGLMN,CVTSPSA,WSAG,   0486
*           WSAGGMFM);                                             0486
*                    /*
      SETLOCK OBTAIN,TYPE=SALLOC,MODE=UNCOND,                         **
               RELATED=('FREEMAIN-OBTAINED BEFORE FREEMAIN')
      FREEMAIN RU,LV=(0),A=(1),SP=245,BRANCH=(YES,GLOBAL)
      SETLOCK RELEASE,TYPE=SALLOC,                                    **
               RELATED=('FREEMAIN-RELEASE AFTER FREEMAIN')
*     END;                          /* END OF FREE SQA FOR SCHEDULE A
*                                      SRB                           */
*   GEN REFS(FLC,PSALITA);                                         0488
@RF00482 DS    0H                                                  0488
*                                      /*
    SETLOCK OBTAIN,TYPE=DISP,MODE=UNCOND,                             **
               RELATED=('DEQTQE-RELEASED AFTER DEQTQE COMPLETED')
*   LM(R0,R15,TMC01SAV);            /* RESTORE REG0-15               */
         LM    R0,R15,TMC01SAV(DDRPTR)                             0489
*   RFY                                                            0490
*     R2 RSTD;                      /* RESTRICT REG2                 */
*   R1=TQEPTR;                      /* SETUP TQE ADDR IN PARAM       */
         LR    R1,TQEPTR                                           0491
*   R2=ADDR(DEQRETN);               /* SET RETURN ADDRESS FROM DEQTQE*/
         LA    R2,DEQRETN                                          0492
*   CALL DEQTQE;                    /* ENSURE TQE NOT ON RTQ DEQTQE
*                                      WILL NOT FAIL IF IT IS ALREADY
*                                      DEQUEUED                      */
         L     @12,CVTPTR                                          0493
         L     @15,CVTQTD00(,@12)                                  0493
         BALR  @14,@15                                             0493
*   RFY                                                            0494
*     R2 UNRSTD;                    /* RELEASE REG2                  */
*DEQRETN:                                                          0495
*   GEN REFS(FLC,PSALITA);                                         0495
DEQRETN  DS    0H                                                  0495
*                          /*        /*RELEASE DISP LOCK           */
     SETLOCK RELEASE,TYPE=DISP,                                       **
               RELATED=('DEQTQE-OBTAINED BEFORE DEQTQE')
*   RFY                                                            0496
*    (R0,                                                          0496
*     R15) UNRSTD;                  /* RELEASE REG 0-15              */
*   IF TMC1RETY<=THREE|FRREXITI^=ZERO/* ERROR RETRY MORE THAN 3 TIME
*                                      OR ERROR IN EXIT ROUTINE    0497
*                                                            @G24LNLC*/
*     THEN                                                         0497
         LH    @15,TMC1RETY(,DDRPTR)                               0497
         C     @15,@CF00305                                        0497
         BNH   @RT00497                                            0497
         L     @15,FRREXITI-1(,FRRPARM)                            0497
         LA    @15,0(,@15)                                         0497
         LTR   @15,@15                                             0497
         BZ    @RF00497                                            0497
@RT00497 DS    0H                                                  0498
*     DO;                           /* NO                            */
*       SAVEPTR=ADDR(TMC01SAV);     /* SET REG 13 TO SAVEAREA ADDR   */
         LA    SAVEPTR,TMC01SAV(,DDRPTR)                           0499
*       RFY                                                        0500
*        (R0,                                                      0500
*         R15) RSTD;                /* RESTRICT REG0 AND 15          */
*       STM(R0,R15,SDWASRSV);       /* STORE REGISTERS 0-15 IN SDWA
*                                      RETRY                         */
         STM   R0,R15,SDWASRSV(SDWAPTR)                            0501
*       RFY                                                        0502
*        (R0,                                                      0502
*         R15) UNRSTD;              /* RELEASE REG 0 AND 15          */
*       SDWAMODN=TMC00;             /* SET IGFTMC00 MODULE NAME IN 0503
*                                      SDWA                          */
         MVC   SDWAMODN(8,SDWAPTR),@CC03172                        0503
*       SDWACSCT=TMC01;             /* SET IGFTMC01 AS CSECT NAME    */
         MVC   SDWACSCT(8,SDWAPTR),@CC03174                        0504
*       SDWAREXN=TMFRR;             /* SET IGFTMFRR AS FRR EXIT      */
         MVC   SDWAREXN(8,SDWAPTR),@CC03176                        0505
*       IF FRREXITI^=ZERO THEN                                     0506
         L     @15,FRREXITI-1(,FRRPARM)                            0506
         LA    @15,0(,@15)                                         0506
         LTR   @15,@15                                             0506
         BZ    @RF00506                                            0506
*         DO;                       /* IF EXIT ACTIVE HANDLE EXIT  0507
*                                      ERROR                 @G24LNLC*/
*           IF FRROPTI=ON THEN                                     0508
         TM    FRROPTI(FRRPARM),B'10000000'                        0508
         BNO   @RF00508                                            0508
*             DO;                   /* IF ON ONCE PER MIH EXIT     0509
*                                                            @G24LNLC*/
*               IF TMCEXER1(FRREXITI)>=THREE THEN                  0510
         SLA   @15,3                                               0510
         L     @12,TMCEXER1-8(@15)                                 0510
         C     @12,@CF00305                                        0510
         BL    @RF00510                                            0510
*                 DO;               /*                       @G24LNLC*/
*                   TMCEX1(FRREXITI)=ADDR(TMCBR14);/* DELETE EXIT IF
*                                      MORE THAN 3 ERRORS    @G24LNLC*/
         LA    @12,TMCBR14                                         0512
         ST    @12,TMCEX1-8(@15)                                   0512
*                   TMCEXER1(FRREXITI)=ZERO;/* ZERO ERROR COUNT    0513
*                                                            @G24LNLC*/
         SLR   @12,@12                                             0513
         ST    @12,TMCEXER1-8(@15)                                 0513
*                 END;                                             0514
*               ELSE                                               0515
*                 TMCEXER1(FRREXITI)=TMCEXER1(FRREXITI)+ONE;/* UPDATE
*                                      ERROR COUNT           @G24LNLC*/
         B     @RC00510                                            0515
@RF00510 L     @15,FRREXITI-1(,FRRPARM)                            0515
         LA    @15,0(,@15)                                         0515
         SLA   @15,3                                               0515
         LA    @12,1                                               0515
         AL    @12,TMCEXER1-8(@15)                                 0515
         ST    @12,TMCEXER1-8(@15)                                 0515
*             END;                                                 0516
*           ELSE                                                   0517
*             DO;                   /* HANDLE UCB EXIT ERROR @G24LNLC*/
         B     @RC00508                                            0517
@RF00508 DS    0H                                                  0518
*               IF TMCEXER2(FRREXITI)>=THREE THEN                  0518
         L     @15,FRREXITI-1(,FRRPARM)                            0518
         LA    @15,0(,@15)                                         0518
         SLA   @15,3                                               0518
         L     @12,TMCEXER2-8(@15)                                 0518
         C     @12,@CF00305                                        0518
         BL    @RF00518                                            0518
*                 DO;               /* G24LNLC                       */
*                   TMCEX2(FRREXITI)=ADDR(TMCBR14);/* DELETE EXIT  0520
*                                                            @G24LNLC*/
         LA    @12,TMCBR14                                         0520
         ST    @12,TMCEX2-8(@15)                                   0520
*                   TMCEXER2(FRREXITI)=ZERO;/* ZERO ERROR COUNT    0521
*                                                            @G24LNLC*/
         SLR   @12,@12                                             0521
         ST    @12,TMCEXER2-8(@15)                                 0521
*                 END;                                             0522
*               ELSE                                               0523
*                 TMCEXER2(FRREXITI)=TMCEXER2(FRREXITI)+ONE;/* UPDATE
*                                      ERROR COUNT           @G24LNLC*/
         B     @RC00518                                            0523
@RF00518 L     @15,FRREXITI-1(,FRRPARM)                            0523
         LA    @15,0(,@15)                                         0523
         SLA   @15,3                                               0523
         LA    @12,1                                               0523
         AL    @12,TMCEXER2-8(@15)                                 0523
         ST    @12,TMCEXER2-8(@15)                                 0523
*             END;                                                 0524
*         END;                                                     0525
*       ELSE                                                       0526
*         TMC1RETY=TMC1RETY+ONE;    /* ERROR NOT IN EXIT UPDATE TOTAL
*                                      RETRY COUNT FOR MIH   @G24LNLC*/
         B     @RC00506                                            0526
@RF00506 LA    @15,1                                               0526
         AH    @15,TMC1RETY(,DDRPTR)                               0526
         STH   @15,TMC1RETY(,DDRPTR)                               0526
*       DO;                         /* SETRP RETADDR(IGFTMC2R)RETREGS
*                                      (YES)RC(4)RECORD(YES)         */
@RC00506 DS    0H                                                  0528
*         RESPECIFY                                                0528
*          (GPR00P,                                                0528
*           GPR01P,                                                0528
*           GPR14P,                                                0528
*           GPR15P) RSTD;                                          0528
*         GPR01P->SDWARCDE=4;       /* STORE RC INTO SDWA            */
         MVI   SDWARCDE(GPR01P),X'04'                              0529
*         GPR01P->SDWARTYA=ADDR(IGFTMC2R);/* SAVE RETRY ADDRESS      */
         LA    @12,IGFTMC2R                                        0530
         ST    @12,SDWARTYA(,GPR01P)                               0530
*         GPR01P->SDWARCRD='1'B;    /* TURN ON RECORD INDICATOR      */
*         GPR01P->SDWAUPRG='1'B;    /* TURN ON RETREGS INDICATOR     */
         OI    SDWARCRD(GPR01P),B'10001000'                        0532
*         RESPECIFY                                                0533
*          (GPR00P,                                                0533
*           GPR01P,                                                0533
*           GPR14P,                                                0533
*           GPR15P) UNRSTD;                                        0533
*       END;                                                       0534
*       TMC01RTY=ON;                /* SET UP RETRY FLAG             */
         OI    TMC01RTY(DDRPTR),B'00100000'                        0535
*     END;                                                         0536
*   ELSE                            /* RETRY MORE THAN 3 TIMES?      */
*     DO;                           /* YES                           */
         B     @RC00497                                            0537
@RF00497 DS    0H                                                  0538
*       IF ECBCODE=ECBPOST THEN     /* ECB POSTED ALREADY?           */
         CLI   ECBCODE(ECBPTR),X'40'                               0538
         BNE   @RF00538                                            0538
*         ECB=ZERO;                 /* RESET THE ECB TO ZERO         */
         SLR   @15,@15                                             0539
         ST    @15,ECB(,ECBPTR)                                    0539
*       GEN REFS(PSALITA,FLC);                                     0540
@RF00538 DS    0H                                                  0540
*                                     /*
            SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,                    **
               RELATED=('POST-LOCAL LOCK RELEASED AFTER POST')
*       RFY                                                        0541
*        (R10,                                                     0541
*         R11) RSTD;                /* RESTRICT REG 10 AND 11        */
*       R10=ERRCOMP;                /* SET MIH IN PERMANENT ERR      */
         LA    R10,45                                              0542
*       R11=ECBPTR;                 /* SET PTR TO ECB                */
         LR    R11,ECBPTR                                          0543
*       CALL POSTRTN;               /* POST ERR ECB TO IGFTMCHK      */
         L     @12,CVTPTR                                          0544
         L     @15,CVT0PT01(,@12)                                  0544
         BALR  @14,@15                                             0544
*       RFY                                                        0545
*        (R10,                                                     0545
*         R11) UNRSTD;              /* RELEASE REG 10 AND 11         */
*       GEN REFS(PSALITA,FLC);                                     0546
*                                     /*
             SETLOCK RELEASE,TYPE=LOCAL,                              **
               RELATED=('POST-LOCAL LOCK OBTAINED BEFORE POST')
*       DO;                         /* SETRP RC(0)                   */
*         RESPECIFY                                                0548
*          (GPR00P,                                                0548
*           GPR01P,                                                0548
*           GPR14P,                                                0548
*           GPR15P) RSTD;                                          0548
*         GPR01P->SDWARCDE=0;       /* SAVE RC VALUE                 */
         MVI   SDWARCDE(GPR01P),X'00'                              0549
*         RESPECIFY                                                0550
*          (GPR00P,                                                0550
*           GPR01P,                                                0550
*           GPR14P,                                                0550
*           GPR15P) UNRSTD;                                        0550
*       END;                        /* ABEND CONTINUED               */
*     END;                                                         0552
*   R14=R4;                         /* RESTORE RETURN ADDR           */
@RC00497 LR    R14,R4                                              0553
*   RFY                                                            0554
*    (R1,                                                          0554
*     R4,                                                          0554
*     R14) UNRSTD;                  /* RELEASE REG1,4 14             */
*   RETURN;                         /* RETURN TO DISPATCHER          */
@EL00003 DS    0H                                                  0555
@EF00003 DS    0H                                                  0555
@ER00003 BR    @14                                                 0555
*   END IGFTMFRR;                                                  0556
*   DECLARE                         /* GENERAL PURPOSE REGISTERS     */
*     GPR00P PTR(31) REG(0),                                       0557
*     GPR01P PTR(31) REG(1),                                       0557
*     GPR14P PTR(31) REG(14),                                      0557
*     GPR15P PTR(31) REG(15);                                      0557
*   DECLARE                         /* COMMON VARIABLES              */
*     I256C CHAR(256) BASED,                                       0558
*     I031F FIXED(31) BASED,                                       0558
*     I031P PTR(31) BASED,                                         0558
*     I015F FIXED(15) BASED,                                       0558
*     I015P PTR(15) BASED,                                         0558
*     I008P PTR(8) BASED,                                          0558
*     I001C CHAR(1) BASED;                                         0558
*   END IGFTMC00                                                   0559
*                                                                  0559
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IHAASVT )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IEEBASEA)                                       */
*/*%INCLUDE SYSLIB  (IHADDR  )                                       */
*/*%INCLUDE SYSLIB  (IECDIOCM)                                       */
*/*%INCLUDE SYSLIB  (IECDIOQ )                                       */
*/*%INCLUDE SYSLIB  (IECDIOSB)                                       */
*/*%INCLUDE SYSLIB  (IHAFRRS )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IHASDWA )                                       */
*/*%INCLUDE SYSLIB  (IHASRB  )                                       */
*/*%INCLUDE SYSLIB  (IHATQE  )                                       */
*/*%INCLUDE SYSLIB  (IEFUCBOB)                                       */
*/*%INCLUDE SYSLIB  (IHAWSAVT)                                       */
*/*%INCLUDE SYSLIB  (IKJTCB  )                                       */
*/*%INCLUDE SYSLIB  (IKJRB   )                                       */
*                                                                  0559
*       ;                                                          0559
@DATA    DS    0H
@DATD    DSECT
         DS    0F
IGFTMC00 CSECT
         DS    0F
@CF00046 DC    F'1'
@CF00086 DC    F'2'
@CF00305 DC    F'3'
@CF03311 DC    F'128'
@CF03324 DC    F'-4'
@CF03319 DC    XL4'0000FFFF'
@CF03153 DC    XL4'8000'
@CF03156 DC    XL4'FFFF'
@DATD    DSECT
         DS    0D
TCBPTR   DS    A
RBSECPTR DS    A
IGFTMC00 CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV03139 DC    V(IECVRSTI)
         DS    0D
@CC03172 DC    C'IGFTMC00'
@CC03174 DC    C'IGFTMC01'
@CC03176 DC    C'IGFTMFRR'
@CC03158 DC    C'SRB '
MIHTAB   DC    X'00'
         DC    X'02'
         DC    X'03'
         DC    X'04'
         DC    X'01'
         DC    X'01'
         DC    X'03'
         DC    X'04'
         DC    X'05'
         DC    X'02'
         DC    X'03'
         DC    X'04'
         DC    X'05'
         DC    X'05'
         DC    X'03'
         DC    X'04'
IGFTMC00 CSECT
*                                    /*EXIT TABLE DEFINITION @G24LNLC*
        WXTRN ICBTMSS0
        WXTRN ICBTMSS1
TMCEXIT1 DC A(ICBTMSS0),XL4'00'
TMCEXIT2 DC A(ICBTMSS1),XL4'00'
TMCBR14  BR 14
IGFTMC00 CSECT
*                                                        /* @ZA28603*/
        DS    0H                                              @ZA28603
IGFTMC0P DC   ((@DATA-@PSTART)/20)X'00'                       @ZA28603
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IGFTMC00 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
I        EQU   @04
CODEBASE EQU   @08
DDRPTR   EQU   @10
SDWAPTR  EQU   @01
SRBPTR   EQU   @04
TQEPTR   EQU   @09
UCBPTR   EQU   @02
R0       EQU   @00
R1       EQU   @01
R2       EQU   @02
INDEXUCB EQU   @11
FRRPARM  EQU   @03
R4       EQU   @04
R5       EQU   @05
INDEXALT EQU   @05
R6       EQU   @06
MSGPTR   EQU   @06
ECBPTR   EQU   @07
R10      EQU   @10
R11      EQU   @11
R12      EQU   @12
SAVEPTR  EQU   @13
R14      EQU   @14
R15      EQU   @15
GPR00P   EQU   @00
GPR01P   EQU   @01
GPR14P   EQU   @14
GPR15P   EQU   @15
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
FLCCVT   EQU   FLCICCW2
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSALITA  EQU   PSA+764
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
PSALSFCC EQU   PSA+1012
ASVT     EQU   0
ASVTFRST EQU   ASVT+524
ASVTENTY EQU   ASVT+528
CVTMAP   EQU   0
CVT      EQU   CVTMAP
CVTILK2  EQU   CVTMAP+40
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTQTE00 EQU   CVTMAP+104
CVTQTD00 EQU   CVTMAP+108
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIXAVL EQU   CVTMAP+124
CVTIERLC EQU   CVTMAP+144
CVTMSER  EQU   CVTMAP+148
CVT0PT01 EQU   CVTMAP+152
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTRMS   EQU   CVTMAP+224
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
BASE     EQU   0
@NM00004 EQU   BASE+13
BALGSTAT EQU   BASE+24
BALOG    EQU   BALGSTAT+4
BASFL    EQU   BASE+36
BARSW    EQU   BASFL
MSLOGST  EQU   BASE+46
BASPBYTE EQU   BASE+47
BAMONITR EQU   BASE+56
@NM00026 EQU   BASE+104
MSLGCLOZ EQU   BASE+108
MSCLOSSW EQU   MSLGCLOZ
MSLGWLOG EQU   BASE+112
MSWLOGSW EQU   MSLGWLOG
MSLGWTR  EQU   BASE+116
MSWTRSW  EQU   MSLGWTR
MSLGSTRT EQU   BASE+120
MSSTRTSW EQU   MSLGSTRT
MS1BASEX EQU   BASE+136
BASES01  EQU   0
MSNTAL   EQU   BASES01
MSSSB    EQU   BASES01+1
MSBTN    EQU   MSSSB
MSPFG    EQU   BASES01+2
MSECBFL  EQU   BASES01+3
MSTUS    EQU   BASES01+4
MSSSA    EQU   MSTUS
MSINLSW  EQU   MSSSA
MSREOF   EQU   MSSSA
MSNWP    EQU   MSSSA
MSFHF    EQU   BASES01+5
DDRCOM   EQU   0
DDRSHORT EQU   DDRCOM
DDRCNTRL EQU   DDRSHORT+8
DDRSRC   EQU   DDRCNTRL
DDRSTAT  EQU   DDRCNTRL+1
DDRDCHAR EQU   DDRCNTRL+2
DDRDSTAT EQU   DDRDCHAR+1
DDRLONG  EQU   DDRCOM+24
DDRROWN  EQU   DDRLONG+8
DDRMIHT  EQU   DDRLONG+12
DDRTER   EQU   DDRLONG+36
DDRINV   EQU   DDRLONG+38
DDRAPP   EQU   DDRLONG+40
DDRIOF   EQU   DDRLONG+52
DDRIOF2  EQU   DDRIOF+1
DDRMSG   EQU   DDRLONG+54
DDRMSGP  EQU   DDRLONG+56
DDRLABEL EQU   DDRLONG+64
DDRREC   EQU   DDRLONG+66
DDRREC2  EQU   DDRREC+1
DDRUSER  EQU   DDRLONG+68
IOCOM    EQU   0
IOCGENA  EQU   IOCOM+84
IOQ      EQU   0
IOQFLAGS EQU   IOQ+4
IOQFLA   EQU   IOQFLAGS
IOQFLB   EQU   IOQFLAGS+1
IOQIOSB  EQU   IOQ+8
IOSB     EQU   0
IOSFLA   EQU   IOSB
IOSACHN  EQU   IOSFLA
IOSFLB   EQU   IOSB+1
IOSFLC   EQU   IOSB+2
IOSDVALT EQU   IOSFLC
IOSDVRID EQU   IOSB+4
IOSASID  EQU   IOSB+6
IOSPKEY  EQU   IOSB+12
IOSOPT   EQU   IOSB+14
IOSOPT2  EQU   IOSB+15
@NM00053 EQU   IOSB+20
IOSCSW   EQU   @NM00053+1
IOSTATUS EQU   IOSCSW+3
IOSIPIB  EQU   IOSB+44
IOSPATH  EQU   IOSB+86
IOSCHN   EQU   IOSPATH
IOSCKEY  EQU   IOSB+89
IOSEEKA  EQU   IOSB+100
IOSCCHH  EQU   IOSEEKA+3
IOSSKHH  EQU   IOSCCHH+2
FRRS     EQU   0
FRRSHEAD EQU   FRRS
FRRSEMP  EQU   FRRSHEAD
FRRSLAST EQU   FRRSHEAD+4
FRRSELEN EQU   FRRSHEAD+8
FRRSCURR EQU   FRRSHEAD+12
FRRSPTR  EQU   0
FRRSENTR EQU   0
FRRSFRRA EQU   FRRSENTR
FRRSFLGS EQU   FRRSENTR+4
FRRSFLG1 EQU   FRRSFLGS
FRRSPARM EQU   FRRSENTR+8
FRREPTR  EQU   0
SDWA     EQU   0
SDWAPARM EQU   SDWA
SDWAFIOB EQU   SDWA+4
SDWAABCC EQU   SDWAFIOB
SDWACMPF EQU   SDWAABCC
SDWACTL1 EQU   SDWA+8
SDWACMKA EQU   SDWACTL1
SDWAMWPA EQU   SDWACTL1+1
SDWAPMKA EQU   SDWACTL1+4
SDWACTL2 EQU   SDWA+16
SDWACMKP EQU   SDWACTL2
SDWAMWPP EQU   SDWACTL2+1
SDWAPMKP EQU   SDWACTL2+4
SDWAGRSV EQU   SDWA+24
SDWANAME EQU   SDWA+88
SDWAEC1  EQU   SDWA+104
SDWAEMK1 EQU   SDWAEC1
SDWAMWP1 EQU   SDWAEC1+1
SDWAINT1 EQU   SDWAEC1+2
SDWANXT1 EQU   SDWAEC1+4
SDWAAEC1 EQU   SDWA+112
SDWAILC1 EQU   SDWAAEC1+1
SDWAINC1 EQU   SDWAAEC1+2
SDWAICD1 EQU   SDWAINC1+1
SDWAEC2  EQU   SDWA+120
SDWAEMK2 EQU   SDWAEC2
SDWAMWP2 EQU   SDWAEC2+1
SDWAINT2 EQU   SDWAEC2+2
SDWANXT2 EQU   SDWAEC2+4
SDWAAEC2 EQU   SDWA+128
SDWAILC2 EQU   SDWAAEC2+1
SDWAINC2 EQU   SDWAAEC2+2
SDWAICD2 EQU   SDWAINC2+1
SDWASRSV EQU   SDWA+136
SDWAIDNT EQU   SDWA+200
SDWAMCH  EQU   SDWA+204
SDWASTCK EQU   SDWAMCH
SDWAMCHI EQU   SDWAMCH+8
SDWAMCHS EQU   SDWAMCHI
SDWAMCHD EQU   SDWAMCHI+1
SDWARSR1 EQU   SDWAMCH+12
SDWARSR2 EQU   SDWAMCH+13
SDWAFLGS EQU   SDWA+232
SDWAERRA EQU   SDWAFLGS
SDWAERRB EQU   SDWAFLGS+1
SDWAERRC EQU   SDWAFLGS+2
SDWAERRD EQU   SDWAFLGS+3
SDWAIOFS EQU   SDWA+238
SDWARTYA EQU   SDWA+240
SDWACPUA EQU   SDWA+248
SDWAPARQ EQU   SDWA+252
SDWARCDE EQU   SDWAPARQ
SDWAACF2 EQU   SDWAPARQ+1
SDWARCRD EQU   SDWAACF2
SDWAUPRG EQU   SDWAACF2
SDWAACF3 EQU   SDWAPARQ+2
SDWAACF4 EQU   SDWAPARQ+3
SDWALKWA EQU   SDWA+256
SDWALKWS EQU   SDWALKWA
SDWARECP EQU   SDWA+292
SDWAMODN EQU   SDWARECP
SDWACSCT EQU   SDWARECP+8
SDWAREXN EQU   SDWARECP+16
SDWASNPA EQU   SDWA+320
SDWADUMP EQU   SDWASNPA
SDWADPFS EQU   SDWADUMP+1
SDWADDAT EQU   SDWASNPA+4
SDWASDAT EQU   SDWADDAT
SDWAPDAT EQU   SDWADDAT+2
SDWADPSA EQU   SDWA+328
SDWADPSL EQU   SDWADPSA
SDWARA   EQU   SDWA+400
SDWADPVA EQU   SDWARA+2
SRBSECT  EQU   0
SRB      EQU   SRBSECT
SRBID    EQU   SRB
SRBFLNK  EQU   SRB+4
SRBASCB  EQU   SRB+8
SRBFLC   EQU   SRB+12
SRBCPAFF EQU   SRBFLC
SRBPTCB  EQU   SRBFLC+4
SRBEP    EQU   SRB+20
SRBPARM  EQU   SRB+28
TQE      EQU   0
TQEFLGS  EQU   TQE+14
TQEFLGS2 EQU   TQE+15
TQEVAL   EQU   TQE+16
TQEVALLH EQU   TQEVAL
TQEEXIT  EQU   TQE+28
TQESRB   EQU   TQE+44
TQEFLGS3 EQU   TQE+88
TQESTCK  EQU   TQE+120
UCB      EQU   0
UCBIOQ   EQU   UCB+508
UCBOB    EQU   0
UCBJBNR  EQU   UCBOB
UCBMMSGP EQU   UCBJBNR
UCBFL5   EQU   UCBOB+1
UCBAF    EQU   UCBFL5
UCBALTPH EQU   UCBFL5
UCBSTAT  EQU   UCBOB+3
UCBONLI  EQU   UCBSTAT
UCBALOC  EQU   UCBSTAT
UCBSYSR  EQU   UCBSTAT
UCBCHAN  EQU   UCBOB+4
UCBSFLS  EQU   UCBOB+6
UCBFLA   EQU   UCBSFLS
UCBFL1   EQU   UCBFLA
UCBBSY   EQU   UCBFL1
UCBNRY   EQU   UCBFL1
UCBPST   EQU   UCBFL1
UCBCUB   EQU   UCBFL1
UCBACTV  EQU   UCBFL1
UCBFLB   EQU   UCBSFLS+1
UCBCHM   EQU   UCBOB+8
UCBCHM1  EQU   UCBCHM
UCBPTH0  EQU   UCBCHM1
UCBPTH1  EQU   UCBCHM1
UCBCPU   EQU   UCBOB+11
UCBWGT   EQU   UCBOB+12
UCBMTPXP EQU   UCBWGT
UCBTYP   EQU   UCBOB+16
UCBTBYT1 EQU   UCBTYP
UCB1FEA5 EQU   UCBTBYT1
UCB1FEA6 EQU   UCBTBYT1
UCBTBYT2 EQU   UCBTYP+1
UCB2OPT2 EQU   UCBTBYT2
UCBDUDN1 EQU   UCB2OPT2
UCB2OPT3 EQU   UCBTBYT2
UCBDUDN2 EQU   UCB2OPT3
UCB2OPT4 EQU   UCBTBYT2
UCBRWTAU EQU   UCB2OPT4
UCB2OPT6 EQU   UCBTBYT2
UCB2OPT7 EQU   UCBTBYT2
UCBTBYT3 EQU   UCBTYP+2
UCBDVCLS EQU   UCBTBYT3
UCB3TAPE EQU   UCBDVCLS
UCB3DACC EQU   UCBDVCLS
UCBTBYT4 EQU   UCBTYP+3
UCBUNTYP EQU   UCBTBYT4
UCBEXTPT EQU   UCBOB+20
UCBFLC   EQU   UCBEXTPT
UCBTICBT EQU   UCBFLC
UCBDDRSW EQU   UCBFLC
UCBDEV   EQU   UCBOB+24
UCBCMEXT EQU   0
UCBATI   EQU   UCBCMEXT+3
@NM00141 EQU   UCBATI
UCBFLP1  EQU   UCBCMEXT+5
UCBCCWOF EQU   UCBCMEXT+8
UCBASID  EQU   UCBCMEXT+14
UCBMIHTI EQU   UCBCMEXT+16
UCBMT    EQU   0
UCBOCR   EQU   0
UCB3540X EQU   0
UCBDKBYT EQU   UCB3540X+6
UCB3800X EQU   0
UCBOPTNS EQU   UCB3800X
UCBACTIV EQU   UCB3800X+3
UCBMDRBF EQU   UCB3800X+36
UCBUCS   EQU   0
UCBUCSOP EQU   UCBUCS+4
UCBFCBOP EQU   UCBUCS+5
UCBBGN   EQU   0
WSAG     EQU   0
WSAGGMFM EQU   WSAG+4
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBRBP   EQU   TCB
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBJPQ   EQU   TCB+44
TCBPURGE EQU   TCBJPQ
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTME   EQU   TCB+120
TCBJSTCB EQU   TCB+124
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBXSCT  EQU   TCB+240
TCBXSCT1 EQU   TCBXSCT
TCBFOE   EQU   TCB+244
TCBESTAE EQU   TCB+264
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCB+276
TCBFBYT2 EQU   TCB+277
TCBRV124 EQU   TCB+278
TCBRV133 EQU   TCB+279
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
RBPREFIX EQU   0
RBRSV019 EQU   RBPREFIX+14
RBRSV028 EQU   RBPREFIX+15
RBRSV041 EQU   RBPREFIX+27
RBRSV054 EQU   RBPREFIX+39
RBRTOPSW EQU   RBPREFIX+40
RBRTPSW2 EQU   RBRTOPSW+8
RBRTICIL EQU   RBRTPSW2
RBFLAGS1 EQU   RBPREFIX+56
RBINTCDA EQU   RBPREFIX+61
RBSECT   EQU   0
RBPPSAV  EQU   RBSECT
@NM00147 EQU   RBSECT+10
@NM00148 EQU   @NM00147
RBTRSVRB EQU   @NM00148
@NM00150 EQU   @NM00147+1
RBETXR   EQU   @NM00150
RBEP     EQU   RBSECT+12
RBPGMQ   EQU   RBSECT+24
@NM00157 EQU   RBSECT+28
@NM00158 EQU   @NM00157
IRBEND   EQU   RBSECT+96
@NM00161 EQU   RBSECT+96
RBRSV138 EQU   @NM00161+7
RBSCBB   EQU   RBSECT+144
RBSPARM  EQU   RBSCBB+8
RBSFLGS1 EQU   RBSPARM
RBSIOPRC EQU   RBSFLGS1
RBSOWNR  EQU   RBSCBB+12
RBSFLGS2 EQU   RBSOWNR
RBSDATA  EQU   RBSCBB+16
RBSFLG3  EQU   RBSDATA
RBRSV150 EQU   RBSECT+167
TMCUCB   EQU   0
ALTPHUCB EQU   0
DEQTQE   EQU   0
POSTRTN  EQU   0
ENQTQE   EQU   0
DDRCOMWK EQU   0
MIHMSGPR EQU   DDRCOMWK+92
MIHRCNT  EQU   DDRCOMWK+96
TMC1RETY EQU   MIHRCNT+2
R14SAVE  EQU   DDRCOMWK+100
MIHTIMSD EQU   DDRCOMWK+104
MIHSECND EQU   MIHTIMSD
MIHTOD   EQU   DDRCOMWK+112
MIHTODS  EQU   MIHTOD
MIHLOCAL EQU   DDRCOMWK+120
MIHLSTAT EQU   MIHLOCAL
TMC01RTY EQU   MIHLSTAT
TMC1LOCL EQU   DDRCOMWK+124
TMCEXITP EQU   TMC1LOCL
MIHEFLG1 EQU   TMCEXITP
MIHIOR   EQU   MIHEFLG1
MIHCOND  EQU   TMCEXITP+3
MIHSW    EQU   MIHCOND
MIHMT    EQU   MIHCOND
MIHCE    EQU   MIHCOND
MIHDE    EQU   MIHCOND
MIHINTVA EQU   TMCEXITP+4
MIHCODE  EQU   TMC1LOCL+8
USERASID EQU   TMC1LOCL+10
MIHINTVL EQU   DDRCOMWK+136
TMC01SAV EQU   DDRCOMWK+148
FRRAREA  EQU   0
FRRDDRCM EQU   FRRAREA
FRRTQE   EQU   FRRAREA+4
FRRECB   EQU   FRRAREA+8
FRRSQA   EQU   FRRAREA+12
FRRETYPE EQU   FRRAREA+20
FRROPTI  EQU   FRRETYPE
FRREXITI EQU   FRRAREA+21
MSGBLK   EQU   0
NEXTMSG  EQU   MSGBLK
ERRCODE  EQU   MSGBLK+4
MIHASID  EQU   MSGBLK+6
MIHUCB   EQU   MSGBLK+8
TMC2IN   EQU   0
TMC2WRK  EQU   TMC2IN
TMSTOSM1 EQU   TMC2WRK
TMC2UCB  EQU   TMC2IN+4
TMCUCBNO EQU   TMC2UCB
TMCUCBAD EQU   TMC2UCB+1
TMC2SAV  EQU   TMC2IN+8
TMC2SRB  EQU   TMC2IN+80
INPARM   EQU   0
INTQE    EQU   INPARM
INDDRCM  EQU   INPARM+4
INECB    EQU   INPARM+8
ECB      EQU   0
ECBCODE  EQU   ECB
I001C    EQU   0
I008P    EQU   0
I015F    EQU   0
I015P    EQU   0
I031F    EQU   0
I031P    EQU   0
I256C    EQU   0
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTASVT  EQU   CVTS01+208
CVTLSMQ  EQU   CVTS01+268
CVTGLMN  EQU   CVTS01+332
CVTSPSA  EQU   CVTS01+336
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
CVTRSUME EQU   CVTS01+676
ASVTPTR  EQU   CVTASVT
CVTPTR   EQU   FLCCVT
IOCOMPTR EQU   CVTIXAVL
IOQPTR   EQU   UCBIOQ
IOSBPTR  EQU   IOQIOSB
IOSATTSC EQU   IOSIPIB
IOSWTOWA EQU   IOSIPIB
IOSPCISC EQU   IOSIPIB
FLC      EQU   PSA
PSARSVTE EQU   PSARSVT
PSACSTK  EQU   PSARSVTE
UCBOBS01 EQU   UCBDEV
UCBSTAB  EQU   UCBOBS01+10
UCBBSVL  EQU   UCBSTAB
UCBPGFL  EQU   UCBSTAB
UCBPRSRS EQU   UCBSTAB
UCBDMCT  EQU   UCBOBS01+11
UCBMOUNT EQU   UCBDMCT
UCBFL4   EQU   UCBOBS01+13
UCBOBS02 EQU   UCBDEV
UCBTFL1  EQU   UCBOBS02+19
UCBXTN   EQU   UCBOBS02+20
UCBVOPT  EQU   UCBXTN
UCBOBS03 EQU   UCBDEV
UCBXTADR EQU   UCBOBS03
UCBOBS04 EQU   UCBDEV
UCBBTA   EQU   UCBOBS04+12
UCBOBS06 EQU   UCBDEV
UCBAOF   EQU   UCBOBS06
UCBAOF1  EQU   UCBAOF
UCBAOF2  EQU   UCBAOF+1
@NM00140 EQU   UCBOBS06+3
UCBIRB   EQU   UCBOBS06+4
UCBGRAF  EQU   UCBIRB
UCBLDNCA EQU   UCBOBS06+8
UCBRDYQ  EQU   UCBLDNCA
UCBIRLN  EQU   UCBRDYQ
UCBLDNCB EQU   UCBRDYQ+1
UCBCTLNK EQU   UCBOBS06+12
UCBOBS07 EQU   UCBDEV
UCBOBS08 EQU   UCBDEV
UCBCTCAD EQU   UCBOBS08
UCBCTCF1 EQU   UCBOBS08+4
UCBOBS09 EQU   UCBDEV
RBSECS03 EQU   RBEP
RBCDE    EQU   RBSECS03
RBCDFLGS EQU   RBCDE
RBSECS05 EQU   RBPGMQ
RBSQE    EQU   RBSECS05
RBSECS06 EQU   RBPGMQ
RBIQE    EQU   RBSECS06
RBSECS07 EQU   RBPGMQ
RBIQE2   EQU   RBSECS07
RBSECS08 EQU   IRBEND
RBSECS09 EQU   IRBEND
CUCBSTAT EQU   UCBSTAT
TMCEXT1  EQU   TMCEXIT1
TMCEX1   EQU   TMCEXT1
TMCEXER1 EQU   TMCEXT1+4
TMCEXT2  EQU   TMCEXIT2
TMCEX2   EQU   TMCEXT2
TMCEXER2 EQU   TMCEXT2+4
RVTPTR   EQU   CVTRMS
TQEECB   EQU   TQEEXIT
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00164 EQU   CUCBSTAT
CUCBCHGS EQU   CUCBSTAT
@NM00163 EQU   CUCBSTAT
RBRSV161 EQU   RBSECS09+64
RBSIRBWA EQU   RBSECS09
RBIQEWRK EQU   RBSECS08+4
RBNEXAV  EQU   RBSECS08
RBIQEA   EQU   RBIQE2
RBIQE1   EQU   RBIQE+1
RBUSE    EQU   RBIQE
RBSQEA   EQU   RBSQE+1
@NM00162 EQU   RBSQE
RBCDE1   EQU   RBCDE+1
RBCDLOAD EQU   RBCDFLGS
RBCDXCTL EQU   RBCDFLGS
RBCDSYNC EQU   RBCDFLGS
RBCDNODE EQU   RBCDFLGS
RBCDSAVE EQU   RBCDFLGS
RBCDATCH EQU   RBCDFLGS
RBRSV009 EQU   RBCDFLGS
RBNOCELL EQU   RBCDFLGS
UCBRV066 EQU   UCBOBS09+4
UCBIOSBA EQU   UCBOBS09
UCBRV042 EQU   UCBOBS08+5
UCBRV082 EQU   UCBCTCF1
UCBRV081 EQU   UCBCTCF1
UCBRV080 EQU   UCBCTCF1
UCBRV079 EQU   UCBCTCF1
UCBRV078 EQU   UCBCTCF1
UCBRV077 EQU   UCBCTCF1
UCBRV076 EQU   UCBCTCF1
UCBCTC80 EQU   UCBCTCF1
UCBCTCAL EQU   UCBCTCAD
UCBICNCB EQU   UCBOBS07+4
UCBRV040 EQU   UCBOBS07
UCBCTLNA EQU   UCBCTLNK+1
UCBRLN   EQU   UCBCTLNK
UCBRDYQA EQU   UCBLDNCB
UCBINRLN EQU   UCBIRLN
UCBIRBA  EQU   UCBIRB+1
UCBRV039 EQU   UCBGRAF
UCBDWNR  EQU   UCBGRAF
UCBRPND  EQU   UCBGRAF
UCBUPM   EQU   UCBGRAF
UCBBTAM  EQU   UCBGRAF
UCBDRNO  EQU   UCBGRAF
UCBDRO   EQU   UCBGRAF
UCBOIP   EQU   UCBGRAF
UCBATRCD EQU   @NM00140
UCBSKPFG EQU   @NM00140
UCBRIPND EQU   @NM00140
UCBRTIAC EQU   @NM00140
UCBRSV79 EQU   @NM00140
UCBRSV78 EQU   @NM00140
UCBRSV77 EQU   @NM00140
UCBOLTEP EQU   @NM00140
UCBATNCT EQU   UCBOBS06+2
UCBRSV76 EQU   UCBAOF2
UCBRSV75 EQU   UCBAOF2
UCBRSV74 EQU   UCBAOF2
UCBRSV73 EQU   UCBAOF2
UCBRSV72 EQU   UCBAOF2
UCBRSV71 EQU   UCBAOF2
UCBRSV70 EQU   UCBAOF2
UCBRSV69 EQU   UCBAOF2
UCBRSV68 EQU   UCBAOF1
UCBRSV67 EQU   UCBAOF1
UCBRSV66 EQU   UCBAOF1
UCBRSV65 EQU   UCBAOF1
UCBRSV64 EQU   UCBAOF1
UCBOFNL  EQU   UCBAOF1
UCBOFSP  EQU   UCBAOF1
UCBOFMCR EQU   UCBAOF1
UCBBTB   EQU   UCBBTA+1
UCBDI    EQU   UCBBTA
UCBSNS   EQU   UCBOBS04+8
UCBTEB   EQU   UCBOBS04+4
UCBGCB   EQU   UCBOBS04+3
UCBOPEN  EQU   UCBOBS04+2
UCBSTART EQU   UCBOBS04
UCBXTNB  EQU   UCBXTN+1
UCBRSV22 EQU   UCBVOPT
UCBRSV21 EQU   UCBVOPT
UCBRSV20 EQU   UCBVOPT
UCBESVE  EQU   UCBVOPT
UCBERPC  EQU   UCBVOPT
UCBESVC  EQU   UCBVOPT
UCBEVA   EQU   UCBVOPT
UCBESV   EQU   UCBVOPT
UCBRV009 EQU   UCBTFL1
UCBRV008 EQU   UCBTFL1
UCBRV007 EQU   UCBTFL1
UCBRV006 EQU   UCBTFL1
UCBRV005 EQU   UCBTFL1
UCBDQDSP EQU   UCBTFL1
UCBNSLTP EQU   UCBTFL1
UCBNLTP  EQU   UCBTFL1
UCBRES1B EQU   UCBOBS02+18
UCBFSER  EQU   UCBOBS02+12
@NM00139 EQU   UCBOBS02+4
UCBFSEQ  EQU   UCBOBS02+2
UCBFSCT  EQU   UCBOBS02
UCBNEXP  EQU   UCBOBS01+20
UCBBASE  EQU   UCBOBS01+16
UCBRES1A EQU   UCBOBS01+15
UCBUSER  EQU   UCBOBS01+14
UCBFL47  EQU   UCBFL4
UCBMAT   EQU   UCBFL4
UCBHOLD  EQU   UCBFL4
UCBATTN  EQU   UCBFL4
UCBDSS   EQU   UCBFL4
UCBRESVP EQU   UCBFL4
UCBWDAV  EQU   UCBFL4
UCBDAVV  EQU   UCBFL4
UCBSQC   EQU   UCBOBS01+12
UCBDATP  EQU   UCBOBS01+12
UCBDMC   EQU   UCBDMCT
UCBBNUL  EQU   UCBSTAB
UCBSHAR  EQU   UCBSTAB
UCBBSTR  EQU   UCBSTAB
UCBBPUB  EQU   UCBSTAB
UCBBPRV  EQU   UCBSTAB
UCBBALB  EQU   UCBPRSRS
UCBDVSHR EQU   UCBBSVL
UCBVOLI  EQU   UCBOBS01+4
UCBVTOC  EQU   UCBOBS01
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
IOSPCIWA EQU   IOSPCISC+44
IOSPCIRS EQU   IOSPCISC+8
@NM00058 EQU   IOSPCISC+4
@NM00057 EQU   IOSPCISC
IOSWRNDR EQU   IOSWTOWA+4
IOSWTOPT EQU   IOSWTOWA+3
IOSWTOCP EQU   IOSWTOWA+2
IOSWTOCH EQU   IOSWTOWA
IOSATTWA EQU   IOSATTSC+40
@NM00056 EQU   IOSATTSC+24
IOSATTSN EQU   IOSATTSC
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTHSM   EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
COMPCODE EQU   ECB+1
TMSVN1   EQU   TMC2WRK+1
@NM00172 EQU   MSGBLK+12
@NM00171 EQU   MSGBLK+5
FRRFLG   EQU   FRRETYPE
FRRUCBLK EQU   FRRAREA+16
MIHRSV0  EQU   TMC1LOCL+9
@NM00170 EQU   MIHCOND
MIHBYT2  EQU   TMCEXITP+1
MIHBITS  EQU   MIHEFLG1
@NM00169 EQU   MIHLOCAL+1
@NM00168 EQU   MIHLSTAT
LCLLOCK  EQU   MIHLSTAT
SETDIEOK EQU   MIHLSTAT
TIMERR   EQU   MIHLSTAT
@NM00167 EQU   MIHTOD+4
@NM00166 EQU   MIHTIMSD+4
TMCKRETY EQU   MIHRCNT
@NM00165 EQU   DDRCOMWK
SVRBEND  EQU   RBSECT+192
RBFEPARM EQU   RBSECT+168
SIRBEND  EQU   RBSECT+168
RBRSV158 EQU   RBRSV150
RBRSV157 EQU   RBRSV150
RBRSV156 EQU   RBRSV150
RBRSV155 EQU   RBRSV150
RBRSV154 EQU   RBRSV150
RBRSV153 EQU   RBRSV150
RBRSV152 EQU   RBRSV150
RBRSV151 EQU   RBRSV150
RBRSV149 EQU   RBSECT+166
RBRSV148 EQU   RBSECT+164
RBRSV169 EQU   RBSDATA+3
RBSID    EQU   RBSDATA+2
RBSPKEY  EQU   RBSDATA+1
RBRSV168 EQU   RBSFLG3
RBSTERMO EQU   RBSFLG3
RBSBRNTR EQU   RBSFLG3
RBSPRNTR EQU   RBSFLG3
RBSCNCEL EQU   RBSFLG3
RBSRECRD EQU   RBSFLG3
RBSTERMI EQU   RBSFLG3
RBRSV167 EQU   RBSFLG3
RBSOWNRA EQU   RBSOWNR+1
RBSSUPER EQU   RBSFLGS2
RBSKEY0  EQU   RBSFLGS2
RBRSV166 EQU   RBSFLGS2
RBRSV165 EQU   RBSFLGS2
RBSINUSE EQU   RBSFLGS2
RBRSV164 EQU   RBSFLGS2
RBSXCTL2 EQU   RBSFLGS2
RBRSV163 EQU   RBSFLGS2
RBSPARMA EQU   RBSPARM+1
RBSHALT  EQU   RBSIOPRC
RBSNOIOP EQU   RBSIOPRC
RBSASYNC EQU   RBSFLGS1
RBRSV162 EQU   RBSFLGS1
RBSESTAE EQU   RBSFLGS1
RBSDUMMY EQU   RBSFLGS1
RBSSTAR  EQU   RBSFLGS1
RBSSTAI  EQU   RBSFLGS1
RBSEXIT  EQU   RBSCBB+4
RBSCHAIN EQU   RBSCBB
TIRBEND  EQU   @NM00161+8
PRBEND   EQU   @NM00161+8
RBRSV146 EQU   RBRSV138
RBRSV145 EQU   RBRSV138
RBRSV144 EQU   RBRSV138
RBRSV143 EQU   RBRSV138
RBRSV142 EQU   RBRSV138
RBRSV141 EQU   RBRSV138
RBRSV140 EQU   RBRSV138
RBRSV139 EQU   RBRSV138
RBRSV137 EQU   @NM00161+6
RBRSV136 EQU   @NM00161+4
RBRSV135 EQU   @NM00161
@NM00160 EQU   RBSECT+32
@NM00159 EQU   @NM00157+1
RBSCF    EQU   @NM00158
RBPGMQ1  EQU   RBPGMQ+1
@NM00156 EQU   RBPGMQ
@NM00155 EQU   RBSECT+16
@NM00154 EQU   @NM00150
@NM00153 EQU   @NM00150
RBIQETP  EQU   @NM00150
RBUSIQE  EQU   RBETXR
RBATTN   EQU   @NM00150
@NM00152 EQU   @NM00150
@NM00151 EQU   @NM00150
RBPMSVRB EQU   @NM00148
RBATNXIT EQU   @NM00148
@NM00149 EQU   @NM00148
RBWAITP  EQU   @NM00148
RBFNSVRB EQU   RBTRSVRB
RBFTP    EQU   @NM00148
RBSIZE   EQU   RBSECT+8
RBABOPSW EQU   RBSECT+4
RBPPSAV1 EQU   RBPPSAV+1
@NM00146 EQU   RBPPSAV
RBPRFXND EQU   RBPREFIX+64
RBINTCOD EQU   RBINTCDA+1
RBINLNTH EQU   RBINTCDA
RBWCSA   EQU   RBPREFIX+60
RBRSV004 EQU   RBPREFIX+57
RBSSSYN  EQU   RBFLAGS1
RBSCB    EQU   RBFLAGS1
RBLONGWT EQU   RBFLAGS1
RBASIR   EQU   RBFLAGS1
RBRSV159 EQU   RBFLAGS1
RBABEND  EQU   RBFLAGS1
RBXWAIT  EQU   RBFLAGS1
RBSLOCK  EQU   RBFLAGS1
RBRTRAN  EQU   RBRTPSW2+4
RBRTINCD EQU   RBRTICIL+2
RBRTILC  EQU   RBRTICIL+1
RBRSV160 EQU   RBRTICIL
RBRTPSW1 EQU   RBRTOPSW
RBRSV062 EQU   RBRSV054
RBRSV061 EQU   RBRSV054
RBRSV060 EQU   RBRSV054
RBRSV059 EQU   RBRSV054
RBRSV058 EQU   RBRSV054
RBRSV057 EQU   RBRSV054
RBRSV056 EQU   RBRSV054
RBRSV055 EQU   RBRSV054
RBRSV053 EQU   RBPREFIX+38
RBRSV052 EQU   RBPREFIX+36
RBRSV051 EQU   RBPREFIX+32
RBPRFXST EQU   RBPREFIX+32
RBRSV050 EQU   RBPREFIX+28
RBRSV049 EQU   RBRSV041
RBRSV048 EQU   RBRSV041
RBRSV047 EQU   RBRSV041
RBRSV046 EQU   RBRSV041
RBRSV045 EQU   RBRSV041
RBRSV044 EQU   RBRSV041
RBRSV043 EQU   RBRSV041
RBRSV042 EQU   RBRSV041
RBRSV040 EQU   RBPREFIX+26
RBRSV039 EQU   RBPREFIX+24
RBRSV038 EQU   RBPREFIX+20
RBRSV037 EQU   RBPREFIX+16
RBRSV036 EQU   RBRSV028
RBRSV035 EQU   RBRSV028
RBRSV034 EQU   RBRSV028
RBRSV033 EQU   RBRSV028
RBRSV032 EQU   RBRSV028
RBRSV031 EQU   RBRSV028
RBRSV030 EQU   RBRSV028
RBRSV029 EQU   RBRSV028
RBRSV027 EQU   RBRSV019
RBRSV026 EQU   RBRSV019
RBRSV025 EQU   RBRSV019
RBRSV024 EQU   RBRSV019
RBRSV023 EQU   RBRSV019
RBRSV022 EQU   RBRSV019
RBRSV021 EQU   RBRSV019
RBRSV020 EQU   RBRSV019
RBRSV018 EQU   RBPREFIX+13
RBRSV017 EQU   RBPREFIX+12
RBSRV016 EQU   RBPREFIX+11
RBRSV015 EQU   RBPREFIX+10
RBRSV014 EQU   RBPREFIX+8
RBRSV013 EQU   RBPREFIX+4
RBRSV012 EQU   RBPREFIX
@NM00145 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBCAUF  EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00144 EQU   TCB+296
TCBSVCA2 EQU   TCB+292
TCBSWASA EQU   TCB+288
TCBDBTB  EQU   TCB+284
TCBRPT   EQU   TCB+280
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBRV327 EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCB+274
TCBRV326 EQU   TCB+272
TCBUKYSP EQU   TCB+268
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBSTAFX EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCB+260
TCBTCBID EQU   TCB+256
TCBSTAWA EQU   TCB+252
TCBSWA   EQU   TCB+248
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBCCPVI EQU   TCBXSCT+2
TCBRV325 EQU   TCBXSCT+1
TCBRV324 EQU   TCBXSCT1
TCBRV323 EQU   TCBXSCT1
TCBRV322 EQU   TCBXSCT1
TCBRV321 EQU   TCBXSCT1
TCBRV320 EQU   TCBXSCT1
TCBRV319 EQU   TCBXSCT1
TCBS3A   EQU   TCBXSCT1
TCBACTIV EQU   TCBXSCT1
TCBRSV41 EQU   TCB+239
TCBTID   EQU   TCB+238
TCBRSVAA EQU   TCB+237
TCBABCUR EQU   TCB+236
TCBTMSAV EQU   TCB+232
TCBIOTIM EQU   TCB+228
TCBRTWA  EQU   TCB+224
TCBBACK  EQU   TCB+220
TCBTIRB  EQU   TCB+216
TCBAECB  EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBSVCS  EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBGPECB EQU   TCBFLGS7
TCBNTJS  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBCPU   EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBRSV95 EQU   TCBNDSP5
TCBRSV94 EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00143 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBNDINT EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBLJSND EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBSTCUR EQU   TCBNSTAE
TCBRV301 EQU   TCBNSTAE
TCBSYNCH EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBNSTAE
TCB33E   EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBAQE   EQU   TCB+156
TCBPQE   EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBJSTCA EQU   TCBJSTCB+1
TCBRSV16 EQU   TCBJSTCB
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBFSA
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBJPQ+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBDWSTA EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBADINP EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBFLGS2
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBNONPR EQU   TCBFLGS1
TCBFERA  EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBTIO   EQU   TCB+12
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00142 EQU   TCBPMASK
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
WSAGSCHE EQU   WSAG+40
WSAGREST EQU   WSAG+36
WSAGNQDQ EQU   WSAG+32
WSAGMEMT EQU   WSAG+28
WSAGOPTM EQU   WSAG+24
WSAGSTAT EQU   WSAG+20
WSAGEMS0 EQU   WSAG+16
WSAGSSRS EQU   WSAG+12
WSAGRSM  EQU   WSAG+8
WSAGPGIO EQU   WSAG
UCBERADR EQU   UCBUCS+12
UCBFCBID EQU   UCBUCS+8
UCBERCNT EQU   UCBUCS+7
UCBRSV51 EQU   UCBUCS+6
UCBFCBPE EQU   UCBFCBOP
UCBRSV49 EQU   UCBFCBOP
UCBRSV48 EQU   UCBFCBOP
UCBRSV47 EQU   UCBFCBOP
UCBRSV46 EQU   UCBFCBOP
UCBRSV45 EQU   UCBFCBOP
UCBRSV44 EQU   UCBFCBOP
UCBFCBO1 EQU   UCBFCBOP
UCBUCSPE EQU   UCBUCSOP
UCBRSV43 EQU   UCBUCSOP
UCBRSV42 EQU   UCBUCSOP
UCBRSV41 EQU   UCBUCSOP
UCBRSV40 EQU   UCBUCSOP
UCBRSV39 EQU   UCBUCSOP
UCBUCSO2 EQU   UCBUCSOP
UCBUCSO1 EQU   UCBUCSOP
UCBUCSID EQU   UCBUCS
UCBMDRBA EQU   UCBMDRBF+1
UCBRV075 EQU   UCBMDRBF
UCBRV074 EQU   UCB3800X+32
UCBIMAGE EQU   UCB3800X+28
UCBFCBNM EQU   UCB3800X+24
UCBCHAR4 EQU   UCB3800X+20
UCBCHAR3 EQU   UCB3800X+16
UCBCHAR2 EQU   UCB3800X+12
UCBCHAR1 EQU   UCB3800X+8
UCBCGMID EQU   UCB3800X+4
UCBBRSTA EQU   UCBACTIV
UCBRV063 EQU   UCBACTIV
UCBRV062 EQU   UCBACTIV
UCBRV061 EQU   UCBACTIV
UCBRV060 EQU   UCBACTIV
UCBRV059 EQU   UCBACTIV
UCBRV058 EQU   UCBACTIV
UCBRV057 EQU   UCBACTIV
UCBRV050 EQU   UCB3800X+2
UCBCGMNO EQU   UCB3800X+1
UCBRV083 EQU   UCBOPTNS
UCBBRSTR EQU   UCBOPTNS
UCBRV056 EQU   UCBOPTNS
UCBRV055 EQU   UCBOPTNS
UCBRV054 EQU   UCBOPTNS
UCBRV053 EQU   UCBOPTNS
UCBRV052 EQU   UCBOPTNS
UCBRV051 EQU   UCBOPTNS
UCBRV073 EQU   UCB3540X+7
UCBRV072 EQU   UCBDKBYT
UCBRV071 EQU   UCBDKBYT
UCBRV070 EQU   UCBDKBYT
UCBRV069 EQU   UCBDKBYT
UCBRV068 EQU   UCBDKBYT
UCBRV067 EQU   UCBDKBYT
UCBVLVER EQU   UCBDKBYT
UCBDKAMX EQU   UCBDKBYT
UCBVLSER EQU   UCB3540X
UCBRDATA EQU   UCBOCR+4
UCBFRID  EQU   UCBOCR
UCBCLN   EQU   UCBMT+14
UCBERG   EQU   UCBMT+12
UCBMS    EQU   UCBMT+11
UCBNB    EQU   UCBMT+10
UCBPW    EQU   UCBMT+9
UCBPR    EQU   UCBMT+8
UCBSIO   EQU   UCBMT+6
UCBTW    EQU   UCBMT+5
UCBTR    EQU   UCBMT+4
UCBTWT   EQU   UCBMT+3
UCBTRT   EQU   UCBMT+2
UCBCTD   EQU   UCBMT
UCBWTOID EQU   UCBCMEXT+17
UCBMFCNT EQU   UCBCMEXT+12
UCBPMSK  EQU   UCBCMEXT+10
UCBRV041 EQU   UCBCMEXT+6
UCBRV036 EQU   UCBFLP1
UCBRV035 EQU   UCBFLP1
UCBERLOG EQU   UCBFLP1
UCBRV033 EQU   UCBFLP1
UCBINHIO EQU   UCBFLP1
UCBNSWAP EQU   UCBFLP1
UCBSHRUP EQU   UCBFLP1
UCBNSRCH EQU   UCBFLP1
UCBSNSCT EQU   UCBCMEXT+4
UCBHPDV  EQU   @NM00141
UCBHALI  EQU   @NM00141
UCBRSV09 EQU   @NM00141
UCBRSV08 EQU   @NM00141
UCBRSV07 EQU   @NM00141
UCBRSV06 EQU   @NM00141
UCBRSV05 EQU   @NM00141
UCBRSV04 EQU   @NM00141
UCBDTI   EQU   UCBCMEXT+2
UCBSTI   EQU   UCBCMEXT+1
UCBETI   EQU   UCBCMEXT
UCBEXTP  EQU   UCBEXTPT+1
UCBIVRR  EQU   UCBFLC
UCBIVRS  EQU   UCBFLC
UCBITF   EQU   UCBFLC
UCBUDE   EQU   UCBFLC
UCBWAA   EQU   UCBFLC
UCBATTP  EQU   UCBFLC
UCBRSV11 EQU   UCBDVCLS
UCBRSV10 EQU   UCBDVCLS
UCB3CHAR EQU   UCBDVCLS
UCB3UREC EQU   UCBDVCLS
UCB3DISP EQU   UCBDVCLS
UCB3COMM EQU   UCBDVCLS
UCBDVPWR EQU   UCB2OPT7
UCBVLPWR EQU   UCB2OPT6
UCB2OPT5 EQU   UCBTBYT2
UCBRVDEV EQU   UCBRWTAU
UCBRPS   EQU   UCBDUDN2
UCBRR    EQU   UCBDUDN1
UCB2OPT1 EQU   UCBTBYT2
UCB2OPT0 EQU   UCBTBYT2
UCB1FEA7 EQU   UCBTBYT1
UCBD6250 EQU   UCB1FEA6
UCBD1600 EQU   UCB1FEA5
UCB1FEA4 EQU   UCBTBYT1
UCB1FEA3 EQU   UCBTBYT1
UCB1FEA2 EQU   UCBTBYT1
UCB1FEA1 EQU   UCBTBYT1
UCB1FEA0 EQU   UCBTBYT1
UCBNAME  EQU   UCBOB+13
UCBRV029 EQU   UCBWGT
UCBVHRSN EQU   UCBWGT
UCBVORSN EQU   UCBWGT
UCBREW   EQU   UCBWGT
UCBPUB   EQU   UCBWGT
UCBOUT   EQU   UCBWGT
UCBIN    EQU   UCBWGT
UCBLCI   EQU   UCBOB+10
UCBCNT   EQU   UCBOB+9
UCBRV017 EQU   UCBCHM1
UCBRV016 EQU   UCBCHM1
UCBRV015 EQU   UCBCHM1
UCBRV014 EQU   UCBCHM1
UCBSPB   EQU   UCBPTH1
UCBPPB   EQU   UCBPTH1
UCBSPA   EQU   UCBPTH0
UCBPPA   EQU   UCBPTH0
UCBSIGP  EQU   UCBFLB
UCBVALPH EQU   UCBFLB
UCBCRHSN EQU   UCBFLB
UCBCRHRV EQU   UCBFLB
UCBRESVH EQU   UCBFLB
UCBSPST  EQU   UCBFLB
UCBASNS  EQU   UCBFLB
UCBIORST EQU   UCBFLB
UCBQISCE EQU   UCBFL1
UCBSAP   EQU   UCBFL1
UCBNOTRC EQU   UCBCUB
UCBPSNS  EQU   UCBFL1
UCBUSING EQU   UCBPST
UCBNOTRD EQU   UCBNRY
UCBBUSYD EQU   UCBBSY
UCBUA    EQU   UCBCHAN+1
UCBCHA   EQU   UCBCHAN
UCBDADI  EQU   UCBSTAT
UCBPRES  EQU   UCBSTAT
UCBUNLD  EQU   UCBSTAT
UCBRESV  EQU   UCBSTAT
UCBCHGS  EQU   UCBSTAT
UCBID    EQU   UCBOB+2
UCBALTCU EQU   UCBFL5
UCBNALOC EQU   UCBFL5
UCBENVRD EQU   UCBFL5
UCBVSDR  EQU   UCBFL5
UCBSASK  EQU   UCBFL5
UCBAMV   EQU   UCBAF
UCBDCC   EQU   UCBFL5
UCBMONT  EQU   UCBJBNR
UCBRV011 EQU   UCBJBNR
UCBOLDSM EQU   UCBJBNR
UCBRV003 EQU   UCBJBNR
UCBDUC   EQU   UCBJBNR
UCBJES3  EQU   UCBJBNR
UCBVRDEV EQU   UCBJBNR
UCBCMSEG EQU   UCBOB
UCBPFXND EQU   UCB+512
UCBLOCK  EQU   UCB+504
UCBPXST  EQU   UCB+504
@NM00138 EQU   UCB
TQESTCKR EQU   TQESTCK+4
TQESTCKL EQU   TQESTCK
TQERSAVE EQU   TQE+116
@NM00137 EQU   TQE+89
@NM00136 EQU   TQEFLGS3
TQEDIE   EQU   TQEFLGS3
TQEDREGS EQU   TQESRB
TQELHPSW EQU   TQE+40
TQEASCB  EQU   TQE+36
TQETCB   EQU   TQE+32
TQESADDR EQU   TQE+24
TQEVALRH EQU   TQEVAL+4
TQEMIDN  EQU   TQEFLGS2
TQEMF1   EQU   TQEFLGS2
TQEOPT   EQU   TQEFLGS2
TQELM    EQU   TQEFLGS2
TQEDUM   EQU   TQEFLGS2
TQECRH   EQU   TQEFLGS2
TQEUSER  EQU   TQEFLGS2
TQECOMP  EQU   TQEFLGS2
TQETYPE  EQU   TQEFLGS
TQEXITSP EQU   TQEFLGS
TQEINCOM EQU   TQEFLGS
TQEWLIM  EQU   TQEFLGS
@NM00135 EQU   TQEFLGS
TQETOD   EQU   TQEFLGS
TQEOFF   EQU   TQEFLGS
TQEAID   EQU   TQE+12
TQEBLNK  EQU   TQE+8
TQEFLNK  EQU   TQE+4
TQETQE   EQU   TQE
@NM00134 EQU   SRB+40
@NM00133 EQU   SRB+38
SRBPRIOR EQU   SRB+37
SRBPKF   EQU   SRB+36
SRBSAVE  EQU   SRB+32
SRBRMTR  EQU   SRB+24
SRBPASID EQU   SRBFLC+2
@NM00132 EQU   SDWA+512
SDWAVRA  EQU   SDWARA+4
SDWAURAL EQU   SDWARA+3
@NM00131 EQU   SDWADPVA
SDWAEBC  EQU   SDWADPVA
SDWAHEX  EQU   SDWADPVA
SDWAVRAL EQU   SDWARA
@NM00130 EQU   SDWA+396
SDWACOMP EQU   SDWA+392
SDWARCPL EQU   SDWA+364
@NM00129 EQU   SDWADPSA+32
SDWATO4  EQU   SDWADPSL+28
SDWAFRM4 EQU   SDWADPSL+24
SDWATO3  EQU   SDWADPSL+20
SDWAFRM3 EQU   SDWADPSL+16
SDWATO2  EQU   SDWADPSL+12
SDWAFRM2 EQU   SDWADPSL+8
SDWATO1  EQU   SDWADPSL+4
SDWAFRM1 EQU   SDWADPSL
@NM00128 EQU   SDWADDAT+3
@NM00127 EQU   SDWAPDAT
SDWAUSPL EQU   SDWAPDAT
SDWADPSW EQU   SDWAPDAT
SDWATJPA EQU   SDWAPDAT
SDWATLPA EQU   SDWAPDAT
SDWADREG EQU   SDWAPDAT
SDWADSAH EQU   SDWAPDAT
SDWADSAS EQU   SDWAPDAT
@NM00126 EQU   SDWADDAT+1
@NM00125 EQU   SDWASDAT
SDWAQQS  EQU   SDWASDAT
SDWACBS  EQU   SDWASDAT
SDWAGTF  EQU   SDWASDAT
SDWASWA  EQU   SDWASDAT
SDWALSQA EQU   SDWASDAT
SDWASQA  EQU   SDWASDAT
SDWANUC  EQU   SDWASDAT
@NM00124 EQU   SDWADUMP+2
@NM00123 EQU   SDWADPFS
SDWASLST EQU   SDWADPFS
@NM00122 EQU   SDWADPFS
SDWADLST EQU   SDWADPFS
SDWADPT  EQU   SDWADPFS
SDWADPID EQU   SDWADUMP
SDWADPLA EQU   SDWA+316
@NM00121 EQU   SDWA+290
SDWAASID EQU   SDWA+288
SDWATALW EQU   SDWALKWS+28
SDWATDLW EQU   SDWALKWS+24
SDWATNLW EQU   SDWALKWS+20
SDWAAPLW EQU   SDWALKWS+16
SDWAIPLW EQU   SDWALKWS+12
SDWAILLW EQU   SDWALKWS+8
SDWAIULW EQU   SDWALKWS+4
SDWAICLW EQU   SDWALKWS
SDWAFLLK EQU   SDWAACF4
SDWACMS  EQU   SDWAACF4
SDWAOPTM EQU   SDWAACF4
SDWATADB EQU   SDWAACF4
SDWATDNB EQU   SDWAACF4
SDWATNCB EQU   SDWAACF4
SDWAILCH EQU   SDWAACF4
SDWAIUCB EQU   SDWAACF4
SDWAICAT EQU   SDWAACF3
SDWAIPRG EQU   SDWAACF3
SDWASALL EQU   SDWAACF3
SDWAASMP EQU   SDWAACF3
SDWADISP EQU   SDWAACF3
@NM00120 EQU   SDWAACF3
@NM00119 EQU   SDWAACF2
SDWAFREE EQU   SDWAACF2
@NM00118 EQU   SDWAACF2
SDWASPIN EQU   SDWAACF2
@NM00117 EQU   SDWAACF2
SDWALCPU EQU   SDWACPUA+2
@NM00116 EQU   SDWACPUA
SDWARECA EQU   SDWA+244
@NM00115 EQU   SDWA+239
@NM00114 EQU   SDWAIOFS
SDWANIOP EQU   SDWAIOFS
SDWANOIO EQU   SDWAIOFS
SDWAIOHT EQU   SDWAIOFS
SDWAIOQR EQU   SDWAIOFS
SDWAFMID EQU   SDWA+236
@NM00113 EQU   SDWAERRD
SDWAMCIV EQU   SDWAERRD
SDWARPIV EQU   SDWAERRD
SDWAMABD EQU   SDWAERRD
SDWACTS  EQU   SDWAERRD
SDWASTAE EQU   SDWAERRD
SDWANRBE EQU   SDWAERRD
SDWACLUP EQU   SDWAERRD
@NM00112 EQU   SDWAERRC
SDWAEAS  EQU   SDWAERRC
SDWAPERC EQU   SDWAERRC
SDWAIRB  EQU   SDWAERRC
SDWASTAI EQU   SDWAERRC
SDWASTAF EQU   SDWAERRC
SDWASRBM EQU   SDWAERRB
SDWALDIS EQU   SDWAERRB
SDWAENRB EQU   SDWAERRB
SDWATYP1 EQU   SDWAERRB
@NM00111 EQU   SDWAERRB
SDWAPGIO EQU   SDWAERRA
SDWATEXC EQU   SDWAERRA
SDWASVCE EQU   SDWAERRA
SDWAABTM EQU   SDWAERRA
SDWASVCD EQU   SDWAERRA
SDWARKEY EQU   SDWAERRA
SDWAPCHK EQU   SDWAERRA
SDWAMCHK EQU   SDWAERRA
SDWATIME EQU   SDWAMCH+20
SDWARFSA EQU   SDWAMCH+16
@NM00110 EQU   SDWAMCH+14
SDWAVEQR EQU   SDWARSR2
SDWAPGFX EQU   SDWARSR2
SDWAFLSQ EQU   SDWARSR2
SDWAFSQA EQU   SDWARSR2
SDWANUCL EQU   SDWARSR2
SDWASPER EQU   SDWARSR2
SDWAINTC EQU   SDWARSR2
SDWAOFLN EQU   SDWARSR2
SDWACHNG EQU   SDWARSR1
SDWAMSER EQU   SDWARSR1
@NM00109 EQU   SDWARSR1
SDWACPID EQU   SDWAMCH+10
SDWATERR EQU   SDWAMCHD
SDWAFPRX EQU   SDWAMCHD
SDWAINSF EQU   SDWAMCHD
SDWAACR  EQU   SDWAMCHD
SDWASCK  EQU   SDWAMCHD
SDWAPSWU EQU   SDWAMCHD
SDWAREGU EQU   SDWAMCHD
SDWASKYF EQU   SDWAMCHD
@NM00108 EQU   SDWAMCHS
SDWARSRF EQU   SDWAMCHS
SDWARSRC EQU   SDWAMCHS
SDWAINVP EQU   SDWAMCHS
SDWATSVL EQU   SDWAMCHS
SDWARCDF EQU   SDWAMCHS
SDWASRVL EQU   SDWAMCHS
SDWASCKE EQU   SDWASTCK+4
SDWASCKB EQU   SDWASTCK
SDWALNTH EQU   SDWAIDNT+1
SDWASPID EQU   SDWAIDNT
SDWASR15 EQU   SDWASRSV+60
SDWASR14 EQU   SDWASRSV+56
SDWASR13 EQU   SDWASRSV+52
SDWASR12 EQU   SDWASRSV+48
SDWASR11 EQU   SDWASRSV+44
SDWASR10 EQU   SDWASRSV+40
SDWASR09 EQU   SDWASRSV+36
SDWASR08 EQU   SDWASRSV+32
SDWASR07 EQU   SDWASRSV+28
SDWASR06 EQU   SDWASRSV+24
SDWASR05 EQU   SDWASRSV+20
SDWASR04 EQU   SDWASRSV+16
SDWASR03 EQU   SDWASRSV+12
SDWASR02 EQU   SDWASRSV+8
SDWASR01 EQU   SDWASRSV+4
SDWASR00 EQU   SDWASRSV
SDWATRN2 EQU   SDWAAEC2+4
SDWAIPC2 EQU   SDWAICD2
SDWAIMC2 EQU   SDWAICD2
SDWAIPR2 EQU   SDWAICD2
@NM00107 EQU   SDWAINC2
@NM00106 EQU   SDWAILC2
SDWAIL2  EQU   SDWAILC2
@NM00105 EQU   SDWAILC2
@NM00104 EQU   SDWAAEC2
SDWAADD2 EQU   SDWANXT2+1
@NM00103 EQU   SDWANXT2
@NM00102 EQU   SDWAEC2+3
SDWASGN2 EQU   SDWAINT2
SDWAEXP2 EQU   SDWAINT2
SDWADEC2 EQU   SDWAINT2
SDWAFPO2 EQU   SDWAINT2
SDWACC2  EQU   SDWAINT2
@NM00101 EQU   SDWAINT2
SDWAPGM2 EQU   SDWAMWP2
SDWAWAT2 EQU   SDWAMWP2
SDWAMCK2 EQU   SDWAMWP2
SDWAECT2 EQU   SDWAMWP2
SDWAKEY2 EQU   SDWAMWP2
SDWAEXT2 EQU   SDWAEMK2
SDWAIO2  EQU   SDWAEMK2
SDWATRM2 EQU   SDWAEMK2
@NM00100 EQU   SDWAEMK2
SDWAPER2 EQU   SDWAEMK2
@NM00099 EQU   SDWAEMK2
SDWATRAN EQU   SDWAAEC1+4
SDWAIPC1 EQU   SDWAICD1
SDWAIMC1 EQU   SDWAICD1
SDWAIPR1 EQU   SDWAICD1
@NM00098 EQU   SDWAINC1
@NM00097 EQU   SDWAILC1
SDWAIL1  EQU   SDWAILC1
@NM00096 EQU   SDWAILC1
@NM00095 EQU   SDWAAEC1
SDWAADD1 EQU   SDWANXT1+1
@NM00094 EQU   SDWANXT1
@NM00093 EQU   SDWAEC1+3
SDWASGN1 EQU   SDWAINT1
SDWAEXP1 EQU   SDWAINT1
SDWADEC1 EQU   SDWAINT1
SDWAFPO1 EQU   SDWAINT1
SDWACC1  EQU   SDWAINT1
@NM00092 EQU   SDWAINT1
SDWAPGM1 EQU   SDWAMWP1
SDWAWAT1 EQU   SDWAMWP1
SDWAMCK1 EQU   SDWAMWP1
SDWAECT1 EQU   SDWAMWP1
SDWAKEY1 EQU   SDWAMWP1
SDWAEXT1 EQU   SDWAEMK1
SDWAIO1  EQU   SDWAEMK1
SDWATRM1 EQU   SDWAEMK1
@NM00091 EQU   SDWAEMK1
SDWAPER1 EQU   SDWAEMK1
@NM00090 EQU   SDWAEMK1
SDWAIOBR EQU   SDWA+100
SDWAEPA  EQU   SDWA+96
@NM00089 EQU   SDWANAME+4
SDWARBAD EQU   SDWANAME
SDWAGR15 EQU   SDWAGRSV+60
SDWAGR14 EQU   SDWAGRSV+56
SDWAGR13 EQU   SDWAGRSV+52
SDWAGR12 EQU   SDWAGRSV+48
SDWAGR11 EQU   SDWAGRSV+44
SDWAGR10 EQU   SDWAGRSV+40
SDWAGR09 EQU   SDWAGRSV+36
SDWAGR08 EQU   SDWAGRSV+32
SDWAGR07 EQU   SDWAGRSV+28
SDWAGR06 EQU   SDWAGRSV+24
SDWAGR05 EQU   SDWAGRSV+20
SDWAGR04 EQU   SDWAGRSV+16
SDWAGR03 EQU   SDWAGRSV+12
SDWAGR02 EQU   SDWAGRSV+8
SDWAGR01 EQU   SDWAGRSV+4
SDWAGR00 EQU   SDWAGRSV
SDWANXTP EQU   SDWACTL2+5
SDWASGP  EQU   SDWAPMKP
SDWAEUP  EQU   SDWAPMKP
SDWADOP  EQU   SDWAPMKP
SDWAFPP  EQU   SDWAPMKP
SDWACCP  EQU   SDWAPMKP
SDWAILP  EQU   SDWAPMKP
SDWAINTP EQU   SDWACTL2+2
SDWASPVP EQU   SDWAMWPP
SDWAWATP EQU   SDWAMWPP
SDWAMCKP EQU   SDWAMWPP
@NM00088 EQU   SDWAMWPP
SDWAKEYP EQU   SDWAMWPP
SDWAEXTP EQU   SDWACMKP
SDWAIOP  EQU   SDWACMKP
SDWANXTA EQU   SDWACTL1+5
SDWASGA  EQU   SDWAPMKA
SDWAEUA  EQU   SDWAPMKA
SDWADOA  EQU   SDWAPMKA
SDWAFPA  EQU   SDWAPMKA
SDWACCA  EQU   SDWAPMKA
SDWAILA  EQU   SDWAPMKA
SDWAINTA EQU   SDWACTL1+2
SDWASPVA EQU   SDWAMWPA
SDWAWATA EQU   SDWAMWPA
SDWAMCKA EQU   SDWAMWPA
@NM00087 EQU   SDWAMWPA
SDWAKEYA EQU   SDWAMWPA
SDWAEXTA EQU   SDWACMKA
SDWAIOA  EQU   SDWACMKA
SDWACMPC EQU   SDWAABCC+1
@NM00086 EQU   SDWACMPF
SDWASTCC EQU   SDWACMPF
@NM00085 EQU   SDWACMPF
SDWASTEP EQU   SDWACMPF
SDWAREQ  EQU   SDWACMPF
@NM00060 EQU   FRRSFLGS+1
@NM00059 EQU   FRRSFLG1
FRRSNEST EQU   FRRSFLG1
FRRSRCUR EQU   FRRSFLG1
FRRSENTS EQU   FRRS+84
FRRSRTMW EQU   FRRS+16
IOSEND   EQU   IOSB+108
IOSSKR   EQU   IOSEEKA+7
IOSSKH2  EQU   IOSSKHH+1
IOSSKH1  EQU   IOSSKHH
IOSSKCC  EQU   IOSCCHH
IOSSKBB  EQU   IOSEEKA+1
IOSSKM   EQU   IOSEEKA
IOSEEK   EQU   IOSB+92
IOSMDM   EQU   IOSB+91
IOSMDB   EQU   IOSB+90
IOSCKEY7 EQU   IOSCKEY
IOSCKEY6 EQU   IOSCKEY
IOSCKEY5 EQU   IOSCKEY
IOSCKEY4 EQU   IOSCKEY
@NM00055 EQU   IOSCKEY
IOSFMSK  EQU   IOSB+88
IOSCUDEV EQU   IOSPATH+1
@NM00054 EQU   IOSCHN
IOSPATH3 EQU   IOSCHN
IOSPATH2 EQU   IOSCHN
IOSEXP   EQU   IOSCHN
IOSGDP   EQU   IOSCHN
IOSAFF   EQU   IOSB+85
IOSRSS1B EQU   IOSB+84
IOSDSID  EQU   IOSB+80
IOSVST   EQU   IOSB+76
IOSRST   EQU   IOSB+72
IOSDIE   EQU   IOSB+68
IOSABN   EQU   IOSB+64
IOSNRM   EQU   IOSB+60
IOSPCI   EQU   IOSB+56
IOSERP   EQU   IOSB+52
IOSPCHN  EQU   IOSB+48
IOSSNS   EQU   IOSB+42
IOSAPMSK EQU   IOSB+40
IOSRES4A EQU   IOSB+36
IOSUSE   EQU   IOSB+32
IOSSRB   EQU   IOSB+28
IOSCSWRC EQU   IOSCSW+5
IOSTSB   EQU   IOSTATUS+1
IOSTSA   EQU   IOSTATUS
IOSCSWCA EQU   IOSCSW
IOSCC    EQU   @NM00053
IOSUCB   EQU   IOSB+16
IOSOPT2X EQU   IOSOPT2
IOSIGP   EQU   IOSOPT2
IOSHTP   EQU   IOSOPT2
IOSRELSE EQU   IOSOPT
IOSAPR   EQU   IOSOPT
IOSTSLL  EQU   IOSOPT
IOSNERP  EQU   IOSOPT
IOSPSLL  EQU   IOSOPT
IOSQISCE EQU   IOSOPT
IOSDEP   EQU   IOSOPT
IOSBYP   EQU   IOSOPT
IOSCOD   EQU   IOSB+13
IOSPKY7  EQU   IOSPKEY
IOSPGDPX EQU   IOSPKEY
IOSIDR   EQU   IOSPKEY
IOSLCL   EQU   IOSPKEY
@NM00052 EQU   IOSPKEY
IOSPGAD  EQU   IOSB+8
IOSPRLVL EQU   IOSB+5
IOSPROC  EQU   IOSB+3
IOSFLC7  EQU   IOSFLC
IOSCTCNR EQU   IOSFLC
IOSRWAIT EQU   IOSFLC
IOSTP    EQU   IOSFLC
IOSCC3WE EQU   IOSFLC
IOSVERIF EQU   IOSDVALT
IOSDVMNT EQU   IOSFLC
IOSLOG   EQU   IOSFLB
IOSBDCST EQU   IOSFLB
IOSMSG   EQU   IOSFLB
IOSFLB4  EQU   IOSFLB
IOSFLB3  EQU   IOSFLB
IOSNOTRS EQU   IOSFLB
IOSSDR   EQU   IOSFLB
IOSDIESE EQU   IOSFLB
IOSIOSB  EQU   IOSFLA
IOSDOM   EQU   IOSFLA
IOSEX    EQU   IOSFLA
IOSSMDB  EQU   IOSFLA
IOSSMDA  EQU   IOSFLA
IOSERR   EQU   IOSFLA
IOSCCHN  EQU   IOSACHN
IOSDCHN  EQU   IOSACHN
IOQEND   EQU   IOQ+12
IOQPTH   EQU   IOQFLAGS+3
IOQPRI   EQU   IOQFLAGS+2
IOQHOLD  EQU   IOQFLB
IOQALOC  EQU   IOQFLB
IOQRLSE  EQU   IOQFLB
IOQRESV  EQU   IOQFLB
@NM00051 EQU   IOQFLA
IOQPBSY  EQU   IOQFLA
IOQLBSY  EQU   IOQFLA
IOQENQ   EQU   IOQFLA
IOQSLCH  EQU   IOQFLA
IOQLNK   EQU   IOQ
IOCOEND  EQU   IOCOM+128
IOCPATCH EQU   IOCOM+124
IOCUCBBM EQU   IOCOM+120
IOCQCNT  EQU   IOCOM+116
IOCIOSDQ EQU   IOCOM+112
IOCIOSEQ EQU   IOCOM+108
IOCSVCF  EQU   IOCOM+104
IOCTCCW  EQU   IOCOM+100
IOCRSVTB EQU   IOCOM+96
IOCMFCNT EQU   IOCOM+92
IOCMFHK  EQU   IOCOM+88
IOCCCH   EQU   IOCOM+80
IOCASYNQ EQU   IOCOM+76
IOCLCHTB EQU   IOCOM+72
IOCATTBL EQU   IOCOM+68
IOCOMEX  EQU   IOCOM+64
IOCSYNCH EQU   IOCOM+56
IOCCATLK EQU   IOCOM+48
IOCPRGID EQU   IOCOM+44
IOCIOSCP EQU   IOCOM+40
IOCORMGT EQU   IOCOM+36
IOCVOID  EQU   IOCOM+32
IOCSTIO  EQU   IOCOM+28
IOCSCOMP EQU   IOCOM+24
IOCHD160 EQU   IOCOM+20
IOCINT   EQU   IOCOM+16
IOCCTBL  EQU   IOCOM+12
IOCHIO   EQU   IOCOM+8
IOCPST   EQU   IOCOM+4
IOCPGCT  EQU   IOCOM+2
IOCVOICT EQU   IOCOM
DDRSSOB  EQU   DDRLONG+76
DDRUBCNT EQU   DDRLONG+72
@NM00050 EQU   DDRUSER+1
DDRUMODE EQU   DDRUSER
@NM00049 EQU   DDRREC2
DDRRFMTO EQU   DDRREC2
DDRREC1  EQU   DDRREC
DDRRETRY EQU   DDRLONG+65
DDRLNOP  EQU   DDRLABEL
@NM00048 EQU   DDRLABEL
DDRLSD   EQU   DDRLABEL
DDRLNSL  EQU   DDRLABEL
DDRLNL   EQU   DDRLABEL
DDRLBLP  EQU   DDRLABEL
DDRLAL   EQU   DDRLABEL
DDRMSGPC EQU   DDRMSGP+1
DDRMSGPN EQU   DDRMSGP
DDRMSGCD EQU   DDRMSG+1
DDRMSGOP EQU   DDRMSG
@NM00047 EQU   DDRIOF2
DDRICNT  EQU   DDRIOF2
DDRIMNT  EQU   DDRIOF2
DDRILAB  EQU   DDRIOF2
DDRITAKE EQU   DDRIOF2
DDRWHICH EQU   DDRIOF2
DDRIOF1  EQU   DDRIOF
DDRCOUNT EQU   DDRLONG+48
DDRIBUF  EQU   DDRLONG+44
DDRIBUFL EQU   DDRLONG+42
DDRAPP2  EQU   DDRAPP+1
DDRAPP1  EQU   DDRAPP
DDRINV2  EQU   DDRINV+1
DDRINV1  EQU   DDRINV
DDRTER2  EQU   DDRTER+1
DDRTER1  EQU   DDRTER
DDRTEST  EQU   DDRLONG+32
DDRUASCB EQU   DDRLONG+28
DDRUTCB  EQU   DDRLONG+24
DDRUIOB  EQU   DDRLONG+20
DDRUDEB  EQU   DDRMIHT+4
DDRUDCB  EQU   DDRMIHT
DDRASID  EQU   DDRLONG+10
DDRMIH   EQU   DDRLONG+9
DDRFIRST EQU   DDRROWN
DDRJES3L EQU   DDRROWN
@NM00046 EQU   DDRROWN
DDRRDENQ EQU   DDRROWN
DDRRUENQ EQU   DDRROWN
DDRRTENQ EQU   DDRROWN
DDRFMUCB EQU   DDRLONG+4
DDRTOUCB EQU   DDRLONG
DDRTOCUA EQU   DDRSHORT+21
DDRFMCUA EQU   DDRSHORT+18
DDRUASID EQU   DDRSHORT+16
DDRUIOSB EQU   DDRSHORT+12
@NM00045 EQU   DDRDSTAT
DDRUR    EQU   DDRDSTAT
DDRMT    EQU   DDRDSTAT
DDRDA    EQU   DDRDSTAT
DDRBUFL  EQU   DDRDSTAT
DDRMDR   EQU   DDRDCHAR
@NM00044 EQU   DDRSTAT
DDRSIRB  EQU   DDRSTAT
DDRPRG   EQU   DDRSTAT
DDRRMV   EQU   DDRSTAT
DDRHAMA  EQU   DDRSTAT
DDRQUE   EQU   DDRSTAT
DDRACTV  EQU   DDRSTAT
@NM00043 EQU   DDRSRC
DDRPAGE  EQU   DDRSRC
DDRSYS   EQU   DDRSRC
DDROPER  EQU   DDRSRC
DDRNXT   EQU   DDRSHORT+4
DDRID    EQU   DDRSHORT
MSSPARE  EQU   BASES01+48
MSUCBAL  EQU   BASES01+44
MSUCBPR  EQU   BASES01+40
MSBOBECB EQU   BASES01+36
MSSJQ    EQU   BASES01+32
MSECB    EQU   BASES01+28
MSPBP    EQU   BASES01+24
MSERM    EQU   BASES01+22
MSPASS   EQU   BASES01+14
MSVRB    EQU   BASES01+6
MSQHR    EQU   MSFHF
@NM00042 EQU   MSFHF
MSPSDT   EQU   MSFHF
MSREPLYB EQU   MSFHF
MSFAX    EQU   MSFHF
MSTTT    EQU   MSFHF
MSCSD    EQU   MSFHF
MSNMF    EQU   MSFHF
MSJNF    EQU   MSSSA
MSYOUT   EQU   MSNWP
MSNRP    EQU   MSSSA
MSSRDR   EQU   MSREOF
MSWRLOG  EQU   MSSSA
MSNUPSW  EQU   MSSSA
MSWRPEN  EQU   MSSSA
MSSSSIPL EQU   MSINLSW
MSSUM    EQU   MSECBFL
MSMCR    EQU   MSECBFL
MSYSOUT  EQU   MSECBFL
MSYSIN   EQU   MSECBFL
MSATTN   EQU   MSECBFL
MSWTL    EQU   MSECBFL
MSWTO    EQU   MSECBFL
MSEXT    EQU   MSECBFL
MSCCS    EQU   MSPFG
MSBSP    EQU   MSPFG
MSSYT    EQU   MSPFG
MSSYN    EQU   MSPFG
MSICR    EQU   MSPFG
MSCMC    EQU   MSPFG
MSPNB    EQU   MSPFG
MSDATE   EQU   MSPFG
@NM00041 EQU   MSBTN
MSTN     EQU   MSBTN
@NM00040 EQU   MSBTN
@NM00039 EQU   MSBTN
MSSO     EQU   MSBTN
MSROLFLG EQU   MSBTN
MSCANFLG EQU   MSBTN
MSCONFLG EQU   MSBTN
MSPNIP   EQU   MSNTAL
MSQNIP   EQU   MSNTAL
MSCURE34 EQU   MSNTAL
@NM00038 EQU   MSNTAL
@NM00037 EQU   MSNTAL
@NM00036 EQU   MSNTAL
@NM00035 EQU   MSNTAL
MSNIP    EQU   MSNTAL
@NM00034 EQU   MS1BASEX+40
@NM00033 EQU   MS1BASEX+20
@NM00032 EQU   MS1BASEX
@NM00031 EQU   BASE+128
MSLGJSCB EQU   BASE+124
@NM00030 EQU   MSSTRTSW
MSSTRTP  EQU   MSSTRTSW
MSSTRTW  EQU   MSSTRTSW
@NM00029 EQU   MSWTRSW
MSWTRP   EQU   MSWTRSW
MSWTRW   EQU   MSWTRSW
@NM00028 EQU   MSWLOGSW
MSWLOGP  EQU   MSWLOGSW
MSWLOGW  EQU   MSWLOGSW
@NM00027 EQU   MSCLOSSW
MSCLOSP  EQU   MSCLOSSW
MSCLOSW  EQU   MSCLOSSW
MSLOGLMT EQU   @NM00026+1
MSLOGCLS EQU   @NM00026
BAASCB   EQU   BASE+100
MSSMFPRM EQU   BASE+96
MSCOMMND EQU   BASE+92
BASP12   EQU   BASE+90
BASTCNT  EQU   BASE+88
BASESCT  EQU   BASE+86
BAJNCNT  EQU   BASE+84
BASUBECB EQU   BASE+80
BALOGCOM EQU   BASE+76
BADACNT  EQU   BASE+74
BATACNT  EQU   BASE+72
BAJBNR   EQU   BASE+64
BASP11   EQU   BASE+62
BALCCNT  EQU   BASE+61
BADUMPID EQU   BASE+60
BABCMAX  EQU   BASE+58
BAMONTR2 EQU   BASE+57
@NM00025 EQU   BAMONITR
BAMACTVE EQU   BAMONITR
@NM00024 EQU   BAMONITR
@NM00023 EQU   BAMONITR
@NM00022 EQU   BAMONITR
@NM00021 EQU   BAMONITR
BASPACE  EQU   BAMONITR
BADSN    EQU   BAMONITR
BADSO    EQU   BASE+52
BALOGECB EQU   BASE+48
@NM00020 EQU   BASPBYTE
@NM00019 EQU   BASPBYTE
@NM00018 EQU   BASPBYTE
@NM00017 EQU   BASPBYTE
@NM00016 EQU   BASPBYTE
BAMASCH  EQU   BASPBYTE
BATRACE  EQU   BASPBYTE
BAMSSTAR EQU   BASPBYTE
@NM00015 EQU   MSLOGST
@NM00014 EQU   MSLOGST
MSLOGSTA EQU   MSLOGST
MSLOGIPL EQU   MSLOGST
MSLOGDAR EQU   MSLOGST
MSLOGCOM EQU   MSLOGST
MSLOGTHD EQU   MSLOGST
MSLOGENQ EQU   MSLOGST
BAMIPAR2 EQU   BASE+44
BAMINPAR EQU   BASE+42
BAPKES   EQU   BASE+40
BAICTR   EQU   BASE+38
@NM00013 EQU   BASE+37
BADSET   EQU   BARSW
BANOSET  EQU   BARSW
BAMIDNT  EQU   BARSW
BAHR     EQU   BARSW
BAVU     EQU   BARSW
BAINTSET EQU   BARSW
MSTODWTO EQU   BARSW
BAIN     EQU   BARSW
BACV     EQU   BASE+32
@NM00012 EQU   BALOG
@NM00011 EQU   BALOG
@NM00010 EQU   BALOG
@NM00009 EQU   BALOG
@NM00008 EQU   BALOG
@NM00007 EQU   BALOG
@NM00006 EQU   BALOG
BALOGINT EQU   BALOG
MSLOGSVC EQU   BALGSTAT
BAPRC    EQU   BASE+20
BAQ      EQU   BASE+16
BAIPLCC  EQU   @NM00004+2
@NM00005 EQU   @NM00004
BAIPL    EQU   BASE+12
BALAD    EQU   BASE+8
BATRM    EQU   BASE+4
BACHN    EQU   BASE
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00003 EQU   CVTFIX+248
@NM00002 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTCCVT  EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
ASVTEND  EQU   ASVT+528
ASVTAVAL EQU   ASVTENTY
ASVTAVAI EQU   ASVTFRST
ASVTRS00 EQU   ASVT+520
ASVTMAXU EQU   ASVT+516
ASVTASVT EQU   ASVT+512
ASVTBEGN EQU   ASVT+512
@NM00001 EQU   ASVT
@NM00084 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00083 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00082 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00081 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSAULCMS EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00080 EQU   FLCFSA
@NM00079 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00078 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00077 EQU   FLCIOA
@NM00076 EQU   FLCMCLA+15
@NM00075 EQU   FLCMCLA+14
@NM00074 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00073 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00072 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00071 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00070 EQU   FLCPER
@NM00069 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00068 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00067 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00066 EQU   FLCPIILC
@NM00065 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00064 EQU   FLCSVILC
@NM00063 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00062 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00061 EQU   FLCICCW2+4
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RT00315 EQU   NEXTUCB
@RT00322 EQU   NEXTUCB
@RT00354 EQU   NEXTUCB
@RT00358 EQU   NEXTUCB
@RC00508 EQU   @RC00506
@RC00518 EQU   @RC00506
@RC00510 EQU   @RC00508
@ENDDATA EQU   *
         END   IGFTMC00,(C'PLS2115',0701,78073)
