         TITLE 'IGG0CLBB, UPDATE EXTEND                                *
                        '
IGG0CLBB CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'IGG0CLBB  77.041'                                 0001
         DROP  @15
@PROLOG  DS    0H                                                  0002
         USING @MAINENT,@15
         USING @DATD-(CCATEMPS-IGGCCA),R11
         DS 0F
         DC CL8'IGGPUPDE'
         EJECT
         B     @PB00002                                            0143
IGGPUPDE DS    0H                                                  0144
         ENTRY IGGPUPDE
         DROP @15
Z003     DS    0H                                                  0146
Z003UPDE DS    0H                                                  0147
         STM 12,14,12(13)
         LA 13,12(13)
         BALR 12,0
IGGSEGST DS 0H
*                                      PROCEDURE                     */
         USING *,12
*/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
**   MODULE NAME =  IGGPUPDE (IGG0CLBB)                               *
**                                                                    *
**   DESCRIPTIVE NAME =  UPDATE EXTEND                                *
**                                                                    *
**   FUNCTION =                                                       *
**      THIS SUB-FUNCTION BRINGS TOGETHER LOWER LEVEL SUB-FUNCTIONS   *
**      TO PERFORM THE DESIRED VSAM DATA SET EXTEND.  THE PROCESSING  *
**      IS AS FOLLOWS:                                                *
**      1. PERFORM THE NECESSARY INITIALIZATION:                      *
**         A. SET UP FOR SMF ALTER PROCESSING.                        *
**         B. INITIALIZE THE SVC 26 CALLER'S WORK AREA.               *
**         C. INDICATE THIS IS NOT AN UPDATE OF THE SEQUENCE SET      *
**            VOLUME OCCURRENCE.                                      *
**         D. CALL IGGPINIT (IGG0CLBC) TO RETRIEVE THE DATA SETS'     *
**            AMDSB.(THE AMDSB CONTAINS RBA                   @Y30SSRS*
**            COMPUTATION PARAMETERS AND MUST ALSO BE UPDATED TO      *
**            REFLECT THE NEW EXTENTS).                               *
**         E. CALL IGGPGET (IGG0CLAG) IF AN EXTEND AGAINST THE DATA   *
**            OBJECT IS BEING PERFORMED WHERE THE SEQUENCE SET IS     *
**            IMBEDDED IN DATA TO OBTAIN THE TOTAL NUMBER OF INDEX    *
**            EXTENTS.                                        @XA02392*
**      2. CALL IGGPSVOL (IGG0CLBC) TO FIND THE CORRECT VOLUME        *
**         OCCURRENCE WHICH IS TO BE GIVEN ADDITIONAL EXTENTS.  THE   *
**         SEARCH IS CONDUCTED BY USING THE SVC 26 CALLER'S INPUT     *
**         VOLUME SERIAL (AND INPUT KEY RANGES). IT IS POSSIBLE THAT  *
**         AN EXISTING VOLUME OCCURRENCE IS NOT FOUND AND THAT A NEW  *
**         VOLUME OCCURRENCE MUST BE ADDED.  SAVE THE SEQUENCE NUMBER *
**         OF THE VOLUME OCCURRENCE AND THE OLD NUMBER OF EXTENTS OF  *
**         THE OCCURRENCE IN THE SVC 26 CALLERS' WORK AREA.   @XA02392*
**      3. CALL IGGPUALL (UNIQUE DATA SET) OR IGGPCSAL (SUB-ALLOCATED *
**         DATA SET) TO OBTAIN MORE EXTENTS FOR THE VSAM DATA SET.    *
**         THESE TWO SUB-FUNCTIONS ARE BASICALLY JUST INTERFACES TO   *
**         IGGPSPAC (IGG0CLBP) AND IGGPSALL (IGG0CLAR).  IGGPSALL     *
**         SUB-ALLOCATES SPACE FROM WITHIN EXISTING VSAM DATA SPACES  *
**         FOR NON-UNIQUE VSAM DATA SETS. HOWEVER, IF THERE IS        *
**         INSUFFICIENT VSAM DATA SPACE FOR SUB-ALLOCATION OR UNIQUE  *
**         DATA SET PROCESSING IS REQUIRED, IGGPSPAC CALLS OS/VS DADSM*
**         EXTEND OR OS/VS DADSM ALLOCATE TO:                         *
**         A. EXTEND AN EXISTING UNIQUE OR NON-UNIQUE VSAM DATA SPACE.*
**         B. ALLOCATE A NEW UNIQUE OR NON-UNIQUE VSAM DATA SPACE.    *
**         ALL OF THE ABOVE PROCESSING IS REFLECTED IN THE VOLUME     *
**         ENTRY ASSOCIATED WITH THE VOLUME OCCURRENCE BEING EXTENDED.*
**      4. UPDATE THE IN-CORE COPIES OF THE AMDSB AND THE VOLUME      *
**         OCCURRENCE TO REFLECT THE NEW NUMBER OF EXTENTS, THE NEW   *
**         HIGH USED AND HIGH ALLOCATED RBA'S, THE NEW FREE SPACE.    *
**      5. CALL IGGPMVOL TO UPDATE THE AMDSB AND TO UPDATE OR ADD THE *
**         VOLUME OCCURRENCE TO THE CATALOG DATA SET.                 *
**      6. CALL IGGPCEXT TO CONSTRUCT THE EXTENT DESCRIPTORS FOR THE  *
**         NEWLY OBTAINED EXTENTS.                                    *
**      7. CALL IGGPMEXT TO ADD THESE EXTENT DESCRIPTORS TO THE NOW   *
**         EXISTING VOLUME OCCURRENCE.                                *
**      8. CALL IGGPSMFA TO WRITE AN SMF ALTER RECORD FOR THE DATA    *
**         OBJECT THAT HAS JUST BEEN EXTENDED TO REFLECT THE CHANGES  *
**         IN ITS CATALOG ENTRY.                                      *
**      9. IF THIS VSAM DATA SET HAS SEQUENCE SET WITH DATA, INDICATE *
**         THE SEQUENCE SET INDEX VOLUME OCCURRENCE IS BEING EXTENDED,*
**         AND CALL IGGPSSWD TO REFLECT THE NEWLY OBTAINED EXTENTS IN *
**         THE INDEX ENTRY.                                           *
**     10. CALL IGGPSMFA (IGG0CLBV) TO WRITE AN SMF ALTER RECORD FOR  *
**         THE INDEX OF THE VSAM DATA SET.                            *
**     11. CALL IGGPSMFL (IGG0CLBV) TO WRITE OUT THE SMF LSPACE       *
**         RECORD 69, IF A VSAM DATA SPACE WAS EXTENDED OR ALLOCATED. *
**     12. CALL IGGPSMFA TO CLEAN UP ANY SMF CHAIN CORE, IF THERE     *
**         WAS A PREVIOUS ERROR.                                      *
**                                                                    *
**   INPUT =                                                          *
**      SVC 26 CALLERS' PARAMETERS:                                   *
**         VOLUME SERIAL OF VSAM DATA SET TO BE EXTENDED              *
**         HIGH AND LOW KEY RANGES IF KEY RANGE DATA SET TO BE EXTEND *
**         WORKAREA INPUT OF NO. OF INDEX EXTENTS AND INDEX CI NO.    *
**                                                            @XA02392*
**   OUTPUT =                                                         *
**      SVC 26 CALLERS' WORK AREA:                                    *
**         SEQUENCE NUMBER OF DATA VOLUME OCCURRENCE EXTENDED.        *
**         SEQUENCE NUMBER OF INDEX SEQUENCE SET VOLUME OCCURRENCE    *
**         EXTENDED.                                                  *
**         NUMBER OF OLD EXTENTS IN DATA AFTER UPDATE EXTEND  @XA02392*
**         NUMBER OF OLD EXTENTS IN INDEX AFTER UPDATE EXTEND @XA02392*
**      CCACD1 - RCS, NO ERROR.                                       *
**               ANY ERROR CODE RETURNED FROM IGGPINIT, IGGPSVOL,     *
**               IGGPUALL, IGGPCSAL, IGGPMVOL, IGGPMEXT, IGGPSSWD.    *
**                                                                    *
**                                                                    *
** * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
*                                                                  0153
*   IF CCARAEOV=ON THEN             /* IF CRA EOV            @Y30SSRS*/
         TM    CCARAEOV(R11),B'01000000'                           0153
         BNO   @RF00153                                            0153
*     CCASMFA=OFF;                  /* NO SMF PROCESSING     @Y30SSRS*/
         NI    CCASMFA(R11),B'11011111'                            0154
*   ELSE                            /* NOT CRA EOV           @Y30SSRS*/
*     CCASMFA=ON;                   /* DO SMF PROCESSING     @Y30SSRS*/
         B     @RC00153                                            0155
@RF00153 OI    CCASMFA(R11),B'00100000'                            0155
*   CCASMFCD=RCS;                   /* ZERO SMF ERROR CODE FIELD     */
*                                                                  0156
@RC00153 MVI   CCASMFCD(R11),X'00'                                 0156
*   /*****************************************************************/
*   /*                                                               */
*   /* CLEAR UPDATE WORK AREA                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0157
*   UPREPARM=UPREPARM&&UPREPARM;    /* ZERO WORK AREA                */
         L     @10,CCAR2REC(,R11)                                  0157
         XC    UPREPARM(18,@10),UPREPARM(@10)                      0157
*   RFY                                                            0158
*     CCARAB BASED(CCARABB);        /* MAP BASE RAB                  */
*   UPUSSWD=OFF;                    /* NOT UPDATE OF SEQ.SET         */
*                                                                  0159
         NI    UPUSSWD(@10),B'01111111'                            0159
*   /*****************************************************************/
*   /*                                                               */
*   /* CALL TO MODULE IGG0CLBC                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0160
*Z004INIT:                                                         0160
*   CALL IGGPINIT;                  /* PERFORM INITIALIZATION        */
*                                                                  0160
Z004INIT L     @15,@CV00038                                        0160
         BALR  @14,@15                                             0160
*   /*****************************************************************/
*   /*                                                               */
*   /* ******** BEGIN                                        @XA02392*/
*   /* IF THE DATA IS BEING EXTENDED AND THE SEQUENCE SET IS IMBEDED */
*   /* IN THE DATA, THE TOTAL NUMBER OF INDEX EXTENTS MUST BE USED AS*/
*   /* THE UPPER LIMIT ON THE NUMBER OF EXTENTS FOR DATA NOTE:       */
*   /* WKAIEXT IS NOT RELIABLE WITH SYSTEM AND REGION SHARING        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0161
*   IF RCDID=CATDATID&UPKEYDS=ON&UPSSWD=ON/* IF SEQ SET WITH         */
*       &CCACD1=RCS THEN            /* DATA, NO PREV ERR     @Y30SSRS*/
         L     @10,CCARABB(,R11)                                   0161
         L     @10,CCACPE1(,@10)                                   0161
         CLI   RCDID(@10),C'D'                                     0161
         BNE   @RF00161                                            0161
         L     @10,CCAR2REC(,R11)                                  0161
         TM    UPKEYDS(@10),B'10100000'                            0161
         BNO   @RF00161                                            0161
         CLI   CCACD1(R11),0                                       0161
         BNE   @RF00161                                            0161
*     DO;                           /* GET INDEX NO. OF EXTENTS      */
*       IF WKAICI=0 THEN            /* IF NO INDEX CI NO     @Y30SSRS*/
         L     @10,CCACPL(,R11)                                    0163
         L     @10,CTGWKA(,@10)                                    0163
         ICM   @05,7,WKAICI(@10)                                   0163
         BNZ   @RF00163                                            0163
*         DO;                       /* ERROR SITUATION       @Y30SSRS*/
*                                                                  0164
*           /*********************************************************/
*           /*                                                       */
*           /* SET CCAMODID='BB', CCAREASN=RSN50, CCARETRN=RCINCNPM  */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0165
*           CCAPROB=IGGSEGID+(RSN50*K256)+RCINCNPM;/* BAD INPUT PARMS
*                                                            @Y30SSRS*/
         MVC   CCAPROB(4,R11),@CF03384                             0165
*           CALL EXIT;              /* ERROR EXIT            @Y30SSRS*/
         BAL   @14,EXIT                                            0166
*         END;                      /* END ERROR             @Y30SSRS*/
*       ELSE                                                       0168
*         ;                         /* INDEX CI NO.          @Y30SSRS*/
@RF00163 DS    0H                                                  0169
*       UPICINO=WKAICI;             /* SAVE INDEX CI NO.     @Y30SSRS*/
         L     @10,CCAR2REC(,R11)                                  0169
         L     @05,CCACPL(,R11)                                    0169
         L     @05,CTGWKA(,@05)                                    0169
         MVC   UPICINO(3,@10),WKAICI(@05)                          0169
*       CCASRID=WKAICI;             /* SET CI NO. OF INDEX           */
         MVC   CCASRID(3,R11),WKAICI(@05)                          0170
*       CCAURAB=ADDR(CCARAB5);      /* USE RAB 5 FOR I/O     @Y30SSRS*/
         LA    @10,CCARAB5(,R11)                                   0171
         ST    @10,CCAURAB(,R11)                                   0171
*       DO;                                                        0172
*         CCAF1KEY=OFF;             /* GET BY CI NO.                 */
*         CCAF1KGE=OFF;             /* NOT GET NEXT                  */
*         CCAF1UP=OFF;              /* NOT GET UPD                   */
*                                                                  0175
         NI    CCAF1KEY(R11),B'11100101'                           0175
*         /***********************************************************/
*         /*                                                         */
*         /* CALL TO MODULE IGG0CLBI                                 */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0176
*Z007GET:                                                          0176
*         CALL IGGPGET;             /* GET RECORD                    */
Z007GET  L     @15,@CV00036                                        0176
         BALR  @14,@15                                             0176
*       END;                        /* READ INDEX RCD        @Y30SSRS*/
*       IF CCACD1^=RCS THEN                                        0178
         CLI   CCACD1(R11),0                                       0178
         BNE   @RT00178                                            0178
*         ;                         /* IF PREV ERROR         @Y30SSRS*/
*       ELSE                        /* NO PREV ERROR         @Y30SSRS*/
*         DO;                       /* GET NO. IDX EXTS      @Y30SSRS*/
*           CCARABB=ADDR(CCARAB5);  /* SET BASE RAB          @Y30SSRS*/
         LA    @10,CCARAB5(,R11)                                   0181
         ST    @10,CCARABB(,R11)                                   0181
*           CCAR3UR=OFF;            /* ALLOW RAB USE         @Y30SSRS*/
         NI    CCAR3UR(R11),B'01111111'                            0182
*           CCAR1UR=ON;             /* DONT USE RA 1         @Y30SSRS*/
*                                                                  0183
         OI    CCAR1UR(R11),B'10000000'                            0183
*           /*********************************************************/
*           /*                                                       */
*           /* CALL TO MODULE IGG0CLAZ                               */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0184
*Z008EXT:                                                          0184
*           CALL IGGPEXT;           /* CALL EXTRACT          @Y30SSRS*/
Z008EXT  L     @15,@CV00037                                        0184
         BALR  @14,@15                                             0184
*           RFY                                                    0185
*             CTGPL BASED(CCAXCPL); /* MAP EXTRACT CPL       @Y30SSRS*/
*           RFY                                                    0186
*             CTGFL BASED(CTGFIELD(1));/* MAP FIRST FPL      @Y30SSRS*/
*           RFY                                                    0187
*             IDAAMDSB BASED(CTGFLPT(1));/* MAP AMDSB        @Y30SSRS*/
*           CCAR3UR=ON;             /* DONT USE RAB          @Y30SSRS*/
         OI    CCAR3UR(R11),B'10000000'                            0188
*           CCAR1UR=OFF;            /* ALLOW RA 1 USE        @Y30SSRS*/
         NI    CCAR1UR(R11),B'01111111'                            0189
*           UPNIEXT=AMDNEXT;        /* SET NO. IDX EXTS      @Y30SSRS*/
         L     @10,CCAR2REC(,R11)                                  0190
         L     @05,CCAXCPL(,R11)                                   0190
         L     @05,CTGFIELD(,@05)                                  0190
         L     @05,CTGFLPT(,@05)                                   0190
         LH    @05,AMDNEXT(,@05)                                   0190
         STH   @05,UPNIEXT(,@10)                                   0190
*           RCDCINO=0;              /* NO REUSE IDX RCD      @Y30SSRS*/
         L     @05,CCARABB(,R11)                                   0191
         L     @05,CCACPE1(,@05)                                   0191
         SLR   @15,@15                                             0191
         STCM  @15,7,RCDCINO(@05)                                  0191
*           CCARABB=ADDR(CCARAB1);  /* RESET BASE RAB        @Y30SSRS*/
         LA    @05,CCARAB1(,R11)                                   0192
         ST    @05,CCARABB(,R11)                                   0192
*           RFY                                                    0193
*             CTGPL BASED(CCACPL);  /* MAP USER CPL          @Y30SSRS*/
*           RFY                                                    0194
*             IDAAMDSB BASED(ADDR(UPREND)+LENGTH(UPENTVOL));/*     0194
*                                                            @Y30SSRS*/
*           CCAURAB=ADDR(CCARAB1);  /* SET RAB ADDR          @Y30SSRS*/
         ST    @05,CCAURAB(,R11)                                   0195
*           UPENTVOL=UPENTVOL&&UPENTVOL;/* ZERO INTERFACE    @Y30SSRS*/
         XC    UPENTVOL+18(176,@10),UPENTVOL+18(@10)               0196
*         END;                      /* END GET               @Y30SSRS*/
*     END;                          /* END GET               @Y30SSRS*/
*   ELSE                            /* INDEX NO. OF EXTENTS NOT    0199
*                                      REQUIRED              @Y30SSRS*/
*     UPNIEXT=0;                    /* NO INDUCED EXTENT LIMIT SINCE
*                                      SEQ SET NOT WITH DATA         */
         B     @RC00161                                            0199
@RF00161 L     @10,CCAR2REC(,R11)                                  0199
         SLR   @05,@05                                             0199
         STH   @05,UPNIEXT(,@10)                                   0199
*   WKARETN=WKARETN&&WKARETN;       /* ZERO USER RETURN AREA         */
@RC00161 L     @10,CCACPL(,R11)                                    0200
         L     @10,CTGWKA(,@10)                                    0200
         XC    WKARETN(8,@10),WKARETN(@10)                         0200
*   WKALEN2=LENGTH(WKAINFO);        /* LENGTH OF RETURNED INFO       */
*                                                                  0201
         MVC   WKALEN2(2,@10),@CH00370                             0201
*   /*****************************************************************/
*   /*                                                               */
*   /* **** END                                              @XA02392*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0202
*   IF CCACD1^=RCS THEN                                            0202
         CLI   CCACD1(R11),0                                       0202
         BNE   @RT00202                                            0202
*     ;                             /* ERROR                         */
*   ELSE                            /* NO ERROR                      */
*     DO;                           /* PROCESS VOLUME                */
*       UPSVOL=UPSVOL&&UPSVOL;      /* ZERO SEARCH VOL WORK AREA     */
         L     @10,CCAR2REC(,R11)                                  0205
         LA    @10,UPREND(,@10)                                    0205
         AL    @10,@CF03385                                        0205
         XC    UPSVOL(22,@10),UPSVOL(@10)                          0205
*       UPVOLSER=UPEVOL;            /* SAVE VOLSER INFO              */
         L     @05,CCACPL(,R11)                                    0206
         L     @01,CTGFIELD(,@05)                                  0206
         L     @01,CTGFLPT(,@01)                                   0206
         MVC   UPVOLSER(6,@10),UPEVOL(@01)                         0206
*       IF CTGNOFLD=NOKEYFPL THEN   /* IF KEY RANGE REQUEST          */
         CLI   CTGNOFLD(@05),3                                     0207
         BNE   @RF00207                                            0207
*         DO;                       /* GET PARM INFO                 */
*           RFY                                                    0209
*             CTGFL BASED(CTGFIELD(2));/* MAP LOW KEY FPL            */
*           UPLKEYPT=CTGFLPT(1);    /* POINT TO LOW KEY              */
         L     @15,CTGFIELD+4(,@05)                                0210
         L     @14,CTGFLPT(,@15)                                   0210
         ST    @14,UPLKEYPT(,@10)                                  0210
*           UPLKEYLN=CTGFLNG(1);    /* LOW KEY LENGTH                */
         L     @15,CTGFLNG(,@15)                                   0211
         STH   @15,UPLKEYLN(,@10)                                  0211
*           RFY                                                    0212
*             CTGFL BASED(CTGFIELD(3));/* MAP HIGH KEY FPL           */
*           UPHKEYPT=CTGFLPT(1);    /* POINT TO HIGH KEY             */
         L     @05,CTGFIELD+8(,@05)                                0213
         L     @15,CTGFLPT(,@05)                                   0213
         ST    @15,UPHKEYPT(,@10)                                  0213
*           UPHKEYLN=CTGFLNG(1);    /* HIGH KEY LENGTH               */
         L     @05,CTGFLNG(,@05)                                   0214
         STH   @05,UPHKEYLN(,@10)                                  0214
*         END;                      /* END GET PARM INFO             */
*       ELSE                                                       0216
*         ;                         /* NON-KEY RANGE REQUEST         */
*                                                                  0216
@RF00207 DS    0H                                                  0217
*       /*************************************************************/
*       /*                                                           */
*       /* CALL TO MODULE IGG0CLBC                                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0217
*Z009SVOL:                                                         0217
*       CALL IGGPSVOL;              /* SEARCH FOR VOLUME             */
Z009SVOL L     @15,@CV00043                                        0217
         BALR  @14,@15                                             0217
*       IF CCACD1^=RCS THEN                                        0218
         CLI   CCACD1(R11),0                                       0218
         BNE   @RT00218                                            0218
*         ;                         /* ERROR                         */
*       ELSE                        /* NO ERROR                      */
*         DO;                       /* GET SPACE                     */
*           WKAREL=UPRLRP;          /* SET OBJECT RELREPNO           */
         L     @10,CCACPL(,R11)                                    0221
         L     @10,CTGWKA(,@10)                                    0221
         L     @05,CCAR2REC(,R11)                                  0221
         LH    @05,UPRLRP+18(,@05)                                 0221
         STH   @05,WKAREL(,@10)                                    0221
*           CCAR3UR=OFF;            /* FREE RECORD AREA FOR DADSM  0222
*                                      EXTEND USE                    */
         NI    CCAR3UR(R11),B'01111111'                            0222
*           IF CUNIQ=ON THEN        /* IF UNIQUE                     */
         L     @10,CCARABB(,R11)                                   0223
         L     @10,CCACPE1(,@10)                                   0223
         TM    CUNIQ(@10),B'01000000'                              0223
         BNO   @RF00223                                            0223
*Z010UALL:                                                         0224
*             CALL IGGPUALL;        /* USE OS/VS EXTEND      @Y30SSRS*/
Z010UALL BAL   @14,IGGPUALL                                        0224
*           ELSE                    /* NO UNIQUE                     */
*Z011CSAL:                                                         0225
*             CALL IGGPCSAL;        /* SUBALLOCATE                   */
         B     @RC00223                                            0225
@RF00223 DS    0H                                                  0225
Z011CSAL BAL   @14,IGGPCSAL                                        0225
*           IF CCACD1^=RCS THEN                                    0226
@RC00223 CLI   CCACD1(R11),0                                       0226
         BNE   @RT00226                                            0226
*             ;                     /* IF ERROR, SKIP PROCESS        */
*           ELSE                    /* NO ERROR                      */
*             DO;                   /* UPDATE RECORD                 */
*               IF CCARAEOV=ON|     /* IF CRA EOV            @Y30SSRS*/
*                   CAXEOV=ON|      /* OR CATALOG EOV        @Y30SSRS*/
*                   CAXF2REC=OFF THEN                              0229
         TM    CCARAEOV(R11),B'01000000'                           0229
         BO    @RT00229                                            0229
         L     @10,CCAACB(,R11)                                    0229
         L     @10,ACBUAPTR(,@10)                                  0229
         TM    CAXEOV(@10),B'00010000'                             0229
         BO    @RT00229                                            0229
         TM    CAXF2REC(@10),B'00000010'                           0229
         BZ    @RT00229                                            0229
*                 ;                 /* OR NON-REC CAT        @Y30SSRS*/
*               ELSE                /* NOT SPECIAL EOV       @Y30SSRS*/
*                 DO;               /* UPDATE SUM TT         @Y30SSRS*/
*                   CCARABB=ADDR(CCARAB3);/* SET UP FOR D.S. @Y30SSRS
*                                      SUM TT UPDATE         @Y30SSRS*/
         LA    @10,CCARAB3(,R11)                                   0232
         ST    @10,CCARABB(,R11)                                   0232
*                   CCARABF=ADDR(CCARAB3);/* SET RAB ADDR    @Y30SSRS*/
         ST    @10,CCARABF(,R11)                                   0233
*                   CCARABL=ADDR(CCARAB5);/* SET LAST RAB ADDR     0234
*                                                            @Y30SSRS*/
*                                                                  0234
         LA    @10,CCARAB5(,R11)                                   0234
         ST    @10,CCARABL(,R11)                                   0234
*                   /*************************************************/
*                   /*                                               */
*                   /* CALL TO MODULE IGG0CLBI                       */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0235
*Z012TNXO:                                                         0235
*                   CALL IGGPTNXO;  /* COMPUTE SUM TT        @Y30SSRS*/
Z012TNXO L     @15,@CV00045                                        0235
         BALR  @14,@15                                             0235
*                   CCARESUM=OFF;   /* INCR SUMM TT          @Y30SSRS*/
         NI    CCARESUM(R11),B'11111110'                           0236
*                   CCASSVOL=UPSSDS;/* SET D.S. SEQ NO.      @Y30SSRS*/
*                                                                  0237
         L     @10,CCAR2REC(,R11)                                  0237
         MVC   CCASSVOL(2,R11),UPSSDS+18(@10)                      0237
*                   /*************************************************/
*                   /*                                               */
*                   /* CALL TO MODULE IGG0CLBI                       */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0238
*Z013TXO:                                                          0238
*                   CALL IGGPTXO;   /* UPD D.S. SUMM TT      @Y30SSRS*/
Z013TXO  L     @15,@CV00046                                        0238
         BALR  @14,@15                                             0238
*                 END;              /* END UPDATE SUM TT     @Y30SSRS*/
*               IF CCACD1^=RCS THEN                                0240
@RT00229 CLI   CCACD1(R11),0                                       0240
         BNE   @RT00240                                            0240
*                 ;                 /* STOP IF ERROR         @Y30SSRS*/
*               ELSE                /* NO ERROR              @Y30SSRS*/
*                 DO;               /* UPDATE RECORD         @Y30SSRS*/
*                   CCAR3UR=ON;     /* USE RECORD AREA AS WORK AREA  */
         OI    CCAR3UR(R11),B'10000000'                            0243
*                   CCARABB=ADDR(CCARAB1);/* RESET BASE RAB ADDR     */
         LA    @10,CCARAB1(,R11)                                   0244
         ST    @10,CCARABB(,R11)                                   0244
*                   CCARABF=ADDR(CCARAB1);/* RESET FIRST RAB ADDR    */
         ST    @10,CCARABF(,R11)                                   0245
*                   CCARABL=ADDR(CCARAB5);/* RESET LAST RAB ADDR     */
         LA    @10,CCARAB5(,R11)                                   0246
         ST    @10,CCARABL(,R11)                                   0246
*                   CCAREUSE=OFF;   /* DONT REUSE RCD AREAS          */
         NI    CCAREUSE(R11),B'11111011'                           0247
*                   RFY                                            0248
*                     CCARAB BASED(ADDR(CCARAB3));/* MAP VOL ENTRY   */
*                   UPNTCYL=CTVNOTRK;/* SAVE TRACKS/CYL              */
         L     @10,CCAR2REC(,R11)                                  0249
         L     @05,CCACPE1+148(,R11)                               0249
         MVC   UPNTCYL(2,@10),CTVNOTRK+48(@05)                     0249
*                   UPVCINO=RCDCINO;/* SAVE VOLUME CI NO.            */
         MVC   UPVCINO(3,@10),RCDCINO(@05)                         0250
*                   RFY                                            0251
*                     CCARAB BASED(CCARABB);/* ORIGINAL BASE         */
*                   R3=0;           /* INITLZ TOTAL NO. CAS          */
         SLR   R3,R3                                               0252
*                   DO R2=1 TO CCANDEXT;/* ADD UP CA'S               */
         LA    R2,1                                                0253
         B     @DE00253                                            0253
@DL00253 DS    0H                                                  0254
*                     R3=R3+(CCAEXTTH(R2)/UPNTKA);/* INCR TOTAL CA'S */
         LR    @10,R2                                              0254
         SLA   @10,3                                               0254
         L     @05,CCAR2REC(,R11)                                  0254
         ALR   @10,R11                                             0254
         ICM   @00,12,CCAEXTTH-8(@10)                              0254
         SRA   @00,16                                              0254
         SRDA  @00,32                                              0254
         LH    @10,UPNTKA+18(,@05)                                 0254
         DR    @00,@10                                             0254
         ALR   R3,@01                                              0254
*                   END;            /* END ADD                       */
         AL    R2,@CF00060                                         0255
@DE00253 SLR   @10,@10                                             0255
         IC    @10,CCANDEXT(,R11)                                  0255
         CR    R2,@10                                              0255
         BNH   @DL00253                                            0255
*                   IF AMDREPL=ON&  /* IF REPLICATION OF INDEX       */
*                       RCDID=CATIXID THEN/* AND INDEX OBJECT        */
         L     @10,CCAR2REC(,R11)                                  0256
         LA    @10,UPREND(,@10)                                    0256
         AL    @10,@CF00522                                        0256
         TM    AMDREPL(@10),B'00010000'                            0256
         BNO   @RF00256                                            0256
         L     @05,CCARABB(,R11)                                   0256
         L     @05,CCACPE1(,@05)                                   0256
         CLI   RCDID(@05),C'I'                                     0256
         BNE   @RF00256                                            0256
*                     R3=R3*AMDCINV;/* TOTAL ADDED RBA               */
         LR    @01,R3                                              0257
         M     @00,AMDCINV(,@10)                                   0257
         LR    R3,@01                                              0257
*                   ELSE            /* NO REPLICATION                */
*                     R3=R3*AMDCIPCA*AMDCINV;/* TOTAL ADDED RBA      */
         B     @RC00256                                            0258
@RF00256 L     @10,CCAR2REC(,R11)                                  0258
         LA    @10,UPREND(,@10)                                    0258
         AL    @10,@CF00522                                        0258
         LR    @01,R3                                              0258
         MH    @01,AMDCIPCA(,@10)                                  0258
         M     @00,AMDCINV(,@10)                                   0258
         LR    R3,@01                                              0258
*                   UPCHIA=CHIA;    /* SAVE HIGH ALLOCATED           */
@RC00256 L     @10,CCAR2REC(,R11)                                  0259
         L     @05,CCARABB(,R11)                                   0259
         L     @05,CCACPE1(,@05)                                   0259
         ICM   @15,15,CHIA(@05)                                    0259
         ST    @15,UPCHIA(,@10)                                    0259
*                   UPHUBA=CHIA;    /* NEW HIGH USED                 */
         LA    @14,18                                              0260
         ALR   @14,@10                                             0260
         STCM  @15,15,UPHUBA(@14)                                  0260
*                   CHIA=CHIA+R3;   /* NEW HIGH ALLOCATED D.S.       */
         ALR   @15,R3                                              0261
         STCM  @15,15,CHIA(@05)                                    0261
*                   UPHABA=CHIA;    /* NEW HIGH ALLOCATED VOLUME     */
         STCM  @15,15,UPHABA(@14)                                  0262
*                   UPNOEXT=UPNOEXT+CCANDEXT;/* NEW TOTAL EXTENTS VOL*/
         SLR   @05,@05                                             0263
         IC    @05,CCANDEXT(,R11)                                  0263
         SLR   @15,@15                                             0263
         IC    @15,UPNOEXT(,@14)                                   0263
         ALR   @15,@05                                             0263
         STC   @15,UPNOEXT(,@14)                                   0263
*                   AMDNEXT=AMDNEXT+CCANDEXT;/* NEW TOTAL EXTENTS  0264
*                                      D.S.                          */
         LA    @10,UPREND(,@10)                                    0264
         AL    @10,@CF00522                                        0264
         AH    @05,AMDNEXT(,@10)                                   0264
         STH   @05,AMDNEXT(,@10)                                   0264
*                   WKAEXT=AMDNEXT; /* SET TOTAL EXTENTS FOR DATA SET
*                                                            @XA02392*/
         L     @01,CCACPL(,R11)                                    0265
         L     @01,CTGWKA(,@01)                                    0265
         STH   @05,WKAEXT(,@01)                                    0265
*                   AMDASPA=AMDASPA+R3;/* NEW FREE SPACE TOTAL       */
         LR    @05,R3                                              0266
         AL    @05,AMDASPA(,@10)                                   0266
         ST    @05,AMDASPA(,@10)                                   0266
*Z014MVOL:                                                         0267
*                   CALL IGGPMVOL;  /* MODIFY AMDSB, VOL OCCUR       */
Z014MVOL BAL   @14,IGGPMVOL                                        0267
*                   WKAREL=UPRLRP;  /* SAVE SEQ. NO. OF ANY ADDED  0268
*                                      OCCURRENCE                    */
         L     @10,CCACPL(,R11)                                    0268
         L     @10,CTGWKA(,@10)                                    0268
         L     @05,CCAR2REC(,R11)                                  0268
         LH    @05,UPRLRP+18(,@05)                                 0268
         STH   @05,WKAREL(,@10)                                    0268
*                   CCAREUSE=ON;    /* REUSE RCD AREAS HERE ON       */
         OI    CCAREUSE(R11),B'00000100'                           0269
*                   IF CCACD1^=RCS THEN                            0270
         CLI   CCACD1(R11),0                                       0270
         BNE   @RT00270                                            0270
*                     ;             /* ERROR, END PROCESS            */
*                   ELSE            /* NO ERROR                      */
*                     DO;           /* UPDATE EXTENTS                */
*Z015CEXT:                                                         0273
*                       CALL IGGPCEXT;/* COMPUTE EXTENTS             */
Z015CEXT BAL   @14,IGGPCEXT                                        0273
*Z016MEXT:                                                         0274
*                       CALL IGGPMEXT;/* MODIFY EXTENT INFO          */
Z016MEXT BAL   @14,IGGPMEXT                                        0274
*                       IF CCASMFA=ON THEN/* IF SMF PROCESSING     0275
*                                                            @Y30SSRS*/
         TM    CCASMFA(R11),B'00100000'                            0275
         BNO   @RF00275                                            0275
*                         DO;       /* DO SMF                @Y30SSRS*/
*                           CCASMFG1=0;/* ZERO OP TYPE       @Y30SSRS*/
         MVI   CCASMFG1(R11),X'00'                                 0277
*                           CCASMFAL=ON;/* ALTER             @Y30SSRS*/
*                                                                  0278
         OI    CCASMFAL(R11),B'01000000'                           0278
*                           /*****************************************/
*                           /*                                       */
*                           /* CALL TO MODULE IGG0CLBV               */
*                           /*                                       */
*                           /*****************************************/
*                                                                  0279
*Z017SMFA:                                                         0279
*                           CALL IGGPSMFA;/* CALL SMF ALTER  @Y30SSRS*/
Z017SMFA L     @15,@CV00044                                        0279
         BALR  @14,@15                                             0279
*                         END;      /* END DO                @Y30SSRS*/
*                       ELSE                                       0281
*                         ;         /* NO SMF                @Y30SSRS*/
@RF00275 DS    0H                                                  0282
*                       IF CCACD1^=RCS THEN                        0282
         CLI   CCACD1(R11),0                                       0282
         BNE   @RT00282                                            0282
*                         ;         /* ERROR                         */
*                       ELSE        /* NO ERROR                      */
*                         DO;       /* UPDATE SEQ. SET IF NEEDED     */
*                           IF UPSSWD=ON&/* IF SEQ. SET WITH DATA    */
*                               RCDID=CATDATID THEN/* AND DATA OBJECT*/
         L     @10,CCAR2REC(,R11)                                  0285
         TM    UPSSWD(@10),B'00100000'                             0285
         BNO   @RF00285                                            0285
         L     @05,CCARABB(,R11)                                   0285
         L     @05,CCACPE1(,@05)                                   0285
         CLI   RCDID(@05),C'D'                                     0285
         BNE   @RF00285                                            0285
*                             DO;   /* UPDATE SEQ SET                */
*                               UPUSSWD=ON;/* UPDATE SEQ SET         */
         OI    UPUSSWD(@10),B'10000000'                            0287
*Z018SSWD:                                                         0288
*                               CALL IGGPSSWD;/* UPDATE SEQ SET      */
Z018SSWD BAL   @14,IGGPSSWD                                        0288
*                               IF CCASMFA=ON THEN/* IF SMF PROCESS
*                                                            @Y30SSRS*/
         TM    CCASMFA(R11),B'00100000'                            0289
         BNO   @RF00289                                            0289
*                                 DO;/* DO SMF               @Y30SSRS*/
*                                                                  0290
*                                   /*********************************/
*                                   /*                               */
*                                   /* CALL TO MODULE IGG0CLBV       */
*                                   /*                               */
*                                   /*********************************/
*                                                                  0291
*Z019SMFA:                                                         0291
*                                   CALL IGGPSMFA;/* SMF ALTER RECORD
*                                                            @Y30SSRS*/
Z019SMFA L     @15,@CV00044                                        0291
         BALR  @14,@15                                             0291
*                                 END;/* END DO SMF          @Y30SSRS*/
*                               ELSE                               0293
*                                 ; /* NO SMF                @Y30SSRS*/
@RF00289 DS    0H                                                  0294
*                             END;  /* END UPDATE SEQ SET            */
*                           ELSE                                   0295
*                             ;     /* NO UPDATE OF SEQ. SET         */
@RF00285 DS    0H                                                  0296
*                         END;      /* END UPDATE SEQ. SET           */
*                     END;          /* END UPDATE EXTENTS            */
@RT00282 DS    0H                                                  0298
*                 END;              /* END UPDATE RECORD     @Y30SSRS*/
@RT00270 DS    0H                                                  0299
*             END;                  /* END UPDATE RECORD             */
@RT00240 DS    0H                                                  0300
*         END;                      /* END GET SPACE                 */
@RT00226 DS    0H                                                  0301
*     END;                          /* END PROCESS VOLUME            */
@RT00218 DS    0H                                                  0302
*   IF UPSMFL=ON&CCACD1=RCS THEN    /* IF NO ERROR & SMF LSPACE IS TO
*                                      BE WRITTEN                    */
@RT00202 L     @10,CCAR2REC(,R11)                                  0302
         TM    UPSMFL(@10),B'00000100'                             0302
         BNO   @RF00302                                            0302
         CLI   CCACD1(R11),0                                       0302
         BNE   @RF00302                                            0302
*     DO;                           /* WRITE SMF                     */
*       CCASMFBR=ON;                /* INDICATE BASE VOLUME RECORD 0304
*                                      MUST BE READ FOR SMF        0304
*                                      PROCESSING                    */
         OI    CCASMFBR(R11),B'00010000'                           0304
*       CCASRID=UPVCINO;            /* SET VOLUME CI NO. IN I/O    0305
*                                      SEARCH ARG FOR SMF            */
         MVC   CCASRID(3,R11),UPVCINO(@10)                         0305
*       CCAR2UR=OFF;                /* FREE RCD AREA FOR LSPACE      */
         NI    CCAR2UR(R11),B'01111111'                            0306
*       CCAR3UR=OFF;                /* FREE RCD AREA                 */
         NI    CCAR3UR(R11),B'01111111'                            0307
*       CCASMFPT=0;                 /* NO DATA INFO SUPPLIED         */
*                                                                  0308
         SLR   @10,@10                                             0308
         ST    @10,CCASMFPT(,R11)                                  0308
*       /*************************************************************/
*       /*                                                           */
*       /* CALL TO MODULE IGG0CLBV                                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0309
*Z020SMFL:                                                         0309
*       CALL IGGPSMFL;              /* WRITE SMF                     */
Z020SMFL L     @15,@CV00041                                        0309
         BALR  @14,@15                                             0309
*     END;                          /* END WRITE SMF                 */
*   ELSE                                                           0311
*     ;                             /* NO LSPACE SMF                 */
@RF00302 DS    0H                                                  0312
*   IF CCACD1^=RCS&CCASMFA=ON THEN  /* IF PREV ERROR         @Y30SSRS*/
         CLI   CCACD1(R11),0                                       0312
         BE    @RF00312                                            0312
         TM    CCASMFA(R11),B'00100000'                            0312
         BNO   @RF00312                                            0312
*     DO;                           /* FREE SMF ALTER CHAIN CORE     */
*                                                                  0313
*       /*************************************************************/
*       /*                                                           */
*       /* CALL TO MODULE IGG0CLBV                                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0314
*Z021SMFA:                                                         0314
*       CALL IGGPSMFA;              /* CALL SMF ALTER                */
Z021SMFA L     @15,@CV00044                                        0314
         BALR  @14,@15                                             0314
*     END;                          /* END FREE                      */
*   ELSE                                                           0316
*     ;                             /* NO ERROR                      */
@RF00312 DS    0H                                                  0317
*   CALL EXIT;                      /* RETURN TO CALLER              */
         BAL   @14,EXIT                                            0317
*   GEN(DS 0F);                     /* FULLWORD BOUNDARY ALIGNMENT   */
         DS 0F
*   GEN(DC CL8'IGGPMEXT');          /* NAME OF FOLLOWING PROCEDURE   */
         DC CL8'IGGPMEXT'
*   END;                            /* END OF INNER PROCEDURE        */
@EL00002 DS    0H                                                  0320
@EF00002 DS    0H                                                  0320
@ER00002 BR    @14                                                 0320
@PB00002 DS    0H                                                  0321
*   GEN(EJECT);                     /* GO TO A NEW PRINT PAGE        */
         EJECT
*                                                                  0322
*/********************************************************************/
*/*                                                                  */
*/*        IGGPMEXT  -  PROCEDURE  INTERNALLY  CALLED  NESTED        */
*/*                                                                  */
*/********************************************************************/
*                                                                  0322
*IGGPMEXT:                                                         0322
*   PROC OPTIONS(NOSAVEAREA,NOSAVE);/* SPECIFY PROCEDURE OPTIONS     */
         B     @PB00003                                            0322
IGGPMEXT DS    0H                                                  0323
*Z022:                              /* LABEL FOR PROCEDURE TRACKING  */
*Z022MEXT:                          /* LABEL FOR PROCEDURE TRACKING  */
*   RFY                                                            0323
*    (R5,                                                          0323
*     R6,                                                          0323
*     R7,                                                          0323
*     R8,                                                          0323
*     R9,                                                          0323
*     R10) UNRSTD;                  /* PL/S COMPILER WORK REGISTERS  */
Z022     DS    0H                                                  0323
Z022MEXT DS    0H                                                  0324
*   RFY                                                            0324
*    (R2,                                                          0324
*     R3,                                                          0324
*     R4) RSTD;                     /* RESTRICT LOCAL WORK REGISTERS */
*   GEN(STM 12,14,12(13));          /* SAVE REGISTERS OF CALLER      */
         STM 12,14,12(13)
*   GEN(LA 13,12(13));              /* POINT TO NEXT SAVE AREA     0326
*                                      PROCEDURE                     */
         LA 13,12(13)
*/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
**   MODULE NAME =  IGGPMEXT (IGG0CLBB)                               *
**                                                                    *
**   DESCRIPTIVE NAME =  MODIFY EXTENTS                               *
**                                                                    *
**   FUNCTION =                                                       *
**      THIS SUB-FUNCTION CALLS MODIFY (IGGPMOD) TO ADD THE NEWLY     *
**      CONSTRUCTED DATA SPACE DESCRIPTORS TO THE ADDED OR UPDATED    *
**      VOLUME OCCURRENCE.  THE PROCESSING IS AS FOLLOWS:             *
**      1. BUILD MODIFY PARAMETER LISTS TO INSERT THE NEW DATA SPACE  *
**         DESCRIPTORS INTO THE VOLUME OCCURRENCE.                    *
**      2. CALL IGGPMOD (IGG0CLAV).                                   *
**                                                                    *
**   INPUT =                                                          *
**      CCA MODIFY INTERFACE FLAGS/ADDRESSES SET.                     *
**      EXTINF1 - NEW DATA SET EXTENT DESCRIPTORS.                    *
**      UPENTVOL PARAMETERS:                                          *
**         UPRLRP - SEQUENCE NUMBER  OF VOLUME OCCURRENCE PREVIOUSLY  *
**                  ADDED OR UPDATED.                                 *
**      UPREPARM PARAMETERS:                                          *
**         UPEXTLN - LENGTH OF EXISTING EXTENT DESCRIPTORS.           *
**                                                                    *
**   OUTPUT =                                                         *
**      NEWLY CONSTRUCTED EXTENT DESCRIPTORS ADDED TO VOLUME          *
**      OCCURRENCE OF DATA SET.                                       *
**      CCACD1 - RCS, NO ERROR.                                       *
**               ANY ERROR CODE RETURNED BY IGGPMOD.                  *
**                                                                    *
**                                                                    *
** * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
*                                                                  0327
*   RFY                                                            0327
*     CTGPL BASED(CCAMCPL);         /* MAP MODIFY CPL                */
*   CCAMCPL=ADDR(UPEND)+LENGTH(IDAAMDSB)+/* ADDR AREA FOR MODIFY     */
*       LENGTH(EXTILEN)+LENGTH(EXTINFO)*MXALEX;/* CPL                */
         L     @10,CCAR2REC(,R11)                                  0328
         LA    @05,18                                              0328
         ALR   @05,@10                                             0328
         LA    @15,UPEND(,@05)                                     0328
         LA    @14,198                                             0328
         ALR   @14,@15                                             0328
         ST    @14,CCAMCPL(,R11)                                   0328
*   RFY                                                            0329
*     CLEAR BASED(CCAMCPL);         /* MAP WORK AREA                 */
*   CLEAR=CLEAR&&CLEAR;             /* CLEAR WORK AREA FOR BUILDING
*                                      MODIFY PARM LIST              */
         XC    CLEAR(256,@14),CLEAR(@14)                           0330
*   CTGNOFLD=NOEXTFPL;              /* NO. FPLS                      */
         MVI   CTGNOFLD(@14),X'01'                                 0331
*   R2=CCAMCPL+LENGTH(CTGPL)        /* POINT TO EXTENT FPL AREA      */
*       +NOEXTFPL*LENGTH(CTGFIELD);                                0332
         LA    R2,32                                               0332
         ALR   R2,@14                                              0332
*   CTGFIELD(1)=R2+LENGTH(FIELDNM); /* EXTENT FPL                    */
         LA    @09,8                                               0333
         LR    @08,R2                                              0333
         ALR   @08,@09                                             0333
         ST    @08,CTGFIELD(,@14)                                  0333
*   RFY                                                            0334
*     CTGFL BASED(CTGFIELD(1));     /* MAP EXTENT FPL                */
*   CTGFLDNM=R2;                    /* POINT FIELD NAME AREA         */
         ST    R2,CTGFLDNM(,@08)                                   0335
*   FIELDNM=EXTENT;                 /* INSERT EXTENT NAME            */
         L     @01,CCAMCPL(,R11)                                   0336
         L     @01,CTGFIELD(,@01)                                  0336
         L     @14,CTGFLDNM(,@01)                                  0336
         MVC   FIELDNM(8,@14),@CC00073                             0336
*   CTGFLDNO=NODAT;                 /* DATA                          */
         MVI   CTGFLDNO(@08),X'01'                                 0337
*   CTGFLPT(1)=ADDR(UPEND)+LENGTH(IDAAMDSB);/* EXTENT INFO ADDR      */
         AL    @15,@CF00479                                        0338
         ST    @15,CTGFLPT(,@08)                                   0338
*   CTGFLNG(1)=0;                   /* DELETE LENGTH OF ZERO         */
         SLR   @15,@15                                             0339
         ST    @15,CTGFLNG(,@08)                                   0339
*   CTGVLDSP=UPEXTLN+LENGTH(UPEXTLN1);/* SET DISPL                   */
         LA    @15,2                                               0340
         LR    @14,@08                                             0340
         ALR   @14,@15                                             0340
         LH    @10,UPEXTLN(,@10)                                   0340
         ALR   @10,@15                                             0340
         STH   @10,CTGVLDSP(,@14)                                  0340
*   R2=ADDR(CTGFL)+LENGTH(CTGFL)+   /* POINT TEST FPL AREA           */
*       NODAT*LENGTH(CTGFLDAT);                                    0341
         LA    R2,24                                               0341
         ALR   R2,@08                                              0341
*   CTGFLCHN=R2+LENGTH(FIELDNM);    /* CHAIN TEST FPL                */
         ALR   @09,R2                                              0342
         ST    @09,CTGFLCHN(,@08)                                  0342
*   RFY                                                            0343
*     CTGFL BASED(R2+LENGTH(FIELDNM));/* MAP TEST FPL                */
*   CTGFLDNM=R2;                    /* FIELD NAME ADDR               */
         ST    R2,CTGFLDNM(,@09)                                   0344
*   FIELDNM=RELREPNO;               /* INSERT NAME RELREPNO          */
         L     @10,CTGFLDNM+8(,R2)                                 0345
         MVC   FIELDNM(8,@10),@CC00081                             0345
*   CTGFLDNO=NODAT;                 /* DATA                          */
         MVI   CTGFLDNO(@09),X'01'                                 0346
*   CTGFLDCD=CTGFLDEQ;              /* EQUAL RELREPNO TEST           */
         MVI   CTGFLDCD(@09),X'80'                                 0347
*   CTGFLDGC=CATVOLGC;              /* GROUP CODE                    */
         MVI   CTGFLDGC(@09),X'03'                                 0348
*   CTGFLPT(1)=ADDR(UPRLRP);        /* POINT TO TEST DATA            */
         ST    @05,CTGFLPT(,@09)                                   0349
*   CTGFLNG(1)=LENGTH(UPRLRP);      /* LENGTH TEST DATA              */
*                                                                  0350
         ST    @15,CTGFLNG(,@09)                                   0350
*   /*****************************************************************/
*   /*                                                               */
*   /* CALL TO MODULE IGG0CLAV                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0351
*Z023MOD:                                                          0351
*   CALL IGGPMOD;                   /* MODIFY EXTENTS                */
Z023MOD  L     @15,@CV00039                                        0351
         BALR  @14,@15                                             0351
*   CALL EXIT;                      /* RETURN TO CALLER              */
         BAL   @14,EXIT                                            0352
*   GEN(DS 0F);                     /* FULLWORD BOUNDARY ALIGNMENT   */
         DS 0F
*   GEN(DC CL8'IGGPUALL');          /* NAME OF FOLLOWING PROCEDURE   */
         DC CL8'IGGPUALL'
*   END;                            /* END OF INNER PROCEDURE        */
@EL00003 DS    0H                                                  0355
@EF00003 DS    0H                                                  0355
@ER00003 BR    @14                                                 0355
@PB00003 DS    0H                                                  0356
*   GEN(EJECT);                     /* GO TO A NEW PRINT PAGE        */
         EJECT
*                                                                  0357
*/********************************************************************/
*/*                                                                  */
*/*        IGGPUALL  -  PROCEDURE  INTERNALLY  CALLED  NESTED        */
*/*                                                                  */
*/********************************************************************/
*                                                                  0357
*IGGPUALL:                                                         0357
*   PROC OPTIONS(NOSAVEAREA,NOSAVE);/* SPECIFY PROCEDURE OPTIONS     */
         B     @PB00004                                            0357
IGGPUALL DS    0H                                                  0358
*Z024:                              /* LABEL FOR PROCEDURE TRACKING  */
*Z024UALL:                          /* LABEL FOR PROCEDURE TRACKING  */
*   RFY                                                            0358
*    (R5,                                                          0358
*     R6,                                                          0358
*     R7,                                                          0358
*     R8,                                                          0358
*     R9,                                                          0358
*     R10) UNRSTD;                  /* PL/S COMPILER WORK REGISTERS  */
Z024     DS    0H                                                  0358
Z024UALL DS    0H                                                  0359
*   RFY                                                            0359
*    (R2,                                                          0359
*     R3,                                                          0359
*     R4) RSTD;                     /* RESTRICT LOCAL WORK REGISTERS */
*   GEN(STM 12,14,12(13));          /* SAVE REGISTERS OF CALLER      */
         STM 12,14,12(13)
*   GEN(LA 13,12(13));              /* POINT TO NEXT SAVE AREA     0361
*                                      PROCEDURE                     */
         LA 13,12(13)
*/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
**   MODULE NAME =  IGGPUALL (IGG0CLBB)                               *
**                                                                    *
**   DESCRIPTIVE NAME =  UNIQUE DATA SET ALLOCATION                   *
**                                                                    *
**   FUNCTION =                                                       *
**      THIS SUB-FUNCTION INTERFACES WITH IGGPSPAC (IGG0CLBP) TO      *
**      OBTAIN MORE EXTENTS FROM DADSM FOR A NEW UNIQUE DATA SPACE OR *
**      AN EXISTING UNIQUE DATA SPACE.  THE PROCESSING IS AS FOLLOWS: *
**      1. BUILD IGGPSPAC PARAMETER LIST FOR A UNIQUE DATA SET.       *
**      2. READ ASSOCIATED VOLUME ENTRY INTO RECORD AREA 3.           *
**      3. CALL IGGPSPAC.                                             *
**      IGGPSPAC WILL RETURN THE NEWLY ACQUIRED EXTENTS IN THE DADSM  *
**      EXTENTS SAVE AREA OF THE CCA (THE SAME AS VSAM SUB-ALLOCATE   *
**      (IGG0CLAR) DOES).                                             *
**                                                                    *
**   INPUT =                                                          *
**      RECORD AREAS 3,4, AND 5 AVAILABLE FOR USE (CCARBUR OFF).      *
**      BASE CATALOG RECORD OF THE DATA SET BEING EXTENDED IN RAB 1.  *
**         CSORT - ALLOCATION UNIT.                                   *
**         CNAME - DATA SET NAME.                                     *
**         CREUSE - REUSE FLAG.                               @Y30SSRS*
**         CPRIM - PRIMARY ALLOCATION QUANTITY.                       *
**         CSEC - SECONDARY ALLOCATION QUANTITY.                      *
**      UPREPARM PARAMETERS:                                          *
**         UPEXTLN - LENGTH OF OLD VOLUME OCCURRENCE EXTENTS.         *
**         UPNIEXT - NO. OF INDEX EXTENTS OR ZERO IF NOT SEQ. SET     *
**                   WITH DATA.                               @XA02392*
**      UPENTVOL PARAMETERS:                                          *
**         UPVOL - VOLUME SERIAL.                                     *
**         UPPHYB - PHYSICAL BLOCK SIZE.                              *
**         UPSSDS - DATA SET DIRECTORY SEQUENCE NO.                   *
**                                                                    *
**   OUTPUT =                                                         *
**      VOLUME ENTRY IN RECORD AREA 3.                                *
**      CCA EXTRACT/MODIFY INTERFACE FLAGS AND ADDRESSES CHANGED.     *
**      CCADESA - DADSM EXTENTS SAVE AREA.                            *
**         CCANDEXT - NUMBER OF NEW EXTENTS OBTAINED FOR UNIQUE DATA  *
**                    SET.                                            *
**         CCAEXTDE(*) - ARRAY OF EXTENT DESCRIPTORS INITIALIZED.     *
**            CCAEXTSS - DESCRIPTOR SPACE SEQUENCE NO.                *
**            CCAEXTAD - EXTENT STARTING CCHH.                        *
**            CCAEXTTH - NUMBER OF TRACKS IN EXTENT.                  *
**      UPREPARM PARAMETERS:                                          *
**         UPSMFL - SET ON, TO INDICATE LSPACE SMF RECORD 69 SHOULD   *
**                  BE WRITTEN.                                       *
**      CCACD1 - RCS, NO ERROR.                                       *
**             - RCNOSP, NO SPACE USER VOLUME.                        *
**             - RCDSEXT, DATA SET HAS MAXIMUM NO. OF EXTENTS.        *
**             - ANY ERROR RETURNED FROM IGGPSPAC.                    *
**      NEW DATA SPACE CREATED OR OLD DATA SPACE EXTENDED.            *
**                                                                    *
**                                                                    *
** * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
*                                                                  0362
*   DCL                                                            0362
*     MXVOLEXT FIXED(31) CONSTANT(16);/* MAX UNIQUE EXTENTS/VOL      */
*   UPSPARM=UPSPARM&&UPSPARM;       /* ZERO SPACE WORK AREA          */
         L     @10,CCAR3REC(,R11)                                  0363
         SL    @10,@CF00544                                        0363
         XC    UPSPARM(220,@10),UPSPARM(@10)                       0363
*   UPSOPT=CSORT;                   /* SPACE OPTIONS                 */
         L     @05,CCARABB(,R11)                                   0364
         L     @05,CCACPE1(,@05)                                   0364
         MVC   UPSOPT(1,@10),CSORT(@05)                            0364
*   UPSUNIQ=ON;                     /* UNIQUE DATA SET               */
         OI    UPSUNIQ(@10),B'10000000'                            0365
*   UPUDSNPT=ADDR(CNAME);           /* UNIQUE DATA SET NAME          */
         LA    @15,CNAME(,@05)                                     0366
         ST    @15,UPUDSNPT(,@10)                                  0366
*   UPMXBLK=UPPHYB;                 /* BLOCKSIZE                     */
         L     @15,CCAR2REC(,R11)                                  0367
         LA    @14,18                                              0367
         ALR   @14,@15                                             0367
         MVC   UPMXBLK(2,@10),UPPHYB+2(@14)                        0367
*   UPSECQTY=CSEC;                  /* SECONDARY ALLOC       @ZA07574*/
         MVC   UPSECQTY(3,@10),CSEC(@05)                           0368
*   UPDSDIR=UPSSDS;                 /* DATA SET DIRECTORY SEQ. NO.   */
         ICM   @14,12,UPSSDS(@14)                                  0369
         SRA   @14,16                                              0369
         STCM  @14,7,UPDSDIR(@10)                                  0369
*   IF UPEXTLN=0 THEN               /* IF NEW VOLUME                 */
         LH    @15,UPEXTLN(,@15)                                   0370
         LTR   @15,@15                                             0370
         BNZ   @RF00370                                            0370
*     UPSPQTY=CPRIM;                /* USE PRIMARY ALLOCATION        */
         MVC   UPSPQTY(3,@10),CPRIM(@05)                           0371
*   ELSE                            /* OLD VOLUME WITH EXTENTS       */
*     IF CSEC=0 THEN                /* IF NO SECONDARY QUANTITY      */
*                                                                  0372
         B     @RC00370                                            0372
@RF00370 L     @10,CCARABB(,R11)                                   0372
         L     @10,CCACPE1(,@10)                                   0372
         L     @10,CSEC-1(,@10)                                    0372
         LA    @10,0(,@10)                                         0372
         LTR   @10,@10                                             0372
         BNZ   @RF00372                                            0372
*       /*************************************************************/
*       /*                                                           */
*       /* SET CCAMODID='BB', CCAREASN=RSN4, CCARETRN=RCNOSP         */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0373
*       CCAPROB=IGGSEGID+(RSN4*K256)+RCNOSP;/* INDICATE NO SPACE   0373
*                                                            @Y30SSRS*/
         MVC   CCAPROB(4,R11),@CF03389                             0373
*     ELSE                          /* USE SECONDARY QUANTITY        */
*       UPSPQTY=CSEC;               /* SET QUANTITY                  */
         B     @RC00372                                            0374
@RF00372 L     @10,CCAR3REC(,R11)                                  0374
         L     @05,CCARABB(,R11)                                   0374
         L     @05,CCACPE1(,@05)                                   0374
         AL    @10,@CF03422                                        0374
         MVC   UPSPQTY-1(3,@10),CSEC(@05)                          0374
*   IF UPNOEXT>=MXVOLEXT THEN       /* IF MAX EXTENTS ON VOLUME      */
*                                                                  0375
@RC00372 DS    0H                                                  0375
@RC00370 L     @10,CCAR2REC(,R11)                                  0375
         CLI   UPNOEXT+18(@10),16                                  0375
         BL    @RF00375                                            0375
*     /***************************************************************/
*     /*                                                             */
*     /* SET CCAMODID='BB', CCAREASN=RSN8, CCARETRN=RCNOSP           */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0376
*     CCAPROB=IGGSEGID+(RSN8*K256)+RCNOSP;/* INDICATE NO SPACE     0376
*                                                            @Y30SSRS*/
         MVC   CCAPROB(4,R11),@CF03392                             0376
*   ELSE                                                           0377
*     ;                             /* MAX EXTENTS NOT REACHED       */
@RF00375 DS    0H                                                  0378
*   IF MAX(AMDNEXT,UPNIEXT)>MXEXT-MXALEX/* IF D S MAX EXTS   @Y30SSRS*/
*     THEN                          /* REACHED               @Y30SSRS*/
*                                                                  0378
         L     @10,CCAR2REC(,R11)                                  0378
         LA    @05,UPREND(,@10)                                    0378
         LH    @05,AMDNEXT+176(,@05)                               0378
         LH    @10,UPNIEXT(,@10)                                   0378
         CR    @05,@10                                             0378
         BNL   *+6
         LR    @05,@10                                             0378
         C     @05,@CF00655                                        0378
         BNH   @RF00378                                            0378
*     /***************************************************************/
*     /*                                                             */
*     /* SET CCAMODID='BB', CCAREASN=RSN0, CCARETRN=RCDSEXT          */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0379
*     CCAPROB=IGGSEGID+(RSN0*K256)+RCDSEXT;/* SET ERROR CODE @Y30SSRS*/
         MVC   CCAPROB(4,R11),@CF03393                             0379
*   ELSE                                                           0380
*     ;                             /* EXTENTS CAN BE ADDED TO DATA
*                                      SET                           */
@RF00378 DS    0H                                                  0381
*   IF CCACD1=RCS THEN              /* IF NO PREVIOUS ERRORS         */
         CLI   CCACD1(R11),0                                       0381
         BNE   @RF00381                                            0381
*     DO;                           /* CALL DADSM FOR SPACE          */
*       CCASRCH=CCASRCH&&CCASRCH;   /* ZERO SEARCH ARG               */
         XC    CCASRCH(44,R11),CCASRCH(R11)                        0383
*       CCASRCH(1:LENGTH(UPVOL))=UPVOL;/* SET VOLSER                 */
         L     @10,CCAR2REC(,R11)                                  0384
         MVC   CCASRCH(6,R11),UPVOL+18(@10)                        0384
*       DO;                                                        0385
*         CCAF1KEY=ON;              /* TRUE NAME GET                 */
*         CCAF1KGE=OFF;             /* NOT GET NEXT                  */
*         CCAF1UP=ON;               /* GET FOR UPD                   */
         OI    CCAF1KEY(R11),B'00010010'                           0388
         NI    CCAF1KGE(R11),B'11110111'                           0388
*         CCAURAB=ADDR(CCARAB3);    /* SET RAB PTR                   */
*                                                                  0389
         LA    @10,CCARAB3(,R11)                                   0389
         ST    @10,CCAURAB(,R11)                                   0389
*         /***********************************************************/
*         /*                                                         */
*         /* CALL TO MODULE IGG0CLBI                                 */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0390
*Z029GET:                                                          0390
*         CALL IGGPGET;             /* GET RECORD                    */
Z029GET  L     @15,@CV00036                                        0390
         BALR  @14,@15                                             0390
*       END;                        /* GET VOLUME ENTRY FOR DADSM  0391
*                                      SPACE CALL                    */
*       IF CCACD1=RCS THEN          /* IF NO PREVIOUS ERROR          */
         CLI   CCACD1(R11),0                                       0392
         BNE   @RF00392                                            0392
*         DO;                       /* CALL DADSM                    */
*                                                                  0393
*           /*********************************************************/
*           /*                                                       */
*           /* CALL TO MODULE IGG0CLBP                               */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0394
*Z030SPAC:                                                         0394
*           CALL IGGPSPAC;          /* GET SPACE FROM DADSM          */
Z030SPAC L     @15,@CV00042                                        0394
         BALR  @14,@15                                             0394
*           UPSMFL=ON;              /* INDICATE LSPACE SMF           */
         L     @10,CCAR2REC(,R11)                                  0395
         OI    UPSMFL(@10),B'00000100'                             0395
*         END;                      /* END CALL DADSM                */
*       ELSE                        /* PREVIOUS ERROR                */
*         IF CCACD1=RCENT THEN      /* IF VOL ENTRY NOT FOUND        */
*                                                                  0397
         B     @RC00392                                            0397
@RF00392 CLI   CCACD1(R11),8                                       0397
         BNE   @RF00397                                            0397
*           /*********************************************************/
*           /*                                                       */
*           /* SET CCAMODID='BB', CCAREASN=RSN0, CCARETRN=RCVOLENT   */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0398
*           CCAPROB=IGGSEGID+(RSN0*K256)+RCVOLENT;/* SET ERROR CODE
*                                                            @Y30SSRS*/
         MVC   CCAPROB(4,R11),@CF03394                             0398
*         ELSE                                                     0399
*           ;                       /* NO ERROR CODE TRANSLATION     */
@RF00397 DS    0H                                                  0400
*     END;                          /* END CALL                      */
*   ELSE                                                           0401
*     ;                             /* PREVIOUS ERROR                */
@RF00381 DS    0H                                                  0402
*   CALL EXIT;                      /* RETURN TO CALLER              */
@RC00381 BAL   @14,EXIT                                            0402
*   GEN(DS 0F);                     /* FULLWORD BOUNDARY ALIGNMENT   */
         DS 0F
*   GEN(DC CL8'IGGPCSAL');          /* NAME OF FOLLOWING PROCEDURE   */
         DC CL8'IGGPCSAL'
*   END;                            /* END OF INNER PROCEDURE        */
@EL00004 DS    0H                                                  0405
@EF00004 DS    0H                                                  0405
@ER00004 BR    @14                                                 0405
@PB00004 DS    0H                                                  0406
*   GEN(EJECT);                     /* GO TO A NEW PRINT PAGE        */
         EJECT
*                                                                  0407
*/********************************************************************/
*/*                                                                  */
*/*        IGGPCSAL  -  PROCEDURE  INTERNALLY  CALLED  NESTED        */
*/*                                                                  */
*/********************************************************************/
*                                                                  0407
*IGGPCSAL:                                                         0407
*   PROC OPTIONS(NOSAVEAREA,NOSAVE);/* SPECIFY PROCEDURE OPTIONS     */
         B     @PB00005                                            0407
IGGPCSAL DS    0H                                                  0408
*Z032:                              /* LABEL FOR PROCEDURE TRACKING  */
*Z032CSAL:                          /* LABEL FOR PROCEDURE TRACKING  */
*   RFY                                                            0408
*    (R5,                                                          0408
*     R6,                                                          0408
*     R7,                                                          0408
*     R8,                                                          0408
*     R9,                                                          0408
*     R10) UNRSTD;                  /* PL/S COMPILER WORK REGISTERS  */
Z032     DS    0H                                                  0408
Z032CSAL DS    0H                                                  0409
*   RFY                                                            0409
*    (R2,                                                          0409
*     R3,                                                          0409
*     R4) RSTD;                     /* RESTRICT LOCAL WORK REGISTERS */
*   GEN(STM 12,14,12(13));          /* SAVE REGISTERS OF CALLER      */
         STM 12,14,12(13)
*   GEN(LA 13,12(13));              /* POINT TO NEXT SAVE AREA     0411
*                                      PROCEDURE                     */
         LA 13,12(13)
*/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
**   MODULE NAME =  IGGPCSAL (IGG0CLBB)                               *
**                                                                    *
**   DESCRIPTIVE NAME =  CALL SUBALLOCATE                             *
**                                                                    *
**   FUNCTION =                                                       *
**      THIS SUB-FUNCTION INTERFACES WITH VSAM SUB-ALLOCATE (IGGPSALL)*
**      TO OBTAIN MORE EXTENTS FOR A VSAM DATA SET.  IF SUB-ALLOCATE  *
**      INDICATES THAT THERE IS NO MORE VSAM DATA SPACE TO SUB-       *
**      ALLOCATE ADDITIONAL EXTENTS FROM FOR THIS DATA SET, AN EXIST- *
**      ING VSAM DATA SPACE IS EXTENDED OR A NEW ONE IS CREATED, AND  *
**      SUB-ALLOCATION IS RE-TRIED.  THE PROCESSING IS AS FOLLOWS:    *
**      1. BUILD SUB-ALLOCATE PARAMETER LIST.                         *
**      2. CALL IGGPSALL (IGG0CLAR) TO OBTAIN SPACE FOR A VSAM DATA   *
**         SET ON A PARTICULAR VOLUME.                                *
**      3. IF SUB-ALLOCATE INDICATES THERE IS NO VSAM DATA SPACE TO   *
**         SUB-ALLOCATE FROM, THEN CALL IGGPSPAC (IGG0CLBP) TO OBTAIN *
**         MORE VSAM DATA SPACE AND CALL IGGPSALL ONCE MORE.          *
**      4. FREE SUB-ALLOCATE WORK CORE AND EXIT WITH THE NEW DATA SET *
**         EXTENTS SET INTO THE CCA.                                  *
**                                                                    *
**   INPUT =                                                          *
**      RECORD AREAS 3,4, AND 5 AVAILABLE FOR USE (CCARBUR OFF)       *
**      BASE CATALOG RECORD IN RAB 1:                                 *
**         CSORT - ALLOCATION UNIT.                                   *
**         CNAME - DATA SET NAME.                                     *
**         CPRIM - PRIMARY ALLOCATION QUANTITY.                       *
**         CSEC  - SECONDARY ALLOCATION QUANTITY.                     *
**         RCDCINO - CONTROL INTERVAL NUMBER.                         *
**      UPREPARM PARAMETERS:                                          *
**         UPEXTLN - LENGTH OF OLD VOLUME OCCURRENCE EXTENTS.         *
**         UPNIEXT - NO. OF INDEX EXTENTS OR ZERO IF NOT SEQ. SET     *
**                   WITH DATA.                               @XA02392*
**      UPENTVOL PARAMETERS:                                          *
**         UPVOL - VOLUME SERIAL                                      *
**         UPPHYB - PHYSICAL BLOCK SIZE.                              *
**         UPSSDS - DATA SET DIRECTORY SEQUENCE NO.                   *
**         UPNTKA - TRACKS/CONTROL AREA.                              *
**      AMDSB PARAMETERS:                                             *
**         AMDNEXT - NUMBER OF OLD DATA SET EXTENTS.                  *
**                                                                    *
**   OUTPUT =                                                         *
**      VOLUME ENTRY IN RAB 3.                                        *
**      CCA EXTRACT/MODIFY INTERFACE FLAGS/ADDRESSES CHANGED.         *
**      CCADESA - DADSM EXTENTS SAVE AREA.                            *
**         CCANDEXT - NUMBER OF NEW EXTENTS OBTAINED FOR VSAM DATA SET*
**         CCAEXTDE(*) - ARRAY OF EXTENT DESCRIPTORS INITIALIZED.     *
**            CCAEXTSS - DESCRIPTOR SPACE SEQUENCE NO.                *
**            CCAEXTAD - EXTENT STARTING CCHH.                        *
**            CCAEXTTH - NUMBER OF TRACKS IN EXTENT.                  *
**      UPREPARM PARAMETERS:                                          *
**         UPSMFL - SET ON, TO INDICATE LSPACE SMF RECORD 69 SHOULD   *
**                  BE WRITTEN, IF IGGPSPAC WAS CALLED.               *
**      CCACD1 - RCS, NO ERROR.                                       *
**             - RCNOSP, NO SPACE USER VOLUME.                        *
**             - RCDSEXT, DATA SET HAS MAXIMUM NO. OF EXTENTS.        *
**             - ANY ERROR CODE RETURNED FROM IGGPSPAC.               *
**      NEW DATA SPACE CREATED OR OLD DATA SPACE EXTENDED IF IGGPSPAC *
**      CALLED.                                                       *
**                                                                    *
**                                                                    *
** * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
*                                                                  0412
*   DCL                                                            0412
*     CLSCI FIXED(31) CONSTANT(2);  /* CLUSTER CI NO         @Y30SSRS*/
*   DCL                                                            0413
*     CATVOLCI FIXED(31) CONSTANT(9);/* CATALOG VOL CI NO    @Y30SSRS*/
*   DCL                                                            0414
*     IDXCI FIXED(31) CONSTANT(1);  /* INDEX CI NO           @Y30SSRS*/
*   RFY                                                            0415
*     R1 RSTD;                      /* GETMAIN REG                   */
*   R2=LENGTH(SALPARL)+LENGTH(PRLIST)/* SET LENGTH OF WORK AREA      */
*       +LENGTH(PRLENT)*PRENTNO     /* CORE REQUIRED FOR             */
*       +LENGTH(USERLIST)+          /* SUBALLOCATE                   */
*       LENGTH(LTENTRY)*NOVOLENT;                                  0416
         LA    R2,525                                              0416
*   CCAMNLEN=R2;                    /* LENGTH CORE                   */
         STCM  R2,7,CCAMNLEN(R11)                                  0417
*   R1=ADDR(CCAMSSPL);              /* POINT TO STRG MGMT P.L.       */
         LA    R1,CCAMSSPL(,R11)                                   0418
*   CCAMNSPL=USUBPOOL;              /* STORE SUBPOOL VALUE           */
*                                                                  0419
         MVI   CCAMNSPL(R11),X'FC'                                 0419
*   /*****************************************************************/
*   /*                                                               */
*   /* ALLOCATE MAIN STORAGE FROM USER SUBPOOL 252                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0420
*   GEN(GETMAIN LC,MF=(E,(1)));     /* GET MAIN STORAGE SPACE        */
         GETMAIN LC,MF=(E,(1))
*   GEN(LR R1,R15);                 /* PICK UP RETURN CODE           */
         LR R1,R15
*   IF R1^=NOGETMSE THEN            /* CHECK FOR ERROR RETURN        */
*                                                                  0422
         LTR   R1,R1                                               0422
         BZ    @RF00422                                            0422
*     /***************************************************************/
*     /*                                                             */
*     /* SET CCAMODID='BB', CCAREASN=RSN2, CCARETRN=RCINSSWA         */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0423
*     CCAPROB=IGGSEGID+(RSN2*K256)+RCINSSWA;/* INSUFFICIENT CORE   0423
*                                      ERROR                         */
         MVC   CCAPROB(4,R11),@CF03400                             0423
*   ELSE                            /* GETMAIN SUCCESSFUL            */
*     DO;                                                          0424
         B     @RC00422                                            0424
@RF00422 DS    0H                                                  0425
*       DO;                                                        0425
*         IF MNATFULL=ON THEN       /* TRACKING TABLE FULL           */
*                                                                  0426
         TM    MNATFULL(R11),B'10000000'                           0426
         BNO   @RF00426                                            0426
*           /*********************************************************/
*           /*                                                       */
*           /* CALL TO MODULE IGG0CLAT                               */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0427
*Z036ARFS:                                                         0427
*           CALL IGGPARFS;          /* YES,CALL SPILL ROUTINE        */
Z036ARFS L     @15,@CV00047                                        0427
         BALR  @14,@15                                             0427
*         GEN REFS(CCAMNAT)(MVC CCAMNAT(248,11),CCAMNAT+8(11));/*  0428
*                                      PUSH AND TRACK                */
@RF00426 DS    0H                                                  0428
         MVC CCAMNAT(248,11),CCAMNAT+8(11)
*       END;                                                       0429
*     END;                          /* GET MAIN STORAGE              */
*   RFY                                                            0431
*     R1 UNRSTD;                    /* FREE REG                      */
@RC00422 DS    0H                                                  0432
*   IF CCACD1^=RCS THEN                                            0432
         CLI   CCACD1(R11),0                                       0432
         BNE   @RT00432                                            0432
*     ;                             /* ERROR                         */
*   ELSE                            /* NO GETMAIN ERROR              */
*     DO;                           /* SET UP FOR SUBALLOCATE        */
*       CCAALPTR=CCAMNADR;          /* SET SUBALLOC REQ PL ADDR      */
         L     @10,CCAMNADR(,R11)                                  0435
         ST    @10,CCAALPTR(,R11)                                  0435
*       RFY                                                        0436
*         CLEAR BASED(CCAALPTR);    /* MAP WORK AREA                 */
*       CLEAR(1:MXM)=CLEAR(1:MXM)&& /* CLEAR PARM LIST AREA OF       */
*           CLEAR(1:MXM);           /* SUBALLOCATE WORK AREA         */
         XC    CLEAR(256,@10),CLEAR(@10)                           0437
*       SALOPTNS=CSORT;             /* SPACE OPTIONS                 */
         L     @05,CCARABB(,R11)                                   0438
         L     @05,CCACPE1(,@05)                                   0438
         IC    @15,CSORT(,@05)                                     0438
         STC   @15,SALOPTNS(,@10)                                  0438
*       SALDSCIN=RCDCINO;           /* SET DATA SET CI NUMBER TO   0439
*                                      LOCATE DIRECTORY              */
         MVC   SALDSCIN(3,@10),RCDCINO(@05)                        0439
*       SALCALN=UPNTKA;             /* CONTROL AREA LENGTH           */
         L     @15,CCAR2REC(,R11)                                  0440
         MVC   SALCALN(2,@10),UPNTKA+18(@15)                       0440
*       IF RCDCINO<=IDXCI THEN      /* IF CATALOG OBJECT     @Y30SSRS*/
         CLC   RCDCINO(3,@05),@CF00060+1                           0441
         BH    @RF00441                                            0441
*         DO;                       /* SET REQUIRED EXTENTS          */
*           SALDSCIN=CLSCI;         /* SET CLUSTER CI NUMBER OF    0443
*                                      CATALOG DATA SET              */
*                                                                  0443
         MVC   SALDSCIN(3,@10),@CF00058+1                          0443
*           /*********************************************************/
*           /*                                                       */
*           /* SET MAXIMUM ALLOWED DATA SET EXTENTS          @XA02392*/
*           /*                                                       */
*           /*********************************************************/
*                                                                  0444
*           SALMXEXT=MIN(MXALEX,MXEXTC-AMDNEXT,MXEXTC-UPNIEXT);    0444
         LA    @05,16                                              0444
         LA    @14,UPREND(,@15)                                    0444
         LR    @09,@05                                             0444
         SH    @09,AMDNEXT+176(,@14)                               0444
         LA    @08,5                                               0444
         CR    @09,@08                                             0444
         BNH   *+6
         LR    @09,@08                                             0444
         SH    @05,UPNIEXT(,@15)                                   0444
         CR    @09,@05                                             0444
         BNH   *+6
         LR    @09,@05                                             0444
         STC   @09,SALMXEXT(,@10)                                  0444
*           IF CCARAEOV=OFF THEN    /* IS THIS A CRA VOL     @OZ05921*/
         TM    CCARAEOV(R11),B'01000000'                           0445
         BNZ   @RF00445                                            0445
*             DO;                   /* NO,GET NEW RECORD     @OZ05921*/
*               CCASRID=CATVOLCI;   /* SET CATALOG VOL       @Y30SSRS
*                                      CI NO.                @Y30SSRS*/
         MVC   CCASRID(3,R11),@CF02759+1                           0447
*               CCAURAB=ADDR(CCARAB3);/* RCD AREA FOR I/O    @Y30SSRS*/
         LA    @10,CCARAB3(,R11)                                   0448
         ST    @10,CCAURAB(,R11)                                   0448
*               DO;                                                0449
*                 CCAF1KEY=OFF;     /* GET BY CI NO.                 */
*                 CCAF1KGE=OFF;     /* NOT GET NEXT                  */
*                 CCAF1UP=ON;       /* GET FOR UPD                   */
*                                                                  0452
         OI    CCAF1UP(R11),B'00000010'                            0452
         NI    CCAF1KEY(R11),B'11100111'                           0452
*                 /***************************************************/
*                 /*                                                 */
*                 /* CALL TO MODULE IGG0CLBI                         */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0453
*Z038GET:                                                          0453
*                 CALL IGGPGET;     /* GET RECORD                    */
Z038GET  L     @15,@CV00036                                        0453
         BALR  @14,@15                                             0453
*               END;                /* READ VOL ENTRY        @Y30SSRS*/
*               IF CCACD1=RCS THEN                                 0455
         CLI   CCACD1(R11),0                                       0455
         BE    @RT00455                                            0455
*                 ;                 /* IF NO ERROR           @Y30SSRS*/
*               ELSE                /* ERROR                 @Y30SSRS*/
*                 IF CCACD1=RCENT THEN/* IF VOL ENTRY NOT    @Y30SSRS
*                                      FOUND                 @Y30SSRS*/
*                                                                  0457
         CLI   CCACD1(R11),8                                       0457
         BNE   @RF00457                                            0457
*                   /*************************************************/
*                   /*                                               */
*                   /* SET CCAMODID='BB', CCAREASN=RSN0,             */
*                   /* CCARETRN=RCVOLENT                             */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0458
*                   CCAPROB=IGGSEGID+(RSN0*K256)+RCVOLENT;/* SET ERR
*                                      CODE                  @Y30SSRS*/
         MVC   CCAPROB(4,R11),@CF03394                             0458
*                 ELSE                                             0459
*                   ;               /* NO ERROR CODE         @Y30SSRS
*                                      TRANSLATION           @Y30SSRS*/
@RF00457 DS    0H                                                  0460
*               SALSOURC=SARABS;    /* VOL ENTRY IN-CORE     @Y30SSRS*/
@RT00455 L     @10,CCAALPTR(,R11)                                  0460
         MVI   SALSOURC(@10),X'01'                                 0460
*             END;                  /*                       @OZ05921*/
*           ELSE                    /* THIS IS CRA VOL       @OZ05921*/
*             SALSOURC=SAVRLIST;    /* FIRST VER NOT         @OZ05921
*                                      IN RAB'S              @OZ05921*/
         B     @RC00445                                            0462
@RF00445 L     @10,CCAALPTR(,R11)                                  0462
         MVI   SALSOURC(@10),X'02'                                 0462
*         END;                      /* END SET REQUIRED              */
*       ELSE                        /* NON-CATALOG OBJECT            */
*         DO;                       /* SET MAX EXTENTS       @Y30SSRS*/
*                                                                  0464
         B     @RC00441                                            0464
@RF00441 DS    0H                                                  0465
*           /*********************************************************/
*           /*                                                       */
*           /* SET MAXIMUM ALLOWED DATA SET EXTENTS          @XA02392*/
*           /*                                                       */
*           /*********************************************************/
*                                                                  0465
*           SALMXEXT=MIN(MXALEX,MXEXT-AMDNEXT,MXEXT-UPNIEXT);      0465
         L     @10,CCAALPTR(,R11)                                  0465
         LA    @05,123                                             0465
         L     @15,CCAR2REC(,R11)                                  0465
         LA    @14,UPREND(,@15)                                    0465
         LR    @09,@05                                             0465
         SH    @09,AMDNEXT+176(,@14)                               0465
         LA    @08,5                                               0465
         CR    @09,@08                                             0465
         BNH   *+6
         LR    @09,@08                                             0465
         SH    @05,UPNIEXT(,@15)                                   0465
         CR    @09,@05                                             0465
         BNH   *+6
         LR    @09,@05                                             0465
         STC   @09,SALMXEXT(,@10)                                  0465
*           IF CREUSE=ON&SALMXEXT>0 THEN/* IF REUSE D.S.     @Y30SSRS
*                                      & MAX EXTS NOT Z      @Y30SSRS*/
         L     @05,CCARABB(,R11)                                   0466
         L     @05,CCACPE1(,@05)                                   0466
         TM    CREUSE(@05),B'00100000'                             0466
         BNO   @RF00466                                            0466
         CLI   SALMXEXT(@10),0                                     0466
         BNH   @RF00466                                            0466
*             IF MXVOLEXT-UPNOEXT>0 THEN/* IF VOL HOLD EXTS  @Y30SSRS*/
         LA    @05,16                                              0467
         SLR   @14,@14                                             0467
         IC    @14,UPNOEXT+18(,@15)                                0467
         SLR   @05,@14                                             0467
         LTR   @05,@05                                             0467
         BNP   @RF00467                                            0467
*               SALMXEXT=MIN(SALMXEXT,MXVOLEXT-UPNOEXT);/* SET MAX 0468
*                                                            @Y30SSRS*/
         CR    @09,@05                                             0468
         BNH   *+6
         LR    @09,@05                                             0468
         STC   @09,SALMXEXT(,@10)                                  0468
*             ELSE                  /* VOL NOT HOLD EXTS     @Y30SSRS*/
*                                                                  0469
*               /*****************************************************/
*               /*                                                   */
*               /* SET CCAMODID='BB', CCAREASN=RSN12, CCARETRN=RCNOSP*/
*               /*                                                   */
*               /*****************************************************/
*                                                                  0469
*               CCAPROB=IGGSEGID+(RSN12*K256)+RCNOSP;/* ERROR      0469
*                                                            @Y30SSRS*/
         B     @RC00467                                            0469
@RF00467 MVC   CCAPROB(4,R11),@CF03403                             0469
*           ELSE                                                   0470
*             ;                     /* NOT REUSE DAT SET     @Y30SSRS*/
@RF00466 DS    0H                                                  0471
*           SALSOURC=SAVRLIST;      /* VOL ENTRY MUST        @Y30SSRS
*                                      BE READ INTO CORE     @Y30SSRS*/
@RC00466 L     @10,CCAALPTR(,R11)                                  0471
         MVI   SALSOURC(@10),X'02'                                 0471
*         END;                      /* END SET               #Y30SSRS*/
*       SALRLIST=CCAALPTR+LENGTH(SALPARL);/* POINT RESPONSE LIST     */
@RC00441 L     @10,CCAALPTR(,R11)                                  0473
         LA    @05,512                                             0473
         ALR   @05,@10                                             0473
         STCM  @05,15,SALRLIST(@10)                                0473
*       PRLLN=PRENTNO;              /* SET NO. RESPONSE ELTS         */
         MVI   PRLLN(@05),X'01'                                    0474
*       SALVLIST=SALRLIST+LENGTH(PRLIST)/* SET ADDR USER LIST        */
*           +LENGTH(PRLENT)*PRENTNO;                               0475
         AL    @05,@CF00075                                        0475
         STCM  @05,15,SALVLIST(@10)                                0475
*       RFY                                                        0476
*         USERLIST BASED(SALVLIST); /* MAP USER LIST                 */
*       LTLENGTH=LENGTH(LTENTRY)*NOVOLENT;/* SET LENGTH OF USER    0477
*                                      VOLUME LIST                   */
         MVC   LTLENGTH(2,@05),@CH00055                            0477
*       LTRETCOD(NOVOLENT)=0;       /* INITLZ RETURN CODE            */
         SLR   @15,@15                                             0478
         STH   @15,LTRETCOD(,@05)                                  0478
*       LTVOLSER(NOVOLENT)=UPVOL;   /* SET VOLSER                    */
         L     @14,CCAR2REC(,R11)                                  0479
         MVC   LTVOLSER(6,@05),UPVOL+18(@14)                       0479
*       IF UPEXTLN=0 THEN           /* IF NEW VOLUME                 */
         CH    @15,UPEXTLN(,@14)                                   0480
         BNE   @RF00480                                            0480
*         SALUNITS=CPRIM;           /* USE PRIMARY ALLOCATION        */
         L     @05,CCARABB(,R11)                                   0481
         L     @05,CCACPE1(,@05)                                   0481
         MVC   SALUNITS(2,@10),CPRIM+1(@05)                        0481
*       ELSE                        /* OLD VOLUME WITH EXTENTS       */
*         IF CSEC=0 THEN            /* IF NO SECONDARY QUANTITY      */
*                                                                  0482
         B     @RC00480                                            0482
@RF00480 L     @10,CCARABB(,R11)                                   0482
         L     @10,CCACPE1(,@10)                                   0482
         L     @10,CSEC-1(,@10)                                    0482
         LA    @10,0(,@10)                                         0482
         LTR   @10,@10                                             0482
         BNZ   @RF00482                                            0482
*           /*********************************************************/
*           /*                                                       */
*           /* SET CCAMODID='BB', CCAREASN=RSN4, CCARETRN=RCNOSP     */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0483
*           CCAPROB=IGGSEGID+(RSN4*K256)+RCNOSP;/* INDICATE NO SPACE
*                                                            @Y30SSRS*/
         MVC   CCAPROB(4,R11),@CF03389                             0483
*         ELSE                      /* USE SECONDARY QUANTITY        */
*           SALUNITS=CSEC;          /* SET QUANTITY                  */
         B     @RC00482                                            0484
@RF00482 L     @10,CCAALPTR(,R11)                                  0484
         L     @05,CCARABB(,R11)                                   0484
         L     @05,CCACPE1(,@05)                                   0484
         MVC   SALUNITS(2,@10),CSEC+1(@05)                         0484
*       IF SALMXEXT>0&CCACD1=RCS THEN/* IF SPACE CAN BE GOTTEN     0485
*                                                            @ZA00749*/
@RC00482 DS    0H                                                  0485
@RC00480 L     @10,CCAALPTR(,R11)                                  0485
         CLI   SALMXEXT(@10),0                                     0485
         BNH   @RF00485                                            0485
         CLI   CCACD1(R11),0                                       0485
         BNE   @RF00485                                            0485
*         DO;                       /* GET SPACE                     */
*                                                                  0486
*           /*********************************************************/
*           /*                                                       */
*           /* CALL TO MODULE IGG0CLAR                               */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0487
*Z042SALL:                                                         0487
*           CALL IGGPSALL;          /* CALL SUB-ALLOCATE             */
Z042SALL L     @15,@CV00040                                        0487
         BALR  @14,@15                                             0487
*           IF CCACD1=RCNOSPSA THEN /* IF NO SPACE                   */
         CLI   CCACD1(R11),156                                     0488
         BNE   @RF00488                                            0488
*             DO;                   /* CALL DADSM FOR SPACE          */
*                                                                  0489
*               /*****************************************************/
*               /*                                                   */
*               /* CLEAR CCAMODID, CCAREASN, AND CCARETRN            */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0490
*               CCAPROB=IGNOREIT;   /* CLEAR ERROR CODE      @Y30SSRS*/
         SLR   @10,@10                                             0490
         ST    @10,CCAPROB(,R11)                                   0490
*               UPSPARM=UPSPARM&&UPSPARM;/* ZERO SPACE WORK AREA     */
         L     @10,CCAR3REC(,R11)                                  0491
         SL    @10,@CF00544                                        0491
         XC    UPSPARM(220,@10),UPSPARM(@10)                       0491
*               UPSOPT=CSORT;       /* SET SPACE OPTIONS             */
         L     @05,CCARABB(,R11)                                   0492
         L     @05,CCACPE1(,@05)                                   0492
         MVC   UPSOPT(1,@10),CSORT(@05)                            0492
*               UPSPQTY=SALUNITS;   /* SPACE QUANTITY                */
         L     @05,CCAALPTR(,R11)                                  0493
         ICM   @05,12,SALUNITS(@05)                                0493
         SRA   @05,16                                              0493
         STCM  @05,7,UPSPQTY(@10)                                  0493
*               RFY                                                0494
*                 CCARAB BASED(ADDR(CCARAB3));/* MAP VOL RAB         */
*               UPMXBLK=MIN(MAXBLK,CTVMXBLK);/* SET MAX BLOCK SIZE   */
         L     @05,CCACPE1+148(,R11)                               0495
         ICM   @15,15,CTVMXBLK+48(@05)                             0495
         L     @05,@CF00049                                        0495
         CR    @15,@05                                             0495
         BNH   *+6
         LR    @15,@05                                             0495
         STH   @15,UPMXBLK(,@10)                                   0495
*               RFY                                                0496
*                 CCARAB BASED(CCARABB);/* ORIGINAL BASE FOR THIS  0496
*                                      MODULE                        */
*                                                                  0496
*               /*****************************************************/
*               /*                                                   */
*               /* CALL TO MODULE IGG0CLBP                           */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0497
*Z044SPAC:                                                         0497
*               CALL IGGPSPAC;      /* GET SPACE FROM DADSM          */
Z044SPAC L     @15,@CV00042                                        0497
         BALR  @14,@15                                             0497
*               UPSMFL=ON;          /* WRITE SMF LSPACE RCD          */
         L     @10,CCAR2REC(,R11)                                  0498
         OI    UPSMFL(@10),B'00000100'                             0498
*               IF CCACD1=RCS THEN  /* IF NO ERROR                   */
         CLI   CCACD1(R11),0                                       0499
         BNE   @RF00499                                            0499
*                 DO;               /* TRY TO GET SPACE AGAIN        */
*                   LTRETCOD(NOVOLENT)=0;/* INITLZ RETURN CODE       */
*                                                                  0501
         L     @10,CCAALPTR(,R11)                                  0501
         ICM   @05,15,SALVLIST(@10)                                0501
         SLR   @10,@10                                             0501
         STH   @10,LTRETCOD(,@05)                                  0501
*                   /*************************************************/
*                   /*                                               */
*                   /* CALL TO MODULE IGG0CLAR                       */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0502
*Z045SALL:                                                         0502
*                   CALL IGGPSALL;  /* CALL SUB-ALLOCATE             */
Z045SALL L     @15,@CV00040                                        0502
         BALR  @14,@15                                             0502
*                   IF CCACD1=RCNOSPSA THEN/* IF NO SUBALLOCATION  0503
*                                      SPACE                         */
*                                                                  0503
         CLI   CCACD1(R11),156                                     0503
         BNE   @RF00503                                            0503
*                     /***********************************************/
*                     /*                                             */
*                     /* SET CCAMODID='BB', CCAREASN=RSN6,           */
*                     /* CCARETRN=RCNOSP                             */
*                     /*                                             */
*                     /***********************************************/
*                                                                  0504
*                     CCAPROB=IGGSEGID+(RSN6*K256)+RCNOSP;/* SET ERR
*                                      CODE                  @Y30SSRS*/
         MVC   CCAPROB(4,R11),@CF03406                             0504
*                   ELSE                                           0505
*                     ;             /* NOT SUBALLOCATE SPACE ERR     */
@RF00503 DS    0H                                                  0506
*                 END;              /* END TRY                       */
*               ELSE                                               0507
*                 ;                 /* ERROR                         */
@RF00499 DS    0H                                                  0508
*             END;                  /* END CALL DADSM                */
*           ELSE                                                   0509
*             ;                     /* SPACE MAY HAVE BEEN GOTTEN    */
@RF00488 DS    0H                                                  0510
*         END;                      /* END GET SPACE                 */
*       ELSE                        /* SPACE NOT BE GOTTEN           */
*         IF CCACD1=RCS THEN        /* IF NO PREVIOUS ERROR          */
*                                                                  0511
         B     @RC00485                                            0511
@RF00485 CLI   CCACD1(R11),0                                       0511
         BNE   @RF00511                                            0511
*           /*********************************************************/
*           /*                                                       */
*           /* SET CCAMODID='BB', CCAREASN=RSN0, CCARETRN=RCDSEXT    */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0512
*           CCAPROB=IGGSEGID+(RSN0*K256)+RCDSEXT;/* DATA SET MAX EXTS
*                                                            @Y30SSRS*/
         MVC   CCAPROB(4,R11),@CF03393                             0512
*         ELSE                                                     0513
*           ;                       /* PREVIOUS ERROR                */
@RF00511 DS    0H                                                  0514
*       CCAMNLEN=LENGTH(SALPARL)+LENGTH(PRLIST)/* SET LEN OF WRK AREA*/
*           +LENGTH(PRLENT)*PRENTNO /* CORE REQUIRED FOR             */
*           +LENGTH(USERLIST)+      /* SUBALLOCATE                   */
*           LENGTH(LTENTRY)*NOVOLENT;                              0514
@RC00485 MVC   CCAMNLEN(3,R11),@CF03398+1                          0514
*       CCAMNADR=CCAALPTR;          /* SET WORK AREA ADDR            */
         L     @10,CCAALPTR(,R11)                                  0515
         ST    @10,CCAMNADR(,R11)                                  0515
*       RFY                                                        0516
*         R1 RSTD;                  /* FREEMAIN REG USE              */
*       R1=ADDR(CCAMSSPL);          /* POINT TO STRG MGMT P.L.       */
         LA    R1,CCAMSSPL(,R11)                                   0517
*       CCAMNSPL=USUBPOOL;          /* STORE SUBPOOL VALUE           */
         MVI   CCAMNSPL(R11),X'FC'                                 0518
*       DO;                                                        0519
*         IF MNATFULL=ON THEN       /* TRACKING TABLE FULL           */
*                                                                  0520
         TM    MNATFULL(R11),B'10000000'                           0520
         BNO   @RF00520                                            0520
*           /*********************************************************/
*           /*                                                       */
*           /* CALL TO MODULE IGG0CLAT                               */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0521
*Z050ARFS:                                                         0521
*           CALL IGGPARFS;          /* YES,CALL SPILL ROUTINE        */
Z050ARFS L     @15,@CV00047                                        0521
         BALR  @14,@15                                             0521
*         GEN REFS(CCAMNAT)(MVC CCAMNAT(248,11),CCAMNAT+8(11));/*  0522
*                                      PUSH AND TRACK                */
@RF00520 DS    0H                                                  0522
         MVC CCAMNAT(248,11),CCAMNAT+8(11)
*       END;                                                       0523
*                                                                  0523
*       /*************************************************************/
*       /*                                                           */
*       /* RELEASE MAIN STORAGE FROM USER SUBPOOL 252                */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0524
*       GEN(FREEMAIN L,MF=(E,(1))) ;/* FREE MAIN STORAGE             */
         FREEMAIN L,MF=(E,(1))
*       RFY                                                        0525
*         R1 UNRSTD;                /* GIVE REG BACK TO COMPILER     */
*     END;                          /* END SET UP                    */
*   CALL EXIT;                      /* RETURN TO CALLER              */
@RT00432 BAL   @14,EXIT                                            0527
*   GEN(DS 0F);                     /* FULLWORD BOUNDARY ALIGNMENT   */
         DS 0F
*   GEN(DC CL8'IGGPCEXT');          /* NAME OF FOLLOWING PROCEDURE   */
         DC CL8'IGGPCEXT'
*   END;                            /* END OF INNER PROCEDURE        */
@EL00005 DS    0H                                                  0530
@EF00005 DS    0H                                                  0530
@ER00005 BR    @14                                                 0530
@PB00005 DS    0H                                                  0531
*   GEN(EJECT);                     /* GO TO A NEW PRINT PAGE        */
         EJECT
*                                                                  0532
*/********************************************************************/
*/*                                                                  */
*/*        IGGPCEXT  -  PROCEDURE  INTERNALLY  CALLED  NESTED        */
*/*                                                                  */
*/********************************************************************/
*                                                                  0532
*IGGPCEXT:                                                         0532
*   PROC OPTIONS(NOSAVEAREA,NOSAVE);/* SPECIFY PROCEDURE OPTIONS     */
         B     @PB00006                                            0532
IGGPCEXT DS    0H                                                  0533
*Z051:                              /* LABEL FOR PROCEDURE TRACKING  */
*Z051CEXT:                          /* LABEL FOR PROCEDURE TRACKING  */
*   RFY                                                            0533
*    (R5,                                                          0533
*     R6,                                                          0533
*     R7,                                                          0533
*     R8,                                                          0533
*     R9,                                                          0533
*     R10) UNRSTD;                  /* PL/S COMPILER WORK REGISTERS  */
Z051     DS    0H                                                  0533
Z051CEXT DS    0H                                                  0534
*   RFY                                                            0534
*    (R2,                                                          0534
*     R3,                                                          0534
*     R4) RSTD;                     /* RESTRICT LOCAL WORK REGISTERS */
*   GEN(STM 12,14,12(13));          /* SAVE REGISTERS OF CALLER      */
         STM 12,14,12(13)
*   GEN(LA 13,12(13));              /* POINT TO NEXT SAVE AREA     0536
*                                      PROCEDURE                     */
         LA 13,12(13)
*/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
**   MODULE NAME =  IGGPCEXT (IGG0CLBB)                               *
**                                                                    *
**   DESCRIPTIVE NAME =  COMPUTE EXTENTS                              *
**                                                                    *
**   FUNCTION =                                                       *
**      THIS SUB-FUNCTION CONSTRUCTS THE EXTENT DESCRIPTORS WHICH ARE *
**      ADDED TO THE VSAM DATA SET  VOLUME OCCURRENCE TO DESCRIBE THE *
**      NEWLY ACQUIRED DATA SET EXTENTS.                              *
**                                                                    *
**   INPUT =                                                          *
**      CCADESA - DADSM EXTENTS SAVE AREA.                            *
**         CCANDEXT - NUMBER OF NEW EXTENTS OBTAINED FOR VSAM DATA SET*
**         CCAEXTDE(*) - ARRAY OF EXTENT DESCRIPTORS.                 *
**            CCAEXTSS - DESCRIPTOR SPACE SEQUENCE NO.                *
**            CCAEXTAD - EXTENT STARTING CCHH.                        *
**            CCAEXTTH - NUMBER OF TRACKS IN EXTENT.                  *
**      IDAAMDSB - IN-CORE COPY OF AMDSB CONTROL BLOCK.               *
**         AMDCINV - CONTROL INTERVAL SIZE.                           *
**         AMDCIPCA - CONTROL INTERVALS/CONTROL AREA.                 *
**      UPREPARM PARAMETERS:                                          *
**         UPCHIA - OLD DATA SET HIGH ALLOCATED.                      *
**         UPUSSWD - SEQUENCE SET VOLUME OCCURRENCE BEING UPDATED.    *
**         UPREPL - REPLICATED INDEX.                                 *
**         UPNTCYL - TRACKS/CYLINDER.                                 *
**      UPENTVOL PARAMETERS:                                          *
**         UPNTKA - TRACKS/CONTROL AREA.                              *
**         UPRLRP - SEQUENCE NUMBER OF ADDED OR UPDATED OCCURRENCES.  *
**      CCA RAB 1 HAS BASE CATALOG RECORD OF DATA SET.                *
**         RCDID - RECORD ID.                                         *
**                                                                    *
**   OUTPUT =                                                         *
**      EXTINF1 - EXTENT DESCRIPTORS TO BE ADDED.                     *
**         EXTILEN - LENGTH OF EXTENT DESCRIPTORS.                    *
**         EXTINFO(*) - ARRAY OF EXTENT DESCRIPTORS.                  *
**            EXTSS - SPACE DESCRIPTOR SEQUENCE NO.                   *
**            EXTST - STARTING CCHH OF EXTENT.                        *
**            EXTEND - ENDING CCHH OF EXTENT.                         *
**            EXTTT - TOTAL TRACKS IN EXTENT.                         *
**            EXTDDDD1 - LOW RBA OF EXTENT.                           *
**            EXTDDDD2 - HIGH RBA OF EXTENT.                          *
**                                                                    *
**                                                                    *
** * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
*                                                                  0537
*   RFY                                                            0537
*     EXTINF1 BASED(ADDR(UPEND)+LENGTH(IDAAMDSB));/* MAP EXTENT    0537
*                                      DESCRIPTOR AREA               */
*   EXTILEN=CCANDEXT*LENGTH(EXTINFO);/* SET EXTENT INSERT LENGTH FOR
*                                      MODIFY                        */
         L     @10,CCAR2REC(,R11)                                  0538
         LA    @10,UPEND+18(,@10)                                  0538
         SLR   @05,@05                                             0538
         IC    @05,CCANDEXT(,R11)                                  0538
         MH    @05,@CH00155                                        0538
         STH   @05,EXTILEN+96(,@10)                                0538
*   DO R2=1 TO CCANDEXT;            /* GET EXTENT DESCRIPTORS        */
         LA    R2,1                                                0539
         B     @DE00539                                            0539
@DL00539 DS    0H                                                  0540
*     EXTSS(R2)=CCAEXTSS(R2);       /* SET SPACE SEQ. NO.            */
         LR    @10,R2                                              0540
         MH    @10,@CH00155                                        0540
         L     @05,CCAR2REC(,R11)                                  0540
         LA    @15,18                                              0540
         ALR   @15,@05                                             0540
         LA    @14,UPEND(,@15)                                     0540
         AL    @14,@CF00479                                        0540
         LR    @09,R2                                              0540
         SLA   @09,3                                               0540
         ST    @09,@TF00001                                        0540
         ALR   @09,R11                                             0540
         SLR   @08,@08                                             0540
         ICM   @08,3,CCAEXTSS-8(@09)                               0540
         LA    @09,0(@10,@14)                                      0540
         AL    @09,@CF03423                                        0540
         STH   @08,EXTSS-2(,@09)                                   0540
*     EXTST(R2)=CCAEXTAD(R2);       /* SET START EXTENT              */
         ST    @10,@TF00002                                        0541
         ALR   @10,@14                                             0541
         AL    @10,@CF03424                                        0541
         LR    @01,R11                                             0541
         AL    @01,@TF00001                                        0541
         MVC   EXTST-4(4,@10),CCAEXTAD-8(@01)                      0541
*     EXTTT(R2)=CCAEXTTH(R2);       /* SET TOTAL TRACKS              */
         LR    @10,R11                                             0542
         AL    @10,@TF00001                                        0542
         ICM   @10,12,CCAEXTTH-8(@10)                              0542
         SRA   @10,16                                              0542
         L     @01,@TF00002                                        0542
         AL    @01,@CF03425                                        0542
         STH   @10,EXTTT-12(@01,@14)                               0542
*     EXTCC2(R2)=EXTCC1(R2)+(EXTHH1(R2)+CCAEXTTH(R2)-1)/UPNTCYL;/* 0543
*                                      END CYL                       */
         L     @01,@TF00002                                        0543
         AL    @01,@CF03426                                        0543
         LH    @09,EXTHH1-6(@01,@14)                               0543
         ALR   @09,@10                                             0543
         BCTR  @09,0                                               0543
         LH    @08,UPNTCYL(,@05)                                   0543
         LR    @00,@09                                             0543
         SRDA  @00,32                                              0543
         DR    @00,@08                                             0543
         L     @09,@TF00002                                        0543
         AL    @09,@CF03424                                        0543
         AH    @01,EXTCC1-4(@09,@14)                               0543
         L     @09,@TF00002                                        0543
         AL    @09,@CF03427                                        0543
         STH   @01,EXTCC2-8(@09,@14)                               0543
*     EXTHH2(R2)=(EXTHH1(R2)+CCAEXTTH(R2)-1)//UPNTCYL;/* END HEAD    */
         L     @01,@TF00002                                        0544
         AL    @01,@CF03426                                        0544
         AH    @10,EXTHH1-6(@01,@14)                               0544
         BCTR  @10,0                                               0544
         LR    @00,@10                                             0544
         SRDA  @00,32                                              0544
         DR    @00,@08                                             0544
         L     @10,@TF00002                                        0544
         AL    @10,@CF03428                                        0544
         STH   @00,EXTHH2-10(@10,@14)                              0544
*     R3=EXTTT(R2)/UPNTKA;          /* TOTAL CA'S IN EXTENT          */
         L     @10,@TF00002                                        0545
         AL    @14,@CF03425                                        0545
         LH    @00,EXTTT-12(@10,@14)                               0545
         SRDA  @00,32                                              0545
         LH    R3,UPNTKA(,@15)                                     0545
         DR    @00,R3                                              0545
         LR    R3,@01                                              0545
*     IF(UPREPL=ON&RCDID=CATIXID)|  /* IF INDEX REPLICATED OR        */
*         UPUSSWD=ON THEN           /* UPDATE OF SEQ. SET            */
         TM    UPREPL(@05),B'00010000'                             0546
         BNO   @GL00011                                            0546
         L     @10,CCARABB(,R11)                                   0546
         L     @10,CCACPE1(,@10)                                   0546
         CLI   RCDID(@10),C'I'                                     0546
         BE    @RT00546                                            0546
@GL00011 L     @10,CCAR2REC(,R11)                                  0546
         TM    UPUSSWD(@10),B'10000000'                            0546
         BNO   @RF00546                                            0546
@RT00546 DS    0H                                                  0547
*       UPHABA=R3*AMDCINV;          /* GET RBA SPACE ADDED           */
         L     @10,CCAR2REC(,R11)                                  0547
         LA    @05,UPREND(,@10)                                    0547
         LR    @01,R3                                              0547
         M     @00,AMDCINV+176(,@05)                               0547
         STCM  @01,15,UPHABA+18(@10)                               0547
*     ELSE                          /* NOT REPL OR UPDATE            */
*       UPHABA=R3*AMDCIPCA*AMDCINV; /* GET RBA SPACE ADDED           */
         B     @RC00546                                            0548
@RF00546 L     @10,CCAR2REC(,R11)                                  0548
         LA    @05,UPREND(,@10)                                    0548
         AL    @05,@CF00522                                        0548
         LR    @01,R3                                              0548
         MH    @01,AMDCIPCA(,@05)                                  0548
         M     @00,AMDCINV(,@05)                                   0548
         STCM  @01,15,UPHABA+18(@10)                               0548
*     EXTDDDD1(R2)=UPCHIA;          /* LOW DDDD                      */
@RC00546 LR    @10,R2                                              0549
         MH    @10,@CH00155                                        0549
         L     @05,CCAR2REC(,R11)                                  0549
         LA    @15,18                                              0549
         ALR   @15,@05                                             0549
         LA    @14,UPEND(,@15)                                     0549
         AL    @14,@CF00479                                        0549
         L     @09,UPCHIA(,@05)                                    0549
         ST    @10,@TF00001                                        0549
         ALR   @10,@14                                             0549
         AL    @10,@CF03429                                        0549
         STCM  @09,15,EXTDDDD1-14(@10)                             0549
*     UPCHIA=UPCHIA+UPHABA;         /* NEW END RBA                   */
         ICM   @10,15,UPHABA(@15)                                  0550
         ALR   @09,@10                                             0550
         ST    @09,UPCHIA(,@05)                                    0550
*     EXTDDDD2(R2)=UPCHIA-1;        /* HIGH DDDD                     */
         BCTR  @09,0                                               0551
         AL    @14,@TF00001                                        0551
         BCTR  @14,0                                               0551
         BCTR  @14,0                                               0551
         STCM  @09,15,EXTDDDD2-18(@14)                             0551
*   END;                            /* END GET EXTENT                */
         AL    R2,@CF00060                                         0552
@DE00539 SLR   @10,@10                                             0552
         IC    @10,CCANDEXT(,R11)                                  0552
         CR    R2,@10                                              0552
         BNH   @DL00539                                            0552
*   CALL EXIT;                      /* RETURN TO CALLER              */
         BAL   @14,EXIT                                            0553
*   GEN(DS 0F);                     /* FULLWORD BOUNDARY ALIGNMENT   */
         DS 0F
*   GEN(DC CL8'IGGPMVOL');          /* NAME OF FOLLOWING PROCEDURE   */
         DC CL8'IGGPMVOL'
*   END;                            /* END OF INNER PROCEDURE        */
@EL00006 DS    0H                                                  0556
@EF00006 DS    0H                                                  0556
@ER00006 BR    @14                                                 0556
@PB00006 DS    0H                                                  0557
*   GEN(EJECT);                     /* GO TO A NEW PRINT PAGE        */
         EJECT
*                                                                  0558
*/********************************************************************/
*/*                                                                  */
*/*        IGGPMVOL  -  PROCEDURE  INTERNALLY  CALLED  NESTED        */
*/*                                                                  */
*/********************************************************************/
*                                                                  0558
*IGGPMVOL:                                                         0558
*   PROC OPTIONS(NOSAVEAREA,NOSAVE);/* SPECIFY PROCEDURE OPTIONS     */
         B     @PB00007                                            0558
IGGPMVOL DS    0H                                                  0559
*Z052:                              /* LABEL FOR PROCEDURE TRACKING  */
*Z052MVOL:                          /* LABEL FOR PROCEDURE TRACKING  */
*   RFY                                                            0559
*    (R5,                                                          0559
*     R6,                                                          0559
*     R7,                                                          0559
*     R8,                                                          0559
*     R9,                                                          0559
*     R10) UNRSTD;                  /* PL/S COMPILER WORK REGISTERS  */
Z052     DS    0H                                                  0559
Z052MVOL DS    0H                                                  0560
*   RFY                                                            0560
*    (R2,                                                          0560
*     R3,                                                          0560
*     R4) RSTD;                     /* RESTRICT LOCAL WORK REGISTERS */
*   GEN(STM 12,14,12(13));          /* SAVE REGISTERS OF CALLER      */
         STM 12,14,12(13)
*   GEN(LA 13,12(13));              /* POINT TO NEXT SAVE AREA     0562
*                                      PROCEDURE                     */
         LA 13,12(13)
*/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
**   MODULE NAME =  IGGPMVOL (IGG0CLBB)                               *
**                                                                    *
**   DESCRIPTIVE NAME =  MODIFY VOLUME OCCURRENCE                     *
**                                                                    *
**   FUNCTION =                                                       *
**      THIS SUB-FUNCTION CALLS MODIFY (IGGPMOD) TO UPDATE THE AMDSB  *
**      CONTROL BLOCK OCCURRENCE AND TO UPDATE OR ADD A NEW VOLUME    *
**      OCCURRENCE FOR THE PARTICULAR VSAM DATA SET BEING EXTENDED.   *
**      THE PROCESSING IS AS FOLLOWS:                                 *
**      1. BUILD THE IGGPMOD (IGG0CLAV) PARAMETER LISTS REQUIRED TO   *
**         UPDATE THE AMDSB. IF THE VOLUME OCCURRENCE SEQUENCE NUMBER *
**         IS NON-ZERO, THE OCCURRENCE ALREADY EXISTS AND MUST BE     *
**         UPDATED. OTHERWISE, IF THE SEQUENCE NUMBER IS ZERO, THE    *
**         VOLUME OCCURRENCE MUST BE ADDED.  (THE VOLUME OCCURRENCE   *
**         SEQUENCE NUMBER HAS BEEN ESTABLISHED BY IGGPSVOL           *
**         (IGG0CLBC).)  BUILD THE REST OF THE REQUIRED IGGPMOD       *
**         PARAMETER LISTS.                                           *
**      2. CALL IGGPMOD.  MODIFY WILL RETURN THE SEQUENCE NUMBER OF   *
**         THE VOLUME OCCURRENCE, IF THE OCCURRENCE WAS ADDED. OTHER- *
**         WISE, THE SEQUENCE NUMBER WILL ALREADY BE SET.             *
**                                                                    *
**   INPUT =                                                          *
**      CCA MODIFY INTERFACE FLAGS/ADDRESSES SET.                     *
**      IDAAMDSB - UPDATED IN-CORE COPY OF THE AMDSB CONTROL BLOCK.   *
**      UPENTVOL - UPDATED IN-CORE COPY OF AN EXISTING VOLUME         *
**                 OCCURRENCE OR A NEW VOLUME OCCURRENCE.             *
**                                                                    *
**   OUTPUT =                                                         *
**      IDAAMDSB - CATALOG COPY OF THE AMDSB CONTROL BLOCK FOR THE    *
**                 PARTICULAR DATA SET UPDATED.                       *
**      UPENTVOL - NEW CATALOG VOLUME OCCURRENCE ADDED OR UPDATED.    *
**         UPRLRP - SEQUENCE NUMBER OF VOLUME OCCURRENCE (RETURN BY   *
**                  IGGPMOD, IF IT WAS AN ADD SITUATION).             *
**      CCACD1 - RCS, NO ERROR.                                       *
**             - ANY ERROR CODE RETURNED FROM IGGPMOD.                *
**                                                                    *
**                                                                    *
** * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
*                                                                  0563
*   RFY                                                            0563
*     RELINFO BASED(R3);            /* MAP RELREPNO FIELD            */
*   CCAMCPL=ADDR(UPEND)+LENGTH(IDAAMDSB);/* POINT AREA FOR MODIFY CPL*/
         LA    @10,96                                              0564
         L     @05,CCAR2REC(,R11)                                  0564
         LA    @15,18                                              0564
         ALR   @15,@05                                             0564
         LA    @14,UPEND(,@15)                                     0564
         ALR   @14,@10                                             0564
         ST    @14,CCAMCPL(,R11)                                   0564
*   RFY                                                            0565
*     CLEAR BASED(CCAMCPL);         /* MAP WORK AREA                 */
*   CLEAR=CLEAR&&CLEAR;             /* CLEAR WORK AREA               */
         XC    CLEAR(256,@14),CLEAR(@14)                           0566
*   CTGNOFLD=NOAVFPL;               /* NO. FPL'S FOR AMDSB AND VOLUME
*                                      OCCURRENCE                    */
         MVI   CTGNOFLD(@14),X'02'                                 0567
*   R2=LENGTH(CTGPL)+CCAMCPL        /* POINT TO AMDSB FPL AREA       */
*       +NOAVFPL*LENGTH(CTGFIELD);                                 0568
         LA    R2,36                                               0568
         ALR   R2,@14                                              0568
*   CTGFIELD(1)=R2+LENGTH(FIELDNM); /* AMDSB FPL                     */
         LA    @09,8                                               0569
         LR    @08,R2                                              0569
         ALR   @08,@09                                             0569
         ST    @08,CTGFIELD(,@14)                                  0569
*   RFY                                                            0570
*     CTGFL BASED(CTGFIELD(1));     /* MAP CURRENT FPL               */
*   CTGFLDNM=R2;                    /* POINT FIELD NAME AREA         */
         ST    R2,CTGFLDNM(,@08)                                   0571
*   FIELDNM=AMDSBCAT;               /* INSERT AMDSB NAME             */
         L     @01,CCAMCPL(,R11)                                   0572
         L     @01,CTGFIELD(,@01)                                  0572
         L     @07,CTGFLDNM(,@01)                                  0572
         MVC   FIELDNM(8,@07),@CC00085                             0572
*   CTGFLDNO=NODAT;                 /* INDICATE DATA                 */
         MVI   CTGFLDNO(@08),X'01'                                 0573
*   CTGFLPT(1)=ADDR(IDAAMDSB);      /* ADDRESS OF AMDSB              */
         LA    @05,UPREND(,@05)                                    0574
         AL    @05,@CF00522                                        0574
         ST    @05,CTGFLPT(,@08)                                   0574
*   CTGFLNG(1)=LENGTH(IDAAMDSB);    /* LENGTH OF AMDSB               */
         ST    @10,CTGFLNG(,@08)                                   0575
*   R2=ADDR(CTGFL)+LENGTH(CTGFL)+   /* POINT TO TEST FPL AREA        */
*       NODAT*LENGTH(CTGFLDAT);                                    0576
         LA    @10,24                                              0576
         LR    R2,@08                                              0576
         ALR   R2,@10                                              0576
*   CTGFLCHN=R2+LENGTH(FIELDNM);    /* CHAIN TEST FPL                */
         LR    @05,R2                                              0577
         ALR   @05,@09                                             0577
         ST    @05,CTGFLCHN(,@08)                                  0577
*   RFY                                                            0578
*     CTGFL BASED(R2+LENGTH(FIELDNM));/* MAP TEST FPL                */
*   CTGFLDNM=R2;                    /* FIELD NAME ADDRESS            */
         ST    R2,CTGFLDNM(,@05)                                   0579
*   FIELDNM=RELREPNO;               /* INSERT NAME RELREPNO          */
         L     @08,CTGFLDNM+8(,R2)                                 0580
         MVC   FIELDNM(8,@08),@CC00081                             0580
*   CTGFLDNO=NODAT;                 /* DATA                          */
         MVI   CTGFLDNO(@05),X'01'                                 0581
*   CTGFLDCD=CTGFLDEQ;              /* EQUAL RELREPNO TEST           */
         MVI   CTGFLDCD(@05),X'80'                                 0582
*   CTGFLDGC=CATDSBGC;              /* GROUP CODE                    */
         MVI   CTGFLDGC(@05),X'01'                                 0583
*   R3=ADDR(CTGFL)+LENGTH(CTGFL)+   /* POINT TO NEXT FPL AREA        */
*       NODAT*LENGTH(CTGFLDAT);                                    0584
         LA    R3,32                                               0584
         ALR   R3,R2                                               0584
*   CTGFLPT(1)=R3;                  /* SET RELREPNO DATA ADDR        */
         ST    R3,CTGFLPT(,@05)                                    0585
*   CTGFLNG(1)=LENGTH(RELREP);      /* LENGTH RELREPNO               */
         LA    @08,2                                               0586
         ST    @08,CTGFLNG(,@05)                                   0586
*   RELREP=1;                       /* UPDATE FIRST/ONLY DSB         */
         MVC   RELREP(2,R3),@CH00060                               0587
*   R2=R3+LENGTH(RELINFO);          /* POINT NEXT FPL AREA           */
         LA    R2,4                                                0588
         ALR   R2,R3                                               0588
*   CTGFIELD(2)=R2+LENGTH(FIELDNM); /* POINT TO FPL AREA             */
         LR    @05,R2                                              0589
         ALR   @05,@09                                             0589
         ST    @05,CTGFIELD+4(,@14)                                0589
*   RFY                                                            0590
*     CTGFL BASED(CTGFIELD(2));     /* MAP VOLUME FPL                */
*   CTGFLDNO=NODAT;                 /* INDICATE DATA                 */
         MVI   CTGFLDNO(@05),X'01'                                 0591
*   CTGFLDNM=R2;                    /* FIELD NAME ADDRESS            */
         ST    R2,CTGFLDNM(,@05)                                   0592
*   R4=ADDR(UPVOLVAR);              /* LENGTH FIXED INFORMATION      */
         LA    R4,UPVOLVAR(,@15)                                   0593
*   RFY                                                            0594
*     VARFIELD BASED(R4);           /* MAP LOW KEY                   */
*   R4=R4+LENGTH(VARLEN)+VARLEN;    /* ADD LOW KEY TO TOTAL LEN      */
         LR    @14,R4                                              0595
         ALR   @14,@08                                             0595
         ICM   @07,12,VARLEN(R4)                                   0595
         SRA   @07,16                                              0595
         ALR   @14,@07                                             0595
         LR    R4,@14                                              0595
*   R4=R4+LENGTH(VARLEN)+VARLEN;    /* ADD HI KEY TO TOTAL LEN       */
         LR    @14,R4                                              0596
         ALR   @14,@08                                             0596
         ICM   @07,12,VARLEN(R4)                                   0596
         SRA   @07,16                                              0596
         ALR   @14,@07                                             0596
         LR    R4,@14                                              0596
*   R4=R4-ADDR(UPVOLFIX);           /* SET ADDR OF FIXED INFO        */
         SLR   R4,@15                                              0597
*   R3=R4+LENGTH(VARLEN);           /* LENGTH TO FIRST EXTENT        */
         LR    R3,R4                                               0598
         ALR   R3,@08                                              0598
*   CTGFLPT(1)=ADDR(UPENTVOL);      /* POINT DATA INFO FOR VOL       */
         ST    @15,CTGFLPT(,@05)                                   0599
*   IF UPRLRP^=0 THEN               /* IF EXISTENT OCCURRENCE        */
         LH    @14,UPRLRP(,@15)                                    0600
         LTR   @14,@14                                             0600
         BZ    @RF00600                                            0600
*     DO;                           /* SET UP FOR UPDATE             */
*       FIELDNM=UPDVOL;             /* INSERT FIELD NAME             */
         L     @01,CCAMCPL(,R11)                                   0602
         L     @01,CTGFIELD+4(,@01)                                0602
         L     @14,CTGFLDNM(,@01)                                  0602
         MVC   FIELDNM(8,@14),@CC00056                             0602
*       CTGFLNG(1)=R4;              /* SET LENGTH                    */
         ST    R4,CTGFLNG(,@05)                                    0603
*       R2=ADDR(CTGFL)+LENGTH(CTGFL)/* POINT TO TEST FPL             */
*           +NODAT*LENGTH(CTGFLDAT);                               0604
         ALR   @10,@05                                             0604
         LR    R2,@10                                              0604
*       CTGFLCHN=R2+LENGTH(FIELDNM);/* CHAIN TEST FPL                */
         ALR   @09,R2                                              0605
         ST    @09,CTGFLCHN(,@05)                                  0605
*       RFY                                                        0606
*         CTGFL BASED(R2+LENGTH(FIELDNM));/* MAP TEST FPL            */
*       CTGFLDNO=NODAT;             /* INDICATE DATA                 */
         MVI   CTGFLDNO(@09),X'01'                                 0607
*       CTGFLDGC=CATVOLGC;          /* VOLUME GROUP CODE             */
         MVI   CTGFLDGC(@09),X'03'                                 0608
*       CTGFLDCD=CTGFLDEQ;          /* EQUAL SEQUENCE NUMBER         */
         MVI   CTGFLDCD(@09),X'80'                                 0609
*       CTGFLDNM=R2;                /* ADDRESS OF FIELD NAME         */
         ST    R2,CTGFLDNM(,@09)                                   0610
*       FIELDNM=RELREPNO;           /* RELREPNO                      */
         L     @10,CTGFLDNM+8(,R2)                                 0611
         MVC   FIELDNM(8,@10),@CC00081                             0611
*       CTGFLPT(1)=ADDR(UPRLRP);    /* ADDR TEST RELREPNO            */
         ST    @15,CTGFLPT(,@09)                                   0612
*       CTGFLNG(1)=LENGTH(UPRLRP);  /* LENGTH RELREPNO               */
         ST    @08,CTGFLNG(,@09)                                   0613
*     END;                          /* END SET UP FOR UPDATE         */
*   ELSE                            /* ADD OCCURENCE                 */
*     DO;                           /* SET FOR ADD                   */
         B     @RC00600                                            0615
@RF00600 DS    0H                                                  0616
*       FIELDNM=ENTVOL;             /* ENTVOL                        */
         LA    @10,8                                               0616
         ALR   @10,R2                                              0616
         L     @05,CTGFLDNM(,@10)                                  0616
         MVC   FIELDNM(8,@05),@CC00083                             0616
*       CTGFLNG(1)=R3;              /* LENGTH ENTVOL                 */
         ST    R3,CTGFLNG(,@10)                                    0617
*     END;                          /* END ADD                       */
*                                                                  0618
*   /*****************************************************************/
*   /*                                                               */
*   /* CALL TO MODULE IGG0CLAV                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0619
*Z053MOD:                                                          0619
*   CALL IGGPMOD;                   /* MODIFY AMDSB AND VOLUME     0619
*                                      OCCURRENCE                    */
@RC00600 DS    0H                                                  0619
Z053MOD  L     @15,@CV00039                                        0619
         BALR  @14,@15                                             0619
*   CALL EXIT;                      /* RETURN TO CALLER              */
         BAL   @14,EXIT                                            0620
*   GEN(DS 0F);                     /* FULLWORD BOUNDARY ALIGNMENT   */
         DS 0F
*   GEN(DC CL8'IGGPSSWD');          /* NAME OF FOLLOWING PROCEDURE   */
         DC CL8'IGGPSSWD'
*   END;                            /* END OF INNER PROCEDURE        */
@EL00007 DS    0H                                                  0623
@EF00007 DS    0H                                                  0623
@ER00007 BR    @14                                                 0623
@PB00007 DS    0H                                                  0624
*   GEN(EJECT);                     /* GO TO A NEW PRINT PAGE        */
         EJECT
*                                                                  0625
*/********************************************************************/
*/*                                                                  */
*/*        IGGPSSWD  -  PROCEDURE  INTERNALLY  CALLED  NESTED        */
*/*                                                                  */
*/********************************************************************/
*                                                                  0625
*IGGPSSWD:                                                         0625
*   PROC OPTIONS(NOSAVEAREA,NOSAVE);/* SPECIFY PROCEDURE OPTIONS     */
         B     @PB00008                                            0625
IGGPSSWD DS    0H                                                  0626
*Z054:                              /* LABEL FOR PROCEDURE TRACKING  */
*Z054SSWD:                          /* LABEL FOR PROCEDURE TRACKING  */
*   RFY                                                            0626
*    (R5,                                                          0626
*     R6,                                                          0626
*     R7,                                                          0626
*     R8,                                                          0626
*     R9,                                                          0626
*     R10) UNRSTD;                  /* PL/S COMPILER WORK REGISTERS  */
Z054     DS    0H                                                  0626
Z054SSWD DS    0H                                                  0627
*   RFY                                                            0627
*    (R2,                                                          0627
*     R3,                                                          0627
*     R4) RSTD;                     /* RESTRICT LOCAL WORK REGISTERS */
*   GEN(STM 12,14,12(13));          /* SAVE REGISTERS OF CALLER      */
         STM 12,14,12(13)
*   GEN(LA 13,12(13));              /* POINT TO NEXT SAVE AREA     0629
*                                      PROCEDURE                     */
         LA 13,12(13)
*/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
**   MODULE NAME =  IGGPSSWD (IGG0CLBB)                               *
**                                                                    *
**   DESCRIPTIVE NAME =                                               *
**      UPDATE SEQUENCE SET INDEX VOLUME OCCURRENCE.                  *
**                                                                    *
**   FUNCTION =                                                       *
**      THIS SUB-FUNCTION INTERFACES WITH LOWER LEVEL SUB-FUNCTIONS   *
**      TO FIND THE INDEX SEQUENCE SET VOLUME OCCURRENCE CORRESPONDING*
**      TO THE ASSOCIATED DATA VOLUME OCCURRENCE, AND TO UPDATE IT TO *
**      REFLECT THE NEWLY ACQUIRED EXTENTS.  THE PROCESSING IS AS     *
**      FOLLOWS:                                                      *
**      1. INITIALIZATION.                                    @Y30SSRS*
**      2. READ INDEX BASE RECORD.                            @Y30SSRS*
**      3. CALL IGGPINIT (IGG0CLBC) TO GET THE INDEX AMDSB CONTROL    *
**         BLOCK.                                                     *
**      4. CALL IGGPSVOL (IGG0CLBC) TO FIND THE SEQUENCE SET VOLUME   *
**         OCCURRENCE (I.E. THE VOLUME OCCURRENCE WITH THE SAME       *
**         VOLUME SERIAL AND KEY RANGES).                             *
**      5. COMPUTE THE NEW RBA'S, THE NEW NUMBER OF EXTENTS, AND THE  *
**         NEW FREE SPACE IN THE AMDSB AND THE SEQUENCE SET VOLUME    *
**         OCCURRENCE.                                                *
**      6. CALL IGGPMVOL TO UPDATE THE AMDSB AND TO ADD OR UPDATE THE *
**         SEQUENCE SET VOLUME OCCURRENCE.                            *
**      7. CALL IGGPCEXT TO CONSTRUCT THE NEW SEQUENCE SET EXTENT     *
**         DESCRIPTORS (THESE NEWLY CONSTRUCTED EXTENT DESCRIPTORS    *
**         WILL CORRESPOND TO THE ASSOCIATED DATA SET EXTENT DESCRIP- *
**         TORS EXCEPT THE COMPUTED RBA'S WILL BE IN THE INDEX RBA    *
**         SPACE).                                                    *
**      8. CALL IGGPMEXT TO ADD THE SEQUENCE SET EXTENT DESCRIPTORS   *
**         TO THE SEQUENCE SET VOLUME OCCURRENCE.                     *
**                                                                    *
**   INPUT =                                                          *
**      UPREPARM PARAMETERS:                                          *
**         UPNTCYL - NUMBER OF TRACKS/CYLINDER.                       *
**         UPICINO - CI NO. OF INDEX RECORD.                  @Y30SSRS*
**         UPUSSWD - SET ON TO INDICATE UPDATE OF SEQUENCE SET VOLUME *
**                   OCCURRENCE.                                      *
**      SVC 26 CALLER PARAMETERS:                                     *
**         VOLUME SERIAL ON WHICH ADDITIONAL EXTENTS ARE TO OBTAINED. *
**         (HIGH AND LOW KEYS OF KEY RANGE TO BE EXTENDED).           *
**      CCANDESA - CCA DADSM EXTENTS SAVE AREA.                       *
**                                                                    *
**   OUTPUT =                                                         *
**      SVC 26 CALLER'S WORK AREA:                                    *
**         SEQUENCE NO. OF SEQUENCE SET VOLUME OCCURRENCE ADDED OR    *
**         UPDATED.                                                   *
**         NUMBER OF EXTENTS IN INDEX AFTER UPDATE EXTEND     @XA02392*
**      CCACD1 - RCS, NO ERROR                                        *
**               ANY ERROR CODE RETURNED FROM IGGPGET,IGGPINIT,       *
**               IGGPSVOL,IGGPMVOL,OR IGGPMEXT.                       *
**      INDEX ENTRY UPDATED TO REFLECT NEW EXTENTS.                   *
**                                                                    *
**                                                                    *
** * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
*                                                                  0630
*   RFY                                                            0630
*     CCARAB BASED(CCARABB);        /* MAP BASE RAB                  */
*   CCASRID=UPICINO;                /* SET UP TO GET IDX     @Y30SSRS
*                                      ENTRY                         */
         L     @10,CCAR2REC(,R11)                                  0631
         MVC   CCASRID(3,R11),UPICINO(@10)                         0631
*   CCAURAB=ADDR(CCARAB1);          /* OVERLAY LAST OBJECT           */
         LA    @10,CCARAB1(,R11)                                   0632
         ST    @10,CCAURAB(,R11)                                   0632
*   DO;                                                            0633
*     CCAF1KEY=OFF;                 /* GET BY CI NO.                 */
*     CCAF1KGE=OFF;                 /* NOT GET NEXT                  */
*     CCAF1UP=OFF;                  /* NOT GET UPD                   */
*                                                                  0636
         NI    CCAF1KEY(R11),B'11100101'                           0636
*     /***************************************************************/
*     /*                                                             */
*     /* CALL TO MODULE IGG0CLBI                                     */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0637
*Z056GET:                                                          0637
*     CALL IGGPGET;                 /* GET RECORD                    */
Z056GET  L     @15,@CV00036                                        0637
         BALR  @14,@15                                             0637
*   END;                            /* GET CLUSTER RECORD            */
*   IF CCACD1^=RCS THEN                                            0639
         CLI   CCACD1(R11),0                                       0639
         BNE   @RT00639                                            0639
*     ;                             /* ERROR                         */
*   ELSE                            /* NO ERROR                      */
*     DO;                           /* PROCESS SEQ SET               */
*                                                                  0641
*       /*************************************************************/
*       /*                                                           */
*       /* CALL TO MODULE IGG0CLBC                                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0642
*Z057INIT:                                                         0642
*       CALL IGGPINIT;              /* PERFORM INITLZ        @Y30SSRS*/
Z057INIT L     @15,@CV00038                                        0642
         BALR  @14,@15                                             0642
*       UPENTVOL=UPENTVOL&&UPENTVOL;/* CLEAR INTERFACE       @Y30SSRS*/
         L     @10,CCAR2REC(,R11)                                  0643
         XC    UPENTVOL+18(176,@10),UPENTVOL+18(@10)               0643
*       IF CCACD1^=RCS THEN                                        0644
         CLI   CCACD1(R11),0                                       0644
         BNE   @RT00644                                            0644
*         ;                         /* ERROR                         */
*       ELSE                        /* NO ERROR                      */
*         DO;                       /* PROCESS VOLUME                */
*           RFY                                                    0647
*             CTGPL BASED(CCACPL);  /* MAP USER CPL                  */
*           RFY                                                    0648
*             CTGFL BASED(CTGFIELD(1));/* MAP VOLSER FPL             */
*           UPSVOL=UPSVOL&&UPSVOL;  /* ZERO SEARCH VOLUME WORK AREA  */
         L     @10,CCAR2REC(,R11)                                  0649
         LA    @10,UPREND(,@10)                                    0649
         AL    @10,@CF03385                                        0649
         XC    UPSVOL(22,@10),UPSVOL(@10)                          0649
*           UPVOLSER=UPEVOL;        /* SAVE VOLSER INFO              */
         L     @05,CCACPL(,R11)                                    0650
         L     @01,CTGFIELD(,@05)                                  0650
         L     @01,CTGFLPT(,@01)                                   0650
         MVC   UPVOLSER(6,@10),UPEVOL(@01)                         0650
*           IF CTGNOFLD=NOKEYFPL THEN/* IF KEY RANGE REQUEST         */
         CLI   CTGNOFLD(@05),3                                     0651
         BNE   @RF00651                                            0651
*             DO;                   /* GET PARM INFO                 */
*               RFY                                                0653
*                 CTGFL BASED(CTGFIELD(2));/* MAP LOW KEY FPL        */
*               UPLKEYPT=CTGFLPT(1);/* POINT TO LOW KEY              */
         L     @15,CTGFIELD+4(,@05)                                0654
         L     @14,CTGFLPT(,@15)                                   0654
         ST    @14,UPLKEYPT(,@10)                                  0654
*               UPLKEYLN=CTGFLNG(1);/* LOW KEY LENGTH                */
         L     @15,CTGFLNG(,@15)                                   0655
         STH   @15,UPLKEYLN(,@10)                                  0655
*               RFY                                                0656
*                 CTGFL BASED(CTGFIELD(3));/* MAP HIGH KEY FPL       */
*               UPHKEYPT=CTGFLPT(1);/* POINT TO HIGH KEY             */
         L     @05,CTGFIELD+8(,@05)                                0657
         L     @15,CTGFLPT(,@05)                                   0657
         ST    @15,UPHKEYPT(,@10)                                  0657
*               UPHKEYLN=CTGFLNG(1);/* HIGH KEY LENGTH               */
         L     @05,CTGFLNG(,@05)                                   0658
         STH   @05,UPHKEYLN(,@10)                                  0658
*             END;                  /* END GET PARM INFO             */
*           ELSE                                                   0660
*             ;                     /* NON-KEY RANGE REQUEST         */
*                                                                  0660
@RF00651 DS    0H                                                  0661
*           /*********************************************************/
*           /*                                                       */
*           /* CALL TO MODULE IGG0CLBC                               */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0661
*Z058SVOL:                                                         0661
*           CALL IGGPSVOL;          /* SEARCH FOR VOLUME             */
Z058SVOL L     @15,@CV00043                                        0661
         BALR  @14,@15                                             0661
*           IF CCACD1^=RCS THEN                                    0662
         CLI   CCACD1(R11),0                                       0662
         BNE   @RT00662                                            0662
*             ;                     /* ERROR                         */
*           ELSE                    /* NO ERROR                      */
*             DO;                   /* UPDATE RECORD                 */
*               WKARELSS=UPRLRP;    /* SET SEQ. SET RELREPNO         */
         L     @10,CCACPL(,R11)                                    0665
         L     @10,CTGWKA(,@10)                                    0665
         L     @05,CCAR2REC(,R11)                                  0665
         LH    @05,UPRLRP+18(,@05)                                 0665
         STH   @05,WKARELSS(,@10)                                  0665
*               R3=0;               /* INITLZ TOTAL CA'S             */
         SLR   R3,R3                                               0666
*               DO R2=1 TO CCANDEXT;/* ADD UP CA'S                   */
         LA    R2,1                                                0667
         B     @DE00667                                            0667
@DL00667 DS    0H                                                  0668
*                 R3=R3+(CCAEXTTH(R2)/UPNTKA);/* INCR TOTAL CA'S     */
         LR    @10,R2                                              0668
         SLA   @10,3                                               0668
         L     @05,CCAR2REC(,R11)                                  0668
         ALR   @10,R11                                             0668
         ICM   @00,12,CCAEXTTH-8(@10)                              0668
         SRA   @00,16                                              0668
         SRDA  @00,32                                              0668
         LH    @10,UPNTKA+18(,@05)                                 0668
         DR    @00,@10                                             0668
         ALR   R3,@01                                              0668
*               END;                /* END ADD                       */
         AL    R2,@CF00060                                         0669
@DE00667 SLR   @10,@10                                             0669
         IC    @10,CCANDEXT(,R11)                                  0669
         CR    R2,@10                                              0669
         BNH   @DL00667                                            0669
*               R3=R3*AMDCINV;      /* COMPUTE TOTAL ADDED RBA SPACE */
         L     @10,CCAR2REC(,R11)                                  0670
         LA    @05,UPREND(,@10)                                    0670
         AL    @05,@CF00522                                        0670
         LR    @01,R3                                              0670
         M     @00,AMDCINV(,@05)                                   0670
         LR    R3,@01                                              0670
*               UPCHIA=CHIA;        /* SAVE HIGH ALLOCATED           */
         L     @01,CCARABB(,R11)                                   0671
         L     @15,CCACPE1(,@01)                                   0671
         ICM   @14,15,CHIA(@15)                                    0671
         ST    @14,UPCHIA(,@10)                                    0671
*               UPHUBA=CHIA;        /* NEW HIGH USED                 */
         AL    @10,@CF00583                                        0672
         STCM  @14,15,UPHUBA(@10)                                  0672
*               CHIA=CHIA+R3;       /* NEW HIGH ALLOCATED D.S.       */
         ALR   @14,R3                                              0673
         STCM  @14,15,CHIA(@15)                                    0673
*               UPHABA=CHIA;        /* NEW HIGH ALLOCATED VOLUME     */
         STCM  @14,15,UPHABA(@10)                                  0674
*               UPNOEXT=UPNOEXT+CCANDEXT;/* NEW TOTAL EXTENTS VOL    */
         SLR   @15,@15                                             0675
         IC    @15,CCANDEXT(,R11)                                  0675
         SLR   @14,@14                                             0675
         IC    @14,UPNOEXT(,@10)                                   0675
         ALR   @14,@15                                             0675
         STC   @14,UPNOEXT(,@10)                                   0675
*               AMDNEXT=AMDNEXT+CCANDEXT;/* NEW TOTAL EXTENTS D.S.   */
         AH    @15,AMDNEXT(,@05)                                   0676
         STH   @15,AMDNEXT(,@05)                                   0676
*               WKAEXTSS=AMDNEXT;   /* SET TOTAL NO. DATA SET EXTENTS
*                                                            @XA02392*/
         L     @10,CCACPL(,R11)                                    0677
         L     @10,CTGWKA(,@10)                                    0677
         STH   @15,WKAEXTSS(,@10)                                  0677
*               AMDASPA=AMDASPA+R3; /* NEW FREE SPACE TOTAL          */
         LR    @10,R3                                              0678
         AL    @10,AMDASPA(,@05)                                   0678
         ST    @10,AMDASPA(,@05)                                   0678
*Z059MVOL:                                                         0679
*               CALL IGGPMVOL;      /* MODIFY AMDSB AND VOL OCCUR    */
Z059MVOL BAL   @14,IGGPMVOL                                        0679
*               WKARELSS=UPRLRP;    /* SET SEQ. SET RELREPNO         */
         L     @10,CCACPL(,R11)                                    0680
         L     @10,CTGWKA(,@10)                                    0680
         L     @05,CCAR2REC(,R11)                                  0680
         LH    @05,UPRLRP+18(,@05)                                 0680
         STH   @05,WKARELSS(,@10)                                  0680
*               IF CCACD1^=RCS THEN                                0681
         CLI   CCACD1(R11),0                                       0681
         BNE   @RT00681                                            0681
*                 ;                 /* ERROR, END PROCESS            */
*               ELSE                /* NO ERROR                      */
*                 DO;               /* UPDATE EXTENTS                */
*Z060CEXT:                                                         0684
*                   CALL IGGPCEXT;  /* COMPUTE EXTENTS               */
Z060CEXT BAL   @14,IGGPCEXT                                        0684
*Z061MEXT:                                                         0685
*                   CALL IGGPMEXT;  /* MODIFY EXTENT INFO            */
Z061MEXT BAL   @14,IGGPMEXT                                        0685
*                 END;              /* END UPDATE EXTENTS            */
*             END;                  /* END UPDATE RECORD             */
@RT00681 DS    0H                                                  0688
*         END;                      /* END PROCESS VOLUME            */
@RT00662 DS    0H                                                  0689
*     END;                          /* END PROCESS SEQ SET           */
@RT00644 DS    0H                                                  0690
*   CALL EXIT;                      /* RETURN TO CALLER              */
@RT00639 BAL   @14,EXIT                                            0690
*   END;                            /* END OF INNER PROCEDURE        */
@EL00008 DS    0H                                                  0691
@EF00008 DS    0H                                                  0691
@ER00008 BR    @14                                                 0691
@PB00008 DS    0H                                                  0692
*   GEN(EJECT);                     /* GO TO A NEW PRINT PAGE        */
         EJECT
*                                                                  0693
*/********************************************************************/
*/*                                                                  */
*/*         RETURN-TO-CALLER  PROCEDURE-EXITING  SUBFUNCTION         */
*/*                                                                  */
*/********************************************************************/
*                                                                  0693
*EXIT:                                                             0693
*   PROC OPTIONS(NOSAVEAREA,NOSAVE);/* SPECIFY PROCEDURE OPTIONS     */
         B     @PB00009                                            0693
EXIT     DS    0H                                                  0694
*   GEN(LM 12,14,0(13));            /* RESTORE REGISTERS OF CALLER   */
         LM 12,14,0(13)
*   GEN(MVI 12(13),255);            /* MARK END OF PDL               */
         MVI 12(13),255
*   GEN(BR 14);                     /* RETURN TO CALLER              */
         BR 14
*PATCH:                                                            0697
*   GEN(DC (12+((*+139-@MAINENT)/140))A(0));/* PATCH AREA            */
PATCH    DC (12+((*+139-@MAINENT)/140))A(0)
*   END;                            /* END OF EXIT PROCEDURE         */
@EL00009 DS    0H                                                  0698
@EF00009 DS    0H                                                  0698
@ER00009 BR    @14                                                 0698
*   END                             /* END PROCEDURE                 */
*                                                                  0699
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IGGMUPDE)                                       */
*/*%INCLUDE SYSLIB  (IGGMVEDC)                                       */
*/*%INCLUDE SYSLIB  (IGGMCDCL)                                       */
*/*%INCLUDE SYSLIB  (IGGMCTRC)                                       */
*/*%INCLUDE SYSLIB  (IGGCCA  )                                       */
*/*%INCLUDE SYSLIB  (IEZCTGPL)                                       */
*/*%INCLUDE SYSLIB  (IEZCTGFL)                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IKJTCB  )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IFGACB  )                                       */
*/*%INCLUDE SYSLIB  (AMCBS   )                                       */
*/*%INCLUDE SYSLIB  (IGGCAXWA)                                       */
*/*%INCLUDE SYSLIB  (IEZCTGFV)                                       */
*/*%INCLUDE SYSLIB  (IEZCTGWA)                                       */
*/*%INCLUDE SYSLIB  (IEZCTGVL)                                       */
*/*%INCLUDE SYSLIB  (IEZCTGCV)                                       */
*/*%INCLUDE SYSLIB  (IGGMCMDM)                                       */
*/*%INCLUDE SYSLIB  (IDAAMDSB)                                       */
*/*%INCLUDE SYSLIB  (IGGMSAWA)                                       */
*                                                                  0699
*       ;                                                          0699
@EL00001 DS    0H                                                  0699
@EF00001 DS    0H                                                  0699
@ER00001 BR    @14                                                 0699
@DATA    DS    0H
@CH00055 DC    H'8'
@CH00370 DC    H'12'
@CH00155 DC    H'20'
@DATD    DSECT
         DS    0F
@TF00001 DS    F
@TF00002 DS    F
IGG0CLBB CSECT
         DS    0F
@CF00060 DC    F'1'
@CH00060 EQU   @CF00060+2
@CF00058 DC    F'2'
@CF00075 DC    F'3'
@CF02759 DC    F'9'
@CF00583 DC    F'18'
@CF00479 DC    F'96'
@CF00655 DC    F'118'
@CF00522 DC    F'176'
@CF00544 DC    F'220'
@CF03385 DC    F'272'
@CF03398 DC    F'525'
@CF00049 DC    F'65535'
@CF03393 DC    F'-1027473316'
@CF03394 DC    F'-1027473160'
@CF03400 DC    F'-1027472732'
@CF03389 DC    F'-1027472316'
@CF03406 DC    F'-1027471804'
@CF03392 DC    F'-1027471292'
@CF03403 DC    F'-1027470268'
@CF03384 DC    F'-1027460468'
@CF03422 DC    F'-219'
@CF03423 DC    F'-18'
@CF03424 DC    F'-16'
@CF03426 DC    F'-14'
@CF03427 DC    F'-12'
@CF03428 DC    F'-10'
@CF03425 DC    F'-8'
@CF03429 DC    F'-6'
@DATD    DSECT
         DS    0D
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IGG0CLBB CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV00036 DC    V(IGGPGET)
@CV00037 DC    V(IGGPEXT)
@CV00038 DC    V(IGGPINIT)
@CV00039 DC    V(IGGPMOD)
@CV00040 DC    V(IGGPSALL)
@CV00041 DC    V(IGGPSMFL)
@CV00042 DC    V(IGGPSPAC)
@CV00043 DC    V(IGGPSVOL)
@CV00044 DC    V(IGGPSMFA)
@CV00045 DC    V(IGGPTNXO)
@CV00046 DC    V(IGGPTXO)
@CV00047 DC    V(IGGPARFS)
         DS    0D
@CC00056 DC    C'UPDVOL  '
@CC00073 DC    C'EXTENT  '
@CC00081 DC    C'RELREPNO'
@CC00083 DC    C'ENTVOL  '
@CC00085 DC    C'AMDSBCAT'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
IGGSEGBR EQU   @12
R2       EQU   @02
R3       EQU   @03
R4       EQU   @04
RWA      EQU   @02
R1       EQU   @01
R5       EQU   @05
R6       EQU   @06
R7       EQU   @07
R8       EQU   @08
R9       EQU   @09
R10      EQU   @10
R11      EQU   @11
R12      EQU   @12
RET      EQU   @14
RFLD     EQU   @04
RGO      EQU   @15
RNDX     EQU   @03
RP0      EQU   @00
RP1      EQU   @01
RSAVE    EQU   @13
RWK1     EQU   @06
RWK2     EQU   @07
RWK3     EQU   @08
RWK4     EQU   @09
RZERO    EQU   @00
R0       EQU   @00
R13      EQU   @13
R14      EQU   @14
R15      EQU   @15
WKR2     EQU   @02
WKR3     EQU   @03
WKR4     EQU   @04
CVTPTR   EQU   16
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
UPEVOL   EQU   0
UPSVOL   EQU   0
UPLKEYLN EQU   UPSVOL
UPHKEYLN EQU   UPSVOL+2
UPLKEYPT EQU   UPSVOL+4
UPHKEYPT EQU   UPSVOL+8
UPVOLSER EQU   UPSVOL+12
IDAAMDSB EQU   0
AMDATTR  EQU   IDAAMDSB+1
AMDREPL  EQU   AMDATTR
AMDNEST  EQU   IDAAMDSB+4
AMDCIPCA EQU   IDAAMDSB+12
AMDCINV  EQU   IDAAMDSB+20
AMDHLRBA EQU   IDAAMDSB+28
AMDSSRBA EQU   IDAAMDSB+32
AMDATTR3 EQU   IDAAMDSB+40
AMDSTAT  EQU   IDAAMDSB+48
AMDNEXT  EQU   AMDSTAT+10
AMDASPA  EQU   AMDSTAT+32
RELINFO  EQU   0
RELREP   EQU   RELINFO
UPEXT1   EQU   0
UPEXTLN1 EQU   UPEXT1
UPKEY1   EQU   0
UPKEY    EQU   0
WKAINFO  EQU   0
WKARETN  EQU   WKAINFO+4
WKAREL   EQU   WKARETN
WKARELSS EQU   WKARETN+2
WKAEXT   EQU   WKARETN+4
WKAEXTSS EQU   WKARETN+6
CTVOLRCD EQU   1
CTVDVCHR EQU   CTVOLRCD+52
CTVMXBLK EQU   CTVDVCHR+4
CTVNOTRK EQU   CTVDVCHR+10
CTVDVFLG EQU   CTVDVCHR+17
CTVSPHDR EQU   0
CTVSPFLG EQU   CTVSPHDR+15
CTVDESGP EQU   0
CTVEXTST EQU   CTVDESGP+4
CTVSTDES EQU   CTVEXTST
CTVDSGRP EQU   0
CTVDSDFL EQU   CTVDSGRP+6
CTVDSDIR EQU   CTVDSGRP+9
CTVGOPT  EQU   0
CTVGOCI  EQU   CTVGOPT
CTVGOGCI EQU   CTVGOPT+3
CTVRCTRL EQU   0
CTVEXRPT EQU   CTVRCTRL
CTVSPMAP EQU   0
CTVSMSN  EQU   CTVSPMAP
CTVDSPAC EQU   0
CTVDSPSN EQU   CTVDSPAC
CTVDSPFG EQU   CTVDSPAC+15
CTVSPEXT EQU   CTVDSPAC+21
CTVEXTNT EQU   CTVSPEXT
CTVDIR   EQU   0
CTVDSDSN EQU   CTVDIR
CTVDEXTN EQU   0
UPREPARM EQU   0
UPNTCYL  EQU   UPREPARM
UPNIEXT  EQU   UPNTCYL
UPICINO  EQU   UPREPARM+2
UPVCINO  EQU   UPREPARM+5
UPFLGS   EQU   UPREPARM+8
UPKEYDS  EQU   UPFLGS
UPSSWD   EQU   UPFLGS
UPREPL   EQU   UPFLGS
UPFLG2S  EQU   UPREPARM+9
UPUSSWD  EQU   UPFLG2S
UPSMFL   EQU   UPFLG2S
UPCHIA   EQU   UPREPARM+12
UPEXTLN  EQU   UPREPARM+16
UPREND   EQU   UPREPARM+18
UPENTVOL EQU   0
UPVOLFIX EQU   UPENTVOL
UPRLRP   EQU   UPVOLFIX
UPVOL    EQU   UPVOLFIX+6
UPVLFLG  EQU   UPVOLFIX+14
UPNOEXT  EQU   UPVOLFIX+15
UPHUBA   EQU   UPVOLFIX+20
UPHABA   EQU   UPVOLFIX+24
UPPHYB   EQU   UPVOLFIX+28
UPNTKA   EQU   UPVOLFIX+34
UPITEX   EQU   UPVOLFIX+36
UPSSDS   EQU   UPVOLFIX+37
UPVOLVAR EQU   UPENTVOL+39
UPEND    EQU   UPENTVOL+176
CLEAR    EQU   0
EXTINF1  EQU   0
EXTILEN  EQU   EXTINF1
EXTINFO  EQU   EXTINF1+2
EXTSS    EQU   EXTINFO
EXTST    EQU   EXTINFO+2
EXTCC1   EQU   EXTST
EXTHH1   EQU   EXTST+2
EXTEND   EQU   EXTINFO+6
EXTCC2   EQU   EXTEND
EXTHH2   EQU   EXTEND+2
EXTTT    EQU   EXTINFO+10
EXTDDDD1 EQU   EXTINFO+12
EXTDDDD2 EQU   EXTINFO+16
UPSPARM  EQU   0
UPSOPT   EQU   UPSPARM
UPSPQTY  EQU   UPSPARM+1
UPSFLG   EQU   UPSPARM+4
UPSUNIQ  EQU   UPSFLG
UPDSDIR  EQU   UPSPARM+5
UPUDSNPT EQU   UPSPARM+8
UPMXBLK  EQU   UPSPARM+12
UPCRDT1  EQU   UPSPARM+24
UPCRDT   EQU   UPCRDT1
UPSPHDR  EQU   UPSPARM+28
UPDIRSP  EQU   UPSPARM+51
UPSPWA   EQU   UPSPARM+63
UPSPD    EQU   UPSPARM+198
UPSECQTY EQU   UPSPARM+217
IGGCCA   EQU   0
CCAPROB  EQU   IGGCCA+4
CCAERRCD EQU   CCAPROB+2
CCAREASN EQU   CCAERRCD
CCARETRN EQU   CCAERRCD+1
CCACD1   EQU   CCARETRN
CCAFLG1  EQU   IGGCCA+14
CCAF1KEY EQU   CCAFLG1
CCAF1KGE EQU   CCAFLG1
CCAF1UP  EQU   CCAFLG1
CCAFLG2  EQU   IGGCCA+15
CCAF2COB EQU   CCAFLG2
CCAFLG3  EQU   IGGCCA+16
CCAFLG4  EQU   IGGCCA+17
CCAFLG5  EQU   IGGCCA+18
CCAFLG6  EQU   IGGCCA+19
CCAREUSE EQU   CCAFLG6
CCATCB   EQU   IGGCCA+20
CCARB    EQU   IGGCCA+24
CCACPL   EQU   IGGCCA+28
CCAACB   EQU   IGGCCA+32
CCAURAB  EQU   IGGCCA+40
CCASRCH  EQU   IGGCCA+44
CCASRID  EQU   CCASRCH
CCARAB0  EQU   IGGCCA+88
CCAR0FLG EQU   CCARAB0
CCAR0SEG EQU   CCARAB0+8
CCARAB1  EQU   IGGCCA+108
CCAR1FLG EQU   CCARAB1
CCAR1UR  EQU   CCAR1FLG
CCAR1SEG EQU   CCARAB1+8
CCARAB2  EQU   IGGCCA+128
CCAR2FLG EQU   CCARAB2
CCAR2UR  EQU   CCAR2FLG
CCAR2REC EQU   CCARAB2+4
CCAR2SEG EQU   CCARAB2+8
CCARAB3  EQU   IGGCCA+148
CCAR3FLG EQU   CCARAB3
CCAR3UR  EQU   CCAR3FLG
CCAR3REC EQU   CCARAB3+4
CCAR3SEG EQU   CCARAB3+8
CCARAB4  EQU   IGGCCA+168
CCAR4FLG EQU   CCARAB4
CCAR4SEG EQU   CCARAB4+8
CCARAB5  EQU   IGGCCA+188
CCAR5FLG EQU   CCARAB5
CCAR5SEG EQU   CCARAB5+8
CCATIQRN EQU   IGGCCA+212
CCADESA  EQU   IGGCCA+224
CCANDEXT EQU   CCADESA
CCASSVOL EQU   CCADESA+2
CCAEXTDE EQU   CCADESA+4
CCAEXTSS EQU   CCAEXTDE
CCAEXTAD EQU   CCAEXTDE+2
CCAEXTTH EQU   CCAEXTDE+6
CCAEQDQ  EQU   IGGCCA+280
CCAEDOPT EQU   CCAEQDQ+2
CCAMSSPL EQU   IGGCCA+300
CCAMNSPL EQU   CCAMSSPL+9
CCACMS   EQU   IGGCCA+316
CCACPE5  EQU   IGGCCA+324
CCACPE6  EQU   IGGCCA+340
CCACPE61 EQU   IGGCCA+344
CCACPE7  EQU   IGGCCA+348
CCAFLPT  EQU   IGGCCA+364
CCADICT  EQU   IGGCCA+372
CCAXCPL  EQU   IGGCCA+376
CCAMCPL  EQU   CCAXCPL
CCARABB  EQU   IGGCCA+380
CCARABF  EQU   IGGCCA+384
CCARABL  EQU   IGGCCA+388
CCALREL  EQU   IGGCCA+396
CCASN    EQU   IGGCCA+398
CCARBA   EQU   IGGCCA+448
CCACRAVL EQU   CCARBA
CCACRADT EQU   CCARBA+6
CCATLNG  EQU   IGGCCA+468
CCAIDPT3 EQU   IGGCCA+480
CCAGRGC  EQU   IGGCCA+493
CCAGRHI  EQU   IGGCCA+494
CCASSEQ  EQU   CCAGRHI
CCAALPTR EQU   IGGCCA+540
CCASMFPT EQU   IGGCCA+544
CCAFLG7  EQU   IGGCCA+552
CCASMFA  EQU   CCAFLG7
CCASMFBR EQU   CCAFLG7
CCAFLG8  EQU   IGGCCA+553
CCAFLG9  EQU   IGGCCA+554
CCARAEOV EQU   CCAFLG9
CCARESUM EQU   CCAFLG9
CCASMFLG EQU   IGGCCA+562
CCASMFG1 EQU   CCASMFLG
CCASMFUC EQU   CCASMFG1
CCASMFSR EQU   CCASMFG1
CCASMFAL EQU   CCASMFSR
CCABMINP EQU   IGGCCA+684
CCABMFLG EQU   CCABMINP+6
CCABMOUT EQU   IGGCCA+692
CCABMOFG EQU   CCABMOUT+4
CCATEMPS EQU   IGGCCA+744
CCAMNCAT EQU   IGGCCA+784
CCAMNAT  EQU   CCAMNCAT
MNATTOP  EQU   CCAMNAT
MNATFULL EQU   MNATTOP
MNATFLGS EQU   CCAMNAT+240
CCAMNLEN EQU   CCAMNCAT+249
CCAMNADR EQU   CCAMNCAT+252
CCAARFWA EQU   IGGCCA+1040
ARFGMLEN EQU   CCAARFWA
CCARVFG1 EQU   IGGCCA+1056
CCAREGS  EQU   IGGCCA+1060
CCABZSAV EQU   IGGCCA+1408
CCARALSA EQU   IGGCCA+1440
CCAFLG10 EQU   IGGCCA+1444
CCASMFP  EQU   IGGCCA+1480
CCASMFCD EQU   CCASMFP+3
CCAPROBX EQU   IGGCCA+1484
CCAERCDX EQU   CCAPROBX+2
CTGPL    EQU   0
CTGOPTN1 EQU   CTGPL
CTGOPTN2 EQU   CTGPL+1
CTGEXT   EQU   CTGOPTN2
CTGERASE EQU   CTGOPTN2
CTGSMF   EQU   CTGERASE
CTGREL   EQU   CTGSMF
CTGPURG  EQU   CTGOPTN2
CTGVMNT  EQU   CTGPURG
CTGOPTN3 EQU   CTGPL+2
CTGOPTN4 EQU   CTGPL+3
CTGENT   EQU   CTGPL+4
CTGFVT   EQU   CTGENT
CTGCAT   EQU   CTGPL+8
CTGCVOL  EQU   CTGCAT
CTGWKA   EQU   CTGPL+12
CTGDSORG EQU   CTGPL+16
CTGNOFLD EQU   CTGPL+19
CTGDDNM  EQU   CTGPL+20
CTGNEWNM EQU   CTGDDNM
CTGFBFLG EQU   CTGNEWNM+2
CTGJSCB  EQU   CTGPL+24
CTGFIELD EQU   CTGPL+28
CTGFL    EQU   0
CTGFLDNO EQU   CTGFL
CTGFLDCD EQU   CTGFL+1
CTGFLDGC EQU   CTGFL+2
CTGFLDRE EQU   CTGFL+3
CTGFLDWA EQU   CTGFL+4
CTGFLDNM EQU   CTGFL+8
CTGFLCHN EQU   CTGFL+12
CTGFLDAT EQU   CTGFL+16
CTGFLNG  EQU   CTGFLDAT
CTGFLPT  EQU   CTGFLDAT+4
USERWKA  EQU   0
WKALEN2  EQU   USERWKA+2
WKA      EQU   USERWKA+4
ENTNAMES EQU   WKA
CTGVLDSP EQU   0
FIELDNM  EQU   0
DICTENT  EQU   0
DICTFLGS EQU   DICTENT
DIC2ENT  EQU   0
DIC2FLGS EQU   DIC2ENT
CCARAB   EQU   0
CCARABFL EQU   CCARAB
CCACPE1  EQU   CCARAB+4
CCACPE2  EQU   CCARAB+8
CATGOPT  EQU   0
CATGOCI  EQU   CATGOPT
CATGOFLG EQU   CATGOCI
CATGOGC1 EQU   CATGOPT+3
CATGOSEQ EQU   CATGOPT+4
CATRCD   EQU   0
RCDCINO  EQU   CATRCD+1
RCDID    EQU   CATRCD+44
NREPLF   EQU   CATRCD+48
REPCNTRL EQU   0
EXTRCDPT EQU   REPCNTRL
VARFIELD EQU   0
VARLEN   EQU   VARFIELD
CNTRLINF EQU   0
LENFIX   EQU   CNTRLINF+1
CVTMAP   EQU   0
CVTTCBP  EQU   CVTMAP
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTCBSP  EQU   CVTMAP+256
CVTPURG  EQU   CVTMAP+260
CVTAMFF  EQU   CVTMAP+264
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
TCBWORDS EQU   0
TCBPTR   EQU   TCBWORDS+4
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBJPQ   EQU   TCB+44
TCBPURGE EQU   TCBJPQ
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTME   EQU   TCB+120
TCBJSTCB EQU   TCB+124
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBFOE   EQU   TCB+244
TCBESTAE EQU   TCB+264
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCB+276
TCBFBYT2 EQU   TCB+277
TCBRV124 EQU   TCB+278
TCBRV133 EQU   TCB+279
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
IFGACB   EQU   0
ACBCOMN  EQU   IFGACB
ACBLENG  EQU   ACBCOMN+2
ACBLENG2 EQU   ACBLENG
ACBAMBL  EQU   ACBCOMN+4
ACBJWA   EQU   ACBAMBL
ACBMACRF EQU   ACBCOMN+12
ACBMACR1 EQU   ACBMACRF
ACBADR   EQU   ACBMACR1
ACBCNV   EQU   ACBMACR1
ACBMACR2 EQU   ACBMACRF+1
ACBBUFPL EQU   ACBCOMN+20
ACBMACR3 EQU   ACBBUFPL
ACBRECFM EQU   ACBCOMN+24
ACBCCTYP EQU   ACBCOMN+25
ACBOPT   EQU   ACBCOMN+26
ACBDSORG EQU   ACBOPT
ACBCROPS EQU   ACBDSORG
ACBDVIND EQU   ACBDSORG
ACBEXLST EQU   ACBCOMN+36
ACBDDNM  EQU   ACBCOMN+40
ACBAMETH EQU   ACBDDNM+3
ACBOFLGS EQU   ACBCOMN+48
ACBEXFG  EQU   ACBOFLGS
ACBIOSFG EQU   ACBOFLGS
ACBINFLG EQU   ACBCOMN+50
ACBVVIC  EQU   ACBINFLG
ACBUJFCB EQU   ACBCOMN+52
ACBBLKSZ EQU   ACBCOMN+60
ACBUAPTR EQU   ACBCOMN+64
AMCBS    EQU   0
CBSCMP   EQU   AMCBS+16
CBSVSRT  EQU   AMCBS+32
IGGCAXWA EQU   0
CAXFLGS  EQU   IGGCAXWA+8
CAXEOV   EQU   CAXFLGS
CAXFLG2  EQU   IGGCAXWA+9
CAXF2REC EQU   CAXFLG2
CAXFLG3  EQU   IGGCAXWA+10
CAXCCR   EQU   IGGCAXWA+32
CAXCNAM  EQU   IGGCAXWA+52
CAXOPLST EQU   IGGCAXWA+96
COPTS    EQU   CAXOPLST
CTGFV    EQU   0
CTGFVPRO EQU   CTGFV+1
CTGFVSPC EQU   CTGFV+52
CTGFVAMD EQU   CTGFV+56
CTGFVLMT EQU   CTGFV+72
CTGFVGAT EQU   CTGFV+76
CTGWA    EQU   0
CTGWAVL  EQU   CTGWA
CTGVL    EQU   0
CTGVLX   EQU   0
CTGCV    EQU   0
CTGCVDSN EQU   CTGCV+6
MWA      EQU   0
VLST     EQU   MWA+2
CVOLIND  EQU   MWA+252
ASGO     EQU   1
PASSGO   EQU   1
PASSWORD EQU   PASSGO
USERAREC EQU   PASSGO+50
USERLIST EQU   0
LTLENGTH EQU   USERLIST
LTENTRY  EQU   USERLIST+2
LTRETCOD EQU   LTENTRY
LTVOLSER EQU   LTENTRY+2
SPACEPRM EQU   0
SPCOPTNS EQU   SPACEPRM+6
CTGDSATR EQU   0
CTGATR1  EQU   CTGDSATR
CTGATR2  EQU   CTGDSATR+1
RGATTRFL EQU   0
RGATTR1  EQU   RGATTRFL
RGATTSG1 EQU   RGATTRFL+1
DEVCHARS EQU   0
RTDEVUCB EQU   DEVCHARS
RTBOKAB  EQU   DEVCHARS+14
RTDVFLGS EQU   DEVCHARS+17
SALPARL  EQU   0
SALOPTNS EQU   SALPARL
SALSOURC EQU   SALPARL+2
SALDSCIN EQU   SALPARL+3
SALPARMS EQU   SALPARL+6
SALCALN  EQU   SALPARMS
SALUNITS EQU   SALPARMS+4
SALMXEXT EQU   SALPARMS+6
SALRLIST EQU   SALPARL+14
SALVLIST EQU   SALPARL+18
PRLIST   EQU   0
PRLLN    EQU   PRLIST
PRLENT   EQU   PRLIST+1
PRELENTF EQU   PRLENT
BUFSIZE  EQU   0
CATRECRD EQU   0
CATSN    EQU   0
CI       EQU   0
CLSCINO  EQU   0
DATEFLD  EQU   0
ENTRYNAM EQU   0
ENTVOL1  EQU   0
ENTVOL2  EQU   0
EXCPNAME EQU   0
IDAAMDS1 EQU   0
KEYINFO  EQU   0
LRECL    EQU   0
OWNIDFLD EQU   0
TNAM     EQU   0
WKAINPUT EQU   WKARETN
WKAICI   EQU   WKAINPUT+2
@NM00060 EQU   CTGDDNM
CTGPROB  EQU   @NM00060
CTGREASN EQU   CTGPROB+2
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
PSARSVTE EQU   PSARSVT
MCATDSTR EQU   CVTAMFF
CVTAMF1  EQU   MCATDSTR
CTGRBASE EQU   NREPLF+1
CNAME    EQU   CTGRBASE
CATTR    EQU   CTGRBASE+58
CATTR1   EQU   CATTR
CUNIQ    EQU   CATTR1
CREUSE   EQU   CATTR1
CATTR2   EQU   CATTR+1
COPEN    EQU   CTGRBASE+60
CSPACPRM EQU   CTGRBASE+65
CPRIM    EQU   CSPACPRM
CSEC     EQU   CSPACPRM+3
CSORT    EQU   CSPACPRM+6
CHIA     EQU   CTGRBASE+76
@NM00124 EQU   CATTR1
CCATTR   EQU   @NM00124
@NM00125 EQU   CCATTR
@NM00127 EQU   CATTR1
CRGATTR  EQU   @NM00127
CUPG     EQU   CRGATTR
FLC      EQU   PSA
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00128 EQU   CRGATTR
CUPD     EQU   CUPG
CPGSP    EQU   @NM00125
@NM00126 EQU   @NM00125
CEXT     EQU   CTGRBASE+86
CDOSUINF EQU   CTGRBASE+84
CLRECL   EQU   CTGRBASE+80
CHIU     EQU   CTGRBASE+72
CBUF     EQU   CTGRBASE+61
@NM00123 EQU   COPEN
COPENDS  EQU   COPEN
CNUS     EQU   CATTR2
@NM00122 EQU   CATTR2
CATTRSSH EQU   CATTR2
CATTRISH EQU   CATTR2
CTRKOV   EQU   CATTR1
CTEMP    EQU   CATTR1
CINHIB   EQU   CATTR1
CRECOV   EQU   CATTR1
CERASE   EQU   CATTR1
CSP      EQU   CATTR1
CEXP     EQU   CTGRBASE+55
CCRE     EQU   CTGRBASE+52
COWNID   EQU   CTGRBASE+44
@NM00112 EQU   MCATDSTR+1
@NM00111 EQU   CVTAMF1
AMF1NONX EQU   CVTAMF1
AMF1OPEN EQU   CVTAMF1
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
CTGREAS2 EQU   CTGREASN+1
CTGREAS1 EQU   CTGREASN
CTGMODID EQU   CTGPROB
WKAIEXT  EQU   WKAINPUT
PRLPAR2  EQU   PRELENTF+1
PRLPAR1  EQU   PRELENTF
SALAXWA  EQU   SALPARL+22
@NM00139 EQU   SALPARMS+7
SALBLKLN EQU   SALPARMS+2
@NM00138 EQU   SALPARL+1
RTTOLFCT EQU   DEVCHARS+18
RTTOLFLG EQU   RTDVFLGS
@NM00135 EQU   RTDVFLGS
RTKABFLG EQU   RTDVFLGS
@NM00134 EQU   RTDVFLGS
RTBONK   EQU   DEVCHARS+16
RTBOKLB  EQU   RTBOKAB+1
RTBOKNLB EQU   RTBOKAB
RTTRKSIZ EQU   DEVCHARS+12
RTNOTRKS EQU   DEVCHARS+10
RTNOCYLS EQU   DEVCHARS+8
RTMXDBLK EQU   DEVCHARS+4
RTCLSTYP EQU   RTDEVUCB+2
@NM00133 EQU   RTDEVUCB
@NM00132 EQU   RGATTSG1
RGATSUP1 EQU   RGATTSG1
@NM00131 EQU   RGATTR1
RGATTUPG EQU   RGATTR1
CTGDSNUS EQU   CTGATR2
@NM00130 EQU   CTGATR2
CTGDSSSH EQU   CTGATR2
CTGDSISH EQU   CTGATR2
CTGTRKOV EQU   CTGATR1
CTGDSTPX EQU   CTGATR1
CTGDSINH EQU   CTGATR1
CTGDSREC EQU   CTGATR1
CTGDSERA EQU   CTGATR1
CTGDSREU EQU   CTGATR1
CTGDSUNQ EQU   CTGATR1
CTGDSSPD EQU   CTGATR1
SPCROUND EQU   SPCOPTNS
SPCALXRQ EQU   SPCOPTNS
SPCMXIGR EQU   SPCOPTNS
SPCCNTIG EQU   SPCOPTNS
@NM00129 EQU   SPCOPTNS
SPCRQTYP EQU   SPCOPTNS
SPCSECDQ EQU   SPACEPRM+3
SPCPRIMQ EQU   SPACEPRM
LTRETCD2 EQU   LTRETCOD+1
LTRETCD1 EQU   LTRETCOD
USERAREV EQU   USERAREC+2
USERAREL EQU   USERAREC
USVRMDUL EQU   PASSGO+42
PASSATMP EQU   PASSGO+40
PASSPRMT EQU   PASSGO+32
READPW   EQU   PASSWORD+24
UPDATEPW EQU   PASSWORD+16
CIPW     EQU   PASSWORD+8
MASTERPW EQU   PASSWORD
ASCI     EQU   ASGO+1
ASTYPE   EQU   ASGO
CVLSER   EQU   MWA+259
TTR2     EQU   MWA+256
BIN0     EQU   CVOLIND+3
TTR1     EQU   CVOLIND
@NM00121 EQU   MWA+242
FSN      EQU   VLST+10
VOLSER   EQU   VLST+4
DEVTYP   EQU   VLST
VOLENTCT EQU   MWA
CTGCVCC  EQU   CTGCV+50
CTGCVDEV EQU   CTGCVDSN
CTGCVVOL EQU   CTGCV
CTGVLTTR EQU   CTGVLX+12
@NM00120 EQU   CTGVLX
CTGVLSEQ EQU   CTGVL+10
CTGVLDEV EQU   CTGVL+6
CTGVLVOL EQU   CTGVL
CTGWAGB  EQU   CTGWA+12
CTGWAGCT EQU   CTGWA+10
CTGWAUCT EQU   CTGWA+8
CTGWAVCT EQU   CTGWA+6
CTGWALV  EQU   CTGWA+4
CTGFVWKA EQU   CTGFV+88
CTGFVPWD EQU   CTGFV+84
CTGFVNAM EQU   CTGFV+80
CTGFVUPG EQU   CTGFVGAT
CTGFVEXT EQU   CTGFVLMT
CTGFVLRS EQU   CTGFV+68
CTGFVBUF EQU   CTGFV+64
CTGFVATR EQU   CTGFV+60
CTGFVFSN EQU   CTGFVAMD
CTGFVTTR EQU   CTGFVSPC
CTGFVDVT EQU   CTGFV+48
CTGFVRNG EQU   CTGFV+44
CTGFVVLT EQU   CTGFV+40
CTGFVCRE EQU   CTGFV+36
CTGFVEXP EQU   CTGFV+32
CTGFVOWN EQU   CTGFV+28
CTGFVSTY EQU   CTGFV+24
CTGFVENT EQU   CTGFV+20
CTGFVIND EQU   CTGFV+16
CTGFVVCH EQU   CTGFV+12
CTGFVICH EQU   CTGFV+8
CTGFVDCH EQU   CTGFV+4
@NM00119 EQU   CTGFV+3
CTGFVELM EQU   CTGFV+2
@NM00118 EQU   CTGFVPRO
CTGFVDRC EQU   CTGFVPRO
CTGFVNDC EQU   CTGFVPRO
CTGFVRVL EQU   CTGFVPRO
CTGFVAVL EQU   CTGFVPRO
CTGFVTYP EQU   CTGFV
CAXCRACB EQU   IGGCAXWA+112
CAXJDE   EQU   IGGCAXWA+108
CAXCCA   EQU   IGGCAXWA+104
CAXOPEWA EQU   IGGCAXWA+100
COPACB   EQU   CAXOPLST+1
@NM00117 EQU   COPTS
CENLST   EQU   COPTS
@NM00116 EQU   CAXCNAM+22
CAXRADDN EQU   CAXCNAM+14
CAXRATEP EQU   CAXCNAM+10
CAXRACTS EQU   CAXCNAM+6
CAXVOLID EQU   CAXCNAM
CAXRPL   EQU   IGGCAXWA+48
CAXRPLCT EQU   IGGCAXWA+46
CAXASID  EQU   IGGCAXWA+44
CAXFDCI  EQU   CAXCCR+9
CAXCDCI  EQU   CAXCCR+6
CAXNFCI  EQU   CAXCCR+3
CAXHACI  EQU   CAXCCR
CAXUCB   EQU   IGGCAXWA+28
CAXACB   EQU   IGGCAXWA+24
CAXDRWP  EQU   IGGCAXWA+20
CAXSCHWA EQU   IGGCAXWA+16
CAXATIOT EQU   IGGCAXWA+12
CAXACT   EQU   IGGCAXWA+11
@NM00115 EQU   CAXFLG3
CAXF3B6  EQU   CAXFLG3
CAXF3B5  EQU   CAXFLG3
@NM00114 EQU   CAXFLG3
CAXF3ANE EQU   CAXFLG3
CAXF3AT  EQU   CAXFLG3
CAXF2VTU EQU   CAXFLG2
CAXF2CA  EQU   CAXFLG2
CAXF2CLR EQU   CAXFLG2
CAXF2IOE EQU   CAXFLG2
CAXF2NCR EQU   CAXFLG2
CAXF2NDD EQU   CAXFLG2
CAXF2DT  EQU   CAXFLG2
CAXSCR   EQU   CAXFLGS
CAXCMR   EQU   CAXFLGS
CAXMCT   EQU   CAXFLGS
CAXCMP   EQU   CAXFLGS
CAXCLS   EQU   CAXFLGS
CAXOPN   EQU   CAXFLGS
CAXBLD   EQU   CAXFLGS
CAXCHN   EQU   IGGCAXWA+4
@NM00113 EQU   IGGCAXWA+1
CAXID    EQU   IGGCAXWA
CBSVPTR  EQU   CBSVSRT+4
CBSVUSE  EQU   CBSVSRT
CBSCRTCB EQU   AMCBS+28
CBSCRACA EQU   AMCBS+24
CBSCAXCN EQU   AMCBS+20
CBSMCUCB EQU   CBSCMP
CBSCBP   EQU   AMCBS+12
CBSACB   EQU   AMCBS+8
CBSMCSTA EQU   AMCBS+4
CBSSIZ   EQU   AMCBS+2
CBSID    EQU   AMCBS
ACBAPID  EQU   ACBCOMN+72
ACBCBMWA EQU   ACBCOMN+68
ACBLRECL EQU   ACBCOMN+62
ACBMSGLN EQU   ACBBLKSZ
ACBBUFSP EQU   ACBCOMN+56
@NM00110 EQU   ACBUJFCB+1
ACBOPTN  EQU   ACBUJFCB
@NM00109 EQU   ACBINFLG+1
ACBBYPSS EQU   ACBINFLG
ACBSDS   EQU   ACBVVIC
ACBUCRA  EQU   ACBINFLG
ACBSCRA  EQU   ACBINFLG
ACBCAT   EQU   ACBINFLG
ACBIJRQE EQU   ACBINFLG
ACBJEPS  EQU   ACBINFLG
@NM00108 EQU   ACBINFLG
ACBERFLG EQU   ACBCOMN+49
ACBBUSY  EQU   ACBIOSFG
ACBLOCK  EQU   ACBEXFG
@NM00107 EQU   ACBOFLGS
ACBDSERR EQU   ACBOFLGS
ACBOPEN  EQU   ACBOFLGS
ACBEOV   EQU   ACBOFLGS
@NM00106 EQU   ACBOFLGS
ACBDEB   EQU   ACBDDNM+5
ACBERFL  EQU   ACBDDNM+4
ACBAM    EQU   ACBAMETH
ACBINFL  EQU   ACBDDNM+2
ACBTIOT  EQU   ACBDDNM
ACBUEL   EQU   ACBEXLST
ACBPASSW EQU   ACBCOMN+32
ACBMSGAR EQU   ACBCOMN+28
@NM00105 EQU   ACBDSORG+1
ACBDORGA EQU   ACBDSORG+1
@NM00104 EQU   ACBDSORG
ACBOPTJ  EQU   ACBDVIND
ACBCRNRE EQU   ACBCROPS
ACBCRNCK EQU   ACBCROPS
ACBASA   EQU   ACBCCTYP
@NM00103 EQU   ACBCCTYP
ACBTRCID EQU   ACBCCTYP
@NM00102 EQU   ACBRECFM
ACBRECAF EQU   ACBRECFM
ACBJBUF  EQU   ACBBUFPL+2
ACBMACR4 EQU   ACBBUFPL+1
@NM00101 EQU   ACBMACR3
ACBNCFX  EQU   ACBMACR3
ACBSIS   EQU   ACBMACR3
ACBDFR   EQU   ACBMACR3
ACBICI   EQU   ACBMACR3
ACBGSR   EQU   ACBMACR3
ACBLSR   EQU   ACBMACR3
@NM00100 EQU   ACBMACR3
ACBBUFNI EQU   ACBCOMN+18
ACBBUFND EQU   ACBCOMN+16
ACBSTRNO EQU   ACBCOMN+15
ACBBSTNO EQU   ACBCOMN+14
ACBAIX   EQU   ACBMACR2
ACBDSN   EQU   ACBMACR2
ACBRST   EQU   ACBMACR2
ACBLOGON EQU   ACBMACR2
ACBSKP   EQU   ACBMACR2
@NM00099 EQU   ACBMACR2
ACBUBF   EQU   ACBMACR1
ACBOUT   EQU   ACBMACR1
ACBIN    EQU   ACBMACR1
ACBDIR   EQU   ACBMACR1
ACBSEQ   EQU   ACBMACR1
ACBBLK   EQU   ACBCNV
ACBADD   EQU   ACBADR
ACBKEY   EQU   ACBMACR1
ACBINRTN EQU   ACBCOMN+8
ACBIBCT  EQU   ACBJWA
ACBLEN2  EQU   ACBLENG2
ACBSTYP  EQU   ACBCOMN+1
ACBID    EQU   ACBCOMN
@NM00074 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBRV143 EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00073 EQU   TCB+296
TCBSVCA2 EQU   TCB+292
TCBSWASA EQU   TCB+288
TCBDBTB  EQU   TCB+284
TCBRPT   EQU   TCB+280
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBACTIV EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCB+274
TCBCCPVI EQU   TCB+272
TCBUKYSP EQU   TCB+268
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBRV308 EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCB+260
TCBTCBID EQU   TCB+256
TCBRSV96 EQU   TCB+252
TCBSWA   EQU   TCB+248
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBRV306 EQU   TCB+240
TCBRSV41 EQU   TCB+239
TCBTID   EQU   TCB+238
TCBRSVAA EQU   TCB+237
TCBABCUR EQU   TCB+236
TCBTMSAV EQU   TCB+232
TCBIOTIM EQU   TCB+228
TCBRTWA  EQU   TCB+224
TCBBACK  EQU   TCB+220
TCBTIRB  EQU   TCB+216
TCBAECB  EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBSVCS  EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBGPECB EQU   TCBFLGS7
TCBNTJS  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBCPU   EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBRSV95 EQU   TCBNDSP5
TCBRSV94 EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00072 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBNDINT EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBLJSND EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBSTCUR EQU   TCBNSTAE
TCBRV301 EQU   TCBNSTAE
TCBSYNCH EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBNSTAE
TCB33E   EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBAQE   EQU   TCB+156
TCBPQE   EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBJSTCA EQU   TCBJSTCB+1
TCBRSV16 EQU   TCBJSTCB
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBFSA
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBJPQ+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBDWSTA EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBADINP EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBFLGS2
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBNONPR EQU   TCBFLGS1
TCBFERA  EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBTIO   EQU   TCB+12
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00071 EQU   TCBPMASK
TCBRBP   EQU   TCB
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
NEXTTCB  EQU   TCBWORDS
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00070 EQU   CVTFIX+248
@NM00069 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVT      EQU   CVTMAP
CNTVAR   EQU   CNTRLINF
VARINFO  EQU   VARFIELD+2
REPGOPT  EQU   REPCNTRL+6
REPCNT   EQU   REPCNTRL+5
@NM00068 EQU   EXTRCDPT+3
EXTGOCI  EQU   EXTRCDPT
NREPCV   EQU   CATRCD+47
RCDSIZ   EQU   CATRCD+45
@NM00067 EQU   CATRCD+26
RCDDICTS EQU   CATRCD+22
RCDRACTS EQU   CATRCD+18
RCDCRADT EQU   CATRCD+14
RCDCRACI EQU   CATRCD+11
RCDCRAVL EQU   CATRCD+5
RCDRELID EQU   CATRCD+4
RCDKEYTY EQU   CATRCD
CATGOGC  EQU   CATGOGC1
CATGODEL EQU   CATGOGC1
CATGOEXT EQU   CATGOGC1
CATGODSP EQU   CATGOCI+1
@NM00066 EQU   CATGOFLG
CCACPE4  EQU   CCARAB+16
CCACPE3  EQU   CCARAB+12
@NM00065 EQU   CCARAB+2
CCARABRI EQU   CCARAB+1
CCARBUPD EQU   CCARABFL
@NM00064 EQU   CCARABFL
CCARBPA  EQU   CCARABFL
CCARBWR  EQU   CCARABFL
CCARBU2  EQU   CCARABFL
CCARBU1  EQU   CCARABFL
CCARBUR  EQU   CCARABFL
DIC2GC   EQU   DIC2ENT+3
DIC2LC   EQU   DIC2ENT+2
DIC2ST   EQU   DIC2ENT+1
@NM00063 EQU   DIC2FLGS
DIC2UPGD EQU   DIC2FLGS
DIC2SCRA EQU   DIC2FLGS
DIC2MV   EQU   DIC2FLGS
DIC2FLG  EQU   DIC2FLGS
DIC2COMB EQU   DIC2FLGS
DIC2REP  EQU   DIC2FLGS
DIC2VAR  EQU   DIC2FLGS
DICTGC   EQU   DICTENT+3
DICTLC   EQU   DICTENT+2
DICTST   EQU   DICTENT+1
@NM00062 EQU   DICTFLGS
DICTUPGD EQU   DICTFLGS
DICTSCRA EQU   DICTFLGS
DICTMV   EQU   DICTFLGS
DICTFLG  EQU   DICTFLGS
DICTCOMB EQU   DICTFLGS
DICTREP  EQU   DICTFLGS
DICTVAR  EQU   DICTFLGS
ENTNAMEV EQU   ENTNAMES+1
ENTNAMET EQU   ENTNAMES
WKALEN1  EQU   USERWKA
CTGFLDTS EQU   CTGFLDRE
@NM00061 EQU   CTGFLDRE
CTGPSWD  EQU   CTGJSCB
@NM00059 EQU   CTGFBFLG
CTGNGDSN EQU   CTGFBFLG
CTGGDGB  EQU   CTGFBFLG
CTGKEEP  EQU   CTGFBFLG
CTGPAR   EQU   CTGFBFLG
CTGFDBK  EQU   CTGNEWNM
CTGTYPE  EQU   CTGPL+18
@NM00058 EQU   CTGDSORG
CTGOPTNS EQU   CTGDSORG
@NM00057 EQU   CTGOPTN4
CTGBYPMT EQU   CTGOPTN4
@NM00056 EQU   CTGOPTN4
CTGDOCAT EQU   CTGOPTN4
CTGLBASE EQU   CTGOPTN4
CTGAM0   EQU   CTGOPTN3
CTGNUM   EQU   CTGOPTN3
CTGSRH   EQU   CTGOPTN3
CTGGDGL  EQU   CTGOPTN3
CTGSUPLT EQU   CTGOPTN3
CTGFUNC  EQU   CTGOPTN3
@NM00055 EQU   CTGOPTN2
CTGSCR   EQU   CTGOPTN2
CTGOVRID EQU   CTGOPTN2
CTGDISC  EQU   CTGOPTN2
CTGGTNXT EQU   CTGOPTN2
CTGRCATN EQU   CTGVMNT
CTGGTALL EQU   CTGREL
CTGNSVS  EQU   CTGEXT
CTGGENLD EQU   CTGOPTN1
CTGCNAME EQU   CTGOPTN1
CTGNAME  EQU   CTGOPTN1
CTGREAD  EQU   CTGOPTN1
CTGUPD   EQU   CTGOPTN1
CTGCI    EQU   CTGOPTN1
CTGMAST  EQU   CTGOPTN1
CTGBYPSS EQU   CTGOPTN1
CCAEND   EQU   IGGCCA+1492
CCADGDGA EQU   IGGCCA+1488
CCARETRX EQU   CCAERCDX+1
CCARESNX EQU   CCAERCDX
CCAMODDX EQU   CCAPROBX
CCASMFRC EQU   CCASMFP+2
CCASMFMD EQU   CCASMFP
CCAREWKA EQU   IGGCCA+1476
CCAVTS   EQU   IGGCCA+1468
CCARAVCA EQU   IGGCCA+1460
CCARANCA EQU   IGGCCA+1452
CCADICTS EQU   IGGCCA+1448
CCASUMTT EQU   IGGCCA+1445
@NM00054 EQU   CCAFLG10
CCAPRANX EQU   CCAFLG10
CCARARTC EQU   CCAFLG10
CCARAFEV EQU   CCAFLG10
CCACATAC EQU   CCAFLG10
CCAPDMW  EQU   CCAFLG10
CCAINCPL EQU   CCAFLG10
@NM00053 EQU   CCARALSA+2
CCACRABT EQU   CCARALSA
CCARAREC EQU   IGGCCA+1436
CCARARBA EQU   IGGCCA+1432
CCARARPL EQU   IGGCCA+1428
CCARAACB EQU   IGGCCA+1424
CCACRACI EQU   IGGCCA+1420
CCASBASE EQU   IGGCCA+1417
CCATNQCT EQU   IGGCCA+1416
CCACUMPL EQU   IGGCCA+1412
CCADSPWA EQU   CCABZSAV
CCAMODNM EQU   CCAREGS+4
@NM00052 EQU   CCAREGS
@NM00051 EQU   IGGCCA+1057
@NM00050 EQU   CCARVFG1
RVESBOR  EQU   CCARVFG1
RVESBO   EQU   CCARVFG1
RVCMSFG  EQU   CCARVFG1
RVARFI   EQU   CCARVFG1
RVCCAV   EQU   CCARVFG1
ARFSBECH EQU   CCAARFWA+12
ARFSBSCH EQU   CCAARFWA+8
ARFGMADR EQU   CCAARFWA+4
ARFLEN   EQU   ARFGMLEN+1
ARFGMLP  EQU   ARFGMLEN
CCAMNLL  EQU   CCAMNCAT+248
MNATARG2 EQU   CCAMNAT+244
MNATARG1 EQU   CCAMNAT+241
MNATSCLS EQU   MNATFLGS
@NM00049 EQU   MNATFLGS
MNATVAL  EQU   MNATFLGS
@NM00048 EQU   CCAMNAT+1
@NM00047 EQU   MNATTOP
CCABMRB2 EQU   IGGCCA+740
CCABMRB1 EQU   IGGCCA+736
CCABMWK4 EQU   IGGCCA+732
CCABMWK3 EQU   IGGCCA+728
CCABMWK2 EQU   IGGCCA+724
CCABMWK1 EQU   IGGCCA+720
CCABMSTR EQU   IGGCCA+718
CCABMBYT EQU   IGGCCA+716
CCABMBTL EQU   IGGCCA+714
CCABMBT1 EQU   IGGCCA+712
CCABMEND EQU   IGGCCA+708
CCABMPTR EQU   IGGCCA+704
CCABMGOP EQU   IGGCCA+700
CCABMPAD EQU   IGGCCA+699
@NM00046 EQU   IGGCCA+697
CCABMOST EQU   CCABMOFG
CCABMOTR EQU   CCABMOUT+2
CCABMONN EQU   CCABMOUT
@NM00045 EQU   CCABMINP+7
CCABMLST EQU   CCABMFLG
CCABMCCK EQU   CCABMFLG
CCABMSET EQU   CCABMFLG
CCABMCHK EQU   CCABMFLG
CCABMST  EQU   CCABMFLG
CCABMMIN EQU   CCABMINP+4
CCABMLIM EQU   CCABMINP+2
CCABMTRK EQU   CCABMINP
CCAR14S  EQU   IGGCCA+680
CCAXLATE EQU   IGGCCA+640
CCADEL2  EQU   IGGCCA+637
CCADEL1  EQU   IGGCCA+634
CCAVAR1  EQU   IGGCCA+614
CCAVAR   EQU   IGGCCA+594
CCADELN  EQU   IGGCCA+592
CCAVARPT EQU   IGGCCA+588
CCARBASE EQU   IGGCCA+584
CCARRAB  EQU   IGGCCA+580
CCAVARLN EQU   IGGCCA+578
CCACI3   EQU   IGGCCA+575
CCACI2   EQU   IGGCCA+572
CCACI1   EQU   IGGCCA+569
CCACHAIN EQU   IGGCCA+566
CCASMFLN EQU   IGGCCA+564
CCASMFG2 EQU   CCASMFLG+1
@NM00044 EQU   CCASMFG1
CCASMFDF EQU   CCASMFUC
CCASMFCT EQU   IGGCCA+560
CCASMFRD EQU   IGGCCA+556
CCANORBA EQU   IGGCCA+555
CCARAICI EQU   CCAFLG9
CCARAACT EQU   CCAFLG9
CCAUCRA  EQU   CCAFLG9
CCARACR  EQU   CCAFLG9
CCARALRD EQU   CCAFLG9
CCARABYC EQU   CCAFLG9
CCAAUCAT EQU   CCAFLG8
CCALEOD  EQU   CCAFLG8
CCAVRIND EQU   CCAFLG8
CCALPIND EQU   CCAFLG8
CCASCICK EQU   CCAFLG8
CCASCRA  EQU   CCAFLG8
CCAVBUFI EQU   CCAFLG8
CCADSRCL EQU   CCAFLG8
CCACRABU EQU   CCAFLG7
CCAFEOV  EQU   CCAFLG7
CCAROREQ EQU   CCAFLG7
CCAONCE  EQU   CCAFLG7
CCASMFEX EQU   CCAFLG7
CCALSP   EQU   CCAFLG7
CCALCPL  EQU   IGGCCA+548
CCAILNG2 EQU   IGGCCA+536
CCAILNG3 EQU   IGGCCA+532
CCASDWAP EQU   IGGCCA+528
CCACWAP  EQU   IGGCCA+524
CCACDTCT EQU   IGGCCA+522
CCADTCT  EQU   IGGCCA+520
CCACDTA  EQU   IGGCCA+516
CCADTA   EQU   IGGCCA+512
CCASVCI1 EQU   IGGCCA+509
CCASVCI  EQU   IGGCCA+506
CCADISP  EQU   IGGCCA+504
CCAREPCT EQU   IGGCCA+502
CCADIFF  EQU   IGGCCA+500
CCADLEN  EQU   IGGCCA+498
CCAIXTPL EQU   IGGCCA+496
CCAGRHI1 EQU   CCASSEQ
CCARCDID EQU   CCAGRGC
@NM00043 EQU   IGGCCA+492
CCANEFV  EQU   IGGCCA+491
CCAGVEXT EQU   IGGCCA+488
CCANEVV  EQU   IGGCCA+486
CCAGVCT  EQU   IGGCCA+484
CCARABSM EQU   CCAIDPT3
CCAIDPT2 EQU   IGGCCA+476
CCASMFIX EQU   IGGCCA+474
CCACNIX  EQU   IGGCCA+472
CCARBAL  EQU   IGGCCA+470
CCATLEN  EQU   CCATLNG
CCARBA2  EQU   CCARBA+16
CCARBA1  EQU   CCARBA+12
CCATT    EQU   CCARBA+10
CCACCHH2 EQU   CCACRADT
CCACCHH1 EQU   CCACRAVL+2
CCASS    EQU   CCACRAVL
CCATEST  EQU   IGGCCA+444
CCATNO   EQU   IGGCCA+442
CCATREL  EQU   IGGCCA+410
CCATNUM  EQU   IGGCCA+408
CCATNREL EQU   IGGCCA+406
CCAIXREL EQU   IGGCCA+404
CCAIXFPL EQU   IGGCCA+402
@NM00042 EQU   IGGCCA+400
CCASN1   EQU   CCASN
CCALREL1 EQU   CCALREL
CCAGC    EQU   IGGCCA+395
CCACBASE EQU   IGGCCA+392
CCARABPT EQU   IGGCCA+368
CCATFLPT EQU   CCAFLPT
CCAILNG  EQU   IGGCCA+360
CCASL    EQU   IGGCCA+358
CCAGOPLN EQU   IGGCCA+356
CCACPE71 EQU   IGGCCA+352
CCAIDPT  EQU   CCACPE7
CCARABSE EQU   CCACPE61
CCACPE53 EQU   IGGCCA+336
CCACPE52 EQU   IGGCCA+332
CCACPE51 EQU   IGGCCA+328
CCALUME  EQU   IGGCCA+324
CCAEXCMS EQU   CCACMS+4
CCACMSWA EQU   CCACMS
CCARPRM  EQU   IGGCCA+312
@NM00041 EQU   CCAMSSPL+10
@NM00040 EQU   CCAMSSPL+8
CCAMNPTR EQU   CCAMSSPL+4
CCAMNLLP EQU   CCAMSSPL
CCAMLRET EQU   IGGCCA+296
CCAEDUCB EQU   CCAEQDQ+12
CCAEDRNM EQU   CCAEQDQ+8
CCAEDQNM EQU   CCAEQDQ+4
CCAEDRCD EQU   CCAEQDQ+3
@NM00039 EQU   CCAEDOPT
CCAEDSHR EQU   CCAEDOPT
CCAEDRLN EQU   CCAEQDQ+1
CCAEDXFF EQU   CCAEQDQ
CCAASCI  EQU   IGGCCA+271
CCAASCIX EQU   IGGCCA+270
CCACRRP  EQU   IGGCCA+269
CCAASCIK EQU   IGGCCA+268
CCAEXTHH EQU   CCAEXTAD+2
CCAEXTCC EQU   CCAEXTAD
CCAIXEXT EQU   CCADESA+1
CCARPL1  EQU   IGGCCA+220
CCAQLEN  EQU   IGGCCA+219
CCASC    EQU   IGGCCA+218
CCATQDB  EQU   CCATIQRN+2
CCATASID EQU   CCATIQRN
CCARPLT  EQU   IGGCCA+211
CCARPLX  EQU   IGGCCA+210
CCARPLF  EQU   IGGCCA+209
CCARPLK  EQU   IGGCCA+208
CCACPE45 EQU   CCAR5SEG+8
CCACPE35 EQU   CCAR5SEG+4
CCACPE25 EQU   CCAR5SEG
CCAR5REC EQU   CCARAB5+4
@NM00038 EQU   CCARAB5+2
CCAR5RPL EQU   CCARAB5+1
CCAR5UPD EQU   CCAR5FLG
@NM00037 EQU   CCAR5FLG
CCAR5PA  EQU   CCAR5FLG
CCAR5WR  EQU   CCAR5FLG
CCAR5U2  EQU   CCAR5FLG
CCAR5U1  EQU   CCAR5FLG
CCAR5UR  EQU   CCAR5FLG
CCACPE44 EQU   CCAR4SEG+8
CCACPE34 EQU   CCAR4SEG+4
CCACPE24 EQU   CCAR4SEG
CCAR4REC EQU   CCARAB4+4
@NM00036 EQU   CCARAB4+2
CCAR4RPL EQU   CCARAB4+1
CCAR4UPD EQU   CCAR4FLG
@NM00035 EQU   CCAR4FLG
CCAR4PA  EQU   CCAR4FLG
CCAR4WR  EQU   CCAR4FLG
CCAR4U2  EQU   CCAR4FLG
CCAR4U1  EQU   CCAR4FLG
CCAR4UR  EQU   CCAR4FLG
CCACPE43 EQU   CCAR3SEG+8
CCACPE33 EQU   CCAR3SEG+4
CCACPE23 EQU   CCAR3SEG
@NM00034 EQU   CCARAB3+2
CCAR3RPL EQU   CCARAB3+1
CCAR3UPD EQU   CCAR3FLG
@NM00033 EQU   CCAR3FLG
CCAR3PA  EQU   CCAR3FLG
CCAR3WR  EQU   CCAR3FLG
CCAR3U2  EQU   CCAR3FLG
CCAR3U1  EQU   CCAR3FLG
CCACPE42 EQU   CCAR2SEG+8
CCACPE32 EQU   CCAR2SEG+4
CCACPE22 EQU   CCAR2SEG
@NM00032 EQU   CCARAB2+2
CCAR2RPL EQU   CCARAB2+1
CCAR2UPD EQU   CCAR2FLG
@NM00031 EQU   CCAR2FLG
CCAR2PA  EQU   CCAR2FLG
CCAR2WR  EQU   CCAR2FLG
CCAR2U2  EQU   CCAR2FLG
CCAR2U1  EQU   CCAR2FLG
CCACPE41 EQU   CCAR1SEG+8
CCACPE31 EQU   CCAR1SEG+4
CCACPE21 EQU   CCAR1SEG
CCAR1REC EQU   CCARAB1+4
@NM00030 EQU   CCARAB1+2
CCAR1RPL EQU   CCARAB1+1
CCAR1UPD EQU   CCAR1FLG
@NM00029 EQU   CCAR1FLG
CCAR1PA  EQU   CCAR1FLG
CCAR1WR  EQU   CCAR1FLG
CCAR1U2  EQU   CCAR1FLG
CCAR1U1  EQU   CCAR1FLG
CCACPE40 EQU   CCAR0SEG+8
CCACPE30 EQU   CCAR0SEG+4
CCACPE20 EQU   CCAR0SEG
CCAR0REC EQU   CCARAB0+4
@NM00028 EQU   CCARAB0+2
CCAR0RPL EQU   CCARAB0+1
CCAR0UPD EQU   CCAR0FLG
@NM00027 EQU   CCAR0FLG
CCAR0PA  EQU   CCAR0FLG
CCAR0WR  EQU   CCAR0FLG
CCAR0U2  EQU   CCAR0FLG
CCAR0U1  EQU   CCAR0FLG
CCAR0UR  EQU   CCAR0FLG
@NM00026 EQU   CCASRCH+3
CCASRCIN EQU   CCASRID
CCANPCCB EQU   IGGCCA+36
CCADPL   EQU   CCARB
CCALBCYL EQU   CCATCB
CCAMOD   EQU   CCAFLG6
CCAEXT   EQU   CCAFLG6
CCASUPFD EQU   CCAFLG6
CCAINIT  EQU   CCAFLG6
CCAMNOSP EQU   CCAFLG6
CCADELP  EQU   CCAFLG6
CCAMCODR EQU   CCAFLG6
CCATEX2  EQU   CCAFLG5
CCATEX1  EQU   CCAFLG5
CCATEX   EQU   CCAFLG5
CCATHIT  EQU   CCAFLG5
CCAMODPA EQU   CCAFLG5
CCAMEX1  EQU   CCAFLG5
CCAMEX   EQU   CCAFLG5
CCAMEX2  EQU   CCAFLG5
CCATCOMP EQU   CCAFLG4
CCAGVNE  EQU   CCAFLG4
CCAGVEX  EQU   CCAFLG4
CCAGVNBS EQU   CCAFLG4
CCAGVNF  EQU   CCAFLG4
CCAGVNC  EQU   CCAFLG4
CCAF4BYS EQU   CCAFLG4
CCAF4DRQ EQU   CCAFLG4
CCAEGREC EQU   CCAFLG3
CCALFT   EQU   CCAFLG3
CCAELC2  EQU   CCAFLG3
CCANF    EQU   CCAFLG3
CCAEXGR2 EQU   CCAFLG3
CCAGDSP  EQU   CCAFLG3
CCAGC4   EQU   CCAFLG3
CCAEXGR1 EQU   CCAFLG3
CCAF2SMO EQU   CCAFLG2
CCAF2CB  EQU   CCAF2COB
CCAF2CO  EQU   CCAF2COB
CCAF2RHS EQU   CCAFLG2
CCAF2XEQ EQU   CCAFLG2
CCAF2CCT EQU   CCAFLG2
CCAF2NVC EQU   CCAFLG2
CCAF2SYS EQU   CCAFLG2
CCAF1DK  EQU   CCAFLG1
CCAF1CR  EQU   CCAFLG1
CCAF1LRD EQU   CCAFLG1
CCAF1CNS EQU   CCAFLG1
CCAF1LPS EQU   CCAFLG1
CCACD2   EQU   IGGCCA+13
@NM00025 EQU   IGGCCA+8
CCACDR   EQU   CCAREASN
CCAMODID EQU   CCAPROB
CCASZ    EQU   IGGCCA+2
CCAID    EQU   IGGCCA
@NM00024 EQU   UPSPARM+216
@NM00023 EQU   UPSPD+2
UPSDREL  EQU   UPSPD
UPSTIME  EQU   UPSPWA
@NM00022 EQU   UPDIRSP+2
UPDDREL  EQU   UPDIRSP
@NM00021 EQU   UPSPHDR+2
UPSHREL  EQU   UPSPHDR
UPCRDTF  EQU   UPCRDT1+3
UPCRDTDD EQU   UPCRDT+1
UPCRDTY  EQU   UPCRDT
UPSOPT1  EQU   UPSPARM+23
UPSPACE  EQU   UPSPARM+20
UPNODSP  EQU   UPSPARM+18
UPREL    EQU   UPSPARM+16
UPCNT    EQU   UPSPARM+14
UPUCB    EQU   UPMXBLK
@NM00020 EQU   UPSFLG
UPSEXIT  EQU   UPSFLG
@NM00019 EQU   UPVOLVAR+134
UPEXLN   EQU   UPVOLVAR+132
@NM00018 EQU   UPVOLVAR+68
UPHKLN   EQU   UPVOLVAR+66
@NM00017 EQU   UPVOLVAR+2
UPLKLN   EQU   UPVOLVAR
@NM00016 EQU   UPITEX
UPEXTNP  EQU   UPITEX
UPSSDT   EQU   UPITEX
UPNBTK   EQU   UPVOLFIX+32
UPHKBA   EQU   UPVOLFIX+16
@NM00015 EQU   UPVLFLG
UPVLOV   EQU   UPVLFLG
UPVLCN   EQU   UPVLFLG
UPVLPR   EQU   UPVLFLG
UPFLSQ   EQU   UPVOLFIX+12
UPDEVT   EQU   UPVOLFIX+2
@NM00014 EQU   UPREPARM+11
UPEXIT   EQU   UPFLG2S
UPKSET   EQU   UPFLG2S
UPSRCH   EQU   UPFLG2S
UPKREQ   EQU   UPFLG2S
@NM00013 EQU   UPFLGS
@NM00012 EQU   UPFLGS
UPKRAN   EQU   UPFLGS
@NM00011 EQU   UPFLGS
@NM00010 EQU   UPFLGS
CTVDRSTT EQU   CTVDEXTN+4
CTVDIRTS EQU   CTVDEXTN
CTVDSDCI EQU   CTVDIR+2
CTVDSDLF EQU   CTVDSDSN+1
CTVDSDCV EQU   CTVDSDSN
CTVEXTNN EQU   CTVEXTNT+2
CTVEXTT  EQU   CTVEXTNT
CTVSQT   EQU   CTVDSPAC+18
CTVSPOPT EQU   CTVDSPAC+17
CTVNOEXT EQU   CTVDSPAC+16
@NM00009 EQU   CTVDSPFG
CTVCATDF EQU   CTVDSPFG
@NM00008 EQU   CTVDSPFG
CTVAUTO  EQU   CTVDSPFG
CTVUNIQ  EQU   CTVDSPFG
CTVF1PTR EQU   CTVDSPAC+10
CTVF1TME EQU   CTVDSPAC+2
CTVDSPLF EQU   CTVDSPSN+1
CTVDSPCV EQU   CTVDSPSN
CTVSMBIT EQU   CTVSPMAP+4
CTVSMLEN EQU   CTVSPMAP+2
CTVSMLF  EQU   CTVSMSN+1
CTVSMCV  EQU   CTVSMSN
CTVEGOPT EQU   CTVRCTRL+6
CTVEXRCT EQU   CTVRCTRL+5
@NM00007 EQU   CTVEXRPT+3
CTVEXGCI EQU   CTVEXRPT
CTVGOSEQ EQU   CTVGOPT+4
CTVGOGC  EQU   CTVGOGCI
CTVGODEL EQU   CTVGOGCI
CTVGOEXT EQU   CTVGOGCI
CTVGODSP EQU   CTVGOCI+1
CTVGOFLG EQU   CTVGOCI
CTVSPSXC EQU   CTVDSDIR+2
CTVSPSSN EQU   CTVDSDIR
CTVDSXCT EQU   CTVDSGRP+7
@NM00006 EQU   CTVDSDFL
CTVDSDCN EQU   CTVDSDFL
CTVDSCID EQU   CTVDSGRP+3
CTVDSNEX EQU   CTVDSGRP+2
CTVDSGLF EQU   CTVDSGRP+1
CTVDSGCV EQU   CTVDSGRP
CTVMAP   EQU   CTVDESGP+14
CTVMAPLN EQU   CTVDESGP+12
CTVDESHD EQU   CTVDESGP+10
CTVDESTK EQU   CTVDESGP+8
CTVSTHH  EQU   CTVSTDES+2
CTVSTCC  EQU   CTVSTDES
CTVDESUU EQU   CTVDESGP+2
CTVDESLF EQU   CTVDESGP+1
CTVDESCV EQU   CTVDESGP
CTVSPSQT EQU   CTVSPHDR+20
CTVSPSPO EQU   CTVSPHDR+19
CTVSPNEX EQU   CTVSPHDR+18
CTVSPNDS EQU   CTVSPHDR+16
@NM00005 EQU   CTVSPFLG
CTVSPCDF EQU   CTVSPFLG
CTVSPMCT EQU   CTVSPFLG
CTVSPUCT EQU   CTVSPFLG
CTVSPAUT EQU   CTVSPFLG
CTVSPUNQ EQU   CTVSPFLG
CTVF1ADR EQU   CTVSPHDR+10
CTVF1TIM EQU   CTVSPHDR+2
CTVSPHLF EQU   CTVSPHDR+1
CTVSPHCV EQU   CTVSPHDR
@NM00004 EQU   CTVOLRCD+74
CTVSYEDS EQU   CTVOLRCD+73
CTVOLFLG EQU   CTVOLRCD+72
CTVTLFAC EQU   CTVDVCHR+18
CTVTLFLG EQU   CTVDVFLG
@NM00003 EQU   CTVDVFLG
CTVBONK  EQU   CTVDVCHR+16
CTVBKLB  EQU   CTVDVCHR+15
CTVBKNLB EQU   CTVDVCHR+14
CTVTRKSZ EQU   CTVDVCHR+12
CTVNOCYL EQU   CTVDVCHR+8
CTVDEVTY EQU   CTVDVCHR
CTVOLTIM EQU   CTVOLRCD+44
CTVOLNME EQU   CTVOLRCD
@NM00002 EQU   WKAINFO
UPKEYD   EQU   UPKEY+2
UPKEYLN  EQU   UPKEY
UPKEYD1  EQU   UPKEY1
UPEXTD2  EQU   UPEXT1+2
@NM00001 EQU   RELINFO+2
AMDEXCP  EQU   AMDSTAT+44
AMDNCAS  EQU   AMDSTAT+40
AMDNCIS  EQU   AMDSTAT+36
AMDRETR  EQU   AMDSTAT+28
AMDUPR   EQU   AMDSTAT+24
AMDIREC  EQU   AMDSTAT+20
AMDDELR  EQU   AMDSTAT+16
AMDNLR   EQU   AMDSTAT+12
AMDNIL   EQU   AMDSTAT+8
AMDSTSP  EQU   AMDSTAT
@NM00137 EQU   IDAAMDSB+41
@NM00136 EQU   AMDATTR3
AMDLM    EQU   AMDATTR3
AMDWAIT  EQU   AMDATTR3
AMDBIND  EQU   AMDATTR3
AMDFAULT EQU   AMDATTR3
AMDUNQ   EQU   AMDATTR3
AMDPARDB EQU   IDAAMDSB+36
AMDMAXRR EQU   AMDSSRBA
AMDNSLOT EQU   AMDHLRBA
AMDLRECL EQU   IDAAMDSB+24
AMDFSCI  EQU   IDAAMDSB+16
AMDFSCA  EQU   IDAAMDSB+14
AMDPCTCI EQU   IDAAMDSB+11
AMDPCTCA EQU   IDAAMDSB+10
AMDKEYLN EQU   IDAAMDSB+8
AMDRKP   EQU   IDAAMDSB+6
AMDAXRKP EQU   AMDNEST
AMDLEN   EQU   IDAAMDSB+2
AMDSPAN  EQU   AMDATTR
AMDRRDS  EQU   AMDATTR
AMDRANGE EQU   AMDATTR
AMDORDER EQU   AMDATTR
AMDSDT   EQU   AMDATTR
AMDWCK   EQU   AMDATTR
AMDDST   EQU   AMDATTR
AMDSBID  EQU   IDAAMDSB
UPSEND   EQU   UPSVOL+22
UPSCNT   EQU   UPSVOL+20
UPSREL   EQU   UPSVOL+18
@NM00098 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00097 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSALITA  EQU   PSA+764
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00096 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00095 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00094 EQU   FLCFSA
@NM00093 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00092 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00091 EQU   FLCIOA
@NM00090 EQU   FLCMCLA+15
@NM00089 EQU   FLCMCLA+14
@NM00088 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00087 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00086 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00085 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00084 EQU   FLCPER
@NM00083 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00082 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00081 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00080 EQU   FLCPIILC
@NM00079 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00078 EQU   FLCSVILC
@NM00077 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00076 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00075 EQU   FLCICCW2+4
FLCCVT   EQU   FLCICCW2
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RT00178 EQU   @RC00161
@RC00392 EQU   @RC00381
@RC00445 EQU   @RC00441
@RC00467 EQU   @RC00466
@PB00009 EQU   @EL00001
@ENDDATA EQU   *
         END   IGG0CLBB,(C'PLS2301',0701,77041)
