TJDM     TITLE 'IGTJDM -- EOT/EOAS APIO CLEANUP                        *
                        '
IGTJDM   CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(16)                                          01S0001
         DC    C'IGTJDM    77.093'                              01S0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01S0001
         BALR  @07,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@07                                      01S0001
*   APCTPTR=R0P->SSCTSUSE;          /* ESTABLISH APCT ADDRESS        */
         LR    @08,R0P                                          01S0094
         L     APCTPTR,SSCTSUSE(,@08)                           01S0094
*   RSSOBPTR=R1P;                   /* SSOB ADDRESS IN SAFE REGISTER */
         LR    RSSOBPTR,R1P                                     01S0095
*   RFY                                                         01S0096
*     SSOB BASED(RSSOBPTR);         /* TELL PL/S OF THE SSOB BASE    */
*   RFY                                                         01S0097
*    (R0P,                                                      01S0097
*     R1P) UNRSTD;                  /* FINISHED WITH INPUT REGISTERS */
         EJECT
*                                                               01S0098
*   /*****************************************************************/
*   /*                                                               */
*   /* GET THE LOCAL AND CMS LOCKS. REQUIRED TO USE APVUWORK (PL/S   */
*   /* DYNAMIC AREA) AND TO SCAN/UPDATE THE APIO QUEUE.              */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0098
*   DO;                             /* START OF CODE SEGMENT         */
*                                                               02S0098
*     /***************************************************************/
*     /*                                                             */
*     /* OBTAIN THE LOCAL & CMS LOCKS. THE CMS LOCK IS REQUIRED TO   */
*     /* SCAN/UPDATE THE APIO CHAIN AND TO USE APVUWORK.             */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0099
*     GEN REFS(PSALITA) SETS(R0P,R1P,R11P,R12P,R13P,R14P);      02S0099
*                                                        /*
         LR    R0P,R12P            SAVE INPUT REGS 12 & 13
         LR    R1P,R13P            * (APCT, SAVEAREA)
         SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND, GET THE LOCAL LOCK     *
               RELATED=(APVUWORK,APIO-CHAIN)
         SETLOCK OBTAIN,TYPE=CMS,MODE=UNCOND, GET THE CMS LOCK         *
               RELATED=(APVUWORK,APIO-CHAIN)
         LR    R12P,R0P            RESTORE DESTROYED REGISTERS
         LR    R13P,R1P            * R11 & R14 STILL BAD
*   END;                            /* LOCAL & CMS LOCKS OWNED       */
         EJECT
*                                                               01S0101
*   /*****************************************************************/
*   /*                                                               */
*   /* BUILD AND INITIALIZE THE PL/S SAVEAREA AND WORKAREA. THE CMS  */
*   /* LOCK MUST BE OWNED FOR THIS PROCESS.                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0101
*   DO;                             /* START OF CODE SEGMENT         */
*                                                               02S0101
*     /***************************************************************/
*     /*                                                             */
*     /* BUILD AND INITIALIZE A SAVEAREA/WORKAREA. USE 'APVUWORK' FOR*/
*     /* THE DYNAMIC AREA. NOTE THAT THE CMS LOCK MUST BE OWNED TO   */
*     /* USE THIS AREA (FOR SERIALIZATION). CARE MUST BE USED TO     */
*     /* INSURE MORE DYNAMIC STORAGE IS NOT USED THAN EXISTS IN      */
*     /* APMVWORK (2000 BYTES). THE ADDRESS OF 'APVU' IS CONTAINED IN*/
*     /* THE APCT (APCTAPVU).                                        */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0102
*     RFY                                                       02S0102
*       R1P RSTD;                   /* CHAIN REGISTER                */
*     R1P=ADDR(APVUWORK);           /* POINT TO WORKAREA             */
*                                                               02S0103
         L     R1P,APCTAPVU(,APCTPTR)                           02S0103
         LA    R1P,APVUWORK(,R1P)                               02S0103
*     /***************************************************************/
*     /*                                                             */
*     /* BUILD AND CHAIN OS SAVEAREAS TOGETHER. DO NOT USE THE VPSS  */
*     /* SAVEAREA FORMAT. THEREFORE STANDARD VPSS ROUTINES CANNOT BE */
*     /* CALLED (SINCE THE LOCAL AND CMS LOCKS ARE OWNED, GETMAINS   */
*     /* FOR ADDITIONAL AREAS CANNOT BE TOLERATED).                  */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0104
*     APSVPTR->APSVNEXT=R1P;        /* FORWARD POINTER               */
         ST    R1P,APSVNEXT(,APSVPTR)                           02S0104
*     R1P->APSVPREV=APSVPTR;        /* BACKWARD CHAIN POINTER        */
         ST    APSVPTR,APSVPREV(,R1P)                           02S0105
*     APSVPTR=R1P;                  /* POINT TO NEW SAVEAREA         */
         LR    APSVPTR,R1P                                      02S0106
*     RFY                                                       02S0107
*       R1P UNRSTD;                 /* FINISHED WITH REGISTER 1      */
*     RFY                                                       02S0108
*       APDATA RSTD;                /* SET APDATA TO ADDRESS         */
*     APDATA=ADDR(APSV)+APSVOSLN;   /* OF PL/S DYNAMIC AREA          */
         LA    APDATA,72(,APSVPTR)                              02S0109
*     GEN(USING @DATD,APDATA)                                   02S0110
*     NOSETS REFS(APDATA);          /* (AFTER SAVEAREA).             */
         USING @DATD,APDATA
*   END;                            /* END OF CODE SEGMENT           */
         EJECT
*                                                               01S0112
*   /*****************************************************************/
*   /*                                                               */
*   /* INITIALIZE THE RECOVERY AREA AND ISSUE A SETFRR TO COVER THIS */
*   /* PROGRAM'S PROCESSING.                                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0112
*   DO;                             /* START OF CODE SEGMENT         */
*                                                               02S0112
*     /***************************************************************/
*     /*                                                             */
*     /* ESTABLISH RECOVERY ENVIRONMENT. THIS EXIT WILL GAIN CONTROL */
*     /* IF AN ABEND OCCURS. A DUMP IS TAKEN, THE APPROPRIATE ERROR  */
*     /* FLAGS SET, AND CONTROL PASSED TO THE CLEANUP ROUTINE TO     */
*     /* RELEASE RESOURCES BEFORE RETURNING TO THE CALLER.           */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0113
*                                                               02S0113
*     /***************************************************************/
*     /*                                                             */
*     /* BUILD ESTAE/FRR EXIT PARAMETER LIST (APES)                  */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0113
*     MVC(APES(1:LENGTH(CAPES)),CAPES);/* INITIALIZE APES CONSTANTS  */
         MVC   APES(136),CAPES                                  02S0113
*     APESADDR=ADDR(APES);          /* ESTAE/SETFRR PARM VALUE       */
         LA    @08,APES                                         02S0114
         ST    @08,APESADDR                                     02S0114
*     APESREGP=ADDR(APESREGZ);      /* DEFAULT REGISTER SAVEAREA     */
         LA    @08,APESREGZ                                     02S0115
         ST    @08,APESREGP                                     02S0115
*     RFY                                                       02S0116
*      (R15P) RSTD;                 /* SET REGISTER 15 TO            */
*     R15P=ADDR(EXIT);              /* BACKOUT ROUTINE               */
         LA    R15P,EXIT                                        02S0117
*     STM(R0F,R15F,APESREGZ);       /* SAVE REGISTERS FOR RETRY      */
         STM   R0F,R15F,APESREGZ                                02S0118
*     RFY                                                       02S0119
*       R15P UNRSTD;                /* FINISHED WITH 15              */
*                                                               02S0119
*     /***************************************************************/
*     /*                                                             */
*     /* ISSUE SETFRR TO COVER THE PROCESSING. PARAMETER LIST IS     */
*     /* 'APES' BLOCK. THE EXIT ROUTINE CAN PROCESS BOTH (E)STAE AND */
*     /* FRR ENTRIES.                                                */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0120
*     APESCODE=CERRN01;             /* SETFRR ERROR CODE             */
         MVI   APESCODE,X'01'                                   02S0120
*     RFY                                                       02S0121
*       R15P RSTD;                  /* SETFRR SETS TO PARM LIST      */
*     GEN REFS(PSA,PSACSTK,PSALSFCC,APCTZUKA,APCT,APCTPTR,FRRSFRRA,
*         FRRSENTR,FRRSPARM,FRRSCURR,FRRSLAST,FRRS) SETS(R14F,R15F,R15P
*         );                                                    02S0122
*                                   /*
         SETFRR A,FRRAD=APCTZUKA-APCT(,APCTPTR), IGTUKA IS EXIT RTN    *
               PARMAD=(R15P),      * SAVE @ 6-WORD PARM FIELD HERE     *
               CLEAR=NO,           * DO NOT CLEAR PARM FIELD           *
               WRKREGS=(R14F,R15F), * WORK REGISTERS                   *
               RELATED=(FREELLCK,APES) * APES IS INPUT
*     APESCODE=CERRN99;             /* RESET ERROR CODE              */
         MVI   APESCODE,X'03'                                   02S0123
*     R15P->I031P=ADDR(APES);       /* 1ST WORD OF PARM LIST IS 02S0124
*                                      ADDRESS OF 'APES'             */
         LA    @14,APES                                         02S0124
         ST    @14,I031P(,R15P)                                 02S0124
*     RFY                                                       02S0125
*       R15P UNRSTD;                /* SETFRR PARM FIELD SET         */
*     APESFFRR=BON;                 /* SHOW SETFRR ISSUED            */
         OI    APESFFRR,B'10000000'                             02S0126
*   END;                            /* RECOVERY ENVIRONMENT SET      */
         EJECT
*                                                               01S0128
*   /*****************************************************************/
*   /*                                                               */
*   /* SCAN THE APIO QUEUE AND RELEASE ANY APIO'S STILL OWNED BY THE */
*   /* TERMINATING TASK OR ADDRESS SPACE                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0128
*   DO;                                                         02S0128
*                                                               02S0128
*     /***************************************************************/
*     /*                                                             */
*     /* SCAN THE APIO'S TO FIND ENTRIES BELONGING TO THE TERMINATED */
*     /* TASK OR ADDRESS SPACE. IF THIS IS A JOBSTEP TERMINATION,    */
*     /* TREAT LIKE AN ADDRESS SPACE TERMINATION (THE INITIATOR DOES */
*     /* NOT USE VPSS).                                              */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0129
*     DRETRY(01)=APESREGF;          /* SAVE CURRENT APESREGS         */
         L     @08,APESREGP                                     02S0129
         L     @15,APESREGF(,@08)                               02S0129
         ST    @15,DRETRY                                       02S0129
*     DRETRY(02)=APESREGE;          /* FOR REGISTERS 14 & 15         */
         L     @15,APESREGE(,@08)                               02S0130
         ST    @15,DRETRY+4                                     02S0130
*     APESREGE=ADDR(SCANIO1);       /* RETRY APIO SCAN POINT         */
         LA    @15,SCANIO1                                      02S0131
         ST    @15,APESREGE(,@08)                               02S0131
*     APESREGF=ADDR(FIXAPIO);       /* FIX APIO CHAIN ROUTINE        */
         LA    @15,FIXAPIO                                      02S0132
         ST    @15,APESREGF(,@08)                               02S0132
*     GOTO SCANIO2;                 /* SKIP RETRY SCAN CODE          */
         B     SCANIO2                                          02S0133
*SCANIO1:                           /* RETRY APIO SCAN               */
*     DO;                           /* ENTRY FROM ESTAE/FRR RETRY    */
*                                                               02S0134
SCANIO1  DS    0H                                               02S0135
*       /*************************************************************/
*       /*                                                           */
*       /* ENTRY FROM ESTAE/FRR RETRY (IGTUKA). RETRY DOES NOT INSURE*/
*       /* REGISTERS 0-5, 8-11, 14-15 VALID SINCE NOT SAVED IN       */
*       /* APESREGS. ISSUE DUMMY RESTRICT TO WIPE PL/S OPTIMIZATION  */
*       /* MEMORY OF CURRENT REGISTER VALUES                         */
*       /*                                                           */
*       /*************************************************************/
*                                                               02S0135
*       RFY                                                     02S0135
*        (R0RSTD,                                               02S0135
*         R1RSTD,                                               02S0135
*         R2RSTD,                                               02S0135
*         R3RSTD,                                               02S0135
*         R4RSTD,                                               02S0135
*         R5RSTD,                   /* 6-7 BASES                     */
*         R8RSTD,                                               02S0135
*         R9RSTD,                                               02S0135
*         R10RSTD,                                              02S0135
*         R11RSTD,                  /* 12-13 APCT/APSV PTRS          */
*         R14RSTD,                                              02S0135
*         R15RSTD) RSTD;            /* KEEP PL/S FROM CARRYING DATA  */
*       GEN(SPACE ,);               /* NULL CODE                     */
         SPACE ,
*       RFY                                                     02S0137
*        (R0RSTD,                                               02S0137
*         R1RSTD,                                               02S0137
*         R2RSTD,                                               02S0137
*         R3RSTD,                                               02S0137
*         R4RSTD,                                               02S0137
*         R5RSTD,                   /* 6-7 BASES                     */
*         R8RSTD,                                               02S0137
*         R9RSTD,                                               02S0137
*         R10RSTD,                                              02S0137
*         R11RSTD,                  /* 12-13 APCT/APSV PTRS          */
*         R14RSTD,                                              02S0137
*         R15RSTD) UNRSTD;          /* ALLOW PL/S TO USE REGS AGAIN  */
*     END;                          /* RETRY ENVIRONMENT SET         */
*     APESREGF=DRETRY(01);          /* RESTORE ORIGINAL              */
         L     @08,APESREGP                                     02S0139
         L     @15,DRETRY                                       02S0139
         ST    @15,APESREGF(,@08)                               02S0139
*     APESREGE=DRETRY(02);          /* REGISTERS 14 & 15             */
         L     @15,DRETRY+4                                     02S0140
         ST    @15,APESREGE(,@08)                               02S0140
*     DO;                           /* ERROR RECOVERY COMPLETE       */
*       APESFPRV=BOFF;              /* RESET RECURSION FLAG.         */
         NI    APESFPRV,B'10111111'                             02S0142
*       APESCODE=CERRN99;           /* RESET ERROR CODE              */
         MVI   APESCODE,X'03'                                   02S0143
*       APESFREC=BON;               /* RESET DUMP/LOG FLAGS          */
*       APESFSDP=BON;               /* TO THEIR NORMAL VALUES        */
         OI    APESFREC,B'01100000'                             02S0145
*     END;                          /* ALL INDICATORS RESET 2ND ABEND
*                                      TERMINATES REQUEST            */
*     APESCOD1=0;                   /* CLEAR ERROR INDICATOR         */
         MVI   APESCOD1,X'00'                                   02S0147
*SCANIO2:                           /* FIRST PASS START              */
*                                                               02S0148
*     /***************************************************************/
*     /*                                                             */
*     /* SET RASCBPTR = ADDRESS OF ASCB BEING PROCESSED AND RTCCBPTR */
*     /* = ADDRESS OF THE TCB BEING PROCESSED (=0 IF ADDRESS-SPACE OR*/
*     /* JOBSTEP TERMINATION).                                       */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0148
*     RFY                                                       02S0148
*      (RZERO,                      /* WORK REGISTER (=0)            */
*       RASCBPTR,                   /* ADDRESS SPACE                 */
*       RTCBPTR) RSTD;              /* TCB (OR 0)                    */
SCANIO2  DS    0H                                               02S0149
*     RZERO=0;                      /* ZERO VALUE                    */
         SLR   RZERO,RZERO                                      02S0149
*     RASCBPTR=SSETASCB;            /* ASCB (MAY NOT BE CURRENT)     */
         L     @05,SSOBINDV(,RSSOBPTR)                          02S0150
         L     RASCBPTR,SSETASCB(,@05)                          02S0150
*     RTCBPTR=SSETCBA;              /* TCB IF EOT                    */
         L     RTCBPTR,SSETCBA(,@05)                            02S0151
*     IF((SSOBFUNC=SSOBEOM)|        /* IF JOBSTEP OR ADDRESS SPACE   */
*         (RTCBPTR->TCBJSTCA=RTCBPTR))/* TERMINATION, SET            */
*       THEN                        /* RTCBPTR=0 (TO SHOW PURGE OF   */
         CLC   SSOBFUNC(2,RSSOBPTR),@CH00037                    02S0152
         BE    @RT00152                                         02S0152
         L     @05,TCBJSTCA-1(,RTCBPTR)                         02S0152
         LA    @05,0(,@05)                                      02S0152
         CR    RTCBPTR,@05                                      02S0152
         BNE   @RF00152                                         02S0152
@RT00152 DS    0H                                               02S0153
*       RTCBPTR=RZERO;              /* ALL APIO'S FOR THIS ASID).    */
*                                                               02S0153
         LR    RTCBPTR,RZERO                                    02S0153
*     /***************************************************************/
*     /*                                                             */
*     /* SCAN ALL APIOS. NOTE -- LOCAL & CMS LOCKS MUST BE HELD.     */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0154
*     RFY                                                       02S0154
*       RAPIOPTR RSTD;              /* APIO SCANNER                  */
@RF00152 DS    0H                                               02S0155
*     RAPIOPTR=APCTAPIO;            /* 1ST APIO                      */
         L     RAPIOPTR,APCTAPIO(,APCTPTR)                      02S0155
*     RFY                                                       02S0156
*       APIO BASED(RAPIOPTR);       /* TELL PL/S                     */
*     APESCODE=CERRN02;             /* APIO CHAIN ERROR              */
         MVI   APESCODE,X'02'                                   02S0157
*     GEN(MODESET EXTKEY=DATAMGT)                               02S0158
*     NOREFS NOSETS;                /* APIO KEY. MAY NOT UPDATE PL/S
*                                      DYNAMIC AREA.                 */
         MODESET EXTKEY=DATAMGT
*     DO WHILE(RAPIOPTR^=RZERO);    /* SCAN ALL APIO ENTRIES         */
         B     @DE00159                                         02S0159
@DL00159 DS    0H                                               02S0160
*       GEN NOREFS NOSETS FLOWS(SCANIO1,FIXAPIO) SEQFLOW;       02S0160
*                                          /* SHOW RTNS USED (NO CODE)
*       IF APIOID^=APIOIDC THEN     /* IF BAD APIO, FIX-UP CHAIN     */
         CLC   APIOID(4,RAPIOPTR),@CC03378                      02S0161
         BE    @RF00161                                         02S0161
*         DO;                       /* FORCE ABEND TO LOG ERROR &
*                                      PASS CONTROL TO THE (E)STAE OR
*                                      FRR EXIT ROUTINE.             */
*           DO;                     /* ABEND(APCTABND)               */
*             RESPECIFY                                         02S0164
*              (GPR01F) RESTRICTED;                             02S0164
*             GPR01F=APCTABND;      /* COMP CODE IN REG 1            */
         L     GPR01F,APCTABND(,APCTPTR)                        02S0165
*             SVC(13);              /* ISSUE ABEND SVC               */
         SVC   13                                               02S0166
*             RESPECIFY                                         02S0167
*              (GPR01F) UNRESTRICTED;                           02S0167
*           END;                    /* ABEND(APCTABND) FORCE ABEND   */
*           GEN NOREFS NOSETS NOSEQFLOW FLOWS(APCVZUKA);        02S0169
*                                                  /* NO CODE
*         END;                      /* ABEND ISSUED                  */
*       IF(RASCBPTR=APIOASCB)&      /* IF CORRECT ADDRESS SPACE &    */
*           ((RTCBPTR=RZERO)|       /* EITHER MEMORY-TERM/JOBSTEP OR */
*           (APIODEB->DEBTCBB=RTCBPTR)) THEN/* CORRECT SUBTASK       */
@RF00161 C     RASCBPTR,APIOASCB(,RAPIOPTR)                     02S0171
         BNE   @RF00171                                         02S0171
         CR    RTCBPTR,RZERO                                    02S0171
         BE    @RT00171                                         02S0171
         L     @02,APIODEB(,RAPIOPTR)                           02S0171
         L     @02,DEBTCBB-1(,@02)                              02S0171
         LA    @02,0(,@02)                                      02S0171
         CR    RTCBPTR,@02                                      02S0171
         BNE   @RF00171                                         02S0171
@RT00171 DS    0H                                               02S0172
*         DO;                       /* THEN MUST RELEASE.            */
*                                                               02S0172
*           /*********************************************************/
*           /*                                                       */
*           /* APIO FOUND WHICH MUST BE RELEASED (RAPIOPTR->APIO)    */
*           /*                                                       */
*           /*********************************************************/
*                                                               02S0173
*           IF APIOACTV^=0 THEN     /* IF APIO HAS OUTSTANDING I/O   */
         CLI   APIOACTV(RAPIOPTR),0                             02S0173
         BE    @RF00173                                         02S0173
*             DO;                   /* THEN MUST CLEAN-UP THE APIO.  */
*               IF SSOBFUNC=SSOBEOT THEN/* IF END-OF-TASK            */
         CLC   SSOBFUNC(2,RSSOBPTR),@CH00045                    02S0175
         BNE   @RF00175                                         02S0175
*                 DO;               /* START OF SEGMENT              */
*                                                               03S0176
*                   /*************************************************/
*                   /*                                               */
*                   /* APIO SHOWS ACTIVE. FREE THE ASSOCIATED I/O    */
*                   /* RESOURCES BY CALLING IGTKCA (TERMINATION      */
*                   /* ROUTINE). NOTE THAT THE I/O MUST HAVE BEEN    */
*                   /* TERMINATED BY NOW SINCE ALL DATASETS SHOULD   */
*                   /* HAVE BEEN CLOSED AND I/O PURGED BY EOT OR EOM.*/
*                   /*                                               */
*                   /*************************************************/
*                                                               03S0177
*                   DRETRY(04)=APESRTRY;/* SAVE CURRENT RETRY POINT  */
         L     @02,APESREGP                                     03S0177
         L     @15,APESRTRY(,@02)                               03S0177
         ST    @15,DRETRY+12                                    03S0177
*                   APESRTRY=ADDR(IOACTV1);/* NEW RETRY POINT        */
         LA    @15,IOACTV1                                      03S0178
         ST    @15,APESRTRY(,@02)                               03S0178
*                   GEN(SPACE ,)                                03S0179
*                   NOREFS NOSETS FLOWS(IOACTV1) SEQFLOW;/* PL/S FLOW
*                                      ANALYSIS                      */
         SPACE ,
*                   DO;             /* FORCE ABEND TO LOG ERROR &
*                                      PASS CONTROL TO THE (E)STAE OR
*                                      FRR EXIT ROUTINE.             */
*                     DO;           /* ABEND(APCTABND)               */
*                       RESPECIFY                               04S0182
*                        (GPR01F) RESTRICTED;                   04S0182
*                       GPR01F=APCTABND;/* COMP CODE IN REG 1        */
         L     GPR01F,APCTABND(,APCTPTR)                        04S0183
*                       SVC(13);    /* ISSUE ABEND SVC               */
         SVC   13                                               04S0184
*                       RESPECIFY                               04S0185
*                        (GPR01F) UNRESTRICTED;                 04S0185
*                     END;          /* ABEND(APCTABND) FORCE ABEND   */
*                     GEN NOREFS NOSETS NOSEQFLOW FLOWS(APCVZUKA);
*                                                  /* NO CODE
*                   END;            /* ABEND ISSUED                  */
*IOACTV1:                           /* STAE RECOVERY POINT           */
*                   DO;             /* ENTRY FROM ESTAE/FRR RETRY    */
*                                                               03S0189
IOACTV1  DS    0H                                               03S0190
*                     /***********************************************/
*                     /*                                             */
*                     /* ENTRY FROM ESTAE/FRR RETRY (IGTUKA). RETRY  */
*                     /* DOES NOT INSURE REGISTERS 0-5, 8-11, 14-15  */
*                     /* VALID SINCE NOT SAVED IN APESREGS. ISSUE    */
*                     /* DUMMY RESTRICT TO WIPE PL/S OPTIMIZATION    */
*                     /* MEMORY OF CURRENT REGISTER VALUES           */
*                     /*                                             */
*                     /***********************************************/
*                                                               03S0190
*                     RFY                                       03S0190
*                      (R0RSTD,                                 03S0190
*                       R1RSTD,                                 03S0190
*                       R2RSTD,                                 03S0190
*                       R3RSTD,                                 03S0190
*                       R4RSTD,                                 03S0190
*                       R5RSTD,     /* 6-7 BASES                     */
*                       R8RSTD,                                 03S0190
*                       R9RSTD,                                 03S0190
*                       R10RSTD,                                03S0190
*                       R11RSTD,    /* 12-13 APCT/APSV PTRS          */
*                       R14RSTD,                                03S0190
*                       R15RSTD) RSTD;/* KEEP PL/S FROM CARRYING DATA*/
*                     GEN(SPACE ,); /* NULL CODE                     */
         SPACE ,
*                     RFY                                       03S0192
*                      (R0RSTD,                                 03S0192
*                       R1RSTD,                                 03S0192
*                       R2RSTD,                                 03S0192
*                       R3RSTD,                                 03S0192
*                       R4RSTD,                                 03S0192
*                       R5RSTD,     /* 6-7 BASES                     */
*                       R8RSTD,                                 03S0192
*                       R9RSTD,                                 03S0192
*                       R10RSTD,                                03S0192
*                       R11RSTD,    /* 12-13 APCT/APSV PTRS          */
*                       R14RSTD,                                03S0192
*                       R15RSTD) UNRSTD;/* ALLOW PL/S TO USE REGS
*                                      AGAIN                         */
*                   END;            /* RETRY ENVIRONMENT SET         */
*                   APESRTRY=ADDR(IOACTV2);/* NEW RETRY POINT        */
         LA    @02,IOACTV2                                      03S0194
         L     @01,APESREGP                                     03S0194
         ST    @02,APESRTRY(,@01)                               03S0194
*                   DO;             /* ERROR RECOVERY COMPLETE       */
*                     APESFPRV=BOFF;/* RESET RECURSION FLAG.         */
         NI    APESFPRV,B'10111111'                             03S0196
*                     APESCODE=CERRN99;/* RESET ERROR CODE           */
         MVI   APESCODE,X'03'                                   03S0197
*                     APESFREC=BON; /* RESET DUMP/LOG FLAGS          */
*                     APESFSDP=BON; /* TO THEIR NORMAL VALUES        */
         OI    APESFREC,B'01100000'                             03S0199
*                   END;            /* ALL INDICATORS RESET          */
*                   APESCOD1=0;     /* RESET ERROR INDICATOR         */
*                                                               03S0201
         MVI   APESCOD1,X'00'                                   03S0201
*                   /*************************************************/
*                   /*                                               */
*                   /* CALL IGTKBC (I/O TERMINATION ROUTINE) TO FREE */
*                   /* THE RESOURCES                                 */
*                   /*                                               */
*                   /*************************************************/
*                                                               03S0202
*                   APIORET=BON;    /* IGTKBC TO BE SUBROUTINE       */
         OI    APIORET(RAPIOPTR),B'00100000'                    03S0202
*                   RFY                                         03S0203
*                     R1P RSTD;     /* R1 MUST POINT                 */
*                   R1P=ADDR(APIO); /* TO APIO (ALSO IOSB)           */
         LR    R1P,RAPIOPTR                                     03S0204
*                   APESMOD='IGTKBC  ';/* SHOW ROUTINE IN CONTROL    */
         MVC   APESMOD(8),@CC03679                              03S0205
*                   APESPROC='IGTKBC  ';/* IF IGTKBC.                */
         MVC   APESPROC(8),@CC03679                             03S0206
*                   CALL APIOTERM->APCVZKBC;/* CALL TERMINATION 03S0207
*                                      ROUTINE                       */
         L     @15,APIOTERM(,RAPIOPTR)                          03S0207
         BALR  @14,@15                                          03S0207
*                   RFY                                         03S0208
*                     R1P UNRSTD;   /* DONE WITH REG 1               */
*IOACTV2:                           /* STAE RETRY POINT              */
*                   DO;             /* ENTRY FROM ESTAE/FRR RETRY    */
*                                                               03S0209
IOACTV2  DS    0H                                               03S0210
*                     /***********************************************/
*                     /*                                             */
*                     /* ENTRY FROM ESTAE/FRR RETRY (IGTUKA). RETRY  */
*                     /* DOES NOT INSURE REGISTERS 0-5, 8-11, 14-15  */
*                     /* VALID SINCE NOT SAVED IN APESREGS. ISSUE    */
*                     /* DUMMY RESTRICT TO WIPE PL/S OPTIMIZATION    */
*                     /* MEMORY OF CURRENT REGISTER VALUES           */
*                     /*                                             */
*                     /***********************************************/
*                                                               03S0210
*                     RFY                                       03S0210
*                      (R0RSTD,                                 03S0210
*                       R1RSTD,                                 03S0210
*                       R2RSTD,                                 03S0210
*                       R3RSTD,                                 03S0210
*                       R4RSTD,                                 03S0210
*                       R5RSTD,     /* 6-7 BASES                     */
*                       R8RSTD,                                 03S0210
*                       R9RSTD,                                 03S0210
*                       R10RSTD,                                03S0210
*                       R11RSTD,    /* 12-13 APCT/APSV PTRS          */
*                       R14RSTD,                                03S0210
*                       R15RSTD) RSTD;/* KEEP PL/S FROM CARRYING DATA*/
*                     GEN(SPACE ,); /* NULL CODE                     */
         SPACE ,
*                     RFY                                       03S0212
*                      (R0RSTD,                                 03S0212
*                       R1RSTD,                                 03S0212
*                       R2RSTD,                                 03S0212
*                       R3RSTD,                                 03S0212
*                       R4RSTD,                                 03S0212
*                       R5RSTD,     /* 6-7 BASES                     */
*                       R8RSTD,                                 03S0212
*                       R9RSTD,                                 03S0212
*                       R10RSTD,                                03S0212
*                       R11RSTD,    /* 12-13 APCT/APSV PTRS          */
*                       R14RSTD,                                03S0212
*                       R15RSTD) UNRSTD;/* ALLOW PL/S TO USE REGS
*                                      AGAIN                         */
*                   END;            /* RETRY ENVIRONMENT SET         */
*                   APESRTRY=DRETRY(04);/* RESET RETRY REGISTER      */
         L     @02,DRETRY+12                                    03S0214
         L     @01,APESREGP                                     03S0214
         ST    @02,APESRTRY(,@01)                               03S0214
*                   DO;             /* ERROR RECOVERY COMPLETE       */
*                     APESFPRV=BOFF;/* RESET RECURSION FLAG.         */
         NI    APESFPRV,B'10111111'                             03S0216
*                     APESCODE=CERRN99;/* RESET ERROR CODE           */
         MVI   APESCODE,X'03'                                   03S0217
*                     APESFREC=BON; /* RESET DUMP/LOG FLAGS          */
*                     APESFSDP=BON; /* TO THEIR NORMAL VALUES        */
         OI    APESFREC,B'01100000'                             03S0219
*                   END;            /* ALL INDICATORS RESET          */
*                   APESCOD1=0;     /* CLEAR ERROR CODE              */
         MVI   APESCOD1,X'00'                                   03S0221
*                   APESMOD='IGTJDM  ';/* RESET MODULE IN CONTROL    */
         MVC   APESMOD(8),@CC03593                              03S0222
*                   APESPROC='IGTJDM  ';/* TO BE IGTJDM.             */
         MVC   APESPROC(8),@CC03593                             03S0223
*                 END;              /* I/O CLEARED                   */
*               APIOACTV=0;         /* INSURE APIO NO LONGER ACTIVE  */
@RF00175 MVI   APIOACTV(RAPIOPTR),X'00'                         02S0225
*             END;                  /* APIO NO LONGER ACTIVE         */
*           APIOASCB=RZERO;         /* RESET APIO 'OWNED' FIELDS     */
@RF00173 ST    RZERO,APIOASCB(,RAPIOPTR)                        02S0227
*           APIODEB=RZERO;          /* (ASCB/DEB)                    */
         ST    RZERO,APIODEB(,RAPIOPTR)                         02S0228
*         END;                      /* APIO RELEASED                 */
*                                                               02S0229
*       /*************************************************************/
*       /*                                                           */
*       /* APIO PROCESSED. GO DO NEXT ENTRY                          */
*       /*                                                           */
*       /*************************************************************/
*                                                               02S0230
*       RAPIOPTR=APIOAPIO;          /* NEXT APIO (IF ANY)            */
@RF00171 L     RAPIOPTR,APIOAPIO(,RAPIOPTR)                     02S0230
*     END;                          /* GO PROCESS                    */
*                                                               02S0231
@DE00159 CR    RAPIOPTR,RZERO                                   02S0231
         BNE   @DL00159                                         02S0231
*     /***************************************************************/
*     /*                                                             */
*     /* ALL APPROPRIATE APIO'S RELEASED                             */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0232
*     GEN(MODESET EXTKEY=ZERO)                                  02S0232
*     NOREFS NOSETS;                /* RESUME STANDARD KEY           */
         MODESET EXTKEY=ZERO
*     APESCODE=CERRN99;             /* RESET ERROR CODE              */
         MVI   APESCODE,X'03'                                   02S0233
*     APESREGF=DRETRY(01);          /* RESTORE ORIGINAL RECOVERY     */
         L     @02,APESREGP                                     02S0234
         L     @15,DRETRY                                       02S0234
         ST    @15,APESREGF(,@02)                               02S0234
*     APESREGE=DRETRY(02);          /* REGISTERS (14 & 15).          */
*                                                               02S0235
         L     @15,DRETRY+4                                     02S0235
         ST    @15,APESREGE(,@02)                               02S0235
*     /***************************************************************/
*     /*                                                             */
*     /* IF THIS IS END-OF-ADDRESS-SPACE OR JOBSTEP TERMINATION      */
*     /* (RTCBPTR = 0), THEN RESET APVUAPIO FOR THIS ASID (IMPLIES NO*/
*     /* APIO RECOVERY REQUIRED FOR THIS USER).                      */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0236
*     IF RTCBPTR=0 THEN             /* IF EOAS OR EOT FOR JOBSTEP,   */
         LTR   RTCBPTR,RTCBPTR                                  02S0236
         BNZ   @RF00236                                         02S0236
*       APVUAPIO(RASCBPTR->ASCBASID)=BOFF;/* RESET ACTIVE INDICATOR  */
         LH    @10,ASCBASID(,RASCBPTR)                          02S0237
         N     @10,@CF03770                                     02S0237
         SLA   @10,2                                            02S0237
         L     @01,APCTAPVU(,APCTPTR)                           02S0237
         ALR   @01,@10                                          02S0237
         LA    @14,APVUAPIO-4(,@01)                             02S0237
         LR    @11,@14                                          02S0237
         LA    @02,3                                            02S0237
         NR    @11,@02                                          02S0237
         LCR   @11,@11                                          02S0237
         ALR   @14,@11                                          02S0237
         L     @02,0(,@14)                                      02S0237
@GL00004 LR    @15,@02                                          02S0237
         N     @15,@CB03766+3(@11)                              02S0237
         CS    @02,@15,0(@14)                                   02S0237
         BNE   @GL00004                                         02S0237
*     RFY                                                       02S0238
*       APIO;                       /* FINISHED WITH BLOCKS AND      */
@RF00236 DS    0H                                               02S0239
*     RFY                                                       02S0239
*      (RAPIOPTR,                                               02S0239
*       RASCBPTR,                                               02S0239
*       RTCBPTR,                                                02S0239
*       RZERO) UNRSTD;              /* REGISTERS.                    */
*   END;                            /* 'OWNED' APIO'S RELEASED       */
         EJECT
*EXIT:                              /* ESTAE RETRY POINT             */
*                                                               01S0241
*   /*****************************************************************/
*   /*                                                               */
*   /* CANCEL THE RECOVERY ENVIRONMENT                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0241
*   DO;                             /* ENTRY FROM ESTAE/FRR RETRY    */
*                                                               01S0241
EXIT     DS    0H                                               01S0242
*     /***************************************************************/
*     /*                                                             */
*     /* ENTRY FROM ESTAE/FRR RETRY (IGTUKA). RETRY DOES NOT INSURE  */
*     /* REGISTERS 0-5, 8-11, 14-15 VALID SINCE NOT SAVED IN         */
*     /* APESREGS. ISSUE DUMMY RESTRICT TO WIPE PL/S OPTIMIZATION    */
*     /* MEMORY OF CURRENT REGISTER VALUES                           */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0242
*     RFY                                                       01S0242
*      (R0RSTD,                                                 01S0242
*       R1RSTD,                                                 01S0242
*       R2RSTD,                                                 01S0242
*       R3RSTD,                                                 01S0242
*       R4RSTD,                                                 01S0242
*       R5RSTD,                     /* 6-7 BASES                     */
*       R8RSTD,                                                 01S0242
*       R9RSTD,                                                 01S0242
*       R10RSTD,                                                01S0242
*       R11RSTD,                    /* 12-13 APCT/APSV PTRS          */
*       R14RSTD,                                                01S0242
*       R15RSTD) RSTD;              /* KEEP PL/S FROM CARRYING DATA  */
*     GEN(SPACE ,);                 /* NULL CODE                     */
         SPACE ,
*     RFY                                                       01S0244
*      (R0RSTD,                                                 01S0244
*       R1RSTD,                                                 01S0244
*       R2RSTD,                                                 01S0244
*       R3RSTD,                                                 01S0244
*       R4RSTD,                                                 01S0244
*       R5RSTD,                     /* 6-7 BASES                     */
*       R8RSTD,                                                 01S0244
*       R9RSTD,                                                 01S0244
*       R10RSTD,                                                01S0244
*       R11RSTD,                    /* 12-13 APCT/APSV PTRS          */
*       R14RSTD,                                                01S0244
*       R15RSTD) UNRSTD;            /* ALLOW PL/S TO USE REGS AGAIN  */
*   END;                            /* RETRY ENVIRONMENT SET         */
*   DO;                             /* START OF CODE SEGMENT         */
*                                                               02S0246
*     /***************************************************************/
*     /*                                                             */
*     /* CANCEL THE RECOVERY ENVIRONMENT (THE OUTSTANDING SETFRR)    */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0247
*     APESFFRR=BOFF;                /* SHOW NOT IN FRR               */
         NI    APESFFRR,B'01111111'                             02S0247
*     APESCODE=CERRN01;             /* ERROR CODE                    */
         MVI   APESCODE,X'01'                                   02S0248
*     GEN REFS(PSA,PSACSTK,FRRS,FRRSCURR,FRRSEMP,FRRSELEN,FRRSCURR)
*         SETS(R14F,R15F);                                      02S0249
*                               /*
         SETFRR D,                 CANCEL THE CURRENT ENTRY            *
               WRKREGS=(R14F,R15F), * WORK REGISTERS                   *
               RELATED=(GETLLCK,APES) * APES WAS INPUT
*     APESCODE=CERRN99;             /* RESET ERROR CODE              */
         MVI   APESCODE,X'03'                                   02S0250
*   END;                            /* RECOVERY ENVIRONMENT CANCELLED*/
         EJECT
*                                                               01S0252
*   /*****************************************************************/
*   /*                                                               */
*   /* RELEASE THE PL/S DYNAMIC AREA AND THIS PROGRAM'S SAVEAREA.    */
*   /* THIS AREAS MUST BE RELEASED PRIOR TO RELEASING THE CMS LOCK   */
*   /* (APVUWORK SERIALIZATION LOCK).                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0252
*   DO;                             /* START OF CODE SEGMENT         */
*                                                               02S0252
*     /***************************************************************/
*     /*                                                             */
*     /* RELEASE THE CURRENT SAVEAREA/WORKAREA. RESET REGISTER 13    */
*     /* (APSVPTR) TO THE ADDRESS OF THE INPUT SAVEAREA. ALSO TELL   */
*     /* THE ASSEMBLER THAT THE PL/S WORKAREA IS NO LONGER           */
*     /* ADDRESSABLE.                                                */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0253
*     APSVPTR=APSVPTR->APSVPREV;    /* POINT TO PREVIOUS SAVEAREA    */
         L     APSVPTR,APSVPREV(,APSVPTR)                       02S0253
*     GEN(DROP  APDATA)                                         02S0254
*     REFS(APDATA) NOSETS;          /* TELL ASSEMBLER                */
         DROP  APDATA
*   END;                            /* END OF CODE SEGMENT           */
         EJECT
*                                                               01S0256
*   /*****************************************************************/
*   /*                                                               */
*   /* RELEASE THE CMS AND LOCAL LOCKS. NOTE: THE PL/S SAVEAREA AND  */
*   /* DYNAMIC AREA CANNOT BE REFERENCED SINCE THE CMS LOCK IS       */
*   /* REQUIRED TO SERIALIZE ITS USE.                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0256
*   DO;                             /* START OF CODE SEGMENT         */
*                                                               02S0256
*     /***************************************************************/
*     /*                                                             */
*     /* RELEASE THE CMS AND LOCAL LOCKS. NOTE THAT THE PL/S         */
*     /* SAVEAREA/WORKAREA (APVUWORK) CANNOT BE USED SINCE THE CMS   */
*     /* LOCK IS REQUIRED (APVUWORK SERIALIZATION IS CMS LOCK).      */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0257
*     GEN REFS(PSALITA) SETS(R0P,R1P,R11P,R12P,R13P,R14P);      02S0257
*                                                        /*
         LR    R0P,R12P            SAVE INPUT REGS 12 & 13
         LR    R1P,R13P            * (APCT, SAVEAREA)
         SETLOCK RELEASE,TYPE=CMS, RELEASE THE CMS LOCK                *
               RELATED=(APVUWORK,APIO-CHAIN)
         SETLOCK RELEASE,TYPE=LOCAL, RELEASE THE LOCAL LOCK            *
               RELATED=(APVUWORK,APIO-CHAIN)
         LR    R12P,R0P            RESTORE DESTROYED REGISTERS
         LR    R13P,R1P            * R11 & R14 STILL BAD
*   END;                            /* CMS AND LOCAL LOCKS RELEASED  */
         EJECT
*                                                               01S0259
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESSING COMPLETE. RETURN TO THE CALLER                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0259
*   GEN(USING @DATD,APDATA)                                     01S0259
*   REFS(APDATA) NOSETS;            /* SHOW DYNAMIC AREA AVAILABLE IN
*                                      THE SUBROUTINES               */
         USING @DATD,APDATA
*   RETURN CODE(0);                 /* RETURN TO THE CALLER          */
         SLR   @15,@15                                          01S0260
         L     @14,12(,@13)                                     01S0260
         LM    @00,@12,20(@13)                                  01S0260
         BR    @14                                              01S0260
         EJECT
*FIXAPIO:                           /* REPAIR THE APIO CHAIN         */
*   PROC;                           /* ENTERED IN KEY-0              */
*                                                               01S0261
FIXAPIO  STM   @14,@12,@SA00002                                 01S0261
*   /*****************************************************************/
*   /*                                                               */
*   /* ENTERED WHEN AN ERROR OCCURS SCANNING OR UPDATING THE APIO    */
*   /* CHAIN. THIS ROUTINE WILL ATTEMPT TO REPAIR THE CHAIN. IF      */
*   /* REPAIR IS IMPOSSIBLE, THE QUEUE HEADERS AND RESET TO ZERO,    */
*   /* THUS ELIMINATING THE ENTIRE APIO QUEUE. CONTROL THEN RETURNS  */
*   /* TO CALL QUEUE USER (RETURN ADDRESS CONTAINED IN REGISTER 14). */
*   /* CONTROL MUST BE RETURNED IN KEY-0, WITH THE RECURSION FLAG    */
*   /* (APESPREV) SET ON. THIS PREVENTS RECURSION LOOPING IF THE     */
*   /* CALLER HAS A PROBLEM (RATHER THAN AN INVALID APIO QUEUE). ON  */
*   /* ENTRY, THE LOCAL AND CMS LOCKS MUST BE OWNED (THIS IS A       */
*   /* REQUIREMENT FOR TASKS UPDATING THE APIO QUEUE).               */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0262
*                                                               01S0262
*   /*****************************************************************/
*   /*                                                               */
*   /* SAVE CURRENT RECOVERY ENVIRONMENT. SET RETRY FOR 'FIXAPIO1',  */
*   /* WHICH ELIMINATES THE APIO CHAIN.                              */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0262
*   DO;                             /* ENTRY FROM ESTAE/FRR RETRY    */
*                                                               01S0262
*     /***************************************************************/
*     /*                                                             */
*     /* ENTRY FROM ESTAE/FRR RETRY (IGTUKA). RETRY DOES NOT INSURE  */
*     /* REGISTERS 0-5, 8-11, 14-15 VALID SINCE NOT SAVED IN         */
*     /* APESREGS. ISSUE DUMMY RESTRICT TO WIPE PL/S OPTIMIZATION    */
*     /* MEMORY OF CURRENT REGISTER VALUES                           */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0263
*     RFY                                                       01S0263
*      (R0RSTD,                                                 01S0263
*       R1RSTD,                                                 01S0263
*       R2RSTD,                                                 01S0263
*       R3RSTD,                                                 01S0263
*       R4RSTD,                                                 01S0263
*       R5RSTD,                     /* 6-7 BASES                     */
*       R8RSTD,                                                 01S0263
*       R9RSTD,                                                 01S0263
*       R10RSTD,                                                01S0263
*       R11RSTD,                    /* 12-13 APCT/APSV PTRS          */
*       R14RSTD,                                                01S0263
*       R15RSTD) RSTD;              /* KEEP PL/S FROM CARRYING DATA  */
*     GEN(SPACE ,);                 /* NULL CODE                     */
         SPACE ,
*     RFY                                                       01S0265
*      (R0RSTD,                                                 01S0265
*       R1RSTD,                                                 01S0265
*       R2RSTD,                                                 01S0265
*       R3RSTD,                                                 01S0265
*       R4RSTD,                                                 01S0265
*       R5RSTD,                     /* 6-7 BASES                     */
*       R8RSTD,                                                 01S0265
*       R9RSTD,                                                 01S0265
*       R10RSTD,                                                01S0265
*       R11RSTD,                    /* 12-13 APCT/APSV PTRS          */
*       R14RSTD,                                                01S0265
*       R15RSTD) UNRSTD;            /* ALLOW PL/S TO USE REGS AGAIN  */
*   END;                            /* RETRY ENVIRONMENT SET         */
*   DRETRY(03)=APESRTRY;            /* SAVE CURRENT RETRY POINT      */
         L     @08,APESREGP                                     01S0267
         L     @15,APESRTRY(,@08)                               01S0267
         ST    @15,DRETRY+8                                     01S0267
*   APESRTRY=ADDR(FIXAPIO1);        /* NEW RETRY -- ELIMINATE APIO Q */
         LA    @15,FIXAPIO1                                     01S0268
         ST    @15,APESRTRY(,@08)                               01S0268
*   GEN NOREFS NOSETS SEQFLOW FLOWS(FIXAPIO1);                  01S0269
*                                   /* NO CODE -- SHOW FIXAPIO1 USED
*   DO;                             /* ERROR RECOVERY COMPLETE       */
*     APESFPRV=BOFF;                /* RESET RECURSION FLAG.         */
         NI    APESFPRV,B'10111111'                             01S0271
*     APESCODE=CERRN99;             /* RESET ERROR CODE              */
         MVI   APESCODE,X'03'                                   01S0272
*     APESFREC=BON;                 /* RESET DUMP/LOG FLAGS          */
*     APESFSDP=BON;                 /* TO THEIR NORMAL VALUES        */
         OI    APESFREC,B'01100000'                             01S0274
*   END;                            /* ALL INDICATORS RESET          */
*                                                               01S0275
*   /*****************************************************************/
*   /*                                                               */
*   /* BUILD Q-VERIFICATION BLOCK                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0276
*   RFY                                                         01S0276
*     APIO BASED(R0P);              /* R0P NOT VALID. ONLY APIO 01S0276
*                                      OFFSETS REFERENCED (PL/S REQ) */
*   QVPL=QVPL&&QVPL;                /* RESET ALL FIELDS              */
         XC    QVPL(40),QVPL                                    01S0277
*   QVPLEVR=ADDR(FIXAPIOV);         /* APIO VERIFICATION ROUTINE     */
         LA    @08,FIXAPIOV                                     01S0278
         ST    @08,QVPLEVR                                      01S0278
*   QVPLWKA=ADDR(DFXAPIOW);         /* Q-VERIFICATION WORKAREA       */
         LA    @08,DFXAPIOW                                     01S0279
         ST    @08,QVPLWKA                                      01S0279
*   QVPLHDR=ADDR(APCTAPIO);         /* Q-HEADER (FORWARD)            */
         LA    @08,APCTAPIO(,APCTPTR)                           01S0280
         ST    @08,QVPLHDR                                      01S0280
*   QVPLFPTR=ADDR(APIOAPIO)-ADDR(APIO);/* FORWARD POINTER OFFSET     */
         MVC   QVPLFPTR(2),@CH03760                             01S0281
*   QVPLTRLR=ADDR(APCTIOAP);        /* Q-HEADER (BACKWARD)           */
         LA    @08,APCTIOAP(,APCTPTR)                           01S0282
         ST    @08,QVPLTRLR                                     01S0282
*   QVPLBPTR=ADDR(APIOIOAP)-ADDR(APIO);/* BACK CHAIN OFFSET          */
         MVC   QVPLBPTR(2),@CH03761                             01S0283
*   RFY                                                         01S0284
*     APIO;                         /* NO APIO POINTER               */
*                                                               01S0284
*   /*****************************************************************/
*   /*                                                               */
*   /* CALL IEAVEQV3 -- DOUBLE THREADED CHAIN VERIFICATION. APCT     */
*   /* (KEY-1) AND APIO (KEY-5) UPDATE REQUIRES IEAVEQV3 TO EXECUTE  */
*   /* IN KEY-0.                                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0285
*   RFY                                                         01S0285
*     R1P RSTD;                     /* INPUT REGISTER                */
*   R1P=ADDR(QVPL);                 /* IEAVEQV3 PARM AREA            */
         LA    R1P,QVPL                                         01S0286
*   CALL IEAVEQV3;                  /* VERIFY QUEUE                  */
         L     @08,CVTPTR                                       01S0287
         L     @15,CVTQV3(,@08)                                 01S0287
         BALR  @14,@15                                          01S0287
*   GEN NOREFS NOSETS FLOWS(FIXAPIOV) SEQFLOW;                  01S0288
*                                   /* NO CODE - SHOW FIXAPIOV USED
*   RFY                                                         01S0289
*     R1P UNRSTD;                   /* FINISHED WITH PARMS           */
*   APESFPRV=BON;                   /* RESET ERROR STATUS            */
         OI    APESFPRV,B'01000000'                             01S0290
*   APESRTRY=DRETRY(03);            /* RESET RECOVERY ADDRESS        */
         L     @08,DRETRY+8                                     01S0291
         L     @01,APESREGP                                     01S0291
         ST    @08,APESRTRY(,@01)                               01S0291
*   RETURN;                         /* RETURN TO RESCAN APIO QUEUE   */
@EL00002 DS    0H                                               01S0292
@EF00002 DS    0H                                               01S0292
@ER00002 LM    @14,@12,@SA00002                                 01S0292
         BR    @14                                              01S0292
*FIXAPIOV:                          /* APIO VERIFICATION EXIT        */
*   PROC OPTIONS(NOSAVE,            /* R13 SAVEAREA NOT AVAILABLE    */
*       NOSAVEAREA);                /* NO DYNAMIC AREA POINTER       */
*                                                               01S0293
FIXAPIOV DS    0H                                               01S0294
*   /*****************************************************************/
*   /*                                                               */
*   /* FOLLOWING INTERNAL PROCEDURE GIVEN CONTROL BY IEAVEQV3 TO     */
*   /* VERIFY THAT THE CONTROL BLOCK POINTED TO BY REGISTER 0 IS AN  */
*   /* APIO. THIS ROUTINE MUST INSURE THAT A PROGRAM CHECK DOES NOT  */
*   /* OCCUR. ON EXIT REGISTER 15 INDICATE IF THE BLOCK IS VALID     */
*   /* (0=YES, 8=NO). REGISTERS 8-14 MUST BE RETURNED UNCHANGED.     */
*   /* OTHERS ARE VOLITILE.                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0294
*   RFY                                                         01S0294
*    (R0P,                          /* APIO ADDRESS                  */
*     R8P,                                                      01S0294
*     R9P,                                                      01S0294
*     R10P,                                                     01S0294
*     R11P,                                                     01S0294
*     R12P,                                                     01S0294
*     R13P,                         /* MUST REMAIN UNCHANGED         */
*     R14P,                         /* RETURN ADDRESS                */
*     R15P) RSTD;                   /* INPUT ADDRESS (APIOFIXV)      */
*   GEN REFS(R15P,APCODE,FIXAPIOV) SETS(APCODE);                01S0295
*                                   /* USING ENVIRONMENT
         PUSH  USING               SAVE CURRENT USING STATUS
         DROP  ,                   DROP ALL BASE REGISTERS
         LR    APCODE,R15P         PUT ENTRY POINT IN BASE REGISTER
         USING FIXAPIOV,APCODE     TELL ASSEMBLER
*   RFY                                                         01S0296
*     R15P UNRSTD;                  /* DONE WITH TEMPORARY BASE      */
*   RFY                                                         01S0297
*    (R1P,                                                      01S0297
*     R2P,                                                      01S0297
*     R15F) RSTD;                   /* REQUIRED REGISTERS            */
*   R1P=R0P&'FFFFFFF8'X;            /* APIO ADDRESS IN USEABLE REG
*                                      (INSURE DOUBLEWORD ALIGNED)   */
         LR    R1P,R0P                                          01S0298
         N     R1P,@CF03695                                     01S0298
*   RFY                                                         01S0299
*     APIO BASED(R1P);              /* TELL PL/S                     */
*                                                               01S0299
*   /*****************************************************************/
*   /*                                                               */
*   /* FOLLOWING CHECKS USED TO VERIFY APIO -- (1) APIO IN REAL      */
*   /* STORAGE, (2) APIO IN KEY-5, NON-FETCH PROTECTED STORAGE, AND  */
*   /* (3) APIOID HAS 'APIO'. CARE IS TAKEN TO INSURE THAT A PROGRAM */
*   /* CHECK DOES NOT OCCUR VERIFYING THE APIO.                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0300
*   R15F=8;                         /* ERROR RETURN CODE             */
         LA    R15F,8                                           01S0300
*   IF R1P=R0P THEN                 /* INSURE APIO WAS DOUBLE WORD   */
         CR    R1P,R0P                                          01S0301
         BNE   @RF00301                                         01S0301
*     DO;                           /* ALIGNED. IF NOT IS ERROR.     */
*       GEN(LRA   R0P,0(,R1P))                                  01S0303
*       REFS(R1P) SETS(R0P);        /* SEE IF IN STORAGE             */
         LRA   R0P,0(,R1P)
*       BC(7,FIXAPIOZ);             /* NO--NOT APIO                  */
         BC    7,FIXAPIOZ                                       01S0304
*       DO;                         /* (TREAT ABOVE AS IF)           */
*         R0P=R0P&'FFFFF800'X;      /* HARDWARE PAGE BDY (2K)        */
         N     R0P,@CF03699                                     01S0306
*         GEN(ISK   R0P,R0P)                                    01S0307
*         REFS(R0P) SETS(R0P);      /* STORAGE KEY                   */
         ISK   R0P,R0P
*         R0P=R0P&'000000F8'X;      /* LEAVE ACCESS CODE, FETCH AUTH */
         N     R0P,@CF03700                                     01S0308
*         IF R0P=16*APIOKEY THEN    /* MUST BE KEY OF APIO AND       */
         C     R0P,@CF02411                                     01S0309
         BNE   @RF00309                                         01S0309
*           DO;                     /* NOT FETCH PROTECTED.          */
*             R2P=ADDR(APIOSIZE);   /* INSURE 'APIOSIZE' FIELD       */
         LA    R2P,APIOSIZE(,R1P)                               01S0311
*             GEN(LRA   R0P,0(,R2P))                            01S0312
*             REFS(R2P) SETS(R0P);  /* IS REFERENCABLE               */
         LRA   R0P,0(,R2P)
*             BC(7,FIXAPIOZ);       /* (KEY CHECK NOT REQUIRED)      */
         BC    7,FIXAPIOZ                                       01S0313
*             DO;                   /* TREAT ABOVE AS 'IF'           */
*               R2P=ADDR(APIO)+APIOSIZE/* SET R2P = ADDR             */
*                   -1;             /* OF LAST BYTE IN APIO          */
         LR    R2P,R1P                                          01S0315
         AH    R2P,APIOSIZE(,R1P)                               01S0315
         BCTR  R2P,0                                            01S0315
*               GEN(LRA   R0P,0(,R1P))                          01S0316
*               REFS(R1P) SETS(R0P);/* REPEAT ABOVE CHECKS           */
         LRA   R0P,0(,R1P)
*               BC(7,FIXAPIOZ);     /* TO INSURE THAT THE ENTIRE     */
         BC    7,FIXAPIOZ                                       01S0317
*               DO;                 /* APIO (LESS THAN 2K) EXISTS    */
*                 R0P=R0P&'FFFFF800'X;/* IN VALID STORAGE.           */
         N     R0P,@CF03699                                     01S0319
*                 GEN(ISK   R0P,R0P)                            01S0320
*                 REFS(R0P) SETS(R0P);/* IF NOT,                     */
         ISK   R0P,R0P
*                 R0P=R0P&'000000F8'X;/* IS ERROR.                   */
         N     R0P,@CF03700                                     01S0321
*                 IF R0P=16*APIOKEY THEN/* IF OK SO FAR,             */
         C     R0P,@CF02411                                     01S0322
         BNE   @RF00322                                         01S0322
*                   IF APIOID=APIOIDC THEN/* THEN CAN                */
         CLC   APIOID(4,R1P),@CC03378                           01S0323
         BNE   @RF00323                                         01S0323
*                     R15F=0;       /* REFERENCE THE APIO.           */
         SLR   R15F,R15F                                        01S0324
*               END;                /* INSURE THAT THE APIO          */
@RF00323 DS    0H                                               01S0325
@RF00322 DS    0H                                               01S0326
*             END;                  /* HEADER ID IS ALSO VALID       */
*           END;                    /* (THIS CHECKS FOR OVERLAID     */
*       END;                        /* APIO).                        */
@RF00309 DS    0H                                               01S0329
*     END;                          /* R15F INDICATES IF BAD APIO.   */
*   RFY                                                         01S0330
*     APIO;                         /* FINISHED WITH APIO            */
@RF00301 DS    0H                                               01S0331
*FIXAPIOZ:                                                      01S0331
*   ;                               /* APIO VERIFIED                 */
*                                                               01S0331
FIXAPIOZ DS    0H                                               01S0332
*   /*****************************************************************/
*   /*                                                               */
*   /* REGISTER 15 SET (0/8). RETURN TO Q-VERIFICATION.              */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0332
*   GEN(POP   USING)                                            01S0332
*   NOREFS NOSETS;                  /* RESTORE USING STATUS          */
         POP   USING
*   RETURN;                         /* RETURN TO Q-VERIFICATION      */
@EL00003 DS    0H                                               01S0333
@EF00003 DS    0H                                               01S0333
@ER00003 BR    @14                                              01S0333
*   RFY                                                         01S0334
*     APIO;                         /* DONE WITH APIO                */
*   RFY                                                         01S0335
*    (R0P,                                                      01S0335
*     R8P,                                                      01S0335
*     R9P,                                                      01S0335
*     R10P,                                                     01S0335
*     R11P,                                                     01S0335
*     R12P,                                                     01S0335
*     R13P,                                                     01S0335
*     R14P,                                                     01S0335
*     R1P,                                                      01S0335
*     R2P,                                                      01S0335
*     R15F) UNRSTD;                                             01S0335
*   END FIXAPIOV;                   /* END OF APIO VERIFICATION EXIT */
*FIXAPIO1:                          /* QUEUE VERIFICATION FAILURE    */
*                                                               01S0337
*   /*****************************************************************/
*   /*                                                               */
*   /* AN ABEND OCCURRED DURING QUEUE VERIFICATION. ELIMINATE THE    */
*   /* ENTIRE APIO QUEUE BY RESETTING THE QUEUE HEADERS TO ZERO.     */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0337
*   DO;                             /* ENTRY FROM ESTAE/FRR RETRY    */
*                                                               01S0337
FIXAPIO1 DS    0H                                               01S0338
*     /***************************************************************/
*     /*                                                             */
*     /* ENTRY FROM ESTAE/FRR RETRY (IGTUKA). RETRY DOES NOT INSURE  */
*     /* REGISTERS 0-5, 8-11, 14-15 VALID SINCE NOT SAVED IN         */
*     /* APESREGS. ISSUE DUMMY RESTRICT TO WIPE PL/S OPTIMIZATION    */
*     /* MEMORY OF CURRENT REGISTER VALUES                           */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0338
*     RFY                                                       01S0338
*      (R0RSTD,                                                 01S0338
*       R1RSTD,                                                 01S0338
*       R2RSTD,                                                 01S0338
*       R3RSTD,                                                 01S0338
*       R4RSTD,                                                 01S0338
*       R5RSTD,                     /* 6-7 BASES                     */
*       R8RSTD,                                                 01S0338
*       R9RSTD,                                                 01S0338
*       R10RSTD,                                                01S0338
*       R11RSTD,                    /* 12-13 APCT/APSV PTRS          */
*       R14RSTD,                                                01S0338
*       R15RSTD) RSTD;              /* KEEP PL/S FROM CARRYING DATA  */
*     GEN(SPACE ,);                 /* NULL CODE                     */
         SPACE ,
*     RFY                                                       01S0340
*      (R0RSTD,                                                 01S0340
*       R1RSTD,                                                 01S0340
*       R2RSTD,                                                 01S0340
*       R3RSTD,                                                 01S0340
*       R4RSTD,                                                 01S0340
*       R5RSTD,                     /* 6-7 BASES                     */
*       R8RSTD,                                                 01S0340
*       R9RSTD,                                                 01S0340
*       R10RSTD,                                                01S0340
*       R11RSTD,                    /* 12-13 APCT/APSV PTRS          */
*       R14RSTD,                                                01S0340
*       R15RSTD) UNRSTD;            /* ALLOW PL/S TO USE REGS AGAIN  */
*   END;                            /* RETRY ENVIRONMENT SET         */
*   APESRTRY=DRETRY(03);            /* RESTORE ORIGINAL RECOVERY ADDR*/
         L     @08,DRETRY+8                                     01S0342
         L     @01,APESREGP                                     01S0342
         ST    @08,APESRTRY(,@01)                               01S0342
*   GEN(MODESET EXTKEY=SCHED)                                   01S0343
*   NOREFS NOSETS;                  /* SWITCH TO APCT KEY            */
         MODESET EXTKEY=SCHED
*   APCTAPIO=0;                     /* CLEAR THE APIO CHAIN          */
         SLR   @08,@08                                          01S0344
         ST    @08,APCTAPIO(,APCTPTR)                           01S0344
*   APCTIOAP=0;                     /* HEADERS (FORWARD AND BACKWARD)*/
         ST    @08,APCTIOAP(,APCTPTR)                           01S0345
*   GEN(MODESET EXTKEY=ZERO)                                    01S0346
*   NOREFS NOSETS;                  /* RESUME STANDARD KEY           */
         MODESET EXTKEY=ZERO
*   RETURN;                         /* RETURN TO CALLER.             */
         B     @EL00002                                         01S0347
*   END FIXAPIO;                    /* END OF SUBROUTINE             */
         EJECT
*                                   /* IGTXEPLG                      */
*                                                               01S0349
*   /*****************************************************************/
*   /*                                                               */
*   /* SYSTEM DECLARES                                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0349
*   DECLARE                         /* GENERAL PURPOSE REGISTERS     */
*     GPR01F FIXED(31) REG(1);                                  01S0349
*   DECLARE                         /* COMMON VARIABLES              */
*     I256C CHAR(256) BASED,                                    01S0350
*     I031F FIXED(31) BASED,                                    01S0350
*     I031P PTR(31) BASED,                                      01S0350
*     I015F FIXED(15) BASED,                                    01S0350
*     I015P PTR(15) BASED,                                      01S0350
*     I008P PTR(8) BASED,                                       01S0350
*     I001C CHAR(1) BASED;                                      01S0350
*                                                               01S0351
*   /*****************************************************************/
*   /*                                                               */
*   /* MODULE PATCH AREA                                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0351
*   DCL                                                         01S0351
*     APPATCH CHAR(*) INT STATIC LOCAL GEND;                    01S0351
*   GENERATE DATA DEFS(APPATCH);                                01S0352
*                                                               01S0353
*   /*****************************************************************/
*   /*                                                               */
*   /* GENERAL REGISTER DECLARES                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0353
*   DCL                                                         01S0353
*     R0F FIXED(31) REG(0),                                     01S0353
*     R0P PTR(24) REG(0),                                       01S0353
*     R0RSTD PTR(31) REG(0),                                    01S0353
*     R1F FIXED(31) REG(1),                                     01S0353
*     R1P PTR(24) REG(1),                                       01S0353
*     R1RSTD PTR(31) REG(1),                                    01S0353
*     R2F FIXED(31) REG(2),                                     01S0353
*     R2P PTR(24) REG(2),                                       01S0353
*     R2RSTD PTR(31) REG(2),                                    01S0353
*     R3F FIXED(31) REG(3),                                     01S0353
*     R3P PTR(24) REG(3),                                       01S0353
*     R3RSTD PTR(31) REG(3),                                    01S0353
*     R4F FIXED(31) REG(4),                                     01S0353
*     R4P PTR(24) REG(4),                                       01S0353
*     R4RSTD PTR(31) REG(4),                                    01S0353
*     R5F FIXED(31) REG(5),                                     01S0353
*     R5P PTR(24) REG(5),                                       01S0353
*     R5RSTD PTR(31) REG(5),                                    01S0353
*     R6F FIXED(31) REG(6),                                     01S0353
*     R6P PTR(24) REG(6),                                       01S0353
*     R6RSTD PTR(31) REG(6),                                    01S0353
*     R7F FIXED(31) REG(7),                                     01S0353
*     R7P PTR(24) REG(7),                                       01S0353
*     R7RSTD PTR(31) REG(7),                                    01S0353
*     R8F FIXED(31) REG(8),                                     01S0353
*     R8P PTR(24) REG(8),                                       01S0353
*     R8RSTD PTR(31) REG(8),                                    01S0353
*     R9F FIXED(31) REG(9),                                     01S0353
*     R9P PTR(24) REG(9),                                       01S0353
*     R9RSTD PTR(31) REG(9),                                    01S0353
*     R10F FIXED(31) REG(10),                                   01S0353
*     R10P PTR(24) REG(10),                                     01S0353
*     R10RSTD PTR(31) REG(10),                                  01S0353
*     R11F FIXED(31) REG(11),                                   01S0353
*     R11P PTR(24) REG(11),                                     01S0353
*     R11RSTD PTR(31) REG(11),                                  01S0353
*     R12F FIXED(31) REG(12),                                   01S0353
*     R12P PTR(24) REG(12),                                     01S0353
*     R12RSTD PTR(31) REG(12),                                  01S0353
*     R13F FIXED(31) REG(13),                                   01S0353
*     R13P PTR(24) REG(13),                                     01S0353
*     R13RSTD PTR(31) REG(13),                                  01S0353
*     R14F FIXED(31) REG(14),                                   01S0353
*     R14P PTR(24) REG(14),                                     01S0353
*     R14RSTD PTR(31) REG(14),                                  01S0353
*     R15F FIXED(31) REG(15),                                   01S0353
*     R15P PTR(24) REG(15),                                     01S0353
*     R15RSTD PTR(31) REG(15),                                  01S0353
*                                                               01S0353
*     /***************************************************************/
*     /*                                                             */
*     /* VPSS CONTROL BLOCK POINTER DECLARES                         */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0353
*     APSMPTR PTR(24) REG(01),      /* STORAGE MANAGEMENT BLOCK 01S0353
*                                      (SUGGESTED POINTER)           */
*     APSCPTR PTR(24) REG(01),      /* STORAGE MANAGEMENT CONTROL
*                                      WORD (SUGGESTED POINTER)      */
*     APINPTR PTR(24) REG(01),      /* USER'S INPUT PARAMETER LIST
*                                      (SUGGESTED POINTER)           */
*/*                                                                  */
*                                                               01S0353
*     APDATA PTR(24) REG(06),       /* ADDRESS OF DYNAMIC DATA  01S0353
*                                      WORKAREA (DATAREG)            */
*     APCODE PTR(24) REG(07),       /* PROGRAM CODE BASE REGISTER
*                                      (CODEREG)                     */
*     APDEBPTR PTR(24) REG(08),     /* VPSS DEB (SUGGESTED POINTER)  */
*     APNPPTR PTR(24) REG(08),      /* SUBSYSTEM INITIALIZATION 01S0353
*                                      WORKAREA BLOCK (ONLY USED BY
*                                      SUBSYSTEM INITIALIZATION)     */
*     APRLPTR PTR(24) REG(08),      /* VPSS ACB REQUEST LIST    01S0353
*                                      (SUGGESTED POINTER)           */
*     APCIPTR PTR(24) REG(08),      /* 3838 CONTROL TABLE (SUGGESTED
*                                      POINTER)                      */
*     APCWPTR PTR(24) REG(08),      /* CALL INTERFACE WORKAREA  01S0353
*                                      (SUGGESTED POINTER)           */
*     APERPTR PTR(24) REG(08),      /* ERP/IO APPENDAGE WORKAREA
*                                      (SUGGESTED POINTER)           */
*     APACBPTR PTR(24) REG(09),     /* VPSS ACB (SUGGESTED POINTER)  */
*     APCQPTR PTR(24) REG(09),      /* COMMAND QUEUE ELEMENT    01S0353
*                                      (SUGGESTED POINTER)           */
*     APOTPTR PTR(24) REG(09),      /* OPTION TABLE (SUGGESTED  01S0353
*                                      POINTER)                      */
*     APIOPTR PTR(24) REG(10),      /* I/O ELEMENT (SUGGESTED   01S0353
*                                      POINTER)                      */
*     APEXLPTR PTR(24) REG(10),     /* VPSS EXLST (SUGGESTED POINTER)*/
*     APUBPTR PTR(24) REG(10),      /* UNIT BLOCK (SUGGESTED POINTER)*/
*     APAXPTR PTR(24) REG(10),      /* VPSS ACB EXTENSION (SUGGESTED
*                                      POINTER)                      */
*     APCPPTR PTR(24) REG(10),      /* VPSS CALL PROCESSING     01S0353
*                                      INDICATORS (SUGGESTED POINTER)*/
*     APOCPTR PTR(24) REG(10),      /* VPSS OPEN/CLOSE SUBSYSTEM
*                                      WORKAREA (REQUIRED POINTER)   */
*     APATPTR PTR(24) REG(11),      /* VPSS ACB TABLE (SUGGESTED
*                                      POINTER)                      */
*     APLBPTR PTR(24) REG(11),      /* LABEL RESOLUTION TABLE   01S0353
*                                      (SUGGESTED POINTER)           */
*     APUTPTR PTR(24) REG(11),      /* USER TABLE (SUGGESTED POINTER)*/
*     APDSPTR PTR(24) REG(11),      /* VPSS DATASET ENTRY (SUGGESTED
*                                      POINTER)                      */
*     APXLPTR PTR(24) REG(11),      /* TRANSLATION TABLE (SUGGESTED
*                                      POINTER)                      */
*     APDXPTR PTR(24) REG(11),      /* VPSS DEB EXTENSION (SUGGESTED
*                                      POINTER)                      */
*     APCTPTR PTR(24) REG(12) RSTD, /* CONTROL TABLE (REQUIRED  01S0353
*                                      POINTER)                      */
*     APSVPTR PTR(24) REG(13) RSTD, /* OS/VPSS SAVEAREA/WORKAREA
*                                      (REQUIRED POINTER)            */
*     APRETURN PTR(24) REG(14),     /* RETURN ADDRESS FOR SUBROUTINE
*                                      LINKAGE                       */
*     APENTRY PTR(24) REG(15),      /* SUBROUTINE ENTRY POINT LINKAGE*/
*     APRCODE PTR(24) REG(15);      /* CONTAINS SUBROUTINE RETURN
*                                      CODE                          */
*                                                               01S0354
*   /*****************************************************************/
*   /*                                                               */
*   /* USER REGISTER DECLARES                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0354
*   DCL                             /* LOCAL REGISTERS               */
*     RASCBPTR PTR(24) REG(03),     /* ASCB TO PROCESS               */
*     RTCBPTR PTR(24) REG(04),      /* TCB TO PROCESS (=0 IF ALL)    */
*     RAPIOPTR PTR(24) REG(05),     /* APIO SCAN REGISTER            */
*     RZERO FIXED(31) REG(08),      /* HOLDS VALUE OF 0              */
*     RSSOBPTR PTR(24) REG(09);     /* ADDRESS OF EOT/EOAS SSOB      */
*   END IGTJDM                      /* END OF MODULE                 */
*                                                               01S0355
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHAFRRS )                                       */
*/*%INCLUDE SYSLIB  (IHAASCB )                                       */
*/*%INCLUDE SYSLIB  (IKJTCB  )                                       */
*/*%INCLUDE SYSLIB  (IEZDEB  )                                       */
*/*%INCLUDE SYSLIB  (IHASDWA )                                       */
*/*%INCLUDE SYSLIB  (IEFJSCVT)                                       */
*/*%INCLUDE SYSLIB  (IEFJSSOB)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPCC)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPCM)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPCT)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPCV)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPDX)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPIO)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPMV)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPSV)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPVU)                                       */
*/*%INCLUDE SYSLIB  (IHAQVPL )                                       */
*/*%INCLUDE SYSLIB  (IGTXAPES)                                       */
*/*%INCLUDE SYSUT5  (GETLOCK )                                       */
*/*%INCLUDE SYSUT5  (BSAWA   )                                       */
*/*%INCLUDE SYSUT5  (INITSTAE)                                       */
*/*%INCLUDE SYSUT5  (SCANAPIO)                                       */
*/*%INCLUDE SYSUT5  (CLRREGS )                                       */
*/*%INCLUDE SYSUT5  (CLRREGS )                                       */
*/*%INCLUDE SYSUT5  (CLRREGS )                                       */
*/*%INCLUDE SYSUT5  (CLRREGS )                                       */
*/*%INCLUDE SYSUT5  (CLRREGS )                                       */
*/*%INCLUDE SYSUT5  (CLRREGS )                                       */
*/*%INCLUDE SYSUT5  (CLRSTAE )                                       */
*/*%INCLUDE SYSUT5  (CLRSTAE )                                       */
*/*%INCLUDE SYSUT5  (CLRSTAE )                                       */
*/*%INCLUDE SYSUT5  (CLRSTAE )                                       */
*/*%INCLUDE SYSUT5  (DOSTAE  )                                       */
*/*%INCLUDE SYSUT5  (DOSTAE  )                                       */
*/*%INCLUDE SYSUT5  (IOACTV  )                                       */
*/*%INCLUDE SYSUT5  (FREESTAE)                                       */
*/*%INCLUDE SYSUT5  (FSAWA   )                                       */
*/*%INCLUDE SYSUT5  (FREELOCK)                                       */
*                                                               01S0355
*       ;                                                       01S0355
@EL00001 DS    0H                                               01S0355
@EF00001 DS    0H                                               01S0355
@ER00001 LM    @14,@12,12(@13)                                  01S0355
         BR    @14                                              01S0355
@DATA    DS    0H
@CH00045 DC    H'4'
@CH00037 DC    H'8'
@CH03760 DC    H'200'
@CH03761 DC    H'240'
@DATD    DSECT
         DS    0F
@SA00002 DS    15F
IGTJDM   CSECT
         DS    0F
@CF02411 DC    F'80'
@CF03695 DC    XL4'FFFFFFF8'
@CF03699 DC    XL4'FFFFF800'
@CF03700 DC    XL4'000000F8'
@CF03770 DC    XL4'0000FFFF'
@DATD    DSECT
         DS    0D
DFXAPIO  DS    CL80
         ORG   DFXAPIO
QVPL     DS    CL40
         ORG   QVPL
QVPLTYP3 DS    CL40
         ORG   QVPLTYP3
QVPLTYP2 DS    CL33
         ORG   QVPLTYP2
QVPLTYP1 DS    CL28
         ORG   QVPLTYP1
QVPLEVR  DS    AL4
QVPLODA  DS    AL4
QVPLWKA  DS    AL4
QVPLNOEL DS    AL4
QVPLHDR  DS    AL4
QVPLHF   DS    CL4
         ORG   QVPLHF
QVPLFLGH DS    CL1
         ORG   QVPLFLGH
QVPLHD3  DS    BL1
QVPLRES1 EQU   QVPLFLGH+0
         ORG   QVPLHF+1
QVPLFLGF DS    CL1
         ORG   QVPLFLGF
QVPLFP3  DS    BL1
QVPLRES2 EQU   QVPLFLGF+0
         ORG   QVPLHF+2
QVPLFPTR DS    FL2
         ORG   QVPLTYP1+24
QVPLLELM DS    AL4
         ORG   QVPLTYP2+28
QVPLTRLR DS    AL4
QVPLTB   DS    CL4
         ORG   QVPLTB
QVPLFLGT DS    CL1
         ORG   QVPLFLGT
QVPLTR3  DS    BL1
QVPLRES3 EQU   QVPLFLGT+0
         ORG   QVPLTB+1
QVPLFLGB DS    CL1
         ORG   QVPLFLGB
QVPLBP3  DS    BL1
QVPLRES4 EQU   QVPLFLGB+0
         ORG   QVPLTB+2
QVPLBPTR DS    FL2
         ORG   QVPLTYP2+36
QVPLFELM DS    AL4
         ORG   DFXAPIO+40
DFXAPIOW DS    CL40
         ORG   DFXAPIO+80
APES     DS    CL648
         ORG   APES
APESID   DS    CL4
APESUSER DS    FL4
APESADDR DS    AL4
APESAPMV DS    AL4
APESFLGS DS    BL2
         ORG   APESFLGS
APESFLG0 DS    BL1
         ORG   APESFLG0
APESFDMP DS    BL1
APESFREC EQU   APESFLG0+0
APESFSDP EQU   APESFLG0+0
@NM00155 EQU   APESFLG0+0
APESFRTY EQU   APESFLG0+0
APESFEXR EQU   APESFLG0+0
@NM00156 EQU   APESFLG0+0
         ORG   APESFLGS+1
APESFLG1 DS    BL1
         ORG   APESFLG1
APESFFRR DS    BL1
APESFPRV EQU   APESFLG1+0
APESFLLK EQU   APESFLG1+0
APESFXLK EQU   APESFLG1+0
APESFGM  EQU   APESFLG1+0
APESFSDI EQU   APESFLG1+0
APESFSTE EQU   APESFLG1+0
@NM00157 EQU   APESFLG1+0
         ORG   APES+18
APESSUID DS    BL1
         ORG   APESSUID
APESSU33 DS    BL1
@NM00158 EQU   APESSUID+0
         ORG   APES+19
APESCODE DS    FL1
APESCOD1 DS    FL1
APESCNTR DS    FL1
APESMXCD DS    FL1
@NM00159 DS    FL1
@NM00160 DS    AL4
@NM00161 DS    AL4
@NM00162 DS    AL4
APESEXRA DS    AL4
APESR14S DS    AL4
APESREGP DS    AL4
APESREGZ DS    CL64
APESMOD  DS    CL8
APESPROC DS    CL8
APESFRR  DS    CL8
APESSDWA DS    CL512
         ORG   APES+648
DRETRY   DS    4A
IGTJDM   CSECT
         NOPR  ((@ENDDATD-@DATD)/1929*16)
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
@CC03593 DC    C'IGTJDM  '
@CC03679 DC    C'IGTKBC  '
@CC03378 DC    C'APIO'
@CB03766 DC    B'111111111111111111111111110111111111111111111111111111C
               11'
         DS    CL1
CAPES    DS    CL136
         ORG   CAPES
CPESID   DC    CL4'APES'
CPESUSER DC    F'0'
CPESADRR DC    AL4(CAPES)
CPESAPMV DC    AL4(CMBRXZZZ)
CPESFLGS DS    CL2
         ORG   CPESFLGS
CPESFLG0 DC    B'01100000'
         ORG   CPESFLG0
CPESFDMP DS    BL1
CPESFREC EQU   CPESFLG0+0
CPESFSDP EQU   CPESFLG0+0
@NM00165 EQU   CPESFLG0+0
         ORG   CPESFLGS+1
CPESFLG1 DC    B'10110000'
         ORG   CPESFLG1
CPESFFRR DS    BL1
CPESFPRV EQU   CPESFLG1+0
CPESFLCK EQU   CPESFLG1+0
CPESFXLK EQU   CPESFLG1+0
CPESFGM  EQU   CPESFLG1+0
CPESFSDI EQU   CPESFLG1+0
@NM00166 EQU   CPESFLG1+0
         ORG   CAPES+18
CPESSUID DC    B'00000000'
CPESCODE DC    AL1(3)
CPESCOD1 DC    AL1(0)
CPESCNTR DC    AL1(0)
CPESMXCD DC    AL1(3)
@NM00167 DC    AL1(0)
@NM00168 DC    F'0'
@NM00169 DC    F'0'
@NM00170 DC    F'0'
@NM00171 DC    F'0'
CPESR14S DC    A(0)
CPESREGP DC    AL4(CPESREGZ)
CPESREGZ DC    F'0'
         DC    F'0'
         DC    F'0'
         DC    F'0'
         DC    F'0'
         DC    F'0'
         DC    F'0'
         DC    F'0'
         DC    F'0'
         DC    F'0'
         DC    F'0'
         DC    F'0'
         DC    F'0'
         DC    F'0'
         DC    F'0'
         DC    F'0'
CPESMOD  DC    CL8'IGTJDM  '
CPESPROC DC    CL8'IGTJDM  '
CPESFRR  DC    CL8'        '
         ORG   CAPES+136
CMBRXZZZ DS    CL24
         ORG   CMBRXZZZ
@NM00172 DS    CL8
         ORG   @NM00172
@NM00173 DC    H'33'
@NM00174 DC    H'59'
@NM00175 DC    AL1(0)
@NM00176 DC    AL1(8)
@NM00177 DC    H'201'
         ORG   CMBRXZZZ+8
@NM00178 DS    CL8
         ORG   @NM00178
@NM00179 DC    H'21'
@NM00180 DC    H'45'
@NM00181 DC    AL1(0)
@NM00182 DC    AL1(4)
@NM00183 DC    H'202'
         ORG   CMBRXZZZ+16
@NM00184 DS    CL8
         ORG   @NM00184
@NM00185 DC    H'36'
@NM00186 DC    H'0'
@NM00187 DC    AL1(0)
@NM00188 DC    AL1(8)
@NM00189 DC    H'203'
         ORG   CMBRXZZZ+24
IGTJDM   CSECT
*                                   /* GENERATE PATCH
         IGTXZAP ,                 GENERATE PATCH AREA
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IGTJDM   CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
APCODE   EQU   @07
FRRSPTR  EQU   @00
FRREPTR  EQU   @00
DEBPTR   EQU   @00
DEBDAPTR EQU   @00
DEBEXPTR EQU   @00
DEBSBPTR EQU   @00
SDWAPTR  EQU   @00
SSCTPTR  EQU   @00
APCTPTR  EQU   @12
APSVPTR  EQU   @13
R0P      EQU   @00
R1P      EQU   @01
RSSOBPTR EQU   @09
R11P     EQU   @11
R12P     EQU   @12
R13P     EQU   @13
R14P     EQU   @14
APDATA   EQU   @06
R15P     EQU   @15
R0F      EQU   @00
R15F     EQU   @15
R14F     EQU   @14
R0RSTD   EQU   @00
R1RSTD   EQU   @01
R2RSTD   EQU   @02
R3RSTD   EQU   @03
R4RSTD   EQU   @04
R5RSTD   EQU   @05
R8RSTD   EQU   @08
R9RSTD   EQU   @09
R10RSTD  EQU   @10
R11RSTD  EQU   @11
R14RSTD  EQU   @14
R15RSTD  EQU   @15
RZERO    EQU   @08
RASCBPTR EQU   @03
RTCBPTR  EQU   @04
RAPIOPTR EQU   @05
GPR01F   EQU   @01
R8P      EQU   @08
R9P      EQU   @09
R10P     EQU   @10
R2P      EQU   @02
APACBPTR EQU   @09
APATPTR  EQU   @11
APAXPTR  EQU   @10
APCIPTR  EQU   @08
APCPPTR  EQU   @10
APCQPTR  EQU   @09
APCWPTR  EQU   @08
APDEBPTR EQU   @08
APDSPTR  EQU   @11
APDXPTR  EQU   @11
APENTRY  EQU   @15
APERPTR  EQU   @08
APEXLPTR EQU   @10
APINPTR  EQU   @01
APIOPTR  EQU   @10
APLBPTR  EQU   @11
APNPPTR  EQU   @08
APOCPTR  EQU   @10
APOTPTR  EQU   @09
APRCODE  EQU   @15
APRETURN EQU   @14
APRLPTR  EQU   @08
APSCPTR  EQU   @01
APSMPTR  EQU   @01
APUBPTR  EQU   @10
APUTPTR  EQU   @11
APXLPTR  EQU   @11
R1F      EQU   @01
R10F     EQU   @10
R11F     EQU   @11
R12F     EQU   @12
R12RSTD  EQU   @12
R13F     EQU   @13
R13RSTD  EQU   @13
R2F      EQU   @02
R3F      EQU   @03
R3P      EQU   @03
R4F      EQU   @04
R4P      EQU   @04
R5F      EQU   @05
R5P      EQU   @05
R6F      EQU   @06
R6P      EQU   @06
R6RSTD   EQU   @06
R7F      EQU   @07
R7P      EQU   @07
R7RSTD   EQU   @07
R8F      EQU   @08
R9F      EQU   @09
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
FLCCVT   EQU   FLCICCW2
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSATOLD  EQU   PSA+540
PSAAOLD  EQU   PSA+548
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSALITA  EQU   PSA+764
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
PSALSFCC EQU   PSA+1012
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
IEAVEQV3 EQU   0
FRRS     EQU   0
FRRSHEAD EQU   FRRS
FRRSEMP  EQU   FRRSHEAD
FRRSLAST EQU   FRRSHEAD+4
FRRSELEN EQU   FRRSHEAD+8
FRRSCURR EQU   FRRSHEAD+12
FRRSENTR EQU   0
FRRSFRRA EQU   FRRSENTR
FRRSFLGS EQU   FRRSENTR+4
FRRSFLG1 EQU   FRRSFLGS
FRRSPARM EQU   FRRSENTR+8
ASCB     EQU   0
ASCBSUPC EQU   ASCB+16
ASCBASID EQU   ASCB+36
ASCBFW1  EQU   ASCB+100
ASCBRCTF EQU   ASCBFW1+2
ASCBFLG1 EQU   ASCBFW1+3
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
ASCBLKGP EQU   ASCB+128
ASCBSRQ  EQU   ASCB+180
ASCBSRQ1 EQU   ASCBSRQ
ASCBSRQ2 EQU   ASCBSRQ+1
ASCBSRQ3 EQU   ASCBSRQ+2
ASCBSRQ4 EQU   ASCBSRQ+3
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBJPQ   EQU   TCB+44
TCBPURGE EQU   TCBJPQ
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTME   EQU   TCB+120
TCBJSTCB EQU   TCB+124
TCBJSTCA EQU   TCBJSTCB+1
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBXSCT  EQU   TCB+240
TCBXSCT1 EQU   TCBXSCT
TCBFOE   EQU   TCB+244
TCBESTAE EQU   TCB+264
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCB+276
TCBFBYT2 EQU   TCB+277
TCBRV124 EQU   TCB+278
TCBRV133 EQU   TCB+279
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
DEBBASIC EQU   0
DEBTCBAD EQU   DEBBASIC
DEBTCBB  EQU   DEBTCBAD+1
DEBDEBAD EQU   DEBBASIC+4
DEBIRBAD EQU   DEBBASIC+8
DEBOFLGS EQU   DEBIRBAD
DEBOPATB EQU   DEBBASIC+12
DEBFLGS1 EQU   DEBBASIC+14
DEBUSRPG EQU   DEBBASIC+16
DEBRRQ   EQU   DEBBASIC+20
DEBECBAD EQU   DEBRRQ
DEBDCBAD EQU   DEBBASIC+24
DEBPROTG EQU   DEBDCBAD
DEBAPPAD EQU   DEBBASIC+28
DEBBASND EQU   DEBBASIC+32
DEBDASD  EQU   0
DEBUCBAD EQU   DEBDASD
DEBACSMD EQU   0
DEBVOLSQ EQU   DEBACSMD
DEBVOLBT EQU   DEBVOLSQ
DEBDSNM  EQU   DEBACSMD+4
DEBUTSAA EQU   DEBDSNM
DEBACS01 EQU   0
DEBDSNAM EQU   DEBACS01
DEBACS02 EQU   0
DEBDBLK  EQU   DEBACS02
DEBACS03 EQU   0
DEBACS04 EQU   0
DEBTBFRA EQU   DEBACS04
DEBTCCWA EQU   DEBACS04+4
DEBACS05 EQU   0
DEBFUCBA EQU   DEBACS05
DEBLUCBA EQU   DEBACS05+4
DEBACS06 EQU   0
DEBACS07 EQU   0
DEBACS08 EQU   0
DEBSUBNM EQU   0
DEB      EQU   0
DEBAVT   EQU   DEB
DEBEOEA  EQU   DEBAVT
DEBEOEAB EQU   DEBEOEA
DEBSIOA  EQU   DEBAVT+4
DEBSIOAB EQU   DEBSIOA
DEBPCIA  EQU   DEBAVT+8
DEBPCIAB EQU   DEBPCIA
DEBCEA   EQU   DEBAVT+12
DEBCEAB  EQU   DEBCEA
DEBXCEA  EQU   DEBAVT+16
DEBXCEAB EQU   DEBXCEA
DEBPREFX EQU   DEB+20
DEBXTNP  EQU   DEBPREFX+8
DEBXTN   EQU   0
DEBXFLG1 EQU   DEBXTN+2
SDWA     EQU   0
SDWAFIOB EQU   SDWA+4
SDWAABCC EQU   SDWAFIOB
SDWACMPF EQU   SDWAABCC
SDWACTL1 EQU   SDWA+8
SDWACMKA EQU   SDWACTL1
SDWAMWPA EQU   SDWACTL1+1
SDWAPMKA EQU   SDWACTL1+4
SDWACTL2 EQU   SDWA+16
SDWACMKP EQU   SDWACTL2
SDWAMWPP EQU   SDWACTL2+1
SDWAPMKP EQU   SDWACTL2+4
SDWAGRSV EQU   SDWA+24
SDWANAME EQU   SDWA+88
SDWAEC1  EQU   SDWA+104
SDWAEMK1 EQU   SDWAEC1
SDWAMWP1 EQU   SDWAEC1+1
SDWAINT1 EQU   SDWAEC1+2
SDWANXT1 EQU   SDWAEC1+4
SDWAAEC1 EQU   SDWA+112
SDWAILC1 EQU   SDWAAEC1+1
SDWAINC1 EQU   SDWAAEC1+2
SDWAICD1 EQU   SDWAINC1+1
SDWAEC2  EQU   SDWA+120
SDWAEMK2 EQU   SDWAEC2
SDWAMWP2 EQU   SDWAEC2+1
SDWAINT2 EQU   SDWAEC2+2
SDWANXT2 EQU   SDWAEC2+4
SDWAAEC2 EQU   SDWA+128
SDWAILC2 EQU   SDWAAEC2+1
SDWAINC2 EQU   SDWAAEC2+2
SDWAICD2 EQU   SDWAINC2+1
SDWASRSV EQU   SDWA+136
SDWAIDNT EQU   SDWA+200
SDWAMCH  EQU   SDWA+204
SDWASTCK EQU   SDWAMCH
SDWAMCHI EQU   SDWAMCH+8
SDWAMCHS EQU   SDWAMCHI
SDWAMCHD EQU   SDWAMCHI+1
SDWARSR1 EQU   SDWAMCH+12
SDWARSR2 EQU   SDWAMCH+13
SDWAFLGS EQU   SDWA+232
SDWAERRA EQU   SDWAFLGS
SDWAERRB EQU   SDWAFLGS+1
SDWAERRC EQU   SDWAFLGS+2
SDWAERRD EQU   SDWAFLGS+3
SDWAIOFS EQU   SDWA+238
SDWACPUA EQU   SDWA+248
SDWAPARQ EQU   SDWA+252
SDWAACF2 EQU   SDWAPARQ+1
SDWAACF3 EQU   SDWAPARQ+2
SDWAACF4 EQU   SDWAPARQ+3
SDWALKWA EQU   SDWA+256
SDWALKWS EQU   SDWALKWA
SDWARECP EQU   SDWA+292
SDWASNPA EQU   SDWA+320
SDWADUMP EQU   SDWASNPA
SDWADPFS EQU   SDWADUMP+1
SDWADDAT EQU   SDWASNPA+4
SDWASDAT EQU   SDWADDAT
SDWASDA0 EQU   SDWASDAT
SDWASDA1 EQU   SDWASDAT+1
SDWAPDAT EQU   SDWADDAT+2
SDWADPSA EQU   SDWA+328
SDWADPSL EQU   SDWADPSA
SDWARA   EQU   SDWA+400
SDWADPVA EQU   SDWARA+2
SSCT     EQU   0
SSCTFLG1 EQU   SSCT+12
SSCTSUSE EQU   SSCT+20
SSOB     EQU   0
SSOBFUNC EQU   SSOB+6
SSOBINDV EQU   SSOB+16
SSEN     EQU   0
SSENFLAG EQU   SSEN+6
SSET     EQU   0
SSETFLAG EQU   SSET+6
SSETCBA  EQU   SSET+8
SSETASCB EQU   SSET+12
APCT     EQU   0
APCTENQM EQU   APCT+12
APCTSMIN EQU   APCT+32
APCTSMAD EQU   APCT+36
APCTZ@@@ EQU   APCT+40
APCTU@@@ EQU   APCT+440
APCTBR14 EQU   APCT+840
APCTERRS EQU   APCT+876
@NM00099 EQU   APCT+936
APCTSTAT EQU   @NM00099
APCTPRSW EQU   @NM00099+1
APCTAPCQ EQU   APCT+944
APCTCQAQ EQU   APCT+952
APCTAPIO EQU   APCT+1064
APCTABND EQU   APCT+1072
APCTIOAP EQU   APCT+1100
APCTZ@@1 EQU   APCT+1120
APCTAPVU EQU   APCT+1520
APCVZUKA EQU   0
APCVZKBC EQU   0
APDX     EQU   0
APDX252A EQU   APDX+28
APDXDXL  EQU   APDX+32
APDXSWS  EQU   APDX+130
APDXSW0  EQU   APDXSWS
APDXSW1  EQU   APDXSWS+1
APIO     EQU   0
APIOIOCB EQU   APIO
APIOID   EQU   APIO+192
APIOAPIO EQU   APIO+200
APIODEB  EQU   APIO+216
APIOIOAP EQU   APIO+240
APIOFLGS EQU   APIO+248
APIOFLGA EQU   APIOFLGS
APIOFLG0 EQU   APIOFLGA
APIOFLG2 EQU   APIOFLGA+2
APIOFLG3 EQU   APIOFLGA+3
APIORET  EQU   APIOFLG3
APIOFLGB EQU   APIOFLGS+4
APIOFLG7 EQU   APIOFLGB+3
APIOACTV EQU   APIOFLG7
APIOINDX EQU   APIO+288
APIOSAVE EQU   APIOINDX
APIOASCB EQU   APIO+348
APIOTERM EQU   APIO+352
APIOTR   EQU   APIO+360
APIOSIZE EQU   APIO+368
APIOGMSZ EQU   APIO+376
APIONBR  EQU   APIO+384
APMV     EQU   0
APMVHDR  EQU   APMV
APMVHKWD EQU   APMVHDR+4
APMVHMSG EQU   APMVHDR+8
APMVKWD  EQU   0
APMVMSG  EQU   0
APSV     EQU   0
APSVPREV EQU   APSV+4
APSVNEXT EQU   APSV+8
APSVREGS EQU   APSV+12
APVU     EQU   0
APVUSPLN EQU   APVU+8
APVUWORK EQU   APVU+40
APVUAUSE EQU   APVU+3040
APVUAPIO EQU   APVUAUSE
APESREGS EQU   0
APESREGE EQU   APESREGS+56
APESREGF EQU   APESREGS+60
APESRTRY EQU   APESREGF
APESMV   EQU   0
I031P    EQU   0
APCVZDAL EQU   0
APCVZDAP EQU   0
APCVZDBK EQU   0
APCVZDDA EQU   0
APCVZDDQ EQU   0
APCVZDEQ EQU   0
APCVZDID EQU   0
APCVZDIO EQU   0
APCVZDIP EQU   0
APCVZDMD EQU   0
APCVZDMM EQU   0
APCVZDQR EQU   0
APCVZDRI EQU   0
APCVZDUA EQU   0
APCVZDUL EQU   0
APCVZDWI EQU   0
APCVZDWT EQU   0
APCVZDX1 EQU   0
APCVZDX2 EQU   0
APCVZDX3 EQU   0
APCVZDX4 EQU   0
APCVZD10 EQU   0
APCVZD20 EQU   0
APCVZD4E EQU   0
APCVZD40 EQU   0
APCVZD41 EQU   0
APCVZD42 EQU   0
APCVZD43 EQU   0
APCVZD44 EQU   0
APCVZD45 EQU   0
APCVZD46 EQU   0
APCVZD47 EQU   0
APCVZD48 EQU   0
APCVZD49 EQU   0
APCVZD60 EQU   0
APCVZD80 EQU   0
APCVZD81 EQU   0
APCVZD82 EQU   0
APCVZD83 EQU   0
APCVZJAA EQU   0
APCVZJAD EQU   0
APCVZJAG EQU   0
APCVZJAJ EQU   0
APCVZJAM EQU   0
APCVZJAP EQU   0
APCVZJAX EQU   0
APCVZJAY EQU   0
APCVZJBA EQU   0
APCVZJBD EQU   0
APCVZJBG EQU   0
APCVZJBJ EQU   0
APCVZJBM EQU   0
APCVZJDA EQU   0
APCVZJDD EQU   0
APCVZJDG EQU   0
APCVZJDJ EQU   0
APCVZJDM EQU   0
APCVZJHC EQU   0
APCVZJHE EQU   0
APCVZJHF EQU   0
APCVZJHO EQU   0
APCVZJHQ EQU   0
APCVZJHR EQU   0
APCVZJHT EQU   0
APCVZJHW EQU   0
APCVZJH0 EQU   0
APCVZJH6 EQU   0
APCVZJI0 EQU   0
APCVZJI3 EQU   0
APCVZJJ0 EQU   0
APCVZKAA EQU   0
APCVZKBA EQU   0
APCVZKBB EQU   0
APCVZKBD EQU   0
APCVZKBE EQU   0
APCVZKBF EQU   0
APCVZKCA EQU   0
APCVZKDA EQU   0
APCVZKGA EQU   0
APCVZKGB EQU   0
APCVZKGC EQU   0
APCVZKGD EQU   0
APCVZLCA EQU   0
APCVZLCB EQU   0
APCVZMBA EQU   0
APCVZMBD EQU   0
APCVZMBG EQU   0
APCVZMBH EQU   0
APCVZMBK EQU   0
APCVZMBM EQU   0
APCVZMIB EQU   0
APCVZMIC EQU   0
APCVZMIF EQU   0
APCVZMJB EQU   0
APCVZMJC EQU   0
APCVZMJH EQU   0
APCVZMJI EQU   0
APCVZMMA EQU   0
APCVZUAA EQU   0
APCVZUAB EQU   0
APCVZUAC EQU   0
APCVZUAD EQU   0
APCVZUAE EQU   0
APCVZUAF EQU   0
APCVZUAG EQU   0
APCVZUBB EQU   0
APCVZUFA EQU   0
APCVZUHA EQU   0
APCVZUHB EQU   0
APCVZUJA EQU   0
APCV1CMD EQU   0
APCV1JAA EQU   0
APCV1JBJ EQU   0
APCV1JHC EQU   0
APCV1JHL EQU   0
APCV1JHT EQU   0
APCV1MAB EQU   0
APCV1MBD EQU   0
APCV2JHC EQU   0
APCV2JHL EQU   0
APCV2MBD EQU   0
I001C    EQU   0
I008P    EQU   0
I015F    EQU   0
I015P    EQU   0
I031F    EQU   0
I256C    EQU   0
PSARSVTE EQU   PSARSVT
PSACSTK  EQU   PSARSVTE
CVTPTR   EQU   FLCCVT
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTQV3   EQU   CVTS01+596
CVTGSDA  EQU   CVTS01+600
ASCBPTR  EQU   PSAAOLD
TCBPTR   EQU   PSATOLD
DEBBAS02 EQU   DEBBASND
DEBDDS1  EQU   DEBBAS02
DEBSUCBA EQU   DEBDDS1
DEBDEVED EQU   DEBDDS1+4
DEBRDCB  EQU   DEBDDS1+4
DEBPDCB  EQU   DEBDDS1+8
DEBWDCB  EQU   DEBDDS1+12
DEBACS09 EQU   DEBDEVED
DEBASC09 EQU   DEBACS09
DEBEAMFG EQU   DEBASC09+3
DEBDSID  EQU   DEBASC09+4
DEBEOD   EQU   DEBASC09+12
DEBBOE   EQU   DEBEOD
DEBEODRV EQU   DEBBOE
DEBEODTT EQU   DEBBOE+1
DEBEOD0  EQU   DEBBOE+2
DEBEODSS EQU   DEBBOE+3
DEBBAS01 EQU   DEBBASND
DEBISAM  EQU   DEBBAS01
DEBFIEAD EQU   DEBISAM
DEBFPEAD EQU   DEBISAM+4
DEBFOEAD EQU   DEBISAM+8
DEBEXPT  EQU   DEBISAM+12
DEBRPSID EQU   DEBEXPT
APCTZ    EQU   APCTZ@@@
APCTZUAA EQU   APCTZ
APCTZUAB EQU   APCTZ+4
APCTZUAC EQU   APCTZ+8
APCTZUAD EQU   APCTZ+12
APCTZUAE EQU   APCTZ+16
APCTZUBB EQU   APCTZ+24
APCTZD10 EQU   APCTZ+28
APCTZD20 EQU   APCTZ+32
APCTZD40 EQU   APCTZ+36
APCTZD41 EQU   APCTZ+40
APCTZD42 EQU   APCTZ+44
APCTZD43 EQU   APCTZ+48
APCTZD44 EQU   APCTZ+52
APCTZD45 EQU   APCTZ+56
APCTZD46 EQU   APCTZ+60
APCTZD47 EQU   APCTZ+64
APCTZD48 EQU   APCTZ+68
APCTZD49 EQU   APCTZ+72
APCTZD60 EQU   APCTZ+76
APCTZD80 EQU   APCTZ+80
APCTZD4E EQU   APCTZ+84
APCTZMBA EQU   APCTZ+88
APCTZMBD EQU   APCTZ+92
APCTZMBG EQU   APCTZ+96
APCTZMBR EQU   APCTZ+100
APCTZDX1 EQU   APCTZ+104
APCTZDX2 EQU   APCTZ+108
APCTZDX3 EQU   APCTZ+112
APCTZDX4 EQU   APCTZ+116
APCTZMBH EQU   APCTZ+120
APCTZMBK EQU   APCTZ+124
APCTZMBM EQU   APCTZ+128
APCTZMJB EQU   APCTZ+132
APCTZMJC EQU   APCTZ+136
APCTZMJH EQU   APCTZ+140
APCTZMMA EQU   APCTZ+144
APCTZDMD EQU   APCTZ+148
APCTZD81 EQU   APCTZ+152
APCTZDID EQU   APCTZ+156
APCTZDRI EQU   APCTZ+160
APCTZMJI EQU   APCTZ+164
APCTZDWT EQU   APCTZ+168
APCTZDMM EQU   APCTZ+172
APCTZDAL EQU   APCTZ+176
APCTZDBK EQU   APCTZ+180
APCTZDIP EQU   APCTZ+184
APCTZDDA EQU   APCTZ+188
APCTZDUL EQU   APCTZ+192
APCTZDEQ EQU   APCTZ+196
APCTZDDQ EQU   APCTZ+200
APCTZDUA EQU   APCTZ+204
APCTZUAF EQU   APCTZ+208
APCTZUAG EQU   APCTZ+212
APCTZDIO EQU   APCTZ+216
APCTZUHA EQU   APCTZ+220
APCTZUHB EQU   APCTZ+224
APCTZJAA EQU   APCTZ+232
APCTZJAD EQU   APCTZ+236
APCTZJAG EQU   APCTZ+240
APCTZJAJ EQU   APCTZ+244
APCTZJAM EQU   APCTZ+248
APCTZJAP EQU   APCTZ+252
APCTZJAY EQU   APCTZ+256
APCTZUFA EQU   APCTZ+260
APCTZUJA EQU   APCTZ+264
APCTZDAP EQU   APCTZ+268
APCTZKAA EQU   APCTZ+272
APCTZD82 EQU   APCTZ+276
APCTZMIB EQU   APCTZ+280
APCTZMIC EQU   APCTZ+284
APCTZD83 EQU   APCTZ+288
APCTZMIF EQU   APCTZ+296
APCTZJH0 EQU   APCTZ+300
APCTZJI0 EQU   APCTZ+304
APCTZJI3 EQU   APCTZ+308
APCTZJJ0 EQU   APCTZ+312
APCTZJBA EQU   APCTZ+316
APCTZJBD EQU   APCTZ+320
APCTZJBG EQU   APCTZ+324
APCTZJBJ EQU   APCTZ+328
APCTZJBM EQU   APCTZ+332
APCTZKCA EQU   APCTZ+340
APCTZKDA EQU   APCTZ+344
APCTZJDA EQU   APCTZ+356
APCTZJDJ EQU   APCTZ+360
APCTZJH6 EQU   APCTZ+364
APCTZJHO EQU   APCTZ+368
APCTZJHF EQU   APCTZ+372
APCTZJHE EQU   APCTZ+376
APCTZDQR EQU   APCTZ+380
APCTZJHR EQU   APCTZ+384
APCTZJHT EQU   APCTZ+388
APCTZJHW EQU   APCTZ+392
APCTZ1   EQU   APCTZ@@1
APCTZKBA EQU   APCTZ1
APCTZKBC EQU   APCTZ1+4
APCTZKBB EQU   APCTZ1+8
APCTZJHC EQU   APCTZ1+20
APCTZJHQ EQU   APCTZ1+24
APCTZKBD EQU   APCTZ1+28
APCTZKBE EQU   APCTZ1+40
APCTZUKA EQU   APCTZ1+56
APCTZKBF EQU   APCTZ1+60
APCTZJDD EQU   APCTZ1+64
APCTZJDG EQU   APCTZ1+68
APCTZJDM EQU   APCTZ1+72
APCTZLCA EQU   APCTZ1+76
APCTZLCB EQU   APCTZ1+80
APCTZDWI EQU   APCTZ1+84
APCTZJAX EQU   APCTZ1+88
APCTZKGA EQU   APCTZ1+92
APCTZKGB EQU   APCTZ1+96
APCTZKGC EQU   APCTZ1+100
APCTZKGD EQU   APCTZ1+104
APCTU    EQU   APCTU@@@
APCT1MAB EQU   APCTU
APCT1MBD EQU   APCTU+4
APCT2MBD EQU   APCTU+8
APCT1CMD EQU   APCTU+12
APCT1JAA EQU   APCTU+20
APCT1JHC EQU   APCTU+24
APCT2JHC EQU   APCTU+28
APCT1JHT EQU   APCTU+32
APCT1JHL EQU   APCTU+36
APCT2JHL EQU   APCTU+40
APCT1JBJ EQU   APCTU+44
@NM00147 EQU   APIOIOCB
@NM00148 EQU   APIOIOCB
CMBRX    EQU   CMBRXZZZ
FLC      EQU   PSA
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
CMBXRCN  EQU   CMBRX+6
CMBXRCT  EQU   CMBRX+5
@NM00190 EQU   CMBRX+4
CMBRKT   EQU   CMBRX+2
CMBRMT   EQU   CMBRX
APIOIOB  EQU   @NM00148+160
@NM00149 EQU   @NM00148
APIOSRB  EQU   @NM00147+128
APIOIOSB EQU   @NM00147
@NM00131 EQU   APCTU+48
APCT1MBM EQU   APCTU+16
@NM00130 EQU   APCTZ1+108
@NM00129 EQU   APCTZ1+52
@NM00128 EQU   APCTZ1+48
@NM00127 EQU   APCTZ1+44
@NM00126 EQU   APCTZ1+36
@NM00125 EQU   APCTZ1+32
@NM00124 EQU   APCTZ1+16
@NM00123 EQU   APCTZ1+12
@NM00122 EQU   APCTZ+396
@NM00121 EQU   APCTZ+352
@NM00120 EQU   APCTZ+348
@NM00119 EQU   APCTZ+336
@NM00118 EQU   APCTZ+292
APCTZJFA EQU   APCTZ+228
@NM00117 EQU   APCTZ+20
DEBEXPTA EQU   DEBEXPT+1
DEBRSV12 EQU   DEBRPSID
DEBRSV11 EQU   DEBRPSID
DEBRSV10 EQU   DEBRPSID
DEBRSV09 EQU   DEBRPSID
DEBRPSAP EQU   DEBRPSID
DEBRPSO  EQU   DEBRPSID
DEBRPSI  EQU   DEBRPSID
DEBRPSP  EQU   DEBRPSID
DEBFOEB  EQU   DEBFOEAD+1
DEBNOEE  EQU   DEBFOEAD
DEBFPEB  EQU   DEBFPEAD+1
DEBNPEE  EQU   DEBFPEAD
DEBFIEB  EQU   DEBFIEAD+1
DEBNIEE  EQU   DEBFIEAD
DEBBOESS EQU   DEBEODSS
DEBBOE0  EQU   DEBEOD0
DEBBOETT EQU   DEBEODTT
DEBBOERV EQU   DEBEODRV
DEBRV008 EQU   DEBDSID+7
DEBWTPTI EQU   DEBDSID+6
DEBEXDTE EQU   DEBDSID
DEBRV007 EQU   DEBEAMFG
DEBRV006 EQU   DEBEAMFG
DEBRV005 EQU   DEBEAMFG
DEBRV004 EQU   DEBEAMFG
DEBSECVL EQU   DEBEAMFG
DEBVAMSG EQU   DEBEAMFG
DEBDSOPN EQU   DEBEAMFG
DEBMULTI EQU   DEBEAMFG
DEBVSEQU EQU   DEBASC09+2
DEBDSSQL EQU   DEBASC09+1
DEBVOLAC EQU   DEBASC09
DEBWDCBA EQU   DEBWDCB+1
DEBRSV08 EQU   DEBWDCB
DEBPDCBA EQU   DEBPDCB+1
DEBRSV07 EQU   DEBPDCB
DEBRDCBA EQU   DEBRDCB+1
DEBRSV06 EQU   DEBRDCB
DEBSUCBB EQU   DEBSUCBA+1
DEBSDVM  EQU   DEBSUCBA
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
@NM00164 EQU   APESMV+6
@NM00163 EQU   APESMV+4
APESMVKW EQU   APESMV+2
APESMVMS EQU   APESMV
APESREGD EQU   APESREGS+52
APESREGC EQU   APESREGS+48
APESREGB EQU   APESREGS+44
APESREGA EQU   APESREGS+40
APESREG9 EQU   APESREGS+36
APESREG8 EQU   APESREGS+32
APESREG7 EQU   APESREGS+28
APESREG6 EQU   APESREGS+24
APESREG5 EQU   APESREGS+20
APESREG4 EQU   APESREGS+16
APESREG3 EQU   APESREGS+12
APESREG2 EQU   APESREGS+8
APESREG1 EQU   APESREGS+4
APESREG0 EQU   APESREGS
@NM00154 EQU   APVU+3040
@NM00153 EQU   APVUAUSE
APVUMON  EQU   APVUAUSE
APVUVUSE EQU   APVUAUSE
@NM00152 EQU   APVU+16
@NM00151 EQU   APVU+14
APVUANUM EQU   APVU+12
APVULEN  EQU   APVUSPLN+1
APVUSPNO EQU   APVUSPLN
APVUUSER EQU   APVU+4
APVUID   EQU   APVU
APSVWORK EQU   APSV+80
@NM00150 EQU   APSV+80
APSVFREE EQU   APSV+76
APSVAPSM EQU   APSV+72
APSVRG12 EQU   APSVREGS+56
APSVRG11 EQU   APSVREGS+52
APSVRG10 EQU   APSVREGS+48
APSVRG9  EQU   APSVREGS+44
APSVRG8  EQU   APSVREGS+40
APSVRG7  EQU   APSVREGS+36
APSVRG6  EQU   APSVREGS+32
APSVRG5  EQU   APSVREGS+28
APSVRG4  EQU   APSVREGS+24
APSVRG3  EQU   APSVREGS+20
APSVRG2  EQU   APSVREGS+16
APSVRG1  EQU   APSVREGS+12
APSVRG0  EQU   APSVREGS+8
APSVRG15 EQU   APSVREGS+4
APSVRG14 EQU   APSVREGS
APSVAPSC EQU   APSV
APMVMMSG EQU   APMVMSG+4
APMVMNBR EQU   APMVMSG
APMVKKWD EQU   APMVKWD+4
APMVKNBR EQU   APMVKWD
APMVHEM  EQU   APMVHDR
@NM00146 EQU   APIO+424
@NM00145 EQU   APIO+400
APIOTMEE EQU   APIO+396
APIOTMES EQU   APIO+392
APIOXTME EQU   APIO+388
APIONBRI EQU   APIONBR+2
APIONBRX EQU   APIONBR
APIOAPCT EQU   APIO+380
APIOGMS1 EQU   APIOGMSZ+2
@NM00144 EQU   APIOGMSZ+1
APIOGMSP EQU   APIOGMSZ
APIOGMAD EQU   APIO+372
APIOCISZ EQU   APIO+370
APIORB   EQU   APIOTR+4
APIOTCB  EQU   APIOTR
APIOECB  EQU   APIO+356
APIOTCSW EQU   APIOSAVE
APIOSNSE EQU   APIO+256
APIOFLG6 EQU   APIOFLGB+2
APIOFLG5 EQU   APIOFLGB+1
APIOFLG4 EQU   APIOFLGB
@NM00143 EQU   APIOFLG3
APIOPGFS EQU   APIOFLG3
APIOPGIP EQU   APIOFLG3
APIORSME EQU   APIOFLG3
APIONPST EQU   APIOFLG3
APIOIOCT EQU   APIOFLG3
@NM00142 EQU   APIOFLG2
APIODMPT EQU   APIOFLG2
APIODUMP EQU   APIOFLG2
APIOCSWT EQU   APIOFLG2
APIOVINX EQU   APIOFLG2
APIOVSNS EQU   APIOFLG2
APIOEXCL EQU   APIOFLG2
APIOFLG1 EQU   APIOFLGA+1
@NM00141 EQU   APIOFLG0
APIOSU50 EQU   APIOFLG0
APIOSYNC EQU   APIOFLG0
APIOFXED EQU   APIOFLG0
@NM00140 EQU   APIO+246
APIOOLAP EQU   APIO+244
APIORGN  EQU   APIO+236
APIOPGFL EQU   APIO+232
APIOPGFX EQU   APIO+228
APIOAPCI EQU   APIO+224
APIOCCW  EQU   APIO+220
APIOAPXL EQU   APIO+212
APIOVCSW EQU   APIO+208
APIOAPUB EQU   APIO+204
APIOUSER EQU   APIO+196
APDXAPIO EQU   APDX+136
@NM00139 EQU   APDX+136
@NM00138 EQU   APDX+133
@NM00137 EQU   APDX+132
@NM00136 EQU   APDXSW1
@NM00135 EQU   APDXSW0
APDXSSMF EQU   APDXSW0
APDXSEOT EQU   APDXSW0
APDXSOPN EQU   APDXSW0
APDXIOCT EQU   APDX+128
@NM00134 EQU   APDX+52
@NM00133 EQU   APDX+50
APDXNDMP EQU   APDX+48
APDXDEB  EQU   APDX+44
APDXAPOC EQU   APDX+40
APDXDXA  EQU   APDX+36
APDXSIZE EQU   APDXDXL+2
@NM00132 EQU   APDXDXL
APDXAPMF EQU   APDX252A
APDX252L EQU   APDX+24
APDX000A EQU   APDX+20
APDX000L EQU   APDX+16
APDXAPDS EQU   APDX+12
APDXAPCT EQU   APDX+8
APDXUSER EQU   APDX+4
APDXID   EQU   APDX
@NM00116 EQU   APCT+1556
APCTSVCT EQU   APCT+1552
APCTDAVT EQU   APCT+1548
APCTLOGL EQU   APCT+1544
@NM00115 EQU   APCT+1540
APCTDMPU EQU   APCT+1536
APCTDMPM EQU   APCT+1532
APCTNDMP EQU   APCT+1530
APCTASID EQU   APCT+1528
APCTLGPG EQU   APCT+1526
APCTLGLN EQU   APCT+1524
APCTABR  EQU   APCT+1116
APCTACTR EQU   APCT+1112
APCTLOGD EQU   APCT+1108
APCTDCLD EQU   APCT+1104
@NM00114 EQU   APCT+1080
@NM00113 EQU   APCT+1078
APCTKCAX EQU   APCT+1076
@NM00112 EQU   APCT+1068
APCTCSCT EQU   APCT+1060
APCTSTDF EQU   APCT+1056
APCTSTMX EQU   APCT+1052
APCTRGMX EQU   APCT+1048
APCTSIZE EQU   APCT+1046
APCTCTUB EQU   APCT+1045
APCTMFID EQU   APCT+1044
APCTMFSZ EQU   APCT+1040
APCTCRTN EQU   APCT+1036
APCTAPCP EQU   APCT+1032
APCTAMNA EQU   APCT+1028
APCTEMNA EQU   APCT+1024
APCTAALP EQU   APCT+1020
APCTEALP EQU   APCT+1016
@NM00111 EQU   APCT+1012
@NM00110 EQU   APCT+1008
@NM00109 EQU   APCT+1004
APCTEIPL EQU   APCT+1000
@NM00108 EQU   APCT+996
@NM00107 EQU   APCT+992
@NM00106 EQU   APCT+988
@NM00105 EQU   APCT+984
@NM00104 EQU   APCT+980
APCTECPW EQU   APCT+976
APCTEULD EQU   APCT+972
APCTECPT EQU   APCT+968
APCTEALC EQU   APCT+964
APCTECBL EQU   APCT+960
APCTECIT EQU   APCT+956
APCTCQAF EQU   APCTCQAQ
APCTCQL  EQU   APCTAPCQ+4
APCTCQF  EQU   APCTAPCQ
APCTCQLK EQU   APCT+940
@NM00103 EQU   @NM00099+2
@NM00102 EQU   APCTPRSW
APCTAPST EQU   APCTPRSW
@NM00101 EQU   APCTPRSW
@NM00100 EQU   APCTSTAT
APCTWARM EQU   APCTSTAT
APCTTERM EQU   APCTSTAT
APCTHALT EQU   APCTSTAT
APCTQSCE EQU   APCTSTAT
APCTSTRT EQU   APCTSTAT
APCTACT  EQU   APCTSTAT
@NM00098 EQU   APCT+935
APCTSOUT EQU   APCT+934
APCTDAID EQU   APCT+933
APCTSV34 EQU   APCT+932
APCTMJOB EQU   APCT+928
APCTTCB  EQU   APCT+924
APCTASCB EQU   APCT+920
APCTDCNW EQU   APCT+918
APCTDCNR EQU   APCT+916
@NM00097 EQU   APCT+912
@NM00096 EQU   APCT+908
@NM00095 EQU   APCT+904
@NM00094 EQU   APCT+900
@NM00093 EQU   APCTERRS+22
APCTERTJ EQU   APCTERRS+20
APCTERTD EQU   APCTERRS+18
APCTERTC EQU   APCTERRS+16
APCTERTB EQU   APCTERRS+14
APCTERTA EQU   APCTERRS+12
APCTERT9 EQU   APCTERRS+10
APCTERT3 EQU   APCTERRS+8
APCTERT2 EQU   APCTERRS+6
APCTERT1 EQU   APCTERRS+4
APCTERT0 EQU   APCTERRS+2
APCTERTT EQU   APCTERRS
APCTDSAP EQU   APCT+872
APCTISUB EQU   APCT+868
APCTUBAP EQU   APCT+864
APCTAPDS EQU   APCT+860
APCTUBIC EQU   APCT+856
APCTUBIS EQU   APCT+852
APCTAPUB EQU   APCT+848
APCTUBLK EQU   APCT+844
APCTBR1A EQU   APCTBR14+2
@NM00092 EQU   APCTBR14
APCTSMSZ EQU   APCTSMAD+2
@NM00091 EQU   APCTSMAD+1
@NM00090 EQU   APCTSMAD
APCTSMIS EQU   APCTSMIN+2
@NM00089 EQU   APCTSMIN+1
APCTSMSP EQU   APCTSMIN
@NM00088 EQU   APCT+30
APCTLINE EQU   APCT+28
APCTLBSZ EQU   APCT+24
APCTREG  EQU   APCT+20
APCTSSID EQU   APCTENQM+4
@NM00087 EQU   APCTENQM
APCTSSVT EQU   APCT+8
APCTUSER EQU   APCT+4
APCTID   EQU   APCT
@NM00086 EQU   SSET+7
@NM00085 EQU   SSETFLAG
SSETYPE  EQU   SSETFLAG
SSETASID EQU   SSET+4
@NM00084 EQU   SSET+2
SSETLEN  EQU   SSET
SSENASCB EQU   SSEN+12
SSENJBNM EQU   SSEN+8
@NM00083 EQU   SSEN+7
@NM00082 EQU   SSENFLAG
SSENTYPE EQU   SSENFLAG
SSENASID EQU   SSEN+4
@NM00081 EQU   SSEN+2
SSENLEN  EQU   SSEN
SSOBRETN EQU   SSOB+12
SSOBSSIB EQU   SSOB+8
SSOBLEN  EQU   SSOB+4
SSOBID   EQU   SSOB
SSCTSSVT EQU   SSCT+16
SSCTRSV1 EQU   SSCT+13
@NM00080 EQU   SSCTFLG1
SSCTUPSS EQU   SSCTFLG1
SSCTSFOR EQU   SSCTFLG1
SSCTSNAM EQU   SSCT+8
SSCTSCTA EQU   SSCT+4
SSCTID   EQU   SSCT
@NM00079 EQU   SDWA+512
SDWAVRA  EQU   SDWARA+4
SDWAURAL EQU   SDWARA+3
@NM00078 EQU   SDWADPVA
SDWAEBC  EQU   SDWADPVA
SDWAHEX  EQU   SDWADPVA
SDWAVRAL EQU   SDWARA
SDWAERTM EQU   SDWA+396
SDWACOMP EQU   SDWA+392
SDWARCPL EQU   SDWA+364
@NM00077 EQU   SDWADPSA+32
SDWATO4  EQU   SDWADPSL+28
SDWAFRM4 EQU   SDWADPSL+24
SDWATO3  EQU   SDWADPSL+20
SDWAFRM3 EQU   SDWADPSL+16
SDWATO2  EQU   SDWADPSL+12
SDWAFRM2 EQU   SDWADPSL+8
SDWATO1  EQU   SDWADPSL+4
SDWAFRM1 EQU   SDWADPSL
@NM00076 EQU   SDWADDAT+3
@NM00075 EQU   SDWAPDAT
SDWAUSPL EQU   SDWAPDAT
SDWADPSW EQU   SDWAPDAT
SDWATJPA EQU   SDWAPDAT
SDWATLPA EQU   SDWAPDAT
SDWADREG EQU   SDWAPDAT
SDWADSAH EQU   SDWAPDAT
SDWADSAS EQU   SDWAPDAT
@NM00074 EQU   SDWASDA1
SDWAERR  EQU   SDWASDA1
SDWAIO   EQU   SDWASDA1
SDWADM   EQU   SDWASDA0
SDWAQQS  EQU   SDWASDA0
SDWACBS  EQU   SDWASDA0
SDWAGTF  EQU   SDWASDA0
SDWASWA  EQU   SDWASDA0
SDWALSQA EQU   SDWASDA0
SDWASQA  EQU   SDWASDA0
SDWANUC  EQU   SDWASDA0
@NM00073 EQU   SDWADUMP+2
@NM00072 EQU   SDWADPFS
SDWASLST EQU   SDWADPFS
@NM00071 EQU   SDWADPFS
SDWAENSN EQU   SDWADPFS
SDWADLST EQU   SDWADPFS
SDWADPT  EQU   SDWADPFS
SDWADPID EQU   SDWADUMP
SDWADPLA EQU   SDWA+316
SDWAREXN EQU   SDWARECP+16
SDWACSCT EQU   SDWARECP+8
SDWAMODN EQU   SDWARECP
SDWASEQ# EQU   SDWA+290
SDWAASID EQU   SDWA+288
SDWATALW EQU   SDWALKWS+28
SDWATDLW EQU   SDWALKWS+24
SDWATNLW EQU   SDWALKWS+20
SDWAAPLW EQU   SDWALKWS+16
SDWAIPLW EQU   SDWALKWS+12
SDWAILLW EQU   SDWALKWS+8
SDWAIULW EQU   SDWALKWS+4
SDWAICLW EQU   SDWALKWS
SDWAFLLK EQU   SDWAACF4
SDWACMS  EQU   SDWAACF4
SDWAOPTM EQU   SDWAACF4
SDWATADB EQU   SDWAACF4
SDWATDNB EQU   SDWAACF4
SDWATNCB EQU   SDWAACF4
SDWAILCH EQU   SDWAACF4
SDWAIUCB EQU   SDWAACF4
SDWAICAT EQU   SDWAACF3
SDWAIPRG EQU   SDWAACF3
SDWASALL EQU   SDWAACF3
SDWAASMP EQU   SDWAACF3
SDWADISP EQU   SDWAACF3
@NM00070 EQU   SDWAACF3
@NM00069 EQU   SDWAACF2
SDWAFREE EQU   SDWAACF2
SDWAUPRG EQU   SDWAACF2
@NM00068 EQU   SDWAACF2
SDWASPIN EQU   SDWAACF2
@NM00067 EQU   SDWAACF2
SDWARCRD EQU   SDWAACF2
SDWARCDE EQU   SDWAPARQ
SDWALCPU EQU   SDWACPUA+2
@NM00066 EQU   SDWACPUA
SDWARECA EQU   SDWA+244
SDWARTYA EQU   SDWA+240
SDWACPUI EQU   SDWA+239
@NM00065 EQU   SDWAIOFS
SDWANIOP EQU   SDWAIOFS
SDWANOIO EQU   SDWAIOFS
SDWAIOHT EQU   SDWAIOFS
SDWAIOQR EQU   SDWAIOFS
SDWAFMID EQU   SDWA+236
SDWAERFL EQU   SDWAERRD
SDWAMCIV EQU   SDWAERRD
SDWARPIV EQU   SDWAERRD
SDWAMABD EQU   SDWAERRD
SDWACTS  EQU   SDWAERRD
SDWASTAE EQU   SDWAERRD
SDWANRBE EQU   SDWAERRD
SDWACLUP EQU   SDWAERRD
@NM00064 EQU   SDWAERRC
SDWAEAS  EQU   SDWAERRC
SDWAPERC EQU   SDWAERRC
SDWAIRB  EQU   SDWAERRC
SDWASTAI EQU   SDWAERRC
SDWASTAF EQU   SDWAERRC
SDWASRBM EQU   SDWAERRB
SDWALDIS EQU   SDWAERRB
SDWAENRB EQU   SDWAERRB
SDWATYP1 EQU   SDWAERRB
@NM00063 EQU   SDWAERRB
SDWAPGIO EQU   SDWAERRA
SDWATEXC EQU   SDWAERRA
SDWASVCE EQU   SDWAERRA
SDWAABTM EQU   SDWAERRA
SDWASVCD EQU   SDWAERRA
SDWARKEY EQU   SDWAERRA
SDWAPCHK EQU   SDWAERRA
SDWAMCHK EQU   SDWAERRA
SDWATIME EQU   SDWAMCH+20
SDWARFSA EQU   SDWAMCH+16
@NM00062 EQU   SDWAMCH+14
SDWAVEQR EQU   SDWARSR2
SDWAPGFX EQU   SDWARSR2
SDWAFLSQ EQU   SDWARSR2
SDWAFSQA EQU   SDWARSR2
SDWANUCL EQU   SDWARSR2
SDWASPER EQU   SDWARSR2
SDWAINTC EQU   SDWARSR2
SDWAOFLN EQU   SDWARSR2
SDWACHNG EQU   SDWARSR1
SDWAMSER EQU   SDWARSR1
@NM00061 EQU   SDWARSR1
SDWACPID EQU   SDWAMCH+10
SDWATERR EQU   SDWAMCHD
SDWAFPRX EQU   SDWAMCHD
SDWAINSF EQU   SDWAMCHD
SDWAACR  EQU   SDWAMCHD
SDWASCK  EQU   SDWAMCHD
SDWAPSWU EQU   SDWAMCHD
SDWAREGU EQU   SDWAMCHD
SDWASKYF EQU   SDWAMCHD
@NM00060 EQU   SDWAMCHS
SDWARSRF EQU   SDWAMCHS
SDWARSRC EQU   SDWAMCHS
SDWAINVP EQU   SDWAMCHS
SDWATSVL EQU   SDWAMCHS
SDWARCDF EQU   SDWAMCHS
SDWASRVL EQU   SDWAMCHS
SDWASCKE EQU   SDWASTCK+4
SDWASCKB EQU   SDWASTCK
SDWALNTH EQU   SDWAIDNT+1
SDWASPID EQU   SDWAIDNT
SDWASR15 EQU   SDWASRSV+60
SDWASR14 EQU   SDWASRSV+56
SDWASR13 EQU   SDWASRSV+52
SDWASR12 EQU   SDWASRSV+48
SDWASR11 EQU   SDWASRSV+44
SDWASR10 EQU   SDWASRSV+40
SDWASR09 EQU   SDWASRSV+36
SDWASR08 EQU   SDWASRSV+32
SDWASR07 EQU   SDWASRSV+28
SDWASR06 EQU   SDWASRSV+24
SDWASR05 EQU   SDWASRSV+20
SDWASR04 EQU   SDWASRSV+16
SDWASR03 EQU   SDWASRSV+12
SDWASR02 EQU   SDWASRSV+8
SDWASR01 EQU   SDWASRSV+4
SDWASR00 EQU   SDWASRSV
SDWATRN2 EQU   SDWAAEC2+4
SDWAIPC2 EQU   SDWAICD2
SDWAIMC2 EQU   SDWAICD2
SDWAIPR2 EQU   SDWAICD2
@NM00059 EQU   SDWAINC2
@NM00058 EQU   SDWAILC2
SDWAIL2  EQU   SDWAILC2
@NM00057 EQU   SDWAILC2
@NM00056 EQU   SDWAAEC2
SDWAADD2 EQU   SDWANXT2+1
@NM00055 EQU   SDWANXT2
@NM00054 EQU   SDWAEC2+3
SDWASGN2 EQU   SDWAINT2
SDWAEXP2 EQU   SDWAINT2
SDWADEC2 EQU   SDWAINT2
SDWAFPO2 EQU   SDWAINT2
SDWACC2  EQU   SDWAINT2
@NM00053 EQU   SDWAINT2
SDWAPGM2 EQU   SDWAMWP2
SDWAWAT2 EQU   SDWAMWP2
SDWAMCK2 EQU   SDWAMWP2
SDWAECT2 EQU   SDWAMWP2
SDWAKEY2 EQU   SDWAMWP2
SDWAEXT2 EQU   SDWAEMK2
SDWAIO2  EQU   SDWAEMK2
SDWATRM2 EQU   SDWAEMK2
@NM00052 EQU   SDWAEMK2
SDWAPER2 EQU   SDWAEMK2
@NM00051 EQU   SDWAEMK2
SDWATRAN EQU   SDWAAEC1+4
SDWAIPC1 EQU   SDWAICD1
SDWAIMC1 EQU   SDWAICD1
SDWAIPR1 EQU   SDWAICD1
@NM00050 EQU   SDWAINC1
@NM00049 EQU   SDWAILC1
SDWAIL1  EQU   SDWAILC1
@NM00048 EQU   SDWAILC1
@NM00047 EQU   SDWAAEC1
SDWAADD1 EQU   SDWANXT1+1
@NM00046 EQU   SDWANXT1
@NM00045 EQU   SDWAEC1+3
SDWASGN1 EQU   SDWAINT1
SDWAEXP1 EQU   SDWAINT1
SDWADEC1 EQU   SDWAINT1
SDWAFPO1 EQU   SDWAINT1
SDWACC1  EQU   SDWAINT1
@NM00044 EQU   SDWAINT1
SDWAPGM1 EQU   SDWAMWP1
SDWAWAT1 EQU   SDWAMWP1
SDWAMCK1 EQU   SDWAMWP1
SDWAECT1 EQU   SDWAMWP1
SDWAKEY1 EQU   SDWAMWP1
SDWAEXT1 EQU   SDWAEMK1
SDWAIO1  EQU   SDWAEMK1
SDWATRM1 EQU   SDWAEMK1
@NM00043 EQU   SDWAEMK1
SDWAPER1 EQU   SDWAEMK1
@NM00042 EQU   SDWAEMK1
SDWAIOBR EQU   SDWA+100
SDWAEPA  EQU   SDWA+96
@NM00041 EQU   SDWANAME+4
SDWARBAD EQU   SDWANAME
SDWAGR15 EQU   SDWAGRSV+60
SDWAGR14 EQU   SDWAGRSV+56
SDWAGR13 EQU   SDWAGRSV+52
SDWAGR12 EQU   SDWAGRSV+48
SDWAGR11 EQU   SDWAGRSV+44
SDWAGR10 EQU   SDWAGRSV+40
SDWAGR09 EQU   SDWAGRSV+36
SDWAGR08 EQU   SDWAGRSV+32
SDWAGR07 EQU   SDWAGRSV+28
SDWAGR06 EQU   SDWAGRSV+24
SDWAGR05 EQU   SDWAGRSV+20
SDWAGR04 EQU   SDWAGRSV+16
SDWAGR03 EQU   SDWAGRSV+12
SDWAGR02 EQU   SDWAGRSV+8
SDWAGR01 EQU   SDWAGRSV+4
SDWAGR00 EQU   SDWAGRSV
SDWANXTP EQU   SDWACTL2+5
SDWASGP  EQU   SDWAPMKP
SDWAEUP  EQU   SDWAPMKP
SDWADOP  EQU   SDWAPMKP
SDWAFPP  EQU   SDWAPMKP
SDWACCP  EQU   SDWAPMKP
SDWAILP  EQU   SDWAPMKP
SDWAINTP EQU   SDWACTL2+2
SDWASPVP EQU   SDWAMWPP
SDWAWATP EQU   SDWAMWPP
SDWAMCKP EQU   SDWAMWPP
@NM00040 EQU   SDWAMWPP
SDWAKEYP EQU   SDWAMWPP
SDWAEXTP EQU   SDWACMKP
SDWAIOP  EQU   SDWACMKP
SDWANXTA EQU   SDWACTL1+5
SDWASGA  EQU   SDWAPMKA
SDWAEUA  EQU   SDWAPMKA
SDWADOA  EQU   SDWAPMKA
SDWAFPA  EQU   SDWAPMKA
SDWACCA  EQU   SDWAPMKA
SDWAILA  EQU   SDWAPMKA
SDWAINTA EQU   SDWACTL1+2
SDWASPVA EQU   SDWAMWPA
SDWAWATA EQU   SDWAMWPA
SDWAMCKA EQU   SDWAMWPA
@NM00039 EQU   SDWAMWPA
SDWAKEYA EQU   SDWAMWPA
SDWAEXTA EQU   SDWACMKA
SDWAIOA  EQU   SDWACMKA
SDWACMPC EQU   SDWAABCC+1
@NM00038 EQU   SDWACMPF
SDWASTCC EQU   SDWACMPF
@NM00037 EQU   SDWACMPF
SDWASTEP EQU   SDWACMPF
SDWAREQ  EQU   SDWACMPF
SDWAPARM EQU   SDWA
DEBXSAMB EQU   DEBXTN+28
DEBXOPNJ EQU   DEBXTN+24
DEBXXARG EQU   DEBXTN+20
DEBXMCF2 EQU   DEBXTN+19
DEBXMCF1 EQU   DEBXTN+18
DEBXDSO2 EQU   DEBXTN+17
DEBXDSO1 EQU   DEBXTN+16
DEBXDBPR EQU   DEBXTN+12
DEBXDCBM EQU   DEBXTN+8
DEBXDSAB EQU   DEBXTN+4
DEBXRV48 EQU   DEBXTN+3
DEBXRV47 EQU   DEBXFLG1
DEBXRV46 EQU   DEBXFLG1
DEBXRV45 EQU   DEBXFLG1
DEBXRV44 EQU   DEBXFLG1
DEBXRV43 EQU   DEBXFLG1
DEBXDSSI EQU   DEBXFLG1
DEBXTSKC EQU   DEBXFLG1
DEBXCDCB EQU   DEBXFLG1
DEBXLNGH EQU   DEBXTN
DEBTBLOF EQU   DEBPREFX+14
DEBAMTYP EQU   DEBPREFX+13
DEBLNGTH EQU   DEBPREFX+12
DEBDCBMK EQU   DEBXTNP
DEBDSCBA EQU   DEBPREFX+1
DEBWKARA EQU   DEBPREFX
DEBXCEAD EQU   DEBXCEA+1
DEBXCENP EQU   DEBXCEAB
DEBRSV35 EQU   DEBXCEAB
DEBRSV34 EQU   DEBXCEAB
DEBRSV33 EQU   DEBXCEAB
DEBRSV32 EQU   DEBXCEAB
DEBCEAD  EQU   DEBCEA+1
DEBCENP  EQU   DEBCEAB
DEBRSV31 EQU   DEBCEAB
DEBRSV30 EQU   DEBCEAB
DEBRSV29 EQU   DEBCEAB
DEBRSV28 EQU   DEBCEAB
DEBPCIAD EQU   DEBPCIA+1
DEBPCINP EQU   DEBPCIAB
DEBRSV27 EQU   DEBPCIAB
DEBRSV26 EQU   DEBPCIAB
DEBRSV25 EQU   DEBPCIAB
DEBRSV24 EQU   DEBPCIAB
DEBSIOAD EQU   DEBSIOA+1
DEBSIONP EQU   DEBSIOAB
DEBFIX   EQU   DEBSIOAB
DEBIOVR  EQU   DEBSIOAB
DEBSIOX  EQU   DEBSIOAB
DEBPGFX  EQU   DEBSIOAB
DEBEOEAD EQU   DEBEOEA+1
DEBEOENP EQU   DEBEOEAB
DEBRSV22 EQU   DEBEOEAB
DEBRSV21 EQU   DEBEOEAB
DEBRSV20 EQU   DEBEOEAB
DEBESMVR EQU   DEBEOEAB
DEBSUBID EQU   DEBSUBNM
DEBSIOA2 EQU   DEBACS08+24
DEBRPSIO EQU   DEBACS08+20
DEBFREED EQU   DEBACS08+16
@NM00036 EQU   DEBACS08+12
@NM00035 EQU   DEBACS08+8
DEBDISAD EQU   DEBACS08+4
@NM00034 EQU   DEBACS08
DEBRPSST EQU   DEBACS07+64
DEBARECK EQU   DEBACS07+60
DEBAREWT EQU   DEBACS07+56
DEBACHK  EQU   DEBACS07+52
DEBAWRIT EQU   DEBACS07+48
DEBASETL EQU   DEBACS07+44
DEBAREAD EQU   DEBACS07+40
DEBCRECK EQU   DEBACS07+36
DEBCREWT EQU   DEBACS07+32
DEBCCHK  EQU   DEBACS07+28
DEBCWRIT EQU   DEBACS07+24
DEBCSETL EQU   DEBACS07+20
DEBCREAD EQU   DEBACS07+16
DEBWKPT5 EQU   DEBACS07+12
DEBWKPT4 EQU   DEBACS07+8
DEBGET   EQU   DEBACS07+4
@NM00033 EQU   DEBACS07
DEBPUT   EQU   DEBACS06+4
DEBDCBFA EQU   DEBACS06
DEBLUCBB EQU   DEBLUCBA+1
DEBRSV18 EQU   DEBLUCBA
DEBFUCBB EQU   DEBFUCBA+1
DEBRSV17 EQU   DEBFUCBA
DEBTCCWB EQU   DEBTCCWA+1
DEBRSV16 EQU   DEBTCCWA
DEBTBFRB EQU   DEBTBFRA+1
DEBRSV15 EQU   DEBTBFRA
DEBDBPEF EQU   DEBACS03+8
DEBDBPP  EQU   DEBACS03+4
DEBDTPP  EQU   DEBACS03
DEBDBPE  EQU   DEBDBLK+1
DEBDBPT  EQU   DEBDBLK
DEBEXTNM EQU   DEBDSNAM
DEBLRECL EQU   DEBACSMD+14
DEBBLKSI EQU   DEBACSMD+12
DEBRSV14 EQU   DEBDSNM+4
DEBUTSAB EQU   DEBUTSAA+1
DEBRSV13 EQU   DEBUTSAA
DEBVOLNM EQU   DEBACSMD+2
DEBVLSEQ EQU   DEBVOLSQ+1
DEBRSV42 EQU   DEBVOLBT
DEBRSV41 EQU   DEBVOLBT
DEBRSV40 EQU   DEBVOLBT
DEBRSV39 EQU   DEBVOLBT
DEBRSV38 EQU   DEBVOLBT
DEBRSV37 EQU   DEBVOLBT
DEBRSV36 EQU   DEBVOLBT
DEBEXFUL EQU   DEBVOLBT
DEBNMTRK EQU   DEBDASD+14
DEBENDHH EQU   DEBDASD+12
DEBENDCC EQU   DEBDASD+10
DEBSTRHH EQU   DEBDASD+8
DEBSTRCC EQU   DEBDASD+6
DEBBINUM EQU   DEBDASD+4
DEBUCBA  EQU   DEBUCBAD+1
DEBDVMOD EQU   DEBUCBAD
DEBAPPB  EQU   DEBAPPAD+1
DEBEXSCL EQU   DEBAPPAD
DEBDCBB  EQU   DEBDCBAD+1
DEBDEBID EQU   DEBPROTG
DEBECBB  EQU   DEBECBAD+1
DEBPRIOR EQU   DEBECBAD
DEBUSRPB EQU   DEBUSRPG+1
DEBNMEXT EQU   DEBUSRPG
DEBRSV05 EQU   DEBBASIC+15
DEBXTNIN EQU   DEBFLGS1
DEBAPFIN EQU   DEBFLGS1
DEBF1CEV EQU   DEBFLGS1
DEBCINDI EQU   DEBFLGS1
DEBRSV02 EQU   DEBFLGS1
DEBRSIOA EQU   DEBFLGS1
DEBEOFDF EQU   DEBFLGS1
DEBPWCKD EQU   DEBFLGS1
DEBQSCNT EQU   DEBBASIC+13
DEBACCS  EQU   DEBOPATB
DEBPOSIT EQU   DEBOPATB
DEBZERO  EQU   DEBOPATB
DEBABEND EQU   DEBOPATB
DEBIRBB  EQU   DEBIRBAD+1
DEBRERR  EQU   DEBOFLGS
DEBLABEL EQU   DEBOFLGS
DEBSPLIT EQU   DEBOFLGS
DEBDCB   EQU   DEBOFLGS
DEBRLSE  EQU   DEBOFLGS
DEBEOF   EQU   DEBOFLGS
DEBDISP  EQU   DEBOFLGS
DEBDEBB  EQU   DEBDEBAD+1
DEBAMLNG EQU   DEBDEBAD
DEBNMSUB EQU   DEBTCBAD
@NM00032 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBRV143 EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00031 EQU   TCB+296
TCBSVCA2 EQU   TCB+292
TCBSWASA EQU   TCB+288
TCBDBTB  EQU   TCB+284
TCBRPT   EQU   TCB+280
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBRV327 EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCB+274
TCBRV326 EQU   TCB+272
TCBUKYSP EQU   TCB+268
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBRV308 EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCB+260
TCBTCBID EQU   TCB+256
TCBSTAWA EQU   TCB+252
TCBSWA   EQU   TCB+248
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBCCPVI EQU   TCBXSCT+2
TCBRV325 EQU   TCBXSCT+1
TCBRV324 EQU   TCBXSCT1
TCBRV323 EQU   TCBXSCT1
TCBRV322 EQU   TCBXSCT1
TCBRV321 EQU   TCBXSCT1
TCBRV320 EQU   TCBXSCT1
TCBRV319 EQU   TCBXSCT1
TCBS3A   EQU   TCBXSCT1
TCBACTIV EQU   TCBXSCT1
TCBRSV41 EQU   TCB+239
TCBTID   EQU   TCB+238
TCBRSVAA EQU   TCB+237
TCBABCUR EQU   TCB+236
TCBTMSAV EQU   TCB+232
TCBIOTIM EQU   TCB+228
TCBRTWA  EQU   TCB+224
TCBBACK  EQU   TCB+220
TCBTIRB  EQU   TCB+216
TCBAECB  EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBSVCS  EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBGPECB EQU   TCBFLGS7
TCBNTJS  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBCPU   EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBRSV95 EQU   TCBNDSP5
TCBRSV94 EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00030 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBNDINT EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBLJSND EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBSTCUR EQU   TCBNSTAE
TCBRV301 EQU   TCBNSTAE
TCBSYNCH EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBNSTAE
TCB33E   EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBAQE   EQU   TCB+156
TCBPQE   EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBRSV16 EQU   TCBJSTCB
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBFSA
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBJPQ+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBDWSTA EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBADINP EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBFLGS2
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBNONPR EQU   TCBFLGS1
TCBFERA  EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBTIO   EQU   TCB+12
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00029 EQU   TCBPMASK
TCBRBP   EQU   TCB
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBRV43 EQU   ASCBSRQ4
ASCBRV42 EQU   ASCBSRQ4
ASCBRV41 EQU   ASCBSRQ4
ASCBRV40 EQU   ASCBSRQ4
ASCBRV39 EQU   ASCBSRQ4
ASCBRV38 EQU   ASCBSRQ4
ASCBRV37 EQU   ASCBSRQ4
ASCBRV36 EQU   ASCBSRQ4
ASCBRV35 EQU   ASCBSRQ3
ASCBRV34 EQU   ASCBSRQ3
ASCBRV33 EQU   ASCBSRQ3
ASCBRV32 EQU   ASCBSRQ3
ASCBRV31 EQU   ASCBSRQ3
ASCBRV30 EQU   ASCBSRQ3
ASCBRV29 EQU   ASCBSRQ3
ASCBRV28 EQU   ASCBSRQ3
ASCBRV27 EQU   ASCBSRQ2
ASCBRV26 EQU   ASCBSRQ2
ASCBRV25 EQU   ASCBSRQ2
ASCBRV24 EQU   ASCBSRQ2
ASCBRV23 EQU   ASCBSRQ2
ASCBRV22 EQU   ASCBSRQ2
ASCBRV21 EQU   ASCBSRQ2
ASCBRV20 EQU   ASCBSRQ2
ASCBRV19 EQU   ASCBSRQ1
ASCBRV18 EQU   ASCBSRQ1
ASCBRV17 EQU   ASCBSRQ1
ASCBRV16 EQU   ASCBSRQ1
ASCBRV15 EQU   ASCBSRQ1
ASCBRV14 EQU   ASCBSRQ1
ASCBRV13 EQU   ASCBSRQ1
ASCBSTA  EQU   ASCBSRQ1
ASCBJBNS EQU   ASCB+176
ASCBJBNI EQU   ASCB+172
ASCBMCC  EQU   ASCB+168
ASCBRTWA EQU   ASCB+164
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUXB EQU   ASCB+148
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBQECB EQU   ASCB+136
ASCBLSQH EQU   ASCBLKGP+4
ASCBLOCK EQU   ASCBLKGP
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSRBS EQU   ASCB+118
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBS2S  EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBASXB EQU   ASCB+108
ASCBTMCH EQU   ASCB+104
ASCBNSWP EQU   ASCBFLG1
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBABNT EQU   ASCBFLG1
ASCBTERM EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBWAIT EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBAFFN EQU   ASCBFW1
ASCBDUMP EQU   ASCB+96
ASCBRV44 EQU   ASCB+92
ASCBUBET EQU   ASCB+88
ASCBECB  EQU   ASCB+84
ASCBJSTL EQU   ASCB+80
ASCBEWST EQU   ASCB+72
ASCBEJST EQU   ASCB+64
ASCBTSB  EQU   ASCB+60
ASCBCSCB EQU   ASCB+56
ASCBRSM  EQU   ASCB+52
ASCBLDA  EQU   ASCB+48
ASCBSTOR EQU   ASCB+44
ASCBDP   EQU   ASCB+43
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBCPUS EQU   ASCB+32
ASCBSPL  EQU   ASCB+28
ASCBIOSP EQU   ASCB+24
ASCBSYNC EQU   ASCBSUPC+4
ASCBSVRB EQU   ASCBSUPC
ASCBCMSF EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBFWDP EQU   ASCB+4
ASCBASCB EQU   ASCB
ASCBEGIN EQU   ASCB
@NM00028 EQU   FRRSFLGS+1
@NM00027 EQU   FRRSFLG1
FRRSNEST EQU   FRRSFLG1
FRRSRCUR EQU   FRRSFLG1
FRRSENTS EQU   FRRS+84
FRRSRTMW EQU   FRRS+16
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00026 EQU   CVTFIX+248
@NM00025 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
@NM00024 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00023 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00022 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00021 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAANEW  EQU   PSA+544
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00020 EQU   FLCFSA
@NM00019 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00018 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00017 EQU   FLCIOA
@NM00016 EQU   FLCMCLA+15
@NM00015 EQU   FLCMCLA+14
@NM00014 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00013 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00012 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00011 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00010 EQU   FLCPER
@NM00009 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00008 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00007 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00006 EQU   FLCPIILC
@NM00005 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00004 EQU   FLCSVILC
@NM00003 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00002 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00001 EQU   FLCICCW2+4
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@ENDDATA EQU   *
         END   IGTJDM,(C'PLS1054',0701,77093)
