TMDA     TITLE 'IGTMDA --- PROCESS ALGORITHM BUILD REQUEST             *
                        '
IGTMDA   CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(16)                                          01S0001
         DC    C'IGTMDA    77.231'                              01S0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01S0001
         BALR  @07,0                                            01S0001
@PSTART  LA    @05,4095(,@07)                                   01S0001
         USING @PSTART,@07                                      01S0001
         USING @PSTART+4095,@05                                 01S0001
         L     @00,@SIZDATD                                     01S0001
         IGTYGSV  R,LV=(0)
         LR    @06,@01                                          01S0001
         USING @DATD,@06                                        01S0001
         ST    @13,@SA00001+4                                   01S0001
         LM    @00,@01,20(@13)                                  01S0001
         ST    @06,8(,@13)                                      01S0001
         LR    @13,@06                                          01S0001
         MVC   @PC00001(4),0(@01)                               01S0001
*/*                                                                  */
*/* END OF APSV                                                      */
*/*                                                                  */
*                                                               01S0043
*                                                               01S0043
*   /*****************************************************************/
*   /*                                                               */
*   /* SET POINTERS FOR CONTROL BLOCKS NEEDED                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0043
*   DO;                                                         01S0043
*     RFY                                                       01S0044
*       APCWPTR RSTD;               /* NEW POINTER FOR APCW          */
*     APCWPTR=ADDR(DAPCW);                                      01S0045
         L     APCWPTR,@PC00001                                 01S0045
*     RFY                                                       01S0046
*       APCW BASED(APCWPTR);        /* GET APCW                      */
*     RFY                                                       01S0047
*       APEM BASED(ADDR(APCWEMSG)); /* GET APEM                      */
*     INPUTPTR=APCWAPIN;            /* POINT TO START OF USER   01S0048
*                                      PARAMETER LIST                */
         L     INPUTPTR,APCWAPIN(,APCWPTR)                      01S0048
*     RFY                                                       01S0049
*       APIN BASED(INPUTPTR);       /* GET APIN                      */
*     RFY                                                       01S0050
*       APAL BASED(APCWAPAL);       /* GET APAL                      */
*     RFY                                                       01S0051
*       APCI BASED(ADDR(CITENTRY(1)));/* MAP APCI ON WORK AREA       */
*     RFY                                                       01S0052
*       ISTATE BASED(APINASTD);     /* MAP ISTATE ON INPUT ISTATE    */
*     RFY                                                       01S0053
*       DESCRVEC BASED(DESCRPTR);   /* MAP DESCRIPTOR                */
*   END;                                                        01S0054
*                                                               01S0054
*   /*****************************************************************/
*   /*                                                               */
*   /* ZERO CIT AND DESCRIPTOR VECTOR WORK AREAS                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0055
*   DO;                                                         01S0055
*     APCIADTA=APCIADTA&&APCIADTA;  /* ZERO HEADER & Y VECTOR        */
         LA    @09,CITENTRY                                     01S0056
         XC    APCIADTA(20,@09),APCIADTA(@09)                   01S0056
*     APCIAV2=APCIAV2&&APCIAV2;     /* ZERO X VECTOR                 */
         XC    APCIAV2(16,@09),APCIAV2(@09)                     01S0057
*     APCIAV3=APCIAV3&&APCIAV3;     /* ZERO U VECTOR                 */
         XC    APCIAV3(16,@09),APCIAV3(@09)                     01S0058
*     DESCRPTR=ADDR(DESCRWRK);      /* POINT TO DESCRIPTOR WORK AREA */
         LA    DESCRPTR,DESCRWRK                                01S0059
*     DESCRVEC=DESCRVEC&&DESCRVEC;  /* ZERO DESCRIPTOR WORK AREA     */
         XC    DESCRVEC(88,DESCRPTR),DESCRVEC(DESCRPTR)         01S0060
*   END;                                                        01S0061
*                                                               01S0061
*   /*****************************************************************/
*   /*                                                               */
*   /* BUILD HEADER PORTION OF ALGORITHM CIT ENTRY                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0062
*   DO;                                                         01S0062
         ST    @09,@TF00001                                     01S0062
*     APCIOPID=APCWAPOP;            /* MOVE FUNCTION CODE TO CIT     */
         L     @04,@TF00001                                     01S0063
         MVC   APCIOPID(2,@04),APCWAPOP(APCWPTR)                01S0063
*     APCIOPSZ=APALCISZ;            /* MOVE ENTRY LENGTH TO CIT      */
         L     @04,APCWAPAL(,APCWPTR)                           01S0064
         LH    @04,APALCISZ(,@04)                               01S0064
         L     @02,@TF00001                                     01S0064
         STH   @04,APCIOPSZ(,@02)                               01S0064
*     NUMVECS=(APCIOPSZ-4)/8;       /* DETERMINE NO. VECTORS IN ALG  */
*                                                               01S0065
         LR    @00,@04                                          01S0065
         SL    @00,@CF00142                                     01S0065
         SRDA  @00,32                                           01S0065
         D     @00,@CF00145                                     01S0065
         LR    NUMVECS,@01                                      01S0065
*     /***************************************************************/
*     /*                                                             */
*     /* PROCESS ISTATE PARAMETER                                    */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0066
*     ERRORBIT=OFF;                 /* INITIALIZE ERROR FLAG         */
         NI    ERRORBIT,B'01111111'                             01S0066
*     IF MASKCONV=ON THEN           /* TEST IF MASK CONVERSION ERROR
*                                      REQUESTED                     */
         L     @04,APINASTD(,INPUTPTR)                          01S0067
         TM    MASKCONV(@04),B'01000000'                        01S0067
         BNO   @RF00067                                         01S0067
*       APCIASCE=ON;                /* YES - SET BIT IN CIT          */
         L     @04,@TF00001                                     01S0068
         OI    APCIASCE(@04),B'00010000'                        01S0068
*     IF MASKUFLO=ON THEN           /* IS MASK UNDERFLOW REQUESTED?  */
@RF00067 L     @04,APINASTD(,INPUTPTR)                          01S0069
         TM    MASKUFLO(@04),B'00100000'                        01S0069
         BNO   @RF00069                                         01S0069
*       APCIASUF=ON;                /* YES - SET BIT IN CIT          */
         LA    @04,CITENTRY                                     01S0070
         OI    APCIASUF(@04),B'01000000'                        01S0070
*     IF MASKOFLO=ON THEN           /* IS MASK OVERFLOW REQUESTED?   */
@RF00069 L     @04,APINASTD(,INPUTPTR)                          01S0071
         TM    MASKOFLO(@04),B'00010000'                        01S0071
         BNO   @RF00071                                         01S0071
*       APCIASOV=ON;                /* YES - SET BIT IN CIT          */
         LA    @04,CITENTRY                                     01S0072
         OI    APCIASOV(@04),B'10000000'                        01S0072
*     IF MASKUNDV=ON THEN           /* IS MASK UNNORMALIZED DIVIDE
*                                      REQUESTED?                    */
@RF00071 L     @04,APINASTD(,INPUTPTR)                          01S0073
         TM    MASKUNDV(@04),B'00001000'                        01S0073
         BNO   @RF00073                                         01S0073
*       APCIASUD=ON;                /* YES - SET BIT IN CIT          */
         LA    @04,CITENTRY                                     01S0074
         OI    APCIASUD(@04),B'00100000'                        01S0074
*     IF STACKING=ON THEN           /* IS STACKING REQUESTED?        */
@RF00073 L     @04,APINASTD(,INPUTPTR)                          01S0075
         TM    STACKING(@04),B'00000100'                        01S0075
         BNO   @RF00075                                         01S0075
*       IF(APALSTKR=ON)|(APALSTKO=ON) THEN/* YES - IS IT ALLOWED?    */
         L     @04,APCWAPAL(,APCWPTR)                           01S0076
         TM    APALSTKR(@04),B'11000000'                        01S0076
         BZ    @RF00076                                         01S0076
*         APCIASSK=ON;              /* YES - SET BIT IN CIT          */
         LA    @04,CITENTRY                                     01S0077
         OI    APCIASSK(@04),B'10000000'                        01S0077
*       ELSE                        /* NO - ERROR                    */
*         ERRORBIT=ON;              /* FLAG IT                       */
         B     @RC00076                                         01S0078
@RF00076 OI    ERRORBIT,B'10000000'                             01S0078
*     ELSE                                                      01S0079
*       IF APALSTKR=ON THEN         /* IS STACKING REQUIRED?         */
         B     @RC00075                                         01S0079
@RF00075 L     @04,APCWAPAL(,APCWPTR)                           01S0079
         TM    APALSTKR(@04),B'10000000'                        01S0079
         BNO   @RF00079                                         01S0079
*         ERRORBIT=ON;              /* YES - ERROR                   */
         OI    ERRORBIT,B'10000000'                             01S0080
*       ELSE                                                    01S0081
*         ;                                                     01S0081
@RF00079 DS    0H                                               01S0082
*   END;                                                        01S0082
*                                                               01S0082
@RC00075 DS    0H                                               01S0083
*   /*****************************************************************/
*   /*                                                               */
*   /* IF ISTATE WAS INVALID, SET ERROR INDICATORS AND RETURN        */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0083
*   IF ERRORBIT=ON THEN             /* TEST IF ISTATE WAS BAD        */
         TM    ERRORBIT,B'10000000'                             01S0083
         BNO   @RF00083                                         01S0083
*     DO;                           /* YES - SET ERROR INDICATORS    */
*       APCWZAM=ON;                 /* INDICATE ERROR OCCURRED       */
         OI    APCWZAM(APCWPTR),B'00000001'                     01S0085
*       APCWR15C=APCCRERR;          /* SET R15 RET CODE              */
         MVC   APCWR15C(4,APCWPTR),@CF00145                     01S0086
*       APCWRCT=APCCTLOG;           /* SET ERROR TYPE AS LOGICAL     */
         MVI   APCWRCT(APCWPTR),X'08'                           01S0087
*       APCWRCC=APCCA;              /* INSERT COMPONENT ID           */
         MVI   APCWRCC(APCWPTR),X'01'                           01S0088
*       APCWRCN=APCCA001;           /* INSERT ERROR NUMBER           */
         MVI   APCWRCN(APCWPTR),X'01'                           01S0089
*       APEMMSGN=APCMA001;          /* SET MSG. NO. FOR INV VALUE    */
         LA    @09,112                                          01S0090
         ALR   @09,APCWPTR                                      01S0090
         MVC   APEMMSGN(4,@09),@CF00170                         01S0090
*       APEMVALN=APCMK015;          /* SET KEYWD NUMBER FOR ISTATE   */
         MVC   APEMVALN(4,@09),@CF00176                         01S0091
*       RETURN;                     /* RETURN TO CALLER              */
@EL00001 L     @13,4(,@13)                                      01S0092
@EF00001 L     @00,@SIZDATD                                     01S0092
         LR    @01,@06                                          01S0092
         IGTYFSV  R,LV=(0),A=(1)
@ER00001 LM    @14,@12,12(@13)                                  01S0092
         BR    @14                                              01S0092
*     END;                                                      01S0093
*   ELSE                                                        01S0094
*     ;                                                         01S0094
*                                                               01S0094
@RF00083 DS    0H                                               01S0095
*   /*****************************************************************/
*   /*                                                               */
*   /* IF THE USE OF A DESCRIPTOR VECTOR IS INDICATED BY ISTATE,     */
*   /* POINT TO IT. OTHERWISE, POINT TO WORK AREA DESCRIPTOR. IF     */
*   /* DESCRIPTOR IS INCOMPLETE, FILL IN THE USER SPECIFIED BULK     */
*   /* STORE STARTING LOCATIONS                                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0095
*   IF(COMDESCV=ON)|(INCDESCV=ON) THEN/* IS USE OF DESCRIPTOR VECTOR
*                                      INDICATED?                    */
         L     @04,APINASTD(,INPUTPTR)                          01S0095
         TM    COMDESCV(@04),B'00000011'                        01S0095
         BZ    @RF00095                                         01S0095
*     DO;                                                       01S0096
*       DESCRPTR=APINADSV;          /* YES - POINT TO USER DESCRIPTOR
*                                      VECTOR                        */
         L     DESCRPTR,APINADSV(,INPUTPTR)                     01S0097
*       RFY                                                     01S0098
*         PARMSIGN BASED(ADDR(APINADSV));                       01S0098
*       IF INCDESCV=ON THEN         /* IS IT INCOMPLETE?             */
         TM    INCDESCV(@04),B'00000001'                        01S0099
         BNO   @RF00099                                         01S0099
*         DO;                       /* YES - INSERT BLK STR ADDRS    */
*           IF PSIGNBIT=ON THEN     /* ARE THERE MORE PARMS?         */
         TM    PSIGNBIT+12(INPUTPTR),B'10000000'                01S0101
         BNO   @RF00101                                         01S0101
*             ERRORBIT=ON;          /* NO - FLAG IT                  */
         OI    ERRORBIT,B'10000000'                             01S0102
*           ELSE                    /* YES - GET YARRV               */
*             DO;                   /* AND RESOLVE IT - PUT IN CIT   */
         B     @RC00101                                         01S0103
@RF00101 DS    0H                                               01S0104
*               YARRV=APINAYST;     /* YES - GET YARRV FROM USER     */
         L     @04,APINAYST(,INPUTPTR)                          01S0104
         ST    @04,YARRV(,DESCRPTR)                             01S0104
*               CALL APCVZMIF(YARRV,RSOLVERR);/* RESOLVE YARRV       */
         LA    @04,YARRV(,DESCRPTR)                             01S0105
         ST    @04,@AL00001                                     01S0105
         LA    @04,RSOLVERR                                     01S0105
         ST    @04,@AL00001+4                                   01S0105
         L     @15,APCTZMIF(,APCTPTR)                           01S0105
         LA    @01,@AL00001                                     01S0105
         BALR  @14,@15                                          01S0105
*               IF RSOLVERR^=0 THEN /* TEST ERROR RETURN WORD        */
         L     @04,RSOLVERR                                     01S0106
         LTR   @04,@04                                          01S0106
         BZ    @RF00106                                         01S0106
*                 IF RSOLVERR=BDYERROR THEN/* BOUNDARY ERROR?        */
         C     @04,@CF00045                                     01S0107
         BNE   @RF00107                                         01S0107
*                   DO;             /* YES - SET ERROR INDICATORS FOR
*                                      YARRV NOT A WORD BOUNDARY     */
*                     APCWRCN=APCCA015;/* ERROR NUMBER FOR YARRV NOT
*                                      A WORD BOUNDARY               */
         MVI   APCWRCN(APCWPTR),X'0F'                           01S0109
*                     APEMMSGN=APCMA015;/* MESSAGE NUMBER FOR NOT A
*                                      WORD BOUNDARY                 */
         LA    @09,112                                          01S0110
         ALR   @09,APCWPTR                                      01S0110
         MVC   APEMMSGN(4,@09),@CF00485                         01S0110
*                     APEMVALN=APCMK017;/* YARRV KWD NUMBER          */
         MVC   APEMVALN(4,@09),@CF00180                         01S0111
*                     GOTO OUTERR;  /* GO SET COMMON ERROR INDICATORS
*                                      AND RETURN                    */
         B     OUTERR                                           01S0112
*                   END;            /* END OF SEGMENT                */
*                 ELSE              /* TEST FOR RANGE ERROR          */
*                   IF RSOLVERR=RNGERROR THEN/* RANGE ERROR?         */
@RF00107 CLC   RSOLVERR(4),@CF00130                             01S0114
         BNE   @RF00114                                         01S0114
*                     DO;           /* YES - SET ERROR INDICATORS FOR
*                                      YARRV OUT OF RANGE            */
*                       APCWRCN=APCCA020;/* ERROR NUMBER FOR YARRV
*                                      OUT OF RANGE                  */
         MVI   APCWRCN(APCWPTR),X'14'                           01S0116
*                       APEMMSGN=APCMA020;/* MESSAGE NUMBER FOR OUT
*                                      OF RANGE                      */
         LA    @09,112                                          01S0117
         ALR   @09,APCWPTR                                      01S0117
         MVC   APEMMSGN(4,@09),@CF00156                         01S0117
*                       APEMVALN=APCMK017;/* YARRV KWD NUMBER        */
         MVC   APEMVALN(4,@09),@CF00180                         01S0118
*                       GOTO OUTERR;/* GO SET COMMON ERROR INDICATORS
*                                      AND RETURN                    */
         B     OUTERR                                           01S0119
*                     END;          /* END OF SEGMENT                */
*                   ELSE                                        01S0121
*                     ;             /* NULL - NO MIF PROBLEMS        */
@RF00114 DS    0H                                               01S0122
*             END;                                              01S0122
@RF00106 DS    0H                                               01S0123
*           RFY                                                 01S0123
*             PARMSIGN BASED(ADDR(APINAYST));                   01S0123
@RC00101 DS    0H                                               01S0124
*           IF NUMVECS>=2 THEN      /* DOES THIS ALGORITHM HAVE AN X
*                                      VECTOR?                       */
         C     NUMVECS,@CF00130                                 01S0124
         BL    @RF00124                                         01S0124
*             IF PSIGNBIT=ON THEN   /* YES - MORE PARMS?             */
         TM    PSIGNBIT+16(INPUTPTR),B'10000000'                01S0125
         BNO   @RF00125                                         01S0125
*               ERRORBIT=ON;        /* NO - FLAG ERROR               */
         OI    ERRORBIT,B'10000000'                             01S0126
*             ELSE                                              01S0127
*               DO;                                             01S0127
         B     @RC00125                                         01S0127
@RF00125 DS    0H                                               01S0128
*                 XARRV=APINAXST;   /* YES - GET XARRV FROM USER     */
         L     @04,APINAXST(,INPUTPTR)                          01S0128
         ST    @04,XARRV(,DESCRPTR)                             01S0128
*                 CALL APCVZMIF(XARRV,RSOLVERR);/* RESOLVE XARRV     */
         LA    @04,XARRV(,DESCRPTR)                             01S0129
         ST    @04,@AL00001                                     01S0129
         LA    @04,RSOLVERR                                     01S0129
         ST    @04,@AL00001+4                                   01S0129
         L     @15,APCTZMIF(,APCTPTR)                           01S0129
         LA    @01,@AL00001                                     01S0129
         BALR  @14,@15                                          01S0129
*                 IF RSOLVERR^=0 THEN/* TEST ERROR RETURN WORD       */
         L     @04,RSOLVERR                                     01S0130
         LTR   @04,@04                                          01S0130
         BZ    @RF00130                                         01S0130
*                   IF RSOLVERR=BDYERROR THEN/* BOUNDARY ERROR?      */
         C     @04,@CF00045                                     01S0131
         BNE   @RF00131                                         01S0131
*                     DO;           /* YES - SET ERROR INDICATORS FOR
*                                      XARRV NOT A WORD BOUNDARY     */
*                       APCWRCN=APCCA016;/* ERROR NUMBER FOR XARRV
*                                      NOT A WORD BOUNDARY           */
         MVI   APCWRCN(APCWPTR),X'10'                           01S0133
*                       APEMMSGN=APCMA016;/* MESSAGE NUMBER FOR NOT A
*                                      WORD BOUNDARY                 */
         LA    @09,112                                          01S0134
         ALR   @09,APCWPTR                                      01S0134
         MVC   APEMMSGN(4,@09),@CF00485                         01S0134
*                       APEMVALN=APCMK024;/* XARRV KWD NUMBER        */
         MVC   APEMVALN(4,@09),@CF00061                         01S0135
*                       GOTO OUTERR;/* GO SET COMMON ERROR INDICATORS
*                                      AND RETURN                    */
         B     OUTERR                                           01S0136
*                     END;          /* END OF SEGMENT                */
*                   ELSE            /* TEST FOR RANGE ERROR          */
*                     IF RSOLVERR=RNGERROR THEN/* RANGE ERROR?       */
@RF00131 CLC   RSOLVERR(4),@CF00130                             01S0138
         BNE   @RF00138                                         01S0138
*                       DO;         /* YES - SET ERROR INDICATORS FOR
*                                      XARRV OUT OF RANGE            */
*                         APCWRCN=APCCA021;/* ERROR NUMBER FOR XARRV
*                                      OUT OF RANGE                  */
         MVI   APCWRCN(APCWPTR),X'15'                           01S0140
*                         APEMMSGN=APCMA021;/* MESSAGE NUMBER FOR OUT
*                                      OF RANGE                      */
         LA    @09,112                                          01S0141
         ALR   @09,APCWPTR                                      01S0141
         MVC   APEMMSGN(4,@09),@CF00156                         01S0141
*                         APEMVALN=APCMK024;/* XARRV KWD NUMBER      */
         MVC   APEMVALN(4,@09),@CF00061                         01S0142
*                         GOTO OUTERR;/* GO SET COMMON ERROR    01S0143
*                                      INDICATORS & RETURN           */
         B     OUTERR                                           01S0143
*                       END;        /* END OF SEGMENT                */
*                     ELSE                                      01S0145
*                       ;           /* NULL - NO MIF PROBLEMS        */
@RF00138 DS    0H                                               01S0146
*               END;                /* END XARRV PROCESSING          */
*           ELSE                    /* NO - CHECK FOR EXCESS PARMS   */
*             IF PSIGNBIT=OFF THEN  /* SEE IF YARRV LAST             */
         B     @RC00124                                         01S0147
@RF00124 TM    PSIGNBIT+16(INPUTPTR),B'10000000'                01S0147
         BNZ   @RF00147                                         01S0147
*               ERRORBIT=ON;        /* NO - FLAG ERROR               */
         OI    ERRORBIT,B'10000000'                             01S0148
*           RFY                                                 01S0149
*             PARMSIGN BASED(ADDR(APINAXST));                   01S0149
@RF00147 DS    0H                                               01S0149
@RC00124 DS    0H                                               01S0150
*           IF NUMVECS=3 THEN       /* DOES IT HAVE A U VECTOR?      */
         C     NUMVECS,@CF00156                                 01S0150
         BNE   @RF00150                                         01S0150
*             IF PSIGNBIT=ON THEN   /* YES - MORE PARMS?             */
         TM    PSIGNBIT+20(INPUTPTR),B'10000000'                01S0151
         BNO   @RF00151                                         01S0151
*               ERRORBIT=ON;        /* NO - FLAG ERROR               */
         OI    ERRORBIT,B'10000000'                             01S0152
*             ELSE                                              01S0153
*               DO;                                             01S0153
         B     @RC00151                                         01S0153
@RF00151 DS    0H                                               01S0154
*                 RFY                                           01S0154
*                   PARMSIGN BASED(ADDR(APINAUST));             01S0154
*                 IF PSIGNBIT=ON THEN/* TEST IF UARRV LAST PARM      */
         TM    PSIGNBIT+24(INPUTPTR),B'10000000'                01S0155
         BNO   @RF00155                                         01S0155
*                   DO;             /* PROCESS YARRV ADDRESS         */
*                     UARRV=APINAUST;/* YES - GET USER'S UARRV       */
         L     @04,APINAUST(,INPUTPTR)                          01S0157
         ST    @04,UARRV(,DESCRPTR)                             01S0157
*                     CALL APCVZMIF(UARRV,RSOLVERR);/* RESOLVE UARRV */
         LA    @04,UARRV(,DESCRPTR)                             01S0158
         ST    @04,@AL00001                                     01S0158
         LA    @04,RSOLVERR                                     01S0158
         ST    @04,@AL00001+4                                   01S0158
         L     @15,APCTZMIF(,APCTPTR)                           01S0158
         LA    @01,@AL00001                                     01S0158
         BALR  @14,@15                                          01S0158
*                     IF RSOLVERR^=0 THEN/* TEST ERROR RETURN WORD   */
         L     @04,RSOLVERR                                     01S0159
         LTR   @04,@04                                          01S0159
         BZ    @RF00159                                         01S0159
*                       IF RSOLVERR=BDYERROR THEN/* BOUNDARY ERROR?  */
         C     @04,@CF00045                                     01S0160
         BNE   @RF00160                                         01S0160
*                         DO;       /* YES - SET ERROR INDICATORS FOR
*                                      UARRV NOT A WOR BOUNDARY      */
*                           APCWRCN=APCCA017;/* ERROR NUMBER UARRV
*                                      NOT A WORD BOUNDARY           */
         MVI   APCWRCN(APCWPTR),X'11'                           01S0162
*                           APEMMSGN=APCMA017;/* MESSAGE NUMBER FOR
*                                      NOT A WORD BOUNDARY           */
         LA    @09,112                                          01S0163
         ALR   @09,APCWPTR                                      01S0163
         MVC   APEMMSGN(4,@09),@CF00485                         01S0163
*                           APEMVALN=APCMK031;/* UARRV KWD NBR       */
         MVC   APEMVALN(4,@09),@CF00041                         01S0164
*                           GOTO OUTERR;/* GO SET COMMON ERROR  01S0165
*                                      INDICATORS & RETURN           */
         B     OUTERR                                           01S0165
*                         END;      /* END OF SEGMENT                */
*                       ELSE        /* TEST FOR RANGE ERROR          */
*                         IF RSOLVERR=RNGERROR THEN/* RANGE ERROR?   */
@RF00160 CLC   RSOLVERR(4),@CF00130                             01S0167
         BNE   @RF00167                                         01S0167
*                           DO;     /* YES - SET ERROR INDICATOR FOR
*                                      UARRV OUT OF RANGE            */
*                             APCWRCN=APCCA022;/* ERROR NUMBER FOR
*                                      UARRV OUT OF RANGE            */
         MVI   APCWRCN(APCWPTR),X'16'                           01S0169
*                             APEMMSGN=APCMA022;/* MESSAGE NUMBER OUT
*                                      OF RANGE                      */
         LA    @09,112                                          01S0170
         ALR   @09,APCWPTR                                      01S0170
         MVC   APEMMSGN(4,@09),@CF00156                         01S0170
*                             APEMVALN=APCMK031;/* UARRV KWD NUMBER  */
         MVC   APEMVALN(4,@09),@CF00041                         01S0171
*                             GOTO OUTERR;/* GO SET COMMON ERROR
*                                      INDICATORS & RETURN           */
         B     OUTERR                                           01S0172
*                           END;    /* END OF SEGMENT                */
*                         ELSE                                  01S0174
*                           ;       /* NULL - NO MIF PROBLEMS        */
@RF00167 DS    0H                                               01S0175
*                   END;            /* END UARRV PROCESSING          */
*                 ELSE              /* NOT LAST - ERROR              */
*                   ERRORBIT=ON;    /* FLAG IT                       */
         B     @RC00155                                         01S0176
@RF00155 OI    ERRORBIT,B'10000000'                             01S0176
*               END;                                            01S0177
*           ELSE                    /* TWO VECTOR OP                 */
*             DO;                   /* MAKE SURE USER THINKS SO      */
         B     @RC00150                                         01S0178
@RF00150 DS    0H                                               01S0179
*               RFY                                             01S0179
*                 PARMSIGN BASED(ADDR(APINAXST));/* GET XARRV SIGN   */
*               IF(PSIGNBIT=OFF)&(NUMVECS^=1) THEN/* ENSURE X LAST
*                                      FOR 2 VEC OP                  */
         TM    PSIGNBIT+20(INPUTPTR),B'10000000'                01S0180
         BNZ   @RF00180                                         01S0180
         C     NUMVECS,@CF00045                                 01S0180
         BE    @RF00180                                         01S0180
*                 ERRORBIT=ON;      /* NO - FLAG ERROR               */
         OI    ERRORBIT,B'10000000'                             01S0181
*               ELSE                                            01S0182
*                 ;                 /* XARRV PROPERLY LAST PARM      */
@RF00180 DS    0H                                               01S0183
*             END;                                              01S0183
*         END;                                                  01S0184
*       ELSE                        /* COMPLETE DESC                 */
*         DO;                                                   01S0185
         B     @RC00099                                         01S0185
@RF00099 DS    0H                                               01S0186
*           RFY                                                 01S0186
*             PARMSIGN BASED(ADDR(APINADSV));                   01S0186
*           IF PSIGNBIT=OFF THEN    /* TEST IF DSC VEC LAST          */
         TM    PSIGNBIT+12(INPUTPTR),B'10000000'                01S0187
         BNZ   @RF00187                                         01S0187
*             ERRORBIT=ON;          /* NO - FLAG ERROR               */
         OI    ERRORBIT,B'10000000'                             01S0188
*         END;                                                  01S0189
@RF00187 DS    0H                                               01S0190
*       IF ERRORBIT=ON THEN         /* TEST IF ERROR DETECTED SO FAR */
@RC00099 TM    ERRORBIT,B'10000000'                             01S0190
         BNO   @RF00190                                         01S0190
*         DO;                       /* YES - SET ERROR INDICATORS    */
*           APCWZAM=ON;             /* INDICATE ERROR DETECTED       */
         OI    APCWZAM(APCWPTR),B'00000001'                     01S0192
*           APCWR15C=APCCRERR;      /* SET R15 RET CODE              */
         MVC   APCWR15C(4,APCWPTR),@CF00145                     01S0193
*           APCWRCT=APCCTLOG;       /* SET ERROR TYPE TO LOGICAL     */
         MVI   APCWRCT(APCWPTR),X'08'                           01S0194
*           APCWRCC=APCCA;          /* SET COMPONENT ID              */
         MVI   APCWRCC(APCWPTR),X'01'                           01S0195
*           APCWRCN=APCCA002;       /* SET ERROR NUMBER              */
         MVI   APCWRCN(APCWPTR),X'02'                           01S0196
*           APEMMSGN=APCMA002;      /* SET MSG NO FOR INVLD NO PARMS */
         MVC   APEMMSGN+112(4,APCWPTR),@CF00166                 01S0197
*           RETURN;                 /* RETURN TO CALLER              */
         B     @EL00001                                         01S0198
*         END;                                                  01S0199
*       ELSE                                                    01S0200
*         ;                                                     01S0200
@RF00190 DS    0H                                               01S0201
*     END;                                                      01S0201
*   ELSE                                                        01S0202
*                                                               01S0202
*     /***************************************************************/
*     /*                                                             */
*     /* FORMAT CALL PARAMETERS INTO DESCRIPTOR FORMAT               */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0202
*     DO;                                                       01S0202
         B     @RC00095                                         01S0202
@RF00095 DS    0H                                               01S0203
*       DESCRPTR=ADDR(DESCRWRK);    /* POINT TO WORK AREA            */
         LA    DESCRPTR,DESCRWRK                                01S0203
*                                                               02S0204
*/********************************************************************/
*/*                                                                  */
*/*       THE FOLLOWING LOCAL INCLUDE BUILDS A DESCRIPTOR            */
*/*       VECTOR FROM A USER INPUT PARAMETER LIST.                   */
*/*       VARIABLES ARE INPUT VIA A USER PARAMETER LIST IN THE       */
*/*       FOLLOWING FORMAT:                                          */
*/*                                                                  */
*/*       CALL VPSS (IUNIT,IFUNC,ISTATE,                             */
*/*                  IFMY,YARRV,ICTY,IDLY,YARRVX,ICTYX,IDLYX,        */
*/*                  IFMX,XARRV,ICTX,IDLX,XARRVX,ICTXX,IDLXX,        */
*/*                  IFMU,UARRV,ICTU,IDLU,UARRVX,ICTUX,IDLUX)        */
*/*                                                                  */
*/*                WHERE:                                            */
*/*                                                                  */
*/*                  IUNIT  UNIT REFERENCE NUMBER                    */
*/*                  IFUNC  ALGORITHM MNEMONIC                       */
*/*                  ISTATE OPERATIONAL PARAMETERS                   */
*/*                  IFMY   Y VECTOR FORMAT DESCRIPTION              */
*/*                  YARRV  Y VECTOR 3838 STARTING LOCATION          */
*/*                  ICTY   LENGTH OF Y VECTOR                       */
*/*                  IDLY   Y VECTOR ELEMENT SPACING                 */
*/*                  YARRVX Y VECTOR START INDEX                     */
*/*                  ICTYX  Y VECTOR COUNT INDEX                     */
*/*                  IDLYX  Y VECTOR SPACING INDEX                   */
*/*                  IFMX   X VECTOR FORMAT DESCRIPTION              */
*/*                  XARRV  X VECTOR 3838 STARTING LOCATION          */
*/*                  ICTX   LENGTH OF X VECTOR                       */
*/*                  IDLX   X VECTOR ELEMENT SPACING                 */
*/*                  XARRVX X VECTOR START INDEX                     */
*/*                  ICTXX  X VECTOR COUNT INDEX                     */
*/*                  IDLXX  X VECTOR SPACING INDEX                   */
*/*                  IFMU   U VECTOR FORMAT DESCRIPTION              */
*/*                  UARRV  U VECTOR 3838 STARTING LOCATION          */
*/*                  ICTU   LENGTH OF U VECTOR                       */
*/*                  IDLU   U VECTOR ELEMENT SPACING                 */
*/*                  UARRVX U VECTOR START INDEX                     */
*/*                  ICTUX  U VECTOR COUNT INDEX                     */
*/*                  IDLUX  U VECTOR SPACING INDEX                   */
*/*                                                                  */
*/*       ALL PARAMETERS ARE NOT NECESSARILY INPUT ON ALL            */
*/*       ALGORITHM CALLS. ONLY THOSE REQUIRED OR OPTIONAL MAY       */
*/*       BE INPUT. RESTRICTIONS ON PARAMETERS FOR ALGORITHM         */
*/*       CALLS ARE DESCRIBED IN THE VPSS FINAL PROGRAMMING          */
*/*       FUNCTIONAL SPECIFICATION. SWITCHES IN IGTXAPAL             */
*/*       ARE USED BY THIS PROGRAM TO DETERMINE WHICH PARA-          */
*/*       METERS ARE ALLOWED FOR A PARTICULAR ALGORITHM CALL.        */
*/*       IF A PARAMETER IS OPTIONAL AND OMITTED, NO FURTHER         */
*/*       PARAMETERS ARE ALLOWED. IF REQUIRED IT MUST BE             */
*/*       PRESENT. IF DISALLOWED, IT IS EITHER UNUSED OR A           */
*/*       DEFAULT VALUE WILL BE SUPPLIED. INDEXES ARE PER-           */
*/*       MITTED ONLY WHEN OPTIONAL AND ITS USE IS REQUESTED         */
*/*       BY SETTING THE APPROPRIATE BIT IN THE VECTOR FORMAT        */
*/*       DESCRIPTION.                                               */
*/*       THIS PROGRAM INSPECTS THE PARAMETER LIST USING APAL        */
*/*       SWITCH SETTINGS TO DETERMINE WHAT EACH PARAMETER           */
*/*       REPRESENTS, PERFORMS VALIDITY CHECKING WHERE               */
*/*       POSSIBLE, SUPPLIES DEFAULTS AND MOVES THE PARAMETERS       */
*/*       INTO THE PROPER SLOTS OF A DESCRIPTOR VECTOR WORK          */
*/*       AREA. THE DESCRIPTOR VECTOR IS THEN CONVERTED INTO A       */
*/*       CIT ENTRY BY THE LOCAL INCLUDE MDACIT.                     */
*/*       AS THE PARAMETER LIST IS INSPECTED, THE HIGH ORDER         */
*/*       BIT OF EACH PARAMETER IS INSPECTED TO DETERMINE IF IT      */
*/*       IS THE LAST ONE. IF IT IS THE LAST, THE LAST               */
*/*       PARAMETER FLAG (LASTPARM) IS SET AND APAL IS THEN          */
*/*       USED TO DETERMINE IF ANY REQUIRED PARAMETERS HAVE          */
*/*       OMITTED.                                                   */
*/*                                                                  */
*/********************************************************************/
*                                                               02S0204
*       RFY                                                     02S0204
*         PARAM1 BASED(APINAP1);    /* GAIN ACCESS TO NEXT TWO PARMS */
*       RFY                                                     02S0205
*         PARAM2 BASED(APINAP2);                                02S0205
*       INPUTPTR=INPUTPTR+12;       /* BUMP NEXT PARAMETER POINTER   */
         AL    INPUTPTR,@CF00147                                02S0206
*       LASTPARM=OFF;               /* LAST PARM FLAG INITIALLY OFF  */
*                                                               02S0207
         NI    LASTPARM,B'01111111'                             02S0207
*       /*************************************************************/
*       /*                                                           */
*       /* BUILD Y VECTOR DESCRIPTOR COMPONENTS                      */
*       /*                                                           */
*       /*************************************************************/
*                                                               02S0208
*       IF APINAP1E=OFF THEN        /* TEST IF IFMY IS LAST PARM     */
         TM    APINAP1E(INPUTPTR),B'10000000'                   02S0208
         BNZ   @RF00208                                         02S0208
*         DO;                       /* IFMY NOT LAST                 */
*           IFMY=PARAM1;            /* SET Y VECTOR FORMAT           */
         L     @04,APINAP1(,INPUTPTR)                           02S0210
         L     @04,PARAM1(,@04)                                 02S0210
         ST    @04,IFMY(,DESCRPTR)                              02S0210
*           YARRV=APINAP2;          /* SET Y VECTOR BULK STORE ADDR  */
         L     @04,APINAP2(,INPUTPTR)                           02S0211
         ST    @04,YARRV(,DESCRPTR)                             02S0211
*           CALL APCVZMIF(YARRV,RSOLVERR);/* RESOLVE ADDRESS         */
         LA    @04,YARRV(,DESCRPTR)                             02S0212
         ST    @04,@AL00001                                     02S0212
         LA    @04,RSOLVERR                                     02S0212
         ST    @04,@AL00001+4                                   02S0212
         L     @15,APCTZMIF(,APCTPTR)                           02S0212
         LA    @01,@AL00001                                     02S0212
         BALR  @14,@15                                          02S0212
*           IF RSOLVERR^=0 THEN     /* ADDRESS OK?                   */
         L     @04,RSOLVERR                                     02S0213
         LTR   @04,@04                                          02S0213
         BZ    @RF00213                                         02S0213
*             IF RSOLVERR=BDYERROR THEN/* IF ERROR WAS WORD BDY 02S0214
*                                      PROBLEM                       */
         C     @04,@CF00045                                     02S0214
         BNE   @RF00214                                         02S0214
*               DO;                 /* SET ERROR INDICATORS FOR YARRV
*                                      NOT A WORD BOUNDARY           */
*                 APCWRCN=APCCA015; /* ERROR NUMBER FOR YARRV NOT A
*                                      WORD BOUNDARY                 */
         MVI   APCWRCN(APCWPTR),X'0F'                           02S0216
*                 APEMMSGN=APCMA015;/* MSG NUMBER FOR YARRV NOT A
*                                      WORD BOUNDARY                 */
         LA    @09,112                                          02S0217
         ALR   @09,APCWPTR                                      02S0217
         MVC   APEMMSGN(4,@09),@CF00485                         02S0217
*                 APEMVALN=APCMK017;/* KEYWORD NUMBER FOR YARRV      */
         MVC   APEMVALN(4,@09),@CF00180                         02S0218
*                 GOTO OUTERR;      /* GO SET COMMON FLAGS & RETURN  */
         B     OUTERR                                           02S0219
*               END;                /* END OF SEGMENT                */
*             ELSE                  /* CHECK FOR RANGE ERROR         */
*               IF RSOLVERR=RNGERROR THEN/* IF RANGE ERROR           */
@RF00214 CLC   RSOLVERR(4),@CF00130                             02S0221
         BNE   @RF00221                                         02S0221
*                 DO;               /* SET ERROR INDICATORS FOR YARRV
*                                      OUT OF RANGE                  */
*                   APCWRCN=APCCA020;/* ERROR NUMBER FOR YARRV OUT OF
*                                      RANGE                         */
         MVI   APCWRCN(APCWPTR),X'14'                           02S0223
*                   APEMMSGN=APCMA020;/* MSG NUMBER FOR OUT OF RANGE */
         LA    @09,112                                          02S0224
         ALR   @09,APCWPTR                                      02S0224
         MVC   APEMMSGN(4,@09),@CF00156                         02S0224
*                   APEMVALN=APCMK017;/* KEYWORD NUMBER FOR YARRV    */
         MVC   APEMVALN(4,@09),@CF00180                         02S0225
*                   GOTO OUTERR;    /* GO SET COMMON FLAGS & RETURN  */
         B     OUTERR                                           02S0226
*                 END;              /* END OF SEGMENT                */
*               ELSE                                            02S0228
*                 ;                 /* NULL - NO MIF PROBLEMS        */
@RF00221 DS    0H                                               02S0229
*           ELSE                                                02S0229
*             ;                     /* YARRV OK - NO ACTION          */
@RF00213 DS    0H                                               02S0230
*           IF APINAP2E=ON THEN     /* IF YARRV IS LAST PARM -       */
         TM    APINAP2E(INPUTPTR),B'10000000'                   02S0230
         BNO   @RF00230                                         02S0230
*             LASTPARM=ON;          /* SET LAST PARM FLAG ON         */
         OI    LASTPARM,B'10000000'                             02S0231
*           ELSE                    /* YARRV NOT LAST                */
*             INPUTPTR=INPUTPTR+8;  /* POINT TO NEXT PARAMETER       */
         B     @RC00230                                         02S0232
@RF00230 AL    INPUTPTR,@CF00145                                02S0232
*         END;                                                  02S0233
*       ELSE                        /* ERROR - IFMY,YARRV REQD ALWAYS*/
*         GOTO OUTERR1;             /* GO SET ERR INDICATORS         */
*       IF APALYCRQ=ON THEN         /* TEST IF ICTY REQD             */
@RC00208 L     @04,APCWAPAL(,APCWPTR)                           02S0235
         TM    APALYCRQ(@04),B'10000000'                        02S0235
         BNO   @RF00235                                         02S0235
*         IF LASTPARM=OFF THEN      /* IF MORE PARAMETERS EXIST      */
         TM    LASTPARM,B'10000000'                             02S0236
         BNZ   @RF00236                                         02S0236
*           DO;                                                 02S0237
*             ICTY=PARAM1;          /* SET ICTY VALUE                */
         L     @04,APINAP1(,INPUTPTR)                           02S0238
         L     @04,PARAM1(,@04)                                 02S0238
         ST    @04,ICTY(,DESCRPTR)                              02S0238
*             IF APINAP1E=ON THEN   /* SET LAST PARM FLAG IF ICTY
*                                      LAST                          */
         TM    APINAP1E(INPUTPTR),B'10000000'                   02S0239
         BNO   @RF00239                                         02S0239
*               LASTPARM=ON;                                    02S0240
         OI    LASTPARM,B'10000000'                             02S0240
*             ELSE                                              02S0241
*               INPUTPTR=INPUTPTR+4;/* POINT TO NEXT PARAMETER       */
         B     @RC00239                                         02S0241
@RF00239 AL    INPUTPTR,@CF00142                                02S0241
*           END;                                                02S0242
*         ELSE                      /* ERROR - ICTY REQD & NOT INPUT */
*           GOTO OUTERR1;           /* GO SET ERROR INDICATORS       */
*       ELSE                        /* ICTY NOT REQUIRED             */
*         IF APALYCOP=ON THEN       /* TEST IF ICTY OPTIONAL         */
         B     @RC00235                                         02S0244
@RF00235 L     @04,APCWAPAL(,APCWPTR)                           02S0244
         TM    APALYCOP(@04),B'01000000'                        02S0244
         BNO   @RF00244                                         02S0244
*           IF LASTPARM=ON THEN     /* OPTIONAL- ARE THERE MORE PARMS*/
         TM    LASTPARM,B'10000000'                             02S0245
         BNO   @RF00245                                         02S0245
*             IF APALYCSD=ON THEN   /* NO - TEST IF VPSS- SUPPLIED   */
         TM    APALYCSD(@04),B'00000001'                        02S0246
         BNO   @RF00246                                         02S0246
*               ICTY=APALYCNT;      /* YES - SUPPLY ICTY VALUE       */
         LH    @04,APALYCNT(,@04)                               02S0247
         ST    @04,ICTY(,DESCRPTR)                              02S0247
*             ELSE                                              02S0248
*               ICTY=1;             /* NO - ICTY = 1                 */
         B     @RC00246                                         02S0248
@RF00246 MVC   ICTY(4,DESCRPTR),@CF00045                        02S0248
*           ELSE                    /* YES - USE NEXT PARAMETER      */
*             DO;                                               02S0249
         B     @RC00245                                         02S0249
@RF00245 DS    0H                                               02S0250
*               ICTY=PARAM1;        /* SET USER SUPPLIED ICTY        */
         L     @04,APINAP1(,INPUTPTR)                           02S0250
         L     @04,PARAM1(,@04)                                 02S0250
         ST    @04,ICTY(,DESCRPTR)                              02S0250
*               IF APINAP1E=ON THEN /* IF ICTY IS LAST INPUT    02S0251
*                                      PARAMETER                     */
         TM    APINAP1E(INPUTPTR),B'10000000'                   02S0251
         BNO   @RF00251                                         02S0251
*                 LASTPARM=ON;      /* TURN ON THE LAST PARM FLAG    */
         OI    LASTPARM,B'10000000'                             02S0252
*               ELSE                                            02S0253
*                 INPUTPTR=INPUTPTR+4;/* POINT TO NEXT PARAMETER     */
         B     @RC00251                                         02S0253
@RF00251 AL    INPUTPTR,@CF00142                                02S0253
*             END;                                              02S0254
*         ELSE                      /* NOT OPT - VPSS SUPPLIES ICTY  */
*           IF APALYCSD=ON THEN     /* SUPPLY ICTY VALUE FROM APAL   */
         B     @RC00244                                         02S0255
@RF00244 L     @04,APCWAPAL(,APCWPTR)                           02S0255
         TM    APALYCSD(@04),B'00000001'                        02S0255
         BNO   @RF00255                                         02S0255
*             ICTY=APALYCT;         /* IF IT EXISTS                  */
         SLR   @15,@15                                          02S0256
         IC    @15,APALYCT(,@04)                                02S0256
         ST    @15,ICTY(,DESCRPTR)                              02S0256
*           ELSE                                                02S0257
*             ICTY=1;               /* OTHERWISE SUPPLY VALUE OF 1   */
         B     @RC00255                                         02S0257
@RF00255 MVC   ICTY(4,DESCRPTR),@CF00045                        02S0257
*       IF APALYDRQ=ON THEN         /* SEE IF IDLY REQUIRED          */
@RC00255 DS    0H                                               02S0258
@RC00244 DS    0H                                               02S0258
@RC00235 L     @04,APCWAPAL(,APCWPTR)                           02S0258
         TM    APALYDRQ(@04),B'10000000'                        02S0258
         BNO   @RF00258                                         02S0258
*         IF LASTPARM=OFF THEN      /* CHECK IF MORE PARMS EXIST     */
         TM    LASTPARM,B'10000000'                             02S0259
         BNZ   @RF00259                                         02S0259
*           DO;                                                 02S0260
*             IDLY=PARAM1;          /* IF SO, GET USER IDLY VALUE    */
         L     @04,APINAP1(,INPUTPTR)                           02S0261
         L     @04,PARAM1(,@04)                                 02S0261
         ST    @04,IDLY(,DESCRPTR)                              02S0261
*             IF APINAP1E=ON THEN   /* IF IDLY LAST TURN ON LAST     */
         TM    APINAP1E(INPUTPTR),B'10000000'                   02S0262
         BNO   @RF00262                                         02S0262
*               LASTPARM=ON;        /* PARM FLAG                     */
         OI    LASTPARM,B'10000000'                             02S0263
*             ELSE                                              02S0264
*               INPUTPTR=INPUTPTR+4;/* POINT TO NEXT PARAMETER       */
         B     @RC00262                                         02S0264
@RF00262 AL    INPUTPTR,@CF00142                                02S0264
*           END;                                                02S0265
*         ELSE                      /* ERROR - IDLY REQD BUT NOT
*                                      INPUT                         */
*           GOTO OUTERR1;           /* GO SET ERROR INDICATORS       */
*       ELSE                        /* IDLY NOT REQUIRED             */
*         IF APALYDOP=ON THEN       /* SEE IF IDLY OPTIONAL          */
         B     @RC00258                                         02S0267
@RF00258 L     @04,APCWAPAL(,APCWPTR)                           02S0267
         TM    APALYDOP(@04),B'01000000'                        02S0267
         BNO   @RF00267                                         02S0267
*           IF LASTPARM=ON THEN     /* IF NO MORE PARAMETERS         */
         TM    LASTPARM,B'10000000'                             02S0268
         BNO   @RF00268                                         02S0268
*             IDLY=1;               /* SET ELEMENT SPACING TO ONE    */
         MVC   IDLY(4,DESCRPTR),@CF00045                        02S0269
*           ELSE                                                02S0270
*             DO;                                               02S0270
         B     @RC00268                                         02S0270
@RF00268 DS    0H                                               02S0271
*               IDLY=PARAM1;        /* GET USER SUPPLIED IDLY VALUE  */
         L     @04,APINAP1(,INPUTPTR)                           02S0271
         L     @04,PARAM1(,@04)                                 02S0271
         ST    @04,IDLY(,DESCRPTR)                              02S0271
*               IF APINAP1E=ON THEN /* IF IDLY LAST, TURN ON LAST    */
         TM    APINAP1E(INPUTPTR),B'10000000'                   02S0272
         BNO   @RF00272                                         02S0272
*                 LASTPARM=ON;      /* PARM FLAG                     */
         OI    LASTPARM,B'10000000'                             02S0273
*               ELSE                                            02S0274
*                 INPUTPTR=INPUTPTR+4;/* POINT TO NEXT PARAMETER     */
         B     @RC00272                                         02S0274
@RF00272 AL    INPUTPTR,@CF00142                                02S0274
*             END;                                              02S0275
*         ELSE                      /* IDLY NOT REQD OR OPTIONAL     */
*           IDLY=1;                 /* IDLY ALWAYS 1 FOR THIS OP     */
         B     @RC00267                                         02S0276
@RF00267 MVC   IDLY(4,DESCRPTR),@CF00045                        02S0276
*       IF YSTARTDX=ON THEN         /* TEST IF USE OF START INDEX
*                                      SPECIFIED IN IFMY             */
@RC00267 DS    0H                                               02S0277
@RC00258 TM    YSTARTDX(DESCRPTR),B'00100000'                   02S0277
         BNO   @RF00277                                         02S0277
*         IF LASTPARM=OFF THEN      /* YES - SEE IF MORE PARMS EXIST */
         TM    LASTPARM,B'10000000'                             02S0278
         BNZ   @RF00278                                         02S0278
*           DO;                                                 02S0279
*             YARRVX=PARAM1;        /* YES - GET USER SUPPLIED YARRVX*/
         L     @04,APINAP1(,INPUTPTR)                           02S0280
         L     @04,PARAM1(,@04)                                 02S0280
         ST    @04,YARRVX(,DESCRPTR)                            02S0280
*             IF APINAP1E=ON THEN   /* IF YARRVX LAST PARAMETER      */
         TM    APINAP1E(INPUTPTR),B'10000000'                   02S0281
         BNO   @RF00281                                         02S0281
*               LASTPARM=ON;        /* TURN ON LAST PARM FLAG        */
         OI    LASTPARM,B'10000000'                             02S0282
*             ELSE                                              02S0283
*               INPUTPTR=INPUTPTR+4;/* POINT TO NEXT PARAMETER       */
         B     @RC00281                                         02S0283
@RF00281 AL    INPUTPTR,@CF00142                                02S0283
*           END;                                                02S0284
*         ELSE                      /* ERROR - YARRVX SPECIFIED & NOT
*                                      INPUT                         */
*           GOTO OUTERR1;           /* GO SET ERROR INDICATORS       */
*       ELSE                                                    02S0286
*         ;                                                     02S0286
@RF00277 DS    0H                                               02S0287
*       IF YCOUNTDX=ON THEN         /* TEST IF USE OF COUNT INDEX
*                                      SPECIFIED IN IFMY             */
@RC00277 TM    YCOUNTDX(DESCRPTR),B'01000000'                   02S0287
         BNO   @RF00287                                         02S0287
*         IF LASTPARM=OFF THEN      /* YES - SEE IF MORE PARMS EXIST */
         TM    LASTPARM,B'10000000'                             02S0288
         BNZ   @RF00288                                         02S0288
*           DO;                                                 02S0289
*             ICTYX=PARAM1;         /* YES - GET USER SUPPLIED ICTYX */
         L     @04,APINAP1(,INPUTPTR)                           02S0290
         L     @04,PARAM1(,@04)                                 02S0290
         ST    @04,ICTYX(,DESCRPTR)                             02S0290
*             IF APINAP1E=ON THEN   /* IF ICTYX IS LAST PARAMETER    */
         TM    APINAP1E(INPUTPTR),B'10000000'                   02S0291
         BNO   @RF00291                                         02S0291
*               LASTPARM=ON;        /* TURN ON LAST PARM FLAG        */
         OI    LASTPARM,B'10000000'                             02S0292
*             ELSE                                              02S0293
*               INPUTPTR=INPUTPTR+4;/* POINT TO NEXT PARAMETER       */
         B     @RC00291                                         02S0293
@RF00291 AL    INPUTPTR,@CF00142                                02S0293
*           END;                                                02S0294
*         ELSE                      /* ERROR - ICTYX SPECIFIED & NOT
*                                      INPUT                         */
*           GOTO OUTERR1;           /* GO SET ERROR INDICATORS       */
*       ELSE                                                    02S0296
*         ;                                                     02S0296
@RF00287 DS    0H                                               02S0297
*       IF YDELTADX=ON THEN         /* SEE IF USE OF DELTA INDEX
*                                      SPECIFIED IN IFMY             */
@RC00287 TM    YDELTADX(DESCRPTR),B'10000000'                   02S0297
         BNO   @RF00297                                         02S0297
*         IF LASTPARM=OFF THEN      /* TEST IF MORE PARAMETERS EXIST */
         TM    LASTPARM,B'10000000'                             02S0298
         BNZ   @RF00298                                         02S0298
*           DO;                                                 02S0299
*             IDLYX=PARAM1;         /* YES - GET USER SUPPLIED IDLYX */
         L     @04,APINAP1(,INPUTPTR)                           02S0300
         L     @04,PARAM1(,@04)                                 02S0300
         ST    @04,IDLYX(,DESCRPTR)                             02S0300
*             IF APINAP1E=ON THEN   /* IF IDLYX IS LAST PARAMETER    */
         TM    APINAP1E(INPUTPTR),B'10000000'                   02S0301
         BNO   @RF00301                                         02S0301
*               LASTPARM=ON;        /* TURN ON LAST PARM FLAG        */
         OI    LASTPARM,B'10000000'                             02S0302
*             ELSE                                              02S0303
*               INPUTPTR=INPUTPTR+4;/* POINT TO NEXT PARAMETER       */
         B     @RC00301                                         02S0303
@RF00301 AL    INPUTPTR,@CF00142                                02S0303
*           END;                                                02S0304
*         ELSE                      /* ERROR - IDLYX SPECIFIED & NOT
*                                      INPUT                         */
*           GO TO OUTERR1;          /* GO SET ERROR INDICATORS       */
*       ELSE                                                    02S0306
*         ;                                                     02S0306
@RF00297 DS    0H                                               02S0307
*       IF NUMVECS>=2 THEN          /* IF MORE VECTORS TO PROCESS    */
*                                                               02S0307
@RC00297 C     NUMVECS,@CF00130                                 02S0307
         BL    @RF00307                                         02S0307
*         /***********************************************************/
*         /*                                                         */
*         /* PROCESS X VECTOR COMPONENTS                             */
*         /*                                                         */
*         /***********************************************************/
*                                                               02S0308
*         DO;                                                   02S0308
*           IFMXIFMY=OFF;           /* CLEAR FLAG                    */
         NI    IFMXIFMY,B'01111111'                             02S0309
*           IF APALXVRQ=ON THEN     /* TEST IF X VECTOR START REQD   */
         L     @04,APCWAPAL(,APCWPTR)                           02S0310
         TM    APALXVRQ(@04),B'10000000'                        02S0310
         BNO   @RF00310                                         02S0310
*             IF(LASTPARM=OFF)&(APINAP1E=OFF) THEN/* IF MORE PARMS
*                                      AND IFMX NOT LAST             */
         TM    LASTPARM,B'10000000'                             02S0311
         BNZ   @RF00311                                         02S0311
         TM    APINAP1E(INPUTPTR),B'10000000'                   02S0311
         BNZ   @RF00311                                         02S0311
*               DO;                                             02S0312
*                 IFMX=PARAM1;      /* GET USERS IFMX AND XARRV      */
         L     @04,APINAP1(,INPUTPTR)                           02S0313
         L     @04,PARAM1(,@04)                                 02S0313
         ST    @04,IFMX(,DESCRPTR)                              02S0313
*                 XARRV=APINAP2;    /* GET PTR FOR XARRV             */
         L     @04,APINAP2(,INPUTPTR)                           02S0314
         ST    @04,XARRV(,DESCRPTR)                             02S0314
*                 CALL APCVZMIF(XARRV,RSOLVERR);/* RESOLVE XARRV     */
         LA    @04,XARRV(,DESCRPTR)                             02S0315
         ST    @04,@AL00001                                     02S0315
         LA    @04,RSOLVERR                                     02S0315
         ST    @04,@AL00001+4                                   02S0315
         L     @15,APCTZMIF(,APCTPTR)                           02S0315
         LA    @01,@AL00001                                     02S0315
         BALR  @14,@15                                          02S0315
*                 IF RSOLVERR^=0 THEN/* TEST ERROR RETURN WORD       */
         L     @04,RSOLVERR                                     02S0316
         LTR   @04,@04                                          02S0316
         BZ    @RF00316                                         02S0316
*                   IF RSOLVERR=BDYERROR THEN/* WAS ERROR BOUNDARY?  */
         C     @04,@CF00045                                     02S0317
         BNE   @RF00317                                         02S0317
*                     DO;           /* YES - SET ERROR INDICATORS FOR
*                                      XARRV NOT A WORD BOUNDARY     */
*                       APCWRCN=APCCA016;/* ERROR NUMBER FOR XARRV
*                                      NOT A WORD BOUNDARY           */
         MVI   APCWRCN(APCWPTR),X'10'                           02S0319
*                       APEMMSGN=APCMA016;/* MESSAGE NUMBER FOR NOT A
*                                      WORD BOUNDARY                 */
         LA    @09,112                                          02S0320
         ALR   @09,APCWPTR                                      02S0320
         MVC   APEMMSGN(4,@09),@CF00485                         02S0320
*                       APEMVALN=APCMK024;/* KEYWORD NUMBER FOR XARRV*/
         MVC   APEMVALN(4,@09),@CF00061                         02S0321
*                       GOTO OUTERR;/* GO SET COMMON ERROR INDICATORS
*                                      AND RETURN                    */
         B     OUTERR                                           02S0322
*                     END;          /* END OF SEGMENT                */
*                   ELSE            /* TEST FOR RANGE ERROR          */
*                     IF RSOLVERR=RNGERROR THEN/* WAS ERROR RANGE?   */
@RF00317 CLC   RSOLVERR(4),@CF00130                             02S0324
         BNE   @RF00324                                         02S0324
*                       DO;         /* YES - SET ERROR INDICATORS FOR
*                                      XARRV OUT OF RANGE            */
*                         APCWRCN=APCCA021;/* ERROR NUMBER FOR XARRV
*                                      OUT OF RANGE                  */
         MVI   APCWRCN(APCWPTR),X'15'                           02S0326
*                         APEMMSGN=APCMA021;/* MESSAGE NUMBER FOR OUT
*                                      OF RANGE                      */
         LA    @09,112                                          02S0327
         ALR   @09,APCWPTR                                      02S0327
         MVC   APEMMSGN(4,@09),@CF00156                         02S0327
*                         APEMVALN=APCMK024;/* KEYWORD NUMBER FOR
*                                      XARRV                         */
         MVC   APEMVALN(4,@09),@CF00061                         02S0328
*                         GOTO OUTERR;/* GO SET COMMON ERROR    02S0329
*                                      INDICATORS AND RETURN         */
         B     OUTERR                                           02S0329
*                       END;        /* END OF SEGMENT                */
*                     ELSE                                      02S0331
*                       ;           /* NULL - NO MIF PROBLEMS        */
@RF00324 DS    0H                                               02S0332
*                 IF APINAP2E=ON THEN/* IF XARRV IS LAST TURN ON LAST*/
@RF00316 TM    APINAP2E(INPUTPTR),B'10000000'                   02S0332
         BNO   @RF00332                                         02S0332
*                   LASTPARM=ON;    /* PARM FLAG                     */
         OI    LASTPARM,B'10000000'                             02S0333
*                 ELSE                                          02S0334
*                   INPUTPTR=INPUTPTR+8;/* POINT TO NEXT PARAMETER   */
         B     @RC00332                                         02S0334
@RF00332 AL    INPUTPTR,@CF00145                                02S0334
*               END;                                            02S0335
*             ELSE                  /* ERROR - NOT ENUFF PARMS       */
*               GOTO OUTERR1;       /* GO SET ERROR INDICATORS       */
*           ELSE                    /* IFMX,XARRV NOT REQUIRED       */
*             IF APALXVOP=ON THEN   /* TEST IF IFMX,XARRV OPTIONAL   */
         B     @RC00310                                         02S0337
@RF00310 L     @04,APCWAPAL(,APCWPTR)                           02S0337
         TM    APALXVOP(@04),B'01000000'                        02S0337
         BNO   @RF00337                                         02S0337
*               IF LASTPARM=ON THEN /* IF NO MORE PARMS              */
         TM    LASTPARM,B'10000000'                             02S0338
         BNO   @RF00338                                         02S0338
*                 DO;                                           02S0339
*                   IFMX=IFMY;      /* SUPPLY DEFAULT VALUES         */
         L     @04,IFMY(,DESCRPTR)                              02S0340
         ST    @04,IFMX(,DESCRPTR)                              02S0340
*                   IFMXIFMY=ON;    /* INDICATE IFMY SUPPLIED AS
*                                      DEFAULT FOR IFMX              */
         OI    IFMXIFMY,B'10000000'                             02S0341
*                   XARRV=YARRV;                                02S0342
         L     @04,YARRV(,DESCRPTR)                             02S0342
         ST    @04,XARRV(,DESCRPTR)                             02S0342
*                 END;                                          02S0343
*               ELSE                                            02S0344
*                 IF APINAP1E=ON THEN/* IF IFMX IS LAST PARAMETER    */
         B     @RC00338                                         02S0344
@RF00338 TM    APINAP1E(INPUTPTR),B'10000000'                   02S0344
         BNO   @RF00344                                         02S0344
*                   DO;                                         02S0345
*                     IFMX=PARAM1;  /* GET USER SUPPLIED IFMX        */
         L     @04,APINAP1(,INPUTPTR)                           02S0346
         L     @04,PARAM1(,@04)                                 02S0346
         ST    @04,IFMX(,DESCRPTR)                              02S0346
*                     XARRV=YARRV;  /* AND USE DEFAULT VALUE FOR
*                                      XARRV                         */
         L     @04,YARRV(,DESCRPTR)                             02S0347
         ST    @04,XARRV(,DESCRPTR)                             02S0347
*                     LASTPARM=ON;  /* TURN ON LAST PARM FLAG        */
         OI    LASTPARM,B'10000000'                             02S0348
*                   END;                                        02S0349
*                 ELSE              /* IFMX AND XARRV USER SUPPLIED  */
*                   DO;                                         02S0350
         B     @RC00344                                         02S0350
@RF00344 DS    0H                                               02S0351
*                     IFMX=PARAM1;  /* GET IFMX AND XARRV FROM USER  */
         L     @04,APINAP1(,INPUTPTR)                           02S0351
         L     @04,PARAM1(,@04)                                 02S0351
         ST    @04,IFMX(,DESCRPTR)                              02S0351
*                     XARRV=APINAP2;/* GET BLK STR ADDR TO RESOLVE   */
         L     @04,APINAP2(,INPUTPTR)                           02S0352
         ST    @04,XARRV(,DESCRPTR)                             02S0352
*                     CALL APCVZMIF(XARRV,RSOLVERR);/* RESOLVE XARRV */
         LA    @04,XARRV(,DESCRPTR)                             02S0353
         ST    @04,@AL00001                                     02S0353
         LA    @04,RSOLVERR                                     02S0353
         ST    @04,@AL00001+4                                   02S0353
         L     @15,APCTZMIF(,APCTPTR)                           02S0353
         LA    @01,@AL00001                                     02S0353
         BALR  @14,@15                                          02S0353
*                     IF RSOLVERR^=0 THEN/* TEST ERROR RETURN WORD   */
         L     @04,RSOLVERR                                     02S0354
         LTR   @04,@04                                          02S0354
         BZ    @RF00354                                         02S0354
*                       IF RSOLVERR=BDYERROR THEN/* BOUNDARY ERROR?  */
         C     @04,@CF00045                                     02S0355
         BNE   @RF00355                                         02S0355
*                         DO;       /* YES - SET ERROR INDICATORS FOR
*                                      XARRV NOT A WORD BOUNDARY     */
*                           APCWRCN=APCCA016;/* ERROR NUMBER FOR
*                                      XARRV NOT A WORD BOUNDARY     */
         MVI   APCWRCN(APCWPTR),X'10'                           02S0357
*                           APEMMSGN=APCMA016;/* MESSAGE NUMBER FOR
*                                      NOT A WORD BOUNDARY           */
         LA    @09,112                                          02S0358
         ALR   @09,APCWPTR                                      02S0358
         MVC   APEMMSGN(4,@09),@CF00485                         02S0358
*                           APEMVALN=APCMK024;/* XARRV KWD NUMBER    */
         MVC   APEMVALN(4,@09),@CF00061                         02S0359
*                           GOTO OUTERR;/* GO SET COMMON ERROR  02S0360
*                                      INDICATORS AND RETURN         */
         B     OUTERR                                           02S0360
*                         END;      /* END OF SEGMENT                */
*                       ELSE        /* TEST FOR RANGE ERROR          */
*                         IF RSOLVERR=RNGERROR THEN/* WAS ERROR 02S0362
*                                      RANGE?                        */
@RF00355 CLC   RSOLVERR(4),@CF00130                             02S0362
         BNE   @RF00362                                         02S0362
*                           DO;     /* YES - SET ERROR INDICATORS FOR
*                                      XARRV OUT OF RANGE            */
*                             APCWRCN=APCCA021;/* ERROR NUMBER FOR
*                                      XARRV OUT OF RANGE            */
         MVI   APCWRCN(APCWPTR),X'15'                           02S0364
*                             APEMMSGN=APCMA021;/* MESSAGE NUMBER FOR
*                                      OUT OF RANGE                  */
         LA    @09,112                                          02S0365
         ALR   @09,APCWPTR                                      02S0365
         MVC   APEMMSGN(4,@09),@CF00156                         02S0365
*                             APEMVALN=APCMK024;/* XARRV KWD NUMBER  */
         MVC   APEMVALN(4,@09),@CF00061                         02S0366
*                             GOTO OUTERR;/* GO SET COMMON ERROR
*                                      INDICATORS AND RETURN         */
         B     OUTERR                                           02S0367
*                           END;    /* END OF SEGMENT                */
*                         ELSE                                  02S0369
*                           ;       /* NULL - NO MIF PROBLEMS        */
@RF00362 DS    0H                                               02S0370
*                     IF APINAP2E=ON THEN/* IF XARRV IS THE LAST PARM*/
@RF00354 TM    APINAP2E(INPUTPTR),B'10000000'                   02S0370
         BNO   @RF00370                                         02S0370
*                       LASTPARM=ON;/* TURN ON THE LAST PARM FLAG    */
         OI    LASTPARM,B'10000000'                             02S0371
*                     ELSE                                      02S0372
*                       INPUTPTR=INPUTPTR+8;/* POINT TO NEXT    02S0372
*                                      PARAMETER                     */
         B     @RC00370                                         02S0372
@RF00370 AL    INPUTPTR,@CF00145                                02S0372
*                   END;                                        02S0373
*             ELSE                                              02S0374
*               ;                                               02S0374
@RF00337 DS    0H                                               02S0375
*           IF APALXCRQ=ON THEN     /* TEST IF ICTX REQUIRED         */
@RC00337 DS    0H                                               02S0375
@RC00310 L     @04,APCWAPAL(,APCWPTR)                           02S0375
         TM    APALXCRQ(@04),B'10000000'                        02S0375
         BNO   @RF00375                                         02S0375
*             IF LASTPARM=OFF THEN  /* YES ARE THERE MORE PARAMETERS */
         TM    LASTPARM,B'10000000'                             02S0376
         BNZ   @RF00376                                         02S0376
*               DO;                                             02S0377
*                 ICTX=PARAM1;      /* YES - GET USER ICTX           */
         L     @04,APINAP1(,INPUTPTR)                           02S0378
         L     @04,PARAM1(,@04)                                 02S0378
         ST    @04,ICTX(,DESCRPTR)                              02S0378
*                 IF APINAP1E=ON THEN/* IF ICTX IS THE LAST PARAMETER*/
         TM    APINAP1E(INPUTPTR),B'10000000'                   02S0379
         BNO   @RF00379                                         02S0379
*                   LASTPARM=ON;    /* SET THE LAST PARM FLAG        */
         OI    LASTPARM,B'10000000'                             02S0380
*                 ELSE                                          02S0381
*                   INPUTPTR=INPUTPTR+4;/* ADVANCE THE INPUT POINTER */
         B     @RC00379                                         02S0381
@RF00379 AL    INPUTPTR,@CF00142                                02S0381
*               END;                                            02S0382
*             ELSE                  /* ERROR - ICTX REQD BUT NOT
*                                      INPUT                         */
*               GOTO OUTERR1;       /* GO SET ERROR INDICATORS       */
*           ELSE                    /* ICTX NOT REQUIRED             */
*             IF APALXCOP=ON THEN   /* SEE IF ICTX IS OPTIONAL       */
         B     @RC00375                                         02S0384
@RF00375 L     @04,APCWAPAL(,APCWPTR)                           02S0384
         TM    APALXCOP(@04),B'01000000'                        02S0384
         BNO   @RF00384                                         02S0384
*               IF LASTPARM=ON THEN /* YES - MORE PARAMETERS?        */
         TM    LASTPARM,B'10000000'                             02S0385
         BNO   @RF00385                                         02S0385
*                 IF APALXCSD=ON THEN/* NO - DEFAULT IN APAL?        */
         TM    APALXCSD(@04),B'00000001'                        02S0386
         BNO   @RF00386                                         02S0386
*                   ICTX=APALXCNT;  /* YES - USE IT                  */
         LH    @04,APALXCNT(,@04)                               02S0387
         ST    @04,ICTX(,DESCRPTR)                              02S0387
*                 ELSE                                          02S0388
*                   ICTX=ICTY;      /* NO - ICTX = ICTY FOR THIS ALG */
         B     @RC00386                                         02S0388
@RF00386 L     @04,ICTY(,DESCRPTR)                              02S0388
         ST    @04,ICTX(,DESCRPTR)                              02S0388
*               ELSE                /* MORE PARMS EXIST              */
*                 DO;                                           02S0389
         B     @RC00385                                         02S0389
@RF00385 DS    0H                                               02S0390
*                   ICTX=PARAM1;    /* GET USER'S ICTX FROM PARM LIST*/
         L     @04,APINAP1(,INPUTPTR)                           02S0390
         L     @04,PARAM1(,@04)                                 02S0390
         ST    @04,ICTX(,DESCRPTR)                              02S0390
*                   IF APINAP1E=ON THEN/* IF ICTX IS THE LAST   02S0391
*                                      PARAMETER                     */
         TM    APINAP1E(INPUTPTR),B'10000000'                   02S0391
         BNO   @RF00391                                         02S0391
*                     LASTPARM=ON;  /* TURN ON THE LAST PARM FLAG    */
         OI    LASTPARM,B'10000000'                             02S0392
*                   ELSE                                        02S0393
*                     INPUTPTR=INPUTPTR+4;/* POINT TO NEXT PARAMETER */
         B     @RC00391                                         02S0393
@RF00391 AL    INPUTPTR,@CF00142                                02S0393
*                 END;                                          02S0394
*             ELSE                  /* NOT OPTIONAL OR REQUIRED      */
*               IF APALXCSD=ON THEN /* IF DEFAULT IN APAL            */
         B     @RC00384                                         02S0395
@RF00384 L     @04,APCWAPAL(,APCWPTR)                           02S0395
         TM    APALXCSD(@04),B'00000001'                        02S0395
         BNO   @RF00395                                         02S0395
*                 ICTX=APALXCNT;    /* USE IT                        */
         LH    @04,APALXCNT(,@04)                               02S0396
         ST    @04,ICTX(,DESCRPTR)                              02S0396
*               ELSE                                            02S0397
*                 ICTX=ICTY;        /* OTHERWISE ICTX MUST EQUAL ICTY*/
         B     @RC00395                                         02S0397
@RF00395 L     @04,ICTY(,DESCRPTR)                              02S0397
         ST    @04,ICTX(,DESCRPTR)                              02S0397
*           IF APALXDRQ=ON THEN     /* TEST IF IDLX REQUIRED         */
@RC00395 DS    0H                                               02S0398
@RC00384 DS    0H                                               02S0398
@RC00375 L     @04,APCWAPAL(,APCWPTR)                           02S0398
         TM    APALXDRQ(@04),B'10000000'                        02S0398
         BNO   @RF00398                                         02S0398
*             IF LASTPARM=OFF THEN  /* YES - MORE PARAMETERS?        */
         TM    LASTPARM,B'10000000'                             02S0399
         BNZ   @RF00399                                         02S0399
*               DO;                                             02S0400
*                 IDLX=PARAM1;      /* YES - GET USER'S IDLX         */
         L     @04,APINAP1(,INPUTPTR)                           02S0401
         L     @04,PARAM1(,@04)                                 02S0401
         ST    @04,IDLX(,DESCRPTR)                              02S0401
*                 IF APINAP1E=ON THEN/* IF IDLX IS THE LAST PARAMETER*/
         TM    APINAP1E(INPUTPTR),B'10000000'                   02S0402
         BNO   @RF00402                                         02S0402
*                   LASTPARM=ON;    /* TURN ON THE LAST PARM FLAG    */
         OI    LASTPARM,B'10000000'                             02S0403
*                 ELSE                                          02S0404
*                   INPUTPTR=INPUTPTR+4;/* POINT TO NEXT PARAMETER   */
         B     @RC00402                                         02S0404
@RF00402 AL    INPUTPTR,@CF00142                                02S0404
*               END;                                            02S0405
*             ELSE                  /* ERROR - IDLX REQD BUT NOT
*                                      INPUT                         */
*               GO TO OUTERR1;      /* GO SET ERROR INDICATORS       */
*           ELSE                    /* IDLX NOT REQUIRED             */
*             IF APALXDOP=ON THEN   /* TEST IF IDLX OPTIONAL         */
         B     @RC00398                                         02S0407
@RF00398 L     @04,APCWAPAL(,APCWPTR)                           02S0407
         TM    APALXDOP(@04),B'01000000'                        02S0407
         BNO   @RF00407                                         02S0407
*               IF LASTPARM=OFF THEN/* YES - MORE PARAMETERS?        */
         TM    LASTPARM,B'10000000'                             02S0408
         BNZ   @RF00408                                         02S0408
*                 DO;                                           02S0409
*                   IDLX=PARAM1;    /* YES - GET USER'S IDLX         */
         L     @04,APINAP1(,INPUTPTR)                           02S0410
         L     @04,PARAM1(,@04)                                 02S0410
         ST    @04,IDLX(,DESCRPTR)                              02S0410
*                   IF APINAP1E=ON THEN/* IF IDLX IS THE LAST   02S0411
*                                      PARAMETER                     */
         TM    APINAP1E(INPUTPTR),B'10000000'                   02S0411
         BNO   @RF00411                                         02S0411
*                     LASTPARM=ON;  /* TURN ON THE LAST PARM FLAG    */
         OI    LASTPARM,B'10000000'                             02S0412
*                   ELSE                                        02S0413
*                     INPUTPTR=INPUTPTR+4;/* POINT TO NEXT PARAMETER */
         B     @RC00411                                         02S0413
@RF00411 AL    INPUTPTR,@CF00142                                02S0413
*                 END;                                          02S0414
*               ELSE                /* NO MORE PARMS                 */
*                 IDLX=IDLY;        /* SUPPLY DEFAULT VALUE = IDLY   */
         B     @RC00408                                         02S0415
@RF00408 L     @04,IDLY(,DESCRPTR)                              02S0415
         ST    @04,IDLX(,DESCRPTR)                              02S0415
*             ELSE                  /* IDLX NOT REQD OR OPTIONAL     */
*               IDLX=1;             /* SUPPLY DEFAULT VALUE          */
         B     @RC00407                                         02S0416
@RF00407 MVC   IDLX(4,DESCRPTR),@CF00045                        02S0416
*           IF XSTARTDX=ON THEN     /* TEST IF USE OF START INDEX
*                                      SPECIFIED IN IFMX             */
@RC00407 DS    0H                                               02S0417
@RC00398 TM    XSTARTDX(DESCRPTR),B'00100000'                   02S0417
         BNO   @RF00417                                         02S0417
*             IF LASTPARM=OFF THEN  /* YES - MORE PARAMETERS IN LIST?*/
         TM    LASTPARM,B'10000000'                             02S0418
         BNZ   @RF00418                                         02S0418
*               DO;                                             02S0419
*                 XARRVX=PARAM1;    /* YES - GET USER START INDEX    */
         L     @04,APINAP1(,INPUTPTR)                           02S0420
         L     @04,PARAM1(,@04)                                 02S0420
         ST    @04,XARRVX(,DESCRPTR)                            02S0420
*                 IF APINAP1E=ON THEN/* STANDARD LAST PARM CHECK     */
         TM    APINAP1E(INPUTPTR),B'10000000'                   02S0421
         BNO   @RF00421                                         02S0421
*                   LASTPARM=ON;                                02S0422
         OI    LASTPARM,B'10000000'                             02S0422
*                 ELSE                                          02S0423
*                   INPUTPTR=INPUTPTR+4;/* POINT TO NEXT PARAMETER   */
         B     @RC00421                                         02S0423
@RF00421 AL    INPUTPTR,@CF00142                                02S0423
*               END;                                            02S0424
*             ELSE                  /* XARRVX NOT INPUT - CHECK IF
*                                      IFMX DEFAULTED TO IFMY. IF SO,
*                                      USE YARRVX. ELSE - ERROR      */
*               IF IFMXIFMY=ON THEN /* CHECK DEFAULT FLAG            */
         B     @RC00418                                         02S0425
@RF00418 TM    IFMXIFMY,B'10000000'                             02S0425
         BNO   @RF00425                                         02S0425
*                 XARRVX=YARRVX;    /* IF DEFAULT, USE Y VECTOR 02S0426
*                                      ADDRESS INDEX FOR X           */
         L     @04,YARRVX(,DESCRPTR)                            02S0426
         ST    @04,XARRVX(,DESCRPTR)                            02S0426
*               ELSE                /* NOT INPUT OR DEFAULTED - ERROR*/
*                 GOTO OUTERR1;     /* GO SET ERROR INDICATORS AND
*                                      RETURN                        */
*           ELSE                                                02S0428
*             ;                                                 02S0428
@RF00417 DS    0H                                               02S0429
*           IF XCOUNTDX=ON THEN     /* TEST IF USE OF COUNT INDEX
*                                      SPECIFIED IN IFMX             */
@RC00417 TM    XCOUNTDX(DESCRPTR),B'01000000'                   02S0429
         BNO   @RF00429                                         02S0429
*             IF LASTPARM=OFF THEN  /* YES - TEST FOR MORE PARAMETERS*/
         TM    LASTPARM,B'10000000'                             02S0430
         BNZ   @RF00430                                         02S0430
*               DO;                                             02S0431
*                 ICTXX=PARAM1;     /* GET USER'S COUNT INDEX        */
         L     @04,APINAP1(,INPUTPTR)                           02S0432
         L     @04,PARAM1(,@04)                                 02S0432
         ST    @04,ICTXX(,DESCRPTR)                             02S0432
*                 IF APINAP1E=ON THEN/* SET LAST PARM FLAG IF NEED BE*/
         TM    APINAP1E(INPUTPTR),B'10000000'                   02S0433
         BNO   @RF00433                                         02S0433
*                   LASTPARM=ON;                                02S0434
         OI    LASTPARM,B'10000000'                             02S0434
*                 ELSE                                          02S0435
*                   INPUTPTR=INPUTPTR+4;/* POINT TO NEXT PARAMETER   */
         B     @RC00433                                         02S0435
@RF00433 AL    INPUTPTR,@CF00142                                02S0435
*               END;                                            02S0436
*             ELSE                  /* ICTXX NOT INPUT - CHECK IF
*                                      IFMX DEFAULTED TO IFMY. IF SO,
*                                      USE ICTYX. ELSE - ERROR       */
*               IF IFMXIFMY=ON THEN /* CHECK DEFAULT FLAG            */
         B     @RC00430                                         02S0437
@RF00430 TM    IFMXIFMY,B'10000000'                             02S0437
         BNO   @RF00437                                         02S0437
*                 ICTXX=ICTYX;      /* IF DEFAULT, USE Y VECTOR COUNT
*                                      INDEX FOR X                   */
         L     @04,ICTYX(,DESCRPTR)                             02S0438
         ST    @04,ICTXX(,DESCRPTR)                             02S0438
*               ELSE                /* NOT INPUT OR DEFAULTED - ERROR*/
*                 GOTO OUTERR1;     /* GO SET ERROR INDICATORS AND
*                                      RETURN                        */
*           ELSE                                                02S0440
*             ;                                                 02S0440
@RF00429 DS    0H                                               02S0441
*           IF XDELTADX=ON THEN     /* TEST IF USE OF DELTA INDEX
*                                      SPECIFIED IN IFMX             */
@RC00429 TM    XDELTADX(DESCRPTR),B'10000000'                   02S0441
         BNO   @RF00441                                         02S0441
*             IF LASTPARM=OFF THEN  /* YES - MORE PARAMETERS?        */
         TM    LASTPARM,B'10000000'                             02S0442
         BNZ   @RF00442                                         02S0442
*               DO;                                             02S0443
*                 IDLXX=PARAM1;     /* YES - GET USER SUPPLIED IDLXX */
         L     @04,APINAP1(,INPUTPTR)                           02S0444
         L     @04,PARAM1(,@04)                                 02S0444
         ST    @04,IDLXX(,DESCRPTR)                             02S0444
*                 IF APINAP1E=ON THEN/* LAST PARM CHECK              */
         TM    APINAP1E(INPUTPTR),B'10000000'                   02S0445
         BNO   @RF00445                                         02S0445
*                   LASTPARM=ON;                                02S0446
         OI    LASTPARM,B'10000000'                             02S0446
*                 ELSE                                          02S0447
*                   INPUTPTR=INPUTPTR+4;/* POINT TO NEXT PARAMETER   */
         B     @RC00445                                         02S0447
@RF00445 AL    INPUTPTR,@CF00142                                02S0447
*               END;                                            02S0448
*             ELSE                  /* IDLXX NOT INPUT - CHECK IF
*                                      IFMX DEFAULTED TO IFMY. IF SO,
*                                      USE IDLYX. ELSE - ERROR       */
*               IF IFMXIFMY=ON THEN /* CHECK DEFAULT FLAG            */
         B     @RC00442                                         02S0449
@RF00442 TM    IFMXIFMY,B'10000000'                             02S0449
         BNO   @RF00449                                         02S0449
*                 IDLXX=IDLYX;      /* IF DEFAULT, USE Y VECTOR DELTA
*                                      INDEX FOR X                   */
         L     @04,IDLYX(,DESCRPTR)                             02S0450
         ST    @04,IDLXX(,DESCRPTR)                             02S0450
*               ELSE                /* NOT INPUT OR DEFAULTED - ERROR*/
*                 GOTO OUTERR1;     /* GO SET ERROR INDICATORS AND
*                                      RETURN                        */
*           ELSE                                                02S0452
*             ;                                                 02S0452
@RF00441 DS    0H                                               02S0453
*         END;                                                  02S0453
*       ELSE                        /* 1 VECTOR OP                   */
*         IF LASTPARM=OFF THEN      /* TEST IF TOO MANY PARMS        */
         B     @RC00307                                         02S0454
@RF00307 TM    LASTPARM,B'10000000'                             02S0454
         BZ    @RT00454                                         02S0454
*           GOTO OUTERR1;           /* YES - GO SET INDICATORS       */
*       IF NUMVECS>=3 THEN          /* TEST IF U VECTOR REQUIRED     */
*                                                               02S0456
@RC00307 C     NUMVECS,@CF00156                                 02S0456
         BL    @RF00456                                         02S0456
*         /***********************************************************/
*         /*                                                         */
*         /* PROCESS U VECTOR COMPONENTS                             */
*         /*                                                         */
*         /***********************************************************/
*                                                               02S0457
*         DO;                                                   02S0457
*           IFMUIFMX=OFF;           /* CLEAR DEFAULT FLAG            */
         NI    IFMUIFMX,B'01111111'                             02S0458
*           IF APALUVRQ=ON THEN     /* TEST IF U VECTOR REQUIRED     */
         L     @04,APCWAPAL(,APCWPTR)                           02S0459
         TM    APALUVRQ(@04),B'10000000'                        02S0459
         BNO   @RF00459                                         02S0459
*             IF(LASTPARM=OFF)&(APINAP1E=OFF) THEN/* TEST FOR MORE
*                                      PARMS AND IFMU NOT LAST       */
         TM    LASTPARM,B'10000000'                             02S0460
         BNZ   @RF00460                                         02S0460
         TM    APINAP1E(INPUTPTR),B'10000000'                   02S0460
         BNZ   @RF00460                                         02S0460
*               DO;                                             02S0461
*                 IFMU=PARAM1;      /* GET USER SUPPLIED IFMU & UARRV*/
         L     @04,APINAP1(,INPUTPTR)                           02S0462
         L     @04,PARAM1(,@04)                                 02S0462
         ST    @04,IFMU(,DESCRPTR)                              02S0462
*                 UARRV=APINAP2;    /* GET POINTER TO UARRV          */
         L     @04,APINAP2(,INPUTPTR)                           02S0463
         ST    @04,UARRV(,DESCRPTR)                             02S0463
*                 CALL APCVZMIF(UARRV,RSOLVERR);/* RESOLVE UARRV     */
         LA    @04,UARRV(,DESCRPTR)                             02S0464
         ST    @04,@AL00001                                     02S0464
         LA    @04,RSOLVERR                                     02S0464
         ST    @04,@AL00001+4                                   02S0464
         L     @15,APCTZMIF(,APCTPTR)                           02S0464
         LA    @01,@AL00001                                     02S0464
         BALR  @14,@15                                          02S0464
*                 IF RSOLVERR^=0 THEN/* TEST ERROR RETURN WORD       */
         L     @04,RSOLVERR                                     02S0465
         LTR   @04,@04                                          02S0465
         BZ    @RF00465                                         02S0465
*                   IF RSOLVERR=BDYERROR THEN/* WAS ERROR BOUNDARY?  */
         C     @04,@CF00045                                     02S0466
         BNE   @RF00466                                         02S0466
*                     DO;           /* YES - SET ERROR INDICATORS FOR
*                                      UARRV NOT A WORD BOUNDARY     */
*                       APCWRCN=APCCA017;/* ERROR NUMBER FOR UARRV
*                                      NOT A WORD BOUNDARY           */
         MVI   APCWRCN(APCWPTR),X'11'                           02S0468
*                       APEMMSGN=APCMA017;/* MESSAGE NUMBER FOR NOT A
*                                      Z WORD BOUNDARY               */
         LA    @09,112                                          02S0469
         ALR   @09,APCWPTR                                      02S0469
         MVC   APEMMSGN(4,@09),@CF00485                         02S0469
*                       APEMVALN=APCMK031;/* KEYWORD NUMBER FOR UARRV*/
         MVC   APEMVALN(4,@09),@CF00041                         02S0470
*                       GOTO OUTERR;/* GO SET COMMON ERROR INDICATORS
*                                      AND RETURN                    */
         B     OUTERR                                           02S0471
*                     END;          /* END OF SEGMENT                */
*                   ELSE            /* TEST FOR RANGE ERROR          */
*                     IF RSOLVERR=RNGERROR THEN/* WAS ERROR RANGE?   */
@RF00466 CLC   RSOLVERR(4),@CF00130                             02S0473
         BNE   @RF00473                                         02S0473
*                       DO;         /* YES - SET ERROR INDICATORS FOR
*                                      UARRV OUT OF RANGE            */
*                         APCWRCN=APCCA022;/* ERROR NUMBER FOR UARRV
*                                      OUT OF RANGE                  */
         MVI   APCWRCN(APCWPTR),X'16'                           02S0475
*                         APEMMSGN=APCMA022;/* MESSAGE NUMBER FOR OUT
*                                      OF RANGE                      */
         LA    @09,112                                          02S0476
         ALR   @09,APCWPTR                                      02S0476
         MVC   APEMMSGN(4,@09),@CF00156                         02S0476
*                         APEMVALN=APCMK031;/* KEYWORD NUMBER FOR
*                                      UARRV                         */
         MVC   APEMVALN(4,@09),@CF00041                         02S0477
*                         GOTO OUTERR;/* GO SET COMMON ERROR    02S0478
*                                      INDICATORS AND RETURN         */
         B     OUTERR                                           02S0478
*                       END;        /* END OF SEGMENT                */
*                     ELSE                                      02S0480
*                       ;           /* NULL - NO MIF PROBLEMS        */
@RF00473 DS    0H                                               02S0481
*                 IF APINAP2E=ON THEN/* LAST PARM CHECK              */
@RF00465 TM    APINAP2E(INPUTPTR),B'10000000'                   02S0481
         BNO   @RF00481                                         02S0481
*                   LASTPARM=ON;                                02S0482
         OI    LASTPARM,B'10000000'                             02S0482
*                 ELSE                                          02S0483
*                   INPUTPTR=INPUTPTR+8;/* POINT TO NEXT PARAMETER   */
         B     @RC00481                                         02S0483
@RF00481 AL    INPUTPTR,@CF00145                                02S0483
*               END;                                            02S0484
*             ELSE                  /* ERROR - UARRV REQD & NOT INPUT*/
*               GOTO OUTERR1;       /* GO SET ERROR INDICATORS       */
*           ELSE                    /* UARRV NOT REQUIRED            */
*             IF APALUVOP=ON THEN   /* TEST IF UARRV OPTIONAL        */
         B     @RC00459                                         02S0486
@RF00459 L     @04,APCWAPAL(,APCWPTR)                           02S0486
         TM    APALUVOP(@04),B'01000000'                        02S0486
         BNO   @RF00486                                         02S0486
*               IF LASTPARM=ON THEN /* YES - MORE PARAMETERS         */
         TM    LASTPARM,B'10000000'                             02S0487
         BNO   @RF00487                                         02S0487
*                 DO;                                           02S0488
*                   IFMUIFMX=ON;    /* INDICATE DEFAULT SUPPLIED     */
         OI    IFMUIFMX,B'10000000'                             02S0489
*                   IFMU=IFMX;      /* NO - SUPPLY DEFAULTS          */
         L     @04,IFMX(,DESCRPTR)                              02S0490
         ST    @04,IFMU(,DESCRPTR)                              02S0490
*                   UARRV=XARRV;                                02S0491
         L     @04,XARRV(,DESCRPTR)                             02S0491
         ST    @04,UARRV(,DESCRPTR)                             02S0491
*                 END;                                          02S0492
*               ELSE                                            02S0493
*                 IF APINAP1E=ON THEN/* TEST IF IFMU IS LAST         */
         B     @RC00487                                         02S0493
@RF00487 TM    APINAP1E(INPUTPTR),B'10000000'                   02S0493
         BNO   @RF00493                                         02S0493
*                   DO;                                         02S0494
*                     IFMU=PARAM1;  /* YES - GET USER'S IFMU         */
         L     @04,APINAP1(,INPUTPTR)                           02S0495
         L     @04,PARAM1(,@04)                                 02S0495
         ST    @04,IFMU(,DESCRPTR)                              02S0495
*                     UARRV=XARRV;  /* PROVIDE DEFAULT FOR UARRV     */
         L     @04,XARRV(,DESCRPTR)                             02S0496
         ST    @04,UARRV(,DESCRPTR)                             02S0496
*                     LASTPARM=ON;  /* SHOW LAST PARM ENCOUNTERED    */
         OI    LASTPARM,B'10000000'                             02S0497
*                   END;                                        02S0498
*                 ELSE              /* NOT LAST - GET PARMS          */
*                   DO;                                         02S0499
         B     @RC00493                                         02S0499
@RF00493 DS    0H                                               02S0500
*                     IFMU=PARAM1;  /* GET USER'S IFMU AND UARRV     */
         L     @04,APINAP1(,INPUTPTR)                           02S0500
         L     @04,PARAM1(,@04)                                 02S0500
         ST    @04,IFMU(,DESCRPTR)                              02S0500
*                     UARRV=APINAP2;/* GET BLK STR ADDR TO RESOLVE   */
         L     @04,APINAP2(,INPUTPTR)                           02S0501
         ST    @04,UARRV(,DESCRPTR)                             02S0501
*                     CALL APCVZMIF(UARRV,RSOLVERR);/* RESOLVE UARRV */
         LA    @04,UARRV(,DESCRPTR)                             02S0502
         ST    @04,@AL00001                                     02S0502
         LA    @04,RSOLVERR                                     02S0502
         ST    @04,@AL00001+4                                   02S0502
         L     @15,APCTZMIF(,APCTPTR)                           02S0502
         LA    @01,@AL00001                                     02S0502
         BALR  @14,@15                                          02S0502
*                     IF RSOLVERR^=0 THEN/* TEST ERROR RETURN WORD   */
         L     @04,RSOLVERR                                     02S0503
         LTR   @04,@04                                          02S0503
         BZ    @RF00503                                         02S0503
*                       IF RSOLVERR=BDYERROR THEN/* BOUNDARY ERROR?  */
         C     @04,@CF00045                                     02S0504
         BNE   @RF00504                                         02S0504
*                         DO;       /* YES - SET ERROR INDICATORS FOR
*                                      UARRV NOT A WORD BOUNDARY     */
*                           APCWRCN=APCCA017;/* ERROR NUMBER FOR
*                                      UARRV NOT A WORD BOUNDARY     */
         MVI   APCWRCN(APCWPTR),X'11'                           02S0506
*                           APEMMSGN=APCMA017;/* MESSAGE NUMBER FOR
*                                      NOT A WORD BOUNDARY           */
         LA    @09,112                                          02S0507
         ALR   @09,APCWPTR                                      02S0507
         MVC   APEMMSGN(4,@09),@CF00485                         02S0507
*                           APEMVALN=APCMK031;/* UARRV KWD NUMBER    */
         MVC   APEMVALN(4,@09),@CF00041                         02S0508
*                           GOTO OUTERR;/* GO SET COMMON ERROR  02S0509
*                                      INDICATORS AND RETURN         */
         B     OUTERR                                           02S0509
*                         END;      /* END OF SEGMENT                */
*                       ELSE        /* TEST FOR RANGE ERROR          */
*                         IF RSOLVERR=RNGERROR THEN/* WAS ERROR 02S0511
*                                      RANGE?                        */
@RF00504 CLC   RSOLVERR(4),@CF00130                             02S0511
         BNE   @RF00511                                         02S0511
*                           DO;     /* YES - SET ERROR INDICATORS FOR
*                                      UARRV OUT OF RANGE            */
*                             APCWRCN=APCCA022;/* ERROR NUMBER FOR
*                                      UARRV OUT OF RANGE            */
         MVI   APCWRCN(APCWPTR),X'16'                           02S0513
*                             APEMMSGN=APCMA022;/* MESSAGE NUMBER FOR
*                                      OUT OF RANGE                  */
         LA    @09,112                                          02S0514
         ALR   @09,APCWPTR                                      02S0514
         MVC   APEMMSGN(4,@09),@CF00156                         02S0514
*                             APEMVALN=APCMK031;/* XARRV KWD NUMBER  */
         MVC   APEMVALN(4,@09),@CF00041                         02S0515
*                             GOTO OUTERR;/* GO SET COMMON ERROR
*                                      INDICATORS AND RETURN         */
         B     OUTERR                                           02S0516
*                           END;    /* END OF SEGMENT                */
*                         ELSE                                  02S0518
*                           ;       /* NULL - NO MIF PROBLEMS        */
@RF00511 DS    0H                                               02S0519
*                     IF APINAP2E=ON THEN/* LAST PARM CHECK          */
@RF00503 TM    APINAP2E(INPUTPTR),B'10000000'                   02S0519
         BNO   @RF00519                                         02S0519
*                       LASTPARM=ON;                            02S0520
         OI    LASTPARM,B'10000000'                             02S0520
*                     ELSE                                      02S0521
*                       INPUTPTR=INPUTPTR+8;/* POINT TO NEXT    02S0521
*                                      PARAMETER                     */
         B     @RC00519                                         02S0521
@RF00519 AL    INPUTPTR,@CF00145                                02S0521
*                   END;                                        02S0522
*             ELSE                                              02S0523
*               ;                                               02S0523
@RF00486 DS    0H                                               02S0524
*           IF APALUCRQ=ON THEN     /* TEST IF ICTU REQUIRED         */
@RC00486 DS    0H                                               02S0524
@RC00459 L     @04,APCWAPAL(,APCWPTR)                           02S0524
         TM    APALUCRQ(@04),B'10000000'                        02S0524
         BNO   @RF00524                                         02S0524
*             IF LASTPARM=OFF THEN  /* YES - MORE PARAMETERS?        */
         TM    LASTPARM,B'10000000'                             02S0525
         BNZ   @RF00525                                         02S0525
*               DO;                                             02S0526
*                 ICTU=PARAM1;      /* YES - GET USER'S ICTU         */
         L     @04,APINAP1(,INPUTPTR)                           02S0527
         L     @04,PARAM1(,@04)                                 02S0527
         ST    @04,ICTU(,DESCRPTR)                              02S0527
*                 IF APINAP1E=ON THEN/* IF ICTU IS LAST PARM         */
         TM    APINAP1E(INPUTPTR),B'10000000'                   02S0528
         BNO   @RF00528                                         02S0528
*                   LASTPARM=ON;    /* TURN ON LAST PARM FLAG        */
         OI    LASTPARM,B'10000000'                             02S0529
*                 ELSE                                          02S0530
*                   INPUTPTR=INPUTPTR+4;/* POINT TO NEXT PARAMETER   */
         B     @RC00528                                         02S0530
@RF00528 AL    INPUTPTR,@CF00142                                02S0530
*               END;                                            02S0531
*             ELSE                  /* ERROR-ICTU REQD & NOT GIVEN   */
*               GO TO OUTERR1;      /* GO SET ERROR INDICATORS       */
*           ELSE                    /* ICTU NOT REQUIRED             */
*             IF APALUCOP=ON THEN   /* IF ICTU OPTIONAL              */
         B     @RC00524                                         02S0533
@RF00524 L     @04,APCWAPAL(,APCWPTR)                           02S0533
         TM    APALUCOP(@04),B'01000000'                        02S0533
         BNO   @RF00533                                         02S0533
*               IF LASTPARM=ON THEN /* YES - MORE PARAMETERS?        */
         TM    LASTPARM,B'10000000'                             02S0534
         BNO   @RF00534                                         02S0534
*                 IF APALUCSD=ON THEN/* NO - DEFAULT IN APAL         */
         TM    APALUCSD(@04),B'00000001'                        02S0535
         BNO   @RF00535                                         02S0535
*                   ICTU=APALUCNT;  /* YES - USE IT                  */
         LH    @04,APALUCNT(,@04)                               02S0536
         ST    @04,ICTU(,DESCRPTR)                              02S0536
*                 ELSE                                          02S0537
*                   ICTU=ICTX;      /* NO - THEN ICTU MUST = ICTX    */
         B     @RC00535                                         02S0537
@RF00535 L     @04,ICTX(,DESCRPTR)                              02S0537
         ST    @04,ICTU(,DESCRPTR)                              02S0537
*               ELSE                /* MORE PARAMETERS EXIST         */
*                 DO;                                           02S0538
         B     @RC00534                                         02S0538
@RF00534 DS    0H                                               02S0539
*                   ICTU=PARAM1;    /* GET USER'S ICTU               */
         L     @04,APINAP1(,INPUTPTR)                           02S0539
         L     @04,PARAM1(,@04)                                 02S0539
         ST    @04,ICTU(,DESCRPTR)                              02S0539
*                   IF APINAP1E=ON THEN/* STANDARD ACTION BY NOW     */
         TM    APINAP1E(INPUTPTR),B'10000000'                   02S0540
         BNO   @RF00540                                         02S0540
*                     LASTPARM=ON;                              02S0541
         OI    LASTPARM,B'10000000'                             02S0541
*                   ELSE                                        02S0542
*                     INPUTPTR=INPUTPTR+4;/* POINT TO NEXT PARAMETER */
         B     @RC00540                                         02S0542
@RF00540 AL    INPUTPTR,@CF00142                                02S0542
*                 END;                                          02S0543
*             ELSE                  /* ICTU NOT REQD OR OPTIONAL     */
*               IF APALUCSD=ON THEN /* IF DEFAULT IN APAL            */
         B     @RC00533                                         02S0544
@RF00533 L     @04,APCWAPAL(,APCWPTR)                           02S0544
         TM    APALUCSD(@04),B'00000001'                        02S0544
         BNO   @RF00544                                         02S0544
*                 ICTU=APALUCNT;    /* USE IT                        */
         LH    @04,APALUCNT(,@04)                               02S0545
         ST    @04,ICTU(,DESCRPTR)                              02S0545
*               ELSE                                            02S0546
*                 ICTU=ICTX;        /* OTHERWISE DEFAULT IS ICTX     */
         B     @RC00544                                         02S0546
@RF00544 L     @04,ICTX(,DESCRPTR)                              02S0546
         ST    @04,ICTU(,DESCRPTR)                              02S0546
*           IF APALUDRQ=ON THEN     /* TEST IF IDLU IS REQUIRED      */
@RC00544 DS    0H                                               02S0547
@RC00533 DS    0H                                               02S0547
@RC00524 L     @04,APCWAPAL(,APCWPTR)                           02S0547
         TM    APALUDRQ(@04),B'10000000'                        02S0547
         BNO   @RF00547                                         02S0547
*             IF LASTPARM=OFF THEN  /* TEST IF MORE PARAMETERS       */
         TM    LASTPARM,B'10000000'                             02S0548
         BNZ   @RF00548                                         02S0548
*               DO;                                             02S0549
*                 IDLU=PARAM1;      /* YES - GET USER'S IDLU         */
         L     @04,APINAP1(,INPUTPTR)                           02S0550
         L     @04,PARAM1(,@04)                                 02S0550
         ST    @04,IDLU(,DESCRPTR)                              02S0550
*                 IF APINAP1E=ON THEN/* LAST PARM TEST               */
         TM    APINAP1E(INPUTPTR),B'10000000'                   02S0551
         BNO   @RF00551                                         02S0551
*                   LASTPARM=ON;                                02S0552
         OI    LASTPARM,B'10000000'                             02S0552
*                 ELSE                                          02S0553
*                   INPUTPTR=INPUTPTR+4;/* POINT TO NEXT PARAMETER   */
         B     @RC00551                                         02S0553
@RF00551 AL    INPUTPTR,@CF00142                                02S0553
*               END;                                            02S0554
*             ELSE                  /* ERROR-IDLU RQD & NOT GIVEN    */
*               GOTO OUTERR1;       /* GO SET ERROR INDICATORS       */
*           ELSE                    /* IDLU NOT REQUIRED             */
*             IF APALUDOP=ON THEN   /* TEST IF IDLU OPTIONAL         */
         B     @RC00547                                         02S0556
@RF00547 L     @04,APCWAPAL(,APCWPTR)                           02S0556
         TM    APALUDOP(@04),B'01000000'                        02S0556
         BNO   @RF00556                                         02S0556
*               IF LASTPARM=OFF THEN/* MORE PARAMETERS?              */
         TM    LASTPARM,B'10000000'                             02S0557
         BNZ   @RF00557                                         02S0557
*                 DO;                                           02S0558
*                   IDLU=PARAM1;    /* YES - GET USER'S IDLU         */
         L     @04,APINAP1(,INPUTPTR)                           02S0559
         L     @04,PARAM1(,@04)                                 02S0559
         ST    @04,IDLU(,DESCRPTR)                              02S0559
*                   IF APINAP1E=ON THEN/* LAST PARM CHECK            */
         TM    APINAP1E(INPUTPTR),B'10000000'                   02S0560
         BNO   @RF00560                                         02S0560
*                     LASTPARM=ON;                              02S0561
         OI    LASTPARM,B'10000000'                             02S0561
*                   ELSE                                        02S0562
*                     INPUTPTR=INPUTPTR+4;/* POINT TO NEXT PARAMETER */
         B     @RC00560                                         02S0562
@RF00560 AL    INPUTPTR,@CF00142                                02S0562
*                 END;                                          02S0563
*               ELSE                /* NO MORE PARMS                 */
*                 IDLU=IDLX;        /* SUPPLY DEFAULT = IDLX         */
         B     @RC00557                                         02S0564
@RF00557 L     @04,IDLX(,DESCRPTR)                              02S0564
         ST    @04,IDLU(,DESCRPTR)                              02S0564
*             ELSE                  /* IDLU NOT RQD OR OPTIONAL      */
*               IDLU=1;             /* SUPPLY DEFAULT                */
         B     @RC00556                                         02S0565
@RF00556 MVC   IDLU(4,DESCRPTR),@CF00045                        02S0565
*           IF USTARTDX=ON THEN     /* DETERMINE IF USE OF START
*                                      INDEX SPECIFIED IN IFMU       */
@RC00556 DS    0H                                               02S0566
@RC00547 TM    USTARTDX(DESCRPTR),B'00100000'                   02S0566
         BNO   @RF00566                                         02S0566
*             IF LASTPARM=OFF THEN  /* YES - MORE PARAMETERS?        */
         TM    LASTPARM,B'10000000'                             02S0567
         BNZ   @RF00567                                         02S0567
*               DO;                                             02S0568
*                 UARRVX=PARAM1;    /* YES - GET USER'S UARRVX       */
         L     @04,APINAP1(,INPUTPTR)                           02S0569
         L     @04,PARAM1(,@04)                                 02S0569
         ST    @04,UARRVX(,DESCRPTR)                            02S0569
*                 IF APINAP1E=ON THEN/* LAST PARM CHECK              */
         TM    APINAP1E(INPUTPTR),B'10000000'                   02S0570
         BNO   @RF00570                                         02S0570
*                   LASTPARM=ON;                                02S0571
         OI    LASTPARM,B'10000000'                             02S0571
*                 ELSE                                          02S0572
*                   INPUTPTR=INPUTPTR+4;/* ADVANCE INPUT POINTER     */
         B     @RC00570                                         02S0572
@RF00570 AL    INPUTPTR,@CF00142                                02S0572
*               END;                                            02S0573
*             ELSE                  /* UARRVX NOT INPUT - CHECK IF
*                                      IFMU DEFAULTED TO IFMX. IF SO,
*                                      USE XARRVX. ELSE - ERROR      */
*               IF IFMUIFMX=ON THEN /* CHECK DEFAULT FLAG            */
         B     @RC00567                                         02S0574
@RF00567 TM    IFMUIFMX,B'10000000'                             02S0574
         BNO   @RF00574                                         02S0574
*                 UARRVX=XARRVX;    /* IF DEFAULT, USE X VECTOR 02S0575
*                                      ADDRESS INDEX FOR U           */
         L     @04,XARRVX(,DESCRPTR)                            02S0575
         ST    @04,UARRVX(,DESCRPTR)                            02S0575
*               ELSE                /* NOT INPUT OR DEFAULTED - ERROR*/
*                 GOTO OUTERR1;     /* GO SET ERROR INDICATORS AND
*                                      RETURN                        */
*           ELSE                                                02S0577
*             ;                                                 02S0577
@RF00566 DS    0H                                               02S0578
*           IF UCOUNTDX=ON THEN     /* TEST IF USE OF COUNT INDEX
*                                      SPECIFIED IN IFMU             */
@RC00566 TM    UCOUNTDX(DESCRPTR),B'01000000'                   02S0578
         BNO   @RF00578                                         02S0578
*             IF LASTPARM=OFF THEN  /* YES - ANY MORE PARAMETERS?    */
         TM    LASTPARM,B'10000000'                             02S0579
         BNZ   @RF00579                                         02S0579
*               DO;                                             02S0580
*                 ICTUX=PARAM1;     /* YES - GET ICTUX               */
         L     @04,APINAP1(,INPUTPTR)                           02S0581
         L     @04,PARAM1(,@04)                                 02S0581
         ST    @04,ICTUX(,DESCRPTR)                             02S0581
*                 IF APINAP1E=ON THEN/* LAST PARAMETER CHECK         */
         TM    APINAP1E(INPUTPTR),B'10000000'                   02S0582
         BNO   @RF00582                                         02S0582
*                   LASTPARM=ON;                                02S0583
         OI    LASTPARM,B'10000000'                             02S0583
*                 ELSE                                          02S0584
*                   INPUTPTR=INPUTPTR+4;/* POINT TO NEXT PARAMETER   */
         B     @RC00582                                         02S0584
@RF00582 AL    INPUTPTR,@CF00142                                02S0584
*               END;                                            02S0585
*             ELSE                  /* ICTUX NOT INPUT - CHECK IF
*                                      IFMU DEFAULTED TO IFMX. IF SO,
*                                      USE ICTXX. ELSE - ERROR       */
*               IF IFMUIFMX=ON THEN /* CHECK DEFAULT FLAG            */
         B     @RC00579                                         02S0586
@RF00579 TM    IFMUIFMX,B'10000000'                             02S0586
         BNO   @RF00586                                         02S0586
*                 ICTUX=ICTXX;      /* IF DEFAULT, USE X VECTOR COUNT
*                                      INDEX FOR U                   */
         L     @04,ICTXX(,DESCRPTR)                             02S0587
         ST    @04,ICTUX(,DESCRPTR)                             02S0587
*               ELSE                /* NOT INPUT OR DEFAULTED - ERROR*/
*                 GOTO OUTERR1;     /* GO SET ERROR INDICATORS AND
*                                      RETURN                        */
*           ELSE                                                02S0589
*             ;                                                 02S0589
@RF00578 DS    0H                                               02S0590
*           IF UDELTADX=ON THEN     /* TEST IF USE OF DELTA INDEX
*                                      SPECIFIED IN IFMU             */
@RC00578 TM    UDELTADX(DESCRPTR),B'10000000'                   02S0590
         BNO   @RF00590                                         02S0590
*             IF LASTPARM=OFF THEN  /* YES - MORE PARAMETERS?        */
         TM    LASTPARM,B'10000000'                             02S0591
         BNZ   @RF00591                                         02S0591
*               DO;                                             02S0592
*                 IDLUX=PARAM1;     /* YES - GET IDLUX               */
         L     @04,APINAP1(,INPUTPTR)                           02S0593
         L     @04,PARAM1(,@04)                                 02S0593
         ST    @04,IDLUX(,DESCRPTR)                             02S0593
*                 IF APINAP1E=ON THEN/* LAST PARM TEST               */
         TM    APINAP1E(INPUTPTR),B'10000000'                   02S0594
         BNO   @RF00594                                         02S0594
*                   LASTPARM=ON;                                02S0595
         OI    LASTPARM,B'10000000'                             02S0595
*                 ELSE                                          02S0596
*                   INPUTPTR=INPUTPTR+4;/* POINT TO NEXT PARAMETER   */
         B     @RC00594                                         02S0596
@RF00594 AL    INPUTPTR,@CF00142                                02S0596
*               END;                                            02S0597
*             ELSE                  /* IDLUX NOT INPUT - CHECK IF
*                                      IFMU DEFAULTED TO IFMX. IF SO,
*                                      USE IDLXX. ELSE - ERROR       */
*               IF IFMUIFMX=ON THEN /* CHECK DEFAULT FLAG            */
         B     @RC00591                                         02S0598
@RF00591 TM    IFMUIFMX,B'10000000'                             02S0598
         BNO   @RF00598                                         02S0598
*                 IDLUX=IDLXX;      /* IF DEFAULT, USE X VECTOR DELTA
*                                      INDEX FOR U                   */
         L     @04,IDLXX(,DESCRPTR)                             02S0599
         ST    @04,IDLUX(,DESCRPTR)                             02S0599
*               ELSE                /* NOT INPUT OR DEFAULTED - ERROR*/
*                 GOTO OUTERR1;     /* GO SET ERROR INDICATORS AND
*                                      RETURN                        */
*           ELSE                                                02S0601
*             ;                                                 02S0601
@RF00590 DS    0H                                               02S0602
*         END;                                                  02S0602
*       ELSE                        /* 2 VECTOR OP                   */
*         IF LASTPARM=OFF THEN      /* TEST FOR TOO MANY PARMS       */
         B     @RC00456                                         02S0603
@RF00456 TM    LASTPARM,B'10000000'                             02S0603
         BZ    @RT00603                                         02S0603
*           GOTO OUTERR1;           /* YES - GO SET ERROR-CATORS     */
*     END;                                                      01S0605
*                                                               01S0605
@RC00456 DS    0H                                               01S0606
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT DESCRIPTOR VECTOR INTO CIT ENTRY                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0606
*   DO;                                                         01S0606
@RC00095 DS    0H                                               01S0607
*                                                               02S0607
*/*******************************************************            */
*/*                                                                  */
*/* THIS LOCAL INCLUDE CONVERTS AN ALGORITHM BUILD                   */
*/* REQUEST FROM DESCRIPTOR VECTOR FORMAT INTO A CONTROL             */
*/* INFORMATION TABLE (CIT) ENTRY. THE CIT ENTRY CAN                 */
*/* THEN BE ADDED TO THE CIT TABLE FOR EVENTUAL OUTPUT               */
*/* TO THE 3838 WHERE ALGORITHM EXECUTION WILL OCCUR.                */
*/*                                                                  */
*/* A DESCRIPTOR VECTOR IS A 22 WORD BLOCK WHICH                     */
*/* CONTAINS ALGORITHM PARAMETERS NECESSARY TO BUILD A               */
*/* CIT ENTRY. A DESCRIPTOR VECTOR MAY BE INPUT EITHER               */
*/* DIRECTLY BY THE USER OR BY THE LOCAL INCLUDE                     */
*/* MDADESCR WHICH CONVERTS A USER'S CALLING SEQUENCE                */
*/* INTO A DESCRIPTOR VECTOR IN THIS PROGRAM'S AUTOMATIC             */
*/* WORK AREA. FORMAT FOR A USER CALL EMPLOYING DIRECT               */
*/* PASSING OF A DESCRIPTOR VECTOR IS:                               */
*/*                                                                  */
*/*   CALL VPSS(IUNIT,IFUNC,ISTATE,IDESCR)                           */
*/*   OR                                                             */
*/*   CALL VPSS(IUNIT,IFUNC,ISTATE,IDESCR,YARRV,XARRV,               */
*/*             UARRV)                                               */
*/*                                                                  */
*/*   WHERE:                                                         */
*/*     IUNIT   UNIT REFERENCE NUMBER                                */
*/*     IFUNC   ALGORITHM MNEMONIC                                   */
*/*     ISTATE  OPERATIONAL PARAMETERS                               */
*/*     IDESCR  POINTER TO THE DESCRIPTOR VECTOR                     */
*/*   THE FOLLOWING PARAMETERS ARE INPUT ONLY ON THE                 */
*/*   SECOND FORM OF A DESCRIPTOR VECTOR CALL. THIS FORM             */
*/*   IS REFERRED TO AS AN INCOMPLETE DESCRIPTOR VECTOR              */
*/*   ( VECTOR STARTING LOCATIONS ARE SUPPLIED AS                    */
*/*     PARAMETERS IN THE CALLING SEQUENCE).                         */
*/*     YARRV   Y VECTOR STARTING LOCATION                           */
*/*     XARRV   X VECTOR STARTING LOCATION                           */
*/*     UARRV   U VECTOR STARTING LOCATION                           */
*/*   USE OF A COMPLETE OR INCOMPLETE DESCRIPTOR VECTOR              */
*/*   IS INDICATED BY BIT SETTINGS IN THE ISTATE                     */
*/*   PARAMETER.                                                     */
*/*                                                                  */
*/* DESCRIPTOR VECTOR FORMAT:                                        */
*/*   WORD 1 RESERVED                                                */
*/*        2 IFMY   Y VECTOR FORMAT SPECIFICATION.                   */
*/*                   BIT SETTINGS IN THIS WORD INDICATE             */
*/*                   THE BASE POINT OF THE VECTOR                   */
*/*                   THE USE AND FORM OF SIGN CONTROL,              */
*/*                   AND WHETHER OR NOT INDEXES ARE                 */
*/*                   TO BE APPLIED.                                 */
*/*        3 YARRV  Y VECTOR 3838 BULK STORE ADDRESS                 */
*/*        4 ICTY   LENGTH OF Y VECTOR                               */
*/*        5 IDLY   Y VECTOR ELEMENT SPACING                         */
*/*        6 YARRVX Y VECTOR ADDRESS INDEX                           */
*/*        7 ICTYX  Y VECTOR LENGTH INDEX                            */
*/*        8 IDLYX  Y VECTOR SPACING INDEX                           */
*/*        9 IFMX   X VECTOR FORMAT SPECIFICATION                    */
*/*       10 XARRV  X VECTOR 3838 BULK STORE ADDRESS                 */
*/*       11 ICTX   X VECTOR LENGTH                                  */
*/*       12 IDLX   X VECTOR ELEMENT SPACING                         */
*/*       13 XARRVX X VECTOR ADDRESS INDEX                           */
*/*       14 ICTXX  X VECTOR LENGTH INDEX                            */
*/*       15 IDLXX  X VECTOR SPACING INDEX                           */
*/*       16 IFMU   U VECTOR FORMAT SPECIFICATION                    */
*/*       17 UARRV  U VECTOR 3838 BULK STORE ADDRESS                 */
*/*       18 ICTU   U VECTOR LENGTH                                  */
*/*       19 IDLU   U VECTOR ELEMENT SPACING                         */
*/*       20 UARRVX U VECTOR ADDRESS INDEX                           */
*/*       21 ICTUX  U VECTOR LENGTH INDEX                            */
*/*       22 IDLUX  U VECTOR SPACING INDEX                           */
*/*                                                                  */
*/*  CIT ENTRY FORMAT:                                               */
*/*                                                                  */
*/*    <---------------- 4 BYTES ------------------>                 */
*/*    ---------------------------------------------                 */
*/*    | OPERATION ID        | ENTRY LENGTH(HWORDS)|                 */
*/*    ---------------------------------------------                 */
*/*    | STD OPTION FLAGS    | ALG DEPENDENT FLAGS |                 */
*/*    ---------------------------------------------                 */
*/*    | Y VECTOR 3838 BULK STORAGE START ADDRESS  |                 */
*/*    ---------------------------------------------                 */
*/*    | Y ELEMENT SPACING   | LENGTH OF Y         |                 */
*/*    ---------------------------------------------                 */
*/*    | Y FORMAT SPEC FLAGS | Y START ADDR INDEX  |                 */
*/*    ---------------------------------------------                 */
*/*    | Y SPACING INDEX     | Y LENGTH INDEX      |                 */
*/*    ---------------------------------------------                 */
*/*    | X VECTOR 3838 BULK STORAGE START ADDRESS  |                 */
*/*    ---------------------------------------------                 */
*/*    | X ELEMENT SPACING   | LENGTH OF X         |                 */
*/*    ---------------------------------------------                 */
*/*    | X FORMAT SPEC FLAGS | X START ADDR INDEX  |                 */
*/*    ---------------------------------------------                 */
*/*    | X SPACING INDEX     | X LENGTH INDEX      |                 */
*/*    ---------------------------------------------                 */
*/*    | U VECTOR 3838 BULK STORAGE START ADDRESS  |                 */
*/*    ---------------------------------------------                 */
*/*    | U ELEMENT SPACING   | LENGTH OF U         |                 */
*/*    ---------------------------------------------                 */
*/*    | U FORMAT SPEC FLAGS | U START ADDR INDEX  |                 */
*/*    ---------------------------------------------                 */
*/*    | U SPACING INDEX     | U LENGTH INDEX      |                 */
*/*    ---------------------------------------------                 */
*/*                                                                  */
*/*    X AND U VECTOR ELEMENTS ARE INCLUDED ONLY IF                  */
*/*    REQUIRED BY THE ALGORITHM.                                    */
*/*    STANDARD OPTIONS   X'8000'  MASK OVERFLOW                     */
*/*                       X'4000'  MASK UNDERFLOW                    */
*/*                       X'2000'  MASK UNNORMALIZED                 */
*/*                                DIVIDE                            */
*/*                       X'1000'  MASK CONVERSION ERROR             */
*/*                       X'0080'  STACK RESULT                      */
*/*    ARRAY DESCRIPTION  X'8000'  REVERSE SIGN                      */
*/*                       X'4000'  FORCE POSITIVE                    */
*/*                       X'2000'  FORCE NEGATIVE                    */
*/*                       X'0800'  FIXED POINT - TWO'S               */
*/*                                COMPLEMENT                        */
*/*                       X'0400'  FIXED POINT - SIGNED              */
*/*                                TRUE                              */
*/*                                                                  */
*/*  THIS PROGRAM MOVES DESCRIPTOR VECTOR ELEMENTS INTO              */
*/*  THE CIT WORK AREA, PERFORMS VALIDITY CHECKING WHERE             */
*/*  POSSIBLE AND SUPPLIES DEFAULT VALUES. THIS IS ACCOM-            */
*/*  BY USING SWITCH SETTINGS IN IGTXAPAL AS A FILTER                */
*/*  TO BUILD AN ALGORITHM CIT ENTRY.                                */
*/*                                                                  */
*/*******************************************************            */
*                                                               02S0607
*     APCIABS1=YARRV;               /* MOVE YARRV TO CIT WORKAREA    */
         LA    @04,CITENTRY                                     02S0607
         L     @03,YARRV(,DESCRPTR)                             02S0607
         ST    @03,APCIABS1(,@04)                               02S0607
*     IF(APALYDOP=ON)|(APALYDRQ=ON) THEN/* TEST IF ELEMENT SPACING
*                                      PERMITTED                     */
         L     @04,APCWAPAL(,APCWPTR)                           02S0608
         TM    APALYDOP(@04),B'11000000'                        02S0608
         BZ    @RF00608                                         02S0608
*       IF(IDLY<-32768)|            /* IDLY MUST BE IN RANGE @ZA25370*/
*           (IDLY>65536) THEN       /* -32768 <-> +65536.    @ZA25370*/
         L     @04,IDLY(,DESCRPTR)                              02S0609
         C     @04,@CF01788                                     02S0609
         BL    @RT00609                                         02S0609
         C     @04,@CF01789                                     02S0609
         BNH   @RF00609                                         02S0609
@RT00609 DS    0H                                               02S0610
*         DO;                       /* IDLY IN ERROR - SET ERROR
*                                      INDICATORS FOR IDLY OUT OF
*                                      RANGE                         */
*           APCWRCN=APCCA027;       /* SET RETURN CODE NO. FOR IDLY
*                                      OUT OF RANGE                  */
         MVI   APCWRCN(APCWPTR),X'1B'                           02S0611
*           APEMMSGN=APCMA027;      /* SET MSG. NO. FOR OUT OF RANGE */
         LA    @09,112                                          02S0612
         ALR   @09,APCWPTR                                      02S0612
         MVC   APEMMSGN(4,@09),@CF00156                         02S0612
*           APEMVALN=APCMK019;      /* SET KYWD. NO. FOR IDLY        */
         MVC   APEMVALN(4,@09),@CF00183                         02S0613
*           GOTO OUTERR;            /* OUTERR SETS COMMON ERROR FLAGS
*                                      AND VALUES AND RETURNS        */
         B     OUTERR                                           02S0614
*         END;                      /* END OF IDLY ERROR PROCESSING  */
*       ELSE                        /* IDLY IS OK                    */
*         APCIADL1=IDLY;            /* MOVE IDLY TO WORKING CIT ENTRY*/
@RF00609 LA    @04,CITENTRY                                     02S0616
         L     @03,IDLY(,DESCRPTR)                              02S0616
         STH   @03,APCIADL1(,@04)                               02S0616
*     ELSE                                                      02S0617
*       APCIADL1=1;                 /* NO - APPLY DEFAULT SPACING    */
         B     @RC00608                                         02S0617
@RF00608 LA    @04,CITENTRY                                     02S0617
         MVC   APCIADL1(2,@04),@CH00045                         02S0617
*     IF(APALYCOP=ON)|(APALYCRQ=ON) THEN/* TEST IF Y COUNT PERMITTED */
@RC00608 L     @04,APCWAPAL(,APCWPTR)                           02S0618
         TM    APALYCOP(@04),B'11000000'                        02S0618
         BZ    @RF00618                                         02S0618
*       IF(ICTY<-32768)|            /* ICTY MUST BE IN RANGE @ZA25370*/
*           (ICTY>65536) THEN       /* -32768 <-> +65536.    @ZA25370*/
         L     @04,ICTY(,DESCRPTR)                              02S0619
         C     @04,@CF01788                                     02S0619
         BL    @RT00619                                         02S0619
         C     @04,@CF01789                                     02S0619
         BNH   @RF00619                                         02S0619
@RT00619 DS    0H                                               02S0620
*         DO;                       /* ICTY IN ERROR - SET ERROR
*                                      INDICATORS FOR ICTY OUT OF
*                                      RANGE                         */
*           APCWRCN=APCCA024;       /* SET RETURN CODE NO. FOR ICTY
*                                      OUT OF RANGE                  */
         MVI   APCWRCN(APCWPTR),X'18'                           02S0621
*           APEMMSGN=APCMA024;      /* SET MSG. NO. FOR OUT OF RANGE */
         LA    @09,112                                          02S0622
         ALR   @09,APCWPTR                                      02S0622
         MVC   APEMMSGN(4,@09),@CF00156                         02S0622
*           APEMVALN=APCMK018;      /* SET KYWD. NO. FOR ICTY        */
         MVC   APEMVALN(4,@09),@CF00074                         02S0623
*           GOTO OUTERR;            /* OUTERR SETS COMMON ERROR FLAGS
*                                      AND VALUES AND RETURNS        */
         B     OUTERR                                           02S0624
*         END;                      /* END OF ICTY ERROR PROCESSING  */
*       ELSE                        /* ICTY IS OK                    */
*         APCIANB1=ICTY;            /* MOVE ICTY TO WORKING CIT ENTRY*/
@RF00619 LA    @04,CITENTRY                                     02S0626
         L     @03,ICTY(,DESCRPTR)                              02S0626
         STH   @03,APCIANB1(,@04)                               02S0626
*     ELSE                                                      02S0627
*       IF APALYCSD=ON THEN         /* NO - IS DEFAULT IN APAL?      */
         B     @RC00618                                         02S0627
@RF00618 L     @04,APCWAPAL(,APCWPTR)                           02S0627
         TM    APALYCSD(@04),B'00000001'                        02S0627
         BNO   @RF00627                                         02S0627
*         APCIANB1=APALYCNT;        /* YES - DEFAULT COUNT TO CIT    */
         LA    @03,CITENTRY                                     02S0628
         LH    @04,APALYCNT(,@04)                               02S0628
         STH   @04,APCIANB1(,@03)                               02S0628
*       ELSE                                                    02S0629
*         APCIANB1=1;               /* NO - DEFAULT IS LENGTH OF 1   */
         B     @RC00627                                         02S0629
@RF00627 LA    @04,CITENTRY                                     02S0629
         MVC   APCIANB1(2,@04),@CH00045                         02S0629
*     IF YNEGATIV=ON THEN           /* IS FORCE NEGATIVE REQUESTED?  */
@RC00627 DS    0H                                               02S0630
@RC00618 TM    YNEGATIV(DESCRPTR),B'00010000'                   02S0630
         BNO   @RF00630                                         02S0630
*       IF(APALYFSR=ON)|(APALYFSO=ON) THEN/* YES - IS IT ALLOWED FOR
*                                      THIS OPERATION?               */
         L     @04,APCWAPAL(,APCWPTR)                           02S0631
         TM    APALYFSR(@04),B'00011000'                        02S0631
         BZ    @RF00631                                         02S0631
*         APCIAFN1=ON;              /* YES - SET FORCE NEGATIVE BIT  */
         LA    @04,CITENTRY                                     02S0632
         OI    APCIAFN1(@04),B'00100000'                        02S0632
*       ELSE                        /* ERROR - SIGN CONTROL NOT 02S0633
*                                      ALLOWED                       */
*         ERRORBIT=ON;              /* FLAG IT                       */
         B     @RC00631                                         02S0633
@RF00631 OI    ERRORBIT,B'10000000'                             02S0633
*     ELSE                                                      02S0634
*       ;                                                       02S0634
@RF00630 DS    0H                                               02S0635
*     IF YREVERSE=ON THEN           /* IS REVERSE SIGN REQUESTED?    */
@RC00630 TM    YREVERSE(DESCRPTR),B'00001000'                   02S0635
         BNO   @RF00635                                         02S0635
*       IF(APALYFSR=ON)|(APALYFSO=ON) THEN/* YES - IS IT ALLOWED?    */
         L     @04,APCWAPAL(,APCWPTR)                           02S0636
         TM    APALYFSR(@04),B'00011000'                        02S0636
         BZ    @RF00636                                         02S0636
*         APCIARS1=ON;              /* YES - SET REVERSE SIGN BIT    */
         LA    @04,CITENTRY                                     02S0637
         OI    APCIARS1(@04),B'10000000'                        02S0637
*       ELSE                        /* ERROR - SIGN CONTROL NOT 02S0638
*                                      ALLOWED                       */
*         ERRORBIT=ON;              /* FLAG IT                       */
         B     @RC00636                                         02S0638
@RF00636 OI    ERRORBIT,B'10000000'                             02S0638
*     ELSE                                                      02S0639
*       ;                                                       02S0639
@RF00635 DS    0H                                               02S0640
*     IF YABSVALU=ON THEN           /* IS ABSOLUTE VALUE REQUESTED?  */
@RC00635 TM    YABSVALU(DESCRPTR),B'00000100'                   02S0640
         BNO   @RF00640                                         02S0640
*       IF(APALYFSR=ON)|(APALYFSO=ON) THEN/* YES - IS IT ALLOWED FOR
*                                      THIS OPERATION?               */
         L     @04,APCWAPAL(,APCWPTR)                           02S0641
         TM    APALYFSR(@04),B'00011000'                        02S0641
         BZ    @RF00641                                         02S0641
*         APCIAFP1=ON;              /* YES - ABSOLUTE VALUE BIT      */
         LA    @04,CITENTRY                                     02S0642
         OI    APCIAFP1(@04),B'01000000'                        02S0642
*       ELSE                        /* ERROR - SIGN CONTROL NOT 02S0643
*                                      ALLOWED                       */
*         ERRORBIT=ON;              /* FLAG IT                       */
         B     @RC00641                                         02S0643
@RF00641 OI    ERRORBIT,B'10000000'                             02S0643
*     ELSE                                                      02S0644
*       ;                                                       02S0644
@RF00640 DS    0H                                               02S0645
*     IF YFXPTTRU=ON THEN           /* IS FIXED-POINT SIGNED TRUE
*                                      REQUESTED?                    */
@RC00640 TM    YFXPTTRU(DESCRPTR),B'00000010'                   02S0645
         BNO   @RF00645                                         02S0645
*       IF APALYFFT=ON THEN         /* YES - IS IT ALLOWED?          */
         L     @04,APCWAPAL(,APCWPTR)                           02S0646
         TM    APALYFFT(@04),B'00100000'                        02S0646
         BNO   @RF00646                                         02S0646
*         APCIAST1=ON;              /* YES - SET APPROPRIATE BIT     */
         LA    @04,CITENTRY                                     02S0647
         OI    APCIAST1(@04),B'00000100'                        02S0647
*       ELSE                        /* ERROR - FIXED POINT NOT  02S0648
*                                      ALLOWED                       */
*         ERRORBIT=ON;              /* FLAG THE ERROR                */
         B     @RC00646                                         02S0648
@RF00646 OI    ERRORBIT,B'10000000'                             02S0648
*     ELSE                                                      02S0649
*       ;                                                       02S0649
@RF00645 DS    0H                                               02S0650
*     IF YFXPTTWO=ON THEN           /* IS FIXED-POINT TWO'S     02S0650
*                                      COMPLEMENT REQUESTED?         */
@RC00645 TM    YFXPTTWO(DESCRPTR),B'00000001'                   02S0650
         BNO   @RF00650                                         02S0650
*       IF APALYFFX=ON THEN         /* YES - IS IT PERMITTED?        */
         L     @04,APCWAPAL(,APCWPTR)                           02S0651
         TM    APALYFFX(@04),B'01000000'                        02S0651
         BNO   @RF00651                                         02S0651
*         APCIATC1=ON;              /* YES - SET APPROPRIATE FORMAT
*                                      FLAG                          */
         LA    @04,CITENTRY                                     02S0652
         OI    APCIATC1(@04),B'00001000'                        02S0652
*       ELSE                        /* ERROR - FIXED POINT NOT  02S0653
*                                      ALLOWED                       */
*         ERRORBIT=ON;              /* FLAG THE ERROR                */
         B     @RC00651                                         02S0653
@RF00651 OI    ERRORBIT,B'10000000'                             02S0653
*     ELSE                                                      02S0654
*       ;                                                       02S0654
@RF00650 DS    0H                                               02S0655
*     IF(APALYFFT=ON)|(APALYFFX=ON) THEN/* IS FIXED - PT REQD?       */
@RC00650 L     @04,APCWAPAL(,APCWPTR)                           02S0655
         TM    APALYFFT(@04),B'01100000'                        02S0655
         BZ    @RF00655                                         02S0655
*       IF(YFXPTTRU=OFF)&(YFXPTTWO=OFF) THEN/* YES - IS IT SET?      */
         TM    YFXPTTRU(DESCRPTR),B'00000011'                   02S0656
         BNZ   @RF00656                                         02S0656
*         ERRORBIT=ON;              /* NO - ERROR                    */
         OI    ERRORBIT,B'10000000'                             02S0657
*       ELSE                                                    02S0658
*         ;                         /* FX-PT REQD AND SET            */
@RF00656 DS    0H                                               02S0659
*     ELSE                                                      02S0659
*       ;                           /* FX-PT NOT REQD                */
@RF00655 DS    0H                                               02S0660
*     IF YSTARTDX=ON THEN           /* IS USE OF A START INDEX  02S0660
*                                      SPECIFIED?                    */
         TM    YSTARTDX(DESCRPTR),B'00100000'                   02S0660
         BNO   @RF00660                                         02S0660
*       IF APALYFXS=ON THEN         /* YES - IS IT ALLOWED?          */
         L     @04,APCWAPAL(,APCWPTR)                           02S0661
         TM    APALYFXS(@04),B'00000100'                        02S0661
         BNO   @RF00661                                         02S0661
*         IF(YARRVX>=0)&(YARRVX<=15) THEN/* IS IT VALID?             */
         L     @04,YARRVX(,DESCRPTR)                            02S0662
         LTR   @04,@04                                          02S0662
         BM    @RF00662                                         02S0662
         C     @04,@CF00176                                     02S0662
         BH    @RF00662                                         02S0662
*           APCIAXB1=YARRVX;        /* YES - MOVE IT TO CIT          */
         LA    @03,CITENTRY                                     02S0663
         STH   @04,APCIAXB1(,@03)                               02S0663
*         ELSE                      /* INVALID - SET ERROR INDS      */
*           DO;                                                 02S0664
         B     @RC00662                                         02S0664
@RF00662 DS    0H                                               02S0665
*             APCWRCN=APCCA003;     /* SET ERROR NUMBER              */
         MVI   APCWRCN(APCWPTR),X'03'                           02S0665
*             APEMMSGN=APCMA003;    /* SET MSG NUMBER                */
         LA    @09,112                                          02S0666
         ALR   @09,APCWPTR                                      02S0666
         MVC   APEMMSGN(4,@09),@CF00156                         02S0666
*             APEMVALN=APCMK020;    /* SET KYWD NBR FOR YARRVX       */
         MVC   APEMVALN(4,@09),@CF00185                         02S0667
*             GOTO OUTERR;          /* GO SET COMMON INDICATORS      */
         B     OUTERR                                           02S0668
*           END;                                                02S0669
*       ELSE                        /* ERROR - START INDEX NOT  02S0670
*                                      ALLOWED                       */
*         ERRORBIT=ON;              /* FLAG IT                       */
         B     @RC00661                                         02S0670
@RF00661 OI    ERRORBIT,B'10000000'                             02S0670
*     ELSE                                                      02S0671
*       ;                                                       02S0671
@RF00660 DS    0H                                               02S0672
*     IF YCOUNTDX=ON THEN           /* IS USE OF A COUNT INDEX  02S0672
*                                      SPECIFIED?                    */
@RC00660 TM    YCOUNTDX(DESCRPTR),B'01000000'                   02S0672
         BNO   @RF00672                                         02S0672
*       IF APALYFXC=ON THEN         /* YES - IS IT ALLOWED?          */
         L     @04,APCWAPAL(,APCWPTR)                           02S0673
         TM    APALYFXC(@04),B'00000010'                        02S0673
         BNO   @RF00673                                         02S0673
*         IF(ICTYX>=0)&(ICTYX<=15) THEN/* YES - VALID?               */
         L     @04,ICTYX(,DESCRPTR)                             02S0674
         LTR   @04,@04                                          02S0674
         BM    @RF00674                                         02S0674
         C     @04,@CF00176                                     02S0674
         BH    @RF00674                                         02S0674
*           APCIAXN1=ICTYX;         /* YES - MOVE IT TO CIT          */
         LA    @03,CITENTRY                                     02S0675
         STH   @04,APCIAXN1(,@03)                               02S0675
*         ELSE                      /* NO - ERROR - OUT OF RANGE     */
*           DO;                     /* SET ERROR INDICATORS          */
         B     @RC00674                                         02S0676
@RF00674 DS    0H                                               02S0677
*             APCWRCN=APCCA004;     /* ERROR NUMBER                  */
         MVI   APCWRCN(APCWPTR),X'04'                           02S0677
*             APEMMSGN=APCMA004;    /* MESSAGE NUMBER                */
         LA    @09,112                                          02S0678
         ALR   @09,APCWPTR                                      02S0678
         MVC   APEMMSGN(4,@09),@CF00156                         02S0678
*             APEMVALN=APCMK021;    /* KYWD NUMBER - ICTYX           */
         MVC   APEMVALN(4,@09),@CF00187                         02S0679
*             GOTO OUTERR;          /* SET COMMON ERR INDS           */
         B     OUTERR                                           02S0680
*           END;                                                02S0681
*       ELSE                        /* NO - ERROR                    */
*         ERRORBIT=ON;              /* FLAG IT                       */
         B     @RC00673                                         02S0682
@RF00673 OI    ERRORBIT,B'10000000'                             02S0682
*     ELSE                                                      02S0683
*       ;                                                       02S0683
@RF00672 DS    0H                                               02S0684
*     IF YDELTADX=ON THEN           /* IS USE OF A SPACING INDEX
*                                      SPECIFIED?                    */
@RC00672 TM    YDELTADX(DESCRPTR),B'10000000'                   02S0684
         BNO   @RF00684                                         02S0684
*       IF APALYFXD=ON THEN         /* YES - ALLOWED?                */
         L     @04,APCWAPAL(,APCWPTR)                           02S0685
         TM    APALYFXD(@04),B'00000001'                        02S0685
         BNO   @RF00685                                         02S0685
*         IF(IDLYX>=0)&(IDLYX<=15) THEN/* YES - VALID?               */
         L     @04,IDLYX(,DESCRPTR)                             02S0686
         LTR   @04,@04                                          02S0686
         BM    @RF00686                                         02S0686
         C     @04,@CF00176                                     02S0686
         BH    @RF00686                                         02S0686
*           APCIAXD1=IDLYX;         /* YES - MOVE IT TO CIT          */
         LA    @03,CITENTRY                                     02S0687
         STH   @04,APCIAXD1(,@03)                               02S0687
*         ELSE                      /* NO - ERROR - OUT OF RANGE     */
*           DO;                     /* SET ERROR INDICATORS          */
         B     @RC00686                                         02S0688
@RF00686 DS    0H                                               02S0689
*             APCWRCN=APCCA005;     /* ERROR NUMBER                  */
         MVI   APCWRCN(APCWPTR),X'05'                           02S0689
*             APEMMSGN=APCMA005;    /* MSG NUMBER                    */
         LA    @09,112                                          02S0690
         ALR   @09,APCWPTR                                      02S0690
         MVC   APEMMSGN(4,@09),@CF00156                         02S0690
*             APEMVALN=APCMK022;    /* KYWD NUMBER - IDLYX           */
         MVC   APEMVALN(4,@09),@CF00055                         02S0691
*             GOTO OUTERR;          /* GO SET COMMON ERRINDS         */
         B     OUTERR                                           02S0692
*           END;                                                02S0693
*       ELSE                        /* NO - ERROR                    */
*         ERRORBIT=ON;              /* FLAG IT                       */
         B     @RC00685                                         02S0694
@RF00685 OI    ERRORBIT,B'10000000'                             02S0694
*     ELSE                                                      02S0695
*       ;                                                       02S0695
@RF00684 DS    0H                                               02S0696
*     IF ERRORBIT=ON THEN           /* ERROR IN IFMY?                */
@RC00684 TM    ERRORBIT,B'10000000'                             02S0696
         BNO   @RF00696                                         02S0696
*       DO;                         /* YES - ERROR - INVALID VALUE   */
*         APCWRCN=APCCA012;         /* ERROR NUMBER                  */
         MVI   APCWRCN(APCWPTR),X'0C'                           02S0698
*         APEMMSGN=APCMA012;        /* MSG NUMBER                    */
         LA    @09,112                                          02S0699
         ALR   @09,APCWPTR                                      02S0699
         MVC   APEMMSGN(4,@09),@CF00170                         02S0699
*         APEMVALN=APCMK016;        /* KYWD NUMBER - IFMY            */
         MVC   APEMVALN(4,@09),@CF00178                         02S0700
*         GOTO OUTERR;              /* GO SET COMMON ERR INDS        */
         B     OUTERR                                           02S0701
*       END;                                                    02S0702
*     ELSE                                                      02S0703
*       ;                                                       02S0703
@RF00696 DS    0H                                               02S0704
*     IF NUMVECS>=2 THEN            /* TEST IF THIS ALGORITHM   02S0704
*                                      REQUIRES AN X VECTOR          */
*                                                               02S0704
         C     NUMVECS,@CF00130                                 02S0704
         BL    @RF00704                                         02S0704
*       /*************************************************************/
*       /*                                                           */
*       /* MOVE X VECTOR ELEMENTS TO CIT                             */
*       /*                                                           */
*       /*************************************************************/
*                                                               02S0705
*       DO;                                                     02S0705
*         APCIABS2=XARRV;           /* MOVE XARRV TO CIT WORKAREA    */
         LA    @04,CITENTRY                                     02S0706
         L     @03,XARRV(,DESCRPTR)                             02S0706
         ST    @03,APCIABS2(,@04)                               02S0706
*         IF(APALXDOP=ON)|(APALXDRQ=ON) THEN/* TEST IF USER CAN 02S0707
*                                      SUPPLY IDLX                   */
         L     @04,APCWAPAL(,APCWPTR)                           02S0707
         TM    APALXDOP(@04),B'11000000'                        02S0707
         BZ    @RF00707                                         02S0707
*           IF(IDLX<-32768)|        /* IDLX MUST BE IN RANGE @ZA25370*/
*               (IDLX>65536) THEN   /* -32768 <-> +65536.    @ZA25370*/
         L     @04,IDLX(,DESCRPTR)                              02S0708
         C     @04,@CF01788                                     02S0708
         BL    @RT00708                                         02S0708
         C     @04,@CF01789                                     02S0708
         BNH   @RF00708                                         02S0708
@RT00708 DS    0H                                               02S0709
*             DO;                   /* IDLX IN ERROR - SET ERROR
*                                      INDICATORS FOR IDLX OUT OF
*                                      RANGE                         */
*               APCWRCN=APCCA028;   /* SET RETURN CODE NO. FOR IDLX
*                                      OUT OF RANGE                  */
         MVI   APCWRCN(APCWPTR),X'1C'                           02S0710
*               APEMMSGN=APCMA028;  /* SET MSG. NO. FOR OUT OF RANGE */
         LA    @09,112                                          02S0711
         ALR   @09,APCWPTR                                      02S0711
         MVC   APEMMSGN(4,@09),@CF00156                         02S0711
*               APEMVALN=APCMK026;  /* SET KYWD. NO. FOR IDLX        */
         MVC   APEMVALN(4,@09),@CF00194                         02S0712
*               GOTO OUTERR;        /* OUTERR SETS COMMON ERROR FLAGS
*                                      AND VALUES AND RETURNS        */
         B     OUTERR                                           02S0713
*             END;                  /* END OF IDLX ERROR PROCESSING  */
*           ELSE                    /* IDLX IS OK                    */
*             APCIADL2=IDLX;        /* MOVE IDLX TO WORKING CIT ENTRY*/
@RF00708 LA    @04,CITENTRY                                     02S0715
         L     @03,IDLX(,DESCRPTR)                              02S0715
         STH   @03,APCIADL2(,@04)                               02S0715
*         ELSE                                                  02S0716
*           APCIADL2=1;             /* NO - SUPPLY DEFAULT           */
         B     @RC00707                                         02S0716
@RF00707 LA    @04,CITENTRY                                     02S0716
         MVC   APCIADL2(2,@04),@CH00045                         02S0716
*         IF(APALXCOP=ON)|(APALXCRQ=ON) THEN/* TEST IF USER CAN 02S0717
*                                      SUPPLY ICTX                   */
@RC00707 L     @04,APCWAPAL(,APCWPTR)                           02S0717
         TM    APALXCOP(@04),B'11000000'                        02S0717
         BZ    @RF00717                                         02S0717
*           IF(ICTX<-32768)|        /* ICTX MUST BE IN RANGE @ZA25370*/
*               (ICTX>65536) THEN   /* -32768 <-> +65536.    @ZA25370*/
         L     @04,ICTX(,DESCRPTR)                              02S0718
         C     @04,@CF01788                                     02S0718
         BL    @RT00718                                         02S0718
         C     @04,@CF01789                                     02S0718
         BNH   @RF00718                                         02S0718
@RT00718 DS    0H                                               02S0719
*             DO;                   /* ICTX IN ERROR - SET ERROR
*                                      INDICATORS FOR ICTX OUT OF
*                                      RANGE                         */
*               APCWRCN=APCCA025;   /* SET RETURN CODE NO. FOR ICTX
*                                      OUT OF RANGE                  */
         MVI   APCWRCN(APCWPTR),X'19'                           02S0720
*               APEMMSGN=APCMA025;  /* SET MSG. NO. FOR OUT OF RANGE */
         LA    @09,112                                          02S0721
         ALR   @09,APCWPTR                                      02S0721
         MVC   APEMMSGN(4,@09),@CF00156                         02S0721
*               APEMVALN=APCMK025;  /* SET KYWD. NO. FOR ICTX        */
         MVC   APEMVALN(4,@09),@CF00043                         02S0722
*               GOTO OUTERR;        /* OUTERR SETS COMMON ERROR FLAGS
*                                      AND VALUES AND RETURNS        */
         B     OUTERR                                           02S0723
*             END;                  /* END OF ICTX ERROR PROCESSING  */
*           ELSE                    /* ICTX IS OK                    */
*             APCIANB2=ICTX;        /* MOVE ICTX TO WORKING CIT ENTRY*/
@RF00718 LA    @04,CITENTRY                                     02S0725
         L     @03,ICTX(,DESCRPTR)                              02S0725
         STH   @03,APCIANB2(,@04)                               02S0725
*         ELSE                                                  02S0726
*           IF APALXCSD=ON THEN     /* NO - IS DEFAULT IN APAL?      */
         B     @RC00717                                         02S0726
@RF00717 L     @04,APCWAPAL(,APCWPTR)                           02S0726
         TM    APALXCSD(@04),B'00000001'                        02S0726
         BNO   @RF00726                                         02S0726
*             APCIANB2=APALXCNT;    /* YES - MOVE IT TO CIT          */
         LA    @03,CITENTRY                                     02S0727
         LH    @04,APALXCNT(,@04)                               02S0727
         STH   @04,APCIANB2(,@03)                               02S0727
*           ELSE                                                02S0728
*             DO;                   /* SET X COUNT TO VALUE OF Y
*                                      COUNT                         */
         B     @RC00726                                         02S0728
@RF00726 DS    0H                                               02S0729
*               APCIANB2=APCIANB1;  /* ICTX = ICTY                   */
         LA    @04,CITENTRY                                     02S0729
         LH    @03,APCIANB1(,@04)                               02S0729
         STH   @03,APCIANB2(,@04)                               02S0729
*               APCIAXN2=APCIAXN1;  /* MUST ALSO USE SAME INDEX      */
         LH    @03,APCIAXN1(,@04)                               02S0730
         STH   @03,APCIAXN2(,@04)                               02S0730
*             END;                  /* END OF ICTX=ICTY SEGMENT      */
*         IF XNEGATIV=ON THEN       /* IS FORCE NEGATIVE REQUESTED?  */
@RC00726 DS    0H                                               02S0732
@RC00717 TM    XNEGATIV(DESCRPTR),B'00010000'                   02S0732
         BNO   @RF00732                                         02S0732
*           IF(APALXFSR=ON)|(APALXFSO=ON) THEN/* YES - IS IT ALLOWED?*/
         L     @04,APCWAPAL(,APCWPTR)                           02S0733
         TM    APALXFSR(@04),B'00011000'                        02S0733
         BZ    @RF00733                                         02S0733
*             APCIAFN2=ON;          /* YES - SET NEGATIVE BIT IN CIT */
         LA    @04,CITENTRY                                     02S0734
         OI    APCIAFN2(@04),B'00100000'                        02S0734
*           ELSE                    /* NO - ERROR                    */
*             ERRORBIT=ON;          /* FLAG IT                       */
         B     @RC00733                                         02S0735
@RF00733 OI    ERRORBIT,B'10000000'                             02S0735
*         ELSE                                                  02S0736
*           ;                                                   02S0736
@RF00732 DS    0H                                               02S0737
*         IF XREVERSE=ON THEN       /* IS REVERSE SIGN REQUESTED?    */
@RC00732 TM    XREVERSE(DESCRPTR),B'00001000'                   02S0737
         BNO   @RF00737                                         02S0737
*           IF(APALXFSR=ON)|(APALXFSO=ON) THEN/* YES - IS IT ALLOWED?*/
         L     @04,APCWAPAL(,APCWPTR)                           02S0738
         TM    APALXFSR(@04),B'00011000'                        02S0738
         BZ    @RF00738                                         02S0738
*             APCIARS2=ON;          /* YES - SET REVERSE BIT IN CIT  */
         LA    @04,CITENTRY                                     02S0739
         OI    APCIARS2(@04),B'10000000'                        02S0739
*           ELSE                    /* NO - ERROR                    */
*             ERRORBIT=ON;          /* FLAG IT                       */
         B     @RC00738                                         02S0740
@RF00738 OI    ERRORBIT,B'10000000'                             02S0740
*         ELSE                                                  02S0741
*           ;                                                   02S0741
@RF00737 DS    0H                                               02S0742
*         IF XABSVALU=ON THEN       /* IS ABSOLUTE VALUE REQUESTED?  */
@RC00737 TM    XABSVALU(DESCRPTR),B'00000100'                   02S0742
         BNO   @RF00742                                         02S0742
*           IF(APALXFSR=ON)|(APALXFSO=ON) THEN/* YES - IS IT ALLOWED?*/
         L     @04,APCWAPAL(,APCWPTR)                           02S0743
         TM    APALXFSR(@04),B'00011000'                        02S0743
         BZ    @RF00743                                         02S0743
*             APCIAFP2=ON;          /* YES - SET ABSOLUTE VALUE BIT  */
         LA    @04,CITENTRY                                     02S0744
         OI    APCIAFP2(@04),B'01000000'                        02S0744
*           ELSE                    /* NO - ERROR                    */
*             ERRORBIT=ON;          /* FLAG IT                       */
         B     @RC00743                                         02S0745
@RF00743 OI    ERRORBIT,B'10000000'                             02S0745
*         ELSE                                                  02S0746
*           ;                                                   02S0746
@RF00742 DS    0H                                               02S0747
*         IF XFXPTTRU=ON THEN       /* IS FIXED POINT SIGNED TRUE
*                                      REQUESTED?                    */
@RC00742 TM    XFXPTTRU(DESCRPTR),B'00000010'                   02S0747
         BNO   @RF00747                                         02S0747
*           IF APALXFFT=ON THEN     /* YES - IS IT ALLOWED?          */
         L     @04,APCWAPAL(,APCWPTR)                           02S0748
         TM    APALXFFT(@04),B'00100000'                        02S0748
         BNO   @RF00748                                         02S0748
*             APCIAST2=ON;          /* YES - SET BIT IN CIT          */
         LA    @04,CITENTRY                                     02S0749
         OI    APCIAST2(@04),B'00000100'                        02S0749
*           ELSE                    /* NO - ERROR                    */
*             ERRORBIT=ON;          /* FLAG IT                       */
         B     @RC00748                                         02S0750
@RF00748 OI    ERRORBIT,B'10000000'                             02S0750
*         ELSE                                                  02S0751
*           ;                                                   02S0751
@RF00747 DS    0H                                               02S0752
*         IF XFXPTTWO=ON THEN       /* IS FIXED POINT TWO'S     02S0752
*                                      COMPLEMENT REQUESTED?         */
@RC00747 TM    XFXPTTWO(DESCRPTR),B'00000001'                   02S0752
         BNO   @RF00752                                         02S0752
*           IF APALXFFX=ON THEN     /* YES - IS IT ALLOWED?          */
         L     @04,APCWAPAL(,APCWPTR)                           02S0753
         TM    APALXFFX(@04),B'01000000'                        02S0753
         BNO   @RF00753                                         02S0753
*             APCIATC2=ON;          /* YES - SET BIT IN CIT          */
         LA    @04,CITENTRY                                     02S0754
         OI    APCIATC2(@04),B'00001000'                        02S0754
*           ELSE                    /* NO - ERROR                    */
*             ERRORBIT=ON;          /* FLAG IT                       */
         B     @RC00753                                         02S0755
@RF00753 OI    ERRORBIT,B'10000000'                             02S0755
*         ELSE                                                  02S0756
*           ;                                                   02S0756
@RF00752 DS    0H                                               02S0757
*         IF(APALXFFT=ON)|(APALXFFX=ON) THEN/* IS FIXED - PT REQD?   */
@RC00752 L     @04,APCWAPAL(,APCWPTR)                           02S0757
         TM    APALXFFT(@04),B'01100000'                        02S0757
         BZ    @RF00757                                         02S0757
*           IF(XFXPTTRU=OFF)&(XFXPTTWO=OFF) THEN/* YES - IS IT SET?  */
         TM    XFXPTTRU(DESCRPTR),B'00000011'                   02S0758
         BNZ   @RF00758                                         02S0758
*             ERRORBIT=ON;          /* NO - ERROR                    */
         OI    ERRORBIT,B'10000000'                             02S0759
*           ELSE                                                02S0760
*             ;                     /* FX-PT REQD AND SET            */
@RF00758 DS    0H                                               02S0761
*         ELSE                                                  02S0761
*           ;                       /* FX-PT NOT REQD                */
@RF00757 DS    0H                                               02S0762
*         IF XSTARTDX=ON THEN       /* IS USE OF A START INDEX  02S0762
*                                      SPECIFIED?                    */
         TM    XSTARTDX(DESCRPTR),B'00100000'                   02S0762
         BNO   @RF00762                                         02S0762
*           IF APALXFXS=ON THEN     /* YES - IS IT ALLOWED?          */
         L     @04,APCWAPAL(,APCWPTR)                           02S0763
         TM    APALXFXS(@04),B'00000100'                        02S0763
         BNO   @RF00763                                         02S0763
*             IF(XARRVX>=0)&(XARRVX<=15) THEN/* YES - VALID?         */
         L     @04,XARRVX(,DESCRPTR)                            02S0764
         LTR   @04,@04                                          02S0764
         BM    @RF00764                                         02S0764
         C     @04,@CF00176                                     02S0764
         BH    @RF00764                                         02S0764
*               APCIAXB2=XARRVX;    /* YES - MOVE IT TO CIT          */
         LA    @03,CITENTRY                                     02S0765
         STH   @04,APCIAXB2(,@03)                               02S0765
*             ELSE                  /* ERROR - OUT OF RANGE          */
*               DO;                 /* SET ERRINDS                   */
         B     @RC00764                                         02S0766
@RF00764 DS    0H                                               02S0767
*                 APCWRCN=APCCA006; /* ERR NUMBER                    */
         MVI   APCWRCN(APCWPTR),X'06'                           02S0767
*                 APEMMSGN=APCMA006;/* MSG NUMBER                    */
         LA    @09,112                                          02S0768
         ALR   @09,APCWPTR                                      02S0768
         MVC   APEMMSGN(4,@09),@CF00156                         02S0768
*                 APEMVALN=APCMK027;/* SET KYWD NBR - XARRVX         */
         MVC   APEMVALN(4,@09),@CF00196                         02S0769
*                 GOTO OUTERR;      /* GO SET COMMON ERR INDS        */
         B     OUTERR                                           02S0770
*               END;                                            02S0771
*           ELSE                    /* NO - ERROR                    */
*             ERRORBIT=ON;          /* FLAG IT                       */
         B     @RC00763                                         02S0772
@RF00763 OI    ERRORBIT,B'10000000'                             02S0772
*         ELSE                                                  02S0773
*           ;                                                   02S0773
@RF00762 DS    0H                                               02S0774
*         IF XCOUNTDX=ON THEN       /* IS USE OF A COUNT INDEX  02S0774
*                                      SPECIFIED?                    */
@RC00762 TM    XCOUNTDX(DESCRPTR),B'01000000'                   02S0774
         BNO   @RF00774                                         02S0774
*           IF APALXFXC=ON THEN     /* YES - IS IT ALLOWED?          */
         L     @04,APCWAPAL(,APCWPTR)                           02S0775
         TM    APALXFXC(@04),B'00000010'                        02S0775
         BNO   @RF00775                                         02S0775
*             IF(ICTXX>=0)&(ICTXX<=15) THEN/* YES - VALID?           */
         L     @04,ICTXX(,DESCRPTR)                             02S0776
         LTR   @04,@04                                          02S0776
         BM    @RF00776                                         02S0776
         C     @04,@CF00176                                     02S0776
         BH    @RF00776                                         02S0776
*               APCIAXN2=ICTXX;     /* YES - MOVE IT TO CIT          */
         LA    @03,CITENTRY                                     02S0777
         STH   @04,APCIAXN2(,@03)                               02S0777
*             ELSE                  /* NO - ERROR - OUT OF RANGE     */
*               DO;                 /* SET ERR INDS                  */
         B     @RC00776                                         02S0778
@RF00776 DS    0H                                               02S0779
*                 APCWRCN=APCCA007; /* ERROR NUMBER                  */
         MVI   APCWRCN(APCWPTR),X'07'                           02S0779
*                 APEMMSGN=APCMA007;/* MSG NUMBER                    */
         LA    @09,112                                          02S0780
         ALR   @09,APCWPTR                                      02S0780
         MVC   APEMMSGN(4,@09),@CF00156                         02S0780
*                 APEMVALN=APCMK028;/* KYWD NUMBER - ICTXX           */
         MVC   APEMVALN(4,@09),@CF00198                         02S0781
*                 GOTO OUTERR;      /* GO SET COMMON ERR INDS        */
         B     OUTERR                                           02S0782
*               END;                                            02S0783
*           ELSE                    /* NO - ERROR                    */
*             ERRORBIT=ON;          /* FLAG IT                       */
         B     @RC00775                                         02S0784
@RF00775 OI    ERRORBIT,B'10000000'                             02S0784
*         ELSE                                                  02S0785
*           ;                                                   02S0785
@RF00774 DS    0H                                               02S0786
*         IF XDELTADX=ON THEN       /* IS USE OF A SPACING INDEX     */
*                                                               02S0786
@RC00774 TM    XDELTADX(DESCRPTR),B'10000000'                   02S0786
         BNO   @RF00786                                         02S0786
*           /*********************************************************/
*           /*                                                       */
*           /* SPECIFIED?                                            */
*           /*                                                       */
*           /*********************************************************/
*                                                               02S0787
*           IF APALXFXD=ON THEN     /* YES - IS IT ALLOWED?          */
         L     @04,APCWAPAL(,APCWPTR)                           02S0787
         TM    APALXFXD(@04),B'00000001'                        02S0787
         BNO   @RF00787                                         02S0787
*             IF(IDLXX>=0)&(IDLXX<=15) THEN/* YES - VALID?           */
         L     @04,IDLXX(,DESCRPTR)                             02S0788
         LTR   @04,@04                                          02S0788
         BM    @RF00788                                         02S0788
         C     @04,@CF00176                                     02S0788
         BH    @RF00788                                         02S0788
*               APCIAXD2=IDLXX;     /* YES - MOVE IT TO CIT          */
         LA    @03,CITENTRY                                     02S0789
         STH   @04,APCIAXD2(,@03)                               02S0789
*             ELSE                  /* NO - ERROR - OUT OF RANGE     */
*               DO;                                             02S0790
         B     @RC00788                                         02S0790
@RF00788 DS    0H                                               02S0791
*                 APCWRCN=APCCA008; /* ERROR NUMBER                  */
         MVI   APCWRCN(APCWPTR),X'08'                           02S0791
*                 APEMMSGN=APCMA008;/* MSG NUMBER                    */
         LA    @09,112                                          02S0792
         ALR   @09,APCWPTR                                      02S0792
         MVC   APEMMSGN(4,@09),@CF00156                         02S0792
*                 APEMVALN=APCMK029;/* KYWD NUMBER - IDLXX           */
         MVC   APEMVALN(4,@09),@CF00200                         02S0793
*                 GOTO OUTERR;      /* GO SET COMMON ERR INDS        */
         B     OUTERR                                           02S0794
*               END;                                            02S0795
*           ELSE                    /* NO - ERROR                    */
*             ERRORBIT=ON;          /* FLAG IT                       */
         B     @RC00787                                         02S0796
@RF00787 OI    ERRORBIT,B'10000000'                             02S0796
*         ELSE                                                  02S0797
*           ;                                                   02S0797
@RF00786 DS    0H                                               02S0798
*         IF ERRORBIT=ON THEN       /* TEST IF ERROR IN IFMX         */
@RC00786 TM    ERRORBIT,B'10000000'                             02S0798
         BNO   @RF00798                                         02S0798
*           DO;                     /* YES - ERROR - INVALID VALUE   */
*             APCWRCN=APCCA013;     /* ERROR NUMBER                  */
         MVI   APCWRCN(APCWPTR),X'0D'                           02S0800
*             APEMMSGN=APCMA013;    /* MESSAGE NUMBER                */
         LA    @09,112                                          02S0801
         ALR   @09,APCWPTR                                      02S0801
         MVC   APEMMSGN(4,@09),@CF00170                         02S0801
*             APEMVALN=APCMK023;    /* KYWD NUMBER - IFMX            */
         MVC   APEMVALN(4,@09),@CF00190                         02S0802
*             GOTO OUTERR;          /* GO SET COMMON ERR INDS        */
         B     OUTERR                                           02S0803
*           END;                                                02S0804
*         ELSE                                                  02S0805
*           ;                                                   02S0805
@RF00798 DS    0H                                               02S0806
*       END;                                                    02S0806
*     ELSE                                                      02S0807
*       ;                                                       02S0807
@RF00704 DS    0H                                               02S0808
*     IF NUMVECS>=3 THEN            /* TEST IF U VECTOR REQUIRED     */
*                                                               02S0808
         C     NUMVECS,@CF00156                                 02S0808
         BL    @RF00808                                         02S0808
*       /*************************************************************/
*       /*                                                           */
*       /* MOVE U VECTOR ELEMENTS TO CIT                             */
*       /*                                                           */
*       /*************************************************************/
*                                                               02S0809
*       DO;                                                     02S0809
*         APCIABS3=UARRV;           /* MOVE UARRV TO CIT WORKAREA    */
         LA    @09,CITENTRY                                     02S0810
         L     @04,UARRV(,DESCRPTR)                             02S0810
         ST    @04,APCIABS3(,@09)                               02S0810
*         IF(APALUDOP=ON)|(APALUDRQ=ON) THEN/* IS USER ALLOWED TO
*                                      SPECIFY IDLU                  */
         L     @09,APCWAPAL(,APCWPTR)                           02S0811
         TM    APALUDOP(@09),B'11000000'                        02S0811
         BZ    @RF00811                                         02S0811
*           IF(IDLU<-32768)|        /* IDLU MUST BE IN RANGE @ZA25370*/
*               (IDLU>65536) THEN   /* -32768 <-> +65536.    @ZA25370*/
         L     @09,IDLU(,DESCRPTR)                              02S0812
         C     @09,@CF01788                                     02S0812
         BL    @RT00812                                         02S0812
         C     @09,@CF01789                                     02S0812
         BNH   @RF00812                                         02S0812
@RT00812 DS    0H                                               02S0813
*             DO;                   /* IDLU IN ERROR - SET ERROR
*                                      INDICATORS FOR IDLU OUT OF
*                                      RANGE                         */
*               APCWRCN=APCCA029;   /* SET RETURN CODE NO. FOR IDLU
*                                      OUT OF RANGE                  */
         MVI   APCWRCN(APCWPTR),X'1D'                           02S0814
*               APEMMSGN=APCMA029;  /* SET MSG. NO. FOR OUT OF RANGE */
         LA    @09,112                                          02S0815
         ALR   @09,APCWPTR                                      02S0815
         MVC   APEMMSGN(4,@09),@CF00156                         02S0815
*               APEMVALN=APCMK033;  /* SET KYWD. NO. FOR IDLU        */
         MVC   APEMVALN(4,@09),@CF00262                         02S0816
*               GOTO OUTERR;        /* OUTERR SETS COMMON ERROR FLAGS
*                                      AND VALUES AND RETURNS        */
         B     OUTERR                                           02S0817
*             END;                  /* END OF IDLU ERROR PROCESSING  */
*           ELSE                    /* IDLU IS OK                    */
*             APCIADL3=IDLU;        /* MOVE IDLU TO WORKING CIT ENTRY*/
@RF00812 LA    @09,CITENTRY                                     02S0819
         L     @04,IDLU(,DESCRPTR)                              02S0819
         STH   @04,APCIADL3(,@09)                               02S0819
*         ELSE                                                  02S0820
*           APCIADL3=1;             /* NO - SUPPLY DEFAULT           */
         B     @RC00811                                         02S0820
@RF00811 LA    @09,CITENTRY                                     02S0820
         MVC   APCIADL3(2,@09),@CH00045                         02S0820
*         IF(APALUCOP=ON)|(APALUCRQ=ON) THEN/* IS USER ALLOWED TO
*                                      SUPPLY COUNT?                 */
@RC00811 L     @09,APCWAPAL(,APCWPTR)                           02S0821
         TM    APALUCOP(@09),B'11000000'                        02S0821
         BZ    @RF00821                                         02S0821
*           IF(ICTU<-32768)|        /* ICTU MUST BE IN RANGE @ZA25370*/
*               (ICTU>65536) THEN   /* -32768 <-> +65536.    @ZA25370*/
         L     @09,ICTU(,DESCRPTR)                              02S0822
         C     @09,@CF01788                                     02S0822
         BL    @RT00822                                         02S0822
         C     @09,@CF01789                                     02S0822
         BNH   @RF00822                                         02S0822
@RT00822 DS    0H                                               02S0823
*             DO;                   /* ICTU IN ERROR - SET ERROR
*                                      INDICATORS FOR ICTU OUT OF
*                                      RANGE                         */
*               APCWRCN=APCCA026;   /* SET RETURN CODE NO. FOR ICTU
*                                      OUT OF RANGE                  */
         MVI   APCWRCN(APCWPTR),X'1A'                           02S0824
*               APEMMSGN=APCMA026;  /* SET MSG. NO. FOR OUT OF RANGE */
         LA    @09,112                                          02S0825
         ALR   @09,APCWPTR                                      02S0825
         MVC   APEMMSGN(4,@09),@CF00156                         02S0825
*               APEMVALN=APCMK032;  /* SET KYWD. NO. FOR ICTU        */
         MVC   APEMVALN(4,@09),@CF00260                         02S0826
*               GOTO OUTERR;        /* OUTERR SETS COMMON ERROR FLAGS
*                                      AND VALUES AND RETURNS        */
         B     OUTERR                                           02S0827
*             END;                  /* END OF ICTU ERROR PROCESSING  */
*           ELSE                    /* ICTU IS OK                    */
*             APCIANB3=ICTU;        /* MOVE ICTU TO WORKING CIT ENTRY*/
@RF00822 LA    @09,CITENTRY                                     02S0829
         L     @04,ICTU(,DESCRPTR)                              02S0829
         STH   @04,APCIANB3(,@09)                               02S0829
*         ELSE                                                  02S0830
*           IF APALUCSD=ON THEN     /* NO - IS DEFAULT IN APAL?      */
         B     @RC00821                                         02S0830
@RF00821 L     @09,APCWAPAL(,APCWPTR)                           02S0830
         TM    APALUCSD(@09),B'00000001'                        02S0830
         BNO   @RF00830                                         02S0830
*             APCIANB3=APALUCNT;    /* YES - MOVE IT TO CIT          */
         LA    @04,CITENTRY                                     02S0831
         LH    @09,APALUCNT(,@09)                               02S0831
         STH   @09,APCIANB3(,@04)                               02S0831
*           ELSE                                                02S0832
*             DO;                   /* SET U COUNT TO VALUE OF X
*                                      COUNT                         */
         B     @RC00830                                         02S0832
@RF00830 DS    0H                                               02S0833
*               APCIANB3=APCIANB2;  /* ICTU = ICTX                   */
         LA    @09,CITENTRY                                     02S0833
         LH    @04,APCIANB2(,@09)                               02S0833
         STH   @04,APCIANB3(,@09)                               02S0833
*               APCIAXN3=APCIAXN2;  /* MUST ALSO USE SAME INDEX      */
         LH    @04,APCIAXN2(,@09)                               02S0834
         STH   @04,APCIAXN3(,@09)                               02S0834
*             END;                  /* END OF ICTU=ICTX SEGMENT      */
*         IF UNEGATIV=ON THEN       /* IS FORCE NEGATIVE REQUESTED?  */
@RC00830 DS    0H                                               02S0836
@RC00821 TM    UNEGATIV(DESCRPTR),B'00010000'                   02S0836
         BNO   @RF00836                                         02S0836
*           IF(APALUFSR=ON)|(APALUFSO=ON) THEN/* YES - IS IT ALLOWED?*/
         L     @09,APCWAPAL(,APCWPTR)                           02S0837
         TM    APALUFSR(@09),B'00011000'                        02S0837
         BZ    @RF00837                                         02S0837
*             APCIAFN3=ON;          /* YES - SET BIT IN CIT          */
         LA    @09,CITENTRY                                     02S0838
         OI    APCIAFN3(@09),B'00100000'                        02S0838
*           ELSE                    /* NO - ERROR                    */
*             ERRORBIT=ON;          /* FLAG IT                       */
         B     @RC00837                                         02S0839
@RF00837 OI    ERRORBIT,B'10000000'                             02S0839
*         ELSE                                                  02S0840
*           ;                                                   02S0840
@RF00836 DS    0H                                               02S0841
*         IF UREVERSE=ON THEN       /* IS REVERSE SIGN REQUESTED?    */
@RC00836 TM    UREVERSE(DESCRPTR),B'00001000'                   02S0841
         BNO   @RF00841                                         02S0841
*           IF(APALUFSR=ON)|(APALUFSO=ON) THEN/* YES - IS IT ALLOWED?*/
         L     @09,APCWAPAL(,APCWPTR)                           02S0842
         TM    APALUFSR(@09),B'00011000'                        02S0842
         BZ    @RF00842                                         02S0842
*             APCIARS3=ON;          /* YES - SET BIT IN CIT          */
         LA    @09,CITENTRY                                     02S0843
         OI    APCIARS3(@09),B'10000000'                        02S0843
*           ELSE                    /* NO - ERROR                    */
*             ERRORBIT=ON;          /* FLAG IT                       */
         B     @RC00842                                         02S0844
@RF00842 OI    ERRORBIT,B'10000000'                             02S0844
*         ELSE                                                  02S0845
*           ;                                                   02S0845
@RF00841 DS    0H                                               02S0846
*         IF UABSVALU=ON THEN       /* IS ABSOLUTE VALUE REQUESTED?  */
@RC00841 TM    UABSVALU(DESCRPTR),B'00000100'                   02S0846
         BNO   @RF00846                                         02S0846
*           IF(APALUFSR=ON)|(APALUFSO=ON) THEN/* YES - IS IT ALLOWED?*/
         L     @09,APCWAPAL(,APCWPTR)                           02S0847
         TM    APALUFSR(@09),B'00011000'                        02S0847
         BZ    @RF00847                                         02S0847
*             APCIAFP3=ON;          /* YES - SET BIT IN CIT          */
         LA    @09,CITENTRY                                     02S0848
         OI    APCIAFP3(@09),B'01000000'                        02S0848
*           ELSE                    /* NO - ERROR                    */
*             ERRORBIT=ON;          /* FLAG IT                       */
         B     @RC00847                                         02S0849
@RF00847 OI    ERRORBIT,B'10000000'                             02S0849
*         ELSE                                                  02S0850
*           ;                                                   02S0850
@RF00846 DS    0H                                               02S0851
*         IF UFXPTTRU=ON THEN       /* IS FIXED POINT SIGNED TRUE
*                                      REQUESTED?                    */
@RC00846 TM    UFXPTTRU(DESCRPTR),B'00000010'                   02S0851
         BNO   @RF00851                                         02S0851
*           IF APALUFFT=ON THEN     /* YES - IS IT ALLOWED?          */
         L     @09,APCWAPAL(,APCWPTR)                           02S0852
         TM    APALUFFT(@09),B'00100000'                        02S0852
         BNO   @RF00852                                         02S0852
*             APCIAST3=ON;          /* YES - SET BIT IN CIT          */
         LA    @09,CITENTRY                                     02S0853
         OI    APCIAST3(@09),B'00000100'                        02S0853
*           ELSE                    /* NO - ERROR                    */
*             ERRORBIT=ON;          /* FLAG IT                       */
         B     @RC00852                                         02S0854
@RF00852 OI    ERRORBIT,B'10000000'                             02S0854
*         ELSE                                                  02S0855
*           ;                                                   02S0855
@RF00851 DS    0H                                               02S0856
*         IF UFXPTTWO=ON THEN       /* IS FIXED POINT TWO'S     02S0856
*                                      COMPLEMENT REQUESTED?         */
@RC00851 TM    UFXPTTWO(DESCRPTR),B'00000001'                   02S0856
         BNO   @RF00856                                         02S0856
*           IF APALUFFX=ON THEN     /* YES - IS IT ALLOWED?          */
         L     @09,APCWAPAL(,APCWPTR)                           02S0857
         TM    APALUFFX(@09),B'01000000'                        02S0857
         BNO   @RF00857                                         02S0857
*             APCIATC3=ON;          /* YES - SET BIT IN CIT          */
         LA    @09,CITENTRY                                     02S0858
         OI    APCIATC3(@09),B'00001000'                        02S0858
*           ELSE                    /* NO - ERROR                    */
*             ERRORBIT=ON;          /* FLAG IT                       */
         B     @RC00857                                         02S0859
@RF00857 OI    ERRORBIT,B'10000000'                             02S0859
*         ELSE                                                  02S0860
*           ;                                                   02S0860
@RF00856 DS    0H                                               02S0861
*         IF(APALUFFT=ON)|(APALUFFX=ON) THEN/* IS FIXED - PT REQD?   */
@RC00856 L     @09,APCWAPAL(,APCWPTR)                           02S0861
         TM    APALUFFT(@09),B'01100000'                        02S0861
         BZ    @RF00861                                         02S0861
*           IF(UFXPTTRU=OFF)&(UFXPTTWO=OFF) THEN/* YES - IS IT SET?  */
         TM    UFXPTTRU(DESCRPTR),B'00000011'                   02S0862
         BNZ   @RF00862                                         02S0862
*             ERRORBIT=ON;          /* NO - ERROR                    */
         OI    ERRORBIT,B'10000000'                             02S0863
*           ELSE                                                02S0864
*             ;                     /* FX-PT REQD AND SET            */
@RF00862 DS    0H                                               02S0865
*         ELSE                                                  02S0865
*           ;                       /* FX-PT NOT REQD                */
@RF00861 DS    0H                                               02S0866
*         IF USTARTDX=ON THEN       /* IS USE OF A START INDEX  02S0866
*                                      SPECIFIED?                    */
         TM    USTARTDX(DESCRPTR),B'00100000'                   02S0866
         BNO   @RF00866                                         02S0866
*           IF APALUFXS=ON THEN     /* YES - IS IT ALLOWED?          */
         L     @09,APCWAPAL(,APCWPTR)                           02S0867
         TM    APALUFXS(@09),B'00000100'                        02S0867
         BNO   @RF00867                                         02S0867
*             IF(UARRVX>=0)&(UARRVX<=15) THEN/* YES - VALID?         */
         L     @09,UARRVX(,DESCRPTR)                            02S0868
         LTR   @09,@09                                          02S0868
         BM    @RF00868                                         02S0868
         C     @09,@CF00176                                     02S0868
         BH    @RF00868                                         02S0868
*               APCIAXB3=UARRVX;    /* YES - MOVE IT TO CIT          */
         LA    @04,CITENTRY                                     02S0869
         STH   @09,APCIAXB3(,@04)                               02S0869
*             ELSE                  /* NO - ERROR - OUT OF RANGE     */
*               DO;                 /* SET ERR INDS                  */
         B     @RC00868                                         02S0870
@RF00868 DS    0H                                               02S0871
*                 APCWRCN=APCCA009; /* ERROR NUMBER                  */
         MVI   APCWRCN(APCWPTR),X'09'                           02S0871
*                 APEMMSGN=APCMA009;/* MESSAGE NUMBER                */
         LA    @09,112                                          02S0872
         ALR   @09,APCWPTR                                      02S0872
         MVC   APEMMSGN(4,@09),@CF00156                         02S0872
*                 APEMVALN=APCMK034;/* KYWD NUMBER - UARRVX          */
         MVC   APEMVALN(4,@09),@CF00264                         02S0873
*                 GOTO OUTERR;      /* GO SET COMMON ERR INDS        */
         B     OUTERR                                           02S0874
*               END;                                            02S0875
*           ELSE                    /* NO - ERROR                    */
*             ERRORBIT=ON;          /* FLAG IT                       */
         B     @RC00867                                         02S0876
@RF00867 OI    ERRORBIT,B'10000000'                             02S0876
*         ELSE                                                  02S0877
*           ;                                                   02S0877
@RF00866 DS    0H                                               02S0878
*         IF UCOUNTDX=ON THEN       /* IS USE OF A COUNT INDEX  02S0878
*                                      SPECIFIED?                    */
@RC00866 TM    UCOUNTDX(DESCRPTR),B'01000000'                   02S0878
         BNO   @RF00878                                         02S0878
*           IF APALUFXC=ON THEN     /* YES - IS IT ALLOWED?          */
         L     @09,APCWAPAL(,APCWPTR)                           02S0879
         TM    APALUFXC(@09),B'00000010'                        02S0879
         BNO   @RF00879                                         02S0879
*             IF(ICTUX>=0)&(ICTUX<=15) THEN/* YES - VALID?           */
         L     @09,ICTUX(,DESCRPTR)                             02S0880
         LTR   @09,@09                                          02S0880
         BM    @RF00880                                         02S0880
         C     @09,@CF00176                                     02S0880
         BH    @RF00880                                         02S0880
*               APCIAXN3=ICTUX;     /* YES - MOVE IT TO CIT          */
         LA    @04,CITENTRY                                     02S0881
         STH   @09,APCIAXN3(,@04)                               02S0881
*             ELSE                  /* NO - ERROR - OUT OF RANGE     */
*               DO;                 /* SET ERR INDS                  */
         B     @RC00880                                         02S0882
@RF00880 DS    0H                                               02S0883
*                 APCWRCN=APCCA010; /* ERROR NUMBER                  */
         MVI   APCWRCN(APCWPTR),X'0A'                           02S0883
*                 APEMMSGN=APCMA010;/* MESSAGE NUMBER                */
         LA    @09,112                                          02S0884
         ALR   @09,APCWPTR                                      02S0884
         MVC   APEMMSGN(4,@09),@CF00156                         02S0884
*                 APEMVALN=APCMK035;/* KYWD NUMBER - ICTUX           */
         MVC   APEMVALN(4,@09),@CF00266                         02S0885
*                 GOTO OUTERR;      /* GO SET COMMON ERR INDS        */
         B     OUTERR                                           02S0886
*               END;                                            02S0887
*           ELSE                    /* NO - ERROR                    */
*             ERRORBIT=ON;          /* FLAG IT                       */
         B     @RC00879                                         02S0888
@RF00879 OI    ERRORBIT,B'10000000'                             02S0888
*         ELSE                                                  02S0889
*           ;                                                   02S0889
@RF00878 DS    0H                                               02S0890
*         IF UDELTADX=ON THEN       /* IS USE OF A SPACING INDEX
*                                      SPECIFIED?                    */
@RC00878 TM    UDELTADX(DESCRPTR),B'10000000'                   02S0890
         BNO   @RF00890                                         02S0890
*           IF APALUFXD=ON THEN     /* YES - IS IT ALLOWED?          */
         L     @09,APCWAPAL(,APCWPTR)                           02S0891
         TM    APALUFXD(@09),B'00000001'                        02S0891
         BNO   @RF00891                                         02S0891
*             IF(IDLUX>=0)&(IDLUX<=15) THEN/* YES - VALID?           */
         L     @09,IDLUX(,DESCRPTR)                             02S0892
         LTR   @09,@09                                          02S0892
         BM    @RF00892                                         02S0892
         C     @09,@CF00176                                     02S0892
         BH    @RF00892                                         02S0892
*               APCIAXD3=IDLUX;     /* YES - MOVE IT TO CIT          */
         LA    @04,CITENTRY                                     02S0893
         STH   @09,APCIAXD3(,@04)                               02S0893
*             ELSE                  /* NO - ERROR - OUT OF RANGE     */
*               DO;                 /* SET ERR INDS                  */
         B     @RC00892                                         02S0894
@RF00892 DS    0H                                               02S0895
*                 APCWRCN=APCCA011; /* ERROR NUMBER                  */
         MVI   APCWRCN(APCWPTR),X'0B'                           02S0895
*                 APEMMSGN=APCMA011;/* MESSAGE NUMBER                */
         LA    @09,112                                          02S0896
         ALR   @09,APCWPTR                                      02S0896
         MVC   APEMMSGN(4,@09),@CF00156                         02S0896
*                 APEMVALN=APCMK036;/* KYWD NUMBER - IDLUX           */
         MVC   APEMVALN(4,@09),@CF00268                         02S0897
*                 GOTO OUTERR;      /* GO SET COMMON ERR INDS        */
         B     OUTERR                                           02S0898
*               END;                                            02S0899
*           ELSE                    /* NO - ERROR                    */
*             ERRORBIT=ON;          /* FLAG IT                       */
         B     @RC00891                                         02S0900
@RF00891 OI    ERRORBIT,B'10000000'                             02S0900
*         ELSE                                                  02S0901
*           ;                                                   02S0901
@RF00890 DS    0H                                               02S0902
*         IF ERRORBIT=ON THEN       /* TEST IF ERROR IN IFMU         */
@RC00890 TM    ERRORBIT,B'10000000'                             02S0902
         BNO   @RF00902                                         02S0902
*           DO;                     /* YES - ERROR - INVALID VALUE   */
*             APCWRCN=APCCA014;     /* ERROR NUMBER                  */
         MVI   APCWRCN(APCWPTR),X'0E'                           02S0904
*             APEMMSGN=APCMA014;    /* MESSAGE NUMBER                */
         LA    @09,112                                          02S0905
         ALR   @09,APCWPTR                                      02S0905
         MVC   APEMMSGN(4,@09),@CF00170                         02S0905
*             APEMVALN=APCMK030;    /* KYWD NUMBER - IFMU            */
         MVC   APEMVALN(4,@09),@CF00485                         02S0906
*             GOTO OUTERR;          /* GO SET COMMON ERR INDS        */
         B     OUTERR                                           02S0907
*           END;                                                02S0908
*         ELSE                                                  02S0909
*           ;                                                   02S0909
@RF00902 DS    0H                                               02S0910
*       END;                                                    02S0910
*     ELSE                                                      02S0911
*       ;                                                       02S0911
@RF00808 DS    0H                                               02S0912
*   END;                                                        01S0912
*                                                               01S0912
*   /*****************************************************************/
*   /*                                                               */
*   /* MOVE CIT ENTRY TO USER CIT TABLE                              */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0913
*   DO;                                                         01S0913
*     CITLNGTH=APALCISZ/2;          /* CIT ENTRY SIZE - WORDS        */
         L     @09,APCWAPAL(,APCWPTR)                           01S0914
         LH    @00,APALCISZ(,@09)                               01S0914
         SRDA  @00,32                                           01S0914
         D     @00,@CF00130                                     01S0914
         ST    @01,CITLNGTH                                     01S0914
*     CALL APCVZMIC(CITENTRY,CITLNGTH,ERRORBIT);                01S0915
         LA    @09,CITENTRY                                     01S0915
         ST    @09,@AL00001                                     01S0915
         LA    @09,CITLNGTH                                     01S0915
         ST    @09,@AL00001+4                                   01S0915
         LA    @09,ERRORBIT                                     01S0915
         ST    @09,@AL00001+8                                   01S0915
         L     @15,APCTZMIC(,APCTPTR)                           01S0915
         LA    @01,@AL00001                                     01S0915
         BALR  @14,@15                                          01S0915
*     IF ERRORBIT=ON THEN           /* CIT FULL?                     */
         TM    ERRORBIT,B'10000000'                             01S0916
         BO    @RT00916                                         01S0916
*       RETURN;                                                 01S0917
*     ELSE                                                      01S0918
*       ;                                                       01S0918
*   END;                                                        01S0919
*                                                               01S0919
*   /*****************************************************************/
*   /*                                                               */
*   /* RETURN TO CALLER                                              */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0920
*   RETURN;                                                     01S0920
*                                                               01S0920
         B     @EL00001                                         01S0920
*   /*****************************************************************/
*   /*                                                               */
*   /* ERROR OUTLET                                                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0921
*OUTERR1:                                                       01S0921
*   ;                               /* INVLD NBR PARMS               */
OUTERR1  DS    0H                                               01S0922
*   DO;                             /* SET ERROR INDICATORS          */
*     APCWRCN=APCCA002;             /* SET ERR NBR                   */
         MVI   APCWRCN(APCWPTR),X'02'                           01S0923
*     APEMMSGN=APCMA002;            /* SET MSG NBR                   */
         MVC   APEMMSGN+112(4,APCWPTR),@CF00166                 01S0924
*   END;                                                        01S0925
*OUTERR:                                                        01S0926
*   ;                               /* COMMON ERR INDICATORS         */
OUTERR   DS    0H                                               01S0927
*   DO;                                                         01S0927
*     APCWZAM=ON;                   /* INDICATE ERR DETECTED         */
         OI    APCWZAM(APCWPTR),B'00000001'                     01S0928
*     APCWR15C=APCCRERR;            /* PROVIDE R15 RET CODE          */
         MVC   APCWR15C(4,APCWPTR),@CF00145                     01S0929
*     APCWRCT=APCCTLOG;             /* SET ERR TYPE AS LOGICAL       */
         MVI   APCWRCT(APCWPTR),X'08'                           01S0930
*     APCWRCC=APCCA;                /* SET COMPONENT ID              */
         MVI   APCWRCC(APCWPTR),X'01'                           01S0931
*     RETURN;                       /* RETURN TO CALLER              */
         B     @EL00001                                         01S0932
*   END;                                                        01S0933
*                                   /* IGTXEPLG                      */
*                                                               01S0934
*   /*****************************************************************/
*   /*                                                               */
*   /* SYSTEM DECLARES                                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0934
*   DECLARE                         /* COMMON VARIABLES              */
*     I256C CHAR(256) BASED,                                    01S0934
*     I031F FIXED(31) BASED,                                    01S0934
*     I031P PTR(31) BASED,                                      01S0934
*     I015F FIXED(15) BASED,                                    01S0934
*     I015P PTR(15) BASED,                                      01S0934
*     I008P PTR(8) BASED,                                       01S0934
*     I001C CHAR(1) BASED;                                      01S0934
*                                                               01S0935
*   /*****************************************************************/
*   /*                                                               */
*   /* MODULE PATCH AREA                                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0935
*   DCL                                                         01S0935
*     APPATCH CHAR(*) INT STATIC LOCAL GEND;                    01S0935
*   GENERATE DATA DEFS(APPATCH);                                01S0936
*                                                               01S0937
*   /*****************************************************************/
*   /*                                                               */
*   /* GENERAL REGISTER DECLARES                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0937
*   DCL                                                         01S0937
*     R0F FIXED(31) REG(0),                                     01S0937
*     R0P PTR(24) REG(0),                                       01S0937
*     R0RSTD PTR(31) REG(0),                                    01S0937
*     R1F FIXED(31) REG(1),                                     01S0937
*     R1P PTR(24) REG(1),                                       01S0937
*     R1RSTD PTR(31) REG(1),                                    01S0937
*     R2F FIXED(31) REG(2),                                     01S0937
*     R2P PTR(24) REG(2),                                       01S0937
*     R2RSTD PTR(31) REG(2),                                    01S0937
*     R3F FIXED(31) REG(3),                                     01S0937
*     R3P PTR(24) REG(3),                                       01S0937
*     R3RSTD PTR(31) REG(3),                                    01S0937
*     R4F FIXED(31) REG(4),                                     01S0937
*     R4P PTR(24) REG(4),                                       01S0937
*     R4RSTD PTR(31) REG(4),                                    01S0937
*     R5F FIXED(31) REG(5),                                     01S0937
*     R5P PTR(24) REG(5),                                       01S0937
*     R5RSTD PTR(31) REG(5),                                    01S0937
*     R6F FIXED(31) REG(6),                                     01S0937
*     R6P PTR(24) REG(6),                                       01S0937
*     R6RSTD PTR(31) REG(6),                                    01S0937
*     R7F FIXED(31) REG(7),                                     01S0937
*     R7P PTR(24) REG(7),                                       01S0937
*     R7RSTD PTR(31) REG(7),                                    01S0937
*     R8F FIXED(31) REG(8),                                     01S0937
*     R8P PTR(24) REG(8),                                       01S0937
*     R8RSTD PTR(31) REG(8),                                    01S0937
*     R9F FIXED(31) REG(9),                                     01S0937
*     R9P PTR(24) REG(9),                                       01S0937
*     R9RSTD PTR(31) REG(9),                                    01S0937
*     R10F FIXED(31) REG(10),                                   01S0937
*     R10P PTR(24) REG(10),                                     01S0937
*     R10RSTD PTR(31) REG(10),                                  01S0937
*     R11F FIXED(31) REG(11),                                   01S0937
*     R11P PTR(24) REG(11),                                     01S0937
*     R11RSTD PTR(31) REG(11),                                  01S0937
*     R12F FIXED(31) REG(12),                                   01S0937
*     R12P PTR(24) REG(12),                                     01S0937
*     R12RSTD PTR(31) REG(12),                                  01S0937
*     R13F FIXED(31) REG(13),                                   01S0937
*     R13P PTR(24) REG(13),                                     01S0937
*     R13RSTD PTR(31) REG(13),                                  01S0937
*     R14F FIXED(31) REG(14),                                   01S0937
*     R14P PTR(24) REG(14),                                     01S0937
*     R14RSTD PTR(31) REG(14),                                  01S0937
*     R15F FIXED(31) REG(15),                                   01S0937
*     R15P PTR(24) REG(15),                                     01S0937
*     R15RSTD PTR(31) REG(15),                                  01S0937
*                                                               01S0937
*     /***************************************************************/
*     /*                                                             */
*     /* VPSS CONTROL BLOCK POINTER DECLARES                         */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0937
*     APSMPTR PTR(24) REG(01),      /* STORAGE MANAGEMENT BLOCK 01S0937
*                                      (SUGGESTED POINTER)           */
*     APSCPTR PTR(24) REG(01),      /* STORAGE MANAGEMENT CONTROL
*                                      WORD (SUGGESTED POINTER)      */
*     APINPTR PTR(24) REG(01),      /* USER'S INPUT PARAMETER LIST
*                                      (SUGGESTED POINTER)           */
*/*                                                                  */
*                                                               01S0937
*     APDATA PTR(24) REG(06),       /* ADDRESS OF DYNAMIC DATA  01S0937
*                                      WORKAREA (DATAREG)            */
*     APCODE PTR(24) REG(07),       /* PROGRAM CODE BASE REGISTER
*                                      (CODEREG)                     */
*     APDEBPTR PTR(24) REG(08),     /* VPSS DEB (SUGGESTED POINTER)  */
*     APNPPTR PTR(24) REG(08),      /* SUBSYSTEM INITIALIZATION 01S0937
*                                      WORKAREA BLOCK (ONLY USED BY
*                                      SUBSYSTEM INITIALIZATION)     */
*     APRLPTR PTR(24) REG(08),      /* VPSS ACB REQUEST LIST    01S0937
*                                      (SUGGESTED POINTER)           */
*     APCIPTR PTR(24) REG(08),      /* 3838 CONTROL TABLE (SUGGESTED
*                                      POINTER)                      */
*     APCWPTR PTR(24) REG(08),      /* CALL INTERFACE WORKAREA  01S0937
*                                      (SUGGESTED POINTER)           */
*     APERPTR PTR(24) REG(08),      /* ERP/IO APPENDAGE WORKAREA
*                                      (SUGGESTED POINTER)           */
*     APACBPTR PTR(24) REG(09),     /* VPSS ACB (SUGGESTED POINTER)  */
*     APCQPTR PTR(24) REG(09),      /* COMMAND QUEUE ELEMENT    01S0937
*                                      (SUGGESTED POINTER)           */
*     APOTPTR PTR(24) REG(09),      /* OPTION TABLE (SUGGESTED  01S0937
*                                      POINTER)                      */
*     APIOPTR PTR(24) REG(10),      /* I/O ELEMENT (SUGGESTED   01S0937
*                                      POINTER)                      */
*     APEXLPTR PTR(24) REG(10),     /* VPSS EXLST (SUGGESTED POINTER)*/
*     APUBPTR PTR(24) REG(10),      /* UNIT BLOCK (SUGGESTED POINTER)*/
*     APAXPTR PTR(24) REG(10),      /* VPSS ACB EXTENSION (SUGGESTED
*                                      POINTER)                      */
*     APCPPTR PTR(24) REG(10),      /* VPSS CALL PROCESSING     01S0937
*                                      INDICATORS (SUGGESTED POINTER)*/
*     APOCPTR PTR(24) REG(10),      /* VPSS OPEN/CLOSE SUBSYSTEM
*                                      WORKAREA (REQUIRED POINTER)   */
*     APATPTR PTR(24) REG(11),      /* VPSS ACB TABLE (SUGGESTED
*                                      POINTER)                      */
*     APLBPTR PTR(24) REG(11),      /* LABEL RESOLUTION TABLE   01S0937
*                                      (SUGGESTED POINTER)           */
*     APUTPTR PTR(24) REG(11),      /* USER TABLE (SUGGESTED POINTER)*/
*     APDSPTR PTR(24) REG(11),      /* VPSS DATASET ENTRY (SUGGESTED
*                                      POINTER)                      */
*     APXLPTR PTR(24) REG(11),      /* TRANSLATION TABLE (SUGGESTED
*                                      POINTER)                      */
*     APDXPTR PTR(24) REG(11),      /* VPSS DEB EXTENSION (SUGGESTED
*                                      POINTER)                      */
*     APCTPTR PTR(24) REG(12) RSTD, /* CONTROL TABLE (REQUIRED  01S0937
*                                      POINTER)                      */
*     APSVPTR PTR(24) REG(13) RSTD, /* OS/VPSS SAVEAREA/WORKAREA
*                                      (REQUIRED POINTER)            */
*     APRETURN PTR(24) REG(14),     /* RETURN ADDRESS FOR SUBROUTINE
*                                      LINKAGE                       */
*     APENTRY PTR(24) REG(15),      /* SUBROUTINE ENTRY POINT LINKAGE*/
*     APRCODE PTR(24) REG(15);      /* CONTAINS SUBROUTINE RETURN
*                                      CODE                          */
*                                                               01S0938
*   /*****************************************************************/
*   /*                                                               */
*   /* USER REGISTER DECLARES                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0938
*   END IGTMDA                                                  01S0938
*                                                               01S0938
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IGTXAPCC)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPCM)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPCT)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPCV)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPCW)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPEM)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPIN)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPAL)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPCI)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPSV)                                       */
*/*%INCLUDE SYSUT5  (MDADESCR)                                       */
*/*%INCLUDE SYSUT5  (MDACIT  )                                       */
*                                                               01S0938
*       ;                                                       01S0938
         B     @EL00001                                         01S0938
@DATA    DS    0H
@DATD    DSECT
         DS    0F
@SA00001 DS    20F
@PC00001 DS    1F
@AL00001 DS    3A
@TF00001 DS    F
IGTMDA   CSECT
         DS    0F
@CF00045 DC    F'1'
@CH00045 EQU   @CF00045+2
@CF00130 DC    F'2'
@CF00156 DC    F'3'
@CF00142 DC    F'4'
@CF00145 DC    F'8'
@CF00166 DC    F'9'
@CF00170 DC    F'11'
@CF00147 DC    F'12'
@CF00176 DC    F'15'
@CF00178 DC    F'16'
@CF00180 DC    F'17'
@CF00074 DC    F'18'
@CF00183 DC    F'19'
@CF00185 DC    F'20'
@CF00187 DC    F'21'
@CF00055 DC    F'22'
@CF00190 DC    F'23'
@CF00061 DC    F'24'
@CF00043 DC    F'25'
@CF00194 DC    F'26'
@CF00196 DC    F'27'
@CF00198 DC    F'28'
@CF00200 DC    F'29'
@CF00485 DC    F'30'
@CF00041 DC    F'31'
@CF00260 DC    F'32'
@CF00262 DC    F'33'
@CF00264 DC    F'34'
@CF00266 DC    F'35'
@CF00268 DC    F'36'
@CF01789 DC    F'65536'
@CF01788 DC    F'-32768'
@DATD    DSECT
         DS    0D
CITLNGTH DS    F
RSOLVERR DS    F
IFMXIFMY DS    BL1
IFMUIFMX DS    BL1
ERRORBIT DS    BL1
LASTPARM DS    BL1
DESCRWRK DS    22F
CITENTRY DS    14F
IGTMDA   CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
IGTMDA   CSECT
*                                  /* GENERATE PATCH
         IGTXZAP ,                 GENERATE PATCH AREA
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IGTMDA   CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
INPUTPTR EQU   @03
DESCRPTR EQU   @02
NUMVECS  EQU   @09
APDATA   EQU   @06
APCODE   EQU   @07
R5P      EQU   @05
APCTPTR  EQU   @12
APSVPTR  EQU   @13
APCWPTR  EQU   @08
APACBPTR EQU   @09
APATPTR  EQU   @11
APAXPTR  EQU   @10
APCIPTR  EQU   @08
APCPPTR  EQU   @10
APCQPTR  EQU   @09
APDEBPTR EQU   @08
APDSPTR  EQU   @11
APDXPTR  EQU   @11
APENTRY  EQU   @15
APERPTR  EQU   @08
APEXLPTR EQU   @10
APINPTR  EQU   @01
APIOPTR  EQU   @10
APLBPTR  EQU   @11
APNPPTR  EQU   @08
APOCPTR  EQU   @10
APOTPTR  EQU   @09
APRCODE  EQU   @15
APRETURN EQU   @14
APRLPTR  EQU   @08
APSCPTR  EQU   @01
APSMPTR  EQU   @01
APUBPTR  EQU   @10
APUTPTR  EQU   @11
APXLPTR  EQU   @11
R0F      EQU   @00
R0P      EQU   @00
R0RSTD   EQU   @00
R1F      EQU   @01
R1P      EQU   @01
R1RSTD   EQU   @01
R10F     EQU   @10
R10P     EQU   @10
R10RSTD  EQU   @10
R11F     EQU   @11
R11P     EQU   @11
R11RSTD  EQU   @11
R12F     EQU   @12
R12P     EQU   @12
R12RSTD  EQU   @12
R13F     EQU   @13
R13P     EQU   @13
R13RSTD  EQU   @13
R14F     EQU   @14
R14P     EQU   @14
R14RSTD  EQU   @14
R15F     EQU   @15
R15P     EQU   @15
R15RSTD  EQU   @15
R2F      EQU   @02
R2P      EQU   @02
R2RSTD   EQU   @02
R3F      EQU   @03
R3P      EQU   @03
R3RSTD   EQU   @03
R4F      EQU   @04
R4P      EQU   @04
R4RSTD   EQU   @04
R5F      EQU   @05
R5RSTD   EQU   @05
R6F      EQU   @06
R6P      EQU   @06
R6RSTD   EQU   @06
R7F      EQU   @07
R7P      EQU   @07
R7RSTD   EQU   @07
R8F      EQU   @08
R8P      EQU   @08
R8RSTD   EQU   @08
R9F      EQU   @09
R9P      EQU   @09
R9RSTD   EQU   @09
ISTATE   EQU   0
MASKCONV EQU   ISTATE+3
MASKUFLO EQU   ISTATE+3
MASKOFLO EQU   ISTATE+3
MASKUNDV EQU   ISTATE+3
STACKING EQU   ISTATE+3
COMDESCV EQU   ISTATE+3
INCDESCV EQU   ISTATE+3
DESCRVEC EQU   0
IFMY     EQU   DESCRVEC+4
YDELTADX EQU   IFMY+3
YCOUNTDX EQU   IFMY+3
YSTARTDX EQU   IFMY+3
YNEGATIV EQU   IFMY+3
YREVERSE EQU   IFMY+3
YABSVALU EQU   IFMY+3
YFXPTTRU EQU   IFMY+3
YFXPTTWO EQU   IFMY+3
YARRV    EQU   DESCRVEC+8
ICTY     EQU   DESCRVEC+12
IDLY     EQU   DESCRVEC+16
YARRVX   EQU   DESCRVEC+20
ICTYX    EQU   DESCRVEC+24
IDLYX    EQU   DESCRVEC+28
IFMX     EQU   DESCRVEC+32
XDELTADX EQU   IFMX+3
XCOUNTDX EQU   IFMX+3
XSTARTDX EQU   IFMX+3
XNEGATIV EQU   IFMX+3
XREVERSE EQU   IFMX+3
XABSVALU EQU   IFMX+3
XFXPTTRU EQU   IFMX+3
XFXPTTWO EQU   IFMX+3
XARRV    EQU   DESCRVEC+36
ICTX     EQU   DESCRVEC+40
IDLX     EQU   DESCRVEC+44
XARRVX   EQU   DESCRVEC+48
ICTXX    EQU   DESCRVEC+52
IDLXX    EQU   DESCRVEC+56
IFMU     EQU   DESCRVEC+60
UDELTADX EQU   IFMU+3
UCOUNTDX EQU   IFMU+3
USTARTDX EQU   IFMU+3
UNEGATIV EQU   IFMU+3
UREVERSE EQU   IFMU+3
UABSVALU EQU   IFMU+3
UFXPTTRU EQU   IFMU+3
UFXPTTWO EQU   IFMU+3
UARRV    EQU   DESCRVEC+64
ICTU     EQU   DESCRVEC+68
IDLU     EQU   DESCRVEC+72
UARRVX   EQU   DESCRVEC+76
ICTUX    EQU   DESCRVEC+80
IDLUX    EQU   DESCRVEC+84
PARAM1   EQU   0
PARAM2   EQU   0
PARMSIGN EQU   0
PSIGNBIT EQU   PARMSIGN
APCT     EQU   0
APCTENQM EQU   APCT+12
APCTSMIN EQU   APCT+32
APCTSMAD EQU   APCT+36
APCTZ@@@ EQU   APCT+40
APCTU@@@ EQU   APCT+440
APCTBR14 EQU   APCT+840
APCTERRS EQU   APCT+876
@NM00020 EQU   APCT+936
APCTSTAT EQU   @NM00020
APCTPRSW EQU   @NM00020+1
APCTAPCQ EQU   APCT+944
APCTCQAQ EQU   APCT+952
APCTZ@@1 EQU   APCT+1120
APCVZMIC EQU   0
APCVZMIF EQU   0
APCW     EQU   0
APCWAPIN EQU   APCW+8
APCWACB  EQU   APCW+20
APCWAPAL EQU   APCW+40
APCWSWS  EQU   APCW+46
APCWSW0  EQU   APCWSWS
APCWOPF  EQU   APCW+62
APCWAPOP EQU   APCWOPF
APCWR15C EQU   APCW+64
APCWRCDE EQU   APCW+68
APCWRCT  EQU   APCWRCDE+1
APCWRCC  EQU   APCWRCDE+2
APCWRCN  EQU   APCWRCDE+3
APCWINTV EQU   APCW+72
APCWINT0 EQU   APCWINTV
APCWZAM  EQU   APCWINT0
APCWINT1 EQU   APCWINTV+1
APCWINT2 EQU   APCWINTV+2
APCWINT3 EQU   APCWINTV+3
APCWAPEM EQU   APCW+112
APCWEMSG EQU   APCWAPEM
APEM     EQU   0
APEMMSG  EQU   APEM+92
APEMMSGN EQU   APEMMSG
APEMVALU EQU   APEM+108
APEMVALN EQU   APEMVALU+4
APIN     EQU   0
APINAUNT EQU   APIN
APINAFNC EQU   APIN+4
APINFMTS EQU   APIN+8
APAL     EQU   0
APALCISZ EQU   APAL+4
APALDATA EQU   APAL+8
APALALG  EQU   APAL+8
APALSTAT EQU   APALALG
APALSTKR EQU   APALSTAT
APALSTKO EQU   APALSTAT
APALY    EQU   APALALG+4
APALYFSW EQU   APALY
APALYFFX EQU   APALYFSW
APALYFFT EQU   APALYFSW
APALYFSR EQU   APALYFSW
APALYFSO EQU   APALYFSW
APALYFXS EQU   APALYFSW
APALYFXC EQU   APALYFSW
APALYFXD EQU   APALYFSW
APALYVS  EQU   APALY+1
APALYCT  EQU   APALY+2
APALYCRQ EQU   APALYCT
APALYCOP EQU   APALYCT
APALYCSD EQU   APALYCT
APALYDL  EQU   APALY+3
APALYDRQ EQU   APALYDL
APALYDOP EQU   APALYDL
APALYFMT EQU   APALY+4
APALYCNT EQU   APALY+10
APALX    EQU   APALALG+16
APALXFSW EQU   APALX
APALXFFX EQU   APALXFSW
APALXFFT EQU   APALXFSW
APALXFSR EQU   APALXFSW
APALXFSO EQU   APALXFSW
APALXFXS EQU   APALXFSW
APALXFXC EQU   APALXFSW
APALXFXD EQU   APALXFSW
APALXVS  EQU   APALX+1
APALXVRQ EQU   APALXVS
APALXVOP EQU   APALXVS
APALXCT  EQU   APALX+2
APALXCRQ EQU   APALXCT
APALXCOP EQU   APALXCT
APALXCSD EQU   APALXCT
APALXDL  EQU   APALX+3
APALXDRQ EQU   APALXDL
APALXDOP EQU   APALXDL
APALXFMT EQU   APALX+4
APALXCNT EQU   APALX+10
APALU    EQU   APALALG+28
APALUFSW EQU   APALU
APALUFFX EQU   APALUFSW
APALUFFT EQU   APALUFSW
APALUFSR EQU   APALUFSW
APALUFSO EQU   APALUFSW
APALUFXS EQU   APALUFSW
APALUFXC EQU   APALUFSW
APALUFXD EQU   APALUFSW
APALUVS  EQU   APALU+1
APALUVRQ EQU   APALUVS
APALUVOP EQU   APALUVS
APALUCT  EQU   APALU+2
APALUCRQ EQU   APALUCT
APALUCOP EQU   APALUCT
APALUCSD EQU   APALUCT
APALUDL  EQU   APALU+3
APALUDRQ EQU   APALUDL
APALUDOP EQU   APALUDL
APALUFMT EQU   APALU+4
APALUCNT EQU   APALU+10
APCI     EQU   0
APCIHDR  EQU   APCI
APCIHFGS EQU   APCIHDR+2
APCIHFG0 EQU   APCIHFGS
APCIHFG1 EQU   APCIHFGS+1
APSV     EQU   0
APSVREGS EQU   APSV+12
APCVZDAL EQU   0
APCVZDAP EQU   0
APCVZDBK EQU   0
APCVZDDA EQU   0
APCVZDDQ EQU   0
APCVZDEQ EQU   0
APCVZDID EQU   0
APCVZDIO EQU   0
APCVZDIP EQU   0
APCVZDMD EQU   0
APCVZDMM EQU   0
APCVZDQR EQU   0
APCVZDRI EQU   0
APCVZDUA EQU   0
APCVZDUL EQU   0
APCVZDWI EQU   0
APCVZDWT EQU   0
APCVZDX1 EQU   0
APCVZDX2 EQU   0
APCVZDX3 EQU   0
APCVZDX4 EQU   0
APCVZD10 EQU   0
APCVZD20 EQU   0
APCVZD4E EQU   0
APCVZD40 EQU   0
APCVZD41 EQU   0
APCVZD42 EQU   0
APCVZD43 EQU   0
APCVZD44 EQU   0
APCVZD45 EQU   0
APCVZD46 EQU   0
APCVZD47 EQU   0
APCVZD48 EQU   0
APCVZD49 EQU   0
APCVZD60 EQU   0
APCVZD80 EQU   0
APCVZD81 EQU   0
APCVZD82 EQU   0
APCVZD83 EQU   0
APCVZJAA EQU   0
APCVZJAD EQU   0
APCVZJAG EQU   0
APCVZJAJ EQU   0
APCVZJAM EQU   0
APCVZJAP EQU   0
APCVZJAX EQU   0
APCVZJAY EQU   0
APCVZJBA EQU   0
APCVZJBD EQU   0
APCVZJBG EQU   0
APCVZJBJ EQU   0
APCVZJBM EQU   0
APCVZJDA EQU   0
APCVZJDD EQU   0
APCVZJDG EQU   0
APCVZJDJ EQU   0
APCVZJDM EQU   0
APCVZJHC EQU   0
APCVZJHE EQU   0
APCVZJHF EQU   0
APCVZJHO EQU   0
APCVZJHQ EQU   0
APCVZJHR EQU   0
APCVZJHT EQU   0
APCVZJHW EQU   0
APCVZJH0 EQU   0
APCVZJH6 EQU   0
APCVZJI0 EQU   0
APCVZJI3 EQU   0
APCVZJJ0 EQU   0
APCVZKAA EQU   0
APCVZKBA EQU   0
APCVZKBB EQU   0
APCVZKBC EQU   0
APCVZKBD EQU   0
APCVZKBE EQU   0
APCVZKBF EQU   0
APCVZKCA EQU   0
APCVZKDA EQU   0
APCVZKGA EQU   0
APCVZKGB EQU   0
APCVZKGC EQU   0
APCVZKGD EQU   0
APCVZLCA EQU   0
APCVZLCB EQU   0
APCVZMBA EQU   0
APCVZMBD EQU   0
APCVZMBG EQU   0
APCVZMBH EQU   0
APCVZMBK EQU   0
APCVZMBM EQU   0
APCVZMIB EQU   0
APCVZMJB EQU   0
APCVZMJC EQU   0
APCVZMJH EQU   0
APCVZMJI EQU   0
APCVZMMA EQU   0
APCVZUAA EQU   0
APCVZUAB EQU   0
APCVZUAC EQU   0
APCVZUAD EQU   0
APCVZUAE EQU   0
APCVZUAF EQU   0
APCVZUAG EQU   0
APCVZUBB EQU   0
APCVZUFA EQU   0
APCVZUHA EQU   0
APCVZUHB EQU   0
APCVZUJA EQU   0
APCVZUKA EQU   0
APCV1CMD EQU   0
APCV1JAA EQU   0
APCV1JBJ EQU   0
APCV1JHC EQU   0
APCV1JHL EQU   0
APCV1JHT EQU   0
APCV1MAB EQU   0
APCV1MBD EQU   0
APCV2JHC EQU   0
APCV2JHL EQU   0
APCV2MBD EQU   0
APINACI  EQU   0
APINACW  EQU   0
APINAPRL EQU   0
APINBIV  EQU   0
APINBLB  EQU   0
APINCHB  EQU   0
APINCHC  EQU   0
APINCHS  EQU   0
APINCHX  EQU   0
APINCXC  EQU   0
APINCXS  EQU   0
APINCXX  EQU   0
APINDLB  EQU   0
APINDSV  EQU   0
APINERR  EQU   0
APINFUNC EQU   0
APINICI  EQU   0
APINICW  EQU   0
APINKYVF EQU   0
APINKYVL EQU   0
APINKYVP EQU   0
APINKYWD EQU   0
APINPXB  EQU   0
APINPXC  EQU   0
APINPXF  EQU   0
APINPXP  EQU   0
APINSTB  EQU   0
APINSTD  EQU   0
APINUNIT EQU   0
APINUST  EQU   0
APINXBS  EQU   0
APINXBX  EQU   0
APINXCD  EQU   0
APINXCT  EQU   0
APINXID  EQU   0
APINXI1  EQU   0
APINXI2  EQU   0
APINXLB  EQU   0
APINXST  EQU   0
APINYST  EQU   0
I001C    EQU   0
I008P    EQU   0
I015F    EQU   0
I015P    EQU   0
I031F    EQU   0
I031P    EQU   0
I256C    EQU   0
DAPCW    EQU   0
APCTZ    EQU   APCTZ@@@
APCTZUAA EQU   APCTZ
APCTZUAB EQU   APCTZ+4
APCTZUAC EQU   APCTZ+8
APCTZUAD EQU   APCTZ+12
APCTZUAE EQU   APCTZ+16
APCTZUBB EQU   APCTZ+24
APCTZD10 EQU   APCTZ+28
APCTZD20 EQU   APCTZ+32
APCTZD40 EQU   APCTZ+36
APCTZD41 EQU   APCTZ+40
APCTZD42 EQU   APCTZ+44
APCTZD43 EQU   APCTZ+48
APCTZD44 EQU   APCTZ+52
APCTZD45 EQU   APCTZ+56
APCTZD46 EQU   APCTZ+60
APCTZD47 EQU   APCTZ+64
APCTZD48 EQU   APCTZ+68
APCTZD49 EQU   APCTZ+72
APCTZD60 EQU   APCTZ+76
APCTZD80 EQU   APCTZ+80
APCTZD4E EQU   APCTZ+84
APCTZMBA EQU   APCTZ+88
APCTZMBD EQU   APCTZ+92
APCTZMBG EQU   APCTZ+96
APCTZDX1 EQU   APCTZ+104
APCTZDX2 EQU   APCTZ+108
APCTZDX3 EQU   APCTZ+112
APCTZDX4 EQU   APCTZ+116
APCTZMBH EQU   APCTZ+120
APCTZMBK EQU   APCTZ+124
APCTZMBM EQU   APCTZ+128
APCTZMJB EQU   APCTZ+132
APCTZMJC EQU   APCTZ+136
APCTZMJH EQU   APCTZ+140
APCTZMMA EQU   APCTZ+144
APCTZDMD EQU   APCTZ+148
APCTZD81 EQU   APCTZ+152
APCTZDID EQU   APCTZ+156
APCTZDRI EQU   APCTZ+160
APCTZMJI EQU   APCTZ+164
APCTZDWT EQU   APCTZ+168
APCTZDMM EQU   APCTZ+172
APCTZDAL EQU   APCTZ+176
APCTZDBK EQU   APCTZ+180
APCTZDIP EQU   APCTZ+184
APCTZDDA EQU   APCTZ+188
APCTZDUL EQU   APCTZ+192
APCTZDEQ EQU   APCTZ+196
APCTZDDQ EQU   APCTZ+200
APCTZDUA EQU   APCTZ+204
APCTZUAF EQU   APCTZ+208
APCTZUAG EQU   APCTZ+212
APCTZDIO EQU   APCTZ+216
APCTZUHA EQU   APCTZ+220
APCTZUHB EQU   APCTZ+224
APCTZJAA EQU   APCTZ+232
APCTZJAD EQU   APCTZ+236
APCTZJAG EQU   APCTZ+240
APCTZJAJ EQU   APCTZ+244
APCTZJAM EQU   APCTZ+248
APCTZJAP EQU   APCTZ+252
APCTZJAY EQU   APCTZ+256
APCTZUFA EQU   APCTZ+260
APCTZUJA EQU   APCTZ+264
APCTZDAP EQU   APCTZ+268
APCTZKAA EQU   APCTZ+272
APCTZD82 EQU   APCTZ+276
APCTZMIB EQU   APCTZ+280
APCTZMIC EQU   APCTZ+284
APCTZD83 EQU   APCTZ+288
APCTZMIF EQU   APCTZ+296
APCTZJH0 EQU   APCTZ+300
APCTZJI0 EQU   APCTZ+304
APCTZJI3 EQU   APCTZ+308
APCTZJJ0 EQU   APCTZ+312
APCTZJBA EQU   APCTZ+316
APCTZJBD EQU   APCTZ+320
APCTZJBG EQU   APCTZ+324
APCTZJBJ EQU   APCTZ+328
APCTZJBM EQU   APCTZ+332
APCTZKCA EQU   APCTZ+340
APCTZKDA EQU   APCTZ+344
APCTZJDA EQU   APCTZ+356
APCTZJDJ EQU   APCTZ+360
APCTZJH6 EQU   APCTZ+364
APCTZJHO EQU   APCTZ+368
APCTZJHF EQU   APCTZ+372
APCTZJHE EQU   APCTZ+376
APCTZDQR EQU   APCTZ+380
APCTZJHR EQU   APCTZ+384
APCTZJHT EQU   APCTZ+388
APCTZJHW EQU   APCTZ+392
APCTZ1   EQU   APCTZ@@1
APCTZKBA EQU   APCTZ1
APCTZKBC EQU   APCTZ1+4
APCTZKBB EQU   APCTZ1+8
APCTZJHC EQU   APCTZ1+20
APCTZJHQ EQU   APCTZ1+24
APCTZKBD EQU   APCTZ1+28
APCTZKBE EQU   APCTZ1+40
APCTZUKA EQU   APCTZ1+56
APCTZKBF EQU   APCTZ1+60
APCTZJDD EQU   APCTZ1+64
APCTZJDG EQU   APCTZ1+68
APCTZJDM EQU   APCTZ1+72
APCTZLCA EQU   APCTZ1+76
APCTZLCB EQU   APCTZ1+80
APCTZDWI EQU   APCTZ1+84
APCTZJAX EQU   APCTZ1+88
APCTZKGA EQU   APCTZ1+92
APCTZKGB EQU   APCTZ1+96
APCTZKGC EQU   APCTZ1+100
APCTZKGD EQU   APCTZ1+104
APCTU    EQU   APCTU@@@
APCT1MAB EQU   APCTU
APCT1MBD EQU   APCTU+4
APCT2MBD EQU   APCTU+8
APCT1CMD EQU   APCTU+12
APCT1JAA EQU   APCTU+20
APCT1JHC EQU   APCTU+24
APCT2JHC EQU   APCTU+28
APCT1JHT EQU   APCTU+32
APCT1JHL EQU   APCTU+36
APCT2JHL EQU   APCTU+40
APCT1JBJ EQU   APCTU+44
APINFMT1 EQU   APINFMTS
APINAERR EQU   APINFMT1
@NM00069 EQU   APINFMT1+4
APINAKYW EQU   @NM00069
APINAKYV EQU   @NM00069+4
APINFMT2 EQU   APINFMTS
APINAAR  EQU   APINFMT2
APINFMT3 EQU   APINFMTS
APINASTB EQU   APINFMT3
APINAACW EQU   APINFMT3+4
APINAICW EQU   APINFMT3+8
APINAACI EQU   APINFMT3+12
APINAICI EQU   APINFMT3+16
APINFMT4 EQU   APINFMTS
APINAXI1 EQU   APINFMT4
APINAXI2 EQU   APINFMT4+4
APINAXLB EQU   APINFMT4+8
APINAXCD EQU   APINFMT4+12
APINFMT5 EQU   APINFMTS
APINADLB EQU   APINFMT5
APINFMT6 EQU   APINFMTS
APINABIV EQU   APINFMT6
APINABLB EQU   APINFMT6+4
APINFMT7 EQU   APINFMTS
APINACHS EQU   APINFMT7
APINACHC EQU   APINFMT7+4
APINACHB EQU   APINFMT7+8
APINACHX EQU   APINFMT7+12
APINFMT8 EQU   APINFMTS
APINACXS EQU   APINFMT8
APINACXC EQU   APINFMT8+4
APINACXX EQU   APINFMT8+8
APINFMT9 EQU   APINFMTS
APINASTD EQU   APINFMT9
APINADSV EQU   APINFMT9+4
APINAYST EQU   APINFMT9+8
APINAXST EQU   APINFMT9+12
APINAUST EQU   APINFMT9+16
APINFM10 EQU   APINFMTS
APINAXBS EQU   APINFM10
APINAXCT EQU   APINFM10+4
APINAXBX EQU   APINFM10+8
APINAXID EQU   APINFM10+12
APINAPMS EQU   APIN
APINAP1  EQU   APINAPMS
APINAP1E EQU   APINAP1
APINAP2  EQU   APINAPMS+4
APINAP2E EQU   APINAP2
APINAP3  EQU   APINAPMS+8
APINAP4  EQU   APINAPMS+12
APALLGCL EQU   APALDATA
APALLI1F EQU   APALLGCL+2
APALLI2F EQU   APALLGCL+3
APALIOXF EQU   APALDATA
APALIOTP EQU   APALIOXF
APALIOCH EQU   APALIOXF+1
@NM00103 EQU   APCI
APCIOPID EQU   @NM00103
APCIOPSZ EQU   @NM00103+2
APCIODTA EQU   @NM00103+4
APCIXDTA EQU   APCIODTA
APCIXIMM EQU   APCIXDTA+4
APCIXCC  EQU   APCIXDTA+8
APCIIDTA EQU   APCIODTA
APCIISZ  EQU   APCIIDTA+2
APCIADTA EQU   APCIODTA
APCIASO  EQU   APCIADTA
APCIASO0 EQU   APCIASO
APCIASOV EQU   APCIASO0
APCIASUF EQU   APCIASO0
APCIASUD EQU   APCIASO0
APCIASCE EQU   APCIASO0
APCIASO1 EQU   APCIASO+1
APCIASSK EQU   APCIASO1
APCIAVCT EQU   APCIADTA+4
APCIAFS  EQU   APCIAVCT+8
APCIAF0  EQU   APCIAFS
APCIAF1  EQU   APCIAFS+1
@NM00110 EQU   APCIAVCT
APCIAV1  EQU   @NM00110
APCIABS1 EQU   APCIAV1
APCIADL1 EQU   APCIAV1+4
APCIANB1 EQU   APCIAV1+6
APCIAFS1 EQU   APCIAV1+8
APCIAF01 EQU   APCIAFS1
APCIARS1 EQU   APCIAF01
APCIAFP1 EQU   APCIAF01
APCIAFN1 EQU   APCIAF01
APCIATC1 EQU   APCIAF01
APCIAST1 EQU   APCIAF01
APCIAF11 EQU   APCIAFS1+1
APCIAXB1 EQU   APCIAV1+10
APCIAXD1 EQU   APCIAV1+12
APCIAXN1 EQU   APCIAV1+14
APCIAV2  EQU   @NM00110+16
APCIABS2 EQU   APCIAV2
APCIADL2 EQU   APCIAV2+4
APCIANB2 EQU   APCIAV2+6
APCIAFS2 EQU   APCIAV2+8
APCIAF02 EQU   APCIAFS2
APCIARS2 EQU   APCIAF02
APCIAFP2 EQU   APCIAF02
APCIAFN2 EQU   APCIAF02
APCIATC2 EQU   APCIAF02
APCIAST2 EQU   APCIAF02
APCIAF12 EQU   APCIAFS2+1
APCIAXB2 EQU   APCIAV2+10
APCIAXD2 EQU   APCIAV2+12
APCIAXN2 EQU   APCIAV2+14
APCIAV3  EQU   @NM00110+32
APCIABS3 EQU   APCIAV3
APCIADL3 EQU   APCIAV3+4
APCIANB3 EQU   APCIAV3+6
APCIAFS3 EQU   APCIAV3+8
APCIAF03 EQU   APCIAFS3
APCIARS3 EQU   APCIAF03
APCIAFP3 EQU   APCIAF03
APCIAFN3 EQU   APCIAF03
APCIATC3 EQU   APCIAF03
APCIAST3 EQU   APCIAF03
APCIAF13 EQU   APCIAFS3+1
APCIAXB3 EQU   APCIAV3+10
APCIAXD3 EQU   APCIAV3+12
APCIAXN3 EQU   APCIAV3+14
APCIZDTA EQU   APCIODTA
APCIZV1  EQU   APCIZDTA+4
APCIZFS1 EQU   APCIZV1+8
APCIZF01 EQU   APCIZFS1
APCIZF11 EQU   APCIZFS1+1
APCIZV2  EQU   APCIZDTA+20
APCIZFS2 EQU   APCIZV2+8
APCIZF02 EQU   APCIZFS2
APCIZF12 EQU   APCIZFS2+1
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
APCIZXN2 EQU   APCIZV2+14
APCIZXD2 EQU   APCIZV2+12
APCIZXB2 EQU   APCIZV2+10
@NM00125 EQU   APCIZF12
@NM00124 EQU   APCIZF02
APCIZST2 EQU   APCIZF02
APCIZTC2 EQU   APCIZF02
@NM00123 EQU   APCIZF02
APCIZFN2 EQU   APCIZF02
APCIZFP2 EQU   APCIZF02
APCIZRS2 EQU   APCIZF02
APCIZNB2 EQU   APCIZV2+6
APCIZDL2 EQU   APCIZV2+4
APCIZBS2 EQU   APCIZV2
APCIZXN1 EQU   APCIZV1+14
APCIZXD1 EQU   APCIZV1+12
APCIZXB1 EQU   APCIZV1+10
@NM00122 EQU   APCIZF11
@NM00121 EQU   APCIZF01
APCIZST1 EQU   APCIZF01
APCIZTC1 EQU   APCIZF01
@NM00120 EQU   APCIZF01
APCIZFN1 EQU   APCIZF01
APCIZFP1 EQU   APCIZF01
APCIZRS1 EQU   APCIZF01
APCIZNB1 EQU   APCIZV1+6
APCIZDL1 EQU   APCIZV1+4
APCIZBS1 EQU   APCIZV1
APCIZX2  EQU   APCIZDTA+2
APCIZX1  EQU   APCIZDTA
@NM00119 EQU   APCIAF13
@NM00118 EQU   APCIAF03
@NM00117 EQU   APCIAF03
@NM00116 EQU   APCIAF12
@NM00115 EQU   APCIAF02
@NM00114 EQU   APCIAF02
@NM00113 EQU   APCIAF11
@NM00112 EQU   APCIAF01
@NM00111 EQU   APCIAF01
@NM00109 EQU   APCIADTA+20
APCIAXN  EQU   APCIAVCT+14
APCIAXD  EQU   APCIAVCT+12
APCIAXB  EQU   APCIAVCT+10
@NM00108 EQU   APCIAF1
@NM00107 EQU   APCIAF0
APCIASTR EQU   APCIAF0
APCIATCM EQU   APCIAF0
@NM00106 EQU   APCIAF0
APCIAFNG EQU   APCIAF0
APCIAFPS EQU   APCIAF0
APCIARSN EQU   APCIAF0
APCIANBR EQU   APCIAVCT+6
APCIADLT EQU   APCIAVCT+4
APCIABSA EQU   APCIAVCT
APCIADO  EQU   APCIADTA+2
@NM00105 EQU   APCIASO1
@NM00104 EQU   APCIASO0
APCIIBSA EQU   APCIIDTA+4
APCIIX2  EQU   APCIISZ
APCIIX   EQU   APCIIDTA
APCIXBRO EQU   APCIXDTA+10
APCIXBSX EQU   APCIXCC
APCIXBSA EQU   APCIXIMM
APCIXID2 EQU   APCIXDTA+2
APCIXID1 EQU   APCIXDTA
APCIOPCD EQU   APCIOPID+1
APCIOPTP EQU   APCIOPID
@NM00098 EQU   APALIOXF+8
@NM00097 EQU   APALIOXF+2
@NM00096 EQU   APALIOCH
APALIOWR EQU   APALIOCH
APALIORD EQU   APALIOCH
@NM00095 EQU   APALIOTP
APALIOX  EQU   APALIOTP
APALIOBS EQU   APALIOTP
@NM00094 EQU   APALLGCL+4
@NM00093 EQU   APALLI2F
APALLI2S EQU   APALLI2F
APALLI2I EQU   APALLI2F
APALLI2X EQU   APALLI2F
@NM00092 EQU   APALLI1F
APALLI1S EQU   APALLI1F
APALLI1I EQU   APALLI1F
APALLI1X EQU   APALLI1F
APALLTYP EQU   APALLGCL
APINAP4P EQU   APINAP4+1
@NM00073 EQU   APINAP4
APINAP4E EQU   APINAP4
APINAP3P EQU   APINAP3+1
@NM00072 EQU   APINAP3
APINAP3E EQU   APINAP3
APINAP2P EQU   APINAP2+1
@NM00071 EQU   APINAP2
APINAP1P EQU   APINAP1+1
@NM00070 EQU   APINAP1
@NM00052 EQU   APCTU+48
APCT1MBM EQU   APCTU+16
@NM00051 EQU   APCTZ1+108
@NM00050 EQU   APCTZ1+52
@NM00049 EQU   APCTZ1+48
@NM00048 EQU   APCTZ1+44
@NM00047 EQU   APCTZ1+36
@NM00046 EQU   APCTZ1+32
@NM00045 EQU   APCTZ1+16
@NM00044 EQU   APCTZ1+12
@NM00043 EQU   APCTZ+396
@NM00042 EQU   APCTZ+352
@NM00041 EQU   APCTZ+348
@NM00040 EQU   APCTZ+336
@NM00039 EQU   APCTZ+292
APCTZJFA EQU   APCTZ+228
APCTZMBR EQU   APCTZ+100
@NM00038 EQU   APCTZ+20
APSVWORK EQU   APSV+80
@NM00126 EQU   APSV+80
APSVFREE EQU   APSV+76
APSVAPSM EQU   APSV+72
APSVRG12 EQU   APSVREGS+56
APSVRG11 EQU   APSVREGS+52
APSVRG10 EQU   APSVREGS+48
APSVRG9  EQU   APSVREGS+44
APSVRG8  EQU   APSVREGS+40
APSVRG7  EQU   APSVREGS+36
APSVRG6  EQU   APSVREGS+32
APSVRG5  EQU   APSVREGS+28
APSVRG4  EQU   APSVREGS+24
APSVRG3  EQU   APSVREGS+20
APSVRG2  EQU   APSVREGS+16
APSVRG1  EQU   APSVREGS+12
APSVRG0  EQU   APSVREGS+8
APSVRG15 EQU   APSVREGS+4
APSVRG14 EQU   APSVREGS
APSVNEXT EQU   APSV+8
APSVPREV EQU   APSV+4
APSVAPSC EQU   APSV
APCIHELM EQU   APCI+4
@NM00102 EQU   APCIHDR+4
@NM00101 EQU   APCIHFG1
@NM00100 EQU   APCIHFG0
@NM00099 EQU   APCIHDR
@NM00091 EQU   APALU+5
@NM00090 EQU   APALUFMT
APALUFOP EQU   APALUFMT
APALUFRQ EQU   APALUFMT
@NM00089 EQU   APALUDL
@NM00088 EQU   APALUCT
@NM00087 EQU   APALUVS
APALUFFL EQU   APALUFSW
@NM00086 EQU   APALX+5
@NM00085 EQU   APALXFMT
APALXFOP EQU   APALXFMT
APALXFRQ EQU   APALXFMT
@NM00084 EQU   APALXDL
@NM00083 EQU   APALXCT
@NM00082 EQU   APALXVS
APALXFFL EQU   APALXFSW
@NM00081 EQU   APALY+5
@NM00080 EQU   APALYFMT
APALYFOP EQU   APALYFMT
APALYFRQ EQU   APALYFMT
@NM00079 EQU   APALYDL
@NM00078 EQU   APALYCT
@NM00077 EQU   APALYVS
APALYVOP EQU   APALYVS
APALYVRQ EQU   APALYVS
APALYFFL EQU   APALYFSW
@NM00076 EQU   APALALG+1
@NM00075 EQU   APALSTAT
APALSDIV EQU   APALSTAT
APALSCON EQU   APALSTAT
APALSUNF EQU   APALSTAT
APALSOVF EQU   APALSTAT
@NM00074 EQU   APAL+6
APALUSER EQU   APAL
@NM00068 EQU   APEM+128
APEMSSNM EQU   APEM+124
APEMCM17 EQU   APEM+123
APEMAPRL EQU   APEM+117
APEMCM16 EQU   APEM+116
APEMVALP EQU   APEMVALU
APEMCM15 EQU   APEM+107
@NM00067 EQU   APEMMSG+4
APEMCM13 EQU   APEM+91
APEMCCWC EQU   APEM+85
APEMCM12 EQU   APEM+84
APEMDDN  EQU   APEM+76
APEMCM11 EQU   APEM+75
APEMDVTP EQU   APEM+73
APEMCM10 EQU   APEM+72
APEMUNIT EQU   APEM+69
APEMCM09 EQU   APEM+68
APEMSTEP EQU   APEM+60
APEMCM08 EQU   APEM+59
APEMJOB  EQU   APEM+51
APEMCM07 EQU   APEM+50
APEMCICT EQU   APEM+48
APEMCM06 EQU   APEM+47
APEMCIOP EQU   APEM+43
APEMCM05 EQU   APEM+42
APEMCINM EQU   APEM+38
APEMCM04 EQU   APEM+37
APEMNAME EQU   APEM+33
APEMCM03 EQU   APEM+32
APEMERCD EQU   APEM+26
APEMCM02 EQU   APEM+25
APEMTIME EQU   APEM+18
APEMCM01 EQU   APEM+17
APEMDATE EQU   APEM+12
APEMREG1 EQU   APEM+8
APEMZ2   EQU   APEM+6
APEMSZ2  EQU   APEM+4
APEMZ1   EQU   APEM+2
APEMSZ1  EQU   APEM
@NM00066 EQU   APCW+240
@NM00065 EQU   APCW+112
@NM00064 EQU   APCW+80
@NM00063 EQU   APCW+76
APCWZCNV EQU   APCWINT3
APCWZFLO EQU   APCWINT3
APCWZFLU EQU   APCWINT3
APCWZFLD EQU   APCWINT3
APCWZIDX EQU   APCWINT3
APCWZFLN EQU   APCWINT3
@NM00062 EQU   APCWINT3
APCWZLGC EQU   APCWINT2
APCWZHDW EQU   APCWINT2
APCWZUKN EQU   APCWINT2
@NM00061 EQU   APCWINT2
@NM00060 EQU   APCWINT1
@NM00059 EQU   APCWINT0
APCWRC0  EQU   APCWRCDE
APCWR15B EQU   APCWR15C+3
@NM00058 EQU   APCWR15C
@NM00057 EQU   APCW+60
APCWAPFN EQU   APCW+56
@NM00056 EQU   APCW+52
APCWNBRI EQU   APCW+48
APCWSW1  EQU   APCWSWS+1
@NM00055 EQU   APCWSW0
APCWSVAL EQU   APCWSW0
APCWSIX  EQU   APCWSW0
@NM00054 EQU   APCW+44
@NM00053 EQU   APCW+36
APCWAPCP EQU   APCW+32
APCWAPIO EQU   APCW+28
APCWAPRL EQU   APCW+24
APCWACBF EQU   APCWACB
APCWAPSV EQU   APCW+16
APCWAPUT EQU   APCW+12
APCWUSER EQU   APCW+4
APCWID   EQU   APCW
@NM00037 EQU   APCT+1556
APCTSVCT EQU   APCT+1552
APCTDAVT EQU   APCT+1548
APCTLOGL EQU   APCT+1544
@NM00036 EQU   APCT+1540
APCTDMPU EQU   APCT+1536
APCTDMPM EQU   APCT+1532
APCTNDMP EQU   APCT+1530
APCTASID EQU   APCT+1528
APCTLGPG EQU   APCT+1526
APCTLGLN EQU   APCT+1524
APCTAPVU EQU   APCT+1520
APCTABR  EQU   APCT+1116
APCTACTR EQU   APCT+1112
APCTLOGD EQU   APCT+1108
APCTDCLD EQU   APCT+1104
APCTIOAP EQU   APCT+1100
@NM00035 EQU   APCT+1080
@NM00034 EQU   APCT+1078
APCTKCAX EQU   APCT+1076
APCTABND EQU   APCT+1072
@NM00033 EQU   APCT+1068
APCTAPIO EQU   APCT+1064
APCTCSCT EQU   APCT+1060
APCTSTDF EQU   APCT+1056
APCTSTMX EQU   APCT+1052
APCTRGMX EQU   APCT+1048
APCTSIZE EQU   APCT+1046
APCTCTUB EQU   APCT+1045
APCTMFID EQU   APCT+1044
APCTMFSZ EQU   APCT+1040
APCTCRTN EQU   APCT+1036
APCTAPCP EQU   APCT+1032
APCTAMNA EQU   APCT+1028
APCTEMNA EQU   APCT+1024
APCTAALP EQU   APCT+1020
APCTEALP EQU   APCT+1016
@NM00032 EQU   APCT+1012
@NM00031 EQU   APCT+1008
@NM00030 EQU   APCT+1004
APCTEIPL EQU   APCT+1000
@NM00029 EQU   APCT+996
@NM00028 EQU   APCT+992
@NM00027 EQU   APCT+988
@NM00026 EQU   APCT+984
@NM00025 EQU   APCT+980
APCTECPW EQU   APCT+976
APCTEULD EQU   APCT+972
APCTECPT EQU   APCT+968
APCTEALC EQU   APCT+964
APCTECBL EQU   APCT+960
APCTECIT EQU   APCT+956
APCTCQAF EQU   APCTCQAQ
APCTCQL  EQU   APCTAPCQ+4
APCTCQF  EQU   APCTAPCQ
APCTCQLK EQU   APCT+940
@NM00024 EQU   @NM00020+2
@NM00023 EQU   APCTPRSW
APCTAPST EQU   APCTPRSW
@NM00022 EQU   APCTPRSW
@NM00021 EQU   APCTSTAT
APCTWARM EQU   APCTSTAT
APCTTERM EQU   APCTSTAT
APCTHALT EQU   APCTSTAT
APCTQSCE EQU   APCTSTAT
APCTSTRT EQU   APCTSTAT
APCTACT  EQU   APCTSTAT
APCTVUNX EQU   APCT+935
APCTSOUT EQU   APCT+934
APCTDAID EQU   APCT+933
APCTSV34 EQU   APCT+932
APCTMJOB EQU   APCT+928
APCTTCB  EQU   APCT+924
APCTASCB EQU   APCT+920
APCTDCNW EQU   APCT+918
APCTDCNR EQU   APCT+916
@NM00019 EQU   APCT+912
@NM00018 EQU   APCT+908
@NM00017 EQU   APCT+904
@NM00016 EQU   APCT+900
@NM00015 EQU   APCTERRS+22
APCTERTJ EQU   APCTERRS+20
APCTERTD EQU   APCTERRS+18
APCTERTC EQU   APCTERRS+16
APCTERTB EQU   APCTERRS+14
APCTERTA EQU   APCTERRS+12
APCTERT9 EQU   APCTERRS+10
APCTERT3 EQU   APCTERRS+8
APCTERT2 EQU   APCTERRS+6
APCTERT1 EQU   APCTERRS+4
APCTERT0 EQU   APCTERRS+2
APCTERTT EQU   APCTERRS
APCTDSAP EQU   APCT+872
APCTISUB EQU   APCT+868
APCTUBAP EQU   APCT+864
APCTAPDS EQU   APCT+860
APCTUBIC EQU   APCT+856
APCTUBIS EQU   APCT+852
APCTAPUB EQU   APCT+848
APCTUBLK EQU   APCT+844
APCTBR1A EQU   APCTBR14+2
@NM00014 EQU   APCTBR14
APCTSMSZ EQU   APCTSMAD+2
@NM00013 EQU   APCTSMAD+1
@NM00012 EQU   APCTSMAD
APCTSMIS EQU   APCTSMIN+2
@NM00011 EQU   APCTSMIN+1
APCTSMSP EQU   APCTSMIN
@NM00010 EQU   APCT+30
APCTLINE EQU   APCT+28
APCTLBSZ EQU   APCT+24
APCTREG  EQU   APCT+20
APCTSSID EQU   APCTENQM+4
@NM00009 EQU   APCTENQM
APCTSSVT EQU   APCT+8
APCTUSER EQU   APCT+4
APCTID   EQU   APCT
@NM00008 EQU   PARMSIGN
@NM00007 EQU   UARRV+1
UARRVLIM EQU   UARRV
@NM00006 EQU   IFMU
@NM00005 EQU   XARRV+1
XARRVLIM EQU   XARRV
@NM00004 EQU   IFMX
@NM00003 EQU   YARRV+1
YARRVLIM EQU   YARRV
@NM00002 EQU   IFMY
RSVD     EQU   DESCRVEC
@NM00001 EQU   ISTATE
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00076 EQU   @RC00075
@RC00125 EQU   @RC00124
@RF00130 EQU   @RC00124
@RC00150 EQU   @RC00099
@RC00230 EQU   @RC00208
@RF00208 EQU   OUTERR1
@RF00236 EQU   OUTERR1
@RC00236 EQU   @RC00235
@RC00245 EQU   @RC00244
@RC00251 EQU   @RC00244
@RF00259 EQU   OUTERR1
@RC00259 EQU   @RC00258
@RC00268 EQU   @RC00267
@RC00272 EQU   @RC00267
@RF00278 EQU   OUTERR1
@RC00278 EQU   @RC00277
@RF00288 EQU   OUTERR1
@RC00288 EQU   @RC00287
@RF00298 EQU   OUTERR1
@RC00298 EQU   @RC00297
@RF00311 EQU   OUTERR1
@RC00311 EQU   @RC00310
@RC00344 EQU   @RC00337
@RC00338 EQU   @RC00337
@RC00370 EQU   @RC00337
@RF00376 EQU   OUTERR1
@RC00376 EQU   @RC00375
@RC00385 EQU   @RC00384
@RC00391 EQU   @RC00384
@RF00399 EQU   OUTERR1
@RC00399 EQU   @RC00398
@RC00408 EQU   @RC00407
@RF00425 EQU   OUTERR1
@RC00418 EQU   @RC00417
@RF00437 EQU   OUTERR1
@RC00430 EQU   @RC00429
@RF00449 EQU   OUTERR1
@RC00441 EQU   @RC00307
@RT00454 EQU   OUTERR1
@RF00460 EQU   OUTERR1
@RC00460 EQU   @RC00459
@RC00493 EQU   @RC00486
@RC00487 EQU   @RC00486
@RC00519 EQU   @RC00486
@RF00525 EQU   OUTERR1
@RC00525 EQU   @RC00524
@RC00534 EQU   @RC00533
@RC00540 EQU   @RC00533
@RF00548 EQU   OUTERR1
@RC00548 EQU   @RC00547
@RC00557 EQU   @RC00556
@RF00574 EQU   OUTERR1
@RC00567 EQU   @RC00566
@RF00586 EQU   OUTERR1
@RC00579 EQU   @RC00578
@RF00598 EQU   OUTERR1
@RC00590 EQU   @RC00456
@RT00603 EQU   OUTERR1
@RC00631 EQU   @RC00630
@RC00636 EQU   @RC00635
@RC00641 EQU   @RC00640
@RC00646 EQU   @RC00645
@RC00651 EQU   @RC00650
@RC00661 EQU   @RC00660
@RC00673 EQU   @RC00672
@RC00685 EQU   @RC00684
@RC00733 EQU   @RC00732
@RC00738 EQU   @RC00737
@RC00743 EQU   @RC00742
@RC00748 EQU   @RC00747
@RC00753 EQU   @RC00752
@RC00763 EQU   @RC00762
@RC00775 EQU   @RC00774
@RC00787 EQU   @RC00786
@RC00837 EQU   @RC00836
@RC00842 EQU   @RC00841
@RC00847 EQU   @RC00846
@RC00852 EQU   @RC00851
@RC00857 EQU   @RC00856
@RC00867 EQU   @RC00866
@RC00879 EQU   @RC00878
@RC00891 EQU   @RC00890
@RT00916 EQU   @EL00001
@RC00151 EQU   @RC00150
@RC00155 EQU   @RC00150
@RC00239 EQU   @RC00236
@RC00246 EQU   @RC00245
@RC00262 EQU   @RC00259
@RC00281 EQU   @RC00278
@RC00291 EQU   @RC00288
@RC00301 EQU   @RC00298
@RC00332 EQU   @RC00311
@RC00379 EQU   @RC00376
@RC00386 EQU   @RC00385
@RC00402 EQU   @RC00399
@RC00411 EQU   @RC00408
@RC00421 EQU   @RC00418
@RC00433 EQU   @RC00430
@RC00442 EQU   @RC00441
@RC00481 EQU   @RC00460
@RC00528 EQU   @RC00525
@RC00535 EQU   @RC00534
@RC00551 EQU   @RC00548
@RC00560 EQU   @RC00557
@RC00570 EQU   @RC00567
@RC00582 EQU   @RC00579
@RC00591 EQU   @RC00590
@RC00662 EQU   @RC00661
@RC00674 EQU   @RC00673
@RC00686 EQU   @RC00685
@RC00764 EQU   @RC00763
@RC00776 EQU   @RC00775
@RC00788 EQU   @RC00787
@RC00868 EQU   @RC00867
@RC00880 EQU   @RC00879
@RC00892 EQU   @RC00891
@RF00159 EQU   @RC00155
@RC00445 EQU   @RC00442
@RC00594 EQU   @RC00591
@ENDDATA EQU   *
         END   IGTMDA,(C'PLS1223',0701,77231)
