TUKA     TITLE 'IGTUKA -- ESTAE/SETFRR EXIT ROUTINE                    *
                        '
IGTUKA   CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(16)                                          01S0001
         DC    C'IGTUKA    77.092'                              01S0001
         DROP  @15
@PROLOG  BALR  @07,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@07                                      01S0001
*                                   /*
***********************************************************************
**                                                                   **
**  DEFINE MACRO GLOBALS WHICH INDICATE THOSE SU'S APPLIED TO        **
**  THE SYSTEM.  BIT-1 = 1 IF SU1 APPLIED, BIT-2 = 1 IF SU-2         **
**  APPLIED, ETC. THESE BITS ARE SET BY MACROS IHASUXX WHERE         **
**  XX IS THE 1 OR 2 DIGIT SU NUMBER (1-99). THESE BITS ARE MAPPED   **
**  BY MACRO IHASUBIT. THESE IHASUXX MACROS RESIDE ON SYS1.AMODGEN.  **
**                                                                   **
***********************************************************************
         SPACE 2
         GBLB  &SGIHASU(100)       SU INDICATORS
         SPACE 2
***********************************************************************
**                                                                   **
**  THE FOLLOWING MACRO INVOCATION WILL SET BIT &SGIHASU(33) TO      **
**  EITHER 0 OR 1 INDICATING WHETHER SU-33 (DUMPING IMPROVEMENTS)    **
**  HAS BEEN APPLIED TO THE SYSTEM.  SYS1.AMODGEN MUST BE PART OF    **
**  THE ASSEMBLER'S SYSLIB DD STATEMENT (IHASUXX MEMBERS RESIDE      **
**  ON SYS1.AMODGEN).                                                **
**  THE IBM ASSEMBLY WILL ALWAYS ASSUME SU-33 HAS BEEN APPLIED.      **
**  NOTE THAT THE AVAILABILITY OF SU33 IS ALSO CHECKED AT EXECUTION  **
**  TIME.  THEREFORE THE CODE ASSEMBLED WITH SU33 PRESENT WILL ALSO  **
**  EXECUTE ON A SYSTEM WITHOUT SU-33.                               **
**                                                                   **
***********************************************************************
         SPACE 2
         IHASU33 ,                 DETERMINE IF SU-33 APPLIED
*   IF R0F=12 THEN                  /* IF NO SDWA OBTAINED,          */
         C     R0F,@CF02492                                     01S0060
         BNE   @RF00060                                         01S0060
*     RETURN CODE(0);               /* JUST CONTINUE THE ABEND       */
*                                                               01S0061
         SLR   @15,@15                                          01S0061
@EL00001 DS    0H                                               01S0061
@EF00001 DS    0H                                               01S0061
@ER00001 BR    @14                                              01S0061
*   /*****************************************************************/
*   /*                                                               */
*   /* LOCATE THE 'APES'. INSURE VALID. IF NOT, LOG THE ERROR, AND   */
*   /* CONTINUE THE ABEND.                                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0062
*   RFY                                                         01S0062
*     SDWA BASED(R1P);              /* SDWA IS INPUT TO ROUTINE      */
@RF00060 DS    0H                                               01S0063
*   RFY                                                         01S0063
*     RAPESPTR RSTD;                /* POINT TO 'APES' BLOCK.        */
*   RAPESPTR=SDWAPARM->I031P;       /* ADDRESS IN 1ST WORD OF PARMS  */
         L     @15,SDWAPARM(,R1P)                               01S0064
         L     RAPESPTR,I031P(,@15)                             01S0064
*   RFY                                                         01S0065
*     APES BASED(RAPESPTR);         /* TELL PL/S OF BASE REGISTER    */
*   IF APESID^=APESIDC THEN         /* IF RAPESPTR DOES NOT POINT TO */
         CLC   APESID(4,RAPESPTR),@CC02134                      01S0066
         BE    @RF00066                                         01S0066
*     DO;                           /* 'APES' BLOCK, IS ERROR        */
*       DO;                         /* SETRP WKAREA(ADDR(SDWA))DUMP(Y
*                                      ES)RECORD(YES)RECPARM(CCSECT)R
*                                      C(0)                          */
*         RESPECIFY                                             01S0069
*          (GPR00P,                                             01S0069
*           GPR01P,                                             01S0069
*           GPR14P,                                             01S0069
*           GPR15P) RSTD;                                       01S0069
*         GPR01P=ADDR(SDWA);                                    01S0070
*         GPR01P->SDWARCDE=0;       /* SAVE RC VALUE                 */
         MVI   SDWARCDE(GPR01P),X'00'                           01S0071
*         GPR01P->SDWARCRD='1'B;    /* TURN ON RECORD INDICATOR      */
         OI    SDWARCRD(GPR01P),B'10000000'                     01S0072
*         GPR15P=ADDR(CCSECT);      /* ACCESS RECORD PARAMETER LIST  */
         LA    GPR15P,CCSECT                                    01S0073
*         GPR01P->SDWARECP=GPR15P->I256C(1:24);/* COPY RECORD   01S0074
*                                      PARAMETERS                    */
         MVC   SDWARECP(24,GPR01P),I256C(GPR15P)                01S0074
*         GPR01P->SDWAREQ='1'B;     /* TURN ON DUMP INDICATOR        */
         OI    SDWAREQ(GPR01P),B'10000000'                      01S0075
*         RESPECIFY                                             01S0076
*          (GPR00P,                                             01S0076
*           GPR01P,                                             01S0076
*           GPR14P,                                             01S0076
*           GPR15P) UNRSTD;                                     01S0076
*       END;                        /* CONTINUE THE ABEND            */
*       RETURN;                     /* CONTINUE THE ABEND            */
         B     @EL00001                                         01S0078
*     END;                          /* INVALID 'APES' PROCESSED      */
*                                                               01S0079
*   /*****************************************************************/
*   /*                                                               */
*   /* RAPESPTR POINTS TO 'APES' BLOCK. RELOAD REGISTER APCTPTR FROM */
*   /* THE INITIAL APES REGISTER SAVEAREA (APESREGZ). THEN SAVE THE  */
*   /* RETURN AND SDWA ADDRESSES.                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0080
*   APCTPTR=ADDR(APESREGZ)->APESREGC;/* RESET APCT POINTER           */
@RF00066 L     APCTPTR,APESREGC+48(,RAPESPTR)                   01S0080
*   APESR14S=R14P;                  /* SAVE SAVE RETURN ADDRESS      */
         ST    R14P,APESR14S(,RAPESPTR)                         01S0081
*   RFY                                                         01S0082
*    (R14P) UNRSTD;                 /* CAN NOW USE THIS REGISTER     */
*   RFY                                                         01S0083
*     RSDWAPTR RSTD;                /* MOVE SDWA ADDRESS TO          */
*   RSDWAPTR=ADDR(SDWA);            /* NON-VOLITILE REGISTER LEAVE
*                                      SDWA BASED ON R1P.            */
         LR    RSDWAPTR,R1P                                     01S0084
*   RFY                                                         01S0085
*     APDATA RSTD;                  /* SAVE FRR WORKAREA (R0)        */
*   APDATA=R0F;                     /* IN NON-VOLITILE REGISTER      */
         LR    APDATA,R0F                                       01S0086
*   RFY                                                         01S0087
*     R0F UNRSTD;                   /* DONE WITH INPUT REGISTER      */
*                                                               01S0087
*   /*****************************************************************/
*   /*                                                               */
*   /* DETERMINE IF ENTERED FROM SETFRR OR ESTAE. ALSO DETERMINE IF  */
*   /* LOCAL AND/OR CMS LOCKS OWNED. SET APESFLG1 ACCORDINGLY.       */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0088
*   APESFFRR=BOFF;                  /* RESET FRR IN-CONTROL,         */
*   APESFLLK=BOFF;                  /* RESET LOCAL LOCK OWNED,       */
*   APESFXLK=BOFF;                  /* RESET CMS LOCK OWNED SWITCH.  */
         NI    APESFFRR(RAPESPTR),B'01001111'                   01S0090
*   GEN REFS(PSAHLHI) FLOWS(KNOWLOCK) SEQFLOW;                  01S0091
*                                   /* SEE IF LOCAL LOCK OWNED
         SETLOCK TEST,             SEE IF LOCAL LOCK OWNED             *
               TYPE=LOCAL,         IF SO, THEN SETFRR ENTRY.           *
               BRANCH=(NOTHELD,KNOWLOCK), SET APES SWITCHES IF OWNED   *
               RELATED=(APESFFRR,APESFLLK) FRR ENTRY, LOCAL LOCK OWNED
*   APESFFRR=BON;                   /* FRR ENTRY                     */
*   APESFLLK=BON;                   /* LOCAL LOCK OWNED              */
         OI    APESFFRR(RAPESPTR),B'10100000'                   01S0093
*   GEN REFS(PSAHLHI) FLOWS(KNOWLOCK) SEQFLOW;                  01S0094
*                                   /* SEE IF CMS LOCK OWNED
         SETLOCK TEST,             SEE IF CMS LOCK OWNED               *
               TYPE=CMS,           (LOCAL LOCK ALREADY OWNED)          *
               BRANCH=(NOTHELD,KNOWLOCK), SET APES SWITCH IF OWNED     *
               RELATED=APESFXLK    INDICATE CMS LOCK OWNED IN APES
*   APESFXLK=BON;                   /* CMS LOCK OWNED                */
         OI    APESFXLK(RAPESPTR),B'00010000'                   01S0095
*KNOWLOCK:                          /* FRR/LOCK INDICATORS SET IN
*                                      APES                          */
*                                                               01S0096
*   /*****************************************************************/
*   /*                                                               */
*   /* ESTABLISH REGISTER 13 SAVEAREA AND THE PL/S DYNAMIC AREA. IF  */
*   /* ENTERED FROM SETFRR, REGISTER 0 ON INPUT CONTAINS THE ADDRESS */
*   /* OF A 200-BYTE SAVEAREA. IF ENTERED FROM ESTAE, ISSUE A        */
*   /* CONDITIONAL GETMAIN FOR 200 BYTES FROM SUBPOOL 253. IF THIS   */
*   /* GETMAIN FAILS USE THE FIRST 200 BYTES OF THE SAVED SDWA IN THE*/
*   /* APES. SET A FLAG IN THE APES TO INDICATE THAT THE SAVED SDWA  */
*   /* HAS BEEN OVERLAID.                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0096
*   RFY                                                         01S0096
*     APDATA RSTD;                  /* PL/S DYNAMIC AREA POINTER     */
KNOWLOCK DS    0H                                               01S0097
*   APESFGM=BOFF;                   /* SHOW GETMAIN NOT ISSUED       */
         NI    APESFGM(RAPESPTR),B'11110111'                    01S0097
*   IF APESFFRR=BOFF THEN           /* IF FRR EXIT, APDATA POINTS    */
         TM    APESFFRR(RAPESPTR),B'10000000'                   01S0098
         BNZ   @RF00098                                         01S0098
*     DO;                           /* TO 200 BYTE AREA. OTHERWISE,  */
*       RFY                                                     01S0100
*        (R1P,                                                  01S0100
*         R15F) RSTD;               /* ISSUE GETMAIN.                */
*       GEN(GETMAIN RC,LV=200,SP=253);/* CONDITIONALLY GETMAIN       */
         GETMAIN RC,LV=200,SP=253
*       IF R15F=0 THEN              /* IF GETMAIN WORKED,            */
         LTR   R15F,R15F                                        01S0102
         BNZ   @RF00102                                         01S0102
*         APESFGM=BON;              /* SHOW GETMAIN WORKED.          */
         OI    APESFGM(RAPESPTR),B'00001000'                    01S0103
*       ELSE                        /* OTHERWISE USE APESSDWA        */
*         DO;                       /* FOR SAVEAREA/WORKAREA.        */
         B     @RC00102                                         01S0104
@RF00102 DS    0H                                               01S0105
*           APESFSDI=BON;           /* SHOW SAVED SDWA INVALID.      */
         OI    APESFSDI(RAPESPTR),B'00000100'                   01S0105
*           R1P=ADDR(APESSDWA);     /* POINT TO WORKAREA             */
         LA    R1P,APESSDWA(,RAPESPTR)                          01S0106
*         END;                      /* PSUEDO GETMAIN SET            */
*       APDATA=R1P;                 /* ESTABLISH DYNAMIC AREA        */
@RC00102 LR    APDATA,R1P                                       01S0108
*       RFY                                                     01S0109
*        (R1P,                                                  01S0109
*         R15F) UNRSTD;             /* GETMAIN DONE                  */
*       RFY                                                     01S0110
*         R1P RSTD;                 /* RE-ESTABLISH SDWA ADDRESS     */
*       R1P=RSDWAPTR;               /* IN REGISTER 1.                */
         LR    R1P,RSDWAPTR                                     01S0111
*     END;                          /* APDATA -> 200-BYTE AREA       */
*   GEN(USING @DATD,APDATA)                                     01S0113
*   NOSETS REFS(APDATA);            /* ALSO TELL ASSEMBLER           */
@RF00098 DS    0H                                               01S0113
         USING @DATD,APDATA
*   R13P=ADDR(DSVEAREA);            /* ESTABLISH OS SAVEAREA         */
*                                                               01S0114
         LA    R13P,DSVEAREA                                    01S0114
*   /*****************************************************************/
*   /*                                                               */
*   /* INCREMENT THE NUMBER OF ENTRIES INTO 'IGTUKA '.               */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0115
*   APESCNTR=APESCNTR+1;            /* INCREMENT NUMBER ABENDS       */
*                                                               01S0115
         LA    @04,1                                            01S0115
         SLR   @02,@02                                          01S0115
         IC    @02,APESCNTR(,RAPESPTR)                          01S0115
         ALR   @04,@02                                          01S0115
         STC   @04,APESCNTR(,RAPESPTR)                          01S0115
*   /*****************************************************************/
*   /*                                                               */
*   /* IF RECURSION ENTRY (APESFPRV=1), FORCE A DUMP AND LOG THE     */
*   /* FAILURE BY UPDATING THE APES.                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0116
*   IF APESFPRV=BON THEN            /* IF RETRY ROUTINE FAILED,      */
         TM    APESFPRV(RAPESPTR),B'01000000'                   01S0116
         BNO   @RF00116                                         01S0116
*     DO;                           /* THEN REQUEST MAXIMUM.         */
*       APESFREC=BON;               /* RECORD ON LOGREC              */
*       APESFDMP=BON;               /* TAKE SNAP DUMP                */
*       APESFSDP=BON;               /* TAKE SDUMP                    */
         OI    APESFREC(RAPESPTR),B'11100000'                   01S0120
*     END;                          /* RECURSION OPTIONS SELECTED    */
*                                                               01S0122
*   /*****************************************************************/
*   /*                                                               */
*   /* IF ENTRY FROM CANCEL, DETACH, ETC (SDWACLUP=1), DO NOT TAKE   */
*   /* SDUMP OR LOG ERROR SINCE NOT A PROGRAM FAILURE. LEAVE SYSUDUMP*/
*   /* FLAG UNCHANGED.                                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0122
*   IF SDWACLUP=BON THEN            /* IF CANCEL, ETC. THEN          */
@RF00116 TM    SDWACLUP(R1P),B'10000000'                        01S0122
         BNO   @RF00122                                         01S0122
*     DO;                           /* CLEAR FLAGS.                  */
*       APESFSDP=BOFF;              /* DO NOT TAKE SDUMP             */
*       APESFREC=BOFF;              /* DO NOT RECORD ON LOGREC       */
*       APESFDMP=BON;               /* SET SYSUDUMP REQUEST FLAG     */
         OI    APESFDMP(RAPESPTR),B'10000000'                   01S0126
         NI    APESFSDP(RAPESPTR),B'10011111'                   01S0126
*       IF SDWAREQ=BOFF THEN        /* TO CURRENT VALUE, SO IT WILL  */
         TM    SDWAREQ(R1P),B'10000000'                         01S0127
         BNZ   @RF00127                                         01S0127
*         APESFDMP=BOFF;            /* SET TO THIS VALUE LATER ON.   */
         NI    APESFDMP(RAPESPTR),B'01111111'                   01S0128
*     END;                          /* OPTIONS RESET                 */
*                                                               01S0129
@RF00127 DS    0H                                               01S0130
*   /*****************************************************************/
*   /*                                                               */
*   /* IF THIS TASK WAS NOT IN CONTROL AT THE TIME OF THE ERROR BUT A*/
*   /* TASK WITHIN THE SAME JOBSTEP REQUESTED A 'STEP' ABEND         */
*   /* (SDWACTS=1), OR AN ANCESTOR TASK ABENDED (SDWAMABD=1), THEN DO*/
*   /* NOT TAKE A SYSUDUMP. NOTE THAT SDWACLUP=1 IN ALL CASES.       */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0130
*   IF SDWACTS=BON|                 /* IF STEP ABEND OR              */
*       SDWAMABD=BON THEN           /* MOTHER ABENDED                */
@RF00122 TM    SDWACTS(R1P),B'00011000'                         01S0130
         BZ    @RF00130                                         01S0130
*     APESFDMP=BOFF;                /* DO NOT TAKE SYSUDUMP.         */
*                                                               01S0131
         NI    APESFDMP(RAPESPTR),B'01111111'                   01S0131
*   /*****************************************************************/
*   /*                                                               */
*   /* IF A LOWER LEVEL RECOVERY ROUTINE HAS PROVIDED SERVICEABILITY */
*   /* INFORMATION (SDWAEAS=1), THEN DO NOT PROVIDE A SECOND SDUMP OF*/
*   /* THE PROBLEM.                                                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0132
*   IF SDWAEAS=BON THEN             /* IF LOWER LEVEL ROUTINE GAVE   */
@RF00130 TM    SDWAEAS(R1P),B'00001000'                         01S0132
         BNO   @RF00132                                         01S0132
*     APESFSDP=BOFF;                /* DEBUG DATA, NO SDUMP NEEDED.  */
         NI    APESFSDP(RAPESPTR),B'11011111'                   01S0133
*                                                               01S0134
*   /*****************************************************************/
*   /*                                                               */
*   /* IF NON-RECURSIVE EXTRY, CALL THE USER'S EXTENDED ESTAE/FRR    */
*   /* EXIT (APESEXRA) IF SPECIFIED (APESFEXR = 1).                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0134
*   IF APESFEXR=BON&                /* IF EXIT ROUTINE SPECIFIED,    */
*       APESFPRV=BOFF THEN          /* AND NOT RECURSION PROCESSING, */
@RF00132 TM    APESFEXR(RAPESPTR),B'00000100'                   01S0134
         BNO   @RF00134                                         01S0134
         TM    APESFPRV(RAPESPTR),B'01000000'                   01S0134
         BNZ   @RF00134                                         01S0134
*     DO;                           /* THEN CALL EXIT RTN (APESEXRA).*/
*       RFY                                                     01S0136
*        (R0P,                                                  01S0136
*         R14P,                                                 01S0136
*         R15P) RSTD;               /* INTERFACE REGISTERS           */
*       APESFPRV=BON;               /* TREAT ERROR AS RECURSION      */
         OI    APESFPRV(RAPESPTR),B'01000000'                   01S0137
*       MVC(DUXINSTR,CUXINSTR);     /* INITIALIZE RETURN CODE        */
         MVC   DUXINSTR(8,R1P),CUXINSTR                         01S0138
*       STM(R0F,R14F,DUXREGS);      /* SAVE CURRENT REGISTERS        */
         STM   R0F,R14F,DUXREGS(R1P)                            01S0139
*       R0P=ADDR(APES);             /* CALLER GETS APES ADDR IN R0   */
         LR    R0P,RAPESPTR                                     01S0140
*       R1P=ADDR(SDWA);             /* CALLER GETS SDWA ADDR IN R1   */
*       R14P=ADDR(DUXDATA);         /* RETURN LOGIC ADDR IN R14      */
         LA    R14P,DUXDATA(,R1P)                               01S0142
*       R15P=APESEXRA;              /* EXIT ROUTINE ADDRESS IN R15   */
         L     R15P,APESEXRA(,RAPESPTR)                         01S0143
*       R13P=APESREGP;              /* POINT TO SAVED REGISTERS      */
         L     R13P,APESREGP(,RAPESPTR)                         01S0144
*       GEN(LM    R2P,R13P,APESREG2-APESREGS(R13P))             01S0145
*       REFS(R2P,R13P,APESREG2,APESREGS,R13P);/* USER REGISTERS      */
         LM    R2P,R13P,APESREG2-APESREGS(R13P)
*       GEN(BR    R15P)                                         01S0146
*       REFS(R15P) SETS(R15F);      /* CALL EXIT ROUTINE             */
         BR    R15P
*       RFY                                                     01S0147
*        (R0P,                                                  01S0147
*         R14P,                                                 01S0147
*         R15P) UNRSTD;             /* FINISHED WITH INPUT REGS      */
*       RFY                                                     01S0148
*         R15F RSTD;                /* RETRY INDICATOR (0/4)         */
*LUEXIT:                            /* USER RETURN (VIA DUXINSTR).   */
*                                                               01S0149
*       /*************************************************************/
*       /*                                                           */
*       /* CONTROL RETURNS TO 'DUXDATA' WHICH LOADS THE SAVED        */
*       /* REGISTER VALUES FOR R0-R14, AND BRANCHES TO 'LUEXIT'.     */
*       /* REGISTER 15 HAS THE RETRY/NORETRY INDICATOR (0/4).        */
*       /*                                                           */
*       /*************************************************************/
*                                                               01S0149
*       APESFPRV=BOFF;              /* RESET RECURSION INDICATOR     */
LUEXIT   NI    APESFPRV(RAPESPTR),B'10111111'                   01S0149
*       APESFRTY=BOFF;              /* BASED UPON REGISTER 15, SET   */
         NI    APESFRTY(RAPESPTR),B'11110111'                   01S0150
*       IF R15F^=4 THEN             /* RETRY/NORETRY FLAG (4/0).     */
         C     R15F,@CF00045                                    01S0151
         BE    @RF00151                                         01S0151
*         APESFRTY=BON;             /* NO RETRY IF CODE NOT 4.       */
         OI    APESFRTY(RAPESPTR),B'00001000'                   01S0152
*       RFY                                                     01S0153
*         R15F UNRSTD;              /* DONE WITH RETURN CODE         */
@RF00151 DS    0H                                               01S0154
*     END;                          /* APESEXRA PROCESSED            */
*                                                               01S0155
*   /*****************************************************************/
*   /*                                                               */
*   /* SET SVCDUMP PARAMETERS FOR SYSTEMS WITH SU-33 AND SYSTEMS     */
*   /* WITHOUT SU-33 (DUMPING IMPROVEMENTS).                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0155
*   IF SU33BIT=BOFF THEN            /* IF SU-33 HAS NOT BEEN APPLIED,*/
@RF00134 L     @04,CVTPTR                                       01S0155
         L     @04,CVTIHASU(,@04)                               01S0155
         TM    SU33BIT(@04),B'01000000'                         01S0155
         BNZ   @RF00155                                         01S0155
*     DO;                           /* THEN DUMP ONLY USER.          */
*       APESSU33=BOFF;              /* SHOW SU-33 NOT APPLIED        */
         NI    APESSU33(RAPESPTR),B'01111111'                   01S0157
*       DASID1=ASCBASID;            /* DUMP CURRENT ASCB             */
         L     @04,ASCBPTR                                      01S0158
         LH    @04,ASCBASID(,@04)                               01S0158
         N     @04,@CF02632                                     01S0158
         STH   @04,DASID1                                       01S0158
*     END;                          /* NON-SU33 PROCESSING COMPLETE  */
*   ELSE                            /* IF SU-33 HAS BEEN APPLIED,    */
*     DO;                           /* DUMP USER & MONITOR.          */
         B     @RC00155                                         01S0160
@RF00155 DS    0H                                               01S0161
*       APESSU33=BON;               /* SHOW SU-33 APPLIED            */
         OI    APESSU33(RAPESPTR),B'10000000'                   01S0161
*       IF ASCBASID=APCTASID THEN   /* IF MONITOR IS CURRENT,        */
         LH    @04,APCTASID(,APCTPTR)                           01S0162
         L     @02,ASCBPTR                                      01S0162
         LH    @02,ASCBASID(,@02)                               01S0162
         N     @02,@CF02632                                     01S0162
         CR    @04,@02                                          01S0162
         BNE   @RF00162                                         01S0162
*         DASID1=APCTASID|          /* THEN ONLY DUMP ONE            */
*             '8000'X;              /* ADDRESS SPACE (MONITOR).      */
         O     @04,@CF02515                                     01S0163
         STH   @04,DASID1                                       01S0163
*       ELSE                        /* IF NOT THE MONITOR, THEN      */
*         DO;                       /* DUMP 2 ADDRESS SPACES --      */
         B     @RC00162                                         01S0164
@RF00162 DS    0H                                               01S0165
*           DASID1=ASCBASID;        /* 1 -- USER                     */
         L     @04,ASCBPTR                                      01S0165
         LH    @04,ASCBASID(,@04)                               01S0165
         N     @04,@CF02632                                     01S0165
         STH   @04,DASID1                                       01S0165
*           DASID2=APCTASID|        /* 2 -- MONITOR                  */
*               '8000'X;            /* SHOW END-OF-LIST.             */
         L     @04,@CF02515                                     01S0166
         LH    @02,APCTASID(,APCTPTR)                           01S0166
         OR    @04,@02                                          01S0166
         STH   @04,DASID2                                       01S0166
*         END;                      /* SU-33 LIST SET                */
*     END;                          /* SU-33 OPTIONS SET             */
*                                                               01S0168
@RC00162 DS    0H                                               01S0169
*   /*****************************************************************/
*   /*                                                               */
*   /* ESTABLISH DUMP OPTION IN SDWA                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0169
*   IF APESFDMP=BOFF THEN           /* IF USER DUMP NOT WANTED       */
@RC00155 TM    APESFDMP(RAPESPTR),B'10000000'                   01S0169
         BNZ   @RF00169                                         01S0169
*     DO;                           /* SETRP                    01S0170
*                                      WKAREA(ADDR(SDWA))DUMP(NO)    */
*       RESPECIFY                                               01S0171
*        (GPR00P,                                               01S0171
*         GPR01P,                                               01S0171
*         GPR14P,                                               01S0171
*         GPR15P) RSTD;                                         01S0171
*       GPR01P=ADDR(SDWA);                                      01S0172
*       GPR01P->SDWARCDE=0;         /* SAVE RC VALUE                 */
         MVI   SDWARCDE(GPR01P),X'00'                           01S0173
*       GPR01P->SDWAREQ='0'B;       /* TURN OFF DUMP INDICATOR       */
         NI    SDWAREQ(GPR01P),B'01111111'                      01S0174
*       RESPECIFY                                               01S0175
*        (GPR00P,                                               01S0175
*         GPR01P,                                               01S0175
*         GPR14P,                                               01S0175
*         GPR15P) UNRSTD;                                       01S0175
*     END;                          /* THE SDWA.                     */
*   ELSE                            /* IF USER DUMP WANTED,          */
*     DO;                           /* SETRP WKAREA(ADDR(SDWA))DUMP(Y
*                                      ES)DUMPOPT(CXSNAP)            */
         B     @RC00169                                         01S0177
@RF00169 DS    0H                                               01S0178
*       RESPECIFY                                               01S0178
*        (GPR00P,                                               01S0178
*         GPR01P,                                               01S0178
*         GPR14P,                                               01S0178
*         GPR15P) RSTD;                                         01S0178
*       GPR01P=ADDR(SDWA);                                      01S0179
*       GPR01P->SDWARCDE=0;         /* SAVE RC VALUE                 */
         MVI   SDWARCDE(GPR01P),X'00'                           01S0180
*       GPR01P->SDWAREQ='1'B;       /* TURN ON DUMP INDICATOR        */
         OI    SDWAREQ(GPR01P),B'10000000'                      01S0181
*       GPR01P->SDWADLST='1'B;      /* INDICATE DUMP OPTIONS PASSED  */
         OI    SDWADLST(GPR01P),B'01000000'                     01S0182
*       GPR15P=ADDR(CXSNAP);        /* ACCESS PTR TO DUMP PARMS      */
         LA    GPR15P,CXSNAP                                    01S0183
*       GPR01P->SDWADDAT=GPR15P->I256C(5:8);/* ACCESS SDATA AND PDATA*/
         MVC   SDWADDAT(4,GPR01P),I256C+4(GPR15P)               01S0184
*       GPR01P->SDWAENSN='1'B;      /* INDICATE ENHANCED DUMP        */
         OI    SDWAENSN(GPR01P),B'00100000'                     01S0185
*       GEN(TM    1(15),X'02');     /* TEST FOR STORAGE LIST         */
         TM    1(15),X'02'
*       BC(1,M0012);                /* BRANCH IF SPECIFIED           */
         BC    1,M0012                                          01S0187
*       IF GPR15P->I256C(17:20)=0 THEN/* FURTHER TEST FOR STOR LIST  */
         ICM   @04,15,I256C+16(GPR15P)                          01S0188
         BZ    @RT00188                                         01S0188
*         GOTO E0012;               /* BRANCH IF NO STORAGE LIST     */
*M0012:                                                         01S0190
*       GPR01P->SDWASLST='1'B;      /* TURN ON STORAGE LIST FLAG     */
M0012    OI    SDWASLST(GPR01P),B'00000010'                     01S0190
*       GPR15P=EVAL(GPR15P+16)->I031P;/* ACCESS PTR TO STORAGE LIST  */
         LA    @04,16                                           01S0191
         ALR   @04,GPR15P                                       01S0191
         L     @04,I031P(,@04)                                  01S0191
         LR    GPR15P,@04                                       01S0191
*       GENERATE SETS(SDWAFRM1,SDWAFRM2,SDWAFRM3,SDWAFRM4,SDWATO4);
         MVC   SDWAFRM1(8,GPR01P),0(15)     MOVE FIRST STORAGE RANGE
         TM    4(15),X'80'                  TEST IF END OF LIST
         BO    E0012                        BRANCH IF END OF LIST
         MVC   SDWAFRM2(8,GPR01P),8(15)     MOVE SECOND STORAGE RANGE
         TM    12(15),X'80'                 TEST IF END OF LIST
         BO    E0012                        BRANCH IF END OF LIST
         MVC   SDWAFRM3(8,GPR01P),16(15)    MOVE THIRD STORAGE RANGE
         TM    20(15),X'80'                 TEST IF END OF LIST
         BO    E0012                        BRANCH IF END OF LIST
         MVC   SDWAFRM4(8,GPR01P),24(15)    MOVE FOURTH STORAGE LIST
         OI    SDWATO4(GPR01P),X'80'        END OF LIST FLAG
*E0012:                                                         01S0193
*       RESPECIFY                                               01S0193
*        (GPR00P,                                               01S0193
*         GPR01P,                                               01S0193
*         GPR14P,                                               01S0193
*         GPR15P) UNRSTD;                                       01S0193
E0012    DS    0H                                               01S0194
*     END;                          /* LSQA INCLUDES SP 230.         */
*                                                               01S0194
*   /*****************************************************************/
*   /*                                                               */
*   /* ESTABLISH LOGREC OPTION                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0195
*   IF APESFREC=BOFF THEN           /* IF RECORDING NOT WANTED,      */
@RC00169 TM    APESFREC(RAPESPTR),B'01000000'                   01S0195
         BNZ   @RF00195                                         01S0195
*     DO;                           /* SETRP                    01S0196
*                                      WKAREA(ADDR(SDWA))RECORD(NO)  */
*       RESPECIFY                                               01S0197
*        (GPR00P,                                               01S0197
*         GPR01P,                                               01S0197
*         GPR14P,                                               01S0197
*         GPR15P) RSTD;                                         01S0197
*       GPR01P=ADDR(SDWA);                                      01S0198
*       GPR01P->SDWARCDE=0;         /* SAVE RC VALUE                 */
         MVI   SDWARCDE(GPR01P),X'00'                           01S0199
*       GPR01P->SDWARCRD='0'B;      /* TURN OFF RECORD INDICATOR     */
         NI    SDWARCRD(GPR01P),B'01111111'                     01S0200
*       RESPECIFY                                               01S0201
*        (GPR00P,                                               01S0201
*         GPR01P,                                               01S0201
*         GPR14P,                                               01S0201
*         GPR15P) UNRSTD;                                       01S0201
*     END;                          /* THE SDWA.                     */
*   ELSE                            /* IF RECORDING WANTED,          */
*     DO;                           /* SETRP                    01S0203
*                                      WKAREA(ADDR(SDWA))RECORD(YES) */
         B     @RC00195                                         01S0203
@RF00195 DS    0H                                               01S0204
*       RESPECIFY                                               01S0204
*        (GPR00P,                                               01S0204
*         GPR01P,                                               01S0204
*         GPR14P,                                               01S0204
*         GPR15P) RSTD;                                         01S0204
*       GPR01P=ADDR(SDWA);                                      01S0205
*       GPR01P->SDWARCDE=0;         /* SAVE RC VALUE                 */
         MVI   SDWARCDE(GPR01P),X'00'                           01S0206
*       GPR01P->SDWARCRD='1'B;      /* TURN ON RECORD INDICATOR      */
         OI    SDWARCRD(GPR01P),B'10000000'                     01S0207
*       RESPECIFY                                               01S0208
*        (GPR00P,                                               01S0208
*         GPR01P,                                               01S0208
*         GPR14P,                                               01S0208
*         GPR15P) UNRSTD;                                       01S0208
*     END;                          /* THE SDWA                      */
*                                                               01S0210
*   /*****************************************************************/
*   /*                                                               */
*   /* MOVE MODULE/CSECT/FRR NAMES IN THE SDWA. THIS IS PERFORMED    */
*   /* EVEN IF RECORDING IS NOT WANTED SINCE THIS DATA IS ALSO MOVED */
*   /* TO THE DEBUG COPY OF THE SDWA.                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0210
*   APESFRR='IGTUKA  ';             /* EXIT ROUTINE NAME             */
@RC00195 MVC   APESFRR(8,RAPESPTR),@CC02524                     01S0210
*   MVC(SDWARECP,APESMOD);          /* MOVE ID FOR LOGREC PRINTOUT   */
*                                                               01S0211
         MVC   SDWARECP(24,R1P),APESMOD(RAPESPTR)               01S0211
*   /*****************************************************************/
*   /*                                                               */
*   /* BUILD LOGREC ERROR MESSAGE AND SDUMP HEADER (HEADER IS PORTION*/
*   /* OF LOGREC MESSAGE). THIS IS PERFORMED EVEN IF RECORDING IS NOT*/
*   /* REQUESTED SINCE THIS DATA IS ALSO MOVED TO THE DEBUG COPY OF  */
*   /* THE SDWA.                                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0212
*                                                               01S0212
*   /*****************************************************************/
*   /*                                                               */
*   /* VALIDATE 'APESCODE'. IF INVALID, SET TO 'INDETERMINATE-ERROR' */
*   /* VALUE (APESMXCD).                                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0212
*   IF APESCODE<=0|                 /* IF ERROR CODE OUT             */
*       APESCODE>APESMXCD THEN      /* OF RANGE, SET TO              */
         CLI   APESCODE(RAPESPTR),0                             01S0212
         BNH   @RT00212                                         01S0212
         CLC   APESCODE(1,RAPESPTR),APESMXCD(RAPESPTR)          01S0212
         BNH   @RF00212                                         01S0212
@RT00212 DS    0H                                               01S0213
*     APESCODE=APESMXCD;            /* 'INDETERMINATE' ERROR VALUE.  */
*                                                               01S0213
         IC    @04,APESMXCD(,RAPESPTR)                          01S0213
         STC   @04,APESCODE(,RAPESPTR)                          01S0213
*   /*****************************************************************/
*   /*                                                               */
*   /* USE APESCODE TO INDEX INTO MESSAGE MODULE IGTMBR TO CONSTRUCT */
*   /* THE ERROR MESSAGE.                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0214
*   MXMSG='';                       /* INITIALIZE MESSAGE AREA       */
@RF00212 MVI   MXMSG(R1P),C' '                                  01S0214
         MVC   MXMSG+1(80,R1P),MXMSG(R1P)                       01S0214
*   MXSSID=APCTSSID;                /* SUBSYSTEM NAME (VPSS)         */
         MVC   MXSSID(4,R1P),APCTSSID(APCTPTR)                  01S0215
*   DINDEX=APESMVMS(APESCODE);      /* MESSAGE NUMBER                */
         SLR   @15,@15                                          01S0216
         IC    @15,APESCODE(,RAPESPTR)                          01S0216
         SLA   @15,3                                            01S0216
         L     @14,APESAPMV(,RAPESPTR)                          01S0216
         AL    @14,@CF02635                                     01S0216
         LH    DINDEX,APESMVMS(@15,@14)                         01S0216
*   DMSGPTR=ADDR(APMVMSG);          /* POINT TO APPROPRIATE MESSAGE. */
         L     @15,APCTZMBR(,APCTPTR)                           01S0217
         L     @15,APMVHMSG(,@15)                               01S0217
         LR    DMSGPTR,@15                                      01S0217
*   IF DINDEX<=APMVMNBR&            /* IF OUT OF RANGE               */
*       DINDEX>0 THEN               /* THEN USE                      */
         C     DINDEX,APMVMNBR(,@15)                            01S0218
         BH    @RF00218                                         01S0218
         LTR   DINDEX,DINDEX                                    01S0218
         BNP   @RF00218                                         01S0218
*     DMSGPTR=DMSGPTR+DINDEX*LENGTH(APMVMMSG);/* MSG 0.              */
         LR    @00,DINDEX                                       01S0219
         MH    @00,@CH00064                                     01S0219
         ALR   DMSGPTR,@00                                      01S0219
*   MXMSGV=DMSGPTR->APMVMMSG;       /* MOVE MSG TO SDWA              */
@RF00218 MVC   MXMSGV(15,R1P),APMVMMSG(DMSGPTR)                 01S0220
*   DINDEX=APESMVKW(APESCODE);      /* KEYWORD NUMBER                */
         SLR   @15,@15                                          01S0221
         IC    @15,APESCODE(,RAPESPTR)                          01S0221
         SLA   @15,3                                            01S0221
         L     @14,APESAPMV(,RAPESPTR)                          01S0221
         AL    @14,@CF02636                                     01S0221
         LH    DINDEX,APESMVKW-2(@15,@14)                       01S0221
*   DKEYPTR=ADDR(APMVKWD);          /* POINT TO APPROPRIATE KEYWORD. */
         L     @15,APCTZMBR(,APCTPTR)                           01S0222
         L     @15,APMVHKWD(,@15)                               01S0222
         LR    DKEYPTR,@15                                      01S0222
*   IF DINDEX<=APMVKNBR&            /* IF OUT OF RANGE               */
*       DINDEX>0 THEN               /* THEN USE                      */
         C     DINDEX,APMVKNBR(,@15)                            01S0223
         BH    @RF00223                                         01S0223
         LTR   DINDEX,DINDEX                                    01S0223
         BNP   @RF00223                                         01S0223
*     DKEYPTR=DKEYPTR+DINDEX*LENGTH(APMVKKWD);/* KEYWORD-0           */
         LR    @00,DINDEX                                       01S0224
         SLA   @00,3                                            01S0224
         ALR   DKEYPTR,@00                                      01S0224
*   MXKYWORD=DKEYPTR->APMVKKWD;     /* MOVE KEYWORD TO SDWA          */
@RF00223 MVC   MXKYWORD(8,R1P),APMVKKWD(DKEYPTR)                01S0225
*   CVD(APESCODE,DCVD);             /* MAKE THE ERROR CODE PRINTABLE */
         SLR   @04,@04                                          01S0226
         IC    @04,APESCODE(,RAPESPTR)                          01S0226
         CVD   @04,DCVD                                         01S0226
*   DCVD7=DCVD7|'0F'X;              /* DECIMAL (01-99) AND MOVE      */
         OI    DCVD7,X'0F'                                      01S0227
*   UNPK(MXCODE,DCVD);              /* TO PRINT LINE.                */
         UNPK  MXCODE(2,R1P),DCVD(8)                            01S0228
*   MXMOD=SDWAMODN;                 /* MODULE NAME                   */
         MVC   MXMOD(8,R1P),SDWAMODN(R1P)                       01S0229
*   MXFRR=SDWAREXN;                 /* RECOVERY ROUTINE NAME         */
         MVC   MXFRR(8,R1P),SDWAREXN(R1P)                       01S0230
*   MXSDWA='SDWA=';                 /* SDWA ADDRESS IDENTIFIER       */
         MVC   MXSDWA(5,R1P),@CC02529                           01S0231
*   DWORK4=ADDR(SDWA);              /* CONVERT THE ADDRESS           */
         ST    R1P,DWORK4                                       01S0232
*   UNPK(MXSDWAA,DCVD(2:5));        /* TO PRINTABLE HEX.             */
         UNPK  MXSDWAA(7,R1P),DCVD+1(4)                         01S0233
*   TR(MXSDWAAT,CXTRTHX);           /* ADDRESS IS SIX CHARACTERS     */
         TR    MXSDWAAT(6,R1P),CXTRTHX                          01S0234
*   MXSDWAAB=' ';                   /* RESET LAST CHARACTER TO BLANK */
         MVI   MXSDWAAB(R1P),C' '                               01S0235
*   MXMSG1='SDUMP TAKEN';           /* SHOW IF ASSOCIATED SDUMP      */
         MVC   MXMSG1(11,R1P),@CC02532                          01S0236
*   IF APESFSDP=BOFF THEN           /* TAKEN. BUILD MSG "(NO) SDUMP  */
         TM    APESFSDP(RAPESPTR),B'00100000'                   01S0237
         BNZ   @RF00237                                         01S0237
*     MXNO='NO';                    /* TAKEN" IN LOGREC HEADER.      */
         MVC   MXNO(2,R1P),@CC02534                             01S0238
*   MXSDUMPL=LENGTH(MXSDUMP)-       /* LENGTH OF SDUMP HEADER        */
*       LENGTH(MXSDUMPL);           /* (LENGTH FIELD NOT INCLUDED).  */
@RF00237 MVI   MXSDUMPL(R1P),X'40'                              01S0239
*   SDWAURAL=LENGTH(MXMSG);         /* LENGTH OF DATA                */
         MVI   SDWAURAL(R1P),X'51'                              01S0240
*   SDWAHEX=BOFF;                   /* HEX DUMP NOT NEEDED           */
*   SDWAEBC=BON;                    /* DUMP IN EBCDIC WANTED         */
         OI    SDWAEBC(R1P),B'01000000'                         01S0242
         NI    SDWAHEX(R1P),B'01111111'                         01S0242
*                                                               01S0243
*   /*****************************************************************/
*   /*                                                               */
*   /* ISSUE SDUMP. IF ENTERED BECAUSE OF SETFRR, USE THE BRANCH     */
*   /* ENTRY TO SDUMP. OTHERWISE ISSUE AN SVC.                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0243
*   IF APESFSDP=BON THEN            /* IF SDUMP REQUESTED,           */
         TM    APESFSDP(RAPESPTR),B'00100000'                   01S0243
         BNO   @RF00243                                         01S0243
*     DO;                           /* BUILD & ISSUE REQUEST.        */
*       SDWAEAS=BON;                /* SERVICEABILITY DATA PROVIDED  */
         OI    SDWAEAS(R1P),B'00001000'                         01S0245
*       RFY                                                     01S0246
*         RMSGPTR RSTD;             /* POINT TO SDUMP HEADER         */
*       RMSGPTR=ADDR(MXSDUMP);      /* MESSAGE IN THE SDWA.          */
*                                                               01S0247
         LA    RMSGPTR,MXSDUMP(,R1P)                            01S0247
*       /*************************************************************/
*       /*                                                           */
*       /* ISSUE SDUMP (BRANCH OR SVC)                               */
*       /*                                                           */
*       /*************************************************************/
*                                                               01S0248
*       GEN(MVC   DXSDUMP,CXSDUMP)                              01S0248
*       REFS(CXSDUMP) SETS(DXSDUMP);/* INITIALIZE SDUMP LIST         */
         MVC   DXSDUMP,CXSDUMP
*       IF APESFLLK=BON THEN        /* IF LOCAL LOCK OWNED (FRR)     */
         TM    APESFLLK(RAPESPTR),B'00100000'                   01S0249
         BNO   @RF00249                                         01S0249
*         IF APESSU33=BOFF THEN     /* IF SU-33 NOT APPLIED          */
         TM    APESSU33(RAPESPTR),B'10000000'                   01S0250
         BNZ   @RF00250                                         01S0250
*           GEN REFS(DXSDUMP,CVTPTR,CVTSDMP,CVTMAP,RMSGPTR,DASID1) SETS
*               (DXSDUMP,R0F,R1F,R14F,R15F);                    01S0251
*                                              /*
         SDUMP BRANCH=YES,         LOCAL LOCK OWNED  (NO SVCS)         *
               ASID=DASID1,        DUMP OUR ADDRESS SPACE              *
               HDRAD=(RMSGPTR),    TITLE                               *
               MF=(E,DXSDUMP)      EXECUTE FORMAT
*         ELSE                      /* IF SU-33 APPLIED --           */
*           GEN REFS(DXSDUMP,CVTPTR,CVTSDMP,CVTMAP,RMSGPTR,DASIDX) SETS
*               (DXSDUMP,R0F,R1F,R14F,R15F);                    01S0252
         B     @RC00250                                         01S0252
@RF00250 DS    0H                                               01S0252
*                                                /*
         AIF   (NOT &SGIHASU(33)).SU33N04 SKIP IF SU-33 NOT ON
         SDUMP BRANCH=YES,         LOCAL LOCK OWNED  (NO SVCS)         *
               ASIDLST=DASIDX,     DUMP FAILING ADDRESS SPACE + MONITOR*
               HDRAD=(RMSGPTR),    TITLE                               *
               MF=(E,DXSDUMP)      EXECUTE FORMAT
         AGO   .SU33Y04                SKIP EXPANSION FOR NO SU-33
.SU33N04 ANOP  ,                       SU-33 NOT APPLIED
.SU33Y04 ANOP  ,                       SDUMP WITH SU-33 PROCESSED
*       ELSE                        /* IF BRANCH ENTRY NOT WANTED -- */
*         IF APESSU33=BOFF THEN     /* IF SU-33 NOT APPLIED --       */
         B     @RC00249                                         01S0253
@RF00249 TM    APESSU33(RAPESPTR),B'10000000'                   01S0253
         BNZ   @RF00253                                         01S0253
*           GEN REFS(DXSDUMP,RMSGPTR) SETS(DXSDUMP,R0F,R1F,R14F,R15F);
*                                                /*
           SDUMP BRANCH=NO,        LOCAL LOCK NOT OWNED                *
               HDRAD=(RMSGPTR),    TITLE                               *
               MF=(E,DXSDUMP)      EXECUTE FORMAT
*         ELSE                      /* IF SU-33 APPLIED --           */
*           GEN REFS(DXSDUMP,RMSGPTR,DASIDX) SETS(DXSDUMP,R0F,R1F,R14F,
*               R15F);                                          01S0255
         B     @RC00253                                         01S0255
@RF00253 DS    0H                                               01S0255
*                                                /*
         AIF   (NOT &SGIHASU(33)).SU33N05 SKIP IF SU-33 NOT ON
         SDUMP BRANCH=NO,          LOCAL LOCK NOT OWNED                *
               ASIDLST=DASIDX,     DUMP FAILING ADDRESS SPACE + MONITOR*
               HDRAD=(RMSGPTR),    TITLE                               *
               MF=(E,DXSDUMP)      EXECUTE FORMAT
         AGO   .SU33Y05                SKIP EXPANSION FOR NO SU-33
.SU33N05 ANOP  ,                       SU-33 NOT APPLIED
.SU33Y05 ANOP  ,                       SDUMP WITH SU-33 PROCESSED
*     END;                          /* SDUMP PROCESSED               */
@RC00253 DS    0H                                               01S0256
@RC00249 DS    0H                                               01S0257
*   RFY                                                         01S0257
*     RMSGPTR UNRSTD;               /* DONE WITH SDUMP HEADER        */
@RF00243 DS    0H                                               01S0258
*   R1P=RSDWAPTR;                   /* RE-INITIALIZE SDWA POINTER    */
*                                                               01S0258
         LR    R1P,RSDWAPTR                                     01S0258
*   /*****************************************************************/
*   /*                                                               */
*   /* IF THIS IS A RECURSION ENTRY (APESFPRV=1) OR NO RETRY IS      */
*   /* WANTED (APESFRTY=1) THEN INDICATE SO IN THE SDWA.             */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0259
*   IF APESFPRV=BON|                /* IF THIS IS RECURSION ENTRY    */
*       APESFRTY=BON THEN           /* OR NO RETRY WANTED,           */
         TM    APESFPRV(RAPESPTR),B'01000000'                   01S0259
         BO    @RT00259                                         01S0259
         TM    APESFRTY(RAPESPTR),B'00001000'                   01S0259
         BNO   @RF00259                                         01S0259
@RT00259 DS    0H                                               01S0260
*     DO;                           /* SETRP WKAREA(ADDR(SDWA))RC(0) */
*       RESPECIFY                                               01S0261
*        (GPR00P,                                               01S0261
*         GPR01P,                                               01S0261
*         GPR14P,                                               01S0261
*         GPR15P) RSTD;                                         01S0261
*       GPR01P=ADDR(SDWA);                                      01S0262
*       GPR01P->SDWARCDE=0;         /* SAVE RC VALUE                 */
         MVI   SDWARCDE(GPR01P),X'00'                           01S0263
*       RESPECIFY                                               01S0264
*        (GPR00P,                                               01S0264
*         GPR01P,                                               01S0264
*         GPR14P,                                               01S0264
*         GPR15P) UNRSTD;                                       01S0264
*     END;                          /* NO RETRY                      */
*   ELSE                            /* IF NOT RECURSION --           */
*                                                               01S0266
*     /***************************************************************/
*     /*                                                             */
*     /* IF NON-RECURSIVE ENTRY AND RETRY WANTED, ESTABLISH REGISTERS*/
*     /* AND INDICATE IN SDWA THAT RETRY IS WANTED.                  */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0266
*     DO;                           /* ESTABLISH RETRY VALUES --     */
         B     @RC00259                                         01S0266
@RF00259 DS    0H                                               01S0267
*       SDWASRSV=APESREGS;          /* RETRY REGISTERS               */
         L     @04,APESREGP(,RAPESPTR)                          01S0267
         MVC   SDWASRSV(64,R1P),APESREGS(@04)                   01S0267
*       SDWASR00=ADDR(APES);        /* 'APES' ADDRESS                */
         ST    RAPESPTR,SDWASR00(,R1P)                          01S0268
*       SDWASR01=ADDR(APESSDWA);    /* SAVED 'SDWA' ADDRESS          */
         LA    @04,APESSDWA(,RAPESPTR)                          01S0269
         ST    @04,SDWASR01(,R1P)                               01S0269
*       DO;                         /* SETRP WKAREA(ADDR(SDWA))RC(4)R
*                                      ETADDR(SDWASR15->I031P)RETREGS
*                                      (YES)FRESDWA(YES)             */
*         RESPECIFY                                             01S0271
*          (GPR00P,                                             01S0271
*           GPR01P,                                             01S0271
*           GPR14P,                                             01S0271
*           GPR15P) RSTD;                                       01S0271
*         GPR01P=ADDR(SDWA);                                    01S0272
*         GPR01P->SDWARCDE=4;       /* STORE RC INTO SDWA            */
         MVI   SDWARCDE(GPR01P),X'04'                           01S0273
*         GPR01P->SDWARTYA=ADDR(SDWASR15->I031P);/* SAVE RETRY  01S0274
*                                      ADDRESS                       */
         L     @04,SDWASR15(,R1P)                               01S0274
         ST    @04,SDWARTYA(,GPR01P)                            01S0274
*         GPR01P->SDWAFREE='1'B;    /* SET FLAG TO FREE SDWA         */
*         GPR01P->SDWAUPRG='1'B;    /* TURN ON RETREGS INDICATOR     */
         OI    SDWAFREE(GPR01P),B'00001100'                     01S0276
*         RESPECIFY                                             01S0277
*          (GPR00P,                                             01S0277
*           GPR01P,                                             01S0277
*           GPR14P,                                             01S0277
*           GPR15P) UNRSTD;                                     01S0277
*       END;                        /* FREE SDWA BEFORE RETRY        */
*     END;                          /* SDWA UPDATED                  */
*                                                               01S0279
*   /*****************************************************************/
*   /*                                                               */
*   /* SINCE APESSDWA MAY BE SUBSTITUTING AS A SAVEAREA/WORKAREA     */
*   /* (ESTAE EXIT GETMAIN FAILED), AND THE REAL SDWA IS TO BE COPIED*/
*   /* TO APESSDWA, NO FURTHER REFERENCES TO THE PL/S DYNAMIC AREA OR*/
*   /* THE SAVEAREA MAY BE MADE.                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0280
*   GEN(DROP  APDATA)                                           01S0280
*   NOSETS REFS(APDATA);            /* TELL ASSEMBLER NO DYNAMIC AREA*/
*                                                               01S0280
@RC00259 DS    0H                                               01S0280
         DROP  APDATA
*   /*****************************************************************/
*   /*                                                               */
*   /* IF INITIAL ABEND, SAVE ERROR CODE (APESCODE) AND THE SDWA.    */
*   /* THIS INSURES THE DUMP DESCRIBES THE INITIAL ABEND PROBLEM.    */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0281
*   IF APESCOD1=0 THEN              /* IF STILL 0, IS 1ST ABEND      */
         CLI   APESCOD1(RAPESPTR),0                             01S0281
         BNE   @RF00281                                         01S0281
*     DO;                           /* THEREFORE SAVE DATA.          */
*       APESCOD1=APESCODE;          /* SAVE ERROR CODE               */
         IC    @04,APESCODE(,RAPESPTR)                          01S0283
         STC   @04,APESCOD1(,RAPESPTR)                          01S0283
*       RFY                                                     01S0284
*        (R0P,                                                  01S0284
*         R1F,                                                  01S0284
*         R14P,                                                 01S0284
*         R15F) RSTD;               /* USE MVCL TO SAVE              */
*       R0P=R1F;                    /* SDWA SINCE MORE               */
         LR    R0P,R1F                                          01S0285
*       R1F=LENGTH(SDWA);           /* THAN 256 BYTES LONG.          */
         LA    R1F,512                                          01S0286
*       R15F=R1F;                   /* NOTE: AFTER MVCL, REGISTER 1  */
         LR    R15F,R1F                                         01S0287
*       R14P=ADDR(APESSDWA);        /* NO LONGER POINTS TO SDWA,     */
         LA    R14P,APESSDWA(,RAPESPTR)                         01S0288
*       MVCL(R14P,R0P);             /* THEREFORE MUST                */
         MVCL  R14P,R0P                                         01S0289
*       RFY                                                     01S0290
*        (R0P,                                                  01S0290
*         R1F,                                                  01S0290
*         R14P,                                                 01S0290
*         R15F) UNRSTD;             /* RE-INITIALIZE THE             */
*       R1P=RSDWAPTR;               /* SDWA POINTER                  */
         LR    R1P,RSDWAPTR                                     01S0291
*       APESFSDI=BOFF;              /* SHOW SAVED SDWA IS VALID      */
         NI    APESFSDI(RAPESPTR),B'11111011'                   01S0292
*     END;                          /* 1ST ABEND PROCESSING DONE.    */
*                                                               01S0293
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESSING COMPLETE. IF THE SAVEAREA/WORKAREA WAS OBTAINED VIA*/
*   /* A GETMAIN (APESFGM=1) THEN FREE THE STORAGE BEFORE EXITING.   */
*   /* RETURN TO ABEND TO EITHER CONTINUE THE ABEND OR SCHEDULE A    */
*   /* RETRY ROUTINE.                                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0294
*   IF APESFGM=BON THEN             /* IF GETMAIN ISSUED,            */
@RF00281 TM    APESFGM(RAPESPTR),B'00001000'                    01S0294
         BNO   @RF00294                                         01S0294
*     DO;                           /* THEN FREE STORAGE.            */
*       GEN(FREEMAIN R,LV=200,SP=253,A=(APDATA))                01S0296
*       REFS(APDATA);               /* APDATA POINTS TO ACQUIRED AREA*/
         FREEMAIN R,LV=200,SP=253,A=(APDATA)
*       R1P=RSDWAPTR;               /* RE-ESTABLISH SDWA POINTER (R1)*/
         LR    R1P,RSDWAPTR                                     01S0297
*     END;                          /* STORAGE FREED.                */
*   APESFPRV=BON;                   /* SHOW RETRY SCHEDULED. RETRY
*                                      ROUTINE MUST RESET WHEN  01S0299
*                                      RECOVERY COMPLETE.            */
@RF00294 OI    APESFPRV(RAPESPTR),B'01000000'                   01S0299
*   RFY                                                         01S0300
*     R14P RSTD;                    /* HOLDS RETURN ADDRESS          */
*   R14P=APESR14S;                  /* R14P = INPUT VALUE OF R14     */
         L     R14P,APESR14S(,RAPESPTR)                         01S0301
*   RETURN;                         /* RETURN TO ABEND MODULE        */
         B     @EL00001                                         01S0302
*   RFY                                                         01S0303
*     R14P UNRSTD;                  /* FINISHED WITH R14             */
*   RFY                                                         01S0304
*    (SDWA,                                                     01S0304
*     APES);                        /* FINISHED WITH SDWA AND APES   */
*   RFY                                                         01S0305
*    (R1P,                                                      01S0305
*     RSDWAPTR,                                                 01S0305
*     RAPESPTR) UNRSTD;             /* RELEASE REGISTER POINTERS     */
         EJECT
*                                   /* IGTXEPLG                      */
*                                                               01S0306
*   /*****************************************************************/
*   /*                                                               */
*   /* SYSTEM DECLARES                                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0306
*   DECLARE                         /* GENERAL PURPOSE REGISTERS     */
*     GPR00P PTR(31) REG(0),                                    01S0306
*     GPR01P PTR(31) REG(1),                                    01S0306
*     GPR14P PTR(31) REG(14),                                   01S0306
*     GPR15P PTR(31) REG(15);                                   01S0306
*   DECLARE                         /* COMMON VARIABLES              */
*     I256C CHAR(256) BASED,                                    01S0307
*     I031F FIXED(31) BASED,                                    01S0307
*     I031P PTR(31) BASED,                                      01S0307
*     I015F FIXED(15) BASED,                                    01S0307
*     I015P PTR(15) BASED,                                      01S0307
*     I008P PTR(8) BASED,                                       01S0307
*     I001C CHAR(1) BASED;                                      01S0307
*                                                               01S0308
*   /*****************************************************************/
*   /*                                                               */
*   /* MODULE PATCH AREA                                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0308
*   DCL                                                         01S0308
*     APPATCH CHAR(*) INT STATIC LOCAL GEND;                    01S0308
*   GENERATE DATA DEFS(APPATCH);                                01S0309
*                                                               01S0310
*   /*****************************************************************/
*   /*                                                               */
*   /* GENERAL REGISTER DECLARES                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0310
*   DCL                                                         01S0310
*     R0F FIXED(31) REG(0),                                     01S0310
*     R0P PTR(24) REG(0),                                       01S0310
*     R0RSTD PTR(31) REG(0),                                    01S0310
*     R1F FIXED(31) REG(1),                                     01S0310
*     R1P PTR(24) REG(1),                                       01S0310
*     R1RSTD PTR(31) REG(1),                                    01S0310
*     R2F FIXED(31) REG(2),                                     01S0310
*     R2P PTR(24) REG(2),                                       01S0310
*     R2RSTD PTR(31) REG(2),                                    01S0310
*     R3F FIXED(31) REG(3),                                     01S0310
*     R3P PTR(24) REG(3),                                       01S0310
*     R3RSTD PTR(31) REG(3),                                    01S0310
*     R4F FIXED(31) REG(4),                                     01S0310
*     R4P PTR(24) REG(4),                                       01S0310
*     R4RSTD PTR(31) REG(4),                                    01S0310
*     R5F FIXED(31) REG(5),                                     01S0310
*     R5P PTR(24) REG(5),                                       01S0310
*     R5RSTD PTR(31) REG(5),                                    01S0310
*     R6F FIXED(31) REG(6),                                     01S0310
*     R6P PTR(24) REG(6),                                       01S0310
*     R6RSTD PTR(31) REG(6),                                    01S0310
*     R7F FIXED(31) REG(7),                                     01S0310
*     R7P PTR(24) REG(7),                                       01S0310
*     R7RSTD PTR(31) REG(7),                                    01S0310
*     R8F FIXED(31) REG(8),                                     01S0310
*     R8P PTR(24) REG(8),                                       01S0310
*     R8RSTD PTR(31) REG(8),                                    01S0310
*     R9F FIXED(31) REG(9),                                     01S0310
*     R9P PTR(24) REG(9),                                       01S0310
*     R9RSTD PTR(31) REG(9),                                    01S0310
*     R10F FIXED(31) REG(10),                                   01S0310
*     R10P PTR(24) REG(10),                                     01S0310
*     R10RSTD PTR(31) REG(10),                                  01S0310
*     R11F FIXED(31) REG(11),                                   01S0310
*     R11P PTR(24) REG(11),                                     01S0310
*     R11RSTD PTR(31) REG(11),                                  01S0310
*     R12F FIXED(31) REG(12),                                   01S0310
*     R12P PTR(24) REG(12),                                     01S0310
*     R12RSTD PTR(31) REG(12),                                  01S0310
*     R13F FIXED(31) REG(13),                                   01S0310
*     R13P PTR(24) REG(13),                                     01S0310
*     R13RSTD PTR(31) REG(13),                                  01S0310
*     R14F FIXED(31) REG(14),                                   01S0310
*     R14P PTR(24) REG(14),                                     01S0310
*     R14RSTD PTR(31) REG(14),                                  01S0310
*     R15F FIXED(31) REG(15),                                   01S0310
*     R15P PTR(24) REG(15),                                     01S0310
*     R15RSTD PTR(31) REG(15),                                  01S0310
*                                                               01S0310
*     /***************************************************************/
*     /*                                                             */
*     /* VPSS CONTROL BLOCK POINTER DECLARES                         */
*     /*                                                             */
*     /***************************************************************/
*                                                               01S0310
*     APSMPTR PTR(24) REG(01),      /* STORAGE MANAGEMENT BLOCK 01S0310
*                                      (SUGGESTED POINTER)           */
*     APSCPTR PTR(24) REG(01),      /* STORAGE MANAGEMENT CONTROL
*                                      WORD (SUGGESTED POINTER)      */
*     APINPTR PTR(24) REG(01),      /* USER'S INPUT PARAMETER LIST
*                                      (SUGGESTED POINTER)           */
*/*                                                                  */
*                                                               01S0310
*     APDATA PTR(24) REG(06),       /* ADDRESS OF DYNAMIC DATA  01S0310
*                                      WORKAREA (DATAREG)            */
*     APCODE PTR(24) REG(07),       /* PROGRAM CODE BASE REGISTER
*                                      (CODEREG)                     */
*     APDEBPTR PTR(24) REG(08),     /* VPSS DEB (SUGGESTED POINTER)  */
*     APNPPTR PTR(24) REG(08),      /* SUBSYSTEM INITIALIZATION 01S0310
*                                      WORKAREA BLOCK (ONLY USED BY
*                                      SUBSYSTEM INITIALIZATION)     */
*     APRLPTR PTR(24) REG(08),      /* VPSS ACB REQUEST LIST    01S0310
*                                      (SUGGESTED POINTER)           */
*     APCIPTR PTR(24) REG(08),      /* 3838 CONTROL TABLE (SUGGESTED
*                                      POINTER)                      */
*     APCWPTR PTR(24) REG(08),      /* CALL INTERFACE WORKAREA  01S0310
*                                      (SUGGESTED POINTER)           */
*     APERPTR PTR(24) REG(08),      /* ERP/IO APPENDAGE WORKAREA
*                                      (SUGGESTED POINTER)           */
*     APACBPTR PTR(24) REG(09),     /* VPSS ACB (SUGGESTED POINTER)  */
*     APCQPTR PTR(24) REG(09),      /* COMMAND QUEUE ELEMENT    01S0310
*                                      (SUGGESTED POINTER)           */
*     APOTPTR PTR(24) REG(09),      /* OPTION TABLE (SUGGESTED  01S0310
*                                      POINTER)                      */
*     APIOPTR PTR(24) REG(10),      /* I/O ELEMENT (SUGGESTED   01S0310
*                                      POINTER)                      */
*     APEXLPTR PTR(24) REG(10),     /* VPSS EXLST (SUGGESTED POINTER)*/
*     APUBPTR PTR(24) REG(10),      /* UNIT BLOCK (SUGGESTED POINTER)*/
*     APAXPTR PTR(24) REG(10),      /* VPSS ACB EXTENSION (SUGGESTED
*                                      POINTER)                      */
*     APCPPTR PTR(24) REG(10),      /* VPSS CALL PROCESSING     01S0310
*                                      INDICATORS (SUGGESTED POINTER)*/
*     APOCPTR PTR(24) REG(10),      /* VPSS OPEN/CLOSE SUBSYSTEM
*                                      WORKAREA (REQUIRED POINTER)   */
*     APATPTR PTR(24) REG(11),      /* VPSS ACB TABLE (SUGGESTED
*                                      POINTER)                      */
*     APLBPTR PTR(24) REG(11),      /* LABEL RESOLUTION TABLE   01S0310
*                                      (SUGGESTED POINTER)           */
*     APUTPTR PTR(24) REG(11),      /* USER TABLE (SUGGESTED POINTER)*/
*     APDSPTR PTR(24) REG(11),      /* VPSS DATASET ENTRY (SUGGESTED
*                                      POINTER)                      */
*     APXLPTR PTR(24) REG(11),      /* TRANSLATION TABLE (SUGGESTED
*                                      POINTER)                      */
*     APDXPTR PTR(24) REG(11),      /* VPSS DEB EXTENSION (SUGGESTED
*                                      POINTER)                      */
*     APCTPTR PTR(24) REG(12) RSTD, /* CONTROL TABLE (REQUIRED  01S0310
*                                      POINTER)                      */
*     APSVPTR PTR(24) REG(13) RSTD, /* OS/VPSS SAVEAREA/WORKAREA
*                                      (REQUIRED POINTER)            */
*     APRETURN PTR(24) REG(14),     /* RETURN ADDRESS FOR SUBROUTINE
*                                      LINKAGE                       */
*     APENTRY PTR(24) REG(15),      /* SUBROUTINE ENTRY POINT LINKAGE*/
*     APRCODE PTR(24) REG(15);      /* CONTAINS SUBROUTINE RETURN
*                                      CODE                          */
*                                                               01S0311
*   /*****************************************************************/
*   /*                                                               */
*   /* USER REGISTER DECLARES                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0311
*   DCL                             /* LOCAL REGISTERS               */
*     RMSGPTR PTR(24) REG(02),      /* POINT TO SDUMP TITLE LOCATED
*                                      IN THE SDWA VARIABLE AREA     */
*     RSDWAPTR PTR(24) REG(03),     /* NON-VOLITILE REGISTER TO HOLD
*                                      SDWA ADDRESS--R1P IS SDWA BASE*/
*     RAPESPTR PTR(24) REG(05);     /* APES REGISTER BASE            */
*   END IGTUKA                                                  01S0312
*                                                               01S0312
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IGTXSYSI)                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHASUBIT)                                       */
*/*%INCLUDE SYSLIB  (IHAFRRS )                                       */
*/*%INCLUDE SYSLIB  (IHAASCB )                                       */
*/*%INCLUDE SYSLIB  (IKJTCB  )                                       */
*/*%INCLUDE SYSLIB  (IHASDWA )                                       */
*/*%INCLUDE SYSLIB  (IGTXAPES)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPCT)                                       */
*/*%INCLUDE SYSLIB  (IGTXAPMV)                                       */
*                                                               01S0312
*       ;                                                       01S0312
         B     @EL00001                                         01S0312
@DATA    DS    0H
@CH00064 DC    H'15'
@DATD    DSECT
         DS    0F
IGTUKA   CSECT
         DS    0F
@CF00045 DC    F'4'
@CF02492 DC    F'12'
@CF02635 DC    F'-8'
@CF02636 DC    F'-6'
@CF02632 DC    XL4'0000FFFF'
@CF02515 DC    XL4'8000'
@DATD    DSECT
         DS    0D
DASIDX   DS    CL4
         ORG   DASIDX
DASID1   DS    FL2
DASID2   DS    FL2
         ORG   DASIDX+4
         DS    CL4
DCVD     DS    CL8
         ORG   DCVD
@NM00139 DS    CL7
         ORG   @NM00139
DWORK4   DS    FL4
         ORG   DCVD+7
DCVD7    DS    CL1
         ORG   DCVD+8
DSVEAREA DS    CL72
IGTUKA   CSECT
         NOPR  ((@ENDDATD-@DATD)/201*16)
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
@CC02532 DC    C'SDUMP TAKEN'
@CC02524 DC    C'IGTUKA  '
@CC02529 DC    C'SDWA='
@CC02134 DC    C'APES'
@CC02534 DC    C'NO'
CCSECT   DC    CL24'UNKNOWN UNKNOWN IGTUKA  '
@DATD    DSECT
*                                     /*
         AIF   (NOT &SGIHASU(33)).SU33N03 SKIP IF SU-33 NOT ON
DXSDUMP1 SDUMP HDRAD=*-*,              TITLE ADDRESS ADDED BY EXECUTE  *
               SDATA=(SQA,ALLPSA,NUC,RGN,TRT,CSA,LPA), DUMP OPTIONS    *
               BUFFER=NO,              SQA BUFFER NOT WANTED           *
               QUIESCE=YES,            STATIC PICTURE OF SQA/CSA       *
               MF=L                    MACRO LIST FORMAT WANTED
         AGO   .SU33Y03              SKIP EXPANSION FOR NO SU-33
.SU33N03 ANOP  ,                       SU-33 NOT APPLIED
DXSDUMP1 SDUMP HDRAD=*-*,              TITLE ADDRESS ADDED BY EXECUTE  *
               SDATA=(SQA,ALLPSA,NUC,RGN,TRT,CSA,LPA), DUMP OPTIONS    *
               BUFFER=NO,              SQA BUFFER NOT WANTED           *
               QUIESCE=YES,            STATIC PICTURE OF SQA/CSA       *
               MF=L                    MACRO LIST FORMAT WANTED
.SU33Y03 ANOP  ,                       DXSDUMP NOW GENERATED
DXSDUMP  EQU   DXSDUMP1,*-DXSDUMP1,C'C' MAKE DXSDUMP START AT SDUMP    *
                                       MACRO & COVER ENTIRE EXPANSION
         SPACE 3
IGTUKA   CSECT
*                                     /*
         AIF   (NOT &SGIHASU(33)).SU33N01 SKIP IF SU-33 NOT ON
CXSDUMP1 SDUMP HDRAD=*-*,              TITLE ADDRESS ADDED BY EXECUTE  *
               SDATA=(SQA,ALLPSA,NUC,RGN,TRT,CSA,LPA), DUMP OPTIONS    *
               BUFFER=NO,              SQA BUFFER NOT WANTED           *
               QUIESCE=YES,            STATIC PICTURE OF SQA/CSA       *
               MF=L                    MACRO LIST FORMAT WANTED
         AGO   .SU33Y01              SKIP EXPANSION FOR NO SU-33
.SU33N01 ANOP  ,                       SU-33 NOT APPLIED
CXSDUMP1 SDUMP HDRAD=*-*,              TITLE ADDRESS ADDED BY EXECUTE  *
               SDATA=(SQA,ALLPSA,NUC,RGN,TRT,CSA,LPA), DUMP OPTIONS    *
               BUFFER=NO,              SQA BUFFER NOT WANTED           *
               QUIESCE=YES,            STATIC PICTURE OF SQA/CSA       *
               MF=L                    MACRO LIST FORMAT WANTED
.SU33Y01 ANOP  ,                       CXSDUMP NOW GENERATED
CXSDUMP  EQU   CXSDUMP1,*-CXSDUMP1,C'C' MAKE CXSDUMP START AT SDUMP    *
                                       MACRO & COVER ENTIRE EXPANSION
         SPACE 3
IGTUKA   CSECT
         AIF   (NOT &SGIHASU(33)).SU33N02  SKIP IF SU-33 NOT ON
CXSNAP1  SNAP  SDATA=(CB,Q,LSQA,TRT,DM,IO,ERR),  REQUIRED SYSTEM DATA  *
               MF=L                    * WITH SU-33
         AGO   .SU33Y02                SKIP NON-SU33 EXPANSION
.SU33N02 ANOP  ,                       SU-33 NOT APPLIED
CXSNAP1  SNAP  SDATA=(CB,Q,LSQA,TRT),  REQUIRED SYSTEM DATA            *
               MF=L                    * WITH SU-33 NOT APPLIED
.SU33Y02 ANOP  ,                       SNAP MACRO NOW EXPANDED
CXSNAP   EQU   CXSNAP1,*-CXSNAP1,C'C'  MAKE CXSNAP START AT SNAP       *
                                       MACRO & COVER ENTIRE EXPANSION
IGTUKA   CSECT
*                                   /* 'APESEXRA' EXIT CODE
CUXINSTR LM    R0F,R14F,8(R14F)      RELOAD SAVED REGISTERS
         B     LUEXIT                RETURN TO MAINLINE CODE
IGTUKA   CSECT
*                                     /*
         SPACE 1
         ORG   *-C'0'                  ELIMINATE UNUSED POSITIONS
CXTRTHX  DS    0CL256                  TRANSLATION TABLE
         ORG   *+C'0'                  SKIP TO FIRST NEEDED SLOT
         DC    C'0123456789ABCDEF'     PRINTABLE VALUES
         ORG   ,                       SKIP TO END
IGTUKA   CSECT
*                                   /* GENERATE PATCH
         IGTXZAP ,                 GENERATE PATCH AREA
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IGTUKA   CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
DKEYPTR  EQU   @04
DMSGPTR  EQU   @04
DINDEX   EQU   @02
APCODE   EQU   @07
FRRSPTR  EQU   @00
FRREPTR  EQU   @00
SDWAPTR  EQU   @00
APCTPTR  EQU   @12
R0F      EQU   @00
R14F     EQU   @14
R1P      EQU   @01
R14P     EQU   @14
RAPESPTR EQU   @05
GPR00P   EQU   @00
GPR01P   EQU   @01
GPR14P   EQU   @14
GPR15P   EQU   @15
RSDWAPTR EQU   @03
APDATA   EQU   @06
R15F     EQU   @15
R13P     EQU   @13
R0P      EQU   @00
R15P     EQU   @15
R2P      EQU   @02
RMSGPTR  EQU   @02
R1F      EQU   @01
APSVPTR  EQU   @13
APACBPTR EQU   @09
APATPTR  EQU   @11
APAXPTR  EQU   @10
APCIPTR  EQU   @08
APCPPTR  EQU   @10
APCQPTR  EQU   @09
APCWPTR  EQU   @08
APDEBPTR EQU   @08
APDSPTR  EQU   @11
APDXPTR  EQU   @11
APENTRY  EQU   @15
APERPTR  EQU   @08
APEXLPTR EQU   @10
APINPTR  EQU   @01
APIOPTR  EQU   @10
APLBPTR  EQU   @11
APNPPTR  EQU   @08
APOCPTR  EQU   @10
APOTPTR  EQU   @09
APRCODE  EQU   @15
APRETURN EQU   @14
APRLPTR  EQU   @08
APSCPTR  EQU   @01
APSMPTR  EQU   @01
APUBPTR  EQU   @10
APUTPTR  EQU   @11
APXLPTR  EQU   @11
R0RSTD   EQU   @00
R1RSTD   EQU   @01
R10F     EQU   @10
R10P     EQU   @10
R10RSTD  EQU   @10
R11F     EQU   @11
R11P     EQU   @11
R11RSTD  EQU   @11
R12F     EQU   @12
R12P     EQU   @12
R12RSTD  EQU   @12
R13F     EQU   @13
R13RSTD  EQU   @13
R14RSTD  EQU   @14
R15RSTD  EQU   @15
R2F      EQU   @02
R2RSTD   EQU   @02
R3F      EQU   @03
R3P      EQU   @03
R3RSTD   EQU   @03
R4F      EQU   @04
R4P      EQU   @04
R4RSTD   EQU   @04
R5F      EQU   @05
R5P      EQU   @05
R5RSTD   EQU   @05
R6F      EQU   @06
R6P      EQU   @06
R6RSTD   EQU   @06
R7F      EQU   @07
R7P      EQU   @07
R7RSTD   EQU   @07
R8F      EQU   @08
R8P      EQU   @08
R8RSTD   EQU   @08
R9F      EQU   @09
R9P      EQU   @09
R9RSTD   EQU   @09
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
FLCCVT   EQU   FLCICCW2
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSATOLD  EQU   PSA+540
PSAAOLD  EQU   PSA+548
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
SUBITS   EQU   0
SUBYTE1  EQU   SUBITS
SUBYTE2  EQU   SUBITS+1
SUBYTE3  EQU   SUBITS+2
SUBYTE4  EQU   SUBITS+3
SUBYTE5  EQU   SUBITS+4
SU33BIT  EQU   SUBYTE5
SUBYTE6  EQU   SUBITS+5
SUBYTE7  EQU   SUBITS+6
SUBYTE8  EQU   SUBITS+7
SUBYTE9  EQU   SUBITS+8
SUBYTE10 EQU   SUBITS+9
SUBYTE11 EQU   SUBITS+10
SUBYTE12 EQU   SUBITS+11
SUBYTE13 EQU   SUBITS+12
FRRS     EQU   0
FRRSHEAD EQU   FRRS
FRRSENTR EQU   0
FRRSFLGS EQU   FRRSENTR+4
FRRSFLG1 EQU   FRRSFLGS
ASCB     EQU   0
ASCBSUPC EQU   ASCB+16
ASCBASID EQU   ASCB+36
ASCBFW1  EQU   ASCB+100
ASCBRCTF EQU   ASCBFW1+2
ASCBFLG1 EQU   ASCBFW1+3
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
ASCBLKGP EQU   ASCB+128
ASCBSRQ  EQU   ASCB+180
ASCBSRQ1 EQU   ASCBSRQ
ASCBSRQ2 EQU   ASCBSRQ+1
ASCBSRQ3 EQU   ASCBSRQ+2
ASCBSRQ4 EQU   ASCBSRQ+3
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBJPQ   EQU   TCB+44
TCBPURGE EQU   TCBJPQ
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTME   EQU   TCB+120
TCBJSTCB EQU   TCB+124
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBXSCT  EQU   TCB+240
TCBXSCT1 EQU   TCBXSCT
TCBFOE   EQU   TCB+244
TCBESTAE EQU   TCB+264
TCBESTRM EQU   TCBESTAE+1
TCBFBYT1 EQU   TCB+276
TCBFBYT2 EQU   TCB+277
TCBRV124 EQU   TCB+278
TCBRV133 EQU   TCB+279
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
TCBRV146 EQU   TCBXTNT2+28
TCBRV155 EQU   TCBXTNT2+29
TCBRV164 EQU   TCBXTNT2+30
TCBRV173 EQU   TCBXTNT2+31
SDWA     EQU   0
SDWAPARM EQU   SDWA
SDWAFIOB EQU   SDWA+4
SDWAABCC EQU   SDWAFIOB
SDWACMPF EQU   SDWAABCC
SDWAREQ  EQU   SDWACMPF
SDWACTL1 EQU   SDWA+8
SDWACMKA EQU   SDWACTL1
SDWAMWPA EQU   SDWACTL1+1
SDWAPMKA EQU   SDWACTL1+4
SDWACTL2 EQU   SDWA+16
SDWACMKP EQU   SDWACTL2
SDWAMWPP EQU   SDWACTL2+1
SDWAPMKP EQU   SDWACTL2+4
SDWAGRSV EQU   SDWA+24
SDWANAME EQU   SDWA+88
SDWAEC1  EQU   SDWA+104
SDWAEMK1 EQU   SDWAEC1
SDWAMWP1 EQU   SDWAEC1+1
SDWAINT1 EQU   SDWAEC1+2
SDWANXT1 EQU   SDWAEC1+4
SDWAAEC1 EQU   SDWA+112
SDWAILC1 EQU   SDWAAEC1+1
SDWAINC1 EQU   SDWAAEC1+2
SDWAICD1 EQU   SDWAINC1+1
SDWAEC2  EQU   SDWA+120
SDWAEMK2 EQU   SDWAEC2
SDWAMWP2 EQU   SDWAEC2+1
SDWAINT2 EQU   SDWAEC2+2
SDWANXT2 EQU   SDWAEC2+4
SDWAAEC2 EQU   SDWA+128
SDWAILC2 EQU   SDWAAEC2+1
SDWAINC2 EQU   SDWAAEC2+2
SDWAICD2 EQU   SDWAINC2+1
SDWASRSV EQU   SDWA+136
SDWASR00 EQU   SDWASRSV
SDWASR01 EQU   SDWASRSV+4
SDWASR15 EQU   SDWASRSV+60
SDWAIDNT EQU   SDWA+200
SDWAMCH  EQU   SDWA+204
SDWASTCK EQU   SDWAMCH
SDWAMCHI EQU   SDWAMCH+8
SDWAMCHS EQU   SDWAMCHI
SDWAMCHD EQU   SDWAMCHI+1
SDWARSR1 EQU   SDWAMCH+12
SDWARSR2 EQU   SDWAMCH+13
SDWAFLGS EQU   SDWA+232
SDWAERRA EQU   SDWAFLGS
SDWAERRB EQU   SDWAFLGS+1
SDWAERRC EQU   SDWAFLGS+2
SDWAEAS  EQU   SDWAERRC
SDWAERRD EQU   SDWAFLGS+3
SDWACLUP EQU   SDWAERRD
SDWACTS  EQU   SDWAERRD
SDWAMABD EQU   SDWAERRD
SDWAIOFS EQU   SDWA+238
SDWARTYA EQU   SDWA+240
SDWACPUA EQU   SDWA+248
SDWAPARQ EQU   SDWA+252
SDWARCDE EQU   SDWAPARQ
SDWAACF2 EQU   SDWAPARQ+1
SDWARCRD EQU   SDWAACF2
SDWAUPRG EQU   SDWAACF2
SDWAFREE EQU   SDWAACF2
SDWAACF3 EQU   SDWAPARQ+2
SDWAACF4 EQU   SDWAPARQ+3
SDWALKWA EQU   SDWA+256
SDWALKWS EQU   SDWALKWA
SDWARECP EQU   SDWA+292
SDWAMODN EQU   SDWARECP
SDWAREXN EQU   SDWARECP+16
SDWASNPA EQU   SDWA+320
SDWADUMP EQU   SDWASNPA
SDWADPFS EQU   SDWADUMP+1
SDWADLST EQU   SDWADPFS
SDWAENSN EQU   SDWADPFS
SDWASLST EQU   SDWADPFS
SDWADDAT EQU   SDWASNPA+4
SDWASDAT EQU   SDWADDAT
SDWASDA0 EQU   SDWASDAT
SDWASDA1 EQU   SDWASDAT+1
SDWAPDAT EQU   SDWADDAT+2
SDWADPSA EQU   SDWA+328
SDWADPSL EQU   SDWADPSA
SDWAFRM1 EQU   SDWADPSL
SDWAFRM2 EQU   SDWADPSL+8
SDWAFRM3 EQU   SDWADPSL+16
SDWAFRM4 EQU   SDWADPSL+24
SDWATO4  EQU   SDWADPSL+28
SDWARA   EQU   SDWA+400
SDWADPVA EQU   SDWARA+2
SDWAHEX  EQU   SDWADPVA
SDWAEBC  EQU   SDWADPVA
SDWAURAL EQU   SDWARA+3
SDWAVRA  EQU   SDWARA+4
APES     EQU   0
APESID   EQU   APES
APESAPMV EQU   APES+12
APESFLGS EQU   APES+16
APESFLG0 EQU   APESFLGS
APESFDMP EQU   APESFLG0
APESFREC EQU   APESFLG0
APESFSDP EQU   APESFLG0
APESFRTY EQU   APESFLG0
APESFEXR EQU   APESFLG0
APESFLG1 EQU   APESFLGS+1
APESFFRR EQU   APESFLG1
APESFPRV EQU   APESFLG1
APESFLLK EQU   APESFLG1
APESFXLK EQU   APESFLG1
APESFGM  EQU   APESFLG1
APESFSDI EQU   APESFLG1
APESSUID EQU   APES+18
APESSU33 EQU   APESSUID
APESCODE EQU   APES+19
APESCOD1 EQU   APES+20
APESCNTR EQU   APES+21
APESMXCD EQU   APES+22
APESEXRA EQU   APES+36
APESR14S EQU   APES+40
APESREGP EQU   APES+44
APESREGZ EQU   APES+48
APESMOD  EQU   APES+112
APESFRR  EQU   APES+128
APESSDWA EQU   APES+136
APESREGS EQU   0
APESREG2 EQU   APESREGS+8
APESREGC EQU   APESREGS+48
APESREGF EQU   APESREGS+60
APESMV   EQU   0
APESMVMS EQU   APESMV
APESMVKW EQU   APESMV+2
APCT     EQU   0
APCTENQM EQU   APCT+12
APCTSSID EQU   APCTENQM+4
APCTSMIN EQU   APCT+32
APCTSMAD EQU   APCT+36
APCTZ@@@ EQU   APCT+40
APCTU@@@ EQU   APCT+440
APCTBR14 EQU   APCT+840
APCTERRS EQU   APCT+876
@NM00106 EQU   APCT+936
APCTSTAT EQU   @NM00106
APCTPRSW EQU   @NM00106+1
APCTAPCQ EQU   APCT+944
APCTCQAQ EQU   APCT+952
APCTZ@@1 EQU   APCT+1120
APCTASID EQU   APCT+1528
APMV     EQU   0
APMVHDR  EQU   APMV
APMVHKWD EQU   APMVHDR+4
APMVHMSG EQU   APMVHDR+8
APMVKWD  EQU   0
APMVKNBR EQU   APMVKWD
APMVKKWD EQU   APMVKWD+4
APMVMSG  EQU   0
APMVMNBR EQU   APMVMSG
APMVMMSG EQU   APMVMSG+4
I031P    EQU   0
I256C    EQU   0
I001C    EQU   0
I008P    EQU   0
I015F    EQU   0
I015P    EQU   0
I031F    EQU   0
PSARSVTE EQU   PSARSVT
CVTPTR   EQU   FLCCVT
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTSDMP  EQU   CVTS01+232
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
CVTIHASU EQU   CVTS01+696
ASCBPTR  EQU   PSAAOLD
TCBPTR   EQU   PSATOLD
MXMSG    EQU   SDWAVRA
MXSDUMP  EQU   MXMSG
MXSDUMPL EQU   MXSDUMP
MXSSID   EQU   MXSDUMP+1
MXMSGV   EQU   MXSDUMP+6
MXKYWORD EQU   MXSDUMP+22
MXCODE   EQU   MXSDUMP+31
MXMOD    EQU   MXSDUMP+34
MXFRR    EQU   MXSDUMP+43
MXSDWA   EQU   MXSDUMP+52
MXSDWAA  EQU   MXSDUMP+57
MXSDWAAT EQU   MXSDWAA
MXSDWAAB EQU   MXSDWAA+6
MXNO     EQU   MXMSG+67
MXMSG1   EQU   MXMSG+70
APCTZ    EQU   APCTZ@@@
APCTZMBR EQU   APCTZ+100
APCTZ1   EQU   APCTZ@@1
APCTU    EQU   APCTU@@@
DUXDATA  EQU   SDWAVRA
DUXINSTR EQU   DUXDATA
DUXREGS  EQU   DUXDATA+8
FLC      EQU   PSA
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00138 EQU   APCTU+48
APCT1JBJ EQU   APCTU+44
APCT2JHL EQU   APCTU+40
APCT1JHL EQU   APCTU+36
APCT1JHT EQU   APCTU+32
APCT2JHC EQU   APCTU+28
APCT1JHC EQU   APCTU+24
APCT1JAA EQU   APCTU+20
APCT1MBM EQU   APCTU+16
APCT1CMD EQU   APCTU+12
APCT2MBD EQU   APCTU+8
APCT1MBD EQU   APCTU+4
APCT1MAB EQU   APCTU
@NM00137 EQU   APCTZ1+108
APCTZKGD EQU   APCTZ1+104
APCTZKGC EQU   APCTZ1+100
APCTZKGB EQU   APCTZ1+96
APCTZKGA EQU   APCTZ1+92
APCTZJAX EQU   APCTZ1+88
APCTZDWI EQU   APCTZ1+84
APCTZLCB EQU   APCTZ1+80
APCTZLCA EQU   APCTZ1+76
APCTZJDM EQU   APCTZ1+72
APCTZJDG EQU   APCTZ1+68
APCTZJDD EQU   APCTZ1+64
APCTZKBF EQU   APCTZ1+60
APCTZUKA EQU   APCTZ1+56
@NM00136 EQU   APCTZ1+52
@NM00135 EQU   APCTZ1+48
@NM00134 EQU   APCTZ1+44
APCTZKBE EQU   APCTZ1+40
@NM00133 EQU   APCTZ1+36
@NM00132 EQU   APCTZ1+32
APCTZKBD EQU   APCTZ1+28
APCTZJHQ EQU   APCTZ1+24
APCTZJHC EQU   APCTZ1+20
@NM00131 EQU   APCTZ1+16
@NM00130 EQU   APCTZ1+12
APCTZKBB EQU   APCTZ1+8
APCTZKBC EQU   APCTZ1+4
APCTZKBA EQU   APCTZ1
@NM00129 EQU   APCTZ+396
APCTZJHW EQU   APCTZ+392
APCTZJHT EQU   APCTZ+388
APCTZJHR EQU   APCTZ+384
APCTZDQR EQU   APCTZ+380
APCTZJHE EQU   APCTZ+376
APCTZJHF EQU   APCTZ+372
APCTZJHO EQU   APCTZ+368
APCTZJH6 EQU   APCTZ+364
APCTZJDJ EQU   APCTZ+360
APCTZJDA EQU   APCTZ+356
@NM00128 EQU   APCTZ+352
@NM00127 EQU   APCTZ+348
APCTZKDA EQU   APCTZ+344
APCTZKCA EQU   APCTZ+340
@NM00126 EQU   APCTZ+336
APCTZJBM EQU   APCTZ+332
APCTZJBJ EQU   APCTZ+328
APCTZJBG EQU   APCTZ+324
APCTZJBD EQU   APCTZ+320
APCTZJBA EQU   APCTZ+316
APCTZJJ0 EQU   APCTZ+312
APCTZJI3 EQU   APCTZ+308
APCTZJI0 EQU   APCTZ+304
APCTZJH0 EQU   APCTZ+300
APCTZMIF EQU   APCTZ+296
@NM00125 EQU   APCTZ+292
APCTZD83 EQU   APCTZ+288
APCTZMIC EQU   APCTZ+284
APCTZMIB EQU   APCTZ+280
APCTZD82 EQU   APCTZ+276
APCTZKAA EQU   APCTZ+272
APCTZDAP EQU   APCTZ+268
APCTZUJA EQU   APCTZ+264
APCTZUFA EQU   APCTZ+260
APCTZJAY EQU   APCTZ+256
APCTZJAP EQU   APCTZ+252
APCTZJAM EQU   APCTZ+248
APCTZJAJ EQU   APCTZ+244
APCTZJAG EQU   APCTZ+240
APCTZJAD EQU   APCTZ+236
APCTZJAA EQU   APCTZ+232
APCTZJFA EQU   APCTZ+228
APCTZUHB EQU   APCTZ+224
APCTZUHA EQU   APCTZ+220
APCTZDIO EQU   APCTZ+216
APCTZUAG EQU   APCTZ+212
APCTZUAF EQU   APCTZ+208
APCTZDUA EQU   APCTZ+204
APCTZDDQ EQU   APCTZ+200
APCTZDEQ EQU   APCTZ+196
APCTZDUL EQU   APCTZ+192
APCTZDDA EQU   APCTZ+188
APCTZDIP EQU   APCTZ+184
APCTZDBK EQU   APCTZ+180
APCTZDAL EQU   APCTZ+176
APCTZDMM EQU   APCTZ+172
APCTZDWT EQU   APCTZ+168
APCTZMJI EQU   APCTZ+164
APCTZDRI EQU   APCTZ+160
APCTZDID EQU   APCTZ+156
APCTZD81 EQU   APCTZ+152
APCTZDMD EQU   APCTZ+148
APCTZMMA EQU   APCTZ+144
APCTZMJH EQU   APCTZ+140
APCTZMJC EQU   APCTZ+136
APCTZMJB EQU   APCTZ+132
APCTZMBM EQU   APCTZ+128
APCTZMBK EQU   APCTZ+124
APCTZMBH EQU   APCTZ+120
APCTZDX4 EQU   APCTZ+116
APCTZDX3 EQU   APCTZ+112
APCTZDX2 EQU   APCTZ+108
APCTZDX1 EQU   APCTZ+104
APCTZMBG EQU   APCTZ+96
APCTZMBD EQU   APCTZ+92
APCTZMBA EQU   APCTZ+88
APCTZD4E EQU   APCTZ+84
APCTZD80 EQU   APCTZ+80
APCTZD60 EQU   APCTZ+76
APCTZD49 EQU   APCTZ+72
APCTZD48 EQU   APCTZ+68
APCTZD47 EQU   APCTZ+64
APCTZD46 EQU   APCTZ+60
APCTZD45 EQU   APCTZ+56
APCTZD44 EQU   APCTZ+52
APCTZD43 EQU   APCTZ+48
APCTZD42 EQU   APCTZ+44
APCTZD41 EQU   APCTZ+40
APCTZD40 EQU   APCTZ+36
APCTZD20 EQU   APCTZ+32
APCTZD10 EQU   APCTZ+28
APCTZUBB EQU   APCTZ+24
@NM00124 EQU   APCTZ+20
APCTZUAE EQU   APCTZ+16
APCTZUAD EQU   APCTZ+12
APCTZUAC EQU   APCTZ+8
APCTZUAB EQU   APCTZ+4
APCTZUAA EQU   APCTZ
@NM00083 EQU   MXMSG+69
@NM00082 EQU   MXMSG+65
@NM00081 EQU   MXSDUMP+51
@NM00080 EQU   MXSDUMP+42
@NM00079 EQU   MXSDUMP+33
@NM00078 EQU   MXSDUMP+30
@NM00077 EQU   MXSDUMP+21
@NM00076 EQU   MXSDUMP+5
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
APMVHEM  EQU   APMVHDR
@NM00123 EQU   APCT+1556
APCTSVCT EQU   APCT+1552
APCTDAVT EQU   APCT+1548
APCTLOGL EQU   APCT+1544
@NM00122 EQU   APCT+1540
APCTDMPU EQU   APCT+1536
APCTDMPM EQU   APCT+1532
APCTNDMP EQU   APCT+1530
APCTLGPG EQU   APCT+1526
APCTLGLN EQU   APCT+1524
APCTAPVU EQU   APCT+1520
APCTABR  EQU   APCT+1116
APCTACTR EQU   APCT+1112
APCTLOGD EQU   APCT+1108
APCTDCLD EQU   APCT+1104
APCTIOAP EQU   APCT+1100
@NM00121 EQU   APCT+1080
@NM00120 EQU   APCT+1078
APCTKCAX EQU   APCT+1076
APCTABND EQU   APCT+1072
@NM00119 EQU   APCT+1068
APCTAPIO EQU   APCT+1064
APCTCSCT EQU   APCT+1060
APCTSTDF EQU   APCT+1056
APCTSTMX EQU   APCT+1052
APCTRGMX EQU   APCT+1048
APCTSIZE EQU   APCT+1046
APCTCTUB EQU   APCT+1045
APCTMFID EQU   APCT+1044
APCTMFSZ EQU   APCT+1040
APCTCRTN EQU   APCT+1036
APCTAPCP EQU   APCT+1032
APCTAMNA EQU   APCT+1028
APCTEMNA EQU   APCT+1024
APCTAALP EQU   APCT+1020
APCTEALP EQU   APCT+1016
@NM00118 EQU   APCT+1012
@NM00117 EQU   APCT+1008
@NM00116 EQU   APCT+1004
APCTEIPL EQU   APCT+1000
@NM00115 EQU   APCT+996
@NM00114 EQU   APCT+992
@NM00113 EQU   APCT+988
@NM00112 EQU   APCT+984
@NM00111 EQU   APCT+980
APCTECPW EQU   APCT+976
APCTEULD EQU   APCT+972
APCTECPT EQU   APCT+968
APCTEALC EQU   APCT+964
APCTECBL EQU   APCT+960
APCTECIT EQU   APCT+956
APCTCQAF EQU   APCTCQAQ
APCTCQL  EQU   APCTAPCQ+4
APCTCQF  EQU   APCTAPCQ
APCTCQLK EQU   APCT+940
@NM00110 EQU   @NM00106+2
@NM00109 EQU   APCTPRSW
APCTAPST EQU   APCTPRSW
@NM00108 EQU   APCTPRSW
@NM00107 EQU   APCTSTAT
APCTWARM EQU   APCTSTAT
APCTTERM EQU   APCTSTAT
APCTHALT EQU   APCTSTAT
APCTQSCE EQU   APCTSTAT
APCTSTRT EQU   APCTSTAT
APCTACT  EQU   APCTSTAT
@NM00105 EQU   APCT+935
APCTSOUT EQU   APCT+934
APCTDAID EQU   APCT+933
APCTSV34 EQU   APCT+932
APCTMJOB EQU   APCT+928
APCTTCB  EQU   APCT+924
APCTASCB EQU   APCT+920
APCTDCNW EQU   APCT+918
APCTDCNR EQU   APCT+916
@NM00104 EQU   APCT+912
@NM00103 EQU   APCT+908
@NM00102 EQU   APCT+904
@NM00101 EQU   APCT+900
@NM00100 EQU   APCTERRS+22
APCTERTJ EQU   APCTERRS+20
APCTERTD EQU   APCTERRS+18
APCTERTC EQU   APCTERRS+16
APCTERTB EQU   APCTERRS+14
APCTERTA EQU   APCTERRS+12
APCTERT9 EQU   APCTERRS+10
APCTERT3 EQU   APCTERRS+8
APCTERT2 EQU   APCTERRS+6
APCTERT1 EQU   APCTERRS+4
APCTERT0 EQU   APCTERRS+2
APCTERTT EQU   APCTERRS
APCTDSAP EQU   APCT+872
APCTISUB EQU   APCT+868
APCTUBAP EQU   APCT+864
APCTAPDS EQU   APCT+860
APCTUBIC EQU   APCT+856
APCTUBIS EQU   APCT+852
APCTAPUB EQU   APCT+848
APCTUBLK EQU   APCT+844
APCTBR1A EQU   APCTBR14+2
@NM00099 EQU   APCTBR14
APCTSMSZ EQU   APCTSMAD+2
@NM00098 EQU   APCTSMAD+1
@NM00097 EQU   APCTSMAD
APCTSMIS EQU   APCTSMIN+2
@NM00096 EQU   APCTSMIN+1
APCTSMSP EQU   APCTSMIN
@NM00095 EQU   APCT+30
APCTLINE EQU   APCT+28
APCTLBSZ EQU   APCT+24
APCTREG  EQU   APCT+20
@NM00094 EQU   APCTENQM
APCTSSVT EQU   APCT+8
APCTUSER EQU   APCT+4
APCTID   EQU   APCT
@NM00093 EQU   APESMV+6
@NM00092 EQU   APESMV+4
APESRTRY EQU   APESREGF
APESREGE EQU   APESREGS+56
APESREGD EQU   APESREGS+52
APESREGB EQU   APESREGS+44
APESREGA EQU   APESREGS+40
APESREG9 EQU   APESREGS+36
APESREG8 EQU   APESREGS+32
APESREG7 EQU   APESREGS+28
APESREG6 EQU   APESREGS+24
APESREG5 EQU   APESREGS+20
APESREG4 EQU   APESREGS+16
APESREG3 EQU   APESREGS+12
APESREG1 EQU   APESREGS+4
APESREG0 EQU   APESREGS
APESPROC EQU   APES+120
@NM00091 EQU   APES+32
@NM00090 EQU   APES+28
@NM00089 EQU   APES+24
@NM00088 EQU   APES+23
@NM00087 EQU   APESSUID
@NM00086 EQU   APESFLG1
APESFSTE EQU   APESFLG1
@NM00085 EQU   APESFLG0
@NM00084 EQU   APESFLG0
APESADDR EQU   APES+8
APESUSER EQU   APES+4
@NM00075 EQU   SDWA+512
@NM00074 EQU   SDWADPVA
SDWAVRAL EQU   SDWARA
SDWAERTM EQU   SDWA+396
SDWACOMP EQU   SDWA+392
SDWARCPL EQU   SDWA+364
@NM00073 EQU   SDWADPSA+32
SDWATO3  EQU   SDWADPSL+20
SDWATO2  EQU   SDWADPSL+12
SDWATO1  EQU   SDWADPSL+4
@NM00072 EQU   SDWADDAT+3
@NM00071 EQU   SDWAPDAT
SDWAUSPL EQU   SDWAPDAT
SDWADPSW EQU   SDWAPDAT
SDWATJPA EQU   SDWAPDAT
SDWATLPA EQU   SDWAPDAT
SDWADREG EQU   SDWAPDAT
SDWADSAH EQU   SDWAPDAT
SDWADSAS EQU   SDWAPDAT
@NM00070 EQU   SDWASDA1
SDWAERR  EQU   SDWASDA1
SDWAIO   EQU   SDWASDA1
SDWADM   EQU   SDWASDA0
SDWAQQS  EQU   SDWASDA0
SDWACBS  EQU   SDWASDA0
SDWAGTF  EQU   SDWASDA0
SDWASWA  EQU   SDWASDA0
SDWALSQA EQU   SDWASDA0
SDWASQA  EQU   SDWASDA0
SDWANUC  EQU   SDWASDA0
@NM00069 EQU   SDWADUMP+2
@NM00068 EQU   SDWADPFS
@NM00067 EQU   SDWADPFS
SDWADPT  EQU   SDWADPFS
SDWADPID EQU   SDWADUMP
SDWADPLA EQU   SDWA+316
SDWACSCT EQU   SDWARECP+8
SDWASEQ# EQU   SDWA+290
SDWAASID EQU   SDWA+288
SDWATALW EQU   SDWALKWS+28
SDWATDLW EQU   SDWALKWS+24
SDWATNLW EQU   SDWALKWS+20
SDWAAPLW EQU   SDWALKWS+16
SDWAIPLW EQU   SDWALKWS+12
SDWAILLW EQU   SDWALKWS+8
SDWAIULW EQU   SDWALKWS+4
SDWAICLW EQU   SDWALKWS
SDWAFLLK EQU   SDWAACF4
SDWACMS  EQU   SDWAACF4
SDWAOPTM EQU   SDWAACF4
SDWATADB EQU   SDWAACF4
SDWATDNB EQU   SDWAACF4
SDWATNCB EQU   SDWAACF4
SDWAILCH EQU   SDWAACF4
SDWAIUCB EQU   SDWAACF4
SDWAICAT EQU   SDWAACF3
SDWAIPRG EQU   SDWAACF3
SDWASALL EQU   SDWAACF3
SDWAASMP EQU   SDWAACF3
SDWADISP EQU   SDWAACF3
@NM00066 EQU   SDWAACF3
@NM00065 EQU   SDWAACF2
@NM00064 EQU   SDWAACF2
SDWASPIN EQU   SDWAACF2
@NM00063 EQU   SDWAACF2
SDWALCPU EQU   SDWACPUA+2
@NM00062 EQU   SDWACPUA
SDWARECA EQU   SDWA+244
SDWACPUI EQU   SDWA+239
@NM00061 EQU   SDWAIOFS
SDWANIOP EQU   SDWAIOFS
SDWANOIO EQU   SDWAIOFS
SDWAIOHT EQU   SDWAIOFS
SDWAIOQR EQU   SDWAIOFS
SDWAFMID EQU   SDWA+236
SDWAERFL EQU   SDWAERRD
SDWAMCIV EQU   SDWAERRD
SDWARPIV EQU   SDWAERRD
SDWASTAE EQU   SDWAERRD
SDWANRBE EQU   SDWAERRD
@NM00060 EQU   SDWAERRC
SDWAPERC EQU   SDWAERRC
SDWAIRB  EQU   SDWAERRC
SDWASTAI EQU   SDWAERRC
SDWASTAF EQU   SDWAERRC
SDWASRBM EQU   SDWAERRB
SDWALDIS EQU   SDWAERRB
SDWAENRB EQU   SDWAERRB
SDWATYP1 EQU   SDWAERRB
@NM00059 EQU   SDWAERRB
SDWAPGIO EQU   SDWAERRA
SDWATEXC EQU   SDWAERRA
SDWASVCE EQU   SDWAERRA
SDWAABTM EQU   SDWAERRA
SDWASVCD EQU   SDWAERRA
SDWARKEY EQU   SDWAERRA
SDWAPCHK EQU   SDWAERRA
SDWAMCHK EQU   SDWAERRA
SDWATIME EQU   SDWAMCH+20
SDWARFSA EQU   SDWAMCH+16
@NM00058 EQU   SDWAMCH+14
SDWAVEQR EQU   SDWARSR2
SDWAPGFX EQU   SDWARSR2
SDWAFLSQ EQU   SDWARSR2
SDWAFSQA EQU   SDWARSR2
SDWANUCL EQU   SDWARSR2
SDWASPER EQU   SDWARSR2
SDWAINTC EQU   SDWARSR2
SDWAOFLN EQU   SDWARSR2
SDWACHNG EQU   SDWARSR1
SDWAMSER EQU   SDWARSR1
@NM00057 EQU   SDWARSR1
SDWACPID EQU   SDWAMCH+10
SDWATERR EQU   SDWAMCHD
SDWAFPRX EQU   SDWAMCHD
SDWAINSF EQU   SDWAMCHD
SDWAACR  EQU   SDWAMCHD
SDWASCK  EQU   SDWAMCHD
SDWAPSWU EQU   SDWAMCHD
SDWAREGU EQU   SDWAMCHD
SDWASKYF EQU   SDWAMCHD
@NM00056 EQU   SDWAMCHS
SDWARSRF EQU   SDWAMCHS
SDWARSRC EQU   SDWAMCHS
SDWAINVP EQU   SDWAMCHS
SDWATSVL EQU   SDWAMCHS
SDWARCDF EQU   SDWAMCHS
SDWASRVL EQU   SDWAMCHS
SDWASCKE EQU   SDWASTCK+4
SDWASCKB EQU   SDWASTCK
SDWALNTH EQU   SDWAIDNT+1
SDWASPID EQU   SDWAIDNT
SDWASR14 EQU   SDWASRSV+56
SDWASR13 EQU   SDWASRSV+52
SDWASR12 EQU   SDWASRSV+48
SDWASR11 EQU   SDWASRSV+44
SDWASR10 EQU   SDWASRSV+40
SDWASR09 EQU   SDWASRSV+36
SDWASR08 EQU   SDWASRSV+32
SDWASR07 EQU   SDWASRSV+28
SDWASR06 EQU   SDWASRSV+24
SDWASR05 EQU   SDWASRSV+20
SDWASR04 EQU   SDWASRSV+16
SDWASR03 EQU   SDWASRSV+12
SDWASR02 EQU   SDWASRSV+8
SDWATRN2 EQU   SDWAAEC2+4
SDWAIPC2 EQU   SDWAICD2
SDWAIMC2 EQU   SDWAICD2
SDWAIPR2 EQU   SDWAICD2
@NM00055 EQU   SDWAINC2
@NM00054 EQU   SDWAILC2
SDWAIL2  EQU   SDWAILC2
@NM00053 EQU   SDWAILC2
@NM00052 EQU   SDWAAEC2
SDWAADD2 EQU   SDWANXT2+1
@NM00051 EQU   SDWANXT2
@NM00050 EQU   SDWAEC2+3
SDWASGN2 EQU   SDWAINT2
SDWAEXP2 EQU   SDWAINT2
SDWADEC2 EQU   SDWAINT2
SDWAFPO2 EQU   SDWAINT2
SDWACC2  EQU   SDWAINT2
@NM00049 EQU   SDWAINT2
SDWAPGM2 EQU   SDWAMWP2
SDWAWAT2 EQU   SDWAMWP2
SDWAMCK2 EQU   SDWAMWP2
SDWAECT2 EQU   SDWAMWP2
SDWAKEY2 EQU   SDWAMWP2
SDWAEXT2 EQU   SDWAEMK2
SDWAIO2  EQU   SDWAEMK2
SDWATRM2 EQU   SDWAEMK2
@NM00048 EQU   SDWAEMK2
SDWAPER2 EQU   SDWAEMK2
@NM00047 EQU   SDWAEMK2
SDWATRAN EQU   SDWAAEC1+4
SDWAIPC1 EQU   SDWAICD1
SDWAIMC1 EQU   SDWAICD1
SDWAIPR1 EQU   SDWAICD1
@NM00046 EQU   SDWAINC1
@NM00045 EQU   SDWAILC1
SDWAIL1  EQU   SDWAILC1
@NM00044 EQU   SDWAILC1
@NM00043 EQU   SDWAAEC1
SDWAADD1 EQU   SDWANXT1+1
@NM00042 EQU   SDWANXT1
@NM00041 EQU   SDWAEC1+3
SDWASGN1 EQU   SDWAINT1
SDWAEXP1 EQU   SDWAINT1
SDWADEC1 EQU   SDWAINT1
SDWAFPO1 EQU   SDWAINT1
SDWACC1  EQU   SDWAINT1
@NM00040 EQU   SDWAINT1
SDWAPGM1 EQU   SDWAMWP1
SDWAWAT1 EQU   SDWAMWP1
SDWAMCK1 EQU   SDWAMWP1
SDWAECT1 EQU   SDWAMWP1
SDWAKEY1 EQU   SDWAMWP1
SDWAEXT1 EQU   SDWAEMK1
SDWAIO1  EQU   SDWAEMK1
SDWATRM1 EQU   SDWAEMK1
@NM00039 EQU   SDWAEMK1
SDWAPER1 EQU   SDWAEMK1
@NM00038 EQU   SDWAEMK1
SDWAIOBR EQU   SDWA+100
SDWAEPA  EQU   SDWA+96
@NM00037 EQU   SDWANAME+4
SDWARBAD EQU   SDWANAME
SDWAGR15 EQU   SDWAGRSV+60
SDWAGR14 EQU   SDWAGRSV+56
SDWAGR13 EQU   SDWAGRSV+52
SDWAGR12 EQU   SDWAGRSV+48
SDWAGR11 EQU   SDWAGRSV+44
SDWAGR10 EQU   SDWAGRSV+40
SDWAGR09 EQU   SDWAGRSV+36
SDWAGR08 EQU   SDWAGRSV+32
SDWAGR07 EQU   SDWAGRSV+28
SDWAGR06 EQU   SDWAGRSV+24
SDWAGR05 EQU   SDWAGRSV+20
SDWAGR04 EQU   SDWAGRSV+16
SDWAGR03 EQU   SDWAGRSV+12
SDWAGR02 EQU   SDWAGRSV+8
SDWAGR01 EQU   SDWAGRSV+4
SDWAGR00 EQU   SDWAGRSV
SDWANXTP EQU   SDWACTL2+5
SDWASGP  EQU   SDWAPMKP
SDWAEUP  EQU   SDWAPMKP
SDWADOP  EQU   SDWAPMKP
SDWAFPP  EQU   SDWAPMKP
SDWACCP  EQU   SDWAPMKP
SDWAILP  EQU   SDWAPMKP
SDWAINTP EQU   SDWACTL2+2
SDWASPVP EQU   SDWAMWPP
SDWAWATP EQU   SDWAMWPP
SDWAMCKP EQU   SDWAMWPP
@NM00036 EQU   SDWAMWPP
SDWAKEYP EQU   SDWAMWPP
SDWAEXTP EQU   SDWACMKP
SDWAIOP  EQU   SDWACMKP
SDWANXTA EQU   SDWACTL1+5
SDWASGA  EQU   SDWAPMKA
SDWAEUA  EQU   SDWAPMKA
SDWADOA  EQU   SDWAPMKA
SDWAFPA  EQU   SDWAPMKA
SDWACCA  EQU   SDWAPMKA
SDWAILA  EQU   SDWAPMKA
SDWAINTA EQU   SDWACTL1+2
SDWASPVA EQU   SDWAMWPA
SDWAWATA EQU   SDWAMWPA
SDWAMCKA EQU   SDWAMWPA
@NM00035 EQU   SDWAMWPA
SDWAKEYA EQU   SDWAMWPA
SDWAEXTA EQU   SDWACMKA
SDWAIOA  EQU   SDWACMKA
SDWACMPC EQU   SDWAABCC+1
@NM00034 EQU   SDWACMPF
SDWASTCC EQU   SDWACMPF
@NM00033 EQU   SDWACMPF
SDWASTEP EQU   SDWACMPF
@NM00032 EQU   TCBXTNT2+32
TCBRV181 EQU   TCBRV173
TCBRV180 EQU   TCBRV173
TCBRV179 EQU   TCBRV173
TCBRV178 EQU   TCBRV173
TCBRV177 EQU   TCBRV173
TCBRV176 EQU   TCBRV173
TCBRV175 EQU   TCBRV173
TCBRV174 EQU   TCBRV173
TCBRV172 EQU   TCBRV164
TCBRV171 EQU   TCBRV164
TCBRV170 EQU   TCBRV164
TCBRV169 EQU   TCBRV164
TCBRV168 EQU   TCBRV164
TCBRV167 EQU   TCBRV164
TCBRV166 EQU   TCBRV164
TCBRV165 EQU   TCBRV164
TCBRV163 EQU   TCBRV155
TCBRV162 EQU   TCBRV155
TCBRV161 EQU   TCBRV155
TCBRV160 EQU   TCBRV155
TCBRV159 EQU   TCBRV155
TCBRV158 EQU   TCBRV155
TCBRV157 EQU   TCBRV155
TCBRV156 EQU   TCBRV155
TCBRV154 EQU   TCBRV146
TCBRV153 EQU   TCBRV146
TCBRV152 EQU   TCBRV146
TCBRV151 EQU   TCBRV146
TCBRV150 EQU   TCBRV146
TCBRV149 EQU   TCBRV146
TCBRV148 EQU   TCBRV146
TCBRV147 EQU   TCBRV146
TCBRV145 EQU   TCBXTNT2+26
TCBRV144 EQU   TCBXTNT2+24
TCBRV143 EQU   TCBXTNT2+20
TCBRV142 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00031 EQU   TCB+296
TCBSVCA2 EQU   TCB+292
TCBSWASA EQU   TCB+288
TCBDBTB  EQU   TCB+284
TCBRPT   EQU   TCB+280
TCBRV141 EQU   TCBRV133
TCBRV140 EQU   TCBRV133
TCBRV139 EQU   TCBRV133
TCBRV138 EQU   TCBRV133
TCBRV137 EQU   TCBRV133
TCBRV136 EQU   TCBRV133
TCBRV135 EQU   TCBRV133
TCBRV134 EQU   TCBRV133
TCBRV132 EQU   TCBRV124
TCBRV131 EQU   TCBRV124
TCBRV130 EQU   TCBRV124
TCBRV129 EQU   TCBRV124
TCBRV128 EQU   TCBRV124
TCBRV127 EQU   TCBRV124
TCBRV126 EQU   TCBRV124
TCBRV125 EQU   TCBRV124
TCBRV123 EQU   TCBFBYT2
TCBRV122 EQU   TCBFBYT2
TCBECBNV EQU   TCBFBYT2
TCBSSSYN EQU   TCBFBYT2
TCBFPRAP EQU   TCBFBYT2
TCBFDW   EQU   TCBFBYT2
TCBFMW   EQU   TCBFBYT2
TCBCNCB  EQU   TCBFBYT2
TCBLLH   EQU   TCBFBYT1
TCBRV113 EQU   TCBFBYT1
TCBEOT   EQU   TCBFBYT1
TCBRTM2  EQU   TCBFBYT1
TCBPGNLY EQU   TCBFBYT1
TCBNDIOS EQU   TCBFBYT1
TCBRV327 EQU   TCBFBYT1
TCBEOTFM EQU   TCBFBYT1
TCBAFFN  EQU   TCB+274
TCBRV326 EQU   TCB+272
TCBUKYSP EQU   TCB+268
TCBMODE  EQU   TCBESTAE+3
TCBERTYP EQU   TCBESTAE+2
TCBRV314 EQU   TCBESTRM
TCBRV313 EQU   TCBESTRM
TCBRV312 EQU   TCBESTRM
TCBRV311 EQU   TCBESTRM
TCBRV310 EQU   TCBESTRM
TCBRV309 EQU   TCBESTRM
TCBRV308 EQU   TCBESTRM
TCBETERM EQU   TCBESTRM
TCBSCBKY EQU   TCBESTAE
TCBRTM12 EQU   TCB+260
TCBTCBID EQU   TCB+256
TCBSTAWA EQU   TCB+252
TCBSWA   EQU   TCB+248
TCBFOEA  EQU   TCBFOE+1
TCBRSV42 EQU   TCBFOE
TCBCCPVI EQU   TCBXSCT+2
TCBRV325 EQU   TCBXSCT+1
TCBRV324 EQU   TCBXSCT1
TCBRV323 EQU   TCBXSCT1
TCBRV322 EQU   TCBXSCT1
TCBRV321 EQU   TCBXSCT1
TCBRV320 EQU   TCBXSCT1
TCBRV319 EQU   TCBXSCT1
TCBS3A   EQU   TCBXSCT1
TCBACTIV EQU   TCBXSCT1
TCBRSV41 EQU   TCB+239
TCBTID   EQU   TCB+238
TCBRSVAA EQU   TCB+237
TCBABCUR EQU   TCB+236
TCBTMSAV EQU   TCB+232
TCBIOTIM EQU   TCB+228
TCBRTWA  EQU   TCB+224
TCBBACK  EQU   TCB+220
TCBTIRB  EQU   TCB+216
TCBAECB  EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBADMP  EQU   TCBFLGS7
TCBRSTSK EQU   TCBFLGS7
TCBSVCS  EQU   TCBFLGS7
TCBSTACK EQU   TCBFLGS7
TCBRSV34 EQU   TCBFLGS7
TCBRSV33 EQU   TCBFLGS7
TCBGPECB EQU   TCBFLGS7
TCBNTJS  EQU   TCBFLGS6
TCBAPG   EQU   TCBFLGS6
TCBMIGR  EQU   TCBFLGS6
TCBRV303 EQU   TCBFLGS6
TCBSPVLK EQU   TCBFLGS6
TCBCPU   EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBRSV95 EQU   TCBNDSP5
TCBRSV94 EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00030 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBNDINT EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBSRBND EQU   TCBNDSP3
TCBRV302 EQU   TCBNDSP3
TCBLJSND EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBSTCUR EQU   TCBNSTAE
TCBRV301 EQU   TCBNSTAE
TCBSYNCH EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBPPSUP EQU   TCBNSTAE
TCB33E   EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBAQE   EQU   TCB+156
TCBPQE   EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBJSTCA EQU   TCBJSTCB+1
TCBRSV16 EQU   TCBJSTCB
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBQEL   EQU   TCBFSA
TCBGRS15 EQU   TCBGRS+60
TCBGRS14 EQU   TCBGRS+56
TCBGRS13 EQU   TCBGRS+52
TCBGRS12 EQU   TCBGRS+48
TCBGRS11 EQU   TCBGRS+44
TCBGRS10 EQU   TCBGRS+40
TCBGRS9  EQU   TCBGRS+36
TCBGRS8  EQU   TCBGRS+32
TCBGRS7  EQU   TCBGRS+28
TCBGRS6  EQU   TCBGRS+24
TCBGRS5  EQU   TCBGRS+20
TCBGRS4  EQU   TCBGRS+16
TCBGRS3  EQU   TCBGRS+12
TCBGRS2  EQU   TCBGRS+8
TCBGRS1  EQU   TCBGRS+4
TCBGRS0  EQU   TCBGRS
TCBJPQB  EQU   TCBJPQ+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBDWSTA EQU   TCBFLGS3
TCBRSV08 EQU   TCBFLGS3
TCBRSV07 EQU   TCBFLGS3
TCBRSV06 EQU   TCBFLGS3
TCBABGM  EQU   TCBFLGS3
TCBABTRM EQU   TCBFLGS3
TCBADINP EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBFDSOP EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBFOINP EQU   TCBFLGS2
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBFT    EQU   TCBFLGS1
TCBPDUMP EQU   TCBFLGS1
TCBNONPR EQU   TCBFLGS1
TCBFERA  EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBTIO   EQU   TCB+12
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00029 EQU   TCBPMASK
TCBRBP   EQU   TCB
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBRV43 EQU   ASCBSRQ4
ASCBRV42 EQU   ASCBSRQ4
ASCBRV41 EQU   ASCBSRQ4
ASCBRV40 EQU   ASCBSRQ4
ASCBRV39 EQU   ASCBSRQ4
ASCBRV38 EQU   ASCBSRQ4
ASCBRV37 EQU   ASCBSRQ4
ASCBRV36 EQU   ASCBSRQ4
ASCBRV35 EQU   ASCBSRQ3
ASCBRV34 EQU   ASCBSRQ3
ASCBRV33 EQU   ASCBSRQ3
ASCBRV32 EQU   ASCBSRQ3
ASCBRV31 EQU   ASCBSRQ3
ASCBRV30 EQU   ASCBSRQ3
ASCBRV29 EQU   ASCBSRQ3
ASCBRV28 EQU   ASCBSRQ3
ASCBRV27 EQU   ASCBSRQ2
ASCBRV26 EQU   ASCBSRQ2
ASCBRV25 EQU   ASCBSRQ2
ASCBRV24 EQU   ASCBSRQ2
ASCBRV23 EQU   ASCBSRQ2
ASCBRV22 EQU   ASCBSRQ2
ASCBRV21 EQU   ASCBSRQ2
ASCBRV20 EQU   ASCBSRQ2
ASCBRV19 EQU   ASCBSRQ1
ASCBRV18 EQU   ASCBSRQ1
ASCBRV17 EQU   ASCBSRQ1
ASCBRV16 EQU   ASCBSRQ1
ASCBRV15 EQU   ASCBSRQ1
ASCBRV14 EQU   ASCBSRQ1
ASCBRV13 EQU   ASCBSRQ1
ASCBSTA  EQU   ASCBSRQ1
ASCBJBNS EQU   ASCB+176
ASCBJBNI EQU   ASCB+172
ASCBMCC  EQU   ASCB+168
ASCBRTWA EQU   ASCB+164
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUXB EQU   ASCB+148
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBQECB EQU   ASCB+136
ASCBLSQH EQU   ASCBLKGP+4
ASCBLOCK EQU   ASCBLKGP
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSRBS EQU   ASCB+118
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBS2S  EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBASXB EQU   ASCB+108
ASCBTMCH EQU   ASCB+104
ASCBNSWP EQU   ASCBFLG1
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBABNT EQU   ASCBFLG1
ASCBTERM EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBWAIT EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBAFFN EQU   ASCBFW1
ASCBDUMP EQU   ASCB+96
ASCBRV44 EQU   ASCB+92
ASCBUBET EQU   ASCB+88
ASCBECB  EQU   ASCB+84
ASCBJSTL EQU   ASCB+80
ASCBEWST EQU   ASCB+72
ASCBEJST EQU   ASCB+64
ASCBTSB  EQU   ASCB+60
ASCBCSCB EQU   ASCB+56
ASCBRSM  EQU   ASCB+52
ASCBLDA  EQU   ASCB+48
ASCBSTOR EQU   ASCB+44
ASCBDP   EQU   ASCB+43
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBCPUS EQU   ASCB+32
ASCBSPL  EQU   ASCB+28
ASCBIOSP EQU   ASCB+24
ASCBSYNC EQU   ASCBSUPC+4
ASCBSVRB EQU   ASCBSUPC
ASCBCMSF EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBFWDP EQU   ASCB+4
ASCBASCB EQU   ASCB
ASCBEGIN EQU   ASCB
FRRSPARM EQU   FRRSENTR+8
@NM00028 EQU   FRRSFLGS+1
@NM00027 EQU   FRRSFLG1
FRRSNEST EQU   FRRSFLG1
FRRSRCUR EQU   FRRSFLG1
FRRSFRRA EQU   FRRSENTR
FRRSENTS EQU   FRRS+84
FRRSRTMW EQU   FRRS+16
FRRSCURR EQU   FRRSHEAD+12
FRRSELEN EQU   FRRSHEAD+8
FRRSLAST EQU   FRRSHEAD+4
FRRSEMP  EQU   FRRSHEAD
SURV104  EQU   SUBITS+13
SURV103  EQU   SUBYTE13
SURV102  EQU   SUBYTE13
SURV101  EQU   SUBYTE13
SU100BT  EQU   SUBYTE13
SU99BIT  EQU   SUBYTE13
SU98BIT  EQU   SUBYTE13
SU97BIT  EQU   SUBYTE13
SU96BIT  EQU   SUBYTE13
SU95BIT  EQU   SUBYTE12
SU94BIT  EQU   SUBYTE12
SU93BIT  EQU   SUBYTE12
SU92BIT  EQU   SUBYTE12
SU91BIT  EQU   SUBYTE12
SU90BIT  EQU   SUBYTE12
SU89BIT  EQU   SUBYTE12
SU88BIT  EQU   SUBYTE12
SU87BIT  EQU   SUBYTE11
SU86BIT  EQU   SUBYTE11
SU85BIT  EQU   SUBYTE11
SU84BIT  EQU   SUBYTE11
SU83BIT  EQU   SUBYTE11
SU82BIT  EQU   SUBYTE11
SU81BIT  EQU   SUBYTE11
SU80BIT  EQU   SUBYTE11
SU79BIT  EQU   SUBYTE10
SU78BIT  EQU   SUBYTE10
SU77BIT  EQU   SUBYTE10
SU76BIT  EQU   SUBYTE10
SU75BIT  EQU   SUBYTE10
SU74BIT  EQU   SUBYTE10
SU73BIT  EQU   SUBYTE10
SU72BIT  EQU   SUBYTE10
SU71BIT  EQU   SUBYTE9
SU70BIT  EQU   SUBYTE9
SU69BIT  EQU   SUBYTE9
SU68BIT  EQU   SUBYTE9
SU67BIT  EQU   SUBYTE9
SU66BIT  EQU   SUBYTE9
SU65BIT  EQU   SUBYTE9
SU64BIT  EQU   SUBYTE9
SU63BIT  EQU   SUBYTE8
SU62BIT  EQU   SUBYTE8
SU61BIT  EQU   SUBYTE8
SU60BIT  EQU   SUBYTE8
SU59BIT  EQU   SUBYTE8
SU58BIT  EQU   SUBYTE8
SU57BIT  EQU   SUBYTE8
SU56BIT  EQU   SUBYTE8
SU55BIT  EQU   SUBYTE7
SU54BIT  EQU   SUBYTE7
SU53BIT  EQU   SUBYTE7
SU52BIT  EQU   SUBYTE7
SU51BIT  EQU   SUBYTE7
SU50BIT  EQU   SUBYTE7
SU49BIT  EQU   SUBYTE7
SU48BIT  EQU   SUBYTE7
SU47BIT  EQU   SUBYTE6
SU46BIT  EQU   SUBYTE6
SU45BIT  EQU   SUBYTE6
SU44BIT  EQU   SUBYTE6
SU43BIT  EQU   SUBYTE6
SU42BIT  EQU   SUBYTE6
SU41BIT  EQU   SUBYTE6
SU40BIT  EQU   SUBYTE6
SU39BIT  EQU   SUBYTE5
SU38BIT  EQU   SUBYTE5
SU37BIT  EQU   SUBYTE5
SU36BIT  EQU   SUBYTE5
SU35BIT  EQU   SUBYTE5
SU34BIT  EQU   SUBYTE5
SU32BIT  EQU   SUBYTE5
SU31BIT  EQU   SUBYTE4
SU30BIT  EQU   SUBYTE4
SU29BIT  EQU   SUBYTE4
SU28BIT  EQU   SUBYTE4
SU27BIT  EQU   SUBYTE4
SU26BIT  EQU   SUBYTE4
SU25BIT  EQU   SUBYTE4
SU24BIT  EQU   SUBYTE4
SU23BIT  EQU   SUBYTE3
SU22BIT  EQU   SUBYTE3
SU21BIT  EQU   SUBYTE3
SU20BIT  EQU   SUBYTE3
SU19BIT  EQU   SUBYTE3
SU18BIT  EQU   SUBYTE3
SU17BIT  EQU   SUBYTE3
SU16BIT  EQU   SUBYTE3
SU15BIT  EQU   SUBYTE2
SU14BIT  EQU   SUBYTE2
SU13BIT  EQU   SUBYTE2
SU12BIT  EQU   SUBYTE2
SU11BIT  EQU   SUBYTE2
SU10BIT  EQU   SUBYTE2
SU9BIT   EQU   SUBYTE2
SU8BIT   EQU   SUBYTE2
SU7BIT   EQU   SUBYTE1
SU6BIT   EQU   SUBYTE1
SU5BIT   EQU   SUBYTE1
SU4BIT   EQU   SUBYTE1
SU3BIT   EQU   SUBYTE1
SU2BIT   EQU   SUBYTE1
SU1BIT   EQU   SUBYTE1
SU0BIT   EQU   SUBYTE1
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00026 EQU   CVTFIX+248
@NM00025 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
@NM00024 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00023 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSALITA  EQU   PSA+764
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00022 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00021 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAANEW  EQU   PSA+544
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00020 EQU   FLCFSA
@NM00019 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00018 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00017 EQU   FLCIOA
@NM00016 EQU   FLCMCLA+15
@NM00015 EQU   FLCMCLA+14
@NM00014 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00013 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00012 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00011 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00010 EQU   FLCPER
@NM00009 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00008 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00007 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00006 EQU   FLCPIILC
@NM00005 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00004 EQU   FLCSVILC
@NM00003 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00002 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00001 EQU   FLCICCW2+4
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RT00188 EQU   E0012
@RC00250 EQU   @RC00249
@ENDDATA EQU   *
         END   IGTUKA,(C'PLS1629',0701,77092)
