         TITLE 'ILRFMTSW   ASM SWAP CONTROL-BLOCK FORMATTING MODULE    *
                        '
ILRFMTSW CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'ILRFMTSW  76.169'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @09,0                                               0001
@PSTART  LA    @10,4095(,@09)                                      0001
         USING @PSTART,@09                                         0001
         USING @PSTART+4095,@10                                    0001
         ST    @13,@SA00001+4                                      0001
         LA    @14,@SA00001                                        0001
         ST    @14,8(,@13)                                         0001
         LR    @13,@14                                             0001
*                                                                  0106
*/********************************************************************/
*/*                                                                  */
*/* SWAP:     SEGMENT TO FORMAT THE SART AND ALL ASSOCIATED SWAPPING */
*/*            CONTROL BLOCKS                                        */
*/*                                                                  */
*/* INPUT:    VIRTUAL ADDRESS OF THE SART IN SARTPTR                 */
*/*                                                                  */
*/* PROCESS:  (1) CALL SEGMENT TO FORMAT THE SART                    */
*/*           (2) ACCESS SDCT PTR AND CALL SEGMENT TO FORMAT SDCT    */
*/*           (3) ACCESS AND FORMAT AIA'S ON THE SART WAIT QUEUE     */
*/*                IF THERE ARE ANY                                  */
*/*           (4) PUT CORRESPONDING DATA SET NAME INTO HEADER WITH   */
*/*                SART ENTRY, UNLESS THAT ENTRY IS ZERO.            */
*/*           (5) CALL THE SEGMENT TO FORMAT THE SART ENTRY          */
*/*           (6) DO (4) AND (5) FOR EACH ENTRY                      */
*/*                                                                  */
*/* OUTPUT:   THE CUMULATIVE RETURN CODE FROM ALL SEGMENTS CALLED    */
*/*            NON-ZERO INDICATES AT LEAST ONE ERROR HAS OCCURRED IN */
*/*            THE CHAIN OF CALLS                                    */
*/*                                                                  */
*/********************************************************************/
*                                                                  0106
*   CUMRC=ZERO;                     /* INITIALIZE CUMRC TO ZERO    0106
*                                                            @ZM43066*/
         SLR   CUMRC,CUMRC                                         0106
*   RFY                                                            0107
*    (R1,                                                          0107
*     R3) RSTD;                                                    0107
*   ASMVTPTR=R3;                    /* GET THE ADDR OF THE ASMVT     */
         ST    R3,ASMVTPTR                                         0108
*   ABDPLPTR=R1;                    /* GET ADDR OF THE PARM LIST     */
         ST    R1,ABDPLPTR                                         0109
*   RFY                                                            0110
*    (R1,                                                          0110
*     R3) UNRSTD;                                                  0110
*                                                                  0110
*   /*****************************************************************/
*   /*                                                               */
*   /* GET THE ADDRESS OF THE SART FROM THE ASMVT                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0111
*   DO;                             /* ILRMACCS (SART) VIA(ASMSART)  */
*     RFY                                                          0112
*      (R0,                                                        0112
*       R1,                                                        0112
*       R14,                                                       0112
*       R15) RSTD;                                                 0112
*     R1=ABDPLPTR;                                                 0113
         L     @12,ABDPLPTR                                        0113
         LR    R1,@12                                              0113
*     R0=ADDR(ASMSART);             /* ADDR OF CELL WITH PTR         */
         L     @08,ASMVTPTR                                        0114
         LA    R0,ASMSART(,@08)                                    0114
*     CALL ACCESS;                  /* ACCESS PTR TO SART            */
         L     @15,ADPLMEMA(,@12)                                  0115
         BALR  @14,@15                                             0115
*     IF R15=GOOD THEN                                             0116
         LTR   R15,R15                                             0116
         BNZ   @RF00116                                            0116
*       DO;                         /* FOUND PTR - NOW FIND BLOCK    */
*         R14=R0;                   /* CANNOT USE R0 AS BASE REG     */
         LR    R14,R0                                              0118
*         R0=CURRENT;               /* POINTER ITSELF                */
         L     R0,CURRENT(,R14)                                    0119
*         SARTPTR=R0;               /* SAVE POINTER                  */
         ST    R0,SARTPTR                                          0120
*         CALL ACCESS;              /* ACCESS SART ITSELF            */
         L     @12,ABDPLPTR                                        0121
         L     @15,ADPLMEMA(,@12)                                  0121
         BALR  @14,@15                                             0121
*         IF R15^=GOOD THEN                                        0122
         SLR   @12,@12                                             0122
         CR    R15,@12                                             0122
         BE    @RF00122                                            0122
*           SARTPTR=NULLPTR;                                       0123
         ST    @12,SARTPTR                                         0123
*       END;                                                       0124
*     ELSE                                                         0125
*       SARTPTR=NULLPTR;                                           0125
         B     @RC00116                                            0125
@RF00116 SLR   @12,@12                                             0125
         ST    @12,SARTPTR                                         0125
*     RFY                                                          0126
*      (R0,                                                        0126
*       R1,                                                        0126
*       R14,                                                       0126
*       R15) UNRSTD;                                               0126
@RC00116 DS    0H                                                  0127
*   END;                            /* GET ADDR OF SART      @ZA11398*/
*                                                                  0128
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK TO SEE IF A POINTER WAS RETURNED. IF NOT THE SART IS NOT*/
*   /* ACCESSIBLE AND A MESSAGE WILL BE PRINTED. IF THE SART IS      */
*   /* AVAILABLE CALL FMTSART TO FORMAT IT.                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0128
*   IF SARTPTR^=NULLPTR THEN        /* ACCESS WAS SUCCESSFUL         */
         ICM   @12,15,SARTPTR                                      0128
         BZ    @RF00128                                            0128
*     DO;                           /* CONTINUE                      */
*       CALL FMTSART;               /* CALL SEGMENT TO FMT SART      */
         BAL   @14,FMTSART                                         0130
*       RFY                                                        0131
*         R15 RSTD;                                                0131
*       IF R15^=0 THEN              /* IS RETURN CODE GOOD           */
         LTR   R15,R15                                             0132
         BNZ   @RT00132                                            0132
*         GO TO NOSART;             /* NO PROCESS MESSAGE            */
*       RFY                                                        0134
*         R15 UNRSTD;                                              0134
*                                                                  0134
*       /*************************************************************/
*       /*                                                           */
*       /* GET THE ADDRESS OF THE SDCT AND IF IT IS AVAILABLE CALL   */
*       /* FMTSDCT FOR FORMATTING.                                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0135
*       DO;                         /* ILRMACCS (SDCTPTR)          0135
*                                      FROM(SARSDCT)                 */
*         RFY                                                      0136
*          (R0,                                                    0136
*           R1,                                                    0136
*           R14,                                                   0136
*           R15) RSTD;                                             0136
*         R0=ADDR(SARSDCT);                                        0137
         L     @12,SARTPTR                                         0137
         LA    R0,SARSDCT(,@12)                                    0137
*         R1=ABDPLPTR;              /* POINT TO PARM LIST            */
         L     @12,ABDPLPTR                                        0138
         LR    R1,@12                                              0138
*         CALL ACCESS;              /* ACCESS DATA                   */
         L     @15,ADPLMEMA(,@12)                                  0139
         BALR  @14,@15                                             0139
*         R14=R0;                   /* CANNOT USE R0 AS BASE         */
         LR    R14,R0                                              0140
*         IF R15=GOOD THEN          /* CHECK ACCESS                  */
         LTR   R15,R15                                             0141
         BNZ   @RF00141                                            0141
*           SDCTPTR=CURRENT;        /* GET REQUESTED FIELD           */
         MVC   SDCTPTR(4),CURRENT(R14)                             0142
*         ELSE                      /* ACCESS NO GOOD                */
*           SDCTPTR=ZERO;           /* ZERO FIELD                    */
         B     @RC00141                                            0143
@RF00141 SLR   @12,@12                                             0143
         ST    @12,SDCTPTR                                         0143
*         RFY                                                      0144
*          (R0,                                                    0144
*           R1,                                                    0144
*           R14,                                                   0144
*           R15) UNRSTD;                                           0144
@RC00141 DS    0H                                                  0145
*       END;                                                       0145
*       IF SDCTPTR^=NULLPTR THEN    /* ACCESS WAS SUCCESSFUL         */
         ICM   @12,15,SDCTPTR                                      0146
         BZ    @RF00146                                            0146
*         CALL FMTSDCT;             /* CALL SEGMENT TO FMT SDCT      */
         BAL   @14,FMTSDCT                                         0147
*       RFY                                                        0148
*         R15 RSTD;                                                0148
@RF00146 DS    0H                                                  0149
*       CUMRC=CUMRC|R15;            /* SAVE RETURN CODE              */
         OR    CUMRC,R15                                           0149
*       RFY                                                        0150
*         R15 UNRSTD;                                              0150
*                                                                  0150
*       /*************************************************************/
*       /*                                                           */
*       /* GET THE FIRST AIA FROM THE SARWAITQ. IF ACCESS WAS        */
*       /* SUCCESSFUL CHECK IF ANYTHING WAS ON THE QUEUE. IF THERE IS*/
*       /* AN AIA SET UP THE ANCHOR AND CALL ILRFAIA.                */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0151
*       DO;                         /* ILRMACCS (AIAPTR)           0151
*                                      FROM(SARWAITF)                */
*         RFY                                                      0152
*          (R0,                                                    0152
*           R1,                                                    0152
*           R14,                                                   0152
*           R15) RSTD;                                             0152
*         R0=ADDR(SARWAITF);                                       0153
         L     @12,SARTPTR                                         0153
         LA    R0,SARWAITF(,@12)                                   0153
*         R1=ABDPLPTR;              /* POINT TO PARM LIST            */
         L     @12,ABDPLPTR                                        0154
         LR    R1,@12                                              0154
*         CALL ACCESS;              /* ACCESS DATA                   */
         L     @15,ADPLMEMA(,@12)                                  0155
         BALR  @14,@15                                             0155
*         R14=R0;                   /* CANNOT USE R0 AS BASE         */
         LR    R14,R0                                              0156
*         IF R15=GOOD THEN          /* CHECK ACCESS                  */
         LTR   R15,R15                                             0157
         BNZ   @RF00157                                            0157
*           AIAPTR=CURRENT;         /* GET REQUESTED FIELD           */
         L     AIAPTR,CURRENT(,R14)                                0158
*         ELSE                      /* ACCESS NO GOOD                */
*           AIAPTR=ZERO;            /* ZERO FIELD                    */
         B     @RC00157                                            0159
@RF00157 SLR   AIAPTR,AIAPTR                                       0159
*         RFY                                                      0160
*          (R0,                                                    0160
*           R1,                                                    0160
*           R14,                                                   0160
*           R15) UNRSTD;                                           0160
@RC00157 DS    0H                                                  0161
*       END;                                                       0161
*       IF AIAPTR^=NULLPTR THEN     /* THE QUEUE IS NOT EMPTY        */
         LTR   AIAPTR,AIAPTR                                       0162
         BZ    @RF00162                                            0162
*         DO;                       /* CONTINUE                      */
*           ANCHTXT=ANCH;           /* PUT LABEL IN BUFFER           */
         L     @08,ABDPLPTR                                        0164
         L     @08,ADPLBUF(,@08)                                   0164
         MVC   ANCHTXT(11,@08),ANCH                                0164
*           ANCHNAME=ANCHAIA4;      /* PUT ANCHOR LOCATION IN BUFFER */
         MVC   ANCHNAME(8,@08),ANCHAIA4                            0165
*           RFY                                                    0166
*            (R0,                                                  0166
*             R1,                                                  0166
*             R2) RSTD;                                            0166
*           R0=AIAPTR;              /* GET THE ADDRESS OF THE AIA    */
         LR    R0,AIAPTR                                           0167
*           R1=ADDR(AIANAM);        /* ADDRESS OF THE NAME OF BLOCK  */
         LA    R1,AIANAM                                           0168
*           R2=3;                   /* CODE FOR THE AIA ROUTINE      */
         LA    R2,3                                                0169
*           RFY                                                    0170
*            (R0,                                                  0170
*             R1,                                                  0170
*             R2) UNRSTD;                                          0170
*           CALL ILRFAIA;           /* CALL SEGMENT TO FMT AIA Q     */
         L     @15,@CV00675                                        0171
         BALR  @14,@15                                             0171
*         END;                                                     0172
*       RFY                                                        0173
*         R15 RSTD;                                                0173
@RF00162 DS    0H                                                  0174
*       CUMRC=CUMRC|R15;            /* SAVE THE RETURN CODE          */
         OR    CUMRC,R15                                           0174
*       RFY                                                        0175
*         R15 UNRSTD;                                              0175
*                                                                  0175
*       /*************************************************************/
*       /*                                                           */
*       /* GET THE NUMBER OF SARTE'S FOR A LOOP. IF THE ACCESS IS    */
*       /* GOOD GET THE ADDRESS OF THE FIRST SARTE AND DO AN ACCESS. */
*       /* FOR THE DSNAME LIST POINTER. IF THE LIST IS NOT AVAILABLE */
*       /* DSNPTR WILL HAVE A 0 IN IT AND FMTSARTE WILL NOT PRINT OUT*/
*       /* THE DATA SET NAME.                                        */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0176
*       DO;                         /* ILRMACCS (NUMSARTE)         0176
*                                      FROM(SARSIZE)                 */
*         RFY                                                      0177
*          (R0,                                                    0177
*           R1,                                                    0177
*           R14,                                                   0177
*           R15) RSTD;                                             0177
*         R0=ADDR(SARSIZE);                                        0178
         L     @12,SARTPTR                                         0178
         LA    R0,SARSIZE(,@12)                                    0178
*         R1=ABDPLPTR;              /* POINT TO PARM LIST            */
         L     @12,ABDPLPTR                                        0179
         LR    R1,@12                                              0179
*         CALL ACCESS;              /* ACCESS DATA                   */
         L     @15,ADPLMEMA(,@12)                                  0180
         BALR  @14,@15                                             0180
*         R14=R0;                   /* CANNOT USE R0 AS BASE         */
         LR    R14,R0                                              0181
*         IF R15=GOOD THEN          /* CHECK ACCESS                  */
         LTR   R15,R15                                             0182
         BNZ   @RF00182                                            0182
*           NUMSARTE=CURRENT;       /* GET REQUESTED FIELD           */
         MVC   NUMSARTE(4),CURRENT(R14)                            0183
*         ELSE                      /* ACCESS NO GOOD                */
*           NUMSARTE=ZERO;          /* ZERO FIELD                    */
         B     @RC00182                                            0184
@RF00182 SLR   @12,@12                                             0184
         ST    @12,NUMSARTE                                        0184
*         RFY                                                      0185
*          (R0,                                                    0185
*           R1,                                                    0185
*           R14,                                                   0185
*           R15) UNRSTD;                                           0185
@RC00182 DS    0H                                                  0186
*       END;                        /* GET NUM SART ENTRIES          */
*       RFY                                                        0187
*         R15 RSTD;                                                0187
*       CUMRC=CUMRC|R15;            /* SAVE THE RETURN CODE          */
         OR    CUMRC,R15                                           0188
*       RFY                                                        0189
*         R15 UNRSTD;                                              0189
*       IF NUMSARTE^=NULLPTR THEN   /* ACCESS WAS GOOD               */
         ICM   @12,15,NUMSARTE                                     0190
         BZ    @RF00190                                            0190
*         DO;                                                      0191
*           SAREPTR=ADDR(SARENTS);  /* ADDR OF FIRST SART ENTRY      */
         L     @12,SARTPTR                                         0192
         LA    @08,SARENTS(,@12)                                   0192
         ST    @08,SAREPTR                                         0192
*           DO;                     /* ILRMACCS (DSNPTR)           0193
*                                      FROM(SARDSNL)                 */
*             RFY                                                  0194
*              (R0,                                                0194
*               R1,                                                0194
*               R14,                                               0194
*               R15) RSTD;                                         0194
*             R0=ADDR(SARDSNL);                                    0195
         LA    R0,SARDSNL(,@12)                                    0195
*             R1=ABDPLPTR;          /* POINT TO PARM LIST            */
         L     @12,ABDPLPTR                                        0196
         LR    R1,@12                                              0196
*             CALL ACCESS;          /* ACCESS DATA                   */
         L     @15,ADPLMEMA(,@12)                                  0197
         BALR  @14,@15                                             0197
*             R14=R0;               /* CANNOT USE R0 AS BASE         */
         LR    R14,R0                                              0198
*             IF R15=GOOD THEN      /* CHECK ACCESS                  */
         LTR   R15,R15                                             0199
         BNZ   @RF00199                                            0199
*               DSNPTR=CURRENT;     /* GET REQUESTED FIELD           */
         MVC   DSNPTR(4),CURRENT(R14)                              0200
*             ELSE                  /* ACCESS NO GOOD                */
*               DSNPTR=ZERO;        /* ZERO FIELD                    */
         B     @RC00199                                            0201
@RF00199 SLR   @12,@12                                             0201
         ST    @12,DSNPTR                                          0201
*             RFY                                                  0202
*              (R0,                                                0202
*               R1,                                                0202
*               R14,                                               0202
*               R15) UNRSTD;                                       0202
@RC00199 DS    0H                                                  0203
*           END;                    /* GET DATA SET NAME             */
*           IF DSNPTR^=NULLPTR THEN                                0204
         L     @12,DSNPTR                                          0204
         LTR   @12,@12                                             0204
         BZ    @RF00204                                            0204
*             DO;                   /* DSN TABLE EXIST?      @ZA11398*/
*               RFY                                                0206
*                (R0,                                              0206
*                 R1,                                              0206
*                 R15) RSTD;        /*                       @ZA11398*/
*               R0=DSNPTR;          /* INPUT TO ACCESS       @ZA11398*/
         LR    R0,@12                                              0207
*               R1=ABDPLPTR;        /* INPUT TO ACCESS       @ZA11398*/
         L     @14,ABDPLPTR                                        0208
         LR    R1,@14                                              0208
*               CALL ACCESS;        /* DSN TABLE ACCESSIBLE? @ZA11398*/
         L     @15,ADPLMEMA(,@14)                                  0209
         BALR  @14,@15                                             0209
*               IF R15^=GOOD THEN                                  0210
         SLR   @14,@14                                             0210
         CR    R15,@14                                             0210
         BE    @RF00210                                            0210
*                 DSNPTR=NULLPTR;   /* INACCESSIBLE          @ZA11398*/
         ST    @14,DSNPTR                                          0211
*               RFY                                                0212
*                (R0,                                              0212
*                 R1) UNRSTD;       /*                       @ZA11398*/
@RF00210 DS    0H                                                  0213
*             END;                  /* DSN TABLE EXIST       @ZA11398*/
*           CUMRC=CUMRC|R15;                                       0214
@RF00204 OR    CUMRC,R15                                           0214
*           RFY                                                    0215
*             R15 UNRSTD;                                          0215
*                                                                  0215
*           /*********************************************************/
*           /*                                                       */
*           /* LOOP UNTIL ALL THE SARTE'S ARE FORMATTED AND SAVE THE */
*           /* RETURN CODE.                                          */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0216
*           DO J=1 TO NUMSARTE;     /* UNTIL ALL ENTRIES PROCESSED   */
         LA    @12,1                                               0216
         B     @DE00216                                            0216
@DL00216 DS    0H                                                  0217
*             CALL FMTSARTE;        /* CALL SEGMENT TO FMT SARTE     */
         BAL   @14,FMTSARTE                                        0217
*             RFY                                                  0218
*               R15 RSTD;                                          0218
*             CUMRC=CUMRC|R15;      /* SAVE RETURN CODE              */
         OR    CUMRC,R15                                           0219
*             RFY                                                  0220
*               R15 UNRSTD;                                        0220
*             IF DSNPTR^=0 THEN     /* WAS ACCESS SUCCESSFUL         */
         L     @12,DSNPTR                                          0221
         LTR   @12,@12                                             0221
         BZ    @RF00221                                            0221
*               DSNPTR=DSNPTR+LENGTH(DSNAME);/* CALCULATE ADDRESS OF
*                                      NEXT DSNAME                   */
         AH    @12,@CH00787                                        0222
         ST    @12,DSNPTR                                          0222
*             SAREPTR=SAREPTR+LENGTH(SARTE);/* GET NEXT SARTE      0223
*                                      CALCULATE SARTE ADDR          */
@RF00221 LA    @12,48                                              0223
         AL    @12,SAREPTR                                         0223
         ST    @12,SAREPTR                                         0223
*           END;                    /* END SARTE PROCESSING          */
         LA    @12,1                                               0224
         AL    @12,J                                               0224
@DE00216 ST    @12,J                                               0224
         C     @12,NUMSARTE                                        0224
         BNH   @DL00216                                            0224
*         END;                      /* END WHEN GOT SART NUM         */
*       ELSE                        /* ACCESS FAILED FOR SARTE       */
*         CUMRC=4;                  /* SET THE RETURN CODE-SARTE   0226
*                                      ACCESS                        */
         B     @RC00190                                            0226
@RF00190 LA    CUMRC,4                                             0226
*     END;                          /* END SART PROCESSING           */
*   ELSE                            /* ACCESS FAILED FOR SART        */
*NOSART:                                                           0228
*     CUMRC=8;                      /* BAD SART ACCESS/FORMAT      0228
*                                                            @ZA11398*/
         B     @RC00128                                            0228
@RF00128 DS    0H                                                  0228
NOSART   LA    CUMRC,8                                             0228
*   RETURN CODE(CUMRC);                                            0229
@RC00128 LR    @15,CUMRC                                           0229
         L     @13,4(,@13)                                         0229
         L     @14,12(,@13)                                        0229
         LM    @00,@12,20(@13)                                     0229
         BR    @14                                                 0229
*                                                                  0230
*/********************************************************************/
*/*                                                                  */
*/* FMTSART: SEGMENT TO FORMAT SART                                  */
*/*                                                                  */
*/* INPUT:   VIRTUAL ADDRESS OF SART IN SARTPTR                      */
*/*                                                                  */
*/* PROCESS: FORMAT FOUR LINES OF THE SART                           */
*/*                                                                  */
*/* OUTPUT:  RETURN CODE = 0 IF FORMAT WAS SUCCESSFUL,               */
*/*           OTHERWISE, RETURN CODE = FOUR                          */
*/*                                                                  */
*/********************************************************************/
*                                                                  0230
*FMTSART:                                                          0230
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0230
FMTSART  DS    0H                                                  0231
*                                                                  0231
*   /*****************************************************************/
*   /*                                                               */
*   /* SAR1:ILRMLINE ((ID,ASIS),SIZE,USE,FXDNX,MOVNX,DSNL) OF(SART)  */
*   /* LABEL VARIABLES REFERENCED IN FORMAT PATTERNS                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0231
*   DCL                                                            0231
*     SAR1LB1 CHAR(LENGTH('ID')) INIT('ID');                       0231
*   DCL                                                            0232
*     SAR1LB2 CHAR(LENGTH('SIZE')) INIT('SIZE');                   0232
*   DCL                                                            0233
*     SAR1LB3 CHAR(LENGTH('USE')) INIT('USE');                     0233
*   DCL                                                            0234
*     SAR1LB4 CHAR(LENGTH('FXDNX')) INIT('FXDNX');                 0234
*   DCL                                                            0235
*     SAR1LB5 CHAR(LENGTH('MOVNX')) INIT('MOVNX');                 0235
*   DCL                                                            0236
*     SAR1LB6 CHAR(LENGTH('DSNL')) INIT('DSNL');                   0236
*                                                                  0236
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT PATTERNS FOR ONE LINE OF OUTPUT                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0237
*   DCL                                                            0237
*     1 SAR1PTS BDY(WORD),                                         0237
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00101111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SARID)-1+16*LENGTH('ID')-16)
*         ,                         /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(5),                                      0237
*       3 * FIXED(8) INIT(11),                                     0237
*       3 * PTR(31) INIT(ADDR(SAR1LB1)),/* SEE PTTLBPTR              */
*       3 SAR1DT1 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SARSIZE)-1+16*LENGTH('SIZE')
*             -16),                 /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(15+8),                                   0237
*       3 * FIXED(8) INIT(21+8),                                   0237
*       3 * PTR(31) INIT(ADDR(SAR1LB2)),/* SEE PTTLBPTR              */
*       3 SAR1DT2 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SARUSE)-1+16*LENGTH('USE')-
*             16),                  /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(25+8+8),                                 0237
*       3 * FIXED(8) INIT(31+8+8),                                 0237
*       3 * PTR(31) INIT(ADDR(SAR1LB3)),/* SEE PTTLBPTR              */
*       3 SAR1DT3 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SARFXDNX)-1+16*LENGTH('FXDNX
*             )-16),                /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(35+8+8+8),                               0237
*       3 * FIXED(8) INIT(41+8+8+8),                               0237
*       3 * PTR(31) INIT(ADDR(SAR1LB4)),/* SEE PTTLBPTR              */
*       3 SAR1DT4 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SARMOVNX)-1+16*LENGTH('MOVNX
*             )-16),                /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(45+8+8+8+8),                             0237
*       3 * FIXED(8) INIT(51+8+8+8+8),                             0237
*       3 * PTR(31) INIT(ADDR(SAR1LB5)),/* SEE PTTLBPTR              */
*       3 SAR1DT5 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SARDSNL)-1+16*LENGTH('DSNL')
*             -16),                 /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(55+8+8+8+8+8),                           0237
*       3 * FIXED(8) INIT(61+8+8+8+8+8),                           0237
*       3 * PTR(31) INIT(ADDR(SAR1LB6)),/* SEE PTTLBPTR              */
*       3 SAR1DT6 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * FIXED(31) INIT(0);       /* END OF FORMAT PATTERNS        */
*                                                                  0238
*   /*****************************************************************/
*   /*                                                               */
*   /* SAR2:ILRMLINE (SDCT,SCCWQ,SETCT,WAITF,WAITL,SRBP) LABEL       */
*   /* VARIABLES REFERENCED IN FORMAT PATTERNS                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0238
*   DCL                                                            0238
*     SAR2LB1 CHAR(LENGTH('SDCT')) INIT('SDCT');                   0238
*   DCL                                                            0239
*     SAR2LB2 CHAR(LENGTH('SCCWQ')) INIT('SCCWQ');                 0239
*   DCL                                                            0240
*     SAR2LB3 CHAR(LENGTH('SETCT')) INIT('SETCT');                 0240
*   DCL                                                            0241
*     SAR2LB4 CHAR(LENGTH('WAITF')) INIT('WAITF');                 0241
*   DCL                                                            0242
*     SAR2LB5 CHAR(LENGTH('WAITL')) INIT('WAITL');                 0242
*   DCL                                                            0243
*     SAR2LB6 CHAR(LENGTH('SRBP')) INIT('SRBP');                   0243
*                                                                  0243
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT PATTERNS FOR ONE LINE OF OUTPUT                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0244
*   DCL                                                            0244
*     1 SAR2PTS BDY(WORD),                                         0244
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SARSDCT)-1+16*LENGTH('SDCT')
*             -16),                 /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(5),                                      0244
*       3 * FIXED(8) INIT(11),                                     0244
*       3 * PTR(31) INIT(ADDR(SAR2LB1)),/* SEE PTTLBPTR              */
*       3 SAR2DT1 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SARSCCWQ)-1+16*LENGTH('SCCWQ
*             )-16),                /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(15+8),                                   0244
*       3 * FIXED(8) INIT(21+8),                                   0244
*       3 * PTR(31) INIT(ADDR(SAR2LB2)),/* SEE PTTLBPTR              */
*       3 SAR2DT2 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SARSETCT)-1+16*LENGTH('SETCT
*             )-16),                /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(25+8+8),                                 0244
*       3 * FIXED(8) INIT(31+8+8),                                 0244
*       3 * PTR(31) INIT(ADDR(SAR2LB3)),/* SEE PTTLBPTR              */
*       3 SAR2DT3 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SARWAITF)-1+16*LENGTH('WAITF
*             )-16),                /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(35+8+8+8),                               0244
*       3 * FIXED(8) INIT(41+8+8+8),                               0244
*       3 * PTR(31) INIT(ADDR(SAR2LB4)),/* SEE PTTLBPTR              */
*       3 SAR2DT4 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SARWAITL)-1+16*LENGTH('WAITL
*             )-16),                /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(45+8+8+8+8),                             0244
*       3 * FIXED(8) INIT(51+8+8+8+8),                             0244
*       3 * PTR(31) INIT(ADDR(SAR2LB5)),/* SEE PTTLBPTR              */
*       3 SAR2DT5 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SARSRBP)-1+16*LENGTH('SRBP')
*             -16),                 /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(55+8+8+8+8+8),                           0244
*       3 * FIXED(8) INIT(61+8+8+8+8+8),                           0244
*       3 * PTR(31) INIT(ADDR(SAR2LB6)),/* SEE PTTLBPTR              */
*       3 SAR2DT6 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * FIXED(31) INIT(0);       /* END OF FORMAT PATTERNS        */
*                                                                  0245
*   /*****************************************************************/
*   /*                                                               */
*   /* SAR3:ILRMLINE (SRBCT,SETSZ) LABEL VARIABLES REFERENCED IN     */
*   /* FORMAT PATTERNS                                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0245
*   DCL                                                            0245
*     SAR3LB1 CHAR(LENGTH('SRBCT')) INIT('SRBCT');                 0245
*   DCL                                                            0246
*     SAR3LB2 CHAR(LENGTH('SETSZ')) INIT('SETSZ');                 0246
*                                                                  0246
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT PATTERNS FOR ONE LINE OF OUTPUT                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0247
*   DCL                                                            0247
*     1 SAR3PTS BDY(WORD),                                         0247
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SARSRBCT)-1+16*LENGTH('SRBCT
*             )-16),                /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(5),                                      0247
*       3 * FIXED(8) INIT(11),                                     0247
*       3 * PTR(31) INIT(ADDR(SAR3LB1)),/* SEE PTTLBPTR              */
*       3 SAR3DT1 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SARSETSZ)-1+16*LENGTH('SETSZ
*             )-16),                /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(15+8),                                   0247
*       3 * FIXED(8) INIT(21+8),                                   0247
*       3 * PTR(31) INIT(ADDR(SAR3LB2)),/* SEE PTTLBPTR              */
*       3 SAR3DT2 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * FIXED(31) INIT(0);       /* END OF FORMAT PATTERNS        */
*   RFY                                                            0248
*     R14 RSTD;                                                    0248
*   RTNADDR1=R14;                   /* SAVE RETURN ADDRESS           */
         ST    R14,RTNADDR1                                        0249
*   RFY                                                            0250
*     R14 UNRSTD;                                                  0250
*   ANCHTXT=ANCH;                   /* PUT LABEL IN BUFFER           */
         L     @12,ABDPLPTR                                        0251
         L     @12,ADPLBUF(,@12)                                   0251
         MVC   ANCHTXT(11,@12),ANCH                                0251
*   ANCHNAME=ANCHSART;              /* PUT IN NAME OF BLOCK          */
         MVC   ANCHNAME(8,@12),ANCHSART                            0252
*   RFY                                                            0253
*    (R0,                                                          0253
*     R1) RSTD;                                                    0253
*   R0=ADDR(SARTPTR);               /* GET ADDR OF CONTROL BLOCK     */
         LA    R0,SARTPTR                                          0254
*   R1=ADDR(SARTNAM);               /* GET ADDRESS OF THE NAME       */
         LA    R1,SARTNAM                                          0255
*   CALL ILRFPRTH;                  /* CALL TO PRINT THE HEADING     */
         L     @15,@CV00676                                        0256
         BALR  @14,@15                                             0256
*   RFY                                                            0257
*    (R0,                                                          0257
*     R1) UNRSTD;                                                  0257
*   DO;                             /* ILRMFRMT (SAR)              0258
*                                      LINES(SAR1,SAR2,SAR3)SPACE    */
*     FORMRC=0;                     /* ZERO THE RETURN CODE          */
         SLR   FORMRC,FORMRC                                       0259
*     SAR1DT1=ADDR(SARID);                                         0260
         L     @12,SARTPTR                                         0260
         ST    @12,SAR1DT1                                         0260
*     SAR1DT2=ADDR(SARSIZE);                                       0261
         LA    @08,SARSIZE(,@12)                                   0261
         ST    @08,SAR1DT2                                         0261
*     SAR1DT3=ADDR(SARUSE);                                        0262
         LA    @08,SARUSE(,@12)                                    0262
         ST    @08,SAR1DT3                                         0262
*     SAR1DT4=ADDR(SARFXDNX);                                      0263
         LA    @08,SARFXDNX(,@12)                                  0263
         ST    @08,SAR1DT4                                         0263
*     SAR1DT5=ADDR(SARMOVNX);                                      0264
         LA    @08,SARMOVNX(,@12)                                  0264
         ST    @08,SAR1DT5                                         0264
*     SAR1DT6=ADDR(SARDSNL);                                       0265
         LA    @12,SARDSNL(,@12)                                   0265
         ST    @12,SAR1DT6                                         0265
*     RFY                                                          0266
*      (R0,                                                        0266
*       R1) RSTD;                                                  0266
*     R0=ADDR(SAR1PTS);                                            0267
         LA    R0,SAR1PTS                                          0267
*     R1=ABDPLPTR;                  /* GET PARM ADDR                 */
         L     @12,ABDPLPTR                                        0268
         LR    R1,@12                                              0268
*     CALL FORMAT;                  /* FORMAT THE LINE               */
         L     @15,ADPLFRMT(,@12)                                  0269
         BALR  @14,@15                                             0269
*     RFY                                                          0270
*       R15 RSTD;                                                  0270
*     FORMRC=FORMRC|R15;            /* SAVE RETURN CODE              */
         OR    FORMRC,R15                                          0271
*     RFY                                                          0272
*       R15 UNRSTD;                                                0272
*     CALL PRINT;                   /* CALL PRINT ROUTINE            */
         L     @12,ABDPLPTR                                        0273
         L     @15,ADPLPRNT(,@12)                                  0273
         BALR  @14,@15                                             0273
*     RFY                                                          0274
*      (R0,                                                        0274
*       R1) UNRSTD;                                                0274
*     SAR2DT1=ADDR(SARSDCT);                                       0275
         L     @12,SARTPTR                                         0275
         LA    @08,SARSDCT(,@12)                                   0275
         ST    @08,SAR2DT1                                         0275
*     SAR2DT2=ADDR(SARSCCWQ);                                      0276
         LA    @08,SARSCCWQ(,@12)                                  0276
         ST    @08,SAR2DT2                                         0276
*     SAR2DT3=ADDR(SARSETCT);                                      0277
         LA    @08,SARSETCT(,@12)                                  0277
         ST    @08,SAR2DT3                                         0277
*     SAR2DT4=ADDR(SARWAITF);                                      0278
         LA    @08,SARWAITF(,@12)                                  0278
         ST    @08,SAR2DT4                                         0278
*     SAR2DT5=ADDR(SARWAITL);                                      0279
         LA    @08,SARWAITL(,@12)                                  0279
         ST    @08,SAR2DT5                                         0279
*     SAR2DT6=ADDR(SARSRBP);                                       0280
         LA    @12,SARSRBP(,@12)                                   0280
         ST    @12,SAR2DT6                                         0280
*     RFY                                                          0281
*      (R0,                                                        0281
*       R1) RSTD;                                                  0281
*     R0=ADDR(SAR2PTS);                                            0282
         LA    R0,SAR2PTS                                          0282
*     R1=ABDPLPTR;                  /* GET PARM ADDR                 */
         L     @12,ABDPLPTR                                        0283
         LR    R1,@12                                              0283
*     CALL FORMAT;                  /* FORMAT THE LINE               */
         L     @15,ADPLFRMT(,@12)                                  0284
         BALR  @14,@15                                             0284
*     RFY                                                          0285
*       R15 RSTD;                                                  0285
*     FORMRC=FORMRC|R15;            /* SAVE RETURN CODE              */
         OR    FORMRC,R15                                          0286
*     RFY                                                          0287
*       R15 UNRSTD;                                                0287
*     CALL PRINT;                   /* CALL PRINT ROUTINE            */
         L     @12,ABDPLPTR                                        0288
         L     @15,ADPLPRNT(,@12)                                  0288
         BALR  @14,@15                                             0288
*     RFY                                                          0289
*      (R0,                                                        0289
*       R1) UNRSTD;                                                0289
*     SAR3DT1=ADDR(SARSRBCT);                                      0290
         L     @12,SARTPTR                                         0290
         LA    @08,SARSRBCT(,@12)                                  0290
         ST    @08,SAR3DT1                                         0290
*     SAR3DT2=ADDR(SARSETSZ);                                      0291
         LA    @12,SARSETSZ(,@12)                                  0291
         ST    @12,SAR3DT2                                         0291
*     RFY                                                          0292
*      (R0,                                                        0292
*       R1) RSTD;                                                  0292
*     R0=ADDR(SAR3PTS);                                            0293
         LA    R0,SAR3PTS                                          0293
*     R1=ABDPLPTR;                  /* GET PARM ADDR                 */
         L     @12,ABDPLPTR                                        0294
         LR    R1,@12                                              0294
*     CALL FORMAT;                  /* FORMAT THE LINE               */
         L     @15,ADPLFRMT(,@12)                                  0295
         BALR  @14,@15                                             0295
*     RFY                                                          0296
*       R15 RSTD;                                                  0296
*     FORMRC=FORMRC|R15;            /* SAVE RETURN CODE              */
         OR    FORMRC,R15                                          0297
*     RFY                                                          0298
*       R15 UNRSTD;                                                0298
*     CALL PRINT;                   /* CALL PRINT ROUTINE            */
         L     @12,ABDPLPTR                                        0299
         L     @15,ADPLPRNT(,@12)                                  0299
         BALR  @14,@15                                             0299
*     RFY                                                          0300
*      (R0,                                                        0300
*       R1) UNRSTD;                                                0300
*     RFY                                                          0301
*       R1 RSTD;                                                   0301
*     R1=ABDPLPTR;                  /* GET PARM ADDR                 */
         L     @12,ABDPLPTR                                        0302
         LR    R1,@12                                              0302
*     CALL PRINT;                   /* CALL PRINT ROUTINE            */
         L     @15,ADPLPRNT(,@12)                                  0303
         BALR  @14,@15                                             0303
*     RFY                                                          0304
*       R1 UNRSTD;                                                 0304
*     RFY                                                          0305
*       R15 RSTD;                                                  0305
*     R15=FORMRC;                   /* SAVE RETURN CODE FROM FORMAT  */
         LR    R15,FORMRC                                          0306
*     RFY                                                          0307
*       R15 UNRSTD;                                                0307
*   END;                            /* ILRMFRMT (SAR)              0308
*                                      LINES(SAR1,SAR2,SAR3)SPACE  0308
*                                      FORMAT AND PRINT SART         */
*   RFY                                                            0309
*     R14 RSTD;                                                    0309
*   R14=RTNADDR1;                   /* RESTORE RETURN ADDRESS        */
         L     R14,RTNADDR1                                        0310
*   RFY                                                            0311
*     R14 UNRSTD;                                                  0311
*   END FMTSART;                    /* RETURN TO CALLER              */
@EL00002 DS    0H                                                  0312
@EF00002 DS    0H                                                  0312
@ER00002 BR    @14                                                 0312
*                                                                  0313
*/********************************************************************/
*/*                                                                  */
*/* FMTSDCT: SEGMENT TO FORMAT SDCT AND SDCT ENTRIES                 */
*/*                                                                  */
*/* INPUT:   VIRTUAL ADDRESS OF SDCT IN SCDTPTR                      */
*/*                                                                  */
*/* PROCESS: FORMAT SDCT AND ONE ENTRY, SET COUNTER FOR NUMBER       */
*/*           OF ENTRIES AND LOOP UNTIL ALL ENTRIES FORMATTED        */
*/*                                                                  */
*/* OUTPUT:  RETURN CODE = 0  IF FORMATS WERE SUCCESSFUL,            */
*/*           OTHERWISE, RETURN CODE = FOUR                          */
*/*                                                                  */
*/********************************************************************/
*                                                                  0313
*FMTSDCT:                                                          0313
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0313
FMTSDCT  DS    0H                                                  0314
*                                                                  0314
*   /*****************************************************************/
*   /*                                                               */
*   /* SDCT1:ILRMLINE ((ID,ASIS),SIZE,RSV1) OF(SDCT) LABEL VARIABLES */
*   /* REFERENCED IN FORMAT PATTERNS                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0314
*   DCL                                                            0314
*     SDCT1LB1 CHAR(LENGTH('ID')) INIT('ID');                      0314
*   DCL                                                            0315
*     SDCT1LB2 CHAR(LENGTH('SIZE')) INIT('SIZE');                  0315
*   DCL                                                            0316
*     SDCT1LB3 CHAR(LENGTH('RSV1')) INIT('RSV1');                  0316
*                                                                  0316
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT PATTERNS FOR ONE LINE OF OUTPUT                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0317
*   DCL                                                            0317
*     1 SDCT1PTS BDY(WORD),                                        0317
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00101111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SDCID)-1+16*LENGTH('ID')-16)
*         ,                         /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(5),                                      0317
*       3 * FIXED(8) INIT(11),                                     0317
*       3 * PTR(31) INIT(ADDR(SDCT1LB1)),/* SEE PTTLBPTR             */
*       3 SDCT1DT1 PTR(31) INIT(0), /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SDCSIZE)-1+16*LENGTH('SIZE')
*             -16),                 /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(15+8),                                   0317
*       3 * FIXED(8) INIT(21+8),                                   0317
*       3 * PTR(31) INIT(ADDR(SDCT1LB2)),/* SEE PTTLBPTR             */
*       3 SDCT1DT2 PTR(31) INIT(0), /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SDCRSV1)-1+16*LENGTH('RSV1')
*             -16),                 /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(25+8+8),                                 0317
*       3 * FIXED(8) INIT(31+8+8),                                 0317
*       3 * PTR(31) INIT(ADDR(SDCT1LB3)),/* SEE PTTLBPTR             */
*       3 SDCT1DT3 PTR(31) INIT(0), /* SEE PTTDTPTR                  */
*      2 * FIXED(31) INIT(0);       /* END OF FORMAT PATTERNS        */
*                                                                  0318
*   /*****************************************************************/
*   /*                                                               */
*   /* SDCT2:ILRMLINE ((DEVTP,ASIS),DTYPX,SLTRK,CYLSZ,CMASK,SSECT)   */
*   /* LABEL VARIABLES REFERENCED IN FORMAT PATTERNS                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0318
*   DCL                                                            0318
*     SDCT2LB1 CHAR(LENGTH('DEVTP')) INIT('DEVTP');                0318
*   DCL                                                            0319
*     SDCT2LB2 CHAR(LENGTH('DTYPX')) INIT('DTYPX');                0319
*   DCL                                                            0320
*     SDCT2LB3 CHAR(LENGTH('SLTRK')) INIT('SLTRK');                0320
*   DCL                                                            0321
*     SDCT2LB4 CHAR(LENGTH('CYLSZ')) INIT('CYLSZ');                0321
*   DCL                                                            0322
*     SDCT2LB5 CHAR(LENGTH('CMASK')) INIT('CMASK');                0322
*   DCL                                                            0323
*     SDCT2LB6 CHAR(LENGTH('SSECT')) INIT('SSECT');                0323
*                                                                  0323
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT PATTERNS FOR ONE LINE OF OUTPUT                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0324
*   DCL                                                            0324
*     1 SDCT2PTS BDY(WORD),                                        0324
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00101111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SDCDEVTP)-1+16*LENGTH('DEVTP
*             )-16),                /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(5),                                      0324
*       3 * FIXED(8) INIT(11),                                     0324
*       3 * PTR(31) INIT(ADDR(SDCT2LB1)),/* SEE PTTLBPTR             */
*       3 SDCT2DT1 PTR(31) INIT(0), /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SDCDTYPX)-1+16*LENGTH('DTYPX
*             )-16),                /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(15+8),                                   0324
*       3 * FIXED(8) INIT(21+8),                                   0324
*       3 * PTR(31) INIT(ADDR(SDCT2LB2)),/* SEE PTTLBPTR             */
*       3 SDCT2DT2 PTR(31) INIT(0), /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SDCSLTRK)-1+16*LENGTH('SLTRK
*             )-16),                /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(25+8+8),                                 0324
*       3 * FIXED(8) INIT(31+8+8),                                 0324
*       3 * PTR(31) INIT(ADDR(SDCT2LB3)),/* SEE PTTLBPTR             */
*       3 SDCT2DT3 PTR(31) INIT(0), /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SDCCYLSZ)-1+16*LENGTH('CYLSZ
*             )-16),                /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(35+8+8+8),                               0324
*       3 * FIXED(8) INIT(41+8+8+8),                               0324
*       3 * PTR(31) INIT(ADDR(SDCT2LB4)),/* SEE PTTLBPTR             */
*       3 SDCT2DT4 PTR(31) INIT(0), /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SDCCMASK)-1+16*LENGTH('CMASK
*             )-16),                /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(45+8+8+8+8),                             0324
*       3 * FIXED(8) INIT(51+8+8+8+8),                             0324
*       3 * PTR(31) INIT(ADDR(SDCT2LB5)),/* SEE PTTLBPTR             */
*       3 SDCT2DT5 PTR(31) INIT(0), /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SDCSSECT)-1+16*LENGTH('SSECT
*             )-16),                /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(55+8+8+8+8+8),                           0324
*       3 * FIXED(8) INIT(61+8+8+8+8+8),                           0324
*       3 * PTR(31) INIT(ADDR(SDCT2LB6)),/* SEE PTTLBPTR             */
*       3 SDCT2DT6 PTR(31) INIT(0), /* SEE PTTDTPTR                  */
*      2 * FIXED(31) INIT(0);       /* END OF FORMAT PATTERNS        */
*   RFY                                                            0325
*     R14 RSTD;                                                    0325
*   RTNADDR1=R14;                   /* SAVE RETURN ADDRESS           */
         ST    R14,RTNADDR1                                        0326
*   RFY                                                            0327
*     R14 UNRSTD;                                                  0327
*   ANCHTXT=ANCH;                   /* PUT LABEL IN BUFFER           */
         L     @12,ABDPLPTR                                        0328
         L     @12,ADPLBUF(,@12)                                   0328
         MVC   ANCHTXT(11,@12),ANCH                                0328
*   ANCHNAME=ANCHSDCT;              /* PUT NAME IN THE BUFFER        */
         MVC   ANCHNAME(8,@12),ANCHSDCT                            0329
*   RFY                                                            0330
*    (R0,                                                          0330
*     R1) RSTD;                                                    0330
*   R0=ADDR(SDCTPTR);               /* GET ADDR OF CONTROL BLOCK     */
         LA    R0,SDCTPTR                                          0331
*   R1=ADDR(SDCTNAM);               /* GET NAME OF CONTROL BLOCK     */
         LA    R1,SDCTNAM                                          0332
*   CALL ILRFPRTH;                  /* PRINT THE HEADING             */
         L     @15,@CV00676                                        0333
         BALR  @14,@15                                             0333
*   RFY                                                            0334
*    (R0,                                                          0334
*     R1) UNRSTD;                                                  0334
*                                                                  0334
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT THE SDCT                                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0335
*   DO;                             /* ILRMFRMT (SDCT) LINES(SDCT1)  */
*     FORMRC=0;                     /* ZERO THE RETURN CODE          */
         SLR   FORMRC,FORMRC                                       0336
*     SDCT1DT1=ADDR(SDCID);                                        0337
         L     @12,SDCTPTR                                         0337
         ST    @12,SDCT1DT1                                        0337
*     SDCT1DT2=ADDR(SDCSIZE);                                      0338
         LA    @08,SDCSIZE(,@12)                                   0338
         ST    @08,SDCT1DT2                                        0338
*     SDCT1DT3=ADDR(SDCRSV1);                                      0339
         LA    @12,SDCRSV1(,@12)                                   0339
         ST    @12,SDCT1DT3                                        0339
*     RFY                                                          0340
*      (R0,                                                        0340
*       R1) RSTD;                                                  0340
*     R0=ADDR(SDCT1PTS);                                           0341
         LA    R0,SDCT1PTS                                         0341
*     R1=ABDPLPTR;                  /* GET PARM ADDR                 */
         L     @12,ABDPLPTR                                        0342
         LR    R1,@12                                              0342
*     CALL FORMAT;                  /* FORMAT THE LINE               */
         L     @15,ADPLFRMT(,@12)                                  0343
         BALR  @14,@15                                             0343
*     RFY                                                          0344
*       R15 RSTD;                                                  0344
*     FORMRC=FORMRC|R15;            /* SAVE RETURN CODE              */
         OR    FORMRC,R15                                          0345
*     RFY                                                          0346
*       R15 UNRSTD;                                                0346
*     CALL PRINT;                   /* CALL PRINT ROUTINE            */
         L     @12,ABDPLPTR                                        0347
         L     @15,ADPLPRNT(,@12)                                  0347
         BALR  @14,@15                                             0347
*     RFY                                                          0348
*      (R0,                                                        0348
*       R1) UNRSTD;                                                0348
*     RFY                                                          0349
*       R15 RSTD;                                                  0349
*     R15=FORMRC;                   /* SAVE RETURN CODE FROM FORMAT  */
         LR    R15,FORMRC                                          0350
*     RFY                                                          0351
*       R15 UNRSTD;                                                0351
*   END;                            /* ILRMFRMT (SDCT) LINES(SDCT1)
*                                      FMT & PRINT HDR SECTION       */
*   RFY                                                            0353
*     R15 RSTD;                                                    0353
*   SDCTRC=R15;                     /* SAVE THE RETURN CODE LOCALLY  */
         LR    SDCTRC,R15                                          0354
*   RFY                                                            0355
*     R15 UNRSTD;                                                  0355
*                                                                  0356
*   /*****************************************************************/
*   /*                                                               */
*   /* GET THE NUMBER OF SDCT ENTRIES TO FORMAT THEM                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0356
*   RFY                                                            0356
*    (R0,                                                          0356
*     R1,                                                          0356
*     R14,                                                         0356
*     R15) RSTD;                                                   0356
*   R0=ADDR(SDCSIZE);               /* ADDRESS OF THE DATA           */
         L     @12,SDCTPTR                                         0357
         LA    R0,SDCSIZE(,@12)                                    0357
*   R1=ABDPLPTR;                    /* ADDRESS OF PARM LIST          */
         L     @12,ABDPLPTR                                        0358
         LR    R1,@12                                              0358
*   CALL ACCESS;                    /* CALL THE ACCESS ROUTINE       */
         L     @15,ADPLMEMA(,@12)                                  0359
         BALR  @14,@15                                             0359
*   R14=R0;                                                        0360
         LR    R14,R0                                              0360
*   IF R15=GOOD THEN                /* IS RETURN CODE GOOD           */
         LTR   R15,R15                                             0361
         BNZ   @RF00361                                            0361
*     ENTRYCNT=HALFCURR;            /* PICK UP HALF WORD             */
         LH    @12,HALFCURR(,R14)                                  0362
         ST    @12,ENTRYCNT                                        0362
*   ELSE                            /* RETURN CODE NOT GOOD          */
*     ENTRYCNT=ZERO;                /* ZERO NOT AVAILABLE            */
         B     @RC00361                                            0363
@RF00361 SLR   @12,@12                                             0363
         ST    @12,ENTRYCNT                                        0363
*   RFY                                                            0364
*    (R0,                                                          0364
*     R1,                                                          0364
*     R14,                                                         0364
*     R15) UNRSTD;                                                 0364
@RC00361 DS    0H                                                  0365
*   IF ENTRYCNT^=NULLPTR THEN       /* ACCESS WAS GOOD               */
         ICM   @12,15,ENTRYCNT                                     0365
         BZ    @RF00365                                            0365
*     DO;                                                          0366
*       SDCTEPTR=SDCTPTR+LENGTH(SDCHDR);/* FIRST ENTRY               */
         LA    SDCTEPTR,8                                          0367
         AL    SDCTEPTR,SDCTPTR                                    0367
*       DO I=1 TO ENTRYCNT;         /* UNTIL ALL ENTRIES FORMATTED   */
         LA    I,1                                                 0368
         B     @DE00368                                            0368
@DL00368 DS    0H                                                  0369
*         DO;                       /* ILRMFRMT LINES(SDCT2)         */
*           FORMRC=0;               /* ZERO THE RETURN CODE          */
         SLR   FORMRC,FORMRC                                       0370
*           SDCT2DT1=ADDR(SDCDEVTP);                               0371
         ST    SDCTEPTR,SDCT2DT1                                   0371
*           SDCT2DT2=ADDR(SDCDTYPX);                               0372
         LA    @08,SDCDTYPX(,SDCTEPTR)                             0372
         ST    @08,SDCT2DT2                                        0372
*           SDCT2DT3=ADDR(SDCSLTRK);                               0373
         LA    @08,SDCSLTRK(,SDCTEPTR)                             0373
         ST    @08,SDCT2DT3                                        0373
*           SDCT2DT4=ADDR(SDCCYLSZ);                               0374
         LA    @08,SDCCYLSZ(,SDCTEPTR)                             0374
         ST    @08,SDCT2DT4                                        0374
*           SDCT2DT5=ADDR(SDCCMASK);                               0375
         LA    @08,SDCCMASK(,SDCTEPTR)                             0375
         ST    @08,SDCT2DT5                                        0375
*           SDCT2DT6=ADDR(SDCSSECT);                               0376
         LA    @08,SDCSSECT(,SDCTEPTR)                             0376
         ST    @08,SDCT2DT6                                        0376
*           RFY                                                    0377
*            (R0,                                                  0377
*             R1) RSTD;                                            0377
*           R0=ADDR(SDCT2PTS);                                     0378
         LA    R0,SDCT2PTS                                         0378
*           R1=ABDPLPTR;            /* GET PARM ADDR                 */
         L     @08,ABDPLPTR                                        0379
         LR    R1,@08                                              0379
*           CALL FORMAT;            /* FORMAT THE LINE               */
         L     @15,ADPLFRMT(,@08)                                  0380
         BALR  @14,@15                                             0380
*           RFY                                                    0381
*             R15 RSTD;                                            0381
*           FORMRC=FORMRC|R15;      /* SAVE RETURN CODE              */
         OR    FORMRC,R15                                          0382
*           RFY                                                    0383
*             R15 UNRSTD;                                          0383
*           CALL PRINT;             /* CALL PRINT ROUTINE            */
         L     @08,ABDPLPTR                                        0384
         L     @15,ADPLPRNT(,@08)                                  0384
         BALR  @14,@15                                             0384
*           RFY                                                    0385
*            (R0,                                                  0385
*             R1) UNRSTD;                                          0385
*           RFY                                                    0386
*             R15 RSTD;                                            0386
*           R15=FORMRC;             /* SAVE RETURN CODE FROM FORMAT  */
         LR    R15,FORMRC                                          0387
*           RFY                                                    0388
*             R15 UNRSTD;                                          0388
*         END;                      /* ILRMFRMT LINES(SDCT2) FORMAT &
*                                      PRINT ENTRY                   */
*         RFY                                                      0390
*           R15 RSTD;                                              0390
*         SDCTRC=SDCTRC|R15;        /* SAVE THE RETURN CODE LOCALLY  */
         OR    SDCTRC,R15                                          0391
*         RFY                                                      0392
*           R15 UNRSTD;                                            0392
*         SDCTEPTR=SDCTEPTR+LENGTH(SDCTE);/* CALC ADDR OF NEXT ENTRY */
         AH    SDCTEPTR,@CH00184                                   0393
*       END;                                                       0394
         AH    I,@CH00041                                          0394
@DE00368 C     I,ENTRYCNT                                          0394
         BNH   @DL00368                                            0394
*     END;                                                         0395
*   ELSE                                                           0396
*     SDCTRC=4;                     /* ACCESS FAILED                 */
         B     @RC00365                                            0396
@RF00365 LA    SDCTRC,4                                            0396
*   RFY                                                            0397
*     R1 RSTD;                                                     0397
@RC00365 DS    0H                                                  0398
*   R1=ABDPLPTR;                    /* GET THE ADDR OF THE PARM LIST */
         L     @12,ABDPLPTR                                        0398
         LR    R1,@12                                              0398
*   CALL PRINT;                     /* PRINT A BLANK LINE            */
         L     @15,ADPLPRNT(,@12)                                  0399
         BALR  @14,@15                                             0399
*   RFY                                                            0400
*     R1 UNRSTD;                                                   0400
*   RFY                                                            0401
*    (R14,                                                         0401
*     R15) RSTD;                                                   0401
*   R15=SDCTRC;                     /* PUT RETURN CODE IN REG 15     */
         LR    R15,SDCTRC                                          0402
*   R14=RTNADDR1;                   /* RESTORE RETURN ADDRESS        */
         L     R14,RTNADDR1                                        0403
*   RFY                                                            0404
*    (R14,                                                         0404
*     R15) UNRSTD;                                                 0404
*   END FMTSDCT;                    /* RETURN TO CALLER              */
@EL00003 DS    0H                                                  0405
@EF00003 DS    0H                                                  0405
@ER00003 BR    @14                                                 0405
*                                                                  0406
*/********************************************************************/
*/*                                                                  */
*/* FMTSARTE:  SEGMENT TO FORMAT A SART ENTRY AND ITS ASSOCIATED     */
*/*             CONTROL BLOCKS                                       */
*/*                                                                  */
*/* INPUT:     VIRTUAL ADDRESS OF SARTE IN SAREPTR                   */
*/*                                                                  */
*/* PROCESS:   IF A DATA SET NAME EXISTS FOR THIS ENTRY, PUT IT      */
*/*             INTO THE HEADER.  THEN, FORMAT THE ENTRY.  NEXT,     */
*/*             CALL SEGMENTS TO FORMAT THE SAT, SCCW QUEUE AND      */
*/*             IORB QUEUE (WHICH INCLUDES IOSB AND SCCW QUEUE).     */
*/*                                                                  */
*/* OUTPUT:    THE CUMULATIVE RETURN CODE FROM ALL SEGMENTS CALLED   */
*/*                                                                  */
*/********************************************************************/
*                                                                  0406
*FMTSARTE:                                                         0406
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0406
FMTSARTE DS    0H                                                  0407
*                                                                  0407
*   /*****************************************************************/
*   /*                                                               */
*   /* SRE1:ILRMLINE (NEXT,LOCK,FLG,NN,SCCW,TOTSL) OF(SRE) LABEL     */
*   /* VARIABLES REFERENCED IN FORMAT PATTERNS                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0407
*   DCL                                                            0407
*     SRE1LB1 CHAR(LENGTH('NEXT')) INIT('NEXT');                   0407
*   DCL                                                            0408
*     SRE1LB2 CHAR(LENGTH('LOCK')) INIT('LOCK');                   0408
*   DCL                                                            0409
*     SRE1LB3 CHAR(LENGTH('FLG')) INIT('FLG');                     0409
*   DCL                                                            0410
*     SRE1LB4 CHAR(LENGTH('NN')) INIT('NN');                       0410
*   DCL                                                            0411
*     SRE1LB5 CHAR(LENGTH('SCCW')) INIT('SCCW');                   0411
*   DCL                                                            0412
*     SRE1LB6 CHAR(LENGTH('TOTSL')) INIT('TOTSL');                 0412
*                                                                  0412
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT PATTERNS FOR ONE LINE OF OUTPUT                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0413
*   DCL                                                            0413
*     1 SRE1PTS BDY(WORD),                                         0413
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SRENEXT)-1+16*LENGTH('NEXT')
*             -16),                 /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(5),                                      0413
*       3 * FIXED(8) INIT(11),                                     0413
*       3 * PTR(31) INIT(ADDR(SRE1LB1)),/* SEE PTTLBPTR              */
*       3 SRE1DT1 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SRELOCK)-1+16*LENGTH('LOCK')
*             -16),                 /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(15+8),                                   0413
*       3 * FIXED(8) INIT(21+8),                                   0413
*       3 * PTR(31) INIT(ADDR(SRE1LB2)),/* SEE PTTLBPTR              */
*       3 SRE1DT2 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SREFLG)-1+16*LENGTH('FLG')-
*             16),                  /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(25+8+8),                                 0413
*       3 * FIXED(8) INIT(31+8+8),                                 0413
*       3 * PTR(31) INIT(ADDR(SRE1LB3)),/* SEE PTTLBPTR              */
*       3 SRE1DT3 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SRENN)-1+16*LENGTH('NN')-16)
*         ,                         /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(35+8+8+8),                               0413
*       3 * FIXED(8) INIT(41+8+8+8),                               0413
*       3 * PTR(31) INIT(ADDR(SRE1LB4)),/* SEE PTTLBPTR              */
*       3 SRE1DT4 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SRESCCW)-1+16*LENGTH('SCCW')
*             -16),                 /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(45+8+8+8+8),                             0413
*       3 * FIXED(8) INIT(51+8+8+8+8),                             0413
*       3 * PTR(31) INIT(ADDR(SRE1LB5)),/* SEE PTTLBPTR              */
*       3 SRE1DT5 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SRETOTSL)-1+16*LENGTH('TOTSL
*             )-16),                /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(55+8+8+8+8+8),                           0413
*       3 * FIXED(8) INIT(61+8+8+8+8+8),                           0413
*       3 * PTR(31) INIT(ADDR(SRE1LB6)),/* SEE PTTLBPTR              */
*       3 SRE1DT6 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * FIXED(31) INIT(0);       /* END OF FORMAT PATTERNS        */
*                                                                  0414
*   /*****************************************************************/
*   /*                                                               */
*   /* SRE2:ILRMLINE (AVLSL,RRCNT,IORB,SAT,SDCTE,EDB) LABEL VARIABLES*/
*   /* REFERENCED IN FORMAT PATTERNS                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0414
*   DCL                                                            0414
*     SRE2LB1 CHAR(LENGTH('AVLSL')) INIT('AVLSL');                 0414
*   DCL                                                            0415
*     SRE2LB2 CHAR(LENGTH('RRCNT')) INIT('RRCNT');                 0415
*   DCL                                                            0416
*     SRE2LB3 CHAR(LENGTH('IORB')) INIT('IORB');                   0416
*   DCL                                                            0417
*     SRE2LB4 CHAR(LENGTH('SAT')) INIT('SAT');                     0417
*   DCL                                                            0418
*     SRE2LB5 CHAR(LENGTH('SDCTE')) INIT('SDCTE');                 0418
*   DCL                                                            0419
*     SRE2LB6 CHAR(LENGTH('EDB')) INIT('EDB');                     0419
*                                                                  0419
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT PATTERNS FOR ONE LINE OF OUTPUT                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0420
*   DCL                                                            0420
*     1 SRE2PTS BDY(WORD),                                         0420
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SREAVLSL)-1+16*LENGTH('AVLSL
*             )-16),                /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(5),                                      0420
*       3 * FIXED(8) INIT(11),                                     0420
*       3 * PTR(31) INIT(ADDR(SRE2LB1)),/* SEE PTTLBPTR              */
*       3 SRE2DT1 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SRERRCNT)-1+16*LENGTH('RRCNT
*             )-16),                /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(15+8),                                   0420
*       3 * FIXED(8) INIT(21+8),                                   0420
*       3 * PTR(31) INIT(ADDR(SRE2LB2)),/* SEE PTTLBPTR              */
*       3 SRE2DT2 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SREIORB)-1+16*LENGTH('IORB')
*             -16),                 /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(25+8+8),                                 0420
*       3 * FIXED(8) INIT(31+8+8),                                 0420
*       3 * PTR(31) INIT(ADDR(SRE2LB3)),/* SEE PTTLBPTR              */
*       3 SRE2DT3 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SRESAT)-1+16*LENGTH('SAT')-
*             16),                  /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(35+8+8+8),                               0420
*       3 * FIXED(8) INIT(41+8+8+8),                               0420
*       3 * PTR(31) INIT(ADDR(SRE2LB4)),/* SEE PTTLBPTR              */
*       3 SRE2DT4 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SRESDCTE)-1+16*LENGTH('SDCTE
*             )-16),                /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(45+8+8+8+8),                             0420
*       3 * FIXED(8) INIT(51+8+8+8+8),                             0420
*       3 * PTR(31) INIT(ADDR(SRE2LB5)),/* SEE PTTLBPTR              */
*       3 SRE2DT5 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SREEDB)-1+16*LENGTH('EDB')-
*             16),                  /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(55+8+8+8+8+8),                           0420
*       3 * FIXED(8) INIT(61+8+8+8+8+8),                           0420
*       3 * PTR(31) INIT(ADDR(SRE2LB6)),/* SEE PTTLBPTR              */
*       3 SRE2DT6 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * FIXED(31) INIT(0);       /* END OF FORMAT PATTERNS        */
*                                                                  0421
*   /*****************************************************************/
*   /*                                                               */
*   /* SRE3:ILRMLINE (UCB) LABEL VARIABLES REFERENCED IN FORMAT      */
*   /* PATTERNS                                                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0421
*   DCL                                                            0421
*     SRE3LB1 CHAR(LENGTH('UCB')) INIT('UCB');                     0421
*                                                                  0421
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT PATTERNS FOR ONE LINE OF OUTPUT                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0422
*   DCL                                                            0422
*     1 SRE3PTS BDY(WORD),                                         0422
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SREUCB)-1+16*LENGTH('UCB')-
*             16),                  /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(5),                                      0422
*       3 * FIXED(8) INIT(11),                                     0422
*       3 * PTR(31) INIT(ADDR(SRE3LB1)),/* SEE PTTLBPTR              */
*       3 SRE3DT1 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * FIXED(31) INIT(0);       /* END OF FORMAT PATTERNS        */
*   RFY                                                            0423
*     R14 RSTD;                                                    0423
*   RTNADDR1=R14;                   /* SAVE RETURN ADDRESS           */
*                                                                  0424
         ST    R14,RTNADDR1                                        0424
*   /*****************************************************************/
*   /*                                                               */
*   /* PUT THE DATA SET NAME INTO THE BUFFER IF IT IS AVAILABLE.     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0425
*   IF DSNPTR=NULLPTR THEN          /* IF THERE IS NO DSNAME THEN    */
         ICM   @15,15,DSNPTR                                       0425
         BNZ   @RF00425                                            0425
*     BUFFER(24:24+LENGTH(DSNLNA))=DSNLNA;/* PUT MSG IN BUFFER       */
         L     @15,ABDPLPTR                                        0426
         L     @15,ADPLBUF(,@15)                                   0426
         MVI   BUFFER+43(@15),C' '                                 0426
         MVC   BUFFER+23(20,@15),DSNLNA                            0426
*   ELSE                            /* DSNAME EXISTS FOR THIS ENTRY  */
*     DO;                                                          0427
         B     @RC00425                                            0427
@RF00425 DS    0H                                                  0428
*       RFY                                                        0428
*        (R0,                                                      0428
*         R1) RSTD;                                                0428
*       R0=ADDR(DSNPTRNS);          /* GET THE ADDR OF THE FORMAT  0429
*                                      PATTERN                       */
         LA    R0,DSNPTRNS                                         0429
*       R1=ABDPLPTR;                /* GET PARM LIST ADDR            */
         L     @15,ABDPLPTR                                        0430
         LR    R1,@15                                              0430
*       DSNDT=DSNPTR;               /* GET THE ADDR OF THE DSNAME    */
         MVC   DSNDT(4),DSNPTR                                     0431
*       RFY                                                        0432
*        (R0,                                                      0432
*         R1) UNRSTD;                                              0432
*       CALL FORMAT;                                               0433
         L     @15,ADPLFRMT(,@15)                                  0433
         BALR  @14,@15                                             0433
*       RFY                                                        0434
*         R15 RSTD;                                                0434
*       SARTERC=R15;                /*                       @ZA11398*/
         ST    R15,SARTERC                                         0435
*     END;                                                         0436
*   RFY                                                            0437
*     R15 UNRSTD;                                                  0437
@RC00425 DS    0H                                                  0438
*   RFY                                                            0438
*    (R0,                                                          0438
*     R1) RSTD;                                                    0438
*   R0=ADDR(SAREPTR);               /* GET ADDRESS OF CONTROL BLOCK  */
         LA    R0,SAREPTR                                          0439
*   R1=ADDR(SARTENAM);              /* GET ADDR OF NAME OF CONTROL 0440
*                                      BLOCK                         */
         LA    R1,SARTENAM                                         0440
*   CALL ILRFPRTH;                  /* PRINT OUT THE CONTROL BLOCK   */
         L     @15,@CV00676                                        0441
         BALR  @14,@15                                             0441
*   RFY                                                            0442
*    (R0,                                                          0442
*     R1) UNRSTD;                                                  0442
*                                                                  0443
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT THE SARTE                                              */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0443
*   DO;                             /* ILRMFRMT (SRE)              0443
*                                      LINES(SRE1,SRE2,SRE3)SPACE    */
*     FORMRC=0;                     /* ZERO THE RETURN CODE          */
         SLR   FORMRC,FORMRC                                       0444
*     SRE1DT1=ADDR(SRENEXT);                                       0445
         L     @15,SAREPTR                                         0445
         ST    @15,SRE1DT1                                         0445
*     SRE1DT2=ADDR(SRELOCK);                                       0446
         LA    @12,SRELOCK(,@15)                                   0446
         ST    @12,SRE1DT2                                         0446
*     SRE1DT3=ADDR(SREFLG);                                        0447
         LA    @12,SREFLG(,@15)                                    0447
         ST    @12,SRE1DT3                                         0447
*     SRE1DT4=ADDR(SRENN);                                         0448
         LA    @12,SRENN(,@15)                                     0448
         ST    @12,SRE1DT4                                         0448
*     SRE1DT5=ADDR(SRESCCW);                                       0449
         LA    @12,SRESCCW(,@15)                                   0449
         ST    @12,SRE1DT5                                         0449
*     SRE1DT6=ADDR(SRETOTSL);                                      0450
         LA    @15,SRETOTSL(,@15)                                  0450
         ST    @15,SRE1DT6                                         0450
*     RFY                                                          0451
*      (R0,                                                        0451
*       R1) RSTD;                                                  0451
*     R0=ADDR(SRE1PTS);                                            0452
         LA    R0,SRE1PTS                                          0452
*     R1=ABDPLPTR;                  /* GET PARM ADDR                 */
         L     @15,ABDPLPTR                                        0453
         LR    R1,@15                                              0453
*     CALL FORMAT;                  /* FORMAT THE LINE               */
         L     @15,ADPLFRMT(,@15)                                  0454
         BALR  @14,@15                                             0454
*     RFY                                                          0455
*       R15 RSTD;                                                  0455
*     FORMRC=FORMRC|R15;            /* SAVE RETURN CODE              */
         OR    FORMRC,R15                                          0456
*     RFY                                                          0457
*       R15 UNRSTD;                                                0457
*     CALL PRINT;                   /* CALL PRINT ROUTINE            */
         L     @12,ABDPLPTR                                        0458
         L     @15,ADPLPRNT(,@12)                                  0458
         BALR  @14,@15                                             0458
*     RFY                                                          0459
*      (R0,                                                        0459
*       R1) UNRSTD;                                                0459
*     SRE2DT1=ADDR(SREAVLSL);                                      0460
         L     @15,SAREPTR                                         0460
         LA    @12,SREAVLSL(,@15)                                  0460
         ST    @12,SRE2DT1                                         0460
*     SRE2DT2=ADDR(SRERRCNT);                                      0461
         LA    @12,SRERRCNT(,@15)                                  0461
         ST    @12,SRE2DT2                                         0461
*     SRE2DT3=ADDR(SREIORB);                                       0462
         LA    @12,SREIORB(,@15)                                   0462
         ST    @12,SRE2DT3                                         0462
*     SRE2DT4=ADDR(SRESAT);                                        0463
         LA    @12,SRESAT(,@15)                                    0463
         ST    @12,SRE2DT4                                         0463
*     SRE2DT5=ADDR(SRESDCTE);                                      0464
         LA    @12,SRESDCTE(,@15)                                  0464
         ST    @12,SRE2DT5                                         0464
*     SRE2DT6=ADDR(SREEDB);                                        0465
         LA    @15,SREEDB(,@15)                                    0465
         ST    @15,SRE2DT6                                         0465
*     RFY                                                          0466
*      (R0,                                                        0466
*       R1) RSTD;                                                  0466
*     R0=ADDR(SRE2PTS);                                            0467
         LA    R0,SRE2PTS                                          0467
*     R1=ABDPLPTR;                  /* GET PARM ADDR                 */
         L     @15,ABDPLPTR                                        0468
         LR    R1,@15                                              0468
*     CALL FORMAT;                  /* FORMAT THE LINE               */
         L     @15,ADPLFRMT(,@15)                                  0469
         BALR  @14,@15                                             0469
*     RFY                                                          0470
*       R15 RSTD;                                                  0470
*     FORMRC=FORMRC|R15;            /* SAVE RETURN CODE              */
         OR    FORMRC,R15                                          0471
*     RFY                                                          0472
*       R15 UNRSTD;                                                0472
*     CALL PRINT;                   /* CALL PRINT ROUTINE            */
         L     @12,ABDPLPTR                                        0473
         L     @15,ADPLPRNT(,@12)                                  0473
         BALR  @14,@15                                             0473
*     RFY                                                          0474
*      (R0,                                                        0474
*       R1) UNRSTD;                                                0474
*     SRE3DT1=ADDR(SREUCB);                                        0475
         L     @15,SAREPTR                                         0475
         LA    @15,SREUCB(,@15)                                    0475
         ST    @15,SRE3DT1                                         0475
*     RFY                                                          0476
*      (R0,                                                        0476
*       R1) RSTD;                                                  0476
*     R0=ADDR(SRE3PTS);                                            0477
         LA    R0,SRE3PTS                                          0477
*     R1=ABDPLPTR;                  /* GET PARM ADDR                 */
         L     @15,ABDPLPTR                                        0478
         LR    R1,@15                                              0478
*     CALL FORMAT;                  /* FORMAT THE LINE               */
         L     @15,ADPLFRMT(,@15)                                  0479
         BALR  @14,@15                                             0479
*     RFY                                                          0480
*       R15 RSTD;                                                  0480
*     FORMRC=FORMRC|R15;            /* SAVE RETURN CODE              */
         OR    FORMRC,R15                                          0481
*     RFY                                                          0482
*       R15 UNRSTD;                                                0482
*     CALL PRINT;                   /* CALL PRINT ROUTINE            */
         L     @12,ABDPLPTR                                        0483
         L     @15,ADPLPRNT(,@12)                                  0483
         BALR  @14,@15                                             0483
*     RFY                                                          0484
*      (R0,                                                        0484
*       R1) UNRSTD;                                                0484
*     RFY                                                          0485
*       R1 RSTD;                                                   0485
*     R1=ABDPLPTR;                  /* GET PARM ADDR                 */
         L     @15,ABDPLPTR                                        0486
         LR    R1,@15                                              0486
*     CALL PRINT;                   /* CALL PRINT ROUTINE            */
         L     @15,ADPLPRNT(,@15)                                  0487
         BALR  @14,@15                                             0487
*     RFY                                                          0488
*       R1 UNRSTD;                                                 0488
*     RFY                                                          0489
*       R15 RSTD;                                                  0489
*     R15=FORMRC;                   /* SAVE RETURN CODE FROM FORMAT  */
         LR    R15,FORMRC                                          0490
*     RFY                                                          0491
*       R15 UNRSTD;                                                0491
*   END;                            /* ILRMFRMT (SRE)              0492
*                                      LINES(SRE1,SRE2,SRE3)SPACE    */
*   RFY                                                            0493
*     R15 RSTD;                                                    0493
*   SARTERC=SARTERC|R15;            /* SAVE THE RETURN CODE          */
         L     @12,SARTERC                                         0494
         OR    @12,R15                                             0494
         ST    @12,SARTERC                                         0494
*   RFY                                                            0495
*     R15 UNRSTD;                                                  0495
*                                                                  0496
*   /*****************************************************************/
*   /*                                                               */
*   /* ISSUE ACCESS TO PICK UP THE ADDRESS OF THE SAT AND IF THE     */
*   /* ACCESS IS SUCCESSFUL CALL FMTSAT TO FORMAT IT.                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0496
*   DO;                             /* ILRMACCS (SATPTR) FROM(SRESAT)*/
*     RFY                                                          0497
*      (R0,                                                        0497
*       R1,                                                        0497
*       R14,                                                       0497
*       R15) RSTD;                                                 0497
*     R0=ADDR(SRESAT);                                             0498
         L     @12,SAREPTR                                         0498
         LA    R0,SRESAT(,@12)                                     0498
*     R1=ABDPLPTR;                  /* POINT TO PARM LIST            */
         L     @12,ABDPLPTR                                        0499
         LR    R1,@12                                              0499
*     CALL ACCESS;                  /* ACCESS DATA                   */
         L     @15,ADPLMEMA(,@12)                                  0500
         BALR  @14,@15                                             0500
*     R14=R0;                       /* CANNOT USE R0 AS BASE         */
         LR    R14,R0                                              0501
*     IF R15=GOOD THEN              /* CHECK ACCESS                  */
         LTR   R15,R15                                             0502
         BNZ   @RF00502                                            0502
*       SATPTR=CURRENT;             /* GET REQUESTED FIELD           */
         MVC   SATPTR(4),CURRENT(R14)                              0503
*     ELSE                          /* ACCESS NO GOOD                */
*       SATPTR=ZERO;                /* ZERO FIELD                    */
         B     @RC00502                                            0504
@RF00502 SLR   @12,@12                                             0504
         ST    @12,SATPTR                                          0504
*     RFY                                                          0505
*      (R0,                                                        0505
*       R1,                                                        0505
*       R14,                                                       0505
*       R15) UNRSTD;                                               0505
@RC00502 DS    0H                                                  0506
*   END;                                                           0506
*   IF SATPTR^=NULLPTR THEN         /* ACCESS WAS GOOD               */
         ICM   @12,15,SATPTR                                       0507
         BZ    @RF00507                                            0507
*     CALL FMTSAT;                  /* CALL SEGMENT TO FMT SAT       */
         BAL   @14,FMTSAT                                          0508
*   RFY                                                            0509
*     R15 RSTD;                                                    0509
@RF00507 DS    0H                                                  0510
*   SARTERC=SARTERC|R15;            /* SAVE THE RETURN CODE          */
         L     @14,SARTERC                                         0510
         OR    @14,R15                                             0510
         ST    @14,SARTERC                                         0510
*   RFY                                                            0511
*     R15 UNRSTD;                                                  0511
*                                                                  0511
*   /*****************************************************************/
*   /*                                                               */
*   /* GET THE SCCW ADDRESS FROM THE SARTE AND IF THE ACCESS IS GOOD */
*   /* AND THERE IS AN SCCW SET UP THE ANCHOR AND CALL FMTSCCW TO    */
*   /* FORMAT IT.                                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0512
*   DO;                             /* ILRMACCS (SCCWPTR)          0512
*                                      FROM(SRESCCW)                 */
*     RFY                                                          0513
*      (R0,                                                        0513
*       R1,                                                        0513
*       R14,                                                       0513
*       R15) RSTD;                                                 0513
*     R0=ADDR(SRESCCW);                                            0514
         L     @12,SAREPTR                                         0514
         LA    R0,SRESCCW(,@12)                                    0514
*     R1=ABDPLPTR;                  /* POINT TO PARM LIST            */
         L     @12,ABDPLPTR                                        0515
         LR    R1,@12                                              0515
*     CALL ACCESS;                  /* ACCESS DATA                   */
         L     @15,ADPLMEMA(,@12)                                  0516
         BALR  @14,@15                                             0516
*     R14=R0;                       /* CANNOT USE R0 AS BASE         */
         LR    R14,R0                                              0517
*     IF R15=GOOD THEN              /* CHECK ACCESS                  */
         LTR   R15,R15                                             0518
         BNZ   @RF00518                                            0518
*       SCCWPTR=CURRENT;            /* GET REQUESTED FIELD           */
         MVC   SCCWPTR(4),CURRENT(R14)                             0519
*     ELSE                          /* ACCESS NO GOOD                */
*       SCCWPTR=ZERO;               /* ZERO FIELD                    */
         B     @RC00518                                            0520
@RF00518 SLR   @12,@12                                             0520
         ST    @12,SCCWPTR                                         0520
*     RFY                                                          0521
*      (R0,                                                        0521
*       R1,                                                        0521
*       R14,                                                       0521
*       R15) UNRSTD;                                               0521
@RC00518 DS    0H                                                  0522
*   END;                                                           0522
*   IF SCCWPTR^=NULLPTR THEN        /* THERE ARE SOME ON QUEUE       */
         ICM   @12,15,SCCWPTR                                      0523
         BZ    @RF00523                                            0523
*     DO;                                                          0524
*       ANCHTXT=ANCH;               /* PUT LABEL IN BUFFER           */
         L     @12,ABDPLPTR                                        0525
         L     @12,ADPLBUF(,@12)                                   0525
         MVC   ANCHTXT(11,@12),ANCH                                0525
*       ANCHNAME=ANCHSCW1;          /* PUT IN ANCHOR NAME            */
         MVC   ANCHNAME(8,@12),ANCHSCW1                            0526
*       CALL FMTSCCW;               /* CALL SEGMENT TO FMT SCCW Q    */
         BAL   @14,FMTSCCW                                         0527
*     END;                                                         0528
*   RFY                                                            0529
*     R15 RSTD;                                                    0529
@RF00523 DS    0H                                                  0530
*   SARTERC=SARTERC|R15;            /* SAVE THE RETURN CODE          */
         L     @14,SARTERC                                         0530
         OR    @14,R15                                             0530
         ST    @14,SARTERC                                         0530
*   RFY                                                            0531
*     R15 UNRSTD;                                                  0531
*                                                                  0532
*   /*****************************************************************/
*   /*                                                               */
*   /* GET THE IORB ADDRESS FROM THE SARTE AND IF THE ACCESS IS      */
*   /* SUCCESSFUL AND THERE IS A POINTER SET UP THE ANCHOR AND CALL  */
*   /* FMTIORB FOR FORMATTING.                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0532
*   DO;                             /* ILRMACCS (IORBPTR)          0532
*                                      FROM(SREIORB)                 */
*     RFY                                                          0533
*      (R0,                                                        0533
*       R1,                                                        0533
*       R14,                                                       0533
*       R15) RSTD;                                                 0533
*     R0=ADDR(SREIORB);                                            0534
         L     @12,SAREPTR                                         0534
         LA    R0,SREIORB(,@12)                                    0534
*     R1=ABDPLPTR;                  /* POINT TO PARM LIST            */
         L     @12,ABDPLPTR                                        0535
         LR    R1,@12                                              0535
*     CALL ACCESS;                  /* ACCESS DATA                   */
         L     @15,ADPLMEMA(,@12)                                  0536
         BALR  @14,@15                                             0536
*     R14=R0;                       /* CANNOT USE R0 AS BASE         */
         LR    R14,R0                                              0537
*     IF R15=GOOD THEN              /* CHECK ACCESS                  */
         LTR   R15,R15                                             0538
         BNZ   @RF00538                                            0538
*       IORBPTR=CURRENT;            /* GET REQUESTED FIELD           */
         MVC   IORBPTR(4),CURRENT(R14)                             0539
*     ELSE                          /* ACCESS NO GOOD                */
*       IORBPTR=ZERO;               /* ZERO FIELD                    */
         B     @RC00538                                            0540
@RF00538 SLR   @12,@12                                             0540
         ST    @12,IORBPTR                                         0540
*     RFY                                                          0541
*      (R0,                                                        0541
*       R1,                                                        0541
*       R14,                                                       0541
*       R15) UNRSTD;                                               0541
@RC00538 DS    0H                                                  0542
*   END;                                                           0542
*   RFY                                                            0543
*     R15 RSTD;                                                    0543
*   RFY                                                            0544
*     R15 UNRSTD;                                                  0544
*   IF IORBPTR^=NULLPTR THEN        /* THERE ARE SOME ON QUEUE       */
         ICM   @12,15,IORBPTR                                      0545
         BZ    @RF00545                                            0545
*     DO;                                                          0546
*       ANCHTXT=ANCH;               /* PUT LABEL IN BUFFER           */
         L     @12,ABDPLPTR                                        0547
         L     @12,ADPLBUF(,@12)                                   0547
         MVC   ANCHTXT(11,@12),ANCH                                0547
*       ANCHNAME=ANCHIOR2;          /* PUT ANCHOR NAME IN BUFFER     */
         MVC   ANCHNAME(8,@12),ANCHIOR2                            0548
*       CALL FMTIORB;               /* CALL SEGMENT TO FMT IORB Q    */
         BAL   @14,FMTIORB                                         0549
*     END;                                                         0550
*   RFY                                                            0551
*     R15 RSTD;                                                    0551
@RF00545 DS    0H                                                  0552
*   SARTERC=SARTERC|R15;            /* SAVE THE RETURN CODE          */
         L     @14,SARTERC                                         0552
         OR    @14,R15                                             0552
         ST    @14,SARTERC                                         0552
*   RFY                                                            0553
*     R15 UNRSTD;                                                  0553
*   RFY                                                            0554
*    (R14,                                                         0554
*     R15) RSTD;                                                   0554
*   R15=SARTERC;                    /* PUT THE RETURN CODE IN REG 15 */
         L     @12,SARTERC                                         0555
         LR    R15,@12                                             0555
*   R14=RTNADDR1;                   /* RESTORE RETURN ADDRESS        */
         L     R14,RTNADDR1                                        0556
*   RFY                                                            0557
*    (R14,                                                         0557
*     R15) UNRSTD;                                                 0557
*   END FMTSARTE;                   /* RETURN TO CALLER              */
@EL00004 DS    0H                                                  0558
@EF00004 DS    0H                                                  0558
@ER00004 BR    @14                                                 0558
*                                                                  0559
*/********************************************************************/
*/*                                                                  */
*/* FMTSAT:  SEGMENT TO FORMAT THE SAT                               */
*/*                                                                  */
*/* INPUT:   VIRTUAL ADDRESS IN SATPTR                               */
*/*                                                                  */
*/* PROCESS: FORMAT THE SAT HEADER SECTION, CALCULATE THE SIZE       */
*/*           FOR THE SATMAP AND FORMAT THE PATMAP.                  */
*/*                                                                  */
*/* OUTPUT:  RETURN CODE = 0 IF ALL FORMATS SUCCEED, OTHERWISE,      */
*/*           RETURN CODE > ZERO.                                    */
*/*                                                                  */
*/********************************************************************/
*                                                                  0559
*FMTSAT:                                                           0559
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0559
FMTSAT   DS    0H                                                  0560
*                                                                  0560
*   /*****************************************************************/
*   /*                                                               */
*   /* SAT1:ILRMLINE ((ID,ASIS),SARTE,MAPLN,BYTCL,OFFST,MASK) OF(SAT)*/
*   /* LABEL VARIABLES REFERENCED IN FORMAT PATTERNS                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0560
*   DCL                                                            0560
*     SAT1LB1 CHAR(LENGTH('ID')) INIT('ID');                       0560
*   DCL                                                            0561
*     SAT1LB2 CHAR(LENGTH('SARTE')) INIT('SARTE');                 0561
*   DCL                                                            0562
*     SAT1LB3 CHAR(LENGTH('MAPLN')) INIT('MAPLN');                 0562
*   DCL                                                            0563
*     SAT1LB4 CHAR(LENGTH('BYTCL')) INIT('BYTCL');                 0563
*   DCL                                                            0564
*     SAT1LB5 CHAR(LENGTH('OFFST')) INIT('OFFST');                 0564
*   DCL                                                            0565
*     SAT1LB6 CHAR(LENGTH('MASK')) INIT('MASK');                   0565
*                                                                  0565
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT PATTERNS FOR ONE LINE OF OUTPUT                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0566
*   DCL                                                            0566
*     1 SAT1PTS BDY(WORD),                                         0566
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00101111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SATID)-1+16*LENGTH('ID')-16)
*         ,                         /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(5),                                      0566
*       3 * FIXED(8) INIT(11),                                     0566
*       3 * PTR(31) INIT(ADDR(SAT1LB1)),/* SEE PTTLBPTR              */
*       3 SAT1DT1 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SATSARTE)-1+16*LENGTH('SARTE
*             )-16),                /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(15+8),                                   0566
*       3 * FIXED(8) INIT(21+8),                                   0566
*       3 * PTR(31) INIT(ADDR(SAT1LB2)),/* SEE PTTLBPTR              */
*       3 SAT1DT2 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SATMAPLN)-1+16*LENGTH('MAPLN
*             )-16),                /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(25+8+8),                                 0566
*       3 * FIXED(8) INIT(31+8+8),                                 0566
*       3 * PTR(31) INIT(ADDR(SAT1LB3)),/* SEE PTTLBPTR              */
*       3 SAT1DT3 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SATBYTCL)-1+16*LENGTH('BYTCL
*             )-16),                /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(35+8+8+8),                               0566
*       3 * FIXED(8) INIT(41+8+8+8),                               0566
*       3 * PTR(31) INIT(ADDR(SAT1LB4)),/* SEE PTTLBPTR              */
*       3 SAT1DT4 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SATOFFST)-1+16*LENGTH('OFFST
*             )-16),                /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(45+8+8+8+8),                             0566
*       3 * FIXED(8) INIT(51+8+8+8+8),                             0566
*       3 * PTR(31) INIT(ADDR(SAT1LB5)),/* SEE PTTLBPTR              */
*       3 SAT1DT5 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SATMASK)-1+16*LENGTH('MASK')
*             -16),                 /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(55+8+8+8+8+8),                           0566
*       3 * FIXED(8) INIT(61+8+8+8+8+8),                           0566
*       3 * PTR(31) INIT(ADDR(SAT1LB6)),/* SEE PTTLBPTR              */
*       3 SAT1DT6 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * FIXED(31) INIT(0);       /* END OF FORMAT PATTERNS        */
*                                                                  0567
*   /*****************************************************************/
*   /*                                                               */
*   /* SAT2:ILRMLINE (SCAN,SLTNO,ASGN) LABEL VARIABLES REFERENCED IN */
*   /* FORMAT PATTERNS                                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0567
*   DCL                                                            0567
*     SAT2LB1 CHAR(LENGTH('SCAN')) INIT('SCAN');                   0567
*   DCL                                                            0568
*     SAT2LB2 CHAR(LENGTH('SLTNO')) INIT('SLTNO');                 0568
*   DCL                                                            0569
*     SAT2LB3 CHAR(LENGTH('ASGN')) INIT('ASGN');                   0569
*                                                                  0569
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT PATTERNS FOR ONE LINE OF OUTPUT                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0570
*   DCL                                                            0570
*     1 SAT2PTS BDY(WORD),                                         0570
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SATSCAN)-1+16*LENGTH('SCAN')
*             -16),                 /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(5),                                      0570
*       3 * FIXED(8) INIT(11),                                     0570
*       3 * PTR(31) INIT(ADDR(SAT2LB1)),/* SEE PTTLBPTR              */
*       3 SAT2DT1 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SATSLTNO)-1+16*LENGTH('SLTNO
*             )-16),                /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(15+8),                                   0570
*       3 * FIXED(8) INIT(21+8),                                   0570
*       3 * PTR(31) INIT(ADDR(SAT2LB2)),/* SEE PTTLBPTR              */
*       3 SAT2DT2 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SATASGN)-1+16*LENGTH('ASGN')
*             -16),                 /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(25+8+8),                                 0570
*       3 * FIXED(8) INIT(31+8+8),                                 0570
*       3 * PTR(31) INIT(ADDR(SAT2LB3)),/* SEE PTTLBPTR              */
*       3 SAT2DT3 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * FIXED(31) INIT(0);       /* END OF FORMAT PATTERNS        */
*                                                                  0571
*   /*****************************************************************/
*   /*                                                               */
*   /* SAT3:ILRMARRY (CYLMP,8) FORMAT PATTERNS FOR ONE LINE OF OUTPUT*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0571
*   DCL                                                            0571
*     1 SAT3PTS BDY(WORD),                                         0571
*      2 * CHAR(8) BDY(WORD),       /* ONE FORMAT PATTERN            */
*       3 * BIT(8) INIT('00001100'B),/* SEE PTTFLGS                  */
*         5 * BIT(2),                                              0571
*         5 * BIT(6),                                              0571
*       3 * BIT(8) INIT(16*0+LENGTH(SATCYLMP)-1),/* SEE PTTLBLGH AND
*                                      PTTDTLGH                      */
*       3 * FIXED(8) INIT(0),       /* SEE PTTLBOFF                  */
*       3 * FIXED(8) INIT(5),       /* SEE PTTDTOFF                  */
*       3 SAT3DT1 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(8) BDY(WORD),       /* ONE FORMAT PATTERN            */
*       3 * BIT(8) INIT('00001100'B),/* SEE PTTFLGS                  */
*         5 * BIT(2),                                              0571
*         5 * BIT(6),                                              0571
*       3 * BIT(8) INIT(16*0+LENGTH(SATCYLMP)-1),/* SEE PTTLBLGH AND
*                                      PTTDTLGH                      */
*       3 * FIXED(8) INIT(0),       /* SEE PTTLBOFF                  */
*       3 * FIXED(8) INIT(17),      /* SEE PTTDTOFF                  */
*       3 SAT3DT2 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(8) BDY(WORD),       /* ONE FORMAT PATTERN            */
*       3 * BIT(8) INIT('00001100'B),/* SEE PTTFLGS                  */
*         5 * BIT(2),                                              0571
*         5 * BIT(6),                                              0571
*       3 * BIT(8) INIT(16*0+LENGTH(SATCYLMP)-1),/* SEE PTTLBLGH AND
*                                      PTTDTLGH                      */
*       3 * FIXED(8) INIT(0),       /* SEE PTTLBOFF                  */
*       3 * FIXED(8) INIT(29),      /* SEE PTTDTOFF                  */
*       3 SAT3DT3 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(8) BDY(WORD),       /* ONE FORMAT PATTERN            */
*       3 * BIT(8) INIT('00001100'B),/* SEE PTTFLGS                  */
*         5 * BIT(2),                                              0571
*         5 * BIT(6),                                              0571
*       3 * BIT(8) INIT(16*0+LENGTH(SATCYLMP)-1),/* SEE PTTLBLGH AND
*                                      PTTDTLGH                      */
*       3 * FIXED(8) INIT(0),       /* SEE PTTLBOFF                  */
*       3 * FIXED(8) INIT(41),      /* SEE PTTDTOFF                  */
*       3 SAT3DT4 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(8) BDY(WORD),       /* ONE FORMAT PATTERN            */
*       3 * BIT(8) INIT('00001100'B),/* SEE PTTFLGS                  */
*         5 * BIT(2),                                              0571
*         5 * BIT(6),                                              0571
*       3 * BIT(8) INIT(16*0+LENGTH(SATCYLMP)-1),/* SEE PTTLBLGH AND
*                                      PTTDTLGH                      */
*       3 * FIXED(8) INIT(0),       /* SEE PTTLBOFF                  */
*       3 * FIXED(8) INIT(53),      /* SEE PTTDTOFF                  */
*       3 SAT3DT5 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(8) BDY(WORD),       /* ONE FORMAT PATTERN            */
*       3 * BIT(8) INIT('00001100'B),/* SEE PTTFLGS                  */
*         5 * BIT(2),                                              0571
*         5 * BIT(6),                                              0571
*       3 * BIT(8) INIT(16*0+LENGTH(SATCYLMP)-1),/* SEE PTTLBLGH AND
*                                      PTTDTLGH                      */
*       3 * FIXED(8) INIT(0),       /* SEE PTTLBOFF                  */
*       3 * FIXED(8) INIT(65),      /* SEE PTTDTOFF                  */
*       3 SAT3DT6 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(8) BDY(WORD),       /* ONE FORMAT PATTERN            */
*       3 * BIT(8) INIT('00001100'B),/* SEE PTTFLGS                  */
*         5 * BIT(2),                                              0571
*         5 * BIT(6),                                              0571
*       3 * BIT(8) INIT(16*0+LENGTH(SATCYLMP)-1),/* SEE PTTLBLGH AND
*                                      PTTDTLGH                      */
*       3 * FIXED(8) INIT(0),       /* SEE PTTLBOFF                  */
*       3 * FIXED(8) INIT(77),      /* SEE PTTDTOFF                  */
*       3 SAT3DT7 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(8) BDY(WORD),       /* ONE FORMAT PATTERN            */
*       3 * BIT(8) INIT('00001100'B),/* SEE PTTFLGS                  */
*         5 * BIT(2),                                              0571
*         5 * BIT(6),                                              0571
*       3 * BIT(8) INIT(16*0+LENGTH(SATCYLMP)-1),/* SEE PTTLBLGH AND
*                                      PTTDTLGH                      */
*       3 * FIXED(8) INIT(0),       /* SEE PTTLBOFF                  */
*       3 * FIXED(8) INIT(89),      /* SEE PTTDTOFF                  */
*       3 SAT3DT8 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * FIXED(31) INIT(0);       /* END OF FORMAT PATTERNS        */
*   RFY                                                            0572
*     R14 RSTD;                                                    0572
*   RTNADDR2=R14;                   /* SAVE RETURN ADDRESS           */
         ST    R14,RTNADDR2                                        0573
*   RFY                                                            0574
*     R14 UNRSTD;                                                  0574
*                                                                  0574
*   /*****************************************************************/
*   /*                                                               */
*   /* SET UP AND PRINT THE HEADER LINE FOR THE SAT                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0575
*   ANCHTXT=ANCH;                   /* SET UP HEADER                 */
         L     @12,ABDPLPTR                                        0575
         L     @12,ADPLBUF(,@12)                                   0575
         MVC   ANCHTXT(11,@12),ANCH                                0575
*   ANCHNAME=ANCHSAT;               /* NAME OF BLOCK                 */
         MVC   ANCHNAME(8,@12),ANCHSAT                             0576
*   RFY                                                            0577
*    (R0,                                                          0577
*     R1) RSTD;                                                    0577
*   R0=ADDR(SATPTR);                /* ADDRESS OF BLOCK              */
         LA    R0,SATPTR                                           0578
*   R1=ADDR(SATNAM);                /* NAME OF BLOCK                 */
         LA    R1,SATNAM                                           0579
*   CALL ILRFPRTH;                  /* PRINT HEADER                  */
         L     @15,@CV00676                                        0580
         BALR  @14,@15                                             0580
*   RFY                                                            0581
*    (R0,                                                          0581
*     R1) UNRSTD;                                                  0581
*                                                                  0581
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT THE FIRST TWO LINES OF THE SAT                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0582
*   DO;                             /* ILRMFRMT (SAT)              0582
*                                      LINES(SAT1,SAT2)              */
*     FORMRC=0;                     /* ZERO THE RETURN CODE          */
         SLR   FORMRC,FORMRC                                       0583
*     SAT1DT1=ADDR(SATID);                                         0584
         L     @12,SATPTR                                          0584
         ST    @12,SAT1DT1                                         0584
*     SAT1DT2=ADDR(SATSARTE);                                      0585
         LA    @03,SATSARTE(,@12)                                  0585
         ST    @03,SAT1DT2                                         0585
*     SAT1DT3=ADDR(SATMAPLN);                                      0586
         LA    @03,SATMAPLN(,@12)                                  0586
         ST    @03,SAT1DT3                                         0586
*     SAT1DT4=ADDR(SATBYTCL);                                      0587
         LA    @03,SATBYTCL(,@12)                                  0587
         ST    @03,SAT1DT4                                         0587
*     SAT1DT5=ADDR(SATOFFST);                                      0588
         LA    @03,SATOFFST(,@12)                                  0588
         ST    @03,SAT1DT5                                         0588
*     SAT1DT6=ADDR(SATMASK);                                       0589
         LA    @12,SATMASK(,@12)                                   0589
         ST    @12,SAT1DT6                                         0589
*     RFY                                                          0590
*      (R0,                                                        0590
*       R1) RSTD;                                                  0590
*     R0=ADDR(SAT1PTS);                                            0591
         LA    R0,SAT1PTS                                          0591
*     R1=ABDPLPTR;                  /* GET PARM ADDR                 */
         L     @12,ABDPLPTR                                        0592
         LR    R1,@12                                              0592
*     CALL FORMAT;                  /* FORMAT THE LINE               */
         L     @15,ADPLFRMT(,@12)                                  0593
         BALR  @14,@15                                             0593
*     RFY                                                          0594
*       R15 RSTD;                                                  0594
*     FORMRC=FORMRC|R15;            /* SAVE RETURN CODE              */
         OR    FORMRC,R15                                          0595
*     RFY                                                          0596
*       R15 UNRSTD;                                                0596
*     CALL PRINT;                   /* CALL PRINT ROUTINE            */
         L     @12,ABDPLPTR                                        0597
         L     @15,ADPLPRNT(,@12)                                  0597
         BALR  @14,@15                                             0597
*     RFY                                                          0598
*      (R0,                                                        0598
*       R1) UNRSTD;                                                0598
*     SAT2DT1=ADDR(SATSCAN);                                       0599
         L     @12,SATPTR                                          0599
         LA    @03,SATSCAN(,@12)                                   0599
         ST    @03,SAT2DT1                                         0599
*     SAT2DT2=ADDR(SATSLTNO);                                      0600
         LA    @03,SATSLTNO(,@12)                                  0600
         ST    @03,SAT2DT2                                         0600
*     SAT2DT3=ADDR(SATASGN);                                       0601
         LA    @12,SATASGN(,@12)                                   0601
         ST    @12,SAT2DT3                                         0601
*     RFY                                                          0602
*      (R0,                                                        0602
*       R1) RSTD;                                                  0602
*     R0=ADDR(SAT2PTS);                                            0603
         LA    R0,SAT2PTS                                          0603
*     R1=ABDPLPTR;                  /* GET PARM ADDR                 */
         L     @12,ABDPLPTR                                        0604
         LR    R1,@12                                              0604
*     CALL FORMAT;                  /* FORMAT THE LINE               */
         L     @15,ADPLFRMT(,@12)                                  0605
         BALR  @14,@15                                             0605
*     RFY                                                          0606
*       R15 RSTD;                                                  0606
*     FORMRC=FORMRC|R15;            /* SAVE RETURN CODE              */
         OR    FORMRC,R15                                          0607
*     RFY                                                          0608
*       R15 UNRSTD;                                                0608
*     CALL PRINT;                   /* CALL PRINT ROUTINE            */
         L     @12,ABDPLPTR                                        0609
         L     @15,ADPLPRNT(,@12)                                  0609
         BALR  @14,@15                                             0609
*     RFY                                                          0610
*      (R0,                                                        0610
*       R1) UNRSTD;                                                0610
*     RFY                                                          0611
*       R15 RSTD;                                                  0611
*     R15=FORMRC;                   /* SAVE RETURN CODE FROM FORMAT  */
         LR    R15,FORMRC                                          0612
*     RFY                                                          0613
*       R15 UNRSTD;                                                0613
*   END;                            /* ILRMFRMT (SAT)              0614
*                                      LINES(SAT1,SAT2)              */
*   RFY                                                            0615
*     R15 RSTD;                                                    0615
*   SATRC=R15;                      /* ADD IN RETURN CODE            */
         LR    SATRC,R15                                           0616
*   RFY                                                            0617
*     R15 UNRSTD;                                                  0617
*                                                                  0618
*   /*****************************************************************/
*   /*                                                               */
*   /* PUT THE HEADER IN THE BUFFER FOR THE SATMAP                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0618
*   BUFFER(1:6)=SATMAP;             /* MOVE 'SATMAP' TO BUFFER       */
         L     @12,ABDPLPTR                                        0618
         L     @01,ADPLBUF(,@12)                                   0618
         MVC   BUFFER(6,@01),SATMAP                                0618
*   CALL PRINT;                     /* PRINT THE HEADING             */
*                                                                  0619
         L     @15,ADPLPRNT(,@12)                                  0619
         BALR  @14,@15                                             0619
*   /*****************************************************************/
*   /*                                                               */
*   /* GET THE SIZE OF THE SATMAP AND USE ILRMARRY TO FORMAT IT.     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0620
*   RFY                                                            0620
*    (R0,                                                          0620
*     R1,                                                          0620
*     R14,                                                         0620
*     R15) RSTD;                                                   0620
*   R0=ADDR(SATMAPLN);              /* GET THE ADDR OF THE DATA      */
         L     @12,SATPTR                                          0621
         LA    R0,SATMAPLN(,@12)                                   0621
*   R1=ABDPLPTR;                    /* GET ADDR OF PARM LIST         */
         L     @12,ABDPLPTR                                        0622
         LR    R1,@12                                              0622
*   CALL ACCESS;                    /* HECK IF DATA IS AVAILABLE     */
         L     @15,ADPLMEMA(,@12)                                  0623
         BALR  @14,@15                                             0623
*   R14=R0;                         /* GET ADDR OF THE DATA          */
         LR    R14,R0                                              0624
*   IF R15=GOOD THEN                /* WAS THE ACCESS SUCCESSFUL     */
         LTR   R15,R15                                             0625
         BNZ   @RF00625                                            0625
*     MAPSIZE=HALFCURR;             /* GET THE DATA                  */
         LH    @12,HALFCURR(,R14)                                  0626
         ST    @12,MAPSIZE                                         0626
*   ELSE                                                           0627
*     MAPSIZE=ZERO;                 /* ZERO THE DATA POINTER         */
         B     @RC00625                                            0627
@RF00625 SLR   @12,@12                                             0627
         ST    @12,MAPSIZE                                         0627
*   RFY                                                            0628
*    (R0,                                                          0628
*     R1,                                                          0628
*     R14,                                                         0628
*     R15) UNRSTD;                                                 0628
@RC00625 DS    0H                                                  0629
*   IF MAPSIZE=0 THEN               /* NO MAP SOMETHING WRONG        */
         ICM   @12,15,MAPSIZE                                      0629
         BNZ   @RF00629                                            0629
*     DO;                           /* ERROR RETURN                  */
*       SATRC=4;                    /* SET ERROR RETURN CODE         */
         LA    SATRC,4                                             0631
*       GO TO SATRTN;               /* RETURN TO CALLER              */
         B     SATRTN                                              0632
*     END;                                                         0633
*                                                                  0633
*   /*****************************************************************/
*   /*                                                               */
*   /* THE SATMAP IS PRINTED 8 WORDS PER LINE AND THE LENGTH IS GIVEN*/
*   /* IN BYTES. TO DETERMINE # OF LINES DIVIDE BY 32(4 BYTES/WORD   */
*   /* AND 8 WORDS/LINE.                                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0634
*   CTR=MAPSIZE/32;                 /* DETERMINE NUMBER OF LINES     */
@RF00629 L     @12,MAPSIZE                                         0634
         LR    @00,@12                                             0634
         SRDA  @00,32                                              0634
         D     @00,@CF00136                                        0634
         ST    @01,CTR                                             0634
*   REM=MAPSIZE//32;                /* OF SATMAP TO PRINT            */
         LR    @00,@12                                             0635
         SRDA  @00,32                                              0635
         D     @00,@CF00136                                        0635
         LR    REM,@00                                             0635
*   MAPPTR=ADDR(SATMAPS);           /* GET THE ADDRESS OF THE ARRAY  */
         L     MAPPTR,SATPTR                                       0636
         LA    MAPPTR,SATMAPS(,MAPPTR)                             0636
*   RFY                                                            0637
*     SATCYLMP BASED(MAPPTR);       /* ADDRESSABILITY FOR MAPWORDS   */
*   DO I=1 TO CTR;                                                 0638
         LA    I,1                                                 0638
         B     @DE00638                                            0638
@DL00638 DS    0H                                                  0639
*     DO;                           /* ILRMFRMT ARRAY(SAT3)          */
*       FORMRC=0;                   /* ZERO THE RETURN CODE          */
         SLR   FORMRC,FORMRC                                       0640
*       SAT3DT1=ADDR(SATCYLMP)+00*LENGTH(SATCYLMP);                0641
         ST    MAPPTR,SAT3DT1                                      0641
*       SAT3DT2=ADDR(SATCYLMP)+01*LENGTH(SATCYLMP);                0642
         LA    @03,4                                               0642
         ALR   @03,MAPPTR                                          0642
         ST    @03,SAT3DT2                                         0642
*       SAT3DT3=ADDR(SATCYLMP)+02*LENGTH(SATCYLMP);                0643
         LA    @03,8                                               0643
         ALR   @03,MAPPTR                                          0643
         ST    @03,SAT3DT3                                         0643
*       SAT3DT4=ADDR(SATCYLMP)+03*LENGTH(SATCYLMP);                0644
         LA    @03,12                                              0644
         ALR   @03,MAPPTR                                          0644
         ST    @03,SAT3DT4                                         0644
*       SAT3DT5=ADDR(SATCYLMP)+04*LENGTH(SATCYLMP);                0645
         LA    @03,16                                              0645
         ALR   @03,MAPPTR                                          0645
         ST    @03,SAT3DT5                                         0645
*       SAT3DT6=ADDR(SATCYLMP)+05*LENGTH(SATCYLMP);                0646
         LA    @03,20                                              0646
         ALR   @03,MAPPTR                                          0646
         ST    @03,SAT3DT6                                         0646
*       SAT3DT7=ADDR(SATCYLMP)+06*LENGTH(SATCYLMP);                0647
         LA    @03,24                                              0647
         ALR   @03,MAPPTR                                          0647
         ST    @03,SAT3DT7                                         0647
*       SAT3DT8=ADDR(SATCYLMP)+07*LENGTH(SATCYLMP);                0648
         LA    @03,28                                              0648
         ALR   @03,MAPPTR                                          0648
         ST    @03,SAT3DT8                                         0648
*       RFY                                                        0649
*        (R0,                                                      0649
*         R1) RSTD;                                                0649
*       R0=ADDR(SAT3PTS);           /* POINT TO FORMAT PATTERN       */
         LA    R0,SAT3PTS                                          0650
*       R1=ABDPLPTR;                /* GET PARM ADDR                 */
         L     @03,ABDPLPTR                                        0651
         LR    R1,@03                                              0651
*       CALL FORMAT;                /* FORMAT THE LINE               */
         L     @15,ADPLFRMT(,@03)                                  0652
         BALR  @14,@15                                             0652
*       RFY                                                        0653
*         R15 RSTD;                                                0653
*       FORMRC=FORMRC|R15;          /* SAVE RETURN CODE              */
         OR    FORMRC,R15                                          0654
*       RFY                                                        0655
*         R15 UNRSTD;                                              0655
*       CALL PRINT;                 /* CALL PRINT ROUTINE            */
         L     @03,ABDPLPTR                                        0656
         L     @15,ADPLPRNT(,@03)                                  0656
         BALR  @14,@15                                             0656
*       RFY                                                        0657
*        (R0,                                                      0657
*         R1) UNRSTD;                                              0657
*       RFY                                                        0658
*         R15 RSTD;                                                0658
*       R15=FORMRC;                 /* SAVE RETURN CODE FROM FORMAT  */
         LR    R15,FORMRC                                          0659
*       RFY                                                        0660
*         R15 UNRSTD;                                              0660
*     END;                          /* ILRMFRMT ARRAY(SAT3)          */
*     RFY                                                          0662
*       R15 RSTD;                                                  0662
*     SATRC=SATRC|R15;              /* SAVE THE RETURN CODE          */
         OR    SATRC,R15                                           0663
*     RFY                                                          0664
*       R15 UNRSTD;                                                0664
*     MAPPTR=MAPPTR+8*LENGTH(SATCYLMP);/* GET ADDR OF NEXT 8 WORDS   */
         AL    MAPPTR,@CF00136                                     0665
*   END;                                                           0666
*                                                                  0666
         AH    I,@CH00041                                          0666
@DE00638 C     I,CTR                                               0666
         BNH   @DL00638                                            0666
*   /*****************************************************************/
*   /*                                                               */
*   /* IF THERE ARE ANY MAP ENTRIES LEFT OVER THEY MUST BE FORMATTED */
*   /* AND THE PATTERNS MUST BE CHANGED SO A FULL LINE IS NOT        */
*   /* PRINTED.                                                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0667
*   IF REM^=0 THEN                  /* IS THERE A PARTIAL LINE TO  0667
*                                      FORMAT                        */
         LTR   REM,REM                                             0667
         BZ    @RF00667                                            0667
*     DO;                                                          0668
*       PPTRNPTR=ADDR(SAT3PTS);     /* GET THE ADDRESS OF THE PATTERN*/
         LA    PPTRNPTR,SAT3PTS                                    0669
*       RFY                                                        0670
*         PTTRNS BASED(PPTRNPTR);   /* MAP THE NAMES TO PATTERN      */
*       DO WHILE(REM>0);            /* LOOP UNTIL ENTIRE ARRAY     0671
*                                      COMPLETE                      */
         B     @DE00671                                            0671
@DL00671 DS    0H                                                  0672
*         PTTLBPTR=MAPPTR;          /* PUT ADDRESS OF DATA IN PATTERN*/
         ST    MAPPTR,PTTLBPTR(,PPTRNPTR)                          0672
*         PPTRNPTR=PPTRNPTR+LENGTH(PTTSTOP)+LENGTH(PTTDTPTR);/* NEXT */
         AH    PPTRNPTR,@CH00062                                   0673
*         MAPPTR=MAPPTR+LENGTH(SATCYLMP);/* NEXT * WORDS             */
         LA    @12,4                                               0674
         ALR   MAPPTR,@12                                          0674
*         REM=REM-4;                /* DECREMENT THE COUNT           */
         SLR   REM,@12                                             0675
*       END;                                                       0676
@DE00671 SLR   @12,@12                                             0676
         CR    REM,@12                                             0676
         BH    @DL00671                                            0676
*       SAVPTR=PTTSTOP;             /* SAVE THE NEXT PATTERN ENTRY   */
         L     SAVPTR,PTTSTOP(,PPTRNPTR)                           0677
*       PTTSTOP=ZERO;               /* ZERO PATTERN TO INDICATE END  */
         ST    @12,PTTSTOP(,PPTRNPTR)                              0678
*       RFY                                                        0679
*        (R0,                                                      0679
*         R1) RSTD;                                                0679
*       R0=ADDR(SAT3PTS);           /* GET THE ADDR OF THE PATTERN   */
         LA    R0,SAT3PTS                                          0680
*       R1=ABDPLPTR;                /* GET PARM LIST ADDR            */
         L     @12,ABDPLPTR                                        0681
         LR    R1,@12                                              0681
*       CALL FORMAT;                /* FORMAT THE LAST LINE OF     0682
*                                      SATMAPS                       */
         L     @15,ADPLFRMT(,@12)                                  0682
         BALR  @14,@15                                             0682
*       CALL PRINT;                 /* PRINT THE LINE                */
         L     @12,ABDPLPTR                                        0683
         L     @15,ADPLPRNT(,@12)                                  0683
         BALR  @14,@15                                             0683
*       PTTSTOP=SAVPTR;             /* RESTORE PATTERN TO ORIGINAL   */
         ST    SAVPTR,PTTSTOP(,PPTRNPTR)                           0684
*       RFY                                                        0685
*         PTTRNS;                                                  0685
*     END;                                                         0686
*   CALL PRINT;                     /* THROW IN A LINE BLANKS        */
@RF00667 L     @12,ABDPLPTR                                        0687
         L     @15,ADPLPRNT(,@12)                                  0687
         BALR  @14,@15                                             0687
*   RFY                                                            0688
*    (R0,                                                          0688
*     R1) UNRSTD;                                                  0688
*   RFY                                                            0689
*    (R14,                                                         0689
*     R15) RSTD;                                                   0689
*SATRTN:                                                           0690
*   R14=RTNADDR2;                   /* RESTORE RETURN ADDRESS        */
SATRTN   L     R14,RTNADDR2                                        0690
*   R15=SATRC;                      /* PUT THE RETURN CODE IN REG 15 */
         LR    R15,SATRC                                           0691
*   RFY                                                            0692
*    (R14,                                                         0692
*     R15) UNRSTD;                                                 0692
*   END FMTSAT;                     /* RETURN TO CALLER              */
@EL00005 DS    0H                                                  0693
@EF00005 DS    0H                                                  0693
@ER00005 BR    @14                                                 0693
*                                                                  0694
*/********************************************************************/
*/*                                                                  */
*/* FMTSCCW: SEGMENT TO FORMAT A QUEUE OF SCCW'S                     */
*/*                                                                  */
*/* INPUT:   VIRTUAL ADDRESS IN SCCWPTR                              */
*/*                                                                  */
*/* PROCESS: FORMAT THE SCCW QUEUE UNTIL THE NEXT SCCW POINTER       */
*/*           IS ZERO OR THE MAXIMUM IS EXCEEDED.  CALL SEGMENT      */
*/*           TO FORMAT AIA QUEUE POINTED IN SCCWAIA.                */
*/*                                                                  */
*/* OUTPUT:  CUMULATIVE RETURN FROM FORMATS, ACCESSES AND            */
*/*           SEGMENTS CALLED.                                       */
*/*                                                                  */
*/********************************************************************/
*                                                                  0694
*FMTSCCW:                                                          0694
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0694
FMTSCCW  DS    0H                                                  0695
*                                                                  0695
*   /*****************************************************************/
*   /*                                                               */
*   /* SCCW1:ILRMLINE (WID,WSECT,(WFLAG,,BIT),WSCCW,WAIA,WIORB)      */
*   /* OF(SCCW) LABEL VARIABLES REFERENCED IN FORMAT PATTERNS        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0695
*   DCL                                                            0695
*     SCCW1LB1 CHAR(LENGTH('WID')) INIT('WID');                    0695
*   DCL                                                            0696
*     SCCW1LB2 CHAR(LENGTH('WSECT')) INIT('WSECT');                0696
*   DCL                                                            0697
*     SCCW1LB3 CHAR(LENGTH('WFLAG')) INIT('WFLAG');                0697
*   DCL                                                            0698
*     SCCW1LB4 CHAR(LENGTH('WSCCW')) INIT('WSCCW');                0698
*   DCL                                                            0699
*     SCCW1LB5 CHAR(LENGTH('WAIA')) INIT('WAIA');                  0699
*   DCL                                                            0700
*     SCCW1LB6 CHAR(LENGTH('WIORB')) INIT('WIORB');                0700
*                                                                  0700
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT PATTERNS FOR ONE LINE OF OUTPUT                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0701
*   DCL                                                            0701
*     1 SCCW1PTS BDY(WORD),                                        0701
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SCCWID)-1+16*LENGTH('WID')-
*             16),                  /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(5),                                      0701
*       3 * FIXED(8) INIT(11),                                     0701
*       3 * PTR(31) INIT(ADDR(SCCW1LB1)),/* SEE PTTLBPTR             */
*       3 SCCW1DT1 PTR(31) INIT(0), /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SCCWSECT)-1+16*LENGTH('WSECT
*             )-16),                /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(15+8),                                   0701
*       3 * FIXED(8) INIT(21+8),                                   0701
*       3 * PTR(31) INIT(ADDR(SCCW1LB2)),/* SEE PTTLBPTR             */
*       3 SCCW1DT2 PTR(31) INIT(0), /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SCCWFLAG)/8-1+16*LENGTH(
*             'WFLAG')-16),         /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(25+8+8),                                 0701
*       3 * FIXED(8) INIT(31+8+8),                                 0701
*       3 * PTR(31) INIT(ADDR(SCCW1LB3)),/* SEE PTTLBPTR             */
*       3 SCCW1DT3 PTR(31) INIT(0), /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SCCWSCCW)-1+16*LENGTH('WSCCW
*             )-16),                /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(35+8+8+8),                               0701
*       3 * FIXED(8) INIT(41+8+8+8),                               0701
*       3 * PTR(31) INIT(ADDR(SCCW1LB4)),/* SEE PTTLBPTR             */
*       3 SCCW1DT4 PTR(31) INIT(0), /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SCCWAIA)-1+16*LENGTH('WAIA')
*             -16),                 /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(45+8+8+8+8),                             0701
*       3 * FIXED(8) INIT(51+8+8+8+8),                             0701
*       3 * PTR(31) INIT(ADDR(SCCW1LB5)),/* SEE PTTLBPTR             */
*       3 SCCW1DT5 PTR(31) INIT(0), /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(SCCWIORB)-1+16*LENGTH('WIORB
*             )-16),                /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(55+8+8+8+8+8),                           0701
*       3 * FIXED(8) INIT(61+8+8+8+8+8),                           0701
*       3 * PTR(31) INIT(ADDR(SCCW1LB6)),/* SEE PTTLBPTR             */
*       3 SCCW1DT6 PTR(31) INIT(0), /* SEE PTTDTPTR                  */
*      2 * FIXED(31) INIT(0);       /* END OF FORMAT PATTERNS        */
*                                                                  0701
*   /*****************************************************************/
*   /*                                                               */
*   /* SCCW3: (SARG) LABEL VARIABLES REFERENCED IN FMT PTTRNS        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0702
*   DCL                                                            0702
*     SCCW3LB1 CHAR(LENGTH('SARG')) INIT('SARG');                  0702
*                                                                  0702
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT PATTERNS FOR ONE LINE OF OUTPUT (HAND CODED)           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0703
*   DCL                                                            0703
*     1 SCCW3PTS BDY(WORD),         /* FORMAT PATTERNS - SEE PTTRNS  */
*      2 * CHAR(12) BDY(WORD),                                     0703
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),                    0703
*       3 * FIXED(8) INIT(3-1+16*LENGTH('SARG')-16),               0703
*       3 * FIXED(8) INIT(5),                                      0703
*       3 * FIXED(8) INIT(11),                                     0703
*       3 * PTR(31) INIT(ADDR(SCCW3LB1)),                          0703
*       3 SCCW3DT1 PTR(31) INIT(0),                                0703
*      2 * CHAR(4) BDY(WORD),                                      0703
*       3 * BIT(8) BDY(BYTE) INIT('00000100'B),                    0703
*       3 * FIXED(8) INIT('04'X),                                  0703
*       3 * FIXED(8) INIT(0),                                      0703
*       3 * FIXED(8) INIT(22),                                     0703
*      2 * CHAR(4) BDY(WORD),                                      0703
*       3 * BIT(8) BDY(BYTE) INIT('00000100'B),                    0703
*       3 * FIXED(8) INIT('04'X),                                  0703
*       3 * FIXED(8) INIT(0),                                      0703
*       3 * FIXED(8) INIT(36),                                     0703
*      2 * CHAR(4) BDY(WORD),                                      0703
*       3 * BIT(8) BDY(BYTE) INIT('00000100'B),                    0703
*       3 * FIXED(8) INIT('04'X),                                  0703
*       3 * FIXED(8) INIT(0),                                      0703
*       3 * FIXED(8) INIT(50),                                     0703
*      2 * CHAR(4) BDY(WORD),                                      0703
*       3 * BIT(8) BDY(BYTE) INIT('00000100'B),                    0703
*       3 * FIXED(8) INIT('04'X),                                  0703
*       3 * FIXED(8) INIT(0),                                      0703
*       3 * FIXED(8) INIT(64),                                     0703
*      2 * CHAR(4) BDY(WORD),                                      0703
*       3 * BIT(8) BDY(BYTE) INIT('00000100'B),                    0703
*       3 * FIXED(8) INIT('04'X),                                  0703
*       3 * FIXED(8) INIT(0),                                      0703
*       3 * FIXED(8) INIT(78),                                     0703
*      2 * CHAR(4) BDY(WORD),                                      0703
*       3 * BIT(8) BDY(BYTE) INIT('00000100'B),                    0703
*       3 * FIXED(8) INIT('04'X),                                  0703
*       3 * FIXED(8) INIT(0),                                      0703
*       3 * FIXED(8) INIT(92),                                     0703
*      2 * FIXED(31) INIT(0);                                      0703
*                                                                  0704
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT PATTERNS FOR ONE LINE OF OUTPUT (HAND CODED)           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0704
*   DCL                                                            0704
*     1 SCCW4PTS BDY(WORD),         /* FORMAT PATTERNS - SEE PTTRNS  */
*      2 * CHAR(4) BDY(WORD),                                      0704
*       3 * BIT(8) BDY(BYTE) INIT('00000100'B),                    0704
*       3 * FIXED(8) INIT('04'X),                                  0704
*       3 * FIXED(8) INIT(0),                                      0704
*       3 * FIXED(8) INIT(22),                                     0704
*      2 * CHAR(4) BDY(WORD),                                      0704
*       3 * BIT(8) BDY(BYTE) INIT('00000100'B),                    0704
*       3 * FIXED(8) INIT('04'X),                                  0704
*       3 * FIXED(8) INIT(0),                                      0704
*       3 * FIXED(8) INIT(36),                                     0704
*      2 * CHAR(4) BDY(WORD),                                      0704
*       3 * BIT(8) BDY(BYTE) INIT('00000100'B),                    0704
*       3 * FIXED(8) INIT('04'X),                                  0704
*       3 * FIXED(8) INIT(0),                                      0704
*       3 * FIXED(8) INIT(50),                                     0704
*      2 * CHAR(4) BDY(WORD),                                      0704
*       3 * BIT(8) BDY(BYTE) INIT('00000100'B),                    0704
*       3 * FIXED(8) INIT('04'X),                                  0704
*       3 * FIXED(8) INIT(0),                                      0704
*       3 * FIXED(8) INIT(64),                                     0704
*      2 * CHAR(4) BDY(WORD),                                      0704
*       3 * BIT(8) BDY(BYTE) INIT('00000100'B),                    0704
*       3 * FIXED(8) INIT('04'X),                                  0704
*       3 * FIXED(8) INIT(0),                                      0704
*       3 * FIXED(8) INIT(78),                                     0704
*      2 * CHAR(4) BDY(WORD),                                      0704
*       3 * BIT(8) BDY(BYTE) INIT('00000100'B),                    0704
*       3 * FIXED(8) INIT('04'X),                                  0704
*       3 * FIXED(8) INIT(0),                                      0704
*       3 * FIXED(8) INIT(92),                                     0704
*      2 * CHAR(4) BDY(WORD),                                      0704
*       3 * BIT(8) BDY(BYTE) INIT('00000100'B),                    0704
*       3 * FIXED(8) INIT('00'X),                                  0704
*       3 * FIXED(8) INIT(0),                                      0704
*       3 * FIXED(8) INIT(106),                                    0704
*      2 * FIXED(31) INIT(0);                                      0704
*                                                                  0705
*   /*****************************************************************/
*   /*                                                               */
*   /* SCCW5: (LCCW),(RSV2,NOLABEL),SEEK,SSEC) LABEL VARIABLES       */
*   /* REFERENCED IN FMT PTTRNS                                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0705
*   DCL                                                            0705
*     SCCW5LB1 CHAR(LENGTH('LCCW')) INIT('LCCW');                  0705
*   DCL                                                            0706
*     SCCW5LB3 CHAR(LENGTH('SEEK')) INIT('SEEK');                  0706
*   DCL                                                            0707
*     SCCW5LB4 CHAR(LENGTH('SSEC')) INIT('SSEC');                  0707
*                                                                  0708
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT PATTERNS FOR ONE LINE OF OUTPUT (HAND CODED)           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0708
*   DCL                                                            0708
*     1 SCCW5PTS BDY(WORD),                                        0708
*      2 * CHAR(12) BDY(WORD),                                     0708
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),                    0708
*       3 * FIXED(8) INIT(LENGTH(SCCWLCCW)-1+16*LENGTH('LCCW')-16),
*       3 * FIXED(8) INIT(5),                                      0708
*       3 * FIXED(8) INIT(11),                                     0708
*       3 * PTR(31) INIT(ADDR(SCCW5LB1)),                          0708
*       3 SCCW5DT1 PTR(31) INIT(0),                                0708
*      2 * CHAR(12) BDY(WORD),                                     0708
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),                    0708
*       3 * FIXED(8) INIT(LENGTH(SCCWSEEK)-1+16*LENGTH('SEEK')-16),
*       3 * FIXED(8) INIT(31),                                     0708
*       3 * FIXED(8) INIT(37),                                     0708
*       3 * PTR(31) INIT(ADDR(SCCW5LB3)),                          0708
*       3 SCCW5DT3 PTR(31) INIT(0),                                0708
*      2 * CHAR(12) BDY(WORD),                                     0708
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),                    0708
*       3 * FIXED(8) INIT(LENGTH(SCCWSSEC)-1+16*LENGTH('SSEC')-16),
*       3 * FIXED(8) INIT(57),                                     0708
*       3 * FIXED(8) INIT(63),                                     0708
*       3 * PTR(31) INIT(ADDR(SCCW5LB4)),                          0708
*       3 SCCW5DT4 PTR(31) INIT(0),                                0708
*      2 * FIXED(31) INIT(0);                                      0708
*                                                                  0709
*   /*****************************************************************/
*   /*                                                               */
*   /* SCCW6: (SRCH,TIC,RW) LABEL VARIABLES REF'D IN FMT PTTRNS      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0709
*   DCL                                                            0709
*     SCCW6LB1 CHAR(LENGTH('SRCH')) INIT('SRCH');                  0709
*   DCL                                                            0710
*     SCCW6LB2 CHAR(LENGTH('TIC')) INIT('TIC');                    0710
*   DCL                                                            0711
*     SCCW6LB3 CHAR(LENGTH('R/W')) INIT('R/W');                    0711
*                                                                  0712
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT PATTERNS FOR ONE LINE OF OUTPUT (HAND CODED)           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0712
*   DCL                                                            0712
*     1 SCCW6PTS BDY(WORD),                                        0712
*      2 * CHAR(12) BDY(WORD),                                     0712
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),                    0712
*       3 * FIXED(8) INIT(LENGTH(SCCWSRCH)-1+16*LENGTH('SRCH')-16),
*       3 * FIXED(8) INIT(5),                                      0712
*       3 * FIXED(8) INIT(11),                                     0712
*       3 * PTR(31) INIT(ADDR(SCCW6LB1)),                          0712
*       3 SCCW6DT1 PTR(31) INIT(0),                                0712
*      2 * CHAR(8) BDY(WORD),                                      0712
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    0712
*       3 * FIXED(8) INIT(LENGTH(SCCWTIC)-1+16*LENGTH('TIC')-16),  0712
*       3 * FIXED(8) INIT(31),                                     0712
*       3 * FIXED(8) INIT(37),                                     0712
*       3 * PTR(31) INIT(ADDR(SCCW6LB2)),                          0712
*      2 * CHAR(8) BDY(WORD),                                      0712
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    0712
*       3 * FIXED(8) INIT(LENGTH(SCCWRW)-1+16*LENGTH('R/W')-16),   0712
*       3 * FIXED(8) INIT(57),                                     0712
*       3 * FIXED(8) INIT(63),                                     0712
*       3 * PTR(31) INIT(ADDR(SCCW6LB3)),                          0712
*      2 * FIXED(31) INIT(0);                                      0712
*                                                                  0713
*   /*****************************************************************/
*   /*                                                               */
*   /* SCCWI: (LTIC) LABEL VARIABLES REF'D IN FMT PTTRNS             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0713
*   DCL                                                            0713
*     SCCWILB1 CHAR(LENGTH('LTIC')) INIT('LTIC');                  0713
*                                                                  0714
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT PATTERNS FOR ONE LINE OF OUTPUT (HAND CODED)           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0714
*   DCL                                                            0714
*     1 SCCWIPTS BDY(WORD),                                        0714
*      2 * CHAR(8) BDY(WORD),                                      0714
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    0714
*       3 * FIXED(8) INIT(LENGTH(SCCWLTIC)-1+16*LENGTH('LTIC')-16),
*       3 * FIXED(8) INIT(5),                                      0714
*       3 * FIXED(8) INIT(11),                                     0714
*       3 * PTR(31) INIT(ADDR(SCCWILB1)),                          0714
*      2 * FIXED(31) INIT(0);                                      0714
*   RFY                                                            0715
*     R14 RSTD;                                                    0715
*   RTNADDR3=R14;                   /* SAVE RETURN ADDRESS           */
         LR    RTNADDR3,R14                                        0716
*   RFY                                                            0717
*     R14 UNRSTD;                                                  0717
*   SCCWRC=0;                       /* ZERO THE RETURN CODE          */
         SLR   SCCWRC,SCCWRC                                       0718
*   MAXCTR=0;                       /* INITIALIZE MAXIMUM COUNTER    */
         SLR   @12,@12                                             0719
         ST    @12,MAXCTR                                          0719
*   DO WHILE(SCCWPTR^=NULLPTR&      /* UNTIL ACCESS FAILS, Q ENDED   */
*         MAXCTR<MAXSCCWS);         /* OR MAX EXCEEDED               */
         B     @DE00720                                            0720
@DL00720 DS    0H                                                  0721
*     MAXCTR=MAXCTR+1;              /* INCREMENT THE LOOP COUNT      */
         LA    @12,1                                               0721
         AL    @12,MAXCTR                                          0721
         ST    @12,MAXCTR                                          0721
*     RFY                                                          0722
*      (R0,                                                        0722
*       R1) RSTD;                                                  0722
*     R0=ADDR(SCCWPTR);             /* GET THE ADDRESS OF THE CONTROL
*                                      BLOCK                         */
         LA    R0,SCCWPTR                                          0723
*     R1=ADDR(SCCWNAM);             /* GET THE NAME OF THE CONTROL 0724
*                                      BLOCK                         */
         LA    R1,SCCWNAM                                          0724
*     CALL ILRFPRTH;                /* PRINT THE HEADING             */
         L     @15,@CV00676                                        0725
         BALR  @14,@15                                             0725
*     RFY                                                          0726
*      (R0,                                                        0726
*       R1) UNRSTD;                                                0726
*                                                                  0726
*     /***************************************************************/
*     /*                                                             */
*     /* FORMAT THE FIRST LINE OF THE SCCW. THE REST OF THE LINES ARE*/
*     /* FORMATTED WITH HARDCODED LINES TO FORMAT ROUTINE.           */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0727
*     DO;                           /* ILRMFRMT (SCCW)             0727
*                                      LINES(SCCW1)OF(SCCW)          */
*       FORMRC=0;                   /* ZERO THE RETURN CODE          */
         SLR   FORMRC,FORMRC                                       0728
*       SCCW1DT1=ADDR(SCCWID);                                     0729
         L     @12,SCCWPTR                                         0729
         ST    @12,SCCW1DT1                                        0729
*       SCCW1DT2=ADDR(SCCWSECT);                                   0730
         LA    @03,SCCWSECT(,@12)                                  0730
         ST    @03,SCCW1DT2                                        0730
*       SCCW1DT3=ADDR(SCCWFLAG);                                   0731
         LA    @03,SCCWFLAG(,@12)                                  0731
         ST    @03,SCCW1DT3                                        0731
*       SCCW1DT4=ADDR(SCCWSCCW);                                   0732
         LA    @03,SCCWSCCW(,@12)                                  0732
         ST    @03,SCCW1DT4                                        0732
*       SCCW1DT5=ADDR(SCCWAIA);                                    0733
         LA    @03,SCCWAIA(,@12)                                   0733
         ST    @03,SCCW1DT5                                        0733
*       SCCW1DT6=ADDR(SCCWIORB);                                   0734
         LA    @12,SCCWIORB(,@12)                                  0734
         ST    @12,SCCW1DT6                                        0734
*       RFY                                                        0735
*        (R0,                                                      0735
*         R1) RSTD;                                                0735
*       R0=ADDR(SCCW1PTS);                                         0736
         LA    R0,SCCW1PTS                                         0736
*       R1=ABDPLPTR;                /* GET PARM ADDR                 */
         L     @12,ABDPLPTR                                        0737
         LR    R1,@12                                              0737
*       CALL FORMAT;                /* FORMAT THE LINE               */
         L     @15,ADPLFRMT(,@12)                                  0738
         BALR  @14,@15                                             0738
*       RFY                                                        0739
*         R15 RSTD;                                                0739
*       FORMRC=FORMRC|R15;          /* SAVE RETURN CODE              */
         OR    FORMRC,R15                                          0740
*       RFY                                                        0741
*         R15 UNRSTD;                                              0741
*       CALL PRINT;                 /* CALL PRINT ROUTINE            */
         L     @12,ABDPLPTR                                        0742
         L     @15,ADPLPRNT(,@12)                                  0742
         BALR  @14,@15                                             0742
*       RFY                                                        0743
*        (R0,                                                      0743
*         R1) UNRSTD;                                              0743
*       RFY                                                        0744
*         R15 RSTD;                                                0744
*       R15=FORMRC;                 /* SAVE RETURN CODE FROM FORMAT  */
         LR    R15,FORMRC                                          0745
*       RFY                                                        0746
*         R15 UNRSTD;                                              0746
*     END;                          /* ILRMFRMT (SCCW)             0747
*                                      LINES(SCCW1)OF(SCCW)          */
*     RFY                                                          0748
*       R15 RSTD;                                                  0748
*     SCCWRC=SCCWRC|R15;            /* SAVE THE RETURN CODE          */
         OR    SCCWRC,R15                                          0749
*     RFY                                                          0750
*       R15 UNRSTD;                                                0750
*                                                                  0750
*     /***************************************************************/
*     /*                                                             */
*     /* SET UP THE ADDRESS OF THE PATTERN AND PARAMETER LIST AND AND*/
*     /* CALL THE FORMAT ROUTINE.                                    */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0751
*     SCCW3DT1=ADDR(SCCWM);                                        0751
         L     @12,SCCWPTR                                         0751
         LA    @12,SCCWM(,@12)                                     0751
         ST    @12,SCCW3DT1                                        0751
*     RFY                                                          0752
*      (R0,                                                        0752
*       R1) RSTD;                                                  0752
*     R0=ADDR(SCCW3PTS);                                           0753
         LA    R0,SCCW3PTS                                         0753
*     R1=ABDPLPTR;                                                 0754
         L     @12,ABDPLPTR                                        0754
         LR    R1,@12                                              0754
*     CALL FORMAT;                                                 0755
         L     @15,ADPLFRMT(,@12)                                  0755
         BALR  @14,@15                                             0755
*     RFY                                                          0756
*       R15 RSTD;                                                  0756
*     SCCWRC=SCCWRC|R15;            /* SAVE THE RETURN CODE          */
         OR    SCCWRC,R15                                          0757
*     RFY                                                          0758
*       R15 UNRSTD;                                                0758
*     CALL PRINT;                                                  0759
         L     @12,ABDPLPTR                                        0759
         L     @15,ADPLPRNT(,@12)                                  0759
         BALR  @14,@15                                             0759
*     RFY                                                          0760
*      (R0,                                                        0760
*       R1) UNRSTD;                                                0760
*                                                                  0760
*     /***************************************************************/
*     /*                                                             */
*     /* SETUP THE POINTERS TO THE DATA AND FORMAT IT                */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0761
*     RFY                                                          0761
*      (R0,                                                        0761
*       R1) RSTD;                                                  0761
*     R0=ADDR(SCCW4PTS);                                           0762
         LA    R0,SCCW4PTS                                         0762
*     R1=ABDPLPTR;                                                 0763
         L     @12,ABDPLPTR                                        0763
         LR    R1,@12                                              0763
*     CALL FORMAT;                                                 0764
         L     @15,ADPLFRMT(,@12)                                  0764
         BALR  @14,@15                                             0764
*     RFY                                                          0765
*       R15 RSTD;                                                  0765
*     SCCWRC=SCCWRC|R15;            /* SAVE THE RETURN CODE          */
         OR    SCCWRC,R15                                          0766
*     RFY                                                          0767
*       R15 UNRSTD;                                                0767
*     CALL PRINT;                                                  0768
         L     @12,ABDPLPTR                                        0768
         L     @15,ADPLPRNT(,@12)                                  0768
         BALR  @14,@15                                             0768
*     RFY                                                          0769
*      (R0,                                                        0769
*       R1) UNRSTD;                                                0769
*                                                                  0769
*     /***************************************************************/
*     /*                                                             */
*     /* SETUP THE POINTERS TO THE DATA AND FORMAT IT                */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0770
*     SCCW5DT1=ADDR(SCCWLCCW);                                     0770
         L     @12,SCCWPTR                                         0770
         LA    @15,SCCWLCCW(,@12)                                  0770
         ST    @15,SCCW5DT1                                        0770
*     SCCW5DT3=ADDR(SCCWSEEK);                                     0771
         LA    @15,SCCWSEEK(,@12)                                  0771
         ST    @15,SCCW5DT3                                        0771
*     SCCW5DT4=ADDR(SCCWSSEC);                                     0772
         LA    @12,SCCWSSEC(,@12)                                  0772
         ST    @12,SCCW5DT4                                        0772
*     RFY                                                          0773
*      (R0,                                                        0773
*       R1) RSTD;                                                  0773
*     R0=ADDR(SCCW5PTS);                                           0774
         LA    R0,SCCW5PTS                                         0774
*     R1=ABDPLPTR;                                                 0775
         L     @12,ABDPLPTR                                        0775
         LR    R1,@12                                              0775
*     CALL FORMAT;                                                 0776
         L     @15,ADPLFRMT(,@12)                                  0776
         BALR  @14,@15                                             0776
*     RFY                                                          0777
*       R15 RSTD;                                                  0777
*     SCCWRC=SCCWRC|R15;            /* SAVE THE RETURN CODE          */
         OR    SCCWRC,R15                                          0778
*     RFY                                                          0779
*       R15 UNRSTD;                                                0779
*     CALL PRINT;                                                  0780
         L     @12,ABDPLPTR                                        0780
         L     @15,ADPLPRNT(,@12)                                  0780
         BALR  @14,@15                                             0780
*     RFY                                                          0781
*      (R0,                                                        0781
*       R1) UNRSTD;                                                0781
*                                                                  0782
*     /***************************************************************/
*     /*                                                             */
*     /* SET UP THE POINTERS TO FORMAT THE SCCWSLOT FIELD AND LOOP TO*/
*     /* PRINT THE ENTIRE ARRAY.                                     */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0782
*     RFY                                                          0782
*      (R0,                                                        0782
*       R1) RSTD;                                                  0782
*     R0=ADDR(SCCW6PTS);                                           0783
         LA    R0,SCCW6PTS                                         0783
*     R1=ABDPLPTR;                                                 0784
         L     R1,ABDPLPTR                                         0784
*                                                                  0785
*     /***************************************************************/
*     /*                                                             */
*     /* LOOP TO PRINT THE SWAP CHANNEL COMMAND AREA                 */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0785
*     DO I=1 TO 12;                                                0785
         LA    I,1                                                 0785
@DL00785 DS    0H                                                  0786
*       SCCW6DT1=ADDR(SCCWSLOT(I));                                0786
         LR    @15,I                                               0786
         MH    @15,@CH00154                                        0786
         L     @14,SCCWPTR                                         0786
         LA    @15,SCCWSLOT-24(@15,@14)                            0786
         ST    @15,SCCW6DT1                                        0786
*       CALL FORMAT;                                               0787
         L     @14,ABDPLPTR                                        0787
         L     @15,ADPLFRMT(,@14)                                  0787
         BALR  @14,@15                                             0787
*       RFY                                                        0788
*         R15 RSTD;                                                0788
*       SCCWRC=SCCWRC|R15;          /* SAVE THE RETURN CODE          */
         OR    SCCWRC,R15                                          0789
*       RFY                                                        0790
*         R15 UNRSTD;                                              0790
*       CALL PRINT;                                                0791
         L     @14,ABDPLPTR                                        0791
         L     @15,ADPLPRNT(,@14)                                  0791
         BALR  @14,@15                                             0791
*     END;                                                         0792
         AH    I,@CH00041                                          0792
         CH    I,@CH00591                                          0792
         BNH   @DL00785                                            0792
*     RFY                                                          0793
*      (R0,                                                        0793
*       R1) UNRSTD;                                                0793
*                                                                  0794
*     /***************************************************************/
*     /*                                                             */
*     /* SETUP THE POINTERS TO FORMAT THE LTIC FIELD OF THE SCCW     */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0794
*     RFY                                                          0794
*      (R0,                                                        0794
*       R1) RSTD;                                                  0794
*     R0=ADDR(SCCWIPTS);                                           0795
         LA    R0,SCCWIPTS                                         0795
*     R1=ABDPLPTR;                                                 0796
         L     @12,ABDPLPTR                                        0796
         LR    R1,@12                                              0796
*     CALL FORMAT;                                                 0797
         L     @15,ADPLFRMT(,@12)                                  0797
         BALR  @14,@15                                             0797
*     RFY                                                          0798
*       R15 RSTD;                                                  0798
*     SCCWRC=SCCWRC|R15;            /* SAVE THE RETURN CODE          */
         OR    SCCWRC,R15                                          0799
*     RFY                                                          0800
*       R15 UNRSTD;                                                0800
*     CALL PRINT;                                                  0801
         L     @12,ABDPLPTR                                        0801
         L     @15,ADPLPRNT(,@12)                                  0801
         BALR  @14,@15                                             0801
*     CALL PRINT;                                                  0802
         L     @12,ABDPLPTR                                        0802
         L     @15,ADPLPRNT(,@12)                                  0802
         BALR  @14,@15                                             0802
*     RFY                                                          0803
*      (R0,                                                        0803
*       R1) UNRSTD;                                                0803
*                                                                  0804
*     /***************************************************************/
*     /*                                                             */
*     /* GET THE ADDRESS OF ANY POSSIBLE AIA'S FROM THE SCCW. IF     */
*     /* THERE ARE ANY SET UP THE ANCHOR AND CALL ILRFAIA.           */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0804
*     DO;                           /* ILRMACCS (AIAPTR)           0804
*                                      FROM(SCCWAIA)                 */
*       RFY                                                        0805
*        (R0,                                                      0805
*         R1,                                                      0805
*         R14,                                                     0805
*         R15) RSTD;                                               0805
*       R0=ADDR(SCCWAIA);                                          0806
         L     @12,SCCWPTR                                         0806
         LA    R0,SCCWAIA(,@12)                                    0806
*       R1=ABDPLPTR;                /* POINT TO PARM LIST            */
         L     @12,ABDPLPTR                                        0807
         LR    R1,@12                                              0807
*       CALL ACCESS;                /* ACCESS DATA                   */
         L     @15,ADPLMEMA(,@12)                                  0808
         BALR  @14,@15                                             0808
*       R14=R0;                     /* CANNOT USE R0 AS BASE         */
         LR    R14,R0                                              0809
*       IF R15=GOOD THEN            /* CHECK ACCESS                  */
         LTR   R15,R15                                             0810
         BNZ   @RF00810                                            0810
*         AIAPTR=CURRENT;           /* GET REQUESTED FIELD           */
         L     AIAPTR,CURRENT(,R14)                                0811
*       ELSE                        /* ACCESS NO GOOD                */
*         AIAPTR=ZERO;              /* ZERO FIELD                    */
         B     @RC00810                                            0812
@RF00810 SLR   AIAPTR,AIAPTR                                       0812
*       RFY                                                        0813
*        (R0,                                                      0813
*         R1,                                                      0813
*         R14,                                                     0813
*         R15) UNRSTD;                                             0813
@RC00810 DS    0H                                                  0814
*     END;                                                         0814
*     IF AIAPTR^=NULLPTR THEN       /* THE Q HAS ELEMENTS            */
         LTR   AIAPTR,AIAPTR                                       0815
         BZ    @RF00815                                            0815
*       DO;                                                        0816
*         ANCHTXT=ANCH;             /* PUT IN LABEL                  */
         L     @01,ABDPLPTR                                        0817
         L     @15,ADPLBUF(,@01)                                   0817
         MVC   ANCHTXT(11,@15),ANCH                                0817
*         ANCHNAME=ANCHAIA5;        /* PUT IN ANCHOR LOCATION        */
         MVC   ANCHNAME(8,@15),ANCHAIA5                            0818
*         RFY                                                      0819
*          (R0,                                                    0819
*           R1,                                                    0819
*           R2) RSTD;                                              0819
*         R0=AIAPTR;                /* GET THE ADDRESS OF THE FIRST
*                                      AIA                           */
         LR    R0,AIAPTR                                           0820
*         R1=ADDR(AIANAM);          /* GET THE ADDRESS OF THE NAME   */
         LA    R1,AIANAM                                           0821
*         R2=3;                     /* SET CODE TO CHAIN BOTH QUEUES */
         LA    R2,3                                                0822
*         CALL ILRFAIA;             /* CALL SEGMENT TO FMT AIA Q     */
         L     @15,@CV00675                                        0823
         BALR  @14,@15                                             0823
*       END;                                                       0824
*     RFY                                                          0825
*       R15 RSTD;                                                  0825
@RF00815 DS    0H                                                  0826
*     SCCWRC=SCCWRC|R15;            /* SAVE THE RETURN CODE          */
         OR    SCCWRC,R15                                          0826
*     RFY                                                          0827
*      (R0,                                                        0827
*       R1,                                                        0827
*       R2,                                                        0827
*       R15) UNRSTD;                                               0827
*                                                                  0827
*     /***************************************************************/
*     /*                                                             */
*     /* TRY TO GET THE NEXT SCCW ADDRESS IN THE CHAIN TO FORMAT IT. */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0828
*     DO;                           /* ILRMACCS (SCCWPTR)          0828
*                                      FROM(SCCWSCCW)                */
*       RFY                                                        0829
*        (R0,                                                      0829
*         R1,                                                      0829
*         R14,                                                     0829
*         R15) RSTD;                                               0829
*       R0=ADDR(SCCWSCCW);                                         0830
         L     @12,SCCWPTR                                         0830
         LA    R0,SCCWSCCW(,@12)                                   0830
*       R1=ABDPLPTR;                /* POINT TO PARM LIST            */
         L     @12,ABDPLPTR                                        0831
         LR    R1,@12                                              0831
*       CALL ACCESS;                /* ACCESS DATA                   */
         L     @15,ADPLMEMA(,@12)                                  0832
         BALR  @14,@15                                             0832
*       R14=R0;                     /* CANNOT USE R0 AS BASE         */
         LR    R14,R0                                              0833
*       IF R15=GOOD THEN            /* CHECK ACCESS                  */
         LTR   R15,R15                                             0834
         BNZ   @RF00834                                            0834
*         SCCWPTR=CURRENT;          /* GET REQUESTED FIELD           */
         MVC   SCCWPTR(4),CURRENT(R14)                             0835
*       ELSE                        /* ACCESS NO GOOD                */
*         SCCWPTR=ZERO;             /* ZERO FIELD                    */
         B     @RC00834                                            0836
@RF00834 SLR   @12,@12                                             0836
         ST    @12,SCCWPTR                                         0836
*       RFY                                                        0837
*        (R0,                                                      0837
*         R1,                                                      0837
*         R14,                                                     0837
*         R15) UNRSTD;                                             0837
@RC00834 DS    0H                                                  0838
*     END;                                                         0838
*     RFY                                                          0839
*       R15 RSTD;                                                  0839
*     SCCWRC=SCCWRC|R15;            /* SAVE THE RETURN CODE          */
         OR    SCCWRC,R15                                          0840
*     RFY                                                          0841
*       R15 UNRSTD;                                                0841
*   END;                            /* END SCCW PROCESSING           */
@DE00720 ICM   @12,15,SCCWPTR                                      0842
         BZ    @DC00720                                            0842
         L     @12,MAXCTR                                          0842
         C     @12,MAXSCCWS                                        0842
         BL    @DL00720                                            0842
@DC00720 DS    0H                                                  0843
*   IF SCCWPTR^=NULLPTR THEN        /* WAS THE MAX EXCEEDED          */
         ICM   @12,15,SCCWPTR                                      0843
         BZ    @RF00843                                            0843
*     DO;                                                          0844
*       SCCWRC=4;                   /* SET THE RETURN CODE           */
         LA    SCCWRC,4                                            0845
*       RFY                                                        0846
*         R1 RSTD;                                                 0846
*       R1=15;                      /* CODE OF MESSAGE               */
         LA    R1,15                                               0847
*       RFY                                                        0848
*         R1 UNRSTD;                                               0848
*       CALL ILRFMSG;               /* GO TO MESSAGE SEGMENT         */
         L     @15,@CV00674                                        0849
         BALR  @14,@15                                             0849
*     END;                                                         0850
*   RFY                                                            0851
*    (R14,                                                         0851
*     R15) RSTD;                                                   0851
@RF00843 DS    0H                                                  0852
*   R15=SCCWRC;                     /* PUT THE RETURN CODE IN REG 15 */
         LR    R15,SCCWRC                                          0852
*   R14=RTNADDR3;                   /* RESTORE RETURN ADDRESS        */
         LR    R14,RTNADDR3                                        0853
*   RFY                                                            0854
*    (R14,                                                         0854
*     R15) UNRSTD;                                                 0854
*   END FMTSCCW;                    /* RETURN TO CALLER              */
@EL00006 DS    0H                                                  0855
@EF00006 DS    0H                                                  0855
@ER00006 BR    @14                                                 0855
*                                                                  0856
*/********************************************************************/
*/*                                                                  */
*/* FMTPCCW: SEGMENT TO FORMAT A QUEUE OF PCCWS                      */
*/*                                                                  */
*/* INPUT:   FIRTUAL ADDRESS IN PCCWPTR                              */
*/*                                                                  */
*/* PROCESS: FORMAT THE PCCW QUEUE UNTIL THE NEXT PCCW POINTER IS    */
*/*           ZERO OR THE MAXIMUM IS EXCEEDED.  CALLS SEGMENT TO     */
*/*           FORMAT AIA QUEUE POINTED IN PCCWAIA.                   */
*/*                                                                  */
*/* OUTPUT:  CUMULATIVE RETURN CODE FROM FORMATS, ACCESSES AND       */
*/*           SEGMENTS CALLED                                        */
*/*                                                                  */
*/********************************************************************/
*                                                                  0856
*FMTPCCW:                                                          0856
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0856
FMTPCCW  DS    0H                                                  0857
*                                                                  0857
*   /*****************************************************************/
*   /*                                                               */
*   /* PCCW1:ILRMLINE (WID,WSECT,WFLGS,WPCCW,WAIA) OF(PCCW) LABEL    */
*   /* VARIABLES REFERENCED IN FORMAT PATTERNS                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0857
*   DCL                                                            0857
*     PCCW1LB1 CHAR(LENGTH('WID')) INIT('WID');                    0857
*   DCL                                                            0858
*     PCCW1LB2 CHAR(LENGTH('WSECT')) INIT('WSECT');                0858
*   DCL                                                            0859
*     PCCW1LB3 CHAR(LENGTH('WFLGS')) INIT('WFLGS');                0859
*   DCL                                                            0860
*     PCCW1LB4 CHAR(LENGTH('WPCCW')) INIT('WPCCW');                0860
*   DCL                                                            0861
*     PCCW1LB5 CHAR(LENGTH('WAIA')) INIT('WAIA');                  0861
*                                                                  0861
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT PATTERNS FOR ONE LINE OF OUTPUT                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0862
*   DCL                                                            0862
*     1 PCCW1PTS BDY(WORD),                                        0862
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(PCCWID)-1+16*LENGTH('WID')-
*             16),                  /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(5),                                      0862
*       3 * FIXED(8) INIT(11),                                     0862
*       3 * PTR(31) INIT(ADDR(PCCW1LB1)),/* SEE PTTLBPTR             */
*       3 PCCW1DT1 PTR(31) INIT(0), /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(PCCWSECT)-1+16*LENGTH('WSECT
*             )-16),                /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(15+8),                                   0862
*       3 * FIXED(8) INIT(21+8),                                   0862
*       3 * PTR(31) INIT(ADDR(PCCW1LB2)),/* SEE PTTLBPTR             */
*       3 PCCW1DT2 PTR(31) INIT(0), /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(PCCWFLGS)-1+16*LENGTH('WFLGS
*             )-16),                /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(25+8+8),                                 0862
*       3 * FIXED(8) INIT(31+8+8),                                 0862
*       3 * PTR(31) INIT(ADDR(PCCW1LB3)),/* SEE PTTLBPTR             */
*       3 PCCW1DT3 PTR(31) INIT(0), /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(PCCWPCCW)-1+16*LENGTH('WPCCW
*             )-16),                /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(35+8+8+8),                               0862
*       3 * FIXED(8) INIT(41+8+8+8),                               0862
*       3 * PTR(31) INIT(ADDR(PCCW1LB4)),/* SEE PTTLBPTR             */
*       3 PCCW1DT4 PTR(31) INIT(0), /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(PCCWAIA)-1+16*LENGTH('WAIA')
*             -16),                 /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(45+8+8+8+8),                             0862
*       3 * FIXED(8) INIT(51+8+8+8+8),                             0862
*       3 * PTR(31) INIT(ADDR(PCCW1LB5)),/* SEE PTTLBPTR             */
*       3 PCCW1DT5 PTR(31) INIT(0), /* SEE PTTDTPTR                  */
*      2 * FIXED(31) INIT(0);       /* END OF FORMAT PATTERNS        */
*                                                                  0863
*   /*****************************************************************/
*   /*                                                               */
*   /* PCCW2:ILRMLINE (WIORB,WM,WBB,WCC,WHH,WR) LABEL VARIABLES      */
*   /* REFERENCED IN FORMAT PATTERNS                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0863
*   DCL                                                            0863
*     PCCW2LB1 CHAR(LENGTH('WIORB')) INIT('WIORB');                0863
*   DCL                                                            0864
*     PCCW2LB2 CHAR(LENGTH('WM')) INIT('WM');                      0864
*   DCL                                                            0865
*     PCCW2LB3 CHAR(LENGTH('WBB')) INIT('WBB');                    0865
*   DCL                                                            0866
*     PCCW2LB4 CHAR(LENGTH('WCC')) INIT('WCC');                    0866
*   DCL                                                            0867
*     PCCW2LB5 CHAR(LENGTH('WHH')) INIT('WHH');                    0867
*   DCL                                                            0868
*     PCCW2LB6 CHAR(LENGTH('WR')) INIT('WR');                      0868
*                                                                  0868
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT PATTERNS FOR ONE LINE OF OUTPUT                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0869
*   DCL                                                            0869
*     1 PCCW2PTS BDY(WORD),                                        0869
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(PCCWIORB)-1+16*LENGTH('WIORB
*             )-16),                /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(5),                                      0869
*       3 * FIXED(8) INIT(11),                                     0869
*       3 * PTR(31) INIT(ADDR(PCCW2LB1)),/* SEE PTTLBPTR             */
*       3 PCCW2DT1 PTR(31) INIT(0), /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(PCCWM)-1+16*LENGTH('WM')-16)
*         ,                         /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(15+8),                                   0869
*       3 * FIXED(8) INIT(21+8),                                   0869
*       3 * PTR(31) INIT(ADDR(PCCW2LB2)),/* SEE PTTLBPTR             */
*       3 PCCW2DT2 PTR(31) INIT(0), /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(PCCWBB)-1+16*LENGTH('WBB')-
*             16),                  /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(25+8+8),                                 0869
*       3 * FIXED(8) INIT(31+8+8),                                 0869
*       3 * PTR(31) INIT(ADDR(PCCW2LB3)),/* SEE PTTLBPTR             */
*       3 PCCW2DT3 PTR(31) INIT(0), /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(PCCWCC)-1+16*LENGTH('WCC')-
*             16),                  /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(35+8+8+8),                               0869
*       3 * FIXED(8) INIT(41+8+8+8),                               0869
*       3 * PTR(31) INIT(ADDR(PCCW2LB4)),/* SEE PTTLBPTR             */
*       3 PCCW2DT4 PTR(31) INIT(0), /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(PCCWHH)-1+16*LENGTH('WHH')-
*             16),                  /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(45+8+8+8+8),                             0869
*       3 * FIXED(8) INIT(51+8+8+8+8),                             0869
*       3 * PTR(31) INIT(ADDR(PCCW2LB5)),/* SEE PTTLBPTR             */
*       3 PCCW2DT5 PTR(31) INIT(0), /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(PCCWR)-1+16*LENGTH('WR')-16)
*         ,                         /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(55+8+8+8+8+8),                           0869
*       3 * FIXED(8) INIT(61+8+8+8+8+8),                           0869
*       3 * PTR(31) INIT(ADDR(PCCW2LB6)),/* SEE PTTLBPTR             */
*       3 PCCW2DT6 PTR(31) INIT(0), /* SEE PTTDTPTR                  */
*      2 * FIXED(31) INIT(0);       /* END OF FORMAT PATTERNS        */
*                                                                  0869
*   /*****************************************************************/
*   /*                                                               */
*   /* PCCW3: (SEEK,SSEC,SRCH,TIC) LABEL VARIABLES REFERENCED IN FMT */
*   /* PTTRNS                                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0870
*   DCL                                                            0870
*     PCCW3LB1 CHAR(LENGTH('SEEK')) INIT('SEEK');                  0870
*   DCL                                                            0871
*     PCCW3LB2 CHAR(LENGTH('SSEC')) INIT('SSEC');                  0871
*   DCL                                                            0872
*     PCCW3LB3 CHAR(LENGTH('SRCH')) INIT('SRCH');                  0872
*   DCL                                                            0873
*     PCCW3LB4 CHAR(LENGTH('TIC')) INIT('TIC');                    0873
*                                                                  0874
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT PATTERNS FOR LINE OF OUTPUT (HAND CODED)               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0874
*   DCL                                                            0874
*     1 PCCW3PTS BDY(WORD),         /* FORMAT PATTERNS - SEE PTTRNS  */
*      2 * CHAR(12) BDY(WORD),                                     0874
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),                    0874
*       3 * FIXED(8) INIT(LENGTH(PCCWSEEK)-1+16*LENGTH('SEEK')-16),
*       3 * FIXED(8) INIT(5),                                      0874
*       3 * FIXED(8) INIT(11),                                     0874
*       3 * PTR(31) INIT(ADDR(PCCW3LB1)),                          0874
*       3 PCCW3DT1 PTR(31) INIT(0),                                0874
*      2 * CHAR(8) BDY(WORD),                                      0874
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    0874
*       3 * FIXED(8) INIT(LENGTH(PCCWSSEC)-1+16*LENGTH('SSEC')-16),
*       3 * FIXED(8) INIT(31),                                     0874
*       3 * FIXED(8) INIT(37),                                     0874
*       3 * PTR(31) INIT(ADDR(PCCW3LB2)),                          0874
*      2 * CHAR(8) BDY(WORD),                                      0874
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    0874
*       3 * FIXED(8) INIT(LENGTH(PCCWSRCH)-1+16*LENGTH('SRCH')-16),
*       3 * FIXED(8) INIT(57),                                     0874
*       3 * FIXED(8) INIT(63),                                     0874
*       3 * PTR(31) INIT(ADDR(PCCW3LB3)),                          0874
*      2 * CHAR(8) BDY(WORD),                                      0874
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    0874
*       3 * FIXED(8) INIT(LENGTH(PCCWTIC)-1+16*LENGTH('TIC')-16),  0874
*       3 * FIXED(8) INIT(83),                                     0874
*       3 * FIXED(8) INIT(89),                                     0874
*       3 * PTR(31) INIT(ADDR(PCCW3LB4)),                          0874
*      2 * FIXED(31) INIT(0);                                      0874
*                                                                  0874
*   /*****************************************************************/
*   /*                                                               */
*   /* PCCW4: (RW,NOP) LABEL VARIABLES REFERENCED IN FMT PTTRNS      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0875
*   DCL                                                            0875
*     PCCW4LB1 CHAR(LENGTH('R/W')) INIT('R/W');                    0875
*   DCL                                                            0876
*     PCCW4LB2 CHAR(LENGTH('NOP')) INIT('NOP');                    0876
*                                                                  0877
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT PATTERNS FOR LINE OF OUTPUT (HAND CODED)               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0877
*   DCL                                                            0877
*     1 PCCW4PTS BDY(WORD),         /* FORMAT PATTERNS - SEE PTTRNS  */
*      2 * CHAR(8) BDY(WORD),                                      0877
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    0877
*       3 * FIXED(8) INIT(LENGTH(PCCWRW)-1+16*LENGTH('R/W')-16),   0877
*       3 * FIXED(8) INIT(5),                                      0877
*       3 * FIXED(8) INIT(11),                                     0877
*       3 * PTR(31) INIT(ADDR(PCCW4LB1)),                          0877
*      2 * CHAR(8) BDY(WORD),                                      0877
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    0877
*       3 * FIXED(8) INIT(LENGTH(PCCWNOP)-1+16*LENGTH('NOP')-16),  0877
*       3 * FIXED(8) INIT(31),                                     0877
*       3 * FIXED(8) INIT(37),                                     0877
*       3 * PTR(31) INIT(ADDR(PCCW4LB2)),                          0877
*      2 * FIXED(31) INIT(0);                                      0877
*   RFY                                                            0878
*     R14 RSTD;                                                    0878
*   RTNADDR3=R14;                   /* SAVE RETURN ADDRESS           */
         LR    RTNADDR3,R14                                        0879
*   RFY                                                            0880
*     R14 UNRSTD;                                                  0880
*   PCCWRC=0;                       /* ZERO THE RETURN CODE          */
*                                                                  0881
         SLR   PCCWRC,PCCWRC                                       0881
*   /*****************************************************************/
*   /*                                                               */
*   /* GET THE NUMBER OF PCCW'S AND IF IT IS NOT AVAILABLE SET IT TO */
*   /* 150.                                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0882
*   DO;                             /* ILRMACCS (MAXNUM)           0882
*                                      FROM(ASMPCCWN)                */
*     RFY                                                          0883
*      (R0,                                                        0883
*       R1,                                                        0883
*       R14,                                                       0883
*       R15) RSTD;                                                 0883
*     R0=ADDR(ASMPCCWN);                                           0884
         L     @12,ASMVTPTR                                        0884
         LA    R0,ASMPCCWN(,@12)                                   0884
*     R1=ABDPLPTR;                  /* POINT TO PARM LIST            */
         L     @12,ABDPLPTR                                        0885
         LR    R1,@12                                              0885
*     CALL ACCESS;                  /* ACCESS DATA                   */
         L     @15,ADPLMEMA(,@12)                                  0886
         BALR  @14,@15                                             0886
*     R14=R0;                       /* CANNOT USE R0 AS BASE         */
         LR    R14,R0                                              0887
*     IF R15=GOOD THEN              /* CHECK ACCESS                  */
         LTR   R15,R15                                             0888
         BNZ   @RF00888                                            0888
*       MAXNUM=CURRENT;             /* GET REQUESTED FIELD           */
         MVC   MAXNUM(4),CURRENT(R14)                              0889
*     ELSE                          /* ACCESS NO GOOD                */
*       MAXNUM=ZERO;                /* ZERO FIELD                    */
         B     @RC00888                                            0890
@RF00888 SLR   @12,@12                                             0890
         ST    @12,MAXNUM                                          0890
*     RFY                                                          0891
*      (R0,                                                        0891
*       R1,                                                        0891
*       R14,                                                       0891
*       R15) UNRSTD;                                               0891
@RC00888 DS    0H                                                  0892
*   END;                            /* GET NUMBER OF PCCWS           */
*   IF MAXNUM^=NULLPTR THEN         /* ACCESS WAS GOOD               */
         L     @12,MAXNUM                                          0893
         LTR   @12,@12                                             0893
         BZ    @RF00893                                            0893
*     MAXPCCWS=MAXNUM;              /* SET MAX TO THAT NUMBER        */
         ST    @12,MAXPCCWS                                        0894
*   ELSE                            /* COUNLD NOT GET MAX NUM        */
*     MAXPCCWS=150;                 /* SET A MAX NUM                 */
         B     @RC00893                                            0895
@RF00893 MVC   MAXPCCWS(4),@CF01731                                0895
*   MAXCTR=0;                       /* INITIALIZE COUNTER            */
@RC00893 SLR   @12,@12                                             0896
         ST    @12,MAXCTR                                          0896
*   ANCHTXT=ANCH;                   /* SET UP THE HEADER LABEL       */
         L     @12,ABDPLPTR                                        0897
         L     @12,ADPLBUF(,@12)                                   0897
         MVC   ANCHTXT(11,@12),ANCH                                0897
*   ANCHNAME=ANCHPCCW;              /* PUT IN SOURCE NAME            */
*                                                                  0898
         MVC   ANCHNAME(8,@12),ANCHPCCW                            0898
*   /*****************************************************************/
*   /*                                                               */
*   /* LOOP UNTIL ALL PCCW'S ARE PRINTED                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0899
*   DO WHILE(PCCWPTR^=NULLPTR&      /* UNTIL ACCESS FAILS, Q ENDED   */
*         MAXCTR<MAXPCCWS);         /* OR MAXEXCEEDED                */
         B     @DE00899                                            0899
@DL00899 DS    0H                                                  0900
*     MAXCTR=MAXCTR+1;              /* INCREMENT LOOP COUNT          */
         LA    @12,1                                               0900
         AL    @12,MAXCTR                                          0900
         ST    @12,MAXCTR                                          0900
*     RFY                                                          0901
*      (R0,                                                        0901
*       R1) RSTD;                                                  0901
*     R0=ADDR(PCCWPTR);             /* GET PCCW PTR                  */
         LA    R0,PCCWPTR                                          0902
*     R1=ADDR(PCCWNAM);             /* GET ADDRESS OF NAME           */
         LA    R1,PCCWNAM                                          0903
*     CALL ILRFPRTH;                /* CALL TO PRINT HEADING         */
         L     @15,@CV00676                                        0904
         BALR  @14,@15                                             0904
*     RFY                                                          0905
*      (R0,                                                        0905
*       R1) UNRSTD;                                                0905
*                                                                  0905
*     /***************************************************************/
*     /*                                                             */
*     /* FORMAT THE FIRST TWO LINES OF THE PCCW                      */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0906
*     DO;                           /* ILRMFRMT (PCCW)             0906
*                                      LINES(PCCW1,PCCW2)            */
*       FORMRC=0;                   /* ZERO THE RETURN CODE          */
         SLR   FORMRC,FORMRC                                       0907
*       PCCW1DT1=ADDR(PCCWID);                                     0908
         L     @12,PCCWPTR                                         0908
         ST    @12,PCCW1DT1                                        0908
*       PCCW1DT2=ADDR(PCCWSECT);                                   0909
         LA    @03,PCCWSECT(,@12)                                  0909
         ST    @03,PCCW1DT2                                        0909
*       PCCW1DT3=ADDR(PCCWFLGS);                                   0910
         LA    @03,PCCWFLGS(,@12)                                  0910
         ST    @03,PCCW1DT3                                        0910
*       PCCW1DT4=ADDR(PCCWPCCW);                                   0911
         LA    @03,PCCWPCCW(,@12)                                  0911
         ST    @03,PCCW1DT4                                        0911
*       PCCW1DT5=ADDR(PCCWAIA);                                    0912
         LA    @12,PCCWAIA(,@12)                                   0912
         ST    @12,PCCW1DT5                                        0912
*       RFY                                                        0913
*        (R0,                                                      0913
*         R1) RSTD;                                                0913
*       R0=ADDR(PCCW1PTS);                                         0914
         LA    R0,PCCW1PTS                                         0914
*       R1=ABDPLPTR;                /* GET PARM ADDR                 */
         L     @12,ABDPLPTR                                        0915
         LR    R1,@12                                              0915
*       CALL FORMAT;                /* FORMAT THE LINE               */
         L     @15,ADPLFRMT(,@12)                                  0916
         BALR  @14,@15                                             0916
*       RFY                                                        0917
*         R15 RSTD;                                                0917
*       FORMRC=FORMRC|R15;          /* SAVE RETURN CODE              */
         OR    FORMRC,R15                                          0918
*       RFY                                                        0919
*         R15 UNRSTD;                                              0919
*       CALL PRINT;                 /* CALL PRINT ROUTINE            */
         L     @12,ABDPLPTR                                        0920
         L     @15,ADPLPRNT(,@12)                                  0920
         BALR  @14,@15                                             0920
*       RFY                                                        0921
*        (R0,                                                      0921
*         R1) UNRSTD;                                              0921
*       PCCW2DT1=ADDR(PCCWIORB);                                   0922
         L     @12,PCCWPTR                                         0922
         LA    @03,PCCWIORB(,@12)                                  0922
         ST    @03,PCCW2DT1                                        0922
*       PCCW2DT2=ADDR(PCCWM);                                      0923
         LA    @03,PCCWM(,@12)                                     0923
         ST    @03,PCCW2DT2                                        0923
*       PCCW2DT3=ADDR(PCCWBB);                                     0924
         LA    @03,PCCWBB(,@12)                                    0924
         ST    @03,PCCW2DT3                                        0924
*       PCCW2DT4=ADDR(PCCWCC);                                     0925
         LA    @03,PCCWCC(,@12)                                    0925
         ST    @03,PCCW2DT4                                        0925
*       PCCW2DT5=ADDR(PCCWHH);                                     0926
         LA    @03,PCCWHH(,@12)                                    0926
         ST    @03,PCCW2DT5                                        0926
*       PCCW2DT6=ADDR(PCCWR);                                      0927
         LA    @12,PCCWR(,@12)                                     0927
         ST    @12,PCCW2DT6                                        0927
*       RFY                                                        0928
*        (R0,                                                      0928
*         R1) RSTD;                                                0928
*       R0=ADDR(PCCW2PTS);                                         0929
         LA    R0,PCCW2PTS                                         0929
*       R1=ABDPLPTR;                /* GET PARM ADDR                 */
         L     @12,ABDPLPTR                                        0930
         LR    R1,@12                                              0930
*       CALL FORMAT;                /* FORMAT THE LINE               */
         L     @15,ADPLFRMT(,@12)                                  0931
         BALR  @14,@15                                             0931
*       RFY                                                        0932
*         R15 RSTD;                                                0932
*       FORMRC=FORMRC|R15;          /* SAVE RETURN CODE              */
         OR    FORMRC,R15                                          0933
*       RFY                                                        0934
*         R15 UNRSTD;                                              0934
*       CALL PRINT;                 /* CALL PRINT ROUTINE            */
         L     @12,ABDPLPTR                                        0935
         L     @15,ADPLPRNT(,@12)                                  0935
         BALR  @14,@15                                             0935
*       RFY                                                        0936
*        (R0,                                                      0936
*         R1) UNRSTD;                                              0936
*       RFY                                                        0937
*         R15 RSTD;                                                0937
*       R15=FORMRC;                 /* SAVE RETURN CODE FROM FORMAT  */
         LR    R15,FORMRC                                          0938
*       RFY                                                        0939
*         R15 UNRSTD;                                              0939
*     END;                          /* ILRMFRMT (PCCW)             0940
*                                      LINES(PCCW1,PCCW2)            */
*     RFY                                                          0941
*       R15 RSTD;                                                  0941
*     PCCWRC=PCCWRC|R15;                                           0942
         OR    PCCWRC,R15                                          0942
*     RFY                                                          0943
*       R15 UNRSTD;                                                0943
*                                                                  0944
*     /***************************************************************/
*     /*                                                             */
*     /* FORMAT THE REST OF THE PCCW WITH HARDCODED CALLS TO FORMAT  */
*     /* AND PRINT.                                                  */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0944
*     PCCW3DT1=ADDR(PCCWSEEK);                                     0944
         L     @12,PCCWPTR                                         0944
         LA    @12,PCCWSEEK(,@12)                                  0944
         ST    @12,PCCW3DT1                                        0944
*     RFY                                                          0945
*      (R0,                                                        0945
*       R1) RSTD;                                                  0945
*     R0=ADDR(PCCW3PTS);                                           0946
         LA    R0,PCCW3PTS                                         0946
*     R1=ABDPLPTR;                                                 0947
         L     @12,ABDPLPTR                                        0947
         LR    R1,@12                                              0947
*     CALL FORMAT;                                                 0948
         L     @15,ADPLFRMT(,@12)                                  0948
         BALR  @14,@15                                             0948
*     RFY                                                          0949
*       R15 RSTD;                                                  0949
*     PCCWRC=PCCWRC|R15;            /* SAVE RETURN CODE              */
         OR    PCCWRC,R15                                          0950
*     RFY                                                          0951
*       R15 UNRSTD;                                                0951
*     CALL PRINT;                                                  0952
         L     @12,ABDPLPTR                                        0952
         L     @15,ADPLPRNT(,@12)                                  0952
         BALR  @14,@15                                             0952
*     RFY                                                          0953
*      (R0,                                                        0953
*       R1) RSTD;                                                  0953
*     R0=ADDR(PCCW4PTS);                                           0954
         LA    R0,PCCW4PTS                                         0954
*     R1=ABDPLPTR;                                                 0955
         L     @12,ABDPLPTR                                        0955
         LR    R1,@12                                              0955
*     CALL FORMAT;                                                 0956
         L     @15,ADPLFRMT(,@12)                                  0956
         BALR  @14,@15                                             0956
*     RFY                                                          0957
*       R15 RSTD;                                                  0957
*     PCCWRC=PCCWRC|R15;            /* SAVE RETURN CODE              */
         OR    PCCWRC,R15                                          0958
*     RFY                                                          0959
*       R15 UNRSTD;                                                0959
*     CALL PRINT;                                                  0960
         L     @12,ABDPLPTR                                        0960
         L     @15,ADPLPRNT(,@12)                                  0960
         BALR  @14,@15                                             0960
*     CALL PRINT;                                                  0961
         L     @12,ABDPLPTR                                        0961
         L     @15,ADPLPRNT(,@12)                                  0961
         BALR  @14,@15                                             0961
*     RFY                                                          0962
*      (R0,                                                        0962
*       R1) UNRSTD;                                                0962
*                                                                  0963
*     /***************************************************************/
*     /*                                                             */
*     /* GET THE ADDRESS OF THE AIA AND IF ONE IS AVAILABLE CALL     */
*     /* ILRFAIA TO FORMAT IT.                                       */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0963
*     DO;                           /* ILRMACCS (AIAPTR)           0963
*                                      FROM(PCCWAIA)                 */
*       RFY                                                        0964
*        (R0,                                                      0964
*         R1,                                                      0964
*         R14,                                                     0964
*         R15) RSTD;                                               0964
*       R0=ADDR(PCCWAIA);                                          0965
         L     @12,PCCWPTR                                         0965
         LA    R0,PCCWAIA(,@12)                                    0965
*       R1=ABDPLPTR;                /* POINT TO PARM LIST            */
         L     @12,ABDPLPTR                                        0966
         LR    R1,@12                                              0966
*       CALL ACCESS;                /* ACCESS DATA                   */
         L     @15,ADPLMEMA(,@12)                                  0967
         BALR  @14,@15                                             0967
*       R14=R0;                     /* CANNOT USE R0 AS BASE         */
         LR    R14,R0                                              0968
*       IF R15=GOOD THEN            /* CHECK ACCESS                  */
         LTR   R15,R15                                             0969
         BNZ   @RF00969                                            0969
*         AIAPTR=CURRENT;           /* GET REQUESTED FIELD           */
         L     AIAPTR,CURRENT(,R14)                                0970
*       ELSE                        /* ACCESS NO GOOD                */
*         AIAPTR=ZERO;              /* ZERO FIELD                    */
         B     @RC00969                                            0971
@RF00969 SLR   AIAPTR,AIAPTR                                       0971
*       RFY                                                        0972
*        (R0,                                                      0972
*         R1,                                                      0972
*         R14,                                                     0972
*         R15) UNRSTD;                                             0972
@RC00969 DS    0H                                                  0973
*     END;                                                         0973
*     IF AIAPTR^=NULLPTR THEN       /* QUEUE HAS ELEMENTS            */
         LTR   AIAPTR,AIAPTR                                       0974
         BZ    @RF00974                                            0974
*       DO;                                                        0975
*         ANCHTXT=ANCH;             /* PUT LABEL IN BUFFER           */
         L     @01,ABDPLPTR                                        0976
         L     @15,ADPLBUF(,@01)                                   0976
         MVC   ANCHTXT(11,@15),ANCH                                0976
*         ANCHNAME=ANCHAIA6;        /* ANCHOR LOCATION               */
         MVC   ANCHNAME(8,@15),ANCHAIA6                            0977
*         RFY                                                      0978
*          (R0,                                                    0978
*           R1,                                                    0978
*           R2) RSTD;                                              0978
*         R0=AIAPTR;                /* GET THE ADDR OF THE FIRST AIA */
         LR    R0,AIAPTR                                           0979
*         R1=ADDR(AIANAM);          /* GET ADDR OF NAME OF BLOCK     */
         LA    R1,AIANAM                                           0980
*         R2=0;                     /* SET CODE FOR ILRFAIA          */
         SLR   R2,R2                                               0981
*         CALL ILRFAIA;             /* CALL SEGMENT TO FMT AIA Q     */
         L     @15,@CV00675                                        0982
         BALR  @14,@15                                             0982
*       END;                                                       0983
*     RFY                                                          0984
*       R15 RSTD;                                                  0984
@RF00974 DS    0H                                                  0985
*     PCCWRC=PCCWRC|R15;            /* SAVE RETURN CODE              */
         OR    PCCWRC,R15                                          0985
*     RFY                                                          0986
*      (R0,                                                        0986
*       R1,                                                        0986
*       R2,                                                        0986
*       R15) UNRSTD;                                               0986
*                                                                  0986
*     /***************************************************************/
*     /*                                                             */
*     /* GET THE ADDRESS OF THE NEXT PCCW. IF THERE IS NONE THE LOOP */
*     /* WILL END.                                                   */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0987
*     DO;                           /* ILRMACCS (PCCWPTR)          0987
*                                      FROM(PCCWPCCW)                */
*       RFY                                                        0988
*        (R0,                                                      0988
*         R1,                                                      0988
*         R14,                                                     0988
*         R15) RSTD;                                               0988
*       R0=ADDR(PCCWPCCW);                                         0989
         L     @12,PCCWPTR                                         0989
         LA    R0,PCCWPCCW(,@12)                                   0989
*       R1=ABDPLPTR;                /* POINT TO PARM LIST            */
         L     @12,ABDPLPTR                                        0990
         LR    R1,@12                                              0990
*       CALL ACCESS;                /* ACCESS DATA                   */
         L     @15,ADPLMEMA(,@12)                                  0991
         BALR  @14,@15                                             0991
*       R14=R0;                     /* CANNOT USE R0 AS BASE         */
         LR    R14,R0                                              0992
*       IF R15=GOOD THEN            /* CHECK ACCESS                  */
         LTR   R15,R15                                             0993
         BNZ   @RF00993                                            0993
*         PCCWPTR=CURRENT;          /* GET REQUESTED FIELD           */
         MVC   PCCWPTR(4),CURRENT(R14)                             0994
*       ELSE                        /* ACCESS NO GOOD                */
*         PCCWPTR=ZERO;             /* ZERO FIELD                    */
         B     @RC00993                                            0995
@RF00993 SLR   @12,@12                                             0995
         ST    @12,PCCWPTR                                         0995
*       RFY                                                        0996
*        (R0,                                                      0996
*         R1,                                                      0996
*         R14,                                                     0996
*         R15) UNRSTD;                                             0996
@RC00993 DS    0H                                                  0997
*     END;                                                         0997
*     RFY                                                          0998
*       R15 RSTD;                                                  0998
*     PCCWRC=PCCWRC|R15;            /* SAVE THE RETURN CODE          */
         OR    PCCWRC,R15                                          0999
*     RFY                                                          1000
*       R15 UNRSTD;                                                1000
*   END;                            /* END PCCW PROCESSING           */
*                                                                  1001
@DE00899 ICM   @12,15,PCCWPTR                                      1001
         BZ    @DC00899                                            1001
         L     @12,MAXCTR                                          1001
         C     @12,MAXPCCWS                                        1001
         BL    @DL00899                                            1001
@DC00899 DS    0H                                                  1002
*   /*****************************************************************/
*   /*                                                               */
*   /* IF THE LOOP COUNTER HAS EXCEEDED THE NUMBER OF ITERATIONS     */
*   /* REQUIRED A MESSAGE WILL BE PUT OUT.                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1002
*   IF PCCWPTR^=NULLPTR THEN        /* MAX WAS EXCEEDED              */
         ICM   @12,15,PCCWPTR                                      1002
         BZ    @RF01002                                            1002
*     DO;                                                          1003
*       PCCWRC=4;                   /* SET THE BAD RETURN CODE       */
         LA    PCCWRC,4                                            1004
*       RFY                                                        1005
*         R1 RSTD;                                                 1005
*       R1=15;                      /* CODE OF ERROR MESSAGE         */
         LA    R1,15                                               1006
*       RFY                                                        1007
*         R1 UNRSTD;                                               1007
*       CALL ILRFMSG;               /* GO TO MESSAGE SEGMENT         */
         L     @15,@CV00674                                        1008
         BALR  @14,@15                                             1008
*     END;                                                         1009
*   RFY                                                            1010
*    (R14,                                                         1010
*     R15) RSTD;                                                   1010
@RF01002 DS    0H                                                  1011
*   R15=PCCWRC;                     /* PUT THE RETURN CODE IN REG 15 */
         LR    R15,PCCWRC                                          1011
*   R14=RTNADDR3;                   /* RESTORE RETURN ADDRESS        */
         LR    R14,RTNADDR3                                        1012
*   RFY                                                            1013
*    (R14,                                                         1013
*     R15) UNRSTD;                                                 1013
*   END FMTPCCW;                    /* RETURN TO CALLER              */
@EL00007 DS    0H                                                  1014
@EF00007 DS    0H                                                  1014
@ER00007 BR    @14                                                 1014
*                                                                  1015
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS CODE IS THE EXTERNAL ENTRY POINT TO FORMAT THE IORB AND  */
*   /* ASSOCIATED BLOCKS. THE BASE REGISTERS HAVE TO BE SET TO WHAT  */
*   /* THEY ARE AT THE MAIN ENTRY POINT OF THE MODULE AND ALL        */
*   /* REGISTERS ARE SAVED. SAVE AREAS ARE CHAINED AND FMTIORB IS    */
*   /* CALLED. UPON RETURN THE REGS EXCEPT 15 ARE RESTORED AND       */
*   /* CONTROL IS RETURNED TO THE CALLER.                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1015
*   GENERATE REFS(SAVEIOR);                                        1015
         ENTRY ILRFIORB
ILRFIORB STM   R14,R12,12(R13)      SAVE ALL THE REGISTERS
         LR    R9,R15               GET ENTRY ADDRESS
         LA    R15,ILRFIORB-@PSTART GET LENGTH TO REAL BASE
        SR   R9,R15    SUBTRACT TO GET THE SAME BASE ADDRESS
        LA   R10,4095(,R9)  SET UP SECOND BASE REG
        ST   R13,SAVEIOR+4   SAVE ADDRESS OF PASSED SAVE AREA
        LA   R14,SAVEIOR     GET ADDR OF MY SAVE AREA
        ST   R14,8(R13)      MY SAVE ADDR IN PASSED SAVE AREA
        LA   R13,SAVEIOR     GET ADDRESS OF MY SAVE AREA
        ST   R0,IORBPTR      STORE THE IORB ADDRESS
        ST   R1,ABDPLPTR     STORE THE ABDUMP PARM LIST ADDR
        LA   R15,FMTIORB     GET THE ADDRESS OF FMTIORB
        BALR  R14,R15      GO TO FORMAT IORT ETC.
        L     R13,4(R13)   GET PASSED SAVE AREA ADDRESS
        L     R14,12(R13)  GET THE RETURN ADDRESS
        LM    R0,R12,20(R13) GET THE REST OF THE REGS
        BR    R14          RETURN CONTROL
*                                                                  1016
*/********************************************************************/
*/*                                                                  */
*/* ILRFIORB:SEGMENT TO FORMAT A QUEUE OF IORBS                      */
*/*                                                                  */
*/* INPUT:   VIRTUAL ADDRESS OF IORB IN IORBPTR                      */
*/*                                                                  */
*/* PROCESS: FORMAT IORB, THEN CALL SEGMENTS TO FORMAT IOSB AND      */
*/*           PCCW OR SCCW CHAIN                                     */
*/*                                                                  */
*/* OUTPUT:  THE CUMULATIVE RETURN FROM FORMATS, ACCESSES AND        */
*/*           SEGMENTS CALLED                                        */
*/*                                                                  */
*/********************************************************************/
*                                                                  1016
*FMTIORB:                                                          1016
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1016
         B     @PB00008                                            1016
FMTIORB  DS    0H                                                  1017
*                                                                  1017
*   /*****************************************************************/
*   /*                                                               */
*   /* IOR1:ILRMLINE (ID,NUM,RQSZ,(FLGS,,BIT),IORB,PCCW) OF(IORB)    */
*   /* LABEL VARIABLES REFERENCED IN FORMAT PATTERNS                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1017
*   DCL                                                            1017
*     IOR1LB1 CHAR(LENGTH('ID')) INIT('ID');                       1017
*   DCL                                                            1018
*     IOR1LB2 CHAR(LENGTH('NUM')) INIT('NUM');                     1018
*   DCL                                                            1019
*     IOR1LB3 CHAR(LENGTH('RQSZ')) INIT('RQSZ');                   1019
*   DCL                                                            1020
*     IOR1LB4 CHAR(LENGTH('FLGS')) INIT('FLGS');                   1020
*   DCL                                                            1021
*     IOR1LB5 CHAR(LENGTH('IORB')) INIT('IORB');                   1021
*   DCL                                                            1022
*     IOR1LB6 CHAR(LENGTH('PCCW')) INIT('PCCW');                   1022
*                                                                  1022
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT PATTERNS FOR ONE LINE OF OUTPUT                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1023
*   DCL                                                            1023
*     1 IOR1PTS BDY(WORD),                                         1023
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(IORID)-1+16*LENGTH('ID')-16)
*         ,                         /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(5),                                      1023
*       3 * FIXED(8) INIT(11),                                     1023
*       3 * PTR(31) INIT(ADDR(IOR1LB1)),/* SEE PTTLBPTR              */
*       3 IOR1DT1 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(IORNUM)-1+16*LENGTH('NUM')-
*             16),                  /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(15+8),                                   1023
*       3 * FIXED(8) INIT(21+8),                                   1023
*       3 * PTR(31) INIT(ADDR(IOR1LB2)),/* SEE PTTLBPTR              */
*       3 IOR1DT2 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(IORRQSZ)-1+16*LENGTH('RQSZ')
*             -16),                 /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(25+8+8),                                 1023
*       3 * FIXED(8) INIT(31+8+8),                                 1023
*       3 * PTR(31) INIT(ADDR(IOR1LB3)),/* SEE PTTLBPTR              */
*       3 IOR1DT3 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(IORFLGS)/8-1+16*LENGTH('FLGS
*             )-16),                /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(35+8+8+8),                               1023
*       3 * FIXED(8) INIT(41+8+8+8),                               1023
*       3 * PTR(31) INIT(ADDR(IOR1LB4)),/* SEE PTTLBPTR              */
*       3 IOR1DT4 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(IORIORB)-1+16*LENGTH('IORB')
*             -16),                 /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(45+8+8+8+8),                             1023
*       3 * FIXED(8) INIT(51+8+8+8+8),                             1023
*       3 * PTR(31) INIT(ADDR(IOR1LB5)),/* SEE PTTLBPTR              */
*       3 IOR1DT5 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(IORPCCW)-1+16*LENGTH('PCCW')
*             -16),                 /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(55+8+8+8+8+8),                           1023
*       3 * FIXED(8) INIT(61+8+8+8+8+8),                           1023
*       3 * PTR(31) INIT(ADDR(IOR1LB6)),/* SEE PTTLBPTR              */
*       3 IOR1DT6 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * FIXED(31) INIT(0);       /* END OF FORMAT PATTERNS        */
*                                                                  1024
*   /*****************************************************************/
*   /*                                                               */
*   /* IOR2:ILRMLINE (ID,NUM,RQSZ,(FLGS,,BIT),IORB,SCCW) LABEL       */
*   /* VARIABLES REFERENCED IN FORMAT PATTERNS                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1024
*   DCL                                                            1024
*     IOR2LB1 CHAR(LENGTH('ID')) INIT('ID');                       1024
*   DCL                                                            1025
*     IOR2LB2 CHAR(LENGTH('NUM')) INIT('NUM');                     1025
*   DCL                                                            1026
*     IOR2LB3 CHAR(LENGTH('RQSZ')) INIT('RQSZ');                   1026
*   DCL                                                            1027
*     IOR2LB4 CHAR(LENGTH('FLGS')) INIT('FLGS');                   1027
*   DCL                                                            1028
*     IOR2LB5 CHAR(LENGTH('IORB')) INIT('IORB');                   1028
*   DCL                                                            1029
*     IOR2LB6 CHAR(LENGTH('SCCW')) INIT('SCCW');                   1029
*                                                                  1029
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT PATTERNS FOR ONE LINE OF OUTPUT                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1030
*   DCL                                                            1030
*     1 IOR2PTS BDY(WORD),                                         1030
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(IORID)-1+16*LENGTH('ID')-16)
*         ,                         /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(5),                                      1030
*       3 * FIXED(8) INIT(11),                                     1030
*       3 * PTR(31) INIT(ADDR(IOR2LB1)),/* SEE PTTLBPTR              */
*       3 IOR2DT1 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(IORNUM)-1+16*LENGTH('NUM')-
*             16),                  /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(15+8),                                   1030
*       3 * FIXED(8) INIT(21+8),                                   1030
*       3 * PTR(31) INIT(ADDR(IOR2LB2)),/* SEE PTTLBPTR              */
*       3 IOR2DT2 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(IORRQSZ)-1+16*LENGTH('RQSZ')
*             -16),                 /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(25+8+8),                                 1030
*       3 * FIXED(8) INIT(31+8+8),                                 1030
*       3 * PTR(31) INIT(ADDR(IOR2LB3)),/* SEE PTTLBPTR              */
*       3 IOR2DT3 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(IORFLGS)/8-1+16*LENGTH('FLGS
*             )-16),                /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(35+8+8+8),                               1030
*       3 * FIXED(8) INIT(41+8+8+8),                               1030
*       3 * PTR(31) INIT(ADDR(IOR2LB4)),/* SEE PTTLBPTR              */
*       3 IOR2DT4 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(IORIORB)-1+16*LENGTH('IORB')
*             -16),                 /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(45+8+8+8+8),                             1030
*       3 * FIXED(8) INIT(51+8+8+8+8),                             1030
*       3 * PTR(31) INIT(ADDR(IOR2LB5)),/* SEE PTTLBPTR              */
*       3 IOR2DT5 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * CHAR(12) BDY(WORD),      /* FORMAT PATTERN SEE PTTRNS     */
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),/* SEE PTTFLGS        */
*       3 * FIXED(8) BDY(BYTE) INIT(LENGTH(IORSCCW)-1+16*LENGTH('SCCW')
*             -16),                 /* SEE PTTLBLGH AND PTTDTLGH     */
*       3 * FIXED(8) INIT(55+8+8+8+8+8),                           1030
*       3 * FIXED(8) INIT(61+8+8+8+8+8),                           1030
*       3 * PTR(31) INIT(ADDR(IOR2LB6)),/* SEE PTTLBPTR              */
*       3 IOR2DT6 PTR(31) INIT(0),  /* SEE PTTDTPTR                  */
*      2 * FIXED(31) INIT(0);       /* END OF FORMAT PATTERNS        */
*   DCL                                                            1031
*     IOR3LB1 CHAR(4) INIT('IOSB');                                1031
*   DCL                                                            1032
*     IOR3LB2 CHAR(4) INIT('SAVE');                                1032
*   DCL                                                            1033
*     IOR3LB3 CHAR(3) INIT('ERR');                                 1033
*   DCL                                                            1034
*     IOR3LB4 CHAR(4) INIT('TSMP');                                1034
*   DCL                                                            1035
*     IOR3LB5 CHAR(5) INIT('PARTE');                               1035
*   DCL                                                            1036
*     1 IOR3PTS BDY(WORD),                                         1036
*      2 * CHAR(12) BDY(WORD),                                     1036
*       3 * BIT(8) INIT('00001111'B),                              1036
*       3 * FIXED(8) INIT(LENGTH(IORIOSB)-1+16*4-16),              1036
*       3 * FIXED(8) INIT(5),                                      1036
*       3 * FIXED(8) INIT(11),                                     1036
*       3 * PTR(31) INIT(ADDR(IOR3LB1)),                           1036
*       3 IOR3DT1 PTR(31),                                         1036
*      2 * CHAR(12),                                               1036
*       3 * BIT(8) INIT('00001111'B),                              1036
*       3 * FIXED(8) INIT(LENGTH(IORSAVE)-1+16*4-16),              1036
*       3 * FIXED(8) INIT(23),                                     1036
*       3 * FIXED(8) INIT(29),                                     1036
*       3 * PTR(31) INIT(ADDR(IOR3LB2)),                           1036
*       3 IOR3DT2 PTR(31),                                         1036
*      2 * CHAR(12),                                               1036
*       3 * BIT(8) INIT('00001111'B),                              1036
*       3 * FIXED(8) INIT(LENGTH(IORERR)-1+16*3-16),               1036
*       3 * FIXED(8) INIT(41),                                     1036
*       3 * FIXED(8) INIT(47),                                     1036
*       3 * PTR(31) INIT(ADDR(IOR3LB3)),                           1036
*       3 IOR3DT3 PTR(31),                                         1036
*      2 * CHAR(12),                                               1036
*       3 * BIT(8) INIT('00001111'B),                              1036
*       3 * FIXED(8) INIT(LENGTH(IORTSMP)-1+16*4-16),              1036
*       3 * FIXED(8) INIT(59),                                     1036
*       3 * FIXED(8) INIT(65),                                     1036
*       3 * PTR(31) INIT(ADDR(IOR3LB4)),                           1036
*       3 IOR3DT4 PTR(31),                                         1036
*      2 * CHAR(12),                                               1036
*       3 * BIT(8) INIT('00001111'B),                              1036
*       3 * FIXED(8) INIT(LENGTH(IORPARTE)-1+16*5-16),             1036
*       3 * FIXED(8) INIT(95),                                     1036
*       3 * FIXED(8) INIT(101),                                    1036
*       3 * PTR(31) INIT(ADDR(IOR3LB5)),                           1036
*       3 IOR3DT5 PTR(31),                                         1036
*      2 * FIXED(31) INIT(0);                                      1036
*                                                                  1037
*/********************************************************************/
*/* HOUSEKEEPING AND INITIALIZATIONS.  PROCESS IORBS UNTIL THE END   */
*/*  OF QUEUE IS REACHED, THE MAXIMUM IS EXCEEDED OR AN ACCESS FAILS */
*/*  THEN GET IOSB PTR AND CALL SEGMENT TO FMT IOSB                  */
*/********************************************************************/
*                                                                  1037
*   RFY                                                            1037
*     R14 RSTD;                                                    1037
*   RTNADDR2=R14;                   /* SAVE RETURN ADDRESS           */
         ST    R14,RTNADDR2                                        1038
*   RFY                                                            1039
*     R14 UNRSTD;                                                  1039
*   IORRC=0;                        /* ZERO THE RETURN CODE          */
         SLR   IORRC,IORRC                                         1040
*   IORCTR=0;                       /* INITIALIZE COUNTER            */
         SLR   @12,@12                                             1041
         ST    @12,IORCTR                                          1041
*   DO WHILE(IORBPTR^=NULLPTR&      /* UNTIL ACCESS FAILS -OR- NEXT
*                                      IORB = 0 -OR-                 */
*         IORCTR<MAXIORBS);         /* UNTIL MAX EXCEEDED            */
         B     @DE01042                                            1042
@DL01042 DS    0H                                                  1043
*     IORCTR=IORCTR+1;              /* INCREMENT THE LOOP COUNTER    */
         LA    @12,1                                               1043
         AL    @12,IORCTR                                          1043
         ST    @12,IORCTR                                          1043
*     RFY                                                          1044
*      (R0,                                                        1044
*       R1) RSTD;                                                  1044
*     R0=ADDR(IORBPTR);             /* GET ADDRESS OF THE BLOCK      */
         LA    R0,IORBPTR                                          1045
*     R1=ADDR(IORBNAM);             /* GET ADDRESS OF THE NAME       */
         LA    R1,IORBNAM                                          1046
*     CALL ILRFPRTH;                /* GO TO PRINT HEADING           */
         L     @15,@CV00676                                        1047
         BALR  @14,@15                                             1047
*     RFY                                                          1048
*      (R0,                                                        1048
*       R1) UNRSTD;                                                1048
*                                                                  1048
*     /***************************************************************/
*     /*                                                             */
*     /* GET THE IORB FLAGS TO DETERMINE IF THIS IS FOR A PAGE OR A  */
*     /* SWAP. IF THE ACCESS IS GOOD DETERMINE IF THE IORB REPRESENTS*/
*     /* A PAGE OR A SWAP AND FORMAT ACCORDINGLY.                    */
*     /*                                                             */
*     /***************************************************************/
*                                                                  1049
*     DO;                           /* ILRMACCS (IORBTYPE)         1049
*                                      FROM(IORID)                   */
*       RFY                                                        1050
*        (R0,                                                      1050
*         R1,                                                      1050
*         R14,                                                     1050
*         R15) RSTD;                                               1050
*       R0=ADDR(IORID);                                            1051
         L     R0,IORBPTR                                          1051
*       R1=ABDPLPTR;                /* POINT TO PARM LIST            */
         L     @12,ABDPLPTR                                        1052
         LR    R1,@12                                              1052
*       CALL ACCESS;                /* ACCESS DATA                   */
         L     @15,ADPLMEMA(,@12)                                  1053
         BALR  @14,@15                                             1053
*       R14=R0;                     /* CANNOT USE R0 AS BASE         */
         LR    R14,R0                                              1054
*       IF R15=GOOD THEN            /* CHECK ACCESS                  */
         LTR   R15,R15                                             1055
         BNZ   @RF01055                                            1055
*         IORBTYPE=CURRENT;         /* GET REQUESTED FIELD           */
         MVC   IORBTYPE(4),CURRENT(R14)                            1056
*       ELSE                        /* ACCESS NO GOOD                */
*         IORBTYPE=ZERO;            /* ZERO FIELD                    */
         B     @RC01055                                            1057
@RF01055 SLR   @12,@12                                             1057
         ST    @12,IORBTYPE                                        1057
*       RFY                                                        1058
*        (R0,                                                      1058
*         R1,                                                      1058
*         R14,                                                     1058
*         R15) UNRSTD;                                             1058
@RC01055 DS    0H                                                  1059
*     END;                                                         1059
*     RFY                                                          1060
*       R15 RSTD;                                                  1060
*     IORRC=IORRC|R15;              /* SAVE THE RETURN CODE          */
         OR    IORRC,R15                                           1061
*     IF R15=GOOD THEN              /* WAS ACCESS SUCCESSFUL         */
         LTR   R15,R15                                             1062
         BNZ   @RF01062                                            1062
*       DO;                                                        1063
*         RFY                                                      1064
*           R15 UNRSTD;                                            1064
*                                                                  1064
*/*   THE FIRST LINE OF THE IORB IS FORMATTED DIFFERENTLY            */
*/*   DEPENDING IF THE IORB IS FOR SWAP OR PAGE. CHECK THE           */
*/*   FLAGS TO DETERMINE WHAT TYPE AND FORMAT THE FIRST LINE.        */
*                                                                  1065
*         IF IORBSWAP='0'B THEN     /* IS THIS A SWAP IORB??         */
         TM    IORBSWAP,B'00001000'                                1065
         BNZ   @RF01065                                            1065
*           DO;                                                    1066
*             DO;                   /* ILRMFRMT (IORB) LINES(IOR1)   */
*               FORMRC=0;           /* ZERO THE RETURN CODE          */
         SLR   FORMRC,FORMRC                                       1068
*               IOR1DT1=ADDR(IORID);                               1069
         L     @12,IORBPTR                                         1069
         ST    @12,IOR1DT1                                         1069
*               IOR1DT2=ADDR(IORNUM);                              1070
         LA    @08,IORNUM(,@12)                                    1070
         ST    @08,IOR1DT2                                         1070
*               IOR1DT3=ADDR(IORRQSZ);                             1071
         LA    @08,IORRQSZ(,@12)                                   1071
         ST    @08,IOR1DT3                                         1071
*               IOR1DT4=ADDR(IORFLGS);                             1072
         LA    @08,IORFLGS(,@12)                                   1072
         ST    @08,IOR1DT4                                         1072
*               IOR1DT5=ADDR(IORIORB);                             1073
         LA    @08,IORIORB(,@12)                                   1073
         ST    @08,IOR1DT5                                         1073
*               IOR1DT6=ADDR(IORPCCW);                             1074
         LA    @12,IORPCCW(,@12)                                   1074
         ST    @12,IOR1DT6                                         1074
*               RFY                                                1075
*                (R0,                                              1075
*                 R1) RSTD;                                        1075
*               R0=ADDR(IOR1PTS);                                  1076
         LA    R0,IOR1PTS                                          1076
*               R1=ABDPLPTR;        /* GET PARM ADDR                 */
         L     @12,ABDPLPTR                                        1077
         LR    R1,@12                                              1077
*               CALL FORMAT;        /* FORMAT THE LINE               */
         L     @15,ADPLFRMT(,@12)                                  1078
         BALR  @14,@15                                             1078
*               RFY                                                1079
*                 R15 RSTD;                                        1079
*               FORMRC=FORMRC|R15;  /* SAVE RETURN CODE              */
         OR    FORMRC,R15                                          1080
*               RFY                                                1081
*                 R15 UNRSTD;                                      1081
*               CALL PRINT;         /* CALL PRINT ROUTINE            */
         L     @12,ABDPLPTR                                        1082
         L     @15,ADPLPRNT(,@12)                                  1082
         BALR  @14,@15                                             1082
*               RFY                                                1083
*                (R0,                                              1083
*                 R1) UNRSTD;                                      1083
*               RFY                                                1084
*                 R15 RSTD;                                        1084
*               R15=FORMRC;         /* SAVE RETURN CODE FROM FORMAT  */
         LR    R15,FORMRC                                          1085
*               RFY                                                1086
*                 R15 UNRSTD;                                      1086
*             END;                  /* ILRMFRMT (IORB) LINES(IOR1)   */
*           END;                                                   1088
*         ELSE                                                     1089
*           DO;                                                    1089
         B     @RC01065                                            1089
@RF01065 DS    0H                                                  1090
*             DO;                   /* ILRMFRMT LINES(IOR2)          */
*               FORMRC=0;           /* ZERO THE RETURN CODE          */
         SLR   FORMRC,FORMRC                                       1091
*               IOR2DT1=ADDR(IORID);                               1092
         L     @12,IORBPTR                                         1092
         ST    @12,IOR2DT1                                         1092
*               IOR2DT2=ADDR(IORNUM);                              1093
         LA    @08,IORNUM(,@12)                                    1093
         ST    @08,IOR2DT2                                         1093
*               IOR2DT3=ADDR(IORRQSZ);                             1094
         LA    @08,IORRQSZ(,@12)                                   1094
         ST    @08,IOR2DT3                                         1094
*               IOR2DT4=ADDR(IORFLGS);                             1095
         LA    @08,IORFLGS(,@12)                                   1095
         ST    @08,IOR2DT4                                         1095
*               IOR2DT5=ADDR(IORIORB);                             1096
         LA    @08,IORIORB(,@12)                                   1096
         ST    @08,IOR2DT5                                         1096
*               IOR2DT6=ADDR(IORSCCW);                             1097
         LA    @12,IORSCCW(,@12)                                   1097
         ST    @12,IOR2DT6                                         1097
*               RFY                                                1098
*                (R0,                                              1098
*                 R1) RSTD;                                        1098
*               R0=ADDR(IOR2PTS);                                  1099
         LA    R0,IOR2PTS                                          1099
*               R1=ABDPLPTR;        /* GET PARM ADDR                 */
         L     @12,ABDPLPTR                                        1100
         LR    R1,@12                                              1100
*               CALL FORMAT;        /* FORMAT THE LINE               */
         L     @15,ADPLFRMT(,@12)                                  1101
         BALR  @14,@15                                             1101
*               RFY                                                1102
*                 R15 RSTD;                                        1102
*               FORMRC=FORMRC|R15;  /* SAVE RETURN CODE              */
         OR    FORMRC,R15                                          1103
*               RFY                                                1104
*                 R15 UNRSTD;                                      1104
*               CALL PRINT;         /* CALL PRINT ROUTINE            */
         L     @12,ABDPLPTR                                        1105
         L     @15,ADPLPRNT(,@12)                                  1105
         BALR  @14,@15                                             1105
*               RFY                                                1106
*                (R0,                                              1106
*                 R1) UNRSTD;                                      1106
*               RFY                                                1107
*                 R15 RSTD;                                        1107
*               R15=FORMRC;         /* SAVE RETURN CODE FROM FORMAT  */
         LR    R15,FORMRC                                          1108
*               RFY                                                1109
*                 R15 UNRSTD;                                      1109
*             END;                  /* ILRMFRMT LINES(IOR2)          */
*           END;                                                   1111
*         RFY                                                      1112
*           R15 RSTD;                                              1112
@RC01065 DS    0H                                                  1113
*         IORRC=IORRC|R15;                                         1113
         OR    IORRC,R15                                           1113
*         RFY                                                      1114
*           R15 UNRSTD;                                            1114
*                                                                  1114
*         /***********************************************************/
*         /*                                                         */
*         /* FORMAT THE SECOND LINE OF THE IORB THE SAME REGARDLESS  */
*         /* IF A PAGE OR A SWAP SET.                                */
*         /*                                                         */
*         /***********************************************************/
*                                                                  1115
*         RFY                                                      1115
*          (R0,                                                    1115
*           R1,                                                    1115
*           R15) RSTD;                                             1115
*         R0=ADDR(IOR3PTS);         /* GET ADDR OF PATTERN           */
         LA    R0,IOR3PTS                                          1116
*         R1=ABDPLPTR;              /* GET PARM LIST ADDRESS         */
         L     @14,ABDPLPTR                                        1117
         LR    R1,@14                                              1117
*         IOR3DT1=ADDR(IORIOSB);    /* GET THE ADDRESS OF THE DATA   */
         L     @12,IORBPTR                                         1118
         LA    @08,IORIOSB(,@12)                                   1118
         ST    @08,IOR3DT1                                         1118
*         IOR3DT2=ADDR(IORSAVE);    /* GET THE ADDRESS OF THE DATA   */
         LA    @08,IORSAVE(,@12)                                   1119
         ST    @08,IOR3DT2                                         1119
*         IOR3DT3=ADDR(IORERR);     /* GET THE ADDRESS OF THE DATA   */
         LA    @08,IORERR(,@12)                                    1120
         ST    @08,IOR3DT3                                         1120
*         IOR3DT4=ADDR(IORTSMP);    /* GET THE ADDRESS OF THE DATA   */
         LA    @08,IORTSMP(,@12)                                   1121
         ST    @08,IOR3DT4                                         1121
*         IOR3DT5=ADDR(IORPARTE);   /* GET THE ADDRESS OF THE DATA   */
         LA    @12,IORPARTE(,@12)                                  1122
         ST    @12,IOR3DT5                                         1122
*         CALL FORMAT;              /* FORMAT THE LINE               */
         L     @15,ADPLFRMT(,@14)                                  1123
         BALR  @14,@15                                             1123
*         IORRC=IORRC|R15;          /* SAVE THE RETURN CODE          */
         OR    IORRC,R15                                           1124
*         RFY                                                      1125
*          (R0,                                                    1125
*           R1,                                                    1125
*           R15) RSTD;                                             1125
*         CALL PRINT;               /* PRINT THE LINE                */
         L     @12,ABDPLPTR                                        1126
         L     @15,ADPLPRNT(,@12)                                  1126
         BALR  @14,@15                                             1126
*         CALL PRINT;               /* PRINT A LINE OF SPACES        */
         L     @12,ABDPLPTR                                        1127
         L     @15,ADPLPRNT(,@12)                                  1127
         BALR  @14,@15                                             1127
*                                                                  1128
*         /***********************************************************/
*         /*                                                         */
*         /* GET THE ADDRESS OF THE IOSB AND IF AVAILABLE FORMAT IT. */
*         /*                                                         */
*         /***********************************************************/
*                                                                  1128
*         DO;                       /* ILRMACCS (IOSBPTR)          1128
*                                      FROM(IORIOSB)                 */
*           RFY                                                    1129
*            (R0,                                                  1129
*             R1,                                                  1129
*             R14,                                                 1129
*             R15) RSTD;                                           1129
*           R0=ADDR(IORIOSB);                                      1130
         L     @12,IORBPTR                                         1130
         LA    R0,IORIOSB(,@12)                                    1130
*           R1=ABDPLPTR;            /* POINT TO PARM LIST            */
         L     @12,ABDPLPTR                                        1131
         LR    R1,@12                                              1131
*           CALL ACCESS;            /* ACCESS DATA                   */
         L     @15,ADPLMEMA(,@12)                                  1132
         BALR  @14,@15                                             1132
*           R14=R0;                 /* CANNOT USE R0 AS BASE         */
         LR    R14,R0                                              1133
*           IF R15=GOOD THEN        /* CHECK ACCESS                  */
         LTR   R15,R15                                             1134
         BNZ   @RF01134                                            1134
*             IOSBPTR=CURRENT;      /* GET REQUESTED FIELD           */
         MVC   IOSBPTR(4),CURRENT(R14)                             1135
*           ELSE                    /* ACCESS NO GOOD                */
*             IOSBPTR=ZERO;         /* ZERO FIELD                    */
         B     @RC01134                                            1136
@RF01134 SLR   @12,@12                                             1136
         ST    @12,IOSBPTR                                         1136
*           RFY                                                    1137
*            (R0,                                                  1137
*             R1,                                                  1137
*             R14,                                                 1137
*             R15) UNRSTD;                                         1137
@RC01134 DS    0H                                                  1138
*         END;                                                     1138
*         IF IOSBPTR^=NULLPTR THEN  /* WAS THERE AN IOSB             */
         ICM   @12,15,IOSBPTR                                      1139
         BZ    @RF01139                                            1139
*           DO;                                                    1140
*             CALL FMTIOSB;         /* CALL SEGMENT TO FMT IOSB      */
         BAL   @14,FMTIOSB                                         1141
*           END;                                                   1142
*         RFY                                                      1143
*           R15 RSTD;                                              1143
@RF01139 DS    0H                                                  1144
*         IORRC=IORRC|R15;          /* ADD IN RETURN CODE            */
         OR    IORRC,R15                                           1144
*         RFY                                                      1145
*           R15 UNRSTD;                                            1145
*                                                                  1146
*/*   GET THE ADDRESS OF THE PCCW AND IF THERE IS ONE CALL           */
*/*   FMTPCCW TO FORMAT IT.                                          */
*                                                                  1146
*         DO;                       /* ILRMACCS (PCCWPTR)          1146
*                                      FROM(IORPCCW)                 */
*           RFY                                                    1147
*            (R0,                                                  1147
*             R1,                                                  1147
*             R14,                                                 1147
*             R15) RSTD;                                           1147
*           R0=ADDR(IORPCCW);                                      1148
         L     @12,IORBPTR                                         1148
         LA    R0,IORPCCW(,@12)                                    1148
*           R1=ABDPLPTR;            /* POINT TO PARM LIST            */
         L     @12,ABDPLPTR                                        1149
         LR    R1,@12                                              1149
*           CALL ACCESS;            /* ACCESS DATA                   */
         L     @15,ADPLMEMA(,@12)                                  1150
         BALR  @14,@15                                             1150
*           R14=R0;                 /* CANNOT USE R0 AS BASE         */
         LR    R14,R0                                              1151
*           IF R15=GOOD THEN        /* CHECK ACCESS                  */
         LTR   R15,R15                                             1152
         BNZ   @RF01152                                            1152
*             PCCWPTR=CURRENT;      /* GET REQUESTED FIELD           */
         MVC   PCCWPTR(4),CURRENT(R14)                             1153
*           ELSE                    /* ACCESS NO GOOD                */
*             PCCWPTR=ZERO;         /* ZERO FIELD                    */
         B     @RC01152                                            1154
@RF01152 SLR   @12,@12                                             1154
         ST    @12,PCCWPTR                                         1154
*           RFY                                                    1155
*            (R0,                                                  1155
*             R1,                                                  1155
*             R14,                                                 1155
*             R15) UNRSTD;                                         1155
@RC01152 DS    0H                                                  1156
*         END;                                                     1156
*         RFY                                                      1157
*           R15 RSTD;                                              1157
*         IORRC=IORRC|R15;                                         1158
         OR    IORRC,R15                                           1158
*         RFY                                                      1159
*           R15 UNRSTD;                                            1159
*         IF PCCWPTR^=NULLPTR THEN  /* ACCESS SUCCESSFUL             */
         L     @12,PCCWPTR                                         1160
         LTR   @12,@12                                             1160
         BZ    @RF01160                                            1160
*           DO;                                                    1161
*             IF IORBSWAP='1'B THEN /* IS THIS A SWAP IORB CALLED  1162
*                                      FROM SWAP SEGMENT             */
         TM    IORBSWAP,B'00001000'                                1162
         BNO   @RF01162                                            1162
*               DO;                                                1163
*                 SCCWPTR=PCCWPTR;  /* SET PTR FOR FMTSCCW           */
         ST    @12,SCCWPTR                                         1164
*                 ANCHTXT=ANCH;     /* GET HEADER LABEL              */
         L     @12,ABDPLPTR                                        1165
         L     @12,ADPLBUF(,@12)                                   1165
         MVC   ANCHTXT(11,@12),ANCH                                1165
*                 ANCHNAME=ANCHSCW2;/* GET ANCHOR NAME               */
         MVC   ANCHNAME(8,@12),ANCHSCW2                            1166
*                 CALL FMTSCCW;     /* CALL SEGMENT TO FMT SCCW Q    */
         BAL   @14,FMTSCCW                                         1167
*               END;                                               1168
*             ELSE                  /* CALLED FROM PAGE SEGMENT      */
*               DO;                                                1169
         B     @RC01162                                            1169
@RF01162 DS    0H                                                  1170
*                 CALL FMTPCCW;     /* CALL SEGMENT TO FMT PCCWQ     */
         BAL   @14,FMTPCCW                                         1170
*               END;                                               1171
*             RFY                                                  1172
*               R15 RSTD;                                          1172
@RC01162 DS    0H                                                  1173
*             IORRC=IORRC|R15;      /* SAVE THE RETURN CODE          */
         OR    IORRC,R15                                           1173
*             RFY                                                  1174
*               R15 UNRSTD;                                        1174
*           END;                    /* END PCCW/SCCW PROCESSING      */
*         DO;                       /* ILRMACCS (IORBPTR)          1176
*                                      FROM(IORIORB)                 */
@RF01160 DS    0H                                                  1177
*           RFY                                                    1177
*            (R0,                                                  1177
*             R1,                                                  1177
*             R14,                                                 1177
*             R15) RSTD;                                           1177
*           R0=ADDR(IORIORB);                                      1178
         L     @12,IORBPTR                                         1178
         LA    R0,IORIORB(,@12)                                    1178
*           R1=ABDPLPTR;            /* POINT TO PARM LIST            */
         L     @12,ABDPLPTR                                        1179
         LR    R1,@12                                              1179
*           CALL ACCESS;            /* ACCESS DATA                   */
         L     @15,ADPLMEMA(,@12)                                  1180
         BALR  @14,@15                                             1180
*           R14=R0;                 /* CANNOT USE R0 AS BASE         */
         LR    R14,R0                                              1181
*           IF R15=GOOD THEN        /* CHECK ACCESS                  */
         LTR   R15,R15                                             1182
         BNZ   @RF01182                                            1182
*             IORBPTR=CURRENT;      /* GET REQUESTED FIELD           */
         MVC   IORBPTR(4),CURRENT(R14)                             1183
*           ELSE                    /* ACCESS NO GOOD                */
*             IORBPTR=ZERO;         /* ZERO FIELD                    */
         B     @RC01182                                            1184
@RF01182 SLR   @12,@12                                             1184
         ST    @12,IORBPTR                                         1184
*           RFY                                                    1185
*            (R0,                                                  1185
*             R1,                                                  1185
*             R14,                                                 1185
*             R15) UNRSTD;                                         1185
@RC01182 DS    0H                                                  1186
*         END;                      /* GET NEXT IORB ADDR            */
*         RFY                                                      1187
*           R15 RSTD;                                              1187
*         IORRC=IORRC|R15;          /* SAVE THE RETURN CODE          */
         OR    IORRC,R15                                           1188
*         RFY                                                      1189
*           R15 UNRSTD;                                            1189
*       END;                                                       1190
*     ELSE                                                         1191
*       DO;                                                        1191
         B     @RC01062                                            1191
@RF01062 DS    0H                                                  1192
*         IORRC=4;                  /* SET A BAD RETURN CODE         */
         LA    IORRC,4                                             1192
*         IORBPTR=0;                /* ZERO PTR TO TERMINATE LOOP    */
         SLR   @12,@12                                             1193
         ST    @12,IORBPTR                                         1193
*       END;                                                       1194
*   END;                            /* END IORB PROCESSING           */
@RC01062 DS    0H                                                  1195
@DE01042 ICM   @12,15,IORBPTR                                      1195
         BZ    @DC01042                                            1195
         L     @12,IORCTR                                          1195
         C     @12,MAXIORBS                                        1195
         BL    @DL01042                                            1195
@DC01042 DS    0H                                                  1196
*   IF IORBPTR^=NULLPTR THEN        /* MAX WAS EXCEEDED              */
         ICM   @12,15,IORBPTR                                      1196
         BZ    @RF01196                                            1196
*     DO;                                                          1197
*       IORRC=4;                    /* SET THE BAD RETURN CODE       */
         LA    IORRC,4                                             1198
*       RFY                                                        1199
*         R1 RSTD;                                                 1199
*       R1=15;                      /* CODE OF ERROR MESSAGE         */
         LA    R1,15                                               1200
*       RFY                                                        1201
*         R1 UNRSTD;                                               1201
*       CALL ILRFMSG;               /* GO TO MESSAGE SEGMENT         */
         L     @15,@CV00674                                        1202
         BALR  @14,@15                                             1202
*     END;                                                         1203
*   RFY                                                            1204
*    (R14,                                                         1204
*     R15) RSTD;                                                   1204
@RF01196 DS    0H                                                  1205
*   R15=IORRC;                      /* PUT RETURN CODE IN REG 15     */
         LR    R15,IORRC                                           1205
*   R14=RTNADDR2;                   /* RESTORE RETURN ADDRESS        */
         L     R14,RTNADDR2                                        1206
*   RFY                                                            1207
*    (R14,                                                         1207
*     R15) UNRSTD;                                                 1207
*   END FMTIORB;                    /* RETURN TO CALLER              */
@EL00008 DS    0H                                                  1208
@EF00008 DS    0H                                                  1208
@ER00008 BR    @14                                                 1208
*                                                                  1209
*/********************************************************************/
*/*                                                                  */
*/* FMTIOSB: SEGMENT TO FORMAT IOSB                                  */
*/*                                                                  */
*/* INPUT:   VIRTUAL ADDRESS IN IOSBPTR                              */
*/*                                                                  */
*/* PROCESS: FORMAT IOSB WITH OFFSETS                                */
*/*                                                                  */
*/* OUTPUT:  RETURN CODE = 0 IF FORMAT WAS SUCCESSFUL                */
*/*           OTHERWISE, RETURN CODE > ZERO                          */
*/*                                                                  */
*/********************************************************************/
*                                                                  1209
*FMTIOSB:                                                          1209
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1209
FMTIOSB  DS    0H                                                  1210
*                                                                  1210
*   /*****************************************************************/
*   /*                                                               */
*   /* IOS1: (FLA,FLB,FLC,PROC,DVRID,PRLVL) LABEL VARIABLES          */
*   /* REFERENCED IN FMT PTTRNS                                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1210
*   DCL                                                            1210
*     IOS1LB1 CHAR(LENGTH('+  0')) INIT('+  0');                   1210
*   DCL                                                            1211
*     IOS1LB2 CHAR(LENGTH('FLA')) INIT('FLA');                     1211
*   DCL                                                            1212
*     IOS1LB3 CHAR(LENGTH('FLB')) INIT('FLB');                     1212
*   DCL                                                            1213
*     IOS1LB4 CHAR(LENGTH('FLC')) INIT('FLC');                     1213
*   DCL                                                            1214
*     IOS1LB5 CHAR(LENGTH('PROC')) INIT('PROC');                   1214
*   DCL                                                            1215
*     IOS1LB6 CHAR(LENGTH('DVRID')) INIT('DVRID');                 1215
*   DCL                                                            1216
*     IOS1LB7 CHAR(LENGTH('PRLVL')) INIT('PRLVL');                 1216
*                                                                  1217
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT PATTERNS FOR ONE LINE OF OUTPUT (HAND CODED)           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1217
*   DCL                                                            1217
*     1 IOS1PTS BDY(WORD),          /* FORMAT PATTERNS - SEE PTTRNS  */
*      2 * CHAR(8) BDY(WORD),                                      1217
*       3 * BIT(8) BDY(BYTE) INIT('00000011'B),                    1217
*       3 * FIXED(8) INIT(16*LENGTH('+  0')-16),                   1217
*       3 * FIXED(8) INIT(0),                                      1217
*       3 * FIXED(8) INIT(0),                                      1217
*       3 * PTR(31) INIT(ADDR(IOS1LB1)),                           1217
*      2 * CHAR(12) BDY(WORD),                                     1217
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),                    1217
*       3 * FIXED(8) INIT(LENGTH(IOSFLA)-1+16*LENGTH('FLA')-16),   1217
*       3 * FIXED(8) INIT(5),                                      1217
*       3 * FIXED(8) INIT(11),                                     1217
*       3 * PTR(31) INIT(ADDR(IOS1LB2)),                           1217
*       3 IOS1DT2 PTR(31),                                         1217
*      2 * CHAR(8) BDY(WORD),                                      1217
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1217
*       3 * FIXED(8) INIT(LENGTH(IOSFLB)-1+16*LENGTH('FLB')-16),   1217
*       3 * FIXED(8) INIT(23),                                     1217
*       3 * FIXED(8) INIT(29),                                     1217
*       3 * PTR(31) INIT(ADDR(IOS1LB3)),                           1217
*      2 * CHAR(8) BDY(WORD),                                      1217
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1217
*       3 * FIXED(8) INIT(LENGTH(IOSFLC)-1+16*LENGTH('FLC')-16),   1217
*       3 * FIXED(8) INIT(41),                                     1217
*       3 * FIXED(8) INIT(47),                                     1217
*       3 * PTR(31) INIT(ADDR(IOS1LB4)),                           1217
*      2 * CHAR(8) BDY(WORD),                                      1217
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1217
*       3 * FIXED(8) INIT(LENGTH(IOSPROC)-1+16*LENGTH('PROC')-16), 1217
*       3 * FIXED(8) INIT(59),                                     1217
*       3 * FIXED(8) INIT(65),                                     1217
*       3 * PTR(31) INIT(ADDR(IOS1LB5)),                           1217
*      2 * CHAR(8) BDY(WORD),                                      1217
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1217
*       3 * FIXED(8) INIT(LENGTH(IOSDVRID)-1+16*LENGTH('DVRID')-16),
*       3 * FIXED(8) INIT(77),                                     1217
*       3 * FIXED(8) INIT(83),                                     1217
*       3 * PTR(31) INIT(ADDR(IOS1LB6)),                           1217
*      2 * CHAR(8) BDY(WORD),                                      1217
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1217
*       3 * FIXED(8) INIT(LENGTH(IOSPRLVL)-1+16*LENGTH('PRLVL')-16),
*       3 * FIXED(8) INIT(95),                                     1217
*       3 * FIXED(8) INIT(101),                                    1217
*       3 * PTR(31) INIT(ADDR(IOS1LB7)),                           1217
*      2 * FIXED(31) INIT(0);                                      1217
*                                                                  1218
*   /*****************************************************************/
*   /*                                                               */
*   /* IOS2: (ASID,PGAD,PKEY,COD,OPT,OPT2) LABEL VARIABLES REFERENCED*/
*   /* IN FMT PTTRNS                                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1218
*   DCL                                                            1218
*     IOS2LB1 CHAR(LENGTH('+  6')) INIT('+  6');                   1218
*   DCL                                                            1219
*     IOS2LB2 CHAR(LENGTH('ASID')) INIT('ASID');                   1219
*   DCL                                                            1220
*     IOS2LB3 CHAR(LENGTH('PGAD')) INIT('PGAD');                   1220
*   DCL                                                            1221
*     IOS2LB4 CHAR(LENGTH('PKEY')) INIT('PKEY');                   1221
*   DCL                                                            1222
*     IOS2LB5 CHAR(LENGTH('COD')) INIT('COD');                     1222
*   DCL                                                            1223
*     IOS2LB6 CHAR(LENGTH('OPT')) INIT('OPT');                     1223
*   DCL                                                            1224
*     IOS2LB7 CHAR(LENGTH('OPT2')) INIT('OPT2');                   1224
*                                                                  1225
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT PATTERNS FOR ONE LINE OF OUTPUT (HAND CODED)           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1225
*   DCL                                                            1225
*     1 IOS2PTS BDY(WORD),          /* FORMAT PATTERNS - SEE PTTRNS  */
*      2 * CHAR(8) BDY(WORD),                                      1225
*       3 * BIT(8) BDY(BYTE) INIT('00000011'B),                    1225
*       3 * FIXED(8) INIT(16*LENGTH('+  6')-16),                   1225
*       3 * FIXED(8) INIT(0),                                      1225
*       3 * FIXED(8) INIT(0),                                      1225
*       3 * PTR(31) INIT(ADDR(IOS2LB1)),                           1225
*      2 * CHAR(8) BDY(WORD),                                      1225
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1225
*       3 * FIXED(8) INIT(LENGTH(IOSASID)-1+16*LENGTH('ASID')-16), 1225
*       3 * FIXED(8) INIT(5),                                      1225
*       3 * FIXED(8) INIT(11),                                     1225
*       3 * PTR(31) INIT(ADDR(IOS2LB2)),                           1225
*      2 * CHAR(8) BDY(WORD),                                      1225
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1225
*       3 * FIXED(8) INIT(LENGTH(IOSPGAD)-1+16*LENGTH('PGAD')-16), 1225
*       3 * FIXED(8) INIT(23),                                     1225
*       3 * FIXED(8) INIT(29),                                     1225
*       3 * PTR(31) INIT(ADDR(IOS2LB3)),                           1225
*      2 * CHAR(8) BDY(WORD),                                      1225
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1225
*       3 * FIXED(8) INIT(LENGTH(IOSPKEY)/8-1+16*LENGTH('PKEY')-16),
*       3 * FIXED(8) INIT(41),                                     1225
*       3 * FIXED(8) INIT(47),                                     1225
*       3 * PTR(31) INIT(ADDR(IOS2LB4)),                           1225
*      2 * CHAR(8) BDY(WORD),                                      1225
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1225
*       3 * FIXED(8) INIT(LENGTH(IOSCOD)-1+16*LENGTH('COD')-16),   1225
*       3 * FIXED(8) INIT(59),                                     1225
*       3 * FIXED(8) INIT(65),                                     1225
*       3 * PTR(31) INIT(ADDR(IOS2LB5)),                           1225
*      2 * CHAR(8) BDY(WORD),                                      1225
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1225
*       3 * FIXED(8) INIT(LENGTH(IOSOPT)-1+16*LENGTH('OPT')-16),   1225
*       3 * FIXED(8) INIT(77),                                     1225
*       3 * FIXED(8) INIT(83),                                     1225
*       3 * PTR(31) INIT(ADDR(IOS2LB6)),                           1225
*      2 * CHAR(8) BDY(WORD),                                      1225
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1225
*       3 * FIXED(8) INIT(LENGTH(IOSOPT2)-1+16*LENGTH('OPT2')-16), 1225
*       3 * FIXED(8) INIT(95),                                     1225
*       3 * FIXED(8) INIT(101),                                    1225
*       3 * PTR(31) INIT(ADDR(IOS2LB7)),                           1225
*      2 * FIXED(31) INIT(0);                                      1225
*                                                                  1226
*   /*****************************************************************/
*   /*                                                               */
*   /* IOS3: (UCB,(CC,,BIT),CSWCA,TATUS,CSWRC,SRB) LABEL VARIABLES   */
*   /* REFERENCED IN FMT PTTRNS                                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1226
*   DCL                                                            1226
*     IOS3LB1 CHAR(LENGTH('+ 10')) INIT('+ 10');                   1226
*   DCL                                                            1227
*     IOS3LB2 CHAR(LENGTH('UCB')) INIT('UCB');                     1227
*   DCL                                                            1228
*     IOS3LB3 CHAR(LENGTH('CC')) INIT('CC');                       1228
*   DCL                                                            1229
*     IOS3LB4 CHAR(LENGTH('CSWCA')) INIT('CSWCA');                 1229
*   DCL                                                            1230
*     IOS3LB5 CHAR(LENGTH('STATUS')) INIT('STATUS');               1230
*   DCL                                                            1231
*     IOS3LB6 CHAR(LENGTH('CSWRC')) INIT('CSWRC');                 1231
*   DCL                                                            1232
*     IOS3LB7 CHAR(LENGTH('SRB')) INIT('SRB');                     1232
*                                                                  1233
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT PATTERNS FOR ONE LINE OF OUTPUT (HAND CODED)           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1233
*   DCL                                                            1233
*     1 IOS3PTS BDY(WORD),          /* FORMAT PATTERNS - SEE PTTRNS  */
*      2 * CHAR(8) BDY(WORD),                                      1233
*       3 * BIT(8) BDY(BYTE) INIT('00000011'B),                    1233
*       3 * FIXED(8) INIT(16*LENGTH('+ 10')-16),                   1233
*       3 * FIXED(8) INIT(0),                                      1233
*       3 * FIXED(8) INIT(0),                                      1233
*       3 * PTR(31) INIT(ADDR(IOS3LB1)),                           1233
*      2 * CHAR(8) BDY(WORD),                                      1233
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1233
*       3 * FIXED(8) INIT(LENGTH(IOSUCB)-1+16*LENGTH('UCB')-16),   1233
*       3 * FIXED(8) INIT(5),                                      1233
*       3 * FIXED(8) INIT(11),                                     1233
*       3 * PTR(31) INIT(ADDR(IOS3LB2)),                           1233
*      2 * CHAR(8) BDY(WORD),                                      1233
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1233
*       3 * FIXED(8) INIT(LENGTH(IOSCC)/8-1+16*LENGTH('CC')-16),   1233
*       3 * FIXED(8) INIT(23),                                     1233
*       3 * FIXED(8) INIT(29),                                     1233
*       3 * PTR(31) INIT(ADDR(IOS3LB3)),                           1233
*      2 * CHAR(8) BDY(WORD),                                      1233
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1233
*       3 * FIXED(8) INIT(LENGTH(IOSCSWCA)-1+16*LENGTH('CSWCA')-16),
*       3 * FIXED(8) INIT(41),                                     1233
*       3 * FIXED(8) INIT(47),                                     1233
*       3 * PTR(31) INIT(ADDR(IOS3LB4)),                           1233
*      2 * CHAR(8) BDY(WORD),                                      1233
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1233
*       3 * FIXED(8) INIT(LENGTH(IOSTATUS)-1+16*LENGTH('STATUS')-16),
*       3 * FIXED(8) INIT(59),                                     1233
*       3 * FIXED(8) INIT(66),                                     1233
*       3 * PTR(31) INIT(ADDR(IOS3LB5)),                           1233
*      2 * CHAR(8) BDY(WORD),                                      1233
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1233
*       3 * FIXED(8) INIT(LENGTH(IOSCSWRC)-1+16*LENGTH('CSWRC')-16),
*       3 * FIXED(8) INIT(77),                                     1233
*       3 * FIXED(8) INIT(83),                                     1233
*       3 * PTR(31) INIT(ADDR(IOS3LB6)),                           1233
*      2 * CHAR(8) BDY(WORD),                                      1233
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1233
*       3 * FIXED(8) INIT(LENGTH(IOSSRB)-1+16*LENGTH('SRB')-16),   1233
*       3 * FIXED(8) INIT(95),                                     1233
*       3 * FIXED(8) INIT(101),                                    1233
*       3 * PTR(31) INIT(ADDR(IOS3LB7)),                           1233
*      2 * FIXED(31) INIT(0);                                      1233
*                                                                  1234
*   /*****************************************************************/
*   /*                                                               */
*   /* IOS4: (USE,RES4A,APMSK,(SNS,,BIT),IPIB,PCHN) LABEL VARIABLES  */
*   /* REFERENCED IN FMT PTTRNS                                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1234
*   DCL                                                            1234
*     IOS4LB1 CHAR(LENGTH('+ 20')) INIT('+ 20');                   1234
*   DCL                                                            1235
*     IOS4LB2 CHAR(LENGTH('USE')) INIT('USE');                     1235
*   DCL                                                            1236
*     IOS4LB3 CHAR(LENGTH('RES4A')) INIT('RES4A');                 1236
*   DCL                                                            1237
*     IOS4LB4 CHAR(LENGTH('APMSK')) INIT('APMSK');                 1237
*   DCL                                                            1238
*     IOS4LB5 CHAR(LENGTH('SNS')) INIT('SNS');                     1238
*   DCL                                                            1239
*     IOS4LB6 CHAR(LENGTH('IPIB')) INIT('IPIB');                   1239
*   DCL                                                            1240
*     IOS4LB7 CHAR(LENGTH('PCHN')) INIT('PCHN');                   1240
*                                                                  1241
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT PATTERNS FOR ONE LINE OF OUTPUT (HAND CODED)           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1241
*   DCL                                                            1241
*     1 IOS4PTS BDY(WORD),          /* FORMAT PATTERNS - SEE PTTRNS  */
*      2 * CHAR(8) BDY(WORD),                                      1241
*       3 * BIT(8) BDY(BYTE) INIT('00000011'B),                    1241
*       3 * FIXED(8) INIT(16*LENGTH('+ 20')-16),                   1241
*       3 * FIXED(8) INIT(0),                                      1241
*       3 * FIXED(8) INIT(0),                                      1241
*       3 * PTR(31) INIT(ADDR(IOS4LB1)),                           1241
*      2 * CHAR(8) BDY(WORD),                                      1241
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1241
*       3 * FIXED(8) INIT(LENGTH(IOSUSE)-1+16*LENGTH('USE')-16),   1241
*       3 * FIXED(8) INIT(5),                                      1241
*       3 * FIXED(8) INIT(11),                                     1241
*       3 * PTR(31) INIT(ADDR(IOS4LB2)),                           1241
*      2 * CHAR(8) BDY(WORD),                                      1241
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1241
*       3 * FIXED(8) INIT(LENGTH(IOSRES4A)-1+16*LENGTH('RES4A')-16),
*       3 * FIXED(8) INIT(23),                                     1241
*       3 * FIXED(8) INIT(29),                                     1241
*       3 * PTR(31) INIT(ADDR(IOS4LB3)),                           1241
*      2 * CHAR(8) BDY(WORD),                                      1241
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1241
*       3 * FIXED(8) INIT(LENGTH(IOSAPMSK)-1+16*LENGTH('APMSK')-16),
*       3 * FIXED(8) INIT(41),                                     1241
*       3 * FIXED(8) INIT(47),                                     1241
*       3 * PTR(31) INIT(ADDR(IOS4LB4)),                           1241
*      2 * CHAR(8) BDY(WORD),                                      1241
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1241
*       3 * FIXED(8) INIT(LENGTH(IOSSNS)/8-1+16*LENGTH('SNS')-16), 1241
*       3 * FIXED(8) INIT(59),                                     1241
*       3 * FIXED(8) INIT(65),                                     1241
*       3 * PTR(31) INIT(ADDR(IOS4LB5)),                           1241
*      2 * CHAR(8) BDY(WORD),                                      1241
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1241
*       3 * FIXED(8) INIT(LENGTH(IOSIPIB)-1+16*LENGTH('IPIB')-16), 1241
*       3 * FIXED(8) INIT(77),                                     1241
*       3 * FIXED(8) INIT(83),                                     1241
*       3 * PTR(31) INIT(ADDR(IOS4LB6)),                           1241
*      2 * CHAR(8) BDY(WORD),                                      1241
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1241
*       3 * FIXED(8) INIT(LENGTH(IOSPCHN)-1+16*LENGTH('PCHN')-16), 1241
*       3 * FIXED(8) INIT(95),                                     1241
*       3 * FIXED(8) INIT(101),                                    1241
*       3 * PTR(31) INIT(ADDR(IOS4LB7)),                           1241
*      2 * FIXED(31) INIT(0);                                      1241
*                                                                  1242
*   /*****************************************************************/
*   /*                                                               */
*   /* IOS5: (ERP,PCI,NRM,DIE,RST) LABEL VARIABLES REFERENCED IN FMT */
*   /* PTTRNS                                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1242
*   DCL                                                            1242
*     IOS5LB1 CHAR(LENGTH('+ 34')) INIT('+ 34');                   1242
*   DCL                                                            1243
*     IOS5LB2 CHAR(LENGTH('ERP')) INIT('ERP');                     1243
*   DCL                                                            1244
*     IOS5LB3 CHAR(LENGTH('PCI')) INIT('PCI');                     1244
*   DCL                                                            1245
*     IOS5LB4 CHAR(LENGTH('NRM')) INIT('NRM');                     1245
*   DCL                                                            1246
*     IOS5LB5 CHAR(LENGTH('ABN')) INIT('ABN');                     1246
*   DCL                                                            1247
*     IOS5LB6 CHAR(LENGTH('DIE')) INIT('DIE');                     1247
*   DCL                                                            1248
*     IOS5LB7 CHAR(LENGTH('RST')) INIT('RST');                     1248
*                                                                  1249
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT PATTERNS FOR ONE LINE OF OUTPUT (HAND CODED)           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1249
*   DCL                                                            1249
*     1 IOS5PTS BDY(WORD),          /* FORMAT PATTERNS - SEE PTTRNS  */
*      2 * CHAR(8) BDY(WORD),                                      1249
*       3 * BIT(8) BDY(BYTE) INIT('00000011'B),                    1249
*       3 * FIXED(8) INIT(16*LENGTH('+ 34')-16),                   1249
*       3 * FIXED(8) INIT(0),                                      1249
*       3 * FIXED(8) INIT(0),                                      1249
*       3 * PTR(31) INIT(ADDR(IOS5LB1)),                           1249
*      2 * CHAR(8) BDY(WORD),                                      1249
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1249
*       3 * FIXED(8) INIT(LENGTH(IOSERP)-1+16*LENGTH('ERP')-16),   1249
*       3 * FIXED(8) INIT(5),                                      1249
*       3 * FIXED(8) INIT(11),                                     1249
*       3 * PTR(31) INIT(ADDR(IOS5LB2)),                           1249
*      2 * CHAR(8) BDY(WORD),                                      1249
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1249
*       3 * FIXED(8) INIT(LENGTH(IOSPCI)-1+16*LENGTH('PCI')-16),   1249
*       3 * FIXED(8) INIT(23),                                     1249
*       3 * FIXED(8) INIT(29),                                     1249
*       3 * PTR(31) INIT(ADDR(IOS5LB3)),                           1249
*      2 * CHAR(8) BDY(WORD),                                      1249
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1249
*       3 * FIXED(8) INIT(LENGTH(IOSNRM)-1+16*LENGTH('NRM')-16),   1249
*       3 * FIXED(8) INIT(41),                                     1249
*       3 * FIXED(8) INIT(47),                                     1249
*       3 * PTR(31) INIT(ADDR(IOS5LB4)),                           1249
*      2 * CHAR(8) BDY(WORD),                                      1249
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1249
*       3 * FIXED(8) INIT(LENGTH(IOSABN)-1+16*LENGTH('ABN')-16),   1249
*       3 * FIXED(8) INIT(59),                                     1249
*       3 * FIXED(8) INIT(65),                                     1249
*       3 * PTR(31) INIT(ADDR(IOS5LB5)),                           1249
*      2 * CHAR(8) BDY(WORD),                                      1249
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1249
*       3 * FIXED(8) INIT(LENGTH(IOSDIE)-1+16*LENGTH('DIE')-16),   1249
*       3 * FIXED(8) INIT(77),                                     1249
*       3 * FIXED(8) INIT(83),                                     1249
*       3 * PTR(31) INIT(ADDR(IOS5LB6)),                           1249
*      2 * CHAR(8) BDY(WORD),                                      1249
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1249
*       3 * FIXED(8) INIT(LENGTH(IOSRST)-1+16*LENGTH('RST')-16),   1249
*       3 * FIXED(8) INIT(95),                                     1249
*       3 * FIXED(8) INIT(101),                                    1249
*       3 * PTR(31) INIT(ADDR(IOS5LB7)),                           1249
*      2 * FIXED(31) INIT(0);                                      1249
*                                                                  1250
*   /*****************************************************************/
*   /*                                                               */
*   /* IOS6: (VST,DSID,RSS1B,(AFF,,BIT),PATH,FMSK) LABEL VARIABLES   */
*   /* REFERENCED IN FMT PTTRNS                                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1250
*   DCL                                                            1250
*     IOS6LB1 CHAR(LENGTH('+ 4C')) INIT('+ 4C');                   1250
*   DCL                                                            1251
*     IOS6LB2 CHAR(LENGTH('VST')) INIT('VST');                     1251
*   DCL                                                            1252
*     IOS6LB3 CHAR(LENGTH('DSID')) INIT('DSID');                   1252
*   DCL                                                            1253
*     IOS6LB4 CHAR(LENGTH('RSS1B')) INIT('RSS1B');                 1253
*   DCL                                                            1254
*     IOS6LB5 CHAR(LENGTH('AFF')) INIT('AFF');                     1254
*   DCL                                                            1255
*     IOS6LB6 CHAR(LENGTH('PATH')) INIT('PATH');                   1255
*   DCL                                                            1256
*     IOS6LB7 CHAR(LENGTH('FMSK')) INIT('FMSK');                   1256
*                                                                  1257
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT PATTERNS FOR ONE LINE OF OUTPUT (HAND CODED)           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1257
*   DCL                                                            1257
*     1 IOS6PTS BDY(WORD),          /* FORMAT PATTERNS - SEE PTTRNS  */
*      2 * CHAR(8) BDY(WORD),                                      1257
*       3 * BIT(8) BDY(BYTE) INIT('00000011'B),                    1257
*       3 * FIXED(8) INIT(16*LENGTH('+ 4C')-16),                   1257
*       3 * FIXED(8) INIT(0),                                      1257
*       3 * FIXED(8) INIT(0),                                      1257
*       3 * PTR(31) INIT(ADDR(IOS6LB1)),                           1257
*      2 * CHAR(8) BDY(WORD),                                      1257
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1257
*       3 * FIXED(8) INIT(LENGTH(IOSVST)-1+16*LENGTH('VST')-16),   1257
*       3 * FIXED(8) INIT(5),                                      1257
*       3 * FIXED(8) INIT(11),                                     1257
*       3 * PTR(31) INIT(ADDR(IOS6LB2)),                           1257
*      2 * CHAR(8) BDY(WORD),                                      1257
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1257
*       3 * FIXED(8) INIT(LENGTH(IOSDSID)-1+16*LENGTH('DSID')-16), 1257
*       3 * FIXED(8) INIT(23),                                     1257
*       3 * FIXED(8) INIT(29),                                     1257
*       3 * PTR(31) INIT(ADDR(IOS6LB3)),                           1257
*      2 * CHAR(8) BDY(WORD),                                      1257
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1257
*       3 * FIXED(8) INIT(LENGTH(IOSRSS1B)-1+16*LENGTH('RSS1B')-16),
*       3 * FIXED(8) INIT(41),                                     1257
*       3 * FIXED(8) INIT(47),                                     1257
*       3 * PTR(31) INIT(ADDR(IOS6LB4)),                           1257
*      2 * CHAR(8) BDY(WORD),                                      1257
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1257
*       3 * FIXED(8) INIT(LENGTH(IOSAFF)/8-1+16*LENGTH('AFF')-16), 1257
*       3 * FIXED(8) INIT(59),                                     1257
*       3 * FIXED(8) INIT(65),                                     1257
*       3 * PTR(31) INIT(ADDR(IOS6LB5)),                           1257
*      2 * CHAR(8) BDY(WORD),                                      1257
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1257
*       3 * FIXED(8) INIT(LENGTH(IOSPATH)-1+16*LENGTH('PATH')-16), 1257
*       3 * FIXED(8) INIT(77),                                     1257
*       3 * FIXED(8) INIT(83),                                     1257
*       3 * PTR(31) INIT(ADDR(IOS6LB6)),                           1257
*      2 * CHAR(8) BDY(WORD),                                      1257
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1257
*       3 * FIXED(8) INIT(LENGTH(IOSFMSK)-1+16*LENGTH('FMSK')-16), 1257
*       3 * FIXED(8) INIT(95),                                     1257
*       3 * FIXED(8) INIT(101),                                    1257
*       3 * PTR(31) INIT(ADDR(IOS6LB7)),                           1257
*      2 * FIXED(31) INIT(0);                                      1257
*                                                                  1258
*   /*****************************************************************/
*   /*                                                               */
*   /* IOS7: ((CKEY,,BIT),MDB,MDM) LABEL VARIABLES REFERENCED IN FMT */
*   /* PTTRNS                                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1258
*   DCL                                                            1258
*     IOS7LB1 CHAR(LENGTH('+ 59')) INIT('+ 59');                   1258
*   DCL                                                            1259
*     IOS7LB2 CHAR(LENGTH('CKEY')) INIT('CKEY');                   1259
*   DCL                                                            1260
*     IOS7LB3 CHAR(LENGTH('MDB')) INIT('MDB');                     1260
*   DCL                                                            1261
*     IOS7LB4 CHAR(LENGTH('MDM')) INIT('MDM');                     1261
*                                                                  1262
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT PATTERNS FOR ONE LINE OF OUTPUT (HAND CODED)           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1262
*   DCL                                                            1262
*     1 IOS7PTS BDY(WORD),          /* FORMAT PATTERNS - SEE PTTRNS  */
*      2 * CHAR(8) BDY(WORD),                                      1262
*       3 * BIT(8) BDY(BYTE) INIT('00000011'B),                    1262
*       3 * FIXED(8) INIT(16*LENGTH('+ 59')-16),                   1262
*       3 * FIXED(8) INIT(0),                                      1262
*       3 * FIXED(8) INIT(0),                                      1262
*       3 * PTR(31) INIT(ADDR(IOS7LB1)),                           1262
*      2 * CHAR(8) BDY(WORD),                                      1262
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1262
*       3 * FIXED(8) INIT(LENGTH(IOSCKEY)/8-1+16*LENGTH('CKEY')-16),
*       3 * FIXED(8) INIT(5),                                      1262
*       3 * FIXED(8) INIT(11),                                     1262
*       3 * PTR(31) INIT(ADDR(IOS7LB2)),                           1262
*      2 * CHAR(8) BDY(WORD),                                      1262
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1262
*       3 * FIXED(8) INIT(LENGTH(IOSMDB)-1+16*LENGTH('MDB')-16),   1262
*       3 * FIXED(8) INIT(23),                                     1262
*       3 * FIXED(8) INIT(29),                                     1262
*       3 * PTR(31) INIT(ADDR(IOS7LB3)),                           1262
*      2 * CHAR(8) BDY(WORD),                                      1262
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1262
*       3 * FIXED(8) INIT(LENGTH(IOSMDM)-1+16*LENGTH('MDM')-16),   1262
*       3 * FIXED(8) INIT(41),                                     1262
*       3 * FIXED(8) INIT(47),                                     1262
*       3 * PTR(31) INIT(ADDR(IOS7LB4)),                           1262
*      2 * FIXED(31) INIT(0);                                      1262
*                                                                  1263
*   /*****************************************************************/
*   /*                                                               */
*   /* IOS8: (SKM,SKBB,SKCC,SKHH,SKR) LABEL VARIABLES REFERENCED IN  */
*   /* FMT PTTRNS                                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1263
*   DCL                                                            1263
*     IOS8LB1 CHAR(LENGTH('+ 64')) INIT('+ 64');                   1263
*   DCL                                                            1264
*     IOS8LB2 CHAR(LENGTH('SKM')) INIT('SKM');                     1264
*   DCL                                                            1265
*     IOS8LB3 CHAR(LENGTH('SKBB')) INIT('SKBB');                   1265
*   DCL                                                            1266
*     IOS8LB4 CHAR(LENGTH('SKCC')) INIT('SKCC');                   1266
*   DCL                                                            1267
*     IOS8LB5 CHAR(LENGTH('SKHH')) INIT('SKHH');                   1267
*   DCL                                                            1268
*     IOS8LB6 CHAR(LENGTH('SKR')) INIT('SKR');                     1268
*                                                                  1269
*   /*****************************************************************/
*   /*                                                               */
*   /* FORMAT PATTERNS FOR ONE LINE OF OUTPUT (HAND CODED)           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1269
*   DCL                                                            1269
*     1 IOS8PTS BDY(WORD),          /* FORMAT PATTERNS - SEE PTTRNS  */
*      2 * CHAR(8) BDY(WORD),                                      1269
*       3 * BIT(8) BDY(BYTE) INIT('00000011'B),                    1269
*       3 * FIXED(8) INIT(16*LENGTH('+ 64')-16),                   1269
*       3 * FIXED(8) INIT(0),                                      1269
*       3 * FIXED(8) INIT(0),                                      1269
*       3 * PTR(31) INIT(ADDR(IOS8LB1)),                           1269
*      2 * CHAR(12) BDY(WORD),                                     1269
*       3 * BIT(8) BDY(BYTE) INIT('00001111'B),                    1269
*       3 * FIXED(8) INIT(LENGTH(IOSSKM)-1+16*LENGTH('SKM')-16),   1269
*       3 * FIXED(8) INIT(5),                                      1269
*       3 * FIXED(8) INIT(11),                                     1269
*       3 * PTR(31) INIT(ADDR(IOS8LB2)),                           1269
*       3 IOS8DT2 PTR(31) INIT(0),                                 1269
*      2 * CHAR(8) BDY(WORD),                                      1269
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1269
*       3 * FIXED(8) INIT(LENGTH(IOSSKBB)-1+16*LENGTH('SKBB')-16), 1269
*       3 * FIXED(8) INIT(23),                                     1269
*       3 * FIXED(8) INIT(29),                                     1269
*       3 * PTR(31) INIT(ADDR(IOS8LB3)),                           1269
*      2 * CHAR(8) BDY(WORD),                                      1269
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1269
*       3 * FIXED(8) INIT(LENGTH(IOSSKCC)-1+16*LENGTH('SKCC')-16), 1269
*       3 * FIXED(8) INIT(41),                                     1269
*       3 * FIXED(8) INIT(47),                                     1269
*       3 * PTR(31) INIT(ADDR(IOS8LB4)),                           1269
*      2 * CHAR(8) BDY(WORD),                                      1269
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1269
*       3 * FIXED(8) INIT(LENGTH(IOSSKHH)-1+16*LENGTH('SKHH')-16), 1269
*       3 * FIXED(8) INIT(59),                                     1269
*       3 * FIXED(8) INIT(65),                                     1269
*       3 * PTR(31) INIT(ADDR(IOS8LB5)),                           1269
*      2 * CHAR(8) BDY(WORD),                                      1269
*       3 * BIT(8) BDY(BYTE) INIT('00000111'B),                    1269
*       3 * FIXED(8) INIT(LENGTH(IOSSKR)-1+16*LENGTH('SKR')-16),   1269
*       3 * FIXED(8) INIT(77),                                     1269
*       3 * FIXED(8) INIT(83),                                     1269
*       3 * PTR(31) INIT(ADDR(IOS8LB6)),                           1269
*      2 * FIXED(31) INIT(0);                                      1269
*   RFY                                                            1270
*     R14 RSTD;                                                    1270
*   RTNADDR3=R14;                   /* SAVE RETURN ADDRESS           */
         LR    RTNADDR3,R14                                        1271
*   RFY                                                            1272
*     R14 UNRSTD;                                                  1272
*   IOSRC=0;                        /* ZERO THE RETURN CODE          */
         SLR   IOSRC,IOSRC                                         1273
*   ANCHTXT=ANCH;                   /* SET UP HEADER                 */
         L     @12,ABDPLPTR                                        1274
         L     @12,ADPLBUF(,@12)                                   1274
         MVC   ANCHTXT(11,@12),ANCH                                1274
*   ANCHNAME=ANCHIOSB;              /* PUT IN BLOCK NAME             */
         MVC   ANCHNAME(8,@12),ANCHIOSB                            1275
*   RFY                                                            1276
*    (R0,                                                          1276
*     R1) RSTD;                                                    1276
*   R0=ADDR(IOSBPTR);               /* NAME OF CONTROL BLOCK         */
         LA    R0,IOSBPTR                                          1277
*   R1=ADDR(IOSBNAM);               /* NAME OF CONTROL BLOCK         */
         LA    R1,IOSBNAM                                          1278
*   RFY                                                            1279
*    (R0,                                                          1279
*     R1) UNRSTD;                                                  1279
*   CALL ILRFPRTH;                  /* GO PUT OUT THE HEADER         */
*                                                                  1280
         L     @15,@CV00676                                        1280
         BALR  @14,@15                                             1280
*   /*****************************************************************/
*   /*                                                               */
*   /* INITIALIZE THE FORMAT PATTERNS                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1281
*   IOS1DT2=ADDR(IOSFLA);                                          1281
         MVC   IOS1DT2(4),IOSBPTR                                  1281
*   DO I=1 TO 7;                    /* LOOP TO PRINT THE IOSB LINES  */
         LA    I,1                                                 1282
@DL01282 DS    0H                                                  1283
*     RFY                                                          1283
*      (R0,                                                        1283
*       R1) RSTD;                                                  1283
*     R0=ADDRTAB(I);                /* PICK UP ADDR OF FORMAT PATTERN*/
         LR    @06,I                                               1284
         SLA   @06,2                                               1284
         L     R0,ADDRTAB-4(@06)                                   1284
*     R1=ABDPLPTR;                                                 1285
         L     @06,ABDPLPTR                                        1285
         LR    R1,@06                                              1285
*     CALL FORMAT;                                                 1286
         L     @15,ADPLFRMT(,@06)                                  1286
         BALR  @14,@15                                             1286
*     RFY                                                          1287
*       R15 RSTD;                                                  1287
*     IOSRC=IOSRC|R15;              /* SAVE THE RETURN CODE          */
         OR    IOSRC,R15                                           1288
*     RFY                                                          1289
*       R15 UNRSTD;                                                1289
*     CALL PRINT;                                                  1290
         L     @06,ABDPLPTR                                        1290
         L     @15,ADPLPRNT(,@06)                                  1290
         BALR  @14,@15                                             1290
*     RFY                                                          1291
*      (R0,                                                        1291
*       R1) UNRSTD;                                                1291
*   END;                                                           1292
         AH    I,@CH00041                                          1292
         CH    I,@CH00302                                          1292
         BNH   @DL01282                                            1292
*   IOS8DT2=ADDR(IOSSKM);                                          1293
         L     @12,IOSBPTR                                         1293
         LA    @12,IOSSKM(,@12)                                    1293
         ST    @12,IOS8DT2                                         1293
*   RFY                                                            1294
*    (R0,                                                          1294
*     R1) RSTD;                                                    1294
*   R0=ADDR(IOS8PTS);                                              1295
         LA    R0,IOS8PTS                                          1295
*   R1=ABDPLPTR;                                                   1296
         L     @12,ABDPLPTR                                        1296
         LR    R1,@12                                              1296
*   CALL FORMAT;                                                   1297
         L     @15,ADPLFRMT(,@12)                                  1297
         BALR  @14,@15                                             1297
*   RFY                                                            1298
*     R15 RSTD;                                                    1298
*   IOSRC=IOSRC|R15;                /* SAVE THE RETURN CODE          */
         OR    IOSRC,R15                                           1299
*   RFY                                                            1300
*     R15 UNRSTD;                                                  1300
*   CALL PRINT;                                                    1301
         L     @12,ABDPLPTR                                        1301
         L     @15,ADPLPRNT(,@12)                                  1301
         BALR  @14,@15                                             1301
*   CALL PRINT;                                                    1302
         L     @12,ABDPLPTR                                        1302
         L     @15,ADPLPRNT(,@12)                                  1302
         BALR  @14,@15                                             1302
*   RFY                                                            1303
*    (R0,                                                          1303
*     R1) UNRSTD;                                                  1303
*   RFY                                                            1304
*    (R14,                                                         1304
*     R15) RSTD;                                                   1304
*   R15=IOSRC;                      /* PUT THE RETURN CODE IN R 15   */
         LR    R15,IOSRC                                           1305
*   R14=RTNADDR3;                   /* RESTORE RETURN ADDRESS        */
         LR    R14,RTNADDR3                                        1306
*   RFY                                                            1307
*    (R14,                                                         1307
*     R15) UNRSTD;                                                 1307
*   END FMTIOSB;                    /* RETURN TO CALLER              */
@EL00009 DS    0H                                                  1308
@EF00009 DS    0H                                                  1308
@ER00009 BR    @14                                                 1308
*   END ILRFMTSW                                                   1309
*                                                                  1309
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IHAABDPL)                                       */
*/*%INCLUDE SYSLIB  (ILRASMVT)                                       */
*/*%INCLUDE SYSLIB  (ILRIORB )                                       */
*/*%INCLUDE SYSLIB  (IECDIOSB)                                       */
*/*%INCLUDE SYSLIB  (ILRPCCW )                                       */
*/*%INCLUDE SYSLIB  (ILRSART )                                       */
*/*%INCLUDE SYSLIB  (ILRSAT  )                                       */
*/*%INCLUDE SYSLIB  (ILRSCCW )                                       */
*/*%INCLUDE SYSLIB  (ILRSDCT )                                       */
*                                                                  1309
*       ;                                                          1309
@EL00001 L     @13,4(,@13)                                         1309
@EF00001 DS    0H                                                  1309
@ER00001 LM    @14,@12,12(@13)                                     1309
         BR    @14                                                 1309
@DATA    DS    0H
@CH00041 DC    H'1'
@CH00302 DC    H'7'
@CH00062 DC    H'8'
@CH00591 DC    H'12'
@CH00184 DC    H'20'
@CH00154 DC    H'24'
@CH00787 DC    H'44'
         DS    0F
@SA00001 DS    18F
         DS    0F
@CF00136 DC    F'32'
@CF01731 DC    F'150'
@CV00674 DC    V(ILRFMSG)
@CV00675 DC    V(ILRFAIA)
@CV00676 DC    V(ILRFPRTH)
@CV00673 DC    V(ILRFIORB)
         DS    0D
ASMVTPTR DS    A
IOSBPTR  DS    A
PCCWPTR  DS    A
SARTPTR  DS    A
SAREPTR  DS    A
SATPTR   DS    A
SCCWPTR  DS    A
SDCTPTR  DS    A
RTNADDR1 DS    F
RTNADDR2 DS    F
CTR      DC    F'0'
SARTERC  DS    F
DSNPTR   DS    A
ENTRYCNT DC    F'0'
IORBTYPE DC    F'0'
J        DS    F
MAPSIZE  DC    F'0'
MAXCTR   DC    F'0'
IORCTR   DS    F
MAXIORBS DC    F'4'
MAXNUM   DC    F'0'
MAXPCCWS DC    F'0'
MAXSCCWS DC    F'10'
NUMSARTE DC    F'0'
PTRS     DS    CL8
         ORG   PTRS
ABDPLPTR DS    AL4
IORBPTR  DS    AL4
         ORG   PTRS+8
ANCH     DC    CL11'ANCHORED IN'
ANCHAIA4 DC    CL8'SARWAITQ'
ANCHAIA5 DC    CL8'SCCWAIA'
ANCHAIA6 DC    CL8'PCCWAIA'
ANCHPCCW DC    CL8'IORPCCW'
ANCHSAT  DC    CL8'SRESAT'
ANCHIOR2 DC    CL8'SREIORB'
ANCHIOSB DC    CL8'IORIOSB'
ANCHSART DC    CL8'ASMSART'
ANCHSCW1 DC    CL8'SRESCCW'
ANCHSCW2 DC    CL8'IORSCCW'
ANCHSDCT DC    CL8'SARSDCT'
AIANAM   DC    CL7'AIA'
SATMAP   DC    CL6'SATMAP'
IOSBNAM  DC    CL7'IOSB'
IORBNAM  DC    CL7'IORB'
PCCWNAM  DC    CL7'PCCW'
SARTNAM  DC    CL7'SART'
SARTENAM DC    CL7'SARTE'
SATNAM   DC    CL7'SAT'
SCCWNAM  DC    CL7'SCCW'
SDCTNAM  DC    CL7'SDCT'
DSNLNA   DC    CL20'DSNAME NOT AVAILABLE'
HDPTRN   DS    CL16
         ORG   HDPTRN
@NM00035 DC    B'00011111'
@NM00036 DC    AL1(16*4+3)
@NM00037 DC    AL1(0)
@NM00038 DC    AL1(6)
HDLBPTR  DS    AL4
HDDTPTR  DS    AL4
@NM00039 DC    F'0'
         ORG   HDPTRN+16
DSNPTRNS DS    CL20
         ORG   DSNPTRNS
@NM00043 DS    CL8
         ORG   @NM00043
@NM00044 DC    B'00101100'
@NM00045 DC    AL1(15)
@NM00046 DC    AL1(0)
@NM00047 DC    AL1(23)
DSNDT    DC    A(0)
         ORG   DSNPTRNS+8
@NM00048 DS    CL4
         ORG   @NM00048
@NM00049 DC    B'00100100'
@NM00050 DC    AL1(15)
@NM00051 DC    AL1(0)
@NM00052 DC    AL1(39)
         ORG   DSNPTRNS+12
@NM00053 DS    CL4
         ORG   @NM00053
@NM00054 DC    B'00100100'
@NM00055 DC    AL1(11)
@NM00056 DC    AL1(0)
@NM00057 DC    AL1(55)
         ORG   DSNPTRNS+16
@NM00058 DC    F'0'
         ORG   DSNPTRNS+20
IOS1PTS  DS    CL64
         ORG   IOS1PTS
@NM00762 DS    CL8
         ORG   @NM00762
@NM00763 DC    B'00000011'
@NM00764 DC    AL1(16*4-16)
@NM00765 DC    AL1(0)
@NM00766 DC    AL1(0)
@NM00767 DC    AL4(IOS1LB1)
         ORG   IOS1PTS+8
@NM00768 DS    CL12
         ORG   @NM00768
@NM00769 DC    B'00001111'
@NM00770 DC    AL1(1-1+16*3-16)
@NM00771 DC    AL1(5)
@NM00772 DC    AL1(11)
@NM00773 DC    AL4(IOS1LB2)
IOS1DT2  DS    AL4
         ORG   IOS1PTS+20
@NM00774 DS    CL8
         ORG   @NM00774
@NM00775 DC    B'00000111'
@NM00776 DC    AL1(1-1+16*3-16)
@NM00777 DC    AL1(23)
@NM00778 DC    AL1(29)
@NM00779 DC    AL4(IOS1LB3)
         ORG   IOS1PTS+28
@NM00780 DS    CL8
         ORG   @NM00780
@NM00781 DC    B'00000111'
@NM00782 DC    AL1(1-1+16*3-16)
@NM00783 DC    AL1(41)
@NM00784 DC    AL1(47)
@NM00785 DC    AL4(IOS1LB4)
         ORG   IOS1PTS+36
@NM00786 DS    CL8
         ORG   @NM00786
@NM00787 DC    B'00000111'
@NM00788 DC    AL1(1-1+16*4-16)
@NM00789 DC    AL1(59)
@NM00790 DC    AL1(65)
@NM00791 DC    AL4(IOS1LB5)
         ORG   IOS1PTS+44
@NM00792 DS    CL8
         ORG   @NM00792
@NM00793 DC    B'00000111'
@NM00794 DC    AL1(1-1+16*5-16)
@NM00795 DC    AL1(77)
@NM00796 DC    AL1(83)
@NM00797 DC    AL4(IOS1LB6)
         ORG   IOS1PTS+52
@NM00798 DS    CL8
         ORG   @NM00798
@NM00799 DC    B'00000111'
@NM00800 DC    AL1(1-1+16*5-16)
@NM00801 DC    AL1(95)
@NM00802 DC    AL1(101)
@NM00803 DC    AL4(IOS1LB7)
         ORG   IOS1PTS+60
@NM00804 DC    F'0'
         ORG   IOS1PTS+64
IOS2PTS  DS    CL60
         ORG   IOS2PTS
@NM00805 DS    CL8
         ORG   @NM00805
@NM00806 DC    B'00000011'
@NM00807 DC    AL1(16*4-16)
@NM00808 DC    AL1(0)
@NM00809 DC    AL1(0)
@NM00810 DC    AL4(IOS2LB1)
         ORG   IOS2PTS+8
@NM00811 DS    CL8
         ORG   @NM00811
@NM00812 DC    B'00000111'
@NM00813 DC    AL1(2-1+16*4-16)
@NM00814 DC    AL1(5)
@NM00815 DC    AL1(11)
@NM00816 DC    AL4(IOS2LB2)
         ORG   IOS2PTS+16
@NM00817 DS    CL8
         ORG   @NM00817
@NM00818 DC    B'00000111'
@NM00819 DC    AL1(4-1+16*4-16)
@NM00820 DC    AL1(23)
@NM00821 DC    AL1(29)
@NM00822 DC    AL4(IOS2LB3)
         ORG   IOS2PTS+24
@NM00823 DS    CL8
         ORG   @NM00823
@NM00824 DC    B'00000111'
@NM00825 DC    AL1(8/8-1+16*4-16)
@NM00826 DC    AL1(41)
@NM00827 DC    AL1(47)
@NM00828 DC    AL4(IOS2LB4)
         ORG   IOS2PTS+32
@NM00829 DS    CL8
         ORG   @NM00829
@NM00830 DC    B'00000111'
@NM00831 DC    AL1(1-1+16*3-16)
@NM00832 DC    AL1(59)
@NM00833 DC    AL1(65)
@NM00834 DC    AL4(IOS2LB5)
         ORG   IOS2PTS+40
@NM00835 DS    CL8
         ORG   @NM00835
@NM00836 DC    B'00000111'
@NM00837 DC    AL1(1-1+16*3-16)
@NM00838 DC    AL1(77)
@NM00839 DC    AL1(83)
@NM00840 DC    AL4(IOS2LB6)
         ORG   IOS2PTS+48
@NM00841 DS    CL8
         ORG   @NM00841
@NM00842 DC    B'00000111'
@NM00843 DC    AL1(1-1+16*4-16)
@NM00844 DC    AL1(95)
@NM00845 DC    AL1(101)
@NM00846 DC    AL4(IOS2LB7)
         ORG   IOS2PTS+56
@NM00847 DC    F'0'
         ORG   IOS2PTS+60
IOS3PTS  DS    CL60
         ORG   IOS3PTS
@NM00848 DS    CL8
         ORG   @NM00848
@NM00849 DC    B'00000011'
@NM00850 DC    AL1(16*4-16)
@NM00851 DC    AL1(0)
@NM00852 DC    AL1(0)
@NM00853 DC    AL4(IOS3LB1)
         ORG   IOS3PTS+8
@NM00854 DS    CL8
         ORG   @NM00854
@NM00855 DC    B'00000111'
@NM00856 DC    AL1(4-1+16*3-16)
@NM00857 DC    AL1(5)
@NM00858 DC    AL1(11)
@NM00859 DC    AL4(IOS3LB2)
         ORG   IOS3PTS+16
@NM00860 DS    CL8
         ORG   @NM00860
@NM00861 DC    B'00000111'
@NM00862 DC    AL1(8/8-1+16*2-16)
@NM00863 DC    AL1(23)
@NM00864 DC    AL1(29)
@NM00865 DC    AL4(IOS3LB3)
         ORG   IOS3PTS+24
@NM00866 DS    CL8
         ORG   @NM00866
@NM00867 DC    B'00000111'
@NM00868 DC    AL1(3-1+16*5-16)
@NM00869 DC    AL1(41)
@NM00870 DC    AL1(47)
@NM00871 DC    AL4(IOS3LB4)
         ORG   IOS3PTS+32
@NM00872 DS    CL8
         ORG   @NM00872
@NM00873 DC    B'00000111'
@NM00874 DC    AL1(2-1+16*6-16)
@NM00875 DC    AL1(59)
@NM00876 DC    AL1(66)
@NM00877 DC    AL4(IOS3LB5)
         ORG   IOS3PTS+40
@NM00878 DS    CL8
         ORG   @NM00878
@NM00879 DC    B'00000111'
@NM00880 DC    AL1(2-1+16*5-16)
@NM00881 DC    AL1(77)
@NM00882 DC    AL1(83)
@NM00883 DC    AL4(IOS3LB6)
         ORG   IOS3PTS+48
@NM00884 DS    CL8
         ORG   @NM00884
@NM00885 DC    B'00000111'
@NM00886 DC    AL1(4-1+16*3-16)
@NM00887 DC    AL1(95)
@NM00888 DC    AL1(101)
@NM00889 DC    AL4(IOS3LB7)
         ORG   IOS3PTS+56
@NM00890 DC    F'0'
         ORG   IOS3PTS+60
IOS4PTS  DS    CL60
         ORG   IOS4PTS
@NM00891 DS    CL8
         ORG   @NM00891
@NM00892 DC    B'00000011'
@NM00893 DC    AL1(16*4-16)
@NM00894 DC    AL1(0)
@NM00895 DC    AL1(0)
@NM00896 DC    AL4(IOS4LB1)
         ORG   IOS4PTS+8
@NM00897 DS    CL8
         ORG   @NM00897
@NM00898 DC    B'00000111'
@NM00899 DC    AL1(4-1+16*3-16)
@NM00900 DC    AL1(5)
@NM00901 DC    AL1(11)
@NM00902 DC    AL4(IOS4LB2)
         ORG   IOS4PTS+16
@NM00903 DS    CL8
         ORG   @NM00903
@NM00904 DC    B'00000111'
@NM00905 DC    AL1(4-1+16*5-16)
@NM00906 DC    AL1(23)
@NM00907 DC    AL1(29)
@NM00908 DC    AL4(IOS4LB3)
         ORG   IOS4PTS+24
@NM00909 DS    CL8
         ORG   @NM00909
@NM00910 DC    B'00000111'
@NM00911 DC    AL1(2-1+16*5-16)
@NM00912 DC    AL1(41)
@NM00913 DC    AL1(47)
@NM00914 DC    AL4(IOS4LB4)
         ORG   IOS4PTS+32
@NM00915 DS    CL8
         ORG   @NM00915
@NM00916 DC    B'00000111'
@NM00917 DC    AL1(16/8-1+16*3-16)
@NM00918 DC    AL1(59)
@NM00919 DC    AL1(65)
@NM00920 DC    AL4(IOS4LB5)
         ORG   IOS4PTS+40
@NM00921 DS    CL8
         ORG   @NM00921
@NM00922 DC    B'00000111'
@NM00923 DC    AL1(4-1+16*4-16)
@NM00924 DC    AL1(77)
@NM00925 DC    AL1(83)
@NM00926 DC    AL4(IOS4LB6)
         ORG   IOS4PTS+48
@NM00927 DS    CL8
         ORG   @NM00927
@NM00928 DC    B'00000111'
@NM00929 DC    AL1(4-1+16*4-16)
@NM00930 DC    AL1(95)
@NM00931 DC    AL1(101)
@NM00932 DC    AL4(IOS4LB7)
         ORG   IOS4PTS+56
@NM00933 DC    F'0'
         ORG   IOS4PTS+60
IOS5PTS  DS    CL60
         ORG   IOS5PTS
@NM00934 DS    CL8
         ORG   @NM00934
@NM00935 DC    B'00000011'
@NM00936 DC    AL1(16*4-16)
@NM00937 DC    AL1(0)
@NM00938 DC    AL1(0)
@NM00939 DC    AL4(IOS5LB1)
         ORG   IOS5PTS+8
@NM00940 DS    CL8
         ORG   @NM00940
@NM00941 DC    B'00000111'
@NM00942 DC    AL1(4-1+16*3-16)
@NM00943 DC    AL1(5)
@NM00944 DC    AL1(11)
@NM00945 DC    AL4(IOS5LB2)
         ORG   IOS5PTS+16
@NM00946 DS    CL8
         ORG   @NM00946
@NM00947 DC    B'00000111'
@NM00948 DC    AL1(4-1+16*3-16)
@NM00949 DC    AL1(23)
@NM00950 DC    AL1(29)
@NM00951 DC    AL4(IOS5LB3)
         ORG   IOS5PTS+24
@NM00952 DS    CL8
         ORG   @NM00952
@NM00953 DC    B'00000111'
@NM00954 DC    AL1(4-1+16*3-16)
@NM00955 DC    AL1(41)
@NM00956 DC    AL1(47)
@NM00957 DC    AL4(IOS5LB4)
         ORG   IOS5PTS+32
@NM00958 DS    CL8
         ORG   @NM00958
@NM00959 DC    B'00000111'
@NM00960 DC    AL1(4-1+16*3-16)
@NM00961 DC    AL1(59)
@NM00962 DC    AL1(65)
@NM00963 DC    AL4(IOS5LB5)
         ORG   IOS5PTS+40
@NM00964 DS    CL8
         ORG   @NM00964
@NM00965 DC    B'00000111'
@NM00966 DC    AL1(4-1+16*3-16)
@NM00967 DC    AL1(77)
@NM00968 DC    AL1(83)
@NM00969 DC    AL4(IOS5LB6)
         ORG   IOS5PTS+48
@NM00970 DS    CL8
         ORG   @NM00970
@NM00971 DC    B'00000111'
@NM00972 DC    AL1(4-1+16*3-16)
@NM00973 DC    AL1(95)
@NM00974 DC    AL1(101)
@NM00975 DC    AL4(IOS5LB7)
         ORG   IOS5PTS+56
@NM00976 DC    F'0'
         ORG   IOS5PTS+60
IOS6PTS  DS    CL60
         ORG   IOS6PTS
@NM00977 DS    CL8
         ORG   @NM00977
@NM00978 DC    B'00000011'
@NM00979 DC    AL1(16*4-16)
@NM00980 DC    AL1(0)
@NM00981 DC    AL1(0)
@NM00982 DC    AL4(IOS6LB1)
         ORG   IOS6PTS+8
@NM00983 DS    CL8
         ORG   @NM00983
@NM00984 DC    B'00000111'
@NM00985 DC    AL1(4-1+16*3-16)
@NM00986 DC    AL1(5)
@NM00987 DC    AL1(11)
@NM00988 DC    AL4(IOS6LB2)
         ORG   IOS6PTS+16
@NM00989 DS    CL8
         ORG   @NM00989
@NM00990 DC    B'00000111'
@NM00991 DC    AL1(4-1+16*4-16)
@NM00992 DC    AL1(23)
@NM00993 DC    AL1(29)
@NM00994 DC    AL4(IOS6LB3)
         ORG   IOS6PTS+24
@NM00995 DS    CL8
         ORG   @NM00995
@NM00996 DC    B'00000111'
@NM00997 DC    AL1(1-1+16*5-16)
@NM00998 DC    AL1(41)
@NM00999 DC    AL1(47)
@NM01000 DC    AL4(IOS6LB4)
         ORG   IOS6PTS+32
@NM01001 DS    CL8
         ORG   @NM01001
@NM01002 DC    B'00000111'
@NM01003 DC    AL1(8/8-1+16*3-16)
@NM01004 DC    AL1(59)
@NM01005 DC    AL1(65)
@NM01006 DC    AL4(IOS6LB5)
         ORG   IOS6PTS+40
@NM01007 DS    CL8
         ORG   @NM01007
@NM01008 DC    B'00000111'
@NM01009 DC    AL1(2-1+16*4-16)
@NM01010 DC    AL1(77)
@NM01011 DC    AL1(83)
@NM01012 DC    AL4(IOS6LB6)
         ORG   IOS6PTS+48
@NM01013 DS    CL8
         ORG   @NM01013
@NM01014 DC    B'00000111'
@NM01015 DC    AL1(1-1+16*4-16)
@NM01016 DC    AL1(95)
@NM01017 DC    AL1(101)
@NM01018 DC    AL4(IOS6LB7)
         ORG   IOS6PTS+56
@NM01019 DC    F'0'
         ORG   IOS6PTS+60
IOS7PTS  DS    CL36
         ORG   IOS7PTS
@NM01020 DS    CL8
         ORG   @NM01020
@NM01021 DC    B'00000011'
@NM01022 DC    AL1(16*4-16)
@NM01023 DC    AL1(0)
@NM01024 DC    AL1(0)
@NM01025 DC    AL4(IOS7LB1)
         ORG   IOS7PTS+8
@NM01026 DS    CL8
         ORG   @NM01026
@NM01027 DC    B'00000111'
@NM01028 DC    AL1(8/8-1+16*4-16)
@NM01029 DC    AL1(5)
@NM01030 DC    AL1(11)
@NM01031 DC    AL4(IOS7LB2)
         ORG   IOS7PTS+16
@NM01032 DS    CL8
         ORG   @NM01032
@NM01033 DC    B'00000111'
@NM01034 DC    AL1(1-1+16*3-16)
@NM01035 DC    AL1(23)
@NM01036 DC    AL1(29)
@NM01037 DC    AL4(IOS7LB3)
         ORG   IOS7PTS+24
@NM01038 DS    CL8
         ORG   @NM01038
@NM01039 DC    B'00000111'
@NM01040 DC    AL1(1-1+16*3-16)
@NM01041 DC    AL1(41)
@NM01042 DC    AL1(47)
@NM01043 DC    AL4(IOS7LB4)
         ORG   IOS7PTS+32
@NM01044 DC    F'0'
         ORG   IOS7PTS+36
SAR1LB1  DC    CL2'ID'
SAR1LB2  DC    CL4'SIZE'
SAR1LB3  DC    CL3'USE'
SAR1LB4  DC    CL5'FXDNX'
SAR1LB5  DC    CL5'MOVNX'
SAR1LB6  DC    CL4'DSNL'
         DS    CL1
SAR1PTS  DS    CL76
         ORG   SAR1PTS
@NM00059 DS    CL12
         ORG   @NM00059
@NM00060 DC    B'00101111'
@NM00061 DC    AL1(4-1+16*2-16)
@NM00062 DC    AL1(5)
@NM00063 DC    AL1(11)
@NM00064 DC    AL4(SAR1LB1)
SAR1DT1  DC    A(0)
         ORG   SAR1PTS+12
@NM00065 DS    CL12
         ORG   @NM00065
@NM00066 DC    B'00001111'
@NM00067 DC    AL1(4-1+16*4-16)
@NM00068 DC    AL1(15+8)
@NM00069 DC    AL1(21+8)
@NM00070 DC    AL4(SAR1LB2)
SAR1DT2  DC    A(0)
         ORG   SAR1PTS+24
@NM00071 DS    CL12
         ORG   @NM00071
@NM00072 DC    B'00001111'
@NM00073 DC    AL1(4-1+16*3-16)
@NM00074 DC    AL1(25+8+8)
@NM00075 DC    AL1(31+8+8)
@NM00076 DC    AL4(SAR1LB3)
SAR1DT3  DC    A(0)
         ORG   SAR1PTS+36
@NM00077 DS    CL12
         ORG   @NM00077
@NM00078 DC    B'00001111'
@NM00079 DC    AL1(4-1+16*5-16)
@NM00080 DC    AL1(35+8+8+8)
@NM00081 DC    AL1(41+8+8+8)
@NM00082 DC    AL4(SAR1LB4)
SAR1DT4  DC    A(0)
         ORG   SAR1PTS+48
@NM00083 DS    CL12
         ORG   @NM00083
@NM00084 DC    B'00001111'
@NM00085 DC    AL1(4-1+16*5-16)
@NM00086 DC    AL1(45+8+8+8+8)
@NM00087 DC    AL1(51+8+8+8+8)
@NM00088 DC    AL4(SAR1LB5)
SAR1DT5  DC    A(0)
         ORG   SAR1PTS+60
@NM00089 DS    CL12
         ORG   @NM00089
@NM00090 DC    B'00001111'
@NM00091 DC    AL1(4-1+16*4-16)
@NM00092 DC    AL1(55+8+8+8+8+8)
@NM00093 DC    AL1(61+8+8+8+8+8)
@NM00094 DC    AL4(SAR1LB6)
SAR1DT6  DC    A(0)
         ORG   SAR1PTS+72
@NM00095 DC    F'0'
         ORG   SAR1PTS+76
SAR2LB1  DC    CL4'SDCT'
SAR2LB2  DC    CL5'SCCWQ'
SAR2LB3  DC    CL5'SETCT'
SAR2LB4  DC    CL5'WAITF'
SAR2LB5  DC    CL5'WAITL'
SAR2LB6  DC    CL4'SRBP'
SAR2PTS  DS    CL76
         ORG   SAR2PTS
@NM00096 DS    CL12
         ORG   @NM00096
@NM00097 DC    B'00001111'
@NM00098 DC    AL1(4-1+16*4-16)
@NM00099 DC    AL1(5)
@NM00100 DC    AL1(11)
@NM00101 DC    AL4(SAR2LB1)
SAR2DT1  DC    A(0)
         ORG   SAR2PTS+12
@NM00102 DS    CL12
         ORG   @NM00102
@NM00103 DC    B'00001111'
@NM00104 DC    AL1(4-1+16*5-16)
@NM00105 DC    AL1(15+8)
@NM00106 DC    AL1(21+8)
@NM00107 DC    AL4(SAR2LB2)
SAR2DT2  DC    A(0)
         ORG   SAR2PTS+24
@NM00108 DS    CL12
         ORG   @NM00108
@NM00109 DC    B'00001111'
@NM00110 DC    AL1(4-1+16*5-16)
@NM00111 DC    AL1(25+8+8)
@NM00112 DC    AL1(31+8+8)
@NM00113 DC    AL4(SAR2LB3)
SAR2DT3  DC    A(0)
         ORG   SAR2PTS+36
@NM00114 DS    CL12
         ORG   @NM00114
@NM00115 DC    B'00001111'
@NM00116 DC    AL1(4-1+16*5-16)
@NM00117 DC    AL1(35+8+8+8)
@NM00118 DC    AL1(41+8+8+8)
@NM00119 DC    AL4(SAR2LB4)
SAR2DT4  DC    A(0)
         ORG   SAR2PTS+48
@NM00120 DS    CL12
         ORG   @NM00120
@NM00121 DC    B'00001111'
@NM00122 DC    AL1(4-1+16*5-16)
@NM00123 DC    AL1(45+8+8+8+8)
@NM00124 DC    AL1(51+8+8+8+8)
@NM00125 DC    AL4(SAR2LB5)
SAR2DT5  DC    A(0)
         ORG   SAR2PTS+60
@NM00126 DS    CL12
         ORG   @NM00126
@NM00127 DC    B'00001111'
@NM00128 DC    AL1(4-1+16*4-16)
@NM00129 DC    AL1(55+8+8+8+8+8)
@NM00130 DC    AL1(61+8+8+8+8+8)
@NM00131 DC    AL4(SAR2LB6)
SAR2DT6  DC    A(0)
         ORG   SAR2PTS+72
@NM00132 DC    F'0'
         ORG   SAR2PTS+76
SAR3LB1  DC    CL5'SRBCT'
SAR3LB2  DC    CL5'SETSZ'
         DS    CL2
SAR3PTS  DS    CL28
         ORG   SAR3PTS
@NM00133 DS    CL12
         ORG   @NM00133
@NM00134 DC    B'00001111'
@NM00135 DC    AL1(4-1+16*5-16)
@NM00136 DC    AL1(5)
@NM00137 DC    AL1(11)
@NM00138 DC    AL4(SAR3LB1)
SAR3DT1  DC    A(0)
         ORG   SAR3PTS+12
@NM00139 DS    CL12
         ORG   @NM00139
@NM00140 DC    B'00001111'
@NM00141 DC    AL1(4-1+16*5-16)
@NM00142 DC    AL1(15+8)
@NM00143 DC    AL1(21+8)
@NM00144 DC    AL4(SAR3LB2)
SAR3DT2  DC    A(0)
         ORG   SAR3PTS+24
@NM00145 DC    F'0'
         ORG   SAR3PTS+28
SDCT1LB1 DC    CL2'ID'
SDCT1LB2 DC    CL4'SIZE'
SDCT1LB3 DC    CL4'RSV1'
         DS    CL2
SDCT1PTS DS    CL40
         ORG   SDCT1PTS
@NM00146 DS    CL12
         ORG   @NM00146
@NM00147 DC    B'00101111'
@NM00148 DC    AL1(4-1+16*2-16)
@NM00149 DC    AL1(5)
@NM00150 DC    AL1(11)
@NM00151 DC    AL4(SDCT1LB1)
SDCT1DT1 DC    A(0)
         ORG   SDCT1PTS+12
@NM00152 DS    CL12
         ORG   @NM00152
@NM00153 DC    B'00001111'
@NM00154 DC    AL1(2-1+16*4-16)
@NM00155 DC    AL1(15+8)
@NM00156 DC    AL1(21+8)
@NM00157 DC    AL4(SDCT1LB2)
SDCT1DT2 DC    A(0)
         ORG   SDCT1PTS+24
@NM00158 DS    CL12
         ORG   @NM00158
@NM00159 DC    B'00001111'
@NM00160 DC    AL1(2-1+16*4-16)
@NM00161 DC    AL1(25+8+8)
@NM00162 DC    AL1(31+8+8)
@NM00163 DC    AL4(SDCT1LB3)
SDCT1DT3 DC    A(0)
         ORG   SDCT1PTS+36
@NM00164 DC    F'0'
         ORG   SDCT1PTS+40
SDCT2LB1 DC    CL5'DEVTP'
SDCT2LB2 DC    CL5'DTYPX'
SDCT2LB3 DC    CL5'SLTRK'
SDCT2LB4 DC    CL5'CYLSZ'
SDCT2LB5 DC    CL5'CMASK'
SDCT2LB6 DC    CL5'SSECT'
         DS    CL2
SDCT2PTS DS    CL76
         ORG   SDCT2PTS
@NM00165 DS    CL12
         ORG   @NM00165
@NM00166 DC    B'00101111'
@NM00167 DC    AL1(6-1+16*5-16)
@NM00168 DC    AL1(5)
@NM00169 DC    AL1(11)
@NM00170 DC    AL4(SDCT2LB1)
SDCT2DT1 DC    A(0)
         ORG   SDCT2PTS+12
@NM00171 DS    CL12
         ORG   @NM00171
@NM00172 DC    B'00001111'
@NM00173 DC    AL1(2-1+16*5-16)
@NM00174 DC    AL1(15+8)
@NM00175 DC    AL1(21+8)
@NM00176 DC    AL4(SDCT2LB2)
SDCT2DT2 DC    A(0)
         ORG   SDCT2PTS+24
@NM00177 DS    CL12
         ORG   @NM00177
@NM00178 DC    B'00001111'
@NM00179 DC    AL1(2-1+16*5-16)
@NM00180 DC    AL1(25+8+8)
@NM00181 DC    AL1(31+8+8)
@NM00182 DC    AL4(SDCT2LB3)
SDCT2DT3 DC    A(0)
         ORG   SDCT2PTS+36
@NM00183 DS    CL12
         ORG   @NM00183
@NM00184 DC    B'00001111'
@NM00185 DC    AL1(2-1+16*5-16)
@NM00186 DC    AL1(35+8+8+8)
@NM00187 DC    AL1(41+8+8+8)
@NM00188 DC    AL4(SDCT2LB4)
SDCT2DT4 DC    A(0)
         ORG   SDCT2PTS+48
@NM00189 DS    CL12
         ORG   @NM00189
@NM00190 DC    B'00001111'
@NM00191 DC    AL1(4-1+16*5-16)
@NM00192 DC    AL1(45+8+8+8+8)
@NM00193 DC    AL1(51+8+8+8+8)
@NM00194 DC    AL4(SDCT2LB5)
SDCT2DT5 DC    A(0)
         ORG   SDCT2PTS+60
@NM00195 DS    CL12
         ORG   @NM00195
@NM00196 DC    B'00001111'
@NM00197 DC    AL1(1-1+16*5-16)
@NM00198 DC    AL1(55+8+8+8+8+8)
@NM00199 DC    AL1(61+8+8+8+8+8)
@NM00200 DC    AL4(SDCT2LB6)
SDCT2DT6 DC    A(0)
         ORG   SDCT2PTS+72
@NM00201 DC    F'0'
         ORG   SDCT2PTS+76
SRE1LB1  DC    CL4'NEXT'
SRE1LB2  DC    CL4'LOCK'
SRE1LB3  DC    CL3'FLG'
SRE1LB4  DC    CL2'NN'
SRE1LB5  DC    CL4'SCCW'
SRE1LB6  DC    CL5'TOTSL'
         DS    CL2
SRE1PTS  DS    CL76
         ORG   SRE1PTS
@NM00202 DS    CL12
         ORG   @NM00202
@NM00203 DC    B'00001111'
@NM00204 DC    AL1(4-1+16*4-16)
@NM00205 DC    AL1(5)
@NM00206 DC    AL1(11)
@NM00207 DC    AL4(SRE1LB1)
SRE1DT1  DC    A(0)
         ORG   SRE1PTS+12
@NM00208 DS    CL12
         ORG   @NM00208
@NM00209 DC    B'00001111'
@NM00210 DC    AL1(4-1+16*4-16)
@NM00211 DC    AL1(15+8)
@NM00212 DC    AL1(21+8)
@NM00213 DC    AL4(SRE1LB2)
SRE1DT2  DC    A(0)
         ORG   SRE1PTS+24
@NM00214 DS    CL12
         ORG   @NM00214
@NM00215 DC    B'00001111'
@NM00216 DC    AL1(1-1+16*3-16)
@NM00217 DC    AL1(25+8+8)
@NM00218 DC    AL1(31+8+8)
@NM00219 DC    AL4(SRE1LB3)
SRE1DT3  DC    A(0)
         ORG   SRE1PTS+36
@NM00220 DS    CL12
         ORG   @NM00220
@NM00221 DC    B'00001111'
@NM00222 DC    AL1(2-1+16*2-16)
@NM00223 DC    AL1(35+8+8+8)
@NM00224 DC    AL1(41+8+8+8)
@NM00225 DC    AL4(SRE1LB4)
SRE1DT4  DC    A(0)
         ORG   SRE1PTS+48
@NM00226 DS    CL12
         ORG   @NM00226
@NM00227 DC    B'00001111'
@NM00228 DC    AL1(4-1+16*4-16)
@NM00229 DC    AL1(45+8+8+8+8)
@NM00230 DC    AL1(51+8+8+8+8)
@NM00231 DC    AL4(SRE1LB5)
SRE1DT5  DC    A(0)
         ORG   SRE1PTS+60
@NM00232 DS    CL12
         ORG   @NM00232
@NM00233 DC    B'00001111'
@NM00234 DC    AL1(4-1+16*5-16)
@NM00235 DC    AL1(55+8+8+8+8+8)
@NM00236 DC    AL1(61+8+8+8+8+8)
@NM00237 DC    AL4(SRE1LB6)
SRE1DT6  DC    A(0)
         ORG   SRE1PTS+72
@NM00238 DC    F'0'
         ORG   SRE1PTS+76
SRE2LB1  DC    CL5'AVLSL'
SRE2LB2  DC    CL5'RRCNT'
SRE2LB3  DC    CL4'IORB'
SRE2LB4  DC    CL3'SAT'
SRE2LB5  DC    CL5'SDCTE'
SRE2LB6  DC    CL3'EDB'
         DS    CL3
SRE2PTS  DS    CL76
         ORG   SRE2PTS
@NM00239 DS    CL12
         ORG   @NM00239
@NM00240 DC    B'00001111'
@NM00241 DC    AL1(4-1+16*5-16)
@NM00242 DC    AL1(5)
@NM00243 DC    AL1(11)
@NM00244 DC    AL4(SRE2LB1)
SRE2DT1  DC    A(0)
         ORG   SRE2PTS+12
@NM00245 DS    CL12
         ORG   @NM00245
@NM00246 DC    B'00001111'
@NM00247 DC    AL1(4-1+16*5-16)
@NM00248 DC    AL1(15+8)
@NM00249 DC    AL1(21+8)
@NM00250 DC    AL4(SRE2LB2)
SRE2DT2  DC    A(0)
         ORG   SRE2PTS+24
@NM00251 DS    CL12
         ORG   @NM00251
@NM00252 DC    B'00001111'
@NM00253 DC    AL1(4-1+16*4-16)
@NM00254 DC    AL1(25+8+8)
@NM00255 DC    AL1(31+8+8)
@NM00256 DC    AL4(SRE2LB3)
SRE2DT3  DC    A(0)
         ORG   SRE2PTS+36
@NM00257 DS    CL12
         ORG   @NM00257
@NM00258 DC    B'00001111'
@NM00259 DC    AL1(4-1+16*3-16)
@NM00260 DC    AL1(35+8+8+8)
@NM00261 DC    AL1(41+8+8+8)
@NM00262 DC    AL4(SRE2LB4)
SRE2DT4  DC    A(0)
         ORG   SRE2PTS+48
@NM00263 DS    CL12
         ORG   @NM00263
@NM00264 DC    B'00001111'
@NM00265 DC    AL1(4-1+16*5-16)
@NM00266 DC    AL1(45+8+8+8+8)
@NM00267 DC    AL1(51+8+8+8+8)
@NM00268 DC    AL4(SRE2LB5)
SRE2DT5  DC    A(0)
         ORG   SRE2PTS+60
@NM00269 DS    CL12
         ORG   @NM00269
@NM00270 DC    B'00001111'
@NM00271 DC    AL1(4-1+16*3-16)
@NM00272 DC    AL1(55+8+8+8+8+8)
@NM00273 DC    AL1(61+8+8+8+8+8)
@NM00274 DC    AL4(SRE2LB6)
SRE2DT6  DC    A(0)
         ORG   SRE2PTS+72
@NM00275 DC    F'0'
         ORG   SRE2PTS+76
SRE3LB1  DC    CL3'UCB'
         DS    CL1
SRE3PTS  DS    CL16
         ORG   SRE3PTS
@NM00276 DS    CL12
         ORG   @NM00276
@NM00277 DC    B'00001111'
@NM00278 DC    AL1(4-1+16*3-16)
@NM00279 DC    AL1(5)
@NM00280 DC    AL1(11)
@NM00281 DC    AL4(SRE3LB1)
SRE3DT1  DC    A(0)
         ORG   SRE3PTS+12
@NM00282 DC    F'0'
         ORG   SRE3PTS+16
SAT1LB1  DC    CL2'ID'
SAT1LB2  DC    CL5'SARTE'
SAT1LB3  DC    CL5'MAPLN'
SAT1LB4  DC    CL5'BYTCL'
SAT1LB5  DC    CL5'OFFST'
SAT1LB6  DC    CL4'MASK'
         DS    CL2
SAT1PTS  DS    CL76
         ORG   SAT1PTS
@NM00283 DS    CL12
         ORG   @NM00283
@NM00284 DC    B'00101111'
@NM00285 DC    AL1(4-1+16*2-16)
@NM00286 DC    AL1(5)
@NM00287 DC    AL1(11)
@NM00288 DC    AL4(SAT1LB1)
SAT1DT1  DC    A(0)
         ORG   SAT1PTS+12
@NM00289 DS    CL12
         ORG   @NM00289
@NM00290 DC    B'00001111'
@NM00291 DC    AL1(4-1+16*5-16)
@NM00292 DC    AL1(15+8)
@NM00293 DC    AL1(21+8)
@NM00294 DC    AL4(SAT1LB2)
SAT1DT2  DC    A(0)
         ORG   SAT1PTS+24
@NM00295 DS    CL12
         ORG   @NM00295
@NM00296 DC    B'00001111'
@NM00297 DC    AL1(2-1+16*5-16)
@NM00298 DC    AL1(25+8+8)
@NM00299 DC    AL1(31+8+8)
@NM00300 DC    AL4(SAT1LB3)
SAT1DT3  DC    A(0)
         ORG   SAT1PTS+36
@NM00301 DS    CL12
         ORG   @NM00301
@NM00302 DC    B'00001111'
@NM00303 DC    AL1(2-1+16*5-16)
@NM00304 DC    AL1(35+8+8+8)
@NM00305 DC    AL1(41+8+8+8)
@NM00306 DC    AL4(SAT1LB4)
SAT1DT4  DC    A(0)
         ORG   SAT1PTS+48
@NM00307 DS    CL12
         ORG   @NM00307
@NM00308 DC    B'00001111'
@NM00309 DC    AL1(2-1+16*5-16)
@NM00310 DC    AL1(45+8+8+8+8)
@NM00311 DC    AL1(51+8+8+8+8)
@NM00312 DC    AL4(SAT1LB5)
SAT1DT5  DC    A(0)
         ORG   SAT1PTS+60
@NM00313 DS    CL12
         ORG   @NM00313
@NM00314 DC    B'00001111'
@NM00315 DC    AL1(1-1+16*4-16)
@NM00316 DC    AL1(55+8+8+8+8+8)
@NM00317 DC    AL1(61+8+8+8+8+8)
@NM00318 DC    AL4(SAT1LB6)
SAT1DT6  DC    A(0)
         ORG   SAT1PTS+72
@NM00319 DC    F'0'
         ORG   SAT1PTS+76
SAT2LB1  DC    CL4'SCAN'
SAT2LB2  DC    CL5'SLTNO'
SAT2LB3  DC    CL4'ASGN'
         DS    CL3
SAT2PTS  DS    CL40
         ORG   SAT2PTS
@NM00320 DS    CL12
         ORG   @NM00320
@NM00321 DC    B'00001111'
@NM00322 DC    AL1(4-1+16*4-16)
@NM00323 DC    AL1(5)
@NM00324 DC    AL1(11)
@NM00325 DC    AL4(SAT2LB1)
SAT2DT1  DC    A(0)
         ORG   SAT2PTS+12
@NM00326 DS    CL12
         ORG   @NM00326
@NM00327 DC    B'00001111'
@NM00328 DC    AL1(4-1+16*5-16)
@NM00329 DC    AL1(15+8)
@NM00330 DC    AL1(21+8)
@NM00331 DC    AL4(SAT2LB2)
SAT2DT2  DC    A(0)
         ORG   SAT2PTS+24
@NM00332 DS    CL12
         ORG   @NM00332
@NM00333 DC    B'00001111'
@NM00334 DC    AL1(4-1+16*4-16)
@NM00335 DC    AL1(25+8+8)
@NM00336 DC    AL1(31+8+8)
@NM00337 DC    AL4(SAT2LB3)
SAT2DT3  DC    A(0)
         ORG   SAT2PTS+36
@NM00338 DC    F'0'
         ORG   SAT2PTS+40
SAT3PTS  DS    CL68
         ORG   SAT3PTS
@NM00339 DS    CL8
         ORG   @NM00339
@NM00340 DC    B'00001100'
         ORG   @NM00340
@NM00341 DS    BL1
@NM00342 EQU   @NM00340+0
         ORG   @NM00339+1
@NM00343 DC    AL1(16*0+4-1)
@NM00344 DC    AL1(0)
@NM00345 DC    AL1(5)
SAT3DT1  DC    A(0)
         ORG   SAT3PTS+8
@NM00346 DS    CL8
         ORG   @NM00346
@NM00347 DC    B'00001100'
         ORG   @NM00347
@NM00348 DS    BL1
@NM00349 EQU   @NM00347+0
         ORG   @NM00346+1
@NM00350 DC    AL1(16*0+4-1)
@NM00351 DC    AL1(0)
@NM00352 DC    AL1(17)
SAT3DT2  DC    A(0)
         ORG   SAT3PTS+16
@NM00353 DS    CL8
         ORG   @NM00353
@NM00354 DC    B'00001100'
         ORG   @NM00354
@NM00355 DS    BL1
@NM00356 EQU   @NM00354+0
         ORG   @NM00353+1
@NM00357 DC    AL1(16*0+4-1)
@NM00358 DC    AL1(0)
@NM00359 DC    AL1(29)
SAT3DT3  DC    A(0)
         ORG   SAT3PTS+24
@NM00360 DS    CL8
         ORG   @NM00360
@NM00361 DC    B'00001100'
         ORG   @NM00361
@NM00362 DS    BL1
@NM00363 EQU   @NM00361+0
         ORG   @NM00360+1
@NM00364 DC    AL1(16*0+4-1)
@NM00365 DC    AL1(0)
@NM00366 DC    AL1(41)
SAT3DT4  DC    A(0)
         ORG   SAT3PTS+32
@NM00367 DS    CL8
         ORG   @NM00367
@NM00368 DC    B'00001100'
         ORG   @NM00368
@NM00369 DS    BL1
@NM00370 EQU   @NM00368+0
         ORG   @NM00367+1
@NM00371 DC    AL1(16*0+4-1)
@NM00372 DC    AL1(0)
@NM00373 DC    AL1(53)
SAT3DT5  DC    A(0)
         ORG   SAT3PTS+40
@NM00374 DS    CL8
         ORG   @NM00374
@NM00375 DC    B'00001100'
         ORG   @NM00375
@NM00376 DS    BL1
@NM00377 EQU   @NM00375+0
         ORG   @NM00374+1
@NM00378 DC    AL1(16*0+4-1)
@NM00379 DC    AL1(0)
@NM00380 DC    AL1(65)
SAT3DT6  DC    A(0)
         ORG   SAT3PTS+48
@NM00381 DS    CL8
         ORG   @NM00381
@NM00382 DC    B'00001100'
         ORG   @NM00382
@NM00383 DS    BL1
@NM00384 EQU   @NM00382+0
         ORG   @NM00381+1
@NM00385 DC    AL1(16*0+4-1)
@NM00386 DC    AL1(0)
@NM00387 DC    AL1(77)
SAT3DT7  DC    A(0)
         ORG   SAT3PTS+56
@NM00388 DS    CL8
         ORG   @NM00388
@NM00389 DC    B'00001100'
         ORG   @NM00389
@NM00390 DS    BL1
@NM00391 EQU   @NM00389+0
         ORG   @NM00388+1
@NM00392 DC    AL1(16*0+4-1)
@NM00393 DC    AL1(0)
@NM00394 DC    AL1(89)
SAT3DT8  DC    A(0)
         ORG   SAT3PTS+64
@NM00395 DC    F'0'
         ORG   SAT3PTS+68
SCCW1LB1 DC    CL3'WID'
SCCW1LB2 DC    CL5'WSECT'
SCCW1LB3 DC    CL5'WFLAG'
SCCW1LB4 DC    CL5'WSCCW'
SCCW1LB5 DC    CL4'WAIA'
SCCW1LB6 DC    CL5'WIORB'
         DS    CL1
SCCW1PTS DS    CL76
         ORG   SCCW1PTS
@NM00396 DS    CL12
         ORG   @NM00396
@NM00397 DC    B'00001111'
@NM00398 DC    AL1(1-1+16*3-16)
@NM00399 DC    AL1(5)
@NM00400 DC    AL1(11)
@NM00401 DC    AL4(SCCW1LB1)
SCCW1DT1 DC    A(0)
         ORG   SCCW1PTS+12
@NM00402 DS    CL12
         ORG   @NM00402
@NM00403 DC    B'00001111'
@NM00404 DC    AL1(1-1+16*5-16)
@NM00405 DC    AL1(15+8)
@NM00406 DC    AL1(21+8)
@NM00407 DC    AL4(SCCW1LB2)
SCCW1DT2 DC    A(0)
         ORG   SCCW1PTS+24
@NM00408 DS    CL12
         ORG   @NM00408
@NM00409 DC    B'00001111'
@NM00410 DC    AL1(8/8-1+16*5-16)
@NM00411 DC    AL1(25+8+8)
@NM00412 DC    AL1(31+8+8)
@NM00413 DC    AL4(SCCW1LB3)
SCCW1DT3 DC    A(0)
         ORG   SCCW1PTS+36
@NM00414 DS    CL12
         ORG   @NM00414
@NM00415 DC    B'00001111'
@NM00416 DC    AL1(4-1+16*5-16)
@NM00417 DC    AL1(35+8+8+8)
@NM00418 DC    AL1(41+8+8+8)
@NM00419 DC    AL4(SCCW1LB4)
SCCW1DT4 DC    A(0)
         ORG   SCCW1PTS+48
@NM00420 DS    CL12
         ORG   @NM00420
@NM00421 DC    B'00001111'
@NM00422 DC    AL1(4-1+16*4-16)
@NM00423 DC    AL1(45+8+8+8+8)
@NM00424 DC    AL1(51+8+8+8+8)
@NM00425 DC    AL4(SCCW1LB5)
SCCW1DT5 DC    A(0)
         ORG   SCCW1PTS+60
@NM00426 DS    CL12
         ORG   @NM00426
@NM00427 DC    B'00001111'
@NM00428 DC    AL1(4-1+16*5-16)
@NM00429 DC    AL1(55+8+8+8+8+8)
@NM00430 DC    AL1(61+8+8+8+8+8)
@NM00431 DC    AL4(SCCW1LB6)
SCCW1DT6 DC    A(0)
         ORG   SCCW1PTS+72
@NM00432 DC    F'0'
         ORG   SCCW1PTS+76
SCCW3LB1 DC    CL4'SARG'
SCCW3PTS DS    CL40
         ORG   SCCW3PTS
@NM00433 DS    CL12
         ORG   @NM00433
@NM00434 DC    B'00001111'
@NM00435 DC    AL1(3-1+16*4-16)
@NM00436 DC    AL1(5)
@NM00437 DC    AL1(11)
@NM00438 DC    AL4(SCCW3LB1)
SCCW3DT1 DC    A(0)
         ORG   SCCW3PTS+12
@NM00439 DS    CL4
         ORG   @NM00439
@NM00440 DC    B'00000100'
@NM00441 DC    XL1'04'
@NM00442 DC    AL1(0)
@NM00443 DC    AL1(22)
         ORG   SCCW3PTS+16
@NM00444 DS    CL4
         ORG   @NM00444
@NM00445 DC    B'00000100'
@NM00446 DC    XL1'04'
@NM00447 DC    AL1(0)
@NM00448 DC    AL1(36)
         ORG   SCCW3PTS+20
@NM00449 DS    CL4
         ORG   @NM00449
@NM00450 DC    B'00000100'
@NM00451 DC    XL1'04'
@NM00452 DC    AL1(0)
@NM00453 DC    AL1(50)
         ORG   SCCW3PTS+24
@NM00454 DS    CL4
         ORG   @NM00454
@NM00455 DC    B'00000100'
@NM00456 DC    XL1'04'
@NM00457 DC    AL1(0)
@NM00458 DC    AL1(64)
         ORG   SCCW3PTS+28
@NM00459 DS    CL4
         ORG   @NM00459
@NM00460 DC    B'00000100'
@NM00461 DC    XL1'04'
@NM00462 DC    AL1(0)
@NM00463 DC    AL1(78)
         ORG   SCCW3PTS+32
@NM00464 DS    CL4
         ORG   @NM00464
@NM00465 DC    B'00000100'
@NM00466 DC    XL1'04'
@NM00467 DC    AL1(0)
@NM00468 DC    AL1(92)
         ORG   SCCW3PTS+36
@NM00469 DC    F'0'
         ORG   SCCW3PTS+40
SCCW4PTS DS    CL32
         ORG   SCCW4PTS
@NM00470 DS    CL4
         ORG   @NM00470
@NM00471 DC    B'00000100'
@NM00472 DC    XL1'04'
@NM00473 DC    AL1(0)
@NM00474 DC    AL1(22)
         ORG   SCCW4PTS+4
@NM00475 DS    CL4
         ORG   @NM00475
@NM00476 DC    B'00000100'
@NM00477 DC    XL1'04'
@NM00478 DC    AL1(0)
@NM00479 DC    AL1(36)
         ORG   SCCW4PTS+8
@NM00480 DS    CL4
         ORG   @NM00480
@NM00481 DC    B'00000100'
@NM00482 DC    XL1'04'
@NM00483 DC    AL1(0)
@NM00484 DC    AL1(50)
         ORG   SCCW4PTS+12
@NM00485 DS    CL4
         ORG   @NM00485
@NM00486 DC    B'00000100'
@NM00487 DC    XL1'04'
@NM00488 DC    AL1(0)
@NM00489 DC    AL1(64)
         ORG   SCCW4PTS+16
@NM00490 DS    CL4
         ORG   @NM00490
@NM00491 DC    B'00000100'
@NM00492 DC    XL1'04'
@NM00493 DC    AL1(0)
@NM00494 DC    AL1(78)
         ORG   SCCW4PTS+20
@NM00495 DS    CL4
         ORG   @NM00495
@NM00496 DC    B'00000100'
@NM00497 DC    XL1'04'
@NM00498 DC    AL1(0)
@NM00499 DC    AL1(92)
         ORG   SCCW4PTS+24
@NM00500 DS    CL4
         ORG   @NM00500
@NM00501 DC    B'00000100'
@NM00502 DC    XL1'00'
@NM00503 DC    AL1(0)
@NM00504 DC    AL1(106)
         ORG   SCCW4PTS+28
@NM00505 DC    F'0'
         ORG   SCCW4PTS+32
SCCW5LB1 DC    CL4'LCCW'
SCCW5LB3 DC    CL4'SEEK'
SCCW5LB4 DC    CL4'SSEC'
SCCW5PTS DS    CL40
         ORG   SCCW5PTS
@NM00506 DS    CL12
         ORG   @NM00506
@NM00507 DC    B'00001111'
@NM00508 DC    AL1(4-1+16*4-16)
@NM00509 DC    AL1(5)
@NM00510 DC    AL1(11)
@NM00511 DC    AL4(SCCW5LB1)
SCCW5DT1 DC    A(0)
         ORG   SCCW5PTS+12
@NM00512 DS    CL12
         ORG   @NM00512
@NM00513 DC    B'00001111'
@NM00514 DC    AL1(8-1+16*4-16)
@NM00515 DC    AL1(31)
@NM00516 DC    AL1(37)
@NM00517 DC    AL4(SCCW5LB3)
SCCW5DT3 DC    A(0)
         ORG   SCCW5PTS+24
@NM00518 DS    CL12
         ORG   @NM00518
@NM00519 DC    B'00001111'
@NM00520 DC    AL1(8-1+16*4-16)
@NM00521 DC    AL1(57)
@NM00522 DC    AL1(63)
@NM00523 DC    AL4(SCCW5LB4)
SCCW5DT4 DC    A(0)
         ORG   SCCW5PTS+36
@NM00524 DC    F'0'
         ORG   SCCW5PTS+40
SCCW6LB1 DC    CL4'SRCH'
SCCW6LB2 DC    CL3'TIC'
SCCW6LB3 DC    CL3'R/W'
         DS    CL2
SCCW6PTS DS    CL32
         ORG   SCCW6PTS
@NM00525 DS    CL12
         ORG   @NM00525
@NM00526 DC    B'00001111'
@NM00527 DC    AL1(8-1+16*4-16)
@NM00528 DC    AL1(5)
@NM00529 DC    AL1(11)
@NM00530 DC    AL4(SCCW6LB1)
SCCW6DT1 DC    A(0)
         ORG   SCCW6PTS+12
@NM00531 DS    CL8
         ORG   @NM00531
@NM00532 DC    B'00000111'
@NM00533 DC    AL1(8-1+16*3-16)
@NM00534 DC    AL1(31)
@NM00535 DC    AL1(37)
@NM00536 DC    AL4(SCCW6LB2)
         ORG   SCCW6PTS+20
@NM00537 DS    CL8
         ORG   @NM00537
@NM00538 DC    B'00000111'
@NM00539 DC    AL1(8-1+16*3-16)
@NM00540 DC    AL1(57)
@NM00541 DC    AL1(63)
@NM00542 DC    AL4(SCCW6LB3)
         ORG   SCCW6PTS+28
@NM00543 DC    F'0'
         ORG   SCCW6PTS+32
SCCWILB1 DC    CL4'LTIC'
SCCWIPTS DS    CL12
         ORG   SCCWIPTS
@NM00544 DS    CL8
         ORG   @NM00544
@NM00545 DC    B'00000111'
@NM00546 DC    AL1(8-1+16*4-16)
@NM00547 DC    AL1(5)
@NM00548 DC    AL1(11)
@NM00549 DC    AL4(SCCWILB1)
         ORG   SCCWIPTS+8
@NM00550 DC    F'0'
         ORG   SCCWIPTS+12
PCCW1LB1 DC    CL3'WID'
PCCW1LB2 DC    CL5'WSECT'
PCCW1LB3 DC    CL5'WFLGS'
PCCW1LB4 DC    CL5'WPCCW'
PCCW1LB5 DC    CL4'WAIA'
         DS    CL2
PCCW1PTS DS    CL64
         ORG   PCCW1PTS
@NM00551 DS    CL12
         ORG   @NM00551
@NM00552 DC    B'00001111'
@NM00553 DC    AL1(1-1+16*3-16)
@NM00554 DC    AL1(5)
@NM00555 DC    AL1(11)
@NM00556 DC    AL4(PCCW1LB1)
PCCW1DT1 DC    A(0)
         ORG   PCCW1PTS+12
@NM00557 DS    CL12
         ORG   @NM00557
@NM00558 DC    B'00001111'
@NM00559 DC    AL1(1-1+16*5-16)
@NM00560 DC    AL1(15+8)
@NM00561 DC    AL1(21+8)
@NM00562 DC    AL4(PCCW1LB2)
PCCW1DT2 DC    A(0)
         ORG   PCCW1PTS+24
@NM00563 DS    CL12
         ORG   @NM00563
@NM00564 DC    B'00001111'
@NM00565 DC    AL1(1-1+16*5-16)
@NM00566 DC    AL1(25+8+8)
@NM00567 DC    AL1(31+8+8)
@NM00568 DC    AL4(PCCW1LB3)
PCCW1DT3 DC    A(0)
         ORG   PCCW1PTS+36
@NM00569 DS    CL12
         ORG   @NM00569
@NM00570 DC    B'00001111'
@NM00571 DC    AL1(4-1+16*5-16)
@NM00572 DC    AL1(35+8+8+8)
@NM00573 DC    AL1(41+8+8+8)
@NM00574 DC    AL4(PCCW1LB4)
PCCW1DT4 DC    A(0)
         ORG   PCCW1PTS+48
@NM00575 DS    CL12
         ORG   @NM00575
@NM00576 DC    B'00001111'
@NM00577 DC    AL1(4-1+16*4-16)
@NM00578 DC    AL1(45+8+8+8+8)
@NM00579 DC    AL1(51+8+8+8+8)
@NM00580 DC    AL4(PCCW1LB5)
PCCW1DT5 DC    A(0)
         ORG   PCCW1PTS+60
@NM00581 DC    F'0'
         ORG   PCCW1PTS+64
PCCW2LB1 DC    CL5'WIORB'
PCCW2LB2 DC    CL2'WM'
PCCW2LB3 DC    CL3'WBB'
PCCW2LB4 DC    CL3'WCC'
PCCW2LB5 DC    CL3'WHH'
PCCW2LB6 DC    CL2'WR'
         DS    CL2
PCCW2PTS DS    CL76
         ORG   PCCW2PTS
@NM00582 DS    CL12
         ORG   @NM00582
@NM00583 DC    B'00001111'
@NM00584 DC    AL1(4-1+16*5-16)
@NM00585 DC    AL1(5)
@NM00586 DC    AL1(11)
@NM00587 DC    AL4(PCCW2LB1)
PCCW2DT1 DC    A(0)
         ORG   PCCW2PTS+12
@NM00588 DS    CL12
         ORG   @NM00588
@NM00589 DC    B'00001111'
@NM00590 DC    AL1(1-1+16*2-16)
@NM00591 DC    AL1(15+8)
@NM00592 DC    AL1(21+8)
@NM00593 DC    AL4(PCCW2LB2)
PCCW2DT2 DC    A(0)
         ORG   PCCW2PTS+24
@NM00594 DS    CL12
         ORG   @NM00594
@NM00595 DC    B'00001111'
@NM00596 DC    AL1(2-1+16*3-16)
@NM00597 DC    AL1(25+8+8)
@NM00598 DC    AL1(31+8+8)
@NM00599 DC    AL4(PCCW2LB3)
PCCW2DT3 DC    A(0)
         ORG   PCCW2PTS+36
@NM00600 DS    CL12
         ORG   @NM00600
@NM00601 DC    B'00001111'
@NM00602 DC    AL1(2-1+16*3-16)
@NM00603 DC    AL1(35+8+8+8)
@NM00604 DC    AL1(41+8+8+8)
@NM00605 DC    AL4(PCCW2LB4)
PCCW2DT4 DC    A(0)
         ORG   PCCW2PTS+48
@NM00606 DS    CL12
         ORG   @NM00606
@NM00607 DC    B'00001111'
@NM00608 DC    AL1(2-1+16*3-16)
@NM00609 DC    AL1(45+8+8+8+8)
@NM00610 DC    AL1(51+8+8+8+8)
@NM00611 DC    AL4(PCCW2LB5)
PCCW2DT5 DC    A(0)
         ORG   PCCW2PTS+60
@NM00612 DS    CL12
         ORG   @NM00612
@NM00613 DC    B'00001111'
@NM00614 DC    AL1(1-1+16*2-16)
@NM00615 DC    AL1(55+8+8+8+8+8)
@NM00616 DC    AL1(61+8+8+8+8+8)
@NM00617 DC    AL4(PCCW2LB6)
PCCW2DT6 DC    A(0)
         ORG   PCCW2PTS+72
@NM00618 DC    F'0'
         ORG   PCCW2PTS+76
PCCW3LB1 DC    CL4'SEEK'
PCCW3LB2 DC    CL4'SSEC'
PCCW3LB3 DC    CL4'SRCH'
PCCW3LB4 DC    CL3'TIC'
         DS    CL1
PCCW3PTS DS    CL40
         ORG   PCCW3PTS
@NM00619 DS    CL12
         ORG   @NM00619
@NM00620 DC    B'00001111'
@NM00621 DC    AL1(8-1+16*4-16)
@NM00622 DC    AL1(5)
@NM00623 DC    AL1(11)
@NM00624 DC    AL4(PCCW3LB1)
PCCW3DT1 DC    A(0)
         ORG   PCCW3PTS+12
@NM00625 DS    CL8
         ORG   @NM00625
@NM00626 DC    B'00000111'
@NM00627 DC    AL1(8-1+16*4-16)
@NM00628 DC    AL1(31)
@NM00629 DC    AL1(37)
@NM00630 DC    AL4(PCCW3LB2)
         ORG   PCCW3PTS+20
@NM00631 DS    CL8
         ORG   @NM00631
@NM00632 DC    B'00000111'
@NM00633 DC    AL1(8-1+16*4-16)
@NM00634 DC    AL1(57)
@NM00635 DC    AL1(63)
@NM00636 DC    AL4(PCCW3LB3)
         ORG   PCCW3PTS+28
@NM00637 DS    CL8
         ORG   @NM00637
@NM00638 DC    B'00000111'
@NM00639 DC    AL1(8-1+16*3-16)
@NM00640 DC    AL1(83)
@NM00641 DC    AL1(89)
@NM00642 DC    AL4(PCCW3LB4)
         ORG   PCCW3PTS+36
@NM00643 DC    F'0'
         ORG   PCCW3PTS+40
PCCW4LB1 DC    CL3'R/W'
PCCW4LB2 DC    CL3'NOP'
         DS    CL2
PCCW4PTS DS    CL20
         ORG   PCCW4PTS
@NM00644 DS    CL8
         ORG   @NM00644
@NM00645 DC    B'00000111'
@NM00646 DC    AL1(8-1+16*3-16)
@NM00647 DC    AL1(5)
@NM00648 DC    AL1(11)
@NM00649 DC    AL4(PCCW4LB1)
         ORG   PCCW4PTS+8
@NM00650 DS    CL8
         ORG   @NM00650
@NM00651 DC    B'00000111'
@NM00652 DC    AL1(8-1+16*3-16)
@NM00653 DC    AL1(31)
@NM00654 DC    AL1(37)
@NM00655 DC    AL4(PCCW4LB2)
         ORG   PCCW4PTS+16
@NM00656 DC    F'0'
         ORG   PCCW4PTS+20
IOR1LB1  DC    CL2'ID'
IOR1LB2  DC    CL3'NUM'
IOR1LB3  DC    CL4'RQSZ'
IOR1LB4  DC    CL4'FLGS'
IOR1LB5  DC    CL4'IORB'
IOR1LB6  DC    CL4'PCCW'
         DS    CL3
IOR1PTS  DS    CL76
         ORG   IOR1PTS
@NM00657 DS    CL12
         ORG   @NM00657
@NM00658 DC    B'00001111'
@NM00659 DC    AL1(1-1+16*2-16)
@NM00660 DC    AL1(5)
@NM00661 DC    AL1(11)
@NM00662 DC    AL4(IOR1LB1)
IOR1DT1  DC    A(0)
         ORG   IOR1PTS+12
@NM00663 DS    CL12
         ORG   @NM00663
@NM00664 DC    B'00001111'
@NM00665 DC    AL1(1-1+16*3-16)
@NM00666 DC    AL1(15+8)
@NM00667 DC    AL1(21+8)
@NM00668 DC    AL4(IOR1LB2)
IOR1DT2  DC    A(0)
         ORG   IOR1PTS+24
@NM00669 DS    CL12
         ORG   @NM00669
@NM00670 DC    B'00001111'
@NM00671 DC    AL1(1-1+16*4-16)
@NM00672 DC    AL1(25+8+8)
@NM00673 DC    AL1(31+8+8)
@NM00674 DC    AL4(IOR1LB3)
IOR1DT3  DC    A(0)
         ORG   IOR1PTS+36
@NM00675 DS    CL12
         ORG   @NM00675
@NM00676 DC    B'00001111'
@NM00677 DC    AL1(8/8-1+16*4-16)
@NM00678 DC    AL1(35+8+8+8)
@NM00679 DC    AL1(41+8+8+8)
@NM00680 DC    AL4(IOR1LB4)
IOR1DT4  DC    A(0)
         ORG   IOR1PTS+48
@NM00681 DS    CL12
         ORG   @NM00681
@NM00682 DC    B'00001111'
@NM00683 DC    AL1(4-1+16*4-16)
@NM00684 DC    AL1(45+8+8+8+8)
@NM00685 DC    AL1(51+8+8+8+8)
@NM00686 DC    AL4(IOR1LB5)
IOR1DT5  DC    A(0)
         ORG   IOR1PTS+60
@NM00687 DS    CL12
         ORG   @NM00687
@NM00688 DC    B'00001111'
@NM00689 DC    AL1(4-1+16*4-16)
@NM00690 DC    AL1(55+8+8+8+8+8)
@NM00691 DC    AL1(61+8+8+8+8+8)
@NM00692 DC    AL4(IOR1LB6)
IOR1DT6  DC    A(0)
         ORG   IOR1PTS+72
@NM00693 DC    F'0'
         ORG   IOR1PTS+76
IOR2LB1  DC    CL2'ID'
IOR2LB2  DC    CL3'NUM'
IOR2LB3  DC    CL4'RQSZ'
IOR2LB4  DC    CL4'FLGS'
IOR2LB5  DC    CL4'IORB'
IOR2LB6  DC    CL4'SCCW'
         DS    CL3
IOR2PTS  DS    CL76
         ORG   IOR2PTS
@NM00694 DS    CL12
         ORG   @NM00694
@NM00695 DC    B'00001111'
@NM00696 DC    AL1(1-1+16*2-16)
@NM00697 DC    AL1(5)
@NM00698 DC    AL1(11)
@NM00699 DC    AL4(IOR2LB1)
IOR2DT1  DC    A(0)
         ORG   IOR2PTS+12
@NM00700 DS    CL12
         ORG   @NM00700
@NM00701 DC    B'00001111'
@NM00702 DC    AL1(1-1+16*3-16)
@NM00703 DC    AL1(15+8)
@NM00704 DC    AL1(21+8)
@NM00705 DC    AL4(IOR2LB2)
IOR2DT2  DC    A(0)
         ORG   IOR2PTS+24
@NM00706 DS    CL12
         ORG   @NM00706
@NM00707 DC    B'00001111'
@NM00708 DC    AL1(1-1+16*4-16)
@NM00709 DC    AL1(25+8+8)
@NM00710 DC    AL1(31+8+8)
@NM00711 DC    AL4(IOR2LB3)
IOR2DT3  DC    A(0)
         ORG   IOR2PTS+36
@NM00712 DS    CL12
         ORG   @NM00712
@NM00713 DC    B'00001111'
@NM00714 DC    AL1(8/8-1+16*4-16)
@NM00715 DC    AL1(35+8+8+8)
@NM00716 DC    AL1(41+8+8+8)
@NM00717 DC    AL4(IOR2LB4)
IOR2DT4  DC    A(0)
         ORG   IOR2PTS+48
@NM00718 DS    CL12
         ORG   @NM00718
@NM00719 DC    B'00001111'
@NM00720 DC    AL1(4-1+16*4-16)
@NM00721 DC    AL1(45+8+8+8+8)
@NM00722 DC    AL1(51+8+8+8+8)
@NM00723 DC    AL4(IOR2LB5)
IOR2DT5  DC    A(0)
         ORG   IOR2PTS+60
@NM00724 DS    CL12
         ORG   @NM00724
@NM00725 DC    B'00001111'
@NM00726 DC    AL1(4-1+16*4-16)
@NM00727 DC    AL1(55+8+8+8+8+8)
@NM00728 DC    AL1(61+8+8+8+8+8)
@NM00729 DC    AL4(IOR2LB6)
IOR2DT6  DC    A(0)
         ORG   IOR2PTS+72
@NM00730 DC    F'0'
         ORG   IOR2PTS+76
IOR3LB1  DC    CL4'IOSB'
IOR3LB2  DC    CL4'SAVE'
IOR3LB3  DC    CL3'ERR'
IOR3LB4  DC    CL4'TSMP'
IOR3LB5  DC    CL5'PARTE'
IOR3PTS  DS    CL64
         ORG   IOR3PTS
@NM00731 DS    CL12
         ORG   @NM00731
@NM00732 DC    B'00001111'
@NM00733 DC    AL1(4-1+16*4-16)
@NM00734 DC    AL1(5)
@NM00735 DC    AL1(11)
@NM00736 DC    AL4(IOR3LB1)
IOR3DT1  DS    AL4
         ORG   IOR3PTS+12
@NM00737 DS    CL12
         ORG   @NM00737
@NM00738 DC    B'00001111'
@NM00739 DC    AL1(4-1+16*4-16)
@NM00740 DC    AL1(23)
@NM00741 DC    AL1(29)
@NM00742 DC    AL4(IOR3LB2)
IOR3DT2  DS    AL4
         ORG   IOR3PTS+24
@NM00743 DS    CL12
         ORG   @NM00743
@NM00744 DC    B'00001111'
@NM00745 DC    AL1(4-1+16*3-16)
@NM00746 DC    AL1(41)
@NM00747 DC    AL1(47)
@NM00748 DC    AL4(IOR3LB3)
IOR3DT3  DS    AL4
         ORG   IOR3PTS+36
@NM00749 DS    CL12
         ORG   @NM00749
@NM00750 DC    B'00001111'
@NM00751 DC    AL1(8-1+16*4-16)
@NM00752 DC    AL1(59)
@NM00753 DC    AL1(65)
@NM00754 DC    AL4(IOR3LB4)
IOR3DT4  DS    AL4
         ORG   IOR3PTS+48
@NM00755 DS    CL12
         ORG   @NM00755
@NM00756 DC    B'00001111'
@NM00757 DC    AL1(4-1+16*5-16)
@NM00758 DC    AL1(95)
@NM00759 DC    AL1(101)
@NM00760 DC    AL4(IOR3LB5)
IOR3DT5  DS    AL4
         ORG   IOR3PTS+60
@NM00761 DC    F'0'
         ORG   IOR3PTS+64
IOS1LB1  DC    CL4'+  0'
IOS1LB2  DC    CL3'FLA'
IOS1LB3  DC    CL3'FLB'
IOS1LB4  DC    CL3'FLC'
IOS1LB5  DC    CL4'PROC'
IOS1LB6  DC    CL5'DVRID'
IOS1LB7  DC    CL5'PRLVL'
IOS2LB1  DC    CL4'+  6'
IOS2LB2  DC    CL4'ASID'
IOS2LB3  DC    CL4'PGAD'
IOS2LB4  DC    CL4'PKEY'
IOS2LB5  DC    CL3'COD'
IOS2LB6  DC    CL3'OPT'
IOS2LB7  DC    CL4'OPT2'
IOS3LB1  DC    CL4'+ 10'
IOS3LB2  DC    CL3'UCB'
IOS3LB3  DC    CL2'CC'
IOS3LB4  DC    CL5'CSWCA'
IOS3LB5  DC    CL6'STATUS'
IOS3LB6  DC    CL5'CSWRC'
IOS3LB7  DC    CL3'SRB'
IOS4LB1  DC    CL4'+ 20'
IOS4LB2  DC    CL3'USE'
IOS4LB3  DC    CL5'RES4A'
IOS4LB4  DC    CL5'APMSK'
IOS4LB5  DC    CL3'SNS'
IOS4LB6  DC    CL4'IPIB'
IOS4LB7  DC    CL4'PCHN'
IOS5LB1  DC    CL4'+ 34'
IOS5LB2  DC    CL3'ERP'
IOS5LB3  DC    CL3'PCI'
IOS5LB4  DC    CL3'NRM'
IOS5LB5  DC    CL3'ABN'
IOS5LB6  DC    CL3'DIE'
IOS5LB7  DC    CL3'RST'
IOS6LB1  DC    CL4'+ 4C'
IOS6LB2  DC    CL3'VST'
IOS6LB3  DC    CL4'DSID'
IOS6LB4  DC    CL5'RSS1B'
IOS6LB5  DC    CL3'AFF'
IOS6LB6  DC    CL4'PATH'
IOS6LB7  DC    CL4'FMSK'
IOS7LB1  DC    CL4'+ 59'
IOS7LB2  DC    CL4'CKEY'
IOS7LB3  DC    CL3'MDB'
IOS7LB4  DC    CL3'MDM'
IOS8LB1  DC    CL4'+ 64'
IOS8LB2  DC    CL3'SKM'
IOS8LB3  DC    CL4'SKBB'
IOS8LB4  DC    CL4'SKCC'
IOS8LB5  DC    CL4'SKHH'
IOS8LB6  DC    CL3'SKR'
         DS    CL2
IOS8PTS  DS    CL56
         ORG   IOS8PTS
@NM01045 DS    CL8
         ORG   @NM01045
@NM01046 DC    B'00000011'
@NM01047 DC    AL1(16*4-16)
@NM01048 DC    AL1(0)
@NM01049 DC    AL1(0)
@NM01050 DC    AL4(IOS8LB1)
         ORG   IOS8PTS+8
@NM01051 DS    CL12
         ORG   @NM01051
@NM01052 DC    B'00001111'
@NM01053 DC    AL1(1-1+16*3-16)
@NM01054 DC    AL1(5)
@NM01055 DC    AL1(11)
@NM01056 DC    AL4(IOS8LB2)
IOS8DT2  DC    A(0)
         ORG   IOS8PTS+20
@NM01057 DS    CL8
         ORG   @NM01057
@NM01058 DC    B'00000111'
@NM01059 DC    AL1(2-1+16*4-16)
@NM01060 DC    AL1(23)
@NM01061 DC    AL1(29)
@NM01062 DC    AL4(IOS8LB3)
         ORG   IOS8PTS+28
@NM01063 DS    CL8
         ORG   @NM01063
@NM01064 DC    B'00000111'
@NM01065 DC    AL1(2-1+16*4-16)
@NM01066 DC    AL1(41)
@NM01067 DC    AL1(47)
@NM01068 DC    AL4(IOS8LB4)
         ORG   IOS8PTS+36
@NM01069 DS    CL8
         ORG   @NM01069
@NM01070 DC    B'00000111'
@NM01071 DC    AL1(2-1+16*4-16)
@NM01072 DC    AL1(59)
@NM01073 DC    AL1(65)
@NM01074 DC    AL4(IOS8LB5)
         ORG   IOS8PTS+44
@NM01075 DS    CL8
         ORG   @NM01075
@NM01076 DC    B'00000111'
@NM01077 DC    AL1(1-1+16*3-16)
@NM01078 DC    AL1(77)
@NM01079 DC    AL1(83)
@NM01080 DC    AL4(IOS8LB6)
         ORG   IOS8PTS+52
@NM01081 DC    F'0'
         ORG   IOS8PTS+56
ADDRTAB  DC    AL4(IOS1PTS)
         DC    AL4(IOS2PTS)
         DC    AL4(IOS3PTS)
         DC    AL4(IOS4PTS)
         DC    AL4(IOS5PTS)
         DC    AL4(IOS6PTS)
         DC    AL4(IOS7PTS)
FMTPATCH DC    50F'0'
SAVEIOR  DC    18F'0'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
MAPPTR   EQU   @06
I        EQU   @12
FORMRC   EQU   @02
SDCTRC   EQU   @07
SAVPTR   EQU   @03
SATRC    EQU   @08
SCCWRC   EQU   @06
REM      EQU   @07
PCCWRC   EQU   @06
IOSRC    EQU   @02
IORRC    EQU   @07
CUMRC    EQU   @11
RTNADDR3 EQU   @08
PPTRNPTR EQU   @02
AIAPTR   EQU   @12
SDCTEPTR EQU   @06
R0       EQU   @00
R1       EQU   @01
R2       EQU   @02
R3       EQU   @03
R9       EQU   @09
R10      EQU   @10
R14      EQU   @14
R15      EQU   @15
R11      EQU   @11
R12      EQU   @12
R13      EQU   @13
R4       EQU   @04
R5       EQU   @05
R6       EQU   @06
R7       EQU   @07
R8       EQU   @08
ABDPL    EQU   0
ADPLFLAG EQU   ABDPL+7
ADPLBUF  EQU   ABDPL+8
ADPLPRNT EQU   ABDPL+12
ADPLMEMA EQU   ABDPL+20
ADPLFRMT EQU   ABDPL+24
ASMVT    EQU   0
ASMFLAG1 EQU   ASMVT
ASMFLAG2 EQU   ASMVT+1
ASMSART  EQU   ASMVT+4
ASMSTAGQ EQU   ASMVT+32
ASMPCCWQ EQU   ASMVT+64
ASMPCCWN EQU   ASMVT+72
ASMLSAI  EQU   ASMVT+144
ASMGOSQS EQU   ASMVT+152
ASMWKSA1 EQU   ASMVT+368
ASMWKSA2 EQU   ASMVT+448
ASMWKSA3 EQU   ASMVT+528
ASMWKSA4 EQU   ASMVT+608
ASMWKSA5 EQU   ASMVT+688
ASMPOOLS EQU   0
ASMCPAVQ EQU   ASMPOOLS+8
ASMCPRSQ EQU   ASMPOOLS+16
IORB     EQU   0
IORID    EQU   IORB
IORNUM   EQU   IORB+1
IORRQSZ  EQU   IORB+2
IORFLGS  EQU   IORB+3
IORAPND  EQU   IORFLGS
IORIORB  EQU   IORB+4
IORPCCW  EQU   IORB+8
IORSCCW  EQU   IORPCCW
IORIOSB  EQU   IORB+12
IORSAVE  EQU   IORB+16
IORERR   EQU   IORB+20
IORTSMP  EQU   IORB+24
IORPARTE EQU   IORB+32
IOSB     EQU   0
IOSFLA   EQU   IOSB
IOSACHN  EQU   IOSFLA
IOSFLB   EQU   IOSB+1
IOSFLC   EQU   IOSB+2
IOSDVALT EQU   IOSFLC
IOSPROC  EQU   IOSB+3
IOSDVRID EQU   IOSB+4
IOSPRLVL EQU   IOSB+5
IOSASID  EQU   IOSB+6
IOSPGAD  EQU   IOSB+8
IOSPKEY  EQU   IOSB+12
IOSCOD   EQU   IOSB+13
IOSOPT   EQU   IOSB+14
IOSOPT2  EQU   IOSB+15
IOSUCB   EQU   IOSB+16
@NM00009 EQU   IOSB+20
IOSCC    EQU   @NM00009
IOSCSW   EQU   @NM00009+1
IOSCSWCA EQU   IOSCSW
IOSTATUS EQU   IOSCSW+3
IOSCSWRC EQU   IOSCSW+5
IOSSRB   EQU   IOSB+28
IOSUSE   EQU   IOSB+32
IOSRES4A EQU   IOSB+36
IOSAPMSK EQU   IOSB+40
IOSSNS   EQU   IOSB+42
IOSIPIB  EQU   IOSB+44
IOSPCHN  EQU   IOSB+48
IOSERP   EQU   IOSB+52
IOSPCI   EQU   IOSB+56
IOSNRM   EQU   IOSB+60
IOSABN   EQU   IOSB+64
IOSDIE   EQU   IOSB+68
IOSDIEFG EQU   IOSDIE
IOSRST   EQU   IOSB+72
IOSVST   EQU   IOSB+76
IOSDSID  EQU   IOSB+80
IOSRSS1B EQU   IOSB+84
IOSAFF   EQU   IOSB+85
IOSPATH  EQU   IOSB+86
IOSCHN   EQU   IOSPATH
IOSFMSK  EQU   IOSB+88
IOSCKEY  EQU   IOSB+89
IOSMDB   EQU   IOSB+90
IOSMDM   EQU   IOSB+91
IOSEEKA  EQU   IOSB+100
IOSSKM   EQU   IOSEEKA
IOSSKBB  EQU   IOSEEKA+1
IOSCCHH  EQU   IOSEEKA+3
IOSSKCC  EQU   IOSCCHH
IOSSKHH  EQU   IOSCCHH+2
IOSSKR   EQU   IOSEEKA+7
PCCW     EQU   0
PCCWID   EQU   PCCW
PCCWSECT EQU   PCCW+1
PCCWFLGS EQU   PCCW+2
PCCWPCCW EQU   PCCW+4
PCCWAIA  EQU   PCCW+8
PCCWIORB EQU   PCCW+12
PCCWCHHR EQU   PCCW+16
PCCWM    EQU   PCCWCHHR
PCCWBB   EQU   PCCWCHHR+1
PCCWCC   EQU   PCCWCHHR+3
PCCWHH   EQU   PCCWCHHR+5
PCCWR    EQU   PCCWCHHR+7
PCCWSEEK EQU   PCCW+24
PCCWSSEC EQU   PCCW+32
PCCWSRCH EQU   PCCW+40
PCCWTIC  EQU   PCCW+48
PCCWRW   EQU   PCCW+56
PCCWNOP  EQU   PCCW+64
SART     EQU   0
SARTHDR  EQU   SART
SARID    EQU   SARTHDR
SARSIZE  EQU   SARTHDR+4
SARUSE   EQU   SARTHDR+8
SARFXDNX EQU   SARTHDR+16
SARMOVNX EQU   SARTHDR+20
SARDSNL  EQU   SARTHDR+24
SARSDCT  EQU   SARTHDR+28
SARSCCWQ EQU   SARTHDR+32
SARSETCT EQU   SARTHDR+36
SARWAITQ EQU   SARTHDR+40
SARWAITF EQU   SARWAITQ
SARWAITL EQU   SARWAITQ+4
SARSRBP  EQU   SARTHDR+48
SARSRBCT EQU   SARTHDR+52
SARSETSZ EQU   SARTHDR+56
SARENTS  EQU   SART+80
SARTE    EQU   0
SRENEXT  EQU   SARTE
SRELOCK  EQU   SARTE+4
SREFLG   EQU   SARTE+9
SRENN    EQU   SARTE+10
SRESCCW  EQU   SARTE+12
SRETOTSL EQU   SARTE+16
SREAVLSL EQU   SARTE+20
SRERRCNT EQU   SARTE+24
SREIORB  EQU   SARTE+28
SRESAT   EQU   SARTE+32
SRESDCTE EQU   SARTE+36
SREEDB   EQU   SARTE+40
SREUCB   EQU   SARTE+44
SAT      EQU   0
SATHDR   EQU   SAT
SATID    EQU   SATHDR
SATSARTE EQU   SATHDR+4
SATMAPLN EQU   SATHDR+8
SATBYTCL EQU   SATHDR+10
SATOFFST EQU   SATHDR+12
SATMASK  EQU   SATHDR+14
SATSCAN  EQU   SATHDR+16
SATSLTNO EQU   SATHDR+20
SATASGN  EQU   SATHDR+24
SATMAPS  EQU   SAT+32
SATCYLMP EQU   0
SCCW     EQU   0
SCCWHDR  EQU   SCCW
SCCWID   EQU   SCCWHDR
SCCWSECT EQU   SCCWHDR+1
SCCWFLAG EQU   SCCWHDR+2
SCCWSCCW EQU   SCCWHDR+4
SCCWAIA  EQU   SCCWHDR+8
SCCWIORB EQU   SCCWHDR+12
SCCWSARG EQU   SCCWHDR+16
SCCWM    EQU   SCCWSARG
SCCWSRH  EQU   SCCWSARG+3
SCCWCCHH EQU   SCCWSRH
SCCWLCCW EQU   SCCWHDR+80
SCCWCCW  EQU   SCCW+88
SCCWSEEK EQU   SCCWCCW
SCCWSSEC EQU   SCCWCCW+8
SCCWSLOT EQU   SCCWCCW+16
SCCWSRCH EQU   SCCWSLOT
SCCWTIC  EQU   SCCWSLOT+8
SCCWRW   EQU   SCCWSLOT+16
SCCWLTIC EQU   SCCWCCW+304
SDCT     EQU   0
SDCHDR   EQU   SDCT
SDCID    EQU   SDCHDR
SDCSIZE  EQU   SDCHDR+4
SDCRSV1  EQU   SDCHDR+6
SDCTE    EQU   0
SDCDEVTP EQU   SDCTE
SDCDTYPX EQU   SDCTE+6
SDCSLTRK EQU   SDCTE+8
SDCCYLSZ EQU   SDCTE+10
SDCCMASK EQU   SDCTE+12
SDCSSECT EQU   SDCTE+16
ACCESS   EQU   0
FORMAT   EQU   0
PRINT    EQU   0
BUFFER   EQU   0
ANCHTXT  EQU   BUFFER+17
ANCHNAME EQU   BUFFER+29
PTTRNS   EQU   0
PTTSTOP  EQU   PTTRNS
PTTFLGS  EQU   PTTSTOP
PTTLBPTR EQU   PTTRNS+4
PTTDTPTR EQU   PTTRNS+8
CURRENT  EQU   0
HALFCURR EQU   0
DSNAME   EQU   0
MESSAGE  EQU   0
ASM1WKSV EQU   ASMWKSA1
ASM1RGSV EQU   ASM1WKSV
ASM1WRKA EQU   ASM1WKSV+60
ASM2WKSV EQU   ASMWKSA2
ASM2WRKA EQU   ASM2WKSV+52
ASM2FLGS EQU   ASM2WRKA+12
ASM3WKSV EQU   ASMWKSA3
ASM4WKSV EQU   ASMWKSA4
ASM4RGSV EQU   ASM4WKSV
ASM5WKSV EQU   ASMWKSA5
ASM5RGSV EQU   ASM5WKSV
IOSATTSC EQU   IOSIPIB
IOSWTOWA EQU   IOSIPIB
IOSPCISC EQU   IOSIPIB
DUMIORB  EQU   IORBTYPE
IORBSWAP EQU   DUMIORB+3
SCCWSK   EQU   SCCWSARG
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00042 EQU   DUMIORB+3
@NM00041 EQU   DUMIORB+3
@NM00040 EQU   DUMIORB
IOSPCIWA EQU   IOSPCISC+44
IOSPCIRS EQU   IOSPCISC+8
@NM00014 EQU   IOSPCISC+4
@NM00013 EQU   IOSPCISC
IOSWRNDR EQU   IOSWTOWA+4
IOSWTOPT EQU   IOSWTOWA+3
IOSWTOCP EQU   IOSWTOWA+2
IOSWTOCH EQU   IOSWTOWA
IOSATTWA EQU   IOSATTSC+40
@NM00012 EQU   IOSATTSC+24
IOSATTSN EQU   IOSATTSC
ASM5FLGS EQU   ASM5WKSV+64
ASM5AIA  EQU   ASM5WKSV+60
ASM5GCTR EQU   ASM5WKSV+56
ASM5SR14 EQU   ASM5WKSV+52
@NM00005 EQU   ASM5RGSV+4
ASM5RG2  EQU   ASM5RGSV
@NM00004 EQU   ASM4RGSV+4
ASM4RG2  EQU   ASM4RGSV
ASM3SR13 EQU   ASM3WKSV+28
ASM3R14B EQU   ASM3WKSV+24
ASM3R14A EQU   ASM3WKSV+20
ASM3GRPA EQU   ASM3WKSV+16
ASM3TMPA EQU   ASM3WKSV+12
ASM3PIOP EQU   ASM3WKSV+8
ASM3GENQ EQU   ASM3WKSV+4
ASM3SWPQ EQU   ASM3WKSV
ASM2SR14 EQU   ASM2WRKA+16
@NM00003 EQU   ASM2WRKA+13
ASM2WFLG EQU   ASM2FLGS
ASM2RFLG EQU   ASM2FLGS
ASM2DUPQ EQU   ASM2WRKA+8
ASM2CAQ  EQU   ASM2WRKA+4
ASM2PAQ  EQU   ASM2WRKA
ASM2RGSV EQU   ASM2WKSV
ASM1NXTA EQU   ASM1WRKA+4
ASM1ASCB EQU   ASM1WRKA
ASM1RG15 EQU   ASM1RGSV+56
@NM00002 EQU   ASM1RGSV+4
ASM1RG1  EQU   ASM1RGSV
PTTDTOFF EQU   PTTSTOP+3
PTTLBOFF EQU   PTTSTOP+2
PTTDTLGH EQU   PTTSTOP+1
PTTLBLGH EQU   PTTSTOP+1
PTTFLBBF EQU   PTTFLGS
PTTFLBLP EQU   PTTFLGS
PTTFDTBF EQU   PTTFLGS
PTTFDATP EQU   PTTFLGS
PTTFSTR  EQU   PTTFLGS
PTTFASIS EQU   PTTFLGS
@NM00034 EQU   PTTFLGS
@NM00033 EQU   BUFFER+28
@NM00032 EQU   BUFFER+8
@NM00031 EQU   BUFFER
SDCRESV  EQU   SDCTE+18
SDCMPEXP EQU   SDCTE+17
@NM00030 EQU   SDCT+128
SDCENTS  EQU   SDCT+8
@NM00029 EQU   SCCWLTIC+4
SCCWLTAD EQU   SCCWLTIC+1
SCCWLTOP EQU   SCCWLTIC
SCCWRWCT EQU   SCCWRW+6
@NM00028 EQU   SCCWRW+5
SCCWRWFL EQU   SCCWRW+4
SCCWRWAD EQU   SCCWRW+1
SCCWRWOP EQU   SCCWRW
@NM00027 EQU   SCCWTIC+4
SCCWTIAD EQU   SCCWTIC+1
SCCWTIOP EQU   SCCWTIC
SCCWSRCT EQU   SCCWSRCH+6
@NM00026 EQU   SCCWSRCH+5
SCCWSRFL EQU   SCCWSRCH+4
SCCWSRAD EQU   SCCWSRCH+1
SCCWSROP EQU   SCCWSRCH
SCCWFLCT EQU   SCCWSSEC+4
SCCWSSAD EQU   SCCWSSEC+1
SCCWSSOP EQU   SCCWSSEC
SCCWFGCT EQU   SCCWSEEK+4
SCCWSKAD EQU   SCCWSEEK+1
SCCWSKOP EQU   SCCWSEEK
SCCWSVOA EQU   SCCWHDR+84
SCCWRSV1 EQU   SCCWSARG+63
SCCWR    EQU   SCCWSRH+4
SCCWHH   EQU   SCCWCCHH+2
SCCWCC   EQU   SCCWCCHH
SCCWBB   EQU   SCCWSARG+1
@NM00025 EQU   SCCWHDR+3
@NM00024 EQU   SCCWFLAG
SCCWERR  EQU   SCCWFLAG
@NM00023 EQU   SATHDR+28
@NM00022 EQU   SATHDR+15
@NM00021 EQU   SREFLG
SREFIXED EQU   SREFLG
SREDRIVE EQU   SREFLG
SREDSBD  EQU   SREFLG
SRENUSE  EQU   SREFLG
@NM00020 EQU   SARTE+8
@NM00019 EQU   SARTHDR+60
@NM00018 EQU   SARTHDR+12
@NM00017 EQU   PCCW+72
PCCWNCT  EQU   PCCWNOP+6
PCCWNFG  EQU   PCCWNOP+4
PCCWNAD  EQU   PCCWNOP+1
PCCWN    EQU   PCCWNOP
PCCWCNT  EQU   PCCWRW+6
PCCWRWFG EQU   PCCWRW+4
PCCWADDR EQU   PCCWRW+1
PCCWRDWT EQU   PCCWRW
PCCWTCT  EQU   PCCWTIC+6
PCCWTFG  EQU   PCCWTIC+4
PCCWTAD  EQU   PCCWTIC+1
PCCWT    EQU   PCCWTIC
PCCWSICT EQU   PCCWSRCH+6
PCCWSIFG EQU   PCCWSRCH+4
PCCWSIAD EQU   PCCWSRCH+1
PCCWSIDE EQU   PCCWSRCH
PCCWSSCT EQU   PCCWSSEC+6
PCCWSSFG EQU   PCCWSSEC+4
PCCWSSAD EQU   PCCWSSEC+1
PCCWSS   EQU   PCCWSSEC
PCCWSKCT EQU   PCCWSEEK+6
PCCWSKFG EQU   PCCWSEEK+4
PCCWSKAD EQU   PCCWSEEK+1
PCCWSK   EQU   PCCWSEEK
@NM00016 EQU   PCCW+3
@NM00015 EQU   PCCWFLGS
PCCWFERR EQU   PCCWFLGS
IOSEND   EQU   IOSB+108
IOSSKH2  EQU   IOSSKHH+1
IOSSKH1  EQU   IOSSKHH
IOSEEK   EQU   IOSB+92
IOSCKEY7 EQU   IOSCKEY
IOSCKEY6 EQU   IOSCKEY
IOSCKEY5 EQU   IOSCKEY
IOSCKEY4 EQU   IOSCKEY
@NM00011 EQU   IOSCKEY
IOSCUDEV EQU   IOSPATH+1
@NM00010 EQU   IOSCHN
IOSPATH3 EQU   IOSCHN
IOSPATH2 EQU   IOSCHN
IOSEXP   EQU   IOSCHN
IOSGDP   EQU   IOSCHN
IOSNOTRS EQU   IOSDIEFG
IOSTSB   EQU   IOSTATUS+1
IOSTSA   EQU   IOSTATUS
IOSOPT2X EQU   IOSOPT2
IOSHTP   EQU   IOSOPT2
IOSRELSE EQU   IOSOPT
IOSAPR   EQU   IOSOPT
IOSTSLL  EQU   IOSOPT
IOSNERP  EQU   IOSOPT
IOSPSLL  EQU   IOSOPT
IOSQISCE EQU   IOSOPT
IOSDEP   EQU   IOSOPT
IOSBYP   EQU   IOSOPT
IOSPKY7  EQU   IOSPKEY
IOSPGDPX EQU   IOSPKEY
IOSIDR   EQU   IOSPKEY
IOSLCL   EQU   IOSPKEY
@NM00008 EQU   IOSPKEY
IOSFLC7  EQU   IOSFLC
IOSFLC6  EQU   IOSFLC
IOSRWAIT EQU   IOSFLC
IOSTP    EQU   IOSFLC
IOSCC3WE EQU   IOSFLC
IOSVERIF EQU   IOSDVALT
IOSDVMNT EQU   IOSFLC
IOSLOG   EQU   IOSFLB
IOSBDCST EQU   IOSFLB
IOSMSG   EQU   IOSFLB
IOSFLB4  EQU   IOSFLB
IOSFLB3  EQU   IOSFLB
IOSFLB2  EQU   IOSFLB
IOSSDR   EQU   IOSFLB
IOSDIESE EQU   IOSFLB
IOSIOSB  EQU   IOSFLA
IOSDOM   EQU   IOSFLA
IOSEX    EQU   IOSFLA
IOSSMDB  EQU   IOSFLA
IOSSMDA  EQU   IOSFLA
IOSERR   EQU   IOSFLA
IOSCCHN  EQU   IOSACHN
IOSDCHN  EQU   IOSACHN
@NM00007 EQU   IORB+40
IORRSV   EQU   IORB+36
IORFAE   EQU   IORAPND
IORFNE   EQU   IORAPND
IORFDI   EQU   IORAPND
IORSWAP  EQU   IORFLGS
@NM00006 EQU   IORFLGS
IORFRPS  EQU   IORFLGS
IORFUSE  EQU   IORFLGS
ASMCPRES EQU   ASMCPRSQ+4
ASMCPTAK EQU   ASMCPRSQ
ASMCPCNT EQU   ASMCPAVQ+4
ASMCPAVL EQU   ASMCPAVQ
ASMCPEXT EQU   ASMPOOLS+6
ASMCPSIZ EQU   ASMPOOLS+4
ASMCPID  EQU   ASMPOOLS
ASMRSV12 EQU   ASMVT+1000
ASMSAVE  EQU   ASMVT+928
ASMWKSA7 EQU   ASMVT+848
ASMWKSA6 EQU   ASMVT+768
ASMACEPC EQU   ASMVT+344
ASMSWKPC EQU   ASMVT+328
ASMBWKPC EQU   ASMVT+312
ASMIOEPC EQU   ASMVT+296
ASMRSV10 EQU   ASMVT+280
ASMPVACE EQU   ASMVT+276
ASMPIOFR EQU   ASMVT+272
ASMPVACQ EQU   ASMVT+268
ASMPMSGS EQU   ASMVT+264
ASMPMSG0 EQU   ASMVT+260
ASMPFRLG EQU   ASMVT+256
ASMPRLG  EQU   ASMVT+252
ASMPACT  EQU   ASMVT+248
ASMPSAV  EQU   ASMVT+244
ASMPCMP  EQU   ASMVT+240
ASMPCMPA EQU   ASMVT+236
ASMPCMPN EQU   ASMVT+232
ASMPCMPD EQU   ASMVT+228
ASMPEX   EQU   ASMVT+224
ASMVRMTR EQU   ASMVT+220
ASMPSRBC EQU   ASMVT+216
ASMPSRMT EQU   ASMVT+212
ASMPSWPD EQU   ASMVT+208
ASMPTM   EQU   ASMVT+204
ASMPFRSW EQU   ASMVT+200
ASMPFRSL EQU   ASMVT+196
ASMPQIOE EQU   ASMVT+192
ASMRSV8  EQU   ASMVT+184
ASMTASCB EQU   ASMVT+180
ASMRLGWQ EQU   ASMVT+176
ASMRLGRQ EQU   ASMVT+172
ASMTMECB EQU   ASMVT+168
ASMTCBPT EQU   ASMVT+164
ASMREQCT EQU   ASMVT+160
ASMGOSWK EQU   ASMGOSQS+4
ASMGOSWT EQU   ASMGOSQS
ASMLSAIH EQU   ASMLSAI+4
ASMLSAIL EQU   ASMLSAI
ASMCINV  EQU   ASMVT+140
ASMSTGXA EQU   ASMVT+136
ASMLGVT  EQU   ASMVT+132
ASMSLOTV EQU   ASMVT+128
ASMERRS  EQU   ASMVT+124
ASMNVSC  EQU   ASMVT+120
ASMVSC   EQU   ASMVT+116
ASMSLOTS EQU   ASMVT+112
ASMBKSLT EQU   ASMVT+108
ASMRSV7  EQU   ASMVT+92
ASMPSRB  EQU   ASMVT+88
ASMSRBCT EQU   ASMVT+84
ASMIOCNT EQU   ASMVT+80
ASMBURST EQU   ASMVT+76
ASMPCCWC EQU   ASMPCCWQ+4
ASMPCCWA EQU   ASMPCCWQ
ASMRSV6  EQU   ASMVT+48
ASMIORQC EQU   ASMVT+44
ASMIORQR EQU   ASMVT+40
ASMSTAGL EQU   ASMSTAGQ+4
ASMSTAGF EQU   ASMSTAGQ
ASMRSV5  EQU   ASMVT+28
ASMMSGBF EQU   ASMVT+24
ASMEREC  EQU   ASMVT+20
ASMTRPAG EQU   ASMVT+16
ASMGOS   EQU   ASMVT+12
ASMPART  EQU   ASMVT+8
ASMRSV4  EQU   ASMVT+2
ASMWARM  EQU   ASMFLAG2
ASMQUICK EQU   ASMFLAG2
ASMNOTPT EQU   ASMFLAG2
ASMNOTMR EQU   ASMFLAG2
ASMNOSAV EQU   ASMFLAG2
ASMCALLQ EQU   ASMFLAG2
ASMPLPAS EQU   ASMFLAG1
ASMCOMMF EQU   ASMFLAG1
ASMPLPAF EQU   ASMFLAG1
ASMNODPX EQU   ASMFLAG1
ASMRSV1  EQU   ASMFLAG1
ASMNOLCL EQU   ASMFLAG1
ASMNOCWQ EQU   ASMFLAG1
ASMDUPLX EQU   ASMFLAG1
ADPLEXT  EQU   ABDPL+52
ADPLFMT2 EQU   ABDPL+48
ADPLFMT1 EQU   ABDPL+44
ADPLCOM4 EQU   ABDPL+40
ADPLCOM3 EQU   ABDPL+36
ADPLCOM2 EQU   ABDPL+32
ADPLCOM1 EQU   ABDPL+28
ADPLCVT  EQU   ABDPL+16
@NM00001 EQU   ADPLFLAG
ADPLSYTM EQU   ADPLFLAG
ADPLSNPR EQU   ADPLFLAG
ADPLSBPL EQU   ABDPL+6
ADPLASID EQU   ABDPL+4
ADPLTCB  EQU   ABDPL
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RF00122 EQU   @RC00116
@RT00132 EQU   NOSART
@RC00190 EQU   @RC00128
@PB00009 EQU   @EL00001
@PB00008 EQU   @PB00009
@ENDDATA EQU   *
         END   ILRFMTSW,(C'PLS1824',0701,76169)
