         TITLE 'ILRPTM, ASM PART MONITOR                               *
                        '
ILRPTM   CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'ILRPTM    76.114'                                 0001
         DROP  @15
@PROLOG  BALR  @10,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@10                                         0001
*                                                                  0088
*/********************************************************************/
*/*                                                                  */
*/* ILRPTM: DECIDES WHEN TO SLOT SORT PAGES FOR A PAGING DATA SET    */
*/*                                                                  */
*/* INPUT:    SEE MODULE PROLOGUE                                    */
*/*                                                                  */
*/* PROCESS:  ILRPTM CHECKS EACH DATA SET (REPRESENTED BY A PART     */
*/*           ENTRY) FOR A NON-ZERO READ OR WRITE QUEUE.  IF THERE   */
*/*           IS WORK FOR THAT DATA SET AND AN IORB IS FREE, THE     */
*/*           PART ENTRY IS LOCKED AND SLOT SORT IS CALLED TO GET    */
*/*           I/O STARTED.                                           */
*/*                                                                  */
*/*            NOTE:  THE 'CPU ID' IS INITIALIZED TO ZERO BY ASM'S   */
*/*            RIM .  'CPU ID' ID IS A COUNTER USED TO IDENTIFY      */
*/*            A SPECIFIC SRB.                                       */
*/*                                                                  */
*/*  OUTPUT:  NONE                                                   */
*/*                                                                  */
*/********************************************************************/
*                                                                  0088
*   /*****************************************************************/
*   /*                                                               */
*   /* RESET COUNT OF PTMS SCHEDULED- SPECIFICALLY DONE HERE FOR     */
*   /* RECOVERY                                                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0088
*   ASMVTPTR=CVTASMVT;              /* SET ASMVT BASE                */
         L     @12,CVTPTR                                          0088
         L     ASMVTPTR,CVTASMVT(,@12)                             0088
*   RFY                                                            0089
*    (R6,                                                          0089
*     R7) RSTD;                                                    0089
*   R7=ASMSRBCT;                    /* GET CURRENT SRB COUNT         */
         L     R7,ASMSRBCT(,ASMVTPTR)                              0090
*   R6=0;                           /* RESET VALUE                   */
         SLR   R6,R6                                               0091
*RETRYP1:                                                          0092
*   CS(R7,R6,ASMSRBCT);             /* REPLACE WITH 0                */
RETRYP1  CS    R7,@06,ASMSRBCT(ASMVTPTR)                           0092
*   BC(NE,RETRYP1);                                                0093
         BC    7,RETRYP1                                           0093
*   RFY                                                            0094
*    (R6,                                                          0094
*     R7) UNRSTD;                                                  0094
*                                                                  0094
*   /*****************************************************************/
*   /*                                                               */
*   /* ESTABLISH RECOVERY ENVIRONMENT                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0095
*   RFY                                                            0095
*    (R1,                                                          0095
*     R4,                                                          0095
*     R6,                                                          0095
*     R7) RSTD;                                                    0095
*   R1=ADDR(ILRSRT01);              /* GET RECOVERY RTN ADDRESS      */
         L     R1,@CV01756                                         0096
*PTMARCV1:                                                         0097
*   GEN REFS(R1,R4,R6,R7,PSACSTK,FRRSCURR,FRRSLAST,FRRS,FRRSENTR,  0097
*       FRRSPARM,PSALSFCC,FRRSELEN,FRRSFRRA);                      0097
PTMARCV1 DS    0H                                                  0097
         SETFRR A,FRRAD=(R1),PARMAD=(R4),WRKREGS=(R6,R7),              *
               RELATED=(PAGE,ILRPTM(PTMDRCV1))
*   RFY                                                            0098
*    (R1,                                                          0098
*     R6,                                                          0098
*     R7) UNRSTD;                                                  0098
*   ATAMODID=ATAMPTM;               /* TELL RECOVERY WHO WE ARE      */
         MVI   ATAMODID(ATAPTR),X'07'                              0099
*   R9=WSACASMS;                    /* SET ADDRESSABILITY TO WORKAREA*/
         L     @12,LCCAPTR                                         0100
         L     @12,LCCACPUS(,@12)                                  0100
         L     R9,WSACASMS(,@12)                                   0100
*   GEN REFS(R9)(USING @DATD,R9);                                  0101
         USING @DATD,R9
*   ZEROWORK=''B;                   /* ZERO ENTIRE PTM WORKAREA      */
         XC    ZEROWORK(256,R9),ZEROWORK(R9)                       0102
*   ATAWORKA=R9;                    /* LET RECOVERY KNOW WHERE ITS AT*/
         ST    R9,ATAWORKA(,ATAPTR)                                0103
*   ATAEPATH=ADDR(EPATH);           /* SET EPATH ADDRESS IN ATA      */
         LA    @12,EPATH                                           0104
         ST    @12,ATAEPATH(,ATAPTR)                               0104
*   EPAPARM=ADDR(PARMLIST);         /* SET ADDR OF PTM/SRT PLIST FOR
*                                      RECOVERY                      */
         LA    @12,PARMLIST                                        0105
         ST    @12,EPAPARM                                         0105
*   SRTWORK=R9+LENGTH(ZEROWORK);    /* SAVE ADDRESS OF SRT WORKAREA
*                                      IN PLIST                      */
*                                                                  0106
         LA    @12,256                                             0106
         ALR   @12,R9                                              0106
         ST    @12,SRTWORK                                         0106
*   /*****************************************************************/
*   /*                                                               */
*   /* FRR ESTABLISHED, BOTH WORKAREAS ADDRESSED, ATA + EPATH + PLIST*/
*   /* PRELIMINARY INITIALIZATION DONE- CAN START MAIN LINE PROCESS  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0107
*   PARTPTR=ASMPART;                /* SET PART BASE                 */
         L     @12,ASMPART(,ASMVTPTR)                              0107
         ST    @12,PARTPTR                                         0107
*   RFY                                                            0108
*    (R0,                                                          0108
*     R1) RSTD;                                                    0108
*   R1=PARTLKUP;                    /* GET IN PROCESS FLAG AND CPU CT*/
         L     R1,PARTLKUP(,@12)                                   0109
*RETRYP2:                                                          0110
*   R0=R1+ONE;                      /* UP CPU CT BY 1                */
RETRYP2  LA    R0,1                                                0110
         ALR   R0,R1                                               0110
*   CS(R1,R0,PARTLKUP);             /* REPLACE VIA CS                */
         L     @12,PARTPTR                                         0111
         CS    R1,@00,PARTLKUP(@12)                                0111
*   BC(NE,RETRYP2);                                                0112
         BC    7,RETRYP2                                           0112
*   EPACPUID=R0;                    /* SAVE FOR RECOVERY             */
         STH   R0,EPACPUID                                         0113
*   RFY                                                            0114
*    (R0,                                                          0114
*     R1) UNRSTD;                                                  0114
*                                                                  0115
*   /*****************************************************************/
*   /*                                                               */
*   /* SET UP FOR LOOP THRU PARTES. LASTPARE IS ALREADY INIT TO ZERO */
*   /* TO STOP PLPA/COMM/DPLX PARTE LOOP. QPARE ALREADY INIT TO PLPAQ*/
*   /* (0) TO INDICATE PROCESSING PLPA/COMM/DPLX Q                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0115
*   PAREPTR=ADDR(PARTENTS(PARTPLPN+1));/* PICK UP PTR TO PLPA PARTE  */
*                                                                  0115
         L     @12,PARTPTR                                         0115
         LA    @12,PARTENTS(,@12)                                  0115
         ST    @12,PAREPTR                                         0115
*   /*****************************************************************/
*   /*                                                               */
*   /* PROCESS THE THREE QUEUES OF PART ENTRIES: PLPA, COMMON, AND   */
*   /* DUPLEX QUEUE (A STRAIGHT QUEUE- LAST CHAIN FIELD = ZERO) THEN */
*   /* THE FIXED HEAD AND THEN THE MOVABLE HEAD DEVICE QUEUES (BOTH  */
*   /* ARE CIRCULAR QUEUES WITH A MOVABLE ANCHOR ALWAYS SET TO FIRST */
*   /* PARTE IN CIRCLE FOR WHICH WE HAD NO WRITES FOR EACH CALL OF   */
*   /* PART MONITOR. THIS WILL BE THE STARTING POINT NEXT TIME THRU  */
*   /* TO MORE EVENLY DISTRIBUTE WRITES.)                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0116
*   DO UNTIL QPARE=DONE;            /* PROCESS PARTE QUEUES          */
*                                                                  0116
@DL00116 DS    0H                                                  0117
*     /***************************************************************/
*     /*                                                             */
*     /* LOOP THROUGH ALL PARTES FOR THIS PARTE QUEUE. CALL SLOTSORT */
*     /* TO PROCESS PAGE REQUESTS FOR EACH PARTE                     */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0117
*     DO UNTIL PAREPTR=LASTPARE;    /* PROCESS ALL PARTES THIS QUEUE */
@DL00117 DS    0H                                                  0118
*       CURQ=PAREWTQE;              /* GET THIS PARTES WRITE Q PTR   */
         L     @12,PAREPTR                                         0118
         L     @12,PAREWTQE(,@12)                                  0118
         ST    @12,CURQ                                            0118
*       CALL GETWRTQ;               /* REMOVE WRITES & PLACE IN    0119
*                                      PARMLIST                      */
         BAL   @14,GETWRTQ                                         0119
*       IF WRTIOEQ=0 THEN           /* ANY WRITES TO PROCESS THIS  0120
*                                      PARTE?                        */
         SLR   @12,@12                                             0120
         C     @12,WRTIOEQ                                         0120
         BNE   @RF00120                                            0120
*/* IN CASE WE ARE PROCESSING A CIRCULAR Q, IF CIRC Q ANCHOR NOT   0121
*   ALREADY SET FOR MOVE, INDICATE SO NOW SINCE THIS IS FIRST PARTE
*   FOR WHICH WE HAD NO WRITES. NEXT TIME AROUND WE WILL START WITH
*   THIS PARTE                                                       */
*                                                                  0121
*         IF CIRCUPDT=0 THEN                                       0121
         C     @12,CIRCUPDT                                        0121
         BNE   @RF00121                                            0121
*           CIRCUPDT=PAREPTR;                                      0122
         L     @12,PAREPTR                                         0122
         ST    @12,CIRCUPDT                                        0122
*         ELSE                                                     0123
*           ;                                                      0123
@RF00121 DS    0H                                                  0124
*       ELSE                                                       0124
*         ;                         /* THERE ARE WRITES TO PROCESS-
*                                      THIS PARTE                    */
@RF00120 DS    0H                                                  0125
*/* DETERMINE WHETHER WE HAVE WORK FOR THIS PARTE BEFORE GO ON       */
*                                                                  0125
*       IF WRTIOEQ^=0|              /* ANY WRITES?                   */
*           PAREIOEQ^=0|            /* ANY UNSORTED READS?           */
*           PARENODE^=0 THEN        /* ANY SORTED READS?             */
         SLR   @12,@12                                             0125
         C     @12,WRTIOEQ                                         0125
         BNE   @RT00125                                            0125
         L     @11,PAREPTR                                         0125
         C     @12,PAREIOEQ(,@11)                                  0125
         BNE   @RT00125                                            0125
         C     @12,PARENODE(,@11)                                  0125
         BE    @RF00125                                            0125
@RT00125 DS    0H                                                  0126
*         DO;                       /* WORK TO DO                    */
*                                                                  0126
*           /*********************************************************/
*           /*                                                       */
*           /* AT THIS POINT, WEVE GOT WORK TO DO- EITHER WRITES OR  */
*           /* READS OR BOTH SERIALIZE USAGE OF THE PARTE ENTRY      */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0127
*           RFY                                                    0127
*            (R0,                                                  0127
*             R1) RSTD;                                            0127
*           R1=PARELKUP;            /* LOAD ENTRY FLAGS              */
         L     @12,PAREPTR                                         0128
         L     R1,PARELKUP(,@12)                                   0128
*RETRYLK:                                                          0129
*           IF PAREFSIP^=ON THEN    /* ALREADY LOCKED?               */
RETRYLK  L     @12,PAREPTR                                         0129
         TM    PAREFSIP(@12),B'10000000'                           0129
         BO    @RF00129                                            0129
*             DO;                   /* NO- GRAB IT                   */
*               R0=R1|PAREFSPC;     /* OR ON FSIP BIT LOCK PARTE     */
         LR    R0,R1                                               0131
         O     R0,@CF01247                                         0131
*               GEN REFS(R0,EPACPUID)(ICM R0,3,EPACPUID);/* SET NEW
*                                      CPU COUNT                     */
         ICM R0,3,EPACPUID
*               CS(R1,R0,PARELKUP); /* ATTEMPT TO LOCK PARTE         */
         L     @12,PAREPTR                                         0133
         CS    R1,@00,PARELKUP(@12)                                0133
*               BC(NE,RETRYLK);                                    0134
         BC    7,RETRYLK                                           0134
*               RFY                                                0135
*                (R0,                                              0135
*                 R1) UNRSTD;                                      0135
*                                                                  0135
*               /*****************************************************/
*               /*                                                   */
*               /* PARTE IS LOCKED. GET REQUIRED RESOURCES TO PROCESS*/
*               /* PARTE                                             */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0136
*               IF PAREIORB=0 THEN  /* THIS PARTE HAVE NO IORBS?     */
         L     @12,PAREPTR                                         0136
         L     @12,PAREIORB(,@12)                                  0136
         LTR   @12,@12                                             0136
         BNZ   @RF00136                                            0136
*                 DO;                                              0137
*                   ATARCODE=NOIORB;/* SET REASON FOR ABEND CODE     */
         MVI   ATARCODE(ATAPTR),X'0C'                              0138
*                   RFY                                            0139
*                     R1 RSTD;                                     0139
*                   GEN EXIT NOSEQFLOW(ABEND X'084',,,SYSTEM);/* WAKE
*                                      UP FRR- FRR DOES NOT RETURN,
*                                      BUT RESCHEDULES PTM           */
         ABEND X'084',,,SYSTEM
*                   RFY                                            0141
*                     R1 UNRSTD;                                   0141
*                 END;                                             0142
*               ELSE                                               0143
*                 ;                 /* PARTE HAS AT LEAST 1 IORB     */
@RF00136 DS    0H                                                  0144
*               PTRIORB=PAREIORB;                                  0144
         L     @12,PAREPTR                                         0144
         L     PTRIORB,PAREIORB(,@12)                              0144
*               DO WHILE PTRIORB^=0;/* LOOP THRU IORBS TIL ONE     0145
*                                      AVAILABLE                     */
         B     @DE00145                                            0145
@DL00145 DS    0H                                                  0146
*                 IF PTRIORB->IORFUSE^=ON THEN/* AVAILABLE?          */
         TM    IORFUSE(PTRIORB),B'10000000'                        0146
         BO    @RF00146                                            0146
*                   DO;             /* YES- GRAB IT                  */
*                     IORBPTR=PTRIORB;/* SET PLIST IORB ADDRESS      */
         ST    PTRIORB,IORBPTR                                     0148
*                     PTRIORB->IORFUSE=ON;/* MARK IN USE             */
*                                                                  0149
         OI    IORFUSE(PTRIORB),B'10000000'                        0149
*                     /***********************************************/
*                     /*                                             */
*                     /* GET A PCCW, IF DONT ALREADY HAVE ONE        */
*                     /*                                             */
*                     /***********************************************/
*                                                                  0150
*                     IF PCCWPTR=0 THEN/* NEED ONE?                  */
         L     @12,PCCWPTR                                         0150
         LTR   @12,@12                                             0150
         BNZ   @RF00150                                            0150
*                       DO;         /* YES                           */
*                         RFY                                      0152
*                          (R0,                                    0152
*                           R1,                                    0152
*                           R14,                                   0152
*                           R15) RSTD;                             0152
*                         LM(R14,R15,ASMPCCWQ);/* GET PTR TO FIRST 0153
*                                      PCCW + SYNCH COUNT            */
         LM    R14,R15,ASMPCCWQ(ASMVTPTR)                          0153
*PCCWRETR:                                                         0154
*                         IF R14^=0 THEN/* ARE THERE ANY THERE?      */
PCCWRETR LTR   R14,R14                                             0154
         BZ    @RF00154                                            0154
*                           DO;     /* AT LEAST ONE THERE NOW        */
*                             R0=R14->PCCWPCCW;/* PTR TO NEXT TO   0156
*                                      UPDATE AVAIL Q                */
         L     R0,PCCWPCCW(,R14)                                   0156
*                             R1=R15-ONE;/* DECR SYNCH CT            */
         LR    R1,R15                                              0157
         BCTR  R1,0                                                0157
*                             CDS(R14,R0,ASMPCCWQ);/* UPDATE AVAIL Q */
         CDS   R14,R0,ASMPCCWQ(ASMVTPTR)                           0158
*                             BC(NE,PCCWRETR);/* TRY AGAIN, IF MISSED*/
         BC    7,PCCWRETR                                          0159
*                             PCCWPTR=R14;/* PUT IN PLIST FOR SRT AND
*                                      ALSO BASE MAPPING             */
         ST    R14,PCCWPTR                                         0160
*                             PCCWPCCW=0;/* INDICATE ONLY 1 ON PLIST */
         L     @12,PCCWPTR                                         0161
         SLR   @11,@11                                             0161
         ST    @11,PCCWPCCW(,@12)                                  0161
*                           END;                                   0162
*                                                                  0162
*                         /*******************************************/
*                         /*                                         */
*                         /* WE COULDNT GET A PCCW- FREE UP ALREADY  */
*                         /* OBTAINED RESOURCES AND GET OUT OF PART  */
*                         /* MONITOR- IOC WILL RESCHED US            */
*                         /*                                         */
*                         /*******************************************/
*                                                                  0163
*                         ELSE      /* WERENT ANY ON AVAIL QUEUE     */
*                           DO;                                    0163
         B     @RC00154                                            0163
@RF00154 DS    0H                                                  0164
*                             IORFUSE=OFF;/* MAKE IORB AVAILABLE     */
         L     @12,IORBPTR                                         0164
         NI    IORFUSE(@12),B'01111111'                            0164
*                             IORBPTR=0;/* MAKE SURE RECOVERY KNOWS
*                                      WHATS WHAT                    */
         SLR   @12,@12                                             0165
         ST    @12,IORBPTR                                         0165
*                             RFY                                  0166
*                              (R0,                                0166
*                               R1) RSTD;                          0166
*                             R1=PARELKUP;/* LOAD FLAG WORD          */
         L     @12,PAREPTR                                         0167
         L     R1,PARELKUP(,@12)                                   0167
*RETRYSET:                                                         0168
*                             R0=R1&PAREMASK;/* TURN OFF LOCK BIT    */
RETRYSET LR    R0,R1                                               0168
         N     R0,@CF01723                                         0168
*                             CS(R1,R0,PARELKUP);/* UNLOCK PARTE     */
         L     @12,PAREPTR                                         0169
         CS    R1,@00,PARELKUP(@12)                                0169
*                             BC(NE,RETRYSET);                     0170
         BC    7,RETRYSET                                          0170
*                             RFY                                  0171
*                              (R0,                                0171
*                               R1) UNRSTD;                        0171
*                             GOTO PTMXIT;/* CLEANUP + GET OUT       */
         B     PTMXIT                                              0172
*                           END;                                   0173
*                         RFY                                      0174
*                          (R0,                                    0174
*                           R1,                                    0174
*                           R14,                                   0174
*                           R15) UNRSTD;                           0174
@RC00154 DS    0H                                                  0175
*                       END;        /* END NEEDED A PCCW             */
*                     ELSE                                         0176
*                       ;           /* ALREADY HAD A PCCW            */
@RF00150 DS    0H                                                  0177
*                     IORPCCW=PCCWPTR;/* ADDRESS PCCW FROM IORB      */
         L     @12,PCCWPTR                                         0177
         L     @11,IORBPTR                                         0177
         ST    @12,IORPCCW(,@11)                                   0177
*                                                                  0178
*                     /***********************************************/
*                     /*                                             */
*                     /* AGAIN, IT IS NECESSARY TO INSURE WORK       */
*                     /* REMAINS. COULD HAVE BEEN GRABBED BY PTM ON  */
*                     /* ANOTHER CPU WHILE WE WERE LOCKING PARTE.    */
*                     /*                                             */
*                     /***********************************************/
*                                                                  0178
*                     IF PAREIOEQ^=0 THEN/* ANY UNSORTED READS?      */
         L     @12,PAREPTR                                         0178
         L     @12,PAREIOEQ(,@12)                                  0178
         LTR   @12,@12                                             0178
         BZ    @RF00178                                            0178
*                       CALL SORTREAD;/* SORT THE READS AND PUT ON 0179
*                                      PARENODE                      */
         BAL   @14,SORTREAD                                        0179
*                     ELSE                                         0180
*                       ;           /* WERENT ANY UNSORTED READS     */
@RF00178 DS    0H                                                  0181
*                     IF PARENODE^=0|/* IF THERE ARE SORTED READS    */
*                         (WRTIOEQ^=0&PARESLTA^=0) THEN/* OR WRITES
*                                      WITH ROOM ON DS               */
         SLR   @12,@12                                             0181
         L     @11,PAREPTR                                         0181
         C     @12,PARENODE(,@11)                                  0181
         BNE   @RT00181                                            0181
         C     @12,WRTIOEQ                                         0181
         BE    @RF00181                                            0181
         C     @12,PARESLTA(,@11)                                  0181
         BE    @RF00181                                            0181
@RT00181 DS    0H                                                  0182
*                       DO;                                        0182
*                                                                  0182
*                         /*******************************************/
*                         /*                                         */
*                         /* CALL SLOT SORT TO PROCESS WORK FOR THIS */
*                         /* PARTE. R4 ALREADY POINTS TO ATA. SET R1 */
*                         /* TO ADDRESS PARM LIST AND R13 TO ADDR OF */
*                         /* SAVEAREA.                               */
*                         /*                                         */
*                         /*******************************************/
*                                                                  0183
*                         RFY                                      0183
*                          (R1,                                    0183
*                           R13) RSTD;                             0183
*                         R1=ADDR(PARMLIST);                       0184
         LA    R1,PARMLIST                                         0184
*                         R13=ADDR(PTMSAVE);/* SAVEAREA              */
         LA    R13,PTMSAVE                                         0185
*                         CALL ILRSRT;                             0186
         L     @15,@CV01757                                        0186
         BALR  @14,@15                                             0186
*                         RFY                                      0187
*                          (R1,                                    0187
*                           R13) UNRSTD;                           0187
*                                                                  0187
*                         /*******************************************/
*                         /*                                         */
*                         /* CHECK RETURN CODE FROM SLOT SORT. GO    */
*                         /* BACK IF MORE WORK AND ANOTHER IORB      */
*                         /* AVAILABLE.                              */
*                         /*                                         */
*                         /*******************************************/
*                                                                  0188
*                         RFY                                      0188
*                           R15 RSTD;                              0188
*                         IF R15=0 THEN/* ALL OK- NO WORK REMAINS?   */
         LTR   R15,R15                                             0189
         BNZ   @RF00189                                            0189
*                           DO;                                    0190
*                             PTRIORB=0;/* ZERO TO STOP LOOP- NO MORE
*                                      WORK THIS PARTE               */
         SLR   PTRIORB,PTRIORB                                     0191
*                             MOREWORK=OFF;/* NO WORK REMAINS        */
         NI    MOREWORK,B'10111111'                                0192
*                           END;                                   0193
*                         ELSE                                     0194
*                           DO;                                    0194
         B     @RC00189                                            0194
@RF00189 DS    0H                                                  0195
*                             MOREWORK=ON;/* WORK MAY REMAIN         */
         OI    MOREWORK,B'01000000'                                0195
*                             IF R15=RCSRT4 THEN/* ALL OK WITH WORK
*                                      REMAINING?                    */
         C     R15,@CF00117                                        0196
         BNE   @RF00196                                            0196
*                               PTRIORB=PTRIORB->IORIORB;/* GET NEXT
*                                      IORB FOR LOOP- CONTINUE       */
         L     PTRIORB,IORIORB(,PTRIORB)                           0197
*                             ELSE                                 0198
*                               DO;                                0198
*                                                                  0198
         B     @RC00196                                            0198
@RF00196 DS    0H                                                  0199
*                                 /***********************************/
*                                 /*                                 */
*                                 /* AT THIS POINT WE KNOW DS WAS    */
*                                 /* FULL- IF NOT A LOCAL DS, CALL   */
*                                 /* DSFULL RTN TO EXAMINE SITUATION.*/
*                                 /* IF GET CONTROL BACK FROM DSFULL */
*                                 /* (CONTINUING), GET NEXT IORB IF  */
*                                 /* ANY & GO BACK FOR SAME PARTE IF */
*                                 /* THERE WERE STILL MORE READS TO  */
*                                 /* DO WHEN DS FILLED UP            */
*                                 /*                                 */
*                                 /***********************************/
*                                                                  0199
*                                 SRTCODSV=R15;/* SAVE RET CODE    0199
*                                      ACROSS DSFULL SUBRTN          */
         ST    R15,SRTCODSV                                        0199
*                                 IF PARELOCL=OFF THEN/* THIS PARTE
*                                      JUST A LOCAL?                 */
         L     @14,PAREPTR                                         0200
         TM    PARELOCL(@14),B'00010000'                           0200
         BNZ   @RF00200                                            0200
*                                   CALL DSFULL;/* NO- PLPA, COMM, OR
*                                      DUPLX- LET DSFULL SEE WHATS 0201
*                                      WHAT                          */
         BAL   @14,DSFULL                                          0201
*                                 ELSE                             0202
*                                   ;/* WAS A LOCAL                  */
*                                                                  0202
@RF00200 DS    0H                                                  0203
*                                 /***********************************/
*                                 /*                                 */
*                                 /* STILL HERE- CONTINUE WITH READS,*/
*                                 /* IF ANY                          */
*                                 /*                                 */
*                                 /***********************************/
*                                                                  0203
*                                 IF SRTCODSV=RCSRTC THEN/* DS FULL
*                                      WITH READS LEFT?              */
         CLC   SRTCODSV(4),@CF00267                                0203
         BNE   @RF00203                                            0203
*                                   PTRIORB=PTRIORB->IORIORB;/* YES,
*                                      GET NEXT IORB FOR LOOP        */
         L     PTRIORB,IORIORB(,PTRIORB)                           0204
*                                 ELSE/* NO READS REMAINING          */
*                                   PTRIORB=0;/* ZERO TO STOP LOOP   */
         B     @RC00203                                            0205
@RF00203 SLR   PTRIORB,PTRIORB                                     0205
*                               END;/* END DATA SET FULL             */
@RC00203 DS    0H                                                  0207
*                           END;    /* END NOT RC 0                  */
@RC00196 DS    0H                                                  0208
*                         RFY                                      0208
*                           R15 UNRSTD;                            0208
@RC00189 DS    0H                                                  0209
*                       END;        /* END WORK TO DO                */
*                                                                  0210
*                     /***********************************************/
*                     /*                                             */
*                     /* AT THIS POINT WE KNOW WE DIDNT HAVE ANY     */
*                     /* READS FOR THIS PARTE. ALSO, WE EITHER HAD NO*/
*                     /* WRITES OR WE HAD WRITES BUT NO AVAILABLE    */
*                     /* SLOTS.                                      */
*                     /*                                             */
*                     /***********************************************/
*                                                                  0210
*                     ELSE                                         0210
*                       DO;                                        0210
         B     @RC00181                                            0210
@RF00181 DS    0H                                                  0211
*                         IF WRTIOEQ^=0 THEN/* DID WE HAVE WRITES TO
*                                      DO?                           */
         L     @12,WRTIOEQ                                         0211
         LTR   @12,@12                                             0211
         BZ    @RF00211                                            0211
*/*  YES- SINCE WE KNOW WE DIDNT HAVE READS, DS WAS FULL             */
*                                                                  0212
*                           IF PARELOCL=OFF THEN/* JUST LOCAL DS?    */
         L     @12,PAREPTR                                         0212
         TM    PARELOCL(@12),B'00010000'                           0212
         BNZ   @RF00212                                            0212
*                             CALL DSFULL;/* NOPE- CHECK IT OUT      */
         BAL   @14,DSFULL                                          0213
*                           ELSE                                   0214
*                             ;     /* LOCAL DS- SKIP DSFULL         */
@RF00212 DS    0H                                                  0215
*                         ELSE                                     0215
*                           ;       /* HAD NO WRITES EITHER- WORKED
*                                      SNATCHED BEFORE WE LOCKED     */
@RF00211 DS    0H                                                  0216
*/* IN BOTH CASES, FREE RESOURCES AND TRY NEXT PARTE                 */
*                                                                  0216
*                         IORPCCW=0;/* ZERO PCCW PTR IN IORB         */
         SLR   @12,@12                                             0216
         L     @11,IORBPTR                                         0216
         ST    @12,IORPCCW(,@11)                                   0216
*                         IORFUSE=OFF;/* FREE THE IORB               */
         NI    IORFUSE(@11),B'01111111'                            0217
*                         IORBPTR=0;/* INDICATE FOR RECOVERY         */
         ST    @12,IORBPTR                                         0218
*                         PTRIORB=0;/* STOP THE LOOP                 */
         SLR   PTRIORB,PTRIORB                                     0219
*                       END;        /* END NO WORK OR JUST WRITES  0220
*                                      WITH DS FULL                  */
*                   END;            /* END- THIS IORB IS AVAILABLE   */
*                 ELSE              /* IORB WAS IN USE               */
*                   PTRIORB=PTRIORB->IORIORB;/* GET NEXT IORB        */
         B     @RC00146                                            0222
@RF00146 L     PTRIORB,IORIORB(,PTRIORB)                           0222
*               END;                /* END DO WHILE WEVE GOT IORBS 0223
*                                      THIS PARTE                    */
@RC00146 DS    0H                                                  0223
@DE00145 SLR   @12,@12                                             0223
         CR    PTRIORB,@12                                         0223
         BNE   @DL00145                                            0223
*                                                                  0224
*               /*****************************************************/
*               /*                                                   */
*               /* EITHER FINISHED WITH THIS PARTE OR HAD LOCKED IT  */
*               /* AND COULDNT USE IT- UNLOCK                        */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0224
*               IF MOREWORK=ON&ASMIOCNT=0 THEN/* WORK REMAINING WITH
*                                      NO OTHER MEANS OF REDRIVE?    */
         TM    MOREWORK,B'01000000'                                0224
         BNO   @RF00224                                            0224
         C     @12,ASMIOCNT(,ASMVTPTR)                             0224
         BNE   @RF00224                                            0224
*                 PRESCHED=ON;      /* INSURE THIS WORK GETS       0225
*                                      PROCESSED                     */
         OI    PRESCHED,B'00100000'                                0225
*               ELSE                                               0226
*                 ;                                                0226
@RF00224 DS    0H                                                  0227
*               IORBPTR=0;          /* MAKE SURE PLIST IORB ADDR ZERO
*                                      FOR RECOVERY                  */
         SLR   @12,@12                                             0227
         ST    @12,IORBPTR                                         0227
*               RFY                                                0228
*                (R0,                                              0228
*                 R1) RSTD;                                        0228
*               R1=PARELKUP;        /* LOAD FLAG WORD                */
         L     @12,PAREPTR                                         0229
         L     R1,PARELKUP(,@12)                                   0229
*RETRYST1:                                                         0230
*               R0=R1&PAREMASK;     /* TURN OFF LOCK BIT             */
RETRYST1 LR    R0,R1                                               0230
         N     R0,@CF01723                                         0230
*               CS(R1,R0,PARELKUP); /* UNLOCK PARTE                  */
         L     @12,PAREPTR                                         0231
         CS    R1,@00,PARELKUP(@12)                                0231
*               BC(NE,RETRYST1);                                   0232
         BC    7,RETRYST1                                          0232
*               RFY                                                0233
*                (R0,                                              0233
*                 R1) UNRSTD;                                      0233
*             END;                  /* END PARTE NOT ALREADY LOCKED  */
*           ELSE                                                   0235
*             ;                     /* PARTE WAS LOCKED BY ANOTHER 0235
*                                      CPU                           */
@RF00129 DS    0H                                                  0236
*         END;                      /* END OF WORK TO DO FOR THIS  0236
*                                      PARTE                         */
*       ELSE                                                       0237
*         ;                         /* NO WORK TO DO FOR THIS PARTE  */
*                                                                  0237
@RF00125 DS    0H                                                  0238
*       /*************************************************************/
*       /*                                                           */
*       /* PICK UP NEXT PARTE IN THIS PARTE CHAIN AND CONTINUE       */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0238
*       PAREPTR=PAREPARE;                                          0238
         L     @12,PAREPTR                                         0238
         L     @12,PAREPARE(,@12)                                  0238
         ST    @12,PAREPTR                                         0238
*     END;                          /* END DO UNTIL ALL PARTES THIS
*                                      CHAIN PROCESSED               */
@DE00117 CLC   PAREPTR(4),LASTPARE                                 0239
         BNE   @DL00117                                            0239
*                                                                  0240
*     /***************************************************************/
*     /*                                                             */
*     /* DETERMINE WHICH QUEUE OF PARTES WEVE JUST PROCESSED. UPDATE */
*     /* CIRCULAR QUEUE ANCHORS IF NECESSARY AND SET UP TO PROCESS   */
*     /* NEXT QUEUE OF PARTES                                        */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0240
*     IF QPARE=PLPAQ THEN           /* JUST FINISH PLPA, COMM, &   0240
*                                      DUPLX QUEUE?                  */
         SLR   @12,@12                                             0240
         C     @12,QPARE                                           0240
         BNE   @RF00240                                            0240
*       DO;                         /* YES-                          */
*                                                                  0241
*         /***********************************************************/
*         /*                                                         */
*         /* INITIALIZE FOR PROCESS OF FIXED HEAD QUEUE              */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0242
*         QPARE=FIXEDQ;             /* FIXED HEAD CIRCULAR Q IS NEXT */
         MVC   QPARE(4),@CF00117                                   0242
*         CIRCUPDT=0;               /* INITIALIZE CIRCULAR QUEUE   0243
*                                      ANCHOR PLACE HOLDER           */
         ST    @12,CIRCUPDT                                        0243
*/* MAKE SURE WEVE GOT PAGE SPACES ON THE FIXED HEAD QUEUE           */
*                                                                  0244
*         IF PARTCIR1^=0 THEN       /* QUEUE EXIST?                  */
         L     @11,PARTPTR                                         0244
         L     @11,PARTCIR1(,@11)                                  0244
         CR    @11,@12                                             0244
         BE    @RF00244                                            0244
*           DO;                     /* YES                           */
*             PAREPTR=PARTCIR1;     /* SET LOOP INDEX VARIABLE       */
         ST    @11,PAREPTR                                         0246
*             LASTPARE=PARTCIR1;    /* AND LOOP STOPPER              */
         ST    @11,LASTPARE                                        0247
*             GOTO NXTQUE;          /* CONTINUE                      */
         B     NXTQUE                                              0248
*           END;                                                   0249
*         ELSE                                                     0250
*           ;                       /* NOTHING ON FIXED HEAD QUEUE-
*                                      SKIP IT                       */
@RF00244 DS    0H                                                  0251
*       END;                        /* END PLPA/COMM/DPLX            */
*     ELSE                                                         0252
*       ;                           /* NOT PLPA/COMM/DPLX - CHEC   0252
*                                      CIRCS                         */
@RF00240 DS    0H                                                  0253
*     IF QPARE=FIXEDQ THEN          /* JUST FINISH FIXED HEAD Q?     */
         CLC   QPARE(4),@CF00117                                   0253
         BNE   @RF00253                                            0253
*       DO;                                                        0254
*                                                                  0254
*         /***********************************************************/
*         /*                                                         */
*         /* INITIALIZE FOR PROCESS OF MOVABLE HEAD Q                */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0255
*         QPARE=MOVABLQ;                                           0255
*                                                                  0255
         MVC   QPARE(4),@CF00040                                   0255
*/* UPDATE FIXED HEAD QUEUE ANCHOR IF NECESSARY                      */
*                                                                  0256
*         IF CIRCUPDT^=0 THEN       /* HAD WE RUN OUT OF WRITES WHILE
*                                      CIRCLING?                     */
         L     @12,CIRCUPDT                                        0256
         SLR   @11,@11                                             0256
         CR    @12,@11                                             0256
         BE    @RF00256                                            0256
*           DO;                     /* YES                           */
*             PARTCIR1=CIRCUPDT;                                   0258
         L     @08,PARTPTR                                         0258
         ST    @12,PARTCIR1(,@08)                                  0258
*             CIRCUPDT=0;           /* REINIT ANCHOR PLACEHOLDER     */
         ST    @11,CIRCUPDT                                        0259
*           END;                                                   0260
*         ELSE                                                     0261
*           ;                       /* NO- LEAVE QUEUE ANCHOR        */
@RF00256 DS    0H                                                  0262
*/* MAKE SURE WEVE GOT PAGE SPACES ON THE MOVABLE HEAD QUEUE         */
*                                                                  0262
*         IF PARTCIR2^=0 THEN       /* QUEUE EXIST?                  */
         L     @12,PARTPTR                                         0262
         L     @12,PARTCIR2(,@12)                                  0262
         LTR   @12,@12                                             0262
         BZ    @RF00262                                            0262
*           DO;                     /* YES                           */
*             PAREPTR=PARTCIR2;                                    0264
         ST    @12,PAREPTR                                         0264
*             LASTPARE=PARTCIR2;                                   0265
         ST    @12,LASTPARE                                        0265
*             GOTO NXTQUE;          /* CONTINUE                      */
         B     NXTQUE                                              0266
*           END;                                                   0267
*         ELSE                                                     0268
*           ;                       /* NOTHING ON MOVABLE HEAD QUEUE-
*                                      SKIP IT                       */
@RF00262 DS    0H                                                  0269
*       END;                        /* END FIXED QUEUE               */
*     ELSE                                                         0270
*       ;                           /* WASNT FIXED-                  */
*                                                                  0270
@RF00253 DS    0H                                                  0271
*     /***************************************************************/
*     /*                                                             */
*     /* HAD TO HAVE JUST FINISHED THE MOVABLE QUEUE. SET UP TO KICK */
*     /* OUT OF PARTE QUEUE LOOP                                     */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0271
*     QPARE=DONE;                   /* FINI                          */
         MVC   QPARE(4),@CF00267                                   0271
*/* UPDATE MOVABLE HEAD QUEUE ANCHOR IF NECESSARY                    */
*                                                                  0272
*     IF CIRCUPDT^=0 THEN           /* HAD WE RUN OUT OF WRITES WHILE
*                                      CIRCLING?                     */
         L     @12,CIRCUPDT                                        0272
         SLR   @11,@11                                             0272
         CR    @12,@11                                             0272
         BE    @RF00272                                            0272
*       DO;                         /* YES                           */
*         PARTCIR2=CIRCUPDT;                                       0274
         L     @08,PARTPTR                                         0274
         ST    @12,PARTCIR2(,@08)                                  0274
*         CIRCUPDT=0;                                              0275
         ST    @11,CIRCUPDT                                        0275
*       END;                                                       0276
*     ELSE                                                         0277
*       ;                           /* NO- LEAVE QUEUE ANCHOR        */
*                                                                  0277
@RF00272 DS    0H                                                  0278
*     /***************************************************************/
*     /*                                                             */
*     /* END OF PARTE QUEUE LOOP. GO BACK AND PROCESS NEXT QUEUE OF  */
*     /* PARTES UNTIL ALL THREE QUEUES ARE PROCESSED.                */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0278
*NXTQUE:                                                           0278
*     ;                                                            0278
NXTQUE   DS    0H                                                  0279
*   END;                            /* END PROCESS PARTE QUEUES      */
@DE00116 CLC   QPARE(4),@CF00267                                   0279
         BNE   @DL00116                                            0279
*                                                                  0280
*   /*****************************************************************/
*   /*                                                               */
*   /* PART MONITOR EXIT PROCESSING. REPLACE PCCW ON AVAILABLE QUEUE,*/
*   /* REPLACE ANY WRITES ON PART WRITE QUEUE. POST PAGE COMPLETION  */
*   /* WITH ANY AIAS ON PART AIA ERROR QUEUE DELETE RECOVERY AND     */
*   /* EXIT.                                                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0280
*PTMXIT:                                                           0280
*   IF PCCWPTR^=0 THEN              /* A PCCW TO RETURN?             */
PTMXIT   L     @12,PCCWPTR                                         0280
         SLR   @11,@11                                             0280
         CR    @12,@11                                             0280
         BE    @RF00280                                            0280
*     DO;                           /* YES-                          */
*       RFY                                                        0282
*        (R0,                                                      0282
*         R1) RSTD;                                                0282
*       R1=PCCWPTR;                                                0283
         LR    R1,@12                                              0283
*       PCCWAIA=0;                  /* MAKE SURE AIA PTR IS ZERO     */
         ST    @11,PCCWAIA(,@12)                                   0284
*       R0=ASMPCCWA;                /* GET HEAD OF AVAILABLE QUEUE   */
         L     R0,ASMPCCWA(,ASMVTPTR)                              0285
*       PCCWPTR=0;                  /* ZERO FOR RECOVERY             */
         ST    @11,PCCWPTR                                         0286
*REPPCCW:                                                          0287
*       R1->PCCWPCCW=R0;            /* CHAIN IN EXISTING PCCWS       */
REPPCCW  ST    R0,PCCWPCCW(,R1)                                    0287
*       CS(R0,R1,ASMPCCWA);         /* UPDATE AVAILABLE QUEUE        */
         CS    R0,@01,ASMPCCWA(ASMVTPTR)                           0288
*       BC(NE,REPPCCW);                                            0289
         BC    7,REPPCCW                                           0289
*       RFY                                                        0290
*        (R0,                                                      0290
*         R1) UNRSTD;                                              0290
*     END;                          /* END-REPLACE PCCW              */
*   ELSE                                                           0292
*     ;                             /* NO PCCW TO RETURN             */
@RF00280 DS    0H                                                  0293
*   IF WRTIOEQ^=0 THEN              /* ANY WRITES TO RETURN?         */
         L     @12,WRTIOEQ                                         0293
         LTR   @12,@12                                             0293
         BZ    @RF00293                                            0293
*     DO;                           /* YES-                          */
*       CALL GETLOCK;               /* LOCK THE PARTE WRITE QUEUES   */
         BAL   @14,GETLOCK                                         0295
*       IOEPTR=WRTIOEQ;             /* SET INDEX PTR                 */
         L     IOEPTR,WRTIOEQ                                      0296
*       DO WHILE(IOENXT^=0);        /* LOOP THRU IOES ON WRTIOEQ TO
*                                      FIND LAST                     */
         B     @DE00297                                            0297
@DL00297 DS    0H                                                  0298
*         IOEPTR=IOENXT;            /* GET NEXT ONE                  */
         L     IOEPTR,IOENXT(,IOEPTR)                              0298
*       END;                        /* IOEPTR NOW PTS TO LAST IOE    */
@DE00297 SLR   @12,@12                                             0299
         C     @12,IOENXT(,IOEPTR)                                 0299
         BNE   @DL00297                                            0299
*       IOENXT=CURQ->WRITEQUE;      /* CHAIN EXISTING WRITES TO LAST */
         L     @11,CURQ                                            0300
         L     @08,WRITEQUE(,@11)                                  0300
         ST    @08,IOENXT(,IOEPTR)                                 0300
*       CURQ->WRITEQUE=WRTIOEQ;     /* RETURN THESE TO TOP           */
         L     @08,WRTIOEQ                                         0301
         ST    @08,WRITEQUE(,@11)                                  0301
*       WRTIOEQ=0;                  /* ZERO FOR RECOVERY             */
         ST    @12,WRTIOEQ                                         0302
*       IF CURQ->WRITEQUL=0 THEN    /* WERE THERE ANY THERE?         */
         C     @12,WRITEQUL(,@11)                                  0303
         BNE   @RF00303                                            0303
*         CURQ->WRITEQUL=IOEPTR;    /* NO- USE OUR LAST              */
         ST    IOEPTR,WRITEQUL(,@11)                               0304
*       ELSE                                                       0305
*         ;                         /* YES- KEEP OLD LAST, WE ADDED
*                                      TO FRONT OF QUEUE             */
@RF00303 DS    0H                                                  0306
*       CALL RELLOCK;               /* UNLOCK THE PART WRITE QUEUES  */
         BAL   @14,RELLOCK                                         0306
*     END;                          /* END- RETURN WRITES            */
*   ELSE                                                           0308
*     ;                             /* NO WRITES TO RETURN           */
@RF00293 DS    0H                                                  0309
*   IF PARTAIAE^=0 THEN             /* ANYTHING ON ERROR QUEUE?      */
         L     @12,PARTPTR                                         0309
         L     @12,PARTAIAE(,@12)                                  0309
         LTR   @12,@12                                             0309
         BZ    @RF00309                                            0309
*     DO;                           /* YES- RETURN TO PAGE COMPLETION*/
*       RFY                                                        0311
*        (R0,                                                      0311
*         R1) RSTD;                                                0311
*       R1=PARTAIAE;                /* GET 1ST ELEMENT               */
         LR    R1,@12                                              0312
*       R0=0;                       /* UPDATE VALUE                  */
         SLR   R0,R0                                               0313
*RETRYAIA:                                                         0314
*       CS(R1,R0,PARTAIAE);         /* REMOVE QUEUE + UPDATE HEADER  */
RETRYAIA L     @12,PARTPTR                                         0314
         CS    R1,@00,PARTAIAE(@12)                                0314
*       BC(NE,RETRYAIA);                                           0315
         BC    7,RETRYAIA                                          0315
*       RFY                                                        0316
*         R13 RSTD;                                                0316
*       R13=ADDR(PTMSAVE);          /* PROVIDE SAVEAREA              */
         LA    R13,PTMSAVE                                         0317
*       CALL ILRPAGCM;              /* POST BACK BAD AIAS            */
         L     @15,@CV01758                                        0318
         BALR  @14,@15                                             0318
*       RFY                                                        0319
*        (R0,                                                      0319
*         R1,                                                      0319
*         R13) UNRSTD;                                             0319
*     END;                          /* END POST BACK AIAS            */
*   ELSE                                                           0321
*     ;                                                            0321
*                                                                  0321
@RF00309 DS    0H                                                  0322
*   /*****************************************************************/
*   /*                                                               */
*   /* FINAL CLEANUP AND EXIT PROCESSING. MAY NEED TO RESCHEDULE     */
*   /* OURSELVES IF HAD TO USE SPILL QUEUE OR IF WORK TO DO WITH NO  */
*   /* OTHER MEANS OF REDRIVE. DELETE RECOVERY RTN AND EXIT TO       */
*   /* DISPATCHER                                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0322
*   IF PRESCHED=ON THEN             /* RESCHED PTM INDICATED?        */
         TM    PRESCHED,B'00100000'                                0322
         BNO   @RF00322                                            0322
*     DO;                           /* YES                           */
*       RFY                                                        0324
*        (R0,                                                      0324
*         R1) RSTD;                                                0324
*       R0=ONE;                     /* VALUE TO REPLACE IF WE CAN  0325
*                                      SCHEDULE                      */
         LA    R0,1                                                0325
*       R1=0;                       /* VALUE TO CHECK TO ALLOW A   0326
*                                      SCHEDULE                      */
         SLR   R1,R1                                               0326
*       CS(R1,R0,ASMSRBCT);                                        0327
         CS    R1,@00,ASMSRBCT(ASMVTPTR)                           0327
*       BC(NE,PTMNOSCH);            /* IF ALREADY ONE OUT- CANT    0328
*                                      SCHEDULE                      */
         BC    7,PTMNOSCH                                          0328
*/* CAN SCHEDULE- DO IT                                              */
*                                                                  0329
*       R1=ASMPSRB;                 /* PICK UP PTM SRB ADDR          */
         L     R1,ASMPSRB(,ASMVTPTR)                               0329
*       RFY                                                        0330
*         R15 RSTD;                                                0330
*       GEN REFS(R1)(SCHEDULE SRB=(1),SCOPE=GLOBAL);               0331
         SCHEDULE SRB=(1),SCOPE=GLOBAL
*PTMNOSCH:                                                         0332
*       RFY                                                        0332
*        (R0,                                                      0332
*         R1,                                                      0332
*         R2,                                                      0332
*         R15) UNRSTD;                                             0332
PTMNOSCH DS    0H                                                  0333
*     END;                          /* END RESCHED PTM               */
*   ELSE                                                           0334
*     ;                             /* RESCHED NOT INDICATED         */
@RF00322 DS    0H                                                  0335
*/* REMOVE RECOVERY                                                  */
*                                                                  0335
*   RFY                                                            0335
*    (R6,                                                          0335
*     R7) RSTD;                                                    0335
*PTMDRCV1:                                                         0336
*   GEN REFS(R6,R7,PSACSTK,FRRSCURR,FRRS,FRRSEMP,FRRSELEN,PSA);    0336
PTMDRCV1 DS    0H                                                  0336
         SETFRR D,WRKREGS=(R6,R7),RELATED=(PAGE,ILRPTM(PTMARCV1))
*   RFY                                                            0337
*    (R6,                                                          0337
*     R7) UNRSTD;                                                  0337
*   RFY                                                            0338
*     R14 RSTD;                                                    0338
*   R14=CVTSRBRT;                   /* GET RETURN ADDR               */
         L     @12,CVTPTR                                          0339
         L     R14,CVTSRBRT(,@12)                                  0339
*   RFY                                                            0340
*     R14 UNRSTD;                                                  0340
*   RETURN;                         /* EXIT                          */
@EL00001 DS    0H                                                  0341
@EF00001 DS    0H                                                  0341
@ER00001 BR    @14                                                 0341
*                                                                  0342
*/********************************************************************/
*/*                                                                  */
*/* GETWRTQ: REMOVE IOES FROM APPROPRIATE WRITE QUEUE                */
*/*                                                                  */
*/* INPUT: WRTIOEQ - CONTAINS PTR TO A CHAIN OF IOES IF PREVIOUS     */
*/*                  CALL TO SLOT SORT DID NOT PROCESS ALL REQUESTS  */
*/*                  OR CONTAINS ZERO.                               */
*/*        CURQ    - CONTAINS A PTR TO THE WRITE QUE FOR THIS CALL   */
*/*        EPAWRTQ - CONTAINS A PTR TO THE WRITE QUE USED BY THE     */
*/*                  LAST PART ENTRY OR ZERO.                        */
*/*                                                                  */
*/* PROCESS: IF THE PREVIOUS PART ENTRY DOES NOT SHARE THE SAME      */
*/*          WRITE QUEUE AS THE CURRENT ENTRY, ANY WRITES ON THE     */
*/*          PLIST WRTIOEQ ARE RETURNED TO THEIR PART WRITE QUEUE.   */
*/*          WRITE IOES ARE THEN PICKED UP FROM THE CURRENT PART     */
*/*          WRITE QUEUE AND PLACED ON WRTIOEQ. IF CURRENT AND PREV  */
*/*          SHARE THE SAME PART WRITE QUEUE, WRITES ARE MOVED TO    */
*/*          WRTIOEQ ONLY IF THERE ARE NONE LEFT ON WRTIOEQ FROM     */
*/*          PREVIOUS PROCESSING. CHECKS ARE MADE FOR CURQ = ZERO    */
*/*          WHICH INDICATES TO PART MONITOR THAT THIS PARTE HAS     */
*/*          NO WRITE QUEUE. THE ASM CLASS LOCK IS HELD WHILE        */
*/*          MANIPULATING THE PART WRITE QUEUES.                     */
*/*                                                                  */
*/* OUTPUT: WRTIOEQ - WILL CONTAIN A PTR TO THE IOE CHAIN FOR THE    */
*/*                   CURRENT PART ENTRY BEING PROCESSED OR ZERO.    */
*/*         EPAWRTQ - WILL BE UPDATED TO POINT TO THE CURRENT WRITE  */
*/*                   QUEUE.                                         */
*/*                                                                  */
*/********************************************************************/
*                                                                  0342
*GETWRTQ:                                                          0342
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0342
GETWRTQ  DS    0H                                                  0343
*   RFY                                                            0343
*     R14 RSTD;                                                    0343
*   RETADDR1=R14;                   /* SAVE RETURN ADDRESS           */
         ST    R14,RETADDR1                                        0344
*   RFY                                                            0345
*     R14 UNRSTD;                                                  0345
*   IF CURQ^=EPAWRTQ THEN           /* NEW PARTE HAVE DIFFERENT WRITE
*                                      QUE?                          */
         CLC   CURQ(4),EPAWRTQ                                     0346
         BE    @RF00346                                            0346
*     DO;                           /* YES - RETURN ANY WRITES AND 0347
*                                      SET EPAWRTQ = CURQ            */
*       IF WRTIOEQ^=0 THEN          /* ANY WRITES REMAIN ON PLIST?   */
         L     @12,WRTIOEQ                                         0348
         LTR   @12,@12                                             0348
         BZ    @RF00348                                            0348
*         DO;                       /* YES- RETURN WRITE IOES TO PREV
*                                      PARTES PART WRITE QUEUE       */
*           CALL GETLOCK;           /* LOCK PART WRITE QUEUES        */
         BAL   @14,GETLOCK                                         0350
*           WRTLOCKD=ON;            /* INDICATE LOCKED               */
         OI    WRTLOCKD,B'10000000'                                0351
*           IOEPTR=WRTIOEQ;         /* SET INDEX PTR                 */
         L     IOEPTR,WRTIOEQ                                      0352
*           DO WHILE(IOENXT^=0);    /* LOOP THRU IOES ON WRTIOEQ TO
*                                      FIND LAST                     */
         B     @DE00353                                            0353
@DL00353 DS    0H                                                  0354
*             IOEPTR=IOENXT;        /* GET NEXT                      */
         L     IOEPTR,IOENXT(,IOEPTR)                              0354
*           END;                    /* IOEPTR NOW POINTS TO LAST IOE */
@DE00353 SLR   @12,@12                                             0355
         C     @12,IOENXT(,IOEPTR)                                 0355
         BNE   @DL00353                                            0355
*           IOENXT=EPAWRTQ->WRITEQUE;/* CHAIN EXISTING WRITES FOR  0356
*                                      PREV PARTE ONTO LAST PLIST IOE*/
         L     @11,EPAWRTQ                                         0356
         L     @08,WRITEQUE(,@11)                                  0356
         ST    @08,IOENXT(,IOEPTR)                                 0356
*           EPAWRTQ->WRITEQUE=WRTIOEQ;/* RETURN PLIST IOES TO TOP OF
*                                      PREVIOUS WRITE QUEUE          */
         L     @08,WRTIOEQ                                         0357
         ST    @08,WRITEQUE(,@11)                                  0357
*           WRTIOEQ=0;              /* OFF OF PLIST WRITE QUEUE      */
         ST    @12,WRTIOEQ                                         0358
*           IF EPAWRTQ->WRITEQUL=0 THEN/* WERE THERE SOME THERE?     */
         C     @12,WRITEQUL(,@11)                                  0359
         BNE   @RF00359                                            0359
*             EPAWRTQ->WRITEQUL=IOEPTR;/* NO- USE OUR LAST           */
         ST    IOEPTR,WRITEQUL(,@11)                               0360
*           ELSE                                                   0361
*             ;                     /* YES- KEEP OLD TAIL PTR, WE  0361
*                                      ADDED TO FRONT                */
@RF00359 DS    0H                                                  0362
*         END;                      /* END WRITES REMAIN ON PLIST TO
*                                      RETURN                        */
*       ELSE                                                       0363
*         ;                         /* NO WRITES TO RETURN           */
@RF00348 DS    0H                                                  0364
*       EPAWRTQ=CURQ;               /* UPDATE TO CURRENT PARTE PART
*                                      WRITE QUEUE PTR               */
         L     @12,CURQ                                            0364
         ST    @12,EPAWRTQ                                         0364
*     END;                          /* END CURQ ^= PREVIOUS QUEUE    */
*   ELSE                                                           0366
*     ;                             /* CURQ WAS EQUAL TO PREVIOUS  0366
*                                      QUEUE                         */
@RF00346 DS    0H                                                  0367
*   IF WRTIOEQ=0&                   /* NO WRITES THERE FROM PREV   0367
*                                      PROCESSING? AND               */
*       CURQ^=0&                    /* THIS PARTE HAS A WRITE QUE  0367
*                                      PTR? AND                      */
*       CURQ->WRITEQUE^=0 THEN      /* ARE THERE IOES ON IT?         */
         SLR   @12,@12                                             0367
         C     @12,WRTIOEQ                                         0367
         BNE   @RF00367                                            0367
         L     @11,CURQ                                            0367
         CR    @11,@12                                             0367
         BE    @RF00367                                            0367
         C     @12,WRITEQUE(,@11)                                  0367
         BE    @RF00367                                            0367
*     DO;                           /* YES- GET WRITES               */
*       IF WRTLOCKD=OFF THEN        /* WRITE QUEUES ALREADY LOCKED?  */
         TM    WRTLOCKD,B'10000000'                                0369
         BNZ   @RF00369                                            0369
*         DO;                       /* NO- GET LOCK                  */
*           CALL GETLOCK;                                          0371
         BAL   @14,GETLOCK                                         0371
*           WRTLOCKD=ON;            /* INDICATE LOCKED               */
         OI    WRTLOCKD,B'10000000'                                0372
*         END;                                                     0373
*       ELSE                                                       0374
*         ;                         /* ALREADY LOCKED                */
@RF00369 DS    0H                                                  0375
*       WRTIOEQ=CURQ->WRITEQUE;     /* QUEUE IOES TO PLIST           */
         L     @12,CURQ                                            0375
         L     @11,WRITEQUE(,@12)                                  0375
         ST    @11,WRTIOEQ                                         0375
*       CURQ->WRITEQUE=0;           /* ZERO PART WRITE QUEUE HEAD AND*/
         SLR   @11,@11                                             0376
         ST    @11,WRITEQUE(,@12)                                  0376
*       CURQ->WRITEQUL=0;           /* TAIL PTRS                     */
         ST    @11,WRITEQUL(,@12)                                  0377
*     END;                                                         0378
*   ELSE                                                           0379
*     ;                             /* WRITES LEFT OR NO NEW WRITES  */
@RF00367 DS    0H                                                  0380
*   IF WRTLOCKD=ON THEN             /* LOCK HELD?                    */
         TM    WRTLOCKD,B'10000000'                                0380
         BNO   @RF00380                                            0380
*     DO;                           /* YES- RELEASE IT               */
*       CALL RELLOCK;                                              0382
         BAL   @14,RELLOCK                                         0382
*       WRTLOCKD=OFF;               /* INDICATE LOCK RELEASED        */
         NI    WRTLOCKD,B'01111111'                                0383
*     END;                                                         0384
*   RFY                                                            0385
*     R14 RSTD;                                                    0385
@RF00380 DS    0H                                                  0386
*   R14=RETADDR1;                   /* RESTORE RETURN ADDRESS        */
         L     R14,RETADDR1                                        0386
*   RFY                                                            0387
*     R14 UNRSTD;                                                  0387
*   END GETWRTQ;                                                   0388
@EL00002 DS    0H                                                  0388
@EF00002 DS    0H                                                  0388
@ER00002 BR    @14                                                 0388
*                                                                  0389
*/********************************************************************/
*/*                                                                  */
*/* GETLOCK: OBTAIN ASM CLASS LOCK FOR PART WRITE QUEUES             */
*/*                                                                  */
*/* INPUT: NONE                                                      */
*/*                                                                  */
*/* PROCESS: USE SETLOCK TO OBTAIN THE ASM CLASS LOCK TO SERIALIZE   */
*/*          USE OF THE PART WRITE QUEUES.                           */
*/*                                                                  */
*/* OUTPUT: NONE                                                     */
*/*                                                                  */
*/****************************************************************** */
*                                                                  0389
*GETLOCK:                                                          0389
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0389
GETLOCK  DS    0H                                                  0390
*   RFY                                                            0390
*    (R11,                                                         0390
*     R12,                                                         0390
*     R13,                                                         0390
*     R14) RSTD;                                                   0390
*   RETADDR2=R14;                   /* SAVE RETURN ADDRESS           */
         ST    R14,RETADDR2                                        0391
*   R11=ADDR(PARTLOCK);             /* SET LOCKWORD ADDRESS          */
         L     R11,PARTPTR                                         0392
         LA    R11,PARTLOCK(,R11)                                  0392
*PTMLK1:                                                           0393
*   GEN REFS(R11,R12,R13,R14,PSALITA,FLC);                         0393
PTMLK1   DS    0H                                                  0393
         SETLOCK OBTAIN,TYPE=ASM,ADDR=(11),MODE=UNCOND,                *
               RELATED=(PART,ILRPTM(PTMUNLK1))
*   R14=RETADDR2;                   /* RESTORE RETURN ADDRESS        */
         L     R14,RETADDR2                                        0394
*   RFY                                                            0395
*    (R11,                                                         0395
*     R12,                                                         0395
*     R13,                                                         0395
*     R14) UNRSTD;                                                 0395
*   END GETLOCK;                                                   0396
@EL00003 DS    0H                                                  0396
@EF00003 DS    0H                                                  0396
@ER00003 BR    @14                                                 0396
*                                                                  0397
*/********************************************************************/
*/*                                                                  */
*/* RELLOCK: RELEASE ASM CLASS LOCK                                  */
*/*                                                                  */
*/* INPUT: NONE                                                      */
*/*                                                                  */
*/* PROCESS: USE SETLOCK TO RELEASE THE ASM CLASS LOCK               */
*/*                                                                  */
*/* OUTPUT: NONE                                                     */
*/*                                                                  */
*/********************************************************************/
*                                                                  0397
*RELLOCK:                                                          0397
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0397
RELLOCK  DS    0H                                                  0398
*   RFY                                                            0398
*    (R11,                                                         0398
*     R12,                                                         0398
*     R13,                                                         0398
*     R14) RSTD;                                                   0398
*   RETADDR2=R14;                   /* SAVE RETURN ADDRESS           */
         ST    R14,RETADDR2                                        0399
*   R11=ADDR(PARTLOCK);             /* SET LOCKWORD ADDRESS          */
         L     R11,PARTPTR                                         0400
         LA    R11,PARTLOCK(,R11)                                  0400
*PTMUNLK1:                                                         0401
*   GEN REFS(R11,R12,R13,R14,PSALITA,FLC);                         0401
PTMUNLK1 DS    0H                                                  0401
         SETLOCK RELEASE,TYPE=ASM,ADDR=(11),                           *
               RELATED=(PART,ILRPTM(PTMLK1))
*   R14=RETADDR2;                   /* RESTORE RETURN ADDRESS        */
         L     R14,RETADDR2                                        0402
*   RFY                                                            0403
*    (R11,                                                         0403
*     R12,                                                         0403
*     R13,                                                         0403
*     R14) UNRSTD;                                                 0403
*   END RELLOCK;                                                   0404
@EL00004 DS    0H                                                  0404
@EF00004 DS    0H                                                  0404
@ER00004 BR    @14                                                 0404
*                                                                  0405
*/********************************************************************/
*/*                                                                  */
*/* DSFULL: PLPA/COMMON/DUPLEX DATA SET FULL SUBROUTINE              */
*/*                                                                  */
*/* INPUT: NONE                                                      */
*/*                                                                  */
*/* PROCESS: OBTAIN THE SALLOC LOCK TO SERIALIZE SETTING OF ASMVT    */
*/*          FULL INDICATORS. DETERMINE WHICH DATA SET FILLED AND    */
*/*          SET UP FOR CALL TO ILRMSG00 TO ISSUE APPROPRIATE MESSAGE*/
*/*          AND POSSIBLY TERMINATE THE SYSTEM IF A CRITICAL RESOURCE*/
*/*          HAS BEEN LOST. CHECKS ARE MADE TO INSURE THAT THE       */
*/*          MESSAGES INDICATING A FILLED DATA SET ARE ISSUED ONLY   */
*/*          ONCE.                                                   */
*/*                                                                  */
*/* OUTPUT: FOR PLPA FULL AND COMMON OK, PLPAS WRITE QUEUE PTR (TO   */
*/*         THE COMMON PART WRITE QUEUE) IS ZEROED AND COMMONS       */
*/*         WRITE QUE PTR (WHICH WAS ZERO) IS SET TO ADDRESS THE     */
*/*         COMMON PART WRITE QUEUE.                                 */
*/*         FOR COMMON FULL AND PLPA OK, THE WRITE IOES ON           */
*/*         THE COMMON PART WRITE QUE ARE MOVED TO THE PLPA SPILL QUE*/
*/*         AND RESCHEDULE OF PART MONITOR IS INDICATED. COMMONS     */
*/*         WRITE QUEUE PTR IS NOT ZEROED (AS WAS PLPAS ABOVE)       */
*/*         BECAUSE COMMON MAY FREE UP SOME SLOTS LATER WHEREAS      */
*/*         PLPA NEVER WOULD HAVE.                                   */
*/*         IF EITHER OF THE ABOVE CANNOT BE HANDLED BY THE OTHER    */
*/*         AND DUPLX IS ACTIVE, THE ASSOC AIAS ARE MARKED LSID 0    */
*/*         AND PUT ON THE PART ERROR QUEUE - IOES FREED. IF DUPLEX  */
*/*         NOT ACTIVE IN THIS CASE, SYSTEM WILL TERMINATE AFTER CALL*/
*/*         TO MSG00. IF DUPLEX FILLED AND WE ARE NOT DEPENDING ON   */
*/*         DUPLEXING, THE ASSOCIATED AIAS ARE MARKED SECONDARY ERROR*/
*/*         AND PUT ON THE PART ERROR QUEUE - IOES FREED. IF DEPEND  */
*/*         ON DUPLEX, SYSTEM WILL BE TERMINATED.                    */
*/*                                                                  */
*/********************************************************************/
*                                                                  0405
*DSFULL:                                                           0405
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0405
DSFULL   DS    0H                                                  0406
*   RFY                                                            0406
*     R14 RSTD;                                                    0406
*   RETADDR1=R14;                   /* SAVE RETURN ADDRESS           */
         ST    R14,RETADDR1                                        0407
*   RFY                                                            0408
*    (R11,                                                         0408
*     R12,                                                         0408
*     R13,                                                         0408
*     R14) RSTD;                                                   0408
*PTMLK2:                                                           0409
*   GEN REFS(R12,R13,R14,PSALITA,FLC);                             0409
PTMLK2   DS    0H                                                  0409
         SETLOCK OBTAIN,TYPE=SALLOC,MODE=UNCOND,                       *
               RELATED=(ASMVT,ILRPTM(PTMUNLK2))
*   RFY                                                            0410
*    (R11,                                                         0410
*     R12,                                                         0410
*     R13,                                                         0410
*     R14) UNRSTD;                                                 0410
*   MSGPLIST=''B;                   /* INITIAL MSG00 PLIST SETUP     */
         XC    MSGPLIST(8),MSGPLIST                                0411
*   MSGCBADR=PAREPTR;               /* PARTE ADDRESS                 */
         L     @12,PAREPTR                                         0412
         ST    @12,MSGCBADR                                        0412
*   EPAMSPAD=0;                     /* INITIALLY INDICATE NO MSG REQD*/
         SLR   @11,@11                                             0413
         ST    @11,EPAMSPAD                                        0413
*   IF PAREPLPA=ON THEN             /* FILL UP PLPA D.S.?            */
         TM    PAREPLPA(@12),B'10000000'                           0414
         BNO   @RF00414                                            0414
*     DO;                           /* YES-                          */
*                                                                  0415
*       /*************************************************************/
*       /*                                                           */
*       /* FILLED THE PLPA DATA SET                                  */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0416
*       IF ASMPLPAF=OFF THEN        /* MSG NOT ISSUED BEFORE?        */
         TM    ASMPLPAF(ASMVTPTR),B'00000100'                      0416
         BNZ   @RF00416                                            0416
*         DO;                       /* YES- INDICATE NEED TO ISSUE   */
*           MSGNUM=MSGFIVE;         /* SET MSG NUMBER                */
         MVC   MSGNUM(2),@CH01299                                  0418
*           EPAMSPAD=ADDR(MSGPLIST);/* NON ZERO ADDR INDICATES MSG 0419
*                                      REQD TO US AND RECOVERY       */
         LA    @12,MSGPLIST                                        0419
         ST    @12,EPAMSPAD                                        0419
*         END;                                                     0420
*       ELSE                                                       0421
*         ;                         /* MSG ALREADY ISSUED            */
@RF00416 DS    0H                                                  0422
*       IF ASMCOMMF=ON|             /* COMMON FULL TOO OR            */
*           ADDR(PARTENTS(PARTCOMN+1))->PAREDSBD=ON THEN/* BAD?      */
         TM    ASMCOMMF(ASMVTPTR),B'00000010'                      0422
         BO    @RT00422                                            0422
         L     @12,PARTPTR                                         0422
         LA    @12,PARTENTS+64(,@12)                               0422
         TM    PAREDSBD(@12),B'01000000'                           0422
         BNO   @RF00422                                            0422
@RT00422 DS    0H                                                  0423
*         DO;                       /* YES- CANT FORCE TO COMMON.  0423
*                                      CHECK TO SEE IF WE CAN RELY ON
*                                      DUPLEX                @Z40WPWP*/
*           IF ASMDUPLX=ON THEN     /* DUPLEXING ACTIVE?     @Z40WPWP*/
         TM    ASMDUPLX(ASMVTPTR),B'10000000'                      0424
         BNO   @RF00424                                            0424
*             DO;                   /* YES- MARK AIAS AS LSID = 0, 0425
*                                      FREE IOES + ISSUE MSG 10      */
*               IF ASMPLPAF=OFF THEN/* 1ST INDICATION THAT PLPA    0426
*                                      FILLED?               @Z40WPWP*/
         TM    ASMPLPAF(ASMVTPTR),B'00000100'                      0426
         BNZ   @RF00426                                            0426
*                 DO;               /* YES, ISSUE MESSAGE ILR010I  0427
*                                                            @Z40WPWP*/
*                   MSGNUM=MSGTEN;  /* SET MSG NUMBER        @Z40WPWP*/
         MVC   MSGNUM(2),@CH00033                                  0428
*                   EPAMSPAD=ADDR(MSGPLIST);/* INDICATE MSG REQD   0429
*                                                            @Z40WPWP*/
         LA    @12,MSGPLIST                                        0429
         ST    @12,EPAMSPAD                                        0429
*                 END;              /* FOR ISSUE MSG 10I     @Z40WPWP*/
*               ELSE                                               0431
*                 ;                 /* NOW STOP ANY WRITES FOR THIS
*                                      PARTE                 @Z40WPWP*/
@RF00426 DS    0H                                                  0432
*               CALL STOPWRT;       /* MARK AIAS AS LSID 0 AND FREE
*                                      IOES                  @Z40WPWP*/
         BAL   @14,STOPWRT                                         0432
*             END;                  /* END DUPLEXING ACTIVE  @Z40WPWP*/
*           ELSE                    /* DUPLEXING NOT ACTIVE- @Z40WPWP*/
*             DO;                   /* CAN NOT KEEP THE SYSTEM GOING
*                                                            @Z40WPWP*/
         B     @RC00424                                            0434
@RF00424 DS    0H                                                  0435
*               MSGNUM=MSGEIGHT;    /* TERMINATION MSG       @Z40WPWP*/
         MVC   MSGNUM(2),@CH00040                                  0435
*               EPAMSPAD=ADDR(MSGPLIST);/* INDICATE MSG REQD @Z40WPWP*/
         LA    @12,MSGPLIST                                        0436
         ST    @12,EPAMSPAD                                        0436
*             END;                  /*                       @Z40WPWP*/
*         END;                      /* FOR CAN WE RELY ON DUPLEX   0438
*                                                            @Z40WPWP*/
*       ELSE                        /* COMMON OK-                    */
*         DO;                       /* FORCE WRITES TO COMMON BY     */
         B     @RC00422                                            0439
@RF00422 DS    0H                                                  0440
*           PAREWTQE=0;             /* ZEROING PLPAS PART WRITE QUEUE
*                                      PTR AND                       */
         L     @12,PAREPTR                                         0440
         SLR   @11,@11                                             0440
         ST    @11,PAREWTQE(,@12)                                  0440
*           ADDR(PARTENTS(PARTCOMN+1))->PAREWTQE=ADDR(PARTCOMQ);/* 0441
*                                      POINTING COMMON PARTE TO    0441
*                                      COMMON PART WRITE QUEUE.      */
         L     @12,PARTPTR                                         0441
         LA    @11,PARTENTS+64(,@12)                               0441
         LA    @12,PARTCOMQ(,@12)                                  0441
         ST    @12,PAREWTQE(,@11)                                  0441
*         END;                      /* END FORCE WRITES TO COMMON    */
*       ASMPLPAF=ON;                /* INDICATE PLPA FILLED  @Z40WPWP*/
@RC00422 OI    ASMPLPAF(ASMVTPTR),B'00000100'                      0443
*     END;                          /* END PLPA FILLED               */
*   ELSE                            /* NOT PLPA-                     */
*     IF PARECOMM=ON THEN           /* FILL UP COMMON D.S.?          */
         B     @RC00414                                            0445
@RF00414 L     @12,PAREPTR                                         0445
         TM    PARECOMM(@12),B'01000000'                           0445
         BNO   @RF00445                                            0445
*       DO;                                                        0446
*                                                                  0446
*         /***********************************************************/
*         /*                                                         */
*         /* FILLED THE COMMON DATA SET                              */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0447
*         IF ASMCOMMF=OFF THEN      /* MSG NOT ISSUED BEFORE?        */
         TM    ASMCOMMF(ASMVTPTR),B'00000010'                      0447
         BNZ   @RF00447                                            0447
*           DO;                     /* YES-                          */
*             MSGNUM=MSGSIX;        /* SET MSG NUMBER                */
         MVC   MSGNUM(2),@CH00986                                  0449
*             EPAMSPAD=ADDR(MSGPLIST);/* INDICATE NEED TO ISSUE      */
         LA    @12,MSGPLIST                                        0450
         ST    @12,EPAMSPAD                                        0450
*           END;                                                   0451
*         ELSE                                                     0452
*           ;                       /* MSG ALREADY ISSUED            */
@RF00447 DS    0H                                                  0453
*         IF ASMPLPAF=ON|           /* PLPA FULL TOO OR              */
*             ADDR(PARTENTS(PARTPLPN+1))->PAREDSBD=ON THEN/* BAD?    */
         TM    ASMPLPAF(ASMVTPTR),B'00000100'                      0453
         BO    @RT00453                                            0453
         L     @12,PARTPTR                                         0453
         LA    @12,PARTENTS(,@12)                                  0453
         TM    PAREDSBD(@12),B'01000000'                           0453
         BNO   @RF00453                                            0453
@RT00453 DS    0H                                                  0454
*           DO;                     /* SEE IF WE CAN RELY ON DUPLEX  */
*             IF ASMDUPLX=ON THEN   /* DUPLEXING ACTIVE?             */
         TM    ASMDUPLX(ASMVTPTR),B'10000000'                      0455
         BNO   @RF00455                                            0455
*               DO;                 /* YES- MARK AIAS AS LSID = 0, 0456
*                                      FREE IOES + ISSUE MSG 10      */
*                 IF ASMCOMMF=OFF THEN/* 1ST INDICATION THAT COMMON
*                                      FILLED?               @Z40WPWP*/
         TM    ASMCOMMF(ASMVTPTR),B'00000010'                      0457
         BNZ   @RF00457                                            0457
*                   DO;             /* YES, ISSUE MESSAGE ILR010I  0458
*                                                            @Z40WPWP*/
*                     MSGNUM=MSGTEN;/* SET MSG NUMBER                */
         MVC   MSGNUM(2),@CH00033                                  0459
*                     EPAMSPAD=ADDR(MSGPLIST);/* INDICATE MSG REQD   */
         LA    @12,MSGPLIST                                        0460
         ST    @12,EPAMSPAD                                        0460
*                   END;            /* FOR ISSUE MSG 10I     @Z40WPWP*/
*                 ELSE                                             0462
*                   ;               /* NOW STOP ANY WRITES FOR THIS
*                                      PARTE                 @Z40WPWP*/
@RF00457 DS    0H                                                  0463
*                 CALL STOPWRT;     /* MARK AIAS AS LSID 0 AND FREE
*                                      IOES                          */
         BAL   @14,STOPWRT                                         0463
*               END;                /* END DUPLEXING ACTIVE          */
*             ELSE                  /* DUPLEXING NOT ACTIVE-         */
*               DO;                 /* TIME TO GO WEST               */
         B     @RC00455                                            0465
@RF00455 DS    0H                                                  0466
*                 MSGNUM=MSGEIGHT;  /* TERMINATION MSG               */
         MVC   MSGNUM(2),@CH00040                                  0466
*                 EPAMSPAD=ADDR(MSGPLIST);/* INDICATE MSG REQD       */
         LA    @12,MSGPLIST                                        0467
         ST    @12,EPAMSPAD                                        0467
*               END;                                               0468
*           END;                    /* FOR CAN WE RELY ON DUPLEX   0469
*                                                            @Z40WPWP*/
*         ELSE                      /* PLPA STILL OK- FORCE WRITES TO
*                                      IT                            */
*           DO;                                                    0470
         B     @RC00453                                            0470
@RF00453 DS    0H                                                  0471
*             IOEPTR=WRTIOEQ;       /* SET INDEX PTR                 */
         L     IOEPTR,WRTIOEQ                                      0471
*             DO WHILE(IOENXT^=0);  /* FIND LAST IOE ON PLIST        */
         B     @DE00472                                            0472
@DL00472 DS    0H                                                  0473
*               IOEPTR=IOENXT;      /* GET NEXT                      */
         L     IOEPTR,IOENXT(,IOEPTR)                              0473
*             END;                                                 0474
@DE00472 SLR   @12,@12                                             0474
         C     @12,IOENXT(,IOEPTR)                                 0474
         BNE   @DL00472                                            0474
*             IOEHOLDR=WRTIOEQ;     /* REMOVE WRITES INTO PLACEHOLDER
*                                      AND                           */
         L     IOEHOLDR,WRTIOEQ                                    0475
*             WRTIOEQ=0;            /* ZERO FOR RECOVERY BEFORE PUT
*                                      ON SPILL QUEUE                */
         ST    @12,WRTIOEQ                                         0476
*             IF PARTSPLL^=0 THEN   /* SOME ALREADY THERE?           */
         L     @11,PARTPTR                                         0477
         L     @11,PARTSPLL(,@11)                                  0477
         CR    @11,@12                                             0477
         BE    @RF00477                                            0477
*               PARTSPLL->IOENXT=IOEHOLDR;/* CHAIN PLIST WRITES TO 0478
*                                      END                           */
         ST    IOEHOLDR,IOENXT(,@11)                               0478
*             ELSE                  /* NO-                           */
*               PARTSPLF=IOEHOLDR;  /* THESE ARE THE FIRST           */
         B     @RC00477                                            0479
@RF00477 L     @12,PARTPTR                                         0479
         ST    IOEHOLDR,PARTSPLF(,@12)                             0479
*             PARTSPLL=IOEPTR;      /* RESET SPILL QUEUE LAST PTR    */
@RC00477 L     @12,PARTPTR                                         0480
         ST    IOEPTR,PARTSPLL(,@12)                               0480
*             PRESCHED=ON;          /* INDICATE RESCHED REQD         */
         OI    PRESCHED,B'00100000'                                0481
*           END;                    /* END PLPA OK- FORCING WRITES TO
*                                      SPILL QUEUE                   */
*         ASMCOMMF=ON;              /* INDICATE COMMON FILLED      0483
*                                                            @Z40WPWP*/
@RC00453 OI    ASMCOMMF(ASMVTPTR),B'00000010'                      0483
*       END;                        /* END COMMON FILLED             */
*                                                                  0485
*   /*****************************************************************/
*   /*                                                               */
*   /* FILLED THE DUPLEX DATA SET. IF WE WERE DEPENDING ON DUPLEXING,*/
*   /* GOTO ILRMSG00 WITH MSG ILR0008W WHICH WILL TERMINATE THE      */
*   /* SYSTEM. OTHERWISE, SUSPEND DUPLEXING AND MARK EACH AIA AS     */
*   /* SECONDARY ERROR AND GOTO ILRMSG00 WITH MSG ILR0007I.          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0485
*     ELSE                          /* NOT COMMON- MUST BE DUPLEX  0485
*                                      THAT FILLED                   */
*       IF ASMNOCWQ=ON|             /* NO COMMON WRITE QUEUE OR      */
*           (ASMPLPAF=ON&ASMCOMMF=ON) THEN/* BOTH PLPA & COMM FULL 0485
*                                      INDICATES DEPEND ON DUPLEX    */
         B     @RC00445                                            0485
@RF00445 TM    ASMNOCWQ(ASMVTPTR),B'01000000'                      0485
         BO    @RT00485                                            0485
         TM    ASMPLPAF(ASMVTPTR),B'00000110'                      0485
         BNO   @RF00485                                            0485
@RT00485 DS    0H                                                  0486
*         DO;                       /* TROUBLE- SET UP FOR         0486
*                                      TERMINATION MSG               */
*           MSGNUM=MSGEIGHT;        /* SET MSG NUMBER                */
         MVC   MSGNUM(2),@CH00040                                  0487
*           EPAMSPAD=ADDR(MSGPLIST);/* INDICATE NEED TO ISSUE MSG    */
         LA    @12,MSGPLIST                                        0488
         ST    @12,EPAMSPAD                                        0488
*         END;                      /* END DEPENDING ON DUPLEX       */
*       ELSE                        /* NOT DEPENDING ON DUPLEX-      */
*         DO;                       /* CAN CONTINUE WITHOUT IT       */
         B     @RC00485                                            0490
@RF00485 DS    0H                                                  0491
*           IF ASMNODPX=OFF&ASMDUPLX=ON THEN/* MSG NOT ISSUED BEFORE?*/
         TM    ASMDUPLX(ASMVTPTR),B'10000000'                      0491
         BNO   @RF00491                                            0491
         TM    ASMNODPX(ASMVTPTR),B'00001000'                      0491
         BNZ   @RF00491                                            0491
*             DO;                   /* YES- SET UP TO ISSUE          */
*               MSGNUM=MSGSEVEN;    /* MESSAGE ILR0007I              */
         MVC   MSGNUM(2),@CH01285                                  0493
*               EPAMSPAD=ADDR(MSGPLIST);/* MSG REQD                  */
         LA    @12,MSGPLIST                                        0494
         ST    @12,EPAMSPAD                                        0494
*               ASMNODPX=ON;        /* INDICATE DUPLEXING HAS        */
*               ASMDUPLX=OFF;       /* BEEN SUSPENDED                */
         OI    ASMNODPX(ASMVTPTR),B'00001000'                      0496
         NI    ASMDUPLX(ASMVTPTR),B'01111111'                      0496
*             END;                  /* END MSG NOT ISSUED BEFORE     */
*           ELSE                                                   0498
*             ;                     /* MSG ISSUED BEFORE             */
*                                                                  0498
@RF00491 DS    0H                                                  0499
*           /*********************************************************/
*           /*                                                       */
*           /* MARK EACH AIA SECONDARY ERROR, QUEUE TO PARTAIAE      */
*           /* QUEUE, AND FREE EACH IOE.                             */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0499
*           CALL STOPWRT;           /* MARK AIAS AS SECONDARY ERROR
*                                      AND FREE IOES                 */
         BAL   @14,STOPWRT                                         0499
*         END;                      /* END NOT DEPEND ON DUPLEX &  0500
*                                      CONTINUING WITHOUT            */
*                                                                  0501
*   /*****************************************************************/
*   /*                                                               */
*   /* DETERMINE IF IT IS NECESSARY TO CALL ILRMSG00. IF CALL        */
*   /* ILRMSG00, MAY NOT GET CONTROL BACK- SYSTEM MAY BE TERMINATED. */
*   /* IF CONTROL IS RETURNED, FREE SALLOC AND RETURN TO MAINLINE.   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0501
*   IF EPAMSPAD^=0 THEN             /* MSG REQD?                     */
@RC00485 DS    0H                                                  0501
@RC00445 DS    0H                                                  0501
@RC00414 L     @12,EPAMSPAD                                        0501
         LTR   @12,@12                                             0501
         BZ    @RF00501                                            0501
*     DO;                                                          0502
*       RFY                                                        0503
*        (R1,                                                      0503
*         R13) RSTD;                                               0503
*       R13=ADDR(PTMSAVE);          /* SAVE AREA                     */
         LA    R13,PTMSAVE                                         0504
*       R1=EPAMSPAD;                /* SET INTERFACE TO MSG00        */
         LR    R1,@12                                              0505
*       CALL ILRMSG00;                                             0506
         L     @15,@CV01759                                        0506
         BALR  @14,@15                                             0506
*       EPAMSPAD=0;                 /* ZERO FOR RECOVERY             */
         SLR   @12,@12                                             0507
         ST    @12,EPAMSPAD                                        0507
*       RFY                                                        0508
*        (R1,                                                      0508
*         R13) UNRSTD;                                             0508
*     END;                                                         0509
*   ELSE                                                           0510
*     ;                             /* MSG NOT REQD                  */
@RF00501 DS    0H                                                  0511
*   RFY                                                            0511
*    (R11,                                                         0511
*     R12,                                                         0511
*     R13,                                                         0511
*     R14) RSTD;                                                   0511
*PTMUNLK2:                                                         0512
*   GEN REFS(R12,R13,R14,PSALITA,FLC);                             0512
PTMUNLK2 DS    0H                                                  0512
         SETLOCK RELEASE,TYPE=SALLOC,RELATED=(ASMVT,ILRPTM(PTMLK2))
*   RFY                                                            0513
*    (R11,                                                         0513
*     R12,                                                         0513
*     R13) UNRSTD;                                                 0513
*   R14=RETADDR1;                   /* RESTORE RETURN ADDRESS        */
         L     R14,RETADDR1                                        0514
*   RFY                                                            0515
*     R14 UNRSTD;                                                  0515
*   END DSFULL;                                                    0516
@EL00005 DS    0H                                                  0516
@EF00005 DS    0H                                                  0516
@ER00005 BR    @14                                                 0516
*                                                                  0517
*/********************************************************************/
*/*                                                                  */
*/* STOPWRT: MARK AIAS AND FREE IOES                                 */
*/*                                                                  */
*/* INPUT: IOEPTR ADDRESSES ONE OR MORE WRITE IOES                   */
*/*                                                                  */
*/* PROCESS: USE ASMDUPLX FLAG TO DETERMINE CALLER OF STOPWRT.       */
*/*          IF ON, WE HAD FILLED PLPA OR COMMON DS AND ARE          */
*/*          RELYING ON DUPLX. THEREFORE THE AIALSID FIELD IS        */
*/*          SET TO ZERO. OTHERWISE (ASMDUPLX IS OFF) WE HAD         */
*/*          FILLED DUPLEX BUT WE ARE NOT DEPENDING ON IT TO         */
*/*          CONTINUE SO THE AIASECER BIT IS SET.  EITHER WAY,       */
*/*          IF THE AIADPXCT IS NOT EQUAL T0 TWO THEN                */
*/*          EACH AIA IS PLACED ON THE PARTAIAE ERROR QUEUE          */
*/*          USING C+S AND EACH IOE IS FREED USING ILRGMA.           */
*/*                                                                  */
*/* OUTPUT: PARTAIAE CONTAINS AIAS MARKED ACCORDINGLY.               */
*/*                                                                  */
*/* NOTE: THIS ROUTINE IS ONLY CALLED IF THE SYSTEM WAS DUPLEXING    */
*/*                                                                  */
*/********************************************************************/
*                                                                  0517
*STOPWRT:                                                          0517
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0517
STOPWRT  DS    0H                                                  0518
*   RFY                                                            0518
*     R14 RSTD;                                                    0518
*   RETADDR2=R14;                   /* SAVE RETURN ADDRESS           */
         ST    R14,RETADDR2                                        0519
*   RFY                                                            0520
*     R14 UNRSTD;                                                  0520
*   IOEPTR=WRTIOEQ;                 /* REMOVE IOES FROM PLIST      0521
*                                                            @Z40WPWP*/
         L     IOEPTR,WRTIOEQ                                      0521
*   WRTIOEQ=0;                      /*                       @Z40WPWP*/
         SLR   @12,@12                                             0522
         ST    @12,WRTIOEQ                                         0522
*   DO WHILE(IOEPTR^=0);            /* LOOP THRU IOES FOR THIS D.S.  */
         B     @DE00523                                            0523
@DL00523 DS    0H                                                  0524
*     IF ASMDUPLX=ON THEN           /* USING DUPLEX- PLPA OR COMM  0524
*                                      FILLED?                       */
         TM    ASMDUPLX(ASMVTPTR),B'10000000'                      0524
         BNO   @RF00524                                            0524
*       IOEAIA->AIALSID=0;          /* TELL PAGCM WHAT HAPPENED      */
         L     @12,IOEAIA(,IOEPTR)                                 0525
         SLR   @11,@11                                             0525
         ST    @11,AIALSID(,@12)                                   0525
*     ELSE                          /* NO- DUPLEX FILLED BUT NOT   0526
*                                      DEPENDING ON IT               */
*       IOEAIA->AIASECER=ON;        /* TELL PAGCM WHAT HAPPENED      */
         B     @RC00524                                            0526
@RF00524 L     @12,IOEAIA(,IOEPTR)                                 0526
         OI    AIASECER(@12),B'00000100'                           0526
*     IF IOEAIA->AIADPXCT=2 THEN    /* 2 REQUESTS OUTSTANDING      0527
*                                                            @Z40WPWP*/
@RC00524 L     @12,IOEAIA(,IOEPTR)                                 0527
         L     @11,AIADPXCT(,@12)                                  0527
         C     @11,@CF00082                                        0527
         BNE   @RF00527                                            0527
*       IOEAIA->AIADPXCT=IOEAIA->AIADPXCT-1;/* LET PAGCM KNOW THAT 0528
*                                      ONLY ONE REQUEST IS LEFT AND
*                                      DO NOT PUT ON PARTAIAE      0528
*                                                            @Z40WPWP*/
         BCTR  @11,0                                               0528
         ST    @11,AIADPXCT(,@12)                                  0528
*     ELSE                                                         0529
*       DO;                         /* PUT THE AIA ON THE PARTAIAE 0529
*                                      QUEUE                 @Z40WPWP*/
         B     @RC00527                                            0529
@RF00527 DS    0H                                                  0530
*         RFY                                                      0530
*          (R0,                                                    0530
*           R1) RSTD;                                              0530
*         R1=IOEAIA;                /* GET THIS IOES AIA             */
         L     R1,IOEAIA(,IOEPTR)                                  0531
*         IOEAIA=0;                 /* REMOVE FROM IOE               */
         SLR   @12,@12                                             0532
         ST    @12,IOEAIA(,IOEPTR)                                 0532
*         R0=PARTAIAE;              /* GET HEAD OF ERROR QUEUE       */
         L     @12,PARTPTR                                         0533
         L     R0,PARTAIAE(,@12)                                   0533
*RETRYAI1:                                                         0534
*         R1->AIANXAIA=R0;          /* CHAIN IN EXISTING AIA'S       */
RETRYAI1 ST    R0,AIANXAIA(,R1)                                    0534
*         CS(R0,R1,PARTAIAE);       /* UPDATE THE QUEUE              */
         L     @12,PARTPTR                                         0535
         CS    R0,@01,PARTAIAE(@12)                                0535
*         BC(NE,RETRYAI1);                                         0536
         BC    7,RETRYAI1                                          0536
*         RFY                                                      0537
*           R0 UNRSTD;                                             0537
*       END;                        /* FOR PUT AIA ON PARTAIAE QUEUE
*                                                            @Z40WPWP*/
*     R1=IOEPTR;                    /* SET UP TO FREE THIS IOE       */
@RC00527 LR    R1,IOEPTR                                           0539
*     IOEPTR=IOENXT;                /* GET NEXT IOE                  */
*                                                                  0540
         L     IOEPTR,IOENXT(,IOEPTR)                              0540
*     /***************************************************************/
*     /*                                                             */
*     /* BEGIN ILRGMA MACRO EXPANSION                                */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0541
*     DO;                           /* ILRGMA FREE                 0541
*                                      CELL(IOE)WORKREGS(R11,R12)    */
*       DECLARE                     /* ASMVT VECTOR TO ILRPEX        */
*         ILRPEX ENTRY BASED(ASMPEX) VALRG(0);                     0542
*       DECLARE                     /* MAP FOR CELL CONTROL WORDS    */
*         1 GMACELL BASED BDY(WORD),                               0543
*          2 GMANEXT PTR(31);       /* PTR NEXT FREE CELL            */
*       RESPECIFY                                                  0544
*        (R0,                                                      0544
*         R1,                                                      0544
*         R11,                                                     0544
*         R12,                                                     0544
*         R14,                                                     0544
*         R15) RESTRICTED;                                         0544
*       RESPECIFY                                                  0545
*         ASMPOOLS BASED(R11);                                     0545
*       RESPECIFY                                                  0546
*         GMACELL BASED(R1);                                       0546
*       R11=ADDR(ASMIOEPC);                                        0547
         LA    R11,ASMIOEPC(,ASMVTPTR)                             0547
*       R14=ASMCPAVL;                                              0548
         L     R14,ASMCPAVL(,R11)                                  0548
*GMA00012:                                                         0549
*       GMANEXT=R14;                /* PUT ADDR CURRENT FIRST IN   0549
*                                      INPUT CELL                    */
GMA00012 ST    R14,GMANEXT(,R1)                                    0549
*       CS(R14,R1,ASMCPAVL);        /* ADD INPUT CELL TO POOL        */
         CS    R14,@01,ASMCPAVL(R11)                               0550
*       BC(7,GMA00012);                                            0551
         BC    7,GMA00012                                          0551
*       RESPECIFY                                                  0552
*        (R0,                                                      0552
*         R1,                                                      0552
*         R11,                                                     0552
*         R12,                                                     0552
*         R14,                                                     0552
*         R15) UNRESTRICTED;                                       0552
*     END;                          /* ILRGMA FREE                 0553
*                                      CELL(IOE)WORKREGS(R11,R12)    */
*                                                                  0553
*     /***************************************************************/
*     /*                                                             */
*     /* END ILRGMA MACRO EXPANSION                                  */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0554
*     RFY                                                          0554
*       R1 UNRSTD;                                                 0554
*   END;                            /* END DO WHILE IOES             */
@DE00523 LTR   IOEPTR,IOEPTR                                       0555
         BNZ   @DL00523                                            0555
*   RFY                                                            0556
*     R14 RSTD;                                                    0556
*   R14=RETADDR2;                   /* RESTORE RETURN ADDRESS        */
         L     R14,RETADDR2                                        0557
*   RFY                                                            0558
*     R14 UNRSTD;                                                  0558
*   END STOPWRT;                                                   0559
@EL00006 DS    0H                                                  0559
@EF00006 DS    0H                                                  0559
@ER00006 BR    @14                                                 0559
*                                                                  0560
*/********************************************************************/
*/*                                                                  */
*/*      SORTREAD: SORT ANY NEW READ REQUESTS, IF ANY                */
*/*                                                                  */
*/*      INPUT: ADDR OF FIRST READ IOE IN PARTE LIFO QUEUE           */
*/*             PART ENTRY                                           */
*/*                                                                  */
*/*      PROCESS: THE ENTIRE QUEUE OF READ IOES IS REMOVED FROM THE  */
*/*               PART ENTRY VIA C&S. THE SPECIFIC INTENT OF THIS    */
*/*               ROUTINE IS TO ADD EACH IOE FROM THE QUEUE TO ITS   */
*/*               APPROPRIATE PLACE ON A TWO DIRECTION (<= AND >)    */
*/*               TREE.  THE FIRST IOE ON THE TREE IS ANCHORED IN THE*/
*/*               PART ENTRY.  EACH SUCCESSIVE IOE IS ADDED ON THE   */
*/*               END OF A "LEG" OF THE TREE IF POSSIBLE. HOWEVER,   */
*/*               IN ORDER TO GROUP IOES REPRESENTING READ REQUESTS  */
*/*               FROM THE SAME RELATIVE CYLINDER OF THE PAGING SPACE*/
*/*               AN INSERTION OF AN IOE IS SOMETIMES NECESSARY IN   */
*/*               THE MIDDLE OF A 'LEG'. WITH THIS EXCEPTION, SORTING*/
*/*               IS PERFORMED BY RELATIVE SLOT NUMBER (CONTAINED IN */
*/*               THE AIA ADDRESSED FROM THE IOE).                   */
*/*                                                                  */
*/*               FOR EACH IOE, THE RELATIVE SLOT NUMBER IN THE      */
*/*               CORRESPONDING AIA IS TRANSLATED INTO A RELATIVE    */
*/*               CYLINDER VALUE AND A RELATIVE SLOT WITHIN THE      */
*/*               CYLINDER.  THESE VALUES ARE SOTRED IN THE AIA AND  */
*/*               ARE USED ELSEWHERE IN THE MODULE WHEN HANDLING READ*/
*/*               IOES ON THE TREE.                                  */
*/*                                                                  */
*/*               SPECIAL CASE: IF THERE IS ONLY ONE IOE ON THE PART */
*/*               ENTRY READ QUEUE AND NO IOES ALREADY EXIST ON THE  */
*/*               TREE AND NO WRITE REQUESTS ARE PRESENT, THEN THE   */
*/*               ONE READ REQUEST IS PROCESSED VIA A FAST PATH THRU */
*/*               SLOT SORT.  INSTEAD OF ADDING THE REQUEST TO THE   */
*/*               TREE, THE ELEMENT ADDRESS IS COMPLIMENTED AND      */
*/*               PLACED ON PARENODE.  SLOT SORT RECOGNIZES THIS     */
*/*               AND WILL USE A QUICK PATH TO PROCESS THIS IOE.     */
*/*                                                                  */
*/*      OUTPUT:  ALWAYS - RELATIVE CYLINDER AND SLOT IN CYLINDER    */
*/*                        VALUES STORED IN EACH AIA ADDRESSED BY    */
*/*                        EACH IOE.                                 */
*/*               ORDINARY - UPDATED TREE HANGING FROM PART ENTRY    */
*/*               SPECIAL CASE - COMPLIMENTED IOE ADDRESS ON         */
*/*                              PARENODE.                           */
*/*                                                                  */
*/*                                                                  */
*/********************************************************************/
*                                                                  0560
*SORTREAD:                                                         0560
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0560
SORTREAD DS    0H                                                  0561
*   RFY                                                            0561
*     R14 RSTD;                                                    0561
*   RETADDR1=R14;                   /* SAVE RETURN ADDRESS           */
         ST    R14,RETADDR1                                        0562
*   RFY                                                            0563
*     R14 UNRSTD;                                                  0563
*                                                                  0563
*   /*****************************************************************/
*   /*                                                               */
*   /* GET READ REQUESTS FROM PART ENTRY, USING COMPARE AND SWAP     */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0564
*   IOEPTR=PAREIOEQ;                /* GET CURRENT UNSORTED READ QUE
*                                      CONTENTS                      */
         L     @12,PAREPTR                                         0564
         L     IOEPTR,PAREIOEQ(,@12)                               0564
*   RFY                                                            0565
*     R0 RSTD;                                                     0565
*   R0=ZERO;                        /* TO SET PARTE FIELD TO ZERO    */
         SLR   R0,R0                                               0566
*READLOOP:                                                         0567
*   CS(IOEPTR,R0,PAREIOEQ);         /* ATTEMPT TO OBTAIN READS       */
READLOOP L     @12,PAREPTR                                         0567
         CS    IOEPTR,@00,PAREIOEQ(@12)                            0567
*   BC(NE,READLOOP);                /* UNSUCCESSFUL, TRY AGAIN       */
         BC    7,READLOOP                                          0568
*   RFY                                                            0569
*     R0 UNRSTD;                                                   0569
*   EPAIOEQP=IOEPTR;                /* SET FOR RECOVERY              */
*                                                                  0570
         ST    IOEPTR,EPAIOEQP                                     0570
*   /*****************************************************************/
*   /*                                                               */
*   /* ------ LOOP UNTIL ALL THE READ REQUEST IOES HAVE BEEN SORTED  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0571
*   DO WHILE IOEPTR^=ZERO;                                         0571
         B     @DE00571                                            0571
@DL00571 DS    0H                                                  0572
*     AIAPTR=IOEAIA;                /* GET PTR TO AIA                */
*                                                                  0572
         L     AIAPTR,IOEAIA(,IOEPTR)                              0572
*     /***************************************************************/
*     /*                                                             */
*     /* OBTAIN THE RELATIVE SLOT NUMBER OF THIS READ REQUEST FROM   */
*     /* THE AIA... CALCULATE THE RELATIVE CYLINDER WHERE IT IS IN   */
*     /* THE PAGING SPACE AND ITS RELATIVE SLOT NUMBER WITHIN THE    */
*     /* CYLINDER...                                                 */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0573
*     TSLOTNBR=AIASLOT;             /* GET REL. SLOT# FOR REQ        */
         LH    TSLOTNBR,AIASLOT(,AIAPTR)                           0573
         N     TSLOTNBR,@CF01849                                   0573
*     RFY                                                          0574
*      (R0,                                                        0574
*       R1) RSTD;                                                  0574
*     R1=TSLOTNBR;                  /* RELATIVE SLOT# IN PGG SPACE   */
         LR    R1,TSLOTNBR                                         0575
*     R0=ZERO;                      /* ZERO EVEN REG OF PAIR         */
         SLR   R0,R0                                               0576
*     CYLSLOTS=PATCYLSZ;            /* NBR SLOTS PER CYLINDER        */
         L     @08,PAREPTR                                         0577
         L     @08,PATPTR(,@08)                                    0577
         LH    @08,PATCYLSZ(,@08)                                  0577
         ST    @08,CYLSLOTS                                        0577
*     GEN(D     R0,CYLSLOTS)        /* DIVIDE FOR DESIRED VALUES     */
*     REFS(CYLSLOTS);                                              0578
         D     R0,CYLSLOTS
*     AIARCSN=R0;                   /* REMAINDER: REL SLOT# IN CYL   */
         STH   R0,AIARCSN(,AIAPTR)                                 0579
*     AIACYL=R1;                    /* QUOTIENT: RELATIVE CYL NBR    */
         STH   R1,AIACYL(,AIAPTR)                                  0580
*     THISCYL=R1;                   /* REL CYL NBR TO WRK VBL        */
         LR    THISCYL,R1                                          0581
*     RFY                                                          0582
*      (R0,                                                        0582
*       R1) UNRSTD;                                                0582
*                                                                  0582
*     /***************************************************************/
*     /*                                                             */
*     /* PROCEED TO ADD IOE TO THE SORTED READ REQUEST TREE          */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0583
*     THISNODE=PARENODE;            /* INITLZ CURRENT NODE ADDR      */
         L     @08,PAREPTR                                         0583
         L     THISNODE,PARENODE(,@08)                             0583
*     EPAIOEQP=IOENXT;              /* SET FOR RECOVERY              */
         L     @05,IOENXT(,IOEPTR)                                 0584
         ST    @05,EPAIOEQP                                        0584
*     EPAIOEIP=IOEPTR;              /* SET FOR RECOVERY              */
         ST    IOEPTR,EPAIOEIP                                     0585
*     IOENXTLE=ZERO;                /* ZERO LE LEG PTR               */
         SLR   @15,@15                                             0586
         ST    @15,IOENXTLE(,IOEPTR)                               0586
*     IOENXTGT=ZERO;                /* ZERO GT LEG PTR               */
*                                                                  0587
         ST    @15,IOENXTGT(,IOEPTR)                               0587
*     /***************************************************************/
*     /*                                                             */
*     /* IF NO READ IOES ARE CURRENTLY ON THE TREE AND ONLY ONE      */
*     /* EXISTS ON THE CURRENT QUEUE AND NO WRITES EXIST THEN SPECIAL*/
*     /* CASE THIS ONE READ AND SKIP OVERHEAD BY COMPLIMENTING THE   */
*     /* IOE ADDR AND PLACE ON PARENODE FOR SLOT SORT. IF THE LATTER */
*     /* CONDITIONS ARE NOT TRUE THEN ADD THIS CURRENT IOE FIRST ON  */
*     /* THE TREE.                                                   */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0588
*     IF THISNODE=ZERO THEN         /* NO IOES ALREADY ON TREE ?     */
         CR    THISNODE,@15                                        0588
         BNE   @RF00588                                            0588
*       IF EPAIOEQP=ZERO&           /* NO SECOND IOE ? -AND-         */
*           WRTIOEQ=ZERO THEN       /* NO WRITE IOES ?               */
         CR    @05,@15                                             0589
         BNE   @RF00589                                            0589
         C     @15,WRTIOEQ                                         0589
         BNE   @RF00589                                            0589
*         PARENODE=-IOEPTR;         /* COMPLIMENT ADDRESS FOR SLOT 0590
*                                      SORT                          */
         LCR   @12,IOEPTR                                          0590
         ST    @12,PARENODE(,@08)                                  0590
*       ELSE                        /* NO SPECIAL CASE ?             */
*         DO;                                                      0591
*                                                                  0591
         B     @RC00589                                            0591
@RF00589 DS    0H                                                  0592
*           /*********************************************************/
*           /*                                                       */
*           /* TO ADD FIRST IOE (OR NODE) TO TREE, SET THE PART ENTRY*/
*           /* ANCHOR PTR TO THE IOE AND ZERO THE BACKWARD LEG PTR IN*/
*           /* THE IOE                                               */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0592
*           PARENODE=IOEPTR;        /* PUT FIRST IOE ON TREE         */
         L     @12,PAREPTR                                         0592
         ST    IOEPTR,PARENODE(,@12)                               0592
*           IOEBKPTR=ZERO;          /* ZERO BACKWARD LEG PTR         */
         SLR   @12,@12                                             0593
         ST    @12,IOEBKPTR(,IOEPTR)                               0593
*         END;                                                     0594
*     ELSE                          /* AT LEAST ONE IOE ON TREE ?    */
*                                                                  0595
*       /*************************************************************/
*       /*                                                           */
*       /* IF IOES ARE ALREADY HUNG ON THE TREE, INVOKE ADRTTREE TO  */
*       /* ADD (SORT) THIS IOE TO ITS APPROPRIATE PLACE ON THE TREE  */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0595
*       CALL ADRTTREE;              /* CHAIN NEW IOE TO TREE         */
*                                                                  0595
         B     @RC00588                                            0595
@RF00588 BAL   @14,ADRTTREE                                        0595
*     /***************************************************************/
*     /*                                                             */
*     /* GET ADDRESS OF NEXT IOE ON QUEUE FOR NEXT LOOP ITERATION    */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0596
*     IOEPTR=EPAIOEQP;              /* GET NEXT READ REQUEST         */
@RC00588 L     IOEPTR,EPAIOEQP                                     0596
*   END;                            /* END LOOP TO SORT READS        */
@DE00571 LTR   IOEPTR,IOEPTR                                       0597
         BNZ   @DL00571                                            0597
*   RFY                                                            0598
*     R14 RSTD;                                                    0598
*   R14=RETADDR1;                   /* RESTORE RETURN ADDRESS        */
         L     R14,RETADDR1                                        0599
*   RFY                                                            0600
*     R14 UNRSTD;                                                  0600
*   END SORTREAD;                   /* END SUBROUTINE SORTREAD       */
@EL00007 DS    0H                                                  0601
@EF00007 DS    0H                                                  0601
@ER00007 BR    @14                                                 0601
*                                                                  0602
*/********************************************************************/
*/*                                                                  */
*/*      ADRTTREE: SORT AN IOE TO THE TREE                           */
*/*                                                                  */
*/*      INPUT: ADDRESS OF TOP NODE (READ IOE) IN TREE               */
*/*             ADDRESS OF IOE (NEW NODE) TO BE ADDED TO TREE        */
*/*             RELATIVE SLOT NUMBER ASSOCIATED WITH NEW NODE        */
*/*                                                                  */
*/*      PROCESS: (SEE ALSO PROLOG FOR SUBROUTINE SORTREAD ABOVE)    */
*/*               A LOOP IS EXECUTED TO MOVE DOWN THE TREE ONE NODE  */
*/*               AT A TIME IN ORDER TO FIND THE APPROPRIATE NODE TO */
*/*               WHICH THE NEW NODE IS TO BE CHAINED.  DECISION AS  */
*/*               TO WHICH LEG TO MOVE DOWN THE TREE IS BASED ON THE */
*/*               RESULT OF A COMPARE BETWEEN THE SLOT NUMBER ASSOC- */
*/*               IATED WITH THE NEW NODE AND THAT OF THE CURRENT    */
*/*               NODE ON THE TREE (EITHER GT (>) OR LE (<=)). IF    */
*/*               IN MOVING DOWN THE TREE A NODE IS FOUND WHICH      */
*/*               CORRESPONDS TO A READ REQUEST FOR THE SAME CYLINDER*/
*/*               AS THE NEW NODE AND THE NEXT NODE DOWN THE APPRO-  */
*/*               PRIATE LEG CORRESPONDS TO A REQUEST ON A DIFFERENT */
*/*               CYLINDER, THEN THE NEW NODE IS INSERTED BETWEEN THE*/
*/*               TWO LATTER NODES. OTHERWISE THE NEW NODE IS CHAINED*/
*/*               ON THE END OF WHICHEVER LEG THE LOOP FINDS.        */
*/*                                                                  */
*/*      OUTPUT: NEW NODE ADDED TO TREE                              */
*/*              NODE FIELDS ALTERED:                                */
*/*               GIVEN X IS THE NEW NODE                            */
*/*                     A IS NODE TO WHICH NEW NODE IS CHAINED       */
*/*                     D IS NODE WHICH WAS PREVIOUSLY CHAINED TO A  */
*/*                      (INSERTION CASE ONLY)                       */
*/*               CASE 1. NEW NODE ADDED TO END OF LEG               */
*/*                    -ADDR OF X IN APPROPRIATE LEG PTR OF A        */
*/*                    -ADDR OF A IN BACKWARD POINTER OF X           */
*/*               CASE 2. NEW NODE INSERTED                          */
*/*                    -ALL OF CASE 1 PLUS                           */
*/*                    -ADDR OF D IN APPROPRIATE LEG PTR OF X        */
*/*                    -ADDR OF X IN BACKWARD POINTER OF D           */
*/*                                                                  */
*/********************************************************************/
*                                                                  0602
*ADRTTREE:                                                         0602
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0602
ADRTTREE DS    0H                                                  0603
*   RFY                                                            0603
*     R14 RSTD;                     /* RESTRICT RETURN REGISTER      */
*                                                                  0603
*   /*****************************************************************/
*   /*                                                               */
*   /* LOOP, MOVING DOWN THE TREE ONE NODE WITH EACH ITERATION, UNTIL*/
*   /* INPUT IOE HAS BEEN ADDED TO THE TREE                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0604
*   EPAIOEIP=ZERO;                  /* SET FOR RECOVERY              */
         SLR   @15,@15                                             0604
         ST    @15,EPAIOEIP                                        0604
*   DO WHILE THISNODE^=ZERO;                                       0605
*                                                                  0605
         B     @DE00605                                            0605
@DL00605 DS    0H                                                  0606
*     /***************************************************************/
*     /*                                                             */
*     /* DETERMINE WHICH WAY TO MOVE DOWN THE TREE----               */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0606
*     IF TSLOTNBR>                  /* WHICH WAY DOWN TREE ?         */
*         THISNODE->IOEAIA->AIASLOT THEN                           0606
         L     @15,IOEAIA(,THISNODE)                               0606
         LH    @15,AIASLOT(,@15)                                   0606
         N     @15,@CF01849                                        0606
         CR    TSLOTNBR,@15                                        0606
         BNH   @RF00606                                            0606
*       DO;                                                        0607
*                                                                  0607
*         /***********************************************************/
*         /*                                                         */
*         /* IF THE NEW IOE REPRESENTS A REQUEST FROM A RELATIVE SLOT*/
*         /* NUMBER GREATER THAN THAT OF THE CURRENT NODE BEING      */
*         /* EXAMINED, THEN MOVE DOWN THE TREE ON THE GT LEG         */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0608
*         LASTNODE=THISNODE;        /* SAVE PREV NODE ADDRESS        */
         LR    LASTNODE,THISNODE                                   0608
*         THISNODE=THISNODE->IOENXTGT;/* DOWN GT PATH                */
*                                                                  0609
         L     THISNODE,IOENXTGT(,THISNODE)                        0609
*         /***********************************************************/
*         /*                                                         */
*         /* ADD THE IOE TO THE TREE IF WE ARE AT THE END OF THE GT  */
*         /* LEG ----OR---- AN INSERTION IS NECESSARY. AN INSERTION  */
*         /* IS NECESSARY WHEN IT IS APPARENT THAT NORMAL SORTING    */
*         /* WOULD SEPARATE TWO NODES ASSOCIATED WITH REQUESTS FOR   */
*         /* THE SAME CYLINDER WITH A NODE FOR A DIFFERENT CYLINDER  */
*         /* REQUEST IN BETWEEN... IE. WHEN LASTNODE REPRESENTS A    */
*         /* REQUEST FOR CYLINDER X, THE SAME AS THE NEW IOE, BUT    */
*         /* THISNODE REPRESENTS A REQUEST FOR CYLINDER Y (>X)       */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0610
*         IF THISNODE=ZERO|         /* AT END OF LEG -OR-            */
*             (THISCYL<THISNODE->IOEAIA->AIACYL&/* INSERTION         */
*             THISCYL=LASTNODE->IOEAIA->AIACYL) THEN/* NECESSARY?    */
         LTR   THISNODE,THISNODE                                   0610
         BZ    @RT00610                                            0610
         L     @15,IOEAIA(,THISNODE)                               0610
         CH    THISCYL,AIACYL(,@15)                                0610
         BNL   @RF00610                                            0610
         L     @15,IOEAIA(,LASTNODE)                               0610
         CH    THISCYL,AIACYL(,@15)                                0610
         BNE   @RF00610                                            0610
@RT00610 DS    0H                                                  0611
*           DO;                                                    0611
*                                                                  0611
*             /*******************************************************/
*             /*                                                     */
*             /* PROCESSING COMMON TO END-OF-LEG-ADDITION OR         */
*             /* INSERTION...                                        */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0612
*             IOEBKPTR=LASTNODE;                                   0612
         ST    LASTNODE,IOEBKPTR(,IOEPTR)                          0612
*             LASTNODE->IOENXTGT=IOEPTR;                           0613
*                                                                  0613
         ST    IOEPTR,IOENXTGT(,LASTNODE)                          0613
*             /*******************************************************/
*             /*                                                     */
*             /* INSERT THE IOE, IF NECESSARY                        */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0614
*             IF THISNODE^=ZERO THEN/* NEW NODE TO BE INSERTED ?     */
         LTR   THISNODE,THISNODE                                   0614
         BZ    @RF00614                                            0614
*               DO;                                                0615
*                 IOENXTGT=THISNODE;/* RECHAIN OLD GT NODE TO NEW    */
         ST    THISNODE,IOENXTGT(,IOEPTR)                          0616
*                 THISNODE->IOEBKPTR=IOEPTR;/* RESET BWD PTR IN OLD
*                                      GT NODE                       */
         ST    IOEPTR,IOEBKPTR(,THISNODE)                          0617
*                 THISNODE=ZERO;    /* SET CTL TO GET OUT OF LOOP    */
         SLR   THISNODE,THISNODE                                   0618
*               END;                                               0619
*             ELSE                                                 0620
*               ;                                                  0620
@RF00614 DS    0H                                                  0621
*           END;                    /* END ADD-NODE-TO-GT-LEG        */
*         ELSE                                                     0622
*           ;                                                      0622
@RF00610 DS    0H                                                  0623
*       END;                        /* END MOVE-DOWN-GT-LEG          */
*     ELSE                                                         0624
*       DO;                                                        0624
*                                                                  0624
         B     @RC00606                                            0624
@RF00606 DS    0H                                                  0625
*         /***********************************************************/
*         /*                                                         */
*         /* IF THE NEW IOE REPRESENTS A REQUEST FROM A RELATIVE SLOT*/
*         /* NUMBER LESS THAN OR EQUAL THAT OF THE CURRENT NODE BEING*/
*         /* EXAMINED, THEN MOVE DOWN THE TREE ON THE LE LEG         */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0625
*         LASTNODE=THISNODE;        /* SAVE PREV NODE ADDRESS        */
         LR    LASTNODE,THISNODE                                   0625
*         THISNODE=THISNODE->IOENXTLE;/* DOWN LE PATH                */
*                                                                  0626
         L     THISNODE,IOENXTLE(,THISNODE)                        0626
*         /***********************************************************/
*         /*                                                         */
*         /* ADD THE IOE TO THE TREE IF WE ARE AT THE END OF THE LE  */
*         /* LEG ----OR---- AN INSERTION IS NECESSARY. AN INSERTION  */
*         /* IS NECESSARY WHEN IT IS APPARENT THAT NORMAL SORTING    */
*         /* WOULD SEPARATE TWO NODES ASSOCIATED WITH REQUESTS FOR   */
*         /* THE SAME CYLINDER WITH A NODE FOR A DIFFERENT CYLINDER  */
*         /* REQUEST IN BETWEEN... IE. WHEN LASTNODE REPRESENTS A    */
*         /* REQUEST FOR CYLINDER X, THE SAME AS THE NEW IOE, BUT    */
*         /* THISNODE REPRESENTS A REQUEST FOR CYLINDER Y (<X)       */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0627
*         IF THISNODE=ZERO|         /* AT END OF LEG -OR-            */
*             (THISCYL>THISNODE->IOEAIA->AIACYL&/* INSERTION         */
*             THISCYL=LASTNODE->IOEAIA->AIACYL) THEN/* NECESSARY?    */
         LTR   THISNODE,THISNODE                                   0627
         BZ    @RT00627                                            0627
         L     @15,IOEAIA(,THISNODE)                               0627
         CH    THISCYL,AIACYL(,@15)                                0627
         BNH   @RF00627                                            0627
         L     @15,IOEAIA(,LASTNODE)                               0627
         CH    THISCYL,AIACYL(,@15)                                0627
         BNE   @RF00627                                            0627
@RT00627 DS    0H                                                  0628
*           DO;                                                    0628
*                                                                  0628
*             /*******************************************************/
*             /*                                                     */
*             /* PROCESSING COMMON TO END-OF-LEG-ADDITION OR         */
*             /* INSERTION...                                        */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0629
*             IOEBKPTR=LASTNODE;                                   0629
         ST    LASTNODE,IOEBKPTR(,IOEPTR)                          0629
*             LASTNODE->IOENXTLE=IOEPTR;                           0630
*                                                                  0630
         ST    IOEPTR,IOENXTLE(,LASTNODE)                          0630
*             /*******************************************************/
*             /*                                                     */
*             /* INSERT THE IOE, IF NECESSARY                        */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0631
*             IF THISNODE^=ZERO THEN/* NEW NODE TO BE INSERTED ?     */
         LTR   THISNODE,THISNODE                                   0631
         BZ    @RF00631                                            0631
*               DO;                                                0632
*                 IOENXTLE=THISNODE;/* RECHAIN OLD LE NODE TO NEW    */
         ST    THISNODE,IOENXTLE(,IOEPTR)                          0633
*                 THISNODE->IOEBKPTR=IOEPTR;/* RESET BWD PTR IN OLD
*                                      LE NODE                       */
         ST    IOEPTR,IOEBKPTR(,THISNODE)                          0634
*                 THISNODE=ZERO;    /* SET CTL TO GET OUT OF LOOP    */
         SLR   THISNODE,THISNODE                                   0635
*               END;                                               0636
*             ELSE                                                 0637
*               ;                                                  0637
@RF00631 DS    0H                                                  0638
*           END;                    /* END ADD-NODE-TO-LE-LEG        */
*         ELSE                                                     0639
*           ;                                                      0639
@RF00627 DS    0H                                                  0640
*       END;                        /* END MOVE-DOWN-LE-LEG          */
*   END;                            /* END LOOP TO FIND CHAIN NODE   */
@RC00606 DS    0H                                                  0641
@DE00605 LTR   THISNODE,THISNODE                                   0641
         BNZ   @DL00605                                            0641
*   RFY                                                            0642
*     R14 UNRSTD;                   /* RELEASE RETURN REGISTER       */
*   END ADRTTREE;                   /* END SUBROUTINE ADRTTREE       */
@EL00008 DS    0H                                                  0643
@EF00008 DS    0H                                                  0643
@ER00008 BR    @14                                                 0643
*   END ILRPTM                                                     0644
*                                                                  0644
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (ILRAIA  )                                       */
*/*%INCLUDE SYSLIB  (ILRASMVT)                                       */
*/*%INCLUDE SYSLIB  (ILRATA  )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (ILREPATH)                                       */
*/*%INCLUDE SYSLIB  (IHAFRRS )                                       */
*/*%INCLUDE SYSLIB  (ILRIOE  )                                       */
*/*%INCLUDE SYSLIB  (ILRIORB )                                       */
*/*%INCLUDE SYSLIB  (IHALCCA )                                       */
*/*%INCLUDE SYSLIB  (ILRPAT  )                                       */
*/*%INCLUDE SYSLIB  (ILRPART )                                       */
*/*%INCLUDE SYSLIB  (ILRPCCW )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IHASRB  )                                       */
*/*%INCLUDE SYSLIB  (IHAWSAVT)                                       */
*                                                                  0644
*       ;                                                          0644
@DATA    DS    0H
@CH01299 DC    H'5'
@CH00986 DC    H'6'
@CH01285 DC    H'7'
@CH00033 DC    H'10'
@DATD    DSECT
         DS    0F
ILRPTM   CSECT
         DS    0F
@CF00082 DC    F'2'
@CF00117 DC    F'4'
@CF00040 DC    F'8'
@CH00040 EQU   @CF00040+2
@CF00267 DC    F'12'
@CF01247 DC    XL4'80000000'
@CF01723 DC    XL4'7FFFFFFF'
@CF01849 DC    XL4'0000FFFF'
@DATD    DSECT
         DS    0D
PARTPTR  DS    A
CURQ     DS    A
RETADDR1 DS    A
RETADDR2 DS    A
SRTCODSV DS    F
CYLSLOTS DS    F
EPATH    DS    CL40
         ORG   EPATH
EPAPARM  DS    AL4
EPAIOEIP DS    AL4
EPAIOEQP DS    AL4
EPAFFIOE DS    AL4
EPALFIOE DS    AL4
EPAWRTQ  DS    AL4
EPAWTPAT DS    AL4
EPACYLA  DS    AL4
EPAMSPAD DS    AL4
EPAWRTCT DS    FL2
EPACPUID DS    FL2
         ORG   EPATH+40
PARMLIST DS    CL20
         ORG   PARMLIST
IORBPTR  DS    AL4
PAREPTR  DS    AL4
PCCWPTR  DS    AL4
WRTIOEQ  DS    AL4
SRTWORK  DS    AL4
         ORG   PARMLIST+20
@NM00048 DS    CL12
         ORG   @NM00048
LASTPARE DS    AL4
QPARE    DS    AL4
CIRCUPDT DS    AL4
         ORG   @NM00048+12
MSGPLIST DS    CL8
         ORG   MSGPLIST
MSGNUM   DS    FL2
MSGTYPE  DS    FL2
MSGCBADR DS    AL4
         ORG   MSGPLIST+8
PTMFLAGS DS    CL1
         ORG   PTMFLAGS
WRTLOCKD DS    BL1
MOREWORK EQU   PTMFLAGS+0
PRESCHED EQU   PTMFLAGS+0
@NM00049 EQU   PTMFLAGS+0
         ORG   PTMFLAGS+1
         DS    CL3
PTMSAVE  DS    18A
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
ILRPTM   CSECT
         NOPR  ((@ENDDATD-@DATD)/257*16)
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV01756 DC    V(ILRSRT01)
@CV01757 DC    V(ILRSRT)
@CV01758 DC    V(ILRPAGCM)
@CV01759 DC    V(ILRMSG00)
         DS    0D
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
TSLOTNBR EQU   @11
THISNODE EQU   @02
LASTNODE EQU   @05
PTRIORB  EQU   @07
THISCYL  EQU   @12
IOEHOLDR EQU   @02
IOEPTR   EQU   @06
AIAPTR   EQU   @02
ASMVTPTR EQU   @03
ATAPTR   EQU   @04
R0       EQU   @00
R1       EQU   @01
R2       EQU   @02
R4       EQU   @04
R6       EQU   @06
R7       EQU   @07
R9       EQU   @09
R11      EQU   @11
R12      EQU   @12
R13      EQU   @13
R14      EQU   @14
R15      EQU   @15
R10      EQU   @10
R3       EQU   @03
R5       EQU   @05
R8       EQU   @08
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
FLCCVT   EQU   FLCICCW2
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSALCCAV EQU   PSA+528
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSALITA  EQU   PSA+764
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
PSALSFCC EQU   PSA+1012
AIA      EQU   0
AIAFLG1  EQU   AIA+9
AIAFLG2  EQU   AIA+10
AIASECER EQU   AIAFLG2
AIAFLG3  EQU   AIA+11
AIANXAIA EQU   AIA+12
AIACYL   EQU   AIANXAIA
AIARCSN  EQU   AIANXAIA+2
AIAID    EQU   AIA+16
AIALPID  EQU   AIAID
AIALGID  EQU   AIALPID
AIALSID  EQU   AIALGID
AIASSID  EQU   AIALSID+1
AIASLOT  EQU   AIASSID+1
AIARPN   EQU   AIALPID+4
AIALSID2 EQU   AIARPN
AIALPMEP EQU   AIALSID2
AIAGRPSZ EQU   AIA+24
AIALGE   EQU   AIAGRPSZ
AIADPXCT EQU   AIALGE
ASMVT    EQU   0
ASMFLAG1 EQU   ASMVT
ASMDUPLX EQU   ASMFLAG1
ASMNOCWQ EQU   ASMFLAG1
ASMNODPX EQU   ASMFLAG1
ASMPLPAF EQU   ASMFLAG1
ASMCOMMF EQU   ASMFLAG1
ASMFLAG2 EQU   ASMVT+1
ASMPART  EQU   ASMVT+8
ASMSTAGQ EQU   ASMVT+32
ASMPCCWQ EQU   ASMVT+64
ASMPCCWA EQU   ASMPCCWQ
ASMIOCNT EQU   ASMVT+80
ASMSRBCT EQU   ASMVT+84
ASMPSRB  EQU   ASMVT+88
ASMLSAI  EQU   ASMVT+144
ASMGOSQS EQU   ASMVT+152
ASMPEX   EQU   ASMVT+224
ASMIOEPC EQU   ASMVT+296
ASMWKSA1 EQU   ASMVT+368
ASMWKSA2 EQU   ASMVT+448
ASMWKSA3 EQU   ASMVT+528
ASMWKSA4 EQU   ASMVT+608
ASMWKSA5 EQU   ASMVT+688
ASMPOOLS EQU   0
ASMCPAVQ EQU   ASMPOOLS+8
ASMCPAVL EQU   ASMCPAVQ
ASMCPRSQ EQU   ASMPOOLS+16
ATA      EQU   0
ATAMODID EQU   ATA
ATASFLGS EQU   ATA+1
ATARFLGS EQU   ATA+4
ATARCRSN EQU   ATA+6
ATARCODE EQU   ATA+7
ATACLEAR EQU   ATA+8
ATAWORKA EQU   ATACLEAR
ATAEPATH EQU   ATACLEAR+4
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
FRRS     EQU   0
FRRSHEAD EQU   FRRS
FRRSEMP  EQU   FRRSHEAD
FRRSLAST EQU   FRRSHEAD+4
FRRSELEN EQU   FRRSHEAD+8
FRRSCURR EQU   FRRSHEAD+12
FRRSENTR EQU   0
FRRSFRRA EQU   FRRSENTR
FRRSFLGS EQU   FRRSENTR+4
FRRSFLG1 EQU   FRRSFLGS
FRRSPARM EQU   FRRSENTR+8
IOE      EQU   0
IOENXT   EQU   IOE
IOENXTLE EQU   IOENXT
IOELSIDA EQU   IOE+4
IOENXTGT EQU   IOELSIDA
IOEAIA   EQU   IOE+8
IOEWORK  EQU   IOE+12
IOEBKPTR EQU   IOEWORK
IORB     EQU   0
IORFLGS  EQU   IORB+3
IORFUSE  EQU   IORFLGS
IORAPND  EQU   IORFLGS
IORIORB  EQU   IORB+4
IORPCCW  EQU   IORB+8
LCCA     EQU   0
LCCAIHRC EQU   LCCA+520
LCCAIHR1 EQU   LCCAIHRC
LCCAIHR2 EQU   LCCAIHRC+1
LCCAIHR3 EQU   LCCAIHRC+2
LCCAIHR4 EQU   LCCAIHRC+3
LCCASPIN EQU   LCCA+524
LCCASPN1 EQU   LCCASPIN
LCCASPN2 EQU   LCCASPIN+1
LCCASPN3 EQU   LCCASPIN+2
LCCASPN4 EQU   LCCASPIN+3
LCCACPUS EQU   LCCA+536
LCCADSF1 EQU   LCCA+540
LCCADSF2 EQU   LCCA+541
LCCASPSA EQU   LCCA+544
LCCACRFL EQU   LCCA+692
LCCACREX EQU   LCCA+693
LCCALKFG EQU   LCCA+694
LCCASRBF EQU   LCCA+720
PAT      EQU   0
PATHDR   EQU   PAT
PATCYLSZ EQU   PATHDR+10
PATMAP   EQU   PAT+16
PART     EQU   0
PARTHDR  EQU   PART
PARTAIAE EQU   PARTHDR+12
PARTCIR1 EQU   PARTHDR+16
PARTCIR2 EQU   PARTHDR+20
PARTTPAR EQU   PARTHDR+24
PARTLKUP EQU   PARTHDR+40
PARTLOCK EQU   PARTHDR+44
PARTCOMQ EQU   PARTHDR+48
PARTSPLQ EQU   PARTHDR+56
PARTSPLF EQU   PARTSPLQ
PARTSPLL EQU   PARTSPLQ+4
PARTDUPQ EQU   PARTHDR+64
PARTLOCQ EQU   PARTHDR+72
PARTENTS EQU   PART+80
PARTENT  EQU   0
PAREPARE EQU   PARTENT
PARELKUP EQU   PARTENT+4
PARELKFL EQU   PARELKUP
PAREFSIP EQU   PARELKFL
PARETYPE EQU   PARTENT+8
PAREPLPA EQU   PARETYPE
PARECOMM EQU   PARETYPE
PARELOCL EQU   PARETYPE
PAREFLG1 EQU   PARTENT+9
PAREDSBD EQU   PAREFLG1
PAREIOEQ EQU   PARTENT+12
PARESLTA EQU   PARTENT+20
PAREIORB EQU   PARTENT+28
PAREPATP EQU   PARTENT+32
PARENODE EQU   PARTENT+48
PAREWTQE EQU   PARTENT+52
PCCW     EQU   0
PCCWFLGS EQU   PCCW+2
PCCWPCCW EQU   PCCW+4
PCCWAIA  EQU   PCCW+8
PCCWCHHR EQU   PCCW+16
PCCWSEEK EQU   PCCW+24
PCCWSSEC EQU   PCCW+32
PCCWSRCH EQU   PCCW+40
PCCWTIC  EQU   PCCW+48
PCCWRW   EQU   PCCW+56
PCCWNOP  EQU   PCCW+64
SRBSECT  EQU   0
SRB      EQU   SRBSECT
SRBFLC   EQU   SRB+12
SRBPTR   EQU   0
WSAC     EQU   0
WSACASMS EQU   WSAC+60
ZEROWORK EQU   0
WRITEQ   EQU   0
WRITEQUE EQU   WRITEQ
WRITEQUL EQU   WRITEQ+4
GMACELL  EQU   0
GMANEXT  EQU   GMACELL
ILRPEX   EQU   0
PATCYL   EQU   0
PATCYLMP EQU   0
ASM1WKSV EQU   ASMWKSA1
ASM1RGSV EQU   ASM1WKSV
ASM1WRKA EQU   ASM1WKSV+60
ASM2WKSV EQU   ASMWKSA2
ASM2WRKA EQU   ASM2WKSV+52
ASM2FLGS EQU   ASM2WRKA+12
ASM3WKSV EQU   ASMWKSA3
ASM4WKSV EQU   ASMWKSA4
ASM4RGSV EQU   ASM4WKSV
ASM5WKSV EQU   ASMWKSA5
ASM5RGSV EQU   ASM5WKSV
CVTPTR   EQU   FLCCVT
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTSRBRT EQU   CVTS01+100
CVTASMVT EQU   CVTS01+356
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
LCCAPTR  EQU   PSALCCAV
PATPTR   EQU   PAREPATP
FLC      EQU   PSA
PSARSVTE EQU   PSARSVT
PSACSTK  EQU   PSARSVTE
*                                      START UNREFERENCED COMPONENTS
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
ASM5FLGS EQU   ASM5WKSV+64
ASM5AIA  EQU   ASM5WKSV+60
ASM5GCTR EQU   ASM5WKSV+56
ASM5SR14 EQU   ASM5WKSV+52
@NM00006 EQU   ASM5RGSV+4
ASM5RG2  EQU   ASM5RGSV
@NM00005 EQU   ASM4RGSV+4
ASM4RG2  EQU   ASM4RGSV
ASM3SR13 EQU   ASM3WKSV+28
ASM3R14B EQU   ASM3WKSV+24
ASM3R14A EQU   ASM3WKSV+20
ASM3GRPA EQU   ASM3WKSV+16
ASM3TMPA EQU   ASM3WKSV+12
ASM3PIOP EQU   ASM3WKSV+8
ASM3GENQ EQU   ASM3WKSV+4
ASM3SWPQ EQU   ASM3WKSV
ASM2SR14 EQU   ASM2WRKA+16
@NM00004 EQU   ASM2WRKA+13
ASM2WFLG EQU   ASM2FLGS
ASM2RFLG EQU   ASM2FLGS
ASM2DUPQ EQU   ASM2WRKA+8
ASM2CAQ  EQU   ASM2WRKA+4
ASM2PAQ  EQU   ASM2WRKA
ASM2RGSV EQU   ASM2WKSV
ASM1NXTA EQU   ASM1WRKA+4
ASM1ASCB EQU   ASM1WRKA
ASM1RG15 EQU   ASM1RGSV+56
@NM00003 EQU   ASM1RGSV+4
ASM1RG1  EQU   ASM1RGSV
WSACASMD EQU   WSAC+56
WSACCCH  EQU   WSAC+52
WSACRRSA EQU   WSAC+48
WSACREST EQU   WSAC+44
WSACRSTI EQU   WSAC+40
WSACABTM EQU   WSAC+36
WSACMF1  EQU   WSAC+32
WSACEDS0 EQU   WSAC+28
WSACIOS  EQU   WSAC+24
WSACRTMK EQU   WSAC+20
WSACACR  EQU   WSAC+16
WSACTIME EQU   WSAC+12
WSACOPTM EQU   WSAC+8
WSACGTF  EQU   WSAC+4
WSACCWSA EQU   WSAC
@NM00047 EQU   SRB+40
@NM00046 EQU   SRB+38
SRBPRIOR EQU   SRB+37
SRBPKF   EQU   SRB+36
SRBSAVE  EQU   SRB+32
SRBPARM  EQU   SRB+28
SRBRMTR  EQU   SRB+24
SRBEP    EQU   SRB+20
SRBPTCB  EQU   SRBFLC+4
SRBPASID EQU   SRBFLC+2
SRBCPAFF EQU   SRBFLC
SRBASCB  EQU   SRB+8
SRBFLNK  EQU   SRB+4
SRBID    EQU   SRB
@NM00021 EQU   PCCW+72
PCCWNCT  EQU   PCCWNOP+6
PCCWNFG  EQU   PCCWNOP+4
PCCWNAD  EQU   PCCWNOP+1
PCCWN    EQU   PCCWNOP
PCCWCNT  EQU   PCCWRW+6
PCCWRWFG EQU   PCCWRW+4
PCCWADDR EQU   PCCWRW+1
PCCWRDWT EQU   PCCWRW
PCCWTCT  EQU   PCCWTIC+6
PCCWTFG  EQU   PCCWTIC+4
PCCWTAD  EQU   PCCWTIC+1
PCCWT    EQU   PCCWTIC
PCCWSICT EQU   PCCWSRCH+6
PCCWSIFG EQU   PCCWSRCH+4
PCCWSIAD EQU   PCCWSRCH+1
PCCWSIDE EQU   PCCWSRCH
PCCWSSCT EQU   PCCWSSEC+6
PCCWSSFG EQU   PCCWSSEC+4
PCCWSSAD EQU   PCCWSSEC+1
PCCWSS   EQU   PCCWSSEC
PCCWSKCT EQU   PCCWSEEK+6
PCCWSKFG EQU   PCCWSEEK+4
PCCWSKAD EQU   PCCWSEEK+1
PCCWSK   EQU   PCCWSEEK
PCCWR    EQU   PCCWCHHR+7
PCCWHH   EQU   PCCWCHHR+5
PCCWCC   EQU   PCCWCHHR+3
PCCWBB   EQU   PCCWCHHR+1
PCCWM    EQU   PCCWCHHR
PCCWIORB EQU   PCCW+12
@NM00020 EQU   PCCW+3
@NM00019 EQU   PCCWFLGS
PCCWFERR EQU   PCCWFLGS
PCCWSECT EQU   PCCW+1
PCCWID   EQU   PCCW
@NM00018 EQU   PARTENT+62
PARELCYL EQU   PARTENT+60
PARERQTM EQU   PARTENT+56
PAREUCBP EQU   PARTENT+44
PAREEDBP EQU   PARTENT+40
PAREPCTP EQU   PARTENT+36
PARERRCT EQU   PARTENT+24
PARESZSL EQU   PARTENT+16
PARENN   EQU   PARTENT+10
@NM00017 EQU   PAREFLG1
PAREINCP EQU   PAREFLG1
PARENUSE EQU   PAREFLG1
@NM00016 EQU   PARETYPE
PAREDPLX EQU   PARETYPE
PARECPCT EQU   PARELKUP+2
PAREIORN EQU   PARELKUP+1
@NM00015 EQU   PARELKFL
PARTLOCL EQU   PARTLOCQ+4
PARTLOCF EQU   PARTLOCQ
PARTDUPL EQU   PARTDUPQ+4
PARTDUPF EQU   PARTDUPQ
PARTCOML EQU   PARTCOMQ+4
PARTCOMF EQU   PARTCOMQ
@NM00014 EQU   PARTHDR+34
PARTLCNT EQU   PARTHDR+32
PARTPCTQ EQU   PARTHDR+28
PARTDSNL EQU   PARTTPAR
PARTEUSE EQU   PARTHDR+8
PARTSIZE EQU   PARTHDR+4
PARTIDEN EQU   PARTHDR
PATCYLS  EQU   PATMAP
PATRSV1  EQU   PATHDR+14
PATCYLMW EQU   PATHDR+12
PATCYLNO EQU   PATHDR+8
PATPART  EQU   PATHDR+4
PATIDENT EQU   PATHDR
LCCAR125 EQU   LCCA+964
LCCAR124 EQU   LCCA+960
LCCASGPR EQU   LCCA+896
LCCADRT2 EQU   LCCA+888
LCCADRT1 EQU   LCCA+880
LCCAR103 EQU   LCCA+876
LCCAESS2 EQU   LCCA+872
LCCASPLJ EQU   LCCA+868
LCCASMQJ EQU   LCCA+864
LCCAIRT  EQU   LCCA+736
LCCAASID EQU   LCCA+732
LCCARV89 EQU   LCCA+728
LCCAPGTA EQU   LCCASRBF+2
LCCASAFN EQU   LCCASRBF
LCCAECSA EQU   LCCA+716
LCCAICR0 EQU   LCCA+712
LCCALWTM EQU   LCCA+704
LCCARV78 EQU   LCCA+700
LCCAPINV EQU   LCCA+696
LCCARV88 EQU   LCCA+695
LCCARV87 EQU   LCCALKFG
LCCARV86 EQU   LCCALKFG
LCCARV85 EQU   LCCALKFG
LCCARV84 EQU   LCCALKFG
LCCALKRD EQU   LCCALKFG
LCCALKAQ EQU   LCCALKFG
LCCALKSA EQU   LCCALKFG
LCCALKDP EQU   LCCALKFG
LCCACRST EQU   LCCACREX
LCCACRDP EQU   LCCACREX
LCCACRLM EQU   LCCACREX
LCCACRIN EQU   LCCACREX
LCCACRRT EQU   LCCACREX
LCCACRLE EQU   LCCACREX
LCCACRRM EQU   LCCACREX
LCCACREF EQU   LCCACREX
LCCAVARY EQU   LCCACRFL
LCCARV73 EQU   LCCACRFL
LCCARV72 EQU   LCCACRFL
LCCARV71 EQU   LCCACRFL
LCCARV70 EQU   LCCACRFL
LCCARV69 EQU   LCCACRFL
LCCACLMS EQU   LCCACRFL
LCCACRTM EQU   LCCACRFL
LCCALCR0 EQU   LCCA+688
LCCACRLC EQU   LCCA+684
LCCARCPU EQU   LCCA+680
LCCADCPU EQU   LCCA+676
LCCASRBJ EQU   LCCA+672
LCCADSSR EQU   LCCA+668
LCCADSSC EQU   LCCA+660
LCCADSS3 EQU   LCCA+648
LCCADSS2 EQU   LCCA+636
LCCADSS1 EQU   LCCA+624
LCCAWTIM EQU   LCCA+616
LCCAITOD EQU   LCCA+608
LCCADTOD EQU   LCCA+600
LCCASTOD EQU   LCCA+592
LCCARIR5 EQU   LCCASPSA+44
LCCARIR4 EQU   LCCASPSA+40
LCCARIR3 EQU   LCCASPSA+36
LCCARIR2 EQU   LCCASPSA+32
LCCARPR5 EQU   LCCASPSA+28
LCCARPR4 EQU   LCCASPSA+24
LCCARPR3 EQU   LCCASPSA+20
LCCARPR2 EQU   LCCASPSA+16
LCCADSR5 EQU   LCCASPSA+12
LCCADSR4 EQU   LCCASPSA+8
LCCADSR3 EQU   LCCASPSA+4
LCCADSR2 EQU   LCCASPSA
LCCARV68 EQU   LCCA+543
LCCAPSMK EQU   LCCA+542
LCCARV67 EQU   LCCADSF2
LCCARV66 EQU   LCCADSF2
LCCARV65 EQU   LCCADSF2
LCCARV64 EQU   LCCADSF2
LCCADSRW EQU   LCCADSF2
LCCADSPL EQU   LCCADSF2
LCCAGSRB EQU   LCCADSF2
LCCASRBM EQU   LCCADSF2
LCCARV61 EQU   LCCADSF1
LCCARV60 EQU   LCCADSF1
LCCARV59 EQU   LCCADSF1
LCCARV58 EQU   LCCADSF1
LCCATIMR EQU   LCCADSF1
LCCADSS  EQU   LCCADSF1
LCCAVCPU EQU   LCCADSF1
LCCAACR  EQU   LCCADSF1
LCCAASCP EQU   LCCA+532
LCCAESSA EQU   LCCA+528
LCCARV55 EQU   LCCASPN4
LCCARV54 EQU   LCCASPN4
LCCARV53 EQU   LCCASPN4
LCCARV52 EQU   LCCASPN4
LCCARV51 EQU   LCCASPN4
LCCARV50 EQU   LCCASPN4
LCCARV49 EQU   LCCASPN4
LCCARV48 EQU   LCCASPN4
LCCARV47 EQU   LCCASPN3
LCCARV46 EQU   LCCASPN3
LCCARV45 EQU   LCCASPN3
LCCARV44 EQU   LCCASPN3
LCCARV43 EQU   LCCASPN3
LCCARV42 EQU   LCCASPN3
LCCARV41 EQU   LCCASPN3
LCCARV40 EQU   LCCASPN3
LCCARV39 EQU   LCCASPN2
LCCARV38 EQU   LCCASPN2
LCCARV37 EQU   LCCASPN2
LCCARV36 EQU   LCCASPN2
LCCARV35 EQU   LCCASPN2
LCCARV34 EQU   LCCASPN2
LCCARV33 EQU   LCCASPN2
LCCARV32 EQU   LCCASPN2
LCCARV31 EQU   LCCASPN1
LCCARV30 EQU   LCCASPN1
LCCAMFIO EQU   LCCASPN1
LCCARSTR EQU   LCCASPN1
LCCATSPN EQU   LCCASPN1
LCCALOCK EQU   LCCASPN1
LCCASIGP EQU   LCCASPN1
LCCAPTLB EQU   LCCASPN1
LCCARV27 EQU   LCCAIHR4
LCCARV26 EQU   LCCAIHR4
LCCARV25 EQU   LCCAIHR4
LCCARV24 EQU   LCCAIHR4
LCCARV23 EQU   LCCAIHR4
LCCARV22 EQU   LCCAIHR4
LCCARV21 EQU   LCCAIHR4
LCCARV20 EQU   LCCAIHR4
LCCARV19 EQU   LCCAIHR3
LCCARV18 EQU   LCCAIHR3
LCCARV17 EQU   LCCAIHR3
LCCARV16 EQU   LCCAIHR3
LCCARV15 EQU   LCCAIHR3
LCCARV14 EQU   LCCAIHR3
LCCARV13 EQU   LCCAIHR3
LCCARV12 EQU   LCCAIHR3
LCCARV11 EQU   LCCAIHR2
LCCARV10 EQU   LCCAIHR2
LCCARV09 EQU   LCCAIHR2
LCCARV08 EQU   LCCAIHR2
LCCARV07 EQU   LCCAIHR2
LCCARV06 EQU   LCCAIHR2
LCCARV05 EQU   LCCAIHR2
LCCARV04 EQU   LCCAIHR2
LCCARV03 EQU   LCCAIHR1
LCCARV02 EQU   LCCAIHR1
LCCARV01 EQU   LCCAIHR1
LCCAPPIE EQU   LCCAIHR1
LCCAPSG1 EQU   LCCAIHR1
LCCAPDAT EQU   LCCAIHR1
LCCAXRC2 EQU   LCCAIHR1
LCCAXRC1 EQU   LCCAIHR1
LCCAIOPS EQU   LCCA+512
LCCAGPGR EQU   LCCA+448
LCCAR133 EQU   LCCA+444
LCCAR132 EQU   LCCA+440
LCCAR131 EQU   LCCA+436
LCCAR130 EQU   LCCA+432
LCCAR129 EQU   LCCA+428
LCCAR128 EQU   LCCA+424
LCCAR127 EQU   LCCA+420
LCCAR126 EQU   LCCA+416
LCCARSGR EQU   LCCA+352
LCCAXGR3 EQU   LCCA+288
LCCAXGR2 EQU   LCCA+224
LCCAXGR1 EQU   LCCA+160
LCCACR0  EQU   LCCA+156
LCCAMCR1 EQU   LCCA+152
LCCAPVAD EQU   LCCA+148
LCCAPINT EQU   LCCA+144
LCCAPPSW EQU   LCCA+136
LCCAPGR2 EQU   LCCA+72
LCCAPGR1 EQU   LCCA+8
LCCARV77 EQU   LCCA+6
LCCACPUA EQU   LCCA+4
LCCALCCA EQU   LCCA
@NM00013 EQU   IORB+40
IORRSV   EQU   IORB+36
IORPARTE EQU   IORB+32
IORTSMP  EQU   IORB+24
IORERR   EQU   IORB+20
IORSAVE  EQU   IORB+16
IORIOSB  EQU   IORB+12
IORSCCW  EQU   IORPCCW
IORFAE   EQU   IORAPND
IORFNE   EQU   IORAPND
IORFDI   EQU   IORAPND
IORSWAP  EQU   IORFLGS
@NM00012 EQU   IORFLGS
IORFRPS  EQU   IORFLGS
IORRQSZ  EQU   IORB+2
IORNUM   EQU   IORB+1
IORID    EQU   IORB
@NM00011 EQU   IOE+16
@NM00010 EQU   FRRSFLGS+1
@NM00009 EQU   FRRSFLG1
FRRSNEST EQU   FRRSFLG1
FRRSRCUR EQU   FRRSFLG1
FRRSENTS EQU   FRRS+84
FRRSRTMW EQU   FRRS+16
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00008 EQU   CVTFIX+248
@NM00007 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTRSV99 EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
ATARCRF8 EQU   ATARCRSN
ATARCRF7 EQU   ATARCRSN
ATARCRF6 EQU   ATARCRSN
ATARCRF5 EQU   ATARCRSN
ATARCRF4 EQU   ATARCRSN
ATARCRF3 EQU   ATARCRSN
ATARCRF2 EQU   ATARCRSN
ATARCRF1 EQU   ATARCRSN
ATARSV2  EQU   ATARFLGS
ATABADPK EQU   ATARFLGS
ATASCCWP EQU   ATARFLGS
ATASGNST EQU   ATARFLGS
ATARSV1  EQU   ATASFLGS+1
ATASRT   EQU   ATASFLGS+1
ATASWPDR EQU   ATASFLGS+1
ATATRPAG EQU   ATASFLGS+1
ATASWAP  EQU   ATASFLGS+1
ATAPAGCM EQU   ATASFLGS
ATAPAGIO EQU   ATASFLGS
ATAPOS   EQU   ATASFLGS
ATAPCOMP EQU   ATASFLGS
ATAVIOCM EQU   ATASFLGS
ATASCOMP EQU   ATASFLGS
ATASLSQA EQU   ATASFLGS
ATAQIOE  EQU   ATASFLGS
ASMCPRES EQU   ASMCPRSQ+4
ASMCPTAK EQU   ASMCPRSQ
ASMCPCNT EQU   ASMCPAVQ+4
ASMCPEXT EQU   ASMPOOLS+6
ASMCPSIZ EQU   ASMPOOLS+4
ASMCPID  EQU   ASMPOOLS
ASMRSV12 EQU   ASMVT+1000
ASMSAVE  EQU   ASMVT+928
ASMWKSA7 EQU   ASMVT+848
ASMWKSA6 EQU   ASMVT+768
ASMACEPC EQU   ASMVT+344
ASMSWKPC EQU   ASMVT+328
ASMBWKPC EQU   ASMVT+312
ASMRSV10 EQU   ASMVT+280
ASMPVACE EQU   ASMVT+276
ASMPIOFR EQU   ASMVT+272
ASMPVACQ EQU   ASMVT+268
ASMPMSGS EQU   ASMVT+264
ASMPMSG0 EQU   ASMVT+260
ASMPFRLG EQU   ASMVT+256
ASMPRLG  EQU   ASMVT+252
ASMPACT  EQU   ASMVT+248
ASMPSAV  EQU   ASMVT+244
ASMPCMP  EQU   ASMVT+240
ASMPCMPA EQU   ASMVT+236
ASMPCMPN EQU   ASMVT+232
ASMPCMPD EQU   ASMVT+228
ASMVRMTR EQU   ASMVT+220
ASMPSRBC EQU   ASMVT+216
ASMPSRMT EQU   ASMVT+212
ASMPSWPD EQU   ASMVT+208
ASMPTM   EQU   ASMVT+204
ASMPFRSW EQU   ASMVT+200
ASMPFRSL EQU   ASMVT+196
ASMPQIOE EQU   ASMVT+192
ASMRSV8  EQU   ASMVT+184
ASMTASCB EQU   ASMVT+180
ASMRLGWQ EQU   ASMVT+176
ASMRLGRQ EQU   ASMVT+172
ASMTMECB EQU   ASMVT+168
ASMTCBPT EQU   ASMVT+164
ASMREQCT EQU   ASMVT+160
ASMGOSWK EQU   ASMGOSQS+4
ASMGOSWT EQU   ASMGOSQS
ASMLSAIH EQU   ASMLSAI+4
ASMLSAIL EQU   ASMLSAI
ASMCINV  EQU   ASMVT+140
ASMSTGXA EQU   ASMVT+136
ASMLGVT  EQU   ASMVT+132
ASMSLOTV EQU   ASMVT+128
ASMERRS  EQU   ASMVT+124
ASMNVSC  EQU   ASMVT+120
ASMVSC   EQU   ASMVT+116
ASMSLOTS EQU   ASMVT+112
ASMBKSLT EQU   ASMVT+108
ASMRSV7  EQU   ASMVT+92
ASMBURST EQU   ASMVT+76
ASMPCCWN EQU   ASMVT+72
ASMPCCWC EQU   ASMPCCWQ+4
ASMRSV6  EQU   ASMVT+48
ASMIORQC EQU   ASMVT+44
ASMIORQR EQU   ASMVT+40
ASMSTAGL EQU   ASMSTAGQ+4
ASMSTAGF EQU   ASMSTAGQ
ASMRSV5  EQU   ASMVT+28
ASMMSGBF EQU   ASMVT+24
ASMEREC  EQU   ASMVT+20
ASMTRPAG EQU   ASMVT+16
ASMGOS   EQU   ASMVT+12
ASMSART  EQU   ASMVT+4
ASMRSV4  EQU   ASMVT+2
ASMWARM  EQU   ASMFLAG2
ASMQUICK EQU   ASMFLAG2
ASMNOTPT EQU   ASMFLAG2
ASMNOTMR EQU   ASMFLAG2
ASMNOSAV EQU   ASMFLAG2
ASMCALLQ EQU   ASMFLAG2
ASMPLPAS EQU   ASMFLAG1
ASMRSV1  EQU   ASMFLAG1
ASMNOLCL EQU   ASMFLAG1
AIACEPTR EQU   AIALPMEP
@NM00002 EQU   AIASSID
@NM00001 EQU   AIALSID
AIARSV9  EQU   AIAFLG3
AIARSV8  EQU   AIAFLG3
AIARSV7  EQU   AIAFLG3
AIALPMEC EQU   AIAFLG3
AIARSV6  EQU   AIAFLG3
AIATRPSP EQU   AIAFLG3
AIAPRINO EQU   AIAFLG3
AIARSV5  EQU   AIAFLG3
AIABADID EQU   AIAFLG2
AIAERROR EQU   AIAFLG2
AIAPRIER EQU   AIAFLG2
AIARSV4  EQU   AIAFLG2
AIAIORTY EQU   AIAFLG2
AIATERMR EQU   AIAFLG2
AIAFRAUX EQU   AIAFLG2
AIARSV1  EQU   AIAFLG1
AIASWPFX EQU   AIAFLG1
AIAPAGDS EQU   AIAFLG1
AIALSQA  EQU   AIAFLG1
AIADUPLX EQU   AIAFLG1
AIAVIO   EQU   AIAFLG1
AIAPRIV  EQU   AIAFLG1
AIAWRITE EQU   AIAFLG1
AIAOP    EQU   AIA+8
AIABQPA  EQU   AIA+4
AIAFQPA  EQU   AIA
@NM00045 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00044 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00043 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00042 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00041 EQU   FLCFSA
@NM00040 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00039 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00038 EQU   FLCIOA
@NM00037 EQU   FLCMCLA+15
@NM00036 EQU   FLCMCLA+14
@NM00035 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00034 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00033 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00032 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00031 EQU   FLCPER
@NM00030 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00029 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00028 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00027 EQU   FLCPIILC
@NM00026 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00025 EQU   FLCSVILC
@NM00024 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00023 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00022 EQU   FLCICCW2+4
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
*                                      END UNREFERENCED COMPONENTS
@RC00181 EQU   @RC00146
@RC00424 EQU   @RC00422
@RC00455 EQU   @RC00453
@RC00589 EQU   @RC00588
@ENDDATA EQU   *
         END   ILRPTM,(C'PLS2045',0701,76114)
