         TITLE 'IRARMCTL -- SYSTEM RESOURCES MANAGER CONTROL ALGORITHM *
                        '
IRARMCTL CSECT ,                                                01S0001
@PROLOG  BALR  @12,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@12                                      01S0001
*                                                               01S0029
*   /*****************************************************************/
*   /*                                                               */
*   /* RMCTPTR (REG 2) MUST BE SET UP BEFORE IRARMCTL IS ENTERED     */
*   /* RRPAPTR (REG 3) MUST BE SET UP BEFORE IRARMCTL IS ENTERED     */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0029
*   SVEREG=RMCTRMSA;                /* SUPPLY SAVE AREA STACK ADDRS  */
         L     SVEREG,RMCTRMSA(,RMCTPTR)                        01S0029
*   RRPAEPA=ADDR(RMEPBCTL);         /* INDICATE CONTROL ROUTINE RMEP */
         LA    @09,RMEPBCTL(,RMCTPTR)                           01S0030
         ST    @09,RRPAEPA(,RRPAPTR)                            01S0030
*                                                               02S0031
*/* **************************************************************** */
*/*                                                                  */
*/*    ROUTINE NAME - IRARMCEN                                       */
*/*                                                                  */
*/*    DESCRIPTIVE NAME - SYSTEM RESOURCES MANAGER CNTRL ALGORITHM   */
*/*                       DEFERRED USER ACTION PROCESSING ROUTINE    */
*/*                                                                  */
*/*    FUNCTION- THE IRARMCEN ROUTINE TESTS THE DEFERRED     @Z40BPCJ*/
*/*          ACTION QUEUE AT -RMCTAQHD-.  IF THE ACTION QUEUE IS     */
*/*          NOT EMPTY, IRARMCEN PICKS THE FIRST OUCB ON THE QUEUE,  */
*/*          AND ROUTES CONTROL TO THOSE ROUTINES WHOSE REQUEST      */
*/*          FLAGS HAVE BEEN SET IN THE -OUCBACN- FIELD.  WHEN       */
*/*          THERE ARE NO MORE ACTIONS TO BE PERFORMED, IRARMCEN     */
*/*          DEQUEUES THE OUCB FROM THE ACTION QUEUE, AND SETS ITS   */
*/*          -OUCBACT- FIELD TO ZERO TO INDICATE UNQUEUED STATUS.    */
*/*                                                                  */
*/*    NOTE  - WHILE IRARMCEN IS EXECUTING, OTHR CONCURRENT PROCSS   */
*/*            MAY INSERT, VIA THE IRARMCRN RTNE, ADDITIONL ACTION   */
*/*            REQUEST BITS INTO THE -OUCBACN- FIELD.                */
*/*                                                                  */
*/*    SETUP PERFORMED FOR EACH INVOKED ACTION PROCESSING ROUTINE    */
*/*          - REG 1 CONTAINS THE ADDRESS OF THE RMEP BLOCK FOR THE  */
*/*            ACTION ROUTINE BEING INVOKED.                         */
*/*          - REG 4 CONTAINS THE ADDRESS OF THE OUCB FOR WHOM THE   */
*/*            ACTION IS TO BE PERFORMED.                            */
*/*          - REG 13 CONTAINS THE ADDRESS OF THE SAVE AREA STACK    */
*/*            ASSOCIATED WITH THE SYSTEM RESOURCES MANAGER LOCK.    */
*/*          - REG 14 CONTAINS THE RETURN ADDRESS.                   */
*/*          - REG 15 CONTAINS THE ACTION RTNE ENTRY ADDRESS.        */
*/*                                                                  */
*/* **************************************************************** */
*                                                               02S0031
*   /*****************************************************************/
*   /*                                                               */
*   /* CAN NOW INVOKE ROUTINES WHICH WERE PREVIOUSLY DEFERRED. ANY   */
*   /* USERS FOR WHOM ACTIONS WERE DEFERRED HAVE BEEN QUEUED ONTO THE*/
*   /* ACTION QUEUE. THE FOLLOWING CODE IS EXECUTED AS LONG AS THE   */
*   /* ACTION QUEUE IS NOT EMPTY. EMPTY IS INDICATED WHEN THE        */
*   /* REMAINING MEMBER IS THE DUMMY PREASSEMBLED OUCB.              */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0031
*   DO WHILE(RMCTAQHD^=RMCTOUCB);                               02S0031
         B     @DE00031                                         02S0031
@DL00031 DS    0H                                               02S0032
*RMCENL1:                           /* RETRY PICK 1ST OUCB IF QUEUE
*                                      CHANGED BY OTHER PROCESS      */
*     OUCBPTR=RMCTAQHD;             /* PICK TOP OUCB ON ACTION QUE   */
*                                                               02S0032
RMCENL1  L     OUCBPTR,RMCTAQHD(,RMCTPTR)                       02S0032
*     /***************************************************************/
*     /*                                                             */
*     /* DEQUEUE THE OUCB FROM THE ACTION QUEUE, AS ALL REQSTD       */
*     /* ACTIONS WILL HAVE BEEN PERFORMED BY THE TIME THAT THE       */
*     /* IRARMCEN ROUTINE STEPS AWAY FROM THIS OUCB. A ZERO IS       */
*     /* INSERTED INTO THE -OUCBACT- FIELD TO INDICATE THAT THIS USER*/
*     /* IS NO LONGER QUEUED UP FOR ACTION PROCESSING.               */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0033
*     R0=ZERO;                      /* ZERO - TO MARK OUCB NOT QUED  */
         SLR   R0,R0                                            02S0033
*     SVRE=RMCTAQCT;                /* PICK PREV ACTION QUEUE COUNT  */
         L     SVRE,RMCTAQCT(,RMCTPTR)                          02S0034
*     SVRO=OUCBPTR;                 /* INSURE OUCB STILL QUED AT TOP */
         LR    SVRO,OUCBPTR                                     02S0035
*     WKRE=SVRE;                    /* KEEP PREV ACTION QUEUE COUNT  */
         LR    WKRE,SVRE                                        02S0036
*     WKRO=OUCBACT;                 /* PICK NEW TOP ACTION QUE OUCB  */
         L     WKRO,OUCBACT(,OUCBPTR)                           02S0037
*     CDS(SVRE,WKRE,RMCTACQH);      /* STORE UPDATED QUEUE HEADER    */
         CDS   SVRE,WKRE,RMCTACQH(RMCTPTR)                      02S0038
*     BC(7,RMCENL1);                /* REPEAT IF OUCB WAS NOT AT TOP */
         BC    7,RMCENL1                                        02S0039
*     OUCBACT=R0;                   /* MARK OUCB AS NOT ON QUEUE     */
         ST    R0,OUCBACT(,OUCBPTR)                             02S0040
*     WKRE=OUCBCSW&ACTNDEF;         /* PICK DEFERRED ACTION REQ FLGS */
         L     WKRE,OUCBCSW(,OUCBPTR)                           02S0041
         N     WKRE,ACTNDEF                                     02S0041
*     IF WKRE^=EMPTY THEN           /* ACTIONS HAVE BEEN DEFERRED    */
*                                                               02S0042
         LTR   WKRE,WKRE                                        02S0042
         BZ    @RF00042                                         02S0042
*       /*************************************************************/
*       /*                                                           */
*       /* INVOKE THE IRARMCRT SUBROUTINE, PASSING IT THE ADDRESS OF */
*       /* THE DEFERRABLE ACTION ROUTINE TABLE. IRARMCRT WILL ROUTE  */
*       /* CONTROL TO ALL OF THE ENTRY POINTS WHOSE FLAGS HAVE BEEN  */
*       /* SET IN THE -OUCBACN- FIELD, AND WILL TURN OFF EACH        */
*       /* -OUCBACN- FLAG WHEN THE CORRESPONDING ENTRY POINT ROUTINE */
*       /* HAS COMPLETED ITS PROCESSING.                             */
*       /*                                                           */
*       /*************************************************************/
*                                                               02S0043
*       DO;                                                     02S0043
*         RMCAINV=ACTNDEF;          /* INDICATE THE ACTN REQST FLAGS */
         MVC   RMCAINV(4,RMCTPTR),ACTNDEF                       02S0044
*         PMRE=ADDR(OUCBACN);       /* INDICATE THE RTNE REQST ACCUM */
         LA    PMRE,OUCBACN(,OUCBPTR)                           02S0045
*         RMEPPTR=RMCTEPDT;         /* INDICATE ACTION TABLE TO SCAN */
         L     RMEPPTR,RMCTEPDT(,RMCTPTR)                       02S0046
*         CALL IRARMCRT;            /* SCAN AND PERFORM ACTION RTNES */
         BAL   @14,IRARMCRT                                     02S0047
*       END;                                                    02S0048
*   END;                                                        02S0049
@RF00042 DS    0H                                               02S0049
@DE00031 CLC   RMCTAQHD(4,RMCTPTR),RMCTOUCB(RMCTPTR)            02S0049
         BNE   @DL00031                                         02S0049
*                                                               02S0050
*/* **************************************************************** */
*/*                                                                  */
*/*    ROUTINE NAME - IRARMCEL                                       */
*/*                                                                  */
*/*    DESCRIPTIVE NAME - SYSTEM RESOURCES MANAGER CNTRL ALGORITHM   */
*/*          INDIVIDUALLY REQUESTED ALGORITHM CONTROL ROUTING RTNE   */
*/*                                                                  */
*/*    FUNCTION - THE IRARMCEL ROUTINE GATHERS ALGORITHM EXECUTION   */
*/*          REQUESTS, WHICH HAVE BEEN STORED AS BIT PATTERNS IN     */
*/*          -RMCTALR- BY SYSTEM RESOURCES MANAGER LOCKED RTNES,     */
*/*          AND IN -RMCTALA- BY OUTSIDE-LOCK ROUTINES.      @Z40BPCJ*/
*/*          ALL REQUESTS ARE PUT IN -RMCTALR-.  CONTROL IS  @Z40BPCJ*/
*/*          THEN ROUTED, VIA THE IRARMCRT SBRTNE, TO ALGORITHMS     */
*/*          REQUESTED IN -RMCTALR-.  AS EACH REQUESTED ALGORITHM    */
*/*          COMPLETES, ITS REQUEST BIT IS TURNED OFF IN -RMCTALR-.  */
*/*          WHEN CONTROL ROUTING IS COMPLETE, ANY REMAINING RE-     */
*/*          QUESTS ARE LEFT FOR THE NEXT TIME IRARMCEL IS RUN.      */
*/*                                                                  */
*/*    NOTE  - WHILE IRARMCEL IS EXECUTING, OTHR CONCURRENT PROCSS   */
*/*            MAY INSERT, VIA THE IRARMCRL ROUTINE, ADDITIONL ALG   */
*/*            REQUEST BITS INTO THE -RMCTALA- FIELD.                */
*/*                                                                  */
*/*    SETUP PERFORMED FOR EACH INVOKED ALGORITHM ROUTINE            */
*/*          - REG 1 CONTAINS THE ADDRESS OF THE RMEP BLOCK FOR THE  */
*/*            ALGORITHM BEING INVOKED.                              */
*/*          - REG 13 CONTAINS THE ADDRESS OF THE SAVE AREA STACK    */
*/*            ASSOCIATED WITH THE SYSTEM RESOURCES MANAGER LOCK.    */
*/*          - REG 14 CONTAINS THE RETURN ADDRESS.                   */
*/*          - REG 15 CONTAINS THE ALGORITHM RTNE ENTRY ADDRESS      */
*/*                                                                  */
*/* **************************************************************** */
*                                                               02S0050
*   /*****************************************************************/
*   /*                                                               */
*   /* TEST IF ANY ALGORITHMS HAVE BEEN INDIVIDUALLY REQUESTED       */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0050
*   R0=EMPTY;                       /* ZERO - TO TEST + CLEAR ACCUMS */
         SLR   R0,R0                                            02S0050
*   WKRE=RMCTALA;                   /* PICK ALG REQUEST ACCUM FIELD  */
         L     WKRE,RMCTALA(,RMCTPTR)                           02S0051
*   WKRO=WKRE|RMCTALR;              /* ADD IMMED ALG REQUEST FIELD   */
         LR    WKRO,WKRE                                        02S0052
         O     WKRO,RMCTALR(,RMCTPTR)                           02S0052
*   IF WKRO^=R0 THEN                /* HAVE ALGORITHM REQUEST        */
*                                                               02S0053
         CLR   WKRO,R0                                          02S0053
         BE    @RF00053                                         02S0053
*     /***************************************************************/
*     /*                                                             */
*     /* THE FOLLOWING INSTRUCTIONS ARE EXECUTED ONLY IF AT LEAST ONE*/
*     /* REQUEST FOR ALGORITHM EXECUTION IS PENDING.                 */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0054
*     DO;                                                       02S0054
*       IF WKRE^=R0 THEN            /* RMCTALA FIELD NON-ZERO        */
*                                                               02S0055
         CLR   WKRE,R0                                          02S0055
         BE    @RF00055                                         02S0055
*         /***********************************************************/
*         /*                                                         */
*         /* MOVE REQUEST BITS OUT OF OUTSIDE-LOCK REQUEST ACCUMULATR*/
*         /*                                                         */
*         /***********************************************************/
*                                                               02S0056
*         DO;                                                   02S0056
*RMCELL1:                           /* POINT WHERE MOVE RMCTALA BITS
*                                      INTO RMCTALR                  */
*           RMCTALR=WKRE|RMCTALR;   /* GATHER ALL ALG REQUEST BITS   */
RMCELL1  LR    @09,WKRE                                         02S0057
         O     @09,RMCTALR(,RMCTPTR)                            02S0057
         ST    @09,RMCTALR(,RMCTPTR)                            02S0057
*           CS(WKRE,R0,RMCTALAW);   /* CLEAR OUTSIDE-LOCK ACCUMULATR */
         CS    WKRE,@00,RMCTALAW(RMCTPTR)                       02S0058
*           BC(7,RMCELL1);          /* REPEAT IF REQUEST JUST ADDED  */
         BC    7,RMCELL1                                        02S0059
*         END;                                                  02S0060
*                                                               02S0060
*       /*************************************************************/
*       /*                                                           */
*       /* INVOKE THE IRARMCRT SUBROUTINE, PASSING IT THE ADDRESS OF */
*       /* THE INDIVIDUALLY REQUESTABLE ALGORITHMS TABLE. IRARMCRT   */
*       /* WILL ROUTE CONTROL TO THE ALGS REQUESTED IN -RMCTALR-. AS */
*       /* EACH ALGORITHM COMPLETES ITS EXECUTION, IRARMCRT WILL TURN*/
*       /* OFF ITS REQUEST BIT IN -RMCTALR-.                         */
*       /*                                                           */
*       /*************************************************************/
*                                                               02S0061
*       RMCAINV=FLAGDEF;            /* PASS THE ALG REQST FLGS MASK  */
@RF00055 MVC   RMCAINV(4,RMCTPTR),FLAGDEF                       02S0061
*       PMRE=ADDR(RMCTALR);         /* PASS THE ALG REQUEST ACCUML   */
         LA    PMRE,RMCTALR(,RMCTPTR)                           02S0062
*       RMEPPTR=RMCTEPAT;           /* PASS ALGORITHM TABLE TO SCAN  */
         L     RMEPPTR,RMCTEPAT(,RMCTPTR)                       02S0063
*       CALL IRARMCRT;              /* SCAN AND PERFORM ALGORITHMS   */
         BAL   @14,IRARMCRT                                     02S0064
*     END;                                                      02S0065
*                                                               01S0066
*   /*****************************************************************/
*   /*                                                               */
*   /* RETURN TO SYSTEM RESOURCES MANAGER INTERFACE PROGRAM ?        */
*   /* IRACTLCL EPN(I01)                                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                               01S0066
*   GOTO RMEXI01->IRARMNTR;         /* EXIT TO I01 FUNCT             */
@RF00053 L     @09,RMEXI01(,RMCTPTR)                            01S0066
         BR    @09                                              01S0066
*                                                               02S0067
*/* **************************************************************** */
*/*                                                                  */
*/*    ROUTINE NAME - IRARMCET                                       */
*/*                                                                  */
*/*    DESCRIPTIVE NAME - SYSTEM RESOURCES MANAGER CNTRL ALGORITHM   */
*/*          PERIODIC ENTRY POINT SCHEDULING ROUTINE                 */
*/*                                                                  */
*/*    FUNCTION - THE IRARMCET ROUTINE ACCEPTS TIMER INTERRUPTS,     */
*/*          SETS UP REQUESTS FOR ALL THOSE PERIODICALLY SCHEDU-     */
*/*          LED SYSTEM RESOURCES MANAGER ALGORITHMIC PROCESSING     */
*/*          ROUTINES WHICH ARE THEN DUE, AND RESETS THE SYSTEM      */
*/*          RESOURCES MANAGER TIMER ELEMENT SO AS TO INTERRUPT      */
*/*          AGAIN WHEN IRARMCET WILL BE NEXT REQUIRED.              */
*/*                                                                  */
*/*    INPUT - THE TIME-DRIVEN ALGORITHM QUEUE IS ORDERED BY THE     */
*/*            RMEPTME VALUES OF THE BLOCKS ON THE QUEUE.            */
*/*          - RMCTTOD CONTAINS THE CURRENT TIME.                    */
*/*          - RMPTTOL CONTAINS THE ALLOWED SCHEDULING TOLERANCE.    */
*/*          - RMPTTOM CONTAINS THE REQUIRED MINIMUM SCHD PERIOD.    */
*/*          - THE RMEPINT FIELDS OF THE BLCKS ON THE TIME-DRIVEN    */
*/*            ALG QUE INDICATE THE SCHED INTERVALS FOR THE ALGS.    */
*/*                                                                  */
*/*    OUTPT - RMCTALA CONTAINS THE REQUEST FLAGS FOR ALL THOSE      */
*/*            TIME-DRIVEN ALGORITHMS SCHEDULED TO BE EXECUTED       */
*/*            AT THE PRESENT TIME.                                  */
*/*          - RMPTTOI CONTAINS THE TIME OF EXPIRATION OF THE        */
*/*            NEXT SYSTEM RESOURCES MANAGER SCHEDULING INTERVAL.    */
*/*                                                                  */
*/* **************************************************************** */
*                                                               02S0067
*   DCL                                                         02S0067
*     IRARMCET LABEL EXTERNAL;                                  02S0067
*IRARMCET:                          /* PROCESS SYSTEM RESOURCES 02S0068
*                                      MANAGER TIMER INTERRUPT       */
*   GEN CODE;                                                   02S0068
IRARMCET DS    0H                                               02S0068
*                                  /*
IRARMXTL DS    0H
         ENTRY IRARMXTL
         BALR  @15,0                   SETUP ENTRY ADDRESSABILITY
         LA    @12,*-@PSTART           DISPLACEMENT TO MODULE BASE
         LCR   @12,@12                 NEGATIVE FOR SUBTRACT
         ALR   @12,@15                 SETUP MODULE ADDRESSABILITY
*   SVEREG=RMCTRMSA;                /* SUPPLY SAVE AREA STACK ADDRS  */
         L     SVEREG,RMCTRMSA(,RMCTPTR)                        02S0069
*   RRPAEPA=ADDR(RMEPBCTL);         /* INDICATE CONTROL ROUTINE RMEP */
         LA    @09,RMEPBCTL(,RMCTPTR)                           02S0070
         ST    @09,RRPAEPA(,RRPAPTR)                            02S0070
*   RRPACTL='0'B;                   /* REVERT TO NORMAL FAIL PROCESS */
         NI    RRPACTL(RRPAPTR),B'11110111'                     02S0071
*   RMEPPTR=RMCTTMQE->RMEPFWD;      /* PICK 1ST RMEP ON TMEDRVN QUE  */
         L     @09,RMCTTMQE(,RMCTPTR)                           02S0072
         L     RMEPPTR,RMEPFWD(,@09)                            02S0072
*   PMRE=RMEPINT;                   /* DEFAULT TME OF NXT INTERRUPT  */
         L     PMRE,RMEPINT(,RMEPPTR)                           02S0073
*   IF RRPARFI='0'B THEN            /* NOT MULTIPLE ERROR RECURSION  */
*                                                               02S0074
         TM    RRPARFI(RRPAPTR),B'00000010'                     02S0074
         BNZ   @RF00074                                         02S0074
*     /***************************************************************/
*     /*                                                             */
*     /* REQUEST EACH TIME-DRIVEN QUE RTNE NOT SCHEDULED FOR LATER   */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0075
*     DO WHILE(RRPATOD+RMPTTOL^<RMEPTME);                       02S0075
         B     @DE00075                                         02S0075
@DL00075 DS    0H                                               02S0076
*       WKRO=RMCTALR;               /* PICK IMMED ALG REQUEST FIELD  */
         L     WKRO,RMCTALR(,RMCTPTR)                           02S0076
*       WKRO=RMEPFLG|WKRO;          /* INSERT FLAG FOR REQUESTD ALG  */
         O     WKRO,RMEPFLG(,RMEPPTR)                           02S0077
*       WKRO=WKRO&FLAGDEF;          /* CLR RTNE CHARACTERISTIC FLGS  */
         N     WKRO,FLAGDEF                                     02S0078
*       RMCTALR=WKRO;               /* STORE UPDATED ALG REQST FLD   */
         ST    WKRO,RMCTALR(,RMCTPTR)                           02S0079
*       IF PMRE>RMEPINT THEN        /* RTNE RESCHED INTERVL SMALLER  */
         L     @09,RMEPINT(,RMEPPTR)                            02S0080
         CLR   PMRE,@09                                         02S0080
         BNH   @RF00080                                         02S0080
*         PMRE=RMEPINT;             /* SET NEW TME OF NXT INTERRUPT  */
         LR    PMRE,@09                                         02S0081
*       RMEPPTR=RMEPFWD;            /* STEP TO NXT TMEDRVN QUE RMEP  */
@RF00080 L     RMEPPTR,RMEPFWD(,RMEPPTR)                        02S0082
*     END;                                                      02S0083
@DE00075 L     @09,RRPATOD(,RRPAPTR)                            02S0083
         AL    @09,RMPTTOL(,RMCTPTR)                            02S0083
         CL    @09,RMEPTME(,RMEPPTR)                            02S0083
         BNL   @DL00075                                         02S0083
*   PMRE=MIN(PMRE,RMEPTME-RRPATOD); /* CONSIDER NEXT RTNE SCHEDL     */
@RF00074 L     @09,RMEPTME(,RMEPPTR)                            02S0084
         SL    @09,RRPATOD(,RRPAPTR)                            02S0084
         CLR   PMRE,@09                                         02S0084
         BNH   *+6
         LR    PMRE,@09                                         02S0084
*   R1=RMCTTOD+MAX(RMPTTOM,PMRE);   /* PASS NXT TIME OF EXPIRATN     */
*                                                               02S0085
         L     R1,RMPTTOM(,RMCTPTR)                             02S0085
         CLR   R1,PMRE                                          02S0085
         BNL   *+6
         LR    R1,PMRE                                          02S0085
         AL    R1,RMCTTOD(,RMCTPTR)                             02S0085
*   /*****************************************************************/
*   /*                                                               */
*   /* ? IRACTLCL EPN(I05)                                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0086
*   CALL RMSBI05->IRARMRTN;         /* INVOKE I05 SUBRTN             */
         L     @15,RMSBI05(,RMCTPTR)                            02S0086
         BALR  @14,@15                                          02S0086
*   IF RTNCOD=ZERO THEN             /* TIMER INTERVAL SET SUCCESSFUL */
         LTR   RTNCOD,RTNCOD                                    02S0087
         BNZ   @RF00087                                         02S0087
*     RMCATOI=R1;                   /* SAVE NEW TIMER EXPIRE SETTING */
*                                                               02S0088
         ST    R1,RMCATOI(,RMCTPTR)                             02S0088
*   /*****************************************************************/
*   /*                                                               */
*   /* ? IRACTLCL EPN(CTL)                                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0089
*   GOTO RMEXCTL->IRARMNTR;         /* EXIT TO CTL FUNCT             */
@RF00087 L     @09,RMEXCTL(,RMCTPTR)                            02S0089
         BR    @09                                              02S0089
*                                                               02S0090
*/* **************************************************************** */
*/*                                                                  */
*/*    ROUTINE NAME - IRARMCED                                       */
*/*                                                                  */
*/*    DESCRIPTIVE NAME - SYSTEM RESOURCES MANAGER CNTRL ALGORITHM   */
*/*          SRB DISPATCHED ORIGINAL ENTRY PROCESSING ROUTINE        */
*/*                                                                  */
*/*    FUNCTION - THE IRARMCED ROUTINE RECEIVES CONTROL UNDER AN     */
*/*          SRB SCHEDULED BY THE DISPATCHER.  IRARMCED SETS UP AN   */
*/*          ENTRY TO THE MAINLINE OF THE SYSTEM RESOURCES MANAGER   */
*/*          BY LINKING TO THE SRM AS SYSEVENT 48.  THIS SYSEVENT    */
*/*          IS INTERPRETED BY THE SRM ROUTINES AS A REQUEST THAT    */
*/*          IRARMCTL BE RE-ENTERED, ONCE THE SRM LOCK AND THE SRM   */
*/*          FRR HAVE BEEN ACQUIRED.  ONE SRB MAKES USE OF THIS      */
*/*                                                          @Z40BPCJ*/
*/*          FACILITY.  IT IS SCHEDULED BY ROUTINES NOT HOLDING      */
*/*                                                          @Z40BPCJ*/
*/*          THE SRM LOCK, IN ORDER THAT DEPENDENT ROUTINES, WHICH   */
*/*          DO REQUIRE THE LOCK, MAY BE RUN (BY THE SRB) WITHOUT    */
*/*          DELAY.                                          @Z40BPCJ*/
*/*                                                                  */
*/*    EXIT  - BRANCH ON REGISTER 14 BACK TO THE DISPATCHER.         */
*/*          - THERE IS NO ERROR EXIT OR INDICATION.                 */
*/*                                                                  */
*/* **************************************************************** */
*                                                               02S0090
*   DCL                                                         02S0090
*     IRARMCED LABEL EXTERNAL;                                  02S0090
*IRARMCED:                          /* SYSTEM RESOURCES MANAGER SRB
*                                      PROCESSING ENTRY POINT        */
*   R1=R0;                          /* SAVE SRB ADDRESS AS PARAMETR  */
IRARMCED LR    R1,R0                                            02S0091
*   RMCTPTR=CVTOPCTP;               /* ADDR SYSTEM RSRCS MNGR TABLE  */
         L     @09,CVTPTR                                       02S0092
         L     RMCTPTR,CVTOPCTP(,@09)                           02S0092
*   SVEREG=RTNREG;                  /* PASS REG 14 CONTENT IN REG 13 */
         LR    SVEREG,RTNREG                                    02S0093
*   R0=E48;                         /* SRB ENTRY SYSEVENT CODE       */
         LA    R0,48                                            02S0094
*   GOTO RMEXI48->IRARMNTR;         /* OBTAIN SRM LOCK, RRPA BLOCK   */
         L     @09,RMEXI48(,RMCTPTR)                            02S0095
         BR    @09                                              02S0095
*                                                               02S0096
*/* **************************************************************** */
*/*                                                                  */
*/*    ROUTINE NAME - IRARMCQT                                       */
*/*                                                                  */
*/*    DESCRIPTIVE NAME - SYSTEM RESOURCES MANAGER CNTRL ALGORITHM   */
*/*          PERIODICALLY INVOKED ENTRY POINT RESCHEDULING SBRTNE    */
*/*                                                                  */
*/*    FUNCTION - THE IRARMCQT SUBROUTINE ACCEPTS A REQUEST TO       */
*/*          RESCHEDULE THE EXECUTION OF A PERIODICALLY INVOKED      */
*/*          SYSTEM RESOURCES MANAGER ENTRY POINT.  IT ADDS THE      */
*/*          INVOCATION INTERVAL TO THE TIME THE ENTRY WAS LAST      */
*/*          SCHEDULED, AND REPOSITIONS THE ROUTINE SCHEDULING       */
*/*          BLOCK ON THE SYSTEM RESOURCES MANAGER ENTRY TIMING      */
*/*          QUEUE ACCORDING TO WHEN IT IS NEXT DUE.                 */
*/*                                                                  */
*/*    INPUT - REG 1 CONTAINS THE ADDRESS OF THE RMEP BLOCK TO       */
*/*            BE PLACED ON THE ENTRY TIMING QUEUE.  THE RMEP        */
*/*            MUST HAVE BEEN DEQUED PRIOR TO USING IRARMCQT.        */
*/*          - REG 14 CONTAINS THE RETURN ADDRESS.                   */
*/*          - RMEPTME CONTAINS THE STARTING TIME WITH RESPECT       */
*/*            TO WHICH THE ENTRY POINT WILL BE RESCHEDULED.         */
*/*          - RMEPINT CONTAINS THE INTERVAL VALUE TO BE ADDED       */
*/*            TO THE STARTING TIME.                                 */
*/*                                                                  */
*/*    OUTPT - THE INTERVAL VALUE IS ADDED TO THE RMEPTME FIELD.     */
*/*          - THE RMEP IS MOVED TO THE PROPER POSITION ON THE       */
*/*            ENTRY TIMING QUEUE.                                   */
*/*                                                                  */
*/*    EXIT  - BRANCH ON REGISTER 14.                                */
*/*          - THERE IS NO ERROR EXIT OR INDICATION.                 */
*/*                                                                  */
*/* **************************************************************** */
*                                                               02S0096
*IRARMCQT:                                                      02S0096
*   PROC OPTIONS(NOSAVE,NOSAVEAREA,NOENTREG,RETREG,NOPARMREG);  02S0096
IRARMCQT DS    0H                                               02S0097
*   RMEPTME=RRPATOD+MAX(RMPTTOM,RMEPINT);/* CALC POSITN VALUE        */
         L     @09,RMPTTOM(,RMCTPTR)                            02S0097
         L     @08,RMEPINT(,RMEPPTR)                            02S0097
         CLR   @09,@08                                          02S0097
         BNL   *+6
         LR    @09,@08                                          02S0097
         AL    @09,RRPATOD(,RRPAPTR)                            02S0097
         ST    @09,RMEPTME(,RMEPPTR)                            02S0097
*   TMRE=RMCTTMQE->RMEPFWD;         /* PICK 1ST TIMED QUEUE RMEP     */
*                                                               02S0098
         L     @09,RMCTTMQE(,RMCTPTR)                           02S0098
         L     TMRE,RMEPFWD(,@09)                               02S0098
*   /*****************************************************************/
*   /*                                                               */
*   /* SEARCH FOR POSITION INTO WHICH TO INSERT THE GIVEN RMEP       */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0099
*   RESPECIFY                                                   02S0099
*    (RMEP) BASED(TMRE);            /* TME REG USED TO SCAN MEMBERS  */
*                                                               02S0099
*   /*****************************************************************/
*   /*                                                               */
*   /* THE END OF THE Q IS MARKED WITH THE HIGHEST POSSIBLE VALUE    */
*   /* STEP UNTIL FIND QUEUE MEMBER WITH A LARGER TIME VALUE         */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0100
*   DO WHILE(RMEPPTR->RMEPTME^<RMEPTME);                        02S0100
         B     @DE00100                                         02S0100
@DL00100 DS    0H                                               02S0101
*     TMRE=RMEPFWD;                 /* STEP TO NEXT MEMBER ON QUE    */
         L     TMRE,RMEPFWD(,TMRE)                              02S0101
*   END;                                                        02S0102
*                                                               02S0102
@DE00100 CLC   RMEPTME(4,RMEPPTR),RMEPTME(TMRE)                 02S0102
         BNL   @DL00100                                         02S0102
*   /*****************************************************************/
*   /*                                                               */
*   /* ENQUEUE RMEP AHEAD OF CURRENT EXISTING QUEUE MEMBER           */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0103
*   RMEPPTR->RMEPFWD=ADDR(RMEP);    /* POINT RMEP TO FWD CHAIN       */
         ST    TMRE,RMEPFWD(,RMEPPTR)                           02S0103
*   RMEPPTR->RMEPBCK=RMEPBCK;       /* POINT RMEP TO BCKWD CHAIN     */
         L     @09,RMEPBCK(,TMRE)                               02S0104
         ST    @09,RMEPBCK(,RMEPPTR)                            02S0104
*   RMEPBCK->RMEPFWD=RMEPPTR;       /* ENQUE RMEP ONTO FORWD CHAIN   */
         ST    RMEPPTR,RMEPFWD(,@09)                            02S0105
*   RMEPBCK=RMEPPTR;                /* ENQUE RMEP ONTO BCKWD CHAIN   */
         ST    RMEPPTR,RMEPBCK(,TMRE)                           02S0106
*   RESPECIFY                                                   02S0107
*    (RMEP) BASED(RMEPPTR);         /* RESTORE NORMAL RMEP BASE      */
*   END IRARMCQT;                                               02S0108
@EL00002 DS    0H                                               02S0108
@EF00002 DS    0H                                               02S0108
@ER00002 BR    @14                                              02S0108
*                                                               02S0109
*/* **************************************************************** */
*/*                                                                  */
*/*    ROUTINE NAME - IRARMCRD                                       */
*/*                                                                  */
*/*    DESCRIPTIVE NAME - SYSTEM RESOURCES MANAGER CNTRL ALGORITHM   */
*/*          SRB SCHEDULING REQUEST RECEIVING SUBROUTINE             */
*/*                                                                  */
*/*    FUNCTION - THE IRARMCRD SUBROUTINE ACCEPTS A REQUEST  @Z40BPCJ*/
*/*          TO SCHEDULE THE SRM SRB TO OBTAIN THE SRM LOCK. @Z40BPCJ*/
*/*          IF THE SRB IS                                   @Z40BPCJ*/
*/*          NOT CURRENTLY IN USE, IRARMCRD ISSUES A 'SCHEDULE' IN   */
*/*          ORDER TO BRING ABOUT THE DISPATCHING OF THAT SRB.       */
*/*                                                                  */
*/*    NOTE  - IRARMCRD DOES NOT REQUIRE THE OPT LOCK TO BE HELD.    */
*/*                                                                  */
*/*    INPUT - REG 1 CONTAINS THE ADDRESS OF THE RMEP BLOCK FOR      */
*/*            THE RTNE ON WHOSE BEHALF THE REQUEST IS ISSUED.       */
*/*          - REG 14 CONTAINS THE RETURN ADDRESS.                   */
*/*          - REG 15 CONTAINS THE IRARMCRD ROUTINE ADDRESS.         */
*/*          - SRBPARM INDICATES WHETHER THE SRB IS AVAILABLE.       */
*/*                                                                  */
*/*    OUTPT - SEE FUNCTION.                                         */
*/*                                                                  */
*/*    EXIT  - BRANCH ON REGISTER 14.                                */
*/*          - THERE IS NO ERROR EXIT OR INDICATION.                 */
*/*                                                                  */
*/* **************************************************************** */
*                                                               02S0109
*IRARMCRD:                                                      02S0109
*   PROC OPTIONS(NOSAVE,NOSAVEAREA,NOENTREG,RETREG,NOPARMREG);  02S0109
IRARMCRD DS    0H                                               02S0110
*   PMRE=RMEPPTR;                   /* SAVE INPUT RTNE BLOCK ADDR    */
         LR    PMRE,RMEPPTR                                     02S0110
*   SRBPTR=RMCTSRBT;                /* PICK LOCK OBTAIN SRB ADDR
*                                                            @Z40BPCJ*/
         L     SRBPTR,RMCTSRBT(,RMCTPTR)                        02S0111
*   WKRE=ZERO;                      /* INDICATOR FOR AVAILABLE SRB   */
         SLR   WKRE,WKRE                                        02S0112
*   DO;                                                         02S0113
*     WKRO=MAX(RRPATOD,EIGHT);      /* PICK NONZERO PARAMETER VALUE  */
         L     WKRO,RRPATOD(,RRPAPTR)                           02S0114
         LA    @09,8                                            02S0114
         CLR   WKRO,@09                                         02S0114
         BNL   *+6
         LR    WKRO,@09                                         02S0114
*     CS(WKRE,WKRO,SRBPARM);        /* STORE VLU AS USAGE INDICATOR  */
         CS    WKRE,@11,SRBPARM(SRBPTR)                         02S0115
*     BC(7,RMCRDX1);                /* BYPASS SCHED IF STORE FAILED  */
         BC    7,RMCRDX1                                        02S0116
*     GEN CODE REFS(CVTGSMQ,SRBFLNK,SRBSECT);                   02S0117
*                                             /*
         SCHEDULE  SRB=(1),SCOPE=GLOBAL
*     IF RRPASVC='1'B&              /* SRM INVOKED VIA TYPE-1 SVC    */
*         RRPACOD^=E48 THEN         /* NOT INVOKED FROM SRB ENTRY    */
         TM    RRPASVC(RRPAPTR),B'00100000'                     02S0118
         BNO   @RF00118                                         02S0118
         CLI   RRPACOD(RRPAPTR),48                              02S0118
         BE    @RF00118                                         02S0118
*       RRPARTN=CVTEXP1;            /* FORCE EXIT THRU DISPATCHER    */
         L     @09,CVTPTR                                       02S0119
         L     @09,CVTEXP1(,@09)                                02S0119
         ST    @09,RRPARTN(,RRPAPTR)                            02S0119
*RMCRDX1:                           /* BRANCH POINT WHEN DESIGNATED
*                                      SRB NOT AVAILABLE FOR USE     */
*   END;                                                        02S0120
@RF00118 DS    0H                                               02S0120
RMCRDX1  DS    0H                                               02S0121
*   RMEPPTR=PMRE;                   /* REST INPUT RTNE BLOCK ADDR    */
         LR    RMEPPTR,PMRE                                     02S0121
*   END IRARMCRD;                                               02S0122
@EL00003 DS    0H                                               02S0122
@EF00003 DS    0H                                               02S0122
@ER00003 BR    @14                                              02S0122
*                                                               02S0123
*/* **************************************************************** */
*/*                                                                  */
*/*    ROUTINE NAME - IRARMCRL                                       */
*/*                                                                  */
*/*    DESCRIPTIVE NAME - SYSTEM RESOURCES MANAGER ALGORITHMIC       */
*/*                       PROCESSING REQUEST RECEIVING SUBROUTINE    */
*/*                                                                  */
*/*    FUNCTION - THE IRARMCRL SUBROUTINE ACCEPTS A REQUEST FOR AN   */
*/*          ALGORITHM, AND TURNS ON A BIT IN THE RMCT TO INDICATE   */
*/*          THAT THAT ALGORITHM HAS BEEN REQUESTED.  SUBSEQUENTLY,  */
*/*          THE IRARMCEL SBRTINE WILL OBSERVE THAT BIT,     @Z40BPCJ*/
*/*          AND WILL INVOKE THE ALGORITHM.                  @Z40BPCJ*/
*/*                                                                  */
*/*    NOTE  - IRARMCRL DOES NOT REQUIRE THE SRM LOCK TO BE HELD.    */
*/*            WHILE IRARMCRL IS EXECUTING, OTHR CONCURRENT PROCSS   */
*/*            MAY BE INSERTING, ALSO VIA THE IRARMCRL ROUTINE, OR   */
*/*            MAY BE REMOVING, VIA THE IRARMCEL ROUTINE, REQUEST    */
*/*            BITS INTO/FROM -RMCTALA-.  HOWEVER, -RMCTALR- USAGE   */
*/*            IS SERIALIZED, IN THAT ALL ROUTINES WHICH ACCESS IT   */
*/*            MUST HOLD THE SYSTEM RESOURCES MANAGER LOCK.          */
*/*                                                                  */
*/*    INPUT - REG 1 CONTAINS THE ADDRESS OF THE RMEP BLOCK FOR THE  */
*/*            ALGORITHM BEING REQUESTED.                            */
*/*          - REG 14 CONTAINS THE RETURN ADDRESS.                   */
*/*          - REG 15 CONTAINS THE IRARMCRL ROUTINE ADDRESS.         */
*/*          - THE RRPA LOCATED BY REG 3 INDICATES IF THIS REQUEST   */
*/*            IS/IS NOT COMING FROM A PROCESS HOLDING THE SYSTEM    */
*/*            RESOURCES MANAGER LOCK.                               */
*/*          - THE RRPAEPA FIELD CONTAINS THE ADDRESS OF THE RMEP    */
*/*            BLOCK OF THE ROUTINE WHICH IS ISSUING THE REQUEST.    */
*/*                                                                  */
*/*    OUTPT - IF IRARMCRL IS ENTERED WITH THE SRM LOCK,     @Z40BPCJ*/
*/*            THE FLAG FROM THE RMEPFLG FIELD OF THE INPUT RMEP IS  */
*/*            OR'ED INTO RMCTALR.  OTHERWISE, THE FLAG      @Z40BPCJ*/
*/*            IS SET IN THE RMCTALA FIELD BY A COMPARE AND SWAP.    */
*/*                                                                  */
*/*    EXIT  - BRANCH ON REGISTER 14.                                */
*/*          - THERE IS NO ERROR EXIT OR INDICATION.                 */
*/*                                                                  */
*/* **************************************************************** */
*                                                               02S0123
*   /*****************************************************************/
*   /*                                                               */
*   /* IRARMCRL ROUTINE - ENTRY SEQUENCE ? IRACTLEP                  */
*   /* EPN(CRL)SAVE(6,14)                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0123
*   DCL                                                         02S0123
*     IRARMCRL ENTRY INT;                                       02S0123
*   GEN CODE REFS(LCCACPUS,PSALCCAV,WSACOPTM) DEFS(IRARMCRL) NOEXIT
*       SEQFLOW;                                                02S0124
*                                                               02S0124
*                                  /*
         ENTRY IRARMCRL
IRARMCRL DS    0H
         L     @15,PSALCCAV            LCCA ADDRESS
         L     @15,LCCACPUS-LCCA(,@15) CPU SAVE AREA VECTOR TABLE
         L     @15,WSACOPTM-WSAC(,@15) SRM SAVE AREA START ADDRESS
         STM   @06,@14,000+024(@15)    SAVE INVOKING RTNE REGS
         LR    @13,@15                 ROUTINE SAVE AREA ADDRESS
         BALR  @15,0                   SETUP ENTRY ADDRESSABILITY
         LA    @12,*-@PSTART           DISPLACEMENT TO MODULE BASE
         LCR   @12,@12                 NEGATIVE FOR SUBTRACT
         ALR   @12,@15                 SETUP MODULE ADDRESSABILITY
*   /*****************************************************************/
*   /*                                                               */
*   /* TEST THAT LOCK IS HELD, REQST IS NOT RECURSIVE                */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0125
*   IF RRPAOPT='1'B&RRPAEPA^=R1 THEN                            02S0125
*                                                               02S0125
         TM    RRPAOPT(RRPAPTR),B'00000010'                     02S0125
         BNO   @RF00125                                         02S0125
         C     R1,RRPAEPA(,RRPAPTR)                             02S0125
         BE    @RF00125                                         02S0125
*     /***************************************************************/
*     /*                                                             */
*     /* INSTRUCTION EXECUTION SERIALIZED BY HOLDING THE SRM LOCK    */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0126
*     DO;                                                       02S0126
*       WKRO=RMCTALR;               /* PICK IMMED ALG REQUEST FIELD  */
         L     WKRO,RMCTALR(,RMCTPTR)                           02S0127
*       WKRO=RMEPFLG|WKRO;          /* INSERT FLAG FOR REQUESTD ALG  */
         O     WKRO,RMEPFLG(,RMEPPTR)                           02S0128
*       WKRO=WKRO&FLAGDEF;          /* CLR RTNE CHARACTERISTIC FLGS  */
         N     WKRO,FLAGDEF                                     02S0129
*       RMCTALR=WKRO;               /* STORE UPDATED ALG REQST FLD   */
         ST    WKRO,RMCTALR(,RMCTPTR)                           02S0130
*     END;                                                      02S0131
*   ELSE                            /* REQUEST FROM OUTSIDE OPT LOCK */
*                                                               02S0132
*     /***************************************************************/
*     /*                                                             */
*     /* CAN EXECUTE IN PARALLEL - MUST USE COMPARE AND SWAP INSTR   */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0132
*     DO;                                                       02S0132
         B     @RC00125                                         02S0132
@RF00125 DS    0H                                               02S0133
*       WKRE=RMCTALA;               /* PICK ALG REQUEST ACCUM FIELD  */
         L     WKRE,RMCTALA(,RMCTPTR)                           02S0133
*RMCRLL1:                           /* POINT FROM WHICH TRY AGAIN IF
*                                      COMPARE AND SWAP FAILS        */
*       WKRO=WKRE;                  /* PICK ALG REQ ACCUM CONTENTS   */
RMCRLL1  LR    WKRO,WKRE                                        02S0134
*       WKRO=RMEPFLG|WKRO;          /* INSERT FLAG FOR REQUESTD ALG  */
         O     WKRO,RMEPFLG(,RMEPPTR)                           02S0135
*       WKRO=WKRO&FLAGDEF;          /* CLR RTNE CHARACTERISTIC FLGS  */
         N     WKRO,FLAGDEF                                     02S0136
*       CS(WKRE,WKRO,RMCTALAW);     /* STORE UPDATED ALG REQST FLD   */
         CS    WKRE,@11,RMCTALAW(RMCTPTR)                       02S0137
*       BC(7,RMCRLL1);              /* REPEAT IF ACCUM UPDTE FAILED  */
         BC    7,RMCRLL1                                        02S0138
*       IF(RRPAOPT='0'B&RMEPRCR='1'B)/* REQ ACTION W/O DELAY @Z40BPCJ*/
*           |(R1=ADDR(RMEPBPR1))    /* OR UIC UPDATE REDRIVE @ZA33182*/
*           |(R1=ADDR(RMEPBCAP)) THEN/* OR IF CAP REDRIVE    @Z40BPCJ*/
*                                                               02S0139
         TM    RRPAOPT(RRPAPTR),B'00000010'                     02S0139
         BNZ   @GL00004                                         02S0139
         TM    RMEPRCR(RMEPPTR),B'00000100'                     02S0139
         BO    @RT00139                                         02S0139
@GL00004 LA    @09,RMEPBPR1(,RMCTPTR)                           02S0139
         CR    R1,@09                                           02S0139
         BE    @RT00139                                         02S0139
         LA    @09,RMEPBCAP(,RMCTPTR)                           02S0139
         CR    R1,@09                                           02S0139
         BNE   @RF00139                                         02S0139
@RT00139 DS    0H                                               02S0140
*         /***********************************************************/
*         /*                                                         */
*         /* REQUEST SCHEDULING OF SRB TO GET LOCK AND RUN ALGORITHM */
*         /*                                                         */
*         /***********************************************************/
*                                                               02S0140
*         DO;                                                   02S0140
*           SVRO=R0;                /* SAVE INPUT R0 ACROSS CALL     */
         LR    SVRO,R0                                          02S0141
*           CALL IRARMCRD;          /* REQUEST LOCK SRB SCHEDULING   */
         BAL   @14,IRARMCRD                                     02S0142
*           R0=SVRO;                /* RESTORE INPUT R0 CONTENTS     */
         LR    R0,SVRO                                          02S0143
*         END;                                                  02S0144
*     END;                                                      02S0145
*                                                               02S0145
@RF00139 DS    0H                                               02S0146
*   /*****************************************************************/
*   /*                                                               */
*   /* IRARMCRL ROUTINE - EXIT SEQUENCE ? IRACTLEP ENN(CRL)          */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0146
*   GEN CODE EXIT NOSEQFLOW;                                    02S0146
@RC00125 DS    0H                                               02S0146
*                                  /*
         LM    @06,@14,000+024(@13)    RELOAD INVOKING RTNE REGS
         BR    RTNREG                  RETURN TO INVOKER
*                                                               02S0147
*/* **************************************************************** */
*/*                                                                  */
*/*    ROUTINE NAME - IRARMCRN                                       */
*/*                                                                  */
*/*    DESCRIPTIVE NAME - SYSTEM RESOURCES MANAGER DEFERRABLE USER   */
*/*                       ACTION REQUEST RECEIVING SUBROUTINE        */
*/*                                                                  */
*/*    FUNCTION - THE IRARMCRN SUBROUTINE ACCEPTS A REQUEST FOR AN   */
*/*          ACTION WHICH REQUIRES SERIALIZATION WITH OTHER SYSTEM   */
*/*          RESOURCES MANAGER PROCESSING.  IT CHECKS TO SEE IF THE  */
*/*          ACTION MAY BE PERFORMED IMMEDIATELY, IF YES, IT INVOKES */
*/*          THE REQUESTED ROUTINE.  OTHERWISE, IRARMCRN SETS A BIT  */
*/*          IN THE OUCB OF THE AFFECTED USER, AND QUEUES THAT OUCB  */
*/*          FOR SUBSEQUENT PROCESSING BY THE IRARMCTL ROUTINE.      */
*/*                                                                  */
*/*    NOTE  - IRARMCRN DOES NOT REQUIRE THE SRM LOCK.       @Z40BPJC*/
*/*            WHILE IRARMCRN IS EXECUTING, OTHR CONCURRENT PROCSS   */
*/*            MAY BE INSERTING, ALSO VIA THE IRARMCRN ROUTINE, OR   */
*/*            MAY BE REMOVING, VIA THE IRARMCEN ROUTINE, REQUEST    */
*/*            BITS INTO/FROM THE -OUCBACN- FIELDS OF THE SAME OR    */
*/*            DIFFERENT OUCB'S, AND MAY BE ENQUEUEING/DEQUEUEING    */
*/*            THOSE OUCBS TO/FRM THE ACTION QUEUE IN -RMCTAQHD-.    */
*/*                                                                  */
*/*    INPUT - REG 1 CONTAINS THE ADDRESS OF THE RMEP BLOCK FOR THE  */
*/*            ACTION ROUTINE BEING REQUESTED.                       */
*/*          - REG 4 CONTAINS THA ADDRESS OF THE OUCB OF THE USER    */
*/*            FOR WHOM THE ACTION IS TO BE PERFORMED.               */
*/*          - REG 14 CONTAINS THE RETURN ADDRESS.                   */
*/*          - THE RRPA LOCATED BY REG 3 INDICATES IF THIS REQUEST   */
*/*            IS/IS NOT COMING FORM A PROCESS HOLDING THE SYSTEM    */
*/*            RESOURCES MANAGER LOCK.                               */
*/*                                                                  */
*/*    OUTPT - IF THE REQUESTED ACTION IS TO BE DEFERRED,    @Z40BPJC*/
*/*            THE RMEPFLG FIELD OF THE INPUT RMEP IS OR'ED  @Z40BPJC*/
*/*            INTO THE OUCBACN FIELD OF THE OUCB LOCATED BY THE     */
*/*            INPUT ASCB.  THAT OUCB IS THEN ADDED TO THE SYSTEM    */
*/*            RESOURCES MANAGER ACTION QUEUE, WHOSE MEMBERS ARE     */
*/*            LINKED VIA THEIR OUCBACT FIELDS, AND WHOSE HEAD IS    */
*/*            LOCATED VIA THE RMCTAQHD FIELD.                       */
*/*                                                                  */
*/*    SETUP PERFORMED IF THE ACTION ROUTINE IS INVOKED DIRECTLY     */
*/*          - REG 1 CONTAINS THE ADDRESS OF THE RMEP BLOCK FOR THE  */
*/*            ACTION ROUTINE BEING INVOKED.                         */
*/*          - REG 4 CONTAINS THE ADDRESS OF THE OUCB FOR WHOM THE   */
*/*            ACTION IS TO BE PERFORMED.                            */
*/*          - REG 13 CONTAINS THE ADDRESS OF THE SAVE AREA STACK    */
*/*            ASSOCIATED WITH THE SYSTEM RESOURCES MANAGER LOCK.    */
*/*          - REG 14 CONTAINS THE RETURN ADDRESS.                   */
*/*          - REG 15 CONTAINS THE ACTION RTNE ENTRY ADDRESS.        */
*/*                                                                  */
*/*    EXIT  - BRANCH ON REGISTER 14.                                */
*/*          - THERE IS NO ERROR EXIT OR INDICATION.                 */
*/*                                                                  */
*/* **************************************************************** */
*                                                               02S0147
*   /*****************************************************************/
*   /*                                                               */
*   /* IRARMCRN ROUTINE - ENTRY SEQUENCE ? IRACTLEP EPN(CRN)         */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0147
*   DCL                                                         02S0147
*     IRARMCRN ENTRY INT;                                       02S0147
*   GEN CODE REFS(LCCACPUS,PSALCCAV,WSACOPTM) DEFS(IRARMCRN) NOEXIT
*       SEQFLOW;                                                02S0148
*                                  /*
         ENTRY IRARMCRN
IRARMCRN DS    0H
         L     @15,PSALCCAV            LCCA ADDRESS
         L     @15,LCCACPUS-LCCA(,@15) CPU SAVE AREA VECTOR TABLE
         L     @15,WSACOPTM-WSAC(,@15) SRM SAVE AREA START ADDRESS
         STM   @00,@14,064+000(@15)    SAVE INVOKING RTNE REGS
         LR    @13,@15                 ROUTINE SAVE AREA ADDRESS
         BALR  @15,0                   SETUP ENTRY ADDRESSABILITY
         LA    @12,*-@PSTART           DISPLACEMENT TO MODULE BASE
         LCR   @12,@12                 NEGATIVE FOR SUBTRACT
         ALR   @12,@15                 SETUP MODULE ADDRESSABILITY
*   IF RRPAOPT='1'B&                /* LOCKED,               @Z40BPCJ*/
*       RRPAEPA->RMEPACN='0'B THEN  /* NOT RECURSIV ACN CALL         */
*                                                               02S0149
         TM    RRPAOPT(RRPAPTR),B'00000010'                     02S0149
         BNO   @RF00149                                         02S0149
         L     @09,RRPAEPA(,RRPAPTR)                            02S0149
         TM    RMEPACN(@09),B'00000001'                         02S0149
         BNZ   @RF00149                                         02S0149
*     /***************************************************************/
*     /*                                                             */
*     /* THE REQUEST DOES NOT HAVE TO BE DEFERRED.           @Z40BPCJ*/
*     /* THE REQUESTED RTNE IS INVOKED DIRECTLY.             @Z40BPCJ*/
*     /* HOLDING THE SRM LOCK ASSURES SERIALIZATION.         @Z40BPCJ*/
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0150
*     NTRREG=RMEPEPA;               /* ENTRY TO REQSTD ACTION RTNE   */
         L     NTRREG,RMEPEPA(,RMEPPTR)                         02S0150
*   ELSE                            /* OTHER PROCSS USING RESOURCES  */
*                                                               02S0151
*     /***************************************************************/
*     /*                                                             */
*     /* THE INVOCATION MUST BE DEFERRED. THE REQUEST IS FLAGGED IN  */
*     /* THE USER CONTROL BLOCK, AND THE CTRL BLOCK IS QUEUED FOR    */
*     /* LATER EXAMINATION. COMPARE AND SWAP USAGE PERMITS THE       */
*     /* HANDLING OF SIMULTANEOUS UPDATES.                           */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0151
*     DO;                                                       02S0151
*                                                               02S0151
         B     @RC00149                                         02S0151
@RF00149 DS    0H                                               02S0152
*       /*************************************************************/
*       /*                                                           */
*       /* INSERT REQUEST FLAG INTO USER DEFERRED ACTION FIELD       */
*       /*                                                           */
*       /*************************************************************/
*                                                               02S0152
*       WKRE=OUCBCSW;               /* PICK DEFERRED ACTION ACCUMUL  */
         L     WKRE,OUCBCSW(,OUCBPTR)                           02S0152
*RMCRNL1:                           /* RETRY INSERT ACTION IF OUCB
*                                      CHANGED BY OTHER PROCESS      */
*       WKRO=RMEPFLG&FLAGDEF;       /* CLR RTNE CHARACTERISTIC FLGS  */
RMCRNL1  L     WKRO,RMEPFLG(,RMEPPTR)                           02S0153
         N     WKRO,FLAGDEF                                     02S0153
*       WKRO=WKRO|WKRE;             /* INSERT FLAG FOR REQUESTD ACN  */
         OR    WKRO,WKRE                                        02S0154
*       CS(WKRE,WKRO,OUCBCSW);      /* STORE UPDATED ACTN REQ FIELD  */
         CS    WKRE,@11,OUCBCSW(OUCBPTR)                        02S0155
*       BC(7,RMCRNL1);              /* REPEAT IF ACCUM UPDATE FAILED */
*                                                               02S0156
         BC    7,RMCRNL1                                        02S0156
*       /*************************************************************/
*       /*                                                           */
*       /* INSURE OUCB IS QUEUED ONTO THE DEFERRED ACTION QUEUE      */
*       /*                                                           */
*       /*************************************************************/
*                                                               02S0157
*       R0=ZERO;                    /* ZERO - TO SEE IF OUCB QUEUED  */
         SLR   R0,R0                                            02S0157
*       WKRO=OUCBPTR;               /* INSERT NEW OUCB FOR Q HEADER  */
         LR    WKRO,OUCBPTR                                     02S0158
*       GEN(LM    SVRE,SVRO,RMCTAQCT(RMCTPTR));/* PICK OLD Q HEADER  */
         LM    SVRE,SVRO,RMCTAQCT(RMCTPTR)
*       CS(R0,SVRO,OUCBACTW);       /* POINT NEW OUCB TO TOP OF QUE  */
         CS    R0,@07,OUCBACTW(OUCBPTR)                         02S0160
*       BC(7,RMCRNX1);              /* EXIT IF OUCB ALREADY ON QUEUE */
*                                                               02S0161
         BC    7,RMCRNX1                                        02S0161
*       /*************************************************************/
*       /*                                                           */
*       /* IT IS THE RESPONSIBILITY OF WHOEVER MAKES -OUCBACT- NON-  */
*       /* ZERO TO INSURE THAT THE OUCB IS PROPERLY QUEUED ONTO THE  */
*       /* ACTION QUEUE. IT IS THE RESPONSIBILITY OF WHOEVER MAKES   */
*       /* -OUCBACT- ZERO TO DO SO ONLY IF ALL ACTIONS REQUESTED UP  */
*       /* TO THAT MOMENT WILL BE COMPLETED BY THE ZERO SET ROUTINE. */
*       /*                                                           */
*       /*************************************************************/
*                                                               02S0162
*RMCRNL2:                           /* RETRY ENQUEUE OUCB IF QUEUE
*                                      CHANGED BY OTHER PROCESS      */
*       WKRE=SVRE+ONE;              /* INCREMENT Q COUNT FOR HEADER  */
RMCRNL2  LA    WKRE,1                                           02S0162
         ALR   WKRE,SVRE                                        02S0162
*       CDS(SVRE,WKRE,RMCTACQH);    /* STORE UPDATED QUEUE HEADER    */
         CDS   SVRE,WKRE,RMCTACQH(RMCTPTR)                      02S0163
*       BC(8,RMCRNX1);              /* EXIT IF OUCB ENQ SUCCESSFUL   */
         BC    8,RMCRNX1                                        02S0164
*       OUCBACT=SVRO;               /* POINT OUCB TO NEW TOP OF QUE  */
         ST    SVRO,OUCBACT(,OUCBPTR)                           02S0165
*       GOTO RMCRNL2;               /* REPEAT IF OUCB ENQUEUE FAILED */
         B     RMCRNL2                                          02S0166
*RMCRNX1:                                                       02S0167
*       ;                           /* BRANCH POINT WHEN ACTION 02S0167
*                                      DEFERRAL HAS BEEN COMPLETED   */
RMCRNX1  DS    0H                                               02S0168
*       IF RRPAOPT='0'B&RMEPRCR='1'B THEN/* REQ ACTION W/O DELAY
*                                                            @Z40BPCJ*/
*                                                               02S0168
         TM    RRPAOPT(RRPAPTR),B'00000010'                     02S0168
         BNZ   @RF00168                                         02S0168
         TM    RMEPRCR(RMEPPTR),B'00000100'                     02S0168
         BNO   @RF00168                                         02S0168
*         /***********************************************************/
*         /*                                                         */
*         /* REQUEST SCHEDULING OF SRB TO GET LOCK AND RUN ALGORITHM */
*         /*                                                         */
*         /***********************************************************/
*                                                               02S0169
*         DO;                                                   02S0169
*           CALL IRARMCRD;          /* REQUEST LOCK SRB SCHEDULING   */
         BAL   @14,IRARMCRD                                     02S0170
*         END;                                                  02S0171
*       NTRREG=CRNRTRN;             /* RETURN TO REQUESTOR OF ACTION */
@RF00168 L     NTRREG,CRNRTRN(,SVEREG)                          02S0172
*     END;                                                      02S0173
*                                                               02S0173
*   /*****************************************************************/
*   /*                                                               */
*   /* IRARMCRN ROUTINE - EXIT SEQUENCE ? IRACTLEP ENN(CRN)          */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0174
*   GEN CODE EXIT NOSEQFLOW;                                    02S0174
@RC00149 DS    0H                                               02S0174
*                                  /*
         LM    @00,@14,064+000(@13)    RELOAD INVOKING RTNE REGS
         BR    NTRREG                  EXIT TO ACTION/REQUEST
*                                                               02S0175
*/* **************************************************************** */
*/*                                                                  */
*/*    ROUTINE NAME - IRARMCRT                                       */
*/*                                                                  */
*/*    DESCRIPTIVE NAME - SYSTEM RESOURCES MANAGER CNTRL ALGORITHM   */
*/*                       ENTRY POINT TABLE SCANNING SUBROUTINE      */
*/*                                                                  */
*/*    FUNCTION - THE IRARMCRT SUBROUTINE ACCEPTS AN INVOCATION BIT  */
*/*          PATTERN AND AN ENTRY POINT TABLE ADDRESS.  IT SCANS THE */
*/*          TABLE LOOKING FOR ENTRY POINT BLOCKS WHOSE INVOCATION   */
*/*          FLAGS MATCH 'ONE' BITS IN THE INPUT BIT PATTERN.  FOR   */
*/*          EACH SUCCESSFUL MATCH, THE CORRESPONDING ENTRY POINT    */
*/*          ROUTINE IS INVOKED.  AFTER THE ROUTINE COMPLETES, ITS   */
*/*          INVOCATION BIT IS SET 'ZERO' IN THE INPUT BIT PATTERN.  */
*/*                                                                  */
*/*    INPUT - REG 1 CONTAINS THE ADDRESS OF THE TOP RMEP BLOCK IN   */
*/*            A CHAINED TABLE.  THE RMEP BLOCKS IN THIS TABLE CON-  */
*/*            STITUTE THE LIST OF CANDIDATES THAT MAY BE INVOKED.   */
*/*          - REG 8 CONTAINS THE ADDRESS OF A FULL WORD WHOSE BITS  */
*/*            IF 'ONE' REPRESENT ROUTINES TO BE INVOKED.            */
*/*          - REG 13 CONTAINS THE ADDRESS OF THE SAVE AREA STACK    */
*/*            APPLICABLE TO THE ROUTINES TO BE INVOKED.             */
*/*          - REG 14 CONTAINS THE RETURN ADDRESS                    */
*/*                                                                  */
*/*    OUTPT - SEE FUNCTION.                                         */
*/*                                                                  */
*/*    EXIT  - BRANCH ON REGISTER 14.                                */
*/*          - THERE IS NO ERROR EXIT OR INDICATION.                 */
*/*                                                                  */
*/* **************************************************************** */
*                                                               02S0175
*IRARMCRT:                                                      02S0175
*   PROC OPTIONS(NOSAVE,NOSAVEAREA,NOENTREG,RETREG,NOPARMREG);  02S0175
IRARMCRT DS    0H                                               02S0176
*   SVRO=RTNREG;                    /* SAVE RETURN REG CONTENTS      */
         LR    SVRO,RTNREG                                      02S0176
*   WKRE=INMASK&RMCAINV;            /* PICK RTNE INVOCN BIT PATTERN  */
*                                                               02S0177
         L     WKRE,INMASK(,PMRE)                               02S0177
         N     WKRE,RMCAINV(,RMCTPTR)                           02S0177
*   /*****************************************************************/
*   /*                                                               */
*   /* THE FOLLOWING CODE WILL BE EXECUTED AS LONG AS ALL BITS IN THE*/
*   /* SUPPLIED INVOCATION PATTERN HAVE NOT BEEN TURNED OFF.         */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0178
*   DO WHILE(WKRE^=EMPTY&RMEPPTR^=ZERO);                        02S0178
*                                                               02S0178
         B     @DE00178                                         02S0178
@DL00178 DS    0H                                               02S0179
*     /***************************************************************/
*     /*                                                             */
*     /* THE FOLLOWING CODE STEPS THROUGH THE CHAINED RMEP BLOCKS IN */
*     /* THE SPECIFIED TABLE. TABLE END IS INDICATED BY A ZERO VALUE */
*     /* IN THE CHAIN FORWARD POINTER.                               */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0179
*     WKRO=WKRE&RMEPFLG;            /* TEST CURRENT RTNE INVOCN BIT  */
         LR    WKRO,WKRE                                        02S0179
         N     WKRO,RMEPFLG(,RMEPPTR)                           02S0179
*     IF WKRO^=EMPTY THEN           /* ROUTINE FLAG MATCHES PATTERN  */
*                                                               02S0180
         LTR   WKRO,WKRO                                        02S0180
         BZ    @RF00180                                         02S0180
*       /*************************************************************/
*       /*                                                           */
*       /* INVOKE THE ROUTINE WHOSE FLAG IS 'ONE' IN THE PATTERN     */
*       /*                                                           */
*       /*************************************************************/
*                                                               02S0181
*       DO;                                                     02S0181
*         WKRE=INMASK;              /* PICK RTNE INVOCN BIT PATTERN  */
         L     WKRE,INMASK(,PMRE)                               02S0182
*RMCRTL1:                           /* POINT FROM WHICH TRY AGAIN IF
*                                      COMPARE AND SWAP FAILS        */
*         RTNREG=WKRE|WKRO;         /* ADD IN FLAG FOR INVOKED RTNE  */
RMCRTL1  LR    RTNREG,WKRE                                      02S0183
         OR    RTNREG,WKRO                                      02S0183
*         RTNREG=RTNREG&&WKRO;      /* DELETE FLAG FOR INVOKED RTNE  */
         XR    RTNREG,WKRO                                      02S0184
*         CS(WKRE,RTNREG,INMASK);   /* STORE UPDATED INVOCN PATTERN  */
         CS    WKRE,@14,INMASK(PMRE)                            02S0185
*         BC(7,RMCRTL1);            /* REPEAT IF PATTRN UPDTE FAILD  */
         BC    7,RMCRTL1                                        02S0186
*         RRPACTL='1'B;             /* CONTINUE IRARMCTL ON 2ND FAIL */
         OI    RRPACTL(RRPAPTR),B'00001000'                     02S0187
*         CALL RMEPEPA->IRARMRTN;   /* INVOKE DESIGNATED ROUTINE     */
         L     @15,RMEPEPA(,RMEPPTR)                            02S0188
         BALR  @14,@15                                          02S0188
*         RRPACTL='0'B;             /* REVERT TO NORMAL FAIL PROCESS */
         NI    RRPACTL(RRPAPTR),B'11110111'                     02S0189
*         RRPAEPA=ADDR(RMEPBCTL);   /* RESTORE CONTROL ROUTINE RMEP  */
         LA    @09,RMEPBCTL(,RMCTPTR)                           02S0190
         ST    @09,RRPAEPA(,RRPAPTR)                            02S0190
*         IF RMEPTMD='1'B&          /* TIME-DRIVEN ALGORITHM INVKD   */
*             RMCTTBS^=ZERO THEN    /* SRM TIMER INTERRUPTS ACTIVE   */
*                                                               02S0191
         TM    RMEPTMD(RMEPPTR),B'00000010'                     02S0191
         BNO   @RF00191                                         02S0191
         L     @09,RMCTTBS(,RMCTPTR)                            02S0191
         LTR   @09,@09                                          02S0191
         BZ    @RF00191                                         02S0191
*           /*********************************************************/
*           /*                                                       */
*           /* CALL SBRTN TO RESCHED THE RMEP ON THE TIMED ENTRY QUE */
*           /*                                                       */
*           /*********************************************************/
*                                                               02S0192
*           DO;                                                 02S0192
*             RMEPBCK->RMEPFWD=RMEPFWD;/* DEQ RMEP FROM FWD CHAIN    */
         L     @09,RMEPBCK(,RMEPPTR)                            02S0193
         L     @08,RMEPFWD(,RMEPPTR)                            02S0193
         ST    @08,RMEPFWD(,@09)                                02S0193
*             RMEPFWD->RMEPBCK=RMEPBCK;/* DEQ RMEP FROM BCK CHAIN    */
         ST    @09,RMEPBCK(,@08)                                02S0194
*             CALL IRARMCQT;        /* RE-ENQUE RMEP ONTO TIMED QUE  */
         BAL   @14,IRARMCQT                                     02S0195
*           END;                                                02S0196
*         WKRE=INMASK&RMCAINV;      /* RELOD RTN INVOCN BIT PATTERN  */
@RF00191 L     WKRE,INMASK(,PMRE)                               02S0197
         N     WKRE,RMCAINV(,RMCTPTR)                           02S0197
*       END;                                                    02S0198
*     RMEPPTR=RMEPPRV;              /* STEP TO NEXT RMEP ON CHAIN    */
@RF00180 L     RMEPPTR,RMEPPRV(,RMEPPTR)                        02S0199
*   END;                                                        02S0200
@DE00178 SLR   @09,@09                                          02S0200
         CLR   WKRE,@09                                         02S0200
         BE    @DC00178                                         02S0200
         CR    RMEPPTR,@09                                      02S0200
         BNE   @DL00178                                         02S0200
@DC00178 DS    0H                                               02S0201
*   RTNREG=SVRO;                    /* RESTORE RETURN REG CONTENTS   */
         LR    RTNREG,SVRO                                      02S0201
*   END IRARMCRT;                                               02S0202
@EL00004 DS    0H                                               02S0202
@EF00004 DS    0H                                               02S0202
@ER00004 BR    @14                                              02S0202
*                                                               02S0203
*/* **************************************************************** */
*/*                                                                  */
*/*    ROUTINE NAME - IRARMCRY                                       */
*/*                                                                  */
*/*    DESCRIPTIVE NAME - SYSTEM RESOURCES MANAGER CNTRL ALGORITHM   */
*/*          USER SWAP REQUEST RECEIVING SUBROUTINE          @Z40BPCJ*/
*/*                                                                  */
*/*    FUNCTION - THE IRARMCRY SUBROUTINE ACCEPTS A REQUEST THAT     */
*/*          A USER BE SWAPPED INTO OR OUT OF CORE.  IF THE USER IS  */
*/*                                                          @Z40BPCJ*/
*/*          IN THE PROCESS OF BEING SWAPPED, A CODE IS RETURNED     */
*/*          TO INDICATE THAT THE REQUEST COULD NOT BE HONORED.      */
*/*          IF THE REQUESTOR HAS OBTAINED THE SYSTEM RESOURCES      */
*/*          MANAGER LOCK, CONTROL IS ROUTED TO THE SUBROUTINE       */
*/*          WHICH WILL PROCESS THE REQUEST.  IF THE SRM LOCK IS     */
*/*          NOT HELD, A CODE IS RETURNED TO INDICATE THAT THE       */
*/*          REQUEST COULD NOT BE HONORED.                           */
*/*                                                                  */
*/*    INPUT - REG 1 CONTAINS THE ADDRESS OF THE RMEP BLOCK FOR THE  */
*/*            SWAP FUNCTION BEING REQUESTED.                @Z40BPCJ*/
*/*          - REG 4 CONTAINS THE ADDRESS OF THE OUCB OF THE USER    */
*/*            TO BE SWAPPED.                                @Z40BPCJ*/
*/*          - REG 14 CONTAINS THE RETURN ADDRESS.                   */
*/*          - REG 15 CONTAINS THE IRARMCRY ROUTINE ADDRESS.         */
*/*          - THE RRPA LOCATED BY REG 3 INDICATES IF THIS REQUEST   */
*/*            IS/IS NOT COMING FROM A PROCESS HOLDING THE SYSTEM    */
*/*            RESOURCES MANAGER LOCK.                               */
*/*          - THE RRPAEPA FIELD CONTAINS THE ADDRESS OF THE RMEP    */
*/*            BLOCK OF THE ROUTINE WHICH IS ISSUING THE REQUEST.    */
*/*          - SEE INPUT DATA DESCRIPTION OF THE INDIVIDUAL SWAP     */
*/*            SUBROUTINES FOR FURTHER PARAMETERS.           @Z40BPCJ*/
*/*                                                                  */
*/*    OUTPT - IF THE CURRENT STATE OF THE SPECIFIED OUCB WAS SUCH   */
*/*            THAT THE REQUEST COULD BE HONORED,            @Z40BPCJ*/
*/*            THE APPROPRIATE SWAPPING PROCEDURE            @Z40BPCJ*/
*/*            WILL HAVE BEEN INITIATED FOR THAT ADDRESS SPACE.      */
*/*                                                                  */
*/*    EXIT NORMAL - BRANCH ON REGISTER 14.                          */
*/*          - 0 IN REG 15 TO INDICATE THAT THE REQUEST WAS HONORED. */
*/*                                                                  */
*/*    EXIT ERROR  - BRANCH ON REGISTER 14.                          */
*/*          - 4 IN REG 15 IF THE INDICATED USER IS          @Z40BPCJ*/
*/*            NON-SWAPPABLE OR INVALID                      @Z40BPCJ*/
*/*          - 8 IN REG 15 IF THE INDICATED USER IS CURRENTLY IN     */
*/*            THE PROCESS OF BEING SWAPPED.                         */
*/*          - SEE ERROR EXIT DESCRIPTION OF THE INDIVIDUAL SWAP     */
*/*            SUBROUTINES FOR FURTHER ERROR CODES.          @Z40BPCJ*/
*/*                                                                  */
*/* **************************************************************** */
*                                                               02S0203
*   /*****************************************************************/
*   /*                                                               */
*   /* IRARMCRY ROUTINE - ENTRY SEQUENCE ? IRACTLEP EPN(CRY)         */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0203
*   DCL                                                         02S0203
*     IRARMCRY ENTRY INT;                                       02S0203
*   GEN CODE REFS(LCCACPUS,PSALCCAV,WSACOPTM) DEFS(IRARMCRY) NOEXIT
*       SEQFLOW;                                                02S0204
*                                                               02S0204
*                                  /*
         ENTRY IRARMCRY
IRARMCRY DS    0H
         L     @15,PSALCCAV            LCCA ADDRESS
         L     @15,LCCACPUS-LCCA(,@15) CPU SAVE AREA VECTOR TABLE
         L     @15,WSACOPTM-WSAC(,@15) SRM SAVE AREA START ADDRESS
         STM   @00,@14,128+000(@15)    SAVE INVOKING RTNE REGS
         LR    @13,@15                 ROUTINE SAVE AREA ADDRESS
         BALR  @15,0                   SETUP ENTRY ADDRESSABILITY
         LA    @12,*-@PSTART           DISPLACEMENT TO MODULE BASE
         LCR   @12,@12                 NEGATIVE FOR SUBTRACT
         ALR   @12,@15                 SETUP MODULE ADDRESSABILITY
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK IF SWAP INAPPLICABLE TO THIS USER.              @Z40BPCJ*/
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0205
*   IF(OUCBNSW='0'B|OUCBOUT='1'B)&OUCBNAME='OUCB'&OUCBINV='0'B THEN/*
*                                      USER STATUS SWAPPABLE AND
*                                      VALID                 @Z40BPCJ*/
*                                                               02S0205
         TM    OUCBNSW(OUCBPTR),B'10000000'                     02S0205
         BZ    @GL00011                                         02S0205
         TM    OUCBOUT(OUCBPTR),B'00000100'                     02S0205
         BNO   @RF00205                                         02S0205
@GL00011 CLC   OUCBNAME(4,OUCBPTR),@CC02242                     02S0205
         BNE   @RF00205                                         02S0205
         TM    OUCBINV(OUCBPTR),B'00010000'                     02S0205
         BNZ   @RF00205                                         02S0205
*     /***************************************************************/
*     /*                                                             */
*     /* SWAP NOT PROHIBITED. CHECK IF THE ADDRESS           @Z40BPCJ*/
*     /* SPACE IS IN THE PROCESS OF BEING SWAPPED.                   */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0206
*     IF OUCBGOO='0'B&OUCBGOI='0'B THEN/* NOT BEING SWAPPED          */
*                                                               02S0206
         TM    OUCBGOO(OUCBPTR),B'11000000'                     02S0206
         BNZ   @RF00206                                         02S0206
*       /*************************************************************/
*       /*                                                           */
*       /* CHECK IF THE FUNCTION CAN BE INVOKED AT THIS TIME.        */
*       /*                                                           */
*       /*************************************************************/
*                                                               02S0207
*       IF RRPAOPT='1'B THEN        /* SRM LOCK HELD BY REQUESTOR    */
*                                                               02S0207
         TM    RRPAOPT(RRPAPTR),B'00000010'                     02S0207
         BNO   @RF00207                                         02S0207
*         /***********************************************************/
*         /*                                                         */
*         /* INVOKE REQUESTED SUBFUNCTION.                   @Z40BPCJ*/
*         /*                                                         */
*         /***********************************************************/
*                                                               02S0208
*         DO;                                                   02S0208
*           WKRO=SVEREG;            /* SAVE IRARMCRY CALLERS REG 13  */
         LR    WKRO,SVEREG                                      02S0209
*           SVEREG=RMCTRMSA;        /* PASS SAVE AREA STACK TO RTNE  */
         L     SVEREG,RMCTRMSA(,RMCTPTR)                        02S0210
*           CALL RMEPEPA->IRARMRTN; /* INVOKE REQSTD SWAP FUNCTN     */
         L     @15,RMEPEPA(,RMEPPTR)                            02S0211
         BALR  @14,@15                                          02S0211
*           SVEREG=WKRO;            /* REST IRARMCRY CALLERS REG 13  */
         LR    SVEREG,WKRO                                      02S0212
*         END;                                                  02S0213
*       ELSE                        /* NONLOCKED REQ FOR SWAP@Z40BPCJ*/
*         RTNCOD=FOUR;              /* RESULT EQUALS NON-SWAPPABLE   */
         B     @RC00207                                         02S0214
@RF00207 LA    RTNCOD,4                                         02S0214
*     ELSE                          /* HAVE ONGOING SWAP     @Z40BPCJ*/
*       RTNCOD=EIGHT;               /* REQUEST GIVEN AT WRONG TIME   */
         B     @RC00206                                         02S0215
@RF00206 LA    RTNCOD,8                                         02S0215
*   ELSE                            /* ADDRESS SPACE NON-SWAPPABLE   */
*     RTNCOD=FOUR;                  /* REQUEST GIVEN FOR WRONG USER  */
*                                                               02S0216
         B     @RC00205                                         02S0216
@RF00205 LA    RTNCOD,4                                         02S0216
*   /*****************************************************************/
*   /*                                                               */
*   /* IRARMCRY ROUTINE - EXIT SEQUENCE ? IRACTLEP ENN(CRY)          */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0217
*   GEN CODE EXIT NOSEQFLOW;                                    02S0217
@RC00205 DS    0H                                               02S0217
*                                  /*
         LM    @00,@14,128+000(@13)    RELOAD INVOKING RTNE REGS
         BR    RTNREG                  RETURN TO INVOKER
*                                                               02S0218
*/* **************************************************************** */
*/*                                                                  */
*/*    ROUTINE NAME - IRARMCSI                                       */
*/*                                                                  */
*/*    DESCRIPTIVE NAME - SYSTEM RESOURCES MANAGER CNTRL ALGORITHM   */
*/*                       USER SWAP-IN REQUEST RECEIVING SBRTNE      */
*/*                                                                  */
*/*    FUNCTION - THE IRARMCSI SUBROUTINE ACCEPTS A REQUEST THAT AN  */
*/*          ADDRESS SPACE BE SWAPPED IN.  ROUTINES          @Z40BPCJ*/
*/*          ARE INVOKED TO ALLOCATE AN OUXB TO THE ADDRESS SPACE,   */
*/*          AND TO SCHEDULE THE SWAP-IN.  IF THE SWAPIN     @Z40BPCJ*/
*/*          PROCESS WAS SUCCESSFULLY INITIATED, THE OUCB IS MARKED  */
*/*          THAT THE ADDRESS SPACE IS BEING SWAPPED IN.             */
*/*                                                                  */
*/*    NOTE  - THE IRARMCSI ROUTINE DOES NOT REQUIRE SERIALIZATION   */
*/*            WITH OTHER SYSTEM RESOURCES MANAGER PROCESSES, WHICH  */
*/*            COULD BE CONCURRENTLY EXAMINING THE SAME OUCB WHOSE   */
*/*            STATUS IS BEING CHANGED BY IRARMCSI.                  */
*/*                                                                  */
*/*    INPUT - REG 4 CONTAINS THE ADDRESS OF THE OUCB OF THE USER    */
*/*            WHO IS TO BE SWAPPED IN.                              */
*/*          - REG 13 CONTAINS THE ADDRESS OF THE SAVE AREA STACK    */
*/*            ASSOCIATED WITH THE SYSTEM RESOURCES MANAGER LOCK.    */
*/*          - REG 14 CONTAINS THE RETURN ADDRESS.                   */
*/*          - REG 15 CONTAINS THE IRARMCSI ROUTINE ADDRESS.         */
*/*                                                                  */
*/*    OUTPT - AN OUXB IS ASSIGNED TO THE ADDRESS SPACE TO BE        */
*/*            SWAPPED IN.                                           */
*/*          - OUCBGOI IS SET IF THE SWAP-IN IS INITIATED.           */
*/*                                                                  */
*/*    EXIT NORMAL - BRANCH ON REGISTER 14.                          */
*/*          - 0 IN REG 15 TO INDICATE THAT SWAP-IN WAS INITIATED.   */
*/*                                                                  */
*/*    EXIT ERROR  - BRANCH ON REGISTER 14.                          */
*/*          - SEE IRARMI04 ROUTINE TO DETERMINE THE ERROR   @Z40BPCJ*/
*/*            CODES RETURNED WHEN A STORAGE REQUEST FAILS.  @Z40BPCJ*/
*/*          - SEE IRARMI07 ROUTINE TO DETERMINE THE ERROR   @Z40BPCJ*/
*/*            CODES RETURNED WHEN A SWAPIN REQUEST FAILS.   @Z40BPCJ*/
*/*          - 8 IN REG 15 IF THE INDICATED USER IS          @Z40BPCJ*/
*/*            ALREADY SWAPPED IN.                           @Z40BPCJ*/
*/*                                                                  */
*/* **************************************************************** */
*                                                               02S0218
*   /*****************************************************************/
*   /*                                                               */
*   /* IRARMCSI ROUTINE - ENTRY SEQUENCE ? IRACTLEP EPN(CSI)         */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0218
*   DCL                                                         02S0218
*     IRARMCSI ENTRY INT;                                       02S0218
*   GEN CODE DEFS(IRARMCSI) NOEXIT SEQFLOW;                     02S0219
*                                  /*
         ENTRY IRARMCSI
IRARMCSI DS    0H
         STM   @00,@14,128+000(@13)    SAVE INVOKING RTNE REGS
         LA    @12,IRARMCSI-@PSTART    DISPLACEMENT TO MODULE BASE
         LCR   @12,@12                 NEGATIVE FOR SUBTRACT
         ALR   @12,@15                 SETUP MODULE ADDRESSABILITY
*   IF OUCBOUT='1'B THEN                                        02S0220
         TM    OUCBOUT(OUCBPTR),B'00000100'                     02S0220
         BNO   @RF00220                                         02S0220
*     DO;                           /* USER CURRENTLY OUT OF CORE
*                                                            @Z40BPCJ*/
*       ASCBPTR=OUCBASCB;           /* PICK USER TO BE SWPD  @ZA00250*/
         L     ASCBPTR,OUCBASCB(,OUCBPTR)                       02S0222
*       R1=ASCBOUXB;                /* PICK EXTENSION ADDRS  @ZA00250*/
         L     R1,ASCBOUXB(,ASCBPTR)                            02S0223
*       IF R1=RMCTOUXB THEN         /* DON'T HAVE EXTENSION  @Z40BPCJ*/
*                                                               02S0224
         C     R1,RMCTOUXB(,RMCTPTR)                            02S0224
         BNE   @RF00224                                         02S0224
*         /***********************************************************/
*         /*                                                         */
*         /* PREPARE FOR SWAP-IN - OBTAIN USER CNTRL BLOCK EXTENSION */
*         /*                                                         */
*         /***********************************************************/
*                                                               02S0225
*         DO;                                                   02S0225
*                                                               02S0225
*           /*********************************************************/
*           /*                                                       */
*           /* INVOKE SUBROUTINE TO OBTAIN STORAGE FOR ADDR SPACE    */
*           /* OUXB                                                  */
*           /*                                                       */
*           /*********************************************************/
*                                                               02S0226
*           R0=LENGTH(OUXB);        /* INDICATE SIZE OF AREA WANTED  */
         LA    R0,144                                           02S0226
*           R1=ZERO;                /* INDICATE STORAGE GET REQUEST  */
*                                                               02S0227
         SLR   R1,R1                                            02S0227
*           /*********************************************************/
*           /*                                                       */
*           /* ? IRACTLCL EPN(I04)                                   */
*           /*                                                       */
*           /*********************************************************/
*                                                               02S0228
*           CALL RMSBI04->IRARMRTN; /* INVOKE I04 SUBRTN             */
         L     @15,RMSBI04(,RMCTPTR)                            02S0228
         BALR  @14,@15                                          02S0228
*           IF RTNCOD^=ZERO THEN                                02S0229
         LTR   RTNCOD,RTNCOD                                    02S0229
         BNZ   @RT00229                                         02S0229
*             GO TO RMCSIL5;        /* DONT HAVE STORAGE FOR OUXB
*                                                            @Z40BPCJ*/
*         END;                                                  02S0231
*                                                               02S0231
*       /*************************************************************/
*       /*                                                           */
*       /* INVOKE SUBROUTINE TO SCHEDULE SWAP-IN FOR ADDRESS SPACE ? */
*       /* IRACTLCL EPN(I07)                                         */
*       /*                                                           */
*       /*************************************************************/
*                                                               02S0232
*       CALL RMSBI07->IRARMRTN;     /* INVOKE I07 SUBRTN             */
@RF00224 L     @15,RMSBI07(,RMCTPTR)                            02S0232
         BALR  @14,@15                                          02S0232
*       IF RTNCOD=ZERO THEN         /* PHYSICAL SWAP-IN INITIATED    */
*                                                               02S0233
         LTR   RTNCOD,RTNCOD                                    02S0233
         BNZ   @RF00233                                         02S0233
*         /***********************************************************/
*         /*                                                         */
*         /* INITIALIZE BLOCKS FOR ADDRESS SPACE SWAP-IN             */
*         /*                                                         */
*         /***********************************************************/
*                                                               02S0234
*         DO;                                                   02S0234
*           R1->OUXB=R1->OUXB&&R1->OUXB;/* CLEAR OUXB                */
         XC    OUXB(144,R1),OUXB(R1)                            02S0235
*           R1->OUXBNAME='OUXB';    /* SETUP BLOCK IDENTIFIER        */
         MVC   OUXBNAME(4,R1),@CC02246                          02S0236
*           ASCBOUXB=R1;            /* STORE NEW OUXB ADDRESS        */
         ST    R1,ASCBOUXB(,ASCBPTR)                            02S0237
*           OUCBGOI='1'B;           /* INDICATE USER STATUS CHANGE   */
         OI    OUCBGOI(OUCBPTR),B'01000000'                     02S0238
*           RMCACIUS=RMCACIUS+ONE;  /* ADD TO COMING IN USRS @Z30WIGS*/
         LA    @09,1                                            02S0239
         AH    @09,RMCACIUS(,RMCTPTR)                           02S0239
         STH   @09,RMCACIUS(,RMCTPTR)                           02S0239
*         END;                                                  02S0240
*       ELSE                        /* ERROR IN TRYING TO SWAP-IN    */
*                                                               02S0241
*         /***********************************************************/
*         /*                                                         */
*         /* FREE STORAGE OBTAINED FOR USE AS OUXB                   */
*         /*                                                         */
*         /***********************************************************/
*                                                               02S0241
*         DO;                                                   02S0241
         B     @RC00233                                         02S0241
@RF00233 DS    0H                                               02S0242
*           RESPECIFY                                           02S0242
*             CVRE RSTD;            /*                       @Z40BPCJ*/
*           CVRE=RTNCOD;            /*                       @Z40BPCJ*/
         LR    CVRE,RTNCOD                                      02S0243
*           ASCBOUXB=RMCTOUXB;      /* STORE PTR TO PREDEFINED OUXB
*                                                            @Z40BPCJ*/
         L     @09,RMCTOUXB(,RMCTPTR)                           02S0244
         ST    @09,ASCBOUXB(,ASCBPTR)                           02S0244
*           R0=LENGTH(OUXB);        /* INDICATE SIZE OF AREA FREED   */
*                                                               02S0245
         LA    R0,144                                           02S0245
*           /*********************************************************/
*           /*                                                       */
*           /* ? IRACTLCL EPN(I04)                                   */
*           /*                                                       */
*           /*********************************************************/
*                                                               02S0246
*           CALL RMSBI04->IRARMRTN; /* INVOKE I04 SUBRTN             */
         L     @15,RMSBI04(,RMCTPTR)                            02S0246
         BALR  @14,@15                                          02S0246
*           RTNCOD=CVRE;            /*                       @Z40BPCJ*/
         LR    RTNCOD,CVRE                                      02S0247
*           RESPECIFY                                           02S0248
*             CVRE UNRSTD;          /*                       @Z40BPCJ*/
*         END;                                                  02S0249
*RMCSIL5:                                                       02S0250
*     END;                          /*                       @Z40BPCJ*/
*   ELSE                                                        02S0251
*     RTNCOD=EIGHT;                 /*                       @Z40BPCJ*/
*                                                               02S0251
         B     @RC00220                                         02S0251
@RF00220 LA    RTNCOD,8                                         02S0251
*   /*****************************************************************/
*   /*                                                               */
*   /* ? IRACTLEP ENN(CSI)                                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0252
*   GEN CODE EXIT NOSEQFLOW;                                    02S0252
@RC00220 DS    0H                                               02S0252
*                                  /*
         LM    @00,@14,128+000(@13)    RELOAD INVOKING RTNE REGS
         BR    RTNREG                  RETURN TO INVOKER
*                                                               02S0253
*/* **************************************************************** */
*/*                                                                  */
*/*    ROUTINE NAME - IRARMCSO                                       */
*/*                                                                  */
*/*    DESCRIPTIVE NAME - SYSTEM RESOURCES MANAGER CNTRL ALGORITHM   */
*/*                       USER SWAP-OUT REQUEST RECEIVING SBRTNE     */
*/*                                                                  */
*/*    FUNCTION - THE IRARMCSO SUBROUTINE ACCEPTS A REQUEST THAT AN  */
*/*          ADDRESS SPACE BE SWAPPED OUT.  IF THE ADDRESS SPACE IS  */
*/*          ALREADY SWAPPED OUT, A CODE IS RETURNED TO INDICATE     */
*/*          THAT THE REQUEST COULD NOT BE HONORED.  OTHERWISE, THE  */
*/*          IRARMI06 ROUTINE IS INVOKED TO POST QUIESCE FOR THE     */
*/*          ADDRESS SPACE, AND THE SYSTEM RESOURCES MANAGER USER    */
*/*          CONTROL BLOCK IS MARKED TO SHOW THAT THE USER IS IN     */
*/*          THE PROCESS OF BEING SWAPPED OUT.                       */
*/*                                                                  */
*/*    NOTE  - THE IRARMCSO ROUTINE DOES NOT REQUIRE SERIALIZATION   */
*/*            WITH OTHER SYSTEM RESOURCES MANAGER PROCESSES, WHICH  */
*/*            COULD BE EXAMINING THE SAME OUCB WHOSE STATUS IS      */
*/*            BEING CHANGED BY IRARMCSO.                            */
*/*                                                                  */
*/*    INPUT - REG 4 CONTAINS THE ADDRESS OF THE OUCB OF THE USER    */
*/*            WHO IS TO BE SWAPPED OUT.                             */
*/*          - REG 14 CONTAINS THE RETURN ADDRESS.                   */
*/*          - REG 15 CONTAINS THE IRARMCSO ROUTINE ADDRESS.         */
*/*                                                                  */
*/*    OUTPT - OUCBGOO IS SET IF THE SWAP-OUT IS INITIATED.          */
*/*                                                                  */
*/*    EXIT NORMAL - BRANCH ON REGISTER 14.                          */
*/*          - 0 IN REG 15 TO INDICATE THAT SWAP-OUT WAS INITIATED.  */
*/*                                                                  */
*/*    EXIT ERROR  - BRANCH ON REGISTER 14.                          */
*/*          - 4 IN REG 15 IF AN ERROR WAS EXPERIENCED WHILE         */
*/*            TRYING TO POST QUIESCE FOR THE ADDRESS SPACE.         */
*/*          - 8 IN REG 15 IF THE INDICATED USER IS ALREADY          */
*/*            SWAPPED OUT.                                          */
*/*          - SEE IRARMCRY EXIT DESCRIPTION FOR ERROR CODES         */
*/*            GIVEN IF THE USER IS NOT IN SWAPPABLE STATUS.         */
*/*                                                                  */
*/* **************************************************************** */
*                                                               02S0253
*   /*****************************************************************/
*   /*                                                               */
*   /* IRARMCSO ROUTINE - ENTRY SEQUENCE ? IRACTLEP EPN(CSO)         */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0253
*   DCL                                                         02S0253
*     IRARMCSO ENTRY INT;                                       02S0253
*   GEN CODE DEFS(IRARMCSO) NOEXIT SEQFLOW;                     02S0254
*                                                               02S0254
*                                  /*
         ENTRY IRARMCSO
IRARMCSO DS    0H
         STM   @00,@14,128+000(@13)    SAVE INVOKING RTNE REGS
         LA    @12,IRARMCSO-@PSTART    DISPLACEMENT TO MODULE BASE
         LCR   @12,@12                 NEGATIVE FOR SUBTRACT
         ALR   @12,@15                 SETUP MODULE ADDRESSABILITY
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK IF SWAP-OUT REQUEST INAPPLICABLE TO THIS USER.          */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0255
*   IF OUCBOUT='0'B THEN            /* USER CURRENTLY IN CORE        */
*                                                               02S0255
         TM    OUCBOUT(OUCBPTR),B'00000100'                     02S0255
         BNZ   @RF00255                                         02S0255
*     /***************************************************************/
*     /*                                                             */
*     /* INITIATE ACTUAL SWAP-OUT PROCESS.                           */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0256
*     DO;                                                       02S0256
*                                                               02S0256
*       /*************************************************************/
*       /*                                                           */
*       /* INVOKE SUBROUTINE TO POST QUIESCE.                        */
*       /*                                                           */
*       /*************************************************************/
*                                                               02S0257
*       ASCBPTR=OUCBASCB;           /* PASS USER TO BE QUIESCED      */
         L     ASCBPTR,OUCBASCB(,OUCBPTR)                       02S0257
*       OUCBPSTR='1'B;              /* IF POST ERROR, RECOVER (BIT IS
*                                      RESET BY QSCEST SYSEVENT)
*                                                            @ZA16887*/
         OI    OUCBPSTR(OUCBPTR),B'00001000'                    02S0258
*       R0=ZERO;                    /* PASS POST CODE 0      @Z116887*/
         SLR   R0,R0                                            02S0259
*       R1=ADDR(ASCBECB);           /* PASS RCT ECB ADDRESS          */
         LA    R1,ASCBECB(,ASCBPTR)                             02S0260
*       ASCBFQUB='1'B;              /* TELL RCT TO QUIESCE           */
*                                                               02S0261
         L     @09,ASCBFQUB-2(,ASCBPTR)                         02S0261
@GL00013 LR    @08,@09                                          02S0261
         O     @08,@CF02292                                     02S0261
         CS    @09,@08,ASCBFQUB-2(ASCBPTR)                      02S0261
         BNE   @GL00013                                         02S0261
*       /*************************************************************/
*       /*                                                           */
*       /* ? IRACTLCL EPN(I06)                                       */
*       /*                                                           */
*       /*************************************************************/
*                                                               02S0262
*       CALL RMSBI06->IRARMRTN;     /* INVOKE I06 SUBRTN             */
         L     @15,RMSBI06(,RMCTPTR)                            02S0262
         BALR  @14,@15                                          02S0262
*       IF RTNCOD=ZERO THEN         /* PHYSICAL SWAP-OUT INITIATED   */
*                                                               02S0263
         LTR   RTNCOD,RTNCOD                                    02S0263
         BNZ   @RF00263                                         02S0263
*         /***********************************************************/
*         /*                                                         */
*         /* PUT USER AT TOP OF DISPATCHING QUEUE DURING QUIESCE     */
*         /*                                                         */
*         /***********************************************************/
*                                                               02S0264
*         DO;                       /*                       @YM05632*/
*           OUCBGOO='1'B;           /* INDICATE USER STATUS CHANGE   */
         OI    OUCBGOO(OUCBPTR),B'10000000'                     02S0265
*           IF OUCBAPG='0'B         /* PREVENT ZERO DP IF A  @ZA11365*/
*             THEN                                              02S0266
         TM    OUCBAPG(OUCBPTR),B'01000000'                     02S0266
         BNZ   @RF00266                                         02S0266
*             OUCBNDP=ASCBDP;       /* SWAP BEFORE EVENT 10. @ZA11365*/
         IC    @09,ASCBDP(,ASCBPTR)                             02S0267
         STC   @09,OUCBNDP(,OUCBPTR)                            02S0267
*           RMCACHU=ASCBPTR;        /* PASS USER TO BE CHAPPED  02S0268
*                                                            @YM05632*/
@RF00266 ST    ASCBPTR,RMCACHU(,RMCTPTR)                        02S0268
*           R1=ADDR(RMCACHP);       /* ADDR OF CHAP PARAM LIST  02S0269
*                                                            @YM05632*/
*                                                               02S0269
         LA    R1,RMCACHP(,RMCTPTR)                             02S0269
*           /*********************************************************/
*           /*                                                       */
*           /* ? IRACTLCL EPN(I02)                                   */
*           /*                                                       */
*           /*********************************************************/
*                                                               02S0270
*           CALL RMSBI02->IRARMRTN; /* INVOKE I02 SUBRTN             */
         L     @15,RMSBI02(,RMCTPTR)                            02S0270
         BALR  @14,@15                                          02S0270
*           RTNCOD=ZERO;            /* SWAP-OUT REQUEST PROCESSED
*                                                            @YM05632*/
         SLR   RTNCOD,RTNCOD                                    02S0271
*         END;                      /*                       @YM05632*/
*       ELSE                        /* ERROR IN TRYING TO SWAP-OUT   */
*         RTNCOD=FOUR;              /* PASS INVOKER ERROR RESPONSE   */
         B     @RC00263                                         02S0273
@RF00263 LA    RTNCOD,4                                         02S0273
*     END;                                                      02S0274
*   ELSE                            /* USER ALREADY SWAPPED OUT      */
*     RTNCOD=EIGHT;                 /* REQUEST GIVEN AT WRONG TIME   */
*                                                               02S0275
         B     @RC00255                                         02S0275
@RF00255 LA    RTNCOD,8                                         02S0275
*   /*****************************************************************/
*   /*                                                               */
*   /* IRARMCSO ROUTINE - EXIT SEQUENCE ? IRACTLEP ENN(CSO)          */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0276
*   GEN CODE EXIT NOSEQFLOW;                                    02S0276
@RC00255 DS    0H                                               02S0276
*                                  /*
         LM    @00,@14,128+000(@13)    RELOAD INVOKING RTNE REGS
         BR    RTNREG                  RETURN TO INVOKER
*                                                               02S0277
*/* *********************************************************@Z40BPCH*/
*/*                                                          @Z40BPCH*/
*/* ROUTINE NAME - IRARMRPS                                  @Z40BPCH*/
*/*                                                          @Z40BPCH*/
*/* DESCRIPTIVE NAME - SYSTEM RESOURCES MANAGER USER CONTROL @Z40BPCH*/
*/*                    BLOCK REPOSITIONING ROUTINE           @Z40BPCH*/
*/*                                                          @Z40BPCH*/
*/* FUNCTION - THE IRARMRPS SUBROUTINE DEQUEUES THE INDICATED@Z40BPCH*/
*/*            OUCB FROM THE PRESENT POSITION ON ITS PRESENT @Z40BPCH*/
*/*            QUEUE, AND ENQUEUES THE OUCB ONTO THE QUEUE   @Z40BPCH*/
*/*            SPECIFIED BY THE FLAGS IN ITS OUCBQFL FIELD   @Z40BPCH*/
*/*            AT THE END POSITION ON THE QUEUE.             @Z40BPCH*/
*/*                                                          @Z40BPCH*/
*/* NOTE - IRARMRPS IS AN 'ACTION ROUTINE' I.E. IT PERFORMS  @Z40BPCH*/
*/*        OUCB ENQUEUEING FOR ONE USER. IRARMRPS RUNS UNDER @Z40BPCH*/
*/*        THE SRM LOCK.                                     @Z40BPCH*/
*/*                                                          @Z40BPCH*/
*/* INPUT - OUCBGOB MUST BE SET '1'B WHEN CALLED             @Z40BPCH*/
*/*         REG 1 CONTAINS THE ADDRESS OF THE RMEP FOR RPS   @Z40BPCH*/
*/*         REG 4 CONTAINS THE ADDR OF THE OUCB TO BE QUEUED @Z40BPCH*/
*/*         REG 13 CONTAINS THE ADDR OF THE SAVE AREA STACK  @Z40BPCH*/
*/*         ASSOCIATED WITH THE SRM LOCK                     @Z40BPCH*/
*/*         REG 14 CONTAINS THE RETURN ADDRESS               @Z40BPCH*/
*/*         REG 15 CONTAINS THE RPS ROUTINE ADDRESS          @Z40BPCH*/
*/*         IF THE OUCBOUT FLAG IS OFF, THE OUCB WILL BE     @Z40BPCH*/
*/*         PLACED ON THE IN-CORE QUEUE.                     @Z40BPCH*/
*/*         ELSE, IF THE OUCBOFF FLAG IS ON AND THE USER IS  @Z40BPCH*/
*/*         NOT READY OR IS BEING FORCED OUT BY AN AUXILIARY @Z40BPCH*/
*/*         STORAGE SHORTAGE, THE OUCB WILL BE PLACED ON THE @Z40BPCH*/
*/*         WAIT QUEUE. OTHERWISE THE OUCB WILL BE PLACED ON @Z40BPCH*/
*/*         THE OUT QUEUE.                                   @Z40BPCH*/
*/*                                                          @Z40BPCH*/
*/* OUTPUT - THE OUXB IS MOVED TO THE END POSITION ON THE    @Z40BPCH*/
*/*          INDICATED QUEUE.                                @Z40BPCH*/
*/*                                                          @Z40BPCH*/
*/* EXIT - BRANCH ON REGISTER 14                             @Z40BPCH*/
*/*        THERE IS NO ERROR EXIT OR INDICATOR.              @Z40BPCH*/
*/*                                                          @Z40BPCH*/
*/* *********************************************************@Z40BPCH*/
*/* IRARMRPS ROUTINE - ENTRY SEQUENCE                        @Z40BPCH*/
*                                                               02S0277
*   /*****************************************************************/
*   /*                                                               */
*   /* ? IRACTLEP EPN(RPS)SAVE(6,14)CODEREG(*)                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0277
*   DCL                                                         02S0277
*     IRARMRPS ENTRY INT;                                       02S0277
*   GEN CODE REFS(RMCTRMSA,RRPAEPA) DEFS(IRARMRPS) NOEXIT SEQFLOW;
*                                                               02S0278
*                                  /*
         ENTRY IRARMRPS
IRARMRPS DS    0H
         L     @15,RMCTRMSA(,RMCTPTR)  SRM SAVE AREA START ADDRESS
         STM   @00,@14,064+000(@15)    SAVE INVOKING RTNE REGS
         MVC   064+060(4,@15),RRPAEPA(RRPAPTR) SAVE PREV RMEP
         ST    @01,RRPAEPA(,RRPAPTR)   INDICATE NEW CURRENT RMEP
         LR    @13,@15                 ROUTINE SAVE AREA ADDRESS
         BALR  @15,0                   RESET ENTRY ADDRESSABILITY
         USING *,@15
*/*                                                          @Z40BPCH*/
*/* DEQUEUE OUCB FROM ITS PRESENT POSITION ON SOME QUEUE. THE@Z40BPCH*/
*/* SUBROUTINE IS ONLY EXECUTED WHILE HOLDING THE SRM LOCK.  @Z40BPCH*/
*/* COMPARE AND SWAP INSTRUCTIONS DO NOT HAVE TO BE USED.    @Z40BPCH*/
*                                                               02S0279
*   OUCBFWD->OUCBBCK=OUCBBCK;       /* DEQ OUCB FROM PREV BACK CHAIN
*                                                            @Z40BPCH*/
         L     @09,OUCBFWD(,OUCBPTR)                            02S0279
         L     @08,OUCBBCK(,OUCBPTR)                            02S0279
         ST    @08,OUCBBCK(,@09)                                02S0279
*   OUCBBCK->OUCBFWD=OUCBFWD;       /* DEQ OUCB FROM PREV FWD CHAIN
*                                                            @Z40BPCH*/
         ST    @09,OUCBFWD(,@08)                                02S0280
*/* DETERMINE QUEUE ONTO WHICH OUCB IS TO BE PLACED          @Z40BPCH*/
*                                                               02S0281
*   IF OUCBOUT='0'B THEN            /* TEST IF USER IS IN CORE  02S0281
*                                                            @Z40BPCH*/
         TM    OUCBOUT(OUCBPTR),B'00000100'                     02S0281
         BNZ   @RF00281                                         02S0281
*     PMRO=RMCTINQE;                /* SAVE INQ QUEUE HEADER ADDRESS
*                                                            @Z40BPCH*/
         L     PMRO,RMCTINQE(,RMCTPTR)                          02S0282
*   ELSE                            /* USER CONSIDERED OUT OF CORE
*                                                            @Z40BPCH*/
*/* THERE ARE TWO QUEUES FOR OUT OF CORE USERS. THE LONG WAIT QUEUE
*                                                            @Z40BPCH*/
*/* CONTAINS USERS WHICH MUST BE AWAKENED BEFORE THEY CAN EXECUTE.
*                                                            @Z40PBCH*/
*/* THE OUT OF CORE QUEUE CONTAINS USERS SUBJECT TO PERFORMANCE 02S0283
*                                                            @Z40PBCH*/
*/* ANALYSIS BEFORE BEING BROUGHT BACK IN.                   @Z40BPCH*/
*                                                               02S0283
*     DO;                           /*                       @Z40BPCH*/
         B     @RC00281                                         02S0283
@RF00281 DS    0H                                               02S0284
*/* TEST IF USER PUT ON WAIT QUEUE BY LONG WAIT OR BY AUXILIARY 02S0284
*                                                            @Z40BPCH*/
*/* STORAGE SHORTAGE.                                        @Z40BPCH*/
*                                                               02S0284
*       IF OUCBOFF='1'B&(OUCBRDY='0'B|OUCBAXS='1'B|OUCBFXS='1'B|
*           OUCBJSAS='1'B|OUCBJSFS='1'B) THEN/*              @ZM43072*/
         TM    OUCBOFF(OUCBPTR),B'00001000'                     02S0284
         BNO   @RF00284                                         02S0284
         TM    OUCBRDY(OUCBPTR),B'10000000'                     02S0284
         BZ    @RT00284                                         02S0284
         TM    OUCBAXS(OUCBPTR),B'00000101'                     02S0284
         BNZ   @RT00284                                         02S0284
         TM    OUCBJSAS(OUCBPTR),B'11000000'                    02S0284
         BZ    @RF00284                                         02S0284
@RT00284 DS    0H                                               02S0285
*         PMRO=RMCTWTQE;            /* PLACE USER ON WAIT QUEUE 02S0285
*                                                            @Z40BPCH*/
         L     PMRO,RMCTWTQE(,RMCTPTR)                          02S0285
*       ELSE                        /*                       @Z40BPCH*/
*         DO;                       /* PLACE USER ON OUT QUEUE  02S0286
*                                                            @Z40BPCH*/
         B     @RC00284                                         02S0286
@RF00284 DS    0H                                               02S0287
*           OUCBOFF='0'B;           /* REMOVE USER IF ON WAIT QUEUE
*                                                            @Z40BPCH*/
         NI    OUCBOFF(OUCBPTR),B'11110111'                     02S0287
*           PMRO=RMCTOTQE;          /* PLACE USER ON OUT QUEUE  02S0288
*                                                            @Z40BPCH*/
         L     PMRO,RMCTOTQE(,RMCTPTR)                          02S0288
*         END;                      /*                       @Z40BPCH*/
*     END;                          /*                       @Z40BPCH*/
@RC00284 DS    0H                                               02S0291
*/* INSERT THE OUCB ON THE END OF THE QUEUE                  @Z40BPCH*/
*                                                               02S0291
*   RESPECIFY                       /*                       @Z40BPCH*/
*    (OUCB) BASED(PMRO);            /*                       @Z40BPCH*/
@RC00281 DS    0H                                               02S0292
*   PMRO=OUCBBCK;                   /* ADDRESS OF LAST OUCB ON QUEUE
*                                                            @Z40BPCH*/
         L     PMRO,OUCBBCK(,PMRO)                              02S0292
*   OUCBPTR->OUCBBCK=ADDR(OUCB);    /* POINT OUCB TO BACK CHAIN 02S0293
*                                                            @Z40BPCH*/
         ST    PMRO,OUCBBCK(,OUCBPTR)                           02S0293
*   OUCBPTR->OUCBFWD=OUCBFWD;       /* POINT TO QUEUE HEADER @Z40BPCH*/
         L     @09,OUCBFWD(,PMRO)                               02S0294
         ST    @09,OUCBFWD(,OUCBPTR)                            02S0294
*   OUCBFWD->OUCBBCK=OUCBPTR;       /* ENQ OUCB ON BACKWD CHAIN 02S0295
*                                                            @Z40BPCH*/
         ST    OUCBPTR,OUCBBCK(,@09)                            02S0295
*   OUCBFWD=OUCBPTR;                /* ENQ OUCB ON FORWORD CHAIN
*                                                            @Z40BPCH*/
         ST    OUCBPTR,OUCBFWD(,PMRO)                           02S0296
*   RESPECIFY                       /*                       @Z40BPCH*/
*    (OUCB) BASED(OUCBPTR);         /* RESTORE NORMAL OUCB BASE 02S0297
*                                                            @Z40BPCH*/
*   OUCBGOB='0'B;                   /* CLEAR OUCB REPOSITION FLAG
*                                                            @Z40BPCH*/
         NI    OUCBGOB(OUCBPTR),B'11011111'                     02S0298
*/* IRARMRPS ROUTINE - EXIT SEQUENCE                         @Z40BPCH*/
*                                                               02S0299
*   /*****************************************************************/
*   /*                                                               */
*   /* ? IRACTLEP ENN(RPS)                                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0299
*   GEN CODE EXIT NOSEQFLOW;                                    02S0299
*                                                               02S0299
*                                  /*
         MVC   RRPAEPA(4,RRPAPTR),064+060(@13) RESTORE PREV RMEP
         LM    @06,@14,064+024(@13)    RELOAD INVOKING RTNE REGS
         BR    RTNREG                  RETURN TO INVOKER
         DROP  @15
*/*                                                          @Z40BPCH*/
*                                                               02S0300
*                                                               02S0300
*/* **************************************************************** */
*/*                                                                  */
*/*    ROUTINE NAME - IRARMWMY                                       */
*/*                                                                  */
*/*    DESCRIPTIVE NAME - SYSTEM RESOURCES MANAGER CNTRL ALGORITHM   */
*/*          PERIODIC ENTRY POINT INVOKE INITIALIZATION ROUTINE      */
*/*                                                                  */
*/*    FUNCTION - THE IRARMWMY ROUTINE TAKES THE EXISTING BCKWRDS    */
*/*          CHAINED ENTRY TIMING QUEUE LOCATED BY -RMCTTMQE- AND    */
*/*          REQUEUES ALL OF ITS MEMBERS, ADJUSTING THE TIME DUE     */
*/*          FIELD OF EACH BY THE DIFFERENCE BETWEEN -RMCTTOD-       */
*/*          AND -RMPTTOI-.  THIS EFFECTIVELY RESETS THE ENTIRE      */
*/*          QUEUE TO START ANEW BASED UPON THE CURRENT TIME.        */
*/*                                                                  */
*/* **************************************************************** */
*                                                               02S0300
*   /*****************************************************************/
*   /*                                                               */
*   /* IRARMWMY ROUTINE - ENTRY SEQUENCE ? IRACTLEP EPN(WMY)         */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0300
*   DCL                                                         02S0300
*     IRARMWMY ENTRY INT;                                       02S0300
*   GEN CODE DEFS(IRARMWMY) NOEXIT SEQFLOW;                     02S0301
*                                                               02S0301
*                                  /*
         ENTRY IRARMWMY
IRARMWMY DS    0H
         STM   @00,@14,128+000(@13)    SAVE INVOKING RTNE REGS
         LA    @12,IRARMWMY-@PSTART    DISPLACEMENT TO MODULE BASE
         LCR   @12,@12                 NEGATIVE FOR SUBTRACT
         ALR   @12,@15                 SETUP MODULE ADDRESSABILITY
*   /*****************************************************************/
*   /*                                                               */
*   /* CALCULATE AMT BY WHICH TO ADJUST SCHEDULED INVOCATION TIMES   */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0302
*   WKRO=RRPATOD-RMCATOI;           /* DELTA BETWEEN EXPECT AND GET  */
         L     @09,RRPATOD(,RRPAPTR)                            02S0302
         LR    WKRO,@09                                         02S0302
         SL    WKRO,RMCATOI(,RMCTPTR)                           02S0302
*   IF RRPATOD=WKRO THEN            /* RRPATOD NOT ALLOW TO BE ZERO  */
         CLR   @09,WKRO                                         02S0303
         BNE   @RF00303                                         02S0303
*     WKRO=WKRO-ONE;                /* INSURE RMCTTOD NOT MADE ZERO  */
         BCTR  WKRO,0                                           02S0304
*   IF RMCTTBS=WKRO THEN            /* RMCTTBS ZERO IF HAVEN'T INIT  */
@RF00303 CL    WKRO,RMCTTBS(,RMCTPTR)                           02S0305
         BNE   @RF00305                                         02S0305
*     WKRO=WKRO-ONE;                /* INSURE RMCTTBS NOT MADE ZERO  */
         BCTR  WKRO,0                                           02S0306
*   RMCTTBS=RMCTTBS-WKRO;           /* ADJUST RSRCS MNGR TIME BASE   */
@RF00305 L     @09,RMCTTBS(,RMCTPTR)                            02S0307
         SLR   @09,WKRO                                         02S0307
         ST    @09,RMCTTBS(,RMCTPTR)                            02S0307
*   RRPATOD=RRPATOD-WKRO;           /* ADJUST RSRCS MNGR CURR TIME   */
         L     @09,RRPATOD(,RRPAPTR)                            02S0308
         SLR   @09,WKRO                                         02S0308
         ST    @09,RRPATOD(,RRPAPTR)                            02S0308
*   RMCTTOD=RMCTTOD-WKRO;           /* ADJUST RSRCS MNGR CURR TIME   */
*                                                               02S0309
         L     @09,RMCTTOD(,RMCTPTR)                            02S0309
         SLR   @09,WKRO                                         02S0309
         ST    @09,RMCTTOD(,RMCTPTR)                            02S0309
*   /*****************************************************************/
*   /*                                                               */
*   /* START NEW TIMED ENTRY QUEUE BY CHAINING HEADER TO ITSELF      */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0310
*   RMEPPTR=RMCTTMQE;               /* PICK TIMED QUEUE HEADER ADDR  */
         L     RMEPPTR,RMCTTMQE(,RMCTPTR)                       02S0310
*   PMRE=RMEPBCK;                   /* PRESERVE PREVIOUS MEMBER ADR  */
         L     PMRE,RMEPBCK(,RMEPPTR)                           02S0311
*   RMEPFWD=RMEPPTR;                /* ENQUE FORWRD CHAIN TO HEADER  */
         ST    RMEPPTR,RMEPFWD(,RMEPPTR)                        02S0312
*   RMEPBCK=RMEPPTR;                /* ENQUE BCKWRD CHAIN TO HEADER  */
         ST    RMEPPTR,RMEPBCK(,RMEPPTR)                        02S0313
*   RMEPPTR=PMRE;                   /* PICK 1ST FORMER QUEUE MEMBER  */
*                                                               02S0314
         LR    RMEPPTR,PMRE                                     02S0314
*   /*****************************************************************/
*   /*                                                               */
*   /* STEP THROUGH MEMBERS OF PREVIOUS ENTRY TIMING QUE. ADJUST EACH*/
*   /* TO THE NEW TIME BASE, AND REQUE ONTO THE ENTRY TIMING QUEUE.  */
*   /* DONE STEPPING WHEN ARRIVE BACK AT QUEUE HEADER.               */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0315
*   DO WHILE(RMEPFLG^=EMPTY);                                   02S0315
         B     @DE00315                                         02S0315
@DL00315 DS    0H                                               02S0316
*     PMRE=RMEPBCK;                 /* PRESERVE PREVIOUS MEMBER ADR  */
         L     PMRE,RMEPBCK(,RMEPPTR)                           02S0316
*     CALL IRARMCQT;                /* REENQUE MEMBR ONTO TIMED QUE  */
         BAL   @14,IRARMCQT                                     02S0317
*     RMEPPTR=PMRE;                 /* PICK NXT FORMER QUEUE MEMBER  */
         LR    RMEPPTR,PMRE                                     02S0318
*   END;                                                        02S0319
*                                                               02S0319
@DE00315 L     @09,RMEPFLG(,RMEPPTR)                            02S0319
         LTR   @09,@09                                          02S0319
         BNZ   @DL00315                                         02S0319
*/*  THE SUBSEQUENT IRARMCET ROUTINE WILL RESET RMCTTOI AND RESET    */
*/*  THE TIMER EXPIRE SETTING FOR THE SYSTEM RESOURCES MANAGER.      */
*                                                               02S0320
*   /*****************************************************************/
*   /*                                                               */
*   /* IRARMWMY ROUTINE - EXIT SEQUENCE ? IRACTLEP ENN(WMY)          */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0320
*   GEN CODE EXIT NOSEQFLOW;                                    02S0320
*                                  /*
         LM    @00,@14,128+000(@13)    RELOAD INVOKING RTNE REGS
         BR    RTNREG                  RETURN TO INVOKER
*                                                               02S0321
*/* *********************************************************@Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/*   ROUTINE NAME - IRARMCAP                                @Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/*   DESCRIPTIVE NAME - SYSTEM RESOURCES MANAGER (SRM)      @Z40BPJC*/
*/*                      SWAP ANALYSIS ALGORITHM             @Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/*   FUNCTION - THE IRARMCAP ROUTINE ATTEMPTS TO KEEP THE   @Z40BPJC*/
*/*              MULTIPROGRAMMING LEVEL (MPL) PER DOMAIN AT  @Z40BPJC*/
*/*              ITS TARGET LEVEL.  THE TARGET MPL PER DOMAIN@Z40BPJC*/
*/*              IS THE DESIRED NUMBER OF MEMORIES BELONGING @Z40BPJC*/
*/*              TO THAT DOMAIN TO BE KEPT IN CORE.  IRARMCAP@Z40BPJC*/
*/*              ATTEMPTS TO MAINTAIN THE MPL PER DOMAIN AT  @Z40BPJC*/
*/*              ITS TARGET BY PERFORMING MEMORY SWAPS.      @Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/*   NOTE - IRARMCAP IS AN 'ALGORITHM' ROUTINE - I.E. IT HAS@Z40BPJC*/
*/*          A SYSTEM-WIDE SCOPE OF APPLICABILITY.  IRARMCAP @Z40BPJC*/
*/*          RUNS UNDER THE SRM LOCK.  IT IS A TIMED         @Z40BPJC*/
*/*          ALGORITHM AND IS ALSO INVOKED BY THE USERRDY AND@Z40BPJC*/
*/*          SWOUTCMP SYSEVENTS.                             @Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/*   INPUT - REG 1 CONTAINS THE ADDRESS OF RMEP FOR IRARMCAP@Z40BPJC*/
*/*         - REG 13 CONTAINS THE ADDRESS OF THE SAVE AREA   @Z40BPJC*/
*/*         STACK ASSOCIATED WITH THE SYSTEM RESOURCES       @Z40BPJC*/
*/*         MANAGER LOCK.                                    @Z40BPJC*/
*/*         - REG 14 CONTAINS THE RETURN ADDRESS.            @Z40BPJC*/
*/*         - REG 15 CONTAINS THE IRARMCAP ROUTINE ADDRESS.  @Z40BPJC*/
*/*         - THE OUCB OUT QUEUE CONTAINS USERS WHICH ARE    @Z40BPJC*/
*/*         CANDIDATES FOR SWAP-IN.                          @Z40BPJC*/
*/*         - THE OUCB IN QUEUE CONTAINS USERS WHICH ARE     @Z40BPJC*/
*/*         CANDIDATES FOR SWAP-OUT.                         @Z40BPJC*/
*/*         - THE DOMAIN TABLE CONTAINS THE TARGET MPL PER   @Z40BPJC*/
*/*         DOMAIN                                           @Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/*   OUTPUT - THE FOLLOWING DATA IS CALCULATED PER DOMAIN   @Z40BPJC*/
*/*            AND STORED IN THE DOMAIN TABLE:  THE CURRENT  @Z40BPJC*/
*/*            MPL, THE NUMBER OF SWAPPABLE INCORE USERS, THE@Z40BPJC*/
*/*            NUMBER OF OUT USERS, AND THE NUMBER OF USERS  @Z40BPJC*/
*/*            GOING OUT.  THESE COUNTS ARE UPDATED TO       @Z40BPJC*/
*/*            REFLECT CHANGES RESULTING FROM SWAPS.  THE    @Z40BPJC*/
*/*            STEPS OF THE SWAP ANALYSIS ARE DEFINED        @Z40BPJC*/
*/*            BELOW IN THE ORDER IN WHICH THEY ARE          @Z40BPJC*/
*/*            INVOKED.  ALL DOMAINS ARE CONSIDERED FOR EACH @Z40BPJC*/
*/*            STEP BEFORE PROCEEDING TO THE NEXT STEP.      @Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/*            1) FOR EACH DOMAIN, SWAP OUT THE REQUIRED     @Z40BPJC*/
*/*               NUMBER OF USERS TO DRIVE THE MPL DOWN TO   @Z40BPJC*/
*/*               ITS TARGET.  SELECT THE USERS WITH THE     @Z40BPJC*/
*/*               SMALLEST RECOMMENDATION VALUES.  IF ANY    @Z40BPJC*/
*/*               SWAPS ARE INITIATED BY STEP 1, THE OTHER   @ZA29015*/
*/*               STEPS ARE SKIPPED, AND THE ANALYSIS ENDS.  @ZA29015*/
*/*                                                          @Z40BPJC*/
*/*            2) IF THERE IS A USER ON THE OUT QUEUE        @Z40BPJC*/
*/*               ENQUEUED UPON A RESOURCE REQUESTED BY      @Z40BPJC*/
*/*               ANOTHER USER, OR BEING CANCELLED, SWAP IN  @Z40BPJC*/
*/*               THE USER IF THE MPL FOR ITS DOMAIN         @Z40BPJC*/
*/*               IS LESS THAN ITS TARGET.   OTHERWISE       @Z40BPJC*/
*/*               SWAP OUT THE INCORE USER IN THAT DOMAIN    @Z40PBJC*/
*/*               WITH THE SMALLEST RECOMMENDATION           @Z40BPJC*/
*/*               VALUE. IF NO INCORE USER IN                @Z40BPJC*/
*/*               THAT DOMAIN IS SWAPPABLE, SWAP IN          @Z40BPJC*/
*/*               THE OUT-OF-CORE USER ANYWAY.  IF A SWAP    @Z40BPJC*/
*/*               IS INITIATED BY STEP 2, THE REMAINING      @ZA29015*/
*/*               STEPS ARE SKIPPED, AND THE ANALYSIS ENDS.  @ZA29015*/
*/*                                                          @Z40BPJC*/
*/*            3) FOR EACH DOMAIN, SWAP IN THE REQUIRED      @Z40BPJC*/
*/*               NUMBER OF USERS TO RAISE THE MPL TO ITS    @Z40BPJC*/
*/*               TARGET VALUE.  SELECT THE USERS WITH THE   @Z49BPJC*/
*/*               LARGEST RECOMMENDATION VALUES.  IF ANY     @Z40BPJC*/
*/*               SWAPS ARE INITIATED BY STEP 3, STEP 4 IS   @ZA29015*/
*/*               SKIPPED, AND THE ANALYSIS ENDS.            @ZA29015*/
*/*                                                          @Z40BPJC*/
*/*            4) IF THE MPL FOR A DOMAIN IS EQUAL TO ITS    @Z40BPJC*/
*/*               TARGET, SELECT AN INCORE AND OUT OF CORE   @Z40BPJC*/
*/*               USER OF THE GIVEN DOMAIN TO EXCHANGE.  FIND@Z40BPJC*/
*/*               THE OUT OF CORE USER WITH THE LARGEST      @Z40BPJC*/
*/*               RECOMMENDATION VALUE AND THE INCORE USER   @Z40BPJC*/
*/*               WITH THE SMALLEST RECOMMENDATION VALUE.    @Z40BPJC*/
*/*               THE RECOMMENDATION VALUE OF THE OUT OF CORE@Z40BPJC*/
*/*               USER MUST EXCEED THE RECOMMENDATION VALUE  @Z40BPJC*/
*/*               OF THE INCORE USER BY A THRESHOLD.  IF AN  @Z40BPJC*/
*/*               EXCHANGE IS JUSTIFIED, A SWAPOUT OF THE    @Z40BPJC*/
*/*               INCORE USER IS INITIATED.  THE SWAPIN OF   @Z40BPJC*/
*/*               THE OUT OF CORE MEMORY MAY BE INITIATED    @Z40BPJC*/
*/*               UPON THE NEXT INVOCATION OF THE SWAP       @Z40BPJC*/
*/*               ANALYSIS ALGORITHM.                        @Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/*   EXIT - BRANCH ON REGISTER 14.                          @Z40BPJC*/
*/*          THERE IS NO ERROR EXIT OR INDICATION.           @Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/* *********************************************************@Z40BPJC*/
*                                                               02S0321
*   /*****************************************************************/
*   /*                                                               */
*   /* IRARMCAP ROUTINE - ENTRY SEQUENCE                     @Z40BPJC*/
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0321
*/*   ? IRACTLEP EPN(CAP)                                            */
*                                                               02S0321
*   DCL                                                         02S0321
*     IRARMCAP ENTRY INT;                                       02S0321
*   GEN CODE REFS(RRPAEPA) DEFS(IRARMCAP) NOEXIT SEQFLOW;       02S0322
*                                                               02S0322
*                                  /*
         ENTRY IRARMCAP
IRARMCAP DS    0H
         STM   @00,@14,000+000(@13)    SAVE INVOKING RTNE REGS
         ST    @01,RRPAEPA(,RRPAPTR)   INDICATE NEW CURRENT RMEP
         LA    @12,IRARMCAP-@PSTART    DISPLACEMENT TO MODULE BASE
         LCR   @12,@12                 NEGATIVE FOR SUBTRACT
         ALR   @12,@15                 SETUP MODULE ADDRESSABILITY
*   /*****************************************************************/
*   /*                                                               */
*   /*                                                       @Z40BPJC*/
*   /* REINITIALIZE DOMAIN TABLE                                     */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0323
*   RESPECIFY                                                   02S0323
*     DMDT BASED(DMDTPTR2);         /*                       @Z40BPJC*/
*   DO DMDTPTR2=RMCTDMDT BY LENGTH(DMDT) TO RMCTDMDE;/* DO EVERY
*                                      DOMAIN                @Z40BPJC*/
         L     DMDTPTR2,RMCTDMDT(,RMCTPTR)                      02S0324
         B     @DE00324                                         02S0324
@DL00324 DS    0H                                               02S0325
*     DMDTBLK1=0;                   /* ZERO NUMBER OF USERS GOING
*                                      OUT, CURRENT MPL      @Z40BPJC*/
         SLR   @09,@09                                          02S0325
         ST    @09,DMDTBLK1(,DMDTPTR2)                          02S0325
*     DMDTBLK2=0;                   /* NUMBER OF SWAPPABLE IN USERS
*                                      AND NUMBER OF OUT USERS  02S0326
*                                                            @Z40BPJC*/
         ST    @09,DMDTBLK2(,DMDTPTR2)                          02S0326
*   END;                            /*                       @Z40BPJC*/
*                                                               02S0327
         AL    DMDTPTR2,@CF02274                                02S0327
@DE00324 C     DMDTPTR2,RMCTDMDE(,RMCTPTR)                      02S0327
         BNH   @DL00324                                         02S0327
*   /*****************************************************************/
*   /*                                                               */
*   /* COUNT THREE TYPES OF USERS ON IN QUEUE:               @Z40BPJC*/
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0328
*   OUCBPTR=RMCTINQE->OUCBFWD;      /* SCAN QUEUE FRWRD      @Z40BPJC*/
         L     @09,RMCTINQE(,RMCTPTR)                           02S0328
         L     OUCBPTR,OUCBFWD(,@09)                            02S0328
*   DO WHILE OUCBSCN='0'B;          /* TO ITS END            @Z40BPJC*/
         B     @DE00329                                         02S0329
@DL00329 DS    0H                                               02S0330
*     DMDTPTR2=RMCTDMDT+OUCBDMO;    /* POINT TO CURRENT OUCB'S 'S
*                                      DOMAIN ENTRY          @Z40BPJC*/
         LH    DMDTPTR2,OUCBDMO(,OUCBPTR)                       02S0330
         AL    DMDTPTR2,RMCTDMDT(,RMCTPTR)                      02S0330
*     IF OUCBNSW='0'B&              /* COUNT ONLY VALID/SWAPPABLE    */
*         OUCBINV='0'B THEN         /* USERS                 @Z40BPCJ*/
         TM    OUCBNSW(OUCBPTR),B'10010000'                     02S0331
         BNZ   @RF00331                                         02S0331
*       DO;                         /*                       @Z40BPJC*/
*         IF(OUCBGOO='1'B|OUCBGOB='1'B) THEN                    02S0333
         TM    OUCBGOO(OUCBPTR),B'10100000'                     02S0333
         BZ    @RF00333                                         02S0333
*           DMDTGOOU=DMDTGOOU+1;    /* COUNT USERS GOING OUT @Z40BPJC*/
         LA    @09,1                                            02S0334
         AH    @09,DMDTGOOU(,DMDTPTR2)                          02S0334
         STH   @09,DMDTGOOU(,DMDTPTR2)                          02S0334
*         ELSE                                                  02S0335
*           DO;                     /*                       @Z40BPJC*/
         B     @RC00333                                         02S0335
@RF00333 DS    0H                                               02S0336
*             DMDTCMPL=DMDTCMPL+1;  /* INCLUDE IN CURRENT MPL   02S0336
*                                                            @Z40BPJC*/
         LA    @09,1                                            02S0336
         LH    @08,DMDTCMPL(,DMDTPTR2)                          02S0336
         ALR   @08,@09                                          02S0336
         STH   @08,DMDTCMPL(,DMDTPTR2)                          02S0336
*             IF OUCBENQ='0'B&OUCBBIB='0'B THEN                 02S0337
         TM    OUCBENQ(OUCBPTR),B'00100010'                     02S0337
         BNZ   @RF00337                                         02S0337
*               DMDTINCU=DMDTINCU+1;/* COUNT INCORE USERS    @Z40BPJC*/
         AH    @09,DMDTINCU(,DMDTPTR2)                          02S0338
         STH   @09,DMDTINCU(,DMDTPTR2)                          02S0338
*           END;                    /*                       @Z40BPJC*/
@RF00337 DS    0H                                               02S0340
*       END;                        /*                       @Z40BPJC*/
@RC00333 DS    0H                                               02S0341
*     OUCBPTR=OUCBFWD;              /* CHAIN THRU ALL OUCBS  @Z40BPJC*/
@RF00331 L     OUCBPTR,OUCBFWD(,OUCBPTR)                        02S0341
*   END;                            /*                       @Z40BPJC*/
*                                                               02S0342
@DE00329 TM    OUCBSCN(OUCBPTR),B'00000001'                     02S0342
         BZ    @DL00329                                         02S0342
*   /*****************************************************************/
*   /*                                                               */
*   /* EXAMINE OUT QUEUE FOR USERS IN EACH DOMAIN WHICH ARE OUT,     */
*   /* GOING IN, OUT WITH ENQ BIT OR CANCEL BIT ON.          @Z40BPJC*/
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0343
*   RMCACPW1=0;                     /* INITIALIZE POINTER TO OLDEST
*                                      ENQUEUED USER         @Z40BPJC*/
         SLR   @09,@09                                          02S0343
         ST    @09,RMCACPW1(,RMCTPTR)                           02S0343
*   OUCBPTR=RMCTOTQE->OUCBBCK;      /* START WITH YOUNGEST USER 02S0344
*                                                            @Z40BPJC*/
         L     @09,RMCTOTQE(,RMCTPTR)                           02S0344
         L     OUCBPTR,OUCBBCK(,@09)                            02S0344
*   DO WHILE OUCBSCN='0'B;          /* LOOP THROUGH OUCBS BACK TO HDR
*                                                            @Z40BPJC*/
         B     @DE00345                                         02S0345
@DL00345 DS    0H                                               02S0346
*     IF OUCBNSWI='0'B THEN         /* EXCLUDE TERMINATING USERS
*                                                            @ZA29015*/
         TM    OUCBNSWI(OUCBPTR),B'00001000'                    02S0346
         BNZ   @RF00346                                         02S0346
*       DO;                         /* FROM DOMAIN COUNTS    @ZA29015*/
*         DMDTPTR2=RMCTDMDT+OUCBDMO;/* POINT TO THIS OUCB'S DOMAIN
*                                                            @Z40BPJC*/
         LH    DMDTPTR2,OUCBDMO(,OUCBPTR)                       02S0348
         AL    DMDTPTR2,RMCTDMDT(,RMCTPTR)                      02S0348
*         IF OUCBGOI='1'B|OUCBGOB='1'B THEN                     02S0349
         TM    OUCBGOI(OUCBPTR),B'01100000'                     02S0349
         BZ    @RF00349                                         02S0349
*           DMDTCMPL=DMDTCMPL+1;    /* ADD 1 TO CURRENT MPL COUNT
*                                                            @Z40BPJC*/
         LA    @09,1                                            02S0350
         AH    @09,DMDTCMPL(,DMDTPTR2)                          02S0350
         STH   @09,DMDTCMPL(,DMDTPTR2)                          02S0350
*         ELSE                                                  02S0351
*           DO;                     /*                       @Z4OBPJC*/
         B     @RC00349                                         02S0351
@RF00349 DS    0H                                               02S0352
*             IF OUCBGOO='0'B THEN                              02S0352
         TM    OUCBGOO(OUCBPTR),B'10000000'                     02S0352
         BNZ   @RF00352                                         02S0352
*               DO;                 /* EXCLUDE GOING OUT USERS  02S0353
*                                                            @Z40BPJC*/
*                 DMDTOUTU=DMDTOUTU+1;/* ADD 1 TO OUT USER COUNT
*                                                            @Z40BPJC*/
         LA    @09,1                                            02S0354
         AH    @09,DMDTOUTU(,DMDTPTR2)                          02S0354
         STH   @09,DMDTOUTU(,DMDTPTR2)                          02S0354
*                 IF OUCBENQ='1'B|OUCBBIB='1'B THEN             02S0355
         TM    OUCBENQ(OUCBPTR),B'00100010'                     02S0355
         BZ    @RF00355                                         02S0355
*                   RMCACPW1=OUCBPTR;/* OLDEST OUCB FOUND SO FAR
*                                                            @Z40BPJC*/
         ST    OUCBPTR,RMCACPW1(,RMCTPTR)                       02S0356
*               END;                /*                       @Z40BPJC*/
*             ELSE                                              02S0358
*               DMDTGOOU=DMDTGOOU+1;/* COUNT USERS GOING OUT @Z40BPJC*/
         B     @RC00352                                         02S0358
@RF00352 LA    @09,1                                            02S0358
         AH    @09,DMDTGOOU(,DMDTPTR2)                          02S0358
         STH   @09,DMDTGOOU(,DMDTPTR2)                          02S0358
*           END;                    /*                       @Z40BPJC*/
@RC00352 DS    0H                                               02S0360
*       END;                        /* END DOMAIN COUNTS     @ZA29015*/
@RC00349 DS    0H                                               02S0361
*     OUCBPTR=OUCBBCK;              /* GET NEXT OLDER OUCB   @Z40BPJC*/
@RF00346 L     OUCBPTR,OUCBBCK(,OUCBPTR)                        02S0361
*   END;                            /*                       @Z40BPJC*/
@DE00345 TM    OUCBSCN(OUCBPTR),B'00000001'                     02S0362
         BZ    @DL00345                                         02S0362
*/* COUNTERS NOW UPDATED. RMCACPW1 HOLDS ADDRESS OF OLDEST OUCB 02S0363
*              ENQUEUED ON A RESOURCE                        @Z40BPJC*/
*                                                               02S0363
*                                                               02S0363
*   /*****************************************************************/
*   /*                                                               */
*   /* UNILATERAL SWAPOUT                                    @Z40BPJC*/
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0363
*   OUCBPTR=0;                      /* PTR = 0 SHOWS NO SWAPOUTS YET
*                                                            @Z40BPJC*/
         SLR   OUCBPTR,OUCBPTR                                  02S0363
*   DO DMDTPTR2=RMCTDMDT BY LENGTH(DMDT) TO RMCTDMDE;/* DO EVERY
*                                      DOMAIN                @Z40BPJC*/
         L     DMDTPTR2,RMCTDMDT(,RMCTPTR)                      02S0364
         B     @DE00364                                         02S0364
@DL00364 DS    0H                                               02S0365
*     DO WHILE DMDTCMPL>DMDTMPLT&   /* IN EACH DOMAIN REDUCE MPL TO
*                                      TARGET,               @Z40BPJC*/
*           DMDTINCU^=0;            /* IF THIS DOMAIN HAS USERS IN
*                                      CORE AND SWAPPABLE.   @Z40BPJC*/
         B     @DE00365                                         02S0365
@DL00365 DS    0H                                               02S0366
*       CALL IRARMCPO;              /* PICK BEST CANDIDATE FOR  02S0366
*                                      SWAPOUT. DMDTPTR2 HAS ADDRESS
*                                      OF DMDT ENTRY         @Z40BPJC*/
         BAL   @14,IRARMCPO                                     02S0366
*       IF OUCBPTR=0 THEN                                       02S0367
         LTR   OUCBPTR,OUCBPTR                                  02S0367
         BZ    @RT00367                                         02S0367
*         GO TO RMCAPEND;           /* CHK RETURN AND QUIT IF CPO
*                                      DETECTED A DOMAIN CHANGE 02S0368
*                                                            @Z40BPJC*/
*                                                               02S0368
*       /*************************************************************/
*       /*                                                           */
*       /* ? IRACTLCL EPN(CSO)                                       */
*       /*                                                           */
*       /*************************************************************/
*                                                               02S0369
*       DO;                                                     02S0369
*         R1=ADDR(RMEPBCSO);        /* CSO REQUEST IS PARAM          */
         LA    R1,RMEPBCSO(,RMCTPTR)                            02S0370
*         CALL RMSBCRY->IRARMRTN;   /* ACTION INVK FUNCT             */
         L     @15,RMSBCRY(,RMCTPTR)                            02S0371
         BALR  @14,@15                                          02S0371
*       END;                        /* SWAP OUT THE USER, OUCBPTR
*                                      NON-ZERO SHOWS SWPOUT         */
*       IF RTNCOD^=0 THEN                                       02S0373
         LTR   RTNCOD,RTNCOD                                    02S0373
         BNZ   @RT00373                                         02S0373
*         GO TO RMCAPEND;           /* QUIT ALGORITHM TO AVOID  02S0374
*                                      LOOPING               @Z40BPJC*/
*       OUCBSRC=SRCDUSSC;           /* SET SWAP REASON CODE  @Z40BPJC*/
         MVI   OUCBSRC(OUCBPTR),X'0A'                           02S0375
*       DMDTCMPL=DMDTCMPL-1;        /* MPL=MPL-1             @Z40BPJC*/
         LH    @09,DMDTCMPL(,DMDTPTR2)                          02S0376
         BCTR  @09,0                                            02S0376
         STH   @09,DMDTCMPL(,DMDTPTR2)                          02S0376
*       DMDTINCU=DMDTINCU-1;        /* IN USER CNT=CNT - 1   @Z40BPJC*/
         LH    @09,DMDTINCU(,DMDTPTR2)                          02S0377
         BCTR  @09,0                                            02S0377
         STH   @09,DMDTINCU(,DMDTPTR2)                          02S0377
*       DMDTGOOU=DMDTGOOU+1;        /* USER GOING OUT CNT=CNT+1 02S0378
*                                                            @Z40BPJC*/
         LA    @09,1                                            02S0378
         AH    @09,DMDTGOOU(,DMDTPTR2)                          02S0378
         STH   @09,DMDTGOOU(,DMDTPTR2)                          02S0378
*     END;                          /*                       @Z40BPJC*/
@DE00365 LH    @09,DMDTCMPL(,DMDTPTR2)                          02S0379
         CH    @09,DMDTMPLT(,DMDTPTR2)                          02S0379
         BNH   @DC00365                                         02S0379
         LH    @09,DMDTINCU(,DMDTPTR2)                          02S0379
         LTR   @09,@09                                          02S0379
         BNZ   @DL00365                                         02S0379
@DC00365 DS    0H                                               02S0380
*   END;                            /* END OF DO LOOP        @Z40BPJC*/
         AL    DMDTPTR2,@CF02274                                02S0380
@DE00364 C     DMDTPTR2,RMCTDMDE(,RMCTPTR)                      02S0380
         BNH   @DL00364                                         02S0380
*   IF OUCBPTR^=0 THEN                                          02S0381
         SLR   @09,@09                                          02S0381
         CR    OUCBPTR,@09                                      02S0381
         BNE   @RT00381                                         02S0381
*     GO TO RMCAPEND;               /* IF ANY SWAPS, END ALGORITHM
*                                                            @Z40BPJC*/
*                                                               02S0383
*   /*****************************************************************/
*   /*                                                               */
*   /* EXPRESS SWAP IN FOR USER ENQUEUED ON RESOURCE OR BEING        */
*   /* CANCELLED                                             @Z40BPJC*/
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0383
*   IF RMCACPW1^=0 THEN                                         02S0383
         L     @08,RMCACPW1(,RMCTPTR)                           02S0383
         CR    @08,@09                                          02S0383
         BE    @RF00383                                         02S0383
*     DO;                           /* LOOK IN FLD FOR ADDR OF  02S0384
*                                                            @Z40BPJC*/
*       OUCBPTR=RMCACPW1;           /* OUCB OF PREVIOUSLY-SELECTED
*                                      USR                   @Z40BPJC*/
         LR    OUCBPTR,@08                                      02S0385
*       DMDTPTR2=RMCTDMDT+OUCBDMO;  /* POINT TO USER'S DOMAIN   02S0386
*                                                            @Z40BPJC*/
         LH    DMDTPTR2,OUCBDMO(,OUCBPTR)                       02S0386
         AL    DMDTPTR2,RMCTDMDT(,RMCTPTR)                      02S0386
*       IF DMDTCMPL^<DMDTMPLT&      /* MPL GTR THAN OR = TO TARGT
*                                                            @Z40BPJC*/
*           DMDTINCU^=0 THEN                                    02S0387
         LH    @08,DMDTCMPL(,DMDTPTR2)                          02S0387
         CH    @08,DMDTMPLT(,DMDTPTR2)                          02S0387
         BL    @RF00387                                         02S0387
         CH    @09,DMDTINCU(,DMDTPTR2)                          02S0387
         BE    @RF00387                                         02S0387
*         DO;                       /* AND AT LEAST ONE IN USER 02S0388
*                                      (DOMAIN OF ENQUEUED USER IN
*                                      DMDTPTR2)             @Z40BPJC*/
*           CALL IRARMCPO;          /* SELECT USER TO SWAP OUT TO
*                                      MAKE ROOM             @Z40BPJC*/
         BAL   @14,IRARMCPO                                     02S0389
*           IF OUCBPTR^=0 THEN                                  02S0390
         LTR   OUCBPTR,OUCBPTR                                  02S0390
         BZ    @RF00390                                         02S0390
*             DO;                   /* UNLESS DOMAIN CHANGE, @Z40BPJC*/
*                                                               02S0391
*               /*****************************************************/
*               /*                                                   */
*               /* ? IRACTLCL EPN(CSO)                               */
*               /*                                                   */
*               /*****************************************************/
*                                                               02S0392
*               DO;                                             02S0392
*                 R1=ADDR(RMEPBCSO);/* CSO REQUEST IS PARAM          */
         LA    R1,RMEPBCSO(,RMCTPTR)                            02S0393
*                 CALL RMSBCRY->IRARMRTN;/* ACTION INVK FUNCT        */
         L     @15,RMSBCRY(,RMCTPTR)                            02S0394
         BALR  @14,@15                                          02S0394
*               END;                /* MAKE ROOM FOR ENQUEUED USR
*                                                            @Z40BPJC*/
*               IF RTNCOD=0 THEN                                02S0396
         LTR   RTNCOD,RTNCOD                                    02S0396
         BNZ   @RF00396                                         02S0396
*                 DO;                                           02S0397
*                   OUCBSRC=SRCDNQSC;/* SET REASON COD AND   @Z40BPJC*/
         MVI   OUCBSRC(OUCBPTR),X'08'                           02S0398
*                   DMDTCMPL=DMDTCMPL-1;/* MPL=MPL-1         @Z40BPJC*/
         LH    @09,DMDTCMPL(,DMDTPTR2)                          02S0399
         BCTR  @09,0                                            02S0399
         STH   @09,DMDTCMPL(,DMDTPTR2)                          02S0399
*                   DMDTINCU=DMDTINCU-1;/* IN USER CNT=CNT - 1  02S0400
*                                                            @Z40BPJC*/
         LH    @09,DMDTINCU(,DMDTPTR2)                          02S0400
         BCTR  @09,0                                            02S0400
         STH   @09,DMDTINCU(,DMDTPTR2)                          02S0400
*                   DMDTGOOU=DMDTGOOU+1;/* USER GOING OUT CNT=CNT+1
*                                                            @Z40BPJC*/
         LA    @09,1                                            02S0401
         AH    @09,DMDTGOOU(,DMDTPTR2)                          02S0401
         STH   @09,DMDTGOOU(,DMDTPTR2)                          02S0401
*                   GO TO RMCAPEND; /* QUIT ALGORITHM        @Z40BPJC*/
         B     RMCAPEND                                         02S0402
*                 END;              /*                       @Z40BPJC*/
*             END;                  /*                       @Z40BPJC*/
@RF00396 DS    0H                                               02S0405
*           OUCBPTR=RMCACPW1;       /* RESTORE OUCB OF PREVIOUSLY
*                                      SELECTED ENQUEUED USER   02S0405
*                                                            @Z40BPJC*/
@RF00390 L     OUCBPTR,RMCACPW1(,RMCTPTR)                       02S0405
*         END;                      /*                       @Z40BPJC*/
*                                                               02S0406
*       /*************************************************************/
*       /*                                                           */
*       /* ? IRACTLCL EPN(CSI)                                       */
*       /*                                                           */
*       /*************************************************************/
*                                                               02S0407
*       DO;                                                     02S0407
@RF00387 DS    0H                                               02S0408
*         R1=ADDR(RMEPBCSI);        /* CSI REQUEST IS PARAM          */
         LA    R1,RMEPBCSI(,RMCTPTR)                            02S0408
*         CALL RMSBCRY->IRARMRTN;   /* ACTION INVK FUNCT             */
         L     @15,RMSBCRY(,RMCTPTR)                            02S0409
         BALR  @14,@15                                          02S0409
*       END;                        /* SWAP IN ENQUEUED USER @Z40BPJC*/
*       IF RTNCOD=0 THEN                                        02S0411
         LTR   RTNCOD,RTNCOD                                    02S0411
         BNZ   @RF00411                                         02S0411
*         DO;                       /*                       @Z40BPJC*/
*           DMDTCMPL=DMDTCMPL+1;    /* MPL=MPL+1             @Z40BPJC*/
         LA    @09,1                                            02S0413
         AH    @09,DMDTCMPL(,DMDTPTR2)                          02S0413
         STH   @09,DMDTCMPL(,DMDTPTR2)                          02S0413
*           DMDTOUTU=DMDTOUTU-1;    /* OUT USER CNT=CNT - 1  @Z40BPJC*/
         LH    @09,DMDTOUTU(,DMDTPTR2)                          02S0414
         BCTR  @09,0                                            02S0414
         STH   @09,DMDTOUTU(,DMDTPTR2)                          02S0414
*         END;                      /*                       @Z40BPJC*/
*       GO TO RMCAPEND;             /* END ALGORITHM         @Z40BPJC*/
         B     RMCAPEND                                         02S0416
*     END;                          /*                       @Z40BPJC*/
*                                                               02S0418
*   /*****************************************************************/
*   /*                                                               */
*   /* UNILATERAL SWAP IN                                    @Z40BPJC*/
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0418
*   OUCBPTR=0;                      /* SET SWAPIN SWITCH TO ZERO
*                                                            @Z40BPJC*/
@RF00383 SLR   OUCBPTR,OUCBPTR                                  02S0418
*   DO DMDTPTR2=RMCTDMDT BY LENGTH(DMDT) TO RMCTDMDE;/* DO EVERY
*                                      DOMAIN                @Z40BPJC*/
         L     DMDTPTR2,RMCTDMDT(,RMCTPTR)                      02S0419
         B     @DE00419                                         02S0419
@DL00419 DS    0H                                               02S0420
*     DO WHILE(DMDTCMPL+DMDTGOOU<DMDTMPLT)&DMDTOUTU^=0;/* CONSIDER
*                                      MPL TO INCLUDE IN USERS, AND
*                                      USERS GOING OUT AND BE SURE
*                                      THERE ARE USERS ELIGIBLE FOR
*                                      SWAPIN. PASS ADDRESS OF DOMAIN
*                                      TABLE ENTRY OF THIS DOMAIN IN
*                                      DMDTPTR2              @Z40BPJC*/
         B     @DE00420                                         02S0420
@DL00420 DS    0H                                               02S0421
*       CALL IRARMCPI;              /* SELECT USER           @Z40BPJC*/
         BAL   @14,IRARMCPI                                     02S0421
*       IF OUCBPTR=0 THEN           /* CHK RETURNED USER ADDR.       */
         LTR   OUCBPTR,OUCBPTR                                  02S0422
         BZ    @RT00422                                         02S0422
*         GO TO RMCAPEND;           /* FOR DOMAIN CHANGE     @Z40BPJC*/
*                                                               02S0423
*       /*************************************************************/
*       /*                                                           */
*       /* ? IRACTLCL EPN(CSI)                                       */
*       /*                                                           */
*       /*************************************************************/
*                                                               02S0424
*       DO;                                                     02S0424
*         R1=ADDR(RMEPBCSI);        /* CSI REQUEST IS PARAM          */
         LA    R1,RMEPBCSI(,RMCTPTR)                            02S0425
*         CALL RMSBCRY->IRARMRTN;   /* ACTION INVK FUNCT             */
         L     @15,RMSBCRY(,RMCTPTR)                            02S0426
         BALR  @14,@15                                          02S0426
*       END;                        /* SWAP IN SELECTED USER @Z40BPJC*/
*       IF RTNCOD^=0 THEN                                       02S0428
         LTR   RTNCOD,RTNCOD                                    02S0428
         BNZ   @RT00428                                         02S0428
*         GO TO RMCAPEND;           /* QUIT                  @Z40BPJC*/
*       DMDTCMPL=DMDTCMPL+1;        /* MPL=MPL+1             @Z40BPJC*/
         LA    @09,1                                            02S0430
         AH    @09,DMDTCMPL(,DMDTPTR2)                          02S0430
         STH   @09,DMDTCMPL(,DMDTPTR2)                          02S0430
*       DMDTOUTU=DMDTOUTU-1;        /* OUT USER CNT=CNT - 1  @Z40BPJC*/
         LH    @09,DMDTOUTU(,DMDTPTR2)                          02S0431
         BCTR  @09,0                                            02S0431
         STH   @09,DMDTOUTU(,DMDTPTR2)                          02S0431
*     END;                          /*                       @Z40BPJC*/
@DE00420 LH    @09,DMDTCMPL(,DMDTPTR2)                          02S0432
         AH    @09,DMDTGOOU(,DMDTPTR2)                          02S0432
         CH    @09,DMDTMPLT(,DMDTPTR2)                          02S0432
         BNL   @DC00420                                         02S0432
         LH    @09,DMDTOUTU(,DMDTPTR2)                          02S0432
         LTR   @09,@09                                          02S0432
         BNZ   @DL00420                                         02S0432
@DC00420 DS    0H                                               02S0433
*   END;                            /*                       @Z40BPJC*/
         AL    DMDTPTR2,@CF02274                                02S0433
@DE00419 C     DMDTPTR2,RMCTDMDE(,RMCTPTR)                      02S0433
         BNH   @DL00419                                         02S0433
*   IF OUCBPTR^=0 THEN                                          02S0434
         LTR   OUCBPTR,OUCBPTR                                  02S0434
         BNZ   @RT00434                                         02S0434
*     GO TO RMCAPEND;               /* IF ANY SWAPS, END ALGORITHM
*                                                            @Z40BPJC*/
*                                                               02S0436
*   /*****************************************************************/
*   /*                                                               */
*   /* EXCHANGE SWAP INITIATION                              @Z40BPJC*/
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0436
*   DO DMDTPTR2=RMCTDMDT BY LENGTH(DMDT) TO RMCTDMDE;/* DO ALL  02S0436
*                                      DOMAINS UNTIL SWAP EXCHANGE
*                                      INITIATED             @Z40BPJC*/
         L     DMDTPTR2,RMCTDMDT(,RMCTPTR)                      02S0436
         B     @DE00436                                         02S0436
@DL00436 DS    0H                                               02S0437
*     IF(DMDTCMPL=DMDTMPLT&         /* MPL ON TARGET AND     @Z40BPJC*/
*         DMDTOUTU^=0&              /* AT LEAST ONE OUT USER @Z40BPJC*/
*         DMDTINCU^=0)              /* AND AT LEAST ONE IN USER 02S0437
*                                                            @Z40BPJC*/
*       THEN                                                    02S0437
         CLC   DMDTCMPL(2,DMDTPTR2),DMDTMPLT(DMDTPTR2)          02S0437
         BNE   @RF00437                                         02S0437
         SLR   @09,@09                                          02S0437
         CH    @09,DMDTOUTU(,DMDTPTR2)                          02S0437
         BE    @RF00437                                         02S0437
         CH    @09,DMDTINCU(,DMDTPTR2)                          02S0437
         BE    @RF00437                                         02S0437
*       DO;                         /* PASS DOMAIN ENTRY IN DMDTPTR2
*                                                            @Z40BPJC*/
*         CALL IRARMCPI;            /* SELECT BEST CAND FOR SWAP IN
*                                                            @Z40BPJC*/
         BAL   @14,IRARMCPI                                     02S0439
*         IF OUCBPTR=0 THEN                                     02S0440
         LTR   OUCBPTR,OUCBPTR                                  02S0440
         BZ    @RT00440                                         02S0440
*           GO TO RMCAPEND;         /* TERMINATE ALGORITHM   @Z40BPJC*/
*         ELSE                                                  02S0442
*           DO;                     /*                       @Z40PBJC*/
*             RMCACPW1=OUCBPTR;     /* SAVE ADDR OUCB PICKED FOR
*                                      SWAPIN. PASS DOMAIN ENTRY IN
*                                      DMDTPTR2              @Z40BPJC*/
         ST    OUCBPTR,RMCACPW1(,RMCTPTR)                       02S0443
*             CALL IRARMCPO;        /* SELECT SWAP OUT CANDIDATE
*                                                            @Z40BPJC*/
         BAL   @14,IRARMCPO                                     02S0444
*             IF OUCBPTR=0 THEN                                 02S0445
         LTR   OUCBPTR,OUCBPTR                                  02S0445
         BZ    @RT00445                                         02S0445
*               GO TO RMCAPEND;     /* TERMINATE ALGORITHM   @Z40BPJC*/
*             ELSE                                              02S0447
*               IF(RMCACPW1->OUCBCMRV-OUCBCMRV>RMPTXCHT) THEN   02S0447
         L     @09,RMCACPW1(,RMCTPTR)                           02S0447
         L     @09,OUCBCMRV(,@09)                               02S0447
         SL    @09,OUCBCMRV(,OUCBPTR)                           02S0447
         C     @09,RMPTXCHT(,RMCTPTR)                           02S0447
         BNH   @RF00447                                         02S0447
*                 DO;               /* RV DIFFERENCE EXCEEDS THRESH
*                                                            @Z40BPJC*/
*                                                               02S0448
*                   /*************************************************/
*                   /*                                               */
*                   /* ? IRACTLCL EPN(CSO)                           */
*                   /*                                               */
*                   /*************************************************/
*                                                               02S0449
*                   DO;                                         02S0449
*                     R1=ADDR(RMEPBCSO);/* CSO REQUEST IS PARAM      */
         LA    R1,RMEPBCSO(,RMCTPTR)                            02S0450
*                     CALL RMSBCRY->IRARMRTN;/* ACTION INVK FUNCT    */
         L     @15,RMSBCRY(,RMCTPTR)                            02S0451
         BALR  @14,@15                                          02S0451
*                   END;            /* SWAP OUT              @Z40BPJC*/
*                   IF RTNCOD=0 THEN                            02S0453
         LTR   RTNCOD,RTNCOD                                    02S0453
         BNZ   @RF00453                                         02S0453
*                     DO;                                       02S0454
*                       OUCBSRC=SRCDEXSC;/* SET SWAP REASON CODE
*                                                            @Z40BPJC*/
         MVI   OUCBSRC(OUCBPTR),X'09'                           02S0455
*                       DMDTCMPL=DMDTCMPL-1;/* MPL=MPL-1     @Z40BPJC*/
         LH    @09,DMDTCMPL(,DMDTPTR2)                          02S0456
         BCTR  @09,0                                            02S0456
         STH   @09,DMDTCMPL(,DMDTPTR2)                          02S0456
*                       DMDTINCU=DMDTINCU-1;/* IN USER CNT=CNT - 1
*                                                            @Z40BPJC*/
         LH    @09,DMDTINCU(,DMDTPTR2)                          02S0457
         BCTR  @09,0                                            02S0457
         STH   @09,DMDTINCU(,DMDTPTR2)                          02S0457
*                       DMDTGOOU=DMDTGOOU+1;/* USER GOING OUT   02S0458
*                                      CNT=CNT+1             @Z40BPJC*/
         LA    @09,1                                            02S0458
         AH    @09,DMDTGOOU(,DMDTPTR2)                          02S0458
         STH   @09,DMDTGOOU(,DMDTPTR2)                          02S0458
*                     END;          /*                       @Z40BPJC*/
*                   GO TO RMCAPEND; /* INDICATE ALGORITHM END   02S0460
*                                                            @Z40BPJC*/
         B     RMCAPEND                                         02S0460
*                 END;              /*                       @Z40BPJC*/
*           END;                    /*                       @Z40BPJC*/
@RF00447 DS    0H                                               02S0463
*       END;                        /*                       @Z40BPJC*/
*   END;                            /*                       @Z40BPJC*/
*                                                               02S0464
@RF00437 AL    DMDTPTR2,@CF02274                                02S0464
@DE00436 C     DMDTPTR2,RMCTDMDE(,RMCTPTR)                      02S0464
         BNH   @DL00436                                         02S0464
*   /*****************************************************************/
*   /*                                                               */
*   /* RETURN - ALGORITHM END                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0465
*RMCAPEND:                                                      02S0465
*                                                               02S0465
*   /*****************************************************************/
*   /*                                                               */
*   /* ? IRACTLEP ENN(CAP)                                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0465
*   GEN CODE EXIT NOSEQFLOW;                                    02S0465
*                                                               02S0465
RMCAPEND DS    0H                                               02S0465
*                                  /*
         LM    @00,@14,000+000(@13)    RELOAD INVOKING RTNE REGS
         BR    RTNREG                  RETURN TO INVOKER
*   /*****************************************************************/
*   /*                                                               */
*   /*                                                       @Z40BPJC*/
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0466
*                                                               02S0466
*/***********************************************************@Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/*   ROUTINE NAME - IRARMCPI                                @Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/*   DESCRIPTIVE NAME - SYSTEM RESOURCES MANAGER (SRM)      @Z40BPJC*/
*/*                      PICK SWAP-IN CANDIDATE SUBROUTINE   @Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/*   FUNCTION - THE IRARMCPI ROUTINE SCANS THE OUT QUEUE FOR@Z40BPJC*/
*/*              THE USER, BELONGING TO A SPECIFIED DOMAIN,  @Z40BPJC*/
*/*              WITH THE HIGHEST RECOMMENDATION VALUE.      @Z40BPJC*/
*/*              SUBROUTINE IRARMCVL IS CALLED TO COMPUTE A  @Z40BPJC*/
*/*              CURRENT SWAP RECOMMENDATION VALUE FOR EACH  @Z40BPJC*/
*/*              USER EVALUATED.                             @Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/*   INPUT - REGISTER DMDTPTR2 CONTAINS THE ADDRESS OF THE  @Z40BPJC*/
*/*           DOMAIN TABLE ENTRY CORRESPONDING TO THE        @Z40BPJC*/
*/*           SPECIFIED DOMAIN.                              @Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/*   OUTPUT - REGISTER 4(OUCBPTR) WILL CONTAIN THE ADDRESS  @Z40BPJC*/
*/*            OF THE OUCB HAVING THE HIGHEST RECOMMENDATION @Z40PBJC*/
*/*            VALUE IN THE SPECIFIED DOMAIN.                @Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/*   EXIT NORMAL - BRANCH ON REGISTER 14.                   @Z40BPJC*/
*/*                 REGISTER 4 IS NON-ZERO.                  @Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/*   EXIT ERROR - REGISTER 4 IS 0.                          @Z40BPJC*/
*/*                A DOMAIN CHANGE OCCURRED.                 @Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/***********************************************************@Z40BPJC*/
*                                                               02S0466
*IRARMCPI:                                                      02S0466
*   PROCEDURE OPTIONS(NOSAVE,NOSAVEAREA,NOENTREG,RETREG,NOPARMREG);/*
*                                                            @Z40BPJC*/
*                                                               02S0466
IRARMCPI DS    0H                                               02S0467
*   /*****************************************************************/
*   /*                                                               */
*   /* INITIAL PTR AND SWITCH SETTING                        @Z40BPJC*/
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0467
*   WKRE=RTNREG;                    /* SAVE RETURN REGISTER  @Z40BPJC*/
         LR    WKRE,RTNREG                                      02S0467
*   RESPECIFY                                                   02S0468
*     CPICKPTR RSTD;                /*                       @Z40BPJC*/
*   CPICKPTR=0;                     /* INITIALIZE PTR TO SHOW OUCB
*                                      NOT YET FOUND         @Z40BPJC*/
         SLR   CPICKPTR,CPICKPTR                                02S0469
*   DMDTPTR2=DMDTPTR2-RMCTDMDT;     /* CONVERT ADDR TO OFFSET   02S0470
*                                                            @Z40BPJC*/
         SL    DMDTPTR2,RMCTDMDT(,RMCTPTR)                      02S0470
*   RMCTCPS1='0'B;                  /* DOMAIN CHANGE SWITCH OFF 02S0471
*                                                            @Z40BPJC*/
*                                                               02S0471
         NI    RMCTCPS1(RMCTPTR),B'10111111'                    02S0471
*   /*****************************************************************/
*   /*                                                               */
*   /* FIND OUCBS ON OUT QUEUE IN THIS DOMAIN                @Z40BPJC*/
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0472
*   OUCBPTR=RMCTOTQE->OUCBFWD;      /* SCAN OUT QUEUE FORWARD   02S0472
*                                                            @Z40BPJC*/
         L     @09,RMCTOTQE(,RMCTPTR)                           02S0472
         L     OUCBPTR,OUCBFWD(,@09)                            02S0472
*   DO WHILE OUCBSCN='0'B;          /* ALL THE WAY TO END    @Z40BPJC*/
         B     @DE00473                                         02S0473
@DL00473 DS    0H                                               02S0474
*     IF OUCBNSWI='0'B&             /* EXCLUDE TERMINATING USERS
*                                                            @ZA29015*/
*         DMDTPTR2=OUCBDMO&         /* IF OUCB IN THIS DOMAIN,       */
*         OUCBGOI='0'B&             /* NOT GOING IN                  */
*         OUCBGOO='0'B&             /* OR OUT                        */
*         OUCBGOB='0'B              /* AND NOT TRANSITIONING         */
*       THEN                                                    02S0474
         TM    OUCBNSWI(OUCBPTR),B'00001000'                    02S0474
         BNZ   @RF00474                                         02S0474
         CH    DMDTPTR2,OUCBDMO(,OUCBPTR)                       02S0474
         BNE   @RF00474                                         02S0474
         TM    OUCBGOI(OUCBPTR),B'11100000'                     02S0474
         BNZ   @RF00474                                         02S0474
*       DO;                         /*                       @Z40BPJC*/
*         IF(RRPATOD-OUCBTMA)>RMPTSAET|/* IF WMR TOO OLD             */
*             OUCBRMA='1'B THEN     /* OR RTB = 1 (NEED I/O OR CPU
*                                      RV)                   @Z40BPJC*/
         L     @09,RRPATOD(,RRPAPTR)                            02S0476
         SL    @09,OUCBTMA(,OUCBPTR)                            02S0476
         CL    @09,RMPTSAET(,RMCTPTR)                           02S0476
         BH    @RT00476                                         02S0476
         TM    OUCBRMA(OUCBPTR),B'00100000'                     02S0476
         BNO   @RF00476                                         02S0476
@RT00476 DS    0H                                               02S0477
*           CALL IRARMCVL;          /* CALL CVL TO CMPUT NEW CMPS RV
*                                                            @Z40BPJC*/
         BAL   @14,IRARMCVL                                     02S0477
*         ELSE                                                  02S0478
*           OUCBCMRV=OUCBWMR;       /* OR USE OLD WMR AS COMPOSITE
*                                      SINCE RTB = 0         @Z40BPJC*/
         B     @RC00476                                         02S0478
@RF00476 L     @09,OUCBWMR(,OUCBPTR)                            02S0478
         ST    @09,OUCBCMRV(,OUCBPTR)                           02S0478
*         IF RMCTCPS1='0'B THEN                                 02S0479
@RC00476 TM    RMCTCPS1(RMCTPTR),B'01000000'                    02S0479
         BNZ   @RF00479                                         02S0479
*           DO;                     /* NO PREVIOUS DOMAIN CHANGE
*                                                            @Z40BPJC*/
*             IF DMDTPTR2^=OUCBDMO THEN                         02S0481
         CH    DMDTPTR2,OUCBDMO(,OUCBPTR)                       02S0481
         BE    @RF00481                                         02S0481
*               DO;                 /* IF THIS OUCB'S DOMAIN CHANGED,
*                                                            @Z40BPJC*/
*                 RMCTCPS1='1'B;    /* SIGNAL TO QUIT SRCH FOR HI RV
*                                                            @Z40BPJC*/
         OI    RMCTCPS1(RMCTPTR),B'01000000'                    02S0483
*                 CPICKPTR=0;       /* SET RETURN CODE TO SHOW NO
*                                      OUCB                  @Z40BPJC*/
*                                                               02S0484
         SLR   CPICKPTR,CPICKPTR                                02S0484
*                 /***************************************************/
*                 /*                                                 */
*                 /* ? IRACTLCL EPN(CAP)                             */
*                 /*                                                 */
*                 /***************************************************/
*                                                               02S0485
*                 DO;                                           02S0485
*                   R1=ADDR(RMEPBCAP);/* CAP REQUEST IS PARAM        */
         LA    R1,RMEPBCAP(,RMCTPTR)                            02S0486
*                   CALL RMSBCRL->IRARMRTN;/* ALGRTHM SCH FUNCT      */
         L     @15,RMSBCRL(,RMCTPTR)                            02S0487
         BALR  @14,@15                                          02S0487
*                 END;              /* ENSURE CAP REDRIVE SOON       */
*               END;                /*                       @Z40BPJC*/
*             ELSE                                              02S0490
*               DO;                 /* NO DOMAIN CHG FOUND BY CVL
*                                                            @Z40BPJC*/
         B     @RC00481                                         02S0490
@RF00481 DS    0H                                               02S0491
*                 IF CPICKPTR=0|(OUCBCMRV>CPICKPTR->OUCBCMRV) THEN
         LTR   CPICKPTR,CPICKPTR                                02S0491
         BZ    @RT00491                                         02S0491
         L     @09,OUCBCMRV(,OUCBPTR)                           02S0491
         C     @09,OUCBCMRV(,CPICKPTR)                          02S0491
         BNH   @RF00491                                         02S0491
@RT00491 DS    0H                                               02S0492
*                   CPICKPTR=OUCBPTR;/* USE HIGHR RV OF TWO. IF 02S0492
*                                      EQUAL, USE OLDER OUCB @Z40BPJC*/
         LR    CPICKPTR,OUCBPTR                                 02S0492
*               END;                /*                       @Z40BPJC*/
@RF00491 DS    0H                                               02S0494
*           END;                    /*                       @Z40BPJC*/
@RC00481 DS    0H                                               02S0495
*       END;                        /*                       @Z40BPJC*/
@RF00479 DS    0H                                               02S0496
*     OUCBPTR=OUCBFWD;              /* CONTINUE FORWARD SCAN @Z40BPJC*/
@RF00474 L     OUCBPTR,OUCBFWD(,OUCBPTR)                        02S0496
*   END;                            /*                       @Z40BPJC*/
@DE00473 TM    OUCBSCN(OUCBPTR),B'00000001'                     02S0497
         BZ    @DL00473                                         02S0497
*   OUCBPTR=CPICKPTR;               /* PASS BACK SELECTED OUCB  02S0498
*                                                            @Z40BPJC*/
         LR    OUCBPTR,CPICKPTR                                 02S0498
*   DMDTPTR2=DMDTPTR2+RMCTDMDT;     /* CONVERT BACK TO ADDR. @Z40BPJC*/
         AL    DMDTPTR2,RMCTDMDT(,RMCTPTR)                      02S0499
*   RTNREG=WKRE;                    /* RESTORE RETURN REGISTER  02S0500
*                                                            @Z40BPJC*/
         LR    RTNREG,WKRE                                      02S0500
*   RESPECIFY                                                   02S0501
*     CPICKPTR UNRSTD;              /*                       @Z40BPJC*/
*   END IRARMCPI;                   /*                       @Z40BPJC*/
@EL00005 DS    0H                                               02S0502
@EF00005 DS    0H                                               02S0502
@ER00005 BR    @14                                              02S0502
*                                                               02S0503
*/***********************************************************@Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/*   ROUTINE NAME - IRARMCPO                                @Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/*   DESCRIPTIVE NAME - SYSTEM RESOURCES MANAGER (SRM)      @Z40BPJC*/
*/*                      PICK SWAP-OUT CANDIDATE SUBROUTINE  @Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/*   FUNCTION - THE IRARMCPO ROUTINE SCANS THE IN QUEUE FOR @Z40BPJC*/
*/*              THE USER, BELONGING TO A SPECIFIED DOMAIN,  @Z40BPJC*/
*/*              WITH THE LOWEST RECOMMENDATION VALUE.       @Z40BPJC*/
*/*              SUBROUTINE IRARMCVL IS CALLED TO COMPUTE    @Z40BPJC*/
*/*              A CURRENT SWAP RECOMMENDATION VALUE FOR     @Z40BPJC*/
*/*              EACH USER EVALUATED.                        @Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/*   INPUT  - REGISTER DMDTPTR2 CONTAINS THE ADDRESS OF THE @Z40BPJC*/
*/*            DOMAIN TABLE ENTRY CORRESPONDING TO THE       @Z40BPJC*/
*/*            SPECIFIED DOMAIN.                             @Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/*   OUTPUT - REGISTER 4(OUCBPTR) WILL CONTAIN THE ADDRESS  @Z40BPJC*/
*/*            OF THE OUCB HAVING THE LOWEST RECOMMENDATION  @Z40BPJC*/
*/*            VALUE IN THE SPECIFIED DOMAIN.                @Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/*   EXIT NORMAL - BRANCH ON REGISTER 14.                   @Z40BPJC*/
*/*                 REGISTER 4 IS NON-ZERO.                  @Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/*   EXIT ERROR - REGISTER 4 IS 0.                          @Z40BPJC*/
*/*                A DOMAIN CHANGE OCCURRED.                 @Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/***********************************************************@Z40BPJC*/
*                                                               02S0503
*IRARMCPO:                                                      02S0503
*   PROCEDURE OPTIONS(NOSAVE,NOSAVEAREA,NOENTREG,RETREG,NOPARMREG);/*
*                                                            @Z40BPJC*/
*                                                               02S0503
IRARMCPO DS    0H                                               02S0504
*   /*****************************************************************/
*   /*                                                               */
*   /* INITIAL PTR AND SWITCH SETTING                        @Z40BPJC*/
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0504
*   WKRE=RTNREG;                    /* SAVE RETURN REGISTER  @Z40BPJC*/
         LR    WKRE,RTNREG                                      02S0504
*   RESPECIFY                                                   02S0505
*     CPICKPTR RSTD;                /*                       @Z40BPJC*/
*   CPICKPTR=0;                     /* INITIALIZE POINTER TO SELECTED
*                                      OUCB                  @Z40BPJC*/
         SLR   CPICKPTR,CPICKPTR                                02S0506
*   DMDTPTR2=DMDTPTR2-RMCTDMDT;     /* CONVERT TO OFFSET     @Z40BPJC*/
         SL    DMDTPTR2,RMCTDMDT(,RMCTPTR)                      02S0507
*   RMCTCPS1='0'B;                  /* SET DOMAIN CHANGE SWITCH OFF
*                                                            @Z40BPJC*/
*                                                               02S0508
         NI    RMCTCPS1(RMCTPTR),B'10111111'                    02S0508
*   /*****************************************************************/
*   /*                                                               */
*   /* FIND OUCBS ON IN QUEUE IN THIS DOMAIN                 @Z40BPJC*/
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0509
*   OUCBPTR=RMCTINQE->OUCBFWD;      /* SCAN QUEUE FORWARD    @Z40BPJC*/
         L     @09,RMCTINQE(,RMCTPTR)                           02S0509
         L     OUCBPTR,OUCBFWD(,@09)                            02S0509
*   DO WHILE OUCBSCN='0'B;          /* ALL THE WAY TO THE END   02S0510
*                                                            @Z40BPJC*/
         B     @DE00510                                         02S0510
@DL00510 DS    0H                                               02S0511
*     IF DMDTPTR2=OUCBDMO&          /* IF OUCB IN THIS DOMAIN,       */
*         OUCBNSW='0'B&             /* USER SWAPPABLE,               */
*         OUCBBIB='0'B&             /* NOT BEING CANCELLED           */
*         OUCBENQ='0'B&             /* NOT ENQUEUED AND              */
*         OUCBINV='0'B&             /* VALID AND                     */
*         OUCBGOO='0'B&             /* NOT ON WAY OUT                */
*         OUCBGOB='0'B              /* OR TRANSITIONING              */
*       THEN                                                    02S0511
         CH    DMDTPTR2,OUCBDMO(,OUCBPTR)                       02S0511
         BNE   @RF00511                                         02S0511
         TM    OUCBNSW(OUCBPTR),B'10110010'                     02S0511
         BNZ   @RF00511                                         02S0511
         TM    OUCBGOO(OUCBPTR),B'10100000'                     02S0511
         BNZ   @RF00511                                         02S0511
*       DO;                         /*                       @Z40BPJC*/
*         IF(RRPATOD-OUCBTMA)>RMPTSAET|/* AND ENUF TIME              */
*             OUCBRMA='1'B THEN     /* AND RTB = 1,          @Z40BPJC*/
         L     @09,RRPATOD(,RRPAPTR)                            02S0513
         SL    @09,OUCBTMA(,OUCBPTR)                            02S0513
         CL    @09,RMPTSAET(,RMCTPTR)                           02S0513
         BH    @RT00513                                         02S0513
         TM    OUCBRMA(OUCBPTR),B'00100000'                     02S0513
         BNO   @RF00513                                         02S0513
@RT00513 DS    0H                                               02S0514
*           CALL IRARMCVL;          /* CALL CVL TO COMPUTE COMPOSITE
*                                                            @Z40BPJC*/
         BAL   @14,IRARMCVL                                     02S0514
*         ELSE                                                  02S0515
*           OUCBCMRV=OUCBWMR;       /* OR USE OLD WMR AS COMPOSITE
*                                      SINCE RTB = 0         @Z40BPJC*/
         B     @RC00513                                         02S0515
@RF00513 L     @09,OUCBWMR(,OUCBPTR)                            02S0515
         ST    @09,OUCBCMRV(,OUCBPTR)                           02S0515
*         IF RMCTCPS1='0'B THEN                                 02S0516
@RC00513 TM    RMCTCPS1(RMCTPTR),B'01000000'                    02S0516
         BNZ   @RF00516                                         02S0516
*           DO;                     /* NO PREVIOUS DOMAIN CHANGE
*                                                            @Z40BPJC*/
*             IF DMDTPTR2^=OUCBDMO THEN                         02S0518
         CH    DMDTPTR2,OUCBDMO(,OUCBPTR)                       02S0518
         BE    @RF00518                                         02S0518
*               DO;                 /* IF THIS OUCB'S DOMAIN CHANGED,
*                                                            @Z40BPJC*/
*                 RMCTCPS1='1'B;    /* SIGNAL TO QUIT SRCH FOR LOW RV
*                                                            @Z40BPJC*/
         OI    RMCTCPS1(RMCTPTR),B'01000000'                    02S0520
*                 CPICKPTR=0;       /* SET RETURN CODE TO SHOW NO
*                                      OUCB                  @Z40BPJC*/
*                                                               02S0521
         SLR   CPICKPTR,CPICKPTR                                02S0521
*                 /***************************************************/
*                 /*                                                 */
*                 /* ? IRACTLCL EPN(CAP)                             */
*                 /*                                                 */
*                 /***************************************************/
*                                                               02S0522
*                 DO;                                           02S0522
*                   R1=ADDR(RMEPBCAP);/* CAP REQUEST IS PARAM        */
         LA    R1,RMEPBCAP(,RMCTPTR)                            02S0523
*                   CALL RMSBCRL->IRARMRTN;/* ALGRTHM SCH FUNCT      */
         L     @15,RMSBCRL(,RMCTPTR)                            02S0524
         BALR  @14,@15                                          02S0524
*                 END;              /* ENSURE CAP REDRIVE SOON  02S0525
*                                                            @Z40BPJC*/
*               END;                /*                       @Z40BPJC*/
*             ELSE                                              02S0527
*               DO;                 /* NO DOMAIN CHG FOUND BY CVL
*                                                            @Z40BPJC*/
         B     @RC00518                                         02S0527
@RF00518 DS    0H                                               02S0528
*                 IF(CPICKPTR=0|OUCBCMRV<CPICKPTR->OUCBCMRV) THEN
         LTR   CPICKPTR,CPICKPTR                                02S0528
         BZ    @RT00528                                         02S0528
         L     @09,OUCBCMRV(,OUCBPTR)                           02S0528
         C     @09,OUCBCMRV(,CPICKPTR)                          02S0528
         BNL   @RF00528                                         02S0528
@RT00528 DS    0H                                               02S0529
*                   CPICKPTR=OUCBPTR;/* USE LOWER RV OF TWO. IF 02S0529
*                                      EQUAL, USE OLDER OUCB @Z40BPJC*/
         LR    CPICKPTR,OUCBPTR                                 02S0529
*               END;                /*                       @Z40BPJC*/
@RF00528 DS    0H                                               02S0531
*           END;                    /*                       @Z40BPJC*/
@RC00518 DS    0H                                               02S0532
*       END;                        /*                       @Z40BPJC*/
@RF00516 DS    0H                                               02S0533
*     OUCBPTR=OUCBFWD;              /* CONTINUE FORWARD SCAN @Z40BPJC*/
@RF00511 L     OUCBPTR,OUCBFWD(,OUCBPTR)                        02S0533
*   END;                            /*                       @Z40BPJC*/
@DE00510 TM    OUCBSCN(OUCBPTR),B'00000001'                     02S0534
         BZ    @DL00510                                         02S0534
*   OUCBPTR=CPICKPTR;               /* PASS BACK SELECTED OUCB  02S0535
*                                                            @Z40BPJC*/
         LR    OUCBPTR,CPICKPTR                                 02S0535
*   DMDTPTR2=DMDTPTR2+RMCTDMDT;     /* CONVERT BACK TO ADDR. @Z40BPJC*/
         AL    DMDTPTR2,RMCTDMDT(,RMCTPTR)                      02S0536
*   RTNREG=WKRE;                    /* RESTORE RETURN REGISTER  02S0537
*                                                            @Z40BPJC*/
         LR    RTNREG,WKRE                                      02S0537
*   RESPECIFY                                                   02S0538
*     CPICKPTR UNRSTD;              /*                       @Z40BPJC*/
*   END IRARMCPO;                   /*                       @Z40BPJC*/
@EL00006 DS    0H                                               02S0539
@EF00006 DS    0H                                               02S0539
@ER00006 BR    @14                                              02S0539
*                                                               02S0540
*/* *********************************************************@Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/*   ROUTINE NAME - IRARMCVL                                @Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/*   DESCRIPTIVE NAME - SYSTEM RESOURCES MANAGER (SRM)      @Z40BPJC*/
*/*                      USER SWAP EVALUATION ROUTINE        @Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/*   FUNCTION - THE IRARMCVL ROUTINE COMPUTES A NUMERICAL   @Z40BPJC*/
*/*              VALUE REPRESENTING THE RECOMMENDATION OF A  @Z40BPJC*/
*/*              A USER TO BE SWAPPED INTO OR TO REMAIN      @Z40BPJC*/
*/*              IN CORE.  THE RECOMMENDATION VALUE IS THE   @Z40BPJC*/
*/*              COMPOSITE SUM OF THE USER'S NORMALIZED      @Z40BPJC*/
*/*              WORKLOAD LEVEL AND THE RECOMMENDATIONS      @Z40BPJC*/
*/*              OF THE I/O AND CPU RESOURCE MANAGERS.       @Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/*   INPUT - REG 4 CONTAINS THE ADDRESS OF THE OUCB OF THE  @Z40BPJC*/
*/*           USER TO BE EVALUATED.                          @Z40BPJC*/
*/*         - REG 14 CONTAINS THE RETURN ADDRESS.            @Z40BPJC*/
*/*         - RMCTALU CONTAINS FLAGS REPRESENTING IMBALANCED @Z40BPJC*/
*/*           RESOURCES.                                     @Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/*   OUTPUT - THE COMPOSITE RECOMMENDATION VALUE IS STORED  @Z40BPJC*/
*/*            IN -OUCBCMRV-.                                @Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/*   EXIT - BRANCH ON REGISTER 14.                          @Z40BPJC*/
*/*          THERE IS NO ERROR EXIT OR INDICATION.           @Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/*                                                          @Z40BPJC*/
*/* *********************************************************@Z40BPJC*/
*                                                               02S0540
*IRARMCVL:                                                      02S0540
*   PROCEDURE OPTIONS(NOSAVE,NOSAVEAREA,NOENTREG,RETREG,NOPARMREG);/*
*                                                            @Z40BPJC*/
IRARMCVL DS    0H                                               02S0541
*   RESPECIFY                                                   02S0541
*     CVRE RSTD;                    /*                       @Z40BPJC*/
*   PMRO=RTNREG;                    /* SAVE ACROSS CALL TO CL3/IL3
*                                                            @Z40BPJC*/
         LR    PMRO,RTNREG                                      02S0542
*   IF(RRPATOD-OUCBTMA>RMPTSAET) THEN                           02S0543
*                                                               02S0543
         L     @09,RRPATOD(,RRPAPTR)                            02S0543
         SL    @09,OUCBTMA(,OUCBPTR)                            02S0543
         CL    @09,RMPTSAET(,RMCTPTR)                           02S0543
         BNH   @RF00543                                         02S0543
*     /***************************************************************/
*     /*                                                             */
*     /* ? IRACTLCL EPN(WM3)                                         */
*     /*                                                             */
*     /***************************************************************/
*                                                               02S0544
*     CALL EPSTWM3->IRARMRTN;       /* INVOKE WM3 ACTION             */
*                                                               02S0544
         L     @15,EPSTWM3(,RMCTPTR)                            02S0544
         BALR  @14,@15                                          02S0544
*   /*****************************************************************/
*   /*                                                               */
*   /*                                                       @Z40BPJC*/
*   /*                                                               */
*   /*****************************************************************/
*                                                               02S0545
*   CVRE=OUCBWMR;                   /* ACCUM. COMPOSITE EQUALS  02S0545
*                                      NORMALIZED LEVEL      @Z40BPJC*/
@RF00543 L     CVRE,OUCBWMR(,OUCBPTR)                           02S0545
*   IF(OUCBRMA='1'B) THEN                                       02S0546
         TM    OUCBRMA(OUCBPTR),B'00100000'                     02S0546
         BNO   @RF00546                                         02S0546
*     DO;                           /* BE SURE RTB = 1 FOR USER 02S0547
*                                                            @Z40BPJC*/
*       IF(CCTCPUOT='1'B)           /* IS CPU OUT-OF-BAL AND IS THIS */
*           &(OUCBCPL='1'B) THEN                                02S0548
         TM    CCTCPUOT(RMCTPTR),B'01000000'                    02S0548
         BNO   @RF00548                                         02S0548
         TM    OUCBCPL(OUCBPTR),B'00010000'                     02S0548
         BNO   @RF00548                                         02S0548
*         DO;                       /* A SIGNIFICNT USR      @Z40BPJC*/
*           IF(RRPATOD-OUCBTCP)>RMPTCPET THEN/* ENUF TIME PASSED     */
*                                                               02S0550
         L     @09,RRPATOD(,RRPAPTR)                            02S0550
         SL    @09,OUCBTCP(,OUCBPTR)                            02S0550
         CL    @09,RMPTCPET(,RMCTPTR)                           02S0550
         BNH   @RF00550                                         02S0550
*             /*******************************************************/
*             /*                                                     */
*             /* ? IRACTLCL EPN(CL3)                                 */
*             /*                                                     */
*             /*******************************************************/
*                                                               02S0551
*             CALL EPSTCL3->IRARMRTN;/* INVOKE CL3 ACTION            */
*                                                               02S0551
         L     @15,EPSTCL3(,RMCTPTR)                            02S0551
         BALR  @14,@15                                          02S0551
*           /*********************************************************/
*           /*                                                       */
*           /* INVOKE CL3 RTN                                @Z40BPJC*/
*           /*                                                       */
*           /*********************************************************/
*                                                               02S0552
*           CVRE=CVRE+OUCBCRV*RMPTCPU;/* ADD CPU RV          @Z40BPJC*/
@RF00550 L     @09,RMPTCPU(,RMCTPTR)                            02S0552
         MH    @09,OUCBCRV(,OUCBPTR)                            02S0552
         ALR   CVRE,@09                                         02S0552
*         END;                      /*                       @Z40BPJC*/
*       ELSE                        /* CPU IN BAL OR NOT A SIG USER
*                                                            @ZA26908*/
*         OUCBCRV=ZERO;             /* THEN REC VALUE = ZERO @ZA26908*/
         B     @RC00548                                         02S0554
@RF00548 SLR   @09,@09                                          02S0554
         STH   @09,OUCBCRV(,OUCBPTR)                            02S0554
*       IF ICTIOOT='1'B THEN                                    02S0555
@RC00548 TM    ICTIOOT(RMCTPTR),B'00100000'                     02S0555
         BNO   @RF00555                                         02S0555
*         DO;                       /* I/O OUT-OF-BAL        @Z40BPJC*/
*           IF(RRPATOD-OUCBTIO)>RMPTIOET THEN                   02S0557
*                                                               02S0557
         L     @09,RRPATOD(,RRPAPTR)                            02S0557
         SL    @09,OUCBTIO(,OUCBPTR)                            02S0557
         CL    @09,RMPTIOET(,RMCTPTR)                           02S0557
         BNH   @RF00557                                         02S0557
*             /*******************************************************/
*             /*                                                     */
*             /* ? IRACTLCL EPN(IL3)                                 */
*             /*                                                     */
*             /*******************************************************/
*                                                               02S0558
*             CALL EPSTIL3->IRARMRTN;/* INVOKE IL3 ACTION            */
*                                                               02S0558
         L     @15,EPSTIL3(,RMCTPTR)                            02S0558
         BALR  @14,@15                                          02S0558
*           /*********************************************************/
*           /*                                                       */
*           /* IF ENOUGH TIME SINCE LAST CALCULATION, INVOKE IL3 RTN */
*           /*                                               @Z40BPJC*/
*           /*                                                       */
*           /*********************************************************/
*                                                               02S0559
*           CVRE=CVRE+OUCBIRV*RMPTIOC;/* ADD I/O RV          @Z40BPJC*/
@RF00557 L     @09,RMPTIOC(,RMCTPTR)                            02S0559
         MH    @09,OUCBIRV(,OUCBPTR)                            02S0559
         ALR   CVRE,@09                                         02S0559
*         END;                      /*                       @Z40BPJC*/
*       ELSE                        /* I/O IN BAL            @ZA26908*/
*         OUCBIRV=ZERO;             /* THEN REC VALUE = ZERO @ZA26908*/
         B     @RC00555                                         02S0561
@RF00555 SLR   @09,@09                                          02S0561
         STH   @09,OUCBIRV(,OUCBPTR)                            02S0561
*     END;                          /*                       @Z40BPJC*/
@RC00555 DS    0H                                               02S0563
*   RTNREG=PMRO;                    /*                       @Z40BPJC*/
@RF00546 LR    RTNREG,PMRO                                      02S0563
*   OUCBCMRV=CVRE;                  /* SAVE ACCUM COMPOS R.V.   02S0564
*                                                            @Z40BPJC*/
         ST    CVRE,OUCBCMRV(,OUCBPTR)                          02S0564
*   RESPECIFY                                                   02S0565
*     CVRE UNRSTD;                  /*                       @Z40BPJC*/
*   END IRARMCVL;                                               02S0566
@EL00007 DS    0H                                               02S0566
@EF00007 DS    0H                                               02S0566
@ER00007 BR    @14                                              02S0566
*   END IRARMCTL                                                01S0567
*                                                               01S0567
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSUT5  (IRACTLDT)                                       */
*/*%INCLUDE SYSLIB  (IRACNSMP)                                       */
*/*%INCLUDE SYSLIB  (IRARMCT )                                       */
*/*%INCLUDE SYSLIB  (IRACCT  )                                       */
*/*%INCLUDE SYSLIB  (IRAICT  )                                       */
*/*%INCLUDE SYSLIB  (IRAMCT  )                                       */
*/*%INCLUDE SYSLIB  (IRARCT  )                                       */
*/*%INCLUDE SYSLIB  (IRARMPT )                                       */
*/*%INCLUDE SYSLIB  (IRARMCA )                                       */
*/*%INCLUDE SYSLIB  (IRARMEX )                                       */
*/*%INCLUDE SYSLIB  (IRARMSB )                                       */
*/*%INCLUDE SYSLIB  (IRAEPAT )                                       */
*/*%INCLUDE SYSLIB  (IRAEPDT )                                       */
*/*%INCLUDE SYSLIB  (IRAEPST )                                       */
*/*%INCLUDE SYSLIB  (IRARRPA )                                       */
*/*%INCLUDE SYSLIB  (IHAASCB )                                       */
*/*%INCLUDE SYSLIB  (IRAOUCB )                                       */
*/*%INCLUDE SYSLIB  (IHAOUXB )                                       */
*/*%INCLUDE SYSLIB  (IRARMEP )                                       */
*/*%INCLUDE SYSLIB  (IRADMDT )                                       */
*/*%INCLUDE SYSLIB  (IHAWSAVT)                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IHALCCA )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHAPVT  )                                       */
*/*%INCLUDE SYSLIB  (IHASRB  )                                       */
*/*%INCLUDE SYSLIB  (IRAREGS )                                       */
*/*%INCLUDE SYSLIB  (IRASRCD )                                       */
*/*%INCLUDE SYSUT5  (IRARMCEN)                                       */
*/*%INCLUDE SYSUT5  (IRARMCEL)                                       */
*/*%INCLUDE SYSUT5  (IRARMCET)                                       */
*/*%INCLUDE SYSUT5  (IRARMCED)                                       */
*/*%INCLUDE SYSUT5  (IRARMCQT)                                       */
*/*%INCLUDE SYSUT5  (IRARMCRD)                                       */
*/*%INCLUDE SYSUT5  (IRARMCRL)                                       */
*/*%INCLUDE SYSUT5  (IRARMCRN)                                       */
*/*%INCLUDE SYSUT5  (IRARMCRT)                                       */
*/*%INCLUDE SYSUT5  (IRARMCRY)                                       */
*/*%INCLUDE SYSUT5  (IRARMCSI)                                       */
*/*%INCLUDE SYSUT5  (IRARMCSO)                                       */
*/*%INCLUDE SYSUT5  (IRARMRPS)                                       */
*/*%INCLUDE SYSUT5  (IRARMWMY)                                       */
*/*%INCLUDE SYSUT5  (IRARMCAP)                                       */
*/*%INCLUDE SYSUT5  (IRARMCPI)                                       */
*/*%INCLUDE SYSUT5  (IRARMCPO)                                       */
*/*%INCLUDE SYSUT5  (IRARMCVL)                                       */
*                                                               01S0567
*       ;                                                       01S0567
@DATA    DS    0H
@DATD    DSECT
         DS    0F
IRARMCTL CSECT
         DS    0F
@CF02274 DC    F'20'
@CF02292 DC    BL4'00000000000000000010000000000000'
@DATD    DSECT
         DS    0D
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IRARMCTL CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
@CC02242 DC    C'OUCB'
@CC02246 DC    C'OUXB'
FLAGDEF  DC    X'FFFFFFF0'
ACTNDEF  DC    X'FFF00000'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
RMCTPTR  EQU   @02
RRPAPTR  EQU   @03
ASCBPTR  EQU   @05
OUCBPTR  EQU   @04
OUXBPTR  EQU   @06
RMEPPTR  EQU   @01
DMDTPTR  EQU   @06
SRBPTR   EQU   @01
R0       EQU   @00
R1       EQU   @01
SVEREG   EQU   @13
RTNREG   EQU   @14
NTRREG   EQU   @15
RTNCOD   EQU   @15
PMRE     EQU   @06
PMRO     EQU   @07
SVRE     EQU   @06
SVRO     EQU   @07
TMRE     EQU   @10
WKRE     EQU   @10
WKRO     EQU   @11
CVRE     EQU   @06
CPICKPTR EQU   @05
DMDTPTR2 EQU   @11
VLRE     EQU   @10
VLRO     EQU   @11
         ENTRY IRARMCET
         ENTRY IRARMCED
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
FLCCVT   EQU   FLCICCW2
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSALCCAV EQU   PSA+528
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
RMCT     EQU   0
RMCTRMSA EQU   RMCT+32
RMCTEPDT EQU   RMCT+52
RMCTEPAT EQU   RMCT+56
RMCTTMQE EQU   RMCT+92
RMCTAQCT EQU   RMCT+96
RMCTAQHD EQU   RMCT+100
RMCTWTQE EQU   RMCT+104
RMCTOTQE EQU   RMCT+108
RMCTINQE EQU   RMCT+112
RMCTTBS  EQU   RMCT+120
RMCTTOD  EQU   RMCT+124
RMCTALA  EQU   RMCT+136
RMCTALR  EQU   RMCT+140
RMCTFLGS EQU   RMCT+148
RMCTCPS1 EQU   RMCTFLGS
RMCTOUCB EQU   RMCT+168
RMCTOUXB EQU   RMCT+172
RMCTSRBT EQU   RMCT+176
RMCTDMDT EQU   RMCT+180
RMCTDMDE EQU   RMCT+184
CCT      EQU   RMCT+192
CCTFLG1  EQU   CCT+124
CCTCPUOT EQU   CCTFLG1
ICT      EQU   RMCT+320
ICTFLAGS EQU   ICT+84
ICTIOOT  EQU   ICTFLAGS
MCT      EQU   RMCT+408
MCTSFLGS EQU   MCT+64
MCTOFLGS EQU   MCT+65
RCT      EQU   RMCT+504
RMPT     EQU   RMCT+592
RMPTCPU  EQU   RMPT+4
RMPTIOC  EQU   RMPT+8
RMPTTOM  EQU   RMPT+24
RMPTTOL  EQU   RMPT+28
RMPTXCHT EQU   RMPT+40
RMPTSAET EQU   RMPT+44
RMPTCPET EQU   RMPT+52
RMPTIOET EQU   RMPT+56
RMCA     EQU   RMCT+664
RMCATOI  EQU   RMCA+20
RMCAFLGS EQU   RMCA+36
RMCACHP  EQU   RMCA+48
RMCACHU  EQU   RMCA+52
RMCAINV  EQU   RMCA+64
RMCACIUS EQU   RMCA+118
RMCACPW1 EQU   RMCA+120
RMCASRC  EQU   RMCA+124
RMEX     EQU   RMCT+832
RMEPBEVT EQU   RMEX
RMEPBCTL EQU   RMEX+16
RMEXCTL  EQU   RMEPBCTL
RMEXI01  EQU   RMEX+32
RMEXI48  EQU   RMEX+44
RMSB     EQU   RMCT+896
RMSBI02  EQU   RMSB
RMSBI04  EQU   RMSB+8
RMSBI05  EQU   RMSB+12
RMSBI06  EQU   RMSB+16
RMSBI07  EQU   RMSB+20
RMSBCRL  EQU   RMSB+36
RMSBCRY  EQU   RMSB+44
EPAT     EQU   RMCT+1016
RMEPBCAP EQU   EPAT
RMEPBPR1 EQU   EPAT+368
EPDT     EQU   RMCT+1416
EPST     EQU   RMCT+1512
RMEPBWM3 EQU   EPST
EPSTWM3  EQU   RMEPBWM3
RMEPBIL3 EQU   EPST+16
EPSTIL3  EQU   RMEPBIL3
RMEPBCL3 EQU   EPST+32
EPSTCL3  EQU   RMEPBCL3
RMEPBCSO EQU   EPST+48
RMEPBCSI EQU   EPST+64
RRPA     EQU   0
RRPAINC  EQU   RRPA
RRPAVPGN EQU   RRPAINC+2
RRPAFLG0 EQU   RRPAVPGN
RRPACOD  EQU   RRPAINC+3
RRPAINP  EQU   RRPA+4
RRPAFLG  EQU   RRPA+8
RRPASVC  EQU   RRPAFLG
RRPAOPT  EQU   RRPAFLG
RRPACTL  EQU   RRPAFLG+1
RRPARFI  EQU   RRPAFLG+1
RRPATOD  EQU   RRPA+12
RRPAINS  EQU   RRPA+16
RRPARTN  EQU   RRPAINS
RRPAEPA  EQU   RRPA+20
ASCB     EQU   0
ASCBSUPC EQU   ASCB+16
ASCBDP   EQU   ASCB+43
ASCBRSM  EQU   ASCB+52
ASCBRSMF EQU   ASCBRSM
ASCBECB  EQU   ASCB+84
ASCBFW1  EQU   ASCB+100
ASCBRCTF EQU   ASCBFW1+2
ASCBFLG1 EQU   ASCBFW1+3
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
ASCBLKGP EQU   ASCB+128
ASCBOUXB EQU   ASCB+148
ASCBSRQ  EQU   ASCB+180
ASCBSRQ1 EQU   ASCBSRQ
ASCBSRQ2 EQU   ASCBSRQ+1
ASCBSRQ3 EQU   ASCBSRQ+2
ASCBSRQ4 EQU   ASCBSRQ+3
OUCB     EQU   0
OUCBNAME EQU   OUCB
OUCBFWD  EQU   OUCB+4
OUCBBCK  EQU   OUCB+8
OUCBTMA  EQU   OUCB+12
OUCBQFL  EQU   OUCB+16
OUCBGOO  EQU   OUCBQFL
OUCBGOI  EQU   OUCBQFL
OUCBGOB  EQU   OUCBQFL
OUCBOFF  EQU   OUCBQFL
OUCBOUT  EQU   OUCBQFL
OUCBSFL  EQU   OUCB+17
OUCBNSW  EQU   OUCBSFL
OUCBBIB  EQU   OUCBSFL
OUCBINV  EQU   OUCBSFL
OUCBNSWI EQU   OUCBSFL
OUCBENQ  EQU   OUCBSFL
OUCBSCN  EQU   OUCBSFL
OUCBYFL  EQU   OUCB+18
OUCBPSTR EQU   OUCBYFL
OUCBAXS  EQU   OUCBYFL
OUCBFXS  EQU   OUCBYFL
OUCBAFL  EQU   OUCB+19
OUCBAPG  EQU   OUCBAFL
OUCBRMA  EQU   OUCBAFL
OUCBCPL  EQU   OUCBAFL
OUCBTFL  EQU   OUCB+20
OUCBEFL  EQU   OUCB+21
OUCBUFL  EQU   OUCB+23
OUCBJSFS EQU   OUCBUFL
OUCBJSAS EQU   OUCBUFL
OUCBNDP  EQU   OUCB+26
OUCBDMO  EQU   OUCB+34
OUCBSRC  EQU   OUCB+37
OUCBASCB EQU   OUCB+40
OUCBACT  EQU   OUCB+80
OUCBCSW  EQU   OUCB+84
OUCBACN  EQU   OUCBCSW
OUCBCFL  EQU   OUCBCSW+2
OUCBRDY  EQU   OUCBCFL
OUCBCMRV EQU   OUCB+88
OUCBWMR  EQU   OUCB+92
OUCBIRV  EQU   OUCB+96
OUCBCRV  EQU   OUCB+98
OUCBPSS  EQU   OUCB+112
OUCBTCP  EQU   OUCB+124
OUCBTIO  EQU   OUCB+128
OUXB     EQU   0
OUXBNAME EQU   OUXB
RMEP     EQU   0
RMEPEPB  EQU   RMEP
RMEPEPA  EQU   RMEPEPB
RMEPFLG  EQU   RMEPEPB+8
RMEPRCR  EQU   RMEPFLG+3
RMEPTMD  EQU   RMEPFLG+3
RMEPACN  EQU   RMEPFLG+3
RMEPPRV  EQU   RMEPEPB+12
RMEPSCH  EQU   RMEP+16
RMEPFWD  EQU   RMEPSCH
RMEPBCK  EQU   RMEPSCH+4
RMEPTME  EQU   RMEPSCH+8
RMEPINT  EQU   RMEPSCH+12
DMDT     EQU   0
DMDTMPLT EQU   DMDT+4
DMDTGOOU EQU   DMDT+8
DMDTCMPL EQU   DMDT+10
DMDTOUTU EQU   DMDT+12
DMDTINCU EQU   DMDT+14
WSAC     EQU   0
WSACOPTM EQU   WSAC+8
LCCA     EQU   0
LCCAIHRC EQU   LCCA+520
LCCAIHR1 EQU   LCCAIHRC
LCCAIHR2 EQU   LCCAIHRC+1
LCCAIHR3 EQU   LCCAIHRC+2
LCCAIHR4 EQU   LCCAIHRC+3
LCCASPIN EQU   LCCA+524
LCCASPN1 EQU   LCCASPIN
LCCASPN2 EQU   LCCASPIN+1
LCCASPN3 EQU   LCCASPIN+2
LCCASPN4 EQU   LCCASPIN+3
LCCACPUS EQU   LCCA+536
LCCADSF1 EQU   LCCA+540
LCCADSF2 EQU   LCCA+541
LCCASPSA EQU   LCCA+544
LCCACRFL EQU   LCCA+692
LCCACREX EQU   LCCA+693
LCCALKFG EQU   LCCA+694
LCCASRBF EQU   LCCA+720
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
PVT      EQU   0
PVTFLAG1 EQU   PVT
PVTFLAG2 EQU   PVT+1
PVTQS    EQU   PVT+304
PVTWSAX  EQU   PVT+344
SRBSECT  EQU   0
SRB      EQU   SRBSECT
SRBFLNK  EQU   SRB+4
SRBFLC   EQU   SRB+12
SRBPARM  EQU   SRB+28
IRARMNTR EQU   0
IRARMRTN EQU   0
CRNRTRN  EQU   120
INMASK   EQU   0
IRARMPTR EQU   0
PSARSVTE EQU   PSARSVT
LCCAPTR  EQU   PSALCCAV
CVTPTR   EQU   FLCCVT
CVTS01   EQU   CVTPGSIA
CVTPVTP  EQU   CVTS01+8
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTOPCTP EQU   CVTS01+256
CVTGSMQ  EQU   CVTS01+264
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTEXP1  EQU   CVTS01+572
CVTGSDA  EQU   CVTS01+600
PVTPTR   EQU   CVTPVTP
RMCTACQH EQU   RMCTAQCT
RMCTALAW EQU   RMCTALA
OUCBACTW EQU   OUCBACT
DMDTBLK1 EQU   DMDTGOOU
DMDTBLK2 EQU   DMDTOUTU
ASCBQFLG EQU   ASCBFW1
ASCBFQUB EQU   ASCBQFLG+2
FLC      EQU   PSA
NEGATIV  EQU   FLAGDEF
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00033 EQU   ASCBQFLG+2
@NM00032 EQU   ASCBQFLG
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTHSM   EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTEXPRO EQU   CVTS01+260
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
@NM00031 EQU   SRB+40
@NM00030 EQU   SRB+38
SRBPRIOR EQU   SRB+37
SRBPKF   EQU   SRB+36
SRBSAVE  EQU   SRB+32
SRBRMTR  EQU   SRB+24
SRBEP    EQU   SRB+20
SRBPTCB  EQU   SRBFLC+4
SRBPASID EQU   SRBFLC+2
SRBCPAFF EQU   SRBFLC
SRBASCB  EQU   SRB+8
SRBID    EQU   SRB
PVTEND   EQU   PVT+1848
PVTTASID EQU   PVT+1846
PVTXXXXX EQU   PVT+1844
PVTMVCLC EQU   PVT+1840
PVTSPARE EQU   PVT+1838
PVTCHUIC EQU   PVT+1836
PVTCOMFX EQU   PVT+1834
PVTSQAFX EQU   PVT+1832
PVTCNTFX EQU   PVT+1830
PVTDEFFX EQU   PVT+1828
PVTFIXOK EQU   PVT+1826
PVTPEROK EQU   PVT+1824
PVTMAXFX EQU   PVT+1822
PVTPERFX EQU   PVT+1820
PVTRSRB  EQU   PVT+1776
PVTRESV5 EQU   PVT+1773
PVTSRBS  EQU   PVT+1772
PVTSSRB  EQU   PVT+1768
PVTACA   EQU   PVTWSAX+1400
PVTSAVE  EQU   PVTWSAX+1328
PVTWSA18 EQU   PVTWSAX+1256
PVTWSA17 EQU   PVTWSAX+1184
PVTWSA16 EQU   PVTWSAX+1112
PVTWSA15 EQU   PVTWSAX+1040
PVTWSA14 EQU   PVTWSAX+968
PVTWSA13 EQU   PVTWSAX+896
PVTWSA12 EQU   PVTWSAX+824
PVTWSA11 EQU   PVTWSAX+752
PVTWSA10 EQU   PVTWSAX+672
PVTWSA9  EQU   PVTWSAX+592
PVTWSA8  EQU   PVTWSAX+504
PVTWSA7  EQU   PVTWSAX+432
PVTWSA6  EQU   PVTWSAX+360
PVTWSA5  EQU   PVTWSAX+288
PVTWSA4  EQU   PVTWSAX+216
PVTWSA3  EQU   PVTWSAX+144
PVTWSA2  EQU   PVTWSAX+72
PVTWSA1  EQU   PVTWSAX
PVTCIOQL EQU   PVTQS+36
PVTCIOQF EQU   PVTQS+32
PVTGFADL EQU   PVTQS+28
PVTGFADF EQU   PVTQS+24
PVTFPCBL EQU   PVTQS+20
PVTFPCBF EQU   PVTQS+16
PVTSQAQL EQU   PVTQS+14
PVTSQAQF EQU   PVTQS+12
PVTCFQL  EQU   PVTQS+10
PVTCFQF  EQU   PVTQS+8
PVTRSRVL EQU   PVTQS+6
PVTRSRVF EQU   PVTQS+4
PVTAFQL  EQU   PVTQS+2
PVTAFQF  EQU   PVTQS
PVTSPFR  EQU   PVT+302
PVTCFMCT EQU   PVT+300
PVTSPREC EQU   PVT+296
PVTCAREC EQU   PVT+292
PVTCAOUT EQU   PVT+288
PVTCAIN  EQU   PVT+284
PVTNSWPS EQU   PVT+280
PVTNPREC EQU   PVT+276
PVTSPOUT EQU   PVT+272
PVTSPIN  EQU   PVT+268
PVTVAMR  EQU   PVT+264
PVTVAMO  EQU   PVT+260
PVTVAMI  EQU   PVT+256
PVTNPOUT EQU   PVT+252
PVTNPIN  EQU   PVT+248
PVTPRSET EQU   PVT+244
PVTFRSLT EQU   PVT+240
PVTPAGIO EQU   PVT+236
PVTSWPIO EQU   PVT+232
PVTPSWPP EQU   PVT+228
PVTPPREF EQU   PVT+224
PVTPOPBR EQU   PVT+220
PVTPRELF EQU   PVT+216
PVTPRELV EQU   PVT+212
PVTPFREE EQU   PVT+208
PVTPRELS EQU   PVT+204
PVTPOUT  EQU   PVT+200
PVTPFXLD EQU   PVT+196
PVTPITAS EQU   PVT+192
PVTPSRBP EQU   PVT+188
PVTPDSEG EQU   PVT+184
PVTPCSGB EQU   PVT+180
PVTPCSEG EQU   PVT+176
PVTPINV  EQU   PVT+172
PVTPSWPC EQU   PVT+168
PVTPSOUT EQU   PVT+164
PVTPSWIN EQU   PVT+160
PVTPRCV  EQU   PVT+156
PVTPRCFI EQU   PVT+152
PVTPRCF  EQU   PVT+148
PVTPVRC  EQU   PVT+144
PVTPVRIN EQU   PVT+140
PVTPVRLS EQU   PVT+136
PVTPVEQR EQU   PVT+132
PVTPPIOI EQU   PVT+128
PVTPVRPO EQU   PVT+124
PVTPRFR  EQU   PVT+120
PVTPFP2  EQU   PVT+116
PVTPFP   EQU   PVT+112
PVTPFTE  EQU   PVT+108
PVTPCB   EQU   PVT+104
PVTREP2  EQU   PVT+100
PVTPIOCP EQU   PVT+96
PVTPIOP  EQU   PVT+92
PVTPGFAD EQU   PVT+88
PVTPGFA  EQU   PVT+84
PVTPSQA  EQU   PVT+80
PVTPSINT EQU   PVT+76
PVTPSIB  EQU   PVT+72
PVTSRBID EQU   PVT+68
PVTPCIWA EQU   PVT+64
PVTHQSA  EQU   PVT+62
PVTLQSA  EQU   PVT+60
PVTOROOT EQU   PVT+56
PVTPRCA  EQU   PVT+52
PVTREUS  EQU   PVT+48
PVTSQNPC EQU   PVT+47
PVTSQVRC EQU   PVT+46
PVTRSUS  EQU   PVT+44
PVTVROOT EQU   PVT+40
PVTPCBLO EQU   PVT+38
PVTPCBCT EQU   PVT+36
PVTDFRS  EQU   PVT+34
PVTRSQA  EQU   PVT+32
PVTPTLB  EQU   PVT+31
PVTPCBNO EQU   PVT+30
PVTSRBNO EQU   PVT+29
PVTSQDC  EQU   PVT+28
PVTLCSA  EQU   PVT+26
PVTLPRIV EQU   PVT+24
PVTLVR   EQU   PVT+22
PVTFVR   EQU   PVT+20
PVTLPFN  EQU   PVT+18
PVTFPFN  EQU   PVT+16
PVTPFTP  EQU   PVT+12
PVTSSPIN EQU   PVT+11
PVTPCBS  EQU   PVT+10
PVTPOOL  EQU   PVT+8
PVTAFCOK EQU   PVT+6
PVTAFCLO EQU   PVT+4
PVTAFC   EQU   PVT+2
@NM00029 EQU   PVTFLAG2
PVTRSMGM EQU   PVTFLAG2
PVTDUMP  EQU   PVTFLAG1
PVTSIT   EQU   PVTFLAG1
PVTLSI   EQU   PVTFLAG1
PVTAPREF EQU   PVTFLAG1
PVTPCBLT EQU   PVTFLAG1
PVTSRBIU EQU   PVTFLAG1
PVTBGMS  EQU   PVTFLAG1
PVTPMSG  EQU   PVTFLAG1
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00028 EQU   CVTFIX+248
@NM00027 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTCCVT  EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
LCCAR125 EQU   LCCA+964
LCCAR124 EQU   LCCA+960
LCCASGPR EQU   LCCA+896
LCCADRT2 EQU   LCCA+888
LCCADRT1 EQU   LCCA+880
LCCAR103 EQU   LCCA+876
LCCAESS2 EQU   LCCA+872
LCCASPLJ EQU   LCCA+868
LCCASMQJ EQU   LCCA+864
LCCAIRT  EQU   LCCA+736
LCCAASID EQU   LCCA+732
LCCARV89 EQU   LCCA+728
LCCAPGTA EQU   LCCASRBF+2
LCCASAFN EQU   LCCASRBF
LCCAECSA EQU   LCCA+716
LCCAICR0 EQU   LCCA+712
LCCALWTM EQU   LCCA+704
LCCARV78 EQU   LCCA+700
LCCAPINV EQU   LCCA+696
LCCARV88 EQU   LCCA+695
LCCARV87 EQU   LCCALKFG
LCCARV86 EQU   LCCALKFG
LCCARV85 EQU   LCCALKFG
LCCARV84 EQU   LCCALKFG
LCCALKRD EQU   LCCALKFG
LCCALKAQ EQU   LCCALKFG
LCCALKSA EQU   LCCALKFG
LCCALKDP EQU   LCCALKFG
LCCACRST EQU   LCCACREX
LCCACRDP EQU   LCCACREX
LCCACRLM EQU   LCCACREX
LCCACRIN EQU   LCCACREX
LCCACRRT EQU   LCCACREX
LCCACRLE EQU   LCCACREX
LCCACRRM EQU   LCCACREX
LCCACREF EQU   LCCACREX
LCCAVARY EQU   LCCACRFL
LCCARV73 EQU   LCCACRFL
LCCARV72 EQU   LCCACRFL
LCCARV71 EQU   LCCACRFL
LCCARV70 EQU   LCCACRFL
LCCARV69 EQU   LCCACRFL
LCCACLMS EQU   LCCACRFL
LCCACRTM EQU   LCCACRFL
LCCALCR0 EQU   LCCA+688
LCCACRLC EQU   LCCA+684
LCCARCPU EQU   LCCA+680
LCCADCPU EQU   LCCA+676
LCCASRBJ EQU   LCCA+672
LCCADSSR EQU   LCCA+668
LCCADSSC EQU   LCCA+660
LCCADSS3 EQU   LCCA+648
LCCADSS2 EQU   LCCA+636
LCCADSS1 EQU   LCCA+624
LCCAWTIM EQU   LCCA+616
LCCAITOD EQU   LCCA+608
LCCADTOD EQU   LCCA+600
LCCASTOD EQU   LCCA+592
LCCARIR5 EQU   LCCASPSA+44
LCCARIR4 EQU   LCCASPSA+40
LCCARIR3 EQU   LCCASPSA+36
LCCARIR2 EQU   LCCASPSA+32
LCCARPR5 EQU   LCCASPSA+28
LCCARPR4 EQU   LCCASPSA+24
LCCARPR3 EQU   LCCASPSA+20
LCCARPR2 EQU   LCCASPSA+16
LCCADSR5 EQU   LCCASPSA+12
LCCADSR4 EQU   LCCASPSA+8
LCCADSR3 EQU   LCCASPSA+4
LCCADSR2 EQU   LCCASPSA
LCCARV68 EQU   LCCA+543
LCCAPSMK EQU   LCCA+542
LCCARV67 EQU   LCCADSF2
LCCARV66 EQU   LCCADSF2
LCCARV65 EQU   LCCADSF2
LCCARV64 EQU   LCCADSF2
LCCADSRW EQU   LCCADSF2
LCCADSPL EQU   LCCADSF2
LCCAGSRB EQU   LCCADSF2
LCCASRBM EQU   LCCADSF2
LCCARV61 EQU   LCCADSF1
LCCARV60 EQU   LCCADSF1
LCCARV59 EQU   LCCADSF1
LCCARV58 EQU   LCCADSF1
LCCATIMR EQU   LCCADSF1
LCCADSS  EQU   LCCADSF1
LCCAVCPU EQU   LCCADSF1
LCCAACR  EQU   LCCADSF1
LCCAASCP EQU   LCCA+532
LCCAESSA EQU   LCCA+528
LCCARV55 EQU   LCCASPN4
LCCARV54 EQU   LCCASPN4
LCCARV53 EQU   LCCASPN4
LCCARV52 EQU   LCCASPN4
LCCARV51 EQU   LCCASPN4
LCCARV50 EQU   LCCASPN4
LCCARV49 EQU   LCCASPN4
LCCARV48 EQU   LCCASPN4
LCCARV47 EQU   LCCASPN3
LCCARV46 EQU   LCCASPN3
LCCARV45 EQU   LCCASPN3
LCCARV44 EQU   LCCASPN3
LCCARV43 EQU   LCCASPN3
LCCARV42 EQU   LCCASPN3
LCCARV41 EQU   LCCASPN3
LCCARV40 EQU   LCCASPN3
LCCARV39 EQU   LCCASPN2
LCCARV38 EQU   LCCASPN2
LCCARV37 EQU   LCCASPN2
LCCARV36 EQU   LCCASPN2
LCCARV35 EQU   LCCASPN2
LCCARV34 EQU   LCCASPN2
LCCARV33 EQU   LCCASPN2
LCCARV32 EQU   LCCASPN2
LCCARV31 EQU   LCCASPN1
LCCARV30 EQU   LCCASPN1
LCCAMFIO EQU   LCCASPN1
LCCARSTR EQU   LCCASPN1
LCCATSPN EQU   LCCASPN1
LCCALOCK EQU   LCCASPN1
LCCASIGP EQU   LCCASPN1
LCCAPTLB EQU   LCCASPN1
LCCARV27 EQU   LCCAIHR4
LCCARV26 EQU   LCCAIHR4
LCCARV25 EQU   LCCAIHR4
LCCARV24 EQU   LCCAIHR4
LCCARV23 EQU   LCCAIHR4
LCCARV22 EQU   LCCAIHR4
LCCARV21 EQU   LCCAIHR4
LCCARV20 EQU   LCCAIHR4
LCCARV19 EQU   LCCAIHR3
LCCARV18 EQU   LCCAIHR3
LCCARV17 EQU   LCCAIHR3
LCCARV16 EQU   LCCAIHR3
LCCARV15 EQU   LCCAIHR3
LCCARV14 EQU   LCCAIHR3
LCCARV13 EQU   LCCAIHR3
LCCARV12 EQU   LCCAIHR3
LCCARV11 EQU   LCCAIHR2
LCCARV10 EQU   LCCAIHR2
LCCARV09 EQU   LCCAIHR2
LCCARV08 EQU   LCCAIHR2
LCCARV07 EQU   LCCAIHR2
LCCARV06 EQU   LCCAIHR2
LCCARV05 EQU   LCCAIHR2
LCCARV04 EQU   LCCAIHR2
LCCARV03 EQU   LCCAIHR1
LCCARV02 EQU   LCCAIHR1
LCCARV01 EQU   LCCAIHR1
LCCAPPIE EQU   LCCAIHR1
LCCAPSG1 EQU   LCCAIHR1
LCCAPDAT EQU   LCCAIHR1
LCCAXRC2 EQU   LCCAIHR1
LCCAXRC1 EQU   LCCAIHR1
LCCAIOPS EQU   LCCA+512
LCCAGPGR EQU   LCCA+448
LCCAR133 EQU   LCCA+444
LCCAR132 EQU   LCCA+440
LCCAR131 EQU   LCCA+436
LCCAR130 EQU   LCCA+432
LCCAR129 EQU   LCCA+428
LCCAR128 EQU   LCCA+424
LCCAR127 EQU   LCCA+420
LCCAR126 EQU   LCCA+416
LCCARSGR EQU   LCCA+352
LCCAXGR3 EQU   LCCA+288
LCCAXGR2 EQU   LCCA+224
LCCAXGR1 EQU   LCCA+160
LCCACR0  EQU   LCCA+156
LCCAMCR1 EQU   LCCA+152
LCCAPVAD EQU   LCCA+148
LCCAPINT EQU   LCCA+144
LCCAPPSW EQU   LCCA+136
LCCAPGR2 EQU   LCCA+72
LCCAPGR1 EQU   LCCA+8
LCCARV77 EQU   LCCA+6
LCCACPUA EQU   LCCA+4
LCCALCCA EQU   LCCA
WSACASMS EQU   WSAC+60
WSACASMD EQU   WSAC+56
WSACCCH  EQU   WSAC+52
WSACRRSA EQU   WSAC+48
WSACREST EQU   WSAC+44
WSACRSTI EQU   WSAC+40
WSACABTM EQU   WSAC+36
WSACMF1  EQU   WSAC+32
WSACEDS0 EQU   WSAC+28
WSACIOS  EQU   WSAC+24
WSACRTMK EQU   WSAC+20
WSACACR  EQU   WSAC+16
WSACTIME EQU   WSAC+12
WSACGTF  EQU   WSAC+4
WSACCWSA EQU   WSAC
DMDTEND  EQU   DMDT+20
DMDTRUC  EQU   DMDT+16
DMDTRUA  EQU   DMDT+6
DMDTWT   EQU   DMDT+3
DMDTHI   EQU   DMDT+2
DMDTLO   EQU   DMDT+1
DMDTNO   EQU   DMDT
RMEPSND  EQU   RMEP+32
RMEPEND  EQU   RMEP+16
RMEPVFL  EQU   RMEPFLG
RMEPERA  EQU   RMEPEPB+4
OUXBEND  EQU   OUXB+144
OUXBTSW  EQU   OUXB+140
OUXBFIXC EQU   OUXB+138
OUXBNVC  EQU   OUXB+136
OUXBUIC  EQU   OUXB+134
OUXBVSC  EQU   OUXB+132
OUXBILS  EQU   OUXB+128
OUXBRSV1 EQU   OUXB+126
OUXBWCT  EQU   OUXB+124
OUXBPRS  EQU   OUXB+120
OUXBSTD  EQU   OUXB+116
OUXBITD  EQU   OUXB+112
OUXBMSS  EQU   OUXB+104
OUXBCPS  EQU   OUXB+96
OUXBAET  EQU   OUXB+92
OUXBTRR  EQU   OUXB+88
OUXBJBR  EQU   OUXB+84
OUXBTRT  EQU   OUXB+80
OUXBTRS  EQU   OUXB+76
OUXBJBT  EQU   OUXB+72
OUXBJBS  EQU   OUXB+68
OUXBTRC  EQU   OUXB+64
OUXBNQT  EQU   OUXB+60
OUXBIOSM EQU   OUXB+56
OUXBSTC  EQU   OUXB+54
OUXBIOS  EQU   OUXB+52
OUXBSTCT EQU   OUXB+48
OUXBCAPR EQU   OUXB+44
OUXBCAPI EQU   OUXB+40
OUXBVAMR EQU   OUXB+36
OUXBVAMO EQU   OUXB+32
OUXBVAMI EQU   OUXB+28
OUXBPREC EQU   OUXB+24
OUXBPOUT EQU   OUXB+20
OUXBPIN  EQU   OUXB+16
OUXBRSW  EQU   OUXB+12
OUXBMET  EQU   OUXB+8
OUXBPET  EQU   OUXB+4
OUCBEND  EQU   OUCB+136
OUCBNTSP EQU   OUCB+134
OUCBNDS  EQU   OUCB+132
OUCBPST  EQU   OUCB+120
OUCBPS2  EQU   OUCBPSS+4
OUCBPS1  EQU   OUCBPSS
OUCBIOSM EQU   OUCB+108
OUCBTMP  EQU   OUCB+104
OUCBR03  EQU   OUCB+102
OUCBIOR  EQU   OUCB+100
OUCBCF2  EQU   OUCBCFL
OUCBRSM  EQU   OUCBCFL
OUCBWSS  EQU   OUCB+78
OUCBPSO  EQU   OUCB+76
OUCBTMO  EQU   OUCB+72
OUCBTMS  EQU   OUCB+68
OUCBMSO  EQU   OUCB+64
OUCBIOC  EQU   OUCB+60
OUCBCPU  EQU   OUCB+56
OUCBWMS  EQU   OUCB+52
OUCBTMW  EQU   OUCB+48
OUCBIMCB EQU   OUCB+44
OUCBSWC  EQU   OUCB+38
OUCBDMN  EQU   OUCB+36
OUCBWMG  EQU   OUCB+32
OUCBPGP  EQU   OUCB+31
OUCBR40  EQU   OUCB+30
OUCBR30  EQU   OUCB+29
OUCBSPG  EQU   OUCB+28
OUCBRDP  EQU   OUCB+27
OUCBRPG  EQU   OUCB+25
OUCBNPG  EQU   OUCB+24
OUCBUF7  EQU   OUCBUFL
OUCBUF6  EQU   OUCBUFL
OUCBUF5  EQU   OUCBUFL
OUCBTSWC EQU   OUCBUFL
OUCBTSWP EQU   OUCBUFL
OUCBRSWP EQU   OUCBUFL
OUCBNQC  EQU   OUCB+22
OUCBMWT  EQU   OUCBEFL
OUCBQSC  EQU   OUCBEFL
OUCBQSS  EQU   OUCBEFL
OUCBNQF  EQU   OUCBEFL
OUCBCIM  EQU   OUCBEFL
OUCBOWT  EQU   OUCBEFL
OUCBTRM  EQU   OUCBEFL
OUCBLWT  EQU   OUCBEFL
OUCBINC  EQU   OUCBTFL
OUCBINP  EQU   OUCBTFL
OUCBMAR  EQU   OUCBTFL
OUCBPCH  EQU   OUCBTFL
OUCBRTR  EQU   OUCBTFL
OUCBNTR  EQU   OUCBTFL
OUCBSTR  EQU   OUCBTFL
OUCBATR  EQU   OUCBTFL
OUCBASW  EQU   OUCBAFL
OUCBNWT  EQU   OUCBAFL
OUCBR02  EQU   OUCBAFL
OUCBJSR  EQU   OUCBAFL
OUCBAF0  EQU   OUCBAFL
OUCBDTA  EQU   OUCBYFL
OUCBMNT  EQU   OUCBYFL
OUCBLOG  EQU   OUCBYFL
OUCBSTT  EQU   OUCBYFL
OUCBPSTE EQU   OUCBYFL
OUCBPVL  EQU   OUCBSFL
OUCBCTI  EQU   OUCBSFL
OUCBQF7  EQU   OUCBQFL
OUCBQF6  EQU   OUCBQFL
OUCBQSFL EQU   OUCBQFL
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBRV43 EQU   ASCBSRQ4
ASCBRV42 EQU   ASCBSRQ4
ASCBRV41 EQU   ASCBSRQ4
ASCBRV40 EQU   ASCBSRQ4
ASCBRV39 EQU   ASCBSRQ4
ASCBRV38 EQU   ASCBSRQ4
ASCBRV37 EQU   ASCBSRQ4
ASCBRV36 EQU   ASCBSRQ4
ASCBRV35 EQU   ASCBSRQ3
ASCBRV34 EQU   ASCBSRQ3
ASCBRV33 EQU   ASCBSRQ3
ASCBRV32 EQU   ASCBSRQ3
ASCBRV31 EQU   ASCBSRQ3
ASCBRV30 EQU   ASCBSRQ3
ASCBRV29 EQU   ASCBSRQ3
ASCBRV28 EQU   ASCBSRQ3
ASCBRV27 EQU   ASCBSRQ2
ASCBRV26 EQU   ASCBSRQ2
ASCBRV25 EQU   ASCBSRQ2
ASCBRV24 EQU   ASCBSRQ2
ASCBRV23 EQU   ASCBSRQ2
ASCBRV22 EQU   ASCBSRQ2
ASCBRV21 EQU   ASCBSRQ2
ASCBRV20 EQU   ASCBSRQ2
ASCBRV19 EQU   ASCBSRQ1
ASCBRV18 EQU   ASCBSRQ1
ASCBRV17 EQU   ASCBSRQ1
ASCBRV16 EQU   ASCBSRQ1
ASCBRV15 EQU   ASCBSRQ1
ASCBRV14 EQU   ASCBSRQ1
ASCBRV13 EQU   ASCBSRQ1
ASCBSTA  EQU   ASCBSRQ1
ASCBJBNS EQU   ASCB+176
ASCBJBNI EQU   ASCB+172
ASCBMCC  EQU   ASCB+168
ASCBRTWA EQU   ASCB+164
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBQECB EQU   ASCB+136
ASCBLSQH EQU   ASCBLKGP+4
ASCBLOCK EQU   ASCBLKGP
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSRBS EQU   ASCB+118
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBS2S  EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBASXB EQU   ASCB+108
ASCBTMCH EQU   ASCB+104
ASCBNSWP EQU   ASCBFLG1
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBABNT EQU   ASCBFLG1
ASCBTERM EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBWAIT EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBAFFN EQU   ASCBFW1
ASCBDUMP EQU   ASCB+96
ASCBRV44 EQU   ASCB+92
ASCBUBET EQU   ASCB+88
ASCBJSTL EQU   ASCB+80
ASCBEWST EQU   ASCB+72
ASCBEJST EQU   ASCB+64
ASCBTSB  EQU   ASCB+60
ASCBCSCB EQU   ASCB+56
ASCBRSMA EQU   ASCBRSM+1
ASCBRV54 EQU   ASCBRSMF
ASCBRV53 EQU   ASCBRSMF
ASCBRV52 EQU   ASCBRSMF
ASCBRV51 EQU   ASCBRSMF
ASCBVEQR EQU   ASCBRSMF
ASCBN2LP EQU   ASCBRSMF
ASCB1LPU EQU   ASCBRSMF
ASCB2LPU EQU   ASCBRSMF
ASCBLDA  EQU   ASCB+48
ASCBSTOR EQU   ASCB+44
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBASID EQU   ASCB+36
ASCBCPUS EQU   ASCB+32
ASCBSPL  EQU   ASCB+28
ASCBIOSP EQU   ASCB+24
ASCBSYNC EQU   ASCBSUPC+4
ASCBSVRB EQU   ASCBSUPC
ASCBCMSF EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBFWDP EQU   ASCB+4
ASCBASCB EQU   ASCB
ASCBEGIN EQU   ASCB
RRPAEND  EQU   RRPA+24
RRPARTC  EQU   RRPA+11
RRPAKEY  EQU   RRPA+10
RRPARCI  EQU   RRPAFLG+1
RRPARTI  EQU   RRPAFLG+1
RRPAF11  EQU   RRPAFLG+1
RRPAIPS  EQU   RRPAFLG+1
RRPAWAR  EQU   RRPAFLG+1
RRPAF07  EQU   RRPAFLG
RRPAF05  EQU   RRPAFLG
RRPAF04  EQU   RRPAFLG
RRPADSP  EQU   RRPAFLG
RRPAENB  EQU   RRPAFLG
RRPADSB  EQU   RRPAFLG
RRPAVLU  EQU   RRPAINP
@NM00002 EQU   RRPAFLG0
RRPANSWI EQU   RRPAFLG0
RRPAASD  EQU   RRPAINC
EPSTEND  EQU   EPST+80
EPSTCSI  EQU   RMEPBCSI
EPSTCSO  EQU   RMEPBCSO
EPDTEND  EQU   EPDT+96
RMEPBRPS EQU   EPDT+80
RMEPBHIT EQU   EPDT+64
RMEPBUXB EQU   EPDT+48
RMEPBIL4 EQU   EPDT+32
RMEPBDEL EQU   EPDT+16
RMEPBIPS EQU   EPDT
EPATEND  EQU   EPAT+400
RMEPBEQ1 EQU   EPAT+336
RMEPBAP1 EQU   EPAT+304
RMEPBCL1 EQU   EPAT+272
RMEPBWM2 EQU   EPAT+240
RMEPBIL1 EQU   EPAT+208
RMEPBASM EQU   EPAT+176
RMEPBMS2 EQU   EPAT+160
RMEPBPR5 EQU   EPAT+144
RMEPBMS6 EQU   EPAT+112
RMEPBSQA EQU   EPAT+96
RMEPBRM2 EQU   EPAT+64
RMEPBRM1 EQU   EPAT+32
RMSBEND  EQU   RMSB+120
RMSBRA9  EQU   RMSB+116
RMSBIL0  EQU   RMSB+112
RMSBCL0  EQU   RMSB+108
RMSBRA6  EQU   RMSB+104
RMSBNOP  EQU   RMSB+100
RMSBSET  EQU   RMSB+96
RMSBWR6  EQU   RMSB+92
RMSBWR4  EQU   RMSB+88
RMSBTRC  EQU   RMSB+84
RMSBWMY  EQU   RMSB+80
RMSBWMR  EQU   RMSB+76
RMSBWMQ  EQU   RMSB+72
RMSBWMO  EQU   RMSB+68
RMSBWMN  EQU   RMSB+64
RMSBWMK  EQU   RMSB+60
RMSBWM4  EQU   RMSB+56
RMSBWM1  EQU   RMSB+52
RMSBWM5  EQU   RMSB+48
RMSBCRN  EQU   RMSB+40
RMSBI10  EQU   RMSB+32
RMSBI09  EQU   RMSB+28
RMSBR24  EQU   RMSB+24
RMSBI03  EQU   RMSB+4
RMEXEND  EQU   RMEX+64
RMEXSRE  EQU   RMEX+60
RMEXXPE  EQU   RMEX+56
RMEXRR2  EQU   RMEX+52
RMEXRR1  EQU   RMEX+48
RMEXCET  EQU   RMEX+40
RMEXCXX  EQU   RMEX+36
RMEXEVT  EQU   RMEPBEVT
RMCAEND  EQU   RMCA+168
RMCAR90  EQU   RMCA+164
RMCAUSSC EQU   RMCASRC+36
RMCAEXSC EQU   RMCASRC+32
RMCANQSC EQU   RMCASRC+28
RMCARQSC EQU   RMCASRC+24
RMCADWSC EQU   RMCASRC+20
RMCARSSC EQU   RMCASRC+16
RMCAXSSC EQU   RMCASRC+12
RMCALWSC EQU   RMCASRC+8
RMCATISC EQU   RMCASRC+4
RMCATOSC EQU   RMCASRC
RMCAR14  EQU   RMCA+116
RMCAR13  EQU   RMCA+112
RMCAWKA  EQU   RMCA+80
RMCAMAS  EQU   RMCA+76
RMCAR20  EQU   RMCA+74
RMCABCPG EQU   RMCA+73
RMCALGPG EQU   RMCA+72
RMCAISV  EQU   RMCA+70
RMCAR11  EQU   RMCA+68
RMCAR10  EQU   RMCA+60
RMCARSV9 EQU   RMCA+56
RMCARSV8 EQU   RMCA+44
RMCARSV7 EQU   RMCA+40
RMCARSVF EQU   RMCAFLGS
RMCASAAF EQU   RMCAFLGS
RMCARSV5 EQU   RMCA+32
RMCARSV4 EQU   RMCA+28
RMCARSV3 EQU   RMCA+24
RMCATRS  EQU   RMCA+16
RMCATQS  EQU   RMCA+12
RMCARSV2 EQU   RMCA+10
RMCARSV1 EQU   RMCA+8
RMCAINUS EQU   RMCA+6
RMCAR04  EQU   RMCA+4
RMCANAME EQU   RMCA
RMPTEND  EQU   RMPT+72
RMPTOPE  EQU   RMPT+66
RMPTOPI  EQU   RMPT+63
RMPTOPC  EQU   RMPT+60
RMPTWMET EQU   RMPT+48
RMPTRSV3 EQU   RMPT+38
RMPTRSV2 EQU   RMPT+36
RMPTRSV1 EQU   RMPT+32
RMPTTCS  EQU   RMPT+20
RMPTIMN  EQU   RMPT+16
RMPTERV  EQU   RMPT+12
RMPTNAME EQU   RMPT
RCTEND   EQU   RCT+88
RCVRSVF3 EQU   RCT+84
RCVRSVF2 EQU   RCT+80
RCVTAPAD EQU   RCT+76
RCVRSVF1 EQU   RCT+74
RCVTOTDF EQU   RCT+72
RCVBPTTM EQU   RCT+68
RCVBPTCT EQU   RCT+64
RCVASMQ  EQU   RCT+60
RCVAVQP  EQU   RCT+56
RCVCPUC  EQU   RCT+52
RCVUICC  EQU   RCT+48
RCVPTR   EQU   RCT+46
RCVASMQA EQU   RCT+44
RCVAVQC  EQU   RCT+42
RCVCPUA  EQU   RCT+40
RCVUICA  EQU   RCT+38
RCVCTMC  EQU   RCT+36
RCCRSVF3 EQU   RCT+32
RCCRSVF2 EQU   RCT+28
RCCRSVF1 EQU   RCT+26
RCCLCHRR EQU   RCT+24
RCCLCHUT EQU   RCT+22
RCCTOTUT EQU   RCT+20
RCCASMTH EQU   RCT+18
RCCASMTL EQU   RCT+16
RCCPTRTH EQU   RCT+14
RCCPTRTL EQU   RCT+12
RCCCPUTH EQU   RCT+10
RCCCPUTL EQU   RCT+8
RCCUICTH EQU   RCT+6
RCCUICTL EQU   RCT+4
RCTRCT   EQU   RCT
MCTEND   EQU   MCT+96
MCVRSVF3 EQU   MCT+92
MCVRSVF2 EQU   MCT+88
MCVRSVF1 EQU   MCT+84
MCCINTMX EQU   MCT+80
MCCPR1IN EQU   MCT+76
MCCUICIN EQU   MCT+72
MCCUICBD EQU   MCT+68
MCTRSVB1 EQU   MCT+67
MCTXRSVD EQU   MCT+66
MCTFX2   EQU   MCTOFLGS
MCTFX1   EQU   MCTOFLGS
MCTSMS2  EQU   MCTOFLGS
MCTSMS1  EQU   MCTOFLGS
MCTAMS2  EQU   MCTOFLGS
@NM00001 EQU   MCTOFLGS
MCTASM2  EQU   MCTOFLGS
MCTASM1  EQU   MCTOFLGS
MCTSF04  EQU   MCTSFLGS
MCTFAVQ  EQU   MCTSFLGS
MCTAVQ1  EQU   MCTSFLGS
MCTSQA2  EQU   MCTSFLGS
MCTSQA1  EQU   MCTSFLGS
MCVAVQC  EQU   MCT+60
MCVFRCNT EQU   MCT+58
MCVSTCRI EQU   MCT+56
MCCEND   EQU   MCT+56
MCCASMT2 EQU   MCT+54
MCCASMT1 EQU   MCT+52
MCCRSVH1 EQU   MCT+50
MCCPLUS  EQU   MCT+48
MCCMS403 EQU   MCT+44
MCCMS402 EQU   MCT+40
MCCMS401 EQU   MCT+36
MCCMS400 EQU   MCT+32
MCCMS203 EQU   MCT+28
MCCMS202 EQU   MCT+24
MCCMS201 EQU   MCT+20
MCCMS200 EQU   MCT+16
MCCMS102 EQU   MCT+12
MCCMS101 EQU   MCT+8
MCCMS100 EQU   MCT+4
MCTMCT   EQU   MCT
ICTEND   EQU   ICT+88
ICTRSVB3 EQU   ICT+87
ICTRSVB2 EQU   ICT+86
ICTRSVB1 EQU   ICT+85
ICT003   EQU   ICTFLAGS
ICTIOL   EQU   ICTFLAGS
ICTDRSV4 EQU   ICTFLAGS
ICVIRSV3 EQU   ICT+80
ICVULCBT EQU   ICT+76
ICVOLCBT EQU   ICT+72
ICVLCBPT EQU   ICT+68
ICVLUTBT EQU   ICT+64
ICCEND   EQU   ICT+64
ICCRSV01 EQU   ICT+62
ICCEDSUT EQU   ICT+60
ICCSRSV2 EQU   ICT+58
ICCSIGUP EQU   ICT+56
ICCINDAT EQU   ICT+52
ICCINLOT EQU   ICT+48
ICCINHIT EQU   ICT+44
ICCDAUTH EQU   ICT+42
ICCLOUTH EQU   ICT+40
ICCHIUTH EQU   ICT+38
ICCDASF2 EQU   ICT+36
ICCDASF1 EQU   ICT+34
ICCMINRV EQU   ICT+32
ICCMAXRV EQU   ICT+30
ICCRVSCF EQU   ICT+28
ICCMNIOR EQU   ICT+26
ICCLCHN  EQU   ICT+24
ICCLCLST EQU   ICT+20
ICCMNSWP EQU   ICT+16
ICCMNUIN EQU   ICT+12
ICCMXICT EQU   ICT+8
ICCMRSV1 EQU   ICT+4
ICTICT   EQU   ICT
CCVEND   EQU   CCT+128
CCTFLG2  EQU   CCT+125
CCTALL   EQU   CCTFLG1
CCVCPUCT EQU   CCT+122
CCVENQCT EQU   CCT+120
CCVLGFMC EQU   CCT+118
CCVLGUTL EQU   CCT+116
CCVR07   EQU   CCT+114
CCVR06   EQU   CCT+112
CCVUTILP EQU   CCT+110
CCVR05   EQU   CCT+108
CCVIMBBT EQU   CCT+104
CCVEJST  EQU   CCT+100
CCVPGCPF EQU   CCT+96
CCVRVSWF EQU   CCT+92
CCVRBSTD EQU   CCT+88
CCVR04   EQU   CCT+84
CCVRBSWT EQU   CCT+80
CCVR03   EQU   CCT+76
CCCEND   EQU   CCT+76
CCCRSVH1 EQU   CCT+74
CCCSCFC2 EQU   CCT+72
CCCSCFC1 EQU   CCT+70
CCCR02   EQU   CCT+68
CCCSIGUR EQU   CCT+66
CCCSIGDP EQU   CCT+64
CCCSCFAC EQU   CCT+62
CCCMINRV EQU   CCT+60
CCCMAXRV EQU   CCT+58
CCCLOSCF EQU   CCT+56
CCCHISCF EQU   CCT+54
CCCUTLOT EQU   CCT+52
CCCUTHIT EQU   CCT+50
CCCAPRHT EQU   CCT+48
CCCAPRLT EQU   CCT+46
CCCR01   EQU   CCT+44
CCCAPGDP EQU   CCT+42
CCCAPMDP EQU   CCT+40
CCCAPLDP EQU   CCT+38
CCCAPBDP EQU   CCT+36
CCCAPROT EQU   CCT+34
CCCAPDIV EQU   CCT+32
CCCRSVF1 EQU   CCT+28
CCCMNSIN EQU   CCT+24
CCCMNUIN EQU   CCT+20
CCCAPDEL EQU   CCT+16
CCCAPMAX EQU   CCT+12
CCCAPMIN EQU   CCT+8
CCCAPMET EQU   CCT+4
CCTCCT   EQU   CCT
RMCTEND  EQU   RMCT+192
RMCTR50  EQU   RMCT+190
RMCTDMNC EQU   RMCT+188
RMCTTOCI EQU   RMCT+160
RMCTCPID EQU   RMCT+156
RMCTTELM EQU   RMCT+152
RMCTF09  EQU   RMCTFLGS+1
RMCTMFS  EQU   RMCTFLGS+1
RMCTF07  EQU   RMCTFLGS+1
RMCTF06  EQU   RMCTFLGS
RMCTRSV2 EQU   RMCTFLGS
RMCTSTW  EQU   RMCTFLGS
RMCTRSV1 EQU   RMCTFLGS
RMCTINIT EQU   RMCTFLGS
RMCTF03  EQU   RMCTFLGS
RMCTMFA  EQU   RMCTFLGS
RMCTRQSV EQU   RMCT+144
RMCTTOC  EQU   RMCT+128
RMCTR10  EQU   RMCT+116
RMCTWAMT EQU   RMCT+88
RMCTWAST EQU   RMCT+84
RMCTEPPR EQU   RMCT+80
RMCTFLTM EQU   RMCT+76
RMCTEPET EQU   RMCT+72
RMCTITT  EQU   RMCT+68
RMCTADJC EQU   RMCT+64
RMCTEPBG EQU   RMCT+60
RMCTEPPA EQU   RMCT+48
RMCTRMSB EQU   RMCT+44
RMCTRMEX EQU   RMCT+40
RMCTRMPD EQU   RMCT+36
RMCTRLCT EQU   RMCT+28
RMCTWMST EQU   RMCT+24
RMCTRMCA EQU   RMCT+20
RMCTRMPT EQU   RMCT+16
RMCTMCT  EQU   RMCT+12
RMCTICT  EQU   RMCT+8
RMCTCCT  EQU   RMCT+4
RMCTNAME EQU   RMCT
@NM00026 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00025 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSALITA  EQU   PSA+764
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00024 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00023 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSAULCMS EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00022 EQU   FLCFSA
@NM00021 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00020 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00019 EQU   FLCIOA
@NM00018 EQU   FLCMCLA+15
@NM00017 EQU   FLCMCLA+14
@NM00016 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00015 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00014 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00013 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00012 EQU   FLCPER
@NM00011 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00010 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00009 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00008 EQU   FLCPIILC
@NM00007 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00006 EQU   FLCSVILC
@NM00005 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00004 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00003 EQU   FLCICCW2+4
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00206 EQU   @RC00205
@RC00233 EQU   @RC00220
RMCSIL5  EQU   @RC00220
@RC00263 EQU   @RC00255
@RF00355 EQU   @RC00352
@RT00367 EQU   RMCAPEND
@RT00373 EQU   RMCAPEND
@RT00381 EQU   RMCAPEND
@RF00411 EQU   RMCAPEND
@RT00422 EQU   RMCAPEND
@RT00428 EQU   RMCAPEND
@RT00434 EQU   RMCAPEND
@RT00440 EQU   RMCAPEND
@RT00445 EQU   RMCAPEND
@RF00453 EQU   RMCAPEND
@RC00207 EQU   @RC00206
@RT00229 EQU   RMCSIL5
@ENDDATA EQU   *
         END   IRARMCTL,(C'PLS2008',0701,78177)
