         TITLE 'IRARMIPS - SYSTEM RESOURCES MANAGER LIST PROCESSOR     *
                        '
         MACRO
&MFSNAME MFSYSTR &INITIAL,&ALTLST,&RCALTLS
         AGO   .BEGIN
* MODULE NAME = MFSYSTR                                            *
*                                                                  *
* DESCRIPTIVE NAME = MF/1 SYNTAX TABLE STRUCTURE ENTRY             *
*                                                                  *
* COPYRIGHT = NONE                                                 *
*                                                                  *
* STATUS = RELEASE 2, VERSION 0                                    *
*                                                                  *
* FUNCTION = EXECUTABLE MACRO FOR THE SYNTAX TABLE (MFSYNTAB).     *
*            IT DESCRIBES A STRUCTURE ENTRY. (SEE METHOD OF INVOCA-*
*            TION.)                                                *
*                                                                  *
* NOTES = NONE                                                     *
*                                                                  *
* MODULE TYPE = BAL EXECUTABLE MACRO                               *
*                                                                  *
* CHANGE ACTIVITY = A000000-999999                           Y02150*
*                                                                  *
* MACCOMP Y-2 SC1CQ/GAM20                                          *
*                                                                  *
* MACMEAN MFSYSTR MEANS MF/1 SYNTAX TABLE STRUCTURE ENTRY          *
*                                                                  *
* METHOD OF INVOCATION                                             *
*    BAL - MFSYSTR A,B,C                                           *
*        WHERE                                                     *
*             A -'1' INDICATES INITIAL STRUCTURE                   *
*                '0' OTHERWISE                                     *
*             B -ADDRESS OF A LIST OF ALTERNATIVE ENTRIES (REGULAR)*
*             C -ADDRESS OF A LIST OF RECURSIVE ALTERNATIVES       *
*                                                                  *
*    PLS - NONE                                                    *
.BEGIN   ANOP
* MACDATE Y-2 73026                                                *
         AIF (NOT ('&INITIAL' EQ '1' AND '&RCALTLS' NE '0')).A
&MFSNAME DC    X'C0' .            INITIAL STRUCTURE WITH RECURSIVE
*                                 ALTERNATIVES
         AGO   .D
.A       AIF   (NOT ('&INITIAL' EQ '1' AND '&RCALTLS' EQ '0')).B
&MFSNAME DC    X'80' .            INITIAL STRUCTURE - NOT RECURSIVE
         AGO   .D
.B       AIF   (NOT ('&INITIAL' NE '1' AND '&RCALTLS' NE '0')).C
&MFSNAME DC    X'40' .            RECURSIVE ALTERNATIVES EXIST
         AGO   .D
.C       AIF   (NOT ('&INITIAL' NE '1' AND '&RCALTLS' EQ '0')).D
&MFSNAME DC    X'00' .            NOT INITIAL STRUCUTRE - NO RECURSIVE
*                                 ALTERNATIVES
.D       ANOP
         DC    AL3(0) .           RESERVED
         DC    A(&ALTLST) .       ALTERNATIVE LIST ADDRESS
         DC    A(&RCALTLS) .      RECURSIVE ALTERNATIVE
         MEND
         MACRO
&MFANAME MFSYALT &ENDLST,&ITMLST,&INITRTN,&INITPRM
         AGO   .BEGIN
* MODULE NAME = MFSYALT                                            *
*                                                                  *
* DESCRIPTIVE NAME = MF/1 SYNTAX TABLE ALTERNATIVE ENTRY           *
*                                                                  *
* COPYRIGHT = NONE                                                 *
*                                                                  *
* STATUS = RELEASE 2, LEVEL 0                                      *
*                                                                  *
* FUNCTION = EXECUTABLE MACRO FOR THE SYNTAX TABLE (MFSYNTAB).     *
*            IT DESCRIBES AN ALTERNATIVE ENTRY.  (SEE METHOD OF    *
*            INVOCATION                                            *
*                                                                  *
* NOTES = NONE                                                     *
*                                                                  *
* MODULE TYPE = EXECUTABLE MACRO (BAL)                             *
*                                                                  *
* CHANGE ACTIVITY = A000000-999999                           Y02150*
*                                                                  *
* MACCOMP Y-2 SC1CQ/GAM20                                          *
*                                                                  *
* MACMEAN MFSYALT MEANS MF/1 SYNTAX TABLE ALTERNATIVE ENTRY        *
*                                                                  *
* METHOD OF INVOCATION                                             *
*    BAL - MFSYALT A,B,C,D                                         *
*        WHERE                                                     *
*             A - '1' INDICATES END OF ALTERNATIVES LIST           *
*                 '0' OTHERWISE                                    *
*             B - ADDRESS OF AN ITEM ENTRY                         *
*             C - ADDRESS OF AN INITIALIZATION ROUTINE OR ZERO     *
*             D - ADDRESS OF A PARAMETER LIST TO BE PASSED TO THE  *
*                 INITIALIZATION ROUTINE                           *
*                                                                  *
*    PLS - NONE                                                    *
.BEGIN   ANOP
* MACDATE Y-2 73026                                                *
         AIF   (NOT ('&ENDLST' EQ '1' AND '&INITRTN' NE '0')).A
&MFANAME DC    X'C0' .            END OF LIST AND INITIALIZATION
*                                 ROUTINE EXISTS
         AGO   .D
.A       AIF   (NOT ('&ENDLST' EQ '1' AND '&INITRTN' EQ '0')).B
&MFANAME DC    X'80' .            END OF LIST
         AGO   .D
.B       AIF   (NOT ('&ENDLST' NE '1' AND '&INITRTN' NE '0')).C
&MFANAME DC    X'40' .            INITIALIZATION ROUTINE EXISTS
         AGO   .D
.C       AIF (NOT ('&ENDLST' NE '1' AND '&INITRTN' EQ '0')).D
&MFANAME DC    X'00' .            NOT END OF LIST - NO INITIALIZATION
*                                 ROUTINE EXISTS
.D       ANOP
         DC    AL3(0) .           RESERVED
         DC    A(&ITMLST) .       ADDRESS OF AN ITEM LIST
         DC    A(&INITRTN) .      INITIALIZATION RTN ADDRESS
         DC    A(&INITPRM) .      ADDRESS OF A PARAMETER LIST
*                                 FOR INITIALIZATION ROUTINE
         MEND
         MACRO
&MFINAME MFSYITM &ENDLST,&RECGNZR,&TRMDEF,&RCGPARM
         AGO   .BEGIN
* MODULE NAME = MFSYITM                                            *
*                                                                  *
* DESCRIPTIVE NAME = MF/1 SYNTAX TABLE ITEM ENTRY                  *
*                                                                  *
* COPYRIGHT = NONE                                                 *
*                                                                  *
* STATUS = RELEASE 2, LEVEL 0                                      *
*                                                                  *
* FUNCTION = EXECUTABLE MACRO FOR MF/1 SYNTAX TABLE (MFSYNTAB).    *
*                                                                  *
* NOTES = NONE                                                     *
*                                                                  *
* MODULE TYPE = BAL EXECUTABLE MACRO                               *
*                                                                  *
* CHANGE ACTIVITY = A000000-999999                           Y02150*
*                                                                  *
* MACCOMP Y-2 SC1SQ/GAM20                                          *
*                                                                  *
* MACMEAN MFSYITM MEANS MF/1 SYNTAX TABLE ITEM ENTRY               *
*                                                                  *
* METHOD OF INVOCATION                                             *
*    BAL - MFSYITM A,B,C,D                                         *
*        WHERE                                                     *
*             A - '1' INDICATES END OF ITEM LIST                   *
*                 '0' OTHERWISE                                    *
*             B - ADDRESS OF A RECOGNIZER ROUTINE OR A STRUCTURE   *
*                 ENTRY                                            *
*             C - '1' INDICATES ITEM ENTRY IS A TERMINAL TYPE      *
*                 '0' INDICATES ITEM ENTRY IS A STRUCTURE TYPE     *
*             D - ADDRESS OF A PARAMETER LIST TO BE PASSED TO THE  *
*                 RECOGNIZE ROUTINE OR 0.                          *
*                                                                  *
*    PLS - NONE                                                    *
.BEGIN   ANOP
* MACDATE Y-2 73026                                                *
         AIF   (NOT ('&ENDLST' EQ '1' AND '&TRMDEF' EQ '1')).A
&MFINAME DC    X'C0' .            END OF LIST AND ITEM IS
*                                 TERMINAL TYPE
         AGO   .D
.A       AIF   (NOT ('&ENDLST' EQ '1' AND '&TRMDEF' NE '1')).B
&MFINAME DC    X'80'              END OF LIST
         AGO   .D
.B       AIF   (NOT ('&ENDLST' NE '1' AND '&TRMDEF' EQ '1')).C
&MFINAME DC    X'40'              ITEM IS TERMINAL TYPE
         AGO   .D
.C       AIF   (NOT ('&ENDLST' NE '1' AND '&TRMDEF' NE '1')).D
&MFINAME DC    X'00'              NOT END OF LIST AND ITEM IS
*                                 DEFINED TYPE
.D       ANOP
         DC    AL3(0) .           RESERVED
         DC    A(&RECGNZR) .      ADDRESS OF A RECOGNIZER
*                                 OR STRUCTURE ENTRY
         DC    A(&RCGPARM) .      ADDRESS OF A PARAMETER LIST
*                                 PASSED TO RECOGNIZER ROUTINE
         MEND
IRARMIPS CSECT ,                                                   0002
@MAINENT DS    0H                                                  0002
         USING *,@15                                               0002
         B     @PROLOG                                             0002
         DC    AL2(@EP00002-@MAINENT)
IRARMFRE DS    0H                                                  0002
         USING *,@15                                               0002
         B     @PROLOG                                             0002
         DC    AL2(@EP00768-IRARMFRE)
         ENTRY IRARMFRE
IRARMOPT DS    0H                                                  0002
         USING *,@15                                               0002
         B     @PROLOG                                             0002
         DC    AL2(@EP00796-IRARMOPT)
         ENTRY IRARMOPT
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0002
         BALR  @09,0                                               0002
@PSTART  LA    @10,4095(,@09)                                      0002
         LA    @11,4095(,@10)                                      0002
         LA    @12,4095(,@11)                                      0002
         USING @PSTART,@09                                         0002
         USING @PSTART+4095,@10                                    0002
         USING @PSTART+8190,@11                                    0002
         USING @PSTART+12285,@12                                   0002
         L     @00,@SIZDATD                                        0002
         GETMAIN  R,LV=(0)
         LR    @08,@01                                             0002
         USING @DATD,@08                                           0002
         ST    @13,@SA00001+4                                      0002
         LM    @15,@01,16(@13)                                     0002
         ST    @08,8(,@13)                                         0002
         LR    @13,@08                                             0002
         AH    @15,4(,@15)                                         0002
         BR    @15                                                 0002
@EP00002 MVC   @PC00001(12),0(@01)                                 0002
*   IPWMSTAD=ZERO;                  /* ZERO OUTPUT PARM              */
         L     @03,@PC00001+4                                      0029
         SLR   @15,@15                                             0029
         ST    @15,IPWMSTAD(,@03)                                  0029
*   RMCTPTR=CVTOPCTP;               /* ADDR OF SYSTEM RESOURCES    0030
*                                      MANAGER CONTROL TABLE         */
         L     @01,CVTPTR                                          0030
         L     RMCTPTR,CVTOPCTP(,@01)                              0030
*   RMPTPTR=RMCTRMPT;               /* ADDR OF RESOURCE MANAGER    0031
*                                      PARAMETER TABLE               */
         L     @15,RMCTRMPT(,RMCTPTR)                              0031
         ST    @15,RMPTPTR                                         0031
*/*  SET  MFRTPTR TO THE ADDRESS OF THE ROUTINE WHICH PROCESSES      */
*/*  IPS LIST DATA                                                   */
*                                                                  0032
*   MFRTPTR=ADDR(RMIPINIT);         /* ADDR OF IPS LIST PROCESSING 0032
*                                      ROUTINE                       */
         LA    MFRTPTR,RMIPINIT                                    0032
*/* INITIALIZE  ERROR MESSAGE BUFFERS                                */
*                                                                  0033
*   IPMSGCOM=IPMSGCTX;              /* COMMON MESSAGE TEXT           */
         MVC   IPMSGCOM(20),IPMSGCTX                               0033
*   IPMSGIPS=IPIPSID;               /* IPS MEMBER SUFFIX             */
         L     @02,@PC00001                                        0034
         MVC   IPMSGIPS(2),IPIPSID(@02)                            0034
*   IPMSGIPA=IPMSGID(1);            /* MESSAGE ID IN INPUT STRING  0035
*                                      MESSAGE                       */
         MVI   IPMSGIPA+8,C' '                                     0035
         MVC   IPMSGIPA+9(79),IPMSGIPA+8                           0035
         MVC   IPMSGIPA(8),IPMSGID                                 0035
*/*  INVOKE RMIPGM ROUTINE TO CONSTRUCT THE FOLLOWING TABLES-        */
*/*    WORKLOAD MANAGER SPECIFICATION TABLE   - WMST                 */
*                                                                  0036
*   IPWMSTLN=LENGTH(WMST);          /* LENGTH OF WORKLOAD MGR TBL    */
         MVC   IPWMSTLN(4),@CF02023                                0036
*   CALL RMIPGM(IPWMSTAD,IPWMSTLN,WMSTPTR);/* GETMAIN FOR WMST       */
         ST    @03,@AL00001                                        0037
         LA    @15,IPWMSTLN                                        0037
         ST    @15,@AL00001+4                                      0037
         LA    @15,WMSTPTR                                         0037
         ST    @15,@AL00001+8                                      0037
         LA    @01,@AL00001                                        0037
         BAL   @14,RMIPGM                                          0037
*/*    PERFORMANCE GROUP VECTOR TABLE         - WPGVT                */
*                                                                  0038
*   WMSTPGVS=MAXPGE                 /* MAX SIZE OF PERFORMANCE GROUP
*                                      VECTOR TABLE                  */
*       *LENGTH(WPGVTENT);                                         0038
         L     @15,WMSTPTR                                         0038
         MVC   WMSTPGVS(4,@15),@CF02024                            0038
*   CALL RMIPGM(WMSTPGVT,WMSTPGVS,WPGVPTR);/* GETMAIN FOR WPGV       */
         LA    @14,WMSTPGVT(,@15)                                  0039
         ST    @14,@AL00001                                        0039
         LA    @15,WMSTPGVS(,@15)                                  0039
         ST    @15,@AL00001+4                                      0039
         LA    @15,WPGVPTR                                         0039
         ST    @15,@AL00001+8                                      0039
         LA    @01,@AL00001                                        0039
         BAL   @14,RMIPGM                                          0039
*/*    PERFORMANCE OBJECTIVE VECTOR TABLE     - WPOVT                */
*                                                                  0040
*   WMSTPOVS=MAXOBJE                /* MAX SIZE OF PERFORMANCE     0040
*                                      OBJECTIVE VECTOR TABLE        */
*       *LENGTH(WPOVTENT);                                         0040
         L     @15,WMSTPTR                                         0040
         MVC   WMSTPOVS(4,@15),@CF02025                            0040
*   CALL RMIPGM(WMSTPOVT,WMSTPOVS,WPOVPTR);/* GETMAIN FOR WPOV       */
         LA    @14,WMSTPOVT(,@15)                                  0041
         ST    @14,@AL00001                                        0041
         LA    @15,WMSTPOVS(,@15)                                  0041
         ST    @15,@AL00001+4                                      0041
         LA    @15,WPOVPTR                                         0041
         ST    @15,@AL00001+8                                      0041
         LA    @01,@AL00001                                        0041
         BAL   @14,RMIPGM                                          0041
*/*     DOMAIN VECTOR TABLE      - DMVT                      @Z40BPEM*/
*                                                                  0042
*   WMSTDMVS=MAXDMNE*LENGTH(DMVTENT);/* MAX SIZE OF VECTOR TABLE   0042
*                                                            @Z40BPEM*/
         L     @15,WMSTPTR                                         0042
         MVC   WMSTDMVS(4,@15),@CF02026                            0042
*   CALL RMIPGM(WMSTDMVT,WMSTDMVS,DMVTPTR);/* GETMAIN FOR DMVT     0043
*                                                            @Z40BPEM*/
         LA    @14,WMSTDMVT(,@15)                                  0043
         ST    @14,@AL00001                                        0043
         LA    @15,WMSTDMVS(,@15)                                  0043
         ST    @15,@AL00001+4                                      0043
         LA    @15,DMVTPTR                                         0043
         ST    @15,@AL00001+8                                      0043
         LA    @01,@AL00001                                        0043
         BAL   @14,RMIPGM                                          0043
*/*    PERFORMANCE GROUP DESCRIPTOR TABLE     - WPGDT                */
*                                                                  0044
*   WMSTPGDS=TBLSIZE;               /* INITIAL SIZE OF PERF GRP    0044
*                                      DESCRIPTOR TABLE              */
         L     @15,WMSTPTR                                         0044
         MVC   WMSTPGDS(4,@15),@CF01245                            0044
*   CALL RMIPGM(WMSTPGDT,WMSTPGDS,WPGDPTR);/* GETMAIN FOR WPGD       */
         LA    @14,WMSTPGDT(,@15)                                  0045
         ST    @14,@AL00001                                        0045
         LA    @15,WMSTPGDS(,@15)                                  0045
         ST    @15,@AL00001+4                                      0045
         LA    @15,WPGDPTR                                         0045
         ST    @15,@AL00001+8                                      0045
         LA    @01,@AL00001                                        0045
         BAL   @14,RMIPGM                                          0045
*/*    PERFORMANCE OBJECTIVE DESCRIPTOR TABLE - WPODT                */
*                                                                  0046
*   WMSTPODS=TBLSIZE;               /* INITIAL SIZE OF PERF OBJ    0046
*                                      DESCRIPTOR TABLE              */
         L     @15,WMSTPTR                                         0046
         MVC   WMSTPODS(4,@15),@CF01245                            0046
*   CALL RMIPGM(WMSTPODT,WMSTPODS,WPODPTR);/* GETMAIN FOR WPOD       */
         LA    @14,WMSTPODT(,@15)                                  0047
         ST    @14,@AL00001                                        0047
         LA    @15,WMSTPODS(,@15)                                  0047
         ST    @15,@AL00001+4                                      0047
         LA    @15,WPODPTR                                         0047
         ST    @15,@AL00001+8                                      0047
         LA    @01,@AL00001                                        0047
         BAL   @14,RMIPGM                                          0047
*/*  DOMAIN DESCRIPTION TABLE - DMDT                         @Z40BPEM*/
*                                                                  0048
*   WMSTDMDS=TBLSIZE;               /* INIT SIZE OF DMDT     @Z40BPEM*/
         L     @15,WMSTPTR                                         0048
         MVC   WMSTDMDS(4,@15),@CF01245                            0048
*   CALL RMIPGM(WMSTDMDT,WMSTDMDS,DMDTPTR);/* GETMAIN FOR DMDT     0049
*                                                            @Z40BPEM*/
         LA    @14,WMSTDMDT(,@15)                                  0049
         ST    @14,@AL00001                                        0049
         LA    @15,WMSTDMDS(,@15)                                  0049
         ST    @15,@AL00001+4                                      0049
         LA    @15,DMDTPTR                                         0049
         ST    @15,@AL00001+8                                      0049
         LA    @01,@AL00001                                        0049
         BAL   @14,RMIPGM                                          0049
*/*  INITIALIZE WORKLOAD MANAGER SPECIFICATION TABLE (WMST)          */
*                                                                  0050
*   WMSTNAME=WMSTCHAR;              /* TABLE NAME                    */
         L     @15,WMSTPTR                                         0050
         MVC   WMSTNAME(4,@15),@CC01275                            0050
*   WMSTID=IPIPSID;                 /* IPS LIST ID                   */
         L     @14,@PC00001                                        0051
         MVC   WMSTID(2,@15),IPIPSID(@14)                          0051
*   WMSTCPU=DEFCPUSC;               /* DEFAULT CPU SERVICE COEF      */
         LA    @14,10                                              0052
         ST    @14,WMSTCPU(,@15)                                   0052
*   WMSTIOC=DEFIOCSC;               /* DEFAULT IOC SERVICE COEF      */
         ST    @14,WMSTIOC(,@15)                                   0053
*   WMSTMSO=DEFMSOSC;               /* DEFAULT MSO SERVICE COEF      */
         ST    @14,WMSTMSO(,@15)                                   0054
*/*    SET DEFAULTS IN PRINTABLE FORM FOR COEFFICIENTS       @Z40BPEM*/
*                                                                  0055
*   DO LOOPC=ONE TO NSRVCOEF;       /* ALL COEFF HAVE A      @Z40BPEM*/
         LA    LOOPC,1                                             0055
@DL00055 DS    0H                                                  0056
*     REALIPSV(LOOPC)=DEFSCOEF;     /* DEFAULT OF '1.0'      @Z40BPEM*/
         LR    @03,LOOPC                                           0056
         SLA   @03,2                                               0056
         L     @01,WMSTPTR                                         0056
         ALR   @01,@03                                             0056
         MVC   REALIPSV-4(4,@01),DEFSCOEF                          0056
*   END;                            /*                       @Z40BPEM*/
         AL    LOOPC,@CF00077                                      0057
         C     LOOPC,@CF00082                                      0057
         BNH   @DL00055                                            0057
*/*  INITIALIZE COUNTERS AND POINTERS                                */
*                                                                  0058
*   WPGVPTR=WPGVPTR+LENGTH(WPGVTENT);/* RESERVE 1 ENTRY              */
         LA    @15,2                                               0058
         L     @14,WPGVPTR                                         0058
         ALR   @14,@15                                             0058
         ST    @14,WPGVPTR                                         0058
*   WPOVPTR=WPOVPTR+LENGTH(WPOVTENT);/* RESERVE 1 ENTRY              */
         L     @14,WPOVPTR                                         0059
         ALR   @14,@15                                             0059
         ST    @14,WPOVPTR                                         0059
*   DMVTPTR=DMVTPTR+LENGTH(DMVTENT);/* RESERVE 1 ENTRY       @Z40BPEM*/
         AL    @15,DMVTPTR                                         0060
         ST    @15,DMVTPTR                                         0060
*/*  INITIALIZE DESCRIPTION FOR DOMAIN 0                     @Z40BPEM*/
*                                                                  0061
*   DMDT=DMD0;                      /* SET DEF DMN 0         @Z40BPEM*/
         L     @15,DMDTPTR                                         0061
         MVC   DMDT(20,@15),DMD0                                   0061
*/* INITIALIZE DESCRIPTION FOR DOMAIN 1                      @Z40BPEM*/
*                                                                  0062
*   DMDTPTR=DMDTPTR+LENGTH(DMDT);   /* PTR TO DMN1 ENTRY     @Z40BPEM*/
         AL    @15,@CF01251                                        0062
         ST    @15,DMDTPTR                                         0062
*   DMN1PTR=DMDTPTR;                /* SAVE PTR DMN 1        @Z40BPEM*/
         ST    @15,DMN1PTR                                         0063
*   DMDT=DMD1;                      /* SET DEF DMN 1         @Z40BPEM*/
         MVC   DMDT(20,@15),DMD1                                   0064
*/*  INITIALIZE DESCRIPTION FOR OBJECTIVE 0                  @Z40BPEM*/
*                                                                  0065
*   DO LOOPC=ONE TO NOBJ0PTS;       /* THERE ARE 3 PTS       @Z40BPEM*/
         LA    LOOPC,1                                             0065
@DL00065 DS    0H                                                  0066
*     WPOP=OBJ0ARAY(LOOPC);         /* IN OBJ 0              @Z40BPEM*/
         L     @03,WPODPTR                                         0066
         LR    @15,LOOPC                                           0066
         SLA   @15,2                                               0066
         LA    @14,OBJ0ARAY-4(@15)                                 0066
         MVC   WPOP(4,@03),0(@14)                                  0066
*     WPODPTR=WPODPTR+LENGTH(WPOS); /* INC PTR TO NEXT ENTRY @Z40BPEM*/
         AL    @03,@CF00054                                        0067
         ST    @03,WPODPTR                                         0067
*   END;                            /*                       @Z40BPEM*/
         AL    LOOPC,@CF00077                                      0068
         C     LOOPC,@CF00082                                      0068
         BNH   @DL00065                                            0068
*   OBJ0PT3=WPODPTR-LENGTH(WPOS);   /* SAVE PTR TO 3RD OBJ0 PT     0069
*                                                            @Z40BPEM*/
         L     @15,WPODPTR                                         0069
         SL    @15,@CF00054                                        0069
         ST    @15,OBJ0PT3                                         0069
*/* INITIALIZE PERF GRP DESCRIPTOR FOR PERF GRP 0                    */
*                                                                  0070
*   WPGD=WPG0;                      /* DESCRIPTOR FOR PGN 0          */
         L     @15,WPGDPTR                                         0070
         MVC   WPGD(20,@15),WPG0                                   0070
*   WPGDISV=RMPTIMN;                /* BASE ISV SERVICE              */
         L     @01,RMPTPTR                                         0071
         L     @14,RMPTIMN(,@01)                                   0071
         ST    @14,WPGDISV(,@15)                                   0071
*   WPGDPTR=WPGDPTR+LENGTH(WPGD);   /* RESERVE THE FIRST ENTRY OF  0072
*                                      WPGDT FOR PERG GRP #0         */
         LA    @07,20                                              0072
         ALR   @15,@07                                             0072
         ST    @15,WPGDPTR                                         0072
*   DMDTPTR=DMDTPTR+LENGTH(DMDT);   /* RESERVE 2 ENTRIES     @Z40BPEM*/
         AL    @07,DMDTPTR                                         0073
         ST    @07,DMDTPTR                                         0073
*   DMNTOTC=TWO;                    /* INCL DMN 0 & 1        @Z40BPEM*/
         MVC   DMNTOTC(2),@CH00118                                 0074
*   IPWPGPTC=ONE;                   /* SET TOTAL PERF GRP PERIOD   0075
*                                      COUNTER = 1 TO INCLUDE PG0    */
         MVC   IPWPGPTC(2),@CH00077                                0075
*   DMNHI=ZERO;                     /* HIGHEST DMN #         @Z40BPEM*/
         SLR   @15,@15                                             0076
         STH   @15,DMNHI                                           0076
*   IPWPGNHI=ZERO;                  /* RESET HIGHEST PERF GRP NO     */
         STH   @15,IPWPGNHI                                        0077
*   IPWOBJHI=ZERO;                  /* HIGHEST OBJ NO = 0            */
         STH   @15,IPWOBJHI                                        0078
*   IPWFLGS=ZERO;                   /* RESET FLAGS                   */
         MVI   IPWFLGS,X'00'                                       0079
*   IPWAMCOF=ZERO;                  /* RESET INDICATORS              */
         ST    @15,IPWAMCOF                                        0080
*   IPWPGL(1)=RMPTIMN;              /* INIT TO BASE ISV VALUE        */
         ST    @14,IPWPGL                                          0081
*   PGTOTALC=ZERO;                  /* INIT TOT # PERFGRP    @Z40BPEM*/
         STH   @15,PGTOTALC                                        0082
*   PGP1DMN=ZERO;                   /* INIT TOTAL # MISSING PERF GRP
*                                      PER1 DMNS             @Z40BPEM*/
         STH   @15,PGP1DMN                                         0083
*   WLLI=ZERO;                      /* INDEX TO WLLFSRV0     @Z40BPEM*/
         STH   @15,WLLI                                            0084
*   WORKHI=ZERO;                    /* USED TO FIND HIGH WORKLOAD LVL
*                                                            @Z40BPEM*/
         SLR   WORKHI,WORKHI                                       0085
*   WORKLO=MAXWKLV;                 /* USED TO FIND LOW WORKLOAD LVL
*                                                            @Z40BPEM*/
         MVC   WORKLO(2),@CH01273                                  0086
*   DMNSTATS=ZERO;                  /* RESET FLAGS           @Z40BPEM*/
         MVI   DMNSTATS,X'00'                                      0087
*/*  CONSTRUCT PARAMETERS FOR IRBMFANL ROUTINE                       */
*/****  START OF SPECIFICATIONS  *************************************/
*/*                                                                  */
*/* MACCOMP Y-2 SC1CQ/GAM20                                          */
*/* MACMEAN IRBANDCL MEANS COMMON SYNTAX ANALYZING DECLARATIONS      */
*/* MACSTAT Y-2 73059/Y02150                                         */
*/*                                                                  */
*/* MODULE NAME -IRBANDCL                                            */
*/*                                                                  */
*/* DESCRIPTIVE NAME - COMMON SYNTAX ANALYZING DECLARATIONS          */
*/*                                                                  */
*/* COPYRIGHT = NONE                                                 */
*/*                                                                  */
*/* STATUS = RELEASE 2, LEVEL 0                                      */
*/*                                                                  */
*/* FUNCTION = LISTS COMMON DECLARATIONS AND INTIALIZATIONS NECESSARY*/
*/*            FOR SYNTAX CHECKING                                   */
*/*                                                                  */
*/* NOTES = NONE                                                     */
*/*                                                                  */
*/* MODULE TYPE = PLS EXECUTABLE MACRO                               */
*/*                                                                  */
*/* CHANGE ACTIVITY = SEE BELOW                                      */
*/*                                                                  */
*/*  A000000-999999                                            Y02150*/
*/*                                                                  */
*/* METHOD OF INVOCATION                                             */
*/*    BAL - NONE                                                    */
*/*                                                                  */
*/*    PLS - QUESTION MARK IRBANDCL INTEGER(A) ERROR(B) ALPHA(C)     */
*/*                                    DECL(D) INITL(E)              */
*/*        WHERE                                                     */
*/*             A - PLACE OR PLACES TO STORE INTEGER VALUES          */
*/*             B - PLACE OR PLACES TO STORE ERROR VALUES            */
*/*             C - PLACE OR PLACES TO STORE ALPHA VALUES            */
*/*             D -  YES  IF DECLARATIONS ARE WANTED                 */
*/*                 OMIT DECL OTHERWISE                              */
*/*             E -  YES  IF INITIALIZATIONS ARE WANTED              */
*/*                 OMIT INITL OTHERWISE                             */
*/*                                                                  */
*/****  END OF SPECIFICATIONS  ***************************************/
*/*                                                                  */
*/*  INITIALIZE ANALYZER CONTROL BLOCKS                              */
*                                                                  0088
*   INBCBNAM='BCB ';                /* ACRONYM                       */
         MVC   INBCBNAM(4),@CC01534                                0088
*   INBCBFRS=0;                     /* NO ELEMENTS IN QUEUE          */
         ST    @15,INBCBFRS                                        0089
*   INBCBLST=ADDR(INBCBFRS);        /* INITIAL CONDITION             */
         LA    @14,INBCBFRS                                        0090
         ST    @14,INBCBLST                                        0090
*   INCURBCB=ADDR(INBCBFRS);        /* INITIAL CONDITION             */
         ST    @14,INCURBCB                                        0091
*   INTXTCUR=0;                     /* NO TEXT EXIST                 */
         ST    @15,INTXTCUR                                        0092
*   INBYTLFT=0;                     /* INITIAL CONDITION             */
         ST    @15,INBYTLFT                                        0093
*   INEXTSRC='0'B;                  /* EXTERNAL TEXT SOURCE          */
         NI    INEXTSRC,B'01111111'                                0094
*/*  INTEGER VECTOR TABLE INITIALIZATION                             */
*                                                                  0095
*   ININTPTR(1)=ADDR(IPWINT1);                                     0095
         LA    @15,IPWINT1                                         0095
         ST    @15,ININTPTR                                        0095
*   ININTPTR(2)=ADDR(IPWINT2);                                     0096
         LA    @15,IPWINT2                                         0096
         ST    @15,ININTPTR+4                                      0096
*   ININTPTR(3)=ADDR(IPWPGN);                                      0097
         LA    @15,IPWPGN                                          0097
         ST    @15,ININTPTR+8                                      0097
*   ININTPTR(4)=ADDR(IPWOBJ);                                      0098
         LA    @15,IPWOBJ                                          0098
         ST    @15,ININTPTR+12                                     0098
*   ININTPTR(5)=ADDR(IPWDMN);       /*                       @Z40BPEM*/
         LA    @15,IPWDMN                                          0099
         ST    @15,ININTPTR+16                                     0099
*   INENDITM='1'B;                  /* SET LAST ITEM INDICATOR       */
*   INSTRM='0'B;                    /* SET STRUCTURE INDICATOR       */
         OI    INENDITM,B'10000000'                                0101
         NI    INSTRM,B'10111111'                                  0101
*   INRECSTR=ADDR(IPSYNTAB);        /* ADDR OF IPS SYNTAX TABLE      */
         LA    @15,IPSYNTAB                                        0102
         ST    @15,INRECSTR                                        0102
*/*  GET STORAGE FOR IRBMFANL WORK AREA                              */
*                                                                  0103
*   RESPECIFY                                                      0103
*    (R0,                                                          0103
*     R1,                                                          0103
*     R14,                                                         0103
*     R15) RSTD;                                                   0103
*   INWKARSZ=SIZDATD*INRCURNO;      /* SIZE OF WORK AREA             */
         L     @07,@CA01279                                        0104
         L     INWKARSZ,SIZDATD-SIZDATD(,@07)                      0104
         MH    INWKARSZ,INRCURNO                                   0104
*   R0=INWKARSZ;                    /* SIZE OF WORK AREA             */
         LR    R0,INWKARSZ                                         0105
*   GEN( GETMAIN R,LV=(0) );        /* GET STORAGE                   */
          GETMAIN R,LV=(0)
*   INWKARPT=R1;                    /* PTR TO IRBMFANL WORK AREA     */
         ST    R1,INWKARPT                                         0107
*   RESPECIFY                                                      0108
*     R1 UNRSTD;                                                   0108
*                                                                  0108
*/*  INVOKE SYNTAX ANALYZER TO ANALYZE THE IPS LIST                  */
*                                                                  0109
*   CALL IRBMFANL(INDUMITM,         /* ITEM ENTRY                    */
*       INSCB,                      /* SCAN CONTROL BLOCK            */
*       INWKARPT);                  /* PTR TO IRBMFANL WORK AREA     */
         LA    @01,INDUMITM                                        0109
         ST    @01,@AL00001                                        0109
         LA    @01,INSCB                                           0109
         ST    @01,@AL00001+4                                      0109
         LA    @01,INWKARPT                                        0109
         ST    @01,@AL00001+8                                      0109
         L     @15,@CV01278                                        0109
         LA    @01,@AL00001                                        0109
         BALR  @14,@15                                             0109
*/*  IF IPS CONTAINS INVALID PARAMETER SPECIFICATION                 */
*/*  INVOKE IRARMFRE ROUTINE TO FREE THE STORAGE PREVIOUSLY GOTTEN   */
*/*  AND RETURN TO CALLER OF IRARMIPS WITH A RETURN CODE INDICATING  */
*/*  UNSUCCESSFUL RETURN                                             */
*                                                                  0110
*   RESPECIFY                                                      0110
*     R1 RSTD;                                                     0110
*   RESPECIFY                                                      0111
*     RCODE RSTD;                                                  0111
*   INRCODE=RCODE;                  /* SAVE IRBMFANL RET CODE        */
         ST    RCODE,INRCODE                                       0112
*   R0=INWKARSZ;                    /* SIZE OF IRBMFANL WORK AREA    */
         LR    R0,INWKARSZ                                         0113
*   R1=INWKARPT;                    /* PTR TO WORK AREA              */
         L     R1,INWKARPT                                         0114
*   GEN( FREEMAIN R,LV=(0),A=(1) ); /* FREE WORK AREA                */
          FREEMAIN R,LV=(0),A=(1)
*   RESPECIFY                                                      0116
*    (R0,                                                          0116
*     R1,                                                          0116
*     R14,                                                         0116
*     R15) UNRSTD;                                                 0116
*   RESPECIFY                                                      0117
*     RCODE UNRSTD;                                                0117
*   IF IPWAMWKL^='1'B THEN          /* WKL NOT SPECIFIED             */
         TM    IPWAMWKL,B'01000000'                                0118
         BO    @RF00118                                            0118
*     DO;                                                          0119
*       CALL RMIPMSGR(ERRCWKL);     /* WRITE WKL INVALID MSG         */
         LA    @01,@AL00120                                        0120
         BAL   @14,RMIPMSGR                                        0120
*       IPWFIPER='1'B;              /* IPS IS INVALID                */
         OI    IPWFIPER,B'10000000'                                0121
*     END;                                                         0122
*                                                                  0122
*/*  VERIFY THAT THE REQUIRED PERFORMANCE GROUPS HAVE BEEN SPECIFIED */
*                                                                  0123
*   DO I=REQPGNLO                   /* LOWEST REQUIRED PERF GRP #    */
*         TO REQPGNHI;              /* HIGHEST REQUIRED PERF GRP #   */
@RF00118 LA    I,1                                                 0123
@DL00123 DS    0H                                                  0124
*     IF WPGVTENT(I)=ZERO           /* CHECK IF REQUIRED PERF GRPS 0124
*                                      HAS BEEN SPECIFIED IN IPS     */
*       THEN                        /* IPS IS INVALID                */
         LR    @15,I                                               0124
         ALR   @15,@15                                             0124
         L     @01,WPGVPTR                                         0124
         BCTR  @01,0                                               0124
         BCTR  @01,0                                               0124
         LH    @15,WPGVTENT(@15,@01)                               0124
         LTR   @15,@15                                             0124
         BNZ   @RF00124                                            0124
*       DO;                                                        0125
*         IPWPGN=I;                 /* PERF GRP NO.                  */
         ST    I,IPWPGN                                            0126
*         CALL RMIPMSGR(ERRCRPG);   /* WRITES REQUIRED PGN INVALID 0127
*                                      MESSAGE                       */
         LA    @01,@AL00127                                        0127
         BAL   @14,RMIPMSGR                                        0127
*         IPWFIPER='1'B;            /* IPS IS INVALID                */
         OI    IPWFIPER,B'10000000'                                0128
*       END;                                                       0129
*   END;                            /* COMPLETED CHECKING THE      0130
*                                      EXISTENCE OF ALL REQUIRED PERF
*                                      GRPS                          */
@RF00124 AL    I,@CF00077                                          0130
         C     I,@CF00118                                          0130
         BNH   @DL00123                                            0130
*/*  VERIFY THAT DOMAIN HAS BEEN SPECIFIED IN ALL FIRST PERIODS    0131
*                                                             @Z40BPEM
*                                                                    */
*                                                                  0131
*   IF((PGP1DMN^=ZERO)&(DMNDEF='1'B))/* CHECK FOR MISSING DMNS       */
*     THEN                          /* IPS IS INVALID        @Z40BPEM*/
         LH    @02,PGP1DMN                                         0131
         LTR   @02,@02                                             0131
         BZ    @RF00131                                            0131
         TM    DMNDEF,B'00100000'                                  0131
         BNO   @RF00131                                            0131
*     DO;                           /*                       @Z40BPEM*/
*       CALL RMIPMSGR(ERRCDMN);     /* WRITES DMN MISSING MSG      0133
*                                                            @Z40BPEM*/
         LA    @01,@AL00133                                        0133
         BAL   @14,RMIPMSGR                                        0133
*       IPWFIPER='1'B;              /* SET IPS INVALID       @Z40BPEM*/
         OI    IPWFIPER,B'10000000'                                0134
*     END;                          /*                       @Z40BPEM*/
*/*  VERIFY THAT THE IPS HAS BEEN SPECIFIED CORRECTLY                */
*                                                                  0136
*   IF INRCODE^=SUCCESS             /* RET CODE FROM IRBMFANL^=0     */
*       |IPWFIPER='1'B              /* IPS INVALID FLAG SET          */
*     THEN                          /* IPS IS INVALID                */
@RF00131 L     @02,INRCODE                                         0136
         LTR   @02,@02                                             0136
         BNZ   @RT00136                                            0136
         TM    IPWFIPER,B'10000000'                                0136
         BO    @RT00136                                            0136
*     GO TO RMIPERR;                /* IPS ERROR PROCESSING          */
*/*  INITIALIZE WORKLOAD MANAGER SPECIFICATION TABLE(WMST)           */
*                                                                  0138
*   WMSTPGHI=IPWPGNHI;              /* HIGHEST PERF GRP NO           */
         L     @02,WMSTPTR                                         0138
         LH    @15,IPWPGNHI                                        0138
         STH   @15,WMSTPGHI(,@02)                                  0138
*   WMSTPGPC=IPWPGPTC;              /* TOTAL PERF GRP PERIOD COUNT   */
         LH    @15,IPWPGPTC                                        0139
         STH   @15,WMSTPGPC(,@02)                                  0139
*   WMSTWLLO=IPWWLLO;               /* LOWEST WKL SPEC'ED IN IPS     */
         LH    @15,IPWWLLO                                         0140
         STH   @15,WMSTWLLO(,@02)                                  0140
*   WMSTDMNC=DMNTOTC;               /* TOTAL # OF DOMAINS    @Z40BPEM*/
         LH    @15,DMNTOTC                                         0141
         STH   @15,WMSTDMNC(,@02)                                  0141
*/*  DETERMINE HIGHEST AND LOWEST WORKLOAD LEVEL WHERE AN    @Z40BPEM*/
*/*  OBJECTIVE GOES TO ZERO                                  @Z40BPEM*/
*                                                                  0142
*   DO LOOPC=ONE TO WLLI;           /* FOR ALL OBJECTIVES    @Z40BPEM*/
         LA    LOOPC,1                                             0142
         B     @DE00142                                            0142
@DL00142 DS    0H                                                  0143
*     IF WLLFSRV0(LOOPC)>WORKHI     /* PUT LARGER VALUE              */
*       THEN                        /* INTO                          */
         LR    @15,LOOPC                                           0143
         ALR   @15,@15                                             0143
         LH    @15,WLLFSRV0-2(@15)                                 0143
         N     @15,@CF02034                                        0143
         CR    @15,WORKHI                                          0143
         BNH   @RF00143                                            0143
*       WORKHI=WLLFSRV0(LOOPC);     /* WORKHI                @Z40BPEM*/
         LR    WORKHI,@15                                          0144
*     IF WLLFSRV0(LOOPC)<WORKLO     /* PUT SMALLER VALUE             */
*       THEN                        /* INTO                          */
@RF00143 LR    @15,LOOPC                                           0145
         ALR   @15,@15                                             0145
         LA    @14,WLLFSRV0-2(@15)                                 0145
         CLC   0(2,@14),WORKLO                                     0145
         BNL   @RF00145                                            0145
*       WORKLO=WLLFSRV0(LOOPC);     /* WORKLO                @Z40BPEM*/
         LH    @15,WLLFSRV0-2(@15)                                 0146
         N     @15,@CF02034                                        0146
         STH   @15,WORKLO                                          0146
*   END;                                                           0147
@RF00145 AL    LOOPC,@CF00077                                      0147
@DE00142 CH    LOOPC,WLLI                                          0147
         BNH   @DL00142                                            0147
*   WMSTWLHI=WORKHI/WKLSCALE;       /* SAVE HIGHEST WLL IN WMST    0148
*                                                            @Z40BPEM*/
         L     @02,WMSTPTR                                         0148
         LR    @15,WORKHI                                          0148
         SRL   @15,8                                               0148
         STH   @15,WMSTWLHI(,@02)                                  0148
*/* SET DISP IN VECTOR TABLE FOR DMN 1                       @Z40BPEM*/
*                                                                  0149
*   DMVTENT(ONE)=LENGTH(DMDT);      /* DISP MAY NOT HAVE BEEN SET  0149
*                                                            @Z40BPEM*/
         L     @01,DMVTPTR                                         0149
         MVC   DMVTENT(2,@01),@CH01251                             0149
*/*  ADJUST THE SERVICE COEFFICIENTS                                 */
*/*  SET WMSTWLLO=0 IF ALL THREE SERVICE COEFFICIENTS ARE EACH =0    */
*                                                                  0150
*   IF WMSTCPU=ZERO&WMSTIOC=ZERO&WMSTMSO=ZERO THEN/* ALL SERVICE   0150
*                                      COEFFICIENTS=0                */
         SLR   @03,@03                                             0150
         C     @03,WMSTCPU(,@02)                                   0150
         BNE   @RF00150                                            0150
         C     @03,WMSTIOC(,@02)                                   0150
         BNE   @RF00150                                            0150
         C     @03,WMSTMSO(,@02)                                   0150
         BNE   @RF00150                                            0150
*     WMSTWLLO=ZERO;                                               0151
         STH   @03,WMSTWLLO(,@02)                                  0151
*   ELSE                            /* NOT ALL SERVICE COEFFICIENTS
*                                      ARE ZEROES                    */
*     DO;                                                          0152
         B     @RC00150                                            0152
@RF00150 DS    0H                                                  0153
*       IF WMSTCPU^=ZERO THEN       /* CPU SERV COEF ^=0             */
         L     @15,WMSTPTR                                         0153
         L     @14,WMSTCPU(,@15)                                   0153
         LTR   @14,@14                                             0153
         BZ    @RF00153                                            0153
*         WMSTCPU=WMSTCPU*CPUSCM/SCSF+ONE;/* SCALE CPU SERV          */
         LR    @01,@14                                             0154
         M     @00,@CF01259                                        0154
         D     @00,@CF01216                                        0154
         AL    @01,@CF00077                                        0154
         ST    @01,WMSTCPU(,@15)                                   0154
*       IF WMSTIOC^=ZERO THEN       /* IOC SERV COEF ^=0             */
@RF00153 L     @15,WMSTPTR                                         0155
         L     @14,WMSTIOC(,@15)                                   0155
         LTR   @14,@14                                             0155
         BZ    @RF00155                                            0155
*         WMSTIOC=WMSTIOC*IOCSCM/SCSF+ONE;/* SCALE IOC SERV          */
         LR    @01,@14                                             0156
         M     @00,@CF01259                                        0156
         D     @00,@CF01216                                        0156
         AL    @01,@CF00077                                        0156
         ST    @01,WMSTIOC(,@15)                                   0156
*       IF WMSTMSO^=ZERO THEN       /* MSO SERV COEF ^=0             */
@RF00155 L     @15,WMSTPTR                                         0157
         L     @14,WMSTMSO(,@15)                                   0157
         LTR   @14,@14                                             0157
         BZ    @RF00157                                            0157
*         WMSTMSO=WMSTMSO*MSOSCM/MSOSF+ONE;/* SCALE MSO SER          */
         LR    @01,@14                                             0158
         M     @00,@CF01259                                        0158
         D     @00,@CF01263                                        0158
         AL    @01,@CF00077                                        0158
         ST    @01,WMSTMSO(,@15)                                   0158
*     END;                                                         0159
*                                                                  0159
@RF00157 DS    0H                                                  0160
*/*  FOR THE FOLLOWING TABLES -                                      */
*/*  RELEASE THE UNUSED STORAGE AND ADJUST THE RESPECTIVE ENTRIES    */
*/*  IN WORKLOAD MANAGER SPECIFICATION TABLE TO REFLECT THE ACTUAL   */
*/*  SIZES OF THE TABLES                                             */
*/*  THE ACTUAL SIZE OF THE TABLE IS COMPUTED AND PASSED TO RMIPFM   */
*/*  ROUTINE VIA IPTBASZE                                            */
*/*    PERFORMANCE GROUP VECTOR TABLE         - WPGVT              0160
*      LEAVE THIS TABLE AT MAXIMUM SIZE, SO THAT ANY SRM MODULE    0160
*      CAN STUDY A PGD MAPPING WITHOUT WORRY OF STEPPING BEYOND    0160
*      THE END OF THE PGVT.                                  @ZA27109*/
*/*    PERFORMANCE OBJECTIVE VECTOR TABLE     - WPOVT                */
*                                                                  0160
*   IPTBASZE=(IPWOBJHI+ONE)*LENGTH(WPOVTENT);/* ACTUAL SIZE OF WPOVT */
@RC00150 LA    @15,1                                               0160
         AH    @15,IPWOBJHI                                        0160
         ALR   @15,@15                                             0160
         ST    @15,IPTBASZE                                        0160
*   CALL RMIPFM(WMSTPOVT,WMSTPOVS,IPTBASZE);/* FREE UNUSED SPACE IN
*                                      WPOVT                         */
         L     @15,WMSTPTR                                         0161
         LA    @14,WMSTPOVT(,@15)                                  0161
         ST    @14,@AL00001                                        0161
         LA    @15,WMSTPOVS(,@15)                                  0161
         ST    @15,@AL00001+4                                      0161
         LA    @15,IPTBASZE                                        0161
         ST    @15,@AL00001+8                                      0161
         LA    @01,@AL00001                                        0161
         BAL   @14,RMIPFM                                          0161
*/* DOMAIN VECTOR TABLE       - DMVT                         @Z40BPEM*/
*                                                                  0162
*   IPTBASZE=(DMNHI+ONE)*LENGTH(DMVTENT);/* ACTUAL SIZE OF DMVT    0162
*                                                            @Z40BPEM*/
         LA    @15,1                                               0162
         AH    @15,DMNHI                                           0162
         ALR   @15,@15                                             0162
         ST    @15,IPTBASZE                                        0162
*   CALL RMIPFM(WMSTDMVT,WMSTDMVS,IPTBASZE);/* FREE UNUSED SPACE IN
*                                      DMVT                  @Z40BPEM*/
         L     @15,WMSTPTR                                         0163
         LA    @14,WMSTDMVT(,@15)                                  0163
         ST    @14,@AL00001                                        0163
         LA    @15,WMSTDMVS(,@15)                                  0163
         ST    @15,@AL00001+4                                      0163
         LA    @15,IPTBASZE                                        0163
         ST    @15,@AL00001+8                                      0163
         LA    @01,@AL00001                                        0163
         BAL   @14,RMIPFM                                          0163
*/*    PERFORMANCE GROUP DESCRIPTOR TABLE     - WPGDT                */
*                                                                  0164
*   IPTBASZE=WPGDPTR-WMSTPGDT;                                     0164
         L     @15,WMSTPTR                                         0164
         L     @14,WPGDPTR                                         0164
         SL    @14,WMSTPGDT(,@15)                                  0164
         ST    @14,IPTBASZE                                        0164
*   CALL RMIPFM(WMSTPGDT,WMSTPGDS,IPTBASZE);/* FREE UNUSED SPACE IN
*                                      WPGDT                         */
         LA    @14,WMSTPGDT(,@15)                                  0165
         ST    @14,@AL00001                                        0165
         LA    @15,WMSTPGDS(,@15)                                  0165
         ST    @15,@AL00001+4                                      0165
         LA    @15,IPTBASZE                                        0165
         ST    @15,@AL00001+8                                      0165
         LA    @01,@AL00001                                        0165
         BAL   @14,RMIPFM                                          0165
*/*    PERFORMANCE OBJECTIVE DESCRIPTOR TABLE - WPODT                */
*                                                                  0166
*   IPTBASZE=WPODPTR-WMSTPODT;                                     0166
         L     @15,WMSTPTR                                         0166
         L     @14,WPODPTR                                         0166
         SL    @14,WMSTPODT(,@15)                                  0166
         ST    @14,IPTBASZE                                        0166
*   CALL RMIPFM(WMSTPODT,WMSTPODS,IPTBASZE);/* FREE UNUSED SPACE IN
*                                      WPODT                         */
         LA    @14,WMSTPODT(,@15)                                  0167
         ST    @14,@AL00001                                        0167
         LA    @15,WMSTPODS(,@15)                                  0167
         ST    @15,@AL00001+4                                      0167
         LA    @15,IPTBASZE                                        0167
         ST    @15,@AL00001+8                                      0167
         LA    @01,@AL00001                                        0167
         BAL   @14,RMIPFM                                          0167
*/*    DOMAIN DESCRIPTION TABLE    - DMDT                    @Z40BPEM*/
*                                                                  0168
*   IPTBASZE=DMDTPTR-WMSTDMDT;      /* SIZE OF DMDT          @Z40BPEM*/
         L     @15,WMSTPTR                                         0168
         L     @14,DMDTPTR                                         0168
         SL    @14,WMSTDMDT(,@15)                                  0168
         ST    @14,IPTBASZE                                        0168
*   CALL RMIPFM(WMSTDMDT,WMSTDMDS,IPTBASZE);/* FREE UNUSED SPACE IN
*                                      DMDT                  @Z40BPEM*/
         LA    @14,WMSTDMDT(,@15)                                  0169
         ST    @14,@AL00001                                        0169
         LA    @15,WMSTDMDS(,@15)                                  0169
         ST    @15,@AL00001+4                                      0169
         LA    @15,IPTBASZE                                        0169
         ST    @15,@AL00001+8                                      0169
         LA    @01,@AL00001                                        0169
         BAL   @14,RMIPFM                                          0169
*/* GET CONTIGUOUS STORAGE FOR ALL THE IPS TABLES            @Z40BPEM*/
*                                                                  0170
*   TOTSIZE=WMSTPGVS+WMSTPOVS+WMSTDMVS+WMSTPGDS+WMSTPODS+WMSTDMDS+ 0170
*       LENGTH(WMST);               /* SIZE REQUIRED FOR ALL TABLES
*                                                            @Z40BPEM*/
         L     @15,WMSTPTR                                         0170
         L     @14,WMSTPGVS(,@15)                                  0170
         AL    @14,WMSTPOVS(,@15)                                  0170
         AL    @14,WMSTDMVS(,@15)                                  0170
         AL    @14,WMSTPGDS(,@15)                                  0170
         AL    @14,WMSTPODS(,@15)                                  0170
         AL    @14,WMSTDMDS(,@15)                                  0170
         AL    @14,@CF02023                                        0170
         ST    @14,TOTSIZE                                         0170
*   CALL RMIPGMCS(NEWMST,TOTSIZE);  /* GET NEW STORAGE,FREE OLD    0171
*                                      STORAGE               @Z40BPEM*/
         LA    @15,NEWMST                                          0171
         ST    @15,@AL00001                                        0171
         LA    @15,TOTSIZE                                         0171
         ST    @15,@AL00001+4                                      0171
         LA    @01,@AL00001                                        0171
         BAL   @14,RMIPGMCS                                        0171
*/* SETUP NEW ADDRESSES TO IPS TABLES IN NEW WMST            @Z40BPEM*/
*                                                                  0172
*   IPWMSTAD=NEWMST;                /* SET PTR TO WMST IN OUTPUT   0172
*                                      PARAMETER             @Z40BPEM*/
         L     @15,@PC00001+4                                      0172
         L     @14,NEWMST                                          0172
         ST    @14,IPWMSTAD(,@15)                                  0172
*   WMSTPGVT=WMSTPTR+LENGTH(WMST);  /* ADDR OF NEW PGVT      @Z40BPEM*/
         L     @15,WMSTPTR                                         0173
         LA    @14,112                                             0173
         ALR   @14,@15                                             0173
         ST    @14,WMSTPGVT(,@15)                                  0173
*   WMSTPGDT=WMSTPGVT+TABSIZE(2);   /* ADDR OF NEW PGDT      @Z40BPEM*/
         AL    @14,TABSIZE+8(,@15)                                 0174
         ST    @14,WMSTPGDT(,@15)                                  0174
*   WMSTPOVT=WMSTPGDT+TABSIZE(3);   /* ADDR OF NEW POVT      @Z40BPEM*/
         AL    @14,TABSIZE+16(,@15)                                0175
         ST    @14,WMSTPOVT(,@15)                                  0175
*   WMSTPODT=WMSTPOVT+TABSIZE(4);   /* ADDR OF NEW PODT      @Z40BPEM*/
         AL    @14,TABSIZE+24(,@15)                                0176
         ST    @14,WMSTPODT(,@15)                                  0176
*   WMSTDMDT=WMSTPODT+TABSIZE(5);   /* ADDR OF NEW DMDT      @Z40BPEM*/
         AL    @14,TABSIZE+32(,@15)                                0177
         ST    @14,WMSTDMDT(,@15)                                  0177
*   WMSTDMVT=WMSTDMDT+TABSIZE(6);   /* ADDR OF NEW DMVT      @Z40BPEM*/
         AL    @14,TABSIZE+40(,@15)                                0178
         ST    @14,WMSTDMVT(,@15)                                  0178
*/*  RETURN TO CALLER WITH A RETURN CODE INDICATING SUCCESSFUL RETURN*/
*                                                                  0179
*   RETURN CODE(SUCCESS);           /* RETURN SUCCESSFUL             */
         L     @13,4(,@13)                                         0179
         L     @00,@SIZDATD                                        0179
         LR    @01,@08                                             0179
         FREEMAIN R,LV=(0),A=(1)
         SLR   @15,@15                                             0179
         L     @14,12(,@13)                                        0179
         LM    @00,@12,20(@13)                                     0179
         BR    @14                                                 0179
*/*  RETURN TO CALLER WITH A RETURN CODE INDICATING FAILURE          */
*                                                                  0180
*RMIPERR:                                                          0180
*   ;                               /* IPS IS INVALID                */
RMIPERR  DS    0H                                                  0181
*   CALL IRARMFRE(IPWMSTAD);        /* FREE IPS STORAGE              */
         L     @15,@PC00001+4                                      0181
         ST    @15,@AL00001                                        0181
         LA    @01,@AL00001                                        0181
         L     @15,@CA01542                                        0181
         BALR  @14,@15                                             0181
*   RETURN CODE(FAIL);              /* RETURN UNSUCCESSFUL           */
         L     @13,4(,@13)                                         0182
         L     @00,@SIZDATD                                        0182
         LR    @01,@08                                             0182
         FREEMAIN R,LV=(0),A=(1)
         LA    @15,4                                               0182
         L     @14,12(,@13)                                        0182
         LM    @00,@12,20(@13)                                     0182
         BR    @14                                                 0182
*                                                                  0183
*/********************************************************************/
*/*    PROCEDURE NAME = RMIPGMCS                                     */
*/*                                                                  */
*/*    FUNCTION:                                                     */
*/*    CONTIGUOUS STORAGE IS OBTAINED FROM SUBPOOL 245 FOR THE       */
*/*    WMST AND CONTROL BLOCKS WHICH CONTAIN IPS DATA.               */
*/*    PREVIOUS STORAGE FOR CONTROL BLOCKS IS RETURNED               */
*/*    TO SUBPOOL 245.                                               */
*/*                                                                  */
*/*    PARAMETERS:                                                   */
*/*             1. 1 WORD-ADDR OF AREA UPON EXIT                     */
*/*             2. 1 WORD-SIZE OF AREA                               */
*/*                                                          @Z40BPEM*/
*/********************************************************************/
*                                                                  0183
*RMIPGMCS:                                                         0183
*   PROC(NEWAREA,SIZE);                                            0183
RMIPGMCS STM   @14,@12,@SA00002                                    0183
         MVC   @PC00002(8),0(@01)                                  0183
*   DECLARE                                                        0184
*     NEWAREA PTR,                  /* PTR TO AREA                   */
*     SIZE FIXED,                   /* SIZE OF AREA                  */
*     NOTABLES FIXED(15) CONSTANT(7),/* # OF IPS CONTROL BLOCKS      */
*     TABLEPTR PTR,                 /* NEW PTR TO TABLES             */
*     LENTH FIXED,                  /* LENGTH OF TABLE               */
*     DUMMYPTR PTR;                 /* DUMMY PARAMETER FOR RMIPGM    */
*/*  GET STORAGE FOR THE TABLES                                      */
*                                                                  0185
*   CALL RMIPGM(NEWAREA,SIZE,DUMMYPTR);                            0185
         L     @15,@PC00002                                        0185
         ST    @15,@AL00001                                        0185
         L     @15,@PC00002+4                                      0185
         ST    @15,@AL00001+4                                      0185
         LA    @15,DUMMYPTR                                        0185
         ST    @15,@AL00001+8                                      0185
         LA    @01,@AL00001                                        0185
         BAL   @14,RMIPGM                                          0185
*   LENTH=ZERO;                     /* INITIAL LENGTH                */
         SLR   @02,@02                                             0186
         ST    @02,LENTH                                           0186
*   TABLEPTR=NEWAREA;               /* PTR TO 1ST BYTE OF AREA     0187
*                                      OBTAINED                      */
         L     @15,@PC00002                                        0187
         L     TABLEPTR,NEWAREA(,@15)                              0187
*   RESPECIFY                                                      0188
*    (R0,                                                          0188
*     R1,                                                          0188
*     R14,                                                         0188
*     R15) RSTD;                                                   0188
*                                                                  0188
*/* MOVE DATA TO NEW AREA AND FREE OLD STORAGE                       */
*                                                                  0189
*   DO I=ONE TO NOTABLES;           /* MOVE DATA FOR EACH TABLE      */
         LA    I,1                                                 0189
@DL00189 DS    0H                                                  0190
*     TABLEPTR=TABLEPTR+LENTH;      /* PTR TO NEW AREA FOR TABLE     */
         AL    TABLEPTR,LENTH                                      0190
*     R0=TABLEPTR;                  /* ADDR OF NEW TABLE             */
         LR    R0,TABLEPTR                                         0191
*     IF I=ONE THEN                                                0192
         C     I,@CF00077                                          0192
         BNE   @RF00192                                            0192
*       DO;                         /* FIRST TABLE IN AREA IS WMST   */
*         R14=WMSTPTR;              /* ADDR OF WMST                  */
         L     R14,WMSTPTR                                         0194
*         R1=LENGTH(WMST);          /* SIZE OF WMST                  */
         LA    R1,112                                              0195
*       END;                                                       0196
*     ELSE                                                         0197
*       DO;                         /* IPS CONTROL BLOCKS FOLLOW     */
         B     @RC00192                                            0197
@RF00192 DS    0H                                                  0198
*         R14=TABADDR(I);           /* ADDR OF OLD TABLE             */
         L     @07,WMSTPTR                                         0198
         LR    @06,I                                               0198
         SLA   @06,3                                               0198
         LA    @05,0(@06,@07)                                      0198
         AL    @05,@CF02035                                        0198
         L     R14,TABADDR(,@05)                                   0198
*         R1=TABSIZE(I);            /* LENGTH OF OLD TABLE           */
         AL    @07,@CF02036                                        0199
         L     R1,TABSIZE-4(@06,@07)                               0199
*       END;                                                       0200
*     R15=R1;                                                      0201
*                                                                  0201
@RC00192 LR    R15,R1                                              0201
*/* MOVE DATA TO NEW AREA                                            */
*                                                                  0202
*     GEN REFS(R0,R1,R14,R15)(MVCL R0,R14);                        0202
*                                                                  0202
         MVCL R0,R14
*/* FREE OLD STORAGE                                                 */
*                                                                  0203
*     IF I=ONE THEN                                                0203
         C     I,@CF00077                                          0203
         BNE   @RF00203                                            0203
*       DO;                         /* FREE WMST                     */
*         R0=LENGTH(WMST)|SUBPL245; /* SUBPOOL # AND STOR SIZE       */
         LA    @07,112                                             0205
         L     R0,SUBPL245                                         0205
         OR    R0,@07                                              0205
*         R1=WMSTPTR;               /* ADDR OF OLD TABLE             */
         L     R1,WMSTPTR                                          0206
*         WMSTPTR=TABLEPTR;         /* RESET WMSTPTR         @Z40BPEM*/
         ST    TABLEPTR,WMSTPTR                                    0207
*         LENTH=LENGTH(WMST);       /* DISP INTO AREA FOR NEXT TABLE */
         ST    @07,LENTH                                           0208
*       END;                                                       0209
*     ELSE                                                         0210
*       DO;                         /* FREE THE OTHER TABLES         */
         B     @RC00203                                            0210
@RF00203 DS    0H                                                  0211
*         R0=TABSIZE(I)|SUBPL245;   /* SUBPOOL # AND STORAGE SZE     */
         L     @07,WMSTPTR                                         0211
         LR    @06,I                                               0211
         SLA   @06,3                                               0211
         LA    @05,0(@06,@07)                                      0211
         AL    @05,@CF02036                                        0211
         L     @05,TABSIZE-4(,@05)                                 0211
         LR    R0,@05                                              0211
         O     R0,SUBPL245                                         0211
*         R1=TABADDR(I);            /* ADDR OF OLD TABLE             */
         AL    @07,@CF02035                                        0212
         L     R1,TABADDR(@06,@07)                                 0212
*         LENTH=TABSIZE(I);         /* DISP INTO AREA FOR NEXT TABLE */
         ST    @05,LENTH                                           0213
*       END;                                                       0214
*     GEN(FREEMAIN R,LV=(0),A=(1));                                0215
@RC00203 DS    0H                                                  0215
         FREEMAIN R,LV=(0),A=(1)
*   END;                                                           0216
         AL    I,@CF00077                                          0216
         C     I,@CF01119                                          0216
         BNH   @DL00189                                            0216
*   RETURN;                                                        0217
@EL00002 DS    0H                                                  0217
@EF00002 DS    0H                                                  0217
@ER00002 LM    @14,@12,@SA00002                                    0217
         BR    @14                                                 0217
*   RESPECIFY                                                      0218
*    (R0,                                                          0218
*     R1,                                                          0218
*     R14,                                                         0218
*     R15) UNRSTD;                                                 0218
*   END RMIPGMCS;                                                  0219
*                                                                  0220
*/********************************************************************/
*/*                                                                  */
*/*  PROCEDURE NAME: RMIPGM                                          */
*/*                                                                  */
*/*  FUNCTION:                                                       */
*/*  GETMAIN FROM SUBPOOL 245 FOR A CONTROL BLOCK                    */
*/*  PARAMTERS FOR RMIPGM:                                           */
*/*    1. 1 WORD-ADDR OF CONTROL BLOCK UPON EXIT                     */
*/*    2. 1 WORD-SIZE OF CONTROL BLOCK                               */
*/*    3. 1 WORD-ADDR OF CONTROL BLOCK UPON EXIT                     */
*/*                                                                  */
*/********************************************************************/
*                                                                  0220
*RMIPGM:                                                           0220
*   PROC(IPGMPPTR,IPGMPSZE,IPGFTPTR);                              0220
RMIPGM   STM   @14,@12,@SA00003                                    0220
         MVC   @PC00003(12),0(@01)                                 0220
*   DECLARE                                                        0221
*     IPGMPPTR PTR,                 /* PTR TO TABLE                  */
*     IPGMPSZE FIXED,               /* SIZE OF TABLE                 */
*     IPGFTPTR PTR                  /* PTR TO TABLE                  */
*         ;                                                        0221
*   RESPECIFY                                                      0222
*    (R0,                                                          0222
*     R1,                                                          0222
*     R14,                                                         0222
*     R15) RESTRICTED;                                             0222
*   R0=IPGMPSZE|SUBPL245;           /* SUBPOOL NO & STORAGE SIZE     */
         L     @07,@PC00003+4                                      0223
         L     R0,IPGMPSZE(,@07)                                   0223
         O     R0,SUBPL245                                         0223
*   GEN(GETMAIN R,LV=(0));                                         0224
         GETMAIN R,LV=(0)
*   IPGMPPTR=R1;                    /* ADDR OF AREA GOTTEN           */
         L     @07,@PC00003                                        0225
         ST    R1,IPGMPPTR(,@07)                                   0225
*   IPGFTPTR=R1;                    /* ADDR OF AREA GOTTEN           */
         L     @07,@PC00003+8                                      0226
         ST    R1,IPGFTPTR(,@07)                                   0226
*/*  CLEAR AREA GOTTEN                                               */
*                                                                  0227
*   R0=R1;                          /* ADDR OF AREA TO BE CLEARED    */
         LR    R0,R1                                               0227
*   R1=IPGMPSZE;                    /* LENGTH OF AREA                */
         L     @07,@PC00003+4                                      0228
         L     R1,IPGMPSZE(,@07)                                   0228
*   R14=ADDR(CLEAR);                /* ADDR OF LOCATION WITH 0       */
         LA    R14,CLEAR                                           0229
*   R15=ZERO;                       /* PADDING CHAR IS 0             */
         SLR   R15,R15                                             0230
*   GEN REFS(R0,R1,R14,R15)( MVCL  R0,R14 );                       0231
          MVCL  R0,R14
*   RETURN;                         /* RETURN TO CALLER              */
@EL00003 DS    0H                                                  0232
@EF00003 DS    0H                                                  0232
@ER00003 LM    @14,@12,@SA00003                                    0232
         BR    @14                                                 0232
*   END RMIPGM;                                                    0233
*                                                                  0234
*/********************************************************************/
*/*                                                                  */
*/*  PROCEDURE NAME: RMIPFM                                          */
*/*                                                                  */
*/*  FUNCTION:                                                       */
*/*  FREEMAIN FROM SUBPOOL 245 FOR UNUSED SPACE IN A CONTROL BLOCK   */
*/*  PARAMETERS FOR RMIPFM:                                          */
*/*    1. 1 WORD-ADDR OF CONTROL BLOCK                               */
*/*    2. 1 WORD-SIZE OF CONTROL BLOCK                               */
*/*    3. 1 WORD-ACTUAL SIZE OF STORAGE USED IN CONTROL BLOCK        */
*/*  IF THE ACTUAL SIZE OF THE CONTROL BLOCK IS NOT A MULTIPLE OF A  */
*/*  DOUBLE WORD, ROUND IT UP TO THE NEXT DOUBLEWORD BOUNDARY        */
*/*                                                                  */
*/********************************************************************/
*                                                                  0234
*RMIPFM:                                                           0234
*   PROC(IPFMPPTR,IPFMPSZE,IPFMASZE);                              0234
RMIPFM   STM   @14,@12,@SA00004                                    0234
         MVC   @PC00004(12),0(@01)                                 0234
*   DECLARE                                                        0235
*     IPFMPPTR PTR,                 /* PTR TO TABLE                  */
*     IPFMPSZE FIXED,               /* SIZE OF TABLE                 */
*     IPFMASZE FIXED                /* SIZE OF STORAGE USED          */
*         ;                                                        0235
*   IF(IPFMASZE//DBLWORD)=ZERO THEN /* SIZE OF STORAGE USED IS     0236
*                                      MULTIPLE OF DOUBLE WORD       */
         L     @07,@PC00004+8                                      0236
         L     @07,IPFMASZE(,@07)                                  0236
         LR    @02,@07                                             0236
         SRDA  @02,32                                              0236
         D     @02,@CF00046                                        0236
         LTR   @02,@02                                             0236
         BNZ   @RF00236                                            0236
*     IPFMRSZE=IPFMASZE;                                           0237
         LR    IPFMRSZE,@07                                        0237
*   ELSE                            /* NOT A MULTIPLE OF DWORD       */
*     IPFMRSZE=(IPFMASZE/DBLWORD+ONE)*DBLWORD;/* ROUND TO NEXT DWORD
*                                      BOUNDARY                      */
         B     @RC00236                                            0238
@RF00236 L     @07,@PC00004+8                                      0238
         L     IPFMRSZE,IPFMASZE(,@07)                             0238
         SRDA  IPFMRSZE,32                                         0238
         D     IPFMRSZE,@CF00046                                   0238
         AL    @03,@CF00077                                        0238
         SLA   @03,3                                               0238
         LR    IPFMRSZE,@03                                        0238
*/*  ADDR OF AREA TO BE FREED = ADDR OF BEG OF TABLE+SIZE OF STORAGE */
*/*  USED (ROUNDED TO A DWORD)                                       */
*/*  SIZE OF AREA TO BE FREED = INITIAL SIZE OF TABLE-SIZE OF STORAGE*/
*/*  USED (ROUNDED TO A DWORD)                                       */
*                                                                  0239
*   IPGFQSZE=IPFMPSZE-IPFMRSZE;     /* SIZE OF STORAGE TO BE FREED =
*                                      ALLOCATED SIZE - ACTUAL SIZE  */
@RC00236 L     @07,@PC00004+4                                      0239
         L     IPGFQSZE,IPFMPSZE(,@07)                             0239
         SLR   IPGFQSZE,IPFMRSZE                                   0239
*   IF IPGFQSZE>ZERO THEN           /* UNUSED STORAGE SIZE>0         */
         LTR   IPGFQSZE,IPGFQSZE                                   0240
         BNP   @RF00240                                            0240
*     DO;                           /* FREE UNUSED STORAGE           */
*       R0=IPGFQSZE|SUBPL245;       /* SUBPOOL NO & STORAGE SIZE     */
         LR    R0,IPGFQSZE                                         0242
         O     R0,SUBPL245                                         0242
*       R1=IPFMPPTR+IPFMRSZE;       /* ADDR OF STORAGE TO BE FREED   */
         L     @03,@PC00004                                        0243
         LR    R1,IPFMRSZE                                         0243
         AL    R1,IPFMPPTR(,@03)                                   0243
*       GEN(FREEMAIN R,LV=(0),A=(1));                              0244
         FREEMAIN R,LV=(0),A=(1)
*     END;                                                         0245
*   IPFMPSZE=IPFMRSZE;              /* ACTUAL SIZE OF TABLE ROUNDED
*                                      UP TO NEXT DWORD              */
@RF00240 L     @03,@PC00004+4                                      0246
         ST    IPFMRSZE,IPFMPSZE(,@03)                             0246
*   RETURN;                         /* RETURN TO CALLER              */
@EL00004 DS    0H                                                  0247
@EF00004 DS    0H                                                  0247
@ER00004 LM    @14,@12,@SA00004                                    0247
         BR    @14                                                 0247
*   END RMIPFM;                                                    0248
*   RESPECIFY                                                      0249
*    (R0,                                                          0249
*     R1,                                                          0249
*     R14,                                                         0249
*     R15) UNRESTRICTED;                                           0249
*                                                                  0250
*/********************************************************************/
*/*                                                                  */
*/*  PROCEDURE NAME: RMIPCKTS                                        */
*/*                                                                  */
*/*  FUNCTION:                                                       */
*/*  THIS ROUTINE CHECKS IF THERE IS SUFFICIENT SPACE IN THE CURRENT */
*/*  TABLE TO ACCOMMODATE THE NEXT ENTRY.  IF SPACE IS INSUFFICIENT, */
*/*  IT WILL GET STORAGE FOR THE MAX SIZE OF THE TABLE, COPY THE DATA*/
*/*  FROM THE OLD TABLE TO THE NEW TABLE, UPDATE TABLE POINTERS TO   */
*/*  POINT TO THE NEW TABLE AND FREE THE OLD TABLE.                  */
*/*                                                                  */
*/*  PARAMETERS FOR RMIPCKTS:                                        */
*/*    1. 1 WORD-POINTER TO 1ST BYTE OF CURRENT TABLE                */
*/*    2. 1 WORD-SIZE OF CURRENT TABLE                               */
*/*    3. 1 WORD-POINTER TO NEXT TABLE ENTRY                         */
*/*    4. 1 WORD-SIZE OF NEXT ENTRY                                  */
*/*    5. 1 WORD - MAX SIZE OF TABLE                                 */
*/*                                                                  */
*/********************************************************************/
*                                                                  0250
*RMIPCKTS:                                                         0250
*   PROC(IPCKCTPT,IPCKCTSZ,IPCKCEPT,IPCKNXES,IPCKMAXS);            0250
RMIPCKTS STM   @14,@12,@SA00005                                    0250
         MVC   @PC00005(20),0(@01)                                 0250
*   DECLARE                                                        0251
*     IPCKCTPT FIXED,               /* PTR TO 1ST BYTE OF CURRENT  0251
*                                      TABLE                         */
*     IPCKCTSZ FIXED,               /* SIZE OF CURRENT TABLE         */
*     IPCKCEPT FIXED,               /* PTR TO NEXT ENTRY             */
*     IPCKNXES FIXED,               /* SIXE OF NEXT ENTRY            */
*     IPCKMAXS FIXED,               /* MAX SIZE OF TABLE             */
*     IPCKOTPT FIXED,               /* PTR TO 1ST BYTE OF OLD TBL    */
*     IPCKOTSZ FIXED,               /* SIZE OF OLD TABLE             */
*     IPCKOEPT FIXED                /* PTR TO NEXT ENTRY IN OLD TABLE*/
*         ;                                                        0251
*   IF(IPCKCEPT+IPCKNXES)>(IPCKCTPT+IPCKCTSZ) THEN/* SIZE OF       0252
*                                      ENTRIE+SIZE OF NEXT ENTRY>SIZE
*                                      OF CURRENT TABLE              */
         L     @15,@PC00005+8                                      0252
         L     @14,IPCKCEPT(,@15)                                  0252
         L     @07,@PC00005+12                                     0252
         LR    @06,@14                                             0252
         AL    @06,IPCKNXES(,@07)                                  0252
         L     @07,@PC00005                                        0252
         L     @05,IPCKCTPT(,@07)                                  0252
         L     @04,@PC00005+4                                      0252
         L     @03,IPCKCTSZ(,@04)                                  0252
         LR    @02,@05                                             0252
         ALR   @02,@03                                             0252
         CR    @06,@02                                             0252
         BNH   @RF00252                                            0252
*     DO;                           /* CONSTRUCT TABLE OF MAX SIZE   */
*       IPCKOTPT=IPCKCTPT;          /* SAVE PTR TO CURRENT TABLE     */
         LR    IPCKOTPT,@05                                        0254
*       IPCKOTSZ=IPCKCTSZ;          /* SAVE SIZE OF CURRENT TABLE    */
         L     @06,@PC00005+4                                      0255
         L     @06,IPCKCTSZ(,@06)                                  0255
         LR    IPCKOTSZ,@06                                        0255
*       IPCKOEPT=IPCKCEPT;          /* SAVE PTR TO NEXT ENTRY IN   0256
*                                      CURRENT TABLE                 */
         ST    @14,IPCKOEPT                                        0256
*       IPCKCTSZ=IPCKMAXS;          /* MAX SIZE OF TABLE             */
         L     @05,@PC00005+16                                     0257
         L     @05,IPCKMAXS(,@05)                                  0257
         ST    @05,IPCKCTSZ(,@04)                                  0257
*       CALL RMIPGM(IPCKCTPT,IPCKCTSZ,IPCKCEPT);/* GET STORAGE FOR 0258
*                                      TABLE OF MAX SIZE             */
         ST    @07,@AL00001                                        0258
         ST    @04,@AL00001+4                                      0258
         ST    @15,@AL00001+8                                      0258
         LA    @01,@AL00001                                        0258
         BAL   @14,RMIPGM                                          0258
*/*  MOVE DATA TO NEW TABLE                                          */
*                                                                  0259
*       RESPECIFY                                                  0259
*        (R0,                                                      0259
*         R1,                                                      0259
*         R14,                                                     0259
*         R15) RSTD;                                               0259
*       R0=IPCKCTPT;                /* ADDR OF NEW TABLE             */
         L     @07,@PC00005                                        0260
         L     R0,IPCKCTPT(,@07)                                   0260
*       R14=IPCKOTPT;               /* ADDR OF 1ST BYTE OF OLD TBL   */
         LR    R14,IPCKOTPT                                        0261
*       R1=IPCKOEPT-IPCKOTPT;       /* SIZE OF DATA FIELD TO BE    0262
*                                      COPIED                        */
         L     R1,IPCKOEPT                                         0262
         SLR   R1,IPCKOTPT                                         0262
*       R15=R1;                     /* SIZE OF DATA FIELD            */
         LR    R15,R1                                              0263
*       GEN REFS(R0,R1,R14,R15)( MVCL R0,R14 );                    0264
          MVCL R0,R14
*       IPCKCEPT=R0;                /* PTR TO NEXT ENTRY IN NEW TABLE*/
         L     @07,@PC00005+8                                      0265
         ST    R0,IPCKCEPT(,@07)                                   0265
*/*  FREE OLD TABLE                                                  */
*                                                                  0266
*       R0=IPCKOTSZ|SUBPL245;       /* SUBPOOL NO. & STORAGE SIZE    */
         LR    R0,IPCKOTSZ                                         0266
         O     R0,SUBPL245                                         0266
*       R1=IPCKOTPT;                /* ADDR OF OLD TABLE             */
         LR    R1,IPCKOTPT                                         0267
*       GEN( FREEMAIN R,LV=(0),A=(1) );                            0268
          FREEMAIN R,LV=(0),A=(1)
*     END;                                                         0269
*   RETURN;                         /* RETURN TO CALLER              */
@EL00005 DS    0H                                                  0270
@EF00005 DS    0H                                                  0270
@ER00005 LM    @14,@12,@SA00005                                    0270
         BR    @14                                                 0270
*   END RMIPCKTS;                                                  0271
         B     @EL00005                                            0271
*   RESPECIFY                                                      0272
*    (R0,                                                          0272
*     R1,                                                          0272
*     R14,                                                         0272
*     R15) UNRSTD;                                                 0272
*                                                                  0273
*/********************************************************************/
*/*                                                                  */
*/*  PROCEDURE NAME: RMIPINIT                                        */
*/*                                                                  */
*/*   PURPOSE     = TO PROCESS DATA FROM THE IEAIPSXX LIST           */
*/*   LINKAGE     = VIA CALL                                         */
*/*   INPUT       = ADDR OF A 1-BYTE FIELD CONTAINING THE PROCESSING */
*/*                 SUBROUTINE NUMBER                                */
*/*   INVOKER     = IRBMFANL                                         */
*/*   EXIT-NORMAL = RETURN TO CALLER                                 */
*/*    OUTPUT DATA= NONE                                             */
*/*                                                                  */
*/********************************************************************/
*                                                                  0273
*RMIPINIT:                                                         0273
*   PROC(IPCODEPT);                                                0273
RMIPINIT STM   @14,@12,@SA00006                                    0273
         MVC   @PC00006(4),0(@01)                                  0273
*   DECLARE                                                        0274
*     IPCODEPT PTR(31),             /* POINTER TO CODE               */
*     IPBRINDX FIXED(8) BASED(IPCODEPT),/* INDEX TO BRANCH TABLE     */
*/*  IPBRTAB IS A TABLE CONTAINING THE ADDRESSES OF THE SUBROUTINES  */
*/*  WHICH PROCESS IPS DATA.  THE DIMENSION OF IPBRTAB IS THE NUMBER */
*/*  OF SUBROUTINES.  THE INPUT PARAMETER TO THE RMIPINIT PROCEDURE  */
*/*  IS USED TO ACCESS THE SUBSCRIPT FOR IPBRTAB                     */
*                                                                  0274
*     IPBRTAB(31) PTR INIT(ADDR(RMIP001),ADDR(RMIP002),ADDR(RMIP003),
*         ADDR(RMIP004),ADDR(RMIP005),ADDR(RMIP006),ADDR(RMIP007),ADDR(
*         RMIP008),ADDR(RMIP009),ADDR(RMIP010),ADDR(RMIP011),ADDR( 0274
*         RMIP012),ADDR(RMIP013),ADDR(RMIP014),ADDR(RMIP015),ADDR( 0274
*         RMIP016),ADDR(RMIP017),ADDR(RMIP018),ADDR(RMIP019),ADDR( 0274
*         RMIP020),ADDR(RMIP021),ADDR(RMIP022),ADDR(RMIP023),ADDR( 0274
*         RMIP024),                 /*                       @Z40BPEM*/
*         ADDR(RMIP025),            /*                       @Z40BPEM*/
*         ADDR(RMIP026),            /*                       @Z40BPEM*/
*         ADDR(RMIP027),            /*                       @Z40BPEM*/
*         ADDR(RMIP028),            /*                       @Z40BPEM*/
*         ADDR(RMIP029),            /*                       @Z40BPEM*/
*         ADDR(RMIP030),            /*                       @Z40BPEM*/
*         ADDR(RMIP031)),           /*                       @Z40BPEM*/
*     RMIPLBL LABEL BASED(IPBRTAB(IPBRINDX))/* LABEL FOR PROCESSING
*                                      SUBROUTINE                    */
*         ;                                                        0274
*   DECLARE                                                        0275
*     K FIXED(31) CONSTANT(1000),   /* 1K                            */
*     MILLISEC FIXED(31) CONSTANT(1024),/* CONSTANT USED TO CONVERT A
*                                      SECOND TO A MILLISECOND       */
*     CPU FIXED CONSTANT(1),        /* CPU SERVICE COEFF INDEX NO.   */
*     IOC FIXED CONSTANT(2),        /* IOC SERVICE COEFF INDEX NO.   */
*     MSO FIXED CONSTANT(3),        /* MSO SERVICE COEFF INDEX NO.   */
*     CSTMIN FIXED CONSTANT(1),     /* MIN INDEX #           @Z40BPEM*/
*     CSTMAX FIXED CONSTANT(2),     /* MAX INDEX #           @Z40BPEM*/
*     CSTWT FIXED CONSTANT(3),      /* WT INDEX #            @Z40BPEM*/
*     MINWKLC FIXED(31) CONSTANT(2),/* MIN WORKLOAD LEVEL COUNT      */
*     MINWKLN FIXED(31) CONSTANT(1),/* MIN WORKLOAD LEVEL NO         */
*     MAXWKLN FIXED(31) CONSTANT(128),/* MAX WORKLOAD LEVEL NUMBER   */
*     MAXSRV FIXED(31) CONSTANT(9999),/* MAX SERVICE RATE NO.        */
*     MINPGN FIXED(31) CONSTANT(1), /* MIN PERFORMANCE GROUP NO.     */
*     MINOBJ FIXED(31) CONSTANT(1), /* MIN OBJECTIVE NO.             */
*     MINDMN FIXED(31) CONSTANT(1), /* MIN DMN #             @Z40BPEM*/
*     MAXDUR FIXED(31) CONSTANT(999999999),/* MAX DURATION NO.       */
*     MAXDURK FIXED(31) CONSTANT(999999),/* MAX DURATION NO. IN K  0275
*                                      UNITS                         */
*     MAXISV FIXED(31) CONSTANT(999999),/* MAX INTERVAL SERVICE VALUE*/
*     MAXISVK FIXED(31) CONSTANT(999),/* MAX INTERVAL SERVICE VALUE
*                                      IN K UNITS                    */
*     MINRTB FIXED(31) CONSTANT(0), /* MIN RTB VALUE                 */
*     MAXRTB FIXED(31) CONSTANT(1), /* MAX RTB VALUE                 */
*     MAXRDURC FIXED(31) CONSTANT(1000000),/* MAX NO. IN SECS FOR  0275
*                                      PERF GRP PERIOD DURATION      */
*     MAXCSTC FIXED(31) CONSTANT(3),/* MAX # OF CNSTRS       @Z40BPEM*/
*     MAXAPG FIXED CONSTANT(15),    /* UPPER LIMIT ON APG    @Z40BPEM*/
*     CNSTRLB FIXED,                /* LOWER BOUND ON CNSTRS @Z40BPEM*/
*     CNSTRUB FIXED CONSTANT(255),  /* UPPER LIMIT ON CNSTRS @Z40BPEM*/
*     INDX FIXED,                   /* WORK AREA             @Z40BPEM*/
*     RUNIT BIT(1) CONSTANT('1'B)   /* REAL TIME UNIT CODE           */
*         ;                                                        0275
*   DECLARE                                                        0276
*     NEGSRV FIXED(15) INIT(-32768),/* NEGATIVE SERVICE RATE         */
*/*  PERF OBJ ENTRY FOR THE POINT FOR MAX SERV RATE & WKL=0          */
*                                                                  0276
*     1 MAXSRVPT STATIC LOCAL,      /* WPOD ENTRY FOR MAX SERVICE  0276
*                                      RATE AND WKL=0                */
*      2 * FIXED(15) INIT(32767),   /* MAX SERVICE RATE              */
*      2 * FIXED(16) UNSIGNED INIT(0),/* WKL=0                       */
*/*  PERIOD DURATION MASK FOR 8 PERIODS                              */
*                                                                  0276
*     PDURMASK(8) FIXED(32) STATIC LOCAL INIT(1,/* PERIOD 1          */
*         2,                        /* PERIOD 2                      */
*         4,                        /* PERIOD 3                      */
*         8,                        /* PERIOD 4                      */
*         16,                       /* PERIOD 5                      */
*         32,                       /* PERIOD 6                      */
*         64,                       /* PERIOD 7                      */
*         128),                     /* PERIOD 8                      */
*/*  PERIOD DOMAIN MASK FOR 8 PERIODS                        @Z40BPEM*/
*                                                                  0276
*     PDMNMASK(8) FIXED(32) STATIC LOCAL INIT(1,/* PERIOD 1  @Z40BPEM*/
*         2,                        /* PERIOD 2              @Z40BPEM*/
*         4,                        /* PERIOD 3              @Z40BPEM*/
*         8,                        /* PERIOD 4              @Z40BPEM*/
*         16,                       /* PERIOD 5              @Z40BPEM*/
*         32,                       /* PERIOD 6              @Z40BPEM*/
*         64,                       /* PERIOD 7              @Z40BPEM*/
*         128),                     /* PERIOD 8              @Z40BPEM*/
*/*  DOMAIN CONSTRAINTS MASK                                 @Z40BPEM*/
*                                                                  0276
*     DCSTMASK(3) FIXED(32) STATIC LOCAL INIT(1,/* MIN IS SPECIFIED
*                                                            @Z40BPEM*/
*         2,                        /* MAX IS SPECIFIED      @Z40BPEM*/
*         4),                       /* WT IS SPECIFIED       @Z40BPEM*/
*/*  DEFAULT PERF GROUP PERIOD ENTRY                                 */
*                                                                  0276
*     1 DEFWPGP CHAR(8) BDY(WORD) STATIC LOCAL,/*            @Z40BPEM*/
*      2 DPGPOBJN PTR(08) INIT(0),  /* OBJ NO.=0                     */
*      2 DPGPDMN PTR(8) INIT(1),    /* DMN NO.=1             @Z40BPEM*/
*      2 * CHAR(2) INIT(''),        /* RESERVED              @Z40BPEM*/
*      2 DPGPAPGV PTR(8) INIT(0),   /* APG DISP. PRTY.       @Z40BPEM*/
*      2 DPGPINDS BIT(8) INIT('00000000'B),/* RTB = 0        @ZM43078*/
*      2 DPGPISVP PTR(08) INIT('01'X),/* INDEX TO IPWPGL ENTRY WHICH
*                                      CONTAINS THE BASE ISV         */
*      2 DPGPDURP PTR(08) INIT(0),  /* PERIOD DUR=0                  */
*/*  DEFAULT DOMAIN TABLE ENTRY                              @Z40BPEM*/
*                                                                  0276
*     1 DEFDMDE CHAR(20) BDY(WORD) STATIC LOCAL,/*           @Z40BPEM*/
*      2 DMDNO FIXED(8) INIT(1),    /* DOMAIN NO.            @Z40BPEM*/
*      2 DMDLO FIXED(8) INIT(1),    /* MIN MPL NO.           @Z40BPEM*/
*      2 DMDHI FIXED(8) INIT(255),  /* MAX MPL NO.           @Z40BPEM*/
*      2 DMDWT FIXED(8) INIT(1),    /* WEIGHTING FACTOR      @Z40BPEM*/
*      2 DMDMPLT FIXED(15) INIT(1), /* MPL TARGET            @Z40BPEM*/
*      2 DMDGOOU FIXED(15) INIT(0), /* CURRENT # OF USERS GOING OUT
*                                                            @Z40BPEM*/
*      2 DMDCMPL FIXED(15) INIT(0), /* CURRENT MPL           @Z40BPEM*/
*      2 DMDOUTU FIXED(15) INIT(0), /* CURRENT # USERS ON OUT QUEUE
*                                                            @Z40BPEM*/
*      2 DMDINCU FIXED(15) INIT(0), /* CURRENT # OF SWAPPABLE IN CORE
*                                      USERS                 @Z40BPEM*/
*      2 DMDRUA FIXED(15) INIT(0),  /* AVE # OF READY USERS  @Z40BPEM*/
*      2 DMDRUC FIXED(31) INIT(0);  /* ACCUMULATOR FOR READY USER  0276
*                                      AVERAGE               @Z40BPEM*/
*   DECLARE                                                        0277
*     WPGPPTR PTR(31),              /* PTR TO PERF GRP PERIOD        */
*     WPGLPTR PTR(31),              /* PTR TO WPGL                   */
*     IPWDURVL FIXED(31),           /* MAX VALUE FOR DURATION        */
*     IPWISVL FIXED(31),            /* MAX VALUE FOR INTERVAL SERVICE
*                                      VALUE                         */
*     IPWPGLPT CHAR(17) DEFINED(IPWPGLP),/* OFFSETS FOR IPWPGLL    0277
*                                      ENTRIES                       */
*     IPWSRV(32) FIXED(15),         /* SRV FOR A PERF OBJ            */
*     IPWORK(32) FIXED(16) UNSIGNED,/* WKL FOR A PERF OBJ            */
*     IPWWKLS FIXED(16) UNSIGNED,   /* HIGHEST WKL SPEC'ED FOR AN  0277
*                                      OBJ*SCALING NO/LOWEST WORKLOAD
*                                      LEVEL SPEC'ED IN IPS          */
*     IPWWKLD FIXED(16) UNSIGNED,   /* WORKING AREA                  */
*     IPWWKLZ FIXED(16) UNSIGNED,   /* DUMMY WKL                     */
*     IPWWKLE FIXED(16) UNSIGNED,   /* EXTRAPOLATED WKL NO           */
*     IPWSLP FIXED(31),             /* RATE/LEVEL SLOPE              */
*     IPWSLPP FIXED(31),            /* SLOPE AT PREVIOUS PT          */
*     IPWPGLI FIXED(15),            /* WORKING AREA                  */
*     IPWWKL(32) FIXED(08),         /* WORKLOAD LEVEL NUMBERS        */
*     IPWSRVC FIXED(15),            /* SERVICE RATES COUNT           */
*     IPWINDX FIXED(15),            /* USED AS INDEX TO IPWCOEF AND
*                                      IPWAM                         */
*     IPWS FIXED(15),               /* USED AS INDEX TO IPWORK       */
*     IPWWKLI FIXED(15),            /* USED AS INDEX TO IPWWKL       */
*     IPWWKLC FIXED(15),            /* WORKLOAD LEVELS COUNT         */
*     IPWPGPC FIXED(15),            /* PG PERIOD COUNT FOR A PG      */
*     IPWPGLCT FIXED(15),           /* NO OF ENTRIES FOR WPGL        */
*     IPWLOOPC FIXED(15),           /* LOOP COUNTER                  */
*     IPWDURMB FIXED(32),           /* CORRECT PERIOD DURATION     0277
*                                      INDICATOR                     */
*     CNSTRVAL(3) FIXED(8),         /* ARRAY FOR STORING CNSTR VALUES
*                                                            @Z40BPEM*/
*     CNSTRI FIXED(8),              /* INDEX TO CNSTRVAL     @Z40BPEM*/
*     CSTMB FIXED(32),              /* CORRECT CNSTR IND     @Z40BPEM*/
*     DMNMB FIXED(32),              /* CORRECT PER DMN IND   @Z40BPEM*/
*     PREVPDMN FIXED(8),            /* STORE AREA FOR PREVIOUS DMN #
*                                                            @Z40BPEM*/
*/*  PERFORMANCE GROUP PERIOD OPTION FLAGS                           */
*                                                                  0277
*     1 IPWPGPM FIXED(08),          /* PG PERIOD OPTION SELECTIONS   */
*      2 IPWPMOBJ BIT(1),           /* OBJ OPTION                    */
*      2 IPWPMDUR BIT(1),           /* DUR OPTION                    */
*      2 IPWPMISV BIT(1),           /* ISV OPTION                    */
*      2 IPWPMRTB BIT(1),           /* RTB OPTION                    */
*      2 IPWPMUNT BIT(1),           /* UNT OPTION                    */
*      2 IPWPMDMN BIT(1),           /* DMN OPTION            @Z40BPEM*/
*      2 IPWPMAPG BIT(1),           /* APG OPTION            @Z40BPEM*/
*      2 * BIT(1);                  /* RESERVED              @Z40BPEM*/
*                                                                  0278
*/*  BRANCH TO THE SUBROUTINE BASED ON THE INPUT PARAMETER           */
*                                                                  0278
*   GO TO RMIPLBL;                  /* GO TO PROCESSING SUBRTN       */
         L     @15,@PC00006                                        0278
         L     @01,IPCODEPT(,@15)                                  0278
         SLR   @15,@15                                             0278
         IC    @15,IPBRINDX(,@01)                                  0278
         SLA   @15,2                                               0278
         L     @01,IPBRTAB-4(@15)                                  0278
         BR    @01                                                 0278
*RMIP001:                                                          0279
*   ;                               /* THE PARM KEYWORD 'CPU' HAS  0279
*                                      BEEN RECOGNIZED               */
RMIP001  DS    0H                                                  0280
*   IPWINDX=CPU;                                                   0280
         MVC   IPWINDX(2),@CH00077                                 0280
*   RETURN;                         /* RETURN TO CALLER              */
@EL00006 DS    0H                                                  0281
@EF00006 DS    0H                                                  0281
@ER00006 LM    @14,@12,@SA00006                                    0281
         BR    @14                                                 0281
*RMIP002:                                                          0282
*   ;                               /* THE PARM KEYWORD 'IOC' HAS  0282
*                                      BEEN RECOGNIZED               */
RMIP002  DS    0H                                                  0283
*   IPWINDX=IOC;                                                   0283
         MVC   IPWINDX(2),@CH00118                                 0283
*   RETURN;                         /* RETURN TO CALLER              */
         B     @EL00006                                            0284
*RMIP003:                                                          0285
*   ;                               /* THE PARM KEYWORD 'MSO' HAS  0285
*                                      BEEN RECOGNIZED               */
RMIP003  DS    0H                                                  0286
*   IPWINDX=MSO;                                                   0286
         MVC   IPWINDX(2),@CH00082                                 0286
*   RETURN;                         /* RETURN TO CALLER              */
         B     @EL00006                                            0287
*RMIP004:                                                          0288
*                                                                  0288
*/*  THE COEFFICIENT VALUE HAS BEEN RECOGNIZED                       */
*/*  VERIFY THAT THE COEFFICIENT IS WITHIN ALLOWABLE RANGE           */
*/*  IF THE COEFFICIENT IS INVALID, THE IPS IS INVALID               */
*/*  IF THE COEFFICIENT HAS BEEN PREVIOUSLY SPECIFIED, THEN IGNORE IT*/
*                                                                  0288
*   IF IPWINT1>=ZERO&IPWINT1<=MAXSDC/* 99>=IPWINT1>=0                */
*       &IPWINT2>=ZERO&IPWINT2<=NINE/* 9>=IPWINT2>=0                 */
*     THEN                          /* SERVICE COEFF NO. VALID       */
RMIP004  L     @15,IPWINT1                                         0288
         SLR   @14,@14                                             0288
         CR    @15,@14                                             0288
         BL    @RF00288                                            0288
         C     @15,@CF01218                                        0288
         BH    @RF00288                                            0288
         L     @07,IPWINT2                                         0288
         CR    @07,@14                                             0288
         BL    @RF00288                                            0288
         C     @07,@CF01214                                        0288
         BH    @RF00288                                            0288
*     DO;                                                          0289
*       IF(IPWAMCOF&IPMASKTB(IPWINDX))=ZERO/* PARAMETER HAS NOT BEEN
*                                      PROCESSED                     */
*         THEN                      /* PROCESS SERVICE COEFF PARM    */
         L     @06,IPWAMCOF                                        0290
         LH    @05,IPWINDX                                         0290
         SLA   @05,2                                               0290
         L     @04,IPMASKTB-4(@05)                                 0290
         LR    @03,@06                                             0290
         NR    @03,@04                                             0290
         CLR   @03,@14                                             0290
         BNE   @RF00290                                            0290
*         DO;                                                      0291
*           IPWAMCOF=IPWAMCOF|IPMASKTB(IPWINDX);/* INDICATES SERVICE
*                                      COEFFICIENT PROCESS           */
         OR    @06,@04                                             0292
         ST    @06,IPWAMCOF                                        0292
*           IPWMCOEF(IPWINDX)=IPWINT1*TEN+IPWINT2;/* COMBINE THE TWO
*                                      DIGITS TO FORM THE COEFFICIENT
*                                      VALUE                         */
         MH    @15,@CH01216                                        0293
         ALR   @15,@07                                             0293
         L     @14,WMSTPTR                                         0293
         ST    @15,IPWMCOEF-4(@05,@14)                             0293
*/*  CONVERT COEFFICIENT VALUES TO PRINTABLE FORM AND STORE          */
*/*  RESULTS IN THE WMST                                     @Z40BPEM*/
*                                                                  0294
*           CALL RMIPTRT(IPWINT1,TWO,ADDR(WHOLENO));/*       @Z40BPEM*/
         LA    @15,IPWINT1                                         0294
         ST    @15,@AL00001                                        0294
         LA    @15,@CF00118                                        0294
         ST    @15,@AL00001+4                                      0294
         LA    @15,WHOLENO                                         0294
         ST    @15,@AFTEMPS                                        0294
         LA    @15,@AFTEMPS                                        0294
         ST    @15,@AL00001+8                                      0294
         LA    @01,@AL00001                                        0294
         BAL   @14,RMIPTRT                                         0294
*           CALL RMIPTRT(IPWINT2,ONE,ADDR(FRACTION));/*      @Z40BPEM*/
         LA    @15,IPWINT2                                         0295
         ST    @15,@AL00001                                        0295
         LA    @15,@CF00077                                        0295
         ST    @15,@AL00001+4                                      0295
         LA    @15,FRACTION                                        0295
         ST    @15,@AFTEMPS                                        0295
         LA    @15,@AFTEMPS                                        0295
         ST    @15,@AL00001+8                                      0295
         LA    @01,@AL00001                                        0295
         BAL   @14,RMIPTRT                                         0295
*           INTGR1(IPWINDX)=WHOLENO;/* COEFF VALUES IN WMST ARE IN 0296
*                                                            @Z40BPEM*/
         L     @15,WMSTPTR                                         0296
         LH    @14,IPWINDX                                         0296
         SLA   @14,2                                               0296
         ST    @14,@TF00001                                        0296
         ALR   @14,@15                                             0296
         MVC   INTGR1-4(2,@14),WHOLENO                             0296
*           INTGR2(IPWINDX)=FRACTION;/* PRINTABLE FORM       @Z40BPEM*/
         AL    @15,@TF00001                                        0297
         MVC   INTGR2-4(1,@15),FRACTION                            0297
*         END;                                                     0298
*       RETURN;                     /* RETURN TO CALLER      @Z40BPEM*/
         B     @EL00006                                            0299
*     END;                                                         0300
*   ELSE                            /* SERVICE COEFF PARM INVALID    */
*     GO TO RMIPIPE;                /* IPS ERROR PROCESSING          */
*RMIP005:                                                          0302
*                                                                  0302
*/*  THE FIRST WORKLOAD LEVEL NO. IN THE WKL SPECIFICATION HAS BEEN  */
*/*  RECOGNIZED                                                      */
*                                                                  0302
*   IPWERWKL='0'B;                  /* RESET WKL ERROR INDICATOR     */
RMIP005  NI    IPWERWKL,B'11011111'                                0302
*   IPWWKLI=ZERO;                   /* INIT INDEX TO IPWWKL          */
         SLR   @15,@15                                             0303
         STH   @15,IPWWKLI                                         0303
*RMIP006:                                                          0304
*                                                                  0304
*/*  A WORKLOAD LEVEL NUMBER HAS BEEN RECOGNIZED                     */
*/*  VERIFY-1 THE WORKLOAD LEVEL NUMBER IS WITHIN ALLOWABLE RANGE    */
*/*         2 WORKLOAD LEVELS SPECIFICATION HAS NOT BEEN PROCESSED   */
*/*         3 NO MORE THAN 32 WORKLOAD LEVELS HAVE BEEN SPECIFIED    */
*/*  IF THE WORKLOAD LEVEL NUMBER IS OUT OF RANGE, THE ENTIRE IPS    */
*/*  IS CONSIDERED TO BE INVALID, SET IPS ERROR FLAG                 */
*                                                                  0304
*   IF(IPWINT1>=MINWKLN)&(IPWINT1<=MAXWKLN)/* NUMBER IS VALID        */
*     THEN                          /* WKL NO. IS VALID              */
RMIP006  L     @15,IPWINT1                                         0304
         LA    @14,1                                               0304
         CR    @15,@14                                             0304
         BL    @RF00304                                            0304
         C     @15,@CF01243                                        0304
         BH    @RF00304                                            0304
*     DO;                                                          0305
*       IF(IPWAMWKL='0'B)&(IPWWKLI<MAXWKLC)/* WKL HAS NOT BEEN     0306
*                                      PROCESSED AND LESS THAN THE 0306
*                                      MAX NO. OF LEVELS HAVE BEEN 0306
*                                      SPECIFIED                     */
*         THEN                      /* PROCESS WKL NO.               */
         TM    IPWAMWKL,B'01000000'                                0306
         BNZ   @RF00306                                            0306
         LH    @07,IPWWKLI                                         0306
         C     @07,@CF00135                                        0306
         BNL   @RF00306                                            0306
*         DO;                                                      0307
*           IPWWKLI=IPWWKLI+ONE;    /* INCREMENT WORKLOAD LEVEL COUNT*/
         ALR   @07,@14                                             0308
         STH   @07,IPWWKLI                                         0308
*           IPWWKL(IPWWKLI)=IPWINT1;/* SAVE WORKLOAD LEVEL NUMBER    */
         STC   @15,IPWWKL-1(@07)                                   0309
*         END;                                                     0310
*       RETURN;                     /* RETURN TO CALLER              */
         B     @EL00006                                            0311
*     END;                                                         0312
*   ELSE                            /* WKL NO. IS INVALID            */
*     DO;                                                          0313
@RF00304 DS    0H                                                  0314
*       IPWERWKL='1'B;              /* WKL IS INVALID                */
         OI    IPWERWKL,B'00100000'                                0314
*       GO TO RMIPIPE;              /* IPS IS INVALID                */
         B     RMIPIPE                                             0315
*     END;                                                         0316
*RMIP007:                                                          0317
*                                                                  0317
*/*  COMPLETED SCANNING WORKLOAD LEVEL SPECIFICATION                 */
*/*  IF THE WORKLOAD LEVELS ARE WITHIN THE ALLOWABLE RANGE AND THERE */
*/*  ARE AT LEASE 2 WORKLOAD LEVELS SPECIFIED, VERIFY THAT THE LEVEL */
*/*  NUMBERS ARE IN ASCENDING SEQUENCE                               */
*                                                                  0317
*   IF(IPWAMWKL='0'B)               /* WKL HAS NOT BEEN SPEC'ED      */
*       &(IPWERWKL='0'B) THEN       /* NO ERROR FOUND IN THIS WKL    */
RMIP007  TM    IPWAMWKL,B'01100000'                                0317
         BNZ   @RF00317                                            0317
*     DO;                                                          0318
*       IF IPWWKLI>=MINWKLC THEN    /* MORE THAN 1 WORKLOAD LEVEL NO.
*                                      HAVE BEEN SPECIFIED           */
         LH    @15,IPWWKLI                                         0319
         C     @15,@CF00118                                        0319
         BL    @RF00319                                            0319
*         DO;                                                      0320
*           IPWLOOPC=IPWWKLI-ONE;   /* WORKLOAD LEVELS CNT - 1       */
         BCTR  @15,0                                               0321
         LR    IPWLOOPC,@15                                        0321
*           DO I=ONE TO IPWLOOPC;                                  0322
         LA    I,1                                                 0322
         B     @DE00322                                            0322
@DL00322 DS    0H                                                  0323
*             IF IPWWKL(I)>=IPWWKL(I+ONE) THEN/* NOT IN ASCENDING  0323
*                                      SEQUENCE                      */
         SLR   @15,@15                                             0323
         IC    @15,IPWWKL-1(I)                                     0323
         SLR   @14,@14                                             0323
         IC    @14,IPWWKL(I)                                       0323
         CR    @15,@14                                             0323
         BL    @RF00323                                            0323
*               DO;                                                0324
*                 IPWERWKL='1'B;    /* THIS WKL IS INVALID           */
         OI    IPWERWKL,B'00100000'                                0325
*                 GO TO RMIPIPE;    /* IPS IS INVALID                */
         B     RMIPIPE                                             0326
*               END;                                               0327
*           END;                    /* COMPLETED CHECKING WKL NOS    */
@RF00323 AL    I,@CF00077                                          0328
@DE00322 CR    I,IPWLOOPC                                          0328
         BNH   @DL00322                                            0328
*           IF IPWAMWKL='0'B THEN   /* WKL HAS NOT BEEN PROCESSED    */
         TM    IPWAMWKL,B'01000000'                                0329
         BNZ   @RF00329                                            0329
*             DO;                                                  0330
*               IPWAMWKL='1'B;      /* INDICATE WORKLOAD LEVELS HAVE
*                                      BEEN PROCESSED                */
         OI    IPWAMWKL,B'01000000'                                0331
*               IPWWKLC=IPWWKLI;    /* SAVE WORKLOAD LEVELS CNT      */
         LH    @03,IPWWKLI                                         0332
         STH   @03,IPWWKLC                                         0332
*               IPWWLLO=IPWWKL(1);  /* LOWEST WKL SPEC'ED IN IPS     */
         SLR   @15,@15                                             0333
         IC    @15,IPWWKL                                          0333
         STH   @15,IPWWLLO                                         0333
*               IPWWKLS=IPWWKL(IPWWKLC)*WKLSCALE;/* HIGHEST WKL    0334
*                                      *SCALING NO           @Z40BPEM*/
         SLR   IPWWKLS,IPWWKLS                                     0334
         IC    IPWWKLS,IPWWKL-1(@03)                               0334
         SLA   IPWWKLS,8                                           0334
*               IPWWKLD=IPWWKLS*THREE/TWO;/* WKL CORRESPONDING TO  0335
*                                      SRV=0                         */
         LR    @01,IPWWKLS                                         0335
         M     @00,@CF00082                                        0335
         D     @00,@CF00118                                        0335
         STH   @01,IPWWKLD                                         0335
*               IPWWKLZ=IPWWKLS*SEVEN/FOUR;/* WKL CORRESPONDING TO 0336
*                                      NEGATIVE SERV RATE            */
         LR    @01,IPWWKLS                                         0336
         M     @00,@CF01119                                        0336
         D     @00,@CF00054                                        0336
         STH   @01,IPWWKLZ                                         0336
*/*   INITIALIZE 3RD PT. IN OBJECITIVE 0                     @Z40BPEM*/
*                                                                  0337
*               RFY                                                0337
*                 WPOD BASED(OBJ0PT3);/* RESET WPOD TO OBJ0  @Z40BPEM*/
*               WPOPWKL=IPWWKLZ;    /* WKL CORRES. TO NEG. SERVICE 0338
*                                      RATE                  @Z40BPEM*/
         L     @15,OBJ0PT3                                         0338
         STH   @01,WPOPWKL(,@15)                                   0338
*               RFY                                                0339
*                 WPOD BASED(WPODPTR);/* RESET WPOD TO CURRENT ENTRY
*                                                            @Z40BPEM*/
*             END;                                                 0340
*         END;                                                     0341
*       ELSE                        /* LESS THAN MIN NO. OF WKL    0342
*                                      LEVELS SPECIFIED              */
*         DO;                                                      0342
         B     @RC00319                                            0342
@RF00319 DS    0H                                                  0343
*           IPWERWKL='1'B;          /* THIS WKL IS INVALID           */
         OI    IPWERWKL,B'00100000'                                0343
*           GO TO RMIPIPE;          /* IPS IS INVALID                */
         B     RMIPIPE                                             0344
*         END;                                                     0345
*     END;                                                         0346
*   RETURN;                         /* RETURN TO CALLER              */
         B     @EL00006                                            0347
*RMIP008:                                                          0348
*                                                                  0348
*/*  THE PERFORMANCE OBJECTIVE NO. IN AN OBJECTIVE SPECIFICATION     */
*/*  HAS BEEN SPECIFIED.                                             */
*/*  PERFORM INITIALIZATION FOR AN OBJ DEFINITION                    */
*                                                                  0348
*   IPWSRVC=ZERO;                   /* INIT SERVICE RATE COUNT       */
RMIP008  SLR   @15,@15                                             0348
         STH   @15,IPWSRVC                                         0348
*   IPWS=ZERO;                      /* INIT INDEX TO IPWSRV & IPWORK */
         STH   @15,IPWS                                            0349
*   IF IPWOBJ>=MINOBJ&IPWOBJ<=MAXOBJ THEN/* OBJ NO IS WITHIN RANGE   */
         L     @15,IPWOBJ                                          0350
         C     @15,@CF00077                                        0350
         BL    @RF00350                                            0350
         C     @15,@CF00224                                        0350
         BH    @RF00350                                            0350
*     DO;                                                          0351
*       IPWERSRV='0'B;              /* SERVICE RATE ERROR FLAG=0     */
         NI    IPWERSRV,B'11101111'                                0352
*       RETURN;                     /* RETURN TO CALLER              */
         B     @EL00006                                            0353
*     END;                                                         0354
*   ELSE                            /* OBJ NO IS INVALID             */
*     DO;                                                          0355
@RF00350 DS    0H                                                  0356
*       IPWERSRV='1'B;              /* SERVICE RATE ERROR FLAG=1     */
         OI    IPWERSRV,B'00010000'                                0356
*       GO TO RMIPIPE;              /* IPS INVALID                   */
         B     RMIPIPE                                             0357
*     END;                                                         0358
*RMIP009:                                                          0359
*                                                                  0359
*/*  A SERVICE RATE NUMBER HAS BEEN RECOGNIZED                       */
*/*  VERIFY THAT THE COUNT OF SERVICE RATES DOES NOT EXCEED THE COUNT*/
*/*  OF WORKLOAD LEVELS                                              */
*                                                                  0359
*   IF IPWSRVC<IPWWKLC&             /* NO OF SRVC RATES      @Z30WIWP*/
*       (IPWSRV(IPWS)^=ZERO|        /* <= NO OF WKLD LEVELS  @Z30WIWP*/
*       IPWS=ZERO) THEN             /* AND ZERO NOT REACHED  @Z30WIWP*/
RMIP009  LH    @15,IPWSRVC                                         0359
         CH    @15,IPWWKLC                                         0359
         BNL   @RF00359                                            0359
         SLR   @15,@15                                             0359
         LH    @14,IPWS                                            0359
         LR    @07,@14                                             0359
         ALR   @07,@07                                             0359
         CH    @15,IPWSRV-2(@07)                                   0359
         BNE   @RT00359                                            0359
         CR    @14,@15                                             0359
         BNE   @RF00359                                            0359
@RT00359 DS    0H                                                  0360
*     DO;                           /* SAVE SERVICE RATE IN IPWSRV 0360
*                                      AND SAVE CORRESPONDING WKL  0360
*                                      NUMBER IN IPWORK              */
*       IF IPWINT1<=MAXSRV THEN     /* SERVICE RATE WITHIN RANGE     */
         L     @15,IPWINT1                                         0361
         C     @15,@CF01642                                        0361
         BH    @RF00361                                            0361
*         DO;                                                      0362
*           IPWSRVC=IPWSRVC+ONE;    /* INCR SRV CNT                  */
         LA    @14,1                                               0363
         LH    @07,IPWSRVC                                         0363
         ALR   @07,@14                                             0363
         STH   @07,IPWSRVC                                         0363
*           IPWS=IPWS+ONE;          /* INCR INDEX                    */
         AH    @14,IPWS                                            0364
         STH   @14,IPWS                                            0364
*           IPWSRV(IPWS)=IPWINT1;                                  0365
         ALR   @14,@14                                             0365
         STH   @15,IPWSRV-2(@14)                                   0365
*           IPWORK(IPWS)=IPWWKL(IPWSRVC);                          0366
         SLR   @06,@06                                             0366
         IC    @06,IPWWKL-1(@07)                                   0366
         STH   @06,IPWORK-2(@14)                                   0366
*         END;                                                     0367
*       ELSE                        /* SERVICE RATE NO. IS INVALID   */
*         DO;                                                      0368
         B     @RC00361                                            0368
@RF00361 DS    0H                                                  0369
*           IPWERSRV='1'B;          /* SET SRV ERROR FLAG            */
         OI    IPWERSRV,B'00010000'                                0369
*           GO TO RMIPIPE;          /* IPS INVALID                   */
         B     RMIPIPE                                             0370
*         END;                                                     0371
*     END;                                                         0372
*   RETURN;                         /* RETURN TO CALLER              */
         B     @EL00006                                            0373
*RMIP010:                                                          0374
*                                                                  0374
*/*  A SERVICE RATE SPECIFIED AS AN ASTERISK (*) HAS BEEN RECOGNIZED */
*                                                                  0374
*   IPWSRVC=IPWSRVC+ONE;            /* INCREMENT SERVICE RATES COUNT */
RMIP010  LH    @01,IPWSRVC                                         0374
         LA    @01,1(,@01)                                         0374
         STH   @01,IPWSRVC                                         0374
*   RETURN;                         /* RETURN TO CALLER              */
         B     @EL00006                                            0375
*RMIP011:                                                          0376
*                                                                  0376
*/*  COMPLETED SCANNING A PERFORMANCE OBJECTIVE SPECIFICATION        */
*/*  VERIFY THAT THE SERVICE RATES SPECIFIED ARE VALID AND THAT THEY */
*/*  ARE NOT IN ASCENDING SEQUENCE.  BUILD A PERF OBJECTIVE TABLE    */
*/*  ENTRY, UPDATE PTR TO WPOD TABLE, AND INITIALIZE THE PERF OBJ    */
*/*  VECTOR TABLE ENTRY                                              */
*                                                                  0376
*   IF IPWERSRV='0'B THEN           /* NO ERROR FOUND IN THIS OBJ  0376
*                                      SPECIFICATION                 */
RMIP011  TM    IPWERSRV,B'00010000'                                0376
         BNZ   @RF00376                                            0376
*     DO;                                                          0377
*                                                                  0377
*/* VERIFY THAT THE SERVICE RATES ARE NOT IN ASCENDING SEQUENCE      */
*                                                                  0378
*       IPWLOOPC=IPWS-ONE;                                         0378
         LH    IPWLOOPC,IPWS                                       0378
         BCTR  IPWLOOPC,0                                          0378
*       DO I=ONE TO IPWLOOPC;                                      0379
         LA    I,1                                                 0379
         B     @DE00379                                            0379
@DL00379 DS    0H                                                  0380
*         IF IPWSRV(I)<IPWSRV(I+ONE) THEN/* SERVICE RATES ARE NOT IN
*                                      SEQUENCE                      */
         LR    @15,I                                               0380
         ALR   @15,@15                                             0380
         LH    @14,IPWSRV-2(@15)                                   0380
         CH    @14,IPWSRV(@15)                                     0380
         BL    @RT00380                                            0380
*           GO TO RMIPIPE;          /* IPS INVALID                   */
*       END;                                                       0382
         AL    I,@CF00077                                          0382
@DE00379 CR    I,IPWLOOPC                                          0382
         BNH   @DL00379                                            0382
*       IF WPOVTENT(IPWOBJ)=ZERO THEN/* THIS OBJ HAS NOT BEEN SPEC   */
         L     @15,IPWOBJ                                          0383
         ALR   @15,@15                                             0383
         L     @01,WPOVPTR                                         0383
         BCTR  @01,0                                               0383
         BCTR  @01,0                                               0383
         LH    @15,WPOVTENT(@15,@01)                               0383
         LTR   @15,@15                                             0383
         BNZ   @RF00383                                            0383
*         DO;                                                      0384
*                                                                  0384
*/*  IF THE SIZE OF THE CURRENT PERFORMANCE OBJECTIVE  DESCRIPTOR    */
*/*  TABLE IS NOT SUFFICIENT FOR THE MAXIMUM NUMBER OF PERFORMANCE   */
*/*  OBJECTIVE DESCRIPTORS, INVOKE RMIPCKTS ROUTINE TO EXPAND THE    */
*/*  PERFORMANCE OBJECTIVE DESCRIPTOR TABLE IF NECESSARY.            */
*                                                                  0385
*           IF WMSTPODS^=MAXPODTS THEN/* SIZE OF WPOD TABLE IS NOT 0385
*                                      MAX SIZE                      */
         L     @15,WMSTPTR                                         0385
         CLC   WMSTPODS(4,@15),MAXPODTS                            0385
         BE    @RF00385                                            0385
*             DO;                                                  0386
*               IPWNPODS=MAX(MAXSRVE,IPWS+FOUR)*LENGTH(WPOS);/* MAX
*                                      SIZE OF NEXT WPOD ENTRY       */
         LA    @14,4                                               0387
         AH    @14,IPWS                                            0387
         LA    @07,35                                              0387
         CR    @14,@07                                             0387
         BNL   *+6
         LR    @14,@07                                             0387
         SLA   @14,2                                               0387
         ST    @14,IPWNPODS                                        0387
*               CALL RMIPCKTS(WMSTPODT,/* PTR TO 1ST BYTE OF CURRENT
*                                      PERF OBJ DESCRIPTOR TABLE     */
*                   WMSTPODS,       /* SIZE OF CURRNET WPOD TABLE    */
*                   WPODPTR,        /* PTR TO NEXT WPOD ENTRY        */
*                   IPWNPODS,       /* MAX SIZE OF NEXT WPOD ENTRY   */
*                   MAXPODTS);      /* MAX SIZE OF WPOD TABLE        */
         LA    @14,WMSTPODT(,@15)                                  0388
         ST    @14,@AL00001                                        0388
         LA    @15,WMSTPODS(,@15)                                  0388
         ST    @15,@AL00001+4                                      0388
         LA    @15,WPODPTR                                         0388
         ST    @15,@AL00001+8                                      0388
         LA    @15,IPWNPODS                                        0388
         ST    @15,@AL00001+12                                     0388
         LA    @15,MAXPODTS                                        0388
         ST    @15,@AL00001+16                                     0388
         LA    @01,@AL00001                                        0388
         BAL   @14,RMIPCKTS                                        0388
*             END;                                                 0389
*                                                                  0389
*/*  INITIALIZE PERF OBJ VECTOR TABLE ENTRY WITH THE OFFSET OF THE   */
*/*  PERF OBJ DESCRIPITON FROM THE BEGINNING OF WPODT                */
*                                                                  0390
*           WPOVTENT(IPWOBJ)=WPODPTR-WMSTPODT;                     0390
@RF00385 L     @15,IPWOBJ                                          0390
         LR    @14,@15                                             0390
         ALR   @14,@14                                             0390
         L     @07,WPODPTR                                         0390
         L     @06,WMSTPTR                                         0390
         SL    @07,WMSTPODT(,@06)                                  0390
         L     @06,WPOVPTR                                         0390
         BCTR  @06,0                                               0390
         BCTR  @06,0                                               0390
         STH   @07,WPOVTENT(@14,@06)                               0390
*           IF IPWAMWKL='1'B THEN   /* WKL WAS SPECIFIED CORRECTLY   */
         TM    IPWAMWKL,B'01000000'                                0391
         BNO   @RF00391                                            0391
*             DO;                                                  0392
*                                                                  0392
*/*  UPDATE HIGHEST PERF OBJ NO. IF NECESSARY                        */
*                                                                  0393
*               IF IPWOBJ>IPWOBJHI THEN/* CURRENT OBJ NO>PREVIOUS  0393
*                                      HIGHEST OBJ NO.               */
         CH    @15,IPWOBJHI                                        0393
         BNH   @RF00393                                            0393
*                 IPWOBJHI=IPWOBJ;  /* UPDATE HIGHEST PERF OBJ NO.   */
         STH   @15,IPWOBJHI                                        0394
*               WLLI=WLLI+ONE;      /* UPDATE INDEX TO WLLFSRV0    0395
*                                                            @Z40BPEM*/
@RF00393 LA    @02,1                                               0395
         LH    @15,WLLI                                            0395
         ALR   @15,@02                                             0395
         STH   @15,WLLI                                            0395
*/*  BUILD PERFORMANCE OBJECTIVE DESCRIPTION                         */
*/*  THE FIRST WPOD ENTRY IS FOR THE POINT(SRV=32767,WKL=0).         */
*/*  THIS IS FOLLOWED BY A WPOD ENTRY FOR EACH POINT FOR EACH BEND   */
*/*  IN THE RATE/LEVEL LINE SPEC'ED FOR THIS PERF OBJ.  THE NEXT     */
*/*  WPOD ENTRY IS FOR THE POINT(SRV=0,WKL=X), WHERE X=(HIGHEST      */
*/*  WORKLOAD NO SPEC'ED MULTIPLIED BY WKL SCALING NO, DIVIDED BY    */
*/*  THE LOWEST WORKLOAD NO SPED'ED IN THE IPS) *3/2 OR THE WORKLOAD */
*/*  NO EXTRAPOLATED FROM THE LAST RATE/LEVEL SLOPE, WHICHEVER ONE   */
*/*  IS SMALLER                                                      */
*/*  THEN FOLLOWS THE WPOD ENTRY FOR THE PT(SRV=0) AND THE WPOD ENTRY*/
*/*  FOR THE PT(SRV=-32768)                                          */
*/*  BUILD WPOD ENTRY FOR PT(SRV=32767,WKL=0)                        */
*                                                                  0396
*               WPOP=MAXSRVPT;                                     0396
         L     @15,WPODPTR                                         0396
         MVC   WPOP(4,@15),MAXSRVPT                                0396
*               WPODPTR=WPODPTR+LENGTH(WPOS);/* INCR PTR TO WPOD   0397
*                                      ENTRY                         */
         AL    @15,@CF00054                                        0397
         ST    @15,WPODPTR                                         0397
*/*  BUILD WPOD ENTRIES FOR POINTS SPECIFIED FOR THIS PERF OBJ       */
*                                                                  0398
*               IPWSLPP=ONE;        /* INIT FIRST SLOPE              */
         LR    IPWSLPP,@02                                         0398
*               DO I=ONE TO IPWS;   /* NO OF NON-* PTS               */
         LA    @15,1                                               0399
         LR    I,@15                                               0399
         B     @DE00399                                            0399
@DL00399 DS    0H                                                  0400
*                 IF I>ONE THEN     /* NOT THE FIRST POINT           */
         C     I,@CF00077                                          0400
         BNH   @RF00400                                            0400
*                   DO;             /* NEED TO CALCUATE SLOPE        */
*                     IPWSLP=(IPWSRV(I-ONE)-IPWSRV(I))*SRVSCALE/(IPWORK
*                         (I)-IPWORK(I-ONE));/* COMPUTE RATE/ LEVEL
*                                      SLOPE AT PT I                 */
         LR    @15,I                                               0402
         ALR   @15,@15                                             0402
         LH    @14,IPWSRV-4(@15)                                   0402
         SH    @14,IPWSRV-2(@15)                                   0402
         SLA   @14,16                                              0402
         LH    @07,IPWORK-2(@15)                                   0402
         N     @07,@CF02034                                        0402
         LH    @06,IPWORK-4(@15)                                   0402
         N     @06,@CF02034                                        0402
         SLR   @07,@06                                             0402
         SRDA  @14,32                                              0402
         DR    @14,@07                                             0402
         ST    @15,IPWSLP                                          0402
*                     IF IPWSLP=IPWSLPP THEN/* SLOPE IS LEVEL, I. E.
*                                      THE PREVIOUS PT IS NOT AT A 0403
*                                      BEND, OVERLAY PREVIOUS PT     */
         CR    @15,IPWSLPP                                         0403
         BNE   @RF00403                                            0403
*                       WPODPTR=WPODPTR-LENGTH(WPOS);/* BACKUP PTR TO
*                                      WPOD                          */
         L     @15,WPODPTR                                         0404
         SL    @15,@CF00054                                        0404
         ST    @15,WPODPTR                                         0404
*                     ELSE          /* CURRENT SLOPE IS DIFFERENT  0405
*                                      FROM PREVIOUS SLOPE           */
*                       IPWSLPP=IPWSLP;/* SAVE CURRENT SLOPE         */
         B     @RC00403                                            0405
@RF00403 L     IPWSLPP,IPWSLP                                      0405
*                   END;                                           0406
@RC00403 DS    0H                                                  0407
*                 WPOPSRV=IPWSRV(I);                               0407
@RF00400 L     @15,WPODPTR                                         0407
         LR    @14,I                                               0407
         ALR   @14,@14                                             0407
         LH    @07,IPWSRV-2(@14)                                   0407
         STH   @07,WPOPSRV(,@15)                                   0407
*                 WPOPWKL=IPWORK(I)*WKLSCALE;/*              @Z40BPEM*/
         LH    @14,IPWORK-2(@14)                                   0408
         N     @14,@CF02034                                        0408
         SLA   @14,8                                               0408
         STH   @14,WPOPWKL(,@15)                                   0408
*                 IF(I=IPWS&IPWSRV(I)=ZERO)/* LAST NON '*' VALUE     */
*                   THEN            /* SAVE THIS WKL VALUE           */
         CH    I,IPWS                                              0409
         BNE   @RF00409                                            0409
         LTR   @07,@07                                             0409
         BNZ   @RF00409                                            0409
*                   WLLFSRV0(WLLI)=WPOPWKL;/* IF THE SRV RATE IS ZERO
*                                                            @Z40BPEM*/
         LH    @15,WLLI                                            0410
         ALR   @15,@15                                             0410
         STH   @14,WLLFSRV0-2(@15)                                 0410
*                 WPODPTR=WPODPTR+LENGTH(WPOS);/* INCR PTR TO WPOD 0411
*                                      ENTRY                         */
@RF00409 LA    @15,4                                               0411
         AL    @15,WPODPTR                                         0411
         ST    @15,WPODPTR                                         0411
*               END;                                               0412
         AL    I,@CF00077                                          0412
@DE00399 CH    I,IPWS                                              0412
         BNH   @DL00399                                            0412
*               IPWSLPP=(IPWSLPP+SRVROUND)/SRVSCALE;/* SLOPE         */
         LR    @00,IPWSLPP                                         0413
         AL    @00,@CF01271                                        0413
         SRDA  @00,32                                              0413
         D     @00,@CF01269                                        0413
         LR    IPWSLPP,@01                                         0413
*/*  IF THE LAST SERVICE RATE SPEC'ED IS AN '*', GET THE WORKLOAD    */
*/*  LEVEL CORRESPONDING TO THE '*'.  IF ONLY ONE SERVICE RATE NO.   */
*/*  HAS BEEN SPEC'ED, THEN '*' WILL BE REPLACED BY THE SPEC'ED      */
*/*  SERVICE RATE NO.  IF MORE THAN ONE SERVICE RATE NOS. HAVE BEEN  */
*/*  SPEC'ED, THEN '*' WILL BE REPLACED BY THE EXTRAPOLATED SERVICE  */
*/*  RATE NO.                                                        */
*                                                                  0414
*               IF(IPWORK(IPWS)^=IPWWKL(IPWSRVC))/* LAST SERVICE RATE
*                                      IS '*'                        */
*                   &(IPWSRV(IPWS)^=ZERO)/* LAST SERVICE RATE NO.^=0 */
*                 THEN              /* NEED TO CALCULATE LAST PT     */
         LH    @02,IPWS                                            0414
         LR    @15,@02                                             0414
         ALR   @15,@15                                             0414
         LH    @01,IPWSRVC                                         0414
         SLR   @14,@14                                             0414
         IC    @14,IPWWKL-1(@01)                                   0414
         LH    @00,IPWORK-2(@15)                                   0414
         N     @00,@CF02034                                        0414
         CR    @14,@00                                             0414
         BE    @RF00414                                            0414
         SLR   @07,@07                                             0414
         CH    @07,IPWSRV-2(@15)                                   0414
         BE    @RF00414                                            0414
*                 DO;                                              0415
*                   IPWS=IPWS+ONE;                                 0416
         AL    @02,@CF00077                                        0416
         STH   @02,IPWS                                            0416
*                   IPWORK(IPWS)=IPWWKL(IPWSRVC);/* GET WORKLOAD   0417
*                                      LEVEL                         */
         LR    @15,@02                                             0417
         ALR   @15,@15                                             0417
         STH   @14,IPWORK-2(@15)                                   0417
*                   IPWSRV(IPWS)=MAX(IPWSRV(IPWS-ONE)-IPWSLPP*(IPWORK(
*                       IPWS)-IPWORK(IPWS-ONE)),ZERO);/* USE 0 IF  0418
*                                      EXTRAPOLATED PT IS NEGATIVE   */
         LR    @05,@14                                             0418
         LH    @14,IPWORK-4(@15)                                   0418
         N     @14,@CF02034                                        0418
         SLR   @05,@14                                             0418
         MR    @04,IPWSLPP                                         0418
         LCR   @05,@05                                             0418
         AH    @05,IPWSRV-4(@15)                                   0418
         CR    @05,@07                                             0418
         BNL   *+6
         LR    @05,@07                                             0418
         STH   @05,IPWSRV-2(@15)                                   0418
*                   IF(IPWS>TWO)&(IPWSRV(IPWS)^=ZERO) THEN/* MORE  0419
*                                      THAN 1 PT HAS BEEN SPEC'ED AND
*                                      THE EXTRAPOLATED PT IS ON THE
*                                      SAME LINE AS THE LAST 2 POINTS*/
         C     @02,@CF00118                                        0419
         BNH   @RF00419                                            0419
         CR    @05,@07                                             0419
         BE    @RF00419                                            0419
*                     WPODPTR=WPODPTR-LENGTH(WPOS);/* BACKUP PTR TO
*                                      WPOD                          */
         L     @02,WPODPTR                                         0420
         SL    @02,@CF00054                                        0420
         ST    @02,WPODPTR                                         0420
*                   WPOPSRV=IPWSRV(IPWS);                          0421
@RF00419 L     @02,WPODPTR                                         0421
         LH    @15,IPWS                                            0421
         ALR   @15,@15                                             0421
         LH    @14,IPWSRV-2(@15)                                   0421
         STH   @14,WPOPSRV(,@02)                                   0421
*                   WPOPWKL=IPWORK(IPWS)*WKLSCALE;/*         @Z40BPEM*/
         LH    @00,IPWORK-2(@15)                                   0422
         N     @00,@CF02034                                        0422
         SLA   @00,8                                               0422
         STH   @00,WPOPWKL(,@02)                                   0422
*                   WLLFSRV0(WLLI)=WPOPWKL;/* SAVE WKL IN CASE SRV 0423
*                                      RATE IS ZERO          @Z40BPEM*/
         LH    @15,WLLI                                            0423
         ALR   @15,@15                                             0423
         STH   @00,WLLFSRV0-2(@15)                                 0423
*                   WPODPTR=WPODPTR+LENGTH(WPOS);/* INCR PTR TO WPOD
*                                      ENTRY                         */
         AL    @02,@CF00054                                        0424
         ST    @02,WPODPTR                                         0424
*                 END;                                             0425
*                                                                  0425
*/*  IF THE LAST SERVICE RATE SPECIFIED IS NON-ZERO, BUILD WPOD ENTRY*/
*/*  FOR THE PT(SRV=0,WKL=X)                                         */
*                                                                  0426
*               IF IPWSRV(IPWS)^=ZERO THEN/* LAST SERVICE RATE^=0    */
@RF00414 SLR   @02,@02                                             0426
         LH    @15,IPWS                                            0426
         LR    @14,@15                                             0426
         ALR   @14,@14                                             0426
         CH    @02,IPWSRV-2(@14)                                   0426
         BE    @RF00426                                            0426
*                 DO;                                              0427
*                   IF IPWS=ONE     /* ONLY 1 SERVICE RATE    SPEC'ED*/
*                       |IPWSLPP=ZERO/* SLOPE =0                     */
*                     THEN          /* USE PRE-DETERMINED POINT      */
         C     @15,@CF00077                                        0428
         BE    @RT00428                                            0428
         CR    IPWSLPP,@02                                         0428
         BNE   @RF00428                                            0428
@RT00428 DS    0H                                                  0429
*                     IPWWKLE=IPWWKLD;/* USE HIGHEST WKL*SCALING NO
*                                      *3/2                  @Z40BPEM*/
         LH    IPWWKLE,IPWWKLD                                     0429
         N     IPWWKLE,@CF02034                                    0429
*                   ELSE            /* SLOPE AT LAST PT^=0           */
*                     DO;           /* COMPUTE WKL NO. AT WHICH LAST
*                                      SLOPE INTERSECTS SRV=0        */
         B     @RC00428                                            0430
@RF00428 DS    0H                                                  0431
*                       IPWWKLE=(IPWORK(IPWS)+IPWSRV(IPWS)/IPWSLPP)*
*                           WKLSCALE;/*                      @Z40BPEM*/
         LH    @15,IPWS                                            0431
         ALR   @15,@15                                             0431
         LH    @04,IPWSRV-2(@15)                                   0431
         SRDA  @04,32                                              0431
         DR    @04,IPWSLPP                                         0431
         LH    IPWWKLE,IPWORK-2(@15)                               0431
         N     IPWWKLE,@CF02034                                    0431
         ALR   @05,IPWWKLE                                         0431
         SLA   @05,8                                               0431
         LR    IPWWKLE,@05                                         0431
*                       IF IPWWKLD<IPWWKLE THEN/* DUMMY            0432
*                                      PT<EXTRAPOLATED PT            */
         LH    @03,IPWWKLD                                         0432
         N     @03,@CF02034                                        0432
         CR    @03,IPWWKLE                                         0432
         BNL   @RF00432                                            0432
*                         IPWWKLE=IPWWKLD;/* USE DUMMY PT            */
         LR    IPWWKLE,@03                                         0433
*                     END;                                         0434
@RF00432 DS    0H                                                  0435
*                   WPOPSRV=ZERO;                                  0435
@RC00428 L     @03,WPODPTR                                         0435
         SLR   @00,@00                                             0435
         STH   @00,WPOPSRV(,@03)                                   0435
*                   WPOPWKL=IPWWKLE;                               0436
         STH   IPWWKLE,WPOPWKL(,@03)                               0436
*                   WLLFSRV0(WLLI)=WPOPWKL;/* SAVE EXTRAP. PT CORRES
*                                      TO SRV 0              @Z40BPEM*/
         LH    @02,WLLI                                            0437
         ALR   @02,@02                                             0437
         L     @15,WPODPTR                                         0437
         LH    @15,WPOPWKL(,@15)                                   0437
         N     @15,@CF02034                                        0437
         STH   @15,WLLFSRV0-2(@02)                                 0437
*                   WPODPTR=WPODPTR+LENGTH(WPOS);/* INCR PTR TO WPOD
*                                      ENTRY                         */
         AL    @03,@CF00054                                        0438
         ST    @03,WPODPTR                                         0438
*                 END;                                             0439
*                                                                  0439
*/*  BUILD WPOD ENTRY FOR PT(SRV=-32768,WKL=Y), WHERE Y=(HIGHEST     */
*/*  WORKLOAD NO SPEC'ED IN IPS*SCALING NO/LOEWEST WORKLOAD NO       */
*/*  SPEC'ED IN IPS)*7/4                                             */
*                                                                  0440
*               WPOPSRV=NEGSRV;                                    0440
@RF00426 L     @15,WPODPTR                                         0440
         LH    @14,NEGSRV                                          0440
         STH   @14,WPOPSRV(,@15)                                   0440
*               WPOPWKL=IPWWKLZ;                                   0441
         LH    @14,IPWWKLZ                                         0441
         N     @14,@CF02034                                        0441
         STH   @14,WPOPWKL(,@15)                                   0441
*               WPODPTR=WPODPTR+LENGTH(WPOS);/* INCR PTR TO WPOD   0442
*                                      ENTRY                         */
         AL    @15,@CF00054                                        0442
         ST    @15,WPODPTR                                         0442
*             END;                                                 0443
*         END;                                                     0444
*     END;                                                         0445
*   RETURN;                         /* RETURN TO CALLER              */
         B     @EL00006                                            0446
*RMIP012:                                                          0447
*                                                                  0447
*/* THE DOMAIN NUMBER HAS BEEN RECOGNIZED.                           */
*/* VERIFY DOMAIN NUMBER IS IN CORRECT RANGE.                        */
*/* IF DOMAIN NUMBER IS OUT OF RANGE, IPS IS INVALID.                */
*                                                                  0447
*   CSTMB=ZERO;                     /* RESET CNSTRS INDICATOR      0447
*                                                            @Z40BPEM*/
RMIP012  SLR   @00,@00                                             0447
         ST    @00,CSTMB                                           0447
*   DMNDEF='1'B;                    /* DMN DEFINED IN IPS    @Z40BPEM*/
         OI    DMNDEF,B'00100000'                                  0448
*   IF(IPWDMN<=MAXDMN)&(IPWDMN>=MINDMN)/* DMN IN RANGE               */
*     THEN                                                         0449
         L     @15,IPWDMN                                          0449
         C     @15,@CF01243                                        0449
         BH    @RF00449                                            0449
         C     @15,@CF00077                                        0449
         BL    @RF00449                                            0449
*     DO;                           /*                       @Z40BPEM*/
*       ERRDMN='0'B;                /* NO ERROR IN DMN       @Z40BPEM*/
         NI    ERRDMN,B'01111111'                                  0451
*       RETURN;                     /* RETURN TO CALLER      @Z40BPEM*/
         B     @EL00006                                            0452
*     END;                          /*                       @Z40BPEM*/
*   ELSE                            /* DMN # IS INVALID              */
*     DO;                           /*                       @Z40BPEM*/
@RF00449 DS    0H                                                  0455
*       ERRDMN='1'B;                /* ERROR IN DMN          @Z40BPEM*/
         OI    ERRDMN,B'10000000'                                  0455
*       GO TO RMIPIPE;              /* IPS IS INVALID        @Z40BPEM*/
         B     RMIPIPE                                             0456
*     END;                          /*                       @Z40BPEM*/
*RMIP013:                                                          0458
*                                                                  0458
*/* MINIMUM MPL CONSTRAINT VALUE IS RECOGNIZED                       */
*                                                                  0458
*   INDX=CSTMIN;                    /* SET INDEX FOR MIN OPT @Z40BPEM*/
RMIP013  LA    INDX,1                                              0458
*   CNSTRLB=ZERO;                   /* MIN OPT HAS LOWER BOUND OF  0459
*                                      ZERO                  @Z40BPEM*/
         SLR   CNSTRLB,CNSTRLB                                     0459
*   GO TO RMIP151;                  /* VALIDATE MIN OPT VALUE      0460
*                                                            @Z40BPEM*/
         B     RMIP151                                             0460
*RMIP014:                                                          0461
*                                                                  0461
*/* MAXIMUM MPL CONSTRAINT IS RECOGNIZED                             */
*                                                                  0461
*   INDX=CSTMAX;                    /* SET INDEX FOR MAX OPT @Z40BPEM*/
RMIP014  LA    INDX,2                                              0461
*   CNSTRLB=ZERO;                   /* LOWER BOUND IS 0      @Z40BPEM*/
         SLR   CNSTRLB,CNSTRLB                                     0462
*   GO TO RMIP151;                  /* VALIDATE MAX VALUE    @Z40BPEM*/
         B     RMIP151                                             0463
*RMIP015:                                                          0464
*                                                                  0464
*/* WEIGHTING FACTOR CONSTRAINT IS RECOGNIZED                        */
*                                                                  0464
*   INDX=CSTWT;                     /* SET INDEX FOR WEIGHT OPTION 0464
*                                                            @Z40BPEM*/
RMIP015  LA    INDX,3                                              0464
*   CNSTRLB=ONE;                    /* WT HAS LB=1           @Z40BPEM*/
         LA    CNSTRLB,1                                           0465
*RMIP151:                                                          0466
*                                                                  0466
*/* VERIFY CONSTRAINT VALUE IS IN CORRECT RANGE.                     */
*/* IF VALUE IS OUT OF RANGE, IPS IS INVALID.                        */
*/* OTHERWISE, SAVE THE VALUE AND SET INDICATOR THAT                 */
*/* CONSTRAINT OPTION IS CORRECT                                     */
*                                                                  0466
*   IF(IPWINT1>=CNSTRLB)&(IPWINT1<=CNSTRUB)/* 255 >= IPWINT1 IPWINT1
*                                      >= 1,0                        */
*     THEN                                                         0466
RMIP151  L     @15,IPWINT1                                         0466
         CR    @15,CNSTRLB                                         0466
         BL    @RF00466                                            0466
         C     @15,@CF01229                                        0466
         BH    @RF00466                                            0466
*     DO;                                                          0467
*       CNSTRVAL(INDX)=IPWINT1;     /* SAVE VALUE            @Z40BPEM*/
         STC   @15,CNSTRVAL-1(INDX)                                0468
*       CSTMB=CSTMB|DCSTMASK(INDX); /* SET INDICATOR VALUE IS CORRECT
*                                                            @Z40BPEM*/
         LR    @03,INDX                                            0469
         SLA   @03,2                                               0469
         L     @00,CSTMB                                           0469
         O     @00,DCSTMASK-4(@03)                                 0469
         ST    @00,CSTMB                                           0469
*       RETURN;                     /*                       @Z40BPEM*/
         B     @EL00006                                            0470
*     END;                          /*                       @Z40BPEM*/
*   ELSE                            /* IPS IS INVALID                */
*     DO;                           /*                       @Z40BPEM*/
@RF00466 DS    0H                                                  0473
*       ERRDMN='1'B;                /* ERROR IN DMN SPEC     @Z40BPEM*/
         OI    ERRDMN,B'10000000'                                  0473
*       GO TO RMIPIPE;              /* IPS IS INVALID        @Z40BPEM*/
         B     RMIPIPE                                             0474
*     END;                          /*                       @Z40BPEM*/
*RMIP030:                                                          0476
*                                                                  0476
*/*  COMPLETED PROCESSING CONSTRAINTS. IF ANY CONSTRAINT VALUE       */
*/*  IS MISSING,THE IPS IS INVALID.                                  */
*                                                                  0476
*   IF(CSTMB&DCSTMASK(CSTMIN))=ZERO|(CSTMB&DCSTMASK(CSTMAX))=ZERO|(
*       CSTMB&DCSTMASK(CSTWT))=ZERO THEN                           0476
RMIP030  SLR   @15,@15                                             0476
         L     @14,CSTMB                                           0476
         LR    @00,@14                                             0476
         N     @00,DCSTMASK                                        0476
         CLR   @00,@15                                             0476
         BE    @RT00476                                            0476
         LR    @00,@14                                             0476
         N     @00,DCSTMASK+4                                      0476
         CLR   @00,@15                                             0476
         BE    @RT00476                                            0476
         N     @14,DCSTMASK+8                                      0476
         CLR   @14,@15                                             0476
         BNE   @RF00476                                            0476
@RT00476 DS    0H                                                  0477
*     DO;                           /* ANY CNSTR VALUE IS MISSING  0477
*                                                            @Z40BPEM*/
*       CALL RMIPMSGR(ERRCSTS);     /* WRITE MSG             @Z40BPEM*/
         LA    @01,@AL00478                                        0478
         BAL   @14,RMIPMSGR                                        0478
*       IPWFIPER='1'B;              /* IPS IS INVALID        @Z40BPEM*/
         OI    IPWFIPER,B'10000000'                                0479
*     END;                          /*                       @Z40BPEM*/
*   RETURN;                                                        0481
         B     @EL00006                                            0481
*RMIP016:                                                          0482
*                                                                  0482
*/* COMPLETED PROCESSING A DOMAIN SPECIFICATION                      */
*/* BUILD ENTRY IN THE DOMAIN TABLE,EXCEPT FOR DOMAIN 1.             */
*/* IF DOMAIN 1 WAS SPECIFIED, AN ENTRY ALREADY EXISTS.              */
*/* OVERLAY DEFAULT VALUES IN DOMAIN 1 WITH SPECIFIED                */
*/* VALUES. IF THERE WAS AN ERROR IN THE DOMAIN SPECIFICATION,       */
*/* OR THIS IS A DUPLICATE SPEC, IGNORE IT                           */
*                                                                  0482
*   IF ERRDMN='0'B&(DMVTENT(IPWDMN)=ZERO)/* NO ERROR FOUND AND DMN 0482
*                                      NOT ALREADY DEFINED   @Z40BPEM*/
*     THEN                                                         0482
RMIP016  TM    ERRDMN,B'10000000'                                  0482
         BNZ   @RF00482                                            0482
         L     @15,IPWDMN                                          0482
         LR    @14,@15                                             0482
         ALR   @14,@14                                             0482
         L     @07,DMVTPTR                                         0482
         BCTR  @07,0                                               0482
         BCTR  @07,0                                               0482
         LH    @14,DMVTENT(@14,@07)                                0482
         LTR   @14,@14                                             0482
         BNZ   @RF00482                                            0482
*     DO;                                                          0483
*                                                                  0483
*/*  IF DOMAIN 1 WAS SPECIFIED, OVERLAY VALUES IN DMN 1 ENTRY        */
*                                                                  0484
*       IF IPWDMN=ONE               /* DMN 1 WAS SPEC.       @Z40BPEM*/
*         THEN                                                     0484
         LA    @14,1                                               0484
         CR    @15,@14                                             0484
         BNE   @RF00484                                            0484
*         DO;                                                      0485
*           RFY                                                    0486
*             DMDT BASED(DMN1PTR);                                 0486
*           DO CNSTRI=ONE TO MAXCSTC;/* LOOP THRU ALL POSSIBLE     0487
*                                      CONSTRAINTS           @Z40BPEM*/
         LR    CNSTRI,@14                                          0487
@DL00487 DS    0H                                                  0488
*             IF(CSTMB&DCSTMASK(CNSTRI))^=ZERO/* OPT IS SPEC.        */
*               THEN                                               0488
         LR    @03,CNSTRI                                          0488
         SLA   @03,2                                               0488
         L     @00,CSTMB                                           0488
         N     @00,DCSTMASK-4(@03)                                 0488
         LTR   @00,@00                                             0488
         BZ    @RF00488                                            0488
*               CNSTRLST(CNSTRI)=CNSTRVAL(CNSTRI);/* PUT VALUE IN  0489
*                                      DOMAIN TABLE          @Z40BPEM*/
         SLR   @03,@03                                             0489
         IC    @03,CNSTRVAL-1(CNSTRI)                              0489
         L     @15,DMN1PTR                                         0489
         STC   @03,CNSTRLST-1(CNSTRI,@15)                          0489
*           END;                    /*                       @Z40BPEM*/
@RF00488 AL    CNSTRI,@CF00077                                     0490
         C     CNSTRI,@CF00082                                     0490
         BNH   @DL00487                                            0490
*           DMDTMPLT=CNSTRLST(CSTMIN);/* SET MPL TARGET TO SAME VALUE
*                                      AS MIN                @Z40BPEM*/
         L     @15,DMN1PTR                                         0491
         SLR   @14,@14                                             0491
         IC    @14,CNSTRLST(,@15)                                  0491
         STH   @14,DMDTMPLT(,@15)                                  0491
*           IF CNSTRLST(ONE)>CNSTRLST(TWO)/* MIN > MAX               */
*             THEN                                                 0492
         CLC   CNSTRLST(1,@15),CNSTRLST+1(@15)                     0492
         BH    @RT00492                                            0492
*             GO TO RMIPIPE;        /* SET IPS INVALID       @Z40BPEM*/
*           RFY                                                    0494
*             DMDT BASED(DMDTPTR);  /*                       @Z40BPEM*/
*           DMVTENT(IPWDMN)=LENGTH(DMDT);/* PUT DISP FOR DMN 1 INTO
*                                      VECTOR TABLE          @Z40BPEM*/
         L     @15,IPWDMN                                          0495
         ALR   @15,@15                                             0495
         LA    @14,20                                              0495
         L     @07,DMVTPTR                                         0495
         BCTR  @07,0                                               0495
         BCTR  @07,0                                               0495
         STH   @14,DMVTENT(@15,@07)                                0495
*         END;                      /*                       @Z40BPEM*/
*       ELSE                        /* DMN # OTHER THAN 1 WAS      0497
*                                      SPECIFIED                     */
*         DO;                                                      0497
*                                                                  0497
         B     @RC00484                                            0497
@RF00484 DS    0H                                                  0498
*/*  IF THE SIZE OF THE CURRENT DOMAIN DESCRIPTION TABLE IS NOT      */
*/*  SUFFICIENT FOR THE MAXIMUM NUMBER OF DOMAIN ENTRIES, INVOKE     */
*/*  RMIPCKTS ROUTINE TO EXPAND THE DOMAIN TABLE IF NECESSARY.       */
*                                                                  0498
*           IF WMSTDMDS^=MAXDMDTS THEN/* SIZE OF DMDT IS NOT MAX SIZE*/
         L     @15,WMSTPTR                                         0498
         CLC   WMSTDMDS(4,@15),MAXDMDTS                            0498
         BE    @RF00498                                            0498
*             DO;                   /*                       @ZA15001*/
*               CALL RMIPCKTS(WMSTDMDT,/* PTR TO FIRST BYTE OF DOMAIN
*                                      TABLE                         */
*                   WMSTDMDS,       /* SIZE OF CURRENT DMDT          */
*                   DMDTPTR,        /* PTR TO NEXT DMDT ENTRY        */
*                   MAXDMDS,        /* MAX SIZE OF NEXT ENTRY        */
*                   MAXDMDTS);      /* MAX SIZE OF DMDT      @Z40BPEM*/
         LA    @14,WMSTDMDT(,@15)                                  0500
         ST    @14,@AL00001                                        0500
         LA    @00,WMSTDMDS(,@15)                                  0500
         ST    @00,@AL00001+4                                      0500
         LA    @00,DMDTPTR                                         0500
         ST    @00,@AL00001+8                                      0500
         LA    @00,@CF01251                                        0500
         ST    @00,@AL00001+12                                     0500
         LA    @00,MAXDMDTS                                        0500
         ST    @00,@AL00001+16                                     0500
         LA    @01,@AL00001                                        0500
         BAL   @14,RMIPCKTS                                        0500
*               DMN1PTR=WMSTDMDT+LENGTH(DMDT);/* RESET PTR TO DOMAIN
*                                      ONE ENTRY             @ZA15001*/
         LA    @00,20                                              0501
         L     @15,WMSTPTR                                         0501
         AL    @00,WMSTDMDT(,@15)                                  0501
         ST    @00,DMN1PTR                                         0501
*             END;                  /*                       @ZA15001*/
*/* INITIALIZE DOMAIN TABLE ENTRY WITH OFFSET OF THE DOMAIN ENTRY    */
*/* FROM THE BEGINNING OF DMDT                                       */
*                                                                  0503
*           DMVTENT(IPWDMN)=DMDTPTR-WMSTDMDT;/*              @Z40BPEM*/
@RF00498 L     @15,IPWDMN                                          0503
         LR    @14,@15                                             0503
         ALR   @14,@14                                             0503
         L     @07,DMDTPTR                                         0503
         LR    @06,@07                                             0503
         L     @05,WMSTPTR                                         0503
         SL    @06,WMSTDMDT(,@05)                                  0503
         L     @05,DMVTPTR                                         0503
         BCTR  @05,0                                               0503
         BCTR  @05,0                                               0503
         STH   @06,DMVTENT(@14,@05)                                0503
*/* SET DEFAULT DOMAIN TABLE ENTRY. OVERLAY DEFAULTS  WITH ACTUAL    */
*/* VALUES. UPDATE PTR TO NEXT DOMAIN TABLE ENTRY.                   */
*                                                                  0504
*           DMDT=DEFDMDE;           /* SET DEFAULTS IN ENTRY @Z40BPEM*/
         MVC   DMDT(20,@07),DEFDMDE                                0504
*           DMDTNO=IPWDMN;          /* OVERLAY DMN #         @Z40BPEM*/
         STC   @15,DMDTNO(,@07)                                    0505
*           DO CNSTRI=ONE TO MAXCSTC;/* LOOP THRU ALL POSSIBLE     0506
*                                      CONSTRAINT OPTIONS    @Z40BPEM*/
         LA    CNSTRI,1                                            0506
@DL00506 DS    0H                                                  0507
*             IF(CSTMB&DCSTMASK(CNSTRI))^=ZERO/* OPTION IS SPECIFIED */
*               THEN                                               0507
         LR    @03,CNSTRI                                          0507
         SLA   @03,2                                               0507
         L     @00,CSTMB                                           0507
         N     @00,DCSTMASK-4(@03)                                 0507
         LTR   @00,@00                                             0507
         BZ    @RF00507                                            0507
*               CNSTRLST(CNSTRI)=CNSTRVAL(CNSTRI);/* PUT VALUE IN DMN
*                                      TABLE                 @Z40BPEM*/
         SLR   @03,@03                                             0508
         IC    @03,CNSTRVAL-1(CNSTRI)                              0508
         L     @15,DMDTPTR                                         0508
         STC   @03,CNSTRLST-1(CNSTRI,@15)                          0508
*           END;                    /*                       @Z40BPEM*/
@RF00507 AL    CNSTRI,@CF00077                                     0509
         C     CNSTRI,@CF00082                                     0509
         BNH   @DL00506                                            0509
*           DMDTMPLT=CNSTRLST(CSTMIN);/* SET MPL TARGET TO SAME VALUE
*                                      AS MIN                @Z40BPEM*/
         L     @15,DMDTPTR                                         0510
         SLR   @14,@14                                             0510
         IC    @14,CNSTRLST(,@15)                                  0510
         STH   @14,DMDTMPLT(,@15)                                  0510
*/* CHECK THAT CNSTRS IN CORRECT SEQUENCE                            */
*                                                                  0511
*           IF CNSTRLST(ONE)>CNSTRLST(TWO)/* IF MIN>MAX              */
*             THEN                                                 0511
         CLC   CNSTRLST(1,@15),CNSTRLST+1(@15)                     0511
         BH    @RT00511                                            0511
*             GO TO RMIPIPE;        /* SET IPS INVALID       @Z40BPEM*/
*/* INCREMENT PTR TO NEXT DMDT ENTRY                                 */
*                                                                  0513
*           DMDTPTR=DMDTPTR+LENGTH(DMDT);/*                  @Z40BPEM*/
         AL    @15,@CF01251                                        0513
         ST    @15,DMDTPTR                                         0513
*/* UPDATE TOTAL # OF DMN TABLE ENTRIES                              */
*                                                                  0514
*           DMNTOTC=DMNTOTC+ONE;    /* INC COUNT BY ONE      @Z40BPEM*/
         LH    @15,DMNTOTC                                         0514
         LA    @15,1(,@15)                                         0514
         STH   @15,DMNTOTC                                         0514
*         END;                      /*                       @Z40BPEM*/
*/* RESET HIGHEST SPEC. DMN NO.                                      */
*                                                                  0516
*       IF IPWDMN>DMNHI             /* IF CURRENT > PREV #           */
*         THEN                                                     0516
@RC00484 L     @15,IPWDMN                                          0516
         CH    @15,DMNHI                                           0516
         BNH   @RF00516                                            0516
*         DMNHI=IPWDMN;             /* RESET TO CURRENT      @Z40BPEM*/
         STH   @15,DMNHI                                           0517
*     END;                                                         0518
*   RETURN;                         /* RETURN TO CALLER      @Z40BPEM*/
         B     @EL00006                                            0519
*RMIP017:                           /*                       @Z40BPEM*/
*/*  THE PERFORMANCE GROUP NUMBER HAS BEEN RECOGNIZED                */
*/*  IF THE SIZE OF THE CURRENT PERFORMANCE GROUP DESCRIPTOR TABLE   */
*/*  IS NOT SUFFICIENT FOR THE MAXIMUM NUMBER OF PERFORMANCE GROUP   */
*/*  DESCRIPTORS, INVOKE RMIPCKTS ROUTINE TO EXPAND THE PERFORMANCE  */
*/*  GROUP DESCRIPTOR TABLE IF NECESSARY.                            */
*                                                                  0520
*   IF WMSTPGDS^=MAXPGDTS THEN      /* SIZE OF WPGD TABLE IS NOT MAX
*                                      SIZE                          */
RMIP017  L     @15,WMSTPTR                                         0520
         CLC   WMSTPGDS(4,@15),MAXPGDTS                            0520
         BE    @RF00520                                            0520
*     CALL RMIPCKTS(WMSTPGDT,       /* PTR TO 1ST BYTE OF CURRENT  0521
*                                      PERF GRP DESCRIPTOR TABLE     */
*         WMSTPGDS,                 /* SIZE OF CURRENT WPGD TABLE    */
*         WPGDPTR,                  /* PTR TO NEXT WPGD ENTRY        */
*         MAXPGDS,                  /* MAX SIZE OF NEXT WPGD ENTRY   */
*         MAXPGDTS);                /* MAX SIZE OF WPGD TABLE        */
         LA    @14,WMSTPGDT(,@15)                                  0521
         ST    @14,@AL00001                                        0521
         LA    @00,WMSTPGDS(,@15)                                  0521
         ST    @00,@AL00001+4                                      0521
         LA    @00,WPGDPTR                                         0521
         ST    @00,@AL00001+8                                      0521
         LA    @00,@CF01249                                        0521
         ST    @00,@AL00001+12                                     0521
         LA    @00,MAXPGDTS                                        0521
         ST    @00,@AL00001+16                                     0521
         LA    @01,@AL00001                                        0521
         BAL   @14,RMIPCKTS                                        0521
*/*  PERFORM INITIALIZATION FOR A PERFORMANCE GROUP -                */
*/*  INIT WPGD WITH DEFAULT VALUES                                   */
*                                                                  0522
*   WPGD=''B;                       /* CLEAR WPGD                    */
@RF00520 L     @15,WPGDPTR                                         0522
         XC    WPGD(20,@15),WPGD(@15)                              0522
*   WPGDATM=AVGISV;                 /* AVG TIME TO ABSORB ISV SRV    */
         MVC   WPGDATM(4,@15),@CF01257                             0523
*   WPGDISV=RMPTIMN;                /* BASE ISV VALUE                */
         L     @14,RMPTPTR                                         0524
         L     @14,RMPTIMN(,@14)                                   0524
         ST    @14,WPGDISV(,@15)                                   0524
*/*  RESET POINTERS AND INDICATORS FOR A PERF GRP                    */
*                                                                  0525
*   WPGPPTR=WPGDPTR+LENGTH(WPGD)-LENGTH(WPGP);/* PTR TO 1ST PERF GRP
*                                      PERIOD                        */
         LR    @14,@15                                             0525
         SL    @14,@CF02029                                        0525
         ST    @14,WPGPPTR                                         0525
*   IPWPGPC=ONE;                    /* RESET PERF GRP PERIOD CNT     */
         LA    @07,1                                               0526
         STH   @07,IPWPGPC                                         0526
*   IPWPGLCT=ONE;                   /* RESET PERF GRP LIST CNT       */
         STH   @07,IPWPGLCT                                        0527
*   IPWPGLPT=''B;                   /* CLEAR IPWPGLP                 */
         XC    IPWPGLPT(17),IPWPGLPT                               0528
*   IPWDURMB=ZERO;                  /* RESET PERF GRP PERIOD DURATION
*                                      INDICATOR                     */
         SLR   @06,@06                                             0529
         ST    @06,IPWDURMB                                        0529
*   DMNMB=ZERO;                     /* RESET PGP DMN IND     @Z40BPEM*/
         ST    @06,DMNMB                                           0530
*   IPWPGPM=ZERO;                   /* RESET PERF GRP PER IND      0531
*                                                            @Z40BPEM*/
         MVI   IPWPGPM,X'00'                                       0531
*/*  VERIFY THAT THE PERF GRP NO. IS VALID                           */
*                                                                  0532
*   IF IPWPGN>=MINPGN&IPWPGN<=MAXPGN THEN/* PGN IS WITHIN RANGE      */
         L     @05,IPWPGN                                          0532
         CR    @05,@07                                             0532
         BL    @RF00532                                            0532
         C     @05,@CF01229                                        0532
         BH    @RF00532                                            0532
*     DO;                                                          0533
*       WPGDPGN=IPWPGN;             /* SAVE PGN IN WPGD              */
         STC   @05,WPGDPGN(,@15)                                   0534
*       WPGP=DEFWPGP;               /* DEF VALUES FOR PGP    @Z40BPEM*/
         MVC   WPGP(8,@14),DEFWPGP                                 0535
*       IF WPGVTENT(IPWPGN)=ZERO THEN/* PGN HAS NOT BEEN SPECIFIED   */
         L     @04,WPGVPTR                                         0536
         ALR   @05,@05                                             0536
         LA    @15,0(@05,@04)                                      0536
         BCTR  @15,0                                               0536
         BCTR  @15,0                                               0536
         CH    @06,WPGVTENT(,@15)                                  0536
         BNE   @RF00536                                            0536
*         DO;                                                      0537
*           WPGVTENT(IPWPGN)=ONE;   /* MARK PGN SPECIFIED            */
         BCTR  @04,0                                               0538
         BCTR  @04,0                                               0538
         STH   @07,WPGVTENT(@05,@04)                               0538
*           IPWDUPG='0'B;           /* RESET DUPLICATE PGN FLAG      */
         NI    IPWDUPG,B'11110111'                                 0539
*         END;                                                     0540
*       ELSE                        /* PGN HAS BEEN SPECIFIED        */
*         IPWDUPG='1'B;             /* SET DUPLICATE PGN FLAG        */
         B     @RC00536                                            0541
@RF00536 OI    IPWDUPG,B'00001000'                                 0541
*       RETURN;                     /* RETURN TO CALLER              */
         B     @EL00006                                            0542
*     END;                                                         0543
*   ELSE                            /* PGN IS OUT OF RANGE           */
*     GO TO RMIPIPE;                /* IPS INVALID                   */
*RMIP018:                           /*                       @Z40BPEM*/
*/*  THE PERFORMANCE OBJECTIVE NUMBER IN A PG PERIOD HAS BEEN        */
*/*  RECOGNIZED                                                      */
*/*  VERIFY THAT PERF OBJECTIVE NO IS WITHIN ALLOWABLE RANGE         */
*/*  AND THAT IS HAS BEEN SPECIFIED                                  */
*                                                                  0545
*   IF IPWOBJ>=MINOBJ&IPWOBJ<=MAXOBJ&WPOVTENT(IPWOBJ)^=ZERO THEN/* 0545
*                                      OBJ NO. IS WITHIN RANGE AND 0545
*                                      THIS OBJ NO. IS DEFINED IN AN
*                                      OBJECTIVE SPECIFICATION       */
RMIP018  L     @15,IPWOBJ                                          0545
         C     @15,@CF00077                                        0545
         BL    @RF00545                                            0545
         C     @15,@CF00224                                        0545
         BH    @RF00545                                            0545
         LR    @14,@15                                             0545
         ALR   @14,@14                                             0545
         L     @07,WPOVPTR                                         0545
         BCTR  @07,0                                               0545
         BCTR  @07,0                                               0545
         LH    @14,WPOVTENT(@14,@07)                               0545
         LTR   @14,@14                                             0545
         BZ    @RF00545                                            0545
*     DO;                                                          0546
*       IF IPWPMOBJ='0'B THEN       /* OBJ HAS NOT BEEN SPECIFIED    */
         TM    IPWPMOBJ,B'10000000'                                0547
         BNZ   @RF00547                                            0547
*         DO;                                                      0548
*           IPWPMOBJ='1'B;          /* INDICATE OBJ HAS BEEN SPEC    */
         OI    IPWPMOBJ,B'10000000'                                0549
*           WPGPOBJN=IPWOBJ;        /* SAVE OBJ NO. IN WPGP          */
         L     @14,WPGPPTR                                         0550
         STC   @15,WPGPOBJN(,@14)                                  0550
*         END;                                                     0551
*       RETURN;                     /* RETURN TO CALLER              */
         B     @EL00006                                            0552
*     END;                                                         0553
*   ELSE                            /* OBJ NO. IS INVALID            */
*     GO TO RMIPIPE;                /* IPS INVALID                   */
*RMIP019:                           /*                       @Z40BPEM*/
*/*  THE DURATION NUMBER (IN K UNITS) IN A PG PERIOD HAS BEEN        */
*/*  RECOGNIZED                                                      */
*                                                                  0555
*   IPWDURVL=MAXDURK;               /* MAX DURATION NO.              */
RMIP019  L     IPWDURVL,@CF01500                                   0555
*   GO TO RMIP0201;                 /* PROCESS DURATION NO.          */
         B     RMIP0201                                            0556
*RMIP020:                           /*                       @Z40BPEM*/
*/*  THE DURATION NUMBER IN A PG PERIOD HAS BEEN RECOGNIZED          */
*                                                                  0557
*   IPWDURVL=MAXDUR;                /* MAX VALUE FOR DUR             */
RMIP020  L     IPWDURVL,@CF01647                                   0557
*RMIP0201:                          /*                       @Z40BPEM*/
*/*  VERIFY DURATION SPECIFICATION                                   */
*/*  DUPLICATE OR INVALID SPECIFICATION IS IGNORED                   */
*                                                                  0558
*   IF IPWINT1<=IPWDURVL THEN       /* DUR IS WITHIN ALLOWABLE RANGE */
RMIP0201 L     @03,IPWINT1                                         0558
         CR    @03,IPWDURVL                                        0558
         BH    @RF00558                                            0558
*     DO;                                                          0559
*       IF IPWPMDUR='0'B THEN       /* DUR HAS NOT BEEN SPEC'ED      */
         TM    IPWPMDUR,B'01000000'                                0560
         BNZ   @RF00560                                            0560
*         DO;                                                      0561
*           IPWPMDUR='1'B;          /* MARK DUR PROCESSED            */
         OI    IPWPMDUR,B'01000000'                                0562
*           IPWDURMB=IPWDURMB|PDURMASK(IPWPGPC);/* MARK DURATION IS
*                                      CORRECT                       */
         LH    @15,IPWPGPC                                         0563
         SLA   @15,2                                               0563
         L     @14,IPWDURMB                                        0563
         O     @14,PDURMASK-4(@15)                                 0563
         ST    @14,IPWDURMB                                        0563
*           IF IPWDURVL=MAXDURK THEN/* CONVERT TO UNITS              */
         C     IPWDURVL,@CF01500                                   0564
         BNE   @RF00564                                            0564
*             IPWINT1=IPWINT1*K;                                   0565
         MH    @03,@CH01629                                        0565
         ST    @03,IPWINT1                                         0565
*           CALL RMIPBPGL(WPGPDURP);/* STORE OFFSET FROM WPGL        */
@RF00564 L     @15,WPGPPTR                                         0566
         LA    @00,WPGPDURP(,@15)                                  0566
         ST    @00,@AL00001                                        0566
         LA    @01,@AL00001                                        0566
         BAL   @14,RMIPBPGL                                        0566
*         END;                                                     0567
*       RETURN;                     /* RETURN TO CALLER              */
         B     @EL00006                                            0568
*     END;                                                         0569
*   ELSE                            /* DUR NO. IS OUT OF RANGE       */
*     GO TO RMIPIPE;                /* IPS ERROR PROCESSING          */
*RMIP021:                           /*                       @Z40BPEM*/
*/*  THE INTERVAL SERVICE VALUE (IN K UNITS) IN A PG PERIOD HAS BEEN */
*/*  RECOGNIZED                                                      */
*                                                                  0571
*   IPWISVL=MAXISVK;                /* MAX VALUE FOR ISV             */
RMIP021  LA    IPWISVL,999                                         0571
*   GO TO RMIP0221;                 /* PROCESS ISV NO.               */
         B     RMIP0221                                            0572
*RMIP022:                           /*                       @Z40BPEM*/
*/*  THE INTERVAL SERVICE VALUE IN A PG PERIOD HAS BEEN RECOGNIZED   */
*                                                                  0573
*   IPWISVL=MAXISV;                 /* MAX VALUE FOR ISV             */
RMIP022  L     IPWISVL,@CF01500                                    0573
*RMIP0221:                          /*                       @Z40BPEM*/
*/*  VERIFY THAT THE INTERVAL SERVICE VALUE                          */
*/*  DUPLICATE OR INVALID SPECIFICATION IS IGNORED                   */
*                                                                  0574
*   IF IPWINT1<=IPWISVL THEN        /* ISV IS WITHIN ALLOWABLE RANGE */
RMIP0221 L     @03,IPWINT1                                         0574
         CR    @03,IPWISVL                                         0574
         BH    @RF00574                                            0574
*     DO;                                                          0575
*       IF IPWPMISV='0'B THEN       /* ISV HAS NOT BEEN PROCESSED    */
         TM    IPWPMISV,B'00100000'                                0576
         BNZ   @RF00576                                            0576
*         DO;                                                      0577
*           IPWPMISV='1'B;          /* MARK ISV PROCESSED            */
         OI    IPWPMISV,B'00100000'                                0578
*           IF IPWISVL=MAXISVK THEN /* CONVERT TO UNITS              */
         C     IPWISVL,@CF01651                                    0579
         BNE   @RF00579                                            0579
*             IPWINT1=IPWINT1*K;                                   0580
         MH    @03,@CH01629                                        0580
         ST    @03,IPWINT1                                         0580
*           IF IPWINT1>WPGDISV THEN /* GREATER THAN BASE ISV         */
@RF00579 L     @00,IPWINT1                                         0581
         L     @15,WPGDPTR                                         0581
         C     @00,WPGDISV(,@15)                                   0581
         BNH   @RF00581                                            0581
*             CALL RMIPBPGL(WPGPISVP);/* SET OFFSET FROM WPGL        */
         L     @15,WPGPPTR                                         0582
         LA    @00,WPGPISVP(,@15)                                  0582
         ST    @00,@AL00001                                        0582
         LA    @01,@AL00001                                        0582
         BAL   @14,RMIPBPGL                                        0582
*         END;                                                     0583
*       RETURN;                     /* RETURN TO CALLER              */
         B     @EL00006                                            0584
*     END;                                                         0585
*   ELSE                            /* ISV NO. IS OUT OF RANGE       */
*     GO TO RMIPIPE;                /* IPS ERROR PROCESSING          */
*RMIP023:                           /*                       @Z40BPEM*/
*/* DOMAIN NUMBER IN A PG PERIOD HAS BEEN RECOGNIZED                 */
*/* VERIFY THAT THE DOMAIN NO. IS WITHIN ALLOWABLE RANGE,            */
*/* AND THAT THE DOMAIN HAS BEEN DEFINED                             */
*                                                                  0587
*   IF IPWDMN>=MINDMN&IPWDMN<=MAXDMN/* 1 <=DMN<= 255                 */
*       &(DMVTENT(IPWDMN)^=ZERO|IPWDMN=ONE)/* AND THIS DMN IS DEFINED
*                                      OR IS 1, WHICH IS DEFINED BY
*                                      DEFAULT                       */
*     THEN                                                         0587
RMIP023  L     @15,IPWDMN                                          0587
         LA    @14,1                                               0587
         CR    @15,@14                                             0587
         BL    @RF00587                                            0587
         C     @15,@CF01243                                        0587
         BH    @RF00587                                            0587
         LR    @07,@15                                             0587
         ALR   @07,@07                                             0587
         L     @06,DMVTPTR                                         0587
         BCTR  @06,0                                               0587
         BCTR  @06,0                                               0587
         LH    @00,DMVTENT(@07,@06)                                0587
         LTR   @00,@00                                             0587
         BNZ   @RT00587                                            0587
         CR    @15,@14                                             0587
         BNE   @RF00587                                            0587
@RT00587 DS    0H                                                  0588
*     DO;                           /* SAVE DMN NO. IF IT IS VALID 0588
*                                                            @Z40BPEM*/
*       IF IPWPMDMN='0'B            /* DMN HAS NOT BEEN SPEC BEFORE
*                                      IN THIS PERIOD                */
*         THEN                                                     0589
         TM    IPWPMDMN,B'00000100'                                0589
         BNZ   @RF00589                                            0589
*         DO;                       /*                       @Z40BPEM*/
*           IPWPMDMN='1'B;          /* IND. DMN HAS BEEN SPECIFIED 0591
*                                                            @Z40BPEM*/
         OI    IPWPMDMN,B'00000100'                                0591
*           DMNMB=DMNMB|PDMNMASK(IPWPGPC);/* MARK DMN CORRECT      0592
*                                                            @Z40BPEM*/
         LH    @15,IPWPGPC                                         0592
         SLA   @15,2                                               0592
         L     @14,DMNMB                                           0592
         O     @14,PDMNMASK-4(@15)                                 0592
         ST    @14,DMNMB                                           0592
*           WPGPDMN=IPWDMN;         /* SAVE DMN NO. IN WPGP  @Z40BPEM*/
         L     @00,IPWDMN                                          0593
         L     @15,WPGPPTR                                         0593
         STC   @00,WPGPDMN(,@15)                                   0593
*           DMNDEF='1'B;            /* DMN DEFINED IN IPS    @Z40BPEM*/
         OI    DMNDEF,B'00100000'                                  0594
*         END;                      /*                       @Z40BPEM*/
*       RETURN;                     /*                       @Z40BPEM*/
         B     @EL00006                                            0596
*     END;                          /*                       @Z40BPEM*/
*   ELSE                            /* IPS IS INVALID        @Z40BPEM*/
*     GO TO RMIPIPE;                /* SET IPS INVALID       @Z40BPEM*/
*RMIP024:                           /*                       @Z40BPEM*/
*/* THE RESPONSE/THROUGHPUT BIAS IN A PG PERIOD HAS BEEN RECOGNIZED  */
*/* DUPLICATE OR INVALID SPECIFICATION IS IGNORED                    */
*                                                                  0599
*   IF IPWINT1<=MAXRTB THEN         /* RTB NO. IS WITHIN RANGE       */
RMIP024  L     @15,IPWINT1                                         0599
         LA    @14,1                                               0599
         CR    @15,@14                                             0599
         BH    @RF00599                                            0599
*     DO;                                                          0600
*       IF IPWPMRTB='0'B            /* TEST FOR DUPLICATE RESPONSE 0601
*                                      THROUGHPUT BIAS               */
*         THEN                      /* 1ST SPEC OF RTB PARM          */
         TM    IPWPMRTB,B'00010000'                                0601
         BNZ   @RF00601                                            0601
*         DO;                                                      0602
*           IPWPMRTB='1'B;          /* MARK RTB PROCESSED            */
         OI    IPWPMRTB,B'00010000'                                0603
*           IF IPWINT1=MAXRTB THEN  /* MAX RTB VALUE SPECIFIED       */
         CR    @15,@14                                             0604
         BNE   @RF00604                                            0604
*             WPGPRTB='1'B;         /* RTB = 1               @ZM43078*/
         L     @15,WPGPPTR                                         0605
         OI    WPGPRTB(@15),B'00000001'                            0605
*         END;                                                     0606
*       RETURN;                     /* RETURN TO CALLER              */
         B     @EL00006                                            0607
*     END;                                                         0608
*   ELSE                            /* RTB NO. OUT OF RANGE          */
*     GO TO RMIPIPE;                /* IPS ERROR PROCESSING          */
*RMIP025:                           /*                       @Z40BPEM*/
*/* THE UNIT CODE 'S' IN A PG PERIOD HAS BEEN RECOGNIZED             */
*                                                                  0610
*   IPWPMUNT='1'B;                  /* MARK UNIT CODE PROCESSED      */
RMIP025  OI    IPWPMUNT,B'00001000'                                0610
*   RETURN;                         /* RETURN TO CALLER              */
         B     @EL00006                                            0611
*RMIP026:                           /*                       @Z40BPEM*/
*/* THE UNIT CODE 'R' IN A PG PERIOD HAS BEEN RECOGNIZED             */
*/* DUPLICATE SPECIFICATION IS IGNORED                               */
*                                                                  0612
*   IF IPWPMUNT='0'B                /* TEST FOR DUPLICATE UNIT CODE  */
*     THEN                          /* 1ST SPEC OF UNT PARM          */
RMIP026  TM    IPWPMUNT,B'00001000'                                0612
         BNZ   @RF00612                                            0612
*     DO;                                                          0613
*       IPWPMUNT='1'B;              /* MARK UNIT CODE PROCESSED      */
         OI    IPWPMUNT,B'00001000'                                0614
*       WPGPUNT=RUNIT;              /* UNIT = REAL TIME UNITS        */
         L     @15,WPGPPTR                                         0615
         OI    WPGPUNT(@15),B'01000000'                            0615
*       WMSTREAL=ONE;               /* INDIC REAL TIME IN WMST     0616
*                                                            @ZM43084*/
         L     @15,WMSTPTR                                         0616
         MVI   WMSTREAL(@15),X'01'                                 0616
*     END;                                                         0617
*   RETURN;                         /* RETURN TO CALLER              */
         B     @EL00006                                            0618
*RMIP031:                           /*                       @Z40BPEM*/
*/* THE APG DISPATCHING PRIORITY VALUE HAS BEEN RECOGNIZED.          */
*/* VERIFY THAT THE APG VALUE IS IN THE VALID RANGE.                 */
*/* DUPLICATE SPECIFICATION IS IGNORED.                              */
*                                                                  0619
*   IF IPWINT1>=ZERO&IPWINT1<=MAXAPG/* APG IN RANGE                  */
*     THEN                                                         0619
RMIP031  L     @15,IPWINT1                                         0619
         LTR   @15,@15                                             0619
         BM    @RF00619                                            0619
         C     @15,@CF00073                                        0619
         BH    @RF00619                                            0619
*     DO;                                                          0620
*       IF IPWPMAPG='0'B            /* APG HAS NOT BEEN SPECIFIED    */
*         THEN                                                     0621
         TM    IPWPMAPG,B'00000010'                                0621
         BNZ   @RF00621                                            0621
*         DO;                                                      0622
*           IPWPMAPG='1'B;          /* INDICATE APG HAS BEEN       0623
*                                      SPECIFIED             @Z40BPEM*/
         OI    IPWPMAPG,B'00000010'                                0623
*           WPGPAPG='1'B;           /* IND APG VALUE IS IN WPGP    0624
*                                                            @Z40BPEM*/
         L     @14,WPGPPTR                                         0624
         OI    WPGPAPG(@14),B'00100000'                            0624
*           WPGPAPGV=IPWINT1;       /* SAVE VALUE IN WPGP    @Z40BPEM*/
         STC   @15,WPGPAPGV(,@14)                                  0625
*         END;                      /*                       @Z40BPEM*/
*       RETURN;                                                    0627
         B     @EL00006                                            0627
*     END;                          /*                       @Z40BPEM*/
*   ELSE                                                           0629
*     GO TO RMIPIPE;                /* IPS IS INVALID        @Z40BPEM*/
*RMIP027:                           /*                       @Z40BPEM*/
*/*  COMPLETED PROCESSING A PERFORMANCE GROUP PERIOD SPECIFICATION   */
*/*  UPDATE THE COUNT OF PERIODS FOR THIS GROUP,                     */
*/*  UPDATE THE PTR TO THE NEXT AVAILABLE PERIOD ENTRY IF NOT MORE   */
*/*  THAN THE ALLOWABLE NO. OF PERIODS HAVE BEEN SPECIFIED           */
*                                                                  0630
*   IF IPWPGPC<=MAXPGPC             /* PERIOD NO. IS VALID           */
*     THEN                          /* PERIOD SPECIFICATION IS OK    */
RMIP027  LH    @15,IPWPGPC                                         0630
         C     @15,@CF00046                                        0630
         BH    @RF00630                                            0630
*     DO;                                                          0631
*       IPWPGPC=IPWPGPC+ONE;        /* INC PG PERIOD CNT             */
         LA    @15,1(,@15)                                         0632
         STH   @15,IPWPGPC                                         0632
*       IF WPGPUNT=RUNIT            /* DURATION IS IN REAL TIME      */
*         THEN                      /* CONVERT DUR FROM SECS TO    0633
*                                      MILLISECS                     */
         L     @15,WPGPPTR                                         0633
         TM    WPGPUNT(@15),B'01000000'                            0633
         BNO   @RF00633                                            0633
*         DO;                                                      0634
*           IF IPWPGL(WPGPDURP)>MAXRDURC/* TEST IF DURATION>MAX NO 0635
*                                      ALLOWED FOR DURATION IN RELA
*                                      TIME                          */
*             THEN                  /* DUR NO. IN REAL TIME IS TOO 0635
*                                      LARGE                         */
         L     @14,@CF01655                                        0635
         SLR   @07,@07                                             0635
         IC    @07,WPGPDURP(,@15)                                  0635
         SLA   @07,2                                               0635
         C     @14,IPWPGL-4(@07)                                   0635
         BNL   @RF00635                                            0635
*             IPWPGL(WPGPDURP)=MAXRDURC;/* USE MAX DURATION TIME     */
         ST    @14,IPWPGL-4(@07)                                   0636
*           IPWPGL(WPGPDURP)=IPWPGL(WPGPDURP)*MILLISEC;/* CONVERT TO
*                                      MILLISECONDS                  */
@RF00635 L     @15,WPGPPTR                                         0637
         SLR   @14,@14                                             0637
         IC    @14,WPGPDURP(,@15)                                  0637
         SLA   @14,2                                               0637
         L     @15,IPWPGL-4(@14)                                   0637
         SLA   @15,10                                              0637
         ST    @15,IPWPGL-4(@14)                                   0637
*         END;                                                     0638
*       IF IPWPMOBJ='0'B            /* OBJ NOT SPECIFIED             */
*         THEN                                                     0639
@RF00633 TM    IPWPMOBJ,B'10000000'                                0639
         BNZ   @RF00639                                            0639
*         DO;                       /* ERROR PROCESSING      @Z40BPEM*/
*           CALL RMIPMSGR(ERRCOBJ); /* WRITE MISSING OBJ MSG @Z40BPEM*/
         LA    @01,@AL00641                                        0641
         BAL   @14,RMIPMSGR                                        0641
*           IPWFIPER='1'B;          /* MARK IPS INVALID      @Z40BPEM*/
         OI    IPWFIPER,B'10000000'                                0642
*         END;                      /*                       @Z40BPEM*/
*       WPGPPTR=WPGPPTR+LENGTH(WPGP);/* POINT TO NEXT WPGP           */
@RF00639 LA    @00,8                                               0644
         AL    @00,WPGPPTR                                         0644
         ST    @00,WPGPPTR                                         0644
*     END;                                                         0645
*   IPWPGPM=ZERO;                   /* RESET PERF GRP PER IND      0646
*                                                            @Z40BPEM*/
@RF00630 MVI   IPWPGPM,X'00'                                       0646
*   WPGP=DEFWPGP;                   /* SET DEFAULT VALUES    @Z40BPEM*/
         L     @15,WPGPPTR                                         0647
         MVC   WPGP(8,@15),DEFWPGP                                 0647
*   RETURN;                         /* RETURN TO CALLER              */
         B     @EL00006                                            0648
*RMIP028:                           /*                       @Z40BPEM*/
*/*  COMPLETED PROCESSING A PERFORMANCE GROUP SPECIFICATION          */
*                                                                  0649
*   IPWPGPC=IPWPGPC-ONE;            /* ADJUST PG PERIOD CNT          */
RMIP028  LH    @02,IPWPGPC                                         0649
         BCTR  @02,0                                               0649
         STH   @02,IPWPGPC                                         0649
*/*  IF PERIOD DURATION FOR A PERIOD, OTHER THAN THE LAST ONE, HAS   */
*/*  NOT BEEN SPECIFIED CORRECTLY, THEN THE IPS IS INVALID           */
*                                                                  0650
*   IPWLOOPC=IPWPGPC-ONE;           /* DUR FOR LAST PERIOD IS      0650
*                                      IMMATERIAL                    */
         BCTR  @02,0                                               0650
         LR    IPWLOOPC,@02                                        0650
*   DO I=ONE TO IPWLOOPC;                                          0651
         LA    I,1                                                 0651
         B     @DE00651                                            0651
@DL00651 DS    0H                                                  0652
*     IF(IPWDURMB&PDURMASK(I))=ZERO /* DURATION IS MISSING           */
*       THEN                        /* DUR FOR PERF GRP PERIOD IS  0652
*                                      MISSING                       */
         LR    @15,I                                               0652
         SLA   @15,2                                               0652
         L     @14,IPWDURMB                                        0652
         N     @14,PDURMASK-4(@15)                                 0652
         LTR   @14,@14                                             0652
         BNZ   @RF00652                                            0652
*       DO;                                                        0653
*         CALL RMIPMSGR(ERRCDUR);   /* WRITE DUR INVALID MSG         */
         LA    @01,@AL00654                                        0654
         BAL   @14,RMIPMSGR                                        0654
*         IPWFIPER='1'B;            /* MARK IPS IS INVALID           */
         OI    IPWFIPER,B'10000000'                                0655
*         RETURN;                   /* RETURN TO CALLER              */
         B     @EL00006                                            0656
*       END;                                                       0657
*   END;                                                           0658
*                                                                  0658
@RF00652 AL    I,@CF00077                                          0658
@DE00651 CR    I,IPWLOOPC                                          0658
         BNH   @DL00651                                            0658
*/*  IF IPS IS IN ERROR OR THE PERF GRP IS A DUPLICATE, IGNORE IT.   */
*                                                                  0659
*   IF IPWFIPER='0'B&IPWDUPG='0'B   /* NOT DUPLICATE PGN SPEC        */
*     THEN                          /* PERF GROUP SPEC IS VALID      */
         TM    IPWFIPER,B'10001000'                                0659
         BNZ   @RF00659                                            0659
*     DO;                                                          0660
*                                                                  0660
*/*  FOR EACH PERF GRP PERIOD, UPDATE WPGPDURP AND WPGPISVP          */
*/*  STORE THE ISV FOR THE FIRST PERIOD IN WPGDISV.  IF ISV IS NOT   */
*/*  SPECIFIED FOR A PERIOD, USE THE BASE ISV VALUE                  */
*/*  FOR THE LAST PERIOD, SET THE LAST PERIOD INDICATOR AND SET      */
*/*  DURATION TO ZERO TO INDICATE THAT DURATION IS TO BE IGNORED.    */
*/*  BUILD WPGL ENTRIES FOLLOWING THE PERFORMANCE GROUP PERIODS.     */
*                                                                  0661
*       WPGLPTR=WPGPPTR;            /* PTR TO 1ST WPGL ENTRY         */
         L     WPGLPTR,WPGPPTR                                     0661
*       WPGPPTR=WPGDPTR+LENGTH(WPGD)-LENGTH(WPGP);/* PTR TO 1ST    0662
*                                      PERIOD                        */
         L     @02,WPGDPTR                                         0662
         SL    @02,@CF02029                                        0662
         ST    @02,WPGPPTR                                         0662
*       DO I=ONE TO IPWPGPC;        /* NO OF PERF GRP PERIODS FOR  0663
*                                      CURRENT PERF GRP              */
         LA    I,1                                                 0663
         B     @DE00663                                            0663
@DL00663 DS    0H                                                  0664
*         IF I=ONE THEN             /* 1ST PERF GRP PERIOD           */
         C     I,@CF00077                                          0664
         BNE   @RF00664                                            0664
*           DO;                                                    0665
*             WPGDISV=IPWPGL(WPGPISVP);/* STORE 1ST PERIOD ISV       */
         L     @15,WPGPPTR                                         0666
         SLR   @14,@14                                             0666
         IC    @14,WPGPISVP(,@15)                                  0666
         LR    @07,@14                                             0666
         SLA   @07,2                                               0666
         L     @00,IPWPGL-4(@07)                                   0666
         L     @07,WPGDPTR                                         0666
         ST    @00,WPGDISV(,@07)                                   0666
*             IPWPGLP(WPGPISVP)=BASEISVP;/* SAVE OFFSET OF ISV       */
         SLR   @07,@07                                             0667
         IC    @07,BASEISVP                                        0667
         STC   @07,IPWPGLP-1(@14)                                  0667
*             WPGPISVP=BASEISVP;    /* OFFSET OF WPGDISV             */
         STC   @07,WPGPISVP(,@15)                                  0668
*           END;                                                   0669
*         ELSE                      /* NOT THE 1ST PERF GRP PERIOD   */
*           CALL RMIPMPGL(WPGPISVP);/* UPDATE OFFSET OF ISV ENTRY &
*                                      BUILD WPGL                    */
         B     @RC00664                                            0670
@RF00664 L     @15,WPGPPTR                                         0670
         LA    @00,WPGPISVP(,@15)                                  0670
         ST    @00,@AL00001                                        0670
         LA    @01,@AL00001                                        0670
         BAL   @14,RMIPMPGL                                        0670
*/* IF DMN OPTION IS MISSING FOR ANY PERIOD OTHER THAN THE FIRST     */
*/* PERIOD, SET DMN NO. TO THAT OF THE PRECEEDING PERIOD. SET DMN NO */
*/* TO 1 FOR THE FIRST PERIOD.                                       */
*                                                                  0671
*         IF(DMNMB&PDMNMASK(I))=ZERO/* DMN OPT IS MISSING            */
*           THEN                                                   0671
@RC00664 LR    @15,I                                               0671
         SLA   @15,2                                               0671
         L     @14,DMNMB                                           0671
         N     @14,PDMNMASK-4(@15)                                 0671
         LTR   @14,@14                                             0671
         BNZ   @RF00671                                            0671
*           DO;                     /* SET DMN VALUES        @Z40BPEM*/
*             IF I=ONE              /* DMN MISSING IN FIRST PERIOD 0673
*                                                            @Z40BPEM*/
*               THEN                /* INC # 1ST PERIODS             */
         LA    @15,1                                               0673
         CR    I,@15                                               0673
         BNE   @RF00673                                            0673
*               PGP1DMN=PGP1DMN+1;  /* WITH DMN MISSING      @Z40BPEM*/
         AH    @15,PGP1DMN                                         0674
         STH   @15,PGP1DMN                                         0674
*             ELSE                  /* NOT FIRST PER.        @Z40BPEM*/
*               DO;                 /* SET DMN TO PREVIOUS PERIOD DMN
*                                      #                     @Z40BPEM*/
         B     @RC00673                                            0675
@RF00673 DS    0H                                                  0676
*                 WPGPPTR=WPGPPTR-LENGTH(WPGP);/* BACKUP PTR TO    0676
*                                      PREVIOUS PGP          @Z40BPEM*/
         LA    @15,8                                               0676
         L     @14,WPGPPTR                                         0676
         SLR   @14,@15                                             0676
         ST    @14,WPGPPTR                                         0676
*                 PREVPDMN=WPGPDMN; /* GET PREV. DMN #       @Z40BPEM*/
         IC    @00,WPGPDMN(,@14)                                   0677
         STC   @00,PREVPDMN                                        0677
*                 WPGPPTR=WPGPPTR+LENGTH(WPGP);/* RESET PTR TO     0678
*                                      CURRENT PERIOD        @Z40BPEM*/
         ALR   @14,@15                                             0678
         ST    @14,WPGPPTR                                         0678
*                 WPGPDMN=PREVPDMN; /* SET DMN VALUE         @Z40BPEM*/
         IC    @15,PREVPDMN                                        0679
         STC   @15,WPGPDMN(,@14)                                   0679
*               END;                /*                       @Z40BPEM*/
*           END;                    /*                       @Z40BPEM*/
@RC00673 DS    0H                                                  0682
*         IF I=IPWPGPC THEN         /* LAST PERIOD                   */
@RF00671 CH    I,IPWPGPC                                           0682
         BNE   @RF00682                                            0682
*           DO;                                                    0683
*             WPGPFIN='1'B;         /* SET LAST PERIOD INDICATOR     */
         L     @15,WPGPPTR                                         0684
         OI    WPGPFIN(@15),B'10000000'                            0684
*             WPGPDURP=ZERO;        /* SET LAST PERIOD DURATION=0    */
         MVI   WPGPDURP(@15),X'00'                                 0685
*           END;                                                   0686
*         ELSE                      /* NOT THE LAST PERF GRP PRD     */
*           CALL RMIPMPGL(WPGPDURP);/* UPDATE OFFSET OF DUR ENTRY &
*                                      BUILD WPGL                    */
         B     @RC00682                                            0687
@RF00682 L     @15,WPGPPTR                                         0687
         LA    @00,WPGPDURP(,@15)                                  0687
         ST    @00,@AL00001                                        0687
         LA    @01,@AL00001                                        0687
         BAL   @14,RMIPMPGL                                        0687
*         WPGPPTR=WPGPPTR+LENGTH(WPGP);/* POINT TO NEXT PERIOD       */
@RC00682 LA    @00,8                                               0688
         AL    @00,WPGPPTR                                         0688
         ST    @00,WPGPPTR                                         0688
*       END;                                                       0689
*                                                                  0689
         AL    I,@CF00077                                          0689
@DE00663 CH    I,IPWPGPC                                           0689
         BNH   @DL00663                                            0689
*/*  STORE THE (SIZE OF PERF GRP DESCRIPTION-1) IN WPGD              */
*                                                                  0690
*       WPGDSIZ=WPGLPTR-WPGDPTR-ONE;                               0690
*                                                                  0690
         L     @02,WPGDPTR                                         0690
         LR    @00,WPGLPTR                                         0690
         SLR   @00,@02                                             0690
         BCTR  @00,0                                               0690
         STC   @00,WPGDSIZ(,@02)                                   0690
*/*  STORE THE OFFSET OF WPGD FROM WPGDT IN PERF GRP VECTOR ENTRY    */
*                                                                  0691
*       WPGVTENT(IPWPGN)=WPGDPTR-WMSTPGDT;/* OFFSET OF PERF GRP    0691
*                                      DESCRIPTION                   */
         L     @15,IPWPGN                                          0691
         LR    @14,@15                                             0691
         ALR   @14,@14                                             0691
         L     @07,WMSTPTR                                         0691
         SL    @02,WMSTPGDT(,@07)                                  0691
         L     @07,WPGVPTR                                         0691
         BCTR  @07,0                                               0691
         BCTR  @07,0                                               0691
         STH   @02,WPGVTENT(@14,@07)                               0691
*/*  UPDATE WPGDPTR TO POINT TO NEXT AVAILABLE PERFORMANCE GROUP     */
*/*  ENTRY                                                           */
*                                                                  0692
*       WPGDPTR=WPGLPTR;                                           0692
*                                                                  0692
         ST    WPGLPTR,WPGDPTR                                     0692
*/*  SUM THE COUNT OF TOTAL PERFORMANCE GROUP PERIODS IN IPS         */
*                                                                  0693
*       IPWPGPTC=IPWPGPTC+IPWPGPC;                                 0693
*                                                                  0693
         LH    @14,IPWPGPTC                                        0693
         AH    @14,IPWPGPC                                         0693
         STH   @14,IPWPGPTC                                        0693
*/*  UPDATE THE HIGHEST PERF GRP NO. IF NECESSARY                    */
*                                                                  0694
*       IF IPWPGN>IPWPGNHI THEN     /* CURRENT PERF GRP NO> PREVIOUS
*                                      HIGHEST PERF GRP #            */
         CH    @15,IPWPGNHI                                        0694
         BNH   @RF00694                                            0694
*         IPWPGNHI=IPWPGN;                                         0695
*                                                                  0695
         STH   @15,IPWPGNHI                                        0695
*/* UPDATE COUNT OF PERFORMANCE GROUPS                       @Z40BPEM*/
*                                                                  0696
*       PGTOTALC=PGTOTALC+ONE;      /* INC TOT PERF GRP COUNT      0696
*                                                            @Z40BPEM*/
@RF00694 LH    @15,PGTOTALC                                        0696
         LA    @15,1(,@15)                                         0696
         STH   @15,PGTOTALC                                        0696
*     END;                                                         0697
*   RETURN;                         /* RETURN TO CALLER              */
         B     @EL00006                                            0698
*RMIP029:                                                          0699
*   ;                               /* IPS ERROR PROCESSING SUBRTN 0699
*                                                            @Z40BPEM*/
RMIP029  DS    0H                                                  0700
*RMIPIPE:                                                          0700
*   ;                               /* IPS ERROR PROCESSING    SUBRTN*/
RMIPIPE  DS    0H                                                  0701
*/*  ERROR IN IPS SPECIFICATION, MARK IPS INVALID                    */
*                                                                  0701
*   IPWFIPER='1'B;                                                 0701
         OI    IPWFIPER,B'10000000'                                0701
*   CALL RMIPMSGR(ERRCINP);         /* WRITE INPUT ERROR MSG         */
         LA    @01,@AL00702                                        0702
         BAL   @14,RMIPMSGR                                        0702
*   RETURN;                         /* RETURN TO CALLER              */
         B     @EL00006                                            0703
*                                                                  0704
*/********************************************************************/
*/*                                                                  */
*/*  PROCEDURE NAME: RMIPBPGL                                        */
*/*                                                                  */
*/*  FUNCTION:                                                       */
*/*  THIS ROUTINE CONSTRUCTS IN WORK AREA A 1-WORD ENTRY WHICH       */
*/*  CONTAINS THE INTERVAL SERVICE VALUE OR THE PERIOD DURATION ,    */
*/*  AND RETURNS THE INDEX OF THIS ENTRY IN THE RETURN PARAMETER.    */
*/*                                                                  */
*/********************************************************************/
*                                                                  0704
*RMIPBPGL:                                                         0704
*   PROC(IPBPGLP);                                                 0704
RMIPBPGL STM   @14,@12,12(@13)                                     0704
         MVC   @PC00007(4),0(@01)                                  0704
*   DECLARE                                                        0705
*     IPBPGLP PTR(08)               /* INDEX TO A LIST OF PERF GRP 0705
*                                      DURATION ENTRIES              */
*         ;                                                        0705
*   IF IPWPGPC<=MAXPGPC THEN        /* NOT EXCEEDING THE MAX NO OF 0706
*                                      PERF GRP PERIODS ALLOWED      */
         LH    @00,IPWPGPC                                         0706
         C     @00,@CF00046                                        0706
         BH    @RF00706                                            0706
*     DO;                                                          0707
*       IPWPGLCT=IPWPGLCT+ONE;      /* UPDATE INDEX TO WPGL          */
         LA    @00,1                                               0708
         AH    @00,IPWPGLCT                                        0708
         STH   @00,IPWPGLCT                                        0708
*       IPWPGL(IPWPGLCT)=IPWINT1;   /* SAVE ENTRY IN WORK AREA       */
         LR    @15,@00                                             0709
         SLA   @15,2                                               0709
         L     @14,IPWINT1                                         0709
         ST    @14,IPWPGL-4(@15)                                   0709
*       IPBPGLP=IPWPGLCT;           /* INDEX TO WPGL                 */
         L     @15,@PC00007                                        0710
         STC   @00,IPBPGLP(,@15)                                   0710
*     END;                                                         0711
*   END RMIPBPGL;                                                  0712
*                                                                  0712
@EL00007 DS    0H                                                  0712
@EF00007 DS    0H                                                  0712
@ER00007 LM    @14,@12,12(@13)                                     0712
         BR    @14                                                 0712
*/********************************************************************/
*/*                                                                  */
*/*  PROCEDURE NAME: RMIPMPGL                                        */
*/*                                                                  */
*/*  FUNCTION:                                                       */
*/*  THIS ROUTINE CONSTRUCTS A WPGL ENTRY IN THE PERF GRP DESCRIPTOR */
*/*  IF AN INDENTICAL ENTRY HAS NOT BEEN CONSTRUCTED.  IT UPDATES    */
*/*  THE INPUT PARAMETER FROM THE INDEX TO IPWPGL TO THE OFFSET OF   */
*/*  THE WPGL ENTRY FROM THE BEGINNING OF THE WPGD.                  */
*/*                                                                  */
*/********************************************************************/
*                                                                  0713
*RMIPMPGL:                                                         0713
*   PROC(IPMPGLP);                                                 0713
RMIPMPGL STM   @14,@02,12(@13)                                     0713
         STM   @04,@12,36(@13)                                     0713
         MVC   @PC00008(4),0(@01)                                  0713
*   DECLARE                                                        0714
*     IPMPGEND FIXED,               /* NO OF ENTRIES TO BE MATCHED   */
*     IPMPGLP PTR(08)               /* OFFSET OF PERF GROUP DURATION
*                                      ENTRY                         */
*         ;                                                        0714
*   IPMPGEND=IPMPGLP;               /* NO OF ENTRIES TO BE MATCHED   */
         L     @02,@PC00008                                        0715
         SLR   @00,@00                                             0715
         IC    @00,IPMPGLP(,@02)                                   0715
         ST    @00,IPMPGEND                                        0715
*   DO IPWPGLI=ONE TO IPMPGEND;     /* FIND AN IDENTICAL ENTRY IN  0716
*                                      IPWPGL                        */
         LA    IPWPGLI,1                                           0716
         B     @DE00716                                            0716
@DL00716 DS    0H                                                  0717
*     IF IPWPGL(IPWPGLI)=IPWPGL(IPMPGLP) THEN/* SAME DUR/ISV VALUE 0717
*                                      FOUND                         */
         LR    @15,IPWPGLI                                         0717
         SLA   @15,2                                               0717
         L     @14,@PC00008                                        0717
         SLR   @07,@07                                             0717
         IC    @07,IPMPGLP(,@14)                                   0717
         SLA   @07,2                                               0717
         L     @14,IPWPGL-4(@07)                                   0717
         C     @14,IPWPGL-4(@15)                                   0717
         BNE   @RF00717                                            0717
*       DO;                                                        0718
*         IF IPWPGLP(IPWPGLI)=ZERO  /* IDENTICAL ENTRY HAS NOT BEEN
*                                      CONSTRUCTED IN THE WPGL       */
*           THEN                    /* STORE DUR/ISV VALUE IN WPGL   */
         SLR   @15,@15                                             0719
         IC    @15,IPWPGLP-1(IPWPGLI)                              0719
         C     @15,@CF00044                                        0719
         BNE   @RF00719                                            0719
*           DO;                                                    0720
*             IPWPGLP(IPWPGLI)=WPGLPTR-WPGDPTR;/* OFFSET OF WPGL     */
         LR    @15,WPGLPTR                                         0721
         SL    @15,WPGDPTR                                         0721
         STC   @15,IPWPGLP-1(IPWPGLI)                              0721
*             WPGLISV=IPWPGL(IPMPGLP);/* BUILD WPGL ENTRY            */
         ST    @14,WPGLISV(,WPGLPTR)                               0722
*             WPGLPTR=WPGLPTR+LENGTH(WPGL);/* POINT TO NEXT WPGL   0723
*                                      ENTRY                         */
         AL    WPGLPTR,@CF00054                                    0723
*           END;                                                   0724
*         IPMPGLP=IPWPGLP(IPWPGLI); /* OFFSET OF WPGLL ENTRY         */
@RF00719 L     @15,@PC00008                                        0725
         SLR   @14,@14                                             0725
         IC    @14,IPWPGLP-1(IPWPGLI)                              0725
         STC   @14,IPMPGLP(,@15)                                   0725
*         RETURN;                   /* RETURN TO CALLER              */
@EL00008 DS    0H                                                  0726
@EF00008 DS    0H                                                  0726
@ER00008 LM    @14,@02,12(@13)                                     0726
         LM    @04,@12,36(@13)                                     0726
         BR    @14                                                 0726
*       END;                                                       0727
*   END;                                                           0728
@RF00717 AL    IPWPGLI,@CF00077                                    0728
@DE00716 C     IPWPGLI,IPMPGEND                                    0728
         BNH   @DL00716                                            0728
*   END RMIPMPGL;                                                  0729
         B     @EL00008                                            0729
*   END RMIPINIT;                                                  0730
         B     @EL00006                                            0730
*                                                                  0731
*/********************************************************************/
*/*                                                                  */
*/*  PROCEDURE NAME: RMIPMSGR                                        */
*/*                                                                  */
*/*  FUNCTION:                                                       */
*/*                                                                  */
*/*  THIS ROUTINE DETERMINES WHICH MESSAGE IS TO BE INSERTED INTO    */
*/*  THE WTL PARAMETER LIST.  IT THEN INVOKES THE MESSAGE OUTPUT     */
*/*  ROUTINE TO OUTPUT THE MESSAGE.                                  */
*/*  INPUT - A 1-BYTE CODE INDICATING WHICH MESSAGE IS TO BE OUTPUTED*/
*/*                                                                  */
*/********************************************************************/
*                                                                  0731
*RMIPMSGR:                                                         0731
*   PROC(IPMSGNUM);                                                0731
RMIPMSGR STM   @14,@12,@SA00009                                    0731
         MVC   @PC00009(4),0(@01)                                  0731
*   DCL                                                            0732
*     IPMSGNUM FIXED(8);            /* INPUT MESSAGE NUMBER          */
*   IPMSGTXA=IPMSGTXT(IPMSGNUM);    /* INSERT MSG TEXT               */
         MVI   IPMSGTXA+42,C' '                                    0733
         MVC   IPMSGTXA+43(17),IPMSGTXA+42                         0733
         L     @15,@PC00009                                        0733
         SLR   @14,@14                                             0733
         IC    @14,IPMSGNUM(,@15)                                  0733
         MH    @14,@CH01345                                        0733
         LA    @07,IPMSGTXT-42(@14)                                0733
         MVC   IPMSGTXA(42),0(@07)                                 0733
*   IF IPMSGNUM=ERRCINP THEN        /* INPUT PARM ERROR              */
         CLC   IPMSGNUM(1,@15),ERRCINP                             0734
         BNE   @RF00734                                            0734
*     DO;                                                          0735
*       IPMSGLTA(1:8)=IPMSGID(1);   /* INSERT MSG ID                 */
         MVC   IPMSGLTA(8),IPMSGID                                 0736
*       CALL RMIPTRT(IPERRCOL,TWO,ADDR(IPMSGCOL));/* CONVERT COL NO. */
         LA    @00,IPERRCOL                                        0737
         ST    @00,@AL00001                                        0737
         LA    @00,@CF00118                                        0737
         ST    @00,@AL00001+4                                      0737
         LA    @00,IPMSGCOL                                        0737
         ST    @00,@AFTEMPS+4                                      0737
         LA    @00,@AFTEMPS+4                                      0737
         ST    @00,@AL00001+8                                      0737
         LA    @01,@AL00001                                        0737
         BAL   @14,RMIPTRT                                         0737
*       CALL IRARMWTR(IPMSGLTA,DAPTR);/* WRITE 1ST PART OF MSG     0738
*                                                            @Z40BPEM*/
         LA    @00,IPMSGLTA                                        0738
         ST    @00,@AL00001                                        0738
         L     @00,@PC00001+8                                      0738
         LR    @15,@00                                             0738
         ST    @15,@AL00001+4                                      0738
         L     @15,@CV01277                                        0738
         LA    @01,@AL00001                                        0738
         BALR  @14,@15                                             0738
*       CALL IRARMWTR(IPMSGIPA,DAPTR);/* WRITE 2ND PART OF MSG     0739
*                                                            @Z40BPEM*/
         LA    @00,IPMSGIPA                                        0739
         ST    @00,@AL00001                                        0739
         L     @00,@PC00001+8                                      0739
         LR    @15,@00                                             0739
         ST    @15,@AL00001+4                                      0739
         L     @15,@CV01277                                        0739
         LA    @01,@AL00001                                        0739
         BALR  @14,@15                                             0739
*     END;                                                         0740
*   ELSE                            /* NOT PARM ERROR                */
*     DO;                                                          0741
         B     @RC00734                                            0741
@RF00734 DS    0H                                                  0742
*       IPMSGLTA(1:8)=IPMSGID(2);   /* INSERT MSG ID                 */
         MVC   IPMSGLTA(8),IPMSGID+8                               0742
*       IF IPMSGNUM=ERRCRPG THEN    /* REQ PERF GRP MSG              */
         L     @15,@PC00009                                        0743
         CLC   IPMSGNUM(1,@15),ERRCRPG                             0743
         BNE   @RF00743                                            0743
*         CALL RMIPTRT(IPWPGN,THREE,ADDR(IPMSGRPG));/* CONVERT &   0744
*                                      STORE REQ PERF GRP NO         */
         LA    @00,IPWPGN                                          0744
         ST    @00,@AL00001                                        0744
         LA    @00,@CF00082                                        0744
         ST    @00,@AL00001+4                                      0744
         LA    @00,IPMSGRPG                                        0744
         ST    @00,@AFTEMPS+4                                      0744
         LA    @00,@AFTEMPS+4                                      0744
         ST    @00,@AL00001+8                                      0744
         LA    @01,@AL00001                                        0744
         BAL   @14,RMIPTRT                                         0744
*       IF IPMSGNUM=ERRCDUR THEN    /* PERF GRP DURATION MSG         */
@RF00743 L     @15,@PC00009                                        0745
         CLC   IPMSGNUM(1,@15),ERRCDUR                             0745
         BNE   @RF00745                                            0745
*         CALL RMIPTRT(IPWPGN,THREE,ADDR(IPMSGDPG));/* CONVERT &   0746
*                                      STORE PERF GRP NO             */
         LA    @00,IPWPGN                                          0746
         ST    @00,@AL00001                                        0746
         LA    @00,@CF00082                                        0746
         ST    @00,@AL00001+4                                      0746
         LA    @00,IPMSGDPG                                        0746
         ST    @00,@AFTEMPS+4                                      0746
         LA    @00,@AFTEMPS+4                                      0746
         ST    @00,@AL00001+8                                      0746
         LA    @01,@AL00001                                        0746
         BAL   @14,RMIPTRT                                         0746
*       IF IPMSGNUM=ERRCOBJ THEN    /* PERF GRP OBJ MSG              */
@RF00745 L     @15,@PC00009                                        0747
         CLC   IPMSGNUM(1,@15),ERRCOBJ                             0747
         BNE   @RF00747                                            0747
*         CALL RMIPTRT(IPWPGN,THREE,ADDR(IPMSGOPG));/* CONVERT AND 0748
*                                      STORE PERF GRP NO     @Z40BPEM*/
         LA    @00,IPWPGN                                          0748
         ST    @00,@AL00001                                        0748
         LA    @00,@CF00082                                        0748
         ST    @00,@AL00001+4                                      0748
         LA    @00,IPMSGOPG                                        0748
         ST    @00,@AFTEMPS+4                                      0748
         LA    @00,@AFTEMPS+4                                      0748
         ST    @00,@AL00001+8                                      0748
         LA    @01,@AL00001                                        0748
         BAL   @14,RMIPTRT                                         0748
*       IF IPMSGNUM=ERRCSTS THEN    /* DOMAIN CNSTRS MSG     @Z40BPEM*/
@RF00747 L     @15,@PC00009                                        0749
         CLC   IPMSGNUM(1,@15),ERRCSTS                             0749
         BNE   @RF00749                                            0749
*         CALL RMIPTRT(IPWDMN,THREE,ADDR(IPMSGCST));/* CONVERT AND 0750
*                                      STORE DOMAIN NO       @Z40BPEM*/
         LA    @00,IPWDMN                                          0750
         ST    @00,@AL00001                                        0750
         LA    @00,@CF00082                                        0750
         ST    @00,@AL00001+4                                      0750
         LA    @00,IPMSGCST                                        0750
         ST    @00,@AFTEMPS+4                                      0750
         LA    @00,@AFTEMPS+4                                      0750
         ST    @00,@AL00001+8                                      0750
         LA    @01,@AL00001                                        0750
         BAL   @14,RMIPTRT                                         0750
*       CALL IRARMWTR(IPMSGLTA,DAPTR);/* WRITE MESSAGE       @Z40BPEM*/
@RF00749 LA    @00,IPMSGLTA                                        0751
         ST    @00,@AL00001                                        0751
         L     @00,@PC00001+8                                      0751
         LR    @15,@00                                             0751
         ST    @15,@AL00001+4                                      0751
         L     @15,@CV01277                                        0751
         LA    @01,@AL00001                                        0751
         BALR  @14,@15                                             0751
*     END;                                                         0752
*   END RMIPMSGR;                                                  0753
@EL00009 DS    0H                                                  0753
@EF00009 DS    0H                                                  0753
@ER00009 LM    @14,@12,@SA00009                                    0753
         BR    @14                                                 0753
*                                                                  0754
*/********************************************************************/
*/*                                                                  */
*/*  PROCEDURE NAME: RMIPTRT                                         */
*/*                                                                  */
*/*  FUNCTION:                                                       */
*/*  THIS ROUTINE CONVERTS A BINARY NO. TO DECIMAL IN EBCDIC FORM    */
*/*  AND STORES THE RESULT IN THE OUTPUT AREA                        */
*/*  INPUT - (1) NO. TO BE CONVERTED                                 */
*/*          (2) NO. OF DIGITS TO BE STORED                          */
*/*          (3) ADDR OF OUTPUT AREA                                 */
*/*                                                                  */
*/********************************************************************/
*                                                                  0754
*RMIPTRT:                                                          0754
*   PROC(IPTRTNUM,IPTRTDGT,IPTRTADR);                              0754
RMIPTRT  STM   @14,@12,@SA00010                                    0754
         MVC   @PC00010(12),0(@01)                                 0754
*   DECLARE                                                        0755
*     SHIFTHW FIXED CONSTANT(16),   /* NO. OF BITS IN HALF WORD      */
*     IPTRTNUM FIXED(31),           /* NO. TO BE CONVERTED           */
*     IPTRTDGT FIXED(31),           /* NO. OF DIGITS TO BE STORED    */
*     IPTRTADR PTR(31),             /* ADDR OF OUTPUT AREA           */
*     IPTRTRST CHAR(8) BDY(DWORD),  /* TEMP LOC FOR STORING RESULT   */
*     IPTRTIND FIXED,               /* WORK AREA                     */
*     IPTRTUNP CHAR(6) BDY(HWORD) STATIC LOCAL GENERATED,/* UNPACK 0755
*                                      AREA                          */
*     IPTRTBLK CHAR(1) BASED(EVAL(IPTRTADR+IPTRTIND)),/* LOC FOR   0755
*                                      BLANK                         */
*     IPFZONE CHAR(1) INIT('0F'X),  /* ZONE FOR NUMERICS             */
*     IPZERO CHAR(1) INIT('F0'X),   /* ZERO IN EBCDIC                */
*     IPBLANK CHAR(1) INIT('40'X)   /* BLANK                         */
*         ;                                                        0755
*   GEN DATA DEFS(IPTRTUNP);                                       0756
*   RESPECIFY                                                      0757
*    (R1,                                                          0757
*     R14,                                                         0757
*     R15) RSTD;                                                   0757
*   R1=IPTRTNUM;                    /* NO. TO BE CONVERTED           */
         L     @07,@PC00010                                        0758
         L     R1,IPTRTNUM(,@07)                                   0758
*   R14=IPTRTDGT;                   /* NO. OF DIGITS                 */
         L     @07,@PC00010+4                                      0759
         L     R14,IPTRTDGT(,@07)                                  0759
*   R14=(R14-ONE)*SHIFTHW;          /* SHIFT OUT LOW ORDER 16 BITS   */
         LR    @00,R14                                             0760
         BCTR  @00,0                                               0760
         SLA   @00,4                                               0760
         LR    R14,@00                                             0760
*   R15=IPTRTADR;                   /* ADDR OF OUTPUT AREA           */
         L     @07,@PC00010+8                                      0761
         L     R15,IPTRTADR(,@07)                                  0761
*   GEN REFS(R1,R14,IPTRTRST,IPTRTUNP,IPFZONE);                    0762
IPTRTSGN EQU   7                         SIGN POSITION
         CVD   R1,IPTRTRST               CONVERT TO DECIMAL
         OC    IPTRTRST+IPTRTSGN(R1),IPFZONE MASK OUT SIGN
         EX    R14,IPTRTUNP              UNPACK
*   RESPECIFY                                                      0763
*    (R1,                                                          0763
*     R14,                                                         0763
*     R15) UNRSTD;                                                 0763
*                                                                  0763
*/*  CONVERT LEADING ZEROES TO BLANKS                                */
*                                                                  0764
*   DO IPTRTIND=0 TO(IPTRTDGT-TWO) WHILE(IPTRTBLK=IPZERO);         0764
         SLR   IPTRTIND,IPTRTIND                                   0764
         B     @DE00764                                            0764
@DL00764 L     @03,@PC00010+8                                      0764
         L     @03,IPTRTADR(,@03)                                  0764
         LR    @15,IPTRTIND                                        0764
         ALR   @15,@03                                             0764
         CLC   IPTRTBLK(1,@15),IPZERO                              0764
         BNE   @DC00764                                            0764
*     IPTRTBLK=IPBLANK;                                            0765
         ALR   @03,IPTRTIND                                        0765
         MVC   IPTRTBLK(1,@03),IPBLANK                             0765
*   END;                                                           0766
         AL    IPTRTIND,@CF00077                                   0766
@DE00764 L     @03,@PC00010+4                                      0766
         L     @03,IPTRTDGT(,@03)                                  0766
         BCTR  @03,0                                               0766
         BCTR  @03,0                                               0766
         CR    IPTRTIND,@03                                        0766
         BNH   @DL00764                                            0766
@DC00764 DS    0H                                                  0767
*   END RMIPTRT;                                                   0767
@EL00010 DS    0H                                                  0767
@EF00010 DS    0H                                                  0767
@ER00010 LM    @14,@12,@SA00010                                    0767
         BR    @14                                                 0767
*                                                                  0768
*/********************************************************************/
*/*                                                                  */
*/*  ENTRY POINT - IRARMFRE                                          */
*/*                                                                  */
*/*  FUNCTION - IT FREES IPS TABLES IN SQA                           */
*/*                                                                  */
*/********************************************************************/
*                                                                  0768
*IRARMFRE:                                                         0768
*   ENTRY(FRIPSPTR);                                               0768
@EP00768 MVC   @PC00001+12(4),0(@01)                               0768
*   CALL RMFREIPS(FRIPSPTR);        /* FREE IPS TABLES               */
         L     @15,@PC00001+12                                     0769
         ST    @15,@AL00001                                        0769
         LA    @01,@AL00001                                        0769
         BAL   @14,RMFREIPS                                        0769
*   RETURN;                         /* RETURN TO CALLER              */
@EL00001 L     @13,4(,@13)                                         0770
@EF00001 L     @00,@SIZDATD                                        0770
         LR    @01,@08                                             0770
         FREEMAIN R,LV=(0),A=(1)
@ER00001 LM    @14,@12,12(@13)                                     0770
         BR    @14                                                 0770
*                                                                  0771
*/********************************************************************/
*/*                                                                  */
*/*  PROCEDURE NAME: RMFREIPS                                        */
*/*                                                                  */
*/*  FUNCTION:                                                       */
*/*  THE CONTROL BLOCKS WHICH CONTAIN IPS DATA ARE FREED AND STORAGE */
*/*  IS RETURNED TO SUBPOOL 245                                      */
*/*  INPUT - ADDR OF IPS TO BE FREED                                 */
*/*                                                                  */
*/********************************************************************/
*                                                                  0771
*RMFREIPS:                                                         0771
*   PROC(FRWMSTPT);                 /* FREE IPS SUBROUTINE           */
RMFREIPS STM   @14,@12,@SA00011                                    0771
         MVC   @PC00011(4),0(@01)                                  0771
*   DECLARE                                                        0772
*     MAXIPSBK FIXED CONSTANT(6),   /* NO. OF IPS CONTROL BLOCKS   0772
*                                                            @Z40BPEM*/
*     FRWMSTPT PTR(31),             /* PTR TO WMST TABLE             */
*     FRTBLCNT FIXED,               /* CNT OF IPS TABLES             */
*     SUBPN245 FIXED(32) INIT('F5000000'X),/* SUBPOOL NO=245         */
*     BLKHEADP PTR,                 /* ADDR OF CONTROL BLK HEADER    */
*/*  IPS CONTROL BLOCK HEADER                                        */
*                                                                  0772
*     1 BLKHEAD BASED(BLKHEADP),    /* CONTROL BLOCK HEADER          */
*      2 BLKPTR PTR(31),            /* ADDR OF CONTROL BLOCK         */
*      2 BLKSZE FIXED(31)           /* SIZE OF CONTROL BLOCK         */
*            ;                                                     0772
*   RESPECIFY                                                      0773
*     WMST BASED(WMSTPTR);                                         0773
*   RESPECIFY                                                      0774
*    (GPR00P,                                                      0774
*     GPR01P,                                                      0774
*     GPR14P,                                                      0774
*     GPR15P) RSTD;                                                0774
*                                                                  0774
*/* VALIDITY CHECK THE INPUT PARAMETER                               */
*                                                                  0775
*   IF FRWMSTPT=ZERO THEN           /* NO NEED TO RELEASE STORAGE    */
         L     @07,@PC00011                                        0775
         L     @07,FRWMSTPT(,@07)                                  0775
         LTR   @07,@07                                             0775
         BZ    @RT00775                                            0775
*     RETURN;                       /* RETURN TO CALLER              */
*/*  FREE THE CONTROL BLOCKS WHICH CONTAIN INSTALLATION PERFORMANCE  */
*/*  SPECIFICATION (IPS)                                             */
*                                                                  0777
*   WMSTPTR=FRWMSTPT;                                              0777
         ST    @07,WMSTPTR                                         0777
*   BLKHEADP=ADDR(WMSTPGVT);        /* ADDR OF 1ST CONTROL BLOCK   0778
*                                      HEADER                        */
         LA    BLKHEADP,WMSTPGVT(,@07)                             0778
*   DO FRTBLCNT=ONE TO MAXIPSBK;    /* NO OF CONTROL BLOCKS          */
         LA    FRTBLCNT,1                                          0779
@DL00779 DS    0H                                                  0780
*     IF BLKPTR^=ZERO THEN          /* CONTROL BLK EXISTS            */
         L     @07,BLKPTR(,BLKHEADP)                               0780
         LTR   @07,@07                                             0780
         BZ    @RF00780                                            0780
*       DO;                                                        0781
*         GPR00P=BLKSZE|SUBPN245;   /* SUBPOOL NO. & STORAGE SIZE    */
         L     GPR00P,BLKSZE(,BLKHEADP)                            0782
         O     GPR00P,SUBPN245                                     0782
*         GPR01P=BLKPTR;                                           0783
         LR    GPR01P,@07                                          0783
*         GEN(FREEMAIN R,LV=(0),A=(1));/* FREE STORAGE               */
         FREEMAIN R,LV=(0),A=(1)
*         BLKPTR=ZERO;              /* INDICATE STORAGE IS FREED     */
         SLR   @07,@07                                             0785
         ST    @07,BLKPTR(,BLKHEADP)                               0785
*       END;                                                       0786
*     BLKHEADP=BLKHEADP+LENGTH(BLKHEAD);/* POINT TO NEXT CONTROL   0787
*                                      BLOCK HEADER                  */
@RF00780 AL    BLKHEADP,@CF00046                                   0787
*   END;                                                           0788
*                                                                  0788
         AL    FRTBLCNT,@CF00077                                   0788
         C     FRTBLCNT,@CF00095                                   0788
         BNH   @DL00779                                            0788
*/* FREE WORKLOAD MANAGER SPECIFICATION TABLE                        */
*                                                                  0789
*   GPR00P=LENGTH(WMST)|SUBPN245;   /* SUBPOOL NO. & STORAGE SIZE    */
         L     GPR00P,SUBPN245                                     0789
         O     GPR00P,@CF02023                                     0789
*   GPR01P=WMSTPTR;                 /* ADDR OF WMST                  */
         L     GPR01P,WMSTPTR                                      0790
*   GEN(FREEMAIN R,LV=(0),A=(1));                                  0791
*                                                                  0791
         FREEMAIN R,LV=(0),A=(1)
*/* ZERO OUT INPUT PARAMETER AND RETURN                              */
*                                                                  0792
*   FRWMSTPT=ZERO;                  /* ZERO INPUT PARM               */
         L     @07,@PC00011                                        0792
         SLR   @06,@06                                             0792
         ST    @06,FRWMSTPT(,@07)                                  0792
*   RETURN;                         /* RETURN TO CALLER              */
@EL00011 DS    0H                                                  0793
@EF00011 DS    0H                                                  0793
@ER00011 LM    @14,@12,@SA00011                                    0793
         BR    @14                                                 0793
*   RESPECIFY                                                      0794
*    (GPR00P,                                                      0794
*     GPR01P,                                                      0794
*     GPR14P,                                                      0794
*     GPR15P) UNRSTD;                                              0794
*   END RMFREIPS;                                                  0795
         B     @EL00011                                            0795
*                                                                  0796
*/********************************************************************/
*/*                                                                  */
*/*  ENTRY POINT - IRARMOPT                                          */
*/*                                                                  */
*/*  FUNCTION - -IT PROCESSES SYSTEM RESOURCES MANAGER TUNING        */
*/*              PARAMETERS IN THE IEAOPTXX LIST.                    */
*/*                                                                  */
*/********************************************************************/
*                                                                  0796
*IRARMOPT:                                                         0796
*   ENTRY(OPCATGER,OPSTATUS,DAPTR); /* IEEMB812 DATA AREA    @Z40BPEM*/
@EP00796 MVC   @PC00001+16(8),0(@01)                               0796
         MVC   @PC00001+8(4),8(@01)                                0796
*/*  SYSTEM RESOURCES MANAGER PARAMETER LIST PROCESSING ROUTINE      */
*                                                                  0797
*   RMCTPTR=CVTOPCTP;                                              0797
         L     @01,CVTPTR                                          0797
         L     RMCTPTR,CVTOPCTP(,@01)                              0797
*   RMPTPTR=RMCTRMPT;                                              0798
*                                                                  0798
         L     @03,RMCTRMPT(,RMCTPTR)                              0798
         ST    @03,RMPTPTR                                         0798
*/*  SET MFRTPTR  TO THE ADDRESS OF THE ROUTINE WHICH PROCESSES      */
*/*  OPT LIST DATA                                                   */
*                                                                  0799
*   MFRTPTR=ADDR(RMOPINIT);                                        0799
*                                                                  0799
         LA    MFRTPTR,RMOPINIT                                    0799
*/*  INITIALIZE OPWCTGTB TO CONTAIN THE POINTERS TO RMPT ENTRIES,    */
*/*  THE POINTERS TO ARRAYS IN WHICH PARAMETERS ARE STORED           */
*/*  TEMPORARILY AND RESET THE MASKS                                 */
*                                                                  0800
*   OPWCRMPP(2)=ADDR(RMPTCPU);      /* ADDR OF RMPTCPU IN RMPT       */
         LA    @15,RMPTCPU(,@03)                                   0800
         ST    @15,OPWCRMPP+12                                     0800
*   OPWCRMPP(3)=ADDR(RMPTERV);      /* ADDR OF RMPTERV IN RMPT       */
         LA    @15,RMPTERV(,@03)                                   0801
         ST    @15,OPWCRMPP+24                                     0801
*   OPWCARYP(2)=ADDR(OPWRFCVL);     /* ADDR OF OPWRFCVL              */
         LA    @15,OPWRFCVL                                        0802
         ST    @15,OPWCARYP+12                                     0802
*   OPWCARYP(3)=ADDR(OPWRMCVL);     /* ADDR OF OPWRMCVL              */
         LA    @15,OPWRMCVL                                        0803
         ST    @15,OPWCARYP+24                                     0803
*   OPWCMASK(1)=ZERO;               /* RESET INDICATOR               */
         SLR   @15,@15                                             0804
         ST    @15,OPWCMASK                                        0804
*   OPWCMASK(2)=ZERO;               /* RESET INDICATOR               */
         ST    @15,OPWCMASK+12                                     0805
*   OPWCMASK(3)=ZERO;               /* RESET INDICATOR               */
         ST    @15,OPWCMASK+24                                     0806
*   OPCATGER=ZERO;                  /* RESET ERROR INDICATOR         */
         L     @14,@PC00001+16                                     0807
         ST    @15,OPCATGER(,@14)                                  0807
*   OPCATMK=OPMASKTB(1);            /* SET CATEGORY INDICATOR        */
         L     @14,OPMASKTB                                        0808
         ST    @14,OPCATMK                                         0808
*/* INITIALIZE RMPT WITH PRINTABLE FORM OF RFC AND ERV VALUES      0809
*                                                            @Z40BPEM*/
*                                                                  0809
*   REALERV=DEFERV;                 /* SAVE DEF PRINTABLE ERV VALUE
*                                      -'1'- IN RMPT         @Z40BPEM*/
         MVC   REALERV(6,@03),DEFERV                               0809
*   REALRFCV(RFCCPU)=DEFRFCV;       /* SAVE DEF PRINTABLE RFC      0810
*                                                            @Z40BPEM*/
         MVC   REALRFCV(3,@03),DEFRFCV                             0810
*   REALRFCV(RFCIOC)=DEFRFCV;       /* VALUES -'0.1'- IN RMPT      0811
*                                                            @Z40BPEM*/
         MVC   REALRFCV+3(3,@03),DEFRFCV                           0811
*/*  CONSTRUCT PARAMETERS FOR IRBMFANL ROUTINE                       */
*/****  START OF SPECIFICATIONS  *************************************/
*/*                                                                  */
*/* MACCOMP Y-2 SC1CQ/GAM20                                          */
*/* MACMEAN IRBANDCL MEANS COMMON SYNTAX ANALYZING DECLARATIONS      */
*/* MACSTAT Y-2 73059/Y02150                                         */
*/*                                                                  */
*/* MODULE NAME -IRBANDCL                                            */
*/*                                                                  */
*/* DESCRIPTIVE NAME - COMMON SYNTAX ANALYZING DECLARATIONS          */
*/*                                                                  */
*/* COPYRIGHT = NONE                                                 */
*/*                                                                  */
*/* STATUS = RELEASE 2, LEVEL 0                                      */
*/*                                                                  */
*/* FUNCTION = LISTS COMMON DECLARATIONS AND INTIALIZATIONS NECESSARY*/
*/*            FOR SYNTAX CHECKING                                   */
*/*                                                                  */
*/* NOTES = NONE                                                     */
*/*                                                                  */
*/* MODULE TYPE = PLS EXECUTABLE MACRO                               */
*/*                                                                  */
*/* CHANGE ACTIVITY = SEE BELOW                                      */
*/*                                                                  */
*/*  A000000-999999                                            Y02150*/
*/*                                                                  */
*/* METHOD OF INVOCATION                                             */
*/*    BAL - NONE                                                    */
*/*                                                                  */
*/*    PLS - QUESTION MARK IRBANDCL INTEGER(A) ERROR(B) ALPHA(C)     */
*/*                                    DECL(D) INITL(E)              */
*/*        WHERE                                                     */
*/*             A - PLACE OR PLACES TO STORE INTEGER VALUES          */
*/*             B - PLACE OR PLACES TO STORE ERROR VALUES            */
*/*             C - PLACE OR PLACES TO STORE ALPHA VALUES            */
*/*             D -  YES  IF DECLARATIONS ARE WANTED                 */
*/*                 OMIT DECL OTHERWISE                              */
*/*             E -  YES  IF INITIALIZATIONS ARE WANTED              */
*/*                 OMIT INITL OTHERWISE                             */
*/*                                                                  */
*/****  END OF SPECIFICATIONS  ***************************************/
*/*                                                                  */
*/*  INITIALIZE ANALYZER CONTROL BLOCKS                              */
*                                                                  0812
*   INBCBNAM='BCB ';                /* ACRONYM                       */
         MVC   INBCBNAM(4),@CC01534                                0812
*   INBCBFRS=0;                     /* NO ELEMENTS IN QUEUE          */
         ST    @15,INBCBFRS                                        0813
*   INBCBLST=ADDR(INBCBFRS);        /* INITIAL CONDITION             */
         LA    @03,INBCBFRS                                        0814
         ST    @03,INBCBLST                                        0814
*   INCURBCB=ADDR(INBCBFRS);        /* INITIAL CONDITION             */
         ST    @03,INCURBCB                                        0815
*   INTXTCUR=0;                     /* NO TEXT EXIST                 */
         ST    @15,INTXTCUR                                        0816
*   INBYTLFT=0;                     /* INITIAL CONDITION             */
         ST    @15,INBYTLFT                                        0817
*   INEXTSRC='0'B;                  /* EXTERNAL TEXT SOURCE          */
         NI    INEXTSRC,B'01111111'                                0818
*/*  INTEGER VECTOR TABLE INITIALIZATION                             */
*                                                                  0819
*   ININTPTR(1)=ADDR(IPWINT1);                                     0819
         LA    @03,IPWINT1                                         0819
         ST    @03,ININTPTR                                        0819
*   ININTPTR(2)=ADDR(IPWINT2);                                     0820
         LA    @03,IPWINT2                                         0820
         ST    @03,ININTPTR+4                                      0820
*   INENDITM='1'B;                  /* SET LAST ITEM INDICATOR       */
*   INSTRM='0'B;                    /* SET STRUCTURE INDICATOR       */
         OI    INENDITM,B'10000000'                                0822
         NI    INSTRM,B'10111111'                                  0822
*   INRECSTR=ADDR(OPSYNTAB);        /* ADDR OF OPT SYNTAX TABLE      */
         LA    @03,OPSYNTAB                                        0823
         ST    @03,INRECSTR                                        0823
*/*  GET STORAGE FOR IRBMFANL WORK AREA                              */
*                                                                  0824
*   RESPECIFY                                                      0824
*    (R0,                                                          0824
*     R1,                                                          0824
*     R14,                                                         0824
*     R15) RSTD;                                                   0824
*   INWKARSZ=SIZDATD*INRCURNO;      /* SIZE OF WORK AREA             */
         L     @07,@CA01279                                        0825
         L     INWKARSZ,SIZDATD-SIZDATD(,@07)                      0825
         MH    INWKARSZ,INRCURNO                                   0825
*   R0=INWKARSZ;                    /* SIZE OF WORK AREA             */
         LR    R0,INWKARSZ                                         0826
*   GEN( GETMAIN R,LV=(0) );        /* GET STORAGE                   */
          GETMAIN R,LV=(0)
*   INWKARPT=R1;                    /* PTR TO IRBMFANL WORK AREA     */
         ST    R1,INWKARPT                                         0828
*   RESPECIFY                                                      0829
*     R1 UNRSTD;                                                   0829
*                                                                  0829
*/*  INVOKE SYNTAX ANALYZER TO ANALYZE THE OPT LIST                  */
*                                                                  0830
*   CALL IRBMFANL(INDUMITM,INSCB,   /* SCAN CONTROL BLOCK            */
*       INWKARPT);                  /* PTR TO IRBMFANL WORK AREA     */
         LA    @03,INDUMITM                                        0830
         ST    @03,@AL00001                                        0830
         LA    @03,INSCB                                           0830
         ST    @03,@AL00001+4                                      0830
         LA    @03,INWKARPT                                        0830
         ST    @03,@AL00001+8                                      0830
         L     @15,@CV01278                                        0830
         LA    @01,@AL00001                                        0830
         BALR  @14,@15                                             0830
*   RESPECIFY                                                      0831
*     R1 RSTD;                                                     0831
*   R0=INWKARSZ;                    /* SIZE OF IRBMFANL WORK AREA    */
         LR    R0,INWKARSZ                                         0832
*   R1=INWKARPT;                    /* PTR TO WORK AREA              */
         L     R1,INWKARPT                                         0833
*   GEN( FREEMAIN R,LV=(0),A=(1) ); /* FREE WORK AREA                */
          FREEMAIN R,LV=(0),A=(1)
*   RESPECIFY                                                      0835
*    (R0,                                                          0835
*     R1,                                                          0835
*     R14,                                                         0835
*     R15) UNRSTD;                                                 0835
*                                                                  0835
*/*  IF I/O ERROR HAS OCCURRED DURING IEAOPTXX LIST PROCESSING,      */
*/*  RETURN TO CALLER                                                */
*                                                                  0836
*   IF OPIOERR='0'B THEN            /* I/O ERROR NOT FOUND           */
         L     @15,@PC00001+20                                     0836
         TM    OPIOERR(@15),B'10000000'                            0836
         BNZ   @RF00836                                            0836
*     DO;                                                          0837
*                                                                  0837
*/*  FOR EACH CATEGORY OF DATA THAT HAS NOT BEEN FLAGGED AS ERROR.   */
*/*  AND FOR EACH PARAMETER THAT HAS BEEN CORRECTLY SPECIFIED IN A   */
*/*  CATEGORY, STORE THE PARAMETER VALUE IN RESOURCE MANAGER         */
*/*  PARAMETER TABLE(RMPT)                                           */
*                                                                  0838
*       DO I=ONE TO DIM(OPWCTGTB);  /* MAX NO OF CATEGORIES          */
         LA    I,1                                                 0838
@DL00838 DS    0H                                                  0839
*         IF(OPCATGER&OPMASKTB(I))=ZERO&OPWCMASK(I)^=ZERO THEN/*   0839
*                                      CATEGORY(I) IS ERROR FREE AND
*                                      AT LEAST ONE PARAMETER HAS  0839
*                                      BEEN SPECIFIED FOR THIS     0839
*                                      CATEGORY                      */
         SLR   @03,@03                                             0839
         L     @15,@PC00001+16                                     0839
         LR    @14,I                                               0839
         SLA   @14,2                                               0839
         L     @15,OPCATGER(,@15)                                  0839
         N     @15,OPMASKTB-4(@14)                                 0839
         CLR   @15,@03                                             0839
         BNE   @RF00839                                            0839
         LR    @15,I                                               0839
         MH    @15,@CH02027                                        0839
         L     @14,OPWCMASK-12(@15)                                0839
         CLR   @14,@03                                             0839
         BE    @RF00839                                            0839
*           DO;                                                    0840
*             OPWRMPPT=OPWCRMPP(I); /* ADDR OF ARRAY IN RMPT IN WHICH
*                                      PARAMETER VALUES ARE TO BE  0841
*                                      STORED                        */
         L     @03,OPWCRMPP-12(@15)                                0841
         ST    @03,OPWRMPPT                                        0841
*             OPWARYPT=OPWCARYP(I); /* ADDR OF ARRAY IN WHICH THE  0842
*                                      PARM VALUES ARE STORED DURING
*                                      OPT LIST PROCESSING           */
         L     @03,OPWCARYP-12(@15)                                0842
         ST    @03,OPWARYPT                                        0842
*             OPCPMASK=OPWCMASK(I); /* PARM INDICATOR                */
         ST    @14,OPCPMASK                                        0843
*             OPCPARMN=OPCPARMT(I); /* NO OF PARMS IN CATG           */
         SLR   @03,@03                                             0844
         IC    @03,OPCPARMT-1(I)                                   0844
         ST    @03,OPCPARMN                                        0844
*             DO J=ONE TO OPCPARMN; /* MAX NO OF PARAMETERS FOR    0845
*                                      CATEGORY(I)                   */
         LA    J,1                                                 0845
         B     @DE00845                                            0845
@DL00845 DS    0H                                                  0846
*               IF(OPCPMASK&OPMASKTB(J))^=ZERO/* PARM HAS BEEN     0846
*                                      SPECIFIED                     */
*                 THEN              /* SAVE PARM VALUE               */
         LR    @15,J                                               0846
         SLA   @15,2                                               0846
         L     @14,OPCPMASK                                        0846
         N     @14,OPMASKTB-4(@15)                                 0846
         LTR   @14,@14                                             0846
         BZ    @RF00846                                            0846
*                 OPWRMPPT->OPWARRAY(J)=OPWARYPT->OPWARRAY(J);/*   0847
*                                      STORE PARAMETER VALUE IN RMPT
*                                      ENTRY                         */
         L     @01,OPWARYPT                                        0847
         AL    @01,@CF02036                                        0847
         L     @14,OPWARRAY(@15,@01)                               0847
         L     @01,OPWRMPPT                                        0847
         AL    @01,@CF02036                                        0847
         ST    @14,OPWARRAY(@15,@01)                               0847
*             END;                                                 0848
@RF00846 AL    J,@CF00077                                          0848
@DE00845 C     J,OPCPARMN                                          0848
         BNH   @DL00845                                            0848
*           END;                    /* COMPLETED PROCESSING        0849
*                                      CATEGORY(I)                   */
*       END;                        /* COMPLETED PROCESSING ALL    0850
*                                      CATEGORIES                    */
@RF00839 AL    I,@CF00077                                          0850
         C     I,@CF00082                                          0850
         BNH   @DL00838                                            0850
*     END;                                                         0851
*   RETURN;                         /* RETURN TO CALLER              */
         B     @EL00001                                            0852
*                                                                  0853
*/********************************************************************/
*/*                                                                  */
*/*  OPT DATA PROCESSING ROUTINES                                    */
*/*                                                                  */
*/*    PURPOSE - TO PROCESS DATA FROM THE OPT LIST                   */
*/*    LINKAGE - VIA CALL                                            */
*/*    INPUT - ADDR OF A 1-BYTE FIELD CONTAINING THE PROCESSING      */
*/*            SUBROUTINE NUMBER                                     */
*/*    OUTPUT - NONE                                                 */
*/*                                                                  */
*/********************************************************************/
*                                                                  0853
*RMOPINIT:                                                         0853
*   PROC(OPCODEPT);                 /* OPT PARM PROCESSING    SUBRTNS*/
RMOPINIT STM   @14,@12,@SA00012                                    0853
         MVC   @PC00012(4),0(@01)                                  0853
*   DECLARE                                                        0854
*     OPCODEPT PTR(31),             /* PTR TO INPUT CODE             */
*     OPBRINDX FIXED(8) BASED(OPCODEPT),/* INPUT CODE                */
*/*                                                                  */
*/* OPBRTAB IS A TABLE CONTAINING THE ADDRESSES OF THE SUBROUTINES   */
*/* WHICH PROCESS OPT DATA.  THE DIMENSION OF OPBRTAB IS THE NUMBER  */
*/* OF SUBROUTINES.  THE INPUT PARAMETER TO THE RMOPINIT PROCEDURE   */
*/* IS USED TO ACCESS THE SUBSCRIPT FOR OPBRTAB                      */
*/*                                                                  */
*                                                                  0854
*     OPBRTAB(07) PTR INIT(ADDR(RMOP001),ADDR(RMOP002),ADDR(RMOP003),
*         ADDR(RMOP004),ADDR(RMOP005),ADDR(RMOP006),ADDR(RMOP007)),
*     RMOPLBL LABEL BASED(OPBRTAB(OPBRINDX))/* LABEL FOR OPT PARM  0854
*                                      PROC SUBROUTINES              */
*         ;                                                        0854
*   DCL                                                            0855
*     DIGIT1 CHAR(1),               /* RFC VALUES AS THEY    @Z40BPEM*/
*     DIGIT2 CHAR(1),               /* APPEAR IN OPT         @Z40BPEM*/
*     OPTERV CHAR(6);               /* ERV VALUE AS IT APPEARS IN OPT
*                                                            @Z40BPEM*/
*                                                                  0856
*/*  BRANCH TO THE SUBROUTINE BASED ON THE INPUT PARAMETER           */
*                                                                  0856
*   GO TO RMOPLBL;                  /* BRANCH TO OPT PROCESSING    0856
*                                      SUBROUTINES                   */
         L     @15,@PC00012                                        0856
         L     @01,OPCODEPT(,@15)                                  0856
         SLR   @15,@15                                             0856
         IC    @15,OPBRINDX(,@01)                                  0856
         SLA   @15,2                                               0856
         L     @01,OPBRTAB-4(@15)                                  0856
         BR    @01                                                 0856
*RMOP001:                                                          0857
*                                                                  0857
*/*  FOUND AN ERROR , MARK CATEGORY BEING PROCESSED AS ERRONEOUS     */
*                                                                  0857
*   OPCATGER=OPCATGER|OPCATMK;      /* SET ERROR INDICATOR           */
RMOP001  L     @15,@PC00001+16                                     0857
         OC    OPCATGER(4,@15),OPCATMK                             0857
*   RETURN;                         /* RETURN TO CALLER              */
@EL00012 DS    0H                                                  0858
@EF00012 DS    0H                                                  0858
@ER00012 LM    @14,@12,@SA00012                                    0858
         BR    @14                                                 0858
*RMOP002:                                                          0859
*                                                                  0859
*/*  'RFC' CATEGORY KEYOWRD HAS BEEN RECOGNIZED                      */
*                                                                  0859
*   OPCATMK=OPMASKTB(RFC);          /* SET CATEGORY ID               */
RMOP002  L     @15,OPMASKTB+4                                      0859
         ST    @15,OPCATMK                                         0859
*   RETURN;                         /* RETURN TO CALLER              */
         B     @EL00012                                            0860
*RMOP003:                                                          0861
*                                                                  0861
*/*  'RMC' CATEGORY KEYWORD HAS BEEN RECOGNIZED                      */
*                                                                  0861
*   OPCATMK=OPMASKTB(RMC);          /* SET CATEGORY ID               */
RMOP003  L     @15,OPMASKTB+8                                      0861
         ST    @15,OPCATMK                                         0861
*   RETURN;                         /* RETURN TO CALLER              */
         B     @EL00012                                            0862
*RMOP004:                                                          0863
*                                                                  0863
*/*  THE COEFFICIENT VALUE HAS BEEN RECOGNIZED.                      */
*/*  IF THE COEFFICIENT HAS BEEN PREVIOUSLY SPECIFIED, IGNORE IT.    */
*/*  VERIFY THAT THE COEFFICIENT IS WITHIN ALLOWABLE RANGE.          */
*/*  IF IT IS ERRONEOUS, MARK RFC CATEGORY IN ERROR.                 */
*                                                                  0863
*   IF(OPWCMASK(RFC)&OPWRFCI)=ZERO THEN/* PARM HAS NOT BEEN SPECIFIED*/
RMOP004  SLR   @15,@15                                             0863
         L     @14,OPWRFCI                                         0863
         L     @07,OPWCMASK+12                                     0863
         LR    @06,@07                                             0863
         NR    @06,@14                                             0863
         CLR   @06,@15                                             0863
         BNE   @RF00863                                            0863
*     DO;                                                          0864
*       IF OPWINT1>=ZERO&OPWINT1<=NINE/* 9>=OPWINT1>=0               */
*           &OPWINT2>=ZERO&OPWINT2<=NINE/* 9>=OPWINT2>=0             */
*         THEN                      /* PARM VALUE IS VALID           */
         L     @06,OPWINT1                                         0865
         CR    @06,@15                                             0865
         BL    @RF00865                                            0865
         LA    @05,9                                               0865
         CR    @06,@05                                             0865
         BH    @RF00865                                            0865
         L     @04,OPWINT2                                         0865
         CR    @04,@15                                             0865
         BL    @RF00865                                            0865
         CR    @04,@05                                             0865
         BH    @RF00865                                            0865
*         DO;                                                      0866
*           OPWCMASK(RFC)=OPWCMASK(RFC)|OPWRFCI;                   0867
         OR    @07,@14                                             0867
         ST    @07,OPWCMASK+12                                     0867
*           OPWRFCVL(OPWRFCI)=OPWINT1*TEN+OPWINT2;/* COMBINE THE TWO
*                                      PARTS OF THE COEFFICIENT      */
         SLA   @14,2                                               0868
         MH    @06,@CH01216                                        0868
         ALR   @06,@04                                             0868
         ST    @06,OPWRFCVL-4(@14)                                 0868
*/* CONVERT RFC VALUES TO PRINTABLE FORM AND SAVE IN RMPT    @Z40BPEM*/
*                                                                  0869
*           CALL RMIPTRT(OPWINT1,ONE,ADDR(DIGIT1));/*        @Z40BPEM*/
         LA    @15,OPWINT1                                         0869
         ST    @15,@AL00001                                        0869
         LA    @15,@CF00077                                        0869
         ST    @15,@AL00001+4                                      0869
         LA    @15,DIGIT1                                          0869
         ST    @15,@AFTEMPS+8                                      0869
         LA    @15,@AFTEMPS+8                                      0869
         ST    @15,@AL00001+8                                      0869
         LA    @01,@AL00001                                        0869
         BAL   @14,RMIPTRT                                         0869
*           CALL RMIPTRT(OPWINT2,ONE,ADDR(DIGIT2));/*        @Z40BPEM*/
         LA    @15,OPWINT2                                         0870
         ST    @15,@AL00001                                        0870
         LA    @15,@CF00077                                        0870
         ST    @15,@AL00001+4                                      0870
         LA    @15,DIGIT2                                          0870
         ST    @15,@AFTEMPS+8                                      0870
         LA    @15,@AFTEMPS+8                                      0870
         ST    @15,@AL00001+8                                      0870
         LA    @01,@AL00001                                        0870
         BAL   @14,RMIPTRT                                         0870
*           INT1(OPWRFCI)=DIGIT1;   /* RFC VALUES IN RMPT    @Z40BPEM*/
         L     @15,RMPTPTR                                         0871
         L     @14,OPWRFCI                                         0871
         MH    @14,@CH00082                                        0871
         ST    @14,@TF00001                                        0871
         ALR   @14,@15                                             0871
         MVC   INT1-3(1,@14),DIGIT1                                0871
*           INT2(OPWRFCI)=DIGIT2;   /* ARE NOW PRINTABLE     @Z40BPEM*/
         AL    @15,@TF00001                                        0872
         MVC   INT2-3(1,@15),DIGIT2                                0872
*         END;                                                     0873
*       ELSE                        /* PARM VALUE IS INVALID         */
*         OPCATGER=OPCATGER|OPCATMK;/* MARK RFC ERROR                */
         B     @RC00865                                            0874
@RF00865 L     @15,@PC00001+16                                     0874
         OC    OPCATGER(4,@15),OPCATMK                             0874
*     END;                                                         0875
*   RETURN;                         /* RETURN TO CALLER              */
         B     @EL00012                                            0876
*RMOP005:                                                          0877
*                                                                  0877
*/*  THE 'ERV' PARAMETER VALUE HAS BEEN RECOGNIZED.                  */
*/*  IF THE PARAMETER VALUE HAS BEEN PREVIOUSLY SPECIFIED, IGNORE IT.*/
*/*  VERIFY THAT THE ERV VALUE IS WITHIN ALLOWABLE RANGE.            */
*/*  IF IT IS ERRONEOUS, MARK RMC CATEGORY IN ERROR.                 */
*                                                                  0877
*   IF(OPWCMASK(RMC)&ERV)=ZERO THEN /* PARM HAS NOT BEEN SPECIFIED   */
RMOP005  SLR   @15,@15                                             0877
         LA    @14,1                                               0877
         L     @07,OPWCMASK+24                                     0877
         LR    @06,@07                                             0877
         NR    @06,@14                                             0877
         CLR   @06,@15                                             0877
         BNE   @RF00877                                            0877
*     DO;                                                          0878
*       IF OPWINT1>=MINERV&OPWINT1<=MAXERV THEN/* PARM VALUE IS VALID*/
         L     @06,OPWINT1                                         0879
         CR    @06,@15                                             0879
         BL    @RF00879                                            0879
         C     @06,@CF01500                                        0879
         BH    @RF00879                                            0879
*         DO;                                                      0880
*           OPWCMASK(RMC)=OPWCMASK(RMC)|ERV;/* MARK ERV HAS BEEN   0881
*                                      PROCESSED                     */
         OR    @07,@14                                             0881
         ST    @07,OPWCMASK+24                                     0881
*           OPWRMCVL(ERV)=OPWINT1;  /* SAVE VALUE                    */
         ST    @06,OPWRMCVL                                        0882
*/* CONVERT ERV VALUE TO PRINTABLE FORM AND SAVE IN RMPT             */
*                                                                  0883
*           CALL RMIPTRT(OPWINT1,SIX,ADDR(OPTERV));/*        @Z40BPEM*/
         LA    @15,OPWINT1                                         0883
         ST    @15,@AL00001                                        0883
         LA    @15,@CF00095                                        0883
         ST    @15,@AL00001+4                                      0883
         LA    @15,OPTERV                                          0883
         ST    @15,@AFTEMPS+8                                      0883
         LA    @15,@AFTEMPS+8                                      0883
         ST    @15,@AL00001+8                                      0883
         LA    @01,@AL00001                                        0883
         BAL   @14,RMIPTRT                                         0883
*           REALERV=OPTERV;         /* ERV IN RMPT NOW IN PRINTABLE
*                                      FORM                  @Z40BPEM*/
         L     @01,RMPTPTR                                         0884
         MVC   REALERV(6,@01),OPTERV                               0884
*         END;                                                     0885
*       ELSE                        /* PARM VLAUE IS INVALID         */
*         OPCATGER=OPCATGER|OPCATMK;/* MARK RMC ERROR                */
         B     @RC00879                                            0886
@RF00879 L     @15,@PC00001+16                                     0886
         OC    OPCATGER(4,@15),OPCATMK                             0886
*     END;                                                         0887
*   RETURN;                         /* RETURN TO CALLER              */
         B     @EL00012                                            0888
*RMOP006:                                                          0889
*                                                                  0889
*/*  THE KEYWORD 'CPU' HAS BEEN RECOGNIZED                           */
*                                                                  0889
*   OPWRFCI=RFCCPU;                 /* RFC SUBPARAMETER IS CPU       */
RMOP006  MVC   OPWRFCI(4),@CF00077                                 0889
*   RETURN;                         /* RETURN TO CALLER              */
         B     @EL00012                                            0890
*RMOP007:                                                          0891
*                                                                  0891
*/*  THE KEYWORD 'IOC' HAS BEEN RECOGNIZED                           */
*                                                                  0891
*   OPWRFCI=RFCIOC;                 /* RFC SUBPARAMETER IS IOC       */
RMOP007  MVC   OPWRFCI(4),@CF00118                                 0891
*   RETURN;                         /* RETURN TO CALLER              */
         B     @EL00012                                            0892
*   END RMOPINIT;                                                  0893
         B     @EL00012                                            0893
*                                                                  0894
*/*  PROCEDURE NAME = MFRTEXT                                        */
*/*                                                                  */
*/*  DESCRIPTIVE NAME = TEXT RECOGNIZER                              */
*/*                                                                  */
*/*  FUNCTION = RECOGNIZES TEXT AS THE TEXT PARAMETER INDICATES.     */
*/*                                                                  */
*                                                                  0894
*MFRTEXT:                                                          0894
*   PROCEDURE(RTEXPARM,RTSCB);                                     0894
MFRTEXT  STM   @14,@12,@SA00013                                    0894
         MVC   @PC00013(8),0(@01)                                  0894
*   DECLARE                                                        0895
*     RTEXPARM                      /* PTR TO TEXT PARM LIST         */
*         PTR(31),                                                 0895
*                                                                  0895
*/*  PARAMETERS FOR TEXT RECOGNIZER                                  */
*                                                                  0895
*     1 RTPARMLS BASED(RTEXPARM),   /* TEXT PARM LIST                */
*      2 RTLENGTH                   /* LENGTH OF TEXT                */
*            FIXED(8),                                             0895
*      2 RTTEXT                     /* TEXT TO LOOK FOR              */
*            CHAR(*),                                              0895
*                                                                  0895
*/*  SCAN CONTROL BLOCK                                              */
*                                                                  0895
*     1 RTSCB,                      /* SCAN CONTROL BLOCK            */
*      2 RTCURBCB                   /* CURRENT BCB PTR               */
*            PTR(31),                                              0895
*      2 RTCURTXT                   /* CURRENT TEXT PTR              */
*            PTR(31),                                              0895
*      2 RTBYTLFT                   /* # BYTES LEFT IN BUFFER        */
*            FIXED(31),                                            0895
*     RTSCANER                      /* TEXT IN BUFFER                */
*         CHAR(*) BASED(RTCURTXT);                                 0895
*   IF RTBYTLFT=ZERO THEN           /* AT END OF BUFFER?             */
         L     @15,@PC00013+4                                      0896
         L     @14,RTBYTLFT(,@15)                                  0896
         LTR   @14,@14                                             0896
         BNZ   @RF00896                                            0896
*     DO;                                                          0897
*       CALL MFNXTREC(RTSCB);       /* GET A RECORD IF ONE EXISTS    */
         ST    @15,@AL00001                                        0898
         LA    @01,@AL00001                                        0898
         BAL   @14,MFNXTREC                                        0898
*       RFY                                                        0899
*        (GPR15F) RSTD;                                            0899
*       IF GPR15F=FAIL THEN         /* MFNXTREC UNSUCCESSFUL?        */
         C     GPR15F,@CF00054                                     0900
         BNE   @RF00900                                            0900
*         RETURN CODE(GPR15F);      /* YES, RETURN TO IRBMFANL       */
         L     @14,@SA00013                                        0901
         LM    @00,@12,@SA00013+8                                  0901
         BR    @14                                                 0901
*       RFY                                                        0902
*        (GPR15F) UNRSTD;                                          0902
@RF00900 DS    0H                                                  0903
*     END;                                                         0903
*   IF RTLENGTH>RTBYTLFT THEN       /* IF LENGTH OF TEXT PASSED > NO.
*                                      OF BYTES LEFT IN BUFFER THEN  */
@RF00896 L     @15,@PC00013                                        0904
         L     @01,RTEXPARM(,@15)                                  0904
         L     @15,@PC00013+4                                      0904
         SLR   @00,@00                                             0904
         IC    @00,RTLENGTH(,@01)                                  0904
         C     @00,RTBYTLFT(,@15)                                  0904
         BNH   @RF00904                                            0904
*     RETURN CODE(4);               /* RETURN UNSUCCESSFUL           */
         LA    @15,4                                               0905
         L     @14,@SA00013                                        0905
         LM    @00,@12,@SA00013+8                                  0905
         BR    @14                                                 0905
*   IF RTSCANER(1:RTLENGTH)=RTTEXT(1:RTLENGTH) THEN/* A MATCH?       */
@RF00904 L     @15,@PC00013+4                                      0906
         L     @14,RTCURTXT(,@15)                                  0906
         L     @07,@PC00013                                        0906
         L     @07,RTEXPARM(,@07)                                  0906
         SLR   @06,@06                                             0906
         IC    @06,RTLENGTH(,@07)                                  0906
         LR    @05,@06                                             0906
         BCTR  @05,0                                               0906
         EX    @05,@SC02047                                        0906
         BNE   @RF00906                                            0906
*     DO;                                                          0907
*       RTCURTXT=RTCURTXT+RTLENGTH; /* UPDATE CRRENT TEXT PTR        */
         ALR   @14,@06                                             0908
         ST    @14,RTCURTXT(,@15)                                  0908
*       RTBYTLFT=RTBYTLFT-RTLENGTH; /* DECREASE # BYTES LEFT         */
         LCR   @06,@06                                             0909
         AL    @06,RTBYTLFT(,@15)                                  0909
         ST    @06,RTBYTLFT(,@15)                                  0909
*       RETURN CODE(0);             /* RETURN SUCCESSFUL             */
         SLR   @15,@15                                             0910
         L     @14,@SA00013                                        0910
         LM    @00,@12,@SA00013+8                                  0910
         BR    @14                                                 0910
*     END;                                                         0911
*   RETURN CODE(4);                 /* RETURN UNSUCCESSFUL           */
@RF00906 LA    @15,4                                               0912
         L     @14,@SA00013                                        0912
         LM    @00,@12,@SA00013+8                                  0912
         BR    @14                                                 0912
*   END MFRTEXT;                                                   0913
*                                                                  0914
*/* PROCEDURE NAME = MFRINTGR                                        */
*/*                                                                  */
*/*  DESCRIPTIVE NAME = INTEGER RECOGNIZER                           */
*/*                                                                  */
*/*  FUNCTION = RECOGNIZES ANY INTEGER, CONVERTS IT AND SAVES IT FOR */
*/*             OPTION INITIALIZATION.                               */
*/*                                                                  */
*/* DEPENDENCY = CHARACTER CODE DEPENDENT                            */
*/*                                                                  */
*                                                                  0914
*MFRINTGR:                                                         0914
*   PROCEDURE(RISAVNUM,RISCB);                                     0914
MFRINTGR STM   @14,@12,@SA00014                                    0914
         MVC   @PC00014(8),0(@01)                                  0914
*   DECLARE                                                        0915
*     RISAVNUM                      /* PLACE TO STORE INTEGER PTR    */
*         PTR(31),                                                 0915
*                                                                  0915
*/*  SCAN CONTROL BLOCK                                              */
*                                                                  0915
*     1 RISCB,                      /* SCAN CONTROL BLOCK            */
*      2 RICURBCB                   /* CURRENT BCB PTR               */
*            PTR(31),                                              0915
*      2 RICURTXT                   /* CURRENT TEXT PTR              */
*            PTR(31),                                              0915
*      2 RIBYTLFT                   /* # BYTES LEFT                  */
*            FIXED(31),                                            0915
*     RINUMBER                      /* COMPUTED VALUE OF INTEGER     */
*         FIXED(32),                                               0915
*     RIINTGER                      /* NUMBER IN SOURCE'S BUFFER     */
*         CHAR(1) BASED(RICURTXT),                                 0915
*     RIINTDEC                      /* ACTUAL NUMBER                 */
*         CHAR(1),                                                 0915
*     RITEMNUM                      /* TEMPORARY VALUE               */
*         FIXED(32),                                               0915
*     RIINTFND                      /* INTEGER FOUND INDICATOR       */
*         BIT(1),                                                  0915
*     RINUMVAL                      /* PLACE TO STORE INTEGER        */
*         BASED(ININTPTR(RINUMCOD)) FIXED(32),                     0915
*     RINUMCOD                      /* CODE FOR WHERE TO SAVE        */
*         FIXED(8) BASED(RISAVNUM);                                0915
*   RIINTFND='0'B;                                                 0916
         NI    RIINTFND,B'01111111'                                0916
*   RINUMBER=ZERO;                                                 0917
         SLR   RINUMBER,RINUMBER                                   0917
*   IF RIBYTLFT=ZERO THEN           /* AT END OF BUFFER?             */
         L     @02,@PC00014+4                                      0918
         L     @15,RIBYTLFT(,@02)                                  0918
         LTR   @15,@15                                             0918
         BNZ   @RF00918                                            0918
*     DO;                                                          0919
*       CALL MFNXTREC(RISCB);       /* GET A RECORD IF ONE EXISTS    */
         ST    @02,@AL00001                                        0920
         LA    @01,@AL00001                                        0920
         BAL   @14,MFNXTREC                                        0920
*       RFY                                                        0921
*        (GPR15F) RSTD;                                            0921
*       IF GPR15F=FAIL THEN         /* MFNXTREC UNSUCCESSFUL?        */
         C     GPR15F,@CF00054                                     0922
         BNE   @RF00922                                            0922
*         RETURN CODE(GPR15F);      /* YES, RETURN TO IRBMFANL       */
         L     @14,@SA00014                                        0923
         LM    @00,@12,@SA00014+8                                  0923
         BR    @14                                                 0923
*       RFY                                                        0924
*        (GPR15F) UNRSTD;                                          0924
@RF00922 DS    0H                                                  0925
*     END;                                                         0925
*                                                                  0925
*/*  SAVE COLUMN NO. AT WHICH SCAN BEGINS                            */
*/*  SAVE INPUT STRING                                               */
*                                                                  0926
*   IPERRCOL=IPDATALN-RIBYTLFT;     /* COL NO.                       */
@RF00918 L     @02,@PC00014+4                                      0926
         LA    @15,72                                              0926
         SL    @15,RIBYTLFT(,@02)                                  0926
         ST    @15,IPERRCOL                                        0926
*   IPMSGINP=RICURBCB->INBCBTXT->IPINPUTS(2:81);/* SAVE INPUT        */
         L     @02,RICURBCB(,@02)                                  0927
         L     @02,INBCBTXT(,@02)                                  0927
         MVC   IPMSGINP(80),IPINPUTS+1(@02)                        0927
*   DO I=1 TO RIBYTLFT WHILE(RIINTGER>='F0'X&RIINTGER<='F9'X);     0928
         LA    I,1                                                 0928
         B     @DE00928                                            0928
@DL00928 L     @15,@PC00014+4                                      0928
         L     @15,RICURTXT(,@15)                                  0928
         CLI   RIINTGER(@15),X'F0'                                 0928
         BL    @DC00928                                            0928
         CLI   RIINTGER(@15),X'F9'                                 0928
         BH    @DC00928                                            0928
*     RIINTFND='1'B;                /* INDICATE NUMBER FOUND         */
         OI    RIINTFND,B'10000000'                                0929
*     RIINTDEC=RIINTGER&'0F'X;      /* CLEAR OUT BITS                */
         MVC   RIINTDEC(1),RIINTGER(@15)                           0930
         NI    RIINTDEC,X'0F'                                      0930
*     RITEMNUM=RINUMBER;            /* SAVE OLD VALUE                */
         ST    RINUMBER,RITEMNUM                                   0931
*     RINUMBER=RINUMBER*TEN+RIINTDEC;                              0932
         LR    @15,RINUMBER                                        0932
         MH    @15,@CH01216                                        0932
         SLR   @14,@14                                             0932
         IC    @14,RIINTDEC                                        0932
         ALR   @15,@14                                             0932
         LR    RINUMBER,@15                                        0932
*     IF RINUMBER<RITEMNUM THEN     /* OVERFLOW?                     */
         L     @15,RITEMNUM                                        0933
         CLR   RINUMBER,@15                                        0933
         BNL   @RF00933                                            0933
*       DO;                                                        0934
*         RINUMBER=RITEMNUM;        /* SET TO PREVIOUS VALUE         */
         LR    RINUMBER,@15                                        0935
*         GOTO RILAB1;              /* STORE NUMBER                  */
         B     RILAB1                                              0936
*       END;                                                       0937
*     RICURTXT=RICURTXT+ONE;        /* UPDATE CURRENT TXT PTR        */
@RF00933 L     @15,@PC00014+4                                      0938
         LA    @14,1                                               0938
         AL    @14,RICURTXT(,@15)                                  0938
         ST    @14,RICURTXT(,@15)                                  0938
*   END;                                                           0939
         AL    I,@CF00077                                          0939
@DE00928 L     @15,@PC00014+4                                      0939
         C     I,RIBYTLFT(,@15)                                    0939
         BNH   @DL00928                                            0939
@DC00928 DS    0H                                                  0940
*RILAB1:                                                           0940
*   ;                               /* COMPLETED SCANNING FOR INTEGER*/
RILAB1   DS    0H                                                  0941
*   RIBYTLFT=RIBYTLFT-(I-ONE);      /* DECREASE # BYTES LEFT         */
         L     @15,@PC00014+4                                      0941
         LR    @14,I                                               0941
         BCTR  @14,0                                               0941
         LCR   @14,@14                                             0941
         AL    @14,RIBYTLFT(,@15)                                  0941
         ST    @14,RIBYTLFT(,@15)                                  0941
*   IF RIINTFND='1'B THEN           /* NUMBER FOUND?                 */
         TM    RIINTFND,B'10000000'                                0942
         BNO   @RF00942                                            0942
*     DO;                                                          0943
*       RINUMVAL=RINUMBER;          /* STORE INTEGER                 */
         L     @02,@PC00014                                        0944
         L     @02,RISAVNUM(,@02)                                  0944
         SLR   @15,@15                                             0944
         IC    @15,RINUMCOD(,@02)                                  0944
         SLA   @15,2                                               0944
         L     @02,ININTPTR-4(@15)                                 0944
         ST    RINUMBER,RINUMVAL(,@02)                             0944
*       RETURN CODE(0);             /* RETURN SUCCESSFUL             */
         SLR   @15,@15                                             0945
         L     @14,@SA00014                                        0945
         LM    @00,@12,@SA00014+8                                  0945
         BR    @14                                                 0945
*     END;                                                         0946
*   RETURN CODE(4);                 /* RETURN UNSUCCESSFUL           */
@RF00942 LA    @15,4                                               0947
         L     @14,@SA00014                                        0947
         LM    @00,@12,@SA00014+8                                  0947
         BR    @14                                                 0947
*   END MFRINTGR;                                                  0948
*                                                                  0949
*/*  PROCEDURE NAME = MFRBLANK                                       */
*/*                                                                  */
*/*  DESCRIPTIVE NAME = BLANK RECOGNIZER                             */
*/*                                                                  */
*/*  FUNCTION = RECOGNIZES BLANKS DEPENDING ON THE INPUT PARAMTER.   */
*/*             THIS RECOGNIZER WILL ALWAYS RETURN SUCCESSFULLY (EVEN*/
*/*             IF NO BLANKS OR COMMENTS WERE FOUND) OR IT WILL      */
*/*             RETURN A SUCCESSFUL INDICATION ONLY IF AT LEAST ONE  */
*/*             BLANK OR COMMENT IS FOUND. (DELIMITER TYPE).         */
*/*                                                                  */
*                                                                  0949
*MFRBLANK:                                                         0949
*   PROCEDURE(RBTYPE,RBSCB);                                       0949
MFRBLANK STM   @14,@12,@SA00015                                    0949
         MVC   @PC00015(8),0(@01)                                  0949
*   DECLARE                                                        0950
*     RBTYPE                        /* PTR TO TYPE OF BLANK        0950
*                                      RECOGNIZER TO BE EXECUTED     */
*         PTR(31),                                                 0950
*     RBTYPBIT                      /* TYPE OF BLANK RECOGNIZER 0 -
*                                      GENERAL BLANK RECOGNIZER 1 -
*                                      DELIMITER TYPE BLANK        0950
*                                      RECOGNIZER                    */
*         BASED(RBTYPE) BIT(1),                                    0950
*                                                                  0950
*/*  SCAN CONTROL BLOCK                                              */
*                                                                  0950
*     1 RBSCB,                      /* SCAN CONTROL BLOCK            */
*      2 RBCURBCB                   /* CURRENT BCB PTR               */
*            PTR(31),                                              0950
*      2 RBCURTXT                   /* CURRENT TXT PTR               */
*            PTR(31),                                              0950
*      2 RBBYTLFT                   /* # BYTES LEFT                  */
*            FIXED(31),                                            0950
*     RBTXTPTR                      /* PTR TO TEXT IN BUFFER         */
*         PTR(31),                                                 0950
*     RBCHAR                        /* CHARACTER POINTED TO BY     0950
*                                      RBTXTPTR                      */
*         CHAR(*) BASED(RBTXTPTR),                                 0950
*     RBFINISH                      /* FINISH SCANNING FOR BLANKS OR
*                                      COMMENTS                      */
*         BIT(1),                                                  0950
*     RBFOUND                       /* FOUND BLANKS OR COMMENTS      */
*         BIT(1),                                                  0950
*     RBCOMBEG                      /* BEGINNING DELIMITER FOR COMENT*/
*         CHAR(2) STATIC LOCAL GEND,                               0950
*     RBCOMEND                      /* END DELIMITER FOR COMMENT     */
*         CHAR(2) STATIC LOCAL GEND,                               0950
*     RBCOMENT                      /* COMMENT SCANNER               */
*         FIXED(31);                                               0950
*   GEN DATA DEFS(RBCOMBEG,RBCOMEND);                              0951
*   RBFOUND='0'B;                                                  0952
         NI    RBFOUND,B'01111111'                                 0952
*   RBFINISH='0'B;                  /* INITIALIZE FINISH BIT         */
         NI    RBFINISH,B'01111111'                                0953
*   DO WHILE RBFINISH='0'B;                                        0954
         B     @DE00954                                            0954
@DL00954 DS    0H                                                  0955
*     IF RBBYTLFT=ZERO THEN         /* AT END OF BUFFER?             */
         L     @15,@PC00015+4                                      0955
         L     @14,RBBYTLFT(,@15)                                  0955
         LTR   @14,@14                                             0955
         BNZ   @RF00955                                            0955
*       DO;                                                        0956
*         CALL MFNXTREC(RBSCB);     /* GET A RECORD IF ONE EXISTS    */
         ST    @15,@AL00001                                        0957
         LA    @01,@AL00001                                        0957
         BAL   @14,MFNXTREC                                        0957
*         RFY                                                      0958
*          (GPR15F) RSTD;                                          0958
*         IF GPR15F=FAIL THEN       /* NO MORE RECORDS?              */
         C     GPR15F,@CF00054                                     0959
         BNE   @RF00959                                            0959
*           DO;                                                    0960
*             RBFINISH='1'B;        /* INDICATE SCAN IS FINISHED     */
         OI    RBFINISH,B'10000000'                                0961
*             GOTO RBENDLOP;        /* END THIS LOOP                 */
         B     RBENDLOP                                            0962
*             RFY                                                  0963
*              (GPR15F) UNRSTD;                                    0963
*           END;                                                   0964
*       END;                                                       0965
*                                                                  0965
@RF00959 DS    0H                                                  0966
*     /***************************************************************/
*     /*                                                             */
*     /* SCAN FOR BLANKS OR COMMENTS                                 */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0966
*     DO RBTXTPTR=RBCURTXT TO RBCURTXT+RBBYTLFT-ONE;               0966
@RF00955 L     @15,@PC00015+4                                      0966
         L     RBTXTPTR,RBCURTXT(,@15)                             0966
         B     @DE00966                                            0966
@DL00966 DS    0H                                                  0967
*       IF RBTXTPTR=RBCURTXT+RBBYTLFT-ONE THEN/* REACH END OF BUFFER?*/
         L     @03,@PC00015+4                                      0967
         L     @15,RBCURTXT(,@03)                                  0967
         AL    @15,RBBYTLFT(,@03)                                  0967
         BCTR  @15,0                                               0967
         CR    RBTXTPTR,@15                                        0967
         BE    @RT00967                                            0967
*         GOTO RBCHKBLN;            /* CHECK FOR BLANKS              */
*       IF RBCHAR(1:2)=RBCOMBEG THEN/* BEGINNING OF A COMMENT?       */
         CLC   RBCHAR(2,RBTXTPTR),RBCOMBEG                         0969
         BNE   @RF00969                                            0969
*         DO;                                                      0970
*           RBFOUND='1'B;           /* COMMENT BEGINNING FOUND       */
         OI    RBFOUND,B'10000000'                                 0971
*RBCOMSCN:                                                         0972
*           ;                       /* SCAN THROUGH COMMENT TEXT     */
RBCOMSCN DS    0H                                                  0973
*           DO RBCOMENT=1 BY ONE WHILE RBCOMENT+RBTXTPTR<RBCURTXT+ 0973
*                 RBBYTLFT;                                        0973
         LA    RBCOMENT,1                                          0973
         B     @DE00973                                            0973
@DL00973 DS    0H                                                  0974
*             IF RBCHAR(RBCOMENT:RBCOMENT+ONE)=RBCOMEND THEN/*     0974
*                                      REACHED END OF COMMENT?       */
         LR    @01,RBTXTPTR                                        0974
         ALR   @01,RBCOMENT                                        0974
         BCTR  @01,0                                               0974
         CLC   RBCHAR(2,@01),RBCOMEND                              0974
         BNE   @RF00974                                            0974
*               DO;                                                0975
*                 RBTXTPTR=RBTXTPTR+RBCOMENT;/* UPDATE PTR IN BUFFER */
         ALR   RBTXTPTR,RBCOMENT                                   0976
*                 GOTO RBLOOP;      /* END THIS LOOP                 */
         B     RBLOOP                                              0977
*               END;                                               0978
*           END;                                                   0979
@RF00974 AL    RBCOMENT,@CF00077                                   0979
@DE00973 LR    @15,RBCOMENT                                        0979
         ALR   @15,RBTXTPTR                                        0979
         L     @14,@PC00015+4                                      0979
         L     @07,RBCURTXT(,@14)                                  0979
         AL    @07,RBBYTLFT(,@14)                                  0979
         CR    @15,@07                                             0979
         BL    @DL00973                                            0979
*           RBCURTXT=RBCURTXT+RBBYTLFT;/* UPDATE CURRENT TXT PTR     */
         ST    @07,RBCURTXT(,@14)                                  0980
*           RBBYTLFT=ZERO;          /* INDICATE NO BYTES LEFT        */
         SLR   @15,@15                                             0981
         ST    @15,RBBYTLFT(,@14)                                  0981
*           CALL MFNXTREC(RBSCB);   /* GET NEXT RECORD               */
         ST    @14,@AL00001                                        0982
         LA    @01,@AL00001                                        0982
         BAL   @14,MFNXTREC                                        0982
*           RFY                                                    0983
*            (GPR15F) RSTD;                                        0983
*           IF GPR15F=ZERO THEN     /* DID A RECORD EXIST?           */
         LTR   GPR15F,GPR15F                                       0984
         BNZ   @RF00984                                            0984
*             DO;                                                  0985
*               RBTXTPTR=RBCURTXT;  /* POINT TO BEGINNING OF BUFFER  */
         L     @14,@PC00015+4                                      0986
         L     RBTXTPTR,RBCURTXT(,@14)                             0986
*               GOTO RBCOMSCN;      /* CONTINUE SCAN FOR COMMENTS    */
         B     RBCOMSCN                                            0987
*               RFY                                                0988
*                (GPR15F) UNRSTD;                                  0988
*             END;                                                 0989
*           RBFINISH='1'B;          /* NO MORE TEXT, SCAN IS FINISHED*/
@RF00984 OI    RBFINISH,B'10000000'                                0990
*           GOTO RBENDLOP;          /* END THIS LOOP                 */
         B     RBENDLOP                                            0991
*         END;                                                     0992
*RBCHKBLN:                                                         0993
*       ;                           /* SCAN FOR BLANKS               */
@RF00969 DS    0H                                                  0993
RBCHKBLN DS    0H                                                  0994
*       IF RBCHAR(1:1)^=' ' THEN    /* NONBLANK CHARACTER?           */
         CLI   RBCHAR(RBTXTPTR),C' '                               0994
         BE    @RF00994                                            0994
*         DO;                                                      0995
*           RBFINISH='1'B;          /* YES, BLANK SCAN IS FINISHED   */
         OI    RBFINISH,B'10000000'                                0996
*           GOTO RBENDSCN;          /* UPDATE BCB AND SCB            */
         B     RBENDSCN                                            0997
*         END;                                                     0998
*       RBFOUND='1'B;               /* BLANK FOUND                   */
@RF00994 OI    RBFOUND,B'10000000'                                 0999
*RBLOOP:                                                           1000
*       ;                           /* CONTINUE SCAN FOR BLANKS OR 1000
*                                      COMMENTS                      */
RBLOOP   DS    0H                                                  1001
*     END;                                                         1001
         AL    RBTXTPTR,@CF00077                                   1001
@DE00966 L     @03,@PC00015+4                                      1001
         L     @15,@PC00015+4                                      1001
         L     @03,RBCURTXT(,@03)                                  1001
         AL    @03,RBBYTLFT(,@15)                                  1001
         BCTR  @03,0                                               1001
         CR    RBTXTPTR,@03                                        1001
         BNH   @DL00966                                            1001
*RBENDSCN:                                                         1002
*     ;                             /* COMPLETED SCANNING BLANKS OR
*                                      ONE COMMENT                   */
RBENDSCN DS    0H                                                  1003
*     RBBYTLFT=RBBYTLFT-(RBTXTPTR-RBCURTXT);/* NO. BYTES LEFT        */
         L     @03,@PC00015+4                                      1003
         LR    @15,RBTXTPTR                                        1003
         SL    @15,RBCURTXT(,@03)                                  1003
         LCR   @15,@15                                             1003
         AL    @15,RBBYTLFT(,@03)                                  1003
         ST    @15,RBBYTLFT(,@03)                                  1003
*     RBCURTXT=RBTXTPTR;            /* UPDATE CURRENT TEXT PTR       */
         ST    RBTXTPTR,RBCURTXT(,@03)                             1004
*RBENDLOP:                                                         1005
*     ;                             /* CONTINUE SCAN FOR MORE BLANKS
*                                      OR COMMENTS                   */
RBENDLOP DS    0H                                                  1006
*   END;                                                           1006
@DE00954 TM    RBFINISH,B'10000000'                                1006
         BZ    @DL00954                                            1006
*   IF RBFOUND='0'B&RBTYPBIT='1'B THEN/* NO BLANKS/COMMENTS FOUND?   */
         TM    RBFOUND,B'10000000'                                 1007
         BNZ   @RF01007                                            1007
         L     @15,@PC00015                                        1007
         L     @01,RBTYPE(,@15)                                    1007
         TM    RBTYPBIT(@01),B'10000000'                           1007
         BNO   @RF01007                                            1007
*     RETURN CODE(4);               /* RETURN UNSUCCESSFUL           */
         LA    @15,4                                               1008
         L     @14,@SA00015                                        1008
         LM    @00,@12,@SA00015+8                                  1008
         BR    @14                                                 1008
*   RETURN CODE(0);                 /* RETURN SUCCESSFUL             */
@RF01007 SLR   @15,@15                                             1009
         L     @14,@SA00015                                        1009
         LM    @00,@12,@SA00015+8                                  1009
         BR    @14                                                 1009
*   END MFRBLANK;                                                  1010
*                                                                  1011
*/*  PROCEDURE = MFRRERR                                             */
*/*                                                                  */
*/*  DESCRIPTIVE NAME = ERROR RECOGNIZER                             */
*/*                                                                  */
*/*  FUNCTION = SKIPS TEXT UP TO BUT NOT INCLUDING A COMMA, COMMENT, */
*/*             BLANK OR RIGHT PARENTHESIS.                          */
*/*                                                                  */
*                                                                  1011
*MFRRERR:                                                          1011
*   PROCEDURE(RRPARM,RRSCB);                                       1011
MFRRERR  STM   @14,@12,@SA00016                                    1011
         MVC   @PC00016(8),0(@01)                                  1011
*   DECLARE                                                        1012
*     RRPARM                        /* PTR TO A PARAMETER LIST       */
*         PTR(31),                                                 1012
*                                                                  1012
*/*  PARAMETERS FOR ERROR RECOGNIZER                                 */
*                                                                  1012
*     1 RRPARMLS                    /* PARAMETER LIST                */
*           BASED(RRPARM),                                         1012
*      2 RRTYPE                     /* TYPE OF ERROR RECOGNIZER      */
*            BIT(1),                                               1012
*      2 *                          /* NOT USED                      */
*            BIT(7),                                               1012
*      2 RRLENGTH                   /* LENGTH OF ERROR TEXT TO BE  1012
*                                      SAVED FOR FUTURE REFERENCE    */
*            FIXED(8),                                             1012
*      2 RRSAVETX                   /* CODE FOR WHERE TO SAVE        */
*            FIXED(8),                                             1012
*                                                                  1012
*/*  SCAN CONTROL BLOCK                                              */
*                                                                  1012
*     1 RRSCB,                      /* SCB PASSED FROM ANALYZER      */
*      2 RRCURBCB                   /* CURRENT BCB PTR               */
*            PTR(31),                                              1012
*      2 RRTXTCUR                   /* CURRENT TEXT PTR              */
*            PTR(31),                                              1012
*      2 RRBYTLFT                   /* NO. BYTES LEFT IN BUFFER      */
*            FIXED(31),                                            1012
*     RRTXTPTR                      /* PTR TO TEXT IN BUFFER         */
*         PTR(31),                                                 1012
*     RRCHAR                        /* CHARS. IN BUFFER              */
*         CHAR(2) BASED(RRTXTPTR),                                 1012
*     RRERRTXT                      /* BEGINNING OF ERROR TEXT       */
*         CHAR(*) BASED(INERRPTR(RRSAVETX)),                       1012
*     RRFINISH                      /* FINISHED LOOPING INDICATOR    */
*         BIT(1),                                                  1012
*     RRFOUND                       /* ERROR TEXT FOUND              */
*         BIT(1),                                                  1012
*     RRERRSCN                      /* # CHARACTERS SCANNED          */
*         FIXED(31),                                               1012
*     RRCOMBEG                      /* COMMENT DELIMITER             */
*         CHAR(2) STATIC LOCAL GEND;                               1012
*   GENERATE DATA DEFS(RRCOMBEG);                                  1013
*   RRFOUND='0'B;                   /* INITIALIZE FOUND BIT          */
         NI    RRFOUND,B'01111111'                                 1014
*   RRFINISH='0'B;                  /* INITIALIZE FINISH BIT         */
         NI    RRFINISH,B'01111111'                                1015
*   RRERRSCN=ONE;                   /* INITIALIZE TEXT SCAN          */
         LA    RRERRSCN,1                                          1016
*/*  CHECK IF IT IS NECESSARY TO READ IN NEXT RECORD                 */
*                                                                  1017
*   IF RRBYTLFT=ZERO THEN           /* AT END OF BUFFER?             */
         L     @15,@PC00016+4                                      1017
         L     @14,RRBYTLFT(,@15)                                  1017
         LTR   @14,@14                                             1017
         BNZ   @RF01017                                            1017
*     DO;                                                          1018
*       CALL MFNXTREC(RRSCB);       /* GET NEXT RECORD               */
         ST    @15,@AL00001                                        1019
         LA    @01,@AL00001                                        1019
         BAL   @14,MFNXTREC                                        1019
*       RFY                                                        1020
*        (GPR15F) RSTD;                                            1020
*       IF GPR15F=FAIL THEN         /* NO MORE RECORDS               */
         C     GPR15F,@CF00054                                     1021
         BNE   @RF01021                                            1021
*         DO;                                                      1022
*           RRFINISH='1'B;          /* INDICATE FINISH               */
         OI    RRFINISH,B'10000000'                                1023
*           GO TO RRBEGLOP;         /* BEGIN SCAN FOR ERROR          */
         B     RRBEGLOP                                            1024
*         END;                                                     1025
*       RFY                                                        1026
*        (GPR15F) UNRSTD;                                          1026
@RF01021 DS    0H                                                  1027
*     END;                                                         1027
*                                                                  1027
*/*  SAVE COLUMN NO. AT WHICH SCAN BEGINS                            */
*/*  SAVE INPUT STRING                                               */
*                                                                  1028
*   IPERRCOL=IPDATALN-RRBYTLFT;     /* COLUMN NO.                    */
@RF01017 L     @15,@PC00016+4                                      1028
         LA    @14,72                                              1028
         SL    @14,RRBYTLFT(,@15)                                  1028
         ST    @14,IPERRCOL                                        1028
*   IPMSGINP=RRCURBCB->INBCBTXT->IPINPUTS(2:81);                   1029
         L     @01,RRCURBCB(,@15)                                  1029
         L     @01,INBCBTXT(,@01)                                  1029
         MVC   IPMSGINP(80),IPINPUTS+1(@01)                        1029
*RRBEGLOP:                                                         1030
*   ;                               /* BEGIN SCAN FOR ERROR INPUT    */
RRBEGLOP DS    0H                                                  1031
*   DO WHILE RRFINISH='0'B;                                        1031
         B     @DE01031                                            1031
@DL01031 DS    0H                                                  1032
*     IF RRBYTLFT=ZERO THEN         /* AT END OF BUFFER?             */
         L     @15,@PC00016+4                                      1032
         L     @14,RRBYTLFT(,@15)                                  1032
         LTR   @14,@14                                             1032
         BNZ   @RF01032                                            1032
*       DO;                                                        1033
*         CALL MFNXTREC(RRSCB);     /* GET NEXT RECORD               */
         ST    @15,@AL00001                                        1034
         LA    @01,@AL00001                                        1034
         BAL   @14,MFNXTREC                                        1034
*         RFY                                                      1035
*          (GPR15F) RSTD;                                          1035
*         IF GPR15F=FAIL THEN       /* NO MORE RECORDS?              */
         C     GPR15F,@CF00054                                     1036
         BNE   @RF01036                                            1036
*           DO;                                                    1037
*             RRFINISH='1'B;        /* INDICATE LOOP FINISHED        */
         OI    RRFINISH,B'10000000'                                1038
*             GOTO RRENDLOP;        /* END THIS LOOP                 */
         B     RRENDLOP                                            1039
*           END;                                                   1040
*         RFY                                                      1041
*          (GPR15F) UNRSTD;                                        1041
@RF01036 DS    0H                                                  1042
*       END;                                                       1042
*     IF RRTYPE='0'B THEN           /* SKIP UP TO COMMA, BLANK OR  1043
*                                      COMMENT                       */
@RF01032 L     @15,@PC00016                                        1043
         L     @01,RRPARM(,@15)                                    1043
         TM    RRTYPE(@01),B'10000000'                             1043
         BNZ   @RF01043                                            1043
*       DO RRTXTPTR=RRTXTCUR TO RRTXTCUR+RRBYTLFT-ONE;             1044
         L     @15,@PC00016+4                                      1044
         L     RRTXTPTR,RRTXTCUR(,@15)                             1044
         B     @DE01044                                            1044
@DL01044 DS    0H                                                  1045
*         IF RRCHAR(1:1)=','|RRCHAR(1:1)=' ' THEN/* COMMA OR BLANK?  */
         CLI   RRCHAR(RRTXTPTR),C','                               1045
         BE    @RT01045                                            1045
         CLI   RRCHAR(RRTXTPTR),C' '                               1045
         BE    @RT01045                                            1045
*           GOTO RRSCNEND;          /* END THIS LOOP                 */
*         IF RRTXTPTR=RRTXTCUR+RRBYTLFT-ONE THEN/* REACH END OF    1047
*                                      BUFFER ?                      */
         L     @03,@PC00016+4                                      1047
         L     @15,RRTXTCUR(,@03)                                  1047
         AL    @15,RRBYTLFT(,@03)                                  1047
         BCTR  @15,0                                               1047
         CR    RRTXTPTR,@15                                        1047
         BE    @RT01047                                            1047
*           GOTO RRUPDATE;          /* MOVE IN ERROR TEXT            */
*         IF RRCHAR(1:2)=RRCOMBEG THEN/* BEGINNING OF A COMMENT?     */
         CLC   RRCHAR(2,RRTXTPTR),RRCOMBEG                         1049
         BE    @RT01049                                            1049
*           GOTO RRSCNEND;          /* UPDATE BCB & SCB              */
*RRUPDATE:                                                         1051
*         RRFOUND='1'B;             /* INDICATE END OF BUFFER        */
RRUPDATE OI    RRFOUND,B'10000000'                                 1051
*       END;                                                       1052
         AL    RRTXTPTR,@CF00077                                   1052
@DE01044 L     @03,@PC00016+4                                      1052
         L     @15,@PC00016+4                                      1052
         L     @03,RRTXTCUR(,@03)                                  1052
         AL    @03,RRBYTLFT(,@15)                                  1052
         BCTR  @03,0                                               1052
         CR    RRTXTPTR,@03                                        1052
         BNH   @DL01044                                            1052
*     ELSE                          /* SKIP UP TO COMMA,BLANK,COMMENT
*                                      OR RIGHT PAREN                */
*       DO RRTXTPTR=RRTXTCUR TO RRTXTCUR+RRBYTLFT-ONE;             1053
         B     @RC01043                                            1053
@RF01043 L     @15,@PC00016+4                                      1053
         L     RRTXTPTR,RRTXTCUR(,@15)                             1053
         B     @DE01053                                            1053
@DL01053 DS    0H                                                  1054
*         IF RRCHAR(1:1)=','|RRCHAR(1:1)=' '|RRCHAR(1:1)=')'/*     1054
*                                      COMMA,BLANK OR RIGHT PAREN?   */
*           THEN                    /* STOP SCAN                     */
         CLI   RRCHAR(RRTXTPTR),C','                               1054
         BE    @RT01054                                            1054
         CLI   RRCHAR(RRTXTPTR),C' '                               1054
         BE    @RT01054                                            1054
         CLI   RRCHAR(RRTXTPTR),C')'                               1054
         BE    @RT01054                                            1054
*           GOTO RRSCNEND;          /* UPDATE BCB & SCB              */
*         IF RRTXTPTR=RRTXTCUR+RRBYTLFT-ONE THEN/* REACH END OF    1056
*                                      BUFFER?                       */
         L     @03,@PC00016+4                                      1056
         L     @15,RRTXTCUR(,@03)                                  1056
         AL    @15,RRBYTLFT(,@03)                                  1056
         BCTR  @15,0                                               1056
         CR    RRTXTPTR,@15                                        1056
         BE    @RT01056                                            1056
*           GOTO RRUPDAT2;          /* MOVE IN ERROR TEXT            */
*         IF RRCHAR(1:2)=RRCOMBEG THEN/* BEGINNING OF A COMMENT?     */
         CLC   RRCHAR(2,RRTXTPTR),RRCOMBEG                         1058
         BE    @RT01058                                            1058
*           GOTO RRSCNEND;          /* UPDATE BCB & SCB              */
*RRUPDAT2:                                                         1060
*         RRFOUND='1'B;             /* INDICATE END OF BUFFER        */
RRUPDAT2 OI    RRFOUND,B'10000000'                                 1060
*       END;                                                       1061
         AL    RRTXTPTR,@CF00077                                   1061
@DE01053 L     @03,@PC00016+4                                      1061
         L     @15,@PC00016+4                                      1061
         L     @03,RRTXTCUR(,@03)                                  1061
         AL    @03,RRBYTLFT(,@15)                                  1061
         BCTR  @03,0                                               1061
         CR    RRTXTPTR,@03                                        1061
         BNH   @DL01053                                            1061
*RRSCNEND:                                                         1062
*     ;                             /* UPDATE POINTER TO INPUT       */
@RC01043 DS    0H                                                  1062
RRSCNEND DS    0H                                                  1063
*     RRBYTLFT=RRBYTLFT-(RRTXTPTR-RRTXTCUR);/* NUMBER OF BYTES LEFT  */
         L     @03,@PC00016+4                                      1063
         LR    @15,RRTXTPTR                                        1063
         SL    @15,RRTXTCUR(,@03)                                  1063
         LCR   @15,@15                                             1063
         AL    @15,RRBYTLFT(,@03)                                  1063
         ST    @15,RRBYTLFT(,@03)                                  1063
*     RRTXTCUR=RRTXTPTR;            /* UPDATE CURRENT TEXT PTR       */
         ST    RRTXTPTR,RRTXTCUR(,@03)                             1064
*     IF RRBYTLFT^=ZERO THEN        /* AT END OF BUFFER?             */
         LTR   @15,@15                                             1065
         BZ    @RF01065                                            1065
*       RRFINISH='1'B;              /* INDICATE SO                   */
         OI    RRFINISH,B'10000000'                                1066
*RRENDLOP:                                                         1067
*     ;                             /* COMPLETED SCAN FOR ERROR      */
@RF01065 DS    0H                                                  1067
RRENDLOP DS    0H                                                  1068
*   END;                                                           1068
@DE01031 TM    RRFINISH,B'10000000'                                1068
         BZ    @DL01031                                            1068
*   IF RRFOUND='0'B THEN            /* NO TEXT SKIPPED?              */
         TM    RRFOUND,B'10000000'                                 1069
         BNZ   @RF01069                                            1069
*     RETURN CODE(4);               /* RETURN UNSUCCESSFUL           */
         LA    @15,4                                               1070
         L     @14,@SA00016                                        1070
         LM    @00,@12,@SA00016+8                                  1070
         BR    @14                                                 1070
*   ELSE                            /* MOVE IN MORE TEXT FOR CLARITY */
*     RETURN CODE(0);               /* RETURN SUCCESSFUL             */
@RF01069 SLR   @15,@15                                             1071
         L     @14,@SA00016                                        1071
         LM    @00,@12,@SA00016+8                                  1071
         BR    @14                                                 1071
*   END MFRRERR;                                                   1072
*                                                                  1073
*/*  PROCEDURE NAME = MFFREBUF                                       */
*/*                                                                  */
*/*  DESCRIPTIVE NAME = FREE UP BUFFERS AND BCBS                     */
*/*                                                                  */
*/*  FUNCTION = THIS ROUTINE FREES UP BUFFERS AND BCBS NO LONGER     */
*/*             NEEDED IN SCANNING AN INPUT SOURCE. A CODE IS PASSED */
*/*              TO THIS ROUTINE TO INDICATE WHETHER ALL BUFFERS AND */
*/*              BCBS ARE TO BE FREED OR FREE ONLY UP TO CURRENT ONE */
*/*                                                                  */
*                                                                  1073
*MFFREBUF:                                                         1073
*   PROCEDURE(FRFRECOD,FRSCB);                                     1073
MFFREBUF STM   @14,@12,@SA00017                                    1073
         MVC   @PC00017(8),0(@01)                                  1073
*   DECLARE                                                        1074
*     FRFRECOD                      /* FREE CODE - 0=FREE ALL BCB'S
*                                      AND BUFFERS. 4=FREE UP TO   1074
*                                      CURRENT BCB AND BUFFER        */
*         FIXED(31),                                               1074
*                                                                  1074
*/*  SCAN CONTROL BLOCK                                              */
*                                                                  1074
*     1 FRSCB,                      /* SCAN CONTROL BLOCK            */
*      2 FRCURBCB                   /* CURRENT BCB PTR               */
*            PTR(31),                                              1074
*      2 FRCURTXT                   /* CURRENT TEXT PTR              */
*            PTR(31),                                              1074
*      2 FRBYTLFT                   /* # BYTES LEFT                  */
*            FIXED(31),                                            1074
*     FRFREBCB                      /* BCB TO FREE                   */
*         PTR(31),                                                 1074
*                                                                  1074
*/*  SUBPOOL INFORMATION                                             */
*                                                                  1074
*     1 FRBCBCOR                    /* FREEMAIN PARAMETERS           */
*           BDY(WORD),                                             1074
*      2 FRSUBPOL                   /* SUBPOOL                       */
*            FIXED(8),                                             1074
*      2 FRBCBLEN                   /* LENGTH                        */
*            FIXED(24),                                            1074
*     FRCONTRL                      /* CONTROL FOR DO GROUP          */
*         PTR(31);                                                 1074
*   FRSUBPOL=ZERO;                  /* SUPOOL 0                      */
         MVI   FRSUBPOL,X'00'                                      1075
*   IF FRFRECOD=ZERO|INBCBFRS=ZERO THEN/* FREE ALL BUFFERS AND BCBS
*                                      OR NONE TO FREE?              */
         SLR   @15,@15                                             1076
         L     @14,@PC00017                                        1076
         C     @15,FRFRECOD(,@14)                                  1076
         BE    @RT01076                                            1076
         C     @15,INBCBFRS                                        1076
         BNE   @RF01076                                            1076
@RT01076 DS    0H                                                  1077
*     FRCONTRL=ZERO;                                               1077
         SLR   FRCONTRL,FRCONTRL                                   1077
*   ELSE                            /* FREE UP TO CURRENT            */
*     FRCONTRL=FRCURBCB;                                           1078
         B     @RC01076                                            1078
@RF01076 L     @15,@PC00017+4                                      1078
         L     FRCONTRL,FRCURBCB(,@15)                             1078
*   DO WHILE INBCBFRS^=FRCONTRL;                                   1079
@RC01076 B     @DE01079                                            1079
@DL01079 DS    0H                                                  1080
*     FRBCBLEN=INBCBFRS->INBCBLEN;  /* BUFFER LENGTH                 */
         L     @15,INBCBFRS                                        1080
         LH    @14,INBCBLEN(,@15)                                  1080
         STCM  @14,7,FRBCBLEN                                      1080
*     RFY                                                          1081
*      (GPR00F,                                                    1081
*       GPR01P,                                                    1081
*       GPR14F,                                                    1081
*       GPR15F) RSTD;                                              1081
*     GPR00F=FRBCBCOR;              /* SUBPOOL & LENGTH              */
         L     GPR00F,FRBCBCOR                                     1082
*     GPR01P=INBCBFRS->INBCBTXT;    /* ADDRESS OF BUFFER TO FREE     */
         L     @07,INBCBFRS                                        1083
         L     GPR01P,INBCBTXT(,@07)                               1083
*     GEN(FREEMAIN R,LV=(0),A=(1)); /* FREE BUFFER                   */
         FREEMAIN R,LV=(0),A=(1)
*     FRFREBCB=INBCBFRS;            /* SAVE BCB TO BE FREED          */
         L     @07,INBCBFRS                                        1085
         LR    FRFREBCB,@07                                        1085
*     INBCBFRS=INBCBFRS->INBCBNXT;  /* FIRST = NEXT BCB              */
         L     @07,INBCBNXT(,@07)                                  1086
         ST    @07,INBCBFRS                                        1086
*     FRBCBLEN=LENGTH(INBCB);       /* BCB LENGTH                    */
         MVC   FRBCBLEN(3),@CF02027+1                              1087
*     GPR00F=FRBCBCOR;              /* SUBPOOL & LENGTH              */
         L     GPR00F,FRBCBCOR                                     1088
*     GPR01P=FRFREBCB;              /* ADDRESS OF BCB TO FREE        */
         LR    GPR01P,FRFREBCB                                     1089
*     GEN(FREEMAIN R,LV=(0),A=(1)); /* FREE BCB                      */
         FREEMAIN R,LV=(0),A=(1)
*     RFY                                                          1091
*      (GPR00F,                                                    1091
*       GPR01P,                                                    1091
*       GPR14F,                                                    1091
*       GPR15F) UNRSTD;                                            1091
*   END;                                                           1092
@DE01079 C     FRCONTRL,INBCBFRS                                   1092
         BNE   @DL01079                                            1092
*   IF FRFRECOD=ZERO THEN           /* FREE ALL?                     */
         SLR   @15,@15                                             1093
         L     @14,@PC00017                                        1093
         C     @15,FRFRECOD(,@14)                                  1093
         BNE   @RF01093                                            1093
*     DO;                                                          1094
*       INBCBLST=ADDR(INBCBFRS);    /* LAST BCB = ADDR(FIRST)        */
         LA    @14,INBCBFRS                                        1095
         ST    @14,INBCBLST                                        1095
*       FRCURBCB=ADDR(INBCBFRS);    /* SCB INITIAL CONDITION         */
         L     @07,@PC00017+4                                      1096
         ST    @14,FRCURBCB(,@07)                                  1096
*       FRCURTXT=ZERO;              /* SCB INITIAL CONDITION         */
         ST    @15,FRCURTXT(,@07)                                  1097
*       FRBYTLFT=ZERO;              /* SCB INITIAL CONDITION         */
         ST    @15,FRBYTLFT(,@07)                                  1098
*     END;                                                         1099
*   RETURN;                         /* RETURN TO CALLER              */
@EL00017 DS    0H                                                  1100
@EF00017 DS    0H                                                  1100
@ER00017 LM    @14,@12,@SA00017                                    1100
         BR    @14                                                 1100
*   END MFFREBUF;                                                  1101
         B     @EL00017                                            1101
*                                                                  1102
*/*  PROCEDURE NAME = MFBUFENQ                                       */
*/*                                                                  */
*/*  DESCRIPTIVE NAME = BUFFER ENQUEING ROUTINE                      */
*/*                                                                  */
*/*  FUNCTION = THIS ROUTINE QUEUES UP THE BCBS. EACH BCB POINTS TO  */
*/*             A BUFFER CONTAINING TEXT PASSED FROM CALLING ROUTINE.*/
*/*             AS A RESULT OF QUEUEING BUFFERS AND BCBS, THE SCB AND*/
*/*             BQCB ARE UPDATED ACCORDINGLY.                        */
*/*                                                                  */
*/*                                                                  */
*                                                                  1102
*MFBUFENQ:                                                         1102
*   PROCEDURE(BUBUFTXT,BUBUFSZE,BUSCB);                            1102
MFBUFENQ STM   @14,@12,@SA00018                                    1102
         MVC   @PC00018(12),0(@01)                                 1102
*   DECLARE                                                        1103
*     BUBUFTXT                      /* TEXT TO BE PLACED IN BUFFER   */
*         CHAR(*),                                                 1103
*     BUBUFSZE                      /* LENGTH OF TEXT                */
*         FIXED(31),                                               1103
*                                                                  1103
*/*  SCAN CONTROL BLOCK                                              */
*                                                                  1103
*     1 BUSCB,                      /* SCAN CONTROL BLOCK            */
*      2 BUCURBCB                   /* CURRENT BCB PTR               */
*            PTR(31),                                              1103
*      2 BUCURTXT                   /* CURRENT TEXT PTR              */
*            PTR(31),                                              1103
*      2 BUBYTLFT                   /* # BYTES LEFT                  */
*            FIXED(31),                                            1103
*                                                                  1103
*/*  SUBPOOL INFORMATION                                             */
*                                                                  1103
*     1 BUBCBCOR                    /* GETMAIN PARAMETERS            */
*           BDY(WORD),                                             1103
*      2 BUSUBPOL                   /* SUBPOOL                       */
*            FIXED(8),                                             1103
*      2 BUBUFLEN                   /* LENGTH                        */
*            FIXED(24),                                            1103
*     BUBCBARA                      /* PTR TO GOTTEN AREA FOR BCB    */
*         PTR(31);                                                 1103
*                                                                  1103
*   /*****************************************************************/
*   /*                                                               */
*   /* GET CORE FOR A BCB                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1104
*   BUSUBPOL=ZERO;                                                 1104
         MVI   BUSUBPOL,X'00'                                      1104
*   BUBUFLEN=LENGTH(INBCB);                                        1105
         MVC   BUBUFLEN(3),@CF02027+1                              1105
*   RFY                                                            1106
*    (GPR00F,                                                      1106
*     GPR01P,                                                      1106
*     GPR14P,                                                      1106
*     GPR15F) RSTD;                                                1106
*   GPR00F=BUBCBCOR;                /* SET UP SUBPOOL ID AND LENGTH
*                                      IN REG0                       */
         L     GPR00F,BUBCBCOR                                     1107
*   GEN(GETMAIN R,LV=(0));          /* GET CORE FOR BCB              */
         GETMAIN R,LV=(0)
*   BUBCBARA=GPR01P;                /* GET ADDRESS OF THE GOTTEN CORE*/
         LR    BUBCBARA,GPR01P                                     1109
*   RFY                                                            1110
*    (GPR00F,                                                      1110
*     GPR01P,                                                      1110
*     GPR14P,                                                      1110
*     GPR15F) UNRSTD;                                              1110
*   IF INBCBFRS=ZERO THEN           /* IF THIS BCB IS 1ST ON THE   1111
*                                      CHAIN                         */
         L     @03,INBCBFRS                                        1111
         LTR   @03,@03                                             1111
         BNZ   @RF01111                                            1111
*     DO;                           /* INDICATE THIS IN THE BQCB     */
*       INBCBFRS=BUBCBARA;          /* FIRST = GOTTEN AREA           */
         ST    BUBCBARA,INBCBFRS                                   1113
*       INBCBLST=INBCBFRS;          /* FIRST BCB IS LAST BCB ON CHAIN*/
         L     @03,INBCBFRS                                        1114
         ST    @03,INBCBLST                                        1114
*     END;                                                         1115
*   ELSE                            /* IF A BCB ALREADY EXISTS       */
*     DO;                                                          1116
         B     @RC01111                                            1116
@RF01111 DS    0H                                                  1117
*       INBCBLST->INBCBNXT=BUBCBARA;/* NEXT BCB IS THIS NEW BCB      */
         L     @03,INBCBLST                                        1117
         ST    BUBCBARA,INBCBNXT(,@03)                             1117
*       INBCBLST=BUBCBARA;          /* THIS BCB IS LAST ON CHAIN     */
         ST    BUBCBARA,INBCBLST                                   1118
*     END;                                                         1119
*   BUBCBARA->INBCBNXT=ZERO;        /* INDICATES LAST BCB            */
@RC01111 SLR   @03,@03                                             1120
         ST    @03,INBCBNXT(,BUBCBARA)                             1120
*   BUBCBARA->INBCBLEN=BUBUFSZE;    /* INITIALIZE BCB BUFFER LENGTH  */
         L     @03,@PC00018+4                                      1121
         L     @03,BUBUFSZE(,@03)                                  1121
         STH   @03,INBCBLEN(,BUBCBARA)                             1121
*   BUBCBARA->INBCBTXT=ADDR(BUBUFTXT);/* POINT BCB TO BUFFER         */
         L     @03,@PC00018                                        1122
         ST    @03,INBCBTXT(,BUBCBARA)                             1122
*   BUCURBCB=BUBCBARA;              /* CURRENT BCB IS THIS BCB       */
         L     @15,@PC00018+8                                      1123
         ST    BUBCBARA,BUCURBCB(,@15)                             1123
*   BUCURTXT=ADDR(BUBUFTXT);        /* CURRENT INPUT STRING NOT    1124
*                                      SCANNED IS ENTIRE INPUT STRING*/
         ST    @03,BUCURTXT(,@15)                                  1124
*   BUBYTLFT=IPDATALN;              /* LENGTH OF DATA FIELD          */
         MVC   BUBYTLFT(4,@15),@CF01232                            1125
*   RETURN;                         /* RETURN TO CALLER              */
@EL00018 DS    0H                                                  1126
@EF00018 DS    0H                                                  1126
@ER00018 LM    @14,@12,@SA00018                                    1126
         BR    @14                                                 1126
*   END MFBUFENQ;                                                  1127
*                                                                  1128
*/*  PROCEDURE NAME = MFNXTREC                                       */
*/*                                                                  */
*/*  DESCRIPTIVE NAME = GET THE NEXT SEQUENTIAL RECORD OF AN INPUT   */
*/*                     SOURCE                                       */
*/*                                                                  */
*/*  FUNCTION = THIS ROUTINE RETRIEVES THE NEXT SEQUENTIAL RECORD OF */
*/*             AN INPUT SOURCE. IF NONE EXIST, IT RETURNS UNSUCCESS-*/
*/*             FUL TO CALLER.                                       */
*/*                                                                  */
*                                                                  1128
*MFNXTREC:                                                         1128
*   PROCEDURE(NXSCB);                                              1128
MFNXTREC STM   @14,@12,@SA00019                                    1128
         MVC   @PC00019(4),0(@01)                                  1128
*   DECLARE                                                        1129
*                                                                  1129
*/*  SCAN CONTROL BLOCK                                              */
*                                                                  1129
*     1 NXSCB,                      /* SCAN CONTROL BLOCK            */
*      2 NXCURBCB                   /* CURRENT BCB PTR               */
*            PTR(31),                                              1129
*      2 NXCURTXT                   /* CURRENT TEXT PTR              */
*            PTR(31),                                              1129
*      2 NXBYTLFT                   /* # BYTES LEFT                  */
*            FIXED(31),                                            1129
*                                                                  1129
*/*  SUBPOOL INFORMATION                                             */
*                                                                  1129
*     1 NXFRECOR BDY(WORD),         /* GETMAIN PARAMETERS            */
*      2 NXSUBPOL                   /* SUBPOOL                       */
*            FIXED(8),                                             1129
*      2 NXLEN                      /* LENGTH                        */
*            FIXED(24),                                            1129
*     NXFOUND BIT(1),               /* RECORD FOUND BIT              */
*     NXLENGTH                      /* LENGTH OF TEXT IN A RECORD    */
*         FIXED(31),                                               1129
*     NXTEXT                        /* TEXT IN RECORD                */
*         CHAR(*) BASED(NXTEXPTR),                                 1129
*     NXTEXPTR                      /* PTR TO RECORD                 */
*         PTR(31),                                                 1129
*     NXSUCCES                      /* SUCCESSFUL RETURN             */
*         FIXED(31) CONSTANT(0),                                   1129
*     NXUNSUCC                      /* UNSUCCESSFUL RETURN           */
*         FIXED(31) CONSTANT(4);                                   1129
*   IF NXCURBCB=INBCBLST THEN       /* LAST BCB ON CHAIN?            */
         L     @15,@PC00019                                        1130
         CLC   NXCURBCB(4,@15),INBCBLST                            1130
         BNE   @RF01130                                            1130
*     DO;                           /* YES                           */
*       NXFOUND='0'B;                                              1132
         NI    NXFOUND,B'01111111'                                 1132
*       CALL IRARMRDR(NXTEXPTR,NXLENGTH,NXFRECOR,DAPTR);/* READ IN A
*                                      RECORD                @Z40BPEM*/
         LA    @15,NXTEXPTR                                        1133
         ST    @15,@AL00001                                        1133
         LA    @15,NXLENGTH                                        1133
         ST    @15,@AL00001+4                                      1133
         LA    @15,NXFRECOR                                        1133
         ST    @15,@AL00001+8                                      1133
         L     @15,@PC00001+8                                      1133
         ST    @15,@AL00001+12                                     1133
         L     @15,@CV01276                                        1133
         LA    @01,@AL00001                                        1133
         BALR  @14,@15                                             1133
*       RFY                                                        1134
*        (GPR15F) RSTD;                                            1134
*       IF GPR15F=NXSUCCES THEN     /* WAS READ OK?                  */
         LTR   GPR15F,GPR15F                                       1135
         BNZ   @RF01135                                            1135
*         DO;                       /* YES                           */
*           RFY                                                    1137
*            (GPR15F) UNRSTD;                                      1137
*           NXFOUND='1'B;           /* A RECORD WAS RETRIEVED        */
         OI    NXFOUND,B'10000000'                                 1138
*           CALL MFBUFENQ(NXTEXT,NXLENGTH,NXSCB);/* SET UP BUFFER &
*                                      BCB                           */
         L     @01,NXTEXPTR                                        1139
         ST    @01,@AL00001                                        1139
         LA    @15,NXLENGTH                                        1139
         ST    @15,@AL00001+4                                      1139
         L     @15,@PC00019                                        1139
         ST    @15,@AL00001+8                                      1139
         LA    @01,@AL00001                                        1139
         BAL   @14,MFBUFENQ                                        1139
*         END;                                                     1140
*       IF NXFOUND='1'B THEN        /* RECORD RETRIEVED?             */
@RF01135 TM    NXFOUND,B'10000000'                                 1141
         BNO   @RF01141                                            1141
*         RETURN CODE(NXSUCCES);    /* RETURN SUCCESSFUL             */
         SLR   @15,@15                                             1142
         L     @14,@SA00019                                        1142
         LM    @00,@12,@SA00019+8                                  1142
         BR    @14                                                 1142
*       ELSE                        /* END OF FILE                   */
*         RETURN CODE(NXUNSUCC);    /* RETURN UNSUCCESSFUL           */
@RF01141 LA    @15,4                                               1143
         L     @14,@SA00019                                        1143
         LM    @00,@12,@SA00019+8                                  1143
         BR    @14                                                 1143
*     END;                                                         1144
*   NXCURBCB=NXCURBCB->INBCBNXT;    /* POINT CURRENT TO NEXT BCB     */
@RF01130 L     @15,@PC00019                                        1145
         L     @01,NXCURBCB(,@15)                                  1145
         L     @14,INBCBNXT(,@01)                                  1145
         ST    @14,NXCURBCB(,@15)                                  1145
*   NXCURTXT=NXCURBCB->INBCBTXT;    /* CURRENT TEXT UPDATED          */
         L     @14,INBCBTXT(,@14)                                  1146
         ST    @14,NXCURTXT(,@15)                                  1146
*   NXBYTLFT=IPDATALN;              /* LENGTH OF DATA FIELD          */
         MVC   NXBYTLFT(4,@15),@CF01232                            1147
*   RETURN CODE(NXSUCCES);          /* RETURN SUCCESSFUL             */
         SLR   @15,@15                                             1148
         L     @14,@SA00019                                        1148
         LM    @00,@12,@SA00019+8                                  1148
         BR    @14                                                 1148
*   END MFNXTREC;                                                  1149
*   GENERATE DATA DEFS(OPSYNTAB) REFS(MFRBLANK,MFRTEXT,MFRRERR,MFRINTGR
*       ,RMOPINIT);                                                1150
*   GENERATE DATA DEFS(IPSYNTAB) REFS(MFRBLANK,MFRTEXT,MFRRERR,MFRINTGR
*       ,RMIPINIT);                                                1151
*   END IRARMIPS                                                   1152
*                                                                  1152
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IRARMCT )                                       */
*/*%INCLUDE SYSLIB  (IRAWMST )                                       */
*/*%INCLUDE SYSLIB  (IRARMPT )                                       */
*/*%INCLUDE SYSLIB  (IRAWPGDT)                                       */
*/*%INCLUDE SYSLIB  (IRAWPODT)                                       */
*/*%INCLUDE SYSLIB  (IRADMDT )                                       */
*/*%INCLUDE SYSUT5  (RMFREIPS)                                       */
*/*%INCLUDE SYSUT5  (RMOPT   )                                       */
*/*%INCLUDE SYSUT5  (MFSOURCE)                                       */
*/*%INCLUDE SYSUT5  (OPSYNTAB)                                       */
*/*%INCLUDE SYSUT5  (IPSYNTAB)                                       */
*                                                                  1152
*       ;                                                          1152
         B     @EL00001                                            1152
@DATA    DS    0H
@CH01345 DC    H'42'
@CH01629 DC    H'1000'
@CH01273 DC    AL2(65535)
@SC02047 CLC   RTSCANER(0,@14),RTTEXT(@07)
         DS    0F
@AL00120 DC    A(ERRCWKL)              LIST WITH   1 ARGUMENT(S)
@AL00127 DC    A(ERRCRPG)              LIST WITH   1 ARGUMENT(S)
@AL00133 DC    A(ERRCDMN)              LIST WITH   1 ARGUMENT(S)
@AL00478 DC    A(ERRCSTS)              LIST WITH   1 ARGUMENT(S)
@AL00641 DC    A(ERRCOBJ)              LIST WITH   1 ARGUMENT(S)
@AL00654 DC    A(ERRCDUR)              LIST WITH   1 ARGUMENT(S)
@AL00702 DC    A(ERRCINP)              LIST WITH   1 ARGUMENT(S)
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    6F
@SA00017 DS    15F
@PC00017 DS    2F
@SA00006 DS    15F
@PC00006 DS    1F
@SA00003 DS    15F
@PC00003 DS    3F
@SA00009 DS    15F
@PC00009 DS    1F
@SA00004 DS    15F
@PC00004 DS    3F
@SA00002 DS    15F
@PC00002 DS    2F
@SA00005 DS    15F
@PC00005 DS    5F
@SA00010 DS    15F
@PC00010 DS    3F
@PC00007 DS    1F
@PC00008 DS    1F
@SA00011 DS    15F
@PC00011 DS    1F
@SA00012 DS    15F
@PC00012 DS    1F
@SA00013 DS    15F
@PC00013 DS    2F
@SA00019 DS    15F
@PC00019 DS    1F
@SA00014 DS    15F
@PC00014 DS    2F
@SA00015 DS    15F
@PC00015 DS    2F
@SA00016 DS    15F
@PC00016 DS    2F
@SA00018 DS    15F
@PC00018 DS    3F
@AL00001 DS    5A
@TF00001 DS    F
@AFTEMPS DS    3F
IRARMIPS CSECT
         DS    0F
@CF00044 DC    F'0'
@CF00077 DC    F'1'
@CH00077 EQU   @CF00077+2
@CF00118 DC    F'2'
@CH00118 EQU   @CF00118+2
@CF00082 DC    F'3'
@CH00082 EQU   @CF00082+2
@CF00054 DC    F'4'
@CF00095 DC    F'6'
@CF01119 DC    F'7'
@CF00046 DC    F'8'
@CF01214 DC    F'9'
@CF01216 DC    F'10'
@CH01216 EQU   @CF01216+2
@CF02027 DC    F'12'
@CH02027 EQU   @CF02027+2
@CF00073 DC    F'15'
@CF01251 DC    F'20'
@CH01251 EQU   @CF01251+2
@CF00135 DC    F'32'
@CF00224 DC    F'64'
@CF01232 DC    F'72'
@CF01218 DC    F'99'
@CF02023 DC    F'112'
@CF01243 DC    F'128'
@CF02025 DC    F'130'
@CF01249 DC    F'140'
@CF01229 DC    F'255'
@CF02026 DC    F'258'
@CF01263 DC    F'500'
@CF02024 DC    F'512'
@CF01651 DC    F'999'
@CF01245 DC    F'2048'
@CF01259 DC    F'4096'
@CF01642 DC    F'9999'
@CF01257 DC    F'32000'
@CF01271 DC    F'32768'
@CF01269 DC    F'65536'
@CF01500 DC    F'999999'
@CF01655 DC    F'1000000'
@CF01647 DC    F'999999999'
@CF02029 DC    F'-12'
@CF02035 DC    F'-8'
@CF02036 DC    F'-4'
@CF02034 DC    XL4'0000FFFF'
@DATD    DSECT
         DS    0D
WMSTPTR  DS    A
RMPTPTR  DS    A
WPGDPTR  DS    A
WPGPPTR  DS    A
WPODPTR  DS    A
DMDTPTR  DS    A
DMN1PTR  DS    A
OBJ0PT3  DS    A
IPERRCOL DS    F
INWKARPT DS    A
INRCODE  DS    F
WPGVPTR  DS    A
WPOVPTR  DS    A
DMVTPTR  DS    A
TOTSIZE  DS    F
NEWMST   DS    A
IPWAMCOF DS    F
IPWINT1  DS    F
IPWINT2  DS    F
IPWPGN   DS    F
IPWOBJ   DS    F
IPWDMN   DS    F
IPTBASZE DS    F
IPWMSTLN DS    F
IPWNPODS DS    F
OPWRFCI  DS    F
OPCPARMN DS    F
OPCPMASK DS    F
OPWARYPT DS    A
OPWRMPPT DS    A
LENTH    DS    F
DUMMYPTR DS    A
IPCKOEPT DS    F
IPWSLP   DS    F
IPWDURMB DS    F
CSTMB    DS    F
DMNMB    DS    F
IPMPGEND DS    F
RITEMNUM DS    F
NXLENGTH DS    F
NXTEXPTR DS    A
IPREADAD DS    A
IPWPGNHI DS    H
IPWOBJHI DS    H
IPWPGPTC DS    H
IPWWLLO  DS    H
DMNTOTC  DS    H
DMNHI    DS    H
PGTOTALC DS    H
PGP1DMN  DS    H
WORKLO   DS    H
WLLI     DS    H
IPWWKLD  DS    H
IPWWKLZ  DS    H
IPWSRVC  DS    H
IPWINDX  DS    H
IPWS     DS    H
IPWWKLI  DS    H
IPWWKLC  DS    H
IPWPGPC  DS    H
IPWPGLCT DS    H
PERCNTHI DS    H
IPWFLGS  DS    FL1
         ORG   IPWFLGS
IPWFIPER DS    BL1
IPWAMWKL EQU   IPWFLGS+0
IPWERWKL EQU   IPWFLGS+0
IPWERSRV EQU   IPWFLGS+0
IPWDUPG  EQU   IPWFLGS+0
@NM00030 EQU   IPWFLGS+0
         ORG   IPWFLGS+1
DMNSTATS DS    FL1
         ORG   DMNSTATS
ERRDMN   DS    BL1
PGPDMNOP EQU   DMNSTATS+0
DMNDEF   EQU   DMNSTATS+0
@NM00031 EQU   DMNSTATS+0
         ORG   DMNSTATS+1
PREVPDMN DS    FL1
IPWPGPM  DS    FL1
         ORG   IPWPGPM
IPWPMOBJ DS    BL1
IPWPMDUR EQU   IPWPGPM+0
IPWPMISV EQU   IPWPGPM+0
IPWPMRTB EQU   IPWPGPM+0
IPWPMUNT EQU   IPWPGPM+0
IPWPMDMN EQU   IPWPGPM+0
IPWPMAPG EQU   IPWPGPM+0
@NM00038 EQU   IPWPGPM+0
         ORG   IPWPGPM+1
WHOLENO  DS    CL2
FRACTION DS    CL1
         DS    CL1
IPMSGLTA DS    CL88
IPMSGIPA DS    CL88
OPCATMK  DS    BL4
INEXTSRC DS    BL1
         DS    CL3
INBQ     DS    CL12
         ORG   INBQ
INBCBNAM DS    CL4
INBCBFRS DS    AL4
INBCBLST DS    AL4
         ORG   INBQ+12
INSCB    DS    CL12
         ORG   INSCB
INCURBCB DS    AL4
INTXTCUR DS    AL4
INBYTLFT DS    FL4
         ORG   INSCB+12
INDUMITM DS    CL12
         ORG   INDUMITM
INIFLAGS DS    CL4
         ORG   INIFLAGS
INENDITM DS    BL1
INSTRM   EQU   INIFLAGS+0
@NM00034 EQU   INIFLAGS+0
         ORG   INDUMITM+4
INRECSTR DS    AL4
INIPARM  DS    AL4
         ORG   INDUMITM+12
         DS    CL4
IPTRTRST DS    CL8
DIGIT1   DS    CL1
DIGIT2   DS    CL1
OPTERV   DS    CL6
RIINTDEC DS    CL1
RIINTFND DS    BL1
RBFINISH DS    BL1
RBFOUND  DS    BL1
RRFINISH DS    BL1
RRFOUND  DS    BL1
         DS    CL2
FRBCBCOR DS    CL4
         ORG   FRBCBCOR
FRSUBPOL DS    FL1
FRBCBLEN DS    FL3
         ORG   FRBCBCOR+4
BUBCBCOR DS    CL4
         ORG   BUBCBCOR
BUSUBPOL DS    FL1
BUBUFLEN DS    FL3
         ORG   BUBCBCOR+4
NXFRECOR DS    CL4
         ORG   NXFRECOR
NXSUBPOL DS    FL1
NXLEN    DS    FL3
         ORG   NXFRECOR+4
NXFOUND  DS    BL1
         DS    CL3
IPWPGL   DS    17F
IPWPGLP  DS    17AL1
         DS    CL1
WLLFSRV0 DS    65AL2
OPWRFCVL DS    2F
OPWRMCVL DS    1F
OPWCTGTB DS    CL12
         ORG   OPWCTGTB+0
OPWCRMPP DS    AL4
OPWCARYP DS    AL4
OPWCMASK DS    FL4
         ORG   OPWCTGTB+36
ININTPTR DS    5A
INERRPTR DS    1A
IPWSRV   DS    32H
IPWORK   DS    32AL2
IPWWKL   DS    32AL1
CNSTRVAL DS    3AL1
IRARMIPS CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CA01542 DC    A(IRARMFRE)
@CV01276 DC    V(IRARMRDR)
@CV01277 DC    V(IRARMWTR)
@CV01278 DC    V(IRBMFANL)
@CA01279 DC    A(SIZDATD)
         DS    0D
MAXPGDTS DC    AL4(255*140+140+20)
MAXPODTS DC    AL4(64*35*4+3*4)
MAXDMDTS DC    AL4(128*20+20)
CLEAR    DC    F'0'
SUBPL245 DC    XL4'F5000000'
INFREBUF DC    AL4(MFFREBUF)
SUBPN245 DC    XL4'F5000000'
INRCURNO DC    H'9'
NEGSRV   DC    H'-32768'
ERRCINP  DC    AL1(1)
ERRCWKL  DC    AL1(2)
ERRCRPG  DC    AL1(3)
ERRCDUR  DC    AL1(4)
ERRCOBJ  DC    AL1(5)
ERRCDMN  DC    AL1(6)
ERRCSTS  DC    AL1(7)
BASEISVP DC    AL1(WPGDISV-WPGD)
@CC01275 DC    C'WMST'
@CC01534 DC    C'BCB '
DEFSCOEF DC    CL4' 1.0'
IPMSGCTX DC    CL20'IPS MEMBER IEAIPSXX '
WPG0     DS    CL20
         ORG   WPG0
WPG0PGN  DC    AL1(0)
WPG0SIZ  DC    AL1(WPG0END-WPG0-1)
WPG0R02  DC    AL1(0)
WPG0DFL  DC    X'00'
WPG0ATM  DC    A(32000)
WPG0ISV  DC    F'0'
WPG0PGP  DS    CL8
         ORG   WPG0PGP
WPG0OBJN DC    AL1(0)
WPG0DMN  DC    AL1(0)
@NM00029 DC    X'00'
         DC    XL1'0'
WPG0APGV DC    AL1(11)
WPG0INDS DC    B'10000000'
WPG0ISVP DC    AL1(WPG0ISV-WPG0)
WPG0DURP DC    AL1(0)
         ORG   WPG0+20
WPG0END  DS    0C
         ORG   WPG0+20
DMD0     DS    CL20
         ORG   DMD0
DMD0NO   DC    AL1(0)
DMD0LO   DC    AL1(255)
DMD0HI   DC    AL1(255)
DMD0WT   DC    AL1(1)
DMD0MPLT DC    H'255'
DMD0GOOU DC    H'0'
DMD0CMPL DC    H'0'
DMD0OUTU DC    H'0'
DMD0INCU DC    H'0'
DMD0RUA  DC    H'0'
DMD0RUC  DC    F'0'
         ORG   DMD0+20
DMD1     DS    CL20
         ORG   DMD1
DMD1NO   DC    AL1(1)
DMD1LO   DC    AL1(1)
DMD1HI   DC    AL1(255)
DMD1WT   DC    AL1(1)
DMD1MPLT DC    H'1'
DMD1GOOU DC    H'0'
DMD1CMPL DC    H'0'
DMD1OUTU DC    H'0'
DMD1INCU DC    H'0'
DMD1RUA  DC    H'0'
DMD1RUC  DC    F'0'
         ORG   DMD1+20
DEFRFCV  DC    CL3'0.1'
DEFERV   DC    CL6'     1'
         DS    CL1
MAXSRVPT DS    CL4
         ORG   MAXSRVPT
@NM00035 DC    H'32767'
@NM00036 DC    AL2(0)
         ORG   MAXSRVPT+4
         DS    CL2
DEFWPGP  DS    CL8
         ORG   DEFWPGP
DPGPOBJN DC    AL1(0)
DPGPDMN  DC    AL1(1)
@NM00037 DC    CL2' '
DPGPAPGV DC    AL1(0)
DPGPINDS DC    B'00000000'
DPGPISVP DC    XL1'01'
DPGPDURP DC    AL1(0)
         ORG   DEFWPGP+8
DEFDMDE  DS    CL20
         ORG   DEFDMDE
DMDNO    DC    AL1(1)
DMDLO    DC    AL1(1)
DMDHI    DC    AL1(255)
DMDWT    DC    AL1(1)
DMDMPLT  DC    H'1'
DMDGOOU  DC    H'0'
DMDCMPL  DC    H'0'
DMDOUTU  DC    H'0'
DMDINCU  DC    H'0'
DMDRUA   DC    H'0'
DMDRUC   DC    F'0'
         ORG   DEFDMDE+20
IPFZONE  DC    X'0F'
IPZERO   DC    X'F0'
IPBLANK  DC    X'40'
         DS    CL1
IPMASKTB DC    A(1)
         DC    A(2)
         DC    A(4)
IPMSGID  DC    CL8'IRA300I '
         DC    CL8'IRA301I '
IPMSGTXT DC    CL42'INPUT ERROR NEAR COLUMN NN.  TEXT FOLLOWS:'
         DC    CL42'MISSING WORKLOAD LEVELS'
         DC    CL42'MISSING REQUIRED PERF GRP NNN'
         DC    CL42'MISSING PERF GRP NNN DURATION'
         DC    CL42'MISSING PERF GRP NNN OBJECTIVE'
         DC    CL42'MISSING DOMAINS IN FIRST PER OF PERF GRPS'
         DC    CL42'MISSING DOMAIN NNN CONSTRAINT VALUE(S)'
OBJ0ARAY DS    CL4
         ORG   OBJ0ARAY+0
OBJ0SRV  DC    H'32767'
OBJ0WLL  DC    AL2(0)
         ORG   OBJ0ARAY+4
         ORG   OBJ0ARAY+4
         DC    H'0'
         DC    AL2(49152)
         ORG   OBJ0ARAY+8
         ORG   OBJ0ARAY+8
         DC    H'-32768'
         DC    AL2(0)
         ORG   OBJ0ARAY+12
         DS    CL2
OPMASKTB DC    A(1)
         DC    A(2)
         DC    A(4)
OPCPARMT DC    AL1(0)
         DC    AL1(2)
         DC    AL1(1)
         DS    CL1
IPBRTAB  DC    AL4(RMIP001)
         DC    AL4(RMIP002)
         DC    AL4(RMIP003)
         DC    AL4(RMIP004)
         DC    AL4(RMIP005)
         DC    AL4(RMIP006)
         DC    AL4(RMIP007)
         DC    AL4(RMIP008)
         DC    AL4(RMIP009)
         DC    AL4(RMIP010)
         DC    AL4(RMIP011)
         DC    AL4(RMIP012)
         DC    AL4(RMIP013)
         DC    AL4(RMIP014)
         DC    AL4(RMIP015)
         DC    AL4(RMIP016)
         DC    AL4(RMIP017)
         DC    AL4(RMIP018)
         DC    AL4(RMIP019)
         DC    AL4(RMIP020)
         DC    AL4(RMIP021)
         DC    AL4(RMIP022)
         DC    AL4(RMIP023)
         DC    AL4(RMIP024)
         DC    AL4(RMIP025)
         DC    AL4(RMIP026)
         DC    AL4(RMIP027)
         DC    AL4(RMIP028)
         DC    AL4(RMIP029)
         DC    AL4(RMIP030)
         DC    AL4(RMIP031)
PDURMASK DC    A(1)
         DC    A(2)
         DC    A(4)
         DC    A(8)
         DC    A(16)
         DC    A(32)
         DC    A(64)
         DC    A(128)
PDMNMASK DC    A(1)
         DC    A(2)
         DC    A(4)
         DC    A(8)
         DC    A(16)
         DC    A(32)
         DC    A(64)
         DC    A(128)
DCSTMASK DC    A(1)
         DC    A(2)
         DC    A(4)
OPBRTAB  DC    AL4(RMOP001)
         DC    AL4(RMOP002)
         DC    AL4(RMOP003)
         DC    AL4(RMOP004)
         DC    AL4(RMOP005)
         DC    AL4(RMOP006)
         DC    AL4(RMOP007)
IRARMIPS CSECT
RMIPSPCH DC    25F'0'
IRARMIPS CSECT
IPTRTUNP UNPK  0(,R15),IPTRTRST
IRARMIPS CSECT
RBCOMBEG DC    C'/*'                     START OF COMMENT DELIMITER
RBCOMEND DC     C'*/'                    END OF COMMENT DELIMITER
IRARMIPS CSECT
*                                     /* COMMENT DELIMITER */
RRCOMBEG DC    C'/*'                     DELIMITER FOR COMMENT
IRARMIPS CSECT
**********************************************************************
*                         OPT SYNTAX TABLE                           *
*     (SYNTAX TABLE FOR THE RESOURCES MANAGER PARAMETER LIST)        *
*     OPT SYNTAX IN BACKUS NORMAL FORM:                              *
*                                                                    *
*     <INPUT>      ::= B <INPUTOPT> |                                *
*                      <INPUT> <DELIM> <INPUTOPT>                    *
*                                                                    *
*     <INPUTOPT>   ::= <RFC> B1 <RFCOPTION> |                        *
*                      <RMC> B1 <RMCOPTION> |                        *
*                      <RFC> |                                       *
*                      <RMC> |                                       *
*                      E                                             *
*                                                                    *
*     <RFC>        ::= RFC                                           *
*                                                                    *
*     <RMC>        ::= RMC                                           *
*                                                                    *
*     <RFCOPTION>  ::= <RFCKEY> <EQ> V . V |                         *
*                      <RFCOPTION> <DELIM> <RFCKEY> <EQ> V . V       *
*                                                                    *
*     <RMCOPTION>  ::= ERV <EQ> V                                    *
*                                                                    *
*     <RFCKEY>     ::= CPU |                                         *
*                      IOC                                           *
*                                                                    *
*     <EQ>         ::= B = B                                         *
*                                                                    *
*     <DELIM>      ::= B , B |                                       *
*                      B1                                            *
*                                                                    *
*     V - INTEGER                                                    *
*                                                                    *
*     B - SKIP BLANKS                                                *
*                                                                    *
*     E - SKIP INPUT UNTIL A BLANK, A COMMA OR END OF INPUT          *
*                                                                    *
**********************************************************************
OPSYNTAB DS    0F
*     <INPUT>                                                        *
OP000000 MFSYSTR 1,OP000100,OP000200
OP000100 MFSYALT 1,OP000101,0,0
OP000101 MFSYITM 0,MFRBLANK,1,IPBLNK
         MFSYITM 1,OP010000,0,0
OP000200 MFSYALT 1,OP000201,0,0
OP000201 MFSYITM 0,IPDL0000,0,0
         MFSYITM 1,OP010000,0,0
*     <INPUTOPT>                                                     *
OP010000 MFSYSTR 0,OP010100,0
OP010100 MFSYALT 0,OP010101,0,0
         MFSYALT 0,OP010102,0,0
         MFSYALT 0,OP010103,0,0
         MFSYALT 0,OP010104,0,0
         MFSYALT 1,OP010105,RMOPINIT,IPGRC001
OP010101 MFSYITM 0,OP020000,0,0
         MFSYITM 0,MFRBLANK,1,IPBLNK1
         MFSYITM 1,OP040000,0,0
OP010102 MFSYITM 0,OP030000,0,0
         MFSYITM 0,MFRBLANK,1,IPBLNK1
         MFSYITM 1,OP050000,0,0
OP010103 MFSYITM 1,OP020000,0,0
OP010104 MFSYITM 1,OP030000,0,0
OP010105 MFSYITM 1,MFRRERR,1,IPERR
*     <RFC>                                                          *
OP020000 MFSYSTR 0,OP020100,0
OP020100 MFSYALT 1,OP020101,RMOPINIT,IPGRC002
OP020101 MFSYITM 1,MFRTEXT,1,OPSYMRFC
*     <RMC>                                                          *
OP030000 MFSYSTR 0,OP030100,0
OP030100 MFSYALT 1,OP030101,RMOPINIT,IPGRC003
OP030101 MFSYITM 1,MFRTEXT,1,OPSYMRMC
*     <RFCOPTION>                                                    *
OP040000 MFSYSTR 0,OP040100,OP040200
OP040100 MFSYALT 1,OP040101,RMOPINIT,IPGRC004
OP040200 MFSYALT 1,OP040201,RMOPINIT,IPGRC004
OP040101 MFSYITM 0,OP060000,0,0
         MFSYITM 0,IPEQ0000,0,0
         MFSYITM 0,MFRINTGR,1,IPINT001
         MFSYITM 0,MFRTEXT,1,IPSYMPER
         MFSYITM 1,MFRINTGR,1,IPINT002
OP040201 MFSYITM 0,IPDL0000,0,0
         MFSYITM 0,OP060000,0,0
         MFSYITM 0,IPEQ0000,0,0
         MFSYITM 0,MFRINTGR,1,IPINT001
         MFSYITM 0,MFRTEXT,1,IPSYMPER
         MFSYITM 1,MFRINTGR,1,IPINT002
*     <RMCOPTION>                                                    *
OP050000 MFSYSTR 0,OP050100,0
OP050100 MFSYALT 1,OP050101,RMOPINIT,IPGRC005
OP050101 MFSYITM 0,MFRTEXT,1,OPSYMERV
         MFSYITM 0,IPEQ0000,0,0
         MFSYITM 1,MFRINTGR,1,IPINT001
*     <RFCKEY>                                                       *
OP060000 MFSYSTR 0,OP060100,0
OP060100 MFSYALT 0,OP060101,RMOPINIT,IPGRC006
         MFSYALT 1,OP060102,RMOPINIT,IPGRC007
OP060101 MFSYITM 1,MFRTEXT,1,IPSYMCPU
OP060102 MFSYITM 1,MFRTEXT,1,IPSYMIOC
*     PARAMETER LISTS FOR MFRTEXT PROCEDURE                          *
*     PARAMETERS FOR MFRTEXT -                                       *
*       (1) A 1-BYTE FIELD CONTAINING THE LENGTH OF THE TEXT TO BE   *
*           MATCHED                                                  *
*       (2) THE TEXT IN EBCDIC                                       *
OPSYMRFC DC    FL1'3'
         DC    CL3'RFC'                  KEYWORD=RFC
OPSYMRMC DC    FL1'3'
         DC    CL3'RMC'                  KEYWORD=RMC
OPSYMERV DC    FL1'3'
         DC    CL3'ERV'                  KEYWORD=ERV
OPSYNTE  DS    0F
IRARMIPS CSECT
**********************************************************************
*                         IPS SYNTAX TABLE                           *
*    (SYNTAX TABLE FOR THE INSTALLATION PERFORMANCE SPECIFICATION)   *
*    IPS SYNTAX IN BACKUS NORMAL FORM:                               *
*                                                                    *
*    <INPUT>       ::= B <INPUTOPT> |                                *
*                      <INPUT> <DELIM> <INPUTOPT> |                  *
*                      <INPUT> E                                     *
*                                                                    *
*    <INPUTOPT>    ::= <KEY1> <EQ> V . V |                           *
*                      WKL <EQ> ( B <WKLLIST> <COMBLK> ) |           *
*                      <OBJ> <DELIM> SRV <EQ> ( B <SRATE>            *
*                        <COMBLK> ) |                                *
*                      <DMN> <DELIM> <CONSTRAINTS> |         @Z40BPEM*
*                      <DMN>  |                              @Z40BPEM*
*                      <PGN> <DELIM> <PERIODLIST> |                  *
*                      E |                                           *
*                      B                                             *
*                                                                    *
*    <KEY1>        ::= CPU |                                         *
*                      IOC |                                         *
*                      MSO                                           *
*                                                                    *
*    <WKLLIST>     ::= V |                                           *
*                      <WKLLIST> <DELIM> V |                         *
*                      <WKLLIST> <DELIM> E1                          *
*                                                                    *
*    <SRATE>       ::= V |                                           *
*                      <SRATE> <DELIM> V |                           *
*                      <SRATE> <DELIM> * |                           *
*                      <SRATE> <DELIM> E1                            *
*                                                                    *
*    <CONSTRAINTS> ::= CNSTR <EQ> ( B <MINOPT> <DELIM>       @Z40BPEM*
*                        <MAXOPT> <DELIM> <WTOPT> <COMBLK> ) @Z40BPEM*
*                                                                    *
*    <MINOPT>      ::= V |                                   @Z40BPEM*
*                      E1 |                                  @Z40BPEM*
*                      B                                     @Z40BPEM*
*                                                            @Z40BPEM*
*    <MAXOPT>      ::= V |                                   @Z40BPEM*
*                      E1 |                                  @Z40BPEM*
*                      B                                     @Z40BPEM*
*                                                            @Z40BPEM*
*    <WTOPT>       ::= V |                                   @Z40BPEM*
*                      E1 |                                  @Z40BPEM*
*                      B                                     @Z40BPEM*
*                                                                    *
*    <PERIODLIST>  ::= <PERIOD> |                                    *
*                      <PERIODLIST> <DELIM> <PERIOD>                 *
*                                                                    *
*    <PERIOD>      ::= ( B <OPTIONLIST> )                            *
*                                                                    *
*    <OPTIONLIST>  ::= <OPTION> |                                    *
*                      <OPTIONLIST> <DELIM> <OPTION>                 *
*                                                                    *
*    <OPTION>      ::= OBJ <EQ> V |                          @Z40BPEM*
*                      DUR <EQ> V K |                                *
*                      DUR <EQ> V |                                  *
*                      ISV <EQ> V K |                                *
*                      ISV <EQ> V |                                  *
*                      DMN <EQ> V |                          @Z40BPEM*
*                      RTB <EQ> V |                                  *
*                      UNT <EQ> S |                                  *
*                      UNT <EQ> R |                                  *
*                      APG <EQ> V |                                  *
*                      E1 |                                          *
*                      B                                             *
*                                                                    *
*    <PGN>         ::= PGN <EQ> V                                    *
*                                                                    *
*    <OBJ>         ::= OBJ <EQ> V                                    *
*                                                                    *
*    <DMN>         ::= DMN <EQ> V                            @Z40BPEM*
*                                                                    *
*    <EQ>          ::= B = B                                         *
*                                                                    *
*    <DELIM>       ::= B , B |                                       *
*                      B1                                            *
*                                                                    *
*    <COMBLK>      ::= B , B |                                       *
*                      B |                                           *
*                      <COMBLK> B , B                                *
*                                                                    *
*    V - INTEGER                                                     *
*                                                                    *
*    B - SKIP BLANKS                                                 *
*                                                                    *
*    B1 - SEARCH FOR AT LEAST ONE BLANK                              *
*                                                                    *
*    E - SKIP INPUT UNTIL A BLANK, A COMMA OR END OF INPUT           *
*                                                                    *
*    E1 - SKIP INPUT UNTIL A BLANK, A COMMA, A ) OR END OF INPUT     *
*                                                                    *
**********************************************************************
IPSYNTAB DS    0F
*    <INPUT>                                                         *
IP000000 MFSYSTR 1,IP000100,IP000200
IP000100 MFSYALT 1,IP000101,0,0
IP000101 MFSYITM 0,MFRBLANK,1,IPBLNK
         MFSYITM 1,IP010000,0,0
IP000200 MFSYALT 0,IP000201,0,0
         MFSYALT 1,IP000202,RMIPINIT,IPGRC029               @ZA14986
IP000201 MFSYITM 0,IPDL0000,0,0
         MFSYITM 1,IP010000,0,0
IP000202 MFSYITM 1,MFRRERR,1,IPERR
*    <INPUTOPT>                                                      *
IP010000 MFSYSTR 0,IP010100,0
IP010100 MFSYALT 0,IP010101,RMIPINIT,IPGRC004
         MFSYALT 0,IP010102,RMIPINIT,IPGRC007
         MFSYALT 0,IP010103,RMIPINIT,IPGRC011
         MFSYALT 0,IP010104,RMIPINIT,IPGRC016                @Z40BPEM*
         MFSYALT 0,IP010105,RMIPINIT,IPGRC016                @Z40BPEM*
         MFSYALT 0,IP010106,RMIPINIT,IPGRC028                @Z40BPEM*
         MFSYALT 0,IP010107,RMIPINIT,IPGRC029                @Z40BPEM*
         MFSYALT 1,IP010108,0,0                              @Z40BPEM*
IP010101 MFSYITM 0,IP020000,0,0
         MFSYITM 0,IPEQ0000,0,0
         MFSYITM 0,MFRINTGR,1,IPINT001
         MFSYITM 0,MFRTEXT,1,IPSYMPER
         MFSYITM 1,MFRINTGR,1,IPINT002
IP010102 MFSYITM 0,MFRTEXT,1,IPSYMWKL
         MFSYITM 0,IPEQ0000,0,0
         MFSYITM 0,MFRTEXT,1,IPSYMLPR
         MFSYITM 0,MFRBLANK,1,IPBLNK
         MFSYITM 0,IP030000,0,0
         MFSYITM 0,IPCB0000,0,0
         MFSYITM 1,MFRTEXT,1,IPSYMRPR
IP010103 MFSYITM 0,IP110000,0,0
         MFSYITM 0,IPDL0000,0,0
         MFSYITM 0,MFRTEXT,1,IPSYMSRV
         MFSYITM 0,IPEQ0000,0,0
         MFSYITM 0,MFRTEXT,1,IPSYMLPR
         MFSYITM 0,MFRBLANK,1,IPBLNK
         MFSYITM 0,IP040000,0,0
         MFSYITM 0,IPCB0000,0,0
         MFSYITM 1,MFRTEXT,1,IPSYMRPR
IP010104 MFSYITM 0,IP120000,0,0                              @Z40BPEM*
         MFSYITM 0,IPDL0000,0,0                              @Z40BPEM*
         MFSYITM 1,IP046000,0,0                              @Z40BPEM*
IP010105 MFSYITM 1,IP120000,0,0                            @Z40BPEM*
IP010106 MFSYITM 0,IP100000,0,0                              @Z40BPEM*
         MFSYITM 0,IPDL0000,0,0
         MFSYITM 1,IP050000,0,0
IP010107 MFSYITM 1,MFRRERR,1,IPERR                           @Z40BPEM*
IP010108 MFSYITM 1,MFRBLANK,1,IPBLNK                         @Z40BPEM*
*    <KEY1>                                                          *
IP020000 MFSYSTR 0,IP020100,0
IP020100 MFSYALT 0,IP020101,RMIPINIT,IPGRC001
         MFSYALT 0,IP020102,RMIPINIT,IPGRC002
         MFSYALT 1,IP020103,RMIPINIT,IPGRC003
IP020101 MFSYITM 1,MFRTEXT,1,IPSYMCPU
IP020102 MFSYITM 1,MFRTEXT,1,IPSYMIOC
IP020103 MFSYITM 1,MFRTEXT,1,IPSYMMSO
*    <WKLLIST>                                                       *
IP030000 MFSYSTR 0,IP030100,IP030200
IP030100 MFSYALT 1,IP030101,RMIPINIT,IPGRC005
IP030101 MFSYITM 1,MFRINTGR,1,IPINT001
IP030200 MFSYALT 0,IP030201,RMIPINIT,IPGRC006
         MFSYALT 1,IP030202,RMIPINIT,IPGRC029               @ZA14986
IP030201 MFSYITM 0,IPDL0000,0,0
         MFSYITM 1,MFRINTGR,1,IPINT001
IP030202 MFSYITM 0,IPDL0000,0,0
         MFSYITM 1,MFRRERR,1,IPERR1
*    <SRATE>                                                         *
IP040000 MFSYSTR 0,IP040100,IP040200
IP040100 MFSYALT 1,IP040101,RMIPINIT,IPGRC009
IP040101 MFSYITM 1,MFRINTGR,1,IPINT001
IP040200 MFSYALT 0,IP040201,RMIPINIT,IPGRC009
         MFSYALT 0,IP040202,RMIPINIT,IPGRC010
         MFSYALT 1,IP040203,RMIPINIT,IPGRC029
IP040201 MFSYITM 0,IPDL0000,0,0
         MFSYITM 1,MFRINTGR,1,IPINT001
IP040202 MFSYITM 0,IPDL0000,0,0
         MFSYITM 1,MFRTEXT,1,IPSYMAST
IP040203 MFSYITM 0,IPDL0000,0,0
         MFSYITM 1,MFRRERR,1,IPERR1
*    <CONSTRAINTS>                                           @Z40BPEM*
IP046000 MFSYSTR 0,IP046100,0                                @Z40BPEM*
IP046100 MFSYALT 1,IP046101,RMIPINIT,IPGRC030                @Z40BPEM*
IP046101 MFSYITM 0,MFRTEXT,1,IPSYMCST                        @Z40BPEM*
         MFSYITM 0,IPEQ0000,0,0                              @Z40BPEM*
         MFSYITM 0,MFRTEXT,1,IPSYMLPR                        @Z40BPEM*
         MFSYITM 0,MFRBLANK,1,IPBLNK                         @Z40BPEM*
         MFSYITM 0,IP047000,0,0                              @Z40BPEM*
         MFSYITM 0,IPDL0000,0,0                              @Z40BPEM*
         MFSYITM 0,IP048000,0,0                              @Z40BPEM*
         MFSYITM 0,IPDL0000,0,0                              @Z40BPEM*
         MFSYITM 0,IP049000,0,0                              @Z40BPEM*
         MFSYITM 0,IPCB0000,0,0                              @Z40BPEM*
         MFSYITM 1,MFRTEXT,1,IPSYMRPR                        @Z40BPEM*
*    <MINOPT>                                                @Z40BPEM*
IP047000 MFSYSTR 0,IP047100,0                                @Z40BPEM*
IP047100 MFSYALT 0,IP047101,RMIPINIT,IPGRC013                @Z40BPEM*
         MFSYALT 0,IP047102,RMIPINIT,IPGRC029                @Z40BPEM*
         MFSYALT 1,IP047103,0,0                              @Z40BPEM*
IP047101 MFSYITM 1,MFRINTGR,1,IPINT001                       @Z40BPEM*
IP047102 MFSYITM 1,MFRRERR,1,IPERR1                          @Z40BPEM*
IP047103 MFSYITM 1,MFRBLANK,1,IPBLNK                         @Z40BPEM*
*    <MAXOPT>                                                @Z40BPEM*
IP048000 MFSYSTR 0,IP048100,0                                @Z40BPEM*
IP048100 MFSYALT 0,IP048101,RMIPINIT,IPGRC014                @Z40BPEM*
         MFSYALT 0,IP048102,RMIPINIT,IPGRC029                @Z40BPEM*
         MFSYALT 1,IP048103,0,0                              @Z40BPEM*
IP048101 MFSYITM 1,MFRINTGR,1,IPINT001                       @Z40BPEM*
IP048102 MFSYITM 1,MFRRERR,1,IPERR1                          @Z40BPEM*
IP048103 MFSYITM 1,MFRBLANK,1,IPBLNK                         @Z40BPEM*
*    <WTOPT>                                                 @Z40BPEM*
IP049000 MFSYSTR 0,IP049100,0                                @Z40BPEM*
IP049100 MFSYALT 0,IP049101,RMIPINIT,IPGRC015                @Z40BPEM*
         MFSYALT 0,IP049102,RMIPINIT,IPGRC029                @Z40BPEM*
         MFSYALT 1,IP049103,0,0                              @Z40BPEM*
IP049101 MFSYITM 1,MFRINTGR,1,IPINT001                       @Z40BPEM*
IP049102 MFSYITM 1,MFRRERR,1,IPERR1                          @Z40BPEM*
IP049103 MFSYITM 1,MFRBLANK,1,IPBLNK                         @Z40BPEM*
*    <PERIODLIST>                                                    *
IP050000 MFSYSTR 0,IP050100,IP050200
IP050100 MFSYALT 1,IP050101,0,0
IP050101 MFSYITM 1,IP060000,0,0
IP050200 MFSYALT 1,IP050201,0,0
IP050201 MFSYITM 0,IPDL0000,0,0
         MFSYITM 1,IP060000,0,0
*    <PERIOD>                                                        *
IP060000 MFSYSTR 0,IP060100,0
IP060100 MFSYALT 1,IP060101,RMIPINIT,IPGRC027                @Z40BPEM*
IP060101 MFSYITM 0,MFRTEXT,1,IPSYMLPR
         MFSYITM 0,MFRBLANK,1,IPBLNK
         MFSYITM 0,IP080000,0,0
         MFSYITM 1,MFRTEXT,1,IPSYMRPR
*    <OPTIONLIST>                                                    *
IP080000 MFSYSTR 0,IP080100,IP080200
IP080100 MFSYALT 1,IP080101,0,0
IP080101 MFSYITM 1,IP090000,0,0
IP080200 MFSYALT 1,IP080201,0,0
IP080201 MFSYITM 0,IPDL0000,0,0
         MFSYITM 1,IP090000,0,0
*    <OPTION>                                                        *
IP090000 MFSYSTR 0,IP090100,0
IP090100 MFSYALT 0,IP090101,RMIPINIT,IPGRC018                @Z40BPEM*
         MFSYALT 0,IP090102,RMIPINIT,IPGRC019                @Z40BPEM*
         MFSYALT 0,IP090103,RMIPINIT,IPGRC020                @Z40BPEM*
         MFSYALT 0,IP090104,RMIPINIT,IPGRC021                @Z40BPEM*
         MFSYALT 0,IP090105,RMIPINIT,IPGRC022                @Z40BPEM*
         MFSYALT 0,IP090106,RMIPINIT,IPGRC023                @Z40BPEM*
         MFSYALT 0,IP090107,RMIPINIT,IPGRC024                @Z40BPEM*
         MFSYALT 0,IP090108,RMIPINIT,IPGRC025                @Z40BPEM*
         MFSYALT 0,IP090109,RMIPINIT,IPGRC026                @Z40BPEM*
         MFSYALT 0,IP090112,RMIPINIT,IPGRC031                @Z40BPEM*
         MFSYALT 0,IP090110,RMIPINIT,IPGRC029                @Z40BPEM*
         MFSYALT 1,IP090111,0,0                              @Z40BPEM*
IP090101 MFSYITM 0,MFRTEXT,1,IPSYMOBJ                        @Z40BPEM*
         MFSYITM 0,IPEQ0000,0,0                              @Z40BPEM*
         MFSYITM 1,MFRINTGR,1,IPINT004                       @Z40BPEM*
IP090102 MFSYITM 0,MFRTEXT,1,IPSYMDUR
         MFSYITM 0,IPEQ0000,0,0
         MFSYITM 0,MFRINTGR,1,IPINT001
         MFSYITM 1,MFRTEXT,1,IPSYMK
IP090103 MFSYITM 0,MFRTEXT,1,IPSYMDUR
         MFSYITM 0,IPEQ0000,0,0
         MFSYITM 1,MFRINTGR,1,IPINT001
IP090104 MFSYITM 0,MFRTEXT,1,IPSYMISV
         MFSYITM 0,IPEQ0000,0,0
         MFSYITM 0,MFRINTGR,1,IPINT001
         MFSYITM 1,MFRTEXT,1,IPSYMK
IP090105 MFSYITM 0,MFRTEXT,1,IPSYMISV
         MFSYITM 0,IPEQ0000,0,0
         MFSYITM 1,MFRINTGR,1,IPINT001
IP090106 MFSYITM 0,MFRTEXT,1,IPSYMDMN                        @Z40BPEM*
         MFSYITM 0,IPEQ0000,0,0                              @Z40BPEM*
         MFSYITM 1,MFRINTGR,1,IPINT005                       @Z40BPEM*
IP090107 MFSYITM 0,MFRTEXT,1,IPSYMRTB                        @Z40BPEM*
         MFSYITM 0,IPEQ0000,0,0
         MFSYITM 1,MFRINTGR,1,IPINT001
IP090108 MFSYITM 0,MFRTEXT,1,IPSYMUNT                        @Z40BPEM*
         MFSYITM 0,IPEQ0000,0,0
         MFSYITM 1,MFRTEXT,1,IPSYMS
IP090109 MFSYITM 0,MFRTEXT,1,IPSYMUNT                        @Z40BPEM*
         MFSYITM 0,IPEQ0000,0,0
         MFSYITM 1,MFRTEXT,1,IPSYMR
IP090110 MFSYITM 1,MFRRERR,1,IPERR1                          @Z40BPEM*
IP090111 MFSYITM 1,MFRBLANK,1,IPBLNK                         @Z40BPEM*
IP090112 MFSYITM 0,MFRTEXT,1,IPSYMAPG                        @Z40BPEM*
         MFSYITM 0,IPEQ0000,0,0                              @Z40BPEM*
         MFSYITM 1,MFRINTGR,1,IPINT001                       @Z40BPEM*
*    <PGN>                                                           *
IP100000 MFSYSTR 0,IP100100,0
IP100100 MFSYALT 1,IP100101,RMIPINIT,IPGRC017                @Z40BPEM*
IP100101 MFSYITM 0,MFRTEXT,1,IPSYMPGN
         MFSYITM 0,IPEQ0000,0,0
         MFSYITM 1,MFRINTGR,1,IPINT003
*    <OBJ>                                                           *
IP110000 MFSYSTR 0,IP110100,0
IP110100 MFSYALT 1,IP110101,RMIPINIT,IPGRC008
IP110101 MFSYITM 0,MFRTEXT,1,IPSYMOBJ
         MFSYITM 0,IPEQ0000,0,0
         MFSYITM 1,MFRINTGR,1,IPINT004
*    <DMN>                                                   @Z40BPEM*
IP120000 MFSYSTR 0,IP120100,0                                @Z40BPEM*
IP120100 MFSYALT 1,IP120101,RMIPINIT,IPGRC012                @Z40BPEM*
IP120101 MFSYITM 0,MFRTEXT,1,IPSYMDMN                        @Z40BPEM*
         MFSYITM 0,IPEQ0000,0,0                              @Z40BPEM*
         MFSYITM 1,MFRINTGR,1,IPINT005                       @Z40BPEM*
*    <EQ>                                                            *
IPEQ0000 MFSYSTR 0,IPEQ0100,0
IPEQ0100 MFSYALT 1,IPEQ0101,0,0
IPEQ0101 MFSYITM 0,MFRBLANK,1,IPBLNK
         MFSYITM 0,MFRTEXT,1,IPSYMEQ
         MFSYITM 1,MFRBLANK,1,IPBLNK
*    <DELIM>                                                         *
IPDL0000 MFSYSTR 0,IPDL0100,0
IPDL0100 MFSYALT 0,IPDL0101,0,0
         MFSYALT 1,IPDL0102,0,0
IPDL0101 MFSYITM 0,MFRBLANK,1,IPBLNK
         MFSYITM 0,MFRTEXT,1,IPSYMCOM
         MFSYITM 1,MFRBLANK,1,IPBLNK
IPDL0102 MFSYITM 1,MFRBLANK,1,IPBLNK1
*    <COMBLK>                                                        *
IPCB0000 MFSYSTR 0,IPCB0100,IPCB0200
IPCB0100 MFSYALT 0,IPCB0101,0,0
         MFSYALT 1,IPCB0102,0,0
IPCB0101 MFSYITM 0,MFRBLANK,1,IPBLNK
         MFSYITM 0,MFRTEXT,1,IPSYMCOM
         MFSYITM 1,MFRBLANK,1,IPBLNK
IPCB0102 MFSYITM 1,MFRBLANK,1,IPBLNK
IPCB0200 MFSYALT 1,IPCB0201,0,0
IPCB0201 MFSYITM 0,MFRBLANK,1,IPBLNK
         MFSYITM 0,MFRTEXT,1,IPSYMCOM
         MFSYITM 1,MFRBLANK,1,IPBLNK
*    PARAMETERS FOR RMIPINIT PROCEDURE                               *
*    THE PARAMETER IS USED TO INDEX INTO A BRANCH TABLE, SO THAT     *
*    CONTROL IS GIVEN TO THE APPROPRIATE ROUTINE TO PROCESS THE DATA *
IPGRC001 DC   FL1'1'
IPGRC002 DC   FL1'2'
IPGRC003 DC   FL1'3'
IPGRC004 DC   FL1'4'
IPGRC005 DC   FL1'5'
IPGRC006 DC   FL1'6'
IPGRC007 DC   FL1'7'
IPGRC008 DC   FL1'8'
IPGRC009 DC   FL1'9'
IPGRC010 DC   FL1'10'
IPGRC011 DC   FL1'11'
IPGRC012 DC   FL1'12'
IPGRC013 DC   FL1'13'
IPGRC014 DC   FL1'14'
IPGRC015 DC   FL1'15'
IPGRC016 DC   FL1'16'
IPGRC017 DC   FL1'17'
IPGRC018 DC   FL1'18'
IPGRC019 DC   FL1'19'
IPGRC020 DC   FL1'20'
IPGRC021 DC   FL1'21'
IPGRC022 DC   FL1'22'
IPGRC023 DC   FL1'23'
IPGRC024 DC   FL1'24'                                        @Z40BPEM*
IPGRC025 DC   FL1'25'                                        @Z40BPEM*
IPGRC026 DC   FL1'26'                                        @Z40BPEM*
IPGRC027 DC   FL1'27'                                        @Z40BPEM*
IPGRC028 DC   FL1'28'                                        @Z40BPEM*
IPGRC029 DC   FL1'29'                                        @Z40BPEM*
IPGRC030 DC   FL1'30'                                        @Z40BPEM*
IPGRC031 DC   FL1'31'                                        @Z40BPEM*
*    PARAMETERS FOR MFRINTGR PROCEDURE                               *
*    THE PARAMETER IS USED AS AN INDEX TO A TABLE WHICH CONTAINS     *
*    THE ADDRESS OF THE LOCATION WHERE THE INTEGER VALUE IS TO BE    *
*    STORED                                                          *
IPINT001 EQU   IPGRC001
IPINT002 EQU   IPGRC002
IPINT003 EQU   IPGRC003
IPINT004 EQU   IPGRC004
IPINT005 EQU   IPGRC005                                      @Z40BPEM*
*    PARAMETER LISTS FOR MFRTEXT PROCEDURE                           *
*    PARAMETERS FOR MFRTEXT -                                        *
*      (1) A 1-BYTE FIELD CONTAINING THE LENGTH OF THE TEXT TO BE    *
*          MATCHED                                                   *
*      (2) THE TEXT IN EBCDIC                                        *
IPSYMCPU DC   FL1'3'
         DC    CL3'CPU'                  KEYWORD=CPU
IPSYMIOC DC   FL1'3'
         DC    CL3'IOC'                  KEYWORD=IOC
IPSYMMSO DC   FL1'3'
         DC    CL3'MSO'                  KEYWORD=MSO
IPSYMWKL DC   FL1'3'
         DC    CL3'WKL'                  KEYWORD=WKL
IPSYMSRV DC   FL1'3'
         DC    CL3'SRV'                  KEYWORD=SRV
IPSYMOBJ DC   FL1'3'
         DC    CL3'OBJ'                  KEYWORD=OBJ
IPSYMDMN DC   FL1'3'                                         @Z40BPEM*
         DC    CL3'DMN'                  KEYWORD=DMN         @Z40BPEM*
IPSYMCST DC   FL1'5'                                         @Z40BPEM*
         DC    CL5'CNSTR'                KEYWORD=CNSTR       @Z40BPEM*
IPSYMAPG DC   FL1'3'                                         @Z40BPEM*
         DC    CL3'APG'                  KEYWORD=APG         @Z40BPEM*
IPSYMPGN DC   FL1'3'
         DC    CL3'PGN'                  KEYWORD=PGN
IPSYMDUR DC   FL1'3'
         DC    CL3'DUR'                  KEYWORD=DUR
IPSYMISV DC   FL1'3'
         DC    CL3'ISV'                  KEYWORD=ISV
IPSYMRTB DC   FL1'3'
         DC    CL3'RTB'                  KEYWORD=RTB
IPSYMUNT DC   FL1'3'
         DC    CL3'UNT'                  KEYWORD=UNT
IPSYMK   DC   FL1'1'
         DC    CL1'K'                    KEYWORD=K
IPSYMS   DC   FL1'1'
         DC    CL1'S'                    KEYWORD=S
IPSYMR   DC   FL1'1'
         DC    CL1'R'                    KEYWORD=R
IPSYMLPR DC   FL1'1'
         DC    CL1'('                    KEYWORD=(
IPSYMRPR DC   FL1'1'
         DC    CL1')'                    KEYWORD=)
IPSYMCOM DC   FL1'1'
         DC    CL1','                    KEYWORD=,
IPSYMPER DC   FL1'1'
         DC    CL1'.'                    KEYWORD=.
IPSYMAST DC   FL1'1'
         DC    CL1'*'                    KEYWORD=*
IPSYMEQ  DC   FL1'1'
         DC    CL1'='                    KEYWORD==
*    PARAMETER LISTS FOR MFRBLANK PROCEDURE                          *
IPBLNK   DC    AL.1(0)                   INDICATOR FOR SKIPPING ZERO
*                                        OR MORE BLANKS
IPBLNK1  DC    AL.1(1)                   INDICATOR FOR SKIPPING AT
*                                        LEAST 1 BLANK
*    PARAMETER LISTS FOR MFRRERR PROCEDURE                           *
IPERR    DC    AL.1(0)                   INDICATOR FOR SKIPPING TO
*                                        TO A BLANK, A COMMA OR EOF
         DC    FL1'0'                    RESERVED
         DC    FL1'0'                    RESERVED
IPERR1   DC    AL.1(1)                   INDICATOR FOR SKIPPING TO
*                                        A BLANK, A COMMA, A ) OR EOF
         DC    FL1'0'                    RESERVED
         DC    FL1'0'                    RESERVED
IPSYNTE  DS    0F
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IRARMIPS CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
BUBCBARA EQU   @02
FRCONTRL EQU   @02
FRFREBCB EQU   @03
RRERRSCN EQU   @02
RRTXTPTR EQU   @02
RBCOMENT EQU   @03
RBTXTPTR EQU   @02
RINUMBER EQU   @03
BLKHEADP EQU   @02
FRTBLCNT EQU   @03
IPTRTIND EQU   @02
CNSTRI   EQU   @02
IPWLOOPC EQU   @03
IPWPGLI  EQU   @02
IPWSLPP  EQU   @03
IPWWKLE  EQU   @02
IPWWKLS  EQU   @02
IPWISVL  EQU   @02
IPWDURVL EQU   @02
INDX     EQU   @02
CNSTRLB  EQU   @03
IPCKOTSZ EQU   @03
IPCKOTPT EQU   @02
TABLEPTR EQU   @03
J        EQU   @03
IPFMRSZE EQU   @02
IPGFQSZE EQU   @03
WORKHI   EQU   @03
LOOPC    EQU   @02
I        EQU   @02
MFRTPTR  EQU   @02
INWKARSZ EQU   @02
WPGLPTR  EQU   @03
RMCTPTR  EQU   @02
CODEREG1 EQU   @09
CODEREG2 EQU   @10
CODEREG3 EQU   @11
CODEREG4 EQU   @12
DATAREG1 EQU   @08
GPR00F   EQU   @00
GPR14F   EQU   @14
GPR15F   EQU   @15
GPR00P   EQU   @00
GPR01P   EQU   @01
GPR14P   EQU   @14
GPR15P   EQU   @15
R0       EQU   @00
R1       EQU   @01
R14      EQU   @14
R15      EQU   @15
RCODE    EQU   @15
GPR01F   EQU   @01
REG4     EQU   @04
         ENTRY INFREBUF
         EXTRN SIZDATD
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
FLCCVT   EQU   FLCICCW2
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIOQET EQU   CVTMAP+120
CVTIERLC EQU   CVTMAP+144
CVTHEAD  EQU   CVTMAP+160
CVTSV76C EQU   CVTHEAD
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
RMCT     EQU   0
RMCTRMPT EQU   RMCT+16
RMCTFLGS EQU   RMCT+148
WMST     EQU   0
WMSTNAME EQU   WMST
WMSTID   EQU   WMST+4
WMSTWLLO EQU   WMST+6
WMSTPGVT EQU   WMST+8
WMSTPGVS EQU   WMST+12
WMSTPGDT EQU   WMST+16
WMSTPGDS EQU   WMST+20
WMSTPOVT EQU   WMST+24
WMSTPOVS EQU   WMST+28
WMSTPODT EQU   WMST+32
WMSTPODS EQU   WMST+36
WMSTDMDT EQU   WMST+40
WMSTDMDS EQU   WMST+44
WMSTDMVT EQU   WMST+48
WMSTDMVS EQU   WMST+52
WMSTWLHI EQU   WMST+60
WMSTPGHI EQU   WMST+62
WMSTPGPC EQU   WMST+64
WMSTDMNC EQU   WMST+66
WMSTCPU  EQU   WMST+68
WMSTIOC  EQU   WMST+72
WMSTMSO  EQU   WMST+76
WMSTREAL EQU   WMST+80
WMSTIPC  EQU   WMST+100
RMPT     EQU   0
RMPTCPU  EQU   RMPT+4
RMPTERV  EQU   RMPT+12
RMPTIMN  EQU   RMPT+16
RMPTOPC  EQU   RMPT+60
RMPTOPE  EQU   RMPT+66
WPGD     EQU   0
WPGDPGN  EQU   WPGD
WPGDSIZ  EQU   WPGD+1
WPGDDFL  EQU   WPGD+3
WPGDATM  EQU   WPGD+4
WPGDISV  EQU   WPGD+8
WPGDPGP  EQU   WPGD+12
WPGDINDS EQU   WPGDPGP+5
WPGP     EQU   0
WPGPOBJN EQU   WPGP
WPGPDMN  EQU   WPGP+1
WPGPAPGV EQU   WPGP+4
WPGPINDS EQU   WPGP+5
WPGPFIN  EQU   WPGPINDS
WPGPUNT  EQU   WPGPINDS
WPGPAPG  EQU   WPGPINDS
WPGPRTB  EQU   WPGPINDS
WPGPISVP EQU   WPGP+6
WPGPDURP EQU   WPGP+7
WPGL     EQU   0
WPGLISV  EQU   WPGL
WPOD     EQU   0
WPOP     EQU   WPOD
WPOPSRV  EQU   WPOP
WPOPWKL  EQU   WPOP+2
WPOS     EQU   WPOD+4
DMDT     EQU   0
DMDTNO   EQU   DMDT
DMDTLO   EQU   DMDT+1
DMDTMPLT EQU   DMDT+4
IPINPUTS EQU   0
WPGVTENT EQU   0
WPOVTENT EQU   0
DMVTENT  EQU   0
OPWARRAY EQU   0
INBCB    EQU   0
INBCBNXT EQU   INBCB
INBCBLEN EQU   INBCB+4
INBCBTXT EQU   INBCB+8
IPBRINDX EQU   0
RMIPLBL  EQU   0
IPTRTBLK EQU   0
BLKHEAD  EQU   0
BLKPTR   EQU   BLKHEAD
BLKSZE   EQU   BLKHEAD+4
OPBRINDX EQU   0
RMOPLBL  EQU   0
RTPARMLS EQU   0
RTLENGTH EQU   RTPARMLS
RTTEXT   EQU   RTPARMLS+1
RTSCANER EQU   0
RIINTGER EQU   0
RINUMVAL EQU   0
RINUMCOD EQU   0
RBTYPBIT EQU   0
RBCHAR   EQU   0
RRPARMLS EQU   0
RRTYPE   EQU   RRPARMLS
RRSAVETX EQU   RRPARMLS+2
RRCHAR   EQU   0
NXTEXT   EQU   0
IKEBC    EQU   0
IKEBF15  EQU   0
IKEBF31  EQU   0
IKEBP15  EQU   0
IKEBP31  EQU   0
IKEBP8   EQU   0
MFOPINIT EQU   0
RRERRTXT EQU   0
IPIPSID  EQU   0
IPWMSTAD EQU   0
DAPTR    EQU   0
FRIPSPTR EQU   0
OPCATGER EQU   0
OPSTATUS EQU   0
OPIOERR  EQU   OPSTATUS
NEWAREA  EQU   0
SIZE     EQU   0
IPGMPPTR EQU   0
IPGMPSZE EQU   0
IPGFTPTR EQU   0
IPFMPPTR EQU   0
IPFMPSZE EQU   0
IPFMASZE EQU   0
IPCKCTPT EQU   0
IPCKCTSZ EQU   0
IPCKCEPT EQU   0
IPCKNXES EQU   0
IPCKMAXS EQU   0
IPCODEPT EQU   0
IPBPGLP  EQU   0
IPMPGLP  EQU   0
IPMSGNUM EQU   0
IPTRTNUM EQU   0
IPTRTDGT EQU   0
IPTRTADR EQU   0
FRWMSTPT EQU   0
OPCODEPT EQU   0
RTEXPARM EQU   0
RTSCB    EQU   0
RTCURTXT EQU   RTSCB+4
RTBYTLFT EQU   RTSCB+8
RISAVNUM EQU   0
RISCB    EQU   0
RICURBCB EQU   RISCB
RICURTXT EQU   RISCB+4
RIBYTLFT EQU   RISCB+8
RBTYPE   EQU   0
RBSCB    EQU   0
RBCURTXT EQU   RBSCB+4
RBBYTLFT EQU   RBSCB+8
RRPARM   EQU   0
RRSCB    EQU   0
RRCURBCB EQU   RRSCB
RRTXTCUR EQU   RRSCB+4
RRBYTLFT EQU   RRSCB+8
FRFRECOD EQU   0
FRSCB    EQU   0
FRCURBCB EQU   FRSCB
FRCURTXT EQU   FRSCB+4
FRBYTLFT EQU   FRSCB+8
BUBUFTXT EQU   0
BUBUFSZE EQU   0
BUSCB    EQU   0
BUCURBCB EQU   BUSCB
BUCURTXT EQU   BUSCB+4
BUBYTLFT EQU   BUSCB+8
NXSCB    EQU   0
NXCURBCB EQU   NXSCB
NXCURTXT EQU   NXSCB+4
NXBYTLFT EQU   NXSCB+8
PSARSVTE EQU   PSARSVT
CVTPTR   EQU   FLCCVT
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTOPCTP EQU   CVTS01+256
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
IPMSGCOM EQU   IPMSGLTA+8
IPMSGIPS EQU   IPMSGLTA+25
IPMSGTXA EQU   IPMSGLTA+28
IPMSGOPG EQU   IPMSGLTA+45
IPMSGCST EQU   IPMSGLTA+43
IPMSGDPG EQU   IPMSGLTA+45
IPMSGCOL EQU   IPMSGLTA+52
IPMSGRPG EQU   IPMSGLTA+54
IPMSGINP EQU   IPMSGIPA+8
IPWMCOEF EQU   WMSTCPU
CNSTRLST EQU   DMDTLO
REALIPSV EQU   WMSTIPC
INTGR1   EQU   REALIPSV
INTGR2   EQU   REALIPSV+3
TABARRAY EQU   WMST
TABADDR  EQU   TABARRAY
TABSIZE  EQU   TABARRAY+4
OPWINT1  EQU   IPWINT1
OPWINT2  EQU   IPWINT2
REALRFCV EQU   RMPTOPC
INT1     EQU   REALRFCV
INT2     EQU   REALRFCV+2
REALERV  EQU   RMPTOPE
IPWPGLPT EQU   IPWPGLP
FLC      EQU   PSA
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
DECPOINT EQU   REALRFCV+1
DECPT    EQU   REALIPSV+2
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTIHASU EQU   CVTS01+696
CVTSUSP  EQU   CVTS01+692
CVTT6SVC EQU   CVTS01+688
CVTCDAL  EQU   CVTS01+684
CVTTCTL  EQU   CVTS01+680
CVTRSUME EQU   CVTS01+676
CVTJTERM EQU   CVTS01+672
CVTASMRM EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTRV609 EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTHSM   EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
RBCURBCB EQU   RBSCB
RTCURBCB EQU   RTSCB
@NM00032 EQU   OPSTATUS
RRLENGTH EQU   RRPARMLS+1
@NM00039 EQU   RRPARMLS
@NM00033 EQU   INBCB+6
DMDTEND  EQU   DMDT+20
DMDTRUC  EQU   DMDT+16
DMDTINCU EQU   DMDT+14
DMDTOUTU EQU   DMDT+12
DMDTCMPL EQU   DMDT+10
DMDTGOOU EQU   DMDT+8
DMDTRUA  EQU   DMDT+6
DMDTWT   EQU   DMDT+3
DMDTHI   EQU   DMDT+2
WPOSEND  EQU   WPOD+8
WPOSWKL  EQU   WPOS+2
WPOSSRV  EQU   WPOS
WPODEND  EQU   WPOD+4
WPGLEND  EQU   WPGL+4
WPGLDUR  EQU   WPGLISV
WPGPEND  EQU   WPGP+8
WPGPRB2  EQU   WPGPINDS
@NM00028 EQU   WPGP+2
WPGDEND  EQU   WPGD+20
WPGDPGL  EQU   WPGD+20
WPGDDURP EQU   WPGDPGP+7
WPGDISVP EQU   WPGDPGP+6
WPGDRTB  EQU   WPGDINDS
WPGDRB2  EQU   WPGDINDS
WPGDAPG  EQU   WPGDINDS
WPGDUNT  EQU   WPGDINDS
WPGDFIN  EQU   WPGDINDS
WPGDAPGV EQU   WPGDPGP+4
@NM00027 EQU   WPGDPGP+2
WPGDDMN  EQU   WPGDPGP+1
WPGDOBJN EQU   WPGDPGP
WPGDRD1  EQU   WPGDDFL
WPGDVLD  EQU   WPGDDFL
WPGDR02  EQU   WPGD+2
RMPTEND  EQU   RMPT+72
RMPTOPI  EQU   RMPT+63
RMPTIOET EQU   RMPT+56
RMPTCPET EQU   RMPT+52
RMPTWMET EQU   RMPT+48
RMPTSAET EQU   RMPT+44
RMPTXCHT EQU   RMPT+40
RMPTRSV3 EQU   RMPT+38
RMPTRSV2 EQU   RMPT+36
RMPTRSV1 EQU   RMPT+32
RMPTTOL  EQU   RMPT+28
RMPTTOM  EQU   RMPT+24
RMPTTCS  EQU   RMPT+20
RMPTIOC  EQU   RMPT+8
RMPTNAME EQU   RMPT
WMSTEND  EQU   WMST+112
WMSTIPM  EQU   WMST+108
WMSTIPI  EQU   WMST+104
WMSTSECB EQU   WMST+96
WMSTNWST EQU   WMST+92
WMSTSTCB EQU   WMST+88
WMSTSET  EQU   WMST+84
WMSTRSVD EQU   WMST+81
WMSTDMDE EQU   WMST+56
RMCTEND  EQU   RMCT+192
RMCTR50  EQU   RMCT+190
RMCTDMNC EQU   RMCT+188
RMCTDMDE EQU   RMCT+184
RMCTDMDT EQU   RMCT+180
RMCTSRBT EQU   RMCT+176
RMCTOUXB EQU   RMCT+172
RMCTOUCB EQU   RMCT+168
RMCTTOCI EQU   RMCT+160
RMCTCPID EQU   RMCT+156
RMCTTELM EQU   RMCT+152
RMCTF09  EQU   RMCTFLGS+1
RMCTMFS  EQU   RMCTFLGS+1
RMCTF07  EQU   RMCTFLGS+1
RMCTF06  EQU   RMCTFLGS
RMCTRSV2 EQU   RMCTFLGS
RMCTSTW  EQU   RMCTFLGS
RMCTRSV1 EQU   RMCTFLGS
RMCTINIT EQU   RMCTFLGS
RMCTF03  EQU   RMCTFLGS
RMCTCPS1 EQU   RMCTFLGS
RMCTMFA  EQU   RMCTFLGS
RMCTRQSV EQU   RMCT+144
RMCTALR  EQU   RMCT+140
RMCTALA  EQU   RMCT+136
RMCTTOC  EQU   RMCT+128
RMCTTOD  EQU   RMCT+124
RMCTTBS  EQU   RMCT+120
RMCTR10  EQU   RMCT+116
RMCTINQE EQU   RMCT+112
RMCTOTQE EQU   RMCT+108
RMCTWTQE EQU   RMCT+104
RMCTAQHD EQU   RMCT+100
RMCTAQCT EQU   RMCT+96
RMCTTMQE EQU   RMCT+92
RMCTWAMT EQU   RMCT+88
RMCTWAST EQU   RMCT+84
RMCTEPPR EQU   RMCT+80
RMCTFLTM EQU   RMCT+76
RMCTEPET EQU   RMCT+72
RMCTITT  EQU   RMCT+68
RMCTADJC EQU   RMCT+64
RMCTEPBG EQU   RMCT+60
RMCTEPAT EQU   RMCT+56
RMCTEPDT EQU   RMCT+52
RMCTEPPA EQU   RMCT+48
RMCTRMSB EQU   RMCT+44
RMCTRMEX EQU   RMCT+40
RMCTRMPD EQU   RMCT+36
RMCTRMSA EQU   RMCT+32
RMCTRLCT EQU   RMCT+28
RMCTWMST EQU   RMCT+24
RMCTRMCA EQU   RMCT+20
RMCTMCT  EQU   RMCT+12
RMCTICT  EQU   RMCT+8
RMCTCCT  EQU   RMCT+4
RMCTNAME EQU   RMCT
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00026 EQU   CVTFIX+248
@NM00025 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTCCVT  EQU   CVTXTNT2+40
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTLDEV  EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTSV76Q EQU   CVTSV76C
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTSV76M EQU   CVTIOQET
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
@NM00024 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00023 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSALITA  EQU   PSA+764
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00022 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00021 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSAULCMS EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSAESTA  EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSATYPE6 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00020 EQU   FLCFSA
@NM00019 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00018 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00017 EQU   FLCIOA
@NM00016 EQU   FLCMCLA+15
@NM00015 EQU   FLCMCLA+14
@NM00014 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00013 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00012 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00011 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00010 EQU   FLCPER
@NM00009 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00008 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00007 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00006 EQU   FLCPIILC
@NM00005 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00004 EQU   FLCSVILC
@NM00003 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00002 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00001 EQU   FLCICCW2+4
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RT00136 EQU   RMIPERR
@RF00252 EQU   @EL00005
@RF00290 EQU   @EL00006
@RF00288 EQU   RMIPIPE
@RF00306 EQU   @EL00006
@RF00317 EQU   @EL00006
@RC00319 EQU   @EL00006
@RF00359 EQU   @EL00006
@RC00361 EQU   @EL00006
@RT00380 EQU   RMIPIPE
@RF00376 EQU   @EL00006
@RF00383 EQU   @EL00006
@RF00391 EQU   @EL00006
@RF00476 EQU   @EL00006
@RT00492 EQU   RMIPIPE
@RT00511 EQU   RMIPIPE
@RF00482 EQU   @EL00006
@RF00516 EQU   @EL00006
@RC00536 EQU   @EL00006
@RF00532 EQU   RMIPIPE
@RF00547 EQU   @EL00006
@RF00545 EQU   RMIPIPE
@RF00560 EQU   @EL00006
@RF00558 EQU   RMIPIPE
@RF00576 EQU   @EL00006
@RF00581 EQU   @EL00006
@RF00574 EQU   RMIPIPE
@RF00589 EQU   @EL00006
@RF00587 EQU   RMIPIPE
@RF00601 EQU   @EL00006
@RF00604 EQU   @EL00006
@RF00599 EQU   RMIPIPE
@RF00612 EQU   @EL00006
@RF00621 EQU   @EL00006
@RF00619 EQU   RMIPIPE
@RF00659 EQU   @EL00006
@RF00706 EQU   @EL00007
@RC00734 EQU   @EL00009
@RT00775 EQU   @EL00011
@RF00836 EQU   @EL00001
@RF00863 EQU   @EL00012
@RC00865 EQU   @EL00012
@RF00877 EQU   @EL00012
@RC00879 EQU   @EL00012
@RT00967 EQU   RBCHKBLN
@RT01045 EQU   RRSCNEND
@RT01047 EQU   RRUPDATE
@RT01049 EQU   RRSCNEND
@RT01054 EQU   RRSCNEND
@RT01056 EQU   RRUPDAT2
@RT01058 EQU   RRSCNEND
@RF01093 EQU   @EL00017
@RF00329 EQU   @RC00319
@ENDDATA EQU   *
         END   IRARMIPS,(C'PLS1817',0701,78116)
