         TITLE ' /* IRBMFINP - MF/1 INPUT/MERGE CONTROL                *
                       '
         MACRO
&MFSNAME MFSYSTR &INITIAL,&ALTLST,&RCALTLS
         AGO   .BEGIN
*/********************************************************************/
*/* MODULE NAME = MFSYSTR                                            */
*/*                                                                  */
*/* DESCRIPTIVE NAME = MF/1 SYNTAX TABLE STRUCTURE ENTRY             */
*/*                                                                  */
*/* COPYRIGHT = NONE                                                 */
*/*                                                                  */
*/* STATUS = RELEASE 2, VERSION 0                                    */
*/*                                                                  */
*/* FUNCTION = EXECUTABLE MACRO FOR THE SYNTAX TABLE (MFSYNTAB).     */
*/*            IT DESCRIBES A STRUCTURE ENTRY. (SEE METHOD OF INVOCA-*/
*/*            TION.)                                                */
*/*                                                                  */
*/* NOTES = NONE                                                     */
*/*                                                                  */
*/* MODULE TYPE = BAL EXECUTABLE MACRO                               */
*/*                                                                  */
*/* CHANGE ACTIVITY = SEE BELOW                                      */
*/* A000000-999999                                             Y02150*/
*/*                                                                  */
*/* MACCOMP Y-2 SC1CQ/GAM20                                          */
*/*                                                                  */
*/* MACMEAN MFSYSTR MEANS MF/1 SYNTAX TABLE STRUCTURE ENTRY          */
*/*                                                                  */
*/* METHOD OF INVOCATION                                             */
*/*    BAL - MFSYSTR A,B,C                                           */
*/*        WHERE                                                     */
*/*             A -'1' INDICATES INITIAL STRUCTURE                   */
*/*                '0' OTHERWISE                                     */
*/*             B -ADDRESS OF A LIST OF ALTERNATIVE ENTRIES (REGULAR)*/
*/*             C -ADDRESS OF A LIST OF RECURSIVE ALTERNATIVES       */
*/*                                                                  */
*/*    PLS - NONE                                                    */
*/********************************************************************/
.BEGIN   ANOP
*/* MACDATE Y-2 73026                                                */
         AIF (NOT ('&INITIAL' EQ '1' AND '&RCALTLS' NE '0')).A
&MFSNAME DC    X'C0' .            INITIAL STRUCTURE WITH RECURSIVE
*                                 ALTERNATIVES
         AGO   .D
.A       AIF   (NOT ('&INITIAL' EQ '1' AND '&RCALTLS' EQ '0')).B
&MFSNAME DC    X'80' .            INITIAL STRUCTURE - NOT RECURSIVE
         AGO   .D
.B       AIF   (NOT ('&INITIAL' NE '1' AND '&RCALTLS' NE '0')).C
&MFSNAME DC    X'40' .            RECURSIVE ALTERNATIVES EXIST
         AGO   .D
.C       AIF   (NOT ('&INITIAL' NE '1' AND '&RCALTLS' EQ '0')).D
&MFSNAME DC    X'00' .            NOT INITIAL STRUCUTRE - NO RECURSIVE
*                                 ALTERNATIVES
.D       ANOP
         DC    AL3(0) .           RESERVED
         DC    A(&ALTLST) .       ALTERNATIVE LIST ADDRESS
         DC    A(&RCALTLS) .      RECURSIVE ALTERNATIVE
         MEND
         MACRO
&MFANAME MFSYALT &ENDLST,&ITMLST,&INITRTN,&INITPRM
         AGO   .BEGIN
*/********************************************************************/
*/* MODULE NAME = MFSYALT                                            */
*/*                                                                  */
*/* DESCRIPTIVE NAME = MF/1 SYNTAX TABLE ALTERNATIVE ENTRY           */
*/*                                                                  */
*/* COPYRIGHT = NONE                                                 */
*/*                                                                  */
*/* STATUS = RELEASE 2, LEVEL 0                                      */
*/*                                                                  */
*/* FUNCTION = EXECUTABLE MACRO FOR THE SYNTAX TABLE (MFSYNTAB).     */
*/*            IT DESCRIBES AN ALTERNATIVE ENTRY.  (SEE METHOD OF    */
*/*            INVOCATION                                            */
*/*                                                                  */
*/* NOTES = NONE                                                     */
*/*                                                                  */
*/* MODULE TYPE = EXECUTABLE MACRO (BAL)                             */
*/*                                                                  */
*/* CHANGE ACTIVITY = SEE BELOW                                      */
*/* A000000-999999                                             Y02150*/
*/*                                                                  */
*/* MACCOMP Y-2 SC1CQ/GAM20                                          */
*/*                                                                  */
*/* MACMEAN MFSYALT MEANS MF/1 SYNTAX TABLE ALTERNATIVE ENTRY        */
*/*                                                                  */
*/* METHOD OF INVOCATION                                             */
*/*    BAL - MFSYALT A,B,C,D                                         */
*/*        WHERE                                                     */
*/*             A - '1' INDICATES END OF ALTERNATIVES LIST           */
*/*                 '0' OTHERWISE                                    */
*/*             B - ADDRESS OF AN ITEM ENTRY                         */
*/*             C - ADDRESS OF AN INITIALIZATION ROUTINE OR ZERO     */
*/*             D - ADDRESS OF A PARAMETER LIST TO BE PASSED TO THE  */
*/*                 INITIALIZATION ROUTINE                           */
*/*                                                                  */
*/*    PLS - NONE                                                    */
*/********************************************************************/
.BEGIN   ANOP
*/* MACDATE Y-2 73026                                                */
         AIF   (NOT ('&ENDLST' EQ '1' AND '&INITRTN' NE '0')).A
&MFANAME DC    X'C0' .            END OF LIST AND INITIALIZATION
*                                 ROUTINE EXISTS
         AGO   .D
.A       AIF   (NOT ('&ENDLST' EQ '1' AND '&INITRTN' EQ '0')).B
&MFANAME DC    X'80' .            END OF LIST
         AGO   .D
.B       AIF   (NOT ('&ENDLST' NE '1' AND '&INITRTN' NE '0')).C
&MFANAME DC    X'40' .            INITIALIZATION ROUTINE EXISTS
         AGO   .D
.C       AIF (NOT ('&ENDLST' NE '1' AND '&INITRTN' EQ '0')).D
&MFANAME DC    X'00' .            NOT END OF LIST - NO INITIALIZATION
*                                 ROUTINE EXISTS
.D       ANOP
         DC    AL3(0) .           RESERVED
         DC    A(&ITMLST) .       ADDRESS OF AN ITEM LIST
         DC    A(&INITRTN) .      INITIALIZATION RTN ADDRESS
         DC    A(&INITPRM) .      ADDRESS OF A PARAMETER LIST
*                                 FOR INITIALIZATION ROUTINE
         MEND
         MACRO
&MFINAME MFSYITM &ENDLST,&RECGNZR,&TRMDEF,&RCGPARM
         AGO   .BEGIN
*/********************************************************************/
*/* MODULE NAME = MFSYITM                                            */
*/*                                                                  */
*/* DESCRIPTIVE NAME = MF/1 SYNTAX TABLE ITEM ENTRY                  */
*/*                                                                  */
*/* COPYRIGHT = NONE                                                 */
*/*                                                                  */
*/* STATUS = RELEASE 2, LEVEL 0                                      */
*/*                                                                  */
*/* FUNCTION = EXECUTABLE MACRO FOR MF/1 SYNTAX TABLE (MFSYNTAB).    */
*/*                                                                  */
*/* NOTES = NONE                                                     */
*/*                                                                  */
*/* MODULE TYPE = BAL EXECUTABLE MACRO                               */
*/*                                                                  */
*/* CHANGE ACTIVITY = SEE BELOW                                      */
*/* A000000-999999                                             Y02150*/
*/*                                                                  */
*/* MACCOMP Y-2 SC1SQ/GAM20                                          */
*/*                                                                  */
*/* MACMEAN MFSYITM MEANS MF/1 SYNTAX TABLE ITEM ENTRY               */
*/*                                                                  */
*/* METHOD OF INVOCATION                                             */
*/*    BAL - MFSYITM A,B,C,D                                         */
*/*        WHERE                                                     */
*/*             A - '1' INDICATES END OF ITEM LIST                   */
*/*                 '0' OTHERWISE                                    */
*/*             B - ADDRESS OF A RECOGNIZER ROUTINE OR A STRUCTURE   */
*/*                 ENTRY                                            */
*/*             C - '1' INDICATES ITEM ENTRY IS A TERMINAL TYPE      */
*/*                 '0' INDICATES ITEM ENTRY IS A STRUCTURE TYPE     */
*/*             D - ADDRESS OF A PARAMETER LIST TO BE PASSED TO THE  */
*/*                 RECOGNIZE ROUTINE OR 0.                          */
*/*                                                                  */
*/*    PLS - NONE                                                    */
*/********************************************************************/
.BEGIN   ANOP
*/* MACDATE Y-2 73026                                                */
         AIF   (NOT ('&ENDLST' EQ '1' AND '&TRMDEF' EQ '1')).A
&MFINAME DC    X'C0' .            END OF LIST AND ITEM IS
*                                 TERMINAL TYPE
         AGO   .D
.A       AIF   (NOT ('&ENDLST' EQ '1' AND '&TRMDEF' NE '1')).B
&MFINAME DC    X'80'              END OF LIST
         AGO   .D
.B       AIF   (NOT ('&ENDLST' NE '1' AND '&TRMDEF' EQ '1')).C
&MFINAME DC    X'40'              ITEM IS TERMINAL TYPE
         AGO   .D
.C       AIF   (NOT ('&ENDLST' NE '1' AND '&TRMDEF' NE '1')).D
&MFINAME DC    X'00'              NOT END OF LIST AND ITEM IS
*                                 DEFINED TYPE
.D       ANOP
         DC    AL3(0) .           RESERVED
         DC    A(&RECGNZR) .      ADDRESS OF A RECOGNIZER
*                                 OR STRUCTURE ENTRY
         DC    A(&RCGPARM) .      ADDRESS OF A PARAMETER LIST
*                                 PASSED TO RECOGNIZER ROUTINE
         MEND
IRBMFINP CSECT ,                                                   0002
@MAINENT DS    0H                                                  0002
         USING *,@15                                               0002
         B     @PROLOG                                             0002
         DC    AL1(16)                                             0002
         DC    C'IRBMFINP  74.107'                                 0002
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0002
         BALR  @08,0                                               0002
@PSTART  LA    @09,4095(,@08)                                      0002
         LA    @11,4095(,@09)                                      0002
         LA    @12,4095(,@11)                                      0002
         USING @PSTART,@08                                         0002
         USING @PSTART+4095,@09                                    0002
         USING @PSTART+8190,@11                                    0002
         USING @PSTART+12285,@12                                   0002
         L     @00,@SIZDATD                                        0002
         GETMAIN R,LV=(0)
         LR    @10,@01                                             0002
         USING @DATD,@10                                           0002
         ST    @13,@SA00001+4                                      0002
         LM    @00,@01,20(@13)                                     0002
         ST    @10,8(,@13)                                         0002
         LR    @13,@10                                             0002
         XC    @ZTEMPS(@ZLEN),@ZTEMPS
         MVC   @PC00001(12),0(@01)                                 0002
*                                                                  0039
*/* INITIALIZE ANALYZER CONTROL BLOCKS                               */
*                                                                  0040
*   INBCBNAM='BCB ';                /* ACRONYM                       */
         MVC   INBCBNAM(4),@CC00944                                0040
*   INBCBFRS=0;                     /* NO ELEMENTS IN QUEUE          */
         SR    @15,@15                                             0041
         ST    @15,INBCBFRS                                        0041
*   INBCBLST=ADDR(INBCBFRS);        /* INITIAL CONDITION             */
         LA    @14,INBCBFRS                                        0042
         ST    @14,INBCBLST                                        0042
*   INCURBCB=ADDR(INBCBFRS);        /* INITIAL CONDITION             */
         ST    @14,INCURBCB                                        0043
*   INTXTCUR=0;                     /* NO TEXT EXIST                 */
         ST    @15,INTXTCUR                                        0044
*   INBYTLFT=0;                     /* INITIAL CONDITION             */
         ST    @15,INBYTLFT                                        0045
*   INEXTSRC='0'B;                  /* EXTERNAL TEXT SOURCE          */
*                                                                  0046
         NI    INEXTSRC,B'01111111'                                0046
*/* INTEGER VECTOR TABLE INITIALIZATION                              */
*                                                                  0047
*   ININTPTR(1)=ADDR(SYPRMV01);                                    0047
*                                                                  0047
         LA    @14,SYPRMV01                                        0047
         ST    @14,ININTPTR                                        0047
*/* ERROR VECTOR TABLE INITIALIZATION                                */
*                                                                  0048
*   INERRPTR(1)=ADDR(INCOXER2);                                    0048
*                                                                  0048
         LA    @14,INCOXER2                                        0048
         ST    @14,INERRPTR                                        0048
*/* ALPHA VECTOR TABLE INITIALIZATION                                */
*                                                                  0049
*   INALPPTR(1)=ADDR(SYPRMA01);                                    0049
         LA    @14,SYPRMA01                                        0049
         ST    @14,INALPPTR                                        0049
*                                                                  0050
*   /*****************************************************************/
*   /*                                                               */
*   /* STATIC TO AUTOMATIC MACRO LIST INITIALIZATION                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0050
*   INEXTCIB=INEXCIB;               /* MOVE STATIC PARM LIST TO AUTO
*                                      PARM LIST                     */
         MVC   INEXTCIB(12),INEXCIB                                0050
*   INMEMLIB=INSTCLIB;              /* STATIC DCB MOVE TO AUTO DCB   */
         MVC   INMEMLIB(88),INSTCLIB                               0051
*   INOPNADC=INOPNSDC;              /* STATIC OPEN PARM LIST MOVED TO
*                                      AUTO OPEN PARM LIST           */
         MVC   INOPNADC(4),INOPNSDC                                0052
*   INMSGDCB=INSTCDCB;              /* STATIC MSG DCB MOVED TO AUTO
*                                      MSG DCB                       */
         MVC   INMSGDCB(96),INSTCDCB                               0053
*   INCLOSEA=INCLOSE;               /* STATIC CLOSE LIST MOVED TO  0054
*                                      AUTO CLOSE LIST               */
         MVC   INCLOSEA(4),INCLOSE                                 0054
*   INAUMOPN=INMSGOPN;              /* STATIC PARMLIST MOVE TO AUTO.
*                                      PARM LIST                     */
         MVC   INAUMOPN(4),INMSGOPN                                0055
*   INARDMAC=INRDMAC;               /* MOVE STATIC LIST INTO AUTO ONE*/
         MVC   INARDMAC(20),INRDMAC                                0056
*                                                                  0057
*   /*****************************************************************/
*   /*                                                               */
*   /* GENERAL INITIALIZATION                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0057
*   INEXTSRC='1'B;                  /* INTERNAL SOURCE               */
         OI    INEXTSRC,B'10000000'                                0057
*   INEOFBIT='0'B;                  /* END OF FILE BIT               */
         NI    INEOFBIT,B'01111111'                                0058
*   INDDNAME='MF1INPUT';            /* MSG DATASET DD NAME           */
         MVC   INDDNAME(8),@CC00946                                0059
*   INMDCBAD=ADDR(INMSGDCB);        /* ADDRESS OF DCB                */
         LA    @14,INMSGDCB                                        0060
         ST    @14,INMDCBAD                                        0060
*   INOPNERR='0'B;                  /* OPEN ERROR BIT                */
         NI    INOPNERR,B'01111111'                                0061
*   INMPREFX='IRBMF1';              /* MEMBER NAME PREFIX            */
         MVC   INMPREFX(6),@CC00947                                0062
*   INREPLEN=LENGTH(INREPTXT);      /* LENGTH OF REPLY TEXT          */
         MVC   INREPLEN(2),@CH00823                                0063
*   INMRGFIN='0'B;                  /* INDICATE MERGE IN PROGRESS    */
         NI    INMRGFIN,B'01111111'                                0064
*   IN304PRT=0;                     /* NOT A MESSAGE PART            */
         STH   @15,IN304PRT                                        0065
*   IN304LEN=0;                     /* NO TEXT SUPPLIED              */
*                                                                  0066
         STH   @15,IN304LEN                                        0066
*/* INITIALIZE MVT (TEMPORARY ONE )                                  */
*                                                                  0067
*   DO I=1 TO MFMVNUM;                                             0067
         LA    @15,1                                               0067
         B     @DE00067                                            0067
@DL00067 DS    0H                                                  0068
*     INMVADD(I)=ADDR(TMPMA(I));                                   0068
         LR    @14,@15                                             0068
         SLA   @14,2                                               0068
         LR    @07,@15                                             0068
         MH    @07,@CH00584                                        0068
         LA    @07,TMPMA-12(@07)                                   0068
         ST    @07,INMVADD-4(@14)                                  0068
*   END;                                                           0069
         AH    @15,@CH00065                                        0069
@DE00067 ST    @15,I                                               0069
         L     @14,@PC00001+4                                      0069
         C     @15,MFMVNUM(,@14)                                   0069
         BNH   @DL00067                                            0069
*   INMODULE='IRBMFMPR';                                           0070
         MVC   INMODULE(8),@CC00949                                0070
*   RESPECIFY                                                      0071
*    (GPR00P,                                                      0071
*     GPR01P,                                                      0071
*     GPR14P,                                                      0071
*     GPR15F)RSTD;                                                 0071
*   GENERATE;                                                      0072
*                                   /* LOAD IRBMFMPR */
         LOAD EPLOC=INMODULE
*   INMSGADR=GPR00P;                /* SAVE ITS ADDRESS              */
         ST    GPR00P,INMSGADR                                     0073
*   RESPECIFY                                                      0074
*    (GPR00P,                                                      0074
*     GPR01P,                                                      0074
*     GPR14P,                                                      0074
*     GPR15F)UNRSTD;                                               0074
*                                                                  0074
*   /*****************************************************************/
*   /*                                                               */
*   /* FUNCTIONAL CODE.                                              */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0075
*   RFY                                                            0075
*    (GPR01F,                                                      0075
*     GPR00F)RSTD;                                                 0075
*   GEN;                                                           0076
         L     @01,INSZDADR            ADDRESS OF SIZDATD
         L     @01,0(@01)              ACTUAL SIZE OF ANL SIZDATD
*   INGMWORD=GPR01F*(INMXRCUR);     /* CALCULATE ANL STORAGE SIZE    */
         LR    @15,GPR01F                                          0077
         MH    @15,@CH00091                                        0077
         ST    @15,INGMWORD                                        0077
*   GEN;                                                           0078
         L     @00,INGMWORD            SET UP REG 0 FOR GETMAIN
         GETMAIN R,LV=(0)
*   INAUTPTR=GPR01P;                /* GET PTR TO AREA               */
         ST    GPR01P,INAUTPTR                                     0079
*   INAUTSAV=INAUTPTR;              /* SAVE PTR TO AREA FOR FREEING  */
         L     @15,INAUTPTR                                        0080
         ST    @15,INAUTSAV                                        0080
*   RFY                                                            0081
*    (GPR01F,                                                      0081
*     GPR00F)UNRSTD;                                               0081
*                                                                  0081
*   /*****************************************************************/
*   /*                                                               */
*   /* THE 1ST SOURCE OF INPUT WITH HIGHEST PRIORITY IS THE DATA FROM*/
*   /* THE START COMMAND PARM FIELD. THIS FIELD CAN OVERRIDE ANY     */
*   /* PRESET OPTION VALUE. THE CODE TO PROCESS IT FOLLOWS.          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0082
*   INCOXSRC=INSTRTPM;              /* INDICATE START PARMS BEING  0082
*                                      PROCESSED                     */
         NI    INCOXSRC,B'11100111'                                0082
*   RFY                                                            0083
*    (GPR00F,                                                      0083
*     GPR01P,                                                      0083
*     GPR14P,                                                      0083
*     GPR15P)RSTD;                                                 0083
*   GENERATE(EXTRACT INEXTLST,,FIELDS=(COMM),MF=(E,INEXTCIB));     0084
         EXTRACT INEXTLST,,FIELDS=(COMM),MF=(E,INEXTCIB)
*   RFY                                                            0085
*    (GPR00F,                                                      0085
*     GPR01P,                                                      0085
*     GPR14P,                                                      0085
*     GPR15P)UNRSTD;                                               0085
*   IF CIBPTR^=0 THEN               /* IF STARTED BY CONSOLE COMMAND
*                                                            @YM5633P*/
         SR    @15,@15                                             0086
         L     @01,INEXTLST                                        0086
         L     @14,CIBPTR(,@01)                                    0086
         CR    @14,@15                                             0086
         BE    @RF00086                                            0086
*     DO;                           /*                       @YM5633P*/
*       IF CIBDATLN>0 THEN          /* WERE ANY PARMS SPECIFIED?     */
         CH    @15,CIBDATLN(,@14)                                  0088
         BNL   @RF00088                                            0088
*         DO;                                                      0089
*           CALL MFBUFENQ(CIBDATA,EVAL(CIBDATLN),INSCB);/* CREATE A
*                                      BUFFER AND BCB                */
         LA    @15,CIBDATA(,@14)                                   0090
         ST    @15,@AL00001                                        0090
         LH    @15,CIBDATLN(,@14)                                  0090
         ST    @15,@AFTEMPS+20                                     0090
         LA    @15,@AFTEMPS+20                                     0090
         ST    @15,@AL00001+4                                      0090
         LA    @15,INSCB                                           0090
         ST    @15,@AL00001+8                                      0090
         LA    @01,@AL00001                                        0090
         BAL   @14,MFBUFENQ                                        0090
*           CALL MFSRCPRO(INFORCE); /* PROCESS START PARMS           */
         LA    @01,@AL00091                                        0091
         BAL   @14,MFSRCPRO                                        0091
*         END;                                                     0092
*     END;                          /*                       @YM5633P*/
*                                                                  0093
@RF00088 DS    0H                                                  0094
*   /*****************************************************************/
*   /*                                                               */
*   /* THE NEXT HIGHEST PRIORITY SOURCE IS THE EXEC STMT PARM FIELD  */
*   /* OF THE PROCEDURE INVOKED BY STARTING MF/1. CODE TO PROCESS IT */
*   /* FOLLOWS                                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0094
*   INCOXSRC=INEXECPM;              /* INDICATE EXEC STMT PARM FIELD
*                                      BEING PROCESSED               */
@RF00086 NI    INCOXSRC,B'11101111'                                0094
         OI    INCOXSRC,B'00001000'                                0094
*   IF INEXLENG>0 THEN              /* ANY PARMS ON EXEC STMT?       */
         L     @15,@PC00001                                        0095
         LH    @14,INEXLENG(,@15)                                  0095
         LTR   @14,@14                                             0095
         BNP   @RF00095                                            0095
*     DO;                                                          0096
*       CALL MFBUFENQ(INEXPARM,EVAL(INEXLENG),INSCB);/* CREATE A   0097
*                                      BUFFER AND BCB                */
         LA    @14,INEXPARM(,@15)                                  0097
         ST    @14,@AL00001                                        0097
         LH    @15,INEXLENG(,@15)                                  0097
         ST    @15,@AFTEMPS+20                                     0097
         LA    @15,@AFTEMPS+20                                     0097
         ST    @15,@AL00001+4                                      0097
         LA    @15,INSCB                                           0097
         ST    @15,@AL00001+8                                      0097
         LA    @01,@AL00001                                        0097
         BAL   @14,MFBUFENQ                                        0097
*       CALL MFSRCPRO(INFORCE);     /* PROCESS EXEC PARMS            */
         LA    @01,@AL00098                                        0098
         BAL   @14,MFSRCPRO                                        0098
*     END;                                                         0099
*                                                                  0099
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS NEXT SOURCE IS THE IEFRDER DATA SET (IRBMF1NN, WHERE NN  */
*   /* IS THE MEMBER NUMBER DEFINED BY 'MEMBER(NN)' OPTION) IF THE   */
*   /* MEMBER OPTION HAS NOT BEEN SPECIFIED THE DEFAULT MEMBER       */
*   /* IRBMF100 WILL BE USED.                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0100
*   INCOXSRC=INLIBRDS;              /* INDICATE LIBRARY MEMBER BEING
*                                      PROCESSED                     */
@RF00095 NI    INCOXSRC,B'11110111'                                0100
         OI    INCOXSRC,B'00010000'                                0100
*   INEXTSRC=INEXSRCE;              /* EXTERNAL INPUT SOURCE         */
         NI    INEXTSRC,B'01111111'                                0101
*   IF MFCOMEMC=INOPTSPC THEN       /* WAS MEMBER OPTION SPECIFIED   */
         L     @15,@PC00001+8                                      0102
         TM    MFCOMEMC(@15),B'10000000'                           0102
         BNZ   @RF00102                                            0102
*     INMEMNUM=MFCOMEMV;            /* YES, MOVE IN MEMEBER NO.      */
         MVC   INMEMNUM(2),MFCOMEMV(@15)                           0103
*   ELSE                            /* MEMBER NO. NOT SPECIFIED SO   */
*     DO;                                                          0104
         B     @RC00102                                            0104
@RF00102 DS    0H                                                  0105
*       INMEMNUM='00';              /* DEFAULT MEMBER                */
         MVC   INMEMNUM(2),@CC00951                                0105
*       MFCOMEMV='00';              /* INDICATE DEFAULT MEMBER       */
         L     @15,@PC00001+8                                      0106
         MVC   MFCOMEMV(2,@15),@CC00951                            0106
*       MFCOMEMC=INOPTSPC;          /* IN PERMANENT COA              */
         NI    MFCOMEMC(@15),B'01111111'                           0107
*     END;                                                         0108
*   INVTXLST(1)=ADDR(IN304LST);     /* VARIABLE TEXT LIST 1          */
@RC00102 LA    @15,IN304LST                                        0109
         ST    @15,INVTXLST                                        0109
*   INVTXLST(2)=ADDR(IN304LST);     /* VARIABLE TEXT LIST 2          */
         ST    @15,INVTXLST+4                                      0110
*   RFY                                                            0111
*    (GPR00F,                                                      0111
*     GPR01P,                                                      0111
*     GPR14P,                                                      0111
*     GPR15P)RSTD;                                                 0111
*   GENERATE SETS(INMEMLIB,INOPNADC);                              0112
*                                     /* OPEN IEFRDER DD DATASET */
         OPEN (INMEMLIB,(INPUT)),MF=(E,INOPNADC)
*   DCBPTR=ADDR(INMEMLIB);          /* INITIALIZE DCB POINTER        */
         LA    @07,INMEMLIB                                        0113
         ST    @07,DCBPTR                                          0113
*   DCBEXLSA=0;                     /* CLEAR EXIT LIST ADDRESS       */
         LA    @06,DCBIOBAD+16(,@07)                               0114
         SR    @05,@05                                             0114
         ST    @05,@TF00001                                        0114
         MVC   DCBEXLSA(3,@06),@TF00001+1                          0114
*   IF DCBOFOPN^='1'B THEN          /* OPEN FAILURE?                 */
         TM    DCBOFOPN+40(@07),B'00010000'                        0115
         BO    @RF00115                                            0115
*     DO;                                                          0116
*       CALL INMSGMOD(MID304I,INVTXLST,0,0);/* ISSUE I/O ERROR MSG   */
         MVC   @AL00001(16),@AL00117                               0117
         LA    @07,INVTXLST                                        0117
         ST    @07,@AL00001+4                                      0117
         L     @15,INMSGADR                                        0117
         LA    @01,@AL00001                                        0117
         BALR  @14,@15                                             0117
*       GOTO INDEFALT;              /* PROCESS PROGRAM DEFAULTS      */
         B     INDEFALT                                            0118
*     END;                                                         0119
*   GENERATE REFS(INMEMLIB,INMEMNAM);                              0120
@RF00115 DS    0H                                                  0120
         FIND INMEMLIB,INMEMNAM,D   /* FIND MF/1 MEMBER */
*   IF GPR15F=04 THEN               /* MEMBER NAME NOT FOUND?        */
         CH    GPR15F,@CH00254                                     0121
         BNE   @RF00121                                            0121
*     DO;                           /* BUILD MESSAGE IRB302I PARM  0122
*                                      LIST                          */
*       IN302NUM=0;                 /* VARIABLE TEXT TO BE SUPPLIED
*                                      BY THIS CALLER                */
         SR    @07,@07                                             0123
         STH   @07,IN302NUM                                        0123
*       IN302LEN=LENGTH(MFCOMEMV);  /* LENGTH OF VARIABLE TEXT BEING
*                                      SUPPLIED                      */
         MVC   IN302LEN(2),@CH00078                                0124
*       IN302TXT=MFCOMEMV;          /* MEMBER NUMBER-VARIABLE TEXT   */
         L     @07,@PC00001+8                                      0125
         MVC   IN302TXT(2),MFCOMEMV(@07)                           0125
*       INVTXLST(1)=ADDR(IN302LST); /* VARIABLE TEXT LIST            */
*                                                                  0126
         LA    @07,IN302LST                                        0126
         ST    @07,INVTXLST                                        0126
*       /*************************************************************/
*       /*                                                           */
*       /* CALL MESSAGE MODULE TO ISSUE MSG IRB302I                  */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0127
*       CALL INMSGMOD(MID302I,INVTXLST,0,0);                       0127
         MVC   @AL00001(16),@AL00127                               0127
         LA    @07,INVTXLST                                        0127
         ST    @07,@AL00001+4                                      0127
         L     @15,INMSGADR                                        0127
         LA    @01,@AL00001                                        0127
         BALR  @14,@15                                             0127
*       INCOOPIC=INOPISET;          /* INDICATE OPI SPECIFIED        */
         NI    INCOOPIC,B'01111111'                                0128
*       INCOOPIV=INOPIYES;          /* SET OPI OPTION VALUE TO YES   */
         OI    INCOOPIV,B'00000001'                                0129
*     END;                                                         0130
*   IF GPR15F=08 THEN               /* I/O ERROR DURING FIND?        */
@RF00121 CH    GPR15F,@CH00069                                     0131
         BNE   @RF00131                                            0131
*     CALL INMSGMOD(MID304I,INVTXLST,0,0);/* ISSUE I/O ERROR MSG     */
         MVC   @AL00001(16),@AL00132                               0132
         LA    @07,INVTXLST                                        0132
         ST    @07,@AL00001+4                                      0132
         L     @15,INMSGADR                                        0132
         LA    @01,@AL00001                                        0132
         BALR  @14,@15                                             0132
*   IF GPR15F=00 THEN               /* FIND WORKED O.K.?             */
@RF00131 LTR   GPR15F,GPR15F                                       0133
         BNZ   @RF00133                                            0133
*     CALL MFSRCPRO(INFORCE);       /* PROCESS MEMBER DATA SET       */
         LA    @01,@AL00134                                        0134
         BAL   @14,MFSRCPRO                                        0134
*   GEN(CLOSE (INMEMLIB),MF=(E,INCLOSEA));                         0135
@RF00133 DS    0H                                                  0135
         CLOSE (INMEMLIB),MF=(E,INCLOSEA)
*   RFY                                                            0136
*    (GPR00F,                                                      0136
*     GPR01P,                                                      0136
*     GPR14P,                                                      0136
*     GPR15F)UNRSTD;                                               0136
*INDEFALT:                                                         0137
*                                                                  0137
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK FOR OPTIONS NOT SPECIFIED AND MOVE IN PROGRAM DEFAULTS. */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0137
*   INCOXSRC=INDEFLTC;              /* PROGRAM DEFAULTS SOURCE BEING
*                                      PROCESSED                     */
INDEFALT OI    INCOXSRC,B'00011000'                                0137
*   INEXTSRC=ININTSRC;              /* INTERNAL INPUT SOURCE         */
         OI    INEXTSRC,B'10000000'                                0138
*   CALL MFBUFENQ(INPGMDEF,INDEFLEN,INSCB);/* BUILD A BUFFER AND BCB */
         MVC   @AL00001(8),@AL00139                                0139
         LA    @14,INSCB                                           0139
         ST    @14,@AL00001+8                                      0139
         LA    @01,@AL00001                                        0139
         BAL   @14,MFBUFENQ                                        0139
*   CALL MFSRCPRO(INFORCE);         /* PROCESS PROGRAM DEFAULTS      */
         LA    @01,@AL00140                                        0140
         BAL   @14,MFSRCPRO                                        0140
*   INMRGFIN=INMRGDON;              /* INDICATE MERGE COMPLETE       */
*                                                                  0141
         OI    INMRGFIN,B'10000000'                                0141
*   /*****************************************************************/
*   /*                                                               */
*   /* TO PREVENT INCONSISTENCY IN SETTING OPTION VALUES, A VALIDITY */
*   /* CHECK IS MADE BY MFVALCHK TO ENSURE CONSISTENCY               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0142
*   CALL MFVALCHK;                                                 0142
*                                                                  0142
         BAL   @14,MFVALCHK                                        0142
*   /*****************************************************************/
*   /*                                                               */
*   /* IF THE OPI OPTION WAS SET TO YES BY EXPLICIT SPECIFICATION    */
*   /* FROM THE OPERATOR OR SET BY INPUT/MERGE DUE TO ERRORS OR      */
*   /* INCONSISTENCY A LIST OF OPTIONS IN EFFECT IS PRINTED TO THE   */
*   /* CONSOLE                                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0143
*   CALL MFLISTOP;                  /* LIST OPTIONS IN EFFECT        */
         BAL   @14,MFLISTOP                                        0143
*   RFY                                                            0144
*    (GPR00F,                                                      0144
*     GPR01P,                                                      0144
*     GPR14P,                                                      0144
*     GPR15P)RSTD;                                                 0144
*   INMODULE='IRBMFMPR';            /* IDENTIFY MESSAGE PROCESSOR.   */
         MVC   INMODULE(8),@CC00949                                0145
*   GEN(DELETE EPLOC=INMODULE);     /* DELETE MESSAGE MODULE         */
         DELETE EPLOC=INMODULE
*   GPR00F=INGMWORD;                                               0147
         L     GPR00F,INGMWORD                                     0147
*   GPR01P=INAUTSAV;                /* GET PTR TO STORAGE GOTTEN     */
         L     GPR01P,INAUTSAV                                     0148
*   GEN;                                                           0149
         FREEMAIN R,LV=(0),A=(1)       FREE AUTOMATIC STORAGE
*   RFY                                                            0150
*    (GPR00F,                                                      0150
*     GPR01P,                                                      0150
*     GPR14P,                                                      0150
*     GPR15P)UNRSTD;                                               0150
*   RETURN CODE(0);                 /* RETURN TO MFC                 */
         L     @13,4(,@13)                                         0151
         L     @00,@SIZDATD                                        0151
         LR    @01,@10                                             0151
         FREEMAIN R,LV=(0),A=(1)
         SR    @15,@15                                             0151
         L     @14,12(,@13)                                        0151
         LM    @00,@12,20(@13)                                     0151
         BR    @14                                                 0151
*                                                                  0152
*/*  PROCEDURE NAME=MFOPNERR                                         */
*/*                                                                  */
*/*  DESCRIPTIVE NAME = OPEN ABEND EXIT ROUTINE                      */
*/*                                                                  */
*/*  FUNCTION = HANDLES PROCESSING UPON AN OPEN ABEND. INDICATES THAT*/
*/*             THE ABEND IS TO BE IGNORED.                          */
*/*                                                                  */
*                                                                  0152
*MFOPNERR:                                                         0152
*   PROCEDURE OPTIONS(NOSAVE,NOSAVEAREA);                          0152
MFOPNERR DS    0H                                                  0153
*   GENERATE;                                                      0153
         NI    3(@01),X'40'       KEEP IGNORE BIT IF SET
         BR    @14                RETURN TO OPEN ABEND PROCESSING
*   END MFOPNERR;                                                  0154
@EL00002 DS    0H                                                  0154
@EF00002 DS    0H                                                  0154
@ER00002 BR    @14                                                 0154
*                                                                  0155
*/*  PROCEDURE NAME = MFSRCPRO                                       */
*/*                                                                  */
*/*  DESCRIPTIVE NAME = MF/1 SOURCE PROCESSOR                        */
*/*                                                                  */
*/*  FUNCTION = CALLS ANALYZE ROUTINE AND CHECKS FOR ERROR AFTER EACH*/
*/*             SOURCE HAS BEEN PROCESSED                            */
*/*                                                                  */
*/*                                                                  */
*                                                                  0155
*MFSRCPRO:                                                         0155
*   PROCEDURE(SRFORCE);                                            0155
MFSRCPRO STM   @14,@12,@SA00003                                    0155
         MVC   @PC00003(4),0(@01)                                  0155
*   DECLARE                                                        0156
*     SRFORCE                       /* FORCE BIT FOR MERGE           */
*         BIT(1),                                                  0156
*     SRSTRCAD                      /* STRUCTURE ENTRY ADDRESS EXISTS*/
*         BIT(1)CONSTANT('0'B),                                    0156
*     1 SRDUMITM,                   /* DUMMY ITEM ENTRY              */
*      2 SRIFLAGS,                  /* FLAGS BYTE                    */
*       3 SRENDITM                  /* END OF LIST                   */
*             BIT(1),                                              0156
*       3 SRSTRM                    /* STRUCTURE OR TERMINAL         */
*             BIT(1),                                              0156
*       3 *                         /* RESERVED                      */
*             BIT(30),                                             0156
*      2 SRRECSTR                   /* ADDRESS OF RECOGNIZER OR    0156
*                                      STRUCTURE ENTRY               */
*            PTR(31),                                              0156
*      2 SRIPARM                    /* PARMS PASSED TO RECOGNIZER    */
*            PTR(31),                                              0156
*        SRNOTSPF                   /* NOT SPECIFIED BIT             */
*            BIT(1)CONSTANT('1'B),                                 0156
*        SRCNTRL                    /* CONTROL WORD                  */
*            FIXED(8)CONSTANT(1),                                  0156
*     1 SRVTXLST,                   /* VARIABLE TEXT LIST            */
*      2 SRVTPNUM                   /* PART NUMBER - 0               */
*            FIXED(15),                                            0156
*      2 SRVTLEN                    /* LENGTH OF VARIABLE TEXT       */
*            FIXED(15),                                            0156
*      2 SRVTEXT                    /* VARIABLE TEXT                 */
*            CHAR(INERRLEN),                                       0156
*        SROPRATR                   /* INCOXSRC OPERATOR SOURCE      */
*            BIT(2)CONSTANT('00'B),                                0156
*        SREXEC                     /* INCOXSRC EXEC CARD SOURCE     */
*            BIT(2)CONSTANT('01'B),                                0156
*        SRLIBRAY                   /* INCOXSRC LIBRARY SOURCE       */
*            BIT(2)CONSTANT('10'B),                                0156
*        SRNDXARY                   /* MESSAGE INDEX NUMBER ARRAY FOR
*                                      LISTOP                        */
*            (10)FIXED(15),                                        0156
*        SRPARTNO                   /* PART NUMBER VARIABLE          */
*            FIXED(15);                                            0156
*SRSTRSCN:                                                         0157
*   INCOA=INCOA&&INCOA;             /* ZERO OUT TEMPORARY COA        */
SRSTRSCN XC    INCOA(32),INCOA                                     0157
*   DO I=1 TO MAXCOMM;              /* DO FOR EVERY COA              */
         LA    @15,1                                               0158
         ST    @15,I                                               0158
@DL00158 DS    0H                                                  0159
*     INCOCTRL(I)=SRNOTSPF;         /* TURN ON 'NOT SPECIFIED' BIT   */
         LR    @14,@15                                             0159
         SLA   @14,2                                               0159
         LA    @01,INCOCTRL-4(@14)                                 0159
         OI    0(@01),B'10000000'                                  0159
*   END;                                                           0160
         AH    @15,@CH00065                                        0160
         ST    @15,I                                               0160
         CH    @15,@CH00069                                        0160
         BNH   @DL00158                                            0160
*   DO I=1 TO MFMVNUM;              /* DO FOR EVERY PMA              */
         LA    @15,1                                               0161
         B     @DE00161                                            0161
@DL00161 DS    0H                                                  0162
*     RFY                                                          0162
*       INPMA BASED(INMVADD(I));                                   0162
*     INPMA=INPMA&&INPMA;           /* ZERO OUT PMA                  */
         LR    @14,@15                                             0163
         SLA   @14,2                                               0163
         L     @01,INMVADD-4(@14)                                  0163
         XC    INPMA(12,@01),INPMA(@01)                            0163
*   END;                                                           0164
         AH    @15,@CH00065                                        0164
@DE00161 ST    @15,I                                               0164
         L     @14,@PC00001+4                                      0164
         C     @15,MFMVNUM(,@14)                                   0164
         BNH   @DL00161                                            0164
*   DO I=1 TO MFMVNUM;              /* DO FOR EVERY PMA              */
         LA    @15,1                                               0165
         B     @DE00165                                            0165
@DL00165 DS    0H                                                  0166
*     INMVADD(I)->INPMCON=SRNOTSPF; /* OPTION NOT SPECIFIED          */
         LR    @14,@15                                             0166
         SLA   @14,2                                               0166
         L     @14,INMVADD-4(@14)                                  0166
         OI    INPMCON(@14),B'10000000'                            0166
*     IF(I-1)*LENGTH(INMVADD)=ADDR(INMVDEV)-ADDR(INMVOPT)THEN/*    0167
*                                      DEVICE PMA?                   */
         BCTR  @15,0                                               0167
         SLA   @15,2                                               0167
         LA    @07,INMVDEV                                         0167
         LA    @06,INMVOPT                                         0167
         SR    @07,@06                                             0167
         CR    @15,@07                                             0167
         BNE   @RF00167                                            0167
*       INMVADD(I)->INPMDEVF(SRCNTRL)=INPMDEVC;/* NOT SET            */
         MVI   INPMDEVF(@14),X'FC'                                 0168
*   END;                                                           0169
@RF00167 LA    @15,1                                               0169
         A     @15,I                                               0169
@DE00165 ST    @15,I                                               0169
         L     @14,@PC00001+4                                      0169
         C     @15,MFMVNUM(,@14)                                   0169
         BNH   @DL00165                                            0169
*   RFY                                                            0170
*     INPMA;                                                       0170
*   INCOXINV='0'B;                  /* CLEAR ALL                     */
*   INCOXSYN='0'B;                  /* ERROR FLAGS                   */
         NI    INCOXINV,B'11111001'                                0172
*   SRSTRM=SRSTRCAD;                /* STRUCTURE ENTRY               */
*   SRENDITM='1'B;                  /* END OF LIST INDICATOR         */
         OI    SRENDITM,B'10000000'                                0174
         NI    SRSTRM,B'10111111'                                  0174
*   SRRECSTR=ADDR(MFSYNTAB);        /* INITIAL STRUCTURE             */
         LA    @15,MFSYNTAB                                        0175
         ST    @15,SRRECSTR                                        0175
*   SRIPARM=0;                      /* NO PARAMETERS FOR STRUCTURE   */
         SR    @15,@15                                             0176
         ST    @15,SRIPARM                                         0176
*   CALL IRBMFANL(SRDUMITM,INSCB,INAUTPTR);/* SYNTAX CHECK INPUT     */
*                                                                  0177
         LA    @15,SRDUMITM                                        0177
         ST    @15,@AL00001                                        0177
         LA    @15,INSCB                                           0177
         ST    @15,@AL00001+4                                      0177
         LA    @15,INAUTPTR                                        0177
         ST    @15,@AL00001+8                                      0177
         L     @15,@CV00904                                        0177
         LA    @01,@AL00001                                        0177
         BALR  @14,@15                                             0177
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK FOR INVALID VALUES, MUTUALLY EXCLUSIVE OPTIONS, OR      */
*   /* SYNTAX ERRORS                                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0178
*   IF INCOXINV='1'B|INCOXSYN='1'B THEN                            0178
         TM    INCOXINV,B'00000110'                                0178
         BZ    @RF00178                                            0178
*     DO;                                                          0179
*                                                                  0179
*       /*************************************************************/
*       /*                                                           */
*       /* SET UP FOR MESSAGES                                       */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0180
*       IF INCOXSRC=SROPRATR THEN   /* OPERATOR SOURCE               */
         TM    INCOXSRC,B'00011000'                                0180
         BNZ   @RF00180                                            0180
*         DO;                                                      0181
*           SRPARTNO=LMPART9;       /* PART NO. FOR OPERATOR         */
         MVC   SRPARTNO(2),@CH00578                                0182
*           GO TO SRLAB1;           /* SET UP MESSAGE                */
         B     SRLAB1                                              0183
*         END;                                                     0184
*       IF INCOXSRC=SREXEC THEN     /* EXEC CARD SOURCE              */
@RF00180 TM    INCOXSRC,B'00001000'                                0185
         BNO   @RF00185                                            0185
         TM    INCOXSRC,B'00010000'                                0185
         BNZ   @RF00185                                            0185
*         DO;                                                      0186
*           SRPARTNO=LMPART10;      /* PART NO. FOR PARM             */
         MVC   SRPARTNO(2),@CH00580                                0187
*           GO TO SRLAB1;           /* SET UP MESSAGE                */
         B     SRLAB1                                              0188
*         END;                                                     0189
*       IF INCOXSRC=SRLIBRAY THEN   /* LIBRARY SOURCE                */
@RF00185 TM    INCOXSRC,B'00010000'                                0190
         BNO   @RF00190                                            0190
         TM    INCOXSRC,B'00001000'                                0190
         BNZ   @RF00190                                            0190
*         DO;                                                      0191
*           SRPARTNO=LMPART11;      /* PART NO. FOR LIBRARY          */
         MVC   SRPARTNO(2),@CH00582                                0192
*           GO TO SRLAB1;           /* SET UP MESSAGE                */
         B     SRLAB1                                              0193
*         END;                                                     0194
*       IF SRFORCE='1'B THEN        /* MERGE COMPLETE - MUST BE    0195
*                                      OPERATOR REPLY OF MORE VALUES */
@RF00190 L     @15,@PC00003                                        0195
         TM    SRFORCE(@15),B'10000000'                            0195
         BNO   @RF00195                                            0195
*         DO;                                                      0196
*           SRPARTNO=LMPART21;      /* PART NO. FOR REPLY            */
         MVC   SRPARTNO(2),@CH00600                                0197
*           GO TO SRLAB1;           /* SET UP MESSAGE                */
         B     SRLAB1                                              0198
*         END;                                                     0199
*                                                                  0199
*       /*************************************************************/
*       /*                                                           */
*       /* MUST BE ERROR IN PROGRAM DEFAULTS, ABEND                  */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0200
*       GENERATE(ABEND 1100,DUMP);                                 0200
@RF00195 DS    0H                                                  0200
         ABEND 1100,DUMP
*SRLAB1:                                                           0201
*                                                                  0201
*       /*************************************************************/
*       /*                                                           */
*       /* ISSUE APPROPRIATE MESSAGES                                */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0201
*       IF INCOXINV='1'B THEN       /* VALUE ERROR OR MUTUALLY     0201
*                                      EXCLUSIVE OPTIONS             */
SRLAB1   TM    INCOXINV,B'00000100'                                0201
         BNO   @RF00201                                            0201
*         DO;                                                      0202
*           INVTXLST(1)=ADDR(SRPARTNO);                            0203
         LA    @15,SRPARTNO                                        0203
         ST    @15,INVTXLST                                        0203
*           CALL INMSGMOD(MID301I,INVTXLST,0,0);/* ISSUE MESSAGE     */
         MVC   @AL00001(16),@AL00204                               0204
         LA    @15,INVTXLST                                        0204
         ST    @15,@AL00001+4                                      0204
         L     @15,INMSGADR                                        0204
         LA    @01,@AL00001                                        0204
         BALR  @14,@15                                             0204
*         END;                                                     0205
*       IF INCOXSYN='1'B THEN       /* SYNTAX ERROR FOUND            */
@RF00201 TM    INCOXSYN,B'00000010'                                0206
         BNO   @RF00206                                            0206
*         DO;                                                      0207
*                                                                  0207
*           /*********************************************************/
*           /*                                                       */
*           /* INITIALIZE VARIABLE PARTS FOR ERROR TEXT              */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0208
*           SRVTPNUM=0;             /* TEXT FOLLOWS                  */
         SR    @15,@15                                             0208
         STH   @15,SRVTPNUM                                        0208
*           SRVTLEN=INERRLEN;       /* LENGTH OF TEXT                */
         MVC   SRVTLEN(2),@CH00580                                 0209
*           SRVTEXT=INCOXER1;       /* TEXT IN ERROR                 */
         MVC   SRVTEXT(10),INCOXER1                                0210
*           INVTXLST(1)=ADDR(SRVTXLST);/* VARIABLE ERROR TEXT ADDRESS*/
         LA    @15,SRVTXLST                                        0211
         ST    @15,INVTXLST                                        0211
*           INVTXLST(2)=ADDR(SRPARTNO);/* SOURCE PART IN ERROR       */
         LA    @15,SRPARTNO                                        0212
         ST    @15,INVTXLST+4                                      0212
*           CALL INMSGMOD(MID300I,INVTXLST,0,0);/* ISSUE MESSAGE     */
         MVC   @AL00001(16),@AL00213                               0213
         LA    @15,INVTXLST                                        0213
         ST    @15,@AL00001+4                                      0213
         L     @15,INMSGADR                                        0213
         LA    @01,@AL00001                                        0213
         BALR  @14,@15                                             0213
*         END;                                                     0214
*       IF INCOXSRC=SROPRATR THEN   /* IF SOURCE IS OPERATOR         */
@RF00206 TM    INCOXSRC,B'00011000'                                0215
         BNZ   @RF00215                                            0215
*         DO;                                                      0216
*                                                                  0216
*           /*********************************************************/
*           /*                                                       */
*           /* WRITE MESSAGE TO REQUEST NEW OPTIONS OR 'IGNORE'      */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0217
*           CALL INMSGMOD(MID308A,0,INREPBUF,0);                   0217
         MVC   @AL00001(16),@AL00217                               0217
         LA    @15,INREPBUF                                        0217
         ST    @15,@AL00001+8                                      0217
         L     @15,INMSGADR                                        0217
         LA    @01,@AL00001                                        0217
         BALR  @14,@15                                             0217
*           IF INREPTXT(1:6)='IGNORE' THEN/* IGNORE START PARMS      */
         CLC   INREPTXT(6),@CC00987                                0218
         BNE   @RF00218                                            0218
*             DO;                   /* CHECK TO SEE IF REST OF REPLY
*                                      IS BLANK                      */
*               DO I=7 TO LENGTH(INREPTXT)WHILE INREPTXT(I)=' ';   0220
         LA    @15,7                                               0220
         ST    @15,I                                               0220
@DL00220 LA    @14,INREPTXT-1(@15)                                 0220
         CLI   0(@14),C' '                                         0220
         BNE   @DC00220                                            0220
*               END;                                               0221
         AH    @15,@CH00065                                        0221
         ST    @15,I                                               0221
         CH    @15,@CH00823                                        0221
         BNH   @DL00220                                            0221
@DC00220 DS    0H                                                  0222
*               IF I=LENGTH(INREPTXT)+1 THEN/* REST OF REPLY BLANK?  */
         CLC   I(4),@CF01488                                       0222
         BE    @RT00222                                            0222
*                 RETURN;           /* RETURN TO INP                 */
*             END;                                                 0224
*                                                                  0224
*/* REPLY TEXT WAS NOT IGNORE. BUILD A BUFFER AND BCB                */
*                                                                  0225
*           CALL MFBUFENQ(INREPTXT,EVAL(INREPLEN),INSCB);          0225
@RF00218 LA    @15,INREPTXT                                        0225
         ST    @15,@AL00001                                        0225
         LH    @15,INREPLEN                                        0225
         ST    @15,@AFTEMPS                                        0225
         LA    @15,@AFTEMPS                                        0225
         ST    @15,@AL00001+4                                      0225
         LA    @15,INSCB                                           0225
         ST    @15,@AL00001+8                                      0225
         LA    @01,@AL00001                                        0225
         BAL   @14,MFBUFENQ                                        0225
*           GO TO SRSTRSCN;         /* REPROCESS                     */
         B     SRSTRSCN                                            0226
*         END;                                                     0227
*                                                                  0227
*       /*************************************************************/
*       /*                                                           */
*       /* SOME OPTIONS MAY HAVE BEEN ACCEPTED FROM BAD INPUT IN THIS*/
*       /* SOURCE. LIST THESE. ISSUE MF/1 OPTIONS ASSUMED FROM SOURCE*/
*       /* IN ERROR MESSAGE                                          */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0228
*       CALL INMSGMOD(MID309I1,0,0,0);                             0228
*                                                                  0228
@RF00215 L     @15,INMSGADR                                        0228
         LA    @01,@AL00228                                        0228
         BALR  @14,@15                                             0228
*       /*************************************************************/
*       /*                                                           */
*       /* SET UP MSGID ARRAY                                        */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0229
*       SRNDXARY(1)=MID309I2;                                      0229
         MVC   SRNDXARY(2),@CH00632                                0229
*       SRNDXARY(2)=MID309I3;                                      0230
         MVC   SRNDXARY+2(2),@CH00330                              0230
*       SRNDXARY(3)=MID309I4;                                      0231
         MVC   SRNDXARY+4(2),@CH00635                              0231
*       SRNDXARY(4)=MID309I5;                                      0232
         MVC   SRNDXARY+6(2),@CH00637                              0232
*       SRNDXARY(5)=MID309I6;                                      0233
         MVC   SRNDXARY+8(2),@CH00639                              0233
*       SRNDXARY(6)=MID309I7;                                      0234
         MVC   SRNDXARY+10(2),@CH00641                             0234
*       SRNDXARY(7)=MID309I8;                                      0235
         MVC   SRNDXARY+12(2),@CH00643                             0235
*       SRNDXARY(8)=MID309I9;                                      0236
         MVC   SRNDXARY+14(2),@CH00645                             0236
*       SRNDXARY(9)=MID309IA;                                      0237
         MVC   SRNDXARY+16(2),@CH00647                             0237
*       SRNDXARY(10)=MID309IB;                                     0238
*                                                                  0238
         MVC   SRNDXARY+18(2),@CH00452                             0238
*       /*************************************************************/
*       /*                                                           */
*       /* LIST OPTIONS CHOSEN                                       */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0239
*       CALL LISTOP(SRNDXARY,ADDR(INCOA),ADDR(INMVT));             0239
         LA    @15,SRNDXARY                                        0239
         ST    @15,@AL00001                                        0239
         LA    @15,INCOA                                           0239
         ST    @15,@AFTEMPS                                        0239
         LA    @15,@AFTEMPS                                        0239
         ST    @15,@AL00001+4                                      0239
         LA    @15,INMVT                                           0239
         ST    @15,@AFTEMPS+4                                      0239
         LA    @15,@AFTEMPS+4                                      0239
         ST    @15,@AL00001+8                                      0239
         LA    @01,@AL00001                                        0239
         BAL   @14,LISTOP                                          0239
*     END;                                                         0240
*                                                                  0240
*   /*****************************************************************/
*   /*                                                               */
*   /* NOW MERGE OPTIONS VALUES INTO THE MFPMA AND MFCOA THAT WERE   */
*   /* TEMPORARILY STORED IN THE INCOA AND INPMA DURING OPTION       */
*   /* INITIALIZATION                                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0241
*   CALL MFMERGE(SRFORCE);          /* CALL MERGE                    */
@RF00178 L     @15,@PC00003                                        0241
         ST    @15,@AL00001                                        0241
         LA    @01,@AL00001                                        0241
         BAL   @14,MFMERGE                                         0241
*   RETURN;                         /* RETURN TO INP                 */
@EL00003 DS    0H                                                  0242
@EF00003 DS    0H                                                  0242
@ER00003 LM    @14,@12,@SA00003                                    0242
         BR    @14                                                 0242
*   END MFSRCPRO;                                                  0243
         B     @EL00003                                            0243
*                                                                  0244
*/*  PROCEDURE NAME = MFBUFENQ                                       */
*/*                                                                  */
*/*  DESCRIPTIVE NAME = BUFFER ENQUEING ROUTINE                      */
*/*                                                                  */
*/*  FUNCTION = THIS ROUTINE QUEUES UP THE BCBS. EACH BCB POINTS TO  */
*/*             A BUFFER CONTAINING TEXT PASSED FROM CALLING ROUTINE.*/
*/*             AS A RESULT OF QUEUEING BUFFERS AND BCBS, THE SCB AND*/
*/*             BQCB ARE UPDATED ACCORDINGLY.                        */
*/*                                                                  */
*/*                                                                  */
*                                                                  0244
*MFBUFENQ:                                                         0244
*   PROCEDURE(BUBUFTXT,BUBUFSZE,BUSCB);                            0244
MFBUFENQ STM   @14,@12,@SA00004                                    0244
         MVC   @PC00004(12),0(@01)                                 0244
*   DECLARE                                                        0245
*     BUBUFTXT                      /* TEXT TO BE PLACED IN BUFFER   */
*         CHAR(*),                                                 0245
*     BUBUFSZE                      /* LENGTH OF TEXT                */
*         FIXED(31),                                               0245
*     1 BUSCB,                      /* SCAN CONTROL BLOCK            */
*      2 BUCURBCB                   /* CURRENT BCB PTR               */
*            PTR(31),                                              0245
*      2 BUCURTXT                   /* CURRENT TEXT PTR              */
*            PTR(31),                                              0245
*      2 BUBYTLFT                   /* # BYTES LEFT                  */
*            FIXED(31),                                            0245
*        BUBUFARA                   /* PTR TO GOTTEN AREA            */
*            PTR(31),                                              0245
*        BUBUF                      /* BUFFER                        */
*            CHAR(*)BASED(BUBUFARA),                               0245
*                                                                  0245
*/* REGISTERS USED IN THE 'MVCL' INSTRUCTION                         */
*                                                                  0245
*        GPR02F REG(2)PTR(31),                                     0245
*        GPR03F REG(3)FIXED(31),                                   0245
*        GPR04F REG(4)PTR(31),                                     0245
*        GPR05F REG(5)FIXED(31),                                   0245
*                                                                  0245
*/*                                                                  */
*                                                                  0245
*     1 BUBCBCOR                    /* GETMAIN PARAMETERS            */
*           BDY(WORD),                                             0245
*      2 BUSUBPOL                   /* SUBPOOL                       */
*            FIXED(8),                                             0245
*      2 BUBUFLEN                   /* LENGTH                        */
*            FIXED(24),                                            0245
*        BUBCBARA                   /* PTR TO GOTTEN AREA FOR BCB    */
*            PTR(31);                                              0245
*                                                                  0245
*   /*****************************************************************/
*   /*                                                               */
*   /* GET CORE FOR A BCB                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0246
*   BUSUBPOL=0;                                                    0246
         MVI   BUSUBPOL,X'00'                                      0246
*   BUBUFLEN=LENGTH(INBCB);                                        0247
         MVC   BUBUFLEN(3),@CF00584+1                              0247
*   RFY                                                            0248
*    (GPR00F,                                                      0248
*     GPR01P,                                                      0248
*     GPR14P,                                                      0248
*     GPR15F)RSTD;                                                 0248
*   GPR00F=BUBCBCOR;                /* SET UP SUBPOOL ID AND LENGTH
*                                      IN REG0                       */
         L     GPR00F,BUBCBCOR                                     0249
*   GEN(GETMAIN R,LV=(0));          /* GET CORE FOR BCB              */
         GETMAIN R,LV=(0)
*   BUBCBARA=GPR01P;                /* GET ADDRESS OF THE GOTTEN CORE*/
*                                                                  0251
         ST    GPR01P,BUBCBARA                                     0251
*   /*****************************************************************/
*   /*                                                               */
*   /* GET CORE FOR A BUFFER                                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0252
*   BUBUFLEN=BUBUFSZE;              /* MOVE IN BUFFER LENGTH         */
         L     @07,@PC00004+4                                      0252
         MVC   BUBUFLEN(3),BUBUFSZE+1(@07)                         0252
*   GPR00F=BUBCBCOR;                /* SUBPOOL ID AND LENGTH         */
         L     GPR00F,BUBCBCOR                                     0253
*   GEN(GETMAIN R,LV=(0));          /* GET CORE FOR BUFFER           */
         GETMAIN R,LV=(0)
*   BUBUFARA=GPR01P;                /* GET ADDRESS OF GOTTEN CORE    */
         ST    GPR01P,BUBUFARA                                     0255
*   RFY                                                            0256
*    (GPR00F,                                                      0256
*     GPR01P,                                                      0256
*     GPR14P,                                                      0256
*     GPR15F)UNRSTD;                                               0256
*   RFY                                                            0257
*    (GPR02F,                                                      0257
*     GPR03F,                                                      0257
*     GPR04F,                                                      0257
*     GPR05F)RSTD;                                                 0257
*                                                                  0257
*/* MOVE TEXT INTO BUFFER AREA                                       */
*                                                                  0258
*   GPR02F=ADDR(BUBUF);             /* AREA TO MOVE IN TEXT          */
         L     @15,BUBUFARA                                        0258
         LR    GPR02F,@15                                          0258
*   GPR03F=BUBUFSZE;                /* LENGTH TO BE MOVED            */
         L     @15,@PC00004+4                                      0259
         L     @15,BUBUFSZE(,@15)                                  0259
         LR    GPR03F,@15                                          0259
*   GPR04F=ADDR(BUBUFTXT);          /* AREA FROM WHICH TEXT IS MOVED */
         L     GPR04F,@PC00004                                     0260
*   GPR05F=BUBUFSZE;                /* LENGTH TO BE MOVED            */
         LR    GPR05F,@15                                          0261
*   GEN(MVCL @02,@04);              /* MOVE IN TEXT                  */
         MVCL @02,@04
*   RFY                                                            0263
*    (GPR02F,                                                      0263
*     GPR03F,                                                      0263
*     GPR04F,                                                      0263
*     GPR05F)UNRSTD;                                               0263
*   IF INBCBFRS=0 THEN              /* IF THIS BCB IS 1ST ON THE   0264
*                                      CHAIN                         */
         L     @15,INBCBFRS                                        0264
         LTR   @15,@15                                             0264
         BNZ   @RF00264                                            0264
*     DO;                           /* INDICATE THIS IN THE BQCB     */
*       INBCBFRS=BUBCBARA;          /* FIRST = GOTTEN AREA           */
         L     @15,BUBCBARA                                        0266
         ST    @15,INBCBFRS                                        0266
*       INBCBLST=INBCBFRS;          /* FIRST BCB IS LAST BCB ON CHAIN*/
         ST    @15,INBCBLST                                        0267
*     END;                                                         0268
*   ELSE                            /* IF A BCB ALREADY EXISTS       */
*     DO;                                                          0269
         B     @RC00264                                            0269
@RF00264 DS    0H                                                  0270
*       INBCBLST->INBCBNXT=BUBCBARA;/* NEXT BCB IS THIS NEW BCB      */
         L     @15,BUBCBARA                                        0270
         L     @14,INBCBLST                                        0270
         ST    @15,INBCBNXT(,@14)                                  0270
*       INBCBLST=BUBCBARA;          /* THIS BCB IS LAST ON CHAIN     */
         ST    @15,INBCBLST                                        0271
*     END;                                                         0272
*   BUBCBARA->INBCBNXT=0;           /* INDICATES LAST BCB            */
@RC00264 L     @15,BUBCBARA                                        0273
         SR    @14,@14                                             0273
         ST    @14,INBCBNXT(,@15)                                  0273
*   BUBCBARA->INBCBLEN=BUBUFSZE;    /* INITIALIZE BCB BUFFER LENGTH  */
         L     @14,@PC00004+4                                      0274
         L     @14,BUBUFSZE(,@14)                                  0274
         STH   @14,INBCBLEN(,@15)                                  0274
*   BUBCBARA->INBCBTXT=BUBUFARA;    /* POINT BCB TO BUFFER           */
         L     @07,BUBUFARA                                        0275
         ST    @07,INBCBTXT(,@15)                                  0275
*   BUCURBCB=BUBCBARA;              /* CURRENT BCB IS THIS BCB       */
         L     @06,@PC00004+8                                      0276
         ST    @15,BUCURBCB(,@06)                                  0276
*   BUCURTXT=BUBUFARA;              /* CURRENT INPUT STRING NOT    0277
*                                      SCANNED IS ENTIRE INPUT STRING*/
         ST    @07,BUCURTXT(,@06)                                  0277
*   BUBYTLFT=BUBCBARA->INBCBLEN;    /* # BYTES LEFT IN BUFFER        */
         ST    @14,BUBYTLFT(,@06)                                  0278
*   RETURN;                         /* RETURN TO CALLER              */
@EL00004 DS    0H                                                  0279
@EF00004 DS    0H                                                  0279
@ER00004 LM    @14,@12,@SA00004                                    0279
         BR    @14                                                 0279
*   END MFBUFENQ;                                                  0280
*                                                                  0281
*/*  PROCEDURE NAME = MFRTEXT                                        */
*/*                                                                  */
*/*  DESCRIPTIVE NAME = TEXT RECOGNIZER                              */
*/*                                                                  */
*/*  FUNCTION = RECOGNIZES TEXT AS THE TEXT PARAMETER INDICATES.     */
*/*                                                                  */
*                                                                  0281
*MFRTEXT:                                                          0281
*   PROCEDURE(RTEXPARM,RTSCB);                                     0281
MFRTEXT  STM   @14,@12,@SA00005                                    0281
         MVC   @PC00005(8),0(@01)                                  0281
*   DECLARE                                                        0282
*     RTEXPARM                      /* PTR TO TEXT PARM LIST         */
*         PTR(31),                                                 0282
*     1 RTPARMLS BASED(RTEXPARM),   /* TEXT PARM LIST                */
*      2 RTLENGTH                   /* LENGTH OF TEXT                */
*            FIXED(8),                                             0282
*      2 RTTEXT                     /* TEXT TO LOOK FOR              */
*            CHAR(*),                                              0282
*     1 RTSCB,                      /* SCAN CONTROL BLOCK            */
*      2 RTCURBCB                   /* CURRENT BCB PTR               */
*            PTR(31),                                              0282
*      2 RTCURTXT                   /* CURRENT TEXT PTR              */
*            PTR(31),                                              0282
*      2 RTBYTLFT                   /* # BYTES LEFT IN BUFFER        */
*            FIXED(31),                                            0282
*        RTSCANER                   /* TEXT IN BUFFER                */
*            CHAR(*)BASED(RTCURTXT);                               0282
*   IF RTBYTLFT=0 THEN              /* AT END OF BUFFER?             */
         L     @15,@PC00005+4                                      0283
         L     @14,RTBYTLFT(,@15)                                  0283
         LTR   @14,@14                                             0283
         BNZ   @RF00283                                            0283
*     DO;                                                          0284
*       CALL MFNXTREC(RTSCB);       /* GET A RECORD IF ONE EXISTS    */
         ST    @15,@AL00001                                        0285
         LA    @01,@AL00001                                        0285
         BAL   @14,MFNXTREC                                        0285
*       RFY                                                        0286
*        (GPR15F)RSTD;                                             0286
*       IF GPR15F=4 THEN            /* MFNXTREC UNSUCCESSFUL?        */
         CH    GPR15F,@CH00254                                     0287
         BNE   @RF00287                                            0287
*         RETURN CODE(GPR15F);      /* YES, RETURN TO IRBMFANL       */
         L     @14,@SA00005                                        0288
         LM    @00,@12,@SA00005+8                                  0288
         BR    @14                                                 0288
*       RFY                                                        0289
*        (GPR15F)UNRSTD;                                           0289
@RF00287 DS    0H                                                  0290
*     END;                                                         0290
*   IF RTLENGTH>RTBYTLFT THEN       /* IF LENGTH OF TEXT PASSED > NO.*/
@RF00283 L     @15,@PC00005                                        0291
         L     @01,RTEXPARM(,@15)                                  0291
         L     @15,@PC00005+4                                      0291
         SR    @00,@00                                             0291
         IC    @00,RTLENGTH(,@01)                                  0291
         C     @00,RTBYTLFT(,@15)                                  0291
         BNH   @RF00291                                            0291
*                                   /* OF BYTES LEFT IN BUFFER THEN  */
*     RETURN CODE(4);               /* RETURN UNSUCCESSFUL           */
         LA    @15,4                                               0292
         L     @14,@SA00005                                        0292
         LM    @00,@12,@SA00005+8                                  0292
         BR    @14                                                 0292
*   IF RTSCANER(1:RTLENGTH)=RTTEXT(1:RTLENGTH)THEN/* A MATCH?        */
@RF00291 L     @15,@PC00005+4                                      0293
         L     @14,RTCURTXT(,@15)                                  0293
         L     @07,@PC00005                                        0293
         L     @07,RTEXPARM(,@07)                                  0293
         SR    @06,@06                                             0293
         IC    @06,RTLENGTH(,@07)                                  0293
         LR    @05,@06                                             0293
         BCTR  @05,0                                               0293
         EX    @05,@SC01510                                        0293
         BNE   @RF00293                                            0293
*     DO;                                                          0294
*       RTCURTXT=RTCURTXT+RTLENGTH; /* UPDATE CRRENT TEXT PTR        */
         AR    @14,@06                                             0295
         ST    @14,RTCURTXT(,@15)                                  0295
*       RTBYTLFT=RTBYTLFT-RTLENGTH; /* DECREASE # BYTES LEFT         */
         LCR   @06,@06                                             0296
         A     @06,RTBYTLFT(,@15)                                  0296
         ST    @06,RTBYTLFT(,@15)                                  0296
*       RETURN CODE(0);             /* RETURN SUCCESSFUL             */
         SR    @15,@15                                             0297
         L     @14,@SA00005                                        0297
         LM    @00,@12,@SA00005+8                                  0297
         BR    @14                                                 0297
*     END;                                                         0298
*   RETURN CODE(4);                 /* RETURN UNSUCCESSFUL           */
@RF00293 LA    @15,4                                               0299
         L     @14,@SA00005                                        0299
         LM    @00,@12,@SA00005+8                                  0299
         BR    @14                                                 0299
*   END MFRTEXT;                                                   0300
*                                                                  0301
*/*  PROCEDURE NAME = MFRBLANK                                       */
*/*                                                                  */
*/*  DESCRIPTIVE NAME = BLANK RECOGNIZER                             */
*/*                                                                  */
*/*  FUNCTION = RECOGNIZES BLANKS DEPENDING ON THE INPUT PARAMTER.   */
*/*             THIS RECOGNIZER WILL ALWAYS RETURN SUCCESSFULLY (EVEN*/
*/*             IF NO BLANKS OR COMMENTS WERE FOUND) OR IT WILL      */
*/*             RETURN A SUCCESSFUL INDICATION ONLY IF AT LEAST ONE  */
*/*             BLANK OR COMMENT IS FOUND. (DELIMITER TYPE).         */
*/*                                                                  */
*                                                                  0301
*MFRBLANK:                                                         0301
*   PROCEDURE(RBTYPE,RBSCB);                                       0301
MFRBLANK STM   @14,@12,@SA00006                                    0301
         MVC   @PC00006(8),0(@01)                                  0301
*   DECLARE                                                        0302
*     RBTYPE                        /* PTR TO TYPE OF BLANK        0302
*                                      RECOGNIZER TO BE EXECUTED     */
*         PTR(31),                                                 0302
*     RBTYPBIT                      /* TYPE OF BLANK RECOGNIZER 0 -
*                                      GENERAL BLANK RECOGNIZER 1 -
*                                      DELIMITER TYPE BLANK        0302
*                                      RECOGNIZER                    */
*         BASED(RBTYPE)BIT(1),                                     0302
*     1 RBSCB,                      /* SCAN CONTROL BLOCK            */
*      2 RBCURBCB                   /* CURRENT BCB PTR               */
*            PTR(31),                                              0302
*      2 RBCURTXT                   /* CURRENT TXT PTR               */
*            PTR(31),                                              0302
*      2 RBBYTLFT                   /* # BYTES LEFT                  */
*            FIXED(31),                                            0302
*        RBTXTPTR                   /* PTR TO TEXT IN BUFFER         */
*            PTR(31),                                              0302
*        RBCHAR                     /* CHARACTER POINTED TO BY     0302
*                                      RBTXTPTR                      */
*            CHAR(*)BASED(RBTXTPTR),                               0302
*        RBFINISH                   /* FINISH SCANNING FOR BLANKS OR
*                                      COMMENTS                      */
*            BIT(1),                                               0302
*        RBFOUND                    /* FOUND BLANKS OR COMMENTS      */
*            BIT(1),                                               0302
*        RBCOMBEG                   /* BEGINNING DELIMITER FOR COMENT*/
*            CHAR(2)STATIC LOCAL GEND,                             0302
*        RBCOMEND                   /* END DELIMITER FOR COMMENT     */
*            CHAR(2)STATIC LOCAL GEND,                             0302
*        RBCOMENT                   /* COMMENT SCANNER               */
*            FIXED(31);                                            0302
*   GEN DATA DEFS(RBCOMBEG,RBCOMEND);                              0303
*   RBFOUND='0'B;                                                  0304
         NI    RBFOUND,B'01111111'                                 0304
*   RBFINISH='0'B;                  /* INITIALIZE FINISH BIT         */
         NI    RBFINISH,B'01111111'                                0305
*   DO WHILE RBFINISH='0'B;                                        0306
         B     @DE00306                                            0306
@DL00306 DS    0H                                                  0307
*     IF RBBYTLFT=0 THEN            /* AT END OF BUFFER?             */
         L     @15,@PC00006+4                                      0307
         L     @14,RBBYTLFT(,@15)                                  0307
         LTR   @14,@14                                             0307
         BNZ   @RF00307                                            0307
*       DO;                                                        0308
*         CALL MFNXTREC(RBSCB);     /* GET A RECORD IF ONE EXISTS    */
         ST    @15,@AL00001                                        0309
         LA    @01,@AL00001                                        0309
         BAL   @14,MFNXTREC                                        0309
*         RFY                                                      0310
*          (GPR15F)RSTD;                                           0310
*         IF GPR15F=4 THEN          /* NO MORE RECORDS?              */
         CH    GPR15F,@CH00254                                     0311
         BNE   @RF00311                                            0311
*           DO;                                                    0312
*             RBFINISH='1'B;        /* INDICATE SCAN IS FINISHED     */
         OI    RBFINISH,B'10000000'                                0313
*             GOTO RBENDLOP;        /* END THIS LOOP                 */
         B     RBENDLOP                                            0314
*             RFY                                                  0315
*              (GPR15F)UNRSTD;                                     0315
*           END;                                                   0316
*       END;                                                       0317
*                                                                  0317
@RF00311 DS    0H                                                  0318
*     /***************************************************************/
*     /*                                                             */
*     /* SCAN FOR BLANKS OR COMMENTS                                 */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0318
*     DO RBTXTPTR=RBCURTXT TO RBCURTXT+RBBYTLFT-1;                 0318
@RF00307 L     @15,@PC00006+4                                      0318
         L     @15,RBCURTXT(,@15)                                  0318
         B     @DE00318                                            0318
@DL00318 DS    0H                                                  0319
*       IF RBTXTPTR=RBCURTXT+RBBYTLFT-1 THEN/* REACHED END OF BUFFER?*/
         L     @14,@PC00006+4                                      0319
         L     @07,RBCURTXT(,@14)                                  0319
         A     @07,RBBYTLFT(,@14)                                  0319
         BCTR  @07,0                                               0319
         CR    @15,@07                                             0319
         BE    @RT00319                                            0319
*         GOTO RBCHKBLN;            /* CHECK FOR BLANKS              */
*       IF RBCHAR(1:2)=RBCOMBEG THEN/* BEGINNING OF A COMMENT?       */
         CLC   RBCHAR(2,@15),RBCOMBEG                              0321
         BNE   @RF00321                                            0321
*         DO;                                                      0322
*           RBFOUND='1'B;           /* COMMENT BEGINNING FOUND       */
         OI    RBFOUND,B'10000000'                                 0323
*RBCOMSCN:                                                         0324
*           ;                                                      0324
*                                                                  0324
RBCOMSCN DS    0H                                                  0325
*/* SCAN THROUGH COMMENT TEXT                                        */
*                                                                  0325
*           DO RBCOMENT=1 BY 1 WHILE RBCOMENT+RBTXTPTR<RBCURTXT+   0325
*                 RBBYTLFT;                                        0325
         LA    @15,1                                               0325
         ST    @15,RBCOMENT                                        0325
         B     @DE00325                                            0325
@DL00325 DS    0H                                                  0326
*             IF RBCHAR(RBCOMENT:RBCOMENT+1)=RBCOMEND THEN/* REACHED
*                                      END OF COMMENT?               */
         L     @15,RBTXTPTR                                        0326
         L     @14,RBCOMENT                                        0326
         ALR   @14,@15                                             0326
         AL    @14,@CF01512                                        0326
         CLC   RBCHAR(2,@14),RBCOMEND                              0326
         BNE   @RF00326                                            0326
*               DO;                                                0327
*                 RBTXTPTR=RBTXTPTR+RBCOMENT;/* UPDATE PTR IN BUFFER */
         L     @14,RBCOMENT                                        0328
         AR    @15,@14                                             0328
         ST    @15,RBTXTPTR                                        0328
*                 GOTO RBLOOP;      /* END THIS LOOP                 */
         B     RBLOOP                                              0329
*               END;                                               0330
*           END;                                                   0331
@RF00326 LA    @15,1                                               0331
         A     @15,RBCOMENT                                        0331
         ST    @15,RBCOMENT                                        0331
@DE00325 L     @15,RBCOMENT                                        0331
         A     @15,RBTXTPTR                                        0331
         L     @14,@PC00006+4                                      0331
         L     @07,RBCURTXT(,@14)                                  0331
         A     @07,RBBYTLFT(,@14)                                  0331
         CR    @15,@07                                             0331
         BL    @DL00325                                            0331
*           RBCURTXT=RBCURTXT+RBBYTLFT;/* UPDATE CURRENT TXT PTR     */
         ST    @07,RBCURTXT(,@14)                                  0332
*           RBBYTLFT=0;             /* INDICATE NO BYTES LEFT        */
         SR    @15,@15                                             0333
         ST    @15,RBBYTLFT(,@14)                                  0333
*           CALL MFNXTREC(RBSCB);   /* GET NEXT RECORD               */
         ST    @14,@AL00001                                        0334
         LA    @01,@AL00001                                        0334
         BAL   @14,MFNXTREC                                        0334
*           RFY                                                    0335
*            (GPR15F)RSTD;                                         0335
*           IF GPR15F=0 THEN        /* DID A RECORD EXIST?           */
         LTR   GPR15F,GPR15F                                       0336
         BNZ   @RF00336                                            0336
*             DO;                                                  0337
*               RBTXTPTR=RBCURTXT;  /* POINT TO BEGINNING OF BUFFER  */
         L     @14,@PC00006+4                                      0338
         MVC   RBTXTPTR(4),RBCURTXT(@14)                           0338
*               GOTO RBCOMSCN;      /* CONTINUE SCAN FOR COMMENTS    */
         B     RBCOMSCN                                            0339
*               RFY                                                0340
*                (GPR15F)UNRSTD;                                   0340
*             END;                                                 0341
*           RBFINISH='1'B;          /* NO MORE TEXT, SCAN IS FINISHED*/
@RF00336 OI    RBFINISH,B'10000000'                                0342
*           GOTO RBENDLOP;          /* END THIS LOOP                 */
         B     RBENDLOP                                            0343
*         END;                                                     0344
*RBCHKBLN:                                                         0345
*       ;                                                          0345
*                                                                  0345
@RF00321 DS    0H                                                  0345
RBCHKBLN DS    0H                                                  0346
*/* SCAN FOR BLANKS                                                  */
*                                                                  0346
*       IF RBCHAR(1:1)^=' ' THEN    /* NONBLANK CHARACTER?           */
         L     @01,RBTXTPTR                                        0346
         CLI   RBCHAR(@01),C' '                                    0346
         BE    @RF00346                                            0346
*         DO;                                                      0347
*           RBFINISH='1'B;          /* YES, BLANK SCAN IS FINISHED   */
         OI    RBFINISH,B'10000000'                                0348
*           GOTO RBENDSCN;          /* UPDATE BCB AND SCB            */
         B     RBENDSCN                                            0349
*         END;                                                     0350
*       RBFOUND='1'B;               /* BLANK FOUND                   */
@RF00346 OI    RBFOUND,B'10000000'                                 0351
*RBLOOP:                                                           0352
*       ;                                                          0352
RBLOOP   DS    0H                                                  0353
*     END;                                                         0353
         LA    @15,1                                               0353
         A     @15,RBTXTPTR                                        0353
@DE00318 ST    @15,RBTXTPTR                                        0353
         L     @14,@PC00006+4                                      0353
         L     @07,@PC00006+4                                      0353
         L     @14,RBCURTXT(,@14)                                  0353
         A     @14,RBBYTLFT(,@07)                                  0353
         BCTR  @14,0                                               0353
         CR    @15,@14                                             0353
         BNH   @DL00318                                            0353
*RBENDSCN:                                                         0354
*     ;                                                            0354
RBENDSCN DS    0H                                                  0355
*     RBBYTLFT=RBBYTLFT-(RBTXTPTR-RBCURTXT);/* NO. BYTES LEFT        */
         L     @15,@PC00006+4                                      0355
         L     @14,RBTXTPTR                                        0355
         LR    @07,@14                                             0355
         S     @07,RBCURTXT(,@15)                                  0355
         LCR   @07,@07                                             0355
         A     @07,RBBYTLFT(,@15)                                  0355
         ST    @07,RBBYTLFT(,@15)                                  0355
*     RBCURTXT=RBTXTPTR;            /* UPDATE CURRENT TEXT PTR       */
         ST    @14,RBCURTXT(,@15)                                  0356
*RBENDLOP:                                                         0357
*     ;                                                            0357
RBENDLOP DS    0H                                                  0358
*   END;                                                           0358
@DE00306 TM    RBFINISH,B'10000000'                                0358
         BZ    @DL00306                                            0358
*   IF RBFOUND='0'B&RBTYPBIT='1'B THEN/* NO BLANKS/COMMENTS FOUND?   */
         TM    RBFOUND,B'10000000'                                 0359
         BNZ   @RF00359                                            0359
         L     @15,@PC00006                                        0359
         L     @01,RBTYPE(,@15)                                    0359
         TM    RBTYPBIT(@01),B'10000000'                           0359
         BNO   @RF00359                                            0359
*     RETURN CODE(4);               /* RETURN UNSUCCESSFUL           */
         LA    @15,4                                               0360
         L     @14,@SA00006                                        0360
         LM    @00,@12,@SA00006+8                                  0360
         BR    @14                                                 0360
*   RETURN CODE(0);                 /* RETURN SUCCESSFUL             */
@RF00359 SR    @15,@15                                             0361
         L     @14,@SA00006                                        0361
         LM    @00,@12,@SA00006+8                                  0361
         BR    @14                                                 0361
*   END MFRBLANK;                                                  0362
*                                                                  0363
*/*  PROCEDURE = MFRRERR                                             */
*/*                                                                  */
*/*  DESCRIPTIVE NAME = ERROR RECOGNIZER                             */
*/*                                                                  */
*/*  FUNCTION = SKIPS TEXT UP TO BUT NOT INCLUDING A COMMA, COMMENT, */
*/*             BLANK OR RIGHT PARENTHESIS.                          */
*/*                                                                  */
*                                                                  0363
*MFRRERR:                                                          0363
*   PROCEDURE(RRPARM,RRSCB);                                       0363
MFRRERR  STM   @14,@12,@SA00007                                    0363
         MVC   @PC00007(8),0(@01)                                  0363
*   DECLARE                                                        0364
*     RRPARM                        /* PTR TO A PARAMETER LIST       */
*         PTR(31),                                                 0364
*     1 RRPARMLS                    /* PARAMETER LIST                */
*           BASED(RRPARM),                                         0364
*      2 RRTYPE                     /* TYPE OF ERROR RECOGNIZER      */
*            BIT(1),                                               0364
*      2 *                          /* NOT USED                      */
*            BIT(7),                                               0364
*      2 RRLENGTH                   /* LENGTH OF ERROR TEXT TO BE  0364
*                                      SAVED FOR FUTURE REFERENCE    */
*            FIXED(8),                                             0364
*      2 RRSAVETX                   /* CODE FOR WHERE TO SAVE        */
*            FIXED(8),                                             0364
*     1 RRSCB,                      /* SCB PASSED FROM ANALYZER      */
*      2 RRCURBCB                   /* CURRENT BCB PTR               */
*            PTR(31),                                              0364
*      2 RRTXTCUR                   /* CURRENT TEXT PTR              */
*            PTR(31),                                              0364
*      2 RRBYTLFT                   /* NO. BYTES LEFT IN BUFFER      */
*            FIXED(31),                                            0364
*        RRTXTPTR                   /* PTR TO TEXT IN BUFFER         */
*            PTR(31),                                              0364
*        RRCHAR                     /* CHARS. IN BUFFER              */
*            CHAR(2)BASED(RRTXTPTR),                               0364
*        RRERRTXT                   /* BEGINNING OF ERROR TEXT       */
*            CHAR(*)BASED(INERRPTR(RRSAVETX)),                     0364
*        RRFINISH                   /* FINISHED LOOPING INDICATOR    */
*            BIT(1),                                               0364
*        RRFOUND                    /* ERROR TEXT FOUND              */
*            BIT(1),                                               0364
*        RRERRSCN                   /* # CHARACTERS SCANNED          */
*            FIXED(31),                                            0364
*        RRCOMBEG                   /* COMMENT DELIMITER             */
*            CHAR(2)STATIC LOCAL GEND;                             0364
*   GENERATE DATA DEFS(RRCOMBEG);                                  0365
*   IF RRSAVETX^=0 THEN             /* SAVE ERROR TEXT?              */
         L     @15,@PC00007                                        0366
         L     @01,RRPARM(,@15)                                    0366
         CLI   RRSAVETX(@01),0                                     0366
         BE    @RF00366                                            0366
*     DO I=1 TO RRLENGTH;                                          0367
         LA    @15,1                                               0367
         B     @DE00367                                            0367
@DL00367 DS    0H                                                  0368
*       RRERRTXT(I)=' ';            /* CLEAR OUT SAVING PLACE        */
         L     @14,@PC00007                                        0368
         L     @01,RRPARM(,@14)                                    0368
         SR    @14,@14                                             0368
         IC    @14,RRSAVETX(,@01)                                  0368
         SLA   @14,2                                               0368
         L     @01,INERRPTR-4(@14)                                 0368
         ALR   @01,@15                                             0368
         AL    @01,@CF01512                                        0368
         MVI   RRERRTXT(@01),C' '                                  0368
*     END;                                                         0369
         AH    @15,@CH00065                                        0369
@DE00367 ST    @15,I                                               0369
         L     @14,@PC00007                                        0369
         L     @14,RRPARM(,@14)                                    0369
         MVC   @ZT00003+3(1),RRLENGTH(@14)                         0369
         C     @15,@ZT00003                                        0369
         BNH   @DL00367                                            0369
*   RRFOUND='0'B;                   /* INITIALIZE FOUND BIT          */
@RF00366 NI    RRFOUND,B'01111111'                                 0370
*   RRFINISH='0'B;                  /* INITIALIZE FINISH BIT         */
         NI    RRFINISH,B'01111111'                                0371
*   RRERRSCN=1;                     /* INITIALIZE TEXT SCAN          */
         MVC   RRERRSCN(4),@CF00065                                0372
*   DO WHILE RRFINISH='0'B;                                        0373
         B     @DE00373                                            0373
@DL00373 DS    0H                                                  0374
*     IF RRBYTLFT=0 THEN            /* AT END OF BUFFER?             */
         L     @15,@PC00007+4                                      0374
         L     @14,RRBYTLFT(,@15)                                  0374
         LTR   @14,@14                                             0374
         BNZ   @RF00374                                            0374
*       DO;                                                        0375
*         CALL MFNXTREC(RRSCB);     /* GET NEXT RECORD               */
         ST    @15,@AL00001                                        0376
         LA    @01,@AL00001                                        0376
         BAL   @14,MFNXTREC                                        0376
*         RFY                                                      0377
*          (GPR15F)RSTD;                                           0377
*         IF GPR15F=4 THEN          /* NO MORE RECORDS?              */
         CH    GPR15F,@CH00254                                     0378
         BNE   @RF00378                                            0378
*           DO;                                                    0379
*             RRFINISH='1'B;        /* INDICATE LOOP FINISHED        */
         OI    RRFINISH,B'10000000'                                0380
*             GOTO RRENDLOP;        /* END THIS LOOP                 */
         B     RRENDLOP                                            0381
*           END;                                                   0382
*         RFY                                                      0383
*          (GPR15F)UNRSTD;                                         0383
@RF00378 DS    0H                                                  0384
*       END;                                                       0384
*     IF RRTYPE='0'B THEN           /* SKIP UP TO COMMA, BLANK OR  0385
*                                      COMMENT                       */
@RF00374 L     @15,@PC00007                                        0385
         L     @01,RRPARM(,@15)                                    0385
         TM    RRTYPE(@01),B'10000000'                             0385
         BNZ   @RF00385                                            0385
*       DO RRTXTPTR=RRTXTCUR TO RRTXTCUR+RRBYTLFT-1;               0386
         L     @15,@PC00007+4                                      0386
         L     @15,RRTXTCUR(,@15)                                  0386
         B     @DE00386                                            0386
@DL00386 DS    0H                                                  0387
*         IF RRCHAR(1:1)=','|RRCHAR(1:1)=' ' THEN/* COMMA OR BLANK?  */
         CLI   RRCHAR(@15),C','                                    0387
         BE    @RT00387                                            0387
         CLI   RRCHAR(@15),C' '                                    0387
         BE    @RT00387                                            0387
*           GOTO RRSCNEND;          /* END THIS LOOP                 */
*         IF RRTXTPTR=RRTXTCUR+RRBYTLFT-1 THEN/* REACHED END OF    0389
*                                      BUFFER?                       */
         L     @14,@PC00007+4                                      0389
         L     @07,RRTXTCUR(,@14)                                  0389
         A     @07,RRBYTLFT(,@14)                                  0389
         BCTR  @07,0                                               0389
         CR    @15,@07                                             0389
         BE    @RT00389                                            0389
*           GOTO RRUPDATE;          /* MOVE IN ERROR TEXT            */
*         IF RRCHAR(1:2)=RRCOMBEG THEN/* BEGINNING OF A COMMENT?     */
         CLC   RRCHAR(2,@15),RRCOMBEG                              0391
         BE    @RT00391                                            0391
*           GOTO RRSCNEND;          /* UPDATE BCB & SCB              */
*RRUPDATE:                                                         0393
*         RRFOUND='1'B;             /* INDICATE END OF BUFFER        */
RRUPDATE OI    RRFOUND,B'10000000'                                 0393
*         IF RRERRSCN<=RRLENGTH&RRSAVETX^=0 THEN/* MOVE IN ERROR   0394
*                                      TEXT?                         */
         L     @15,RRERRSCN                                        0394
         L     @14,@PC00007                                        0394
         L     @14,RRPARM(,@14)                                    0394
         MVC   @ZT00003+3(1),RRLENGTH(@14)                         0394
         C     @15,@ZT00003                                        0394
         BH    @RF00394                                            0394
         CLI   RRSAVETX(@14),0                                     0394
         BE    @RF00394                                            0394
*           DO;                                                    0395
*             RRERRTXT(RRERRSCN)=RRCHAR(1);/* YES, ONE CHAR AT A TIME*/
         SR    @07,@07                                             0396
         IC    @07,RRSAVETX(,@14)                                  0396
         SLA   @07,2                                               0396
         L     @01,INERRPTR-4(@07)                                 0396
         ALR   @01,@15                                             0396
         AL    @01,@CF01512                                        0396
         L     @14,RRTXTPTR                                        0396
         MVC   RRERRTXT(1,@01),RRCHAR(@14)                         0396
*             RRERRSCN=RRERRSCN+1;  /* NUMBER OF CHAR. MOVED         */
         AH    @15,@CH00065                                        0397
         ST    @15,RRERRSCN                                        0397
*           END;                                                   0398
*       END;                                                       0399
@RF00394 LA    @15,1                                               0399
         A     @15,RRTXTPTR                                        0399
@DE00386 ST    @15,RRTXTPTR                                        0399
         L     @14,@PC00007+4                                      0399
         L     @07,@PC00007+4                                      0399
         L     @14,RRTXTCUR(,@14)                                  0399
         A     @14,RRBYTLFT(,@07)                                  0399
         BCTR  @14,0                                               0399
         CR    @15,@14                                             0399
         BNH   @DL00386                                            0399
*     ELSE                          /* SKIP UP TO COMMA,BLANK,COMMENT
*                                      OR RIGHT PAREN                */
*       DO RRTXTPTR=RRTXTCUR TO RRTXTCUR+RRBYTLFT-1;               0400
         B     @RC00385                                            0400
@RF00385 L     @15,@PC00007+4                                      0400
         L     @15,RRTXTCUR(,@15)                                  0400
         B     @DE00400                                            0400
@DL00400 DS    0H                                                  0401
*         IF RRCHAR(1:1)=','|RRCHAR(1:1)=' '|RRCHAR(1:1)=')'/*     0401
*                                      COMMA,BLANK OR RIGHT PAREN?   */
*           THEN                    /* STOP SCAN                     */
         CLI   RRCHAR(@15),C','                                    0401
         BE    @RT00401                                            0401
         CLI   RRCHAR(@15),C' '                                    0401
         BE    @RT00401                                            0401
         CLI   RRCHAR(@15),C')'                                    0401
         BE    @RT00401                                            0401
*           GOTO RRSCNEND;          /* UPDATE BCB & SCB              */
*         IF RRTXTPTR=RRTXTCUR+RRBYTLFT-1 THEN/* REACHED END OF    0403
*                                      BUFFER?                       */
         L     @14,@PC00007+4                                      0403
         L     @07,RRTXTCUR(,@14)                                  0403
         A     @07,RRBYTLFT(,@14)                                  0403
         BCTR  @07,0                                               0403
         CR    @15,@07                                             0403
         BE    @RT00403                                            0403
*           GOTO RRUPDAT2;          /* MOVE IN ERROR TEXT            */
*         IF RRCHAR(1:2)=RRCOMBEG THEN/* BEGINNING OF A COMMENT?     */
         CLC   RRCHAR(2,@15),RRCOMBEG                              0405
         BE    @RT00405                                            0405
*           GOTO RRSCNEND;          /* UPDATE BCB & SCB              */
*RRUPDAT2:                                                         0407
*         RRFOUND='1'B;             /* INDICATE END OF BUFFER        */
RRUPDAT2 OI    RRFOUND,B'10000000'                                 0407
*         IF RRERRSCN<=RRLENGTH&RRSAVETX^=0 THEN/* MOVE IN ERROR   0408
*                                      TEXT?                         */
         L     @15,RRERRSCN                                        0408
         L     @14,@PC00007                                        0408
         L     @14,RRPARM(,@14)                                    0408
         MVC   @ZT00003+3(1),RRLENGTH(@14)                         0408
         C     @15,@ZT00003                                        0408
         BH    @RF00408                                            0408
         CLI   RRSAVETX(@14),0                                     0408
         BE    @RF00408                                            0408
*           DO;                                                    0409
*             RRERRTXT(RRERRSCN)=RRCHAR(1);/* YES, ONE CHAR. AT A  0410
*                                      TIME                          */
         SR    @07,@07                                             0410
         IC    @07,RRSAVETX(,@14)                                  0410
         SLA   @07,2                                               0410
         L     @01,INERRPTR-4(@07)                                 0410
         ALR   @01,@15                                             0410
         AL    @01,@CF01512                                        0410
         L     @14,RRTXTPTR                                        0410
         MVC   RRERRTXT(1,@01),RRCHAR(@14)                         0410
*             RRERRSCN=RRERRSCN+1;  /* NUMBER OF CHAR. MOVED         */
         AH    @15,@CH00065                                        0411
         ST    @15,RRERRSCN                                        0411
*           END;                                                   0412
*       END;                                                       0413
@RF00408 LA    @15,1                                               0413
         A     @15,RRTXTPTR                                        0413
@DE00400 ST    @15,RRTXTPTR                                        0413
         L     @14,@PC00007+4                                      0413
         L     @07,@PC00007+4                                      0413
         L     @14,RRTXTCUR(,@14)                                  0413
         A     @14,RRBYTLFT(,@07)                                  0413
         BCTR  @14,0                                               0413
         CR    @15,@14                                             0413
         BNH   @DL00400                                            0413
*RRSCNEND:                                                         0414
*     ;                                                            0414
@RC00385 DS    0H                                                  0414
RRSCNEND DS    0H                                                  0415
*     RRBYTLFT=RRBYTLFT-(RRTXTPTR-RRTXTCUR);/* NUMBER OF BYTES LEFT  */
         L     @15,@PC00007+4                                      0415
         L     @14,RRTXTPTR                                        0415
         LR    @07,@14                                             0415
         S     @07,RRTXTCUR(,@15)                                  0415
         LCR   @07,@07                                             0415
         A     @07,RRBYTLFT(,@15)                                  0415
         ST    @07,RRBYTLFT(,@15)                                  0415
*     RRTXTCUR=RRTXTPTR;            /* UPDATE CURRENT TEXT PTR       */
         ST    @14,RRTXTCUR(,@15)                                  0416
*     IF RRBYTLFT^=0 THEN           /* AT END OF BUFFER?             */
         LTR   @07,@07                                             0417
         BZ    @RF00417                                            0417
*       RRFINISH='1'B;              /* INDICATE SO                   */
         OI    RRFINISH,B'10000000'                                0418
*RRENDLOP:                                                         0419
*     ;                                                            0419
@RF00417 DS    0H                                                  0419
RRENDLOP DS    0H                                                  0420
*   END;                                                           0420
@DE00373 TM    RRFINISH,B'10000000'                                0420
         BZ    @DL00373                                            0420
*   IF RRFOUND='0'B THEN            /* NO TEXT SKIPPED?              */
         TM    RRFOUND,B'10000000'                                 0421
         BNZ   @RF00421                                            0421
*     RETURN CODE(4);               /* RETURN UNSUCCESSFUL           */
         LA    @15,4                                               0422
         L     @14,@SA00007                                        0422
         LM    @00,@12,@SA00007+8                                  0422
         BR    @14                                                 0422
*   ELSE                            /* MOVE IN MORE TEXT FOR CLARITY */
*     DO;                                                          0423
@RF00421 DS    0H                                                  0424
*       DO RRTXTPTR=RRTXTCUR TO RRTXTCUR+RRBYTLFT-1 WHILE(RRERRSCN<=
*             RRLENGTH&RRSAVETX^=0);                               0424
         L     @15,@PC00007+4                                      0424
         L     @15,RRTXTCUR(,@15)                                  0424
         B     @DE00424                                            0424
@DL00424 L     @14,RRERRSCN                                        0424
         L     @07,@PC00007                                        0424
         L     @07,RRPARM(,@07)                                    0424
         MVC   @ZT00003+3(1),RRLENGTH(@07)                         0424
         C     @14,@ZT00003                                        0424
         BH    @DC00424                                            0424
         CLI   RRSAVETX(@07),0                                     0424
         BE    @DC00424                                            0424
*         RRERRTXT(RRERRSCN)=RRCHAR(1);/* MOVE IN MORE TEXT FOR    0425
*                                      CLARITY                       */
         SR    @06,@06                                             0425
         IC    @06,RRSAVETX(,@07)                                  0425
         SLA   @06,2                                               0425
         L     @01,INERRPTR-4(@06)                                 0425
         ALR   @01,@14                                             0425
         AL    @01,@CF01512                                        0425
         MVC   RRERRTXT(1,@01),RRCHAR(@15)                         0425
*         RRERRSCN=RRERRSCN+1;      /* NUMBER OF CHAR. MOVED         */
         AH    @14,@CH00065                                        0426
         ST    @14,RRERRSCN                                        0426
*       END;                                                       0427
*                                                                  0427
         AH    @15,@CH00065                                        0427
@DE00424 ST    @15,RRTXTPTR                                        0427
         L     @14,@PC00007+4                                      0427
         L     @07,@PC00007+4                                      0427
         L     @14,RRTXTCUR(,@14)                                  0427
         A     @14,RRBYTLFT(,@07)                                  0427
         BCTR  @14,0                                               0427
         CR    @15,@14                                             0427
         BNH   @DL00424                                            0427
@DC00424 DS    0H                                                  0428
*       /*************************************************************/
*       /*                                                           */
*       /* FILL WITH BLANKS                                          */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0428
*       DO RRERRSCN=RRERRSCN TO RRLENGTH WHILE RRSAVETX^=0;        0428
         L     @15,RRERRSCN                                        0428
         B     @DE00428                                            0428
@DL00428 L     @14,@PC00007                                        0428
         L     @14,RRPARM(,@14)                                    0428
         CLI   RRSAVETX(@14),0                                     0428
         BE    @DC00428                                            0428
*         RRERRTXT(RRERRSCN)=' ';                                  0429
         SR    @07,@07                                             0429
         IC    @07,RRSAVETX(,@14)                                  0429
         SLA   @07,2                                               0429
         L     @01,INERRPTR-4(@07)                                 0429
         ALR   @01,@15                                             0429
         AL    @01,@CF01512                                        0429
         MVI   RRERRTXT(@01),C' '                                  0429
*       END;                                                       0430
         AH    @15,@CH00065                                        0430
         ST    @15,RRERRSCN                                        0430
@DE00428 L     @14,@PC00007                                        0430
         L     @14,RRPARM(,@14)                                    0430
         MVC   @ZT00003+3(1),RRLENGTH(@14)                         0430
         C     @15,@ZT00003                                        0430
         BNH   @DL00428                                            0430
@DC00428 DS    0H                                                  0431
*     END;                                                         0431
*   RETURN CODE(0);                 /* RETURN SUCCESSFUL             */
         SR    @15,@15                                             0432
         L     @14,@SA00007                                        0432
         LM    @00,@12,@SA00007+8                                  0432
         BR    @14                                                 0432
*   END MFRRERR;                                                   0433
*                                                                  0434
*/* PROCEDURE NAME = MFRINTGR                                        */
*/*                                                                  */
*/*  DESCRIPTIVE NAME = INTEGER RECOGNIZER                           */
*/*                                                                  */
*/*  FUNCTION = RECOGNIZES ANY INTEGER, CONVERTS IT AND SAVES IT FOR */
*/*             OPTION INITIALIZATION.                               */
*/*                                                                  */
*/* DEPENDENCY = CHARACTER CODE DEPENDENT                            */
*/*                                                                  */
*                                                                  0434
*MFRINTGR:                                                         0434
*   PROCEDURE(RISAVNUM,RISCB);                                     0434
MFRINTGR STM   @14,@12,@SA00008                                    0434
         MVC   @PC00008(8),0(@01)                                  0434
*   DECLARE                                                        0435
*     RISAVNUM                      /* PLACE TO STORE INTEGER PTR    */
*         PTR(31),                                                 0435
*     1 RISCB,                      /* SCAN CONTROL BLOCK            */
*      2 RICURBCB                   /* CURRENT BCB PTR               */
*            PTR(31),                                              0435
*      2 RICURTXT                   /* CURRENT TEXT PTR              */
*            PTR(31),                                              0435
*      2 RIBYTLFT                   /* # BYTES LEFT                  */
*            FIXED(31),                                            0435
*        RINUMBER                   /* COMPUTED VALUE OF INTEGER     */
*            FIXED(32),                                            0435
*        RIINTGER                   /* NUMBER IN SOURCE'S BUFFER     */
*            CHAR(1)BASED(RICURTXT),                               0435
*        RIINTDEC                   /* ACTUAL NUMBER                 */
*            CHAR(1),                                              0435
*        RITEMNUM                   /* TEMPORARY VALUE               */
*            FIXED(32),                                            0435
*        RIINTFND                   /* INTEGER FOUND INDICATOR       */
*            BIT(1),                                               0435
*        RINUMVAL                   /* PLACE TO STORE INTEGER        */
*            BASED(ININTPTR(RINUMCOD))FIXED(32),                   0435
*        RINUMCOD                   /* CODE FOR WHERE TO SAVE        */
*            FIXED(8)BASED(RISAVNUM);                              0435
*   RINUMBER=0;                                                    0436
         SR    @15,@15                                             0436
         ST    @15,RINUMBER                                        0436
*   RIINTFND='0'B;                                                 0437
         NI    RIINTFND,B'01111111'                                0437
*   IF RIBYTLFT=0 THEN              /* AT END OF BUFFER?             */
         L     @14,@PC00008+4                                      0438
         C     @15,RIBYTLFT(,@14)                                  0438
         BNE   @RF00438                                            0438
*     DO;                                                          0439
*       CALL MFNXTREC(RISCB);       /* GET A RECORD IF ONE EXISTS    */
         ST    @14,@AL00001                                        0440
         LA    @01,@AL00001                                        0440
         BAL   @14,MFNXTREC                                        0440
*       RFY                                                        0441
*        (GPR15F)RSTD;                                             0441
*       IF GPR15F=4 THEN            /* MFNXTREC UNSUCCESSFUL?        */
         CH    GPR15F,@CH00254                                     0442
         BNE   @RF00442                                            0442
*         RETURN CODE(GPR15F);      /* YES, RETURN TO IRBMFANL       */
         L     @14,@SA00008                                        0443
         LM    @00,@12,@SA00008+8                                  0443
         BR    @14                                                 0443
*       RFY                                                        0444
*        (GPR15F)UNRSTD;                                           0444
@RF00442 DS    0H                                                  0445
*     END;                                                         0445
*   DO I=1 TO RIBYTLFT WHILE(RIINTGER>='F0'X&RIINTGER<='F9'X);     0446
@RF00438 LA    @15,1                                               0446
         B     @DE00446                                            0446
@DL00446 L     @15,@PC00008+4                                      0446
         L     @15,RICURTXT(,@15)                                  0446
         CLI   RIINTGER(@15),X'F0'                                 0446
         BL    @DC00446                                            0446
         CLI   RIINTGER(@15),X'F9'                                 0446
         BH    @DC00446                                            0446
*     RIINTFND='1'B;                /* INDICATE NUMBER FOUND         */
         OI    RIINTFND,B'10000000'                                0447
*     RIINTDEC=RIINTGER&'0F'X;      /* CLEAR OUT BITS                */
         MVC   RIINTDEC(1),RIINTGER(@15)                           0448
         NI    RIINTDEC,X'0F'                                      0448
*     RITEMNUM=RINUMBER;            /* SAVE OLD VALUE                */
         L     @15,RINUMBER                                        0449
         ST    @15,RITEMNUM                                        0449
*     RINUMBER=RINUMBER*10+RIINTDEC;                               0450
         LR    @14,@15                                             0450
         MH    @14,@CH00580                                        0450
         MVC   @ZT00003+3(1),RIINTDEC                              0450
         AL    @14,@ZT00003                                        0450
         ST    @14,RINUMBER                                        0450
*     IF RINUMBER<RITEMNUM THEN     /* OVERFLOW?                     */
         CLR   @14,@15                                             0451
         BNL   @RF00451                                            0451
*       DO;                                                        0452
*         RINUMBER=RITEMNUM;        /* SET TO PREVIOUS VALUE         */
         ST    @15,RINUMBER                                        0453
*         GOTO RILAB1;              /* STORE NUMBER                  */
         B     RILAB1                                              0454
*       END;                                                       0455
*     RICURTXT=RICURTXT+1;          /* UPDATE CURRENT TXT PTR        */
@RF00451 L     @15,@PC00008+4                                      0456
         LA    @14,1                                               0456
         A     @14,RICURTXT(,@15)                                  0456
         ST    @14,RICURTXT(,@15)                                  0456
*   END;                                                           0457
         LA    @15,1                                               0457
         A     @15,I                                               0457
@DE00446 ST    @15,I                                               0457
         L     @14,@PC00008+4                                      0457
         C     @15,RIBYTLFT(,@14)                                  0457
         BNH   @DL00446                                            0457
@DC00446 DS    0H                                                  0458
*RILAB1:                                                           0458
*   ;                                                              0458
RILAB1   DS    0H                                                  0459
*   RIBYTLFT=RIBYTLFT-(I-1);        /* DECREASE # BYTES LEFT         */
         L     @15,@PC00008+4                                      0459
         L     @14,I                                               0459
         BCTR  @14,0                                               0459
         LCR   @14,@14                                             0459
         A     @14,RIBYTLFT(,@15)                                  0459
         ST    @14,RIBYTLFT(,@15)                                  0459
*   IF RIINTFND='1'B THEN           /* NUMBER FOUND?                 */
         TM    RIINTFND,B'10000000'                                0460
         BNO   @RF00460                                            0460
*     DO;                                                          0461
*       RINUMVAL=RINUMBER;          /* STORE INTEGER                 */
         L     @15,@PC00008                                        0462
         L     @01,RISAVNUM(,@15)                                  0462
         SR    @15,@15                                             0462
         IC    @15,RINUMCOD(,@01)                                  0462
         SLA   @15,2                                               0462
         L     @01,ININTPTR-4(@15)                                 0462
         MVC   RINUMVAL(4,@01),RINUMBER                            0462
*       RETURN CODE(0);             /* RETURN SUCCESSFUL             */
         SR    @15,@15                                             0463
         L     @14,@SA00008                                        0463
         LM    @00,@12,@SA00008+8                                  0463
         BR    @14                                                 0463
*     END;                                                         0464
*   RETURN CODE(4);                 /* RETURN UNSUCCESSFUL           */
@RF00460 LA    @15,4                                               0465
         L     @14,@SA00008                                        0465
         LM    @00,@12,@SA00008+8                                  0465
         BR    @14                                                 0465
*   END MFRINTGR;                                                  0466
*                                                                  0467
*/*  PROCEDURE NAME = MFFREBUF                                       */
*/*                                                                  */
*/*  DESCRIPTIVE NAME = FREE UP BUFFERS AND BCBS                     */
*/*                                                                  */
*/*  FUNCTION = THIS ROUTINE FREES UP BUFFERS AND BCBS NO LONGER     */
*/*             NEEDED IN SCANNING AN INPUT SOURCE. A CODE IS PASSED */
*/*              TO THIS ROUTINE TO INDICATE WHETHER ALL BUFFERS AND */
*/*              BCBS ARE TO BE FREED OR FREE ONLY UP TO CURRENT ONE */
*/*                                                                  */
*                                                                  0467
*MFFREBUF:                                                         0467
*   PROCEDURE(FRFRECOD,FRSCB);                                     0467
MFFREBUF STM   @14,@12,@SA00009                                    0467
         MVC   @PC00009(8),0(@01)                                  0467
*   DECLARE                                                        0468
*     FRFRECOD                      /* FREE CODE - 0=FREE ALL BCB'S
*                                      AND BUFFERS. 4=FREE UP TO   0468
*                                      CURRENT BCB AND BUFFER        */
*         FIXED(31),                                               0468
*     1 FRSCB,                      /* SCAN CONTROL BLOCK            */
*      2 FRCURBCB                   /* CURRENT BCB PTR               */
*            PTR(31),                                              0468
*      2 FRCURTXT                   /* CURRENT TEXT PTR              */
*            PTR(31),                                              0468
*      2 FRBYTLFT                   /* # BYTES LEFT                  */
*            FIXED(31),                                            0468
*        FRFREBCB                   /* BCB TO FREE                   */
*            PTR(31),                                              0468
*     1 FRBCBCOR                    /* FREEMAIN PARAMETERS           */
*           BDY(WORD),                                             0468
*      2 FRSUBPOL                   /* SUBPOOL                       */
*            FIXED(8),                                             0468
*      2 FRBCBLEN                   /* LENGTH                        */
*            FIXED(24),                                            0468
*        FRCONTRL                   /* CONTROL FOR DO GROUP          */
*            PTR(31);                                              0468
*   FRSUBPOL=0;                     /* SUPOOL 0                      */
         MVI   FRSUBPOL,X'00'                                      0469
*   IF FRFRECOD=0|INBCBFRS=0 THEN   /* FREE ALL BUFFERS AND BCBS OR
*                                      NONE TO FREE?                 */
         SR    @15,@15                                             0470
         L     @14,@PC00009                                        0470
         C     @15,FRFRECOD(,@14)                                  0470
         BE    @RT00470                                            0470
         C     @15,INBCBFRS                                        0470
         BNE   @RF00470                                            0470
@RT00470 DS    0H                                                  0471
*     FRCONTRL=0;                                                  0471
         SR    @15,@15                                             0471
         ST    @15,FRCONTRL                                        0471
*   ELSE                            /* FREE UP TO CURRENT            */
*     FRCONTRL=FRCURBCB;                                           0472
         B     @RC00470                                            0472
@RF00470 L     @15,@PC00009+4                                      0472
         MVC   FRCONTRL(4),FRCURBCB(@15)                           0472
*   DO WHILE INBCBFRS^=FRCONTRL;                                   0473
@RC00470 B     @DE00473                                            0473
@DL00473 DS    0H                                                  0474
*     FRBCBLEN=INBCBFRS->INBCBLEN;  /* BUFFER LENGTH                 */
         L     @15,INBCBFRS                                        0474
         LH    @14,INBCBLEN(,@15)                                  0474
         ST    @14,@TF00001                                        0474
         MVC   FRBCBLEN(3),@TF00001+1                              0474
*     RFY                                                          0475
*      (GPR00F,                                                    0475
*       GPR01P,                                                    0475
*       GPR14F,                                                    0475
*       GPR15F)RSTD;                                               0475
*     GPR00F=FRBCBCOR;              /* SUBPOOL & LENGTH              */
         L     GPR00F,FRBCBCOR                                     0476
*     GPR01P=INBCBFRS->INBCBTXT;    /* ADDRESS OF BUFFER TO FREE     */
         L     @07,INBCBFRS                                        0477
         L     GPR01P,INBCBTXT(,@07)                               0477
*     GEN(FREEMAIN R,LV=(0),A=(1)); /* FREE BUFFER                   */
         FREEMAIN R,LV=(0),A=(1)
*     FRFREBCB=INBCBFRS;            /* SAVE BCB TO BE FREED          */
         L     @07,INBCBFRS                                        0479
         ST    @07,FRFREBCB                                        0479
*     INBCBFRS=INBCBFRS->INBCBNXT;  /* FIRST = NEXT BCB              */
         L     @06,INBCBNXT(,@07)                                  0480
         ST    @06,INBCBFRS                                        0480
*     FRBCBLEN=LENGTH(INBCB);       /* BCB LENGTH                    */
         MVC   FRBCBLEN(3),@CF00584+1                              0481
*     GPR00F=FRBCBCOR;              /* SUBPOOL & LENGTH              */
         L     GPR00F,FRBCBCOR                                     0482
*     GPR01P=FRFREBCB;              /* ADDRESS OF BCB TO FREE        */
         LR    GPR01P,@07                                          0483
*     GEN(FREEMAIN R,LV=(0),A=(1)); /* FREE BCB                      */
         FREEMAIN R,LV=(0),A=(1)
*     RFY                                                          0485
*      (GPR00F,                                                    0485
*       GPR01P,                                                    0485
*       GPR14F,                                                    0485
*       GPR15F)UNRSTD;                                             0485
*   END;                                                           0486
@DE00473 CLC   INBCBFRS(4),FRCONTRL                                0486
         BNE   @DL00473                                            0486
*   IF FRFRECOD=0 THEN              /* FREE ALL?                     */
         SR    @15,@15                                             0487
         L     @14,@PC00009                                        0487
         C     @15,FRFRECOD(,@14)                                  0487
         BNE   @RF00487                                            0487
*     DO;                                                          0488
*       INBCBLST=ADDR(INBCBFRS);    /* LAST BCB = ADDR(FIRST)        */
         LA    @14,INBCBFRS                                        0489
         ST    @14,INBCBLST                                        0489
*       FRCURBCB=ADDR(INBCBFRS);    /* SCB INITIAL CONDITION         */
         L     @07,@PC00009+4                                      0490
         ST    @14,FRCURBCB(,@07)                                  0490
*       FRCURTXT=0;                 /* SCB INITIAL CONDITION         */
         ST    @15,FRCURTXT(,@07)                                  0491
*       FRBYTLFT=0;                 /* SCB INITIAL CONDITION         */
         ST    @15,FRBYTLFT(,@07)                                  0492
*     END;                                                         0493
*   RETURN;                         /* RETURN TO CALLER              */
@EL00009 DS    0H                                                  0494
@EF00009 DS    0H                                                  0494
@ER00009 LM    @14,@12,@SA00009                                    0494
         BR    @14                                                 0494
*   END MFFREBUF;                                                  0495
         B     @EL00009                                            0495
*                                                                  0496
*/*  PROCEDURE NAME = MFNXTREC                                       */
*/*                                                                  */
*/*  DESCRIPTIVE NAME = GET THE NEXT SEQUENTIAL RECORD OF AN INPUT   */
*/*                     SOURCE                                       */
*/*                                                                  */
*/*  FUNCTION = THIS ROUTINE RETRIEVES THE NEXT SEQUENTIAL RECORD OF */
*/*             AN INPUT SOURCE. IF NONE EXIST, IT RETURNS UNSUCCESS-*/
*/*             FUL TO CALLER.                                       */
*/*                                                                  */
*                                                                  0496
*MFNXTREC:                                                         0496
*   PROCEDURE(NXSCB);                                              0496
MFNXTREC STM   @14,@12,@SA00010                                    0496
         MVC   @PC00010(4),0(@01)                                  0496
*   DECLARE                                                        0497
*     1 NXSCB,                      /* SCAN CONTROL BLOCK            */
*      2 NXCURBCB                   /* CURRENT BCB PTR               */
*            PTR(31),                                              0497
*      2 NXCURTXT                   /* CURRENT TEXT PTR              */
*            PTR(31),                                              0497
*      2 NXBYTLFT                   /* # BYTES LEFT                  */
*            FIXED(31),                                            0497
*     1 NXFRECOR BDY(WORD),         /* GETMAIN PARAMETERS            */
*      2 NXSUBPOL                   /* SUBPOOL                       */
*            FIXED(8),                                             0497
*      2 NXLEN                      /* LENGTH                        */
*            FIXED(24),                                            0497
*        NXFOUND BIT(1),            /* RECORD FOUND BIT              */
*        NXLENGTH                   /* LENGTH OF TEXT IN A RECORD    */
*            FIXED(31),                                            0497
*        NXTEXT                     /* TEXT IN RECORD                */
*            CHAR(*)BASED(NXTEXPTR),                               0497
*        NXTEXPTR                   /* PTR TO RECORD                 */
*            PTR(31),                                              0497
*        NXSUCCES                   /* SUCCESSFUL RETURN             */
*            FIXED(31)CONSTANT(0),                                 0497
*        NXUNSUCC                   /* UNSUCCESSFUL RETURN           */
*            FIXED(31)CONSTANT(4);                                 0497
*   IF INEXTSRC=ININTSRC THEN       /* INTERNAL INPUT SOURCE?        */
         TM    INEXTSRC,B'10000000'                                0498
         BNO   @RF00498                                            0498
*     RETURN CODE(NXUNSUCC);        /* RETURN UNSUCCESSFUL           */
         LA    @15,4                                               0499
         L     @14,@SA00010                                        0499
         LM    @00,@12,@SA00010+8                                  0499
         BR    @14                                                 0499
*   IF NXCURBCB=INBCBLST THEN       /* LAST BCB ON CHAIN?            */
@RF00498 L     @15,@PC00010                                        0500
         CLC   NXCURBCB(4,@15),INBCBLST                            0500
         BNE   @RF00500                                            0500
*     DO;                           /* YES                           */
*       NXFOUND='0'B;                                              0502
         NI    NXFOUND,B'01111111'                                 0502
*       CALL MFREADIO(NXTEXPTR,NXLENGTH,NXFRECOR);/* READ IN A RECORD*/
         LA    @15,NXTEXPTR                                        0503
         ST    @15,@AL00001                                        0503
         LA    @15,NXLENGTH                                        0503
         ST    @15,@AL00001+4                                      0503
         LA    @15,NXFRECOR                                        0503
         ST    @15,@AL00001+8                                      0503
         LA    @01,@AL00001                                        0503
         BAL   @14,MFREADIO                                        0503
*       RFY                                                        0504
*        (GPR15F)RSTD;                                             0504
*       IF GPR15F=NXSUCCES THEN     /* WAS READ OK?                  */
         LTR   GPR15F,GPR15F                                       0505
         BNZ   @RF00505                                            0505
*         DO;                       /* YES                           */
*           RFY                                                    0507
*            (GPR15F)UNRSTD;                                       0507
*           NXFOUND='1'B;           /* A RECORD WAS RETRIEVED        */
         OI    NXFOUND,B'10000000'                                 0508
*           CALL MFBUFENQ(NXTEXT,NXLENGTH,NXSCB);/* SET UP BUFFER &
*                                      BCB                           */
         L     @01,NXTEXPTR                                        0509
         ST    @01,@AL00001                                        0509
         LA    @15,NXLENGTH                                        0509
         ST    @15,@AL00001+4                                      0509
         L     @15,@PC00010                                        0509
         ST    @15,@AL00001+8                                      0509
         LA    @01,@AL00001                                        0509
         BAL   @14,MFBUFENQ                                        0509
*         END;                                                     0510
*       RFY                                                        0511
*        (GPR00P,                                                  0511
*         GPR01P,                                                  0511
*         GPR14P,                                                  0511
*         GPR15P)RSTD;                                             0511
@RF00505 DS    0H                                                  0512
*       GPR00P=NXFRECOR;            /* SUBPOOL AND LENGTH            */
         L     GPR00P,NXFRECOR                                     0512
*       GPR01P=NXTEXPTR;            /* PTR TO GOTTEN AREA            */
         L     GPR01P,NXTEXPTR                                     0513
*       GEN(FREEMAIN R,LV=(0),A=(1));/* FREE GOTTEN AREA             */
         FREEMAIN R,LV=(0),A=(1)
*       RFY                                                        0515
*        (GPR00P,                                                  0515
*         GPR01P,                                                  0515
*         GPR14P,                                                  0515
*         GPR15P)UNRSTD;                                           0515
*       IF NXFOUND='1'B THEN        /* RECORD RETRIEVED?             */
         TM    NXFOUND,B'10000000'                                 0516
         BNO   @RF00516                                            0516
*         RETURN CODE(NXSUCCES);    /* RETURN SUCCESSFUL             */
         SR    @15,@15                                             0517
         L     @14,@SA00010                                        0517
         LM    @00,@12,@SA00010+8                                  0517
         BR    @14                                                 0517
*       ELSE                        /* END OF FILE                   */
*         RETURN CODE(NXUNSUCC);    /* RETURN UNSUCCESSFUL           */
@RF00516 LA    @15,4                                               0518
         L     @14,@SA00010                                        0518
         LM    @00,@12,@SA00010+8                                  0518
         BR    @14                                                 0518
*     END;                                                         0519
*   NXCURBCB=NXCURBCB->INBCBNXT;    /* POINT CURRENT TO NEXT BCB     */
@RF00500 L     @15,@PC00010                                        0520
         L     @01,NXCURBCB(,@15)                                  0520
         L     @14,INBCBNXT(,@01)                                  0520
         ST    @14,NXCURBCB(,@15)                                  0520
*   NXCURTXT=NXCURBCB->INBCBTXT;    /* CURRENT TEXT UPDATED          */
         MVC   NXCURTXT(4,@15),INBCBTXT(@14)                       0521
*   NXBYTLFT=NXCURBCB->INBCBLEN;    /* LENGTH OF TEXT                */
         LH    @14,INBCBLEN(,@14)                                  0522
         ST    @14,NXBYTLFT(,@15)                                  0522
*   RETURN CODE(NXSUCCES);          /* RETURN SUCCESSFUL             */
         SR    @15,@15                                             0523
         L     @14,@SA00010                                        0523
         LM    @00,@12,@SA00010+8                                  0523
         BR    @14                                                 0523
*   END MFNXTREC;                                                  0524
*                                                                  0525
*/*  PROCEDURE NAME = MFRALPHA                                       */
*/*                                                                  */
*/*  DESCRIPTIVE NAME = ALPHANUMERIC RECOGNIZER                      */
*/*                                                                  */
*/*  FUNCTION = RECOGNIZES ANY ALPHANUMERIC CHARACTER. SAVES VALUE   */
*/*             FOR OPTION INITIALIZATION.                           */
*/*                                                                  */
*/* DEPENDENCY = CHARACTER CODE DEPENDENT                            */
*/*                                                                  */
*                                                                  0525
*MFRALPHA:                                                         0525
*   PROCEDURE(RASAVALP,RASCB);                                     0525
MFRALPHA STM   @14,@12,@SA00011                                    0525
         MVC   @PC00011(8),0(@01)                                  0525
*   DECLARE                                                        0526
*     RASAVALP                      /* PTR TO PLACE TO SAVE CHARACTER*/
*         PTR(31),                                                 0526
*     RASAVCHA                      /* CHARACTER TO SAVE             */
*         CHAR(1)BASED(INALPPTR(RASAVCOD)),                        0526
*     RASAVCOD                      /* CODE FOR WHERE TO SAVE        */
*         FIXED(8)BASED(RASAVALP),                                 0526
*     1 RASCB,                      /* SCAN CONTROL BLOCK            */
*      2 RACURBCB                   /* CURRENT BCB PTR               */
*            PTR(31),                                              0526
*      2 RACURTXT                   /* CURRENT TEXT PTR              */
*            PTR(31),                                              0526
*      2 RABYTLFT                   /* # BYTES LEFT                  */
*            FIXED(31),                                            0526
*        RACHAR                     /* CHARACTER IN BUFFER           */
*            CHAR(1)BASED(RACURTXT);                               0526
*   IF RABYTLFT=0 THEN              /* END OF BUFFER?                */
         L     @15,@PC00011+4                                      0527
         L     @14,RABYTLFT(,@15)                                  0527
         LTR   @14,@14                                             0527
         BNZ   @RF00527                                            0527
*     DO;                                                          0528
*       CALL MFNXTREC(RASCB);       /* GET NEXT RECORD               */
         ST    @15,@AL00001                                        0529
         LA    @01,@AL00001                                        0529
         BAL   @14,MFNXTREC                                        0529
*       RFY                                                        0530
*        (GPR15F)RSTD;                                             0530
*       IF GPR15F=4 THEN            /* MFNXTREC UNSUCCESSFUL?        */
         CH    GPR15F,@CH00254                                     0531
         BNE   @RF00531                                            0531
*         RETURN CODE(GPR15F);      /* YES, RETURN UNSUCCESSFUL      */
         L     @14,@SA00011                                        0532
         LM    @00,@12,@SA00011+8                                  0532
         BR    @14                                                 0532
*       RFY                                                        0533
*        (GPR15F)UNRSTD;                                           0533
@RF00531 DS    0H                                                  0534
*     END;                                                         0534
*                                                                  0534
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK FOR VALID ALPHANUMERIC CHARACTER                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0535
*   IF RACHAR>='C1'X&RACHAR<='C9'X| /* A-I? OR                       */
*       RACHAR>='D1'X&RACHAR<='D9'X|/* J-R? OR                       */
*       RACHAR>='E2'X&RACHAR<='E9'X|/* S-Z? OR                       */
*       RACHAR>='F0'X&RACHAR<='F9'X THEN/* 0-9?                      */
@RF00527 L     @15,@PC00011+4                                      0535
         L     @15,RACURTXT(,@15)                                  0535
         CLI   RACHAR(@15),X'C1'                                   0535
         BL    @GL00012                                            0535
         CLI   RACHAR(@15),X'C9'                                   0535
         BNH   @RT00535                                            0535
@GL00012 L     @15,@PC00011+4                                      0535
         L     @15,RACURTXT(,@15)                                  0535
         CLI   RACHAR(@15),X'D1'                                   0535
         BL    @GL00011                                            0535
         CLI   RACHAR(@15),X'D9'                                   0535
         BNH   @RT00535                                            0535
@GL00011 L     @15,@PC00011+4                                      0535
         L     @15,RACURTXT(,@15)                                  0535
         CLI   RACHAR(@15),X'E2'                                   0535
         BL    @GL00010                                            0535
         CLI   RACHAR(@15),X'E9'                                   0535
         BNH   @RT00535                                            0535
@GL00010 L     @15,@PC00011+4                                      0535
         L     @15,RACURTXT(,@15)                                  0535
         CLI   RACHAR(@15),X'F0'                                   0535
         BL    @RF00535                                            0535
         CLI   RACHAR(@15),X'F9'                                   0535
         BH    @RF00535                                            0535
@RT00535 DS    0H                                                  0536
*     DO;                                                          0536
*       RASAVCHA=RACHAR;            /* STORE CHARACTER               */
         L     @15,@PC00011                                        0537
         L     @01,RASAVALP(,@15)                                  0537
         SR    @15,@15                                             0537
         IC    @15,RASAVCOD(,@01)                                  0537
         SLA   @15,2                                               0537
         L     @01,INALPPTR-4(@15)                                 0537
         L     @15,@PC00011+4                                      0537
         L     @14,RACURTXT(,@15)                                  0537
         MVC   RASAVCHA(1,@01),RACHAR(@14)                         0537
*       RACURTXT=RACURTXT+1;        /* UPDATE CURRENT TEXT PTR       */
         AH    @14,@CH00065                                        0538
         ST    @14,RACURTXT(,@15)                                  0538
*       RABYTLFT=RABYTLFT-1;        /* UPDATE BYTES LEFT             */
         L     @14,RABYTLFT(,@15)                                  0539
         BCTR  @14,0                                               0539
         ST    @14,RABYTLFT(,@15)                                  0539
*       RETURN CODE(0);             /* RETURN SUCCESSFUL             */
         SR    @15,@15                                             0540
         L     @14,@SA00011                                        0540
         LM    @00,@12,@SA00011+8                                  0540
         BR    @14                                                 0540
*     END;                                                         0541
*   RETURN CODE(4);                 /* RETURN UNSUCCESSFUL           */
@RF00535 LA    @15,4                                               0542
         L     @14,@SA00011                                        0542
         LM    @00,@12,@SA00011+8                                  0542
         BR    @14                                                 0542
*   END MFRALPHA;                                                  0543
*MFLISTOP:                                                         0544
*   PROCEDURE;                                                     0544
MFLISTOP STM   @14,@12,@SA00012                                    0544
*   DECLARE                                                        0545
*     LINDXARY(10)                  /* INDEX NUMBER ARRAY FOR LISTOP */
*         FIXED(15),                                               0545
*     LIFORCE                       /* FORCE BIT FOR MERGE           */
*         BIT(1)CONSTANT('1'B),                                    0545
*     LIGOSPFD                      /* INDICATES THAT 'GO' WAS     0545
*                                      ENTERED AT CONSOLE            */
*         BIT(1),                                                  0545
*     LI1STIME                      /* 1ST TIME THROUGH CODE         */
*         BIT(1);                                                  0545
*                                                                  0545
*   /*****************************************************************/
*   /*                                                               */
*   /* LIST MERGED SOURCES                                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0546
*   IF MFCOOPIV^=INOPIYES THEN      /* 'NOOPI' SPECIFIED?            */
         L     @15,@PC00001+8                                      0546
         TM    MFCOOPIV(@15),B'00000001'                           0546
         BNO   @RT00546                                            0546
*     GO TO LIMSGDS;                /* LIST OPTIONS IN MSG D.S. ONLY */
*LIST:                                                             0548
*   MFCOOPIV='0'B;                  /* TURN OFF OPI OPTION           */
LIST     L     @15,@PC00001+8                                      0548
         NI    MFCOOPIV(@15),B'11111110'                           0548
*   LI1STIME='1'B;                  /* INDICATE 1ST TIME THROUGH     */
         OI    LI1STIME,B'10000000'                                0549
*   LINDXARY(1)=MID305I2;           /* INDEX ARRAY FOR IRB305I       */
         MVC   LINDXARY(2),@CH00614                                0550
*   LINDXARY(2)=MID305I3;                                          0551
         MVC   LINDXARY+2(2),@CH00616                              0551
*   LINDXARY(3)=MID305I4;                                          0552
         MVC   LINDXARY+4(2),@CH00045                              0552
*   LINDXARY(4)=MID305I5;                                          0553
         MVC   LINDXARY+6(2),@CH00169                              0553
*   LINDXARY(5)=MID305I6;                                          0554
         MVC   LINDXARY+8(2),@CH00620                              0554
*   LINDXARY(6)=MID305I7;                                          0555
         MVC   LINDXARY+10(2),@CH00622                             0555
*   LINDXARY(7)=MID305I8;                                          0556
         MVC   LINDXARY+12(2),@CH00624                             0556
*   LINDXARY(8)=MID305I9;                                          0557
         MVC   LINDXARY+14(2),@CH00626                             0557
*   LINDXARY(9)=MID305IA;                                          0558
         MVC   LINDXARY+16(2),@CH00628                             0558
*   LINDXARY(10)=MID305IB;                                         0559
*                                                                  0559
         MVC   LINDXARY+18(2),@CH00592                             0559
*   /*****************************************************************/
*   /*                                                               */
*   /* ISSUE 'MF/1 PARAMETERS' MESSAGE                               */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0560
*   CALL INMSGMOD(MID305I1,0,0,0);                                 0560
*                                                                  0560
         L     @15,INMSGADR                                        0560
         LA    @01,@AL00560                                        0560
         BALR  @14,@15                                             0560
*   /*****************************************************************/
*   /*                                                               */
*   /* CALL LISTOP TO LIST THE OPTIONS REQUESTED ON THE CONSOLE      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0561
*   CALL LISTOP(LINDXARY,ADDR(MFCOA),ADDR(MFMVT));                 0561
         LA    @15,LINDXARY                                        0561
         ST    @15,@AL00001                                        0561
         L     @15,@PC00001+8                                      0561
         ST    @15,@AFTEMPS+8                                      0561
         LA    @15,@AFTEMPS+8                                      0561
         ST    @15,@AL00001+4                                      0561
         L     @15,@PC00001+4                                      0561
         ST    @15,@AFTEMPS+12                                     0561
         LA    @15,@AFTEMPS+12                                     0561
         ST    @15,@AL00001+8                                      0561
         LA    @01,@AL00001                                        0561
         BAL   @14,LISTOP                                          0561
*LIREPLY:                                                          0562
*                                                                  0562
*   /*****************************************************************/
*   /*                                                               */
*   /* ALLOW OPERATOR TO REPLY WITH MORE OPTIONS OR 'GO'             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0562
*   CALL INMSGMOD(MID306D,0,INREPBUF,0);                           0562
*                                                                  0562
LIREPLY  MVC   @AL00001(16),@AL00562                               0562
         LA    @15,INREPBUF                                        0562
         ST    @15,@AL00001+8                                      0562
         L     @15,INMSGADR                                        0562
         LA    @01,@AL00001                                        0562
         BALR  @14,@15                                             0562
*   /*****************************************************************/
*   /*                                                               */
*   /* CHECK OPERATOR S REPLY                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0563
*   IF INREPTXT(1:2)='GO' THEN      /* WAS REPLY GO?                 */
         CLC   INREPTXT(2),@CC01181                                0563
         BNE   @RF00563                                            0563
*     DO;                                                          0564
*                                                                  0564
*/*CHECK FOR BLANKS IN REST OF RECORD                                */
*                                                                  0565
*       DO I=3 TO LENGTH(INREPTXT)WHILE(INREPTXT(I)=' ');          0565
         LA    @15,3                                               0565
         ST    @15,I                                               0565
@DL00565 LA    @14,INREPTXT-1(@15)                                 0565
         CLI   0(@14),C' '                                         0565
         BNE   @DC00565                                            0565
*       END;                                                       0566
         AH    @15,@CH00065                                        0566
         ST    @15,I                                               0566
         CH    @15,@CH00823                                        0566
         BNH   @DL00565                                            0566
@DC00565 DS    0H                                                  0567
*       IF I=LENGTH(INREPTXT)+1 THEN/* IF REST OF TEXT WAS BLANK     */
         CLC   I(4),@CF01488                                       0567
         BNE   @RF00567                                            0567
*         LIGOSPFD='1'B;            /* INDICATE 'GO' WAS SPECIFIED   */
         OI    LIGOSPFD,B'10000000'                                0568
*       ELSE                        /* INDICATE                      */
*         LIGOSPFD='0'B;            /* 'GO' NOT SPECIFIED            */
         B     @RC00567                                            0569
@RF00567 NI    LIGOSPFD,B'01111111'                                0569
*     END;                                                         0570
*   ELSE                            /* 'GO' NOT SPECIFIED            */
*     LIGOSPFD='0'B;                /* TEXT WILL BE PROCESSED        */
         B     @RC00563                                            0571
@RF00563 NI    LIGOSPFD,B'01111111'                                0571
*   IF LIGOSPFD='1'B THEN           /* WAS REPLY GO?                 */
@RC00563 TM    LIGOSPFD,B'10000000'                                0572
         BNO   @RF00572                                            0572
*     DO;                                                          0573
*       IF LI1STIME='0'B THEN       /* DID OPERATOR REPLY WITH VALUES*/
         TM    LI1STIME,B'10000000'                                0574
         BNZ   @RF00574                                            0574
*         DO;                                                      0575
*           CALL MFVALCHK;          /* CHECK OPTIONS VALIDITY        */
         BAL   @14,MFVALCHK                                        0576
*           IF MFCOOPIV='1'B THEN   /* OPI REQUESTED?                */
         L     @15,@PC00001+8                                      0577
         TM    MFCOOPIV(@15),B'00000001'                           0577
         BO    @RT00577                                            0577
*             GOTO LIST;            /* REPEAT PROCESSING UNTIL NO  0578
*                                      ERRORS ARE FOUND              */
*         END;                                                     0579
*LIMSGDS:                                                          0580
*       ;                                                          0580
@RF00574 DS    0H                                                  0580
LIMSGDS  DS    0H                                                  0581
*       INDDNAME='MF1INPUT';        /* UNIQUE DDNAME                 */
*                                                                  0581
         MVC   INDDNAME(8),@CC00946                                0581
*       /*************************************************************/
*       /*                                                           */
*       /* ALLOCATE MESSAGE DATASET. IF REPORT(REALTIME) WAS         */
*       /* SPECIFIED, UNALLOCATE DATASET AT CLOSE TIME.              */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0582
*       INMODULE='IRBMFALL';        /* ALLOCATION ROUTINE            */
         MVC   INMODULE(8),@CC01183                                0582
*       RFY                                                        0583
*        (GPR00P,                                                  0583
*         GPR01P,                                                  0583
*         GPR14P,                                                  0583
*         GPR15P)RSTD;                                             0583
*       GEN(LOAD EPLOC=INMODULE);                                  0584
         LOAD EPLOC=INMODULE
*       INALLADR=GPR00P;            /* SAVE ITS ADDRESS              */
         ST    GPR00P,INALLADR                                     0585
*       RFY                                                        0586
*        (GPR00P,                                                  0586
*         GPR01P,                                                  0586
*         GPR14P,                                                  0586
*         GPR15P)UNRSTD;                                           0586
*       IF MFCOREPV='10'B THEN      /* REPORT(REALTIME)?             */
         L     @15,@PC00001+8                                      0587
         TM    MFCOREPV(@15),B'00000010'                           0587
         BNO   @RF00587                                            0587
         TM    MFCOREPV(@15),B'00000001'                           0587
         BNZ   @RF00587                                            0587
*         DO;                                                      0588
*           INUNALLC='1'B;                                         0589
         OI    INUNALLC,B'10000000'                                0589
*           CALL INALLMOD(INDDNAME,MFCOOUTV,INUNALLC);/* UNALLOC.  0590
*                                      D.S.                          */
         LA    @14,INDDNAME                                        0590
         ST    @14,@AL00001                                        0590
         LA    @15,MFCOOUTV(,@15)                                  0590
         ST    @15,@AL00001+4                                      0590
         LA    @15,INUNALLC                                        0590
         ST    @15,@AL00001+8                                      0590
         L     @14,INALLADR                                        0590
         LR    @15,@14                                             0590
         LA    @01,@AL00001                                        0590
         BALR  @14,@15                                             0590
*         END;                                                     0591
*       ELSE                        /* DO NOT UNALLOCATE DATA SET    */
*         DO;                                                      0592
         B     @RC00587                                            0592
@RF00587 DS    0H                                                  0593
*           INUNALLC='0'B;          /* TURN OFF UNALLOCATE BIT       */
         NI    INUNALLC,B'01111111'                                0593
*           CALL INALLMOD(INDDNAME,MFCOOUTV,INUNALLC);/* CALL      0594
*                                      IRBMFALL                      */
         LA    @15,INDDNAME                                        0594
         ST    @15,@AL00001                                        0594
         L     @15,@PC00001+8                                      0594
         LA    @15,MFCOOUTV(,@15)                                  0594
         ST    @15,@AL00001+4                                      0594
         LA    @15,INUNALLC                                        0594
         ST    @15,@AL00001+8                                      0594
         L     @15,INALLADR                                        0594
         LA    @01,@AL00001                                        0594
         BALR  @14,@15                                             0594
*         END;                                                     0595
*       RFY                                                        0596
*        (GPR00P,                                                  0596
*         GPR01P,                                                  0596
*         GPR14P,                                                  0596
*         GPR15P)RSTD;                                             0596
@RC00587 DS    0H                                                  0597
*       GEN(DELETE EPLOC=INMODULE);                                0597
         DELETE EPLOC=INMODULE
*       RFY                                                        0598
*        (GPR00P,                                                  0598
*         GPR01P,                                                  0598
*         GPR14P,                                                  0598
*         GPR15P)UNRSTD;                                           0598
*                                                                  0598
*       /*************************************************************/
*       /*                                                           */
*       /* OPEN MESSAGE DATASET                                      */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0599
*       DCBPTR=ADDR(INMSGDCB);      /* SET UP MSG DCB PTR            */
         LA    @15,INMSGDCB                                        0599
         ST    @15,DCBPTR                                          0599
*       GENERATE SETS(INMSGDCB,INAUMOPN);                          0600
         OPEN (INMSGDCB,(OUTPUT)),MF=(E,INAUMOPN)
*       IF DCBOFOPN^='1'B THEN      /* OPEN FAILED?                  */
         L     @01,DCBPTR                                          0601
         TM    DCBOFOPN+40(@01),B'00010000'                        0601
         BO    @RF00601                                            0601
*         GENERATE(ABEND 1110,DUMP);                               0602
         ABEND 1110,DUMP
*       LINDXARY(1)=MID103I2;       /* MSG INDEX NUMBERS PASSED TO   */
@RF00601 MVC   LINDXARY(2),@CH00600                                0603
*       LINDXARY(2)=MID103I3;       /* LISTOP SUBROUTINE FOR IRB103I */
         MVC   LINDXARY+2(2),@CH00602                              0604
*       LINDXARY(3)=MID103I4;                                      0605
         MVC   LINDXARY+4(2),@CH00067                              0605
*       LINDXARY(4)=MID103I5;                                      0606
         MVC   LINDXARY+6(2),@CH00088                              0606
*       LINDXARY(5)=MID103I6;                                      0607
         MVC   LINDXARY+8(2),@CH00606                              0607
*       LINDXARY(6)=MID103I7;                                      0608
         MVC   LINDXARY+10(2),@CH00608                             0608
*       LINDXARY(7)=MID103I8;                                      0609
         MVC   LINDXARY+12(2),@CH00610                             0609
*       LINDXARY(8)=MID103I9;                                      0610
         MVC   LINDXARY+14(2),@CH00612                             0610
*       LINDXARY(9)=MID103IA;                                      0611
         MVC   LINDXARY+16(2),@CH00630                             0611
*       LINDXARY(10)=MID103IB;                                     0612
*                                                                  0612
         MVC   LINDXARY+18(2),@CH00650                             0612
*       /*************************************************************/
*       /*                                                           */
*       /* LIST OPTIONS IN EFFECT IN MESSAGE DATASET                 */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0613
*       CALL INMSGMOD(MID103I1,0,0,INMDCBAD);                      0613
         MVC   @AL00001(12),@AL00613                               0613
         LA    @15,INMDCBAD                                        0613
         ST    @15,@AL00001+12                                     0613
         L     @15,INMSGADR                                        0613
         LA    @01,@AL00001                                        0613
         BALR  @14,@15                                             0613
*       CALL LISTOP(LINDXARY,ADDR(MFCOA),ADDR(MFMVT));/* LIST OPTIONS*/
*                                                                  0614
         LA    @15,LINDXARY                                        0614
         ST    @15,@AL00001                                        0614
         L     @15,@PC00001+8                                      0614
         ST    @15,@AFTEMPS+8                                      0614
         LA    @15,@AFTEMPS+8                                      0614
         ST    @15,@AL00001+4                                      0614
         L     @15,@PC00001+4                                      0614
         ST    @15,@AFTEMPS+12                                     0614
         LA    @15,@AFTEMPS+12                                     0614
         ST    @15,@AL00001+8                                      0614
         LA    @01,@AL00001                                        0614
         BAL   @14,LISTOP                                          0614
*       /*************************************************************/
*       /*                                                           */
*       /* CLOSE MESSAGE DATASET                                     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0615
*       GENERATE REFS(INMSGDCB,INAUMOPN);                          0615
         CLOSE (INMSGDCB,DISP),MF=(E,INAUMOPN)
*       RETURN;                     /* RETURN TO INP                 */
@EL00012 DS    0H                                                  0616
@EF00012 DS    0H                                                  0616
@ER00012 LM    @14,@12,@SA00012                                    0616
         BR    @14                                                 0616
*     END;                                                         0617
*   ELSE                            /* PROCESS OPERATOR REPLY        */
*     DO;                                                          0618
*                                                                  0618
@RF00572 DS    0H                                                  0619
*       /*************************************************************/
*       /*                                                           */
*       /* OPERATOR REPLIED WITH MORE VALUES. PROCESS THEM           */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0619
*       CALL MFBUFENQ(INREPTXT,EVAL(INREPLEN),INSCB);/* BUILD A    0619
*                                      BUFFER & BCB                  */
         LA    @15,INREPTXT                                        0619
         ST    @15,@AL00001                                        0619
         LH    @15,INREPLEN                                        0619
         ST    @15,@AFTEMPS+8                                      0619
         LA    @15,@AFTEMPS+8                                      0619
         ST    @15,@AL00001+4                                      0619
         LA    @15,INSCB                                           0619
         ST    @15,@AL00001+8                                      0619
         LA    @01,@AL00001                                        0619
         BAL   @14,MFBUFENQ                                        0619
*       CALL MFSRCPRO(LIFORCE);     /* PROCESS REPLY FORCING A MERGE */
         LA    @01,@AL00620                                        0620
         BAL   @14,MFSRCPRO                                        0620
*       LI1STIME='0'B;              /* OPERATOR REPLIED WITH MORE  0621
*                                      VALUES                        */
         NI    LI1STIME,B'01111111'                                0621
*       GOTO LIREPLY;               /* ALLOW OPERATOR TO REPLY       */
         B     LIREPLY                                             0622
*     END;                                                         0623
*   END MFLISTOP;                                                  0624
*                                                                  0625
*/*  PROCEDURE NAME = LISTOP                                         */
*/*                                                                  */
*/*  DESCRIPTIVE NAME = LIST THE OPTIONS                             */
*/*                                                                  */
*/*  FUNCTION = LISTS THE OPTIONS AFTER ALL SOURCES OF INPUT HAVE    */
*/*             BEEN MERGED INTO THE PERMANENT PMA AND COA           */
*/*                                                                  */
*                                                                  0625
*LISTOP:                                                           0625
*   PROCEDURE(LINDXNUM,LICOAPTR,LIMVTPTR);                         0625
*                                                                  0625
LISTOP   STM   @14,@12,@SA00013                                    0625
         MVC   @PC00013(12),0(@01)                                 0625
*/*   BASED COA AND MVT                                              */
*/**** START OF SPECIFICATIONS ***************************************/
*/*                                                                  */
*/* MACCOMP Y-2 SC1CQ/GAM20                                          */
*/* MACSTAT Y-2 73121/Y02150                                         */
*/* MACMEAN TMCOA MEANS COMMON OPTION AREA                           */
*/*                                                                  */
*/* MODULE-NAME = IRBINCOA                                           */
*/*               IRBMFCOA                                           */
*/*               IRBSTCOA                                           */
*/*               IRBTMCOA                                           */
*/*                                                                  */
*/* DESCRIPTIVE-NAME = COMMON OPTION AREA                            */
*/*                                                                  */
*/* COPYRIGHT = NONE                                                 */
*/*                                                                  */
*/* STATUS = RELEASE 2, VERSION 0                                    */
*/*                                                                  */
*/* FUNCTION = MAPPING MACRO FOR THE COA.  THE COA CONTAINS THE      */
*/*            OPTIONS COMMON TO ALL MEASUREMENTS MADE BY MF/1.      */
*/*                                                                  */
*/* NOTES = SEE BELOW                                                */
*/*                                                                  */
*/*    MULTIPLE MACRO NAMES ALLOWS A PROGRAM TO HAVE MULTIPLE COPIES */
*/*    OF THE SAME DATA STRUCTURE FOR DIFFERENT USES, EACH WITH ITS  */
*/*    OWN IMPLICIT POINTER AND ATTRIBUTES.                          */
*/*                                                                  */
*/* MODULE-TYPE = PLS MAPPING MACRO                                  */
*/*                                                                  */
*/* CHANGE-ACTIVITY =                                                */
*/*                                                                  */
*/* A000000-999999                                             Y02150*/
*/*                                                                  */
*/* METHOD-OF-INVOCATION = SEE BELOW                                 */
*/*                                                                  */
*/*    PLS - .QUESTION MARK.IRBINCOA ATTRIBUT(ATTRIBUTES)            */
*/*        - .QUESTION MARK.IRBMFCOA ATTRIBUT(ATTRIBUTES)            */
*/*        - .QUESTION MARK.IRBSTCOA ATTRIBUT(ATTRIBUTES)            */
*/*        - .QUESTION MARK.IRBTMCOA ATTRIBUT(ATTRIBUTES)            */
*/*          WHERE ATTRIBUTES ARE ANY ACCEPTABLE PLS ATTRIBUTES      */
*/*          FOR STRUCTURE DECLARATIONS.                             */
*/*                                                                  */
*/**** END OF SPECIFICATIONS *****************************************/
*                                                                  0626
*   /*****************************************************************/
*   /*                                                               */
*   /* ?IRBTMCOA ATTRIBUT(BASED(LICOAPTR))                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0626
*   DECLARE                                                        0626
*     1 TMCOA                       /* COMMON OPTION AREA            */
*           BASED(LICOAPTR)BDY(WORD),                              0626
*      2 TMCOTCE                    /* TRACE OPTION VARIABLES        */
*            FIXED(31),                                            0626
*       3 TMCOTCEF                  /* TRACE OPTION FLAGS            */
*             BIT(8),                                              0626
*        4 TMCOTCEC                 /* TRACE OPTION CONTROL          */
*              BIT(1),              /* 0-OPTION HAS BEEN SPECIFIED 0626
*                                      1-OPTION NOT YET SPECIFIED    */
*       3 * CHAR(2),                                               0626
*       3 TMCOTCEL                  /* TRACE OPTION VALUE AREA       */
*             CHAR(1),                                             0626
*        4 * BIT(7),                                               0626
*        4 TMCOTCEV                 /* TRACE OPTION VALUE FLAG       */
*              BIT(1),              /* 0-MF/1 MEASUREMENTS NOT TRACED
*                                      TO SMF. 1-MEASUREMENTS ARE  0626
*                                      TRACED WITH SMF.              */
*      2 TMCOCYC                    /* CYCLE OPTION VARIABLES        */
*            FIXED(31),                                            0626
*       3 TMCOCYCF                  /* CYCLE OPTION FLAGS            */
*             BIT(8),                                              0626
*        4 TMCOCYCC                 /* CYCLE OPTION CONTROL          */
*              BIT(1),              /* 0-OPTION HAS BEEN SPECIFIED 0626
*                                      1-OPTION NOT YET SPECIFIED    */
*       3 * CHAR(1),                                               0626
*       3 TMCOCYCV                  /* CYCLE OPTION VALUE            */
*             FIXED(15),            /* 50 TO 999 MILLISECONDS        */
*      2 TMCOOUT                    /* OUT(PUT)CLASS OPTION          */
*            FIXED(31),                                            0626
*       3 TMCOOUTF                  /* OUTCLASS OPTION FLAGS         */
*             BIT(8),                                              0626
*        4 TMCOOUTC                 /* OUTCLASS OPTION CONTROL       */
*              BIT(1),              /* 0-OPTION HAS BEEN SPECIFIED 0626
*                                      1-OPTION NOT YET SPECIFIED    */
*       3 * CHAR(2),                                               0626
*       3 TMCOOUTV                  /* OUTCLASS OPTION VALUE         */
*             CHAR(1),              /* ALPHANUMERIC OUTPUT CLASS     */
*      2 TMCOINT                    /* INTERVAL OPTION               */
*            FIXED(31),                                            0626
*       3 TMCOINTF                  /* INTERVAL OPTION FLAGS         */
*             BIT(8),                                              0626
*        4 TMCOINTC                 /* INTERVAL OPTION CONTROL       */
*              BIT(1),              /* 0-OPTION HAS BEEN SPECIFIED 0626
*                                      1-OPTION NOT YET SPECIFIED    */
*       3 * CHAR(1),                                               0626
*       3 TMCOINTV                  /* INTERVAL OPTION VALUE         */
*             FIXED(15),            /* 1 TO 60 MINUTES               */
*      2 TMCOREP                    /* REPORT OPTION                 */
*            FIXED(31),                                            0626
*       3 TMCOREPF                  /* REPORT OPTION FLAGS           */
*             BIT(8),                                              0626
*        4 TMCOREPC                 /* REPORT OPTION CONTROL         */
*              BIT(1),              /* 0-OPTION HAS BEEN SPECIFIED 0626
*                                      1-OPTION NOT YET SPECIFIED    */
*       3 * CHAR(2),                                               0626
*       3 TMCOREPL                  /* REPORT OPTION VALUE AREA      */
*             CHAR(1),                                             0626
*        4 * BIT(6),                                               0626
*        4 TMCOREPV                 /* REPORT OPTION VALUE FLAGS     */
*              BIT(2),              /* 00-NO REPORTS, 01-DEFERRED  0626
*                                      REPORTS, 10-REALTIME REPORTS  */
*      2 TMCOSTP                    /* STOP OPTION VALUE             */
*            FIXED(31),                                            0626
*       3 TMCOSTPF                  /* STOP OPTION FLAGS             */
*             BIT(8),                                              0626
*        4 TMCOSTPC                 /* STOP OPTION CONTROL           */
*              BIT(1),              /* 0-OPTION HAS BEEN SPECIFIED 0626
*                                      1-OPTION NOT YET SPECIFIED    */
*        4 TMCOSTPS                 /* STOP OPTION STATUS            */
*              BIT(1),              /* 0-MF/1 STOPS AFTER --COSTPV 0626
*                                      STOP OPTION UNITS(COSTPU).  0626
*                                      1-MF/1 DOES NOT STOP UNDER  0626
*                                      PROGRAM CONTROL,(STOP       0626
*                                      COMMAND).                     */
*        4 TMCOSTPU                 /* STOP OPTION UNITS             */
*              BIT(1),              /* 0-VALUE IS IN MINUTES 1-VALUE
*                                      IS IN HOURS                   */
*       3 * CHAR(1),                                               0626
*       3 TMCOSTPV                  /* STOP OPTION VALUE             */
*             FIXED(15),            /* 1-168 HOURS, 1-10080 MINUTES
*                                      (1 WEEK)                      */
*      2 TMCOOPI                    /* OPERATOR INTERVENTION OPTION  */
*            FIXED(31),                                            0626
*       3 TMCOOPIF                  /* OPI OPTION FLAGS              */
*             BIT(8),                                              0626
*        4 TMCOOPIC                 /* OPI OPTION CONTROL            */
*              BIT(1),              /* 0-OPTION HAS BEEN SPECIFIED 0626
*                                      1-OPTION NOT YET SPECIFIED    */
*       3 * CHAR(2),                                               0626
*       3 TMCOOPIL                  /* OPI OPTION VALUE AREA         */
*             CHAR(1),                                             0626
*        4 * BIT(7),                                               0626
*        4 TMCOOPIV                 /* OPI OPTION VALUE FLAG         */
*              BIT(1),              /* 0-DO NOT LIST OPTIONS, 1-LIST
*                                      OPTIONS                       */
*      2 TMCOMEM                    /* MEMBER OPTION                 */
*            FIXED(31),                                            0626
*       3 TMCOMEMF                  /* MEMBER OPTION FLAGS           */
*             BIT(8),                                              0626
*        4 TMCOMEMC                 /* MEMBER OPTION CONTROL         */
*              BIT(1),                                             0626
*       3 * CHAR(1),                                               0626
*       3 TMCOMEMV                  /* MEMBER OPTION VALUE           */
*             CHAR(2),              /* MF/1 OPTION DATA SET SUFFIX   */
*     1 TMCOOPTN                    /* OPTION ARRAY                  */
*           (*)BIT(32)DEFINED(TMCOA),                              0626
*      2 TMCOCTRL                   /* OPTION CONTROL                */
*            BIT(1);                                               0626
*                                                                  0626
*/**** START OF SPECIFICATIONS ***************************************/
*/*                                                                  */
*/* MACCOMP Y-2 SC1CQ/GAM20                                          */
*/* MACSTAT Y-2 73121/Y02150                                         */
*/* MACMEAN TMMVT MEANS MEASUREMENT VECTOR TABLE                     */
*/*                                                                  */
*/* MODULE-NAME = IRBDTMVT                                           */
*/*               IRBINMVT                                           */
*/*               IRBMFMVT                                           */
*/*               IRBSTMVT                                           */
*/*               IRBTMMVT                                           */
*/*                                                                  */
*/* DESCRIPTIVE-NAME = MEASUREMENT VECTOR TABLE                      */
*/*                                                                  */
*/* COPYRIGHT = NONE                                                 */
*/*                                                                  */
*/* STATUS = RELEASE 2, VERSION 0                                    */
*/*                                                                  */
*/* FUNCTION = MAPPING MACRO FOR THE MVT.  FOR EACH MF/1 MEASUREMENT,*/
*/*            MVT CONTAINS A POINTER TO TO MEASUREMENT DATA, CONTROL*/
*/*            DATA, OR A LIST OF MEASUREMENT DATA OR CONTROL        */
*/*            POINTERS.                                             */
*/*                                                                  */
*/* NOTES = SEE BELOW                                                */
*/*                                                                  */
*/*    MULTIPLE MACRO NAMES ALLOWS A PROGRAM TO HAVE MULTIPLE COPIES */
*/*    OF THE SAME DATA STRUCTURE FOR DIFFERENT USES, EACH WITH ITS  */
*/*    OWN IMPLICIT POINTER AND ATTRIBUTES.                          */
*/*                                                                  */
*/* MODULE-TYPE = PLS MAPPING MACRO                                  */
*/*                                                                  */
*/* CHANGE-ACTIVITY =                                                */
*/*                                                                  */
*/* A000000-999999                                             Y02150*/
*/*                                                                  */
*/* METHOD-OF-INVOCATION = SEE BELOW                                 */
*/*                                                                  */
*/*    PLS - .QUESTION MARK.IRBDTMVT ATTRIBUT(ATTRIBUTES)            */
*/*        - .QUESTION MARK.IRBINMVT ATTRIBUT(ATTRIBUTES)            */
*/*        - .QUESTION MARK.IRBMFMVT ATTRIBUT(ATTRIBUTES)            */
*/*        - .QUESTION MARK.IRBSTMVT ATTRIBUT(ATTRIBUTES)            */
*/*        - .QUESTION MARK.IRBTMMVT ATTRIBUT(ATTRIBUTES)            */
*/*          WHERE ATTRIBUTES ARE ANY ACCEPTABLE PLS ATTRIBUTES      */
*/*          FOR STRUCTURE DECLARATIONS.                             */
*/*                                                                  */
*/**** END OF SPECIFICATIONS *****************************************/
*                                                                  0627
*   /*****************************************************************/
*   /*                                                               */
*   /* ?IRBTMMVT ATTRIBUT(BASED(LIMVTPTR))                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0627
*   DECLARE                                                        0627
*     1 TMMVT                       /* MEASUREMENT VECTOR TABLE      */
*           BASED(LIMVTPTR)BDY(WORD),                              0627
*      2 TMMVNUM                    /* NUMBER OF MEASUREMENT OPTIONS */
*            FIXED(31),                                            0627
*      2 TMMVOPT,                   /* OPTION FIELDS                 */
*       3 TMMVCPU                   /* CPU DATA/VECTOR               */
*             PTR(31),                                             0627
*       3 TMMVPAG                   /* PAGING DATA/VECTOR            */
*             PTR(31),                                             0627
*       3 TMMVWKL                   /* WORKLOAD DATA/VECTOR          */
*             PTR(31),                                             0627
*       3 TMMVCHA                   /* CHANNEL DATA/VECTOR           */
*             PTR(31),                                             0627
*       3 TMMVDEV                   /* DEVICE DATA/VECTOR            */
*             PTR(31),                                             0627
*         TMMVADD                   /* DATA ADDRESS,GENERAL REFERENCE*/
*             (5)                   /* NUMBER OF MEASUREMENT OPTIONS */
*             PTR(31)DEFINED(TMMVOPT);                             0627
*   DECLARE                                                        0628
*     LISYSTEM                      /* WKLD(SYSTEM) SPECIFIED        */
*         BIT(2)CONSTANT('01'B),                                   0628
*     LIGROUP                       /* WKLD(GROUP) SPECIFIED         */
*         BIT(2)CONSTANT('10'B),                                   0628
*     LIPERIOD                      /* WKLD(PERIOD) SPECIFIED        */
*         BIT(2)CONSTANT('11'B),                                   0628
*     LINOSTOP                      /* NOSTOP SPECIFIED              */
*         BIT(1)CONSTANT('1'B),                                    0628
*     LISTPMIN                      /* STOP TIME IN MINUTES          */
*         BIT(1)CONSTANT('0'B),                                    0628
*     LINORPRT                      /* NOREPORT SPECIFIED            */
*         BIT(2)CONSTANT('00'B),                                   0628
*     LIDEFER                       /* REPORT(DEFER) SPECIFIED       */
*         BIT(2)CONSTANT('01'B),                                   0628
*     LIREALTM                      /* REPORT(REALTIME)              */
*         BIT(2)CONSTANT('10'B),                                   0628
*     LINOWKLD                      /* NOWKLD SPECIFIED              */
*         BIT(2)CONSTANT('00'B),                                   0628
*     LIOPTSET                      /* OPI OPTION SET                */
*         BIT(1)CONSTANT('1'B),                                    0628
*     LICONTRL                      /* DEVICE OPTION CONTROL INDEX   */
*         FIXED(8)CONSTANT(1),                                     0628
*     LIALLSET                      /* ALL DEVICE CONTROL FLAGS SET  */
*         BIT(8)CONSTANT('00'X),                                   0628
*     LINODEV                       /* ALL DEVICE STATUS FLAGS OFF   */
*         BIT(8)CONSTANT('00'X),                                   0628
*     LISTATUS                      /* OPTION STATUS BYTE            */
*         FIXED(8)CONSTANT(2),                                     0628
*     LINDXNUM(10)                  /* MSG INDEX NUMBER ARRAY        */
*         FIXED(15),                                               0628
*     LICOAPTR                      /* PARAMETER 2 - PTR TO COA TO 0628
*                                      LIST                          */
*         POINTER(31),                                             0628
*     LIMVTPTR                      /* PARAMETER 3 - PTR TO MVT TO 0628
*                                      LIST                          */
*         POINTER(31),                                             0628
*     LICTLSET                      /* OPTION SET                    */
*         BIT(1)CONSTANT('0'B),                                    0628
*     LIONEMSG                      /* INDICATES AT LEAST ONE OPTION
*                                      WAS SET                       */
*         BIT(1),                                                  0628
*     LINDX                         /* MSG INDEX NUMBER              */
*         FIXED(31),                                               0628
*     LICNVADR                      /* CONVERT ROUTINE ADDRESS       */
*         PTR(31),                                                 0628
*     LICNVMOD                      /* ENTRY POINT TO CONVERT ROUTINE*/
*         ENTRY BASED(LICNVADR),                                   0628
*     LISCALE                       /* CONVERT ROUTINE PARM          */
*         FIXED(31)CONSTANT(0),                                    0628
*     LISTRLEN                      /* CONVERT ROUTINE PARM          */
*         FIXED(31),                                               0628
*     LISTRNG                       /* CONVERT ROUTINE PARM          */
*         CHAR(6),                                                 0628
*     LIDIGIT                       /* CONVERT ROUTINE PARM          */
*         FIXED(31)CONSTANT(0),                                    0628
*     LICOMMA                       /* CONVERT ROUTINE PARM          */
*         BIT(1)CONSTANT('0'B),                                    0628
*     LIFLOAT                       /* CONVERT ROUTINE PARM          */
*         BIT(1)CONSTANT('0'B),                                    0628
*     1 LIVTXLST(6),                /* VARIABLE TEXT LIST ARRAY      */
*      2 LIPARTNO                   /* MSG PART NUMBER               */
*            FIXED(15),                                            0628
*      2 LITXTLEN                   /* LENGTH OF VARIABLE TEXT       */
*            FIXED(15),                                            0628
*      2 LIVARTXT                   /* VARIABLE TEXT                 */
*            CHAR(6);                                              0628
*   LIONEMSG='0'B;                  /* INITIALIZE NO OPTIONS SET AND
*                                      NO MESSAGES ISSUED            */
*                                                                  0629
         NI    LIONEMSG,B'01111111'                                0629
*/* SET UP POINTERS TO MAXIMUM NUMBER OF VARIABLE TEXT LIST          */
*                                                                  0630
*   INVTXLST(1)=ADDR(LIPARTNO(1));                                 0630
         LA    @15,LIPARTNO                                        0630
         ST    @15,INVTXLST                                        0630
*   INVTXLST(2)=ADDR(LIPARTNO(2));                                 0631
         LA    @15,LIPARTNO+10                                     0631
         ST    @15,INVTXLST+4                                      0631
*   INVTXLST(3)=ADDR(LIPARTNO(3));                                 0632
         LA    @15,LIPARTNO+20                                     0632
         ST    @15,INVTXLST+8                                      0632
*   INVTXLST(4)=ADDR(LIPARTNO(4));                                 0633
         LA    @15,LIPARTNO+30                                     0633
         ST    @15,INVTXLST+12                                     0633
*   INVTXLST(5)=ADDR(LIPARTNO(5));                                 0634
         LA    @15,LIPARTNO+40                                     0634
         ST    @15,INVTXLST+16                                     0634
*   INVTXLST(6)=ADDR(LIPARTNO(6));                                 0635
         LA    @15,LIPARTNO+50                                     0635
         ST    @15,INVTXLST+20                                     0635
*   IF TMMVCPU->MFPMCON=LICTLSET THEN/* CPU OPTION SET               */
         L     @15,@PC00013+8                                      0636
         L     @01,LIMVTPTR(,@15)                                  0636
         L     @15,TMMVCPU(,@01)                                   0636
         TM    MFPMCON(@15),B'10000000'                            0636
         BNZ   @RF00636                                            0636
*     DO;                           /* SEND MESSAGE FOR THIS OPTION  */
*       LIONEMSG='1'B;              /* INDICATE ONE MSG SENT         */
         OI    LIONEMSG,B'10000000'                                0638
*       IF TMMVCPU->MFPMSTA=LIOPTSET THEN/* 'CPU' MEASUREMENT      0639
*                                      REQUESTED?                    */
         TM    MFPMSTA(@15),B'00000001'                            0639
         BNO   @RF00639                                            0639
*         LIPARTNO(1)=LMPART27;     /* MSG PART NO. FOR CPU          */
         MVC   LIPARTNO(2),@CH00610                                0640
*       ELSE                        /* 'NOCPU' REQUESTED             */
*         LIPARTNO(1)=LMPART28;     /* MSG PART NO. FOR NOCPU        */
         B     @RC00639                                            0641
@RF00639 MVC   LIPARTNO(2),@CH00612                                0641
*       LINDX=LINDXNUM(1);          /* INDEX NUMBER FOR CPU|NOCPU    */
@RC00639 L     @15,@PC00013                                        0642
         LH    @15,LINDXNUM(,@15)                                  0642
         ST    @15,LINDX                                           0642
*       CALL INMSGMOD(LINDX,INVTXLST,0,INMDCBAD);/* ISSUE MESSAGE    */
         LA    @15,LINDX                                           0643
         ST    @15,@AL00001                                        0643
         LA    @15,INVTXLST                                        0643
         ST    @15,@AL00001+4                                      0643
         LA    @15,@CF00945                                        0643
         ST    @15,@AL00001+8                                      0643
         LA    @15,INMDCBAD                                        0643
         ST    @15,@AL00001+12                                     0643
         L     @15,INMSGADR                                        0643
         LA    @01,@AL00001                                        0643
         BALR  @14,@15                                             0643
*     END;                                                         0644
*                                                                  0644
*/*   NOTE: MESSAGES IRB305I AND IRB309I DO NOT REFERENCE THE DCB ADDR
*     BUT THE PARAMETER IS PASSED SO THAT WHEN THIS SUBROUTINE IS  0645
*    CALLED FOR MESSAGE IRB103I WHICH USES A DCB ADDRESS, IT WILL  0645
*    ALWAYS BE PROVIDED.  THE MESSAGE PROCESSOR WILL NOT CALL FOR A DCB
*    ADDRESS FOR MESSAGES IRB305I AND IRB309I.                       */
*                                                                  0645
*   IF TMMVPAG->MFPMCON=LICTLSET THEN/* PAG OPTION SET               */
@RF00636 L     @15,@PC00013+8                                      0645
         L     @01,LIMVTPTR(,@15)                                  0645
         L     @15,TMMVPAG(,@01)                                   0645
         TM    MFPMCON(@15),B'10000000'                            0645
         BNZ   @RF00645                                            0645
*     DO;                           /* SEND MESSAGE FOR THIS OPTION  */
*       LIONEMSG='1'B;              /* INDICATE ONE MSG SENT         */
         OI    LIONEMSG,B'10000000'                                0647
*       IF TMMVPAG->MFPMSTA=LIOPTSET THEN/* 'PAGING' REQUESTED?      */
         TM    MFPMSTA(@15),B'00000001'                            0648
         BNO   @RF00648                                            0648
*         LIPARTNO(1)=LMPART30;     /* MSG PART NO. FOR PAGING       */
         MVC   LIPARTNO(2),@CH00616                                0649
*       ELSE                        /* 'NOPAGING' REQUESTED          */
*         LIPARTNO(1)=LMPART29;     /* MSG PART NO. FOR NOPAGING     */
         B     @RC00648                                            0650
@RF00648 MVC   LIPARTNO(2),@CH00614                                0650
*       LINDX=LINDXNUM(1);          /* INDEX NUMBER FOR PAGING|NOPAG.*/
@RC00648 L     @15,@PC00013                                        0651
         LH    @15,LINDXNUM(,@15)                                  0651
         ST    @15,LINDX                                           0651
*       CALL INMSGMOD(LINDX,INVTXLST,0,INMDCBAD);/* ISSUE MESSAGE    */
         LA    @15,LINDX                                           0652
         ST    @15,@AL00001                                        0652
         LA    @15,INVTXLST                                        0652
         ST    @15,@AL00001+4                                      0652
         LA    @15,@CF00945                                        0652
         ST    @15,@AL00001+8                                      0652
         LA    @15,INMDCBAD                                        0652
         ST    @15,@AL00001+12                                     0652
         L     @15,INMSGADR                                        0652
         LA    @01,@AL00001                                        0652
         BALR  @14,@15                                             0652
*     END;                                                         0653
*   IF TMMVCHA->MFPMCON=LICTLSET THEN/* CHA OPTION SET               */
@RF00645 L     @15,@PC00013+8                                      0654
         L     @01,LIMVTPTR(,@15)                                  0654
         L     @15,TMMVCHA(,@01)                                   0654
         TM    MFPMCON(@15),B'10000000'                            0654
         BNZ   @RF00654                                            0654
*     DO;                           /* SEND MESSAGE FOR THIS OPTION  */
*       LIONEMSG='1'B;              /* INDICATE ONE MSG SENT         */
         OI    LIONEMSG,B'10000000'                                0656
*       IF TMMVCHA->MFPMSTA=LIOPTSET THEN/* 'CHAN' REQUESTED?        */
         TM    MFPMSTA(@15),B'00000001'                            0657
         BNO   @RF00657                                            0657
*         LIPARTNO(1)=LMPART31;     /* MSG PART NO. FOR CHAN         */
         MVC   LIPARTNO(2),@CH00045                                0658
*       ELSE                        /* 'NOCHAN' REQUESTED            */
*         LIPARTNO(1)=LMPART51;     /* MSG PART NO. FOR NOCHAN       */
         B     @RC00657                                            0659
@RF00657 MVC   LIPARTNO(2),@CH00703                                0659
*       LINDX=LINDXNUM(1);                                         0660
@RC00657 L     @15,@PC00013                                        0660
         LH    @15,LINDXNUM(,@15)                                  0660
         ST    @15,LINDX                                           0660
*       CALL INMSGMOD(LINDX,INVTXLST,0,INMDCBAD);/* ISSUE MESSAGE    */
         LA    @15,LINDX                                           0661
         ST    @15,@AL00001                                        0661
         LA    @15,INVTXLST                                        0661
         ST    @15,@AL00001+4                                      0661
         LA    @15,@CF00945                                        0661
         ST    @15,@AL00001+8                                      0661
         LA    @15,INMDCBAD                                        0661
         ST    @15,@AL00001+12                                     0661
         L     @15,INMSGADR                                        0661
         LA    @01,@AL00001                                        0661
         BALR  @14,@15                                             0661
*     END;                                                         0662
*   IF TMMVWKL->MFPMCON=LICTLSET THEN/* WKL OPTION SET               */
@RF00654 L     @15,@PC00013+8                                      0663
         L     @01,LIMVTPTR(,@15)                                  0663
         L     @15,TMMVWKL(,@01)                                   0663
         TM    MFPMCON(@15),B'10000000'                            0663
         BNZ   @RF00663                                            0663
*     DO;                           /* SEND MESSAGE FOR THIS OPTION  */
*       LIONEMSG='1'B;              /* INDICATE ONE MSG SENT         */
         OI    LIONEMSG,B'10000000'                                0665
*       IF TMMVWKL->MFPMWKLD=LINOWKLD THEN/* 'NOWKLD' REQUESTED?     */
         TM    MFPMWKLD(@15),B'00000011'                           0666
         BNZ   @RF00666                                            0666
*         DO;                       /* 'NOWKLD' REQUESTED?           */
*           LIPARTNO(1)=LMPART59;   /* MSG PART NO. FOR NOWKLD       */
         MVC   LIPARTNO(2),@CH00718                                0668
*           LINDX=LINDXNUM(1);                                     0669
         L     @15,@PC00013                                        0669
         LH    @15,LINDXNUM(,@15)                                  0669
         ST    @15,LINDX                                           0669
*         END;                                                     0670
*       ELSE                        /* WKLD(WKLDVALUE) WAS SPECIFIED */
*         DO;                                                      0671
         B     @RC00666                                            0671
@RF00666 DS    0H                                                  0672
*           IF TMMVWKL->MFPMWKLD=LISYSTEM THEN/* 'WKLD(SYSTEM)'    0672
*                                      REQUESTED?                    */
         L     @15,@PC00013+8                                      0672
         L     @01,LIMVTPTR(,@15)                                  0672
         L     @01,TMMVWKL(,@01)                                   0672
         TM    MFPMWKLD(@01),B'00000001'                           0672
         BNO   @RF00672                                            0672
         TM    MFPMWKLD(@01),B'00000010'                           0672
         BNZ   @RF00672                                            0672
*             LIPARTNO(1)=LMPART49; /* MSG PART NO. FOR WKLD(SYSTEM) */
         MVC   LIPARTNO(2),@CH00650                                0673
*           IF TMMVWKL->MFPMWKLD=LIGROUP THEN/* 'WKLD(GROUP)'      0674
*                                      REQUESTED?                    */
@RF00672 L     @15,@PC00013+8                                      0674
         L     @01,LIMVTPTR(,@15)                                  0674
         L     @01,TMMVWKL(,@01)                                   0674
         TM    MFPMWKLD(@01),B'00000010'                           0674
         BNO   @RF00674                                            0674
         TM    MFPMWKLD(@01),B'00000001'                           0674
         BNZ   @RF00674                                            0674
*             LIPARTNO(1)=LMPART47; /* MSG PART NO. FOR WKLD(GROUP)  */
         MVC   LIPARTNO(2),@CH00647                                0675
*           IF TMMVWKL->MFPMWKLD=LIPERIOD THEN/* 'WKLD(PERIOD)'    0676
*                                      REQUESTED                     */
@RF00674 L     @15,@PC00013+8                                      0676
         L     @01,LIMVTPTR(,@15)                                  0676
         L     @01,TMMVWKL(,@01)                                   0676
         TM    MFPMWKLD(@01),B'00000011'                           0676
         BNO   @RF00676                                            0676
*             LIPARTNO(1)=LMPART46; /* MSG PART NO. FOR WKLD(PERIOD) */
         MVC   LIPARTNO(2),@CH00645                                0677
*           LINDX=LINDXNUM(2);                                     0678
@RF00676 L     @15,@PC00013                                        0678
         LH    @15,LINDXNUM+2(,@15)                                0678
         ST    @15,LINDX                                           0678
*         END;                                                     0679
*       CALL INMSGMOD(LINDX,INVTXLST,0,INMDCBAD);/* ISSUE MESSAGE    */
@RC00666 LA    @15,LINDX                                           0680
         ST    @15,@AL00001                                        0680
         LA    @15,INVTXLST                                        0680
         ST    @15,@AL00001+4                                      0680
         LA    @15,@CF00945                                        0680
         ST    @15,@AL00001+8                                      0680
         LA    @15,INMDCBAD                                        0680
         ST    @15,@AL00001+12                                     0680
         L     @15,INMSGADR                                        0680
         LA    @01,@AL00001                                        0680
         BALR  @14,@15                                             0680
*     END;                                                         0681
*   IF TMMVDEV->MFPMCON=LICTLSET THEN/* DEV OPTION SET               */
@RF00663 L     @15,@PC00013+8                                      0682
         L     @01,LIMVTPTR(,@15)                                  0682
         L     @15,TMMVDEV(,@01)                                   0682
         TM    MFPMCON(@15),B'10000000'                            0682
         BNZ   @RF00682                                            0682
*     DO;                           /* SEND MESSAGE FOR THIS OPTION  */
*       LIONEMSG='1'B;              /* INDICATE ONE MSG SENT         */
         OI    LIONEMSG,B'10000000'                                0684
*       IF TMMVDEV->MFPMDEVF(LICONTRL)=LIALLSET&TMMVDEV->MFPMDEVF( 0685
*           LISTATUS)=LINODEV THEN  /* 'NODEVICE' REQUESTED?         */
         CLI   MFPMDEVF(@15),X'00'                                 0685
         BNE   @RF00685                                            0685
         CLI   MFPMDEVF+1(@15),X'00'                               0685
         BNE   @RF00685                                            0685
*         DO;                                                      0686
*           LIPARTNO(1)=LMPART52;   /* MSG PART NO. FOR NODEVICE     */
         MVC   LIPARTNO(2),@CH00250                                0687
*           LINDX=LINDXNUM(1);                                     0688
         L     @15,@PC00013                                        0688
         LH    @15,LINDXNUM(,@15)                                  0688
         ST    @15,LINDX                                           0688
*           CALL INMSGMOD(LINDX,INVTXLST,0,INMDCBAD);/* ISSUE MESSAGE*/
         LA    @15,LINDX                                           0689
         ST    @15,@AL00001                                        0689
         LA    @15,INVTXLST                                        0689
         ST    @15,@AL00001+4                                      0689
         LA    @15,@CF00945                                        0689
         ST    @15,@AL00001+8                                      0689
         LA    @15,INMDCBAD                                        0689
         ST    @15,@AL00001+12                                     0689
         L     @15,INMSGADR                                        0689
         LA    @01,@AL00001                                        0689
         BALR  @14,@15                                             0689
*         END;                                                     0690
*       ELSE                        /* DEVICE OPTION SPECIFIED       */
*         DO;                                                      0691
         B     @RC00685                                            0691
@RF00685 DS    0H                                                  0692
*           IF TMMVDEV->MFPMUNIT(LICONTRL)=LICTLSET THEN/* WAS     0692
*                                      CONTROL FLAG SET?             */
         L     @15,@PC00013+8                                      0692
         L     @01,LIMVTPTR(,@15)                                  0692
         L     @15,TMMVDEV(,@01)                                   0692
         TM    MFPMUNIT(@15),B'00001000'                           0692
         BNZ   @RF00692                                            0692
*             DO;                                                  0693
*               IF TMMVDEV->MFPMUNIT(LISTATUS)=LIOPTSET THEN/*     0694
*                                      'UNITR' REQUESTED?            */
         TM    MFPMUNIT+1(@15),B'00001000'                         0694
         BNO   @RF00694                                            0694
*                 LIPARTNO(1)=LMPART40;/* 'UNITR' DEVICE PART NO.    */
         MVC   LIPARTNO(2),@CH00330                                0695
*               ELSE                                               0696
*                 LIPARTNO(1)=LMPART60;/* 'NOUNITR' DEVICE PART NO.  */
         B     @RC00694                                            0696
@RF00694 MVC   LIPARTNO(2),@CH00529                                0696
*             END;                                                 0697
*           ELSE                    /* CONTROL FLAG NOT SET          */
*             DO;                   /* INSERT NULL STRING            */
         B     @RC00692                                            0698
@RF00692 DS    0H                                                  0699
*               LIPARTNO(1)=0;                                     0699
         SR    @15,@15                                             0699
         STH   @15,LIPARTNO                                        0699
*               LITXTLEN(1)=0;                                     0700
         STH   @15,LITXTLEN                                        0700
*             END;                                                 0701
*           IF TMMVDEV->MFPMGRAP(LICONTRL)=LICTLSET THEN           0702
@RC00692 L     @15,@PC00013+8                                      0702
         L     @01,LIMVTPTR(,@15)                                  0702
         L     @15,TMMVDEV(,@01)                                   0702
         TM    MFPMGRAP(@15),B'00010000'                           0702
         BNZ   @RF00702                                            0702
*             DO;                   /* CONTROL FLAG SET              */
*               IF TMMVDEV->MFPMGRAP(LISTATUS)=LIOPTSET THEN/*     0704
*                                      'GRAPH' REQUESTED?            */
         TM    MFPMGRAP+1(@15),B'00010000'                         0704
         BNO   @RF00704                                            0704
*                 LIPARTNO(2)=LMPART44;/* 'GRAPH' DEVICE PART NO.    */
         MVC   LIPARTNO+10(2),@CH00641                             0705
*               ELSE                                               0706
*                 LIPARTNO(2)=LMPART61;/* 'NOGRAPH' DEVICE PART NO.  */
         B     @RC00704                                            0706
@RF00704 MVC   LIPARTNO+10(2),@CH00721                             0706
*             END;                                                 0707
*           ELSE                    /* CONTROL FLAG NOT SET          */
*             DO;                   /* INSERT NULL STRING            */
         B     @RC00702                                            0708
@RF00702 DS    0H                                                  0709
*               LIPARTNO(2)=0;                                     0709
         SR    @15,@15                                             0709
         STH   @15,LIPARTNO+10                                     0709
*               LITXTLEN(2)=0;                                     0710
         STH   @15,LITXTLEN+10                                     0710
*             END;                                                 0711
*           IF TMMVDEV->MFPMDA(LICONTRL)=LICTLSET THEN             0712
@RC00702 L     @15,@PC00013+8                                      0712
         L     @01,LIMVTPTR(,@15)                                  0712
         L     @15,TMMVDEV(,@01)                                   0712
         TM    MFPMDA(@15),B'00100000'                             0712
         BNZ   @RF00712                                            0712
*             DO;                   /* CONTROL FLAG SET              */
*               IF TMMVDEV->MFPMDA(LISTATUS)=LIOPTSET THEN/* 'DASD'
*                                      REQUESTED?                    */
         TM    MFPMDA+1(@15),B'00100000'                           0714
         BNO   @RF00714                                            0714
*                 LIPARTNO(3)=LMPART42;/* 'DASD' DEVICE PART NO.     */
         MVC   LIPARTNO+20(2),@CH00637                             0715
*               ELSE                                               0716
*                 LIPARTNO(3)=LMPART62;/* 'NODASD' DEVICE PART NO.   */
         B     @RC00714                                            0716
@RF00714 MVC   LIPARTNO+20(2),@CH00723                             0716
*             END;                                                 0717
*           ELSE                    /* CONTROL FLAG NOT SET          */
*             DO;                   /* INSERT NULL STRING            */
         B     @RC00712                                            0718
@RF00712 DS    0H                                                  0719
*               LIPARTNO(3)=0;                                     0719
         SR    @15,@15                                             0719
         STH   @15,LIPARTNO+20                                     0719
*               LITXTLEN(3)=0;                                     0720
         STH   @15,LITXTLEN+20                                     0720
*             END;                                                 0721
*           IF TMMVDEV->MFPMTP(LICONTRL)=LICTLSET THEN             0722
@RC00712 L     @15,@PC00013+8                                      0722
         L     @01,LIMVTPTR(,@15)                                  0722
         L     @15,TMMVDEV(,@01)                                   0722
         TM    MFPMTP(@15),B'01000000'                             0722
         BNZ   @RF00722                                            0722
*             DO;                   /* CONTROL FLAG SET              */
*               IF TMMVDEV->MFPMTP(LISTATUS)=LIOPTSET THEN/* 'COMM'
*                                      REQUESTED                     */
         TM    MFPMTP+1(@15),B'01000000'                           0724
         BNO   @RF00724                                            0724
*                 LIPARTNO(4)=LMPART43;/* 'COMM' DEVICE PART NO.     */
         MVC   LIPARTNO+30(2),@CH00639                             0725
*               ELSE                                               0726
*                 LIPARTNO(4)=LMPART63;/* 'NOCOMM' DEVICE PART NO.   */
         B     @RC00724                                            0726
@RF00724 MVC   LIPARTNO+30(2),@CH00725                             0726
*             END;                                                 0727
*           ELSE                    /* CONTROL FLAG NOT SET          */
*             DO;                   /* INSERT NULL STRING            */
         B     @RC00722                                            0728
@RF00722 DS    0H                                                  0729
*               LIPARTNO(4)=0;                                     0729
         SR    @15,@15                                             0729
         STH   @15,LIPARTNO+30                                     0729
*               LITXTLEN(4)=0;                                     0730
         STH   @15,LITXTLEN+30                                     0730
*             END;                                                 0731
*           IF TMMVDEV->MFPMTAPE(LICONTRL)=LICTLSET THEN           0732
@RC00722 L     @15,@PC00013+8                                      0732
         L     @01,LIMVTPTR(,@15)                                  0732
         L     @15,TMMVDEV(,@01)                                   0732
         TM    MFPMTAPE(@15),B'10000000'                           0732
         BNZ   @RF00732                                            0732
*             DO;                   /* CONTROL FLAG SET              */
*               IF TMMVDEV->MFPMTAPE(LISTATUS)=LIOPTSET THEN/* 'TAPE'
*                                      REQUESTED                     */
         TM    MFPMTAPE+1(@15),B'10000000'                         0734
         BNO   @RF00734                                            0734
*                 LIPARTNO(5)=LMPART41;/* 'TAPE' DEVICE PART NO.     */
         MVC   LIPARTNO+40(2),@CH00635                             0735
*               ELSE                                               0736
*                 LIPARTNO(5)=LMPART64;/* 'NOTAPE' DEVICE            */
         B     @RC00734                                            0736
@RF00734 MVC   LIPARTNO+40(2),@CH00727                             0736
*             END;                                                 0737
*           ELSE                    /* CONTROL FLAG NOT SET          */
*             DO;                   /* INSERT NULL STRING            */
         B     @RC00732                                            0738
@RF00732 DS    0H                                                  0739
*               LIPARTNO(5)=0;                                     0739
         SR    @15,@15                                             0739
         STH   @15,LIPARTNO+40                                     0739
*               LITXTLEN(5)=0;                                     0740
         STH   @15,LITXTLEN+40                                     0740
*             END;                                                 0741
*           IF TMMVDEV->MFPMCRDR(LICONTRL)=LICTLSET THEN           0742
@RC00732 L     @15,@PC00013+8                                      0742
         L     @01,LIMVTPTR(,@15)                                  0742
         L     @15,TMMVDEV(,@01)                                   0742
         TM    MFPMCRDR(@15),B'00000100'                           0742
         BNZ   @RF00742                                            0742
*             DO;                   /* CONTROL FLAG SET              */
*               IF TMMVDEV->MFPMCRDR(LISTATUS)=LIOPTSET THEN/*     0744
*                                      'CHRDR' REQUESTED?            */
         TM    MFPMCRDR+1(@15),B'00000100'                         0744
         BNO   @RF00744                                            0744
*                 LIPARTNO(6)=LMPART65;/* 'CHRDR' DEVICE PART NO.    */
         MVC   LIPARTNO+50(2),@CH00729                             0745
*               ELSE                                               0746
*                 LIPARTNO(6)=LMPART66;/* 'NOCHRDR' DEVICE PART NO.  */
         B     @RC00744                                            0746
@RF00744 MVC   LIPARTNO+50(2),@CH00731                             0746
*             END;                                                 0747
*           ELSE                    /* CONTROL FLAG NOT SET          */
*             DO;                   /* INSERT NULL STRING            */
         B     @RC00742                                            0748
@RF00742 DS    0H                                                  0749
*               LIPARTNO(6)=0;                                     0749
         SR    @15,@15                                             0749
         STH   @15,LIPARTNO+50                                     0749
*               LITXTLEN(6)=0;                                     0750
         STH   @15,LITXTLEN+50                                     0750
*             END;                                                 0751
*           LINDX=LINDXNUM(8);                                     0752
@RC00742 L     @15,@PC00013                                        0752
         LH    @15,LINDXNUM+14(,@15)                               0752
         ST    @15,LINDX                                           0752
*           CALL INMSGMOD(LINDX,INVTXLST,0,INMDCBAD);/* ISSUE MESSAGE*/
         LA    @15,LINDX                                           0753
         ST    @15,@AL00001                                        0753
         LA    @15,INVTXLST                                        0753
         ST    @15,@AL00001+4                                      0753
         LA    @15,@CF00945                                        0753
         ST    @15,@AL00001+8                                      0753
         LA    @15,INMDCBAD                                        0753
         ST    @15,@AL00001+12                                     0753
         L     @15,INMSGADR                                        0753
         LA    @01,@AL00001                                        0753
         BALR  @14,@15                                             0753
*         END;                                                     0754
*     END;                                                         0755
@RC00685 DS    0H                                                  0756
*   IF TMCOTCEC=LICTLSET THEN       /* TRACE OPTION SET              */
@RF00682 L     @15,@PC00013+4                                      0756
         L     @15,LICOAPTR(,@15)                                  0756
         TM    TMCOTCEC(@15),B'10000000'                           0756
         BNZ   @RF00756                                            0756
*     DO;                           /* SEND MESSAGE FOR THIS OPTION  */
*       LIONEMSG='1'B;              /* INDICATE ONE MSG SENT         */
         OI    LIONEMSG,B'10000000'                                0758
*       IF TMCOTCEV=LIOPTSET THEN   /* 'TRACE' REQUESTED?            */
         TM    TMCOTCEV(@15),B'00000001'                           0759
         BNO   @RF00759                                            0759
*         LIPARTNO(1)=LMPART33;     /* MSG PART NO. FOR TRACE        */
         MVC   LIPARTNO(2),@CH00620                                0760
*       ELSE                                                       0761
*         LIPARTNO(1)=LMPART56;     /* MSG PART NO. FOR NOTRACE      */
         B     @RC00759                                            0761
@RF00759 MVC   LIPARTNO(2),@CH00712                                0761
*       LINDX=LINDXNUM(1);                                         0762
@RC00759 L     @15,@PC00013                                        0762
         LH    @15,LINDXNUM(,@15)                                  0762
         ST    @15,LINDX                                           0762
*       CALL INMSGMOD(LINDX,INVTXLST,0,INMDCBAD);/* ISSUE MESSAGE    */
         LA    @15,LINDX                                           0763
         ST    @15,@AL00001                                        0763
         LA    @15,INVTXLST                                        0763
         ST    @15,@AL00001+4                                      0763
         LA    @15,@CF00945                                        0763
         ST    @15,@AL00001+8                                      0763
         LA    @15,INMDCBAD                                        0763
         ST    @15,@AL00001+12                                     0763
         L     @15,INMSGADR                                        0763
         LA    @01,@AL00001                                        0763
         BALR  @14,@15                                             0763
*     END;                                                         0764
*                                                                  0764
*   /*****************************************************************/
*   /*                                                               */
*   /* CYCLE,INTERVAL,AND STOP VALUES NEED CONVERTING. IRBMFCNV IS   */
*   /* CALLED TO PERFORM THE CONVERSION                              */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0765
*   INMODULE='IRBMFCNV';                                           0765
@RF00756 MVC   INMODULE(8),@CC01283                                0765
*   RFY                                                            0766
*    (GPR00P,                                                      0766
*     GPR01P,                                                      0766
*     GPR14P,                                                      0766
*     GPR15F)RSTD;                                                 0766
*   GENERATE;                                                      0767
         LOAD EPLOC=INMODULE
*   LICNVADR=GPR00P;                                               0768
         ST    GPR00P,LICNVADR                                     0768
*   RFY                                                            0769
*    (GPR00P,                                                      0769
*     GPR01P,                                                      0769
*     GPR14P,                                                      0769
*     GPR15F)UNRSTD;                                               0769
*   IF TMCOCYCC=LICTLSET THEN       /* CYCLE OPTION SET              */
         L     @15,@PC00013+4                                      0770
         L     @15,LICOAPTR(,@15)                                  0770
         TM    TMCOCYCC(@15),B'10000000'                           0770
         BNZ   @RF00770                                            0770
*     DO;                           /* SEND MESSAGE FOR THIS OPTION  */
*       LIONEMSG='1'B;              /* INDICATE ONE MSG SENT         */
         OI    LIONEMSG,B'10000000'                                0772
*       LISTRLEN=3;                                                0773
         MVC   LISTRLEN(4),@CF00311                                0773
*       CALL LICNVMOD(EVAL(TMCOCYCV),LISCALE,LISTRNG,LISTRLEN,LIDIGIT,
*           LICOMMA,LIFLOAT);       /* CONVERT VALUE                 */
         MVC   @AL00001+4(24),@AL00774                             0774
         LH    @15,TMCOCYCV(,@15)                                  0774
         ST    @15,@AFTEMPS+16                                     0774
         LA    @15,@AFTEMPS+16                                     0774
         ST    @15,@AL00001                                        0774
         LA    @15,LISTRNG                                         0774
         ST    @15,@AL00001+8                                      0774
         LA    @15,LISTRLEN                                        0774
         ST    @15,@AL00001+12                                     0774
         L     @14,LICNVADR                                        0774
         LR    @15,@14                                             0774
         LA    @01,@AL00001                                        0774
         BALR  @14,@15                                             0774
*       LIVARTXT(1)=LISTRNG(1:LISTRLEN);/* MOVE INTO LIST CYCLE VALUE*/
         MVI   LIVARTXT+1,C' '                                     0775
         MVC   LIVARTXT+2(4),LIVARTXT+1                            0775
         L     @15,LISTRLEN                                        0775
         LR    @14,@15                                             0775
         BCTR  @14,0                                               0775
         EX    @14,@SM01514                                        0775
*       LITXTLEN(1)=LISTRLEN;                                      0776
         STH   @15,LITXTLEN                                        0776
*       IF LIVARTXT(1,1)=' ' THEN   /* A LEADING BLANK?              */
         CLI   LIVARTXT,C' '                                       0777
         BNE   @RF00777                                            0777
*         DO;                       /* REMOVE LEADING BLANK          */
*           LIVARTXT(1,1:LISTRLEN-1)=LIVARTXT(1,2:LISTRLEN);       0779
         BCTR  @15,0                                               0779
         BCTR  @15,0                                               0779
         MVC   @TS00001(6),LIVARTXT+1                              0779
         EX    @15,@SM01516                                        0779
*           LITXTLEN(1)=LISTRLEN-1;                                0780
         STH   @14,LITXTLEN                                        0780
*         END;                                                     0781
*       LIPARTNO(1)=0;                                             0782
@RF00777 SR    @15,@15                                             0782
         STH   @15,LIPARTNO                                        0782
*       LINDX=LINDXNUM(5);                                         0783
         L     @15,@PC00013                                        0783
         LH    @15,LINDXNUM+8(,@15)                                0783
         ST    @15,LINDX                                           0783
*       CALL INMSGMOD(LINDX,INVTXLST,0,INMDCBAD);/* ISSUE MESSAGE    */
         LA    @15,LINDX                                           0784
         ST    @15,@AL00001                                        0784
         LA    @15,INVTXLST                                        0784
         ST    @15,@AL00001+4                                      0784
         LA    @15,@CF00945                                        0784
         ST    @15,@AL00001+8                                      0784
         LA    @15,INMDCBAD                                        0784
         ST    @15,@AL00001+12                                     0784
         L     @15,INMSGADR                                        0784
         LA    @01,@AL00001                                        0784
         BALR  @14,@15                                             0784
*     END;                                                         0785
*   IF TMCOINTC=LICTLSET THEN       /* INTERVAL OPTION SET           */
@RF00770 L     @15,@PC00013+4                                      0786
         L     @15,LICOAPTR(,@15)                                  0786
         TM    TMCOINTC(@15),B'10000000'                           0786
         BNZ   @RF00786                                            0786
*     DO;                           /* SEND MESSAGE FOR THIS OPTION  */
*       LIONEMSG='1'B;              /* INDICATE ONE MSG SENT         */
         OI    LIONEMSG,B'10000000'                                0788
*       LISTRLEN=2;                                                0789
         MVC   LISTRLEN(4),@CF00078                                0789
*       CALL LICNVMOD(EVAL(TMCOINTV),LISCALE,LISTRNG,LISTRLEN,LIDIGIT,
*           LICOMMA,LIFLOAT);       /* CONVERT VALUE                 */
         MVC   @AL00001+4(24),@AL00790                             0790
         LH    @15,TMCOINTV(,@15)                                  0790
         ST    @15,@AFTEMPS+16                                     0790
         LA    @15,@AFTEMPS+16                                     0790
         ST    @15,@AL00001                                        0790
         LA    @15,LISTRNG                                         0790
         ST    @15,@AL00001+8                                      0790
         LA    @15,LISTRLEN                                        0790
         ST    @15,@AL00001+12                                     0790
         L     @15,LICNVADR                                        0790
         LA    @01,@AL00001                                        0790
         BALR  @14,@15                                             0790
*       LISTRNG(3)='M';             /* TIME IN MINUTES               */
         MVI   LISTRNG+2,C'M'                                      0791
*       LIVARTXT(1)=LISTRNG;        /* MOVE IN INTERVAL VALUE        */
         MVC   LIVARTXT(6),LISTRNG                                 0792
*       LITXTLEN(1)=3;                                             0793
         MVC   LITXTLEN(2),@CH00311                                0793
*       IF LIVARTXT(1,1)=' ' THEN   /* LEADING BLANK?                */
         CLI   LIVARTXT,C' '                                       0794
         BNE   @RF00794                                            0794
*         DO;                                                      0795
*           LIVARTXT(1,1:2)=LIVARTXT(1,2:3);/* MOVE OVER ONE CHAR    */
         MVC   @TS00001(2),LIVARTXT+1                              0796
         MVC   LIVARTXT(2),@TS00001                                0796
*           LITXTLEN(1)=2;          /* CHANGE LENGTH                 */
         MVC   LITXTLEN(2),@CH00078                                0797
*         END;                                                     0798
*       LIPARTNO(1)=0;                                             0799
@RF00794 SR    @15,@15                                             0799
         STH   @15,LIPARTNO                                        0799
*       LINDX=LINDXNUM(4);                                         0800
         L     @15,@PC00013                                        0800
         LH    @15,LINDXNUM+6(,@15)                                0800
         ST    @15,LINDX                                           0800
*       CALL INMSGMOD(LINDX,INVTXLST,0,INMDCBAD);/* ISSUE MESSAGE    */
         LA    @15,LINDX                                           0801
         ST    @15,@AL00001                                        0801
         LA    @15,INVTXLST                                        0801
         ST    @15,@AL00001+4                                      0801
         LA    @15,@CF00945                                        0801
         ST    @15,@AL00001+8                                      0801
         LA    @15,INMDCBAD                                        0801
         ST    @15,@AL00001+12                                     0801
         L     @15,INMSGADR                                        0801
         LA    @01,@AL00001                                        0801
         BALR  @14,@15                                             0801
*     END;                                                         0802
*   IF TMCOSTPC=LICTLSET THEN       /* STOP OPTION SET               */
@RF00786 L     @15,@PC00013+4                                      0803
         L     @15,LICOAPTR(,@15)                                  0803
         TM    TMCOSTPC(@15),B'10000000'                           0803
         BNZ   @RF00803                                            0803
*     DO;                           /* SEND MESSAGE FOR THIS OPTION  */
*       LIONEMSG='1'B;              /* INDICATE ONE MSG SENT         */
         OI    LIONEMSG,B'10000000'                                0805
*       IF TMCOSTPS=LINOSTOP THEN   /* 'NOSTOP' REQUESTED?           */
         TM    TMCOSTPS(@15),B'01000000'                           0806
         BNO   @RF00806                                            0806
*         DO;                                                      0807
*           LIPARTNO(1)=LMPART58;   /* MSG PART NO. FOR NOSTOP       */
         MVC   LIPARTNO(2),@CH00716                                0808
*           LINDX=LINDXNUM(1);      /* INDEX NUMBER                  */
         L     @15,@PC00013                                        0809
         LH    @15,LINDXNUM(,@15)                                  0809
         ST    @15,LINDX                                           0809
*           CALL INMSGMOD(LINDX,INVTXLST,0,INMDCBAD);/* ISSUE MESSAGE*/
         LA    @15,LINDX                                           0810
         ST    @15,@AL00001                                        0810
         LA    @15,INVTXLST                                        0810
         ST    @15,@AL00001+4                                      0810
         LA    @15,@CF00945                                        0810
         ST    @15,@AL00001+8                                      0810
         LA    @15,INMDCBAD                                        0810
         ST    @15,@AL00001+12                                     0810
         L     @15,INMSGADR                                        0810
         LA    @01,@AL00001                                        0810
         BALR  @14,@15                                             0810
*         END;                                                     0811
*       ELSE                        /* STOP(VALUE) SPECIFIED         */
*         DO;                                                      0812
         B     @RC00806                                            0812
@RF00806 DS    0H                                                  0813
*           IF TMCOSTPU=LISTPMIN THEN/* STOP TIME IN MINUTES?        */
         L     @15,@PC00013+4                                      0813
         L     @01,LICOAPTR(,@15)                                  0813
         TM    TMCOSTPU(@01),B'00100000'                           0813
         BNZ   @RF00813                                            0813
*             DO;                                                  0814
*               LISTRLEN=5;         /* LENGTH OF CONVERTED STRING    */
         MVC   LISTRLEN(4),@CF00053                                0815
*               LISTRNG(6)='M';     /* INDICATE MINUTES IN STRING    */
         MVI   LISTRNG+5,C'M'                                      0816
*             END;                                                 0817
*           ELSE                    /* STOP TIME IN HOURS            */
*             DO;                                                  0818
         B     @RC00813                                            0818
@RF00813 DS    0H                                                  0819
*               LISTRLEN=3;         /* LENGTH OF CONVERTED STRING    */
         MVC   LISTRLEN(4),@CF00311                                0819
*               LISTRNG(4)='H';     /* INDICATE HOURS IN STRING      */
         MVI   LISTRNG+3,C'H'                                      0820
*             END;                                                 0821
*           CALL LICNVMOD(EVAL(TMCOSTPV),LISCALE,LISTRNG,LISTRLEN, 0822
*               LIDIGIT,LICOMMA,LIFLOAT);/* CONVERT VALUE            */
@RC00813 MVC   @AL00001+4(24),@AL00822                             0822
         L     @15,@PC00013+4                                      0822
         L     @01,LICOAPTR(,@15)                                  0822
         LH    @15,TMCOSTPV(,@01)                                  0822
         ST    @15,@AFTEMPS+16                                     0822
         LA    @15,@AFTEMPS+16                                     0822
         ST    @15,@AL00001                                        0822
         LA    @15,LISTRNG                                         0822
         ST    @15,@AL00001+8                                      0822
         LA    @15,LISTRLEN                                        0822
         ST    @15,@AL00001+12                                     0822
         L     @15,LICNVADR                                        0822
         LA    @01,@AL00001                                        0822
         BALR  @14,@15                                             0822
*           LIVARTXT(1)=LISTRNG;    /* MOVE IN STOP VALUE            */
         MVC   LIVARTXT(6),LISTRNG                                 0823
*           LITXTLEN(1)=LISTRLEN+1; /* ALLOW FOR 'M' OR 'H'          */
*                                                                  0824
         LA    @15,1                                               0824
         L     @14,LISTRLEN                                        0824
         AR    @14,@15                                             0824
         STH   @14,LITXTLEN                                        0824
*/* TAKE OUT LEADING BLANKS                                          */
*                                                                  0825
*           DO I=1 TO LITXTLEN(1)WHILE(LIVARTXT(1,I)=' ');         0825
         B     @DE00825                                            0825
@DL00825 LA    @14,LIVARTXT-1(@15)                                 0825
         CLI   0(@14),C' '                                         0825
         BNE   @DC00825                                            0825
*           END;                                                   0826
         AH    @15,@CH00065                                        0826
@DE00825 ST    @15,I                                               0826
         CH    @15,LITXTLEN                                        0826
         BNH   @DL00825                                            0826
@DC00825 DS    0H                                                  0827
*           LIVARTXT(1,1:LITXTLEN(1)-I+1)=LIVARTXT(1,I:LITXTLEN(1));
         L     @15,I                                               0827
         LH    @14,LITXTLEN                                        0827
         SR    @14,@15                                             0827
         LA    @01,LIVARTXT-1(@15)                                 0827
         MVC   @TS00001(6),0(@01)                                  0827
         EX    @14,@SM01516                                        0827
*                                   /* MOVE CHARACTERS OVER          */
*           LITXTLEN(1)=LITXTLEN(1)-I+1;/* CHANGE LENGTH             */
         LCR   @15,@15                                             0828
         AH    @15,LITXTLEN                                        0828
         AH    @15,@CH00065                                        0828
         STH   @15,LITXTLEN                                        0828
*           LIPARTNO(1)=0;                                         0829
         SR    @15,@15                                             0829
         STH   @15,LIPARTNO                                        0829
*           LINDX=LINDXNUM(6);                                     0830
         L     @15,@PC00013                                        0830
         LH    @15,LINDXNUM+10(,@15)                               0830
         ST    @15,LINDX                                           0830
*           CALL INMSGMOD(LINDX,INVTXLST,0,INMDCBAD);/* ISSUE MESSAGE*/
         LA    @15,LINDX                                           0831
         ST    @15,@AL00001                                        0831
         LA    @15,INVTXLST                                        0831
         ST    @15,@AL00001+4                                      0831
         LA    @15,@CF00945                                        0831
         ST    @15,@AL00001+8                                      0831
         LA    @15,INMDCBAD                                        0831
         ST    @15,@AL00001+12                                     0831
         L     @15,INMSGADR                                        0831
         LA    @01,@AL00001                                        0831
         BALR  @14,@15                                             0831
*         END;                                                     0832
*     END;                                                         0833
@RC00806 DS    0H                                                  0834
*   IF TMCOOUTC=LICTLSET THEN       /* SYSOUT OPTION SET             */
@RF00803 L     @15,@PC00013+4                                      0834
         L     @15,LICOAPTR(,@15)                                  0834
         TM    TMCOOUTC(@15),B'10000000'                           0834
         BNZ   @RF00834                                            0834
*     DO;                           /* SEND MESSAGE FOR THIS OPTION  */
*       LIONEMSG='1'B;              /* INDICATE ONE MSG SENT         */
         OI    LIONEMSG,B'10000000'                                0836
*       LIVARTXT(1)=TMCOOUTV;       /* MOVE IN SYSOUT VALUE          */
         MVI   LIVARTXT+1,C' '                                     0837
         MVC   LIVARTXT+2(4),LIVARTXT+1                            0837
         MVC   LIVARTXT(1),TMCOOUTV(@15)                           0837
*       LITXTLEN(1)=1;                                             0838
         MVC   LITXTLEN(2),@CH00065                                0838
*       LIPARTNO(1)=0;                                             0839
         SR    @15,@15                                             0839
         STH   @15,LIPARTNO                                        0839
*       LINDX=LINDXNUM(7);                                         0840
         L     @15,@PC00013                                        0840
         LH    @15,LINDXNUM+12(,@15)                               0840
         ST    @15,LINDX                                           0840
*       CALL INMSGMOD(LINDX,INVTXLST,0,INMDCBAD);/* ISSUE MESSAGE    */
         LA    @15,LINDX                                           0841
         ST    @15,@AL00001                                        0841
         LA    @15,INVTXLST                                        0841
         ST    @15,@AL00001+4                                      0841
         LA    @15,@CF00945                                        0841
         ST    @15,@AL00001+8                                      0841
         LA    @15,INMDCBAD                                        0841
         ST    @15,@AL00001+12                                     0841
         L     @15,INMSGADR                                        0841
         LA    @01,@AL00001                                        0841
         BALR  @14,@15                                             0841
*     END;                                                         0842
*   IF TMCOREPC=LICTLSET THEN       /* REPORT OPTION SET             */
@RF00834 L     @15,@PC00013+4                                      0843
         L     @15,LICOAPTR(,@15)                                  0843
         TM    TMCOREPC(@15),B'10000000'                           0843
         BNZ   @RF00843                                            0843
*     DO;                           /* SEND MESSAGE FOR THIS OPTION  */
*       LIONEMSG='1'B;              /* INDICATE ONE MSG SENT         */
         OI    LIONEMSG,B'10000000'                                0845
*       INVTXLST(1)=ADDR(LIPARTNO(1));                             0846
         LA    @14,LIPARTNO                                        0846
         ST    @14,INVTXLST                                        0846
*       IF TMCOREPV=LINORPRT THEN   /* 'NOREPORT' REQUESTED?         */
         TM    TMCOREPV(@15),B'00000011'                           0847
         BNZ   @RF00847                                            0847
*         DO;                                                      0848
*           LIPARTNO(1)=LMPART57;   /* MSG PART NO. FOR NOREPORT     */
         MVC   LIPARTNO(2),@CH00714                                0849
*           LINDX=LINDXNUM(1);                                     0850
         L     @15,@PC00013                                        0850
         LH    @15,LINDXNUM(,@15)                                  0850
         ST    @15,LINDX                                           0850
*         END;                                                     0851
*       ELSE                        /* REPORT(REPORTVALUE) SPECIFIED */
*         DO;                                                      0852
         B     @RC00847                                            0852
@RF00847 DS    0H                                                  0853
*           IF TMCOREPV=LIDEFER THEN/* 'REPORT(DEFER)' REQUESTED?    */
         L     @15,@PC00013+4                                      0853
         L     @01,LICOAPTR(,@15)                                  0853
         TM    TMCOREPV(@01),B'00000001'                           0853
         BNO   @RF00853                                            0853
         TM    TMCOREPV(@01),B'00000010'                           0853
         BNZ   @RF00853                                            0853
*             LIPARTNO(1)=LMPART48; /* MSG PART NO. FOR DEFER        */
         MVC   LIPARTNO(2),@CH00452                                0854
*           ELSE                    /* 'REPORT(REALTIME)' REQUESTED  */
*             LIPARTNO(1)=LMPART50; /* MSG PART NO. FOR REALTIME     */
         B     @RC00853                                            0855
@RF00853 MVC   LIPARTNO(2),@CH00701                                0855
*           LINDX=LINDXNUM(3);                                     0856
@RC00853 L     @15,@PC00013                                        0856
         LH    @15,LINDXNUM+4(,@15)                                0856
         ST    @15,LINDX                                           0856
*         END;                                                     0857
*       CALL INMSGMOD(LINDX,INVTXLST,0,INMDCBAD);/* ISSUE MESSAGE    */
@RC00847 LA    @15,LINDX                                           0858
         ST    @15,@AL00001                                        0858
         LA    @15,INVTXLST                                        0858
         ST    @15,@AL00001+4                                      0858
         LA    @15,@CF00945                                        0858
         ST    @15,@AL00001+8                                      0858
         LA    @15,INMDCBAD                                        0858
         ST    @15,@AL00001+12                                     0858
         L     @15,INMSGADR                                        0858
         LA    @01,@AL00001                                        0858
         BALR  @14,@15                                             0858
*     END;                                                         0859
*   IF TMCOMEMC=LICTLSET THEN       /* MEMBER OPTION SET             */
@RF00843 L     @15,@PC00013+4                                      0860
         L     @15,LICOAPTR(,@15)                                  0860
         TM    TMCOMEMC(@15),B'10000000'                           0860
         BNZ   @RF00860                                            0860
*     DO;                           /* SEND MESSAGE FOR THIS OPTION  */
*       LIONEMSG='1'B;              /* INDICATE ONE MSG SENT         */
*                                                                  0862
         OI    LIONEMSG,B'10000000'                                0862
*       /*************************************************************/
*       /*                                                           */
*       /* IF MERGE COMPLETE AND LISTING CURRENT SOURCE, PRINT REAL  */
*       /* MEMBER USED. OTHERWISE PRINT CURRENT MEMBER ASSUMED       */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0863
*       IF LICOAPTR=ADDR(INCOA)&INMRGFIN='1'B THEN                 0863
         LA    @14,INCOA                                           0863
         CR    @15,@14                                             0863
         BNE   @RF00863                                            0863
         TM    INMRGFIN,B'10000000'                                0863
         BNO   @RF00863                                            0863
*         LIVARTXT(1)=MFCOMEMV;                                    0864
         MVI   LIVARTXT+2,C' '                                     0864
         MVC   LIVARTXT+3(3),LIVARTXT+2                            0864
         L     @15,@PC00001+8                                      0864
         MVC   LIVARTXT(2),MFCOMEMV(@15)                           0864
*       ELSE                                                       0865
*         LIVARTXT(1)=TMCOMEMV;                                    0865
         B     @RC00863                                            0865
@RF00863 MVI   LIVARTXT+2,C' '                                     0865
         MVC   LIVARTXT+3(3),LIVARTXT+2                            0865
         L     @15,@PC00013+4                                      0865
         L     @01,LICOAPTR(,@15)                                  0865
         MVC   LIVARTXT(2),TMCOMEMV(@01)                           0865
*       LITXTLEN(1)=LENGTH(TMCOMEMV);                              0866
@RC00863 MVC   LITXTLEN(2),@CH00078                                0866
*       LIPARTNO(1)=0;                                             0867
         SR    @15,@15                                             0867
         STH   @15,LIPARTNO                                        0867
*       LINDX=LINDXNUM(9);                                         0868
         L     @15,@PC00013                                        0868
         LH    @15,LINDXNUM+16(,@15)                               0868
         ST    @15,LINDX                                           0868
*       CALL INMSGMOD(LINDX,INVTXLST,0,INMDCBAD);/* ISSUE MESSAGE    */
         LA    @15,LINDX                                           0869
         ST    @15,@AL00001                                        0869
         LA    @15,INVTXLST                                        0869
         ST    @15,@AL00001+4                                      0869
         LA    @15,@CF00945                                        0869
         ST    @15,@AL00001+8                                      0869
         LA    @15,INMDCBAD                                        0869
         ST    @15,@AL00001+12                                     0869
         L     @15,INMSGADR                                        0869
         LA    @01,@AL00001                                        0869
         BALR  @14,@15                                             0869
*     END;                                                         0870
*                                                                  0870
*   /*****************************************************************/
*   /*                                                               */
*   /* WRITE OUT OPI MSG IF THIS IS CURRENT SOURCE AND OPTION IS SET */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0871
*   IF LIMVTPTR=ADDR(INMVT)&TMCOOPIC=LICTLSET THEN                 0871
@RF00860 L     @15,@PC00013+8                                      0871
         LA    @14,INMVT                                           0871
         C     @14,LIMVTPTR(,@15)                                  0871
         BNE   @RF00871                                            0871
         L     @15,@PC00013+4                                      0871
         L     @15,LICOAPTR(,@15)                                  0871
         TM    TMCOOPIC(@15),B'10000000'                           0871
         BNZ   @RF00871                                            0871
*     DO;                                                          0872
*       LIONEMSG='1'B;              /* INDICATE ONE MSG SENT         */
         OI    LIONEMSG,B'10000000'                                0873
*       IF TMCOOPIV=LIOPTSET THEN                                  0874
         TM    TMCOOPIV(@15),B'00000001'                           0874
         BNO   @RF00874                                            0874
*         LIPARTNO(1)=LMPART71;     /* MSG PART NO. FOR OPI          */
         MVC   LIPARTNO(2),@CH00741                                0875
*       ELSE                                                       0876
*         LIPARTNO(1)=LMPART72;     /* MSG PART NO. FOR NOOPI        */
*                                                                  0876
         B     @RC00874                                            0876
@RF00874 MVC   LIPARTNO(2),@CH00535                                0876
*       /*************************************************************/
*       /*                                                           */
*       /* ISSUE MESSAGE                                             */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0877
*       LINDX=LINDXNUM(1);                                         0877
@RC00874 L     @15,@PC00013                                        0877
         LH    @15,LINDXNUM(,@15)                                  0877
         ST    @15,LINDX                                           0877
*       CALL INMSGMOD(LINDX,INVTXLST,0,INMDCBAD);/* ISSUE MESSAGE    */
         LA    @15,LINDX                                           0878
         ST    @15,@AL00001                                        0878
         LA    @15,INVTXLST                                        0878
         ST    @15,@AL00001+4                                      0878
         LA    @15,@CF00945                                        0878
         ST    @15,@AL00001+8                                      0878
         LA    @15,INMDCBAD                                        0878
         ST    @15,@AL00001+12                                     0878
         L     @15,INMSGADR                                        0878
         LA    @01,@AL00001                                        0878
         BALR  @14,@15                                             0878
*     END;                                                         0879
*                                                                  0879
*   /*****************************************************************/
*   /*                                                               */
*   /* MACDATE Y-2 73018                                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0880
*   RESPECIFY                                                      0880
*    (GPR00P,                                                      0880
*     GPR01P,                                                      0880
*     GPR14P,                                                      0880
*     GPR15P)RESTRICTED;                                           0880
@RF00871 DS    0H                                                  0881
*   GENERATE;                                                      0881
*                                                                  0881
*                                   /* DELETE CONVERT ROUTINE */
         DELETE EPLOC=INMODULE
*   /*****************************************************************/
*   /*                                                               */
*   /* MACDATE Y-2 73018                                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0882
*   RESPECIFY                                                      0882
*    (GPR00P,                                                      0882
*     GPR01P,                                                      0882
*     GPR14P,                                                      0882
*     GPR15P)UNRESTRICTED;                                         0882
*   IF LIONEMSG='0'B THEN           /* NO MESSAGES ISSUED BECAUSE NO
*                                      OPTIONS WERE SET. ISSUE NO  0883
*                                      MF/1 OPTIONS ASSUMED MSG.     */
         TM    LIONEMSG,B'10000000'                                0883
         BNZ   @RF00883                                            0883
*     CALL INMSGMOD(EVAL(LINDXNUM(10)),0,0,INMDCBAD);/* ISSUE MESSAGE*/
         L     @15,@PC00013                                        0884
         LH    @15,LINDXNUM+18(,@15)                               0884
         ST    @15,@AFTEMPS+16                                     0884
         LA    @15,@AFTEMPS+16                                     0884
         ST    @15,@AL00001                                        0884
         LA    @15,@CF00945                                        0884
         ST    @15,@AL00001+4                                      0884
         LA    @15,@CF00945                                        0884
         ST    @15,@AL00001+8                                      0884
         LA    @15,INMDCBAD                                        0884
         ST    @15,@AL00001+12                                     0884
         L     @15,INMSGADR                                        0884
         LA    @01,@AL00001                                        0884
         BALR  @14,@15                                             0884
*   RETURN;                         /* RETURN TO INP                 */
@EL00013 DS    0H                                                  0885
@EF00013 DS    0H                                                  0885
@ER00013 LM    @14,@12,@SA00013                                    0885
         BR    @14                                                 0885
*   END LISTOP;                                                    0886
         B     @EL00013                                            0886
*                                                                  0887
*/*  PROCEDURE NAME = MFOPINIT                                       */
*/*                                                                  */
*/*  DESCRIPTIVE NAME = OPTION INITIALIZATION                        */
*/*                                                                  */
*/*  FUNCTION = INITIALIZES THE PMA AND COA (TEMPORARY ONES)         */
*/*             ACCORDING TO THE OPTIONS SPECIFIED.                  */
*/*                                                                  */
*                                                                  0887
*MFOPINIT:                                                         0887
*   PROCEDURE(OPCODPTR);                                           0887
MFOPINIT STM   @14,@12,@SA00014                                    0887
         MVC   @PC00014(4),0(@01)                                  0887
*   DECLARE                                                        0888
*     1 OP303LST,                   /* TEXT TO BE INSERTED IN MSG    */
*      2 OPTXTNUM                   /* MSG PART NUMBER               */
*            FIXED(15),                                            0888
*      2 OPTXTLEN                   /* LENGTH OF TEXT                */
*            FIXED(15),                                            0888
*      2 OPTEXT                     /* TEXT                          */
*            CHAR(2),                                              0888
*        OPMAXVAL                   /* MAXIMUM VALUE FOR STOP IN HRS */
*            STATIC LOCAL FIXED(31)INIT(168),                      0888
*        OPCODPTR                   /* PTR TO SUBROUTINE CODE        */
*            PTR(31),                                              0888
*        OPSUBCOD                   /* SUBROUTINE CODE               */
*            FIXED(8)BASED(OPCODPTR),                              0888
*        OPCNTRL                    /* DEVICE TYPES CONTROL ELEMENT  */
*            FIXED(8)CONSTANT(1),                                  0888
*        OPSTATUS                   /* DEVICE TYPES STATUS ELEMENT   */
*            FIXED(8)CONSTANT(2),                                  0888
*        OPLABEL                    /* SECTION OF CODE TO BE EXECUTED*/
*            LABEL BASED,                                          0888
*        OPONEMIN                   /* MINIMUM INTERVAL TIME         */
*            FIXED(15)CONSTANT(1),                                 0888
*        OP60MIN                    /* MAXIMUM INTERVAL TIME         */
*            FIXED(15)CONSTANT(60),                                0888
*        OPCNVADR                   /* CONVERT ROUTINE ADDRESS       */
*            PTR(31),                                              0888
*        OPCNVMOD                   /* CONVERT ROUTINE ENTRY POINT   */
*            ENTRY BASED(OPCNVADR),                                0888
*        OPTMEMBR                   /* CONVERTED MEMBER NUMBER       */
*            CHARACTER(2),                                         0888
*        OP999MS                    /* CYCLE MAXIMUM VALUE           */
*            FIXED(15)CONSTANT(999),                               0888
*        OP50MS                     /* CYCLE MINIMUM VALUE           */
*            FIXED(15)CONSTANT(50),                                0888
*        OPOPTSET                   /* OPTION SET                    */
*            BIT(1)CONSTANT('0'B),                                 0888
*        OPSYSTEM                   /* WKLD(SYSTEM) SPECIFIED        */
*            BIT(2)CONSTANT('01'B),                                0888
*        OPGROUP                    /* WKLD(GROUP) SPECIFIED         */
*            BIT(2)CONSTANT('10'B),                                0888
*        OPPERIOD                   /* WKLD(PERIOD) SPECIFIED        */
*            BIT(2)CONSTANT('11'B),                                0888
*        OPNOWKLD                   /* NOWKLD SPECIFIED              */
*            BIT(2)CONSTANT('00'B),                                0888
*        OPPAGC                     /* PAGING OPTION                 */
*            BIT(1)CONSTANT('1'B),                                 0888
*        OPNOPAGC                   /* NOPAGING OPTION               */
*            BIT(1)CONSTANT('0'B),                                 0888
*        OPCPUC                     /* CPU OPTION                    */
*            BIT(1)CONSTANT('1'B),                                 0888
*        OPNOCPUC                   /* NOCPU OPTION                  */
*            BIT(1)CONSTANT('0'B),                                 0888
*        OPCHANC                    /* CHANNEL OPTION                */
*            BIT(1)CONSTANT('1'B),                                 0888
*        OPNOCHN                    /* NOCHANNEL OPTION              */
*            BIT(1)CONSTANT('0'B),                                 0888
*        OPTAPDEV                   /* TAPE DEVICE                   */
*            BIT(1)CONSTANT('1'B),                                 0888
*        OPNOTADV                   /* NOTAPE DEVICE                 */
*            BIT(1)CONSTANT('0'B),                                 0888
*        OPGRAPHC                   /* GRAPHICS DEVICE               */
*            BIT(1)CONSTANT('1'B),                                 0888
*        OPNOGRAC                   /* NOGRAPH                       */
*            BIT(1)CONSTANT('0'B),                                 0888
*        OPUNITRC                   /* UNITR DEVICE                  */
*            BIT(1)CONSTANT('1'B),                                 0888
*        OPNOUNIT                   /* NOUNITR                       */
*            BIT(1)CONSTANT('0'B),                                 0888
*        OPTP                       /* TP DEVICE                     */
*            BIT(1)CONSTANT('1'B),                                 0888
*        OPNOTP                     /* NOTP                          */
*            BIT(1)CONSTANT('0'B),                                 0888
*        OPDASDEV                   /* DASD DEVICE                   */
*            BIT(1)CONSTANT('1'B),                                 0888
*        OPNODAS                    /* NODASD                        */
*            BIT(1)CONSTANT('0'B),                                 0888
*        OPNODEVS                   /* NODEVICE                      */
*            BIT(8)CONSTANT('00000000'B),                          0888
*        OPCRDR                     /* CHRDR DEVICE                  */
*            BIT(1)CONSTANT('1'B),                                 0888
*        OPNOCRDR                   /* NOCHRDR                       */
*            BIT(1)CONSTANT('0'B),                                 0888
*        OPDEFER                    /* REPORT(DEFER)                 */
*            BIT(2)CONSTANT('01'B),                                0888
*        OPREALTM                   /* REPORT(REALTIME)              */
*            BIT(2)CONSTANT('10'B),                                0888
*        OPNOREPT                   /* NOREPORT                      */
*            BIT(2)CONSTANT('00'B),                                0888
*        OPNOSTP                    /* NOSTOP                        */
*            BIT(1)CONSTANT('1'B),                                 0888
*        OPUNTHRS                   /* STOP TIME IN HOURS            */
*            BIT(1)CONSTANT('1'B),                                 0888
*        OPSTP                      /* STOP SPECIFIED                */
*            BIT(1)CONSTANT('0'B),                                 0888
*        OPUNTMIN                   /* STOP TIME IN MINUTES          */
*            BIT(1)CONSTANT('0'B),                                 0888
*        OPTRC                      /* TRACE                         */
*            BIT(1)CONSTANT('1'B),                                 0888
*        OPNOTRC                    /* NOTRACE                       */
*            BIT(1)CONSTANT('0'B),                                 0888
*        OPSUBTAB(38)               /* SUBROUTINE TABLE              */
*            PTR(31)STATIC LOCAL INIT(ADDR(OPCHRDR),ADDR(OPWKLD1),ADDR(
*            OPWKLD2),ADDR(OPWKLD3),ADDR(OPWKLD4),ADDR(OPPAGING),ADDR(
*            OPNOPAG),ADDR(OPCPU),ADDR(OPNOCPU),ADDR(OPCHAN),ADDR( 0888
*            OPNOCHAN),ADDR(OPINTVAL),ADDR(OPNOCHR),ADDR(OPTAPE),ADDR(
*            OPGRAPH),ADDR(OPUNRC),ADDR(OPTPCOM),ADDR(OPDASD),ADDR(
*            OPNOTAPE),ADDR(OPNOGRAP),ADDR(OPNOUNRC),ADDR(OPNOTPCM),
*            ADDR(OPNODASD),ADDR(OPNODEV),ADDR(OPRPRT1),ADDR(OPRPRT2),
*            ADDR(OPNORPT),ADDR(OPNOSTOP),ADDR(OPTRACE),ADDR(OPNOTRCE),
*            ADDR(OPOPI),ADDR(OPNOPI),ADDR(OPSTOP1),ADDR(OPSTOP2),ADDR(
*            OPCYCLE),ADDR(OPERR),ADDR(OPSYSOUT),ADDR(OPMEMBER));  0888
*   GOTO OPSUBTAB(OPSUBCOD)->OPLABEL;/* INITIALIZE THIS OPTION VALUE */
*                                                                  0889
         L     @15,@PC00014                                        0889
         L     @01,OPCODPTR(,@15)                                  0889
         SR    @15,@15                                             0889
         IC    @15,OPSUBCOD(,@01)                                  0889
         SLA   @15,2                                               0889
         L     @01,OPSUBTAB-4(@15)                                 0889
         BR    @01                                                 0889
*   /*****************************************************************/
*   /*                                                               */
*   /* WORKLOAD INITIALIZATION                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0890
*OPWKLD1:                                                          0890
*   ;                               /* SYSTEM INITIALIZATION         */
OPWKLD1  DS    0H                                                  0891
*   IF INMVWKL->INPMCON=OPOPTSET&INMVWKL->INPMWKLD^=OPSYSTEM THEN/*
*                                      MUTUAL EXCLUSIVENESS?         */
         L     @15,INMVWKL                                         0891
         TM    INPMCON(@15),B'10000000'                            0891
         BNZ   @RF00891                                            0891
         TM    INPMWKLD(@15),B'00000001'                           0891
         BNO   @RT00891                                            0891
         TM    INPMWKLD(@15),B'00000010'                           0891
         BZ    @RF00891                                            0891
@RT00891 DS    0H                                                  0892
*     DO;                                                          0892
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                0893
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                0894
*       INCOXINV='1'B;                                             0895
         OI    INCOXINV,B'00000100'                                0895
*     END;                                                         0896
*   INMVWKL->INPMWKLD=OPSYSTEM;     /* WKLD(SYSTEM)                  */
@RF00891 L     @15,INMVWKL                                         0897
         NI    INPMWKLD(@15),B'11111101'                           0897
         OI    INPMWKLD(@15),B'00000001'                           0897
*   INMVWKL->INPMCON=OPOPTSET;      /* OPTION SET                    */
         NI    INPMCON(@15),B'01111111'                            0898
*   RETURN;                                                        0899
@EL00014 DS    0H                                                  0899
@EF00014 DS    0H                                                  0899
@ER00014 LM    @14,@12,@SA00014                                    0899
         BR    @14                                                 0899
*OPWKLD2:                                                          0900
*   ;                               /* GROUP INITIALIZATION          */
OPWKLD2  DS    0H                                                  0901
*   IF INMVWKL->INPMCON=OPOPTSET&INMVWKL->INPMWKLD^=OPGROUP THEN/* 0901
*                                      MUTUAL EXCLUSIVENESS?         */
         L     @15,INMVWKL                                         0901
         TM    INPMCON(@15),B'10000000'                            0901
         BNZ   @RF00901                                            0901
         TM    INPMWKLD(@15),B'00000010'                           0901
         BNO   @RT00901                                            0901
         TM    INPMWKLD(@15),B'00000001'                           0901
         BZ    @RF00901                                            0901
@RT00901 DS    0H                                                  0902
*     DO;                                                          0902
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                0903
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                0904
*       INCOXINV='1'B;                                             0905
         OI    INCOXINV,B'00000100'                                0905
*     END;                                                         0906
*   INMVWKL->INPMWKLD=OPGROUP;      /* WKLD(GROUP)                   */
@RF00901 L     @15,INMVWKL                                         0907
         NI    INPMWKLD(@15),B'11111110'                           0907
         OI    INPMWKLD(@15),B'00000010'                           0907
*   INMVWKL->INPMCON=OPOPTSET;      /* OPTION SET                    */
         NI    INPMCON(@15),B'01111111'                            0908
*   RETURN;                                                        0909
         B     @EL00014                                            0909
*OPWKLD3:                                                          0910
*   ;                               /* PERIOD INITIALIZATION         */
OPWKLD3  DS    0H                                                  0911
*   IF INMVWKL->INPMCON=OPOPTSET&INMVWKL->INPMWKLD^=OPPERIOD THEN/*
*                                      MUTUAL EXCLUSIVENESS?         */
         L     @15,INMVWKL                                         0911
         TM    INPMCON(@15),B'10000000'                            0911
         BNZ   @RF00911                                            0911
         TM    INPMWKLD(@15),B'00000011'                           0911
         BO    @RF00911                                            0911
*     DO;                                                          0912
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                0913
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                0914
*       INCOXINV='1'B;                                             0915
         OI    INCOXINV,B'00000100'                                0915
*     END;                                                         0916
*   INMVWKL->INPMWKLD=OPPERIOD;     /* WKLD(PERIOD)                  */
@RF00911 L     @15,INMVWKL                                         0917
         OI    INPMWKLD(@15),B'00000011'                           0917
*   INMVWKL->INPMCON=OPOPTSET;      /* OPTION SET                    */
         NI    INPMCON(@15),B'01111111'                            0918
*   RETURN;                                                        0919
         B     @EL00014                                            0919
*OPWKLD4:                                                          0920
*   ;                               /* NOWKLD INITIALIZATION         */
OPWKLD4  DS    0H                                                  0921
*   IF INMVWKL->INPMCON=OPOPTSET&INMVWKL->INPMWKLD^=OPNOWKLD THEN/*
*                                      MUTUAL EXCLUSIVENESS?         */
         L     @15,INMVWKL                                         0921
         TM    INPMCON(@15),B'10000000'                            0921
         BNZ   @RF00921                                            0921
         TM    INPMWKLD(@15),B'00000011'                           0921
         BZ    @RF00921                                            0921
*     DO;                                                          0922
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                0923
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                0924
*       INCOXINV='1'B;                                             0925
         OI    INCOXINV,B'00000100'                                0925
*     END;                                                         0926
*   INMVWKL->INPMWKLD=OPNOWKLD;     /* NOWKLD                        */
@RF00921 L     @15,INMVWKL                                         0927
         NI    INPMWKLD(@15),B'11111100'                           0927
*   INMVWKL->INPMCON=OPOPTSET;      /* OPTION SET                    */
         NI    INPMCON(@15),B'01111111'                            0928
*   RETURN;                                                        0929
*                                                                  0929
         B     @EL00014                                            0929
*   /*****************************************************************/
*   /*                                                               */
*   /* PAGING INITIALIZATION                                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0930
*OPPAGING:                                                         0930
*   ;                               /* PAGING INITIALIZATION         */
OPPAGING DS    0H                                                  0931
*   IF INMVPAG->INPMCON=OPOPTSET&INMVPAG->INPMSTA^=OPPAGC THEN/*   0931
*                                      MUTUAL EXCLUSIVENESS?         */
         L     @15,INMVPAG                                         0931
         TM    INPMCON(@15),B'10000000'                            0931
         BNZ   @RF00931                                            0931
         TM    INPMSTA(@15),B'00000001'                            0931
         BO    @RF00931                                            0931
*     DO;                                                          0932
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                0933
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                0934
*       INCOXINV='1'B;                                             0935
         OI    INCOXINV,B'00000100'                                0935
*     END;                                                         0936
*   INMVPAG->INPMSTA=OPPAGC;        /* PAGING                        */
@RF00931 L     @15,INMVPAG                                         0937
         OI    INPMSTA(@15),B'00000001'                            0937
*   INMVPAG->INPMCON=OPOPTSET;      /* OPTION SET                    */
         NI    INPMCON(@15),B'01111111'                            0938
*   RETURN;                                                        0939
         B     @EL00014                                            0939
*OPNOPAG:                                                          0940
*   ;                               /* NO PAGING INITIALIZATION      */
OPNOPAG  DS    0H                                                  0941
*   IF INMVPAG->INPMCON=OPOPTSET&INMVPAG->INPMSTA^=OPNOPAGC THEN   0941
         L     @15,INMVPAG                                         0941
         TM    INPMCON(@15),B'10000000'                            0941
         BNZ   @RF00941                                            0941
         TM    INPMSTA(@15),B'00000001'                            0941
         BZ    @RF00941                                            0941
*     DO;                                                          0942
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                0943
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                0944
*       INCOXINV='1'B;                                             0945
         OI    INCOXINV,B'00000100'                                0945
*     END;                                                         0946
*   INMVPAG->INPMSTA=OPNOPAGC;      /* NOPAGING                      */
@RF00941 L     @15,INMVPAG                                         0947
         NI    INPMSTA(@15),B'11111110'                            0947
*   INMVPAG->INPMCON=OPOPTSET;      /* OPTION SET                    */
         NI    INPMCON(@15),B'01111111'                            0948
*   RETURN;                                                        0949
*                                                                  0949
         B     @EL00014                                            0949
*   /*****************************************************************/
*   /*                                                               */
*   /* CPU INITIALIZATION                                            */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0950
*OPCPU:                                                            0950
*   ;                               /* CPU INIT.                     */
OPCPU    DS    0H                                                  0951
*   IF INMVCPU->INPMCON=OPOPTSET&INMVCPU->INPMSTA^=OPCPUC THEN/*   0951
*                                      MUTUAL EXCLUSIVENESS?         */
         L     @15,INMVCPU                                         0951
         TM    INPMCON(@15),B'10000000'                            0951
         BNZ   @RF00951                                            0951
         TM    INPMSTA(@15),B'00000001'                            0951
         BO    @RF00951                                            0951
*     DO;                                                          0952
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                0953
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                0954
*       INCOXINV='1'B;                                             0955
         OI    INCOXINV,B'00000100'                                0955
*     END;                                                         0956
*   INMVCPU->INPMSTA=OPCPUC;        /* CPU OPTION                    */
@RF00951 L     @15,INMVCPU                                         0957
         OI    INPMSTA(@15),B'00000001'                            0957
*   INMVCPU->INPMCON=OPOPTSET;      /* OPTION SET                    */
         NI    INPMCON(@15),B'01111111'                            0958
*   RETURN;                                                        0959
         B     @EL00014                                            0959
*OPNOCPU:                                                          0960
*   ;                               /* NO CPU INIT.                  */
OPNOCPU  DS    0H                                                  0961
*   IF INMVCPU->INPMCON=OPOPTSET&INMVCPU->INPMSTA^=OPNOCPUC THEN   0961
         L     @15,INMVCPU                                         0961
         TM    INPMCON(@15),B'10000000'                            0961
         BNZ   @RF00961                                            0961
         TM    INPMSTA(@15),B'00000001'                            0961
         BZ    @RF00961                                            0961
*     DO;                                                          0962
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                0963
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                0964
*       INCOXINV='1'B;                                             0965
         OI    INCOXINV,B'00000100'                                0965
*     END;                                                         0966
*   INMVCPU->INPMSTA=OPNOCPUC;      /* NOCPU OPTION                  */
@RF00961 L     @15,INMVCPU                                         0967
         NI    INPMSTA(@15),B'11111110'                            0967
*   INMVCPU->INPMCON=OPOPTSET;      /* OPTION SET                    */
         NI    INPMCON(@15),B'01111111'                            0968
*   RETURN;                                                        0969
*                                                                  0969
         B     @EL00014                                            0969
*   /*****************************************************************/
*   /*                                                               */
*   /* CHANNEL INITIALIZATION                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0970
*OPCHAN:                                                           0970
*   ;                               /* CHAN INITIALIZATION           */
OPCHAN   DS    0H                                                  0971
*   IF INMVCHA->INPMCON=OPOPTSET&INMVCHA->INPMSTA^=OPCHANC THEN/*  0971
*                                      MUTUAL EXCLUSIVENESS?         */
         L     @15,INMVCHA                                         0971
         TM    INPMCON(@15),B'10000000'                            0971
         BNZ   @RF00971                                            0971
         TM    INPMSTA(@15),B'00000001'                            0971
         BO    @RF00971                                            0971
*     DO;                                                          0972
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                0973
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                0974
*       INCOXINV='1'B;                                             0975
         OI    INCOXINV,B'00000100'                                0975
*     END;                                                         0976
*   INMVCHA->INPMSTA=OPCHANC;       /* CHANNEL OPTION                */
@RF00971 L     @15,INMVCHA                                         0977
         OI    INPMSTA(@15),B'00000001'                            0977
*   INMVCHA->INPMCON=OPOPTSET;      /* OPTION SET                    */
         NI    INPMCON(@15),B'01111111'                            0978
*   RETURN;                                                        0979
         B     @EL00014                                            0979
*OPNOCHAN:                                                         0980
*   ;                               /* NOCHANNEL INIT.               */
OPNOCHAN DS    0H                                                  0981
*   IF INMVCHA->INPMCON=OPOPTSET&INMVCHA->INPMSTA^=OPNOCHN THEN/*  0981
*                                      MUTUAL EXCLUSIVENESS?         */
         L     @15,INMVCHA                                         0981
         TM    INPMCON(@15),B'10000000'                            0981
         BNZ   @RF00981                                            0981
         TM    INPMSTA(@15),B'00000001'                            0981
         BZ    @RF00981                                            0981
*     DO;                                                          0982
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                0983
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                0984
*       INCOXINV='1'B;                                             0985
         OI    INCOXINV,B'00000100'                                0985
*     END;                                                         0986
*   INMVCHA->INPMSTA=OPNOCHN;       /* NOCHANNEL OPTION              */
@RF00981 L     @15,INMVCHA                                         0987
         NI    INPMSTA(@15),B'11111110'                            0987
*   INMVCHA->INPMCON=OPOPTSET;      /* OPTION SET                    */
         NI    INPMCON(@15),B'01111111'                            0988
*   RETURN;                                                        0989
*                                                                  0989
         B     @EL00014                                            0989
*   /*****************************************************************/
*   /*                                                               */
*   /* INTERVAL INITIALIZATION                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0990
*OPINTVAL:                                                         0990
*   ;                                                              0990
OPINTVAL DS    0H                                                  0991
*   IF INCOINTC=OPOPTSET&SYPRMV01^=INCOINTV THEN                   0991
         TM    INCOINTC,B'10000000'                                0991
         BNZ   @RF00991                                            0991
         L     @15,SYPRMV01                                        0991
         CH    @15,INCOINTV                                        0991
         BE    @RF00991                                            0991
*     DO;                                                          0992
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                0993
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                0994
*       INCOXINV='1'B;                                             0995
         OI    INCOXINV,B'00000100'                                0995
*     END;                                                         0996
*   INCOINTV=SYPRMV01;                                             0997
@RF00991 L     @15,SYPRMV01                                        0997
         STH   @15,INCOINTV                                        0997
*   INCOINTC=OPOPTSET;                                             0998
         NI    INCOINTC,B'01111111'                                0998
*   IF INCOINTV<OPONEMIN THEN       /* VALUE LESS THAN 1 MIN?        */
         LA    @14,1                                               0999
         CR    @15,@14                                             0999
         BNL   @RF00999                                            0999
*     DO;                                                          1000
*       INCOINTV=OPONEMIN;          /* SET VALUE = 1 MIN             */
         STH   @14,INCOINTV                                        1001
*       INCOOPIV='1'B;              /* REQUEST OPERATOR INTERVENTION */
         OI    INCOOPIV,B'00000001'                                1002
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1003
*       INCOXINV='1'B;                                             1004
         OI    INCOXINV,B'00000100'                                1004
*     END;                                                         1005
*   IF INCOINTV>OP60MIN THEN        /* VALUE GREATER THAN 60 MIN?    */
@RF00999 LA    @15,60                                              1006
         CH    @15,INCOINTV                                        1006
         BNL   @RF01006                                            1006
*     DO;                                                          1007
*       INCOINTV=OP60MIN;           /* SET VALUE = 60 MIN            */
         STH   @15,INCOINTV                                        1008
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1009
*       INCOOPIV='1'B;              /* REQUEST OPERATOR INTERVENTION */
         OI    INCOOPIV,B'00000001'                                1010
*       INCOXINV='1'B;                                             1011
         OI    INCOXINV,B'00000100'                                1011
*     END;                                                         1012
*   RETURN;                                                        1013
*                                                                  1013
         B     @EL00014                                            1013
*   /*****************************************************************/
*   /*                                                               */
*   /* TAPE DEVICE INITIALIZATION                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1014
*OPTAPE:                                                           1014
*   ;                               /* TAPE INIT.                    */
OPTAPE   DS    0H                                                  1015
*   IF INMVDEV->INPMTAPE(OPCNTRL)=OPOPTSET&INMVDEV->INPMTAPE(OPSTATUS)
*       ^=OPTAPDEV THEN             /* MUTUAL EXCLUSIVENESS?         */
         L     @15,INMVDEV                                         1015
         TM    INPMTAPE(@15),B'10000000'                           1015
         BNZ   @RF01015                                            1015
         TM    INPMTAPE+1(@15),B'10000000'                         1015
         BO    @RF01015                                            1015
*     DO;                                                          1016
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1017
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                1018
*       INCOXINV='1'B;                                             1019
         OI    INCOXINV,B'00000100'                                1019
*     END;                                                         1020
*   INMVDEV->INPMTAPE(OPSTATUS)=OPTAPDEV;/* TAPE DEVICE              */
@RF01015 L     @15,INMVDEV                                         1021
         OI    INPMTAPE+1(@15),B'10000000'                         1021
*   INMVDEV->INPMTAPE(OPCNTRL)=OPOPTSET;/* OPTION SET                */
         NI    INPMTAPE(@15),B'01111111'                           1022
*   INMVDEV->INPMCON=OPOPTSET;      /* OPTION SET                    */
         NI    INPMCON(@15),B'01111111'                            1023
*   RETURN;                                                        1024
         B     @EL00014                                            1024
*OPNOTAPE:                                                         1025
*   ;                               /* NO TAPE INIT.                 */
OPNOTAPE DS    0H                                                  1026
*   IF INMVDEV->INPMTAPE(OPCNTRL)=OPOPTSET&INMVDEV->INPMTAPE(OPSTATUS)
*       ^=OPNOTADV THEN             /* MUTUAL EXCLUSIVE?             */
         L     @15,INMVDEV                                         1026
         TM    INPMTAPE(@15),B'10000000'                           1026
         BNZ   @RF01026                                            1026
         TM    INPMTAPE+1(@15),B'10000000'                         1026
         BZ    @RF01026                                            1026
*     DO;                                                          1027
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1028
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                1029
*       INCOXINV='1'B;                                             1030
         OI    INCOXINV,B'00000100'                                1030
*     END;                                                         1031
*   INMVDEV->INPMTAPE(OPSTATUS)=OPNOTADV;/* NOTAPE                   */
@RF01026 L     @15,INMVDEV                                         1032
         NI    INPMTAPE+1(@15),B'01111111'                         1032
*   INMVDEV->INPMTAPE(OPCNTRL)=OPOPTSET;/* OPTION SET                */
         NI    INPMTAPE(@15),B'01111111'                           1033
*   INMVDEV->INPMCON=OPOPTSET;      /* OPTION SET                    */
         NI    INPMCON(@15),B'01111111'                            1034
*   RETURN;                                                        1035
*                                                                  1035
         B     @EL00014                                            1035
*   /*****************************************************************/
*   /*                                                               */
*   /* GRAPHICS DEVICE INITIALIZATION                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1036
*OPGRAPH:                                                          1036
*   ;                               /* GRAPH INIT.                   */
OPGRAPH  DS    0H                                                  1037
*   IF INMVDEV->INPMGRAP(OPCNTRL)=OPOPTSET&INMVDEV->INPMGRAP(OPSTATUS)
*       ^=OPGRAPHC THEN             /* MUTUAL EXCLUSIVE?             */
         L     @15,INMVDEV                                         1037
         TM    INPMGRAP(@15),B'00010000'                           1037
         BNZ   @RF01037                                            1037
         TM    INPMGRAP+1(@15),B'00010000'                         1037
         BO    @RF01037                                            1037
*     DO;                                                          1038
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1039
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                1040
*       INCOXINV='1'B;                                             1041
         OI    INCOXINV,B'00000100'                                1041
*     END;                                                         1042
*   INMVDEV->INPMGRAP(OPSTATUS)=OPGRAPHC;/* GRAPHICS DEVICE          */
@RF01037 L     @15,INMVDEV                                         1043
         OI    INPMGRAP+1(@15),B'00010000'                         1043
*   INMVDEV->INPMGRAP(OPCNTRL)=OPOPTSET;/* OPTION SET                */
         NI    INPMGRAP(@15),B'11101111'                           1044
*   INMVDEV->INPMCON=OPOPTSET;      /* OPTION SET                    */
         NI    INPMCON(@15),B'01111111'                            1045
*   RETURN;                                                        1046
         B     @EL00014                                            1046
*OPNOGRAP:                                                         1047
*   ;                               /* NOGRAPH INIT.                 */
OPNOGRAP DS    0H                                                  1048
*   IF INMVDEV->INPMGRAP(OPCNTRL)=OPOPTSET&INMVDEV->INPMGRAP(OPSTATUS)
*       ^=OPNOGRAC THEN             /* MUTUAL EXCLUSIVE?             */
         L     @15,INMVDEV                                         1048
         TM    INPMGRAP(@15),B'00010000'                           1048
         BNZ   @RF01048                                            1048
         TM    INPMGRAP+1(@15),B'00010000'                         1048
         BZ    @RF01048                                            1048
*     DO;                                                          1049
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1050
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                1051
*       INCOXINV='1'B;                                             1052
         OI    INCOXINV,B'00000100'                                1052
*     END;                                                         1053
*   INMVDEV->INPMGRAP(OPSTATUS)=OPNOGRAC;/* NOGRAPH                  */
@RF01048 L     @15,INMVDEV                                         1054
         NI    INPMGRAP+1(@15),B'11101111'                         1054
*   INMVDEV->INPMGRAP(OPCNTRL)=OPOPTSET;/* OPTION SET                */
         NI    INPMGRAP(@15),B'11101111'                           1055
*   INMVDEV->INPMCON=OPOPTSET;      /* OPTION SET                    */
         NI    INPMCON(@15),B'01111111'                            1056
*   RETURN;                                                        1057
*                                                                  1057
         B     @EL00014                                            1057
*   /*****************************************************************/
*   /*                                                               */
*   /* UNIT RECORD DEVICE INITIALIZATION                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1058
*OPUNRC:                                                           1058
*   ;                               /* UNITR INIT.                   */
OPUNRC   DS    0H                                                  1059
*   IF INMVDEV->INPMUNIT(OPCNTRL)=OPOPTSET&INMVDEV->INPMUNIT(OPSTATUS)
*       ^=OPUNITRC THEN             /* MUTUAL EXCLUSIVE?             */
         L     @15,INMVDEV                                         1059
         TM    INPMUNIT(@15),B'00001000'                           1059
         BNZ   @RF01059                                            1059
         TM    INPMUNIT+1(@15),B'00001000'                         1059
         BO    @RF01059                                            1059
*     DO;                                                          1060
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1061
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                1062
*       INCOXINV='1'B;                                             1063
         OI    INCOXINV,B'00000100'                                1063
*     END;                                                         1064
*   INMVDEV->INPMUNIT(OPSTATUS)=OPUNITRC;/* UNIT RECORD DEVICE       */
@RF01059 L     @15,INMVDEV                                         1065
         OI    INPMUNIT+1(@15),B'00001000'                         1065
*   INMVDEV->INPMUNIT(OPCNTRL)=OPOPTSET;/* OPTION SET                */
         NI    INPMUNIT(@15),B'11110111'                           1066
*   INMVDEV->INPMCON=OPOPTSET;      /* OPTION SET                    */
         NI    INPMCON(@15),B'01111111'                            1067
*   RETURN;                                                        1068
         B     @EL00014                                            1068
*OPNOUNRC:                                                         1069
*   ;                               /* NOUNITR INIT.                 */
OPNOUNRC DS    0H                                                  1070
*   IF INMVDEV->INPMUNIT(OPCNTRL)=OPOPTSET&INMVDEV->INPMUNIT(OPSTATUS)
*       ^=OPNOUNIT THEN             /* MUTUAL EXCLUSIVE?             */
         L     @15,INMVDEV                                         1070
         TM    INPMUNIT(@15),B'00001000'                           1070
         BNZ   @RF01070                                            1070
         TM    INPMUNIT+1(@15),B'00001000'                         1070
         BZ    @RF01070                                            1070
*     DO;                                                          1071
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1072
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                1073
*       INCOXINV='1'B;                                             1074
         OI    INCOXINV,B'00000100'                                1074
*     END;                                                         1075
*   INMVDEV->INPMUNIT(OPSTATUS)=OPNOUNIT;/* NOUNITR                  */
@RF01070 L     @15,INMVDEV                                         1076
         NI    INPMUNIT+1(@15),B'11110111'                         1076
*   INMVDEV->INPMUNIT(OPCNTRL)=OPOPTSET;/* OPTION SET                */
         NI    INPMUNIT(@15),B'11110111'                           1077
*   INMVDEV->INPMCON=OPOPTSET;      /* OPTION SET                    */
         NI    INPMCON(@15),B'01111111'                            1078
*   RETURN;                                                        1079
*                                                                  1079
         B     @EL00014                                            1079
*   /*****************************************************************/
*   /*                                                               */
*   /* TELEPROCESSING COMMUNICATIONS DEVICE INITIALIZATION           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1080
*OPTPCOM:                                                          1080
*   ;                               /* COM INIT.                     */
OPTPCOM  DS    0H                                                  1081
*   IF INMVDEV->INPMTP(OPCNTRL)=OPOPTSET&INMVDEV->INPMTP(OPSTATUS)^=
*       OPTP THEN                   /* MUTUAL EXCLUSIVE?             */
         L     @15,INMVDEV                                         1081
         TM    INPMTP(@15),B'01000000'                             1081
         BNZ   @RF01081                                            1081
         TM    INPMTP+1(@15),B'01000000'                           1081
         BO    @RF01081                                            1081
*     DO;                                                          1082
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1083
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                1084
*       INCOXINV='1'B;                                             1085
         OI    INCOXINV,B'00000100'                                1085
*     END;                                                         1086
*   INMVDEV->INPMTP(OPSTATUS)=OPTP; /* TP DEVICE                     */
@RF01081 L     @15,INMVDEV                                         1087
         OI    INPMTP+1(@15),B'01000000'                           1087
*   INMVDEV->INPMTP(OPCNTRL)=OPOPTSET;/* OPTION SET                  */
         NI    INPMTP(@15),B'10111111'                             1088
*   INMVDEV->INPMCON=OPOPTSET;      /* OPTION SET                    */
         NI    INPMCON(@15),B'01111111'                            1089
*   RETURN;                                                        1090
         B     @EL00014                                            1090
*OPNOTPCM:                                                         1091
*   ;                               /* NOCOM INIT.                   */
OPNOTPCM DS    0H                                                  1092
*   IF INMVDEV->INPMTP(OPCNTRL)=OPOPTSET&INMVDEV->INPMTP(OPSTATUS)^=
*       OPNOTP THEN                 /* MUTUAL EXCLUSIVE?             */
         L     @15,INMVDEV                                         1092
         TM    INPMTP(@15),B'01000000'                             1092
         BNZ   @RF01092                                            1092
         TM    INPMTP+1(@15),B'01000000'                           1092
         BZ    @RF01092                                            1092
*     DO;                                                          1093
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1094
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                1095
*       INCOXINV='1'B;                                             1096
         OI    INCOXINV,B'00000100'                                1096
*     END;                                                         1097
*   INMVDEV->INPMTP(OPSTATUS)=OPNOTP;/* NOTP                         */
@RF01092 L     @15,INMVDEV                                         1098
         NI    INPMTP+1(@15),B'10111111'                           1098
*   INMVDEV->INPMTP(OPCNTRL)=OPOPTSET;/* OPTION SET                  */
         NI    INPMTP(@15),B'10111111'                             1099
*   INMVDEV->INPMCON=OPOPTSET;      /* OPTION SET                    */
         NI    INPMCON(@15),B'01111111'                            1100
*   RETURN;                                                        1101
*                                                                  1101
         B     @EL00014                                            1101
*   /*****************************************************************/
*   /*                                                               */
*   /* DASD DEVICE INITIALIZATION                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1102
*OPDASD:                                                           1102
*   ;                                                              1102
OPDASD   DS    0H                                                  1103
*   IF INMVDEV->INPMDA(OPCNTRL)=OPOPTSET&INMVDEV->INPMDA(OPSTATUS)^=
*       OPDASDEV THEN               /* MUTUAL EXCLUSIVE?             */
         L     @15,INMVDEV                                         1103
         TM    INPMDA(@15),B'00100000'                             1103
         BNZ   @RF01103                                            1103
         TM    INPMDA+1(@15),B'00100000'                           1103
         BO    @RF01103                                            1103
*     DO;                                                          1104
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1105
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                1106
*       INCOXINV='1'B;                                             1107
         OI    INCOXINV,B'00000100'                                1107
*     END;                                                         1108
*   INMVDEV->INPMDA(OPSTATUS)=OPDASDEV;/* DASD DEVICE                */
@RF01103 L     @15,INMVDEV                                         1109
         OI    INPMDA+1(@15),B'00100000'                           1109
*   INMVDEV->INPMDA(OPCNTRL)=OPOPTSET;/* OPTION SET                  */
         NI    INPMDA(@15),B'11011111'                             1110
*   INMVDEV->INPMCON=OPOPTSET;      /* OPTION SET                    */
         NI    INPMCON(@15),B'01111111'                            1111
*   RETURN;                                                        1112
         B     @EL00014                                            1112
*OPNODASD:                                                         1113
*   ;                               /* NODASD INIT.                  */
OPNODASD DS    0H                                                  1114
*   IF INMVDEV->INPMDA(OPCNTRL)=OPOPTSET&INMVDEV->INPMDA(OPSTATUS)^=
*       OPNODAS THEN                /* MUTUAL EXCLUSIVE?             */
         L     @15,INMVDEV                                         1114
         TM    INPMDA(@15),B'00100000'                             1114
         BNZ   @RF01114                                            1114
         TM    INPMDA+1(@15),B'00100000'                           1114
         BZ    @RF01114                                            1114
*     DO;                                                          1115
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1116
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                1117
*       INCOXINV='1'B;                                             1118
         OI    INCOXINV,B'00000100'                                1118
*     END;                                                         1119
*   INMVDEV->INPMDA(OPSTATUS)=OPNODAS;/* NODASD                      */
@RF01114 L     @15,INMVDEV                                         1120
         NI    INPMDA+1(@15),B'11011111'                           1120
*   INMVDEV->INPMDA(OPCNTRL)=OPOPTSET;/* OPTION SET                  */
         NI    INPMDA(@15),B'11011111'                             1121
*   INMVDEV->INPMCON=OPOPTSET;      /* OPTION SET                    */
         NI    INPMCON(@15),B'01111111'                            1122
*   RETURN;                                                        1123
*                                                                  1123
         B     @EL00014                                            1123
*   /*****************************************************************/
*   /*                                                               */
*   /* NODEVICE INITIALIZATION                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1124
*OPNODEV:                                                          1124
*   ;                                                              1124
OPNODEV  DS    0H                                                  1125
*   IF INMVDEV->INPMDEVF(OPSTATUS)^=OPNODEVS THEN/* MUTUAL         1125
*                                      EXCLUSIVENESS?                */
         L     @01,INMVDEV                                         1125
         CLI   INPMDEVF+1(@01),B'00000000'                         1125
         BE    @RF01125                                            1125
*     DO;                                                          1126
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1127
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                1128
*       INCOXINV='1'B;                                             1129
         OI    INCOXINV,B'00000100'                                1129
*     END;                                                         1130
*   INMVDEV->INPMDEVF(OPSTATUS)=OPNODEVS;/* NODEVICE                 */
@RF01125 L     @15,INMVDEV                                         1131
         MVI   INPMDEVF+1(@15),B'00000000'                         1131
*   INMVDEV->INPMDEVF(OPCNTRL)=OPOPTSET;/* OPTION SET                */
         MVI   INPMDEVF(@15),B'00000000'                           1132
*   INMVDEV->INPMCON=OPOPTSET;      /* OPTION SET                    */
         NI    INPMCON(@15),B'01111111'                            1133
*   RETURN;                                                        1134
*                                                                  1134
         B     @EL00014                                            1134
*   /*****************************************************************/
*   /*                                                               */
*   /* CHARACTER READER DEVICE INITIALIZATION                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1135
*OPCHRDR:                                                          1135
*   ;                               /* CHRDR INIT.                   */
OPCHRDR  DS    0H                                                  1136
*   IF INMVDEV->INPMCRDR(OPCNTRL)=OPOPTSET&INMVDEV->INPMCRDR(OPSTATUS)
*       ^=OPCRDR THEN               /* MUTUAL EXCLUSIVE?             */
         L     @15,INMVDEV                                         1136
         TM    INPMCRDR(@15),B'00000100'                           1136
         BNZ   @RF01136                                            1136
         TM    INPMCRDR+1(@15),B'00000100'                         1136
         BO    @RF01136                                            1136
*     DO;                                                          1137
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1138
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                1139
*       INCOXINV='1'B;                                             1140
         OI    INCOXINV,B'00000100'                                1140
*     END;                                                         1141
*   INMVDEV->INPMCRDR(OPSTATUS)=OPCRDR;/* CHRDR DEVICE               */
@RF01136 L     @15,INMVDEV                                         1142
         OI    INPMCRDR+1(@15),B'00000100'                         1142
*   INMVDEV->INPMCRDR(OPCNTRL)=OPOPTSET;/* OPTION SET                */
         NI    INPMCRDR(@15),B'11111011'                           1143
*   INMVDEV->INPMCON=OPOPTSET;      /* OPTION SET                    */
         NI    INPMCON(@15),B'01111111'                            1144
*   RETURN;                                                        1145
         B     @EL00014                                            1145
*OPNOCHR:                                                          1146
*   ;                                                              1146
OPNOCHR  DS    0H                                                  1147
*   IF INMVDEV->INPMCRDR(OPCNTRL)=OPOPTSET&INMVDEV->INPMCRDR(OPSTATUS)
*       ^=OPNOCRDR THEN             /* MUTUAL EXCLUSIVE?             */
         L     @15,INMVDEV                                         1147
         TM    INPMCRDR(@15),B'00000100'                           1147
         BNZ   @RF01147                                            1147
         TM    INPMCRDR+1(@15),B'00000100'                         1147
         BZ    @RF01147                                            1147
*     DO;                                                          1148
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1149
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                1150
*       INCOXINV='1'B;                                             1151
         OI    INCOXINV,B'00000100'                                1151
*     END;                                                         1152
*   INMVDEV->INPMCRDR(OPSTATUS)=OPNOCRDR;/* NOCHRDR                  */
@RF01147 L     @15,INMVDEV                                         1153
         NI    INPMCRDR+1(@15),B'11111011'                         1153
*   INMVDEV->INPMCRDR(OPCNTRL)=OPOPTSET;/* OPTION SET                */
         NI    INPMCRDR(@15),B'11111011'                           1154
*   INMVDEV->INPMCON=OPOPTSET;      /* OPTION SET                    */
         NI    INPMCON(@15),B'01111111'                            1155
*   RETURN;                                                        1156
*                                                                  1156
         B     @EL00014                                            1156
*   /*****************************************************************/
*   /*                                                               */
*   /* REPORT OPTION INITIALIZATION                                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1157
*OPRPRT1:                                                          1157
*   ;                               /* DEFER INIT.                   */
OPRPRT1  DS    0H                                                  1158
*   IF INCOREPC=OPOPTSET&INCOREPV^=OPDEFER THEN/* MUTUAL EXCLUSIVE?  */
         TM    INCOREPC,B'10000000'                                1158
         BNZ   @RF01158                                            1158
         TM    INCOREPV,B'00000001'                                1158
         BNO   @RT01158                                            1158
         TM    INCOREPV,B'00000010'                                1158
         BZ    @RF01158                                            1158
@RT01158 DS    0H                                                  1159
*     DO;                                                          1159
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1160
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                1161
*       INCOXINV='1'B;                                             1162
         OI    INCOXINV,B'00000100'                                1162
*     END;                                                         1163
*   INCOREPV=OPDEFER;               /* REPORT(DEFER)                 */
@RF01158 NI    INCOREPV,B'11111101'                                1164
         OI    INCOREPV,B'00000001'                                1164
*   INCOREPC=OPOPTSET;              /* OPTION SET                    */
         NI    INCOREPC,B'01111111'                                1165
*   RETURN;                                                        1166
         B     @EL00014                                            1166
*OPRPRT2:                                                          1167
*   ;                               /* REALTIME INIT.                */
OPRPRT2  DS    0H                                                  1168
*   IF INCOREPC=OPOPTSET&INCOREPV^=OPREALTM THEN/* MUTUAL EXCLUSIVE? */
         TM    INCOREPC,B'10000000'                                1168
         BNZ   @RF01168                                            1168
         TM    INCOREPV,B'00000010'                                1168
         BNO   @RT01168                                            1168
         TM    INCOREPV,B'00000001'                                1168
         BZ    @RF01168                                            1168
@RT01168 DS    0H                                                  1169
*     DO;                                                          1169
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1170
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                1171
*       INCOXINV='1'B;                                             1172
         OI    INCOXINV,B'00000100'                                1172
*     END;                                                         1173
*   INCOREPV=OPREALTM;              /* REPORT(REALTIME)              */
@RF01168 NI    INCOREPV,B'11111110'                                1174
         OI    INCOREPV,B'00000010'                                1174
*   INCOREPC=OPOPTSET;              /* OPTION SET                    */
         NI    INCOREPC,B'01111111'                                1175
*   RETURN;                                                        1176
         B     @EL00014                                            1176
*OPNORPT:                                                          1177
*   ;                               /* NOREPORT INIT.                */
OPNORPT  DS    0H                                                  1178
*   IF INCOREPC=OPOPTSET&INCOREPV^=OPNOREPT THEN/* MUTUAL EXCLUSIVE? */
         TM    INCOREPC,B'10000000'                                1178
         BNZ   @RF01178                                            1178
         TM    INCOREPV,B'00000011'                                1178
         BZ    @RF01178                                            1178
*     DO;                                                          1179
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1180
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                1181
*       INCOXINV='1'B;                                             1182
         OI    INCOXINV,B'00000100'                                1182
*     END;                                                         1183
*   INCOREPV=OPNOREPT;              /* NOREPORT                      */
@RF01178 NI    INCOREPV,B'11111100'                                1184
*   INCOREPC=OPOPTSET;              /* OPTION SET                    */
         NI    INCOREPC,B'01111111'                                1185
*   RETURN;                                                        1186
*                                                                  1186
         B     @EL00014                                            1186
*   /*****************************************************************/
*   /*                                                               */
*   /* STOP OPTION INITIALIZATION. AN INVALID VALUE OR MUTUAL        */
*   /* EXCLUSIVE ERROR EXISTS FOR THE STOP OPTION IN MINUTES OR HOURS*/
*   /* IN THE FOLLOWING TWO WAYS: 1)IF STOP WAS PREVIOUSLY SPECIFIED */
*   /* IN THE SAME SOURCE AND THE TIME SPECIFIED WAS IN MINUTES OR   */
*   /* HOURS AND A DIFFERENT VALUE (TIME) IS REQUESTED. 2) THE STOP  */
*   /* OPTION WAS PREVIOUSLY SPECIFIED IN THE SAME SOURCE AND THE    */
*   /* PREVIOUS REQUEST WAS FOR 'NOSTOP'                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1187
*OPNOSTOP:                                                         1187
*   ;                               /* NOSTOP INIT.                  */
OPNOSTOP DS    0H                                                  1188
*   IF INCOSTPC=OPOPTSET&INCOSTPS^=OPNOSTP THEN/* MUTUAL EXCLUSIVE?  */
         TM    INCOSTPC,B'11000000'                                1188
         BNZ   @RF01188                                            1188
*     DO;                                                          1189
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1190
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                1191
*       INCOXINV='1'B;                                             1192
         OI    INCOXINV,B'00000100'                                1192
*     END;                                                         1193
*   INCOSTPS=OPNOSTP;               /* NOSTOP                        */
@RF01188 DS    0H                                                  1195
*   INCOSTPC=OPOPTSET;              /* OPTION SET                    */
         OI    INCOSTPS,B'01000000'                                1195
         NI    INCOSTPC,B'01111111'                                1195
*   RETURN;                                                        1196
         B     @EL00014                                            1196
*OPSTOP1:                                                          1197
*   ;                               /* STOP H INIT.                  */
OPSTOP1  DS    0H                                                  1198
*   IF INCOSTPC=OPOPTSET&(          /* IF PREVIOUSLY SPECIFIED AND   */
*       (INCOSTPU=OPUNTHRS&INCOSTPV^=SYPRMV01)|/* NOT SAME # HRS OR  */
*       (INCOSTPU^=OPUNTHRS&INCOSTPV^=SYPRMV01*60)|/* NOT EQUIV #  1198
*                                      MIN. OR                       */
*       INCOSTPS=OPNOSTP)THEN       /* NOSTOP                        */
         TM    INCOSTPC,B'10000000'                                1198
         BNZ   @RF01198                                            1198
         TM    INCOSTPU,B'00100000'                                1198
         BNO   @GL00048                                            1198
         LH    @15,INCOSTPV                                        1198
         C     @15,SYPRMV01                                        1198
         BNE   @RT01198                                            1198
@GL00048 TM    INCOSTPU,B'00100000'                                1198
         BO    @GL00047                                            1198
         L     @15,SYPRMV01                                        1198
         MH    @15,@CH00529                                        1198
         CH    @15,INCOSTPV                                        1198
         BNE   @RT01198                                            1198
@GL00047 TM    INCOSTPS,B'01000000'                                1198
         BNO   @RF01198                                            1198
@RT01198 DS    0H                                                  1199
*     DO;                                                          1199
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1200
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                1201
*       INCOXINV='1'B;                                             1202
         OI    INCOXINV,B'00000100'                                1202
*     END;                                                         1203
*   IF SYPRMV01>OPMAXVAL THEN       /* VALUE TOO LARGE?              */
@RF01198 L     @15,OPMAXVAL                                        1204
         C     @15,SYPRMV01                                        1204
         BNL   @RF01204                                            1204
*     DO;                                                          1205
*       SYPRMV01=OPMAXVAL;          /* SET TO MAXIMUM VALUE          */
         ST    @15,SYPRMV01                                        1206
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1207
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                1208
*       INCOXINV='1'B;                                             1209
         OI    INCOXINV,B'00000100'                                1209
*     END;                                                         1210
*   IF SYPRMV01<1 THEN              /* VALUE BELOW MINIMUM?          */
@RF01204 LA    @15,1                                               1211
         C     @15,SYPRMV01                                        1211
         BNH   @RF01211                                            1211
*     DO;                                                          1212
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1213
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                1214
*       INCOXINV='1'B;                                             1215
         OI    INCOXINV,B'00000100'                                1215
*       SYPRMV01=1;                 /* SET TO MINUMUM                */
         ST    @15,SYPRMV01                                        1216
*     END;                                                         1217
*   INCOSTPS=OPSTP;                 /* STOP SPECIFIED                */
@RF01211 DS    0H                                                  1219
*   INCOSTPU=OPUNTHRS;              /* TIME IN HOURS                 */
*   INCOSTPC=OPOPTSET;              /* OPTION SET                    */
         OI    INCOSTPU,B'00100000'                                1220
         NI    INCOSTPS,B'00111111'                                1220
*   INCOSTPV=SYPRMV01;              /* MOVE IN VALUE                 */
         MVC   INCOSTPV(2),SYPRMV01+2                              1221
*   RETURN;                                                        1222
         B     @EL00014                                            1222
*OPSTOP2:                                                          1223
*   ;                               /* STOP M INIT.                  */
OPSTOP2  DS    0H                                                  1224
*   IF INCOSTPC=OPOPTSET&(          /* IF PREVIOUSLY SPECIFIED AND   */
*       (INCOSTPU=OPUNTMIN&INCOSTPV^=SYPRMV01)|/* NOT SAME # MIN. OR */
*       (INCOSTPU^=OPUNTMIN&INCOSTPV/60^=SYPRMV01&INCOSTPV//60^=0)|/*
*                                      NOT EQUIV. # HRS. OR          */
*       INCOSTPS=OPNOSTP)THEN       /* NOSTOP                        */
         TM    INCOSTPC,B'10000000'                                1224
         BNZ   @RF01224                                            1224
         TM    INCOSTPU,B'00100000'                                1224
         BNZ   @GL00053                                            1224
         LH    @15,INCOSTPV                                        1224
         C     @15,SYPRMV01                                        1224
         BNE   @RT01224                                            1224
@GL00053 TM    INCOSTPU,B'00100000'                                1224
         BZ    @GL00052                                            1224
         LH    @15,INCOSTPV                                        1224
         LA    @14,60                                              1224
         LR    @00,@15                                             1224
         SRDA  @00,32                                              1224
         DR    @00,@14                                             1224
         C     @01,SYPRMV01                                        1224
         BE    @GL00052                                            1224
         LR    @00,@15                                             1224
         SRDA  @00,32                                              1224
         DR    @00,@14                                             1224
         LTR   @00,@00                                             1224
         BNZ   @RT01224                                            1224
@GL00052 TM    INCOSTPS,B'01000000'                                1224
         BNO   @RF01224                                            1224
@RT01224 DS    0H                                                  1225
*     DO;                                                          1225
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1226
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                1227
*       INCOXINV='1'B;                                             1228
         OI    INCOXINV,B'00000100'                                1228
*     END;                                                         1229
*   IF SYPRMV01>OPMAXVAL*60 THEN    /* VALUE TOO LARGE?              */
@RF01224 L     @15,OPMAXVAL                                        1230
         MH    @15,@CH00529                                        1230
         C     @15,SYPRMV01                                        1230
         BNL   @RF01230                                            1230
*     DO;                                                          1231
*       SYPRMV01=OPMAXVAL*60;       /* SET TO MAXIMUM VALUE          */
         ST    @15,SYPRMV01                                        1232
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1233
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                1234
*       INCOXINV='1'B;                                             1235
         OI    INCOXINV,B'00000100'                                1235
*     END;                                                         1236
*   IF SYPRMV01<1 THEN              /* VALUE BELOW MINIMUM?          */
@RF01230 LA    @15,1                                               1237
         C     @15,SYPRMV01                                        1237
         BNH   @RF01237                                            1237
*     DO;                                                          1238
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1239
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                1240
*       INCOXINV='1'B;                                             1241
         OI    INCOXINV,B'00000100'                                1241
*       SYPRMV01=1;                 /* SET TO MINIMUM                */
         ST    @15,SYPRMV01                                        1242
*     END;                                                         1243
*   INCOSTPS=OPSTP;                 /* STOP SPECIFIED                */
@RF01237 DS    0H                                                  1245
*   INCOSTPU=OPUNTMIN;              /* STOP TIME IN MINUTES          */
*   INCOSTPC=OPOPTSET;              /* OPTION SET                    */
         NI    INCOSTPS,B'00011111'                                1246
*   INCOSTPV=SYPRMV01;              /* MOVE IN VALUE                 */
         MVC   INCOSTPV(2),SYPRMV01+2                              1247
*   RETURN;                                                        1248
*                                                                  1248
         B     @EL00014                                            1248
*   /*****************************************************************/
*   /*                                                               */
*   /* TRACE OPTION INITIALIZATION                                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1249
*OPTRACE:                                                          1249
*   ;                               /* TRACE INIT.                   */
OPTRACE  DS    0H                                                  1250
*   IF INCOTCEC=OPOPTSET&INCOTCEV^=OPTRC THEN/* MUTUAL EXCLUSIVENESS?*/
         TM    INCOTCEC,B'10000000'                                1250
         BNZ   @RF01250                                            1250
         TM    INCOTCEV,B'00000001'                                1250
         BO    @RF01250                                            1250
*     DO;                                                          1251
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1252
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                1253
*       INCOXINV='1'B;                                             1254
         OI    INCOXINV,B'00000100'                                1254
*     END;                                                         1255
*   INCOTCEV=OPTRC;                 /* TRACE                         */
@RF01250 OI    INCOTCEV,B'00000001'                                1256
*   INCOTCEC=OPOPTSET;              /* OPTION SPECIFIED              */
         NI    INCOTCEC,B'01111111'                                1257
*   RETURN;                                                        1258
         B     @EL00014                                            1258
*OPNOTRCE:                                                         1259
*   ;                               /* NOTRACE INIT.                 */
OPNOTRCE DS    0H                                                  1260
*   IF INCOTCEC=OPOPTSET&INCOTCEV^=OPNOTRC THEN/* MUTUAL           1260
*                                      EXCLUSIVENESS?                */
         TM    INCOTCEC,B'10000000'                                1260
         BNZ   @RF01260                                            1260
         TM    INCOTCEV,B'00000001'                                1260
         BZ    @RF01260                                            1260
*     DO;                                                          1261
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1262
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                1263
*       INCOXINV='1'B;                                             1264
         OI    INCOXINV,B'00000100'                                1264
*     END;                                                         1265
*   INCOTCEV=OPNOTRC;               /* NOTRACE                       */
@RF01260 NI    INCOTCEV,B'11111110'                                1266
*   INCOTCEC=OPOPTSET;              /* OPTION SPECIFIED              */
         NI    INCOTCEC,B'01111111'                                1267
*   RETURN;                                                        1268
*                                                                  1268
         B     @EL00014                                            1268
*   /*****************************************************************/
*   /*                                                               */
*   /* OPERATOR INTERVENTION (OPI) INITIALIZATION                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1269
*OPOPI:                                                            1269
*   ;                               /* OPI INIT.                     */
OPOPI    DS    0H                                                  1270
*   IF INCOOPIC=OPOPTSET&INCOOPIV^='1'B THEN/* MUTUAL EXCLUSIVENESS? */
         TM    INCOOPIC,B'10000000'                                1270
         BNZ   @RF01270                                            1270
         TM    INCOOPIV,B'00000001'                                1270
         BO    @RF01270                                            1270
*     INCOXINV='1'B;                /* OPERATOR INTERVENTION         */
         OI    INCOXINV,B'00000100'                                1271
*   INCOOPIC=OPOPTSET;              /* OPTION SET                    */
@RF01270 NI    INCOOPIC,B'01111111'                                1272
*   INCOOPIV='1'B;                                                 1273
         OI    INCOOPIV,B'00000001'                                1273
*   RETURN;                                                        1274
         B     @EL00014                                            1274
*OPNOPI:                                                           1275
*   ;                               /* NOOPI INIT.                   */
OPNOPI   DS    0H                                                  1276
*   IF INCOOPIC=OPOPTSET&INCOOPIV^='0'B THEN/* MUTUAL EXCLUSIVENESS? */
         TM    INCOOPIC,B'10000000'                                1276
         BNZ   @RF01276                                            1276
         TM    INCOOPIV,B'00000001'                                1276
         BZ    @RF01276                                            1276
*     INCOXINV='1'B;                                               1277
         OI    INCOXINV,B'00000100'                                1277
*   ELSE                                                           1278
*     DO;                                                          1278
         B     @RC01276                                            1278
@RF01276 DS    0H                                                  1279
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1279
*       INCOOPIV='0'B;              /* NO OPERATOR INTERVENTION      */
         NI    INCOOPIV,B'11111110'                                1280
*     END;                                                         1281
*   RETURN;                                                        1282
*                                                                  1282
         B     @EL00014                                            1282
*   /*****************************************************************/
*   /*                                                               */
*   /* CYCLE OPTION INITIALIZATION                                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1283
*OPCYCLE:                                                          1283
*   ;                               /* CYCLE INIT.                   */
OPCYCLE  DS    0H                                                  1284
*   IF INCOCYCC=OPOPTSET&INCOCYCV^=SYPRMV01 THEN/* DIFFERENT VALUE?  */
         TM    INCOCYCC,B'10000000'                                1284
         BNZ   @RF01284                                            1284
         LH    @15,INCOCYCV                                        1284
         C     @15,SYPRMV01                                        1284
         BE    @RF01284                                            1284
*     DO;                                                          1285
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1286
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                1287
*       INCOXINV='1'B;                                             1288
         OI    INCOXINV,B'00000100'                                1288
*     END;                                                         1289
*   IF SYPRMV01>OP999MS THEN        /* VALUE TOO LARGE?              */
@RF01284 LA    @15,999                                             1290
         C     @15,SYPRMV01                                        1290
         BNL   @RF01290                                            1290
*     DO;                                                          1291
*       SYPRMV01=OP999MS;           /* SET TO MAXIMUM                */
         ST    @15,SYPRMV01                                        1292
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1293
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                1294
*       INCOXINV='1'B;                                             1295
         OI    INCOXINV,B'00000100'                                1295
*     END;                                                         1296
*   IF SYPRMV01<OP50MS THEN         /* BELOW MINIMUM?                */
@RF01290 LA    @15,50                                              1297
         C     @15,SYPRMV01                                        1297
         BNH   @RF01297                                            1297
*     DO;                                                          1298
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1299
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                1300
*       INCOXINV='1'B;                                             1301
         OI    INCOXINV,B'00000100'                                1301
*       SYPRMV01=OP50MS;            /* SET TO MINIMUM                */
         ST    @15,SYPRMV01                                        1302
*     END;                                                         1303
*   INCOCYCV=SYPRMV01;              /* MOVE IN CYCLE VALUE           */
@RF01297 MVC   INCOCYCV(2),SYPRMV01+2                              1304
*   INCOCYCC=OPOPTSET;              /* OPTION SET                    */
         NI    INCOCYCC,B'01111111'                                1305
*   RETURN;                                                        1306
*                                                                  1306
         B     @EL00014                                            1306
*   /*****************************************************************/
*   /*                                                               */
*   /* ERROR INITIALIZATION                                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1307
*OPERR:                                                            1307
*   ;                                                              1307
OPERR    DS    0H                                                  1308
*   IF INCOXSYN='0'B THEN           /* FIRST ERROR FOUND?            */
         TM    INCOXSYN,B'00000010'                                1308
         BNZ   @RF01308                                            1308
*     DO;                                                          1309
*       INCOXER1=INCOXER2;          /* NO, MOVE IN 1ST 4 ERROR-CHAR. */
         MVC   INCOXER1(10),INCOXER2                               1310
*       INCOXSYN='1'B;                                             1311
         OI    INCOXSYN,B'00000010'                                1311
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1312
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                1313
*     END;                                                         1314
*   RETURN;                                                        1315
*                                                                  1315
         B     @EL00014                                            1315
*   /*****************************************************************/
*   /*                                                               */
*   /* SYSOUT CLASS INITIALIZATION                                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1316
*OPSYSOUT:                                                         1316
*   ;                                                              1316
OPSYSOUT DS    0H                                                  1317
*   IF INCOOUTC=OPOPTSET&SYPRMA01^=INCOOUTV THEN/* DIFFERENT VALUE?  */
         TM    INCOOUTC,B'10000000'                                1317
         BNZ   @RF01317                                            1317
         CLC   SYPRMA01(1),INCOOUTV                                1317
         BE    @RF01317                                            1317
*     DO;                                                          1318
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1319
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                1320
*       INCOXINV='1'B;                                             1321
         OI    INCOXINV,B'00000100'                                1321
*     END;                                                         1322
*   INCOOUTV=SYPRMA01;              /* MOVE IN SYSOUT CLASS VALUE    */
@RF01317 MVC   INCOOUTV(1),SYPRMA01                                1323
*   INCOOUTC=OPOPTSET;              /* OPTION SET                    */
         NI    INCOOUTC,B'01111111'                                1324
*   RETURN;                                                        1325
*                                                                  1325
         B     @EL00014                                            1325
*   /*****************************************************************/
*   /*                                                               */
*   /* LIBRARY MEMBER INITIALIZATION                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1326
*OPMEMBER:                                                         1326
*   ;                                                              1326
OPMEMBER DS    0H                                                  1327
*   INMODULE='IRBMFCNV';            /* MODULE TO BE LOADED           */
         MVC   INMODULE(8),@CC01283                                1327
*   RFY                                                            1328
*    (GPR00P,                                                      1328
*     GPR01P,                                                      1328
*     GPR14P,                                                      1328
*     GPR15P)RSTD;                                                 1328
*   GEN(LOAD EPLOC=INMODULE);                                      1329
         LOAD EPLOC=INMODULE
*   OPCNVADR=GPR00P;                /* SAVE ENTRY POINT ADDRESS      */
         ST    GPR00P,OPCNVADR                                     1330
*   IF INCOXSRC=INLIBRDS THEN       /* MEMBER KEYWORD SPECIFIED IN 1331
*                                      LIBRARY MEMBER                */
         TM    INCOXSRC,B'00010000'                                1331
         BNO   @RF01331                                            1331
         TM    INCOXSRC,B'00001000'                                1331
         BNZ   @RF01331                                            1331
*     DO;                           /* YES, BUILD MSG IRB303I PARMLST*/
*       OPTXTNUM=0;                 /* SOME TEXT FOLLOWS             */
         SR    @07,@07                                             1333
         STH   @07,OPTXTNUM                                        1333
*       OPTXTLEN=2;                 /* LENGTH OF TEXT                */
         MVC   OPTXTLEN(2),@CH00078                                1334
*       CALL OPCNVMOD(SYPRMV01,0,OPTMEMBR,2,0,'0'B,'0'B);          1335
         MVC   @AL00001+4(24),@AL01335                             1335
         LA    @07,SYPRMV01                                        1335
         ST    @07,@AL00001                                        1335
         LA    @07,OPTMEMBR                                        1335
         ST    @07,@AL00001+8                                      1335
         L     @07,OPCNVADR                                        1335
         LR    @15,@07                                             1335
         LA    @01,@AL00001                                        1335
         BALR  @14,@15                                             1335
*       OPTEXT=OPTMEMBR;            /* VARIABLE TEXT IS MEMBER NO.   */
         MVC   OPTEXT(2),OPTMEMBR                                  1336
*       INVTXLST(1)=ADDR(OP303LST); /* VARIABLE TEXT LIST 1          */
*                                                                  1337
         LA    @07,OP303LST                                        1337
         ST    @07,INVTXLST                                        1337
*       /*************************************************************/
*       /*                                                           */
*       /* ISSUE MESSAGE VIA IRBMFMPR                                */
*       /*                                                           */
*       /*************************************************************/
*                                                                  1338
*       CALL INMSGMOD(MID303I,INVTXLST,0,0);                       1338
         MVC   @AL00001(16),@AL01338                               1338
         LA    @07,INVTXLST                                        1338
         ST    @07,@AL00001+4                                      1338
         L     @15,INMSGADR                                        1338
         LA    @01,@AL00001                                        1338
         BALR  @14,@15                                             1338
*       GEN(DELETE EPLOC=INMODULE);                                1339
         DELETE EPLOC=INMODULE
*       RETURN;                     /* RETURN TO IRBMFANL            */
         B     @EL00014                                            1340
*     END;                                                         1341
*   IF SYPRMV01<0|SYPRMV01>99 THEN  /* VALUE OUT OF RANGE?           */
@RF01331 L     @07,SYPRMV01                                        1342
         LTR   @07,@07                                             1342
         BM    @RT01342                                            1342
         CH    @07,@CH01420                                        1342
         BNH   @RF01342                                            1342
@RT01342 DS    0H                                                  1343
*     DO;                                                          1343
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1344
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                1345
*       INCOXINV='1'B;                                             1346
         OI    INCOXINV,B'00000100'                                1346
*       INCOMEMV='00';              /* MOVE IN DEFAULT MEMBER NO.    */
         MVC   INCOMEMV(2),@CC00951                                1347
*       RETURN;                                                    1348
         B     @EL00014                                            1348
*     END;                                                         1349
*   CALL OPCNVMOD(SYPRMV01,0,OPTMEMBR,2,0,'0'B,'0'B);              1350
@RF01342 MVC   @AL00001+4(24),@AL01350                             1350
         LA    @07,SYPRMV01                                        1350
         ST    @07,@AL00001                                        1350
         LA    @07,OPTMEMBR                                        1350
         ST    @07,@AL00001+8                                      1350
         L     @15,OPCNVADR                                        1350
         LA    @01,@AL00001                                        1350
         BALR  @14,@15                                             1350
*   RFY                                                            1351
*    (GPR00P,                                                      1351
*     GPR01P,                                                      1351
*     GPR14P,                                                      1351
*     GPR15P)UNRSTD;                                               1351
*   GEN(DELETE EPLOC=INMODULE);                                    1352
         DELETE EPLOC=INMODULE
*   IF OPTMEMBR(1:1)=' ' THEN       /* LEADING BLANK?                */
         CLI   OPTMEMBR,C' '                                       1353
         BNE   @RF01353                                            1353
*     OPTMEMBR(1:1)='0';            /* MAKE BLANK ZERO               */
         MVI   OPTMEMBR,C'0'                                       1354
*   IF INCOMEMC=OPOPTSET&INCOMEMV^=OPTMEMBR THEN/* DIFFERENT VALUE?  */
@RF01353 TM    INCOMEMC,B'10000000'                                1355
         BNZ   @RF01355                                            1355
         CLC   INCOMEMV(2),OPTMEMBR                                1355
         BE    @RF01355                                            1355
*     DO;                                                          1356
*       INCOOPIC=OPOPTSET;          /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1357
*       INCOOPIV='1'B;              /* OPERATOR INTERVENTION         */
         OI    INCOOPIV,B'00000001'                                1358
*       INCOXINV='1'B;                                             1359
         OI    INCOXINV,B'00000100'                                1359
*     END;                                                         1360
*   INCOMEMV=OPTMEMBR;              /* MOVE IN MEMBER NUMBER         */
@RF01355 MVC   INCOMEMV(2),OPTMEMBR                                1361
*   INCOMEMC=OPOPTSET;              /* OPTION SET                    */
         NI    INCOMEMC,B'01111111'                                1362
*   RETURN;                                                        1363
         B     @EL00014                                            1363
*   END MFOPINIT;                                                  1364
         B     @EL00014                                            1364
*                                                                  1365
*/*  PROCEDURE NAME = MFREADIO                                       */
*/*                                                                  */
*/*  DESCRIPTIVE NAME = READ ROUTINE                                 */
*/*                                                                  */
*/*  FUNCTION = READS IN RECORDS FOR THE MF/1 LIBRARY DATASET        */
*/*                                                                  */
*                                                                  1365
*MFREADIO:                                                         1365
*   PROCEDURE(RERECPTR,RERECLEN,RERECCOR);                         1365
MFREADIO STM   @14,@12,@SA00015                                    1365
         MVC   @PC00015(12),0(@01)                                 1365
*   DECLARE                                                        1366
*     RERECPTR                      /* PTR TO RECORD READ IN         */
*         PTR(31),                                                 1366
*     RERECLEN                      /* LENGTH OF RECORD              */
*         FIXED(31),                                               1366
*     1 RERECCOR BDY(WORD),         /* GETMAIN PARAMETERS            */
*      2 RESUBPOL                   /* SUBPOOL                       */
*            FIXED(8),                                             1366
*      2 RERECSZE                   /* LENGTH                        */
*            FIXED(24),                                            1366
*        GPR02P                     /* REG USED IN READ              */
*            REG(2)PTR(31),                                        1366
*     1 REWRKARA BASED(RERECPTR),   /* WORKAREA FOR NEW RECORD       */
*      2 REDLMBYT                   /* DELIMITER BYTE                */
*            CHAR(1),                                              1366
*      2 RERECORD                   /* ACTUAL RECORD                 */
*            CHAR(80);                                             1366
*   RERECSZE=81;                    /* SIZE OF WORKAREA              */
         L     @15,@PC00015+8                                      1367
         MVC   RERECSZE(3,@15),@CF01437+1                          1367
*   RESUBPOL=0;                     /* SUBPOOL 0                     */
         MVI   RESUBPOL(@15),X'00'                                 1368
*   RFY                                                            1369
*    (GPR00F,                                                      1369
*     GPR01P,                                                      1369
*     GPR14P,                                                      1369
*     GPR15F)RSTD;                                                 1369
*   GPR00F=RERECCOR;                /* MOVE IN GETMAIN PARAMETERS    */
         L     @07,@PC00015+8                                      1370
         L     GPR00F,RERECCOR(,@07)                               1370
*   GEN(GETMAIN R,LV=(0));          /* GET CORE FOR WORKAREA         */
         GETMAIN R,LV=(0)
*   RERECPTR=GPR01P;                /* INITIALIZE RECORD PTR         */
         L     @07,@PC00015                                        1372
         ST    GPR01P,RERECPTR(,@07)                               1372
*   RERECLEN=73;                    /* AND ITS LENGTH                */
         L     @07,@PC00015+4                                      1373
         MVC   RERECLEN(4,@07),@CF01438                            1373
*   RFY                                                            1374
*    (GPR00F,                                                      1374
*     GPR01P,                                                      1374
*     GPR14P,                                                      1374
*     GPR15F)UNRSTD;                                               1374
*   IF INEOFBIT='1'B THEN           /* END OF FILE REACHED?          */
         TM    INEOFBIT,B'10000000'                                1375
         BNO   @RF01375                                            1375
*     RETURN CODE(4);               /* RETURN UNSUCCESSFUL           */
         LA    @15,4                                               1376
         L     @14,@SA00015                                        1376
         LM    @00,@12,@SA00015+8                                  1376
         BR    @14                                                 1376
*   DCBEODA=ADDR(REEODAD);          /* SET UP EODAD ADDRESS          */
@RF01375 L     @15,DCBPTR                                          1377
         LA    @14,DCBIOBAD+16(,@15)                               1377
         LA    @07,REEODAD                                         1377
         ST    @07,@TF00001                                        1377
         MVC   DCBEODA(3,@14),@TF00001+1                           1377
*   DCBSYNA=ADDR(MFRESYNA);         /* SET UP SYNAD RTN ADDRESS      */
         LA    @14,MFRESYNA                                        1378
         ST    @14,@TF00001                                        1378
         MVC   DCBSYNA+52(3,@15),@TF00001+1                        1378
*   REDLMBYT=' ';                   /* INSERT DELIMITER IN 1ST BYTE  */
         L     @15,@PC00015                                        1379
         L     @15,RERECPTR(,@15)                                  1379
         MVI   REDLMBYT(@15),C' '                                  1379
*   RFY                                                            1380
*    (GPR00P,                                                      1380
*     GPR01P,                                                      1380
*     GPR02P,                                                      1380
*     GPR14P,                                                      1380
*     GPR15P)RSTD;                                                 1380
*   GPR02P=ADDR(RERECORD);          /* SET UP AREA ADDRESS           */
         L     @07,@PC00015                                        1381
         L     @07,RERECPTR(,@07)                                  1381
         LA    GPR02P,RERECORD(,@07)                               1381
*   GENERATE;                                                      1382
         READ INARDMAC,SF,INMEMLIB,(GPR02P),'S',MF=E
         CHECK INARDMAC
*   RFY                                                            1383
*    (GPR00P,                                                      1383
*     GPR01P,                                                      1383
*     GPR02P,                                                      1383
*     GPR14P,                                                      1383
*     GPR15P)UNRSTD;                                               1383
*   IF INEOFBIT='1'B THEN           /* END OF FILE REACHED?          */
         TM    INEOFBIT,B'10000000'                                1384
         BNO   @RF01384                                            1384
*     RETURN CODE(4);               /* I/O ERROR                     */
         LA    @15,4                                               1385
         L     @14,@SA00015                                        1385
         LM    @00,@12,@SA00015+8                                  1385
         BR    @14                                                 1385
*   ELSE                            /* RECORD READ                   */
*     RETURN CODE(0);               /* RETURN SUCCESSFUL             */
@RF01384 SR    @15,@15                                             1386
         L     @14,@SA00015                                        1386
         LM    @00,@12,@SA00015+8                                  1386
         BR    @14                                                 1386
*REEODAD:                                                          1387
*   ;                                                              1387
REEODAD  DS    0H                                                  1388
*   INEOFBIT='1'B;                  /* INDICATE END OF FILE          */
         OI    INEOFBIT,B'10000000'                                1388
*   RETURN CODE(4);                 /* RETURN UNSUCCESSFUL           */
*                                                                  1389
         LA    @15,4                                               1389
         L     @14,@SA00015                                        1389
         LM    @00,@12,@SA00015+8                                  1389
         BR    @14                                                 1389
*   /*****************************************************************/
*   /*                                                               */
*   /* SYNAD ROUTINE                                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1390
*MFRESYNA:                                                         1390
*   PROCEDURE OPTIONS(NOSAVEAREA,NOSAVE);                          1390
MFRESYNA DS    0H                                                  1391
*   DECLARE                                                        1391
*     RESAVARA                      /* SAVEAREA FOR REGS AT ENTRY    */
*         CHAR(64)BDY(WORD),                                       1391
*     REBUFPTR                      /* PTR TO SYNAD TEXT             */
*         PTR(31),                                                 1391
*     REMESAGE                      /* SYNAD TEXT                    */
*         CHAR(128)BASED(REBUFPTR),                                1391
*     REOPISET                      /* OPERATOR INTERVENTION         */
*         BIT(1)CONSTANT('0'B),                                    1391
*     1 RE304INO(2),                /* VARIABLE TEXT LIST            */
*      2 RE304PRT                   /* PART NUMBER                   */
*            FIXED(15),                                            1391
*      2 RE304LEN                   /* LENGTH                        */
*            FIXED(15),                                            1391
*      2 RE304TXT                   /* VARIABLE TEXT                 */
*            CHAR(128);                                            1391
*                                                                  1391
*   /*****************************************************************/
*   /*                                                               */
*   /* SAVE REGISTERS AND ISSUE SYNADF MACRO TO GET ERROR MESSAGE AND*/
*   /* ESTABLISH NEW SAVE AREA                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1392
*   GENERATE SETS(RESAVARA);                                       1392
         STM   0,15,RESAVARA           SAVE REGISTERS
         SYNADAF ACSMETH=BPAM
*   RFY                                                            1393
*    (GPR01P)RSTD;                                                 1393
*   REBUFPTR=GPR01P;                /* SAVE PTR TO SYNAD TEXT        */
         ST    GPR01P,REBUFPTR                                     1394
*   RFY                                                            1395
*    (GPR01P)UNRSTD;                                               1395
*   RE304PRT(1)=LMPART22;           /* PART # FOR THE SYNAD TEXT   1396
*                                      FOLLOWS                       */
         MVC   RE304PRT(2),@CH00602                                1396
*   RE304PRT(2)=0;                  /* VARIABLE TEXT                 */
         SR    @15,@15                                             1397
         STH   @15,RE304PRT+132                                    1397
*   RE304LEN(2)=LENGTH(REMESAGE);   /* SYNAD TEXT LENGTH             */
         MVC   RE304LEN+132(2),@CH01448                            1398
*   RE304TXT(2)=REMESAGE;           /* SYNAD TEXT                    */
         L     @15,REBUFPTR                                        1399
         MVC   RE304TXT+132(128),REMESAGE(@15)                     1399
*   INVTXLST(1)=ADDR(RE304INO(1));  /* VARIABLE TEXT LIST            */
         LA    @15,RE304INO                                        1400
         ST    @15,INVTXLST                                        1400
*   INVTXLST(2)=ADDR(RE304INO(2));                                 1401
*                                                                  1401
         LA    @15,RE304INO+132                                    1401
         ST    @15,INVTXLST+4                                      1401
*   /*****************************************************************/
*   /*                                                               */
*   /* ISSUE MESSAGE IRB304I                                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1402
*   CALL INMSGMOD(MID304I,INVTXLST,0,0);                           1402
         MVC   @AL00001(16),@AL01402                               1402
         LA    @15,INVTXLST                                        1402
         ST    @15,@AL00001+4                                      1402
         L     @15,INMSGADR                                        1402
         LA    @01,@AL00001                                        1402
         BALR  @14,@15                                             1402
*   INCOOPIC=REOPISET;              /* OPTION SET                    */
         NI    INCOOPIC,B'01111111'                                1403
*   INCOOPIV='1'B;                  /* REQUEST OPERATOR INTERVENTION */
         OI    INCOOPIV,B'00000001'                                1404
*   INEOFBIT='1'B;                  /* INDICATE END OF FILE          */
         OI    INEOFBIT,B'10000000'                                1405
*   GEN REFS(RESAVARA);                                            1406
         SYNADRLS
         LM    0,15,RESAVARA
*   RETURN;                         /* GO TO NEXT SOURCE             */
@EL00016 DS    0H                                                  1407
@EF00016 DS    0H                                                  1407
@ER00016 BR    @14                                                 1407
*   END MFRESYNA;                                                  1408
*   END MFREADIO;                                                  1409
@EL00015 DS    0H                                                  1409
@EF00015 DS    0H                                                  1409
@ER00015 LM    @14,@12,@SA00015                                    1409
         BR    @14                                                 1409
*                                                                  1410
*/*  PROCEDURE NAME = MFMERGE                                        */
*/*                                                                  */
*/*  DESCRIPTIVE NAME = MERGE OPTIONS                                */
*/*                                                                  */
*/*  FUNCTION = THIS ROUTINE MERGES THE VALUES SET IN THE TEMPORARY  */
*/*             PMA AND COA WITH THOSE IN THE PERMANENT PMA AND COA. */
*/*                                                                  */
*                                                                  1410
*MFMERGE:                                                          1410
*   PROCEDURE(MEFORCE);                                            1410
MFMERGE  STM   @14,@12,12(@13)                                     1410
         MVC   @PC00017(4),0(@01)                                  1410
*   DECLARE                                                        1411
*     MEFORCE                       /* FORCE MERGE BIT               */
*         BIT(1),                                                  1411
*     V BIT(8),                     /* BIT                           */
*     X BIT(8),                     /* MASKING                       */
*     Z BIT(8),                     /* FOR MERGING                   */
*     M BIT(8),                     /* OPTION VALUES                 */
*     MEOPTSPF                      /* OPTION SPECIFIED INDICATION   */
*         BIT(1)CONSTANT('0'B),                                    1411
*     MECNTRL                       /* DEVICE TYPES CONTROL ELEMENT  */
*         FIXED(8)CONSTANT(1),                                     1411
*     MESTATUS                      /* DEVICES TYPES STATUS ELEMENT  */
*         FIXED(8)CONSTANT(2);                                     1411
*                                                                  1411
*   /*****************************************************************/
*   /*                                                               */
*   /* COMMON OPTION AREA MERGE. IT CONTAINS TRACE,CYCLE,SYSOUT,     */
*   /* INTERVAL,REPORT,STOP,AND OPI OPTIONS VALUES                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1412
*   IF MEFORCE='0'B THEN            /* DO NOT FORCE MERGE?           */
         L     @15,@PC00017                                        1412
         TM    MEFORCE(@15),B'10000000'                            1412
         BNZ   @RF01412                                            1412
*     DO I=1 TO MAXCOMM;            /* DO FOR EVERY COA OPTION       */
         LA    @15,1                                               1413
         ST    @15,I                                               1413
@DL01413 DS    0H                                                  1414
*       IF(MFCOCTRL(I)^=MEOPTSPF)&(INCOCTRL(I)=MEOPTSPF)THEN/* IF NOT
*                                      SPECIFIED IN PERMANENT        */
         SLA   @15,2                                               1414
         L     @14,@PC00001+8                                      1414
         ST    @15,@TF00001                                        1414
         ALR   @15,@14                                             1414
         AL    @15,@CF01528                                        1414
         TM    MFCOCTRL(@15),B'10000000'                           1414
         BZ    @RF01414                                            1414
         L     @01,@TF00001                                        1414
         LA    @15,INCOCTRL-4(@01)                                 1414
         TM    0(@15),B'10000000'                                  1414
         BNZ   @RF01414                                            1414
*                                   /* BUT SET IN TEMPORARY          */
*         MFCOOPTN(I)=INCOOPTN(I);  /* MOVE IN OPTION VALUE          */
         AL    @14,@TF00001                                        1415
         AL    @14,@CF01528                                        1415
         L     @15,@TF00001                                        1415
         LA    @01,INCOOPTN-4(@15)                                 1415
         MVC   MFCOOPTN(4,@14),0(@01)                              1415
*     END;                                                         1416
@RF01414 LA    @15,1                                               1416
         A     @15,I                                               1416
         ST    @15,I                                               1416
         CH    @15,@CH00069                                        1416
         BNH   @DL01413                                            1416
*   ELSE                            /* FORCE MERGING VALUES INTO     */
*     DO I=1 TO MAXCOMM;            /* PERMANENT CONTROL BLOCKS      */
         B     @RC01412                                            1417
@RF01412 LA    @15,1                                               1417
         ST    @15,I                                               1417
@DL01417 DS    0H                                                  1418
*       IF INCOCTRL(I)=MEOPTSPF&(I-1)*(LENGTH(MFCOOPTN)/8)^=ADDR(  1418
*           MFCOMEM)-ADDR(MFCOA)THEN/* THIS OPTION SPECIFIED AND NOT
*                                      MEMBER OPTION?                */
         LR    @14,@15                                             1418
         SLA   @14,2                                               1418
         LA    @01,INCOCTRL-4(@14)                                 1418
         TM    0(@01),B'10000000'                                  1418
         BNZ   @RF01418                                            1418
         BCTR  @15,0                                               1418
         SLA   @15,2                                               1418
         L     @07,@PC00001+8                                      1418
         LA    @06,MFCOMEM(,@07)                                   1418
         SR    @06,@07                                             1418
         CR    @15,@06                                             1418
         BE    @RF01418                                            1418
*         MFCOOPTN(I)=INCOOPTN(I);  /* MOVE IN VALUE                 */
         ALR   @07,@14                                             1419
         AL    @07,@CF01528                                        1419
         LA    @15,INCOOPTN-4(@14)                                 1419
         MVC   MFCOOPTN(4,@07),0(@15)                              1419
*     END;                                                         1420
*                                                                  1420
@RF01418 LA    @15,1                                               1420
         A     @15,I                                               1420
         ST    @15,I                                               1420
         CH    @15,@CH00069                                        1420
         BNH   @DL01417                                            1420
*   /*****************************************************************/
*   /*                                                               */
*   /* PROBLEM OPTION AREA MERGE. IT CONTAINS CPU,PAGING,WORKLOAD,   */
*   /* CHANNEL AND DEVICE OPTIONS' VALUES.                           */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1421
*   IF MEFORCE='0'B THEN            /* DO NOT FORCE MERGE?           */
@RC01412 L     @15,@PC00017                                        1421
         TM    MEFORCE(@15),B'10000000'                            1421
         BNZ   @RF01421                                            1421
*     DO;                           /* YES                           */
*       V=MFMVDEV->MFPMDEVF(MECNTRL);/* INITIALIZE VARIABLE          */
         L     @15,@PC00001+4                                      1423
         L     @01,MFMVDEV(,@15)                                   1423
         MVC   V(1),MFPMDEVF(@01)                                  1423
*       DO I=1 TO MFMVNUM;          /* DO FOR EACH PMA               */
         LA    @15,1                                               1424
         B     @DE01424                                            1424
@DL01424 DS    0H                                                  1425
*         RFY                                                      1425
*           MFPMA BASED(MFMVADD(I));                               1425
*         RFY                                                      1426
*           INPMA BASED(INMVADD(I));                               1426
*         IF(I-1)*LENGTH(MFMVADD)=ADDR(MFMVDEV)-ADDR(MFMVOPT)THEN/*
*                                      DEVICE PMA?                   */
         LR    @14,@15                                             1427
         BCTR  @14,0                                               1427
         SLA   @14,2                                               1427
         L     @07,@PC00001+4                                      1427
         LA    @06,MFMVDEV(,@07)                                   1427
         LA    @05,MFMVOPT(,@07)                                   1427
         SR    @06,@05                                             1427
         CR    @14,@06                                             1427
         BNE   @RF01427                                            1427
*           DO;                     /* SET DEVICE STATUS             */
*             X=V&&INPMDEVF(MECNTRL);/* BEGIN SETTING UP A MASK      */
         SLA   @15,2                                               1429
         L     @14,INMVADD-4(@15)                                  1429
         MVC   X(1),V                                              1429
         XC    X(1),INPMDEVF(@14)                                  1429
*             M=X&V;                                               1430
         MVC   M(1),X                                              1430
         NC    M(1),V                                              1430
*             Z=M&INPMDEVF(MESTATUS);/* STATUS BITS TURNED ON        */
         MVC   Z(1),M                                              1431
         NC    Z(1),INPMDEVF+1(@14)                                1431
*             MFPMDEVF(MESTATUS)=Z|MFPMDEVF(MESTATUS);             1432
         L     @15,MFMVADD-4(@15,@07)                              1432
         OC    MFPMDEVF+1(1,@15),Z                                 1432
*             MFPMDEVF(MECNTRL)=MFPMDEVF(MECNTRL)&&M;/* OPTION SET   */
         XC    MFPMDEVF(1,@15),M                                   1433
*             IF MFPMDEVF(MECNTRL)^=MFPMDEVC THEN/* ANY OPTIONS SET? */
         CLI   MFPMDEVF(@15),X'FC'                                 1434
         BE    @RF01434                                            1434
*               MFPMCON=MEOPTSPF;   /* OPTION SET                    */
         NI    MFPMCON(@15),B'01111111'                            1435
*           END;                                                   1436
*         ELSE                      /* ALL OTHER OPTION PMA'S        */
*           IF(MFPMCON^=MEOPTSPF)&INPMCON=MEOPTSPF THEN/* OPTION   1437
*                                      SPECIFIED?                    */
         B     @RC01427                                            1437
@RF01427 L     @15,I                                               1437
         SLA   @15,2                                               1437
         L     @14,@PC00001+4                                      1437
         L     @14,MFMVADD-4(@15,@14)                              1437
         TM    MFPMCON(@14),B'10000000'                            1437
         BZ    @RF01437                                            1437
         L     @15,INMVADD-4(@15)                                  1437
         TM    INPMCON(@15),B'10000000'                            1437
         BNZ   @RF01437                                            1437
*             DO;                                                  1438
*               MFPMOPT=INPMOPT;    /* MOVE IN OPTION VALUE          */
         MVC   MFPMOPT(4,@14),INPMOPT(@15)                         1439
*               MFPMCON=MEOPTSPF;   /* OPTION SET                    */
         NI    MFPMCON(@14),B'01111111'                            1440
*             END;                                                 1441
*       END;                                                       1442
@RF01437 DS    0H                                                  1442
@RC01427 LA    @15,1                                               1442
         A     @15,I                                               1442
@DE01424 ST    @15,I                                               1442
         L     @14,@PC00001+4                                      1442
         C     @15,MFMVNUM(,@14)                                   1442
         BNH   @DL01424                                            1442
*     END;                                                         1443
*   ELSE                            /* FORCE MERGING VALUES INTO     */
*     DO;                           /* PERMANENT CONTROL BLOCKS      */
         B     @RC01421                                            1444
@RF01421 DS    0H                                                  1445
*       V=MFPMDEVC;                 /* INITIALIZE VARIABLE           */
         MVI   V,X'FC'                                             1445
*       DO I=1 TO MFMVNUM;          /* DO FOR EVERY PMA              */
         LA    @15,1                                               1446
         B     @DE01446                                            1446
@DL01446 DS    0H                                                  1447
*         RFY                                                      1447
*           MFPMA BASED(MFMVADD(I));                               1447
*         RFY                                                      1448
*           INPMA BASED(INMVADD(I));                               1448
*         IF(I-1)*LENGTH(MFMVADD)=ADDR(MFMVDEV)-ADDR(MFMVOPT)THEN/*
*                                      DEVICE PMA?                   */
         LR    @14,@15                                             1449
         BCTR  @14,0                                               1449
         SLA   @14,2                                               1449
         L     @07,@PC00001+4                                      1449
         LA    @06,MFMVDEV(,@07)                                   1449
         LA    @05,MFMVOPT(,@07)                                   1449
         SR    @06,@05                                             1449
         CR    @14,@06                                             1449
         BNE   @RF01449                                            1449
*           DO;                                                    1450
*             MFPMDEVF(MESTATUS)=MFPMDEVF(MESTATUS)&INPMDEVF(MECNTRL);
         SLA   @15,2                                               1451
         L     @14,MFMVADD-4(@15,@07)                              1451
         L     @15,INMVADD-4(@15)                                  1451
         NC    MFPMDEVF+1(1,@14),INPMDEVF(@15)                     1451
*             X=INPMDEVF(MECNTRL)&&V;                              1452
         MVC   X(1),INPMDEVF(@15)                                  1452
         XC    X(1),V                                              1452
*             Z=X&INPMDEVF(MESTATUS);                              1453
         MVC   Z(1),X                                              1453
         NC    Z(1),INPMDEVF+1(@15)                                1453
*             MFPMDEVF(MESTATUS)=MFPMDEVF(MESTATUS)|Z;             1454
         OC    MFPMDEVF+1(1,@14),Z                                 1454
*             MFPMDEVF(MECNTRL)=INPMDEVF(MECNTRL)&MFPMDEVF(MECNTRL);
         NC    MFPMDEVF(1,@14),INPMDEVF(@15)                       1455
*             IF MFPMDEVF(MECNTRL)^=MFPMDEVC THEN/* ANY OPTIONS SET? */
         CLI   MFPMDEVF(@14),X'FC'                                 1456
         BE    @RF01456                                            1456
*               MFPMCON=MEOPTSPF;   /* OPTION SET                    */
         NI    MFPMCON(@14),B'01111111'                            1457
*           END;                                                   1458
*         ELSE                      /* NOT DEVICE ENTRY              */
*           IF INPMCON=MEOPTSPF THEN/* OPTION SPECIFIED?             */
         B     @RC01449                                            1459
@RF01449 L     @15,I                                               1459
         SLA   @15,2                                               1459
         L     @14,INMVADD-4(@15)                                  1459
         TM    INPMCON(@14),B'10000000'                            1459
         BNZ   @RF01459                                            1459
*             DO;                                                  1460
*               MFPMOPT=INPMOPT;    /* MOVE IN VALUE                 */
         L     @07,@PC00001+4                                      1461
         L     @15,MFMVADD-4(@15,@07)                              1461
         MVC   MFPMOPT(4,@15),INPMOPT(@14)                         1461
*               MFPMCON=MEOPTSPF;   /* OPTION SET                    */
         NI    MFPMCON(@15),B'01111111'                            1462
*             END;                                                 1463
*       END;                                                       1464
@RF01459 DS    0H                                                  1464
@RC01449 LA    @15,1                                               1464
         A     @15,I                                               1464
@DE01446 ST    @15,I                                               1464
         L     @14,@PC00001+4                                      1464
         C     @15,MFMVNUM(,@14)                                   1464
         BNH   @DL01446                                            1464
*     END;                                                         1465
*   RFY                                                            1466
*     INPMA;                                                       1466
*   RFY                                                            1467
*     MFPMA;                                                       1467
*   END MFMERGE;                                                   1468
@EL00017 DS    0H                                                  1468
@EF00017 DS    0H                                                  1468
@ER00017 LM    @14,@12,12(@13)                                     1468
         BR    @14                                                 1468
*                                                                  1469
*/*  PROCEDURE NAME = MFVALCHK                                       */
*/*                                                                  */
*/*  DESCRIPTIVE NAME = OPTIONS VALIDITY CHECK                       */
*/*                                                                  */
*/*  FUNCTION = CERTAIN COMBINATIONS OF OPTION VALUES CONFLICT. THIS */
*/*             ROUTINES CHECKS THOSE OPTION S VALUES.               */
*/*                                                                  */
*                                                                  1469
*MFVALCHK:                                                         1469
*   PROCEDURE;                                                     1469
MFVALCHK STM   @14,@12,@SA00018                                    1469
*   DECLARE                                                        1470
*     VAVALCHK                      /* VALIDITY CHECK ERROR BIT      */
*         BIT(1),                                                  1470
*     VADEFER                       /* REPORT VALUE - DEFER          */
*         BIT(2)CONSTANT('01'B),                                   1470
*     VARELTME                      /* REPORT VALUE - REALTIME       */
*         BIT(2)CONSTANT('10'B),                                   1470
*     1 VAVTXLST,                   /* VARIABLE TEXT LIST            */
*      2 VA301INO                   /* MSG PART NUMBER               */
*            FIXED(15),                                            1470
*      2 VA301LEN                   /* LENGTH OF PART                */
*            FIXED(15),                                            1470
*        VANOREP                    /* NOREPORT VALUE                */
*            BIT(2)CONSTANT('00'B),                                1470
*        VASTOP                     /* STOP                          */
*            BIT(1)CONSTANT('0'B),                                 1470
*        VAMINTES                   /* STOP TIME IN MINUTES          */
*            BIT(1)CONSTANT('0'B),                                 1470
*        VANOTCE                    /* NOTRACE VALUE                 */
*            BIT(1)CONSTANT('0'B);                                 1470
*   VAVALCHK='0'B;                  /* INITIALIZE ERROR BIT          */
*                                                                  1471
         NI    VAVALCHK,B'01111111'                                1471
*   /*****************************************************************/
*   /*                                                               */
*   /* REPORT/STOP VALIDITY CHECK. IF REPORT OPTION IS SET TO DEFER  */
*   /* AND NOSTOP IS REQUESTED, VALIDITY CHECK ERROR RESULTS         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1472
*   IF MFCOREPV=VADEFER&MFCOSTPS^=VASTOP THEN                      1472
         L     @15,@PC00001+8                                      1472
         TM    MFCOREPV(@15),B'00000001'                           1472
         BNO   @RF01472                                            1472
         TM    MFCOREPV(@15),B'00000010'                           1472
         BNZ   @RF01472                                            1472
         TM    MFCOSTPS(@15),B'01000000'                           1472
         BZ    @RF01472                                            1472
*     DO;                                                          1473
*       MFCOSTPV=MFCOINTV;          /* SET STOP = INTERVAL           */
         MVC   MFCOSTPV(2,@15),MFCOINTV(@15)                       1474
*       MFCOSTPS=VASTOP;            /* STOP SPECIFIED                */
*       MFCOSTPU=VAMINTES;          /* STOP TIME IN MIN.             */
         NI    MFCOSTPS(@15),B'10011111'                           1476
*       MFCOOPIV='1'B;              /* REQUEST OPERATOR INTERVENTION */
         OI    MFCOOPIV(@15),B'00000001'                           1477
*       VAVALCHK='1'B;              /* VALIDITY CHECK ERROR          */
         OI    VAVALCHK,B'10000000'                                1478
*     END;                                                         1479
*                                                                  1479
*   /*****************************************************************/
*   /*                                                               */
*   /* REPORT/TRACE VALIDITY CHECK. 'NOREPORT' AND 'NOTRACE'         */
*   /* SPECIFIED TOGETHER AS MF/1 INPUT RESULTS IN VALIDITY CHECK    */
*   /* ERROR                                                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1480
*   IF MFCOREPV=VANOREP&MFCOTCEV=VANOTCE THEN                      1480
@RF01472 L     @15,@PC00001+8                                      1480
         TM    MFCOREPV(@15),B'00000011'                           1480
         BNZ   @RF01480                                            1480
         TM    MFCOTCEV(@15),B'00000001'                           1480
         BNZ   @RF01480                                            1480
*     DO;                                                          1481
*       MFCOREPV=VADEFER;           /* SET REPORT = DEFER            */
         NI    MFCOREPV(@15),B'11111101'                           1482
         OI    MFCOREPV(@15),B'00000001'                           1482
*       MFCOOPIV='1'B;              /* REQUEST OPERATOR INTERVENTION */
         OI    MFCOOPIV(@15),B'00000001'                           1483
*       VAVALCHK='1'B;              /* VALIDITY CHECK ERROR          */
         OI    VAVALCHK,B'10000000'                                1484
*     END;                                                         1485
*                                                                  1485
*   /*****************************************************************/
*   /*                                                               */
*   /* STOP/INTERVAL VALIDITY CHECK. IF STOP VALUE IS LESS THAN THE  */
*   /* INTERVAL VALUE A VALIDITY CHECK ERROR RESULTS.                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1486
*   IF MFCOSTPS=VASTOP&MFCOSTPU=VAMINTES&MFCOSTPV<MFCOINTV THEN    1486
@RF01480 L     @15,@PC00001+8                                      1486
         TM    MFCOSTPS(@15),B'01100000'                           1486
         BNZ   @RF01486                                            1486
         LH    @14,MFCOINTV(,@15)                                  1486
         CH    @14,MFCOSTPV(,@15)                                  1486
         BNH   @RF01486                                            1486
*     DO;                                                          1487
*       MFCOSTPV=MFCOINTV;          /* STOP=INTERVAL                 */
         STH   @14,MFCOSTPV(,@15)                                  1488
*       MFCOOPIV='1'B;              /* REQUEST OPERATOR INTERVENTION */
         OI    MFCOOPIV(@15),B'00000001'                           1489
*       VAVALCHK='1'B;              /* VALIDITY CHECK ERROR          */
         OI    VAVALCHK,B'10000000'                                1490
*     END;                                                         1491
*   IF VAVALCHK='1'B THEN           /* VALIDITY CHECK ERROR FOUND?   */
@RF01486 TM    VAVALCHK,B'10000000'                                1492
         BNO   @RF01492                                            1492
*     DO;                                                          1493
*       VA301INO=0;                 /* VARIABLE TEXT LIST 2          */
         SR    @15,@15                                             1494
         STH   @15,VA301INO                                        1494
*       VA301LEN=0;                 /* NO MSG PART SUPPLIED          */
         STH   @15,VA301LEN                                        1495
*       INVTXLST(1)=ADDR(VA301INO);                                1496
*                                                                  1496
         LA    @15,VA301INO                                        1496
         ST    @15,INVTXLST                                        1496
*       /*************************************************************/
*       /*                                                           */
*       /* ISSUE MESSAGE IRBMF301I                                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  1497
*       CALL INMSGMOD(MID301I,INVTXLST,0,INMDCBAD);                1497
         LA    @15,@CF00580                                        1497
         ST    @15,@AL00001                                        1497
         LA    @15,INVTXLST                                        1497
         ST    @15,@AL00001+4                                      1497
         LA    @15,@CF00945                                        1497
         ST    @15,@AL00001+8                                      1497
         LA    @15,INMDCBAD                                        1497
         ST    @15,@AL00001+12                                     1497
         L     @15,INMSGADR                                        1497
         LA    @01,@AL00001                                        1497
         BALR  @14,@15                                             1497
*     END;                                                         1498
*   RETURN;                         /* RETURN TO INP                 */
@EL00018 DS    0H                                                  1499
@EF00018 DS    0H                                                  1499
@ER00018 LM    @14,@12,@SA00018                                    1499
         BR    @14                                                 1499
*   END MFVALCHK;                                                  1500
         B     @EL00018                                            1500
@PB00018 DS    0H                                                  1501
*                                                                  1501
*   /*****************************************************************/
*   /*                                                               */
*   /* MF/1 SYNTAX TABLE IN BACKUS NORMAL FORM                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1501
*   GENERATE DATA REFS(MFRBLANK,MFRTEXT,MFRRERR,MFRINTGR,MFRALPHA, 1501
*       MFOPINIT)DEFS(MFSYNTAB);                                   1501
*   END IRBMFINP                                                   1502
*                                                                  1502
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IHADCBDF)                                       */
*/*%INCLUDE SYSLIB  (IHADCB  )                                       */
*/*%INCLUDE SYSLIB  (IRBMFMID)                                       */
*/*%INCLUDE SYSLIB  (IRBMFLMM)                                       */
*/*%INCLUDE SYSLIB  (IEZCIB  )                                       */
*                                                                  1502
*       ;                                                          1502
@EL00001 L     @13,4(,@13)                                         1502
@EF00001 L     @00,@SIZDATD                                        1502
         LR    @01,@10                                             1502
         FREEMAIN R,LV=(0),A=(1)
@ER00001 LM    @14,@12,12(@13)                                     1502
         BR    @14                                                 1502
@DATA    DS    0H
@CH00091 DC    H'6'
@CH00592 DC    H'17'
@CH00600 DC    H'21'
@CH00602 DC    H'22'
@CH00067 DC    H'23'
@CH00088 DC    H'24'
@CH00606 DC    H'25'
@CH00608 DC    H'26'
@CH00610 DC    H'27'
@CH00612 DC    H'28'
@CH00614 DC    H'29'
@CH00616 DC    H'30'
@CH00045 DC    H'31'
@CH00169 DC    H'32'
@CH00620 DC    H'33'
@CH00622 DC    H'34'
@CH00624 DC    H'35'
@CH00626 DC    H'36'
@CH00628 DC    H'37'
@CH00630 DC    H'38'
@CH00632 DC    H'39'
@CH00330 DC    H'40'
@CH00635 DC    H'41'
@CH00637 DC    H'42'
@CH00639 DC    H'43'
@CH00641 DC    H'44'
@CH00643 DC    H'45'
@CH00645 DC    H'46'
@CH00647 DC    H'47'
@CH00452 DC    H'48'
@CH00650 DC    H'49'
@CH00701 DC    H'50'
@CH00703 DC    H'51'
@CH00250 DC    H'52'
@CH00712 DC    H'56'
@CH00714 DC    H'57'
@CH00716 DC    H'58'
@CH00718 DC    H'59'
@CH00529 DC    H'60'
@CH00721 DC    H'61'
@CH00723 DC    H'62'
@CH00725 DC    H'63'
@CH00727 DC    H'64'
@CH00729 DC    H'65'
@CH00731 DC    H'66'
@CH00741 DC    H'71'
@CH00535 DC    H'72'
@CH01420 DC    H'99'
@CH00823 DC    H'119'
@CH01448 DC    H'128'
@SC01510 CLC   RTSCANER(0,@14),RTTEXT(@07)
@SM01514 MVC   LIVARTXT(0),LISTRNG
@SM01516 MVC   LIVARTXT(0),@TS00001
         DS    0F
@AL00117 EQU   *                       LIST WITH   4 ARGUMENT(S)
@AL00132 EQU   *                       LIST WITH   4 ARGUMENT(S)
@AL01402 DC    A(@CF00588)             LIST WITH   4 ARGUMENT(S)
         DC    A(@CF00254)
         DC    A(@CF00945)
         DC    A(@CF00945)
@AL00127 DC    A(@CF00584)             LIST WITH   4 ARGUMENT(S)
         DC    A(@CB00850)
         DC    A(@CF00945)
         DC    A(@CF00945)
@AL00139 DC    A(INPGMDEF)             LIST WITH   2 ARGUMENT(S)
         DC    A(INDEFLEN)
@AL00204 DC    A(@CF00580)             LIST WITH   4 ARGUMENT(S)
         DC    A(@CB00847)
         DC    A(@CF00945)
         DC    A(@CF00945)
@AL00213 DC    A(@CF00069)             LIST WITH   4 ARGUMENT(S)
         DC    A(@CF00254)
         DC    A(@CF00945)
         DC    A(@CF00945)
@AL00217 DC    A(@CF00578)             LIST WITH   4 ARGUMENT(S)
         DC    A(@CF00945)
@AL00562 DC    A(@CF00076)             LIST WITH   4 ARGUMENT(S)
         DC    A(@CF00945)
@AL00228 DC    A(@CF00582)             LIST WITH   4 ARGUMENT(S)
         DC    A(@CF00945)
         DC    A(@CF00945)
         DC    A(@CF00945)
@AL00560 DC    A(@CF00131)             LIST WITH   4 ARGUMENT(S)
@AL00774 EQU   *                       LIST WITH   6 ARGUMENT(S)
@AL00790 EQU   *                       LIST WITH   6 ARGUMENT(S)
@AL00822 DC    A(@CF00945)             LIST WITH   6 ARGUMENT(S)
         DC    A(@CF00945)
         DC    A(@CF00945)
         DC    A(@CF00945)
         DC    A(@CB00847)
         DC    A(@CB00847)
@AL01335 EQU   *                       LIST WITH   6 ARGUMENT(S)
@AL01350 DC    A(@CF00945)             LIST WITH   6 ARGUMENT(S)
@AL00620 DC    A(@CB00850)             LIST WITH   1 ARGUMENT(S)
         DC    A(@CF00078)
         DC    A(@CF00945)
         DC    A(@CB00847)
@AL00091 EQU   *                       LIST WITH   1 ARGUMENT(S)
@AL00098 EQU   *                       LIST WITH   1 ARGUMENT(S)
@AL00134 EQU   *                       LIST WITH   1 ARGUMENT(S)
@AL00140 DC    A(@CB00847)             LIST WITH   1 ARGUMENT(S)
@AL01338 DC    A(@CF00586)             LIST WITH   4 ARGUMENT(S)
@AL00613 DC    A(@CF00254)             LIST WITH   3 ARGUMENT(S)
         DC    A(@CF00945)
         DC    A(@CF00945)
@DATD    DSECT
         DS    0F
@SA00001 DS    18F
@PC00001 DS    3F
@SA00004 DS    15F
@PC00004 DS    3F
@PC00017 DS    1F
@SA00012 DS    15F
@SA00014 DS    15F
@PC00014 DS    1F
@SA00018 DS    15F
@SA00003 DS    15F
@PC00003 DS    1F
@SA00009 DS    15F
@PC00009 DS    2F
@SA00013 DS    15F
@PC00013 DS    3F
@SA00005 DS    15F
@PC00005 DS    2F
@SA00010 DS    15F
@PC00010 DS    1F
@SA00006 DS    15F
@PC00006 DS    2F
@SA00007 DS    15F
@PC00007 DS    2F
@SA00008 DS    15F
@PC00008 DS    2F
@SA00015 DS    15F
@PC00015 DS    3F
@SA00011 DS    15F
@PC00011 DS    2F
@AL00001 DS    7A
@TF00001 DS    F
@AFTEMPS DS    6F
@ZTEMPS  DS    0F
@ZT00003 DC    F'0'
@ZTEMPND EQU   *
@ZLEN    EQU   @ZTEMPND-@ZTEMPS
IRBMFINP CSECT
         DS    0F
@CF01528 DC    F'-4'
@CF01512 DC    F'-1'
@CF00945 DC    F'0'
@CF00065 DC    F'1'
@CH00065 EQU   @CF00065+2
@CF00078 DC    F'2'
@CH00078 EQU   @CF00078+2
@CF00311 DC    F'3'
@CH00311 EQU   @CF00311+2
@CF00254 DC    F'4'
@CH00254 EQU   @CF00254+2
@CF00053 DC    F'5'
@CF00069 DC    F'8'
@CH00069 EQU   @CF00069+2
@CF00578 DC    F'9'
@CH00578 EQU   @CF00578+2
@CF00580 DC    F'10'
@CH00580 EQU   @CF00580+2
@CF00582 DC    F'11'
@CH00582 EQU   @CF00582+2
@CF00584 DC    F'12'
@CH00584 EQU   @CF00584+2
@CF00586 DC    F'13'
@CF00588 DC    F'14'
@CF00131 DC    F'15'
@CF00076 DC    F'16'
@CF01438 DC    F'73'
@CF01437 DC    F'81'
@CF01488 DC    F'120'
@DATD    DSECT
         DS    0D
DCBPTR   DS    A
SYPRMV01 DS    F
INEXTLST DS    A
INMDCBAD DS    A
INAUTPTR DS    A
INAUTSAV DS    A
INGMWORD DS    F
INALLADR DS    A
INMSGADR DS    A
I        DS    F
BUBUFARA DS    A
BUBCBARA DS    A
RBTXTPTR DS    A
RBCOMENT DS    F
RRTXTPTR DS    A
RRERRSCN DS    F
RINUMBER DS    F
RITEMNUM DS    F
FRFREBCB DS    A
FRCONTRL DS    A
NXLENGTH DS    F
NXTEXPTR DS    A
LINDX    DS    F
LICNVADR DS    A
LISTRLEN DS    F
OPCNVADR DS    A
REBUFPTR DS    A
INAUTSIZ DS    F
SRPARTNO DS    H
@TS00001 DS    CL6
INMVT    DS    CL24
         ORG   INMVT
INMVNUM  DS    FL4
INMVOPT  DS    CL20
         ORG   INMVOPT
INMVCPU  DS    AL4
INMVPAG  DS    AL4
INMVWKL  DS    AL4
INMVCHA  DS    AL4
INMVDEV  DS    AL4
         ORG   INMVT+24
INCOA    DS    CL32
         ORG   INCOA
INCOTCE  DS    FL4
         ORG   INCOTCE
INCOTCEF DS    BL1
         ORG   INCOTCEF
INCOTCEC DS    BL1
         ORG   INCOTCE+1
@NM00028 DS    CL2
INCOTCEL DS    CL1
         ORG   INCOTCEL
@NM00029 DS    BL1
INCOTCEV EQU   INCOTCEL+0
         ORG   INCOA+4
INCOCYC  DS    FL4
         ORG   INCOCYC
INCOCYCF DS    BL1
         ORG   INCOCYCF
INCOCYCC DS    BL1
         ORG   INCOCYC+1
@NM00030 DS    CL1
INCOCYCV DS    FL2
         ORG   INCOA+8
INCOOUT  DS    FL4
         ORG   INCOOUT
INCOOUTF DS    BL1
         ORG   INCOOUTF
INCOOUTC DS    BL1
         ORG   INCOOUT+1
@NM00031 DS    CL2
INCOOUTV DS    CL1
         ORG   INCOA+12
INCOINT  DS    FL4
         ORG   INCOINT
INCOINTF DS    BL1
         ORG   INCOINTF
INCOINTC DS    BL1
         ORG   INCOINT+1
@NM00032 DS    CL1
INCOINTV DS    FL2
         ORG   INCOA+16
INCOREP  DS    FL4
         ORG   INCOREP
INCOREPF DS    BL1
         ORG   INCOREPF
INCOREPC DS    BL1
         ORG   INCOREP+1
@NM00033 DS    CL2
INCOREPL DS    CL1
         ORG   INCOREPL
@NM00034 DS    BL1
INCOREPV EQU   INCOREPL+0
         ORG   INCOA+20
INCOSTP  DS    FL4
         ORG   INCOSTP
INCOSTPF DS    BL1
         ORG   INCOSTPF
INCOSTPC DS    BL1
INCOSTPS EQU   INCOSTPF+0
INCOSTPU EQU   INCOSTPF+0
         ORG   INCOSTP+1
@NM00035 DS    CL1
INCOSTPV DS    FL2
         ORG   INCOA+24
INCOOPI  DS    FL4
         ORG   INCOOPI
INCOOPIF DS    BL1
         ORG   INCOOPIF
INCOOPIC DS    BL1
         ORG   INCOOPI+1
@NM00036 DS    CL2
INCOOPIL DS    CL1
         ORG   INCOOPIL
@NM00037 DS    BL1
INCOOPIV EQU   INCOOPIL+0
         ORG   INCOA+28
INCOMEM  DS    FL4
         ORG   INCOMEM
INCOMEMF DS    BL1
         ORG   INCOMEMF
INCOMEMC DS    BL1
         ORG   INCOMEM+1
@NM00038 DS    CL1
INCOMEMV DS    CL2
         ORG   INCOA+32
INCOXEXT DS    CL24
         ORG   INCOXEXT
INCOXFLG DS    CL1
         ORG   INCOXFLG
@NM00075 DS    BL1
INCOXSRC EQU   INCOXFLG+0
INCOXINV EQU   INCOXFLG+0
INCOXSYN EQU   INCOXFLG+0
         ORG   INCOXEXT+1
INCOXALP DS    CL1
INCOXRES DS    BL2
INCOXER1 DS    CL10
INCOXER2 DS    CL10
         ORG   INCOXEXT+24
SYPRMA01 DS    CL1
         DS    CL3
INOPNADC DS    CL4
INMEMLIB DS    CL88
INMSGDCB DS    CL96
INEXTCIB DS    CL12
IN302LST DS    CL6
         ORG   IN302LST
IN302NUM DS    FL2
IN302LEN DS    FL2
IN302TXT DS    CL2
         ORG   IN302LST+6
INMODULE DS    CL8
         DS    CL2
INCLOSEA DS    CL4
INDDNAME DS    CL8
INUNALLC DS    BL1
         DS    CL3
INAUMOPN DS    CL4
INARDMAC DS    CL20
INREPBUF DS    CL121
         ORG   INREPBUF
INREPLEN DS    FL2
INREPTXT DS    CL119
         ORG   INREPBUF+121
         DS    CL3
INMEMNAM DS    CL8
         ORG   INMEMNAM
INMPREFX DS    CL6
INMEMNUM DS    CL2
         ORG   INMEMNAM+8
INMRGFIN DS    BL1
         DS    CL1
IN304LST DS    CL4
         ORG   IN304LST
IN304PRT DS    FL2
IN304LEN DS    FL2
         ORG   IN304LST+4
INOPNERR DS    BL1
INEOFBIT DS    BL1
INEXTSRC DS    BL1
         DS    CL3
INBQ     DS    CL12
         ORG   INBQ
INBCBNAM DS    CL4
INBCBFRS DS    AL4
INBCBLST DS    AL4
         ORG   INBQ+12
INSCB    DS    CL12
         ORG   INSCB
INCURBCB DS    AL4
INTXTCUR DS    AL4
INBYTLFT DS    FL4
         ORG   INSCB+12
INDUMITM DS    CL12
         ORG   INDUMITM
INIFLAGS DS    CL4
         ORG   INIFLAGS
INENDITM DS    BL1
INSTRM   EQU   INIFLAGS+0
@NM00092 EQU   INIFLAGS+0
         ORG   INDUMITM+4
INRECSTR DS    AL4
INIPARM  DS    AL4
         ORG   INDUMITM+12
SRDUMITM DS    CL12
         ORG   SRDUMITM
SRIFLAGS DS    CL4
         ORG   SRIFLAGS
SRENDITM DS    BL1
SRSTRM   EQU   SRIFLAGS+0
@NM00093 EQU   SRIFLAGS+0
         ORG   SRDUMITM+4
SRRECSTR DS    AL4
SRIPARM  DS    AL4
         ORG   SRDUMITM+12
SRVTXLST DS    CL14
         ORG   SRVTXLST
SRVTPNUM DS    FL2
SRVTLEN  DS    FL2
SRVTEXT  DS    CL10
         ORG   SRVTXLST+14
         DS    CL2
BUBCBCOR DS    CL4
         ORG   BUBCBCOR
BUSUBPOL DS    FL1
BUBUFLEN DS    FL3
         ORG   BUBCBCOR+4
RBFINISH DS    BL1
RBFOUND  DS    BL1
RRFINISH DS    BL1
RRFOUND  DS    BL1
RIINTDEC DS    CL1
RIINTFND DS    BL1
         DS    CL2
FRBCBCOR DS    CL4
         ORG   FRBCBCOR
FRSUBPOL DS    FL1
FRBCBLEN DS    FL3
         ORG   FRBCBCOR+4
NXFRECOR DS    CL4
         ORG   NXFRECOR
NXSUBPOL DS    FL1
NXLEN    DS    FL3
         ORG   NXFRECOR+4
NXFOUND  DS    BL1
LIGOSPFD DS    BL1
LI1STIME DS    BL1
LIONEMSG DS    BL1
LISTRNG  DS    CL6
OP303LST DS    CL6
         ORG   OP303LST
OPTXTNUM DS    FL2
OPTXTLEN DS    FL2
OPTEXT   DS    CL2
         ORG   OP303LST+6
OPTMEMBR DS    CL2
         DS    CL2
RESAVARA DS    CL64
V        DS    BL1
X        DS    BL1
Z        DS    BL1
M        DS    BL1
VAVALCHK DS    BL1
         DS    CL1
VAVTXLST DS    CL4
         ORG   VAVTXLST
VA301INO DS    FL2
VA301LEN DS    FL2
         ORG   VAVTXLST+4
         DS    CL2
TMPMA    DS    CL12
         ORG   TMPMA+0
TMPMOPT  DS    FL4
         ORG   TMPMOPT+0
TMPMCON  DS    BL1
@NM00039 EQU   TMPMOPT+0
         DS    CL2
@NM00040 DS    BL1
         ORG   @NM00040+0
@NM00041 DS    BL1
TMPMSTA  EQU   @NM00040+0
         ORG   TMPMA+4
TMPMSARG DS    CL8
         ORG   TMPMA+60
INVTXLST DS    6A
ININTPTR DS    1A
INERRPTR DS    1A
INALPPTR DS    1A
SRNDXARY DS    10H
LINDXARY DS    10H
LIVTXLST DS    CL10
         ORG   LIVTXLST+0
LIPARTNO DS    FL2
LITXTLEN DS    FL2
LIVARTXT DS    CL6
         ORG   LIVTXLST+60
RE304INO DS    CL132
         ORG   RE304INO+0
RE304PRT DS    FL2
RE304LEN DS    FL2
RE304TXT DS    CL128
         ORG   RE304INO+264
IRBMFINP CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV00904 DC    V(IRBMFANL)
@CA00841 DC    A(SIZDATD)
         DS    0D
INDEFLEN DC    AL4(155)
INFREBUF DC    AL4(MFFREBUF)
OPMAXVAL DC    F'168'
@CC00951 DC    C'00'
@CC01181 DC    C'GO'
@CC00944 DC    C'BCB '
@CC00947 DC    C'IRBMF1'
@CC00987 DC    C'IGNORE'
@CC00946 DC    C'MF1INPUT'
@CC00949 DC    C'IRBMFMPR'
@CC01183 DC    C'IRBMFALL'
@CC01283 DC    C'IRBMFCNV'
@CB00847 DC    B'00000000'
@CB00850 DC    B'10000000'
INPGMDEF DS    CL155
         ORG   INPGMDEF
@NM00078 DC    CL4'CPU,'
@NM00079 DC    CL7'PAGING,'
@NM00080 DC    CL5'CHAN,'
@NM00081 DC    CL13'WKLD(PERIOD),'
@NM00082 DC    CL41'DEVICE(UNITR,TAPE,DASD,GRAPH,COMM,CHRDR),'
@NM00083 DC    CL14'REPORT(DEFER),'
@NM00084 DC    CL10'SYSOUT(A),'
@NM00085 DC    CL9'NORECORD,'
@NM00086 DC    CL14'INTERVAL(15M),'
@NM00087 DC    CL11'CYCLE(250),'
@NM00088 DC    CL10'STOP(15M),'
@NM00089 DC    CL8'OPTIONS,'
@NM00090 DC    CL9'MEMBER(0)'
         ORG   INPGMDEF+155
         DS    CL3
INOPNABN DS    CL4
         ORG   INOPNABN
INOPNFLG DC    B'10010001'
INOPNEXT DC    AL3(MFOPNERR)
         ORG   INOPNABN+4
INPATCH  DS    CL800
OPSUBTAB DC    AL4(OPCHRDR)
         DC    AL4(OPWKLD1)
         DC    AL4(OPWKLD2)
         DC    AL4(OPWKLD3)
         DC    AL4(OPWKLD4)
         DC    AL4(OPPAGING)
         DC    AL4(OPNOPAG)
         DC    AL4(OPCPU)
         DC    AL4(OPNOCPU)
         DC    AL4(OPCHAN)
         DC    AL4(OPNOCHAN)
         DC    AL4(OPINTVAL)
         DC    AL4(OPNOCHR)
         DC    AL4(OPTAPE)
         DC    AL4(OPGRAPH)
         DC    AL4(OPUNRC)
         DC    AL4(OPTPCOM)
         DC    AL4(OPDASD)
         DC    AL4(OPNOTAPE)
         DC    AL4(OPNOGRAP)
         DC    AL4(OPNOUNRC)
         DC    AL4(OPNOTPCM)
         DC    AL4(OPNODASD)
         DC    AL4(OPNODEV)
         DC    AL4(OPRPRT1)
         DC    AL4(OPRPRT2)
         DC    AL4(OPNORPT)
         DC    AL4(OPNOSTOP)
         DC    AL4(OPTRACE)
         DC    AL4(OPNOTRCE)
         DC    AL4(OPOPI)
         DC    AL4(OPNOPI)
         DC    AL4(OPSTOP1)
         DC    AL4(OPSTOP2)
         DC    AL4(OPCYCLE)
         DC    AL4(OPERR)
         DC    AL4(OPSYSOUT)
         DC    AL4(OPMEMBER)
IRBMFINP CSECT
INEXCIB  EXTRACT 0,,FIELDS=(COMM),MF=L
IRBMFINP CSECT
INMSGOPN OPEN  (INSTCDCB,(OUTPUT)),MF=L
IRBMFINP CSECT
INOPNSDC OPEN  (INSTCLIB,(INPUT)),MF=L
IRBMFINP CSECT
         READ  INRDMAC,SF,MF=L
IRBMFINP CSECT
*                                 /* STATIC DCB AREA FOR WTD */
INSTCDCB DCB   DDNAME=MF1INPUT,DSORG=PS,LRECL=121,MACRF=PM,            *
               BLKSIZE=1693,RECFM=VBA
IRBMFINP CSECT
*                                 /* STATIC DCB AREA FOR LIB D.S. */
INSTCLIB DCB   DDNAME=IEFRDER,DSORG=PO,EXLST=INOPNABN,LRECL=80,        *
               MACRF=(R)
IRBMFINP CSECT
*                                    /* LIST FORM FOR CLOSE */
INCLOSE  CLOSE (INSTCLIB),MF=L
IRBMFINP CSECT
INSZDADR DC    V(SIZDATD)
IRBMFINP CSECT
RBCOMBEG DC    C'/*'
RBCOMEND DC    C'*/'
IRBMFINP CSECT
*                                      /* COMMENT DELIMITER */
RRCOMBEG DC    C'/*'
IRBMFINP CSECT
*                                      /* MFSYNTAB - SYNTAX TABLE */
*                                                                     *
* <INPUT>::= BLANK <OPTION> |
*            <INPUT><DELIM><OPTION> |
*            <INPUT> E
*                                                                     *
* <OPTION>::= WKLD <LP> <WKLDVAL> <RP> |
*             NOWKLD |
*             PAGING |
*             NOPAGING |
*             CPU |
*             NOCPU |
*             CHAN |
*             NOCHAN |
*             DEVICE <LP> <DEVVAL> <RP> |
*             NODEVICE |
*             REPORT <LP> <RPTVAL> <RP> |
*             NOREPORT |
*             INTERVAL <LP> <INTVAL> <RP> |
*             CYCLE <LP> <CYCVAL> <RP> |
*             SYSOUT <LP> <OUTVAL> <RP> |
*             STOP <LP> <STOPVAL> <RP> |
*             NOSTOP |
*             RECORD |
*             NORECORD |
*             OPTIONS |
*             OPTN |
*             NOOPTIONS |
*             NOOPTN |
*             MEMBER <LP> <MEMVAL> <RP> |
*             E |
*             BLANK
*                                                                     *
* <LP>::= BLANK ( BLANK
*                                                                     *
* <RP>::= BLANK )
*                                                                     *
* <DELIM>::= BLANK , BLANK
*             BLANK1
*                                                                     *
* <WKLDVAL>::= SYSTEM |
*              GROUP |
*              PERIOD
*                                                                     *
* <DEVVAL>::= <VALUE> |
*             <DEVVAL> <DELIM> <VALUE> |
*             <DEVVAL> E1
*                                                                     *
* <VALUE>::= TAPE |
*            GRAPH |
*            UNITR |
*            COMM |
*            DASD |
*            CHRDR |
*            NOTAPE |
*            NOGRAPH |
*            NOUNITR |
*            NOCOMM |
*            NODASD |
*            NOCHRDR |
*            E1
*            BLANK
*                                                                     *
* <RPTVAL>::= DEFER |
*             REALTIME
*                                                                     *
* <INTVAL>::= V M |
*             V
*                                                                     *
* <CYCVAL>::= V
*                                                                     *
* <OUTVAL>::= A
*                                                                     *
* <STOPVAL>::= V H |
*              V M |
*              V
*                                                                     *
* <MEMVAL::= V
*                                                                   *
MFSYNTAB DS  0F
*                                                                     *
SYSTRENT MFSYSTR 1,SYALT01,SYALT02 INITIAL STRUCTURE - RECURSIVE
*                                                                     *
SYSTR01  MFSYSTR 0,SYALT03,0
*                                                                     *
* WKLDVAL IS A DEFINED TYPE WHICH CALLS FOR A STRUCTURE ENTRY. IT WILL*
* POINT TO AN ALTERNATIVE LIST WHICH WILL LIST THE VARIOUS VALUES FOR
* THE'WORKLOAD' OPTION.                                               *
SYSTR02  MFSYSTR 0,SYALT04,0
*                                                                     *
* DEVVAL    IS A DEFINED TYPE WHICH CALLS FOR A STRUCTURE ENTRY. IT   *
* WILL POINT TO AN ALTERNATIVES LIST. THIS STRUCTURE IS RECURSIVE.    *
SYSTR03  MFSYSTR 0,SYALT05,SYALT06
*                                                                     *
* SYSTR04 LABEL IS NOT USED                                           *
*                                                                     *
* STRUCTURE ENTRY FOR 'VALUE' WHICH IS AN ALTERNATIVE FOR 'DEVVAL'    *
*                                                                     *
SYSTR05  MFSYSTR 0,SYALT08,0
*                                                                     *
* STRUCTURE ENTRY FOR 'INTVAL' WHICH IS AN ITEM FOR 'INTERVAL'        *
*                                                                     *
SYSTR06  MFSYSTR 0,SYALT09,0
*                                                                     *
* STRUCTURE ENTRY FOR 'CYCVAL' WHICH IS AN ITEM FOR 'CYCLE'           *
*                                                                     *
SYSTR07  MFSYSTR 0,SYALT14,0
*                                                                     *
* STRUCTURE ENTRY FOR 'OUTVAL' WHICH IS AN ITEM FOR 'SYSOUT'          *
*                                                                     *
SYSTR08  MFSYSTR 0,SYALT10,0
*                                                                     *
*STRUCTURE ENTRY FOR 'RPTVAL' WHICH IS AN ITEM FOR 'REPORT'           *
*                                                                     *
SYSTR09  MFSYSTR 0,SYALT11,0
*                                                                     *
* STRUCTURE ENTRY FOR 'STOPVAL' WHICH IS AN ITEM FOR 'STOPVAL'        *
*                                                                     *
SYSTR10  MFSYSTR 0,SYALT12,0
*                                                                     *
* STRUCTURE ENTRY FOR 'DELIM'                                         *
SYSTR11  MFSYSTR 0,SYALT13,0
*                                                                     *
* STRUCTURE ENTRY FOR LEFT PARENTHESIS                                *
*                                                                     *
SYSTR12  MFSYSTR 0,SYALT15,0
*                                                                     *
* STRUCTURE ENTRY FOR RIGHT PARENTHESIS                               *
*                                                                     *
SYSTR13  MFSYSTR 0,SYALT16,0
*                                                                     *
* LIST OF REGULAR ALTERNATIVES FOR VALID INPUT. IF POINTS TO A LIST   *
* OF ITEMS EXCEPTABLE AS VALID INPUT.                                 *
*                                                                     *
SYALT01  MFSYALT 1,SYITME01,0,0 'BLANK' FOLLOWED BY OPTION
*                                                                     *
* RECURSIVE ALTERNATIVE LIST FOR 'INPUT'                              *
*                                                                     *
SYALT02 MFSYALT 0,SYITME51,0,0        'INPUT' FOLLOWED BY 'DELIM'
*                                      FOLLOWED BY 'OPTION' ALTERNATIVE
        MFSYALT 1,SYITME22,MFOPINIT,SYPRMI21
*                                      'INPUT'FOLLOWED BY 'ERROR'
*                                      ALTERNATIVE
* ALTERNATIVE LIST FOR VALID 'OPTION' TERMS. IT POINTS TO A LIST OF   *
* ITEMS DESCRIBING 'OPTION' TERMS.                                    *
*                                                                     *
SYALT03  MFSYALT 0,SYITME02,0,0               'WKLD' OPTION
         MFSYALT 0,SYITME03,MFOPINIT,SYPRMI02 'NOWKLD' OPTION
         MFSYALT 0,SYITME04,MFOPINIT,SYPRMI03 'PAGING' OPTION
         MFSYALT 0,SYITME05,MFOPINIT,SYPRMI04 'NOPAGING' OPTION
         MFSYALT 0,SYITME06,MFOPINIT,SYPRMI05 'CPU' OPTION
         MFSYALT 0,SYITME07,MFOPINIT,SYPRMI06 'NOCPU' OPTION
         MFSYALT 0,SYITME08,MFOPINIT,SYPRMI07 'CHAN'OPTION
         MFSYALT 0,SYITME09,MFOPINIT,SYPRMI08 'NOCHAN' OPTION
         MFSYALT 0,SYITME10,0,0               'DEVICE' OPTION
         MFSYALT 0,SYITME11,MFOPINIT,SYPRMI10 'NODEVICE' OPTION
         MFSYALT 0,SYITME12,0,0               'INTERVAL' OPTION
         MFSYALT 0,SYITME13,0,0               'CYCLE' OPTION
         MFSYALT 0,SYITME14,0,0               'SYSOUT' OPTION
         MFSYALT 0,SYITME15,0,0               'REPORT' OPTION
         MFSYALT 0,SYITME16,MFOPINIT,SYPRMI15 'NOREPORT' OPTION
         MFSYALT 0,SYITME17,0,0               'STOP' OPTION
         MFSYALT 0,SYITME18,MFOPINIT,SYPRMI17 'NOSTOP' OPTION
         MFSYALT 0,SYITME47,MFOPINIT,SYPRMI11 'TRACE' OPTION
         MFSYALT 0,SYITME48,MFOPINIT,SYPRMI12 'NOTRACE' OPTION
         MFSYALT 0,SYITME19,MFOPINIT,SYPRMI18 'OPI' OPTION
         MFSYALT 0,SYITME58,MFOPINIT,SYPRMI18 'OPTN' OPTION
         MFSYALT 0,SYITME20,MFOPINIT,SYPRMI19 'NOOPI' OPTION
         MFSYALT 0,SYITME59,MFOPINIT,SYPRMI19 'NOOPTN' OPTION
         MFSYALT 0,SYITME21,MFOPINIT,SYPRMI14 'MEMBER' OPTION
         MFSYALT 0,SYITME22,MFOPINIT,SYPRMI21 'ERROR'
         MFSYALT 1,SYITME55,0,0               'BLANK'
*         THE LIST WILL POINT TO AN ITEM LIST DESCRIBING THE ALTERNA- *
* TIVES FOR THE WKLD OPTION S VALUES.                                 *
*                                                                     *
SYALT04  MFSYALT 0,SYITME23,MFOPINIT,SYPRMI22 'SYSTEM' ENTRY
         MFSYALT 0,SYITME24,MFOPINIT,SYPRMI23 'GROUP' ENTRY
         MFSYALT 1,SYITME25,MFOPINIT,SYPRMI24 'PERIOD' ENTRY
*                                                                     *
* REGULAR ALTERNATIVE LIST FOR 'DEVVAL'                               *
*                                                                     *
SYALT05  MFSYALT 1,SYITME27,0,0               ' VALUE'ALTERNATIVE
* RECURSIVE ALTERNATIVE LIST FOR 'DEVVAL'                             *
*                                                                     *
SYALT06  MFSYALT 0,SYITME26,0,0       'DELIM' FOLLOWED BY 'VALUE'
         MFSYALT 1,SYITME40,MFOPINIT,SYPRMI21 'ERROR' ALTERNATIVE
*                                                                     *
* SYALT07 LABEL IS NOT USED                                           *
*                                                                     *
* ALTERNATIVES FOR 'VALUE'
SYALT08  MFSYALT 0,SYITME28,MFOPINIT,SYPRMI27 'TAPE' ALTERNATIVE
         MFSYALT 0,SYITME29,MFOPINIT,SYPRMI29 'GRAPH' ALTERNATIVE
         MFSYALT 0,SYITME30,MFOPINIT,SYPRMI30 'UNITR' ALTERNATIVE
         MFSYALT 0,SYITME31,MFOPINIT,SYPRMI31 'TP' ALTERNATIVE
         MFSYALT 0,SYITME32,MFOPINIT,SYPRMI32 'DASD' ALTERNATIVE
         MFSYALT 0,SYITME33,MFOPINIT,SYPRMI33 'NOTAPE' ALTERNATIVE
         MFSYALT 0,SYITME34,MFOPINIT,SYPRMI34 'NOGRAPH' ALTERNATIVE
         MFSYALT 0,SYITME35,MFOPINIT,SYPRMI35 'NOUNITR' ALTERNATIVE
         MFSYALT 0,SYITME36,MFOPINIT,SYPRMI36 'NOTP' ALTERNATIVE
         MFSYALT 0,SYITME37,MFOPINIT,SYPRMI37 'NODASD' ALTERNATIVE
         MFSYALT 0,SYITME54,MFOPINIT,SYPRMI01 'CHRDR' OPTION
         MFSYALT 0,SYITME53,MFOPINIT,SYPRMI09 'NOCHRDR' OPTION
         MFSYALT 0,SYITME40,MFOPINIT,SYPRMI21 'ERROR' ALTERNATIVE
         MFSYALT 1,SYITME55,0,0        'BLANK' ALTERNATIVE
*                                                                     *
* ALTERNATIVE LIST FOR INTVAL                                         *
*                                                                     *
SYALT09  MFSYALT 0,SYITME46,MFOPINIT,SYPRMI39 'VALUE' M ALTERNATIVE
         MFSYALT 1,SYITME41,MFOPINIT,SYPRMI39 'VALUE' ALTERNATIVE
*                                                                     *
* ALTERNATIVE LIST FOR 'OUTVAL'                                       *
*                                                                     *
SYALT10  MFSYALT 1,SYITME42,MFOPINIT,SYPRMI13 'A' (ALPHA) ALTERNATIVE
*                                                                     *
* ALTERNATIVE LIST FOR 'RPTVAL'                                       *
*                                                                     *
SYALT11  MFSYALT 0,SYITME43,MFOPINIT,SYPRMI41 'DEFER' ALTERNATIVE
         MFSYALT 1,SYITME44,MFOPINIT,SYPRMI42 'REALTIME' ALTERNATIVE
*                                                                     *
* ALTERNATIVE LIST FOR 'STOPVAL'                                      *
*                                                                     *
SYALT12  MFSYALT 0,SYITME45,MFOPINIT,SYPRMI43 'VALUE' H ALTERNATIVE
         MFSYALT 0,SYITME46,MFOPINIT,SYPRMI44 'VALUE'M ALTERNATIVE
         MFSYALT 1,SYITME41,MFOPINIT,SYPRMI44 'VALUE' ALTERNATIVE
* ALTERNATIVE LIST FOR 'DELIM'
SYALT13  MFSYALT 0,SYITME49,0,0        'BLANK' COMMA 'BLANK'
         MFSYALT 1,SYITME50,0,0        'DELIMITER BLANK'
*                                                                     *
* ALTERNATIVE LIST FOR 'CYCVAL'                                       *
*                                                                     *
SYALT14  MFSYALT 1,SYITME52,MFOPINIT,SYPRMI38 'CYCVAL' ALTERNATIVE
*                                                                     *
* ALTERNATIVE LIST FOR LEFT PARENTHESIS                               *
*                                                                     *
SYALT15  MFSYALT 1,SYITME56,0,0
*                                                                     *
* ALTERNATIVE LIST FOR RIGHT PARENTHESIS
*                                                                     *
SYALT16  MFSYALT 1,SYITME57,0,0
*                                                                     *
* THE ITEM LIST DEFINES AS VALID INPUT: 'BLANK' OR NO BLANK           *
* FOLLOWED BY 'OPTION' (A DEFINED TYPE STRUCTURE)                     *
*                                                                     *
SYITME01 MFSYITM 0,MFRBLANK,1,SYPRMB01 'BLANK' ITEM
         MFSYITM 1,SYSTR01,0,0 'OPTION' ITEM
*                                                                     *
* ITEM LIST ENTRY FOR 'WKLD' FOLLOWED BY A'(WKLDVAL)'(A DEFINED TYPE) *
*                                                                     *
SYITME02 MFSYITM 0,MFRTEXT,1,SYPRMT01  'WKLD' ITEM ENTRY
         MFSYITM 0,SYSTR12,0,0         LEFT PARENTHESIS
         MFSYITM 0,SYSTR02,0,0         'WKLDVAL' CALLS FOR STRUCTURE
*                                      ENTRY
         MFSYITM 1,SYSTR13,0,0         RIGHT PARENTHESIS
*                                                                     *
* ITEM LIST ENTRY FOR 'NOWKLD' OPTION                                 *
SYITME03 MFSYITM 1,MFRTEXT,1,SYPRMT07
*                                                                     *
* ITEM LIST ENTRY FOR 'PAGING' OPTION
*                                                                     *
SYITME04 MFSYITM 1,MFRTEXT,1,SYPRMT08
*                                                                     *
* ITEM LIST ENTRY FOR 'NOPAGING' OPTION                               *
*                                                                     *
SYITME05 MFSYITM 1,MFRTEXT,1,SYPRMT09
*                                                                     *
* ITEM LIST ENTRY FOR 'CPU' OPTION                                    *
*                                                                     *
SYITME06 MFSYITM 1,MFRTEXT,1,SYPRMT10
*                                                                     *
* ITEM LIST ENTRY FOR 'NOCPU' OPTION                                  *
*                                                                     *
SYITME07 MFSYITM 1,MFRTEXT,1,SYPRMT11
*                                                                     *
* ITEM LIST ENTRY FOR 'CHAN' OPTION                                   *
*                                                                     *
SYITME08 MFSYITM 1,MFRTEXT,1,SYPRMT12
*                                                                     *
* ITEM LIST ENTRY FOR 'NOCHAN' OPTION                                 *
*                                                                     *
SYITME09 MFSYITM 1,MFRTEXT,1,SYPRMT13
*                                                                     *
* ITEM LIST ENTRY FOR 'DEVICE' FOLLOWED BY A '(DEVICEVAL)'(A DEFINED  *
* TYPE)                                                               *
SYITME10 MFSYITM 0,MFRTEXT,1,SYPRMT42  'DEVICE' ITEM ENTRY
         MFSYITM 0,SYSTR12,0,0         LEFT PARENTHESIS
         MFSYITM 0,SYSTR03,0,0         'DEVVAL'CALLS FOR STRUCTURE
*                                      ENTRY
         MFSYITM 1,SYSTR13,0,0         RIGHT PARENTHESIS
* ITEM LIST ENTRY FOR 'NODEVICE' OPTION                               *
*                                                                     *
SYITME11 MFSYITM 1,MFRTEXT,1,SYPRMT24
*                                                                     *
* ITEM LIST ENTRY FOR 'INTERVAL' FOLLOWED BY 'INTVAL' OPTION          *
*                                                                     *
SYITME12 MFSYITM 0,MFRTEXT,1,SYPRMT25 'INTERVAL' ITEM
         MFSYITM 0,SYSTR12,0,0         LEFT PARENTHESIS
         MFSYITM 0,SYSTR06,0,0         'INTVAL' IS A DEFINED TYPE ITEM
         MFSYITM 1,SYSTR13,0,0         RIGHT PARENTHESIS
*                                                                     *
* ITEM LIST ENTRY FOR 'CYCLE' FOLLOWED BY 'CYCVAL' OPTION             *
*                                                                     *
SYITME13 MFSYITM 0,MFRTEXT,1,SYPRMT26 'CYCLE' ITEM
         MFSYITM 0,SYSTR12,0,0         LEFT PARENTHESIS
         MFSYITM 0,SYSTR07,0,0        'CYCVAL' IS A DEFINED TYPE ITEM
         MFSYITM 1,SYSTR13,0,0         RIGHT PARENTHESIS
*                                                                     *
* ITEM LIST ENTRY FOR 'SYSOUT' FOLLOWED BY 'OUTVAL'                   *
*                                                                     *
SYITME14 MFSYITM 0,MFRTEXT,1,SYPRMT27 'SYSOUT' ITEM
         MFSYITM 0,SYSTR12,0,0         LEFT PARENTHESIS
         MFSYITM 0,SYSTR08,0,0        'OUTVAL' IS A DEFINED TYPE ITEM
         MFSYITM 1,SYSTR13,0,0         RIGHT PARENTHESIS
*                                                                     *
* ITEM LIST ENTRY FOR 'REPORT' FOLLOWED BY 'RPTVAL'                   *
*                                                                     *
SYITME15 MFSYITM 0,MFRTEXT,1,SYPRMT28        'REPORT' ITEM
         MFSYITM 0,SYSTR12,0,0         LEFT PARENTHESIS
         MFSYITM 0,SYSTR09,0,0         'RPTVAL' IS A DEFINED TYPE
         MFSYITM 1,SYSTR13,0,0         RIGHT PARENTHESIS
*                                                                     *
* ITEM LIST ENTRY FOR 'NOREPORT' OPTION                               *
*                                                                     *
SYITME16 MFSYITM 1,MFRTEXT,1,SYPRMT31
*                                                                     *
* ITEM LIST ENTRY FOR 'STOP' FOLLOWED BY 'STOPVAL' OPTION             *
*                                                                     *
SYITME17 MFSYITM 0,MFRTEXT,1,SYPRMT32        'STOP' ITEM
         MFSYITM 0,SYSTR12,0,0         LEFT PARENTHESIS
         MFSYITM 0,SYSTR10,0,0               'STOPVAL' IS A DEFINED
         MFSYITM 1,SYSTR13,0,0         RIGHT PARENTHESIS
*                                            TYPE
* ITEM LIST ENTRY FOR 'NOSTOP'OPTION                                  *
SYITME18 MFSYITM 1,MFRTEXT,1,SYPRMT33
*                                                                     *
* ITEM LIST ENTRY FOR 'OPI'OPTION                                     *
SYITME19 MFSYITM 1,MFRTEXT,1,SYPRMT34
*                                                                     *
*                                                                     *
* ITEM LIST ENTRY 'NOOPI' OPTION                                      *
*                                                                     *
SYITME20 MFSYITM 1,MFRTEXT,1,SYPRMT35
*                                                                     *
* ITEM LIST ENTRY FOR 'MEMBER'FOLLOWED BY 'MEMVAL'                    *
*                                                                     *
SYITME21 MFSYITM 0,MFRTEXT,1,SYPRMT36  'MEMBER' ITEM
         MFSYITM 0,SYSTR12,0,0         LEFT PARENTHESIS
         MFSYITM 0,MFRINTGR,1,SYINTGRV 'MEMVAL'
         MFSYITM 1,SYSTR13,0,0         RIGHT PARENTHESIS
*                                                                     *
* ITEM LIST ENTRY FOR 'ERROR'                                         *
*                                                                     *
*                                                                     *
SYITME22 MFSYITM 1,MFRRERR,1,SYPRME01
* ITEM LIST FOR VALID 'WKLD' VALUES (WKLDVAL). EACH ENTRY POINTS TO A *
* A PARAMETER LIST DESCIBING THE VARIOUS VALUES. THE PARAMETER LIST IS*
* NEEDED BY A RECOGNIZER ROUTINE (ALSO POINTED TO BY EACH ITEM LIST   *
* ENTRY) TO VERIFY THE INPUT SOURCE S TEXT.                           *
SYITME23 MFSYITM 1,MFRTEXT,1,SYPRMT04 'SYSTEM' ENTRY
SYITME24 MFSYITM 1,MFRTEXT,1,SYPRMT05 'GROUP' ENTRY
SYITME25 MFSYITM 1,MFRTEXT,1,SYPRMT06 'PERIOD' ENTRY
*                                                                     *
* ITEM LIST FOR DEVVAL (RECURSIVE)                                    *
*                                                                     *
SYITME26 MFSYITM 0,SYSTR11,0,0         'DELIM' ITEM
         MFSYITM 1,SYSTR05,0,0         'VALUE' ITEM
*                                                                     *
SYITME27 MFSYITM 1,SYSTR05,0,0         VALUE ITEM - DEFINED TYPE
*                                                                     *
* 'VALUE' ITEM LIST.                                                  *
*                                                                     *
SYITME28 MFSYITM 1,MFRTEXT,1,SYPRMT14  'TAPE' ITEM
SYITME29 MFSYITM 1,MFRTEXT,1,SYPRMT15  'GRAPH' ITEM
SYITME30 MFSYITM 1,MFRTEXT,1,SYPRMT16  'UNITR' ITEM
SYITME31 MFSYITM 1,MFRTEXT,1,SYPRMT17  'COMM' ITEM
SYITME32 MFSYITM 1,MFRTEXT,1,SYPRMT18  'DASD' ITEM
SYITME33 MFSYITM 1,MFRTEXT,1,SYPRMT19  'NOTAPE' ITEM
SYITME34 MFSYITM 1,MFRTEXT,1,SYPRMT20  'NOGRAPH' ITEM
SYITME35 MFSYITM 1,MFRTEXT,1,SYPRMT21  'NOUNITR' ITEM
SYITME36 MFSYITM 1,MFRTEXT,1,SYPRMT22  'NOCOMM' ITEM
SYITME37 MFSYITM 1,MFRTEXT,1,SYPRMT23  'NODASD' ITEM
SYITME38 MFSYITM 1,MFRRERR,1,SYPRME02 'ERROR' ITEM
*                                                                     *
* ITEM LIST FOR 'DELIM'                                               *
SYITME39 MFSYITM 1,SYSTR11,0,0         'DELIM' IS A DEFINED TYPE
*                                                                     *
* ITEM LIST FOR SPECIAL ERROR                                         *
*                                                                     *
SYITME40 MFSYITM 1,MFRRERR,1,SYPRME02  'ERROR' ITEM
*                                                                     *
* ITEM LIST FOR AN INTEGER VALUE                                      *
*                                                                     *
SYITME41 MFSYITM 1,MFRINTGR,1,SYINTGRV
*                                                                     *
* ITEM LIST FOR 'OUTVAL'                                              *
*                                                                     *
SYITME42 MFSYITM 1,MFRALPHA,1,SYALPHAV 'ALPHA' VALUE
*                                                                     *
* ITEM LIST ENTRY FOR 'RPTVAL'                                        *
*                                                                     *
SYITME43 MFSYITM 1,MFRTEXT,1,SYPRMT29  'DEFER' ITEM
SYITME44 MFSYITM 1,MFRTEXT,1,SYPRMT30  'REALTIME' ITEM
*                                                                     *
* ITEM LIST ENTRY FOR 'STOPVAL' - 'V' FOLLOWED BY 'H'                 *
*                                                                     *
SYITME45 MFSYITM 0,MFRINTGR,1,SYINTGRV 'V' ITEM
         MFSYITM 1,MFRTEXT,1,SYPRMT37  'H' ITEM
*                                                                     *
*                               - 'V' FOLLOWED BY 'M'                 *
*                                                                     *
SYITME46 MFSYITM 0,MFRINTGR,1,SYINTGRV 'V' ITEM
         MFSYITM 1,MFRTEXT,1,SYPRMT38  'M' ITEM
*                                                                     *
* ITEM LIST ENTRY FOR'TRACE'                                          *
*                                                                     *
SYITME47 MFSYITM 1,MFRTEXT,1,SYPRMT39
*                                                                     *
* ITEM LIST ENTRY FOR 'NOTRACE'                                       *
*                                                                     *
SYITME48 MFSYITM 1,MFRTEXT,1,SYPRMT40
*                                                                     *
* ITEM LIST ENTRY FOR 'BLANK' COMMA 'BLANK'                           *
*                                                                     *
SYITME49 MFSYITM 0,MFRBLANK,1,SYPRMB01 'BLANK' ITEM
         MFSYITM 0,MFRTEXT,1,SYPRMT41  COMMA ITEM
         MFSYITM 1,MFRBLANK,1,SYPRMB01 'BLANK' ITEM
*                                                                     *
* ITEM LIST ENTRY FOR 'DELIMITER BLANK'                               *
*                                                                     *
SYITME50 MFSYITM 1,MFRBLANK,1,SYPRMB02
*                                                                     *
* ITEM LIST ENTRY FOR 'INPUT' FOLLOWED BY 'DELIM' FOLLOWED BY 'OPTION'*
*                                                                     *
SYITME51 MFSYITM 0,SYSTR11,0,0         'DELIM' IS A DEFINED TYPE
         MFSYITM 1,SYSTR01,0,0         'OPTION' IS A DEFINED TYPE
*                                                                     *
* ITEM LIST FOR CYCLE 'VALUE'                                         *
*                                                                     *
SYITME52 MFSYITM 1,MFRINTGR,1,SYINTGRV 'CYCVAL'
*                                                                     *
* ITEM LIST FOR 'NOCHRDR'                                             *
*                                                                     *
SYITME53 MFSYITM 1,MFRTEXT,1,SYPRMT44
*                                                                     *
* ITEM LIST FOR 'CHRDR'                                               *
*                                                                     *
SYITME54 MFSYITM 1,MFRTEXT,1,SYPRMT43
*                                                                     *
* ITEM LIST FOR 'BLANK'                                               *
*                                                                     *
SYITME55 MFSYITM 1,MFRBLANK,1,SYPRMB01
*                                                                     *
* ITEM LIST FOR LEFT PARENTHESIS                                      *
*                                                                     *
SYITME56 MFSYITM 0,MFRBLANK,1,SYPRMB01 'BLANK'
         MFSYITM 0,MFRTEXT,1,SYPRMT02  '('
         MFSYITM 1,MFRBLANK,1,SYPRMB01 'BLANK'
*                                                                     *
* ITEM LIST FOR RIGHT PARENTHESIS                                     *
*                                                                     *
SYITME57 MFSYITM 0,MFRBLANK,1,SYPRMB01 'BLANK'
         MFSYITM 1,MFRTEXT,1,SYPRMT03  ')'
*                                                                     *
* ITEM LIST FOR OPTIONS (OPTN)                                        *
*                                                                     *
SYITME58 MFSYITM 1,MFRTEXT,1,SYPRMT45
*                                                                     *
* ITEM LIST FOR NOOPTIONS (NOOPTN)                                    *
*                                                                     *
SYITME59 MFSYITM 1,MFRTEXT,1,SYPRMT46
*                                                                     *
* PARAMETER LIST FOR BLANK RECOGNIZER (GENERAL)                       *
*                                                                     *
SYPRMB01 DC    AL.1(0)            INDICATES GENERAL BLANK RECOGNIZER
* PARAMETER LIST FOR DELIMITER BLANK RECOGNIZER. RECOGNIZES ANY NON-  *
* ZERO NUMBER OF BLANKS AND/OR COMMENTS.
*                                                                     *
SYPRMB02 DC    AL.1(1)            INDICATES DELIMITER BLANK RECOGNIZER*
* PARAMETER LISTS FOR TEXT RECOGNIZER
SYPRMT01 DC    AL1(L'SYTEXT01)
SYTEXT01 DC    C'WKLD'            WKLD OPTION
SYPRMT02 DC    AL1(L'SYTEXT02)
SYTEXT02 DC    C'('               LEFT PARENTHESIS
SYPRMT03 DC    AL1(L'SYTEXT03)
SYTEXT03 DC    C')'               RIGHT PARENTHESIS
SYPRMT04 DC    AL1(L'SYTEXT04)
SYTEXT04 DC    C'SYSTEM'          WKLD OPTION VALUE
SYPRMT05 DC    AL1(L'SYTEXT05)
SYTEXT05 DC    C'GROUP'           WKLD OPTION VALUE
SYPRMT06 DC    AL1(L'SYTEXT06)
SYTEXT06 DC    C'PERIOD'          WKLD OPTION VALUE
SYPRMT07 DC    AL1(L'SYTEXT07)
SYTEXT07 DC    C'NOWKLD'          NOWKLD OPTION
SYPRMT08 DC    AL1(L'SYTEXT08)
SYTEXT08 DC    C'PAGING'          PAGING OPTION
SYPRMT09 DC    AL1(L'SYTEXT09)
SYTEXT09 DC    C'NOPAGING'        NOPAGING OPTION
SYPRMT10 DC    AL1(L'SYTEXT10)
SYTEXT10 DC    C'CPU'             CPU OPTION
SYPRMT11 DC    AL1(L'SYTEXT11)
SYTEXT11 DC    C'NOCPU'           NOCPU OPTION
SYPRMT12 DC    AL1(L'SYTEXT12)
SYTEXT12 DC    C'CHAN'            CHANNEL OPTION
SYPRMT13 DC    AL1(L'SYTEXT13)
SYTEXT13 DC    C'NOCHAN'          NO CHANNEL OPTION
SYPRMT14 DC    AL1(L'SYTEXT14)
SYTEXT14 DC    C'TAPE'            DEVICE OPTION VALUE
SYPRMT15 DC    AL1(L'SYTEXT15)
SYTEXT15 DC    C'GRAPH'           DEVICE OPTION VALUE
SYPRMT16 DC    AL1(L'SYTEXT16)
SYTEXT16 DC    C'UNITR'           DEVICE OPTION VALUE
SYPRMT17 DC    AL1(L'SYTEXT17)
SYTEXT17 DC    C'COMM'            DEVICE OPTION VALUE
SYPRMT18 DC    AL1(L'SYTEXT18)
SYTEXT18 DC    C'DASD'            DEVICE OPTION VALUE
SYPRMT19 DC    AL1(L'SYTEXT19)
SYTEXT19 DC    C'NOTAPE'          DEVICE OPTION VALUE
SYPRMT20 DC    AL1(L'SYTEXT20)
SYTEXT20 DC    C'NOGRAPH'         DEVICE OPTION VALUE
SYPRMT21 DC    AL1(L'SYTEXT21)
SYTEXT21 DC    C'NOUNITR'         DEVICE OPTION VALUE
SYPRMT22 DC    AL1(L'SYTEXT22)
SYTEXT22 DC    C'NOCOMM'          DEVICE OPTION VALUE
SYPRMT23 DC    AL1(L'SYTEXT23)
SYTEXT23 DC    C'NODASD'          DEVICE OPTION VALUE
SYPRMT24 DC    AL1(L'SYTEXT24)
SYTEXT24 DC    C'NODEVICE'        NODEVICE OPTION
SYPRMT25 DC    AL1(L'SYTEXT25)
SYTEXT25 DC    C'INTERVAL'        INTERVAL OPTION
SYPRMT26 DC    AL1(L'SYTEXT26)
SYTEXT26 DC    C'CYCLE'           CYCLE OPTION
SYPRMT27 DC    AL1(L'SYTEXT27)
SYTEXT27 DC    C'SYSOUT'          SYSOUT OPTION
SYPRMT28 DC    AL1(L'SYTEXT28)
SYTEXT28 DC    C'REPORT'          REPORT OPTION
SYPRMT29 DC    AL1(L'SYTEXT29)
SYTEXT29 DC    C'DEFER'           REPORT OPTION VALUE
SYPRMT30 DC    AL1(L'SYTEXT30)
SYTEXT30 DC    C'REALTIME'        REPORT OPTION VALUE
SYPRMT31 DC    AL1(L'SYTEXT31)
SYTEXT31 DC    C'NOREPORT'        NO REPORT OPTION
SYPRMT32 DC    AL1(L'SYTEXT32)
SYTEXT32 DC    C'STOP'            STOP OPTION
SYPRMT33 DC    AL1(L'SYTEXT33)
SYTEXT33 DC    C'NOSTOP'          NOSTOP OPTION
SYPRMT34 DC    AL1(L'SYTEXT34)
SYTEXT34 DC    C'OPTIONS'         OPTIONS OPTION
SYPRMT35 DC    AL1(L'SYTEXT35)
SYTEXT35 DC    C'NOOPTIONS'       NOOPTIONS OPTION
SYPRMT36 DC    AL1(L'SYTEXT36)
SYTEXT36 DC    C'MEMBER'          MEMBER OPTION
SYPRMT37 DC    AL1(L'SYTEXT37)
SYTEXT37 DC    C'H'               STOP VALUE
SYPRMT38 DC    AL1(L'SYTEXT38)
SYTEXT38 DC    C'M'               STOP VALUE
SYPRMT39 DC    AL1(L'SYTEXT39)
SYTEXT39 DC    C'RECORD'          RECORD OPTION
SYPRMT40 DC    AL1(L'SYTEXT40)
SYTEXT40 DC    C'NORECORD'        NORECORD OPTION
SYPRMT41 DC    AL1(L'SYTEXT41)
SYTEXT41 DC    C','               COMMA
SYPRMT42 DC    AL1(L'SYTEXT42)
SYTEXT42 DC    C'DEVICE'          DEVICE OPTION
SYPRMT43 DC    AL1(L'SYTEXT43)
SYTEXT43 DC    C'CHRDR'           DEVICE OPTION VALUE
SYPRMT44 DC    AL1(L'SYTEXT44)
SYTEXT44 DC    C'NOCHRDR'         DEVICE OPTION VALUE
SYPRMT45 DC    AL1(L'SYTEXT45)
SYTEXT45 DC    C'OPTN'            OPTIONS OPTION (SHORT FORM)
SYPRMT46 DC    AL1(L'SYTEXT46)
SYTEXT46 DC    C'NOOPTN'          NOOPTIONS OPTION (SHORT FORM)
*                                                                     *
* PARAMETER LIST FOR ERROR RECOGNIZER.                                *
*                                                                     *
SYPRME01 DC    AL.1(0)            SKIPS TO COMMA,COMMENT OR BLANK
         DC    FL1'10'            LENGTH OF ERROR TEXT
         DC    FL1'1'
SYPRME02 DC    AL.1(1)            SKIPS TO COMMA,COMMENT,BLANK OR ')'
         DC    FL1'10'            LENGTH OF ERROR TEXT
         DC    FL1'1'
* PARAMETER LISTS FOR INITIALIZATION ROUTINE                          *
SYPRMI01 DC    FL1'1'             CODE FOR CHRDR INITIALIZATION
SYPRMI22 DC    FL1'2'             CODE FOR WKLVAL SYSTEM INITIALIZATION
SYPRMI23 DC    FL1'3'             CODE FOR WKLDVAL GROUP INITIALIZATION
SYPRMI24 DC    FL1'4'             CODE FOR WKLDVAL PERIOD INITIAL.
SYPRMI21 DC    FL1'36'            CODE FOR ERROR INITIALIZATION
SYPRMI02 DC    FL1'5'             CODE FOR NOWKLD INITIALIZATION
SYPRMI03 DC    FL1'6'             CODE FOR PAGING INITIALIZATION
SYPRMI04 DC    FL1'7'             CODE FOR NOPAGING INITIALIZATION
SYPRMI05 DC    FL1'8'             CODE FOR CPU INITIALIZATION
SYPRMI06 DC    FL1'9'             CODE FOR NOCPU INITIALIZATION
SYPRMI07 DC    FL1'10'            CODE FOR CHAN INITIALIZATION
SYPRMI08 DC    FL1'11'            CODE FOR NOCHAN INITIALIZATION
SYPRMI09 DC    FL1'13'            CODE FOR NOCHRDR INITIALIZATION
SYPRMI27 DC    FL1'14'            CODE FOR TAPE INITIALIZATION
SYPRMI29 DC    FL1'15'            CODE FOR GRAPH INITIALIZATION
SYPRMI30 DC    FL1'16'            CODE FOR UNITR INITIALIZATION
SYPRMI31 DC    FL1'17'            CODE FOR COMM INITIALIZATION
SYPRMI32 DC    FL1'18'            CODE FOR DASD INITIALIZATION
SYPRMI33 DC    FL1'19'            CODE FOR NOTAPE INITIALIZATION
SYPRMI34 DC    FL1'20'            CODE FOR NOGRAPH INITIALIZATION
SYPRMI35 DC    FL1'21'            CODE FOR NOUNITR INITIALIZATION
SYPRMI36 DC    FL1'22'            CODE FOR NOCOMM INITIALIAZTION
SYPRMI37 DC    FL1'23'            CODE FOR NODASD INITIALIZATION
SYPRMI10 DC    FL1'24'            CODE FOR NODEVICE INITIALIZATION
SYPRMI38 DC    FL1'35'            CODE FOR CYCLE VALUE INITIALIZATION
SYPRMI39 DC    FL1'12'            CODE FOR INTERVAL VALUE INITIAL.
SYPRMI40 DC    FL1'32'            CODE FOR SYSOUT VALUE INITIALIZATION
SYPRMI41 DC    FL1'25'            CODE FOR REPORT INITIALIZATION -DEFER
SYPRMI42 DC    FL1'26'            CODE FOR REPORT INITIALIZATION -REAL-
*                                          TIME
SYPRMI15 DC    FL1'27'            CODE FOR NOREPORT INITIALIZATION
SYPRMI43 DC    FL1'33'            CODE FOR STOP INITIALIZATION - 'V'H
SYPRMI44 DC    FL1'34'            CODE FOR STOP INITIALIZATION - 'V'M
SYPRMI17 DC    FL1'28'            CODE FOR NOSTOP INITIALIZATION
SYPRMI18 DC    FL1'31'            CODE FOR OPI INITIALIZATION
SYPRMI19 DC    FL1'32'            CODE FOR NOOPI INITIALIZATION
SYPRMI11 DC    FL1'29'            CODE FOR TRACE INITIALIZATION
SYPRMI12 DC    FL1'30'            CODE FOR NOTRACE INITIALIZATION
SYPRMI13 DC    FL1'37'            CODE FOR OUTCLASS INITIALIZATION
SYPRMI14 DC    FL1'38'            CODE FOR MEMBER INITIALIZATION
* PARAMETER LIST FOR MFRALPHA RECOGNIZER ROUTINE                      *
SYALPHAV DC    FL1'1'
* PARAMETER LIST FOR MFRINTGR RECOGNIZER ROUTINE                      *
SYINTGRV DC    FL1'1'
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
IRBMFINP CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
GPR10    EQU   @10
GPR08    EQU   @08
GPR09    EQU   @09
GPR11    EQU   @11
GPR12    EQU   @12
GPR00F   EQU   @00
GPR01F   EQU   @01
GPR14F   EQU   @14
GPR15F   EQU   @15
GPR00P   EQU   @00
GPR01P   EQU   @01
GPR14P   EQU   @14
GPR15P   EQU   @15
GPR02F   EQU   @02
GPR03F   EQU   @03
GPR04F   EQU   @04
GPR05F   EQU   @05
GPR02P   EQU   @02
         ENTRY INFREBUF
         EXTRN SIZDATD
INPMA    EQU   0
INPMOPT  EQU   INPMA
INPMCON  EQU   INPMOPT
@NM00002 EQU   INPMOPT+3
INPMSTA  EQU   @NM00002
MFPMA    EQU   0
MFPMOPT  EQU   MFPMA
MFPMCON  EQU   MFPMOPT
@NM00010 EQU   MFPMOPT+3
MFPMSTA  EQU   @NM00010
IHADCB   EQU   0
IHADCS00 EQU   0
DCBFDAD  EQU   IHADCS00+5
IHADCS01 EQU   0
DCBDVTBL EQU   IHADCS01
IHADCS11 EQU   0
DCBRELB  EQU   IHADCS11
DCBREL   EQU   DCBRELB+1
DCBBUFCB EQU   IHADCS11+4
DCBDSORG EQU   IHADCS11+10
DCBDSRG1 EQU   DCBDSORG
DCBDSRG2 EQU   DCBDSORG+1
DCBIOBAD EQU   IHADCS11+12
DCBODEB  EQU   DCBIOBAD
DCBLNP   EQU   DCBODEB
DCBQSLM  EQU   DCBLNP
DCBIOBAA EQU   DCBODEB+1
IHADCS50 EQU   0
DCBSVCXL EQU   IHADCS50
DCBEODAD EQU   IHADCS50+4
DCBBFALN EQU   DCBEODAD
DCBHIARC EQU   DCBBFALN
DCBBFTEK EQU   DCBHIARC
DCBBFT   EQU   DCBBFTEK
DCBEODA  EQU   DCBEODAD+1
DCBEXLST EQU   IHADCS50+8
DCBRECFM EQU   DCBEXLST
DCBRECLA EQU   DCBRECFM
DCBEXLSA EQU   DCBEXLST+1
IHADCS24 EQU   0
DCBOFLGS EQU   IHADCS24+8
DCBOFLWR EQU   DCBOFLGS
DCBOFOPN EQU   DCBOFLGS
DCBIFLG  EQU   IHADCS24+9
DCBMACR  EQU   IHADCS24+10
DCBMACR1 EQU   DCBMACR
DCBMRFE  EQU   DCBMACR1
DCBMRGET EQU   DCBMRFE
DCBMRAPG EQU   DCBMACR1
DCBMRRD  EQU   DCBMRAPG
DCBMRCI  EQU   DCBMACR1
DCBMRMVG EQU   DCBMRCI
DCBMRLCG EQU   DCBMACR1
DCBMRABC EQU   DCBMACR1
DCBMRPT1 EQU   DCBMRABC
DCBMRSBG EQU   DCBMRPT1
DCBMRCRL EQU   DCBMACR1
DCBMRCHK EQU   DCBMRCRL
DCBMRRDX EQU   DCBMRCHK
DCBMRDMG EQU   DCBMACR1
DCBMACR2 EQU   DCBMACR+1
DCBMRPUT EQU   DCBMACR2
DCBMRWRT EQU   DCBMACR2
DCBMRMVP EQU   DCBMACR2
DCBMR5WD EQU   DCBMACR2
DCBMRLDM EQU   DCBMR5WD
DCBMRLCP EQU   DCBMRLDM
DCBMR4WD EQU   DCBMACR2
DCBMRPT2 EQU   DCBMR4WD
DCBMRTMD EQU   DCBMRPT2
DCBMR3WD EQU   DCBMACR2
DCBMRCTL EQU   DCBMR3WD
DCBMRSTK EQU   DCBMRCTL
DCBMR1WD EQU   DCBMACR2
DCBMRSWA EQU   DCBMR1WD
DCBMRDMD EQU   DCBMRSWA
IHADCS25 EQU   0
DCBMACRF EQU   IHADCS25+2
DCBMACF1 EQU   DCBMACRF
DCBMFFE  EQU   DCBMACF1
DCBMFGET EQU   DCBMFFE
DCBMFAPG EQU   DCBMACF1
DCBMFRD  EQU   DCBMFAPG
DCBMFCI  EQU   DCBMACF1
DCBMFMVG EQU   DCBMFCI
DCBMFLCG EQU   DCBMACF1
DCBMFABC EQU   DCBMACF1
DCBMFPT1 EQU   DCBMFABC
DCBMFSBG EQU   DCBMFPT1
DCBMFCRL EQU   DCBMACF1
DCBMFCHK EQU   DCBMFCRL
DCBMFDMG EQU   DCBMACF1
DCBMACF2 EQU   DCBMACRF+1
DCBMFPUT EQU   DCBMACF2
DCBMFWRT EQU   DCBMACF2
DCBMFMVP EQU   DCBMACF2
DCBMF5WD EQU   DCBMACF2
DCBMFLDM EQU   DCBMF5WD
DCBMFLCP EQU   DCBMFLDM
DCBMF4WD EQU   DCBMACF2
DCBMFPT2 EQU   DCBMF4WD
DCBMFTMD EQU   DCBMFPT2
DCBMF3WD EQU   DCBMACF2
DCBMFCTL EQU   DCBMF3WD
DCBMFSTK EQU   DCBMFCTL
DCBMF1WD EQU   DCBMACF2
DCBMFSWA EQU   DCBMF1WD
DCBMFDMD EQU   DCBMFSWA
DCBDEBAD EQU   IHADCS25+4
DCBIFLGS EQU   DCBDEBAD
IHADCS26 EQU   0
DCBWRITE EQU   IHADCS26
DCBREAD  EQU   DCBWRITE
DCBWRITA EQU   DCBREAD+1
IHADCS27 EQU   0
DCBGET   EQU   IHADCS27
DCBPUT   EQU   DCBGET
DCBGETA  EQU   DCBPUT+1
IHADCS36 EQU   0
DCBGERR  EQU   IHADCS36
DCBPERR  EQU   DCBGERR
DCBCHECK EQU   DCBPERR
DCBOPTCD EQU   DCBCHECK
DCBOPTH  EQU   DCBOPTCD
DCBOPTO  EQU   DCBOPTH
DCBOPTZ  EQU   DCBOPTCD
DCBGERRA EQU   DCBCHECK+1
DCBPERRA EQU   DCBGERRA
DCBSYNAD EQU   IHADCS36+4
DCBSYNA  EQU   DCBSYNAD+1
DCBCIND1 EQU   IHADCS36+8
DCBCIND2 EQU   IHADCS36+9
DCBIOBA  EQU   IHADCS36+16
DCBCICB  EQU   DCBIOBA
IHADCS52 EQU   0
DCBDIRCT EQU   IHADCS52
DCBQSWS  EQU   DCBDIRCT
DCBUSASI EQU   DCBQSWS
DCBQADFS EQU   DCBUSASI
DCBBUFOF EQU   DCBDIRCT+1
IHADCS37 EQU   0
DCBFLAG1 EQU   IHADCS37
IHADCS38 EQU   0
DCBEOBR  EQU   IHADCS38
DCBPOINT EQU   IHADCS38+12
DCBCNTRL EQU   DCBPOINT
IHADCS40 EQU   0
DCBEOBAD EQU   IHADCS40
DCBCCCW  EQU   IHADCS40+4
DCBRECAD EQU   DCBCCCW
DCBRECBT EQU   DCBRECAD
DCBRCREL EQU   DCBRECBT
@NM00071 EQU   IHADCS40+12
DCBEROPT EQU   @NM00071
CIBNAME  EQU   0
CIBASID  EQU   CIBNAME+10
CIBDATLN EQU   CIBNAME+14
CIBDATA  EQU   CIBNAME+16
INCSCLST EQU   0
CIBPTR   EQU   INCSCLST+4
INALLMOD EQU   0
INMSGMOD EQU   0
INBCB    EQU   0
INBCBNXT EQU   INBCB
INBCBLEN EQU   INBCB+4
INBCBTXT EQU   INBCB+8
BUBUF    EQU   0
RTPARMLS EQU   0
RTLENGTH EQU   RTPARMLS
RTTEXT   EQU   RTPARMLS+1
RTSCANER EQU   0
RBTYPBIT EQU   0
RBCHAR   EQU   0
RRPARMLS EQU   0
RRTYPE   EQU   RRPARMLS
RRLENGTH EQU   RRPARMLS+1
RRSAVETX EQU   RRPARMLS+2
RRCHAR   EQU   0
RRERRTXT EQU   0
RIINTGER EQU   0
RINUMVAL EQU   0
RINUMCOD EQU   0
NXTEXT   EQU   0
RASAVCHA EQU   0
RASAVCOD EQU   0
RACHAR   EQU   0
TMCOA    EQU   0
TMCOTCE  EQU   TMCOA
TMCOTCEF EQU   TMCOTCE
TMCOTCEC EQU   TMCOTCEF
TMCOTCEL EQU   TMCOTCE+3
TMCOTCEV EQU   TMCOTCEL
TMCOCYC  EQU   TMCOA+4
TMCOCYCF EQU   TMCOCYC
TMCOCYCC EQU   TMCOCYCF
TMCOCYCV EQU   TMCOCYC+2
TMCOOUT  EQU   TMCOA+8
TMCOOUTF EQU   TMCOOUT
TMCOOUTC EQU   TMCOOUTF
TMCOOUTV EQU   TMCOOUT+3
TMCOINT  EQU   TMCOA+12
TMCOINTF EQU   TMCOINT
TMCOINTC EQU   TMCOINTF
TMCOINTV EQU   TMCOINT+2
TMCOREP  EQU   TMCOA+16
TMCOREPF EQU   TMCOREP
TMCOREPC EQU   TMCOREPF
TMCOREPL EQU   TMCOREP+3
TMCOREPV EQU   TMCOREPL
TMCOSTP  EQU   TMCOA+20
TMCOSTPF EQU   TMCOSTP
TMCOSTPC EQU   TMCOSTPF
TMCOSTPS EQU   TMCOSTPF
TMCOSTPU EQU   TMCOSTPF
TMCOSTPV EQU   TMCOSTP+2
TMCOOPI  EQU   TMCOA+24
TMCOOPIF EQU   TMCOOPI
TMCOOPIC EQU   TMCOOPIF
TMCOOPIL EQU   TMCOOPI+3
TMCOOPIV EQU   TMCOOPIL
TMCOMEM  EQU   TMCOA+28
TMCOMEMF EQU   TMCOMEM
TMCOMEMC EQU   TMCOMEMF
TMCOMEMV EQU   TMCOMEM+2
TMMVT    EQU   0
TMMVOPT  EQU   TMMVT+4
TMMVCPU  EQU   TMMVOPT
TMMVPAG  EQU   TMMVOPT+4
TMMVWKL  EQU   TMMVOPT+8
TMMVCHA  EQU   TMMVOPT+12
TMMVDEV  EQU   TMMVOPT+16
LICNVMOD EQU   0
OPSUBCOD EQU   0
OPLABEL  EQU   0
OPCNVMOD EQU   0
REWRKARA EQU   0
REDLMBYT EQU   REWRKARA
RERECORD EQU   REWRKARA+1
REMESAGE EQU   0
IKEBC    EQU   0
IKEBF15  EQU   0
IKEBF31  EQU   0
IKEBP15  EQU   0
IKEBP31  EQU   0
IKEBP8   EQU   0
INEXSTMT EQU   0
INEXLENG EQU   INEXSTMT
INEXPARM EQU   INEXSTMT+2
MFMVT    EQU   0
MFMVNUM  EQU   MFMVT
MFMVOPT  EQU   MFMVT+4
MFMVDEV  EQU   MFMVOPT+16
MFCOA    EQU   0
MFCOTCE  EQU   MFCOA
MFCOTCEF EQU   MFCOTCE
MFCOTCEL EQU   MFCOTCE+3
MFCOTCEV EQU   MFCOTCEL
MFCOCYC  EQU   MFCOA+4
MFCOCYCF EQU   MFCOCYC
MFCOOUT  EQU   MFCOA+8
MFCOOUTF EQU   MFCOOUT
MFCOOUTV EQU   MFCOOUT+3
MFCOINT  EQU   MFCOA+12
MFCOINTF EQU   MFCOINT
MFCOINTV EQU   MFCOINT+2
MFCOREP  EQU   MFCOA+16
MFCOREPF EQU   MFCOREP
MFCOREPL EQU   MFCOREP+3
MFCOREPV EQU   MFCOREPL
MFCOSTP  EQU   MFCOA+20
MFCOSTPF EQU   MFCOSTP
MFCOSTPS EQU   MFCOSTPF
MFCOSTPU EQU   MFCOSTPF
MFCOSTPV EQU   MFCOSTP+2
MFCOOPI  EQU   MFCOA+24
MFCOOPIF EQU   MFCOOPI
MFCOOPIL EQU   MFCOOPI+3
MFCOOPIV EQU   MFCOOPIL
MFCOMEM  EQU   MFCOA+28
MFCOMEMF EQU   MFCOMEM
MFCOMEMC EQU   MFCOMEMF
MFCOMEMV EQU   MFCOMEM+2
SRFORCE  EQU   0
BUBUFTXT EQU   0
BUBUFSZE EQU   0
BUSCB    EQU   0
BUCURBCB EQU   BUSCB
BUCURTXT EQU   BUSCB+4
BUBYTLFT EQU   BUSCB+8
RTEXPARM EQU   0
RTSCB    EQU   0
RTCURTXT EQU   RTSCB+4
RTBYTLFT EQU   RTSCB+8
RBTYPE   EQU   0
RBSCB    EQU   0
RBCURTXT EQU   RBSCB+4
RBBYTLFT EQU   RBSCB+8
RRPARM   EQU   0
RRSCB    EQU   0
RRTXTCUR EQU   RRSCB+4
RRBYTLFT EQU   RRSCB+8
RISAVNUM EQU   0
RISCB    EQU   0
RICURTXT EQU   RISCB+4
RIBYTLFT EQU   RISCB+8
FRFRECOD EQU   0
FRSCB    EQU   0
FRCURBCB EQU   FRSCB
FRCURTXT EQU   FRSCB+4
FRBYTLFT EQU   FRSCB+8
NXSCB    EQU   0
NXCURBCB EQU   NXSCB
NXCURTXT EQU   NXSCB+4
NXBYTLFT EQU   NXSCB+8
RASAVALP EQU   0
RASCB    EQU   0
RACURTXT EQU   RASCB+4
RABYTLFT EQU   RASCB+8
LINDXNUM EQU   0
LICOAPTR EQU   0
LIMVTPTR EQU   0
OPCODPTR EQU   0
RERECPTR EQU   0
RERECLEN EQU   0
RERECCOR EQU   0
RESUBPOL EQU   RERECCOR
RERECSZE EQU   RERECCOR+1
MEFORCE  EQU   0
INMVADD  EQU   INMVOPT
MFMVADD  EQU   MFMVOPT
INPMB    EQU   INPMOPT
@NM00005 EQU   INPMB+2
INPMDEVF EQU   @NM00005
INPMTAPE EQU   INPMDEVF
INPMTP   EQU   INPMDEVF
INPMDA   EQU   INPMDEVF
INPMGRAP EQU   INPMDEVF
INPMUNIT EQU   INPMDEVF
INPMCRDR EQU   INPMDEVF
INPMC    EQU   INPMOPT
@NM00007 EQU   INPMC+3
INPMWKLD EQU   @NM00007
MFPMB    EQU   MFPMOPT
@NM00013 EQU   MFPMB+2
MFPMDEVF EQU   @NM00013
MFPMTAPE EQU   MFPMDEVF
MFPMTP   EQU   MFPMDEVF
MFPMDA   EQU   MFPMDEVF
MFPMGRAP EQU   MFPMDEVF
MFPMUNIT EQU   MFPMDEVF
MFPMCRDR EQU   MFPMDEVF
MFPMC    EQU   MFPMOPT
@NM00015 EQU   MFPMC+3
MFPMWKLD EQU   @NM00015
MFCOOPTN EQU   MFCOA
MFCOCTRL EQU   MFCOOPTN
INCOOPTN EQU   INCOA
INCOCTRL EQU   INCOOPTN
TMPMB    EQU   TMPMOPT
@NM00043 EQU   TMPMB+2
TMPMDEVF EQU   @NM00043
TMPMC    EQU   TMPMOPT
@NM00045 EQU   TMPMC+3
TMCOOPTN EQU   TMCOA
TMMVADD  EQU   TMMVOPT
*                                      START UNREFERENCED COMPONENTS
TMCOCTRL EQU   TMCOOPTN
TMPMWKLD EQU   @NM00045
@NM00046 EQU   @NM00045
@NM00044 EQU   TMPMC
TMPMCRDR EQU   TMPMDEVF
TMPMUNIT EQU   TMPMDEVF
TMPMGRAP EQU   TMPMDEVF
TMPMDA   EQU   TMPMDEVF
TMPMTP   EQU   TMPMDEVF
TMPMTAPE EQU   TMPMDEVF
@NM00042 EQU   TMPMB
@NM00016 EQU   @NM00015
@NM00014 EQU   MFPMC
@NM00012 EQU   MFPMB
@NM00008 EQU   @NM00007
@NM00006 EQU   INPMC
@NM00004 EQU   INPMB
RACURBCB EQU   RASCB
RICURBCB EQU   RISCB
RRCURBCB EQU   RRSCB
RBCURBCB EQU   RBSCB
RTCURBCB EQU   RTSCB
@NM00027 EQU   MFCOMEM+1
@NM00026 EQU   MFCOOPIL
@NM00025 EQU   MFCOOPI+1
MFCOOPIC EQU   MFCOOPIF
@NM00024 EQU   MFCOSTP+1
MFCOSTPC EQU   MFCOSTPF
@NM00023 EQU   MFCOREPL
@NM00022 EQU   MFCOREP+1
MFCOREPC EQU   MFCOREPF
@NM00021 EQU   MFCOINT+1
MFCOINTC EQU   MFCOINTF
@NM00020 EQU   MFCOOUT+1
MFCOOUTC EQU   MFCOOUTF
MFCOCYCV EQU   MFCOCYC+2
@NM00019 EQU   MFCOCYC+1
MFCOCYCC EQU   MFCOCYCF
@NM00018 EQU   MFCOTCEL
@NM00017 EQU   MFCOTCE+1
MFCOTCEC EQU   MFCOTCEF
MFMVCHA  EQU   MFMVOPT+12
MFMVWKL  EQU   MFMVOPT+8
MFMVPAG  EQU   MFMVOPT+4
MFMVCPU  EQU   MFMVOPT
TMMVNUM  EQU   TMMVT
@NM00105 EQU   TMCOMEM+1
@NM00104 EQU   TMCOOPIL
@NM00103 EQU   TMCOOPI+1
@NM00102 EQU   TMCOSTP+1
@NM00101 EQU   TMCOREPL
@NM00100 EQU   TMCOREP+1
@NM00099 EQU   TMCOINT+1
@NM00098 EQU   TMCOOUT+1
@NM00097 EQU   TMCOCYC+1
@NM00096 EQU   TMCOTCEL
@NM00095 EQU   TMCOTCE+1
@NM00094 EQU   RRPARMLS
@NM00091 EQU   INBCB+6
INCECB   EQU   INCSCLST
@NM00077 EQU   CIBNAME+13
CIBCONID EQU   CIBNAME+12
CIBTJID  EQU   CIBASID
@NM00076 EQU   CIBNAME+6
CIBLEN   EQU   CIBNAME+5
CIBVERB  EQU   CIBNAME+4
CIBNEXT  EQU   CIBNAME
DCBEOB   EQU   IHADCS40+20
DCBPRECL EQU   IHADCS40+18
@NM00074 EQU   IHADCS40+16
@NM00073 EQU   @NM00071+1
@NM00072 EQU   DCBEROPT
DCBERABE EQU   DCBEROPT
DCBERSKP EQU   DCBEROPT
DCBERACC EQU   DCBEROPT
@NM00070 EQU   IHADCS40+10
@NM00069 EQU   IHADCS40+9
@NM00068 EQU   IHADCS40+8
DCBRECA  EQU   DCBRECAD+1
@NM00067 EQU   DCBRECBT
DCBRCFGT EQU   DCBRCREL
DCBRCTRU EQU   DCBRCREL
DCBLCCW  EQU   DCBEOBAD
DCBNOTE  EQU   DCBCNTRL
DCBLRECL EQU   IHADCS38+10
@NM00066 EQU   IHADCS38+8
DCBEOBW  EQU   IHADCS38+4
DCBEOBRA EQU   DCBEOBR+1
DCBNCP   EQU   DCBEOBR
@NM00065 EQU   DCBFLAG1
DCBSTFLS EQU   DCBFLAG1
DCBSTQCK EQU   DCBFLAG1
DCBDIRCQ EQU   DCBBUFOF
DCBQSTRU EQU   DCBUSASI
@NM00064 EQU   DCBUSASI
DCBQADF3 EQU   DCBQADFS
DCBQADF2 EQU   DCBQADFS
DCBQADF1 EQU   DCBQADFS
DCBBLBP  EQU   DCBUSASI
@NM00063 EQU   DCBUSASI
DCBCICBA EQU   DCBCICB+1
@NM00062 EQU   DCBCICB
DCBOFFSW EQU   IHADCS36+15
DCBOFFSR EQU   IHADCS36+14
DCBWCPL  EQU   IHADCS36+13
DCBWCPO  EQU   IHADCS36+12
DCBBLKSI EQU   IHADCS36+10
DCBCNQSM EQU   DCBCIND2
DCBCNFEO EQU   DCBCIND2
DCBCNCHS EQU   DCBCIND2
DCBCNBFP EQU   DCBCIND2
DCBCNIOE EQU   DCBCIND2
DCBCNCLO EQU   DCBCIND2
DCBCNWRO EQU   DCBCIND2
DCBCNSTO EQU   DCBCIND2
DCBCNEXB EQU   DCBCIND1
@NM00061 EQU   DCBCIND1
DCBCNBRM EQU   DCBCIND1
@NM00060 EQU   DCBCIND1
DCBCNEVA EQU   DCBCIND1
DCBCNEVB EQU   DCBCIND1
DCBCNSRD EQU   DCBCIND1
DCBCNTOV EQU   DCBCIND1
DCBIOBL  EQU   DCBSYNAD
DCBCHCKA EQU   DCBPERRA
@NM00059 EQU   DCBOPTCD
DCBOPTT  EQU   DCBOPTCD
DCBSRCHD EQU   DCBOPTZ
DCBOPTQ  EQU   DCBOPTCD
DCBBCKPT EQU   DCBOPTO
DCBOPTC  EQU   DCBOPTCD
DCBOPTU  EQU   DCBOPTCD
DCBOPTW  EQU   DCBOPTCD
DCBPUTA  EQU   DCBGETA
@NM00058 EQU   DCBPUT
DCBREADA EQU   DCBWRITA
@NM00057 EQU   DCBREAD
DCBDEBA  EQU   DCBDEBAD+1
@NM00056 EQU   DCBIFLGS
DCBIFIOE EQU   DCBIFLGS
DCBIFPCT EQU   DCBIFLGS
DCBIFEC  EQU   DCBIFLGS
DCBMFSTI EQU   DCBMFDMD
DCBMFAWR EQU   DCBMFSTK
DCBMFUIP EQU   DCBMFTMD
DCBMFIDW EQU   DCBMFLCP
DCBMFWRK EQU   DCBMFMVP
DCBMFRDQ EQU   DCBMFWRT
DCBMFGTQ EQU   DCBMFPUT
DCBMFSTL EQU   DCBMACF2
DCBMFCK  EQU   DCBMFDMG
DCBMFRDX EQU   DCBMFCHK
DCBMFDBF EQU   DCBMFSBG
DCBMFRDI EQU   DCBMFLCG
DCBMFRDK EQU   DCBMFMVG
DCBMFWRQ EQU   DCBMFRD
DCBMFPTQ EQU   DCBMFGET
DCBMFECP EQU   DCBMACF1
DCBTIOT  EQU   IHADCS25
DCBMRSTI EQU   DCBMRDMD
DCBMRAWR EQU   DCBMRSTK
DCBMRUIP EQU   DCBMRTMD
DCBMRIDW EQU   DCBMRLCP
DCBMRWRK EQU   DCBMRMVP
DCBMRRDQ EQU   DCBMRWRT
DCBMRGTQ EQU   DCBMRPUT
DCBMRSTL EQU   DCBMACR2
DCBMRCK  EQU   DCBMRDMG
DCBPGFXA EQU   DCBMRRDX
DCBMRDBF EQU   DCBMRSBG
DCBMRRDI EQU   DCBMRLCG
DCBMRRDK EQU   DCBMRMVG
DCBMRWRQ EQU   DCBMRRD
DCBMRPTQ EQU   DCBMRGET
DCBMRECP EQU   DCBMACR1
@NM00055 EQU   DCBIFLG
DCBIBIOE EQU   DCBIFLG
DCBIBPCT EQU   DCBIFLG
DCBIBEC  EQU   DCBIFLG
DCBOFIOF EQU   DCBOFLGS
DCBOFUEX EQU   DCBOFLGS
DCBOFTM  EQU   DCBOFLGS
DCBOFPPC EQU   DCBOFLGS
DCBOFEOV EQU   DCBOFLGS
DCBOFLRB EQU   DCBOFLGS
DCBOFIOD EQU   DCBOFLWR
DCBDDNAM EQU   IHADCS24
DCBRECKL EQU   DCBRECFM
DCBRECCC EQU   DCBRECFM
DCBRECSB EQU   DCBRECFM
DCBRECBR EQU   DCBRECFM
DCBRECTO EQU   DCBRECLA
DCBRECL  EQU   DCBRECLA
DCBBFA   EQU   DCBBFTEK
DCBH0    EQU   DCBBFTEK
DCBBFTKD EQU   DCBBFTEK
DCBBFTE  EQU   DCBBFT
DCBBFTKR EQU   DCBBFT
DCBBFTS  EQU   DCBBFT
DCBH1    EQU   DCBBFTEK
DCBSVCXA EQU   DCBSVCXL+1
@NM00054 EQU   DCBSVCXL
DCBODEBA EQU   DCBIOBAA
@NM00053 EQU   DCBQSLM
DCBUPDBT EQU   DCBQSLM
DCBUPDCM EQU   DCBQSLM
DCB1DVDS EQU   DCBQSLM
@NM00052 EQU   DCBDSRG2
DCBDSGTR EQU   DCBDSRG2
DCBACBM  EQU   DCBDSRG2
@NM00051 EQU   DCBDSRG2
DCBDSGTQ EQU   DCBDSRG2
DCBDSGTX EQU   DCBDSRG2
DCBDSGGS EQU   DCBDSRG2
DCBDSGU  EQU   DCBDSRG1
DCBDSGPO EQU   DCBDSRG1
DCBDSGMQ EQU   DCBDSRG1
DCBDSGCQ EQU   DCBDSRG1
DCBDSGCX EQU   DCBDSRG1
DCBDSGDA EQU   DCBDSRG1
DCBDSGPS EQU   DCBDSRG1
DCBDSGIS EQU   DCBDSRG1
DCBBUFL  EQU   IHADCS11+8
DCBBUFCA EQU   DCBBUFCB+1
DCBBUFNO EQU   DCBBUFCB
DCBDEVT  EQU   DCBREL
DCBKEYLE EQU   DCBRELB
DCBTRBAL EQU   IHADCS01+6
@NM00050 EQU   IHADCS01+5
@NM00049 EQU   IHADCS01+4
DCBDVTBA EQU   DCBDVTBL+1
@NM00048 EQU   DCBDVTBL
DCBKEYCN EQU   IHADCS00+4
DCBRELAD EQU   IHADCS00
@NM00047 EQU   IHADCB
MFPMSARG EQU   MFPMA+4
@NM00011 EQU   @NM00010
@NM00009 EQU   MFPMOPT
INPMSARG EQU   INPMA+4
@NM00003 EQU   @NM00002
@NM00001 EQU   INPMOPT
*                                      END UNREFERENCED COMPONENTS
@RT00222 EQU   @EL00003
@RT00319 EQU   RBCHKBLN
@RT00387 EQU   RRSCNEND
@RT00389 EQU   RRUPDATE
@RT00391 EQU   RRSCNEND
@RT00401 EQU   RRSCNEND
@RT00403 EQU   RRUPDAT2
@RT00405 EQU   RRSCNEND
@RF00487 EQU   @EL00009
@RT00546 EQU   LIMSGDS
@RC00567 EQU   @RC00563
@RT00577 EQU   LIST
@RC00694 EQU   @RC00692
@RC00704 EQU   @RC00702
@RC00714 EQU   @RC00712
@RC00724 EQU   @RC00722
@RC00734 EQU   @RC00732
@RC00744 EQU   @RC00742
@RF00883 EQU   @EL00013
@RF01006 EQU   @EL00014
@RC01276 EQU   @EL00014
@RF01308 EQU   @EL00014
@PB00016 EQU   @EL00015
@RF01434 EQU   @RC01427
@RF01456 EQU   @RC01449
@RC01421 EQU   @EL00017
@PB00017 EQU   @PB00018
@RF01492 EQU   @EL00018
@PB00015 EQU   @PB00017
@PB00014 EQU   @PB00015
@PB00013 EQU   @PB00014
@PB00012 EQU   @PB00013
@PB00011 EQU   @PB00012
@PB00010 EQU   @PB00011
@PB00009 EQU   @PB00010
@PB00008 EQU   @PB00009
@PB00007 EQU   @PB00008
@PB00006 EQU   @PB00007
@PB00005 EQU   @PB00006
@PB00004 EQU   @PB00005
@PB00003 EQU   @PB00004
@PB00002 EQU   @PB00003
@ENDDATA EQU   *
         END   IRBMFINP,(C'PL/S-II',0502,74107)
