         TITLE 'ISTDCC11 - READ LDO REQUEST                            *
                        '
ISTDCC11 CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'ISTDCC11  75.346'                                 0001
         DROP  @15
@PROLOG  BALR  @08,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@08                                         0001
*                                                                  0467
*/********************************************************************/
*/*                                                                  */
*/*           INFORMATION TABLE FOR MAIN ROUTINE                     */
*/*                                                                  */
*/********************************************************************/
*/*                                                                  */
*/*                       CONTROL BLOCKS                             */
*/*------------------------------------------------------------------*/
*/* CB    FIELD        S/R/T (SET,REF,TEST)      COMMENTS            */
*/*------------------------------------------------------------------*/
*/* RPH                                                              */
*/*       RPHCRR         R    POINTER TO CONTROL LAYER'S CRR         */
*/*------------------------------------------------------------------*/
*/* CRR                                                              */
*/*       CRRC11         S    HISTORY AUDIT TRAIL SWITCH             */
*/*       CRRMAS         S    MODULE AUDIT TRAIL SWITCHES            */
*/*       CRRM11         S    ISTDCC11'S MODULE AUDIT TRAIL SWITCH   */
*/*       CRRCLDO        R    POINTER TO CURRENT LDO TO PROCESS      */
*/*       CRRFMCB        R    POINTER TO FMCB                        */
*/*       CRRFINI        S    INDICATES REQUEST PROCESSING FINISHED  */
*/*       CRRRTNCD       S    MAJOR RETURN CODE FOR FEEDBACK         */
*/*       CRRFDB2        S    MINOR RETURN CODE FOR FEEDBACK         */
*/*       CRRSPACE       R    BASE FOR CRRSAREA                      */
*/*------------------------------------------------------------------*/
*/* DEVCH                                                            */
*/*       DEVINPUT       T    SEE IF INPUT DEVICE FOR READ           */
*/********************************************************************/
*/*                                                                  */
*/*                             REGISTERS                            */
*/*------------------------------------------------------------------*/
*/* RPHPTR (REGISTER 1) INPUT PARAMETER WHICH POINTS TO THE RPH      */
*/* LDOPTR (REGISTER 9) POINTER TO CURRENT LDO TO BE PROCESSED       */
*/********************************************************************/
*/*                                                                  */
*/*                              MACROS                              */
*/*------------------------------------------------------------------*/
*/* TPESC - USED TO TRANSFER CONTROL TO THE NEXT DVT ENTRY           */
*/********************************************************************/
*/*                                                                  */
*/*                              CALLS                               */
*/*------------------------------------------------------------------*/
*/* CSUBR1 - PROCESS READ LDO IF DEVICE IS AN INPUT DEVICE           */
*/********************************************************************/
*                                                                  0467
*   /*****************************************************************/
*   /*                                                               */
*   /* INITIALIZE POINTERS AND SET AUDIT TRAIL SWITCHES              */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0467
*   CRRPTR=ADDR(CRRSPACE);          /* REFERENCE CRR                 */
         L     CRRPTR,RPHCRR(,RPHPTR)                              0467
         LA    CRRPTR,CRRSPACE+312(,CRRPTR)                        0467
*   CRRC11=ON;                      /* INITIALIZE HISTORY SWITCHES   */
         OI    CRRC11(CRRPTR),B'00001000'                          0468
*   CRRMAS=CRRMAS&&CRRMAS;          /* CLEAR MODULE AUDIT SWITCHES   */
         XC    CRRMAS(8,CRRPTR),CRRMAS(CRRPTR)                     0469
*   CRRM11=ON;                      /* INDICATE ISTDCC11 PROCESSING  */
         OI    CRRM11(CRRPTR),B'00001000'                          0470
*   LDOPTR=CRRCLDO;                 /* REFERENCE CURRENT LDO         */
*                                                                  0471
         L     LDOPTR,CRRCLDO(,CRRPTR)                             0471
*   /*****************************************************************/
*   /*                                                               */
*   /* IF FMCB INDICATES THAT THE CURRENT DEVICE TO BE PROCESSED IS  */
*   /* AN OUTPUT ONLY DEVICE, PROCESSING OF READ LDO'S MUST BE       */
*   /* TERMINATED WITH AN ERROR INDICATION.                          */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0472
*   IF DEVINPUT=OFF&                /* SEE IF DEVICE FOR INPUT       */
*       DEVCHAR2^=DEV3284&DEVCHAR2^=DEV3286 THEN                   0472
         L     @15,CRRFMCB(,CRRPTR)                                0472
         LA    @12,36                                              0472
         AL    @12,FMCDNCBA(,@15)                                  0472
         TM    DEVINPUT(@12),B'10000000'                           0472
         BNZ   @RF00472                                            0472
         CLI   DEVCHAR2(@12),X'1A'                                 0472
         BE    @RF00472                                            0472
         CLI   DEVCHAR2(@12),X'1B'                                 0472
         BE    @RF00472                                            0472
*     DO;                           /* OUTPUT ONLY DEVICE            */
*                                                                  0473
*       /*************************************************************/
*       /*                                                           */
*       /* ERROR-NOT INPUT DEVICE                                    */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0474
*       CRRFDB2=CRRRTOOD;           /* SET REASON CODE FOR FEEDBACK  */
         MVI   CRRFDB2(CRRPTR),X'10'                               0474
*       CRRRTNCD=CRRLOGIC;          /* SET LOGICAL I/O ERROR CODE    */
         MVI   CRRRTNCD(CRRPTR),X'08'                              0475
*       CRRFINI=ON;                 /* INDICATE DO PROCESSING      0476
*                                      FINISHED                      */
         OI    CRRFINI(CRRPTR),B'00001000'                         0476
*     END;                                                         0477
*   ELSE                                                           0478
*     CALL CSUBR1;                  /* HANDLE LDO'S                  */
         B     @RC00472                                            0478
@RF00472 BAL   @14,CSUBR1                                          0478
*/*TPESC                                                             */
*                                                                  0479
*   DO;                                                            0479
*                                                                  0479
@RC00472 DS    0H                                                  0480
*/* ATBUILD (ISTDYPAB,ISTAVT,ISTATCVT)                               */
*                                                                  0480
*/* VTAM ADDRESS VECTOR TABLE */                                   0480
*/*  REVISIONS                                         002 03/06/75  */
*DCL  1  ISTAVT BDY(WORD) BASED,                                   0480
*       2  ISTACVT PTR(31),            /* ADDR OF VTAM CVT           */
*       2  ISTAS49 PTR(31),            /* ADDR OF SVC 49 CODE        */
*          3  ISTAHIP BIT(1),          /* HALT IN PROGRESS           */
*       2  ISTAS53 PTR(31),            /* ADDR OF SVC 53 CODE        */
*       2  ISTAPSTA PTR(31),           /* ADDR OF APS TABLE          */
*       2  AVTASID FIXED(15),          /* VTAM ASID                  */
*       2  ISTVTTIK FIXED(15),         /* VTAMRP TASK ID             */
*       2  ISTAPSEX PTR(31),           /* ADDR OF APS EXIT           */
*       2  ISTPHNM CHAR(5),            /* PHASE NAME OF TRANSIENT    */
*       2  ISTX1 CHAR(1),              /* TEST FIELD                 */
*       2  ISTARID PTR(15),            /* ADDR OF RID                */
*       2  ISTATRT PTR(15),            /* ADDR OF VTAM GATES IN RETAB*/
*       2  ISTAGTWT PTR(15),           /* ADDR OF GATEWAIT ROUTINE   */
*       2  ISTVTTP  PTR(15),           /* ADDR OF CODE TO CHECK FOR  */
*                                      /* PENDING TIMER INTERRUPT    */
*       2  ISTAVR01 CHAR(2),           /* RESERVED                   */
*       2  ISTPDAVP PTR(31);           /* VECTOR FOR PDAIDS SMS TRACE*/
*                                                                  0481
*/* END OF ATBUILD                                                   */
*                                                                  0481
*     RFY                                                          0481
*       GPR15P RSTD;                                               0481
*     DO;                           /* LISATCVT                    0482
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*       GPR15P=ATCLCPTR;            /* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     0483
*     END;                          /* LISATCVT                      */
*     GPR15P=GPR15P->ATCESC01;                                     0485
         L     GPR15P,ATCESC01(,GPR15P)                            0485
*     DCL                                                          0486
*       FMZL0008 BASED(GPR15P) LABEL VALUERANGE(*);                0486
*     CALL FMZL0008;                                               0487
         BALR  @14,@15                                             0487
*     RESPECIFY                                                    0488
*       GPR15P UNRSTD;                                             0488
*   END;                            /* **** END OF TPESC EXIT TO NEXT
*                                      DVT ENTRY                     */
*CSUBR1:                                                           0490
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0490
*                                                                  0490
         B     @PB00002                                            0490
CSUBR1   DS    0H                                                  0491
*/********************************************************************/
*/*                                                                  */
*/*              INFORMATION TABLE FOR CSUBR1                        */
*/*                                                                  */
*/********************************************************************/
*/*                                                                  */
*/*                           CONTROL BLOCKS                         */
*/*------------------------------------------------------------------*/
*/* CB    FIELD        S/R/T       COMMENTS                          */
*/*------------------------------------------------------------------*/
*/* CRR                                                              */
*/*       CRRRTN1        S/R  SAVE AREA FOR CALLER'S RETURN ADDRESS  */
*/*       CRRDOCUR       S    INDICATES READ OCCURRED FOR DO GROUP   */
*/*       CRRFINI        T    INDICATES REQUEST PROCESSING FINISHED  */
*/*       CRRSW0         S    INTERNAL CONTROL SWITCH                */
*/*       CRRSW1         S    INTERNAL CONTROL SWITCH                */
*/*       CRRSW2         S    INTERNAL CONTROL SWITCH                */
*/********************************************************************
*                                                                    */
*/*                                                                  */
*/*                           REGISTERS                              */
*/*------------------------------------------------------------------*/
*/* RETPTR (REGISTER 14) CALLER'S RETURN ADDRESS                     */
*/********************************************************************/
*/*                                                                  */
*/*                           NO MACROS                              */
*/********************************************************************/
*/*                                                                  */
*/*                              CALLS                               */
*/*------------------------------------------------------------------*/
*/* CSUBR8 - IF A PREVIOUS READ HAS NOT OCCURRED, CSUBR8 IS CALLED   */
*/*          TO VALIDATE THE LDO AND TO CALL CSUBR3 TO HANDLE READ   */
*/*          MODIFIED OR READ BUFFER.                                */
*/* CSUBR2 - IF NO ERRORS WERE FOUND IN CSUBR8 OR CSUBR3, CSUBR2 IS  */
*/*         INVOKED TO CONTINUE PROCESSING FOR A NORMAL READ.        */
*/********************************************************************
*                                                                    */
*                                                                  0491
*   CRRRTN1=RETPTR;                 /* SAVE RETURN ADDRESS           */
*                                                                  0491
         ST    RETPTR,CRRRTN1(,CRRPTR)                             0491
*   /*****************************************************************/
*   /*                                                               */
*   /* CSUBR8 IS CALLED TO VALIDATE THE LDO, AND CSUBR2 IS CALLED IF */
*   /* THE LDO IS VALID AND IT WAS NOT A READ MODIFIED OR READ       */
*   /* BUFFER.                                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0492
*   DO;                             /* MODESET EXTKEY(ZERO)          */
*     SPKA(0);                      /* SET PSW KEY                   */
         SLR   @15,@15                                             0493
         SPKA  0(@15)                                              0493
*   END;                            /* MODESET EXTKEY(ZERO) GET USER
*                                      KEY                   @VM40576*/
*   CRRSW3=OFF;                     /* CLEAR STRUCTURE SWITCHES      */
*   CRRSW2=OFF;                                                    0496
*   CRRSW1=OFF;                                                    0497
*   CRRSW0=OFF;                                                    0498
         NI    CRRSW3(CRRPTR),B'00001111'                          0498
*   CRRDOCUR=ON;                    /* INDICATE READ HAS OCCURRED    */
         OI    CRRDOCUR(CRRPTR),B'10000000'                        0499
*   LCPBPTR=CRRLCPB;                /* REFERENCE LCPB                */
         L     LCPBPTR,CRRLCPB(,CRRPTR)                            0500
*   CALL CSUBR8;                    /* LOCK AND VALIDATE LDO         */
         BAL   @14,CSUBR8                                          0501
*   IF CRRFINI=ON THEN                                             0502
         TM    CRRFINI(CRRPTR),B'00001000'                         0502
         BO    @RT00502                                            0502
*     ;                             /* PROCESSING FINISHED           */
*   ELSE                                                           0504
*     CALL CSUBR2;                  /* CONTINUE LDO PROCESSING       */
         BAL   @14,CSUBR2                                          0504
*   DO;                             /* MODESET EXTKEY(VTAM)          */
@RT00502 DS    0H                                                  0506
*     SPKA(96);                     /* SET PSW KEY                   */
         LA    @15,96                                              0506
         SPKA  0(@15)                                              0506
*   END;                            /* MODESET EXTKEY(VTAM) GET VTAM
*                                      KEY VS30 122          @Z30APGE*/
*   RETPTR=CRRRTN1;                 /* GET RETURN ADDRESS            */
         L     RETPTR,CRRRTN1(,CRRPTR)                             0508
*   END CSUBR1;                     /* RETURN TO CALLER              */
@EL00002 DS    0H                                                  0509
@EF00002 DS    0H                                                  0509
@ER00002 BR    @14                                                 0509
*CSUBR2:                                                           0510
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0510
*                                                                  0510
CSUBR2   DS    0H                                                  0511
*/********************************************************************/
*/*                                                                  */
*/*              INFORMATION TABLE FOR CSUBR2                        */
*/*                                                                  */
*/********************************************************************/
*/*                                                                  */
*/*                           CONTROL BLOCKS                         */
*/*------------------------------------------------------------------*/
*/* CB    FIELD        S/R/T (SET,REF,TEST)      COMMENTS            */
*/*------------------------------------------------------------------*/
*/* CRR                                                              */
*/*       CRRRTN2        S/R  SAVE AREA FOR CALLER'S RETURN ADDRESS  */
*/*       CRRINIO        T    SEE IF THE LDO WAS PROCEEDED BY  WRITE */
*/*                           WHICH WILL CAUSE I/O TO BE INITIATED   */
*/*       CRRFINI        S    INDICATES REQUEST PROCESSING FINISHED  */
*/*       CRRFSB         S    FSB POINTER OBTAINED FROM TPFEL        */
*/*------------------------------------------------------------------*/
*/* FMCB                                                             */
*/*       FMCFBA         R    START OF FMCB DATA QUEUE               */
*/*------------------------------------------------------------------*/
*/* PROCD                                                            */
*/*       PROMODE        T    DETERMINE WHETHER READ BLOCK, MESSAGE, */
*/*                           TRANSMISSION OR CONTINUOUS LCCW IS TO  */
*/*                           BE BUILT                               */
*/*------------------------------------------------------------------*/
*/* LCCW                                                             */
*/*       LCCWRWOP       S    LCCW OP CODE                           */
*/********************************************************************/
*/*                                                                  */
*/*                           REGISTERS                              */
*/*------------------------------------------------------------------*/
*/* FSBPTR - CONTAINS FSB POINTER AFTER TPFEL                        */
*/* RETPTR (REGISTER 14) CALLER'S RETURN ADDRESS                     */
*/********************************************************************/
*/*                                                                  */
*/*                              MACROS                              */
*/*------------------------------------------------------------------*/
*/* TPFEL - GET ADDRESS OF OLDEST FSB ON THE FMCB DATA QUEUE         */
*/********************************************************************/
*/*                                                                  */
*/*                              CALLS                               */
*/*------------------------------------------------------------------*/
*/* CSUBR5 - IF LCCW WAS BUILT, CSUBR5 IS CALLED TO SET UP FOR I/O   */
*/* CSUBR4 - IF NO FSB ON FMCB DATA QUEUE, SEE IF DATA EXPECTED      */
*/* CSUBR6 - MOVE DATA FROM FSB TO USER'S BUFFER                     */
*/********************************************************************/
*                                                                  0511
*   CRRRTN2=RETPTR;                 /* SAVE RETURN ADDRESS           */
*                                                                  0511
         ST    RETPTR,CRRRTN2(,CRRPTR)                             0511
*   /*****************************************************************/
*   /*                                                               */
*   /* IF A PREVIOUS WRITE LDO IN THIS DO GROUP CAUSED AN I/O        */
*   /* OPERATION TO BE INITIATED, THEN A LCCW MUST BE BUILT FOR THIS */
*   /* READ CAUSING AN I/O OPERATION TO OCCUR. IF I/O HAS NOT BEEN   */
*   /* INITIATED AND THERE IS DATA ON THE FMCB DATA QUEUE, THIS MAY  */
*   /* BE USED TO SATISFY THE READ. IF NO DATA IS PRESENT, BUT THE   */
*   /* FMCB INDICATES DATA IS EXPECTED, THEN AN INDICATION IS SET FOR*/
*   /* REQUEST FINISH INDICATING THAT THIS LDO IS AWAITING DATA FROM */
*   /* A PREVIOUS I/O OPERATION. OTHERWISE A READ LCCW IS BUILT TO BE*/
*   /* SHIPPED TO TPIOS.                                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0512
*   IF CRRINIO=ON THEN              /* PREVIOUS WRITE LDO?           */
         TM    CRRINIO(CRRPTR),B'00100000'                         0512
         BNO   @RF00512                                            0512
*     DO;                                                          0513
*       IF(PROSETM4=PROSBLCK|       /* VALID READ MODIFIER?          */
*           PROSETM4=PROSMSG|PROSETM4=PROSTRNS|PROSETM4=PROSCONT) THEN
         LA    @15,48                                              0514
         AL    @15,CRRFMCB(,CRRPTR)                                0514
         CLI   PROSETM4(@15),X'01'                                 0514
         BE    @RT00514                                            0514
         CLI   PROSETM4(@15),X'02'                                 0514
         BE    @RT00514                                            0514
         CLI   PROSETM4(@15),X'03'                                 0514
         BE    @RT00514                                            0514
         CLI   PROSETM4(@15),X'83'                                 0514
         BNE   @RF00514                                            0514
@RT00514 DS    0H                                                  0515
*         DO;                       /* I/O HAS BEEN INITIATED        */
*                                                                  0515
*           /*********************************************************/
*           /*                                                       */
*           /* BUILD READ LCCW                                       */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0516
*           IF PROSETM4=PROSBLCK THEN/* READ BLOCK                   */
         L     @15,CRRFMCB(,CRRPTR)                                0516
         CLI   PROSETM4+48(@15),X'01'                              0516
         BNE   @RF00516                                            0516
*             LCCWRWOP=LRB;                                        0517
         L     @15,CRRCLCCW(,CRRPTR)                               0517
         NI    LCCWRWOP(@15),B'11000110'                           0517
         OI    LCCWRWOP(@15),B'00000110'                           0517
*           ELSE                                                   0518
*             IF PROSETM4=PROSMSG THEN/* READ MESSAGE                */
         B     @RC00516                                            0518
@RF00516 L     @15,CRRFMCB(,CRRPTR)                                0518
         CLI   PROSETM4+48(@15),X'02'                              0518
         BNE   @RF00518                                            0518
*               LCCWRWOP=LRM;                                      0519
         L     @15,CRRCLCCW(,CRRPTR)                               0519
         NI    LCCWRWOP(@15),B'11001010'                           0519
         OI    LCCWRWOP(@15),B'00001010'                           0519
*             ELSE                                                 0520
*               IF PROSETM4=PROSTRNS THEN/* READ TRANS               */
         B     @RC00518                                            0520
@RF00518 L     @15,CRRFMCB(,CRRPTR)                                0520
         CLI   PROSETM4+48(@15),X'03'                              0520
         BNE   @RF00520                                            0520
*                 LCCWRWOP=LRT;                                    0521
         L     @15,CRRCLCCW(,CRRPTR)                               0521
         NI    LCCWRWOP(@15),B'11001110'                           0521
         OI    LCCWRWOP(@15),B'00001110'                           0521
*               ELSE                                               0522
*                 LCCWRWOP=LRCONT;  /* READ CONT                     */
         B     @RC00520                                            0522
@RF00520 L     @15,CRRCLCCW(,CRRPTR)                               0522
         NI    LCCWRWOP(@15),B'11011010'                           0522
         OI    LCCWRWOP(@15),B'00011010'                           0522
*           CALL CSUBR5;            /* CHECK DATA CHAIN AND DIALOGUE */
@RC00520 DS    0H                                                  0523
@RC00518 DS    0H                                                  0523
@RC00516 BAL   @14,CSUBR5                                          0523
*         END;                                                     0524
*       ELSE                                                       0525
*         DO;                       /* VALID READ MODIFIER NOT GIVEN */
*                                                                  0525
         B     @RC00514                                            0525
@RF00514 DS    0H                                                  0526
*           /*********************************************************/
*           /*                                                       */
*           /* ERROR-NO VALID READ MODIFIER GIVEN                    */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0526
*           CRRRTNCD=CRRLOGIC;      /* SHOW LOGIC ERROR FOR FEEDBACK */
         MVI   CRRRTNCD(CRRPTR),X'08'                              0526
*           CRRFDB2=CRRINVRM;       /* SET ERROR CODE                */
         MVI   CRRFDB2(CRRPTR),X'2A'                               0527
*         END;                                                     0528
*       CRRFINI=ON;                 /* INDICATE DO PROCESSING      0529
*                                      FINISHED                      */
@RC00514 OI    CRRFINI(CRRPTR),B'00001000'                         0529
*     END;                          /* END-I/O HAS BEEN INITIATED    */
*   ELSE                                                           0531
*     DO;                           /* I/O HAS NOT BEEN INITIATED    */
*                                                                  0531
         B     @RC00512                                            0531
@RF00512 DS    0H                                                  0532
*       /*************************************************************/
*       /*                                                           */
*       /* GET ADDRESS OF OLDEST FSB ON FMCB DATA QUEUE              */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0532
*/* TPFEL (,FMCFBA) RETPTR(FSBPTR)                                   */
*                                                                  0532
*       DO;                         /* BEGIN TPFEL CODE GENERATION   */
*         DCL                                                      0533
*           FMZCA020 BIT(32) CONSTANT('80000000'X);                0533
*         DCL                                                      0534
*           FMZCB020 BIT(32) CONSTANT('7FFFFFFF'X);                0534
*         RFY                                                      0535
*          (GPR00P,                                                0535
*           GPR01P,                                                0535
*           GPR14P,                                                0535
*           GPR15P) RSTD;                                          0535
*         GPR15P=ADDR(FMCFBA);      /* ADDRESS QUEUE POINTER         */
         L     GPR15P,CRRFMCB(,CRRPTR)                             0536
         LA    GPR15P,FMCFBA(,GPR15P)                              0536
*         GPR14P=GPR15P->PABWEQA|FMZCA020;                         0537
         L     @12,@CF02549                                        0537
         L     GPR14P,PABWEQA(,GPR15P)                             0537
         OR    GPR14P,@12                                          0537
*         IF GPR14P=FMZCA020 THEN                                  0538
         CLR   GPR14P,@12                                          0538
         BE    @RT00538                                            0538
*           ;                                                      0539
*         ELSE                                                     0540
*           DO;                                                    0540
*             GPR00P=FMZCA020;      /* INITIALIZE QUIT FLAG          */
         L     GPR00P,@CF02549                                     0541
*             DO WHILE(GPR00P^=GPR14P->WKECHAIN);                  0542
         B     @DE00542                                            0542
@DL00542 DS    0H                                                  0543
*               GPR14P=GPR14P->WKECHAIN;/* SEARCH FOR END OF CHAIN   */
         L     GPR14P,WKECHAIN(,GPR14P)                            0543
*             END;                                                 0544
@DE00542 C     GPR00P,WKECHAIN(,GPR14P)                            0544
         BNE   @DL00542                                            0544
*           END;                                                   0545
*         GPR14P=GPR14P&FMZCB020;                                  0546
@RT00538 N     GPR14P,@CF02547                                     0546
*         FSBPTR=GPR14P;                                           0547
         LR    FSBPTR,GPR14P                                       0547
*         RFY                                                      0548
*          (GPR00P,                                                0548
*           GPR01P,                                                0548
*           GPR14P,                                                0548
*           GPR15P) UNRSTD;                                        0548
*       END;                        /* END TPFEL GENERATION          */
*       IF FSBPTR=0|FSBPTR=GATE0    /* IF QUEUE EMPTY                */
*                                                                  0550
*       /*************************************************************/
*       /*                                                           */
*       /* NO DATA PRESENT ON QUEUE                                  */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0550
*         THEN                                                     0550
         LTR   FSBPTR,FSBPTR                                       0550
         BZ    @RT00550                                            0550
         CL    FSBPTR,@CF02549                                     0550
         BNE   @RF00550                                            0550
@RT00550 DS    0H                                                  0551
*         CALL CSUBR4;              /* NO DATA-CHECK DATA EXPECTED   */
         BAL   @14,CSUBR4                                          0551
*       ELSE                                                       0552
*         DO;                       /* DATA PRESENT                  */
*                                                                  0552
         B     @RC00550                                            0552
@RF00550 DS    0H                                                  0553
*           /*********************************************************/
*           /*                                                       */
*           /* DATA PRESENT ON Q                                     */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0553
*           CRRFSB=FSBPTR;          /* SAVE FSB FOR MOVE ROUTINE     */
         ST    FSBPTR,CRRFSB(,CRRPTR)                              0553
*           CALL CSUBR6;            /* MOVE DATA TO USER'S BUFFER    */
         BAL   @14,CSUBR6                                          0554
*         END;                                                     0555
*     END;                                                         0556
@RC00550 DS    0H                                                  0557
*   RETPTR=CRRRTN2;                 /* GET RETURN ADDRESS            */
@RC00512 L     RETPTR,CRRRTN2(,CRRPTR)                             0557
*   END CSUBR2;                     /* RETURN TO CALLER              */
@EL00003 DS    0H                                                  0558
@EF00003 DS    0H                                                  0558
@ER00003 BR    @14                                                 0558
*CSUBR3:                                                           0559
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0559
CSUBR3   DS    0H                                                  0560
*   CRRRTN3=RETPTR;                 /* SAVE RETURN ADDRESS           */
         ST    RETPTR,CRRRTN3(,CRRPTR)                             0560
*/********************************************************************/
*/*                                                                  */
*/* ROUTINE NAME : CSUBR3 - VALIDATE LCCW                            */
*/*                                                                  */
*/* FUNCTION :                                                       */
*/*    IF THE COMMAND IS A READ MODIFY OR READ BUFFER AND THE        */
*/*    INPUT DEVICE IS A 3270 THEN THE LCCW IS BUILT AND             */
*/*    CSUBR5 IS INVOKED TO SET UP CERTAIN FLAGS FOR THE REQUEST.    */
*/*                                                                  */
*/* INPUT :  LDOPTR  (REG 9) - POINTS TO CURRENT LDO                 */
*/*                                                                  */
*/* OUTPUT : SAME                                                    */
*/*                                                                  */
*/* SUBROUTINES CALLED : CSUBR5 - CHECK DATA CHAIN,DIALOGUE          */
*/*                                                                  */
*/*                                                                  */
*/* MACROS USED : NONE                                               */
*/*                                                                  */
*/********************************************************************/
*                                                                  0561
*   IF LCPNXLCW->LCCWOP^=LTIC THEN                                 0561
         L     @15,LCPNXLCW(,LCPBPTR)                              0561
         CLI   LCCWOP(@15),X'08'                                   0561
         BE    @RF00561                                            0561
*     DCLLDO1=LDOPTR;               /* SAVE LDO ADDR IN LCPB         */
         ST    LDOPTR,DCLLDO1(,LCPBPTR)                            0562
*   ELSE                                                           0563
*     EVAL(CRRCLCCW+LDOFFSET)->LDOSAVE=LDOPTR;/* SAVE IN EXTENSION   */
         B     @RC00561                                            0563
@RF00561 LA    @15,32                                              0563
         AL    @15,CRRCLCCW(,CRRPTR)                               0563
         ST    LDOPTR,LDOSAVE(,@15)                                0563
*   IF LDOLEN=0 THEN                                               0564
@RC00561 LH    @15,LDOLEN(,LDOPTR)                                 0564
         N     @15,@CF04303                                        0564
         LTR   @15,@15                                             0564
         BNZ   @RF00564                                            0564
*     DO;                           /* ERROR-BUFFER LENGTH IS 0      */
*                                                                  0565
*       /*************************************************************/
*       /*                                                           */
*       /* ERROR-0 BUFFER LENGTH                                     */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0566
*       CRRFDB2=CRRIDA;             /* SET REASON CODE FOR FEEDBACK  */
         MVI   CRRFDB2(CRRPTR),X'17'                               0566
*       CRRRTNCD=CRRLOGIC;          /* SET LOGICAL I/O ERROR CODE    */
         MVI   CRRRTNCD(CRRPTR),X'08'                              0567
*       CRRFINI=ON;                 /* INDICATE DO PROCESSING      0568
*                                      FINISHED                      */
         OI    CRRFINI(CRRPTR),B'00001000'                         0568
*     END;                                                         0569
*   ELSE                                                           0570
*     IF LCCWRWOP=LRMOD|LCCWRWOP=LRBUF THEN                        0570
         B     @RC00564                                            0570
@RF00564 L     @15,CRRCLCCW(,CRRPTR)                               0570
         TM    LCCWRWOP(@15),B'00010010'                           0570
         BNO   @GL00007                                            0570
         TM    LCCWRWOP(@15),B'00101101'                           0570
         BZ    @RT00570                                            0570
@GL00007 L     @15,CRRCLCCW(,CRRPTR)                               0570
         TM    LCCWRWOP(@15),B'00010110'                           0570
         BNO   @RF00570                                            0570
         TM    LCCWRWOP(@15),B'00101001'                           0570
         BNZ   @RF00570                                            0570
@RT00570 DS    0H                                                  0571
*       DO;                         /* READ BUFFER OR READ MODIFIED  */
*         IF(DEVCHAR2>=DEV3277&DEVCHAR2<=DEV3275) THEN             0572
*                                                                  0572
         L     @15,CRRFMCB(,CRRPTR)                                0572
         LA    @12,36                                              0572
         AL    @12,FMCDNCBA(,@15)                                  0572
         CLI   DEVCHAR2(@12),X'19'                                 0572
         BL    @RF00572                                            0572
         CLI   DEVCHAR2(@12),X'1C'                                 0572
         BH    @RF00572                                            0572
*           /*********************************************************/
*           /*                                                       */
*           /* 3270 COMMAND AND DEVICE TYPE 3270                     */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0573
*           CALL CSUBR5;            /* CHECK DATA CHAIN AND DIALOGUE */
         BAL   @14,CSUBR5                                          0573
*         ELSE                                                     0574
*           DO;                     /* DEVICE IS NOT A 3270          */
*                                                                  0574
         B     @RC00572                                            0574
@RF00572 DS    0H                                                  0575
*             /*******************************************************/
*             /*                                                     */
*             /* ERROR-DEVICE NOT 3270                               */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0575
*             CRRFDB2=CRRMBTWD;     /* SET REASON CODE FOR FEEDBACK  */
         MVI   CRRFDB2(CRRPTR),X'25'                               0575
*             CRRRTNCD=CRRLOGIC;    /* SET LOGICAL I/O ERROR CODE    */
         MVI   CRRRTNCD(CRRPTR),X'08'                              0576
*           END;                                                   0577
*         CRRFINI=ON;               /* INDICATE DO PROCESSING      0578
*                                      FINISHED                      */
@RC00572 OI    CRRFINI(CRRPTR),B'00001000'                         0578
*       END;                                                       0579
*     ELSE                                                         0580
*       ;                           /* NOT READ MODIFIED OR READ   0580
*                                      BUFFER                        */
@RF00570 DS    0H                                                  0581
*   RETPTR=CRRRTN3;                 /* GET RETURN ADDRESS            */
@RC00564 L     RETPTR,CRRRTN3(,CRRPTR)                             0581
*   END CSUBR3;                     /* RETURN TO CALLER              */
@EL00004 DS    0H                                                  0582
@EF00004 DS    0H                                                  0582
@ER00004 BR    @14                                                 0582
*                                                                  0583
*/********************************************************************/
*/*                                                                  */
*/* ROUTINE NAME : CSUBR4 -LCCW BUILDER                              */
*/*                                                                  */
*/* FUNCTION :                                                       */
*/*   IF DATA EXPECTED INDICATOR IS ON, THIS READ CAN BE SATISFIED   */
*/*   BY THE DATA WHICH WILL ARRIVE FOR A PREVIOUSLY ISSUED SLICIT   */
*/*   OR READ REQUEST.  REQUEST FINISH IS NOTIFIED TO WAIT FOR       */
*/*   THAT DATA TO ARRIVE.  IF THE INDICATOR IS NOT ON, A READ       */
*/*   LCCW IS BUILT. IF THIS IS A 3270 DEVICE IN SOME CASES AN LCPB  */
*/*   IS NOT SENT TO TPIOS. THE ONLY TIME ONE IS IS WHEN THIS IS THE */
*/*   FIRST I/O OPERATION TO THE GENERAL POLL TYPE DEVICE . IN ANY   */
*/*   OTHER CASE THE RPL IS QUEUED, AND THE PREVIOS I/O FLAG IS TURN-*/
*/*   ED ON IN THE CRR.                                              */
*/*                                                                  */
*/* INPUT :  LDOPTR  (REG 9) - POINTS TO CURRENT LDO                 */
*/*                                                                  */
*/* OUTPUT : SAME                                                    */
*/*                                                                  */
*/* SUBROUTINES CALLED : CSUBR5 - CHECK DATA CHAINING                */
*/*                                                                  */
*/* MACROS USED :  NONE                                              */
*/*                                                                  */
*/********************************************************************/
*                                                                  0583
*CSUBR4:                                                           0583
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0583
CSUBR4   DS    0H                                                  0584
*   CRRRTN3=RETPTR;                 /* SAVE RETURN ADDRESS           */
         ST    RETPTR,CRRRTN3(,CRRPTR)                             0584
*   IF FMCFLGA0=ON THEN             /* DATA EXPECTED                 */
         L     @15,CRRFMCB(,CRRPTR)                                0585
         TM    FMCFLGA0(@15),B'10000000'                           0585
         BNO   @RF00585                                            0585
*     DO;                                                          0586
*                                                                  0586
*       /*************************************************************/
*       /*                                                           */
*       /* DATA EXPECTED FROM DEVICE                                 */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0587
*       CRRPREIO=ON;                /* AWAITING PREVIOUS I/O       0587
*                                      OPERATION                     */
         OI    CRRPREIO(CRRPTR),B'00010000'                        0587
*       RPLAAREA=LDOPTR;            /* POINT TO LDO IN CASE OF RESET */
         LR    RPLAAREA,LDOPTR                                     0588
*     END;                                                         0589
*   ELSE                                                           0590
*     DO;                                                          0590
         B     @RC00585                                            0590
@RF00585 DS    0H                                                  0591
*       IF(DEVTCODE>=DEV3277&DEVTCODE<=DEV3275)&/*           @ZM02162*/
*                                                                  0591
*       /*************************************************************/
*       /*                                                           */
*       /* THIS IS A GENERAL POLL DEVICE AL DATA COMING IN FROM THIS */
*       /* DEVICE IS TO BE UNSOLICITED. NO I/O REQUEST IS TO GO OUT  */
*       /* TO THE DEVICE IF THIS IS NOT THE FIRST I/O REQUEST TO IT. */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0591
*           FMCFLGB7=ON THEN                                       0591
         L     @15,CRRFMCB(,CRRPTR)                                0591
         LA    @12,36                                              0591
         AL    @12,FMCDNCBA(,@15)                                  0591
         CLI   DEVTCODE(@12),X'19'                                 0591
         BL    @RF00591                                            0591
         CLI   DEVTCODE(@12),X'1C'                                 0591
         BH    @RF00591                                            0591
         TM    FMCFLGB7(@15),B'00000001'                           0591
         BNO   @RF00591                                            0591
*         DO;                       /* NOT FIRST OPER.       @ZM02162*/
*           CRRPREIO=ON;            /* SET AWAITING PREV     @XM10597*/
         OI    CRRPREIO(CRRPTR),B'00010000'                        0593
*           RFY                                                    0594
*            (REG10,                                               0594
*             REG11) RSTD;                                         0594
*           REG10=FMCCMPS2;         /* GET A0 FLAG VALUE     @XM10597*/
         L     REG10,FMCCMPS2(,@15)                                0595
*CS0:                                                              0596
*           REG11=REG10|FLGA0ON;    /* RESET THE VALUE       @XM10597*/
CS0      LR    REG11,REG10                                         0596
         O     REG11,@CF02549                                      0596
*           CS(REG10,REG11,FMCCMPS2);/* CHANGE FMCCMPS2      @XM10597*/
         L     @15,CRRFMCB(,CRRPTR)                                0597
         CS    REG10,@11,FMCCMPS2(@15)                             0597
*           BC(7,CS0);              /* NO CHANGE,RETRY       @XM10597*/
         BC    7,CS0                                               0598
*           CRRDEXP=ON;             /* SET DATA EXPECTED     @XM10597*/
         OI    CRRDEXP(CRRPTR),B'10000000'                         0599
*         END;                      /* END NOT FIRST         @XM10597*/
*                                                                  0600
*       /*************************************************************/
*       /*                                                           */
*       /* THIS IS THE FIRST I/O OPERATION TO THIS DEVICE,RESET THE  */
*       /* I/O FLAG IN THE FMCB, AND PERMIT THIS REQUEST TO GO OUT   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0601
*       ELSE                                                       0601
*         IF(DEVTCODE>=DEV3277&DEVTCODE<=DEV3275) THEN             0601
         B     @RC00591                                            0601
@RF00591 L     @15,CRRFMCB(,CRRPTR)                                0601
         LA    @12,36                                              0601
         AL    @12,FMCDNCBA(,@15)                                  0601
         CLI   DEVTCODE(@12),X'19'                                 0601
         BL    @RF00601                                            0601
         CLI   DEVTCODE(@12),X'1C'                                 0601
         BH    @RF00601                                            0601
*           DO;                     /*                       @XM10338*/
*             REG10=FMCCMPS2;       /* GET B7 VALUE          @XM10597*/
         L     REG10,FMCCMPS2(,@15)                                0603
*CSB7:                                                             0604
*             REG11=REG10|FLGB7ON;  /* TURN ON THE FLAG      @XM10597*/
CSB7     LR    REG11,REG10                                         0604
         O     REG11,@CF03732                                      0604
*             CS(REG10,REG11,FMCCMPS2);/* CHANGE FMCCMPS2    @XM10597*/
         L     @15,CRRFMCB(,CRRPTR)                                0605
         CS    REG10,@11,FMCCMPS2(@15)                             0605
*             BC(7,CSB7);           /* FAILED,RETRY          @XM10597*/
         BC    7,CSB7                                              0606
*           END;                    /* END FIRST OPER DO     @XM10597*/
*         ELSE                                                     0608
*           ;                       /*                       @ZM02162*/
@RF00601 DS    0H                                                  0609
*       IF CRRPREIO=OFF THEN        /* NOT AWAITING PREVIOS I/O    0609
*                                                            @ZM02162*/
@RC00591 TM    CRRPREIO(CRRPTR),B'00010000'                        0609
         BNZ   @RF00609                                            0609
*         IF(PROSETM4=PROSBLCK|     /* VALID READ MODIFIER GIVEN?    */
*             PROSETM4=PROSMSG|PROSETM4=PROSTRNS|PROSETM4=PROSCONT)
*           THEN                                                   0610
         LA    @15,48                                              0610
         AL    @15,CRRFMCB(,CRRPTR)                                0610
         CLI   PROSETM4(@15),X'01'                                 0610
         BE    @RT00610                                            0610
         CLI   PROSETM4(@15),X'02'                                 0610
         BE    @RT00610                                            0610
         CLI   PROSETM4(@15),X'03'                                 0610
         BE    @RT00610                                            0610
         CLI   PROSETM4(@15),X'83'                                 0610
         BNE   @RF00610                                            0610
@RT00610 DS    0H                                                  0611
*           DO;                     /* VALID READ MODIFIER           */
*                                                                  0611
*             /*******************************************************/
*             /*                                                     */
*             /* BUILD READ LCCW                                     */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0612
*             IF PROSETM4=PROSBLCK THEN/* READ BLOCK                 */
         L     @15,CRRFMCB(,CRRPTR)                                0612
         CLI   PROSETM4+48(@15),X'01'                              0612
         BNE   @RF00612                                            0612
*               LCCWRWOP=LRB;                                      0613
         L     @15,CRRCLCCW(,CRRPTR)                               0613
         NI    LCCWRWOP(@15),B'11000110'                           0613
         OI    LCCWRWOP(@15),B'00000110'                           0613
*             ELSE                                                 0614
*               IF PROSETM4=PROSMSG THEN/* READ MESSAGE              */
         B     @RC00612                                            0614
@RF00612 L     @15,CRRFMCB(,CRRPTR)                                0614
         CLI   PROSETM4+48(@15),X'02'                              0614
         BNE   @RF00614                                            0614
*                 LCCWRWOP=LRM;                                    0615
         L     @15,CRRCLCCW(,CRRPTR)                               0615
         NI    LCCWRWOP(@15),B'11001010'                           0615
         OI    LCCWRWOP(@15),B'00001010'                           0615
*               ELSE                                               0616
*                 IF PROSETM4=PROSTRNS THEN/* READ TRANS             */
         B     @RC00614                                            0616
@RF00614 L     @15,CRRFMCB(,CRRPTR)                                0616
         CLI   PROSETM4+48(@15),X'03'                              0616
         BNE   @RF00616                                            0616
*                   LCCWRWOP=LRT;                                  0617
         L     @15,CRRCLCCW(,CRRPTR)                               0617
         NI    LCCWRWOP(@15),B'11001110'                           0617
         OI    LCCWRWOP(@15),B'00001110'                           0617
*                 ELSE                                             0618
*                   LCCWRWOP=LRCONT;/* READ CONT                     */
         B     @RC00616                                            0618
@RF00616 L     @15,CRRCLCCW(,CRRPTR)                               0618
         NI    LCCWRWOP(@15),B'11011010'                           0618
         OI    LCCWRWOP(@15),B'00011010'                           0618
*             CALL CSUBR5;          /* CHECK DATA CHAIN AND DIALOGUE */
@RC00616 DS    0H                                                  0619
@RC00614 DS    0H                                                  0619
@RC00612 BAL   @14,CSUBR5                                          0619
*           END;                                                   0620
*         ELSE                                                     0621
*           DO;                     /* INVALID READ MODIFIER         */
*                                                                  0621
         B     @RC00610                                            0621
@RF00610 DS    0H                                                  0622
*             /*******************************************************/
*             /*                                                     */
*             /* ERROR-NO VALID READ MODIFIER GIVEN                  */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0622
*             CRRRTNCD=CRRLOGIC;    /* SHOW LOGIC ERROR FOR FEEDBACK */
         MVI   CRRRTNCD(CRRPTR),X'08'                              0622
*             CRRFDB2=CRRINVRM;     /* SET ERROR CODE                */
         MVI   CRRFDB2(CRRPTR),X'2A'                               0623
*           END;                                                   0624
*       ELSE                                                       0625
*         ;                         /*                       @ZM02162*/
@RF00609 DS    0H                                                  0626
*     END;                          /* DATA NOT EXPECTED     @DM14120*/
@RC00609 DS    0H                                                  0627
*   CRRFINI=ON;                     /* INDICATE DO PROCESSING      0627
*                                      FINISHED                      */
@RC00585 OI    CRRFINI(CRRPTR),B'00001000'                         0627
*   RETPTR=CRRRTN3;                 /* GET RETURN ADDRESS            */
         L     RETPTR,CRRRTN3(,CRRPTR)                             0628
*   END CSUBR4;                                                    0629
@EL00005 DS    0H                                                  0629
@EF00005 DS    0H                                                  0629
@ER00005 BR    @14                                                 0629
*CSUBR5:                                                           0630
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0630
*                                                                  0630
CSUBR5   DS    0H                                                  0631
*/********************************************************************/
*/*                                                                  */
*/* ROUTINE NAME : CSUBR5 - CHECK DATA CHAIN AND DIALOGUE            */
*/*                                                                  */
*/* FUNCTION :                                                       */
*/*    IF LDO IS DATA CHAINED, UPDATE CURRENT LDO POINTER TO FIRST   */
*/*    NON-DATA CHAINED LDO.  SET SWITCHES TO START I/O.  INDICATE   */
*/*    DATA IS NOW EXPECTED FROM THE DEVICE AND THAT A READ HAS      */
*/*    BEEN ISSUED TO THE DEVICE.  TEST WHETHER USER WISHES TO BE    */
*/*    IN DIALOGUE WITH A SPECIFIC TERMINAL OR WITH ANY TERMINAL.    */
*/*                                                                  */
*/* INPUT :  LDOPTR  (REG 9) - POINTS TO CURRENT LDO                 */
*/*                                                                  */
*/* OUTPUT : SAME                                                    */
*/*                                                                  */
*/* SUBROUTINES CALLED : UPLDOPTR - FIND NON-DATA CHAINED LDO        */
*/*                                                                  */
*/* MACROS USED : NONE                                               */
*/*                                                                  */
*/********************************************************************/
*                                                                  0631
*   CRRRTN4=RETPTR;                 /* SAVE RETURN ADDRESS           */
         ST    RETPTR,CRRRTN4(,CRRPTR)                             0631
*   IF LDOACHN=ON THEN                                             0632
         TM    LDOACHN(LDOPTR),B'10000000'                         0632
         BNO   @RF00632                                            0632
*     CALL UPLDOPTR;                /* DATA CHAINED                  */
         BAL   @14,UPLDOPTR                                        0633
*   ELSE                                                           0634
*     ;                             /* NOT DATA CHAINED              */
@RF00632 DS    0H                                                  0635
*   IF CRRFINI=ON THEN                                             0635
         TM    CRRFINI(CRRPTR),B'00001000'                         0635
         BO    @RT00635                                            0635
*     ;                             /* ERROR - DO NOT START I/O      */
*                                                                  0636
*   /*****************************************************************/
*   /*                                                               */
*   /* INDICATE I/O TO BE STARTED                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0637
*   ELSE                                                           0637
*     DO;                           /* NO ERRORS FOUND BY UPLDOPTR   */
*       RFY                                                        0638
*        (REG10,                                                   0638
*         REG11) RSTD;                                             0638
*CS1:                                                              0639
*       REG10=FMCCMPS2;             /* REFERENCE OLD FLAG VALUE      */
CS1      L     @15,CRRFMCB(,CRRPTR)                                0639
         L     REG10,FMCCMPS2(,@15)                                0639
*       REG11=REG10|FLGA06ON;       /* SET DATA EXPECTED AND READ  0640
*                                      DONE TO DEVICE                */
         LR    REG11,REG10                                         0640
         O     REG11,@CF04162                                      0640
*       CS(REG10,REG11,FMCCMPS2);   /* SET NEW VALUE IN FMCB         */
         CS    REG10,@11,FMCCMPS2(@15)                             0641
*       BC(7,CS1);                  /* TRY AGAIN IF FAILURE          */
         BC    7,CS1                                               0642
*       CRRDEXP=ON;                 /* SET DATA EXPECTED IN CRR      */
         OI    CRRDEXP(CRRPTR),B'10000000'                         0643
*       CRRINIO=ON;                 /* I/O REQUEST TO BE INITIATED   */
         OI    CRRINIO(CRRPTR),B'00100000'                         0644
*CS2:                                                              0645
*       REG10=FMCCMPS2;             /* REFERENCE OLD FLAG VALUE      */
CS2      L     @15,CRRFMCB(,CRRPTR)                                0645
         L     REG10,FMCCMPS2(,@15)                                0645
*       IF RPLDLGIN=OFF THEN        /* TEST FOR CONTINUE ANY         */
         L     @15,CRRARPL(,CRRPTR)                                0646
         TM    RPLDLGIN(@15),B'10000000'                           0646
         BNZ   @RF00646                                            0646
*         REG11=REG10&FLGA1OFF;     /* RESET SATISFY SPECIFIC RD     */
         LR    REG11,REG10                                         0647
         N     REG11,@CF02553                                      0647
*       ELSE                                                       0648
*         REG11=REG10|FLGA1ON;      /* SET SATISFY SPECIFIC READ     */
         B     @RC00646                                            0648
@RF00646 LR    REG11,REG10                                         0648
         O     REG11,@CF02555                                      0648
*       CS(REG10,REG11,FMCCMPS2);   /* SET NEW VALUE IN FMCB         */
@RC00646 L     @15,CRRFMCB(,CRRPTR)                                0649
         CS    REG10,@11,FMCCMPS2(@15)                             0649
*       BC(7,CS2);                  /* TRY AGAIN IF FAILURE          */
         BC    7,CS2                                               0650
*       RFY                                                        0651
*        (REG10,                                                   0651
*         REG11) UNRSTD;                                           0651
*     END;                                                         0652
*   RETPTR=CRRRTN4;                 /* GET RETURN ADDRESS            */
@RT00635 L     RETPTR,CRRRTN4(,CRRPTR)                             0653
*   END CSUBR5;                     /* RETURN TO CALLER              */
@EL00006 DS    0H                                                  0654
@EF00006 DS    0H                                                  0654
@ER00006 BR    @14                                                 0654
*CSUBR6:                                                           0655
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0655
*                                                                  0655
CSUBR6   DS    0H                                                  0656
*/********************************************************************/
*/*                                                                  */
*/* ROUTINE NAME :  SUBR6 - MOVE DATA                                */
*/*                                                                  */
*/* FUNCTION :                                                       */
*/*    SUBR6 SET UP THE PARAMETER LIST FOR THE MOVE ROUTINE          */
*/*    AND CALLS CSUBR7 TO ACTUALLY MOVE THE DATA. SUBR7 IS          */
*/*    CALLED AS MANY TIMES AS NECESSARY UNTIL ALL THE DATA          */
*/*    IS MOVED.                                                     */
*/*                                                                  */
*/* INPUT :  LDOPTR (REG 10) - ADDRESS OF LDO                        */
*/*                                                                  */
*/* OUTPUT :    ALL DATA IN FSB MOVED TO USER'S AREA                 */
*/*                                                                  */
*/* SUBROUTINES CALLED :                                             */
*/*         SUBR7 - MOVE DATA                                        */
*/*                                                                  */
*/*  MACROS USED :  NONE                                             */
*/*                                                                  */
*/********************************************************************/
*                                                                  0656
*   CRRRTN3=RETPTR;                 /* SAVE RETURN ADDRESS           */
*                                                                  0656
         ST    RETPTR,CRRRTN3(,CRRPTR)                             0656
*   /*****************************************************************/
*   /*                                                               */
*   /* SET UP INPUT PARAMETERS FOR THE MOVE ROUTINE TO MOVE DATA FROM*/
*   /* THE FSB TO THE USER'S BUFFER                                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0657
*   ATCVTPTR=CRRATCVT;              /* BASE FOR VTAM CVT             */
         L     ATCVTPTR,CRRATCVT(,CRRPTR)                          0657
*   CRRBARAD=LDOADDR;               /* ADDR OF USER'S INPUT AREA     */
         L     @15,LDOADDR(,LDOPTR)                                0658
         ST    @15,CRRBARAD(,CRRPTR)                               0658
*   CRRBLDAD=CRRCLDO;               /* CURRENT LDO FOR MOVE          */
         L     @15,CRRCLDO(,CRRPTR)                                0659
         ST    @15,CRRBLDAD(,CRRPTR)                               0659
*   CRRBTLEN=CRRBTLEN&&CRRBTLEN;    /* CLEAR RESIDUAL COUNT          */
         L     @15,CRRBTLEN(,CRRPTR)                               0660
         LR    @12,@15                                             0660
         XR    @12,@15                                             0660
         ST    @12,CRRBTLEN(,CRRPTR)                               0660
*   CRRBLEN=LDOLEN;                 /* SIZE OF CURRENT INPUT AREA    */
         LH    @15,LDOLEN(,LDOPTR)                                 0661
         N     @15,@CF04303                                        0661
         STH   @15,CRRBLEN(,CRRPTR)                                0661
*   DO WHILE(CRRSW3=OFF);           /* CONTROL LOOP FOR MOVE         */
*                                                                  0662
         B     @DE00662                                            0662
@DL00662 DS    0H                                                  0663
*     /***************************************************************/
*     /*                                                             */
*     /* CYCLE UNTIL MOVE COMPLETE                                   */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0663
*     CALL CSUBR7;                  /* MOVE DATA                     */
         BAL   @14,CSUBR7                                          0663
*   END;                            /* END OF DO WHILE LOOP          */
@DE00662 TM    CRRSW3(CRRPTR),B'00010000'                          0664
         BZ    @DL00662                                            0664
*   CRRFINI=ON;                     /* INDICATE DO PROCESSING      0665
*                                      FINISHED                      */
         OI    CRRFINI(CRRPTR),B'00001000'                         0665
*   RETPTR=CRRRTN3;                 /* GET RETURN ADDRESS            */
         L     RETPTR,CRRRTN3(,CRRPTR)                             0666
*   END CSUBR6;                     /* RETURN TO CALLER              */
@EL00007 DS    0H                                                  0667
@EF00007 DS    0H                                                  0667
@ER00007 BR    @14                                                 0667
*                                                                  0668
*/********************************************************************/
*/*                                                                  */
*/* ROUTINE NAME :  SUBR7 - MOVE DATA TO USER AREA                   */
*/*                                                                  */
*/* FUNCTION :                                                       */
*/*    SUBR7 CALLS INPUT BUFFER MOVE(ISTDCC60) TO MOVE THE DATA      */
*/*    AND HANDLES THE FEEDBACK FROM THE MOVE ROUTINE                */
*/*                                                                  */
*/* INPUT :  LDOPTR (REG 10) - ADDRESS OF LDO                        */
*/*                                                                  */
*/* OUTPUT :  FEEDBACK STATUS SET IN THE CRR- SOME OR ALL DATA MOVED */
*/*                                                                  */
*/* SUBROUTINES CALLED :                                             */
*/*         ISTDCC60 - INPUT BUFFER MOVE                             */
*/*         SUBR9    - HANDLE RETURN CODE ZERO                       */
*/*         SUBR10   - CHECK FOR TRUNC/KEEP                          */
*/*                                                                  */
*/*  MACROS USED :  VMDESET, VSETLCK                                 */
*/*                                                                  */
*/********************************************************************/
*                                                                  0668
*CSUBR7:                                                           0668
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0668
CSUBR7   DS    0H                                                  0669
*   CRRRTN6=RETPTR;                 /* SAVE RETURN ADDRESS           */
*                                                                  0669
         ST    RETPTR,CRRRTN6(,CRRPTR)                             0669
*   /*****************************************************************/
*   /*                                                               */
*   /* INVOKE ISTDCC60 TO MOVE THE DATA TO THE USER'S BUFFERS        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0670
*   RFY                                                            0670
*    (GPR10F,                                                      0670
*     GPR14F) RSTD;                 /*                       @Z30APGE*/
*   STM(GPR10F,GPR14F,CRRSAVE);     /* SAVE REGS ACROSS SETLOCK    0671
*                                                            @Z30APGE*/
         STM   GPR10F,GPR14F,CRRSAVE(CRRPTR)                       0671
*   GPR10F=CRRPTR;                  /* SAVE REG 13           @Z30APGE*/
         LR    GPR10F,CRRPTR                                       0672
*C11LOCK:                                                          0673
*   DO;                             /* SETLOCK (OBTAIN) MODE(UNCOND)
*                                      TYPE(LOCAL) RELATED(LOCAL,ISTD
*                                      CC11(C11UNLCK))               */
C11LOCK  DS    0H                                                  0674
*     RFY                                                          0674
*      (GPR11P,                                                    0674
*       GPR12P,                                                    0674
*       GPR13P,                                                    0674
*       GPR14P) RSTD;                                              0674
*     GPR13P=PSALITA;               /* ADDRESS OF LOCK INTERFACE   0675
*                                      TABLE.                        */
         L     GPR13P,PSALITA                                      0675
*     GEN(LM GPR11P,GPR13P,576(GPR13P));/* LOAD LOCKWORD, CLHT AND 0676
*                                      ENTRY ADRS.                   */
         LM GPR11P,GPR13P,576(GPR13P)
*     GEN(BALR GPR14P,GPR13P);      /* BALR TO SETLOCK RTN.          */
         BALR GPR14P,GPR13P
*     RFY                                                          0678
*      (GPR11P,                                                    0678
*       GPR12P,                                                    0678
*       GPR13P,                                                    0678
*       GPR14P) UNRSTD;                                            0678
*   END;                            /* SETLOCK (OBTAIN) MODE(UNCOND)
*                                      TYPE(LOCAL) RELATED(LOCAL,ISTD
*                                      CC11(C11UNLCK))       @Z30APGE*/
*   CRRPTR=GPR10F;                  /* RESTORE REG 13        @Z30APGE*/
         LR    CRRPTR,GPR10F                                       0680
*   LM(GPR10F,GPR14F,CRRSAVE);      /* RESTORE REGS          @Z30APGE*/
         LM    GPR10F,GPR14F,CRRSAVE(CRRPTR)                       0681
*   CRRPTR=ADDR(CRRSAVE1);          /* SAVE AREA FOR MOVE ROUTINE    */
         LA    @15,CRRSAVE1(,CRRPTR)                               0682
         LR    CRRPTR,@15                                          0682
*   RFY                                                            0683
*    (GPR10F,                                                      0683
*     GPR14F) UNRSTD;               /*                       @Z30APGE*/
*   CALL ATCDCC60;                  /* INVOKE MOVE ROUTINE           */
         L     @15,ATCDCC60(,ATCVTPTR)                             0684
         BALR  @14,@15                                             0684
*   CRRPTR=ADDR(CRRSPACE);          /* REBASE CRR            @D8388NL*/
         L     CRRPTR,RPHCRR(,RPHPTR)                              0685
         LA    CRRPTR,CRRSPACE+312(,CRRPTR)                        0685
*   RPLRLEN=CRRBTLEN;               /* SET AMT OF DATA MOVED IN RPL  */
         L     @15,CRRARPL(,CRRPTR)                                0686
         L     @12,CRRBTLEN(,CRRPTR)                               0686
         ST    @12,RPLRLEN(,@15)                                   0686
*   RFY                                                            0687
*    (GPR10F,                                                      0687
*     GPR14F) RSTD;                 /*                       @Z30APGE*/
*   STM(GPR10F,GPR14F,CRRSAVE);     /* SAVE REGS ACROSS SETLOCK    0688
*                                                            @Z30APGE*/
         STM   GPR10F,GPR14F,CRRSAVE(CRRPTR)                       0688
*   GPR10F=CRRPTR;                  /* SAVE REG 13           @Z30APGE*/
         LR    GPR10F,CRRPTR                                       0689
*C11UNLCK:                                                         0690
*   DO;                             /* SETLOCK (RELEASE) TYPE(LOCAL)
*                                      RELATED(LOCAL,ISTDCC11(C11LOCK
*                                      ))                            */
C11UNLCK DS    0H                                                  0691
*     RFY                                                          0691
*      (GPR11P,                                                    0691
*       GPR12P,                                                    0691
*       GPR13P,                                                    0691
*       GPR14P) RSTD;                                              0691
*     GPR13P=PSALITA;               /* ADDRESS OF LOCK INTERFACE   0692
*                                      TABLE.                        */
         L     GPR13P,PSALITA                                      0692
*     GEN(LM GPR11P,GPR13P,588(GPR13P));/* LOAD LOCKWORD, CLHT AND 0693
*                                      ENTRY ADRS.                   */
         LM GPR11P,GPR13P,588(GPR13P)
*     GEN(BALR GPR14P,GPR13P);      /* BALR TO SETLOCK RTN.          */
         BALR GPR14P,GPR13P
*     RFY                                                          0695
*      (GPR11P,                                                    0695
*       GPR12P,                                                    0695
*       GPR13P,                                                    0695
*       GPR14P) UNRSTD;                                            0695
*   END;                            /* SETLOCK (RELEASE) TYPE(LOCAL)
*                                      RELATED(LOCAL,ISTDCC11(C11LOCK
*                                      ))                    @Z30APGE*/
*   CRRPTR=GPR10F;                  /* RESTORE REG 13        @Z30APGE*/
         LR    CRRPTR,GPR10F                                       0697
*   LM(GPR10F,GPR14F,CRRSAVE);      /* RESTORE REGS          @Z30APGE*/
         LM    GPR10F,GPR14F,CRRSAVE(CRRPTR)                       0698
*   RFY                                                            0699
*    (GPR10F,                                                      0699
*     GPR14F) UNRSTD;               /*                       @Z30APGE*/
*                                                                  0699
*   /*****************************************************************/
*   /*                                                               */
*   /* THE MOVE ROUTINE WILL RETURN A CODE OF 0, 4 , OR 8 TO INDICATE*/
*   /* THE STATUS AFTER THE MOVE. A CODE OF 8 INDICATES THAT NO DATA */
*   /* WAS MOVED DUE TO AN ERROR CONDITION. THE MOVE ROUTINE SET THE */
*   /* ERROR STATUS IN THE CRR. THE FSB SHOULD REMAIN ON THE DATA    */
*   /* QUEUE. A CODE OF 4 INDICATES THAT THE USER'S BUFFER WAS       */
*   /* FILLED, BUT THERE IS MORE DATA IN THE FSB. CSUBR10 WILL BE    */
*   /* INVOKED TO HANDLE THIS CONDITION. A CODE OF 0 INDICATES THAT  */
*   /* ALL THE DATA ASSOCIATED WITH ONE FSB WAS MOVED. CSUBR9 WILL BE*/
*   /* INVOKED TO DETERMINE IF ANOTHER FSB SHOULD BE REFERENCED AND  */
*   /* THE MOVE SHOULD BE CONTINUED.                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0700
*   IF CRRBRTCD=CRRBEROR THEN                                      0700
         CLI   CRRBRTCD(CRRPTR),8                                  0700
         BNE   @RF00700                                            0700
*     DO;                           /* ERROR - NO DATA WAS MOVED     */
*                                                                  0701
*       /*************************************************************/
*       /*                                                           */
*       /* ERROR-NO DATA MOVED                                       */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0702
*       CRRCLDO=CRRBLDAD;           /* SAVE INVALID LDO              */
         L     @15,CRRBLDAD(,CRRPTR)                               0702
         ST    @15,CRRCLDO(,CRRPTR)                                0702
*       CRRSW3=ON;                  /* INDICATE MOVE COMPLETED       */
         OI    CRRSW3(CRRPTR),B'00010000'                          0703
*     END;                                                         0704
*   ELSE                                                           0705
*     DO;                           /* DATA WAS MOVED                */
*                                                                  0705
         B     @RC00700                                            0705
@RF00700 DS    0H                                                  0706
*       /*************************************************************/
*       /*                                                           */
*       /* SET FEEDBACK STATUS IN CRR FROM FSB                       */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0706
*       CRRRTNCD=FSBSRCAT;          /* MAJOR RETURN CODE             */
         MVC   CRRRTNCD(1,CRRPTR),FSBSRCAT(FSBPTR)                 0706
*       CRRFDB2=FSBMNRCD;           /* MINOR RETURN CODE             */
         MVC   CRRFDB2(1,CRRPTR),FSBMNRCD(FSBPTR)                  0707
*       CRRFDB3=FSBERC;             /* DATA FLAGS                    */
         MVC   CRRFDB3(1,CRRPTR),FSBERC(FSBPTR)                    0708
*       CRRESR1=FSBDMGRS;           /* SYSTEM RESPONSE               */
         MVC   CRRESR1(1,CRRPTR),FSBDMGRS(FSBPTR)                  0709
*       CRRESR2=FSBEXTRS;           /* EXTENDED SYSTEM RESPONSE      */
         MVC   CRRESR2(1,CRRPTR),FSBEXTRS(FSBPTR)                  0710
*       IF CRRRTNCD=CRRPHYSC THEN                                  0711
         CLI   CRRRTNCD(CRRPTR),X'0C'                              0711
         BNE   @RF00711                                            0711
*         IF CRRSTSAV=ON THEN                                      0712
         TM    CRRSTSAV(CRRPTR),B'00000001'                        0712
         BNO   @RF00712                                            0712
*           CRRDSB=FSBDMGRS;        /* COPY SENSE DATA               */
         MVC   CRRDSB(2,CRRPTR),FSBDMGRS(FSBPTR)                   0713
*         ELSE                                                     0714
*           ;                       /* NO SENSE DATA TO MOVE         */
@RF00712 DS    0H                                                  0715
*       ELSE                                                       0715
*         ;                                                        0715
@RF00711 DS    0H                                                  0716
*       IF CRRBRTCD=CRRBMDAT THEN   /* BUFFER WAS FILLED             */
*                                                                  0716
         CLI   CRRBRTCD(CRRPTR),4                                  0716
         BNE   @RF00716                                            0716
*         /***********************************************************/
*         /*                                                         */
*         /* BUFFER FILLED-NOT ALL DATA MOVED                        */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0717
*         CALL CSUBR10;             /* CHECK TRUNC/KEEP OPTION       */
*                                                                  0717
         BAL   @14,CSUBR10                                         0717
*       /*************************************************************/
*       /*                                                           */
*       /* ALL DATA FROM CURRENT FSB MOVED                           */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0718
*       ELSE                                                       0718
*         CALL CSUBR9;              /* ANALYZE FOR RETURN CODE 0     */
         B     @RC00716                                            0718
@RF00716 BAL   @14,CSUBR9                                          0718
*     END;                                                         0719
@RC00716 DS    0H                                                  0720
*   RETPTR=CRRRTN6;                 /* GET RETURN ADDRESS            */
@RC00700 L     RETPTR,CRRRTN6(,CRRPTR)                             0720
*   END CSUBR7;                     /* RETURN TO CALLER              */
@EL00008 DS    0H                                                  0721
@EF00008 DS    0H                                                  0721
@ER00008 BR    @14                                                 0721
*FREEFSB:                                                          0722
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0722
FREEFSB  DS    0H                                                  0723
*   CRRRTN8=RETPTR;                 /* SAVE RETURN ADDRESS           */
         ST    RETPTR,CRRRTN8(,CRRPTR)                             0723
*/********************************************************************/
*/*                                                                  */
*/* ROUTINE NAME : FREEFSB - FREE THE FSB/FDB BUFFERS                */
*/*                                                                  */
*/* FUNCTION :                                                       */
*/*    THIS ROUTINE WILL DEQUEUE AND RELEASE THE STORAGE FOR AT LEAST*/
*/*    ONE FSB AND THE FDBS ASSOCIATED WITH IT.                      */
*/*    IF CRRSW0 IS ON INDICATING A FLUSH CONDITION (ON FOR TRUNC)   */
*/*    THEN ALL FSB'S WILL BE DEQUEUED AND FREED UNTIL AND ENDING    */
*/*    CONDITION IS ENCOUNTERED OR UNTIL THERE ARE NO MORE FSB'S ON  */
*/*    THE FMCB DATA QUEUE.  IF THE QUEUE IS EXHAUSTED, THE FLUSH    */
*/*    BIT IS TURNED ON IN THE FMCB TO TELL FEEDBACK TO THROW AWAY   */
*/*    FSB'S UNTIL THE ENDING CONDITION IS MET.                      */
*/*                                                                  */
*/* INPUT :  LDOPTR (REG 10) - ADDRESS OF LDO                        */
*/*                                                                  */
*/* OUTPUT :   FSB/FDB CHAIN IS RELEASED AND ERROR LOCK RESET        */
*/*                                                                  */
*/* SUBROUTINES CALLED :                                             */
*/*    LCPBINIT - BUILD AND SCHEDULE RESET ERROR LOCK                */
*/*                                                                  */
*/*  MACROS USED :  TPDEQ, LCPBINIT                                  */
*/*                                                                  */
*/********************************************************************/
*                                                                  0724
*   CRRSW1=ON;                      /* SET UP FOR DO WHILE LOOP      */
         OI    CRRSW1(CRRPTR),B'01000000'                          0724
*   DO WHILE(CRRSW1=ON);            /* FREE FSB'S                    */
         B     @DE00725                                            0725
@DL00725 DS    0H                                                  0726
*/* TPDEQ (,FMCFBA) RETPTR(FSBPTR)                                   */
*                                                                  0726
*     DO;                           /* BEGIN TPDEQ CODE GENERATION   */
*       RFY                                                        0727
*        (GPR00P,                                                  0727
*         GPR01P,                                                  0727
*         GPR14P,                                                  0727
*         GPR15P) RSTD;                                            0727
*       GPR15P=ADDR(FMCFBA);        /* ADDRESS QUEUE POINTER         */
         L     GPR15P,CRRFMCB(,CRRPTR)                             0728
         LA    GPR15P,FMCFBA(,GPR15P)                              0728
*       GPR14P=GPR15P->PABWEQA|FMZCA020;                           0729
         L     @12,@CF02549                                        0729
         L     GPR14P,PABWEQA(,GPR15P)                             0729
         OR    GPR14P,@12                                          0729
*       IF GPR14P=FMZCA020 THEN                                    0730
         CLR   GPR14P,@12                                          0730
         BE    @RT00730                                            0730
*         ;                                                        0731
*       ELSE                                                       0732
*         DO;                                                      0732
*FMZL1028:                                                         0733
*           ;                                                      0733
FMZL1028 DS    0H                                                  0734
*           DO WHILE(GPR14P->WKECHAIN^=FMZCA020);                  0734
         B     @DE00734                                            0734
@DL00734 DS    0H                                                  0735
*             GPR15P=ADDR(GPR14P->WKECHAIN);                       0735
         LA    GPR15P,WKECHAIN(,GPR14P)                            0735
*             GPR14P=GPR15P->PABWEQA;                              0736
         L     GPR14P,PABWEQA(,GPR15P)                             0736
*           END;                                                   0737
@DE00734 L     @12,@CF02549                                        0737
         CL    @12,WKECHAIN(,GPR14P)                               0737
         BNE   @DL00734                                            0737
*           GPR00P=FMZCA020;                                       0738
         LR    GPR00P,@12                                          0738
*           CS(GPR14P,GPR00P,GPR15P->PABWEQA);                     0739
         CS    GPR14P,@00,PABWEQA(GPR15P)                          0739
*           BC(7,FMZL1028);                                        0740
         BC    7,FMZL1028                                          0740
*           GPR14P->WKECHAIN=0;                                    0741
         SLR   @12,@12                                             0741
         ST    @12,WKECHAIN(,GPR14P)                               0741
*         END;                                                     0742
*ISTA0028:                                                         0743
*       ;                                                          0743
@RT00730 DS    0H                                                  0743
ISTA0028 DS    0H                                                  0744
*       GPR14P=GPR14P&FMZCB020;                                    0744
         N     GPR14P,@CF02547                                     0744
*       FSBPTR=GPR14P;                                             0745
         LR    FSBPTR,GPR14P                                       0745
*       RFY                                                        0746
*        (GPR00P,                                                  0746
*         GPR01P,                                                  0746
*         GPR14P,                                                  0746
*         GPR15P) UNRSTD;                                          0746
*     END;                          /* END TPDEQ GENERATION          */
*     IF FSBPTR=0|FSBPTR=GATE0 THEN                                0748
         LTR   FSBPTR,FSBPTR                                       0748
         BZ    @RT00748                                            0748
         CL    FSBPTR,@CF02549                                     0748
         BNE   @RF00748                                            0748
@RT00748 DS    0H                                                  0749
*       DO;                         /* NO MORE FSB'S ON DATA QUEUE   */
*                                                                  0749
*         /***********************************************************/
*         /*                                                         */
*         /* NO MORE FSB'S ON DATA QUEUE                             */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0750
*         RFY                                                      0750
*          (REG10,                                                 0750
*           REG11) RSTD;                                           0750
*CS3:                                                              0751
*         REG10=FMCCMPS2;           /* REFERENCE OLD FLAG VALUE      */
CS3      L     @15,CRRFMCB(,CRRPTR)                                0751
         L     REG10,FMCCMPS2(,@15)                                0751
*         REG11=REG10|FLGA3ON;      /* TURN ON FLUSH FLAG            */
         LR    REG11,REG10                                         0752
         O     REG11,@CF02565                                      0752
*         CS(REG10,REG11,FMCCMPS2); /* SET NEW FLAG IN FMCB          */
         CS    REG10,@11,FMCCMPS2(@15)                             0753
*         BC(7,CS3);                /* TRY AGIN IF FAILURE           */
         BC    7,CS3                                               0754
*         RFY                                                      0755
*          (REG10,                                                 0755
*           REG11) UNRSTD;                                         0755
*         CRRSW0=OFF;               /* SET END OF LOOP               */
         NI    CRRSW0(CRRPTR),B'01111111'                          0756
*       END;                                                       0757
*     ELSE                                                         0758
*       DO;                         /* FSB FOUND ON QUEUE            */
*                                                                  0758
         B     @RC00748                                            0758
@RF00748 DS    0H                                                  0759
*         /***********************************************************/
*         /*                                                         */
*         /* FSB PRESENT ON QUEUE                                    */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0759
*         IF FSBEBI=ON|FSBLCPB=ZERO THEN                           0759
         TM    FSBEBI(FSBPTR),B'00100000'                          0759
         BO    @RT00759                                            0759
         L     @15,FSBLCPB(,FSBPTR)                                0759
         LTR   @15,@15                                             0759
         BNZ   @RF00759                                            0759
@RT00759 DS    0H                                                  0760
*           CRRSW0=OFF;             /* RESET FLUSH CONDITION         */
         NI    CRRSW0(CRRPTR),B'01111111'                          0760
*         ELSE                                                     0761
*           ;                       /* ENDING CONDITION NOT FOUND    */
@RF00759 DS    0H                                                  0762
*         IF FSBMNELI=ON THEN       /* ERROR LOCK SET IN FSB?        */
         TM    FSBMNELI(FSBPTR),B'10000000'                        0762
         BNO   @RF00762                                            0762
*           DO;                                                    0763
*             CRRELSRI=ON;          /* INDICATE ERROR LOCK SET       */
         OI    CRRELSRI(CRRPTR),B'00001000'                        0764
*             CRRSW0=OFF;           /* EXIT LOOP                     */
         NI    CRRSW0(CRRPTR),B'01111111'                          0765
*           END;                                                   0766
*         ELSE                                                     0767
*           ;                       /* ERROR LOCK NOT SET            */
*                                                                  0767
@RF00762 DS    0H                                                  0768
*         /***********************************************************/
*         /*                                                         */
*         /* DECREMENT COUNT OF NUMBER OF BUFFERS IN USE BY NUMBER   */
*         /* NOW BEING FREED                                         */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0768
*         RFY                                                      0768
*          (FDBPTR,                                                0768
*           WORKA,                                                 0768
*           COUNTER) RSTD;                                         0768
*         FDBPTR=ADDR(FSBFDB);      /* REFERENCE FIRST FDB           */
         LA    FDBPTR,FSBFDB(,FSBPTR)                              0769
*         COUNTER=0;                /* CLEAR BUFFER COUNT ACCUMULATOR*/
         SLR   COUNTER,COUNTER                                     0770
*         DO WHILE(FDBPTR^=0);      /* LOOP THROUGH ALL FDB'S        */
         B     @DE00771                                            0771
@DL00771 DS    0H                                                  0772
*           COUNTER=COUNTER+1;      /* ACCUMULATE BUFFER COUNT       */
         AL    COUNTER,@CF00105                                    0772
*           FDBPTR=FDBFDBA;         /* REFERENCE NEXT FDB            */
         L     FDBPTR,FDBFDBA(,FDBPTR)                             0773
*         END;                                                     0774
@DE00771 LTR   FDBPTR,FDBPTR                                       0774
         BNZ   @DL00771                                            0774
*         RFY                                                      0775
*          (REG10,                                                 0775
*           REG11) RSTD;                                           0775
*CS5:                                                              0776
*         REG10=FMCCMPS1;           /* REFERENCE CURRENT COUNT       */
CS5      L     @15,CRRFMCB(,CRRPTR)                                0776
         L     REG10,FMCCMPS1(,@15)                                0776
*         REG11=REG10-COUNTER;      /* DECREMENT BUFFER COUNT        */
         LR    REG11,REG10                                         0777
         SLR   REG11,COUNTER                                       0777
*         CS(REG10,REG11,FMCCMPS1); /* SET NEW COUNT IN FMCB         */
         CS    REG10,@11,FMCCMPS1(@15)                             0778
*         BC(7,CS5);                /* TRY AGAIN IF FAILURE          */
         BC    7,CS5                                               0779
*         RFY                                                      0780
*          (REG10,                                                 0780
*           REG11) UNRSTD;                                         0780
*                                                                  0780
*         /***********************************************************/
*         /*                                                         */
*         /* FREE STORAGE FOR FSB AND ALL FDBS                       */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0781
*         FDBPTR=ADDR(FSBFDB);                                     0781
         LA    FDBPTR,FSBFDB(,FSBPTR)                              0781
*         WORKA=FDBPTR-FDBOFSET;    /* START OF AREA TO RELEASE      */
         LR    WORKA,FDBPTR                                        0782
         SH    WORKA,FDBOFSET(,FDBPTR)                             0782
*         WORKA->FDBFDBA=FDBFDBA;   /* UPDATE CHAIN PTR TO NEXT FDB  */
         L     @15,FDBFDBA(,FDBPTR)                                0783
         ST    @15,FDBFDBA(,WORKA)                                 0783
*         IF PROCFTX=ON THEN                                       0784
*                                                                  0784
         L     @15,CRRFMCB(,CRRPTR)                                0784
         TM    PROCFTX+48(@15),B'00000001'                         0784
         BNO   @RF00784                                            0784
*           /*********************************************************/
*           /*                                                       */
*           /* RELSTORE BUFADDR(WORKA)CHAIN(YES)CLEAR(YES)           */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0785
*           DO;                                                    0785
*                                                                  0785
*/* ATBUILD (ISTATCVT,ISTRPH)                                        */
*/* END OF ATBUILD                                                   */
*                                                                  0786
*             RFY                                                  0786
*              (GPR02P,                                            0786
*               GPR03P,                                            0786
*               GPR04P,                                            0786
*               GPR15P) RSTD;                                      0786
*             RFY                                                  0787
*              (GPR01P,                                            0787
*               GPR13P) RSTD;                                      0787
*             GENERATE REFS(GPR01P,GPR02P,GPR13P) SETS(RPHWORK);   0788
          STM GPR02P,GPR13P,RPHWORK(GPR01P)
*             RFY                                                  0789
*               GPR13P UNRSTD;                                     0789
*             GPR04P=WORKA|'80000000'X;                            0790
         LR    @12,WORKA                                           0790
         O     @12,@CF02549                                        0790
         LR    GPR04P,@12                                          0790
*             DCL                                                  0791
*               1 FMZA0032 FIXED(31) STATIC LOCAL,                 0791
*                2 * FIXED(8) INIT(80),                            0791
*                2 * PTR(24) INIT(0);                              0791
*             GPR03F=FMZA0032;                                     0792
         L     GPR03F,FMZA0032                                     0792
*             DO;                   /* LISATCVT                    0793
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*               GPR15P=ATCLCPTR;    /* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     0794
*             END;                  /* LISATCVT                      */
*             GPR02P=GPR15P->ATCBPDA;                              0796
         L     GPR02P,ATCBPDA(,GPR15P)                             0796
*             GPR15P=GPR15P->ATCSMRS;                              0797
         L     GPR15P,ATCSMRS(,GPR15P)                             0797
*             DCL                                                  0798
*               FMZL0032 BASED(GPR15P) LABEL VALUERANGE(*);        0798
*             CALL FMZL0032;                                       0799
         BALR  @14,@15                                             0799
*             RFY                                                  0800
*               GPR13P RSTD;                                       0800
*             GENERATE REFS(GPR01P,RPHWORK) SETS(GPR02P,GPR13P);   0801
          LM GPR02P,GPR13P,RPHWORK(GPR01P)
*             RFY                                                  0802
*              (GPR01P,                                            0802
*               GPR13P) UNRSTD;                                    0802
*             RFY                                                  0803
*              (GPR02P,                                            0803
*               GPR03P,                                            0803
*               GPR04P,                                            0803
*               GPR15P) UNRSTD;                                    0803
*           END;                    /* *********END OF RELSTORE    0804
*                                      EXPANSION*********            */
*         ELSE                                                     0805
*                                                                  0805
*           /*********************************************************/
*           /*                                                       */
*           /* RELSTORE BUFADDR(WORKA)CHAIN(YES)                     */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0805
*           DO;                                                    0805
*                                                                  0805
         B     @RC00784                                            0805
@RF00784 DS    0H                                                  0806
*/* ATBUILD (ISTATCVT,ISTRPH)                                        */
*/* END OF ATBUILD                                                   */
*                                                                  0806
*             RFY                                                  0806
*              (GPR02P,                                            0806
*               GPR03P,                                            0806
*               GPR04P,                                            0806
*               GPR15P) RSTD;                                      0806
*             RFY                                                  0807
*              (GPR01P,                                            0807
*               GPR13P) RSTD;                                      0807
*             GENERATE REFS(GPR01P,GPR02P,GPR13P) SETS(RPHWORK);   0808
          STM GPR02P,GPR13P,RPHWORK(GPR01P)
*             RFY                                                  0809
*               GPR13P UNRSTD;                                     0809
*             GPR04P=WORKA;                                        0810
*             DCL                                                  0811
*               1 FMZA0048 FIXED(31) STATIC LOCAL,                 0811
*                2 * FIXED(8) INIT(80),                            0811
*                2 * PTR(24) INIT(0);                              0811
*             GPR03F=FMZA0048;                                     0812
         L     GPR03F,FMZA0048                                     0812
*             DO;                   /* LISATCVT                    0813
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*               GPR15P=ATCLCPTR;    /* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     0814
*             END;                  /* LISATCVT                      */
*             GPR02P=GPR15P->ATCBPDA;                              0816
         L     GPR02P,ATCBPDA(,GPR15P)                             0816
*             GPR15P=GPR15P->ATCSMRS;                              0817
         L     GPR15P,ATCSMRS(,GPR15P)                             0817
*             DCL                                                  0818
*               FMZL0048 BASED(GPR15P) LABEL VALUERANGE(*);        0818
*             CALL FMZL0048;                                       0819
         BALR  @14,@15                                             0819
*             RFY                                                  0820
*               GPR13P RSTD;                                       0820
*             GENERATE REFS(GPR01P,RPHWORK) SETS(GPR02P,GPR13P);   0821
          LM GPR02P,GPR13P,RPHWORK(GPR01P)
*             RFY                                                  0822
*              (GPR01P,                                            0822
*               GPR13P) UNRSTD;                                    0822
*             RFY                                                  0823
*              (GPR02P,                                            0823
*               GPR03P,                                            0823
*               GPR04P,                                            0823
*               GPR15P) UNRSTD;                                    0823
*           END;                    /* *********END OF RELSTORE    0824
*                                      EXPANSION********* NOT      0824
*                                      CONFIDENTIAL                  */
*       END;                        /* DONE WITH CURRENT FSB         */
@RC00784 DS    0H                                                  0826
*     RFY                                                          0826
*      (FDBPTR,                                                    0826
*       WORKA,                                                     0826
*       COUNTER) UNRSTD;                                           0826
@RC00748 DS    0H                                                  0827
*     IF CRRSW0=ON THEN             /* MUST MAKE ANOTHER PASS        */
         TM    CRRSW0(CRRPTR),B'10000000'                          0827
         BNO   @RF00827                                            0827
*       CRRSW7=ON;                  /* SHOW LOOPED MORE THAN ONCE    */
         OI    CRRSW7(CRRPTR),B'00000001'                          0828
*     ELSE                                                         0829
*       CRRSW1=OFF;                 /* DONE WITH LOOP                */
         B     @RC00827                                            0829
@RF00827 NI    CRRSW1(CRRPTR),B'10111111'                          0829
*   END;                            /* END OF DO WHILE PROCESSING    */
@RC00827 DS    0H                                                  0830
@DE00725 TM    CRRSW1(CRRPTR),B'01000000'                          0830
         BO    @DL00725                                            0830
*   IF CRRELSRI=ON THEN             /* WAS ERROR LOCK SET IN FSB?    */
         TM    CRRELSRI(CRRPTR),B'00001000'                        0831
         BNO   @RF00831                                            0831
*     IF CRRSW7=ON THEN             /* WERE WE TRUNCATING?           */
*                                                                  0832
         TM    CRRSW7(CRRPTR),B'00000001'                          0832
         BNO   @RF00832                                            0832
*       /*************************************************************/
*       /*                                                           */
*       /* IF THE ERROR LOCK IS SET IN A FSB BEING FLUSHED, CALL     */
*       /* LCPBINIT TO INITIALIZE THE LCPB TO A RESET ERROR LOCK     */
*       /* SINCE THE USER WILL NOT KNOW THAT THE ERROR LOCK IS SET.  */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0833
*       CALL LCPBINIT;              /* ISSUE RESET ERROR LOCK        */
         BAL   @14,LCPBINIT                                        0833
*     ELSE                                                         0834
*       CRRELSRI=OFF;               /* NOT TRUNCATING-USER WILL FIND */
         B     @RC00832                                            0834
@RF00832 NI    CRRELSRI(CRRPTR),B'11110111'                        0834
*   ELSE                                                           0835
*     ;                             /* ERROR LOCK NOT SET            */
@RF00831 DS    0H                                                  0836
*   RETPTR=CRRRTN8;                 /* GET RETURN ADDRESS            */
@RC00831 L     RETPTR,CRRRTN8(,CRRPTR)                             0836
*   END FREEFSB;                    /* RETURN TO CALLER              */
@EL00009 DS    0H                                                  0837
@EF00009 DS    0H                                                  0837
@ER00009 BR    @14                                                 0837
*UPLDOPTR:                                                         0838
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0838
UPLDOPTR DS    0H                                                  0839
*   CRRRTN7=RETPTR;                 /* SAVE RETURN ADDRESS           */
         ST    RETPTR,CRRRTN7(,CRRPTR)                             0839
*/********************************************************************/
*/*                                                                  */
*/* ROUTINE NAME :   UPLDOP7R - UPDATE LDO POINTER                   */
*/*                                                                  */
*/* FUNCTION :                                                       */
*/*    FOR A NORMAL ENTRY (CRRSW2 NOT SET) UPLDOPTR WILL SEARCH      */
*/*    THROUGH THE CHAIN OF LDO'S ASSOCIATED WITH THE READ TO FIND   */
*/*    THE LAST DATA CHAINED LDO.  THIS ONE WILL BE TESTED TO SEE    */
*/*    IF IT IS COMMAND CHAINED.  IF SO, AN ERROR INDICATION WILL    */
*/*    BE SET IN THE CRR, AND AN I/O OPERATION WILL NOT OCCUR.  IF   */
*/*    ANY LDO'S ARE FOUND TO BE INVALID, NO I/O WILL OCCUR. IF      */
*/*    CRRSW2 IS SET, UPLDOPTR WILL ONLY UPDATE TO THE NEXT NON-JUMP */
*/*    LDO.                                                          */
*/* INPUT :  LDOPTR (REG 10) - ADDRESS OF LDO                        */
*/*                                                                  */
*/* OUTPUT :     LDOPTR REG(REG 9) - POINTS TO PROPER LDO            */
*/*                                                                  */
*/* SUBROUTINES CALLED :  NONE                                       */
*/*                                                                  */
*/*  MACROS USED :   NONE                                            */
*/*                                                                  */
*/********************************************************************/
*                                                                  0840
*   LDOPTR=CRRCLDO;                 /* GET CURRENT LDO               */
         L     LDOPTR,CRRCLDO(,CRRPTR)                             0840
*   DO WHILE(CRRFINI=OFF&CRRSW1=OFF);/* LOOP UNTIL ERROR OR END      */
         B     @DE00841                                            0841
@DL00841 DS    0H                                                  0842
*     IF LDOCMD=LDOJUMP THEN                                       0842
         CLI   LDOCMD(LDOPTR),X'08'                                0842
         BNE   @RF00842                                            0842
*       DO;                         /* CURRENT LDO IS A JUMP         */
*         IF LDOADDR->LDOCMD=LDOJUMP THEN                          0844
         L     @15,LDOADDR(,LDOPTR)                                0844
         CLI   LDOCMD(@15),X'08'                                   0844
         BNE   @RF00844                                            0844
*           DO;                     /* ERROR - JUMP TO A JUMP        */
*                                                                  0845
*             /*******************************************************/
*             /*                                                     */
*             /* ERROR-JUMP TO A JUMP LDO                            */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0846
*             CRRFDB2=CRRJTOJ;      /* SET REASON CODE FOR FEEDBACK  */
         MVI   CRRFDB2(CRRPTR),X'19'                               0846
*             CRRRTNCD=CRRLOGIC;    /* SET LOGICAL I/O ERROR CODE    */
         MVI   CRRRTNCD(CRRPTR),X'08'                              0847
*             CRRFINI=ON;           /* DO PROCESSING FINISHED        */
         OI    CRRFINI(CRRPTR),B'00001000'                         0848
*           END;                                                   0849
*         ELSE                      /* JUMP TO GOOD LDO              */
*                                                                  0850
*           /*********************************************************/
*           /*                                                       */
*           /* JUMP TO A VALID LDO                                   */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0850
*           LDOPTR=LDOADDR;         /* REFERENCE NEXT LDO            */
         B     @RC00844                                            0850
@RF00844 L     LDOPTR,LDOADDR(,LDOPTR)                             0850
*       END;                        /* END OF JUMP PROCESSING        */
*     ELSE                                                         0852
*       IF LDOACHN=ON THEN                                         0852
         B     @RC00842                                            0852
@RF00842 TM    LDOACHN(LDOPTR),B'10000000'                         0852
         BNO   @RF00852                                            0852
*         DO;                       /* LDO IS DATA CHAINED           */
*           IF CRRSW2=ON THEN                                      0854
         TM    CRRSW2(CRRPTR),B'00100000'                          0854
         BNO   @RF00854                                            0854
*             CRRSW1=ON;            /* LDO CHAIN UPDATED             */
         OI    CRRSW1(CRRPTR),B'01000000'                          0855
*           ELSE                                                   0856
*             ;                     /* MORE PASSES THROUGH           */
@RF00854 DS    0H                                                  0857
*           LDOPTR=LDOPTR+LDOSIZE;  /* REF NEXT LDO                  */
         AL    LDOPTR,@CF00103                                     0857
*         END;                      /* END OF DATA CHAIN PROCESSING  */
*       ELSE                                                       0859
*         IF LDOCMHN=ON THEN                                       0859
         B     @RC00852                                            0859
@RF00852 TM    LDOCMHN(LDOPTR),B'01000000'                         0859
         BNO   @RF00859                                            0859
*           DO;                     /* READ LDO CAN'T BE COMMEND   0860
*                                      CHAIN                         */
*                                                                  0860
*             /*******************************************************/
*             /*                                                     */
*             /* ERROR-LDO IS COMMAND CHAINED                        */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0861
*             CRRFDB2=CRRRIOCC;     /* SET REASON CODE FOR FEEDBACK  */
         MVI   CRRFDB2(CRRPTR),X'1D'                               0861
*             CRRRTNCD=CRRLOGIC;    /* SET LOGICAL I/O ERROR CODE    */
         MVI   CRRRTNCD(CRRPTR),X'08'                              0862
*             CRRFINI=ON;           /* DO PROCESSING FINISHED        */
         OI    CRRFINI(CRRPTR),B'00001000'                         0863
*           END;                                                   0864
*         ELSE                                                     0865
*           CRRSW1=ON;              /* FINISHED - EXIT LOOP          */
         B     @RC00859                                            0865
@RF00859 OI    CRRSW1(CRRPTR),B'01000000'                          0865
*     CRRCLDO=LDOPTR;               /* SAVE CURRENT LDOPTR IN CRR    */
@RC00859 DS    0H                                                  0866
@RC00852 DS    0H                                                  0866
@RC00842 ST    LDOPTR,CRRCLDO(,CRRPTR)                             0866
*   END;                            /* END OF DO WHILE LOOP          */
@DE00841 TM    CRRFINI(CRRPTR),B'00001000'                         0867
         BNZ   @DC00841                                            0867
         TM    CRRSW1(CRRPTR),B'01000000'                          0867
         BZ    @DL00841                                            0867
@DC00841 DS    0H                                                  0868
*   CRRSW2=OFF;                     /* CLEAR CONTROL SWITHCES        */
*   CRRSW1=OFF;                                                    0869
         NI    CRRSW2(CRRPTR),B'10011111'                          0869
*   RETPTR=CRRRTN7;                 /* GET RETURN ADDRESS            */
         L     RETPTR,CRRRTN7(,CRRPTR)                             0870
*   END UPLDOPTR;                   /* RETURN TO CALLER              */
@EL00010 DS    0H                                                  0871
@EF00010 DS    0H                                                  0871
@ER00010 BR    @14                                                 0871
*CSUBR8:                                                           0872
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0872
*                                                                  0872
CSUBR8   DS    0H                                                  0873
*/********************************************************************/
*/*                                                                  */
*/* ROUTINE NAME :  SUBR8 - VALIDATE LDO                             */
*/*                                                                  */
*/* FUNCTION :                                                       */
*/*    THE LDO IS CHECKED TO INSURE THAT THE LDO IS A READ           */
*/*    AND IS NOT COMMAND CHAINED. SUBR3 IS CALLED TO MAKE           */
*/*    FURTHER CHECKS.                                               */
*/*                                                                  */
*/* INPUT :  LDOPTR (REG 10) - ADDRESS OF LDO                        */
*/*                                                                  */
*/* OUTPUT :   THE CURRENT LDO IS VALIDATED                          */
*/*                                                                  */
*/* SUBROUTINES CALLED :                                             */
*/*         SUBR3 - CHECK LDO                                        */
*/*                                                                  */
*/*  MACROS USED :  NONE                                             */
*/*                                                                  */
*/********************************************************************/
*                                                                  0873
*   CRRRTN2=RETPTR;                 /* SAVE RETURN ADDRESS           */
         ST    RETPTR,CRRRTN2(,CRRPTR)                             0873
*   IF LDOCMD=LDORDBUF|LDOCMD=LDORDMOD|LDOCMD=LDOREAD THEN/* LDO IS A
*                                      READ                          */
         CLI   LDOCMD(LDOPTR),X'16'                                0874
         BE    @RT00874                                            0874
         CLI   LDOCMD(LDOPTR),X'12'                                0874
         BE    @RT00874                                            0874
         CLI   LDOCMD(LDOPTR),X'02'                                0874
         BNE   @RF00874                                            0874
@RT00874 DS    0H                                                  0875
*     IF LDOCMHN=ON THEN                                           0875
         TM    LDOCMHN(LDOPTR),B'01000000'                         0875
         BNO   @RF00875                                            0875
*       DO;                         /* ERROR-RD LDO IS COMMAND     0876
*                                      CHAINED                       */
*         RFY                                                      0877
*           RETCODE UNRSTD;                                        0877
*                                                                  0877
*         /***********************************************************/
*         /*                                                         */
*         /* ERROR-READ LDO COMMAND CHAINED                          */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0878
*         CRRFDB2=CRRRIOCC;         /* SET REASON CODE               */
         MVI   CRRFDB2(CRRPTR),X'1D'                               0878
*         CRRRTNCD=CRRLOGIC;        /* LOGICAL I/O ERROR CODE        */
         MVI   CRRRTNCD(CRRPTR),X'08'                              0879
*         CRRFINI=ON;               /* DO PROCESSING FINISHED        */
         OI    CRRFINI(CRRPTR),B'00001000'                         0880
*         RFY                                                      0881
*           RETCODE RSTD;           /* RESTRICT RETURN CODE REG      */
*       END;                                                       0882
*                                                                  0882
*   /*****************************************************************/
*   /*                                                               */
*   /* VALID READ LDO                                                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0883
*     ELSE                                                         0883
*       CALL CSUBR3;                /* CHECK LDO                     */
         B     @RC00875                                            0883
@RF00875 BAL   @14,CSUBR3                                          0883
*   ELSE                                                           0884
*     DO;                           /* OP CODE NOT A READ            */
*                                                                  0884
         B     @RC00874                                            0884
@RF00874 DS    0H                                                  0885
*       /*************************************************************/
*       /*                                                           */
*       /* ERROR-NOT VALID READ OP CODE                              */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0885
*       CRRFDB2=CRRILDOP;           /* SET REASON CODE               */
         MVI   CRRFDB2(CRRPTR),X'06'                               0885
*       CRRRTNCD=CRRLOGIC;          /* SET LOGICAL I/O ERROR CODE    */
         MVI   CRRRTNCD(CRRPTR),X'08'                              0886
*       CRRFINI=ON;                 /* DO PROCESSING FINISHED        */
         OI    CRRFINI(CRRPTR),B'00001000'                         0887
*     END;                                                         0888
*   RETPTR=CRRRTN2;                 /* GET RETURN ADDRESS            */
@RC00874 L     RETPTR,CRRRTN2(,CRRPTR)                             0889
*   END CSUBR8;                     /* RETURN TO CALLER              */
@EL00011 DS    0H                                                  0890
@EF00011 DS    0H                                                  0890
@ER00011 BR    @14                                                 0890
*CSUBR9:                                                           0891
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0891
CSUBR9   DS    0H                                                  0892
*   CRRRTN4=RETPTR;                 /* SAVE RETURN ADDRESS           */
*                                                                  0892
         ST    RETPTR,CRRRTN4(,CRRPTR)                             0892
*   /*****************************************************************/
*   /*                                                               */
*   /* DETERMINE WHETHER THE MOVE OF DATA IS COMPLETE. THE MOVE      */
*   /* ROUTINE SUCCESSFULLY MOVED ALL THE DATA FROM ONE FSB INTO THE */
*   /* USER'S BUFFER. IF THE FSB IS NOT A SUBBLOCK (NO EOB), THE     */
*   /* RETURN CODE IS NOT 0, OR LEADING GRAPHICS WERE RECEIVED THEN  */
*   /* PROCESSING IS FINISHED. THE FSB WILL BE FREED AND THE LDO'S   */
*   /* WILL BE EXAMINED TO MAKE SURE THE LAST ONE ASSOCIATED WITH    */
*   /* THIS READ IS NOT COMMAND CHAINED. IF THE CURRENT FSB IS A     */
*   /* SUBBLOCK AND THERE IS MORE ROOM IN THE USER'S BUFFERS, CSUBR11*/
*   /* WILL BE CALLED. IF THERE IS NO ROOM IN THE USER'S BUFFER,     */
*   /* CSUBR10 WILL BE CALLED TO TEST WHETHER THE USER HAS SPECIFIED */
*   /* TRUNC OR KEEP IN HIS FMCB.                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0893
*   IF(FSBEBI=OFF&FSBLGI=OFF&       /* SUBBLOCK AND NO LEADING GRAPH */
*       FSBSOHI=OFF&                /* START OF HEADER               */
*       FSBMJRCD=FRNORM)&           /* NO ERROR CODE IN FSB          */
*       FSBLCPB^=ZERO THEN          /* NOT UNSOLICITED FSB           */
*                                                                  0893
         TM    FSBEBI(FSBPTR),B'00100011'                          0893
         BNZ   @RF00893                                            0893
         CLI   FSBMJRCD(FSBPTR),X'00'                              0893
         BNE   @RF00893                                            0893
         SLR   @12,@12                                             0893
         C     @12,FSBLCPB(,FSBPTR)                                0893
         BE    @RF00893                                            0893
*     /***************************************************************/
*     /*                                                             */
*     /* CURRENT FSB IS A SUBBLOCK                                   */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0894
*     IF(CRRBLEN=0&LDOACHN=OFF) THEN                               0894
         CH    @12,CRRBLEN(,CRRPTR)                                0894
         BNE   @RF00894                                            0894
         TM    LDOACHN(LDOPTR),B'10000000'                         0894
         BNZ   @RF00894                                            0894
*       DO;                         /* NO ROOM IN BUFFER             */
*                                                                  0895
*         /***********************************************************/
*         /*                                                         */
*         /* MORE DATA TO MOVE, BUT NO MORE ROOM                     */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0896
*         CALL FREEFSB;             /* RELEASE FSB JUST COMPLETED    */
         BAL   @14,FREEFSB                                         0896
*         CRRSW7=ON;                /* INDICATE TRUNCATION           */
         OI    CRRSW7(CRRPTR),B'00000001'                          0897
*         CALL CSUBR10;             /* CHECK TRUNC/KEEP OPTION       */
         BAL   @14,CSUBR10                                         0898
*       END;                                                       0899
*                                                                  0899
*   /*****************************************************************/
*   /*                                                               */
*   /* MORE DATA EXPECTED AND ROOM IN BUFFER                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0900
*     ELSE                                                         0900
*       CALL CSUBR11;               /* SEE IF MORE DATA TO MOVE      */
         B     @RC00894                                            0900
@RF00894 BAL   @14,CSUBR11                                         0900
*   ELSE                                                           0901
*     DO;                           /* ALL DATA WAS MOVED            */
*                                                                  0901
         B     @RC00893                                            0901
@RF00893 DS    0H                                                  0902
*       /*************************************************************/
*       /*                                                           */
*       /* PROCESSING FINISHED-ALL DATA MOVED                        */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0902
*       CALL FREEFSB;               /* DEQUEUE AND FEE FSB           */
         BAL   @14,FREEFSB                                         0902
*       CRRCLDO=CRRBLDAD;           /* SAVE PTR TO LAST LDO USED     */
         L     @12,CRRBLDAD(,CRRPTR)                               0903
         ST    @12,CRRCLDO(,CRRPTR)                                0903
*       RPLAAREA=CRRBLDAD;          /* SAVE LDO POINTER FOR USER     */
         LR    RPLAAREA,@12                                        0904
*       CALL UPLDOPTR;              /* UPDATE TO END-CHECK CMD CHAIN */
         BAL   @14,UPLDOPTR                                        0905
*       CRRSW3=ON;                  /* FINISHED WITH MOVE            */
         OI    CRRSW3(CRRPTR),B'00010000'                          0906
*     END;                                                         0907
*   RETPTR=CRRRTN4;                 /* GET RETURN ADDRESS            */
@RC00893 L     RETPTR,CRRRTN4(,CRRPTR)                             0908
*   END CSUBR9;                     /* GET RETURN ADDRESS            */
@EL00012 DS    0H                                                  0909
@EF00012 DS    0H                                                  0909
@ER00012 BR    @14                                                 0909
*CSUBR10:                                                          0910
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0910
CSUBR10  DS    0H                                                  0911
*   CRRRTN7=RETPTR;                 /* SAVE RETURN ADDRESS           */
*                                                                  0911
         ST    RETPTR,CRRRTN7(,CRRPTR)                             0911
*   /*****************************************************************/
*   /*                                                               */
*   /* THERE IS NO ROOM IN THE USER'S BUFFER, BUT THERE IS MORE DATA */
*   /* TO BE MOVED. IF THE USER SPECIFIED KEEP IN HIS FMCB, AN       */
*   /* INDICATION THAT PARTIAL DATA WAS RECEIVED IS SET AS FEEDBACK  */
*   /* STATUS AND THE FSB IS NOT FREED. IF TRUNC WAS SPECIFIED, A    */
*   /* LOGICAL I/O ERROR IS SET AS STATUS AND ALL THE DATA IS THROWN */
*   /* AWAY UNTIL AND ENDING CONDITION IS FOUND(EOB).                */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0912
*   IF PROTRUNC=ON THEN                                            0912
         L     @12,CRRFMCB(,CRRPTR)                                0912
         TM    PROTRUNC+48(@12),B'01000000'                        0912
         BNO   @RF00912                                            0912
*     DO;                           /* TRUNC OPTION                  */
*                                                                  0913
*       /*************************************************************/
*       /*                                                           */
*       /* TRUNC PROCESSING                                          */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0914
*       IF FSBLGI=OFF&              /* TEST FOR LEADING GRAPHICS     */
*           FSBSOHI=OFF&            /* START OF HEADER               */
*           FSBMJRCD=FRNORM&        /* NORMAL RETURN CODE            */
*           FSBLCPB^=ZERO THEN      /* NOT UNSOLICITED FSB           */
         TM    FSBLGI(FSBPTR),B'00000011'                          0914
         BNZ   @RF00914                                            0914
         CLI   FSBMJRCD(FSBPTR),X'00'                              0914
         BNE   @RF00914                                            0914
         L     @12,FSBLCPB(,FSBPTR)                                0914
         LTR   @12,@12                                             0914
         BZ    @RF00914                                            0914
*         CRRSW0=ON;                /* INDICATE FLUSH TO EOB         */
         OI    CRRSW0(CRRPTR),B'10000000'                          0915
*       ELSE                                                       0916
*         ;                         /* LEADING GRAPH TREATED AS EOB  */
@RF00914 DS    0H                                                  0917
*       CALL FREEFSB;               /* DEQUEUE AND FREE STG FOR FSB
*                                      D31JKMQ                       */
         BAL   @14,FREEFSB                                         0917
*     END;                                                         0918
*   ELSE                                                           0919
*     DO;                           /* KEEP OPTION                   */
*                                                                  0919
         B     @RC00912                                            0919
@RF00912 DS    0H                                                  0920
*       /*************************************************************/
*       /*                                                           */
*       /* KEEP PROCESSING                                           */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0920
*       CRRRDEOB=OFF;               /* INDICATE PARTIAL DATA         */
*       CRRRDEOM=OFF;                                              0921
*       CRRRDEOT=OFF;                                              0922
         NI    CRRRDEOB(CRRPTR),B'11000111'                        0922
*       IF CRRBLDAD->LDOCMHN=ON THEN                               0923
         L     @12,CRRBLDAD(,CRRPTR)                               0923
         TM    LDOCMHN(@12),B'01000000'                            0923
         BNO   @RF00923                                            0923
*         DO;                       /* CURRENT LDO IS COMMAND CHAINED*/
*                                                                  0924
*           /*********************************************************/
*           /*                                                       */
*           /* ERROR-LDO COMMAND CHAINED                             */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0925
*           CRRFDB2=CRRRIOCC;       /* SET REASON CODE FOR FEEDBACK  */
         MVI   CRRFDB2(CRRPTR),X'1D'                               0925
*           CRRRTNCD=CRRLOGIC;      /* SET LOGICAL I/O ERROR CODE    */
         MVI   CRRRTNCD(CRRPTR),X'08'                              0926
*         END;                                                     0927
*       ELSE                                                       0928
*         ;                         /* NOT COMMAND CHAINED           */
@RF00923 DS    0H                                                  0929
*     END;                                                         0929
*   CRRSW3=ON;                      /* MOVE FINISHED                 */
@RC00912 OI    CRRSW3(CRRPTR),B'00010000'                          0930
*   CRRCLDO=CRRBLDAD;               /* SAVE CURRENT LDO FROM MOVE    */
         L     @12,CRRBLDAD(,CRRPTR)                               0931
         ST    @12,CRRCLDO(,CRRPTR)                                0931
*   RPLAAREA=CRRCLDO;               /* SET LDO FOR FEEDBACK          */
         LR    RPLAAREA,@12                                        0932
*   RETPTR=CRRRTN7;                 /* GET RETURN ADDRESS            */
         L     RETPTR,CRRRTN7(,CRRPTR)                             0933
*   END CSUBR10;                    /* RETURN TO CALLER              */
@EL00013 DS    0H                                                  0934
@EF00013 DS    0H                                                  0934
@ER00013 BR    @14                                                 0934
*CSUBR11:                                                          0935
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0935
CSUBR11  DS    0H                                                  0936
*   CRRRTN5=RETPTR;                 /* SAVE RETURN ADDRESS           */
*                                                                  0936
         ST    RETPTR,CRRRTN5(,CRRPTR)                             0936
*   /*****************************************************************/
*   /*                                                               */
*   /* THE FSB WHICH WAS EXHAUSTED WAS A SUBBLOCK (NO EOB) AND THERE */
*   /* IS ROOM IN THE USER'S BUFFER FOR MORE DATA. FREE AND RELEASE  */
*   /* THE FSB JUST USED. IF THERE IS ANOTHER FSB ON THE FMCB DATA   */
*   /* QUEUE, SAVE IT'S ADDRESS AND SET UP TO MOVE AGAIN. IF THERE IS*/
*   /* NO FSB, AND THERE WAS A LCPB ASSOCIATED WITH THE LAST FSB,    */
*   /* CHECK FOR ERROR LOCK SET. IF SO, NOTIFY THE USER NOW.         */
*   /* OTHERWISE, INDICATE TO REQUEST FINISH THAT THE CURRENT RPL IS */
*   /* WAITING FOR A FSB FROM A PREVIOUS I/O OPERATION. SAVE THE     */
*   /* STATUS FROM THE MOVE IN THE LCPB SO THAT WHEN DATA ARRIVES THE*/
*   /* MOVE CAN CONTINUE AT THE PROPER PLACE.                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0937
*   LCPBPTR=FSBLCPB;                /* SAVE LCPB PTR FROM USED FSB   */
         L     LCPBPTR,FSBLCPB(,FSBPTR)                            0937
*   CALL FREEFSB;                   /* DEQUE AND RELEASE STG FOR FSB */
         BAL   @14,FREEFSB                                         0938
*/* TPFEL (,FMCFBA) RETPTR(FSBPTR)                                   */
*                                                                  0939
*   DO;                             /* BEGIN TPFEL CODE GENERATION   */
*     RFY                                                          0940
*      (GPR00P,                                                    0940
*       GPR01P,                                                    0940
*       GPR14P,                                                    0940
*       GPR15P) RSTD;                                              0940
*     GPR15P=ADDR(FMCFBA);          /* ADDRESS QUEUE POINTER         */
         L     GPR15P,CRRFMCB(,CRRPTR)                             0941
         LA    GPR15P,FMCFBA(,GPR15P)                              0941
*     GPR14P=GPR15P->PABWEQA|FMZCA020;                             0942
         L     @12,@CF02549                                        0942
         L     GPR14P,PABWEQA(,GPR15P)                             0942
         OR    GPR14P,@12                                          0942
*     IF GPR14P=FMZCA020 THEN                                      0943
         CLR   GPR14P,@12                                          0943
         BE    @RT00943                                            0943
*       ;                                                          0944
*     ELSE                                                         0945
*       DO;                                                        0945
*         GPR00P=FMZCA020;          /* INITIALIZE QUIT FLAG          */
         L     GPR00P,@CF02549                                     0946
*         DO WHILE(GPR00P^=GPR14P->WKECHAIN);                      0947
         B     @DE00947                                            0947
@DL00947 DS    0H                                                  0948
*           GPR14P=GPR14P->WKECHAIN;/* SEARCH FOR END OF CHAIN       */
         L     GPR14P,WKECHAIN(,GPR14P)                            0948
*         END;                                                     0949
@DE00947 C     GPR00P,WKECHAIN(,GPR14P)                            0949
         BNE   @DL00947                                            0949
*       END;                                                       0950
*     GPR14P=GPR14P&FMZCB020;                                      0951
@RT00943 N     GPR14P,@CF02547                                     0951
*     FSBPTR=GPR14P;                                               0952
         LR    FSBPTR,GPR14P                                       0952
*     RFY                                                          0953
*      (GPR00P,                                                    0953
*       GPR01P,                                                    0953
*       GPR14P,                                                    0953
*       GPR15P) UNRSTD;                                            0953
*   END;                            /* END TPFEL GENERATION          */
*   IF FSBPTR^=0&FSBPTR^=GATE0 THEN                                0955
         SLR   @12,@12                                             0955
         CR    FSBPTR,@12                                          0955
         BE    @RF00955                                            0955
         CL    FSBPTR,@CF02549                                     0955
         BE    @RF00955                                            0955
*     DO;                           /* ANOTHER FSB IS PRESENT        */
*                                                                  0956
*       /*************************************************************/
*       /*                                                           */
*       /* MORE DATA PRESENT ON Q                                    */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0957
*       CRRFSB=FSBPTR;              /* NEW FSB ADDR IN CRR           */
         ST    FSBPTR,CRRFSB(,CRRPTR)                              0957
*       IF CRRBLEN=0 THEN                                          0958
         CH    @12,CRRBLEN(,CRRPTR)                                0958
         BNE   @RF00958                                            0958
*         DO;                       /* LDO SATISFIED - UPDATE TO NEXT*/
*                                                                  0959
*           /*********************************************************/
*           /*                                                       */
*           /* UPDATE TO NEXT LDO                                    */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0960
*           CRRSW2=ON;              /* INDICATE NEXT LDO WANTED      */
         OI    CRRSW2(CRRPTR),B'00100000'                          0960
*           CALL UPLDOPTR;          /* GET NEXT NON-JUMP LDO         */
         BAL   @14,UPLDOPTR                                        0961
*           CRRBLDAD=CRRCLDO;       /* SAVE LDO FOR MOVE             */
         L     @12,CRRCLDO(,CRRPTR)                                0962
         ST    @12,CRRBLDAD(,CRRPTR)                               0962
*         END;                                                     0963
*       ELSE                                                       0964
*         ;                         /* ALL SET FOR NEXT MOVE         */
@RF00958 DS    0H                                                  0965
*     END;                                                         0965
*   ELSE                                                           0966
*     DO;                           /* NO MORE FSB'S ON DATA QUEUE   */
*                                                                  0966
         B     @RC00955                                            0966
@RF00955 DS    0H                                                  0967
*       /*************************************************************/
*       /*                                                           */
*       /* NO MORE DATA ON DATA QUEUE                                */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0967
*       IF LCPBPTR^=0 THEN          /* IF FSB POINTED TO LCPB        */
         LTR   LCPBPTR,LCPBPTR                                     0967
         BZ    @RF00967                                            0967
*         IF CRRERLK=ON THEN        /* IF ERROR LOCK WAS SET         */
*                                                                  0968
         TM    CRRERLK(CRRPTR),B'10000000'                         0968
         BNO   @RF00968                                            0968
*           /*********************************************************/
*           /*                                                       */
*           /* ERROR CONDITION-NO MORE DATA                          */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0969
*           DCLRPLA=DCLRPLA&&DCLRPLA;/* DONE WITH THIS REQUEST       */
         L     @12,DCLRPLA(,LCPBPTR)                               0969
         LR    @06,@12                                             0969
         XR    @06,@12                                             0969
         ST    @06,DCLRPLA(,LCPBPTR)                               0969
*         ELSE                                                     0970
*           DO;                     /* NO ERROR INDICATED            */
*                                                                  0970
         B     @RC00968                                            0970
@RF00968 DS    0H                                                  0971
*             /*******************************************************/
*             /*                                                     */
*             /* WAIT FOR MORE DATA TO ARRIVE                        */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0971
*             CRRSUBBK=ON;          /* WAITING FOR SUBBLOCK          */
         OI    CRRSUBBK(CRRPTR),B'00000100'                        0971
*             CRRSW3=ON;            /* MOVE FINISHED                 */
         OI    CRRSW3(CRRPTR),B'00010000'                          0972
*             DCLRPLA=CRRARPL;      /* RPL ASSOCIATED WITH THIS LCPB */
         L     @12,CRRARPL(,CRRPTR)                                0973
         ST    @12,DCLRPLA(,LCPBPTR)                               0973
*             DCLCLDOA=CRRBLDAD;    /* LDO TO PROCESS NEXT           */
         L     @12,CRRBLDAD(,CRRPTR)                               0974
         ST    @12,DCLCLDOA(,LCPBPTR)                              0974
*             IF ADDR(LCPLCCW)->LCCWOP^=LTIC THEN                  0975
         CLI   LCCWOP+48(LCPBPTR),X'08'                            0975
         BE    @RF00975                                            0975
*               DCLLDO1=CRRBLDAD;   /* SAVE NEXT LDO                 */
         ST    @12,DCLLDO1(,LCPBPTR)                               0976
*             ELSE                  /* SAVE NEXT LDO IN EXTENSION    */
*               EVAL(CRRCLCCW+LDOFFSET)->LDOSAVE=CRRBLDAD;         0977
         B     @RC00975                                            0977
@RF00975 LA    @12,32                                              0977
         AL    @12,CRRCLCCW(,CRRPTR)                               0977
         L     @06,CRRBLDAD(,CRRPTR)                               0977
         ST    @06,LDOSAVE(,@12)                                   0977
*             DCLBTLEN=CRRBTLEN;    /* SAVE RESIDUAL COUNT           */
@RC00975 L     @12,CRRBTLEN(,CRRPTR)                               0978
         ST    @12,DCLBTLEN(,LCPBPTR)                              0978
*             DCLIOLEN=CRRBLEN;     /* AMOUNT LEFT TO MOVE           */
         LH    @12,CRRBLEN(,CRRPTR)                                0979
         STH   @12,DCLIOLEN(,LCPBPTR)                              0979
*             DCLIOBUF=CRRBARAD;    /* RESUME BUFFER ADDRESS         */
         L     @12,CRRBARAD(,CRRPTR)                               0980
         ST    @12,DCLIOBUF(,LCPBPTR)                              0980
*           END;                                                   0981
*       ELSE                                                       0982
*         ;                         /* FSB DID NOT POINT TO LCPB     */
@RF00967 DS    0H                                                  0983
*     END;                                                         0983
@RC00967 DS    0H                                                  0984
*   RETPTR=CRRRTN5;                 /* GET RETURN ADDRESS            */
@RC00955 L     RETPTR,CRRRTN5(,CRRPTR)                             0984
*   END CSUBR11;                    /* RETURN TO CALLER              */
@EL00014 DS    0H                                                  0985
@EF00014 DS    0H                                                  0985
@ER00014 BR    @14                                                 0985
*LCPBINIT:                                                         0986
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0986
LCPBINIT DS    0H                                                  0987
*   CRRRTN9=RETPTR;                 /* SAVE CALLER'S RETURN ADDR     */
*                                                                  0987
         ST    RETPTR,CRRRTN9(,CRRPTR)                             0987
*   /*****************************************************************/
*   /*                                                               */
*   /* THIS ROUTINE IS INVOKED BY FREEFSB WHEN AN ERROR LOCK IS FOUND*/
*   /* ON IN A FSB BEING FLUSHED. THE RESET ERROR LOCK MUST BE ISSUED*/
*   /* INTERNALLY SINCE THE USER DOES NOT KNOW IT IS SET. INITIALIZE */
*   /* LCPB FOR RESET ERROR LOCK AND QUEUE TO TPIOS OUTBOUND PAB WITH*/
*   /* RESET OPTION.                                                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0988
*   LCPBPTR=CRRLCPB;                /* REFERENCE LCPB                */
         L     LCPBPTR,CRRLCPB(,CRRPTR)                            0988
*   LCPNXLCW=ADDR(DCLLCCW2);        /* POINT TO LCCW FOR RESET       */
         LA    @12,DCLLCCW2(,LCPBPTR)                              0989
         ST    @12,LCPNXLCW(,LCPBPTR)                              0989
*   DCLRQTP=DCLRESET;               /* INDICATE RESET OPERATION      */
         MVI   DCLRQTP(LCPBPTR),X'12'                              0990
*   RFY                                                            0991
*     ISTLCCW BASED(LCPNXLCW);                                     0991
*   LCCWOP=LXEL;                    /* RESET ERROR LOCK              */
         MVI   LCCWOP(@12),X'0B'                                   0992
*   DCLSRESW=ON;                    /* INDICATE SPECIAL RESET        */
         OI    DCLSRESW(LCPBPTR),B'10000000'                       0993
*/*  TPQUE (LCPBPTR,FMCPAB3) RESET                                   */
*                                                                  0994
*   DO;                                                            0994
*     RFY                                                          0995
*      (GPR00P,                                                    0995
*       GPR01P,                                                    0995
*       GPR02P,                                                    0995
*       GPR15P) RSTD;                                              0995
*     GEN REFS(GPR01P) SETS(RPHWORK)                               0996
*         (STM   GPR14P,GPR09P,RPHWORK(GPR01P));                   0996
         STM   GPR14P,GPR09P,RPHWORK(GPR01P)
*     GPR00P=ADDR(FMCPAB3);                                        0997
         L     @12,CRRFMCB(,CRRPTR)                                0997
         LA    GPR00P,FMCPAB3(,@12)                                0997
*     GPR02P=LCPBPTR;                                              0998
         LR    GPR02P,LCPBPTR                                      0998
*     CALL ATCLCPTR->ATCAP34->ISTAPC34;                            0999
         L     @12,ATCLCPTR                                        0999
         L     @15,ATCAP34(,@12)                                   0999
         BALR  @14,@15                                             0999
*     GEN REFS(RPHWORK,GPR01P) NOSETS                              1000
*         (LM    GPR14P,GPR09P,RPHWORK(GPR01P));                   1000
         LM    GPR14P,GPR09P,RPHWORK(GPR01P)
*     RFY                                                          1001
*      (GPR00P,                                                    1001
*       GPR01P,                                                    1001
*       GPR02P,                                                    1001
*       GPR15P) UNRSTD;                                            1001
*   END;                            /* *** END OF TPQUE GENERATION 1002
*                                      SHIP RESET TO TPIOS           */
*   RETPTR=CRRRTN9;                 /* GET CALLER'S RETURN ADDRESS   */
         L     RETPTR,CRRRTN9(,CRRPTR)                             1003
*   END LCPBINIT;                   /* RETURN TO CALLER              */
@EL00015 DS    0H                                                  1004
@EF00015 DS    0H                                                  1004
@ER00015 BR    @14                                                 1004
@PB00015 DS    0H                                                  1004
*/* TPEPILOG                                                         */
*                                                                  1005
*   GEN(PRINT OFF);                                                1005
         PRINT OFF
*   DCL                                                            1006
*     ISTAPC34 ENTRY BASED(ATCAP34) VALRG(*);/* RESET ROUTINE        */
*   DCL                                                            1007
*     ISTAPC37 ENTRY BASED(ATCAP37) VALRG(*);/* TPQUE ROUTINE        */
*   GEN(PRINT ON);                                                 1008
*                                                                  1008
         PRINT ON
*/* END OF TPEPILOG                                                  */
*                                                                  1009
*   END ISTDCC11                    /* END OF PROGRAM                */
*                                                                  1009
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IFGRPL  )                                       */
*                                                                  1009
*       ;                                                          1009
@DATA    DS    0H
@DATD    DSECT
         DS    0F
ISTDCC11 CSECT
         DS    0F
@CF00105 DC    F'1'
@CF00103 DC    F'8'
@CF02547 DC    XL4'7FFFFFFF'
@CF02549 DC    XL4'80000000'
@CF02553 DC    XL4'BFFFFFFF'
@CF02555 DC    XL4'40000000'
@CF02565 DC    XL4'10000000'
@CF03732 DC    XL4'00010000'
@CF04162 DC    XL4'82000000'
@CF04303 DC    XL4'0000FFFF'
@DATD    DSECT
         DS    0D
CVTPTR   DS    A
FMCBPTR  DS    A
DNCBPTR  DS    A
WKEPTR   DS    A
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
ISTDCC11 CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
FMZA0032 DS    FL4
         ORG   FMZA0032
@NM00082 DC    AL1(80)
@NM00083 DC    AL3(0)
         ORG   FMZA0032+4
FMZA0048 DS    FL4
         ORG   FMZA0048
@NM00084 DC    AL1(80)
@NM00085 DC    AL3(0)
         ORG   FMZA0048+4
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
RPLAAREA EQU   @02
ATCVTPTR EQU   @03
WORKA    EQU   @04
COUNTER  EQU   @04
LCPBPTR  EQU   @05
FDBPTR   EQU   @06
FSBPTR   EQU   @07
LDOPTR   EQU   @09
GPR00P   EQU   @00
GPR01P   EQU   @01
GPR02P   EQU   @02
GPR03F   EQU   @03
GPR03P   EQU   @03
GPR04P   EQU   @04
GPR10F   EQU   @10
GPR11P   EQU   @11
GPR12P   EQU   @12
GPR13P   EQU   @13
GPR14F   EQU   @14
GPR14P   EQU   @14
GPR15P   EQU   @15
REG10    EQU   @10
REG11    EQU   @11
CRRPTR   EQU   @13
RETPTR   EQU   @14
RETCODE  EQU   @15
RPHPTR   EQU   @01
GPR00F   EQU   @00
GPR01F   EQU   @01
GPR02F   EQU   @02
GPR04F   EQU   @04
GPR05F   EQU   @05
GPR05P   EQU   @05
GPR06F   EQU   @06
GPR06P   EQU   @06
GPR07F   EQU   @07
GPR07P   EQU   @07
GPR08F   EQU   @08
GPR08P   EQU   @08
GPR09F   EQU   @09
GPR09P   EQU   @09
GPR10P   EQU   @10
GPR11F   EQU   @11
GPR12F   EQU   @12
GPR13F   EQU   @13
GPR15F   EQU   @15
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSALITA  EQU   PSA+764
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
ATCLCPTR EQU   1032
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTSHS   EQU   CVTXTNT2+40
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
IFGRPL   EQU   0
RPLCOMN  EQU   IFGRPL
RPLIDWD  EQU   RPLCOMN
RPLLEN   EQU   RPLIDWD+3
RPLECB   EQU   RPLCOMN+8
RPLFDBWD EQU   RPLCOMN+12
RPLFDBK  EQU   RPLFDBWD+1
RPLRTNCD EQU   RPLFDBK
RPLCNDCD EQU   RPLFDBK+1
RPLCMPON EQU   RPLCNDCD
RPLFDB2  EQU   RPLCMPON
RPLERRCD EQU   RPLCNDCD+1
RPLFDB3  EQU   RPLERRCD
RPLKEYLE EQU   RPLCOMN+16
RPLARG   EQU   RPLCOMN+36
RPLOPTCD EQU   RPLCOMN+40
RPLOPT1  EQU   RPLOPTCD
RPLECBSW EQU   RPLOPT1
RPLOPT2  EQU   RPLOPTCD+1
RPLADR   EQU   RPLOPT2
RPLOPT3  EQU   RPLOPTCD+2
RPLOPT4  EQU   RPLOPTCD+3
RPLNXTRP EQU   RPLCOMN+44
RPLRLEN  EQU   RPLCOMN+48
RPLOPTC2 EQU   RPLCOMN+56
RPLOPT5  EQU   RPLOPTC2
RPLDLGIN EQU   RPLOPT5
RPLWRTYP EQU   RPLOPT5
RPLOPT6  EQU   RPLOPTC2+1
RPLUNTYP EQU   RPLOPT6
RPLOPT7  EQU   RPLOPTC2+2
RPLCNOPT EQU   RPLOPT7
RPLOPT8  EQU   RPLOPTC2+3
RPLRBAR  EQU   RPLCOMN+60
RPLAIXID EQU   RPLRBAR+2
RPLEXTDS EQU   RPLCOMN+68
RPLEXTD1 EQU   RPLEXTDS
ISTRPH   EQU   0
RPHCNTL  EQU   ISTRPH
RPHFLAGS EQU   RPHCNTL+2
RPHAPTYP EQU   RPHFLAGS
RPHFSTLC EQU   RPHFLAGS
RPHFLGB  EQU   RPHCNTL+3
RPHRPHA  EQU   ISTRPH+4
RPHTSKID EQU   ISTRPH+8
RPHRESMA EQU   ISTRPH+16
RPHWPFLG EQU   RPHRESMA
RPHWEA   EQU   ISTRPH+24
RPHCSPA  EQU   RPHWEA
RPHSRPRM EQU   ISTRPH+28
RPHCRR   EQU   ISTRPH+32
RPHPABQA EQU   ISTRPH+36
RPHWORK  EQU   ISTRPH+40
RPHSAVE1 EQU   RPHWORK
RPHSBITS EQU   RPHSAVE1+1
ISTDCCRR EQU   0
CRRSPACE EQU   ISTDCCRR+12
CRRSAREA EQU   0
CRRSAVE  EQU   CRRSAREA
CRRSAVE1 EQU   CRRSAREA+72
CRRFSB   EQU   CRRSAREA+144
CRRMAS   EQU   CRRSAREA+148
CRRMAS1  EQU   CRRMAS
CRRM11   EQU   CRRMAS1
CRRMAS2  EQU   CRRMAS+1
CRRMAS3  EQU   CRRMAS+2
CRRMAS4  EQU   CRRMAS+3
CRRRMAS1 EQU   CRRMAS+4
CRRRMAS2 EQU   CRRMAS+5
CRRRMAS3 EQU   CRRMAS+6
CRRSMAS  EQU   CRRRMAS3
CRRATS   EQU   CRRSAREA+156
CRRATS1  EQU   CRRATS
CRRC11   EQU   CRRATS1
CRRATS2  EQU   CRRATS+1
CRRATS3  EQU   CRRATS+2
CRRATS4  EQU   CRRATS+3
CRRRATS1 EQU   CRRATS+4
CRRRATS2 EQU   CRRATS+5
CRRRATS3 EQU   CRRATS+6
CRRSATS  EQU   CRRRATS3
CRRFLGS1 EQU   CRRSAREA+164
CRRDOCUR EQU   CRRFLGS1
CRRINIO  EQU   CRRFLGS1
CRRPREIO EQU   CRRFLGS1
CRRFINI  EQU   CRRFLGS1
CRRFLGS2 EQU   CRRSAREA+165
CRRDEXP  EQU   CRRFLGS2
CRRELSRI EQU   CRRFLGS2
CRRFLGS3 EQU   CRRSAREA+166
CRRSUBBK EQU   CRRFLGS3
CRRFLGS4 EQU   CRRSAREA+167
CRRFLGS  EQU   CRRSAREA+168
CRRSW0   EQU   CRRFLGS
CRRSW1   EQU   CRRFLGS
CRRSW2   EQU   CRRFLGS
CRRSW3   EQU   CRRFLGS
CRRSW7   EQU   CRRFLGS
CRRRFLG1 EQU   CRRSAREA+169
CRRRTYPE EQU   CRRRFLG1
CRRFDBK1 EQU   CRRSAREA+170
CRRRTNCD EQU   CRRFDBK1
CRRFDB2  EQU   CRRFDBK1+1
CRRERLK  EQU   CRRFDB2
CRRSTSAV EQU   CRRFDB2
CRRFDB3  EQU   CRRFDBK1+2
CRRRDEOB EQU   CRRFDB3
CRRRDEOM EQU   CRRFDB3
CRRRDEOT EQU   CRRFDB3
CRRFDBK2 EQU   CRRSAREA+176
CRRDSB   EQU   CRRFDBK2
CRRESR   EQU   CRRFDBK2+2
CRRESR1  EQU   CRRESR
CRRESR2  EQU   CRRESR+1
CRRCLCCW EQU   CRRSAREA+180
CRRFMCB  EQU   CRRSAREA+184
CRRLCPB  EQU   CRRSAREA+192
CRRCLDO  EQU   CRRSAREA+200
CRRTRBUF EQU   CRRSAREA+204
CRRARPL  EQU   CRRTRBUF+4
CRRATCVT EQU   CRRSAREA+216
CRRRTN1  EQU   CRRSAREA+224
CRRRTN2  EQU   CRRSAREA+228
CRRRTN3  EQU   CRRSAREA+232
CRRRTN4  EQU   CRRSAREA+236
CRRRTN5  EQU   CRRSAREA+240
CRRRTN6  EQU   CRRSAREA+244
CRRRTN7  EQU   CRRSAREA+248
CRRRTN8  EQU   CRRSAREA+252
CRRRTN9  EQU   CRRSAREA+256
CRRBARAD EQU   CRRSAREA+272
CRRBLDAD EQU   CRRSAREA+276
CRRBFLGS EQU   CRRSAREA+280
CRRBRTCD EQU   CRRSAREA+281
CRRBLEN  EQU   CRRSAREA+282
CRRBTLEN EQU   CRRSAREA+284
ISTFDB   EQU   0
FDBFDBA  EQU   ISTFDB
FDBOFSET EQU   ISTFDB+10
ISTFSB   EQU   0
FSBFSB   EQU   ISTFSB
FSBMNRCD EQU   FSBFSB+2
FSBMNELI EQU   FSBMNRCD
FSBSFLGS EQU   FSBFSB+3
FSBFSBA  EQU   FSBFSB+4
FSBBTH   EQU   FSBFSB+8
FSBCID   EQU   FSBBTH
FSBRQTAG EQU   FSBBTH+4
FSBSEQID EQU   FSBRQTAG
FSBFLAGS EQU   FSBSEQID
FSBSEQ   EQU   FSBSEQID+1
FSBCSWST EQU   FSBBTH+6
FSBTHFLD EQU   FSBCSWST
FSBTH1   EQU   FSBTHFLD
FSBSYSRS EQU   FSBTH1
FSBTH2   EQU   FSBTHFLD+1
FSBEXTRS EQU   FSBTH2
FSBXFSTS EQU   FSBEXTRS
FSBXCODE EQU   FSBEXTRS
FSBNETRS EQU   FSBFSB+16
FSBSRCAT EQU   FSBNETRS
FSBMJRCD EQU   FSBSRCAT
FSBERC   EQU   FSBNETRS+1
FSBEBI   EQU   FSBERC
FSBFBMI  EQU   FSBERC
FSBLGI   EQU   FSBERC
FSBSOHI  EQU   FSBERC
FSBDMGRS EQU   FSBFSB+18
FSBSS1   EQU   FSBDMGRS
FSBSS2   EQU   FSBDMGRS+1
FSBLCPB  EQU   FSBFSB+20
FSBMSGID EQU   FSBLCPB
FSBLCCWA EQU   FSBFSB+24
FSBRLSTS EQU   FSBLCCWA
FSBFDB   EQU   ISTFSB+32
ISTLCCW  EQU   0
LCCWOP   EQU   ISTLCCW
LCCWRWOP EQU   LCCWOP
LCCWCTL  EQU   LCCWRWOP
LCCWFLAG EQU   ISTLCCW+1
LCCWLSI  EQU   LCCWFLAG
ISTLCPB  EQU   0
LCPREQTG EQU   ISTLCPB+2
LCPFLAGS EQU   LCPREQTG
LCPZF001 EQU   LCPFLAGS
LCPZRT02 EQU   LCPZF001
LCPZF002 EQU   LCPFLAGS
LCPZRT03 EQU   LCPZF002
LCPZF003 EQU   LCPFLAGS
LCPZRT04 EQU   LCPZF003
LCPZF004 EQU   LCPFLAGS
LCPZRT05 EQU   LCPZF004
LCPZRT06 EQU   LCPFLAGS
LCPZRT07 EQU   LCPFLAGS
LCPMNRCD EQU   LCPREQTG+1
LCPZRT08 EQU   LCPMNRCD
LCPZRT09 EQU   LCPMNRCD
LCPCHAIN EQU   ISTLCPB+4
LCPCHAI1 EQU   LCPCHAIN
LCPRUCNT EQU   ISTLCPB+8
LCPFLAG2 EQU   ISTLCPB+9
LCPTLBPI EQU   LCPFLAG2
LCPFID0  EQU   LCPFLAG2
LCPSEQ   EQU   ISTLCPB+10
LCPCID   EQU   ISTLCPB+16
LCPNXLCW EQU   ISTLCPB+20
LCPFDBA  EQU   ISTLCPB+24
LCPFLG1  EQU   ISTLCPB+37
LCPFLCCW EQU   ISTLCPB+40
LCPLCCW  EQU   ISTLCPB+48
LCPPABA  EQU   LCPLCCW+4
LCPRPHA  EQU   LCPPABA
ISTDCLCP EQU   0
DCLLCPB  EQU   ISTDCLCP
DCLLCCW2 EQU   ISTDCLCP+56
DCLRPLA  EQU   ISTDCLCP+72
DCLRTYPE EQU   ISTDCLCP+76
DCLRQTP  EQU   DCLRTYPE
DCLRFLG  EQU   DCLRTYPE+1
DCLFLAG1 EQU   ISTDCLCP+78
DCLSRESW EQU   DCLFLAG1
DCLLDO1  EQU   ISTDCLCP+80
DCLIOBUF EQU   ISTDCLCP+84
DCLCLDOA EQU   ISTDCLCP+88
DCLBTLEN EQU   ISTDCLCP+92
DCLIOLEN EQU   ISTDCLCP+96
ISTPAB   EQU   0
PABWQCHN EQU   ISTPAB
PABWEQA  EQU   PABWQCHN
PABCHAIN EQU   PABWQCHN+4
PABRPHFG EQU   ISTPAB+12
PABFLAGS EQU   PABRPHFG
PABERLCK EQU   PABFLAGS
PABERRLK EQU   PABERLCK
ISTPROCD EQU   0
PROPROC  EQU   ISTPROCD
PROPROC1 EQU   PROPROC
PROTRUNC EQU   PROPROC1
PROPROC2 EQU   PROPROC+1
PROCFTX  EQU   PROPROC2
PROPROC3 EQU   PROPROC+2
PROPROC4 EQU   PROPROC+3
PROPROCS EQU   0
PROSETMS EQU   PROPROCS+1
PROSETM2 EQU   PROSETMS
PROSETM3 EQU   PROSETMS+1
PROSETM4 EQU   PROSETMS+2
ISTDEVCH EQU   0
DEVSHCH  EQU   ISTDEVCH
DEVCHAR  EQU   DEVSHCH
DEVINPUT EQU   DEVCHAR
DEVTCODE EQU   ISTDEVCH+1
DEVCHAR2 EQU   DEVTCODE
DEVFLAGS EQU   ISTDEVCH+3
DEVFCCTL EQU   DEVFLAGS
DEVCHAR3 EQU   DEVFLAGS
ISTLOK   EQU   0
LOKCHN   EQU   ISTLOK+1
LOKCHNG  EQU   LOKCHN
@NM00049 EQU   LOKCHNG+2
ISTFMCB  EQU   0
FMCDNCBA EQU   ISTFMCB+16
FMCSTAT  EQU   ISTFMCB+28
FMCSTAT1 EQU   ISTFMCB+29
FMCCMDFL EQU   ISTFMCB+31
FMCCMPS1 EQU   ISTFMCB+36
FMCPROCD EQU   ISTFMCB+48
FMCPAB3  EQU   ISTFMCB+96
FMCSIPA  EQU   ISTFMCB+148
FMCNXOSQ EQU   ISTFMCB+152
FMCNXCFM EQU   FMCNXOSQ
FMCNXOSC EQU   FMCNXOSQ+2
FMCSSTAT EQU   ISTFMCB+159
FMCPACE  EQU   ISTFMCB+160
FMCPACEN EQU   FMCPACE
FMCPACEM EQU   FMCPACE+1
FMCPACPC EQU   FMCPACE+2
FMCCVAL  EQU   FMCPACE+3
FMCOBCE  EQU   FMCCVAL
FMCCLEXT EQU   ISTFMCB+164
FMCRPLA  EQU   FMCCLEXT
FMCFBA   EQU   FMCCLEXT+4
FMCCMPS2 EQU   FMCCLEXT+16
FMCFLGA  EQU   FMCCMPS2
FMCFLGA0 EQU   FMCFLGA
FMCFLGCL EQU   FMCCMPS2+1
FMCFLGB7 EQU   FMCFLGCL
FMCPSCMD EQU   FMCCMPS2+2
FMCPSTAT EQU   FMCCMPS2+3
FMCSTAT2 EQU   ISTFMCB+186
FMCMODEB EQU   ISTFMCB+189
FMCCLSEQ EQU   ISTFMCB+190
FMCRRESP EQU   ISTFMCB+195
FMCSSEGQ EQU   ISTFMCB+200
FMCFBAS  EQU   ISTFMCB+216
FMCZV002 EQU   FMCFBAS
FMCSNCTL EQU   ISTFMCB+224
FMCSCFLG EQU   FMCSNCTL
FMCVS1   EQU   ISTFMCB+232
FMCZFLAG EQU   FMCVS1
FMCZF006 EQU   FMCZFLAG
FMCLBXM  EQU   FMCVS1+12
FMCSHEAQ EQU   FMCLBXM
FMCLCPBQ EQU   FMCVS1+16
FMCLCPAQ EQU   FMCVS1+20
FMCSEQ1  EQU   FMCVS1+34
FMCZFLG2 EQU   FMCVS1+35
FMCCVFLG EQU   FMCVS1+44
FMCFLAG  EQU   0
FMCFLGB  EQU   FMCFLAG
ISTLDO   EQU   0
LDOCMD   EQU   ISTLDO
LDOFLAGS EQU   ISTLDO+1
LDOACHN  EQU   LDOFLAGS
LDOCMHN  EQU   LDOFLAGS
LDOLEN   EQU   ISTLDO+2
LDOADDR  EQU   ISTLDO+4
ISTNCB   EQU   0
NCBFLAGS EQU   ISTNCB+24
NCBFRAS  EQU   NCBFLAGS+1
NCBFTRIO EQU   NCBFRAS
NCBFLAG1 EQU   NCBFLAGS+2
NCBDEVCH EQU   ISTNCB+36
ISTDNCB  EQU   0
DNCNCB   EQU   ISTDNCB
DNCOS    EQU   ISTDNCB+56
DNCZFLGS EQU   DNCOS
DNCBSCED EQU   DNCOS+2
ISTZSAVE EQU   0
ZSAZSVBC EQU   ISTZSAVE
ZSAZSVMS EQU   ZSAZSVBC
ISTPFCRR EQU   0
PFCCRR   EQU   ISTPFCRR
PFCCRRID EQU   PFCCRR
PFCCRRLN EQU   PFCCRR+2
PFCHDR   EQU   ISTPFCRR+4
PFCCRRO  EQU   PFCHDR
PFCFRRO  EQU   PFCHDR+4
ISTCFCRR EQU   0
CFCAUDIT EQU   ISTCFCRR
CFCNTRD  EQU   CFCAUDIT
CFCCRT   EQU   CFCAUDIT+1
ISTZCRR  EQU   0
ZCRCRR   EQU   ISTZCRR
ZCRFLGS1 EQU   ISTZCRR+12
ZCRFLGS2 EQU   ISTZCRR+13
ZCRSWFLD EQU   ISTZCRR+14
ZCRENDSH EQU   ZCRSWFLD
ZCRNDLCP EQU   ZCRSWFLD
ZCRRESET EQU   ZCRSWFLD
ZCRFLGS3 EQU   ISTZCRR+15
ZCRGENSW EQU   ISTZCRR+16
ZCRPFLGS EQU   ISTZCRR+17
ZCRIBPR  EQU   ISTZCRR+18
ZCRSCPSW EQU   ISTZCRR+19
ZCRPARMS EQU   ISTZCRR+24
ZCRFBPTR EQU   ZCRPARMS
ZCRDFRDA EQU   ZCRPARMS+10
ZCRPCOD1 EQU   ZCRPARMS+12
ZCRPLSBF EQU   ZCRPCOD1
ZCRPCOD2 EQU   ZCRPARMS+13
ZCRSVRTN EQU   ISTZCRR+56
ZCRWKARA EQU   ISTZCRR+156
ZCRCIDSV EQU   ISTZCRR+192
ZCRAUDIT EQU   ISTZCRR+440
ZCRENTER EQU   ZCRAUDIT+5
ZCRLCPB  EQU   ISTZCRR+480
ZCRRHRU  EQU   ZCRLCPB
ISTASCRR EQU   0
ASCFLAGS EQU   ISTASCRR+16
ASCFLG1  EQU   ASCFLAGS
ASCFLG2  EQU   ASCFLAGS+2
ASCFLG3  EQU   ASCFLAGS+4
ASCUSRGS EQU   ISTASCRR+28
ISTAPCRR EQU   0
APCATFLG EQU   ISTAPCRR+16
APCRFLG  EQU   ISTAPCRR+18
APCSAVE  EQU   ISTAPCRR+44
APCCOMF  EQU   ISTAPCRR+116
APCCOMF1 EQU   APCCOMF
APC31FLG EQU   ISTAPCRR+132
APC52FLG EQU   ISTAPCRR+133
APC53FLG EQU   ISTAPCRR+134
APC54FLG EQU   ISTAPCRR+135
APC57FLG EQU   ISTAPCRR+136
ISTCRA   EQU   0
CRABASIC EQU   ISTCRA
CRAHDR   EQU   CRABASIC
CRALKACT EQU   CRABASIC+8
CRAPROCR EQU   ISTCRA+312
CRASVC   EQU   ISTCRA+848
CRABUFA  EQU   CRASVC+68
ISTDYPAB EQU   0
ISTATCVT EQU   0
ATCCOM   EQU   ISTATCVT
ATCSTAT  EQU   ATCCOM
ATCSTAT1 EQU   ATCSTAT
ATCSTFLG EQU   ATCSTAT+1
ATCPOFLG EQU   ATCSTAT+2
ATCSTAT4 EQU   ATCSTAT+3
ATCBPDA  EQU   ATCCOM+128
ATCIOTRC EQU   ATCCOM+140
ATCTHTRC EQU   ATCIOTRC
ATCSMRS  EQU   ATCCOM+188
ATCDCC60 EQU   ATCCOM+212
ATCESC01 EQU   ISTATCVT+288
ATCCSMR  EQU   ISTATCVT+296
ATCSHRFG EQU   ISTATCVT+316
ATCHPGM  EQU   ISTATCVT+384
ATCVLCNT EQU   ISTATCVT+772
ATCRNO   EQU   ISTATCVT+788
ATCSOPD  EQU   ISTATCVT+792
ATCSIPD  EQU   ISTATCVT+800
ATCSECST EQU   ISTATCVT+812
ATCSTAT2 EQU   ISTATCVT+818
ATCVTBAM EQU   ISTATCVT+908
@NM00077 EQU   ATCVTBAM+3
ATCAOSM  EQU   ISTATCVT+912
ATCGSRBQ EQU   ATCAOSM+4
ATCGSRBG EQU   ATCGSRBQ
ATCAP34  EQU   ATCAOSM+32
ATCICAPP EQU   ATCAOSM+100
ATCLDAPP EQU   ATCAOSM+120
ATCDAPVT EQU   ATCAOSM+140
ATCAP37  EQU   ATCAOSM+264
ATCVTFLG EQU   ATCAOSM+392
ATCZFLAG EQU   ATCAOSM+588
ISTWKE   EQU   0
WKECHAIN EQU   ISTWKE+4
WKEFLAGS EQU   WKECHAIN
LDOSAVE  EQU   0
ISTAVT   EQU   0
ISTAS49  EQU   ISTAVT+4
FMZL0008 EQU   0
FMZL0032 EQU   0
FMZL0048 EQU   0
ISTAPC34 EQU   0
ISTAPC37 EQU   0
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
PSARSVTE EQU   PSARSVT
FSBCOMBN EQU   FSBNETRS
FSBRHFLD EQU   FSBCOMBN+1
FSBRH3   EQU   FSBRHFLD+2
FSBLDFLG EQU   FSBRH3
@NM00046 EQU   FSBRQTAG
LCPZTIE  EQU   LCPCID
LCPZSNAM EQU   LCPZTIE+8
FLC      EQU   PSA
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
LCPZTRV4 EQU   LCPZSNAM+4
LCPZTRV1 EQU   LCPZSNAM
LCPZSNA  EQU   LCPZTIE+4
LCPZFMCA EQU   LCPZTIE
FSBRT0B  EQU   @NM00046+1
FSBRT0A  EQU   @NM00046+1
FSBRT09  EQU   @NM00046+1
FSBRT08  EQU   @NM00046+1
FSBRT07  EQU   @NM00046
FSBRT06  EQU   @NM00046
FSBRT05  EQU   @NM00046
FSBRT04  EQU   @NM00046
FSBRT03  EQU   @NM00046
FSBRT02  EQU   @NM00046
FSBRT01  EQU   @NM00046
FSBRT00  EQU   @NM00046
FSBLDCUF EQU   FSBLDFLG
FSBLDSIF EQU   FSBLDFLG
FSBLDSOF EQU   FSBLDFLG
FSBLDEBF EQU   FSBLDFLG
FSBLDBBF EQU   FSBLDFLG
FSBLDFME EQU   FSBLDFLG
FSBLDSCF EQU   FSBLDFLG
FSBLDRMF EQU   FSBLDFLG
FSBRH2   EQU   FSBRHFLD+1
FSBRH1   EQU   FSBRHFLD
FSBALIGN EQU   FSBCOMBN
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTRV620 EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTIRM   EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRV607 EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
ISTPDAVP EQU   ISTAVT+40
ISTAVR01 EQU   ISTAVT+38
ISTVTTP  EQU   ISTAVT+36
ISTAGTWT EQU   ISTAVT+34
ISTATRT  EQU   ISTAVT+32
ISTARID  EQU   ISTAVT+30
ISTX1    EQU   ISTAVT+29
ISTPHNM  EQU   ISTAVT+24
ISTAPSEX EQU   ISTAVT+20
ISTVTTIK EQU   ISTAVT+18
AVTASID  EQU   ISTAVT+16
ISTAPSTA EQU   ISTAVT+12
ISTAS53  EQU   ISTAVT+8
ISTAHIP  EQU   ISTAS49
ISTACVT  EQU   ISTAVT
WKECHNGP EQU   WKECHAIN+1
@NM00081 EQU   WKEFLAGS
WKEGATE  EQU   WKEFLAGS
@NM00080 EQU   ISTWKE
ATCAOS   EQU   ISTATCVT+1584
ATCPOPAB EQU   ATCAOSM+640
ATCVIOPM EQU   ATCAOSM+636
ATCTPMMI EQU   ATCAOSM+632
ATCTPMPB EQU   ATCAOSM+600
ATCRSV88 EQU   ATCAOSM+596
ATCRPLCT EQU   ATCAOSM+594
ATCCRACT EQU   ATCAOSM+592
ATCSRBCT EQU   ATCAOSM+590
ATCRSV75 EQU   ATCAOSM+589
ATCRSV66 EQU   ATCZFLAG
ATCZF001 EQU   ATCZFLAG
ATCTPCP1 EQU   ATCAOSM+584
ATCTPCP0 EQU   ATCAOSM+580
ATCAICTN EQU   ATCAOSM+576
ATCZR01  EQU   ATCAOSM+572
ATCMPLTA EQU   ATCAOSM+568
ATCASCB  EQU   ATCAOSM+564
ATCAP86  EQU   ATCAOSM+560
ATCAP85  EQU   ATCAOSM+556
ATCAP84  EQU   ATCAOSM+552
ATCAP83  EQU   ATCAOSM+548
ATCAP82  EQU   ATCAOSM+544
ATCAP69  EQU   ATCAOSM+540
ATCAP66  EQU   ATCAOSM+536
ATCAP62  EQU   ATCAOSM+532
ATCAPC59 EQU   ATCAOSM+528
ATCAP56  EQU   ATCAOSM+524
ATCAP55  EQU   ATCAOSM+520
ATCRCFY0 EQU   ATCAOSM+516
ATCAP41  EQU   ATCAOSM+512
ATCAPC25 EQU   ATCAOSM+508
ATCAP23  EQU   ATCAOSM+504
ATCTPSPB EQU   ATCAOSM+472
ATCTRMPB EQU   ATCAOSM+440
ATCAPBE  EQU   ATCAOSM+436
ATCPSTA  EQU   ATCAOSM+432
ATCSMABF EQU   ATCAOSM+428
ATCSMAPR EQU   ATCAOSM+424
ATCTPWQA EQU   ATCAOSM+420
ATCSMAID EQU   ATCAOSM+416
ATCSMARA EQU   ATCAOSM+412
ATCCACXA EQU   ATCAOSM+408
ATCZLAAB EQU   ATCAOSM+404
ATCATA10 EQU   ATCAOSM+400
ATCHLTCB EQU   ATCAOSM+396
@NM00079 EQU   ATCVTFLG
ATCVTACT EQU   ATCVTFLG
ATCRPT40 EQU   ATCAOSM+388
ATCRPT39 EQU   ATCAOSM+384
ATCRPT38 EQU   ATCAOSM+380
ATCRPT37 EQU   ATCAOSM+376
ATCRPT36 EQU   ATCAOSM+372
ATCRPT35 EQU   ATCAOSM+368
ATCRPT34 EQU   ATCAOSM+364
ATCRPT33 EQU   ATCAOSM+360
ATCRPT32 EQU   ATCAOSM+356
ATCRPT31 EQU   ATCAOSM+352
ATCRPT30 EQU   ATCAOSM+348
ATCRPT29 EQU   ATCAOSM+344
ATCRPT28 EQU   ATCAOSM+340
ATCRPT27 EQU   ATCAOSM+336
ATCRPT26 EQU   ATCAOSM+332
ATCRPT25 EQU   ATCAOSM+328
ATCRPT24 EQU   ATCAOSM+324
ATCRPT23 EQU   ATCAOSM+320
ATCRPT22 EQU   ATCAOSM+316
ATCRPT21 EQU   ATCAOSM+312
ATCRPT20 EQU   ATCAOSM+308
ATCRPT19 EQU   ATCAOSM+304
ATCRPT18 EQU   ATCAOSM+300
ATCRPT17 EQU   ATCAOSM+296
ATCRPT16 EQU   ATCAOSM+292
ATCRPT15 EQU   ATCAOSM+288
ATCRPT14 EQU   ATCAOSM+284
ATCRPT13 EQU   ATCAOSM+280
ATCRPT12 EQU   ATCAOSM+276
ATCDMAPP EQU   ATCAOSM+272
ATCAP38  EQU   ATCAOSM+268
ATCZDFJ0 EQU   ATCAOSM+260
ATCAP51  EQU   ATCAOSM+256
ATCZPAB2 EQU   ATCAOSM+224
ATCZPAB1 EQU   ATCAOSM+192
ATCZLFVT EQU   ATCAOSM+188
ATCZLPVT EQU   ATCAOSM+184
ATCZDVTX EQU   ATCAOSM+180
ATCZDVTA EQU   ATCAOSM+176
ATCZDVT9 EQU   ATCAOSM+172
ATCZDVT8 EQU   ATCAOSM+168
ATCZDVT7 EQU   ATCAOSM+164
ATCRSV56 EQU   ATCDAPVT+22
ATCDAPDG EQU   ATCDAPVT+20
ATCDXCEA EQU   ATCDAPVT+16
ATCDCEA  EQU   ATCDAPVT+12
ATCDPCIA EQU   ATCDAPVT+8
ATCDSIOA EQU   ATCDAPVT+4
ATCDEOEA EQU   ATCDAPVT
ATCZLAEA EQU   ATCLDAPP+16
ATCZLCEA EQU   ATCLDAPP+12
ATCRSV17 EQU   ATCLDAPP+8
ATCSMFRR EQU   ATCLDAPP+4
ATCCDTID EQU   ATCLDAPP
ATCZAEA  EQU   ATCICAPP+16
ATCZCEA  EQU   ATCICAPP+12
ATCCDTCB EQU   ATCICAPP+8
ATCZSIOA EQU   ATCICAPP+4
ATCCDRPH EQU   ATCICAPP
ATCAP65  EQU   ATCAOSM+96
ATCZDVT6 EQU   ATCAOSM+92
ATCZDVT4 EQU   ATCAOSM+88
ATCZDVT3 EQU   ATCAOSM+84
ATCZDVT1 EQU   ATCAOSM+80
ATCICNCB EQU   ATCAOSM+76
ATCZPSVT EQU   ATCAOSM+72
ATCZFSVT EQU   ATCAOSM+68
ATCAP64  EQU   ATCAOSM+64
ATCAP63  EQU   ATCAOSM+60
ATCAP61  EQU   ATCAOSM+56
ATCAP58  EQU   ATCAOSM+52
ATCAP57  EQU   ATCAOSM+48
ATCAP54  EQU   ATCAOSM+44
ATCAP53  EQU   ATCAOSM+40
ATCAP52  EQU   ATCAOSM+36
ATCAP32  EQU   ATCAOSM+28
ATCAP31  EQU   ATCAOSM+24
ATCAP12  EQU   ATCAOSM+20
ATCAP11  EQU   ATCAOSM+16
ATCCMTCB EQU   ATCAOSM+12
ATCPRPH  EQU   ATCAOSM+8
ATCGSRBF EQU   ATCGSRBG
ATCSRBRT EQU   ATCAOSM
@NM00078 EQU   @NM00077
ATCVTMAB EQU   @NM00077
@NM00076 EQU   ATCVTBAM
ATCVDLOK EQU   ISTATCVT+904
ATCVFPAB EQU   ISTATCVT+872
ATCVDPAB EQU   ISTATCVT+840
ATCIOECB EQU   ISTATCVT+836
ATCINCW3 EQU   ISTATCVT+832
ATCMODTB EQU   ISTATCVT+828
ATCUSSPT EQU   ISTATCVT+824
ATCSRTAB EQU   ISTATCVT+820
@NM00075 EQU   ISTATCVT+819
@NM00074 EQU   ATCSTAT2
ATCTRSMS EQU   ATCSTAT2
ATCTRLOK EQU   ATCSTAT2
ATCTRPSS EQU   ATCSTAT2
ATCTRESC EQU   ATCSTAT2
ATCTRAPI EQU   ATCSTAT2
ATCNMCTR EQU   ISTATCVT+816
ATCSEC51 EQU   ATCSECST
ATCSEC40 EQU   ATCSIPD+8
ATCSEC30 EQU   ATCSIPD+4
ATCSEC21 EQU   ATCSIPD
ATCSEC10 EQU   ATCSOPD+4
ATCSEC01 EQU   ATCSOPD
ATCPOIA  EQU   ATCRNO+1
@NM00073 EQU   ATCRNO
ATCPODVT EQU   ISTATCVT+784
ATCS49XL EQU   ISTATCVT+780
ATCS49XI EQU   ISTATCVT+776
ATCLCLCT EQU   ATCVLCNT+2
ATCRNCNT EQU   ATCVLCNT
ATCCFEAD EQU   ISTATCVT+768
ATCPTR00 EQU   ISTATCVT+736
ATCRSV10 EQU   ISTATCVT+704
ATCTACB  EQU   ISTATCVT+700
ATCVTINM EQU   ISTATCVT+696
ATCTCLIM EQU   ISTATCVT+692
ATCTCLOM EQU   ISTATCVT+688
ATCVTIPB EQU   ISTATCVT+656
ATCTCIPB EQU   ISTATCVT+624
ATCTIPAB EQU   ISTATCVT+592
ATCOCCCB EQU   ISTATCVT+588
ATCOCCOB EQU   ISTATCVT+584
ATCCDLAD EQU   ISTATCVT+580
ATCCCLAD EQU   ISTATCVT+576
ATCDLRPB EQU   ISTATCVT+544
ATCPGPAB EQU   ISTATCVT+512
ATCVPAB1 EQU   ISTATCVT+480
ATCRSV97 EQU   ISTATCVT+476
ATCRDTLK EQU   ISTATCVT+472
ATCVOCLK EQU   ISTATCVT+468
ATCCDFDN EQU   ISTATCVT+464
ATCCDFIN EQU   ISTATCVT+460
ATCDVTLK EQU   ISTATCVT+456
ATCAP36  EQU   ISTATCVT+452
ATCAP35  EQU   ISTATCVT+448
ATCAP33  EQU   ISTATCVT+444
ATCRSV99 EQU   ISTATCVT+440
ATCONFIG EQU   ISTATCVT+432
ATCNODDS EQU   ISTATCVT+428
ATCNODEL EQU   ISTATCVT+420
ATCRSV69 EQU   ISTATCVT+416
ATCAPCR5 EQU   ISTATCVT+412
ATCLDECB EQU   ISTATCVT+408
ATCLDNCS EQU   ISTATCVT+404
ATCCDPTR EQU   ISTATCVT+400
ATCADEL  EQU   ISTATCVT+396
ATCTODVT EQU   ISTATCVT+392
ATCDEBCH EQU   ISTATCVT+388
ATCHBSIZ EQU   ATCHPGM+2
ATCHBFNO EQU   ATCHPGM
ATCCRME  EQU   ISTATCVT+380
ATCRVCHS EQU   ISTATCVT+372
ATCECTLP EQU   ISTATCVT+368
ATCZDVTB EQU   ISTATCVT+364
ATCECPRT EQU   ISTATCVT+360
ATCVTLOD EQU   ISTATCVT+356
ATCTRPAB EQU   ISTATCVT+352
ATCMSGM  EQU   ISTATCVT+348
ATCMSGP  EQU   ISTATCVT+344
ATCEPT   EQU   ISTATCVT+340
ATCDVT   EQU   ISTATCVT+336
ATCTRCPT EQU   ISTATCVT+332
ATCDVLOD EQU   ISTATCVT+328
ATCALERT EQU   ISTATCVT+324
ATCEPA   EQU   ISTATCVT+320
ATCSAF   EQU   ISTATCVT+318
ATCXRANG EQU   ISTATCVT+317
ATCLAST  EQU   ATCSHRFG
ATCSHRTN EQU   ISTATCVT+308
ATCUEP   EQU   ISTATCVT+304
ATCOCRT  EQU   ISTATCVT+300
ATCCSMA  EQU   ATCCSMR
ATCESC02 EQU   ISTATCVT+292
ATCCDFND EQU   ISTATCVT+284
ATCCDDEL EQU   ISTATCVT+280
ATCCDADD EQU   ISTATCVT+276
ATCMNT   EQU   ISTATCVT+272
ATCRSV16 EQU   ISTATCVT+270
ATCMAXID EQU   ISTATCVT+269
ATCMSGSP EQU   ATCCOM+268
ATCCIDM  EQU   ATCCOM+266
ATCACTRM EQU   ATCCOM+264
ATCNERAP EQU   ATCCOM+260
ATCNESAL EQU   ATCCOM+256
ATCRCC65 EQU   ATCCOM+252
ATCRCC26 EQU   ATCCOM+248
ATCRCC63 EQU   ATCCOM+244
ATCRSV11 EQU   ATCCOM+242
ATCVTMID EQU   ATCCOM+240
ATCAPOST EQU   ATCCOM+236
ATCNERFN EQU   ATCCOM+232
ATCNERNE EQU   ATCCOM+228
ATCNERCV EQU   ATCCOM+224
ATCNERST EQU   ATCCOM+220
ATCDCC61 EQU   ATCCOM+216
ATCSRTDF EQU   ATCCOM+208
ATCSRTAD EQU   ATCCOM+204
ATCFIRA  EQU   ATCCOM+200
ATCSMBQ  EQU   ATCCOM+196
ATCSMRC  EQU   ATCCOM+192
ATCSMQU  EQU   ATCCOM+184
ATCSMRQ  EQU   ATCCOM+180
ATCACDA  EQU   ATCCOM+176
ATCSTMA  EQU   ATCCOM+172
ATCFRSTR EQU   ATCCOM+168
ATCGTSTR EQU   ATCCOM+164
ATCREADA EQU   ATCCOM+160
ATCALOAD EQU   ATCCOM+156
ATCBLDLA EQU   ATCCOM+152
ATCFBRPH EQU   ATCCOM+148
ATCBFTRC EQU   ATCCOM+144
ATCTPBUF EQU   ATCTHTRC
ATCREMOV EQU   ATCCOM+136
ATCADD   EQU   ATCCOM+132
ATCDVTPT EQU   ATCCOM+124
ATCFEPT  EQU   ATCCOM+120
ATCFDVT  EQU   ATCCOM+116
ATCCONFT EQU   ATCCOM+112
ATCPTCHA EQU   ATCCOM+108
ATCAUTHA EQU   ATCCOM+104
ATCACCTA EQU   ATCCOM+100
ATCRDTH  EQU   ATCCOM+96
ATCFRSCH EQU   ATCCOM+92
ATCFSB   EQU   ATCCOM+88
ATCHLTMS EQU   ATCCOM+84
ATCECPRM EQU   ATCCOM+80
ATCECNET EQU   ATCCOM+76
ATCECOPC EQU   ATCCOM+72
ATCVPARM EQU   ATCCOM+68
ATCECVRQ EQU   ATCCOM+64
ATCECSES EQU   ATCCOM+60
ATCOCHA  EQU   ATCCOM+56
ATCDSPLQ EQU   ATCCOM+52
ATCECDSP EQU   ATCCOM+48
ATCVARYQ EQU   ATCCOM+44
ATCECVRY EQU   ATCCOM+40
ATCHALTQ EQU   ATCCOM+36
ATCECHLT EQU   ATCCOM+32
ATCMODQ  EQU   ATCCOM+28
ATCECMOD EQU   ATCCOM+24
ATCASCHD EQU   ATCCOM+20
ATCSRT   EQU   ATCCOM+16
ATCRDT   EQU   ATCCOM+12
ATCDCFRR EQU   ATCCOM+8
ATCAPI   EQU   ATCCOM+4
ATCRSV04 EQU   ATCSTAT4
ATCVTTRC EQU   ATCSTAT4
ATCNCSD  EQU   ATCSTAT4
ATCMTST  EQU   ATCSTAT4
ATCTPRT  EQU   ATCSTAT4
ATCPRTAT EQU   ATCSTAT4
@NM00072 EQU   ATCPOFLG
ATCPOUNS EQU   ATCPOFLG
ATCHSDMF EQU   ATCSTFLG
@NM00071 EQU   ATCSTAT1
ATCMDHLT EQU   ATCSTAT1
ATCINHLT EQU   ATCSTAT1
ATCNETSL EQU   ATCSTAT1
ATCQKHLT EQU   ATCSTAT1
ATCSNHLT EQU   ATCSTAT1
ATCACTIV EQU   ATCSTAT1
ATCSTART EQU   ATCSTAT1
DYPPAB   EQU   ISTDYPAB+16
DYPRSV01 EQU   ISTDYPAB+12
DYPTSKID EQU   ISTDYPAB+8
DYPCHAIN EQU   ISTDYPAB+4
DYPFLGS  EQU   ISTDYPAB+2
DYPLNGTH EQU   ISTDYPAB+1
DYPTYPE  EQU   ISTDYPAB
CRACHAIN EQU   ISTCRA+928
CRARSV02 EQU   ISTCRA+924
CRARSV01 EQU   ISTCRA+920
CRABFTBA EQU   CRABUFA
CRAMASK  EQU   CRASVC+64
CRAHSIZ  EQU   CRASVC+60
CRAASCRR EQU   CRASVC
CRAPSS   EQU   ISTCRA+160
CRARPH   EQU   ISTCRA+52
CRALAPTR EQU   CRABASIC+48
CRAL9PTR EQU   CRABASIC+44
CRAL8PTR EQU   CRABASIC+40
CRAL7PTR EQU   CRABASIC+36
CRAL6PTR EQU   CRABASIC+32
CRAL5PTR EQU   CRABASIC+28
CRAL4PTR EQU   CRABASIC+24
CRAL3PTR EQU   CRABASIC+20
CRAL2PTR EQU   CRABASIC+16
CRAL1PTR EQU   CRABASIC+12
CRALEV01 EQU   CRALKACT+3
CRALEV02 EQU   CRALKACT+3
CRALEV03 EQU   CRALKACT+3
CRALEV04 EQU   CRALKACT+3
CRALEV05 EQU   CRALKACT+3
CRALEV06 EQU   CRALKACT+3
CRALEV07 EQU   CRALKACT+3
CRALEV08 EQU   CRALKACT+3
CRALEV09 EQU   CRALKACT+2
CRALEV10 EQU   CRALKACT+2
CRALEV11 EQU   CRALKACT+2
CRALEV12 EQU   CRALKACT+2
CRALEV13 EQU   CRALKACT+2
CRALEV14 EQU   CRALKACT+2
CRALEV15 EQU   CRALKACT+2
CRALEV16 EQU   CRALKACT+2
CRALEV17 EQU   CRALKACT+1
CRALEV18 EQU   CRALKACT+1
CRALEV19 EQU   CRALKACT+1
CRALEV20 EQU   CRALKACT+1
CRALEV21 EQU   CRALKACT+1
CRALEV22 EQU   CRALKACT+1
CRALEV23 EQU   CRALKACT+1
CRALEV24 EQU   CRALKACT+1
CRALEV25 EQU   CRALKACT
CRALEV26 EQU   CRALKACT
CRALEV27 EQU   CRALKACT
CRALEV28 EQU   CRALKACT
CRALEV29 EQU   CRALKACT
CRALEV30 EQU   CRALKACT
CRALEV31 EQU   CRALKACT
CRALEV32 EQU   CRALKACT
CRAFRR   EQU   CRAHDR+4
CRACRR   EQU   CRAHDR
@NM00070 EQU   ISTAPCRR+137
@NM00069 EQU   APC57FLG
APCNREL  EQU   APC57FLG
APCRECRA EQU   APC57FLG
@NM00068 EQU   APC54FLG
APCRLST  EQU   APC54FLG
APCPR153 EQU   APC53FLG
@NM00067 EQU   APC52FLG
APCWKF   EQU   APC52FLG
APCNWF   EQU   APC52FLG
APCRDQ   EQU   APC52FLG
APCQENQ  EQU   APC52FLG
APCSMSR  EQU   APC52FLG
APCCKRQ  EQU   APC52FLG
@NM00066 EQU   APC31FLG
APCSORT  EQU   APC31FLG
APCRESCH EQU   APC31FLG
APCTPXIT EQU   APC31FLG
APCSWTWD EQU   ISTAPCRR+128
APCSAV2  EQU   ISTAPCRR+124
APCSAV1  EQU   ISTAPCRR+120
APCRETCD EQU   APCCOMF+2
@NM00065 EQU   APCCOMF1+1
APCZLBER EQU   APCCOMF1
APCEXIT  EQU   APCCOMF1
APCRELR  EQU   APCCOMF1
APCIRB2  EQU   APCCOMF1
APCIRB1  EQU   APCCOMF1
APCSMCR  EQU   APCCOMF1
APCUETSK EQU   APCCOMF1
APCSSTSK EQU   APCCOMF1
APCESTAL EQU   APCSAVE
APCFRRPM EQU   ISTAPCRR+40
APCQWFO  EQU   ISTAPCRR+36
APCPABSV EQU   ISTAPCRR+32
APCRTRN  EQU   ISTAPCRR+28
APCTCBA  EQU   ISTAPCRR+24
APCPSTA  EQU   ISTAPCRR+20
@NM00064 EQU   APCRFLG+1
APC31R   EQU   APCRFLG
APC58R   EQU   APCRFLG
APC57R   EQU   APCRFLG
APC56R   EQU   APCRFLG
APC54R   EQU   APCRFLG
APC53R   EQU   APCRFLG
APC52R   EQU   APCRFLG
APC51R   EQU   APCRFLG
@NM00063 EQU   APCATFLG+1
APC31E   EQU   APCATFLG
APC58E   EQU   APCATFLG
APC57E   EQU   APCATFLG
APC56E   EQU   APCATFLG
APC54E   EQU   APCATFLG
APC53E   EQU   APCATFLG
APC52E   EQU   APCATFLG
APC51E   EQU   APCATFLG
APCHDRSV EQU   ISTAPCRR
ASCPSREG EQU   ISTASCRR+44
ASCUSR01 EQU   ASCUSRGS+12
ASCUSR00 EQU   ASCUSRGS+8
ASCUSR15 EQU   ASCUSRGS+4
ASCUSR14 EQU   ASCUSRGS
ASCETRYA EQU   ISTASCRR+24
ASCKEY   EQU   ISTASCRR+23
ASCAUDIT EQU   ASCFLG3
ASCFBDUD EQU   ASCFLG3
ASCLLKF  EQU   ASCFLG3
ASCKEYF  EQU   ASCFLG3
ASCFBDAL EQU   ASCFLG3
ASCFSRGT EQU   ASCFLG3
ASCICR   EQU   ASCFLG2
ASCFSRIC EQU   ASCFLG2
ASCFBDIC EQU   ASCFLG2
ASCFBAIC EQU   ASCFLG2
ASCPASTR EQU   ASCFLG1
ASCFSR   EQU   ASCFLG1
ASCFBD   EQU   ASCFLG1
ASCFBA   EQU   ASCFLG1
ASCPFCRR EQU   ISTASCRR
ZCRRU    EQU   ZCRRHRU+3
ZCRRH    EQU   ZCRRHRU
ZCRWORDA EQU   ISTZCRR+477
ZCRCMNRC EQU   ISTZCRR+476
ZCRRSV97 EQU   ZCRENTER+18
ZCREIC2B EQU   ZCRENTER+18
ZCREAC2B EQU   ZCRENTER+18
ZCRELCAB EQU   ZCRENTER+18
ZCREDCMF EQU   ZCRENTER+18
ZCREBCIF EQU   ZCRENTER+18
ZCREICSG EQU   ZCRENTER+18
ZCREDCK0 EQU   ZCRENTER+18
ZCRECFY0 EQU   ZCRENTER+17
ZCREKCCB EQU   ZCRENTER+17
ZCREDCNB EQU   ZCRENTER+17
ZCREICOE EQU   ZCRENTER+17
ZCREBCNB EQU   ZCRENTER+17
ZCREBC0L EQU   ZCRENTER+17
ZCREBCAL EQU   ZCRENTER+17
ZCREDCQR EQU   ZCRENTER+17
ZCREDCPR EQU   ZCRENTER+16
ZCREBCSB EQU   ZCRENTER+16
ZCREAC1R EQU   ZCRENTER+16
ZCRECCCI EQU   ZCRENTER+16
ZCRECCAI EQU   ZCRENTER+16
ZCRECCBI EQU   ZCRENTER+16
ZCREBCAR EQU   ZCRENTER+16
ZCREBCDR EQU   ZCRENTER+16
ZCREBCBR EQU   ZCRENTER+15
ZCREDCXR EQU   ZCRENTER+15
ZCREDCWB EQU   ZCRENTER+15
ZCREDCWR EQU   ZCRENTER+15
ZCREKCCN EQU   ZCRENTER+15
ZCREKCBN EQU   ZCRENTER+15
ZCREKCBB EQU   ZCRENTER+15
ZCREJC0B EQU   ZCRENTER+15
ZCREJCDB EQU   ZCRENTER+14
ZCREJCCB EQU   ZCRENTER+14
ZCREJCBB EQU   ZCRENTER+14
ZCREJCAB EQU   ZCRENTER+14
ZCREIC1B EQU   ZCRENTER+14
ZCREIC0B EQU   ZCRENTER+14
ZCREICX0 EQU   ZCRENTER+14
ZCREICWB EQU   ZCRENTER+14
ZCREICVB EQU   ZCRENTER+13
ZCREICUB EQU   ZCRENTER+13
ZCREICTB EQU   ZCRENTER+13
ZCREICSC EQU   ZCRENTER+13
ZCREICSB EQU   ZCRENTER+13
ZCREICRB EQU   ZCRENTER+13
ZCREICQB EQU   ZCRENTER+13
ZCREICQA EQU   ZCRENTER+13
ZCREICOB EQU   ZCRENTER+12
ZCREICOA EQU   ZCRENTER+12
ZCREICNB EQU   ZCRENTER+12
ZCREICNA EQU   ZCRENTER+12
ZCREICMB EQU   ZCRENTER+12
ZCREICLB EQU   ZCRENTER+12
ZCREICKG EQU   ZCRENTER+12
ZCREICKE EQU   ZCRENTER+12
ZCREICKB EQU   ZCRENTER+11
ZCREICJB EQU   ZCRENTER+11
ZCREICID EQU   ZCRENTER+11
ZCREICIB EQU   ZCRENTER+11
ZCREICHB EQU   ZCRENTER+11
ZCREICGB EQU   ZCRENTER+11
ZCREICEB EQU   ZCRENTER+11
ZCREICDB EQU   ZCRENTER+11
ZCREICCI EQU   ZCRENTER+10
ZCREICCB EQU   ZCRENTER+10
ZCREICBI EQU   ZCRENTER+10
ZCREICBB EQU   ZCRENTER+10
ZCREICAB EQU   ZCRENTER+10
ZCREICAA EQU   ZCRENTER+10
ZCREHCAN EQU   ZCRENTER+10
ZCREGC0B EQU   ZCRENTER+10
ZCREGC0A EQU   ZCRENTER+9
ZCREGCLA EQU   ZCRENTER+9
ZCREGCEB EQU   ZCRENTER+9
ZCREGCDB EQU   ZCRENTER+9
@NM00062 EQU   ZCRENTER+9
ZCREGCBB EQU   ZCRENTER+9
ZCREGCAB EQU   ZCRENTER+9
ZCREFCEB EQU   ZCRENTER+9
ZCREFCEA EQU   ZCRENTER+8
ZCREECTA EQU   ZCRENTER+8
ZCREECEA EQU   ZCRENTER+8
ZCREECDA EQU   ZCRENTER+8
ZCREECCB EQU   ZCRENTER+8
ZCREECCA EQU   ZCRENTER+8
ZCREECBB EQU   ZCRENTER+8
ZCREECBA EQU   ZCRENTER+8
ZCREDCMB EQU   ZCRENTER+7
ZCREDCL0 EQU   ZCRENTER+7
ZCREDCKB EQU   ZCRENTER+7
ZCREDCKA EQU   ZCRENTER+7
ZCREDCJ0 EQU   ZCRENTER+7
ZCREDCI0 EQU   ZCRENTER+7
ZCREDCH0 EQU   ZCRENTER+7
ZCREDCF0 EQU   ZCRENTER+7
ZCREDCE0 EQU   ZCRENTER+6
ZCREDCD0 EQU   ZCRENTER+6
ZCREDCC0 EQU   ZCRENTER+6
ZCREDCB0 EQU   ZCRENTER+6
ZCREDCA0 EQU   ZCRENTER+6
ZCRECC2B EQU   ZCRENTER+6
ZCRECC1B EQU   ZCRENTER+6
ZCRECC1A EQU   ZCRENTER+6
ZCRECC0B EQU   ZCRENTER+5
ZCRECC0A EQU   ZCRENTER+5
ZCREBC0B EQU   ZCRENTER+5
ZCREBC0A EQU   ZCRENTER+5
ZCREBCZ0 EQU   ZCRENTER+5
ZCREBCY0 EQU   ZCRENTER+5
ZCREBCX0 EQU   ZCRENTER+5
ZCREBCXA EQU   ZCRENTER+5
ZCREBCSC EQU   ZCRENTER+4
ZCREBCRB EQU   ZCRENTER+4
ZCREBCRA EQU   ZCRENTER+4
ZCREBCQB EQU   ZCRENTER+4
ZCREBCPB EQU   ZCRENTER+4
ZCREBCOB EQU   ZCRENTER+4
ZCREBCNE EQU   ZCRENTER+4
ZCREBCND EQU   ZCRENTER+4
ZCREBCMB EQU   ZCRENTER+3
ZCREBCLB EQU   ZCRENTER+3
ZCREBCLA EQU   ZCRENTER+3
ZCREBCKB EQU   ZCRENTER+3
ZCREBCKA EQU   ZCRENTER+3
ZCREBCJB EQU   ZCRENTER+3
ZCREBCJA EQU   ZCRENTER+3
ZCREBCID EQU   ZCRENTER+3
ZCREBCIB EQU   ZCRENTER+2
ZCREBCIA EQU   ZCRENTER+2
ZCREBCHB EQU   ZCRENTER+2
ZCREBCHA EQU   ZCRENTER+2
ZCREBCGB EQU   ZCRENTER+2
ZCREBCGA EQU   ZCRENTER+2
ZCREBCFB EQU   ZCRENTER+2
ZCREBCFA EQU   ZCRENTER+2
ZCREBCEB EQU   ZCRENTER+1
ZCREBCDI EQU   ZCRENTER+1
ZCREBCCB EQU   ZCRENTER+1
ZCREBCBI EQU   ZCRENTER+1
ZCREBCBB EQU   ZCRENTER+1
ZCREBCBA EQU   ZCRENTER+1
ZCREBCAM EQU   ZCRENTER+1
ZCREBCAI EQU   ZCRENTER+1
ZCREBCAG EQU   ZCRENTER
ZCREBCAE EQU   ZCRENTER
ZCREBCAB EQU   ZCRENTER
ZCREBCAA EQU   ZCRENTER
ZCREAC1B EQU   ZCRENTER
ZCREAC0B EQU   ZCRENTER
ZCREAC0A EQU   ZCRENTER
ZCREAC1A EQU   ZCRENTER
ZCRTNAME EQU   ZCRAUDIT+1
ZCRTID   EQU   ZCRAUDIT
ZCRREMIC EQU   ISTZCRR+436
ZCRSAVEZ EQU   ISTZCRR+196
ZCRDAFSV EQU   ZCRCIDSV+2
ZCRSAFSV EQU   ZCRCIDSV
ZCRR13SV EQU   ISTZCRR+188
ZCRR2SV  EQU   ISTZCRR+184
ZCROPCDE EQU   ISTZCRR+183
ZCRPRMTC EQU   ISTZCRR+182
ZCRRCDSV EQU   ISTZCRR+181
ZCRAWQSW EQU   ISTZCRR+180
ZCRTOPQ  EQU   ISTZCRR+180
ZCRLSTFB EQU   ISTZCRR+180
ZCRXSCHD EQU   ISTZCRR+180
ZCRNXTEL EQU   ISTZCRR+180
ZCRSCANQ EQU   ISTZCRR+180
ZCRMOREL EQU   ISTZCRR+180
ZCRFBPRC EQU   ISTZCRR+180
ZCRFSBSV EQU   ISTZCRR+176
ZCRSVWK5 EQU   ZCRWKARA+16
ZCRSVWK4 EQU   ZCRWKARA+12
ZCRSVWK3 EQU   ZCRWKARA+8
ZCRSVWK2 EQU   ZCRWKARA+4
ZCRSVWK1 EQU   ZCRWKARA
ZCRSVF25 EQU   ZCRSVRTN+96
ZCRSVF24 EQU   ZCRSVRTN+92
ZCRSVF23 EQU   ZCRSVRTN+88
ZCRSVF22 EQU   ZCRSVRTN+84
ZCRSVF21 EQU   ZCRSVRTN+80
ZCRSVF20 EQU   ZCRSVRTN+76
ZCRSVF19 EQU   ZCRSVRTN+72
ZCRSVF18 EQU   ZCRSVRTN+68
ZCRSVF17 EQU   ZCRSVRTN+64
ZCRSVF16 EQU   ZCRSVRTN+60
ZCRSVF15 EQU   ZCRSVRTN+56
ZCRSVF14 EQU   ZCRSVRTN+52
ZCRSVF13 EQU   ZCRSVRTN+48
ZCRSVF12 EQU   ZCRSVRTN+44
ZCRSVF11 EQU   ZCRSVRTN+40
ZCRSVF10 EQU   ZCRSVRTN+36
ZCRSVF9  EQU   ZCRSVRTN+32
ZCRSVF8  EQU   ZCRSVRTN+28
ZCRSVF7  EQU   ZCRSVRTN+24
ZCRSVF6  EQU   ZCRSVRTN+20
ZCRSVF5  EQU   ZCRSVRTN+16
ZCRSVF4  EQU   ZCRSVRTN+12
ZCRSVF3  EQU   ZCRSVRTN+8
ZCRSVF2  EQU   ZCRSVRTN+4
ZCRSVF1  EQU   ZCRSVRTN
ZCRPVZB  EQU   ISTZCRR+52
ZCRZLB   EQU   ISTZCRR+48
ZCRBFPTR EQU   ISTZCRR+44
ZCRCCWA  EQU   ISTZCRR+40
ZCRPSW   EQU   ZCRPARMS+15
ZCRPCHAR EQU   ZCRPARMS+14
ZCRPRES2 EQU   ZCRPCOD2
ZCRPMFGF EQU   ZCRPCOD2
ZCRPFHDR EQU   ZCRPCOD2
ZCRPPG2  EQU   ZCRPCOD2
ZCRPRES  EQU   ZCRPCOD1
ZCRPCFTX EQU   ZCRPCOD1
ZCRPBUF  EQU   ZCRPCOD1
ZCRPLSCB EQU   ZCRPCOD1
ZCRPLSBQ EQU   ZCRPLSBF
ZCRPFSB  EQU   ZCRPCOD1
ZCRPLNG  EQU   ZCRPCOD1
ZCRPPG   EQU   ZCRPCOD1
ZCRDTODA EQU   ZCRDFRDA
ZCRMLNG  EQU   ZCRPARMS+8
ZCRTBPTR EQU   ZCRPARMS+4
ZCRCBPTR EQU   ZCRFBPTR
ZCRCRLCP EQU   ISTZCRR+20
@NM00061 EQU   ZCRSCPSW
ZCRSKIPT EQU   ZCRSCPSW
ZCRFSBWE EQU   ZCRSCPSW
ZCRPRCMP EQU   ZCRSCPSW
ZCRLREQ  EQU   ZCRSCPSW
ZCRRJLCP EQU   ZCRSCPSW
ZCRTPINV EQU   ZCRSCPSW
ZCRTPEX  EQU   ZCRSCPSW
@NM00060 EQU   ZCRIBPR
ZCR3270R EQU   ZCRIBPR
ZCR3270  EQU   ZCRIBPR
ZCRLCPFD EQU   ZCRIBPR
ZCRLCPFR EQU   ZCRIBPR
ZCRRELK  EQU   ZCRIBPR
ZCRERR   EQU   ZCRIBPR
ZCRNOBUF EQU   ZCRIBPR
@NM00059 EQU   ZCRPFLGS
ZCRQAHED EQU   ZCRPFLGS
ZCRF1RES EQU   ZCRGENSW
ZCRBRIS  EQU   ZCRGENSW
ZCRCLRBD EQU   ZCRGENSW
ZCREXRES EQU   ZCRGENSW
ZCRLCSYN EQU   ZCRGENSW
ZCRRT06  EQU   ZCRGENSW
ZCRTSW2  EQU   ZCRGENSW
ZCRTSW1  EQU   ZCRGENSW
ZCRINLCP EQU   ZCRFLGS3
ZCRWRPTR EQU   ZCRFLGS3
ZCRNOFRE EQU   ZCRFLGS3
ZCREDRIV EQU   ZCRFLGS3
ZCRDISC  EQU   ZCRFLGS3
ZCRTPDIS EQU   ZCRFLGS3
ZCRTPCON EQU   ZCRFLGS3
ZCRTIC   EQU   ZCRFLGS3
ZCRCNLXL EQU   ZCRRESET
ZCRENDAN EQU   ZCRSWFLD
ZCRENDXL EQU   ZCRSWFLD
ZCRENDX  EQU   ZCRSWFLD
ZCROB1   EQU   ZCRNDLCP
ZCRENDPR EQU   ZCRSWFLD
ZCREXTYP EQU   ZCRSWFLD
ZCRSLCP  EQU   ZCRENDSH
ZCRIF0E3 EQU   ZCRFLGS2
ZCRIF0E2 EQU   ZCRFLGS2
ZCRIF0E1 EQU   ZCRFLGS2
ZCROB    EQU   ZCRFLGS2
ZCRFMSED EQU   ZCRFLGS2
ZCRSHEDI EQU   ZCRFLGS2
ZCRLOCAL EQU   ZCRFLGS2
ZCRFEXIT EQU   ZCRFLGS1
ZCRUNSOL EQU   ZCRFLGS1
ZCRENDLP EQU   ZCRFLGS1
ZCRNRMEX EQU   ZCRFLGS1
ZCRWAIT  EQU   ZCRFLGS1
ZCRDEQSW EQU   ZCRFLGS1
ZCRQUESW EQU   ZCRFLGS1
ZCREXSW  EQU   ZCRFLGS1
ZCRFRRA  EQU   ISTZCRR+8
ZCRCHAIN EQU   ISTZCRR+4
ZCRFLAG  EQU   ZCRCRR+3
ZCRLEN   EQU   ZCRCRR+1
ZCRID    EQU   ZCRCRR
CCFRSVD1 EQU   CFCCRT
CCFCR2   EQU   CFCCRT
CCFCRP   EQU   CFCCRT
CCFCR1   EQU   CFCCRT
CCFCS2   EQU   CFCCRT
CCFCS1   EQU   CFCCRT
NCFRSVD  EQU   CFCNTRD
NCFCR2   EQU   CFCNTRD
NCFCRP   EQU   CFCNTRD
NCFCR1   EQU   CFCNTRD
NCFCS2   EQU   CFCNTRD
NCFCS1   EQU   CFCNTRD
PFCRSV01 EQU   ISTPFCRR+13
PFCFTA   EQU   ISTPFCRR+12
CRRFRR   EQU   PFCFRRO
CRRCHAIN EQU   PFCCRRO
CRRLEN   EQU   PFCCRRLN
PFCRSV10 EQU   PFCCRR+1
CRRID    EQU   PFCCRRID
ZSAZTRAC EQU   ISTZSAVE+36
ZSAZSVVR EQU   ISTZSAVE+12
ZSAZSVRR EQU   ISTZSAVE+8
ZSAZSVFC EQU   ISTZSAVE+4
ZSAZACTV EQU   ZSAZSVMS
DNCZC001 EQU   DNCOS+40
DNCLOCK  EQU   DNCOS+36
DNCZV005 EQU   DNCOS+32
DNCZV004 EQU   DNCOS+28
DNCZV003 EQU   DNCOS+24
DNCZV002 EQU   DNCOS+21
DNCZX001 EQU   DNCOS+20
DNCZV001 EQU   DNCOS+17
DNCZX003 EQU   DNCOS+16
DNCZV000 EQU   DNCOS+12
DNCSESCQ EQU   DNCOS+8
DNCSESIQ EQU   DNCOS+4
DNCACIP  EQU   DNCBSCED+1
DNCLICP  EQU   DNCBSCED
DNCZF008 EQU   DNCZFLGS+1
DNCZPSRD EQU   DNCZFLGS+1
DNCPSOL  EQU   DNCZFLGS+1
DNCZF007 EQU   DNCZFLGS+1
DNCZF006 EQU   DNCZFLGS+1
DNCZF005 EQU   DNCZFLGS+1
DNCZF004 EQU   DNCZFLGS+1
DNCZF003 EQU   DNCZFLGS
DNCZF002 EQU   DNCZFLGS
DNCZRSCH EQU   DNCZFLGS
DNCDISC  EQU   DNCZFLGS
DNCCONT  EQU   DNCZFLGS
DNCINVIT EQU   DNCZFLGS
DNCSESS  EQU   DNCZFLGS
DNCZF001 EQU   DNCZFLGS
DNCMODE  EQU   ISTDNCB+49
DNCBHSET EQU   ISTDNCB+48
NCBRSV01 EQU   ISTNCB+46
NCBSWDAF EQU   ISTNCB+44
NCBFMCBP EQU   ISTNCB+32
NCBLTRC  EQU   ISTNCB+30
NCBRVPT1 EQU   ISTNCB+28
NCBNMLLN EQU   NCBFLAGS+3
@NM00058 EQU   NCBFLAG1
NCBFORCE EQU   NCBFLAG1
NCBTTF   EQU   NCBFLAG1
NCBRSYNC EQU   NCBFLAG1
NCBRSTRT EQU   NCBFLAG1
NCBCONF  EQU   NCBFLAG1
NCBSNAI  EQU   NCBFLAG1
NCBFLTIO EQU   NCBFTRIO
NCBCSTAT EQU   NCBFLAGS
NCBNCSL  EQU   ISTNCB+22
NCBNCBA  EQU   ISTNCB+20
NCBFMCBA EQU   ISTNCB+16
NCBNSNA  EQU   ISTNCB+12
NCBTSKID EQU   ISTNCB+8
NCBRDTE  EQU   ISTNCB+4
NCBDAF   EQU   ISTNCB+2
NCBLNGTH EQU   ISTNCB+1
NCBTYPE  EQU   ISTNCB
FMCFLRSV EQU   FMCFLGB
FMCFLGA8 EQU   FMCFLGB
FMCCLRPH EQU   FMCVS1+45
FMCRSV0X EQU   FMCCVFLG
FMCVYRPH EQU   FMCCVFLG
FMCZV004 EQU   FMCVS1+40
FMCLOCK2 EQU   FMCVS1+36
@NM00057 EQU   FMCZFLG2
FMCZF027 EQU   FMCZFLG2
FMCZF026 EQU   FMCZFLG2
FMCSEQ1B EQU   FMCSEQ1
FMCSEQ1T EQU   FMCSEQ1
FMCZX006 EQU   FMCVS1+33
FMCZX005 EQU   FMCVS1+32
FMCZX004 EQU   FMCVS1+31
FMCZX003 EQU   FMCVS1+30
FMCZX002 EQU   FMCVS1+29
FMCZX001 EQU   FMCVS1+28
FMCZV001 EQU   FMCVS1+24
FMCAWATQ EQU   FMCLCPAQ+1
@NM00056 EQU   FMCLCPAQ
FMCLCPB2 EQU   FMCLCPBQ+1
FMCLCPB1 EQU   FMCLCPBQ
FMCASCDQ EQU   FMCSHEAQ+1
@NM00055 EQU   FMCSHEAQ
FMCSHEDQ EQU   FMCVS1+8
FMCZFCSQ EQU   FMCVS1+6
FMCZH001 EQU   FMCVS1+4
FMCZF025 EQU   FMCZFLAG+3
FMCZF024 EQU   FMCZFLAG+3
FMCZF023 EQU   FMCZFLAG+3
FMCZF022 EQU   FMCZFLAG+3
FMCZF021 EQU   FMCZFLAG+3
FMCZF020 EQU   FMCZFLAG+3
FMCZF019 EQU   FMCZFLAG+3
FMCZF018 EQU   FMCZFLAG+3
FMCZF017 EQU   FMCZFLAG+2
FMCZF016 EQU   FMCZFLAG+2
FMCZF015 EQU   FMCZFLAG+2
FMCZF014 EQU   FMCZFLAG+2
FMCZF013 EQU   FMCZFLAG+2
FMCZF012 EQU   FMCZFLAG+2
FMCZF011 EQU   FMCZFLAG+2
FMCZF010 EQU   FMCZFLAG+2
FMCZF00F EQU   FMCZFLAG+1
FMCZF00E EQU   FMCZFLAG+1
FMCZF00D EQU   FMCZFLAG+1
FMCZF00C EQU   FMCZFLAG+1
FMCZF00B EQU   FMCZFLAG+1
FMCRSV10 EQU   FMCZFLAG+1
FMCZF009 EQU   FMCZFLAG+1
FMCZFD06 EQU   FMCZF006+1
FMCZFC06 EQU   FMCZF006
FMCZFB06 EQU   FMCZF006
FMCZFA06 EQU   FMCZF006
FMCZF005 EQU   FMCZFLAG
FMCZF004 EQU   FMCZFLAG
FMCZF003 EQU   FMCZFLAG
FMCZF002 EQU   FMCZFLAG
FMCZF001 EQU   FMCZFLAG
FMCFRESA EQU   ISTFMCB+228
FMCSCSQN EQU   FMCSNCTL+2
FMCSCCTL EQU   FMCSNCTL+1
FMCSTCTL EQU   FMCSCFLG
FMCSCCLO EQU   FMCSCFLG
FMCAPRO  EQU   FMCSCFLG
FMCLURO  EQU   FMCSCFLG
FMCOBSAC EQU   FMCSCFLG
FMCIBSAC EQU   FMCSCFLG
FMCFBRE  EQU   ISTFMCB+220
FMCFBXM  EQU   FMCZV002
FMCASEGQ EQU   ISTFMCB+212
FMCRDTPT EQU   ISTFMCB+208
FMCLOCK  EQU   ISTFMCB+204
FMCSEGD  EQU   FMCSSEGQ
FMCRSPLM EQU   ISTFMCB+198
FMCPSTRS EQU   ISTFMCB+196
@NM00054 EQU   FMCRRESP
FMCTSLHA EQU   FMCRRESP
FMCFRRN  EQU   FMCRRESP
FMCFME   EQU   FMCRRESP
FMCFEX   EQU   FMCRRESP
FMCFPE   EQU   FMCRRESP
FMCCTLB  EQU   ISTFMCB+194
FMCBSQNO EQU   FMCCLSEQ+2
FMCTSQNO EQU   FMCCLSEQ
FMCOBPRG EQU   FMCMODEB
FMCIBPRG EQU   FMCMODEB
FMCRESOT EQU   FMCMODEB
FMCRSTSR EQU   FMCMODEB
FMCLUQ   EQU   FMCMODEB
FMCAPQ   EQU   FMCMODEB
FMCCLEAR EQU   FMCMODEB
FMCHOLD  EQU   FMCMODEB
FMCIPSEQ EQU   ISTFMCB+188
FMCLUSTR EQU   ISTFMCB+187
FMCRSV87 EQU   FMCSTAT2
FMCSEQI  EQU   FMCSTAT2
FMCCPIP  EQU   FMCSTAT2
FMCALIPR EQU   FMCSTAT2
FMCIAIO  EQU   FMCSTAT2
FMCZF00A EQU   FMCSTAT2
FMCVPIP  EQU   FMCSTAT2
FMCBHSET EQU   ISTFMCB+185
FMCPRMRC EQU   FMCCLEXT+20
FMCRSV89 EQU   FMCPSTAT
FMCPCLSD EQU   FMCPSTAT
FMCDDOCD EQU   FMCPSTAT
FMCIDVFD EQU   FMCPSTAT
FMCELKST EQU   FMCPSTAT
FMCRSV88 EQU   FMCPSCMD
FMCRDBLK EQU   FMCPSCMD
FMCDSEOC EQU   FMCPSCMD
FMCPURGE EQU   FMCPSCMD
FMCRESTI EQU   FMCPSCMD
FMCCNTCT EQU   FMCPSCMD
FMCINVT  EQU   FMCPSCMD
FMCFLGB6 EQU   FMCFLGCL
FMCFLGB5 EQU   FMCFLGCL
FMCFLGB4 EQU   FMCFLGCL
FMCFLGB3 EQU   FMCFLGCL
FMCFLGB2 EQU   FMCFLGCL
FMCFLGB1 EQU   FMCFLGCL
FMCFLGB0 EQU   FMCFLGCL
FMCFLGA7 EQU   FMCFLGA
FMCFLGA6 EQU   FMCFLGA
FMCFLGA5 EQU   FMCFLGA
FMCFLGA4 EQU   FMCFLGA
FMCFLGA3 EQU   FMCFLGA
FMCFLGA2 EQU   FMCFLGA
FMCFLGA1 EQU   FMCFLGA
FMCDCLOK EQU   FMCCLEXT+12
FMCRAFM  EQU   FMCCLEXT+8
FMCFBPTR EQU   FMCFBA+1
FMCFBRSV EQU   FMCFBA
FMCRPLPT EQU   FMCRPLA+1
FMCRPLRS EQU   FMCRPLA
FMCPRCLS EQU   FMCCVAL
FMCIBCE  EQU   FMCCVAL
FMCONLY  EQU   FMCOBCE
FMCLAST  EQU   FMCOBCE
FMCMIDLE EQU   FMCOBCE
FMCFIRST EQU   FMCOBCE
FMCCPCNT EQU   FMCPACPC
FMCMPCNT EQU   FMCPACEM
FMCNPCNT EQU   FMCPACEN
FMCCONF  EQU   FMCSSTAT
FMCPURCH EQU   FMCSSTAT
FMCNSALU EQU   FMCSSTAT
FMCBIP   EQU   FMCSSTAT
FMCSDTR  EQU   FMCSSTAT
FMCUIPI  EQU   FMCSSTAT
FMCCIPI  EQU   FMCSSTAT
FMCSNBI  EQU   FMCSSTAT
FMCRVD01 EQU   ISTFMCB+158
FMCISSN  EQU   ISTFMCB+156
FMCOASN  EQU   FMCNXOSC
FMCOSSN  EQU   FMCNXCFM
FMCSIP   EQU   FMCSIPA
FMCEXLST EQU   ISTFMCB+144
FMCPAB5  EQU   ISTFMCB+128
FMCPAB4  EQU   ISTFMCB+112
FMCPAB2  EQU   ISTFMCB+80
FMCPAB1  EQU   ISTFMCB+64
FMCFASYA EQU   ISTFMCB+60
FMCMODE  EQU   ISTFMCB+52
FMCVWT   EQU   ISTFMCB+44
FMCRPLH  EQU   ISTFMCB+40
FMCBUFNB EQU   FMCCMPS1+2
FMCBUFLM EQU   FMCCMPS1
FMCDEBA  EQU   ISTFMCB+32
@NM00053 EQU   FMCCMDFL
FMCSNA   EQU   FMCCMDFL
FMCVSNA  EQU   FMCCMDFL
FMCCMDR  EQU   FMCCMDFL
@NM00052 EQU   ISTFMCB+30
@NM00051 EQU   FMCSTAT1
FMCLTCLS EQU   FMCSTAT1
FMCHPURG EQU   FMCSTAT1
FMCVSP2  EQU   FMCSTAT1
FMCVSP1  EQU   FMCSTAT
FMCLTEAS EQU   FMCSTAT
FMCZF007 EQU   FMCSTAT
FMCDEDSC EQU   FMCSTAT
FMCDEVOF EQU   FMCSTAT
FMCDAPT  EQU   FMCSTAT
FMCPRMTE EQU   FMCSTAT
FMCPRMTR EQU   FMCSTAT
FMCUSFLD EQU   ISTFMCB+24
FMCFMCBA EQU   ISTFMCB+20
FMCDVTA  EQU   ISTFMCB+12
FMCTSKID EQU   ISTFMCB+8
FMCNXTCB EQU   ISTFMCB+4
FMCSAF   EQU   ISTFMCB+2
FMCLNGTH EQU   ISTFMCB+1
FMCTYPE  EQU   ISTFMCB
LOKXCL   EQU   @NM00049
LOKPRY   EQU   @NM00049
@NM00050 EQU   @NM00049
@NM00048 EQU   LOKCHNG
LOKCT    EQU   ISTLOK
DEVRSV03 EQU   ISTDEVCH+5
DEVPHYSA EQU   ISTDEVCH+4
DEVCSLPN EQU   DEVCHAR3
DEVCSTCL EQU   DEVCHAR3
DEVCCHEK EQU   DEVCHAR3
DEVCATTN EQU   DEVCHAR3
DEVCSWL  EQU   DEVFCCTL
DEVCRVB  EQU   DEVFCCTL
DEVCSSL  EQU   DEVFCCTL
DEVCBSC  EQU   DEVFCCTL
DEVMCODE EQU   ISTDEVCH+2
DEVRSV01 EQU   DEVCHAR
DEVCCTL  EQU   DEVCHAR
DEVNNSPT EQU   DEVCHAR
DEVSPS   EQU   DEVCHAR
DEVSUBND EQU   DEVCHAR
DEVCONVR EQU   DEVCHAR
DEVOTPUT EQU   DEVCHAR
PROSRDEF EQU   PROSETM4
PRORSV47 EQU   PROSETM4
PROSCON  EQU   PROSETM4
PRORSV46 EQU   PROSETM3
PROSMONT EQU   PROSETM3
PRORSV45 EQU   PROSETM3
PROSNTO  EQU   PROSETM3
PRORSV44 EQU   PROSETM3
PRORSV43 EQU   PROSETM2
PROSNTFL EQU   PROSETM2
PRORSV42 EQU   PROSETM2
PRORSV41 EQU   PROPROCS
PROMODC  EQU   PROPROC4
PROMODT  EQU   PROPROC4
PROMODM  EQU   PROPROC4
PROMODB  EQU   PROPROC4
PRORSV14 EQU   PROPROC4
PRORSV13 EQU   PROPROC4
PRORSV12 EQU   PROPROC4
PROEIB   EQU   PROPROC4
PRORSV11 EQU   PROPROC3
PROMONT2 EQU   PROPROC3
PROMONIT EQU   PROPROC3
PROSUBLK EQU   PROPROC3
PRONTO   EQU   PROPROC3
PROLGIN  EQU   PROPROC3
PROERPI  EQU   PROPROC3
PRORSV07 EQU   PROPROC3
PROEMLC  EQU   PROPROC2
PRONTFL  EQU   PROPROC2
PRORSV05 EQU   PROPROC2
PRORSV04 EQU   PROPROC2
PROLGOT  EQU   PROPROC2
PROERPO  EQU   PROPROC2
PRORSV03 EQU   PROPROC2
PRORPLC  EQU   PROPROC1
PROCS    EQU   PROPROC1
PROCA    EQU   PROPROC1
PRORESPX EQU   PROPROC1
PRODFASY EQU   PROPROC1
PROXPOPT EQU   PROPROC1
PROASYIP EQU   PROPROC1
PABRPHA  EQU   PABRPHFG+1
PABNODQ  EQU   PABFLAGS
PABINHBT EQU   PABFLAGS
PABERLOK EQU   PABERRLK
PABSSN   EQU   PABFLAGS
PABDYNAM EQU   PABFLAGS
PABNORPR EQU   PABFLAGS
PABPRIOR EQU   PABFLAGS
PABAPYP  EQU   PABFLAGS
PABDVTA  EQU   ISTPAB+9
PABOFFST EQU   ISTPAB+8
PABCHNGP EQU   PABCHAIN+1
PABRSV02 EQU   PABCHAIN
PABRUNNG EQU   PABCHAIN
PABRESET EQU   PABCHAIN
PABUNCON EQU   PABCHAIN
PABCDP   EQU   PABCHAIN
PABRESCH EQU   PABCHAIN
PABCHNG  EQU   PABCHAIN
PABWEQP  EQU   PABWEQA+1
PABRSV01 EQU   PABWEQA
PABWEQG  EQU   PABWEQA
DCLECHAR EQU   ISTDCLCP+98
DCLRSV03 EQU   ISTDCLCP+79
DCLRSV02 EQU   DCLFLAG1
DCLRPLS  EQU   DCLFLAG1
DCLBTEIS EQU   DCLFLAG1
DCLNODE  EQU   DCLFLAG1
DCLRSV04 EQU   DCLFLAG1
DCLBNSP  EQU   DCLRFLG
DCLCONV  EQU   DCLRFLG
DCLRSV01 EQU   DCLRFLG
DCLLCCW3 EQU   ISTDCLCP+64
LCPFTYPE EQU   LCPRPHA
LCPRSTQH EQU   LCPLCCW
LCPCLREP EQU   ISTLCPB+44
LCPUBFSB EQU   LCPFLCCW
LCPRSV77 EQU   ISTLCPB+39
LCPLCCWC EQU   ISTLCPB+38
LCPRSV78 EQU   LCPFLG1
LCPTRANS EQU   LCPFLG1
LCPSTLB  EQU   LCPFLG1
LCPREDRV EQU   LCPFLG1
LCPDIRPT EQU   LCPFLG1
LCPINTER EQU   LCPFLG1
LCPRESET EQU   LCPFLG1
LCPSTYPE EQU   ISTLCPB+36
LCPFSNCH EQU   ISTLCPB+34
LCPFOSN  EQU   ISTLCPB+32
LCPTLBAD EQU   ISTLCPB+28
LCPFDB2  EQU   LCPFDBA+1
LCPFDB1  EQU   LCPFDBA
LCPDAF   EQU   LCPCID+2
LCPSAF   EQU   LCPCID
LCPLCCW1 EQU   ISTLCPB+12
LCPRRCNT EQU   LCPSEQ+1
LCPRRCCT EQU   LCPSEQ
LCPATOP  EQU   LCPFLAG2
LCPFREE  EQU   LCPFLAG2
LCPDSTAT EQU   LCPFLAG2
LCPEXRES EQU   LCPFID0
LCPZRIMM EQU   LCPTLBPI
LCPRSTRT EQU   LCPFLAG2
LCPASYN  EQU   LCPFLAG2
LCPPRFLG EQU   LCPFLAG2
LCPZMIRC EQU   LCPRUCNT
LCPCHAI2 EQU   LCPCHAIN+1
LCPCHNG  EQU   LCPCHAI1
LCPZRT0B EQU   LCPMNRCD
LCPZRT0A EQU   LCPMNRCD
LCPZRTL9 EQU   LCPZRT09
LCPZRTL8 EQU   LCPZRT08
LCPZRTL7 EQU   LCPZRT07
LCPZRTL6 EQU   LCPZRT06
LCPZRTL5 EQU   LCPZRT05
LCPZRTL4 EQU   LCPZRT04
LCPZRTL3 EQU   LCPZRT03
LCPZRTL2 EQU   LCPZRT02
LCPZRT01 EQU   LCPFLAGS
LCPZRT00 EQU   LCPFLAGS
LCPLNGTH EQU   ISTLCPB+1
LCPTYPE  EQU   ISTLCPB
LCCWDATA EQU   ISTLCCW+4
LCCWCNT  EQU   ISTLCCW+2
LCCWACI  EQU   LCCWFLAG
LCCWRFI  EQU   LCCWFLAG
LCCWPER  EQU   LCCWLSI
LCCWIDAT EQU   LCCWFLAG
LCCWNTVC EQU   LCCWFLAG
LCCWCKPT EQU   LCCWFLAG
LCCWCC   EQU   LCCWFLAG
LCCWCD   EQU   LCCWFLAG
LCCWTYPE EQU   LCCWCTL
LCCWMODE EQU   LCCWCTL
LCCWSOP  EQU   LCCWRWOP
@NM00047 EQU   LCCWRWOP
LCCWSD   EQU   LCCWOP
LCCWSI   EQU   LCCWOP
FSBRSV01 EQU   FSBFSB+30
FSBTHCNT EQU   FSBFSB+28
FSBRLRSV EQU   FSBRLSTS
FSBCFTX  EQU   FSBRLSTS
FSBICNCB EQU   FSBMSGID
FSBSSOC  EQU   FSBSS2
FSBSSCC  EQU   FSBSS2
FSBSSDC  EQU   FSBSS2
FSBSSEC  EQU   FSBSS2
FSBSSIR  EQU   FSBSS2
FSBSSCR  EQU   FSBSS2
@NM00045 EQU   FSBSS2
@NM00044 EQU   FSBSS1
FSBSSDE  EQU   FSBSS1
FSBSSUS  EQU   FSBSS1
@NM00043 EQU   FSBSS1
FSBLMRI  EQU   FSBFBMI
FSBETI   EQU   FSBERC
FSBEMI   EQU   FSBERC
FSBECI   EQU   FSBERC
FSBELI   EQU   FSBERC
FSBXLCI  EQU   FSBXCODE
FSBXFINS EQU   FSBXCODE
FSBXNORM EQU   FSBXFSTS
FSBSCODE EQU   FSBSYSRS
FSBSPHSE EQU   FSBSYSRS
FSBSERR  EQU   FSBSYSRS
FSBCMD   EQU   FSBSEQ
FSBDTRCE EQU   FSBFLAGS
FSBASBTU EQU   FSBFLAGS
FSBINPET EQU   FSBFLAGS
FSBNONCB EQU   FSBFLAGS
FSBLBIND EQU   FSBFLAGS
FSBFFIND EQU   FSBFLAGS
FSBACIND EQU   FSBFLAGS
FSBRFIND EQU   FSBFLAGS
FSBDAF   EQU   FSBCID+2
FSBSAF   EQU   FSBCID
FSBGATE  EQU   FSBFSBA
FSBRSV02 EQU   FSBSFLGS
FSBPGBUF EQU   FSBSFLGS
FSBMNSDA EQU   FSBMNRCD
FSBMNOA  EQU   FSBMNRCD
FSBMNDIF EQU   FSBMNRCD
FSBMNEOP EQU   FSBMNRCD
FSBMNDNU EQU   FSBMNRCD
FSBMNATN EQU   FSBMNRCD
FSBMNRVI EQU   FSBMNRCD
FSBLNGTH EQU   FSBFSB+1
FSBTYPE  EQU   FSBFSB
FDBDATCT EQU   ISTFDB+8
FDBDATAA EQU   ISTFDB+4
CRRRVPT5 EQU   CRRSAREA+316
CRRRVPT4 EQU   CRRSAREA+312
CRRRVPT3 EQU   CRRSAREA+308
CRRRVPT2 EQU   CRRSAREA+304
CRRRVPT1 EQU   CRRSAREA+300
CRRRVCR2 EQU   CRRSAREA+292
CRRRVCR1 EQU   CRRSAREA+291
CRRXFNCD EQU   CRRSAREA+290
CRRLDOCT EQU   CRRSAREA+288
@NM00042 EQU   CRRBFLGS
CRRBFLG1 EQU   CRRBFLGS
CRRRTN12 EQU   CRRSAREA+268
CRRRTN11 EQU   CRRSAREA+264
CRRRTN10 EQU   CRRSAREA+260
CRRRES1  EQU   CRRSAREA+222
CRRLCNT  EQU   CRRSAREA+220
CRRVALCK EQU   CRRSAREA+212
CRRBIND  EQU   CRRTRBUF+3
CRRTRRES EQU   CRRTRBUF
CRRUECB  EQU   CRRSAREA+196
CRRCMDAD EQU   CRRSAREA+188
CRRDSB2  EQU   CRRDSB+1
CRRDSB1  EQU   CRRDSB
CRRDTACT EQU   CRRSAREA+174
CRRRSV99 EQU   CRRSAREA+173
CRRRDSOH EQU   CRRFDB3
CRRRLG   EQU   CRRFDB3
CRRLGFRC EQU   CRRFDB3
CRRUNUSD EQU   CRRFDB3
CRRUINPT EQU   CRRFDB3
CRRCUERR EQU   CRRFDB2
CRRDLGFL EQU   CRRFDB2
CRRIOERR EQU   CRRFDB2
CRRDVUNS EQU   CRRFDB2
CRRATND  EQU   CRRFDB2
CRRRVID  EQU   CRRFDB2
CRRNSNA  EQU   CRRRTYPE
CRRDFSYN EQU   CRRRTYPE
CRRRESP  EQU   CRRRTYPE
CRRDFASY EQU   CRRRTYPE
CRRDBLCK EQU   CRRRFLG1
CRRRPSBD EQU   CRRRFLG1
CRRRPLOQ EQU   CRRRFLG1
CRRRPLS  EQU   CRRRFLG1
CRRSW6   EQU   CRRFLGS
CRRSW5   EQU   CRRFLGS
CRRSW4   EQU   CRRFLGS
CRRRSV04 EQU   CRRFLGS4
CRRFMCLK EQU   CRRFLGS4
CRRDLCCW EQU   CRRFLGS3
CRRRESET EQU   CRRFLGS3
CRRRSV08 EQU   CRRFLGS3
CRRDEBQ  EQU   CRRFLGS3
CRRSTSPR EQU   CRRFLGS3
CRRDREQ  EQU   CRRFLGS3
CRRDFDBK EQU   CRRFLGS3
CRRDFSB  EQU   CRRFLGS2
CRRDPROC EQU   CRRFLGS2
CRREXTS  EQU   CRRFLGS2
CRRPOST  EQU   CRRFLGS2
CRRENDLW EQU   CRRFLGS2
CRRPRGIP EQU   CRRFLGS2
CRRSOLRQ EQU   CRRFLGS1
CRRREQP  EQU   CRRFLGS1
CRRCPROC EQU   CRRFLGS1
CRRFLDOS EQU   CRRFLGS1
CRRRATS4 EQU   CRRATS+7
@NM00041 EQU   CRRSATS
CRRASC51 EQU   CRRSATS
CRRASC40 EQU   CRRSATS
CRRASC30 EQU   CRRSATS
CRRASC21 EQU   CRRSATS
CRRASC10 EQU   CRRSATS
CRRASC01 EQU   CRRSATS
@NM00040 EQU   CRRRATS2
CRRPLIC  EQU   CRRRATS2
CRRRC81  EQU   CRRRATS2
CRRRC80  EQU   CRRRATS2
CRRRC65  EQU   CRRRATS2
CRRRC63  EQU   CRRRATS2
CRRRC55  EQU   CRRRATS2
CRRRC54  EQU   CRRRATS2
CRRRC53  EQU   CRRRATS1
CRRRC52  EQU   CRRRATS1
CRRRC51  EQU   CRRRATS1
CRRRC30  EQU   CRRRATS1
CRRRC26  EQU   CRRRATS1
CRRRC23  EQU   CRRRATS1
CRRRC22  EQU   CRRRATS1
CRRRC21  EQU   CRRRATS1
@NM00039 EQU   CRRATS4
CRRC3X   EQU   CRRATS4
CRRC85   EQU   CRRATS4
CRRC83   EQU   CRRATS4
CRRC82   EQU   CRRATS4
CRRC61   EQU   CRRATS4
CRRC60   EQU   CRRATS4
CRRC81   EQU   CRRATS3
CRRC80   EQU   CRRATS3
CRRC75   EQU   CRRATS3
CRRC51   EQU   CRRATS3
CRRC50   EQU   CRRATS3
CRRC42   EQU   CRRATS3
CRRC41   EQU   CRRATS3
CRRC40   EQU   CRRATS3
CRRC32   EQU   CRRATS2
CRRC31   EQU   CRRATS2
CRRC30   EQU   CRRATS2
CRRC25   EQU   CRRATS2
CRRC24   EQU   CRRATS2
CRRC23   EQU   CRRATS2
CRRC22   EQU   CRRATS2
CRRC21   EQU   CRRATS2
CRRC20   EQU   CRRATS1
CRRC13   EQU   CRRATS1
CRRC12   EQU   CRRATS1
CRRC10   EQU   CRRATS1
CRRC02   EQU   CRRATS1
CRRC01   EQU   CRRATS1
CRRC00   EQU   CRRATS1
CRRRMAS4 EQU   CRRMAS+7
@NM00038 EQU   CRRSMAS
CRRMSC51 EQU   CRRSMAS
CRRMSC40 EQU   CRRSMAS
CRRMSC30 EQU   CRRSMAS
CRRMSC21 EQU   CRRSMAS
CRRMSC10 EQU   CRRSMAS
CRRMSC01 EQU   CRRSMAS
@NM00037 EQU   CRRRMAS2
CRRRM81  EQU   CRRRMAS2
CRRRM80  EQU   CRRRMAS2
CRRRM65  EQU   CRRRMAS2
CRRRM63  EQU   CRRRMAS2
CRRRM55  EQU   CRRRMAS2
CRRRM54  EQU   CRRRMAS2
CRRRM53  EQU   CRRRMAS1
CRRRM52  EQU   CRRRMAS1
CRRRM51  EQU   CRRRMAS1
CRRRM30  EQU   CRRRMAS1
CRRRM26  EQU   CRRRMAS1
CRRRM23  EQU   CRRRMAS1
CRRRM22  EQU   CRRRMAS1
CRRRM21  EQU   CRRRMAS1
@NM00036 EQU   CRRMAS4
CRRM3X   EQU   CRRMAS4
CRRM85   EQU   CRRMAS4
CRRM83   EQU   CRRMAS4
CRRM82   EQU   CRRMAS4
CRRM61   EQU   CRRMAS4
CRRM60   EQU   CRRMAS4
CRRM81   EQU   CRRMAS3
CRRM80   EQU   CRRMAS3
CRRM75   EQU   CRRMAS3
CRRM51   EQU   CRRMAS3
CRRM50   EQU   CRRMAS3
CRRM42   EQU   CRRMAS3
CRRM41   EQU   CRRMAS3
CRRM40   EQU   CRRMAS3
CRRM32   EQU   CRRMAS2
CRRM31   EQU   CRRMAS2
CRRM30   EQU   CRRMAS2
CRRM25   EQU   CRRMAS2
CRRM24   EQU   CRRMAS2
CRRM23   EQU   CRRMAS2
CRRM22   EQU   CRRMAS2
CRRM21   EQU   CRRMAS2
CRRM20   EQU   CRRMAS1
CRRM13   EQU   CRRMAS1
CRRM12   EQU   CRRMAS1
CRRM10   EQU   CRRMAS1
CRRM02   EQU   CRRMAS1
CRRM01   EQU   CRRMAS1
CRRM00   EQU   CRRMAS1
CRRRSV22 EQU   ISTDCCRR+4
CRRCRR   EQU   ISTDCCRR
RPHNEXPO EQU   ISTRPH+104
RPHSAV16 EQU   RPHWORK+60
RPHSAV15 EQU   RPHWORK+56
RPHSAV14 EQU   RPHWORK+52
RPHSAV13 EQU   RPHWORK+48
RPHSAV12 EQU   RPHWORK+44
RPHSAV11 EQU   RPHWORK+40
RPHSAV10 EQU   RPHWORK+36
RPHSAVE9 EQU   RPHWORK+32
RPHSAVE8 EQU   RPHWORK+28
RPHSAVE7 EQU   RPHWORK+24
RPHSAVE6 EQU   RPHWORK+20
RPHSAVE5 EQU   RPHWORK+16
RPHSAVE4 EQU   RPHWORK+12
RPHSAVE3 EQU   RPHWORK+8
RPHSAVE2 EQU   RPHWORK+4
RPHSHALF EQU   RPHSAVE1+2
RPHSBIT8 EQU   RPHSBITS
RPHSBIT7 EQU   RPHSBITS
RPHSBIT6 EQU   RPHSBITS
RPHSBIT5 EQU   RPHSBITS
RPHSBIT4 EQU   RPHSBITS
RPHSBIT3 EQU   RPHSBITS
RPHSBIT2 EQU   RPHSBITS
RPHSBIT1 EQU   RPHSBITS
RPHSBYTE EQU   RPHSAVE1
RPHPABQP EQU   RPHPABQA+1
RPHPABFG EQU   RPHPABQA
RPHSRP34 EQU   RPHSRPRM+2
RPHSRP12 EQU   RPHSRPRM
RPHWEGT  EQU   RPHCSPA
RPHMAJCB EQU   ISTRPH+21
RPHPABOF EQU   ISTRPH+20
RPHRESUM EQU   RPHRESMA+1
RPHRSV01 EQU   RPHWPFLG
RPHPURGE EQU   RPHWPFLG
RPHPT    EQU   RPHWPFLG
RPHWT    EQU   RPHWPFLG
RPHRSKEY EQU   RPHWPFLG
RPHDVTA  EQU   ISTRPH+12
RPHTIK   EQU   RPHTSKID+3
@NM00035 EQU   RPHTSKID
RPHRPHAP EQU   RPHRPHA+1
@NM00034 EQU   RPHRPHA
RPHGATE  EQU   RPHRPHA
@NM00033 EQU   RPHFLGB
RPHRLCRA EQU   RPHFLGB
RPHNRSAV EQU   RPHFLGB
RPHPGCMP EQU   RPHFLGB
RPHFBAPS EQU   RPHFLGB
RPHBSSP  EQU   RPHFLGB
RPHLOCK  EQU   RPHFLGB
RPHFNFLG EQU   RPHFSTLC
RPHMLTCP EQU   RPHFLAGS
RPHSMCLR EQU   RPHFLAGS
RPHSMTYP EQU   RPHFLAGS
RPHSMQ   EQU   RPHFLAGS
RPHAUTEX EQU   RPHAPTYP
RPHSPGIN EQU   RPHFLAGS
RPHOGIND EQU   RPHFLAGS
RPHLNGTH EQU   RPHCNTL+1
RPHTYPE  EQU   RPHCNTL
RPLERMSA EQU   RPLCOMN+72
RPLEMLEN EQU   RPLCOMN+70
RPLACTIV EQU   RPLCOMN+69
RPLBRANC EQU   RPLEXTD1
RPLNIB   EQU   RPLEXTD1
@NM00032 EQU   RPLEXTD1
RPLEXIT  EQU   RPLEXTD1
RPLNEXIT EQU   RPLEXTD1
RPLEXSCH EQU   RPLEXTD1
RPLDDDD  EQU   RPLRBAR+4
@NM00031 EQU   RPLRBAR+3
@NM00030 EQU   RPLAIXID
RPLAXPKP EQU   RPLAIXID
RPLAIXPC EQU   RPLRBAR
RPLRSV88 EQU   RPLOPT8
RPLUNCON EQU   RPLOPT8
RPLACTV  EQU   RPLOPT8
RPLSESS  EQU   RPLOPT8
RPLPEND  EQU   RPLOPT8
RPLODPRM EQU   RPLOPT8
RPLODACP EQU   RPLOPT8
RPLODACQ EQU   RPLOPT8
RPLRSV78 EQU   RPLOPT7
RPLTCRNO EQU   RPLOPT7
RPLRLSOP EQU   RPLOPT7
RPLTPOST EQU   RPLOPT7
RPLQOPT  EQU   RPLOPT7
RPLCNIMM EQU   RPLCNOPT
RPLCNANY EQU   RPLCNOPT
RPLCNALL EQU   RPLCNOPT
RPLRSV68 EQU   RPLOPT6
RPLRSV67 EQU   RPLOPT6
RPLLOCK  EQU   RPLOPT6
RPLNCOND EQU   RPLOPT6
RPLCOND  EQU   RPLOPT6
RPLEOT   EQU   RPLUNTYP
RPLEOM   EQU   RPLUNTYP
RPLEOB   EQU   RPLUNTYP
RPLWROPT EQU   RPLOPT5
RPLNODE  EQU   RPLOPT5
RPLERACE EQU   RPLWRTYP
RPLEAU   EQU   RPLWRTYP
RPLNERAS EQU   RPLWRTYP
RPLPSOPT EQU   RPLOPT5
@NM00029 EQU   RPLOPT5
RPLBUFL  EQU   RPLCOMN+52
RPLCHAIN EQU   RPLNXTRP
RPLBOP   EQU   RPLOPT4
@NM00028 EQU   RPLOPT4
RPLMKFRM EQU   RPLOPT4
RPLENDTR EQU   RPLOPT4
RPLALIGN EQU   RPLOPT3
RPLFMT   EQU   RPLOPT3
RPLFLD   EQU   RPLOPT3
RPLVFY   EQU   RPLOPT3
RPLBLK   EQU   RPLOPT3
RPLSFORM EQU   RPLOPT3
RPLEODS  EQU   RPLOPT3
RPLNSP   EQU   RPLOPT2
RPLUPD   EQU   RPLOPT2
@NM00027 EQU   RPLOPT2
RPLLRD   EQU   RPLOPT2
RPLBWD   EQU   RPLOPT2
RPLCNV   EQU   RPLOPT2
RPLADD   EQU   RPLADR
RPLKEY   EQU   RPLOPT2
RPLECBIN EQU   RPLECBSW
RPLGEN   EQU   RPLOPT1
RPLKGE   EQU   RPLOPT1
RPLASY   EQU   RPLOPT1
RPLSKP   EQU   RPLOPT1
RPLSEQ   EQU   RPLOPT1
RPLDIR   EQU   RPLOPT1
RPLLOC   EQU   RPLOPT1
RPLDAF   EQU   RPLARG+2
RPLSAF   EQU   RPLARG
RPLAREA  EQU   RPLCOMN+32
RPLTCBPT EQU   RPLCOMN+28
RPLDACB  EQU   RPLCOMN+24
RPLCCHAR EQU   RPLCOMN+20
RPLSTRID EQU   RPLCOMN+18
RPLKEYL  EQU   RPLKEYLE
RPLRDSOH EQU   RPLFDB3
RPLRLG   EQU   RPLFDB3
RPLLGFRC EQU   RPLFDB3
RPLREOT  EQU   RPLFDB3
RPLREOM  EQU   RPLFDB3
RPLREOB  EQU   RPLFDB3
RPLSV32  EQU   RPLFDB3
RPLUINPT EQU   RPLFDB3
RPLSTSAV EQU   RPLFDB2
RPLCUERR EQU   RPLFDB2
RPLDLGFL EQU   RPLFDB2
RPLIOERR EQU   RPLFDB2
RPLDVUNS EQU   RPLFDB2
RPLATND  EQU   RPLFDB2
RPLRVID  EQU   RPLFDB2
RPLERLK  EQU   RPLFDB2
RPLERREG EQU   RPLRTNCD
RPLSTAT  EQU   RPLFDBWD
RPLPOST  EQU   RPLECB
RPLWAIT  EQU   RPLECB
RPLPLHPT EQU   RPLCOMN+4
RPLLEN2  EQU   RPLLEN
RPLREQ   EQU   RPLIDWD+2
RPLSTYP  EQU   RPLIDWD+1
RPLID    EQU   RPLIDWD
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00002 EQU   CVTFIX+248
@NM00001 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTSHSB  EQU   CVTSHS
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
@NM00026 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00025 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00024 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00023 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSARV011 EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSARV063 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00022 EQU   FLCFSA
@NM00021 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00020 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00019 EQU   FLCIOA
@NM00018 EQU   FLCMCLA+15
@NM00017 EQU   FLCMCLA+14
@NM00016 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00015 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00014 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00013 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00012 EQU   FLCPER
@NM00011 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00010 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00009 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00008 EQU   FLCPIILC
@NM00007 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00006 EQU   FLCSVILC
@NM00005 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00004 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00003 EQU   FLCICCW2+4
FLCCVT   EQU   FLCICCW2
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00610 EQU   @RC00609
@RC00832 EQU   @RC00831
@RC00844 EQU   @RC00842
@RC00875 EQU   @RC00874
@RC00894 EQU   @RC00893
@RC00968 EQU   @RC00967
@PB00014 EQU   @PB00015
@PB00013 EQU   @PB00014
@PB00012 EQU   @PB00013
@PB00011 EQU   @PB00012
@PB00010 EQU   @PB00011
@PB00009 EQU   @PB00010
@PB00008 EQU   @PB00009
@PB00007 EQU   @PB00008
@PB00006 EQU   @PB00007
@PB00005 EQU   @PB00006
@PB00004 EQU   @PB00005
@PB00003 EQU   @PB00004
@PB00002 EQU   @PB00003
@ENDDATA EQU   *
         END   ISTDCC11,(C'PLS1223',0603,75346)
