         TITLE 'ISTDCC50-- SOLICIT,READ,WRITE FEEDBACK                 *
                        '
ISTDCC50 CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'ISTDCC50  78.173'                                 0001
         DROP  @15
@PROLOG  BALR  @12,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@12                                         0001
*                                                                  0486
*/********************************************************************/
*/*                                                                  */
*/*                                                                  */
*/*  ROUTINE NAME : ISTDCC50 MAINLINE ROUTINE                        */
*/*                                                                  */
*/*  FUNCTION : THE MAIN ROUTINE CALLS THE APPROPIATE PROCESSING     */
*/*   SUBROUTINES:                                                   */
*/*    READMAC - READ AND SOLICIT FEEDBACK                           */
*/*    WRTMAC - WRITE FEEDBACK                                       */
*/*    FLUSH - FREES INCOMING DATA                                   */
*/*                                                                  */
*/*  IF FEEDBACK IS FOR A SOLICIT REQUEST, DCLRPLA                   */
*/*  WILL BE ZERO ON ENTRY.  CONTROL IS THEN TRANSFERRED             */
*/*  TO READMAC WITH CONTROL SWITCH, CRRSW0, SET.                    */
*/*                                                                  */
*/* INPUT :  RPHPTR REG(1) - ADDRESS OF RPH                          */
*/*                                                                  */
*/* OUTPUT :  RPHPTR REG(1) - ADDRESS OF RPH                         */
*/*                                                                  */
*/* SUBROUTINES CALLED : READMAC - READ AND SOLICIT FEEDBACK         */
*/*                      WRTMAC  - WRITE FEEDBACK PROCESSING         */
*/*                      FLUSH   - FREE UP DATA BUFFERS              */
*/* MACROS USED : TPESC - NORMAL EXIT                                */
*/*                                                                  */
*/********************************************************************/
*                                                                  0486
*   CRRPTR=ADDR(CRRSPACE);          /* INITIALIZE TO MAIN CRR        */
         L     CRRPTR,RPHCRR(,RPHPTR)                              0486
         LA    CRRPTR,CRRSPACE+312(,CRRPTR)                        0486
*   CRRMAS=CRRMAS&&CRRMAS;                                         0487
         XC    CRRMAS(8,CRRPTR),CRRMAS(CRRPTR)                     0487
*   CRRFLGS=CRRFLGS&&CRRFLGS;       /* CLEAR ALL CONTROL SWITCHES    */
         XC    CRRFLGS(1,CRRPTR),CRRFLGS(CRRPTR)                   0488
*   CRRM50=ON;                      /* MODULE AUDIT                  */
         OI    CRRM50(CRRPTR),B'00010000'                          0489
*   CRRC50=ON;                      /* AUDIT TRAIL                   */
         OI    CRRC50(CRRPTR),B'00010000'                          0490
*   CRRSW4=ON;                      /* FLUSH SWITCH                  */
         OI    CRRSW4(CRRPTR),B'00001000'                          0491
*   FSBPTR=CRRFSB;                  /* REFERENCE FSB                 */
         L     FSBPTR,CRRFSB(,CRRPTR)                              0492
*   IF CRRFMCLK=OFF THEN            /* FMCB LOCKED?          @ZA33377*/
         TM    CRRFMCLK(CRRPTR),B'10000000'                        0493
         BNZ   @RF00493                                            0493
*     DO;                           /* LOCK FMCB             @ZA33377*/
*/*** START -TPLOCK (CTLLOCK)TYPE(XCLSIVE)- **                       */
*                                                                  0495
*       DO;                                                        0495
*         RFY                                                      0496
*          (GPR00P,                                                0496
*           GPR01P,                                                0496
*           GPR02P,                                                0496
*           GPR03P,                                                0496
*           GPR04P,                                                0496
*           GPR15P) RSTD;                                          0496
*         GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(RPHWORK);
         STM GPR00P,GPR14P,RPHWORK(GPR01P)
*         GPR02P=ADDR(FMCDCLOK);    /* SET PARAM - LOCKWORD PTR      */
         L     GPR02P,CRRFMCB(,CRRPTR)                             0498
         LA    GPR02P,FMCDCLOK(,GPR02P)                            0498
*         GPR04P=GPR01P->RPHCRR;    /* SET PARAM - ISTCRA PTR        */
         L     GPR04P,RPHCRR(,GPR01P)                              0499
*         GPR00P=CRALMS08;          /* SET PARAM - LOCK LEVEL FLAG   */
         LA    GPR00P,128                                          0500
*         GPR03P=ADDR(GPR04P->CRAL8PTR);/* SET PARAM - LOCK LEVEL PTR*/
         LA    GPR03P,CRAL8PTR(,GPR04P)                            0501
*         GPR15P=ATCLCPTR->ATCAP36; /* ADDRESS OF LOCK ROUTINE       */
         L     @05,ATCLCPTR                                        0502
         L     GPR15P,ATCAP36(,@05)                                0502
*         DCL                                                      0503
*           FMZL0007 BASED(GPR15P) LABEL VALUERANGE(*);            0503
*         CALL FMZL0007;                                           0504
         BALR  @14,@15                                             0504
*         GENERATE REFS(GPR00P,GPR01P,GPR14P,RPHWORK) SETS(GPR00P, 0505
*             GPR01P,GPR02P,GPR03P,GPR04P,GPR05P,GPR06P,GPR07P,GPR08P,
*             GPR09P,GPR10P,GPR11P,GPR12P,GPR13P,GPR14P,GPR15P);   0505
         LM GPR00P,GPR15P,RPHWORK(GPR01P)
*         RFY                                                      0506
*          (GPR00P,                                                0506
*           GPR01P,                                                0506
*           GPR02P,                                                0506
*           GPR03P,                                                0506
*           GPR04P,                                                0506
*           GPR15P) UNRSTD;                                        0506
*       END;                                                       0507
*                                                                  0507
*/*** END -TPLOCK (CTLLOCK)TYPE(XCLSIVE)- **                         */
*                                                                  0508
*                                   /* GET LOCK              @ZA33377*/
*       CRRFMCLK=ON;                /* FMCB LOCK HELD        @ZA33377*/
         OI    CRRFMCLK(CRRPTR),B'10000000'                        0508
*     END;                          /* LOCK FMCB             @ZA33377*/
*   IF FMCFLGA3=ON THEN             /* FLUSH BIT ON IN FMCB          */
@RF00493 L     @15,CRRFMCB(,CRRPTR)                                0510
         TM    FMCFLGA3(@15),B'00010000'                           0510
         BNO   @RF00510                                            0510
*     IF FSBMJRCD='00'X THEN        /* RETURN CODE NORMAL?   @ZA33102*/
*                                                                  0511
         CLI   FSBMJRCD(FSBPTR),X'00'                              0511
         BNE   @RF00511                                            0511
*       /*************************************************************/
*       /*                                                           */
*       /* THROW AWAY FSB                                            */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0512
*       CALL FLUSH;                                                0512
         BAL   @14,FLUSH                                           0512
*     ELSE                          /*                       @ZA33102*/
*       DO;                         /* TURN OFF FLUSH BIT    @ZA33102*/
         B     @RC00511                                            0513
@RF00511 DS    0H                                                  0514
*         RFY                                                      0514
*          (REG2,                                                  0514
*           REG3) RSTD;             /*                       @ZA33102*/
*CS10:                                                             0515
*         REG2=FMCCMPS2;            /* GET FLAG VALUE        @ZA33102*/
CS10     L     @15,CRRFMCB(,CRRPTR)                                0515
         L     REG2,FMCCMPS2(,@15)                                 0515
*         REG3=REG2&FLGA3OFF;       /* RESET FLUSH FLAG      @ZA33102*/
         LR    REG3,REG2                                           0516
         N     REG3,@CF01563                                       0516
*         CS(REG2,REG3,FMCCMPS2);   /* SET NEW VAL IN FMCB   @ZA33102*/
         CS    REG2,@03,FMCCMPS2(@15)                              0517
*         BC(7,CS10);               /* TRY AGAIN IF FAILURE  @ZA33102*/
         BC    7,CS10                                              0518
*         RFY                                                      0519
*          (REG2,                                                  0519
*           REG3) UNRSTD;           /*                       @ZA33102*/
*       END;                        /* TURN OFF FLUSH BIT    @ZA33102*/
*   ELSE                                                           0521
*     ;                                                            0521
@RF00510 DS    0H                                                  0522
*   IF CRRSW4=ON THEN               /* IF NOTHING FLUSHED            */
@RC00510 TM    CRRSW4(CRRPTR),B'00001000'                          0522
         BNO   @RF00522                                            0522
*     DO;                                                          0523
*       IF DCLRPLA=ZEROWORD THEN    /* RPL PTR IN DCLCP      @DM9272K*/
         L     @15,CRRLCPB(,CRRPTR)                                0524
         L     @15,DCLRPLA(,@15)                                   0524
         LTR   @15,@15                                             0524
         BNZ   @RF00524                                            0524
*         CRRSW0=ON;                /* REQUEST IS SOLICIT            */
         OI    CRRSW0(CRRPTR),B'10000000'                          0525
*       ELSE                                                       0526
*         ;                                                        0526
@RF00524 DS    0H                                                  0527
*       IF DCLRQTP=DCLREAD|CRRSW0=ON THEN                          0527
*                                                                  0527
         L     @15,CRRLCPB(,CRRPTR)                                0527
         CLI   DCLRQTP(@15),X'1D'                                  0527
         BE    @RT00527                                            0527
         TM    CRRSW0(CRRPTR),B'10000000'                          0527
         BNO   @RF00527                                            0527
@RT00527 DS    0H                                                  0528
*         /***********************************************************/
*         /*                                                         */
*         /* READ/SOL REQUEST                                        */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0528
*         CALL READMAC;                                            0528
         BAL   @14,READMAC                                         0528
*       ELSE                                                       0529
*                                                                  0529
*         /***********************************************************/
*         /*                                                         */
*         /* WRITE REQUEST                                           */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0529
*         CALL WRTMAC;                                             0529
         B     @RC00527                                            0529
@RF00527 BAL   @14,WRTMAC                                          0529
*     END;                                                         0530
*   ELSE                                                           0531
*     ;                             /* FSB WAS FLUSHED               */
@RF00522 DS    0H                                                  0532
*/*TPESC                                                             */
*                                                                  0532
*   DO;                                                            0532
*                                                                  0532
@RC00522 DS    0H                                                  0533
*/* ATBUILD (ISTDYPAB,ISTAVT,ISTATCVT)                               */
*/* END OF ATBUILD                                                   */
*                                                                  0533
*     RFY                                                          0533
*       GPR15P RSTD;                                               0533
*     DO;                           /* LISATCVT                    0534
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*       GPR15P=ATCLCPTR;            /* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     0535
*     END;                          /* LISATCVT                      */
*     GPR15P=GPR15P->ATCESC01;                                     0537
         L     GPR15P,ATCESC01(,GPR15P)                            0537
*     DCL                                                          0538
*       FMZL0012 BASED(GPR15P) LABEL VALUERANGE(*);                0538
*     CALL FMZL0012;                                               0539
         BALR  @14,@15                                             0539
*     RESPECIFY                                                    0540
*       GPR15P UNRSTD;                                             0540
*   END;                            /* **** END OF TPESC             */
*                                                                  0542
*/********************************************************************/
*/*                                                                  */
*/* ROUTINE NAME : READMAC                                           */
*/*                                                                  */
*/* FUNCTION :                                                       */
*/*  READMAC RECEIVES CONTROL ON READ OR SOLICIT FEEDBACK.           */
*/*  IF CRRSW0 IS SET, READMAC WILL QUEUE THE DATA OR ATTEMPT TO     */
*/*  SCHEDULE AN ASYNCHRONOUS INPUT EXIT.                            */
*/*                                                                  */
*/*  IF ENTRY WAS FOR A READ, THE FEEDBACK STATUS IS MOVED FROM      */
*/*  THE FSB TO THE CRR.  THE PARM LIST FOR THE MOVE ROUTINE-        */
*/*  ISTDCC60 - IS BUILT IN THE CRR USING THE INFORMATION IN THE     */
*/*  RPL OR IN THE DCLCP.  THE DCLCP IS USED IF THE DATA TO BE       */
*/*  MOVED WAS SAVED FROM A PREVIOUS REQUEST.                        */
*/*                                                                  */
*/* INPUT :  FSBPTR REG(4) - ADDRESS OF FSB                          */
*/*                                                                  */
*/* OUTPUT : SAME                                                    */
*/*                                                                  */
*/* SUBROUTINES CALLED : SETCRR   - COPY STATUS TO CRR               */
*/*                      MOVEDATA - MOVE DATA TO USER AREA           */
*/*                      XFRFSB   - QUEUE FSB TO DATA QUEUE          */
*/*                      SOLMAC1  - CHECK FOR ASYNCH INPUT EXIT      */
*/*                                                                  */
*/* MACROS USED :  NONE                                              */
*/*                                                                  */
*/********************************************************************/
*                                                                  0542
*READMAC:                                                          0542
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0542
         B     @PB00002                                            0542
READMAC  DS    0H                                                  0543
*   CRRRTN1=RTNREG;                 /* SAVE RETURN REGISTER          */
         ST    RTNREG,CRRRTN1(,CRRPTR)                             0543
*   DO WHILE(CRRSW1=OFF);           /*                       @D31KKNL*/
         B     @DE00544                                            0544
@DL00544 DS    0H                                                  0545
*     IF CRRSW0=OFF THEN            /* IF RPL EXISTS         @D31KKNL*/
         TM    CRRSW0(CRRPTR),B'10000000'                          0545
         BNZ   @RF00545                                            0545
*       DO;                         /* PROCESS THE DATA      @D31KKNL*/
*         DCLRPLA=ZEROWORD;         /* CLEAR RPL ADDRESS     @D31KKNL*/
         L     @15,CRRLCPB(,CRRPTR)                                0547
         SLR   @05,@05                                             0547
         ST    @05,DCLRPLA(,@15)                                   0547
*         CALL SETCRR;              /* COPY FEEDBACK STATUS  @D31KKNL*/
         BAL   @14,SETCRR                                          0548
*         CALL MOVEDATA;            /* MOVE DATA TO USER BUFFERS   0549
*                                                            @D31KKNL*/
         BAL   @14,MOVEDATA                                        0549
*         CRRSW1=ON;                /* END THIS LOOP         @D31KKNL*/
         OI    CRRSW1(CRRPTR),B'01000000'                          0550
*       END;                        /* END-RPL EXISTS        @D31KKNL*/
*     ELSE                                                         0552
*       DO;                         /* NO RPL EXISTS         @D31KKNL*/
         B     @RC00545                                            0552
@RF00545 DS    0H                                                  0553
*         IF(FMCFBA=ZEROWORD|FMCFBA=GATEBIT)&/* NO DATA              */
*             FMCFLGA1=OFF THEN     /* AND SPECIFIC MODE             */
         L     @15,CRRFMCB(,CRRPTR)                                0553
         L     @15,FMCFBA(,@15)                                    0553
         LTR   @15,@15                                             0553
         BZ    @GL00002                                            0553
         CL    @15,@CF01547                                        0553
         BNE   @RF00553                                            0553
@GL00002 L     @15,CRRFMCB(,CRRPTR)                                0553
         TM    FMCFLGA1(@15),B'01000000'                           0553
         BNZ   @RF00553                                            0553
*           CALL SOLMAC1;           /* CHECK ASY. INPUT              */
         BAL   @14,SOLMAC1                                         0554
*         ELSE                                                     0555
*           DO;                     /* THERE IS DATA                 */
         B     @RC00553                                            0555
@RF00553 DS    0H                                                  0556
*             CRRSW6=ON;            /* SET DATA EXISTS FLG           */
         OI    CRRSW6(CRRPTR),B'00000010'                          0556
*             CALL XFRFSB;          /* QUEUE PAGEABLE FSB            */
         BAL   @14,XFRFSB                                          0557
*             CRRSW1=ON;            /* SET EXIT SWITCH       @DM9361K*/
         OI    CRRSW1(CRRPTR),B'01000000'                          0558
*           END;                                                   0559
*       END;                        /* END - NO RPL EXISTS           */
@RC00553 DS    0H                                                  0561
*   END;                            /* END DO WHILE                  */
@RC00545 DS    0H                                                  0561
@DE00544 TM    CRRSW1(CRRPTR),B'01000000'                          0561
         BZ    @DL00544                                            0561
*   RTNREG=CRRRTN1;                 /* RESTORE RETURN REG            */
         L     RTNREG,CRRRTN1(,CRRPTR)                             0562
*   END READMAC;                                                   0563
@EL00002 DS    0H                                                  0563
@EF00002 DS    0H                                                  0563
@ER00002 BR    @14                                                 0563
*                                                                  0564
*/********************************************************************/
*/*                                                                  */
*/* ROUTINE NAME : WRTMAC                                            */
*/*                                                                  */
*/* FUNCTION :                                                       */
*/*  WRTMAC RECEIVES CONTROL FROM THE MAINLINE ROUTINE               */
*/*  TO PROCESS A WRITE FEEDBACK.  FEEDBACK STATUS IS                */
*/*  MOVED FROM THE FSB TO THE CRR.  IF THE WRITE WAS                */
*/*  CONVERSATIONAL AND INPUT WAS RECEIVED, THE MOVEDATA             */
*/*  SUBROUTINE IS CALLED TO PROCESS THE DATA.  IF THE               */
*/*  OPERATION WAS A NORMAL WRITE AND DATA WAS RECEIVED              */
*/*  THE FSB IS QUEUED IS THE FMCB DATA QUEUE AND THE                */
*/*  UNSOLICITED INPUT FLAG IS SET IN THE CRR.                       */
*/*                                                                  */
*/* INPUT : FSBPTR REG(4) - ADDRESS FSB                              */
*/*                                                                  */
*/* OUTPUT : SAME                                                    */
*/*                                                                  */
*/* SUBROUTINES CALLED : SETCRR   - COPY STATUS TO CRR               */
*/*                      MOVEDATA - MOVE DATA TO USER AREA           */
*/*                      FREEBUF  - FREE FSB CHAIN                   */
*/*                      XFRFSB   - QUEUE FSB TO DATA QUEUE          */
*/* MACROS USED : NONE                                               */
*/*                                                                  */
*/********************************************************************/
*                                                                  0564
*WRTMAC:                                                           0564
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0564
WRTMAC   DS    0H                                                  0565
*   CRRRTN1=RTNREG;                 /* SAVE RETURN REG               */
         ST    RTNREG,CRRRTN1(,CRRPTR)                             0565
*   CALL SETCRR;                    /* MOVE STATUS TO CRR    @D31KKNL*/
         BAL   @14,SETCRR                                          0566
*   RFY                                                            0567
*     FDBPTR RSTD;                                                 0567
*   FDBPTR=ADDR(FSBFDB);            /* COVER THE FDB DSECT           */
         LA    FDBPTR,FSBFDB(,FSBPTR)                              0568
*   IF RPLWROPT=ON THEN             /* WRITE CONVERSATIONAL          */
         L     @15,CRRARPL(,CRRPTR)                                0569
         TM    RPLWROPT(@15),B'00000001'                           0569
         BNO   @RF00569                                            0569
*     IF FDBDATCT>ZEROWORD THEN     /* DATA RECEIVED                 */
*                                                                  0570
         SLR   @15,@15                                             0570
         CH    @15,FDBDATCT(,FDBPTR)                               0570
         BNL   @RF00570                                            0570
*       /*************************************************************/
*       /*                                                           */
*       /* WRITE CONVERSATIONAL WITH DATA RECEIVED                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0571
*       DO;                         /* PROCESS IT            @DM9258K*/
*         DCLRPLA=ZEROWORD;         /* CLEAR RPL ADDRESS     @DM9258K*/
         L     @09,CRRLCPB(,CRRPTR)                                0572
         ST    @15,DCLRPLA(,@09)                                   0572
*         CALL MOVEDATA;            /* MOVE DATA TO USER BUFFERS   0573
*                                                            @D31KKNL*/
         BAL   @14,MOVEDATA                                        0573
*       END;                        /* END-DATA REC'D        @DM9258K*/
*     ELSE                                                         0575
*       DO;                                                        0575
*                                                                  0575
         B     @RC00570                                            0575
@RF00570 DS    0H                                                  0576
*         /***********************************************************/
*         /*                                                         */
*         /* FINISHED PROCESSING-WRITE CONVERSATIONAL BUT NO DATA    */
*         /* RECEIVED                                                */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0576
*         CRRPOST=ON;               /* SET DO POST SWITCH            */
         OI    CRRPOST(CRRPTR),B'00010000'                         0576
*         CALL EOBANAL;             /*                       @ZA28667*/
         BAL   @14,EOBANAL                                         0577
*         DCLRPLA=ZEROWORD;         /* CLEAR RPL ADDRESS     @ZA28667*/
         L     @15,CRRLCPB(,CRRPTR)                                0578
         SLR   @09,@09                                             0578
         ST    @09,DCLRPLA(,@15)                                   0578
*         IF CRRRTNCD=ZEROWORD THEN /* IF NO ERROR                   */
         CLI   CRRRTNCD(CRRPTR),0                                  0579
         BNE   @RF00579                                            0579
*           CRRRTNCD=CRRNGRCC;      /* SET CONDITIONAL OPERATION     */
         MVI   CRRRTNCD(CRRPTR),X'10'                              0580
*         CALL FREEBUF;                                            0581
@RF00579 BAL   @14,FREEBUF                                         0581
*       END;                                                       0582
*   ELSE                                                           0583
*     DO;                                                          0583
*                                                                  0583
         B     @RC00569                                            0583
@RF00569 DS    0H                                                  0584
*       /*************************************************************/
*       /*                                                           */
*       /* NONCONVERSATIONAL WRITE                                   */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0584
*       CRRPOST=ON;                 /* SET DO POST SWITCH            */
*       CRRENDLW=ON;                /* SET END OF IO LCCW            */
         OI    CRRPOST(CRRPTR),B'00110000'                         0585
*       IF FDBDATCT>ZEROWORD THEN   /* DATA RECEIVED                 */
         SLR   @15,@15                                             0586
         CH    @15,FDBDATCT(,FDBPTR)                               0586
         BNL   @RF00586                                            0586
*         DO;                                                      0587
*                                                                  0587
*           /*********************************************************/
*           /*                                                       */
*           /* DATA RECEIVED-TREAT AS UNSOLICITED INPUT              */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0588
*           IF FSBELI=OFF THEN      /* CHECK FOR END OF LCP          */
         TM    FSBELI(FSBPTR),B'10000000'                          0588
         BNZ   @RF00588                                            0588
*             DO;                                                  0589
*               DCLRPLA=ZEROWORD;                                  0590
         L     @09,CRRLCPB(,CRRPTR)                                0590
         ST    @15,DCLRPLA(,@09)                                   0590
*               CRRENDLW=OFF;       /* RESET END OF LCP FLAG         */
         NI    CRRENDLW(CRRPTR),B'11011111'                        0591
*             END;                                                 0592
*           ELSE                                                   0593
*             ;                     /* LEAVE END OF LCP SW SET       */
@RF00588 DS    0H                                                  0594
*           FSBECI=OFF;                                            0594
         NI    FSBECI(FSBPTR),B'10111111'                          0594
*           CRRUINPT=ON;            /* INDICATE UNSOLICITED INPUT    */
*           CRRRDEOB=OFF;           /* RESET EOB                     */
*           CRRRDEOM=OFF;           /* RESET EOM                     */
*           CRRRDEOT=OFF;           /* RESET EOT                     */
*           CRRRLG=OFF;             /* RESET LEADING GRAPHICS        */
         OI    CRRUINPT(CRRPTR),B'10000000'                        0599
         NI    CRRRDEOB(CRRPTR),B'11000101'                        0599
*           CALL XFRFSB;            /* SAVE FSB ON FMCB DATA Q       */
         BAL   @14,XFRFSB                                          0600
*           FSBELI=ON;                                             0601
         OI    FSBELI(FSBPTR),B'10000000'                          0601
*         END;                                                     0602
*       ELSE                                                       0603
*                                                                  0603
*         /***********************************************************/
*         /*                                                         */
*         /* NORMAL WRITE COMPLETED                                  */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0603
*         CALL FREEBUF;                                            0603
         B     @RC00586                                            0603
@RF00586 BAL   @14,FREEBUF                                         0603
*     END;                                                         0604
@RC00586 DS    0H                                                  0605
*   RFY                                                            0605
*     FDBPTR UNRSTD;                                               0605
@RC00569 DS    0H                                                  0606
*   RTNREG=CRRRTN1;                 /* RESTORE RETURN REG            */
         L     RTNREG,CRRRTN1(,CRRPTR)                             0606
*   END WRTMAC;                                                    0607
@EL00003 DS    0H                                                  0607
@EF00003 DS    0H                                                  0607
@ER00003 BR    @14                                                 0607
*                                                                  0608
*/********************************************************************/
*/*                                                                  */
*/* ROUTINE NAME : SETCRR                                            */
*/*                                                                  */
*/* FUNCTION :                                                       */
*/*  SETCRR COPIES THE FEEDBACK STATUS FROM THE FSB TO THE CRR AS    */
*/*   THE FSB  WILL BE EVENTUALLY BE FREED UP                        */
*/*                                                                  */
*/* INPUT : FSBPTR REG(4) - ADDRESS OF FSB                           */
*/*                                                                  */
*/* OUTPUT : SAME                                                    */
*/*                                                                  */
*/* SUBROUTINES CALLED :  NONE                                       */
*/*                                                                  */
*/* MACROS USED : NONE                                               */
*/*                                                                  */
*/********************************************************************/
*                                                                  0608
*SETCRR:                                                           0608
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);/*                       @D31KKNL*/
SETCRR   DS    0H                                                  0609
*   CRRRTNCD=FSBSRCAT;              /* COPY SYS RESPONSE CATEGORY  0609
*                                                            @D31KKNL*/
         MVC   CRRRTNCD(1,CRRPTR),FSBSRCAT(FSBPTR)                 0609
*   CRRFDB2=FSBMNRCD;               /* COPY MINOR RETURN CODE      0610
*                                                            @D31KKNL*/
         MVC   CRRFDB2(1,CRRPTR),FSBMNRCD(FSBPTR)                  0610
*   CRRFDB3=FSBERC;                 /* EXTENDED RESPONSE     @D31KKNL*/
         MVC   CRRFDB3(1,CRRPTR),FSBERC(FSBPTR)                    0611
*   CRRUINPT=OFF;                   /* UNUSED FIELD          @D31KKNL*/
*   CRRUNUSD=OFF;                   /* CLEAR UNUSED FIELD    @D31KKNL*/
         NI    CRRUINPT(CRRPTR),B'00111111'                        0613
*   CRRESR1=FSBSYSRS;               /* SYSTEM RESPONSE       @D31KKNL*/
         MVC   CRRESR1(1,CRRPTR),FSBSYSRS(FSBPTR)                  0614
*   CRRESR2=FSBEXTRS;               /* EXTENDED RESPONSE     @D31KKNL*/
         MVC   CRRESR2(1,CRRPTR),FSBEXTRS(FSBPTR)                  0615
*   IF CRRRTNCD=CRRPHYSC&           /* IF PHYSICAL CONDITION @D31KKNL*/
*       CRRSTSAV=ON THEN            /* SENSE DATA AVAILABLE  @D31KKNL*/
         CLI   CRRRTNCD(CRRPTR),X'0C'                              0616
         BNE   @RF00616                                            0616
         TM    CRRSTSAV(CRRPTR),B'00000001'                        0616
         BNO   @RF00616                                            0616
*     CRRDSB=FSBDMGRS;              /* COPY SENSE DATA       @D31KKNL*/
         MVC   CRRDSB(2,CRRPTR),FSBDMGRS(FSBPTR)                   0617
*   ELSE                                                           0618
*     ;                             /*                       @D31KKNL*/
@RF00616 DS    0H                                                  0619
*   RETURN;                         /*                       @D31KKNL*/
@EL00004 DS    0H                                                  0619
@EF00004 DS    0H                                                  0619
@ER00004 BR    @14                                                 0619
*   END SETCRR;                     /*                       @D31KKNL*/
*                                                                  0621
*/********************************************************************/
*/*                                                                  */
*/* ROUTINE NAME : SOLMAC1                                           */
*/*                                                                  */
*/* FUNCTION :                                                       */
*/*  SOLMAC1 RECEIVES CONTROL FROM SOLMAC TO CHECK FOR ASYNCHRONOUS  */
*/*  INPUT.  THE SUBROUTINE ASYNCH IS CALLED TO CHECK FOR AN ACTIVE  */
*/*  ASYNCHRONOUS INPUT EXIT.  IF THERE IS AN EXIT ACTIVE, THE EXIT  */
*/*  SWITCH, CRRSW1, IS SET AND THE ROUTINE RETURNS TO SOLMAC.       */
*/*                                                                  */
*/*  IF THERE IS NO ACTIVE EXIT AN THE RPL IS CHAINED OFF THE        */
*/*  ACBDEB, THE RPL IS DEQUEUED, THE RPL IS INITIALIZED, AND        */
*/*  THE RPL PTR IS STORED IN THE CRR.  THE EXIT SWITCH IS NOT       */
*/*  SET  THE DATA WILL BE PROCESSED BY RECYCLING THROUGH THE        */
*/*  READ LOGIC.                                                     */
*/*                                                                  */
*/*  IF THE RPL IS NOT CHAINED OFF THE ACBDEB, THE FMCB IS           */
*/*  QUEUED TO THE READ ANY QUEUE AND SUBROUTINE XFRFSB              */
*/*  IS CALLED TO QUEUE THE FSB TO THE DATA QUEUE.                   */
*/*                                                                  */
*/* INPUT : FSBPTR REG(4) - ADDRESS OF FSB                           */
*/*                                                                  */
*/* OUTPUT : SAME                                                    */
*/*                                                                  */
*/* SUBROUTINES:         XFRFSB   - QUEUE FSB TO DATA QUEUE          */
*/*                                                                  */
*/* MACROS USED :  TPFEL, TPQUE, VMDESET, TPDEQ                      */
*/*                                                                  */
*/********************************************************************/
*                                                                  0621
*SOLMAC1:                                                          0621
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0621
SOLMAC1  DS    0H                                                  0622
*   CRRRTN3=RTNREG;                                                0622
         ST    RTNREG,CRRRTN3(,CRRPTR)                             0622
*   CRRBARAD=ZEROWORD;                                             0623
         SLR   @15,@15                                             0623
         ST    @15,CRRBARAD(,CRRPTR)                               0623
*   ACBPTR=FMCDEBA;                 /* SET UP ACDEB POINTER  @VS40357*/
         L     @15,CRRFMCB(,CRRPTR)                                0624
         L     ACBPTR,FMCDEBA(,@15)                                0624
*   CRRSW7=ON;                      /* TURN ON SW TO GET OUT OF LOOP
*                                                            @ZA17037*/
         OI    CRRSW7(CRRPTR),B'00000001'                          0625
*   IF CRRFMCLK=ON THEN             /* IS THE FMCB LOCKED?   @ZA30066*/
         TM    CRRFMCLK(CRRPTR),B'10000000'                        0626
         BNO   @RF00626                                            0626
*     DO;                           /* YES, UNLOCK IT        @ZA30066*/
*       CRRFMCLK=OFF;               /* TURN OFF FMCB LOCK FLAG     0628
*                                                            @ZA30066*/
         NI    CRRFMCLK(CRRPTR),B'01111111'                        0628
*/*** START -TPUNLOCK (CTLLOCK)- **                                  */
*                                                                  0629
*       DO;                                                        0629
*                                                                  0629
*/* ATBUILD (ISTRPH,ISTLOK,ISTCRA)                                   */
*/* END OF ATBUILD                                                   */
*                                                                  0630
*         RFY                                                      0630
*          (GPR00P,                                                0630
*           GPR01P,                                                0630
*           GPR02P,                                                0630
*           GPR03P,                                                0630
*           GPR04P,                                                0630
*           GPR15P) RSTD;                                          0630
*         GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(RPHWORK);
         STM GPR00P,GPR15P,RPHWORK(GPR01P)
*         GPR02P=ADDR(FMCDCLOK);    /* SET PARAM - LOCKWORD PTR      */
         L     GPR02P,CRRFMCB(,CRRPTR)                             0632
         LA    GPR02P,FMCDCLOK(,GPR02P)                            0632
*         GPR04P=GPR01P->RPHCRR;    /* SET PARAM - ISTCRA PTR        */
         L     GPR04P,RPHCRR(,GPR01P)                              0633
*         GPR00P=CRALMS08;          /* SET PARAM - LOCK LEVEL FLAG   */
         LA    GPR00P,128                                          0634
*         GPR03P=ADDR(GPR04P->CRAL8PTR);/* SET PARAM - LOCK LEVEL PTR*/
         LA    GPR03P,CRAL8PTR(,GPR04P)                            0635
*         DO;                       /* LISATCVT                    0636
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*           GPR15P=ATCLCPTR;        /* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     0637
*         END;                      /* LISATCVT                      */
*         GPR15P=GPR15P->ATCAP33;                                  0639
         L     GPR15P,ATCAP33(,GPR15P)                             0639
*         DCL                                                      0640
*           FMZL0020 BASED(GPR15P) LABEL VALUERANGE(*);            0640
*         CALL FMZL0020;                                           0641
         BALR  @14,@15                                             0641
*         GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(GPR00P, 0642
*             GPR01P,GPR02P,GPR03P,GPR04P,GPR05P,GPR06P,GPR07P,GPR08P,
*             GPR09P,GPR10P,GPR11P,GPR12P,GPR13P,GPR14P,GPR15P);   0642
         LM GPR00P,GPR15P,RPHWORK(GPR01P)
*         RFY                                                      0643
*          (GPR00P,                                                0643
*           GPR01P,                                                0643
*           GPR02P,                                                0643
*           GPR03P,                                                0643
*           GPR04P,                                                0643
*           GPR15P) UNRSTD;                                        0643
*       END;                                                       0644
*                                                                  0644
*/*** END -TPUNLOCK (CTLLOCK)- **                                    */
*                                                                  0645
*                                   /* UNLOCK FMCB           @ZA30066*/
*     END;                          /*                       @ZA30066*/
*/*** START -TPLOCK (DEBLOCK)TYPE(XCLSIVE)- **                       */
*                                                                  0646
*   DO;                                                            0646
@RF00626 DS    0H                                                  0647
*     RFY                                                          0647
*      (GPR00P,                                                    0647
*       GPR01P,                                                    0647
*       GPR02P,                                                    0647
*       GPR03P,                                                    0647
*       GPR04P,                                                    0647
*       GPR15P) RSTD;                                              0647
*     GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(RPHWORK);   0648
         STM GPR00P,GPR14P,RPHWORK(GPR01P)
*     GPR02P=ADDR(ACDLOCK);         /* SET PARAM - LOCKWORD PTR      */
         LA    GPR02P,ACDLOCK(,ACBPTR)                             0649
*     GPR04P=GPR01P->RPHCRR;        /* SET PARAM - ISTCRA PTR        */
         L     GPR04P,RPHCRR(,GPR01P)                              0650
*     GPR00P=CRALMS05;              /* SET PARAM - LOCK LEVEL FLAG   */
         LA    GPR00P,16                                           0651
*     GPR03P=ADDR(GPR04P->CRAL5PTR);/* SET PARAM - LOCK LEVEL PTR    */
         LA    GPR03P,CRAL5PTR(,GPR04P)                            0652
*     GPR15P=ATCLCPTR->ATCAP36;     /* ADDRESS OF LOCK ROUTINE       */
         L     @05,ATCLCPTR                                        0653
         L     GPR15P,ATCAP36(,@05)                                0653
*     DCL                                                          0654
*       FMZL0030 BASED(GPR15P) LABEL VALUERANGE(*);                0654
*     CALL FMZL0030;                                               0655
         BALR  @14,@15                                             0655
*     GENERATE REFS(GPR00P,GPR01P,GPR14P,RPHWORK) SETS(GPR00P,GPR01P,
*         GPR02P,GPR03P,GPR04P,GPR05P,GPR06P,GPR07P,GPR08P,GPR09P, 0656
*         GPR10P,GPR11P,GPR12P,GPR13P,GPR14P,GPR15P);              0656
         LM GPR00P,GPR15P,RPHWORK(GPR01P)
*     RFY                                                          0657
*      (GPR00P,                                                    0657
*       GPR01P,                                                    0657
*       GPR02P,                                                    0657
*       GPR03P,                                                    0657
*       GPR04P,                                                    0657
*       GPR15P) UNRSTD;                                            0657
*   END;                                                           0658
*                                                                  0658
*/*** END -TPLOCK (DEBLOCK)TYPE(XCLSIVE)- **                         */
*                                                                  0659
*                                   /* LOCK ACDEB            @ZA30066*/
*   CRRDBLCK=ON;                    /* ACDEB LOCK HELD       @ZA30066*/
         OI    CRRDBLCK(CRRPTR),B'00010000'                        0659
*/*** START -TPLOCK (CTLLOCK)TYPE(XCLSIVE)- **                       */
*                                                                  0660
*   DO;                                                            0660
*     RFY                                                          0661
*      (GPR00P,                                                    0661
*       GPR01P,                                                    0661
*       GPR02P,                                                    0661
*       GPR03P,                                                    0661
*       GPR04P,                                                    0661
*       GPR15P) RSTD;                                              0661
*     GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(RPHWORK);   0662
         STM GPR00P,GPR14P,RPHWORK(GPR01P)
*     GPR02P=ADDR(FMCDCLOK);        /* SET PARAM - LOCKWORD PTR      */
         L     GPR02P,CRRFMCB(,CRRPTR)                             0663
         LA    GPR02P,FMCDCLOK(,GPR02P)                            0663
*     GPR04P=GPR01P->RPHCRR;        /* SET PARAM - ISTCRA PTR        */
         L     GPR04P,RPHCRR(,GPR01P)                              0664
*     GPR00P=CRALMS08;              /* SET PARAM - LOCK LEVEL FLAG   */
         LA    GPR00P,128                                          0665
*     GPR03P=ADDR(GPR04P->CRAL8PTR);/* SET PARAM - LOCK LEVEL PTR    */
         LA    GPR03P,CRAL8PTR(,GPR04P)                            0666
*     GPR15P=ATCLCPTR->ATCAP36;     /* ADDRESS OF LOCK ROUTINE       */
         L     @05,ATCLCPTR                                        0667
         L     GPR15P,ATCAP36(,@05)                                0667
*     DCL                                                          0668
*       FMZL0035 BASED(GPR15P) LABEL VALUERANGE(*);                0668
*     CALL FMZL0035;                                               0669
         BALR  @14,@15                                             0669
*     GENERATE REFS(GPR00P,GPR01P,GPR14P,RPHWORK) SETS(GPR00P,GPR01P,
*         GPR02P,GPR03P,GPR04P,GPR05P,GPR06P,GPR07P,GPR08P,GPR09P, 0670
*         GPR10P,GPR11P,GPR12P,GPR13P,GPR14P,GPR15P);              0670
         LM GPR00P,GPR15P,RPHWORK(GPR01P)
*     RFY                                                          0671
*      (GPR00P,                                                    0671
*       GPR01P,                                                    0671
*       GPR02P,                                                    0671
*       GPR03P,                                                    0671
*       GPR04P,                                                    0671
*       GPR15P) UNRSTD;                                            0671
*   END;                                                           0672
*                                                                  0672
*/*** END -TPLOCK (CTLLOCK)TYPE(XCLSIVE)- **                         */
*                                                                  0673
*                                   /* LOCK FMCB             @ZA30066*/
*   CRRFMCLK=ON;                    /* FMCB LOCK HELD        @ZA30066*/
         OI    CRRFMCLK(CRRPTR),B'10000000'                        0673
*   DO WHILE CRRSW7=ON;             /*                       @ZA17037*/
         B     @DE00674                                            0674
@DL00674 DS    0H                                                  0675
*     IF(FMCFLGA3=OFF)&             /* FSB SHOULD BE FLUSHED         */
*         (ACDRARQ^=ZEROWORD&ACDRARQ^=GATEBIT) THEN/* READ ANY Q   0675
*                                      EMPTY                         */
         L     @15,CRRFMCB(,CRRPTR)                                0675
         TM    FMCFLGA3(@15),B'00010000'                           0675
         BNZ   @RF00675                                            0675
         L     @15,ACDRARQ(,ACBPTR)                                0675
         LTR   @15,@15                                             0675
         BZ    @RF00675                                            0675
         CL    @15,@CF01547                                        0675
         BE    @RF00675                                            0675
*       DO;                                                        0676
*         RFY                                                      0677
*           RPLPTR RSTD;                                           0677
*         RFY                                                      0678
*           IFGRPL BASED(RPLPTR);                                  0678
*         RPLPTR=ACDRARQ;           /* GET ADDR FROM DEB READ ANY Q  */
*                                                                  0679
         LR    RPLPTR,@15                                          0679
*         /***********************************************************/
*         /*                                                         */
*         /* SEARCH THE CHAIN FOR READ REQUESTS                      */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0680
*         DO WHILE RPLPTR^=ZEROWORD&RPLPTR^=GATEBIT&CRRBARAD=ZEROWORD;
         B     @DE00680                                            0680
@DL00680 DS    0H                                                  0681
*                                   /*                       @D31KKNL*/
*           IF RPLREQ='1D'X THEN    /* READ?                 @D31KKNL*/
         CLI   RPLREQ(RPLPTR),29                                   0681
         BNE   @RF00681                                            0681
*             CRRBARAD=RPLPTR;                                     0682
         ST    RPLPTR,CRRBARAD(,CRRPTR)                            0682
*           ELSE                                                   0683
*             ;                                                    0683
@RF00681 DS    0H                                                  0684
*           RPLPTR=RPLPLHPT;        /* GET POINTER TO NEXT RPL       */
         L     RPLPTR,RPLPLHPT(,RPLPTR)                            0684
*         END;                                                     0685
@DE00680 SLR   @15,@15                                             0685
         CR    RPLPTR,@15                                          0685
         BE    @DC00680                                            0685
         CL    RPLPTR,@CF01547                                     0685
         BE    @DC00680                                            0685
         C     @15,CRRBARAD(,CRRPTR)                               0685
         BE    @DL00680                                            0685
@DC00680 DS    0H                                                  0686
*       END;                                                       0686
*     ELSE                                                         0687
*       ;                                                          0687
@RF00675 DS    0H                                                  0688
*     IF CRRBARAD=ZEROWORD THEN                                    0688
         L     @15,CRRBARAD(,CRRPTR)                               0688
         LTR   @15,@15                                             0688
         BNZ   @RF00688                                            0688
*       DO;                                                        0689
*                                                                  0689
*         /***********************************************************/
*         /*                                                         */
*         /* FSB TO BE FLUSHED OR NO RPL ON ACBDEB READ ANY QUEUE    */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0690
*         CRRSW6=ON;                /* FSB QUEUED                    */
         OI    CRRSW6(CRRPTR),B'00000010'                          0690
*         CRRDBLCK=OFF;             /* DEB LOCK NOT HELD     @ZA33377*/
         NI    CRRDBLCK(CRRPTR),B'11101111'                        0691
*/*** START -TPUNLOCK (DEBLOCK)- **                                  */
*                                                                  0692
*         DO;                                                      0692
*                                                                  0692
*/* ATBUILD (ISTRPH,ISTLOK,ISTCRA)                                   */
*/* END OF ATBUILD                                                   */
*                                                                  0693
*           RFY                                                    0693
*            (GPR00P,                                              0693
*             GPR01P,                                              0693
*             GPR02P,                                              0693
*             GPR03P,                                              0693
*             GPR04P,                                              0693
*             GPR15P) RSTD;                                        0693
*           GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(RPHWORK);
         STM GPR00P,GPR15P,RPHWORK(GPR01P)
*           GPR02P=ADDR(ACDLOCK);   /* SET PARAM - LOCKWORD PTR      */
         LA    GPR02P,ACDLOCK(,ACBPTR)                             0695
*           GPR04P=GPR01P->RPHCRR;  /* SET PARAM - ISTCRA PTR        */
         L     GPR04P,RPHCRR(,GPR01P)                              0696
*           GPR00P=CRALMS05;        /* SET PARAM - LOCK LEVEL FLAG   */
         LA    GPR00P,16                                           0697
*           GPR03P=ADDR(GPR04P->CRAL5PTR);/* SET PARAM - LOCK LEVEL
*                                      PTR                           */
         LA    GPR03P,CRAL5PTR(,GPR04P)                            0698
*           DO;                     /* LISATCVT                    0699
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*             GPR15P=ATCLCPTR;      /* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     0700
*           END;                    /* LISATCVT                      */
*           GPR15P=GPR15P->ATCAP33;                                0702
         L     GPR15P,ATCAP33(,GPR15P)                             0702
*           DCL                                                    0703
*             FMZL0040 BASED(GPR15P) LABEL VALUERANGE(*);          0703
*           CALL FMZL0040;                                         0704
         BALR  @14,@15                                             0704
*           GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(GPR00P,
*               GPR01P,GPR02P,GPR03P,GPR04P,GPR05P,GPR06P,GPR07P,GPR08P
*               ,GPR09P,GPR10P,GPR11P,GPR12P,GPR13P,GPR14P,GPR15P);
         LM GPR00P,GPR15P,RPHWORK(GPR01P)
*           RFY                                                    0706
*            (GPR00P,                                              0706
*             GPR01P,                                              0706
*             GPR02P,                                              0706
*             GPR03P,                                              0706
*             GPR04P,                                              0706
*             GPR15P) UNRSTD;                                      0706
*         END;                                                     0707
*                                                                  0707
*/*** END -TPUNLOCK (DEBLOCK)- **                                    */
*                                                                  0708
*                                   /* UNLOCK DEB FOR DCC60  @ZA33377*/
*         CALL XFRFSB;              /* FSB ON DATA Q                 */
         BAL   @14,XFRFSB                                          0708
*         IF CRRFMCLK=ON THEN                                      0709
         TM    CRRFMCLK(CRRPTR),B'10000000'                        0709
         BNO   @RF00709                                            0709
*           DO;                     /* FMCB LOCK HELD?       @ZA33377*/
*             CRRFMCLK=OFF;         /* FMCB LOCK NOT HELD    @ZA33377*/
         NI    CRRFMCLK(CRRPTR),B'01111111'                        0711
*/*** START -TPUNLOCK (CTLLOCK)- **                                  */
*                                                                  0712
*             DO;                                                  0712
*                                                                  0712
*/* ATBUILD (ISTRPH,ISTLOK,ISTCRA)                                   */
*/* END OF ATBUILD                                                   */
*                                                                  0713
*               RFY                                                0713
*                (GPR00P,                                          0713
*                 GPR01P,                                          0713
*                 GPR02P,                                          0713
*                 GPR03P,                                          0713
*                 GPR04P,                                          0713
*                 GPR15P) RSTD;                                    0713
*               GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(  0714
*                   RPHWORK);                                      0714
         STM GPR00P,GPR15P,RPHWORK(GPR01P)
*               GPR02P=ADDR(FMCDCLOK);/* SET PARAM - LOCKWORD PTR    */
         L     GPR02P,CRRFMCB(,CRRPTR)                             0715
         LA    GPR02P,FMCDCLOK(,GPR02P)                            0715
*               GPR04P=GPR01P->RPHCRR;/* SET PARAM - ISTCRA PTR      */
         L     GPR04P,RPHCRR(,GPR01P)                              0716
*               GPR00P=CRALMS08;    /* SET PARAM - LOCK LEVEL FLAG   */
         LA    GPR00P,128                                          0717
*               GPR03P=ADDR(GPR04P->CRAL8PTR);/* SET PARAM - LOCK  0718
*                                      LEVEL PTR                     */
         LA    GPR03P,CRAL8PTR(,GPR04P)                            0718
*               DO;                 /* LISATCVT                    0719
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*                 GPR15P=ATCLCPTR;  /* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     0720
*               END;                /* LISATCVT                      */
*               GPR15P=GPR15P->ATCAP33;                            0722
         L     GPR15P,ATCAP33(,GPR15P)                             0722
*               DCL                                                0723
*                 FMZL0050 BASED(GPR15P) LABEL VALUERANGE(*);      0723
*               CALL FMZL0050;                                     0724
         BALR  @14,@15                                             0724
*               GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(GPR00P
*                   ,GPR01P,GPR02P,GPR03P,GPR04P,GPR05P,GPR06P,GPR07P,
*                   GPR08P,GPR09P,GPR10P,GPR11P,GPR12P,GPR13P,GPR14P,
*                   GPR15P);                                       0725
         LM GPR00P,GPR15P,RPHWORK(GPR01P)
*               RFY                                                0726
*                (GPR00P,                                          0726
*                 GPR01P,                                          0726
*                 GPR02P,                                          0726
*                 GPR03P,                                          0726
*                 GPR04P,                                          0726
*                 GPR15P) UNRSTD;                                  0726
*             END;                                                 0727
*                                                                  0727
*/*** END -TPUNLOCK (CTLLOCK)- **                                    */
*                                                                  0728
*                                   /* UNLOCK FMCB           @ZA33377*/
*           END;                    /* FMCB LOCK HELD?       @ZA33377*/
*/*** START -TPLOCK (DEBLOCK)TYPE(XCLSIVE)- **                       */
*                                                                  0729
*         DO;                                                      0729
@RF00709 DS    0H                                                  0730
*           RFY                                                    0730
*            (GPR00P,                                              0730
*             GPR01P,                                              0730
*             GPR02P,                                              0730
*             GPR03P,                                              0730
*             GPR04P,                                              0730
*             GPR15P) RSTD;                                        0730
*           GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(RPHWORK);
         STM GPR00P,GPR14P,RPHWORK(GPR01P)
*           GPR02P=ADDR(ACDLOCK);   /* SET PARAM - LOCKWORD PTR      */
         LA    GPR02P,ACDLOCK(,ACBPTR)                             0732
*           GPR04P=GPR01P->RPHCRR;  /* SET PARAM - ISTCRA PTR        */
         L     GPR04P,RPHCRR(,GPR01P)                              0733
*           GPR00P=CRALMS05;        /* SET PARAM - LOCK LEVEL FLAG   */
         LA    GPR00P,16                                           0734
*           GPR03P=ADDR(GPR04P->CRAL5PTR);/* SET PARAM - LOCK LEVEL
*                                      PTR                           */
         LA    GPR03P,CRAL5PTR(,GPR04P)                            0735
*           GPR15P=ATCLCPTR->ATCAP36;/* ADDRESS OF LOCK ROUTINE      */
         L     @08,ATCLCPTR                                        0736
         L     GPR15P,ATCAP36(,@08)                                0736
*           DCL                                                    0737
*             FMZL0060 BASED(GPR15P) LABEL VALUERANGE(*);          0737
*           CALL FMZL0060;                                         0738
         BALR  @14,@15                                             0738
*           GENERATE REFS(GPR00P,GPR01P,GPR14P,RPHWORK) SETS(GPR00P,
*               GPR01P,GPR02P,GPR03P,GPR04P,GPR05P,GPR06P,GPR07P,GPR08P
*               ,GPR09P,GPR10P,GPR11P,GPR12P,GPR13P,GPR14P,GPR15P);
         LM GPR00P,GPR15P,RPHWORK(GPR01P)
*           RFY                                                    0740
*            (GPR00P,                                              0740
*             GPR01P,                                              0740
*             GPR02P,                                              0740
*             GPR03P,                                              0740
*             GPR04P,                                              0740
*             GPR15P) UNRSTD;                                      0740
*         END;                                                     0741
*                                                                  0741
*/*** END -TPLOCK (DEBLOCK)TYPE(XCLSIVE)- **                         */
*                                                                  0742
*                                   /* LOCK DEB              @ZA33377*/
*         CRRDBLCK=ON;              /* DEB LOCK HELD         @ZA33377*/
         OI    CRRDBLCK(CRRPTR),B'00010000'                        0742
*/*** START -TPLOCK (CTLLOCK)TYPE(XCLSIVE)- **                       */
*                                                                  0743
*         DO;                                                      0743
*           RFY                                                    0744
*            (GPR00P,                                              0744
*             GPR01P,                                              0744
*             GPR02P,                                              0744
*             GPR03P,                                              0744
*             GPR04P,                                              0744
*             GPR15P) RSTD;                                        0744
*           GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(RPHWORK);
         STM GPR00P,GPR14P,RPHWORK(GPR01P)
*           GPR02P=ADDR(FMCDCLOK);  /* SET PARAM - LOCKWORD PTR      */
         L     GPR02P,CRRFMCB(,CRRPTR)                             0746
         LA    GPR02P,FMCDCLOK(,GPR02P)                            0746
*           GPR04P=GPR01P->RPHCRR;  /* SET PARAM - ISTCRA PTR        */
         L     GPR04P,RPHCRR(,GPR01P)                              0747
*           GPR00P=CRALMS08;        /* SET PARAM - LOCK LEVEL FLAG   */
         LA    GPR00P,128                                          0748
*           GPR03P=ADDR(GPR04P->CRAL8PTR);/* SET PARAM - LOCK LEVEL
*                                      PTR                           */
         LA    GPR03P,CRAL8PTR(,GPR04P)                            0749
*           GPR15P=ATCLCPTR->ATCAP36;/* ADDRESS OF LOCK ROUTINE      */
         L     @08,ATCLCPTR                                        0750
         L     GPR15P,ATCAP36(,@08)                                0750
*           DCL                                                    0751
*             FMZL0065 BASED(GPR15P) LABEL VALUERANGE(*);          0751
*           CALL FMZL0065;                                         0752
         BALR  @14,@15                                             0752
*           GENERATE REFS(GPR00P,GPR01P,GPR14P,RPHWORK) SETS(GPR00P,
*               GPR01P,GPR02P,GPR03P,GPR04P,GPR05P,GPR06P,GPR07P,GPR08P
*               ,GPR09P,GPR10P,GPR11P,GPR12P,GPR13P,GPR14P,GPR15P);
         LM GPR00P,GPR15P,RPHWORK(GPR01P)
*           RFY                                                    0754
*            (GPR00P,                                              0754
*             GPR01P,                                              0754
*             GPR02P,                                              0754
*             GPR03P,                                              0754
*             GPR04P,                                              0754
*             GPR15P) UNRSTD;                                      0754
*         END;                                                     0755
*                                                                  0755
*/*** END -TPLOCK (CTLLOCK)TYPE(XCLSIVE)- **                         */
*                                                                  0756
*                                   /* LOCK FMCB             @ZA33377*/
*         CRRFMCLK=ON;              /* FMCB LOCK HELD        @ZA33377*/
         OI    CRRFMCLK(CRRPTR),B'10000000'                        0756
*         CRRSW1=ON;                /* SET EXIT SWITCH               */
         OI    CRRSW1(CRRPTR),B'01000000'                          0757
*/* TPFEL (,FMCFBA) RETPTR(FSBPTR)                                   */
*                                                                  0758
*         DO;                       /* BEGIN TPFEL CODE GENERATION   */
*           DCL                                                    0759
*             FMZCA070 BIT(32) CONSTANT('80000000'X);              0759
*           DCL                                                    0760
*             FMZCB070 BIT(32) CONSTANT('7FFFFFFF'X);              0760
*           RFY                                                    0761
*            (GPR00P,                                              0761
*             GPR01P,                                              0761
*             GPR14P,                                              0761
*             GPR15P) RSTD;                                        0761
*           GPR15P=ADDR(FMCFBA);    /* ADDRESS QUEUE POINTER         */
         L     GPR15P,CRRFMCB(,CRRPTR)                             0762
         LA    GPR15P,FMCFBA(,GPR15P)                              0762
*           GPR14P=GPR15P->PABWEQA|FMZCA070;                       0763
         L     @08,@CF01547                                        0763
         L     GPR14P,PABWEQA(,GPR15P)                             0763
         OR    GPR14P,@08                                          0763
*           IF GPR14P=FMZCA070 THEN                                0764
         CLR   GPR14P,@08                                          0764
         BE    @RT00764                                            0764
*             ;                                                    0765
*           ELSE                                                   0766
*             DO;                                                  0766
*               GPR00P=FMZCA070;    /* INITIALIZE QUIT FLAG          */
         L     GPR00P,@CF01547                                     0767
*               DO WHILE(GPR00P^=GPR14P->WKECHAIN);                0768
         B     @DE00768                                            0768
@DL00768 DS    0H                                                  0769
*                 GPR14P=GPR14P->WKECHAIN;/* SEARCH FOR END OF CHAIN */
         L     GPR14P,WKECHAIN(,GPR14P)                            0769
*               END;                                               0770
@DE00768 C     GPR00P,WKECHAIN(,GPR14P)                            0770
         BNE   @DL00768                                            0770
*             END;                                                 0771
*           GPR14P=GPR14P&FMZCB070;                                0772
@RT00764 N     GPR14P,@CF01545                                     0772
*           FSBPTR=GPR14P;                                         0773
         LR    FSBPTR,GPR14P                                       0773
*           RFY                                                    0774
*            (GPR00P,                                              0774
*             GPR01P,                                              0774
*             GPR14P,                                              0774
*             GPR15P) UNRSTD;                                      0774
*         END;                      /* END TPFEL GENERATION DATA ON
*                                      QUEUE?                        */
*         IF FSBPTR^=ZEROWORD&FSBPTR^=GATEBIT THEN                 0776
         LTR   FSBPTR,FSBPTR                                       0776
         BZ    @RF00776                                            0776
         CL    FSBPTR,@CF01547                                     0776
         BE    @RF00776                                            0776
*           DO;                     /* DATA PLACED ON QUEUE  @ZA24578*/
*                                                                  0777
*             /*******************************************************/
*             /*                                                     */
*             /* QUEUE FMCB ON ACBDEB READ ANY QUEUE                 */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0778
*/*  THE FOLLOWING CODE DELETED BY APAR ZA30066              @ZA30066*/
*/*            IF CRRFMCLK=ON THEN DO;      IS FMCB LOCKED?  @ZA17037*/
*/*            CRRFMCLK=OFF;               OFF LOCK FMCB FLG @ZA17037*/
*/*            ?TPUNLOCK (CTLLOCK);         UNLOCK FMCB      @ZA17037*/
*/*                END;                                    /*@ZA17037*/
*/*            ?VMDESET ((15),ZERO);                               0778
*/*           ?TPLOCK (DEBLOCK) TYPE(XCLSIVE);    LOCK DEB   @ZA17037*/
*/*           CRRDBLCK=ON;                 DEB LOCK HELD     @ZA17037*/
*/*             ?TPLOCK (CTLLOCK) TYPE(XCLSIVE);   LOCK FMCB @ZA17037*/
*/*             CRRFMCLK=ON;              ON LOCKED FMCB FLG @ZA17037*/
*                                                                  0778
*             IF FMCFLGA2=OFF THEN                                 0778
         L     @15,CRRFMCB(,CRRPTR)                                0778
         TM    FMCFLGA2(@15),B'00100000'                           0778
         BNZ   @RF00778                                            0778
*               DO;                 /* NOT ON ACDEB RAFQ     @ZA24578*/
*/*  TPQUE ((CRRFMCB),ACDRAFQ) CHAIN(FMCRAFM)                        */
*                                                                  0780
*                 DO;                                              0780
*                   RFY                                            0781
*                    (GPR00P,                                      0781
*                     GPR01P,                                      0781
*                     GPR02P,                                      0781
*                     GPR14P,                                      0781
*                     GPR15P) RSTD;                                0781
*                   GEN REFS(GPR01P) SETS(RPHWORK)                 0782
*                       (STM GPR02P,GPR08P,RPHWORK(GPR01P));       0782
         STM GPR02P,GPR08P,RPHWORK(GPR01P)
*                   GPR15P=(CRRFMCB);/* GET WORK ELEM POINTER        */
         L     GPR15P,CRRFMCB(,CRRPTR)                             0783
*                   GPR14P=ADDR(ACDRAFQ);/* ADDRESS PAB/QUEUE POINTER*/
         LA    GPR14P,ACDRAFQ(,ACBPTR)                             0784
*                   GPR15P=GPR15P|PABWEQG1;                        0785
         O     GPR15P,@CF01547                                     0785
*                   GPR02P=GPR14P->PABWEQA;/* INITIALIZE WITH QUEUE
*                                      HEADER                        */
         L     GPR02P,PABWEQA(,GPR14P)                             0786
*CMZA0074:                                                         0787
*                   ;               /* CS FAIL TARGET                */
CMZA0074 DS    0H                                                  0788
*                   GPR00P=GPR02P;  /* SAVE QUEUE CONTENTS           */
         LR    GPR00P,GPR02P                                       0788
*                   GPR15P->FMCRAFM=GPR02P|PABWEQG1;/* FORWARD CHAIN
*                                      WORK ELEMENT                  */
         LR    @08,GPR02P                                          0789
         O     @08,@CF01547                                        0789
         ST    @08,FMCRAFM(,GPR15P)                                0789
*                   CS(GPR02P,GPR15P,GPR14P->PABWEQA);/* CHECK FOR 0790
*                                      END OF QUEUE                  */
         CS    GPR02P,@15,PABWEQA(GPR14P)                          0790
*                   BC(7,CMZA0074);                                0791
         BC    7,CMZA0074                                          0791
*                   GEN REFS(RPHWORK,GPR01P) NOSETS                0792
*                       (LM    GPR02P,GPR08P,RPHWORK(GPR01P));     0792
         LM    GPR02P,GPR08P,RPHWORK(GPR01P)
*                   RFY                                            0793
*                    (GPR00P,                                      0793
*                     GPR01P,                                      0793
*                     GPR02P,                                      0793
*                     GPR14P,                                      0793
*                     GPR15P) UNRSTD;                              0793
*                 END;              /* *** END OF TPQUE GENERATION 0794
*                                      QUEUE FMCB            @ZA17037*/
*                 RFY                                              0795
*                  (REG2,                                          0795
*                   REG3) RSTD;                                    0795
*CS1:                                                              0796
*                 REG2=FMCCMPS2;    /* REFERENCE FLAG VALUE          */
CS1      L     @15,CRRFMCB(,CRRPTR)                                0796
         L     REG2,FMCCMPS2(,@15)                                 0796
*                 REG3=REG2|FLGA2ON;/* SET FMCB ON ACBDEB READ ANY Q */
         LR    REG3,REG2                                           0797
         O     REG3,@CF01557                                       0797
*                 CS(REG2,REG3,FMCCMPS2);/* SET VALUE IN FMCB        */
         CS    REG2,@03,FMCCMPS2(@15)                              0798
*                 BC(7,CS1);        /* TRY AGAIN IF FAILURE          */
         BC    7,CS1                                               0799
*                 RFY                                              0800
*                  (REG2,                                          0800
*                   REG3) UNRSTD;   /*                       @ZA24578*/
*               END;                /* NOT ON ACDEB RAFQ     @ZA24578*/
*/*             CRRDBLCK=OFF;           DELETED BY           @ZA30066*/
*/*             ?TPUNLOCK (DEBLOCK);    DELETED BY           @ZA30066*/
*/*                  ?VMDESET ((15),ATCAM); DELETED BY       @ZA30066*/
*                                                                  0802
*           END;                                                   0802
*         ELSE                                                     0803
*           ;                       /* FSB WAS FLUSHED               */
@RF00776 DS    0H                                                  0804
*         CRRSW7=OFF;               /* END DO WHILE          @ZA17037*/
@RC00776 NI    CRRSW7(CRRPTR),B'11111110'                          0804
*       END;                                                       0805
*     ELSE                                                         0806
*       DO;                                                        0806
*                                                                  0806
         B     @RC00688                                            0806
@RF00688 DS    0H                                                  0807
*         /***********************************************************/
*         /*                                                         */
*         /* DEQUEUE RPL FROM ACBDEB READ ANY QUEUE AND RECYCLE TO   */
*         /* PROCESS IT AS NORMAL READ REQUEST                       */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0807
*/*      THE FOLLOWING CODE DELETED BY ZA30066               @ZA30066*/
*/*            IF CRRFMCLK=ON THEN DO;      IS FMCB LOCKED?  @D33SKD3*/
*/*            CRRFMCLK=OFF;               OFF LOCK FMCB FLG @D33SKD3*/
*/*            ?TPUNLOCK (CTLLOCK);         UNLOCK FMCB      @D31KKNL*/
*/*                END;                                      @D33SKD3*/
*/*           ?TPLOCK (DEBLOCK) TYPE(XCLSIVE);    LOCK DEB   @D31KKNL*/
*/*           CRRDBLCK=ON;                 DEB LOCK HELD     @D31KKNL*/
*/*             ?TPLOCK (CTLLOCK) TYPE(XCLSIVE);   LOCK FMCB @D31KKNL*/
*/*             CRRFMCLK=ON;              ON LOCKED FMCB FLG @D33SKD3*/
*/* TPDEQ (CRRBARAD,ACDRARQ) RETPTR(CRRBARAD)                        */
*                                                                  0807
*         DO;                       /* BEGIN TPDEQ CODE GENERATION   */
*           RFY                                                    0808
*            (GPR00P,                                              0808
*             GPR01P,                                              0808
*             GPR14P,                                              0808
*             GPR15P) RSTD;                                        0808
*           GPR15P=ADDR(ACDRARQ);   /* ADDRESS QUEUE POINTER         */
         LA    GPR15P,ACDRARQ(,ACBPTR)                             0809
*           RFY                                                    0810
*            (GPR02P,                                              0810
*             GPR03P) RSTD;                                        0810
*           STM(GPR02P,GPR03P,GPR01P->RPHWORK(5:12));              0811
         STM   GPR02P,GPR03P,RPHWORK+4(GPR01P)                     0811
*           GPR03P=CRRBARAD|FMZCA070;                              0812
         L     @08,@CF01547                                        0812
         L     GPR03P,CRRBARAD(,CRRPTR)                            0812
         OR    GPR03P,@08                                          0812
*           GPR14P=FMZCA070;                                       0813
         LR    GPR14P,@08                                          0813
*           GPR15P=ADDR(GPR15P->PABWEQA);                          0814
*           GPR02P=GPR15P->PABWEQA|FMZCA070;                       0815
         O     @08,PABWEQA(,GPR15P)                                0815
         LR    GPR02P,@08                                          0815
*           DO WHILE(GPR02P^=GPR14P);                              0816
         B     @DE00816                                            0816
@DL00816 DS    0H                                                  0817
*FMZL2080:                                                         0817
*             ;                                                    0817
FMZL2080 DS    0H                                                  0818
*             IF GPR02P=GPR03P THEN                                0818
         CR    GPR02P,GPR03P                                       0818
         BNE   @RF00818                                            0818
*               DO;                                                0819
*                 GPR00P=GPR02P->WKECHAIN;                         0820
         L     GPR00P,WKECHAIN(,GPR02P)                            0820
*                 CS(GPR02P,GPR00P,GPR15P->PABWEQA);               0821
         CS    GPR02P,@00,PABWEQA(GPR15P)                          0821
*                 BC(7,FMZL3080);                                  0822
         BC    7,FMZL3080                                          0822
*                 GPR14P=GPR02P;                                   0823
         LR    GPR14P,GPR02P                                       0823
*                 GPR14P->WKECHAIN=0;                              0824
         SLR   @08,@08                                             0824
         ST    @08,WKECHAIN(,GPR14P)                               0824
*               END;                                               0825
*             ELSE                                                 0826
*               DO;                                                0826
         B     @RC00818                                            0826
@RF00818 DS    0H                                                  0827
*                 IF(GPR02P->WKECHAIN)=GPR14P THEN                 0827
         L     @08,WKECHAIN(,GPR02P)                               0827
         CR    @08,GPR14P                                          0827
         BE    @RT00827                                            0827
*                   GOTO ISTA0080;                                 0828
*                 ELSE                                             0829
*                   DO;                                            0829
*                     GPR15P=ADDR(GPR02P->WKECHAIN);               0830
         LA    GPR15P,WKECHAIN(,GPR02P)                            0830
*                     GPR02P=GPR02P->WKECHAIN;                     0831
         LR    GPR02P,@08                                          0831
*                     GOTO FMZL2080;                               0832
         B     FMZL2080                                            0832
*                   END;                                           0833
*               END;                                               0834
*FMZL3080:                                                         0835
*             ;                                                    0835
@RC00818 DS    0H                                                  0835
FMZL3080 DS    0H                                                  0836
*           END;                                                   0836
@DE00816 CR    GPR02P,GPR14P                                       0836
         BNE   @DL00816                                            0836
*ISTA0080:                                                         0837
*           ;                                                      0837
ISTA0080 DS    0H                                                  0838
*           LM(GPR02P,GPR03P,GPR01P->RPHWORK(5:12));               0838
         LM    GPR02P,GPR03P,RPHWORK+4(GPR01P)                     0838
*           RFY                                                    0839
*            (GPR02P,                                              0839
*             GPR03P) UNRSTD;                                      0839
*           GPR14P=GPR14P&FMZCB070;                                0840
         N     GPR14P,@CF01545                                     0840
*           CRRBARAD=GPR14P;                                       0841
         ST    GPR14P,CRRBARAD(,CRRPTR)                            0841
*           RFY                                                    0842
*            (GPR00P,                                              0842
*             GPR01P,                                              0842
*             GPR14P,                                              0842
*             GPR15P) UNRSTD;                                      0842
*         END;                      /* END TPDEQ GENERATION DEQUEUE
*                                      RPL                   @ZA10414*/
*         CRRDBLCK=OFF;             /* OFF DEB LOCK FLG      @D33SKD3*/
         NI    CRRDBLCK(CRRPTR),B'11101111'                        0844
*/*** START -TPUNLOCK (DEBLOCK)- **                                  */
*                                                                  0845
*         DO;                                                      0845
*                                                                  0845
*/* ATBUILD (ISTRPH,ISTLOK,ISTCRA)                                   */
*/* END OF ATBUILD                                                   */
*                                                                  0846
*           RFY                                                    0846
*            (GPR00P,                                              0846
*             GPR01P,                                              0846
*             GPR02P,                                              0846
*             GPR03P,                                              0846
*             GPR04P,                                              0846
*             GPR15P) RSTD;                                        0846
*           GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(RPHWORK);
         STM GPR00P,GPR15P,RPHWORK(GPR01P)
*           GPR02P=ADDR(ACDLOCK);   /* SET PARAM - LOCKWORD PTR      */
         LA    GPR02P,ACDLOCK(,ACBPTR)                             0848
*           GPR04P=GPR01P->RPHCRR;  /* SET PARAM - ISTCRA PTR        */
         L     GPR04P,RPHCRR(,GPR01P)                              0849
*           GPR00P=CRALMS05;        /* SET PARAM - LOCK LEVEL FLAG   */
         LA    GPR00P,16                                           0850
*           GPR03P=ADDR(GPR04P->CRAL5PTR);/* SET PARAM - LOCK LEVEL
*                                      PTR                           */
         LA    GPR03P,CRAL5PTR(,GPR04P)                            0851
*           DO;                     /* LISATCVT                    0852
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*             GPR15P=ATCLCPTR;      /* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     0853
*           END;                    /* LISATCVT                      */
*           GPR15P=GPR15P->ATCAP33;                                0855
         L     GPR15P,ATCAP33(,GPR15P)                             0855
*           DCL                                                    0856
*             FMZL0086 BASED(GPR15P) LABEL VALUERANGE(*);          0856
*           CALL FMZL0086;                                         0857
         BALR  @14,@15                                             0857
*           GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(GPR00P,
*               GPR01P,GPR02P,GPR03P,GPR04P,GPR05P,GPR06P,GPR07P,GPR08P
*               ,GPR09P,GPR10P,GPR11P,GPR12P,GPR13P,GPR14P,GPR15P);
         LM GPR00P,GPR15P,RPHWORK(GPR01P)
*           RFY                                                    0859
*            (GPR00P,                                              0859
*             GPR01P,                                              0859
*             GPR02P,                                              0859
*             GPR03P,                                              0859
*             GPR04P,                                              0859
*             GPR15P) UNRSTD;                                      0859
*         END;                                                     0860
*                                                                  0860
*/*** END -TPUNLOCK (DEBLOCK)- **                                    */
*                                                                  0861
*                                   /* UNLOCK DEB            @D31KKNL*/
*/*             ?VMDESET ((15),ATCAM);   DELETED BY          @ZA30066*/
*                                                                  0861
*         IF CRRBARAD^=0 THEN                                      0861
         L     @15,CRRBARAD(,CRRPTR)                               0861
         LTR   @15,@15                                             0861
         BZ    @RF00861                                            0861
*           DO;                     /* RPL DEQ'ED            @ZA10414*/
*             RFY                                                  0863
*               RPLPTR UNRSTD;      /* FREE RPL TEMPORARY REG        */
*             RFY                                                  0864
*               IFGRPL BASED(CRRARPL);/* REBASE RPL ON CRR           */
*             CRRARPL=CRRBARAD;     /* RPL DEQUEUED          @ZA10975*/
         ST    @15,CRRARPL(,CRRPTR)                                0865
*             RPLSAF=FMCSAF;        /* SET SOURCE ID IN RPL          */
         L     @05,CRRFMCB(,CRRPTR)                                0866
         LH    @00,FMCSAF(,@05)                                    0866
         N     @00,@CF04865                                        0866
         STH   @00,RPLSAF(,@15)                                    0866
*             RPLDAF=NCBDAF;        /* SET DESTINATION ID IN RPL     */
         L     @05,FMCDNCBA(,@05)                                  0867
         LH    @05,NCBDAF(,@05)                                    0867
         N     @05,@CF04865                                        0867
         STH   @05,RPLDAF(,@15)                                    0867
*             RPLNIB=OFF;           /* CID HAS REPLACED NIB          */
         NI    RPLNIB(@15),B'11111011'                             0868
*             RFY                                                  0869
*              (REG2,                                              0869
*               REG3) RSTD;                                        0869
*CS2:                                                              0870
*             REG2=FMCCMPS2;        /* REFERENCE FLAG VALUE          */
CS2      L     @15,CRRFMCB(,CRRPTR)                                0870
         L     REG2,FMCCMPS2(,@15)                                 0870
*             IF RPLDLGIN=OFF THEN  /* IF CONTINUE ANY SPEC          */
         L     @15,CRRARPL(,CRRPTR)                                0871
         TM    RPLDLGIN(@15),B'10000000'                           0871
         BNZ   @RF00871                                            0871
*               REG3=REG2&FLGA1OFF; /* RESET SATISFY SPEC RD         */
         LR    REG3,REG2                                           0872
         N     REG3,@CF01551                                       0872
*             ELSE                                                 0873
*               REG3=REG2|FLGA1ON;  /* SET SATISFY SPEC READ         */
         B     @RC00871                                            0873
@RF00871 LR    REG3,REG2                                           0873
         O     REG3,@CF01553                                       0873
*             CS(REG2,REG3,FMCCMPS2);/* SET VALUE IN FMCB            */
@RC00871 L     @15,CRRFMCB(,CRRPTR)                                0874
         CS    REG2,@03,FMCCMPS2(@15)                              0874
*             BC(7,CS2);            /* TRY AGAIN IF FAILURE          */
         BC    7,CS2                                               0875
*             RFY                                                  0876
*              (REG2,                                              0876
*               REG3) UNRSTD;                                      0876
*             CRRSW0=OFF;           /* TURN OFF CONTROL SWITCH       */
*             CRRSW7=OFF;           /* TURN OFF DO WHILE SW  @ZA17037*/
         NI    CRRSW0(CRRPTR),B'01111110'                          0878
*           END;                                                   0879
*       END;                                                       0880
@RF00861 DS    0H                                                  0881
*   END;                                                           0881
@RC00688 DS    0H                                                  0881
@DE00674 TM    CRRSW7(CRRPTR),B'00000001'                          0881
         BO    @DL00674                                            0881
*   RTNREG=CRRRTN3;                 /* RESTORE RETURN REG            */
         L     RTNREG,CRRRTN3(,CRRPTR)                             0882
*   END SOLMAC1;                                                   0883
@EL00005 DS    0H                                                  0883
@EF00005 DS    0H                                                  0883
@ER00005 BR    @14                                                 0883
*                                                                  0884
*/********************************************************************/
*/*                                                                  */
*/* ROUTINE NAME : EOBANAL                                           */
*/*                                                                  */
*/* FUNCTION :                                                       */
*/*  EOBANAL DETERMINES IF AN EOB, EOM, OR EOT HAS BEEN  RECIEVED.   */
*/*   IF SO, THE DATA EXPECTED FLAG IS SET OFF IN THE FSB AND THE    */
*/*   END OF I/O LCCW IS SET ON IN THE CRR.                          */
*/*                                                                  */
*/* INPUT :  FSBPTR REG(4) - ADDRESS OF FSB                          */
*/*                                                                  */
*/* OUTPUT : SAME                                                    */
*/*                                                                  */
*/* SUBROUTINES CALLED : NONE                                        */
*/*                                                                  */
*/* MACROS USED : NONE                                               */
*/*                                                                  */
*/********************************************************************/
*                                                                  0884
*EOBANAL:                                                          0884
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0884
EOBANAL  DS    0H                                                  0885
*   IF FSBELI=ON THEN               /* CHECK FOR END OF LCP          */
         TM    FSBELI(FSBPTR),B'10000000'                          0885
         BNO   @RF00885                                            0885
*     DO;                           /* END OF LCP                    */
*       RFY                                                        0887
*        (REG2,                                                    0887
*         REG3) RSTD;                                              0887
*CS3:                                                              0888
*       REG2=FMCCMPS2;              /* REFERENCE FLAG VALUE          */
CS3      L     @15,CRRFMCB(,CRRPTR)                                0888
         L     REG2,FMCCMPS2(,@15)                                 0888
*       REG3=REG2&FLGA0OFF;         /* RESET DATA EXPECTED           */
         LR    REG3,REG2                                           0889
         N     REG3,@CF01545                                       0889
*       CS(REG2,REG3,FMCCMPS2);     /* SET NEW VALUE IN FMCB         */
         CS    REG2,@03,FMCCMPS2(@15)                              0890
*       BC(7,CS3);                  /* TRY AGAIN IF FAILURE          */
         BC    7,CS3                                               0891
*       RFY                                                        0892
*        (REG2,                                                    0892
*         REG3) UNRSTD;                                            0892
*       CRRENDLW=ON;                /* SET END OF I/O LCCW IN CRR    */
         OI    CRRENDLW(CRRPTR),B'00100000'                        0893
*     END;                                                         0894
*   ELSE                                                           0895
*     ;                             /* MORE DATA YET TO COME         */
@RF00885 DS    0H                                                  0896
*   END EOBANAL;                                                   0896
@EL00006 DS    0H                                                  0896
@EF00006 DS    0H                                                  0896
@ER00006 BR    @14                                                 0896
*                                                                  0897
*/********************************************************************/
*/*                                                                  */
*/* ROUTINE NAME : XFRFSB                                            */
*/*                                                                  */
*/* FUNCTION :                                                       */
*/*  THE FSB IS MOVED TO PAGEABLE STORAGE AND QUEUED TO THE FMCB     */
*/*   DATA QUEUE AND THE NUMBER OF BUFFERS IN THE CHAIN IS ADDED     */
*/*   TO THE BUFFER COUNT IN THE FMCB.  A RESET COMMAND IS ISSUED    */
*/*   IF SUFFICIENT BUFFERS EXIST AND NO PURGE IS IN PROGRESS.       */
*/*   DATA WILL BE THROWN AWAY IF FLUSH IS INDICATED.                */
*/*                                                                  */
*/* INPUT : FSBPTR REG(4) - ADDRESS OF FSB                           */
*/*                                                                  */
*/* OUTPUT : SAME                                                    */
*/*                                                                  */
*/* SUBROUTINES CALLED : EOBANAL  - CHECK FOR ENDING STATUS          */
*/*                      ISTDCC61 - MOVE FSB TO PAGEABLE STORAGE     */
*/*                      LCPBINIT - BUILD AND SCHEDULE RESET LCPB    */
*/*                      FLUSH    - FREE DATA BUFFERS                */
*/*                                                                  */
*/* MACROS USED : TPQUE                                              */
*/*                                                                  */
*/********************************************************************/
*                                                                  0897
*XFRFSB:                                                           0897
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0897
XFRFSB   DS    0H                                                  0898
*   CRRRTN9=RTNREG;                 /* SAVE RETURN REG               */
         ST    RTNREG,CRRRTN9(,CRRPTR)                             0898
*   CALL EOBANAL;                   /* CHECK FOR LAST FSB            */
         BAL   @14,EOBANAL                                         0899
*   FSBELI=OFF;                     /* CLEAR UNSOL INPUT FLAG        */
*   FSBECI=OFF;                     /* CLEAR UNUSED FLAG             */
*                                                                  0901
         NI    FSBELI(FSBPTR),B'00111111'                          0901
*   /*****************************************************************/
*   /*                                                               */
*   /* MOVE FSB TO PAGEABLE BUFFER                                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0902
*   RFY                                                            0902
*     CVTPTR RSTD;                  /* RESTRICT PTR TO ATCVT         */
*   CVTPTR=CRRATCVT;                /* SET PTR FOR ATCVT             */
         L     CVTPTR,CRRATCVT(,CRRPTR)                            0903
*   CRRPTR=ADDR(CRRSAVE1);          /* SAVEAREA FOR MOVE ROUTINE     */
         LA    @15,CRRSAVE1(,CRRPTR)                               0904
         LR    CRRPTR,@15                                          0904
*   CALL MOVE61;                    /* MOVE FSB TO PAGEABLE BUFFER   */
         L     @15,ATCDCC61(,CVTPTR)                               0905
         BALR  @14,@15                                             0905
*   RFY                                                            0906
*     CVTPTR UNRSTD;                /* UNRESTRICT PTR TO ATCVT       */
*   CRRPTR=ADDR(CRRSPACE);          /* REESTABLISH BASE              */
         L     CRRPTR,RPHCRR(,RPHPTR)                              0907
         LA    CRRPTR,CRRSPACE+312(,CRRPTR)                        0907
*   FSBPTR=CRRFSB;                  /* GET NEW FSB (PAGEABLE) ADDRESS*/
*                                                                  0908
         L     FSBPTR,CRRFSB(,CRRPTR)                              0908
*   /*****************************************************************/
*   /*                                                               */
*   /* ACCUMULATE COUNT OF BUFFERS IN USE. IF BUFFER LIMIT REACHED,  */
*   /* RESET ANY OUTSTANDING I/O.                                    */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0909
*   RFY                                                            0909
*    (COUNTER,                                                     0909
*     FDBPTR) RSTD;                                                0909
*   FDBPTR=ADDR(FSBFDB);            /* REFERENCE FIRST FDB           */
         LA    FDBPTR,FSBFDB(,FSBPTR)                              0910
*   COUNTER=0;                      /* INITIALIZE BUFFER ACCUMULATOR */
         SLR   COUNTER,COUNTER                                     0911
*   DO WHILE FDBPTR^=ZEROWORD;      /* LOOP THROUGH ALL FDB'S        */
         B     @DE00912                                            0912
@DL00912 DS    0H                                                  0913
*     COUNTER=COUNTER+1;            /* COUNT BUFFERS USED            */
         AL    COUNTER,@CF00067                                    0913
*     FDBPTR=FDBFDBA;               /* REFERENCE NEXT FDB            */
         L     FDBPTR,FDBFDBA(,FDBPTR)                             0914
*   END;                                                           0915
@DE00912 LTR   FDBPTR,FDBPTR                                       0915
         BNZ   @DL00912                                            0915
*   RFY                                                            0916
*    (REG2,                                                        0916
*     REG3) RSTD;                                                  0916
*CS4:                                                              0917
*   REG2=FMCCMPS1;                  /* GET CURRENT BUFFER COUNT      */
CS4      L     @15,CRRFMCB(,CRRPTR)                                0917
         L     REG2,FMCCMPS1(,@15)                                 0917
*   REG3=REG2+COUNTER;              /* UPDATE BUFFER COUNT           */
         LR    REG3,REG2                                           0918
         ALR   REG3,COUNTER                                        0918
*   CS(REG2,REG3,FMCCMPS1);         /* SET NEW COUNT IN FMCB         */
         CS    REG2,@03,FMCCMPS1(@15)                              0919
*   BC(7,CS4);                      /* TRY AGAIN IF FAILURE          */
         BC    7,CS4                                               0920
*   RFY                                                            0921
*    (COUNTER,                                                     0921
*     FDBPTR,                                                      0921
*     REG2,                                                        0921
*     REG3) UNRSTD;                                                0921
*   FSBPTR=CRRFSB;                  /* RESTORE FSB POINTER (USED AS
*                                      COUNTER)                      */
         L     FSBPTR,CRRFSB(,CRRPTR)                              0922
*/*  TPQUE ((FSBPTR),FMCFBA)                                         */
*                                                                  0923
*   DO;                                                            0923
*     RFY                                                          0924
*      (GPR00P,                                                    0924
*       GPR01P,                                                    0924
*       GPR02P,                                                    0924
*       GPR14P,                                                    0924
*       GPR15P) RSTD;                                              0924
*     GEN REFS(GPR01P) SETS(RPHWORK)(STM GPR02P,GPR08P,RPHWORK(GPR01P))
*         ;                                                        0925
         STM GPR02P,GPR08P,RPHWORK(GPR01P)
*     GPR15P=(FSBPTR);              /* GET WORK ELEM POINTER         */
         LR    GPR15P,FSBPTR                                       0926
*     GPR14P=ADDR(FMCFBA);          /* ADDRESS PAB/QUEUE POINTER     */
         L     GPR14P,CRRFMCB(,CRRPTR)                             0927
         LA    GPR14P,FMCFBA(,GPR14P)                              0927
*     GPR15P=GPR15P|PABWEQG1;                                      0928
         O     GPR15P,@CF01547                                     0928
*     GPR02P=GPR14P->PABWEQA;       /* INITIALIZE WITH QUEUE HEADER  */
         L     GPR02P,PABWEQA(,GPR14P)                             0929
*CMZA0096:                                                         0930
*     ;                             /* CS FAIL TARGET                */
CMZA0096 DS    0H                                                  0931
*     GPR00P=GPR02P;                /* SAVE QUEUE CONTENTS           */
         LR    GPR00P,GPR02P                                       0931
*     GPR15P->PABCHAIN=GPR02P|PABWEQG1;/* FORWARD CHAIN WORK ELEMENT */
         LR    @05,GPR02P                                          0932
         O     @05,@CF01547                                        0932
         ST    @05,PABCHAIN(,GPR15P)                               0932
*     CS(GPR02P,GPR15P,GPR14P->PABWEQA);/* CHECK FOR END OF QUEUE    */
         CS    GPR02P,@15,PABWEQA(GPR14P)                          0933
*     BC(7,CMZA0096);                                              0934
         BC    7,CMZA0096                                          0934
*     GEN REFS(RPHWORK,GPR01P) NOSETS                              0935
*         (LM    GPR02P,GPR08P,RPHWORK(GPR01P));                   0935
         LM    GPR02P,GPR08P,RPHWORK(GPR01P)
*     RFY                                                          0936
*      (GPR00P,                                                    0936
*       GPR01P,                                                    0936
*       GPR02P,                                                    0936
*       GPR14P,                                                    0936
*       GPR15P) UNRSTD;                                            0936
*   END;                            /* *** END OF TPQUE GENERATION 0937
*                                      SAVE FSB ON FMCB DATA Q       */
*   IF FMCBUFNB>FMCBUFLM THEN       /* BUF NUMBER EXCEEDS LIMIT?     */
         L     @15,CRRFMCB(,CRRPTR)                                0938
         CLC   FMCBUFNB(2,@15),FMCBUFLM(@15)                       0938
         BNH   @RF00938                                            0938
*     IF FMCFLGA5=OFF THEN          /* BUFFER THRESHOLD EXCEEDED?    */
         TM    FMCFLGA5(@15),B'00000100'                           0939
         BNZ   @RF00939                                            0939
*       IF FMCFLGA4=OFF THEN        /* PURGE IN PROGRESS?            */
         TM    FMCFLGA4(@15),B'00001000'                           0940
         BNZ   @RF00940                                            0940
*         IF FMCZF019=OFF THEN      /* RESET ORDERLY         @ZA28324*/
         TM    FMCZF019(@15),B'01000000'                           0941
         BNZ   @RF00941                                            0941
*           DO;                     /* IN PROGRESS           @ZA28324*/
*             RFY                                                  0943
*              (REG2,                                              0943
*               REG3) RSTD;                                        0943
*CS5:                                                              0944
*             REG2=FMCCMPS2;        /* REFERENCE FLAG VALUE          */
CS5      L     @15,CRRFMCB(,CRRPTR)                                0944
         L     REG2,FMCCMPS2(,@15)                                 0944
*             REG3=REG2|FLGA5ON;    /* BUFFER THRESHOLD EXCEEDED     */
         LR    REG3,REG2                                           0945
         O     REG3,@CF01561                                       0945
*             CS(REG2,REG3,FMCCMPS2);/* SET NEW VALUE IN FMCB        */
         CS    REG2,@03,FMCCMPS2(@15)                              0946
*             BC(7,CS5);            /* TRY AGAIN IF FAILURE          */
         BC    7,CS5                                               0947
*             RFY                                                  0948
*              (REG2,                                              0948
*               REG3) UNRSTD;                                      0948
*             DCLBTEIS=ON;          /* THRESHOLD EXCEEDED            */
*                                                                  0949
         L     @15,CRRLCPB(,CRRPTR)                                0949
         OI    DCLBTEIS(@15),B'00010000'                           0949
*             /*******************************************************/
*             /*                                                     */
*             /* CALL LCPBINIT TO GET STORAGE FOR A LCPB. BUILD RESET*/
*             /* ACCORDING TO DEVICE TYPE AND QUEUE ON TPIOS OUTBOUND*/
*             /* PAB WITH RESET OPTION.                              */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0950
*             CALL LCPBINIT;        /* GET LCPB FOR RESET            */
         BAL   @14,LCPBINIT                                        0950
*           END;                                                   0951
*         ELSE                                                     0952
*           ;                       /* ALREADY EXCEEDED              */
@RF00941 DS    0H                                                  0953
*       ELSE                                                       0953
*         ;                         /* BUFF THRESHOLD NOT PASSED     */
@RF00940 DS    0H                                                  0954
*     ELSE                                                         0954
*       ;                           /* PURGE IN PROGRESS             */
@RF00939 DS    0H                                                  0955
*   IF CRRSW6=ON THEN               /* WAS FSB QUEUED                */
@RF00938 TM    CRRSW6(CRRPTR),B'00000010'                          0955
         BNO   @RF00955                                            0955
*     IF FMCFLGA3=ON THEN           /* FLUSH FLAG SET?               */
*                                                                  0956
         L     @15,CRRFMCB(,CRRPTR)                                0956
         TM    FMCFLGA3(@15),B'00010000'                           0956
         BNO   @RF00956                                            0956
*       /*************************************************************/
*       /*                                                           */
*       /* IF DATA FROM A SOLICIT AND THE FLUSH INDICATOR NOW SET,   */
*       /* FLUSH FSB UNTIL EOB.                                      */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0957
*       CALL FLUSH;                 /* FLUSH DATA TILL EOB           */
         BAL   @14,FLUSH                                           0957
*     ELSE                                                         0958
*       ;                           /* NO FLUSH                      */
@RF00956 DS    0H                                                  0959
*   ELSE                                                           0959
*     ;                                                            0959
@RF00955 DS    0H                                                  0960
*   RTNREG=CRRRTN9;                 /* RESTORE RETURN REG            */
         L     RTNREG,CRRRTN9(,CRRPTR)                             0960
*   END XFRFSB;                                                    0961
@EL00007 DS    0H                                                  0961
@EF00007 DS    0H                                                  0961
@ER00007 BR    @14                                                 0961
*                                                                  0962
*/********************************************************************/
*/*                                                                  */
*/* ROUTINE NAME : FREEBUF                                           */
*/*                                                                  */
*/* FUNCTION :                                                       */
*/*  FREEBUF IS CALLED TO FREE THE FSB AND FDBS.  THE RELSTORE       */
*/*   MACRO IS ISSUED WITH THE ERASE OPTION IF THE FDB CONTAINED     */
*/*   CONFIDENTIAL DATA.                                             */
*/* INPUT : FSBPTR REG(4) - ADDRESS OF FSB                           */
*/*                                                                  */
*/* OUTPUT :  SAME                                                   */
*/*                                                                  */
*/* SUBROUTINES CALLED :   NONE                                      */
*/*                                                                  */
*/* MACROS USED :   RELSTORE                                         */
*/*                                                                  */
*/********************************************************************/
*                                                                  0962
*FREEBUF:                                                          0962
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0962
FREEBUF  DS    0H                                                  0963
*   CRRRTN7=RTNREG;                 /* SAVE RETURN REGISTER          */
         ST    RTNREG,CRRRTN7(,CRRPTR)                             0963
*   RFY                                                            0964
*     FDBPTR RSTD;                                                 0964
*   FDBPTR=ADDR(FSBFDB);            /* ADDR OF FDB                   */
         LA    FDBPTR,FSBFDB(,FSBPTR)                              0965
*   FSBPTR=FDBPTR-FDBOFSET;         /* COMPUTE AREA TO FREE          */
         LR    FSBPTR,FDBPTR                                       0966
         SH    FSBPTR,FDBOFSET(,FDBPTR)                            0966
*   FSBPTR->FDBFDBA=FDBFDBA;        /* SET UP CHAIN OF FDB'S         */
         L     @15,FDBFDBA(,FDBPTR)                                0967
         ST    @15,FDBFDBA(,FSBPTR)                                0967
*   RFY                                                            0968
*     FDBPTR UNRSTD;                                               0968
*   IF PROCFTX=OFF THEN             /* NOT CONF TEXT                 */
*                                                                  0969
         L     @15,CRRFMCB(,CRRPTR)                                0969
         TM    PROCFTX+48(@15),B'00000001'                         0969
         BNZ   @RF00969                                            0969
*     /***************************************************************/
*     /*                                                             */
*     /* RELSTORE BUFADDR(FSBPTR)CHAIN(YES)                          */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0970
*     DO;                                                          0970
*                                                                  0970
*/* ATBUILD (ISTATCVT,ISTRPH)                                        */
*/* END OF ATBUILD                                                   */
*                                                                  0971
*       RFY                                                        0971
*        (GPR02P,                                                  0971
*         GPR03P,                                                  0971
*         GPR04P,                                                  0971
*         GPR15P) RSTD;                                            0971
*       RFY                                                        0972
*        (GPR01P,                                                  0972
*         GPR13P) RSTD;                                            0972
*       GENERATE REFS(GPR01P,GPR02P,GPR13P) SETS(RPHWORK);         0973
          STM GPR02P,GPR13P,RPHWORK(GPR01P)
*       RFY                                                        0974
*         GPR13P UNRSTD;                                           0974
*       GPR04P=FSBPTR;                                             0975
*       DCL                                                        0976
*         1 FMZA0102 FIXED(31) STATIC LOCAL,                       0976
*          2 * FIXED(8) INIT(80),                                  0976
*          2 * PTR(24) INIT(0);                                    0976
*       GPR03F=FMZA0102;                                           0977
         L     GPR03F,FMZA0102                                     0977
*       DO;                         /* LISATCVT                    0978
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*         GPR15P=ATCLCPTR;          /* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     0979
*       END;                        /* LISATCVT                      */
*       GPR02P=GPR15P->ATCBPDA;                                    0981
         L     GPR02P,ATCBPDA(,GPR15P)                             0981
*       GPR15P=GPR15P->ATCSMRS;                                    0982
         L     GPR15P,ATCSMRS(,GPR15P)                             0982
*       DCL                                                        0983
*         FMZL0102 BASED(GPR15P) LABEL VALUERANGE(*);              0983
*       CALL FMZL0102;                                             0984
         BALR  @14,@15                                             0984
*       RFY                                                        0985
*         GPR13P RSTD;                                             0985
*       GENERATE REFS(GPR01P,RPHWORK) SETS(GPR02P,GPR13P);         0986
          LM GPR02P,GPR13P,RPHWORK(GPR01P)
*       RFY                                                        0987
*        (GPR01P,                                                  0987
*         GPR13P) UNRSTD;                                          0987
*       RFY                                                        0988
*        (GPR02P,                                                  0988
*         GPR03P,                                                  0988
*         GPR04P,                                                  0988
*         GPR15P) UNRSTD;                                          0988
*     END;                          /* *********END OF RELSTORE    0989
*                                      EXPANSION*********            */
*   ELSE                                                           0990
*                                                                  0990
*     /***************************************************************/
*     /*                                                             */
*     /* RELSTORE BUFADDR(FSBPTR)CLEAR(YES)CHAIN(YES)                */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0990
*     DO;                                                          0990
*                                                                  0990
         B     @RC00969                                            0990
@RF00969 DS    0H                                                  0991
*/* ATBUILD (ISTATCVT,ISTRPH)                                        */
*/* END OF ATBUILD                                                   */
*                                                                  0991
*       RFY                                                        0991
*        (GPR02P,                                                  0991
*         GPR03P,                                                  0991
*         GPR04P,                                                  0991
*         GPR15P) RSTD;                                            0991
*       RFY                                                        0992
*        (GPR01P,                                                  0992
*         GPR13P) RSTD;                                            0992
*       GENERATE REFS(GPR01P,GPR02P,GPR13P) SETS(RPHWORK);         0993
          STM GPR02P,GPR13P,RPHWORK(GPR01P)
*       RFY                                                        0994
*         GPR13P UNRSTD;                                           0994
*       GPR04P=FSBPTR|'80000000'X;                                 0995
         LR    @05,FSBPTR                                          0995
         O     @05,@CF01547                                        0995
         LR    GPR04P,@05                                          0995
*       DCL                                                        0996
*         1 FMZA0118 FIXED(31) STATIC LOCAL,                       0996
*          2 * FIXED(8) INIT(80),                                  0996
*          2 * PTR(24) INIT(0);                                    0996
*       GPR03F=FMZA0118;                                           0997
         L     GPR03F,FMZA0118                                     0997
*       DO;                         /* LISATCVT                    0998
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*         GPR15P=ATCLCPTR;          /* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     0999
*       END;                        /* LISATCVT                      */
*       GPR02P=GPR15P->ATCBPDA;                                    1001
         L     GPR02P,ATCBPDA(,GPR15P)                             1001
*       GPR15P=GPR15P->ATCSMRS;                                    1002
         L     GPR15P,ATCSMRS(,GPR15P)                             1002
*       DCL                                                        1003
*         FMZL0118 BASED(GPR15P) LABEL VALUERANGE(*);              1003
*       CALL FMZL0118;                                             1004
         BALR  @14,@15                                             1004
*       RFY                                                        1005
*         GPR13P RSTD;                                             1005
*       GENERATE REFS(GPR01P,RPHWORK) SETS(GPR02P,GPR13P);         1006
          LM GPR02P,GPR13P,RPHWORK(GPR01P)
*       RFY                                                        1007
*        (GPR01P,                                                  1007
*         GPR13P) UNRSTD;                                          1007
*       RFY                                                        1008
*        (GPR02P,                                                  1008
*         GPR03P,                                                  1008
*         GPR04P,                                                  1008
*         GPR15P) UNRSTD;                                          1008
*     END;                          /* *********END OF RELSTORE    1009
*                                      EXPANSION*********            */
*   RTNREG=CRRRTN7;                 /* RESTORE RETURN REGISTER       */
@RC00969 L     RTNREG,CRRRTN7(,CRRPTR)                             1010
*   END FREEBUF;                                                   1011
@EL00008 DS    0H                                                  1011
@EF00008 DS    0H                                                  1011
@ER00008 BR    @14                                                 1011
*                                                                  1012
*/********************************************************************/
*/*                                                                  */
*/* ROUTINE NAME : MOVEDATA                                          */
*/*                                                                  */
*/* FUNCTION :                                                       */
*/*  MOVEDATA IS CALLED BY EITH READMAC OR WRTMAC TO MOVE DATA TO    */
*/*   USER BUFFERS. THE PARM LIST FOR THE MOVE ROUTINE, ISTDCC60,    */
*/*   HAS BEEN BUILT IN THE CRR BY THE CALLER.  IF THERE WAS NO      */
*/*   IS BUILT IN THE CRR USING INFORMATION FROM EITHER THE RPL      */
*/*   OR THE DCLCP.  THE DCLCP IS USED IF DATA TO BE MOVED WAS       */
*/*   SAVED FROM AN EARLIER REQUEST.                                 */
*/*                                                                  */
*/*  IF THERE WAS AN ERROR DURING THE MOVE, THE FSB IS QUEUED        */
*/*   TO THE FMCB DATA QUEUE.                                        */
*/*                                                                  */
*/* INPUT : FSBPTR REG(4) - ADDRESS OF FSB                           */
*/*                                                                  */
*/* OUTPUT : FSBPTR REG(4) - ADDRESS OF FSB                          */
*/*                                                                  */
*/* SUBROUTINES CALLED : ISTDCC60 - MOVE DATA TO USER BUFFERS        */
*/*                      XFRFSB   - QUEUE FSB TO FMCB DATA QUEUE     */
*/*                      TRUNC    _ PROCESS USER TRUNC OPTION        */
*/*                      KEEP     - PROCESS USER KEEP OPTION         */
*/*                                                                  */
*/* MACROS USED : VSETLCK, VMDESET                                   */
*/*                                                                  */
*/********************************************************************/
*                                                                  1012
*MOVEDATA:                                                         1012
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1012
MOVEDATA DS    0H                                                  1013
*   CRRRTN6=RTNREG;                 /* SAVE RETURN REG               */
         ST    RTNREG,CRRRTN6(,CRRPTR)                             1013
*   CRRBLDAD=ZEROWORD;              /* ZERO DATA LENGTH              */
         SLR   @15,@15                                             1014
         ST    @15,CRRBLDAD(,CRRPTR)                               1014
*   IF DCLIOBUF=ZEROWORD THEN       /* NO USER BUFFER                */
         L     @05,CRRLCPB(,CRRPTR)                                1015
         C     @15,DCLIOBUF(,@05)                                  1015
         BNE   @RF01015                                            1015
*     DO;                           /* USE RPL BUFFER                */
*       IF DCLRQTP=DCLWRITE         /* WRITE REQUEST         @DM09829*/
*           &RPLWROPT=ON THEN       /* WRITE CONV?           @DM09257*/
         CLI   DCLRQTP(@05),X'11'                                  1017
         BNE   @RF01017                                            1017
         L     @15,CRRARPL(,CRRPTR)                                1017
         TM    RPLWROPT(@15),B'00000001'                           1017
         BNO   @RF01017                                            1017
*         DO;                                                      1018
*           CRRBARAD=RPLAAREA;      /* ALT ADDRESS           @DM09257*/
         L     @05,RPLAAREA(,@15)                                  1019
         ST    @05,CRRBARAD(,CRRPTR)                               1019
*           CRRBLEN=RPLAARLN;       /* LENGTH OF ALT ADDR    @DM09257*/
         L     @15,RPLAARLN(,@15)                                  1020
         STH   @15,CRRBLEN(,CRRPTR)                                1020
*         END;                                                     1021
*       ELSE                                                       1022
*         DO;                                                      1022
         B     @RC01017                                            1022
@RF01017 DS    0H                                                  1023
*           CRRBARAD=RPLAREA;       /* ADDRESS OF USER AREA          */
         L     @15,CRRARPL(,CRRPTR)                                1023
         L     @05,RPLAREA(,@15)                                   1023
         ST    @05,CRRBARAD(,CRRPTR)                               1023
*           CRRBLEN=RPLBUFL;        /* LENGTH OF USER BUFFER         */
         L     @15,RPLBUFL(,@15)                                   1024
         STH   @15,CRRBLEN(,CRRPTR)                                1024
*         END;                                                     1025
*       CRRBTLEN=ZEROWORD;          /* ZERO DATA LENGTH              */
@RC01017 SLR   @15,@15                                             1026
         ST    @15,CRRBTLEN(,CRRPTR)                               1026
*     END;                                                         1027
*   ELSE                                                           1028
*     DO;                           /* DATA IS PARTIALLY MOVED       */
         B     @RC01015                                            1028
@RF01015 DS    0H                                                  1029
*       CRRBARAD=DCLIOBUF;          /* ADDRESS OF OLD BUFFER         */
         L     @15,CRRLCPB(,CRRPTR)                                1029
         L     @05,DCLIOBUF(,@15)                                  1029
         ST    @05,CRRBARAD(,CRRPTR)                               1029
*       CRRBLEN=DCLIOLEN;           /* LENGTH OF BUFFER              */
         LH    @05,DCLIOLEN(,@15)                                  1030
         STH   @05,CRRBLEN(,CRRPTR)                                1030
*       CRRBTLEN=DCLBTLEN;          /* TOTAL DATA LENGTH             */
         L     @15,DCLBTLEN(,@15)                                  1031
         ST    @15,CRRBTLEN(,CRRPTR)                               1031
*     END;                                                         1032
*                                                                  1032
*   /*****************************************************************/
*   /*                                                               */
*   /* CHANGE TO KEY 0 AND OBTAIN LOCAL MEMORY LOCK                  */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1033
*                                                                  1033
*/*VMDESET  ((15),ZERO)                                              */
*                                                                  1033
*   DO;                             /* INVOKE MODESET MACRO          */
@RC01015 DS    0H                                                  1034
*     GEN;                                                         1034
         MODESET EXTKEY=ZERO,WORKREG=2
*     RFY                                                          1035
*      (GPR15P) RSTD;                                              1035
*     GPR15F=0;                                                    1036
         SLR   GPR15F,GPR15F                                       1036
*     RFY                                                          1037
*      (GPR15P) UNRSTD;             /* PUT RETURN CODE IN RCREG      */
*   END;                            /* VMDESET                       */
*/*VSETLCK  (15,OBTAIN,LOCAL,(LOCAL,ISTDCC50(UNLOCK)),)              */
*                                                                  1039
*LOCK:                                                             1039
*   DO;                             /* DECLARE AND RESTRICT REGS   1039
*                                      2,10,11,12,13,14, AND 15      */
LOCK     DS    0H                                                  1040
*     RFY                                                          1040
*      (GPR02P,                                                    1040
*       GPR10P,                                                    1040
*       GPR11P,                                                    1040
*       GPR12P,                                                    1040
*       GPR13P,                                                    1040
*       GPR14P,                                                    1040
*       GPR15P) RSTD;               /* SAVE REGS 2 AND 10 THRU 14    */
*     GEN REFS(GPR02F,GPR10F,GPR11F,GPR12F,GPR14F,GPR13P);         1041
         STM   GPR10F,GPR12F,0(GPR13P)
         ST    GPR14F,12(GPR13P)
         ST    GPR02F,16(GPR13P)
*                                   /* INVOKE MODESET TO CHANGE PSW
*                                      PROTECTION KEY TO 0           */
*     GEN SETS(2);                                                 1042
         MODESET EXTKEY=ZERO,SAVEKEY=(2),WORKREG=2
*     GPR10P=GPR13P;                /* PUT SAVE AREA ADDR IN R 10  1043
*                                      INVOKE OS/VS SETLOCK MACRO    */
         LR    GPR10P,GPR13P                                       1043
*     GEN REFS(GPR13P,PSALITA,FLC) SETS(GPR12F);                   1044
         SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,                        *
               RELATED=(LOCAL,ISTDCC50(UNLOCK))
*     GPR15P=GPR13P;                /* PUT RETURN CODE IN R 15 INVOKE
*                                      MODESET MACRO TO              */
         LR    GPR15P,GPR13P                                       1045
*     DO;                           /* RESTORE PSW PROTECTION KEY    */
*       GEN SETS(2);                                               1047
         MODESET KEYADDR=(2),WORKREG=2
*     END;                          /* RESTORE REGISTERS             */
*     GEN REFS(GPR10F,GPR13P) SETS(GPR10F,GPR11F,GPR12F,GPR13F,GPR14F,
*         GPR02F);                                                 1049
         LR    GPR13F,GPR10F
         LM    GPR10F,GPR12F,0(GPR13P)
         L     GPR14F,12(GPR13P)
         L     GPR02F,16(GPR13P)
*     IF GPR15F=4 THEN                                             1050
         C     GPR15F,@CF00044                                     1050
         BNE   @RF01050                                            1050
*       GPR15F=0;                                                  1051
         SLR   GPR15F,GPR15F                                       1051
*     RFY                                                          1052
*      (GPR02P,                                                    1052
*       GPR10P,                                                    1052
*       GPR11P,                                                    1052
*       GPR12P,                                                    1052
*       GPR13P,                                                    1052
*       GPR14P,                                                    1052
*       GPR15P) UNRSTD;                                            1052
@RF01050 DS    0H                                                  1053
*   END;                            /* LOCK:VSETLCK                  */
*                                                                  1053
*   /*****************************************************************/
*   /*                                                               */
*   /* MOVE DATA TO USER'S BUFFERS                                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1054
*   RFY                                                            1054
*     CVTPTR RSTD;                  /* RESTRICT PTR TO ATCVT         */
*   CVTPTR=CRRATCVT;                /* SET PTR TO ATCVT              */
         L     CVTPTR,CRRATCVT(,CRRPTR)                            1055
*   CRRPTR=ADDR(CRRSAVE1);          /* PASS MOVE ADDR OF SAVE AREA   */
         LA    @15,CRRSAVE1(,CRRPTR)                               1056
         LR    CRRPTR,@15                                          1056
*   CALL MOVE60;                    /* MOVE DATA TO USER AREA        */
         L     @15,ATCDCC60(,CVTPTR)                               1057
         BALR  @14,@15                                             1057
*   CRRPTR=ADDR(CRRSPACE);          /* REESTABILSH BASE      @ZA31577*/
         L     CRRPTR,RPHCRR(,RPHPTR)                              1058
         LA    CRRPTR,CRRSPACE+312(,CRRPTR)                        1058
*   DCLIOBUF=0;                     /* RESET THE LCPB BUFFER @ZA24575*/
         SLR   @15,@15                                             1059
         L     @05,CRRLCPB(,CRRPTR)                                1059
         ST    @15,DCLIOBUF(,@05)                                  1059
*   DCLIOLEN=0;                     /* LENGTH INDICATORS FOR @ZA24575*/
         STH   @15,DCLIOLEN(,@05)                                  1060
*   DCLBTLEN=0;                     /* REUSE OF LCPB.        @ZA24575*/
         ST    @15,DCLBTLEN(,@05)                                  1061
*   RFY                                                            1062
*     CVTPTR UNRSTD;                /* UNRESTRICT PTR TO ATCVT       */
*   IF RPLWROPT=ON&                 /* WRITE CONVERSATIONAL          */
*       DCLRQTP=DCLWRITE THEN       /* REQUEST IS FOR WRITE          */
         L     @15,CRRARPL(,CRRPTR)                                1063
         TM    RPLWROPT(@15),B'00000001'                           1063
         BNO   @RF01063                                            1063
         CLI   DCLRQTP(@05),X'11'                                  1063
         BNE   @RF01063                                            1063
*     RPLARCLN=CRRBTLEN;            /* SET LENGTH OF DATA MOVED      */
         L     @05,CRRBTLEN(,CRRPTR)                               1064
         ST    @05,RPLARCLN(,@15)                                  1064
*   ELSE                                                           1065
*     RPLRLEN=CRRBTLEN;             /* SET LENGTH MOVED FOR READ   1065
*                                      COMMAND                       */
*                                                                  1065
         B     @RC01063                                            1065
@RF01063 L     @15,CRRARPL(,CRRPTR)                                1065
         L     @05,CRRBTLEN(,CRRPTR)                               1065
         ST    @05,RPLRLEN(,@15)                                   1065
*   /*****************************************************************/
*   /*                                                               */
*   /* RELEASE LOCAL MEMORY LOCK AND CHANGE TO KEY 6                 */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1066
*/*VSETLCK  (15,RELEASE,LOCAL,(LOCAL,ISTDCC50(LOCK)),)               */
*                                                                  1066
*UNLOCK:                                                           1066
*   DO;                             /* DECLARE AND RESTRICT REGS   1066
*                                      2,10,11,12,13,14, AND 15      */
@RC01063 DS    0H                                                  1066
UNLOCK   DS    0H                                                  1067
*     RFY                                                          1067
*      (GPR02P,                                                    1067
*       GPR10P,                                                    1067
*       GPR11P,                                                    1067
*       GPR12P,                                                    1067
*       GPR13P,                                                    1067
*       GPR14P,                                                    1067
*       GPR15P) RSTD;               /* SAVE REGS 2 AND 10 THRU 14    */
*     GEN REFS(GPR02F,GPR10F,GPR11F,GPR12F,GPR14F,GPR13P);         1068
         STM   GPR10F,GPR12F,0(GPR13P)
         ST    GPR14F,12(GPR13P)
         ST    GPR02F,16(GPR13P)
*                                   /* INVOKE MODESET TO CHANGE PSW
*                                      PROTECTION KEY TO 0           */
*     GEN SETS(2);                                                 1069
         MODESET EXTKEY=ZERO,SAVEKEY=(2),WORKREG=2
*     GPR10P=GPR13P;                /* PUT SAVE AREA ADDR IN R 10  1070
*                                      INVOKE OS/VS SETLOCK MACRO    */
         LR    GPR10P,GPR13P                                       1070
*     GEN REFS(GPR13P,PSALITA,FLC) SETS(GPR12F);                   1071
         SETLOCK RELEASE,TYPE=LOCAL,                                   *
               RELATED=(LOCAL,ISTDCC50(LOCK))
*     GPR15P=GPR13P;                /* PUT RETURN CODE IN R 15 INVOKE
*                                      MODESET MACRO TO              */
         LR    GPR15P,GPR13P                                       1072
*     DO;                           /* RESTORE PSW PROTECTION KEY    */
*       GEN SETS(2);                                               1074
         MODESET KEYADDR=(2),WORKREG=2
*     END;                          /* RESTORE REGISTERS             */
*     GEN REFS(GPR10F,GPR13P) SETS(GPR10F,GPR11F,GPR12F,GPR13F,GPR14F,
*         GPR02F);                                                 1076
         LR    GPR13F,GPR10F
         LM    GPR10F,GPR12F,0(GPR13P)
         L     GPR14F,12(GPR13P)
         L     GPR02F,16(GPR13P)
*     IF GPR15F=4 THEN                                             1077
         C     GPR15F,@CF00044                                     1077
         BNE   @RF01077                                            1077
*       GPR15F=0;                                                  1078
         SLR   GPR15F,GPR15F                                       1078
*     RFY                                                          1079
*      (GPR02P,                                                    1079
*       GPR10P,                                                    1079
*       GPR11P,                                                    1079
*       GPR12P,                                                    1079
*       GPR13P,                                                    1079
*       GPR14P,                                                    1079
*       GPR15P) UNRSTD;                                            1079
@RF01077 DS    0H                                                  1080
*   END;                            /* UNLOCK:VSETLCK                */
*/*VMDESET  ((15),ATCAM)                                             */
*                                                                  1081
*   DO;                             /* INVOKE MODESET MACRO          */
*     GEN;                                                         1082
         MODESET EXTKEY=VTAM,WORKREG=2
*     RFY                                                          1083
*      (GPR15P) RSTD;                                              1083
*     GPR15F=0;                                                    1084
         SLR   GPR15F,GPR15F                                       1084
*     RFY                                                          1085
*      (GPR15P) UNRSTD;             /* PUT RETURN CODE IN RCREG      */
*   END;                            /* VMDESET                       */
*   IF CRRBRTCD=CRRBEROR THEN       /* ERROR DURING MOVE             */
         CLI   CRRBRTCD(CRRPTR),8                                  1087
         BNE   @RF01087                                            1087
*     DO;                                                          1088
*                                                                  1088
*       /*************************************************************/
*       /*                                                           */
*       /* ERROR-NO DATA MOVED                                       */
*       /*                                                           */
*       /*************************************************************/
*                                                                  1089
*       CRRPOST=ON;                 /* SET DO POST SWITCH            */
         OI    CRRPOST(CRRPTR),B'00010000'                         1089
*       CALL XFRFSB;                /* SAVE FSB ON FMCB DATA Q       */
         BAL   @14,XFRFSB                                          1090
*     END;                                                         1091
*   ELSE                                                           1092
*     IF PROTRUNC=ON THEN           /* TRUNC SPECIFIED               */
*                                                                  1092
         B     @RC01087                                            1092
@RF01087 L     @15,CRRFMCB(,CRRPTR)                                1092
         TM    PROTRUNC+48(@15),B'01000000'                        1092
         BNO   @RF01092                                            1092
*       /*************************************************************/
*       /*                                                           */
*       /* TRUNC PROCESSING                                          */
*       /*                                                           */
*       /*************************************************************/
*                                                                  1093
*       CALL TRUNC;                 /* PROCESS TRUNC OPTION          */
         BAL   @14,TRUNC                                           1093
*     ELSE                                                         1094
*                                                                  1094
*       /*************************************************************/
*       /*                                                           */
*       /* KEEP PROCESSING                                           */
*       /*                                                           */
*       /*************************************************************/
*                                                                  1094
*       CALL KEEP;                  /* PROCESS KEEP OPTION           */
         B     @RC01092                                            1094
@RF01092 BAL   @14,KEEP                                            1094
*   RTNREG=CRRRTN6;                 /* RESTORE RETURN REG            */
@RC01092 DS    0H                                                  1095
@RC01087 L     RTNREG,CRRRTN6(,CRRPTR)                             1095
*   END MOVEDATA;                                                  1096
@EL00009 DS    0H                                                  1096
@EF00009 DS    0H                                                  1096
@ER00009 BR    @14                                                 1096
*                                                                  1097
*/********************************************************************/
*/*                                                                  */
*/* ROUTINE NAME : FLUSH                                             */
*/*                                                                  */
*/* FUNCTION :                                                       */
*/*  IF EOB IS INDICATED IN THE FSB, OR END OF CHANNEL PROGRAM       */
*/*   IS REACHED FLUSHING IS ENDED.  THE FSB AND FDBS ARE FREED      */
*/*   BY CALLING THE FREEBUF SUBROUTINE. IF THE ERROR LOCK IS SET    */
*/*   AN INTERNAL RESET ERROR LOCK IS ISSUED.                        */
*/*                                                                  */
*/* INPUT : FSBPTR REG(4) - ADDRESS OF FSB                           */
*/*                                                                  */
*/* OUTPUT :  SAME                                                   */
*/*                                                                  */
*/* SUBROUTINES CALLED : EOBANAL  - CHECK FOR ENDING STATUS          */
*/*                      FREEBUF  - FREE FSB AND FDB BUFFERS         */
*/*                      LCPBINIT - BUILD AND SCHEDULE RESET DCLCP   */
*/* MACROS USED : TPDEQ                                              */
*/*                                                                  */
*/********************************************************************/
*                                                                  1097
*FLUSH:                                                            1097
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1097
FLUSH    DS    0H                                                  1098
*   CRRRTN1=RTNREG;                 /* SAVE RETURN REG               */
         ST    RTNREG,CRRRTN1(,CRRPTR)                             1098
*   CRRSW4=OFF;                     /* INDICATE FLUSH OCCURRED       */
         NI    CRRSW4(CRRPTR),B'11110111'                          1099
*   CALL EOBANAL;                   /* CHECK FOR ENDING CONDITION    */
         BAL   @14,EOBANAL                                         1100
*   IF FSBMNELI=ON THEN             /* ERROR LOCK SET IN FSB?        */
*                                                                  1101
         TM    FSBMNELI(FSBPTR),B'10000000'                        1101
         BNO   @RF01101                                            1101
*     /***************************************************************/
*     /*                                                             */
*     /* ERROR LOCK SET                                              */
*     /*                                                             */
*     /***************************************************************/
*                                                                  1102
*     CRRSW5=ON;                    /* YES, INDICATE SO              */
         OI    CRRSW5(CRRPTR),B'00000100'                          1102
*   IF FSBEBI=ON|                   /* END OF BLOCK?                 */
*       FSBELI=ON THEN              /* END OF PROGRAM?               */
@RF01101 TM    FSBEBI(FSBPTR),B'10100000'                          1103
         BZ    @RF01103                                            1103
*     DO;                                                          1104
*                                                                  1104
*       /*************************************************************/
*       /*                                                           */
*       /* FLUSH FINISHED                                            */
*       /*                                                           */
*       /*************************************************************/
*                                                                  1105
*       RFY                                                        1105
*        (REG2,                                                    1105
*         REG3) RSTD;                                              1105
*CS6:                                                              1106
*       REG2=FMCCMPS2;              /* REFERENCE FLAG VALUE          */
CS6      L     @15,CRRFMCB(,CRRPTR)                                1106
         L     REG2,FMCCMPS2(,@15)                                 1106
*       REG3=REG2&FLGA3OFF;         /* RESET FLUSH FLAG              */
         LR    REG3,REG2                                           1107
         N     REG3,@CF01563                                       1107
*       CS(REG2,REG3,FMCCMPS2);     /* SET NEW VALUE IN FMCB         */
         CS    REG2,@03,FMCCMPS2(@15)                              1108
*       BC(7,CS6);                  /* TRY AGAIN IF FAILURE          */
         BC    7,CS6                                               1109
*       RFY                                                        1110
*        (REG2,                                                    1110
*         REG3) UNRSTD;                                            1110
*     END;                                                         1111
*   ELSE                                                           1112
*     ;                             /* KEEP FLUSHING                 */
@RF01103 DS    0H                                                  1113
*   IF CRRSW6=ON THEN               /* WAS FSB QUEUED ON DATA Q?     */
         TM    CRRSW6(CRRPTR),B'00000010'                          1113
         BNO   @RF01113                                            1113
*     DO;                                                          1114
*                                                                  1114
*       /*************************************************************/
*       /*                                                           */
*       /* DEQUEUE FSB WHICH WAS QUEUED BY XFRFSB AND SET BUFFER     */
*       /* COUNT TO ZERO                                             */
*       /*                                                           */
*       /*************************************************************/
*                                                                  1115
*/* TPDEQ (,FMCFBA) RETPTR(FSBPTR)                                   */
*                                                                  1115
*       DO;                         /* BEGIN TPDEQ CODE GENERATION   */
*         RFY                                                      1116
*          (GPR00P,                                                1116
*           GPR01P,                                                1116
*           GPR14P,                                                1116
*           GPR15P) RSTD;                                          1116
*         GPR15P=ADDR(FMCFBA);      /* ADDRESS QUEUE POINTER         */
         L     GPR15P,CRRFMCB(,CRRPTR)                             1117
         LA    GPR15P,FMCFBA(,GPR15P)                              1117
*         GPR14P=GPR15P->PABWEQA|FMZCA070;                         1118
         L     @05,@CF01547                                        1118
         L     GPR14P,PABWEQA(,GPR15P)                             1118
         OR    GPR14P,@05                                          1118
*         IF GPR14P=FMZCA070 THEN                                  1119
         CLR   GPR14P,@05                                          1119
         BE    @RT01119                                            1119
*           ;                                                      1120
*         ELSE                                                     1121
*           DO;                                                    1121
*FMZL1146:                                                         1122
*             ;                                                    1122
FMZL1146 DS    0H                                                  1123
*             DO WHILE(GPR14P->WKECHAIN^=FMZCA070);                1123
         B     @DE01123                                            1123
@DL01123 DS    0H                                                  1124
*               GPR15P=ADDR(GPR14P->WKECHAIN);                     1124
         LA    GPR15P,WKECHAIN(,GPR14P)                            1124
*               GPR14P=GPR15P->PABWEQA;                            1125
         L     GPR14P,PABWEQA(,GPR15P)                             1125
*             END;                                                 1126
@DE01123 L     @05,@CF01547                                        1126
         CL    @05,WKECHAIN(,GPR14P)                               1126
         BNE   @DL01123                                            1126
*             GPR00P=FMZCA070;                                     1127
         LR    GPR00P,@05                                          1127
*             CS(GPR14P,GPR00P,GPR15P->PABWEQA);                   1128
         CS    GPR14P,@00,PABWEQA(GPR15P)                          1128
*             BC(7,FMZL1146);                                      1129
         BC    7,FMZL1146                                          1129
*             GPR14P->WKECHAIN=0;                                  1130
         SLR   @05,@05                                             1130
         ST    @05,WKECHAIN(,GPR14P)                               1130
*           END;                                                   1131
*ISTA0146:                                                         1132
*         ;                                                        1132
@RT01119 DS    0H                                                  1132
ISTA0146 DS    0H                                                  1133
*         GPR14P=GPR14P&FMZCB070;                                  1133
         N     GPR14P,@CF01545                                     1133
*         FSBPTR=GPR14P;                                           1134
         LR    FSBPTR,GPR14P                                       1134
*         RFY                                                      1135
*          (GPR00P,                                                1135
*           GPR01P,                                                1135
*           GPR14P,                                                1135
*           GPR15P) UNRSTD;                                        1135
*       END;                        /* END TPDEQ GENERATION DEQUE FSB*/
*       RFY                                                        1137
*        (REG2,                                                    1137
*         REG3) RSTD;                                              1137
*CS7:                                                              1138
*       REG2=FMCCMPS1;              /* GET CURRENT BUFFER COUNT      */
CS7      L     @15,CRRFMCB(,CRRPTR)                                1138
         L     REG2,FMCCMPS1(,@15)                                 1138
*       REG3=REG2&BUFNB0;           /* SET COUNT TO ZERO             */
         LR    REG3,REG2                                           1139
         N     REG3,@CF04668                                       1139
*       CS(REG2,REG3,FMCCMPS1);     /* SET NEW COUNT IN FMCB         */
         CS    REG2,@03,FMCCMPS1(@15)                              1140
*       BC(7,CS7);                  /* TRY AGAIN IF FAILURE          */
         BC    7,CS7                                               1141
*       RFY                                                        1142
*        (REG2,                                                    1142
*         REG3) UNRSTD;                                            1142
*       IF FSBPTR^=ZEROWORD&FSBPTR^=GATEBIT THEN/* WAS FSB DEQUED?   */
         LTR   FSBPTR,FSBPTR                                       1143
         BZ    @RF01143                                            1143
         CL    FSBPTR,@CF01547                                     1143
         BE    @RF01143                                            1143
*         CALL FREEBUF;             /* YES, RELEASE IT               */
         BAL   @14,FREEBUF                                         1144
*       ELSE                                                       1145
*         ;                         /* NO FSB ON DATA Q              */
@RF01143 DS    0H                                                  1146
*     END;                                                         1146
*   ELSE                                                           1147
*     CALL FREEBUF;                 /* FREE CURRENT FSB              */
         B     @RC01113                                            1147
@RF01113 BAL   @14,FREEBUF                                         1147
*   IF CRRSW5=ON THEN               /* WAS ERROR LOCK SET?           */
*                                                                  1148
@RC01113 TM    CRRSW5(CRRPTR),B'00000100'                          1148
         BNO   @RF01148                                            1148
*     /***************************************************************/
*     /*                                                             */
*     /* IF THE ERROR LOCK IS SET IN THE FSB BEING FLUSHED, THE ERROR*/
*     /* LOCK MUST BE RESET INTERNALLY SINCE THE USER WILL NOT KNOW  */
*     /* IT IS SET. CALL LCPBINIT TO GET STORAGE FOR A LCPB. BUILD   */
*     /* RESET ERROR LOCK AND QUEUE TO TPIOS OUTBOUND PAB WITH RESET */
*     /* OPTION.                                                     */
*     /*                                                             */
*     /***************************************************************/
*                                                                  1149
*     CALL LCPBINIT;                /* GET LCPB FOR RESET            */
         BAL   @14,LCPBINIT                                        1149
*   ELSE                                                           1150
*     ;                             /* ERROR LOCK NOT SET            */
@RF01148 DS    0H                                                  1151
*   RTNREG=CRRRTN1;                 /* RESTORE RETURN REG            */
         L     RTNREG,CRRRTN1(,CRRPTR)                             1151
*   END FLUSH;                                                     1152
@EL00010 DS    0H                                                  1152
@EF00010 DS    0H                                                  1152
@ER00010 BR    @14                                                 1152
*                                                                  1153
*/********************************************************************/
*/*                                                                  */
*/* ROUTINE NAME : TRUNC                                             */
*/*                                                                  */
*/*  FUNCTITION :                                                    */
*/* TRUNC IS CALLED BY MOVEDATA TO PROCESS THE USER TRUNCATE         */
*/* OPTION.  IF THERE WAS NO ERROR IN THE MOVE, SUBROUTINE           */
*/* TRUNC1 IS CALLED.   ON RETURN FROM TRUNC1, THE FSB AND FDBS      */
*/* ARE FREED AND THE SUBROUTINE RETURNS TO MOVEDATA.                */
*/*                                                                  */
*/* IF THERE WAS AN ERROR DURING THE MOVE, ERROR FLGAS ARE SET IN    */
*/* THE CRR(CRRTRUN AND CRRLOGIC).  THE DO POST SWITCH,              */
*/* CRRPOST, IS SET AND SUBROUTINE EOBANAL IS CALLED.  IF            */
*/* EOB WAS NOT RECEIVED, THE FLUSH BIT IS SET.  IN EITHER           */
*/* CASE, THE FSB AND FDBS ARE FREED AND THE ROUTINE                 */
*/* RETURNS TO MOVEDATA VIA REG 14.                                  */
*/*                                                                  */
*/* INPUT :  FSBPTR REG(4) - ADDRESS OF FSB                          */
*/*                                                                  */
*/* OUTPUT : SAME                                                    */
*/*                                                                  */
*/* SUBROUTINES CALLED : EOBANAL  - CHECK FOR ENDING STATUS          */
*/*                      TRUNC1   - MORE TRUNC PROCESSING NECESSARY  */
*/* MACROS USED : NONE                                               */
*/*                                                                  */
*/********************************************************************/
*                                                                  1153
*TRUNC:                                                            1153
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1153
TRUNC    DS    0H                                                  1154
*   CRRRTN3=RTNREG;                 /* SAVE RETURN REG               */
         ST    RTNREG,CRRRTN3(,CRRPTR)                             1154
*   IF CRRBRTCD=CRRBRSUC THEN       /* RETURN CODE FROM MOVE OK      */
*                                                                  1155
         CLI   CRRBRTCD(CRRPTR),0                                  1155
         BNE   @RF01155                                            1155
*     /***************************************************************/
*     /*                                                             */
*     /* ALL THE DATA FROM ONE FSB MOVED                             */
*     /*                                                             */
*     /***************************************************************/
*                                                                  1156
*     CALL TRUNC1;                                                 1156
         BAL   @14,TRUNC1                                          1156
*   ELSE                                                           1157
*     DO;                                                          1157
*                                                                  1157
         B     @RC01155                                            1157
@RF01155 DS    0H                                                  1158
*       /*************************************************************/
*       /*                                                           */
*       /* DATA TRUNCATED                                            */
*       /*                                                           */
*       /*************************************************************/
*                                                                  1158
*                                   /* D31JKMQ                       */
*       CRRPOST=ON;                 /* SET DO POST SWITCH            */
         OI    CRRPOST(CRRPTR),B'00010000'                         1158
*       CALL EOBANAL;               /* CHECK FOR EOB, EOM, EOT       */
         BAL   @14,EOBANAL                                         1159
*       IF FSBEBI=ON|               /* EOM,EOT,EOB                   */
*           FSBLGI=ON|              /* LEADING GRAPHICS?             */
*           FSBSOHI=ON|             /* START OF HEADING (SOH)      1160
*                                      INDICATOR                     */
*           FSBMJRCD^=FRNORM THEN                                  1160
         TM    FSBEBI(FSBPTR),B'00100011'                          1160
         BNZ   @RT01160                                            1160
         CLI   FSBMJRCD(FSBPTR),X'00'                              1160
         BNE   @RT01160                                            1160
*         ;                         /* ERROR CODE IN FSB?            */
*       ELSE                                                       1162
*         DO;                                                      1162
*                                                                  1162
*           /*********************************************************/
*           /*                                                       */
*           /* SUBBLOCK-INDICATE REMAINING SUBBLOCKS SHOULD BE       */
*           /* FLUSHED AS THEY ARRIVE                                */
*           /*                                                       */
*           /*********************************************************/
*                                                                  1163
*           RFY                                                    1163
*            (REG2,                                                1163
*             REG3) RSTD;                                          1163
*CS8:                                                              1164
*           REG2=FMCCMPS2;          /* REFERENCE FLAG VALUE          */
CS8      L     @15,CRRFMCB(,CRRPTR)                                1164
         L     REG2,FMCCMPS2(,@15)                                 1164
*           REG3=REG2|FLGA3ON;      /* SET FLUSH INDICATOR           */
         LR    REG3,REG2                                           1165
         O     REG3,@CF01565                                       1165
*           CS(REG2,REG3,FMCCMPS2); /* SET NEW VALUE IN FMCB         */
         CS    REG2,@03,FMCCMPS2(@15)                              1166
*           BC(7,CS8);              /* TRY AGAIN IF FAILURE          */
         BC    7,CS8                                               1167
*           RFY                                                    1168
*            (REG2,                                                1168
*             REG3) UNRSTD;                                        1168
*         END;                                                     1169
*     END;                                                         1170
@RT01160 DS    0H                                                  1171
*   CALL FREEBUF;                   /* FREE FSB AND FDBS             */
@RC01155 BAL   @14,FREEBUF                                         1171
*   RTNREG=CRRRTN3;                 /* RESTORE RETURN REG            */
         L     RTNREG,CRRRTN3(,CRRPTR)                             1172
*   END TRUNC;                                                     1173
@EL00011 DS    0H                                                  1173
@EF00011 DS    0H                                                  1173
@ER00011 BR    @14                                                 1173
*                                                                  1174
*/********************************************************************/
*/*                                                                  */
*/* ROUTINE NAME : TRUNC1                                            */
*/*                                                                  */
*/* FUNCTION:                                                        */
*/* TRUNC1 IS CALLED BY TRUNC IF THE USER SPECIFIED THE TRUNC        */
*/* OPTION AND NO ERROR CODE WAS RETURNED BY THE MOVE ROUTINE.       */
*/* IF EOB WAS NOT RECEIVED IN THE FSB AND THERE IS MORE SPACE       */
*/* IN THE USER AREA, THE BUFFER INFORMATION IS MOVED FROM THE       */
*/* CRR TO THE DCLCP AND THE RPL PTR IS PUT BACK IN THE DCLCP.       */
*/* IF THERE IS NO SPACE LEFT IN THE USER AREA, ERROR INDICATORS     */
*/* (CRRTRUN AND CRRLOGIC) ARE SET IN THE CRR.  THE FLUSH BIT        */
*/* IS SET TO FREE THE FSB AND FDBS.  THE SUBROUTINE RETURNS TO      */
*/*                                                                  */
*/* INPUT :  FSBPTR REG(4) - ADDRESS OF FSB                          */
*/*                                                                  */
*/* OUTPUT : SAME                                                    */
*/*                                                                  */
*/* SUBROUTINES CALLED : EOBANAL  - CHECK FOR ENDING STATUS          */
*/*                                                                  */
*/* MACROS USED :  NONE                                              */
*/*                                                                  */
*/********************************************************************/
*                                                                  1174
*TRUNC1:                                                           1174
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1174
TRUNC1   DS    0H                                                  1175
*   CRRRTN4=RTNREG;                 /* SAVE RETURN REG               */
         ST    RTNREG,CRRRTN4(,CRRPTR)                             1175
*   CALL EOBANAL;                   /* CHECK FOR EOM,EOB,EOT         */
         BAL   @14,EOBANAL                                         1176
*   IF FSBEBI=ON|FSBECI=ON|         /* EOM,EOB,EOT           @OX11109*/
*       FSBLGI=ON|                  /* LEADING GRAPHICS IN FSB       */
*       FSBSOHI=ON|                 /* START OF HEADING(SOH)INDICATOR*/
*       FSBMJRCD^=FRNORM THEN       /* ERROR RETURN CODE IN FSB      */
*                                                                  1177
         TM    FSBEBI(FSBPTR),B'01100011'                          1177
         BNZ   @RT01177                                            1177
         CLI   FSBMJRCD(FSBPTR),X'00'                              1177
         BE    @RF01177                                            1177
@RT01177 DS    0H                                                  1178
*     /***************************************************************/
*     /*                                                             */
*     /* ENDING STATUS IN FSB-DO NOT EXPECT ANOTHER FSB. PROCESSING  */
*     /* FINISHED                                                    */
*     /*                                                             */
*     /***************************************************************/
*                                                                  1178
*     CRRPOST=ON;                   /* SET DO POST SWITCH            */
         OI    CRRPOST(CRRPTR),B'00010000'                         1178
*   ELSE                                                           1179
*     IF CRRBLEN>ZEROWORD THEN      /* MORE SPACE IN USER DATA AREA  */
         B     @RC01177                                            1179
@RF01177 LH    @15,CRRBLEN(,CRRPTR)                                1179
         LTR   @15,@15                                             1179
         BNP   @RF01179                                            1179
*       IF CRRERLK=ON THEN          /* TEST FOR ERROR LOCK           */
*                                                                  1180
         TM    CRRERLK(CRRPTR),B'10000000'                         1180
         BNO   @RF01180                                            1180
*         /***********************************************************/
*         /*                                                         */
*         /* ERROR LOCK SET IN FSB JUST PROCESSED. PROCESSING        */
*         /* FINISHED                                                */
*         /*                                                         */
*         /***********************************************************/
*                                                                  1181
*         CRRPOST=ON;               /* POST USET WITH ERR LOCK       */
         OI    CRRPOST(CRRPTR),B'00010000'                         1181
*       ELSE                                                       1182
*         DO;                       /* ERROR LOCK NOT SET            */
*                                                                  1182
         B     @RC01180                                            1182
@RF01180 DS    0H                                                  1183
*           /*********************************************************/
*           /*                                                       */
*           /* FSB JUST PROCESSED WAS A SUBBLOCK AND THERE IS MORE   */
*           /* ROOM IN THE USER'S BUFFER. SAVE STATUS IN LCPB TO     */
*           /* RESUME MOVE WHEN NEXT FSB ARRIVES                     */
*           /*                                                       */
*           /*********************************************************/
*                                                                  1183
*           DCLIOBUF=CRRBARAD;      /* MOVE ADDR OF NEXT AVAIL SPACE
*                                      IN USER BUFFER TO DCLCP     1183
*                                      EXTENSION                     */
         L     @15,CRRLCPB(,CRRPTR)                                1183
         L     @05,CRRBARAD(,CRRPTR)                               1183
         ST    @05,DCLIOBUF(,@15)                                  1183
*           DCLIOLEN=CRRBLEN;       /* MOVE RESIDUAL COUNT TO DCLCP  */
         LH    @05,CRRBLEN(,CRRPTR)                                1184
         STH   @05,DCLIOLEN(,@15)                                  1184
*           DCLBTLEN=CRRBTLEN;      /* PUT LENGTH MOVED IN DCLCP     */
         L     @05,CRRBTLEN(,CRRPTR)                               1185
         ST    @05,DCLBTLEN(,@15)                                  1185
*           DCLRPLA=CRRARPL;        /* PUT ADR OF RPL IN DCLCP       */
         L     @05,CRRARPL(,CRRPTR)                                1186
         ST    @05,DCLRPLA(,@15)                                   1186
*         END;                                                     1187
*     ELSE                                                         1188
*       DO;                                                        1188
*                                                                  1188
         B     @RC01179                                            1188
@RF01179 DS    0H                                                  1189
*         /***********************************************************/
*         /*                                                         */
*         /* FSB JUST PROCESSED WAS A SUBBLOCK BUT THE USER'S BUFFER */
*         /* IS FILLED.                                              */
*         /*                                                         */
*         /***********************************************************/
*                                                                  1189
*                                   /* D31JKMQ                       */
*         CRRPOST=ON;               /* SET DO POST SWITCH            */
         OI    CRRPOST(CRRPTR),B'00010000'                         1189
*         RFY                                                      1190
*          (REG2,                                                  1190
*           REG3) RSTD;                                            1190
*CS9:                                                              1191
*         REG2=FMCCMPS2;            /* REFERENCE FLAG VALUE          */
CS9      L     @15,CRRFMCB(,CRRPTR)                                1191
         L     REG2,FMCCMPS2(,@15)                                 1191
*         REG3=REG2|FLGA3ON;        /* SET FLUSH INDICATOR           */
         LR    REG3,REG2                                           1192
         O     REG3,@CF01565                                       1192
*         CS(REG2,REG3,FMCCMPS2);   /* SET NEW VALUE IN FMCB         */
         CS    REG2,@03,FMCCMPS2(@15)                              1193
*         BC(7,CS9);                /* TRY AGAIN IF FAILURE          */
         BC    7,CS9                                               1194
*         RFY                                                      1195
*          (REG2,                                                  1195
*           REG3) UNRSTD;                                          1195
*       END;                                                       1196
*   RTNREG=CRRRTN4;                 /* RESTORE RETURN REG            */
@RC01179 DS    0H                                                  1197
@RC01177 L     RTNREG,CRRRTN4(,CRRPTR)                             1197
*   END TRUNC1;                                                    1198
@EL00012 DS    0H                                                  1198
@EF00012 DS    0H                                                  1198
@ER00012 BR    @14                                                 1198
*                                                                  1199
*/********************************************************************/
*/*                                                                  */
*/* ROUTINE NAME : KEEP                                              */
*/*                                                                  */
*/* FUNCTION :                                                       */
*/* KEEP IS CALLED BY MOVEDATA IF THE USER HAS NOT SPECIFIED THE     */
*/* TRUNC OPTION.  IF THERE WERE NO ERRORS DURING THE MOVE KEEP1 IS  */
*/* CALLED.  OTHERWISE, THE EOB, EOM, EOT INDICATORS ARE TURNED OFF  */
*/* IN THE CRR, THE DO POST FLAG IS SET AND THE FSB AND FDBS ARE     */
*/* QUEUED TO THE FMCB DATA QUEUE.  RETURN IS TO MOVEDATA VIA        */
*/* REG 14.                                                          */
*/*                                                                  */
*/* INPUT : FSBPTR REG(4) - ADDRESS OF FSB                           */
*/*                                                                  */
*/* OUTPUT : SAME                                                    */
*/*                                                                  */
*/* SUBROUTINES CALLED : KEEP1    - FURTHER KEEP PROCESSING          */
*/*                      XFRFSB   - QUEUE FSB ON FMCB DATA QUEUE     */
*/*                      FREEBUF  - RELEASE FSB AND FDB BUFFERS      */
*/*                                                                  */
*/* MACROS USED :                                                    */
*/*                                                                  */
*/********************************************************************/
*                                                                  1199
*KEEP:                                                             1199
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1199
KEEP     DS    0H                                                  1200
*   CRRRTN3=RTNREG;                 /* SAVE RETURN REG               */
         ST    RTNREG,CRRRTN3(,CRRPTR)                             1200
*   IF CRRBRTCD=CRRBRSUC THEN       /* 0 RETURN CODE FROM MOVE       */
         CLI   CRRBRTCD(CRRPTR),0                                  1201
         BNE   @RF01201                                            1201
*     DO;                                                          1202
*                                                                  1202
*       /*************************************************************/
*       /*                                                           */
*       /* ALL DATA FROM ONE FSB MOVED- CHECK IF MORE DATA EXPECTED  */
*       /*                                                           */
*       /*************************************************************/
*                                                                  1203
*       CALL KEEP1;                                                1203
         BAL   @14,KEEP1                                           1203
*       CALL FREEBUF;               /* FREE FSB AND FDBS             */
         BAL   @14,FREEBUF                                         1204
*     END;                                                         1205
*   ELSE                                                           1206
*     DO;                                                          1206
*                                                                  1206
         B     @RC01201                                            1206
@RF01201 DS    0H                                                  1207
*       /*************************************************************/
*       /*                                                           */
*       /* BUFFER WAS FILLED BEFORE ALL DATA WAS MOVED. RESET ANY    */
*       /* ENDING STATUS IN THE FEEDBACK TO INFORM USER OF THIS FACT.*/
*       /* SAVE FSB TO BE PROCESSED DURING NEXT READ.                */
*       /*                                                           */
*       /*************************************************************/
*                                                                  1207
*       CRRPOST=ON;                 /* SET DO POST SWITCH            */
         OI    CRRPOST(CRRPTR),B'00010000'                         1207
*       CRRRDEOB=OFF;               /* TURN OFF EOB,EOM, EOT         */
*       CRRRDEOM=OFF;                                              1209
*       CRRRDEOT=OFF;                                              1210
         NI    CRRRDEOB(CRRPTR),B'11000111'                        1210
*       CALL XFRFSB;                /* PUT FSB ON FMCB DATA Q        */
         BAL   @14,XFRFSB                                          1211
*     END;                                                         1212
*   RTNREG=CRRRTN3;                 /* RESTORE RETURN REG            */
@RC01201 L     RTNREG,CRRRTN3(,CRRPTR)                             1213
*   END KEEP;                                                      1214
@EL00013 DS    0H                                                  1214
@EF00013 DS    0H                                                  1214
@ER00013 BR    @14                                                 1214
*                                                                  1215
*/********************************************************************/
*/*                                                                  */
*/* ROUTINE NAME : KEEP1                                             */
*/*                                                                  */
*/* FUNCTION :                                                       */
*/* KEEP1 IS CALLED BY KEEP IF THERE WERE NO ERRORS DURING THE MOVE. */
*/* IF EOB WAS RECEIVED IN THE FSB, THE DO POST SWITCH IS SET AND    */
*/* THE SUBROUTINE RETURNS TO KEEP.                                  */
*/*                                                                  */
*/* OTHERWISE, IF THERE IS MORE SPACE LEFT IN THE USER AREA, THE     */
*/* BUFFER INFORMATION IS MOVED FROM THE CRR TO THE DCLCP AND THE    */
*/* RPL PTR IS PUT BACK INTO THE DCLCP.  IF THERE IS NO MORE SPACE   */
*/* IN THE USER AREA THE EOB, EOM, EOT INDICATORS ARE TURNED OFF IN  */
*/* THE CRR AND THE DO POST FLAG IS SET.  THE SUBROUTINE RETURNS TO  */
*/* KEEP VIA REG 14.                                                 */
*/*                                                                  */
*/* INPUT : FSBPTR REG(4) - ADDRESS OF FSB                           */
*/*                                                                  */
*/* OUTPUT : SAME                                                    */
*/*                                                                  */
*/* SUBROUTINES CALLED : EOBANAL  - CHECK FOR ENDING STATUS          */
*/*                                                                  */
*/* MACROS USED : NONE                                               */
*/*                                                                  */
*/********************************************************************/
*                                                                  1215
*KEEP1:                                                            1215
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1215
KEEP1    DS    0H                                                  1216
*   CRRRTN4=RTNREG;                 /* SAVE RETURN REG               */
         ST    RTNREG,CRRRTN4(,CRRPTR)                             1216
*   CALL EOBANAL;                   /* CHECK FOR EOM, EOB, EOT       */
         BAL   @14,EOBANAL                                         1217
*   IF FSBEBI=ON|FSBECI=ON THEN     /* CHECK EOB & END CHAN PGM    1218
*                                                            @OX11109*/
*                                                                  1218
         TM    FSBEBI(FSBPTR),B'01100000'                          1218
         BZ    @RF01218                                            1218
*     /***************************************************************/
*     /*                                                             */
*     /* FSB JUST PROCESSED WAS NOT A SUBBLOCK SO MOVE PROCESSING    */
*     /* COMPLETE.                                                   */
*     /*                                                             */
*     /***************************************************************/
*                                                                  1219
*     CRRPOST=ON;                   /* SET DO POST SWITCH            */
         OI    CRRPOST(CRRPTR),B'00010000'                         1219
*   ELSE                                                           1220
*     IF CRRBLEN>ZEROWORD THEN      /* MORE SPACE LEFT IN USER AREA  */
         B     @RC01218                                            1220
@RF01218 LH    @15,CRRBLEN(,CRRPTR)                                1220
         LTR   @15,@15                                             1220
         BNP   @RF01220                                            1220
*       IF CRRERLK=ON|              /* CHECK FOR ERROR LOCK          */
*           FSBMJRCD^=FRNORM|       /* ERROR RETURN CODE             */
*           FSBLGI=ON THEN          /* LEADING GRAPHICS RECEIVED     */
*                                                                  1221
         TM    CRRERLK(CRRPTR),B'10000000'                         1221
         BO    @RT01221                                            1221
         CLI   FSBMJRCD(FSBPTR),X'00'                              1221
         BNE   @RT01221                                            1221
         TM    FSBLGI(FSBPTR),B'00000010'                          1221
         BNO   @RF01221                                            1221
@RT01221 DS    0H                                                  1222
*         /***********************************************************/
*         /*                                                         */
*         /* ERROR RETURN CODE OR LEADING GRAPHICS RECEIVED SO MOVE  */
*         /* PROCESSING COMPLETE.                                    */
*         /*                                                         */
*         /***********************************************************/
*                                                                  1222
*         CRRPOST=ON;               /* POST USER WITH ERROR LOCK     */
         OI    CRRPOST(CRRPTR),B'00010000'                         1222
*       ELSE                        /* ERROR LOCK NOT SET-CONTINUE   */
*         DO;                                                      1223
*                                                                  1223
         B     @RC01221                                            1223
@RF01221 DS    0H                                                  1224
*           /*********************************************************/
*           /*                                                       */
*           /* FSB JUST PROCESSED WAS A SUBBLOCK AND THERE IS ROOM IN*/
*           /* THE USER'S BUFFER FOR MORE DATA. SAVE STATUS IN THE   */
*           /* DCLCP FOR WHEN ANOTHER FSB ARRIVES SO THE MOVE CAN BE */
*           /* RESUMED.                                              */
*           /*                                                       */
*           /*********************************************************/
*                                                                  1224
*           DCLIOBUF=CRRBARAD;      /* MOVE ADDR OF NEXT AVAIL SPACE
*                                      IN USER BUFFER TO DCLCP     1224
*                                      EXTENSION                     */
         L     @15,CRRLCPB(,CRRPTR)                                1224
         L     @05,CRRBARAD(,CRRPTR)                               1224
         ST    @05,DCLIOBUF(,@15)                                  1224
*           DCLIOLEN=CRRBLEN;       /* MOVE RESIDUAL COUNT TO DCLCP  */
         LH    @05,CRRBLEN(,CRRPTR)                                1225
         STH   @05,DCLIOLEN(,@15)                                  1225
*           DCLBTLEN=CRRBTLEN;      /* PUT LENGTH MOVED IN DCLCP     */
         L     @05,CRRBTLEN(,CRRPTR)                               1226
         ST    @05,DCLBTLEN(,@15)                                  1226
*           DCLRPLA=CRRARPL;        /* PUT ADR OF RPL IN DCLCP       */
         L     @05,CRRARPL(,CRRPTR)                                1227
         ST    @05,DCLRPLA(,@15)                                   1227
*         END;                                                     1228
*     ELSE                                                         1229
*       DO;                                                        1229
*                                                                  1229
         B     @RC01220                                            1229
@RF01220 DS    0H                                                  1230
*         /***********************************************************/
*         /*                                                         */
*         /* FSB JUST PROCESSED WAS A SUBBLOCK BUT THE USER'S BUFFER */
*         /* IS FILLED. RESET FEEDBACK STATUS TO INDICATE NOT ALL    */
*         /* DATA WAS RECEIVED. SAVE FSB TO BE USED FOR NEXT READ.   */
*         /*                                                         */
*         /***********************************************************/
*                                                                  1230
*         CRRPOST=ON;               /* SET DO POST SWITCH            */
         OI    CRRPOST(CRRPTR),B'00010000'                         1230
*         CRRRDEOB=OFF;             /* TURN OFF EOB,EOM,EOT          */
*         CRRRDEOM=OFF;                                            1232
*         CRRRDEOT=OFF;                                            1233
         NI    CRRRDEOB(CRRPTR),B'11000111'                        1233
*       END;                                                       1234
*   RTNREG=CRRRTN4;                 /* RESTORE RETURN REG            */
@RC01220 DS    0H                                                  1235
@RC01218 L     RTNREG,CRRRTN4(,CRRPTR)                             1235
*   END KEEP1;                                                     1236
@EL00014 DS    0H                                                  1236
@EF00014 DS    0H                                                  1236
@ER00014 BR    @14                                                 1236
*LCPBINIT:                                                         1237
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1237
*                                                                  1237
LCPBINIT DS    0H                                                  1238
*/*****************************************************************  */
*/*                                                                  */
*/* ROUTINE NAME : LCPBINIT                                          */
*/*                                                                  */
*/* FUNCTION :                                                       */
*/*                                                                  */
*/*  THIS ROUTINE IS ENTERED TO GET SPACE FOR AND TO INITIALIZE      */
*/*  A LCPB.  THIS IS CALLED BY XFRFSB WHEN BUFFER THRESHOLD HAS     */
*/*  BEEN EXCEEDED AND I/O IS TO BE RESET.  IT IS ALSO CALLED BY     */
*/*  FLUSH IF THE FSB BEING FLUSHED HAS THE ERROR LOCK SET AND AN    */
*/*  INTERNAL RESET ERROR LOCK IS TO BE ISSUED.  THE DCLCP IS        */
*/*  INITIALIZED TO BE USED FOR RESET OPERATIONS.                    */
*/*                                                                  */
*/* INPUT : FSBPTR REG(4) - ADDRESS OF FSB                           */
*/*                                                                  */
*/* OUTPUT : SAME                                                    */
*/*                                                                  */
*/* SUBROUTINES CALLED : NONE                                        */
*/*                                                                  */
*/* MACROS USED :  REQSTORE, TPWAIT, TPQUE                           */
*/*                                                                  */
*/********************************************************************/
*                                                                  1238
*   CRRRTN8=RTNREG;                 /* SAVE RETURN ADDRESS           */
*                                                                  1238
         ST    RTNREG,CRRRTN8(,CRRPTR)                             1238
*   /*****************************************************************/
*   /*                                                               */
*   /* GET STORAGE FOR DCLCPB AND WAIT IF STORAGE NOT AVAILABLE      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1239
*   RFY                                                            1239
*     RTCODREG RSTD;                                               1239
*                                                                  1239
*   /*****************************************************************/
*   /*                                                               */
*   /* REQSTORE CBID(DCLCP)RPH(RPHPTR)CLEAR(YES)PRIORITY(YES)        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1240
*   DO;                                                            1240
*                                                                  1240
*/* ATBUILD (ISTDYPAB,ISTATCVT,ISTRPH)                               */
*/* END OF ATBUILD                                                   */
*                                                                  1241
*     RFY                                                          1241
*      (GPR02P,                                                    1241
*       GPR03P,                                                    1241
*       GPR04P,                                                    1241
*       GPR15P) RSTD;                                              1241
*     RFY                                                          1242
*      (GPR01P,                                                    1242
*       GPR13P) RSTD;                                              1242
*     GENERATE REFS(GPR01P,GPR02P,GPR13P) SETS(RPHWORK);           1243
           STM GPR02P,GPR13P,RPHWORK(GPR01P)
*     RFY                                                          1244
*      (GPR01P,                                                    1244
*       GPR13P) UNRSTD;                                            1244
*     DO;                           /* LISATCVT                    1245
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*       GPR15P=ATCLCPTR;            /* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     1246
*     END;                          /* LISATCVT                      */
*     GPR02P=GPR15P->ATCBPDA|'80000000'X;                          1248
         L     GPR02P,ATCBPDA(,GPR15P)                             1248
         O     GPR02P,@CF01547                                     1248
*     DCL                                                          1249
*       1 FMZA0150 FIXED(31) STATIC LOCAL,                         1249
*        2 * FIXED(8) INIT(248),                                   1249
*        2 * PTR(24) INIT(0);                                      1249
*     GPR03F=FMZA0150;                                             1250
         L     GPR03F,FMZA0150                                     1250
*     GPR04F=5;                                                    1251
         LA    GPR04F,5                                            1251
*     GPR15P=GPR15P->ATCSMRQ;                                      1252
         L     GPR15P,ATCSMRQ(,GPR15P)                             1252
*     DCL                                                          1253
*       FMZL0150 BASED(GPR15P) LABEL VALUERANGE(*);                1253
*     CALL FMZL0150;                                               1254
         BALR  @14,@15                                             1254
*     RFY                                                          1255
*      (GPR13P) RSTD;                                              1255
*     GENERATE REFS(GPR01P,RPHWORK) SETS(GPR02P,GPR13P);           1256
           LM GPR02P,GPR13P,RPHWORK(GPR01P)
*     RFY                                                          1257
*      (GPR13P) UNRSTD;                                            1257
*     RFY                                                          1258
*      (GPR02P,                                                    1258
*       GPR03P,                                                    1258
*       GPR04P,                                                    1258
*       GPR15P) UNRSTD;                                            1258
*   END;                            /* ******** END OF REQSTORE    1259
*                                      EXPANSION                     */
*   IF RTCODREG=X8 THEN             /* WAS STORAGE AVAILABLE?        */
         C     RTCODREG,@CF00036                                   1260
         BNE   @RF01260                                            1260
*     CALL WAITUP;                  /* NO, WAIT FOR STORAGE          */
         BAL   @14,WAITUP                                          1261
*   ELSE                                                           1262
*     ;                             /* YES                           */
@RF01260 DS    0H                                                  1263
*   RFY                                                            1263
*     RTCODREG UNRSTD;                                             1263
*                                                                  1263
*   /*****************************************************************/
*   /*                                                               */
*   /* INITIALIZE ISTDCLCP FOR RESET OPERATION                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1264
*   RFY                                                            1264
*     ISTDCLCP BASED(LCPBPTR);                                     1264
*   RFY                                                            1265
*     LCPBPTR RSTD;                 /* RESTRICT DCLCP BASE REG       */
*   LCPBPTR=RPHSRPRM;               /* REFERENCE STORAGE             */
         L     LCPBPTR,RPHSRPRM(,RPHPTR)                           1266
*   LCPTYPE=DCLTYPE;                /* INDICATE DCLCP                */
         MVI   LCPTYPE(LCPBPTR),X'12'                              1267
*   LCPLNGTH=LENGTH(ISTDCLCP);      /* INITAILIZE LENGTH             */
         MVI   LCPLNGTH(LCPBPTR),X'64'                             1268
*   LCPNXLCW=ADDR(DCLLCCW2);        /* POINT TO RESET LCCW SLOT      */
         LA    @15,DCLLCCW2(,LCPBPTR)                              1269
         ST    @15,LCPNXLCW(,LCPBPTR)                              1269
*   LCPDAF=NCBDAF;                  /* INITIALIZE DESTINATION ID     */
         L     @15,CRRFMCB(,CRRPTR)                                1270
         L     @08,FMCDNCBA(,@15)                                  1270
         MVC   LCPDAF(2,LCPBPTR),NCBDAF(@08)                       1270
*   LCPSAF=FMCSAF;                  /* INITIALIZE SOURCE ID          */
         MVC   LCPSAF(2,LCPBPTR),FMCSAF(@15)                       1271
*   DCLRQTP=DCLRESET;               /* INDICATE LCPB FOR RESET OP    */
         MVI   DCLRQTP(LCPBPTR),X'12'                              1272
*   RFY                                                            1273
*     ISTLCCW BASED(ADDR(DCLLCCW2));/* COVER 2ND LCCW SLOT           */
*   IF CRRSW5=ON THEN               /* IF THRESHOLD EXCEEDED         */
         TM    CRRSW5(CRRPTR),B'00000100'                          1274
         BNO   @RF01274                                            1274
*     LCCWOP=LXEL;                  /* BUILD RESET ERR LOCK          */
         MVI   LCCWOP+56(LCPBPTR),X'0B'                            1275
*   ELSE                                                           1276
*     IF DEVCHAR2>=DEV2980&DEVCHAR2<=DEV3275 THEN/* 2980 OR 3270?    */
         B     @RC01274                                            1276
@RF01274 L     @15,CRRFMCB(,CRRPTR)                                1276
         LA    @08,36                                              1276
         AL    @08,FMCDNCBA(,@15)                                  1276
         CLI   DEVCHAR2(@08),X'18'                                 1276
         BL    @RF01276                                            1276
         CLI   DEVCHAR2(@08),X'1C'                                 1276
         BH    @RF01276                                            1276
*       LCCWOP=LXEC;                /* RESET AT END OF CMD           */
         MVI   LCCWOP+56(LCPBPTR),X'4B'                            1277
*     ELSE                                                         1278
*       IF DEVCRVB=ON THEN          /* START-STOP REVERSE BREAK      */
         B     @RC01276                                            1278
@RF01276 L     @15,CRRFMCB(,CRRPTR)                                1278
         L     @15,FMCDNCBA(,@15)                                  1278
         TM    DEVCRVB+36(@15),B'00100000'                         1278
         BNO   @RF01278                                            1278
*         LCCWOP=LXI;               /* RESET IMMEDIATE LCCW          */
         MVI   LCCWOP+56(LCPBPTR),X'2B'                            1279
*       ELSE                                                       1280
*         IF DEVCBSC=ON THEN        /* BSC DEVICE                    */
         B     @RC01278                                            1280
@RF01278 L     @15,CRRFMCB(,CRRPTR)                                1280
         L     @15,FMCDNCBA(,@15)                                  1280
         TM    DEVCBSC+36(@15),B'10000000'                         1280
         BNO   @RF01280                                            1280
*           LCCWOP=LXO;             /* RESET ORDERLY                 */
         MVI   LCCWOP+56(LCPBPTR),X'5B'                            1281
*         ELSE                      /* START-STOP W/O REVERSE BK     */
*           LCCWOP=LXEC;            /* RESET END OF COMMAND LCCW     */
         B     @RC01280                                            1282
@RF01280 MVI   LCCWOP+56(LCPBPTR),X'4B'                            1282
*   DCLSRESW=ON;                    /* INDICATE INTERNAL RESET       */
@RC01280 DS    0H                                                  1283
@RC01278 DS    0H                                                  1283
@RC01276 DS    0H                                                  1283
@RC01274 OI    DCLSRESW(LCPBPTR),B'10000000'                       1283
*/*  TPQUE ((LCPBPTR),FMCPAB3) RESET                                 */
*                                                                  1284
*   DO;                                                            1284
*     RFY                                                          1285
*      (GPR00P,                                                    1285
*       GPR01P,                                                    1285
*       GPR02P,                                                    1285
*       GPR15P) RSTD;                                              1285
*     GEN REFS(GPR01P) SETS(RPHWORK)                               1286
*         (STM   GPR14P,GPR09P,RPHWORK(GPR01P));                   1286
         STM   GPR14P,GPR09P,RPHWORK(GPR01P)
*     GPR00P=ADDR(FMCPAB3);                                        1287
         L     @08,CRRFMCB(,CRRPTR)                                1287
         LA    GPR00P,FMCPAB3(,@08)                                1287
*     GPR02P=(LCPBPTR);                                            1288
         LR    GPR02P,LCPBPTR                                      1288
*     CALL ATCLCPTR->ATCAP34->ISTAPC34;                            1289
         L     @08,ATCLCPTR                                        1289
         L     @15,ATCAP34(,@08)                                   1289
         BALR  @14,@15                                             1289
*     GEN REFS(RPHWORK,GPR01P) NOSETS                              1290
*         (LM    GPR14P,GPR09P,RPHWORK(GPR01P));                   1290
         LM    GPR14P,GPR09P,RPHWORK(GPR01P)
*     RFY                                                          1291
*      (GPR00P,                                                    1291
*       GPR01P,                                                    1291
*       GPR02P,                                                    1291
*       GPR15P) UNRSTD;                                            1291
*   END;                            /* *** END OF TPQUE GENERATION 1292
*                                      SHIP TO TPIOS                 */
*   RFY                                                            1293
*     LCPBPTR UNRSTD;                                              1293
*   RFY                                                            1294
*     ISTDEVCH;                                                    1294
*   RFY                                                            1295
*     DEVCHPTR UNRSTD;                                             1295
*   RTNREG=CRRRTN8;                 /* PICK UP RETURN ADDRESS        */
         L     RTNREG,CRRRTN8(,CRRPTR)                             1296
*   END LCPBINIT;                   /* RETURN TO CALLER              */
@EL00015 DS    0H                                                  1297
@EF00015 DS    0H                                                  1297
@ER00015 BR    @14                                                 1297
*WAITUP:                                                           1298
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1298
WAITUP   DS    0H                                                  1299
*   RFY                                                            1299
*     RTNREG RSTD;                                                 1299
*   CRRRTN2=RTNREG;                                                1300
         ST    RTNREG,CRRRTN2(,CRRPTR)                             1300
*   RFY                                                            1301
*     RTNREG UNRSTD;                                               1301
*                                                                  1301
*/*  TPWAIT                                                          */
*                                                                  1302
*   DO;                             /* BEGIN TPWAIT GENERATION       */
*     RFY                                                          1303
*      (GPR01P,                                                    1303
*       GPR14P,                                                    1303
*       GPR15P) RSTD;                                              1303
*     RFY                                                          1304
*      (GPR00P) RSTD;                                              1304
*     GEN(STM   GPR00P,GPR15P,RPHWORK(GPR01P))                     1305
*     REFS(GPR00P,GPR01P,GPR15P) SETS(RPHWORK);                    1305
         STM   GPR00P,GPR15P,RPHWORK(GPR01P)
*     RFY                                                          1306
*      (GPR00P) UNRSTD;                                            1306
*     GPR15P=ADDR(LHAA0175);                                       1307
         LA    GPR15P,LHAA0175                                     1307
*     GPR14P=0;                                                    1308
         SLR   GPR14P,GPR14P                                       1308
*     GPR15P=GPR15P&'00FFFFFF'X;                                   1309
         N     GPR15P,@CF04830                                     1309
*     GPR15P=GPR15P|RPHWT1;                                        1310
         O     GPR15P,@CF01571                                     1310
*     CS(GPR14P,GPR15P,GPR01P->RPHRESMA);                          1311
         CS    GPR14P,@15,RPHRESMA(GPR01P)                         1311
*     BC(7,LHAB0175);                                              1312
*                                                                  1312
         BC    7,LHAB0175                                          1312
*/* TPEXIT  NONE                                                     */
*                                                                  1313
*     DO;                                                          1313
*       RESPECIFY                                                  1314
*         GPR15P RSTD;                                             1314
*                                                                  1314
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTATCVT)                               */
*/* END OF ATBUILD                                                   */
*                                                                  1315
*       DO;                         /* LISATCVT                    1315
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*         GPR15P=ATCLCPTR;          /* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     1316
*       END;                        /* LISATCVT                      */
*       RESPECIFY                                                  1318
*         GPR00F RSTD;                                             1318
*       GPR00F=0;                   /* SET PARAMETER REGISTER TO 0   */
         SLR   GPR00F,GPR00F                                       1319
*       GPR15P=GPR15P->ATCAP31;                                    1320
         L     GPR15P,ATCAP31(,GPR15P)                             1320
*       DCL                                                        1321
*         FMZL0180 BASED(GPR15P) LABEL VALUERANGE(*);              1321
*       CALL FMZL0180;                                             1322
         BALR  @14,@15                                             1322
*       RESPECIFY                                                  1323
*        (GPR00F,                                                  1323
*         GPR15P) UNRSTD;                                          1323
*     END;                          /* **** END OF TPEXIT            */
*LHAB0175:                                                         1325
*     ;                                                            1325
LHAB0175 DS    0H                                                  1326
*     GPR01P->RPHRESMA=0;                                          1326
         SLR   @15,@15                                             1326
         ST    @15,RPHRESMA(,GPR01P)                               1326
*     RFY                                                          1327
*      (GPR00P) RSTD;                                              1327
*LHAA0175:                                                         1328
*     ;                                                            1328
LHAA0175 DS    0H                                                  1329
*     GEN(LM    GPR00P,GPR15P,RPHWORK(GPR01P))                     1329
*     REFS(RPHWORK,GPR01P) SETS(GPR00P,GPR15P);                    1329
         LM    GPR00P,GPR15P,RPHWORK(GPR01P)
*     RFY                                                          1330
*      (GPR00P,                                                    1330
*       GPR01P,                                                    1330
*       GPR14P,                                                    1330
*       GPR15P) UNRSTD;                                            1330
*   END;                            /* ****END OF TPWAIT             */
*   RFY                                                            1332
*     RTNREG RSTD;                                                 1332
*   RTNREG=CRRRTN2;                                                1333
         L     RTNREG,CRRRTN2(,CRRPTR)                             1333
*   RFY                                                            1334
*     RTNREG UNRSTD;                                               1334
*   RETURN;                                                        1335
@EL00016 DS    0H                                                  1335
@EF00016 DS    0H                                                  1335
@ER00016 BR    @14                                                 1335
*   END WAITUP;                                                    1336
*                                                                  1336
@PB00016 DS    0H                                                  1337
*/* TPEPILOG                                                         */
*                                                                  1337
*   GEN(PRINT OFF);                                                1337
         PRINT OFF
*   DCL                                                            1338
*     ISTAPC34 ENTRY BASED(ATCAP34) VALRG(*);/* RESET ROUTINE        */
*   DCL                                                            1339
*     ISTAPC37 ENTRY BASED(ATCAP37) VALRG(*);/* TPQUE ROUTINE        */
*   GEN(PRINT ON);                                                 1340
*                                                                  1340
         PRINT ON
*/* END OF TPEPILOG                                                  */
*                                                                  1341
*   END ISTDCC50                                                   1341
*                                                                  1341
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IFGACB  )                                       */
*/*%INCLUDE SYSLIB  (IFGACBVT)                                       */
*/*%INCLUDE SYSLIB  (IFGRPL  )                                       */
*/*%INCLUDE SYSLIB  (IFGRPLVT)                                       */
*/*%INCLUDE SYSLIB  (ISTRPLFB)                                       */
*/*%INCLUDE SYSLIB  (IFGEXLST)                                       */
*/*%INCLUDE SYSLIB  (IFGEXLVT)                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*                                                                  1341
*       ;                                                          1341
@EL00001 DS    0H                                                  1341
@EF00001 DS    0H                                                  1341
@ER00001 BR    @14                                                 1341
@DATA    DS    0H
@DATD    DSECT
         DS    0F
ISTDCC50 CSECT
         DS    0F
@CF00067 DC    F'1'
@CF00044 DC    F'4'
@CF00036 DC    F'8'
@CF01545 DC    XL4'7FFFFFFF'
@CF01547 DC    XL4'80000000'
@CF01551 DC    XL4'BFFFFFFF'
@CF01553 DC    XL4'40000000'
@CF01557 DC    XL4'20000000'
@CF01561 DC    XL4'04000000'
@CF01563 DC    XL4'EFFFFFFF'
@CF01565 DC    XL4'10000000'
@CF01571 DC    XL4'08000000'
@CF04668 DC    XL4'FFFF0000'
@CF04830 DC    XL4'00FFFFFF'
@CF04865 DC    XL4'0000FFFF'
@DATD    DSECT
         DS    0D
FMCBPTR  DS    A
DNCBPTR  DS    A
WKEPTR   DS    A
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
ISTDCC50 CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
FMZA0102 DS    FL4
         ORG   FMZA0102
@NM00136 DC    AL1(80)
@NM00137 DC    AL3(0)
         ORG   FMZA0102+4
FMZA0118 DS    FL4
         ORG   FMZA0118
@NM00138 DC    AL1(80)
@NM00139 DC    AL3(0)
         ORG   FMZA0118+4
FMZA0150 DS    FL4
         ORG   FMZA0150
@NM00140 DC    AL1(248)
@NM00141 DC    AL3(0)
         ORG   FMZA0150+4
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
BASE1    EQU   @12
CVTPTR   EQU   @02
LCPBPTR  EQU   @09
RPHPTR   EQU   @01
FSBPTR   EQU   @04
GPR00F   EQU   @00
GPR00P   EQU   @00
GPR01P   EQU   @01
GPR02F   EQU   @02
GPR02P   EQU   @02
GPR03F   EQU   @03
GPR03P   EQU   @03
GPR04F   EQU   @04
GPR04P   EQU   @04
GPR05P   EQU   @05
GPR06P   EQU   @06
GPR07P   EQU   @07
GPR08P   EQU   @08
GPR09P   EQU   @09
GPR10F   EQU   @10
GPR10P   EQU   @10
GPR11F   EQU   @11
GPR11P   EQU   @11
GPR12F   EQU   @12
GPR12P   EQU   @12
GPR13F   EQU   @13
GPR13P   EQU   @13
GPR14F   EQU   @14
GPR14P   EQU   @14
GPR15F   EQU   @15
GPR15P   EQU   @15
REG2     EQU   @02
REG3     EQU   @03
COUNTER  EQU   @04
ACBPTR   EQU   @06
UECBPTR  EQU   @07
FDBPTR   EQU   @08
DEVCHPTR EQU   @08
RPLPTR   EQU   @09
CRRPTR   EQU   @13
RTNREG   EQU   @14
RTCODREG EQU   @15
GPR01F   EQU   @01
GPR05F   EQU   @05
GPR06F   EQU   @06
GPR07F   EQU   @07
GPR08F   EQU   @08
GPR09F   EQU   @09
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSALITA  EQU   PSA+764
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
ATCLCPTR EQU   1032
IFGACB   EQU   0
ACBCOMN  EQU   IFGACB
ACBLENG  EQU   ACBCOMN+2
ACBLENG2 EQU   ACBLENG
ACBAMBL  EQU   ACBCOMN+4
ACBJWA   EQU   ACBAMBL
ACBMACRF EQU   ACBCOMN+12
ACBMACR1 EQU   ACBMACRF
ACBADR   EQU   ACBMACR1
ACBCNV   EQU   ACBMACR1
ACBMACR2 EQU   ACBMACRF+1
ACBBUFPL EQU   ACBCOMN+20
ACBMACR3 EQU   ACBBUFPL
ACBRECFM EQU   ACBCOMN+24
ACBCCTYP EQU   ACBCOMN+25
ACBOPT   EQU   ACBCOMN+26
ACBDSORG EQU   ACBOPT
ACBCROPS EQU   ACBDSORG
ACBDVIND EQU   ACBDSORG
ACBEXLST EQU   ACBCOMN+36
ACBUEL   EQU   ACBEXLST
ACBDDNM  EQU   ACBCOMN+40
ACBAMETH EQU   ACBDDNM+3
ACBOFLGS EQU   ACBCOMN+48
ACBEXFG  EQU   ACBOFLGS
ACBIOSFG EQU   ACBOFLGS
ACBINFLG EQU   ACBCOMN+50
ACBVVIC  EQU   ACBINFLG
ACBUJFCB EQU   ACBCOMN+52
ACBBLKSZ EQU   ACBCOMN+60
ACBVTEXT EQU   IFGACB+76
IFGRPL   EQU   0
RPLCOMN  EQU   IFGRPL
RPLIDWD  EQU   RPLCOMN
RPLREQ   EQU   RPLIDWD+2
RPLLEN   EQU   RPLIDWD+3
RPLPLHPT EQU   RPLCOMN+4
RPLECB   EQU   RPLCOMN+8
RPLFDBWD EQU   RPLCOMN+12
RPLFDBK  EQU   RPLFDBWD+1
RPLRTNCD EQU   RPLFDBK
RPLCNDCD EQU   RPLFDBK+1
RPLCMPON EQU   RPLCNDCD
RPLFDB2  EQU   RPLCMPON
RPLERRCD EQU   RPLCNDCD+1
RPLFDB3  EQU   RPLERRCD
RPLKEYLE EQU   RPLCOMN+16
RPLAREA  EQU   RPLCOMN+32
RPLARG   EQU   RPLCOMN+36
RPLSAF   EQU   RPLARG
RPLDAF   EQU   RPLARG+2
RPLOPTCD EQU   RPLCOMN+40
RPLOPT1  EQU   RPLOPTCD
RPLECBSW EQU   RPLOPT1
RPLOPT2  EQU   RPLOPTCD+1
RPLADR   EQU   RPLOPT2
RPLOPT3  EQU   RPLOPTCD+2
RPLOPT4  EQU   RPLOPTCD+3
RPLNXTRP EQU   RPLCOMN+44
RPLRLEN  EQU   RPLCOMN+48
RPLBUFL  EQU   RPLCOMN+52
RPLOPTC2 EQU   RPLCOMN+56
RPLOPT5  EQU   RPLOPTC2
RPLDLGIN EQU   RPLOPT5
RPLWRTYP EQU   RPLOPT5
RPLWROPT EQU   RPLOPT5
RPLOPT6  EQU   RPLOPTC2+1
RPLUNTYP EQU   RPLOPT6
RPLOPT7  EQU   RPLOPTC2+2
RPLCNOPT EQU   RPLOPT7
RPLOPT8  EQU   RPLOPTC2+3
RPLRBAR  EQU   RPLCOMN+60
RPLAIXID EQU   RPLRBAR+2
RPLEXTDS EQU   RPLCOMN+68
RPLEXTD1 EQU   RPLEXTDS
RPLNIB   EQU   RPLEXTD1
RPLVTEXT EQU   IFGRPL+76
RPLAAREA EQU   RPLVTEXT
RPLAARLN EQU   RPLVTEXT+4
RPLARCLN EQU   RPLVTEXT+8
RPLFDBK2 EQU   RPLVTEXT+12
RPLSSNSI EQU   RPLFDBK2
RPLDSB   EQU   RPLSSNSI
RPLDSB1  EQU   RPLDSB
RPLSSEI  EQU   RPLDSB1
RPLDSB2  EQU   RPLDSB+1
RPLUSNSI EQU   RPLFDBK2+2
RPLOPTC3 EQU   RPLVTEXT+20
RPLOPT9  EQU   RPLOPTC3
RPLOPT10 EQU   RPLOPTC3+1
RPLOPT11 EQU   RPLOPTC3+2
RPLOPT12 EQU   RPLOPTC3+3
RPLOSENS EQU   RPLVTEXT+24
RPLSSNSO EQU   RPLOSENS
RPLSSEO  EQU   RPLSSNSO
RPLOF16  EQU   0
RPLRH3   EQU   RPLOF16
RPLSRTYP EQU   RPLOF16+1
RPLSTYPE EQU   RPLSRTYP
RPLRTYPE EQU   RPLSRTYP
RPLCHN   EQU   RPLOF16+2
RPLVTFL1 EQU   RPLOF16+3
RPLVTFL2 EQU   RPLOF16+4
RPLPOSTV EQU   RPLVTFL2
RPLRESP  EQU   RPLVTFL2
RPLCNTRL EQU   RPLOF16+5
RPLCNTDF EQU   RPLCNTRL
RPLCNTDC EQU   RPLCNTRL+1
RPLCNTSC EQU   RPLCNTRL+2
RPLOF60  EQU   0
RPLOBSQ  EQU   RPLOF60+4
RPLIBSQ  EQU   RPLOF60+5
IFGEXLST EQU   0
EXLCOMN  EQU   IFGEXLST
EXLLEN   EQU   EXLCOMN+2
EXLEODF  EQU   EXLCOMN+5
EXLSYNF  EQU   EXLCOMN+10
EXLLERF  EQU   EXLCOMN+15
EXLSCIPF EQU   EXLCOMN+20
EXLLGNF  EQU   EXLCOMN+25
EXLJRNF  EQU   EXLCOMN+30
EXLOPNF  EQU   EXLCOMN+35
EXLVTEXT EQU   IFGEXLST+40
EXLNLGNF EQU   EXLVTEXT
EXLRLRQF EQU   EXLVTEXT+5
EXLATTNF EQU   EXLVTEXT+15
EXLTPNDF EQU   EXLVTEXT+20
EXLDFAS  EQU   0
EXLDFASF EQU   EXLDFAS
EXLRESP  EQU   0
EXLRESPF EQU   EXLRESP
IFGEXLEF EQU   0
EXLENTRY EQU   IFGEXLEF
EXLFLAG  EQU   EXLENTRY
EXLENFL  EQU   EXLFLAG
EXLEXITP EQU   EXLENTRY+1
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTSHS   EQU   CVTXTNT2+40
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
ISTPAB   EQU   0
PABWQCHN EQU   ISTPAB
PABWEQA  EQU   PABWQCHN
PABCHAIN EQU   PABWQCHN+4
PABRPHFG EQU   ISTPAB+12
PABFLAGS EQU   PABRPHFG
PABERLCK EQU   PABFLAGS
PABERRLK EQU   PABERLCK
ISTFDB   EQU   0
FDBFDBA  EQU   ISTFDB
FDBDATCT EQU   ISTFDB+8
FDBOFSET EQU   ISTFDB+10
ISTLCCW  EQU   0
LCCWOP   EQU   ISTLCCW
LCCWRWOP EQU   LCCWOP
LCCWCTL  EQU   LCCWRWOP
LCCWFLAG EQU   ISTLCCW+1
LCCWLSI  EQU   LCCWFLAG
ISTLCPB  EQU   0
LCPTYPE  EQU   ISTLCPB
LCPLNGTH EQU   ISTLCPB+1
LCPREQTG EQU   ISTLCPB+2
LCPFLAGS EQU   LCPREQTG
LCPZF001 EQU   LCPFLAGS
LCPZRT02 EQU   LCPZF001
LCPZF002 EQU   LCPFLAGS
LCPZRT03 EQU   LCPZF002
LCPZF003 EQU   LCPFLAGS
LCPZRT04 EQU   LCPZF003
LCPZF004 EQU   LCPFLAGS
LCPZRT05 EQU   LCPZF004
LCPZRT06 EQU   LCPFLAGS
LCPZRT07 EQU   LCPFLAGS
LCPMNRCD EQU   LCPREQTG+1
LCPZRT08 EQU   LCPMNRCD
LCPZRT09 EQU   LCPMNRCD
LCPCHAIN EQU   ISTLCPB+4
LCPCHAI1 EQU   LCPCHAIN
LCPRUCNT EQU   ISTLCPB+8
LCPFLAG2 EQU   ISTLCPB+9
LCPTLBPI EQU   LCPFLAG2
LCPFID0  EQU   LCPFLAG2
LCPSEQ   EQU   ISTLCPB+10
LCPCID   EQU   ISTLCPB+16
LCPSAF   EQU   LCPCID
LCPDAF   EQU   LCPCID+2
LCPNXLCW EQU   ISTLCPB+20
LCPFDBA  EQU   ISTLCPB+24
LCPFLG1  EQU   ISTLCPB+37
LCPFLCCW EQU   ISTLCPB+40
LCPLCCW  EQU   ISTLCPB+48
LCPPABA  EQU   LCPLCCW+4
LCPRPHA  EQU   LCPPABA
ISTRPH   EQU   0
RPHCNTL  EQU   ISTRPH
RPHFLAGS EQU   RPHCNTL+2
RPHAPTYP EQU   RPHFLAGS
RPHFSTLC EQU   RPHFLAGS
RPHFLGB  EQU   RPHCNTL+3
RPHRPHA  EQU   ISTRPH+4
RPHCVFLG EQU   RPHRPHA
RPHGATE  EQU   RPHCVFLG
RPHTSKID EQU   ISTRPH+8
RPHRESMA EQU   ISTRPH+16
RPHWPFLG EQU   RPHRESMA
RPHWEA   EQU   ISTRPH+24
RPHCSPA  EQU   RPHWEA
RPHSRPRM EQU   ISTRPH+28
RPHCRR   EQU   ISTRPH+32
RPHPABQA EQU   ISTRPH+36
RPHWORK  EQU   ISTRPH+40
RPHSAVE1 EQU   RPHWORK
RPHSBITS EQU   RPHSAVE1+1
ISTDCCRR EQU   0
CRRSPACE EQU   ISTDCCRR+12
CRRSAREA EQU   0
CRRSAVE1 EQU   CRRSAREA+72
CRRFSB   EQU   CRRSAREA+144
CRRMAS   EQU   CRRSAREA+148
CRRMAS1  EQU   CRRMAS
CRRMAS2  EQU   CRRMAS+1
CRRMAS3  EQU   CRRMAS+2
CRRM50   EQU   CRRMAS3
CRRMAS4  EQU   CRRMAS+3
CRRRMAS1 EQU   CRRMAS+4
CRRRMAS2 EQU   CRRMAS+5
CRRRMAS3 EQU   CRRMAS+6
CRRSMAS  EQU   CRRRMAS3
CRRATS   EQU   CRRSAREA+156
CRRATS1  EQU   CRRATS
CRRATS2  EQU   CRRATS+1
CRRATS3  EQU   CRRATS+2
CRRC50   EQU   CRRATS3
CRRATS4  EQU   CRRATS+3
CRRRATS1 EQU   CRRATS+4
CRRRATS2 EQU   CRRATS+5
CRRRATS3 EQU   CRRATS+6
CRRSATS  EQU   CRRRATS3
CRRFLGS1 EQU   CRRSAREA+164
CRRFLGS2 EQU   CRRSAREA+165
CRRENDLW EQU   CRRFLGS2
CRRPOST  EQU   CRRFLGS2
CRRFLGS3 EQU   CRRSAREA+166
CRRFLGS4 EQU   CRRSAREA+167
CRRFMCLK EQU   CRRFLGS4
CRRFLGS  EQU   CRRSAREA+168
CRRSW0   EQU   CRRFLGS
CRRSW1   EQU   CRRFLGS
CRRSW4   EQU   CRRFLGS
CRRSW5   EQU   CRRFLGS
CRRSW6   EQU   CRRFLGS
CRRSW7   EQU   CRRFLGS
CRRRFLG1 EQU   CRRSAREA+169
CRRDBLCK EQU   CRRRFLG1
CRRRTYPE EQU   CRRRFLG1
CRRFDBK1 EQU   CRRSAREA+170
CRRRTNCD EQU   CRRFDBK1
CRRFDB2  EQU   CRRFDBK1+1
CRRERLK  EQU   CRRFDB2
CRRSTSAV EQU   CRRFDB2
CRRFDB3  EQU   CRRFDBK1+2
CRRUINPT EQU   CRRFDB3
CRRUNUSD EQU   CRRFDB3
CRRRDEOB EQU   CRRFDB3
CRRRDEOM EQU   CRRFDB3
CRRRDEOT EQU   CRRFDB3
CRRRLG   EQU   CRRFDB3
CRRFDBK2 EQU   CRRSAREA+176
CRRDSB   EQU   CRRFDBK2
CRRESR   EQU   CRRFDBK2+2
CRRESR1  EQU   CRRESR
CRRESR2  EQU   CRRESR+1
CRRFMCB  EQU   CRRSAREA+184
CRRLCPB  EQU   CRRSAREA+192
CRRTRBUF EQU   CRRSAREA+204
CRRARPL  EQU   CRRTRBUF+4
CRRATCVT EQU   CRRSAREA+216
CRRRTN1  EQU   CRRSAREA+224
CRRRTN2  EQU   CRRSAREA+228
CRRRTN3  EQU   CRRSAREA+232
CRRRTN4  EQU   CRRSAREA+236
CRRRTN6  EQU   CRRSAREA+244
CRRRTN7  EQU   CRRSAREA+248
CRRRTN8  EQU   CRRSAREA+252
CRRRTN9  EQU   CRRSAREA+256
CRRBARAD EQU   CRRSAREA+272
CRRBLDAD EQU   CRRSAREA+276
CRRBFLGS EQU   CRRSAREA+280
CRRBRTCD EQU   CRRSAREA+281
CRRBLEN  EQU   CRRSAREA+282
CRRBTLEN EQU   CRRSAREA+284
ISTZSAVE EQU   0
ZSAZSVBC EQU   ISTZSAVE
ZSAZSVMS EQU   ZSAZSVBC
ISTPFCRR EQU   0
PFCCRR   EQU   ISTPFCRR
PFCCRRID EQU   PFCCRR
PFCCRRLN EQU   PFCCRR+2
PFCHDR   EQU   ISTPFCRR+4
PFCCRRO  EQU   PFCHDR
PFCFRRO  EQU   PFCHDR+4
ISTCFCRR EQU   0
CFCAUDIT EQU   ISTCFCRR
CFCNTRD  EQU   CFCAUDIT
CFCCRT   EQU   CFCAUDIT+1
ISTZCRR  EQU   0
ZCRCRR   EQU   ISTZCRR
ZCRFLGS1 EQU   ISTZCRR+12
ZCRFLGS2 EQU   ISTZCRR+13
ZCRSWFLD EQU   ISTZCRR+14
ZCRENDSH EQU   ZCRSWFLD
ZCRNDLCP EQU   ZCRSWFLD
ZCRRESET EQU   ZCRSWFLD
ZCRFLGS3 EQU   ISTZCRR+15
ZCRGENSW EQU   ISTZCRR+16
ZCRPFLGS EQU   ISTZCRR+17
ZCRIBPR  EQU   ISTZCRR+18
ZCRSCPSW EQU   ISTZCRR+19
ZCRPARMS EQU   ISTZCRR+24
ZCRFBPTR EQU   ZCRPARMS
ZCRDFRDA EQU   ZCRPARMS+10
ZCRPCOD1 EQU   ZCRPARMS+12
ZCRPLSBF EQU   ZCRPCOD1
ZCRPCOD2 EQU   ZCRPARMS+13
ZCRSVRTN EQU   ISTZCRR+56
ZCRWKARA EQU   ISTZCRR+156
ZCRCIDSV EQU   ISTZCRR+192
ZCRAUDIT EQU   ISTZCRR+440
ZCRENTER EQU   ZCRAUDIT+5
ZCRLCPB  EQU   ISTZCRR+480
ZCRRHRU  EQU   ZCRLCPB
ISTASCRR EQU   0
ASCFLAGS EQU   ISTASCRR+16
ASCFLG1  EQU   ASCFLAGS
ASCFLG2  EQU   ASCFLAGS+2
ASCFLG3  EQU   ASCFLAGS+4
ASCUSRGS EQU   ISTASCRR+28
ISTAPCRR EQU   0
APCATFLG EQU   ISTAPCRR+16
APCRFLG  EQU   ISTAPCRR+18
APCSAVE  EQU   ISTAPCRR+44
APCCOMF  EQU   ISTAPCRR+116
APCCOMF1 EQU   APCCOMF
APC31FLG EQU   ISTAPCRR+132
APC52FLG EQU   ISTAPCRR+133
APC53FLG EQU   ISTAPCRR+134
APC54FLG EQU   ISTAPCRR+135
APC57FLG EQU   ISTAPCRR+136
ISTCRA   EQU   0
CRABASIC EQU   ISTCRA
CRAHDR   EQU   CRABASIC
CRALKACT EQU   CRABASIC+8
CRAL5PTR EQU   CRABASIC+28
CRAL8PTR EQU   CRABASIC+40
CRAPROCR EQU   ISTCRA+312
CRASVC   EQU   ISTCRA+848
CRABUFA  EQU   CRASVC+68
ISTUECB  EQU   0
UECPLIST EQU   ISTUECB+32
UECACB   EQU   UECPLIST
UECNDID  EQU   UECPLIST+4
UECTPNCD EQU   UECNDID
UECREQTR EQU   UECPLIST+8
UECDLEN  EQU   UECPLIST+12
UECRSNCD EQU   UECDLEN
ISTLOK   EQU   0
LOKCHN   EQU   ISTLOK+1
LOKCHNG  EQU   LOKCHN
@NM00107 EQU   LOKCHNG+2
ISTDYPAB EQU   0
ISTATCVT EQU   0
ATCCOM   EQU   ISTATCVT
ATCSTAT  EQU   ATCCOM
ATCSTAT1 EQU   ATCSTAT
ATCSTFLG EQU   ATCSTAT+1
ATCPOFLG EQU   ATCSTAT+2
ATCSTAT4 EQU   ATCSTAT+3
ATCBPDA  EQU   ATCCOM+128
ATCIOTRC EQU   ATCCOM+140
ATCTHTRC EQU   ATCIOTRC
ATCSMRQ  EQU   ATCCOM+180
ATCSMRS  EQU   ATCCOM+188
ATCDCC60 EQU   ATCCOM+212
ATCDCC61 EQU   ATCCOM+216
ATCESC01 EQU   ISTATCVT+288
ATCCSMR  EQU   ISTATCVT+296
ATCSHRFG EQU   ISTATCVT+316
ATCHPGM  EQU   ISTATCVT+384
ATCAP33  EQU   ISTATCVT+444
ATCAP36  EQU   ISTATCVT+452
ATCVLCNT EQU   ISTATCVT+772
ATCRNO   EQU   ISTATCVT+788
ATCSOPD  EQU   ISTATCVT+792
ATCSIPD  EQU   ISTATCVT+800
ATCSECST EQU   ISTATCVT+812
ATCSTAT2 EQU   ISTATCVT+818
ATCVTBAM EQU   ISTATCVT+908
@NM00115 EQU   ATCVTBAM+3
ATCAOSM  EQU   ISTATCVT+912
ATCGSRBQ EQU   ATCAOSM+4
ATCGSRBG EQU   ATCGSRBQ
ATCAP31  EQU   ATCAOSM+24
ATCAP34  EQU   ATCAOSM+32
ATCICAPP EQU   ATCAOSM+100
ATCLDAPP EQU   ATCAOSM+120
ATCDAPVT EQU   ATCAOSM+140
ATCAP37  EQU   ATCAOSM+264
ATCCRA   EQU   ATCAOSM+280
ATCCRACN EQU   ATCCRA+4
ATCSRB   EQU   ATCAOSM+288
ATCSRBCN EQU   ATCSRB+4
ATCCRPL  EQU   ATCAOSM+296
ATCRPLCN EQU   ATCCRPL+4
ATCSQAFR EQU   ATCAOSM+304
ATCORTBC EQU   ATCSQAFR+4
ATCORSRB EQU   ATCORTBC
@NM00117 EQU   ATCAOSM+332
ATCVTFLG EQU   ATCAOSM+392
ATCZFLAG EQU   ATCAOSM+588
ISTDEVCH EQU   0
DEVSHCH  EQU   ISTDEVCH
DEVCHAR  EQU   DEVSHCH
DEVTCODE EQU   ISTDEVCH+1
DEVCHAR2 EQU   DEVTCODE
DEVFLAGS EQU   ISTDEVCH+3
DEVFCCTL EQU   DEVFLAGS
DEVCBSC  EQU   DEVFCCTL
DEVCRVB  EQU   DEVFCCTL
DEVCHAR3 EQU   DEVFLAGS
ISTPROCD EQU   0
PROPROC  EQU   ISTPROCD
PROPROC1 EQU   PROPROC
PROTRUNC EQU   PROPROC1
PROPROC2 EQU   PROPROC+1
PROCFTX  EQU   PROPROC2
PROPROC3 EQU   PROPROC+2
PROPROC4 EQU   PROPROC+3
PROPROCS EQU   0
PROSETMS EQU   PROPROCS+1
PROSETM2 EQU   PROSETMS
PROSETM3 EQU   PROSETMS+1
PROSETM4 EQU   PROSETMS+2
ISTFMCB  EQU   0
FMCSAF   EQU   ISTFMCB+2
FMCDNCBA EQU   ISTFMCB+16
FMCSTAT  EQU   ISTFMCB+28
FMCSTAT1 EQU   ISTFMCB+29
FMCCMDFL EQU   ISTFMCB+31
FMCDEBA  EQU   ISTFMCB+32
FMCCMPS1 EQU   ISTFMCB+36
FMCBUFLM EQU   FMCCMPS1
FMCBUFNB EQU   FMCCMPS1+2
FMCPROCD EQU   ISTFMCB+48
FMCPAB3  EQU   ISTFMCB+96
FMCSIPA  EQU   ISTFMCB+148
FMCNXOSQ EQU   ISTFMCB+152
FMCNXCFM EQU   FMCNXOSQ
FMCNXOSC EQU   FMCNXOSQ+2
FMCSSTAT EQU   ISTFMCB+159
FMCPACE  EQU   ISTFMCB+160
FMCPACEN EQU   FMCPACE
FMCPACEM EQU   FMCPACE+1
FMCPACPC EQU   FMCPACE+2
FMCCVAL  EQU   FMCPACE+3
FMCOBCE  EQU   FMCCVAL
FMCCLEXT EQU   ISTFMCB+164
FMCRPLA  EQU   FMCCLEXT
FMCFBA   EQU   FMCCLEXT+4
FMCRAFM  EQU   FMCCLEXT+8
FMCDCLOK EQU   FMCCLEXT+12
FMCCMPS2 EQU   FMCCLEXT+16
FMCFLGA  EQU   FMCCMPS2
FMCFLGA1 EQU   FMCFLGA
FMCFLGA2 EQU   FMCFLGA
FMCFLGA3 EQU   FMCFLGA
FMCFLGA4 EQU   FMCFLGA
FMCFLGA5 EQU   FMCFLGA
FMCFLGCL EQU   FMCCMPS2+1
FMCPSCMD EQU   FMCCMPS2+2
FMCPSTAT EQU   FMCCMPS2+3
FMCSTAT2 EQU   ISTFMCB+186
FMCMODEB EQU   ISTFMCB+189
FMCCLSEQ EQU   ISTFMCB+190
FMCRRESP EQU   ISTFMCB+195
FMCSSEGQ EQU   ISTFMCB+200
FMCFBAS  EQU   ISTFMCB+216
FMCZV002 EQU   FMCFBAS
FMCSNCTL EQU   ISTFMCB+224
FMCSCFLG EQU   FMCSNCTL
FMCVS1   EQU   ISTFMCB+232
FMCZFLAG EQU   FMCVS1
FMCZF006 EQU   FMCZFLAG
FMCZF019 EQU   FMCZFLAG+3
FMCLBXM  EQU   FMCVS1+12
FMCSHEAQ EQU   FMCLBXM
FMCLCPBQ EQU   FMCVS1+16
FMCLCPAQ EQU   FMCVS1+20
FMCSEQ1  EQU   FMCVS1+34
FMCZFLG2 EQU   FMCVS1+35
FMCCVFLG EQU   FMCVS1+44
FMCFLAG  EQU   0
FMCFLGB  EQU   FMCFLAG
ISTFSB   EQU   0
FSBFSB   EQU   ISTFSB
FSBMNRCD EQU   FSBFSB+2
FSBMNELI EQU   FSBMNRCD
FSBSFLGS EQU   FSBFSB+3
FSBFSBA  EQU   FSBFSB+4
FSBBTH   EQU   FSBFSB+8
FSBCID   EQU   FSBBTH
FSBRQTAG EQU   FSBBTH+4
FSBSEQID EQU   FSBRQTAG
FSBFLAGS EQU   FSBSEQID
FSBSEQ   EQU   FSBSEQID+1
FSBCSWST EQU   FSBBTH+6
FSBTHFLD EQU   FSBCSWST
FSBTH1   EQU   FSBTHFLD
FSBSYSRS EQU   FSBTH1
FSBTH2   EQU   FSBTHFLD+1
FSBEXTRS EQU   FSBTH2
FSBXFSTS EQU   FSBEXTRS
FSBXCODE EQU   FSBEXTRS
FSBNETRS EQU   FSBFSB+16
FSBSRCAT EQU   FSBNETRS
FSBMJRCD EQU   FSBSRCAT
FSBERC   EQU   FSBNETRS+1
FSBELI   EQU   FSBERC
FSBECI   EQU   FSBERC
FSBEBI   EQU   FSBERC
FSBFBMI  EQU   FSBERC
FSBLGI   EQU   FSBERC
FSBSOHI  EQU   FSBERC
FSBDMGRS EQU   FSBFSB+18
FSBSS1   EQU   FSBDMGRS
FSBSS2   EQU   FSBDMGRS+1
FSBLCPB  EQU   FSBFSB+20
FSBMSGID EQU   FSBLCPB
FSBLCCWA EQU   FSBFSB+24
FSBRLSTS EQU   FSBLCCWA
FSBFDB   EQU   ISTFSB+32
ISTACDEB EQU   0
ACDVTPRX EQU   ISTACDEB
ACDDBPFX EQU   ISTACDEB+16
ACDTBLOF EQU   ACDDBPFX+6
ACDBASIC EQU   ISTACDEB+24
ACDTCBAD EQU   ACDBASIC
ACDNMSUB EQU   ACDTCBAD
ACDDEBAD EQU   ACDBASIC+4
ACDUSRPG EQU   ACDBASIC+16
ACDACBAD EQU   ACDBASIC+24
ACDAPPAD EQU   ACDBASIC+28
ACDVTAM  EQU   ISTACDEB+56
ACDLOCK  EQU   ACDVTAM
ACDRAFQ  EQU   ACDVTAM+12
ACDRARQ  EQU   ACDVTAM+16
ACDSSFLG EQU   ACDVTAM+80
ACDAPDAT EQU   ACDVTAM+83
ISTDCLCP EQU   0
DCLLCPB  EQU   ISTDCLCP
DCLLCCW2 EQU   ISTDCLCP+56
DCLRPLA  EQU   ISTDCLCP+72
DCLRTYPE EQU   ISTDCLCP+76
DCLRQTP  EQU   DCLRTYPE
DCLRFLG  EQU   DCLRTYPE+1
DCLFLAG1 EQU   ISTDCLCP+78
DCLSRESW EQU   DCLFLAG1
DCLBTEIS EQU   DCLFLAG1
DCLIOBUF EQU   ISTDCLCP+84
DCLBTLEN EQU   ISTDCLCP+92
DCLIOLEN EQU   ISTDCLCP+96
ISTNCB   EQU   0
NCBDAF   EQU   ISTNCB+2
NCBFLAGS EQU   ISTNCB+24
NCBFRAS  EQU   NCBFLAGS+1
NCBFTRIO EQU   NCBFRAS
NCBFLAG1 EQU   NCBFLAGS+2
NCBDEVCH EQU   ISTNCB+36
ISTDNCB  EQU   0
DNCOS    EQU   ISTDNCB+56
DNCZFLGS EQU   DNCOS
DNCBSCED EQU   DNCOS+2
ISTWKE   EQU   0
WKECHAIN EQU   ISTWKE+4
WKEFLAGS EQU   WKECHAIN
ISTAVT   EQU   0
ISTAS49  EQU   ISTAVT+4
MOVE60   EQU   0
MOVE61   EQU   0
FMZL0007 EQU   0
FMZL0012 EQU   0
FMZL0020 EQU   0
FMZL0030 EQU   0
FMZL0035 EQU   0
FMZL0040 EQU   0
FMZL0050 EQU   0
FMZL0060 EQU   0
FMZL0065 EQU   0
FMZL0086 EQU   0
FMZL0102 EQU   0
FMZL0118 EQU   0
FMZL0150 EQU   0
ISTAPC34 EQU   0
FMZL0180 EQU   0
ISTACB   EQU   0
ISTAPC37 EQU   0
ISTRPL   EQU   0
FLC      EQU   PSA
PSARSVTE EQU   PSARSVT
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
LCPZTIE  EQU   LCPCID
LCPZSNAM EQU   LCPZTIE+8
FSBCOMBN EQU   FSBNETRS
FSBRHFLD EQU   FSBCOMBN+1
FSBRH3   EQU   FSBRHFLD+2
FSBLDFLG EQU   FSBRH3
@NM00131 EQU   FSBRQTAG
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
FSBRT0B  EQU   @NM00131+1
FSBRT0A  EQU   @NM00131+1
FSBRT09  EQU   @NM00131+1
FSBRT08  EQU   @NM00131+1
FSBRT07  EQU   @NM00131
FSBRT06  EQU   @NM00131
FSBRT05  EQU   @NM00131
FSBRT04  EQU   @NM00131
FSBRT03  EQU   @NM00131
FSBRT02  EQU   @NM00131
FSBRT01  EQU   @NM00131
FSBRT00  EQU   @NM00131
FSBLDCUF EQU   FSBLDFLG
FSBLDSIF EQU   FSBLDFLG
FSBLDSOF EQU   FSBLDFLG
FSBLDEBF EQU   FSBLDFLG
FSBLDBBF EQU   FSBLDFLG
FSBLDFME EQU   FSBLDFLG
FSBLDSCF EQU   FSBLDFLG
FSBLDRMF EQU   FSBLDFLG
FSBRH2   EQU   FSBRHFLD+1
FSBRH1   EQU   FSBRHFLD
FSBALIGN EQU   FSBCOMBN
LCPZTRV4 EQU   LCPZSNAM+4
LCPZTRV1 EQU   LCPZSNAM
LCPZSNA  EQU   LCPZTIE+4
LCPZFMCA EQU   LCPZTIE
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTRV620 EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTIRM   EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRV607 EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
ISTPDAVP EQU   ISTAVT+40
ISTAVR01 EQU   ISTAVT+38
ISTVTTP  EQU   ISTAVT+36
ISTAGTWT EQU   ISTAVT+34
ISTATRT  EQU   ISTAVT+32
ISTARID  EQU   ISTAVT+30
ISTX1    EQU   ISTAVT+29
ISTPHNM  EQU   ISTAVT+24
ISTAPSEX EQU   ISTAVT+20
ISTVTTIK EQU   ISTAVT+18
AVTASID  EQU   ISTAVT+16
ISTAPSTA EQU   ISTAVT+12
ISTAS53  EQU   ISTAVT+8
ISTAHIP  EQU   ISTAS49
ISTACVT  EQU   ISTAVT
WKECHNGP EQU   WKECHAIN+1
@NM00135 EQU   WKEFLAGS
WKEGATE  EQU   WKEFLAGS
@NM00134 EQU   ISTWKE
DNCZC001 EQU   DNCOS+40
DNCLOCK  EQU   DNCOS+36
DNCZV005 EQU   DNCOS+32
DNCZV004 EQU   DNCOS+28
DNCZV003 EQU   DNCOS+24
DNCZV002 EQU   DNCOS+21
DNCZX001 EQU   DNCOS+20
DNCZV001 EQU   DNCOS+17
DNCZX003 EQU   DNCOS+16
DNCZV000 EQU   DNCOS+12
DNCSESCQ EQU   DNCOS+8
DNCSESIQ EQU   DNCOS+4
DNCACIP  EQU   DNCBSCED+1
DNCLICP  EQU   DNCBSCED
DNCZF008 EQU   DNCZFLGS+1
DNCZPSRD EQU   DNCZFLGS+1
DNCPSOL  EQU   DNCZFLGS+1
DNCZF007 EQU   DNCZFLGS+1
DNCZF006 EQU   DNCZFLGS+1
DNCZF005 EQU   DNCZFLGS+1
DNCZF004 EQU   DNCZFLGS+1
DNCZF003 EQU   DNCZFLGS
DNCZF002 EQU   DNCZFLGS
DNCZRSCH EQU   DNCZFLGS
DNCDISC  EQU   DNCZFLGS
DNCCONT  EQU   DNCZFLGS
DNCINVIT EQU   DNCZFLGS
DNCSESS  EQU   DNCZFLGS
DNCZF001 EQU   DNCZFLGS
DNCMODE  EQU   ISTDNCB+49
DNCBHSET EQU   ISTDNCB+48
DNCNCB   EQU   ISTDNCB
NCBRSV01 EQU   ISTNCB+46
NCBSWDAF EQU   ISTNCB+44
NCBFMCBP EQU   ISTNCB+32
NCBLTRC  EQU   ISTNCB+30
NCBRVPT1 EQU   ISTNCB+28
NCBNMLLN EQU   NCBFLAGS+3
@NM00133 EQU   NCBFLAG1
NCBFORCE EQU   NCBFLAG1
NCBTTF   EQU   NCBFLAG1
NCBRSYNC EQU   NCBFLAG1
NCBRSTRT EQU   NCBFLAG1
NCBCONF  EQU   NCBFLAG1
NCBSNAI  EQU   NCBFLAG1
NCBFLTIO EQU   NCBFTRIO
NCBCSTAT EQU   NCBFLAGS
NCBNCSL  EQU   ISTNCB+22
NCBNCBA  EQU   ISTNCB+20
NCBFMCBA EQU   ISTNCB+16
NCBNSNA  EQU   ISTNCB+12
NCBTSKID EQU   ISTNCB+8
NCBRDTE  EQU   ISTNCB+4
NCBLNGTH EQU   ISTNCB+1
NCBTYPE  EQU   ISTNCB
DCLECHAR EQU   ISTDCLCP+98
DCLCLDOA EQU   ISTDCLCP+88
DCLLDO1  EQU   ISTDCLCP+80
DCLRSV03 EQU   ISTDCLCP+79
DCLRSV02 EQU   DCLFLAG1
DCLRPLS  EQU   DCLFLAG1
DCLNODE  EQU   DCLFLAG1
DCLRSV04 EQU   DCLFLAG1
DCLBNSP  EQU   DCLRFLG
DCLCONV  EQU   DCLRFLG
DCLRSV01 EQU   DCLRFLG
DCLLCCW3 EQU   ISTDCLCP+64
ACDREFQ  EQU   ISTACDEB+204
ACDASFQ  EQU   ISTACDEB+200
ACDSOP   EQU   ISTACDEB+184
ACDSIP   EQU   ISTACDEB+168
ACDRSV24 EQU   ACDVTAM+108
ACDRSV23 EQU   ACDVTAM+104
ACDRSV22 EQU   ACDVTAM+100
ACDOCWAD EQU   ACDVTAM+96
ACDRSV10 EQU   ACDVTAM+92
ACDAPDDT EQU   ACDAPDAT+1
ACDAPDLN EQU   ACDAPDAT
ACDRSV07 EQU   ACDVTAM+82
ACDRSV06 EQU   ACDVTAM+81
@NM00132 EQU   ACDSSFLG
ACDTSO   EQU   ACDSSFLG
ACDTPEND EQU   ACDSSFLG
ACDAICLS EQU   ACDSSFLG
ACDABEND EQU   ACDSSFLG
ACDCACB  EQU   ACDSSFLG
ACDRSV21 EQU   ACDVTAM+64
ACDSSPAB EQU   ACDVTAM+48
ACDNEPAB EQU   ACDVTAM+32
ACDRSV20 EQU   ACDVTAM+20
ACDFMCB  EQU   ACDVTAM+8
ACDRDTE  EQU   ACDVTAM+4
ACDAPP   EQU   ACDAPPAD+1
ACDEXSCL EQU   ACDAPPAD
ACDACB   EQU   ACDACBAD+1
ACDDEBID EQU   ACDACBAD
ACDPROTG EQU   ACDACBAD
ACDECBAD EQU   ACDBASIC+20
ACDUSRPB EQU   ACDUSRPG+1
ACDNMEXT EQU   ACDUSRPG
ACDPRLEN EQU   ACDBASIC+15
ACDFLGS1 EQU   ACDBASIC+14
ACDQSCNT EQU   ACDBASIC+13
ACDOPATB EQU   ACDBASIC+12
ACDIRBAD EQU   ACDBASIC+8
ACDDEB   EQU   ACDDEBAD+1
ACDAMLNG EQU   ACDDEBAD
ACDTCB   EQU   ACDTCBAD+1
ACDOPNAD EQU   ACDNMSUB
ACDRSV03 EQU   ACDTBLOF+1
ACDRSV02 EQU   ACDTBLOF
ACDAMTYP EQU   ACDDBPFX+5
ACDLENG  EQU   ACDDBPFX+4
ACDDEBX  EQU   ACDDBPFX
ACDRSV08 EQU   ACDVTPRX+12
ACDTSKID EQU   ACDVTPRX+8
ACDCHN   EQU   ACDVTPRX+4
ACDSAF   EQU   ACDVTPRX+2
ACDLNGTH EQU   ACDVTPRX+1
ACDTYPE  EQU   ACDVTPRX
FSBRSV01 EQU   FSBFSB+30
FSBTHCNT EQU   FSBFSB+28
FSBRLRSV EQU   FSBRLSTS
FSBCFTX  EQU   FSBRLSTS
FSBICNCB EQU   FSBMSGID
FSBSSOC  EQU   FSBSS2
FSBSSCC  EQU   FSBSS2
FSBSSDC  EQU   FSBSS2
FSBSSEC  EQU   FSBSS2
FSBSSIR  EQU   FSBSS2
FSBSSCR  EQU   FSBSS2
@NM00130 EQU   FSBSS2
@NM00129 EQU   FSBSS1
FSBSSDE  EQU   FSBSS1
FSBSSUS  EQU   FSBSS1
@NM00128 EQU   FSBSS1
FSBLMRI  EQU   FSBFBMI
FSBETI   EQU   FSBERC
FSBEMI   EQU   FSBERC
FSBXLCI  EQU   FSBXCODE
FSBXFINS EQU   FSBXCODE
FSBXNORM EQU   FSBXFSTS
FSBSCODE EQU   FSBSYSRS
FSBSPHSE EQU   FSBSYSRS
FSBSERR  EQU   FSBSYSRS
FSBCMD   EQU   FSBSEQ
FSBDTRCE EQU   FSBFLAGS
FSBASBTU EQU   FSBFLAGS
FSBINPET EQU   FSBFLAGS
FSBNONCB EQU   FSBFLAGS
FSBLBIND EQU   FSBFLAGS
FSBFFIND EQU   FSBFLAGS
FSBACIND EQU   FSBFLAGS
FSBRFIND EQU   FSBFLAGS
FSBDAF   EQU   FSBCID+2
FSBSAF   EQU   FSBCID
FSBGATE  EQU   FSBFSBA
FSBLATOP EQU   FSBSFLGS
FSBRSV02 EQU   FSBSFLGS
FSBPGBUF EQU   FSBSFLGS
FSBMNSDA EQU   FSBMNRCD
FSBMNOA  EQU   FSBMNRCD
FSBMNDIF EQU   FSBMNRCD
FSBMNEOP EQU   FSBMNRCD
FSBMNDNU EQU   FSBMNRCD
FSBMNATN EQU   FSBMNRCD
FSBMNRVI EQU   FSBMNRCD
FSBLNGTH EQU   FSBFSB+1
FSBTYPE  EQU   FSBFSB
FMCFLRSV EQU   FMCFLGB
FMCFLGA8 EQU   FMCFLGB
FMCCLRPH EQU   FMCVS1+45
FMCRSV0X EQU   FMCCVFLG
FMCFRRPH EQU   FMCCVFLG
FMCOWRPH EQU   FMCCVFLG
FMCCDRPH EQU   FMCCVFLG
FMCPSRPH EQU   FMCCVFLG
FMCVYRPH EQU   FMCCVFLG
FMCZV004 EQU   FMCVS1+40
FMCLOCK2 EQU   FMCVS1+36
@NM00127 EQU   FMCZFLG2
FMCZF027 EQU   FMCZFLG2
FMCZF026 EQU   FMCZFLG2
FMCSEQ1B EQU   FMCSEQ1
FMCSEQ1T EQU   FMCSEQ1
FMCZX006 EQU   FMCVS1+33
FMCZX005 EQU   FMCVS1+32
FMCZX004 EQU   FMCVS1+31
FMCZX003 EQU   FMCVS1+30
FMCZX002 EQU   FMCVS1+29
FMCZX001 EQU   FMCVS1+28
FMCZV001 EQU   FMCVS1+24
FMCAWATQ EQU   FMCLCPAQ+1
@NM00126 EQU   FMCLCPAQ
FMCLCPB2 EQU   FMCLCPBQ+1
FMCLCPB1 EQU   FMCLCPBQ
FMCASCDQ EQU   FMCSHEAQ+1
@NM00125 EQU   FMCSHEAQ
FMCSHEDQ EQU   FMCVS1+8
FMCZFCSQ EQU   FMCVS1+6
FMCZH001 EQU   FMCVS1+4
FMCZF025 EQU   FMCZFLAG+3
FMCZF024 EQU   FMCZFLAG+3
FMCZF023 EQU   FMCZFLAG+3
FMCZF022 EQU   FMCZFLAG+3
FMCZF021 EQU   FMCZFLAG+3
FMCZF020 EQU   FMCZFLAG+3
FMCZF018 EQU   FMCZFLAG+3
FMCZF017 EQU   FMCZFLAG+2
FMCZF016 EQU   FMCZFLAG+2
FMCZF015 EQU   FMCZFLAG+2
FMCZF014 EQU   FMCZFLAG+2
FMCZF013 EQU   FMCZFLAG+2
FMCZF012 EQU   FMCZFLAG+2
FMCZF011 EQU   FMCZFLAG+2
FMCZF010 EQU   FMCZFLAG+2
FMCZF00F EQU   FMCZFLAG+1
FMCZF00E EQU   FMCZFLAG+1
FMCZF00D EQU   FMCZFLAG+1
FMCZF00C EQU   FMCZFLAG+1
FMCZF00B EQU   FMCZFLAG+1
FMCRSV10 EQU   FMCZFLAG+1
FMCZF009 EQU   FMCZFLAG+1
FMCZFD06 EQU   FMCZF006+1
FMCZFC06 EQU   FMCZF006
FMCZFB06 EQU   FMCZF006
FMCZFA06 EQU   FMCZF006
FMCZF005 EQU   FMCZFLAG
FMCZF004 EQU   FMCZFLAG
FMCZF003 EQU   FMCZFLAG
FMCZF002 EQU   FMCZFLAG
FMCZF001 EQU   FMCZFLAG
FMCFRESA EQU   ISTFMCB+228
FMCSCSQN EQU   FMCSNCTL+2
FMCSCCTL EQU   FMCSNCTL+1
FMCSTCTL EQU   FMCSCFLG
FMCSCCLO EQU   FMCSCFLG
FMCAPRO  EQU   FMCSCFLG
FMCLURO  EQU   FMCSCFLG
FMCOBSAC EQU   FMCSCFLG
FMCIBSAC EQU   FMCSCFLG
FMCFBRE  EQU   ISTFMCB+220
FMCFBXM  EQU   FMCZV002
FMCASEGQ EQU   ISTFMCB+212
FMCRDTPT EQU   ISTFMCB+208
FMCLOCK  EQU   ISTFMCB+204
FMCSEGD  EQU   FMCSSEGQ
FMCRSPLM EQU   ISTFMCB+198
FMCPSTRS EQU   ISTFMCB+196
@NM00124 EQU   FMCRRESP
FMCTSLHA EQU   FMCRRESP
FMCFRRN  EQU   FMCRRESP
FMCFME   EQU   FMCRRESP
FMCFEX   EQU   FMCRRESP
FMCFPE   EQU   FMCRRESP
FMCCTLB  EQU   ISTFMCB+194
FMCBSQNO EQU   FMCCLSEQ+2
FMCTSQNO EQU   FMCCLSEQ
FMCOBPRG EQU   FMCMODEB
FMCIBPRG EQU   FMCMODEB
FMCRESOT EQU   FMCMODEB
FMCRSTSR EQU   FMCMODEB
FMCLUQ   EQU   FMCMODEB
FMCAPQ   EQU   FMCMODEB
FMCCLEAR EQU   FMCMODEB
FMCHOLD  EQU   FMCMODEB
FMCIPSEQ EQU   ISTFMCB+188
FMCLUSTR EQU   ISTFMCB+187
FMCCDPIP EQU   FMCSTAT2
FMCPSPIP EQU   FMCSTAT2
FMCSEQI  EQU   FMCSTAT2
FMCCPIP  EQU   FMCSTAT2
FMCALIPR EQU   FMCSTAT2
FMCIAIO  EQU   FMCSTAT2
FMCZF00A EQU   FMCSTAT2
FMCVPIP  EQU   FMCSTAT2
FMCBHSET EQU   ISTFMCB+185
FMCPRMRC EQU   FMCCLEXT+20
FMCRSV89 EQU   FMCPSTAT
FMCPCLSD EQU   FMCPSTAT
FMCDDOCD EQU   FMCPSTAT
FMCIDVFD EQU   FMCPSTAT
FMCELKST EQU   FMCPSTAT
FMCRSV88 EQU   FMCPSCMD
FMCRDBLK EQU   FMCPSCMD
FMCDSEOC EQU   FMCPSCMD
FMCPURGE EQU   FMCPSCMD
FMCRESTI EQU   FMCPSCMD
FMCCNTCT EQU   FMCPSCMD
FMCINVT  EQU   FMCPSCMD
FMCFLGB7 EQU   FMCFLGCL
FMCFLGB6 EQU   FMCFLGCL
FMCFLGB5 EQU   FMCFLGCL
FMCFLGB4 EQU   FMCFLGCL
FMCFLGB3 EQU   FMCFLGCL
FMCFLGB2 EQU   FMCFLGCL
FMCFLGB1 EQU   FMCFLGCL
FMCFLGB0 EQU   FMCFLGCL
FMCFLGA7 EQU   FMCFLGA
FMCFLGA6 EQU   FMCFLGA
FMCFLGA0 EQU   FMCFLGA
FMCFBPTR EQU   FMCFBA+1
FMCFBRSV EQU   FMCFBA
FMCRPLPT EQU   FMCRPLA+1
FMCRPLRS EQU   FMCRPLA
FMCPRCLS EQU   FMCCVAL
FMCIBCE  EQU   FMCCVAL
FMCONLY  EQU   FMCOBCE
FMCLAST  EQU   FMCOBCE
FMCMIDLE EQU   FMCOBCE
FMCFIRST EQU   FMCOBCE
FMCCPCNT EQU   FMCPACPC
FMCMPCNT EQU   FMCPACEM
FMCNPCNT EQU   FMCPACEN
FMCCONF  EQU   FMCSSTAT
FMCPURCH EQU   FMCSSTAT
FMCNSALU EQU   FMCSSTAT
FMCBIP   EQU   FMCSSTAT
FMCSDTR  EQU   FMCSSTAT
FMCUIPI  EQU   FMCSSTAT
FMCCIPI  EQU   FMCSSTAT
FMCSNBI  EQU   FMCSSTAT
FMCRVD01 EQU   ISTFMCB+158
FMCISSN  EQU   ISTFMCB+156
FMCOASN  EQU   FMCNXOSC
FMCOSSN  EQU   FMCNXCFM
FMCSIP   EQU   FMCSIPA
FMCEXLST EQU   ISTFMCB+144
FMCPAB5  EQU   ISTFMCB+128
FMCPAB4  EQU   ISTFMCB+112
FMCPAB2  EQU   ISTFMCB+80
FMCPAB1  EQU   ISTFMCB+64
FMCFASYA EQU   ISTFMCB+60
FMCMODE  EQU   ISTFMCB+52
FMCVWT   EQU   ISTFMCB+44
FMCRPLH  EQU   ISTFMCB+40
@NM00123 EQU   FMCCMDFL
FMCSNA   EQU   FMCCMDFL
FMCVSNA  EQU   FMCCMDFL
FMCCMDR  EQU   FMCCMDFL
@NM00122 EQU   ISTFMCB+30
@NM00121 EQU   FMCSTAT1
FMCLTCLS EQU   FMCSTAT1
FMCHPURG EQU   FMCSTAT1
FMCVSP2  EQU   FMCSTAT1
FMCVSP1  EQU   FMCSTAT
FMCLTEAS EQU   FMCSTAT
FMCZF007 EQU   FMCSTAT
FMCDEDSC EQU   FMCSTAT
FMCDEVOF EQU   FMCSTAT
FMCDAPT  EQU   FMCSTAT
FMCPRMTE EQU   FMCSTAT
FMCPRMTR EQU   FMCSTAT
FMCUSFLD EQU   ISTFMCB+24
FMCFMCBA EQU   ISTFMCB+20
FMCDVTA  EQU   ISTFMCB+12
FMCTSKID EQU   ISTFMCB+8
FMCNXTCB EQU   ISTFMCB+4
FMCLNGTH EQU   ISTFMCB+1
FMCTYPE  EQU   ISTFMCB
PROSRDEF EQU   PROSETM4
PRORSV47 EQU   PROSETM4
PROSCON  EQU   PROSETM4
PRORSV46 EQU   PROSETM3
PROSMONT EQU   PROSETM3
PRORSV45 EQU   PROSETM3
PROSNTO  EQU   PROSETM3
PRORSV44 EQU   PROSETM3
PROCPUID EQU   PROSETM3
PRORSV43 EQU   PROSETM2
PROSNTFL EQU   PROSETM2
PRORSV42 EQU   PROSETM2
PRORSV41 EQU   PROPROCS
PROMODC  EQU   PROPROC4
PROMODT  EQU   PROPROC4
PROMODM  EQU   PROPROC4
PROMODB  EQU   PROPROC4
PRORSV14 EQU   PROPROC4
PRORSV13 EQU   PROPROC4
PRORSV12 EQU   PROPROC4
PROEIB   EQU   PROPROC4
PROMONT3 EQU   PROPROC3
PROMONT2 EQU   PROPROC3
PROMONIT EQU   PROPROC3
PROSUBLK EQU   PROPROC3
PRONTO   EQU   PROPROC3
PROLGIN  EQU   PROPROC3
PROERPI  EQU   PROPROC3
PRORSV07 EQU   PROPROC3
PROEMLC  EQU   PROPROC2
PRONTFL  EQU   PROPROC2
PRORSV05 EQU   PROPROC2
PRORSV04 EQU   PROPROC2
PROLGOT  EQU   PROPROC2
PROERPO  EQU   PROPROC2
PRORSV03 EQU   PROPROC2
PRORPLC  EQU   PROPROC1
PROCS    EQU   PROPROC1
PROCA    EQU   PROPROC1
PRORESPX EQU   PROPROC1
PRODFASY EQU   PROPROC1
PROXPOPT EQU   PROPROC1
PROASYIP EQU   PROPROC1
DEVRSV03 EQU   ISTDEVCH+5
DEVPHYSA EQU   ISTDEVCH+4
DEVCSLPN EQU   DEVCHAR3
DEVCSTCL EQU   DEVCHAR3
DEVCCHEK EQU   DEVCHAR3
DEVCATTN EQU   DEVCHAR3
DEVCSWL  EQU   DEVFCCTL
DEVCSSL  EQU   DEVFCCTL
DEVMCODE EQU   ISTDEVCH+2
DEVRSV01 EQU   DEVCHAR
DEVCCTL  EQU   DEVCHAR
DEVNNSPT EQU   DEVCHAR
DEVSPS   EQU   DEVCHAR
DEVSUBND EQU   DEVCHAR
DEVCONVR EQU   DEVCHAR
DEVOTPUT EQU   DEVCHAR
DEVINPUT EQU   DEVCHAR
ATCAOS   EQU   ISTATCVT+1584
ATCPOPAB EQU   ATCAOSM+640
ATCVIOPM EQU   ATCAOSM+636
ATCTPMMI EQU   ATCAOSM+632
ATCTPMPB EQU   ATCAOSM+600
ATCRSV88 EQU   ATCAOSM+596
ATCRPLCT EQU   ATCAOSM+594
ATCCRACT EQU   ATCAOSM+592
ATCSRBCT EQU   ATCAOSM+590
ATCRSV75 EQU   ATCAOSM+589
ATCRSV66 EQU   ATCZFLAG
ATCZF001 EQU   ATCZFLAG
ATCTPCP1 EQU   ATCAOSM+584
ATCTPCP0 EQU   ATCAOSM+580
ATCAICTN EQU   ATCAOSM+576
ATCZR01  EQU   ATCAOSM+572
ATCMPLTA EQU   ATCAOSM+568
ATCASCB  EQU   ATCAOSM+564
ATCAP86  EQU   ATCAOSM+560
ATCAP85  EQU   ATCAOSM+556
ATCAP84  EQU   ATCAOSM+552
ATCAP83  EQU   ATCAOSM+548
ATCAP82  EQU   ATCAOSM+544
ATCAP69  EQU   ATCAOSM+540
ATCAP66  EQU   ATCAOSM+536
ATCAP62  EQU   ATCAOSM+532
ATCAPC59 EQU   ATCAOSM+528
ATCAP56  EQU   ATCAOSM+524
ATCAP55  EQU   ATCAOSM+520
ATCRCFY0 EQU   ATCAOSM+516
ATCAP41  EQU   ATCAOSM+512
ATCAPC25 EQU   ATCAOSM+508
ATCAP23  EQU   ATCAOSM+504
ATCTPSPB EQU   ATCAOSM+472
ATCTRMPB EQU   ATCAOSM+440
ATCAPBE  EQU   ATCAOSM+436
ATCPSTA  EQU   ATCAOSM+432
ATCSMABF EQU   ATCAOSM+428
ATCSMAPR EQU   ATCAOSM+424
ATCTPWQA EQU   ATCAOSM+420
ATCSMAID EQU   ATCAOSM+416
ATCSMARA EQU   ATCAOSM+412
ATCCACXA EQU   ATCAOSM+408
ATCZLAAB EQU   ATCAOSM+404
ATCATA10 EQU   ATCAOSM+400
ATCHLTCB EQU   ATCAOSM+396
@NM00120 EQU   ATCVTFLG
ATCVTACT EQU   ATCVTFLG
ATCRPT40 EQU   ATCAOSM+388
ATCRPT39 EQU   ATCAOSM+384
ATCRPT38 EQU   ATCAOSM+380
ATCRPT37 EQU   ATCAOSM+376
ATCRPT36 EQU   ATCAOSM+372
ATCRPT35 EQU   ATCAOSM+368
ATCRPT34 EQU   ATCAOSM+364
ATCRPT33 EQU   ATCAOSM+360
ATCRPT32 EQU   ATCAOSM+356
ATCRPT31 EQU   ATCAOSM+352
ATCRPT30 EQU   ATCAOSM+348
ATCOCWCB EQU   ATCAOSM+344
ATCOCWOB EQU   ATCAOSM+340
ATCRPT27 EQU   ATCAOSM+336
@NM00119 EQU   ATCAOSM+333
@NM00118 EQU   @NM00117
ATCSNUF  EQU   @NM00117
ATCOPKL  EQU   @NM00117
ATCABEN  EQU   @NM00117
ATCAIWT  EQU   ATCAOSM+328
ATCINFDD EQU   ATCAOSM+324
ATCORFMG EQU   ATCAOSM+320
ATCORFRL EQU   ATCAOSM+316
ATCOROBT EQU   ATCAOSM+312
ATCORQG  EQU   ATCORSRB
ATCORTBF EQU   ATCSQAFR
ATCRPLAC EQU   ATCRPLCN+2
ATCRPLRC EQU   ATCRPLCN
ATCCRPLQ EQU   ATCCRPL
ATCSRBAC EQU   ATCSRBCN+2
ATCSRBRC EQU   ATCSRBCN
ATCSRBQ  EQU   ATCSRB
ATCCRAAC EQU   ATCCRACN+2
ATCCRARC EQU   ATCCRACN
ATCCRAQ  EQU   ATCCRA
ATCRPT12 EQU   ATCAOSM+276
ATCDMAPP EQU   ATCAOSM+272
ATCAP38  EQU   ATCAOSM+268
ATCZDFJ0 EQU   ATCAOSM+260
ATCAP51  EQU   ATCAOSM+256
ATCZPAB2 EQU   ATCAOSM+224
ATCZPAB1 EQU   ATCAOSM+192
ATCZLFVT EQU   ATCAOSM+188
ATCZLPVT EQU   ATCAOSM+184
ATCZDVTX EQU   ATCAOSM+180
ATCZDVTA EQU   ATCAOSM+176
ATCZDVT9 EQU   ATCAOSM+172
ATCZDVT8 EQU   ATCAOSM+168
ATCZDVT7 EQU   ATCAOSM+164
ATCRSV56 EQU   ATCDAPVT+22
ATCDAPDG EQU   ATCDAPVT+20
ATCDXCEA EQU   ATCDAPVT+16
ATCDCEA  EQU   ATCDAPVT+12
ATCDPCIA EQU   ATCDAPVT+8
ATCDSIOA EQU   ATCDAPVT+4
ATCDEOEA EQU   ATCDAPVT
ATCZLAEA EQU   ATCLDAPP+16
ATCZLCEA EQU   ATCLDAPP+12
ATCRSV17 EQU   ATCLDAPP+8
ATCSMFRR EQU   ATCLDAPP+4
ATCCDTID EQU   ATCLDAPP
ATCZAEA  EQU   ATCICAPP+16
ATCZCEA  EQU   ATCICAPP+12
ATCCDTCB EQU   ATCICAPP+8
ATCZSIOA EQU   ATCICAPP+4
ATCCDRPH EQU   ATCICAPP
ATCAP65  EQU   ATCAOSM+96
ATCZDVT6 EQU   ATCAOSM+92
ATCZDVT4 EQU   ATCAOSM+88
ATCZDVT3 EQU   ATCAOSM+84
ATCZDVT1 EQU   ATCAOSM+80
ATCICNCB EQU   ATCAOSM+76
ATCZPSVT EQU   ATCAOSM+72
ATCZFSVT EQU   ATCAOSM+68
ATCAP64  EQU   ATCAOSM+64
ATCAP63  EQU   ATCAOSM+60
ATCAP61  EQU   ATCAOSM+56
ATCAP58  EQU   ATCAOSM+52
ATCAP57  EQU   ATCAOSM+48
ATCAP54  EQU   ATCAOSM+44
ATCAP53  EQU   ATCAOSM+40
ATCAP52  EQU   ATCAOSM+36
ATCAP32  EQU   ATCAOSM+28
ATCAP12  EQU   ATCAOSM+20
ATCAP11  EQU   ATCAOSM+16
ATCCMTCB EQU   ATCAOSM+12
ATCPRPH  EQU   ATCAOSM+8
ATCGSRBF EQU   ATCGSRBG
ATCSRBRT EQU   ATCAOSM
@NM00116 EQU   @NM00115
ATCVTMAB EQU   @NM00115
@NM00114 EQU   ATCVTBAM
ATCVDLOK EQU   ISTATCVT+904
ATCVFPAB EQU   ISTATCVT+872
ATCVDPAB EQU   ISTATCVT+840
ATCIOECB EQU   ISTATCVT+836
ATCINCW3 EQU   ISTATCVT+832
ATCMODTB EQU   ISTATCVT+828
ATCUSSPT EQU   ISTATCVT+824
ATCSRTAB EQU   ISTATCVT+820
@NM00113 EQU   ISTATCVT+819
@NM00112 EQU   ATCSTAT2
ATCTRSMS EQU   ATCSTAT2
ATCTRLOK EQU   ATCSTAT2
ATCTRPSS EQU   ATCSTAT2
ATCTRESC EQU   ATCSTAT2
ATCTRAPI EQU   ATCSTAT2
ATCNMCTR EQU   ISTATCVT+816
ATCSEC51 EQU   ATCSECST
ATCSEC40 EQU   ATCSIPD+8
ATCSEC30 EQU   ATCSIPD+4
ATCSEC21 EQU   ATCSIPD
ATCSEC10 EQU   ATCSOPD+4
ATCSEC01 EQU   ATCSOPD
ATCPOIA  EQU   ATCRNO+1
@NM00111 EQU   ATCRNO
ATCPODVT EQU   ISTATCVT+784
ATCS49XL EQU   ISTATCVT+780
ATCS49XI EQU   ISTATCVT+776
ATCLCLCT EQU   ATCVLCNT+2
ATCRNCNT EQU   ATCVLCNT
ATCCFEAD EQU   ISTATCVT+768
ATCPTR00 EQU   ISTATCVT+736
ATCRSV10 EQU   ISTATCVT+704
ATCTACB  EQU   ISTATCVT+700
ATCVTINM EQU   ISTATCVT+696
ATCTCLIM EQU   ISTATCVT+692
ATCTCLOM EQU   ISTATCVT+688
ATCVTIPB EQU   ISTATCVT+656
ATCTCIPB EQU   ISTATCVT+624
ATCTIPAB EQU   ISTATCVT+592
ATCOCCCB EQU   ISTATCVT+588
ATCOCCOB EQU   ISTATCVT+584
ATCCDLAD EQU   ISTATCVT+580
ATCCCLAD EQU   ISTATCVT+576
ATCDLRPB EQU   ISTATCVT+544
ATCPGPAB EQU   ISTATCVT+512
ATCVPAB1 EQU   ISTATCVT+480
ATCRSV97 EQU   ISTATCVT+476
ATCRDTLK EQU   ISTATCVT+472
ATCVOCLK EQU   ISTATCVT+468
ATCCDFDN EQU   ISTATCVT+464
ATCCDFIN EQU   ISTATCVT+460
ATCDVTLK EQU   ISTATCVT+456
ATCAP35  EQU   ISTATCVT+448
ATCRSV99 EQU   ISTATCVT+440
ATCONFIG EQU   ISTATCVT+432
ATCNODDS EQU   ISTATCVT+428
ATCNODEL EQU   ISTATCVT+420
ATCRSV69 EQU   ISTATCVT+416
ATCAPCR5 EQU   ISTATCVT+412
ATCLDECB EQU   ISTATCVT+408
ATCLDNCS EQU   ISTATCVT+404
ATCCDPTR EQU   ISTATCVT+400
ATCADEL  EQU   ISTATCVT+396
ATCTODVT EQU   ISTATCVT+392
ATCDEBCH EQU   ISTATCVT+388
ATCHBSIZ EQU   ATCHPGM+2
ATCHBFNO EQU   ATCHPGM
ATCCRME  EQU   ISTATCVT+380
ATCRVCHS EQU   ISTATCVT+372
ATCECTLP EQU   ISTATCVT+368
ATCZDVTB EQU   ISTATCVT+364
ATCECPRT EQU   ISTATCVT+360
ATCVTLOD EQU   ISTATCVT+356
ATCTRPAB EQU   ISTATCVT+352
ATCMSGM  EQU   ISTATCVT+348
ATCMSGP  EQU   ISTATCVT+344
ATCEPT   EQU   ISTATCVT+340
ATCDVT   EQU   ISTATCVT+336
ATCTRCPT EQU   ISTATCVT+332
ATCDVLOD EQU   ISTATCVT+328
ATCALERT EQU   ISTATCVT+324
ATCEPA   EQU   ISTATCVT+320
ATCSAF   EQU   ISTATCVT+318
ATCXRANG EQU   ISTATCVT+317
ATCLAST  EQU   ATCSHRFG
ATCSHRTN EQU   ISTATCVT+308
ATCUEP   EQU   ISTATCVT+304
ATCOCRT  EQU   ISTATCVT+300
ATCCSMA  EQU   ATCCSMR
ATCESC02 EQU   ISTATCVT+292
ATCCDFND EQU   ISTATCVT+284
ATCCDDEL EQU   ISTATCVT+280
ATCCDADD EQU   ISTATCVT+276
ATCMNT   EQU   ISTATCVT+272
ATCRSV16 EQU   ISTATCVT+270
ATCMAXID EQU   ISTATCVT+269
ATCMSGSP EQU   ATCCOM+268
ATCCIDM  EQU   ATCCOM+266
ATCACTRM EQU   ATCCOM+264
ATCNERAP EQU   ATCCOM+260
ATCNESAL EQU   ATCCOM+256
ATCRCC65 EQU   ATCCOM+252
ATCRCC26 EQU   ATCCOM+248
ATCRCC63 EQU   ATCCOM+244
ATCRSV11 EQU   ATCCOM+242
ATCVTMID EQU   ATCCOM+240
ATCAPOST EQU   ATCCOM+236
ATCNERFN EQU   ATCCOM+232
ATCNERNE EQU   ATCCOM+228
ATCNERCV EQU   ATCCOM+224
ATCNERST EQU   ATCCOM+220
ATCSRTDF EQU   ATCCOM+208
ATCSRTAD EQU   ATCCOM+204
ATCFIRA  EQU   ATCCOM+200
ATCSMBQ  EQU   ATCCOM+196
ATCSMRC  EQU   ATCCOM+192
ATCSMQU  EQU   ATCCOM+184
ATCACDA  EQU   ATCCOM+176
ATCSTMA  EQU   ATCCOM+172
ATCFRSTR EQU   ATCCOM+168
ATCGTSTR EQU   ATCCOM+164
ATCREADA EQU   ATCCOM+160
ATCALOAD EQU   ATCCOM+156
ATCBLDLA EQU   ATCCOM+152
ATCFBRPH EQU   ATCCOM+148
ATCBFTRC EQU   ATCCOM+144
ATCTPBUF EQU   ATCTHTRC
ATCREMOV EQU   ATCCOM+136
ATCADD   EQU   ATCCOM+132
ATCDVTPT EQU   ATCCOM+124
ATCFEPT  EQU   ATCCOM+120
ATCFDVT  EQU   ATCCOM+116
ATCCONFT EQU   ATCCOM+112
ATCPTCHA EQU   ATCCOM+108
ATCAUTHA EQU   ATCCOM+104
ATCACCTA EQU   ATCCOM+100
ATCRDTH  EQU   ATCCOM+96
ATCFRSCH EQU   ATCCOM+92
ATCFSB   EQU   ATCCOM+88
ATCHLTMS EQU   ATCCOM+84
ATCECPRM EQU   ATCCOM+80
ATCECNET EQU   ATCCOM+76
ATCECOPC EQU   ATCCOM+72
ATCVPARM EQU   ATCCOM+68
ATCECVRQ EQU   ATCCOM+64
ATCECSES EQU   ATCCOM+60
ATCOCHA  EQU   ATCCOM+56
ATCDSPLQ EQU   ATCCOM+52
ATCECDSP EQU   ATCCOM+48
ATCVARYQ EQU   ATCCOM+44
ATCECVRY EQU   ATCCOM+40
ATCHALTQ EQU   ATCCOM+36
ATCECHLT EQU   ATCCOM+32
ATCMODQ  EQU   ATCCOM+28
ATCECMOD EQU   ATCCOM+24
ATCASCHD EQU   ATCCOM+20
ATCSRT   EQU   ATCCOM+16
ATCRDT   EQU   ATCCOM+12
ATCDCFRR EQU   ATCCOM+8
ATCAPI   EQU   ATCCOM+4
ATCRSV04 EQU   ATCSTAT4
ATCVTTRC EQU   ATCSTAT4
ATCNCSD  EQU   ATCSTAT4
ATCMTST  EQU   ATCSTAT4
ATCTPRT  EQU   ATCSTAT4
ATCPRTAT EQU   ATCSTAT4
@NM00110 EQU   ATCPOFLG
ATCPOUNS EQU   ATCPOFLG
ATCHSDMF EQU   ATCSTFLG
@NM00109 EQU   ATCSTAT1
ATCMDHLT EQU   ATCSTAT1
ATCINHLT EQU   ATCSTAT1
ATCNETSL EQU   ATCSTAT1
ATCQKHLT EQU   ATCSTAT1
ATCSNHLT EQU   ATCSTAT1
ATCACTIV EQU   ATCSTAT1
ATCSTART EQU   ATCSTAT1
DYPPAB   EQU   ISTDYPAB+16
DYPRSV01 EQU   ISTDYPAB+12
DYPTSKID EQU   ISTDYPAB+8
DYPCHAIN EQU   ISTDYPAB+4
DYPFLGS  EQU   ISTDYPAB+2
DYPLNGTH EQU   ISTDYPAB+1
DYPTYPE  EQU   ISTDYPAB
LOKXCL   EQU   @NM00107
LOKPRY   EQU   @NM00107
@NM00108 EQU   @NM00107
@NM00106 EQU   LOKCHNG
LOKCT    EQU   ISTLOK
UECRVPT4 EQU   ISTUECB+80
UECRVPT3 EQU   ISTUECB+76
UECLGDTA EQU   ISTUECB+72
UECDVTPT EQU   ISTUECB+68
UECREQNM EQU   ISTUECB+60
UECSYMNM EQU   ISTUECB+52
UECVRPL  EQU   UECPLIST+16
UECRSNBT EQU   UECRSNCD+3
@NM00105 EQU   UECRSNCD
UECUSFLD EQU   UECREQTR
UECDAF   EQU   UECTPNCD+2
UECSAF   EQU   UECTPNCD
UECRPLAD EQU   UECACB
UECPAB   EQU   ISTUECB+16
UECEXLST EQU   ISTUECB+12
UECTSKID EQU   ISTUECB+8
UECFORW  EQU   ISTUECB+4
UECTYPE  EQU   ISTUECB+3
UECRSV01 EQU   ISTUECB+2
UECLEN   EQU   ISTUECB+1
UECID    EQU   ISTUECB
CRACHAIN EQU   ISTCRA+928
CRARSV02 EQU   ISTCRA+924
CRARSV01 EQU   ISTCRA+920
CRABFTBA EQU   CRABUFA
CRAMASK  EQU   CRASVC+64
CRAHSIZ  EQU   CRASVC+60
CRAASCRR EQU   CRASVC
CRAPSS   EQU   ISTCRA+160
CRARPH   EQU   ISTCRA+52
CRALAPTR EQU   CRABASIC+48
CRAL9PTR EQU   CRABASIC+44
CRAL7PTR EQU   CRABASIC+36
CRAL6PTR EQU   CRABASIC+32
CRAL4PTR EQU   CRABASIC+24
CRAL3PTR EQU   CRABASIC+20
CRAL2PTR EQU   CRABASIC+16
CRAL1PTR EQU   CRABASIC+12
CRALEV01 EQU   CRALKACT+3
CRALEV02 EQU   CRALKACT+3
CRALEV03 EQU   CRALKACT+3
CRALEV04 EQU   CRALKACT+3
CRALEV05 EQU   CRALKACT+3
CRALEV06 EQU   CRALKACT+3
CRALEV07 EQU   CRALKACT+3
CRALEV08 EQU   CRALKACT+3
CRALEV09 EQU   CRALKACT+2
CRALEV10 EQU   CRALKACT+2
CRALEV11 EQU   CRALKACT+2
CRALEV12 EQU   CRALKACT+2
CRALEV13 EQU   CRALKACT+2
CRALEV14 EQU   CRALKACT+2
CRALEV15 EQU   CRALKACT+2
CRALEV16 EQU   CRALKACT+2
CRALEV17 EQU   CRALKACT+1
CRALEV18 EQU   CRALKACT+1
CRALEV19 EQU   CRALKACT+1
CRALEV20 EQU   CRALKACT+1
CRALEV21 EQU   CRALKACT+1
CRALEV22 EQU   CRALKACT+1
CRALEV23 EQU   CRALKACT+1
CRALEV24 EQU   CRALKACT+1
CRALEV25 EQU   CRALKACT
CRALEV26 EQU   CRALKACT
CRALEV27 EQU   CRALKACT
CRALEV28 EQU   CRALKACT
CRALEV29 EQU   CRALKACT
CRALEV30 EQU   CRALKACT
CRALEV31 EQU   CRALKACT
CRALEV32 EQU   CRALKACT
CRAFRR   EQU   CRAHDR+4
CRACRR   EQU   CRAHDR
@NM00104 EQU   ISTAPCRR+137
@NM00103 EQU   APC57FLG
APCNREL  EQU   APC57FLG
APCRECRA EQU   APC57FLG
@NM00102 EQU   APC54FLG
APCRLST  EQU   APC54FLG
APCPR153 EQU   APC53FLG
@NM00101 EQU   APC52FLG
APCWKF   EQU   APC52FLG
APCNWF   EQU   APC52FLG
APCRDQ   EQU   APC52FLG
APCQENQ  EQU   APC52FLG
APCSMSR  EQU   APC52FLG
APCCKRQ  EQU   APC52FLG
@NM00100 EQU   APC31FLG
APCSORT  EQU   APC31FLG
APCRESCH EQU   APC31FLG
APCTPXIT EQU   APC31FLG
APCSWTWD EQU   ISTAPCRR+128
APCSAV2  EQU   ISTAPCRR+124
APCSAV1  EQU   ISTAPCRR+120
APCRETCD EQU   APCCOMF+2
@NM00099 EQU   APCCOMF1+1
APCZLBER EQU   APCCOMF1
APCEXIT  EQU   APCCOMF1
APCRELR  EQU   APCCOMF1
APCIRB2  EQU   APCCOMF1
APCIRB1  EQU   APCCOMF1
APCSMCR  EQU   APCCOMF1
APCUETSK EQU   APCCOMF1
APCSSTSK EQU   APCCOMF1
APCESTAL EQU   APCSAVE
APCFRRPM EQU   ISTAPCRR+40
APCQWFO  EQU   ISTAPCRR+36
APCPABSV EQU   ISTAPCRR+32
APCRTRN  EQU   ISTAPCRR+28
APCTCBA  EQU   ISTAPCRR+24
APCPSTA  EQU   ISTAPCRR+20
@NM00098 EQU   APCRFLG+1
APC31R   EQU   APCRFLG
APC58R   EQU   APCRFLG
APC57R   EQU   APCRFLG
APC56R   EQU   APCRFLG
APC54R   EQU   APCRFLG
APC53R   EQU   APCRFLG
APC52R   EQU   APCRFLG
APC51R   EQU   APCRFLG
@NM00097 EQU   APCATFLG+1
APC31E   EQU   APCATFLG
APC58E   EQU   APCATFLG
APC57E   EQU   APCATFLG
APC56E   EQU   APCATFLG
APC54E   EQU   APCATFLG
APC53E   EQU   APCATFLG
APC52E   EQU   APCATFLG
APC51E   EQU   APCATFLG
APCHDRSV EQU   ISTAPCRR
ASCPSREG EQU   ISTASCRR+44
ASCUSR01 EQU   ASCUSRGS+12
ASCUSR00 EQU   ASCUSRGS+8
ASCUSR15 EQU   ASCUSRGS+4
ASCUSR14 EQU   ASCUSRGS
ASCETRYA EQU   ISTASCRR+24
ASCKEY   EQU   ISTASCRR+23
ASCAUDIT EQU   ASCFLG3
ASCFBDUD EQU   ASCFLG3
ASCLLKF  EQU   ASCFLG3
ASCKEYF  EQU   ASCFLG3
ASCFBDAL EQU   ASCFLG3
ASCFSRGT EQU   ASCFLG3
ASCICR   EQU   ASCFLG2
ASCFSRIC EQU   ASCFLG2
ASCFBDIC EQU   ASCFLG2
ASCFBAIC EQU   ASCFLG2
ASCPASTR EQU   ASCFLG1
ASCFSR   EQU   ASCFLG1
ASCFBD   EQU   ASCFLG1
ASCFBA   EQU   ASCFLG1
ASCPFCRR EQU   ISTASCRR
ZCRRU    EQU   ZCRRHRU+3
ZCRRH    EQU   ZCRRHRU
ZCRWORDA EQU   ISTZCRR+477
ZCRCMNRC EQU   ISTZCRR+476
ZCRRSV97 EQU   ZCRENTER+18
ZCREIC2B EQU   ZCRENTER+18
ZCREAC2B EQU   ZCRENTER+18
ZCRELCAB EQU   ZCRENTER+18
ZCREDCMF EQU   ZCRENTER+18
ZCREBCIF EQU   ZCRENTER+18
ZCREICSG EQU   ZCRENTER+18
ZCREDCK0 EQU   ZCRENTER+18
ZCRECFY0 EQU   ZCRENTER+17
ZCREKCCB EQU   ZCRENTER+17
ZCREDCNB EQU   ZCRENTER+17
ZCREICOE EQU   ZCRENTER+17
ZCREBCNB EQU   ZCRENTER+17
ZCREBC0L EQU   ZCRENTER+17
ZCREBCAL EQU   ZCRENTER+17
ZCREDCQR EQU   ZCRENTER+17
ZCREDCPR EQU   ZCRENTER+16
ZCREBCSB EQU   ZCRENTER+16
ZCREAC1R EQU   ZCRENTER+16
ZCRECCCI EQU   ZCRENTER+16
ZCRECCAI EQU   ZCRENTER+16
ZCRECCBI EQU   ZCRENTER+16
ZCREBCAR EQU   ZCRENTER+16
ZCREBCDR EQU   ZCRENTER+16
ZCREBCBR EQU   ZCRENTER+15
ZCREDCXR EQU   ZCRENTER+15
ZCREDCWB EQU   ZCRENTER+15
ZCREDCWR EQU   ZCRENTER+15
ZCREKCCN EQU   ZCRENTER+15
ZCREKCBN EQU   ZCRENTER+15
ZCREKCBB EQU   ZCRENTER+15
ZCREJC0B EQU   ZCRENTER+15
ZCREJCDB EQU   ZCRENTER+14
ZCREJCCB EQU   ZCRENTER+14
ZCREJCBB EQU   ZCRENTER+14
ZCREJCAB EQU   ZCRENTER+14
ZCREIC1B EQU   ZCRENTER+14
ZCREIC0B EQU   ZCRENTER+14
ZCREICX0 EQU   ZCRENTER+14
ZCREICWB EQU   ZCRENTER+14
ZCREICVB EQU   ZCRENTER+13
ZCREICUB EQU   ZCRENTER+13
ZCREICTB EQU   ZCRENTER+13
ZCREICSC EQU   ZCRENTER+13
ZCREICSB EQU   ZCRENTER+13
ZCREICRB EQU   ZCRENTER+13
ZCREICQB EQU   ZCRENTER+13
ZCREICQA EQU   ZCRENTER+13
ZCREICOB EQU   ZCRENTER+12
ZCREICOA EQU   ZCRENTER+12
ZCREICNB EQU   ZCRENTER+12
ZCREICNA EQU   ZCRENTER+12
ZCREICMB EQU   ZCRENTER+12
ZCREICLB EQU   ZCRENTER+12
ZCREICKG EQU   ZCRENTER+12
ZCREICKE EQU   ZCRENTER+12
ZCREICKB EQU   ZCRENTER+11
ZCREICJB EQU   ZCRENTER+11
ZCREICID EQU   ZCRENTER+11
ZCREICIB EQU   ZCRENTER+11
ZCREICHB EQU   ZCRENTER+11
ZCREICGB EQU   ZCRENTER+11
ZCREICEB EQU   ZCRENTER+11
ZCREICDB EQU   ZCRENTER+11
ZCREICCI EQU   ZCRENTER+10
ZCREICCB EQU   ZCRENTER+10
ZCREICBI EQU   ZCRENTER+10
ZCREICBB EQU   ZCRENTER+10
ZCREICAB EQU   ZCRENTER+10
ZCREICAA EQU   ZCRENTER+10
ZCREHCAN EQU   ZCRENTER+10
ZCREGC0B EQU   ZCRENTER+10
ZCREGC0A EQU   ZCRENTER+9
ZCREGCLA EQU   ZCRENTER+9
ZCREGCEB EQU   ZCRENTER+9
ZCREGCDB EQU   ZCRENTER+9
@NM00096 EQU   ZCRENTER+9
ZCREGCBB EQU   ZCRENTER+9
ZCREGCAB EQU   ZCRENTER+9
ZCREFCEB EQU   ZCRENTER+9
ZCREFCEA EQU   ZCRENTER+8
ZCREECTA EQU   ZCRENTER+8
ZCREECEA EQU   ZCRENTER+8
ZCREECDA EQU   ZCRENTER+8
ZCREECCB EQU   ZCRENTER+8
ZCREECCA EQU   ZCRENTER+8
ZCREECBB EQU   ZCRENTER+8
ZCREECBA EQU   ZCRENTER+8
ZCREDCMB EQU   ZCRENTER+7
ZCREDCL0 EQU   ZCRENTER+7
ZCREDCKB EQU   ZCRENTER+7
ZCREDCKA EQU   ZCRENTER+7
ZCREDCJ0 EQU   ZCRENTER+7
ZCREDCI0 EQU   ZCRENTER+7
ZCREDCH0 EQU   ZCRENTER+7
ZCREDCF0 EQU   ZCRENTER+7
ZCREDCE0 EQU   ZCRENTER+6
ZCREDCD0 EQU   ZCRENTER+6
ZCREDCC0 EQU   ZCRENTER+6
ZCREDCB0 EQU   ZCRENTER+6
ZCREDCA0 EQU   ZCRENTER+6
ZCRECC2B EQU   ZCRENTER+6
ZCRECC1B EQU   ZCRENTER+6
ZCRECC1A EQU   ZCRENTER+6
ZCRECC0B EQU   ZCRENTER+5
ZCRECC0A EQU   ZCRENTER+5
ZCREBC0B EQU   ZCRENTER+5
ZCREBC0A EQU   ZCRENTER+5
ZCREBCZ0 EQU   ZCRENTER+5
ZCREBCY0 EQU   ZCRENTER+5
ZCREBCX0 EQU   ZCRENTER+5
ZCREBCXA EQU   ZCRENTER+5
ZCREBCSC EQU   ZCRENTER+4
ZCREBCRB EQU   ZCRENTER+4
ZCREBCRA EQU   ZCRENTER+4
ZCREBCQB EQU   ZCRENTER+4
ZCREBCPB EQU   ZCRENTER+4
ZCREBCOB EQU   ZCRENTER+4
ZCREBCNE EQU   ZCRENTER+4
ZCREBCND EQU   ZCRENTER+4
ZCREBCMB EQU   ZCRENTER+3
ZCREBCLB EQU   ZCRENTER+3
ZCREBCLA EQU   ZCRENTER+3
ZCREBCKB EQU   ZCRENTER+3
ZCREBCKA EQU   ZCRENTER+3
ZCREBCJB EQU   ZCRENTER+3
ZCREBCJA EQU   ZCRENTER+3
ZCREBCID EQU   ZCRENTER+3
ZCREBCIB EQU   ZCRENTER+2
ZCREBCIA EQU   ZCRENTER+2
ZCREBCHB EQU   ZCRENTER+2
ZCREBCHA EQU   ZCRENTER+2
ZCREBCGB EQU   ZCRENTER+2
ZCREBCGA EQU   ZCRENTER+2
ZCREBCFB EQU   ZCRENTER+2
ZCREBCFA EQU   ZCRENTER+2
ZCREBCEB EQU   ZCRENTER+1
ZCREBCDI EQU   ZCRENTER+1
ZCREBCCB EQU   ZCRENTER+1
ZCREBCBI EQU   ZCRENTER+1
ZCREBCBB EQU   ZCRENTER+1
ZCREBCBA EQU   ZCRENTER+1
ZCREBCAM EQU   ZCRENTER+1
ZCREBCAI EQU   ZCRENTER+1
ZCREBCAG EQU   ZCRENTER
ZCREBCAE EQU   ZCRENTER
ZCREBCAB EQU   ZCRENTER
ZCREBCAA EQU   ZCRENTER
ZCREAC1B EQU   ZCRENTER
ZCREAC0B EQU   ZCRENTER
ZCREAC0A EQU   ZCRENTER
ZCREAC1A EQU   ZCRENTER
ZCRTNAME EQU   ZCRAUDIT+1
ZCRTID   EQU   ZCRAUDIT
ZCRREMIC EQU   ISTZCRR+436
ZCRSAVEZ EQU   ISTZCRR+196
ZCRDAFSV EQU   ZCRCIDSV+2
ZCRSAFSV EQU   ZCRCIDSV
ZCRR13SV EQU   ISTZCRR+188
ZCRR2SV  EQU   ISTZCRR+184
ZCROPCDE EQU   ISTZCRR+183
ZCRPRMTC EQU   ISTZCRR+182
ZCRRCDSV EQU   ISTZCRR+181
ZCRAWQSW EQU   ISTZCRR+180
ZCRTOPQ  EQU   ISTZCRR+180
ZCRLSTFB EQU   ISTZCRR+180
ZCRXSCHD EQU   ISTZCRR+180
ZCRNXTEL EQU   ISTZCRR+180
ZCRSCANQ EQU   ISTZCRR+180
ZCRMOREL EQU   ISTZCRR+180
ZCRFBPRC EQU   ISTZCRR+180
ZCRFSBSV EQU   ISTZCRR+176
ZCRSVWK5 EQU   ZCRWKARA+16
ZCRSVWK4 EQU   ZCRWKARA+12
ZCRSVWK3 EQU   ZCRWKARA+8
ZCRSVWK2 EQU   ZCRWKARA+4
ZCRSVWK1 EQU   ZCRWKARA
ZCRSVF25 EQU   ZCRSVRTN+96
ZCRSVF24 EQU   ZCRSVRTN+92
ZCRSVF23 EQU   ZCRSVRTN+88
ZCRSVF22 EQU   ZCRSVRTN+84
ZCRSVF21 EQU   ZCRSVRTN+80
ZCRSVF20 EQU   ZCRSVRTN+76
ZCRSVF19 EQU   ZCRSVRTN+72
ZCRSVF18 EQU   ZCRSVRTN+68
ZCRSVF17 EQU   ZCRSVRTN+64
ZCRSVF16 EQU   ZCRSVRTN+60
ZCRSVF15 EQU   ZCRSVRTN+56
ZCRSVF14 EQU   ZCRSVRTN+52
ZCRSVF13 EQU   ZCRSVRTN+48
ZCRSVF12 EQU   ZCRSVRTN+44
ZCRSVF11 EQU   ZCRSVRTN+40
ZCRSVF10 EQU   ZCRSVRTN+36
ZCRSVF9  EQU   ZCRSVRTN+32
ZCRSVF8  EQU   ZCRSVRTN+28
ZCRSVF7  EQU   ZCRSVRTN+24
ZCRSVF6  EQU   ZCRSVRTN+20
ZCRSVF5  EQU   ZCRSVRTN+16
ZCRSVF4  EQU   ZCRSVRTN+12
ZCRSVF3  EQU   ZCRSVRTN+8
ZCRSVF2  EQU   ZCRSVRTN+4
ZCRSVF1  EQU   ZCRSVRTN
ZCRPVZB  EQU   ISTZCRR+52
ZCRZLB   EQU   ISTZCRR+48
ZCRBFPTR EQU   ISTZCRR+44
ZCRCCWA  EQU   ISTZCRR+40
ZCRPSW   EQU   ZCRPARMS+15
ZCRPCHAR EQU   ZCRPARMS+14
ZCRPRES2 EQU   ZCRPCOD2
ZCRPMFGF EQU   ZCRPCOD2
ZCRPFHDR EQU   ZCRPCOD2
ZCRPPG2  EQU   ZCRPCOD2
ZCRPRES  EQU   ZCRPCOD1
ZCRPCFTX EQU   ZCRPCOD1
ZCRPBUF  EQU   ZCRPCOD1
ZCRPLSCB EQU   ZCRPCOD1
ZCRPLSBQ EQU   ZCRPLSBF
ZCRPFSB  EQU   ZCRPCOD1
ZCRPLNG  EQU   ZCRPCOD1
ZCRPPG   EQU   ZCRPCOD1
ZCRDTODA EQU   ZCRDFRDA
ZCRMLNG  EQU   ZCRPARMS+8
ZCRTBPTR EQU   ZCRPARMS+4
ZCRCBPTR EQU   ZCRFBPTR
ZCRCRLCP EQU   ISTZCRR+20
ZCRMDATA EQU   ZCRSCPSW
ZCRSKIPT EQU   ZCRSCPSW
ZCRFSBWE EQU   ZCRSCPSW
ZCRPRCMP EQU   ZCRSCPSW
ZCRLREQ  EQU   ZCRSCPSW
ZCRRJLCP EQU   ZCRSCPSW
ZCRTPINV EQU   ZCRSCPSW
ZCRTPEX  EQU   ZCRSCPSW
@NM00095 EQU   ZCRIBPR
ZCR3270R EQU   ZCRIBPR
ZCR3270  EQU   ZCRIBPR
ZCRLCPFD EQU   ZCRIBPR
ZCRLCPFR EQU   ZCRIBPR
ZCRRELK  EQU   ZCRIBPR
ZCRERR   EQU   ZCRIBPR
ZCRNOBUF EQU   ZCRIBPR
@NM00094 EQU   ZCRPFLGS
ZCRQAHED EQU   ZCRPFLGS
ZCRF1RES EQU   ZCRGENSW
ZCRBRIS  EQU   ZCRGENSW
ZCRCLRBD EQU   ZCRGENSW
ZCREXRES EQU   ZCRGENSW
ZCRLCSYN EQU   ZCRGENSW
ZCRRT06  EQU   ZCRGENSW
ZCRTSW2  EQU   ZCRGENSW
ZCRTSW1  EQU   ZCRGENSW
ZCRINLCP EQU   ZCRFLGS3
ZCRWRPTR EQU   ZCRFLGS3
ZCRNOFRE EQU   ZCRFLGS3
ZCREDRIV EQU   ZCRFLGS3
ZCRDISC  EQU   ZCRFLGS3
ZCRTPDIS EQU   ZCRFLGS3
ZCRTPCON EQU   ZCRFLGS3
ZCRTIC   EQU   ZCRFLGS3
ZCRCNLXL EQU   ZCRRESET
ZCRENDAN EQU   ZCRSWFLD
ZCRENDXL EQU   ZCRSWFLD
ZCRENDX  EQU   ZCRSWFLD
ZCROB1   EQU   ZCRNDLCP
ZCRENDPR EQU   ZCRSWFLD
ZCREXTYP EQU   ZCRSWFLD
ZCRSLCP  EQU   ZCRENDSH
ZCRIF0E3 EQU   ZCRFLGS2
ZCRIF0E2 EQU   ZCRFLGS2
ZCRIF0E1 EQU   ZCRFLGS2
ZCROB    EQU   ZCRFLGS2
ZCRFMSED EQU   ZCRFLGS2
ZCRSHEDI EQU   ZCRFLGS2
ZCRLOCAL EQU   ZCRFLGS2
ZCRFEXIT EQU   ZCRFLGS1
ZCRUNSOL EQU   ZCRFLGS1
ZCRENDLP EQU   ZCRFLGS1
ZCRNRMEX EQU   ZCRFLGS1
ZCRWAIT  EQU   ZCRFLGS1
ZCRDEQSW EQU   ZCRFLGS1
ZCRQUESW EQU   ZCRFLGS1
ZCREXSW  EQU   ZCRFLGS1
ZCRFRRA  EQU   ISTZCRR+8
ZCRCHAIN EQU   ISTZCRR+4
ZCRFLAG  EQU   ZCRCRR+3
ZCRLEN   EQU   ZCRCRR+1
ZCRID    EQU   ZCRCRR
CCFRSVD1 EQU   CFCCRT
CCFCR2   EQU   CFCCRT
CCFCRP   EQU   CFCCRT
CCFCR1   EQU   CFCCRT
CCFCS2   EQU   CFCCRT
CCFCS1   EQU   CFCCRT
NCFRSVD  EQU   CFCNTRD
NCFCR2   EQU   CFCNTRD
NCFCRP   EQU   CFCNTRD
NCFCR1   EQU   CFCNTRD
NCFCS2   EQU   CFCNTRD
NCFCS1   EQU   CFCNTRD
PFCRSV01 EQU   ISTPFCRR+13
PFCFTA   EQU   ISTPFCRR+12
CRRFRR   EQU   PFCFRRO
CRRCHAIN EQU   PFCCRRO
CRRLEN   EQU   PFCCRRLN
PFCRSV10 EQU   PFCCRR+1
CRRID    EQU   PFCCRRID
ZSAZTRAC EQU   ISTZSAVE+36
ZSAZSVVR EQU   ISTZSAVE+12
ZSAZSVRR EQU   ISTZSAVE+8
ZSAZSVFC EQU   ISTZSAVE+4
ZSAZACTV EQU   ZSAZSVMS
CRRRVPT5 EQU   CRRSAREA+316
CRRRVPT4 EQU   CRRSAREA+312
CRRRVPT3 EQU   CRRSAREA+308
CRRRVPT2 EQU   CRRSAREA+304
CRRRVPT1 EQU   CRRSAREA+300
CRRRVCR2 EQU   CRRSAREA+292
CRRRVCR1 EQU   CRRSAREA+291
CRRXFNCD EQU   CRRSAREA+290
CRRLDOCT EQU   CRRSAREA+288
@NM00093 EQU   CRRBFLGS
CRRDIRPT EQU   CRRBFLGS
CRRBFLG1 EQU   CRRBFLGS
CRRRTN12 EQU   CRRSAREA+268
CRRRTN11 EQU   CRRSAREA+264
CRRRTN10 EQU   CRRSAREA+260
CRRRTN5  EQU   CRRSAREA+240
CRRRES1  EQU   CRRSAREA+222
CRRLCNT  EQU   CRRSAREA+220
CRRVALCK EQU   CRRSAREA+212
CRRBIND  EQU   CRRTRBUF+3
CRRTRRES EQU   CRRTRBUF
CRRCLDO  EQU   CRRSAREA+200
CRRUECB  EQU   CRRSAREA+196
CRRCMDAD EQU   CRRSAREA+188
CRRCLCCW EQU   CRRSAREA+180
CRRDSB2  EQU   CRRDSB+1
CRRDSB1  EQU   CRRDSB
CRRDTACT EQU   CRRSAREA+174
CRRRSV99 EQU   CRRSAREA+173
CRRRDSOH EQU   CRRFDB3
CRRLGFRC EQU   CRRFDB3
CRRCUERR EQU   CRRFDB2
CRRDLGFL EQU   CRRFDB2
CRRIOERR EQU   CRRFDB2
CRRDVUNS EQU   CRRFDB2
CRRATND  EQU   CRRFDB2
CRRRVID  EQU   CRRFDB2
CRRNSNA  EQU   CRRRTYPE
CRRDFSYN EQU   CRRRTYPE
CRRRESP  EQU   CRRRTYPE
CRRDFASY EQU   CRRRTYPE
CRRRPSBD EQU   CRRRFLG1
CRRRPLOQ EQU   CRRRFLG1
CRRRPLS  EQU   CRRRFLG1
CRRSW3   EQU   CRRFLGS
CRRSW2   EQU   CRRFLGS
CRRRSV04 EQU   CRRFLGS4
CRRDLCCW EQU   CRRFLGS3
CRRRESET EQU   CRRFLGS3
CRRSUBBK EQU   CRRFLGS3
CRRRSV08 EQU   CRRFLGS3
CRRDEBQ  EQU   CRRFLGS3
CRRSTSPR EQU   CRRFLGS3
CRRDREQ  EQU   CRRFLGS3
CRRDFDBK EQU   CRRFLGS3
CRRDFSB  EQU   CRRFLGS2
CRRDPROC EQU   CRRFLGS2
CRREXTS  EQU   CRRFLGS2
CRRELSRI EQU   CRRFLGS2
CRRPRGIP EQU   CRRFLGS2
CRRDEXP  EQU   CRRFLGS2
CRRSOLRQ EQU   CRRFLGS1
CRRREQP  EQU   CRRFLGS1
CRRCPROC EQU   CRRFLGS1
CRRFINI  EQU   CRRFLGS1
CRRPREIO EQU   CRRFLGS1
CRRINIO  EQU   CRRFLGS1
CRRFLDOS EQU   CRRFLGS1
CRRDOCUR EQU   CRRFLGS1
CRRRATS4 EQU   CRRATS+7
@NM00092 EQU   CRRSATS
CRRASC51 EQU   CRRSATS
CRRASC40 EQU   CRRSATS
CRRASC30 EQU   CRRSATS
CRRASC21 EQU   CRRSATS
CRRASC10 EQU   CRRSATS
CRRASC01 EQU   CRRSATS
@NM00091 EQU   CRRRATS2
CRRPLIC  EQU   CRRRATS2
CRRRC81  EQU   CRRRATS2
CRRRC80  EQU   CRRRATS2
CRRRC65  EQU   CRRRATS2
CRRRC63  EQU   CRRRATS2
CRRRC55  EQU   CRRRATS2
CRRRC54  EQU   CRRRATS2
CRRRC53  EQU   CRRRATS1
CRRRC52  EQU   CRRRATS1
CRRRC51  EQU   CRRRATS1
CRRRC30  EQU   CRRRATS1
CRRRC26  EQU   CRRRATS1
CRRRC23  EQU   CRRRATS1
CRRRC22  EQU   CRRRATS1
CRRRC21  EQU   CRRRATS1
@NM00090 EQU   CRRATS4
CRRC3X   EQU   CRRATS4
CRRC85   EQU   CRRATS4
CRRC83   EQU   CRRATS4
CRRC82   EQU   CRRATS4
CRRC61   EQU   CRRATS4
CRRC60   EQU   CRRATS4
CRRC81   EQU   CRRATS3
CRRC80   EQU   CRRATS3
CRRC75   EQU   CRRATS3
CRRC51   EQU   CRRATS3
CRRC42   EQU   CRRATS3
CRRC41   EQU   CRRATS3
CRRC40   EQU   CRRATS3
CRRC32   EQU   CRRATS2
CRRC31   EQU   CRRATS2
CRRC30   EQU   CRRATS2
CRRC25   EQU   CRRATS2
CRRC24   EQU   CRRATS2
CRRC23   EQU   CRRATS2
CRRC22   EQU   CRRATS2
CRRC21   EQU   CRRATS2
CRRC20   EQU   CRRATS1
CRRC13   EQU   CRRATS1
CRRC12   EQU   CRRATS1
CRRC11   EQU   CRRATS1
CRRC10   EQU   CRRATS1
CRRC02   EQU   CRRATS1
CRRC01   EQU   CRRATS1
CRRC00   EQU   CRRATS1
CRRRMAS4 EQU   CRRMAS+7
@NM00089 EQU   CRRSMAS
CRRMSC51 EQU   CRRSMAS
CRRMSC40 EQU   CRRSMAS
CRRMSC30 EQU   CRRSMAS
CRRMSC21 EQU   CRRSMAS
CRRMSC10 EQU   CRRSMAS
CRRMSC01 EQU   CRRSMAS
@NM00088 EQU   CRRRMAS2
CRRRM81  EQU   CRRRMAS2
CRRRM80  EQU   CRRRMAS2
CRRRM65  EQU   CRRRMAS2
CRRRM63  EQU   CRRRMAS2
CRRRM55  EQU   CRRRMAS2
CRRRM54  EQU   CRRRMAS2
CRRRM53  EQU   CRRRMAS1
CRRRM52  EQU   CRRRMAS1
CRRRM51  EQU   CRRRMAS1
CRRRM30  EQU   CRRRMAS1
CRRRM26  EQU   CRRRMAS1
CRRRM23  EQU   CRRRMAS1
CRRRM22  EQU   CRRRMAS1
CRRRM21  EQU   CRRRMAS1
@NM00087 EQU   CRRMAS4
CRRM3X   EQU   CRRMAS4
CRRM85   EQU   CRRMAS4
CRRM83   EQU   CRRMAS4
CRRM82   EQU   CRRMAS4
CRRM61   EQU   CRRMAS4
CRRM60   EQU   CRRMAS4
CRRM81   EQU   CRRMAS3
CRRM80   EQU   CRRMAS3
CRRM75   EQU   CRRMAS3
CRRM51   EQU   CRRMAS3
CRRM42   EQU   CRRMAS3
CRRM41   EQU   CRRMAS3
CRRM40   EQU   CRRMAS3
CRRM32   EQU   CRRMAS2
CRRM31   EQU   CRRMAS2
CRRM30   EQU   CRRMAS2
CRRM25   EQU   CRRMAS2
CRRM24   EQU   CRRMAS2
CRRM23   EQU   CRRMAS2
CRRM22   EQU   CRRMAS2
CRRM21   EQU   CRRMAS2
CRRM20   EQU   CRRMAS1
CRRM13   EQU   CRRMAS1
CRRM12   EQU   CRRMAS1
CRRM11   EQU   CRRMAS1
CRRM10   EQU   CRRMAS1
CRRM02   EQU   CRRMAS1
CRRM01   EQU   CRRMAS1
CRRM00   EQU   CRRMAS1
CRRSAVE  EQU   CRRSAREA
CRRRSV22 EQU   ISTDCCRR+4
CRRCRR   EQU   ISTDCCRR
RPHNEXPO EQU   ISTRPH+104
RPHSAV16 EQU   RPHWORK+60
RPHSAV15 EQU   RPHWORK+56
RPHSAV14 EQU   RPHWORK+52
RPHSAV13 EQU   RPHWORK+48
RPHSAV12 EQU   RPHWORK+44
RPHSAV11 EQU   RPHWORK+40
RPHSAV10 EQU   RPHWORK+36
RPHSAVE9 EQU   RPHWORK+32
RPHSAVE8 EQU   RPHWORK+28
RPHSAVE7 EQU   RPHWORK+24
RPHSAVE6 EQU   RPHWORK+20
RPHSAVE5 EQU   RPHWORK+16
RPHSAVE4 EQU   RPHWORK+12
RPHSAVE3 EQU   RPHWORK+8
RPHSAVE2 EQU   RPHWORK+4
RPHSHALF EQU   RPHSAVE1+2
RPHSBIT8 EQU   RPHSBITS
RPHSBIT7 EQU   RPHSBITS
RPHSBIT6 EQU   RPHSBITS
RPHSBIT5 EQU   RPHSBITS
RPHSBIT4 EQU   RPHSBITS
RPHSBIT3 EQU   RPHSBITS
RPHSBIT2 EQU   RPHSBITS
RPHSBIT1 EQU   RPHSBITS
RPHSBYTE EQU   RPHSAVE1
RPHPABQP EQU   RPHPABQA+1
RPHPABFG EQU   RPHPABQA
RPHSRP34 EQU   RPHSRPRM+2
RPHSRP12 EQU   RPHSRPRM
RPHWEGT  EQU   RPHCSPA
RPHMAJCB EQU   ISTRPH+21
RPHPABOF EQU   ISTRPH+20
RPHRESUM EQU   RPHRESMA+1
RPHRSV01 EQU   RPHWPFLG
RPHPURGE EQU   RPHWPFLG
RPHPT    EQU   RPHWPFLG
RPHWT    EQU   RPHWPFLG
RPHRSKEY EQU   RPHWPFLG
RPHDVTA  EQU   ISTRPH+12
RPHTIK   EQU   RPHTSKID+3
@NM00086 EQU   RPHTSKID
RPHRPHAP EQU   RPHRPHA+1
@NM00085 EQU   RPHCVFLG
RPHFRRPH EQU   RPHCVFLG
RPHOWRPH EQU   RPHCVFLG
RPHCDRPH EQU   RPHCVFLG
RPHPSRPH EQU   RPHCVFLG
RPHVYRPH EQU   RPHGATE
@NM00084 EQU   RPHFLGB
RPHRLCRA EQU   RPHFLGB
RPHNRSAV EQU   RPHFLGB
RPHPGCMP EQU   RPHFLGB
RPHFBAPS EQU   RPHFLGB
RPHBSSP  EQU   RPHFLGB
RPHLOCK  EQU   RPHFLGB
RPHFNFLG EQU   RPHFSTLC
RPHMLTCP EQU   RPHFLAGS
RPHSMCLR EQU   RPHFLAGS
RPHSMTYP EQU   RPHFLAGS
RPHSMQ   EQU   RPHFLAGS
RPHAUTEX EQU   RPHAPTYP
RPHSPGIN EQU   RPHFLAGS
RPHOGIND EQU   RPHFLAGS
RPHLNGTH EQU   RPHCNTL+1
RPHTYPE  EQU   RPHCNTL
LCPFTYPE EQU   LCPRPHA
LCPRSTQH EQU   LCPLCCW
LCPCLREP EQU   ISTLCPB+44
LCPUBFSB EQU   LCPFLCCW
LCPRSV77 EQU   ISTLCPB+39
LCPLCCWC EQU   ISTLCPB+38
LCPRSV78 EQU   LCPFLG1
LCPTRANS EQU   LCPFLG1
LCPSTLB  EQU   LCPFLG1
LCPREDRV EQU   LCPFLG1
LCPDIRPT EQU   LCPFLG1
LCPINTER EQU   LCPFLG1
LCPRESET EQU   LCPFLG1
LCPSTYPE EQU   ISTLCPB+36
LCPFSNCH EQU   ISTLCPB+34
LCPFOSN  EQU   ISTLCPB+32
LCPTLBAD EQU   ISTLCPB+28
LCPFDB2  EQU   LCPFDBA+1
LCPFDB1  EQU   LCPFDBA
LCPLCCW1 EQU   ISTLCPB+12
LCPRRCNT EQU   LCPSEQ+1
LCPRRCCT EQU   LCPSEQ
LCPATOP  EQU   LCPFLAG2
LCPFREE  EQU   LCPFLAG2
LCPDSTAT EQU   LCPFLAG2
LCPEXRES EQU   LCPFID0
LCPZRIMM EQU   LCPTLBPI
LCPRSTRT EQU   LCPFLAG2
LCPASYN  EQU   LCPFLAG2
LCPPRFLG EQU   LCPFLAG2
LCPZMIRC EQU   LCPRUCNT
LCPCHAI2 EQU   LCPCHAIN+1
LCPCHNG  EQU   LCPCHAI1
LCPZRT0B EQU   LCPMNRCD
LCPZRT0A EQU   LCPMNRCD
LCPZRTL9 EQU   LCPZRT09
LCPZRTL8 EQU   LCPZRT08
LCPZRTL7 EQU   LCPZRT07
LCPZRTL6 EQU   LCPZRT06
LCPZRTL5 EQU   LCPZRT05
LCPZRTL4 EQU   LCPZRT04
LCPZRTL3 EQU   LCPZRT03
LCPZRTL2 EQU   LCPZRT02
LCPZRT01 EQU   LCPFLAGS
LCPZRT00 EQU   LCPFLAGS
LCCWDATA EQU   ISTLCCW+4
LCCWCNT  EQU   ISTLCCW+2
LCCWACI  EQU   LCCWFLAG
LCCWRFI  EQU   LCCWFLAG
LCCWPER  EQU   LCCWLSI
LCCWIDAT EQU   LCCWFLAG
LCCWNTVC EQU   LCCWFLAG
LCCWCKPT EQU   LCCWFLAG
LCCWCC   EQU   LCCWFLAG
LCCWCD   EQU   LCCWFLAG
LCCWTYPE EQU   LCCWCTL
LCCWMODE EQU   LCCWCTL
LCCWSOP  EQU   LCCWRWOP
@NM00083 EQU   LCCWRWOP
LCCWSD   EQU   LCCWOP
LCCWSI   EQU   LCCWOP
FDBDATAA EQU   ISTFDB+4
PABRPHA  EQU   PABRPHFG+1
PABNODQ  EQU   PABFLAGS
PABINHBT EQU   PABFLAGS
PABERLOK EQU   PABERRLK
PABSSN   EQU   PABFLAGS
PABDYNAM EQU   PABFLAGS
PABNORPR EQU   PABFLAGS
PABPRIOR EQU   PABFLAGS
PABAPYP  EQU   PABFLAGS
PABDVTA  EQU   ISTPAB+9
PABOFFST EQU   ISTPAB+8
PABCHNGP EQU   PABCHAIN+1
PABRSV02 EQU   PABCHAIN
PABDELAY EQU   PABCHAIN
PABRUNNG EQU   PABCHAIN
PABRESET EQU   PABCHAIN
PABUNCON EQU   PABCHAIN
PABCDP   EQU   PABCHAIN
PABRESCH EQU   PABCHAIN
PABCHNG  EQU   PABCHAIN
PABWEQP  EQU   PABWEQA+1
PABRSV01 EQU   PABWEQA
PABWEQG  EQU   PABWEQA
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00082 EQU   CVTFIX+248
@NM00081 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTSHSB  EQU   CVTSHS
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
EXLEADDR EQU   EXLEXITP
@NM00080 EQU   EXLENFL
EXLLNK   EQU   EXLENFL
EXLACTM  EQU   EXLENFL
EXLSPEC  EQU   EXLENFL
EXLRESPP EQU   EXLRESP+1
@NM00079 EQU   EXLRESPF
EXLRESPK EQU   EXLRESPF
EXLRESPA EQU   EXLRESPF
EXLRESPS EQU   EXLRESPF
EXLDFASP EQU   EXLDFAS+1
@NM00078 EQU   EXLDFASF
EXLDFASK EQU   EXLDFASF
EXLDFASA EQU   EXLDFASF
EXLDFASS EQU   EXLDFASF
EXLTPNDP EQU   EXLVTEXT+21
@NM00077 EQU   EXLTPNDF
EXLTPNDK EQU   EXLTPNDF
EXLTPNDA EQU   EXLTPNDF
EXLTPNDS EQU   EXLTPNDF
EXLATTNP EQU   EXLVTEXT+16
@NM00076 EQU   EXLATTNF
EXLATTNK EQU   EXLATTNF
EXLATTNA EQU   EXLATTNF
EXLATTNS EQU   EXLATTNF
@NM00075 EQU   EXLVTEXT+10
EXLRLRQP EQU   EXLVTEXT+6
@NM00074 EQU   EXLRLRQF
EXLRLRQK EQU   EXLRLRQF
EXLRLRQA EQU   EXLRLRQF
EXLRLRQS EQU   EXLRLRQF
EXLNLGNP EQU   EXLVTEXT+1
@NM00073 EQU   EXLNLGNF
EXLNLGNK EQU   EXLNLGNF
EXLNLGNA EQU   EXLNLGNF
EXLNLGNS EQU   EXLNLGNF
EXLOPNP  EQU   EXLCOMN+36
@NM00072 EQU   EXLOPNF
EXLOPNK  EQU   EXLOPNF
EXLOPNA  EQU   EXLOPNF
EXLOPNS  EQU   EXLOPNF
EXLJRNP  EQU   EXLCOMN+31
@NM00071 EQU   EXLJRNF
EXLJRNK  EQU   EXLJRNF
EXLJRNA  EQU   EXLJRNF
EXLJRNS  EQU   EXLJRNF
EXLLGNP  EQU   EXLCOMN+26
@NM00070 EQU   EXLLGNF
EXLLGNK  EQU   EXLLGNF
EXLLGNA  EQU   EXLLGNF
EXLLGNS  EQU   EXLLGNF
EXLSCIPP EQU   EXLCOMN+21
@NM00069 EQU   EXLSCIPF
EXLSCIPK EQU   EXLSCIPF
EXLSCIPA EQU   EXLSCIPF
EXLSCIPS EQU   EXLSCIPF
EXLLERP  EQU   EXLCOMN+16
@NM00068 EQU   EXLLERF
EXLLERK  EQU   EXLLERF
EXLLERA  EQU   EXLLERF
EXLLERS  EQU   EXLLERF
EXLSYNP  EQU   EXLCOMN+11
@NM00067 EQU   EXLSYNF
EXLSYNK  EQU   EXLSYNF
EXLSYNA  EQU   EXLSYNF
EXLSYNS  EQU   EXLSYNF
EXLEODP  EQU   EXLCOMN+6
@NM00066 EQU   EXLEODF
EXLEODK  EQU   EXLEODF
EXLEODA  EQU   EXLEODF
EXLEODS  EQU   EXLEODF
@NM00065 EQU   EXLCOMN+4
EXLLEN2  EQU   EXLLEN
EXLSTYP  EQU   EXLCOMN+1
EXLID    EQU   EXLCOMN
RPLSEQNO EQU   RPLOF60+6
@NM00064 EQU   RPLIBSQ
RPLIINV  EQU   RPLIBSQ
RPLINEG  EQU   RPLIBSQ
RPLIPOS  EQU   RPLIBSQ
RPLIIGN  EQU   RPLIBSQ
RPLIRSET EQU   RPLIBSQ
RPLITST  EQU   RPLIBSQ
RPLISET  EQU   RPLIBSQ
@NM00063 EQU   RPLOBSQ
RPLOINV  EQU   RPLOBSQ
RPLONEG  EQU   RPLOBSQ
RPLOPOS  EQU   RPLOBSQ
RPLOIGN  EQU   RPLOBSQ
RPLORSET EQU   RPLOBSQ
RPLOTST  EQU   RPLOBSQ
RPLOSET  EQU   RPLOBSQ
RPLIBSQV EQU   RPLOF60+2
RPLOBSQV EQU   RPLOF60
@NM00062 EQU   RPLCNTSC
RPLRSHUT EQU   RPLCNTSC
RPLRQR   EQU   RPLCNTSC
RPLSHUTC EQU   RPLCNTSC
RPLSHUTD EQU   RPLCNTSC
RPLSTSN  EQU   RPLCNTSC
RPLCLEAR EQU   RPLCNTSC
RPLSDT   EQU   RPLCNTSC
@NM00061 EQU   RPLCNTDC
RPLSIGNL EQU   RPLCNTDC
RPLLUS   EQU   RPLCNTDC
RPLRTR   EQU   RPLCNTDC
RPLBID   EQU   RPLCNTDC
@NM00060 EQU   RPLCNTDF
RPLQI    EQU   RPLCNTDF
RPLRELQ  EQU   RPLCNTDF
RPLCHASE EQU   RPLCNTDF
RPLQEC   EQU   RPLCNTDF
RPLQC    EQU   RPLCNTDF
RPLCNCEL EQU   RPLCNTDF
RPLDATA  EQU   RPLCNTDF
RPLRRN   EQU   RPLRESP
RPLNFME  EQU   RPLRESP
RPLEX    EQU   RPLRESP
@NM00059 EQU   RPLRESP
@NM00058 EQU   RPLPOSTV
RPLSCHED EQU   RPLPOSTV
@NM00057 EQU   RPLVTFL1
RPLAUTUS EQU   RPLVTFL1
RPLVTUSE EQU   RPLVTFL1
@NM00056 EQU   RPLVTFL1
@NM00055 EQU   RPLCHN
RPLONLY  EQU   RPLCHN
RPLLAST  EQU   RPLCHN
RPLMIDLE EQU   RPLCHN
RPLFIRST EQU   RPLCHN
@NM00054 EQU   RPLRTYPE
RPLDFASY EQU   RPLRTYPE
RPLNFSYN EQU   RPLRTYPE
RPLRRESP EQU   RPLRTYPE
@NM00053 EQU   RPLSTYPE
RPLSRESP EQU   RPLSTYPE
@NM00052 EQU   RPLRH3
RPLCSI   EQU   RPLRH3
RPLCHREQ EQU   RPLRH3
RPLCMD   EQU   RPLRH3
RPLEB    EQU   RPLRH3
RPLBB    EQU   RPLRH3
RPLSIGDA EQU   RPLVTEXT+32
RPLSAV13 EQU   RPLVTEXT+28
RPLUSNSO EQU   RPLOSENS+2
RPLSSMO  EQU   RPLSSNSO+1
@NM00051 EQU   RPLSSEO
RPLRRO   EQU   RPLSSEO
RPLFIO   EQU   RPLSSEO
RPLSTATO EQU   RPLSSEO
RPLCPMO  EQU   RPLSSEO
@NM00050 EQU   RPLSSEO
RPLFMHDR EQU   RPLOPT12
@NM00049 EQU   RPLOPT12
@NM00048 EQU   RPLOPT12
@NM00047 EQU   RPLOPT12
RPLNIBTK EQU   RPLOPT12
RPLTRUNC EQU   RPLOPT12
RPLKEEP  EQU   RPLOPT12
@NM00046 EQU   RPLOPT12
RPLRSVE8 EQU   RPLOPT11
RPLRSVE7 EQU   RPLOPT11
RPLRSVE6 EQU   RPLOPT11
RPLRSVE5 EQU   RPLOPT11
RPLRSVE4 EQU   RPLOPT11
RPLSTOP  EQU   RPLOPT11
RPLSTART EQU   RPLOPT11
RPLQUIES EQU   RPLOPT11
RPLRSVI6 EQU   RPLOPT10
RPLRSVI5 EQU   RPLOPT10
RPLRSVI4 EQU   RPLOPT10
RPLRSVI3 EQU   RPLOPT10
RPLRSVI2 EQU   RPLOPT10
RPLSPARM EQU   RPLOPT10
RPLDSPLY EQU   RPLOPT10
RPLBSCID EQU   RPLOPT10
RPLTOPL  EQU   RPLOPT9
RPLCIDE  EQU   RPLOPT9
RPLRNNM  EQU   RPLOPT9
RPLAPPST EQU   RPLOPT9
RPLCOUNT EQU   RPLOPT9
RPLTERMS EQU   RPLOPT9
RPLDEVCH EQU   RPLOPT9
RPLLOGON EQU   RPLOPT9
RPLUSFLD EQU   RPLVTEXT+16
RPLESR2  EQU   RPLUSNSI+1
RPLESR1  EQU   RPLUSNSI
RPLSSMI  EQU   RPLDSB2
@NM00045 EQU   RPLSSEI
RPLRRI   EQU   RPLSSEI
RPLFII   EQU   RPLSSEI
RPLSTATI EQU   RPLSSEI
RPLCPMI  EQU   RPLSSEI
RPLPATHI EQU   RPLSSEI
RPLERMSA EQU   RPLCOMN+72
RPLEMLEN EQU   RPLCOMN+70
RPLACTIV EQU   RPLCOMN+69
RPLBRANC EQU   RPLEXTD1
@NM00044 EQU   RPLEXTD1
RPLEXIT  EQU   RPLEXTD1
RPLNEXIT EQU   RPLEXTD1
RPLEXSCH EQU   RPLEXTD1
RPLDDDD  EQU   RPLRBAR+4
@NM00043 EQU   RPLRBAR+3
@NM00042 EQU   RPLAIXID
RPLAXPKP EQU   RPLAIXID
RPLAIXPC EQU   RPLRBAR
RPLRSV88 EQU   RPLOPT8
RPLUNCON EQU   RPLOPT8
RPLACTV  EQU   RPLOPT8
RPLSESS  EQU   RPLOPT8
RPLPEND  EQU   RPLOPT8
RPLODPRM EQU   RPLOPT8
RPLODACP EQU   RPLOPT8
RPLODACQ EQU   RPLOPT8
RPLRSV78 EQU   RPLOPT7
RPLTCRNO EQU   RPLOPT7
RPLRLSOP EQU   RPLOPT7
RPLTPOST EQU   RPLOPT7
RPLQOPT  EQU   RPLOPT7
RPLCNIMM EQU   RPLCNOPT
RPLCNANY EQU   RPLCNOPT
RPLCNALL EQU   RPLCNOPT
RPLRSV68 EQU   RPLOPT6
RPLRSV67 EQU   RPLOPT6
RPLLOCK  EQU   RPLOPT6
RPLNCOND EQU   RPLOPT6
RPLCOND  EQU   RPLOPT6
RPLEOT   EQU   RPLUNTYP
RPLEOM   EQU   RPLUNTYP
RPLEOB   EQU   RPLUNTYP
RPLNODE  EQU   RPLOPT5
RPLERACE EQU   RPLWRTYP
RPLEAU   EQU   RPLWRTYP
RPLNERAS EQU   RPLWRTYP
RPLPSOPT EQU   RPLOPT5
@NM00041 EQU   RPLOPT5
RPLCHAIN EQU   RPLNXTRP
RPLBOP   EQU   RPLOPT4
@NM00040 EQU   RPLOPT4
RPLMKFRM EQU   RPLOPT4
RPLENDTR EQU   RPLOPT4
RPLALIGN EQU   RPLOPT3
RPLFMT   EQU   RPLOPT3
RPLFLD   EQU   RPLOPT3
RPLVFY   EQU   RPLOPT3
RPLBLK   EQU   RPLOPT3
RPLSFORM EQU   RPLOPT3
RPLEODS  EQU   RPLOPT3
RPLNSP   EQU   RPLOPT2
RPLUPD   EQU   RPLOPT2
@NM00039 EQU   RPLOPT2
RPLLRD   EQU   RPLOPT2
RPLBWD   EQU   RPLOPT2
RPLCNV   EQU   RPLOPT2
RPLADD   EQU   RPLADR
RPLKEY   EQU   RPLOPT2
RPLECBIN EQU   RPLECBSW
RPLGEN   EQU   RPLOPT1
RPLKGE   EQU   RPLOPT1
RPLASY   EQU   RPLOPT1
RPLSKP   EQU   RPLOPT1
RPLSEQ   EQU   RPLOPT1
RPLDIR   EQU   RPLOPT1
RPLLOC   EQU   RPLOPT1
RPLTCBPT EQU   RPLCOMN+28
RPLDACB  EQU   RPLCOMN+24
RPLCCHAR EQU   RPLCOMN+20
RPLSTRID EQU   RPLCOMN+18
RPLKEYL  EQU   RPLKEYLE
RPLRDSOH EQU   RPLFDB3
RPLRLG   EQU   RPLFDB3
RPLLGFRC EQU   RPLFDB3
RPLREOT  EQU   RPLFDB3
RPLREOM  EQU   RPLFDB3
RPLREOB  EQU   RPLFDB3
RPLSV32  EQU   RPLFDB3
RPLUINPT EQU   RPLFDB3
RPLSTSAV EQU   RPLFDB2
RPLCUERR EQU   RPLFDB2
RPLDLGFL EQU   RPLFDB2
RPLIOERR EQU   RPLFDB2
RPLDVUNS EQU   RPLFDB2
RPLATND  EQU   RPLFDB2
RPLRVID  EQU   RPLFDB2
RPLERLK  EQU   RPLFDB2
RPLERREG EQU   RPLRTNCD
RPLSTAT  EQU   RPLFDBWD
RPLPOST  EQU   RPLECB
RPLWAIT  EQU   RPLECB
RPLLEN2  EQU   RPLLEN
RPLSTYP  EQU   RPLIDWD+1
RPLID    EQU   RPLIDWD
@NM00038 EQU   ACBVTEXT+8
@NM00037 EQU   ACBVTEXT+6
ACBRTN   EQU   ACBVTEXT
ACBAPID  EQU   ACBCOMN+72
ACBCBMWA EQU   ACBCOMN+68
ACBUAPTR EQU   ACBCOMN+64
ACBLRECL EQU   ACBCOMN+62
ACBMSGLN EQU   ACBBLKSZ
ACBBUFSP EQU   ACBCOMN+56
@NM00036 EQU   ACBUJFCB+1
ACBOPTN  EQU   ACBUJFCB
@NM00035 EQU   ACBINFLG+1
ACBBYPSS EQU   ACBINFLG
ACBSDS   EQU   ACBVVIC
ACBUCRA  EQU   ACBINFLG
ACBSCRA  EQU   ACBINFLG
ACBCAT   EQU   ACBINFLG
ACBIJRQE EQU   ACBINFLG
ACBJEPS  EQU   ACBINFLG
@NM00034 EQU   ACBINFLG
ACBERFLG EQU   ACBCOMN+49
ACBBUSY  EQU   ACBIOSFG
ACBLOCK  EQU   ACBEXFG
@NM00033 EQU   ACBOFLGS
ACBDSERR EQU   ACBOFLGS
ACBOPEN  EQU   ACBOFLGS
ACBEOV   EQU   ACBOFLGS
@NM00032 EQU   ACBOFLGS
ACBDEB   EQU   ACBDDNM+5
ACBERFL  EQU   ACBDDNM+4
ACBAM    EQU   ACBAMETH
ACBINFL  EQU   ACBDDNM+2
ACBTIOT  EQU   ACBDDNM
ACBPASSW EQU   ACBCOMN+32
ACBMSGAR EQU   ACBCOMN+28
@NM00031 EQU   ACBDSORG+1
ACBDORGA EQU   ACBDSORG+1
@NM00030 EQU   ACBDSORG
ACBOPTJ  EQU   ACBDVIND
ACBCRNRE EQU   ACBCROPS
ACBCRNCK EQU   ACBCROPS
ACBASA   EQU   ACBCCTYP
@NM00029 EQU   ACBCCTYP
ACBTRCID EQU   ACBCCTYP
@NM00028 EQU   ACBRECFM
ACBRECAF EQU   ACBRECFM
ACBJBUF  EQU   ACBBUFPL+2
ACBMACR4 EQU   ACBBUFPL+1
@NM00027 EQU   ACBMACR3
ACBNCFX  EQU   ACBMACR3
ACBSIS   EQU   ACBMACR3
ACBDFR   EQU   ACBMACR3
ACBICI   EQU   ACBMACR3
ACBGSR   EQU   ACBMACR3
ACBLSR   EQU   ACBMACR3
@NM00026 EQU   ACBMACR3
ACBBUFNI EQU   ACBCOMN+18
ACBBUFND EQU   ACBCOMN+16
ACBSTRNO EQU   ACBCOMN+15
ACBBSTNO EQU   ACBCOMN+14
ACBAIX   EQU   ACBMACR2
ACBDSN   EQU   ACBMACR2
ACBRST   EQU   ACBMACR2
ACBLOGON EQU   ACBMACR2
ACBSKP   EQU   ACBMACR2
@NM00025 EQU   ACBMACR2
ACBUBF   EQU   ACBMACR1
ACBOUT   EQU   ACBMACR1
ACBIN    EQU   ACBMACR1
ACBDIR   EQU   ACBMACR1
ACBSEQ   EQU   ACBMACR1
ACBBLK   EQU   ACBCNV
ACBADD   EQU   ACBADR
ACBKEY   EQU   ACBMACR1
ACBINRTN EQU   ACBCOMN+8
ACBIBCT  EQU   ACBJWA
ACBLEN2  EQU   ACBLENG2
ACBSTYP  EQU   ACBCOMN+1
ACBID    EQU   ACBCOMN
@NM00024 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00023 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00022 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00021 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSARV011 EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSARV063 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00020 EQU   FLCFSA
@NM00019 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00018 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00017 EQU   FLCIOA
@NM00016 EQU   FLCMCLA+15
@NM00015 EQU   FLCMCLA+14
@NM00014 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00013 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00012 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00011 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00010 EQU   FLCPER
@NM00009 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00008 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00007 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00006 EQU   FLCPIILC
@NM00005 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00004 EQU   FLCSVILC
@NM00003 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00002 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00001 EQU   FLCICCW2+4
FLCCVT   EQU   FLCICCW2
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00511 EQU   @RC00510
@RC00527 EQU   @RC00522
@RC00570 EQU   @RC00569
@RF00778 EQU   @RC00776
@RT00827 EQU   ISTA0080
@RC01180 EQU   @RC01179
@RC01221 EQU   @RC01220
@PB00015 EQU   @PB00016
@PB00014 EQU   @PB00015
@PB00013 EQU   @PB00014
@PB00012 EQU   @PB00013
@PB00011 EQU   @PB00012
@PB00010 EQU   @PB00011
@PB00009 EQU   @PB00010
@PB00008 EQU   @PB00009
@PB00007 EQU   @PB00008
@PB00006 EQU   @PB00007
@PB00005 EQU   @PB00006
@PB00004 EQU   @PB00005
@PB00003 EQU   @PB00004
@PB00002 EQU   @PB00003
@ENDDATA EQU   *
         END   ISTDCC50,(C'PLS2052',0603,78173)
