SVTM     TITLE 'ISTINCR4-CONFIGURATION RESTART VSAM IO                 *
                        '
ISTINCR4 CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'ISTINCR4  76.170'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @11,0                                               0001
@PSTART  LA    @12,4095(,@11)                                      0001
         USING @PSTART,@11                                         0001
         USING @PSTART+4095,@12                                    0001
         EJECT
*/*-----------------------------------------------------------     0114
*    EXECTUABLE CODE -MAIN ROUTINE                                 0114
*---------------------------------------------------------------*/ 0114
*/*    CHAIN SAVEAREAS */                                          0114
*                                                                  0114
* DO; /* BLOCK MAIN */                                             0114
*/********************************************************************/
*/*                                                                  */
*/*   MACRO NAME = IDAAMB                                            */
*/*                                                                  */
*/*   DESCRIPTIVE NAME =ACCESS METHOD BLOCK                          */
*/*                                                                  */
*/*   FUNCTION = DESCRIBES DATA SET ATTRIBUTES AND SUPPLIES          */
*/*              IOS COMPATIBLE FIELDS FOR I/O                       */
*/*                                                                  */
*/*   CONTROL BLOCK STRUCTURE = THE IDAAMB IS POINTED TO BY THE      */
*/*              IDAAMBL                                             */
*/*                                                                  */
*/*   INCLUDED MACROS = NONE                                         */
*/*                                                                  */
*/*   METHOD OF ACCESS = PL/S - NO DECLARES NECESSARY                */
*/*                                                                  */
*/*   CREATED BY = VSAM OPEN                                         */
*/*                                                                  */
*/*   STATUS = VS/1 RELEASE 4  (CHANGE FLAG @X04SVXX)                */
*/*               VS/2 RELEASE 3  (CHANGE FLAG @Y30SDXX)             */
*/*                                                                  */
*/*   DATE OF LAST CHANGE = 8 AUG 74                                 */
*/*                                                                  */
*/********************************************************************/
*     DCL  1 IDAAMB  BASED ,                /* AMB                 */
*               2 AMBID         BIT(8),     /* AMB IDENTIFIER      */
*               2 AMBRSC        BIT(8),     /* RESOURCE TS BYTE    */
*               2 AMBLEN        FIXED(15),  /* AMB LENGTH          */
*               2 AMBLINK       PTR(31),    /* NEXT AMB            */
*               2 AMBBUFC       PTR(31),    /* BUFFER CONTROL      */
*               2 AMBPH         PTR(31),    /* PLACEHOLDER         */
*               2 AMBCACB       PTR(31),    /*PTR TO ACB OF CATALOG*/
*                                           /*USED TO ACCESS OBJECT*/
*               2 AMBDSB        PTR(31),    /* AMDSB POINTER       */
*               2 AMBEOVR       CHAR(1),    /* EOV REQUEST TYPE - NOT
*                                              USED IN MVM   @Y30DSJH*/
*                 3 AMBFLG0     BIT(8),     /* MVM AMB FLAGS @Y30DSJH*/
*                   4 AMBPSDS   BIT(1),     /* PAGE SPACE    @Y30DSJH*/
*                   4 *         BIT(7),     /* UNUSED IN MVM @Y30DSJH*/
*               2 AMBFLG1       BIT(8),     /* FLAG BYTE ONE       */
*                 3 AMBCREAT    BIT(1),     /* ON IF IN CREATE MODE*/
*                3 AMBTYPE    BIT(1),       /*                       */
*                3 AMBMCAT    BIT(1),       /* MASTER CATL           */
*                3 AMBPCAT    BIT(1),       /* PRIVATE CATL          */
*                 3 AMBSPEED  BIT(1),       /* CREATE SPEED OPITON */
*                 3 AMBUBF      BIT(1),     /* USER BUFFERING      */
*                 3 AMBJRN      BIT(1),     /* JOURNAL EXIT PRESENT*/
*                 3 AMBINBUF    BIT(1),     /* SHARED DS--DIRECT   */
*                                           /* REQ BFR INVALIDATION*/
*               2 AMBDSORG      BIT(16),    /* DATA SET ORGANIZ.   */
*                    3 *        BIT(12),     /* ALWAYS ZERO         */
*                    3 AMBDORGA BIT(1),      /* ACCESS METHOD INDIC */
*                    3 *        BIT(3),      /* ALWAYS ZERO         */
*               2 AMBIOBAD      PTR(31),    /* IOB ADDR            */
*                 3 AMBIOMB     PTR(31),    /* IOMB CHAIN IN MVM   0115
*                                                            @Y30DSJH*/
*               2 AMBCDSN       CHAR(3),    /* CATALOG DSN         */
*               2 AMBDDSN       CHAR(3),    /* DATA DSN            */
*               2 *             PTR(16),    /* RESERVED            */
*               2 AMBTIOT       FIXED(15),  /* OFFSET TO TIOT      */
*                2 AMBINFL      PTR(8),     /* INDICATOR FLAGS     */
*                  3 *          BIT(1),     /* RESERVED FOR EXCP   */
*                  3 *          BIT(2),     /* RESERVED            */
*                  3 AMBCAT     BIT(1),     /* AMB FOR VSAM CATLG  */
*                  3 AMBSCRA    BIT(1),     /* CATALOG CONTROL BLOCK
*                                              SYSTEM AREA   @X04SVLC*/
*                  3 AMBUCRA    BIT(1),     /* CATALOG CONTROL BLOCK
*                                              USER AREA     @X04SVLC*/
*                  3 AMBUPX     BIT(1),     /* SET ON IF UPGRADE TABLE
*                                              EXISTS        @X04SVLC*/
*                2 AMBAMETH     PTR(8),     /* ACCESS METHOD TYPE  */
*               2 AMBDEBPT      PTR(31),    /* DEB ADDR            */
*                 3 AMBIFLGS    BIT(8),     /* IOS ERROR FLAGS     */
*                 3 AMBDEBAD    PTR(24),    /* DEB ADDR            */
*               2 AMBOFLGS      BIT(8),     /* OPEN FLAGS          */
*                 3 *       BIT(3),         /* ALWAYS ZERO          */
*                 3 AMBOPEN BIT(1),         /* AMB IS OPEN          */
*                 3 *       BIT(2),         /* ALWAYS ZERO          */
*                 3 AMBEXFG BIT(1),         /* USER EXIT FLAG       */
*                 3 AMBBUSY BIT(1),         /* BUSY BIT             */
*               2 AMBFLG2       PTR(8),     /* FLAG BYTE TWO @X04SVLC*/
*                 3 AMBPUG BIT(1),          /* AMB PARTICIPATES IN 0115
*                                              UPGRADE       @X04SVLC*/
*               2 AMBRPT        FIXED(15),  /*                     */
*               2 AMBEDB        PTR(31),    /* EDB POINTER         */
*               2 AMBEOVPT      PTR(31),    /* PTR TO KEY OR RBA - NOT
*                                              USED IN MVM   @Y30DSJH*/
*                 3 AMBAMBXN    PTR(31),    /* PTR TO AMB EXTENSION IN
*                                              MVM           @Y30DSJH*/
*               2 AMBWKA        PTR(31),    /* WORK AREA PTR       */
*               2 AMBIWA        PTR(31),    /* INSERT WORK AREA PTR*/
*               2 *             PTR(31),    /* UNUSED        @Z30SSMR*/
*               2 AMBPIXP       PTR(31),    /* PTR TO PRIME INDEX AMB*/
*               2 AMBPAMBL      PTR(31),    /* PTR TO PRIMARY AMBL 0115
*                                                            @X04SVLC*/
*               2 AMBUPLH       PTR(31),    /* PTR TO UPGRADE PLH  0115
*                                                            @X04SVLC*/
*               2 AMBCSWD1 FIXED(31)BDY(WORD),/* CS WORD 1   @X04SVLC*/
*                 3 AMBAFLG BIT(8), /* ADDITIONAL FLAGS      @X04SVLC*/
*                   4 *      BIT(1),/* UNUSED                @X04SVLC*/
*                   4 AMBLSR BIT(1),/* LSR OPTION            @X04SVLC*/
*                   4 AMBGSR BIT(1),/* GSR OPTION            @Y30SDLP*/
*                   4 AMBICI BIT(1),/* ICIP OPTION           @Y30SDLP*/
*                   4 AMBDFR BIT(1),/* DEFER WRITES          @X04SVLC*/
*                   4 AMBSIS BIT(1),/* SEQ INSERT STRAT      @X04SVLC*/
*                   4 AMBCFX BIT(1),/* FIXED CTRL BLK OPTN   @Y30SDLP*/
*                   4 *      BIT(1),/* UNUSED                @X04SVLC*/
*                 3 * FIXED(8),     /* UNUSED                @X04SVLC*/
*                 3 AMBRDCNT FIXED(15),/* NBR OF CIS READ FOR THIS AMB
*                                           - VS1 ONLY       @X04SVLC*/
*               2 AMBBM2SH PTR(31), /* ADDR OF PLH DOING 2ND SEARCH
*                                      OF SUBPOOL - VS1 ONLY @X04SVLC*/
*               2 AMBCPA PTR(31),   /* DB/DC - PTR TO WSHD.  NON DB/DC
*                                      & VS1 - UNUSED.  NON DB/DC & VS2
*                                      - PTR TO STATIC CPA'S @Y30DSJH*/
*               2 AMBWSHD PTR(31),  /* PTR TO WORK SPACE HDR @X04SVLC*/
*               2 AMBEXEX CHAR(8),  /* EXCEPTION EXIT NAME   @X04SVLC*/
*               2 AMBSZRD FIXED(15),/* CP SIZE FOR READ      @X04SVLC*/
*               2 AMBSZWR FIXED(15),/* CP SIZE FOR WRITE     @X04SVLC*/
*               2 AMBSZFW FIXED(15),/* CP SIZE FORMAT WRITE  @X04SVLC*/
*               2 AMBSZCP FIXED(15),/* SIZE FOR CPA BASE     @X04SVLC*/
*               2 AMBVIOT PTR(31);  /* POINTER TO IDAVIOT    @X04SVLC*/
*  DCL   AMBINDEX BIT(1) CONSTANT('1'B);    /* INDEX TYPE AMB        */
*  DCL   AMBDATA  BIT(1) CONSTANT('0'B);    /* DATA TYPE AMB         */
* DCL AMBEOVMK BIT(8) CONSTANT('00000001'B); /* MOUNT BY KEY         */
* DCL AMBEOVMR BIT(8) CONSTANT('10000001'B); /* MOUNT BY RBA         */
* DCL AMBEOVAK BIT(8) CONSTANT('00000010'B); /* ALLOCATE BY KEY      */
* DCL AMBEOVAR BIT(8) CONSTANT('10000010'B); /* ALLOCATE BY RBA      */
* DCL AMBEOVUC BIT(8) CONSTANT('00000100'B); /* UPDATE CATALOG       */
* DCL AMBEXOFF BIT(1) CONSTANT('1'B);       /* AMB NOT LOCKED       */
* /*     DESCRIPTION SHOULD BE HERE                                 */
* /*                                                                */
* /* MACCOMP Y-2 SC1DE/SJD61                                        */
* /* MACSTAT Y-2 73103/Y02113                                       */
* /*                                                                */
* /*                                                                */
*        DCL 1 IDAAMBL BASED,                                      0124
*              2 AMBLPCHN     PTR(31),  /* PRIMARY CHAIN POINTER    */
*              2 AMBLSCHN     PTR(31),  /* SECONDARY CHAIN POINTER  */
*              2 AMBLACB      PTR(31),  /* POINTER TO ACB           */
*              2 AMBLEOV      FIXED(31),/* EOV/RM INTERFACE         */
*                3 AMBLEFLG   CHAR(1),  /* EOV FLAGS                */
*                  4 AMBLWAIT BIT(1),   /* EOV IS WAITING           */
*                  4 AMBLESET BIT(1),   /* EOV RESET CONTROL BLOCKS. */
*                3 AMBLCOMP   CHAR(1),  /* EOV LOCK                 */
*                3 *          CHAR(2),  /*                          */
*              2 AMBLDDNM     CHAR(8),  /* DDNAME FROM ACB          */
*              2 AMBLCBWA     PTR(31),  /* PTR TO CBM WORK AREA */ 0124
*              2 AMBLCBTS     CHAR(1),  /* CBM TEST AND SET BYTE */
*              2 *            CHAR(1),  /* RESERVED */             0124
*              2 AMBLCBLN     FIXED(15),/* LENGTH OF CBM WORK AREA */
*              2 AMBLID       CHAR(1),  /* AMBL IDENTIFER           */
*              2 AMBLSHAR     BIT(8),   /* SHARING INDICATORS       */
*                3 AMBLPRIM   BIT(1),   /* P-AMBL INDICATOR         */
*                3 AMBLCATO   BIT(1),   /* CATALOG OPEN IND IS ON   */
*                3 AMBLWRIT   BIT(1),   /* OUTPUT/UPDATE SPECIFIED  */
*                3 *          BIT(5),   /* RESERVED                 */
*              2 AMBLLEN      PTR(8),   /* AMBL LENGTH              */
*              2 AMBLFLG1     BIT(8),   /* FLAG BYTE ONE            */
*                3 AMBLFULL   BIT(1),   /* FULL ACCESS OK           */
*                3 AMBLCINV   BIT(1),   /* CINV ACCESS OK           */
*                3 AMBLUPD    BIT(1),   /* UPDATE ACCESS OK         */
*                3 *          BIT(3),   /* RESERVED                 */
*                3 AMBLCAT    BIT(1),   /* IND ACB FOR A CATALOG    */
*                3 AMBLDUMY   BIT(1),   /* DD DUMMY SPECIFIED       */
*              2 AMBLFLG2     BIT(8),   /* FLAG BYTE TWO            */
*                3 AMBLREST   BIT(1),   /* INDIC RESTART INVIR      */
*                3 AMBLCKPT   BIT(1),   /* INDICATE CKPT ENVIR       */
*                3 AMBLRST1   BIT(1),   /* UPDATE HIGH RBA FOR     0124
*                                          RESTART           @XM01565*/
*                3 AMBLSTAG   BIT(1),   /* CLUSTER IS STAGED @Y30LSPS*/
*                3 *          BIT(4),   /* RESERVED          @Y30LSPS*/
*              2 AMBLNST      CHAR(1),  /* NUMBER OF STRINGS        */
*              2 AMBLNUM      FIXED(15),/* NUMBER OF AMB PTRS IN    */
*                                       /* AMBL                     */
*              2 *            CHAR(1),  /* RESERVED                 */
*              2 AMBLNIDS     PTR(8),   /* NUMBER IF IDS            */
*              2 AMBLMIDS(5)  CHAR(2),  /* IDS OF MODULES LOADED    */
*              2 AMBLDTA      PTR(31),  /* POINTER TO DATA AMB      */
*              2 AMBLIX       PTR(31),  /* POINTER TO INDEX AMB     */
*              2 AMBLDS       PTR(31);  /* VARIABLE NUMBER OF OTHER */
*                                       /* DATA SETS - TYPE         */
*                                       /* DETERMINED FROM AMDSB    */
*CR4FWDPT=NCSCRWKA;               /*SET CALLER FORWARD PTR IN SAVEARE*/
         L     @10,NCSCRWKA(,CR4R01)                               0125
         ST    @10,CR4FWDPT(,CR4R13)                               0125
*RFY CR4R6   RSTD;                                                 0126
*CR4R6   =CR4R13;                   /*SAVE PTR TO CALLER SAVEAREA*/
         LR    CR4R6,CR4R13                                        0127
*CR4R13=NCSCRWKA;                  /*SET R-13 TO CR4 SAVEAREA*/    0128
         LR    CR4R13,@10                                          0128
*CR4BCKPT=CR4R6 ;           /*SET CR4 BKWD PTR TO CALLERS          0129
*                                                 SAVEAREA*/       0129
         ST    CR4R6,CR4BCKPT(,CR4R13)                             0129
*RFY CR4R6 UNRSTD;                                                 0130
*CR4FWDPT=0;                       /*ZERO CR4 FORWARD PTR*/        0131
         SLR   @10,@10                                             0131
         ST    @10,CR4FWDPT(,CR4R13)                               0131
*NCSIORC=NCSCRIOS;                 /*SET RETURN CODE TO SUCCESS*/  0132
         MVI   NCSIORC(CR4R01),X'30'                               0132
*CR4NCSAD=CR4R01;                  /*SET UP NCSPL PTR*/            0133
         LR    CR4NCSAD,CR4R01                                     0133
*RFY CR4R01 UNRSTD;                                                0134
*RFY (ISTNCSPL) BASED(CR4NCSAD);   /*PT TO NCSPL*/                 0135
*/* --------------------------------                               0136
*     FIND  RDTE HEADER                                            0136
*   --------------------------------*/                             0136
*CR4HEDAD=NCSCRDTE;                /*SET WORKING PTR TO RDTE */    0136
         L     CR4HEDAD,NCSCRDTE(,CR4NCSAD)                        0136
*RFY(ISTRDT,ISTRPRE) BASED(CR4HEDAD);      /*NEXT RDTE*/           0137
*DO WHILE RPRPELEN ^= 0;           /*LOOP UNTIL BEGINNING OF RDT*/ 0138
         B     @DE00138                                            0138
@DL00138 DS    0H                                                  0139
*  CR4HEDAD = CR4HEDAD - RPRPELEN; /*SET PTR TO PREVIOUS ENTRY*/   0139
         SH    CR4HEDAD,RPRPELEN(,CR4HEDAD)                        0139
*END;                                                              0140
@DE00138 SLR   @10,@10                                             0140
         CH    @10,RPRPELEN(,CR4HEDAD)                             0140
         BNE   @DL00138                                            0140
*CR4ERCOD=0;                        /*ZERO OUT ERROR CODE*/        0141
         STH   @10,CR4ERCOD(,CR4R13)                               0141
*/* ---------------------------------                              0142
*   PROCESS COMMAND CODES                                          0142
* -----------------------------*/                                  0142
* IF NCSCRCMD = NCSCROPN               /*OPEN CASE?*/              0142
*   THEN CALL CR4OPEN;                 /*YES CALL OPEN*/           0142
         CLI   NCSCRCMD(CR4NCSAD),1                                0142
         BNE   @RF00142                                            0142
         BAL   @14,CR4OPEN                                         0143
*   ELSE                                                           0144
*     IF RDTVSRPL ^= 0                  /*HAVE RPL?,ACB OPEN?*/    0144
*       THEN DO;                                                   0144
         B     @RC00142                                            0144
@RF00142 L     @10,RDTVSRPL(,CR4HEDAD)                             0144
         LTR   @10,@10                                             0144
         BZ    @RF00144                                            0144
*        CR4RPLAD=RDTVSRPL;              /*WORKING PTR TO RPL*/    0146
         LR    CR4RPLAD,@10                                        0146
*         RFY(ISTRDT,ISTRPRE) BASED(NCSCRDTE); /*RESET RDTE*/      0147
*       IF NCSCRCMD=NCSCRCLS             /*CLOSE?*/                0148
*         THEN CALL CR4CLOSE;            /*YES-CALL CLOSE*/        0148
         CLI   NCSCRCMD(CR4NCSAD),2                                0148
         BNE   @RF00148                                            0148
         BAL   @14,CR4CLOSE                                        0149
*         ELSE CALL CR4UPERS;            /*NO-CALL UPDATE,ERASE*/  0150
         B     @RC00148                                            0150
@RF00148 BAL   @14,CR4UPERS                                        0150
*      END;                                                        0151
         EJECT
*CR4OPEN:PROC OPTIONS(NOSAVE,NOSAVEAREA);                          0152
         B     @PB00002                                            0152
CR4OPEN  DS    0H                                                  0153
*/*----------------------------------------                        0153
* OPEN DATASET AND UPDATE RDT                                      0153
*------------------------------------------*/                      0153
*CR4R14S1=CR4R14;                       /*SAVE REG-14*/            0153
         ST    CR4R14,CR4R14S1(,CR4R13)                            0153
*RFY (ISTRDT,ISTRPRE) BASED(CR4HEDAD);                             0154
*STM(GPR02P,GPR10P,CR4R210);            /*SAVE REG 2->10*/         0155
         STM   GPR02P,GPR10P,CR4R210(CR4R13)                       0155
*RFY CR4R01 RSTD;                                                  0156
*CR4R01  =LENGTH(CR4GTSTR);                 /*GETSTOR SIZE*/       0157
         LA    CR4R01,185                                          0157
* /*GETSTOR SIZE(CR4R01)CLEAR(YES)SAVE(NO)*/                       0158
*  DO;                                                             0158
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTATCVT,ISTRPH)  */                  0159
* RFY ISTPAB  ;                                                    0159
* RFY ISTDYPAB;                                                    0160
* RFY ISTATCVT;                                                    0161
*/* END OF ATBUILD */                                              0162
* RFY (GPR00P,GPR01P,GPR02P,GPR03P) RSTD;                          0162
* GPR00F = CR4R01;                                     /*SIZE IN REG0*/
         LR    GPR00F,CR4R01                                       0163
* DCL 1 CMZA0006 FIXED(31) STATIC LOCAL,                           0164
*       2 * FIXED(8) INIT(32),                       /* OPTION FLAGS */
*       2 * FIXED(8) INIT(96),                        /* STORAGE KEY */
*       2 * FIXED(8) INIT(231),                    /* SUBPOOL NUMBER */
*       2 * FIXED(8) INIT('00'X);                    /* REQUEST TYPE */
* GPR03F = CMZA0006;                                               0165
*                                                                  0165
         L     GPR03F,CMZA0006                                     0165
* DO; /* LISATCVT CVTBASE(PAGEABLE,(GPR02P)) */                    0166
*   GPR02P = ATCLCPTR; /*SET UP ATCVT POINTER*/                    0167
         L     GPR02P,ATCLCPTR                                     0167
* END; /*LISATCVT*/                                                0168
* CALL GPR02P -> ATCGTSTR;                            /*CALL ISTORFSR*/
         L     @15,ATCGTSTR(,GPR02P)                               0169
         BALR  @14,@15                                             0169
* RFY (GPR00P,GPR01P,GPR02P,GPR03P) UNRSTD;                        0170
* END ;                                              /*END OF GETSTOR*/
*     /*GETSTORAGE*/                                               0172
*RFY CR4R01  UNRSTD;                                               0172
*RFY GPR03P RSTD;                                                  0173
* GPR02P=CR4R2S;                        /*REST REG 2*/             0174
         L     GPR02P,CR4R2S(,CR4R13)                              0174
* LM(GPR04P,GPR10P,CR4R410);            /*REST REG 4->10*/         0175
         LM    GPR04P,GPR10P,CR4R410(CR4R13)                       0175
*IF CR4R15 ^= 0                         /*GETSTOR ERROR */         0176
*  THEN DO;                                                        0176
         LTR   CR4R15,CR4R15                                       0176
         BZ    @RF00176                                            0176
*   CR4ERCOD = FIVE;                    /*INDICATE GETSTOR ERROR*/ 0178
         MVC   CR4ERCOD(2,CR4R13),@CH00203                         0178
*   CALL CR4ERROR;                      /*CALL ERROR ROUTINE*/     0179
         BAL   @14,CR4ERROR                                        0179
*  END;                                                            0180
*RDTVSRPL=GPR03P;                       /*RPL PTR INTO RDT HEADER*/
@RF00176 ST    GPR03P,RDTVSRPL(,CR4HEDAD)                          0181
*CR4RPLAD=GPR03P;                       /*WORKING PTR TO RPL*/     0182
         LR    CR4RPLAD,GPR03P                                     0182
*RFY GPR03P UNRSTD;                                                0183
*FIRSTSW=OFF;                                                      0184
         L     @10,RDTVSRPL(,CR4HEDAD)                             0184
         NI    FIRSTSW(@10),B'01111111'                            0184
*CR4OPN=OPNBASE;                        /*MOVE OPEN LIST TO CR4*/  0185
         MVC   CR4OPN(4,@10),OPNBASE                               0185
*CR4CLS=CLSBASE;                         /*MOVE CLOSE LIST TO CR4*/
         MVC   CR4CLS(4,@10),CLSBASE                               0186
*CR4ACB=ACBBASE;                          /*MOVE ACB TO CR4*/      0187
         MVC   CR4ACB(76,@10),ACBBASE                              0187
*CR4RPL=RPLBASE;                          /*MOVE RPL TO CR4*/      0188
         MVC   CR4RPL(76,@10),RPLBASE                              0188
*RPLDACB=RDTVSRPL+RPLLEN;                   /*PTR TO ACB INTO RPL*/
         SLR   @09,@09                                             0189
         IC    @09,RPLLEN(,CR4RPLAD)                               0189
         ALR   @10,@09                                             0189
         ST    @10,RPLDACB(,CR4RPLAD)                              0189
*RPLRLEN=LENGTH(CR4REC);                    /*REC LENGTH INTO RPL*/
         LA    @09,24                                              0190
         ST    @09,RPLRLEN(,CR4RPLAD)                              0190
*RPLAREA=RPLDACB+ACBLENG;                   /*PTR TO BUF INT RPL*/ 0191
         LH    @06,ACBLENG(,@10)                                   0191
         ALR   @06,@10                                             0191
         ST    @06,RPLAREA(,CR4RPLAD)                              0191
*RPLARG=ADDR(CR4KEY);                   /*KEY ADDR INTO RPL*/      0192
         ST    @06,RPLARG(,CR4RPLAD)                               0192
*RPLKEYL=LENGTH(CR4KEY);                /*KEY LENGTH INTO RPL*/    0193
         MVC   RPLKEYL(2,CR4RPLAD),@CH00117                        0193
*RPLKGE=ON;                             /*SEARCH ON KEY GE*/       0194
         OI    RPLKGE(CR4RPLAD),B'00000100'                        0194
*RPLBUFL=LENGTH(CR4REC);                /*REC LENGTH INTO RPL*/    0195
         ST    @09,RPLBUFL(,CR4RPLAD)                              0195
*ACBLRECL=LENGTH(CR4REC);               /*REC LENGTH INTO ACB*/    0196
         STH   @09,ACBLRECL(,@10)                                  0196
*ACBDDNM=RDTCRSDS;                      /*DDNAME INTO ACB*/        0197
         MVC   ACBDDNM(8,@10),RDTCRSDS(CR4HEDAD)                   0197
*ACBPASSW=ADDR(RDTCRSPW);               /*PASSWORD INTO ACB*/      0198
         LA    @09,RDTCRSPW(,CR4HEDAD)                             0198
         ST    @09,ACBPASSW(,@10)                                  0198
*CR4CKPT=ON;                            /*INDICATE TURN ON CKPT FLAGS*/
         OI    CR4CKPT(@06),B'00001000'                            0199
*CALL CR4FLAGS;                         /*TURN ON CKPT FLAGS*/     0200
         BAL   @14,CR4FLAGS                                        0200
*IF NCSPLWRM=ON                         /*WARM START ?*/           0201
* THEN                                  /*YES */                   0201
         TM    NCSPLWRM(CR4NCSAD),B'10000000'                      0201
         BNO   @RF00201                                            0201
* RPLUPD=OFF;                           /*SET UP RPL FOR NO UPDATE*/
         NI    RPLUPD(CR4RPLAD),B'11111101'                        0202
*RFY (CR4R03,CR4R09) RSTD;                                         0203
@RF00201 DS    0H                                                  0204
*CR4R15=0;                              /*ZERO R-15*/              0204
         SLR   CR4R15,CR4R15                                       0204
*CR4R03=ADDR(CR4ACB);                                              0205
         L     @10,RDTVSRPL(,CR4HEDAD)                             0205
         LA    CR4R03,CR4ACB(,@10)                                 0205
*CR4R09=ADDR(CR4OPN);                                              0206
         LA    CR4R09,CR4OPN(,@10)                                 0206
*GEN(OPEN ((3)),MF=(E,(9)));  /*OPEN DATASET*/                     0207
         OPEN ((3)),MF=(E,(9))
*RFY (CR4R03,CR4R09) UNRSTD;                                       0208
*IF CR4R15 > 4                          /*OPEN ERROR*/             0209
*  THEN DO;                             /*YES*/                    0209
         C     CR4R15,@CF00117                                     0209
         BNH   @RF00209                                            0209
*   CR4ERCOD=THREE;                     /*INDICATE OPEN ERROR*/    0211
         MVC   CR4ERCOD(2,CR4R13),@CH00215                         0211
*   CALL CR4ERROR;                      /*CALL ERROR ROUTINE*/     0212
         BAL   @14,CR4ERROR                                        0212
*  END;                                                            0213
* IF ACBAMBL->AMBLDTA->AMBINBUF=OFF      /*SHARE OPTION 4 SPECIFIED?*/
*   THEN DO;                            /*NO ?*/                   0214
@RF00209 L     @10,RPLDACB(,CR4RPLAD)                              0214
         L     @10,ACBAMBL(,@10)                                   0214
         L     @10,AMBLDTA(,@10)                                   0214
         TM    AMBINBUF(@10),B'00000001'                           0214
         BNZ   @RF00214                                            0214
*RFY(ISTRDT,ISTRPRE) BASED(CR4HEDAD);                              0216
*CR4MSGCH(1:8)=RDTCRSDS;               /*CKPT DS NAME INTO MSG*/   0217
         MVC   CR4MSGCH(8,CR4R13),RDTCRSDS(CR4HEDAD)               0217
*CR4MSGCH(9:16)=RPRNAME;               /*MAJ NODE NAME INTO MSG*/  0218
         MVC   CR4MSGCH+8(8,CR4R13),RPRNAME(CR4HEDAD)              0218
*CR4MSGID=CR4421I;                                                 0219
         MVC   CR4MSGID(4,CR4R13),@CC00492                         0219
*       RFY (CR4MSGNO,CR4MSGTX) RSTD;                              0220
*       CR4MSGNO=ADDR(CR4MSGID);                                   0221
         LA    CR4MSGNO,CR4MSGID(,CR4R13)                          0221
*       CR4MSGTX=ADDR(CR4MSGCH);                                   0222
*                                                                  0222
         LA    CR4MSGTX,CR4MSGCH(,CR4R13)                          0222
*/*TPMSG MSGID((CR4MSGNO))MSG((CR4MSGTX))OPTIONS(NCSPLSID)PLAREA(CR4MSG
*R)*/                                                              0223
*                                                                  0223
*        DO;                                                       0223
*          DCL REG1024  REG(1)  PTR;                               0224
*          RFY (REG1024) RSTD;                                     0225
*                                                                  0225
*        RFY (EMCR13) RSTD;                                        0226
*          DCL 1 * BASED(REG1024),                                 0227
*              2 CMZID024 PTR(31),                                 0227
*              2 *,                                                0227
*                3 CMZRL024 PTR(8),                                0227
*                3 CMZRA024 PTR(24) BDY(BYTE),                     0227
*              2 CMZEA024 PTR(31),                                 0227
*              2 CMZVP024 PTR(31);                                 0227
*                                                                  0227
*/*XREGSET  PID('PLAREA')PPARM(CR4MSGAR)RREG(,REG1024)*/           0228
*        DO;                                                       0228
*          REG1024=ADDR(CR4MSGAR);       /*SET RREG SYMBOL TO ADDRESS*/
         LA    REG1024,CR4MSGAR(,CR4R13)                           0229
*                                        /*OF PPARM OPERAND          */
*        END;  /* XREGSET */                                       0230
*          CMZID024 = 0;                                           0231
         SLR   @06,@06                                             0231
         ST    @06,CMZID024(,REG1024)                              0231
*          CMZRL024 = 0;                                           0232
         MVI   CMZRL024(REG1024),X'00'                             0232
*          CMZRA024 = 0;                                           0233
         STCM  @06,7,CMZRA024(REG1024)                             0233
*          CMZEA024 = 0;                                           0234
         ST    @06,CMZEA024(,REG1024)                              0234
*          CMZVP024 = 0;                                           0235
         ST    @06,CMZVP024(,REG1024)                              0235
*          CMZID024=CR4MSGNO;                                      0236
         ST    CR4MSGNO,CMZID024(,REG1024)                         0236
*          CMZVP024 = CR4MSGTX;                                    0237
         ST    CR4MSGTX,CMZVP024(,REG1024)                         0237
*          DCL CMZSA024 (18) PTR(31) BASED(EMCR13);                0238
*          CMZSA024(5) = ADDR(NCSPLSID);                           0239
*                                                                  0239
         LA    @06,NCSPLSID(,CR4NCSAD)                             0239
         ST    @06,CMZSA024+16(,EMCR13)                            0239
*          DCL REG15024 REG(15) PTR;                               0240
*          RFY REG15024 RSTD;                                      0241
*                                                                  0241
*        DO; /* LISATCVT CVTBASE(PAGEABLE,(REG15024)) */           0242
*          REG15024 = ATCLCPTR; /*SET UP ATCVT POINTER*/           0243
         L     REG15024,ATCLCPTR                                   0243
*        END; /*LISATCVT*/                                         0244
*          DCL CMTA024 BASED(REG15024) ENTRY VALUERANGE(*);        0245
*          REG15024 = REG15024->ATCMSGP;                           0246
         L     REG15024,ATCMSGP(,REG15024)                         0246
*          CALL CMTA024;                                           0247
         BALR  @14,@15                                             0247
*          RESPECIFY (REG1024,REG15024)  UNRESTRICTED;             0248
*                                                                  0248
*        RFY (EMCR13) UNRSTD;                                      0249
*        END;                                                      0250
*       RFY (CR4MSGNO,CR4MSGTX) UNRSTD;                            0251
* END;                                                             0252
*CR4RDTAD=CR4HEDAD;                      /*START AT TOP OF RDT*/   0253
@RF00214 LR    CR4RDTAD,CR4HEDAD                                   0253
*RFY (ISTRPRE,ISTRCPRE,ISTRLC,ISTRRN,ISTRLN,ISTRPT,ISTRCL,ISTRTR,  0254
*ISTRDT,  ISTRCC,ISTRLU,ISTRSW,ISTRDA) BASED(CR4RDTAD);            0254
*FIRSTSW=ON;                          /*TURN ON FIRST SWITCH*/     0255
         L     @10,RDTVSRPL(,CR4RDTAD)                             0255
         OI    FIRSTSW(@10),B'10000000'                            0255
*GEN(GET  RPL=(7));                     /*ISSUE GET*/              0256
         GET  RPL=(7)
*           IF CR4R15^=0            /*ERROR?*/                     0257
*             THEN DO;                                             0257
         LTR   CR4R15,CR4R15                                       0257
         BZ    @RF00257                                            0257
*             CR4ERCOD=FOUR;        /*I/O ERROR*/                  0259
         MVC   CR4ERCOD(2,CR4R13),@CH00117                         0259
*             CALL CR4ERROR;        /*CALL ERROR ROUTINE*/         0260
         BAL   @14,CR4ERROR                                        0260
*             END;                                                 0261
*GEN(CHECK RPL=(7));                                               0262
@RF00257 DS    0H                                                  0262
         CHECK RPL=(7)
*IF (RPLRTNCD=CR4HEX8 & RPLERRCD=CR4HEX74)|   /*EODAD ON FIRST GET*/
*   (RPLRTNCD=CR4HEX8 & RPLERRCD=CR4HEX10)                         0263
*  THEN DO;                                                        0263
         CLI   RPLRTNCD(CR4RPLAD),8                                0263
         BNE   @GL00001                                            0263
         CLI   RPLERRCD(CR4RPLAD),116                              0263
         BE    @RT00263                                            0263
@GL00001 CLI   RPLRTNCD(CR4RPLAD),8                                0263
         BNE   @RF00263                                            0263
         CLI   RPLERRCD(CR4RPLAD),16                               0263
         BNE   @RF00263                                            0263
@RT00263 DS    0H                                                  0264
*       NCSIORC=NCSCRION;                  /*SET RETURN CODE*/     0265
         MVI   NCSIORC(CR4NCSAD),X'34'                             0265
*       FIRSTSW=OFF;                                               0266
         L     @10,RDTVSRPL(,CR4RDTAD)                             0266
         NI    FIRSTSW(@10),B'01111111'                            0266
*    END;                                 /*NULL D S */            0267
*  ELSE DO;                                                        0268
         B     @RC00263                                            0268
@RF00263 DS    0H                                                  0269
*    IF RPLRTNCD^=0                                 /*ERROR,NOT EODAD*/
*      THEN DO;                                                    0269
         CLI   RPLRTNCD(CR4RPLAD),0                                0269
         BE    @RF00269                                            0269
*      CR4ERCOD=FOUR;                   /*INDICATE I/O ERROR*/     0271
         MVC   CR4ERCOD(2,CR4R13),@CH00117                         0271
*      CALL CR4ERROR;                   /*CALL ERROR ROUTINE*/     0272
         BAL   @14,CR4ERROR                                        0272
*      END;                                                        0273
*    /*-------------------------------                             0274
*       LOOP THRU REST OF RECORDS                                  0274
*    ---------------------------------*/                           0274
*    DO WHILE (RPLRTNCD^=CR4HEX8 | RPLERRCD^=CR4HEX10);/*LOOP TIL EOD*/
@RF00269 B     @DE00274                                            0274
@DL00274 DS    0H                                                  0275
*      CR4RDTAD=CR4HEDAD;               /*START AT TOP OF RDTE*/   0275
         LR    CR4RDTAD,CR4HEDAD                                   0275
*      DO WHILE CR4DAF ^= RPRDAF;       /*LOOP UNTIL DAFS MATCH*/  0276
         B     @DE00276                                            0276
@DL00276 DS    0H                                                  0277
*        IF RPRENTED = ON                                          0277
*           THEN DO;                    /*END OF RDT & NO MATCH*/  0277
         TM    RPRENTED(CR4RDTAD),B'00000100'                      0277
         BNO   @RF00277                                            0277
*           CR4ERCOD=TWO;               /*INDICATE LOGICAL ERROR*/ 0279
         MVC   CR4ERCOD(2,CR4R13),@CH00197                         0279
*           CALL CR4ERROR;              /*CALL ERROR ROUTINE*/     0280
         BAL   @14,CR4ERROR                                        0280
*           END;                                                   0281
*        CR4RDTAD=CR4RDTAD+RPRELEN;     /*PT TO NEXT RDTE*/        0282
@RF00277 AH    CR4RDTAD,RPRELEN(,CR4RDTAD)                         0282
*      END;                            /*DAFS MATCH*/              0283
@DE00276 L     @10,RPLAREA(,CR4RPLAD)                              0283
         CLC   CR4DAF(2,@10),RPRDAF(CR4RDTAD)                      0283
         BNE   @DL00276                                            0283
         EJECT
*/*-----------------------------                                   0284
*   SEE IF PROPER ENTRY TYPE                                       0284
*_______________________________*/                                 0284
*IF RPRENTRY^=RPRENTLN & RPRENTRY^=RPRENTCM & RPRENTRY^=RPRENTTR & 0284
*   RPRENTRY^=RPRENTUT & RPRENTRY^=RPRENTLU & RPRENTRY^=RPRENTCC & 0284
*   RPRENTRY^=RPRENTDA & RPRENTRY^=RPRENTRN & RPRENTRY^=RPRENTCL & 0284
*   RPRENTRY^=RPRENTSW & RPRENTRY^=RPRENTLS & RPRENTRY^=RPRENTLH   0284
*   THEN DO;                                                       0284
         CLI   RPRENTRY(CR4RDTAD),X'50'                            0284
         BE    @RF00284                                            0284
         CLI   RPRENTRY(CR4RDTAD),X'90'                            0284
         BE    @RF00284                                            0284
         CLI   RPRENTRY(CR4RDTAD),X'80'                            0284
         BE    @RF00284                                            0284
         CLI   RPRENTRY(CR4RDTAD),X'75'                            0284
         BE    @RF00284                                            0284
         CLI   RPRENTRY(CR4RDTAD),X'81'                            0284
         BE    @RF00284                                            0284
         CLI   RPRENTRY(CR4RDTAD),X'71'                            0284
         BE    @RF00284                                            0284
         CLI   RPRENTRY(CR4RDTAD),X'51'                            0284
         BE    @RF00284                                            0284
         CLI   RPRENTRY(CR4RDTAD),X'01'                            0284
         BE    @RF00284                                            0284
         CLI   RPRENTRY(CR4RDTAD),X'70'                            0284
         BE    @RF00284                                            0284
         CLI   RPRENTRY(CR4RDTAD),X'04'                            0284
         BE    @RF00284                                            0284
         CLI   RPRENTRY(CR4RDTAD),X'05'                            0284
         BE    @RF00284                                            0284
         CLI   RPRENTRY(CR4RDTAD),X'03'                            0284
         BE    @RF00284                                            0284
*   CR4ERCOD=2;                       /*INDICATE LOGICAL ERROR*/   0286
         MVC   CR4ERCOD(2,CR4R13),@CH00197                         0286
*   CALL CR4ERROR;                    /*CALL ERROR ROUTINE*/       0287
         BAL   @14,CR4ERROR                                        0287
*   END;                                                           0288
*/*-----------------------------------------                       0289
*   VERIFY BITMASK CORRESPONDS TO RDTE TYPE                        0289
*-------------------------------------------*/                     0289
*IF                                                                0289
*     (RPRENTRY=RPRENTLN & RLNRACAT=ON     & RLNRATRN = ON   /*DIAL */
*    & RLNPORT=OFF)                                           /*SDLC*/
*      THEN IF                                                     0289
@RF00284 CLI   RPRENTRY(CR4RDTAD),X'50'                            0289
         BNE   @RF00289                                            0289
         TM    RLNRACAT(CR4RDTAD),B'10000000'                      0289
         BNO   @RF00289                                            0289
         TM    RLNRATRN(CR4RDTAD),B'00000010'                      0289
         BNO   @RF00289                                            0289
         TM    RLNPORT(CR4RDTAD),B'00010000'                       0289
         BNZ   @RF00289                                            0289
*      (CR4DTRLM=ON| CR4PACTV=ON | CR4LGAPL=ON | CR4LGMDE=ON |     0290
*       CR4CUA=ON | CR4RNME=ON | CR4PTUSE=ON )                     0290
*        THEN CR4ERCOD=TWO;             /*INDICATE LOGICAL ERROR*/ 0290
         L     @10,RPLAREA(,CR4RPLAD)                              0290
         TM    CR4DTRLM(@10),B'01000111'                           0290
         BNZ   @RT00290                                            0290
         TM    CR4CUA(@10),B'01110000'                             0290
         BZ    @RF00290                                            0290
@RT00290 DS    0H                                                  0291
         MVC   CR4ERCOD(2,CR4R13),@CH00197                         0291
*        ELSE;                                                     0292
@RF00290 DS    0H                                                  0293
*  ELSE DO;                                                        0293
         B     @RC00289                                            0293
@RF00289 DS    0H                                                  0294
*    IF ((RPRENTRY=RPRENTLN                                  /*LINE*/
*        & RLNPORT=OFF)      &                                     0294
*        (CR4DTRLM=ON | CR4LGAPL=ON | CR4LGMDE=ON | CR4ANSMD=ON|   0294
*         CR4CUA=ON | CR4RNME=ON | CR4PTUSE=ON | CR4PACTV=ON))     0294
* THEN  CR4ERCOD=TWO;                   /*INDICATE LOGICAL ERROR*/ 0294
         CLI   RPRENTRY(CR4RDTAD),X'50'                            0294
         BNE   @RF00294                                            0294
         TM    RLNPORT(CR4RDTAD),B'00010000'                       0294
         BNZ   @RF00294                                            0294
         L     @10,RPLAREA(,CR4RPLAD)                              0294
         TM    CR4DTRLM(@10),B'00000111'                           0294
         BNZ   @RT00294                                            0294
         TM    CR4ANSMD(@10),B'11110000'                           0294
         BNZ   @RT00294                                            0294
         TM    CR4PACTV(@10),B'01000000'                           0294
         BNO   @RF00294                                            0294
@RT00294 DS    0H                                                  0295
         MVC   CR4ERCOD(2,CR4R13),@CH00197                         0295
*        ELSE IF                                                   0296
*                                                                  0296
*  (((RPRENTRY=RPRENTCM) | (RPRENTRY=RPRENTTR)) &        /*TERM,COMP*/
*        (CR4PACTV=ON | CR4POLD=ON | CR4NRPL=ON |                  0296
*         CR4SESLM=ON |                             CR4LGMDE=ON |  0296
*         CR4ANSMD=ON | CR4CUA=ON | CR4RNME=ON |  CR4PTUSE=ON))    0296
*                                                                  0296
*THEN   CR4ERCOD=TWO;                   /*INDICATE LOGICAL ERROR*/ 0296
         B     @RC00294                                            0296
@RF00294 CLI   RPRENTRY(CR4RDTAD),X'90'                            0296
         BE    @GL00023                                            0296
         CLI   RPRENTRY(CR4RDTAD),X'80'                            0296
         BNE   @RF00296                                            0296
@GL00023 L     @10,RPLAREA(,CR4RPLAD)                              0296
         TM    CR4PACTV(@10),B'01111001'                           0296
         BNZ   @RT00296                                            0296
         TM    CR4ANSMD(@10),B'11110000'                           0296
         BZ    @RF00296                                            0296
@RT00296 DS    0H                                                  0297
         MVC   CR4ERCOD(2,CR4R13),@CH00197                         0297
*        ELSE IF                                                   0298
*  ((RPRENTRY=RPRENTUT) &                             /*UTERM*/    0298
*        ( CR4PACTV=ON | CR4POLD=ON | CR4NRPL=ON |                 0298
*         CR4SESLM=ON | CR4DTRLM=ON |  CR4LGMDE=ON |               0298
*         CR4ANSMD=ON | CR4CUA=ON | CR4RNME=ON |  CR4PTUSE=ON))    0298
*THEN   CR4ERCOD=TWO;                   /*INDICATE LOGICAL ERROR*/ 0298
         B     @RC00296                                            0298
@RF00296 CLI   RPRENTRY(CR4RDTAD),X'75'                            0298
         BNE   @RF00298                                            0298
         L     @10,RPLAREA(,CR4RPLAD)                              0298
         TM    CR4PACTV(@10),B'01111101'                           0298
         BNZ   @RT00298                                            0298
         TM    CR4ANSMD(@10),B'11110000'                           0298
         BZ    @RF00298                                            0298
@RT00298 DS    0H                                                  0299
         MVC   CR4ERCOD(2,CR4R13),@CH00197                         0299
*        ELSE IF                                                   0300
*                                                                  0300
*  ((RPRENTRY=RPRENTLN & RLNPORT = ON )                    /*PORT */
*                       &                                          0300
*        (              CR4POLD=ON | CR4NRPL=ON |                  0300
*         CR4SESLM=ON | CR4DTRLM=ON | CR4LGAPL=ON | CR4LGMDE=ON |  0300
*         CR4ANSMD=ON | CR4CUA=ON | CR4RNME=ON |  CR4PTUSE=ON))    0300
*                                                                  0300
*THEN   CR4ERCOD=TWO;                   /*INDICATE LOGICAL ERROR*/ 0300
         B     @RC00298                                            0300
@RF00298 CLI   RPRENTRY(CR4RDTAD),X'50'                            0300
         BNE   @RF00300                                            0300
         TM    RLNPORT(CR4RDTAD),B'00010000'                       0300
         BNO   @RF00300                                            0300
         L     @10,RPLAREA(,CR4RPLAD)                              0300
         TM    CR4POLD(@10),B'00111111'                            0300
         BNZ   @RT00300                                            0300
         TM    CR4ANSMD(@10),B'11110000'                           0300
         BZ    @RF00300                                            0300
@RT00300 DS    0H                                                  0301
         MVC   CR4ERCOD(2,CR4R13),@CH00197                         0301
*        ELSE IF                                                   0302
*  ((RPRENTRY=RPRENTLU) &                                 /*LU*/   0302
*        ( CR4PACTV=ON | CR4POLD=ON | CR4NRPL=ON |                 0302
*         CR4SESLM=ON | CR4DTRLM=ON |                              0302
*         CR4ANSMD=ON | CR4CUA=ON | CR4RNME=ON |  CR4PTUSE=ON))    0302
*                                                                  0302
* THEN  CR4ERCOD=TWO;                   /*INDICATE LOGICAL ERROR*/ 0302
         B     @RC00300                                            0302
@RF00300 CLI   RPRENTRY(CR4RDTAD),X'81'                            0302
         BNE   @RF00302                                            0302
         L     @10,RPLAREA(,CR4RPLAD)                              0302
         TM    CR4PACTV(@10),B'01111100'                           0302
         BNZ   @RT00302                                            0302
         TM    CR4ANSMD(@10),B'11110000'                           0302
         BZ    @RF00302                                            0302
@RT00302 DS    0H                                                  0303
         MVC   CR4ERCOD(2,CR4R13),@CH00197                         0303
*       ELSE IF                                                    0304
*  ((RPRENTRY=RPRENTCC) &                                  /*PU*/  0304
*        (  CR4PACTV=ON | CR4POLD=ON | CR4NRPL=ON |                0304
*         CR4SESLM=ON | CR4DTRLM=ON | CR4LGAPL=ON | CR4LGMDE=ON |  0304
*         CR4ANSMD=ON | CR4CUA=ON | CR4RNME=ON   ))                0304
*THEN   CR4ERCOD=TWO;                   /*INDICATE LOGICAL ERROR*/ 0304
         B     @RC00302                                            0304
@RF00302 CLI   RPRENTRY(CR4RDTAD),X'71'                            0304
         BNE   @RF00304                                            0304
         L     @10,RPLAREA(,CR4RPLAD)                              0304
         TM    CR4PACTV(@10),B'01111111'                           0304
         BNZ   @RT00304                                            0304
         TM    CR4ANSMD(@10),B'11100000'                           0304
         BZ    @RF00304                                            0304
@RT00304 DS    0H                                                  0305
         MVC   CR4ERCOD(2,CR4R13),@CH00197                         0305
*     ELSE IF                                                      0306
*                                                                  0306
*  ((RPRENTRY=RPRENTDA) &                                  /*DA*/  0306
*        (CR4ACTV=ON | CR4PACTV=ON | CR4POLD=ON | CR4NRPL=ON |     0306
*         CR4SESLM=ON | CR4DTRLM=ON | CR4LGAPL=ON | CR4LGMDE=ON |  0306
*         CR4ANSMD=ON |  CR4RNME=ON |  CR4PTUSE=ON))               0306
*                                                                  0306
* THEN  CR4ERCOD=TWO;                   /*INDICATE LOGICAL ERROR*/ 0306
         B     @RC00304                                            0306
@RF00304 CLI   RPRENTRY(CR4RDTAD),X'51'                            0306
         BNE   @RF00306                                            0306
         L     @10,RPLAREA(,CR4RPLAD)                              0306
         TM    CR4ACTV(@10),B'11111111'                            0306
         BNZ   @RT00306                                            0306
         TM    CR4ANSMD(@10),B'10110000'                           0306
         BZ    @RF00306                                            0306
@RT00306 DS    0H                                                  0307
         MVC   CR4ERCOD(2,CR4R13),@CH00197                         0307
*        ELSE IF                                                   0308
*  ((RPRENTRY=RPRENTRN & RRNRBREM=OFF)                     /*RN*/  0308
*                       &                                          0308
*        ( CR4PACTV=ON | CR4POLD=ON | CR4NRPL=ON |                 0308
*         CR4SESLM=ON | CR4DTRLM=ON | CR4LGAPL=ON | CR4LGMDE=ON |  0308
*         CR4ANSMD=ON  | CR4RNME=ON |  CR4PTUSE=ON))               0308
*THEN   CR4ERCOD=TWO;                   /*INDICATE LOGICAL ERROR*/ 0308
         B     @RC00306                                            0308
@RF00306 CLI   RPRENTRY(CR4RDTAD),X'01'                            0308
         BNE   @RF00308                                            0308
         TM    RRNRBREM(CR4RDTAD),B'00000100'                      0308
         BNZ   @RF00308                                            0308
         L     @10,RPLAREA(,CR4RPLAD)                              0308
         TM    CR4PACTV(@10),B'01111111'                           0308
         BNZ   @RT00308                                            0308
         TM    CR4ANSMD(@10),B'10110000'                           0308
         BZ    @RF00308                                            0308
@RT00308 DS    0H                                                  0309
         MVC   CR4ERCOD(2,CR4R13),@CH00197                         0309
*         ELSE IF                                                  0310
*                                                                  0310
*  ((RPRENTRY=RPRENTRN & RRNRBREM=ON )                   /*REMOTE RN*/
*                       &                                          0310
*        ( CR4PACTV=ON | CR4POLD=ON | CR4NRPL=ON | CR4CUA=ON |     0310
*         CR4SESLM=ON | CR4DTRLM=ON | CR4LGAPL=ON | CR4LGMDE=ON |  0310
*         CR4ANSMD=ON |   CR4PTUSE=ON))                            0310
*                                                                  0310
*THEN   CR4ERCOD=TWO;                   /*INDICATE LOGICAL ERROR*/ 0310
         B     @RC00308                                            0310
@RF00308 CLI   RPRENTRY(CR4RDTAD),X'01'                            0310
         BNE   @RF00310                                            0310
         TM    RRNRBREM(CR4RDTAD),B'00000100'                      0310
         BNO   @RF00310                                            0310
         L     @10,RPLAREA(,CR4RPLAD)                              0310
         TM    CR4PACTV(@10),B'01110000'                           0310
         BNZ   @RT00310                                            0310
         TM    CR4CUA(@10),B'01000000'                             0310
         BO    @RT00310                                            0310
         TM    CR4SESLM(@10),B'00001111'                           0310
         BNZ   @RT00310                                            0310
         TM    CR4ANSMD(@10),B'10010000'                           0310
         BZ    @RF00310                                            0310
@RT00310 DS    0H                                                  0311
         MVC   CR4ERCOD(2,CR4R13),@CH00197                         0311
*       ELSE IF                                                    0312
*      /* CLUSTER,SWITCH SUBAREA,LOCAL SUBAREA*/                   0312
* (((RPRENTRY=RPRENTCL) |  (RPRENTRY=RPRENTSW) | (RPRENTRY=RPRENTLS))&
*        ( CR4PACTV=ON | CR4POLD=ON | CR4NRPL=ON |                 0312
*         CR4SESLM=ON | CR4DTRLM=ON | CR4LGAPL=ON | CR4LGMDE=ON |  0312
*         CR4ANSMD=ON | CR4CUA=ON | CR4RNME=ON |  CR4PTUSE=ON))    0312
*      THEN CR4ERCOD=TWO;                                          0312
         B     @RC00310                                            0312
@RF00310 CLI   RPRENTRY(CR4RDTAD),X'70'                            0312
         BE    @GL00045                                            0312
         CLI   RPRENTRY(CR4RDTAD),X'04'                            0312
         BE    @GL00045                                            0312
         CLI   RPRENTRY(CR4RDTAD),X'05'                            0312
         BNE   @RF00312                                            0312
@GL00045 L     @10,RPLAREA(,CR4RPLAD)                              0312
         TM    CR4PACTV(@10),B'01111111'                           0312
         BNZ   @RT00312                                            0312
         TM    CR4ANSMD(@10),B'11110000'                           0312
         BZ    @RF00312                                            0312
@RT00312 DS    0H                                                  0313
         MVC   CR4ERCOD(2,CR4R13),@CH00197                         0313
*      END;                             /*SDLC END */              0314
@RF00312 DS    0H                                                  0314
@RC00310 DS    0H                                                  0314
@RC00308 DS    0H                                                  0314
@RC00306 DS    0H                                                  0314
@RC00304 DS    0H                                                  0314
@RC00302 DS    0H                                                  0314
@RC00300 DS    0H                                                  0314
@RC00298 DS    0H                                                  0314
@RC00296 DS    0H                                                  0314
@RC00294 DS    0H                                                  0315
*IF     CR4ERCOD=TWO                    /*INDICATE LOGICAL ERROR*/ 0315
* THEN  CALL CR4ERROR;                  /*CALL ERROR ROUTINE*/     0315
@RC00289 CLC   CR4ERCOD(2,CR4R13),@CH00197                         0315
         BNE   @RF00315                                            0315
         BAL   @14,CR4ERROR                                        0316
         EJECT
*IF NCSPLWRM=ON                         /*IF WARM START*/          0317
*  THEN DO;                             /*PROCESS BITMASK FOR      0317
*                                              WARM*/              0317
@RF00315 TM    NCSPLWRM(CR4NCSAD),B'10000000'                      0317
         BNO   @RF00317                                            0317
*/*---------------------------------------------------             0319
* MOVE FIELDS FROM RECORD TO RDTE CORRESPONDING TO APPROPRIATE BITS
*-----------------------------------------------------*/           0319
*IF CR4ACTV = ON                        /*ACT/INACT*/              0319
* THEN                                                             0319
         L     @10,RPLAREA(,CR4RPLAD)                              0319
         TM    CR4ACTV(@10),B'10000000'                            0319
         BNO   @RF00319                                            0319
*   IF RPRENTRY = RPRENTLN              /*LINE?*/                  0320
*     THEN IF CR4ACT=ON                                            0320
         CLI   RPRENTRY(CR4RDTAD),X'50'                            0320
         BNE   @RF00320                                            0320
*       THEN RLNRBISA=ON;               /*UPDATE RDTE*/            0321
         TM    CR4ACT(@10),B'10000000'                             0321
         BNO   @RF00321                                            0321
         OI    RLNRBISA(CR4RDTAD),B'01000000'                      0322
*       ELSE RLNRBISA=OFF;                                         0323
         B     @RC00321                                            0323
@RF00321 NI    RLNRBISA(CR4RDTAD),B'10111111'                      0323
*     ELSE                                                         0324
*       IF (RPRENTRY=RPRENTTR|RPRENTRY=RPRENTUT|                   0324
*          RPRENTRY=RPRENTCM)           /*TERM,UTERM,COMP?*/       0324
*          THEN DO;                                                0324
         B     @RC00320                                            0324
@RF00320 CLI   RPRENTRY(CR4RDTAD),X'80'                            0324
         BE    @RT00324                                            0324
         CLI   RPRENTRY(CR4RDTAD),X'75'                            0324
         BE    @RT00324                                            0324
         CLI   RPRENTRY(CR4RDTAD),X'90'                            0324
         BNE   @RF00324                                            0324
@RT00324 DS    0H                                                  0325
*             IF CR4ACT=ON                                         0326
*             THEN RTRRBISA=ON;                                    0326
         L     @10,RPLAREA(,CR4RPLAD)                              0326
         TM    CR4ACT(@10),B'10000000'                             0326
         BNO   @RF00326                                            0326
         OI    RTRRBISA(CR4RDTAD),B'01000000'                      0327
*             ELSE RTRRBISA=OFF;        /*UPDATE RDTE*/            0328
         B     @RC00326                                            0328
@RF00326 NI    RTRRBISA(CR4RDTAD),B'10111111'                      0328
*             IF RPRNSNEA->RPRENTRY=RPRENTLC  /*NXT SCH NDE A LCL DEV*/
*               THEN DO;                                           0329
@RC00326 L     @10,RPRNSNEA(,CR4RDTAD)                             0329
         CLI   RPRENTRY(@10),X'45'                                 0329
         BNE   @RF00329                                            0329
*                     IF CR4ACT =ON     /*UPDATE RDTE*/            0331
*                     THEN RPRNSNEA->RLCRBISA=ON;                  0331
         L     @09,RPLAREA(,CR4RPLAD)                              0331
         TM    CR4ACT(@09),B'10000000'                             0331
         BNO   @RF00331                                            0331
         OI    RLCRBISA(@10),B'01000000'                           0332
*                     ELSE RPRNSNEA->RLCRBISA=OFF;                 0333
         B     @RC00331                                            0333
@RF00331 L     @10,RPRNSNEA(,CR4RDTAD)                             0333
         NI    RLCRBISA(@10),B'10111111'                           0333
*               END;                                               0334
*          END;                                                    0335
*          ELSE                                                    0336
*             IF RPRENTRY=RPRENTLU      /*LU*/                     0336
*               THEN IF CR4ACT =ON                                 0336
         B     @RC00324                                            0336
@RF00324 CLI   RPRENTRY(CR4RDTAD),X'81'                            0336
         BNE   @RF00336                                            0336
*                      THEN RLURBISA=ON;                           0337
         L     @10,RPLAREA(,CR4RPLAD)                              0337
         TM    CR4ACT(@10),B'10000000'                             0337
         BNO   @RF00337                                            0337
         OI    RLURBISA(CR4RDTAD),B'10000000'                      0338
*                  ELSE RLURBISA=OFF;                              0339
         B     @RC00337                                            0339
@RF00337 NI    RLURBISA(CR4RDTAD),B'01111111'                      0339
*               ELSE                                               0340
*                 IF RPRENTRY = RPRENTCC /*PU*/                    0340
*                  THEN IF CR4ACT=ON          /*UPDATE RDTE*/      0340
         B     @RC00336                                            0340
@RF00336 CLI   RPRENTRY(CR4RDTAD),X'71'                            0340
         BNE   @RF00340                                            0340
*                       THEN RCCRBISA=ON;                          0341
         L     @10,RPLAREA(,CR4RPLAD)                              0341
         TM    CR4ACT(@10),B'10000000'                             0341
         BNO   @RF00341                                            0341
         OI    RCCRBISA(CR4RDTAD),B'10000000'                      0342
*                       ELSE RCCRBISA=OFF;                         0343
         B     @RC00341                                            0343
@RF00341 NI    RCCRBISA(CR4RDTAD),B'01111111'                      0343
*                   ELSE                                           0344
*                    IF RPRENTRY=RPRENTCL  /*CLUSTER*/             0344
*                     THEN IF CR4ACT =ON         /*UPDATE RDTE*/   0344
         B     @RC00340                                            0344
@RF00340 CLI   RPRENTRY(CR4RDTAD),X'70'                            0344
         BNE   @RF00344                                            0344
*                          THEN RCLRBISA=ON;                       0345
         L     @10,RPLAREA(,CR4RPLAD)                              0345
         TM    CR4ACT(@10),B'10000000'                             0345
         BNO   @RF00345                                            0345
         OI    RCLRBISA(CR4RDTAD),B'01000000'                      0346
*                          ELSE RCLRBISA=OFF;                      0347
         B     @RC00345                                            0347
@RF00345 NI    RCLRBISA(CR4RDTAD),B'10111111'                      0347
*                        ELSE                                      0348
*                        IF RPRENTRY=RPRENTRN /*RN*/               0348
*                         THEN IF CR4ACT =ON     /*UPDATE RDTE*/   0348
         B     @RC00344                                            0348
@RF00344 CLI   RPRENTRY(CR4RDTAD),X'01'                            0348
         BNE   @RF00348                                            0348
*                              THEN RRNRBISA=ON;                   0349
         L     @10,RPLAREA(,CR4RPLAD)                              0349
         TM    CR4ACT(@10),B'10000000'                             0349
         BNO   @RF00349                                            0349
         OI    RRNRBISA(CR4RDTAD),B'01000000'                      0350
*                              ELSE RRNRBISA=OFF;                  0351
         B     @RC00349                                            0351
@RF00349 NI    RRNRBISA(CR4RDTAD),B'10111111'                      0351
*IF CR4PACTV = ON                       /*PORT ACT/INACT*/         0352
*   THEN IF CR4PORT=ON                                             0352
@RC00349 DS    0H                                                  0352
@RF00348 DS    0H                                                  0352
@RC00344 DS    0H                                                  0352
@RC00340 DS    0H                                                  0352
@RC00336 DS    0H                                                  0352
@RC00324 DS    0H                                                  0352
@RC00320 DS    0H                                                  0352
@RF00319 L     @10,RPLAREA(,CR4RPLAD)                              0352
         TM    CR4PACTV(@10),B'01000000'                           0352
         BNO   @RF00352                                            0352
*  THEN RPTISTAT=ON;                                               0353
         TM    CR4PORT(@10),B'01000000'                            0353
         BNO   @RF00353                                            0353
         OI    RPTISTAT(CR4RDTAD),B'00000001'                      0354
*  ELSE RPTISTAT=OFF;                                              0355
         B     @RC00353                                            0355
@RF00353 NI    RPTISTAT(CR4RDTAD),B'11111110'                      0355
*IF CR4POLD = ON                        /*POLL DELAY*/             0356
*  THEN DO;                                                        0356
@RC00353 DS    0H                                                  0356
@RF00352 L     @10,RPLAREA(,CR4RPLAD)                              0356
         TM    CR4POLD(@10),B'00100000'                            0356
         BNO   @RF00356                                            0356
*    RLNSVSKP=ON;                       /*TURN ON LN SCH PARM*/    0358
         OI    RLNSVSKP(CR4RDTAD),B'00001000'                      0358
*    RLNPAUSE=CR4PAUSE;                 /*UPDATE RDTE*/            0359
         MVC   RLNPAUSE(1,CR4RDTAD),CR4PAUSE(@10)                  0359
*  END;                                                            0360
*IF CR4NRPL = ON                        /*NEG RESP TO POLL*/       0361
*  THEN DO;                                                        0361
@RF00356 L     @10,RPLAREA(,CR4RPLAD)                              0361
         TM    CR4NRPL(@10),B'00010000'                            0361
         BNO   @RF00361                                            0361
*   RLNNPRLM=ON;                        /*TURN ON LN SCH PARM*/    0363
         OI    RLNNPRLM(CR4RDTAD),B'00100000'                      0363
*   RLNPOLMT=CR4POLMT;                  /*UPDATE RDTE*/            0364
         MVC   RLNPOLMT(1,CR4RDTAD),CR4POLMT(@10)                  0364
*  END;                                                            0365
*IF CR4SESLM = ON                       /*SESSION LIMIT*/          0366
*  THEN DO;                                                        0366
@RF00361 L     @10,RPLAREA(,CR4RPLAD)                              0366
         TM    CR4SESLM(@10),B'00001000'                           0366
         BNO   @RF00366                                            0366
*   RLNSESLM=ON;                        /*TURN ON LN SCH PATM*/    0368
         OI    RLNSESLM(CR4RDTAD),B'00010000'                      0368
*   RLNCTSES=CR4CTSES;                  /*UPDATE RDTE*/            0369
         MVC   RLNCTSES(1,CR4RDTAD),CR4CTSES(@10)                  0369
*  END;                                                            0370
*IF CR4DTRLM = ON                       /*DEV TRANS LIMIT*/        0371
*  THEN DO;                                                        0371
@RF00366 L     @10,RPLAREA(,CR4RPLAD)                              0371
         TM    CR4DTRLM(@10),B'00000100'                           0371
         BNO   @RF00371                                            0371
*    RTRDTRLM=ON;                        /*UPDATE LINE SCH PARM*/  0373
         OI    RTRDTRLM(CR4RDTAD),B'00100000'                      0373
*    RTRTRMAX=CR4TRMAX;                 /*UPDATE RDTE*/            0374
         MVC   RTRTRMAX(1,CR4RDTAD),CR4TRMAX(@10)                  0374
*  END;                                                            0375
*IF CR4LGAPL = ON                       /*LOGAPPL*/                0376
*  THEN RCPLGNAP=CR4LGNAP;              /*UPDATE RDTE*/            0376
@RF00371 L     @10,RPLAREA(,CR4RPLAD)                              0376
         TM    CR4LGAPL(@10),B'00000010'                           0376
         BNO   @RF00376                                            0376
         MVC   RCPLGNAP(8,CR4RDTAD),CR4LGNAP(@10)                  0377
*IF CR4LGMDE = ON                       /*LOGMODE*/                0378
*  THEN RLULGMOD=CR4LGMOD;              /*UPDATE RDTE*/            0378
@RF00376 L     @10,RPLAREA(,CR4RPLAD)                              0378
         TM    CR4LGMDE(@10),B'00000001'                           0378
         BNO   @RF00378                                            0378
         MVC   RLULGMOD(8,CR4RDTAD),CR4LGMOD(@10)                  0379
*IF CR4ANSMD = ON                       /*ANSWER MODE*/            0380
*  THEN IF CR4ANSWR=ON                                             0380
@RF00378 L     @10,RPLAREA(,CR4RPLAD)                              0380
         TM    CR4ANSMD(@10),B'10000000'                           0380
         BNO   @RF00380                                            0380
*   THEN RLNANSWR=ON;                   /*UPDATE RDTE*/            0381
         TM    CR4ANSWR(@10),B'00100000'                           0381
         BNO   @RF00381                                            0381
         OI    RLNANSWR(CR4RDTAD),B'01000000'                      0382
*   ELSE RLNANSWR=OFF;                                             0383
         B     @RC00381                                            0383
@RF00381 NI    RLNANSWR(CR4RDTAD),B'10111111'                      0383
*IF CR4CUA = ON                         /*CUA*/                    0384
*   THEN                                                           0384
@RC00381 DS    0H                                                  0384
@RF00380 L     @10,RPLAREA(,CR4RPLAD)                              0384
         TM    CR4CUA(@10),B'01000000'                             0384
         BNO   @RF00384                                            0384
*     IF RPRENTRY=RPRENTDA              /*DA*/                     0385
*       THEN RDADACUA=CR4DACUA;         /*UPDATE RDTE*/            0385
         CLI   RPRENTRY(CR4RDTAD),X'51'                            0385
         BNE   @RF00385                                            0385
         MVC   RDADACUA(3,CR4RDTAD),CR4DACUA(@10)                  0386
*       ELSE RRNRDCUA=CR4DACUA;         /*FOR RN - PTM-4927*/      0387
         B     @RC00385                                            0387
@RF00385 L     @10,RPLAREA(,CR4RPLAD)                              0387
         MVC   RRNRDCUA(3,CR4RDTAD),CR4DACUA(@10)                  0387
*IF CR4RNME=ON                          /*RNAME*/                  0388
*   THEN RRNRINNM=CR4RINNM;              /*UPDATE RDTE*/           0388
@RC00385 DS    0H                                                  0388
@RF00384 L     @10,RPLAREA(,CR4RPLAD)                              0388
         TM    CR4RNME(@10),B'00100000'                            0388
         BNO   @RF00388                                            0388
         MVC   RRNRINNM(8,CR4RDTAD),CR4RINNM(@10)                  0389
*IF CR4PTUSE = ON                       /*PATH*/                   0390
*   THEN DO;                                                       0390
@RF00388 L     @10,RPLAREA(,CR4RPLAD)                              0390
         TM    CR4PTUSE(@10),B'00010000'                           0390
         BNO   @RF00390                                            0390
* RFY CR4PATAD RSTD;                                               0392
* CR4PATAD=RCCPATHT;                    /*SET WORKING PTR TO PATH TBL*/
         L     CR4PATAD,RCCPATHT(,CR4RDTAD)                        0393
* RFY ISTPAT BASED(CR4PATAD);           /*BASE PATH TABLE*/        0394
*    CALL CR4PATH;                      /*FIND PATH TABLE ENTRY*/  0395
         BAL   @14,CR4PATH                                         0395
*    IF CR4PATUS=ON                     /*UPDATE RDTE*/            0396
*       THEN PATUSEFG=ON;                                          0396
         L     @09,RPLAREA(,CR4RPLAD)                              0396
         TM    CR4PATUS(@09),B'00010000'                           0396
         BNO   @RF00396                                            0396
         OI    PATUSEFG(CR4PATAD),B'10000000'                      0397
*       ELSE PATUSEFG=OFF;                                         0398
         B     @RC00396                                            0398
@RF00396 NI    PATUSEFG(CR4PATAD),B'01111111'                      0398
*   END;                                                           0399
@RC00396 DS    0H                                                  0400
*RFY CR4PATAD UNRSTD;                                              0400
@RF00390 DS    0H                                                  0401
*END;                                                              0401
         EJECT
*  ELSE DO;                             /*COLD START*/             0402
         B     @RC00317                                            0402
@RF00317 DS    0H                                                  0403
*/*-----------------------------------------                       0403
*  TURN ON THE BITS IN RDTE FOR LN SCHED PARM CHANGE               0403
* ------------------------------------------*/                     0403
*   IF RPRENTRY=RPRENTTR | RPRENTRY=RPRENTCM  /*TERM OR COMP*/     0403
*            | RPRENTRY = RPRENTLN            /*OR LINE*/          0403
*     THEN DO;                                                     0403
         CLI   RPRENTRY(CR4RDTAD),X'80'                            0403
         BE    @RT00403                                            0403
         CLI   RPRENTRY(CR4RDTAD),X'90'                            0403
         BE    @RT00403                                            0403
         CLI   RPRENTRY(CR4RDTAD),X'50'                            0403
         BNE   @RF00403                                            0403
@RT00403 DS    0H                                                  0404
*      IF CR4POLD = ON                  /*POLL DELAY*/             0405
*        THEN RLNSVSKP=ON;             /*UPDATE RDTE*/             0405
         L     @10,RPLAREA(,CR4RPLAD)                              0405
         TM    CR4POLD(@10),B'00100000'                            0405
         BNO   @RF00405                                            0405
         OI    RLNSVSKP(CR4RDTAD),B'00001000'                      0406
*      IF CR4NRPL=ON                    /*NEG RESP TO POLL*/       0407
*        THEN RLNNPRLM=ON;              /*UPDATE RDTE*/            0407
@RF00405 L     @10,RPLAREA(,CR4RPLAD)                              0407
         TM    CR4NRPL(@10),B'00010000'                            0407
         BNO   @RF00407                                            0407
         OI    RLNNPRLM(CR4RDTAD),B'00100000'                      0408
*      IF CR4SESLM = ON                 /*SESSION LIMIT*/          0409
*        THEN RLNSESLM=ON;              /*UPDATE*/                 0409
@RF00407 L     @10,RPLAREA(,CR4RPLAD)                              0409
         TM    CR4SESLM(@10),B'00001000'                           0409
         BNO   @RF00409                                            0409
         OI    RLNSESLM(CR4RDTAD),B'00010000'                      0410
*      IF CR4DTRLM=ON                   /*DEV TRANS LIMIT*/        0411
*         THEN RTRDTRLM = ON;            /*UPDATE RDT*/            0411
@RF00409 L     @10,RPLAREA(,CR4RPLAD)                              0411
         TM    CR4DTRLM(@10),B'00000100'                           0411
         BNO   @RF00411                                            0411
         OI    RTRDTRLM(CR4RDTAD),B'00100000'                      0412
*    END;                               /*TERM OR COMP*/           0413
@RF00411 DS    0H                                                  0414
*    GEN(  ERASE  RPL=(7));             /*ERASE RECORD*/           0414
@RF00403 DS    0H                                                  0414
           ERASE  RPL=(7)
*           IF CR4R15^=0            /*ERROR?*/                     0415
*             THEN DO;                                             0415
         LTR   CR4R15,CR4R15                                       0415
         BZ    @RF00415                                            0415
*             CR4ERCOD=FOUR;        /*I/O ERROR*/                  0417
         MVC   CR4ERCOD(2,CR4R13),@CH00117                         0417
*             CALL CR4ERROR;        /*CALL ERROR ROUTINE*/         0418
         BAL   @14,CR4ERROR                                        0418
*             END;                                                 0419
*GEN(CHECK RPL=(7));                                               0420
@RF00415 DS    0H                                                  0420
         CHECK RPL=(7)
*    IF RPLRTNCD^=0                     /*ERASE ERROR*/            0421
*       THEN DO;                                                   0421
         CLI   RPLRTNCD(CR4RPLAD),0                                0421
         BE    @RF00421                                            0421
*         CR4ERCOD=FOUR;                /*INDICATE I/O ERROR*/     0423
         MVC   CR4ERCOD(2,CR4R13),@CH00117                         0423
*         CALL CR4ERROR;                /*CALL ERROR ROUTINE*/     0424
         BAL   @14,CR4ERROR                                        0424
*       END;                                                       0425
*    END;                               /*FOR COLD START*/         0426
@RF00421 DS    0H                                                  0427
*      CR4KEY=CR4KEY+1;                /*ADD 1 TO KEY*/            0427
@RC00317 L     @10,RPLAREA(,CR4RPLAD)                              0427
         LA    @09,1                                               0427
         AL    @09,CR4KEY(,@10)                                    0427
         ST    @09,CR4KEY(,@10)                                    0427
*      GEN(GET RPL=(7));                /*ISSUE GET*/              0428
         GET RPL=(7)
*           IF CR4R15^=0            /*ERROR?*/                     0429
*             THEN DO;                                             0429
         LTR   CR4R15,CR4R15                                       0429
         BZ    @RF00429                                            0429
*             CR4ERCOD=FOUR;        /*I/O ERROR*/                  0431
         MVC   CR4ERCOD(2,CR4R13),@CH00117                         0431
*             CALL CR4ERROR;        /*CALL ERROR ROUTINE*/         0432
         BAL   @14,CR4ERROR                                        0432
*             END;                                                 0433
*GEN(CHECK RPL=(7));                                               0434
@RF00429 DS    0H                                                  0434
         CHECK RPL=(7)
*    IF RPLRTNCD ^=0 & (RPLRTNCD^=CR4HEX8 |  /*ERROR BUT NO EODAD*/
*                      RPLERRCD^=CR4HEX10)                         0435
*        THEN DO;                                                  0435
         CLI   RPLRTNCD(CR4RPLAD),0                                0435
         BE    @RF00435                                            0435
         CLI   RPLRTNCD(CR4RPLAD),8                                0435
         BNE   @RT00435                                            0435
         CLI   RPLERRCD(CR4RPLAD),16                               0435
         BE    @RF00435                                            0435
@RT00435 DS    0H                                                  0436
*        CR4ERCOD=FOUR;                 /*INDICATE I/O ERROR*/     0437
         MVC   CR4ERCOD(2,CR4R13),@CH00117                         0437
*        CALL CR4ERROR;                 /*CALL ERROR ROUTINE*/     0438
         BAL   @14,CR4ERROR                                        0438
*        END;                                                      0439
*       CR4R15=0;                       /*ZERO R-15*/              0440
@RF00435 SLR   CR4R15,CR4R15                                       0440
*    END;                              /*EODAD LOOP*/              0441
@DE00274 CLI   RPLRTNCD(CR4RPLAD),8                                0441
         BNE   @DL00274                                            0441
         CLI   RPLERRCD(CR4RPLAD),16                               0441
         BNE   @DL00274                                            0441
*END;                                 /*NULL DATASET*/             0442
* RPLUPD=ON;                            /*INDICATE UPDATE*/        0443
@RC00263 OI    RPLUPD(CR4RPLAD),B'00000010'                        0443
*CR4R14=CR4R14S1;                        /*RESTORE REG-14*/        0444
         L     CR4R14,CR4R14S1(,CR4R13)                            0444
*END CR4OPEN;                                                      0445
@EL00002 DS    0H                                                  0445
@EF00002 DS    0H                                                  0445
@ER00002 BR    @14                                                 0445
         EJECT
*CR4UPERS:PROC OPTIONS(NOSAVE,NOSAVEAREA);                         0446
CR4UPERS DS    0H                                                  0447
*/*--------------------------------------------------              0447
*   UPDATE DATASET AND ERASE RECORDS                               0447
*----------------------------------------------------*/            0447
*CR4R14S1=CR4R14;                       /*SAVE REG-14*/            0447
         ST    CR4R14,CR4R14S1(,CR4R13)                            0447
*RFY (ISTRDT) BASED(NCSCRDTE);                                     0448
*RFY (ISTRPRE,ISTRCPRE,ISTRLC,ISTRRN,ISTRLN,ISTRPT,ISTRCL,ISTRTR,  0449
*         ISTRCC,ISTRLU,ISTRSW,ISTRDA) BASED(NCSCRDTE);            0449
*CR4RECRD=CR4ZEROD;                     /*ZERO OUT BUFFER*/        0450
         L     @10,RPLAREA(,CR4RPLAD)                              0450
         MVC   CR4RECRD(24,@10),@CB00526                           0450
*RFY (ISTRDT) BASED(CR4HEDAD);                                     0451
*IF FIRSTSW=ON                         /*FIRST PUT ?*/             0452
*   THEN DO;                                                       0452
         L     @10,RDTVSRPL(,CR4HEDAD)                             0452
         TM    FIRSTSW(@10),B'10000000'                            0452
         BNO   @RF00452                                            0452
*    RPLDIR=ON;                         /*RPL DIRECT,*/            0454
*    RPLSEQ=OFF;                        /*NOT SEQUENTIAL*/         0455
         OI    RPLDIR(CR4RPLAD),B'01000000'                        0455
         NI    RPLSEQ(CR4RPLAD),B'11011111'                        0455
*   END;                                                           0456
*RFY (ISTRDT) BASED(NCSCRDTE);                                     0457
@RF00452 DS    0H                                                  0458
*RPLKGE=OFF;                            /*TURN ON RPL SEARCH KEY GE*/
         NI    RPLKGE(CR4RPLAD),B'11111011'                        0458
*/*-----------------                                               0459
*  BUILD KEY                                                       0459
*-------------------*/                                             0459
*IF(((RPRENTRY=RPRENTUT) | (RPRENTRY=RPRENTTR))                    0459
*&RPRNSNEA->RLNPORT=ON    &          /*PORT IN NEXT SCHED NODE*/   0459
*   (NCSCRDTE=RPRNSNEA->RPTATERM))              /*DAF CHANGED?*/   0459
*   THEN DO;                                                       0459
         L     @10,NCSCRDTE(,CR4NCSAD)                             0459
         CLI   RPRENTRY(@10),X'75'                                 0459
         BE    @GL00057                                            0459
         CLI   RPRENTRY(@10),X'80'                                 0459
         BNE   @RF00459                                            0459
@GL00057 L     @10,NCSCRDTE(,CR4NCSAD)                             0459
         L     @09,RPRNSNEA(,@10)                                  0459
         TM    RLNPORT(@09),B'00010000'                            0459
         BNO   @RF00459                                            0459
         C     @10,RPTATERM(,@09)                                  0459
         BNE   @RF00459                                            0459
*       CR4DAF=RPRNSNEA->   RPTDAFSV; /*USE DAF IN NEXT SCHED NODE*/
         L     @10,RPLAREA(,CR4RPLAD)                              0461
         MVC   CR4DAF(2,@10),RPTDAFSV(@09)                         0461
*   END;                                                           0462
*  ELSE CR4DAF = RPRDAF;              /*USE DAF IN THIS NODE*/     0463
         B     @RC00459                                            0463
@RF00459 L     @10,RPLAREA(,CR4RPLAD)                              0463
         L     @09,NCSCRDTE(,CR4NCSAD)                             0463
         MVC   CR4DAF(2,@10),RPRDAF(@09)                           0463
*IF NCSPTUSE = ON                     /*PATH?*/                    0464
* THEN CR4PID = NCSCRPID + 1;         /*YES- SET UP PID*/          0464
@RC00459 TM    NCSPTUSE(CR4NCSAD),B'00010000'                      0464
         BNO   @RF00464                                            0464
         L     @10,RPLAREA(,CR4RPLAD)                              0465
         LA    @09,1                                               0465
         SLR   @06,@06                                             0465
         IC    @06,NCSCRPID(,CR4NCSAD)                             0465
         ALR   @09,@06                                             0465
         STH   @09,CR4PID(,@10)                                    0465
*/*----- KEY NOW BUILT -------*/                                   0466
*GEN(   GET  RPL=(7));                /*ISSUE GET*/                0466
@RF00464 DS    0H                                                  0466
            GET  RPL=(7)
*           IF CR4R15^=0            /*ERROR?*/                     0467
*             THEN DO;                                             0467
         LTR   CR4R15,CR4R15                                       0467
         BZ    @RF00467                                            0467
*             CR4ERCOD=FOUR;        /*I/O ERROR*/                  0469
         MVC   CR4ERCOD(2,CR4R13),@CH00117                         0469
*             CALL CR4ERROR;        /*CALL ERROR ROUTINE*/         0470
         BAL   @14,CR4ERROR                                        0470
*             END;                                                 0471
*GEN(CHECK RPL=(7));                                               0472
@RF00467 DS    0H                                                  0472
         CHECK RPL=(7)
*IF (RPLRTNCD ^= 0)&((RPLRTNCD^=CR4HEX8)|  /*GET ERROR?*/          0473
*   (RPLERRCD^='74'X)&(RPLERRCD^=CR4HEX10)) /*BUT NOT NO REC*/     0473
*  THEN DO;                                                        0473
         CLI   RPLRTNCD(CR4RPLAD),0                                0473
         BE    @RF00473                                            0473
         CLI   RPLRTNCD(CR4RPLAD),8                                0473
         BNE   @RT00473                                            0473
         CLI   RPLERRCD(CR4RPLAD),116                              0473
         BE    @RF00473                                            0473
         CLI   RPLERRCD(CR4RPLAD),16                               0473
         BE    @RF00473                                            0473
@RT00473 DS    0H                                                  0474
*   CR4ERCOD=FOUR;                    /*INDICATE I/O ERROR*/       0475
         MVC   CR4ERCOD(2,CR4R13),@CH00117                         0475
*   CALL CR4ERROR;                    /*CALL ERROR ROUTINE*/       0476
         BAL   @14,CR4ERROR                                        0476
*  END;                                                            0477
         EJECT
*IF NCSCRCMD = NCSCRWR                /*UPDATE CASE?*/             0478
*  THEN DO;                                                        0478
@RF00473 CLI   NCSCRCMD(CR4NCSAD),0                                0478
         BNE   @RF00478                                            0478
*  /*-------------------------------                               0480
*    MOVE FIELDS FROM RDTE TO RECORD                               0480
* -----------------------------------*/                            0480
*IF NCSACTV = ON                        /*ACT/INACT*/              0480
*   THEN IF NCSAIMOD=ON                                            0480
         TM    NCSACTV(CR4NCSAD),B'10000000'                       0480
         BNO   @RF00480                                            0480
*        THEN CR4ACT=ON;                                           0481
         TM    NCSAIMOD(CR4NCSAD),B'10000000'                      0481
         BNO   @RF00481                                            0481
         L     @10,RPLAREA(,CR4RPLAD)                              0482
         OI    CR4ACT(@10),B'10000000'                             0482
*        ELSE CR4ACT=OFF;                                          0483
         B     @RC00481                                            0483
@RF00481 L     @10,RPLAREA(,CR4RPLAD)                              0483
         NI    CR4ACT(@10),B'01111111'                             0483
*IF NCSPACTV = ON                       /*PORT ACT/INACT*/         0484
*   THEN IF NCSPTMOD=ON                                            0484
@RC00481 DS    0H                                                  0484
@RF00480 TM    NCSPACTV(CR4NCSAD),B'01000000'                      0484
         BNO   @RF00484                                            0484
*        THEN CR4PORT=ON;                                          0485
         TM    NCSPTMOD(CR4NCSAD),B'01000000'                      0485
         BNO   @RF00485                                            0485
         L     @10,RPLAREA(,CR4RPLAD)                              0486
         OI    CR4PORT(@10),B'01000000'                            0486
*        ELSE CR4PORT=OFF;                                         0487
         B     @RC00485                                            0487
@RF00485 L     @10,RPLAREA(,CR4RPLAD)                              0487
         NI    CR4PORT(@10),B'10111111'                            0487
*IF NCSPOLD = ON                        /*POLL DELAY*/             0488
*   THEN CR4PAUSE=RLNPAUSE;                                        0488
@RC00485 DS    0H                                                  0488
@RF00484 TM    NCSPOLD(CR4NCSAD),B'00100000'                       0488
         BNO   @RF00488                                            0488
         L     @10,RPLAREA(,CR4RPLAD)                              0489
         L     @09,NCSCRDTE(,CR4NCSAD)                             0489
         MVC   CR4PAUSE(1,@10),RLNPAUSE(@09)                       0489
*IF NCSNRPL = ON                        /*NEG RESP TO POLL DELAY*/ 0490
*   THEN CR4POLMT=RLNPOLMT;                                        0490
@RF00488 TM    NCSNRPL(CR4NCSAD),B'00010000'                       0490
         BNO   @RF00490                                            0490
         L     @10,RPLAREA(,CR4RPLAD)                              0491
         L     @09,NCSCRDTE(,CR4NCSAD)                             0491
         MVC   CR4POLMT(1,@10),RLNPOLMT(@09)                       0491
*IF NCSESLM = ON                         /*SESSION LIMIT*/         0492
*   THEN CR4CTSES=RLNCTSES;                                        0492
@RF00490 TM    NCSESLM(CR4NCSAD),B'00001000'                       0492
         BNO   @RF00492                                            0492
         L     @10,RPLAREA(,CR4RPLAD)                              0493
         L     @09,NCSCRDTE(,CR4NCSAD)                             0493
         MVC   CR4CTSES(1,@10),RLNCTSES(@09)                       0493
*IF NCSDTRLM = ON                        /*DEV TRANS LIMIT*/       0494
*   THEN CR4TRMAX=RTRTRMAX;                                        0494
@RF00492 TM    NCSDTRLM(CR4NCSAD),B'00000100'                      0494
         BNO   @RF00494                                            0494
         L     @10,RPLAREA(,CR4RPLAD)                              0495
         L     @09,NCSCRDTE(,CR4NCSAD)                             0495
         MVC   CR4TRMAX(1,@10),RTRTRMAX(@09)                       0495
*IF NCSLGAPL = ON                        /*LOGAPPL*/               0496
*   THEN CR4LGNAP=RCPLGNAP;                                        0496
@RF00494 TM    NCSLGAPL(CR4NCSAD),B'00000010'                      0496
         BNO   @RF00496                                            0496
         L     @10,RPLAREA(,CR4RPLAD)                              0497
         L     @09,NCSCRDTE(,CR4NCSAD)                             0497
         MVC   CR4LGNAP(8,@10),RCPLGNAP(@09)                       0497
*IF NCSLGMOD = ON                       /*LOGMODE*/                0498
*   THEN CR4LGMOD=RLULGMOD;                                        0498
@RF00496 TM    NCSLGMOD(CR4NCSAD),B'00000001'                      0498
         BNO   @RF00498                                            0498
         L     @10,RPLAREA(,CR4RPLAD)                              0499
         L     @09,NCSCRDTE(,CR4NCSAD)                             0499
         MVC   CR4LGMOD(8,@10),RLULGMOD(@09)                       0499
*IF NCSANSMD = ON                       /*ANSWER MODE*/            0500
*   THEN IF RLNANSWR=ON                                            0500
@RF00498 TM    NCSANSMD(CR4NCSAD),B'10000000'                      0500
         BNO   @RF00500                                            0500
*         THEN CR4ANSWR=ON;                                        0501
         L     @10,NCSCRDTE(,CR4NCSAD)                             0501
         TM    RLNANSWR(@10),B'01000000'                           0501
         BNO   @RF00501                                            0501
         L     @10,RPLAREA(,CR4RPLAD)                              0502
         OI    CR4ANSWR(@10),B'00100000'                           0502
*         ELSE CR4ANSWR=OFF;                                       0503
         B     @RC00501                                            0503
@RF00501 L     @10,RPLAREA(,CR4RPLAD)                              0503
         NI    CR4ANSWR(@10),B'11011111'                           0503
*IF NCSCUA   = ON                       /*CUA*/                    0504
*   THEN IF RPRENTRY=RPRENTDA           /*DA*/                     0504
@RC00501 DS    0H                                                  0504
@RF00500 TM    NCSCUA(CR4NCSAD),B'01000000'                        0504
         BNO   @RF00504                                            0504
*         THEN CR4DACUA = RDADACUA;                                0505
         L     @10,NCSCRDTE(,CR4NCSAD)                             0505
         CLI   RPRENTRY(@10),X'51'                                 0505
         BNE   @RF00505                                            0505
         L     @09,RPLAREA(,CR4RPLAD)                              0506
         MVC   CR4DACUA(3,@09),RDADACUA(@10)                       0506
*         ELSE CR4DACUA = RRNRDCUA;     /*RN - PTM-4927*/          0507
         B     @RC00505                                            0507
@RF00505 L     @10,RPLAREA(,CR4RPLAD)                              0507
         L     @09,NCSCRDTE(,CR4NCSAD)                             0507
         MVC   CR4DACUA(3,@10),RRNRDCUA(@09)                       0507
*IF NCSRNME=ON                          /*RNAME*/                  0508
*  THEN CR4RINNM=RRNRINNM;                                         0508
@RC00505 DS    0H                                                  0508
@RF00504 TM    NCSRNME(CR4NCSAD),B'00100000'                       0508
         BNO   @RF00508                                            0508
         L     @10,RPLAREA(,CR4RPLAD)                              0509
         L     @09,NCSCRDTE(,CR4NCSAD)                             0509
         MVC   CR4RINNM(8,@10),RRNRINNM(@09)                       0509
*IF NCSPTUSE = ON                       /*PATH*/                   0510
* THEN DO;                                                         0510
@RF00508 TM    NCSPTUSE(CR4NCSAD),B'00010000'                      0510
         BNO   @RF00510                                            0510
* CR4RDTAD=NCSCRDTE;                                               0512
         L     @10,NCSCRDTE(,CR4NCSAD)                             0512
         LR    CR4RDTAD,@10                                        0512
* RFY CR4PATAD RSTD;                                               0513
* CR4PATAD=RCCPATHT;                    /*SET WORKING PTR TO PATH TBL*/
         L     @09,NCSCRDTE(,CR4NCSAD)                             0514
         L     CR4PATAD,RCCPATHT(,@09)                             0514
* RFY ISTPAT BASED(CR4PATAD);           /*BASE PATH TABLE*/        0515
*  CALL CR4PATH;                        /*FIND PATH TABLE ENTRY*/  0516
         BAL   @14,CR4PATH                                         0516
*  IF PATUSEFG=ON                       /*UPDATE RECORD PATH BIT*/ 0517
*     THEN CR4PATUS=ON;                                            0517
         TM    PATUSEFG(CR4PATAD),B'10000000'                      0517
         BNO   @RF00517                                            0517
         L     @09,RPLAREA(,CR4RPLAD)                              0518
         OI    CR4PATUS(@09),B'00010000'                           0518
*     ELSE CR4PATUS=OFF;                                           0519
         B     @RC00517                                            0519
@RF00517 L     @09,RPLAREA(,CR4RPLAD)                              0519
         NI    CR4PATUS(@09),B'11101111'                           0519
*  END;                                                            0520
@RC00517 DS    0H                                                  0521
*RFY CR4PATAD UNRSTD;                                              0521
@RF00510 DS    0H                                                  0522
         EJECT
*   CR4CHKPT=CR4CHKPT|NCSCHKPT;       /*MOVE BITMASK INTO RECORD*/ 0522
         L     @10,RPLAREA(,CR4RPLAD)                              0522
         OC    CR4CHKPT(2,@10),NCSCHKPT(CR4NCSAD)                  0522
*RFY (ISTRDT) BASED(CR4HEDAD);                                     0523
*IF FIRSTSW=OFF                       /*FIRST PUT ?*/              0524
*  THEN DO;                                                        0524
         L     @10,RDTVSRPL(,CR4HEDAD)                             0524
         TM    FIRSTSW(@10),B'10000000'                            0524
         BNZ   @RF00524                                            0524
*   RPLDIR=OFF;                      /*MAKE RPL-  */               0526
*   RPLSEQ=ON;                       /*SEQUENTIAL*/                0527
         OI    RPLSEQ(CR4RPLAD),B'00100000'                        0527
         NI    RPLDIR(CR4RPLAD),B'10111111'                        0527
*   RPLUPD=OFF;                      /*RPL- NO UPDATE*/            0528
         NI    RPLUPD(CR4RPLAD),B'11111101'                        0528
*  END;                                                            0529
*  ELSE DO;                                                        0530
         B     @RC00524                                            0530
@RF00524 DS    0H                                                  0531
*   RPLDIR=ON;                       /*MAKE RPL- */                0531
*   RPLSEQ=OFF;                      /*DIRECT*/                    0532
         OI    RPLDIR(CR4RPLAD),B'01000000'                        0532
         NI    RPLSEQ(CR4RPLAD),B'11011111'                        0532
*   RPLUPD=ON;                       /*RPL-    UPDATE*/            0533
         OI    RPLUPD(CR4RPLAD),B'00000010'                        0533
*  END;                                                            0534
*RFY (ISTRDT) BASED(CR4RDTAD);                                     0535
@RC00524 DS    0H                                                  0536
*IF ((RPLRTNCD=CR4HEX8)&(RPLERRCD=CR4HEX74))|                      0536
*   ((RPLRTNCD=CR4HEX8)&(RPLERRCD=CR4HEX10))                       0536
*   THEN RPLUPD=OFF;                                               0536
         CLI   RPLRTNCD(CR4RPLAD),8                                0536
         BNE   @GL00062                                            0536
         CLI   RPLERRCD(CR4RPLAD),116                              0536
         BE    @RT00536                                            0536
@GL00062 CLI   RPLRTNCD(CR4RPLAD),8                                0536
         BNE   @RF00536                                            0536
         CLI   RPLERRCD(CR4RPLAD),16                               0536
         BNE   @RF00536                                            0536
@RT00536 DS    0H                                                  0537
         NI    RPLUPD(CR4RPLAD),B'11111101'                        0537
*   GEN(    PUT  RPL=(7));               /*PUT OUT THE RECORD*/    0538
@RF00536 DS    0H                                                  0538
             PUT  RPL=(7)
*           IF CR4R15^=0            /*ERROR?*/                     0539
*             THEN DO;                                             0539
         LTR   CR4R15,CR4R15                                       0539
         BZ    @RF00539                                            0539
*             CR4ERCOD=FOUR;        /*I/O ERROR*/                  0541
         MVC   CR4ERCOD(2,CR4R13),@CH00117                         0541
*             CALL CR4ERROR;        /*CALL ERROR ROUTINE*/         0542
         BAL   @14,CR4ERROR                                        0542
*             END;                                                 0543
*GEN(CHECK RPL=(7));                                               0544
@RF00539 DS    0H                                                  0544
         CHECK RPL=(7)
*         RPLUPD=ON;                                               0545
         OI    RPLUPD(CR4RPLAD),B'00000010'                        0545
*   IF RPLRTNCD^=0                       /*PUT ERROR?*/            0546
*      THEN DO;                                                    0546
         CLI   RPLRTNCD(CR4RPLAD),0                                0546
         BE    @RF00546                                            0546
*        CR4ERCOD=FOUR;                   /*INDICATE I/O ERROR*/   0548
         MVC   CR4ERCOD(2,CR4R13),@CH00117                         0548
*        CALL CR4ERROR;                   /*CALL ERROR ROUTINE*/   0549
         BAL   @14,CR4ERROR                                        0549
*      END;                                                        0550
*RFY (ISTRDT) BASED(CR4HEDAD);                                     0551
@RF00546 DS    0H                                                  0552
* IF FIRSTSW=OFF THEN DO;              /*FIRST PUT*/               0552
         L     @10,RDTVSRPL(,CR4HEDAD)                             0552
         TM    FIRSTSW(@10),B'10000000'                            0552
         BNZ   @RF00552                                            0552
*CR4R15=0;                                /*ZERO R-15*/            0554
         SLR   CR4R15,CR4R15                                       0554
*RFY (CR4R03,CR4R09) RSTD;                                         0555
*CR4R03=ADDR(CR4ACB);                                              0556
         LA    CR4R03,CR4ACB(,@10)                                 0556
*CR4R09=ADDR(CR4CLS);                                              0557
         LA    CR4R09,CR4CLS(,@10)                                 0557
*GEN(CLOSE     ((3)),MF=(E,(9)));   /*ISS TCLOSE*/                 0558
         CLOSE     ((3)),MF=(E,(9))
*RFY (CR4R03,CR4R09) UNRSTD;                                       0559
*IF CR4R15 >  4                          /*CLOSE ERROR?*/          0560
*  THEN DO;                                                        0560
         C     CR4R15,@CF00117                                     0560
         BNH   @RF00560                                            0560
*   CR4ERCOD = ONE;                      /*INDICATE CLOSE ERROR*/  0562
         MVC   CR4ERCOD(2,CR4R13),@CH00127                         0562
*   CALL CR4ERROR;                       /*CALL ERROR ROUITNE*/    0563
         BAL   @14,CR4ERROR                                        0563
*  END;                                                            0564
*CR4R15=0;                              /*ZERO R-15*/              0565
@RF00560 SLR   CR4R15,CR4R15                                       0565
*RFY (CR4R03,CR4R09)   RSTD;                                       0566
*CR4R03=ADDR(CR4ACB);                                              0567
         L     @10,RDTVSRPL(,CR4HEDAD)                             0567
         LA    CR4R03,CR4ACB(,@10)                                 0567
*CR4R09=ADDR(CR4OPN);                                              0568
         LA    CR4R09,CR4OPN(,@10)                                 0568
*GEN(OPEN ((3)),MF=(E,(9)));  /*OPEN DATASET*/                     0569
         OPEN ((3)),MF=(E,(9))
*RFY (CR4R03,CR4R09) UNRSTD;                                       0570
*IF CR4R15 > 4                          /*OPEN ERROR*/             0571
*  THEN DO;                             /*YES*/                    0571
         C     CR4R15,@CF00117                                     0571
         BNH   @RF00571                                            0571
*   CR4ERCOD=THREE;                     /*INDICATE OPEN ERROR*/    0573
         MVC   CR4ERCOD(2,CR4R13),@CH00215                         0573
*   CALL CR4ERROR;                      /*CALL ERROR ROUTINE*/     0574
         BAL   @14,CR4ERROR                                        0574
*  END;                                                            0575
*END;                               /* FOR FIRST PUT*/             0576
@RF00571 DS    0H                                                  0577
*RFY (ISTRDT) BASED(CR4HEDAD);                                     0577
@RF00552 DS    0H                                                  0578
*   FIRSTSW=ON;              /*DID FIRST PUT */                    0578
         L     @10,RDTVSRPL(,CR4HEDAD)                             0578
         OI    FIRSTSW(@10),B'10000000'                            0578
*RFY (ISTRDT) BASED(CR4RDTAD);                                     0579
* END;                                                             0580
         EJECT
*/*----------------------------                                    0581
*   ERASE CASE                                                     0581
*-----------------------*/                                         0581
*ELSE  IF NCSCRCMD=NCSCRDEL                                        0581
*   THEN DO;                                                       0581
         B     @RC00478                                            0581
@RF00478 CLI   NCSCRCMD(CR4NCSAD),3                                0581
         BNE   @RF00581                                            0581
* /* SEE IF CHANGE TO ISTATUS*/                                    0583
* IF   NCSACTV=ON THEN CR4ACTV=OFF;       /*ACT/INACT*/            0583
         TM    NCSACTV(CR4NCSAD),B'10000000'                       0583
         BNO   @RF00583                                            0583
         L     @10,RPLAREA(,CR4RPLAD)                              0584
         NI    CR4ACTV(@10),B'01111111'                            0584
* IF NCSPACTV=ON THEN CR4PACTV=OFF;                                0585
@RF00583 TM    NCSPACTV(CR4NCSAD),B'01000000'                      0585
         BNO   @RF00585                                            0585
         L     @10,RPLAREA(,CR4RPLAD)                              0586
         NI    CR4PACTV(@10),B'10111111'                           0586
* IF NCSPOLD=ON THEN CR4POLD=OFF;                                  0587
@RF00585 TM    NCSPOLD(CR4NCSAD),B'00100000'                       0587
         BNO   @RF00587                                            0587
         L     @10,RPLAREA(,CR4RPLAD)                              0588
         NI    CR4POLD(@10),B'11011111'                            0588
* IF NCSNRPL=ON THEN CR4NRPL=OFF;                                  0589
@RF00587 TM    NCSNRPL(CR4NCSAD),B'00010000'                       0589
         BNO   @RF00589                                            0589
         L     @10,RPLAREA(,CR4RPLAD)                              0590
         NI    CR4NRPL(@10),B'11101111'                            0590
* IF NCSESLM=ON THEN CR4SESLM=OFF;                                 0591
@RF00589 TM    NCSESLM(CR4NCSAD),B'00001000'                       0591
         BNO   @RF00591                                            0591
         L     @10,RPLAREA(,CR4RPLAD)                              0592
         NI    CR4SESLM(@10),B'11110111'                           0592
* IF NCSDTRLM=ON THEN CR4DTRLM=OFF;                                0593
@RF00591 TM    NCSDTRLM(CR4NCSAD),B'00000100'                      0593
         BNO   @RF00593                                            0593
         L     @10,RPLAREA(,CR4RPLAD)                              0594
         NI    CR4DTRLM(@10),B'11111011'                           0594
* IF NCSLGAPL=ON THEN CR4LGAPL=OFF;                                0595
@RF00593 TM    NCSLGAPL(CR4NCSAD),B'00000010'                      0595
         BNO   @RF00595                                            0595
         L     @10,RPLAREA(,CR4RPLAD)                              0596
         NI    CR4LGAPL(@10),B'11111101'                           0596
* IF NCSLGMOD=ON THEN CR4LGMDE=OFF;                                0597
@RF00595 TM    NCSLGMOD(CR4NCSAD),B'00000001'                      0597
         BNO   @RF00597                                            0597
         L     @10,RPLAREA(,CR4RPLAD)                              0598
         NI    CR4LGMDE(@10),B'11111110'                           0598
* IF NCSANSMD=ON THEN CR4ANSMD=OFF;                                0599
@RF00597 TM    NCSANSMD(CR4NCSAD),B'10000000'                      0599
         BNO   @RF00599                                            0599
         L     @10,RPLAREA(,CR4RPLAD)                              0600
         NI    CR4ANSMD(@10),B'01111111'                           0600
* IF NCSCUA=ON THEN CR4CUA=OFF;                                    0601
@RF00599 TM    NCSCUA(CR4NCSAD),B'01000000'                        0601
         BNO   @RF00601                                            0601
         L     @10,RPLAREA(,CR4RPLAD)                              0602
         NI    CR4CUA(@10),B'10111111'                             0602
* IF NCSRNME=ON THEN CR4RNME=OFF;                                  0603
@RF00601 TM    NCSRNME(CR4NCSAD),B'00100000'                       0603
         BNO   @RF00603                                            0603
         L     @10,RPLAREA(,CR4RPLAD)                              0604
         NI    CR4RNME(@10),B'11011111'                            0604
* IF NCSPTUSE=ON THEN CR4PTUSE=OFF;                                0605
@RF00603 TM    NCSPTUSE(CR4NCSAD),B'00010000'                      0605
         BNO   @RF00605                                            0605
         L     @10,RPLAREA(,CR4RPLAD)                              0606
         NI    CR4PTUSE(@10),B'11101111'                           0606
* IF CR4CHKPT=CR4ZERO                      /*IF CHNG TO ISTATUS*/  0607
*    THEN DO;                                                      0607
@RF00605 L     @10,RPLAREA(,CR4RPLAD)                              0607
         CLC   CR4CHKPT(2,@10),@CB00513                            0607
         BNE   @RF00607                                            0607
*     GEN(   ERASE   RPL=(7));             /*ERASE THE RECORD*/    0609
            ERASE   RPL=(7)
*           IF CR4R15^=0            /*ERROR?*/                     0610
*             THEN DO;                                             0610
         LTR   CR4R15,CR4R15                                       0610
         BZ    @RF00610                                            0610
*             CR4ERCOD=FOUR;        /*I/O ERROR*/                  0612
         MVC   CR4ERCOD(2,CR4R13),@CH00117                         0612
*             CALL CR4ERROR;        /*CALL ERROR ROUTINE*/         0613
         BAL   @14,CR4ERROR                                        0613
*             END;                                                 0614
*GEN(CHECK RPL=(7));                                               0615
@RF00610 DS    0H                                                  0615
         CHECK RPL=(7)
*    IF RPLRTNCD ^=0 & (RPLRTNCD^=CR4HEX8 |  /*ERROR BUT NO REC FOUND*/
*                      RPLERRCD^='5C'X)                            0616
*       THEN DO;                                                   0616
         CLI   RPLRTNCD(CR4RPLAD),0                                0616
         BE    @RF00616                                            0616
         CLI   RPLRTNCD(CR4RPLAD),8                                0616
         BNE   @RT00616                                            0616
         CLI   RPLERRCD(CR4RPLAD),92                               0616
         BE    @RF00616                                            0616
@RT00616 DS    0H                                                  0617
*         CR4ERCOD=FOUR;                /*INDICATE I/O ERROR*/     0618
         MVC   CR4ERCOD(2,CR4R13),@CH00117                         0618
*         CALL CR4ERROR;                /*CALL ERROR ROUTINE*/     0619
         BAL   @14,CR4ERROR                                        0619
*       END;                                                       0620
*    END;                                                          0621
*   ELSE DO;                            /*DO NOT ERASE*/           0622
         B     @RC00607                                            0622
@RF00607 DS    0H                                                  0623
*    GEN(    PUT    RPL=(7));           /*PUT OUT THE RECORD*/     0623
             PUT    RPL=(7)
*           IF CR4R15^=0            /*ERROR?*/                     0624
*             THEN DO;                                             0624
         LTR   CR4R15,CR4R15                                       0624
         BZ    @RF00624                                            0624
*             CR4ERCOD=FOUR;        /*I/O ERROR*/                  0626
         MVC   CR4ERCOD(2,CR4R13),@CH00117                         0626
*             CALL CR4ERROR;        /*CALL ERROR ROUTINE*/         0627
         BAL   @14,CR4ERROR                                        0627
*             END;                                                 0628
*GEN(CHECK RPL=(7));                                               0629
@RF00624 DS    0H                                                  0629
         CHECK RPL=(7)
*    IF RPLRTNCD ^=0 & (RPLRTNCD^=CR4HEX8 |  /*ERROR BUT NO REC FOUND*/
*                      RPLERRCD^='5C'X)                            0630
*      THEN DO;                                                    0630
         CLI   RPLRTNCD(CR4RPLAD),0                                0630
         BE    @RF00630                                            0630
         CLI   RPLRTNCD(CR4RPLAD),8                                0630
         BNE   @RT00630                                            0630
         CLI   RPLERRCD(CR4RPLAD),92                               0630
         BE    @RF00630                                            0630
@RT00630 DS    0H                                                  0631
*        CR4ERCOD=FOUR;                 /*INDICATE I/O ERROR*/     0632
         MVC   CR4ERCOD(2,CR4R13),@CH00117                         0632
*        CALL CR4ERROR;                 /*CALL ERROR ROUTINE*/     0633
         BAL   @14,CR4ERROR                                        0633
*      END;                                                        0634
*   END;                                                           0635
@RF00630 DS    0H                                                  0636
*END;                                                              0636
@RC00607 DS    0H                                                  0637
*RFY(ISTRDT,ISTRPRE) BASED(CR4HEDAD);                              0637
@RF00581 DS    0H                                                  0637
@RC00478 DS    0H                                                  0638
*IF ACBAMBL->AMBLDTA->AMBINBUF=OFF      /*SHARE OPTION 4 SPECIFIED?*/
*   THEN DO;                            /*NO ?*/                   0638
         L     @10,RPLDACB(,CR4RPLAD)                              0638
         L     @10,ACBAMBL(,@10)                                   0638
         L     @10,AMBLDTA(,@10)                                   0638
         TM    AMBINBUF(@10),B'00000001'                           0638
         BNZ   @RF00638                                            0638
*CR4R15=0;                                /*ZERO R-15*/            0640
         SLR   CR4R15,CR4R15                                       0640
*RFY (CR4R03,CR4R09) RSTD;                                         0641
*CR4R03=ADDR(CR4ACB);                                              0642
         L     @10,RDTVSRPL(,CR4HEDAD)                             0642
         LA    CR4R03,CR4ACB(,@10)                                 0642
*CR4R09=ADDR(CR4CLS);                                              0643
         LA    CR4R09,CR4CLS(,@10)                                 0643
*GEN(CLOSE     ((3)),TYPE=T,MF=(E,(9)));   /*ISS TCLOSE*/          0644
         CLOSE     ((3)),TYPE=T,MF=(E,(9))
*RFY (CR4R03,CR4R09) UNRSTD;                                       0645
*END;                                   /*SHARE OPTION 4-TCLOSE*/  0646
*CR4R14 = CR4R14S1;                     /*RESTORE REG-14*/         0647
@RF00638 L     CR4R14,CR4R14S1(,CR4R13)                            0647
*END CR4UPERS;                                                     0648
@EL00003 DS    0H                                                  0648
@EF00003 DS    0H                                                  0648
@ER00003 BR    @14                                                 0648
         EJECT
*CR4CLOSE:PROC OPTIONS(NOSAVE,NOSAVEAREA);                         0649
CR4CLOSE DS    0H                                                  0650
*/*------------------------------------------                      0650
*   CLOSE DATASET                                                  0650
*--------------------------------------------*/                    0650
*CR4R14S1=CR4R14;                        /*SAVE REG-14*/           0650
         ST    CR4R14,CR4R14S1(,CR4R13)                            0650
*RFY(ISTRDT,ISTRPRE) BASED(CR4HEDAD);                              0651
*CR4CKPT=OFF;                            /*INDICATE TURN OFF FLAGS*/
         L     @10,RPLAREA(,CR4RPLAD)                              0652
         NI    CR4CKPT(@10),B'11110111'                            0652
*CALL CR4FLAGS;                          /*TURN OFF CKPT FLAGS*/   0653
         BAL   @14,CR4FLAGS                                        0653
*CR4R15=0;                                /*ZERO R-15*/            0654
         SLR   CR4R15,CR4R15                                       0654
*RFY(ISTRDT,ISTRPRE) BASED(CR4HEDAD);                              0655
*RFY (CR4R03,CR4R09) RSTD;                                         0656
*CR4R03=ADDR(CR4ACB);                                              0657
         L     @10,RDTVSRPL(,CR4HEDAD)                             0657
         LA    CR4R03,CR4ACB(,@10)                                 0657
*CR4R09=ADDR(CR4CLS);                                              0658
         LA    CR4R09,CR4CLS(,@10)                                 0658
*GEN(CLOSE     ((3)),MF=(E,(9)));   /*ISS TCLOSE*/                 0659
         CLOSE     ((3)),MF=(E,(9))
*RFY (CR4R03,CR4R09) UNRSTD;                                       0660
*IF CR4R15 >  0                          /*CLOSE ERROR?*/          0661
*  THEN DO;                                                        0661
         LTR   CR4R15,CR4R15                                       0661
         BNP   @RF00661                                            0661
*   CR4ERCOD = ONE;                      /*INDICATE CLOSE ERROR*/  0663
         MVC   CR4ERCOD(2,CR4R13),@CH00127                         0663
*   CALL CR4ERROR;                       /*CALL ERROR ROUITNE*/    0664
         BAL   @14,CR4ERROR                                        0664
*  END;                                                            0665
*RDTVSRPL = 0;                          /* 0 RPL PTR IN RDT  @ZA10991*/
@RF00661 SLR   @10,@10                                             0666
         ST    @10,RDTVSRPL(,CR4HEDAD)                             0666
*STM(GPR14P,GPR00P,CR4R140);            /*SAVE REG 14->0*/         0667
         STM   GPR14P,GPR00P,CR4R140(CR4R13)                       0667
*STM(GPR02P,GPR10P,CR4R210);            /*SAVE REG 2->10*/         0668
         STM   GPR02P,GPR10P,CR4R210(CR4R13)                       0668
* /*FREESTOR AREA(CR4RPLAD)SIZE(LENGTH(CR4GTSTR))SAVE(NO)*/        0669
*  DO;                                                             0669
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTATCVT,ISTRPH)  */                  0670
*/* END OF ATBUILD */                                              0670
* RFY (GPR00P,GPR01P,GPR02P,GPR03P) RSTD;                          0670
* GPR00F = LENGTH(CR4GTSTR);                           /*SIZE IN REG0*/
         LA    GPR00F,185                                          0671
* DCL 1 CMZA0033 FIXED(31) STATIC LOCAL,                           0672
*       2 * FIXED(8) INIT(0),                        /* OPTION FLAGS */
*       2 * FIXED(8) INIT(96),                        /* STORAGE KEY */
*       2 * FIXED(8) INIT(231),                    /* SUBPOOL NUMBER */
*       2 * FIXED(8) INIT('01'X);                    /* REQUEST TYPE */
* GPR03F = CMZA0033;                                               0673
         L     GPR03F,CMZA0033                                     0673
* RFY (GPR04P) RSTD;                                               0674
* GPR04P = CR4RPLAD;                      /*PUT FREEMAIN ADDR IN REG4*/
*                                                                  0675
         LR    GPR04P,CR4RPLAD                                     0675
* DO; /* LISATCVT CVTBASE(PAGEABLE,(GPR02P)) */                    0676
*   GPR02P = ATCLCPTR; /*SET UP ATCVT POINTER*/                    0677
         L     GPR02P,ATCLCPTR                                     0677
* END; /*LISATCVT*/                                                0678
* CALL GPR02P -> ATCGTSTR;                            /*CALL ISTORFSR*/
         L     @15,ATCGTSTR(,GPR02P)                               0679
         BALR  @14,@15                                             0679
* RFY (GPR00P,GPR01P,GPR02P,GPR03P,GPR04P) UNRSTD;                 0680
* END ;                                             /*END OF FREESTOR*/
* LM(GPR14P,GPR00P,CR4R140);            /*REST REG 14->0*/         0682
         LM    GPR14P,GPR00P,CR4R140(CR4R13)                       0682
* LM(GPR02P,GPR10P,CR4R210);            /*REST REG 2->10*/         0683
         LM    GPR02P,GPR10P,CR4R210(CR4R13)                       0683
*CR4R14 = CR4R14S1;                      /*RESTORE REG-14*/        0684
         L     CR4R14,CR4R14S1(,CR4R13)                            0684
*END CR4CLOSE;                                                     0685
@EL00004 DS    0H                                                  0685
@EF00004 DS    0H                                                  0685
@ER00004 BR    @14                                                 0685
         EJECT
*CR4ERROR:PROC OPTIONS(NOSAVE,NOSAVEAREA);                         0686
CR4ERROR DS    0H                                                  0687
*/*------------------------------------------                      0687
* FUNCTION IS TO PROCESS ERRORS DETECTED IN ISTINCR4               0687
*     ERROR CODES ARE                                              0687
*        -ERROR CODE-               -ERROR-                        0687
*           1                       CLOSE                          0687
*           2                       LOGICAL(BITMASK,DAF,RDTE TYPE) 0687
*           3                       OPEN                           0687
*           4                       I/O                            0687
*           5                       GETSTOR                        0687
*-------------------------------------------*/                     0687
*RFY(ISTRDT,ISTRPRE) BASED(CR4HEDAD);                              0687
*CR4MSGCH(1:8)=RDTCRSDS;               /*CKPT DS NAME INTO MSG*/   0688
         MVC   CR4MSGCH(8,CR4R13),RDTCRSDS(CR4HEDAD)               0688
*CR4MSGCH(9:16)=RPRNAME;               /*MAJ NODE NAME INTO MSG*/  0689
         MVC   CR4MSGCH+8(8,CR4R13),RPRNAME(CR4HEDAD)              0689
*IF CR4ERCOD=1 | CR4ERCOD=3            /* OPEN OR CLOSE*/          0690
*   THEN DO;                                                       0690
         LH    @10,CR4ERCOD(,CR4R13)                               0690
         C     @10,@CF00127                                        0690
         BE    @RT00690                                            0690
         C     @10,@CF00215                                        0690
         BNE   @RF00690                                            0690
@RT00690 DS    0H                                                  0691
*   RPLRTNCD=CR4R15;                                               0692
         STC   CR4R15,RPLRTNCD(,CR4RPLAD)                          0692
*   RPLERRCD=ACBERFLG;                                             0693
         L     @10,RPLDACB(,CR4RPLAD)                              0693
         MVC   RPLERRCD(1,CR4RPLAD),ACBERFLG(@10)                  0693
*   END;                                                           0694
*IF CR4ERCOD^=TWO & CR4ERCOD^=FIVE     /* NOT GETSTOR OR     @ZA10991*/
*  THEN                                /* LOGICAL ERROR      @ZA10991*/
@RF00690 LH    @10,CR4ERCOD(,CR4R13)                               0695
         C     @10,@CF00197                                        0695
         BE    @RF00695                                            0695
         C     @10,@CF00203                                        0695
         BE    @RF00695                                            0695
*    DO;                                                   /*@ZA10991*/
*  MVC (CR4MSGCH(17),CR4RCB(1:4));                                 0697
         MVC   CR4MSGCH+16(1,CR4R13),CR4RCB(CR4RPLAD)              0697
*  SRL (CR4MSGCH(17),4);                                           0698
         SLR   @10,@10                                             0698
         IC    @10,CR4MSGCH+16(,CR4R13)                            0698
         SRL   @10,4                                               0698
         STC   @10,CR4MSGCH+16(,CR4R13)                            0698
*  TR (CR4MSGCH(17),CR4TBL);            /*VSAM R.C. INTO MSG,BYTE-1*/
         TR    CR4MSGCH+16(1,CR4R13),CR4TBL                        0699
*  MVC (CR4MSGCH(18),CR4RCB(5:8));                                 0700
         MVC   CR4MSGCH+17(1,CR4R13),CR4RCB(CR4RPLAD)              0700
*  SLL (CR4MSGCH(18),4);                                           0701
         SLR   @10,@10                                             0701
         IC    @10,CR4MSGCH+17(,CR4R13)                            0701
         SLL   @10,4                                               0701
         STC   @10,CR4MSGCH+17(,CR4R13)                            0701
*  SRL (CR4MSGCH(18),4);                                           0702
         SLR   @10,@10                                             0702
         IC    @10,CR4MSGCH+17(,CR4R13)                            0702
         SRL   @10,4                                               0702
         STC   @10,CR4MSGCH+17(,CR4R13)                            0702
*  TR (CR4MSGCH(18),CR4TBL);            /*VSAM R.C. INTO MSG,BYTE-2*/
         TR    CR4MSGCH+17(1,CR4R13),CR4TBL                        0703
*  MVC (CR4MSGCH(19),CR4ERB(1:4));                                 0704
         MVC   CR4MSGCH+18(1,CR4R13),CR4ERB(CR4RPLAD)              0704
*  SRL (CR4MSGCH(19),4);                                           0705
         SLR   @10,@10                                             0705
         IC    @10,CR4MSGCH+18(,CR4R13)                            0705
         SRL   @10,4                                               0705
         STC   @10,CR4MSGCH+18(,CR4R13)                            0705
*  TR (CR4MSGCH(19),CR4TBL);            /*VSAM E.C. INTO MSG,BYTE-1*/
         TR    CR4MSGCH+18(1,CR4R13),CR4TBL                        0706
*  MVC (CR4MSGCH(20),CR4ERB(5:8));                                 0707
         MVC   CR4MSGCH+19(1,CR4R13),CR4ERB(CR4RPLAD)              0707
*  SLL (CR4MSGCH(20),4);                                           0708
         SLR   @10,@10                                             0708
         IC    @10,CR4MSGCH+19(,CR4R13)                            0708
         SLL   @10,4                                               0708
         STC   @10,CR4MSGCH+19(,CR4R13)                            0708
*  SRL (CR4MSGCH(20),4);                                           0709
         SLR   @10,@10                                             0709
         IC    @10,CR4MSGCH+19(,CR4R13)                            0709
         SRL   @10,4                                               0709
         STC   @10,CR4MSGCH+19(,CR4R13)                            0709
*  TR (CR4MSGCH(20),CR4TBL);            /*VSAM E.C. INTO MSG,BYTE-2*/
         TR    CR4MSGCH+19(1,CR4R13),CR4TBL                        0710
*    END;                               /*END-NOT GS OR LOG  @ZA10991*/
*IF CR4ERCOD=ONE                                                   0712
*  THEN CR4MSGID=CR4181I;               /*CLOSE MSGID*/            0712
@RF00695 CLC   CR4ERCOD(2,CR4R13),@CH00127                         0712
         BNE   @RF00712                                            0712
         MVC   CR4MSGID(4,CR4R13),@CC00484                         0713
*  ELSE IF CR4ERCOD=TWO                                            0714
*        THEN CR4MSGID=CR4185I;         /*LOGICAL MSGID*/          0714
         B     @RC00712                                            0714
@RF00712 CLC   CR4ERCOD(2,CR4R13),@CH00197                         0714
         BNE   @RF00714                                            0714
         MVC   CR4MSGID(4,CR4R13),@CC00490                         0715
*        ELSE IF CR4ERCOD=THREE                                    0716
*              THEN CR4MSGID=CR4180I;   /*OPEN MSGID*/             0716
         B     @RC00714                                            0716
@RF00714 CLC   CR4ERCOD(2,CR4R13),@CH00215                         0716
         BNE   @RF00716                                            0716
         MVC   CR4MSGID(4,CR4R13),@CC00482                         0717
*              ELSE IF CR4ERCOD=FOUR                               0718
*                   THEN CR4MSGID=CR4184I;/*I/O MSGID*/            0718
         B     @RC00716                                            0718
@RF00716 CLC   CR4ERCOD(2,CR4R13),@CH00117                         0718
         BNE   @RF00718                                            0718
         MVC   CR4MSGID(4,CR4R13),@CC00488                         0719
*                   ELSE CR4MSGID=CR4182I;/*GETSTOR*/              0720
         B     @RC00718                                            0720
@RF00718 MVC   CR4MSGID(4,CR4R13),@CC00486                         0720
*            /*ISSUE TPMSG*/                                       0721
*       RFY (CR4MSGNO,CR4MSGTX) RSTD;                              0721
@RC00718 DS    0H                                                  0721
@RC00716 DS    0H                                                  0721
@RC00714 DS    0H                                                  0721
@RC00712 DS    0H                                                  0722
*       CR4MSGNO=ADDR(CR4MSGID);                                   0722
         LA    CR4MSGNO,CR4MSGID(,CR4R13)                          0722
*       CR4MSGTX=ADDR(CR4MSGCH);                                   0723
*                                                                  0723
         LA    CR4MSGTX,CR4MSGCH(,CR4R13)                          0723
*/*TPMSG MSGID((CR4MSGNO))MSG((CR4MSGTX))OPTIONS(NCSPLSID)PLAREA(CR4MSG
*R)*/                                                              0724
*                                                                  0724
*        DO;                                                       0724
*          DCL REG1052  REG(1)  PTR;                               0725
*          RFY (REG1052) RSTD;                                     0726
*                                                                  0726
*        RFY (EMCR13) RSTD;                                        0727
*          DCL 1 * BASED(REG1052),                                 0728
*              2 CMZID052 PTR(31),                                 0728
*              2 *,                                                0728
*                3 CMZRL052 PTR(8),                                0728
*                3 CMZRA052 PTR(24) BDY(BYTE),                     0728
*              2 CMZEA052 PTR(31),                                 0728
*              2 CMZVP052 PTR(31);                                 0728
*                                                                  0728
*/*XREGSET  PID('PLAREA')PPARM(CR4MSGAR)RREG(,REG1052)*/           0729
*        DO;                                                       0729
*          REG1052=ADDR(CR4MSGAR);       /*SET RREG SYMBOL TO ADDRESS*/
         LA    REG1052,CR4MSGAR(,CR4R13)                           0730
*                                        /*OF PPARM OPERAND          */
*        END;  /* XREGSET */                                       0731
*          CMZID052 = 0;                                           0732
         SLR   @06,@06                                             0732
         ST    @06,CMZID052(,REG1052)                              0732
*          CMZRL052 = 0;                                           0733
         MVI   CMZRL052(REG1052),X'00'                             0733
*          CMZRA052 = 0;                                           0734
         STCM  @06,7,CMZRA052(REG1052)                             0734
*          CMZEA052 = 0;                                           0735
         ST    @06,CMZEA052(,REG1052)                              0735
*          CMZVP052 = 0;                                           0736
         ST    @06,CMZVP052(,REG1052)                              0736
*          CMZID052=CR4MSGNO;                                      0737
         ST    CR4MSGNO,CMZID052(,REG1052)                         0737
*          CMZVP052 = CR4MSGTX;                                    0738
         ST    CR4MSGTX,CMZVP052(,REG1052)                         0738
*          DCL CMZSA052 (18) PTR(31) BASED(EMCR13);                0739
*          CMZSA052(5) = ADDR(NCSPLSID);                           0740
*                                                                  0740
         LA    @06,NCSPLSID(,CR4NCSAD)                             0740
         ST    @06,CMZSA052+16(,EMCR13)                            0740
*          DCL REG15052 REG(15) PTR;                               0741
*          RFY REG15052 RSTD;                                      0742
*                                                                  0742
*        DO; /* LISATCVT CVTBASE(PAGEABLE,(REG15052)) */           0743
*          REG15052 = ATCLCPTR; /*SET UP ATCVT POINTER*/           0744
         L     REG15052,ATCLCPTR                                   0744
*        END; /*LISATCVT*/                                         0745
*          DCL CMTA052 BASED(REG15052) ENTRY VALUERANGE(*);        0746
*          REG15052 = REG15052->ATCMSGP;                           0747
         L     REG15052,ATCMSGP(,REG15052)                         0747
*          CALL CMTA052;                                           0748
         BALR  @14,@15                                             0748
*          RESPECIFY (REG1052,REG15052)  UNRESTRICTED;             0749
*                                                                  0749
*        RFY (EMCR13) UNRSTD;                                      0750
*        END;                                                      0751
*       RFY (CR4MSGNO,CR4MSGTX) UNRSTD;                            0752
*IF (CR4ERCOD^=ONE&CR4ERCOD^=FIVE)                                 0753
*  THEN DO;                                                        0753
         LH    @10,CR4ERCOD(,CR4R13)                               0753
         C     @10,@CF00127                                        0753
         BE    @RF00753                                            0753
         C     @10,@CF00203                                        0753
         BE    @RF00753                                            0753
*       CR4R15=0;                                                  0755
         SLR   CR4R15,CR4R15                                       0755
*RFY (CR4R03,CR4R09) RSTD;                                         0756
*CR4R03=ADDR(CR4ACB);                                              0757
         L     @10,RDTVSRPL(,CR4HEDAD)                             0757
         LA    CR4R03,CR4ACB(,@10)                                 0757
*CR4R09=ADDR(CR4CLS);                                              0758
         LA    CR4R09,CR4CLS(,@10)                                 0758
*     GEN(   CLOSE     ((3)),MF=(E,(9)));   /*CLOSE DATASET*/      0759
            CLOSE     ((3)),MF=(E,(9))
*RFY (CR4R03,CR4R09) UNRSTD;                                       0760
*    IF ((CR4R15>0   ) & (CR4ERCOD^=3))      /*CLOSE ERROR?*/      0761
*       THEN DO;                                                   0761
         SLR   @10,@10                                             0761
         CR    CR4R15,@10                                          0761
         BNH   @RF00761                                            0761
         CLC   CR4ERCOD(2,CR4R13),@CH00215                         0761
         BE    @RF00761                                            0761
*   RPLRTNCD=CR4R15;                                               0763
         STC   CR4R15,RPLRTNCD(,CR4RPLAD)                          0763
*   RPLERRCD=ACBERFLG;                                             0764
         L     @09,RPLDACB(,CR4RPLAD)                              0764
         MVC   RPLERRCD(1,CR4RPLAD),ACBERFLG(@09)                  0764
*  MVC (CR4MSGCH(17),CR4RCB(1:4));                                 0765
         MVC   CR4MSGCH+16(1,CR4R13),CR4RCB(CR4RPLAD)              0765
*  SRL (CR4MSGCH(17),4);                                           0766
         SLR   @09,@09                                             0766
         IC    @09,CR4MSGCH+16(,CR4R13)                            0766
         SRL   @09,4                                               0766
         STC   @09,CR4MSGCH+16(,CR4R13)                            0766
*  TR (CR4MSGCH(17),CR4TBL);            /*VSAM R.C. INTO MSG,BYTE-1*/
         TR    CR4MSGCH+16(1,CR4R13),CR4TBL                        0767
*  MVC (CR4MSGCH(18),CR4RCB(5:8));                                 0768
         MVC   CR4MSGCH+17(1,CR4R13),CR4RCB(CR4RPLAD)              0768
*  SLL (CR4MSGCH(18),4);                                           0769
         SLR   @09,@09                                             0769
         IC    @09,CR4MSGCH+17(,CR4R13)                            0769
         SLL   @09,4                                               0769
         STC   @09,CR4MSGCH+17(,CR4R13)                            0769
*  SRL (CR4MSGCH(18),4);                                           0770
         SLR   @09,@09                                             0770
         IC    @09,CR4MSGCH+17(,CR4R13)                            0770
         SRL   @09,4                                               0770
         STC   @09,CR4MSGCH+17(,CR4R13)                            0770
*  TR (CR4MSGCH(18),CR4TBL);            /*VSAM R.C. INTO MSG,BYTE-2*/
         TR    CR4MSGCH+17(1,CR4R13),CR4TBL                        0771
*  MVC (CR4MSGCH(19),CR4ERB(1:4));                                 0772
         MVC   CR4MSGCH+18(1,CR4R13),CR4ERB(CR4RPLAD)              0772
*  SRL (CR4MSGCH(19),4);                                           0773
         SLR   @09,@09                                             0773
         IC    @09,CR4MSGCH+18(,CR4R13)                            0773
         SRL   @09,4                                               0773
         STC   @09,CR4MSGCH+18(,CR4R13)                            0773
*  TR (CR4MSGCH(19),CR4TBL);            /*VSAM E.C. INTO MSG,BYTE-1*/
         TR    CR4MSGCH+18(1,CR4R13),CR4TBL                        0774
*  MVC (CR4MSGCH(20),CR4ERB(5:8));                                 0775
         MVC   CR4MSGCH+19(1,CR4R13),CR4ERB(CR4RPLAD)              0775
*  SLL (CR4MSGCH(20),4);                                           0776
         SLR   @09,@09                                             0776
         IC    @09,CR4MSGCH+19(,CR4R13)                            0776
         SLL   @09,4                                               0776
         STC   @09,CR4MSGCH+19(,CR4R13)                            0776
*  SRL (CR4MSGCH(20),4);                                           0777
         SLR   @09,@09                                             0777
         IC    @09,CR4MSGCH+19(,CR4R13)                            0777
         SRL   @09,4                                               0777
         STC   @09,CR4MSGCH+19(,CR4R13)                            0777
*  TR (CR4MSGCH(20),CR4TBL);            /*VSAM E.C. INTO MSG,BYTE-2*/
         TR    CR4MSGCH+19(1,CR4R13),CR4TBL                        0778
*        CR4MSGID=CR4181I;                 /*CLOSE MSGID*/         0779
         MVC   CR4MSGID(4,CR4R13),@CC00484                         0779
*            /*ISSUE TPMSG*/                                       0780
*       CR4MSGCH(1:8)=RDTCRSDS;        /*CKPT DS NAME INTO MSG*/   0780
         MVC   CR4MSGCH(8,CR4R13),RDTCRSDS(CR4HEDAD)               0780
*       CR4MSGCH(9:16)=RPRNAME;        /*MAJ NODE NAME INTO MSG*/  0781
         MVC   CR4MSGCH+8(8,CR4R13),RPRNAME(CR4HEDAD)              0781
*       RFY (CR4MSGNO,CR4MSGTX) RSTD;                              0782
*       CR4MSGNO=ADDR(CR4MSGID);                                   0783
         LA    CR4MSGNO,CR4MSGID(,CR4R13)                          0783
*       CR4MSGTX=ADDR(CR4MSGCH);                                   0784
*                                                                  0784
         LA    CR4MSGTX,CR4MSGCH(,CR4R13)                          0784
*/*TPMSG MSGID((CR4MSGNO))MSG((CR4MSGTX))OPTIONS(NCSPLSID)PLAREA(CR4MSG
*R)*/                                                              0785
*                                                                  0785
*        DO;                                                       0785
*          DCL REG1061  REG(1)  PTR;                               0786
*          RFY (REG1061) RSTD;                                     0787
*                                                                  0787
*        RFY (EMCR13) RSTD;                                        0788
*          DCL 1 * BASED(REG1061),                                 0789
*              2 CMZID061 PTR(31),                                 0789
*              2 *,                                                0789
*                3 CMZRL061 PTR(8),                                0789
*                3 CMZRA061 PTR(24) BDY(BYTE),                     0789
*              2 CMZEA061 PTR(31),                                 0789
*              2 CMZVP061 PTR(31);                                 0789
*                                                                  0789
*/*XREGSET  PID('PLAREA')PPARM(CR4MSGAR)RREG(,REG1061)*/           0790
*        DO;                                                       0790
*          REG1061=ADDR(CR4MSGAR);       /*SET RREG SYMBOL TO ADDRESS*/
         LA    REG1061,CR4MSGAR(,CR4R13)                           0791
*                                        /*OF PPARM OPERAND          */
*        END;  /* XREGSET */                                       0792
*          CMZID061 = 0;                                           0793
         SLR   @06,@06                                             0793
         ST    @06,CMZID061(,REG1061)                              0793
*          CMZRL061 = 0;                                           0794
         MVI   CMZRL061(REG1061),X'00'                             0794
*          CMZRA061 = 0;                                           0795
         STCM  @06,7,CMZRA061(REG1061)                             0795
*          CMZEA061 = 0;                                           0796
         ST    @06,CMZEA061(,REG1061)                              0796
*          CMZVP061 = 0;                                           0797
         ST    @06,CMZVP061(,REG1061)                              0797
*          CMZID061=CR4MSGNO;                                      0798
         ST    CR4MSGNO,CMZID061(,REG1061)                         0798
*          CMZVP061 = CR4MSGTX;                                    0799
         ST    CR4MSGTX,CMZVP061(,REG1061)                         0799
*          DCL CMZSA061 (18) PTR(31) BASED(EMCR13);                0800
*          CMZSA061(5) = ADDR(NCSPLSID);                           0801
*                                                                  0801
         LA    @06,NCSPLSID(,CR4NCSAD)                             0801
         ST    @06,CMZSA061+16(,EMCR13)                            0801
*          DCL REG15061 REG(15) PTR;                               0802
*          RFY REG15061 RSTD;                                      0803
*                                                                  0803
*        DO; /* LISATCVT CVTBASE(PAGEABLE,(REG15061)) */           0804
*          REG15061 = ATCLCPTR; /*SET UP ATCVT POINTER*/           0805
         L     REG15061,ATCLCPTR                                   0805
*        END; /*LISATCVT*/                                         0806
*          DCL CMTA061 BASED(REG15061) ENTRY VALUERANGE(*);        0807
*          REG15061 = REG15061->ATCMSGP;                           0808
         L     REG15061,ATCMSGP(,REG15061)                         0808
*          CALL CMTA061;                                           0809
         BALR  @14,@15                                             0809
*          RESPECIFY (REG1061,REG15061)  UNRESTRICTED;             0810
*                                                                  0810
*        RFY (EMCR13) UNRSTD;                                      0811
*        END;                                                      0812
*       RFY (CR4MSGNO,CR4MSGTX) UNRSTD;                            0813
*       END;                                                       0814
*  END;                                                            0815
@RF00761 DS    0H                                                  0816
*IF CR4ERCOD^=5                                                    0816
*  THEN DO;                                                        0816
@RF00753 CLC   CR4ERCOD(2,CR4R13),@CH00203                         0816
         BE    @RF00816                                            0816
*    CR4CKPT=OFF;                       /*INDICATE FLG OFF   @ZA10991*/
         L     @10,RPLAREA(,CR4RPLAD)                              0818
         NI    CR4CKPT(@10),B'11110111'                            0818
*    CALL CR4FLAGS;                     /*TURN OFF CKPT FLF  @ZA10991*/
         BAL   @14,CR4FLAGS                                        0819
*    RDTVSRPL=0;                        /*0 RPL PTR IN RDT   @ZA10991*/
         SLR   @10,@10                                             0820
         ST    @10,RDTVSRPL(,CR4HEDAD)                             0820
*STM(GPR14P,GPR00P,CR4R140);            /*SAVE REG 14->0*/         0821
         STM   GPR14P,GPR00P,CR4R140(CR4R13)                       0821
*STM(GPR02P,GPR10P,CR4R210);            /*SAVE REG 2->10*/         0822
         STM   GPR02P,GPR10P,CR4R210(CR4R13)                       0822
* /*FREESTOR AREA(CR4RPLAD)SIZE(LENGTH(CR4GTSTR))SAVE(NO)*/        0823
*  DO;                                                             0823
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTATCVT,ISTRPH)  */                  0824
*/* END OF ATBUILD */                                              0824
* RFY (GPR00P,GPR01P,GPR02P,GPR03P) RSTD;                          0824
* GPR00F = LENGTH(CR4GTSTR);                           /*SIZE IN REG0*/
         LA    GPR00F,185                                          0825
* DCL 1 CMZA0070 FIXED(31) STATIC LOCAL,                           0826
*       2 * FIXED(8) INIT(0),                        /* OPTION FLAGS */
*       2 * FIXED(8) INIT(96),                        /* STORAGE KEY */
*       2 * FIXED(8) INIT(231),                    /* SUBPOOL NUMBER */
*       2 * FIXED(8) INIT('01'X);                    /* REQUEST TYPE */
* GPR03F = CMZA0070;                                               0827
         L     GPR03F,CMZA0070                                     0827
* RFY (GPR04P) RSTD;                                               0828
* GPR04P = CR4RPLAD;                      /*PUT FREEMAIN ADDR IN REG4*/
*                                                                  0829
         LR    GPR04P,CR4RPLAD                                     0829
* DO; /* LISATCVT CVTBASE(PAGEABLE,(GPR02P)) */                    0830
*   GPR02P = ATCLCPTR; /*SET UP ATCVT POINTER*/                    0831
         L     GPR02P,ATCLCPTR                                     0831
* END; /*LISATCVT*/                                                0832
* CALL GPR02P -> ATCGTSTR;                            /*CALL ISTORFSR*/
         L     @15,ATCGTSTR(,GPR02P)                               0833
         BALR  @14,@15                                             0833
* RFY (GPR00P,GPR01P,GPR02P,GPR03P,GPR04P) UNRSTD;                 0834
* END ;                                             /*END OF FREESTOR*/
* LM(GPR14P,GPR00P,CR4R140);            /*REST REG 14->0*/         0836
         LM    GPR14P,GPR00P,CR4R140(CR4R13)                       0836
* LM(GPR02P,GPR10P,CR4R210);            /*REST REG 2->10*/         0837
         LM    GPR02P,GPR10P,CR4R210(CR4R13)                       0837
*  END;                                                            0838
*  IF NCSCRCMD=NCSCROPN&NCSPLWRM=OFF                               0839
*    THEN NCSIORC=NCSCRION;                                        0839
@RF00816 CLI   NCSCRCMD(CR4NCSAD),1                                0839
         BNE   @RF00839                                            0839
         TM    NCSPLWRM(CR4NCSAD),B'10000000'                      0839
         BNZ   @RF00839                                            0839
         MVI   NCSIORC(CR4NCSAD),X'34'                             0840
*      ELSE                                                        0841
*  NCSIORC=NCSCRIOF;                    /*SET RET CDE IN NCSPL*/   0841
*                                                                  0841
         B     @RC00839                                            0841
@RF00839 MVI   NCSIORC(CR4NCSAD),X'38'                             0841
*/*  LEAVE(MAIN)  */                                               0842
* GOTO #BCM0005;                                                   0842
*                                                                  0842
         B     #BCM0005                                            0842
*END CR4ERROR;                                                     0843
         EJECT
* CR4PATH:PROC OPTIONS(NOSAVE,NOSAVEAREA);                         0844
CR4PATH  DS    0H                                                  0845
*  /*-----------------------------------------                     0845
*     FIND THE CORRECT PATH TABLE ENTRY                            0845
*   ------------------------------------------*/                   0845
* RFY CR4PATAD RSTD;                                               0845
* RFY(ISTPAT) BASED(CR4PATAD);                                     0846
* RFY(ISTRCC) BASED(CR4RDTAD);                                     0847
* CR4R14S2=CR4R14;                      /*SAVE REG-14*/            0848
         ST    CR4R14,CR4R14S2(,CR4R13)                            0848
* IF (RCCPATHT=0)| CR4HEDAD->RPRHDTYP^=RPRENTSW&/*PTR TO PATH TBL =0*/
*           CR4HEDAD->RPRHDTYP^=RPRENTLS/*OR NOT SWITCHED SUBAREA*/
*     THEN DO;                                                     0849
         L     @09,RCCPATHT(,CR4RDTAD)                             0849
         LTR   @09,@09                                             0849
         BZ    @RT00849                                            0849
         CLI   RPRHDTYP(CR4HEDAD),X'04'                            0849
         BE    @RF00849                                            0849
         CLI   RPRHDTYP(CR4HEDAD),X'05'                            0849
         BE    @RF00849                                            0849
@RT00849 DS    0H                                                  0850
*      CR4ERCOD=2;                      /*INDICATE LOGICAL ERROR*/ 0851
         MVC   CR4ERCOD(2,CR4R13),@CH00197                         0851
*      CALL CR4ERROR;                   /*CALL ERROR ROUTINE*/     0852
         BAL   @14,CR4ERROR                                        0852
*      END;                                                        0853
*CR4PATNO = 1;                           /*SET PATH TBL NO*/       0854
@RF00849 MVC   CR4PATNO(2,CR4R13),@CH00127                         0854
*DO WHILE ((CR4PID-1) ^= (PATPTHID));    /*LOOP UNTIL DAFS MATCH*/ 0855
         B     @DE00855                                            0855
@DL00855 DS    0H                                                  0856
*   IF CR4PATNO>=RCCPATHZ                 /*END OF TABLE & NO MATCH*/
*     THEN DO;                                                     0856
         LH    @09,CR4PATNO(,CR4R13)                               0856
         CH    @09,RCCPATHZ(,CR4RDTAD)                             0856
         BL    @RF00856                                            0856
*        CR4ERCOD=2;                     /*INDICATE LOGICAL ERROR*/
         MVC   CR4ERCOD(2,CR4R13),@CH00197                         0858
*        CALL CR4ERROR;                  /*CALL ERROR ROUTINE*/    0859
         BAL   @14,CR4ERROR                                        0859
*     END;                                                         0860
*   CR4PATNO=CR4PATNO+1;                 /*ADD 1 TO PATH TBL NO.*/ 0861
@RF00856 LA    @09,1                                               0861
         AH    @09,CR4PATNO(,CR4R13)                               0861
         STH   @09,CR4PATNO(,CR4R13)                               0861
*   CR4PATAD=CR4PATAD+LENGTH(ISTPAT);    /*PT TO NEXT TABLE*/      0862
         AL    CR4PATAD,@CF00119                                   0862
*END;                                                              0863
@DE00855 L     @09,RPLAREA(,CR4RPLAD)                              0863
         LH    @09,CR4PID(,@09)                                    0863
         N     @09,@CF02743                                        0863
         BCTR  @09,0                                               0863
         SLR   @06,@06                                             0863
         IC    @06,PATPTHID(,CR4PATAD)                             0863
         CR    @09,@06                                             0863
         BNE   @DL00855                                            0863
*CR4R14=CR4R14S2;                        /*RESTORE REG-14*/        0864
         L     CR4R14,CR4R14S2(,CR4R13)                            0864
*END CR4PATH;                                                      0865
@EL00006 DS    0H                                                  0865
@EF00006 DS    0H                                                  0865
@ER00006 BR    @14                                                 0865
         EJECT
*CR4FLAGS:PROC OPTIONS(NOSAVE,NOSAVEAREA);                         0866
CR4FLAGS DS    0H                                                  0867
*/*----------------------------------------                        0867
*   TURN ON OR OFF CKPT FLAGS DEPENDING ON CR4CKPT                 0867
*---------------------------------------------*/                   0867
*RFY CR4RDTAD RSTD;                                                0867
* CR4RDTAD=CR4HEDAD;                             /*GET HDR PTR*/   0868
         LR    CR4RDTAD,CR4HEDAD                                   0868
*  RFY (ISTRDT,ISTRPRE) BASED(CR4RDTAD);                           0869
* DO WHILE RPRENTED=OFF;                         /*LOOP UNTIL END RDT*/
         B     @DE00870                                            0870
@DL00870 DS    0H                                                  0871
*  IF CR4CKPT=ON THEN RPRCRCPT=ON;               /*TURN ON FLAG*/  0871
         L     @09,RPLAREA(,CR4RPLAD)                              0871
         TM    CR4CKPT(@09),B'00001000'                            0871
         BNO   @RF00871                                            0871
         OI    RPRCRCPT(CR4RDTAD),B'01000000'                      0872
*                ELSE RPRCRCPT=OFF;              /*OR TURN OFF FLAG*/
         B     @RC00871                                            0873
@RF00871 NI    RPRCRCPT(CR4RDTAD),B'10111111'                      0873
*  CR4RDTAD=CR4RDTAD+RPRELEN;                    /*GET NEXT RDTE*/ 0874
@RC00871 AH    CR4RDTAD,RPRELEN(,CR4RDTAD)                         0874
* END;                                                             0875
@DE00870 TM    RPRENTED(CR4RDTAD),B'00000100'                      0875
         BZ    @DL00870                                            0875
*  IF CR4CKPT=ON THEN RPRCRCPT=ON;             /*TURN ON IN LAST RDTE*/
         L     @09,RPLAREA(,CR4RPLAD)                              0876
         TM    CR4CKPT(@09),B'00001000'                            0876
         BNO   @RF00876                                            0876
         OI    RPRCRCPT(CR4RDTAD),B'01000000'                      0877
*                ELSE RPRCRCPT=OFF;           /*TURN OFF IN LAST RDTE*/
         B     @RC00876                                            0878
@RF00876 NI    RPRCRCPT(CR4RDTAD),B'10111111'                      0878
*END CR4FLAGS;                                                     0879
@EL00007 DS    0H                                                  0879
@EF00007 DS    0H                                                  0879
@ER00007 BR    @14                                                 0879
@PB00007 DS    0H                                                  0880
         EJECT
*/* --------------------------------                               0880
*   UNCHAIN SAVEAREAS                                              0880
*-----------------------------------*/                             0880
*                                                                  0880
* END; /* END  */                                                  0880
*#BCM0005:;                                                        0881
#BCM0005 DS    0H                                                  0882
*CR4R13=CR4BCKPT;      /*@XM7958K*/    /*RESTORE CALLER'S SAVEAREA*/
*                                                                  0882
         L     CR4R13,CR4BCKPT(,CR4R13)                            0882
*/*TPPOST  (NCSPLRPH)  NSTR*/                                      0883
*        DO;                                                       0883
*                                       /*DECLARE AND RESTRICT REGS*/
*          RESPECIFY (GPR00F,GPR01F,GPR04F,GPR05F,                 0884
*                    GPR06F,GPR14F,GPR15F) RSTD;                   0884
*                                       /*0,1,4,5,6,14, AND 15   */
*                                                                  0885
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTRPH,ISTAVT,ISTATCVT)  */           0885
*        RFY ISTAVT  ;                                             0885
*/* END OF ATBUILD */                                              0886
*          GPR04F=NCSPLRPH;             /*LOAD RPH PNTR INTO REG 4*/
         L     GPR04F,NCSPLRPH(,CR4NCSAD)                          0886
*          RFY GPR03F RSTD;                                        0887
*          GPR03F=0;                                               0888
*                                                                  0888
         SLR   @09,@09                                             0888
         LR    GPR03F,@09                                          0888
*        DO; /*MODESET  SAVEKEY(GPR06F) KEYADDR(GPR03F) WORKREG(GPR05F)
*/         RESPECIFY (GPR02F) RESTRICTED;                          0889
*          GPR05F = GPR02F; /*SAVE REGISTER 2*/                    0891
         LR    GPR05F,GPR02F                                       0891
*          IPK; /*SAVE CURRENT PSW KEY*/                           0892
         IPK                                                       0892
*          GPR06F = GPR02F;                                        0893
         LR    GPR06F,GPR02F                                       0893
*          GPR02F = GPR05F; /*RESTORE REGISTER 2*/                 0894
         LR    GPR02F,GPR05F                                       0894
*          SPKA (GPR03F); /*SET PSW KEY*/                          0895
         SPKA  0(GPR03F)                                           0895
*          RESPECIFY (GPR02F) UNRESTRICTED;                        0896
*        END; /*MODESET  SAVEKEY(GPR06F) KEYADDR(GPR03F) WORKREG(GPR05F
**/        RFY GPR03F UNRSTD;                                      0897
*          GPR05P=GPR04P->RPHMAJCB+GPR04P->RPHPABOF;               0899
         L     GPR05P,RPHMAJCB-1(,GPR04P)                          0899
         LA    GPR05P,0(,GPR05P)                                   0899
         SLR   @03,@03                                             0899
         IC    @03,RPHPABOF(,GPR04P)                               0899
         ALR   GPR05P,@03                                          0899
*                                       /*LOAD REG 5  WITH ADDR OF*/
*                                       /*MAJOR CONTROL BLOCK PLUS*/
*                                       /*OFFSET OF PAB IN BLOCK  */
*          GPR14P=0;                    /*LOAD 0 INTO REG 14      */
         LR    GPR14P,@09                                          0900
*          GPR15P='FFFFFFFF'X;          /*LOAD REG 15 WITH DUMMY  */
         SLR   GPR15P,GPR15P                                       0901
         BCTR  GPR15P,0                                            0901
*                                       /*ADDRESS                 */
*          CS (GPR14P,GPR15P,GPR04P->RPHRESMA);                    0902
         CS    GPR14P,@15,RPHRESMA(GPR04P)                         0902
*                                       /*COMPARE RESUME ADDRESS  */
*                                       /*WITH 0 AND,IF EQUAL, PUT*/
*                                       /*DUMMY ADDRESS IN CONTROL*/
*                                       /*BLOCK RESUME ADDRESS    */
*          BC (8,FMZT0091);             /*IF EQUAL, BYPASS REMAINDER*/
         BC    8,FMZT0091                                          0903
*                                       /*OF EXPANSION              */
*FMZL0091: IF GPR04P->RPHWT='1'B THEN   /*WT/EXT CONTENTION FLAG ON */
FMZL0091 TM    RPHWT(GPR04P),B'00001000'                           0904
         BNO   @RF00904                                            0904
*          DO;                          /*IN RPH                    */
*            GPR14P=GPR04P->RPHRESMA|RPHWT1;                       0906
         L     GPR14P,RPHRESMA(,GPR04P)                            0906
         O     GPR14P,@CF02235                                     0906
*                                       /*LOAD REG 14 WITH FLAG FIELD*/
*                                       /*AND MAKE CERTAIN WT/EXT    */
*                                       /*CONTENTION FLAG STILL ON   */
*            GPR15P=GPR14P|RPHPT1;      /*LOAD REG 15 WITH FLAG FIELD*/
         LR    GPR15P,GPR14P                                       0907
         O     GPR15P,@CF02238                                     0907
*                                       /*AND TURN POST FLAG ON      */
*            CS (GPR14P,GPR15P,GPR04P->RPHRESMA);                  0908
         CS    GPR14P,@15,RPHRESMA(GPR04P)                         0908
*                                       /*COMPARE REG 14 WITH FLAG */
*                                       /*FIELD--IF WT/EXT BIT ON, */
*                                       /*TURN ON POST FLAG        */
*            BC (4,FMZL0091);           /*IF WT/EXT BIT WAS OFF, LOOP*/
         BC    4,FMZL0091                                          0909
*                                       /*TO TEST CONTENTION FLAG    */
*            BC (8,FMZT0091);           /*IF WT/EXT BIT WAS OFF,     */
         BC    8,FMZT0091                                          0910
*                                       /*BRANCH TO BYPASS CODE GEN  */
*          END;                         /*IF POST FLAG IS ON, FALL*/
*                                       /*THRU BOTTOM OF LOOP     */
*          ELSE;                        /*WT/EXT CONTENTION FLAG OFF*/
@RF00904 DS    0H                                                  0913
*          GPR00F=0;                    /*SET REG 0 TO INDICATE ENA*/
*                                                                  0913
         SLR   GPR00F,GPR00F                                       0913
*        DO; /* LISATCVT CVTBASE(PAGEABLE,(GPR15P)) */             0914
*          GPR15P = ATCLCPTR; /*SET UP ATCVT POINTER*/             0915
         L     GPR15P,ATCLCPTR                                     0915
*        END; /*LISATCVT*/              /*PUT POINTER TO ATCVT IN */
*                                       /*  IN REG 15             */
*          CALL GPR15P->ATCAP32;        /* CALL ISTAPC32: TPSCHED */
         L     @09,ATCAP32(,GPR15P)                                0917
         LR    @15,@09                                             0917
         BALR  @14,@15                                             0917
*FMZT0091:                                                         0918
*        DO; /*MODESET  KEYADDR(GPR06F) WORKREG(GPR05F)*/          0918
FMZT0091 DS    0H                                                  0919
*          GPR05F = GPR06F; /*GET KEY FORM SAVE LOCATION*/         0919
         LR    GPR05F,GPR06F                                       0919
*          SPKA (GPR05F); /*SET PSW KEY*/                          0920
         SPKA  0(GPR05F)                                           0920
*        END; /*MODESET  KEYADDR(GPR06F) WORKREG(GPR05F)*/         0921
*          RESPECIFY (GPR00F,GPR01F,GPR04F,GPR05F,GPR06F,          0922
*          GPR14F,GPR15F) UNRSTD;       /*UNRESTRICT REGS 0,1,    */
*                                       /*4,5,14, AND 15          */
*        END;  /****END OF TPPOST GENERATION****/               /*TPPOS
* THE RPH*/                                                        0923
*RETURN;                                /*RETURN             @ZA10991*/
*                                                                  0924
@EL00001 DS    0H                                                  0924
@EF00001 DS    0H                                                  0924
@ER00001 LM    @14,@12,12(@13)                                     0924
         BR    @14                                                 0924
*/* TPEPILOG   */                                                  0925
* GEN (PRINT OFF);                                                 0925
*                                                                  0925
         PRINT OFF
*/*   PROGRAM OPERATOR MESSAGE HEADER                                */
*DCL  1  ISTPOHD  BDY(WORD) BASED,                                 0926
*        2 POHRSVD1 CHAR(1),       /* RESERVED                       */
*        2 POHSTAT,                /* HEADER STATUS BITS             */
*          3 POHEND   BIT(1),      /* END LINE 1=YES                 */
*          3 POHDATA  BIT(1),      /* DATA LINE 1=YES                */
*          3 POHLBL   BIT(1),      /* LABEL LINE 1=YES               */
*          3 POHCNTRL BIT(1),      /* CONTROL LINE 1=YES             */
*          3 POHRSVD2 BIT(2),      /* RESERVED                       */
*          3 POHRREQ  BIT(1),      /* REPLY REQUESTED 1=YES          */
*          3 POHGEN   BIT(1),      /* ID ORIGIN  0=GENERATED BY VTAM */
*                                  /*            1=GENERATED BY POA  */
*        2 POHID    FIXED(16);     /* MESSAGE IDENTIFIER             */
*/*            VTAM PREFIX FOR QUEUE ELEMENTS                         *
*/*  INITIAL LEVEL                                     001 03/04/75  */
*DECLARE                                                           0927
*  1 ISTPFX  BDY(WORD)  BASED,                                     0927
*   2 PFXID        CHAR(4),             /* QUEUE ACRONYM (SAME AS  0927
*                                          QABID)                     *
*     3 PFXCBID    BIT(8),              /* CONTROL BLOCK ID           *
*   2 PFXPRTY      CHAR(1),             /* PRIORITY OF ELEMENT        *
*   2 PFXLNG       CHAR(3),             /* ELEMENT LENGTH,         0927
*                                          INCLUDING PREFIX           *
*   2 PFXFWD       PTR(31),   /* POINTER TO NEXT QUEUE             0927
*                                          ELEMENT (IF LAST        0927
*                                          POINTER TO QAB)            *
*   2 PFXBCK       PTR(31) ;   /* POINTER TO PREVIOUS              0927
*                                          QUEUE ELEMENT (IF       0927
*                                          FIRST, POINTER TO QAB)     *
*DCL NCSPLTYP BIT(8) CONSTANT('60'X);   /* NCSPL CONTROL BLOCK ID     *
*   /* NETWORK CONFIGURATION SERVICES CONTROL BLOCK  */            0929
*/*  REVISIONS                                         14 07/01/75  */
*DECLARE                                                           0929
*  1 ISTNCSPL BASED BDY(DWORD),                                    0929
*   2 *      CHAR(16) BDY(WORD),                                   0929
*     3 NCSPFX CHAR(LENGTH(ISTPFX)), /* QUE ELEMENT PREFIX           */
*       4 *        CHAR(12),                                       0929
*       4 NCSCRWKA PTR(31),       /* PTR TO WORK AREA FOR C/R I/O    */
*   2 *           BIT(8),         /*RESERVED                         */
*   2 NCSPLVCD    BIT(8),         /*VERB CODE                        */
*   2 NCSPLVBF    CHAR(2),        /*VERB MODIFIER FLAGS              */
*      3 NCSVBF01 BIT(1),         /* UNUSED                          */
*      3 NCSVBF02 BIT(1),         /* UNUSED                          */
*      3 NCSVBF03 BIT(1),         /* MODIFY MSG SUP                  */
*      3 NCSVBF04 BIT(1),         /* TYPE=VTAM                       */
*      3 NCSVBF05 BIT(1),         /* LINETRACE=1                     */
*      3 NCSVBF06 BIT(1),         /* I/O TRACE=1                     */
*      3 NCSVBF07 BIT(1),         /* BUFFER TRACE=1                  */
*      3 NCSVBF08 BIT(1),         /* MODIFY TPRINT                   */
*      3 NCSVBF09 BIT(1),         /* MODIFY TEST                     */
*      3 NCSVBF10 BIT(1),         /* MODIFY TRACE=NO                 */
*      3 NCSVBF11 BIT(1),         /* VARY INTERNAL ONLY & MODIFY     */
*                                 /*  TRACE = YES                    */
*      3 NCSVBF12 BIT(1),         /* VARY IMMEDIATE  & MODIFY        */
*                                 /*  NETSOL=NO                      */
*      3 NCSVBF13 BIT(1),         /* MODIFY NETSOL=YES               */
*      3 NCSVBF14 BIT(1),         /* VARY LOGON & MODIFY             */
*                                 /*  CHANGE                         */
*      3 NCSVBF15 BIT(1),         /* VARY DEACTIVATE & VARY NORMAL   */
*                                 /*  CLOSE(ERP)                     */
*      3 NCSVBF16 BIT(1),         /* VARY ACTIVATE & ERP REQUEST     */
*                                 /*   & MODIFY DUMP                 */
*   2 NCSPLVFL    CHAR(1),        /*COMMAND FLAGS                    */
*    3 NCSVNCSA   BIT(1),         /*NCSPL IS ACTIVE                  */
*    3 NCSVDEL    BIT(1),         /*DELETE NCSPL                     */
*    3 NCSVSTAT   BIT(1),         /*INDICATE NCSPL WAS NOT GETMAINED */
*    3 NCSDCONT   BIT(1),         /* DO DISCONACT                    */
*    3 NCSABCON   BIT(1),         /* DO ABANDON CONNECTION           */
*    3 NCSDACLK   BIT(1),         /* DO ACTIVATE LINE                */
*    3 NCSRSV02   BIT(2),         /* RESERVED                        */
*   2 NCSPLVF1    CHAR(1),        /* SPECIAL PROC FLAGS              */
*    3 NCSOVFMC   BIT(1),         /* PURGE ONLY VARY'S FMCB          */
*   2 NCSPRMRC    CHAR(1),        /* PURGE MINOR RETURN CODE FIELD   */
*   2 NCSIORC     CHAR(1),        /* I/O OR RESTART RETURN CODE      */
*   2 NCSRRNPT    CHAR(4),        /* ADDR RN ENTRY FOR LINE TRACE    */
*   2 NCSPLRID    CHAR(8),        /*ID = 'NODENAME'                  */
*   2 NCSPLLID    CHAR(8),        /*LOGON = 'NODENAME'               */
*   2 NCSDLID     CHAR(6),        /* OFFHOOK ID                      */
*   2 NCSCRCMD    FIXED(8),       /* C/R I/O COMMAND CODE            */
*   2 NCSCRPID    PTR(8),         /* C/R PATH ID (PID)               */
*   2 NCSPLRPT    PTR(31),        /*ID='NODENAME' RDTE ADDRESS       */
*   2 NCSPLLPT    PTR(31),        /*LOGON/LOGOFF='NODENAME' RDTE ADDR*/
*   2 NCSPLCMD    CHAR(2),        /*3705 CONTROL COMMAND CODES       */
*     3 NCSCMDA  BIT(8),          /*RH FLAGS                         */
*       4 NCSPLSYS BIT(1),        /*ON-SYSTEM OFF-FM                 */
*       4 NCSPLCTL BIT(1),        /*ON-CONTROL OFF-DATA              */
*       4 NCSPLSYN BIT(1),        /*ON=SYNCHR OFF-ASYNCHR            */
*       4 NCSPLFLO BIT(1),        /*ON-WITH FLOW  OFF-AGAINST FLOW   */
*       4 NCSPLUFM BIT(1),        /*ON=UNFORMATTED RU,OFF=FORMATTED  */
*       4 *        BIT(3),        /*RESERVED                         */
*     3 NCSCMDB  BIT(8),          /*COMMAND FIELD                    */
*   2 NCSNCPEP    BIT(8),         /* EP SUBCHANNEL ADDR              */
*   2 NCSMSGSP    CHAR(1),        /* RESERVED FOR MESSAGE SURPRESSION*/
*   2 NCSPLUAD    CHAR(3),        /*U = 'UNIT ADDRESS'               */
*   2 NCSCRFLG    CHAR(1),        /* MISCELLANEOUS C/R FLAGS         */
*     3 NCSPLWRM    BIT(1),       /* COMMAND SPECIFIED WARM PARAM,   */
*                                 /* 1 = YES                         */
*     3 NCSPLCLD    BIT(1),       /* COMMAND SPECIFIED COLD PARAM,   */
*                                 /* 1 = YES                         */
*     3 NCSFMCLD    BIT(1),       /* 370X RESPONDED COLD TO ACTPU    */
*                                 /* (ERP), 1 = YES                  */
*     3 NCSFMERP    BIT(1),       /* 370X RESPONDED ERP TO ACTPU     */
*                                 /* (ERP), 1 = YES                  */
*     3 NCSCRDSE    BIT(1),       /* 0=C/R DATA SET DOES NOT EXIST   */
*                                 /* OR IS NULL                      */
*                                 /* 1=C/R DATA SET EXISTS           */
*                                 /* AND IS NOT NULL                 */
*     3 NCSOPRQU    BIT(1),       /* OPERATOR REQUESTS REIPL, 1 = YES*/
*     3 NCSUSRNF    BIT(1),       /* EARLY WARNING PURGE HAS ALREADY */
*                                 /* OCCURED, 1 = YES                */
*     3 NCSSTCMD    BIT(1),       /* ACTIVATE IS A RESULT OF         */
*                                 /* START VTAM COMMAND, 1 = YES     */
*   2 NCSPLWRE    BIT(32),        /* WTOR ECB                        */
*   2 NCSPLWRF    CHAR(72),       /* WTOR REPLY AREA                 */
*   2 NCSPLRAD    PTR(31),        /* RDTE PTR FOR ALLOCATE/DEALLOCATE*/
*     3 NCSLSCMD BIT(8),          /* LINE SCHED COMMAND TYPE         */
*     3 NCSPLRCD BIT(8),          /* HEX VALUE FOR LINE SCHED PARAM  */
*   2 NCSIOCID    CHAR(4),        /* CURRENT CID FOR DAF LOCK HELD   */
*     3  NCSPLCID CHAR(4),        /* ALIAS FOR ABOVE                 */
*        4  NCSPLSAF  CHAR(2),    /* SOURCE ADDRESS                  */
*        4  NCSPLDAF  CHAR(2),    /* DESTINATION ADDRESS             */
*   2 NCSPLWKA    PTR(31),        /* NCS WORK AREA ADDRESS           */
*   2 NCSPLCVT    PTR(31),        /* POINTER TO VTAM CVT             */
*   2 NCSPLRPH    PTR(31),        /* POINTER TO RPH                  */
*   2 NCSPLECB    BIT(32),        /* ECB FOR VARY PGS                */
*   2 NCSPLFSB    PTR(31),        /* ADDRESS OF USS-FSS FSB OR RU    */
*   2 NCSPLRCR    PTR(31),        /* ADDRESS RDTE FOR CR             */
*   2 NCSPLFL1    CHAR(1),        /* VARY FLAGS                      */
*     3 NCSPL2IN  BIT(1),         /* SECOND ENTRY                    */
*     3 NCSPLSOM  BIT(1),         /* SUPRESS OP. MESSAGE             */
*     3 NCSPLEBN  BIT(1),         /* ENTRY FROM BNN SSCP             */
*     3 NCSPLREQ  BIT(1),         /* NCSPL FROM RESTORE              */
*     3 NCSPLNON  BIT(1),         /* DO NOT ADDR RDT SEGMENT         */
*     3 NCSPLAPU  BIT(1),         /* ACTIVATE PHYSICAL DONE BY LOAD  */
*     3 NCSPL2CN  BIT(1),         /* SECOND CONTACT REQUEST          */
*     3 NCSPLPOS  BIT(1),         /* BNN POSTED                      */
*   2 NCSPLFL2    CHAR(1),        /* VARY FLAGS                      */
*     3 NCSPLVDP  BIT(1),         /* NCSPL ON VARDEF PAB             */
*     3 NCSPLRSF  BIT(1),         /* NO SICK CLEAR BEFORE I/O        */
*     3 NCSPLRIO  BIT(1),         /* I/O = RESTART I/O               */
*     3 NCSOUFMC  BIT(1),         /* PURGE ONLY USER FMCB            */
*     3 NCSPLDS   BIT(1),         /* 1=CIO SAVED RESPONSE DATA       */
*     3 NCSREMPO  BIT(1),         /* REMOTE POWER OFF SPEC BY OPER   */
*     3 NCSPLVIS  BIT(1),         /* VARY IMM START CALLER OF CVP    */
*     3 NCSPLVIT  BIT(1),         /* VARY IMM TERM CALLER OF CVP     */
*   2 NCSPLFL3    CHAR(1),        /* FLAG BYTE                       */
*     3 NCSPLMOM  BIT(1),         /* ERP CAUSED BY FAILURE OF      0929
*                                    HIGHER NODE                     */
*     3 NCSEPP    BIT(1),         /* 1=EP SUBCHANNEL PRESENT         */
*     3 NCSPLANS  BIT(1),         /* ON FOR ACT IN ANSWER MODE       */
*                                 /* OFF FOR ACT IN NON-ANSWER MODE  */
*     3 NCSGID    BIT(1),         /* ON FOR PATH WITH GID PARM       */
*     3 NCSPID    BIT(1),         /* ON FOR PATH WITH PID PARM       */
*     3 NCSANS    BIT(1),         /* ON FOR ACTIVATE WITH ANS PARM   */
*     3 NCSFINAL  BIT(1),         /* FINAL PARM EXISTS               */
*     3 NCSEND    BIT(1),         /* END PARM EXISTS                 */
*   2 NCSPLFL4    CHAR(1),        /* FLAG BYTE                       */
*     3 NCSDLNID  BIT(1),         /* ID PRESENT IN NCSPL - OFF       */
*     3 NCSPLRSO  BIT(1),         /* RESET ONLY                      */
*     3 NCSPLVID  BIT(1),         /* ORIG CMD WAS MODIFY DUMP        */
*     3 NCSDSPE   BIT(1),         /* DISPLAY EVERY                   */
*     3 NCSDSPA   BIT(1),         /* DISPLAY ACT                     */
*     3 NCSDSPI   BIT(1),         /* DISPLAY INACT                   */
*     3 NCSDSPN   BIT(1),         /* DISPLAY NONE                    */
*     3 NCSPL2AP  BIT(1),         /* SECOND ACTPU TO 320X            */
*   2 NCSDLRSN    CHAR(1),        /* DIAL REASON CODES               */
*   2 NCSPLFL5    CHAR(1),        /* FLAG BYTE                       */
*     3 NCSSCPPS  BIT(1),         /* SSCP WORK AREA IN PVT STORAGE   */
*     3 NCSSDLK   BIT(1),         /* ON-SDLC LINK PROCESSED          */
*     3 NCSFORCE  BIT(1),         /* FORCED DEACT IN PROGRESS        */
*     3 *         BIT(5),         /* RESERVED                        */
*   2 NCSPLOLN    FIXED(15),      /* LENGTH O/B RU                   */
*   2 NCSPLP1     PTR(31),        /* ADDR VARY PAB                   */
*   2 NCSPLP2     PTR(31),        /* ADDR D/L/R PAB                  */
*   2 NCSPLP3     PTR(31),        /* ADDR ERP PAB                    */
*   2 NCSPLSPL    PTR(31),        /* ADDR ASSOC. NCSPL               */
*   2 NCSPLWEL    PTR(31),        /* ADDR POST RPH                   */
*   2 NCSPLRRP    PTR(31),        /* ADDR REMOTE RN RDTE IN LOCAL RDT*/
*   2 NCSPLRUO    PTR(31),        /* ADDR O/B RU                     */
*   2 NCSPLRUI    PTR(31),        /* ADDR BUFFER FOR I/B RU          */
*   2 NCSPLAPP    PTR(31),        /* ADDR NCSPL APPENDAGE            */
*   2 NCSRNAME    CHAR(8),        /* RNAME=FROM VARY ACTIVATE        */
*   2 NCSPLSQN    FIXED(15),      /* SEQUENCE=NR. FOR RESPONSE       */
*   2 NCSPLGID    BIT(8),         /* BINARY REP OF GID VALUE         */
*   2 NCSPLPID    BIT(8),         /* BINARY REP OF PID VALUE         */
*   2 NCSPLMID    CHAR(8),        /* LOGMODE = 'MODENAME'            */
*   2 NCSPLNSN    PTR(31),        /* RDTE NSNEA AT CLSDST            */
*   2 NCSSENSE    CHAR(4),        /* SENSE                           */
*     3 NCSSNS1  CHAR(1),         /* SENSE DATA MAJOR CODE           */
*     3 NCSSNS2  CHAR(1),         /* SENSE MODIFIER BYTE             */
*     3 NCSSENS2 CHAR(2),         /* USER SENSE DATA                 */
*   2 NCSCPWPT    PTR(31),        /* ADDRESS OF CPWA                 */
*   2 NCSMGLPT    PTR(31),        /* PTR TO USS/FSS MSG PARAM LIST   */
*   2 NCSUFMCB    PTR(31),        /* POINTER TO SSCP-LU FMCB         */
*   2 NCSPLRH     CHAR(3),        /* REQUEST RH                      */
*   2 NCSPLRTY    CHAR(1),        /* TYPE FROM RTGOH RU              */
*   2 NCSCRDTE    PTR(31),        /* PTR TO RDTE BEING PROCESSED     */
*                                 /* FOR C/R I/O                     */
*   2 NCSCRMSK,                   /* FLAGS FOR C/R CHECK POINTING    */
*     3 NCSCHKPT    CHAR(2),      /* FLAGS FOR ITEMS CHECK POINTED   */
*       4 NCSACTV     BIT(1),     /* ACTICE/INACTIVE STATUS CHANGED  */
*                                 /* 1 = YES                         */
*       4 NCSPACTV    BIT(1),     /* PORT ACT/INACTIVE STATUS CHANGED*/
*                                 /* 1 = YES                         */
*       4 NCSPOLD     BIT(1),     /* POLL DELAY VALUE CHANGED, 1=YES */
*       4 NCSNRPL     BIT(1),     /* NEGATIVE RESPONSE TO POLL       */
*                                 /* LIMIT VALUE CHANGED, 1 = YES    */
*       4 NCSESLM     BIT(1),     /* SESSION LIMIT VALUE CHANGED,1=YES*
*       4 NCSDTRLM    BIT(1),     /* DEVICE TRANSMISSION LIMIT       */
*                                 /* VALUE CHANGED, 1 = YES          */
*       4 NCSLGAPL    BIT(1),     /* APPLICATION CONTROLLER NAME     */
*                                 /* (LOGAPPL) CHANGED, 1 = YES      */
*       4 NCSLGMOD    BIT(1),     /* LOGON MODE (LOGMODE)            */
*                                 /* CHANGED, 1 = YES                */
*       4 NCSANSMD    BIT(1),     /* ANSWER MODE STATUS CHANGED,1=YES*/
*       4 NCSCUA      BIT(1),     /* CUA VALUE CHANGED, 1 = YES      */
*       4 NCSRNME     BIT(1),     /* RNAME VALUE CHANGED, 1 = YES    */
*       4 NCSPTUSE    BIT(1),     /* PATH USE/NOUSE STATUS CHANGED   */
*                                 /* 1 = YES                         */
*       4 NCSRSVD1    BIT(4),     /* RESERVED                        */
*     3 NCSCRMOD    CHAR(1),      /* NEW VALUES FOR ITEMS CHECKPOINTED*
*                                 /* NOT OBTAINED FROM RDTE          */
*       4 NCSAIMOD    BIT(1),     /* ACTIVE/INACTIVE STATUS, 1=ACTIVE*/
*       4 NCSPTMOD    BIT(1),     /* PORT ACT/INACT STATUS, 1=ACTIVE */
*       4 NCSRSVD2    BIT(6),     /* RESERVED                        */
*   2 NCSPLSID BDY(BYTE),         /* MESSAGE ROUTING INFORMATION     */
*     3 NCSPLSTA    CHAR(1),      /* STATUS FLAG BYTE                */
*       4 NCSRSVD4    BIT(7),     /* RESERVED                        */
*       4 NCSPLPO     BIT(1),     /* 0 = CONSOLE ID FOLLOWS, 1 =     */
*                                 /* PROGRAM OPERATOR HEADER FOLLOWS */
*     3 NCSPLPHD CHAR(LENGTH(ISTPOHD)), /* PO HEADER IF NCSPLPO = 01 */
*       4 NCSPLNID    FIXED(8),   /* CONSOLE ID IF NCSPLPO = 0       */
*     3 NCSPLPDB    PTR(31);      /* PTR TO PO ACDEB PREFIX          */
*/*   COMMAND VALUES FOR C/R FIELD NCSCRCMD                          */
*DCL NCSCRWR  FIXED(8) CONSTANT(0);  /* WRITE TO C/R DATA SET        */
*DCL NCSCROPN FIXED(8) CONSTANT(1);  /* OPEN C/R DATA SET            */
*DCL NCSCRCLS FIXED(8) CONSTANT(2);  /* CLOSE C/R DATA SET           */
*DCL NCSCRDEL FIXED(8) CONSTANT(3);  /* DELETE C/R DATA SET RECORD   */
*DCL NCSCROPQ FIXED(8) CONSTANT(4);  /* OPERATOR QUERY               */
*DCL NCSDCID  FIXED(8) CONSTANT(1);  /* CONSOLE ID INDICATOR         */
*DCL NCSCRIO  BIT(16) CONSTANT('0800'X); /* INDICATES REQUESTS       */
*                                        /* FOR VSAM I/O FOR C/R     */
*DCL NCSCRVIO BIT(16) CONSTANT('0C00'X); /* VSAM I/O OPERATION       */
*/* NCSPL APPENDAGE DEFINATION                                       */
*DCL  1  NCSAPP BASED(NCSPLAPP),                                   0938
*        2 NCSAPSA  CHAR(72),     /* SAVE AREA                       */
*        2 NCSAPECB CHAR(4),      /* ECB                             */
*        2 NCSAPTXT CHAR(8),      /* DUMP DATA                       */
*        2 NCSAPEND PTR(31),      /* HIGH STORAGE ADDRESS            */
*        2 NCSAPBUE CHAR(520),                                     0938
*          3 NCSRSV04 CHAR(3),    /* RESERVED                        */
*          3 NCSAPRU  CHAR(5),    /* IPL CMD RU PREFIX               */
*          3 NCSAPDAT CHAR(512),  /* RESP FOR DUMP, O/B LOAD         */
*        2 NCSAPPAB PTR(31);      /* BNN VARY PAB ADDR               */
*/*    USS/FSS RU AREA MAP                                           */
*DCL  1  NCSUSSRU BASED(NCSPLFSB),                                 0939
*        2 NCSRULEN FIXED(15),    /* LENGTH OF RU                    */
*        2 NCSRUITS CHAR(*);      /* START OF RU                     */
*/*    GENERAL CONSTANTS                                             */
*DCL NCSWASZ  FIXED(15) CONSTANT(2032);   /* NCSPL WORK AREA SIZE    */
*DCL NCSRTGOH BIT(16) CONSTANT('1000'X);  /* VBF VALUE FOR INTERNAL  */
*                                         /* COMMAND-RTGOH RECVD.    */
*/*    CONSTANTS FOR VERB CODES                                      */
*DCL NCSPLVC0 BIT(08) CONSTANT('00'X);    /* ERROR                   */
*DCL NCSPLVC1 BIT(08) CONSTANT('01'X);    /* VARY                    */
*DCL NCSPLVC2 BIT(08) CONSTANT('02'X);    /* MODIFY                  */
*DCL NCSPLVC3 BIT(08) CONSTANT('03'X);    /* ERP                     */
*DCL NCSPLVC4 BIT(08) CONSTANT('04'X);    /* DISPLAY                 */
*DCL NCSPLVC5 BIT(08) CONSTANT('05'X);    /* STATUS TO SM            */
*DCL NCSPLVC6 BIT(08) CONSTANT('06'X);    /* INTERNAL CMD            */
*DCL NCSPLVC7 BIT(08) CONSTANT('07'X);    /* INIT/TERM TUSM          */
*DCL NCSPLVC8 BIT(08) CONSTANT('08'X);    /* DIAL                    */
*/*    CONSTANTS FOR VARY COMMAND MODIFIERS                          */
*DCL NCSVACT BIT(16) CONSTANT('0001'X);   /*ACTIVATE                 */
*DCL NCSVDEA BIT(16) CONSTANT('0002'X);   /* DEACTIVATE              */
*DCL NCSVLON BIT(16) CONSTANT('0004'X);   /* LOGON                   */
*DCL NCSVVPP BIT(16) CONSTANT('0080'X);   /* VARY NORMAL CLEANUP REQST*
*DCL NCSVIMM BIT(16) CONSTANT('0010'X);   /* IMMEDIATE               */
*DCL NCSVINT BIT(16) CONSTANT('0020'X);   /* INTERNAL ONLY           */
*DCL NCSVALO BIT(16) CONSTANT('0005'X);   /* ACTIVATE WITH LOGON     */
*DCL NCSVDEI BIT(16) CONSTANT('0012'X);   /* DEACTIVATE IMMEDIATE    */
*DCL NCSVDII BIT(16) CONSTANT('0032'X);   /* DEACTIV. IMMEDIATE INTERNA
*                                            ONLY*/                0959
*DCL NCSCNOTF BIT(16) CONSTANT('FFF8'X);  /* NOTIFY REQUEST          */
*DCL NCSVANON BIT(16) CONSTANT('0008'X);  /* ANSWER = ON             */
*DCL NCSVANOF BIT(16) CONSTANT('0040'X);  /* ANSWER = OFF            */
*DCL NCSVPUSE BIT(16) CONSTANT('0100'X);  /* PATH = USABLE           */
*DCL NCSVPNUS BIT(16) CONSTANT('0200'X);  /* PATH = NOT USABLE       */
*DCL NCSVINOP BIT(16) CONSTANT('0400'X);  /* INOPERATIVE             */
*/*    CONSTANTS FOR MODIFY COMMAND MODIFIERS                        */
*DCL NCSMDUM BIT(16) CONSTANT('0001'X);   /* DUMP 3705               */
*DCL NCSMCHA BIT(16) CONSTANT('0004'X);   /* CHANGE                  */
*DCL NCSMNSY BIT(16) CONSTANT('0008'X);   /* NETSOL = YES            */
*DCL NCSMNSN BIT(16) CONSTANT('0010'X);   /* NETSOL = NO             */
*DCL NCSMTRY BIT(16) CONSTANT('0020'X);   /* TRACE = YES             */
*DCL NCSMVTRY BIT(16) CONSTANT('1020'X);                           0971
*DCL NCSMVTRN BIT(16) CONSTANT('1040'X);                           0972
*DCL NCSMTRN BIT(16) CONSTANT('0040'X);   /* TRACE = NO              */
*DCL NCSMTPR BIT(16) CONSTANT('0100'X);   /* TRACE PRINT             */
*DCL NCSMTST BIT(16) CONSTANT('0080'X);   /* MODIFY TEST             */
*DCL NCSDPF   BIT(16) CONSTANT('0000'X);  /* POTENTIAL FAIL          */
*DCL NCSDSTRT BIT(16) CONSTANT('0001'X);  /* DIAL START              */
*DCL NCSDOH1  BIT(16) CONSTANT('0002'X);  /* OFFHOOK 1               */
*DCL NCSDOH2  BIT(16) CONSTANT('0004'X);  /* OFFHOOK 2               */
*DCL NCSDDF   BIT(16) CONSTANT('0010'X);  /* DIAL FAILED             */
*DCL NCSDLKS  BIT(16) CONSTANT('0008'X);  /* LINK START              */
*DCL NCSDLKC  BIT(16) CONSTANT('0020'X);  /* LINK COMPLETION         */
*DCL NCSDHU   BIT(16) CONSTANT('0040'X);  /* HANGUP                  */
*DCL NCSDLK   BIT(16) CONSTANT('0080'X);  /* DEALLOCATE              */
*DCL NCSDGIVE BIT(16) CONSTANT('0100'X);  /* GIVE                    */
*DCL NCSDINOP BIT(16) CONSTANT('0200'X);  /* INOP                    */
*DCL NCSDLRST BIT(16) CONSTANT('0400'X);  /* RECOVERY SW LINKS       */
*                                         /* AFTER RN FAILURE        */
*/*    CONSTANTS FOR ERP COMMAND MODIFIERS                           */
*DCL NCSEERRA BIT(16) CONSTANT('0001'X);  /* ERP REQUEST          */
*DCL NCSECLOR BIT(16) CONSTANT('0002'X);  /* VARY NORMAL CLOSE REQUEST*
*DCL NCSEDACT BIT(16) CONSTANT('0004'X);  /* ERP DEACTIVATE REQUEST   *
*DCL NCSERSTR BIT(16) CONSTANT('0008'X);/* RSTRT ENTRY FROM DLR PROC */
*DCL NCSVFORC BIT(16) CONSTANT('0802'X);/* FORCED DEACT              */
*DCL NCSVRACT BIT(16) CONSTANT('1002'X);/* DEACT AND REACT           */
*/*   PURGE MINOR RETURN CODES CONSTANTS                             */
*DCL NCSAPABN BIT(8) CONSTANT('05'X),    /* APPLICATION ABEND        */
*    NCSCLDST BIT(8) CONSTANT('06'X),    /* CLOSE DEST OCCURED       */
*    NCSDDISC BIT(8) CONSTANT('08'X),    /* DIAL DISCONNECT OCCURED
*                                           - CONN NO LONGER AVAILABL*/
*    NCSBTHEX BIT(8) CONSTANT('09'X);    /* BUFFER THRESHOLD EXCEEDED*/
*/*   I/O OR RESTART RETURN CODES CONSTANTS                          */
*DCL NCSIOSUC BIT(8) CONSTANT('00'X),    /* I/O SUCCESSFUL           */
*    NCSIOERR BIT(8) CONSTANT('04'X),    /* I/O ERROR                */
*    NCSIOPRG BIT(8) CONSTANT('08'X),    /* I/O PURGED               */
*    NCSRSSUC BIT(8) CONSTANT('00'X),    /* RESTART SUCCESSFUL       */
*    NCSRSERR BIT(8) CONSTANT('04'X),    /* RESTART ERROR            */
*    NCSVAIPL BIT(8) CONSTANT('00'X),  /* IPL NO RESTART ON VARY ACTV*/
*    NCSVANRA BIT(8) CONSTANT('10'X),    /* IPL SUCCESSFUL, NO RESTART
*                                           AVAILABLE ON VARY ACTIVE  *
*    NCSVAWMF BIT(8) CONSTANT('08'X),    /* WARM START FAILURE FOR 0995
*                                           VARY ACTIVATE            */
*    NCSVAIPF BIT(8) CONSTANT('0C'X),   /* IPL FAILED ON VARY ACTIVATE*
*    NCSDSIA  BIT(8) CONSTANT('14'X),   /* INVALID ADDRESS SPECIFIED
*                                          ON DISPLAY STORAGE CMND    *
*    NCSVAISZ BIT(8) CONSTANT('08'X),   /* NCP SIZE TOO LARGE         *
*    NCSIPLSC BIT(8) CONSTANT('00'X),   /* IPL SUCCESSFUL             *
*    NCSIOER  BIT(8) CONSTANT('0C'X),   /* I/O ERROR ON REMOTE IPL    *
*    NCSNCPAC BIT(8) CONSTANT('04'X),   /* REMOTE NCP ALREADY ACTIVE  *
*    NCSNCRPF BIT(8) CONSTANT('70'X),   /* REMOTE POWER OFF           *
*    NCSCRIOS BIT(8) CONSTANT('30'X),   /* SUCCESSFUL I/O             *
*    NCSCRION BIT(8) CONSTANT('34'X),   /* NULL D.S. OPENED           *
*    NCSCRIOF BIT(8) CONSTANT('38'X);   /* FAILURE ON I/O             *
*/*           CONSTANTS FOR LIBERTY SUPPORT                           *
*DCL  NCSES   BIT(16) CONSTANT('0001'X),/* END SESSION                *
*     NCSBF   BIT(16) CONSTANT('0002'X),/* BIND FAILURE               *
*     NCSUF   BIT(16) CONSTANT('0004'X),/* UNBIND FAILURE             *
*     NCSINIT BIT(16) CONSTANT('0001'X),                           0996
*     NCSTERM BIT(16) CONSTANT('0002'X);                           0996
*DCL NCSTPPST BIT(16) CONSTANT('0001'X);/* TPPST COMMAND              *
*DCL NCSII    BIT(16) CONSTANT('0002'X);/* IPL INIT COMMAND           *
*DCL NCSIT    BIT(16) CONSTANT('0004'X);/* IPL COMMAND                *
*DCL NCSIF    BIT(16) CONSTANT('0008'X);/* IPL FINAL COMMAND          *
*DCL NCSDI    BIT(16) CONSTANT('0010'X);/* DUMP INIT COMMAND          *
*DCL NCSDT    BIT(16) CONSTANT('0020'X);/* DUMP TEXT COMMAND          *
*DCL NCSDF    BIT(16) CONSTANT('0040'X);/* DUMP FINAL COMMAND         *
*DCL NCSCON   BIT(16) CONSTANT('0080'X);/* CONTACT COMMAND            *
*DCL NCSDICON BIT(16) CONSTANT('0100'X);/* DISCONTACT COMMAND         *
*DCL NCSMSFMD BIT(16) CONSTANT('0200'X);/* SEND FMD                   *
*DCL NCSSEND  BIT(16) CONSTANT('0400'X);/* SEND                       *
*DCL NCSPURGE BIT(16) CONSTANT('0800'X);/* PAB PURGE                  *
*DCL NCSMSSUP BIT(16) CONSTANT('2000'X);/* CONSTANT FOR MSG SUP       *
*DCL NCSCRDS  BIT(16) CONSTANT('3023'X);/* RECORD DEV STATS COMMAND   *
*DCL NCSCQUIS BIT(16) CONSTANT('F01A'X);/* QUIESCE COMMAND            *
*DCL NCSSNUSS BIT(16) CONSTANT('381F'X);/* SEND USS MESSAGE           *
*/*                                                                   *
*DCL NCSNC    BIT(8)  CONSTANT('04'X);  /* NOT CONTACTED              *
*DCL NCSLD    BIT(8)  CONSTANT('00'X);  /* CONTACTED LOADED           *
*DCL NCSNLD   BIT(8)  CONSTANT('0C'X);  /* CONTACTED NEEDS LOAD       *
*DCL NCSNCD   BIT(8)  CONSTANT('08'X);  /* NOT CONTACTED DUE TO DEACT *
*DCL NCSNCE   BIT(8)  CONSTANT('10'X);  /* NOT CONTACTED DUE TO ERP   *
*DCL NCSNFME  BIT(8)  CONSTANT('24'X);  /* NEGATIVE FME               *
*/*  CONSTANTS FOR IORC FOR DISPLAY STORAGE                          */
*DCL NCSDSDEA BIT(8)  CONSTANT('0C'X);  /* PRIOR DEACT                *
*DCL NCSDSFAL BIT(8)  CONSTANT('04'X);  /* FAIL OTHER THAN PRIOR DEACT*
*/* TYPE CODES FOR CONFIGURATION RESTART                              *
*DCL NCSCTRLM BIT(8) CONSTANT('01'X);   /* CHANGE DEV TRANS LIMIT     *
*DCL NCSCNPOL BIT(8) CONSTANT('02'X);   /* CHANGE NEG POLL RESP LIMIT *
*DCL NCSCSESS BIT(8) CONSTANT('03'X);   /* CHANGE SESSION LIMIT       *
*DCL NCSCPOLL BIT(8) CONSTANT('04'X);   /* CHANGE LINE SERV SEEK PAUSE*
*/*  FM DATA COMMAND CODES                                            *
*DCL NCSCAPU  BIT(16) CONSTANT('D001'X);   /* ACT PHYS                *
*DCL NCSCDPU  BIT(16) CONSTANT('D002'X);   /* DEACT PHYS              *
*DCL NCSCALU  BIT(16) CONSTANT('D003'X);   /* ACT LOG                 *
*DCL NCSCDLU  BIT(16) CONSTANT('D004'X);   /* DEACT LOG               *
*DCL NCSCSDT  BIT(16) CONSTANT('D005'X);   /* SDT                     *
*DCL NCSCFME  BIT(16) CONSTANT('2006'X);   /* SEND POS RESP           *
*DCL NCSCEXCP BIT(16) CONSTANT('2007'X);   /* SEND NEG RESP           *
*DCL NCSCCON  BIT(16) CONSTANT('3008'X);   /* CONTACT                 *
*DCL NCSCDCON BIT(16) CONSTANT('3009'X);   /* DISCONTACT              *
*DCL NCSCIPLI BIT(16) CONSTANT('300A'X);   /* IPL INIT                *
*DCL NCSCIPLT BIT(16) CONSTANT('300B'X);   /* IPL                     *
*DCL NCSCIPLF BIT(16) CONSTANT('300C'X);   /* IPL FINAL               *
*DCL NCSCDUMI BIT(16) CONSTANT('300D'X);   /* DUMP INIT               *
*DCL NCSCDUMP BIT(16) CONSTANT('300E'X);   /* DUMP                    *
*DCL NCSCDUMF BIT(16) CONSTANT('300F'X);   /* DUMP FINAL              *
*DCL NCSCACTL BIT(16) CONSTANT('3010'X);   /* ACT LINK                *
*DCL NCSCDACL BIT(16) CONSTANT('3011'X);   /* DEACT LINK              *
*DCL NCSCSSV  BIT(16) CONSTANT('3012'X);   /* SET STATE VECTOR        *
*DCL NCSCNSP  BIT(16) CONSTANT('3013'X);   /* NS PROC ERROR           *
*DCL NCSCSTD  BIT(16) CONSTANT('3019'X);   /* SET TIME & DATE         *
*DCL NCSCSEP  BIT(16) CONSTANT('9014'X);   /* SWITCH TO EP            *
*DCL NCSCSNC  BIT(16) CONSTANT('9015'X);   /* SWITCH TO NCP           *
*DCL NCSCLSD  BIT(16) CONSTANT('3016'X);   /* LINE SCHED PARM         *
*DCL NCSCDS   BIT(16) CONSTANT('3017'X);   /* DISPLAY STORAGE         *
*DCL NCSCPWO  BIT(16) CONSTANT('3018'X);   /* REMOTE POWER OFF        *
*DCL NCSSNFMD BIT(16) CONSTANT('301C'X);   /* SEND FMD                *
*DCL NCSCDIAL BIT(16) CONSTANT('301A'X);   /* DIAL                    *
*DCL NCSCADIL BIT(16) CONSTANT('301B'X);   /* ABANDON DIAL            *
*DCL NCSCEANS BIT(16) CONSTANT('301D'X);   /* ENABLE ANS MODE         *
*DCL NCSCAANS BIT(16) CONSTANT('301E'X);   /* ABANDON ANS MODE        *
*DCL NCSCANA  BIT(16) CONSTANT('301F'X);   /* ASSIGN NET ADDRESS      *
*DCL NCSCFNA  BIT(16) CONSTANT('3020'X);   /* FREE NET ADDRESS        *
*DCL NCSCACON BIT(16) CONSTANT('3021'X);   /* ABANDON CONNECTION      *
*DCL NCSCSCV  BIT(16) CONSTANT('3022'X);   /* SET CONTROL VECTOR      *
*DCL NCSNCPPG BIT(16) CONSTANT('FFFF'X);   /* PURGE                   *
*/* NEW VALUES FOR NCSPLCMD   */                                   1060
*DCL NCSCLCND BIT(16) CONSTANT('0041'X);  /* LOAD CONDITIONALLY  */
*DCL NCSCUCND BIT(16) CONSTANT('0042'X); /* LOAD UNCONDITIONALLY */
*DCL NCSCRSRT BIT(16) CONSTANT('0043'X); /* RESTART 370X OR CLUS  */
*DCL NCSDUCMD BIT(16) CONSTANT('0044'X); /* DUMP 370X  */          1063
*DCL NCSCERPP BIT(16) CONSTANT('0045'X); /* PERFORM ERP DUMP AND   1064
*                                           RELOAD OF 370X  */     1064
*DCL NCSDOUT  BIT(16) CONSTANT('0046'X); /* DIAL OUT                 */
*DCL NCSDCNT  BIT(16) CONSTANT('0047'X); /* DIAL CONTACT             */
*DCL NCSDABDN BIT(16) CONSTANT('0048'X); /* DIAL ABANDON             */
*DCL NCSDENAS BIT(16) CONSTANT('0049'X); /* DIAL ENABLE ANSWER       */
*/*  VALUES FOR NCSCMDB                                              */
*DCL NCSBFME BIT(8) CONSTANT('06'X);     /* SEND POS RESP COMMAND    */
*DCL NCSBEXC BIT(8) CONSTANT('07'X);     /* SEND NEG RESP COMMAND    */
*/*  CONSTANTS FOR DIAL REASON CODES                                 */
*DCL NCSDLRRD BIT(8) CONSTANT('01'X);    /* REDIAL                   */
*DCL NCSDLRQT BIT(8) CONSTANT('02'X);    /* QUIT                     */
*/* NEW VALUES FOR NCSIORC   */                                    1073
*DCL NCSLDAOK BIT(8) CONSTANT('00'X);  /* COMMAND PROCESSED SUCESS */
*DCL NCSLDACT BIT(8) CONSTANT('04'X);  /* NCP ACTIVE-LOAD NOT PERF */
*DCL NCSLDCAN BIT(8) CONSTANT('04'X);  /* RELOAD DECLINED BY OPER  */
*DCL NCSLDIOP BIT(8) CONSTANT('08'X);  /* I/O PURGED               */
*DCL NCSLDNOG BIT(8) CONSTANT('0C'X);  /* COMMAND FAILED           */
*DCL NCSDUCOM BIT(8) CONSTANT('14'X);  /* DUMP COMPLETE            */
*DCL NCSHALTD BIT(8) CONSTANT('18'X);  /* CMD REJECTED,HALT IN PROG*/
*DCL NCSUNREC BIT(8) CONSTANT('1C'X);  /* COMMAND UNRECOGNIZED     */
*DCL NCSNOSTG BIT(8) CONSTANT('20'X);  /* CMD REJ,INSUFF STORAGE   */
*DCL NCSDOS   BIT(8) CONSTANT('00'X);  /* DIAL-OUT SUCCESSFUL      */
*DCL NCSDOF   BIT(8) CONSTANT('04'X);  /* DIAL-OUT UNSUCCESSFUL    */
*DCL NCSDOP   BIT(8) CONSTANT('08'X);  /* DIAL-OUT PENDING         */
*DCL NCSDCS   BIT(8) CONSTANT('00'X);  /* DIAL-CONTACT LOADED      */
*DCL NCSDCF   BIT(8) CONSTANT('0C'X);  /* DIAL-CONTACT FAILED      */
*DCL NCSDAS   BIT(8) CONSTANT('00'X);  /* DIAL-ABANDON CONN COMPLETE*/
*DCL NCSDENSO BIT(8) CONSTANT('00'X);  /* ENABLE ANSWER SUCCESSFUL  */
*DCL NCSDOFHR BIT(8) CONSTANT('04'X);  /* OFFHOOK REQUIRED          */
*DCL NCSDENSF BIT(8) CONSTANT('08'X);  /* ENABLE ANSWER FAIL        */
*/*  NEW VALUES FOR NCSPRMRC    */                                 1091
*DCL NCSFIRM  BIT(8) CONSTANT('10'X);  /* RESTART SUCC,OPENDST REQ */
*DCL NCSEWRN  BIT(8) CONSTANT('11'X);  /* CON LOST,RECOV IN  PROG  */
*/* CONSTANTS FOR TRACE                                            */
*DCL NCSACTLT BIT(16) CONSTANT('0820'X); /* ACTIVATE LINE TRACE    */
*DCL NCSDACLT BIT(16) CONSTANT('0840'X); /* DEACTIVATE LINE TRACE  */
*DCL NCSCACLT BIT(16) CONSTANT('301D'X); /* SSCP ACT LINE TRACE    */
*DCL NCSCDCLT BIT(16) CONSTANT('301E'X); /* SSCP DEACT LINE TRACE  */
*/* DISPLAY COMMAND MODIFIER CONSTANTS                             */
*DCL NCSDPATH BIT(16) CONSTANT('0001'X); /* PATHS                  */
*/* LOCKWORD FORMAT DSECT                                            */
*/*  INITIAL LEVEL                                     001 05/24/74  */
*DCL 1 ISTLOK BDY(WORD) BASED,                                     1098
*     2  LOKCT CHAR(1) BDY(WORD),       /* COUNT OF LOCK OWNERS      */
*     2  LOKCHN PTR(24),                /* ADDR OF NEXT RPH WAITING
*                                          ON LOCK                   */
*        3  LOKCHNG CHAR(3),            /* CHAIN/FLAGS               */
*           4 *        CHAR(2),                                    1098
*           4 *        BIT(8),                                     1098
*             5 *        BIT(6),                                   1098
*             5  LOKPRY BIT(1),         /* PRIORITY FLAG, 1 = ON     */
*             5  LOKXCL BIT(1);         /* EXCLUSIVE FLAG, 1 = ON    */
*DCL LOKXCL1  BIT(32) CONSTANT('00000001'X); /* CONSTANT TO TURN LOKXCL
*                                          ON                        */
*DCL LOKPRY1  BIT(32) CONSTANT('00000002'X); /* CONSTANT TO TURN LOKPRY
*                                          ON                        */
*DCL LOKCHN1  BIT(32) CONSTANT('00FFFFFC'X); /* CONSTANT TO TURN LOKXCL
*                                          AND LOKPRY OFF            */
*DCL LOKCT1   BIT(32) CONSTANT('01000000'X); /* CONSTANT TO MAKE LOKCT
*                                          = 1                       */
*DCL LOKCT255 BIT(32) CONSTANT('FF000000'X); /* CONSTANT TO CHECK FOR
*                                          MAX LOKCT (255)           */
*/*   DEVICE CHARACTERISTICS TABLE - ORIGINATES IN RDT USED TO DEFINE
*    DEVICE CHARACTERISTICS IN DNCB,FMCB AND NIB  */               1104
*/*  INITIAL LEVEL                                     001 08/07/74  */
*DCL  1  ISTDEVCH  BDY(WORD)BASED,                                 1104
*        2  DEVSHCH BIT(8),            /* DEV SCHED CHARACTERISTICS  */
*           3  DEVCHAR  BIT(8),        /* COMPATIBILITY EXISTING CODE*/
*              4  DEVINPUT  BIT(1),    /* DEVICE IS FOR INPUT        */
*              4  DEVOTPUT  BIT(1),    /* DEVICE IS FOR OUTPUT       */
*              4  DEVCONVR  BIT(1),    /* DEVICE IS CONVERSATION     */
*                                      /* RN DEFINITION              */
*              4  DEVSUBND  BIT(1),    /* DEVICE HAS SCHEDULABLE     */
*                                      /*   SUB-NODES                */
*              4  DEVSPS BIT(1),       /* DEV IS START PRINT SENSITIVE*
*              4  DEVNNSPT BIT(1),     /* NODE HAS NETWRK MNGMNT SPRT*/
*              4  DEVCCTL BIT(1),      /* NODE HAS CONN CNTRL DEPENDCS*
*              4  DEVRSV01  BIT(1),    /* RESERVED                   */
*        2  DEVTCODE BIT(8),           /* DEVICE TYPE CODES          */
*           3  DEVCHAR2  BIT(8),       /* COMPATIBILITY EXISTING CODE*/
*        2  DEVMCODE BIT(8),           /* DEVICE MODEL CODE           *
*        2  DEVFLAGS BIT(8),           /*USE DEPENDS ON DEVSHCH VALUES*
*           3  DEVFCCTL BIT(4),        /* USED IF DEVICE REQ CONN CTRL*
*              4  DEVCBSC BIT(1),      /* RESET ORDERLY, BI-SYNCH  1104
*                                         TERMINALS EXCEPT 3270'S    */
*              4  DEVCSSL BIT(1),      /*RESET AT END OF COMMAND. 3270'
*                                         AND START/STOP EXCEPT TERMS
*                                         WITH REVERSE BREAK FEATURE */
*                                                                  1104
*              4  DEVCRVB BIT(1),      /* RESET IMMEDIATE. START/STOP
*                                         TERMS WITH REVERSE BREAK 1104
*                                         FEATURE                    */
*              4  DEVCSWL BIT(1),      /* 1=HIGHER NODE IS SWITCH CON-
*                                         NECTION, 0=LEASED CONNECTION*
*           3  DEVCHAR3 BIT(4),        /* COMPATIBILITY EXISTING CODE*/
*              4  DEVCATTN BIT(1),     /* TERMINAL CAN INTERRUPT WITH
*                                         ATTENTION                  */
*              4  DEVCCHEK BIT(1),     /* TERMINAL HAS CHECKING      */
*              4  DEVCSTCL BIT(1),     /* TERMINAL HAS STATION     1104
*                                         CONTROL                    */
*              4  DEVCSLPN BIT(1),     /* TERMINAL HAS SELECTOR PEN  */
*        2  DEVPHYSA CHAR(1),          /* PHYSICAL DEVICE ADDRESS    */
*        2  DEVRSV03 CHAR(3);          /* RESERVED                   */
*/* DEVICE TYPE CODES */                                           1105
*DCL DEV2740 BIT(8) CONSTANT ('01'X);  /* DEVICE IS A 2740           */
*DCL DEV2741 BIT(8) CONSTANT ('02'X);  /* DEVICE IS A 2741           */
*DCL DEV1050 BIT(8) CONSTANT ('03'X);  /* DEVICE IS A 1050           */
*DCL DEVTWX  BIT(8) CONSTANT ('04'X);  /* DEVICE IS A TWX            */
*DCL DEVWTTY BIT(8) CONSTANT ('05'X);  /* DEVICE IS A WTTY           */
*DCL DEV115A BIT(8) CONSTANT ('06'X);  /* DEVICE IS A 115A           */
*DCL DEV83B3 BIT(8) CONSTANT ('07'X);  /* DEVICE IS AN 83B3          */
*DCL DEV2715 BIT(8) CONSTANT ('08'X);  /* DEVICE IS A 2715           */
*DCL DEV2770 BIT(8) CONSTANT ('09'X);  /* DEVICE IS A 2770           */
*DCL DEV2780 BIT(8) CONSTANT ('0A'X);  /* DEVICE IS A 2780           */
*DCL DEV3735 BIT(8) CONSTANT ('0B'X);  /* DEVICE IS A 3735           */
*DCL DEV3780 BIT(8) CONSTANT ('0C'X);  /* DEVICE IS A 3780           */
*DCL DEV1130 BIT(8) CONSTANT ('0D'X);  /* DEVICE IS AN 1130          */
*DCL DEV1800 BIT(8) CONSTANT ('0E'X);  /* DEVICE IS AN 1800          */
*DCL DEV3125 BIT(8) CONSTANT ('11'X);  /* DEVICE IS A 3125           */
*DCL DEV3135 BIT(8) CONSTANT ('12'X);  /* DEVICE IS A 3135           */
*DCL DEVSYS3 BIT(8) CONSTANT ('13'X);  /* DEVICE IS SYS 3            */
*DCL DEV2701 BIT(8) CONSTANT ('14'X);  /* DEVICE IS A 2701 OZ05270   */
*DCL DEV2703 BIT(8) CONSTANT ('15'X);  /* DEVICE IS A 2703 OZ05270   */
*DCL DEV3704 BIT(8) CONSTANT ('16'X);  /* DEVICE IS A 3704           */
*DCL DEV3705 BIT(8) CONSTANT ('17'X);  /* DEVICE IS A 3705           */
*DCL DEV2980 BIT(8) CONSTANT ('18'X);  /* DEVICE IS A 2980           */
*DCL DEV3277 BIT(8) CONSTANT ('19'X);  /* DEVICE IS A 3277           */
*DCL DEV3284 BIT(8) CONSTANT ('1A'X);  /* DEVICE IS A 3284           */
*DCL DEV3286 BIT(8) CONSTANT ('1B'X);  /* DEVICE IS A 3286           */
*DCL DEV3275 BIT(8) CONSTANT ('1C'X);  /* DEVICE IS A 3275           */
*DCL DEV3741 BIT(8) CONSTANT ('1D'X);  /* DEVICE IS A 3741           */
*DCL DEV3747 BIT(8) CONSTANT ('1E'X);  /* DEVICE IS A 3747           */
*DCL DEVMTA  BIT(8) CONSTANT ('28'X);  /* DEVICE IS AN MTA           */
*DCL DEV2972 BIT(8) CONSTANT ('33'X);  /* DEVICE IS A 2972           */
*DCL DEV3271 BIT(8) CONSTANT ('34'X);  /* DEVICE IS A 3271           */
*DCL DEV3272 BIT(8) CONSTANT ('36'X);  /* DEVICE IS A 3272           */
*DCL DEVCC   BIT(8) CONSTANT ('35'X);  /* DEVICE IS A PHYSICAL UNIT  */
*DCL DEV1052 BIT(8) CONSTANT ('64'X);  /* DEVICE IS A 1052           */
*DCL DEV1053 BIT(8) CONSTANT ('65'X);  /* DEVICE IS A 1053           */
*DCL DEV1054 BIT(8) CONSTANT ('66'X);  /* DEVICE IS A 1054           */
*DCL DEV1055 BIT(8) CONSTANT ('67'X);  /* DEVICE IS A 1055           */
*DCL DEV1056 BIT(8) CONSTANT ('68'X);  /* DEVICE IS A 1056           */
*DCL DEV1057 BIT(8) CONSTANT ('69'X);  /* DEVICE IS A 1057           */
*DCL DEV1058 BIT(8) CONSTANT ('6A'X);  /* DEVICE IS A 1058           */
*DCL DEV1092 BIT(8) CONSTANT ('6B'X);  /* DEVICE IS A 1092           */
*DCL DEV1093 BIT(8) CONSTANT ('6C'X);  /* DEVICE IS A 1093           */
*DCL DEVLU   BIT(8) CONSTANT ('6D'X);  /* DEVICE IS A LOGICAL UNIT   */
*DCL DEV545  BIT(8) CONSTANT ('78'X);  /* DEVICE IS A 545            */
*DCL DEV1017 BIT(8) CONSTANT ('79'X);  /* DEVICE IS A 1017           */
*DCL DEV1018 BIT(8) CONSTANT ('7A'X);  /* DEVICE IS A 1018           */
*DCL DEV2203 BIT(8) CONSTANT ('7B'X);  /* DEVICE IS A 2203           */
*DCL DEV2213 BIT(8) CONSTANT ('7C'X);  /* DEVICE IS A 2213           */
*DCL DEV2265 BIT(8) CONSTANT ('7D'X);  /* DEVICE IS A 2265           */
*DCL DEV2502 BIT(8) CONSTANT ('7E'X);  /* DEVICE IS A 2502           */
*DCL DEV50   BIT(8) CONSTANT ('7F'X);  /* DEVICE IS A 50             */
*DCL DEV1255 BIT(8) CONSTANT ('80'X);  /* DEVICE IS A 1255           */
*DCL DEV5496 BIT(8) CONSTANT ('81'X);  /* DEVICE IS A 5496           */
*/* MODEL CODES */                                                 1158
*DCL DEVMOD1 BIT(8) CONSTANT ('00'X);  /* MODEL 1                    */
*DCL DEVMOD2 BIT(8) CONSTANT ('01'X);  /* MODEL 2                    */
*/*              RESOURCE DEFINITION TABLE                           */
*/*  REVISIONS                                         013 07/01/75  */
*DCL                                                               1160
*1  ISTRPRE BDY(WORD) BASED,     /* COMMON PREFIX                    */
*   2  RPRNAME  CHAR(8),         /* RESOURCE NAME                    */
*   2  RPRCOMID FIXED(31),       /* COMMUNICATION ID                 */
*      3  RPRSAF BIT(16),        /* SOURCE ADDRESS FIELD             */
*      3  RPRDAF BIT(16),        /* DESTINATION ADDRESS FIELD-       */
*                             /* CONTAINS DAF OF CTERM IN PORT ENTRY */
*   2  RPRRLOCK CHAR(LENGTH(ISTLOK)),  /* RESOURCE LOCK              */
*   2  RPRELEN  FIXED(15),       /* CURRENT ENTRY LENGTH             */
*   2  RPRPELEN FIXED(15),       /* PREVIOUS ENTRY LENGTH            */
*   2  RPRENTRY BIT(8),          /* FLAG FIELD 1 (ENTRY TYPE)        */
*   2  RPRFLAGA BIT(8),                                            1160
*      3  RPRACT BIT(1),         /* ACTIVE                           */
*      3  RPRINV BIT(1),         /* INVALID                          */
*      3  RPRTIED BIT(1),        /* TIED                             */
*      3  RPRENTBF BIT(1),       /* BUFFER TRACE THIS NODE           */
*      3  RPRENTIO BIT(1),       /* RESERVED                         */
*      3  RPRENTED BIT(1),       /* LAST ENTRY IN RDT SEGMENT        */
*      3  RPRVRYPD BIT(1),       /* VARY PENDING ON ENTRY            */
*      3  RPRLIVE  BIT(1),       /* RESOURCE IS LIVE                 */
*   2  RPRFLAGB BIT(8),          /* FLAG FIELD                       */
*      3  RPRENTVH BIT(1),       /* WHEN 1, ENTRY IS A VTAM HEADER   */
*      3  RPRENTVT BIT(1),       /* WHEN 1, ENTRY IS VTAM            */
*      3  RPRAOPN BIT(1),        /* NODE OPENABLE BY APPLICATION     */
*      3  RPRVIODN BIT(1),       /* VARY I/O HAS BEEN DONE           */
*      3  RPRONLIN BIT(1),       /* NODE VARIED ONLINE               */
*      3  RPRHLVPD BIT(1),       /* VARY PENDING IN HIGHEST        1160
*                                   LEVEL NODE                       */
*      3  RPRVYIMM BIT(1),       /* VARY IMMEDAITE ISSUED FOR NODE   */
*      3  RPRINTST BIT(1),       /* DEVICE IN TEST MODE              */
*   2  RPRCAUSE BIT(8),          /* FLAGS INDICATING CAUSE OF ENTRY
*                                                      INVALIDATION  */
*      3  RPRNOSRT BIT(1),       /* RPRINV SET BECAUSE NO SRTE BUILT */
*      3  RPRCRCPT BIT(1),       /* C/R CHECKPOINT ACTIVE 1=ACTIVE   */
*      3  RPRRSYNC BIT(1),       /* C/R RE-SYNC ON FIRST I/O         */
*                                /* REQUIRED: 1=YES                  */
*      3  RPRRSV03 BIT(5),       /* RESERVED                         */
*   2  RPRPEPCT FIXED(15),       /* VARY PENDING COUNTER             */
*   2  RPRTIOCT FIXED(8),        /* I/O TRACE COUNT                  */
*   2  RPRHDTYP BIT(8),          /* HEADER TYPE                      */
*   2  RPRLGONF PTR(31),         /* SIM. LOGON CHAIN FORWARD PTR     */
*   2  RPRLGONB PTR(31),         /* SIM. LOGON CHAIN BACKWARD PTR    */
*   2  RPRNSNEA PTR(31),         /* NEXT SCHEDULABLE NODE ENTRY ADDR */
*   2  RPRNCBA PTR(31),          /* ADDR OF ASSOCIATED NCB FOR     1160
*                                    OPENED NODES                    */
*   2  RPRDEVCH CHAR(LENGTH(ISTDEVCH)),  /* DEVICE CHARACTERISTICS   */
*   2  RPRRVPT1 PTR(31),         /* RESERVED                         */
*   2  RPRSTPCT FIXED(15),       /* COUNT OF SHOULDER TAPS           */
*   2  RPRSWDAF BIT(16),         /* SWITCHED DAF                     */
*   2  RPRPTHCT FIXED(8),        /* COUNT OF AVAILABLE PATHS       1160
*                                   TO THIS DEVICE                   */
*   2  RPRFLAGD CHAR(1),         /* FLAG BYTE                        */
*      3 RPRLTASN BIT(1),        /* LINE TRACE ACTIVE = 1            */
*      3 RPRCONCT BIT(1),        /* PHYSICAL CONNECTION EXISTS       */
*      3 RPRRSON  BIT(1),        /* RESET ONLINE                     */
*      3 RPRACTP  BIT(1),        /* ACTIVATE IN PROGRESS             */
*      3 RPRCONP  BIT(1),        /* CONTACT IN PROGRESS              */
*      3 RPRRSV05 BIT(2),        /* RESERVED                         */
*      3 RPRINIMM BIT(1),        /* ON=INACTIVATE IMMED. IN PROGRESS */
*   2  RPRFLAGC BIT(8),          /* FLAG FIELD                       */
*      3  RPRCLVPD BIT(1),       /* THIS ENTRY HAS BEEN CLOSED       */
*   2  RPRCONID CHAR(9);         /* CONTROL BLOCK ID                 */
*                                                                  1160
*                                                                  1160
*/* RPRENTRY - FOLLOWING EQUATES ARE FOR THE VARIOUS ENTRY TYPES     */
*DCL RPRENTCM BIT(8) CONSTANT('90'X);  /* ENTRY IS A COMPONENT       */
*DCL RPRENTIN BIT(8) CONSTANT('82'X);  /* ENTRY IS INTERMEDIATE NODE */
*DCL RPRENTTR BIT(8) CONSTANT('80'X);  /* ENTRY IS A TERMINAL        */
*DCL RPRENTUT BIT(8) CONSTANT('75'X);  /* ENTRY IS UTERM             */
*DCL RPRENTCL BIT(8) CONSTANT('70'X);  /* ENTRY IS A CLUSTER         */
*DCL RPRENTLN BIT(8) CONSTANT('50'X);  /* ENTRY IS A LINE            */
*DCL RPRENTLH BIT(8) CONSTANT('03'X);  /* ENTRY IS A LOCAL HEADER    */
*DCL RPRENTGP BIT(8) CONSTANT('30'X);  /* ENTRY IS A GROUP           */
*DCL RPRENTLC BIT(8) CONSTANT('45'X);  /* ENTRY IS A LOCAL DEVICE    */
*DCL RPRENTAH BIT(8) CONSTANT('02'X);  /* ENTRY IS APPLICATION HEADER*/
*DCL RPRENTAP BIT(8) CONSTANT('55'X);  /* ENTRY IS APPLICATION       */
*DCL RPRENTDS BIT(8) CONSTANT('20'X);  /* ENTRY IS LCDO            1172
*                                         (DIALSET)                  */
*DCL RPRENTRN BIT(8) CONSTANT('01'X);  /* ENTRY IS THE RN            */
*DCL RPRENTCC BIT(8) CONSTANT('71'X);  /* ENTRY IS A PU              */
*DCL RPRENTLU BIT(8) CONSTANT('81'X);  /* ENTRY IS LOGICAL UNIT      */
*DCL RPRENTSW BIT(8) CONSTANT('04'X);  /* ENTRY IS SWITCHED          */
*                                      /* SUBAREA HEADER             */
*DCL RPRENTLS BIT(8) CONSTANT('05'X);  /* ENTRY IS LOCAL             */
*                                      /* SUBAREA HEADER             */
*DCL RPRENTPX BIT(8) CONSTANT('72'X);  /* ENTRY IS A PUX             */
*DCL RPRENTLX BIT(8) CONSTANT('10'X);  /* ENTRY IS A LUX             */
*DCL RPRENTDA BIT(8) CONSTANT('51'X);  /* ENTRY IS A DAN             */
*                                                                  1180
*                                                                  1180
*/* THE FOLLOWING IS A PREFIX FOR ALOCATION ENTRIES                  */
*/*   ISTRCL-CLUSTER,ISTRTR-TERMINAL,ISTRCM-COMPONENT                */
*                                                                  1181
*DCL                                                               1181
*1  ISTRCPRE BDY(WORD) BASED,    /* LEVEL 1 DECLARE                  */
*   2  RCPPRE  CHAR(LENGTH(ISTRPRE)),      /* COMMON PREFIX          */
*   2  RCPICELN PTR(31),         /* PTR LOGON ICE QUEUE              */
*   2  RCPLNAPA PTR(31),         /* PTR APLICATION ENTRY FOR SIMLOGON*/
*   2  RCPICEAQ PTR(31),         /* PTR ACQUIRE ICE QUEUE            */
*   2  RCPACETR PTR(31),         /* PTR ACE QUEUE                    */
*   2  RCPBHSI1 CHAR(1),         /* GEN'D BHSET ID                   */
*   2  RCPBHSI2 CHAR(1),         /* OVERRIDING BHSET ID SPECIFIED  1181
*                                   BY USER                          */
*   2  RCPBFLIM PTR(8),          /* BUFFER LIMIT                     */
*   2  RCPPMODE CHAR(1),         /* PERMISSABLE MODES                */
*      3 RCPRBASC BIT(1),        /* 1= BASIC OK                      */
*      3 RCPRRECD BIT(1),        /* 1= RECORD OK                     */
*      3 *        BIT(6),        /* RESERVED                         */
*   2  RCPLGNIN CHAR(20) BDY(WORD), /* INIT LOGON DATA               */
*      3 RCPLGNAP CHAR(8),       /* APPL FOR VTAM SIMLOGON           */
*      3 RCPLGNCT CHAR(8),       /* NAME OF LOGON CHAR TABLE         */
*      3 RCPINTA  PTR(31),       /* ADDR OF INTERPRET TABLE          */
*   2  RCPRSV03 PTR(31),         /* RESERVED FOR C/R                 */
*   2  RCPRSV04 PTR(31),         /* RESERVED FOR C/R                 */
*   2  RCPRSV05 PTR(31);         /* RESERVED FOR C/R                 */
*                                                                  1181
*                                                                  1181
*DCL                                                               1182
*1  ISTRDT BDY(WORD) BASED,      /* LEVEL 1 DECLARE                  */
*   2  RDTPRE CHAR(LENGTH(ISTRPRE)), /* ENTRY PREFIX                 */
*   2  RDTPLEN CHAR(4)BDY(WORD), /* PRIORITY AND LENGTH FIELD        */
*      3  RDTPRIOR,              /* DETERMINES SEGMENT TYPE          */
*         4  * BIT(3),           /*    NOT USED                      */
*         4  RDTPRIAP BIT(1),    /*    APPLICATION SEGMENT           */
*         4  RDTPRILC BIT(1),    /*    LOCAL SEGMENT                 */
*         4  RDTPRIRN BIT(1),    /*    RN SEGMENT                    */
*         4  RDTPRISW BIT(1),    /*    SWITCHED SEGMENT              */
*         4  RDTPRILS BIT(1),    /*    LOCAL SUBAREA SEGMENT         */
*      3  RDTLEN FIXED(24),      /* LENGTH OF RDT                    */
*   2  RDTFORW PTR(31),          /* FOREWARD POINTER                 */
*   2  RDTBACK PTR(31),          /* BACKWARD POINTER                 */
*   2  RDTFLAGS BIT(16),         /* SEGMENT FLAGS,UNUSED/REUSED      */
*   2  RDTCTSNT FIXED(15),       /* COUNT OF SNT ENTRIES FOR       1182
*                                   SEGMENT                          */
*   2  RDTMAXID PTR(8),          /* MAXIMUM NODE ID FOR            1182
*                                   NETWORK                          */
*   2  RDTNODID PTR(8),          /* NODE ID FOR THIS SEGMENT         */
*   2  RDTLGCT  PTR(8),          /* COUNT OF LOGONS OUTSTANDING      */
*   2  RDTFLAGB BIT(8),          /* FLAG BYTE                        */
*      3 RDTOUERP BIT(1),        /* 1 = REPEAT ERP                   */
*      3 RDTPRGDN BIT(1),        /* 1 = PURGE ISSUED                 */
*      3 RDTCTPGD BIT(1),        /* 1 = CONTACT PURGED               */
*      3 RDTCTCFL BIT(1),        /* HIGHER FAILURE-CONTACT FLUSHED   */
*      3 RDTBHSET BIT(1),        /* BHSET REQUIRED                   */
*      3 RDTRSV01 BIT(3),        /* RESERVED                         */
*   2  RDTVPAB  PTR(31),         /* ADDR OF VARY PAB                 */
*   2  RDTEPAB  PTR(31),         /* ADDR OF ERP PAB                  */
*   2  RDTDPAB  PTR(31),         /* ADDR OF DUMP/LOAD/RESTART PAB    */
*   2  RDTTPAB  PTR(31),         /* TOLTEP SSCP PAB                  */
*   2  RDTVYRPH PTR(31),         /* @ OF VARY RPH WAITING            */
*                                /* FOR RESTART COMPLETION           */
*      3 RRNVYRPH PTR(31),       /* DELETE ALIAS IN NEXT             */
*                                /* FIRST SNA/2 BUILD                */
*   2  RDTSTCNT PTR(8),          /* ACTIVE SUBNODE COUNT             */
*      3 RRNSTCNT PTR(8),        /* DELETE ALIAS IN NEXT             */
*                                /* FIRST SNA/2 BUILD                */
*   2  *        CHAR(3),         /* RESERVED                         */
*   2  RDTCRSDS CHAR(8),         /* C/R DATA SET IDENTIFIER          */
*                                /* BLANK IMPLIES NOT SPECIFIED      */
*   2  RDTCRSPW CHAR(8),         /* C/R DATASET PASSWORD             */
*                                /* BLANK IMPLIES NOT SPECIFIED      */
*   2  RDTVSRPL PTR(31);         /* C/R PTR TO VSAM RPL              */
*                                                                  1182
*                                                                  1182
*DCL                                                               1183
*1  ISTRAP BDY(WORD) BASED,      /* APPLICATION ENTRY                */
*   2  RAPPRE CHAR(LENGTH(ISTRPRE)), /*  USE ISTRPRE DSECT           */
*   2  RAPACBA PTR(31),          /*   POINTER TO ACB                 */
*   2  RAPACDEB PTR(31),         /*  POINTER TO ACBDEB               */
*   2  RAPAPPWD CHAR(8),         /* APPLICATION PASSWORD             */
*   2  RAPICELG PTR(31),         /* ANCHOR FOR LOGON ICE TO APLICATION*
*   2  RAPICEAC PTR(31),         /* ANCHOR ACEPT ICE FOR APPLICATION */
*   2  RAPICEAQ PTR(31),         /*  ANCHOR ACQUIRE ICE BY APPLI     */
*   2  RAPACEAP PTR(31),         /* ANCHOR FOR APPLICATION ACES      */
*   2  RAPTRPRE FIXED(15),       /* COUNT OF PREMPTED TERMINALS      */
*   2  RAPACEQD FIXED(15),       /* COUNT OF ACES QUEUED             */
*   2  RAPFLG BIT(8),            /*  FLAG FIELD                      */
*      3 RAPABLGN BIT(1),        /*  PERMANENTLY BLOCK LOGONS BIT    */
*      3 RAPAQUI BIT(1),         /* QUIESCE IN PROCESS               */
*      3 RAPASLGI BIT(1),        /*  APPLICATION FIRST TIME LOGON  1183
*                                    ISSUED FLAG                     */
*      3 RAPATLGN BIT(1),        /*  TEMPORARILY BLOCK LOGONS BIT    */
*      3 RAPRSV03 BIT(1),        /*  RESERVED                        */
*      3 RAPRSV04 BIT(1),        /*  RESERVED                        */
*      3 RAPRSV05 BIT(1),        /*  RESERVED                        */
*      3 RAPRSV06 BIT(1),        /*  RESERVED                        */
*   2  RAPFLGB BIT(8),           /* AUTHORIZATION FLAGS              */
*      3 RAPALLF BIT(1),         /* ALL FUNCTIONS AUTH.              */
*      3 RAPABLCK BIT(1),        /* BLOCK I/O AUTH.                  */
*      3 RAPAPASS BIT(1),        /* PASS AUTH.                       */
*      3 RAPAPRMT BIT(1),        /* PREEMPT AUTH.                    */
*      3 RAPAACQ BIT(1),         /* ACQUIRE AUTH.                    */
*      3 RAPAPPO  BIT(1),        /* RNO PPO (PRIMARY PROGRAM AUTH    */
*      3 RAPASPO  BIT(1),        /* RNO SPO (SECONDARY PROGRAM AUTH  */
*      3 RAPANVPC BIT(1),        /* NO VSPACE AUTHORIZED             */
*   2  RAPFLGC BIT(8),           /* AUTHORIZATION FLAGS RESERVED     */
*      3 RAPRSV10 BIT(1),        /*  RESERVED                        */
*      3 RAPRSV11 BIT(1),        /*  RESERVED                        */
*      3 RAPRSV12 BIT(1),        /*  RESERVED                        */
*      3 RAPRSV13 BIT(1),        /*  RESERVED                        */
*      3 RAPRSV14 BIT(1),        /*  RESERVED                        */
*      3 RAPRSV15 BIT(1),        /*  RESERVED                        */
*      3 RAPRSV16 BIT(1),        /*  RESERVED                        */
*      3 RAPRSV17 BIT(1),        /*  RESERVED                        */
*   2  RAPBFACT PTR(8),          /* BUFFER LIMIT FACTOR              */
*   2  RAPRVPT1 PTR(31),         /*  RESERVED                        */
*   2  RAPRVPT2 PTR(31);         /*  RESERVED                        */
*                                                                  1183
*                                                                  1183
*DCL                                                               1184
*1  ISTRLC BDY(WORD) BASED,      /* LOCAL ENTRY                      */
*   2  RLCPRE CHAR(LENGTH(ISTRPRE)),  /* COMMON PREFIX               */
*   2  RLCADR PTR(31),                                             1184
*      3  RLCFLAG BIT(8),        /* FLAG BYTE                        */
*         4  RLCRSV22 BIT(1),    /* RESERVED                         */
*         4  RLCRBISA BIT(1),    /* INITIAL STATUS - 1 = ACTIVE      */
*         4  RLCRSV14 BIT(3),    /* UNUSED/RESERVED                  */
*         4  RLCACNT BIT(1),     /* MESSAGE BLOCK ACCEPTED           */
*         4  RLCRSVDE BIT(2),    /* RESERVED                         */
*      3  RLCUCBAD PTR(24),      /* UCB /PUB ADDRESS                 */
*   2 RLCLCCUA CHAR(3),          /* DEVICE CHANNEL UNIT ADDR         */
*   2 RLCRVPT1 CHAR(1),          /* RESERVED                         */
*   2 RLCRVPT2 PTR(31);          /* RESERVED                         */
*                                                                  1184
*                                                                  1184
*DCL                                                               1185
*1  ISTRRN BDY(WORD) BASED,      /* RN ENTRY                         */
*   2  RRNPRE CHAR(LENGTH(ISTRDT)),  /*  USE ISTRDT DSECT            */
*   2  RRNADR PTR(31),                                             1185
*      3  RRNFLAG BIT(8),                                          1185
*         4  RRNRSV89 BIT(1),    /* RESERVED                         */
*         4  RRNRBISA BIT(1),    /* INITIAL STATUS 1 = ACTIVE        */
*         4  RRNLCSIP BIT(1),    /* NODE BEING ACTIVATED             */
*         4  RRNLCDIE BIT(1),    /* HIGHER NODE NOT SUCCESFULLY      */
*                                /*             ACTIVATED            */
*         4  RRNLCDIP BIT(1),    /* NODE BEING DEACTIVATED           */
*         4  RRNERPIP BIT(1),    /* ERP IN PROCESS                   */
*         4  RRNDSTCT BIT(1),    /* DEACT TO DECREMENT STCNT         */
*         4  RRNRSV11 BIT(1),    /* UNUSED/RESERVED                  */
*      3  RRNUCBAD PTR(24),      /* UCB/PUB ADDR                     */
*         4 RRNCHQI  BIT(8),     /* CHANNEL QUEUE INDEX              */
*         4 RRNLUBA  PTR(16),    /* DESCRIBE ENTRY IN PUB            */
*                                /* OWNERSHIP TABLE                  */
*   2  RRNGRPA PTR(31),          /* POINTER TO FIRST GROUP ENTRY     */
*   2  RRNRNCUA CHAR(3),         /* CHANNEL UNIT ADDR                */
*   2  RRNRLDIP FIXED(8),        /* REMOTE LOAD/DUMP IN PROG. COUNT  */
*   2  RRNTRENT PTR(31),         /* ADDR TERM ENTRY IN LOCAL         */
*   2  RRNBHSET PTR(31),         /* POINTER TO TABLE OF BHSET NAMES  */
*   2  RRNCTBHS FIXED(15),       /* COUNT OF BHSET NAMES IN RRNBHSET */
*   2  RRNCTEGP FIXED(15),       /* COUNT OF GROUP ENTRIES FOR RN    */
*   2  RRNCTELI FIXED(15),       /* COUNT OF LINE ENTRIES FOR RN     */
*   2  RRNCTECL FIXED(15),       /* COUNT OF CLUSTER ENTRIES FOR RN  */
*   2  RRNCTETR FIXED(15),       /* COUNT OF TERMINAL ENTRIES FOR RN */
*   2  RRNCTEIN FIXED(15),       /* COUNT OF INT. NODE ENTRIES FOR RN*/
*   2  RRNCTECM FIXED(15),       /* CNT OF COMPONENT ENTRIES FOR RN  */
*   2  RRNCTENT FIXED(15),       /* # ALL ENTRIES IN 370X RDT SEGMENT*/
*   2  RRNRDF CHAR(4),           /*  RESOURCE DEFINITION FLAG        */
*      3  RRNRDFA  BIT(8),       /* FLAGS (WORD 1 BYTE 1)            */
*         4  RRNRASHT BIT(1),    /* AUTO NETWORK SHUTDOWN            */
*         4  RRNRAIPL BIT(1),    /* AUTO IPL ON RN FAILURE           */
*         4  RRNRADMP BIT(1),    /* AUTO DUMP ON RN FAILURE          */
*         4  RRNRASYN BIT(1),    /* C/R AUTOMATICALLY RESYNCHRONIZED */
*                                /* IF ALREADY LOADED NCP            */
*                                /* 0=NO, 1=YES                      */
*         4  RRNRAOLT BIT(1),    /* ON-LINE TERMINAL TEST            */
*         4  RRNRBREM  BIT(1),   /* REMOTE RN FLAG                   */
*         4  RRNRANCP BIT(1),    /* GENERATION TYPE NCP              */
*         4  RRNRAPEP BIT(1),    /* GENERATION TYPE PEP              */
*      3  RRNRDFB BIT(16),       /* FLAG FIELD B (RDF)               */
*         4  RRNRBMDL BIT(1),    /* (=1 IF 3705) ELSE 3704           */
*         4  RRNRSV02 BIT(1),    /* RESERVED                         */
*         4  RRNRBCCL BIT(1),    /* LOOSELY COUPLED CHANNEL          */
*         4  RRNRBCCT BIT(1),    /* TIGHTLY COUPLED CHANNEL          */
*         4  RRNRBSEC BIT(1),    /* SECONDARY CHANNEL EXIST          */
*         4  RRNRBCT1 BIT(1),    /* PRIM CHAN TYPE (0=TYPE1,1=TYPE2) */
*         4  RRNRBCT2 BIT(1),    /* SEC CHAN TYPE (0=TYPE1,1=TYPE2)  */
*         4  RRNRSV03 BIT(1),    /* RESERVED                         */
*         4  RRNRBBUP BIT(1),    /* BRINGUP IS TO BE EXERCISED     1185
*                                         FOR THIS RN DURING IPL     */
*         4  RRNVYDON BIT(1),    /* RDT SEG IS BEING FREED           */
*         4  RRNRSV01 BIT(5),    /* RESERVED                         */
*         4  RRNPTASL BIT(1),    /* SOME PORT SOLICITOR IS WAITING 1185
*                                   TO BE REDRIVEN BY CLSDST         */
*      3  RRNRSV55 CHAR(1),      /*  RESERVED                        */
*   2  RRNCMF CHAR(4),           /*  FLAG FIELDS FOR COMMANDS        */
*      3  RRNCMFA  BIT(8),       /* FLAG FIELD A -COMMANDS           */
*         4  RRNCAALL BIT(1),    /* PHYSICAL DISCONNECT              */
*         4  RRNCAATD BIT(1),    /* ACTIVATE DEVICE                  */
*         4  RRNCAATG BIT(1),    /* ACTIVATE GROUP                   */
*         4  RRNCAATI BIT(1),    /* ACTIVATE INVITES                 */
*         4  RRNCAMBH BIT(1),    /* MODIFY BLOCK HANDLER SET         */
*         4  RRNCACDT BIT(1),    /* CHANGE DATE AND TIME             */
*         4  RRNCADTD BIT(1),    /* DEACTIVATE DEVICE                */
*         4  RRNCADGO BIT(1),    /* DEACTIVATE GROUP ORDERLY         */
*      3  RRNCMFB  BIT(8),       /* FLAG FIELD B - COMMANDS          */
*         4  RRNCBDLO BIT(1),    /* DEACTIVATE LINE ORDERLY          */
*         4  RRNCBDLH BIT(1),    /* DEACTIVATE LINE HALT             */
*         4  RRNCBDLR BIT(1),    /* DISPLAY LINE RESOURCE ID         */
*         4  RRNCBRDS BIT(1),    /* REQUEST DEVICE STATUS            */
*         4  RRNCBRLS BIT(1),    /* REQUEST LINE STATUS              */
*         4  RRNCBNPL BIT(1),    /* CHANGE LINE NEG POLL RESPONSE LIM*/
*         4  RRNCBMOD BIT(1),    /* COPY/SET DESTINATION NODE        */
*         4  RRNCBALT BIT(1),    /*  ACTIVATE LINE TRACE             */
*      3  RRNCMFC  BIT(8),       /* FLAG FIELD C - COMMANDS          */
*         4  RRNCCRCN BIT(1),    /* RESET CONDITIONAL                */
*         4  RRNCCRDQ BIT(1),    /* RESET DEVICE QUEUE               */
*         4  RRNCCRST BIT(1),    /* REQUEST DEVICE STATISTICS        */
*         4  RRNCCCRC BIT(1),    /* CHANGE RETRY COUNTS              */
*         4  RRNCCRIM BIT(1),    /* RESET IMMEDIATE                  */
*         4  RRNCCRCM BIT(1),    /* RESET CONTROL MODE               */
*         4  RRNCCSIM BIT(1),    /* COPY/REPLACE SESSION INIT INFO   */
*         4  RRNCCCSL BIT(1),    /* CHANGE SESSION LIMIT             */
*      3  RRNCMFD  BIT(8),       /* FLAG FIELD D - COMMANDS          */
*         4  RRNCDCSP BIT(1),    /* CHANGE SERIVCE PAUSE             */
*         4  RRNCDSTD BIT(1),    /* DISPLAY STORAGE                  */
*         4  RRNCDDTL BIT(1),    /* CHANGE DEVICE TRANSMIT LIMIT     */
*         4  RRNCDBCK BIT(1),    /* SWITCHED NETWORK BACKUP          */
*         4  RRNCDDSI BIT(1),    /* COPY/REPLACE DEV SESSION INIT INFO*
*         4  RRNCDREC BIT(1),    /* RESET AT END OF COMMAND          */
*         4  RRNREMPO BIT(1),    /* REMOTE POWER OFF                 */
*         4 RRNRSV05  BIT(1),    /*       NOT  USED                  */
*   2  RRNFLUX  PTR(31),         /* POINTER TO FIRST LUX             */
*   2  RRNCPLUB CHAR(6),         /* SYMBOLIC UNIT NAME OF NCP DATASET*/
*   2  RRNEPADR PTR(15),         /* EP SUBCHANNEL ADDRESS            */
*   2  RRNNMDPD  CHAR(8),        /* FILENAME FOR DUMP DATA SET       */
*      3  RRNDPLUB CHAR(6),      /* LUB NAME FOR DUMP DATASET        */
*      3  RRNPUBI  BIT(8),       /* PUB INDEX                        */
*      3  RRNRSV88 CHAR(1),      /* RESERVED-DOS ONLY                */
*   2  RRNRSV04  CHAR(6),        /* RESERVED                         */
*   2  RRNDELAY  CHAR(2),        /* INITIAL VALUE FROM DELAY         */
*   2  RRNNMNCP  CHAR(8),        /* DSNAME FOR NCP LOAD MODULE       */
*   2  RRNHPRE PTR(16),          /* HOST PREFIX INFORMATION          */
*      3  RRNHLENH PTR(8),       /* LENGTH OF HOST HEADER PREFIX     */
*      3  RRNHLENT PTR(8),       /* LENGTH OF HOST TEXT PREFIX       */
*   2  RRNHBUFS FIXED(15),       /* SIZE OF BUFFER UNITS FOR HOST    */
*   2  RRNCTPCC PTR(8),          /* CNT OF BUFFERS RECEIVING PCCU DATA*
*   2  RRNNCPNM CHAR(7),         /* NAME OF NCP LOAD MOD 7 CHAR MAX  */
*   2  RRNMSIZE PTR(31),         /* MAX SIZE OF SEND                 */
*   2  RRNRPLPT PTR(31),         /* C/R POINTER TO RPL               */
*   2  RRNNCSPL PTR(31),         /* POINTER TO NCSPL                 */
*   2  RRNLASTE PTR(31),         /* PTR TO LAST ENTRY IN RN SEGMENT  */
*   2  RRNRDCUA CHAR(3),         /* DEFAULT CUA                      */
*   2  *        PTR(8),          /* RESERVED                         */
*   2  RRNRINNM CHAR(8);         /* DEFAULT INNODE NAME IN LOCAL   1185
*                                   RDT TO CONNECT REMOTE RN         */
*                                                                  1185
*DCL                                                               1186
*1  ISTRGP BDY(WORD) BASED,      /* GROUP ENTRY                      */
*   2  RGPPRE CHAR(LENGTH(ISTRPRE)),        /*  USE ISTRPRE DSECT    */
*   2  RGPFLG BIT(8),            /*  FLAG FIELD                      */
*      3  RGPADIL BIT(1),        /* =1 SWITCHED, =0 NON-SWIT         */
*      3  RGPASS  BIT(1),        /* START/STOP                       */
*      3  RGPABSC  BIT(1),       /* BINARY SYNCHRONOUS               */
*      3  RGPASDLC BIT(1),       /* DATA LINK CONTROL                */
*      3 RGPRSV02  BIT(4),       /*     NOT USED                     */
*   2  RGPRSV03 FIXED(8),        /* USED TO FORCE ALINEMENT          */
*   2  RGPCTELN FIXED(15),       /* COUNT OF LINE ENTRIES FOR GROUP  */
*   2  RGPCTECL FIXED(15),       /* CNT OF CLUSTER ENTRIES FOR GROUP */
*   2  RGPCTETR FIXED(15),       /* CNT TERMINAL ENTRIES FOR GROUP   */
*   2  RGPCTEIN FIXED(15),       /* COUNT OF INNODE ENTRIES FOR GROUP*/
*   2  RGPCTECM FIXED(15),       /* CNT COMPONENT ENTRIES FOR GROUP  */
*   2  RGPRVPT1 PTR(31),         /* RESERVED                         */
*   2  RGPRVPT2 PTR(31);         /* RESERVED                         */
*                                                                  1186
*                                                                  1186
*DCL                                                               1187
*1  ISTRLN BDY(WORD) BASED,      /* LINE ENTRY                       */
*   2  RLNPRE CHAR(LENGTH(ISTRPRE)), /* USE COMMON PREFIX            */
*   2  RLNADR PTR(31),                                             1187
*      3  RLNFLAG BIT(8),                                          1187
*         4  RLNEAM   BIT(1),    /* ENABLE ANSWER MODE DONE          */
*         4  RLNRBISA BIT(1),    /* INITIAL STATUS 1=ACTIVE          */
*         4  RLNRSV01 BIT(6),    /* RESERVED                         */
*      3  RLNUCBAD PTR(24),      /* UCB/PUB ADDRESS                  */
*         4  RLNCUA CHAR(3),     /* NOT USED                         */
*   2  RLNCTECL FIXED(15),       /* CNT OF CLUSTER ENTRIES FOR LINE  */
*   2  RLNCTETR FIXED(15),       /* CNT OF TERMINAL ENTRIES FOR LINE */
*   2  RLNCTEIN FIXED(15),       /* COUNT OF INNODE ENTRIES FOR LINE */
*   2  RLNCTECM FIXED(15),       /* CNT OF COMPONENT ENTRIES FOR LINE*/
*   2  RLNACTCT FIXED(15),       /* COUNT OF COMPONENTS, CLUSTERS  1187
*                                             AND TERMINALS ON LINE  */
*   2  RLNSTAT1 BIT(8),          /* LINK TRAP STATUS                 */
*      3 RLNTRAP  BIT(1),        /* INTERCEPT NEXT LINK OPERATION    */
*      3 RLNLRST  BIT(1),        /* LINK RESTART COND CAUSED TRAP    */
*      3 RLNINOPL BIT(1),        /* LINK INOP CONDITION CAUSED TRAP  */
*      3 RLNINOPP BIT(1),        /* PU INOP CONDITION CAUSED TRAP    */
*      3 RLNVD    BIT(1),        /* VARY INACT CONDITION CAUSED TRAP */
*      3 RLNRSV03 BIT(3),        /* RESERVED                         */
*    2 RLNSTAT2 BIT(8),          /* LINK NORMAL STATUS               */
*      3 RLNOHIN  BIT(1),        /* OFFHOOK REPORTED TO SW SUBAREA-  */
*                                /* REPLY DUE                        */
*      3 RLNINUSE BIT(1),        /* LINK RESOURCES ALLOCATED TO PU   */
*      3 RLNRSV04 BIT(6),        /* RESERVED                         */
*   2  RLNRDF CHAR(4),           /*  RESOURCE DEFINITION FLAG        */
*      3  RLNRDFA  BIT(8),       /* FLAGS FIELD A                    */
*         4  RLNRACNT BIT(2),    /*  NEXT TWO FIELDS                 */
*            5  RLNRACAT BIT(1), /* CALL INITIATOR-TERMINAL          */
*            5  RLNRACAN BIT(1), /* CALL INITIATOR-NCP               */
*         4  RLNGANSW BIT(1),    /* C/R GENNED IN ANSWER MODE, 1=YES */
*         4  RLNPORT  BIT(1),    /* THIS IS A PORT ENTRY             */
*         4  RLNIDV   BIT(1),    /* THIS IS AN ID VERIFIED PORT      */
*         4  RLNRAEP  BIT(1),    /* TYPE IS EP                       */
*         4  RLNRANCP BIT(1),    /* TYPE IS NCP                      */
*         4  RLNRAPEP BIT(1),    /* TYPE IS PEP                      */
*      3  RLNRDFB  BIT(8),       /* FLAGS FIELD B                    */
*         4  RLNRBUSE BIT(1),    /* EP/NCP USE  1=NCP                */
*         4  RLNANSWR BIT(1),    /* ON = SEND ENABLE ANSWER          */
*                                /* AT ACTIVATE                      */
*         4  RLNAUTOD BIT(1),    /* ON=AUTODIAL, OFF=MANUAL          */
*         4  RLNRSV0B BIT(1),    /* RESERVED                         */
*         4  RLNTTV   BIT(1),    /* THIS IS TERM TYPE VERIFICATION 1187
*                                   PORT                             */
*         4  RLNRAPOL BIT(1),    /* POLLED LINE                      */
*         4  RLNRATRN BIT(1),    /* SDLC LINE                        */
*         4  RLNMULTP BIT(1),    /* 0 = POINT TO POINT,            1187
*                                   1 = MULTI POINT                  */
*      3  RLNRDFC  BIT(8),       /* FLAGS FIELD C - LINE CODES       */
*                                /* SEE CONSTANTS FOR DEFINITION     */
*      3  RLNRDFD  BIT(8),       /* FLAGS FIELD D - RESERVED         */
*   2  RLNAUTOA FIXED(15),       /* AUTOCALL ADDRESS                 */
*   2  RLNRDSLM FIXED(8),        /* SCHED. LIM BASED ON LINE SPEED 2-4*
*   2  RLNCTSES FIXED(8),        /* COUNT OF CONCURRENT SESSIONS     */
*   2  RLNACTRM PTR(8),          /* COUNT OF ACTIVE REMOTES FOR THIS
*                                   TRUNK                            */
*   2  RLNRESV1 BIT(8),          /* RESERVED/UNUSED                  */
*   2  RLNACTSN FIXED(15),       /* COUNT ACTIVE NODES ON LINK       */
*   2  RLNPOLMT FIXED(8),        /* NEG POLL RESPONSE LIMIT          */
*   2  RLNPAUSE FIXED(8),        /* POLL DELAY/PAUSE                 */
*   2  RLNCRFLG BIT(8),          /* FLAG-CONFIGURATION RESTART       */
*      3 RLNACTLN BIT(1),        /* ACTIVATE LINK OK                 */
*      3 RLNSWNCP BIT(1),        /* SWITCH PEP LINE TO NCP OK        */
*      3 RLNLSCMD BIT(3),        /* LINE SCHEDULING COMMANDS       1187
*                                   ISSUED OK                        */
*        4 RLNNPRLM BIT(1),      /* CHNG NEG POLL RESP LIMIT OK      */
*        4 RLNSESLM BIT(1),      /* CHNG SESSION LIMIT OK            */
*        4 RLNSVSKP BIT(1),      /* CHNG SERVICE SEEK PAUSE OK       */
*      3 RLNSWEP  BIT(1),        /* SWITCH TO EP                     */
*      3 RLNCRRSV BIT(2),        /* RESERVED FOR CONFIG RESTART      */
*   2  *        CHAR(1),         /* RESERVED                         */
*   2  RLNX2SW  PTR(31),         /* ADDRESS OF 370X TO SWITCH        */
*                                /* COMMUNICATION NCSPL              */
*   2  RLNNCSPL PTR(31),         /* ADDRESS OF SPIN-OFF NCSPL        */
*                                /* FOR VARY DEACTIVATE              */
*   2  RLNRVPT2 PTR(31);         /* RESERVED                         */
*                                                                  1187
*                                                                  1187
*DCL RLNRCEDC BIT(8) CONSTANT('01'X);  /* EBCDIC (CONSTANTS)         */
*DCL RLNRCUSA BIT(8) CONSTANT('02'X);  /* USASCII                    */
*DCL RLNRCBCD BIT(8) CONSTANT('03'X);  /* BCD                        */
*DCL RLNRCEBC BIT(8) CONSTANT('04'X);  /* EBCD                       */
*DCL RLNRCCOR BIT(8) CONSTANT('05'X);  /* COR                        */
*DCL RLNRCKAT BIT(8) CONSTANT('06'X);  /* KATAKANA                   */
*DCL RLNRCIT2 BIT(8) CONSTANT('08'X);  /* ITA2                       */
*DCL RLNRCZS3 BIT(8) CONSTANT('09'X);  /* ZSC3                       */
*                                                                  1195
*                                                                  1195
*DCL                                                               1196
*1  ISTRPT BDY(WORD) BASED,        /* PORT ENTRY                     */
*   2 RPTLN CHAR(LENGTH(ISTRLN)),  /* INCLUDE LINE ENTRY             */
*   2 RPTLNCID BDY(WORD) CHAR(4),  /* COMM ID OF LINE                */
*     3 RPTLNSAF CHAR(2),          /* SAF                            */
*     3 RPTLNDAF CHAR(2),          /* DAF                            */
*   2 RPTCTNM CHAR(8),             /* CTERM NAME                     */
*   2 RPTDITT PTR(31),             /* POINTER TO DITT TABLE          */
*     3 RPTDIVT PTR(31),           /* POINTER TO DIVT TABLE          */
*   2 RPTATERM PTR(31),            /* POINTER TO ASSOCIATED ENTRY    */
*   2 RPTUTERM PTR(31),            /* POINTER TO UTERM ENTRY         */
*   2 RPTFLAG1 CHAR(1),            /* PORT SOLICITOR FLAGS           */
*     3  RPTASLEP BIT(1),          /* THIS PORT SOLICITOR IS WAITING
*                                     TO BE REDRIVEN BY CLSDST       */
*     3 RPTVRYPD BIT(1),           /* VARY PENDING IN THIS CTERM     */
*     3 RPTHLVPD BIT(1),           /* VARY PENDING IN HIGHER LEVEL 1196
*                                     NODE                           */
*     3 RPTONLIN BIT(1),           /* ONLINE/OFFLINE(VARY)           */
*     3 RPTVIODN BIT(1),           /* I/O DONE FOR THIS NODE         */
*     3 RPTVYIMM BIT(1),           /* VARY IMM ISSUED FOR PORT       */
*     3 RPTDYNAM BIT(1),           /* BHSET = DYNAMIC                */
*     3 RPTISTAT BIT(1),           /* CTERM(PORT) IS INITIALLY ACTIVE*/
*                                  /* 1 = YES                        */
*   2 RPTRSV01 CHAR(1),            /* RESERVED                       */
*   2 RPTDAFSV BIT(16),            /* SAVE TERMINAL DAF              */
*   2 RPTPEPCT FIXED(15),          /* PEP COUNT FOR CTERM            */
*   2 RPTPTHCT FIXED(15),          /* PATH COUNT FOR CTERM           */
*   2 RPTNSNSV PTR(31),            /* SAVE TERMINAL NEXT SCHED NODE
*                                     POINTER                        */
*   2  RPTRSV02 PTR(31),           /* RESERVED                       */
*   2  RPTRSV03 PTR(31);           /* RESERVED                       */
*                                                                  1196
*                                                                  1196
*DCL                                                               1197
*1  ISTRCL BDY(WORD) BASED,      /* CLUSTER ENTRY                    */
*   2  RCLPRE CHAR(LENGTH(ISTRPRE)),    /* USE COMMON PREFIX         */
*   2  RCLADR PTR(31),                                             1197
*      3  RCLFLAG BIT(8),                                          1197
*         4  RCLRSV22 BIT(1),    /* RESERVED                         */
*         4  RCLRBISA BIT(1),    /* INITIAL STATUS 1=ACTIVE          */
*         4  RCLBATCH BIT(1),    /* BATCHED MESSAGE INPUT          1197
*                                   FEATURE                          */
*         4  RCLRSV33 BIT(5),    /* RESERVED                         */
*      3  RCLGPADR PTR(24),      /* ADDRESSING INFORMATION POINTER 1197
*                                                  (ADDR RCLCNGP)    */
*   2  RCLCTETR FIXED(15),       /* CNT TERMINAL ENTRIES FOR CLUSTER */
*   2  RCLCTECM FIXED(15),       /* CNT COMPONENT ENTRIES FOR CLUSTER*/
*   2  RCLRSV01 FIXED(15),       /* FILLER TO FORCE ALIGNMENT        */
*   2  RCLCTNGP FIXED(15),       /* GPOLL CHARACTER COUNT            */
*   2  RCLGPOLA PTR(31),         /* GPOLL CHARACTER STRING POINTER   */
*   2  RCLRVPT1 PTR(31),         /* RESERVED                         */
*   2  RCLRVPT2 PTR(31);         /* RESERVED                         */
*                                                                  1197
*                                                                  1197
*DCL                                                               1198
*1  ISTRTR BDY(WORD) BASED,      /* TERMINAL AND/OR COMPONENT ENTRY  */
*   2  RTRCRPR CHAR(LENGTH(ISTRCPRE)),     /* USE ISTRCPRE DSECT     */
*   2  RTRADR PTR(31),                                             1198
*      3  RTRFLAG BIT(8),                                          1198
*         4  RTRRSV21 BIT (1),   /* RESERVED */                    1198
*         4  RTRRBISA BIT(1),    /* INITIAL STATUS 1 = ACITVE        */
*         4  RTRRSV51 BIT(3),    /* RESERVED                         */
*         4  RTRVTERM BIT(1),    /* VTERM TERMINAL ENTRY             */
*         4 RTRRSV22 BIT(2),     /* UNUSED                           */
*      3  RTRADRPT PTR(24),      /* TO BE USED FOR POINTER TO      1198
*                                            ADDRESSING INFORMATION  */
*   2  RTRCTECM FIXED(15),       /* COUNT OF COMPONENT             1198
*                                               ENTRIES FOR TERMINAL */
*   2  RTRRSV01 FIXED(15),       /*  FILLER TO FORCE ALINEMENT       */
*   2  RTRRSV45 CHAR(4),         /* RESERVED                         */
*   2  RTRRDFA  BIT(8),          /* FLAG FIELD A                     */
*      3  RTRRAATN BIT(1),       /* TERMINAL CAN INTERRUPT PCCU      */
*      3  RTRRAALL BIT(3),       /* 3 FLAG FIELD                     */
*         4  RTRRAPT1 BIT(1),    /* PT1 BLOCK HANDLER FLAGS          */
*         4  RTRRAPT2 BIT(1),    /* PT2                              */
*         4  RTRRAPT3 BIT(1),    /* PT3                              */
*      3  RTRRACDT BIT(1),       /* CRITICAL DATA FLAG               */
*      3  RTRRSV60 BIT(1),       /* RESERVED                         */
*      3  RTRRACTR BIT(1),       /* LOGICAL DEVICE FLAG              */
*      3  RTRRSV02 BIT(1),       /* UNUSED                           */
*   2  RTRRDFB  BIT(8),          /* FLAG FIELD B - RESOURCE DEF      */
*      3  RTRRBECT BIT(1),       /* EMBEDDED LINE CONTROL            */
*      3  RTRRBEND BIT(1),       /* EOT/EOB                          */
*      3  RTRRSV32 BIT(6),       /* RESERVED                         */
*   2  RTRRDFC  BIT(8),          /* FLAG FIELD C - RESOURCE DEF      */
*      3  RTRRCIT1 BIT(1),       /* EIB CHAR AFTER ITB ON RECV       */
*      3  RTRRCIT2 BIT(1),       /* EIB CHAR AFTER ITB ON SEND       */
*      3  RTRRCPT3 BIT(1),       /* DEVICE HAS PT3 BHSET             */
*      3  RTRRCBLK BIT(1),       /* RECORD DATA - BLOCK              */
*      3  RTRRCMSG BIT(1),       /* RECORD DATA - MESSAGE            */
*      3  RTRRCXMS BIT(1),       /* RECORD DATA - XMISSION           */
*      3  RTRRSV23 BIT(2),       /* RESERVED/UNUSED                  */
*   2  RTRRDFD  BIT(8),          /* FLAG FIELD D - RESERVED          */
*      3  RTRRDBHN  BIT(1),      /* BHSET = NONE                     */
*      3  RTRRDBHD  BIT(1),      /* BHSET = DYNAMIC                  */
*      3  RTRRDBHI  BIT(1),      /* BHSET = SETNAME AND EXECUTR      */
*      3  RTRRSV10 BIT(2),       /* RESERVED                         */
*      3  RTRRSV11 BIT(3),       /* RESERVED                         */
*   2  RTRRDFE  BIT(8),          /* FLAG FIELD E - RESOURCE DEF      */
*/*                RTRREFT1  FEATURE FLAGS  (9 BITS)                 */
*      3  RTRREBRK BIT(1),       /* TRANSMIT INTERRUPT               */
*      3  RTRRSV0A BIT(1),       /* RESERVED                         */
*      3  RTRREACR BIT(1),       /* ACCELERATED CARRIAGE RETURN      */
*      3  RTRRECHK BIT(1),       /* CHECKING FEATURE                 */
*      3  RTRREATT BIT(1),       /*  TERMINAL INTERRUPT              */
*      3  RTRRESUP BIT(1),       /*  TIMEOUT SUPPRESSION             */
*      3  RTRRESCT BIT(1),       /*  STATION CONTROL                 */
*   2  RTRRDFF  BIT(8),          /* FLAG FIELD F - RESOURCE DEF      */
*      3  RTRRFXCT BIT(1),       /* TRANSMIT CONTROL                 */
*/*                      RTRRFFT2 FEATURE 2 FLAGS (NEXT 5 BITS)      */
*      3  RTRRFPEN BIT(1),       /* SELECTOR PEN                     */
*      3  RTRRFPFK BIT(1),       /* PROGRAM FUNCTION DEYBOARD        */
*      3  RTRRFANK BIT(1),       /* STANDARD ALPHA-NUMERIC KEYBOARD  */
*      3  RTRRFDEK BIT(1),       /* DATA ENTRY KEYBOARD              */
*      3  RTRRSV24 BIT(3),       /* UNUSED/RESERVED                  */
*   2  RTRTRMAX CHAR(1),         /* MAX # TRANSMISSIONS TERM TO PCCU */
*   2  RTRCRFLG PTR(8),          /* FLAG-CONFIGURATION RESTART       */
*      3 RTRCRSV1 BIT(2),        /* RESERVED FOR CONFIG RESTART      */
*      3 RTRLSCMD BIT(1),        /* LINE SCHEDULING CMD ISSUED OK    */
*        4 RTRDTRLM BIT(1),      /* CHNG DEV TRANSMISSION LIMIT OK   */
*      3 RTRCRSV2 BIT(5),        /* RESERVED FOR CONFIG. RESTART     */
*   2  RTRBHSN1 CHAR(8),         /* DEFAULT BHSET NAME IS BHF IS ON  */
*   2  RTRRVPT1 PTR(31),         /* RESERVED                         */
*   2  RTRRSV03 FIXED(15),       /* FILLER TO FORCE ALIGNMENT        */
*   2  RTRCTDIA FIXED(15),       /* CNT OF CHARS. IN TERM DIAL NUMBER*/
*   2  RTRCTPOL FIXED(15),       /* # CHARS. IN TERM POLL STRING     */
*   2  RTRCTADR FIXED(15),       /* COUNT OF ADDRESSING CHARACTERS   */
*   2  RTRCADDR  CHAR(8),        /* COMPONENT ADDRESSING CHARS       */
*   2  RTRPOLA PTR(31),          /* POINTER TO POLLING CHARACTERS    */
*   2  RTRDIAA PTR(31),          /* POINTING TO DIAL CHARACTERS      */
*   2  RTRRDFG  BIT(8),          /* CORRESPONDENCE CODE USED BY THIS
*                                   TERM LINE. SEE CONSTANTS.        */
*   2  RTRRSVDD CHAR(7),         /* RESERVED                         */
*   2  RTRBSCID CHAR(21),        /* BSC ID FIELD                     */
*      3  RTRIDLEN FIXED(8),     /* LENGTH OF ID                     */
*      3  RTRIDCAS CHAR(20),     /* ID CHARACTER                     */
*   2  RTRLCTI BIT(8),           /* LINE CONTROL TYPE ID             */
*   2  RTRRSV04 CHAR(2);         /* RESERVED                         */
*                                                                  1198
* DCL RTRDNCBA PTR(31) DEF(ISTRTR) POS(41);  /* SCAFFOLDING          */
*/* CONSTANTS FOR FIELD RTRRDFG                                      */
*DCL RTRRCBCD BIT(8) CONSTANT('03'X); /* BCD                         */
*DCL RTRRCEBC BIT(8) CONSTANT('04'X); /* EBCD                        */
*DCL RTRRCCOR BIT(8) CONSTANT('05'X); /* COR                         */
*                                                                  1202
*/*     CONSTANTS FOR FIELD RTRLCTI                                  */
*DCL RTR2741  BIT(8) CONSTANT('00'X);  /* 2741                       */
*DCL RTR2740A BIT(8) CONSTANT('02'X);  /* 2740-1 A (BASIC)           */
*DCL RTR2740D BIT(8) CONSTANT('06'X);  /* 2740-1 D (TRANS CONTROL)   */
*DCL RTR2740E BIT(8) CONSTANT('0A'X);  /* 2740-1 E (TRANS          1206
*                                   CONTROL WITH CHECKING            */
*DCL RTR2740F BIT(8) CONSTANT('0C'X);  /* 2740-1 F (CHECKING)        */
*DCL RTR1050  BIT(8) CONSTANT('1C'X);  /* 1050                       */
*DCL RTRTWX   BIT(8) CONSTANT('22'X);  /* TWX                        */
*/*                                                                  */
*/*   ENTRY IN LOCAL RN FOR REMOTE SEGMENT                           */
*/*                                                                  */
*DCL  1  ISTRIN   BDY(WORD) BASED,   /* INNODE REMOTE ENT IN LOCAL RN*/
*        2 RINCRPRE CHAR(LENGTH(ISTRCPRE)),  /* PREFIX               */
*        2 RINDFD   BIT(8),          /* FLAG FIELD                   */
*          3 RINREMPO BIT(1),        /* REMOTE POWER OFF             */
*            4 RTRREMPO BIT(1),      /* ALIAS                        */
*          3 RINNODEF BIT(1),        /* REMOTE TERM ENTRY INV AS ENT */
*            4 RTRNODEF BIT(1),      /* ALIAS                        */
*          3 RINLDISC BIT(1),        /* DISCONNECT REMOTE REQUIRED   */
*            4 RTRLDISC BIT(1),      /* ALIAS                        */
*          3 RINRSV01 BIT(5),        /* RESERVED                     */
*        2 RINNODID PTR(8),          /* NODE ID OF REMOTE            */
*          3 RTRNODID PTR(8),        /* ALIAS                        */
*        2 RINRLDAF CHAR(2),         /* DAF OF REMOTE WHEN ACTIVE    */
*          3 RTRRLDAF CHAR(2),       /* ALIAS                        */
*        2 RINREMOT PTR(31),         /* PTR TO RN ENTRY FOR REMOTE   */
*          3 RTRREMOT PTR(31),       /* ALIAS                        */
*        2 RINVPAB  PTR(31),         /* ADDR VARY PAB FOR REMOTE     */
*          3 RTRVPAB  PTR(31),       /* ALIAS                        */
*        2 RINRPHCN PTR(31),         /* ADDR RPH WAITING FOR CONTACT */
*          3 RTRRPHCN PTR(31),       /* ALIAS                        */
*        2 RINNCSPL PTR(31),         /* ADDR FOR NCSPL FOR DEACTIVATE*/
*          3 RTRNCSPL PTR(31),       /* ALIAS                        */
*        2 RINCNCNT PTR(8),          /* CONTACT COUNT FOR REMOTE     */
*          3 RTRCNCNT PTR(8),        /* ALIAS                        */
*        2 RINRSV02 CHAR(3),         /* RESERVED                     */
*        2 RINLOCRN PTR(31),         /* PTR TO RN ENTRY OF LOCAL     */
*        2 RINRSV04 CHAR(4),         /* RESERVED                     */
*        2 RINRSV05 CHAR(4);         /* RESERVED                     */
*/*                                                                  */
*DCL                                                               1211
*1   ISTRDS BDY(WORD) BASED,       /* LCDO ENTRY                     */
*           2  RDSPRE CHAR(LENGTH(ISTRPRE)), /* ENTRY PREFIX         */
*           2  RDSCTTRM FIXED(15), /* COUNT OF ENTRY POINTERS      1211
*                                     IN DIAL OUT TABLE              */
*           2  RDSCTATR FIXED(15), /*                                */
*           2  RDSADDOT PTR(31);   /* ADDRESS OF DIAL OUT TABLE      */
*/*                                                                  */
*DCL                                                               1212
*1   ISTDOT BDY(WORD) BASED,       /* DIAL OUT TABLE                 */
*           2  DOTADTRM PTR(31);   /* PTR TO DIAL OUT OR DIAL IN/  1212
*                                     OUT TERMINAL RDTE              */
*/*                                                                  */
*DCL                                                               1213
*1 ISTRCC BDY(WORD) BASED,             /* PU ENTRY                   */
*  2 RCCPRE   CHAR(LENGTH(ISTRPRE)),   /* COMMON PREFIX              */
*  2 RCCTYPE  CHAR(1),                 /* PU TYPE                    */
*  2 RCCFLAG  BIT(8),                  /* FLAG FIELD                 */
*    3 RCCRBISA BIT(1),                /* I STATUS 1=ACTIVE          */
*    3 RCCCUDIE BIT(1),                /* CLUSTER DEACTIVATING       */
*    3 RCCERPIP BIT(1),                /* ERP IN PROCESS             */
*    3 RCCLDISC BIT(1),                /* DISCONNECT REQUEST         */
*    3 RCCOHIMM BIT(1),                /* RTGOH RECEIVED AND WAS     */
*                                      /* AN IMMEDIATE TYPE          */
*    3 RCCOUERP BIT(1),                /* REPEAT ERP                 */
*    3 RCCPRGDN BIT(1),                /* PURGE ISSUED               */
*    3 RCCCTPGD BIT(1),                /* CONTACT PURGED             */
*  2 RCCFLAGB BIT(8),                  /* FLAG FIELD                 */
*    3 RCCDSTCT BIT(1),                /* DEACT TO DECR STCNT IN HDR */
*    3 RCCDIALP BIT(1),                /* DIAL IN PROGRESS           */
*    3 RCCIRETR BIT(1),                /* IRETRY 1 = YES             */
*    3 RCCBNNSP BIT(1),                /* BNNSUP FOR 3270            */
*    3 RCCFINAL BIT(1),                /* ON = DEACT PU FINAL REQD   */
*    3 RCCRESET BIT(1),                /* ON = RESET DEACT IN PROCESS*/
*    3 RCCBRKCN BIT(1),                /* ON-DISCOUNT=YES SPECIFIED  */
*                                      /* OFF-DISCOUNT=NO SPECIFIED  */
*    3 RCCRTGOH BIT(1),                /* ON=RTGOH RECEIVED          */
*  2 RCCCNCNT  PTR(8),                 /* CONTACT COUNT              */
*  2 RCCCTELU FIXED(15),               /* COUNT OF PU LU ENTRIES     */
*  2 RCCSTAID CHAR(8),                 /* 64 BIT PU STATION ID       */
*    3 RCCIDPA1 BIT(16),               /* FILLER OF 2 BYTES OF 0     */
*    3 RCCID48,                                                    1213
*      4 RCCIDPUT BIT(8),              /* PU TYPE                    */
*      4 RCCIDPA2 BIT(8),              /* FILLER OF 1 BYTE OF 0      */
*      4 RCCIDBLK BIT(12),             /* IDBLK VALUE                */
*      4 RCCIDNUM BIT(20),             /* IDNUM VALUE                */
*  2 RCCSESCT PTR(8),                  /* SESSION COUNT              */
*  2 *        CHAR(1),                 /* RESERVED                   */
*  2  RCCVPAB PTR(31),                 /* ADDRESS OF VARY PAB        */
*  2 RCCDPAB  PTR(31),                 /* ADDR RESTART PAB           */
*  2 RCCEPAB  PTR(31),                 /* ADDR OF ERP PAB            */
*  2 RCCRPHCN PTR(31),                 /* ADDR RPH WAIT FOR CONTACT  */
*  2 RCCNCSPL PTR(31),                 /* ADDR NCSPL FOR DEACTIVATE  */
*  2 RCCCRFLG BIT(8),                  /* FLAG-CONFIGURATION RESTART */
*    3 RCCACTPU BIT(1),                /* ACTIVATE PHYSICAL          */
*    3 RCCCTCFL BIT(1),          /* HIGHER FAILURE-CONTACT FLUSHED   */
*    3 RCCCRRSV BIT(6),                /* RES. FOR CONFIG. RESTART   */
*  2 RCCRSV02 PTR(24),                 /* RESERVED                   */
*  2 RCCTPAB  PTR(31),                 /* TOLTEP SSCP PAB            */
*  2 RCCDPQ   PTR(31),                 /* DIAL PENDING NCSPL QUE PTR */
*  2 RCCPATHT PTR(31),                 /* PTR TO PATH TABLE          */
*  2 RCCPATHZ FIXED(15),               /* # ENTRIES IN PATH TABLE    */
*  2 RCCINDEX FIXED(15),               /* INDEX TO PATH TABLE        */
*  2 RCCMXDAT FIXED(15),               /* MAXDATA SIZE               */
*  2 RCCMXOUT FIXED(8),                /* MAXOUT VALUE               */
*  2 RCCPASSL FIXED(8),                /* PASSLIM VALUE              */
*  2 RCCADDR  FIXED(8),                /* STATION ADDRESS            */
*  2 RCCRSPT2 PTR(24),                 /* RESERVED                   */
*  2 RCCSWTOX PTR(31),                 /* SWITCHED TO 370X           */
*                                      /* COMMUNICATIONS NCSPL       */
*  2 RCCXTOSW PTR(31),                 /* 370X TO SWITCHED           */
*                                      /* COMMUNICATIONS NCSPL       */
*  2 RCCRVPT2 PTR(31);                 /* RESERVED                   */
*/* RCCTYPE - PU TYPE CODES                                          */
*DCL RCCPU01  BIT(8) CONSTANT('01'X);  /* PU TYPE 1                  */
*DCL RCCPU02  BIT(8) CONSTANT('02'X);  /* PU TYPE 2                  */
*DCL RCCPU03  BIT(8) CONSTANT('03'X);  /* PU TYPE 3                  */
*DCL RCCPU04  BIT(8) CONSTANT('04'X);  /* PU TYPE 4                  */
*/*                                                                  */
*DCL                                                               1218
*1 ISTRLU BDY(WORD) BASED,             /* LU ENTRY                   */
*  2 RLUCRPR CHAR(LENGTH(ISTRCPRE)),   /* COMMON PREFIX              */
*  2 RLUTYPE  CHAR(1),                 /* LU TYPE                    */
*  2 RLUFLAG  CHAR(1),                 /* RLU FLAGS                  */
*    3 RLURBISA BIT(1),                /* I STATUS 1=ACTIVE          */
*    3 RLUBATCH BIT(1),                /* 1 IF BATCH = YES           */
*    3 RLUGSTAT BIT(1),                /* C/R GENNED ISTATUS VALUE   */
*                                      /* 1 = ACTIVE                 */
*    3 RLUNDSES BIT(1),                /* SPECIAL END SESSION        */
*    3 RLURSV00 BIT(4),                /* RESERVED                   */
*  2 RLUCRFLG BIT(8),                  /* FLAG-CONFIGURATION RESTART */
*    3 RLUACTLU BIT(1),                /* ACTIVATE LOGICAL UNIT OK   */
*    3 RLUCRRSV BIT(7),                /* RESERVED FOR CONFIG RESTART*/
*  2 RLUSSCFM BIT(8),                  /* FUNCTION MANAGER TYPE      */
*  2 RLUINTA PTR(31),                  /* RESERVED                   */
*  2 RLUPACE CHAR(2),                  /* VPACING COUNTS             */
*    3 RLUPACEN CHAR(1),               /* N COUNT                    */
*    3 RLUPACEM CHAR(1),               /* M COUNT                    */
*  2 RLUNCPPC CHAR(2),                 /* NCP PACING COUNTS          */
*    3 RLUNCPPN CHAR(1),               /* N COUNT                    */
*    3 RLUNCPPM CHAR(1),               /* M COUNT                    */
*  2 RLULOCAD CHAR(1),                 /* LOCAL ADDRESS OF LU        */
*  2 RLURSV01 CHAR(3),                 /* RESERVED                   */
*  2 RLUUSSTB CHAR(12) BDY(WORD),      /* USSTAB                     */
*    3 RLUUSSNM CHAR(8),               /* USSTAB NAME                */
*    3 RLUUSSPT PTR(31),               /* USSTAB ADDRESS             */
*  2 RLUMODET CHAR(12) BDY(WORD),      /* MODETAB                    */
*    3 RLUMODEN CHAR(8),               /* MODETAB NAME               */
*    3 RLUMODEP PTR(31),               /* MODETAB ADDRESS            */
*  2 RLULGMOD CHAR(8),                 /* LOGMODE                    */
*  2 RLURSV02 PTR(31);                 /* RESERVED                   */
*/*  RLUSSCFM - FOLLOWING EQUATES ARE FOR THE VARIOUS                */
*/*             FUNCTION MANAGER TYPES                               */
*DCL RLUFSS   BIT(8) CONSTANT('01'X);  /* FORMATTED SYS SERVICES     */
*DCL RLUUSS   BIT(8) CONSTANT('02'X);  /* UNFORMATTED SYS SERVICES   */
*DCL RLUU3270 BIT(8) CONSTANT('04'X);  /* UNFORMATTED SYS SVCS 3270  */
*/*  RLUTYPE - EQUATES FOR LU TYPE                                   */
*DCL RLUTYP04 BIT(8) CONSTANT('04'X);  /* LU TYPE IS 4               */
*/*                                                                  */
*DCL 1 ISTRPX BDY(WORD) BASED,     /* SKELETON PUX ENTRY             */
*      2 RPXPRE CHAR(LENGTH(ISTRPRE)),  /* COMMON PREFIX             */
*      2 RPXFLUX  PTR(31),         /* PTR TO FIRST LUX IN CHAIN      */
*      2 RPXMAXLU PTR(8),          /* MAX NUMBER OF LU'S             */
*                                  /* FOR THIS LINK                  */
*      2 RPXRSV02 PTR(24),         /* RESERVED                       */
*      2 RPXRSV01 PTR(31);         /* RESERVED                       */
*/*                                                                  */
*DCL 1 ISTRLX BDY(WORD) BASED,     /* SKELETON LUX ENTRY             */
*      2 RLXPRE CHAR(LENGTH(ISTRPRE)),  /* COMMON PREFIX             */
*      2 RLXNLUX  PTR(31),         /* PTR TO NEXT LUX IN CHAIN       */
*      2 RLXFLAGA CHAR(1),         /* FLAG BYTE                      */
*        3 RLXINUSE BIT(1),        /* ON = LUX IS IN USE             */
*        3 RLXRSV01 BIT(7),        /* RESERVED                       */
*      2 RLXRSV02 CHAR(3),         /* RESERVED                       */
*      2 RLXRSV03 PTR(31);         /* RESERVED                       */
*/*                                                                  */
*DCL 1 ISTRSW BDY(WORD) BASED,     /* SWITCHED SUBAREA HDR ENTRY     */
*      2 RSWPRE CHAR(LENGTH(ISTRDT)),   /* USE ISTRDT DSECT          */
*      2 RSWDIALT PTR(31),         /* PTR TO DIAL #'S TABLE          */
*      2 RSWGRUPT PTR(31),         /* PTR TO GROUP NAMES TABLE       */
*      2 RSWDIALZ FIXED(15),       /* # ENTRIES IN DIAL NO. TABLE    */
*      2 RSWGRUPZ FIXED(15),       /* # ENTRIES IN GRP NAME TABLE    */
*      2 RSWCTELU FIXED(15),       /* COUNT OF LU ENTRIES IN THIS SEG*/
*      2 RSWRSV02 CHAR(2),         /* RESERVED                       */
*      2 RSWRSV01 PTR(31);         /* RESERVED                       */
*/*                                                                  */
*DCL 1 ISTRDA BDY(WORD) BASED,     /* DAN ENTRY                      */
*      2 RDAPRE CHAR(LENGTH(ISTRPRE)),  /* COMMON PREFIX             */
*      2 RDAADR   PTR(31),                                         1226
*        3 RDAFLAG  BIT(8),        /* FLAG BYTE                      */
*          4 RDARBISA BIT(1),      /* INITIAL STATUS, 1 = ACTIVE     */
*          4 RDARSV01 BIT(7),      /* RESERVED                       */
*        3 RDAUCBAD PTR(24),       /* UCB.PUB ADDRESS                */
*          4 RDACHQI  BIT(8),      /* CHANNEL QUEUE INDEX            */
*          4 RDALUBA  BIT(16),     /* @ OF LOGICAL UNIT BLOCK        */
*      2 RDADACUA CHAR(3),         /* CHANNEL UNIT ADDRESS           */
*      2 RDACTPCC PTR(8),          /* CNT OF BUFFERS RECEIVING DATA  */
*      2 RDADFCUA CHAR(3),         /* DEFAULT CUA                    */
*      2 RDAPUBI  BIT(8),          /* PUB INDEX                      */
*      2 RDARSVPT PTR(31);         /* RESERVED                       */
*/*                                                                  */
*DCL 1 ISTRLS BDY(WORD) BASED,     /* LOCAL SUBAREA HEADER ENTRY     */
*      2 RLSPRE CHAR(LENGTH(ISTRDT)),   /* USE ISTRDT DSECT          */
*      2 RLSCTELU FIXED(15),       /* COUNT OF LU ENTRIES IN THIS SEG*/
*      2 RLSRSV01 FIXED(15),       /* RESERVED                       */
*      2 RLSRSV02 PTR(31);         /* RESERVED                       */
*/*                                                                  */
*DCL  1  ISTDNT BDY(WORD) BASED,  /* DIAL NUMBER TABLE               */
*        2 DNTCTDIG FIXED(8),     /* NUMBER OF DIGITS IN TEL. NUM.   */
*        2 DNTTELNO CHAR(32);     /* TELEPHONE NUMBER                */
*/*                                                                  */
* DCL  1  ISTGNT BDY(WORD) BASED, /* GROUP NAMES TABLE               */
*         2 GNTGRPNM CHAR(8);     /* GROUP NAME ENTRY                */
*/*                                                                  */
*DCL  1  ISTPAT BDY(WORD) BASED,  /* PATH TABLE                      */
*        2 PATGINDX FIXED(15),    /* INDEX TO GROUP NAME TABLE       */
*        2 PATDINDX FIXED(15),    /* INDEX TO DIAL NUMBER TABLE      */
*        2 PATPTHID PTR(8),       /* PATH ID                         */
*        2 PATGRPID PTR(8),       /* GROUP PATH ID                   */
*        2 PATRDCNT PTR(8),       /* REDIAL COUNT                    */
*        2 PATFLAGA BIT(8),       /* FLAG BYTE                       */
*          3 PATUSEFG BIT(1),     /* ON = PATH INITIALLY USABLE      */
*          3 PATRSV01 BIT(7);     /* RESERVED                        */
*/* RPL HEADER                                                        *
*/*  REVISIONS                                         006 04/09/75   *
*DCL RPHPTR PTR(31) REGISTER(1) RESTRICTED;                        1231
*DCL  1  ISTRPH BDY(WORD) BASED(RPHPTR),                           1232
*       2  RPHCNTL FIXED(32),          /* CONTROL INFORMATION         *
*       3  RPHTYPE CHAR(1),            /* CONTROL BLOCK TYPE          *
*       3  RPHLNGTH PTR(8),            /* LENGTH IN BYTES             *
*       3  RPHFLAGS BIT(8),            /* SYSTEM DEPENDENT FLAGS      *
*         4  RPHOGIND BIT(1),          /* OPEN GATE INDICATOR         *
*         4  RPHSPGIN BIT(1),          /* SPECIAL GATE OPEN IND.      *
*         4  RPHAPTYP BIT(1),          /* APS IS A USER EXIT          *
*            5  RPHAUTEX BIT(1),        /*EXIT TO AUTHORIZED USER VS2 *
*         4  RPHSMQ BIT(1),            /* INDICATOR IF RPH IS TO BE   *
*                                      /* QUEUED                      *
*         4  RPHSMTYP BIT(1),          /* REQUEST TYPE IS BUFFER OR   *
*                                      /* DOUBLE-WORD                 *
*         4  RPHSMCLR BIT(1),          /* INDICATOR IF BUFFER TO BE   *
*                                      /* CLEARED                     *
*           4  RPHMLTCP BIT(1),        /* USED BY LOCAL 3270  SUPPORT *
*                                      /* WHEN BUILDING MULTIPLE CHAN *
*                                      /* PROGRAM                     *
*           4  RPHFSTLC BIT(1),        /* USED BY LOCAL 3270 SUPPORT  *
*                                      /* TO INDICATE FIRST LCCW      *
*              5  RPHFNFLG BIT(1),     /* LCCW SET FUNCTION FLAGS     *
*        3  RPHFLGB BIT(8),            /* SECOND FLAG BYTE            *
*           4  RPHLOCK BIT(1),         /* LOCKING OPTION              *
*           4  RPHBSSP BIT(1),         /* SYSTEM SERVICES PROGRESS    *
*           4  RPHFBAPS BIT(1),        /* STG. OBTAINED BY APS        *
*           4  RPHPGCMP BIT(1),        /* BIT ON INDICATES RESOURCE   *
*                                      /* MGR HAS COMPLETED UNLOCK    *
*           4  RPHNRSAV BIT(1),        /* DO NOT SAVE ON ACTIVATE     *
*           4  RPHRLCRA BIT(1),        /* RPH CAN BE RELEASED         *
*                                      /* WHEN PURGE COMPLETE         *
*           4  *        BIT(2),        /* RESERVED                    *
*       2  RPHRPHA PTR(31),            /* ADDR.OF NEXT RPL HEADER     *
*         3  RPHGATE BIT(1),           /* GATING FLAG                 *
*         3  *       BIT(7),           /* RESERVED                    *
*         3  RPHRPHAP PTR(24),                                     1232
*       2  RPHTSKID PTR(31),           /* TASK IDENTIFICATION         *
*                                      /* OR ADDR.OF APS TABLE        *
*          3  *     CHAR(3),           /* RPH TSK ID                  *
*          3  RPHTIK PTR(8),           /* TIK                         *
*       2  RPHDVTA PTR(31),            /* ADDR.OF  CURRENT DVT        *
*       2  RPHRESMA PTR(31) BDY(WORD), /* TPWAIT-POST INFO */      1232
*         3 RPHWPFLG CHAR(1),          /* WAIT-POST FLAGS */       1232
*           4 RPHRSKEY BIT(4),         /* STORAGE PROTECT KEY TO RESUME
*                                         PROCESSING                  *
*           4 RPHWT BIT(1),            /* WAIT BIT */              1232
*           4 RPHPT BIT(1),            /* POST BIT */              1232
*           4 RPHPURGE BIT(1),         /* RPH FLAGGED BY RECOVERY    */
*                                      /* TO BE PURGED BY PSS        */
*                                      /* VS/2 ONLY                  */
*           4 RPHRSV01 BIT(1),        /* RESERVED                    */
*         3 RPHRESUM PTR(24),          /* RESUME ADDRESS */        1232
*       2  RPHPABOF PTR(8),            /* OFFSET OF PAB IN CONTROL BLK*
*       2  RPHMAJCB PTR(24),           /* ADDR.OF MAJOR CONTROL BLOCK *
*       2  RPHWEA PTR(31),             /* ADDR.OF WORK ELEMENT        *
*         3  RPHCSPA PTR(31),          /* ADDR OF ISTCSP              *
*           4  RPHWEGT BIT(1),         /* GATE FOR WORK ELEMENT PROC. *
*       2  RPHSRPRM PTR(31),           /* SERVICE ROUTINE PARM.FIELD  *
*         3 RPHSRP12 FIXED(15),        /* COUNT OF Q'ED SMS REQUESTS  *
*         3 RPHSRP34 FIXED(15),        /* SIZE OF Q'ED SMS REQUESTS   *
*       2  RPHCRR PTR(31),             /* ADDR.OF COMPONENT RECOVERY  *
*                                      /* RECORD                      *
*       2  RPHPABQA PTR(31),           /* PAB QUEUE ADDRESS           *
*          3 RPHPABFG CHAR(1),         /* FLAG BYTE CARRIED FROM PAB  *
*          3 RPHPABQP PTR(24),         /* POINTER TO QUEUE OF PAB'S   *
*       2  RPHWORK CHAR(64) BDY(WORD), /* 16 WORD WORK AREA           *
*         3  RPHSAVE1 FIXED(31),       /*                             *
*           4  RPHSBYTE CHAR(1),       /* 1-BYTE SAVE FIELD           *
*           4  RPHSBITS BIT(8),        /* SAVE FIELD FOR FLAG BYTE    *
*              5  RPHSBIT1 BIT(1),     /* 1ST SAVE FIELD              *
*              5  RPHSBIT2 BIT(1),     /* 2ND SAVE FIELD              *
*              5  RPHSBIT3 BIT(1),     /* 3RD SAVE FIELD              *
*              5  RPHSBIT4 BIT(1),     /* 4TH SAVE FIELD              *
*              5  RPHSBIT5 BIT(1),     /* 5TH SAVE FIELD              *
*              5  RPHSBIT6 BIT(1),     /* 6TH SAVE FIELD              *
*              5  RPHSBIT7 BIT(1),     /* 7TH SAVE FIELD              *
*              5  RPHSBIT8 BIT(1),     /* 8TH SAVE FIELD              *
*           4  RPHSHALF FIXED(15),     /* HALF WORD SAVE AREA         *
*         3  RPHSAVE2 FIXED(31),       /*                             *
*         3  RPHSAVE3 FIXED(31),       /*                             *
*         3  RPHSAVE4 FIXED(31),       /*                             *
*         3  RPHSAVE5 FIXED(31),       /*                             *
*         3  RPHSAVE6 FIXED(31),       /*                             *
*         3  RPHSAVE7 FIXED(31),       /*                             *
*         3  RPHSAVE8 FIXED(31),       /*                             *
*         3  RPHSAVE9 FIXED(31),       /*                             *
*         3  RPHSAV10 FIXED(31),       /*                             *
*         3  RPHSAV11 FIXED(31),       /*                             *
*         3  RPHSAV12 FIXED(31),       /*                             *
*         3  RPHSAV13 FIXED(31),       /*                             *
*         3  RPHSAV14 FIXED(31),       /*                             *
*         3  RPHSAV15 FIXED(31),       /*                             *
*         3  RPHSAV16 FIXED(31),       /*                             *
*       2  RPHNEXPO PTR(31);           /* ADDR.NEXT RPH TO BE POSTED  *
* DCL RPTYPE BIT(8) CONSTANT('01'X);   /* TYPE CODE FOR RPH           *
* DCL RPHWT0 BIT(32) CONSTANT('F7FFFFFF'X);   /* TURN RPHWT OFF */ 1234
* DCL RPHWT1 BIT(32) CONSTANT('08000000'X);   /* TURN RPHWT ON */  1235
* DCL RPHPT0 BIT(32) CONSTANT('FBFFFFFF'X);   /* TURN RPHPT OFF */ 1236
* DCL RPHPT1 BIT(32) CONSTANT('04000000'X);   /* TURN RPHPT ON */  1237
* DCL RPHPABQ1 BIT(24) CONSTANT('000000'X); /* TURN RPHPBQ GATE */ 1238
*/* PROCESS ANCHOR BLOCK                                              *
*/*  REVISIONS                                         002 11/16/75  */
*DCL  1  ISTPAB BDY(DWORD) BASED,                                  1239
*       2  PABWQCHN CHAR(8) BDY(DWORD), /* CPS SWAP FIELD FOR NEQ&CHN *
*        3  PABWEQA PTR(31) BDY(WORD), /* WORK ELEMENT QUEUE ADDRESS  *
*           4  PABWEQG BIT(1),         /* GATING BIT                  *
*           4  PABRSV01 BIT(7),        /* RESERVED                    *
*           4  PABWEQP PTR(24),        /* WKEL PTR                    *
*        3  PABCHAIN PTR(31) BDY(WORD), /* APS CHAIN                  *
*           4  PABCHNG BIT(1),         /* GATING BIT                  *
*           4  PABRESCH BIT(1),        /* RESCHEDULE PAB AT        1239
*                                         TPEXIT                      *
*           4  PABCDP BIT(1),          /* CLOSE DST/CHANGE IN PROGRESS*
*           4  PABUNCON BIT(1),        /* UNCONDITIONALLY RESCHEDULE
*                                         PAB AT TPEXIT               *
*           4  PABRESET BIT(1),        /* RESET ISSUED ON THIS PAB    *
*           4  PABRUNNG BIT(1),        /* PAB RUNNING                 *
*           4  PABDELAY BIT(1),        /* DELAY OPTION USED           *
*           4  PABRSV02 BIT(1),        /* RESERVED                    *
*           4  PABCHNGP PTR(24),       /* PSS CHAIN PTR               *
*        2  PABOFFST PTR(8),           /* OFFSET FROM CONTROL BLOCK   *
*        2  PABDVTA PTR(24),           /* DVT ADDRESS                 *
*        2  PABRPHFG PTR(31),          /* SCHED FLAGS AND RPH         *
*           3  PABFLAGS BIT(8),        /* SCHEDULING FLAGS            *
*              4  PABAPYP BIT(1),      /* APPLICATION IS A USER EXIT  *
*              4  PABPRIOR BIT(1),     /* IMMEDIATE PRIORITY          *
*              4  PABNORPR BIT(1),     /* NORMAL PRIORITY -           *
*                                      /* RESCHEDUALABLE              *
*              4  PABDYNAM BIT(1),     /* DYNAMIC                     *
*              4  PABSSN BIT(1),       /* SYSTEM SERVICES             *
*              4  PABERLCK BIT(1),     /* PAB ERROR LOCK FLAG         *
*                 5  PABERRLK BIT(1),  /* ERROR LOCK                  *
*                    6  PABERLOK BIT(1), /* ERROR LOCK                *
*/*    ABNORMAL TO ALLOW VARY COMPARE AND SWAP                        *
*              4  PABINHBT BIT(1) ABNL,/* 1=INHIBIT TRAFFIC,0=NO      *
*              4  PABNODQ BIT(1),      /* DO NOT DEQ WORK ELEMENT     *
*           3  PABRPHA PTR(24);        /* RPL HEADER ADDRESS          *
*DCL PABWEQG0 BIT(32) CONSTANT('7FFFFFFF'X),  /* TURN PABWEQG OFF     *
*    PABWEQG1 BIT(32) CONSTANT('80000000'X),  /* TURN PABWEQG ON      *
*    PABCHNG0 BIT(32) CONSTANT('7FFFFFFF'X),  /* TURN PABCHNG OFF     *
*    PABCHNG1 BIT(32) CONSTANT('80000000'X),  /* TURN PABCHNG ON      *
*    PABRESC0 BIT(32) CONSTANT('BFFFFFFF'X),  /* TURN PABRESCH OFF    *
*    PABRESC1 BIT(32) CONSTANT('40000000'X),  /* TURN PABRESCH ON     *
*    PABCDP0  BIT(32) CONSTANT ('DFFFFFFF'X), /* TURN PABCDP OFF      *
*    PABCDP1  BIT(32) CONSTANT ('20000000'X), /* TURN PABCDP ON       *
*    PABERLK0 BIT(32) CONSTANT('FBFFFFFF'X),  /* TURN PABERRLK ON     *
*    PABERLK1 BIT(32) CONSTANT('04000000'X),  /* TURN PABERRLK OFF    *
*    PABUNCO0 BIT(32) CONSTANT('EFFFFFFF'X),  /* TURN PABUNCON OFF    *
*    PABUNCO1 BIT(32) CONSTANT('10000000'X),  /* TURN PABUNCON ON     *
*    PABPRIR0 BIT(32) CONSTANT('BFFFFFFF'X),  /* TURN PAB PRIOR OFF   *
*    PABPRIR1 BIT(32) CONSTANT('40000000'X),  /* TURN PAB PRIOR ON    *
*    PABRST0  BIT(32) CONSTANT('F7FFFFFF'X),  /* TURN PABRESET OFF    *
*    PABRST1  BIT(32) CONSTANT('08000000'X),  /* TURN PABRESET ON     *
*    PABDLAY0 BIT(32) CONSTANT('FDFFFFFF'X),  /* TURN PAB DELAY OFF   *
*    PABDLAY1 BIT(32) CONSTANT('02000000'X);  /* TURN PAB DELAY ON    *
*              /* DYNAMIC PAB 1K633 */                             1241
* /* 1K0997 JAN 20, 1973  MB   */                                  1241
* /* 1K1142 MAR 03, 1973  MB   */                                  1241
* DCL 1 ISTDYPAB BDY(DWORD) BASED, /* LEVEL 1 DECLARE 1K633 */     1241
*       2  DYPTYPE CHAR(1), /* CONTROL BLOCK TYPE CODE 1K633 */    1241
*       2  DYPLNGTH PTR(8), /* CONTROL BLOCK LENGTH (BYTES)  1K633 */
*       2 DYPFLGS CHAR(2),     /* FLAGS 1K633 */                   1241
*       2 DYPCHAIN PTR(31),    /* CHAIN POINTER 1K633 */           1241
*       2 DYPTSKID PTR(31),    /* TASKID OR PTR TO PSS TABLES 1K633 */
*       2  DYPRSV01 PTR(31),   /* RESERVED TO PRESERVE ALIGNMENT   1241
*                                                             1K0997 */
*       2 DYPPAB CHAR(LENGTH(ISTPAB)) BDY(DWORD); /* LENGTH OF 1K0997
*                                                    PAB         */
*DCL DYTYP   BIT(8) CONSTANT ('11'X);   /* TYPE           1K1142 */
*/*  REVISIONS                                         015 11/16/75   *
*DCL ATCLCPTR PTR LOCATION(1032);      /* POINTER TO ATCVT            *
*DCL  1  ISTATCVT BDY(DWORD) BASED,                                1244
*        2  ATCCOM BDY(WORD),          /* SYSTEM INDEPENDENT FIELDS   *
*           3  ATCSTAT CHAR(4),        /* VTAM  STATUS INDICATORS     *
*              4  ATCSTAT1 CHAR(1),    /* VTAM  STATUS BYTE 1         *
*                 5  ATCSTART BIT(1),  /* VTAM  IS STARTING           *
*                 5  ATCACTIV BIT(1),  /* VTAM  IS ACTIVE             *
*                 5  ATCSNHLT BIT(1),  /* VTAM  SESSION HALT          *
*                 5  ATCQKHLT BIT(1),  /* VTAM  QUICK HALT            *
*                 5  ATCNETSL BIT(1),  /* NETSOL=YES SPECIFIED ON CMD *
*                 5  ATCINHLT BIT(1),  /* INTERNAL VTAM HALT QUICK    *
*                 5  ATCMDHLT BIT(1),  /* VTAM CMD PROC HALTED        *
*                 5 * BIT(1),          /* RESERVED                    *
*              4  ATCSTFLG BIT(8),     /* STORAGE MANAGEMENT FLAGS    *
*                 5  ATCHSDMF BIT(1),  /* SYSTEM SLOW DOWN FLAG       *
*              4  ATCPOFLG BIT(8),     /* PROGRAM OPERATOR            *
*                                      /* INTERFACE FLAGS             *
*                 5 ATCPOUNS BIT(1),   /* APPLICATION AUTHORIZED TO   *
*                                      /* RECEIVE UNSOLICITED MESSAGES*
*                                      /* 1 = YES                     *
*                 5 *        BIT(7),   /* RESERVED                    *
*              4  ATCSTAT4 CHAR(1),    /* VTAM  STATUS BYTE 4         *
*                 5  ATCPRTAT BIT(1),  /* 1 = TRACE PRINT ACTIVE,  1244
*                                         0 = NOT ACTIVE              *
*                 5  ATCTPRT BIT(1),   /* WHEN 1, TPRINT IN PROCESS   *
*                 5  ATCMTST BIT(1),   /* WHEN 1, MODIFY TEST IN   1244
*                                         PROCESS                     *
*                 5  ATCNCSD BIT(1),   /* NCS QUIESCED DURING HALT    *
*                 5  ATCVTTRC BIT(1),  /* VTAM TRACE, 1=ACTIVE        *
*                 5  ATCRSV04 BIT(3),  /* RESERVED                    *
*           3  ATCAPI PTR(31),         /* ADDR OF API ROUTINE         *
*           3  ATCDCFRR PTR(31),       /* POINTER TO FRR OF CONTROL
*                                         LAYER,INITIALIZED BY OPENDST*
*           3  ATCRDT PTR(31),         /* POINTER TO FIRST RDT        *
*           3  ATCSRT PTR(31),         /* POINTER TO SRT DIRECTORY    *
*           3  ATCASCHD PTR(31),       /* POINTER TO AP SCHEDULER     *
*           3  ATCECMOD CHAR(4),       /* ECB FOR MODIFY COMMAND PROC.*
*           3  ATCMODQ PTR(31),        /* POINTER FOR OUTPUT QUEUE    *
*                                      /* FOR MODIFY COMMAND          *
*           3  ATCECHLT CHAR(4),       /* ECB FOR HALT COMMAND        *
*           3  ATCHALTQ PTR(31),       /* POINTER TO OUTPUT QUEUE     *
*                                      /* FOR HALT COMMAND            *
*           3  ATCECVRY CHAR(4),       /* ECB FOR VARY COMMAND PROC.  *
*           3  ATCVARYQ PTR(31),       /* POINTER TO OUTPUT QUEUE     *
*                                      /* FOR VARY COMMAND            *
*           3  ATCECDSP CHAR(4),       /* ECB FOR DISPLAY COMMAND     *
*           3  ATCDSPLQ PTR(31),       /*  POINTER TO OUTPUT QUEUE    *
*                                      /* FOR DISPLAY COMMAND         *
*           3  ATCOCHA PTR(31),        /* POINTER TO OCT HEADER       *
*           3  ATCECSES CHAR(4),       /* ECB TO HALT SESSION MODE    *
*           3  ATCECVRQ CHAR(4),       /* ERP ECB FOR VARY REQ. INFO. *
*                                      /* REQUEST NOTIFICATION        *
*           3  ATCVPARM PTR(31),       /* ADDR OF VARY PARAMETERS     *
*           3  ATCECOPC CHAR(4),       /* ECB TOINDICATE OPERATOR     *
*                                      /* CONTROL PROCESSING COMPLETE *
*           3  ATCECNET CHAR(4),       /* ERP ECB FOR NETWORK         *
*                                      /* CONFIGURATION REQUEST       *
*           3  ATCECPRM PTR(31),       /* POINTER TO QAB FOR ERP'S    *
*                                      /* ECB PARAMETERS              *
*           3  ATCHLTMS PTR(31),       /* POINTER TO HALT COMMAND     *
*                                      /* OR HALT RETURN MESSAGE      *
*           3  ATCFSB PTR(31),         /* PTR TO FEEDBACK STATUS      *
*                                      /* BLOCK                       *
*           3  ATCFRSCH PTR(31),       /* POINTER TO FEEDBACK         *
*                                      /* ROUTINE SCHEDULER           *
*           3  ATCRDTH PTR(31),        /*  POINTER RDT HEADER         *
*           3  ATCACCTA PTR(31),       /* POINTER TO INSTALLATION     *
*                                      /* ACCOUNTING ROUTINE          *
*           3  ATCAUTHA PTR(31),       /* POINTER TO INSTALLATION     *
*                                      /* AUTHORISATION ROUTINE       *
*           3  ATCPTCHA PTR(31),       /* PTR TO VTAM PATCH AREA      *
*           3  ATCCONFT PTR(31),       /* POINTER TO VTAM             *
*                                      /* CONFIGURATION TABLE         *
*           3  ATCFDVT PTR(31),        /* PTR TO FIRST DVT FOR O/C    *
*           3  ATCFEPT PTR(31),        /* PTR TO FIRST EPT FOR O/C    *
*           3  ATCDVTPT PTR(31),       /* ADDR OF LOAD MOD FOR        *
*                                      /* TYPE=VTAM TRACING           *
*           3  ATCBPDA PTR(31),        /* PTR TO BUFFER POOL DIRECTORY*
*           3  ATCADD PTR(31),         /* POINTER TO ADD PROCEDURE    *
*           3  ATCREMOV PTR(31),       /* POINTER TO REMOVE PROCEDURE *
*           3  ATCIOTRC PTR(31),       /*  POINTER TO I/O TRACE       *
*                                      /* PROCEDURE                   *
*              4 ATCTHTRC PTR(31),     /* ADDR OF TH TRACE ROUTINE    *
*                5 ATCTPBUF PTR(31),   /* TPIOS BUFFER TRACE(ISTRARTP)*
*           3  ATCBFTRC PTR(31),       /* PTR TO BUFFER TRACE         *
*                                      /* PROCEDURE                   *
*           3  ATCFBRPH PTR(31),       /* ADDR OF FEEDBACK PROC RPH   *
*           3  ATCBLDLA PTR(31),       /* ADDR OF BLDL ROUTINE        *
*           3  ATCALOAD PTR(31),       /* ADDR OF ALOAD ROUTINE       *
*           3  ATCREADA PTR(31),       /* ADDR OF SOURCE READ ROUTINE *
*           3  ATCGTSTR PTR(31),       /* ADDR OF GETSTOR ROUTINE     *
*           3  ATCFRSTR PTR(31),       /* ADDR OF FREESTOR ROUTINE    *
*           3  ATCSTMA PTR(31),        /* ADDR OF SM INITIALIZATION   *
*                                      /* ROUTINE                     *
*           3  ATCACDA PTR(31),        /* ADDR OF FIRST ACDEB         *
*           3  ATCSMRQ PTR(31),        /* ADDR OF REQUEST STORAGE     *
*                                      /* ROUTINE                     *
*           3  ATCSMQU PTR(31),        /* ADDR OF QUEUE REQUEST RTNE
*                                         - DOS ONLY                  *
*           3  ATCSMRS PTR(31),        /* ADDR OF RELEASE STORAGE     *
*                                      /* ROUTINE                     *
*           3  ATCSMRC PTR(31),        /* ADDR OF RECOVER STORAGE     *
*                                      /* ROUTINE  - DOS ONLY         *
*           3  ATCSMBQ PTR(31),        /* PTR TO Q'ED REQ. SMS RTN.   *
*           3  ATCFIRA PTR(31),        /* ADDR OF FEEDBACK INITIATION *
*                                      /* RPH                         *
*           3  ATCSRTAD PTR(31),       /* PTR TO SRTADD ROUTINE       *
*           3  ATCSRTDF PTR(31),       /* PTR TO SRTDELE ROUTN        *
*           3  ATCDCC60 PTR(31),       /* PTR TO ISTDCC60 - CTL. LAYER
*                                         MOVE TO USER AREA           *
*           3  ATCDCC61 PTR(31),       /* PTR TO ISTDCC61 - CTL. LAYER
*                                         MOVE FIXED TO PAGABLE       *
*/*  BEGIN 'ANY' DVT                                                  *
*           3  ATCNERST PTR(31),       /* PTR TO ISTDCC00 - REQUEST-ST*
*           3  ATCNERCV PTR(31),       /* PTR TO ISTRCC21-RECEIVE OB  *
*           3  ATCNERNE PTR(31),      /* PTR TO ISTDCC25 - READ-ANY   *
*           3  ATCNERFN PTR(31),      /* PTR TO ISTDCC02 - REQUEST-FN *
*/*  END 'ANY' DVT                                                    *
*           3  ATCAPOST PTR(31),      /* PTR TO VTAM  POST ROUTINE    *
*           3  ATCVTMID CHAR(2),      /* HOST MAJOR NODE I.D.         *
*           3  ATCRSV11 CHAR(2),      /* RESERVED                     *
*           3 ATCRCC63 PTR(31),  /* HSKPANYQ POINTER                  *
*           3 ATCRCC26 PTR(31),  /* SEND RESPONSE POINTER             *
*           3 ATCRCC65 PTR(31),  /* SET RPL POINTER                   *
*           3  ATCNESAL PTR(31),      /* PTR TO ISTDCC24 - SOLICIT-ALL*
*           3  ATCNERAP PTR(31),       /* PTR TO ISTDCC85 - READ ANY
*                                         PURGE                       *
*           3 ATCACTRM FIXED(15),     /* COUNT OF ACTIVE TERMINALS    *
*           3 ATCCIDM BIT(16),        /* CID MASK                     *
*           3 ATCMSGSP BIT(8), /* RESERVED FOR MESAGE SURPRESSION     *
*         2 ATCMAXID PTR(8),   /* MAXIMUM NUMBER OF MAJOR NODES, 0 =
*                                 NUMBER OF ENTRIES IN THE MNT        *
*         2 ATCRSV16 CHAR(2),  /* NOT USED                            *
*         2 ATCMNT PTR(31),    /*PTR TO MAJOR NODE TABLE -SET BY SYS.
*                                DEF. REF. BY ISTSDCCB (CBDEF),    1244
*                                ISTSDCCI (CINDEXY)                   *
*         2 ATCCDADD PTR(31),  /*PTR TO CIDADD ROUTINE ISTSDCCA    1244
*                                 REF. BY CIDCTL MACRO                *
*         2 ATCCDDEL PTR(31),  /*PTR TO CIDDEL ROUTINE ISTSDCCD    1244
*                                 REF. BY CIDCTL MACRO                *
*         2 ATCCDFND PTR(31),  /*PTR TO CIDFND ROUTINE IATSDCCF    1244
*                                 REF. BY CIDCTL MACRO                *
*         2 ATCESC01 PTR(31),  /*PTR TO ESC01                         *
*         2 ATCESC02 PTR(31),  /*PTR TO ESC02                         *
*         2 ATCCSMR PTR(31),        /* PTR TO CONNECTION SERVICES     *
*                                   /*  MASTER ROUTINE                *
*           3 ATCCSMA PTR(31),      /* PTR TO CONNECTION SERVICES  1244
*                                      MASTER ROUTINE                 *
*         2 ATCOCRT PTR(31),        /* PTR TO OPEN/CLOSE ROUTINE      *
*         2 ATCUEP  PTR(31),        /* POINTER TO USER EXIT           *
*         2 ATCSHRTN CHAR(8),       /* NAME OF VTAM  SHARED RTN       *
*                                   /*  TO BE LOADED                  *
*         2 ATCSHRFG BIT(8),        /* ATTRIBUTE FLAGS                *
*           3 ATCLAST BIT(1),       /* INDICATE HTIS IS LAST MODULE   *
*         2 ATCXRANG CHAR(1),       /* NUMBER OT BITS IN X-VALUE   1244
*                                       PORTION   OF CID              *
*         2 ATCSAF   CHAR(2),       /* SUB AREA ADDRESS FIELD         *
*         2 ATCEPA PTR(31),         /* ENTRY POINT ADDR OF LOADED     *
*         2 ATCALERT PTR(31),       /* POINTER TO ALERT-ROUTINE    1244
*                                      ISTSDCAL                       *
*         2 ATCDVLOD PTR(31),       /* PTR TO ISTSDCOD                *
*         2 ATCTRCPT PTR(31),       /* POINTER TO TRACE PARM LIST     *
*         2 ATCDVT   PTR(31),       /* POINTER TO FIRST DVT ON CHAIN  *
*         2 ATCEPT   PTR(31),       /* POINTER TO FIRST EPT ON CHAIN  *
*         2 ATCMSGP PTR(31),        /* POINTER TO TPMSG PROCESSOR     *
*         2 ATCMSGM PTR(31),        /* POINTER TO TPMSG - MESSAGE  1244
*                                      CSECT                          *
*         2 ATCTRPAB  PTR(31),      /* ADDRESS OF TRACE WRITER PAB    *
*         2 ATCVTLOD PTR(31),       /* ADDR OF VTAM LOAD LIST         *
*         2 ATCECPRT CHAR(4),       /* ECB FOR TRACE FILE PRINT       *
*         2 ATCZDVTB PTR(31),       /* ADDRESS OF ISTZCFBI            *
*         2 ATCECTLP CHAR(4),       /* TOLTEP ECB                     *
*         2 ATCRVCHS CHAR(8),       /* RESERVED                       *
*         2 ATCCRME  PTR(31),       /* VARY PSS CONTROL MECHANISM     *
*         2 ATCHPGM,                /* BUFFER INFORMATION            */
*           3 ATCHBFNO FIXED(15),   /* NUMBER OF BUFFS FOR CHANNEL   */
*           3 ATCHBSIZ FIXED(15),   /* BUFFER SIZE IN BYTES          */
*         2 ATCDEBCH PTR(31),       /* CLOSE DEB CHAIN PTR           */
*         2 ATCTODVT PTR(31),       /* THE TOLTEP DVT PTR POINTED  1244
*                                      TO BY 3RD WORD OF PAB         */
*         2 ATCADEL  PTR(31),       /* A DELETE ROUTINE ADDRESS      */
*         2 ATCCDPTR PTR(31),       /* PTR TO ISTOCCCD - DOS ONLY    */
*         2 ATCLDNCS PTR(31),       /* PTR TO NCSPL FOR LOAD/DUMP    */
*         2 ATCLDECB BIT(32),       /* ECB FOR LOAD/DUMP SUBTASK     */
*         2 ATCAPCR5 PTR(31),       /* POINTER TO ISTINCR5           */
*         2 ATCRSV69 PTR(31),       /* RESERVED TO SYNCH WITH DOS    */
*         2 ATCNODEL CHAR(8),       /* VSAM DATA SET NAME            */
*         2 ATCNODDS PTR(31),       /* POINTER TO RPL                */
*         2 ATCONFIG CHAR(8),       /* START VTAM CONFIG = PARAMETER */
*         2 ATCRSV99 CHAR(4),       /* RESERVED FOR LATER POINTERS   */
*         2 ATCAP33 PTR(31),        /* PTR TO ISTAPC33               */
*         2 ATCAP35 PTR(31),        /* PTR TO ISTAPC35               */
*         2 ATCAP36 PTR(31),        /* PTR TO ISTAPC36               */
*         2 ATCDVTLK CHAR(LENGTH(ISTLOK)), /* LOCK WORD FOR DVT LOCK */
*         2 ATCCDFIN PTR(31),       /* POINTER TO ISTSDCRR           */
*         2 ATCCDFDN PTR(31),       /* POINTER TO ISTSDCCN           */
*         2 ATCVOCLK CHAR(LENGTH(ISTLOK)), /* VOCLOCK LOCK           */
*         2 ATCRDTLK CHAR(LENGTH(ISTLOK)), /* RDTLOCK LOCK           */
*         2 ATCRSV97 PTR(31),              /* DWORD ALIGNMENT        */
*         2 ATCVPAB1 CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* PAB FOR VARY
*                                           UNDER PSS CONTROL        */
*         2 ATCPGPAB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* ERP PAB FOR
*                                      PURGE                         */
*         2 ATCDLRPB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* DUMP LOAD &
*                                           RESTART PAB              */
*         2 ATCCCLAD PTR(31),       /* ADDRESS OF VARY ERP (ISTINCCL)*/
*         2 ATCCDLAD PTR(31),       /* ADDRESS OF VARY DUMP,LD RSTRT
*                                      (ISTINCDL)                    */
*         2 ATCOCCOB PTR(31),       /* ADDRESS ISTOCCOB              */
*         2 ATCOCCCB PTR(31),       /* ADDRESS ISTOCCCB              */
*         2 ATCTIPAB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* A PAB   1244
*                                           FOR ISTOLTP              */
*         2 ATCTCIPB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* A PAB   1244
*                                           FOR TOLTEP CLIP          */
*         2 ATCVTIPB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* A PAB   1244
*                                           FOR TOLTEP-VTAM INTERFACE*/
*         2 ATCTCLOM PTR(31),      /* ADDR TOLTEP CLOP PROC          */
*         2 ATCTCLIM PTR(31),      /* ADDR TOLTEP CLIP PROC          */
*         2 ATCVTINM PTR(31),      /* ADDR TOLTEP-VTAM INTF PROC     */
*         2 ATCTACB  PTR(31),      /* TOLTEP ACB                     */
*         2 ATCRSV10 CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* RESERVED  */
*         2 ATCPTR00 CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* A PAB     */
*         2 ATCCFEAD PTR(31),          /* ADDR OF ISTINCFE           */
*         2 ATCVLCNT CHAR(4) BDY(HWORD), /* VARY DEVICE ONLINE COUNTS*/
*           3 ATCRNCNT PTR(16),        /* 370X COUNT                 */
*           3 ATCLCLCT PTR(16),        /* 3270 COUNT                 */
*         2 ATCS49XI PTR(31),          /* ADDRESS OF ISTPICXI        */
*         2 ATCS49XL PTR(31),          /* ADDRESS OF ISTPICXL        */
*         2 ATCPODVT PTR(31),          /* PTR TO PROGRAM OPERATOR DVT*/
*         2 ATCRNO,                                                1244
*           3 *        CHAR(1),                                    1244
*           3 ATCPOIA  PTR(24),        /* PTR TO PROGRAM OPERATOR    */
*                                      /* INTERFACE AREA             */
*         2 ATCSOPD CHAR(8) BDY(WORD), /* SESSION CONTROL            */
*           3 ATCSEC01 PTR(31),        /* OUTBOUND PROCESSING        */
*           3 ATCSEC10 PTR(31),        /* DVT                        */
*         2 ATCSIPD CHAR(12) BDY(WORD),/* SESSION CONTROL            */
*           3 ATCSEC21 PTR(31),        /* INBOUND PROCESSING         */
*           3 ATCSEC30 PTR(31),        /* FEEDBACK                   */
*           3 ATCSEC40 PTR(31),        /* DVT                        */
*         2 ATCSECST CHAR(4) BDY(WORD),/* SESSION CONTROLSESS TERM   */
*           3 ATCSEC51 PTR(31),        /* RECOVERY DVT               */
*         2 ATCNMCTR FIXED(15),        /* NAME COUNTER               */
*         2 ATCSTAT2 BIT(8),           /* TRACE FLAGS                */
*           3 ATCTRAPI BIT(1),         /* API                        */
*           3 ATCTRESC BIT(1),         /* ESC                        */
*           3 ATCTRPSS BIT(1),         /* PSS                        */
*           3 ATCTRLOK BIT(1),         /* LOCKS                      */
*           3 ATCTRSMS BIT(1),         /* SMS                        */
*           3 *        BIT(3),         /* RESERVED                   */
*         2 *        BIT(8),           /* RESERVED                   */
*         2 ATCSRTAB PTR(31),          /* SEARCH LOGON MODE TABLE    */
*                                      /* RTN ADDRESS (ISTINCSH)     */
*         2 ATCUSSPT PTR(31),          /* DEFAULT USS DEFINITION     */
*                                      /* TABLE ADDRESS (ISTINCDT)   */
*         2 ATCMODTB PTR(31),          /* DEFAULT SYSTEM LOGON MODE  */
*                                      /* TABLE ADDRESS (ISTINCLM)   */
*         2 ATCINCW3 PTR(31),          /* ADDRESS OF ISTINCW3        */
*         2 ATCIOECB PTR(31),          /* ECB USED BY IOS -          */
*                                      /* POINTED TO BY IOBECBPT     */
* 2 ATCVDPAB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD),                    1244
*                                    /* SSCP COMMAND PROCESSING PAB  */
* 2 ATCVFPAB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD),                    1244
*                                    /* SSCP FRONT END PAB           */
* 2 ATCVDLOK CHAR(LENGTH(ISTLOK)),   /* SSCP SERIALIZATION LOCK      */
*/* END OF COMMON AREA                                               */
*/* VS1/VS2 COMMON CODE.                                             */
*        2  ATCVTBAM CHAR(4),                                      1244
*           3  *     CHAR(3),          /* RESERVED                    *
*           3  *     CHAR(1),          /* FLAGS                       *
*              4 ATCVTMAB BIT(1) ABNL, /* ABEND IN VTAM JOBSTEP       *
*              4 *        BIT(7),      /* RESERVED                    *
*        2  ATCAOSM BDY(DWORD),                                    1244
*/*                                                                   *
*           3  ATCSRBRT PTR(31),       /* POINTER TO ROUTINE UNDER    *
*                                      /* SRB CONTROL                 *
*           3  ATCGSRBQ PTR(31),       /* READY QUEUE FOR GLOBAL SRB'S*
*              4  ATCGSRBG BIT(8),     /* READY QUEUE GATE BYTE       *
*                 5  ATCGSRBF BIT(1),  /* READY QUEUE GATE BIT        *
*           3  ATCPRPH PTR(31),        /* PTR TO PREALLOCATED RPH     *
*           3  ATCCMTCB PTR(31),       /* PTR TO COMMUNICATIONS TASK  *
*                                      /* TCB                         *
*           3  ATCAP11 PTR(31),        /* PTR TO ISTAPC11             *
*           3  ATCAP12 PTR(31),        /* PTR TO ISTAPC12             *
*           3  ATCAP31 PTR(31),        /* PTR TO ISTAPC31             *
*           3  ATCAP32 PTR(31),        /* PTR TO ISTAPC32             *
*           3  ATCAP34 PTR(31),        /* PTR TO ISTAPC34             *
*           3  ATCAP52 PTR(31),        /* PTR TO ISTAPC52             *
*           3  ATCAP53 PTR(31),        /* PTR TO ISTAPC53             *
*           3  ATCAP54 PTR(31),        /* PTR TO ISTAPC54             *
*           3  ATCAP57 PTR(31),        /* PTR TO ISTAPC57             *
*           3  ATCAP58 PTR(31),        /* PTR TO ISTAPC58             *
*           3  ATCAP61 PTR(31),        /* PTR TO ISTAPC61             *
*           3  ATCAP63 PTR(31),        /* PTR TO ISTAPC63             *
*           3  ATCAP64 PTR(31),        /* PTR TO ISTAPC64             *
*           3  ATCZFSVT PTR(31),       /* TPIOS FIXED SRVICES VCTR TAB*
*           3  ATCZPSVT PTR(31),       /* TPIOS PAGBL SRVCES VCTR TABL*
*           3  ATCICNCB PTR(31),       /* HEAD OF ICNCB QUEUE         *
*           3  ATCZDVT1 PTR(31),       /* TPIOS SLODWN RECOVRY PRCSR  *
*           3  ATCZDVT3 PTR(31),       /* 370X FEEDBACK STAT CNTRL RTR*
*           3  ATCZDVT4 PTR(31),       /* OPERATOR MESSAGE SCHEDULER  *
*           3  ATCZDVT6 PTR(31),       /* DIALOGUE SCHEDULER (INBOUND)*
*           3  ATCAP65 PTR(31),        /* PTR TO ISTAPC65            */
*           3  ATCICAPP CHAR(20) BDY(WORD), /* 3705 APPENDAGE VECTOR  *
*              4  ATCCDRPH PTR(31),    /* ADDR CLOSE DEB RPH       1244
*                                         (DUMMY EOA APP.)           */
*              4  ATCZSIOA PTR(31),    /* ADDR 3705 SIO APPENDAGE    */
*              4  ATCCDTCB PTR(31),    /* VTAM TCB (DUMMY PCI APP.)  */
*              4  ATCZCEA PTR(31),     /* ADDR 3705 CHANNEL END    1244
*                                         APPENDAGE                  */
*              4  ATCZAEA PTR(31),     /* ADDR 3705 CHANNEL END    1244
*                                         APPENDAGE                  */
*           3  ATCLDAPP CHAR(20) BDY(WORD), /* LOCAL 3270 APPENDAGE
*                                         VECTOR                     */
*              4  ATCCDTID PTR(31),    /* TASK ID OF VTAM          1244
*                                         (DUMP EOE)                 */
*              4  ATCSMFRR PTR(31),    /* ADDR OF SMS FRR          1244
*                                         (DUMMY SIOA)               */
*              4  ATCRSV17 PTR(31),    /* RESERVED FOR ALIGNMENT     */
*              4  ATCZLCEA PTR(31),    /* ADDR 3270 CHANNEL END    1244
*                                         APPENDAGE                  */
*              4  ATCZLAEA PTR(31),    /* ADDR 3270 CHANNEL END    1244
*                                         APPENDAGE                  */
*           3  ATCDAPVT CHAR(24) BDY(WORD),  /* DUMMY APPENDAGE    1244
*                                         VECTOR TABLE FOR LOAD/DVMMY*/
*              4  ATCDEOEA PTR(31),    /* ADDRESS OF DUMMY END     1244
*                                         OF EXTENT APPENDAGE        */
*              4  ATCDSIOA PTR(31),    /* ADDRESS OF DUMMY END     1244
*                                         OF SIO APPENDAGE           */
*              4  ATCDPCIA PTR(31),    /* ADDRESS OF DUMMY PCI     1244
*                                         APPENDAGE                  */
*              4  ATCDCEA PTR(31),     /* ADDRESS OF CHANNEL END   1244
*                                         APPENDAGE                  */
*              4  ATCDXCEA PTR(31),    /* ADDRESS OF ABNORMAL      1244
*                                         END APPENDAGE              */
*              4  ATCDAPDG CHAR(2),    /* DUMMY APPENDAGE            */
*              4  ATCRSV56 CHAR(2),    /* RESERVED                   */
*           3  ATCZDVT7 PTR(31),       /* ADDR OF RESET CLEANUP    1244
*                                         (PHASE 1)                   *
*           3  ATCZDVT8 PTR(31),       /* 3270 LOCAL TEST AND CTL  1244
*                                         FEEDBACK ROUTER            */
*           3  ATCZDVT9 PTR(31),       /* ADDRESS OF ISTZDFKA        */
*           3  ATCZDVTA PTR(31),       /* ADDRESS OF ISTZCFIA        */
*           3  ATCZDVTX PTR(31),       /* ADDRESS OF TRUNK LINE    1244
*                                         DEACTIVATE ROUTINE         */
*           3  ATCZLPVT PTR(31),       /* ADDRESS OF ISTZPSVA        */
*           3  ATCZLFVT PTR(31),       /* TPIOS 3270 LOCAL FIXED   1244
*                                         SERVICES VECTOR TABLE      */
*           3  ATCZPAB1 CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* PAB FOR
*                                         TEST AND CTL FEEDBACK ROUTER*
*           3  ATCZPAB2 CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* 370X 1244
*                                         STATUS AND FEEDBACK ROUTER
*                                         DYNAMIC PAB                */
*           3  ATCAP51  PTR(31),       /* PTR TO ISTAPC51            */
*           3  ATCZDFJ0 PTR(31),       /* ADDR OF ISTZDFJ0           */
*           3  ATCAP37  PTR(31),       /* PTR TO ISTAPC37            */
*           3  ATCAP38  PTR(31),       /* PTR TO ISTAPC38            */
*           3  ATCDMAPP PTR(31),       /* DUMMY APPENDAGE ROUTINE    */
*                                      /* FOR ABEND                  */
*           3  ATCRPT12 PTR(31),       /* RESERVED                   */
*        3  ATCCRA   CHAR(8) BDY(DWORD), /* AVAILABLE CRA             *
*           4 ATCCRAQ  PTR(31),          /* QUEUE OF AVAILABLE CRAS   *
*           4 ATCCRACN FIXED(31),        /* COUNTS                    *
*             5 ATCCRARC FIXED(16),      /* ENQUEUE COUNT TO ALLOW    *
*                                        /* MULTIPLE SIMUALTANIOUS    *
*                                        /* ENQUEUES AND DEQUEUES     *
*             5 ATCCRAAC FIXED(16),      /* COUNT OF CRAS ON AVAIL Q  *
*        3  ATCSRB   CHAR(8) BDY(DWORD), /* AVAILABLE SRBS            *
*             4 ATCSRBQ  PTR(31),        /* QUE OF AVAILABLE SRBS     *
*             4 ATCSRBCN FIXED(31),      /* COUNTS                    *
*               5 ATCSRBRC FIXED(16),    /* ENQUEUE COUNT TO ALLOW    *
*                                        /* MULTIPLE SIMUALTANIOUS    *
*                                        /* ENQUEUES AND DEQUEUES     *
*               5 ATCSRBAC FIXED(16),    /* COUNT OF SRBS ON AVAIL Q  *
*        3  ATCCRPL  CHAR(8) BDY(DWORD), /* AVAILABLE CRPLS           *
*             4 ATCCRPLQ PTR(31),        /* QUE OF AVAILABLE CRPLS    *
*             4 ATCRPLCN FIXED(31),      /* COUNTS                    *
*               5 ATCRPLRC FIXED(16),    /* ENQUEUE COUNT TO ALLOW    *
*                                        /* MULTIPLE SIMUALTANIOUS    *
*                                        /* ENQUEUES AND DEQUEUES     *
*               5 ATCRPLAC FIXED(16),    /* COUNT OF CRPLS ON AVAIL Q *
*           3  ATCRPT19 PTR(31),       /* RESERVED                   */
*           3  ATCRPT20 PTR(31),       /* RESERVED                   */
*           3  ATCRPT21 PTR(31),       /* RESERVED                   */
*           3  ATCRPT22 PTR(31),       /* RESERVED                   */
*           3  ATCRPT23 PTR(31),       /* RESERVED                   */
*           3  ATCRPT24 PTR(31),       /* RESERVED                   */
*           3  ATCRPT25 PTR(31),       /* RESERVED                   */
*           3  ATCRPT26 PTR(31),       /* RESERVED                   */
*           3  ATCRPT27 PTR(31),       /* RESERVED                   */
*           3  ATCRPT28 PTR(31),       /* RESERVED                   */
*           3  ATCRPT29 PTR(31),       /* RESERVED                   */
*           3  ATCRPT30 PTR(31),       /* RESERVED                   */
*           3  ATCRPT31 PTR(31),       /* RESERVED                   */
*           3  ATCRPT32 PTR(31),       /* RESERVED                   */
*           3  ATCRPT33 PTR(31),       /* RESERVED                   */
*           3  ATCRPT34 PTR(31),       /* RESERVED                   */
*           3  ATCRPT35 PTR(31),       /* RESERVED                   */
*           3  ATCRPT36 PTR(31),       /* RESERVED                   */
*           3  ATCRPT37 PTR(31),       /* RESERVED                   */
*           3  ATCRPT38 PTR(31),       /* RESERVED                   */
*           3  ATCRPT39 PTR(31),       /* RESERVED                   */
*           3  ATCRPT40 PTR(31),       /* RESERVED                   */
*/* END OF VS1/VS2 COMMON CODE.                                      */
*/* START OF VS2 UNIQUE CODE.                                        */
*           3  ATCVTFLG BIT(32),                                   1244
*              4 ATCVTACT BIT(1),      /* VTT ACTIVE                 */
*              4 *        BIT(31),     /* RESERVED                   */
*           3  ATCHLTCB PTR(31),       /* ECB FOR HALTING VTAM       */
*           3  ATCATA10 PTR(31),       /* PTR TO ISTATM10            */
*           3  ATCZLAAB PTR(31),       /* PTR TO ISTZLFAB            */
*           3  ATCCACXA PTR(31),       /* PTR TO ISTCFCXA            */
*           3  ATCSMARA PTR(31),       /* PTR TO ISTORFRA            */
*           3  ATCSMAID PTR(31),       /* PTR TO ISTORFID            */
*           3  ATCTPWQA PTR(31),       /* WAIT Q ANCHOR FOR TPIOS    */
*           3  ATCSMAPR PTR(31),       /* PTR TO ISTORFPR            */
*           3  ATCSMABF PTR(31),       /* PTR TO ISTORFBF            */
*           3  ATCPSTA  PTR(31),       /* ACTIVE PST QUEUE           */
*           3  ATCAPBE  PTR(31),       /* POINTER TO ISTAICBE        */
*           3  ATCTRMPB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD),         1244
*                                      /* PAB FOR VTAM TERM TASK     */
*           3  ATCTPSPB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD),         1244
*                                      /* PAB FOR TPIOS              */
*           3  ATCAP23  PTR(31),       /* PTR TO ISTAPC23            */
*           3  ATCAPC25 PTR(31),       /* PTR TO ISTAPC25            */
*           3  ATCAP41  PTR(31),       /* PTR TO ISTAPC41            */
*           3  ATCRCFY0 PTR(31),       /* PTR TO ISTRCFY0            */
*           3  ATCAP55  PTR(31),       /* PTR TO ISTAPC55            */
*           3  ATCAP56  PTR(31),       /* PTR TO ISTAPC56            */
*           3  ATCAPC59 PTR(31),       /* PTR TO ISTAPC59            */
*           3  ATCAP62  PTR(31),       /* PTR TO ISTAPC62            */
*           3  ATCAP66  PTR(31),       /* PTR TO ISTAPC66            */
*           3  ATCAP69  PTR(31),       /* PTR TO ISTAPM69            */
*           3  ATCAP82  PTR(31),       /* PTR TO ISTAPC82            */
*           3  ATCAP83  PTR(31),       /* PTR TO ISTAPC83            */
*           3  ATCAP84  PTR(31),       /* PTR TO ISTAPC84            */
*           3  ATCAP85  PTR(31),       /* PTR TO ISTAPC85            */
*           3  ATCAP86  PTR(31),       /* PTR TO ISTAPC86            */
*           3  ATCASCB  PTR(31),       /* PTR TO VTAM ASCB           */
*           3  ATCMPLTA  PTR(31),      /* PTR TO MPST LIST TABLE     */
*           3  ATCZR01  PTR(31),       /* PTR TO ISTZRM01            */
*           3  ATCAICTN PTR(31),       /* PTR TO ISTAICTN            */
*           3  ATCTPCP0 PTR(31),       /* PTR TO ISTZFSAV            */
*           3  ATCTPCP1 PTR(31),       /* PTR TO ISTZ19SV            */
*           3  ATCZFLAG BIT(8),        /* FLAG BYTE                  */
*              4 ATCZF001 BIT(1),      /* MDR RECORDING SUSPENDED    */
*              4 ATCRSV66 BIT(7),      /* RESERVED                   */
*           3  ATCRSV75 BIT(8),        /* RESERVED                   */
*           3  ATCSRBCT FIXED(16),     /* COUNT OF PREALLOCATED SRB'S*/
*           3  ATCCRACT FIXED(16),     /* COUNT OF PREALLOCATED CRA'S*/
*           3  ATCRPLCT FIXED(16),     /* COUNT OF PREALLOCATED CRPL */
*           3  ATCRSV88 PTR(31),       /* RESERVED                   */
*           3  ATCTPMPB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /*TP MSG PAB
*                                                         FOR VS2    */
*           3  ATCTPMMI PTR(31),        /* PTR TO ISTCFMMI - MSG ISSUER
*                                          FOR SRB MODE ROUTINES     */
*           3  ATCVIOPM PTR(31),       /* PTR TO ISTVIOPM            */
*           3  ATCPOPAB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD),         1244
*                   /* POPAB FOR REPLY PROCESSING, POI TERMINATION,  */
*                   /* AND VTAM MESSAGE PROCESSOR                    */
*        2  ATCAOS CHAR(0) BDY(WORD);  /* VS2 ONLY FIELDS            */
*/* VTAM ADDRESS VECTOR TABLE */                                   1245
*/*  REVISIONS                                         002 03/06/75  */
*DCL  1  ISTAVT BDY(WORD) BASED,                                   1245
*       2  ISTACVT PTR(31),            /* ADDR OF VTAM CVT           */
*       2  ISTAS49 PTR(31),            /* ADDR OF SVC 49 CODE        */
*          3  ISTAHIP BIT(1),          /* HALT IN PROGRESS           */
*       2  ISTAS53 PTR(31),            /* ADDR OF SVC 53 CODE        */
*       2  ISTAPSTA PTR(31),           /* ADDR OF APS TABLE          */
*       2  AVTASID FIXED(15),          /* VTAM ASID                  */
*       2  ISTVTTIK FIXED(15),         /* VTAMRP TASK ID             */
*       2  ISTAPSEX PTR(31),           /* ADDR OF APS EXIT           */
*       2  ISTPHNM CHAR(5),            /* PHASE NAME OF TRANSIENT    */
*       2  ISTX1 CHAR(1),              /* TEST FIELD                 */
*       2  ISTARID PTR(15),            /* ADDR OF RID                */
*       2  ISTATRT PTR(15),            /* ADDR OF VTAM GATES IN RETAB*/
*       2  ISTAGTWT PTR(15),           /* ADDR OF GATEWAIT ROUTINE   */
*       2  ISTVTTP  PTR(15),           /* ADDR OF CODE TO CHECK FOR  */
*                                      /* PENDING TIMER INTERRUPT    */
*       2  ISTAVR01 CHAR(2),           /* RESERVED                   */
*       2  ISTPDAVP PTR(31);           /* VECTOR FOR PDAIDS SMS TRACE*/
*                                                                  1246
* DECLARE                                                          1246
*   EMCR0 PTR REG(0),                                              1246
*   EMCR1 PTR REG(1),                                              1246
*   EMCR2 PTR REG(2),                                              1246
*   EMCR3 PTR REG(3),                                              1246
*   EMCR4 PTR REG(4),                                              1246
*   EMCR5 PTR REG(5),                                              1246
*   EMCR6 PTR REG(6),                                              1246
*   EMCR7 PTR REG(7),                                              1246
*   EMCR8 PTR REG(8),                                              1246
*   EMCR9 PTR REG(9),                                              1246
*   EMCR10 PTR REG(10),                                            1246
*   EMCR11 PTR REG(11),                                            1246
*   EMCR12 PTR REG(12),                                            1246
*   EMCR13 PTR REG(13),                                            1246
*   EMCR14 PTR REG(14),                                            1246
*   EMCR15 PTR REG(15);                                            1246
* GEN (PRINT ON);                                                  1247
         PRINT ON
*/* END OF TPEPILOG */                                             1248
*END ISTINCR4                                                      1248
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (IFGRPL  )                                        *
*/*%INCLUDE SYSLIB  (IFGACB  )                                        *
*/*%INCLUDE SYSLIB  (IDAAMB  )                                        *
*/*%INCLUDE SYSLIB  (IDAAMBL )                                        *
*;                                                                 1248
         B     @EL00001                                            1248
@DATA    DS    0H
@DATD    DSECT
         DS    0F
ISTINCR4 CSECT
         DS    0F
@CF00127 DC    F'1'
@CH00127 EQU   @CF00127+2
@CF00197 DC    F'2'
@CH00197 EQU   @CF00197+2
@CF00215 DC    F'3'
@CH00215 EQU   @CF00215+2
@CF00117 DC    F'4'
@CH00117 EQU   @CF00117+2
@CF00203 DC    F'5'
@CH00203 EQU   @CF00203+2
@CF00119 DC    F'8'
@CF02235 DC    XL4'08000000'
@CF02238 DC    XL4'04000000'
@CF02743 DC    XL4'0000FFFF'
@DATD    DSECT
         DS    0D
ISTINCR4 CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
CMZA0006 DS    FL4
         ORG   CMZA0006
@NM00043 DC    AL1(32)
@NM00044 DC    AL1(96)
@NM00045 DC    AL1(231)
@NM00046 DC    XL1'00'
         ORG   CMZA0006+4
CMZA0033 DS    FL4
         ORG   CMZA0033
@NM00049 DC    AL1(0)
@NM00050 DC    AL1(96)
@NM00051 DC    AL1(231)
@NM00052 DC    XL1'01'
         ORG   CMZA0033+4
CMZA0070 DS    FL4
         ORG   CMZA0070
@NM00057 DC    AL1(0)
@NM00058 DC    AL1(96)
@NM00059 DC    AL1(231)
@NM00060 DC    XL1'01'
         ORG   CMZA0070+4
@CC00482 DC    C'180I'
@CC00484 DC    C'181I'
@CC00486 DC    C'182I'
@CC00488 DC    C'184I'
@CC00490 DC    C'185I'
@CC00492 DC    C'421I'
@CB00526 DC    X'000000000000000000000000000000000000000000000000'
@CB00513 EQU   @CB00526
CR4TBL   DC    CL16'0123456789ABCDEF'
ISTINCR4 CSECT
RPLBASE            RPL OPTCD=(DIR,ASY,UPD),AM=VSAM
ACBBASE           ACB MACRF=(DIR,OUT),AM=VSAM
ISTINCR4 CSECT
OPNBASE          OPEN  (CR4ACB),MF=L
CLSBASE          CLOSE  (CR4ACB),MF=L
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
ISTINCR4 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
GPR00F   EQU   @00
GPR00P   EQU   @00
GPR01F   EQU   @01
GPR01P   EQU   @01
GPR02F   EQU   @02
GPR02P   EQU   @02
GPR03F   EQU   @03
GPR03P   EQU   @03
GPR04F   EQU   @04
GPR04P   EQU   @04
GPR05F   EQU   @05
GPR05P   EQU   @05
GPR06F   EQU   @06
GPR10P   EQU   @10
GPR14F   EQU   @14
GPR14P   EQU   @14
GPR15F   EQU   @15
GPR15P   EQU   @15
CR4R01   EQU   @01
CR4RPLAD EQU   @07
CR4NCSAD EQU   @02
CR4R03   EQU   @03
CR4HEDAD EQU   @05
CR4R6    EQU   @06
CR4RDTAD EQU   @08
CR4R09   EQU   @09
CR4MSGNO EQU   @09
CR4MSGTX EQU   @10
CR4PATAD EQU   @10
CR4R13   EQU   @13
CR4R14   EQU   @14
CR4R15   EQU   @15
REG1024  EQU   @01
EMCR13   EQU   @13
REG15024 EQU   @15
REG1052  EQU   @01
REG15052 EQU   @15
REG1061  EQU   @01
REG15061 EQU   @15
RPHPTR   EQU   @01
EMCR0    EQU   @00
EMCR1    EQU   @01
EMCR10   EQU   @10
EMCR11   EQU   @11
EMCR12   EQU   @12
EMCR14   EQU   @14
EMCR15   EQU   @15
EMCR2    EQU   @02
EMCR3    EQU   @03
EMCR4    EQU   @04
EMCR5    EQU   @05
EMCR6    EQU   @06
EMCR7    EQU   @07
EMCR8    EQU   @08
EMCR9    EQU   @09
GPR06P   EQU   @06
GPR07F   EQU   @07
GPR07P   EQU   @07
GPR08F   EQU   @08
GPR08P   EQU   @08
GPR09F   EQU   @09
GPR09P   EQU   @09
GPR10F   EQU   @10
GPR11F   EQU   @11
GPR11P   EQU   @11
GPR12F   EQU   @12
GPR12P   EQU   @12
GPR13F   EQU   @13
GPR13P   EQU   @13
ATCLCPTR EQU   1032
ISTPOHD  EQU   0
POHSTAT  EQU   ISTPOHD+1
ISTPFX   EQU   0
PFXID    EQU   ISTPFX
ISTNCSPL EQU   0
@NM00061 EQU   ISTNCSPL
NCSPFX   EQU   @NM00061
NCSCRWKA EQU   NCSPFX+12
NCSPLVBF EQU   ISTNCSPL+18
NCSPLVFL EQU   ISTNCSPL+20
NCSPLVF1 EQU   ISTNCSPL+21
NCSIORC  EQU   ISTNCSPL+23
NCSCRCMD EQU   ISTNCSPL+50
NCSCRPID EQU   ISTNCSPL+51
NCSPLCMD EQU   ISTNCSPL+60
NCSCMDA  EQU   NCSPLCMD
NCSCRFLG EQU   ISTNCSPL+67
NCSPLWRM EQU   NCSCRFLG
NCSPLRAD EQU   ISTNCSPL+144
NCSIOCID EQU   ISTNCSPL+148
NCSPLCID EQU   NCSIOCID
NCSPLRPH EQU   ISTNCSPL+160
NCSPLFSB EQU   ISTNCSPL+168
NCSPLFL1 EQU   ISTNCSPL+176
NCSPLFL2 EQU   ISTNCSPL+177
NCSPLFL3 EQU   ISTNCSPL+178
NCSPLFL4 EQU   ISTNCSPL+179
NCSPLFL5 EQU   ISTNCSPL+181
NCSPLAPP EQU   ISTNCSPL+216
NCSSENSE EQU   ISTNCSPL+244
NCSCRDTE EQU   ISTNCSPL+264
NCSCRMSK EQU   ISTNCSPL+268
NCSCHKPT EQU   NCSCRMSK
NCSACTV  EQU   NCSCHKPT
NCSPACTV EQU   NCSCHKPT
NCSPOLD  EQU   NCSCHKPT
NCSNRPL  EQU   NCSCHKPT
NCSESLM  EQU   NCSCHKPT
NCSDTRLM EQU   NCSCHKPT
NCSLGAPL EQU   NCSCHKPT
NCSLGMOD EQU   NCSCHKPT
NCSANSMD EQU   NCSCHKPT+1
NCSCUA   EQU   NCSCHKPT+1
NCSRNME  EQU   NCSCHKPT+1
NCSPTUSE EQU   NCSCHKPT+1
NCSCRMOD EQU   NCSCRMSK+2
NCSAIMOD EQU   NCSCRMOD
NCSPTMOD EQU   NCSCRMOD
NCSPLSID EQU   ISTNCSPL+271
NCSPLSTA EQU   NCSPLSID
NCSPLPHD EQU   NCSPLSID+1
NCSAPP   EQU   0
NCSAPBUE EQU   NCSAPP+88
ISTLOK   EQU   0
LOKCHN   EQU   ISTLOK+1
LOKCHNG  EQU   LOKCHN
@NM00067 EQU   LOKCHNG+2
ISTDEVCH EQU   0
DEVSHCH  EQU   ISTDEVCH
DEVCHAR  EQU   DEVSHCH
DEVTCODE EQU   ISTDEVCH+1
DEVFLAGS EQU   ISTDEVCH+3
DEVFCCTL EQU   DEVFLAGS
DEVCHAR3 EQU   DEVFLAGS
ISTRPRE  EQU   0
RPRNAME  EQU   ISTRPRE
RPRCOMID EQU   ISTRPRE+8
RPRDAF   EQU   RPRCOMID+2
RPRELEN  EQU   ISTRPRE+16
RPRPELEN EQU   ISTRPRE+18
RPRENTRY EQU   ISTRPRE+20
RPRFLAGA EQU   ISTRPRE+21
RPRENTED EQU   RPRFLAGA
RPRFLAGB EQU   ISTRPRE+22
RPRCAUSE EQU   ISTRPRE+23
RPRCRCPT EQU   RPRCAUSE
RPRHDTYP EQU   ISTRPRE+27
RPRNSNEA EQU   ISTRPRE+36
RPRFLAGD EQU   ISTRPRE+61
RPRFLAGC EQU   ISTRPRE+62
ISTRCPRE EQU   0
RCPPMODE EQU   ISTRCPRE+91
RCPLGNIN EQU   ISTRCPRE+92
RCPLGNAP EQU   RCPLGNIN
ISTRDT   EQU   0
RDTPLEN  EQU   ISTRDT+72
RDTPRIOR EQU   RDTPLEN
RDTFLAGB EQU   ISTRDT+91
RDTVYRPH EQU   ISTRDT+108
RDTSTCNT EQU   ISTRDT+112
RDTCRSDS EQU   ISTRDT+116
RDTCRSPW EQU   ISTRDT+124
RDTVSRPL EQU   ISTRDT+132
ISTRAP   EQU   0
RAPFLG   EQU   ISTRAP+108
RAPFLGB  EQU   ISTRAP+109
RAPFLGC  EQU   ISTRAP+110
ISTRLC   EQU   0
RLCADR   EQU   ISTRLC+72
RLCFLAG  EQU   RLCADR
RLCRBISA EQU   RLCFLAG
ISTRRN   EQU   0
RRNADR   EQU   ISTRRN+136
RRNFLAG  EQU   RRNADR
RRNRBISA EQU   RRNFLAG
RRNUCBAD EQU   RRNADR+1
RRNRDF   EQU   ISTRRN+172
RRNRDFA  EQU   RRNRDF
RRNRBREM EQU   RRNRDFA
RRNRDFB  EQU   RRNRDF+1
RRNCMF   EQU   ISTRRN+176
RRNCMFA  EQU   RRNCMF
RRNCMFB  EQU   RRNCMF+1
RRNCMFC  EQU   RRNCMF+2
RRNCMFD  EQU   RRNCMF+3
RRNNMDPD EQU   ISTRRN+192
RRNHPRE  EQU   ISTRRN+216
RRNRDCUA EQU   ISTRRN+244
RRNRINNM EQU   ISTRRN+248
ISTRGP   EQU   0
RGPFLG   EQU   ISTRGP+72
ISTRLN   EQU   0
RLNADR   EQU   ISTRLN+72
RLNFLAG  EQU   RLNADR
RLNRBISA EQU   RLNFLAG
RLNUCBAD EQU   RLNADR+1
RLNSTAT1 EQU   ISTRLN+86
RLNSTAT2 EQU   ISTRLN+87
RLNRDF   EQU   ISTRLN+88
RLNRDFA  EQU   RLNRDF
RLNRACNT EQU   RLNRDFA
RLNRACAT EQU   RLNRACNT
RLNPORT  EQU   RLNRDFA
RLNRDFB  EQU   RLNRDF+1
RLNANSWR EQU   RLNRDFB
RLNRATRN EQU   RLNRDFB
RLNCTSES EQU   ISTRLN+95
RLNPOLMT EQU   ISTRLN+100
RLNPAUSE EQU   ISTRLN+101
RLNCRFLG EQU   ISTRLN+102
RLNLSCMD EQU   RLNCRFLG
RLNNPRLM EQU   RLNLSCMD
RLNSESLM EQU   RLNLSCMD
RLNSVSKP EQU   RLNLSCMD
ISTRPT   EQU   0
RPTLNCID EQU   ISTRPT+116
RPTDITT  EQU   ISTRPT+128
RPTATERM EQU   ISTRPT+132
RPTFLAG1 EQU   ISTRPT+140
RPTISTAT EQU   RPTFLAG1
RPTDAFSV EQU   ISTRPT+142
ISTRCL   EQU   0
RCLADR   EQU   ISTRCL+72
RCLFLAG  EQU   RCLADR
RCLRBISA EQU   RCLFLAG
ISTRTR   EQU   0
RTRADR   EQU   ISTRTR+124
RTRFLAG  EQU   RTRADR
RTRRBISA EQU   RTRFLAG
RTRRDFA  EQU   ISTRTR+136
RTRRAALL EQU   RTRRDFA
RTRRDFB  EQU   ISTRTR+137
RTRRDFC  EQU   ISTRTR+138
RTRRDFD  EQU   ISTRTR+139
RTRRDFE  EQU   ISTRTR+140
RTRRDFF  EQU   ISTRTR+141
RTRTRMAX EQU   ISTRTR+142
RTRCRFLG EQU   ISTRTR+143
RTRLSCMD EQU   RTRCRFLG
RTRDTRLM EQU   RTRLSCMD
RTRBSCID EQU   ISTRTR+188
ISTRIN   EQU   0
RINDFD   EQU   ISTRIN+124
RINREMPO EQU   RINDFD
RINNODEF EQU   RINDFD
RINLDISC EQU   RINDFD
RINNODID EQU   ISTRIN+125
RINRLDAF EQU   ISTRIN+126
RINREMOT EQU   ISTRIN+128
RINVPAB  EQU   ISTRIN+132
RINRPHCN EQU   ISTRIN+136
RINNCSPL EQU   ISTRIN+140
RINCNCNT EQU   ISTRIN+144
ISTRDS   EQU   0
ISTDOT   EQU   0
ISTRCC   EQU   0
RCCFLAG  EQU   ISTRCC+73
RCCRBISA EQU   RCCFLAG
RCCFLAGB EQU   ISTRCC+74
RCCSTAID EQU   ISTRCC+78
RCCID48  EQU   RCCSTAID+2
RCCCRFLG EQU   ISTRCC+108
RCCPATHT EQU   ISTRCC+120
RCCPATHZ EQU   ISTRCC+124
ISTRLU   EQU   0
RLUFLAG  EQU   ISTRLU+125
RLURBISA EQU   RLUFLAG
RLUCRFLG EQU   ISTRLU+126
RLUPACE  EQU   ISTRLU+132
RLUNCPPC EQU   ISTRLU+134
RLUUSSTB EQU   ISTRLU+140
RLUMODET EQU   ISTRLU+152
RLULGMOD EQU   ISTRLU+164
ISTRPX   EQU   0
ISTRLX   EQU   0
RLXFLAGA EQU   ISTRLX+76
ISTRSW   EQU   0
ISTRDA   EQU   0
RDAADR   EQU   ISTRDA+72
RDAFLAG  EQU   RDAADR
RDAUCBAD EQU   RDAADR+1
RDADACUA EQU   ISTRDA+76
ISTRLS   EQU   0
ISTDNT   EQU   0
ISTGNT   EQU   0
ISTPAT   EQU   0
PATPTHID EQU   ISTPAT+4
PATFLAGA EQU   ISTPAT+7
PATUSEFG EQU   PATFLAGA
ISTRPH   EQU   0
RPHCNTL  EQU   ISTRPH
RPHFLAGS EQU   RPHCNTL+2
RPHAPTYP EQU   RPHFLAGS
RPHFSTLC EQU   RPHFLAGS
RPHFLGB  EQU   RPHCNTL+3
RPHRPHA  EQU   ISTRPH+4
RPHTSKID EQU   ISTRPH+8
RPHRESMA EQU   ISTRPH+16
RPHWPFLG EQU   RPHRESMA
RPHWT    EQU   RPHWPFLG
RPHPABOF EQU   ISTRPH+20
RPHMAJCB EQU   ISTRPH+21
RPHWEA   EQU   ISTRPH+24
RPHCSPA  EQU   RPHWEA
RPHSRPRM EQU   ISTRPH+28
RPHPABQA EQU   ISTRPH+36
RPHWORK  EQU   ISTRPH+40
RPHSAVE1 EQU   RPHWORK
RPHSBITS EQU   RPHSAVE1+1
IFGRPL   EQU   0
RPLCOMN  EQU   IFGRPL
RPLIDWD  EQU   RPLCOMN
RPLLEN   EQU   RPLIDWD+3
RPLECB   EQU   RPLCOMN+8
RPLFDBWD EQU   RPLCOMN+12
RPLFDBK  EQU   RPLFDBWD+1
RPLRTNCD EQU   RPLFDBK
RPLCNDCD EQU   RPLFDBK+1
RPLCMPON EQU   RPLCNDCD
RPLFDB2  EQU   RPLCMPON
RPLERRCD EQU   RPLCNDCD+1
RPLFDB3  EQU   RPLERRCD
RPLKEYLE EQU   RPLCOMN+16
RPLKEYL  EQU   RPLKEYLE
RPLDACB  EQU   RPLCOMN+24
RPLAREA  EQU   RPLCOMN+32
RPLARG   EQU   RPLCOMN+36
RPLOPTCD EQU   RPLCOMN+40
RPLOPT1  EQU   RPLOPTCD
RPLDIR   EQU   RPLOPT1
RPLSEQ   EQU   RPLOPT1
RPLKGE   EQU   RPLOPT1
RPLECBSW EQU   RPLOPT1
RPLOPT2  EQU   RPLOPTCD+1
RPLADR   EQU   RPLOPT2
RPLUPD   EQU   RPLOPT2
RPLOPT3  EQU   RPLOPTCD+2
RPLOPT4  EQU   RPLOPTCD+3
RPLNXTRP EQU   RPLCOMN+44
RPLRLEN  EQU   RPLCOMN+48
RPLBUFL  EQU   RPLCOMN+52
RPLOPTC2 EQU   RPLCOMN+56
RPLOPT5  EQU   RPLOPTC2
RPLWRTYP EQU   RPLOPT5
RPLOPT6  EQU   RPLOPTC2+1
RPLUNTYP EQU   RPLOPT6
RPLOPT7  EQU   RPLOPTC2+2
RPLCNOPT EQU   RPLOPT7
RPLOPT8  EQU   RPLOPTC2+3
RPLRBAR  EQU   RPLCOMN+60
RPLAIXID EQU   RPLRBAR+2
RPLEXTDS EQU   RPLCOMN+68
RPLEXTD1 EQU   RPLEXTDS
IFGACB   EQU   0
ACBCOMN  EQU   IFGACB
ACBLENG  EQU   ACBCOMN+2
ACBLENG2 EQU   ACBLENG
ACBAMBL  EQU   ACBCOMN+4
ACBJWA   EQU   ACBAMBL
ACBMACRF EQU   ACBCOMN+12
ACBMACR1 EQU   ACBMACRF
ACBADR   EQU   ACBMACR1
ACBCNV   EQU   ACBMACR1
ACBMACR2 EQU   ACBMACRF+1
ACBBUFPL EQU   ACBCOMN+20
ACBMACR3 EQU   ACBBUFPL
ACBRECFM EQU   ACBCOMN+24
ACBCCTYP EQU   ACBCOMN+25
ACBOPT   EQU   ACBCOMN+26
ACBDSORG EQU   ACBOPT
ACBCROPS EQU   ACBDSORG
ACBDVIND EQU   ACBDSORG
ACBPASSW EQU   ACBCOMN+32
ACBEXLST EQU   ACBCOMN+36
ACBDDNM  EQU   ACBCOMN+40
ACBAMETH EQU   ACBDDNM+3
ACBOFLGS EQU   ACBCOMN+48
ACBEXFG  EQU   ACBOFLGS
ACBIOSFG EQU   ACBOFLGS
ACBERFLG EQU   ACBCOMN+49
ACBINFLG EQU   ACBCOMN+50
ACBVVIC  EQU   ACBINFLG
ACBUJFCB EQU   ACBCOMN+52
ACBBLKSZ EQU   ACBCOMN+60
ACBLRECL EQU   ACBCOMN+62
@NM00019 EQU   0
CR4BCKPT EQU   @NM00019+4
CR4FWDPT EQU   @NM00019+8
@NM00021 EQU   @NM00019+12
CR4R140  EQU   @NM00021
CR4R210  EQU   @NM00021+16
CR4R2S   EQU   CR4R210
CR4R410  EQU   CR4R210+8
CR4MSGID EQU   @NM00019+72
CR4R14S1 EQU   @NM00019+76
CR4R14S2 EQU   @NM00019+80
CR4MSGCH EQU   @NM00019+84
CR4MSGAR EQU   @NM00019+104
CR4ERCOD EQU   @NM00019+120
CR4PATNO EQU   @NM00019+122
CR4RECRD EQU   0
CR4KEY   EQU   CR4RECRD
CR4DAF   EQU   CR4KEY
CR4PID   EQU   CR4KEY+2
CR4BTMSK EQU   CR4RECRD+4
CR4CHKPT EQU   CR4BTMSK
CR4ACTV  EQU   CR4CHKPT
CR4PACTV EQU   CR4CHKPT
CR4POLD  EQU   CR4CHKPT
CR4NRPL  EQU   CR4CHKPT
CR4SESLM EQU   CR4CHKPT
CR4DTRLM EQU   CR4CHKPT
CR4LGAPL EQU   CR4CHKPT
CR4LGMDE EQU   CR4CHKPT
CR4ANSMD EQU   CR4CHKPT+1
CR4CUA   EQU   CR4CHKPT+1
CR4RNME  EQU   CR4CHKPT+1
CR4PTUSE EQU   CR4CHKPT+1
@NM00024 EQU   CR4BTMSK+2
CR4ACT   EQU   @NM00024
CR4PORT  EQU   @NM00024
CR4ANSWR EQU   @NM00024
CR4PATUS EQU   @NM00024
CR4CKPT  EQU   @NM00024
CR4FIELD EQU   CR4RECRD+8
CR4GTSTR EQU   0
CR4RPL   EQU   CR4GTSTR
CR4ACB   EQU   CR4GTSTR+76
CR4REC   EQU   CR4GTSTR+152
CR4OPN   EQU   CR4GTSTR+176
CR4CLS   EQU   CR4GTSTR+180
WBITS    EQU   CR4GTSTR+184
FIRSTSW  EQU   WBITS
IDAAMB   EQU   0
AMBEOVR  EQU   IDAAMB+24
AMBFLG0  EQU   AMBEOVR
AMBFLG1  EQU   IDAAMB+25
AMBINBUF EQU   AMBFLG1
AMBDSORG EQU   IDAAMB+26
AMBIOBAD EQU   IDAAMB+28
AMBINFL  EQU   IDAAMB+42
AMBDEBPT EQU   IDAAMB+44
AMBOFLGS EQU   IDAAMB+48
AMBFLG2  EQU   IDAAMB+49
AMBEOVPT EQU   IDAAMB+56
AMBCSWD1 EQU   IDAAMB+84
AMBAFLG  EQU   AMBCSWD1
IDAAMBL  EQU   0
AMBLEOV  EQU   IDAAMBL+12
AMBLEFLG EQU   AMBLEOV
AMBLSHAR EQU   IDAAMBL+33
AMBLFLG1 EQU   IDAAMBL+35
AMBLFLG2 EQU   IDAAMBL+36
AMBLDTA  EQU   IDAAMBL+52
ISTPAB   EQU   0
PABWQCHN EQU   ISTPAB
PABWEQA  EQU   PABWQCHN
PABCHAIN EQU   PABWQCHN+4
PABRPHFG EQU   ISTPAB+12
PABFLAGS EQU   PABRPHFG
PABERLCK EQU   PABFLAGS
PABERRLK EQU   PABERLCK
ISTDYPAB EQU   0
ISTATCVT EQU   0
ATCCOM   EQU   ISTATCVT
ATCSTAT  EQU   ATCCOM
ATCSTAT1 EQU   ATCSTAT
ATCSTFLG EQU   ATCSTAT+1
ATCPOFLG EQU   ATCSTAT+2
ATCSTAT4 EQU   ATCSTAT+3
ATCIOTRC EQU   ATCCOM+140
ATCTHTRC EQU   ATCIOTRC
ATCGTSTR EQU   ATCCOM+164
ATCCSMR  EQU   ISTATCVT+296
ATCSHRFG EQU   ISTATCVT+316
ATCMSGP  EQU   ISTATCVT+344
ATCHPGM  EQU   ISTATCVT+384
ATCVLCNT EQU   ISTATCVT+772
ATCRNO   EQU   ISTATCVT+788
ATCSOPD  EQU   ISTATCVT+792
ATCSIPD  EQU   ISTATCVT+800
ATCSECST EQU   ISTATCVT+812
ATCSTAT2 EQU   ISTATCVT+818
ATCVTBAM EQU   ISTATCVT+908
@NM00084 EQU   ATCVTBAM+3
ATCAOSM  EQU   ISTATCVT+912
ATCGSRBQ EQU   ATCAOSM+4
ATCGSRBG EQU   ATCGSRBQ
ATCAP32  EQU   ATCAOSM+28
ATCICAPP EQU   ATCAOSM+100
ATCLDAPP EQU   ATCAOSM+120
ATCDAPVT EQU   ATCAOSM+140
ATCCRA   EQU   ATCAOSM+280
ATCCRACN EQU   ATCCRA+4
ATCSRB   EQU   ATCAOSM+288
ATCSRBCN EQU   ATCSRB+4
ATCCRPL  EQU   ATCAOSM+296
ATCRPLCN EQU   ATCCRPL+4
ATCVTFLG EQU   ATCAOSM+392
ATCZFLAG EQU   ATCAOSM+588
@NM00047 EQU   0
CMZID024 EQU   @NM00047
@NM00048 EQU   @NM00047+4
CMZRL024 EQU   @NM00048
CMZRA024 EQU   @NM00048+1
CMZEA024 EQU   @NM00047+8
CMZVP024 EQU   @NM00047+12
CMZSA024 EQU   0
CMTA024  EQU   0
@NM00053 EQU   0
CMZID052 EQU   @NM00053
@NM00054 EQU   @NM00053+4
CMZRL052 EQU   @NM00054
CMZRA052 EQU   @NM00054+1
CMZEA052 EQU   @NM00053+8
CMZVP052 EQU   @NM00053+12
CMZSA052 EQU   0
CMTA052  EQU   0
@NM00055 EQU   0
CMZID061 EQU   @NM00055
@NM00056 EQU   @NM00055+4
CMZRL061 EQU   @NM00056
CMZRA061 EQU   @NM00056+1
CMZEA061 EQU   @NM00055+8
CMZVP061 EQU   @NM00055+12
CMZSA061 EQU   0
CMTA061  EQU   0
ISTAVT   EQU   0
ISTAS49  EQU   ISTAVT+4
NCSUSSRU EQU   0
CR4RCB   EQU   RPLRTNCD
CR4ERB   EQU   RPLERRCD
CR4LNFLD EQU   CR4FIELD
CR4PAUSE EQU   CR4LNFLD
CR4POLMT EQU   CR4LNFLD+1
CR4CTSES EQU   CR4LNFLD+2
CR4LGNAP EQU   CR4FIELD
CR4TRMAX EQU   CR4FIELD+8
CR4LGMOD EQU   CR4FIELD+8
CR4RNFLD EQU   CR4FIELD
CR4RINNM EQU   CR4RNFLD
CR4DACUA EQU   CR4RNFLD+8
RTRDNCBA EQU   ISTRTR+40
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
NCSRUITS EQU   NCSUSSRU+2
NCSRULEN EQU   NCSUSSRU
ISTPDAVP EQU   ISTAVT+40
ISTAVR01 EQU   ISTAVT+38
ISTVTTP  EQU   ISTAVT+36
ISTAGTWT EQU   ISTAVT+34
ISTATRT  EQU   ISTAVT+32
ISTARID  EQU   ISTAVT+30
ISTX1    EQU   ISTAVT+29
ISTPHNM  EQU   ISTAVT+24
ISTAPSEX EQU   ISTAVT+20
ISTVTTIK EQU   ISTAVT+18
AVTASID  EQU   ISTAVT+16
ISTAPSTA EQU   ISTAVT+12
ISTAS53  EQU   ISTAVT+8
ISTAHIP  EQU   ISTAS49
ISTACVT  EQU   ISTAVT
ATCAOS   EQU   ISTATCVT+1584
ATCPOPAB EQU   ATCAOSM+640
ATCVIOPM EQU   ATCAOSM+636
ATCTPMMI EQU   ATCAOSM+632
ATCTPMPB EQU   ATCAOSM+600
ATCRSV88 EQU   ATCAOSM+596
ATCRPLCT EQU   ATCAOSM+594
ATCCRACT EQU   ATCAOSM+592
ATCSRBCT EQU   ATCAOSM+590
ATCRSV75 EQU   ATCAOSM+589
ATCRSV66 EQU   ATCZFLAG
ATCZF001 EQU   ATCZFLAG
ATCTPCP1 EQU   ATCAOSM+584
ATCTPCP0 EQU   ATCAOSM+580
ATCAICTN EQU   ATCAOSM+576
ATCZR01  EQU   ATCAOSM+572
ATCMPLTA EQU   ATCAOSM+568
ATCASCB  EQU   ATCAOSM+564
ATCAP86  EQU   ATCAOSM+560
ATCAP85  EQU   ATCAOSM+556
ATCAP84  EQU   ATCAOSM+552
ATCAP83  EQU   ATCAOSM+548
ATCAP82  EQU   ATCAOSM+544
ATCAP69  EQU   ATCAOSM+540
ATCAP66  EQU   ATCAOSM+536
ATCAP62  EQU   ATCAOSM+532
ATCAPC59 EQU   ATCAOSM+528
ATCAP56  EQU   ATCAOSM+524
ATCAP55  EQU   ATCAOSM+520
ATCRCFY0 EQU   ATCAOSM+516
ATCAP41  EQU   ATCAOSM+512
ATCAPC25 EQU   ATCAOSM+508
ATCAP23  EQU   ATCAOSM+504
ATCTPSPB EQU   ATCAOSM+472
ATCTRMPB EQU   ATCAOSM+440
ATCAPBE  EQU   ATCAOSM+436
ATCPSTA  EQU   ATCAOSM+432
ATCSMABF EQU   ATCAOSM+428
ATCSMAPR EQU   ATCAOSM+424
ATCTPWQA EQU   ATCAOSM+420
ATCSMAID EQU   ATCAOSM+416
ATCSMARA EQU   ATCAOSM+412
ATCCACXA EQU   ATCAOSM+408
ATCZLAAB EQU   ATCAOSM+404
ATCATA10 EQU   ATCAOSM+400
ATCHLTCB EQU   ATCAOSM+396
@NM00086 EQU   ATCVTFLG
ATCVTACT EQU   ATCVTFLG
ATCRPT40 EQU   ATCAOSM+388
ATCRPT39 EQU   ATCAOSM+384
ATCRPT38 EQU   ATCAOSM+380
ATCRPT37 EQU   ATCAOSM+376
ATCRPT36 EQU   ATCAOSM+372
ATCRPT35 EQU   ATCAOSM+368
ATCRPT34 EQU   ATCAOSM+364
ATCRPT33 EQU   ATCAOSM+360
ATCRPT32 EQU   ATCAOSM+356
ATCRPT31 EQU   ATCAOSM+352
ATCRPT30 EQU   ATCAOSM+348
ATCRPT29 EQU   ATCAOSM+344
ATCRPT28 EQU   ATCAOSM+340
ATCRPT27 EQU   ATCAOSM+336
ATCRPT26 EQU   ATCAOSM+332
ATCRPT25 EQU   ATCAOSM+328
ATCRPT24 EQU   ATCAOSM+324
ATCRPT23 EQU   ATCAOSM+320
ATCRPT22 EQU   ATCAOSM+316
ATCRPT21 EQU   ATCAOSM+312
ATCRPT20 EQU   ATCAOSM+308
ATCRPT19 EQU   ATCAOSM+304
ATCRPLAC EQU   ATCRPLCN+2
ATCRPLRC EQU   ATCRPLCN
ATCCRPLQ EQU   ATCCRPL
ATCSRBAC EQU   ATCSRBCN+2
ATCSRBRC EQU   ATCSRBCN
ATCSRBQ  EQU   ATCSRB
ATCCRAAC EQU   ATCCRACN+2
ATCCRARC EQU   ATCCRACN
ATCCRAQ  EQU   ATCCRA
ATCRPT12 EQU   ATCAOSM+276
ATCDMAPP EQU   ATCAOSM+272
ATCAP38  EQU   ATCAOSM+268
ATCAP37  EQU   ATCAOSM+264
ATCZDFJ0 EQU   ATCAOSM+260
ATCAP51  EQU   ATCAOSM+256
ATCZPAB2 EQU   ATCAOSM+224
ATCZPAB1 EQU   ATCAOSM+192
ATCZLFVT EQU   ATCAOSM+188
ATCZLPVT EQU   ATCAOSM+184
ATCZDVTX EQU   ATCAOSM+180
ATCZDVTA EQU   ATCAOSM+176
ATCZDVT9 EQU   ATCAOSM+172
ATCZDVT8 EQU   ATCAOSM+168
ATCZDVT7 EQU   ATCAOSM+164
ATCRSV56 EQU   ATCDAPVT+22
ATCDAPDG EQU   ATCDAPVT+20
ATCDXCEA EQU   ATCDAPVT+16
ATCDCEA  EQU   ATCDAPVT+12
ATCDPCIA EQU   ATCDAPVT+8
ATCDSIOA EQU   ATCDAPVT+4
ATCDEOEA EQU   ATCDAPVT
ATCZLAEA EQU   ATCLDAPP+16
ATCZLCEA EQU   ATCLDAPP+12
ATCRSV17 EQU   ATCLDAPP+8
ATCSMFRR EQU   ATCLDAPP+4
ATCCDTID EQU   ATCLDAPP
ATCZAEA  EQU   ATCICAPP+16
ATCZCEA  EQU   ATCICAPP+12
ATCCDTCB EQU   ATCICAPP+8
ATCZSIOA EQU   ATCICAPP+4
ATCCDRPH EQU   ATCICAPP
ATCAP65  EQU   ATCAOSM+96
ATCZDVT6 EQU   ATCAOSM+92
ATCZDVT4 EQU   ATCAOSM+88
ATCZDVT3 EQU   ATCAOSM+84
ATCZDVT1 EQU   ATCAOSM+80
ATCICNCB EQU   ATCAOSM+76
ATCZPSVT EQU   ATCAOSM+72
ATCZFSVT EQU   ATCAOSM+68
ATCAP64  EQU   ATCAOSM+64
ATCAP63  EQU   ATCAOSM+60
ATCAP61  EQU   ATCAOSM+56
ATCAP58  EQU   ATCAOSM+52
ATCAP57  EQU   ATCAOSM+48
ATCAP54  EQU   ATCAOSM+44
ATCAP53  EQU   ATCAOSM+40
ATCAP52  EQU   ATCAOSM+36
ATCAP34  EQU   ATCAOSM+32
ATCAP31  EQU   ATCAOSM+24
ATCAP12  EQU   ATCAOSM+20
ATCAP11  EQU   ATCAOSM+16
ATCCMTCB EQU   ATCAOSM+12
ATCPRPH  EQU   ATCAOSM+8
ATCGSRBF EQU   ATCGSRBG
ATCSRBRT EQU   ATCAOSM
@NM00085 EQU   @NM00084
ATCVTMAB EQU   @NM00084
@NM00083 EQU   ATCVTBAM
ATCVDLOK EQU   ISTATCVT+904
ATCVFPAB EQU   ISTATCVT+872
ATCVDPAB EQU   ISTATCVT+840
ATCIOECB EQU   ISTATCVT+836
ATCINCW3 EQU   ISTATCVT+832
ATCMODTB EQU   ISTATCVT+828
ATCUSSPT EQU   ISTATCVT+824
ATCSRTAB EQU   ISTATCVT+820
@NM00082 EQU   ISTATCVT+819
@NM00081 EQU   ATCSTAT2
ATCTRSMS EQU   ATCSTAT2
ATCTRLOK EQU   ATCSTAT2
ATCTRPSS EQU   ATCSTAT2
ATCTRESC EQU   ATCSTAT2
ATCTRAPI EQU   ATCSTAT2
ATCNMCTR EQU   ISTATCVT+816
ATCSEC51 EQU   ATCSECST
ATCSEC40 EQU   ATCSIPD+8
ATCSEC30 EQU   ATCSIPD+4
ATCSEC21 EQU   ATCSIPD
ATCSEC10 EQU   ATCSOPD+4
ATCSEC01 EQU   ATCSOPD
ATCPOIA  EQU   ATCRNO+1
@NM00080 EQU   ATCRNO
ATCPODVT EQU   ISTATCVT+784
ATCS49XL EQU   ISTATCVT+780
ATCS49XI EQU   ISTATCVT+776
ATCLCLCT EQU   ATCVLCNT+2
ATCRNCNT EQU   ATCVLCNT
ATCCFEAD EQU   ISTATCVT+768
ATCPTR00 EQU   ISTATCVT+736
ATCRSV10 EQU   ISTATCVT+704
ATCTACB  EQU   ISTATCVT+700
ATCVTINM EQU   ISTATCVT+696
ATCTCLIM EQU   ISTATCVT+692
ATCTCLOM EQU   ISTATCVT+688
ATCVTIPB EQU   ISTATCVT+656
ATCTCIPB EQU   ISTATCVT+624
ATCTIPAB EQU   ISTATCVT+592
ATCOCCCB EQU   ISTATCVT+588
ATCOCCOB EQU   ISTATCVT+584
ATCCDLAD EQU   ISTATCVT+580
ATCCCLAD EQU   ISTATCVT+576
ATCDLRPB EQU   ISTATCVT+544
ATCPGPAB EQU   ISTATCVT+512
ATCVPAB1 EQU   ISTATCVT+480
ATCRSV97 EQU   ISTATCVT+476
ATCRDTLK EQU   ISTATCVT+472
ATCVOCLK EQU   ISTATCVT+468
ATCCDFDN EQU   ISTATCVT+464
ATCCDFIN EQU   ISTATCVT+460
ATCDVTLK EQU   ISTATCVT+456
ATCAP36  EQU   ISTATCVT+452
ATCAP35  EQU   ISTATCVT+448
ATCAP33  EQU   ISTATCVT+444
ATCRSV99 EQU   ISTATCVT+440
ATCONFIG EQU   ISTATCVT+432
ATCNODDS EQU   ISTATCVT+428
ATCNODEL EQU   ISTATCVT+420
ATCRSV69 EQU   ISTATCVT+416
ATCAPCR5 EQU   ISTATCVT+412
ATCLDECB EQU   ISTATCVT+408
ATCLDNCS EQU   ISTATCVT+404
ATCCDPTR EQU   ISTATCVT+400
ATCADEL  EQU   ISTATCVT+396
ATCTODVT EQU   ISTATCVT+392
ATCDEBCH EQU   ISTATCVT+388
ATCHBSIZ EQU   ATCHPGM+2
ATCHBFNO EQU   ATCHPGM
ATCCRME  EQU   ISTATCVT+380
ATCRVCHS EQU   ISTATCVT+372
ATCECTLP EQU   ISTATCVT+368
ATCZDVTB EQU   ISTATCVT+364
ATCECPRT EQU   ISTATCVT+360
ATCVTLOD EQU   ISTATCVT+356
ATCTRPAB EQU   ISTATCVT+352
ATCMSGM  EQU   ISTATCVT+348
ATCEPT   EQU   ISTATCVT+340
ATCDVT   EQU   ISTATCVT+336
ATCTRCPT EQU   ISTATCVT+332
ATCDVLOD EQU   ISTATCVT+328
ATCALERT EQU   ISTATCVT+324
ATCEPA   EQU   ISTATCVT+320
ATCSAF   EQU   ISTATCVT+318
ATCXRANG EQU   ISTATCVT+317
ATCLAST  EQU   ATCSHRFG
ATCSHRTN EQU   ISTATCVT+308
ATCUEP   EQU   ISTATCVT+304
ATCOCRT  EQU   ISTATCVT+300
ATCCSMA  EQU   ATCCSMR
ATCESC02 EQU   ISTATCVT+292
ATCESC01 EQU   ISTATCVT+288
ATCCDFND EQU   ISTATCVT+284
ATCCDDEL EQU   ISTATCVT+280
ATCCDADD EQU   ISTATCVT+276
ATCMNT   EQU   ISTATCVT+272
ATCRSV16 EQU   ISTATCVT+270
ATCMAXID EQU   ISTATCVT+269
ATCMSGSP EQU   ATCCOM+268
ATCCIDM  EQU   ATCCOM+266
ATCACTRM EQU   ATCCOM+264
ATCNERAP EQU   ATCCOM+260
ATCNESAL EQU   ATCCOM+256
ATCRCC65 EQU   ATCCOM+252
ATCRCC26 EQU   ATCCOM+248
ATCRCC63 EQU   ATCCOM+244
ATCRSV11 EQU   ATCCOM+242
ATCVTMID EQU   ATCCOM+240
ATCAPOST EQU   ATCCOM+236
ATCNERFN EQU   ATCCOM+232
ATCNERNE EQU   ATCCOM+228
ATCNERCV EQU   ATCCOM+224
ATCNERST EQU   ATCCOM+220
ATCDCC61 EQU   ATCCOM+216
ATCDCC60 EQU   ATCCOM+212
ATCSRTDF EQU   ATCCOM+208
ATCSRTAD EQU   ATCCOM+204
ATCFIRA  EQU   ATCCOM+200
ATCSMBQ  EQU   ATCCOM+196
ATCSMRC  EQU   ATCCOM+192
ATCSMRS  EQU   ATCCOM+188
ATCSMQU  EQU   ATCCOM+184
ATCSMRQ  EQU   ATCCOM+180
ATCACDA  EQU   ATCCOM+176
ATCSTMA  EQU   ATCCOM+172
ATCFRSTR EQU   ATCCOM+168
ATCREADA EQU   ATCCOM+160
ATCALOAD EQU   ATCCOM+156
ATCBLDLA EQU   ATCCOM+152
ATCFBRPH EQU   ATCCOM+148
ATCBFTRC EQU   ATCCOM+144
ATCTPBUF EQU   ATCTHTRC
ATCREMOV EQU   ATCCOM+136
ATCADD   EQU   ATCCOM+132
ATCBPDA  EQU   ATCCOM+128
ATCDVTPT EQU   ATCCOM+124
ATCFEPT  EQU   ATCCOM+120
ATCFDVT  EQU   ATCCOM+116
ATCCONFT EQU   ATCCOM+112
ATCPTCHA EQU   ATCCOM+108
ATCAUTHA EQU   ATCCOM+104
ATCACCTA EQU   ATCCOM+100
ATCRDTH  EQU   ATCCOM+96
ATCFRSCH EQU   ATCCOM+92
ATCFSB   EQU   ATCCOM+88
ATCHLTMS EQU   ATCCOM+84
ATCECPRM EQU   ATCCOM+80
ATCECNET EQU   ATCCOM+76
ATCECOPC EQU   ATCCOM+72
ATCVPARM EQU   ATCCOM+68
ATCECVRQ EQU   ATCCOM+64
ATCECSES EQU   ATCCOM+60
ATCOCHA  EQU   ATCCOM+56
ATCDSPLQ EQU   ATCCOM+52
ATCECDSP EQU   ATCCOM+48
ATCVARYQ EQU   ATCCOM+44
ATCECVRY EQU   ATCCOM+40
ATCHALTQ EQU   ATCCOM+36
ATCECHLT EQU   ATCCOM+32
ATCMODQ  EQU   ATCCOM+28
ATCECMOD EQU   ATCCOM+24
ATCASCHD EQU   ATCCOM+20
ATCSRT   EQU   ATCCOM+16
ATCRDT   EQU   ATCCOM+12
ATCDCFRR EQU   ATCCOM+8
ATCAPI   EQU   ATCCOM+4
ATCRSV04 EQU   ATCSTAT4
ATCVTTRC EQU   ATCSTAT4
ATCNCSD  EQU   ATCSTAT4
ATCMTST  EQU   ATCSTAT4
ATCTPRT  EQU   ATCSTAT4
ATCPRTAT EQU   ATCSTAT4
@NM00079 EQU   ATCPOFLG
ATCPOUNS EQU   ATCPOFLG
ATCHSDMF EQU   ATCSTFLG
@NM00078 EQU   ATCSTAT1
ATCMDHLT EQU   ATCSTAT1
ATCINHLT EQU   ATCSTAT1
ATCNETSL EQU   ATCSTAT1
ATCQKHLT EQU   ATCSTAT1
ATCSNHLT EQU   ATCSTAT1
ATCACTIV EQU   ATCSTAT1
ATCSTART EQU   ATCSTAT1
DYPPAB   EQU   ISTDYPAB+16
DYPRSV01 EQU   ISTDYPAB+12
DYPTSKID EQU   ISTDYPAB+8
DYPCHAIN EQU   ISTDYPAB+4
DYPFLGS  EQU   ISTDYPAB+2
DYPLNGTH EQU   ISTDYPAB+1
DYPTYPE  EQU   ISTDYPAB
PABRPHA  EQU   PABRPHFG+1
PABNODQ  EQU   PABFLAGS
PABINHBT EQU   PABFLAGS
PABERLOK EQU   PABERRLK
PABSSN   EQU   PABFLAGS
PABDYNAM EQU   PABFLAGS
PABNORPR EQU   PABFLAGS
PABPRIOR EQU   PABFLAGS
PABAPYP  EQU   PABFLAGS
PABDVTA  EQU   ISTPAB+9
PABOFFST EQU   ISTPAB+8
PABCHNGP EQU   PABCHAIN+1
PABRSV02 EQU   PABCHAIN
PABDELAY EQU   PABCHAIN
PABRUNNG EQU   PABCHAIN
PABRESET EQU   PABCHAIN
PABUNCON EQU   PABCHAIN
PABCDP   EQU   PABCHAIN
PABRESCH EQU   PABCHAIN
PABCHNG  EQU   PABCHAIN
PABWEQP  EQU   PABWEQA+1
PABRSV01 EQU   PABWEQA
PABWEQG  EQU   PABWEQA
AMBLDS   EQU   IDAAMBL+60
AMBLIX   EQU   IDAAMBL+56
AMBLMIDS EQU   IDAAMBL+42
AMBLNIDS EQU   IDAAMBL+41
@NM00042 EQU   IDAAMBL+40
AMBLNUM  EQU   IDAAMBL+38
AMBLNST  EQU   IDAAMBL+37
@NM00041 EQU   AMBLFLG2
AMBLSTAG EQU   AMBLFLG2
AMBLRST1 EQU   AMBLFLG2
AMBLCKPT EQU   AMBLFLG2
AMBLREST EQU   AMBLFLG2
AMBLDUMY EQU   AMBLFLG1
AMBLCAT  EQU   AMBLFLG1
@NM00040 EQU   AMBLFLG1
AMBLUPD  EQU   AMBLFLG1
AMBLCINV EQU   AMBLFLG1
AMBLFULL EQU   AMBLFLG1
AMBLLEN  EQU   IDAAMBL+34
@NM00039 EQU   AMBLSHAR
AMBLWRIT EQU   AMBLSHAR
AMBLCATO EQU   AMBLSHAR
AMBLPRIM EQU   AMBLSHAR
AMBLID   EQU   IDAAMBL+32
AMBLCBLN EQU   IDAAMBL+30
@NM00038 EQU   IDAAMBL+29
AMBLCBTS EQU   IDAAMBL+28
AMBLCBWA EQU   IDAAMBL+24
AMBLDDNM EQU   IDAAMBL+16
@NM00037 EQU   AMBLEOV+2
AMBLCOMP EQU   AMBLEOV+1
AMBLESET EQU   AMBLEFLG
AMBLWAIT EQU   AMBLEFLG
AMBLACB  EQU   IDAAMBL+8
AMBLSCHN EQU   IDAAMBL+4
AMBLPCHN EQU   IDAAMBL
AMBVIOT  EQU   IDAAMB+116
AMBSZCP  EQU   IDAAMB+114
AMBSZFW  EQU   IDAAMB+112
AMBSZWR  EQU   IDAAMB+110
AMBSZRD  EQU   IDAAMB+108
AMBEXEX  EQU   IDAAMB+100
AMBWSHD  EQU   IDAAMB+96
AMBCPA   EQU   IDAAMB+92
AMBBM2SH EQU   IDAAMB+88
AMBRDCNT EQU   AMBCSWD1+2
@NM00036 EQU   AMBCSWD1+1
@NM00035 EQU   AMBAFLG
AMBCFX   EQU   AMBAFLG
AMBSIS   EQU   AMBAFLG
AMBDFR   EQU   AMBAFLG
AMBICI   EQU   AMBAFLG
AMBGSR   EQU   AMBAFLG
AMBLSR   EQU   AMBAFLG
@NM00034 EQU   AMBAFLG
AMBUPLH  EQU   IDAAMB+80
AMBPAMBL EQU   IDAAMB+76
AMBPIXP  EQU   IDAAMB+72
@NM00033 EQU   IDAAMB+68
AMBIWA   EQU   IDAAMB+64
AMBWKA   EQU   IDAAMB+60
AMBAMBXN EQU   AMBEOVPT
AMBEDB   EQU   IDAAMB+52
AMBRPT   EQU   IDAAMB+50
AMBPUG   EQU   AMBFLG2
AMBBUSY  EQU   AMBOFLGS
AMBEXFG  EQU   AMBOFLGS
@NM00032 EQU   AMBOFLGS
AMBOPEN  EQU   AMBOFLGS
@NM00031 EQU   AMBOFLGS
AMBDEBAD EQU   AMBDEBPT+1
AMBIFLGS EQU   AMBDEBPT
AMBAMETH EQU   IDAAMB+43
AMBUPX   EQU   AMBINFL
AMBUCRA  EQU   AMBINFL
AMBSCRA  EQU   AMBINFL
AMBCAT   EQU   AMBINFL
@NM00030 EQU   AMBINFL
@NM00029 EQU   AMBINFL
AMBTIOT  EQU   IDAAMB+40
@NM00028 EQU   IDAAMB+38
AMBDDSN  EQU   IDAAMB+35
AMBCDSN  EQU   IDAAMB+32
AMBIOMB  EQU   AMBIOBAD
@NM00027 EQU   AMBDSORG+1
AMBDORGA EQU   AMBDSORG+1
@NM00026 EQU   AMBDSORG
AMBJRN   EQU   AMBFLG1
AMBUBF   EQU   AMBFLG1
AMBSPEED EQU   AMBFLG1
AMBPCAT  EQU   AMBFLG1
AMBMCAT  EQU   AMBFLG1
AMBTYPE  EQU   AMBFLG1
AMBCREAT EQU   AMBFLG1
@NM00025 EQU   AMBFLG0
AMBPSDS  EQU   AMBFLG0
AMBDSB   EQU   IDAAMB+20
AMBCACB  EQU   IDAAMB+16
AMBPH    EQU   IDAAMB+12
AMBBUFC  EQU   IDAAMB+8
AMBLINK  EQU   IDAAMB+4
AMBLEN   EQU   IDAAMB+2
AMBRSC   EQU   IDAAMB+1
AMBID    EQU   IDAAMB
CR4RSVD3 EQU   WBITS
CR4RSVD2 EQU   @NM00024
CR4RSVD1 EQU   CR4CHKPT+1
@NM00023 EQU   CR4R210+4
@NM00022 EQU   @NM00021+12
@NM00020 EQU   @NM00019
ACBAPID  EQU   ACBCOMN+72
ACBCBMWA EQU   ACBCOMN+68
ACBUAPTR EQU   ACBCOMN+64
ACBMSGLN EQU   ACBBLKSZ
ACBBUFSP EQU   ACBCOMN+56
@NM00018 EQU   ACBUJFCB+1
ACBOPTN  EQU   ACBUJFCB
@NM00017 EQU   ACBINFLG+1
ACBBYPSS EQU   ACBINFLG
ACBSDS   EQU   ACBVVIC
ACBUCRA  EQU   ACBINFLG
ACBSCRA  EQU   ACBINFLG
ACBCAT   EQU   ACBINFLG
ACBIJRQE EQU   ACBINFLG
ACBJEPS  EQU   ACBINFLG
@NM00016 EQU   ACBINFLG
ACBBUSY  EQU   ACBIOSFG
ACBLOCK  EQU   ACBEXFG
@NM00015 EQU   ACBOFLGS
ACBDSERR EQU   ACBOFLGS
ACBOPEN  EQU   ACBOFLGS
ACBEOV   EQU   ACBOFLGS
@NM00014 EQU   ACBOFLGS
ACBDEB   EQU   ACBDDNM+5
ACBERFL  EQU   ACBDDNM+4
ACBAM    EQU   ACBAMETH
ACBINFL  EQU   ACBDDNM+2
ACBTIOT  EQU   ACBDDNM
ACBUEL   EQU   ACBEXLST
ACBMSGAR EQU   ACBCOMN+28
@NM00013 EQU   ACBDSORG+1
ACBDORGA EQU   ACBDSORG+1
@NM00012 EQU   ACBDSORG
ACBOPTJ  EQU   ACBDVIND
ACBCRNRE EQU   ACBCROPS
ACBCRNCK EQU   ACBCROPS
ACBASA   EQU   ACBCCTYP
@NM00011 EQU   ACBCCTYP
ACBTRCID EQU   ACBCCTYP
@NM00010 EQU   ACBRECFM
ACBRECAF EQU   ACBRECFM
ACBJBUF  EQU   ACBBUFPL+2
ACBMACR4 EQU   ACBBUFPL+1
@NM00009 EQU   ACBMACR3
ACBNCFX  EQU   ACBMACR3
ACBSIS   EQU   ACBMACR3
ACBDFR   EQU   ACBMACR3
ACBICI   EQU   ACBMACR3
ACBGSR   EQU   ACBMACR3
ACBLSR   EQU   ACBMACR3
@NM00008 EQU   ACBMACR3
ACBBUFNI EQU   ACBCOMN+18
ACBBUFND EQU   ACBCOMN+16
ACBSTRNO EQU   ACBCOMN+15
ACBBSTNO EQU   ACBCOMN+14
ACBAIX   EQU   ACBMACR2
ACBDSN   EQU   ACBMACR2
ACBRST   EQU   ACBMACR2
ACBLOGON EQU   ACBMACR2
ACBSKP   EQU   ACBMACR2
@NM00007 EQU   ACBMACR2
ACBUBF   EQU   ACBMACR1
ACBOUT   EQU   ACBMACR1
ACBIN    EQU   ACBMACR1
ACBDIR   EQU   ACBMACR1
ACBSEQ   EQU   ACBMACR1
ACBBLK   EQU   ACBCNV
ACBADD   EQU   ACBADR
ACBKEY   EQU   ACBMACR1
ACBINRTN EQU   ACBCOMN+8
ACBIBCT  EQU   ACBJWA
ACBLEN2  EQU   ACBLENG2
ACBSTYP  EQU   ACBCOMN+1
ACBID    EQU   ACBCOMN
RPLERMSA EQU   RPLCOMN+72
RPLEMLEN EQU   RPLCOMN+70
RPLACTIV EQU   RPLCOMN+69
RPLBRANC EQU   RPLEXTD1
RPLNIB   EQU   RPLEXTD1
@NM00006 EQU   RPLEXTD1
RPLEXIT  EQU   RPLEXTD1
RPLNEXIT EQU   RPLEXTD1
RPLEXSCH EQU   RPLEXTD1
RPLDDDD  EQU   RPLRBAR+4
@NM00005 EQU   RPLRBAR+3
@NM00004 EQU   RPLAIXID
RPLAXPKP EQU   RPLAIXID
RPLAIXPC EQU   RPLRBAR
RPLRSV88 EQU   RPLOPT8
RPLUNCON EQU   RPLOPT8
RPLACTV  EQU   RPLOPT8
RPLSESS  EQU   RPLOPT8
RPLPEND  EQU   RPLOPT8
RPLODPRM EQU   RPLOPT8
RPLODACP EQU   RPLOPT8
RPLODACQ EQU   RPLOPT8
RPLRSV78 EQU   RPLOPT7
RPLTCRNO EQU   RPLOPT7
RPLRLSOP EQU   RPLOPT7
RPLTPOST EQU   RPLOPT7
RPLQOPT  EQU   RPLOPT7
RPLCNIMM EQU   RPLCNOPT
RPLCNANY EQU   RPLCNOPT
RPLCNALL EQU   RPLCNOPT
RPLRSV68 EQU   RPLOPT6
RPLRSV67 EQU   RPLOPT6
RPLLOCK  EQU   RPLOPT6
RPLNCOND EQU   RPLOPT6
RPLCOND  EQU   RPLOPT6
RPLEOT   EQU   RPLUNTYP
RPLEOM   EQU   RPLUNTYP
RPLEOB   EQU   RPLUNTYP
RPLWROPT EQU   RPLOPT5
RPLNODE  EQU   RPLOPT5
RPLERACE EQU   RPLWRTYP
RPLEAU   EQU   RPLWRTYP
RPLNERAS EQU   RPLWRTYP
RPLPSOPT EQU   RPLOPT5
@NM00003 EQU   RPLOPT5
RPLDLGIN EQU   RPLOPT5
RPLCHAIN EQU   RPLNXTRP
RPLBOP   EQU   RPLOPT4
@NM00002 EQU   RPLOPT4
RPLMKFRM EQU   RPLOPT4
RPLENDTR EQU   RPLOPT4
RPLALIGN EQU   RPLOPT3
RPLFMT   EQU   RPLOPT3
RPLFLD   EQU   RPLOPT3
RPLVFY   EQU   RPLOPT3
RPLBLK   EQU   RPLOPT3
RPLSFORM EQU   RPLOPT3
RPLEODS  EQU   RPLOPT3
RPLNSP   EQU   RPLOPT2
@NM00001 EQU   RPLOPT2
RPLLRD   EQU   RPLOPT2
RPLBWD   EQU   RPLOPT2
RPLCNV   EQU   RPLOPT2
RPLADD   EQU   RPLADR
RPLKEY   EQU   RPLOPT2
RPLECBIN EQU   RPLECBSW
RPLGEN   EQU   RPLOPT1
RPLASY   EQU   RPLOPT1
RPLSKP   EQU   RPLOPT1
RPLLOC   EQU   RPLOPT1
RPLDAF   EQU   RPLARG+2
RPLSAF   EQU   RPLARG
RPLTCBPT EQU   RPLCOMN+28
RPLCCHAR EQU   RPLCOMN+20
RPLSTRID EQU   RPLCOMN+18
RPLRDSOH EQU   RPLFDB3
RPLRLG   EQU   RPLFDB3
RPLLGFRC EQU   RPLFDB3
RPLREOT  EQU   RPLFDB3
RPLREOM  EQU   RPLFDB3
RPLREOB  EQU   RPLFDB3
RPLSV32  EQU   RPLFDB3
RPLUINPT EQU   RPLFDB3
RPLSTSAV EQU   RPLFDB2
RPLCUERR EQU   RPLFDB2
RPLDLGFL EQU   RPLFDB2
RPLIOERR EQU   RPLFDB2
RPLDVUNS EQU   RPLFDB2
RPLATND  EQU   RPLFDB2
RPLRVID  EQU   RPLFDB2
RPLERLK  EQU   RPLFDB2
RPLERREG EQU   RPLRTNCD
RPLSTAT  EQU   RPLFDBWD
RPLPOST  EQU   RPLECB
RPLWAIT  EQU   RPLECB
RPLPLHPT EQU   RPLCOMN+4
RPLLEN2  EQU   RPLLEN
RPLREQ   EQU   RPLIDWD+2
RPLSTYP  EQU   RPLIDWD+1
RPLID    EQU   RPLIDWD
RPHNEXPO EQU   ISTRPH+104
RPHSAV16 EQU   RPHWORK+60
RPHSAV15 EQU   RPHWORK+56
RPHSAV14 EQU   RPHWORK+52
RPHSAV13 EQU   RPHWORK+48
RPHSAV12 EQU   RPHWORK+44
RPHSAV11 EQU   RPHWORK+40
RPHSAV10 EQU   RPHWORK+36
RPHSAVE9 EQU   RPHWORK+32
RPHSAVE8 EQU   RPHWORK+28
RPHSAVE7 EQU   RPHWORK+24
RPHSAVE6 EQU   RPHWORK+20
RPHSAVE5 EQU   RPHWORK+16
RPHSAVE4 EQU   RPHWORK+12
RPHSAVE3 EQU   RPHWORK+8
RPHSAVE2 EQU   RPHWORK+4
RPHSHALF EQU   RPHSAVE1+2
RPHSBIT8 EQU   RPHSBITS
RPHSBIT7 EQU   RPHSBITS
RPHSBIT6 EQU   RPHSBITS
RPHSBIT5 EQU   RPHSBITS
RPHSBIT4 EQU   RPHSBITS
RPHSBIT3 EQU   RPHSBITS
RPHSBIT2 EQU   RPHSBITS
RPHSBIT1 EQU   RPHSBITS
RPHSBYTE EQU   RPHSAVE1
RPHPABQP EQU   RPHPABQA+1
RPHPABFG EQU   RPHPABQA
RPHCRR   EQU   ISTRPH+32
RPHSRP34 EQU   RPHSRPRM+2
RPHSRP12 EQU   RPHSRPRM
RPHWEGT  EQU   RPHCSPA
RPHRESUM EQU   RPHRESMA+1
RPHRSV01 EQU   RPHWPFLG
RPHPURGE EQU   RPHWPFLG
RPHPT    EQU   RPHWPFLG
RPHRSKEY EQU   RPHWPFLG
RPHDVTA  EQU   ISTRPH+12
RPHTIK   EQU   RPHTSKID+3
@NM00077 EQU   RPHTSKID
RPHRPHAP EQU   RPHRPHA+1
@NM00076 EQU   RPHRPHA
RPHGATE  EQU   RPHRPHA
@NM00075 EQU   RPHFLGB
RPHRLCRA EQU   RPHFLGB
RPHNRSAV EQU   RPHFLGB
RPHPGCMP EQU   RPHFLGB
RPHFBAPS EQU   RPHFLGB
RPHBSSP  EQU   RPHFLGB
RPHLOCK  EQU   RPHFLGB
RPHFNFLG EQU   RPHFSTLC
RPHMLTCP EQU   RPHFLAGS
RPHSMCLR EQU   RPHFLAGS
RPHSMTYP EQU   RPHFLAGS
RPHSMQ   EQU   RPHFLAGS
RPHAUTEX EQU   RPHAPTYP
RPHSPGIN EQU   RPHFLAGS
RPHOGIND EQU   RPHFLAGS
RPHLNGTH EQU   RPHCNTL+1
RPHTYPE  EQU   RPHCNTL
PATRSV01 EQU   PATFLAGA
PATRDCNT EQU   ISTPAT+6
PATGRPID EQU   ISTPAT+5
PATDINDX EQU   ISTPAT+2
PATGINDX EQU   ISTPAT
GNTGRPNM EQU   ISTGNT
DNTTELNO EQU   ISTDNT+1
DNTCTDIG EQU   ISTDNT
RLSRSV02 EQU   ISTRLS+140
RLSRSV01 EQU   ISTRLS+138
RLSCTELU EQU   ISTRLS+136
RLSPRE   EQU   ISTRLS
RDARSVPT EQU   ISTRDA+84
RDAPUBI  EQU   ISTRDA+83
RDADFCUA EQU   ISTRDA+80
RDACTPCC EQU   ISTRDA+79
RDALUBA  EQU   RDAUCBAD+1
RDACHQI  EQU   RDAUCBAD
RDARSV01 EQU   RDAFLAG
RDARBISA EQU   RDAFLAG
RDAPRE   EQU   ISTRDA
RSWRSV01 EQU   ISTRSW+152
RSWRSV02 EQU   ISTRSW+150
RSWCTELU EQU   ISTRSW+148
RSWGRUPZ EQU   ISTRSW+146
RSWDIALZ EQU   ISTRSW+144
RSWGRUPT EQU   ISTRSW+140
RSWDIALT EQU   ISTRSW+136
RSWPRE   EQU   ISTRSW
RLXRSV03 EQU   ISTRLX+80
RLXRSV02 EQU   ISTRLX+77
RLXRSV01 EQU   RLXFLAGA
RLXINUSE EQU   RLXFLAGA
RLXNLUX  EQU   ISTRLX+72
RLXPRE   EQU   ISTRLX
RPXRSV01 EQU   ISTRPX+80
RPXRSV02 EQU   ISTRPX+77
RPXMAXLU EQU   ISTRPX+76
RPXFLUX  EQU   ISTRPX+72
RPXPRE   EQU   ISTRPX
RLURSV02 EQU   ISTRLU+172
RLUMODEP EQU   RLUMODET+8
RLUMODEN EQU   RLUMODET
RLUUSSPT EQU   RLUUSSTB+8
RLUUSSNM EQU   RLUUSSTB
RLURSV01 EQU   ISTRLU+137
RLULOCAD EQU   ISTRLU+136
RLUNCPPM EQU   RLUNCPPC+1
RLUNCPPN EQU   RLUNCPPC
RLUPACEM EQU   RLUPACE+1
RLUPACEN EQU   RLUPACE
RLUINTA  EQU   ISTRLU+128
RLUSSCFM EQU   ISTRLU+127
RLUCRRSV EQU   RLUCRFLG
RLUACTLU EQU   RLUCRFLG
RLURSV00 EQU   RLUFLAG
RLUNDSES EQU   RLUFLAG
RLUGSTAT EQU   RLUFLAG
RLUBATCH EQU   RLUFLAG
RLUTYPE  EQU   ISTRLU+124
RLUCRPR  EQU   ISTRLU
RCCRVPT2 EQU   ISTRCC+144
RCCXTOSW EQU   ISTRCC+140
RCCSWTOX EQU   ISTRCC+136
RCCRSPT2 EQU   ISTRCC+133
RCCADDR  EQU   ISTRCC+132
RCCPASSL EQU   ISTRCC+131
RCCMXOUT EQU   ISTRCC+130
RCCMXDAT EQU   ISTRCC+128
RCCINDEX EQU   ISTRCC+126
RCCDPQ   EQU   ISTRCC+116
RCCTPAB  EQU   ISTRCC+112
RCCRSV02 EQU   ISTRCC+109
RCCCRRSV EQU   RCCCRFLG
RCCCTCFL EQU   RCCCRFLG
RCCACTPU EQU   RCCCRFLG
RCCNCSPL EQU   ISTRCC+104
RCCRPHCN EQU   ISTRCC+100
RCCEPAB  EQU   ISTRCC+96
RCCDPAB  EQU   ISTRCC+92
RCCVPAB  EQU   ISTRCC+88
@NM00074 EQU   ISTRCC+87
RCCSESCT EQU   ISTRCC+86
RCCIDNUM EQU   RCCID48+3
RCCIDBLK EQU   RCCID48+2
RCCIDPA2 EQU   RCCID48+1
RCCIDPUT EQU   RCCID48
RCCIDPA1 EQU   RCCSTAID
RCCCTELU EQU   ISTRCC+76
RCCCNCNT EQU   ISTRCC+75
RCCRTGOH EQU   RCCFLAGB
RCCBRKCN EQU   RCCFLAGB
RCCRESET EQU   RCCFLAGB
RCCFINAL EQU   RCCFLAGB
RCCBNNSP EQU   RCCFLAGB
RCCIRETR EQU   RCCFLAGB
RCCDIALP EQU   RCCFLAGB
RCCDSTCT EQU   RCCFLAGB
RCCCTPGD EQU   RCCFLAG
RCCPRGDN EQU   RCCFLAG
RCCOUERP EQU   RCCFLAG
RCCOHIMM EQU   RCCFLAG
RCCLDISC EQU   RCCFLAG
RCCERPIP EQU   RCCFLAG
RCCCUDIE EQU   RCCFLAG
RCCTYPE  EQU   ISTRCC+72
RCCPRE   EQU   ISTRCC
DOTADTRM EQU   ISTDOT
RDSADDOT EQU   ISTRDS+76
RDSCTATR EQU   ISTRDS+74
RDSCTTRM EQU   ISTRDS+72
RDSPRE   EQU   ISTRDS
RINRSV05 EQU   ISTRIN+156
RINRSV04 EQU   ISTRIN+152
RINLOCRN EQU   ISTRIN+148
RINRSV02 EQU   ISTRIN+145
RTRCNCNT EQU   RINCNCNT
RTRNCSPL EQU   RINNCSPL
RTRRPHCN EQU   RINRPHCN
RTRVPAB  EQU   RINVPAB
RTRREMOT EQU   RINREMOT
RTRRLDAF EQU   RINRLDAF
RTRNODID EQU   RINNODID
RINRSV01 EQU   RINDFD
RTRLDISC EQU   RINLDISC
RTRNODEF EQU   RINNODEF
RTRREMPO EQU   RINREMPO
RINCRPRE EQU   ISTRIN
RTRRSV04 EQU   ISTRTR+210
RTRLCTI  EQU   ISTRTR+209
RTRIDCAS EQU   RTRBSCID+1
RTRIDLEN EQU   RTRBSCID
RTRRSVDD EQU   ISTRTR+181
RTRRDFG  EQU   ISTRTR+180
RTRDIAA  EQU   ISTRTR+176
RTRPOLA  EQU   ISTRTR+172
RTRCADDR EQU   ISTRTR+164
RTRCTADR EQU   ISTRTR+162
RTRCTPOL EQU   ISTRTR+160
RTRCTDIA EQU   ISTRTR+158
RTRRSV03 EQU   ISTRTR+156
RTRRVPT1 EQU   ISTRTR+152
RTRBHSN1 EQU   ISTRTR+144
RTRCRSV2 EQU   RTRCRFLG
RTRCRSV1 EQU   RTRCRFLG
RTRRSV24 EQU   RTRRDFF
RTRRFDEK EQU   RTRRDFF
RTRRFANK EQU   RTRRDFF
RTRRFPFK EQU   RTRRDFF
RTRRFPEN EQU   RTRRDFF
RTRRFXCT EQU   RTRRDFF
RTRRESCT EQU   RTRRDFE
RTRRESUP EQU   RTRRDFE
RTRREATT EQU   RTRRDFE
RTRRECHK EQU   RTRRDFE
RTRREACR EQU   RTRRDFE
RTRRSV0A EQU   RTRRDFE
RTRREBRK EQU   RTRRDFE
RTRRSV11 EQU   RTRRDFD
RTRRSV10 EQU   RTRRDFD
RTRRDBHI EQU   RTRRDFD
RTRRDBHD EQU   RTRRDFD
RTRRDBHN EQU   RTRRDFD
RTRRSV23 EQU   RTRRDFC
RTRRCXMS EQU   RTRRDFC
RTRRCMSG EQU   RTRRDFC
RTRRCBLK EQU   RTRRDFC
RTRRCPT3 EQU   RTRRDFC
RTRRCIT2 EQU   RTRRDFC
RTRRCIT1 EQU   RTRRDFC
RTRRSV32 EQU   RTRRDFB
RTRRBEND EQU   RTRRDFB
RTRRBECT EQU   RTRRDFB
RTRRSV02 EQU   RTRRDFA
RTRRACTR EQU   RTRRDFA
RTRRSV60 EQU   RTRRDFA
RTRRACDT EQU   RTRRDFA
RTRRAPT3 EQU   RTRRAALL
RTRRAPT2 EQU   RTRRAALL
RTRRAPT1 EQU   RTRRAALL
RTRRAATN EQU   RTRRDFA
RTRRSV45 EQU   ISTRTR+132
RTRRSV01 EQU   ISTRTR+130
RTRCTECM EQU   ISTRTR+128
RTRADRPT EQU   RTRADR+1
RTRRSV22 EQU   RTRFLAG
RTRVTERM EQU   RTRFLAG
RTRRSV51 EQU   RTRFLAG
RTRRSV21 EQU   RTRFLAG
RTRCRPR  EQU   ISTRTR
RCLRVPT2 EQU   ISTRCL+92
RCLRVPT1 EQU   ISTRCL+88
RCLGPOLA EQU   ISTRCL+84
RCLCTNGP EQU   ISTRCL+82
RCLRSV01 EQU   ISTRCL+80
RCLCTECM EQU   ISTRCL+78
RCLCTETR EQU   ISTRCL+76
RCLGPADR EQU   RCLADR+1
RCLRSV33 EQU   RCLFLAG
RCLBATCH EQU   RCLFLAG
RCLRSV22 EQU   RCLFLAG
RCLPRE   EQU   ISTRCL
RPTRSV03 EQU   ISTRPT+156
RPTRSV02 EQU   ISTRPT+152
RPTNSNSV EQU   ISTRPT+148
RPTPTHCT EQU   ISTRPT+146
RPTPEPCT EQU   ISTRPT+144
RPTRSV01 EQU   ISTRPT+141
RPTDYNAM EQU   RPTFLAG1
RPTVYIMM EQU   RPTFLAG1
RPTVIODN EQU   RPTFLAG1
RPTONLIN EQU   RPTFLAG1
RPTHLVPD EQU   RPTFLAG1
RPTVRYPD EQU   RPTFLAG1
RPTASLEP EQU   RPTFLAG1
RPTUTERM EQU   ISTRPT+136
RPTDIVT  EQU   RPTDITT
RPTCTNM  EQU   ISTRPT+120
RPTLNDAF EQU   RPTLNCID+2
RPTLNSAF EQU   RPTLNCID
RPTLN    EQU   ISTRPT
RLNRVPT2 EQU   ISTRLN+112
RLNNCSPL EQU   ISTRLN+108
RLNX2SW  EQU   ISTRLN+104
@NM00073 EQU   ISTRLN+103
RLNCRRSV EQU   RLNCRFLG
RLNSWEP  EQU   RLNCRFLG
RLNSWNCP EQU   RLNCRFLG
RLNACTLN EQU   RLNCRFLG
RLNACTSN EQU   ISTRLN+98
RLNRESV1 EQU   ISTRLN+97
RLNACTRM EQU   ISTRLN+96
RLNRDSLM EQU   ISTRLN+94
RLNAUTOA EQU   ISTRLN+92
RLNRDFD  EQU   RLNRDF+3
RLNRDFC  EQU   RLNRDF+2
RLNMULTP EQU   RLNRDFB
RLNRAPOL EQU   RLNRDFB
RLNTTV   EQU   RLNRDFB
RLNRSV0B EQU   RLNRDFB
RLNAUTOD EQU   RLNRDFB
RLNRBUSE EQU   RLNRDFB
RLNRAPEP EQU   RLNRDFA
RLNRANCP EQU   RLNRDFA
RLNRAEP  EQU   RLNRDFA
RLNIDV   EQU   RLNRDFA
RLNGANSW EQU   RLNRDFA
RLNRACAN EQU   RLNRACNT
RLNRSV04 EQU   RLNSTAT2
RLNINUSE EQU   RLNSTAT2
RLNOHIN  EQU   RLNSTAT2
RLNRSV03 EQU   RLNSTAT1
RLNVD    EQU   RLNSTAT1
RLNINOPP EQU   RLNSTAT1
RLNINOPL EQU   RLNSTAT1
RLNLRST  EQU   RLNSTAT1
RLNTRAP  EQU   RLNSTAT1
RLNACTCT EQU   ISTRLN+84
RLNCTECM EQU   ISTRLN+82
RLNCTEIN EQU   ISTRLN+80
RLNCTETR EQU   ISTRLN+78
RLNCTECL EQU   ISTRLN+76
RLNCUA   EQU   RLNUCBAD
RLNRSV01 EQU   RLNFLAG
RLNEAM   EQU   RLNFLAG
RLNPRE   EQU   ISTRLN
RGPRVPT2 EQU   ISTRGP+88
RGPRVPT1 EQU   ISTRGP+84
RGPCTECM EQU   ISTRGP+82
RGPCTEIN EQU   ISTRGP+80
RGPCTETR EQU   ISTRGP+78
RGPCTECL EQU   ISTRGP+76
RGPCTELN EQU   ISTRGP+74
RGPRSV03 EQU   ISTRGP+73
RGPRSV02 EQU   RGPFLG
RGPASDLC EQU   RGPFLG
RGPABSC  EQU   RGPFLG
RGPASS   EQU   RGPFLG
RGPADIL  EQU   RGPFLG
RGPPRE   EQU   ISTRGP
@NM00072 EQU   ISTRRN+247
RRNLASTE EQU   ISTRRN+240
RRNNCSPL EQU   ISTRRN+236
RRNRPLPT EQU   ISTRRN+232
RRNMSIZE EQU   ISTRRN+228
RRNNCPNM EQU   ISTRRN+221
RRNCTPCC EQU   ISTRRN+220
RRNHBUFS EQU   ISTRRN+218
RRNHLENT EQU   RRNHPRE+1
RRNHLENH EQU   RRNHPRE
RRNNMNCP EQU   ISTRRN+208
RRNDELAY EQU   ISTRRN+206
RRNRSV04 EQU   ISTRRN+200
RRNRSV88 EQU   RRNNMDPD+7
RRNPUBI  EQU   RRNNMDPD+6
RRNDPLUB EQU   RRNNMDPD
RRNEPADR EQU   ISTRRN+190
RRNCPLUB EQU   ISTRRN+184
RRNFLUX  EQU   ISTRRN+180
RRNRSV05 EQU   RRNCMFD
RRNREMPO EQU   RRNCMFD
RRNCDREC EQU   RRNCMFD
RRNCDDSI EQU   RRNCMFD
RRNCDBCK EQU   RRNCMFD
RRNCDDTL EQU   RRNCMFD
RRNCDSTD EQU   RRNCMFD
RRNCDCSP EQU   RRNCMFD
RRNCCCSL EQU   RRNCMFC
RRNCCSIM EQU   RRNCMFC
RRNCCRCM EQU   RRNCMFC
RRNCCRIM EQU   RRNCMFC
RRNCCCRC EQU   RRNCMFC
RRNCCRST EQU   RRNCMFC
RRNCCRDQ EQU   RRNCMFC
RRNCCRCN EQU   RRNCMFC
RRNCBALT EQU   RRNCMFB
RRNCBMOD EQU   RRNCMFB
RRNCBNPL EQU   RRNCMFB
RRNCBRLS EQU   RRNCMFB
RRNCBRDS EQU   RRNCMFB
RRNCBDLR EQU   RRNCMFB
RRNCBDLH EQU   RRNCMFB
RRNCBDLO EQU   RRNCMFB
RRNCADGO EQU   RRNCMFA
RRNCADTD EQU   RRNCMFA
RRNCACDT EQU   RRNCMFA
RRNCAMBH EQU   RRNCMFA
RRNCAATI EQU   RRNCMFA
RRNCAATG EQU   RRNCMFA
RRNCAATD EQU   RRNCMFA
RRNCAALL EQU   RRNCMFA
RRNRSV55 EQU   RRNRDF+3
RRNPTASL EQU   RRNRDFB+1
RRNRSV01 EQU   RRNRDFB+1
RRNVYDON EQU   RRNRDFB+1
RRNRBBUP EQU   RRNRDFB+1
RRNRSV03 EQU   RRNRDFB
RRNRBCT2 EQU   RRNRDFB
RRNRBCT1 EQU   RRNRDFB
RRNRBSEC EQU   RRNRDFB
RRNRBCCT EQU   RRNRDFB
RRNRBCCL EQU   RRNRDFB
RRNRSV02 EQU   RRNRDFB
RRNRBMDL EQU   RRNRDFB
RRNRAPEP EQU   RRNRDFA
RRNRANCP EQU   RRNRDFA
RRNRAOLT EQU   RRNRDFA
RRNRASYN EQU   RRNRDFA
RRNRADMP EQU   RRNRDFA
RRNRAIPL EQU   RRNRDFA
RRNRASHT EQU   RRNRDFA
RRNCTENT EQU   ISTRRN+170
RRNCTECM EQU   ISTRRN+168
RRNCTEIN EQU   ISTRRN+166
RRNCTETR EQU   ISTRRN+164
RRNCTECL EQU   ISTRRN+162
RRNCTELI EQU   ISTRRN+160
RRNCTEGP EQU   ISTRRN+158
RRNCTBHS EQU   ISTRRN+156
RRNBHSET EQU   ISTRRN+152
RRNTRENT EQU   ISTRRN+148
RRNRLDIP EQU   ISTRRN+147
RRNRNCUA EQU   ISTRRN+144
RRNGRPA  EQU   ISTRRN+140
RRNLUBA  EQU   RRNUCBAD+1
RRNCHQI  EQU   RRNUCBAD
RRNRSV11 EQU   RRNFLAG
RRNDSTCT EQU   RRNFLAG
RRNERPIP EQU   RRNFLAG
RRNLCDIP EQU   RRNFLAG
RRNLCDIE EQU   RRNFLAG
RRNLCSIP EQU   RRNFLAG
RRNRSV89 EQU   RRNFLAG
RRNPRE   EQU   ISTRRN
RLCRVPT2 EQU   ISTRLC+80
RLCRVPT1 EQU   ISTRLC+79
RLCLCCUA EQU   ISTRLC+76
RLCUCBAD EQU   RLCADR+1
RLCRSVDE EQU   RLCFLAG
RLCACNT  EQU   RLCFLAG
RLCRSV14 EQU   RLCFLAG
RLCRSV22 EQU   RLCFLAG
RLCPRE   EQU   ISTRLC
RAPRVPT2 EQU   ISTRAP+116
RAPRVPT1 EQU   ISTRAP+112
RAPBFACT EQU   ISTRAP+111
RAPRSV17 EQU   RAPFLGC
RAPRSV16 EQU   RAPFLGC
RAPRSV15 EQU   RAPFLGC
RAPRSV14 EQU   RAPFLGC
RAPRSV13 EQU   RAPFLGC
RAPRSV12 EQU   RAPFLGC
RAPRSV11 EQU   RAPFLGC
RAPRSV10 EQU   RAPFLGC
RAPANVPC EQU   RAPFLGB
RAPASPO  EQU   RAPFLGB
RAPAPPO  EQU   RAPFLGB
RAPAACQ  EQU   RAPFLGB
RAPAPRMT EQU   RAPFLGB
RAPAPASS EQU   RAPFLGB
RAPABLCK EQU   RAPFLGB
RAPALLF  EQU   RAPFLGB
RAPRSV06 EQU   RAPFLG
RAPRSV05 EQU   RAPFLG
RAPRSV04 EQU   RAPFLG
RAPRSV03 EQU   RAPFLG
RAPATLGN EQU   RAPFLG
RAPASLGI EQU   RAPFLG
RAPAQUI  EQU   RAPFLG
RAPABLGN EQU   RAPFLG
RAPACEQD EQU   ISTRAP+106
RAPTRPRE EQU   ISTRAP+104
RAPACEAP EQU   ISTRAP+100
RAPICEAQ EQU   ISTRAP+96
RAPICEAC EQU   ISTRAP+92
RAPICELG EQU   ISTRAP+88
RAPAPPWD EQU   ISTRAP+80
RAPACDEB EQU   ISTRAP+76
RAPACBA  EQU   ISTRAP+72
RAPPRE   EQU   ISTRAP
@NM00071 EQU   ISTRDT+113
RRNSTCNT EQU   RDTSTCNT
RRNVYRPH EQU   RDTVYRPH
RDTTPAB  EQU   ISTRDT+104
RDTDPAB  EQU   ISTRDT+100
RDTEPAB  EQU   ISTRDT+96
RDTVPAB  EQU   ISTRDT+92
RDTRSV01 EQU   RDTFLAGB
RDTBHSET EQU   RDTFLAGB
RDTCTCFL EQU   RDTFLAGB
RDTCTPGD EQU   RDTFLAGB
RDTPRGDN EQU   RDTFLAGB
RDTOUERP EQU   RDTFLAGB
RDTLGCT  EQU   ISTRDT+90
RDTNODID EQU   ISTRDT+89
RDTMAXID EQU   ISTRDT+88
RDTCTSNT EQU   ISTRDT+86
RDTFLAGS EQU   ISTRDT+84
RDTBACK  EQU   ISTRDT+80
RDTFORW  EQU   ISTRDT+76
RDTLEN   EQU   RDTPLEN+1
RDTPRILS EQU   RDTPRIOR
RDTPRISW EQU   RDTPRIOR
RDTPRIRN EQU   RDTPRIOR
RDTPRILC EQU   RDTPRIOR
RDTPRIAP EQU   RDTPRIOR
@NM00070 EQU   RDTPRIOR
RDTPRE   EQU   ISTRDT
RCPRSV05 EQU   ISTRCPRE+120
RCPRSV04 EQU   ISTRCPRE+116
RCPRSV03 EQU   ISTRCPRE+112
RCPINTA  EQU   RCPLGNIN+16
RCPLGNCT EQU   RCPLGNIN+8
@NM00069 EQU   RCPPMODE
RCPRRECD EQU   RCPPMODE
RCPRBASC EQU   RCPPMODE
RCPBFLIM EQU   ISTRCPRE+90
RCPBHSI2 EQU   ISTRCPRE+89
RCPBHSI1 EQU   ISTRCPRE+88
RCPACETR EQU   ISTRCPRE+84
RCPICEAQ EQU   ISTRCPRE+80
RCPLNAPA EQU   ISTRCPRE+76
RCPICELN EQU   ISTRCPRE+72
RCPPRE   EQU   ISTRCPRE
RPRCONID EQU   ISTRPRE+63
RPRCLVPD EQU   RPRFLAGC
RPRINIMM EQU   RPRFLAGD
RPRRSV05 EQU   RPRFLAGD
RPRCONP  EQU   RPRFLAGD
RPRACTP  EQU   RPRFLAGD
RPRRSON  EQU   RPRFLAGD
RPRCONCT EQU   RPRFLAGD
RPRLTASN EQU   RPRFLAGD
RPRPTHCT EQU   ISTRPRE+60
RPRSWDAF EQU   ISTRPRE+58
RPRSTPCT EQU   ISTRPRE+56
RPRRVPT1 EQU   ISTRPRE+52
RPRDEVCH EQU   ISTRPRE+44
RPRNCBA  EQU   ISTRPRE+40
RPRLGONB EQU   ISTRPRE+32
RPRLGONF EQU   ISTRPRE+28
RPRTIOCT EQU   ISTRPRE+26
RPRPEPCT EQU   ISTRPRE+24
RPRRSV03 EQU   RPRCAUSE
RPRRSYNC EQU   RPRCAUSE
RPRNOSRT EQU   RPRCAUSE
RPRINTST EQU   RPRFLAGB
RPRVYIMM EQU   RPRFLAGB
RPRHLVPD EQU   RPRFLAGB
RPRONLIN EQU   RPRFLAGB
RPRVIODN EQU   RPRFLAGB
RPRAOPN  EQU   RPRFLAGB
RPRENTVT EQU   RPRFLAGB
RPRENTVH EQU   RPRFLAGB
RPRLIVE  EQU   RPRFLAGA
RPRVRYPD EQU   RPRFLAGA
RPRENTIO EQU   RPRFLAGA
RPRENTBF EQU   RPRFLAGA
RPRTIED  EQU   RPRFLAGA
RPRINV   EQU   RPRFLAGA
RPRACT   EQU   RPRFLAGA
RPRRLOCK EQU   ISTRPRE+12
RPRSAF   EQU   RPRCOMID
DEVRSV03 EQU   ISTDEVCH+5
DEVPHYSA EQU   ISTDEVCH+4
DEVCSLPN EQU   DEVCHAR3
DEVCSTCL EQU   DEVCHAR3
DEVCCHEK EQU   DEVCHAR3
DEVCATTN EQU   DEVCHAR3
DEVCSWL  EQU   DEVFCCTL
DEVCRVB  EQU   DEVFCCTL
DEVCSSL  EQU   DEVFCCTL
DEVCBSC  EQU   DEVFCCTL
DEVMCODE EQU   ISTDEVCH+2
DEVCHAR2 EQU   DEVTCODE
DEVRSV01 EQU   DEVCHAR
DEVCCTL  EQU   DEVCHAR
DEVNNSPT EQU   DEVCHAR
DEVSPS   EQU   DEVCHAR
DEVSUBND EQU   DEVCHAR
DEVCONVR EQU   DEVCHAR
DEVOTPUT EQU   DEVCHAR
DEVINPUT EQU   DEVCHAR
LOKXCL   EQU   @NM00067
LOKPRY   EQU   @NM00067
@NM00068 EQU   @NM00067
@NM00066 EQU   LOKCHNG
LOKCT    EQU   ISTLOK
NCSAPPAB EQU   NCSAPP+608
NCSAPDAT EQU   NCSAPBUE+8
NCSAPRU  EQU   NCSAPBUE+3
NCSRSV04 EQU   NCSAPBUE
NCSAPEND EQU   NCSAPP+84
NCSAPTXT EQU   NCSAPP+76
NCSAPECB EQU   NCSAPP+72
NCSAPSA  EQU   NCSAPP
NCSPLPDB EQU   NCSPLSID+5
NCSPLNID EQU   NCSPLPHD
NCSPLPO  EQU   NCSPLSTA
NCSRSVD4 EQU   NCSPLSTA
NCSRSVD2 EQU   NCSCRMOD
NCSRSVD1 EQU   NCSCHKPT+1
NCSPLRTY EQU   ISTNCSPL+263
NCSPLRH  EQU   ISTNCSPL+260
NCSUFMCB EQU   ISTNCSPL+256
NCSMGLPT EQU   ISTNCSPL+252
NCSCPWPT EQU   ISTNCSPL+248
NCSSENS2 EQU   NCSSENSE+2
NCSSNS2  EQU   NCSSENSE+1
NCSSNS1  EQU   NCSSENSE
NCSPLNSN EQU   ISTNCSPL+240
NCSPLMID EQU   ISTNCSPL+232
NCSPLPID EQU   ISTNCSPL+231
NCSPLGID EQU   ISTNCSPL+230
NCSPLSQN EQU   ISTNCSPL+228
NCSRNAME EQU   ISTNCSPL+220
NCSPLRUI EQU   ISTNCSPL+212
NCSPLRUO EQU   ISTNCSPL+208
NCSPLRRP EQU   ISTNCSPL+204
NCSPLWEL EQU   ISTNCSPL+200
NCSPLSPL EQU   ISTNCSPL+196
NCSPLP3  EQU   ISTNCSPL+192
NCSPLP2  EQU   ISTNCSPL+188
NCSPLP1  EQU   ISTNCSPL+184
NCSPLOLN EQU   ISTNCSPL+182
@NM00065 EQU   NCSPLFL5
NCSFORCE EQU   NCSPLFL5
NCSSDLK  EQU   NCSPLFL5
NCSSCPPS EQU   NCSPLFL5
NCSDLRSN EQU   ISTNCSPL+180
NCSPL2AP EQU   NCSPLFL4
NCSDSPN  EQU   NCSPLFL4
NCSDSPI  EQU   NCSPLFL4
NCSDSPA  EQU   NCSPLFL4
NCSDSPE  EQU   NCSPLFL4
NCSPLVID EQU   NCSPLFL4
NCSPLRSO EQU   NCSPLFL4
NCSDLNID EQU   NCSPLFL4
NCSEND   EQU   NCSPLFL3
NCSFINAL EQU   NCSPLFL3
NCSANS   EQU   NCSPLFL3
NCSPID   EQU   NCSPLFL3
NCSGID   EQU   NCSPLFL3
NCSPLANS EQU   NCSPLFL3
NCSEPP   EQU   NCSPLFL3
NCSPLMOM EQU   NCSPLFL3
NCSPLVIT EQU   NCSPLFL2
NCSPLVIS EQU   NCSPLFL2
NCSREMPO EQU   NCSPLFL2
NCSPLDS  EQU   NCSPLFL2
NCSOUFMC EQU   NCSPLFL2
NCSPLRIO EQU   NCSPLFL2
NCSPLRSF EQU   NCSPLFL2
NCSPLVDP EQU   NCSPLFL2
NCSPLPOS EQU   NCSPLFL1
NCSPL2CN EQU   NCSPLFL1
NCSPLAPU EQU   NCSPLFL1
NCSPLNON EQU   NCSPLFL1
NCSPLREQ EQU   NCSPLFL1
NCSPLEBN EQU   NCSPLFL1
NCSPLSOM EQU   NCSPLFL1
NCSPL2IN EQU   NCSPLFL1
NCSPLRCR EQU   ISTNCSPL+172
NCSPLECB EQU   ISTNCSPL+164
NCSPLCVT EQU   ISTNCSPL+156
NCSPLWKA EQU   ISTNCSPL+152
NCSPLDAF EQU   NCSPLCID+2
NCSPLSAF EQU   NCSPLCID
NCSPLRCD EQU   NCSPLRAD+1
NCSLSCMD EQU   NCSPLRAD
NCSPLWRF EQU   ISTNCSPL+72
NCSPLWRE EQU   ISTNCSPL+68
NCSSTCMD EQU   NCSCRFLG
NCSUSRNF EQU   NCSCRFLG
NCSOPRQU EQU   NCSCRFLG
NCSCRDSE EQU   NCSCRFLG
NCSFMERP EQU   NCSCRFLG
NCSFMCLD EQU   NCSCRFLG
NCSPLCLD EQU   NCSCRFLG
NCSPLUAD EQU   ISTNCSPL+64
NCSMSGSP EQU   ISTNCSPL+63
NCSNCPEP EQU   ISTNCSPL+62
NCSCMDB  EQU   NCSPLCMD+1
@NM00064 EQU   NCSCMDA
NCSPLUFM EQU   NCSCMDA
NCSPLFLO EQU   NCSCMDA
NCSPLSYN EQU   NCSCMDA
NCSPLCTL EQU   NCSCMDA
NCSPLSYS EQU   NCSCMDA
NCSPLLPT EQU   ISTNCSPL+56
NCSPLRPT EQU   ISTNCSPL+52
NCSDLID  EQU   ISTNCSPL+44
NCSPLLID EQU   ISTNCSPL+36
NCSPLRID EQU   ISTNCSPL+28
NCSRRNPT EQU   ISTNCSPL+24
NCSPRMRC EQU   ISTNCSPL+22
NCSOVFMC EQU   NCSPLVF1
NCSRSV02 EQU   NCSPLVFL
NCSDACLK EQU   NCSPLVFL
NCSABCON EQU   NCSPLVFL
NCSDCONT EQU   NCSPLVFL
NCSVSTAT EQU   NCSPLVFL
NCSVDEL  EQU   NCSPLVFL
NCSVNCSA EQU   NCSPLVFL
NCSVBF16 EQU   NCSPLVBF+1
NCSVBF15 EQU   NCSPLVBF+1
NCSVBF14 EQU   NCSPLVBF+1
NCSVBF13 EQU   NCSPLVBF+1
NCSVBF12 EQU   NCSPLVBF+1
NCSVBF11 EQU   NCSPLVBF+1
NCSVBF10 EQU   NCSPLVBF+1
NCSVBF09 EQU   NCSPLVBF+1
NCSVBF08 EQU   NCSPLVBF
NCSVBF07 EQU   NCSPLVBF
NCSVBF06 EQU   NCSPLVBF
NCSVBF05 EQU   NCSPLVBF
NCSVBF04 EQU   NCSPLVBF
NCSVBF03 EQU   NCSPLVBF
NCSVBF02 EQU   NCSPLVBF
NCSVBF01 EQU   NCSPLVBF
NCSPLVCD EQU   ISTNCSPL+17
@NM00063 EQU   ISTNCSPL+16
@NM00062 EQU   NCSPFX
PFXBCK   EQU   ISTPFX+12
PFXFWD   EQU   ISTPFX+8
PFXLNG   EQU   ISTPFX+5
PFXPRTY  EQU   ISTPFX+4
PFXCBID  EQU   PFXID
POHID    EQU   ISTPOHD+2
POHGEN   EQU   POHSTAT
POHRREQ  EQU   POHSTAT
POHRSVD2 EQU   POHSTAT
POHCNTRL EQU   POHSTAT
POHLBL   EQU   POHSTAT
POHDATA  EQU   POHSTAT
POHEND   EQU   POHSTAT
POHRSVD1 EQU   ISTPOHD
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00321 EQU   @RC00320
@RF00329 EQU   @RC00324
@RC00331 EQU   @RC00324
@RC00337 EQU   @RC00336
@RC00341 EQU   @RC00340
@RC00345 EQU   @RC00344
@RF00616 EQU   @RC00607
@RC00839 EQU   #BCM0005
@PB00006 EQU   @PB00007
@RC00876 EQU   @EL00007
@PB00005 EQU   @PB00006
@PB00004 EQU   @PB00005
@PB00003 EQU   @PB00004
@PB00002 EQU   @PB00003
@RF00144 EQU   @PB00002
@RC00142 EQU   @PB00002
@RC00148 EQU   @PB00002
@ENDDATA EQU   *
         END   ISTINCR4,(C'PLS0245',0603,76170)
