SVTM     TITLE 'ISTINCR6-CONFIGURATION RESTART VSAM IO                 *
                        '
ISTINCR6 CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'ISTINCR6  76.278'                                 0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                     0001
         BALR  @12,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@12                                         0001
         EJECT
*/*-----------------------------------------------------------     0121
*    EXECTUABLE CODE -MAIN ROUTINE                                 0121
*---------------------------------------------------------------*/ 0121
*/*    CHAIN SAVEAREAS */                                          0121
*                                                                  0121
* DO; /* BLOCK MAIN */                                             0121
*/********************************************************************/
*/*                                                                  */
*/*   MACRO NAME = IDAAMB                                            */
*/*                                                                  */
*/*   DESCRIPTIVE NAME =ACCESS METHOD BLOCK                          */
*/*                                                                  */
*/*   FUNCTION = DESCRIBES DATA SET ATTRIBUTES AND SUPPLIES          */
*/*              IOS COMPATIBLE FIELDS FOR I/O                       */
*/*                                                                  */
*/*   CONTROL BLOCK STRUCTURE = THE IDAAMB IS POINTED TO BY THE      */
*/*              IDAAMBL                                             */
*/*                                                                  */
*/*   INCLUDED MACROS = NONE                                         */
*/*                                                                  */
*/*   METHOD OF ACCESS = PL/S - NO DECLARES NECESSARY                */
*/*                                                                  */
*/*   CREATED BY = VSAM OPEN                                         */
*/*                                                                  */
*/*   STATUS = VS/1 RELEASE 4  (CHANGE FLAG @X04SVXX)                */
*/*               VS/2 RELEASE 3  (CHANGE FLAG @Y30SDXX)             */
*/*                                                                  */
*/*   DATE OF LAST CHANGE = 8 AUG 74                                 */
*/*                                                                  */
*/********************************************************************/
*     DCL  1 IDAAMB  BASED ,                /* AMB                 */
*               2 AMBID         BIT(8),     /* AMB IDENTIFIER      */
*               2 AMBRSC        BIT(8),     /* RESOURCE TS BYTE    */
*               2 AMBLEN        FIXED(15),  /* AMB LENGTH          */
*               2 AMBLINK       PTR(31),    /* NEXT AMB            */
*               2 AMBBUFC       PTR(31),    /* BUFFER CONTROL      */
*               2 AMBPH         PTR(31),    /* PLACEHOLDER         */
*               2 AMBCACB       PTR(31),    /*PTR TO ACB OF CATALOG*/
*                                           /*USED TO ACCESS OBJECT*/
*               2 AMBDSB        PTR(31),    /* AMDSB POINTER       */
*               2 AMBEOVR       CHAR(1),    /* EOV REQUEST TYPE - NOT
*                                              USED IN MVM   @Y30DSJH*/
*                 3 AMBFLG0     BIT(8),     /* MVM AMB FLAGS @Y30DSJH*/
*                   4 AMBPSDS   BIT(1),     /* PAGE SPACE    @Y30DSJH*/
*                   4 *         BIT(7),     /* UNUSED IN MVM @Y30DSJH*/
*               2 AMBFLG1       BIT(8),     /* FLAG BYTE ONE       */
*                 3 AMBCREAT    BIT(1),     /* ON IF IN CREATE MODE*/
*                3 AMBTYPE    BIT(1),       /*                       */
*                3 AMBMCAT    BIT(1),       /* MASTER CATL           */
*                3 AMBPCAT    BIT(1),       /* PRIVATE CATL          */
*                 3 AMBSPEED  BIT(1),       /* CREATE SPEED OPITON */
*                 3 AMBUBF      BIT(1),     /* USER BUFFERING      */
*                 3 AMBJRN      BIT(1),     /* JOURNAL EXIT PRESENT*/
*                 3 AMBINBUF    BIT(1),     /* SHARED DS--DIRECT   */
*                                           /* REQ BFR INVALIDATION*/
*               2 AMBDSORG      BIT(16),    /* DATA SET ORGANIZ.   */
*                    3 *        BIT(12),     /* ALWAYS ZERO         */
*                    3 AMBDORGA BIT(1),      /* ACCESS METHOD INDIC */
*                    3 *        BIT(3),      /* ALWAYS ZERO         */
*               2 AMBIOBAD      PTR(31),    /* IOB ADDR            */
*                 3 AMBIOMB     PTR(31),    /* IOMB CHAIN IN MVM   0122
*                                                            @Y30DSJH*/
*               2 AMBCDSN       CHAR(3),    /* CATALOG DSN         */
*               2 AMBDDSN       CHAR(3),    /* DATA DSN            */
*               2 *             PTR(16),    /* RESERVED            */
*               2 AMBTIOT       FIXED(15),  /* OFFSET TO TIOT      */
*                2 AMBINFL      PTR(8),     /* INDICATOR FLAGS     */
*                  3 *          BIT(1),     /* RESERVED FOR EXCP   */
*                  3 *          BIT(2),     /* RESERVED            */
*                  3 AMBCAT     BIT(1),     /* AMB FOR VSAM CATLG  */
*                  3 AMBSCRA    BIT(1),     /* CATALOG CONTROL BLOCK
*                                              SYSTEM AREA   @X04SVLC*/
*                  3 AMBUCRA    BIT(1),     /* CATALOG CONTROL BLOCK
*                                              USER AREA     @X04SVLC*/
*                  3 AMBUPX     BIT(1),     /* SET ON IF UPGRADE TABLE
*                                              EXISTS        @X04SVLC*/
*                2 AMBAMETH     PTR(8),     /* ACCESS METHOD TYPE  */
*               2 AMBDEBPT      PTR(31),    /* DEB ADDR            */
*                 3 AMBIFLGS    BIT(8),     /* IOS ERROR FLAGS     */
*                 3 AMBDEBAD    PTR(24),    /* DEB ADDR            */
*               2 AMBOFLGS      BIT(8),     /* OPEN FLAGS          */
*                 3 *       BIT(3),         /* ALWAYS ZERO          */
*                 3 AMBOPEN BIT(1),         /* AMB IS OPEN          */
*                 3 *       BIT(2),         /* ALWAYS ZERO          */
*                 3 AMBEXFG BIT(1),         /* USER EXIT FLAG       */
*                 3 AMBBUSY BIT(1),         /* BUSY BIT             */
*               2 AMBFLG2       PTR(8),     /* FLAG BYTE TWO @X04SVLC*/
*                 3 AMBPUG BIT(1),          /* AMB PARTICIPATES IN 0122
*                                              UPGRADE       @X04SVLC*/
*               2 AMBRPT        FIXED(15),  /*                     */
*               2 AMBEDB        PTR(31),    /* EDB POINTER         */
*               2 AMBEOVPT      PTR(31),    /* PTR TO KEY OR RBA - NOT
*                                              USED IN MVM   @Y30DSJH*/
*                 3 AMBAMBXN    PTR(31),    /* PTR TO AMB EXTENSION IN
*                                              MVM           @Y30DSJH*/
*               2 AMBWKA        PTR(31),    /* WORK AREA PTR       */
*               2 AMBIWA        PTR(31),    /* INSERT WORK AREA PTR*/
*               2 *             PTR(31),    /* UNUSED        @Z30SSMR*/
*               2 AMBPIXP       PTR(31),    /* PTR TO PRIME INDEX AMB*/
*               2 AMBPAMBL      PTR(31),    /* PTR TO PRIMARY AMBL 0122
*                                                            @X04SVLC*/
*               2 AMBUPLH       PTR(31),    /* PTR TO UPGRADE PLH  0122
*                                                            @X04SVLC*/
*               2 AMBCSWD1 FIXED(31)BDY(WORD),/* CS WORD 1   @X04SVLC*/
*                 3 AMBAFLG BIT(8), /* ADDITIONAL FLAGS      @X04SVLC*/
*                   4 *      BIT(1),/* UNUSED                @X04SVLC*/
*                   4 AMBLSR BIT(1),/* LSR OPTION            @X04SVLC*/
*                   4 AMBGSR BIT(1),/* GSR OPTION            @Y30SDLP*/
*                   4 AMBICI BIT(1),/* ICIP OPTION           @Y30SDLP*/
*                   4 AMBDFR BIT(1),/* DEFER WRITES          @X04SVLC*/
*                   4 AMBSIS BIT(1),/* SEQ INSERT STRAT      @X04SVLC*/
*                   4 AMBCFX BIT(1),/* FIXED CTRL BLK OPTN   @Y30SDLP*/
*                   4 *      BIT(1),/* UNUSED                @X04SVLC*/
*                 3 * FIXED(8),     /* UNUSED                @X04SVLC*/
*                 3 AMBRDCNT FIXED(15),/* NBR OF CIS READ FOR THIS AMB
*                                           - VS1 ONLY       @X04SVLC*/
*               2 AMBBM2SH PTR(31), /* ADDR OF PLH DOING 2ND SEARCH
*                                      OF SUBPOOL - VS1 ONLY @X04SVLC*/
*               2 AMBCPA PTR(31),   /* DB/DC - PTR TO WSHD.  NON DB/DC
*                                      & VS1 - UNUSED.  NON DB/DC & VS2
*                                      - PTR TO STATIC CPA'S @Y30DSJH*/
*               2 AMBWSHD PTR(31),  /* PTR TO WORK SPACE HDR @X04SVLC*/
*               2 AMBEXEX CHAR(8),  /* EXCEPTION EXIT NAME   @X04SVLC*/
*               2 AMBSZRD FIXED(15),/* CP SIZE FOR READ      @X04SVLC*/
*               2 AMBSZWR FIXED(15),/* CP SIZE FOR WRITE     @X04SVLC*/
*               2 AMBSZFW FIXED(15),/* CP SIZE FORMAT WRITE  @X04SVLC*/
*               2 AMBSZCP FIXED(15),/* SIZE FOR CPA BASE     @X04SVLC*/
*               2 AMBVIOT PTR(31);  /* POINTER TO IDAVIOT    @X04SVLC*/
*  DCL   AMBINDEX BIT(1) CONSTANT('1'B);    /* INDEX TYPE AMB        */
*  DCL   AMBDATA  BIT(1) CONSTANT('0'B);    /* DATA TYPE AMB         */
* DCL AMBEOVMK BIT(8) CONSTANT('00000001'B); /* MOUNT BY KEY         */
* DCL AMBEOVMR BIT(8) CONSTANT('10000001'B); /* MOUNT BY RBA         */
* DCL AMBEOVAK BIT(8) CONSTANT('00000010'B); /* ALLOCATE BY KEY      */
* DCL AMBEOVAR BIT(8) CONSTANT('10000010'B); /* ALLOCATE BY RBA      */
* DCL AMBEOVUC BIT(8) CONSTANT('00000100'B); /* UPDATE CATALOG       */
* DCL AMBEXOFF BIT(1) CONSTANT('1'B);       /* AMB NOT LOCKED       */
* /*     DESCRIPTION SHOULD BE HERE                                 */
* /*                                                                */
* /* MACCOMP Y-2 SC1DE/SJD61                                        */
* /* MACSTAT Y-2 73103/Y02113                                       */
* /*                                                                */
* /*                                                                */
*        DCL 1 IDAAMBL BASED,                                      0131
*              2 AMBLPCHN     PTR(31),  /* PRIMARY CHAIN POINTER    */
*              2 AMBLSCHN     PTR(31),  /* SECONDARY CHAIN POINTER  */
*              2 AMBLACB      PTR(31),  /* POINTER TO ACB           */
*              2 AMBLEOV      FIXED(31),/* EOV/RM INTERFACE         */
*                3 AMBLEFLG   CHAR(1),  /* EOV FLAGS                */
*                  4 AMBLWAIT BIT(1),   /* EOV IS WAITING           */
*                  4 AMBLESET BIT(1),   /* EOV RESET CONTROL BLOCKS. */
*                3 AMBLCOMP   CHAR(1),  /* EOV LOCK                 */
*                3 *          CHAR(2),  /*                          */
*              2 AMBLDDNM     CHAR(8),  /* DDNAME FROM ACB          */
*              2 AMBLCBWA     PTR(31),  /* PTR TO CBM WORK AREA */ 0131
*              2 AMBLCBTS     CHAR(1),  /* CBM TEST AND SET BYTE */
*              2 *            CHAR(1),  /* RESERVED */             0131
*              2 AMBLCBLN     FIXED(15),/* LENGTH OF CBM WORK AREA */
*              2 AMBLID       CHAR(1),  /* AMBL IDENTIFER           */
*              2 AMBLSHAR     BIT(8),   /* SHARING INDICATORS       */
*                3 AMBLPRIM   BIT(1),   /* P-AMBL INDICATOR         */
*                3 AMBLCATO   BIT(1),   /* CATALOG OPEN IND IS ON   */
*                3 AMBLWRIT   BIT(1),   /* OUTPUT/UPDATE SPECIFIED  */
*                3 *          BIT(5),   /* RESERVED                 */
*              2 AMBLLEN      PTR(8),   /* AMBL LENGTH              */
*              2 AMBLFLG1     BIT(8),   /* FLAG BYTE ONE            */
*                3 AMBLFULL   BIT(1),   /* FULL ACCESS OK           */
*                3 AMBLCINV   BIT(1),   /* CINV ACCESS OK           */
*                3 AMBLUPD    BIT(1),   /* UPDATE ACCESS OK         */
*                3 *          BIT(3),   /* RESERVED                 */
*                3 AMBLCAT    BIT(1),   /* IND ACB FOR A CATALOG    */
*                3 AMBLDUMY   BIT(1),   /* DD DUMMY SPECIFIED       */
*              2 AMBLFLG2     BIT(8),   /* FLAG BYTE TWO            */
*                3 AMBLREST   BIT(1),   /* INDIC RESTART INVIR      */
*                3 AMBLCKPT   BIT(1),   /* INDICATE CKPT ENVIR       */
*                3 AMBLRST1   BIT(1),   /* UPDATE HIGH RBA FOR     0131
*                                          RESTART           @XM01565*/
*                3 AMBLSTAG   BIT(1),   /* CLUSTER IS STAGED @Y30LSPS*/
*                3 *          BIT(4),   /* RESERVED          @Y30LSPS*/
*              2 AMBLNST      CHAR(1),  /* NUMBER OF STRINGS        */
*              2 AMBLNUM      FIXED(15),/* NUMBER OF AMB PTRS IN    */
*                                       /* AMBL                     */
*              2 *            CHAR(1),  /* RESERVED                 */
*              2 AMBLNIDS     PTR(8),   /* NUMBER IF IDS            */
*              2 AMBLMIDS(5)  CHAR(2),  /* IDS OF MODULES LOADED    */
*              2 AMBLDTA      PTR(31),  /* POINTER TO DATA AMB      */
*              2 AMBLIX       PTR(31),  /* POINTER TO INDEX AMB     */
*              2 AMBLDS       PTR(31);  /* VARIABLE NUMBER OF OTHER */
*                                       /* DATA SETS - TYPE         */
*                                       /* DETERMINED FROM AMDSB    */
*CR6R04  =ATCLCPTR->ATCCONFT;                                      0132
         L     @09,ATCLCPTR                                        0132
         L     CR6R04,ATCCONFT(,@09)                               0132
*RFY (ISTCONFT) BASED(CR6R04);                                     0133
*RFY(ISTDLRPL) BASED(CR6R01);      /*REG.1->DLRPL*/                0134
*CR6FWDPT=CR6R01;                 /*SET CALLER FORWARD PTR IN SAVEARE*/
         ST    CR6R01,CR6FWDPT(,CR6R13)                            0135
*RFY CR6R6   RSTD;                                                 0136
*CR6R6   =CR6R13;                   /*SAVE PTR TO CALLER SAVEAREA*/
         LR    CR6R6,CR6R13                                        0137
*CR6R13=CR6R01;                    /*SET R-13 TO CR6 SAVEAREA*/    0138
         LR    CR6R13,CR6R01                                       0138
*CR6BCKPT=CR6R6 ;           /*SET CR6 BKWD PTR TO CALLERS          0139
*                                                 SAVEAREA*/       0139
         ST    CR6R6,CR6BCKPT(,CR6R13)                             0139
*RFY CR6R6 UNRSTD;                                                 0140
*CR6FWDPT=0;                       /*ZERO CR6 FORWARD PTR*/        0141
         SLR   @06,@06                                             0141
         ST    @06,CR6FWDPT(,CR6R13)                               0141
*DLRPLRCD='0'X;                    /*SET RETURN CODE TO SUCCESS*/  0142
         SLR   @05,@05                                             0142
         STC   @05,DLRPLRCD(,CR6R01)                               0142
*CR6DPLAD=CR6R01;                  /*SET UP PARM  PTR*/            0143
         LR    CR6DPLAD,CR6R01                                     0143
*RFY CR6R01 UNRSTD;                                                0144
*RFY (ISTDLRPL) BASED(CR6DPLAD);   /*PT TO PARML*/                 0145
*CR6ERCOD=0;                        /*ZERO OUT ERROR CODE*/        0146
         STH   @06,CR6ERCOD(,CR6DPLAD)                             0146
*/* ---------------------------------                              0147
*   PROCESS COMMAND CODES                                          0147
* -----------------------------*/                                  0147
*     CR6BITS=CR6ZEROB;                /*ZERO OUT BIT FIELD*/      0147
         MVI   CR6BITS(CR6DPLAD),B'00000000'                       0147
*IF DLRPLFNC  = DLRPLOPN               /*OPEN CASE?*/              0148
*   THEN DO;                           /*YES CALL OPEN*/           0148
         CLI   DLRPLFNC(CR6DPLAD),1                                0148
         BNE   @RF00148                                            0148
*     CR6OPSW=OFF;                     /*FIRST CALL TO OPEN*/      0150
         NI    CR6OPSW(CR6DPLAD),B'10111111'                       0150
*         IF  ATCONFIG(3)=CR6BLANK     /*AND 3RD SPACE ZERO */     0151
*           THEN DO;                                               0151
         CLI   ATCONFIG+2(@09),C' '                                0151
         BNE   @RF00151                                            0151
*          CONCONFG(7:8)=ATCONFIG(1:2); /*PUT DIGITS INTO CONF TBL*/
         MVC   CONCONFG+6(2,CR6R04),ATCONFIG(@09)                  0153
*            DLRPLRCD =0;              /*SET RETURN CODE IN DLRPL*/
         MVI   DLRPLRCD(CR6DPLAD),X'00'                            0154
*            END;                                                  0155
*      ELSE  IF ATCONFIG(1:1)=CR6BITNM    /*CON PARM=BINARY 0*/    0156
*               THEN DO;                                           0156
         B     @RC00151                                            0156
@RF00151 L     @09,ATCLCPTR                                        0156
         CLI   ATCONFIG(@09),X'00'                                 0156
         BNE   @RF00156                                            0156
*                CONCONFG(7:8)='00';     /*PUT CHAR 0 IN HIGH ORDER */
         MVC   CONCONFG+6(2,CR6R04),@CC00647                       0158
*                DLRPLRCD=0;                                       0159
         MVI   DLRPLRCD(CR6DPLAD),X'00'                            0159
*               END;                                               0160
*           ELSE DO;                                               0161
         B     @RC00156                                            0161
@RF00156 DS    0H                                                  0162
*            DLRPLRCD =4;              /*SET RETURN CODE IN DLRPL*/
         MVI   DLRPLRCD(CR6DPLAD),X'04'                            0162
*              DLRPLMSG(1:8)  =ATCONFIG;  /*SAVE DATASET NAME*/    0163
         L     @09,ATCLCPTR                                        0163
         MVC   DLRPLMSG(8,CR6DPLAD),ATCONFIG(@09)                  0163
*              CR6WARM=ON;                                         0164
         OI    CR6WARM(CR6DPLAD),B'00010000'                       0164
*              CALL CR6OPEN;                                       0165
         BAL   @14,CR6OPEN                                         0165
*           END;                                                   0166
*       IF CR6COLD=ON|                                             0167
*            (ATCNODEL(1:1)^=CR6BITNM&DLRPLRCD=0) /*NODELIST  */   0167
*         THEN DO;                       /* & ^= CONFIG LIST*/     0167
@RC00156 DS    0H                                                  0167
@RC00151 TM    CR6COLD(CR6DPLAD),B'00001000'                       0167
         BO    @RT00167                                            0167
         L     @09,ATCLCPTR                                        0167
         CLI   ATCNODEL(@09),X'00'                                 0167
         BE    @RF00167                                            0167
         CLI   DLRPLRCD(CR6DPLAD),0                                0167
         BNE   @RF00167                                            0167
@RT00167 DS    0H                                                  0168
*              CR6WARM=OFF;                                        0169
*              CR6COLD=ON;                                         0170
         OI    CR6COLD(CR6DPLAD),B'00001000'                       0170
         NI    CR6WARM(CR6DPLAD),B'11101111'                       0170
*              DLRPLMSG(1:8)  =ATCNODEL; /*SAVE NODELIST DATSET NAME*/
         L     @09,ATCLCPTR                                        0171
         MVC   DLRPLMSG(8,CR6DPLAD),ATCNODEL(@09)                  0171
*              CALL CR6OPEN;                                       0172
         BAL   @14,CR6OPEN                                         0172
*        END;                           /*NODELIST*/               0173
*   END;                                /*OPEN CASE*/              0174
*   ELSE                                                           0175
*     IF ATCNODDS ^= 0                  /*HAVE RPL?,ACB OPEN?*/    0175
*       THEN DO;                                                   0175
         B     @RC00148                                            0175
@RF00148 L     @09,ATCLCPTR                                        0175
         L     @09,ATCNODDS(,@09)                                  0175
         LTR   @09,@09                                             0175
         BZ    @RF00175                                            0175
*        CR6RPLAD=ATCNODDS;              /*WORKING PTR TO RPL*/    0177
         LR    CR6RPLAD,@09                                        0177
*       IF DLRPLFNC=DLRPLCLS             /*CLOSE?*/                0178
*         THEN CALL CR6CLOSE;            /*YES-CALL CLOSE*/        0178
         CLI   DLRPLFNC(CR6DPLAD),4                                0178
         BNE   @RF00178                                            0178
         BAL   @14,CR6CLOSE                                        0179
*         ELSE CALL CR6UPERS;            /*NO-CALL UPDATE,ERASE*/  0180
         B     @RC00178                                            0180
@RF00178 BAL   @14,CR6UPERS                                        0180
*      END;                                                        0181
         EJECT
*CR6OPEN:PROC OPTIONS(NOSAVE,NOSAVEAREA);                          0182
         B     @PB00002                                            0182
CR6OPEN  DS    0H                                                  0183
*/*----------------------------------------                        0183
* OPEN DATASET AND UPDATE CONFIG TABLE                             0183
*------------------------------------------*/                      0183
*DLRPLSA1=CR6R14;                       /*SAVE REG-14*/            0183
         ST    CR6R14,DLRPLSA1(,CR6DPLAD)                          0183
*/*--------------------------------------------------*/            0184
*/*GETSTOR FOR ACB,RPL,BUF,AND WORKING AREA          */            0184
*/*--------------------------------------------------*/            0184
*STM(GPR02P,GPR10P,CR6R210);            /*SAVE REG 2->10*/         0184
         STM   GPR02P,GPR10P,CR6R210(CR6DPLAD)                     0184
*RFY CR6R01 RSTD;                                                  0185
*CR6R01  =LENGTH(CR6GTSTR);                 /*GETSTOR SIZE*/       0186
         LA    CR6R01,177                                          0186
* /*GETSTOR SIZE(CR6R01)CLEAR(YES)SAVE(NO)*/                       0187
*  DO;                                                             0187
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTATCVT,ISTRPH)  */                  0188
*/* END OF ATBUILD */                                              0188
* RFY (GPR00P,GPR01P,GPR02P,GPR03P) RSTD;                          0188
* GPR00F = CR6R01;                                     /*SIZE IN REG0*/
         LR    GPR00F,CR6R01                                       0189
* DCL 1 CMZA0007 FIXED(31) STATIC LOCAL,                           0190
*       2 * FIXED(8) INIT(32),                       /* OPTION FLAGS */
*       2 * FIXED(8) INIT(96),                        /* STORAGE KEY */
*       2 * FIXED(8) INIT(231),                    /* SUBPOOL NUMBER */
*       2 * FIXED(8) INIT('00'X);                    /* REQUEST TYPE */
* GPR03F = CMZA0007;                                               0191
*                                                                  0191
         L     GPR03F,CMZA0007                                     0191
* DO; /* LISATCVT CVTBASE(PAGEABLE,(GPR02P)) */                    0192
*   GPR02P = ATCLCPTR; /*SET UP ATCVT POINTER*/                    0193
         L     GPR02P,ATCLCPTR                                     0193
* END; /*LISATCVT*/                                                0194
* CALL GPR02P -> ATCGTSTR;                            /*CALL ISTORFSR*/
         L     @15,ATCGTSTR(,GPR02P)                               0195
         BALR  @14,@15                                             0195
* RFY (GPR00P,GPR01P,GPR02P,GPR03P) UNRSTD;                        0196
* END ;                                              /*END OF GETSTOR*/
*     /*GETSTORAGE*/                                               0198
*RFY CR6R01  UNRSTD;                                               0198
*RFY GPR03P RSTD;                                                  0199
* RFY (ISTDLRPL) BASED(CR6R13);                                    0200
* GPR02P=CR6R2S;                        /*REST REG 2*/             0201
         L     GPR02P,CR6R2S(,CR6R13)                              0201
* LM(GPR04P,GPR10P,CR6R410);            /*REST REG 4->10*/         0202
         LM    GPR04P,GPR10P,CR6R410(CR6R13)                       0202
* RFY (ISTDLRPL) BASED(CR6DPLAD);                                  0203
*IF CR6R15 ^= 0                         /*GETSTOR ERROR */         0204
*  THEN DO;                                                        0204
         LTR   CR6R15,CR6R15                                       0204
         BZ    @RF00204                                            0204
*   CR6ERCOD = FIVE;                    /*INDICATE GETSTOR ERROR*/ 0206
         MVC   CR6ERCOD(2,CR6DPLAD),@CH00306                       0206
*   CALL CR6ERROR;                      /*CALL ERROR ROUTINE*/     0207
         BAL   @14,CR6ERROR                                        0207
*  END;                                                            0208
*   ATCNODDS=GPR03P;              /*RPL PTR INTO CONFIG LST*/      0209
@RF00204 L     @09,ATCLCPTR                                        0209
         ST    GPR03P,ATCNODDS(,@09)                               0209
*CR6RPLAD=GPR03P;                       /*WORKING PTR TO RPL*/     0210
         LR    CR6RPLAD,GPR03P                                     0210
*RFY GPR03P UNRSTD;                                                0211
*CR6OPN=OPNBASE;                        /*MOVE OPEN LIST TO CR6*/  0212
         L     @09,ATCLCPTR                                        0212
         L     @09,ATCNODDS(,@09)                                  0212
         MVC   CR6OPN(4,@09),OPNBASE                               0212
*CR6CLS=CLSBASE;                         /*MOVE CLOSE LIST TO CR6*/
         MVC   CR6CLS(4,@09),CLSBASE                               0213
*CR6ACB=ACBBASE;                          /*MOVE ACB TO CR6*/      0214
         MVC   CR6ACB(76,@09),ACBBASE                              0214
*CR6RPL=RPLBASE;                          /*MOVE RPL TO CR6*/      0215
         MVC   CR6RPL(76,@09),RPLBASE                              0215
*RPLDACB=ATCNODDS+RPLLEN;                   /*PTR TO ACB INTO RPL*/
         SLR   @06,@06                                             0216
         IC    @06,RPLLEN(,CR6RPLAD)                               0216
         ALR   @06,@09                                             0216
         ST    @06,RPLDACB(,CR6RPLAD)                              0216
*RPLRLEN=LENGTH(CR6REC);                    /*REC LENGTH INTO RPL*/
         LA    @05,10                                              0217
         ST    @05,RPLRLEN(,CR6RPLAD)                              0217
*RPLAREA=RPLDACB+ACBLENG;                   /*PTR TO BUF INT RPL*/ 0218
         LH    @03,ACBLENG(,@06)                                   0218
         ALR   @03,@06                                             0218
         ST    @03,RPLAREA(,CR6RPLAD)                              0218
*RPLARG=ADDR(CR6KEY);                   /*KEY ADDR INTO RPL*/      0219
         ST    @03,RPLARG(,CR6RPLAD)                               0219
*RPLKEYL=LENGTH(CR6KEY);                /*KEY LENGTH INTO RPL*/    0220
         MVC   RPLKEYL(2,CR6RPLAD),@CH00165                        0220
*RPLKGE=ON;                             /*SEARCH ON KEY GE*/       0221
         OI    RPLKGE(CR6RPLAD),B'00000100'                        0221
*RPLBUFL=LENGTH(CR6REC);                /*REC LENGTH INTO RPL*/    0222
         ST    @05,RPLBUFL(,CR6RPLAD)                              0222
*ACBLRECL=LENGTH(CR6REC);               /*REC LENGTH INTO ACB*/    0223
         STH   @05,ACBLRECL(,@06)                                  0223
*ACBDDNM=DLRPLMSG(1:8);                 /*DDNAME INTO ACB*/        0224
         MVC   ACBDDNM(8,@06),DLRPLMSG(CR6DPLAD)                   0224
*RFY (CR6R03,CR6R09) RSTD;                                         0225
*CR6R15=0;                              /*ZERO R-15*/              0226
         SLR   CR6R15,CR6R15                                       0226
*CR6R03=ADDR(CR6ACB);                                              0227
         L     @06,ATCLCPTR                                        0227
         L     @06,ATCNODDS(,@06)                                  0227
         LA    CR6R03,CR6ACB(,@06)                                 0227
*CR6R09=ADDR(CR6OPN);                                              0228
         LA    CR6R09,CR6OPN(,@06)                                 0228
*GEN(OPEN ((3)),MF=(E,(9)));  /*OPEN DATASET*/                     0229
         OPEN ((3)),MF=(E,(9))
*RFY (CR6R03,CR6R09) UNRSTD;                                       0230
         EJECT
*/*--------------------------------*/                              0231
*/* CHECK  IF DATASET NOT CLOSE*/                                  0231
*IF CR6R15=4                                                       0231
*   THEN DO;                                                       0231
         C     CR6R15,@CF00168                                     0231
         BNE   @RF00231                                            0231
*CR6R15=0;                                /*ZERO R-15*/            0233
         SLR   CR6R15,CR6R15                                       0233
*RFY (CR6R03,CR6R09) RSTD;                                         0234
*CR6R03=ADDR(CR6ACB);                                              0235
         L     @06,ATCLCPTR                                        0235
         L     @06,ATCNODDS(,@06)                                  0235
         LA    CR6R03,CR6ACB(,@06)                                 0235
*CR6R09=ADDR(CR6CLS);                                              0236
         LA    CR6R09,CR6CLS(,@06)                                 0236
*GEN(CLOSE     ((3)),MF=(E,(9)));   /*ISS TCLOSE*/                 0237
         CLOSE     ((3)),MF=(E,(9))
*RFY (CR6R03,CR6R09) UNRSTD;                                       0238
*IF CR6R15 >  0                          /*CLOSE ERROR?*/          0239
*  THEN DO;                                                        0239
         LTR   CR6R15,CR6R15                                       0239
         BNP   @RF00239                                            0239
*   CR6ERCOD = ONE;                      /*INDICATE CLOSE ERROR*/  0241
         MVC   CR6ERCOD(2,CR6DPLAD),@CH00125                       0241
*   CALL CR6ERROR;                       /*CALL ERROR ROUITNE*/    0242
         BAL   @14,CR6ERROR                                        0242
*  END;                                                            0243
*CR6R15=0;                              /*ZERO R-15*/              0244
@RF00239 SLR   CR6R15,CR6R15                                       0244
*RFY (CR6R03,CR6R09)   RSTD;                                       0245
*CR6R03=ADDR(CR6ACB);                                              0246
         L     @06,ATCLCPTR                                        0246
         L     @06,ATCNODDS(,@06)                                  0246
         LA    CR6R03,CR6ACB(,@06)                                 0246
*CR6R09=ADDR(CR6OPN);                                              0247
         LA    CR6R09,CR6OPN(,@06)                                 0247
*GEN(OPEN ((3)),MF=(E,(9)));  /*OPEN DATASET*/                     0248
         OPEN ((3)),MF=(E,(9))
*RFY (CR6R03,CR6R09) UNRSTD;                                       0249
*IF CR6R15 > 4                          /*OPEN ERROR*/             0250
*  THEN DO;                             /*YES*/                    0250
         C     CR6R15,@CF00168                                     0250
         BNH   @RF00250                                            0250
*   CR6ERCOD=THREE;                     /*INDICATE OPEN ERROR*/    0252
         MVC   CR6ERCOD(2,CR6DPLAD),@CH00137                       0252
*   CALL CR6ERROR;                      /*CALL ERROR ROUTINE*/     0253
         BAL   @14,CR6ERROR                                        0253
*  END;                                                            0254
*   END;                                                           0255
@RF00250 DS    0H                                                  0256
         EJECT
*IF CR6R15 > 4                          /*OPEN ERROR*/             0256
*  THEN DO;                             /*YES*/                    0256
@RF00231 C     CR6R15,@CF00168                                     0256
         BNH   @RF00256                                            0256
*   CR6ERCOD=THREE;                     /*INDICATE OPEN ERROR*/    0258
         MVC   CR6ERCOD(2,CR6DPLAD),@CH00137                       0258
*   CALL CR6ERROR;                      /*CALL ERROR ROUTINE*/     0259
         BAL   @14,CR6ERROR                                        0259
*  END;                                                            0260
* IF ACBAMBL->AMBLDTA->AMBINBUF=OFF      /*SHARE OPTION 4 SPECIFIED?*/
*   THEN DO;                            /*NO ?*/                   0261
@RF00256 L     @09,RPLDACB(,CR6RPLAD)                              0261
         L     @09,ACBAMBL(,@09)                                   0261
         L     @09,AMBLDTA(,@09)                                   0261
         TM    AMBINBUF(@09),B'00000001'                           0261
         BNZ   @RF00261                                            0261
*DLRPLMID=CR6421I;                                                 0263
         MVC   DLRPLMID(4,CR6DPLAD),@CC00459                       0263
*       RFY (CR6MSGNO,CR6MSGTX) RSTD;                              0264
*       CR6MSGNO=ADDR(DLRPLMID);                                   0265
         LA    CR6MSGNO,DLRPLMID(,CR6DPLAD)                        0265
*       CR6MSGTX=ADDR(DLRPLMSG);                                   0266
*                                                                  0266
         LA    CR6MSGTX,DLRPLMSG(,CR6DPLAD)                        0266
*/*TPMSG MSGID((CR6MSGNO))MSG((CR6MSGTX))OPTIONS((DLRPLCON))PLAREA(DLRP
*TPL)*/                                                            0267
*                                                                  0267
*        DO;                                                       0267
*          DCL REG1025  REG(1)  PTR;                               0268
*          RFY (REG1025) RSTD;                                     0269
*                                                                  0269
*        RFY (EMCR13) RSTD;                                        0270
*          DCL 1 * BASED(REG1025),                                 0271
*              2 CMZID025 PTR(31),                                 0271
*              2 *,                                                0271
*                3 CMZRL025 PTR(8),                                0271
*                3 CMZRA025 PTR(24) BDY(BYTE),                     0271
*              2 CMZEA025 PTR(31),                                 0271
*              2 CMZVP025 PTR(31);                                 0271
*                                                                  0271
*/*XREGSET  PID('PLAREA')PPARM(DLRPLTPL)RREG(,REG1025)*/           0272
*        DO;                                                       0272
*          REG1025=ADDR(DLRPLTPL);       /*SET RREG SYMBOL TO ADDRESS*/
         LA    REG1025,DLRPLTPL(,CR6DPLAD)                         0273
*                                        /*OF PPARM OPERAND          */
*        END;  /* XREGSET */                                       0274
*          CMZID025 = 0;                                           0275
         SLR   @11,@11                                             0275
         ST    @11,CMZID025(,REG1025)                              0275
*          CMZRL025 = 0;                                           0276
         MVI   CMZRL025(REG1025),X'00'                             0276
*          CMZRA025 = 0;                                           0277
         STCM  @11,7,CMZRA025(REG1025)                             0277
*          CMZEA025 = 0;                                           0278
         ST    @11,CMZEA025(,REG1025)                              0278
*          CMZVP025 = 0;                                           0279
         ST    @11,CMZVP025(,REG1025)                              0279
*          CMZID025=CR6MSGNO;                                      0280
         ST    CR6MSGNO,CMZID025(,REG1025)                         0280
*          CMZVP025 = CR6MSGTX;                                    0281
         ST    CR6MSGTX,CMZVP025(,REG1025)                         0281
*          DCL CMZSA025 (18) PTR(31) BASED(EMCR13);                0282
*          CMZSA025(5) = DLRPLCON;                                 0283
*                                                                  0283
         L     @11,DLRPLCON(,CR6DPLAD)                             0283
         ST    @11,CMZSA025+16(,EMCR13)                            0283
*          DCL REG15025 REG(15) PTR;                               0284
*          RFY REG15025 RSTD;                                      0285
*                                                                  0285
*        DO; /* LISATCVT CVTBASE(PAGEABLE,(REG15025)) */           0286
*          REG15025 = ATCLCPTR; /*SET UP ATCVT POINTER*/           0287
         L     REG15025,ATCLCPTR                                   0287
*        END; /*LISATCVT*/                                         0288
*          DCL CMTA025 BASED(REG15025) ENTRY VALUERANGE(*);        0289
*          REG15025 = REG15025->ATCMSGP;                           0290
         L     REG15025,ATCMSGP(,REG15025)                         0290
*          CALL CMTA025;                                           0291
         BALR  @14,@15                                             0291
*          RESPECIFY (REG1025,REG15025)  UNRESTRICTED;             0292
*                                                                  0292
*        RFY (EMCR13) UNRSTD;                                      0293
*        END;                                                      0294
*       RFY (CR6MSGNO,CR6MSGTX) UNRSTD;                            0295
* END;                                                             0296
*FIRSTSW=ON;                                                       0297
@RF00261 L     @09,ATCLCPTR                                        0297
         L     @09,ATCNODDS(,@09)                                  0297
         OI    FIRSTSW(@09),B'10000000'                            0297
*/*---------*/                                                     0298
*/*---------------*/                                               0298
*/*SEE IF EMPTY DATASET*/                                          0298
*/*---------------*/                                               0298
*CR6KEY=0;                                                         0298
         L     @09,RPLAREA(,CR6RPLAD)                              0298
         SLR   @06,@06                                             0298
         STH   @06,CR6KEY(,@09)                                    0298
*GEN(GET  RPL=(7));                     /*ISSUE GET*/              0299
         GET  RPL=(7)
*           IF CR6R15^=0            /*ERROR?*/                     0300
*             THEN DO;                                             0300
         LTR   CR6R15,CR6R15                                       0300
         BZ    @RF00300                                            0300
*             CR6ERCOD=FOUR;        /*I/O ERROR*/                  0302
         MVC   CR6ERCOD(2,CR6DPLAD),@CH00168                       0302
*             CALL CR6ERROR;        /*CALL ERROR ROUTINE*/         0303
         BAL   @14,CR6ERROR                                        0303
*             END;                                                 0304
*GEN(CHECK RPL=(7));                                               0305
@RF00300 DS    0H                                                  0305
         CHECK RPL=(7)
*IF ((RPLRTNCD=CR6HEX8 & RPLERRCD=CR6HEX74)|  /*EODAD ON FIRST GET*/
*   (RPLRTNCD=CR6HEX8 & RPLERRCD=CR6HEX10))                        0306
* THEN DO;                                                         0306
         CLI   RPLRTNCD(CR6RPLAD),8                                0306
         BNE   @GL00003                                            0306
         CLI   RPLERRCD(CR6RPLAD),116                              0306
         BE    @RT00306                                            0306
@GL00003 CLI   RPLRTNCD(CR6RPLAD),8                                0306
         BNE   @RF00306                                            0306
         CLI   RPLERRCD(CR6RPLAD),16                               0306
         BNE   @RF00306                                            0306
@RT00306 DS    0H                                                  0307
*       FIRSTSW=OFF;                        /*TURN OFF FIRST SW*/  0308
         L     @09,ATCLCPTR                                        0308
         L     @09,ATCNODDS(,@09)                                  0308
         NI    FIRSTSW(@09),B'01111111'                            0308
*       GO TO FIXDS;                        /*FIX DATASET*/        0309
         B     FIXDS                                               0309
* END;                                                             0310
*ELSE DO;                                                          0311
@RF00306 DS    0H                                                  0312
*    IF RPLRTNCD ^=0                         /*ERROR BUT NO EODAD*/
*        THEN DO;                                                  0312
         CLI   RPLRTNCD(CR6RPLAD),0                                0312
         BE    @RF00312                                            0312
*        CR6ERCOD=FOUR;                 /*INDICATE I/O ERROR*/     0314
         MVC   CR6ERCOD(2,CR6DPLAD),@CH00168                       0314
*        CALL CR6ERROR;                 /*CALL ERROR ROUTINE*/     0315
         BAL   @14,CR6ERROR                                        0315
*        END;                                                      0316
* END;                                                             0317
@RF00312 DS    0H                                                  0318
*/* -----------------------*/                                      0318
*/* LOOP UNTIL EODAD TO FIND KEY OF LAST RECORD */                 0318
*/* -----------------------*/                                      0318
*IF CR6COLD=OFF                                                    0318
* THEN DO;                                                         0318
         TM    CR6COLD(CR6DPLAD),B'00001000'                       0318
         BNZ   @RF00318                                            0318
*CR6GTSZ=1;                            /*INIT GETSTOR SIZE*/       0320
         LA    @09,1                                               0320
         L     @06,ATCLCPTR                                        0320
         L     @06,ATCNODDS(,@06)                                  0320
         STH   @09,CR6GTSZ(,@06)                                   0320
*CR6KEY=1;                                                         0321
         L     @06,RPLAREA(,CR6RPLAD)                              0321
         STH   @09,CR6KEY(,@06)                                    0321
*DO WHILE (RPLRTNCD^=CR6HEX8 | RPLERRCD^=CR6HEX10);/*LOOP TIL EOD*/
         B     @DE00322                                            0322
@DL00322 DS    0H                                                  0323
*  RPLUPD=ON;                                                      0323
         OI    RPLUPD(CR6RPLAD),B'00000010'                        0323
*  GEN(GET RPL=(7));                    /*ISSUE GET*/              0324
         GET RPL=(7)
*           IF CR6R15^=0            /*ERROR?*/                     0325
*             THEN DO;                                             0325
         LTR   CR6R15,CR6R15                                       0325
         BZ    @RF00325                                            0325
*             CR6ERCOD=FOUR;        /*I/O ERROR*/                  0327
         MVC   CR6ERCOD(2,CR6DPLAD),@CH00168                       0327
*             CALL CR6ERROR;        /*CALL ERROR ROUTINE*/         0328
         BAL   @14,CR6ERROR                                        0328
*             END;                                                 0329
*GEN(CHECK RPL=(7));                                               0330
*                                                                  0330
@RF00325 DS    0H                                                  0330
         CHECK RPL=(7)
*    IF RPLRTNCD ^=0 & (RPLRTNCD^=CR6HEX8 |  /*ERROR BUT NO EODAD*/
*                      RPLERRCD^=CR6HEX10)                         0331
*        THEN DO;                                                  0331
         CLI   RPLRTNCD(CR6RPLAD),0                                0331
         BE    @RF00331                                            0331
         CLI   RPLRTNCD(CR6RPLAD),8                                0331
         BNE   @RT00331                                            0331
         CLI   RPLERRCD(CR6RPLAD),16                               0331
         BE    @RF00331                                            0331
@RT00331 DS    0H                                                  0332
*        CR6ERCOD=FOUR;                 /*INDICATE I/O ERROR*/     0333
         MVC   CR6ERCOD(2,CR6DPLAD),@CH00168                       0333
*        CALL CR6ERROR;                 /*CALL ERROR ROUTINE*/     0334
         BAL   @14,CR6ERROR                                        0334
*        END;                                                      0335
* IF RPLRTNCD =0                                                   0336
*   THEN GOTO ERASES;                                              0336
@RF00331 CLI   RPLRTNCD(CR6RPLAD),0                                0336
         BE    @RT00336                                            0336
* IF                   (RPLRTNCD^=CR6HEX8 |  /*         NOT EODAD*/
*                   RPLERRCD^=CR6HEX10)                            0338
*  THEN DO;                                                        0338
         CLI   RPLRTNCD(CR6RPLAD),8                                0338
         BNE   @RT00338                                            0338
         CLI   RPLERRCD(CR6RPLAD),16                               0338
         BE    @RF00338                                            0338
@RT00338 DS    0H                                                  0339
*   ERASER:;                                                       0340
ERASER   DS    0H                                                  0341
*   CR6GTSZ=CR6GTSZ+1;                  /*INCREM GETSTORE SIZE*/   0341
         L     @09,ATCLCPTR                                        0341
         L     @09,ATCNODDS(,@09)                                  0341
         LA    @06,1                                               0341
         LH    @05,CR6GTSZ(,@09)                                   0341
         N     @05,@CF02827                                        0341
         ALR   @06,@05                                             0341
         STH   @06,CR6GTSZ(,@09)                                   0341
*     CR6GETSW=ON;                                                 0342
         OI    CR6GETSW(CR6DPLAD),B'00100000'                      0342
*     CR6KEYSV=CR6GTSZ;                                            0343
         STH   @06,CR6KEYSV(,@09)                                  0343
*     GOTO NEWKEY;                                                 0344
*                                                                  0344
         B     NEWKEY                                              0344
* ERASES:;                                                         0345
ERASES   DS    0H                                                  0346
*     GEN( ERASE  RPL=(7));             /*ERASE RECORD*/           0346
          ERASE  RPL=(7)
*           IF CR6R15^=0            /*ERROR?*/                     0347
*             THEN DO;                                             0347
         LTR   CR6R15,CR6R15                                       0347
         BZ    @RF00347                                            0347
*             CR6ERCOD=FOUR;        /*I/O ERROR*/                  0349
         MVC   CR6ERCOD(2,CR6DPLAD),@CH00168                       0349
*             CALL CR6ERROR;        /*CALL ERROR ROUTINE*/         0350
         BAL   @14,CR6ERROR                                        0350
*             END;                                                 0351
*GEN(CHECK RPL=(7));                                               0352
@RF00347 DS    0H                                                  0352
         CHECK RPL=(7)
*    IF (RPLRTNCD^=0) & (RPLRTNCD^=CR6HEX8|RPLERRCD^='5C'X)        0353
*        THEN DO;                     /*ERASE ERROR*/              0353
         CLI   RPLRTNCD(CR6RPLAD),0                                0353
         BE    @RF00353                                            0353
         CLI   RPLRTNCD(CR6RPLAD),8                                0353
         BNE   @RT00353                                            0353
         CLI   RPLERRCD(CR6RPLAD),92                               0353
         BE    @RF00353                                            0353
@RT00353 DS    0H                                                  0354
*          CR6ERCOD=FOUR;               /*INDICATE I/O ERROR*/     0355
         MVC   CR6ERCOD(2,CR6DPLAD),@CH00168                       0355
*          CALL CR6ERROR;               /*CALL ERROR ROUTINE*/     0356
         BAL   @14,CR6ERROR                                        0356
*        END;                                                      0357
*   CR6KEY=CR6GTSZ;                     /*RESET KEY */             0358
@RF00353 L     @09,RPLAREA(,CR6RPLAD)                              0358
         L     @06,ATCLCPTR                                        0358
         L     @06,ATCNODDS(,@06)                                  0358
         LH    @06,CR6GTSZ(,@06)                                   0358
         N     @06,@CF02827                                        0358
         STH   @06,CR6KEY(,@09)                                    0358
*   RPLUPD=OFF;                                                    0359
         NI    RPLUPD(CR6RPLAD),B'11111101'                        0359
*    GEN(   PUT  RPL=(7));               /*PUT OUT THE RECORD*/    0360
            PUT  RPL=(7)
*           IF CR6R15^=0            /*ERROR?*/                     0361
*             THEN DO;                                             0361
         LTR   CR6R15,CR6R15                                       0361
         BZ    @RF00361                                            0361
*             CR6ERCOD=FOUR;        /*I/O ERROR*/                  0363
         MVC   CR6ERCOD(2,CR6DPLAD),@CH00168                       0363
*             CALL CR6ERROR;        /*CALL ERROR ROUTINE*/         0364
         BAL   @14,CR6ERROR                                        0364
*             END;                                                 0365
*GEN(CHECK RPL=(7));                                               0366
@RF00361 DS    0H                                                  0366
         CHECK RPL=(7)
*         RPLUPD=ON;                                               0367
         OI    RPLUPD(CR6RPLAD),B'00000010'                        0367
*   IF RPLRTNCD^=0                       /*PUT ERROR?*/            0368
*      THEN DO;                                                    0368
         CLI   RPLRTNCD(CR6RPLAD),0                                0368
         BE    @RF00368                                            0368
*        CR6ERCOD=FOUR;                   /*INDICATE I/O ERROR*/   0370
         MVC   CR6ERCOD(2,CR6DPLAD),@CH00168                       0370
*        CALL CR6ERROR;                   /*CALL ERROR ROUTINE*/   0371
         BAL   @14,CR6ERROR                                        0371
*      END;                                                        0372
*NEWKEY:;                                                          0373
@RF00368 DS    0H                                                  0373
NEWKEY   DS    0H                                                  0374
*IF CR6GETSW=OFF THEN GOTO ERASER;                                 0374
         TM    CR6GETSW(CR6DPLAD),B'00100000'                      0374
         BZ    @RT00374                                            0374
* CR6GETSW=OFF;                                                    0376
         NI    CR6GETSW(CR6DPLAD),B'11011111'                      0376
*CR6KEY=CR6KEY+1;                                                  0377
         L     @09,RPLAREA(,CR6RPLAD)                              0377
         LA    @06,1                                               0377
         LH    @05,CR6KEY(,@09)                                    0377
         N     @05,@CF02827                                        0377
         ALR   @06,@05                                             0377
         STH   @06,CR6KEY(,@09)                                    0377
*END;                                    /*NOT EODAD*/             0378
*END;                        /*EODAD LOOP*/                        0379
@RF00338 DS    0H                                                  0379
@DE00322 CLI   RPLRTNCD(CR6RPLAD),8                                0379
         BNE   @DL00322                                            0379
         CLI   RPLERRCD(CR6RPLAD),16                               0379
         BNE   @DL00322                                            0379
*CR6KEYSV=CR6KEY;                   /*SAVE HIGHEST KEY*/           0380
         L     @09,ATCLCPTR                                        0380
         L     @06,ATCNODDS(,@09)                                  0380
         L     @05,RPLAREA(,CR6RPLAD)                              0380
         LH    @05,CR6KEY(,@05)                                    0380
         N     @05,@CF02827                                        0380
         STH   @05,CR6KEYSV(,@06)                                  0380
*/*--------------------------------------------------*/            0381
*/*GETSTOR FOR CONFIG TABLE BUILDING                 */            0381
*/*--------------------------------------------------*/            0381
*STM(GPR02P,GPR10P,CR6R210);            /*SAVE REG 2->10*/         0381
         STM   GPR02P,GPR10P,CR6R210(CR6DPLAD)                     0381
*RFY CR6R01 RSTD;                                                  0382
*CR6R01  =CR6GTSZ*9;                        /*GETSTOR SIZE*/       0383
         LH    CR6R01,CR6GTSZ(,@06)                                0383
         N     CR6R01,@CF02827                                     0383
         MH    CR6R01,@CH00177                                     0383
* /*GETSTOR SIZE(CR6R01)CLEAR(YES)SAVE(NO)FETCHP(NO)*/             0384
*  DO;                                                             0384
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTATCVT,ISTRPH)  */                  0385
*/* END OF ATBUILD */                                              0385
* RFY (GPR00P,GPR01P,GPR02P,GPR03P) RSTD;                          0385
* GPR00F = CR6R01;                                     /*SIZE IN REG0*/
         LR    GPR00F,CR6R01                                       0386
* DCL 1 CMZA0034 FIXED(31) STATIC LOCAL,                           0387
*       2 * FIXED(8) INIT(32),                       /* OPTION FLAGS */
*       2 * FIXED(8) INIT(96),                        /* STORAGE KEY */
*       2 * FIXED(8) INIT(241),                    /* SUBPOOL NUMBER */
*       2 * FIXED(8) INIT('00'X);                    /* REQUEST TYPE */
* GPR03F = CMZA0034;                                               0388
*                                                                  0388
         L     GPR03F,CMZA0034                                     0388
* DO; /* LISATCVT CVTBASE(PAGEABLE,(GPR02P)) */                    0389
*   GPR02P = ATCLCPTR; /*SET UP ATCVT POINTER*/                    0390
         LR    GPR02P,@09                                          0390
* END; /*LISATCVT*/                                                0391
* CALL GPR02P -> ATCGTSTR;                            /*CALL ISTORFSR*/
         L     @15,ATCGTSTR(,GPR02P)                               0392
         BALR  @14,@15                                             0392
* RFY (GPR00P,GPR01P,GPR02P,GPR03P) UNRSTD;                        0393
* END ;                                              /*END OF GETSTOR*/
*/*GETSTOR*/                                                       0395
*RFY CR6R01  UNRSTD;                                               0395
*RFY GPR03P RSTD;                                                  0396
* RFY (ISTDLRPL) BASED(CR6R13);                                    0397
* GPR02P=CR6R2S;                        /*REST REG 2*/             0398
         L     GPR02P,CR6R2S(,CR6R13)                              0398
* LM(GPR04P,GPR10P,CR6R410);            /*REST REG 4->10*/         0399
         LM    GPR04P,GPR10P,CR6R410(CR6R13)                       0399
* RFY (ISTDLRPL) BASED(CR6DPLAD);                                  0400
*CR6WKPT=GPR03P;                       /*SET UP PTR TO CON TBL*/   0401
         LR    CR6WKPT,GPR03P                                      0401
*RFY GPR03P UNRSTD;                                                0402
*RFY (CR6CNF) BASED(CR6WKPT);                                      0403
*IF CR6R15 ^= 0                         /*GETSTOR ERROR */         0404
*  THEN DO;                                                        0404
         LTR   CR6R15,CR6R15                                       0404
         BZ    @RF00404                                            0404
*   CR6ERCOD = FIVE;                    /*INDICATE GETSTOR ERROR*/ 0406
         MVC   CR6ERCOD(2,CR6DPLAD),@CH00306                       0406
*   CALL CR6ERROR;                      /*CALL ERROR ROUTINE*/     0407
         BAL   @14,CR6ERROR                                        0407
*  END;                                                            0408
*CONBUFSZ=CR6GTSZ*9;                /*BUF SIZE INTO ISTCONFT*/     0409
@RF00404 L     @09,ATCLCPTR                                        0409
         L     @09,ATCNODDS(,@09)                                  0409
         LH    @09,CR6GTSZ(,@09)                                   0409
         N     @09,@CF02827                                        0409
         MH    @09,@CH00177                                        0409
         STH   @09,CONBUFSZ(,CR6R04)                               0409
*CONRDBUF=CR6WKPT;                  /*PTR TO BUF INTO ISTCONFT*/   0410
         ST    CR6WKPT,CONRDBUF(,CR6R04)                           0410
*IF CR6WARM=ON THEN RPLUPD=OFF;                                    0411
         TM    CR6WARM(CR6DPLAD),B'00010000'                       0411
         BNO   @RF00411                                            0411
         NI    RPLUPD(CR6RPLAD),B'11111101'                        0412
*              ELSE RPLUPD=ON;                                     0413
         B     @RC00411                                            0413
@RF00411 OI    RPLUPD(CR6RPLAD),B'00000010'                        0413
*END;                             /*WARM*/                         0414
@RC00411 DS    0H                                                  0415
*                                /*NOT COLD*/                      0415
         EJECT
*                                                                  0415
*    /*-------------------------------                             0415
*       LOOP THRU         RECORDS                                  0415
*    ---------------------------------*/                           0415
*IF CR6COLD=ON THEN      CR6KEYSV=1;         /*IF COLD INIT KEY SAVE*/
@RF00318 TM    CR6COLD(CR6DPLAD),B'00001000'                       0415
         BNO   @RF00415                                            0415
         L     @09,ATCLCPTR                                        0416
         L     @09,ATCNODDS(,@09)                                  0416
         MVC   CR6KEYSV(2,@09),@CH00125                            0416
*    RPLERRCD= '00'X;                  /*SET RPL ERR CODE TO 0*/   0417
@RF00415 MVI   RPLERRCD(CR6RPLAD),X'00'                            0417
*    RPLRTNCD= '00'X;                  /*SET RPL RET CD TO 0*/     0418
         MVI   RPLRTNCD(CR6RPLAD),X'00'                            0418
*    CR6KEY=1;                          /*INIT KEY*/               0419
         LA    @09,1                                               0419
         L     @06,RPLAREA(,CR6RPLAD)                              0419
         STH   @09,CR6KEY(,@06)                                    0419
*    CR6CNT=1;                         /*INIT CONF TBL CNT*/       0420
         L     @06,ATCLCPTR                                        0420
         L     @06,ATCNODDS(,@06)                                  0420
         STH   @09,CR6CNT(,@06)                                    0420
*    DO WHILE (RPLRTNCD^=CR6HEX8 | RPLERRCD^=CR6HEX10);/*LOOP TIL EOD*/
         B     @DE00421                                            0421
@DL00421 DS    0H                                                  0422
*      GEN(GET RPL=(7));                /*ISSUE GET*/              0422
         GET RPL=(7)
*           IF CR6R15^=0            /*ERROR?*/                     0423
*             THEN DO;                                             0423
         LTR   CR6R15,CR6R15                                       0423
         BZ    @RF00423                                            0423
*             CR6ERCOD=FOUR;        /*I/O ERROR*/                  0425
         MVC   CR6ERCOD(2,CR6DPLAD),@CH00168                       0425
*             CALL CR6ERROR;        /*CALL ERROR ROUTINE*/         0426
         BAL   @14,CR6ERROR                                        0426
*             END;                                                 0427
*GEN(CHECK RPL=(7));                                               0428
@RF00423 DS    0H                                                  0428
         CHECK RPL=(7)
*    IF RPLRTNCD ^=0 & (RPLRTNCD^=CR6HEX8 |  /*ERROR BUT NO EODAD*/
*                      RPLERRCD^=CR6HEX10)                         0429
*        THEN DO;                                                  0429
         CLI   RPLRTNCD(CR6RPLAD),0                                0429
         BE    @RF00429                                            0429
         CLI   RPLRTNCD(CR6RPLAD),8                                0429
         BNE   @RT00429                                            0429
         CLI   RPLERRCD(CR6RPLAD),16                               0429
         BE    @RF00429                                            0429
@RT00429 DS    0H                                                  0430
*        CR6ERCOD=FOUR;                 /*INDICATE I/O ERROR*/     0431
         MVC   CR6ERCOD(2,CR6DPLAD),@CH00168                       0431
*        CALL CR6ERROR;                 /*CALL ERROR ROUTINE*/     0432
         BAL   @14,CR6ERROR                                        0432
*        END;                                                      0433
*IF                    (RPLRTNCD^=CR6HEX8 |  /*          NO EODAD*/
*               RPLERRCD^=CR6HEX10)                                0434
*    THEN DO;                                                      0434
@RF00429 CLI   RPLRTNCD(CR6RPLAD),8                                0434
         BNE   @RT00434                                            0434
         CLI   RPLERRCD(CR6RPLAD),16                               0434
         BE    @RF00434                                            0434
@RT00434 DS    0H                                                  0435
*     IF CR6WARM =ON                    /*IF WARM START*/          0436
*      THEN DO;                                                    0436
         TM    CR6WARM(CR6DPLAD),B'00010000'                       0436
         BNO   @RF00436                                            0436
*    RFY CR6R11 RSTD;                                              0438
*       CR6R11=CR6CNT;                                             0439
         L     @09,ATCLCPTR                                        0439
         L     @09,ATCNODDS(,@09)                                  0439
         LH    CR6R11,CR6CNT(,@09)                                 0439
         N     CR6R11,@CF02827                                     0439
*        CR6CNF(CR6R11:CR6R11+8)=CR6MAJ; /*MAJ ND INTO CON TABLE*/ 0440
         LR    @10,CR6WKPT                                         0440
         ALR   @10,CR6R11                                          0440
         BCTR  @10,0                                               0440
         MVI   CR6CNF+8(@10),C' '                                  0440
         L     @09,RPLAREA(,CR6RPLAD)                              0440
         MVC   CR6CNF(8,@10),CR6MAJ(@09)                           0440
*           DO J=CR6R11 TO CR6R11+8;                               0441
         LR    J,CR6R11                                            0441
         B     @DE00441                                            0441
@DL00441 DS    0H                                                  0442
*             IF CR6CNF(J)=CR6BLANK     /*SEARCH FOR BLANK*/       0442
*              THEN DO;                                            0442
         LR    @10,CR6WKPT                                         0442
         ALR   @10,J                                               0442
         BCTR  @10,0                                               0442
         CLI   CR6CNF(@10),C' '                                    0442
         BNE   @RF00442                                            0442
*                CR6CNF(J)=',';         /*PUT IN COMMA*/           0444
         LR    @10,CR6WKPT                                         0444
         ALR   @10,J                                               0444
         BCTR  @10,0                                               0444
         MVI   CR6CNF(@10),C','                                    0444
*                CR6R11=J+1;            /*UPDATE CON TBL COUNTER*/ 0445
         LA    CR6R11,1                                            0445
         ALR   CR6R11,J                                            0445
*                J=CR6R11+9;            /*TO GET OUT OF LOOP*/     0446
         LA    J,9                                                 0446
         ALR   J,CR6R11                                            0446
*             END;                     /*COMMA PART*/              0447
*           END;                      /*CON TBL LOOP*/             0448
@RF00442 AL    J,@CF00125                                          0448
@DE00441 LA    @10,8                                               0448
         ALR   @10,CR6R11                                          0448
         CR    J,@10                                               0448
         BNH   @DL00441                                            0448
*    CR6CNT=CR6R11;                                                0449
         L     @10,ATCLCPTR                                        0449
         L     @10,ATCNODDS(,@10)                                  0449
         STH   CR6R11,CR6CNT(,@10)                                 0449
*    RFY (CR6R11) UNRSTD;                                          0450
*   END;                                 /*    WARM*/              0451
*/*---------------------------------------------------             0452
*-----------------------------------------------------*/           0452
         EJECT
*  ELSE DO;                             /*COLD START*/             0452
         B     @RC00436                                            0452
@RF00436 DS    0H                                                  0453
*/*-----------------------------------------                       0453
*   ERASE RECORDS FOR COLD START                                   0453
* ------------------------------------------*/                     0453
*    GEN(  ERASE  RPL=(7));             /*ERASE RECORD*/           0453
           ERASE  RPL=(7)
*           IF CR6R15^=0            /*ERROR?*/                     0454
*             THEN DO;                                             0454
         LTR   CR6R15,CR6R15                                       0454
         BZ    @RF00454                                            0454
*             CR6ERCOD=FOUR;        /*I/O ERROR*/                  0456
         MVC   CR6ERCOD(2,CR6DPLAD),@CH00168                       0456
*             CALL CR6ERROR;        /*CALL ERROR ROUTINE*/         0457
         BAL   @14,CR6ERROR                                        0457
*             END;                                                 0458
*GEN(CHECK RPL=(7));                                               0459
@RF00454 DS    0H                                                  0459
         CHECK RPL=(7)
*    IF RPLRTNCD^=0                     /*ERASE ERROR*/            0460
*       THEN DO;                                                   0460
         CLI   RPLRTNCD(CR6RPLAD),0                                0460
         BE    @RF00460                                            0460
*         CR6ERCOD=FOUR;                /*INDICATE I/O ERROR*/     0462
         MVC   CR6ERCOD(2,CR6DPLAD),@CH00168                       0462
*         CALL CR6ERROR;                /*CALL ERROR ROUTINE*/     0463
         BAL   @14,CR6ERROR                                        0463
*       END;                                                       0464
*    END;                               /*FOR COLD START*/         0465
@RF00460 DS    0H                                                  0466
*      CR6KEY=CR6KEY+1;                /*ADD 1 TO KEY*/            0466
@RC00436 L     @09,RPLAREA(,CR6RPLAD)                              0466
         LA    @06,1                                               0466
         LH    @05,CR6KEY(,@09)                                    0466
         N     @05,@CF02827                                        0466
         ALR   @06,@05                                             0466
         STH   @06,CR6KEY(,@09)                                    0466
*       CR6R15=0;                       /*ZERO R-15*/              0467
         SLR   CR6R15,CR6R15                                       0467
*     END;                             /*NOT EODAD*/               0468
* END;                                 /*EODAD LOOP*/              0469
@RF00434 DS    0H                                                  0469
@DE00421 CLI   RPLRTNCD(CR6RPLAD),8                                0469
         BNE   @DL00421                                            0469
         CLI   RPLERRCD(CR6RPLAD),16                               0469
         BNE   @DL00421                                            0469
*IF CR6WARM=ON THEN DO;                /*WARM,  THEN BLANK LAST COMMA*/
         TM    CR6WARM(CR6DPLAD),B'00010000'                       0470
         BNO   @RF00470                                            0470
* IF CR6CNT>1                          /* IS LIST NON EMPTY  @ZA13634*/
*   THEN                               /* YES-NON EMPTY      @ZA13634*/
         L     @09,ATCLCPTR                                        0472
         L     @09,ATCNODDS(,@09)                                  0472
         LH    @06,CR6CNT(,@09)                                    0472
         N     @06,@CF02827                                        0472
         C     @06,@CF00125                                        0472
         BNH   @RF00472                                            0472
* CR6CNT=CR6CNT-1;                                                 0473
         BCTR  @06,0                                               0473
         STH   @06,CR6CNT(,@09)                                    0473
* CR6CNF(CR6CNT)=CR6BLANK;                                         0474
@RF00472 L     @09,ATCLCPTR                                        0474
         L     @09,ATCNODDS(,@09)                                  0474
         LH    @09,CR6CNT(,@09)                                    0474
         N     @09,@CF02827                                        0474
         ALR   @09,CR6WKPT                                         0474
         BCTR  @09,0                                               0474
         MVI   CR6CNF(@09),C' '                                    0474
*    END;                                                          0475
*FIXDS:IF (FIRSTSW=OFF)                      /*FIRST PUT ? */      0476
*  THEN DO;                                                        0476
@RF00470 DS    0H                                                  0476
FIXDS    L     @09,ATCLCPTR                                        0476
         L     @09,ATCNODDS(,@09)                                  0476
         TM    FIRSTSW(@09),B'10000000'                            0476
         BNZ   @RF00476                                            0476
* IF CR6OPSW =OFF & DLRPLRCD=4                             /*@VS41708*/
*                 THEN     DLRPLRCD='08'X;                 /*@VS41708*/
         TM    CR6OPSW(CR6DPLAD),B'01000000'                       0478
         BNZ   @RF00478                                            0478
         CLI   DLRPLRCD(CR6DPLAD),4                                0478
         BNE   @RF00478                                            0478
         MVI   DLRPLRCD(CR6DPLAD),X'08'                            0479
*   FIRSTSW=ON;                                                    0480
@RF00478 L     @09,ATCLCPTR                                        0480
         L     @09,ATCNODDS(,@09)                                  0480
         OI    FIRSTSW(@09),B'10000000'                            0480
*   CR6KEYSV=1;                        /*INIT SAVE KEY FOR COLD STRT*/
         MVC   CR6KEYSV(2,@09),@CH00125                            0481
*   RPLSEQ=ON;                                                     0482
*   RPLDIR=OFF;                                                    0483
         OI    RPLSEQ(CR6RPLAD),B'00100000'                        0483
         NI    RPLDIR(CR6RPLAD),B'10111111'                        0483
*   RPLUPD=OFF;                      /*RPL- NO UPDATE*/            0484
         NI    RPLUPD(CR6RPLAD),B'11111101'                        0484
*   CR6RECRD=CR6ZERO;                 /*SET RECRD TO 0*/           0485
         L     @09,RPLAREA(,CR6RPLAD)                              0485
         XC    CR6RECRD+2(8,@09),CR6RECRD+2(@09)                   0485
         MVC   CR6RECRD(2,@09),@CB00483                            0485
*   GEN(    PUT  RPL=(7));               /*PUT OUT THE RECORD*/    0486
             PUT  RPL=(7)
*           IF CR6R15^=0            /*ERROR?*/                     0487
*             THEN DO;                                             0487
         LTR   CR6R15,CR6R15                                       0487
         BZ    @RF00487                                            0487
*             CR6ERCOD=FOUR;        /*I/O ERROR*/                  0489
         MVC   CR6ERCOD(2,CR6DPLAD),@CH00168                       0489
*             CALL CR6ERROR;        /*CALL ERROR ROUTINE*/         0490
         BAL   @14,CR6ERROR                                        0490
*             END;                                                 0491
*GEN(CHECK RPL=(7));                                               0492
@RF00487 DS    0H                                                  0492
         CHECK RPL=(7)
*         RPLUPD=ON;                                               0493
         OI    RPLUPD(CR6RPLAD),B'00000010'                        0493
*   IF RPLRTNCD^=0                       /*PUT ERROR?*/            0494
*      THEN DO;                                                    0494
         CLI   RPLRTNCD(CR6RPLAD),0                                0494
         BE    @RF00494                                            0494
*        CR6ERCOD=FOUR;                   /*INDICATE I/O ERROR*/   0496
         MVC   CR6ERCOD(2,CR6DPLAD),@CH00168                       0496
*        CALL CR6ERROR;                   /*CALL ERROR ROUTINE*/   0497
         BAL   @14,CR6ERROR                                        0497
*      END;                                                        0498
*CR6R15=0;                                /*ZERO R-15*/            0499
@RF00494 SLR   CR6R15,CR6R15                                       0499
*RFY (CR6R03,CR6R09) RSTD;                                         0500
*CR6R03=ADDR(CR6ACB);                                              0501
         L     @06,ATCLCPTR                                        0501
         L     @06,ATCNODDS(,@06)                                  0501
         LA    CR6R03,CR6ACB(,@06)                                 0501
*CR6R09=ADDR(CR6CLS);                                              0502
         LA    CR6R09,CR6CLS(,@06)                                 0502
*GEN(CLOSE     ((3)),MF=(E,(9)));   /*ISS TCLOSE*/                 0503
         CLOSE     ((3)),MF=(E,(9))
*RFY (CR6R03,CR6R09) UNRSTD;                                       0504
*IF CR6R15 >  0                          /*CLOSE ERROR?*/          0505
*  THEN DO;                                                        0505
         LTR   CR6R15,CR6R15                                       0505
         BNP   @RF00505                                            0505
*   CR6ERCOD = ONE;                      /*INDICATE CLOSE ERROR*/  0507
         MVC   CR6ERCOD(2,CR6DPLAD),@CH00125                       0507
*   CALL CR6ERROR;                       /*CALL ERROR ROUITNE*/    0508
         BAL   @14,CR6ERROR                                        0508
*  END;                                                            0509
*CR6R15=0;                              /*ZERO R-15*/              0510
@RF00505 SLR   CR6R15,CR6R15                                       0510
*RFY (CR6R03,CR6R09)   RSTD;                                       0511
*CR6R03=ADDR(CR6ACB);                                              0512
         L     @06,ATCLCPTR                                        0512
         L     @06,ATCNODDS(,@06)                                  0512
         LA    CR6R03,CR6ACB(,@06)                                 0512
*CR6R09=ADDR(CR6OPN);                                              0513
         LA    CR6R09,CR6OPN(,@06)                                 0513
*GEN(OPEN ((3)),MF=(E,(9)));  /*OPEN DATASET*/                     0514
         OPEN ((3)),MF=(E,(9))
*RFY (CR6R03,CR6R09) UNRSTD;                                       0515
*IF CR6R15 > 4                          /*OPEN ERROR*/             0516
*  THEN DO;                             /*YES*/                    0516
         C     CR6R15,@CF00168                                     0516
         BNH   @RF00516                                            0516
*   CR6ERCOD=THREE;                     /*INDICATE OPEN ERROR*/    0518
         MVC   CR6ERCOD(2,CR6DPLAD),@CH00137                       0518
*   CALL CR6ERROR;                      /*CALL ERROR ROUTINE*/     0519
         BAL   @14,CR6ERROR                                        0519
*  END;                                                            0520
*END;                               /* FOR FIRST PUT*/             0521
@RF00516 DS    0H                                                  0522
* RPLUPD=ON;                            /*INDICATE UPDATE*/        0522
@RF00476 OI    RPLUPD(CR6RPLAD),B'00000010'                        0522
*IF DLRPLRCD= '00'X                  /*CONFIG SPECIFIED*/          0523
*  THEN;                                                           0523
         CLI   DLRPLRCD(CR6DPLAD),0                                0523
         BE    @RT00523                                            0523
*  ELSE DO;                                                        0525
*    IF  ATCNODEL(1:1)= '00'X            /*NODELST SPECIFIED ? */  0526
*      | (ATCNODEL^=ATCONFIG            /*CONFIG^=NODELST*/        0526
*        &ATCNODEL(1:1)^= '00'X          /*NODELST SPECIFIED*/     0526
*         &CR6OPSW=OFF)                  /*FIRST CALL TO OPEN*/    0526
*    THEN DO;                                                      0526
         L     @09,ATCLCPTR                                        0526
         CLI   ATCNODEL(@09),X'00'                                 0526
         BE    @RT00526                                            0526
         CLC   ATCNODEL(8,@09),ATCONFIG(@09)                       0526
         BE    @RF00526                                            0526
         CLI   ATCNODEL(@09),X'00'                                 0526
         BE    @RF00526                                            0526
         TM    CR6OPSW(CR6DPLAD),B'01000000'                       0526
         BNZ   @RF00526                                            0526
@RT00526 DS    0H                                                  0527
*     CALL CR6CLOSE;                                               0528
         BAL   @14,CR6CLOSE                                        0528
*     IF ATCNODEL(1:1)^= '00'X                                     0529
*       THEN DO;                                                   0529
         L     @09,ATCLCPTR                                        0529
         CLI   ATCNODEL(@09),X'00'                                 0529
         BE    @RF00529                                            0529
*     CR6COLD=ON;                                                  0531
*     CR6WARM=OFF;                                                 0532
         OI    CR6COLD(CR6DPLAD),B'00001000'                       0532
         NI    CR6WARM(CR6DPLAD),B'11101111'                       0532
*       END;                                                       0533
*    END;                                                          0534
@RF00529 DS    0H                                                  0535
*  END;                                                            0535
@RF00526 DS    0H                                                  0536
*CR6OPSW=ON;                            /*INDICATE SECOND OPEN CALL*/
@RT00523 OI    CR6OPSW(CR6DPLAD),B'01000000'                       0536
*CR6R14=DLRPLSA1;                        /*RESTORE REG-14*/        0537
         L     CR6R14,DLRPLSA1(,CR6DPLAD)                          0537
*END CR6OPEN;                                                      0538
@EL00002 DS    0H                                                  0538
@EF00002 DS    0H                                                  0538
@ER00002 BR    @14                                                 0538
         EJECT
*CR6UPERS:PROC OPTIONS(NOSAVE,NOSAVEAREA);                         0539
CR6UPERS DS    0H                                                  0540
*/*--------------------------------------------------              0540
*   UPDATE DATASET --ADD OR DELETE A RECORD FROM DATASET           0540
*----------------------------------------------------*/            0540
*DLRPLSA1=CR6R14;                       /*SAVE REG-14*/            0540
         ST    CR6R14,DLRPLSA1(,CR6DPLAD)                          0540
*   RPLDIR=ON;                       /*MAKE RPL- */                0541
*   RPLSEQ=OFF;                      /*DIRECT*/                    0542
         OI    RPLDIR(CR6RPLAD),B'01000000'                        0542
         NI    RPLSEQ(CR6RPLAD),B'11011111'                        0542
*CR6MAJ=CR6NAME;                        /*NAME INTO BUFFER*/       0543
         L     @09,RPLAREA(,CR6RPLAD)                              0543
         L     @06,DLRPLNOD(,CR6DPLAD)                             0543
         MVC   CR6MAJ(8,@09),CR6NAME(@06)                          0543
*DLRPLMSG(13:20)=CR6NAME;               /*NAME INTO SAVE*/         0544
         MVC   DLRPLMSG+12(8,CR6DPLAD),CR6NAME(@06)                0544
*              DLRPLMSG(1:8)  =ATCNODEL; /*SAVE NODELIST DATSET NAME*/
         L     @06,ATCLCPTR                                        0545
         MVC   DLRPLMSG(8,CR6DPLAD),ATCNODEL(@06)                  0545
         EJECT
*/* -----------------------*/                                      0546
*/* LOOP UNTIL EODAD TO FIND KEY OF LAST RECORD */                 0546
*/* -----------------------*/                                      0546
*CR6KEY=1;                                                         0546
         MVC   CR6KEY(2,@09),@CH00125                              0546
*CR6DONE=OFF;                                                      0547
         NI    CR6DONE(CR6DPLAD),B'01111111'                       0547
*    RPLERRCD= '00'X;                  /*SET RPL ERR CODE TO 0*/   0548
         MVI   RPLERRCD(CR6RPLAD),X'00'                            0548
*    RPLRTNCD= '00'X;                  /*SET RPL RET CD TO 0*/     0549
         MVI   RPLRTNCD(CR6RPLAD),X'00'                            0549
*DO WHILE (RPLRTNCD^=CR6HEX8 | RPLERRCD^=CR6HEX10) /*LOOP TIL EOD*/
*                       & CR6DONE=OFF;                     /*@XM7947K*/
         B     @DE00550                                            0550
@DL00550 DS    0H                                                  0551
*  RPLUPD=ON;                                                      0551
         OI    RPLUPD(CR6RPLAD),B'00000010'                        0551
*  GEN(GET RPL=(7));                    /*ISSUE GET*/              0552
         GET RPL=(7)
*           IF CR6R15^=0            /*ERROR?*/                     0553
*             THEN DO;                                             0553
         LTR   CR6R15,CR6R15                                       0553
         BZ    @RF00553                                            0553
*             CR6ERCOD=FOUR;        /*I/O ERROR*/                  0555
         MVC   CR6ERCOD(2,CR6DPLAD),@CH00168                       0555
*             CALL CR6ERROR;        /*CALL ERROR ROUTINE*/         0556
         BAL   @14,CR6ERROR                                        0556
*             END;                                                 0557
*GEN(CHECK RPL=(7));                                               0558
@RF00553 DS    0H                                                  0558
         CHECK RPL=(7)
*    IF RPLRTNCD ^=0 & (RPLRTNCD^=CR6HEX8 |  /*ERROR BUT NO EODAD*/
*                      RPLERRCD^=CR6HEX10)                         0559
*        THEN DO;                                                  0559
         CLI   RPLRTNCD(CR6RPLAD),0                                0559
         BE    @RF00559                                            0559
         CLI   RPLRTNCD(CR6RPLAD),8                                0559
         BNE   @RT00559                                            0559
         CLI   RPLERRCD(CR6RPLAD),16                               0559
         BE    @RF00559                                            0559
@RT00559 DS    0H                                                  0560
*        CR6ERCOD=FOUR;                 /*INDICATE I/O ERROR*/     0561
         MVC   CR6ERCOD(2,CR6DPLAD),@CH00168                       0561
*        CALL CR6ERROR;                 /*CALL ERROR ROUTINE*/     0562
         BAL   @14,CR6ERROR                                        0562
*        END;                                                      0563
* IF                (RPLRTNCD^=CR6HEX8 |     /*         NOT EODAD*/
*                   RPLERRCD^=CR6HEX10)                            0564
*     THEN DO;                                                     0564
@RF00559 CLI   RPLRTNCD(CR6RPLAD),8                                0564
         BNE   @RT00564                                            0564
         CLI   RPLERRCD(CR6RPLAD),16                               0564
         BE    @RF00564                                            0564
@RT00564 DS    0H                                                  0565
*  IF CR6MAJ=          DLRPLMSG(13:20)          /*IS MATCH OF MAJOR */
*    THEN DO;                                                      0566
         L     @09,RPLAREA(,CR6RPLAD)                              0566
         CLC   CR6MAJ(8,@09),DLRPLMSG+12(CR6DPLAD)                 0566
         BNE   @RF00566                                            0566
*    CR6DONE=ON;                                                   0568
         OI    CR6DONE(CR6DPLAD),B'10000000'                       0568
*  IF DLRPLFNC=DLRPLDEL        /*IF ERASE CASE*/           /*@XM7993K*/
*       THEN DO;                                                   0569
         CLI   DLRPLFNC(CR6DPLAD),3                                0569
         BNE   @RF00569                                            0569
*    GEN(  ERASE  RPL=(7));             /*ERASE RECORD*/           0571
           ERASE  RPL=(7)
*           IF CR6R15^=0            /*ERROR?*/                     0572
*             THEN DO;                                             0572
         LTR   CR6R15,CR6R15                                       0572
         BZ    @RF00572                                            0572
*             CR6ERCOD=FOUR;        /*I/O ERROR*/                  0574
         MVC   CR6ERCOD(2,CR6DPLAD),@CH00168                       0574
*             CALL CR6ERROR;        /*CALL ERROR ROUTINE*/         0575
         BAL   @14,CR6ERROR                                        0575
*             END;                                                 0576
*GEN(CHECK RPL=(7));                                               0577
@RF00572 DS    0H                                                  0577
         CHECK RPL=(7)
*    IF RPLRTNCD^=0                     /*ERASE ERROR*/            0578
*       THEN DO;                                                   0578
         CLI   RPLRTNCD(CR6RPLAD),0                                0578
         BE    @RF00578                                            0578
*         CR6ERCOD=FOUR;                /*INDICATE I/O ERROR*/     0580
         MVC   CR6ERCOD(2,CR6DPLAD),@CH00168                       0580
*         CALL CR6ERROR;                /*CALL ERROR ROUTINE*/     0581
         BAL   @14,CR6ERROR                                        0581
*       END;                                                       0582
*   END;                          /*ERASE CASE*/                   0583
@RF00578 DS    0H                                                  0584
* END;                           /*NOT MATCH OF NAMES*/            0584
@RF00569 DS    0H                                                  0585
*CR6KEY=CR6KEY+1;                                                  0585
@RF00566 L     @09,RPLAREA(,CR6RPLAD)                              0585
         LA    @06,1                                               0585
         LH    @05,CR6KEY(,@09)                                    0585
         N     @05,@CF02827                                        0585
         ALR   @06,@05                                             0585
         STH   @06,CR6KEY(,@09)                                    0585
* END;                                 /*NOT EODAD*/               0586
*END;                        /*EODAD LOOP*/                        0587
@RF00564 DS    0H                                                  0587
@DE00550 CLI   RPLRTNCD(CR6RPLAD),8                                0587
         BNE   @GL00023                                            0587
         CLI   RPLERRCD(CR6RPLAD),16                               0587
         BE    @DC00550                                            0587
@GL00023 TM    CR6DONE(CR6DPLAD),B'10000000'                       0587
         BZ    @DL00550                                            0587
@DC00550 DS    0H                                                  0588
* /*---------------------------*/                                  0588
* /* ADD A RECORD IF ONE IS NOT THERE  */                          0588
* /*---------------------------*/                                  0588
*IF DLRPLFNC = DLRPLADD & CR6DONE=OFF /*UPDATE CASE?*/     /*@XM7993K*/
*  THEN DO;                                                        0588
         CLI   DLRPLFNC(CR6DPLAD),2                                0588
         BNE   @RF00588                                            0588
         TM    CR6DONE(CR6DPLAD),B'10000000'                       0588
         BNZ   @RF00588                                            0588
*   RPLUPD=OFF;                      /*RPL-    UPDATE*/            0590
         NI    RPLUPD(CR6RPLAD),B'11111101'                        0590
*   CR6MAJ=DLRPLMSG(13:20);          /*SET UP BUFFER*/             0591
         L     @09,RPLAREA(,CR6RPLAD)                              0591
         MVC   CR6MAJ(8,@09),DLRPLMSG+12(CR6DPLAD)                 0591
*   CR6KEY=CR6KEYSV;                 /*KEY INTO BUFFER*/           0592
         L     @06,ATCLCPTR                                        0592
         L     @06,ATCNODDS(,@06)                                  0592
         LH    @06,CR6KEYSV(,@06)                                  0592
         N     @06,@CF02827                                        0592
         STH   @06,CR6KEY(,@09)                                    0592
*   GEN(    PUT  RPL=(7));               /*PUT OUT THE RECORD*/    0593
             PUT  RPL=(7)
*           IF CR6R15^=0            /*ERROR?*/                     0594
*             THEN DO;                                             0594
         LTR   CR6R15,CR6R15                                       0594
         BZ    @RF00594                                            0594
*             CR6ERCOD=FOUR;        /*I/O ERROR*/                  0596
         MVC   CR6ERCOD(2,CR6DPLAD),@CH00168                       0596
*             CALL CR6ERROR;        /*CALL ERROR ROUTINE*/         0597
         BAL   @14,CR6ERROR                                        0597
*             END;                                                 0598
*GEN(CHECK RPL=(7));                                               0599
@RF00594 DS    0H                                                  0599
         CHECK RPL=(7)
*         RPLUPD=ON;                                               0600
         OI    RPLUPD(CR6RPLAD),B'00000010'                        0600
*   IF RPLRTNCD^=0                       /*PUT ERROR?*/            0601
*      THEN DO;                                                    0601
         CLI   RPLRTNCD(CR6RPLAD),0                                0601
         BE    @RF00601                                            0601
*        CR6ERCOD=FOUR;                   /*INDICATE I/O ERROR*/   0603
         MVC   CR6ERCOD(2,CR6DPLAD),@CH00168                       0603
*        CALL CR6ERROR;                   /*CALL ERROR ROUTINE*/   0604
         BAL   @14,CR6ERROR                                        0604
*      END;                                                        0605
*   CR6KEYSV=CR6KEYSV+1;                                           0606
@RF00601 L     @09,ATCLCPTR                                        0606
         L     @09,ATCNODDS(,@09)                                  0606
         LA    @06,1                                               0606
         LH    @05,CR6KEYSV(,@09)                                  0606
         N     @05,@CF02827                                        0606
         ALR   @06,@05                                             0606
         STH   @06,CR6KEYSV(,@09)                                  0606
* END;                                       /*UPDATE CASE*/       0607
         EJECT
*/*-------------------------------*/                               0608
* /* TCLOSE IF SHARE OPTION 4 NOT SPECIFIED ON VSAM DATASET*/      0608
*/*-------------------------------*/                               0608
*IF ACBAMBL->AMBLDTA->AMBINBUF=OFF      /*SHARE OPTION 4 SPECIFIED?*/
*   THEN DO;                            /*NO ?*/                   0608
@RF00588 L     @09,RPLDACB(,CR6RPLAD)                              0608
         L     @09,ACBAMBL(,@09)                                   0608
         L     @09,AMBLDTA(,@09)                                   0608
         TM    AMBINBUF(@09),B'00000001'                           0608
         BNZ   @RF00608                                            0608
*CR6R15=0;                                /*ZERO R-15*/            0610
         SLR   CR6R15,CR6R15                                       0610
*RFY (CR6R03,CR6R09) RSTD;                                         0611
*CR6R03=ADDR(CR6ACB);                                              0612
         L     @06,ATCLCPTR                                        0612
         L     @06,ATCNODDS(,@06)                                  0612
         LA    CR6R03,CR6ACB(,@06)                                 0612
*CR6R09=ADDR(CR6CLS);                                              0613
         LA    CR6R09,CR6CLS(,@06)                                 0613
*GEN(CLOSE     ((3)),TYPE=T,MF=(E,(9)));   /*ISS TCLOSE*/          0614
         CLOSE     ((3)),TYPE=T,MF=(E,(9))
*RFY (CR6R03,CR6R09) UNRSTD;                                       0615
*END;                                   /*SHARE OPTION 4-TCLOSE*/  0616
*CR6R14 = DLRPLSA1;                     /*RESTORE REG-14*/         0617
@RF00608 L     CR6R14,DLRPLSA1(,CR6DPLAD)                          0617
*END CR6UPERS;                                                     0618
@EL00003 DS    0H                                                  0618
@EF00003 DS    0H                                                  0618
@ER00003 BR    @14                                                 0618
         EJECT
*CR6CLOSE:PROC OPTIONS(NOSAVE,NOSAVEAREA);                         0619
CR6CLOSE DS    0H                                                  0620
*/*------------------------------------------                      0620
*   CLOSE DATASET                                                  0620
*--------------------------------------------*/                    0620
*DLRPLSA2=CR6R14;                        /*SAVE REG-14*/           0620
         ST    CR6R14,DLRPLSA2(,CR6DPLAD)                          0620
*IF DLRPLFNC=DLRPLOPN THEN                                         0621
         CLI   DLRPLFNC(CR6DPLAD),1                                0621
         BNE   @RF00621                                            0621
*  DLRPLMSG(1:8)=ATCONFIG;                                         0622
         L     @09,ATCLCPTR                                        0622
         MVC   DLRPLMSG(8,CR6DPLAD),ATCONFIG(@09)                  0622
* ELSE DLRPLMSG(1:8) =ATCNODEL; /*SAVE NODELIST DATSET NAME*/      0623
         B     @RC00621                                            0623
@RF00621 L     @09,ATCLCPTR                                        0623
         MVC   DLRPLMSG(8,CR6DPLAD),ATCNODEL(@09)                  0623
*CR6R15=0;                                /*ZERO R-15*/            0624
@RC00621 SLR   CR6R15,CR6R15                                       0624
*RFY (CR6R03,CR6R09) RSTD;                                         0625
*CR6R03=ADDR(CR6ACB);                                              0626
         L     @06,ATCLCPTR                                        0626
         L     @06,ATCNODDS(,@06)                                  0626
         LA    CR6R03,CR6ACB(,@06)                                 0626
*CR6R09=ADDR(CR6CLS);                                              0627
         LA    CR6R09,CR6CLS(,@06)                                 0627
*GEN(CLOSE     ((3)),MF=(E,(9)));   /*ISS TCLOSE*/                 0628
         CLOSE     ((3)),MF=(E,(9))
*RFY (CR6R03,CR6R09) UNRSTD;                                       0629
*ATCNODDS = 0;                           /*ZERO OUT RPL PTR IN C L*/
         SLR   @09,@09                                             0630
         L     @06,ATCLCPTR                                        0630
         ST    @09,ATCNODDS(,@06)                                  0630
*IF CR6R15 >  0                          /*CLOSE ERROR?*/          0631
*  THEN DO;                                                        0631
         CR    CR6R15,@09                                          0631
         BNH   @RF00631                                            0631
*   CR6ERCOD = ONE;                      /*INDICATE CLOSE ERROR*/  0633
         MVC   CR6ERCOD(2,CR6DPLAD),@CH00125                       0633
*   CALL CR6ERROR;                       /*CALL ERROR ROUITNE*/    0634
         BAL   @14,CR6ERROR                                        0634
*  END;                                                            0635
*STM(GPR14P,GPR00P,CR6R140);            /*SAVE REG 14->0*/         0636
@RF00631 STM   GPR14P,GPR00P,CR6R140(CR6DPLAD)                     0636
*STM(GPR02P,GPR10P,CR6R210);            /*SAVE REG 2->10*/         0637
         STM   GPR02P,GPR10P,CR6R210(CR6DPLAD)                     0637
* /*FREESTOR AREA(CR6RPLAD)SIZE(LENGTH(CR6GTSTR))SAVE(NO)*/        0638
*  DO;                                                             0638
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTATCVT,ISTRPH)  */                  0639
*/* END OF ATBUILD */                                              0639
* RFY (GPR00P,GPR01P,GPR02P,GPR03P) RSTD;                          0639
* GPR00F = LENGTH(CR6GTSTR);                           /*SIZE IN REG0*/
         LA    GPR00F,177                                          0640
* DCL 1 CMZA0052 FIXED(31) STATIC LOCAL,                           0641
*       2 * FIXED(8) INIT(0),                        /* OPTION FLAGS */
*       2 * FIXED(8) INIT(96),                        /* STORAGE KEY */
*       2 * FIXED(8) INIT(231),                    /* SUBPOOL NUMBER */
*       2 * FIXED(8) INIT('01'X);                    /* REQUEST TYPE */
* GPR03F = CMZA0052;                                               0642
         L     GPR03F,CMZA0052                                     0642
* RFY (GPR04P) RSTD;                                               0643
* GPR04P = CR6RPLAD;                      /*PUT FREEMAIN ADDR IN REG4*/
*                                                                  0644
         LR    GPR04P,CR6RPLAD                                     0644
* DO; /* LISATCVT CVTBASE(PAGEABLE,(GPR02P)) */                    0645
*   GPR02P = ATCLCPTR; /*SET UP ATCVT POINTER*/                    0646
         L     GPR02P,ATCLCPTR                                     0646
* END; /*LISATCVT*/                                                0647
* CALL GPR02P -> ATCGTSTR;                            /*CALL ISTORFSR*/
         L     @15,ATCGTSTR(,GPR02P)                               0648
         BALR  @14,@15                                             0648
* RFY (GPR00P,GPR01P,GPR02P,GPR03P,GPR04P) UNRSTD;                 0649
* END ;                                             /*END OF FREESTOR*/
* RFY (ISTDLRPL) BASED(CR6R13);                                    0651
* LM(GPR14P,GPR00P,CR6R140);            /*REST REG 14->0*/         0652
         LM    GPR14P,GPR00P,CR6R140(CR6R13)                       0652
* LM(GPR02P,GPR10P,CR6R210);            /*REST REG 2->10*/         0653
         LM    GPR02P,GPR10P,CR6R210(CR6R13)                       0653
* RFY (ISTDLRPL) BASED(CR6DPLAD);                                  0654
*CR6R14 = DLRPLSA2;                      /*RESTORE REG-14*/        0655
         L     CR6R14,DLRPLSA2(,CR6DPLAD)                          0655
*END CR6CLOSE;                                                     0656
@EL00004 DS    0H                                                  0656
@EF00004 DS    0H                                                  0656
@ER00004 BR    @14                                                 0656
         EJECT
*CR6ERROR:PROC OPTIONS(NOSAVE,NOSAVEAREA);                         0657
CR6ERROR DS    0H                                                  0658
*/*------------------------------------------                      0658
* FUNCTION IS TO PROCESS ERRORS DETECTED IN ISTINCR6               0658
*     ERROR CODES ARE                                              0658
*        -ERROR CODE-               -ERROR-                        0658
*           1                       CLOSE                          0658
*           3                       OPEN                           0658
*           4                       I/O                            0658
*           5                       GETSTOR                        0658
*-------------------------------------------*/                     0658
*IF CR6ERCOD=1 | CR6ERCOD=3            /* OPEN OR CLOSE*/          0658
*   THEN DO;                                                       0658
         LH    @09,CR6ERCOD(,CR6DPLAD)                             0658
         C     @09,@CF00125                                        0658
         BE    @RT00658                                            0658
         C     @09,@CF00137                                        0658
         BNE   @RF00658                                            0658
@RT00658 DS    0H                                                  0659
*   RPLRTNCD=CR6R15;                                               0660
         STC   CR6R15,RPLRTNCD(,CR6RPLAD)                          0660
*   RPLERRCD=ACBERFLG;                                             0661
         L     @09,RPLDACB(,CR6RPLAD)                              0661
         IC    @06,ACBERFLG(,@09)                                  0661
         STC   @06,RPLERRCD(,CR6RPLAD)                             0661
*   END;                                                           0662
*  MVC (DLRPLMSG( 9),CR6RCB(1:4));                                 0663
@RF00658 MVC   DLRPLMSG+8(1,CR6DPLAD),CR6RCB(CR6RPLAD)             0663
*  SRL (DLRPLMSG( 9),4);                                           0664
         SLR   @09,@09                                             0664
         IC    @09,DLRPLMSG+8(,CR6DPLAD)                           0664
         SRL   @09,4                                               0664
         STC   @09,DLRPLMSG+8(,CR6DPLAD)                           0664
*  TR (DLRPLMSG( 9),CR6TBL);            /*VSAM R.C. INTO MSG,BYTE-1*/
         TR    DLRPLMSG+8(1,CR6DPLAD),CR6TBL                       0665
*  MVC (DLRPLMSG(10),CR6RCB(5:8));                                 0666
         MVC   DLRPLMSG+9(1,CR6DPLAD),CR6RCB(CR6RPLAD)             0666
*  SLL (DLRPLMSG(10),4);                                           0667
         SLR   @09,@09                                             0667
         IC    @09,DLRPLMSG+9(,CR6DPLAD)                           0667
         SLL   @09,4                                               0667
         STC   @09,DLRPLMSG+9(,CR6DPLAD)                           0667
*  SRL (DLRPLMSG(10),4);                                           0668
         SLR   @09,@09                                             0668
         IC    @09,DLRPLMSG+9(,CR6DPLAD)                           0668
         SRL   @09,4                                               0668
         STC   @09,DLRPLMSG+9(,CR6DPLAD)                           0668
*  TR (DLRPLMSG(10),CR6TBL);            /*VSAM R.C. INTO MSG,BYTE-2*/
         TR    DLRPLMSG+9(1,CR6DPLAD),CR6TBL                       0669
*  MVC (DLRPLMSG(11),CR6ERB(1:4));                                 0670
         MVC   DLRPLMSG+10(1,CR6DPLAD),CR6ERB(CR6RPLAD)            0670
*  SRL (DLRPLMSG(11),4);                                           0671
         SLR   @09,@09                                             0671
         IC    @09,DLRPLMSG+10(,CR6DPLAD)                          0671
         SRL   @09,4                                               0671
         STC   @09,DLRPLMSG+10(,CR6DPLAD)                          0671
*  TR (DLRPLMSG(11),CR6TBL);            /*VSAM E.C. INTO MSG,BYTE-1*/
         TR    DLRPLMSG+10(1,CR6DPLAD),CR6TBL                      0672
*  MVC (DLRPLMSG(12),CR6ERB(5:8));                                 0673
         MVC   DLRPLMSG+11(1,CR6DPLAD),CR6ERB(CR6RPLAD)            0673
*  SLL (DLRPLMSG(12),4);                                           0674
         SLR   @09,@09                                             0674
         IC    @09,DLRPLMSG+11(,CR6DPLAD)                          0674
         SLL   @09,4                                               0674
         STC   @09,DLRPLMSG+11(,CR6DPLAD)                          0674
*  SRL (DLRPLMSG(12),4);                                           0675
         SLR   @09,@09                                             0675
         IC    @09,DLRPLMSG+11(,CR6DPLAD)                          0675
         SRL   @09,4                                               0675
         STC   @09,DLRPLMSG+11(,CR6DPLAD)                          0675
*  TR (DLRPLMSG(12),CR6TBL);            /*VSAM E.C. INTO MSG,BYTE-2*/
         TR    DLRPLMSG+11(1,CR6DPLAD),CR6TBL                      0676
*IF CR6ERCOD=ONE                                                   0677
*  THEN DLRPLMID=CR6424I;               /*CLOSE MSGID*/            0677
         CLC   CR6ERCOD(2,CR6DPLAD),@CH00125                       0677
         BNE   @RF00677                                            0677
         MVC   DLRPLMID(4,CR6DPLAD),@CC00453                       0678
*  ELSE IF CR6ERCOD=THREE                                          0679
*        THEN DLRPLMID=CR6425I;         /*OPEN MSGID*/             0679
         B     @RC00677                                            0679
@RF00677 CLC   CR6ERCOD(2,CR6DPLAD),@CH00137                       0679
         BNE   @RF00679                                            0679
         MVC   DLRPLMID(4,CR6DPLAD),@CC00451                       0680
*        ELSE IF CR6ERCOD=FOUR                                     0681
*             THEN DLRPLMID=CR6422I;/*I/O MSGID*/                  0681
         B     @RC00679                                            0681
@RF00679 CLC   CR6ERCOD(2,CR6DPLAD),@CH00168                       0681
         BNE   @RF00681                                            0681
         MVC   DLRPLMID(4,CR6DPLAD),@CC00457                       0682
*             ELSE DLRPLMID=CR6423I;/*GETSTOR*/                    0683
         B     @RC00681                                            0683
@RF00681 MVC   DLRPLMID(4,CR6DPLAD),@CC00455                       0683
*            /*ISSUE TPMSG*/                                       0684
*       RFY (CR6MSGNO,CR6MSGTX) RSTD;                              0684
@RC00681 DS    0H                                                  0684
@RC00679 DS    0H                                                  0684
@RC00677 DS    0H                                                  0685
*       CR6MSGNO=ADDR(DLRPLMID);                                   0685
         LA    CR6MSGNO,DLRPLMID(,CR6DPLAD)                        0685
*       CR6MSGTX=ADDR(DLRPLMSG);                                   0686
*                                                                  0686
         LA    CR6MSGTX,DLRPLMSG(,CR6DPLAD)                        0686
*/*TPMSG MSGID((CR6MSGNO))MSG((CR6MSGTX))OPTIONS((DLRPLCON))PLAREA(DLRP
*TPL)*/                                                            0687
*                                                                  0687
*        DO;                                                       0687
*          DCL REG1071  REG(1)  PTR;                               0688
*          RFY (REG1071) RSTD;                                     0689
*                                                                  0689
*        RFY (EMCR13) RSTD;                                        0690
*          DCL 1 * BASED(REG1071),                                 0691
*              2 CMZID071 PTR(31),                                 0691
*              2 *,                                                0691
*                3 CMZRL071 PTR(8),                                0691
*                3 CMZRA071 PTR(24) BDY(BYTE),                     0691
*              2 CMZEA071 PTR(31),                                 0691
*              2 CMZVP071 PTR(31);                                 0691
*                                                                  0691
*/*XREGSET  PID('PLAREA')PPARM(DLRPLTPL)RREG(,REG1071)*/           0692
*        DO;                                                       0692
*          REG1071=ADDR(DLRPLTPL);       /*SET RREG SYMBOL TO ADDRESS*/
         LA    REG1071,DLRPLTPL(,CR6DPLAD)                         0693
*                                        /*OF PPARM OPERAND          */
*        END;  /* XREGSET */                                       0694
*          CMZID071 = 0;                                           0695
         SLR   @11,@11                                             0695
         ST    @11,CMZID071(,REG1071)                              0695
*          CMZRL071 = 0;                                           0696
         MVI   CMZRL071(REG1071),X'00'                             0696
*          CMZRA071 = 0;                                           0697
         STCM  @11,7,CMZRA071(REG1071)                             0697
*          CMZEA071 = 0;                                           0698
         ST    @11,CMZEA071(,REG1071)                              0698
*          CMZVP071 = 0;                                           0699
         ST    @11,CMZVP071(,REG1071)                              0699
*          CMZID071=CR6MSGNO;                                      0700
         ST    CR6MSGNO,CMZID071(,REG1071)                         0700
*          CMZVP071 = CR6MSGTX;                                    0701
         ST    CR6MSGTX,CMZVP071(,REG1071)                         0701
*          DCL CMZSA071 (18) PTR(31) BASED(EMCR13);                0702
*          CMZSA071(5) = DLRPLCON;                                 0703
*                                                                  0703
         L     @11,DLRPLCON(,CR6DPLAD)                             0703
         ST    @11,CMZSA071+16(,EMCR13)                            0703
*          DCL REG15071 REG(15) PTR;                               0704
*          RFY REG15071 RSTD;                                      0705
*                                                                  0705
*        DO; /* LISATCVT CVTBASE(PAGEABLE,(REG15071)) */           0706
*          REG15071 = ATCLCPTR; /*SET UP ATCVT POINTER*/           0707
         L     REG15071,ATCLCPTR                                   0707
*        END; /*LISATCVT*/                                         0708
*          DCL CMTA071 BASED(REG15071) ENTRY VALUERANGE(*);        0709
*          REG15071 = REG15071->ATCMSGP;                           0710
         L     REG15071,ATCMSGP(,REG15071)                         0710
*          CALL CMTA071;                                           0711
         BALR  @14,@15                                             0711
*          RESPECIFY (REG1071,REG15071)  UNRESTRICTED;             0712
*                                                                  0712
*        RFY (EMCR13) UNRSTD;                                      0713
*        END;                                                      0714
*       RFY (CR6MSGNO,CR6MSGTX) UNRSTD;                            0715
*IF (CR6ERCOD^=ONE&CR6ERCOD^=FIVE)                                 0716
*  THEN DO;                                                        0716
         LH    @09,CR6ERCOD(,CR6DPLAD)                             0716
         C     @09,@CF00125                                        0716
         BE    @RF00716                                            0716
         C     @09,@CF00306                                        0716
         BE    @RF00716                                            0716
*       CR6R15=0;                                                  0718
         SLR   CR6R15,CR6R15                                       0718
*RFY (CR6R03,CR6R09) RSTD;                                         0719
*CR6R03=ADDR(CR6ACB);                                              0720
         L     @06,ATCLCPTR                                        0720
         L     @06,ATCNODDS(,@06)                                  0720
         LA    CR6R03,CR6ACB(,@06)                                 0720
*CR6R09=ADDR(CR6CLS);                                              0721
         LA    CR6R09,CR6CLS(,@06)                                 0721
*     GEN(   CLOSE     ((3)),MF=(E,(9)));   /*CLOSE DATASET*/      0722
            CLOSE     ((3)),MF=(E,(9))
*RFY (CR6R03,CR6R09) UNRSTD;                                       0723
*       ATCNODDS=0;                        /*ZERO RPL PTR IN C L*/ 0724
         SLR   @09,@09                                             0724
         L     @06,ATCLCPTR                                        0724
         ST    @09,ATCNODDS(,@06)                                  0724
*    IF ((CR6R15>0   ) & (CR6ERCOD^=3))      /*CLOSE ERROR?*/      0725
*       THEN DO;                                                   0725
         CR    CR6R15,@09                                          0725
         BNH   @RF00725                                            0725
         CLC   CR6ERCOD(2,CR6DPLAD),@CH00137                       0725
         BE    @RF00725                                            0725
*        DLRPLMID=CR6424I;                 /*CLOSE MSGID*/         0727
         MVC   DLRPLMID(4,CR6DPLAD),@CC00453                       0727
*            /*ISSUE TPMSG*/                                       0728
*   RPLRTNCD=CR6R15;                                               0728
         STC   CR6R15,RPLRTNCD(,CR6RPLAD)                          0728
*   RPLERRCD=ACBERFLG;                                             0729
         L     @05,RPLDACB(,CR6RPLAD)                              0729
         IC    @03,ACBERFLG(,@05)                                  0729
         STC   @03,RPLERRCD(,CR6RPLAD)                             0729
*  MVC (DLRPLMSG( 9),CR6RCB(1:4));                                 0730
         MVC   DLRPLMSG+8(1,CR6DPLAD),CR6RCB(CR6RPLAD)             0730
*  SRL (DLRPLMSG( 9),4);                                           0731
         SLR   @05,@05                                             0731
         IC    @05,DLRPLMSG+8(,CR6DPLAD)                           0731
         SRL   @05,4                                               0731
         STC   @05,DLRPLMSG+8(,CR6DPLAD)                           0731
*  TR (DLRPLMSG( 9),CR6TBL);            /*VSAM R.C. INTO MSG,BYTE-1*/
         TR    DLRPLMSG+8(1,CR6DPLAD),CR6TBL                       0732
*  MVC (DLRPLMSG(10),CR6RCB(5:8));                                 0733
         MVC   DLRPLMSG+9(1,CR6DPLAD),CR6RCB(CR6RPLAD)             0733
*  SLL (DLRPLMSG(10),4);                                           0734
         SLR   @05,@05                                             0734
         IC    @05,DLRPLMSG+9(,CR6DPLAD)                           0734
         SLL   @05,4                                               0734
         STC   @05,DLRPLMSG+9(,CR6DPLAD)                           0734
*  SRL (DLRPLMSG(10),4);                                           0735
         SLR   @05,@05                                             0735
         IC    @05,DLRPLMSG+9(,CR6DPLAD)                           0735
         SRL   @05,4                                               0735
         STC   @05,DLRPLMSG+9(,CR6DPLAD)                           0735
*  TR (DLRPLMSG(10),CR6TBL);            /*VSAM R.C. INTO MSG,BYTE-2*/
         TR    DLRPLMSG+9(1,CR6DPLAD),CR6TBL                       0736
*  MVC (DLRPLMSG(11),CR6ERB(1:4));                                 0737
         MVC   DLRPLMSG+10(1,CR6DPLAD),CR6ERB(CR6RPLAD)            0737
*  SRL (DLRPLMSG(11),4);                                           0738
         SLR   @05,@05                                             0738
         IC    @05,DLRPLMSG+10(,CR6DPLAD)                          0738
         SRL   @05,4                                               0738
         STC   @05,DLRPLMSG+10(,CR6DPLAD)                          0738
*  TR (DLRPLMSG(11),CR6TBL);            /*VSAM E.C. INTO MSG,BYTE-1*/
         TR    DLRPLMSG+10(1,CR6DPLAD),CR6TBL                      0739
*  MVC (DLRPLMSG(12),CR6ERB(5:8));                                 0740
         MVC   DLRPLMSG+11(1,CR6DPLAD),CR6ERB(CR6RPLAD)            0740
*  SLL (DLRPLMSG(12),4);                                           0741
         SLR   @05,@05                                             0741
         IC    @05,DLRPLMSG+11(,CR6DPLAD)                          0741
         SLL   @05,4                                               0741
         STC   @05,DLRPLMSG+11(,CR6DPLAD)                          0741
*  SRL (DLRPLMSG(12),4);                                           0742
         SLR   @05,@05                                             0742
         IC    @05,DLRPLMSG+11(,CR6DPLAD)                          0742
         SRL   @05,4                                               0742
         STC   @05,DLRPLMSG+11(,CR6DPLAD)                          0742
*  TR (DLRPLMSG(12),CR6TBL);            /*VSAM E.C. INTO MSG,BYTE-2*/
         TR    DLRPLMSG+11(1,CR6DPLAD),CR6TBL                      0743
*       RFY (CR6MSGNO,CR6MSGTX) RSTD;                              0744
*       CR6MSGNO=ADDR(DLRPLMID);                                   0745
         LA    CR6MSGNO,DLRPLMID(,CR6DPLAD)                        0745
*       CR6MSGTX=ADDR(DLRPLMSG);                                   0746
*                                                                  0746
         LA    CR6MSGTX,DLRPLMSG(,CR6DPLAD)                        0746
*/*TPMSG MSGID((CR6MSGNO))MSG((CR6MSGTX))OPTIONS((DLRPLCON))PLAREA(DLRP
*TPL)*/                                                            0747
*                                                                  0747
*        DO;                                                       0747
*          DCL REG1080  REG(1)  PTR;                               0748
*          RFY (REG1080) RSTD;                                     0749
*                                                                  0749
*        RFY (EMCR13) RSTD;                                        0750
*          DCL 1 * BASED(REG1080),                                 0751
*              2 CMZID080 PTR(31),                                 0751
*              2 *,                                                0751
*                3 CMZRL080 PTR(8),                                0751
*                3 CMZRA080 PTR(24) BDY(BYTE),                     0751
*              2 CMZEA080 PTR(31),                                 0751
*              2 CMZVP080 PTR(31);                                 0751
*                                                                  0751
*/*XREGSET  PID('PLAREA')PPARM(DLRPLTPL)RREG(,REG1080)*/           0752
*        DO;                                                       0752
*          REG1080=ADDR(DLRPLTPL);       /*SET RREG SYMBOL TO ADDRESS*/
         LA    REG1080,DLRPLTPL(,CR6DPLAD)                         0753
*                                        /*OF PPARM OPERAND          */
*        END;  /* XREGSET */                                       0754
*          CMZID080 = 0;                                           0755
         SLR   @11,@11                                             0755
         ST    @11,CMZID080(,REG1080)                              0755
*          CMZRL080 = 0;                                           0756
         MVI   CMZRL080(REG1080),X'00'                             0756
*          CMZRA080 = 0;                                           0757
         STCM  @11,7,CMZRA080(REG1080)                             0757
*          CMZEA080 = 0;                                           0758
         ST    @11,CMZEA080(,REG1080)                              0758
*          CMZVP080 = 0;                                           0759
         ST    @11,CMZVP080(,REG1080)                              0759
*          CMZID080=CR6MSGNO;                                      0760
         ST    CR6MSGNO,CMZID080(,REG1080)                         0760
*          CMZVP080 = CR6MSGTX;                                    0761
         ST    CR6MSGTX,CMZVP080(,REG1080)                         0761
*          DCL CMZSA080 (18) PTR(31) BASED(EMCR13);                0762
*          CMZSA080(5) = DLRPLCON;                                 0763
*                                                                  0763
         L     @11,DLRPLCON(,CR6DPLAD)                             0763
         ST    @11,CMZSA080+16(,EMCR13)                            0763
*          DCL REG15080 REG(15) PTR;                               0764
*          RFY REG15080 RSTD;                                      0765
*                                                                  0765
*        DO; /* LISATCVT CVTBASE(PAGEABLE,(REG15080)) */           0766
*          REG15080 = ATCLCPTR; /*SET UP ATCVT POINTER*/           0767
         LR    REG15080,@06                                        0767
*        END; /*LISATCVT*/                                         0768
*          DCL CMTA080 BASED(REG15080) ENTRY VALUERANGE(*);        0769
*          REG15080 = REG15080->ATCMSGP;                           0770
         L     REG15080,ATCMSGP(,REG15080)                         0770
*          CALL CMTA080;                                           0771
         BALR  @14,@15                                             0771
*          RESPECIFY (REG1080,REG15080)  UNRESTRICTED;             0772
*                                                                  0772
*        RFY (EMCR13) UNRSTD;                                      0773
*        END;                                                      0774
*       RFY (CR6MSGNO,CR6MSGTX) UNRSTD;                            0775
*       END;                                                       0776
*  END;                                                            0777
@RF00725 DS    0H                                                  0778
*IF CR6ERCOD^=5                                                    0778
*  THEN DO;                                                        0778
@RF00716 CLC   CR6ERCOD(2,CR6DPLAD),@CH00306                       0778
         BE    @RF00778                                            0778
*STM(GPR14P,GPR00P,CR6R140);            /*SAVE REG 14->0*/         0780
         STM   GPR14P,GPR00P,CR6R140(CR6DPLAD)                     0780
*STM(GPR02P,GPR10P,CR6R210);            /*SAVE REG 2->10*/         0781
         STM   GPR02P,GPR10P,CR6R210(CR6DPLAD)                     0781
* /*FREESTOR AREA(CR6RPLAD)SIZE(LENGTH(CR6GTSTR))SAVE(NO)*/        0782
*  DO;                                                             0782
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTATCVT,ISTRPH)  */                  0783
*/* END OF ATBUILD */                                              0783
* RFY (GPR00P,GPR01P,GPR02P,GPR03P) RSTD;                          0783
* GPR00F = LENGTH(CR6GTSTR);                           /*SIZE IN REG0*/
         LA    GPR00F,177                                          0784
* DCL 1 CMZA0089 FIXED(31) STATIC LOCAL,                           0785
*       2 * FIXED(8) INIT(0),                        /* OPTION FLAGS */
*       2 * FIXED(8) INIT(96),                        /* STORAGE KEY */
*       2 * FIXED(8) INIT(231),                    /* SUBPOOL NUMBER */
*       2 * FIXED(8) INIT('01'X);                    /* REQUEST TYPE */
* GPR03F = CMZA0089;                                               0786
         L     GPR03F,CMZA0089                                     0786
* RFY (GPR04P) RSTD;                                               0787
* GPR04P = CR6RPLAD;                      /*PUT FREEMAIN ADDR IN REG4*/
*                                                                  0788
         LR    GPR04P,CR6RPLAD                                     0788
* DO; /* LISATCVT CVTBASE(PAGEABLE,(GPR02P)) */                    0789
*   GPR02P = ATCLCPTR; /*SET UP ATCVT POINTER*/                    0790
         L     GPR02P,ATCLCPTR                                     0790
* END; /*LISATCVT*/                                                0791
* CALL GPR02P -> ATCGTSTR;                            /*CALL ISTORFSR*/
         L     @15,ATCGTSTR(,GPR02P)                               0792
         BALR  @14,@15                                             0792
* RFY (GPR00P,GPR01P,GPR02P,GPR03P,GPR04P) UNRSTD;                 0793
* END ;                                             /*END OF FREESTOR*/
* RFY (ISTDLRPL) BASED(CR6R13);                                    0795
* LM(GPR14P,GPR00P,CR6R140);            /*REST REG 14->0*/         0796
         LM    GPR14P,GPR00P,CR6R140(CR6R13)                       0796
* LM(GPR02P,GPR10P,CR6R210);            /*REST REG 2->10*/         0797
         LM    GPR02P,GPR10P,CR6R210(CR6R13)                       0797
* RFY (ISTDLRPL) BASED(CR6DPLAD);                                  0798
*  END;                                                            0799
* DLRPLRCD='08'X;                       /*SET RET CDE IN DLRPL*/   0800
*                                                                  0800
@RF00778 MVI   DLRPLRCD(CR6DPLAD),X'08'                            0800
*/*  LEAVE(MAIN)  */                                               0801
* GOTO #BCM0006;                                                   0801
         B     #BCM0006                                            0801
*END CR6ERROR;                                                     0802
@PB00005 DS    0H                                                  0803
         EJECT
         EJECT
*/* --------------------------------                               0803
*   UNCHAIN SAVEAREAS                                              0803
*-----------------------------------*/                             0803
*                                                                  0803
* END; /* END  */                                                  0803
*#BCM0006:;                                                        0804
#BCM0006 DS    0H                                                  0805
*      /* TEST FUNCTION NOTIFICATION FLAG OF PARAMETER LIST        0805
*         IN ORDER TO KNOW WHAT IS TO BE DONE NEXT     */          0805
*    IF DLRPLRPF = DLRPLRTN /* IS A USER ROUTINE TO BE GIVEN CONTROL?*/
*      THEN DO;         /* YES      */                             0805
         CLI   DLRPLRPF(CR6DPLAD),1                                0805
         BNE   @RF00805                                            0805
*            CR6R01 =  ADDR(ISTDLRPL);   /* POINT R1 TO PARAM LIST  */
         LR    CR6R01,CR6DPLAD                                     0807
*            CR6R15 = DLRPLRNF;  /* POINT R15 TO USRTN ENTRY @ */  0808
         L     CR6R15,DLRPLRNF-1(,CR6DPLAD)                        0808
         LA    CR6R15,0(,CR6R15)                                   0808
*            CALL CR6R15->USRTN; /* EXECUTE FUNCTION IN USRTN  */  0809
         BALR  @14,@15                                             0809
*      CR6R13=CR6BCKPT;    /*@XM7958K*/      /*RESTORE CALLER'S SAVE*/
         L     CR6R13,CR6BCKPT(,CR6R13)                            0810
*           END;                                                   0811
*      ELSE DO;                                                    0812
         B     @RC00805                                            0812
@RF00805 DS    0H                                                  0813
*      CR6R01=CR6R13;      /*@XM7958K*/                            0813
         LR    CR6R01,CR6R13                                       0813
*      CR6R13=CR6BCKPT;    /*@XM7958K*/      /*RESTORE CALLER'S SAVE*/
         L     CR6R13,CR6BCKPT(,CR6R13)                            0814
*  IF DLRPLRPF = DLRPLRPH  /* IS FLAG AN RPH? */                   0815
*    THEN             /* YES           */                          0815
*                                                                  0815
         CLI   DLRPLRPF(CR6DPLAD),2                                0815
         BNE   @RF00815                                            0815
*/*TPPOST  (DLRPLRNF)  NSTR*/                                      0816
*         DO;                                                      0816
*                                       /*DECLARE AND RESTRICT REGS*/
*           RESPECIFY (GPR00F,GPR01F,GPR04F,GPR05F,                0817
*                     GPR06F,GPR14F,GPR15F) RSTD;                  0817
*                                       /*0,1,4,5,6,14, AND 15   */
*                                                                  0818
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTRPH,ISTAVT,ISTATCVT)  */           0818
*         RFY ISTAVT  ;                                            0818
*/* END OF ATBUILD */                                              0819
*           GPR04F=DLRPLRNF;            /*LOAD RPH PNTR INTO REG 4*/
         L     GPR04F,DLRPLRNF-1(,CR6DPLAD)                        0819
         LA    GPR04F,0(,GPR04F)                                   0819
*           RFY GPR03F RSTD;                                       0820
*           GPR03F=0;                                              0821
*                                                                  0821
         SLR   GPR03F,GPR03F                                       0821
*         DO; /*MODESET  SAVEKEY(GPR06F) KEYADDR(GPR03F) WORKREG(GPR05F
**/         RESPECIFY (GPR02F) RESTRICTED;                         0822
*           GPR05F = GPR02F; /*SAVE REGISTER 2*/                   0824
         LR    GPR05F,GPR02F                                       0824
*           IPK; /*SAVE CURRENT PSW KEY*/                          0825
         IPK                                                       0825
*           GPR06F = GPR02F;                                       0826
         LR    GPR06F,GPR02F                                       0826
*           GPR02F = GPR05F; /*RESTORE REGISTER 2*/                0827
         LR    GPR02F,GPR05F                                       0827
*           SPKA (GPR03F); /*SET PSW KEY*/                         0828
         SPKA  0(GPR03F)                                           0828
*           RESPECIFY (GPR02F) UNRESTRICTED;                       0829
*         END; /*MODESET  SAVEKEY(GPR06F) KEYADDR(GPR03F) WORKREG(GPR05
*)*/        RFY GPR03F UNRSTD;                                     0830
*           GPR05P=GPR04P->RPHMAJCB+GPR04P->RPHPABOF;              0832
         L     GPR05P,RPHMAJCB-1(,GPR04P)                          0832
         LA    GPR05P,0(,GPR05P)                                   0832
         SLR   @09,@09                                             0832
         IC    @09,RPHPABOF(,GPR04P)                               0832
         ALR   GPR05P,@09                                          0832
*                                       /*LOAD REG 5  WITH ADDR OF*/
*                                       /*MAJOR CONTROL BLOCK PLUS*/
*                                       /*OFFSET OF PAB IN BLOCK  */
*           GPR14P=0;                   /*LOAD 0 INTO REG 14      */
         SLR   GPR14P,GPR14P                                       0833
*           GPR15P='FFFFFFFF'X;         /*LOAD REG 15 WITH DUMMY  */
         SLR   GPR15P,GPR15P                                       0834
         BCTR  GPR15P,0                                            0834
*                                       /*ADDRESS                 */
*           CS (GPR14P,GPR15P,GPR04P->RPHRESMA);                   0835
         CS    GPR14P,@15,RPHRESMA(GPR04P)                         0835
*                                       /*COMPARE RESUME ADDRESS  */
*                                       /*WITH 0 AND,IF EQUAL, PUT*/
*                                       /*DUMMY ADDRESS IN CONTROL*/
*                                       /*BLOCK RESUME ADDRESS    */
*           BC (8,FMZT0110);            /*IF EQUAL, BYPASS REMAINDER*/
         BC    8,FMZT0110                                          0836
*                                       /*OF EXPANSION              */
*FMZL0110:  IF GPR04P->RPHWT='1'B THEN  /*WT/EXT CONTENTION FLAG ON */
FMZL0110 TM    RPHWT(GPR04P),B'00001000'                           0837
         BNO   @RF00837                                            0837
*           DO;                         /*IN RPH                    */
*             GPR14P=GPR04P->RPHRESMA|RPHWT1;                      0839
         L     GPR14P,RPHRESMA(,GPR04P)                            0839
         O     GPR14P,@CF01359                                     0839
*                                       /*LOAD REG 14 WITH FLAG FIELD*/
*                                       /*AND MAKE CERTAIN WT/EXT    */
*                                       /*CONTENTION FLAG STILL ON   */
*             GPR15P=GPR14P|RPHPT1;     /*LOAD REG 15 WITH FLAG FIELD*/
         LR    GPR15P,GPR14P                                       0840
         O     GPR15P,@CF01362                                     0840
*                                       /*AND TURN POST FLAG ON      */
*             CS (GPR14P,GPR15P,GPR04P->RPHRESMA);                 0841
         CS    GPR14P,@15,RPHRESMA(GPR04P)                         0841
*                                       /*COMPARE REG 14 WITH FLAG */
*                                       /*FIELD--IF WT/EXT BIT ON, */
*                                       /*TURN ON POST FLAG        */
*             BC (4,FMZL0110);          /*IF WT/EXT BIT WAS OFF, LOOP*/
         BC    4,FMZL0110                                          0842
*                                       /*TO TEST CONTENTION FLAG    */
*             BC (8,FMZT0110);          /*IF WT/EXT BIT WAS OFF,     */
         BC    8,FMZT0110                                          0843
*                                       /*BRANCH TO BYPASS CODE GEN  */
*           END;                        /*IF POST FLAG IS ON, FALL*/
*                                       /*THRU BOTTOM OF LOOP     */
*           ELSE;                       /*WT/EXT CONTENTION FLAG OFF*/
@RF00837 DS    0H                                                  0846
*           GPR00F=0;                   /*SET REG 0 TO INDICATE ENA*/
*                                                                  0846
         SLR   GPR00F,GPR00F                                       0846
*         DO; /* LISATCVT CVTBASE(PAGEABLE,(GPR15P)) */            0847
*           GPR15P = ATCLCPTR; /*SET UP ATCVT POINTER*/            0848
         L     GPR15P,ATCLCPTR                                     0848
*         END; /*LISATCVT*/             /*PUT POINTER TO ATCVT IN */
*                                       /*  IN REG 15             */
*           CALL GPR15P->ATCAP32;       /* CALL ISTAPC32: TPSCHED */
         L     @09,ATCAP32(,GPR15P)                                0850
         LR    @15,@09                                             0850
         BALR  @14,@15                                             0850
*FMZT0110:                                                         0851
*         DO; /*MODESET  KEYADDR(GPR06F) WORKREG(GPR05F)*/         0851
FMZT0110 DS    0H                                                  0852
*           GPR05F = GPR06F; /*GET KEY FORM SAVE LOCATION*/        0852
         LR    GPR05F,GPR06F                                       0852
*           SPKA (GPR05F); /*SET PSW KEY*/                         0853
         SPKA  0(GPR05F)                                           0853
*         END; /*MODESET  KEYADDR(GPR06F) WORKREG(GPR05F)*/        0854
*           RESPECIFY (GPR00F,GPR01F,GPR04F,GPR05F,GPR06F,         0855
*           GPR14F,GPR15F) UNRSTD;      /*UNRESTRICT REGS 0,1,    */
*                                       /*4,5,14, AND 15          */
*         END;  /****END OF TPPOST GENERATION****/                 0856
*    ELSE                                                          0857
*      IF DLRPLRPF = DLRPLPAB   /* IS FLAG A PAB?      */          0857
*        THEN                  /* YES                   */         0857
*                                                                  0857
         B     @RC00815                                            0857
@RF00815 CLI   DLRPLRPF(CR6DPLAD),4                                0857
         BNE   @RF00857                                            0857
*/*  TPQUE (CR6R01,DLRPLRNF) NORM NSTR */                          0858
*                                                                  0858
*                                                                  0858
*/*                          CMZVER = OS/VS2                          *
*           DO;                                                    0858
*           RFY (GPR00P,GPR01P,GPR04P,GPR05P,GPR15P) RSTD;         0859
*           GPR00P=0;                                              0860
         SLR   GPR00P,GPR00P                                       0860
*           GPR15P=ADDR(DLRPLRNF); /*HOLD PAB PTR*/                0861
         LA    GPR15P,DLRPLRNF(,CR6DPLAD)                          0861
*           GPR04P=CR6R01; /*WORK ELE PTR*/                        0862
         LR    GPR04P,CR6R01                                       0862
*           GPR05P=GPR15P; /*PASS PAB PTR*/                        0863
         LR    GPR05P,GPR15P                                       0863
*           CALL ATCLCPTR->ATCAP37->ISTAPC37;                      0864
         L     @09,ATCLCPTR                                        0864
         L     @15,ATCAP37(,@09)                                   0864
         BALR  @14,@15                                             0864
*           GEN(NOPR  8)NOSETS NOREFS;                             0865
         NOPR  8
*           RFY (GPR00P,GPR01P,GPR04P,GPR05P,GPR15P) UNRSTD;       0866
*           END; /**** END OF TPQUE GENERATION ****/               0867
*        ELSE                                                      0868
*          IF DLRPLRPF = DLRPLECB  /* IS FLAG AN ECB?        */    0868
*            THEN      /* YES */                                   0868
         B     @RC00857                                            0868
@RF00857 CLI   DLRPLRPF(CR6DPLAD),3                                0868
         BNE   @RF00868                                            0868
*                        DO;                                       0869
*                        CR6R01 = DLRPLRNF;/* PUT ECB @ IN R1  */  0870
         L     CR6R01,DLRPLRNF-1(,CR6DPLAD)                        0870
         LA    CR6R01,0(,CR6R01)                                   0870
*                        GEN (POST (1));                           0871
         POST (1)
*                        END;                                      0872
*            ELSE;  /* NOTIFICATION FLAG IS NOTHING */             0873
@RF00868 DS    0H                                                  0874
*      END;                                                        0874
*RETURN ;                               /*RETURN*/                 0875
*                                                                  0875
@EL00001 DS    0H                                                  0875
@EF00001 DS    0H                                                  0875
@ER00001 LM    @14,@12,12(@13)                                     0875
         BR    @14                                                 0875
*/* TPEPILOG   */                                                  0876
* GEN (PRINT OFF);                                                 0876
*                                                                  0876
         PRINT OFF
*/*   PROGRAM OPERATOR MESSAGE HEADER                                */
*DCL  1  ISTPOHD  BDY(WORD) BASED,                                 0877
*        2 POHRSVD1 CHAR(1),       /* RESERVED                       */
*        2 POHSTAT,                /* HEADER STATUS BITS             */
*          3 POHEND   BIT(1),      /* END LINE 1=YES                 */
*          3 POHDATA  BIT(1),      /* DATA LINE 1=YES                */
*          3 POHLBL   BIT(1),      /* LABEL LINE 1=YES               */
*          3 POHCNTRL BIT(1),      /* CONTROL LINE 1=YES             */
*          3 POHRSVD2 BIT(2),      /* RESERVED                       */
*          3 POHRREQ  BIT(1),      /* REPLY REQUESTED 1=YES          */
*          3 POHGEN   BIT(1),      /* ID ORIGIN  0=GENERATED BY VTAM */
*                                  /*            1=GENERATED BY POA  */
*        2 POHID    FIXED(16);     /* MESSAGE IDENTIFIER             */
*/*            VTAM PREFIX FOR QUEUE ELEMENTS                         *
*/*  INITIAL LEVEL                                     001 03/04/75  */
*DECLARE                                                           0878
*  1 ISTPFX  BDY(WORD)  BASED,                                     0878
*   2 PFXID        CHAR(4),             /* QUEUE ACRONYM (SAME AS  0878
*                                          QABID)                     *
*     3 PFXCBID    BIT(8),              /* CONTROL BLOCK ID           *
*   2 PFXPRTY      CHAR(1),             /* PRIORITY OF ELEMENT        *
*   2 PFXLNG       CHAR(3),             /* ELEMENT LENGTH,         0878
*                                          INCLUDING PREFIX           *
*   2 PFXFWD       PTR(31),   /* POINTER TO NEXT QUEUE             0878
*                                          ELEMENT (IF LAST        0878
*                                          POINTER TO QAB)            *
*   2 PFXBCK       PTR(31) ;   /* POINTER TO PREVIOUS              0878
*                                          QUEUE ELEMENT (IF       0878
*                                          FIRST, POINTER TO QAB)     *
*DCL NCSPLTYP BIT(8) CONSTANT('60'X);   /* NCSPL CONTROL BLOCK ID     *
*   /* NETWORK CONFIGURATION SERVICES CONTROL BLOCK  */            0880
*/*  REVISIONS                                         14 07/01/75  */
*DECLARE                                                           0880
*  1 ISTNCSPL BASED BDY(DWORD),                                    0880
*   2 *      CHAR(16) BDY(WORD),                                   0880
*     3 NCSPFX CHAR(LENGTH(ISTPFX)), /* QUE ELEMENT PREFIX           */
*       4 *        CHAR(12),                                       0880
*       4 NCSCRWKA PTR(31),       /* PTR TO WORK AREA FOR C/R I/O    */
*   2 *           BIT(8),         /*RESERVED                         */
*   2 NCSPLVCD    BIT(8),         /*VERB CODE                        */
*   2 NCSPLVBF    CHAR(2),        /*VERB MODIFIER FLAGS              */
*      3 NCSVBF01 BIT(1),         /* UNUSED                          */
*      3 NCSVBF02 BIT(1),         /* UNUSED                          */
*      3 NCSVBF03 BIT(1),         /* MODIFY MSG SUP                  */
*      3 NCSVBF04 BIT(1),         /* TYPE=VTAM                       */
*      3 NCSVBF05 BIT(1),         /* LINETRACE=1                     */
*      3 NCSVBF06 BIT(1),         /* I/O TRACE=1                     */
*      3 NCSVBF07 BIT(1),         /* BUFFER TRACE=1                  */
*      3 NCSVBF08 BIT(1),         /* MODIFY TPRINT                   */
*      3 NCSVBF09 BIT(1),         /* MODIFY TEST                     */
*      3 NCSVBF10 BIT(1),         /* MODIFY TRACE=NO                 */
*      3 NCSVBF11 BIT(1),         /* VARY INTERNAL ONLY & MODIFY     */
*                                 /*  TRACE = YES                    */
*      3 NCSVBF12 BIT(1),         /* VARY IMMEDIATE  & MODIFY        */
*                                 /*  NETSOL=NO                      */
*      3 NCSVBF13 BIT(1),         /* MODIFY NETSOL=YES               */
*      3 NCSVBF14 BIT(1),         /* VARY LOGON & MODIFY             */
*                                 /*  CHANGE                         */
*      3 NCSVBF15 BIT(1),         /* VARY DEACTIVATE & VARY NORMAL   */
*                                 /*  CLOSE(ERP)                     */
*      3 NCSVBF16 BIT(1),         /* VARY ACTIVATE & ERP REQUEST     */
*                                 /*   & MODIFY DUMP                 */
*   2 NCSPLVFL    CHAR(1),        /*COMMAND FLAGS                    */
*    3 NCSVNCSA   BIT(1),         /*NCSPL IS ACTIVE                  */
*    3 NCSVDEL    BIT(1),         /*DELETE NCSPL                     */
*    3 NCSVSTAT   BIT(1),         /*INDICATE NCSPL WAS NOT GETMAINED */
*    3 NCSDCONT   BIT(1),         /* DO DISCONACT                    */
*    3 NCSABCON   BIT(1),         /* DO ABANDON CONNECTION           */
*    3 NCSDACLK   BIT(1),         /* DO ACTIVATE LINE                */
*    3 NCSRSV02   BIT(2),         /* RESERVED                        */
*   2 NCSPLVF1    CHAR(1),        /* SPECIAL PROC FLAGS              */
*    3 NCSOVFMC   BIT(1),         /* PURGE ONLY VARY'S FMCB          */
*   2 NCSPRMRC    CHAR(1),        /* PURGE MINOR RETURN CODE FIELD   */
*   2 NCSIORC     CHAR(1),        /* I/O OR RESTART RETURN CODE      */
*   2 NCSRRNPT    CHAR(4),        /* ADDR RN ENTRY FOR LINE TRACE    */
*   2 NCSPLRID    CHAR(8),        /*ID = 'NODENAME'                  */
*   2 NCSPLLID    CHAR(8),        /*LOGON = 'NODENAME'               */
*   2 NCSDLID     CHAR(6),        /* OFFHOOK ID                      */
*   2 NCSCRCMD    FIXED(8),       /* C/R I/O COMMAND CODE            */
*   2 NCSCRPID    PTR(8),         /* C/R PATH ID (PID)               */
*   2 NCSPLRPT    PTR(31),        /*ID='NODENAME' RDTE ADDRESS       */
*   2 NCSPLLPT    PTR(31),        /*LOGON/LOGOFF='NODENAME' RDTE ADDR*/
*   2 NCSPLCMD    CHAR(2),        /*3705 CONTROL COMMAND CODES       */
*     3 NCSCMDA  BIT(8),          /*RH FLAGS                         */
*       4 NCSPLSYS BIT(1),        /*ON-SYSTEM OFF-FM                 */
*       4 NCSPLCTL BIT(1),        /*ON-CONTROL OFF-DATA              */
*       4 NCSPLSYN BIT(1),        /*ON=SYNCHR OFF-ASYNCHR            */
*       4 NCSPLFLO BIT(1),        /*ON-WITH FLOW  OFF-AGAINST FLOW   */
*       4 NCSPLUFM BIT(1),        /*ON=UNFORMATTED RU,OFF=FORMATTED  */
*       4 *        BIT(3),        /*RESERVED                         */
*     3 NCSCMDB  BIT(8),          /*COMMAND FIELD                    */
*   2 NCSNCPEP    BIT(8),         /* EP SUBCHANNEL ADDR              */
*   2 NCSMSGSP    CHAR(1),        /* RESERVED FOR MESSAGE SURPRESSION*/
*   2 NCSPLUAD    CHAR(3),        /*U = 'UNIT ADDRESS'               */
*   2 NCSCRFLG    CHAR(1),        /* MISCELLANEOUS C/R FLAGS         */
*     3 NCSPLWRM    BIT(1),       /* COMMAND SPECIFIED WARM PARAM,   */
*                                 /* 1 = YES                         */
*     3 NCSPLCLD    BIT(1),       /* COMMAND SPECIFIED COLD PARAM,   */
*                                 /* 1 = YES                         */
*     3 NCSFMCLD    BIT(1),       /* 370X RESPONDED COLD TO ACTPU    */
*                                 /* (ERP), 1 = YES                  */
*     3 NCSFMERP    BIT(1),       /* 370X RESPONDED ERP TO ACTPU     */
*                                 /* (ERP), 1 = YES                  */
*     3 NCSCRDSE    BIT(1),       /* 0=C/R DATA SET DOES NOT EXIST   */
*                                 /* OR IS NULL                      */
*                                 /* 1=C/R DATA SET EXISTS           */
*                                 /* AND IS NOT NULL                 */
*     3 NCSOPRQU    BIT(1),       /* OPERATOR REQUESTS REIPL, 1 = YES*/
*     3 NCSUSRNF    BIT(1),       /* EARLY WARNING PURGE HAS ALREADY */
*                                 /* OCCURED, 1 = YES                */
*     3 NCSSTCMD    BIT(1),       /* ACTIVATE IS A RESULT OF         */
*                                 /* START VTAM COMMAND, 1 = YES     */
*   2 NCSPLWRE    BIT(32),        /* WTOR ECB                        */
*   2 NCSPLWRF    CHAR(72),       /* WTOR REPLY AREA                 */
*   2 NCSPLRAD    PTR(31),        /* RDTE PTR FOR ALLOCATE/DEALLOCATE*/
*     3 NCSLSCMD BIT(8),          /* LINE SCHED COMMAND TYPE         */
*     3 NCSPLRCD BIT(8),          /* HEX VALUE FOR LINE SCHED PARAM  */
*   2 NCSIOCID    CHAR(4),        /* CURRENT CID FOR DAF LOCK HELD   */
*     3  NCSPLCID CHAR(4),        /* ALIAS FOR ABOVE                 */
*        4  NCSPLSAF  CHAR(2),    /* SOURCE ADDRESS                  */
*        4  NCSPLDAF  CHAR(2),    /* DESTINATION ADDRESS             */
*   2 NCSPLWKA    PTR(31),        /* NCS WORK AREA ADDRESS           */
*   2 NCSPLCVT    PTR(31),        /* POINTER TO VTAM CVT             */
*   2 NCSPLRPH    PTR(31),        /* POINTER TO RPH                  */
*   2 NCSPLECB    BIT(32),        /* ECB FOR VARY PGS                */
*   2 NCSPLFSB    PTR(31),        /* ADDRESS OF USS-FSS FSB OR RU    */
*   2 NCSPLRCR    PTR(31),        /* ADDRESS RDTE FOR CR             */
*   2 NCSPLFL1    CHAR(1),        /* VARY FLAGS                      */
*     3 NCSPL2IN  BIT(1),         /* SECOND ENTRY                    */
*     3 NCSPLSOM  BIT(1),         /* SUPRESS OP. MESSAGE             */
*     3 NCSPLEBN  BIT(1),         /* ENTRY FROM BNN SSCP             */
*     3 NCSPLREQ  BIT(1),         /* NCSPL FROM RESTORE              */
*     3 NCSPLNON  BIT(1),         /* DO NOT ADDR RDT SEGMENT         */
*     3 NCSPLAPU  BIT(1),         /* ACTIVATE PHYSICAL DONE BY LOAD  */
*     3 NCSPL2CN  BIT(1),         /* SECOND CONTACT REQUEST          */
*     3 NCSPLPOS  BIT(1),         /* BNN POSTED                      */
*   2 NCSPLFL2    CHAR(1),        /* VARY FLAGS                      */
*     3 NCSPLVDP  BIT(1),         /* NCSPL ON VARDEF PAB             */
*     3 NCSPLRSF  BIT(1),         /* NO SICK CLEAR BEFORE I/O        */
*     3 NCSPLRIO  BIT(1),         /* I/O = RESTART I/O               */
*     3 NCSOUFMC  BIT(1),         /* PURGE ONLY USER FMCB            */
*     3 NCSPLDS   BIT(1),         /* 1=CIO SAVED RESPONSE DATA       */
*     3 NCSREMPO  BIT(1),         /* REMOTE POWER OFF SPEC BY OPER   */
*     3 NCSPLVIS  BIT(1),         /* VARY IMM START CALLER OF CVP    */
*     3 NCSPLVIT  BIT(1),         /* VARY IMM TERM CALLER OF CVP     */
*   2 NCSPLFL3    CHAR(1),        /* FLAG BYTE                       */
*     3 NCSPLMOM  BIT(1),         /* ERP CAUSED BY FAILURE OF      0880
*                                    HIGHER NODE                     */
*     3 NCSEPP    BIT(1),         /* 1=EP SUBCHANNEL PRESENT         */
*     3 NCSPLANS  BIT(1),         /* ON FOR ACT IN ANSWER MODE       */
*                                 /* OFF FOR ACT IN NON-ANSWER MODE  */
*     3 NCSGID    BIT(1),         /* ON FOR PATH WITH GID PARM       */
*     3 NCSPID    BIT(1),         /* ON FOR PATH WITH PID PARM       */
*     3 NCSANS    BIT(1),         /* ON FOR ACTIVATE WITH ANS PARM   */
*     3 NCSFINAL  BIT(1),         /* FINAL PARM EXISTS               */
*     3 NCSEND    BIT(1),         /* END PARM EXISTS                 */
*   2 NCSPLFL4    CHAR(1),        /* FLAG BYTE                       */
*     3 NCSDLNID  BIT(1),         /* ID PRESENT IN NCSPL - OFF       */
*     3 NCSPLRSO  BIT(1),         /* RESET ONLY                      */
*     3 NCSPLVID  BIT(1),         /* ORIG CMD WAS MODIFY DUMP        */
*     3 NCSDSPE   BIT(1),         /* DISPLAY EVERY                   */
*     3 NCSDSPA   BIT(1),         /* DISPLAY ACT                     */
*     3 NCSDSPI   BIT(1),         /* DISPLAY INACT                   */
*     3 NCSDSPN   BIT(1),         /* DISPLAY NONE                    */
*     3 NCSPL2AP  BIT(1),         /* SECOND ACTPU TO 320X            */
*   2 NCSDLRSN    CHAR(1),        /* DIAL REASON CODES               */
*   2 NCSPLFL5    CHAR(1),        /* FLAG BYTE                       */
*     3 NCSSCPPS  BIT(1),         /* SSCP WORK AREA IN PVT STORAGE   */
*     3 NCSSDLK   BIT(1),         /* ON-SDLC LINK PROCESSED          */
*     3 NCSFORCE  BIT(1),         /* FORCED DEACT IN PROGRESS        */
*     3 *         BIT(5),         /* RESERVED                        */
*   2 NCSPLOLN    FIXED(15),      /* LENGTH O/B RU                   */
*   2 NCSPLP1     PTR(31),        /* ADDR VARY PAB                   */
*   2 NCSPLP2     PTR(31),        /* ADDR D/L/R PAB                  */
*   2 NCSPLP3     PTR(31),        /* ADDR ERP PAB                    */
*   2 NCSPLSPL    PTR(31),        /* ADDR ASSOC. NCSPL               */
*   2 NCSPLWEL    PTR(31),        /* ADDR POST RPH                   */
*   2 NCSPLRRP    PTR(31),        /* ADDR REMOTE RN RDTE IN LOCAL RDT*/
*   2 NCSPLRUO    PTR(31),        /* ADDR O/B RU                     */
*   2 NCSPLRUI    PTR(31),        /* ADDR BUFFER FOR I/B RU          */
*   2 NCSPLAPP    PTR(31),        /* ADDR NCSPL APPENDAGE            */
*   2 NCSRNAME    CHAR(8),        /* RNAME=FROM VARY ACTIVATE        */
*   2 NCSPLSQN    FIXED(15),      /* SEQUENCE=NR. FOR RESPONSE       */
*   2 NCSPLGID    BIT(8),         /* BINARY REP OF GID VALUE         */
*   2 NCSPLPID    BIT(8),         /* BINARY REP OF PID VALUE         */
*   2 NCSPLMID    CHAR(8),        /* LOGMODE = 'MODENAME'            */
*   2 NCSPLNSN    PTR(31),        /* RDTE NSNEA AT CLSDST            */
*   2 NCSSENSE    CHAR(4),        /* SENSE                           */
*     3 NCSSNS1  CHAR(1),         /* SENSE DATA MAJOR CODE           */
*     3 NCSSNS2  CHAR(1),         /* SENSE MODIFIER BYTE             */
*     3 NCSSENS2 CHAR(2),         /* USER SENSE DATA                 */
*   2 NCSCPWPT    PTR(31),        /* ADDRESS OF CPWA                 */
*   2 NCSMGLPT    PTR(31),        /* PTR TO USS/FSS MSG PARAM LIST   */
*   2 NCSUFMCB    PTR(31),        /* POINTER TO SSCP-LU FMCB         */
*   2 NCSPLRH     CHAR(3),        /* REQUEST RH                      */
*   2 NCSPLRTY    CHAR(1),        /* TYPE FROM RTGOH RU              */
*   2 NCSCRDTE    PTR(31),        /* PTR TO RDTE BEING PROCESSED     */
*                                 /* FOR C/R I/O                     */
*   2 NCSCRMSK,                   /* FLAGS FOR C/R CHECK POINTING    */
*     3 NCSCHKPT    CHAR(2),      /* FLAGS FOR ITEMS CHECK POINTED   */
*       4 NCSACTV     BIT(1),     /* ACTICE/INACTIVE STATUS CHANGED  */
*                                 /* 1 = YES                         */
*       4 NCSPACTV    BIT(1),     /* PORT ACT/INACTIVE STATUS CHANGED*/
*                                 /* 1 = YES                         */
*       4 NCSPOLD     BIT(1),     /* POLL DELAY VALUE CHANGED, 1=YES */
*       4 NCSNRPL     BIT(1),     /* NEGATIVE RESPONSE TO POLL       */
*                                 /* LIMIT VALUE CHANGED, 1 = YES    */
*       4 NCSESLM     BIT(1),     /* SESSION LIMIT VALUE CHANGED,1=YES*
*       4 NCSDTRLM    BIT(1),     /* DEVICE TRANSMISSION LIMIT       */
*                                 /* VALUE CHANGED, 1 = YES          */
*       4 NCSLGAPL    BIT(1),     /* APPLICATION CONTROLLER NAME     */
*                                 /* (LOGAPPL) CHANGED, 1 = YES      */
*       4 NCSLGMOD    BIT(1),     /* LOGON MODE (LOGMODE)            */
*                                 /* CHANGED, 1 = YES                */
*       4 NCSANSMD    BIT(1),     /* ANSWER MODE STATUS CHANGED,1=YES*/
*       4 NCSCUA      BIT(1),     /* CUA VALUE CHANGED, 1 = YES      */
*       4 NCSRNME     BIT(1),     /* RNAME VALUE CHANGED, 1 = YES    */
*       4 NCSPTUSE    BIT(1),     /* PATH USE/NOUSE STATUS CHANGED   */
*                                 /* 1 = YES                         */
*       4 NCSRSVD1    BIT(4),     /* RESERVED                        */
*     3 NCSCRMOD    CHAR(1),      /* NEW VALUES FOR ITEMS CHECKPOINTED*
*                                 /* NOT OBTAINED FROM RDTE          */
*       4 NCSAIMOD    BIT(1),     /* ACTIVE/INACTIVE STATUS, 1=ACTIVE*/
*       4 NCSPTMOD    BIT(1),     /* PORT ACT/INACT STATUS, 1=ACTIVE */
*       4 NCSRSVD2    BIT(6),     /* RESERVED                        */
*   2 NCSPLSID BDY(BYTE),         /* MESSAGE ROUTING INFORMATION     */
*     3 NCSPLSTA    CHAR(1),      /* STATUS FLAG BYTE                */
*       4 NCSRSVD4    BIT(7),     /* RESERVED                        */
*       4 NCSPLPO     BIT(1),     /* 0 = CONSOLE ID FOLLOWS, 1 =     */
*                                 /* PROGRAM OPERATOR HEADER FOLLOWS */
*     3 NCSPLPHD CHAR(LENGTH(ISTPOHD)), /* PO HEADER IF NCSPLPO = 01 */
*       4 NCSPLNID    FIXED(8),   /* CONSOLE ID IF NCSPLPO = 0       */
*     3 NCSPLPDB    PTR(31);      /* PTR TO PO ACDEB PREFIX          */
*/*   COMMAND VALUES FOR C/R FIELD NCSCRCMD                          */
*DCL NCSCRWR  FIXED(8) CONSTANT(0);  /* WRITE TO C/R DATA SET        */
*DCL NCSCROPN FIXED(8) CONSTANT(1);  /* OPEN C/R DATA SET            */
*DCL NCSCRCLS FIXED(8) CONSTANT(2);  /* CLOSE C/R DATA SET           */
*DCL NCSCRDEL FIXED(8) CONSTANT(3);  /* DELETE C/R DATA SET RECORD   */
*DCL NCSCROPQ FIXED(8) CONSTANT(4);  /* OPERATOR QUERY               */
*DCL NCSDCID  FIXED(8) CONSTANT(1);  /* CONSOLE ID INDICATOR         */
*DCL NCSCRIO  BIT(16) CONSTANT('0800'X); /* INDICATES REQUESTS       */
*                                        /* FOR VSAM I/O FOR C/R     */
*DCL NCSCRVIO BIT(16) CONSTANT('0C00'X); /* VSAM I/O OPERATION       */
*/* NCSPL APPENDAGE DEFINATION                                       */
*DCL  1  NCSAPP BASED(NCSPLAPP),                                   0889
*        2 NCSAPSA  CHAR(72),     /* SAVE AREA                       */
*        2 NCSAPECB CHAR(4),      /* ECB                             */
*        2 NCSAPTXT CHAR(8),      /* DUMP DATA                       */
*        2 NCSAPEND PTR(31),      /* HIGH STORAGE ADDRESS            */
*        2 NCSAPBUE CHAR(520),                                     0889
*          3 NCSRSV04 CHAR(3),    /* RESERVED                        */
*          3 NCSAPRU  CHAR(5),    /* IPL CMD RU PREFIX               */
*          3 NCSAPDAT CHAR(512),  /* RESP FOR DUMP, O/B LOAD         */
*        2 NCSAPPAB PTR(31);      /* BNN VARY PAB ADDR               */
*/*    USS/FSS RU AREA MAP                                           */
*DCL  1  NCSUSSRU BASED(NCSPLFSB),                                 0890
*        2 NCSRULEN FIXED(15),    /* LENGTH OF RU                    */
*        2 NCSRUITS CHAR(*);      /* START OF RU                     */
*/*    GENERAL CONSTANTS                                             */
*DCL NCSWASZ  FIXED(15) CONSTANT(2032);   /* NCSPL WORK AREA SIZE    */
*DCL NCSRTGOH BIT(16) CONSTANT('1000'X);  /* VBF VALUE FOR INTERNAL  */
*                                         /* COMMAND-RTGOH RECVD.    */
*/*    CONSTANTS FOR VERB CODES                                      */
*DCL NCSPLVC0 BIT(08) CONSTANT('00'X);    /* ERROR                   */
*DCL NCSPLVC1 BIT(08) CONSTANT('01'X);    /* VARY                    */
*DCL NCSPLVC2 BIT(08) CONSTANT('02'X);    /* MODIFY                  */
*DCL NCSPLVC3 BIT(08) CONSTANT('03'X);    /* ERP                     */
*DCL NCSPLVC4 BIT(08) CONSTANT('04'X);    /* DISPLAY                 */
*DCL NCSPLVC5 BIT(08) CONSTANT('05'X);    /* STATUS TO SM            */
*DCL NCSPLVC6 BIT(08) CONSTANT('06'X);    /* INTERNAL CMD            */
*DCL NCSPLVC7 BIT(08) CONSTANT('07'X);    /* INIT/TERM TUSM          */
*DCL NCSPLVC8 BIT(08) CONSTANT('08'X);    /* DIAL                    */
*/*    CONSTANTS FOR VARY COMMAND MODIFIERS                          */
*DCL NCSVACT BIT(16) CONSTANT('0001'X);   /*ACTIVATE                 */
*DCL NCSVDEA BIT(16) CONSTANT('0002'X);   /* DEACTIVATE              */
*DCL NCSVLON BIT(16) CONSTANT('0004'X);   /* LOGON                   */
*DCL NCSVVPP BIT(16) CONSTANT('0080'X);   /* VARY NORMAL CLEANUP REQST*
*DCL NCSVIMM BIT(16) CONSTANT('0010'X);   /* IMMEDIATE               */
*DCL NCSVINT BIT(16) CONSTANT('0020'X);   /* INTERNAL ONLY           */
*DCL NCSVALO BIT(16) CONSTANT('0005'X);   /* ACTIVATE WITH LOGON     */
*DCL NCSVDEI BIT(16) CONSTANT('0012'X);   /* DEACTIVATE IMMEDIATE    */
*DCL NCSVDII BIT(16) CONSTANT('0032'X);   /* DEACTIV. IMMEDIATE INTERNA
*                                            ONLY*/                0910
*DCL NCSCNOTF BIT(16) CONSTANT('FFF8'X);  /* NOTIFY REQUEST          */
*DCL NCSVANON BIT(16) CONSTANT('0008'X);  /* ANSWER = ON             */
*DCL NCSVANOF BIT(16) CONSTANT('0040'X);  /* ANSWER = OFF            */
*DCL NCSVPUSE BIT(16) CONSTANT('0100'X);  /* PATH = USABLE           */
*DCL NCSVPNUS BIT(16) CONSTANT('0200'X);  /* PATH = NOT USABLE       */
*DCL NCSVINOP BIT(16) CONSTANT('0400'X);  /* INOPERATIVE             */
*/*    CONSTANTS FOR MODIFY COMMAND MODIFIERS                        */
*DCL NCSMDUM BIT(16) CONSTANT('0001'X);   /* DUMP 3705               */
*DCL NCSMCHA BIT(16) CONSTANT('0004'X);   /* CHANGE                  */
*DCL NCSMNSY BIT(16) CONSTANT('0008'X);   /* NETSOL = YES            */
*DCL NCSMNSN BIT(16) CONSTANT('0010'X);   /* NETSOL = NO             */
*DCL NCSMTRY BIT(16) CONSTANT('0020'X);   /* TRACE = YES             */
*DCL NCSMVTRY BIT(16) CONSTANT('1020'X);                           0922
*DCL NCSMVTRN BIT(16) CONSTANT('1040'X);                           0923
*DCL NCSMTRN BIT(16) CONSTANT('0040'X);   /* TRACE = NO              */
*DCL NCSMTPR BIT(16) CONSTANT('0100'X);   /* TRACE PRINT             */
*DCL NCSMTST BIT(16) CONSTANT('0080'X);   /* MODIFY TEST             */
*DCL NCSDPF   BIT(16) CONSTANT('0000'X);  /* POTENTIAL FAIL          */
*DCL NCSDSTRT BIT(16) CONSTANT('0001'X);  /* DIAL START              */
*DCL NCSDOH1  BIT(16) CONSTANT('0002'X);  /* OFFHOOK 1               */
*DCL NCSDOH2  BIT(16) CONSTANT('0004'X);  /* OFFHOOK 2               */
*DCL NCSDDF   BIT(16) CONSTANT('0010'X);  /* DIAL FAILED             */
*DCL NCSDLKS  BIT(16) CONSTANT('0008'X);  /* LINK START              */
*DCL NCSDLKC  BIT(16) CONSTANT('0020'X);  /* LINK COMPLETION         */
*DCL NCSDHU   BIT(16) CONSTANT('0040'X);  /* HANGUP                  */
*DCL NCSDLK   BIT(16) CONSTANT('0080'X);  /* DEALLOCATE              */
*DCL NCSDGIVE BIT(16) CONSTANT('0100'X);  /* GIVE                    */
*DCL NCSDINOP BIT(16) CONSTANT('0200'X);  /* INOP                    */
*DCL NCSDLRST BIT(16) CONSTANT('0400'X);  /* RECOVERY SW LINKS       */
*                                         /* AFTER RN FAILURE        */
*/*    CONSTANTS FOR ERP COMMAND MODIFIERS                           */
*DCL NCSEERRA BIT(16) CONSTANT('0001'X);  /* ERP REQUEST          */
*DCL NCSECLOR BIT(16) CONSTANT('0002'X);  /* VARY NORMAL CLOSE REQUEST*
*DCL NCSEDACT BIT(16) CONSTANT('0004'X);  /* ERP DEACTIVATE REQUEST   *
*DCL NCSERSTR BIT(16) CONSTANT('0008'X);/* RSTRT ENTRY FROM DLR PROC */
*DCL NCSVFORC BIT(16) CONSTANT('0802'X);/* FORCED DEACT              */
*DCL NCSVRACT BIT(16) CONSTANT('1002'X);/* DEACT AND REACT           */
*/*   PURGE MINOR RETURN CODES CONSTANTS                             */
*DCL NCSAPABN BIT(8) CONSTANT('05'X),    /* APPLICATION ABEND        */
*    NCSCLDST BIT(8) CONSTANT('06'X),    /* CLOSE DEST OCCURED       */
*    NCSDDISC BIT(8) CONSTANT('08'X),    /* DIAL DISCONNECT OCCURED
*                                           - CONN NO LONGER AVAILABL*/
*    NCSBTHEX BIT(8) CONSTANT('09'X);    /* BUFFER THRESHOLD EXCEEDED*/
*/*   I/O OR RESTART RETURN CODES CONSTANTS                          */
*DCL NCSIOSUC BIT(8) CONSTANT('00'X),    /* I/O SUCCESSFUL           */
*    NCSIOERR BIT(8) CONSTANT('04'X),    /* I/O ERROR                */
*    NCSIOPRG BIT(8) CONSTANT('08'X),    /* I/O PURGED               */
*    NCSRSSUC BIT(8) CONSTANT('00'X),    /* RESTART SUCCESSFUL       */
*    NCSRSERR BIT(8) CONSTANT('04'X),    /* RESTART ERROR            */
*    NCSVAIPL BIT(8) CONSTANT('00'X),  /* IPL NO RESTART ON VARY ACTV*/
*    NCSVANRA BIT(8) CONSTANT('10'X),    /* IPL SUCCESSFUL, NO RESTART
*                                           AVAILABLE ON VARY ACTIVE  *
*    NCSVAWMF BIT(8) CONSTANT('08'X),    /* WARM START FAILURE FOR 0946
*                                           VARY ACTIVATE            */
*    NCSVAIPF BIT(8) CONSTANT('0C'X),   /* IPL FAILED ON VARY ACTIVATE*
*    NCSDSIA  BIT(8) CONSTANT('14'X),   /* INVALID ADDRESS SPECIFIED
*                                          ON DISPLAY STORAGE CMND    *
*    NCSVAISZ BIT(8) CONSTANT('08'X),   /* NCP SIZE TOO LARGE         *
*    NCSIPLSC BIT(8) CONSTANT('00'X),   /* IPL SUCCESSFUL             *
*    NCSIOER  BIT(8) CONSTANT('0C'X),   /* I/O ERROR ON REMOTE IPL    *
*    NCSNCPAC BIT(8) CONSTANT('04'X),   /* REMOTE NCP ALREADY ACTIVE  *
*    NCSNCRPF BIT(8) CONSTANT('70'X),   /* REMOTE POWER OFF           *
*    NCSCRIOS BIT(8) CONSTANT('30'X),   /* SUCCESSFUL I/O             *
*    NCSCRION BIT(8) CONSTANT('34'X),   /* NULL D.S. OPENED           *
*    NCSCRIOF BIT(8) CONSTANT('38'X);   /* FAILURE ON I/O             *
*/*           CONSTANTS FOR LIBERTY SUPPORT                           *
*DCL  NCSES   BIT(16) CONSTANT('0001'X),/* END SESSION                *
*     NCSBF   BIT(16) CONSTANT('0002'X),/* BIND FAILURE               *
*     NCSUF   BIT(16) CONSTANT('0004'X),/* UNBIND FAILURE             *
*     NCSINIT BIT(16) CONSTANT('0001'X),                           0947
*     NCSTERM BIT(16) CONSTANT('0002'X);                           0947
*DCL NCSTPPST BIT(16) CONSTANT('0001'X);/* TPPST COMMAND              *
*DCL NCSII    BIT(16) CONSTANT('0002'X);/* IPL INIT COMMAND           *
*DCL NCSIT    BIT(16) CONSTANT('0004'X);/* IPL COMMAND                *
*DCL NCSIF    BIT(16) CONSTANT('0008'X);/* IPL FINAL COMMAND          *
*DCL NCSDI    BIT(16) CONSTANT('0010'X);/* DUMP INIT COMMAND          *
*DCL NCSDT    BIT(16) CONSTANT('0020'X);/* DUMP TEXT COMMAND          *
*DCL NCSDF    BIT(16) CONSTANT('0040'X);/* DUMP FINAL COMMAND         *
*DCL NCSCON   BIT(16) CONSTANT('0080'X);/* CONTACT COMMAND            *
*DCL NCSDICON BIT(16) CONSTANT('0100'X);/* DISCONTACT COMMAND         *
*DCL NCSMSFMD BIT(16) CONSTANT('0200'X);/* SEND FMD                   *
*DCL NCSSEND  BIT(16) CONSTANT('0400'X);/* SEND                       *
*DCL NCSPURGE BIT(16) CONSTANT('0800'X);/* PAB PURGE                  *
*DCL NCSMSSUP BIT(16) CONSTANT('2000'X);/* CONSTANT FOR MSG SUP       *
*DCL NCSCRDS  BIT(16) CONSTANT('3023'X);/* RECORD DEV STATS COMMAND   *
*DCL NCSCQUIS BIT(16) CONSTANT('F01A'X);/* QUIESCE COMMAND            *
*DCL NCSSNUSS BIT(16) CONSTANT('381F'X);/* SEND USS MESSAGE           *
*/*                                                                   *
*DCL NCSNC    BIT(8)  CONSTANT('04'X);  /* NOT CONTACTED              *
*DCL NCSLD    BIT(8)  CONSTANT('00'X);  /* CONTACTED LOADED           *
*DCL NCSNLD   BIT(8)  CONSTANT('0C'X);  /* CONTACTED NEEDS LOAD       *
*DCL NCSNCD   BIT(8)  CONSTANT('08'X);  /* NOT CONTACTED DUE TO DEACT *
*DCL NCSNCE   BIT(8)  CONSTANT('10'X);  /* NOT CONTACTED DUE TO ERP   *
*DCL NCSNFME  BIT(8)  CONSTANT('24'X);  /* NEGATIVE FME               *
*/*  CONSTANTS FOR IORC FOR DISPLAY STORAGE                          */
*DCL NCSDSDEA BIT(8)  CONSTANT('0C'X);  /* PRIOR DEACT                *
*DCL NCSDSFAL BIT(8)  CONSTANT('04'X);  /* FAIL OTHER THAN PRIOR DEACT*
*/* TYPE CODES FOR CONFIGURATION RESTART                              *
*DCL NCSCTRLM BIT(8) CONSTANT('01'X);   /* CHANGE DEV TRANS LIMIT     *
*DCL NCSCNPOL BIT(8) CONSTANT('02'X);   /* CHANGE NEG POLL RESP LIMIT *
*DCL NCSCSESS BIT(8) CONSTANT('03'X);   /* CHANGE SESSION LIMIT       *
*DCL NCSCPOLL BIT(8) CONSTANT('04'X);   /* CHANGE LINE SERV SEEK PAUSE*
*/*  FM DATA COMMAND CODES                                            *
*DCL NCSCAPU  BIT(16) CONSTANT('D001'X);   /* ACT PHYS                *
*DCL NCSCDPU  BIT(16) CONSTANT('D002'X);   /* DEACT PHYS              *
*DCL NCSCALU  BIT(16) CONSTANT('D003'X);   /* ACT LOG                 *
*DCL NCSCDLU  BIT(16) CONSTANT('D004'X);   /* DEACT LOG               *
*DCL NCSCSDT  BIT(16) CONSTANT('D005'X);   /* SDT                     *
*DCL NCSCFME  BIT(16) CONSTANT('2006'X);   /* SEND POS RESP           *
*DCL NCSCEXCP BIT(16) CONSTANT('2007'X);   /* SEND NEG RESP           *
*DCL NCSCCON  BIT(16) CONSTANT('3008'X);   /* CONTACT                 *
*DCL NCSCDCON BIT(16) CONSTANT('3009'X);   /* DISCONTACT              *
*DCL NCSCIPLI BIT(16) CONSTANT('300A'X);   /* IPL INIT                *
*DCL NCSCIPLT BIT(16) CONSTANT('300B'X);   /* IPL                     *
*DCL NCSCIPLF BIT(16) CONSTANT('300C'X);   /* IPL FINAL               *
*DCL NCSCDUMI BIT(16) CONSTANT('300D'X);   /* DUMP INIT               *
*DCL NCSCDUMP BIT(16) CONSTANT('300E'X);   /* DUMP                    *
*DCL NCSCDUMF BIT(16) CONSTANT('300F'X);   /* DUMP FINAL              *
*DCL NCSCACTL BIT(16) CONSTANT('3010'X);   /* ACT LINK                *
*DCL NCSCDACL BIT(16) CONSTANT('3011'X);   /* DEACT LINK              *
*DCL NCSCSSV  BIT(16) CONSTANT('3012'X);   /* SET STATE VECTOR        *
*DCL NCSCNSP  BIT(16) CONSTANT('3013'X);   /* NS PROC ERROR           *
*DCL NCSCSTD  BIT(16) CONSTANT('3019'X);   /* SET TIME & DATE         *
*DCL NCSCSEP  BIT(16) CONSTANT('9014'X);   /* SWITCH TO EP            *
*DCL NCSCSNC  BIT(16) CONSTANT('9015'X);   /* SWITCH TO NCP           *
*DCL NCSCLSD  BIT(16) CONSTANT('3016'X);   /* LINE SCHED PARM         *
*DCL NCSCDS   BIT(16) CONSTANT('3017'X);   /* DISPLAY STORAGE         *
*DCL NCSCPWO  BIT(16) CONSTANT('3018'X);   /* REMOTE POWER OFF        *
*DCL NCSSNFMD BIT(16) CONSTANT('301C'X);   /* SEND FMD                *
*DCL NCSCDIAL BIT(16) CONSTANT('301A'X);   /* DIAL                    *
*DCL NCSCADIL BIT(16) CONSTANT('301B'X);   /* ABANDON DIAL            *
*DCL NCSCEANS BIT(16) CONSTANT('301D'X);   /* ENABLE ANS MODE         *
*DCL NCSCAANS BIT(16) CONSTANT('301E'X);   /* ABANDON ANS MODE        *
*DCL NCSCANA  BIT(16) CONSTANT('301F'X);   /* ASSIGN NET ADDRESS      *
*DCL NCSCFNA  BIT(16) CONSTANT('3020'X);   /* FREE NET ADDRESS        *
*DCL NCSCACON BIT(16) CONSTANT('3021'X);   /* ABANDON CONNECTION      *
*DCL NCSCSCV  BIT(16) CONSTANT('3022'X);   /* SET CONTROL VECTOR      *
*DCL NCSNCPPG BIT(16) CONSTANT('FFFF'X);   /* PURGE                   *
*/* NEW VALUES FOR NCSPLCMD   */                                   1011
*DCL NCSCLCND BIT(16) CONSTANT('0041'X);  /* LOAD CONDITIONALLY  */
*DCL NCSCUCND BIT(16) CONSTANT('0042'X); /* LOAD UNCONDITIONALLY */
*DCL NCSCRSRT BIT(16) CONSTANT('0043'X); /* RESTART 370X OR CLUS  */
*DCL NCSDUCMD BIT(16) CONSTANT('0044'X); /* DUMP 370X  */          1014
*DCL NCSCERPP BIT(16) CONSTANT('0045'X); /* PERFORM ERP DUMP AND   1015
*                                           RELOAD OF 370X  */     1015
*DCL NCSDOUT  BIT(16) CONSTANT('0046'X); /* DIAL OUT                 */
*DCL NCSDCNT  BIT(16) CONSTANT('0047'X); /* DIAL CONTACT             */
*DCL NCSDABDN BIT(16) CONSTANT('0048'X); /* DIAL ABANDON             */
*DCL NCSDENAS BIT(16) CONSTANT('0049'X); /* DIAL ENABLE ANSWER       */
*/*  VALUES FOR NCSCMDB                                              */
*DCL NCSBFME BIT(8) CONSTANT('06'X);     /* SEND POS RESP COMMAND    */
*DCL NCSBEXC BIT(8) CONSTANT('07'X);     /* SEND NEG RESP COMMAND    */
*/*  CONSTANTS FOR DIAL REASON CODES                                 */
*DCL NCSDLRRD BIT(8) CONSTANT('01'X);    /* REDIAL                   */
*DCL NCSDLRQT BIT(8) CONSTANT('02'X);    /* QUIT                     */
*/* NEW VALUES FOR NCSIORC   */                                    1024
*DCL NCSLDAOK BIT(8) CONSTANT('00'X);  /* COMMAND PROCESSED SUCESS */
*DCL NCSLDACT BIT(8) CONSTANT('04'X);  /* NCP ACTIVE-LOAD NOT PERF */
*DCL NCSLDCAN BIT(8) CONSTANT('04'X);  /* RELOAD DECLINED BY OPER  */
*DCL NCSLDIOP BIT(8) CONSTANT('08'X);  /* I/O PURGED               */
*DCL NCSLDNOG BIT(8) CONSTANT('0C'X);  /* COMMAND FAILED           */
*DCL NCSDUCOM BIT(8) CONSTANT('14'X);  /* DUMP COMPLETE            */
*DCL NCSHALTD BIT(8) CONSTANT('18'X);  /* CMD REJECTED,HALT IN PROG*/
*DCL NCSUNREC BIT(8) CONSTANT('1C'X);  /* COMMAND UNRECOGNIZED     */
*DCL NCSNOSTG BIT(8) CONSTANT('20'X);  /* CMD REJ,INSUFF STORAGE   */
*DCL NCSDOS   BIT(8) CONSTANT('00'X);  /* DIAL-OUT SUCCESSFUL      */
*DCL NCSDOF   BIT(8) CONSTANT('04'X);  /* DIAL-OUT UNSUCCESSFUL    */
*DCL NCSDOP   BIT(8) CONSTANT('08'X);  /* DIAL-OUT PENDING         */
*DCL NCSDCS   BIT(8) CONSTANT('00'X);  /* DIAL-CONTACT LOADED      */
*DCL NCSDCF   BIT(8) CONSTANT('0C'X);  /* DIAL-CONTACT FAILED      */
*DCL NCSDAS   BIT(8) CONSTANT('00'X);  /* DIAL-ABANDON CONN COMPLETE*/
*DCL NCSDENSO BIT(8) CONSTANT('00'X);  /* ENABLE ANSWER SUCCESSFUL  */
*DCL NCSDOFHR BIT(8) CONSTANT('04'X);  /* OFFHOOK REQUIRED          */
*DCL NCSDENSF BIT(8) CONSTANT('08'X);  /* ENABLE ANSWER FAIL        */
*/*  NEW VALUES FOR NCSPRMRC    */                                 1042
*DCL NCSFIRM  BIT(8) CONSTANT('10'X);  /* RESTART SUCC,OPENDST REQ */
*DCL NCSEWRN  BIT(8) CONSTANT('11'X);  /* CON LOST,RECOV IN  PROG  */
*/* CONSTANTS FOR TRACE                                            */
*DCL NCSACTLT BIT(16) CONSTANT('0820'X); /* ACTIVATE LINE TRACE    */
*DCL NCSDACLT BIT(16) CONSTANT('0840'X); /* DEACTIVATE LINE TRACE  */
*DCL NCSCACLT BIT(16) CONSTANT('301D'X); /* SSCP ACT LINE TRACE    */
*DCL NCSCDCLT BIT(16) CONSTANT('301E'X); /* SSCP DEACT LINE TRACE  */
*/* DISPLAY COMMAND MODIFIER CONSTANTS                             */
*DCL NCSDPATH BIT(16) CONSTANT('0001'X); /* PATHS                  */
*/* RPL HEADER                                                        *
*/*  REVISIONS                                         006 04/09/75   *
*DCL RPHPTR PTR(31) REGISTER(1) RESTRICTED;                        1049
*DCL  1  ISTRPH BDY(WORD) BASED(RPHPTR),                           1050
*       2  RPHCNTL FIXED(32),          /* CONTROL INFORMATION         *
*       3  RPHTYPE CHAR(1),            /* CONTROL BLOCK TYPE          *
*       3  RPHLNGTH PTR(8),            /* LENGTH IN BYTES             *
*       3  RPHFLAGS BIT(8),            /* SYSTEM DEPENDENT FLAGS      *
*         4  RPHOGIND BIT(1),          /* OPEN GATE INDICATOR         *
*         4  RPHSPGIN BIT(1),          /* SPECIAL GATE OPEN IND.      *
*         4  RPHAPTYP BIT(1),          /* APS IS A USER EXIT          *
*            5  RPHAUTEX BIT(1),        /*EXIT TO AUTHORIZED USER VS2 *
*         4  RPHSMQ BIT(1),            /* INDICATOR IF RPH IS TO BE   *
*                                      /* QUEUED                      *
*         4  RPHSMTYP BIT(1),          /* REQUEST TYPE IS BUFFER OR   *
*                                      /* DOUBLE-WORD                 *
*         4  RPHSMCLR BIT(1),          /* INDICATOR IF BUFFER TO BE   *
*                                      /* CLEARED                     *
*           4  RPHMLTCP BIT(1),        /* USED BY LOCAL 3270  SUPPORT *
*                                      /* WHEN BUILDING MULTIPLE CHAN *
*                                      /* PROGRAM                     *
*           4  RPHFSTLC BIT(1),        /* USED BY LOCAL 3270 SUPPORT  *
*                                      /* TO INDICATE FIRST LCCW      *
*              5  RPHFNFLG BIT(1),     /* LCCW SET FUNCTION FLAGS     *
*        3  RPHFLGB BIT(8),            /* SECOND FLAG BYTE            *
*           4  RPHLOCK BIT(1),         /* LOCKING OPTION              *
*           4  RPHBSSP BIT(1),         /* SYSTEM SERVICES PROGRESS    *
*           4  RPHFBAPS BIT(1),        /* STG. OBTAINED BY APS        *
*           4  RPHPGCMP BIT(1),        /* BIT ON INDICATES RESOURCE   *
*                                      /* MGR HAS COMPLETED UNLOCK    *
*           4  RPHNRSAV BIT(1),        /* DO NOT SAVE ON ACTIVATE     *
*           4  RPHRLCRA BIT(1),        /* RPH CAN BE RELEASED         *
*                                      /* WHEN PURGE COMPLETE         *
*           4  *        BIT(2),        /* RESERVED                    *
*       2  RPHRPHA PTR(31),            /* ADDR.OF NEXT RPL HEADER     *
*         3  RPHGATE BIT(1),           /* GATING FLAG                 *
*         3  *       BIT(7),           /* RESERVED                    *
*         3  RPHRPHAP PTR(24),                                     1050
*       2  RPHTSKID PTR(31),           /* TASK IDENTIFICATION         *
*                                      /* OR ADDR.OF APS TABLE        *
*          3  *     CHAR(3),           /* RPH TSK ID                  *
*          3  RPHTIK PTR(8),           /* TIK                         *
*       2  RPHDVTA PTR(31),            /* ADDR.OF  CURRENT DVT        *
*       2  RPHRESMA PTR(31) BDY(WORD), /* TPWAIT-POST INFO */      1050
*         3 RPHWPFLG CHAR(1),          /* WAIT-POST FLAGS */       1050
*           4 RPHRSKEY BIT(4),         /* STORAGE PROTECT KEY TO RESUME
*                                         PROCESSING                  *
*           4 RPHWT BIT(1),            /* WAIT BIT */              1050
*           4 RPHPT BIT(1),            /* POST BIT */              1050
*           4 RPHPURGE BIT(1),         /* RPH FLAGGED BY RECOVERY    */
*                                      /* TO BE PURGED BY PSS        */
*                                      /* VS/2 ONLY                  */
*           4 RPHRSV01 BIT(1),        /* RESERVED                    */
*         3 RPHRESUM PTR(24),          /* RESUME ADDRESS */        1050
*       2  RPHPABOF PTR(8),            /* OFFSET OF PAB IN CONTROL BLK*
*       2  RPHMAJCB PTR(24),           /* ADDR.OF MAJOR CONTROL BLOCK *
*       2  RPHWEA PTR(31),             /* ADDR.OF WORK ELEMENT        *
*         3  RPHCSPA PTR(31),          /* ADDR OF ISTCSP              *
*           4  RPHWEGT BIT(1),         /* GATE FOR WORK ELEMENT PROC. *
*       2  RPHSRPRM PTR(31),           /* SERVICE ROUTINE PARM.FIELD  *
*         3 RPHSRP12 FIXED(15),        /* COUNT OF Q'ED SMS REQUESTS  *
*         3 RPHSRP34 FIXED(15),        /* SIZE OF Q'ED SMS REQUESTS   *
*       2  RPHCRR PTR(31),             /* ADDR.OF COMPONENT RECOVERY  *
*                                      /* RECORD                      *
*       2  RPHPABQA PTR(31),           /* PAB QUEUE ADDRESS           *
*          3 RPHPABFG CHAR(1),         /* FLAG BYTE CARRIED FROM PAB  *
*          3 RPHPABQP PTR(24),         /* POINTER TO QUEUE OF PAB'S   *
*       2  RPHWORK CHAR(64) BDY(WORD), /* 16 WORD WORK AREA           *
*         3  RPHSAVE1 FIXED(31),       /*                             *
*           4  RPHSBYTE CHAR(1),       /* 1-BYTE SAVE FIELD           *
*           4  RPHSBITS BIT(8),        /* SAVE FIELD FOR FLAG BYTE    *
*              5  RPHSBIT1 BIT(1),     /* 1ST SAVE FIELD              *
*              5  RPHSBIT2 BIT(1),     /* 2ND SAVE FIELD              *
*              5  RPHSBIT3 BIT(1),     /* 3RD SAVE FIELD              *
*              5  RPHSBIT4 BIT(1),     /* 4TH SAVE FIELD              *
*              5  RPHSBIT5 BIT(1),     /* 5TH SAVE FIELD              *
*              5  RPHSBIT6 BIT(1),     /* 6TH SAVE FIELD              *
*              5  RPHSBIT7 BIT(1),     /* 7TH SAVE FIELD              *
*              5  RPHSBIT8 BIT(1),     /* 8TH SAVE FIELD              *
*           4  RPHSHALF FIXED(15),     /* HALF WORD SAVE AREA         *
*         3  RPHSAVE2 FIXED(31),       /*                             *
*         3  RPHSAVE3 FIXED(31),       /*                             *
*         3  RPHSAVE4 FIXED(31),       /*                             *
*         3  RPHSAVE5 FIXED(31),       /*                             *
*         3  RPHSAVE6 FIXED(31),       /*                             *
*         3  RPHSAVE7 FIXED(31),       /*                             *
*         3  RPHSAVE8 FIXED(31),       /*                             *
*         3  RPHSAVE9 FIXED(31),       /*                             *
*         3  RPHSAV10 FIXED(31),       /*                             *
*         3  RPHSAV11 FIXED(31),       /*                             *
*         3  RPHSAV12 FIXED(31),       /*                             *
*         3  RPHSAV13 FIXED(31),       /*                             *
*         3  RPHSAV14 FIXED(31),       /*                             *
*         3  RPHSAV15 FIXED(31),       /*                             *
*         3  RPHSAV16 FIXED(31),       /*                             *
*       2  RPHNEXPO PTR(31);           /* ADDR.NEXT RPH TO BE POSTED  *
* DCL RPTYPE BIT(8) CONSTANT('01'X);   /* TYPE CODE FOR RPH           *
* DCL RPHWT0 BIT(32) CONSTANT('F7FFFFFF'X);   /* TURN RPHWT OFF */ 1052
* DCL RPHWT1 BIT(32) CONSTANT('08000000'X);   /* TURN RPHWT ON */  1053
* DCL RPHPT0 BIT(32) CONSTANT('FBFFFFFF'X);   /* TURN RPHPT OFF */ 1054
* DCL RPHPT1 BIT(32) CONSTANT('04000000'X);   /* TURN RPHPT ON */  1055
* DCL RPHPABQ1 BIT(24) CONSTANT('000000'X); /* TURN RPHPBQ GATE */ 1056
*/* PROCESS ANCHOR BLOCK                                              *
*/*  REVISIONS                                         002 11/16/75  */
*DCL  1  ISTPAB BDY(DWORD) BASED,                                  1057
*       2  PABWQCHN CHAR(8) BDY(DWORD), /* CPS SWAP FIELD FOR NEQ&CHN *
*        3  PABWEQA PTR(31) BDY(WORD), /* WORK ELEMENT QUEUE ADDRESS  *
*           4  PABWEQG BIT(1),         /* GATING BIT                  *
*           4  PABRSV01 BIT(7),        /* RESERVED                    *
*           4  PABWEQP PTR(24),        /* WKEL PTR                    *
*        3  PABCHAIN PTR(31) BDY(WORD), /* APS CHAIN                  *
*           4  PABCHNG BIT(1),         /* GATING BIT                  *
*           4  PABRESCH BIT(1),        /* RESCHEDULE PAB AT        1057
*                                         TPEXIT                      *
*           4  PABCDP BIT(1),          /* CLOSE DST/CHANGE IN PROGRESS*
*           4  PABUNCON BIT(1),        /* UNCONDITIONALLY RESCHEDULE
*                                         PAB AT TPEXIT               *
*           4  PABRESET BIT(1),        /* RESET ISSUED ON THIS PAB    *
*           4  PABRUNNG BIT(1),        /* PAB RUNNING                 *
*           4  PABDELAY BIT(1),        /* DELAY OPTION USED           *
*           4  PABRSV02 BIT(1),        /* RESERVED                    *
*           4  PABCHNGP PTR(24),       /* PSS CHAIN PTR               *
*        2  PABOFFST PTR(8),           /* OFFSET FROM CONTROL BLOCK   *
*        2  PABDVTA PTR(24),           /* DVT ADDRESS                 *
*        2  PABRPHFG PTR(31),          /* SCHED FLAGS AND RPH         *
*           3  PABFLAGS BIT(8),        /* SCHEDULING FLAGS            *
*              4  PABAPYP BIT(1),      /* APPLICATION IS A USER EXIT  *
*              4  PABPRIOR BIT(1),     /* IMMEDIATE PRIORITY          *
*              4  PABNORPR BIT(1),     /* NORMAL PRIORITY -           *
*                                      /* RESCHEDUALABLE              *
*              4  PABDYNAM BIT(1),     /* DYNAMIC                     *
*              4  PABSSN BIT(1),       /* SYSTEM SERVICES             *
*              4  PABERLCK BIT(1),     /* PAB ERROR LOCK FLAG         *
*                 5  PABERRLK BIT(1),  /* ERROR LOCK                  *
*                    6  PABERLOK BIT(1), /* ERROR LOCK                *
*/*    ABNORMAL TO ALLOW VARY COMPARE AND SWAP                        *
*              4  PABINHBT BIT(1) ABNL,/* 1=INHIBIT TRAFFIC,0=NO      *
*              4  PABNODQ BIT(1),      /* DO NOT DEQ WORK ELEMENT     *
*           3  PABRPHA PTR(24);        /* RPL HEADER ADDRESS          *
*DCL PABWEQG0 BIT(32) CONSTANT('7FFFFFFF'X),  /* TURN PABWEQG OFF     *
*    PABWEQG1 BIT(32) CONSTANT('80000000'X),  /* TURN PABWEQG ON      *
*    PABCHNG0 BIT(32) CONSTANT('7FFFFFFF'X),  /* TURN PABCHNG OFF     *
*    PABCHNG1 BIT(32) CONSTANT('80000000'X),  /* TURN PABCHNG ON      *
*    PABRESC0 BIT(32) CONSTANT('BFFFFFFF'X),  /* TURN PABRESCH OFF    *
*    PABRESC1 BIT(32) CONSTANT('40000000'X),  /* TURN PABRESCH ON     *
*    PABCDP0  BIT(32) CONSTANT ('DFFFFFFF'X), /* TURN PABCDP OFF      *
*    PABCDP1  BIT(32) CONSTANT ('20000000'X), /* TURN PABCDP ON       *
*    PABERLK0 BIT(32) CONSTANT('FBFFFFFF'X),  /* TURN PABERRLK ON     *
*    PABERLK1 BIT(32) CONSTANT('04000000'X),  /* TURN PABERRLK OFF    *
*    PABUNCO0 BIT(32) CONSTANT('EFFFFFFF'X),  /* TURN PABUNCON OFF    *
*    PABUNCO1 BIT(32) CONSTANT('10000000'X),  /* TURN PABUNCON ON     *
*    PABPRIR0 BIT(32) CONSTANT('BFFFFFFF'X),  /* TURN PAB PRIOR OFF   *
*    PABPRIR1 BIT(32) CONSTANT('40000000'X),  /* TURN PAB PRIOR ON    *
*    PABRST0  BIT(32) CONSTANT('F7FFFFFF'X),  /* TURN PABRESET OFF    *
*    PABRST1  BIT(32) CONSTANT('08000000'X),  /* TURN PABRESET ON     *
*    PABDLAY0 BIT(32) CONSTANT('FDFFFFFF'X),  /* TURN PAB DELAY OFF   *
*    PABDLAY1 BIT(32) CONSTANT('02000000'X);  /* TURN PAB DELAY ON    *
*/* LOCKWORD FORMAT DSECT                                            */
*/*  INITIAL LEVEL                                     001 05/24/74  */
*DCL 1 ISTLOK BDY(WORD) BASED,                                     1059
*     2  LOKCT CHAR(1) BDY(WORD),       /* COUNT OF LOCK OWNERS      */
*     2  LOKCHN PTR(24),                /* ADDR OF NEXT RPH WAITING
*                                          ON LOCK                   */
*        3  LOKCHNG CHAR(3),            /* CHAIN/FLAGS               */
*           4 *        CHAR(2),                                    1059
*           4 *        BIT(8),                                     1059
*             5 *        BIT(6),                                   1059
*             5  LOKPRY BIT(1),         /* PRIORITY FLAG, 1 = ON     */
*             5  LOKXCL BIT(1);         /* EXCLUSIVE FLAG, 1 = ON    */
*DCL LOKXCL1  BIT(32) CONSTANT('00000001'X); /* CONSTANT TO TURN LOKXCL
*                                          ON                        */
*DCL LOKPRY1  BIT(32) CONSTANT('00000002'X); /* CONSTANT TO TURN LOKPRY
*                                          ON                        */
*DCL LOKCHN1  BIT(32) CONSTANT('00FFFFFC'X); /* CONSTANT TO TURN LOKXCL
*                                          AND LOKPRY OFF            */
*DCL LOKCT1   BIT(32) CONSTANT('01000000'X); /* CONSTANT TO MAKE LOKCT
*                                          = 1                       */
*DCL LOKCT255 BIT(32) CONSTANT('FF000000'X); /* CONSTANT TO CHECK FOR
*                                          MAX LOKCT (255)           */
*              /* DYNAMIC PAB 1K633 */                             1065
* /* 1K0997 JAN 20, 1973  MB   */                                  1065
* /* 1K1142 MAR 03, 1973  MB   */                                  1065
* DCL 1 ISTDYPAB BDY(DWORD) BASED, /* LEVEL 1 DECLARE 1K633 */     1065
*       2  DYPTYPE CHAR(1), /* CONTROL BLOCK TYPE CODE 1K633 */    1065
*       2  DYPLNGTH PTR(8), /* CONTROL BLOCK LENGTH (BYTES)  1K633 */
*       2 DYPFLGS CHAR(2),     /* FLAGS 1K633 */                   1065
*       2 DYPCHAIN PTR(31),    /* CHAIN POINTER 1K633 */           1065
*       2 DYPTSKID PTR(31),    /* TASKID OR PTR TO PSS TABLES 1K633 */
*       2  DYPRSV01 PTR(31),   /* RESERVED TO PRESERVE ALIGNMENT   1065
*                                                             1K0997 */
*       2 DYPPAB CHAR(LENGTH(ISTPAB)) BDY(DWORD); /* LENGTH OF 1K0997
*                                                    PAB         */
*DCL DYTYP   BIT(8) CONSTANT ('11'X);   /* TYPE           1K1142 */
*/*  REVISIONS                                         015 11/16/75   *
*DCL ATCLCPTR PTR LOCATION(1032);      /* POINTER TO ATCVT            *
*DCL  1  ISTATCVT BDY(DWORD) BASED,                                1068
*        2  ATCCOM BDY(WORD),          /* SYSTEM INDEPENDENT FIELDS   *
*           3  ATCSTAT CHAR(4),        /* VTAM  STATUS INDICATORS     *
*              4  ATCSTAT1 CHAR(1),    /* VTAM  STATUS BYTE 1         *
*                 5  ATCSTART BIT(1),  /* VTAM  IS STARTING           *
*                 5  ATCACTIV BIT(1),  /* VTAM  IS ACTIVE             *
*                 5  ATCSNHLT BIT(1),  /* VTAM  SESSION HALT          *
*                 5  ATCQKHLT BIT(1),  /* VTAM  QUICK HALT            *
*                 5  ATCNETSL BIT(1),  /* NETSOL=YES SPECIFIED ON CMD *
*                 5  ATCINHLT BIT(1),  /* INTERNAL VTAM HALT QUICK    *
*                 5  ATCMDHLT BIT(1),  /* VTAM CMD PROC HALTED        *
*                 5 * BIT(1),          /* RESERVED                    *
*              4  ATCSTFLG BIT(8),     /* STORAGE MANAGEMENT FLAGS    *
*                 5  ATCHSDMF BIT(1),  /* SYSTEM SLOW DOWN FLAG       *
*              4  ATCPOFLG BIT(8),     /* PROGRAM OPERATOR            *
*                                      /* INTERFACE FLAGS             *
*                 5 ATCPOUNS BIT(1),   /* APPLICATION AUTHORIZED TO   *
*                                      /* RECEIVE UNSOLICITED MESSAGES*
*                                      /* 1 = YES                     *
*                 5 *        BIT(7),   /* RESERVED                    *
*              4  ATCSTAT4 CHAR(1),    /* VTAM  STATUS BYTE 4         *
*                 5  ATCPRTAT BIT(1),  /* 1 = TRACE PRINT ACTIVE,  1068
*                                         0 = NOT ACTIVE              *
*                 5  ATCTPRT BIT(1),   /* WHEN 1, TPRINT IN PROCESS   *
*                 5  ATCMTST BIT(1),   /* WHEN 1, MODIFY TEST IN   1068
*                                         PROCESS                     *
*                 5  ATCNCSD BIT(1),   /* NCS QUIESCED DURING HALT    *
*                 5  ATCVTTRC BIT(1),  /* VTAM TRACE, 1=ACTIVE        *
*                 5  ATCRSV04 BIT(3),  /* RESERVED                    *
*           3  ATCAPI PTR(31),         /* ADDR OF API ROUTINE         *
*           3  ATCDCFRR PTR(31),       /* POINTER TO FRR OF CONTROL
*                                         LAYER,INITIALIZED BY OPENDST*
*           3  ATCRDT PTR(31),         /* POINTER TO FIRST RDT        *
*           3  ATCSRT PTR(31),         /* POINTER TO SRT DIRECTORY    *
*           3  ATCASCHD PTR(31),       /* POINTER TO AP SCHEDULER     *
*           3  ATCECMOD CHAR(4),       /* ECB FOR MODIFY COMMAND PROC.*
*           3  ATCMODQ PTR(31),        /* POINTER FOR OUTPUT QUEUE    *
*                                      /* FOR MODIFY COMMAND          *
*           3  ATCECHLT CHAR(4),       /* ECB FOR HALT COMMAND        *
*           3  ATCHALTQ PTR(31),       /* POINTER TO OUTPUT QUEUE     *
*                                      /* FOR HALT COMMAND            *
*           3  ATCECVRY CHAR(4),       /* ECB FOR VARY COMMAND PROC.  *
*           3  ATCVARYQ PTR(31),       /* POINTER TO OUTPUT QUEUE     *
*                                      /* FOR VARY COMMAND            *
*           3  ATCECDSP CHAR(4),       /* ECB FOR DISPLAY COMMAND     *
*           3  ATCDSPLQ PTR(31),       /*  POINTER TO OUTPUT QUEUE    *
*                                      /* FOR DISPLAY COMMAND         *
*           3  ATCOCHA PTR(31),        /* POINTER TO OCT HEADER       *
*           3  ATCECSES CHAR(4),       /* ECB TO HALT SESSION MODE    *
*           3  ATCECVRQ CHAR(4),       /* ERP ECB FOR VARY REQ. INFO. *
*                                      /* REQUEST NOTIFICATION        *
*           3  ATCVPARM PTR(31),       /* ADDR OF VARY PARAMETERS     *
*           3  ATCECOPC CHAR(4),       /* ECB TOINDICATE OPERATOR     *
*                                      /* CONTROL PROCESSING COMPLETE *
*           3  ATCECNET CHAR(4),       /* ERP ECB FOR NETWORK         *
*                                      /* CONFIGURATION REQUEST       *
*           3  ATCECPRM PTR(31),       /* POINTER TO QAB FOR ERP'S    *
*                                      /* ECB PARAMETERS              *
*           3  ATCHLTMS PTR(31),       /* POINTER TO HALT COMMAND     *
*                                      /* OR HALT RETURN MESSAGE      *
*           3  ATCFSB PTR(31),         /* PTR TO FEEDBACK STATUS      *
*                                      /* BLOCK                       *
*           3  ATCFRSCH PTR(31),       /* POINTER TO FEEDBACK         *
*                                      /* ROUTINE SCHEDULER           *
*           3  ATCRDTH PTR(31),        /*  POINTER RDT HEADER         *
*           3  ATCACCTA PTR(31),       /* POINTER TO INSTALLATION     *
*                                      /* ACCOUNTING ROUTINE          *
*           3  ATCAUTHA PTR(31),       /* POINTER TO INSTALLATION     *
*                                      /* AUTHORISATION ROUTINE       *
*           3  ATCPTCHA PTR(31),       /* PTR TO VTAM PATCH AREA      *
*           3  ATCCONFT PTR(31),       /* POINTER TO VTAM             *
*                                      /* CONFIGURATION TABLE         *
*           3  ATCFDVT PTR(31),        /* PTR TO FIRST DVT FOR O/C    *
*           3  ATCFEPT PTR(31),        /* PTR TO FIRST EPT FOR O/C    *
*           3  ATCDVTPT PTR(31),       /* ADDR OF LOAD MOD FOR        *
*                                      /* TYPE=VTAM TRACING           *
*           3  ATCBPDA PTR(31),        /* PTR TO BUFFER POOL DIRECTORY*
*           3  ATCADD PTR(31),         /* POINTER TO ADD PROCEDURE    *
*           3  ATCREMOV PTR(31),       /* POINTER TO REMOVE PROCEDURE *
*           3  ATCIOTRC PTR(31),       /*  POINTER TO I/O TRACE       *
*                                      /* PROCEDURE                   *
*              4 ATCTHTRC PTR(31),     /* ADDR OF TH TRACE ROUTINE    *
*                5 ATCTPBUF PTR(31),   /* TPIOS BUFFER TRACE(ISTRARTP)*
*           3  ATCBFTRC PTR(31),       /* PTR TO BUFFER TRACE         *
*                                      /* PROCEDURE                   *
*           3  ATCFBRPH PTR(31),       /* ADDR OF FEEDBACK PROC RPH   *
*           3  ATCBLDLA PTR(31),       /* ADDR OF BLDL ROUTINE        *
*           3  ATCALOAD PTR(31),       /* ADDR OF ALOAD ROUTINE       *
*           3  ATCREADA PTR(31),       /* ADDR OF SOURCE READ ROUTINE *
*           3  ATCGTSTR PTR(31),       /* ADDR OF GETSTOR ROUTINE     *
*           3  ATCFRSTR PTR(31),       /* ADDR OF FREESTOR ROUTINE    *
*           3  ATCSTMA PTR(31),        /* ADDR OF SM INITIALIZATION   *
*                                      /* ROUTINE                     *
*           3  ATCACDA PTR(31),        /* ADDR OF FIRST ACDEB         *
*           3  ATCSMRQ PTR(31),        /* ADDR OF REQUEST STORAGE     *
*                                      /* ROUTINE                     *
*           3  ATCSMQU PTR(31),        /* ADDR OF QUEUE REQUEST RTNE
*                                         - DOS ONLY                  *
*           3  ATCSMRS PTR(31),        /* ADDR OF RELEASE STORAGE     *
*                                      /* ROUTINE                     *
*           3  ATCSMRC PTR(31),        /* ADDR OF RECOVER STORAGE     *
*                                      /* ROUTINE  - DOS ONLY         *
*           3  ATCSMBQ PTR(31),        /* PTR TO Q'ED REQ. SMS RTN.   *
*           3  ATCFIRA PTR(31),        /* ADDR OF FEEDBACK INITIATION *
*                                      /* RPH                         *
*           3  ATCSRTAD PTR(31),       /* PTR TO SRTADD ROUTINE       *
*           3  ATCSRTDF PTR(31),       /* PTR TO SRTDELE ROUTN        *
*           3  ATCDCC60 PTR(31),       /* PTR TO ISTDCC60 - CTL. LAYER
*                                         MOVE TO USER AREA           *
*           3  ATCDCC61 PTR(31),       /* PTR TO ISTDCC61 - CTL. LAYER
*                                         MOVE FIXED TO PAGABLE       *
*/*  BEGIN 'ANY' DVT                                                  *
*           3  ATCNERST PTR(31),       /* PTR TO ISTDCC00 - REQUEST-ST*
*           3  ATCNERCV PTR(31),       /* PTR TO ISTRCC21-RECEIVE OB  *
*           3  ATCNERNE PTR(31),      /* PTR TO ISTDCC25 - READ-ANY   *
*           3  ATCNERFN PTR(31),      /* PTR TO ISTDCC02 - REQUEST-FN *
*/*  END 'ANY' DVT                                                    *
*           3  ATCAPOST PTR(31),      /* PTR TO VTAM  POST ROUTINE    *
*           3  ATCVTMID CHAR(2),      /* HOST MAJOR NODE I.D.         *
*           3  ATCRSV11 CHAR(2),      /* RESERVED                     *
*           3 ATCRCC63 PTR(31),  /* HSKPANYQ POINTER                  *
*           3 ATCRCC26 PTR(31),  /* SEND RESPONSE POINTER             *
*           3 ATCRCC65 PTR(31),  /* SET RPL POINTER                   *
*           3  ATCNESAL PTR(31),      /* PTR TO ISTDCC24 - SOLICIT-ALL*
*           3  ATCNERAP PTR(31),       /* PTR TO ISTDCC85 - READ ANY
*                                         PURGE                       *
*           3 ATCACTRM FIXED(15),     /* COUNT OF ACTIVE TERMINALS    *
*           3 ATCCIDM BIT(16),        /* CID MASK                     *
*           3 ATCMSGSP BIT(8), /* RESERVED FOR MESAGE SURPRESSION     *
*         2 ATCMAXID PTR(8),   /* MAXIMUM NUMBER OF MAJOR NODES, 0 =
*                                 NUMBER OF ENTRIES IN THE MNT        *
*         2 ATCRSV16 CHAR(2),  /* NOT USED                            *
*         2 ATCMNT PTR(31),    /*PTR TO MAJOR NODE TABLE -SET BY SYS.
*                                DEF. REF. BY ISTSDCCB (CBDEF),    1068
*                                ISTSDCCI (CINDEXY)                   *
*         2 ATCCDADD PTR(31),  /*PTR TO CIDADD ROUTINE ISTSDCCA    1068
*                                 REF. BY CIDCTL MACRO                *
*         2 ATCCDDEL PTR(31),  /*PTR TO CIDDEL ROUTINE ISTSDCCD    1068
*                                 REF. BY CIDCTL MACRO                *
*         2 ATCCDFND PTR(31),  /*PTR TO CIDFND ROUTINE IATSDCCF    1068
*                                 REF. BY CIDCTL MACRO                *
*         2 ATCESC01 PTR(31),  /*PTR TO ESC01                         *
*         2 ATCESC02 PTR(31),  /*PTR TO ESC02                         *
*         2 ATCCSMR PTR(31),        /* PTR TO CONNECTION SERVICES     *
*                                   /*  MASTER ROUTINE                *
*           3 ATCCSMA PTR(31),      /* PTR TO CONNECTION SERVICES  1068
*                                      MASTER ROUTINE                 *
*         2 ATCOCRT PTR(31),        /* PTR TO OPEN/CLOSE ROUTINE      *
*         2 ATCUEP  PTR(31),        /* POINTER TO USER EXIT           *
*         2 ATCSHRTN CHAR(8),       /* NAME OF VTAM  SHARED RTN       *
*                                   /*  TO BE LOADED                  *
*         2 ATCSHRFG BIT(8),        /* ATTRIBUTE FLAGS                *
*           3 ATCLAST BIT(1),       /* INDICATE HTIS IS LAST MODULE   *
*         2 ATCXRANG CHAR(1),       /* NUMBER OT BITS IN X-VALUE   1068
*                                       PORTION   OF CID              *
*         2 ATCSAF   CHAR(2),       /* SUB AREA ADDRESS FIELD         *
*         2 ATCEPA PTR(31),         /* ENTRY POINT ADDR OF LOADED     *
*         2 ATCALERT PTR(31),       /* POINTER TO ALERT-ROUTINE    1068
*                                      ISTSDCAL                       *
*         2 ATCDVLOD PTR(31),       /* PTR TO ISTSDCOD                *
*         2 ATCTRCPT PTR(31),       /* POINTER TO TRACE PARM LIST     *
*         2 ATCDVT   PTR(31),       /* POINTER TO FIRST DVT ON CHAIN  *
*         2 ATCEPT   PTR(31),       /* POINTER TO FIRST EPT ON CHAIN  *
*         2 ATCMSGP PTR(31),        /* POINTER TO TPMSG PROCESSOR     *
*         2 ATCMSGM PTR(31),        /* POINTER TO TPMSG - MESSAGE  1068
*                                      CSECT                          *
*         2 ATCTRPAB  PTR(31),      /* ADDRESS OF TRACE WRITER PAB    *
*         2 ATCVTLOD PTR(31),       /* ADDR OF VTAM LOAD LIST         *
*         2 ATCECPRT CHAR(4),       /* ECB FOR TRACE FILE PRINT       *
*         2 ATCZDVTB PTR(31),       /* ADDRESS OF ISTZCFBI            *
*         2 ATCECTLP CHAR(4),       /* TOLTEP ECB                     *
*         2 ATCRVCHS CHAR(8),       /* RESERVED                       *
*         2 ATCCRME  PTR(31),       /* VARY PSS CONTROL MECHANISM     *
*         2 ATCHPGM,                /* BUFFER INFORMATION            */
*           3 ATCHBFNO FIXED(15),   /* NUMBER OF BUFFS FOR CHANNEL   */
*           3 ATCHBSIZ FIXED(15),   /* BUFFER SIZE IN BYTES          */
*         2 ATCDEBCH PTR(31),       /* CLOSE DEB CHAIN PTR           */
*         2 ATCTODVT PTR(31),       /* THE TOLTEP DVT PTR POINTED  1068
*                                      TO BY 3RD WORD OF PAB         */
*         2 ATCADEL  PTR(31),       /* A DELETE ROUTINE ADDRESS      */
*         2 ATCCDPTR PTR(31),       /* PTR TO ISTOCCCD - DOS ONLY    */
*         2 ATCLDNCS PTR(31),       /* PTR TO NCSPL FOR LOAD/DUMP    */
*         2 ATCLDECB BIT(32),       /* ECB FOR LOAD/DUMP SUBTASK     */
*         2 ATCAPCR5 PTR(31),       /* POINTER TO ISTINCR5           */
*         2 ATCRSV69 PTR(31),       /* RESERVED TO SYNCH WITH DOS    */
*         2 ATCNODEL CHAR(8),       /* VSAM DATA SET NAME            */
*         2 ATCNODDS PTR(31),       /* POINTER TO RPL                */
*         2 ATCONFIG CHAR(8),       /* START VTAM CONFIG = PARAMETER */
*         2 ATCRSV99 CHAR(4),       /* RESERVED FOR LATER POINTERS   */
*         2 ATCAP33 PTR(31),        /* PTR TO ISTAPC33               */
*         2 ATCAP35 PTR(31),        /* PTR TO ISTAPC35               */
*         2 ATCAP36 PTR(31),        /* PTR TO ISTAPC36               */
*         2 ATCDVTLK CHAR(LENGTH(ISTLOK)), /* LOCK WORD FOR DVT LOCK */
*         2 ATCCDFIN PTR(31),       /* POINTER TO ISTSDCRR           */
*         2 ATCCDFDN PTR(31),       /* POINTER TO ISTSDCCN           */
*         2 ATCVOCLK CHAR(LENGTH(ISTLOK)), /* VOCLOCK LOCK           */
*         2 ATCRDTLK CHAR(LENGTH(ISTLOK)), /* RDTLOCK LOCK           */
*         2 ATCRSV97 PTR(31),              /* DWORD ALIGNMENT        */
*         2 ATCVPAB1 CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* PAB FOR VARY
*                                           UNDER PSS CONTROL        */
*         2 ATCPGPAB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* ERP PAB FOR
*                                      PURGE                         */
*         2 ATCDLRPB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* DUMP LOAD &
*                                           RESTART PAB              */
*         2 ATCCCLAD PTR(31),       /* ADDRESS OF VARY ERP (ISTINCCL)*/
*         2 ATCCDLAD PTR(31),       /* ADDRESS OF VARY DUMP,LD RSTRT
*                                      (ISTINCDL)                    */
*         2 ATCOCCOB PTR(31),       /* ADDRESS ISTOCCOB              */
*         2 ATCOCCCB PTR(31),       /* ADDRESS ISTOCCCB              */
*         2 ATCTIPAB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* A PAB   1068
*                                           FOR ISTOLTP              */
*         2 ATCTCIPB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* A PAB   1068
*                                           FOR TOLTEP CLIP          */
*         2 ATCVTIPB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* A PAB   1068
*                                           FOR TOLTEP-VTAM INTERFACE*/
*         2 ATCTCLOM PTR(31),      /* ADDR TOLTEP CLOP PROC          */
*         2 ATCTCLIM PTR(31),      /* ADDR TOLTEP CLIP PROC          */
*         2 ATCVTINM PTR(31),      /* ADDR TOLTEP-VTAM INTF PROC     */
*         2 ATCTACB  PTR(31),      /* TOLTEP ACB                     */
*         2 ATCRSV10 CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* RESERVED  */
*         2 ATCPTR00 CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* A PAB     */
*         2 ATCCFEAD PTR(31),          /* ADDR OF ISTINCFE           */
*         2 ATCVLCNT CHAR(4) BDY(HWORD), /* VARY DEVICE ONLINE COUNTS*/
*           3 ATCRNCNT PTR(16),        /* 370X COUNT                 */
*           3 ATCLCLCT PTR(16),        /* 3270 COUNT                 */
*         2 ATCS49XI PTR(31),          /* ADDRESS OF ISTPICXI        */
*         2 ATCS49XL PTR(31),          /* ADDRESS OF ISTPICXL        */
*         2 ATCPODVT PTR(31),          /* PTR TO PROGRAM OPERATOR DVT*/
*         2 ATCRNO,                                                1068
*           3 *        CHAR(1),                                    1068
*           3 ATCPOIA  PTR(24),        /* PTR TO PROGRAM OPERATOR    */
*                                      /* INTERFACE AREA             */
*         2 ATCSOPD CHAR(8) BDY(WORD), /* SESSION CONTROL            */
*           3 ATCSEC01 PTR(31),        /* OUTBOUND PROCESSING        */
*           3 ATCSEC10 PTR(31),        /* DVT                        */
*         2 ATCSIPD CHAR(12) BDY(WORD),/* SESSION CONTROL            */
*           3 ATCSEC21 PTR(31),        /* INBOUND PROCESSING         */
*           3 ATCSEC30 PTR(31),        /* FEEDBACK                   */
*           3 ATCSEC40 PTR(31),        /* DVT                        */
*         2 ATCSECST CHAR(4) BDY(WORD),/* SESSION CONTROLSESS TERM   */
*           3 ATCSEC51 PTR(31),        /* RECOVERY DVT               */
*         2 ATCNMCTR FIXED(15),        /* NAME COUNTER               */
*         2 ATCSTAT2 BIT(8),           /* TRACE FLAGS                */
*           3 ATCTRAPI BIT(1),         /* API                        */
*           3 ATCTRESC BIT(1),         /* ESC                        */
*           3 ATCTRPSS BIT(1),         /* PSS                        */
*           3 ATCTRLOK BIT(1),         /* LOCKS                      */
*           3 ATCTRSMS BIT(1),         /* SMS                        */
*           3 *        BIT(3),         /* RESERVED                   */
*         2 *        BIT(8),           /* RESERVED                   */
*         2 ATCSRTAB PTR(31),          /* SEARCH LOGON MODE TABLE    */
*                                      /* RTN ADDRESS (ISTINCSH)     */
*         2 ATCUSSPT PTR(31),          /* DEFAULT USS DEFINITION     */
*                                      /* TABLE ADDRESS (ISTINCDT)   */
*         2 ATCMODTB PTR(31),          /* DEFAULT SYSTEM LOGON MODE  */
*                                      /* TABLE ADDRESS (ISTINCLM)   */
*         2 ATCINCW3 PTR(31),          /* ADDRESS OF ISTINCW3        */
*         2 ATCIOECB PTR(31),          /* ECB USED BY IOS -          */
*                                      /* POINTED TO BY IOBECBPT     */
* 2 ATCVDPAB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD),                    1068
*                                    /* SSCP COMMAND PROCESSING PAB  */
* 2 ATCVFPAB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD),                    1068
*                                    /* SSCP FRONT END PAB           */
* 2 ATCVDLOK CHAR(LENGTH(ISTLOK)),   /* SSCP SERIALIZATION LOCK      */
*/* END OF COMMON AREA                                               */
*/* VS1/VS2 COMMON CODE.                                             */
*        2  ATCVTBAM CHAR(4),                                      1068
*           3  *     CHAR(3),          /* RESERVED                    *
*           3  *     CHAR(1),          /* FLAGS                       *
*              4 ATCVTMAB BIT(1) ABNL, /* ABEND IN VTAM JOBSTEP       *
*              4 *        BIT(7),      /* RESERVED                    *
*        2  ATCAOSM BDY(DWORD),                                    1068
*/*                                                                   *
*           3  ATCSRBRT PTR(31),       /* POINTER TO ROUTINE UNDER    *
*                                      /* SRB CONTROL                 *
*           3  ATCGSRBQ PTR(31),       /* READY QUEUE FOR GLOBAL SRB'S*
*              4  ATCGSRBG BIT(8),     /* READY QUEUE GATE BYTE       *
*                 5  ATCGSRBF BIT(1),  /* READY QUEUE GATE BIT        *
*           3  ATCPRPH PTR(31),        /* PTR TO PREALLOCATED RPH     *
*           3  ATCCMTCB PTR(31),       /* PTR TO COMMUNICATIONS TASK  *
*                                      /* TCB                         *
*           3  ATCAP11 PTR(31),        /* PTR TO ISTAPC11             *
*           3  ATCAP12 PTR(31),        /* PTR TO ISTAPC12             *
*           3  ATCAP31 PTR(31),        /* PTR TO ISTAPC31             *
*           3  ATCAP32 PTR(31),        /* PTR TO ISTAPC32             *
*           3  ATCAP34 PTR(31),        /* PTR TO ISTAPC34             *
*           3  ATCAP52 PTR(31),        /* PTR TO ISTAPC52             *
*           3  ATCAP53 PTR(31),        /* PTR TO ISTAPC53             *
*           3  ATCAP54 PTR(31),        /* PTR TO ISTAPC54             *
*           3  ATCAP57 PTR(31),        /* PTR TO ISTAPC57             *
*           3  ATCAP58 PTR(31),        /* PTR TO ISTAPC58             *
*           3  ATCAP61 PTR(31),        /* PTR TO ISTAPC61             *
*           3  ATCAP63 PTR(31),        /* PTR TO ISTAPC63             *
*           3  ATCAP64 PTR(31),        /* PTR TO ISTAPC64             *
*           3  ATCZFSVT PTR(31),       /* TPIOS FIXED SRVICES VCTR TAB*
*           3  ATCZPSVT PTR(31),       /* TPIOS PAGBL SRVCES VCTR TABL*
*           3  ATCICNCB PTR(31),       /* HEAD OF ICNCB QUEUE         *
*           3  ATCZDVT1 PTR(31),       /* TPIOS SLODWN RECOVRY PRCSR  *
*           3  ATCZDVT3 PTR(31),       /* 370X FEEDBACK STAT CNTRL RTR*
*           3  ATCZDVT4 PTR(31),       /* OPERATOR MESSAGE SCHEDULER  *
*           3  ATCZDVT6 PTR(31),       /* DIALOGUE SCHEDULER (INBOUND)*
*           3  ATCAP65 PTR(31),        /* PTR TO ISTAPC65            */
*           3  ATCICAPP CHAR(20) BDY(WORD), /* 3705 APPENDAGE VECTOR  *
*              4  ATCCDRPH PTR(31),    /* ADDR CLOSE DEB RPH       1068
*                                         (DUMMY EOA APP.)           */
*              4  ATCZSIOA PTR(31),    /* ADDR 3705 SIO APPENDAGE    */
*              4  ATCCDTCB PTR(31),    /* VTAM TCB (DUMMY PCI APP.)  */
*              4  ATCZCEA PTR(31),     /* ADDR 3705 CHANNEL END    1068
*                                         APPENDAGE                  */
*              4  ATCZAEA PTR(31),     /* ADDR 3705 CHANNEL END    1068
*                                         APPENDAGE                  */
*           3  ATCLDAPP CHAR(20) BDY(WORD), /* LOCAL 3270 APPENDAGE
*                                         VECTOR                     */
*              4  ATCCDTID PTR(31),    /* TASK ID OF VTAM          1068
*                                         (DUMP EOE)                 */
*              4  ATCSMFRR PTR(31),    /* ADDR OF SMS FRR          1068
*                                         (DUMMY SIOA)               */
*              4  ATCRSV17 PTR(31),    /* RESERVED FOR ALIGNMENT     */
*              4  ATCZLCEA PTR(31),    /* ADDR 3270 CHANNEL END    1068
*                                         APPENDAGE                  */
*              4  ATCZLAEA PTR(31),    /* ADDR 3270 CHANNEL END    1068
*                                         APPENDAGE                  */
*           3  ATCDAPVT CHAR(24) BDY(WORD),  /* DUMMY APPENDAGE    1068
*                                         VECTOR TABLE FOR LOAD/DVMMY*/
*              4  ATCDEOEA PTR(31),    /* ADDRESS OF DUMMY END     1068
*                                         OF EXTENT APPENDAGE        */
*              4  ATCDSIOA PTR(31),    /* ADDRESS OF DUMMY END     1068
*                                         OF SIO APPENDAGE           */
*              4  ATCDPCIA PTR(31),    /* ADDRESS OF DUMMY PCI     1068
*                                         APPENDAGE                  */
*              4  ATCDCEA PTR(31),     /* ADDRESS OF CHANNEL END   1068
*                                         APPENDAGE                  */
*              4  ATCDXCEA PTR(31),    /* ADDRESS OF ABNORMAL      1068
*                                         END APPENDAGE              */
*              4  ATCDAPDG CHAR(2),    /* DUMMY APPENDAGE            */
*              4  ATCRSV56 CHAR(2),    /* RESERVED                   */
*           3  ATCZDVT7 PTR(31),       /* ADDR OF RESET CLEANUP    1068
*                                         (PHASE 1)                   *
*           3  ATCZDVT8 PTR(31),       /* 3270 LOCAL TEST AND CTL  1068
*                                         FEEDBACK ROUTER            */
*           3  ATCZDVT9 PTR(31),       /* ADDRESS OF ISTZDFKA        */
*           3  ATCZDVTA PTR(31),       /* ADDRESS OF ISTZCFIA        */
*           3  ATCZDVTX PTR(31),       /* ADDRESS OF TRUNK LINE    1068
*                                         DEACTIVATE ROUTINE         */
*           3  ATCZLPVT PTR(31),       /* ADDRESS OF ISTZPSVA        */
*           3  ATCZLFVT PTR(31),       /* TPIOS 3270 LOCAL FIXED   1068
*                                         SERVICES VECTOR TABLE      */
*           3  ATCZPAB1 CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* PAB FOR
*                                         TEST AND CTL FEEDBACK ROUTER*
*           3  ATCZPAB2 CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* 370X 1068
*                                         STATUS AND FEEDBACK ROUTER
*                                         DYNAMIC PAB                */
*           3  ATCAP51  PTR(31),       /* PTR TO ISTAPC51            */
*           3  ATCZDFJ0 PTR(31),       /* ADDR OF ISTZDFJ0           */
*           3  ATCAP37  PTR(31),       /* PTR TO ISTAPC37            */
*           3  ATCAP38  PTR(31),       /* PTR TO ISTAPC38            */
*           3  ATCDMAPP PTR(31),       /* DUMMY APPENDAGE ROUTINE    */
*                                      /* FOR ABEND                  */
*           3  ATCRPT12 PTR(31),       /* RESERVED                   */
*        3  ATCCRA   CHAR(8) BDY(DWORD), /* AVAILABLE CRA             *
*           4 ATCCRAQ  PTR(31),          /* QUEUE OF AVAILABLE CRAS   *
*           4 ATCCRACN FIXED(31),        /* COUNTS                    *
*             5 ATCCRARC FIXED(16),      /* ENQUEUE COUNT TO ALLOW    *
*                                        /* MULTIPLE SIMUALTANIOUS    *
*                                        /* ENQUEUES AND DEQUEUES     *
*             5 ATCCRAAC FIXED(16),      /* COUNT OF CRAS ON AVAIL Q  *
*        3  ATCSRB   CHAR(8) BDY(DWORD), /* AVAILABLE SRBS            *
*             4 ATCSRBQ  PTR(31),        /* QUE OF AVAILABLE SRBS     *
*             4 ATCSRBCN FIXED(31),      /* COUNTS                    *
*               5 ATCSRBRC FIXED(16),    /* ENQUEUE COUNT TO ALLOW    *
*                                        /* MULTIPLE SIMUALTANIOUS    *
*                                        /* ENQUEUES AND DEQUEUES     *
*               5 ATCSRBAC FIXED(16),    /* COUNT OF SRBS ON AVAIL Q  *
*        3  ATCCRPL  CHAR(8) BDY(DWORD), /* AVAILABLE CRPLS           *
*             4 ATCCRPLQ PTR(31),        /* QUE OF AVAILABLE CRPLS    *
*             4 ATCRPLCN FIXED(31),      /* COUNTS                    *
*               5 ATCRPLRC FIXED(16),    /* ENQUEUE COUNT TO ALLOW    *
*                                        /* MULTIPLE SIMUALTANIOUS    *
*                                        /* ENQUEUES AND DEQUEUES     *
*               5 ATCRPLAC FIXED(16),    /* COUNT OF CRPLS ON AVAIL Q *
*           3  ATCRPT19 PTR(31),       /* RESERVED                   */
*           3  ATCRPT20 PTR(31),       /* RESERVED                   */
*           3  ATCRPT21 PTR(31),       /* RESERVED                   */
*           3  ATCRPT22 PTR(31),       /* RESERVED                   */
*           3  ATCRPT23 PTR(31),       /* RESERVED                   */
*           3  ATCRPT24 PTR(31),       /* RESERVED                   */
*           3  ATCRPT25 PTR(31),       /* RESERVED                   */
*           3  ATCRPT26 PTR(31),       /* RESERVED                   */
*           3  ATCRPT27 PTR(31),       /* RESERVED                   */
*           3  ATCRPT28 PTR(31),       /* RESERVED                   */
*           3  ATCRPT29 PTR(31),       /* RESERVED                   */
*           3  ATCRPT30 PTR(31),       /* RESERVED                   */
*           3  ATCRPT31 PTR(31),       /* RESERVED                   */
*           3  ATCRPT32 PTR(31),       /* RESERVED                   */
*           3  ATCRPT33 PTR(31),       /* RESERVED                   */
*           3  ATCRPT34 PTR(31),       /* RESERVED                   */
*           3  ATCRPT35 PTR(31),       /* RESERVED                   */
*           3  ATCRPT36 PTR(31),       /* RESERVED                   */
*           3  ATCRPT37 PTR(31),       /* RESERVED                   */
*           3  ATCRPT38 PTR(31),       /* RESERVED                   */
*           3  ATCRPT39 PTR(31),       /* RESERVED                   */
*           3  ATCRPT40 PTR(31),       /* RESERVED                   */
*/* END OF VS1/VS2 COMMON CODE.                                      */
*/* START OF VS2 UNIQUE CODE.                                        */
*           3  ATCVTFLG BIT(32),                                   1068
*              4 ATCVTACT BIT(1),      /* VTT ACTIVE                 */
*              4 *        BIT(31),     /* RESERVED                   */
*           3  ATCHLTCB PTR(31),       /* ECB FOR HALTING VTAM       */
*           3  ATCATA10 PTR(31),       /* PTR TO ISTATM10            */
*           3  ATCZLAAB PTR(31),       /* PTR TO ISTZLFAB            */
*           3  ATCCACXA PTR(31),       /* PTR TO ISTCFCXA            */
*           3  ATCSMARA PTR(31),       /* PTR TO ISTORFRA            */
*           3  ATCSMAID PTR(31),       /* PTR TO ISTORFID            */
*           3  ATCTPWQA PTR(31),       /* WAIT Q ANCHOR FOR TPIOS    */
*           3  ATCSMAPR PTR(31),       /* PTR TO ISTORFPR            */
*           3  ATCSMABF PTR(31),       /* PTR TO ISTORFBF            */
*           3  ATCPSTA  PTR(31),       /* ACTIVE PST QUEUE           */
*           3  ATCAPBE  PTR(31),       /* POINTER TO ISTAICBE        */
*           3  ATCTRMPB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD),         1068
*                                      /* PAB FOR VTAM TERM TASK     */
*           3  ATCTPSPB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD),         1068
*                                      /* PAB FOR TPIOS              */
*           3  ATCAP23  PTR(31),       /* PTR TO ISTAPC23            */
*           3  ATCAPC25 PTR(31),       /* PTR TO ISTAPC25            */
*           3  ATCAP41  PTR(31),       /* PTR TO ISTAPC41            */
*           3  ATCRCFY0 PTR(31),       /* PTR TO ISTRCFY0            */
*           3  ATCAP55  PTR(31),       /* PTR TO ISTAPC55            */
*           3  ATCAP56  PTR(31),       /* PTR TO ISTAPC56            */
*           3  ATCAPC59 PTR(31),       /* PTR TO ISTAPC59            */
*           3  ATCAP62  PTR(31),       /* PTR TO ISTAPC62            */
*           3  ATCAP66  PTR(31),       /* PTR TO ISTAPC66            */
*           3  ATCAP69  PTR(31),       /* PTR TO ISTAPM69            */
*           3  ATCAP82  PTR(31),       /* PTR TO ISTAPC82            */
*           3  ATCAP83  PTR(31),       /* PTR TO ISTAPC83            */
*           3  ATCAP84  PTR(31),       /* PTR TO ISTAPC84            */
*           3  ATCAP85  PTR(31),       /* PTR TO ISTAPC85            */
*           3  ATCAP86  PTR(31),       /* PTR TO ISTAPC86            */
*           3  ATCASCB  PTR(31),       /* PTR TO VTAM ASCB           */
*           3  ATCMPLTA  PTR(31),      /* PTR TO MPST LIST TABLE     */
*           3  ATCZR01  PTR(31),       /* PTR TO ISTZRM01            */
*           3  ATCAICTN PTR(31),       /* PTR TO ISTAICTN            */
*           3  ATCTPCP0 PTR(31),       /* PTR TO ISTZFSAV            */
*           3  ATCTPCP1 PTR(31),       /* PTR TO ISTZ19SV            */
*           3  ATCZFLAG BIT(8),        /* FLAG BYTE                  */
*              4 ATCZF001 BIT(1),      /* MDR RECORDING SUSPENDED    */
*              4 ATCRSV66 BIT(7),      /* RESERVED                   */
*           3  ATCRSV75 BIT(8),        /* RESERVED                   */
*           3  ATCSRBCT FIXED(16),     /* COUNT OF PREALLOCATED SRB'S*/
*           3  ATCCRACT FIXED(16),     /* COUNT OF PREALLOCATED CRA'S*/
*           3  ATCRPLCT FIXED(16),     /* COUNT OF PREALLOCATED CRPL */
*           3  ATCRSV88 PTR(31),       /* RESERVED                   */
*           3  ATCTPMPB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /*TP MSG PAB
*                                                         FOR VS2    */
*           3  ATCTPMMI PTR(31),        /* PTR TO ISTCFMMI - MSG ISSUER
*                                          FOR SRB MODE ROUTINES     */
*           3  ATCVIOPM PTR(31),       /* PTR TO ISTVIOPM            */
*           3  ATCPOPAB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD),         1068
*                   /* POPAB FOR REPLY PROCESSING, POI TERMINATION,  */
*                   /* AND VTAM MESSAGE PROCESSOR                    */
*        2  ATCAOS CHAR(0) BDY(WORD);  /* VS2 ONLY FIELDS            */
*/*   DEVICE CHARACTERISTICS TABLE - ORIGINATES IN RDT USED TO DEFINE
*    DEVICE CHARACTERISTICS IN DNCB,FMCB AND NIB  */               1069
*/*  INITIAL LEVEL                                     001 08/07/74  */
*DCL  1  ISTDEVCH  BDY(WORD)BASED,                                 1069
*        2  DEVSHCH BIT(8),            /* DEV SCHED CHARACTERISTICS  */
*           3  DEVCHAR  BIT(8),        /* COMPATIBILITY EXISTING CODE*/
*              4  DEVINPUT  BIT(1),    /* DEVICE IS FOR INPUT        */
*              4  DEVOTPUT  BIT(1),    /* DEVICE IS FOR OUTPUT       */
*              4  DEVCONVR  BIT(1),    /* DEVICE IS CONVERSATION     */
*                                      /* RN DEFINITION              */
*              4  DEVSUBND  BIT(1),    /* DEVICE HAS SCHEDULABLE     */
*                                      /*   SUB-NODES                */
*              4  DEVSPS BIT(1),       /* DEV IS START PRINT SENSITIVE*
*              4  DEVNNSPT BIT(1),     /* NODE HAS NETWRK MNGMNT SPRT*/
*              4  DEVCCTL BIT(1),      /* NODE HAS CONN CNTRL DEPENDCS*
*              4  DEVRSV01  BIT(1),    /* RESERVED                   */
*        2  DEVTCODE BIT(8),           /* DEVICE TYPE CODES          */
*           3  DEVCHAR2  BIT(8),       /* COMPATIBILITY EXISTING CODE*/
*        2  DEVMCODE BIT(8),           /* DEVICE MODEL CODE           *
*        2  DEVFLAGS BIT(8),           /*USE DEPENDS ON DEVSHCH VALUES*
*           3  DEVFCCTL BIT(4),        /* USED IF DEVICE REQ CONN CTRL*
*              4  DEVCBSC BIT(1),      /* RESET ORDERLY, BI-SYNCH  1069
*                                         TERMINALS EXCEPT 3270'S    */
*              4  DEVCSSL BIT(1),      /*RESET AT END OF COMMAND. 3270'
*                                         AND START/STOP EXCEPT TERMS
*                                         WITH REVERSE BREAK FEATURE */
*                                                                  1069
*              4  DEVCRVB BIT(1),      /* RESET IMMEDIATE. START/STOP
*                                         TERMS WITH REVERSE BREAK 1069
*                                         FEATURE                    */
*              4  DEVCSWL BIT(1),      /* 1=HIGHER NODE IS SWITCH CON-
*                                         NECTION, 0=LEASED CONNECTION*
*           3  DEVCHAR3 BIT(4),        /* COMPATIBILITY EXISTING CODE*/
*              4  DEVCATTN BIT(1),     /* TERMINAL CAN INTERRUPT WITH
*                                         ATTENTION                  */
*              4  DEVCCHEK BIT(1),     /* TERMINAL HAS CHECKING      */
*              4  DEVCSTCL BIT(1),     /* TERMINAL HAS STATION     1069
*                                         CONTROL                    */
*              4  DEVCSLPN BIT(1),     /* TERMINAL HAS SELECTOR PEN  */
*        2  DEVPHYSA CHAR(1),          /* PHYSICAL DEVICE ADDRESS    */
*        2  DEVRSV03 CHAR(3);          /* RESERVED                   */
*/* DEVICE TYPE CODES */                                           1070
*DCL DEV2740 BIT(8) CONSTANT ('01'X);  /* DEVICE IS A 2740           */
*DCL DEV2741 BIT(8) CONSTANT ('02'X);  /* DEVICE IS A 2741           */
*DCL DEV1050 BIT(8) CONSTANT ('03'X);  /* DEVICE IS A 1050           */
*DCL DEVTWX  BIT(8) CONSTANT ('04'X);  /* DEVICE IS A TWX            */
*DCL DEVWTTY BIT(8) CONSTANT ('05'X);  /* DEVICE IS A WTTY           */
*DCL DEV115A BIT(8) CONSTANT ('06'X);  /* DEVICE IS A 115A           */
*DCL DEV83B3 BIT(8) CONSTANT ('07'X);  /* DEVICE IS AN 83B3          */
*DCL DEV2715 BIT(8) CONSTANT ('08'X);  /* DEVICE IS A 2715           */
*DCL DEV2770 BIT(8) CONSTANT ('09'X);  /* DEVICE IS A 2770           */
*DCL DEV2780 BIT(8) CONSTANT ('0A'X);  /* DEVICE IS A 2780           */
*DCL DEV3735 BIT(8) CONSTANT ('0B'X);  /* DEVICE IS A 3735           */
*DCL DEV3780 BIT(8) CONSTANT ('0C'X);  /* DEVICE IS A 3780           */
*DCL DEV1130 BIT(8) CONSTANT ('0D'X);  /* DEVICE IS AN 1130          */
*DCL DEV1800 BIT(8) CONSTANT ('0E'X);  /* DEVICE IS AN 1800          */
*DCL DEV3125 BIT(8) CONSTANT ('11'X);  /* DEVICE IS A 3125           */
*DCL DEV3135 BIT(8) CONSTANT ('12'X);  /* DEVICE IS A 3135           */
*DCL DEVSYS3 BIT(8) CONSTANT ('13'X);  /* DEVICE IS SYS 3            */
*DCL DEV2701 BIT(8) CONSTANT ('14'X);  /* DEVICE IS A 2701 OZ05270   */
*DCL DEV2703 BIT(8) CONSTANT ('15'X);  /* DEVICE IS A 2703 OZ05270   */
*DCL DEV3704 BIT(8) CONSTANT ('16'X);  /* DEVICE IS A 3704           */
*DCL DEV3705 BIT(8) CONSTANT ('17'X);  /* DEVICE IS A 3705           */
*DCL DEV2980 BIT(8) CONSTANT ('18'X);  /* DEVICE IS A 2980           */
*DCL DEV3277 BIT(8) CONSTANT ('19'X);  /* DEVICE IS A 3277           */
*DCL DEV3284 BIT(8) CONSTANT ('1A'X);  /* DEVICE IS A 3284           */
*DCL DEV3286 BIT(8) CONSTANT ('1B'X);  /* DEVICE IS A 3286           */
*DCL DEV3275 BIT(8) CONSTANT ('1C'X);  /* DEVICE IS A 3275           */
*DCL DEV3741 BIT(8) CONSTANT ('1D'X);  /* DEVICE IS A 3741           */
*DCL DEV3747 BIT(8) CONSTANT ('1E'X);  /* DEVICE IS A 3747           */
*DCL DEVMTA  BIT(8) CONSTANT ('28'X);  /* DEVICE IS AN MTA           */
*DCL DEV2972 BIT(8) CONSTANT ('33'X);  /* DEVICE IS A 2972           */
*DCL DEV3271 BIT(8) CONSTANT ('34'X);  /* DEVICE IS A 3271           */
*DCL DEV3272 BIT(8) CONSTANT ('36'X);  /* DEVICE IS A 3272           */
*DCL DEVCC   BIT(8) CONSTANT ('35'X);  /* DEVICE IS A PHYSICAL UNIT  */
*DCL DEV1052 BIT(8) CONSTANT ('64'X);  /* DEVICE IS A 1052           */
*DCL DEV1053 BIT(8) CONSTANT ('65'X);  /* DEVICE IS A 1053           */
*DCL DEV1054 BIT(8) CONSTANT ('66'X);  /* DEVICE IS A 1054           */
*DCL DEV1055 BIT(8) CONSTANT ('67'X);  /* DEVICE IS A 1055           */
*DCL DEV1056 BIT(8) CONSTANT ('68'X);  /* DEVICE IS A 1056           */
*DCL DEV1057 BIT(8) CONSTANT ('69'X);  /* DEVICE IS A 1057           */
*DCL DEV1058 BIT(8) CONSTANT ('6A'X);  /* DEVICE IS A 1058           */
*DCL DEV1092 BIT(8) CONSTANT ('6B'X);  /* DEVICE IS A 1092           */
*DCL DEV1093 BIT(8) CONSTANT ('6C'X);  /* DEVICE IS A 1093           */
*DCL DEVLU   BIT(8) CONSTANT ('6D'X);  /* DEVICE IS A LOGICAL UNIT   */
*DCL DEV545  BIT(8) CONSTANT ('78'X);  /* DEVICE IS A 545            */
*DCL DEV1017 BIT(8) CONSTANT ('79'X);  /* DEVICE IS A 1017           */
*DCL DEV1018 BIT(8) CONSTANT ('7A'X);  /* DEVICE IS A 1018           */
*DCL DEV2203 BIT(8) CONSTANT ('7B'X);  /* DEVICE IS A 2203           */
*DCL DEV2213 BIT(8) CONSTANT ('7C'X);  /* DEVICE IS A 2213           */
*DCL DEV2265 BIT(8) CONSTANT ('7D'X);  /* DEVICE IS A 2265           */
*DCL DEV2502 BIT(8) CONSTANT ('7E'X);  /* DEVICE IS A 2502           */
*DCL DEV50   BIT(8) CONSTANT ('7F'X);  /* DEVICE IS A 50             */
*DCL DEV1255 BIT(8) CONSTANT ('80'X);  /* DEVICE IS A 1255           */
*DCL DEV5496 BIT(8) CONSTANT ('81'X);  /* DEVICE IS A 5496           */
*/* MODEL CODES */                                                 1123
*DCL DEVMOD1 BIT(8) CONSTANT ('00'X);  /* MODEL 1                    */
*DCL DEVMOD2 BIT(8) CONSTANT ('01'X);  /* MODEL 2                    */
*/* PARAMETER FOR ALOAD */                                         1125
*DCL  LDPRMPTR PTR(31) REGISTER(1) RESTRICTED;                     1125
*DCL  1  ISTLDPRM BDY(WORD) BASED(LDPRMPTR),                       1126
*        2  LDPMBR  CHAR(8),           /* MODULE NAME                */
*        2  LDPPDS  CHAR(8),           /* LIBRARY NAME               */
*        2  LDPDCBA PTR(31),           /* DCB POINTER                */
*        2  LDPFG   CHAR(1),           /* LOAD PARAMETER LIST FLAG 1126
*                                         BYTE                       */
*          3  LDPFX  BIT(1),           /* FLAG TO FIX LOADED CODE  1126
*                                                                    */
*          3  LDPPB  BIT(1),           /* FLAG TO LOAD CODE ON 2K BDY
*                                                                    */
*          3  LDPRSV03  BIT(6),        /* RESERVED                   */
*        2  LDPFB2  CHAR(1),           /* LOAD FLAG BYTE 2 (USED   1126
*                                         BY ATTACH)                 */
*         3  LDPFLAST BIT(1),          /* LAST ENTRY IN LIST         */
*         3  LDPATACH BIT(1),          /* ATTACH THIS ROUTINE AFTER
*                                         LOADING IT                 */
*         3  LDPACTIF BIT(1),          /* THIS TASK IS ATTACHED      */
*         3  LDPRSV01 BIT(5),          /* RESERVED                   */
*        2  LDPRSV02 CHAR(2),          /* RESERVED                   */
*        2  LDPTCEP PTR(31);           /* TCB OF ATTACHED ROUTINE    */
*/*              RESOURCE DEFINITION TABLE                           */
*/*  REVISIONS                                         013 07/01/75  */
*DCL                                                               1127
*1  ISTRPRE BDY(WORD) BASED,     /* COMMON PREFIX                    */
*   2  RPRNAME  CHAR(8),         /* RESOURCE NAME                    */
*   2  RPRCOMID FIXED(31),       /* COMMUNICATION ID                 */
*      3  RPRSAF BIT(16),        /* SOURCE ADDRESS FIELD             */
*      3  RPRDAF BIT(16),        /* DESTINATION ADDRESS FIELD-       */
*                             /* CONTAINS DAF OF CTERM IN PORT ENTRY */
*   2  RPRRLOCK CHAR(LENGTH(ISTLOK)),  /* RESOURCE LOCK              */
*   2  RPRELEN  FIXED(15),       /* CURRENT ENTRY LENGTH             */
*   2  RPRPELEN FIXED(15),       /* PREVIOUS ENTRY LENGTH            */
*   2  RPRENTRY BIT(8),          /* FLAG FIELD 1 (ENTRY TYPE)        */
*   2  RPRFLAGA BIT(8),                                            1127
*      3  RPRACT BIT(1),         /* ACTIVE                           */
*      3  RPRINV BIT(1),         /* INVALID                          */
*      3  RPRTIED BIT(1),        /* TIED                             */
*      3  RPRENTBF BIT(1),       /* BUFFER TRACE THIS NODE           */
*      3  RPRENTIO BIT(1),       /* RESERVED                         */
*      3  RPRENTED BIT(1),       /* LAST ENTRY IN RDT SEGMENT        */
*      3  RPRVRYPD BIT(1),       /* VARY PENDING ON ENTRY            */
*      3  RPRLIVE  BIT(1),       /* RESOURCE IS LIVE                 */
*   2  RPRFLAGB BIT(8),          /* FLAG FIELD                       */
*      3  RPRENTVH BIT(1),       /* WHEN 1, ENTRY IS A VTAM HEADER   */
*      3  RPRENTVT BIT(1),       /* WHEN 1, ENTRY IS VTAM            */
*      3  RPRAOPN BIT(1),        /* NODE OPENABLE BY APPLICATION     */
*      3  RPRVIODN BIT(1),       /* VARY I/O HAS BEEN DONE           */
*      3  RPRONLIN BIT(1),       /* NODE VARIED ONLINE               */
*      3  RPRHLVPD BIT(1),       /* VARY PENDING IN HIGHEST        1127
*                                   LEVEL NODE                       */
*      3  RPRVYIMM BIT(1),       /* VARY IMMEDAITE ISSUED FOR NODE   */
*      3  RPRINTST BIT(1),       /* DEVICE IN TEST MODE              */
*   2  RPRCAUSE BIT(8),          /* FLAGS INDICATING CAUSE OF ENTRY
*                                                      INVALIDATION  */
*      3  RPRNOSRT BIT(1),       /* RPRINV SET BECAUSE NO SRTE BUILT */
*      3  RPRCRCPT BIT(1),       /* C/R CHECKPOINT ACTIVE 1=ACTIVE   */
*      3  RPRRSYNC BIT(1),       /* C/R RE-SYNC ON FIRST I/O         */
*                                /* REQUIRED: 1=YES                  */
*      3  RPRRSV03 BIT(5),       /* RESERVED                         */
*   2  RPRPEPCT FIXED(15),       /* VARY PENDING COUNTER             */
*   2  RPRTIOCT FIXED(8),        /* I/O TRACE COUNT                  */
*   2  RPRHDTYP BIT(8),          /* HEADER TYPE                      */
*   2  RPRLGONF PTR(31),         /* SIM. LOGON CHAIN FORWARD PTR     */
*   2  RPRLGONB PTR(31),         /* SIM. LOGON CHAIN BACKWARD PTR    */
*   2  RPRNSNEA PTR(31),         /* NEXT SCHEDULABLE NODE ENTRY ADDR */
*   2  RPRNCBA PTR(31),          /* ADDR OF ASSOCIATED NCB FOR     1127
*                                    OPENED NODES                    */
*   2  RPRDEVCH CHAR(LENGTH(ISTDEVCH)),  /* DEVICE CHARACTERISTICS   */
*   2  RPRRVPT1 PTR(31),         /* RESERVED                         */
*   2  RPRSTPCT FIXED(15),       /* COUNT OF SHOULDER TAPS           */
*   2  RPRSWDAF BIT(16),         /* SWITCHED DAF                     */
*   2  RPRPTHCT FIXED(8),        /* COUNT OF AVAILABLE PATHS       1127
*                                   TO THIS DEVICE                   */
*   2  RPRFLAGD CHAR(1),         /* FLAG BYTE                        */
*      3 RPRLTASN BIT(1),        /* LINE TRACE ACTIVE = 1            */
*      3 RPRCONCT BIT(1),        /* PHYSICAL CONNECTION EXISTS       */
*      3 RPRRSON  BIT(1),        /* RESET ONLINE                     */
*      3 RPRACTP  BIT(1),        /* ACTIVATE IN PROGRESS             */
*      3 RPRCONP  BIT(1),        /* CONTACT IN PROGRESS              */
*      3 RPRRSV05 BIT(2),        /* RESERVED                         */
*      3 RPRINIMM BIT(1),        /* ON=INACTIVATE IMMED. IN PROGRESS */
*   2  RPRFLAGC BIT(8),          /* FLAG FIELD                       */
*      3  RPRCLVPD BIT(1),       /* THIS ENTRY HAS BEEN CLOSED       */
*   2  RPRCONID CHAR(9);         /* CONTROL BLOCK ID                 */
*                                                                  1127
*                                                                  1127
*/* RPRENTRY - FOLLOWING EQUATES ARE FOR THE VARIOUS ENTRY TYPES     */
*DCL RPRENTCM BIT(8) CONSTANT('90'X);  /* ENTRY IS A COMPONENT       */
*DCL RPRENTIN BIT(8) CONSTANT('82'X);  /* ENTRY IS INTERMEDIATE NODE */
*DCL RPRENTTR BIT(8) CONSTANT('80'X);  /* ENTRY IS A TERMINAL        */
*DCL RPRENTUT BIT(8) CONSTANT('75'X);  /* ENTRY IS UTERM             */
*DCL RPRENTCL BIT(8) CONSTANT('70'X);  /* ENTRY IS A CLUSTER         */
*DCL RPRENTLN BIT(8) CONSTANT('50'X);  /* ENTRY IS A LINE            */
*DCL RPRENTLH BIT(8) CONSTANT('03'X);  /* ENTRY IS A LOCAL HEADER    */
*DCL RPRENTGP BIT(8) CONSTANT('30'X);  /* ENTRY IS A GROUP           */
*DCL RPRENTLC BIT(8) CONSTANT('45'X);  /* ENTRY IS A LOCAL DEVICE    */
*DCL RPRENTAH BIT(8) CONSTANT('02'X);  /* ENTRY IS APPLICATION HEADER*/
*DCL RPRENTAP BIT(8) CONSTANT('55'X);  /* ENTRY IS APPLICATION       */
*DCL RPRENTDS BIT(8) CONSTANT('20'X);  /* ENTRY IS LCDO            1139
*                                         (DIALSET)                  */
*DCL RPRENTRN BIT(8) CONSTANT('01'X);  /* ENTRY IS THE RN            */
*DCL RPRENTCC BIT(8) CONSTANT('71'X);  /* ENTRY IS A PU              */
*DCL RPRENTLU BIT(8) CONSTANT('81'X);  /* ENTRY IS LOGICAL UNIT      */
*DCL RPRENTSW BIT(8) CONSTANT('04'X);  /* ENTRY IS SWITCHED          */
*                                      /* SUBAREA HEADER             */
*DCL RPRENTLS BIT(8) CONSTANT('05'X);  /* ENTRY IS LOCAL             */
*                                      /* SUBAREA HEADER             */
*DCL RPRENTPX BIT(8) CONSTANT('72'X);  /* ENTRY IS A PUX             */
*DCL RPRENTLX BIT(8) CONSTANT('10'X);  /* ENTRY IS A LUX             */
*DCL RPRENTDA BIT(8) CONSTANT('51'X);  /* ENTRY IS A DAN             */
*                                                                  1147
*                                                                  1147
*/* THE FOLLOWING IS A PREFIX FOR ALOCATION ENTRIES                  */
*/*   ISTRCL-CLUSTER,ISTRTR-TERMINAL,ISTRCM-COMPONENT                */
*                                                                  1148
*DCL                                                               1148
*1  ISTRCPRE BDY(WORD) BASED,    /* LEVEL 1 DECLARE                  */
*   2  RCPPRE  CHAR(LENGTH(ISTRPRE)),      /* COMMON PREFIX          */
*   2  RCPICELN PTR(31),         /* PTR LOGON ICE QUEUE              */
*   2  RCPLNAPA PTR(31),         /* PTR APLICATION ENTRY FOR SIMLOGON*/
*   2  RCPICEAQ PTR(31),         /* PTR ACQUIRE ICE QUEUE            */
*   2  RCPACETR PTR(31),         /* PTR ACE QUEUE                    */
*   2  RCPBHSI1 CHAR(1),         /* GEN'D BHSET ID                   */
*   2  RCPBHSI2 CHAR(1),         /* OVERRIDING BHSET ID SPECIFIED  1148
*                                   BY USER                          */
*   2  RCPBFLIM PTR(8),          /* BUFFER LIMIT                     */
*   2  RCPPMODE CHAR(1),         /* PERMISSABLE MODES                */
*      3 RCPRBASC BIT(1),        /* 1= BASIC OK                      */
*      3 RCPRRECD BIT(1),        /* 1= RECORD OK                     */
*      3 *        BIT(6),        /* RESERVED                         */
*   2  RCPLGNIN CHAR(20) BDY(WORD), /* INIT LOGON DATA               */
*      3 RCPLGNAP CHAR(8),       /* APPL FOR VTAM SIMLOGON           */
*      3 RCPLGNCT CHAR(8),       /* NAME OF LOGON CHAR TABLE         */
*      3 RCPINTA  PTR(31),       /* ADDR OF INTERPRET TABLE          */
*   2  RCPRSV03 PTR(31),         /* RESERVED FOR C/R                 */
*   2  RCPRSV04 PTR(31),         /* RESERVED FOR C/R                 */
*   2  RCPRSV05 PTR(31);         /* RESERVED FOR C/R                 */
*                                                                  1148
*                                                                  1148
*DCL                                                               1149
*1  ISTRDT BDY(WORD) BASED,      /* LEVEL 1 DECLARE                  */
*   2  RDTPRE CHAR(LENGTH(ISTRPRE)), /* ENTRY PREFIX                 */
*   2  RDTPLEN CHAR(4)BDY(WORD), /* PRIORITY AND LENGTH FIELD        */
*      3  RDTPRIOR,              /* DETERMINES SEGMENT TYPE          */
*         4  * BIT(3),           /*    NOT USED                      */
*         4  RDTPRIAP BIT(1),    /*    APPLICATION SEGMENT           */
*         4  RDTPRILC BIT(1),    /*    LOCAL SEGMENT                 */
*         4  RDTPRIRN BIT(1),    /*    RN SEGMENT                    */
*         4  RDTPRISW BIT(1),    /*    SWITCHED SEGMENT              */
*         4  RDTPRILS BIT(1),    /*    LOCAL SUBAREA SEGMENT         */
*      3  RDTLEN FIXED(24),      /* LENGTH OF RDT                    */
*   2  RDTFORW PTR(31),          /* FOREWARD POINTER                 */
*   2  RDTBACK PTR(31),          /* BACKWARD POINTER                 */
*   2  RDTFLAGS BIT(16),         /* SEGMENT FLAGS,UNUSED/REUSED      */
*   2  RDTCTSNT FIXED(15),       /* COUNT OF SNT ENTRIES FOR       1149
*                                   SEGMENT                          */
*   2  RDTMAXID PTR(8),          /* MAXIMUM NODE ID FOR            1149
*                                   NETWORK                          */
*   2  RDTNODID PTR(8),          /* NODE ID FOR THIS SEGMENT         */
*   2  RDTLGCT  PTR(8),          /* COUNT OF LOGONS OUTSTANDING      */
*   2  RDTFLAGB BIT(8),          /* FLAG BYTE                        */
*      3 RDTOUERP BIT(1),        /* 1 = REPEAT ERP                   */
*      3 RDTPRGDN BIT(1),        /* 1 = PURGE ISSUED                 */
*      3 RDTCTPGD BIT(1),        /* 1 = CONTACT PURGED               */
*      3 RDTCTCFL BIT(1),        /* HIGHER FAILURE-CONTACT FLUSHED   */
*      3 RDTBHSET BIT(1),        /* BHSET REQUIRED                   */
*      3 RDTRSV01 BIT(3),        /* RESERVED                         */
*   2  RDTVPAB  PTR(31),         /* ADDR OF VARY PAB                 */
*   2  RDTEPAB  PTR(31),         /* ADDR OF ERP PAB                  */
*   2  RDTDPAB  PTR(31),         /* ADDR OF DUMP/LOAD/RESTART PAB    */
*   2  RDTTPAB  PTR(31),         /* TOLTEP SSCP PAB                  */
*   2  RDTVYRPH PTR(31),         /* @ OF VARY RPH WAITING            */
*                                /* FOR RESTART COMPLETION           */
*      3 RRNVYRPH PTR(31),       /* DELETE ALIAS IN NEXT             */
*                                /* FIRST SNA/2 BUILD                */
*   2  RDTSTCNT PTR(8),          /* ACTIVE SUBNODE COUNT             */
*      3 RRNSTCNT PTR(8),        /* DELETE ALIAS IN NEXT             */
*                                /* FIRST SNA/2 BUILD                */
*   2  *        CHAR(3),         /* RESERVED                         */
*   2  RDTCRSDS CHAR(8),         /* C/R DATA SET IDENTIFIER          */
*                                /* BLANK IMPLIES NOT SPECIFIED      */
*   2  RDTCRSPW CHAR(8),         /* C/R DATASET PASSWORD             */
*                                /* BLANK IMPLIES NOT SPECIFIED      */
*   2  RDTVSRPL PTR(31);         /* C/R PTR TO VSAM RPL              */
*                                                                  1149
*                                                                  1149
*DCL                                                               1150
*1  ISTRAP BDY(WORD) BASED,      /* APPLICATION ENTRY                */
*   2  RAPPRE CHAR(LENGTH(ISTRPRE)), /*  USE ISTRPRE DSECT           */
*   2  RAPACBA PTR(31),          /*   POINTER TO ACB                 */
*   2  RAPACDEB PTR(31),         /*  POINTER TO ACBDEB               */
*   2  RAPAPPWD CHAR(8),         /* APPLICATION PASSWORD             */
*   2  RAPICELG PTR(31),         /* ANCHOR FOR LOGON ICE TO APLICATION*
*   2  RAPICEAC PTR(31),         /* ANCHOR ACEPT ICE FOR APPLICATION */
*   2  RAPICEAQ PTR(31),         /*  ANCHOR ACQUIRE ICE BY APPLI     */
*   2  RAPACEAP PTR(31),         /* ANCHOR FOR APPLICATION ACES      */
*   2  RAPTRPRE FIXED(15),       /* COUNT OF PREMPTED TERMINALS      */
*   2  RAPACEQD FIXED(15),       /* COUNT OF ACES QUEUED             */
*   2  RAPFLG BIT(8),            /*  FLAG FIELD                      */
*      3 RAPABLGN BIT(1),        /*  PERMANENTLY BLOCK LOGONS BIT    */
*      3 RAPAQUI BIT(1),         /* QUIESCE IN PROCESS               */
*      3 RAPASLGI BIT(1),        /*  APPLICATION FIRST TIME LOGON  1150
*                                    ISSUED FLAG                     */
*      3 RAPATLGN BIT(1),        /*  TEMPORARILY BLOCK LOGONS BIT    */
*      3 RAPRSV03 BIT(1),        /*  RESERVED                        */
*      3 RAPRSV04 BIT(1),        /*  RESERVED                        */
*      3 RAPRSV05 BIT(1),        /*  RESERVED                        */
*      3 RAPRSV06 BIT(1),        /*  RESERVED                        */
*   2  RAPFLGB BIT(8),           /* AUTHORIZATION FLAGS              */
*      3 RAPALLF BIT(1),         /* ALL FUNCTIONS AUTH.              */
*      3 RAPABLCK BIT(1),        /* BLOCK I/O AUTH.                  */
*      3 RAPAPASS BIT(1),        /* PASS AUTH.                       */
*      3 RAPAPRMT BIT(1),        /* PREEMPT AUTH.                    */
*      3 RAPAACQ BIT(1),         /* ACQUIRE AUTH.                    */
*      3 RAPAPPO  BIT(1),        /* RNO PPO (PRIMARY PROGRAM AUTH    */
*      3 RAPASPO  BIT(1),        /* RNO SPO (SECONDARY PROGRAM AUTH  */
*      3 RAPANVPC BIT(1),        /* NO VSPACE AUTHORIZED             */
*   2  RAPFLGC BIT(8),           /* AUTHORIZATION FLAGS RESERVED     */
*      3 RAPRSV10 BIT(1),        /*  RESERVED                        */
*      3 RAPRSV11 BIT(1),        /*  RESERVED                        */
*      3 RAPRSV12 BIT(1),        /*  RESERVED                        */
*      3 RAPRSV13 BIT(1),        /*  RESERVED                        */
*      3 RAPRSV14 BIT(1),        /*  RESERVED                        */
*      3 RAPRSV15 BIT(1),        /*  RESERVED                        */
*      3 RAPRSV16 BIT(1),        /*  RESERVED                        */
*      3 RAPRSV17 BIT(1),        /*  RESERVED                        */
*   2  RAPBFACT PTR(8),          /* BUFFER LIMIT FACTOR              */
*   2  RAPRVPT1 PTR(31),         /*  RESERVED                        */
*   2  RAPRVPT2 PTR(31);         /*  RESERVED                        */
*                                                                  1150
*                                                                  1150
*DCL                                                               1151
*1  ISTRLC BDY(WORD) BASED,      /* LOCAL ENTRY                      */
*   2  RLCPRE CHAR(LENGTH(ISTRPRE)),  /* COMMON PREFIX               */
*   2  RLCADR PTR(31),                                             1151
*      3  RLCFLAG BIT(8),        /* FLAG BYTE                        */
*         4  RLCRSV22 BIT(1),    /* RESERVED                         */
*         4  RLCRBISA BIT(1),    /* INITIAL STATUS - 1 = ACTIVE      */
*         4  RLCRSV14 BIT(3),    /* UNUSED/RESERVED                  */
*         4  RLCACNT BIT(1),     /* MESSAGE BLOCK ACCEPTED           */
*         4  RLCRSVDE BIT(2),    /* RESERVED                         */
*      3  RLCUCBAD PTR(24),      /* UCB /PUB ADDRESS                 */
*   2 RLCLCCUA CHAR(3),          /* DEVICE CHANNEL UNIT ADDR         */
*   2 RLCRVPT1 CHAR(1),          /* RESERVED                         */
*   2 RLCRVPT2 PTR(31);          /* RESERVED                         */
*                                                                  1151
*                                                                  1151
*DCL                                                               1152
*1  ISTRRN BDY(WORD) BASED,      /* RN ENTRY                         */
*   2  RRNPRE CHAR(LENGTH(ISTRDT)),  /*  USE ISTRDT DSECT            */
*   2  RRNADR PTR(31),                                             1152
*      3  RRNFLAG BIT(8),                                          1152
*         4  RRNRSV89 BIT(1),    /* RESERVED                         */
*         4  RRNRBISA BIT(1),    /* INITIAL STATUS 1 = ACTIVE        */
*         4  RRNLCSIP BIT(1),    /* NODE BEING ACTIVATED             */
*         4  RRNLCDIE BIT(1),    /* HIGHER NODE NOT SUCCESFULLY      */
*                                /*             ACTIVATED            */
*         4  RRNLCDIP BIT(1),    /* NODE BEING DEACTIVATED           */
*         4  RRNERPIP BIT(1),    /* ERP IN PROCESS                   */
*         4  RRNDSTCT BIT(1),    /* DEACT TO DECREMENT STCNT         */
*         4  RRNRSV11 BIT(1),    /* UNUSED/RESERVED                  */
*      3  RRNUCBAD PTR(24),      /* UCB/PUB ADDR                     */
*         4 RRNCHQI  BIT(8),     /* CHANNEL QUEUE INDEX              */
*         4 RRNLUBA  PTR(16),    /* DESCRIBE ENTRY IN PUB            */
*                                /* OWNERSHIP TABLE                  */
*   2  RRNGRPA PTR(31),          /* POINTER TO FIRST GROUP ENTRY     */
*   2  RRNRNCUA CHAR(3),         /* CHANNEL UNIT ADDR                */
*   2  RRNRLDIP FIXED(8),        /* REMOTE LOAD/DUMP IN PROG. COUNT  */
*   2  RRNTRENT PTR(31),         /* ADDR TERM ENTRY IN LOCAL         */
*   2  RRNBHSET PTR(31),         /* POINTER TO TABLE OF BHSET NAMES  */
*   2  RRNCTBHS FIXED(15),       /* COUNT OF BHSET NAMES IN RRNBHSET */
*   2  RRNCTEGP FIXED(15),       /* COUNT OF GROUP ENTRIES FOR RN    */
*   2  RRNCTELI FIXED(15),       /* COUNT OF LINE ENTRIES FOR RN     */
*   2  RRNCTECL FIXED(15),       /* COUNT OF CLUSTER ENTRIES FOR RN  */
*   2  RRNCTETR FIXED(15),       /* COUNT OF TERMINAL ENTRIES FOR RN */
*   2  RRNCTEIN FIXED(15),       /* COUNT OF INT. NODE ENTRIES FOR RN*/
*   2  RRNCTECM FIXED(15),       /* CNT OF COMPONENT ENTRIES FOR RN  */
*   2  RRNCTENT FIXED(15),       /* # ALL ENTRIES IN 370X RDT SEGMENT*/
*   2  RRNRDF CHAR(4),           /*  RESOURCE DEFINITION FLAG        */
*      3  RRNRDFA  BIT(8),       /* FLAGS (WORD 1 BYTE 1)            */
*         4  RRNRASHT BIT(1),    /* AUTO NETWORK SHUTDOWN            */
*         4  RRNRAIPL BIT(1),    /* AUTO IPL ON RN FAILURE           */
*         4  RRNRADMP BIT(1),    /* AUTO DUMP ON RN FAILURE          */
*         4  RRNRASYN BIT(1),    /* C/R AUTOMATICALLY RESYNCHRONIZED */
*                                /* IF ALREADY LOADED NCP            */
*                                /* 0=NO, 1=YES                      */
*         4  RRNRAOLT BIT(1),    /* ON-LINE TERMINAL TEST            */
*         4  RRNRBREM  BIT(1),   /* REMOTE RN FLAG                   */
*         4  RRNRANCP BIT(1),    /* GENERATION TYPE NCP              */
*         4  RRNRAPEP BIT(1),    /* GENERATION TYPE PEP              */
*      3  RRNRDFB BIT(16),       /* FLAG FIELD B (RDF)               */
*         4  RRNRBMDL BIT(1),    /* (=1 IF 3705) ELSE 3704           */
*         4  RRNRSV02 BIT(1),    /* RESERVED                         */
*         4  RRNRBCCL BIT(1),    /* LOOSELY COUPLED CHANNEL          */
*         4  RRNRBCCT BIT(1),    /* TIGHTLY COUPLED CHANNEL          */
*         4  RRNRBSEC BIT(1),    /* SECONDARY CHANNEL EXIST          */
*         4  RRNRBCT1 BIT(1),    /* PRIM CHAN TYPE (0=TYPE1,1=TYPE2) */
*         4  RRNRBCT2 BIT(1),    /* SEC CHAN TYPE (0=TYPE1,1=TYPE2)  */
*         4  RRNRSV03 BIT(1),    /* RESERVED                         */
*         4  RRNRBBUP BIT(1),    /* BRINGUP IS TO BE EXERCISED     1152
*                                         FOR THIS RN DURING IPL     */
*         4  RRNVYDON BIT(1),    /* RDT SEG IS BEING FREED           */
*         4  RRNRSV01 BIT(5),    /* RESERVED                         */
*         4  RRNPTASL BIT(1),    /* SOME PORT SOLICITOR IS WAITING 1152
*                                   TO BE REDRIVEN BY CLSDST         */
*      3  RRNRSV55 CHAR(1),      /*  RESERVED                        */
*   2  RRNCMF CHAR(4),           /*  FLAG FIELDS FOR COMMANDS        */
*      3  RRNCMFA  BIT(8),       /* FLAG FIELD A -COMMANDS           */
*         4  RRNCAALL BIT(1),    /* PHYSICAL DISCONNECT              */
*         4  RRNCAATD BIT(1),    /* ACTIVATE DEVICE                  */
*         4  RRNCAATG BIT(1),    /* ACTIVATE GROUP                   */
*         4  RRNCAATI BIT(1),    /* ACTIVATE INVITES                 */
*         4  RRNCAMBH BIT(1),    /* MODIFY BLOCK HANDLER SET         */
*         4  RRNCACDT BIT(1),    /* CHANGE DATE AND TIME             */
*         4  RRNCADTD BIT(1),    /* DEACTIVATE DEVICE                */
*         4  RRNCADGO BIT(1),    /* DEACTIVATE GROUP ORDERLY         */
*      3  RRNCMFB  BIT(8),       /* FLAG FIELD B - COMMANDS          */
*         4  RRNCBDLO BIT(1),    /* DEACTIVATE LINE ORDERLY          */
*         4  RRNCBDLH BIT(1),    /* DEACTIVATE LINE HALT             */
*         4  RRNCBDLR BIT(1),    /* DISPLAY LINE RESOURCE ID         */
*         4  RRNCBRDS BIT(1),    /* REQUEST DEVICE STATUS            */
*         4  RRNCBRLS BIT(1),    /* REQUEST LINE STATUS              */
*         4  RRNCBNPL BIT(1),    /* CHANGE LINE NEG POLL RESPONSE LIM*/
*         4  RRNCBMOD BIT(1),    /* COPY/SET DESTINATION NODE        */
*         4  RRNCBALT BIT(1),    /*  ACTIVATE LINE TRACE             */
*      3  RRNCMFC  BIT(8),       /* FLAG FIELD C - COMMANDS          */
*         4  RRNCCRCN BIT(1),    /* RESET CONDITIONAL                */
*         4  RRNCCRDQ BIT(1),    /* RESET DEVICE QUEUE               */
*         4  RRNCCRST BIT(1),    /* REQUEST DEVICE STATISTICS        */
*         4  RRNCCCRC BIT(1),    /* CHANGE RETRY COUNTS              */
*         4  RRNCCRIM BIT(1),    /* RESET IMMEDIATE                  */
*         4  RRNCCRCM BIT(1),    /* RESET CONTROL MODE               */
*         4  RRNCCSIM BIT(1),    /* COPY/REPLACE SESSION INIT INFO   */
*         4  RRNCCCSL BIT(1),    /* CHANGE SESSION LIMIT             */
*      3  RRNCMFD  BIT(8),       /* FLAG FIELD D - COMMANDS          */
*         4  RRNCDCSP BIT(1),    /* CHANGE SERIVCE PAUSE             */
*         4  RRNCDSTD BIT(1),    /* DISPLAY STORAGE                  */
*         4  RRNCDDTL BIT(1),    /* CHANGE DEVICE TRANSMIT LIMIT     */
*         4  RRNCDBCK BIT(1),    /* SWITCHED NETWORK BACKUP          */
*         4  RRNCDDSI BIT(1),    /* COPY/REPLACE DEV SESSION INIT INFO*
*         4  RRNCDREC BIT(1),    /* RESET AT END OF COMMAND          */
*         4  RRNREMPO BIT(1),    /* REMOTE POWER OFF                 */
*         4 RRNRSV05  BIT(1),    /*       NOT  USED                  */
*   2  RRNFLUX  PTR(31),         /* POINTER TO FIRST LUX             */
*   2  RRNCPLUB CHAR(6),         /* SYMBOLIC UNIT NAME OF NCP DATASET*/
*   2  RRNEPADR PTR(15),         /* EP SUBCHANNEL ADDRESS            */
*   2  RRNNMDPD  CHAR(8),        /* FILENAME FOR DUMP DATA SET       */
*      3  RRNDPLUB CHAR(6),      /* LUB NAME FOR DUMP DATASET        */
*      3  RRNPUBI  BIT(8),       /* PUB INDEX                        */
*      3  RRNRSV88 CHAR(1),      /* RESERVED-DOS ONLY                */
*   2  RRNRSV04  CHAR(6),        /* RESERVED                         */
*   2  RRNDELAY  CHAR(2),        /* INITIAL VALUE FROM DELAY         */
*   2  RRNNMNCP  CHAR(8),        /* DSNAME FOR NCP LOAD MODULE       */
*   2  RRNHPRE PTR(16),          /* HOST PREFIX INFORMATION          */
*      3  RRNHLENH PTR(8),       /* LENGTH OF HOST HEADER PREFIX     */
*      3  RRNHLENT PTR(8),       /* LENGTH OF HOST TEXT PREFIX       */
*   2  RRNHBUFS FIXED(15),       /* SIZE OF BUFFER UNITS FOR HOST    */
*   2  RRNCTPCC PTR(8),          /* CNT OF BUFFERS RECEIVING PCCU DATA*
*   2  RRNNCPNM CHAR(7),         /* NAME OF NCP LOAD MOD 7 CHAR MAX  */
*   2  RRNMSIZE PTR(31),         /* MAX SIZE OF SEND                 */
*   2  RRNRPLPT PTR(31),         /* C/R POINTER TO RPL               */
*   2  RRNNCSPL PTR(31),         /* POINTER TO NCSPL                 */
*   2  RRNLASTE PTR(31),         /* PTR TO LAST ENTRY IN RN SEGMENT  */
*   2  RRNRDCUA CHAR(3),         /* DEFAULT CUA                      */
*   2  *        PTR(8),          /* RESERVED                         */
*   2  RRNRINNM CHAR(8);         /* DEFAULT INNODE NAME IN LOCAL   1152
*                                   RDT TO CONNECT REMOTE RN         */
*                                                                  1152
*DCL                                                               1153
*1  ISTRGP BDY(WORD) BASED,      /* GROUP ENTRY                      */
*   2  RGPPRE CHAR(LENGTH(ISTRPRE)),        /*  USE ISTRPRE DSECT    */
*   2  RGPFLG BIT(8),            /*  FLAG FIELD                      */
*      3  RGPADIL BIT(1),        /* =1 SWITCHED, =0 NON-SWIT         */
*      3  RGPASS  BIT(1),        /* START/STOP                       */
*      3  RGPABSC  BIT(1),       /* BINARY SYNCHRONOUS               */
*      3  RGPASDLC BIT(1),       /* DATA LINK CONTROL                */
*      3 RGPRSV02  BIT(4),       /*     NOT USED                     */
*   2  RGPRSV03 FIXED(8),        /* USED TO FORCE ALINEMENT          */
*   2  RGPCTELN FIXED(15),       /* COUNT OF LINE ENTRIES FOR GROUP  */
*   2  RGPCTECL FIXED(15),       /* CNT OF CLUSTER ENTRIES FOR GROUP */
*   2  RGPCTETR FIXED(15),       /* CNT TERMINAL ENTRIES FOR GROUP   */
*   2  RGPCTEIN FIXED(15),       /* COUNT OF INNODE ENTRIES FOR GROUP*/
*   2  RGPCTECM FIXED(15),       /* CNT COMPONENT ENTRIES FOR GROUP  */
*   2  RGPRVPT1 PTR(31),         /* RESERVED                         */
*   2  RGPRVPT2 PTR(31);         /* RESERVED                         */
*                                                                  1153
*                                                                  1153
*DCL                                                               1154
*1  ISTRLN BDY(WORD) BASED,      /* LINE ENTRY                       */
*   2  RLNPRE CHAR(LENGTH(ISTRPRE)), /* USE COMMON PREFIX            */
*   2  RLNADR PTR(31),                                             1154
*      3  RLNFLAG BIT(8),                                          1154
*         4  RLNEAM   BIT(1),    /* ENABLE ANSWER MODE DONE          */
*         4  RLNRBISA BIT(1),    /* INITIAL STATUS 1=ACTIVE          */
*         4  RLNRSV01 BIT(6),    /* RESERVED                         */
*      3  RLNUCBAD PTR(24),      /* UCB/PUB ADDRESS                  */
*         4  RLNCUA CHAR(3),     /* NOT USED                         */
*   2  RLNCTECL FIXED(15),       /* CNT OF CLUSTER ENTRIES FOR LINE  */
*   2  RLNCTETR FIXED(15),       /* CNT OF TERMINAL ENTRIES FOR LINE */
*   2  RLNCTEIN FIXED(15),       /* COUNT OF INNODE ENTRIES FOR LINE */
*   2  RLNCTECM FIXED(15),       /* CNT OF COMPONENT ENTRIES FOR LINE*/
*   2  RLNACTCT FIXED(15),       /* COUNT OF COMPONENTS, CLUSTERS  1154
*                                             AND TERMINALS ON LINE  */
*   2  RLNSTAT1 BIT(8),          /* LINK TRAP STATUS                 */
*      3 RLNTRAP  BIT(1),        /* INTERCEPT NEXT LINK OPERATION    */
*      3 RLNLRST  BIT(1),        /* LINK RESTART COND CAUSED TRAP    */
*      3 RLNINOPL BIT(1),        /* LINK INOP CONDITION CAUSED TRAP  */
*      3 RLNINOPP BIT(1),        /* PU INOP CONDITION CAUSED TRAP    */
*      3 RLNVD    BIT(1),        /* VARY INACT CONDITION CAUSED TRAP */
*      3 RLNRSV03 BIT(3),        /* RESERVED                         */
*    2 RLNSTAT2 BIT(8),          /* LINK NORMAL STATUS               */
*      3 RLNOHIN  BIT(1),        /* OFFHOOK REPORTED TO SW SUBAREA-  */
*                                /* REPLY DUE                        */
*      3 RLNINUSE BIT(1),        /* LINK RESOURCES ALLOCATED TO PU   */
*      3 RLNRSV04 BIT(6),        /* RESERVED                         */
*   2  RLNRDF CHAR(4),           /*  RESOURCE DEFINITION FLAG        */
*      3  RLNRDFA  BIT(8),       /* FLAGS FIELD A                    */
*         4  RLNRACNT BIT(2),    /*  NEXT TWO FIELDS                 */
*            5  RLNRACAT BIT(1), /* CALL INITIATOR-TERMINAL          */
*            5  RLNRACAN BIT(1), /* CALL INITIATOR-NCP               */
*         4  RLNGANSW BIT(1),    /* C/R GENNED IN ANSWER MODE, 1=YES */
*         4  RLNPORT  BIT(1),    /* THIS IS A PORT ENTRY             */
*         4  RLNIDV   BIT(1),    /* THIS IS AN ID VERIFIED PORT      */
*         4  RLNRAEP  BIT(1),    /* TYPE IS EP                       */
*         4  RLNRANCP BIT(1),    /* TYPE IS NCP                      */
*         4  RLNRAPEP BIT(1),    /* TYPE IS PEP                      */
*      3  RLNRDFB  BIT(8),       /* FLAGS FIELD B                    */
*         4  RLNRBUSE BIT(1),    /* EP/NCP USE  1=NCP                */
*         4  RLNANSWR BIT(1),    /* ON = SEND ENABLE ANSWER          */
*                                /* AT ACTIVATE                      */
*         4  RLNAUTOD BIT(1),    /* ON=AUTODIAL, OFF=MANUAL          */
*         4  RLNRSV0B BIT(1),    /* RESERVED                         */
*         4  RLNTTV   BIT(1),    /* THIS IS TERM TYPE VERIFICATION 1154
*                                   PORT                             */
*         4  RLNRAPOL BIT(1),    /* POLLED LINE                      */
*         4  RLNRATRN BIT(1),    /* SDLC LINE                        */
*         4  RLNMULTP BIT(1),    /* 0 = POINT TO POINT,            1154
*                                   1 = MULTI POINT                  */
*      3  RLNRDFC  BIT(8),       /* FLAGS FIELD C - LINE CODES       */
*                                /* SEE CONSTANTS FOR DEFINITION     */
*      3  RLNRDFD  BIT(8),       /* FLAGS FIELD D - RESERVED         */
*   2  RLNAUTOA FIXED(15),       /* AUTOCALL ADDRESS                 */
*   2  RLNRDSLM FIXED(8),        /* SCHED. LIM BASED ON LINE SPEED 2-4*
*   2  RLNCTSES FIXED(8),        /* COUNT OF CONCURRENT SESSIONS     */
*   2  RLNACTRM PTR(8),          /* COUNT OF ACTIVE REMOTES FOR THIS
*                                   TRUNK                            */
*   2  RLNRESV1 BIT(8),          /* RESERVED/UNUSED                  */
*   2  RLNACTSN FIXED(15),       /* COUNT ACTIVE NODES ON LINK       */
*   2  RLNPOLMT FIXED(8),        /* NEG POLL RESPONSE LIMIT          */
*   2  RLNPAUSE FIXED(8),        /* POLL DELAY/PAUSE                 */
*   2  RLNCRFLG BIT(8),          /* FLAG-CONFIGURATION RESTART       */
*      3 RLNACTLN BIT(1),        /* ACTIVATE LINK OK                 */
*      3 RLNSWNCP BIT(1),        /* SWITCH PEP LINE TO NCP OK        */
*      3 RLNLSCMD BIT(3),        /* LINE SCHEDULING COMMANDS       1154
*                                   ISSUED OK                        */
*        4 RLNNPRLM BIT(1),      /* CHNG NEG POLL RESP LIMIT OK      */
*        4 RLNSESLM BIT(1),      /* CHNG SESSION LIMIT OK            */
*        4 RLNSVSKP BIT(1),      /* CHNG SERVICE SEEK PAUSE OK       */
*      3 RLNSWEP  BIT(1),        /* SWITCH TO EP                     */
*      3 RLNCRRSV BIT(2),        /* RESERVED FOR CONFIG RESTART      */
*   2  *        CHAR(1),         /* RESERVED                         */
*   2  RLNX2SW  PTR(31),         /* ADDRESS OF 370X TO SWITCH        */
*                                /* COMMUNICATION NCSPL              */
*   2  RLNNCSPL PTR(31),         /* ADDRESS OF SPIN-OFF NCSPL        */
*                                /* FOR VARY DEACTIVATE              */
*   2  RLNRVPT2 PTR(31);         /* RESERVED                         */
*                                                                  1154
*                                                                  1154
*DCL RLNRCEDC BIT(8) CONSTANT('01'X);  /* EBCDIC (CONSTANTS)         */
*DCL RLNRCUSA BIT(8) CONSTANT('02'X);  /* USASCII                    */
*DCL RLNRCBCD BIT(8) CONSTANT('03'X);  /* BCD                        */
*DCL RLNRCEBC BIT(8) CONSTANT('04'X);  /* EBCD                       */
*DCL RLNRCCOR BIT(8) CONSTANT('05'X);  /* COR                        */
*DCL RLNRCKAT BIT(8) CONSTANT('06'X);  /* KATAKANA                   */
*DCL RLNRCIT2 BIT(8) CONSTANT('08'X);  /* ITA2                       */
*DCL RLNRCZS3 BIT(8) CONSTANT('09'X);  /* ZSC3                       */
*                                                                  1162
*                                                                  1162
*DCL                                                               1163
*1  ISTRPT BDY(WORD) BASED,        /* PORT ENTRY                     */
*   2 RPTLN CHAR(LENGTH(ISTRLN)),  /* INCLUDE LINE ENTRY             */
*   2 RPTLNCID BDY(WORD) CHAR(4),  /* COMM ID OF LINE                */
*     3 RPTLNSAF CHAR(2),          /* SAF                            */
*     3 RPTLNDAF CHAR(2),          /* DAF                            */
*   2 RPTCTNM CHAR(8),             /* CTERM NAME                     */
*   2 RPTDITT PTR(31),             /* POINTER TO DITT TABLE          */
*     3 RPTDIVT PTR(31),           /* POINTER TO DIVT TABLE          */
*   2 RPTATERM PTR(31),            /* POINTER TO ASSOCIATED ENTRY    */
*   2 RPTUTERM PTR(31),            /* POINTER TO UTERM ENTRY         */
*   2 RPTFLAG1 CHAR(1),            /* PORT SOLICITOR FLAGS           */
*     3  RPTASLEP BIT(1),          /* THIS PORT SOLICITOR IS WAITING
*                                     TO BE REDRIVEN BY CLSDST       */
*     3 RPTVRYPD BIT(1),           /* VARY PENDING IN THIS CTERM     */
*     3 RPTHLVPD BIT(1),           /* VARY PENDING IN HIGHER LEVEL 1163
*                                     NODE                           */
*     3 RPTONLIN BIT(1),           /* ONLINE/OFFLINE(VARY)           */
*     3 RPTVIODN BIT(1),           /* I/O DONE FOR THIS NODE         */
*     3 RPTVYIMM BIT(1),           /* VARY IMM ISSUED FOR PORT       */
*     3 RPTDYNAM BIT(1),           /* BHSET = DYNAMIC                */
*     3 RPTISTAT BIT(1),           /* CTERM(PORT) IS INITIALLY ACTIVE*/
*                                  /* 1 = YES                        */
*   2 RPTRSV01 CHAR(1),            /* RESERVED                       */
*   2 RPTDAFSV BIT(16),            /* SAVE TERMINAL DAF              */
*   2 RPTPEPCT FIXED(15),          /* PEP COUNT FOR CTERM            */
*   2 RPTPTHCT FIXED(15),          /* PATH COUNT FOR CTERM           */
*   2 RPTNSNSV PTR(31),            /* SAVE TERMINAL NEXT SCHED NODE
*                                     POINTER                        */
*   2  RPTRSV02 PTR(31),           /* RESERVED                       */
*   2  RPTRSV03 PTR(31);           /* RESERVED                       */
*                                                                  1163
*                                                                  1163
*DCL                                                               1164
*1  ISTRCL BDY(WORD) BASED,      /* CLUSTER ENTRY                    */
*   2  RCLPRE CHAR(LENGTH(ISTRPRE)),    /* USE COMMON PREFIX         */
*   2  RCLADR PTR(31),                                             1164
*      3  RCLFLAG BIT(8),                                          1164
*         4  RCLRSV22 BIT(1),    /* RESERVED                         */
*         4  RCLRBISA BIT(1),    /* INITIAL STATUS 1=ACTIVE          */
*         4  RCLBATCH BIT(1),    /* BATCHED MESSAGE INPUT          1164
*                                   FEATURE                          */
*         4  RCLRSV33 BIT(5),    /* RESERVED                         */
*      3  RCLGPADR PTR(24),      /* ADDRESSING INFORMATION POINTER 1164
*                                                  (ADDR RCLCNGP)    */
*   2  RCLCTETR FIXED(15),       /* CNT TERMINAL ENTRIES FOR CLUSTER */
*   2  RCLCTECM FIXED(15),       /* CNT COMPONENT ENTRIES FOR CLUSTER*/
*   2  RCLRSV01 FIXED(15),       /* FILLER TO FORCE ALIGNMENT        */
*   2  RCLCTNGP FIXED(15),       /* GPOLL CHARACTER COUNT            */
*   2  RCLGPOLA PTR(31),         /* GPOLL CHARACTER STRING POINTER   */
*   2  RCLRVPT1 PTR(31),         /* RESERVED                         */
*   2  RCLRVPT2 PTR(31);         /* RESERVED                         */
*                                                                  1164
*                                                                  1164
*DCL                                                               1165
*1  ISTRTR BDY(WORD) BASED,      /* TERMINAL AND/OR COMPONENT ENTRY  */
*   2  RTRCRPR CHAR(LENGTH(ISTRCPRE)),     /* USE ISTRCPRE DSECT     */
*   2  RTRADR PTR(31),                                             1165
*      3  RTRFLAG BIT(8),                                          1165
*         4  RTRRSV21 BIT (1),   /* RESERVED */                    1165
*         4  RTRRBISA BIT(1),    /* INITIAL STATUS 1 = ACITVE        */
*         4  RTRRSV51 BIT(3),    /* RESERVED                         */
*         4  RTRVTERM BIT(1),    /* VTERM TERMINAL ENTRY             */
*         4 RTRRSV22 BIT(2),     /* UNUSED                           */
*      3  RTRADRPT PTR(24),      /* TO BE USED FOR POINTER TO      1165
*                                            ADDRESSING INFORMATION  */
*   2  RTRCTECM FIXED(15),       /* COUNT OF COMPONENT             1165
*                                               ENTRIES FOR TERMINAL */
*   2  RTRRSV01 FIXED(15),       /*  FILLER TO FORCE ALINEMENT       */
*   2  RTRRSV45 CHAR(4),         /* RESERVED                         */
*   2  RTRRDFA  BIT(8),          /* FLAG FIELD A                     */
*      3  RTRRAATN BIT(1),       /* TERMINAL CAN INTERRUPT PCCU      */
*      3  RTRRAALL BIT(3),       /* 3 FLAG FIELD                     */
*         4  RTRRAPT1 BIT(1),    /* PT1 BLOCK HANDLER FLAGS          */
*         4  RTRRAPT2 BIT(1),    /* PT2                              */
*         4  RTRRAPT3 BIT(1),    /* PT3                              */
*      3  RTRRACDT BIT(1),       /* CRITICAL DATA FLAG               */
*      3  RTRRSV60 BIT(1),       /* RESERVED                         */
*      3  RTRRACTR BIT(1),       /* LOGICAL DEVICE FLAG              */
*      3  RTRRSV02 BIT(1),       /* UNUSED                           */
*   2  RTRRDFB  BIT(8),          /* FLAG FIELD B - RESOURCE DEF      */
*      3  RTRRBECT BIT(1),       /* EMBEDDED LINE CONTROL            */
*      3  RTRRBEND BIT(1),       /* EOT/EOB                          */
*      3  RTRRSV32 BIT(6),       /* RESERVED                         */
*   2  RTRRDFC  BIT(8),          /* FLAG FIELD C - RESOURCE DEF      */
*      3  RTRRCIT1 BIT(1),       /* EIB CHAR AFTER ITB ON RECV       */
*      3  RTRRCIT2 BIT(1),       /* EIB CHAR AFTER ITB ON SEND       */
*      3  RTRRCPT3 BIT(1),       /* DEVICE HAS PT3 BHSET             */
*      3  RTRRCBLK BIT(1),       /* RECORD DATA - BLOCK              */
*      3  RTRRCMSG BIT(1),       /* RECORD DATA - MESSAGE            */
*      3  RTRRCXMS BIT(1),       /* RECORD DATA - XMISSION           */
*      3  RTRRSV23 BIT(2),       /* RESERVED/UNUSED                  */
*   2  RTRRDFD  BIT(8),          /* FLAG FIELD D - RESERVED          */
*      3  RTRRDBHN  BIT(1),      /* BHSET = NONE                     */
*      3  RTRRDBHD  BIT(1),      /* BHSET = DYNAMIC                  */
*      3  RTRRDBHI  BIT(1),      /* BHSET = SETNAME AND EXECUTR      */
*      3  RTRRSV10 BIT(2),       /* RESERVED                         */
*      3  RTRRSV11 BIT(3),       /* RESERVED                         */
*   2  RTRRDFE  BIT(8),          /* FLAG FIELD E - RESOURCE DEF      */
*/*                RTRREFT1  FEATURE FLAGS  (9 BITS)                 */
*      3  RTRREBRK BIT(1),       /* TRANSMIT INTERRUPT               */
*      3  RTRRSV0A BIT(1),       /* RESERVED                         */
*      3  RTRREACR BIT(1),       /* ACCELERATED CARRIAGE RETURN      */
*      3  RTRRECHK BIT(1),       /* CHECKING FEATURE                 */
*      3  RTRREATT BIT(1),       /*  TERMINAL INTERRUPT              */
*      3  RTRRESUP BIT(1),       /*  TIMEOUT SUPPRESSION             */
*      3  RTRRESCT BIT(1),       /*  STATION CONTROL                 */
*   2  RTRRDFF  BIT(8),          /* FLAG FIELD F - RESOURCE DEF      */
*      3  RTRRFXCT BIT(1),       /* TRANSMIT CONTROL                 */
*/*                      RTRRFFT2 FEATURE 2 FLAGS (NEXT 5 BITS)      */
*      3  RTRRFPEN BIT(1),       /* SELECTOR PEN                     */
*      3  RTRRFPFK BIT(1),       /* PROGRAM FUNCTION DEYBOARD        */
*      3  RTRRFANK BIT(1),       /* STANDARD ALPHA-NUMERIC KEYBOARD  */
*      3  RTRRFDEK BIT(1),       /* DATA ENTRY KEYBOARD              */
*      3  RTRRSV24 BIT(3),       /* UNUSED/RESERVED                  */
*   2  RTRTRMAX CHAR(1),         /* MAX # TRANSMISSIONS TERM TO PCCU */
*   2  RTRCRFLG PTR(8),          /* FLAG-CONFIGURATION RESTART       */
*      3 RTRCRSV1 BIT(2),        /* RESERVED FOR CONFIG RESTART      */
*      3 RTRLSCMD BIT(1),        /* LINE SCHEDULING CMD ISSUED OK    */
*        4 RTRDTRLM BIT(1),      /* CHNG DEV TRANSMISSION LIMIT OK   */
*      3 RTRCRSV2 BIT(5),        /* RESERVED FOR CONFIG. RESTART     */
*   2  RTRBHSN1 CHAR(8),         /* DEFAULT BHSET NAME IS BHF IS ON  */
*   2  RTRRVPT1 PTR(31),         /* RESERVED                         */
*   2  RTRRSV03 FIXED(15),       /* FILLER TO FORCE ALIGNMENT        */
*   2  RTRCTDIA FIXED(15),       /* CNT OF CHARS. IN TERM DIAL NUMBER*/
*   2  RTRCTPOL FIXED(15),       /* # CHARS. IN TERM POLL STRING     */
*   2  RTRCTADR FIXED(15),       /* COUNT OF ADDRESSING CHARACTERS   */
*   2  RTRCADDR  CHAR(8),        /* COMPONENT ADDRESSING CHARS       */
*   2  RTRPOLA PTR(31),          /* POINTER TO POLLING CHARACTERS    */
*   2  RTRDIAA PTR(31),          /* POINTING TO DIAL CHARACTERS      */
*   2  RTRRDFG  BIT(8),          /* CORRESPONDENCE CODE USED BY THIS
*                                   TERM LINE. SEE CONSTANTS.        */
*   2  RTRRSVDD CHAR(7),         /* RESERVED                         */
*   2  RTRBSCID CHAR(21),        /* BSC ID FIELD                     */
*      3  RTRIDLEN FIXED(8),     /* LENGTH OF ID                     */
*      3  RTRIDCAS CHAR(20),     /* ID CHARACTER                     */
*   2  RTRLCTI BIT(8),           /* LINE CONTROL TYPE ID             */
*   2  RTRRSV04 CHAR(2);         /* RESERVED                         */
*                                                                  1165
* DCL RTRDNCBA PTR(31) DEF(ISTRTR) POS(41);  /* SCAFFOLDING          */
*/* CONSTANTS FOR FIELD RTRRDFG                                      */
*DCL RTRRCBCD BIT(8) CONSTANT('03'X); /* BCD                         */
*DCL RTRRCEBC BIT(8) CONSTANT('04'X); /* EBCD                        */
*DCL RTRRCCOR BIT(8) CONSTANT('05'X); /* COR                         */
*                                                                  1169
*/*     CONSTANTS FOR FIELD RTRLCTI                                  */
*DCL RTR2741  BIT(8) CONSTANT('00'X);  /* 2741                       */
*DCL RTR2740A BIT(8) CONSTANT('02'X);  /* 2740-1 A (BASIC)           */
*DCL RTR2740D BIT(8) CONSTANT('06'X);  /* 2740-1 D (TRANS CONTROL)   */
*DCL RTR2740E BIT(8) CONSTANT('0A'X);  /* 2740-1 E (TRANS          1173
*                                   CONTROL WITH CHECKING            */
*DCL RTR2740F BIT(8) CONSTANT('0C'X);  /* 2740-1 F (CHECKING)        */
*DCL RTR1050  BIT(8) CONSTANT('1C'X);  /* 1050                       */
*DCL RTRTWX   BIT(8) CONSTANT('22'X);  /* TWX                        */
*/*                                                                  */
*/*   ENTRY IN LOCAL RN FOR REMOTE SEGMENT                           */
*/*                                                                  */
*DCL  1  ISTRIN   BDY(WORD) BASED,   /* INNODE REMOTE ENT IN LOCAL RN*/
*        2 RINCRPRE CHAR(LENGTH(ISTRCPRE)),  /* PREFIX               */
*        2 RINDFD   BIT(8),          /* FLAG FIELD                   */
*          3 RINREMPO BIT(1),        /* REMOTE POWER OFF             */
*            4 RTRREMPO BIT(1),      /* ALIAS                        */
*          3 RINNODEF BIT(1),        /* REMOTE TERM ENTRY INV AS ENT */
*            4 RTRNODEF BIT(1),      /* ALIAS                        */
*          3 RINLDISC BIT(1),        /* DISCONNECT REMOTE REQUIRED   */
*            4 RTRLDISC BIT(1),      /* ALIAS                        */
*          3 RINRSV01 BIT(5),        /* RESERVED                     */
*        2 RINNODID PTR(8),          /* NODE ID OF REMOTE            */
*          3 RTRNODID PTR(8),        /* ALIAS                        */
*        2 RINRLDAF CHAR(2),         /* DAF OF REMOTE WHEN ACTIVE    */
*          3 RTRRLDAF CHAR(2),       /* ALIAS                        */
*        2 RINREMOT PTR(31),         /* PTR TO RN ENTRY FOR REMOTE   */
*          3 RTRREMOT PTR(31),       /* ALIAS                        */
*        2 RINVPAB  PTR(31),         /* ADDR VARY PAB FOR REMOTE     */
*          3 RTRVPAB  PTR(31),       /* ALIAS                        */
*        2 RINRPHCN PTR(31),         /* ADDR RPH WAITING FOR CONTACT */
*          3 RTRRPHCN PTR(31),       /* ALIAS                        */
*        2 RINNCSPL PTR(31),         /* ADDR FOR NCSPL FOR DEACTIVATE*/
*          3 RTRNCSPL PTR(31),       /* ALIAS                        */
*        2 RINCNCNT PTR(8),          /* CONTACT COUNT FOR REMOTE     */
*          3 RTRCNCNT PTR(8),        /* ALIAS                        */
*        2 RINRSV02 CHAR(3),         /* RESERVED                     */
*        2 RINLOCRN PTR(31),         /* PTR TO RN ENTRY OF LOCAL     */
*        2 RINRSV04 CHAR(4),         /* RESERVED                     */
*        2 RINRSV05 CHAR(4);         /* RESERVED                     */
*/*                                                                  */
*DCL                                                               1178
*1   ISTRDS BDY(WORD) BASED,       /* LCDO ENTRY                     */
*           2  RDSPRE CHAR(LENGTH(ISTRPRE)), /* ENTRY PREFIX         */
*           2  RDSCTTRM FIXED(15), /* COUNT OF ENTRY POINTERS      1178
*                                     IN DIAL OUT TABLE              */
*           2  RDSCTATR FIXED(15), /*                                */
*           2  RDSADDOT PTR(31);   /* ADDRESS OF DIAL OUT TABLE      */
*/*                                                                  */
*DCL                                                               1179
*1   ISTDOT BDY(WORD) BASED,       /* DIAL OUT TABLE                 */
*           2  DOTADTRM PTR(31);   /* PTR TO DIAL OUT OR DIAL IN/  1179
*                                     OUT TERMINAL RDTE              */
*/*                                                                  */
*DCL                                                               1180
*1 ISTRCC BDY(WORD) BASED,             /* PU ENTRY                   */
*  2 RCCPRE   CHAR(LENGTH(ISTRPRE)),   /* COMMON PREFIX              */
*  2 RCCTYPE  CHAR(1),                 /* PU TYPE                    */
*  2 RCCFLAG  BIT(8),                  /* FLAG FIELD                 */
*    3 RCCRBISA BIT(1),                /* I STATUS 1=ACTIVE          */
*    3 RCCCUDIE BIT(1),                /* CLUSTER DEACTIVATING       */
*    3 RCCERPIP BIT(1),                /* ERP IN PROCESS             */
*    3 RCCLDISC BIT(1),                /* DISCONNECT REQUEST         */
*    3 RCCOHIMM BIT(1),                /* RTGOH RECEIVED AND WAS     */
*                                      /* AN IMMEDIATE TYPE          */
*    3 RCCOUERP BIT(1),                /* REPEAT ERP                 */
*    3 RCCPRGDN BIT(1),                /* PURGE ISSUED               */
*    3 RCCCTPGD BIT(1),                /* CONTACT PURGED             */
*  2 RCCFLAGB BIT(8),                  /* FLAG FIELD                 */
*    3 RCCDSTCT BIT(1),                /* DEACT TO DECR STCNT IN HDR */
*    3 RCCDIALP BIT(1),                /* DIAL IN PROGRESS           */
*    3 RCCIRETR BIT(1),                /* IRETRY 1 = YES             */
*    3 RCCBNNSP BIT(1),                /* BNNSUP FOR 3270            */
*    3 RCCFINAL BIT(1),                /* ON = DEACT PU FINAL REQD   */
*    3 RCCRESET BIT(1),                /* ON = RESET DEACT IN PROCESS*/
*    3 RCCBRKCN BIT(1),                /* ON-DISCOUNT=YES SPECIFIED  */
*                                      /* OFF-DISCOUNT=NO SPECIFIED  */
*    3 RCCRTGOH BIT(1),                /* ON=RTGOH RECEIVED          */
*  2 RCCCNCNT  PTR(8),                 /* CONTACT COUNT              */
*  2 RCCCTELU FIXED(15),               /* COUNT OF PU LU ENTRIES     */
*  2 RCCSTAID CHAR(8),                 /* 64 BIT PU STATION ID       */
*    3 RCCIDPA1 BIT(16),               /* FILLER OF 2 BYTES OF 0     */
*    3 RCCID48,                                                    1180
*      4 RCCIDPUT BIT(8),              /* PU TYPE                    */
*      4 RCCIDPA2 BIT(8),              /* FILLER OF 1 BYTE OF 0      */
*      4 RCCIDBLK BIT(12),             /* IDBLK VALUE                */
*      4 RCCIDNUM BIT(20),             /* IDNUM VALUE                */
*  2 RCCSESCT PTR(8),                  /* SESSION COUNT              */
*  2 *        CHAR(1),                 /* RESERVED                   */
*  2  RCCVPAB PTR(31),                 /* ADDRESS OF VARY PAB        */
*  2 RCCDPAB  PTR(31),                 /* ADDR RESTART PAB           */
*  2 RCCEPAB  PTR(31),                 /* ADDR OF ERP PAB            */
*  2 RCCRPHCN PTR(31),                 /* ADDR RPH WAIT FOR CONTACT  */
*  2 RCCNCSPL PTR(31),                 /* ADDR NCSPL FOR DEACTIVATE  */
*  2 RCCCRFLG BIT(8),                  /* FLAG-CONFIGURATION RESTART */
*    3 RCCACTPU BIT(1),                /* ACTIVATE PHYSICAL          */
*    3 RCCCTCFL BIT(1),          /* HIGHER FAILURE-CONTACT FLUSHED   */
*    3 RCCCRRSV BIT(6),                /* RES. FOR CONFIG. RESTART   */
*  2 RCCRSV02 PTR(24),                 /* RESERVED                   */
*  2 RCCTPAB  PTR(31),                 /* TOLTEP SSCP PAB            */
*  2 RCCDPQ   PTR(31),                 /* DIAL PENDING NCSPL QUE PTR */
*  2 RCCPATHT PTR(31),                 /* PTR TO PATH TABLE          */
*  2 RCCPATHZ FIXED(15),               /* # ENTRIES IN PATH TABLE    */
*  2 RCCINDEX FIXED(15),               /* INDEX TO PATH TABLE        */
*  2 RCCMXDAT FIXED(15),               /* MAXDATA SIZE               */
*  2 RCCMXOUT FIXED(8),                /* MAXOUT VALUE               */
*  2 RCCPASSL FIXED(8),                /* PASSLIM VALUE              */
*  2 RCCADDR  FIXED(8),                /* STATION ADDRESS            */
*  2 RCCRSPT2 PTR(24),                 /* RESERVED                   */
*  2 RCCSWTOX PTR(31),                 /* SWITCHED TO 370X           */
*                                      /* COMMUNICATIONS NCSPL       */
*  2 RCCXTOSW PTR(31),                 /* 370X TO SWITCHED           */
*                                      /* COMMUNICATIONS NCSPL       */
*  2 RCCRVPT2 PTR(31);                 /* RESERVED                   */
*/* RCCTYPE - PU TYPE CODES                                          */
*DCL RCCPU01  BIT(8) CONSTANT('01'X);  /* PU TYPE 1                  */
*DCL RCCPU02  BIT(8) CONSTANT('02'X);  /* PU TYPE 2                  */
*DCL RCCPU03  BIT(8) CONSTANT('03'X);  /* PU TYPE 3                  */
*DCL RCCPU04  BIT(8) CONSTANT('04'X);  /* PU TYPE 4                  */
*/*                                                                  */
*DCL                                                               1185
*1 ISTRLU BDY(WORD) BASED,             /* LU ENTRY                   */
*  2 RLUCRPR CHAR(LENGTH(ISTRCPRE)),   /* COMMON PREFIX              */
*  2 RLUTYPE  CHAR(1),                 /* LU TYPE                    */
*  2 RLUFLAG  CHAR(1),                 /* RLU FLAGS                  */
*    3 RLURBISA BIT(1),                /* I STATUS 1=ACTIVE          */
*    3 RLUBATCH BIT(1),                /* 1 IF BATCH = YES           */
*    3 RLUGSTAT BIT(1),                /* C/R GENNED ISTATUS VALUE   */
*                                      /* 1 = ACTIVE                 */
*    3 RLUNDSES BIT(1),                /* SPECIAL END SESSION        */
*    3 RLURSV00 BIT(4),                /* RESERVED                   */
*  2 RLUCRFLG BIT(8),                  /* FLAG-CONFIGURATION RESTART */
*    3 RLUACTLU BIT(1),                /* ACTIVATE LOGICAL UNIT OK   */
*    3 RLUCRRSV BIT(7),                /* RESERVED FOR CONFIG RESTART*/
*  2 RLUSSCFM BIT(8),                  /* FUNCTION MANAGER TYPE      */
*  2 RLUINTA PTR(31),                  /* RESERVED                   */
*  2 RLUPACE CHAR(2),                  /* VPACING COUNTS             */
*    3 RLUPACEN CHAR(1),               /* N COUNT                    */
*    3 RLUPACEM CHAR(1),               /* M COUNT                    */
*  2 RLUNCPPC CHAR(2),                 /* NCP PACING COUNTS          */
*    3 RLUNCPPN CHAR(1),               /* N COUNT                    */
*    3 RLUNCPPM CHAR(1),               /* M COUNT                    */
*  2 RLULOCAD CHAR(1),                 /* LOCAL ADDRESS OF LU        */
*  2 RLURSV01 CHAR(3),                 /* RESERVED                   */
*  2 RLUUSSTB CHAR(12) BDY(WORD),      /* USSTAB                     */
*    3 RLUUSSNM CHAR(8),               /* USSTAB NAME                */
*    3 RLUUSSPT PTR(31),               /* USSTAB ADDRESS             */
*  2 RLUMODET CHAR(12) BDY(WORD),      /* MODETAB                    */
*    3 RLUMODEN CHAR(8),               /* MODETAB NAME               */
*    3 RLUMODEP PTR(31),               /* MODETAB ADDRESS            */
*  2 RLULGMOD CHAR(8),                 /* LOGMODE                    */
*  2 RLURSV02 PTR(31);                 /* RESERVED                   */
*/*  RLUSSCFM - FOLLOWING EQUATES ARE FOR THE VARIOUS                */
*/*             FUNCTION MANAGER TYPES                               */
*DCL RLUFSS   BIT(8) CONSTANT('01'X);  /* FORMATTED SYS SERVICES     */
*DCL RLUUSS   BIT(8) CONSTANT('02'X);  /* UNFORMATTED SYS SERVICES   */
*DCL RLUU3270 BIT(8) CONSTANT('04'X);  /* UNFORMATTED SYS SVCS 3270  */
*/*  RLUTYPE - EQUATES FOR LU TYPE                                   */
*DCL RLUTYP04 BIT(8) CONSTANT('04'X);  /* LU TYPE IS 4               */
*/*                                                                  */
*DCL 1 ISTRPX BDY(WORD) BASED,     /* SKELETON PUX ENTRY             */
*      2 RPXPRE CHAR(LENGTH(ISTRPRE)),  /* COMMON PREFIX             */
*      2 RPXFLUX  PTR(31),         /* PTR TO FIRST LUX IN CHAIN      */
*      2 RPXMAXLU PTR(8),          /* MAX NUMBER OF LU'S             */
*                                  /* FOR THIS LINK                  */
*      2 RPXRSV02 PTR(24),         /* RESERVED                       */
*      2 RPXRSV01 PTR(31);         /* RESERVED                       */
*/*                                                                  */
*DCL 1 ISTRLX BDY(WORD) BASED,     /* SKELETON LUX ENTRY             */
*      2 RLXPRE CHAR(LENGTH(ISTRPRE)),  /* COMMON PREFIX             */
*      2 RLXNLUX  PTR(31),         /* PTR TO NEXT LUX IN CHAIN       */
*      2 RLXFLAGA CHAR(1),         /* FLAG BYTE                      */
*        3 RLXINUSE BIT(1),        /* ON = LUX IS IN USE             */
*        3 RLXRSV01 BIT(7),        /* RESERVED                       */
*      2 RLXRSV02 CHAR(3),         /* RESERVED                       */
*      2 RLXRSV03 PTR(31);         /* RESERVED                       */
*/*                                                                  */
*DCL 1 ISTRSW BDY(WORD) BASED,     /* SWITCHED SUBAREA HDR ENTRY     */
*      2 RSWPRE CHAR(LENGTH(ISTRDT)),   /* USE ISTRDT DSECT          */
*      2 RSWDIALT PTR(31),         /* PTR TO DIAL #'S TABLE          */
*      2 RSWGRUPT PTR(31),         /* PTR TO GROUP NAMES TABLE       */
*      2 RSWDIALZ FIXED(15),       /* # ENTRIES IN DIAL NO. TABLE    */
*      2 RSWGRUPZ FIXED(15),       /* # ENTRIES IN GRP NAME TABLE    */
*      2 RSWCTELU FIXED(15),       /* COUNT OF LU ENTRIES IN THIS SEG*/
*      2 RSWRSV02 CHAR(2),         /* RESERVED                       */
*      2 RSWRSV01 PTR(31);         /* RESERVED                       */
*/*                                                                  */
*DCL 1 ISTRDA BDY(WORD) BASED,     /* DAN ENTRY                      */
*      2 RDAPRE CHAR(LENGTH(ISTRPRE)),  /* COMMON PREFIX             */
*      2 RDAADR   PTR(31),                                         1193
*        3 RDAFLAG  BIT(8),        /* FLAG BYTE                      */
*          4 RDARBISA BIT(1),      /* INITIAL STATUS, 1 = ACTIVE     */
*          4 RDARSV01 BIT(7),      /* RESERVED                       */
*        3 RDAUCBAD PTR(24),       /* UCB.PUB ADDRESS                */
*          4 RDACHQI  BIT(8),      /* CHANNEL QUEUE INDEX            */
*          4 RDALUBA  BIT(16),     /* @ OF LOGICAL UNIT BLOCK        */
*      2 RDADACUA CHAR(3),         /* CHANNEL UNIT ADDRESS           */
*      2 RDACTPCC PTR(8),          /* CNT OF BUFFERS RECEIVING DATA  */
*      2 RDADFCUA CHAR(3),         /* DEFAULT CUA                    */
*      2 RDAPUBI  BIT(8),          /* PUB INDEX                      */
*      2 RDARSVPT PTR(31);         /* RESERVED                       */
*/*                                                                  */
*DCL 1 ISTRLS BDY(WORD) BASED,     /* LOCAL SUBAREA HEADER ENTRY     */
*      2 RLSPRE CHAR(LENGTH(ISTRDT)),   /* USE ISTRDT DSECT          */
*      2 RLSCTELU FIXED(15),       /* COUNT OF LU ENTRIES IN THIS SEG*/
*      2 RLSRSV01 FIXED(15),       /* RESERVED                       */
*      2 RLSRSV02 PTR(31);         /* RESERVED                       */
*/*                                                                  */
*DCL  1  ISTDNT BDY(WORD) BASED,  /* DIAL NUMBER TABLE               */
*        2 DNTCTDIG FIXED(8),     /* NUMBER OF DIGITS IN TEL. NUM.   */
*        2 DNTTELNO CHAR(32);     /* TELEPHONE NUMBER                */
*/*                                                                  */
* DCL  1  ISTGNT BDY(WORD) BASED, /* GROUP NAMES TABLE               */
*         2 GNTGRPNM CHAR(8);     /* GROUP NAME ENTRY                */
*/*                                                                  */
*DCL  1  ISTPAT BDY(WORD) BASED,  /* PATH TABLE                      */
*        2 PATGINDX FIXED(15),    /* INDEX TO GROUP NAME TABLE       */
*        2 PATDINDX FIXED(15),    /* INDEX TO DIAL NUMBER TABLE      */
*        2 PATPTHID PTR(8),       /* PATH ID                         */
*        2 PATGRPID PTR(8),       /* GROUP PATH ID                   */
*        2 PATRDCNT PTR(8),       /* REDIAL COUNT                    */
*        2 PATFLAGA BIT(8),       /* FLAG BYTE                       */
*          3 PATUSEFG BIT(1),     /* ON = PATH INITIALLY USABLE      */
*          3 PATRSV01 BIT(7);     /* RESERVED                        */
*/*     VTAM CONFIGURATION TABLE                                    */
*/*                                                                 */
*/*  DELTA                                             004 02/10/75 */
*/*                                                                 */
*       DECLARE                                                    1198
*       1 ISTCONFT BASED BDY(WORD),                                1198
*         2 CONCONFG CHAR(8),         /*NAME OF CONFIGURATION TABLE */
*         2 CONAPINM CHAR(8),         /*API MODULE NAME             */
*         2 CONAPSNM CHAR(8),         /*APS MODULE NAME             */
*         2 CONDMNM CHAR(8),          /*DEVICE MANAGEMENT CONTROL  1198
*                                       LAYER MODULE NAME           */
*         2 CONFBPNM CHAR(8),         /*FEEDBACK PROCESSING        1198
*                                       ROUTINE MODULE NAME         */
*         2 CONACB PTR(31),           /*POINTER TO VTAM ACB         */
*         2 CONCIBAD PTR(31),         /*POINTER TO COMMAND INPUT   1198
*                                       BUFFER                      */
*         2 CONDISLA PTR(31),         /*DISPLAY COMMAND            1198
*                                       PARAMETER LIST ADDRESS      */
*         2 CONNCSLA PTR(31),         /*NCS PARAMETER LIST         1198
*                                       ADDRESS                     */
*         2 CONHLTLA PTR(31),         /*HALT COMMAND PARAMETER     1198
*                                       LIST ADDRESS                */
*         2 CONMODLA PTR(31),         /*MODIFY COMMAND PARAMETER   1198
*                                       LIST ADDRESS                */
*         2 CONVARLA PTR(31),         /*VARY COMMAND PARAMETER     1198
*                                       LIST ADDRESS                */
*         2 CONENDLA PTR(31),         /*THE LAST COMMAND PROCESSED 1198
*                                       PARAMETER LIST ADDRESS      */
*         2 CONSTCIB PTR(31),         /*START COMMAND CIB ADDRESS   */
*         2 CONRDBUF PTR(31),         /*BUFFER ADDRESS USED BY     1198
*                                       READ ROUTINE                */
*         2 CONLDPRM PTR(31),         /*POINTER TO ISTLDPRM         */
*         2 CONDCBOA PTR(31),         /*ADDRESS OF VTAMLIBDCB       */
*         2 CONDCBLA PTR(31),         /*ADDRESS OF VTAMLIBDCB       */
*         2 CONDCBBA PTR(31),         /*ADDRESS OF VTAMLIBDCB       */
*         2 CONRSV02 PTR(31),         /* RESERVED                   */
*         2 CONBUFSZ FIXED(15),       /*SIZE OF BUFFER USED BY     1198
*                                       READ ROUTINE                */
*         2 CONCID PTR(16),           /*OPERATOR TERMINAL CID       */
*         2 CONRES2 CHAR(1),          /*RESERVED                    */
*         2 CONLAST CHAR(1),          /*LAST COMMAND CODE           */
*         2 CONHALT BIT(8),           /*HALT FLAGS                  */
*             3 CONHLTQ BIT(1),       /* QUICK FLAG                 */
*             3 CONHLTS BIT(1),       /* SESSION FLAG               */
*         2 CONVARY CHAR(1),          /*VARY CODE                   */
*         2 CONDISPL CHAR(1),         /*DISPLAY CODE                */
*         2 CONMODFY CHAR(1),         /*MODIFY CODE                 */
*         2 CONFLAGS CHAR(5),         /*FLAGS                       */
*           3 CONDSFLG CHAR(1),       /*DATA SET FLAGS:             */
*             4 * BIT(1),             /*RESERVED                    */
*             4 * BIT(1),             /*RESERVED                    */
*             4 * BIT(1),             /*RESERVED                    */
*             4 CONSYOBJ BIT(1),      /*SYS1.VTAMOBJ IS OPEN        */
*             4 CONSYLIB BIT(1),      /*SYS1.VTAMLIB IS OPEN        */
*             4 CONSYLST BIT(1),      /*SYS1.VTAMLST IS OPEN        */
*           3 CONOPTFL CHAR(1),       /*OPTIONAL SERVICES FLAGS:    */
*             4 CONWRMST BIT(1),      /* WARM SPECIFIED ON VTAM     */
*                                     /* START COMMAND, 1=YES       */
*             4 * BIT(1),             /*RESERVED                    */
*             4 * BIT(1),             /*RESERVED                    */
*             4 * BIT(1),             /*RESERVED                    */
*             4 CONBUFTR BIT(1),      /*BUFFER TRACE REQUESTED      */
*             4 CONBTUTR BIT(1),      /*BTU TRACE REQUESTED         */
*             4 CONMODTR BIT(1),      /*MODULE TRACE REQUESTED      */
*             4 CONIOTR BIT(1),       /*I/O TRACE REQUESTED         */
*           3 CONSTAT CHAR(1),        /*RESOURCE STATUS FLAGS:      */
*             4 * BIT(1),             /*RESERVED                    */
*             4 * BIT(1),             /*RESERVED                    */
*             4 * BIT(1),             /*RESERVED                    */
*             4 CONSTOR BIT(1),       /*VTAM HAS STORAGE            */
*             4 CONDSOPN BIT(1),      /*DATA SETS OPEN              */
*             4 CONLODED BIT(1),      /*VTAM ROUTINES LOADED        */
*             4 CONVRYIN BIT(1),      /*NETWORK VARIED IN           */
*             4 CONACTV BIT(1),       /*OPERATOR ACTIVE             */
*           3 CONBUFF  CHAR(2),       /*BUFFER STATUS FLAGS          */
*             4 CONSFEX BIT(1),       /*SMALL FIXED POOL EXIST       */
*             4 CONSPEX BIT(1),       /*SMALL PAGED POOL EXIST       */
*             4 CONLFEX BIT(1),       /*LARGE FIXED POOL EXIST       */
*             4 CONLPEX BIT(1),       /*LARGE PAGED POOL EXIST       */
*             4 CONVFEX BIT(1),       /* VARIABLE FIXED BFR POOL (DOS)
*                                        EXISTS                      */
*             4 CONVPEX BIT(1),       /* VARIABLE PG BFR POOL EXISTS
*                                        (DOS)                       */
*             4  CONUECB BIT(1),      /* UECB POOL EXISTS (VS1 & VS2)*/
*             4  CONIOEX BIT(1),      /* I/O FIXED POOL EXISTS       */
*             4  CONWPEX BIT(1),      /* WORKING SET POOL EXISTS     */
*             4  CONAPEX BIT(1),      /* ACE/ICE POOL EXISTS         */
*             4  CONNPEX BIT(1),      /* NON-WORKING SET POOL EXISTS */
*             4  CONPPEX BIT(1),      /* PAGEABLE DATA POOL EXISTS   */
*             4  CONCRPL BIT(1),      /* CRPL POOL EXISTS            */
*         2 CONRSV17 CHAR(1),         /* RESERVED FOR ALIGNMENT      */
*   /***    START BUFFERS           ***/                           1198
*         2 CONSFSBF CHAR(12),        /* SMALL FIXED LIST            */
*         2 CONSPSBF CHAR(12),        /* SMALL PAGEABLE LIST         */
*         2 CONLFSBF CHAR(12) BDY(HWORD), /* LARGE FIXED LIST        */
*         2 CONLPSBF CHAR(12),        /* LARGE PAGEABLE LIST         */
*         2 CONVFSBF CHAR(12),        /* VARIABLE LENGTH FIXED LIST  */
*         2 CONVPSBF CHAR(12),        /* VARIABLE-LENGTH PAGEABLE    */
*         2 CONIOSBF CHAR(12),        /* I/O FIXED LIST              */
*         2 CONWPSBF CHAR(12),        /* WORKING SET POOL LIST       */
*         2 CONAPSBF CHAR(12),        /* ACE/ICE POOL LIST           */
*         2 CONNPSBF CHAR(12),        /* NON-WORKING SET LIST        */
*         2 CONPPSBF CHAR(12),        /* PAGEABLE DATA POOL LIST     */
*         2 CONCRPLS CHAR(12),        /* CRPL POOL LIST              */
*   /***    DEFAULT BUFFERS         ***/                           1198
*         2 CONSFDBF CHAR(12),        /* SMALL FIXED LIST            */
*         2 CONSPDBF CHAR(12),        /* SMALL PAGEABLE LIST         */
*         2 CONLFDBF CHAR(12),        /* LARGE FIXED LIST            */
*         2 CONLPDBF CHAR(12),        /* LARGE PAGEABLE LIST         */
*         2 CONVFDBF CHAR(12),        /* VARIABLE-LENGTH FIXED LIST  */
*         2 CONVPDBF CHAR(12),        /* VARIABLE-LENGTH PAGEABLE    */
*         2 CONUEDBF CHAR(12),        /* UECB LIST                   */
*         2 CONIODBF CHAR(12),        /* I/O FIXED LIST              */
*         2 CONWPDBF CHAR(12),        /* WORKING SET POOL LIST       */
*         2 CONAPDBF CHAR(12),        /* ACE/ICE POOL LIST           */
*         2 CONNPDBF CHAR(12),        /* NON-WORKING SET POOL LIST   */
*         2 CONPPDBF CHAR(12),        /* PAGEABLE DATA POOL LIST     */
*         2 CONCRPLD CHAR(12),        /* CRPL POOL LIST              */
*         2 CONFLG01 CHAR (1),        /* INIT/TERM FLAGS             */
*           3 CONFTSTM BIT(1),        /* BIT TO INDICATE SET TIMER   */
*           3 CONFTTMR BIT(1),        /* BIT TO INDICATE TIMER IS  1198
*                                        RUNNING                     */
*           3 CONFTEXS BIT(1),        /* EXITS SCHEDULED FLAG        */
*           3 CONFTNAC BIT(1),        /* NO ACTIVE CONNECTIONS FLAG  */
*           3 CONFTNSA BIT(1),        /* BIT TO INDICATE NETWORK   1198
*                                        SOLICITOR ACTIVE            */
*           3 CONFTTA BIT(1),         /* TO INDICATE TOLTEP ACTIVE   */
*           3 CONFTPSA BIT(1),        /* BIT TO INDICATE PORT SOLICITOR
*                                        ACTIVE                      */
*           3 CONNSNEC BIT(1),        /* INDICATE NETWORK SOLICITOR
*                                         IS NECESSARY               */
*          2 CONRSV01 CHAR(3),        /* RESERVED - FOR ALIGNMENT    */
*          2 CONVTHDR CHAR(LENGTH(ISTRDT)) BDY(WORD),  /* VTAM RDT 1198
*                                        HEADER                      */
*          2 CONVVTAM CHAR(LENGTH(ISTRAP)) BDY(WORD), /* APPLICATION
*                                         ENTRY FOR VTAM             */
*          2 CONTOLTP CHAR(LENGTH(ISTRAP)) BDY(WORD), /* APPLICATION
*                                         ENTRY FOR TOLTEP           */
*          2 CONTRACE CHAR(LENGTH(ISTRAP)) BDY(WORD), /* APPLICATION
*                                         ENTRY FOR TRACE            */
*          2 CONNTSOL CHAR(LENGTH(ISTRAP)) BDY(WORD),  /* APPLICATION
*                                         ENTRY FOR NETSOL           */
*          2 CONRECON CHAR(LENGTH(ISTRAP)) BDY(WORD), /* APPLICATION */
*                                              /* ENTRY FOR RECOVERY */
*          2 CONECDET FIXED(31),      /* ECB TO BE POSTED UPON     1198
*                                        SUBTASK COMPLETION          */
*          2 CONSTAFP PTR(31),        /* FOOTPRINT FOR NON-PSS STAE
*                                        RTN. FOR VTAM TASK          */
*          2 CONLIST CHAR(2),         /* TWO CHARACTER STORAGE AREA
*                                        FOR THE 'LIST=ID' OPERAND 1198
*                                        ON A START COMMAND. SET AND
*                                        REFERENCED BY THE CONF CTL
*                                        MODULE OF INITIALIZATION  1198
*                                        (ISTINCCC)                  */
*          2  CONRSV50 FIXED(15),      /* RESERVED PRESERVE ALIGNMENT*/
*          2  CONCSCB PTR(31),         /* PTR FOR CSCB               */
*          2  CONFNSAT CHAR(LENGTH(ISTLDPRM)),  /* ATTACH PARAMETER
*                                      LIST FOR NETWORK SOLICTOR     */
*          2  CONFTRAT CHAR(LENGTH(ISTLDPRM)),  /* ATTACH PARAMETER
*                                      LIST FOR TRACE                */
*          2  CONFLDAT CHAR(LENGTH(ISTLDPRM)),  /* ATTACH PARAMETER
*                                      LIST FOR LOAD/DUMP            */
*          2  CONFXXAT CHAR(LENGTH(ISTLDPRM)),  /* ATTACH PARAMETER
*                                         LIST FOR SYS DEF           */
*          2  CONFTTAT CHAR(LENGTH(ISTLDPRM)),  /* ATTACH PARAMETER
*                                      LIST FOR TOLTEP               */
*          2  CONRSV24 CHAR(LENGTH(ISTLDPRM)),  /* RESERVED          */
*          2  CONGLBBH FIXED(8),       /*                            */
*          2  CONRVPT1 CHAR(1),        /* RESERVED                   */
*          2  CONUNITS FIXED(15),      /* RN HOST BUFFERSIZE, LBUF 1198
*                                         DOS/VS, IOBUF IN VS/1,2    */
*          2  CONSDECB PTR(31),        /* ECB USED TO POST ISTSDCLM
*                                         TO RUN SYS DEF IO CODE     */
*          2  CONSDMLC PTR(31),        /* PTR TO SYS DEF PARAMETER LIST
*                                         ISTMLCA                    */
*          2  CONF01SV PTR(31),        /* HOST ATTACH SAVE AREA PTR  */
*          2  CONSCPID BIT(48),        /* SSCPID                     */
*            3 CONFCNL  BIT(8),        /* FUNCTION LEVEL             */
*            3 CONFILL  BIT(8),        /* FILLER                     */
*            3 CONBLKNO BIT(12),       /* BLOCK NUMBER               */
*            3 CONSTAID BIT(20),       /* STATION ID                 */
*              4 CONSTFIL BIT(4),      /* STATION ID FILLER          */
*              4 CONSTVAR BIT(16),     /* VARIABLE PORTION OF ID     */
*          2  CONUESBF CHAR(12);       /* UECB LIST                  */
*/********************************************************************/
*/*                                                                  */
*/*  ISTTPMPL - TPMSG PARAMETER LIST MAPPING MACRO                   */
*/*                                                                  */
*/********************************************************************/
*DCL  1  ISTTPMPL BDY(WORD) BASED, /* TPMSG PARAMETER LIST           */
*        2 TPMPLMID PTR(31),       /* PTR TO MESSAGE ID              */
*        2 TPMPLRLN FIXED(8),      /* LENGTH OF REPLY BUFFER         */
*        2 TPMPLRBA PTR(24),       /* PTR TO REPLY BUFFER            */
*        2 TPMPLRNF PTR(31),       /* REQUESTOR NOTIF FIELD          */
*        2 TPMPLTXT PTR(31),       /* PTR TO MESSAGE TEXT            */
*        2 TPMPLCID PTR(31);       /* PTR TO CONSOLE ID              */
*/********************************************************************/
*/*                                                                  */
*/*  ISTDLRPL - D/L/R PARAMETER LIST MAPPING MACRO                   */
*/*                                                                  */
*/********************************************************************/
*DCL  1  ISTDLRPL BDY(WORD) BASED, /* D/L/R PARAMETER LIST           */
*        2 DLRPLRSA CHAR(72),      /* REGISTER SAVE AREA             */
*          3 DLRPLIDF FIXED(8),    /* CONTROL BLOCK ID FIELD         */
*          3 DLRPLLTH FIXED(8),    /* CONTROL BLOCK LENGTH           */
*          3 DLRPLFCD FIXED(8),    /* D/L/R FUNCTION CODE            */
*          3 DLRPLRCD FIXED(8),    /* D/L/R RETURN CODE              */
*          3 DLRPLQPT PTR(31),     /* TPQUE/TPDEQ CHAIN PTR          */
*          3 *        CHAR(8),     /* FWD PTR, REG 14 SAVE           */
*          3 DLRPLR15 PTR(31),     /* REG 15 SAVE AREA               */
*        2 DLRPLRPF FIXED(8),      /* REQUESTOR NOTIF FLAGS          */
*        2 DLRPLRNF PTR(24),       /* REQUESTOR NOTIF FIELDS         */
*        2 DLRPLUSR PTR(31),       /* USER DATA FIELD                */
*        2 DLRPLIST CHAR(*);       /* PARAMETER LIST                 */
*/********************************************************************/
*/*                                                                  */
*/*  ISTDLRPL CONTROL BLOCK ID FOR FIELD DLRPLIDF                    */
*/*                                                                  */
*/********************************************************************/
*DCL DLRPLBID BIT(8) CONSTANT('50'X);/* ISTDLRPL CBID                */
*/********************************************************************/
*/*                                                                  */
*/* FUNCTION CODE VALUES FOR FIELD DLRPLFCD                          */
*/*                                                                  */
*/********************************************************************/
*DCL DLRPLCKP FIXED(8) CONSTANT(43);  /* FUNCTION = CKPTN            */
*DCL DLRPLCPM FIXED(8) CONSTANT(189); /* FUNCTION = CPMSG            */
*/********************************************************************/
*/*                                                                  */
*/*  REQUESTOR NOTIFICATION VALUES FOR FIELD DLRPLRPF                */
*/*                                                                  */
*/********************************************************************/
*DCL DLRPLNON FIXED(8) CONSTANT(0);  /* NO NOTIFICATION              */
*DCL DLRPLRTN FIXED(8) CONSTANT(1);  /* DLRPLRNF -> RTN              */
*DCL DLRPLRPH FIXED(8) CONSTANT(2);  /* DLRPLRNF -> RPH              */
*DCL DLRPLECB FIXED(8) CONSTANT(3);  /* DLRPLRNF -> ECB              */
*DCL DLRPLPAB FIXED(8) CONSTANT(4);  /* DLRPLRNF -> PAB              */
*/********************************************************************/
*/*                                                                  */
*/* PARAMETER LIST FOR MODULE ISTINCOQ                               */
*/*                                                                  */
*/********************************************************************/
*DCL 1 DLRPLCOQ DEFINED(DLRPLIST), /* ISTINCOQ PARAMETER LIST        */
*      2 DLRPLOPT BIT(32),         /* RESPONSE PROC OPTIONS          */
*        3 DLRPLFOL BIT(1),        /* 1 = FOLD RESPONSE              */
*        3 DLRPLGYN BIT(1),        /* 1 = GUARANTEE YES | NO         */
*      2 DLRPLTPM CHAR(LENGTH(ISTTPMPL));  /* TPMSG PLIST            */
*/********************************************************************/
*/* PARAMETER LIST FOR MODULE ISTINCR6                               */
*/********************************************************************/
*DCL 1 DLRPLCR6 DEFINED(DLRPLIST), /* ISTINCR6 PARAMETER LIST        */
*      2 DLRPLCON PTR(31),         /* POINTER TO CONSOLE ID          */
*      2 DLRPLNOD PTR(31),         /* POINTER TO NODE ID             */
*      2 *        PTR(31),         /* CR6 OPTIONS AREA               */
*        3 DLRPLFNC FIXED(8),      /* CR6 OP CODE FIELD              */
*        3 DLRPLSWS BIT(8),        /* CR6 SWITCHES                   */
*      2 DLRPLMID CHAR(4),         /* CR6 MESSAGE ID FIELD           */
*      2 DLRPLSA1 PTR(31),         /* CR6 SAVE AREA 1                */
*      2 DLRPLSA2 PTR(31),         /* CR6 SAVE AREA 2                */
*      2 DLRPLMSG CHAR(20),        /* CR6 MESSAGE TEXT AREA          */
*      2 DLRPLTPL CHAR(LENGTH(ISTTPMPL)); /* TPMSG PARAM LIST        */
*/********************************************************************/
*/* CKPTN FUNCTION CODES FOR FIELD DLRPLFNC                          */
*/********************************************************************/
*DCL DLRPLOPN FIXED(8) CONSTANT(1);  /* CKPTN FUNC(OPEN)             */
*DCL DLRPLADD FIXED(8) CONSTANT(2);  /* CKPTN FUNC(ADD)              */
*DCL DLRPLDEL FIXED(8) CONSTANT(3);  /* CKPTN FUNC(DELETE)           */
*DCL DLRPLCLS FIXED(8) CONSTANT(4);  /* CKPTN FUNC(CLOSE)            */
*/* VTAM ADDRESS VECTOR TABLE */                                   1215
*/*  REVISIONS                                         002 03/06/75  */
*DCL  1  ISTAVT BDY(WORD) BASED,                                   1215
*       2  ISTACVT PTR(31),            /* ADDR OF VTAM CVT           */
*       2  ISTAS49 PTR(31),            /* ADDR OF SVC 49 CODE        */
*          3  ISTAHIP BIT(1),          /* HALT IN PROGRESS           */
*       2  ISTAS53 PTR(31),            /* ADDR OF SVC 53 CODE        */
*       2  ISTAPSTA PTR(31),           /* ADDR OF APS TABLE          */
*       2  AVTASID FIXED(15),          /* VTAM ASID                  */
*       2  ISTVTTIK FIXED(15),         /* VTAMRP TASK ID             */
*       2  ISTAPSEX PTR(31),           /* ADDR OF APS EXIT           */
*       2  ISTPHNM CHAR(5),            /* PHASE NAME OF TRANSIENT    */
*       2  ISTX1 CHAR(1),              /* TEST FIELD                 */
*       2  ISTARID PTR(15),            /* ADDR OF RID                */
*       2  ISTATRT PTR(15),            /* ADDR OF VTAM GATES IN RETAB*/
*       2  ISTAGTWT PTR(15),           /* ADDR OF GATEWAIT ROUTINE   */
*       2  ISTVTTP  PTR(15),           /* ADDR OF CODE TO CHECK FOR  */
*                                      /* PENDING TIMER INTERRUPT    */
*       2  ISTAVR01 CHAR(2),           /* RESERVED                   */
*       2  ISTPDAVP PTR(31);           /* VECTOR FOR PDAIDS SMS TRACE*/
*                                                                  1216
* DECLARE                                                          1216
*   EMCR0 PTR REG(0),                                              1216
*   EMCR1 PTR REG(1),                                              1216
*   EMCR2 PTR REG(2),                                              1216
*   EMCR3 PTR REG(3),                                              1216
*   EMCR4 PTR REG(4),                                              1216
*   EMCR5 PTR REG(5),                                              1216
*   EMCR6 PTR REG(6),                                              1216
*   EMCR7 PTR REG(7),                                              1216
*   EMCR8 PTR REG(8),                                              1216
*   EMCR9 PTR REG(9),                                              1216
*   EMCR10 PTR REG(10),                                            1216
*   EMCR11 PTR REG(11),                                            1216
*   EMCR12 PTR REG(12),                                            1216
*   EMCR13 PTR REG(13),                                            1216
*   EMCR14 PTR REG(14),                                            1216
*   EMCR15 PTR REG(15);                                            1216
* DCL ISTAPC34 ENTRY BASED(ATCAP34) VALRG(*); /*RESET ROUTINE*/    1217
* DCL ISTAPC37 ENTRY BASED(ATCAP37) VALRG(*); /*TPQUE ROUTINE*/    1218
* GEN (PRINT ON);                                                  1219
         PRINT ON
*/* END OF TPEPILOG */                                             1220
*END ISTINCR6                                                      1220
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (IFGACB  )                                        *
*/*%INCLUDE SYSLIB  (IFGRPL  )                                        *
*/*%INCLUDE SYSLIB  (IDAAMB  )                                        *
*/*%INCLUDE SYSLIB  (IDAAMBL )                                        *
*;                                                                 1220
         B     @EL00001                                            1220
@DATA    DS    0H
@CH00165 DC    H'2'
@CH00177 DC    H'9'
@DATD    DSECT
         DS    0F
ISTINCR6 CSECT
         DS    0F
@CF00125 DC    F'1'
@CH00125 EQU   @CF00125+2
@CF00137 DC    F'3'
@CH00137 EQU   @CF00137+2
@CF00168 DC    F'4'
@CH00168 EQU   @CF00168+2
@CF00306 DC    F'5'
@CH00306 EQU   @CF00306+2
@CF01359 DC    XL4'08000000'
@CF01362 DC    XL4'04000000'
@CF02827 DC    XL4'0000FFFF'
@DATD    DSECT
         DS    0D
ISTINCR6 CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
CMZA0007 DS    FL4
         ORG   CMZA0007
@NM00040 DC    AL1(32)
@NM00041 DC    AL1(96)
@NM00042 DC    AL1(231)
@NM00043 DC    XL1'00'
         ORG   CMZA0007+4
CMZA0034 DS    FL4
         ORG   CMZA0034
@NM00046 DC    AL1(32)
@NM00047 DC    AL1(96)
@NM00048 DC    AL1(241)
@NM00049 DC    XL1'00'
         ORG   CMZA0034+4
CMZA0052 DS    FL4
         ORG   CMZA0052
@NM00050 DC    AL1(0)
@NM00051 DC    AL1(96)
@NM00052 DC    AL1(231)
@NM00053 DC    XL1'01'
         ORG   CMZA0052+4
CMZA0089 DS    FL4
         ORG   CMZA0089
@NM00058 DC    AL1(0)
@NM00059 DC    AL1(96)
@NM00060 DC    AL1(231)
@NM00061 DC    XL1'01'
         ORG   CMZA0089+4
@CC00451 DC    C'425I'
@CC00453 DC    C'424I'
@CC00455 DC    C'423I'
@CC00457 DC    C'422I'
@CC00459 DC    C'421I'
@CC00647 DC    C'00'
@CB00483 DC    X'0000'
CR6TBL   DC    CL16'0123456789ABCDEF'
ISTINCR6 CSECT
RPLBASE            RPL OPTCD=(DIR,ASY,UPD),AM=VSAM
ACBBASE           ACB MACRF=(DIR,OUT),AM=VSAM
ISTINCR6 CSECT
OPNBASE          OPEN  (CR6ACB),MF=L
CLSBASE          CLOSE  (CR6ACB),MF=L
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
ISTINCR6 CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
J        EQU   @03
GPR00F   EQU   @00
GPR00P   EQU   @00
GPR01F   EQU   @01
GPR01P   EQU   @01
GPR02F   EQU   @02
GPR02P   EQU   @02
GPR03F   EQU   @03
GPR03P   EQU   @03
GPR04F   EQU   @04
GPR04P   EQU   @04
GPR05F   EQU   @05
GPR05P   EQU   @05
GPR06F   EQU   @06
GPR10P   EQU   @10
GPR14F   EQU   @14
GPR14P   EQU   @14
GPR15F   EQU   @15
GPR15P   EQU   @15
CR6R01   EQU   @01
CR6RPLAD EQU   @07
CR6DPLAD EQU   @02
CR6R03   EQU   @03
CR6R04   EQU   @04
CR6R6    EQU   @06
CR6WKPT  EQU   @08
CR6R09   EQU   @09
CR6MSGNO EQU   @09
CR6MSGTX EQU   @10
CR6R11   EQU   @11
CR6R13   EQU   @13
CR6R14   EQU   @14
CR6R15   EQU   @15
REG1025  EQU   @01
EMCR13   EQU   @13
REG15025 EQU   @15
REG1071  EQU   @01
REG15071 EQU   @15
REG1080  EQU   @01
REG15080 EQU   @15
RPHPTR   EQU   @01
LDPRMPTR EQU   @01
EMCR0    EQU   @00
EMCR1    EQU   @01
EMCR10   EQU   @10
EMCR11   EQU   @11
EMCR12   EQU   @12
EMCR14   EQU   @14
EMCR15   EQU   @15
EMCR2    EQU   @02
EMCR3    EQU   @03
EMCR4    EQU   @04
EMCR5    EQU   @05
EMCR6    EQU   @06
EMCR7    EQU   @07
EMCR8    EQU   @08
EMCR9    EQU   @09
GPR06P   EQU   @06
GPR07F   EQU   @07
GPR07P   EQU   @07
GPR08F   EQU   @08
GPR08P   EQU   @08
GPR09F   EQU   @09
GPR09P   EQU   @09
GPR10F   EQU   @10
GPR11F   EQU   @11
GPR11P   EQU   @11
GPR12F   EQU   @12
GPR12P   EQU   @12
GPR13F   EQU   @13
GPR13P   EQU   @13
ATCLCPTR EQU   1032
ISTPOHD  EQU   0
POHSTAT  EQU   ISTPOHD+1
ISTPFX   EQU   0
PFXID    EQU   ISTPFX
ISTNCSPL EQU   0
@NM00062 EQU   ISTNCSPL
NCSPFX   EQU   @NM00062
NCSPLVBF EQU   ISTNCSPL+18
NCSPLVFL EQU   ISTNCSPL+20
NCSPLVF1 EQU   ISTNCSPL+21
NCSPLCMD EQU   ISTNCSPL+60
NCSCMDA  EQU   NCSPLCMD
NCSCRFLG EQU   ISTNCSPL+67
NCSPLRAD EQU   ISTNCSPL+144
NCSIOCID EQU   ISTNCSPL+148
NCSPLCID EQU   NCSIOCID
NCSPLFSB EQU   ISTNCSPL+168
NCSPLFL1 EQU   ISTNCSPL+176
NCSPLFL2 EQU   ISTNCSPL+177
NCSPLFL3 EQU   ISTNCSPL+178
NCSPLFL4 EQU   ISTNCSPL+179
NCSPLFL5 EQU   ISTNCSPL+181
NCSPLAPP EQU   ISTNCSPL+216
NCSSENSE EQU   ISTNCSPL+244
NCSCRMSK EQU   ISTNCSPL+268
NCSCHKPT EQU   NCSCRMSK
NCSCRMOD EQU   NCSCRMSK+2
NCSPLSID EQU   ISTNCSPL+271
NCSPLSTA EQU   NCSPLSID
NCSPLPHD EQU   NCSPLSID+1
NCSAPP   EQU   0
NCSAPBUE EQU   NCSAPP+88
ISTRPH   EQU   0
RPHCNTL  EQU   ISTRPH
RPHFLAGS EQU   RPHCNTL+2
RPHAPTYP EQU   RPHFLAGS
RPHFSTLC EQU   RPHFLAGS
RPHFLGB  EQU   RPHCNTL+3
RPHRPHA  EQU   ISTRPH+4
RPHTSKID EQU   ISTRPH+8
RPHRESMA EQU   ISTRPH+16
RPHWPFLG EQU   RPHRESMA
RPHWT    EQU   RPHWPFLG
RPHPABOF EQU   ISTRPH+20
RPHMAJCB EQU   ISTRPH+21
RPHWEA   EQU   ISTRPH+24
RPHCSPA  EQU   RPHWEA
RPHSRPRM EQU   ISTRPH+28
RPHPABQA EQU   ISTRPH+36
RPHWORK  EQU   ISTRPH+40
RPHSAVE1 EQU   RPHWORK
RPHSBITS EQU   RPHSAVE1+1
ISTPAB   EQU   0
PABWQCHN EQU   ISTPAB
PABWEQA  EQU   PABWQCHN
PABCHAIN EQU   PABWQCHN+4
PABRPHFG EQU   ISTPAB+12
PABFLAGS EQU   PABRPHFG
PABERLCK EQU   PABFLAGS
PABERRLK EQU   PABERLCK
ISTLOK   EQU   0
LOKCHN   EQU   ISTLOK+1
LOKCHNG  EQU   LOKCHN
@NM00071 EQU   LOKCHNG+2
ISTDYPAB EQU   0
ISTATCVT EQU   0
ATCCOM   EQU   ISTATCVT
ATCSTAT  EQU   ATCCOM
ATCSTAT1 EQU   ATCSTAT
ATCSTFLG EQU   ATCSTAT+1
ATCPOFLG EQU   ATCSTAT+2
ATCSTAT4 EQU   ATCSTAT+3
ATCCONFT EQU   ATCCOM+112
ATCIOTRC EQU   ATCCOM+140
ATCTHTRC EQU   ATCIOTRC
ATCGTSTR EQU   ATCCOM+164
ATCCSMR  EQU   ISTATCVT+296
ATCSHRFG EQU   ISTATCVT+316
ATCMSGP  EQU   ISTATCVT+344
ATCHPGM  EQU   ISTATCVT+384
ATCNODEL EQU   ISTATCVT+420
ATCNODDS EQU   ISTATCVT+428
ATCONFIG EQU   ISTATCVT+432
ATCVLCNT EQU   ISTATCVT+772
ATCRNO   EQU   ISTATCVT+788
ATCSOPD  EQU   ISTATCVT+792
ATCSIPD  EQU   ISTATCVT+800
ATCSECST EQU   ISTATCVT+812
ATCSTAT2 EQU   ISTATCVT+818
ATCVTBAM EQU   ISTATCVT+908
@NM00079 EQU   ATCVTBAM+3
ATCAOSM  EQU   ISTATCVT+912
ATCGSRBQ EQU   ATCAOSM+4
ATCGSRBG EQU   ATCGSRBQ
ATCAP32  EQU   ATCAOSM+28
ATCAP34  EQU   ATCAOSM+32
ATCICAPP EQU   ATCAOSM+100
ATCLDAPP EQU   ATCAOSM+120
ATCDAPVT EQU   ATCAOSM+140
ATCAP37  EQU   ATCAOSM+264
ATCCRA   EQU   ATCAOSM+280
ATCCRACN EQU   ATCCRA+4
ATCSRB   EQU   ATCAOSM+288
ATCSRBCN EQU   ATCSRB+4
ATCCRPL  EQU   ATCAOSM+296
ATCRPLCN EQU   ATCCRPL+4
ATCVTFLG EQU   ATCAOSM+392
ATCZFLAG EQU   ATCAOSM+588
ISTDEVCH EQU   0
DEVSHCH  EQU   ISTDEVCH
DEVCHAR  EQU   DEVSHCH
DEVTCODE EQU   ISTDEVCH+1
DEVFLAGS EQU   ISTDEVCH+3
DEVFCCTL EQU   DEVFLAGS
DEVCHAR3 EQU   DEVFLAGS
ISTLDPRM EQU   0
LDPFG    EQU   ISTLDPRM+20
LDPFB2   EQU   ISTLDPRM+21
ISTRPRE  EQU   0
RPRCOMID EQU   ISTRPRE+8
RPRFLAGA EQU   ISTRPRE+21
RPRFLAGB EQU   ISTRPRE+22
RPRCAUSE EQU   ISTRPRE+23
RPRFLAGD EQU   ISTRPRE+61
RPRFLAGC EQU   ISTRPRE+62
ISTRCPRE EQU   0
RCPPMODE EQU   ISTRCPRE+91
RCPLGNIN EQU   ISTRCPRE+92
ISTRDT   EQU   0
RDTPLEN  EQU   ISTRDT+72
RDTPRIOR EQU   RDTPLEN
RDTFLAGB EQU   ISTRDT+91
RDTVYRPH EQU   ISTRDT+108
RDTSTCNT EQU   ISTRDT+112
ISTRAP   EQU   0
RAPFLG   EQU   ISTRAP+108
RAPFLGB  EQU   ISTRAP+109
RAPFLGC  EQU   ISTRAP+110
ISTRLC   EQU   0
RLCADR   EQU   ISTRLC+72
RLCFLAG  EQU   RLCADR
ISTRRN   EQU   0
RRNADR   EQU   ISTRRN+136
RRNFLAG  EQU   RRNADR
RRNUCBAD EQU   RRNADR+1
RRNRDF   EQU   ISTRRN+172
RRNRDFA  EQU   RRNRDF
RRNRDFB  EQU   RRNRDF+1
RRNCMF   EQU   ISTRRN+176
RRNCMFA  EQU   RRNCMF
RRNCMFB  EQU   RRNCMF+1
RRNCMFC  EQU   RRNCMF+2
RRNCMFD  EQU   RRNCMF+3
RRNNMDPD EQU   ISTRRN+192
RRNHPRE  EQU   ISTRRN+216
ISTRGP   EQU   0
RGPFLG   EQU   ISTRGP+72
ISTRLN   EQU   0
RLNADR   EQU   ISTRLN+72
RLNFLAG  EQU   RLNADR
RLNUCBAD EQU   RLNADR+1
RLNSTAT1 EQU   ISTRLN+86
RLNSTAT2 EQU   ISTRLN+87
RLNRDF   EQU   ISTRLN+88
RLNRDFA  EQU   RLNRDF
RLNRACNT EQU   RLNRDFA
RLNRDFB  EQU   RLNRDF+1
RLNCRFLG EQU   ISTRLN+102
RLNLSCMD EQU   RLNCRFLG
ISTRPT   EQU   0
RPTLNCID EQU   ISTRPT+116
RPTDITT  EQU   ISTRPT+128
RPTFLAG1 EQU   ISTRPT+140
ISTRCL   EQU   0
RCLADR   EQU   ISTRCL+72
RCLFLAG  EQU   RCLADR
ISTRTR   EQU   0
RTRADR   EQU   ISTRTR+124
RTRFLAG  EQU   RTRADR
RTRRDFA  EQU   ISTRTR+136
RTRRAALL EQU   RTRRDFA
RTRRDFB  EQU   ISTRTR+137
RTRRDFC  EQU   ISTRTR+138
RTRRDFD  EQU   ISTRTR+139
RTRRDFE  EQU   ISTRTR+140
RTRRDFF  EQU   ISTRTR+141
RTRCRFLG EQU   ISTRTR+143
RTRLSCMD EQU   RTRCRFLG
RTRBSCID EQU   ISTRTR+188
ISTRIN   EQU   0
RINDFD   EQU   ISTRIN+124
RINREMPO EQU   RINDFD
RINNODEF EQU   RINDFD
RINLDISC EQU   RINDFD
RINNODID EQU   ISTRIN+125
RINRLDAF EQU   ISTRIN+126
RINREMOT EQU   ISTRIN+128
RINVPAB  EQU   ISTRIN+132
RINRPHCN EQU   ISTRIN+136
RINNCSPL EQU   ISTRIN+140
RINCNCNT EQU   ISTRIN+144
ISTRDS   EQU   0
ISTDOT   EQU   0
ISTRCC   EQU   0
RCCFLAG  EQU   ISTRCC+73
RCCFLAGB EQU   ISTRCC+74
RCCSTAID EQU   ISTRCC+78
RCCID48  EQU   RCCSTAID+2
RCCCRFLG EQU   ISTRCC+108
ISTRLU   EQU   0
RLUFLAG  EQU   ISTRLU+125
RLUCRFLG EQU   ISTRLU+126
RLUPACE  EQU   ISTRLU+132
RLUNCPPC EQU   ISTRLU+134
RLUUSSTB EQU   ISTRLU+140
RLUMODET EQU   ISTRLU+152
ISTRPX   EQU   0
ISTRLX   EQU   0
RLXFLAGA EQU   ISTRLX+76
ISTRSW   EQU   0
ISTRDA   EQU   0
RDAADR   EQU   ISTRDA+72
RDAFLAG  EQU   RDAADR
RDAUCBAD EQU   RDAADR+1
ISTRLS   EQU   0
ISTDNT   EQU   0
ISTGNT   EQU   0
ISTPAT   EQU   0
PATFLAGA EQU   ISTPAT+7
ISTCONFT EQU   0
CONCONFG EQU   ISTCONFT
CONRDBUF EQU   ISTCONFT+76
CONBUFSZ EQU   ISTCONFT+100
CONHALT  EQU   ISTCONFT+106
CONFLAGS EQU   ISTCONFT+110
CONDSFLG EQU   CONFLAGS
CONOPTFL EQU   CONFLAGS+1
CONSTAT  EQU   CONFLAGS+2
CONBUFF  EQU   CONFLAGS+3
CONFLG01 EQU   ISTCONFT+416
CONSCPID EQU   ISTCONFT+1356
CONSTAID EQU   CONSCPID+3
ISTTPMPL EQU   0
ISTDLRPL EQU   0
DLRPLRSA EQU   ISTDLRPL
DLRPLRCD EQU   DLRPLRSA+3
DLRPLRPF EQU   ISTDLRPL+72
DLRPLRNF EQU   ISTDLRPL+73
DLRPLIST EQU   ISTDLRPL+80
IFGACB   EQU   0
ACBCOMN  EQU   IFGACB
ACBLENG  EQU   ACBCOMN+2
ACBLENG2 EQU   ACBLENG
ACBAMBL  EQU   ACBCOMN+4
ACBJWA   EQU   ACBAMBL
ACBMACRF EQU   ACBCOMN+12
ACBMACR1 EQU   ACBMACRF
ACBADR   EQU   ACBMACR1
ACBCNV   EQU   ACBMACR1
ACBMACR2 EQU   ACBMACRF+1
ACBBUFPL EQU   ACBCOMN+20
ACBMACR3 EQU   ACBBUFPL
ACBRECFM EQU   ACBCOMN+24
ACBCCTYP EQU   ACBCOMN+25
ACBOPT   EQU   ACBCOMN+26
ACBDSORG EQU   ACBOPT
ACBCROPS EQU   ACBDSORG
ACBDVIND EQU   ACBDSORG
ACBEXLST EQU   ACBCOMN+36
ACBDDNM  EQU   ACBCOMN+40
ACBAMETH EQU   ACBDDNM+3
ACBOFLGS EQU   ACBCOMN+48
ACBEXFG  EQU   ACBOFLGS
ACBIOSFG EQU   ACBOFLGS
ACBERFLG EQU   ACBCOMN+49
ACBINFLG EQU   ACBCOMN+50
ACBVVIC  EQU   ACBINFLG
ACBUJFCB EQU   ACBCOMN+52
ACBBLKSZ EQU   ACBCOMN+60
ACBLRECL EQU   ACBCOMN+62
IFGRPL   EQU   0
RPLCOMN  EQU   IFGRPL
RPLIDWD  EQU   RPLCOMN
RPLLEN   EQU   RPLIDWD+3
RPLECB   EQU   RPLCOMN+8
RPLFDBWD EQU   RPLCOMN+12
RPLFDBK  EQU   RPLFDBWD+1
RPLRTNCD EQU   RPLFDBK
RPLCNDCD EQU   RPLFDBK+1
RPLCMPON EQU   RPLCNDCD
RPLFDB2  EQU   RPLCMPON
RPLERRCD EQU   RPLCNDCD+1
RPLFDB3  EQU   RPLERRCD
RPLKEYLE EQU   RPLCOMN+16
RPLKEYL  EQU   RPLKEYLE
RPLDACB  EQU   RPLCOMN+24
RPLAREA  EQU   RPLCOMN+32
RPLARG   EQU   RPLCOMN+36
RPLOPTCD EQU   RPLCOMN+40
RPLOPT1  EQU   RPLOPTCD
RPLDIR   EQU   RPLOPT1
RPLSEQ   EQU   RPLOPT1
RPLKGE   EQU   RPLOPT1
RPLECBSW EQU   RPLOPT1
RPLOPT2  EQU   RPLOPTCD+1
RPLADR   EQU   RPLOPT2
RPLUPD   EQU   RPLOPT2
RPLOPT3  EQU   RPLOPTCD+2
RPLOPT4  EQU   RPLOPTCD+3
RPLNXTRP EQU   RPLCOMN+44
RPLRLEN  EQU   RPLCOMN+48
RPLBUFL  EQU   RPLCOMN+52
RPLOPTC2 EQU   RPLCOMN+56
RPLOPT5  EQU   RPLOPTC2
RPLWRTYP EQU   RPLOPT5
RPLOPT6  EQU   RPLOPTC2+1
RPLUNTYP EQU   RPLOPT6
RPLOPT7  EQU   RPLOPTC2+2
RPLCNOPT EQU   RPLOPT7
RPLOPT8  EQU   RPLOPTC2+3
RPLRBAR  EQU   RPLCOMN+60
RPLAIXID EQU   RPLRBAR+2
RPLEXTDS EQU   RPLCOMN+68
RPLEXTD1 EQU   RPLEXTDS
USRTN    EQU   0
CR6SA    EQU   0
CR6BCKPT EQU   CR6SA+4
CR6FWDPT EQU   CR6SA+8
CR6NAME  EQU   0
CR6CNF   EQU   0
CR6RECRD EQU   0
CR6KEY   EQU   CR6RECRD
CR6MAJ   EQU   CR6RECRD+2
CR6GTSTR EQU   0
CR6RPL   EQU   CR6GTSTR
CR6ACB   EQU   CR6GTSTR+76
CR6REC   EQU   CR6GTSTR+152
CR6OPN   EQU   CR6GTSTR+162
CR6CLS   EQU   CR6GTSTR+166
CR6CNT   EQU   CR6GTSTR+170
CR6GTSZ  EQU   CR6GTSTR+172
CR6KEYSV EQU   CR6GTSTR+174
WBITS    EQU   CR6GTSTR+176
FIRSTSW  EQU   WBITS
IDAAMB   EQU   0
AMBEOVR  EQU   IDAAMB+24
AMBFLG0  EQU   AMBEOVR
AMBFLG1  EQU   IDAAMB+25
AMBINBUF EQU   AMBFLG1
AMBDSORG EQU   IDAAMB+26
AMBIOBAD EQU   IDAAMB+28
AMBINFL  EQU   IDAAMB+42
AMBDEBPT EQU   IDAAMB+44
AMBOFLGS EQU   IDAAMB+48
AMBFLG2  EQU   IDAAMB+49
AMBEOVPT EQU   IDAAMB+56
AMBCSWD1 EQU   IDAAMB+84
AMBAFLG  EQU   AMBCSWD1
IDAAMBL  EQU   0
AMBLEOV  EQU   IDAAMBL+12
AMBLEFLG EQU   AMBLEOV
AMBLSHAR EQU   IDAAMBL+33
AMBLFLG1 EQU   IDAAMBL+35
AMBLFLG2 EQU   IDAAMBL+36
AMBLDTA  EQU   IDAAMBL+52
@NM00044 EQU   0
CMZID025 EQU   @NM00044
@NM00045 EQU   @NM00044+4
CMZRL025 EQU   @NM00045
CMZRA025 EQU   @NM00045+1
CMZEA025 EQU   @NM00044+8
CMZVP025 EQU   @NM00044+12
CMZSA025 EQU   0
CMTA025  EQU   0
@NM00054 EQU   0
CMZID071 EQU   @NM00054
@NM00055 EQU   @NM00054+4
CMZRL071 EQU   @NM00055
CMZRA071 EQU   @NM00055+1
CMZEA071 EQU   @NM00054+8
CMZVP071 EQU   @NM00054+12
CMZSA071 EQU   0
CMTA071  EQU   0
@NM00056 EQU   0
CMZID080 EQU   @NM00056
@NM00057 EQU   @NM00056+4
CMZRL080 EQU   @NM00057
CMZRA080 EQU   @NM00057+1
CMZEA080 EQU   @NM00056+8
CMZVP080 EQU   @NM00056+12
CMZSA080 EQU   0
CMTA080  EQU   0
ISTAVT   EQU   0
ISTAS49  EQU   ISTAVT+4
ISTAPC37 EQU   0
NCSUSSRU EQU   0
ISTAPC34 EQU   0
CR6REGSA EQU   DLRPLRSA+12
CR6R140  EQU   CR6REGSA
CR6R210  EQU   CR6REGSA+16
CR6R2S   EQU   CR6R210
CR6R410  EQU   CR6R210+8
DLRPLCR6 EQU   DLRPLIST
DLRPLCON EQU   DLRPLCR6
DLRPLNOD EQU   DLRPLCR6+4
@NM00098 EQU   DLRPLCR6+8
DLRPLFNC EQU   @NM00098
DLRPLSWS EQU   @NM00098+1
DLRPLMID EQU   DLRPLCR6+12
DLRPLSA1 EQU   DLRPLCR6+16
DLRPLSA2 EQU   DLRPLCR6+20
DLRPLMSG EQU   DLRPLCR6+24
DLRPLTPL EQU   DLRPLCR6+44
CR6BITS  EQU   DLRPLSWS
CR6DONE  EQU   CR6BITS
CR6OPSW  EQU   CR6BITS
CR6GETSW EQU   CR6BITS
CR6WARM  EQU   CR6BITS
CR6COLD  EQU   CR6BITS
CR6ERCOD EQU   DLRPLCR6+10
CR6RCB   EQU   RPLRTNCD
CR6ERB   EQU   RPLERRCD
DLRPLCOQ EQU   DLRPLIST
DLRPLOPT EQU   DLRPLCOQ
RTRDNCBA EQU   ISTRTR+40
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
DLRPLTPM EQU   DLRPLCOQ+4
DLRPLGYN EQU   DLRPLOPT
DLRPLFOL EQU   DLRPLOPT
@NM00021 EQU   CR6R210+4
@NM00020 EQU   CR6REGSA+12
NCSRUITS EQU   NCSUSSRU+2
NCSRULEN EQU   NCSUSSRU
ISTPDAVP EQU   ISTAVT+40
ISTAVR01 EQU   ISTAVT+38
ISTVTTP  EQU   ISTAVT+36
ISTAGTWT EQU   ISTAVT+34
ISTATRT  EQU   ISTAVT+32
ISTARID  EQU   ISTAVT+30
ISTX1    EQU   ISTAVT+29
ISTPHNM  EQU   ISTAVT+24
ISTAPSEX EQU   ISTAVT+20
ISTVTTIK EQU   ISTAVT+18
AVTASID  EQU   ISTAVT+16
ISTAPSTA EQU   ISTAVT+12
ISTAS53  EQU   ISTAVT+8
ISTAHIP  EQU   ISTAS49
ISTACVT  EQU   ISTAVT
AMBLDS   EQU   IDAAMBL+60
AMBLIX   EQU   IDAAMBL+56
AMBLMIDS EQU   IDAAMBL+42
AMBLNIDS EQU   IDAAMBL+41
@NM00039 EQU   IDAAMBL+40
AMBLNUM  EQU   IDAAMBL+38
AMBLNST  EQU   IDAAMBL+37
@NM00038 EQU   AMBLFLG2
AMBLSTAG EQU   AMBLFLG2
AMBLRST1 EQU   AMBLFLG2
AMBLCKPT EQU   AMBLFLG2
AMBLREST EQU   AMBLFLG2
AMBLDUMY EQU   AMBLFLG1
AMBLCAT  EQU   AMBLFLG1
@NM00037 EQU   AMBLFLG1
AMBLUPD  EQU   AMBLFLG1
AMBLCINV EQU   AMBLFLG1
AMBLFULL EQU   AMBLFLG1
AMBLLEN  EQU   IDAAMBL+34
@NM00036 EQU   AMBLSHAR
AMBLWRIT EQU   AMBLSHAR
AMBLCATO EQU   AMBLSHAR
AMBLPRIM EQU   AMBLSHAR
AMBLID   EQU   IDAAMBL+32
AMBLCBLN EQU   IDAAMBL+30
@NM00035 EQU   IDAAMBL+29
AMBLCBTS EQU   IDAAMBL+28
AMBLCBWA EQU   IDAAMBL+24
AMBLDDNM EQU   IDAAMBL+16
@NM00034 EQU   AMBLEOV+2
AMBLCOMP EQU   AMBLEOV+1
AMBLESET EQU   AMBLEFLG
AMBLWAIT EQU   AMBLEFLG
AMBLACB  EQU   IDAAMBL+8
AMBLSCHN EQU   IDAAMBL+4
AMBLPCHN EQU   IDAAMBL
AMBVIOT  EQU   IDAAMB+116
AMBSZCP  EQU   IDAAMB+114
AMBSZFW  EQU   IDAAMB+112
AMBSZWR  EQU   IDAAMB+110
AMBSZRD  EQU   IDAAMB+108
AMBEXEX  EQU   IDAAMB+100
AMBWSHD  EQU   IDAAMB+96
AMBCPA   EQU   IDAAMB+92
AMBBM2SH EQU   IDAAMB+88
AMBRDCNT EQU   AMBCSWD1+2
@NM00033 EQU   AMBCSWD1+1
@NM00032 EQU   AMBAFLG
AMBCFX   EQU   AMBAFLG
AMBSIS   EQU   AMBAFLG
AMBDFR   EQU   AMBAFLG
AMBICI   EQU   AMBAFLG
AMBGSR   EQU   AMBAFLG
AMBLSR   EQU   AMBAFLG
@NM00031 EQU   AMBAFLG
AMBUPLH  EQU   IDAAMB+80
AMBPAMBL EQU   IDAAMB+76
AMBPIXP  EQU   IDAAMB+72
@NM00030 EQU   IDAAMB+68
AMBIWA   EQU   IDAAMB+64
AMBWKA   EQU   IDAAMB+60
AMBAMBXN EQU   AMBEOVPT
AMBEDB   EQU   IDAAMB+52
AMBRPT   EQU   IDAAMB+50
AMBPUG   EQU   AMBFLG2
AMBBUSY  EQU   AMBOFLGS
AMBEXFG  EQU   AMBOFLGS
@NM00029 EQU   AMBOFLGS
AMBOPEN  EQU   AMBOFLGS
@NM00028 EQU   AMBOFLGS
AMBDEBAD EQU   AMBDEBPT+1
AMBIFLGS EQU   AMBDEBPT
AMBAMETH EQU   IDAAMB+43
AMBUPX   EQU   AMBINFL
AMBUCRA  EQU   AMBINFL
AMBSCRA  EQU   AMBINFL
AMBCAT   EQU   AMBINFL
@NM00027 EQU   AMBINFL
@NM00026 EQU   AMBINFL
AMBTIOT  EQU   IDAAMB+40
@NM00025 EQU   IDAAMB+38
AMBDDSN  EQU   IDAAMB+35
AMBCDSN  EQU   IDAAMB+32
AMBIOMB  EQU   AMBIOBAD
@NM00024 EQU   AMBDSORG+1
AMBDORGA EQU   AMBDSORG+1
@NM00023 EQU   AMBDSORG
AMBJRN   EQU   AMBFLG1
AMBUBF   EQU   AMBFLG1
AMBSPEED EQU   AMBFLG1
AMBPCAT  EQU   AMBFLG1
AMBMCAT  EQU   AMBFLG1
AMBTYPE  EQU   AMBFLG1
AMBCREAT EQU   AMBFLG1
@NM00022 EQU   AMBFLG0
AMBPSDS  EQU   AMBFLG0
AMBDSB   EQU   IDAAMB+20
AMBCACB  EQU   IDAAMB+16
AMBPH    EQU   IDAAMB+12
AMBBUFC  EQU   IDAAMB+8
AMBLINK  EQU   IDAAMB+4
AMBLEN   EQU   IDAAMB+2
AMBRSC   EQU   IDAAMB+1
AMBID    EQU   IDAAMB
CR6RSVD3 EQU   WBITS
@NM00019 EQU   CR6SA
RPLERMSA EQU   RPLCOMN+72
RPLEMLEN EQU   RPLCOMN+70
RPLACTIV EQU   RPLCOMN+69
RPLBRANC EQU   RPLEXTD1
RPLNIB   EQU   RPLEXTD1
@NM00018 EQU   RPLEXTD1
RPLEXIT  EQU   RPLEXTD1
RPLNEXIT EQU   RPLEXTD1
RPLEXSCH EQU   RPLEXTD1
RPLDDDD  EQU   RPLRBAR+4
@NM00017 EQU   RPLRBAR+3
@NM00016 EQU   RPLAIXID
RPLAXPKP EQU   RPLAIXID
RPLAIXPC EQU   RPLRBAR
RPLRSV88 EQU   RPLOPT8
RPLUNCON EQU   RPLOPT8
RPLACTV  EQU   RPLOPT8
RPLSESS  EQU   RPLOPT8
RPLPEND  EQU   RPLOPT8
RPLODPRM EQU   RPLOPT8
RPLODACP EQU   RPLOPT8
RPLODACQ EQU   RPLOPT8
RPLRSV78 EQU   RPLOPT7
RPLTCRNO EQU   RPLOPT7
RPLRLSOP EQU   RPLOPT7
RPLTPOST EQU   RPLOPT7
RPLQOPT  EQU   RPLOPT7
RPLCNIMM EQU   RPLCNOPT
RPLCNANY EQU   RPLCNOPT
RPLCNALL EQU   RPLCNOPT
RPLRSV68 EQU   RPLOPT6
RPLRSV67 EQU   RPLOPT6
RPLLOCK  EQU   RPLOPT6
RPLNCOND EQU   RPLOPT6
RPLCOND  EQU   RPLOPT6
RPLEOT   EQU   RPLUNTYP
RPLEOM   EQU   RPLUNTYP
RPLEOB   EQU   RPLUNTYP
RPLWROPT EQU   RPLOPT5
RPLNODE  EQU   RPLOPT5
RPLERACE EQU   RPLWRTYP
RPLEAU   EQU   RPLWRTYP
RPLNERAS EQU   RPLWRTYP
RPLPSOPT EQU   RPLOPT5
@NM00015 EQU   RPLOPT5
RPLDLGIN EQU   RPLOPT5
RPLCHAIN EQU   RPLNXTRP
RPLBOP   EQU   RPLOPT4
@NM00014 EQU   RPLOPT4
RPLMKFRM EQU   RPLOPT4
RPLENDTR EQU   RPLOPT4
RPLALIGN EQU   RPLOPT3
RPLFMT   EQU   RPLOPT3
RPLFLD   EQU   RPLOPT3
RPLVFY   EQU   RPLOPT3
RPLBLK   EQU   RPLOPT3
RPLSFORM EQU   RPLOPT3
RPLEODS  EQU   RPLOPT3
RPLNSP   EQU   RPLOPT2
@NM00013 EQU   RPLOPT2
RPLLRD   EQU   RPLOPT2
RPLBWD   EQU   RPLOPT2
RPLCNV   EQU   RPLOPT2
RPLADD   EQU   RPLADR
RPLKEY   EQU   RPLOPT2
RPLECBIN EQU   RPLECBSW
RPLGEN   EQU   RPLOPT1
RPLASY   EQU   RPLOPT1
RPLSKP   EQU   RPLOPT1
RPLLOC   EQU   RPLOPT1
RPLDAF   EQU   RPLARG+2
RPLSAF   EQU   RPLARG
RPLTCBPT EQU   RPLCOMN+28
RPLCCHAR EQU   RPLCOMN+20
RPLSTRID EQU   RPLCOMN+18
RPLRDSOH EQU   RPLFDB3
RPLRLG   EQU   RPLFDB3
RPLLGFRC EQU   RPLFDB3
RPLREOT  EQU   RPLFDB3
RPLREOM  EQU   RPLFDB3
RPLREOB  EQU   RPLFDB3
RPLSV32  EQU   RPLFDB3
RPLUINPT EQU   RPLFDB3
RPLSTSAV EQU   RPLFDB2
RPLCUERR EQU   RPLFDB2
RPLDLGFL EQU   RPLFDB2
RPLIOERR EQU   RPLFDB2
RPLDVUNS EQU   RPLFDB2
RPLATND  EQU   RPLFDB2
RPLRVID  EQU   RPLFDB2
RPLERLK  EQU   RPLFDB2
RPLERREG EQU   RPLRTNCD
RPLSTAT  EQU   RPLFDBWD
RPLPOST  EQU   RPLECB
RPLWAIT  EQU   RPLECB
RPLPLHPT EQU   RPLCOMN+4
RPLLEN2  EQU   RPLLEN
RPLREQ   EQU   RPLIDWD+2
RPLSTYP  EQU   RPLIDWD+1
RPLID    EQU   RPLIDWD
ACBAPID  EQU   ACBCOMN+72
ACBCBMWA EQU   ACBCOMN+68
ACBUAPTR EQU   ACBCOMN+64
ACBMSGLN EQU   ACBBLKSZ
ACBBUFSP EQU   ACBCOMN+56
@NM00012 EQU   ACBUJFCB+1
ACBOPTN  EQU   ACBUJFCB
@NM00011 EQU   ACBINFLG+1
ACBBYPSS EQU   ACBINFLG
ACBSDS   EQU   ACBVVIC
ACBUCRA  EQU   ACBINFLG
ACBSCRA  EQU   ACBINFLG
ACBCAT   EQU   ACBINFLG
ACBIJRQE EQU   ACBINFLG
ACBJEPS  EQU   ACBINFLG
@NM00010 EQU   ACBINFLG
ACBBUSY  EQU   ACBIOSFG
ACBLOCK  EQU   ACBEXFG
@NM00009 EQU   ACBOFLGS
ACBDSERR EQU   ACBOFLGS
ACBOPEN  EQU   ACBOFLGS
ACBEOV   EQU   ACBOFLGS
@NM00008 EQU   ACBOFLGS
ACBDEB   EQU   ACBDDNM+5
ACBERFL  EQU   ACBDDNM+4
ACBAM    EQU   ACBAMETH
ACBINFL  EQU   ACBDDNM+2
ACBTIOT  EQU   ACBDDNM
ACBUEL   EQU   ACBEXLST
ACBPASSW EQU   ACBCOMN+32
ACBMSGAR EQU   ACBCOMN+28
@NM00007 EQU   ACBDSORG+1
ACBDORGA EQU   ACBDSORG+1
@NM00006 EQU   ACBDSORG
ACBOPTJ  EQU   ACBDVIND
ACBCRNRE EQU   ACBCROPS
ACBCRNCK EQU   ACBCROPS
ACBASA   EQU   ACBCCTYP
@NM00005 EQU   ACBCCTYP
ACBTRCID EQU   ACBCCTYP
@NM00004 EQU   ACBRECFM
ACBRECAF EQU   ACBRECFM
ACBJBUF  EQU   ACBBUFPL+2
ACBMACR4 EQU   ACBBUFPL+1
@NM00003 EQU   ACBMACR3
ACBNCFX  EQU   ACBMACR3
ACBSIS   EQU   ACBMACR3
ACBDFR   EQU   ACBMACR3
ACBICI   EQU   ACBMACR3
ACBGSR   EQU   ACBMACR3
ACBLSR   EQU   ACBMACR3
@NM00002 EQU   ACBMACR3
ACBBUFNI EQU   ACBCOMN+18
ACBBUFND EQU   ACBCOMN+16
ACBSTRNO EQU   ACBCOMN+15
ACBBSTNO EQU   ACBCOMN+14
ACBAIX   EQU   ACBMACR2
ACBDSN   EQU   ACBMACR2
ACBRST   EQU   ACBMACR2
ACBLOGON EQU   ACBMACR2
ACBSKP   EQU   ACBMACR2
@NM00001 EQU   ACBMACR2
ACBUBF   EQU   ACBMACR1
ACBOUT   EQU   ACBMACR1
ACBIN    EQU   ACBMACR1
ACBDIR   EQU   ACBMACR1
ACBSEQ   EQU   ACBMACR1
ACBBLK   EQU   ACBCNV
ACBADD   EQU   ACBADR
ACBKEY   EQU   ACBMACR1
ACBINRTN EQU   ACBCOMN+8
ACBIBCT  EQU   ACBJWA
ACBLEN2  EQU   ACBLENG2
ACBSTYP  EQU   ACBCOMN+1
ACBID    EQU   ACBCOMN
DLRPLUSR EQU   ISTDLRPL+76
DLRPLR15 EQU   DLRPLRSA+16
@NM00097 EQU   DLRPLRSA+8
DLRPLQPT EQU   DLRPLRSA+4
DLRPLFCD EQU   DLRPLRSA+2
DLRPLLTH EQU   DLRPLRSA+1
DLRPLIDF EQU   DLRPLRSA
TPMPLCID EQU   ISTTPMPL+16
TPMPLTXT EQU   ISTTPMPL+12
TPMPLRNF EQU   ISTTPMPL+8
TPMPLRBA EQU   ISTTPMPL+5
TPMPLRLN EQU   ISTTPMPL+4
TPMPLMID EQU   ISTTPMPL
CONUESBF EQU   ISTCONFT+1362
CONSTVAR EQU   CONSTAID+1
CONSTFIL EQU   CONSTAID
CONBLKNO EQU   CONSCPID+2
CONFILL  EQU   CONSCPID+1
CONFCNL  EQU   CONSCPID
CONF01SV EQU   ISTCONFT+1352
CONSDMLC EQU   ISTCONFT+1348
CONSDECB EQU   ISTCONFT+1344
CONUNITS EQU   ISTCONFT+1342
CONRVPT1 EQU   ISTCONFT+1341
CONGLBBH EQU   ISTCONFT+1340
CONRSV24 EQU   ISTCONFT+1312
CONFTTAT EQU   ISTCONFT+1284
CONFXXAT EQU   ISTCONFT+1256
CONFLDAT EQU   ISTCONFT+1228
CONFTRAT EQU   ISTCONFT+1200
CONFNSAT EQU   ISTCONFT+1172
CONCSCB  EQU   ISTCONFT+1168
CONRSV50 EQU   ISTCONFT+1166
CONLIST  EQU   ISTCONFT+1164
CONSTAFP EQU   ISTCONFT+1160
CONECDET EQU   ISTCONFT+1156
CONRECON EQU   ISTCONFT+1036
CONNTSOL EQU   ISTCONFT+916
CONTRACE EQU   ISTCONFT+796
CONTOLTP EQU   ISTCONFT+676
CONVVTAM EQU   ISTCONFT+556
CONVTHDR EQU   ISTCONFT+420
CONRSV01 EQU   ISTCONFT+417
CONNSNEC EQU   CONFLG01
CONFTPSA EQU   CONFLG01
CONFTTA  EQU   CONFLG01
CONFTNSA EQU   CONFLG01
CONFTNAC EQU   CONFLG01
CONFTEXS EQU   CONFLG01
CONFTTMR EQU   CONFLG01
CONFTSTM EQU   CONFLG01
CONCRPLD EQU   ISTCONFT+404
CONPPDBF EQU   ISTCONFT+392
CONNPDBF EQU   ISTCONFT+380
CONAPDBF EQU   ISTCONFT+368
CONWPDBF EQU   ISTCONFT+356
CONIODBF EQU   ISTCONFT+344
CONUEDBF EQU   ISTCONFT+332
CONVPDBF EQU   ISTCONFT+320
CONVFDBF EQU   ISTCONFT+308
CONLPDBF EQU   ISTCONFT+296
CONLFDBF EQU   ISTCONFT+284
CONSPDBF EQU   ISTCONFT+272
CONSFDBF EQU   ISTCONFT+260
CONCRPLS EQU   ISTCONFT+248
CONPPSBF EQU   ISTCONFT+236
CONNPSBF EQU   ISTCONFT+224
CONAPSBF EQU   ISTCONFT+212
CONWPSBF EQU   ISTCONFT+200
CONIOSBF EQU   ISTCONFT+188
CONVPSBF EQU   ISTCONFT+176
CONVFSBF EQU   ISTCONFT+164
CONLPSBF EQU   ISTCONFT+152
CONLFSBF EQU   ISTCONFT+140
CONSPSBF EQU   ISTCONFT+128
CONSFSBF EQU   ISTCONFT+116
CONRSV17 EQU   ISTCONFT+115
CONCRPL  EQU   CONBUFF+1
CONPPEX  EQU   CONBUFF+1
CONNPEX  EQU   CONBUFF+1
CONAPEX  EQU   CONBUFF+1
CONWPEX  EQU   CONBUFF+1
CONIOEX  EQU   CONBUFF
CONUECB  EQU   CONBUFF
CONVPEX  EQU   CONBUFF
CONVFEX  EQU   CONBUFF
CONLPEX  EQU   CONBUFF
CONLFEX  EQU   CONBUFF
CONSPEX  EQU   CONBUFF
CONSFEX  EQU   CONBUFF
CONACTV  EQU   CONSTAT
CONVRYIN EQU   CONSTAT
CONLODED EQU   CONSTAT
CONDSOPN EQU   CONSTAT
CONSTOR  EQU   CONSTAT
@NM00096 EQU   CONSTAT
@NM00095 EQU   CONSTAT
@NM00094 EQU   CONSTAT
CONIOTR  EQU   CONOPTFL
CONMODTR EQU   CONOPTFL
CONBTUTR EQU   CONOPTFL
CONBUFTR EQU   CONOPTFL
@NM00093 EQU   CONOPTFL
@NM00092 EQU   CONOPTFL
@NM00091 EQU   CONOPTFL
CONWRMST EQU   CONOPTFL
CONSYLST EQU   CONDSFLG
CONSYLIB EQU   CONDSFLG
CONSYOBJ EQU   CONDSFLG
@NM00090 EQU   CONDSFLG
@NM00089 EQU   CONDSFLG
@NM00088 EQU   CONDSFLG
CONMODFY EQU   ISTCONFT+109
CONDISPL EQU   ISTCONFT+108
CONVARY  EQU   ISTCONFT+107
CONHLTS  EQU   CONHALT
CONHLTQ  EQU   CONHALT
CONLAST  EQU   ISTCONFT+105
CONRES2  EQU   ISTCONFT+104
CONCID   EQU   ISTCONFT+102
CONRSV02 EQU   ISTCONFT+96
CONDCBBA EQU   ISTCONFT+92
CONDCBLA EQU   ISTCONFT+88
CONDCBOA EQU   ISTCONFT+84
CONLDPRM EQU   ISTCONFT+80
CONSTCIB EQU   ISTCONFT+72
CONENDLA EQU   ISTCONFT+68
CONVARLA EQU   ISTCONFT+64
CONMODLA EQU   ISTCONFT+60
CONHLTLA EQU   ISTCONFT+56
CONNCSLA EQU   ISTCONFT+52
CONDISLA EQU   ISTCONFT+48
CONCIBAD EQU   ISTCONFT+44
CONACB   EQU   ISTCONFT+40
CONFBPNM EQU   ISTCONFT+32
CONDMNM  EQU   ISTCONFT+24
CONAPSNM EQU   ISTCONFT+16
CONAPINM EQU   ISTCONFT+8
PATRSV01 EQU   PATFLAGA
PATUSEFG EQU   PATFLAGA
PATRDCNT EQU   ISTPAT+6
PATGRPID EQU   ISTPAT+5
PATPTHID EQU   ISTPAT+4
PATDINDX EQU   ISTPAT+2
PATGINDX EQU   ISTPAT
GNTGRPNM EQU   ISTGNT
DNTTELNO EQU   ISTDNT+1
DNTCTDIG EQU   ISTDNT
RLSRSV02 EQU   ISTRLS+140
RLSRSV01 EQU   ISTRLS+138
RLSCTELU EQU   ISTRLS+136
RLSPRE   EQU   ISTRLS
RDARSVPT EQU   ISTRDA+84
RDAPUBI  EQU   ISTRDA+83
RDADFCUA EQU   ISTRDA+80
RDACTPCC EQU   ISTRDA+79
RDADACUA EQU   ISTRDA+76
RDALUBA  EQU   RDAUCBAD+1
RDACHQI  EQU   RDAUCBAD
RDARSV01 EQU   RDAFLAG
RDARBISA EQU   RDAFLAG
RDAPRE   EQU   ISTRDA
RSWRSV01 EQU   ISTRSW+152
RSWRSV02 EQU   ISTRSW+150
RSWCTELU EQU   ISTRSW+148
RSWGRUPZ EQU   ISTRSW+146
RSWDIALZ EQU   ISTRSW+144
RSWGRUPT EQU   ISTRSW+140
RSWDIALT EQU   ISTRSW+136
RSWPRE   EQU   ISTRSW
RLXRSV03 EQU   ISTRLX+80
RLXRSV02 EQU   ISTRLX+77
RLXRSV01 EQU   RLXFLAGA
RLXINUSE EQU   RLXFLAGA
RLXNLUX  EQU   ISTRLX+72
RLXPRE   EQU   ISTRLX
RPXRSV01 EQU   ISTRPX+80
RPXRSV02 EQU   ISTRPX+77
RPXMAXLU EQU   ISTRPX+76
RPXFLUX  EQU   ISTRPX+72
RPXPRE   EQU   ISTRPX
RLURSV02 EQU   ISTRLU+172
RLULGMOD EQU   ISTRLU+164
RLUMODEP EQU   RLUMODET+8
RLUMODEN EQU   RLUMODET
RLUUSSPT EQU   RLUUSSTB+8
RLUUSSNM EQU   RLUUSSTB
RLURSV01 EQU   ISTRLU+137
RLULOCAD EQU   ISTRLU+136
RLUNCPPM EQU   RLUNCPPC+1
RLUNCPPN EQU   RLUNCPPC
RLUPACEM EQU   RLUPACE+1
RLUPACEN EQU   RLUPACE
RLUINTA  EQU   ISTRLU+128
RLUSSCFM EQU   ISTRLU+127
RLUCRRSV EQU   RLUCRFLG
RLUACTLU EQU   RLUCRFLG
RLURSV00 EQU   RLUFLAG
RLUNDSES EQU   RLUFLAG
RLUGSTAT EQU   RLUFLAG
RLUBATCH EQU   RLUFLAG
RLURBISA EQU   RLUFLAG
RLUTYPE  EQU   ISTRLU+124
RLUCRPR  EQU   ISTRLU
RCCRVPT2 EQU   ISTRCC+144
RCCXTOSW EQU   ISTRCC+140
RCCSWTOX EQU   ISTRCC+136
RCCRSPT2 EQU   ISTRCC+133
RCCADDR  EQU   ISTRCC+132
RCCPASSL EQU   ISTRCC+131
RCCMXOUT EQU   ISTRCC+130
RCCMXDAT EQU   ISTRCC+128
RCCINDEX EQU   ISTRCC+126
RCCPATHZ EQU   ISTRCC+124
RCCPATHT EQU   ISTRCC+120
RCCDPQ   EQU   ISTRCC+116
RCCTPAB  EQU   ISTRCC+112
RCCRSV02 EQU   ISTRCC+109
RCCCRRSV EQU   RCCCRFLG
RCCCTCFL EQU   RCCCRFLG
RCCACTPU EQU   RCCCRFLG
RCCNCSPL EQU   ISTRCC+104
RCCRPHCN EQU   ISTRCC+100
RCCEPAB  EQU   ISTRCC+96
RCCDPAB  EQU   ISTRCC+92
RCCVPAB  EQU   ISTRCC+88
@NM00087 EQU   ISTRCC+87
RCCSESCT EQU   ISTRCC+86
RCCIDNUM EQU   RCCID48+3
RCCIDBLK EQU   RCCID48+2
RCCIDPA2 EQU   RCCID48+1
RCCIDPUT EQU   RCCID48
RCCIDPA1 EQU   RCCSTAID
RCCCTELU EQU   ISTRCC+76
RCCCNCNT EQU   ISTRCC+75
RCCRTGOH EQU   RCCFLAGB
RCCBRKCN EQU   RCCFLAGB
RCCRESET EQU   RCCFLAGB
RCCFINAL EQU   RCCFLAGB
RCCBNNSP EQU   RCCFLAGB
RCCIRETR EQU   RCCFLAGB
RCCDIALP EQU   RCCFLAGB
RCCDSTCT EQU   RCCFLAGB
RCCCTPGD EQU   RCCFLAG
RCCPRGDN EQU   RCCFLAG
RCCOUERP EQU   RCCFLAG
RCCOHIMM EQU   RCCFLAG
RCCLDISC EQU   RCCFLAG
RCCERPIP EQU   RCCFLAG
RCCCUDIE EQU   RCCFLAG
RCCRBISA EQU   RCCFLAG
RCCTYPE  EQU   ISTRCC+72
RCCPRE   EQU   ISTRCC
DOTADTRM EQU   ISTDOT
RDSADDOT EQU   ISTRDS+76
RDSCTATR EQU   ISTRDS+74
RDSCTTRM EQU   ISTRDS+72
RDSPRE   EQU   ISTRDS
RINRSV05 EQU   ISTRIN+156
RINRSV04 EQU   ISTRIN+152
RINLOCRN EQU   ISTRIN+148
RINRSV02 EQU   ISTRIN+145
RTRCNCNT EQU   RINCNCNT
RTRNCSPL EQU   RINNCSPL
RTRRPHCN EQU   RINRPHCN
RTRVPAB  EQU   RINVPAB
RTRREMOT EQU   RINREMOT
RTRRLDAF EQU   RINRLDAF
RTRNODID EQU   RINNODID
RINRSV01 EQU   RINDFD
RTRLDISC EQU   RINLDISC
RTRNODEF EQU   RINNODEF
RTRREMPO EQU   RINREMPO
RINCRPRE EQU   ISTRIN
RTRRSV04 EQU   ISTRTR+210
RTRLCTI  EQU   ISTRTR+209
RTRIDCAS EQU   RTRBSCID+1
RTRIDLEN EQU   RTRBSCID
RTRRSVDD EQU   ISTRTR+181
RTRRDFG  EQU   ISTRTR+180
RTRDIAA  EQU   ISTRTR+176
RTRPOLA  EQU   ISTRTR+172
RTRCADDR EQU   ISTRTR+164
RTRCTADR EQU   ISTRTR+162
RTRCTPOL EQU   ISTRTR+160
RTRCTDIA EQU   ISTRTR+158
RTRRSV03 EQU   ISTRTR+156
RTRRVPT1 EQU   ISTRTR+152
RTRBHSN1 EQU   ISTRTR+144
RTRCRSV2 EQU   RTRCRFLG
RTRDTRLM EQU   RTRLSCMD
RTRCRSV1 EQU   RTRCRFLG
RTRTRMAX EQU   ISTRTR+142
RTRRSV24 EQU   RTRRDFF
RTRRFDEK EQU   RTRRDFF
RTRRFANK EQU   RTRRDFF
RTRRFPFK EQU   RTRRDFF
RTRRFPEN EQU   RTRRDFF
RTRRFXCT EQU   RTRRDFF
RTRRESCT EQU   RTRRDFE
RTRRESUP EQU   RTRRDFE
RTRREATT EQU   RTRRDFE
RTRRECHK EQU   RTRRDFE
RTRREACR EQU   RTRRDFE
RTRRSV0A EQU   RTRRDFE
RTRREBRK EQU   RTRRDFE
RTRRSV11 EQU   RTRRDFD
RTRRSV10 EQU   RTRRDFD
RTRRDBHI EQU   RTRRDFD
RTRRDBHD EQU   RTRRDFD
RTRRDBHN EQU   RTRRDFD
RTRRSV23 EQU   RTRRDFC
RTRRCXMS EQU   RTRRDFC
RTRRCMSG EQU   RTRRDFC
RTRRCBLK EQU   RTRRDFC
RTRRCPT3 EQU   RTRRDFC
RTRRCIT2 EQU   RTRRDFC
RTRRCIT1 EQU   RTRRDFC
RTRRSV32 EQU   RTRRDFB
RTRRBEND EQU   RTRRDFB
RTRRBECT EQU   RTRRDFB
RTRRSV02 EQU   RTRRDFA
RTRRACTR EQU   RTRRDFA
RTRRSV60 EQU   RTRRDFA
RTRRACDT EQU   RTRRDFA
RTRRAPT3 EQU   RTRRAALL
RTRRAPT2 EQU   RTRRAALL
RTRRAPT1 EQU   RTRRAALL
RTRRAATN EQU   RTRRDFA
RTRRSV45 EQU   ISTRTR+132
RTRRSV01 EQU   ISTRTR+130
RTRCTECM EQU   ISTRTR+128
RTRADRPT EQU   RTRADR+1
RTRRSV22 EQU   RTRFLAG
RTRVTERM EQU   RTRFLAG
RTRRSV51 EQU   RTRFLAG
RTRRBISA EQU   RTRFLAG
RTRRSV21 EQU   RTRFLAG
RTRCRPR  EQU   ISTRTR
RCLRVPT2 EQU   ISTRCL+92
RCLRVPT1 EQU   ISTRCL+88
RCLGPOLA EQU   ISTRCL+84
RCLCTNGP EQU   ISTRCL+82
RCLRSV01 EQU   ISTRCL+80
RCLCTECM EQU   ISTRCL+78
RCLCTETR EQU   ISTRCL+76
RCLGPADR EQU   RCLADR+1
RCLRSV33 EQU   RCLFLAG
RCLBATCH EQU   RCLFLAG
RCLRBISA EQU   RCLFLAG
RCLRSV22 EQU   RCLFLAG
RCLPRE   EQU   ISTRCL
RPTRSV03 EQU   ISTRPT+156
RPTRSV02 EQU   ISTRPT+152
RPTNSNSV EQU   ISTRPT+148
RPTPTHCT EQU   ISTRPT+146
RPTPEPCT EQU   ISTRPT+144
RPTDAFSV EQU   ISTRPT+142
RPTRSV01 EQU   ISTRPT+141
RPTISTAT EQU   RPTFLAG1
RPTDYNAM EQU   RPTFLAG1
RPTVYIMM EQU   RPTFLAG1
RPTVIODN EQU   RPTFLAG1
RPTONLIN EQU   RPTFLAG1
RPTHLVPD EQU   RPTFLAG1
RPTVRYPD EQU   RPTFLAG1
RPTASLEP EQU   RPTFLAG1
RPTUTERM EQU   ISTRPT+136
RPTATERM EQU   ISTRPT+132
RPTDIVT  EQU   RPTDITT
RPTCTNM  EQU   ISTRPT+120
RPTLNDAF EQU   RPTLNCID+2
RPTLNSAF EQU   RPTLNCID
RPTLN    EQU   ISTRPT
RLNRVPT2 EQU   ISTRLN+112
RLNNCSPL EQU   ISTRLN+108
RLNX2SW  EQU   ISTRLN+104
@NM00086 EQU   ISTRLN+103
RLNCRRSV EQU   RLNCRFLG
RLNSWEP  EQU   RLNCRFLG
RLNSVSKP EQU   RLNLSCMD
RLNSESLM EQU   RLNLSCMD
RLNNPRLM EQU   RLNLSCMD
RLNSWNCP EQU   RLNCRFLG
RLNACTLN EQU   RLNCRFLG
RLNPAUSE EQU   ISTRLN+101
RLNPOLMT EQU   ISTRLN+100
RLNACTSN EQU   ISTRLN+98
RLNRESV1 EQU   ISTRLN+97
RLNACTRM EQU   ISTRLN+96
RLNCTSES EQU   ISTRLN+95
RLNRDSLM EQU   ISTRLN+94
RLNAUTOA EQU   ISTRLN+92
RLNRDFD  EQU   RLNRDF+3
RLNRDFC  EQU   RLNRDF+2
RLNMULTP EQU   RLNRDFB
RLNRATRN EQU   RLNRDFB
RLNRAPOL EQU   RLNRDFB
RLNTTV   EQU   RLNRDFB
RLNRSV0B EQU   RLNRDFB
RLNAUTOD EQU   RLNRDFB
RLNANSWR EQU   RLNRDFB
RLNRBUSE EQU   RLNRDFB
RLNRAPEP EQU   RLNRDFA
RLNRANCP EQU   RLNRDFA
RLNRAEP  EQU   RLNRDFA
RLNIDV   EQU   RLNRDFA
RLNPORT  EQU   RLNRDFA
RLNGANSW EQU   RLNRDFA
RLNRACAN EQU   RLNRACNT
RLNRACAT EQU   RLNRACNT
RLNRSV04 EQU   RLNSTAT2
RLNINUSE EQU   RLNSTAT2
RLNOHIN  EQU   RLNSTAT2
RLNRSV03 EQU   RLNSTAT1
RLNVD    EQU   RLNSTAT1
RLNINOPP EQU   RLNSTAT1
RLNINOPL EQU   RLNSTAT1
RLNLRST  EQU   RLNSTAT1
RLNTRAP  EQU   RLNSTAT1
RLNACTCT EQU   ISTRLN+84
RLNCTECM EQU   ISTRLN+82
RLNCTEIN EQU   ISTRLN+80
RLNCTETR EQU   ISTRLN+78
RLNCTECL EQU   ISTRLN+76
RLNCUA   EQU   RLNUCBAD
RLNRSV01 EQU   RLNFLAG
RLNRBISA EQU   RLNFLAG
RLNEAM   EQU   RLNFLAG
RLNPRE   EQU   ISTRLN
RGPRVPT2 EQU   ISTRGP+88
RGPRVPT1 EQU   ISTRGP+84
RGPCTECM EQU   ISTRGP+82
RGPCTEIN EQU   ISTRGP+80
RGPCTETR EQU   ISTRGP+78
RGPCTECL EQU   ISTRGP+76
RGPCTELN EQU   ISTRGP+74
RGPRSV03 EQU   ISTRGP+73
RGPRSV02 EQU   RGPFLG
RGPASDLC EQU   RGPFLG
RGPABSC  EQU   RGPFLG
RGPASS   EQU   RGPFLG
RGPADIL  EQU   RGPFLG
RGPPRE   EQU   ISTRGP
RRNRINNM EQU   ISTRRN+248
@NM00085 EQU   ISTRRN+247
RRNRDCUA EQU   ISTRRN+244
RRNLASTE EQU   ISTRRN+240
RRNNCSPL EQU   ISTRRN+236
RRNRPLPT EQU   ISTRRN+232
RRNMSIZE EQU   ISTRRN+228
RRNNCPNM EQU   ISTRRN+221
RRNCTPCC EQU   ISTRRN+220
RRNHBUFS EQU   ISTRRN+218
RRNHLENT EQU   RRNHPRE+1
RRNHLENH EQU   RRNHPRE
RRNNMNCP EQU   ISTRRN+208
RRNDELAY EQU   ISTRRN+206
RRNRSV04 EQU   ISTRRN+200
RRNRSV88 EQU   RRNNMDPD+7
RRNPUBI  EQU   RRNNMDPD+6
RRNDPLUB EQU   RRNNMDPD
RRNEPADR EQU   ISTRRN+190
RRNCPLUB EQU   ISTRRN+184
RRNFLUX  EQU   ISTRRN+180
RRNRSV05 EQU   RRNCMFD
RRNREMPO EQU   RRNCMFD
RRNCDREC EQU   RRNCMFD
RRNCDDSI EQU   RRNCMFD
RRNCDBCK EQU   RRNCMFD
RRNCDDTL EQU   RRNCMFD
RRNCDSTD EQU   RRNCMFD
RRNCDCSP EQU   RRNCMFD
RRNCCCSL EQU   RRNCMFC
RRNCCSIM EQU   RRNCMFC
RRNCCRCM EQU   RRNCMFC
RRNCCRIM EQU   RRNCMFC
RRNCCCRC EQU   RRNCMFC
RRNCCRST EQU   RRNCMFC
RRNCCRDQ EQU   RRNCMFC
RRNCCRCN EQU   RRNCMFC
RRNCBALT EQU   RRNCMFB
RRNCBMOD EQU   RRNCMFB
RRNCBNPL EQU   RRNCMFB
RRNCBRLS EQU   RRNCMFB
RRNCBRDS EQU   RRNCMFB
RRNCBDLR EQU   RRNCMFB
RRNCBDLH EQU   RRNCMFB
RRNCBDLO EQU   RRNCMFB
RRNCADGO EQU   RRNCMFA
RRNCADTD EQU   RRNCMFA
RRNCACDT EQU   RRNCMFA
RRNCAMBH EQU   RRNCMFA
RRNCAATI EQU   RRNCMFA
RRNCAATG EQU   RRNCMFA
RRNCAATD EQU   RRNCMFA
RRNCAALL EQU   RRNCMFA
RRNRSV55 EQU   RRNRDF+3
RRNPTASL EQU   RRNRDFB+1
RRNRSV01 EQU   RRNRDFB+1
RRNVYDON EQU   RRNRDFB+1
RRNRBBUP EQU   RRNRDFB+1
RRNRSV03 EQU   RRNRDFB
RRNRBCT2 EQU   RRNRDFB
RRNRBCT1 EQU   RRNRDFB
RRNRBSEC EQU   RRNRDFB
RRNRBCCT EQU   RRNRDFB
RRNRBCCL EQU   RRNRDFB
RRNRSV02 EQU   RRNRDFB
RRNRBMDL EQU   RRNRDFB
RRNRAPEP EQU   RRNRDFA
RRNRANCP EQU   RRNRDFA
RRNRBREM EQU   RRNRDFA
RRNRAOLT EQU   RRNRDFA
RRNRASYN EQU   RRNRDFA
RRNRADMP EQU   RRNRDFA
RRNRAIPL EQU   RRNRDFA
RRNRASHT EQU   RRNRDFA
RRNCTENT EQU   ISTRRN+170
RRNCTECM EQU   ISTRRN+168
RRNCTEIN EQU   ISTRRN+166
RRNCTETR EQU   ISTRRN+164
RRNCTECL EQU   ISTRRN+162
RRNCTELI EQU   ISTRRN+160
RRNCTEGP EQU   ISTRRN+158
RRNCTBHS EQU   ISTRRN+156
RRNBHSET EQU   ISTRRN+152
RRNTRENT EQU   ISTRRN+148
RRNRLDIP EQU   ISTRRN+147
RRNRNCUA EQU   ISTRRN+144
RRNGRPA  EQU   ISTRRN+140
RRNLUBA  EQU   RRNUCBAD+1
RRNCHQI  EQU   RRNUCBAD
RRNRSV11 EQU   RRNFLAG
RRNDSTCT EQU   RRNFLAG
RRNERPIP EQU   RRNFLAG
RRNLCDIP EQU   RRNFLAG
RRNLCDIE EQU   RRNFLAG
RRNLCSIP EQU   RRNFLAG
RRNRBISA EQU   RRNFLAG
RRNRSV89 EQU   RRNFLAG
RRNPRE   EQU   ISTRRN
RLCRVPT2 EQU   ISTRLC+80
RLCRVPT1 EQU   ISTRLC+79
RLCLCCUA EQU   ISTRLC+76
RLCUCBAD EQU   RLCADR+1
RLCRSVDE EQU   RLCFLAG
RLCACNT  EQU   RLCFLAG
RLCRSV14 EQU   RLCFLAG
RLCRBISA EQU   RLCFLAG
RLCRSV22 EQU   RLCFLAG
RLCPRE   EQU   ISTRLC
RAPRVPT2 EQU   ISTRAP+116
RAPRVPT1 EQU   ISTRAP+112
RAPBFACT EQU   ISTRAP+111
RAPRSV17 EQU   RAPFLGC
RAPRSV16 EQU   RAPFLGC
RAPRSV15 EQU   RAPFLGC
RAPRSV14 EQU   RAPFLGC
RAPRSV13 EQU   RAPFLGC
RAPRSV12 EQU   RAPFLGC
RAPRSV11 EQU   RAPFLGC
RAPRSV10 EQU   RAPFLGC
RAPANVPC EQU   RAPFLGB
RAPASPO  EQU   RAPFLGB
RAPAPPO  EQU   RAPFLGB
RAPAACQ  EQU   RAPFLGB
RAPAPRMT EQU   RAPFLGB
RAPAPASS EQU   RAPFLGB
RAPABLCK EQU   RAPFLGB
RAPALLF  EQU   RAPFLGB
RAPRSV06 EQU   RAPFLG
RAPRSV05 EQU   RAPFLG
RAPRSV04 EQU   RAPFLG
RAPRSV03 EQU   RAPFLG
RAPATLGN EQU   RAPFLG
RAPASLGI EQU   RAPFLG
RAPAQUI  EQU   RAPFLG
RAPABLGN EQU   RAPFLG
RAPACEQD EQU   ISTRAP+106
RAPTRPRE EQU   ISTRAP+104
RAPACEAP EQU   ISTRAP+100
RAPICEAQ EQU   ISTRAP+96
RAPICEAC EQU   ISTRAP+92
RAPICELG EQU   ISTRAP+88
RAPAPPWD EQU   ISTRAP+80
RAPACDEB EQU   ISTRAP+76
RAPACBA  EQU   ISTRAP+72
RAPPRE   EQU   ISTRAP
RDTVSRPL EQU   ISTRDT+132
RDTCRSPW EQU   ISTRDT+124
RDTCRSDS EQU   ISTRDT+116
@NM00084 EQU   ISTRDT+113
RRNSTCNT EQU   RDTSTCNT
RRNVYRPH EQU   RDTVYRPH
RDTTPAB  EQU   ISTRDT+104
RDTDPAB  EQU   ISTRDT+100
RDTEPAB  EQU   ISTRDT+96
RDTVPAB  EQU   ISTRDT+92
RDTRSV01 EQU   RDTFLAGB
RDTBHSET EQU   RDTFLAGB
RDTCTCFL EQU   RDTFLAGB
RDTCTPGD EQU   RDTFLAGB
RDTPRGDN EQU   RDTFLAGB
RDTOUERP EQU   RDTFLAGB
RDTLGCT  EQU   ISTRDT+90
RDTNODID EQU   ISTRDT+89
RDTMAXID EQU   ISTRDT+88
RDTCTSNT EQU   ISTRDT+86
RDTFLAGS EQU   ISTRDT+84
RDTBACK  EQU   ISTRDT+80
RDTFORW  EQU   ISTRDT+76
RDTLEN   EQU   RDTPLEN+1
RDTPRILS EQU   RDTPRIOR
RDTPRISW EQU   RDTPRIOR
RDTPRIRN EQU   RDTPRIOR
RDTPRILC EQU   RDTPRIOR
RDTPRIAP EQU   RDTPRIOR
@NM00083 EQU   RDTPRIOR
RDTPRE   EQU   ISTRDT
RCPRSV05 EQU   ISTRCPRE+120
RCPRSV04 EQU   ISTRCPRE+116
RCPRSV03 EQU   ISTRCPRE+112
RCPINTA  EQU   RCPLGNIN+16
RCPLGNCT EQU   RCPLGNIN+8
RCPLGNAP EQU   RCPLGNIN
@NM00082 EQU   RCPPMODE
RCPRRECD EQU   RCPPMODE
RCPRBASC EQU   RCPPMODE
RCPBFLIM EQU   ISTRCPRE+90
RCPBHSI2 EQU   ISTRCPRE+89
RCPBHSI1 EQU   ISTRCPRE+88
RCPACETR EQU   ISTRCPRE+84
RCPICEAQ EQU   ISTRCPRE+80
RCPLNAPA EQU   ISTRCPRE+76
RCPICELN EQU   ISTRCPRE+72
RCPPRE   EQU   ISTRCPRE
RPRCONID EQU   ISTRPRE+63
RPRCLVPD EQU   RPRFLAGC
RPRINIMM EQU   RPRFLAGD
RPRRSV05 EQU   RPRFLAGD
RPRCONP  EQU   RPRFLAGD
RPRACTP  EQU   RPRFLAGD
RPRRSON  EQU   RPRFLAGD
RPRCONCT EQU   RPRFLAGD
RPRLTASN EQU   RPRFLAGD
RPRPTHCT EQU   ISTRPRE+60
RPRSWDAF EQU   ISTRPRE+58
RPRSTPCT EQU   ISTRPRE+56
RPRRVPT1 EQU   ISTRPRE+52
RPRDEVCH EQU   ISTRPRE+44
RPRNCBA  EQU   ISTRPRE+40
RPRNSNEA EQU   ISTRPRE+36
RPRLGONB EQU   ISTRPRE+32
RPRLGONF EQU   ISTRPRE+28
RPRHDTYP EQU   ISTRPRE+27
RPRTIOCT EQU   ISTRPRE+26
RPRPEPCT EQU   ISTRPRE+24
RPRRSV03 EQU   RPRCAUSE
RPRRSYNC EQU   RPRCAUSE
RPRCRCPT EQU   RPRCAUSE
RPRNOSRT EQU   RPRCAUSE
RPRINTST EQU   RPRFLAGB
RPRVYIMM EQU   RPRFLAGB
RPRHLVPD EQU   RPRFLAGB
RPRONLIN EQU   RPRFLAGB
RPRVIODN EQU   RPRFLAGB
RPRAOPN  EQU   RPRFLAGB
RPRENTVT EQU   RPRFLAGB
RPRENTVH EQU   RPRFLAGB
RPRLIVE  EQU   RPRFLAGA
RPRVRYPD EQU   RPRFLAGA
RPRENTED EQU   RPRFLAGA
RPRENTIO EQU   RPRFLAGA
RPRENTBF EQU   RPRFLAGA
RPRTIED  EQU   RPRFLAGA
RPRINV   EQU   RPRFLAGA
RPRACT   EQU   RPRFLAGA
RPRENTRY EQU   ISTRPRE+20
RPRPELEN EQU   ISTRPRE+18
RPRELEN  EQU   ISTRPRE+16
RPRRLOCK EQU   ISTRPRE+12
RPRDAF   EQU   RPRCOMID+2
RPRSAF   EQU   RPRCOMID
RPRNAME  EQU   ISTRPRE
LDPTCEP  EQU   ISTLDPRM+24
LDPRSV02 EQU   ISTLDPRM+22
LDPRSV01 EQU   LDPFB2
LDPACTIF EQU   LDPFB2
LDPATACH EQU   LDPFB2
LDPFLAST EQU   LDPFB2
LDPRSV03 EQU   LDPFG
LDPPB    EQU   LDPFG
LDPFX    EQU   LDPFG
LDPDCBA  EQU   ISTLDPRM+16
LDPPDS   EQU   ISTLDPRM+8
LDPMBR   EQU   ISTLDPRM
DEVRSV03 EQU   ISTDEVCH+5
DEVPHYSA EQU   ISTDEVCH+4
DEVCSLPN EQU   DEVCHAR3
DEVCSTCL EQU   DEVCHAR3
DEVCCHEK EQU   DEVCHAR3
DEVCATTN EQU   DEVCHAR3
DEVCSWL  EQU   DEVFCCTL
DEVCRVB  EQU   DEVFCCTL
DEVCSSL  EQU   DEVFCCTL
DEVCBSC  EQU   DEVFCCTL
DEVMCODE EQU   ISTDEVCH+2
DEVCHAR2 EQU   DEVTCODE
DEVRSV01 EQU   DEVCHAR
DEVCCTL  EQU   DEVCHAR
DEVNNSPT EQU   DEVCHAR
DEVSPS   EQU   DEVCHAR
DEVSUBND EQU   DEVCHAR
DEVCONVR EQU   DEVCHAR
DEVOTPUT EQU   DEVCHAR
DEVINPUT EQU   DEVCHAR
ATCAOS   EQU   ISTATCVT+1584
ATCPOPAB EQU   ATCAOSM+640
ATCVIOPM EQU   ATCAOSM+636
ATCTPMMI EQU   ATCAOSM+632
ATCTPMPB EQU   ATCAOSM+600
ATCRSV88 EQU   ATCAOSM+596
ATCRPLCT EQU   ATCAOSM+594
ATCCRACT EQU   ATCAOSM+592
ATCSRBCT EQU   ATCAOSM+590
ATCRSV75 EQU   ATCAOSM+589
ATCRSV66 EQU   ATCZFLAG
ATCZF001 EQU   ATCZFLAG
ATCTPCP1 EQU   ATCAOSM+584
ATCTPCP0 EQU   ATCAOSM+580
ATCAICTN EQU   ATCAOSM+576
ATCZR01  EQU   ATCAOSM+572
ATCMPLTA EQU   ATCAOSM+568
ATCASCB  EQU   ATCAOSM+564
ATCAP86  EQU   ATCAOSM+560
ATCAP85  EQU   ATCAOSM+556
ATCAP84  EQU   ATCAOSM+552
ATCAP83  EQU   ATCAOSM+548
ATCAP82  EQU   ATCAOSM+544
ATCAP69  EQU   ATCAOSM+540
ATCAP66  EQU   ATCAOSM+536
ATCAP62  EQU   ATCAOSM+532
ATCAPC59 EQU   ATCAOSM+528
ATCAP56  EQU   ATCAOSM+524
ATCAP55  EQU   ATCAOSM+520
ATCRCFY0 EQU   ATCAOSM+516
ATCAP41  EQU   ATCAOSM+512
ATCAPC25 EQU   ATCAOSM+508
ATCAP23  EQU   ATCAOSM+504
ATCTPSPB EQU   ATCAOSM+472
ATCTRMPB EQU   ATCAOSM+440
ATCAPBE  EQU   ATCAOSM+436
ATCPSTA  EQU   ATCAOSM+432
ATCSMABF EQU   ATCAOSM+428
ATCSMAPR EQU   ATCAOSM+424
ATCTPWQA EQU   ATCAOSM+420
ATCSMAID EQU   ATCAOSM+416
ATCSMARA EQU   ATCAOSM+412
ATCCACXA EQU   ATCAOSM+408
ATCZLAAB EQU   ATCAOSM+404
ATCATA10 EQU   ATCAOSM+400
ATCHLTCB EQU   ATCAOSM+396
@NM00081 EQU   ATCVTFLG
ATCVTACT EQU   ATCVTFLG
ATCRPT40 EQU   ATCAOSM+388
ATCRPT39 EQU   ATCAOSM+384
ATCRPT38 EQU   ATCAOSM+380
ATCRPT37 EQU   ATCAOSM+376
ATCRPT36 EQU   ATCAOSM+372
ATCRPT35 EQU   ATCAOSM+368
ATCRPT34 EQU   ATCAOSM+364
ATCRPT33 EQU   ATCAOSM+360
ATCRPT32 EQU   ATCAOSM+356
ATCRPT31 EQU   ATCAOSM+352
ATCRPT30 EQU   ATCAOSM+348
ATCRPT29 EQU   ATCAOSM+344
ATCRPT28 EQU   ATCAOSM+340
ATCRPT27 EQU   ATCAOSM+336
ATCRPT26 EQU   ATCAOSM+332
ATCRPT25 EQU   ATCAOSM+328
ATCRPT24 EQU   ATCAOSM+324
ATCRPT23 EQU   ATCAOSM+320
ATCRPT22 EQU   ATCAOSM+316
ATCRPT21 EQU   ATCAOSM+312
ATCRPT20 EQU   ATCAOSM+308
ATCRPT19 EQU   ATCAOSM+304
ATCRPLAC EQU   ATCRPLCN+2
ATCRPLRC EQU   ATCRPLCN
ATCCRPLQ EQU   ATCCRPL
ATCSRBAC EQU   ATCSRBCN+2
ATCSRBRC EQU   ATCSRBCN
ATCSRBQ  EQU   ATCSRB
ATCCRAAC EQU   ATCCRACN+2
ATCCRARC EQU   ATCCRACN
ATCCRAQ  EQU   ATCCRA
ATCRPT12 EQU   ATCAOSM+276
ATCDMAPP EQU   ATCAOSM+272
ATCAP38  EQU   ATCAOSM+268
ATCZDFJ0 EQU   ATCAOSM+260
ATCAP51  EQU   ATCAOSM+256
ATCZPAB2 EQU   ATCAOSM+224
ATCZPAB1 EQU   ATCAOSM+192
ATCZLFVT EQU   ATCAOSM+188
ATCZLPVT EQU   ATCAOSM+184
ATCZDVTX EQU   ATCAOSM+180
ATCZDVTA EQU   ATCAOSM+176
ATCZDVT9 EQU   ATCAOSM+172
ATCZDVT8 EQU   ATCAOSM+168
ATCZDVT7 EQU   ATCAOSM+164
ATCRSV56 EQU   ATCDAPVT+22
ATCDAPDG EQU   ATCDAPVT+20
ATCDXCEA EQU   ATCDAPVT+16
ATCDCEA  EQU   ATCDAPVT+12
ATCDPCIA EQU   ATCDAPVT+8
ATCDSIOA EQU   ATCDAPVT+4
ATCDEOEA EQU   ATCDAPVT
ATCZLAEA EQU   ATCLDAPP+16
ATCZLCEA EQU   ATCLDAPP+12
ATCRSV17 EQU   ATCLDAPP+8
ATCSMFRR EQU   ATCLDAPP+4
ATCCDTID EQU   ATCLDAPP
ATCZAEA  EQU   ATCICAPP+16
ATCZCEA  EQU   ATCICAPP+12
ATCCDTCB EQU   ATCICAPP+8
ATCZSIOA EQU   ATCICAPP+4
ATCCDRPH EQU   ATCICAPP
ATCAP65  EQU   ATCAOSM+96
ATCZDVT6 EQU   ATCAOSM+92
ATCZDVT4 EQU   ATCAOSM+88
ATCZDVT3 EQU   ATCAOSM+84
ATCZDVT1 EQU   ATCAOSM+80
ATCICNCB EQU   ATCAOSM+76
ATCZPSVT EQU   ATCAOSM+72
ATCZFSVT EQU   ATCAOSM+68
ATCAP64  EQU   ATCAOSM+64
ATCAP63  EQU   ATCAOSM+60
ATCAP61  EQU   ATCAOSM+56
ATCAP58  EQU   ATCAOSM+52
ATCAP57  EQU   ATCAOSM+48
ATCAP54  EQU   ATCAOSM+44
ATCAP53  EQU   ATCAOSM+40
ATCAP52  EQU   ATCAOSM+36
ATCAP31  EQU   ATCAOSM+24
ATCAP12  EQU   ATCAOSM+20
ATCAP11  EQU   ATCAOSM+16
ATCCMTCB EQU   ATCAOSM+12
ATCPRPH  EQU   ATCAOSM+8
ATCGSRBF EQU   ATCGSRBG
ATCSRBRT EQU   ATCAOSM
@NM00080 EQU   @NM00079
ATCVTMAB EQU   @NM00079
@NM00078 EQU   ATCVTBAM
ATCVDLOK EQU   ISTATCVT+904
ATCVFPAB EQU   ISTATCVT+872
ATCVDPAB EQU   ISTATCVT+840
ATCIOECB EQU   ISTATCVT+836
ATCINCW3 EQU   ISTATCVT+832
ATCMODTB EQU   ISTATCVT+828
ATCUSSPT EQU   ISTATCVT+824
ATCSRTAB EQU   ISTATCVT+820
@NM00077 EQU   ISTATCVT+819
@NM00076 EQU   ATCSTAT2
ATCTRSMS EQU   ATCSTAT2
ATCTRLOK EQU   ATCSTAT2
ATCTRPSS EQU   ATCSTAT2
ATCTRESC EQU   ATCSTAT2
ATCTRAPI EQU   ATCSTAT2
ATCNMCTR EQU   ISTATCVT+816
ATCSEC51 EQU   ATCSECST
ATCSEC40 EQU   ATCSIPD+8
ATCSEC30 EQU   ATCSIPD+4
ATCSEC21 EQU   ATCSIPD
ATCSEC10 EQU   ATCSOPD+4
ATCSEC01 EQU   ATCSOPD
ATCPOIA  EQU   ATCRNO+1
@NM00075 EQU   ATCRNO
ATCPODVT EQU   ISTATCVT+784
ATCS49XL EQU   ISTATCVT+780
ATCS49XI EQU   ISTATCVT+776
ATCLCLCT EQU   ATCVLCNT+2
ATCRNCNT EQU   ATCVLCNT
ATCCFEAD EQU   ISTATCVT+768
ATCPTR00 EQU   ISTATCVT+736
ATCRSV10 EQU   ISTATCVT+704
ATCTACB  EQU   ISTATCVT+700
ATCVTINM EQU   ISTATCVT+696
ATCTCLIM EQU   ISTATCVT+692
ATCTCLOM EQU   ISTATCVT+688
ATCVTIPB EQU   ISTATCVT+656
ATCTCIPB EQU   ISTATCVT+624
ATCTIPAB EQU   ISTATCVT+592
ATCOCCCB EQU   ISTATCVT+588
ATCOCCOB EQU   ISTATCVT+584
ATCCDLAD EQU   ISTATCVT+580
ATCCCLAD EQU   ISTATCVT+576
ATCDLRPB EQU   ISTATCVT+544
ATCPGPAB EQU   ISTATCVT+512
ATCVPAB1 EQU   ISTATCVT+480
ATCRSV97 EQU   ISTATCVT+476
ATCRDTLK EQU   ISTATCVT+472
ATCVOCLK EQU   ISTATCVT+468
ATCCDFDN EQU   ISTATCVT+464
ATCCDFIN EQU   ISTATCVT+460
ATCDVTLK EQU   ISTATCVT+456
ATCAP36  EQU   ISTATCVT+452
ATCAP35  EQU   ISTATCVT+448
ATCAP33  EQU   ISTATCVT+444
ATCRSV99 EQU   ISTATCVT+440
ATCRSV69 EQU   ISTATCVT+416
ATCAPCR5 EQU   ISTATCVT+412
ATCLDECB EQU   ISTATCVT+408
ATCLDNCS EQU   ISTATCVT+404
ATCCDPTR EQU   ISTATCVT+400
ATCADEL  EQU   ISTATCVT+396
ATCTODVT EQU   ISTATCVT+392
ATCDEBCH EQU   ISTATCVT+388
ATCHBSIZ EQU   ATCHPGM+2
ATCHBFNO EQU   ATCHPGM
ATCCRME  EQU   ISTATCVT+380
ATCRVCHS EQU   ISTATCVT+372
ATCECTLP EQU   ISTATCVT+368
ATCZDVTB EQU   ISTATCVT+364
ATCECPRT EQU   ISTATCVT+360
ATCVTLOD EQU   ISTATCVT+356
ATCTRPAB EQU   ISTATCVT+352
ATCMSGM  EQU   ISTATCVT+348
ATCEPT   EQU   ISTATCVT+340
ATCDVT   EQU   ISTATCVT+336
ATCTRCPT EQU   ISTATCVT+332
ATCDVLOD EQU   ISTATCVT+328
ATCALERT EQU   ISTATCVT+324
ATCEPA   EQU   ISTATCVT+320
ATCSAF   EQU   ISTATCVT+318
ATCXRANG EQU   ISTATCVT+317
ATCLAST  EQU   ATCSHRFG
ATCSHRTN EQU   ISTATCVT+308
ATCUEP   EQU   ISTATCVT+304
ATCOCRT  EQU   ISTATCVT+300
ATCCSMA  EQU   ATCCSMR
ATCESC02 EQU   ISTATCVT+292
ATCESC01 EQU   ISTATCVT+288
ATCCDFND EQU   ISTATCVT+284
ATCCDDEL EQU   ISTATCVT+280
ATCCDADD EQU   ISTATCVT+276
ATCMNT   EQU   ISTATCVT+272
ATCRSV16 EQU   ISTATCVT+270
ATCMAXID EQU   ISTATCVT+269
ATCMSGSP EQU   ATCCOM+268
ATCCIDM  EQU   ATCCOM+266
ATCACTRM EQU   ATCCOM+264
ATCNERAP EQU   ATCCOM+260
ATCNESAL EQU   ATCCOM+256
ATCRCC65 EQU   ATCCOM+252
ATCRCC26 EQU   ATCCOM+248
ATCRCC63 EQU   ATCCOM+244
ATCRSV11 EQU   ATCCOM+242
ATCVTMID EQU   ATCCOM+240
ATCAPOST EQU   ATCCOM+236
ATCNERFN EQU   ATCCOM+232
ATCNERNE EQU   ATCCOM+228
ATCNERCV EQU   ATCCOM+224
ATCNERST EQU   ATCCOM+220
ATCDCC61 EQU   ATCCOM+216
ATCDCC60 EQU   ATCCOM+212
ATCSRTDF EQU   ATCCOM+208
ATCSRTAD EQU   ATCCOM+204
ATCFIRA  EQU   ATCCOM+200
ATCSMBQ  EQU   ATCCOM+196
ATCSMRC  EQU   ATCCOM+192
ATCSMRS  EQU   ATCCOM+188
ATCSMQU  EQU   ATCCOM+184
ATCSMRQ  EQU   ATCCOM+180
ATCACDA  EQU   ATCCOM+176
ATCSTMA  EQU   ATCCOM+172
ATCFRSTR EQU   ATCCOM+168
ATCREADA EQU   ATCCOM+160
ATCALOAD EQU   ATCCOM+156
ATCBLDLA EQU   ATCCOM+152
ATCFBRPH EQU   ATCCOM+148
ATCBFTRC EQU   ATCCOM+144
ATCTPBUF EQU   ATCTHTRC
ATCREMOV EQU   ATCCOM+136
ATCADD   EQU   ATCCOM+132
ATCBPDA  EQU   ATCCOM+128
ATCDVTPT EQU   ATCCOM+124
ATCFEPT  EQU   ATCCOM+120
ATCFDVT  EQU   ATCCOM+116
ATCPTCHA EQU   ATCCOM+108
ATCAUTHA EQU   ATCCOM+104
ATCACCTA EQU   ATCCOM+100
ATCRDTH  EQU   ATCCOM+96
ATCFRSCH EQU   ATCCOM+92
ATCFSB   EQU   ATCCOM+88
ATCHLTMS EQU   ATCCOM+84
ATCECPRM EQU   ATCCOM+80
ATCECNET EQU   ATCCOM+76
ATCECOPC EQU   ATCCOM+72
ATCVPARM EQU   ATCCOM+68
ATCECVRQ EQU   ATCCOM+64
ATCECSES EQU   ATCCOM+60
ATCOCHA  EQU   ATCCOM+56
ATCDSPLQ EQU   ATCCOM+52
ATCECDSP EQU   ATCCOM+48
ATCVARYQ EQU   ATCCOM+44
ATCECVRY EQU   ATCCOM+40
ATCHALTQ EQU   ATCCOM+36
ATCECHLT EQU   ATCCOM+32
ATCMODQ  EQU   ATCCOM+28
ATCECMOD EQU   ATCCOM+24
ATCASCHD EQU   ATCCOM+20
ATCSRT   EQU   ATCCOM+16
ATCRDT   EQU   ATCCOM+12
ATCDCFRR EQU   ATCCOM+8
ATCAPI   EQU   ATCCOM+4
ATCRSV04 EQU   ATCSTAT4
ATCVTTRC EQU   ATCSTAT4
ATCNCSD  EQU   ATCSTAT4
ATCMTST  EQU   ATCSTAT4
ATCTPRT  EQU   ATCSTAT4
ATCPRTAT EQU   ATCSTAT4
@NM00074 EQU   ATCPOFLG
ATCPOUNS EQU   ATCPOFLG
ATCHSDMF EQU   ATCSTFLG
@NM00073 EQU   ATCSTAT1
ATCMDHLT EQU   ATCSTAT1
ATCINHLT EQU   ATCSTAT1
ATCNETSL EQU   ATCSTAT1
ATCQKHLT EQU   ATCSTAT1
ATCSNHLT EQU   ATCSTAT1
ATCACTIV EQU   ATCSTAT1
ATCSTART EQU   ATCSTAT1
DYPPAB   EQU   ISTDYPAB+16
DYPRSV01 EQU   ISTDYPAB+12
DYPTSKID EQU   ISTDYPAB+8
DYPCHAIN EQU   ISTDYPAB+4
DYPFLGS  EQU   ISTDYPAB+2
DYPLNGTH EQU   ISTDYPAB+1
DYPTYPE  EQU   ISTDYPAB
LOKXCL   EQU   @NM00071
LOKPRY   EQU   @NM00071
@NM00072 EQU   @NM00071
@NM00070 EQU   LOKCHNG
LOKCT    EQU   ISTLOK
PABRPHA  EQU   PABRPHFG+1
PABNODQ  EQU   PABFLAGS
PABINHBT EQU   PABFLAGS
PABERLOK EQU   PABERRLK
PABSSN   EQU   PABFLAGS
PABDYNAM EQU   PABFLAGS
PABNORPR EQU   PABFLAGS
PABPRIOR EQU   PABFLAGS
PABAPYP  EQU   PABFLAGS
PABDVTA  EQU   ISTPAB+9
PABOFFST EQU   ISTPAB+8
PABCHNGP EQU   PABCHAIN+1
PABRSV02 EQU   PABCHAIN
PABDELAY EQU   PABCHAIN
PABRUNNG EQU   PABCHAIN
PABRESET EQU   PABCHAIN
PABUNCON EQU   PABCHAIN
PABCDP   EQU   PABCHAIN
PABRESCH EQU   PABCHAIN
PABCHNG  EQU   PABCHAIN
PABWEQP  EQU   PABWEQA+1
PABRSV01 EQU   PABWEQA
PABWEQG  EQU   PABWEQA
RPHNEXPO EQU   ISTRPH+104
RPHSAV16 EQU   RPHWORK+60
RPHSAV15 EQU   RPHWORK+56
RPHSAV14 EQU   RPHWORK+52
RPHSAV13 EQU   RPHWORK+48
RPHSAV12 EQU   RPHWORK+44
RPHSAV11 EQU   RPHWORK+40
RPHSAV10 EQU   RPHWORK+36
RPHSAVE9 EQU   RPHWORK+32
RPHSAVE8 EQU   RPHWORK+28
RPHSAVE7 EQU   RPHWORK+24
RPHSAVE6 EQU   RPHWORK+20
RPHSAVE5 EQU   RPHWORK+16
RPHSAVE4 EQU   RPHWORK+12
RPHSAVE3 EQU   RPHWORK+8
RPHSAVE2 EQU   RPHWORK+4
RPHSHALF EQU   RPHSAVE1+2
RPHSBIT8 EQU   RPHSBITS
RPHSBIT7 EQU   RPHSBITS
RPHSBIT6 EQU   RPHSBITS
RPHSBIT5 EQU   RPHSBITS
RPHSBIT4 EQU   RPHSBITS
RPHSBIT3 EQU   RPHSBITS
RPHSBIT2 EQU   RPHSBITS
RPHSBIT1 EQU   RPHSBITS
RPHSBYTE EQU   RPHSAVE1
RPHPABQP EQU   RPHPABQA+1
RPHPABFG EQU   RPHPABQA
RPHCRR   EQU   ISTRPH+32
RPHSRP34 EQU   RPHSRPRM+2
RPHSRP12 EQU   RPHSRPRM
RPHWEGT  EQU   RPHCSPA
RPHRESUM EQU   RPHRESMA+1
RPHRSV01 EQU   RPHWPFLG
RPHPURGE EQU   RPHWPFLG
RPHPT    EQU   RPHWPFLG
RPHRSKEY EQU   RPHWPFLG
RPHDVTA  EQU   ISTRPH+12
RPHTIK   EQU   RPHTSKID+3
@NM00069 EQU   RPHTSKID
RPHRPHAP EQU   RPHRPHA+1
@NM00068 EQU   RPHRPHA
RPHGATE  EQU   RPHRPHA
@NM00067 EQU   RPHFLGB
RPHRLCRA EQU   RPHFLGB
RPHNRSAV EQU   RPHFLGB
RPHPGCMP EQU   RPHFLGB
RPHFBAPS EQU   RPHFLGB
RPHBSSP  EQU   RPHFLGB
RPHLOCK  EQU   RPHFLGB
RPHFNFLG EQU   RPHFSTLC
RPHMLTCP EQU   RPHFLAGS
RPHSMCLR EQU   RPHFLAGS
RPHSMTYP EQU   RPHFLAGS
RPHSMQ   EQU   RPHFLAGS
RPHAUTEX EQU   RPHAPTYP
RPHSPGIN EQU   RPHFLAGS
RPHOGIND EQU   RPHFLAGS
RPHLNGTH EQU   RPHCNTL+1
RPHTYPE  EQU   RPHCNTL
NCSAPPAB EQU   NCSAPP+608
NCSAPDAT EQU   NCSAPBUE+8
NCSAPRU  EQU   NCSAPBUE+3
NCSRSV04 EQU   NCSAPBUE
NCSAPEND EQU   NCSAPP+84
NCSAPTXT EQU   NCSAPP+76
NCSAPECB EQU   NCSAPP+72
NCSAPSA  EQU   NCSAPP
NCSPLPDB EQU   NCSPLSID+5
NCSPLNID EQU   NCSPLPHD
NCSPLPO  EQU   NCSPLSTA
NCSRSVD4 EQU   NCSPLSTA
NCSRSVD2 EQU   NCSCRMOD
NCSPTMOD EQU   NCSCRMOD
NCSAIMOD EQU   NCSCRMOD
NCSRSVD1 EQU   NCSCHKPT+1
NCSPTUSE EQU   NCSCHKPT+1
NCSRNME  EQU   NCSCHKPT+1
NCSCUA   EQU   NCSCHKPT+1
NCSANSMD EQU   NCSCHKPT+1
NCSLGMOD EQU   NCSCHKPT
NCSLGAPL EQU   NCSCHKPT
NCSDTRLM EQU   NCSCHKPT
NCSESLM  EQU   NCSCHKPT
NCSNRPL  EQU   NCSCHKPT
NCSPOLD  EQU   NCSCHKPT
NCSPACTV EQU   NCSCHKPT
NCSACTV  EQU   NCSCHKPT
NCSCRDTE EQU   ISTNCSPL+264
NCSPLRTY EQU   ISTNCSPL+263
NCSPLRH  EQU   ISTNCSPL+260
NCSUFMCB EQU   ISTNCSPL+256
NCSMGLPT EQU   ISTNCSPL+252
NCSCPWPT EQU   ISTNCSPL+248
NCSSENS2 EQU   NCSSENSE+2
NCSSNS2  EQU   NCSSENSE+1
NCSSNS1  EQU   NCSSENSE
NCSPLNSN EQU   ISTNCSPL+240
NCSPLMID EQU   ISTNCSPL+232
NCSPLPID EQU   ISTNCSPL+231
NCSPLGID EQU   ISTNCSPL+230
NCSPLSQN EQU   ISTNCSPL+228
NCSRNAME EQU   ISTNCSPL+220
NCSPLRUI EQU   ISTNCSPL+212
NCSPLRUO EQU   ISTNCSPL+208
NCSPLRRP EQU   ISTNCSPL+204
NCSPLWEL EQU   ISTNCSPL+200
NCSPLSPL EQU   ISTNCSPL+196
NCSPLP3  EQU   ISTNCSPL+192
NCSPLP2  EQU   ISTNCSPL+188
NCSPLP1  EQU   ISTNCSPL+184
NCSPLOLN EQU   ISTNCSPL+182
@NM00066 EQU   NCSPLFL5
NCSFORCE EQU   NCSPLFL5
NCSSDLK  EQU   NCSPLFL5
NCSSCPPS EQU   NCSPLFL5
NCSDLRSN EQU   ISTNCSPL+180
NCSPL2AP EQU   NCSPLFL4
NCSDSPN  EQU   NCSPLFL4
NCSDSPI  EQU   NCSPLFL4
NCSDSPA  EQU   NCSPLFL4
NCSDSPE  EQU   NCSPLFL4
NCSPLVID EQU   NCSPLFL4
NCSPLRSO EQU   NCSPLFL4
NCSDLNID EQU   NCSPLFL4
NCSEND   EQU   NCSPLFL3
NCSFINAL EQU   NCSPLFL3
NCSANS   EQU   NCSPLFL3
NCSPID   EQU   NCSPLFL3
NCSGID   EQU   NCSPLFL3
NCSPLANS EQU   NCSPLFL3
NCSEPP   EQU   NCSPLFL3
NCSPLMOM EQU   NCSPLFL3
NCSPLVIT EQU   NCSPLFL2
NCSPLVIS EQU   NCSPLFL2
NCSREMPO EQU   NCSPLFL2
NCSPLDS  EQU   NCSPLFL2
NCSOUFMC EQU   NCSPLFL2
NCSPLRIO EQU   NCSPLFL2
NCSPLRSF EQU   NCSPLFL2
NCSPLVDP EQU   NCSPLFL2
NCSPLPOS EQU   NCSPLFL1
NCSPL2CN EQU   NCSPLFL1
NCSPLAPU EQU   NCSPLFL1
NCSPLNON EQU   NCSPLFL1
NCSPLREQ EQU   NCSPLFL1
NCSPLEBN EQU   NCSPLFL1
NCSPLSOM EQU   NCSPLFL1
NCSPL2IN EQU   NCSPLFL1
NCSPLRCR EQU   ISTNCSPL+172
NCSPLECB EQU   ISTNCSPL+164
NCSPLRPH EQU   ISTNCSPL+160
NCSPLCVT EQU   ISTNCSPL+156
NCSPLWKA EQU   ISTNCSPL+152
NCSPLDAF EQU   NCSPLCID+2
NCSPLSAF EQU   NCSPLCID
NCSPLRCD EQU   NCSPLRAD+1
NCSLSCMD EQU   NCSPLRAD
NCSPLWRF EQU   ISTNCSPL+72
NCSPLWRE EQU   ISTNCSPL+68
NCSSTCMD EQU   NCSCRFLG
NCSUSRNF EQU   NCSCRFLG
NCSOPRQU EQU   NCSCRFLG
NCSCRDSE EQU   NCSCRFLG
NCSFMERP EQU   NCSCRFLG
NCSFMCLD EQU   NCSCRFLG
NCSPLCLD EQU   NCSCRFLG
NCSPLWRM EQU   NCSCRFLG
NCSPLUAD EQU   ISTNCSPL+64
NCSMSGSP EQU   ISTNCSPL+63
NCSNCPEP EQU   ISTNCSPL+62
NCSCMDB  EQU   NCSPLCMD+1
@NM00065 EQU   NCSCMDA
NCSPLUFM EQU   NCSCMDA
NCSPLFLO EQU   NCSCMDA
NCSPLSYN EQU   NCSCMDA
NCSPLCTL EQU   NCSCMDA
NCSPLSYS EQU   NCSCMDA
NCSPLLPT EQU   ISTNCSPL+56
NCSPLRPT EQU   ISTNCSPL+52
NCSCRPID EQU   ISTNCSPL+51
NCSCRCMD EQU   ISTNCSPL+50
NCSDLID  EQU   ISTNCSPL+44
NCSPLLID EQU   ISTNCSPL+36
NCSPLRID EQU   ISTNCSPL+28
NCSRRNPT EQU   ISTNCSPL+24
NCSIORC  EQU   ISTNCSPL+23
NCSPRMRC EQU   ISTNCSPL+22
NCSOVFMC EQU   NCSPLVF1
NCSRSV02 EQU   NCSPLVFL
NCSDACLK EQU   NCSPLVFL
NCSABCON EQU   NCSPLVFL
NCSDCONT EQU   NCSPLVFL
NCSVSTAT EQU   NCSPLVFL
NCSVDEL  EQU   NCSPLVFL
NCSVNCSA EQU   NCSPLVFL
NCSVBF16 EQU   NCSPLVBF+1
NCSVBF15 EQU   NCSPLVBF+1
NCSVBF14 EQU   NCSPLVBF+1
NCSVBF13 EQU   NCSPLVBF+1
NCSVBF12 EQU   NCSPLVBF+1
NCSVBF11 EQU   NCSPLVBF+1
NCSVBF10 EQU   NCSPLVBF+1
NCSVBF09 EQU   NCSPLVBF+1
NCSVBF08 EQU   NCSPLVBF
NCSVBF07 EQU   NCSPLVBF
NCSVBF06 EQU   NCSPLVBF
NCSVBF05 EQU   NCSPLVBF
NCSVBF04 EQU   NCSPLVBF
NCSVBF03 EQU   NCSPLVBF
NCSVBF02 EQU   NCSPLVBF
NCSVBF01 EQU   NCSPLVBF
NCSPLVCD EQU   ISTNCSPL+17
@NM00064 EQU   ISTNCSPL+16
NCSCRWKA EQU   NCSPFX+12
@NM00063 EQU   NCSPFX
PFXBCK   EQU   ISTPFX+12
PFXFWD   EQU   ISTPFX+8
PFXLNG   EQU   ISTPFX+5
PFXPRTY  EQU   ISTPFX+4
PFXCBID  EQU   PFXID
POHID    EQU   ISTPOHD+2
POHGEN   EQU   POHSTAT
POHRREQ  EQU   POHSTAT
POHRSVD2 EQU   POHSTAT
POHCNTRL EQU   POHSTAT
POHLBL   EQU   POHSTAT
POHDATA  EQU   POHSTAT
POHEND   EQU   POHSTAT
POHRSVD1 EQU   ISTPOHD
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RT00336 EQU   ERASES
@RT00374 EQU   ERASER
@PB00004 EQU   @PB00005
@RC00805 EQU   @EL00001
@RC00857 EQU   @EL00001
@RC00815 EQU   @EL00001
@PB00003 EQU   @PB00004
@PB00002 EQU   @PB00003
@RF00175 EQU   @PB00002
@RC00148 EQU   @PB00002
@RC00178 EQU   @PB00002
@RF00167 EQU   @RC00148
@ENDDATA EQU   *
         END   ISTINCR6,(C'PLS1854',0701,76278)
