SVTM     TITLE 'ISTOCCOA - OPENACB PART I - ATTACHMENT                 *
                        '
         ISEQ 73,80
ISTOCCOA CSECT ,                                                   0002
IFG0192F DS    0H                                                  0002
         ENTRY IFG0192F
@MAINENT DS    0H                                                  0002
         USING *,@15                                               0002
         B     @PROLOG                                             0002
         DC    AL2(@EP00002-@MAINENT)
         DROP  @15
@PROLOG  AH    @15,4(,@15)                                         0002
         BR    @15                                                 0002
@EP00002 DS    0H                                                  0003
RBPRFXLN EQU 64
RBPRFLNA EQU 32
PRBLEN   EQU 136
SIRBLEN  EQU 200
TIRBLEN  EQU 136
IRBLEN   EQU 128
SVRBLEN  EQU 200
RWTGC    EQU   8
*                                                                  0125
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT-NAME = STARTOPN                                          */
*/*                                                                  */
*/* SEGMENT-TYPE = BLOCK                                             */
*/*                                                                  */
*/* FUNCTION     = THE FUNCTION OF STARTOPN IS TO PERFORM            */
*/*                REQUIRED INITIALIZATION FOR THE PHASE-I           */
*/*                OPEN ATTACHMENT TO OCCUR FOR PROCESSING A         */
*/*                VTAM OPEN REQUEST.                                */
*/*                                                                  */
*/* MACROS-USED  = OPENINIT  (OPEN INITIALIZATION)                   */
*/*                UEXIT     (FOR MAINLINE ISSUE CHECK)              */
*/*                                                                  */
*/********************************************************************/
*                                                                  0125
*STARTOPN:                                                         0125
*   ;                                                              0125
STARTOPN DS    0H                                                  0126
*                                                                  0126
*/* OPENINIT   INVOKED.                                              */
*/***********************************************                    */
*/* INPUT:  R2      ADDR OF THE COPY ACB                             */
*/*         R3      GARBAGE                                          */
*/*         R4      ADDR OF THE O/C WORK AREA                        */
*/*         R5      ADDR OF THE O/C RESIDENT RTN                     */
*/*         R6      ADDR OF WHERE TO GO TABLE                        */
*/*         R7      ADDR OF CURRENT ACB ENTRY                        */
*/*         R8      ADDR OF CURRENT WTGT ENTRY                       */
*/*                                                                  */
*/* OUTPUT: RBASE   ADDR OF THE INVOKERS BASE                        */
*/*         RCOPY   ADDR OF THE COPY ACB                             */
*/*         RCORE   ADDR OF THE O/C WORK AREA                        */
*/*         RSAVE   ADDR OF THE SAVE AREA                            */
*/*                                                                  */
*/* NOTES:  THE INVOKING MODULE MUST PROVIDE                         */
*/*         INCLUDES FOR THE FOLLOWING FROM                          */
*/*         SYSLIB:                                                  */
*/*             CVT      - COMM VECTOR TABLE                         */
*/*             IFGACB   - ACCESS CONTROL BLK                        */
*/*         THE INVOKING MODULE MUST PROVIDE                         */
*/*         PERCENT DECLARATIONS AS CHARACTER                        */
*/*         EXTERNAL FOR THE FOLLOWING OPEN                          */
*/*         MACRO VARIABLES AND SEE THAT THEY                        */
*/*         ARE SET TO THEIR ACB EQUIVILENTS:                        */
*/*             OPM-OANAT EQUIV ACB-OANAT                            */
*/*             OPM-OAHLT EQUIV ACB-OAHLT                            */
*/*             OPM-OVINA EQUIV ACB-OVINA                            */
*/***********************************************                    */
*                                                                  0126
*   RFY                                                            0126
*     ISTOCSV;                                                     0126
*   DECLARE                                                        0127
*     MENT0007 LABEL GEND;                                         0127
*   DECLARE                                                        0128
*     PBGN0007 LABEL GEND;                                         0128
*   DECLARE                                                        0129
*     PLOG0007 LABEL GEND;                                         0129
*   DECLARE                                                        0130
*     CMZOCVTP PTR(31) LOCATION(16);                               0130
*   GEN DATA DEFS(C00007);                                         0131
*   RESPECIFY                                                      0132
*    (GPR02P,                                                      0132
*     GPR03P,                                                      0132
*     GPR04P,                                                      0132
*     GPR05P,                                                      0132
*     GPR06P,                                                      0132
*     GPR07P,                                                      0132
*     GPR08P,                                                      0132
*     GPR12P,                                                      0132
*     GPR15P) RESTRICTED;                                          0132
*   GEN DEFS(MENT0007) REFS(GPR15P,MENT0007);                      0133
MENT0007 DS    0H
         USING MENT0007,GPR15P
*   BC(15,PLOG0007);                /* BRANCH AROUND MODULE ID       */
         BC    15,PLOG0007                                         0134
*   GEN DEFS(PBGN0007,PLOG0007) REFS(GPR02P,GPR04P,GPR08P,GPR15P,  0135
*       PBGN0007,PLOG0007) SETS(GPR03P,GPR12P,OCASAV1);            0135
         DC    AL1(8)                  LENGTH OF MODULE ID
         DC    C'ISTOCCOA'             ID OF MODULE
PLOG0007 DS    0H                      PRECEEDING BRANCH TARGET
         LA GPR03P,PBGN0007            R3 MUST GET BASE ADDRESS @ZM0762
         DROP  GPR15P
PBGN0007 DS    0H
         USING PBGN0007,GPR12P         ESTABLISH MOD BASE IN R12
         LR GPR12P,GPR03P              SET UP ADDRESSSABILITY @ZM0762
         MODESET EXTKEY=ZERO,WORKREG=2
         STM  GPR02P,GPR08P,OCASAV1(GPR04P)  SAVE CALLERS REGS 2-8
*   RESPECIFY                                                      0136
*    (GPR03P,                                                      0136
*     GPR05P,                                                      0136
*     GPR06P,                                                      0136
*     GPR07P,                                                      0136
*     GPR08P,                                                      0136
*     GPR15P) UNRESTRICTED;                                        0136
*   RESPECIFY                                                      0137
*     GPR10P RESTRICTED;                                           0137
*                                                                  0137
*   /*****************************************************************/
*   /*                                                               */
*   /* OBTAIN THE VTAM CVT ADDRESS                                   */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0138
*   DO;                             /* LISATCVT                    0138
*                                      CVTBASE(PAGEABLE,(GPR10P))    */
*     GPR10P=ATCLCPTR;              /* SET UP ATCVT POINTER          */
         L     GPR10P,ATCLCPTR                                     0139
*   END;                            /* LISATCVT                      */
*   IF GPR10P=0                     /* IS VTAM ACTIVE?       @ZA03599*/
*       |GPR10P->ATCACTIV='0'B THEN /* NO, SO:               @ZA03599*/
         LTR   GPR10P,GPR10P                                       0141
         BZ    @RT00141                                            0141
         TM    ATCACTIV(GPR10P),B'01000000'                        0141
         BNZ   @RF00141                                            0141
@RT00141 DS    0H                                                  0142
*     GPR02P->ACBERFLG='5C'X;       /* REMEMBER FAILING ERROR      0142
*                                                            @ZA03599*/
         MVI   ACBERFLG(GPR02P),X'5C'                              0142
*   ELSE                                                           0143
*     DO;                           /* ACTIVE, CHECK HALTING         */
         B     @RC00141                                            0143
@RF00141 DS    0H                                                  0144
*       IF GPR10P->ATCQKHLT='1'B|   /* IF QUICK OR                   */
*           GPR10P->ATCSNHLT='1'B   /* SESSION HALTING,              */
*         THEN                                                     0144
         TM    ATCQKHLT(GPR10P),B'00110000'                        0144
         BZ    @RF00144                                            0144
*         GPR02P->ACBERFLG='52'X;   /* REMEMBER FAILING ERROR        */
         MVI   ACBERFLG(GPR02P),X'52'                              0145
*       ELSE                        /* VTAM IS NOT HALTING, SO:      */
*         DO;                                                      0146
         B     @RC00144                                            0146
@RF00144 DS    0H                                                  0147
*           GPR04P->OCAOCXAD=GPR10P;/* SAVE VTAM CVT ADDRESS         */
         ST    GPR10P,OCAOCXAD(,GPR04P)                            0147
*           GPR02P->ACBERFLG='00'X; /* REMEMBER SUCCESS              */
         MVI   ACBERFLG(GPR02P),X'00'                              0148
*         END;                                                     0149
*     END;                                                         0150
@RC00144 DS    0H                                                  0151
*   RESPECIFY                                                      0151
*     GPR10P UNRESTRICTED;                                         0151
@RC00141 DS    0H                                                  0152
*   RBASE=GPR12P;                   /* ESTABLISH MODULE BASE         */
*   GEN REFS(GPR12P,PBGN0007,RBASE);                               0153
         DROP  GPR12P
         USING PBGN0007,RBASE
*   IF GPR02P->ACBERFLG='00'X       /* IF NO ERROR HAS OCCURRED      */
*     THEN                                                         0154
         CLI   ACBERFLG(GPR02P),X'00'                              0154
         BNE   @RF00154                                            0154
*     DO;                                                          0155
*       GPR04P->OCAAPYAD=GPR02P;    /* SET OCA COPY ACB PTR          */
         ST    GPR02P,OCAAPYAD(,GPR04P)                            0156
*       GPR04P->OCALNTH=LENGTH(ISTOCA);/* SET ISTOCA CTL BLK LEN     */
         MVC   OCALNTH(2,GPR04P),@CH03054                          0157
*       GPR04P->OCAID=OCAIDEN;      /* SET ISTOCA CTL BLK ID         */
         MVI   OCAID(GPR04P),X'FF'                                 0158
*       RCOPY=GPR02P;               /* SET UP RCOPY FOR INVOKER      */
         LR    RCOPY,GPR02P                                        0159
*       RCORE=GPR04P;               /* SET UP RCORE FOR INVOKER      */
         LR    RCORE,GPR04P                                        0160
*       RSAVE=ADDR(RCORE->OCASAV2); /* SET UP RSAVE FOR INVOKER      */
         LA    RSAVE,OCASAV2(,RCORE)                               0161
*     END;                                                         0162
*   ELSE                            /* AN ERROR OCCURRED, SO:        */
*     DO;                                                          0163
         B     @RC00154                                            0163
@RF00154 DS    0H                                                  0164
*       GPR04P->OCAACBAD->ACBERFLG=GPR02P->ACBERFLG;/* SET USER ACB
*                                      ERROR FLAGS                   */
         L     @14,OCAACBAD(,GPR04P)                               0164
         MVC   ACBERFLG(1,@14),ACBERFLG(GPR02P)                    0164
*       GPR04P->OCAACBAD->ACBBUSY='0'B;/* INDICATE AN OPEN ERROR     */
         NI    ACBBUSY(@14),B'11111110'                            0165
*       GPR04P->OCAOCXAD=0;         /* CLEAR VTAM CVT PTR IN OCA     */
         SLR   @14,@14                                             0166
         ST    @14,OCAOCXAD(,GPR04P)                               0166
*       RCORE=GPR04P;               /* ESTABLISH ISTOCA BASE         */
*                                                                  0167
         LR    RCORE,GPR04P                                        0167
*       /*************************************************************/
*       /*                                                           */
*       /* EXIT TO OPENTERM WITH ERROR INDICATION                    */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0168
*                                                                  0168
*/* OPENTERM  COPY(NO) INVOKED.                                      */
*                                                                  0168
*       /*************************************************************/
*       /*                                                           */
*       /* INPUT: RBASE ADDR OF THE INVOKERS BASE RCOPY ADDR OF THE  */
*       /* COPY ACB RCORE ADDR OF THE O/C WORK AREA RSAVE ADDR OF THE*/
*       /* SAVE AREA OUTPUT: R2 ADDR OF THE COPY ACB R3 ADDR OF THE  */
*       /* INVOKERS BASE R4 ADDR OF THE O/C WORK AREA R5 ADDR OF O/C */
*       /* RESIDENT RTN R6 ADDR OF WHERE TO GO TABLE R7 ADDR OF      */
*       /* CURRENT ACB ENTRY R8 ADDR OF CURRENT WTGT ENTRY NOTES: THE*/
*       /* INVOKING MODULE MUST PROVIDE INCLUDES FOR THE FOLLOWING   */
*       /* FROM SYSLIB: CVT - COMM VECTOR TABLE IFGACB - ACCESS      */
*       /* CONTROL BLK                                               */
*       /*                                                           */
*       /*************************************************************/
*                                                                  0168
*       DO;                                                        0168
*         GEN SETS(GPR02P,GPR03P,GPR04P,GPR05P,GPR06P,GPR07P,GPR08P)
*             REFS(OCASAV1,RCORE);                                 0169
         LM    GPR02P,GPR08P,OCASAV1(RCORE)      RESTORE REGS FROM
*                                      FIRST SAVE AREA OF ISTOCA.
*         RFY                                                      0170
*          (GPR02P,                                                0170
*           GPR03P,                                                0170
*           GPR04P,                                                0170
*           GPR05P,                                                0170
*           GPR06P,                                                0170
*           GPR07P,                                                0170
*           GPR08P) RESTRICTED;                                    0170
*         RFY                                                      0171
*           ISTOCA BASED(GPR04P);                                  0171
*         DCL                                                      0172
*           X0015 CHAR(*) DEFINED(ISTOCA);                         0172
*                                                                  0172
*         /***********************************************************/
*         /*                                                         */
*         /* ZERO OPEN/CLOSE WORK AREA - ISTOCA                      */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0173
*         RESPECIFY                                                0173
*           GPR09P RESTRICTED;                                     0173
*         GPR09P=ADDR(OCASAV3)-ADDR(ISTOCA)+LENGTH(OCASAV3);       0174
         LA    GPR09P,OCASAV3(,GPR04P)                             0174
         SLR   GPR09P,GPR04P                                       0174
         AH    GPR09P,@CH01788                                     0174
*         X0015(1:GPR09P)=X0015(1:GPR09P)&&X0015(1:GPR09P);        0175
         LR    @14,GPR09P                                          0175
         BCTR  @14,0                                               0175
         EX    @14,@SX03057                                        0175
*         RESPECIFY                                                0176
*           GPR09P UNRESTRICTED;                                   0176
*                                                                  0176
*         /***********************************************************/
*         /*                                                         */
*         /* RETURN TO SYSTEM COMMON OPEN - IFG0196V                 */
*         /*                                                         */
*         /***********************************************************/
*                                                                  0177
*         GEN SETS(GPR14P);                                        0177
         IECRES XCTL,MOD2F6V,8          AFFECT RETURN TO CALLER
*         RFY                                                      0178
*          (GPR02P,                                                0178
*           GPR03P,                                                0178
*           GPR04P,                                                0178
*           GPR05P,                                                0178
*           GPR06P,                                                0178
*           GPR07P,                                                0178
*           GPR08P) UNRESTRICTED;                                  0178
*         RFY                                                      0179
*           ISTOCA BASED(RCORE);                                   0179
*       END;                                                       0180
*                                                                  0180
*/* END OF OPENTERM EXPANSION.                                       */
*                                                                  0181
*     END;                                                         0181
*   RESPECIFY                                                      0182
*    (GPR02P,                                                      0182
*     GPR04P,                                                      0182
*     GPR12P) UNRESTRICTED;                                        0182
*                                                                  0182
@RC00154 DS    0H                                                  0183
*/* END OF OPENINIT EXPANSION.                                       */
*/* UEXIT  OPEN                                                      */
*                                                                  0183
*   DO;                                                            0183
*                                                                  0183
*/* ATBUILD (ISTMPST,ISTDCE,ISTACDEB,ISTPST)                         */
*                                                                  0184
*     RFY                                                          0184
*       ISTMPST;                                                   0184
*     RFY                                                          0185
*       ISTDCE;                                                    0185
*     RFY                                                          0186
*       ISTACDEB;                                                  0186
*     RFY                                                          0187
*       ISTPST;                                                    0187
*                                                                  0187
*/* END OF ATBUILD                                                   */
*                                                                  0188
*     DCL                                                          0188
*       CMZUCVTP PTR(31) LOCATION(16);                             0188
*     RFY                                                          0189
*      (GPR02P,                                                    0189
*       GPR03P,                                                    0189
*       GPR04P,                                                    0189
*       GPR15P) RSTD;               /* ACCESS CURRENT TCB            */
*     GPR04P=PSATOLD;               /* OBTAIN RB PTR                 */
         L     GPR04P,PSATOLD                                      0190
*     GPR03P=GPR04P->TCBRBP;        /* SEARCH RB CHAIN FOR IRB       */
         L     GPR03P,TCBRBP(,GPR04P)                              0191
*     DO WHILE((GPR03P^=0)&(GPR03P^=GPR04P));                      0192
         B     @DE00192                                            0192
@DL00192 DS    0H                                                  0193
*       GPR15P=GPR03P->XSTAB1&'E0'X;/* OBTAIN RB TYPE                */
         LA    GPR15P,224                                          0193
         SLR   @11,@11                                             0193
         IC    @11,XSTAB1(,GPR03P)                                 0193
         NR    GPR15P,@11                                          0193
*       IF GPR15P='00000040'X       /* IS RB AN IRB                  */
*         THEN                                                     0194
         CH    GPR15P,@CH02835                                     0194
         BNE   @RF00194                                            0194
*         GPR03P=0;                                                0195
         SLR   GPR03P,GPR03P                                       0195
*       ELSE                                                       0196
*         GPR03P=GPR03P->RBLINKB;                                  0196
         B     @RC00194                                            0196
@RF00194 SLR   @14,@14                                             0196
         ICM   @14,7,RBLINKB(GPR03P)                               0196
         LR    GPR03P,@14                                          0196
*     END;                                                         0197
@RC00194 DS    0H                                                  0197
@DE00192 LTR   GPR03P,GPR03P                                       0197
         BZ    @DC00192                                            0197
         CR    GPR03P,GPR04P                                       0197
         BNE   @DL00192                                            0197
@DC00192 DS    0H                                                  0198
*     IF GPR03P=0                   /* WAS IRB FOUND                 */
*       THEN                        /* YES, REJECT - OPEN/CLOSE      */
         LTR   GPR03P,GPR03P                                       0198
         BNZ   @RF00198                                            0198
*       GPR15P=4;                   /* WAS NOT ISSUED FROM MAINLINE  */
         LA    GPR15P,4                                            0199
*     ELSE                                                         0200
*       DO;                                                        0200
         B     @RC00198                                            0200
@RF00198 DS    0H                                                  0201
*         GPR15P=0;                 /* ASSUME - ACCEPT OPEN/CLOSE    */
         SLR   GPR15P,GPR15P                                       0201
*         DO;                       /* LISATCVT                    0202
*                                      CVTBASE(PAGEABLE,(GPR03P))    */
*           GPR03P=ATCLCPTR;        /* SET UP ATCVT POINTER          */
         L     GPR03P,ATCLCPTR                                     0203
*         END;                      /* LISATCVT                      */
*         IF PSAAOLD=GPR03P->ATCASCB/* IS THIS VTAMS MEMORY          */
*           THEN                                                   0205
         CLC   PSAAOLD(4),ATCASCB(GPR03P)                          0205
         BE    @RT00205                                            0205
*           ;                       /* YES , ACCEPT REQUEST          */
*         ELSE                      /* NO, CONTINUE CHECKING         */
*           DO;                                                    0207
*             GPR03P=PSAAOLD;       /* OBTAIN ASCB POINTER           */
         L     GPR03P,PSAAOLD                                      0208
*             GPR02P=GPR03P->ASCBASXB;/* OBTAIN ASXB POINTER         */
         L     GPR02P,ASCBASXB(,GPR03P)                            0209
*             GPR04P=GPR02P->ASXBMPST;/* OBTAIN MPST FROM ASXB       */
         L     GPR04P,ASXBMPST(,GPR02P)                            0210
*             IF GPR04P=0 THEN                                     0211
         LTR   GPR04P,GPR04P                                       0211
         BZ    @RT00211                                            0211
*               ;                   /* IS THIS FIRST OPEN ACB IN THIS
*                                      MEMORY                        */
*             ELSE                                                 0213
*               DO;                                                0213
*                 GPR04P=GPR04P->MPSDBTBL->DCEDBPTR;/* OBTAIN DEB  0214
*                                      ADDR FROM MPST DCE            */
         L     @14,MPSDBTBL(,GPR04P)                               0214
         L     @14,DCEDBPTR(,@14)                                  0214
         LR    GPR04P,@14                                          0214
*                 IF GPR04P->ACDTSKID->PSTABINP='1'B/* IS ABEND IN 0215
*                                      PROGRESS?                     */
*                   THEN            /* REJECT OPEN FOR THIS TASK     */
         L     @14,ACDTSKID(,GPR04P)                               0215
         TM    PSTABINP(@14),B'00000001'                           0215
         BNO   @RF00215                                            0215
*                   GPR15P=16;                                     0216
         LA    GPR15P,16                                           0216
*                 ELSE                                             0217
*                   ;                                              0217
@RF00215 DS    0H                                                  0218
*               END;                                               0218
*           END;                                                   0219
@RT00211 DS    0H                                                  0220
*       END;                                                       0220
@RT00205 DS    0H                                                  0221
*     RFY                                                          0221
*      (GPR02P,                                                    0221
*       GPR03P,                                                    0221
*       GPR04P,                                                    0221
*       GPR15P) UNRSTD;                                            0221
@RC00198 DS    0H                                                  0222
*   END;                            /* **** END OF UEXIT GENERATION  */
*   IF RRVAL=MAINLINE               /* REQUEST ACCEPTED?     @X04BHJY*/
*     THEN                                                         0223
         LTR   RRVAL,RRVAL                                         0223
         BZ    @RT00223                                            0223
*     ;                             /* YES---EXIT SUBRTN     @X04BHJY*/
*   ELSE                            /* NO--SET UP CODE       @X04BHJY*/
*     IF RRVAL=NTMNLINE             /* REJECTED BECAUSE NOT ISSUED IN
*                                      MAINLINE?             @X04BHJY*/
*       THEN                        /* YES                   @X04BHJY*/
         CH    RRVAL,@CH00056                                      0225
         BNE   @RF00225                                            0225
*       COPYACB->ACBERFLG='46'X;    /* TELL USER OF MNLINE ERROR     */
         L     @14,COPYACB(,RCORE)                                 0226
         MVI   ACBERFLG(@14),X'46'                                 0226
*     ELSE                          /* REJECTED BECAUSE ABEND IN   0227
*                                      PROGRESS FOR TASK     @X50CKXL*/
*       COPYACB->ACBERFLG='70'X;    /* TELL USER OF ABEND    @X50CKXL*/
         B     @RC00225                                            0227
@RF00225 L     @14,COPYACB(,RCORE)                                 0227
         MVI   ACBERFLG(@14),X'70'                                 0227
*                                                                  0228
*   /*****************************************************************/
*   /*                                                               */
*   /* CALL ISTOCCOB EXTERNAL TO SYNCHRONIZE THE REMAINDER OF THE    */
*   /* OPEN PROCESSING - PASSING THE ADDRESS OF THE OPEN WORK AREA   */
*   /* VIA GENERAL PURPOSE REGISTER ONE.                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0228
*   IF COPYACB->ACBERFLG=NOERRS     /* FREE OF ERRORS?               */
*     THEN                          /* YES                           */
@RC00225 DS    0H                                                  0228
@RT00223 L     @14,COPYACB(,RCORE)                                 0228
         CLI   ACBERFLG(@14),X'00'                                 0228
         BNE   @RF00228                                            0228
*     DO;                                                          0229
*       RFY                                                        0230
*         GPR01P RSTD;                                             0230
*       GPR01P=RWRK;                /* CALL OPEN ACB PART-II         */
         LR    GPR01P,RWRK                                         0231
*       CALL ISTOCCOB;              /* PASSING WORK AREA             */
         L     @11,OCAOCXAD(,RCORE)                                0232
         L     @15,ATCOCCOB(,@11)                                  0232
         BALR  @14,@15                                             0232
*       RFY                                                        0233
*         GPR01P UNRSTD;                                           0233
*     END;                                                         0234
*   ELSE                                                           0235
*     ;                             /* THERE IS AN ERROR HERE        */
@RF00228 DS    0H                                                  0236
*                                                                  0236
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT-NAME = CMPLTOPN                                          */
*/*                                                                  */
*/* SEGMENT-TYPE = BLOCK                                             */
*/*                                                                  */
*/* FUNCTION     = THE FUNCTION OF CMPLTOPN IS TO COMPLETE           */
*/*                THE VTAM OPEN ACB REQUEST PROCESSING.             */
*/*                                                                  */
*/* MACROS-USED  = VMDESET    (TO SWAP KEYS)                         */
*/*                OPENTERM   (FOR OPEN TERMINATION)                 */
*/*                TPEPILOG                                          */
*/*                ATDSPLY    (TO DSPLY ATBUILT CTL BLKS)            */
*/*                                                                  */
*/********************************************************************/
*                                                                  0236
*CMPLTOPN:                                                         0236
*   ;                                                              0236
CMPLTOPN DS    0H                                                  0237
*   IF COPYACB->ACBERFLG^=NOERRS    /* HAS AN ERROR HAS OCCURRED?    */
*     THEN                          /* YES                           */
         L     @14,COPYACB(,RCORE)                                 0237
         CLI   ACBERFLG(@14),X'00'                                 0237
         BE    @RF00237                                            0237
*     COPYACB->ACBBUSY=OFF;         /* TELL COMMON OPEN              */
         NI    ACBBUSY(@14),B'11111110'                            0238
*   ELSE                                                           0239
*     ;                             /* NO ERROR              @DA04539*/
@RF00237 DS    0H                                                  0240
*   RFY                                                            0240
*    (XFRERFLG,                                                    0240
*     USERACB,                                                     0240
*     XFROFLGS) RSTD;                                              0240
*   USERACB=OCAACBAD;               /* GET @ OF USER ACB             */
         L     USERACB,OCAACBAD(,RCORE)                            0241
*   XFRERFLG=COPYACB->ACBERFLG;     /* ERROR FLAGS FROM COPY ACB     */
         L     @14,COPYACB(,RCORE)                                 0242
         SLR   XFRERFLG,XFRERFLG                                   0242
         IC    XFRERFLG,ACBERFLG(,@14)                             0242
*   XFROFLGS=COPYACB->ACBOFLGS;     /* OPEN FLAGS FROM COPY ACB      */
         SLR   XFROFLGS,XFROFLGS                                   0243
         IC    XFROFLGS,ACBOFLGS(,@14)                             0243
*   GPR05P=PSATOLD;                 /*                        XM08732*/
         L     GPR05P,PSATOLD                                      0244
*   GEN REFS(GPR05P)(USING TCB,GPR05P);/*                     XM08732*/
         USING TCB,GPR05P
*                                                                  0246
*/*VMDESET  ((15),TCB)                                               */
*                                                                  0246
*   DO;                             /* INVOKE MODESET MACRO          */
*     GEN;                                                         0247
         MODESET EXTKEY=TCB,WORKREG=2
*     RFY                                                          0248
*      (GPR15P) RSTD;                                              0248
*     GPR15F=0;                                                    0249
         SLR   GPR15F,GPR15F                                       0249
*     RFY                                                          0250
*      (GPR15P) UNRSTD;             /* PUT RETURN CODE IN RCREG      */
*   END;                            /* VMDESET ASSUME APPLICATION KEY*/
*   GEN REFS(GPR05P)(DROP    GPR05P);/*                       XM08732*/
         DROP    GPR05P
*   USERACB->ACBERFLG=XFRERFLG;     /* TRANSFER ERROR FLAGS TO USERS
*                                      ACB                           */
         STC   XFRERFLG,ACBERFLG(,USERACB)                         0253
*   USERACB->ACBOFLGS=XFROFLGS;     /* TRANSFER OPEN FLAGS TO USERS
*                                      ACB                           */
         STC   XFROFLGS,ACBOFLGS(,USERACB)                         0254
*/*VMDESET  ((15),ZERO)                                              */
*                                                                  0255
*   DO;                             /* INVOKE MODESET MACRO          */
*     GEN;                                                         0256
         MODESET EXTKEY=ZERO,WORKREG=2
*     RFY                                                          0257
*      (GPR15P) RSTD;                                              0257
*     GPR15F=0;                                                    0258
         SLR   GPR15F,GPR15F                                       0258
*     RFY                                                          0259
*      (GPR15P) UNRSTD;             /* PUT RETURN CODE IN RCREG      */
*   END;                            /* VMDESET RESTORE KEY           */
*   RFY                                                            0261
*    (XFRERFLG,                                                    0261
*     USERACB,                                                     0261
*     XFROFLGS) UNRSTD;                                            0261
*                                                                  0262
*/* OPENTERM   INVOKED.                                              */
*                                                                  0262
*   /*****************************************************************/
*   /*                                                               */
*   /* INPUT: RBASE ADDR OF THE INVOKERS BASE RCOPY ADDR OF THE COPY */
*   /* ACB RCORE ADDR OF THE O/C WORK AREA RSAVE ADDR OF THE SAVE    */
*   /* AREA OUTPUT: R2 ADDR OF THE COPY ACB R3 ADDR OF THE INVOKERS  */
*   /* BASE R4 ADDR OF THE O/C WORK AREA R5 ADDR OF O/C RESIDENT RTN */
*   /* R6 ADDR OF WHERE TO GO TABLE R7 ADDR OF CURRENT ACB ENTRY R8  */
*   /* ADDR OF CURRENT WTGT ENTRY NOTES: THE INVOKING MODULE MUST    */
*   /* PROVIDE INCLUDES FOR THE FOLLOWING FROM SYSLIB: CVT - COMM    */
*   /* VECTOR TABLE IFGACB - ACCESS CONTROL BLK                      */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0262
*   DO;                                                            0262
*     GEN SETS(GPR02P,GPR03P,GPR04P,GPR05P,GPR06P,GPR07P,GPR08P) REFS(
*         OCASAV1,RCORE);                                          0263
         LM    GPR02P,GPR08P,OCASAV1(RCORE)      RESTORE REGS FROM
*                                      FIRST SAVE AREA OF ISTOCA.
*     RFY                                                          0264
*      (GPR02P,                                                    0264
*       GPR03P,                                                    0264
*       GPR04P,                                                    0264
*       GPR05P,                                                    0264
*       GPR06P,                                                    0264
*       GPR07P,                                                    0264
*       GPR08P) RESTRICTED;                                        0264
*     RFY                                                          0265
*       ISTOCA BASED(GPR04P);                                      0265
*     DCL                                                          0266
*       X0032 CHAR(*) DEFINED(ISTOCA);                             0266
*                                                                  0266
*     /***************************************************************/
*     /*                                                             */
*     /* ZERO OPEN/CLOSE WORK AREA - ISTOCA                          */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0267
*     RESPECIFY                                                    0267
*       GPR09P RESTRICTED;                                         0267
*     GPR09P=ADDR(OCASAV3)-ADDR(ISTOCA)+LENGTH(OCASAV3);           0268
         LA    GPR09P,OCASAV3(,GPR04P)                             0268
         SLR   GPR09P,GPR04P                                       0268
         AH    GPR09P,@CH01788                                     0268
*     X0032(1:GPR09P)=X0032(1:GPR09P)&&X0032(1:GPR09P);            0269
         LR    @14,GPR09P                                          0269
         BCTR  @14,0                                               0269
         EX    @14,@SX03059                                        0269
*     RESPECIFY                                                    0270
*       GPR09P UNRESTRICTED;                                       0270
*                                                                  0270
*     /***************************************************************/
*     /*                                                             */
*     /* RETURN TO SYSTEM COMMON OPEN - IFG0196V                     */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0271
*     GEN SETS(GPR14P);                                            0271
*                                                                  0271
         IECRES XCTL,MOD2F6V,8          AFFECT RETURN TO CALLER
*     /***************************************************************/
*     /*                                                             */
*     /* DEFINE GENERATED CONSTANTS                                  */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0272
*     DCL                                                          0272
*       XCTL6V GEND STATIC;                                        0272
*     DCL                                                          0273
*       RWTGC GEND;                                                0273
*     GEN DATA DEFS(XCTL6V);                                       0274
*     RFY                                                          0275
*      (GPR02P,                                                    0275
*       GPR03P,                                                    0275
*       GPR04P,                                                    0275
*       GPR05P,                                                    0275
*       GPR06P,                                                    0275
*       GPR07P,                                                    0275
*       GPR08P) UNRESTRICTED;                                      0275
*     RFY                                                          0276
*       ISTOCA BASED(RCORE);                                       0276
*   END;                                                           0277
*                                                                  0277
*/* END OF OPENTERM EXPANSION.                                       */
*/* TPEPILOG                                                         */
*                                                                  0278
*   GEN(PRINT OFF);                                                0278
         PRINT OFF
*/*  OPEN/CLOSE STANDARD SAVE AREA IH0311  PH - NOV25 72             */
*  DCL 1 ISTOCSV CHAR(72) BDY(WORD) BASED, /* OPEN/CLOSE SAVE AREA   */
*      2 OCSRSV01 PTR(31),  /* RESERVED                              */
*      2 OCSBACK  PTR(31),  /* BACKWARD POINTER                      */
*      2 OCSFWD   PTR(31),  /* FORWARD POINTER                       */
*      2 OCSR14   PTR(31),  /* SLOT FOR R14                          */
*      2 OCSR15   PTR(31),  /* SLOT FOR R15                          */
*      2 OCSR0    PTR(31),  /* SLOT FOR R0                           */
*      2 OCSR1    PTR(31),  /* SLOT FOR R1                           */
*      2 OCSR2    PTR(31),  /* SLOT FOR R2                           */
*      2 OCSR3    PTR(31),  /* SLOT FOR R3                           */
*      2 OCSR4    PTR(31),  /* SLOT FOR R4                           */
*      2 OCSR5    PTR(31),  /* SLOT FOR R5                           */
*      2 OCSR6    PTR(31),  /* SLOT FOR R6                           */
*      2 OCSR7    PTR(31),  /* SLOT FOR R7                           */
*      2 OCSR8    PTR(31),  /* SLOT FOR R8                           */
*      2 OCSR9    PTR(31),  /* SLOT FOR R9                           */
*      2 OCSR10   PTR(31),  /* SLOT FOR R10                          */
*      2 OCSR11   PTR(31),  /* SLOT FOR R11                          */
*      2 OCSR12   PTR(31);  /* SLOT FOR R12                          */
*/* *****      MEMORY PROCESS SCHEDULE TABLE FOR VS2  ***** */     0280
*/*  REVISIONS                                          002 05/21/75 */
*DCL  1  ISTMPST BDY(DWORD) BASED,                                 0280
*        2  MPSID CHAR(4),               /* MPST EBCDIC ACRONYM */ 0280
*        2  MPSRSV07 PTR(31),          /*RESERVED                     *
*        2  MPSRQUE PTR(31),           /* READY QUEUE                */
*           3  MPSRQUEG BIT(1),        /* GATE FOR READY QUEUE       */
*        2  MPSFLGA CHAR(4) BDY(WORD), /* FLAGS                      */
*           3  MPSSRBO BIT(1),         /* IF ON SMS REQUEST FOR SRB
*                                         OUTSTANDING                */
*           3  MPSCRAO BIT(1),         /* IF ON REQUEST TO SMS FOR 0280
*                                         CRA OUSTANDING             */
*           3  MPSAUTH BIT(1),         /*THIS MEMORY IS AUTHRZD BY APF*
*           3  MPMEMTRM BIT(1),        /* MEMORY TERMINATION HAS OCCUR-
*                                         RED               @YL02HDM */
*           3  MPSTPBU  BIT(1),        /* TPIO PAB NEEDS CLEAN-UP    */
*           3  MPSRSV01 BIT(2),        /* RESERVED                   */
*           3  MPSPSTAB BIT(1),        /* RESERVED FOR MPST/PST      */
*                                      /* COMPATIBILITY              */
*           3  MPSRSV02 BIT(8),        /* RESERVED                   */
*           3  MPSASID CHAR(2),        /* ASID                       */
*        2  MPSPSTCT FIXED(31),        /* COUNT OF PST ASSOCIATED  0280
*                                         WITH THIS MPST             */
*        2  MPSMPSTP PTR(31),          /* PTR TO MPST - MUST BE 6TH
*                                         WORD OF THE MPST           */
*        2  MPSCRA CHAR(8) BDY(DWORD),                             0280
*           3  MPSCRAQ PTR(31),        /* QUEUE OF AVAILABLE CRA'S   */
*           3  MPSCRACT FIXED(31),     /* COUNT OF CRA'S ON THE    0280
*                                         AVAILABLE CRA QUEUE        */
*               4  MPSCRARC FIXED(16), /* RUNNING CNT OF CRA'S Q'D   */
*               4  MPSCRAAC FIXED(16), /*  CNT OF CRA'S ON AVAIL Q   */
*        2  MPSSRB CHAR(8) BDY(DWORD),                             0280
*           3  MPSSRBQ PTR(31),        /* QUEUE OF AVAILABLE PRE-  0280
*                                         ALLOCATED SRB'S            */
*           3  MPSSRBCT FIXED(31),     /* COUNT OF SRB'S ON AVAILABLE
*                                         SRB QUEUE                  */
*               4  MPSSRBRC FIXED(16), /* RUNNING CNT OF SRB'S Q'D   */
*               4  MPSSRBAC FIXED(16), /*  CNT OF SRB'S ON AVAIL Q   */
*        2  MPSCRPL CHAR(8) BDY(DWORD),                            0280
*           3  MPSCRPLQ PTR(31),         /* QUEUE OF AVAILABLE CRPLS*/
*           3  MPSRPLCT FIXED(31),       /* CNT OF CRPLS ON AVAIL Q */
*              4  MPSRPLRC FIXED(16),    /* RUNNING CNT OF CRPLS QED*/
*              4  MPSRPLAC FIXED(16),    /* CNT OF CRPLS ON AVAIL Q */
*        2  MPSSRB55 PTR(31),          /* PTR TO SRB TO SCHEDULE TO
*                                         DISPATCH ISTAPC55          */
*        2  MPSSMRPH PTR(31),          /*  POINTER TO RPH TO REQUEST
*                                         STORAGE FOR SRB'S OR CRA'S */
*        2  MPSSMPAB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* SMS PAB TO
*                                         ALLOCATE SRB'S & CRA'S WITH*/
*        2  MPSTPPAB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* PAB TO  0280
*                                         SERIALIZE TPIOS REQUEST    */
*        2  MPSASCB PTR(31),           /* POINTER TO ASCB            */
*        2  MPSDBTBL PTR(31),          /* ANCHOR FOR OPEN VTAM DEB'S
*                                         IN THIS MEMORY             */
*        2  MPSQEL  PTR(31),           /* QUEUE OF AVAILABLE QUEUING
*                                         ELEMENTS                   */
*        2  MPSSYSRT PTR(31),          /* ADDRESS TO RETRN TO FROM SRB*
*        2  MPSMQLBP PTR(31),          /* ANCHOR FOR MQL BLOCK ALLOC  *
*        2  MPSSAVE CHAR(32) BDY(WORD), /* SAVE AREA TO USE UNDER  0280
*                                          PROTECTION OF LOCAL MEMORY
*                                          LOCK          @YL02HDM  */
*        2  MPSSRB1 CHAR(LENGTH(SRBSECT));/* SRB FOR DIRECT TPIO SCHED*
*DCL  MPSMPST CHAR(4) CONSTANT('MPST');       /* CHARACTER C.B. ID    *
*DCL  MPSGATE0 BIT(32) CONSTANT('7FFFFFFF'X); /* TURN MPST READY QUEUE
*                                                GATE OFF             *
*DCL  MPSGATE1 BIT(32) CONSTANT('80000000'X); /* TURN MPST READY QUEUE
*                                                GATE ON              *
*DCL  MPSPRBO0 BIT(32) CONSTANT('7FFFFFFF'X); /* TURN OFF MPSPRBO     *
*DCL  MPSPRBO1 BIT(32) CONSTANT('80000000'X); /* TURN ON MPSPRBO      *
*DCL  MPSCRBO0 BIT(32) CONSTANT('BFFFFFFF'X); /* TURN OFF MPSCRBO     *
*DCL  MPSCRBO1 BIT(32) CONSTANT('40000000'X); /* TURN ON MPSCRBO      *
*DCL  MPSTERM1 BIT(32) CONSTANT('10000000'X); /* TURN ON MPMEMTRM     *
*DCL  MPSMTRM0 BIT(32) CONSTANT('EFFFFFFF'X); /* TURN OFF MPMEMTRM    *
*DCL 1 ISTDCE BDY(WORD) BASED,    /* DEB TABLE ENTRY                 */
*     2  DCEDBPTR PTR(31),        /* DEB@                            */
*     2  DCECHN PTR(31),          /* NEXT DCE@                       */
*     2  DCETERM CHAR(4),         /* USE TO BUILD MQL AT TERMINATION
*                                    TIME                           */
*     2  DCERSV01 CHAR(4);        /* RESERVED                       */
*/* VTAM DATA EXTENT BLOCK                                         */
*/*                                                                */
*/*  INITIAL LEVEL                                     001 09/17/74  */
*/*                                                                */
*/* VTAM CONTROL BLOCK PREFIX                                      */
*/*                                                                */
*DECLARE                                                           0291
*  1 ISTACDEB BASED BDY(DWORD),                                    0291
*   2 ACDVTPRX BDY(WORD),     /* VTAM DEB PREFIX TO PREFIX SECTION */
*     3 ACDTYPE CHAR(1),      /* CONTROL BLOCK TYPE                */
*     3 ACDLNGTH FIXED(8),    /* CONTROL BLOCK LENGTH IN BYTES     */
*     3 ACDSAF CHAR(2),       /* FLAGS                             */
*     3 ACDCHN PTR(31),       /* CHAIN FIELD                       */
*     3 ACDTSKID PTR(31),     /* PST POINTER                       */
*     3 ACDRSV08 PTR(31),     /* RESERVED PRESERVE ALIGNMENT       */
*/*                                                                */
*/* VSAM DEB PREFIX                                                */
*/*                                                                */
*   2 ACDDBPFX BDY(DWORD),  /* VS1/2 DEB PREFIX SECTION            */
*      3 ACDDEBX  PTR(31),  /* DEB EXTENSION ADDRESS               */
*      3 ACDLENG  CHAR(1),  /* LENGTH FOR OS                       */
*      3 ACDAMTYP CHAR(1),  /* ACCESS METHOD TYPE FOR OS           */
*      3 ACDTBLOF FIXED(16),/* OFFSET IN DEB TABLE TO THE ENTRY FOR
*                              THIS DEB                            */
*        4 ACDRSV02 CHAR(1),/* RESERVED - IF NOT USED              */
*        4 ACDRSV03 CHAR(1),/* RESERVED - IF NOT USED              */
*/*                                                                */
*/* STANDARD DATA EXTENT BLOCK                                     */
*/*                                                                */
*    2  ACDBASIC BDY(DWORD), /* BASIC DEB SECTION                  */
*      3 ACDTCBAD CHAR(4),   /* ADDRESS OF TCB OWNING DEB          */
*        4 ACDNMSUB FIXED(8), /* NO. OF SUBRTNS LOADED BY          0291
*                               OPEN EXECUTOR                      */
*          5  ACDOPNAD CHAR(1), /* 1ST BYTE OF OPEN DEB            */
*        4 ACDTCB   PTR(24) BDY(BYTE),/* ADDRESS OF TCB OWNING THIS
*                               DEB                                */
*      3 ACDDEBAD CHAR(4),    /* ADDR OF ACDBASIC IN NEXT          0291
*                                DEB IN CHAIN OFF TCB              */
*        4 ACDAMLNG FIXED(8), /* NO. OF BYTES IN ACCESS METHOD     0291
*                                DEPENDENT SECTION OF DEB          */
*        4 ACDDEB   PTR(24) BDY(BYTE),/* ADDRESS OF ACDBASIC IN    0291
*                                DEB                               */
*      3 ACDIRBAD CHAR(4),    /* RESERVED TO MAINTAIN FIELD        0291
*                                POSITIONS IN BASIC SECTION        */
*      3 ACDOPATB CHAR(1),    /* RESERVED TO MAINTAIN FIELD        0291
*                                POSITIONS IN BASIC SECTION        */
*      3 ACDQSCNT CHAR(1),    /* RESERVED TO MAINTAIN FIELD        0291
*                                POSITIONS IN BASIC SECTION        */
*      3 ACDFLGS1 CHAR(1),    /* RESERVED TO MAINTAIN FIELD        0291
*                                POSTIONS IN BASIC SECTION         */
*      3 ACDPRLEN CHAR(1),    /* LENGTH OF VS1/2 PREFIX            */
*      3 ACDUSRPG CHAR(4),    /* ADDR OF FIRST IOB IN USER         0291
*                                PURGE CHAIN                       */
*        4 ACDNMEXT FIXED(8), /* NUMBER OF EXTENTS SPECIFIED       0291
*                                IN DSCBS                          */
*        4 ACDUSRPB PTR(24) BDY(BYTE), /* RESERVED TO MAINTAIN FIELD
*                                POSITIONS IN BASIC SECTION        */
*      3 ACDECBAD CHAR(4),    /* RESERVED TO MAINTAIN FIELD        0291
*                                POSITION IN BASIC SECTION         */
*      3 ACDACBAD CHAR(4),    /* ADDRESS OF ACB ASSOCIATED         0291
*                                WITH DEB                          */
*        4 ACDPROTG BIT(4),   /* TASK PROTECT KEY IN               */
*        4 ACDDEBID BIT(4),   /* A HEX F IN SECOND 4 BITS OF       0291
*                                ACDACBAD IDENTIFY BLOCK AS DEB    */
*        4 ACDACB   PTR(24) BDY(BYTE),  /* ADDRESS OF ACB ASSOCIATED
*                                WITH THIS DEB                     */
*      3 ACDAPPAD CHAR(4),    /* ADDR OF I/O APPND VECTOR TABLE    */
*        4 ACDEXSCL FIXED(8), /* EXTENT SCALE                      */
*        4 ACDAPP  PTR(24) BDY(BYTE), /* ADDR OF I/O APPND VECTOR  0291
*                                TABLE                             */
*/*                                                                */
*/* ACCESS METHOD DEPENDENT SECTION                                */
*/*                                                                */
*   2  ACDVTAM  BDY(DWORD),   /* VTAM DEB SECTION                  */
*    3 ACDLOCK  CHAR(LENGTH(ISTLOK)), /* DEBLOCK LOCK              */
*    3 ACDRDTE  PTR(31),      /* POINTER TO RDT ENTRY              */
*    3 ACDFMCB  PTR(31),      /* ADDR OF 1ST FMCB ON FMCB QUE OF   0291
*                                THIS DEB                          */
*    3 ACDRAFQ  PTR(31),      /* ADDR OF 1ST FMCB ON READANY FMCB QUE*/
*    3 ACDRARQ  PTR(31),      /* ADDR OF 1ST RPL ON READANY RPL QUE*/
*    3 ACDRSV20  CHAR(12),    /* RESERVED                          */
*    3 ACDNEPAB CHAR(LENGTH(ISTPAB)) BDY(DWORD),  /* PSS SOLICIT/READ
*                                ANY PAB                           */
*    3 ACDSSPAB CHAR(LENGTH(ISTPAB)) BDY(DWORD),  /* PSS SYSTEM    0291
*                                SERVICES PAB                      */
*    3 ACDRSV21 CHAR(LENGTH(ISTPAB)) BDY(DWORD),  /* RESERVED      */
*    3 ACDSSFLG CHAR(1),      /* SYSTEM SERVICE FLAGS              */
*       4 ACDCACB  BIT(1),    /* CLOSE ACB IN PROGRESS             */
*       4 ACDABEND BIT(1),    /* IF ABEND OR CANCEL IN PROGRESS,   */
*                             /* USED AS FLAG TO INDICATE THAT     */
*                             /* A DUMP MUST BE TAKEN              */
*       4 ACDAICLS BIT(1),    /* CLOSE ISSUED IN ISTRAAA1          */
*       4 ACDRSV09 BIT(5),    /* RESERVED                          */
*    3 ACDRSV06 CHAR(1),      /* RESERVED                          */
*    3 ACDRSV07 CHAR(1),      /* RESERVED                          */
*    3 ACDAPDAT BDY(BYTE),    /* APPLICATION - ID SECTION          */
*     4 ACDAPDLN FIXED(8),    /* LENGTH OF APPLICATION ID DATA     */
*     4  ACDAPDDT CHAR(8),    /* APPLICATION DATA                  */
*    3  ACDRSV10 PTR(31),     /* RESERVED                          */
*    3  ACDOCWAD PTR(31),     /* ADDR OF OCW FOR USE BY CLOSE ACB  */
*    3  ACDRSV22 PTR(31),     /* RESERVED                          */
*    3  ACDRSV23 PTR(31),     /* RESERVED                          */
*    3  ACDRSV24 PTR(31),     /* RESERVED FOR ALIGNMENT            */
*   2  ACDSIP CHAR(LENGTH(ISTPAB)) BDY(DWORD), /* SESSION CONTROL  0291
*                                                 INBOUND PAB      */
*   2  ACDSOP CHAR(LENGTH(ISTPAB)) BDY(DWORD), /* SESSION CONTROL  0291
*                                                 OUTBOUND PAB     */
*   2  ACDASFQ PTR(31),       /* ADDR 1ST FMCB ON DFASY ANY Q      */
*   2  ACDREFQ PTR(31);       /* ADDR 1ST FMCB ON RESP ANY Q       */
*DCL ACDID BIT(8) CONSTANT('0F'X); /* VTAM DATA EXTENT BLOCK ID    */
*/* ***** PROCESS SCHEDULING TABLE FOR VS/2       ****** */        0293
*/*  INITIAL LEVEL                                      001 04/09/75 */
*DCL  1  ISTPST BDY(DWORD) BASED,                                  0293
*        2  PSTTYPE  CHAR(1),          /* CONTROL BLOCK TYPE         */
*        2  PSTLNGTH PTR(8),           /* LENGTH IN BYTES            */
*        2  *        CHAR(2),          /* RESERVED                   */
*        2  PSTCHAIN PTR(31),          /* ADDRESS OF NEXT PST        */
*        2  PSTRQFGA CHAR(8) BDY(DWORD),  /* READY QUEUE AND FLAGS   */
*           3  PSTRQUE PTR(31),        /* READY QUEUE                */
*              4  PSTRQFLG BIT(1),     /* READY QUEUE GATE           */
*              4  PSTRSV01 BIT(1),     /* REVERVED                   */
*              4  PSTRSV02 BIT(1),     /* REVERVED                   */
*              4  PSTRSV03 BIT(1),     /* REVERVED                   */
*              4  PSTRSV04 BIT(1),     /* REVERVED                   */
*              4  PSTRSV05 BIT(1),     /* REVERVED                   */
*              4  PSTRSV06 BIT(1),     /* REVERVED                   */
*              4  PSTRSV07 BIT(1),     /* REVERVED                   */
*              4  PSTRQUEA PTR(24),    /* READY QUEUE                */
*           3  PSTFLGA PTR(32),        /* FLAG FIELD                 */
*              4  PSTSSRN BIT(1),      /* IRB RUNNING SYSTEM SERVICE
*                                         TYPE REQUESTS              */
*              4  PSTUERN BIT(1),      /* IRB RUNNING USER EXIT TYPE
*                                         REQUESTS                   */
*              4  PSTIRBU1 BIT(1),     /* IRB # 1 IN USE             */
*              4  PSTIRBU2 BIT(1),     /* IRB # 2 IN USE             */
*              4  PSTSMQR BIT(1),      /* SMS RPH QUEUED FOR STORAGE */
*              4  PSTSMCU BIT(1),      /* SMS CRA IN USE             */
*              4  PSTAUTH BIT(1),      /* THE TASK THIS PST IS OBTAINED
*                                         FOR IS AUTHORIZED          */
*              4  PSTABINP BIT(1),     /* ABEND IN PROGRESS ON THIS
*                                         TASK                       */
*                 5 PSTABEND BIT(1),   /* TASK ABEND IN PROGRESS     */
*              4  PSTDMPC BIT(1),      /* DUMP HAS BEEN REQUESTED    */
*              4  PSTRSV08 BIT(23),    /* RESERVED                   */
*        2  PSTTCBA PTR(31),           /* TCB POINTER                */
*        2  PSTMPSTP PTR(31),          /* MPST POINTER - PST 6TH WORD*/
*        2  PSTACBCT FIXED(31),        /* COUNT OF OPEN ACB'S USING
*                                         THIS PST                   */
*        2  PSTPSSQ PTR(31),           /* POSTED SYSTEM SERVICE QUEUE*/
*        2  PSTNSSQ PTR(31),           /* NORMAL SYSTEM SERVICE QUEUE*/
*        2  PSTUEQ  PTR(31),           /* USER EXIT QUEUE            */
*        2  PSTIQE11 PTR(31),          /* INACTIVE IQE FOR FIRST IRB */
*        2  PSTIQE12 PTR(31),          /* ACTIVE IQE FOR FIRST IRB   */
*        2  PSTIQE21 PTR(31),          /* INACTIVE IQE FOR 2ND IRB   */
*        2  PSTIQE22 PTR(31),          /* ACTIVE IQE FOR 2ND IRB     */
*        2  PSTCRR1 PTR(31),           /* PREALLOCATED CRA           */
*        2  PSTCRRS PTR(31),           /* SMS CRA                    */
*        2  PSTSMDYP CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* SMS PAB   */
*        2  PSTSAVE CHAR(32),          /* SAVE AREA                  */
*        2  PSTDEBP  PTR(31),          /* POINTER TO DEB CHAIN       */
*                                      /* WHEN TASK ABENDS           */
*        2  PSTDMPS  FIXED(31),        /* DUMMY MPST                 */
*           3 PSTDGATE BIT(1),         /* DUMMY MPST GATE BIT        */
*           3 *        BIT(7),         /* NOT TO BE USED             */
*           3 PSTDRDYQ PTR(24);        /* DUMMY MPST READY QUEUE     */
*DCL  PSTSSRN0 BIT(32) CONSTANT('7FFFFFFF'X); /* TURN PSTSSRN OFF    */
*DCL  PSTSSRN1 BIT(32) CONSTANT('80000000'X); /* TURN PSTSSRN ON     */
*DCL  PSTUERN0 BIT(32) CONSTANT('BFFFFFFF'X); /* TURN PSTUERN OFF    */
*DCL  PSTUERN1 BIT(32) CONSTANT('40000000'X); /* TURN PSTUERN ON     */
*DCL  PSTGATE0 BIT(32) CONSTANT('7FFFFFFF'X); /* TURN PST READY QUEUE
*                                                GATE OFF            */
*DCL  PSTGATE1 BIT(32) CONSTANT('80000000'X); /* TURN PST READY QUEUE
*                                                GATE ON             */
*DCL  PSTIRB10 BIT(32) CONSTANT('DFFFFFFF'X); /* TURN PSTIRBU1 OFF   */
*DCL  PSTIRB11 BIT(32) CONSTANT('20000000'X); /* TURN PSTIRBU1 ON    */
*DCL  PSTIRB20 BIT(32) CONSTANT('EFFFFFFF'X); /* TURN PSTIRBU2 OFF   */
*DCL  PSTIRB21 BIT(32) CONSTANT('10000000'X); /* TURN PSTIRBU2 ON    */
*DCL  PSTSMQR0 BIT(32) CONSTANT('F7FFFFFF'X); /* TURN PSTSMQR OFF    */
*DCL  PSTSMQR1 BIT(32) CONSTANT('08000000'X); /* TURN PSTSMQR ON     */
*DCL  PSTSMCU0 BIT(32) CONSTANT('FBFFFFFF'X); /* TURN PSTSMCU OFF    */
*DCL  PSTSMCU1 BIT(32) CONSTANT('04000000'X); /* TURN PSTSMCU ON     */
*DCL  PSTABIP1 BIT(32) CONSTANT('01000000'X); /* TURN PSTABINP ON    */
*DCL  PSTABIP0 BIT(32) CONSTANT('FEFFFFFF'X); /* TURN OFF PSTABINP   */
*DCL  PSTYPE   BIT(8) CONSTANT('61'X);        /* TYPE CODE FOR PST   */
*   GEN(PRINT ON);                                                 0311
*                                                                  0311
         PRINT ON
*/* END OF TPEPILOG                                                  */
*/* ATDSPLY   INVOKED.                                               */
*/********************************************************************/
*/* THE FOLLOWING ATBUILD INCLUSIONS HAVE BEEN MADE IN THIS          */
*/* COMPILATION:                                                     */
*/*             ISTAVT                                               */
*/*             ISTOCA                                               */
*/*             ISTPAB                                               */
*/*             ISTLOK                                               */
*/*             ISTDYPAB                                             */
*/*             ISTRPH                                               */
*/*             ISTATCVT                                             */
*/*             ISTOCSV                                              */
*/*             ISTMPST                                              */
*/*             ISTDCE                                               */
*/*             ISTACDEB                                             */
*/*             ISTPST                                               */
*/********************************************************************/
*/* END OF ATDSPLY.                                                  */
*                                                                  0312
*   END ISTOCCOA                                                   0312
*                                                                  0312
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSUT5  (DATADCLS)                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IKJTCB  )                                       */
*/*%INCLUDE SYSLIB  (IHARB   )                                       */
*/*%INCLUDE SYSLIB  (IKJRB   )                                       */
*/*%INCLUDE SYSLIB  (IHASRB  )                                       */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (IHAASCB )                                       */
*/*%INCLUDE SYSLIB  (IHAASXB )                                       */
*/*%INCLUDE SYSLIB  (IECDSECS)                                       */
*/*%INCLUDE SYSLIB  (IECDSECT)                                       */
*/*%INCLUDE SYSLIB  (IFGACB  )                                       */
*/*%INCLUDE SYSLIB  (IFGACBVT)                                       */
*/*%INCLUDE SYSUT5  (STARTOPN)                                       */
*/*%INCLUDE SYSUT5  (CMPLTOPN)                                       */
*                                                                  0312
*       ;                                                          0312
@EL00001 DS    0H                                                  0312
@EF00001 DS    0H                                                  0312
@ER00001 BR    @14                                                 0312
@DATA    DS    0H
@CH00056 DC    H'4'
@CH01788 DC    H'72'
@CH03054 DC    H'208'
@CH02835 DC    XL2'00000040'
@SX03057 XC    X0015(0,GPR04P),X0015(GPR04P)
@SX03059 XC    X0032(0,GPR04P),X0032(GPR04P)
@DATD    DSECT
         DS    0F
ISTOCCOA CSECT
         DS    0F
@DATD    DSECT
         DS    0D
CVTPTR   DS    A
TCBPTR   DS    A
RBSECPTR DS    A
SRBPTR   DS    A
ASCBPTR  DS    A
ASXBPTR  DS    A
RWTG     DS    A
ISTOCCOA CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
QNAME    DC    CL8'SYSZNCHT'
RNAME    DC    CL8'STOPOPEN'
@DATD    DSECT
C00007   EQU    0                      CONSTANT  0
ISTOCCOA CSECT
XCTL6V   XCTLTABL SVC=019,ID=(MOD2F6V,6V)
C00032   EQU    0                      CONSTANT  0
RESXCTL  EQU    4
RES      EQU    5
RET      EQU   14
@DATD    DSECT
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
ISTOCCOA CSECT
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
RCORE    EQU   @10
RPHPTR   EQU   @01
RWRK     EQU   @10
USERACB  EQU   @06
XFRERFLG EQU   @07
XFROFLGS EQU   @08
RCOPY    EQU   @09
RBASE    EQU   @12
RSAVE    EQU   @13
RRVAL    EQU   @15
GPR01P   EQU   @01
GPR02P   EQU   @02
GPR03P   EQU   @03
GPR04P   EQU   @04
GPR05P   EQU   @05
GPR06P   EQU   @06
GPR07P   EQU   @07
GPR08P   EQU   @08
GPR09P   EQU   @09
GPR10P   EQU   @10
GPR12P   EQU   @12
GPR14P   EQU   @14
GPR15F   EQU   @15
GPR15P   EQU   @15
GPR00F   EQU   @00
GPR00P   EQU   @00
GPR01F   EQU   @01
GPR02F   EQU   @02
GPR03F   EQU   @03
GPR04F   EQU   @04
GPR05F   EQU   @05
GPR06F   EQU   @06
GPR07F   EQU   @07
GPR08F   EQU   @08
GPR09F   EQU   @09
GPR10F   EQU   @10
GPR11F   EQU   @11
GPR11P   EQU   @11
GPR12F   EQU   @12
GPR13F   EQU   @13
GPR13P   EQU   @13
GPR14F   EQU   @14
KEYSVPTR EQU   @03
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSATOLD  EQU   PSA+540
PSAAOLD  EQU   PSA+548
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
ATCLCPTR EQU   1032
CMZOCVTP EQU   16
CMZUCVTP EQU   16
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTSHS   EQU   CVTXTNT2+40
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
TCBFIX   EQU   0
TCBFRS   EQU   TCBFIX
TCB      EQU   0
TCBRBP   EQU   TCB
TCBPIE   EQU   TCB+4
TCBPMASK EQU   TCBPIE
TCBCMP   EQU   TCB+16
TCBCMPF  EQU   TCBCMP
TCBCPP   EQU   TCBCMPF
TCBSTCC  EQU   TCBCMPF
TCBCDBL  EQU   TCBCMPF
TCBCWTO  EQU   TCBCMPF
TCBCIND  EQU   TCBCMPF
TCBCMSG  EQU   TCBCMPF
TCBTRN   EQU   TCB+20
TCBABF   EQU   TCBTRN
TCBMSS   EQU   TCB+24
TCBPKF   EQU   TCB+28
TCBFLGS  EQU   TCB+29
TCBFLGS1 EQU   TCBFLGS
TCBFLGS2 EQU   TCBFLGS+1
TCBFLGS3 EQU   TCBFLGS+2
TCBFLGS4 EQU   TCBFLGS+3
TCBFLGS5 EQU   TCBFLGS+4
TCBABWF  EQU   TCBFLGS5
TCBFTJST EQU   TCB+44
TCBPURGE EQU   TCBFTJST
TCBGRS   EQU   TCB+48
TCBFSA   EQU   TCB+112
TCBTME   EQU   TCB+120
TCBPIB   EQU   TCB+124
TCBPIBT  EQU   TCBPIB
TCBTSFLG EQU   TCB+148
TCBTSTSK EQU   TCBTSFLG
TCBFTFLG EQU   TCB+153
TCBFTFL1 EQU   TCBFTFLG
TCBFTFL2 EQU   TCBFTFLG+1
TCBFTFL3 EQU   TCBFTFLG+2
TCBSTAB  EQU   TCB+160
TCBNSTAE EQU   TCBSTAB
TCBTCT   EQU   TCB+164
TCBTCTGF EQU   TCBTCT
TCBSCNDY EQU   TCB+172
TCBNDSP  EQU   TCBSCNDY
TCBNDSP1 EQU   TCBNDSP+1
TCBNDSP2 EQU   TCBNDSP+2
TCBNDSP3 EQU   TCBNDSP+3
TCBJSCB  EQU   TCB+180
TCBRECDE EQU   TCBJSCB
TCBEXT1  EQU   TCB+196
TCBBITS  EQU   TCB+200
TCBNDSP4 EQU   TCBBITS
TCBNDSP5 EQU   TCBBITS+1
TCBFLGS6 EQU   TCBBITS+2
TCBFLGS7 EQU   TCBBITS+3
TCBDAR   EQU   TCB+204
TCBDARC  EQU   TCBDAR
TCBEXT2  EQU   TCB+208
TCBARB   EQU   TCB+220
TCBTTQE  EQU   TCB+224
TCBXTNT2 EQU   0
TCBGTF   EQU   TCBXTNT2
TCBTFLG  EQU   TCBGTF
RBPRFX   EQU   0
RBBASIC  EQU   0
RBEXRTNM EQU   RBBASIC
RBTMFLD  EQU   RBEXRTNM
RBSTAB   EQU   RBBASIC+10
XSTAB    EQU   RBSTAB
RBSTAB1  EQU   XSTAB
XSTAB1   EQU   RBSTAB1
RBFTCKPT EQU   XSTAB1
RBSTAB2  EQU   XSTAB+1
XSTAB2   EQU   RBSTAB2
RBTCBNXT EQU   XSTAB2
RBFACTV  EQU   XSTAB2
RBFDYN   EQU   XSTAB2
RBECBWT  EQU   XSTAB2
RBOPSW   EQU   RBBASIC+16
XRBPSW   EQU   RBOPSW
RBOPSWB2 EQU   XRBPSW+1
RBLINK   EQU   RBBASIC+28
XRBLNK   EQU   RBLINK
RBWCF    EQU   XRBLNK
RBLINKB  EQU   XRBLNK+1
RBGRSAVE EQU   RBBASIC+32
XRBREG   EQU   RBGRSAVE
RBGRS0   EQU   XRBREG
RBGRS1   EQU   XRBREG+4
RBGRS2   EQU   XRBREG+8
RBGRS3   EQU   XRBREG+12
RBGRS4   EQU   XRBREG+16
RBGRS5   EQU   XRBREG+20
RBGRS6   EQU   XRBREG+24
RBGRS7   EQU   XRBREG+28
RBGRS8   EQU   XRBREG+32
RBGRS9   EQU   XRBREG+36
RBGRS10  EQU   XRBREG+40
RBGRS11  EQU   XRBREG+44
RBGRS12  EQU   XRBREG+48
RBGRS13  EQU   XRBREG+52
RBGRS14  EQU   XRBREG+56
RBGRS15  EQU   XRBREG+60
XRBESA   EQU   RBBASIC+96
RBPREFIX EQU   0
RBRSV019 EQU   RBPREFIX+14
RBRSV028 EQU   RBPREFIX+15
RBRSV041 EQU   RBPREFIX+27
RBRSV054 EQU   RBPREFIX+39
RBRTOPSW EQU   RBPREFIX+40
RBRTPSW2 EQU   RBRTOPSW+8
RBRTICIL EQU   RBRTPSW2
RBFLAGS1 EQU   RBPREFIX+56
RBINTCDA EQU   RBPREFIX+61
RBSECT   EQU   0
RBPPSAV  EQU   RBSECT
@NM00018 EQU   RBSECT+10
@NM00019 EQU   @NM00018
RBTRSVRB EQU   @NM00019
@NM00021 EQU   @NM00018+1
RBETXR   EQU   @NM00021
RBEP     EQU   RBSECT+12
RBPGMQ   EQU   RBSECT+24
@NM00028 EQU   RBSECT+28
IRBEND   EQU   RBSECT+96
@NM00032 EQU   RBSECT+96
RBRSV138 EQU   @NM00032+7
RBRSV150 EQU   RBSECT+167
SRBSECT  EQU   0
SRBFLC   EQU   SRBSECT+12
ASCB     EQU   0
ASCBFW1  EQU   ASCB+100
ASCBRCTF EQU   ASCBFW1+2
ASCBFLG1 EQU   ASCBFW1+3
ASCBASXB EQU   ASCB+108
ASCBDSP1 EQU   ASCB+114
ASCBFLG2 EQU   ASCB+115
ASXB     EQU   0
ASXBMPST EQU   ASXB+16
ASXBAEQ  EQU   ASXB+168
ASXBSECR EQU   ASXB+199
ASXBSFLG EQU   ASXBSECR
IECPREFX EQU   0
IECEXTPR EQU   IECPREFX+32
IECUPRML EQU   IECEXTPR+80
IECRESWA EQU   IECEXTPR+84
RWARESWA EQU   0
RWAPREFX EQU   RWARESWA
USERPRML EQU   0
IECRRPL  EQU   0
RRPLIST  EQU   IECRRPL
RRFUNCTN EQU   RRPLIST
RRFLAGS1 EQU   RRPLIST+1
RRFLAGS2 EQU   RRPLIST+2
RRFLAGS3 EQU   RRPLIST+3
RRXRETRY EQU   RRPLIST+12
DSMADTRL EQU   0
DSMADTW1 EQU   DSMADTRL
DSMADTB1 EQU   DSMADTW1
DSMADTB2 EQU   DSMADTW1+1
WTGTABLE EQU   0
WTGWTOPR EQU   WTGTABLE
WTG      EQU   0
WTGAREA  EQU   WTG
WTGMODNM EQU   WTGAREA
WTGPREFX EQU   WTGAREA+16
WTGPATHS EQU   WTG+30
WTGENTRY EQU   0
WTGIDTTR EQU   WTGENTRY
APPNMTBL EQU   0
APPENTRY EQU   APPNMTBL+4
FORCORE  EQU   0
DXDSCB   EQU   FORCORE
DXDCB    EQU   FORCORE+320
DXCCW    EQU   FORCORE+368
DXCCW5   EQU   DXCCW+32
DXCCW8   EQU   DXCCW+56
DXCCW12  EQU   DXCCW+88
DXXCTL   EQU   FORCORE+472
DXVOLSR  EQU   FORCORE+500
DXVOLSR1 EQU   DXVOLSR
DXVOLSR2 EQU   DXVOLSR+6
DXVOLSR3 EQU   DXVOLSR+12
DXRESSW  EQU   FORCORE+524
DXUKEY   EQU   FORCORE+526
DXDEBXAD EQU   FORCORE+552
DXUCBSAV EQU   FORCORE+564
DXUDCBAD EQU   FORCORE+568
DXPDCBAD EQU   FORCORE+572
DXUDCBPL EQU   FORCORE+576
DXUDCBML EQU   FORCORE+578
DXATCOM1 EQU   FORCORE+588
DXATGENS EQU   DXATCOM1
DXATVGIV EQU   DXATGENS
DXATOUTA EQU   DXATCOM1+2
DXATDACC EQU   DXATCOM1+3
DXATCOM2 EQU   FORCORE+592
DXATEOV  EQU   DXATCOM2
DXATOPEN EQU   DXATCOM2+1
DXATALL  EQU   DXATCOM2+2
DXATEXC1 EQU   FORCORE+604
DXATEXC2 EQU   FORCORE+608
DSECTSIZ EQU   FORCORE+612
IFGACB   EQU   0
ACBCOMN  EQU   IFGACB
ACBLENG  EQU   ACBCOMN+2
ACBLENG2 EQU   ACBLENG
ACBAMBL  EQU   ACBCOMN+4
ACBJWA   EQU   ACBAMBL
ACBMACRF EQU   ACBCOMN+12
ACBMACR1 EQU   ACBMACRF
ACBADR   EQU   ACBMACR1
ACBCNV   EQU   ACBMACR1
ACBMACR2 EQU   ACBMACRF+1
ACBBUFPL EQU   ACBCOMN+20
ACBMACR3 EQU   ACBBUFPL
ACBRECFM EQU   ACBCOMN+24
ACBCCTYP EQU   ACBCOMN+25
ACBOPT   EQU   ACBCOMN+26
ACBDSORG EQU   ACBOPT
ACBCROPS EQU   ACBDSORG
ACBDVIND EQU   ACBDSORG
ACBEXLST EQU   ACBCOMN+36
ACBDDNM  EQU   ACBCOMN+40
ACBAMETH EQU   ACBDDNM+3
ACBOFLGS EQU   ACBCOMN+48
ACBEXFG  EQU   ACBOFLGS
ACBIOSFG EQU   ACBOFLGS
ACBBUSY  EQU   ACBIOSFG
ACBERFLG EQU   ACBCOMN+49
ACBINFLG EQU   ACBCOMN+50
ACBVVIC  EQU   ACBINFLG
ACBUJFCB EQU   ACBCOMN+52
ACBBLKSZ EQU   ACBCOMN+60
ACBVTEXT EQU   IFGACB+76
ISTAVT   EQU   0
ISTAS49  EQU   ISTAVT+4
ISTOCA   EQU   0
OCAPART1 EQU   ISTOCA
OCAID    EQU   OCAPART1
OCAFLAGS EQU   OCAPART1+1
OCALNTH  EQU   OCAPART1+2
OCAOCXAD EQU   OCAPART1+4
OCAAPYAD EQU   OCAPART1+8
OCASAVES EQU   ISTOCA+36
OCASAV1  EQU   OCASAVES
OCASAV2  EQU   OCASAVES+28
OCASAV3  EQU   ISTOCA+136
ISTPAB   EQU   0
PABWQCHN EQU   ISTPAB
PABWEQA  EQU   PABWQCHN
PABCHAIN EQU   PABWQCHN+4
PABRPHFG EQU   ISTPAB+12
PABFLAGS EQU   PABRPHFG
PABERLCK EQU   PABFLAGS
PABERRLK EQU   PABERLCK
ISTLOK   EQU   0
LOKCHN   EQU   ISTLOK+1
LOKCHNG  EQU   LOKCHN
@NM00104 EQU   LOKCHNG+2
ISTDYPAB EQU   0
ISTRPH   EQU   0
RPHFLAGS EQU   ISTRPH+2
RPHAPTYP EQU   RPHFLAGS
RPHFSTLC EQU   RPHFLAGS
RPHFLGB  EQU   ISTRPH+3
RPHRPHA  EQU   ISTRPH+4
RPHTSKID EQU   ISTRPH+8
RPHRESMA EQU   ISTRPH+16
RPHWPFLG EQU   RPHRESMA
RPHWEA   EQU   ISTRPH+24
RPHCSPA  EQU   RPHWEA
RPHSRPRM EQU   ISTRPH+28
RPHPABQA EQU   ISTRPH+36
RPHWORK  EQU   ISTRPH+40
RPHSAVE1 EQU   RPHWORK
RPHSBITS EQU   RPHSAVE1+1
ISTATCVT EQU   0
ATCCOM   EQU   ISTATCVT
ATCSTAT  EQU   ATCCOM
ATCSTAT1 EQU   ATCSTAT
ATCACTIV EQU   ATCSTAT1
ATCSNHLT EQU   ATCSTAT1
ATCQKHLT EQU   ATCSTAT1
ATCSTFLG EQU   ATCSTAT+1
ATCPOFLG EQU   ATCSTAT+2
ATCSTAT4 EQU   ATCSTAT+3
ATCIOTRC EQU   ATCCOM+140
ATCTHTRC EQU   ATCIOTRC
ATCCSMR  EQU   ISTATCVT+296
ATCSHRFG EQU   ISTATCVT+316
ATCHPGM  EQU   ISTATCVT+384
ATCOCCOB EQU   ISTATCVT+584
ATCVLCNT EQU   ISTATCVT+772
ATCRNO   EQU   ISTATCVT+788
ATCSOPD  EQU   ISTATCVT+792
ATCSIPD  EQU   ISTATCVT+800
ATCSECST EQU   ISTATCVT+812
ATCAOSM  EQU   ISTATCVT+912
ATCGSRBQ EQU   ATCAOSM+4
ATCGSRBG EQU   ATCGSRBQ
ATCICAPP EQU   ATCAOSM+100
ATCLDAPP EQU   ATCAOSM+120
ATCDAPVT EQU   ATCAOSM+140
ATCVTFLG EQU   ATCAOSM+392
ATCASCB  EQU   ATCAOSM+564
ATCZFLAG EQU   ATCAOSM+588
ISTOCCOB EQU   0
ISTOCSV  EQU   0
ISTMPST  EQU   0
MPSRQUE  EQU   ISTMPST+8
MPSFLGA  EQU   ISTMPST+12
MPSCRA   EQU   ISTMPST+24
MPSCRACT EQU   MPSCRA+4
MPSSRB   EQU   ISTMPST+32
MPSSRBCT EQU   MPSSRB+4
MPSCRPL  EQU   ISTMPST+40
MPSRPLCT EQU   MPSCRPL+4
MPSDBTBL EQU   ISTMPST+124
ISTDCE   EQU   0
DCEDBPTR EQU   ISTDCE
ISTACDEB EQU   0
ACDVTPRX EQU   ISTACDEB
ACDTSKID EQU   ACDVTPRX+8
ACDDBPFX EQU   ISTACDEB+16
ACDTBLOF EQU   ACDDBPFX+6
ACDBASIC EQU   ISTACDEB+24
ACDTCBAD EQU   ACDBASIC
ACDNMSUB EQU   ACDTCBAD
ACDDEBAD EQU   ACDBASIC+4
ACDUSRPG EQU   ACDBASIC+16
ACDACBAD EQU   ACDBASIC+24
ACDAPPAD EQU   ACDBASIC+28
ACDVTAM  EQU   ISTACDEB+56
ACDSSFLG EQU   ACDVTAM+80
ACDAPDAT EQU   ACDVTAM+83
ISTPST   EQU   0
PSTRQFGA EQU   ISTPST+8
PSTRQUE  EQU   PSTRQFGA
PSTFLGA  EQU   PSTRQFGA+4
PSTABINP EQU   PSTFLGA
PSTDMPS  EQU   ISTPST+132
ISTACB   EQU   0
SAVEKEY  EQU   0
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
RBSECS03 EQU   RBEP
RBCDE    EQU   RBSECS03
RBCDFLGS EQU   RBCDE
RBSECS05 EQU   RBPGMQ
RBSQE    EQU   RBSECS05
RBSECS06 EQU   RBPGMQ
RBIQE    EQU   RBSECS06
RBSECS07 EQU   RBPGMQ
RBIQE2   EQU   RBSECS07
RBSECS08 EQU   IRBEND
RBSECS09 EQU   IRBEND
PSARSVTE EQU   PSARSVT
DXXWTG   EQU   DSECTSIZ
DXXAREA  EQU   DSECTSIZ+4
DXXMODNM EQU   DXXAREA
DXXLNG   EQU   DXXAREA+29
DXXENTRY EQU   DXXAREA+32
DXXIDTTR EQU   DXXENTRY
DXXEND   EQU   DXXAREA+48
DXREGSAV EQU   DXCCW8
DXREG1   EQU   DXREGSAV+28
DXIDENT  EQU   DXCCW12
DXRETMOD EQU   DXIDENT+2
@NM00077 EQU   DXXCTL
DXSAVMOD EQU   @NM00077+2
@NM00078 EQU   DXRESSW
OCAFLDA  EQU   DXUKEY
OCAFLDB  EQU   DXXEND
OCAACBAD EQU   DXUDCBAD
COPYACB  EQU   OCAAPYAD
X0015    EQU   ISTOCA
X0032    EQU   ISTOCA
DXBTAMX  EQU   DXREG1
DXDSNAME EQU   DXCCW5
FLC      EQU   PSA
OCAACBLN EQU   DXUDCBPL
OCAACBML EQU   DXUDCBML
OCADEBXA EQU   DXDEBXAD
SRB      EQU   SRBSECT
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
OCAEND   EQU   OCAFLDB
OCAUKEY  EQU   OCAFLDA
@NM00102 EQU   OCAFLDA
DXRESIND EQU   @NM00078
DXSAVOFF EQU   @NM00077+7
DXSAVADR EQU   DXSAVMOD+2
DXSAVID  EQU   DXSAVMOD
DXABCODE EQU   @NM00077
DXRETCOD EQU   DXIDENT+7
DXRETTTR EQU   DXRETMOD+2
DXRETID  EQU   DXRETMOD
DXCALLID EQU   DXIDENT
DXREG0   EQU   DXREGSAV+24
DXREGE   EQU   DXREGSAV+20
DXREGD   EQU   DXREGSAV+16
DXREGC   EQU   DXREGSAV+12
DXREGB   EQU   DXREGSAV+8
DXREGA   EQU   DXREGSAV+4
DXREG9   EQU   DXREGSAV
DXXLAST  EQU   DXXAREA+40
DXXCORE  EQU   DXXENTRY+5
DXETTR   EQU   DXXIDTTR+2
DXEID    EQU   DXXIDTTR
DXXPATHS EQU   DXXAREA+30
DXOPCLSW EQU   DXXLNG
DXXTXTLN EQU   DXXAREA+27
DXXMODSZ EQU   DXXAREA+24
DXXATTRB EQU   DXXAREA+22
@NM00062 EQU   DXXAREA+20
DXXPREFX EQU   DXXAREA+16
@NM00061 EQU   DXXAREA+12
DXXMODEP EQU   DXXAREA+8
DXXMODID EQU   DXXMODNM+6
@NM00060 EQU   DXXMODNM
DXXWTOPR EQU   DXXWTG
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
RBRSV161 EQU   RBSECS09+64
RBSIRBWA EQU   RBSECS09
RBIQEWRK EQU   RBSECS08+4
RBNEXAV  EQU   RBSECS08
RBIQEA   EQU   RBIQE2
RBIQE1   EQU   RBIQE+1
RBUSE    EQU   RBIQE
RBSQEA   EQU   RBSQE+1
@NM00033 EQU   RBSQE
RBCDE1   EQU   RBCDE+1
RBCDLOAD EQU   RBCDFLGS
RBCDXCTL EQU   RBCDFLGS
RBCDSYNC EQU   RBCDFLGS
RBCDNODE EQU   RBCDFLGS
RBRSV010 EQU   RBCDFLGS
RBCDATCH EQU   RBCDFLGS
RBRSV009 EQU   RBCDFLGS
RBNOCELL EQU   RBCDFLGS
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTRV620 EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTIRM   EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRAC   EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
PSTDRDYQ EQU   PSTDMPS+1
@NM00115 EQU   PSTDMPS
PSTDGATE EQU   PSTDMPS
PSTDEBP  EQU   ISTPST+128
PSTSAVE  EQU   ISTPST+96
PSTSMDYP EQU   ISTPST+64
PSTCRRS  EQU   ISTPST+60
PSTCRR1  EQU   ISTPST+56
PSTIQE22 EQU   ISTPST+52
PSTIQE21 EQU   ISTPST+48
PSTIQE12 EQU   ISTPST+44
PSTIQE11 EQU   ISTPST+40
PSTUEQ   EQU   ISTPST+36
PSTNSSQ  EQU   ISTPST+32
PSTPSSQ  EQU   ISTPST+28
PSTACBCT EQU   ISTPST+24
PSTMPSTP EQU   ISTPST+20
PSTTCBA  EQU   ISTPST+16
PSTRSV08 EQU   PSTFLGA+1
PSTDMPC  EQU   PSTFLGA+1
PSTABEND EQU   PSTABINP
PSTAUTH  EQU   PSTFLGA
PSTSMCU  EQU   PSTFLGA
PSTSMQR  EQU   PSTFLGA
PSTIRBU2 EQU   PSTFLGA
PSTIRBU1 EQU   PSTFLGA
PSTUERN  EQU   PSTFLGA
PSTSSRN  EQU   PSTFLGA
PSTRQUEA EQU   PSTRQUE+1
PSTRSV07 EQU   PSTRQUE
PSTRSV06 EQU   PSTRQUE
PSTRSV05 EQU   PSTRQUE
PSTRSV04 EQU   PSTRQUE
PSTRSV03 EQU   PSTRQUE
PSTRSV02 EQU   PSTRQUE
PSTRSV01 EQU   PSTRQUE
PSTRQFLG EQU   PSTRQUE
PSTCHAIN EQU   ISTPST+4
@NM00114 EQU   ISTPST+2
PSTLNGTH EQU   ISTPST+1
PSTTYPE  EQU   ISTPST
ACDREFQ  EQU   ISTACDEB+204
ACDASFQ  EQU   ISTACDEB+200
ACDSOP   EQU   ISTACDEB+184
ACDSIP   EQU   ISTACDEB+168
ACDRSV24 EQU   ACDVTAM+108
ACDRSV23 EQU   ACDVTAM+104
ACDRSV22 EQU   ACDVTAM+100
ACDOCWAD EQU   ACDVTAM+96
ACDRSV10 EQU   ACDVTAM+92
ACDAPDDT EQU   ACDAPDAT+1
ACDAPDLN EQU   ACDAPDAT
ACDRSV07 EQU   ACDVTAM+82
ACDRSV06 EQU   ACDVTAM+81
ACDRSV09 EQU   ACDSSFLG
ACDAICLS EQU   ACDSSFLG
ACDABEND EQU   ACDSSFLG
ACDCACB  EQU   ACDSSFLG
ACDRSV21 EQU   ACDVTAM+64
ACDSSPAB EQU   ACDVTAM+48
ACDNEPAB EQU   ACDVTAM+32
ACDRSV20 EQU   ACDVTAM+20
ACDRARQ  EQU   ACDVTAM+16
ACDRAFQ  EQU   ACDVTAM+12
ACDFMCB  EQU   ACDVTAM+8
ACDRDTE  EQU   ACDVTAM+4
ACDLOCK  EQU   ACDVTAM
ACDAPP   EQU   ACDAPPAD+1
ACDEXSCL EQU   ACDAPPAD
ACDACB   EQU   ACDACBAD+1
ACDDEBID EQU   ACDACBAD
ACDPROTG EQU   ACDACBAD
ACDECBAD EQU   ACDBASIC+20
ACDUSRPB EQU   ACDUSRPG+1
ACDNMEXT EQU   ACDUSRPG
ACDPRLEN EQU   ACDBASIC+15
ACDFLGS1 EQU   ACDBASIC+14
ACDQSCNT EQU   ACDBASIC+13
ACDOPATB EQU   ACDBASIC+12
ACDIRBAD EQU   ACDBASIC+8
ACDDEB   EQU   ACDDEBAD+1
ACDAMLNG EQU   ACDDEBAD
ACDTCB   EQU   ACDTCBAD+1
ACDOPNAD EQU   ACDNMSUB
ACDRSV03 EQU   ACDTBLOF+1
ACDRSV02 EQU   ACDTBLOF
ACDAMTYP EQU   ACDDBPFX+5
ACDLENG  EQU   ACDDBPFX+4
ACDDEBX  EQU   ACDDBPFX
ACDRSV08 EQU   ACDVTPRX+12
ACDCHN   EQU   ACDVTPRX+4
ACDSAF   EQU   ACDVTPRX+2
ACDLNGTH EQU   ACDVTPRX+1
ACDTYPE  EQU   ACDVTPRX
DCERSV01 EQU   ISTDCE+12
DCETERM  EQU   ISTDCE+8
DCECHN   EQU   ISTDCE+4
MPSSRB1  EQU   ISTMPST+172
MPSSAVE  EQU   ISTMPST+140
MPSMQLBP EQU   ISTMPST+136
MPSSYSRT EQU   ISTMPST+132
MPSQEL   EQU   ISTMPST+128
MPSASCB  EQU   ISTMPST+120
MPSTPPAB EQU   ISTMPST+88
MPSSMPAB EQU   ISTMPST+56
MPSSMRPH EQU   ISTMPST+52
MPSSRB55 EQU   ISTMPST+48
MPSRPLAC EQU   MPSRPLCT+2
MPSRPLRC EQU   MPSRPLCT
MPSCRPLQ EQU   MPSCRPL
MPSSRBAC EQU   MPSSRBCT+2
MPSSRBRC EQU   MPSSRBCT
MPSSRBQ  EQU   MPSSRB
MPSCRAAC EQU   MPSCRACT+2
MPSCRARC EQU   MPSCRACT
MPSCRAQ  EQU   MPSCRA
MPSMPSTP EQU   ISTMPST+20
MPSPSTCT EQU   ISTMPST+16
MPSASID  EQU   MPSFLGA+2
MPSRSV02 EQU   MPSFLGA+1
MPSPSTAB EQU   MPSFLGA
MPSRSV01 EQU   MPSFLGA
MPSTPBU  EQU   MPSFLGA
MPMEMTRM EQU   MPSFLGA
MPSAUTH  EQU   MPSFLGA
MPSCRAO  EQU   MPSFLGA
MPSSRBO  EQU   MPSFLGA
MPSRQUEG EQU   MPSRQUE
MPSRSV07 EQU   ISTMPST+4
MPSID    EQU   ISTMPST
OCSR12   EQU   ISTOCSV+68
OCSR11   EQU   ISTOCSV+64
OCSR10   EQU   ISTOCSV+60
OCSR9    EQU   ISTOCSV+56
OCSR8    EQU   ISTOCSV+52
OCSR7    EQU   ISTOCSV+48
OCSR6    EQU   ISTOCSV+44
OCSR5    EQU   ISTOCSV+40
OCSR4    EQU   ISTOCSV+36
OCSR3    EQU   ISTOCSV+32
OCSR2    EQU   ISTOCSV+28
OCSR1    EQU   ISTOCSV+24
OCSR0    EQU   ISTOCSV+20
OCSR15   EQU   ISTOCSV+16
OCSR14   EQU   ISTOCSV+12
OCSFWD   EQU   ISTOCSV+8
OCSBACK  EQU   ISTOCSV+4
OCSRSV01 EQU   ISTOCSV
ATCAOS   EQU   ISTATCVT+1584
ATCPOPAB EQU   ATCAOSM+640
ATCVIOPM EQU   ATCAOSM+636
ATCTPMMI EQU   ATCAOSM+632
ATCTPMPB EQU   ATCAOSM+600
ATCRPLCT EQU   ATCAOSM+594
ATCCRACT EQU   ATCAOSM+592
ATCSRBCT EQU   ATCAOSM+590
ATCRSV75 EQU   ATCAOSM+589
ATCRSV66 EQU   ATCZFLAG
ATCZF001 EQU   ATCZFLAG
ATCTPCP1 EQU   ATCAOSM+584
ATCTPCP0 EQU   ATCAOSM+580
ATCAICTN EQU   ATCAOSM+576
ATCZR01  EQU   ATCAOSM+572
ATCMPLTA EQU   ATCAOSM+568
ATCAP86  EQU   ATCAOSM+560
ATCAP85  EQU   ATCAOSM+556
ATCAP84  EQU   ATCAOSM+552
ATCAP83  EQU   ATCAOSM+548
ATCAP82  EQU   ATCAOSM+544
ATCAP69  EQU   ATCAOSM+540
ATCAP66  EQU   ATCAOSM+536
ATCAP62  EQU   ATCAOSM+532
ATCAPC59 EQU   ATCAOSM+528
ATCAP56  EQU   ATCAOSM+524
ATCAP55  EQU   ATCAOSM+520
ATCRCFY0 EQU   ATCAOSM+516
ATCAP41  EQU   ATCAOSM+512
ATCAPC25 EQU   ATCAOSM+508
ATCAP23  EQU   ATCAOSM+504
ATCTPSPB EQU   ATCAOSM+472
ATCTRMPB EQU   ATCAOSM+440
ATCPSTA  EQU   ATCAOSM+432
ATCSMABF EQU   ATCAOSM+428
ATCSMAPR EQU   ATCAOSM+424
ATCTPWQA EQU   ATCAOSM+420
ATCSMAID EQU   ATCAOSM+416
ATCSMARA EQU   ATCAOSM+412
ATCCACXA EQU   ATCAOSM+408
ATCZLAAB EQU   ATCAOSM+404
ATCATA10 EQU   ATCAOSM+400
ATCHLTCB EQU   ATCAOSM+396
@NM00113 EQU   ATCVTFLG
ATCVTACT EQU   ATCVTFLG
ATCRPT40 EQU   ATCAOSM+388
ATCRPT39 EQU   ATCAOSM+384
ATCRPT38 EQU   ATCAOSM+380
ATCRPT37 EQU   ATCAOSM+376
ATCRPT36 EQU   ATCAOSM+372
ATCRPT35 EQU   ATCAOSM+368
ATCRPT34 EQU   ATCAOSM+364
ATCRPT33 EQU   ATCAOSM+360
ATCRPT32 EQU   ATCAOSM+356
ATCRPT31 EQU   ATCAOSM+352
ATCRPT30 EQU   ATCAOSM+348
ATCRPT29 EQU   ATCAOSM+344
ATCRPT28 EQU   ATCAOSM+340
ATCRPT27 EQU   ATCAOSM+336
ATCRPT26 EQU   ATCAOSM+332
ATCRPT25 EQU   ATCAOSM+328
ATCRPT24 EQU   ATCAOSM+324
ATCRPT23 EQU   ATCAOSM+320
ATCRPT22 EQU   ATCAOSM+316
ATCRPT21 EQU   ATCAOSM+312
ATCRPT20 EQU   ATCAOSM+308
ATCRPT19 EQU   ATCAOSM+304
ATCRPT18 EQU   ATCAOSM+300
ATCRPT17 EQU   ATCAOSM+296
ATCRPT16 EQU   ATCAOSM+292
ATCRPT15 EQU   ATCAOSM+288
ATCRPT14 EQU   ATCAOSM+284
ATCRPT13 EQU   ATCAOSM+280
ATCRPT12 EQU   ATCAOSM+276
ATCRPT11 EQU   ATCAOSM+272
ATCAP38  EQU   ATCAOSM+268
ATCAP37  EQU   ATCAOSM+264
ATCZDFJ0 EQU   ATCAOSM+260
ATCAP51  EQU   ATCAOSM+256
ATCZPAB2 EQU   ATCAOSM+224
ATCZPAB1 EQU   ATCAOSM+192
ATCZLFVT EQU   ATCAOSM+188
ATCZLPVT EQU   ATCAOSM+184
ATCZDVTX EQU   ATCAOSM+180
ATCZDVTA EQU   ATCAOSM+176
ATCZDVT9 EQU   ATCAOSM+172
ATCZDVT8 EQU   ATCAOSM+168
ATCZDVT7 EQU   ATCAOSM+164
ATCRSV56 EQU   ATCDAPVT+22
ATCDAPDG EQU   ATCDAPVT+20
ATCDXCEA EQU   ATCDAPVT+16
ATCDCEA  EQU   ATCDAPVT+12
ATCDPCIA EQU   ATCDAPVT+8
ATCDSIOA EQU   ATCDAPVT+4
ATCDEOEA EQU   ATCDAPVT
ATCZLAEA EQU   ATCLDAPP+16
ATCZLCEA EQU   ATCLDAPP+12
ATCRSV17 EQU   ATCLDAPP+8
ATCSMFRR EQU   ATCLDAPP+4
ATCCDTID EQU   ATCLDAPP
ATCZAEA  EQU   ATCICAPP+16
ATCZCEA  EQU   ATCICAPP+12
ATCCDTCB EQU   ATCICAPP+8
ATCZSIOA EQU   ATCICAPP+4
ATCCDRPH EQU   ATCICAPP
ATCAP65  EQU   ATCAOSM+96
ATCZDVT6 EQU   ATCAOSM+92
ATCZDVT4 EQU   ATCAOSM+88
ATCZDVT3 EQU   ATCAOSM+84
ATCZDVT1 EQU   ATCAOSM+80
ATCICNCB EQU   ATCAOSM+76
ATCZPSVT EQU   ATCAOSM+72
ATCZFSVT EQU   ATCAOSM+68
ATCAP64  EQU   ATCAOSM+64
ATCAP63  EQU   ATCAOSM+60
ATCAP61  EQU   ATCAOSM+56
ATCAP58  EQU   ATCAOSM+52
ATCAP57  EQU   ATCAOSM+48
ATCAP54  EQU   ATCAOSM+44
ATCAP53  EQU   ATCAOSM+40
ATCAP52  EQU   ATCAOSM+36
ATCAP34  EQU   ATCAOSM+32
ATCAP32  EQU   ATCAOSM+28
ATCAP31  EQU   ATCAOSM+24
ATCAP12  EQU   ATCAOSM+20
ATCAP11  EQU   ATCAOSM+16
ATCCMTCB EQU   ATCAOSM+12
ATCPRPH  EQU   ATCAOSM+8
ATCGSRBF EQU   ATCGSRBG
ATCSRBRT EQU   ATCAOSM
ATCRSVBB EQU   ISTATCVT+908
ATCVDLOK EQU   ISTATCVT+904
ATCVFPAB EQU   ISTATCVT+872
ATCVDPAB EQU   ISTATCVT+840
ATCIOECB EQU   ISTATCVT+836
ATCINCW3 EQU   ISTATCVT+832
ATCMODTB EQU   ISTATCVT+828
ATCUSSPT EQU   ISTATCVT+824
ATCSRTAB EQU   ISTATCVT+820
@NM00112 EQU   ISTATCVT+818
ATCNMCTR EQU   ISTATCVT+816
ATCSEC51 EQU   ATCSECST
ATCSEC40 EQU   ATCSIPD+8
ATCSEC30 EQU   ATCSIPD+4
ATCSEC21 EQU   ATCSIPD
ATCSEC10 EQU   ATCSOPD+4
ATCSEC01 EQU   ATCSOPD
ATCPOIA  EQU   ATCRNO+1
@NM00111 EQU   ATCRNO
ATCPODVT EQU   ISTATCVT+784
ATCS49XL EQU   ISTATCVT+780
ATCS49XI EQU   ISTATCVT+776
ATCLCLCT EQU   ATCVLCNT+2
ATCRNCNT EQU   ATCVLCNT
ATCCFEAD EQU   ISTATCVT+768
ATCPTR00 EQU   ISTATCVT+736
ATCRSV10 EQU   ISTATCVT+704
ATCTACB  EQU   ISTATCVT+700
ATCVTINM EQU   ISTATCVT+696
ATCTCLIM EQU   ISTATCVT+692
ATCTCLOM EQU   ISTATCVT+688
ATCVTIPB EQU   ISTATCVT+656
ATCTCIPB EQU   ISTATCVT+624
ATCTIPAB EQU   ISTATCVT+592
ATCOCCCB EQU   ISTATCVT+588
ATCCDLAD EQU   ISTATCVT+580
ATCCCLAD EQU   ISTATCVT+576
ATCDLRPB EQU   ISTATCVT+544
ATCPGPAB EQU   ISTATCVT+512
ATCVPAB1 EQU   ISTATCVT+480
ATCRSV97 EQU   ISTATCVT+476
ATCRDTLK EQU   ISTATCVT+472
ATCVOCLK EQU   ISTATCVT+468
ATCCDFDN EQU   ISTATCVT+464
ATCCDFIN EQU   ISTATCVT+460
ATCDVTLK EQU   ISTATCVT+456
ATCAP36  EQU   ISTATCVT+452
ATCAP35  EQU   ISTATCVT+448
ATCAP33  EQU   ISTATCVT+444
ATCRSV99 EQU   ISTATCVT+412
ATCLDECB EQU   ISTATCVT+408
ATCLDNCS EQU   ISTATCVT+404
ATCCDPTR EQU   ISTATCVT+400
ATCADEL  EQU   ISTATCVT+396
ATCTODVT EQU   ISTATCVT+392
ATCDEBCH EQU   ISTATCVT+388
ATCHBSIZ EQU   ATCHPGM+2
ATCHBFNO EQU   ATCHPGM
ATCCRME  EQU   ISTATCVT+380
ATCRVCHS EQU   ISTATCVT+372
ATCECTLP EQU   ISTATCVT+368
ATCZDVTB EQU   ISTATCVT+364
ATCECPRT EQU   ISTATCVT+360
ATCVTLOD EQU   ISTATCVT+356
ATCTRPAB EQU   ISTATCVT+352
ATCMSGM  EQU   ISTATCVT+348
ATCMSGP  EQU   ISTATCVT+344
ATCEPT   EQU   ISTATCVT+340
ATCDVT   EQU   ISTATCVT+336
ATCTRCPT EQU   ISTATCVT+332
ATCDVLOD EQU   ISTATCVT+328
ATCALERT EQU   ISTATCVT+324
ATCEPA   EQU   ISTATCVT+320
ATCSAF   EQU   ISTATCVT+318
ATCXRANG EQU   ISTATCVT+317
ATCLAST  EQU   ATCSHRFG
ATCSHRTN EQU   ISTATCVT+308
ATCUEP   EQU   ISTATCVT+304
ATCOCRT  EQU   ISTATCVT+300
ATCCSMA  EQU   ATCCSMR
ATCESC02 EQU   ISTATCVT+292
ATCESC01 EQU   ISTATCVT+288
ATCCDFND EQU   ISTATCVT+284
ATCCDDEL EQU   ISTATCVT+280
ATCCDADD EQU   ISTATCVT+276
ATCMNT   EQU   ISTATCVT+272
ATCRSV16 EQU   ISTATCVT+270
ATCMAXID EQU   ISTATCVT+269
ATCMSGSP EQU   ATCCOM+268
ATCCIDM  EQU   ATCCOM+266
ATCACTRM EQU   ATCCOM+264
ATCNERAP EQU   ATCCOM+260
ATCNESAL EQU   ATCCOM+256
ATCRCC65 EQU   ATCCOM+252
ATCRCC26 EQU   ATCCOM+248
ATCRCC63 EQU   ATCCOM+244
ATCRSV11 EQU   ATCCOM+242
ATCVTMID EQU   ATCCOM+240
ATCAPOST EQU   ATCCOM+236
ATCNERFN EQU   ATCCOM+232
ATCNERNE EQU   ATCCOM+228
ATCNERCV EQU   ATCCOM+224
ATCNERST EQU   ATCCOM+220
ATCDCC61 EQU   ATCCOM+216
ATCDCC60 EQU   ATCCOM+212
ATCSRTDF EQU   ATCCOM+208
ATCSRTAD EQU   ATCCOM+204
ATCFIRA  EQU   ATCCOM+200
ATCSMBQ  EQU   ATCCOM+196
ATCSMRC  EQU   ATCCOM+192
ATCSMRS  EQU   ATCCOM+188
ATCSMQU  EQU   ATCCOM+184
ATCSMRQ  EQU   ATCCOM+180
ATCACDA  EQU   ATCCOM+176
ATCSTMA  EQU   ATCCOM+172
ATCFRSTR EQU   ATCCOM+168
ATCGTSTR EQU   ATCCOM+164
ATCREADA EQU   ATCCOM+160
ATCALOAD EQU   ATCCOM+156
ATCBLDLA EQU   ATCCOM+152
ATCFBRPH EQU   ATCCOM+148
ATCBFTRC EQU   ATCCOM+144
ATCTPBUF EQU   ATCTHTRC
ATCREMOV EQU   ATCCOM+136
ATCADD   EQU   ATCCOM+132
ATCBPDA  EQU   ATCCOM+128
ATCDVTPT EQU   ATCCOM+124
ATCFEPT  EQU   ATCCOM+120
ATCFDVT  EQU   ATCCOM+116
ATCCONFT EQU   ATCCOM+112
ATCPTCHA EQU   ATCCOM+108
ATCAUTHA EQU   ATCCOM+104
ATCACCTA EQU   ATCCOM+100
ATCRDTH  EQU   ATCCOM+96
ATCFRSCH EQU   ATCCOM+92
ATCFSB   EQU   ATCCOM+88
ATCHLTMS EQU   ATCCOM+84
ATCECPRM EQU   ATCCOM+80
ATCECNET EQU   ATCCOM+76
ATCECOPC EQU   ATCCOM+72
ATCVPARM EQU   ATCCOM+68
ATCECVRQ EQU   ATCCOM+64
ATCECSES EQU   ATCCOM+60
ATCOCHA  EQU   ATCCOM+56
ATCDSPLQ EQU   ATCCOM+52
ATCECDSP EQU   ATCCOM+48
ATCVARYQ EQU   ATCCOM+44
ATCECVRY EQU   ATCCOM+40
ATCHALTQ EQU   ATCCOM+36
ATCECHLT EQU   ATCCOM+32
ATCMODQ  EQU   ATCCOM+28
ATCECMOD EQU   ATCCOM+24
ATCASCHD EQU   ATCCOM+20
ATCSRT   EQU   ATCCOM+16
ATCRDT   EQU   ATCCOM+12
ATCDCFRR EQU   ATCCOM+8
ATCAPI   EQU   ATCCOM+4
ATCRSV04 EQU   ATCSTAT4
ATCNCSD  EQU   ATCSTAT4
ATCMTST  EQU   ATCSTAT4
ATCTPRT  EQU   ATCSTAT4
ATCPRTAT EQU   ATCSTAT4
@NM00110 EQU   ATCPOFLG
ATCPOUNS EQU   ATCPOFLG
ATCHSDMF EQU   ATCSTFLG
@NM00109 EQU   ATCSTAT1
ATCINHLT EQU   ATCSTAT1
ATCNETSL EQU   ATCSTAT1
ATCSTART EQU   ATCSTAT1
RPHNEXPO EQU   ISTRPH+104
RPHSAV16 EQU   RPHWORK+60
RPHSAV15 EQU   RPHWORK+56
RPHSAV14 EQU   RPHWORK+52
RPHSAV13 EQU   RPHWORK+48
RPHSAV12 EQU   RPHWORK+44
RPHSAV11 EQU   RPHWORK+40
RPHSAV10 EQU   RPHWORK+36
RPHSAVE9 EQU   RPHWORK+32
RPHSAVE8 EQU   RPHWORK+28
RPHSAVE7 EQU   RPHWORK+24
RPHSAVE6 EQU   RPHWORK+20
RPHSAVE5 EQU   RPHWORK+16
RPHSAVE4 EQU   RPHWORK+12
RPHSAVE3 EQU   RPHWORK+8
RPHSAVE2 EQU   RPHWORK+4
RPHSHALF EQU   RPHSAVE1+2
RPHSBIT8 EQU   RPHSBITS
RPHSBIT7 EQU   RPHSBITS
RPHSBIT6 EQU   RPHSBITS
RPHSBIT5 EQU   RPHSBITS
RPHSBIT4 EQU   RPHSBITS
RPHSBIT3 EQU   RPHSBITS
RPHSBIT2 EQU   RPHSBITS
RPHSBIT1 EQU   RPHSBITS
RPHSBYTE EQU   RPHSAVE1
RPHPABQP EQU   RPHPABQA+1
RPHPABFG EQU   RPHPABQA
RPHCRR   EQU   ISTRPH+32
RPHSRP34 EQU   RPHSRPRM+2
RPHSRP12 EQU   RPHSRPRM
RPHWEGT  EQU   RPHCSPA
RPHMAJCB EQU   ISTRPH+21
RPHPABOF EQU   ISTRPH+20
RPHRESUM EQU   RPHRESMA+1
RPHRSV01 EQU   RPHWPFLG
RPHPURGE EQU   RPHWPFLG
RPHPT    EQU   RPHWPFLG
RPHWT    EQU   RPHWPFLG
RPHRSKEY EQU   RPHWPFLG
RPHDVTA  EQU   ISTRPH+12
RPHTIK   EQU   RPHTSKID+3
@NM00108 EQU   RPHTSKID
RPHRPHAP EQU   RPHRPHA+1
@NM00107 EQU   RPHRPHA
RPHGATE  EQU   RPHRPHA
@NM00106 EQU   RPHFLGB
RPHRLCRA EQU   RPHFLGB
RPHNRSAV EQU   RPHFLGB
RPHPGCMP EQU   RPHFLGB
RPHFBAPS EQU   RPHFLGB
RPHBSSP  EQU   RPHFLGB
RPHLOCK  EQU   RPHFLGB
RPHFNFLG EQU   RPHFSTLC
RPHMLTCP EQU   RPHFLAGS
RPHSMCLR EQU   RPHFLAGS
RPHSMTYP EQU   RPHFLAGS
RPHSMQ   EQU   RPHFLAGS
RPHAUTEX EQU   RPHAPTYP
RPHSPGIN EQU   RPHFLAGS
RPHOGIND EQU   RPHFLAGS
RPHLNGTH EQU   ISTRPH+1
RPHTYPE  EQU   ISTRPH
DYPPAB   EQU   ISTDYPAB+16
DYPRSV01 EQU   ISTDYPAB+12
DYPTSKID EQU   ISTDYPAB+8
DYPCHAIN EQU   ISTDYPAB+4
DYPFLGS  EQU   ISTDYPAB+2
DYPLNGTH EQU   ISTDYPAB+1
DYPTYPE  EQU   ISTDYPAB
LOKXCL   EQU   @NM00104
LOKPRY   EQU   @NM00104
@NM00105 EQU   @NM00104
@NM00103 EQU   LOKCHNG
LOKCT    EQU   ISTLOK
PABRPHA  EQU   PABRPHFG+1
PABNODQ  EQU   PABFLAGS
PABINHBT EQU   PABFLAGS
PABERLOK EQU   PABERRLK
PABSSN   EQU   PABFLAGS
PABDYNAM EQU   PABFLAGS
PABNORPR EQU   PABFLAGS
PABPRIOR EQU   PABFLAGS
PABAPYP  EQU   PABFLAGS
PABDVTA  EQU   ISTPAB+9
PABOFFST EQU   ISTPAB+8
PABCHNGP EQU   PABCHAIN+1
PABRSV02 EQU   PABCHAIN
PABRUNNG EQU   PABCHAIN
PABRESET EQU   PABCHAIN
PABUNCON EQU   PABCHAIN
PABCDP   EQU   PABCHAIN
PABRESCH EQU   PABCHAIN
PABCHNG  EQU   PABCHAIN
PABWEQP  EQU   PABWEQA+1
PABRSV01 EQU   PABWEQA
PABWEQG  EQU   PABWEQA
OCARSV03 EQU   ISTOCA+32
OCADCPRM EQU   ISTOCA+28
OCARSV10 EQU   ISTOCA+25
OCARC    EQU   ISTOCA+24
OCANEXTF EQU   ISTOCA+20
OCADEBAD EQU   ISTOCA+16
@NM00101 EQU   ISTOCA+12
OCARSV01 EQU   OCAFLAGS
OCAABORT EQU   OCAFLAGS
OCACLDEB EQU   OCAFLAGS
OCAFLG1  EQU   OCAFLAGS
ISTPDAVP EQU   ISTAVT+40
ISTAVR01 EQU   ISTAVT+38
ISTVTTP  EQU   ISTAVT+36
ISTAGTWT EQU   ISTAVT+34
ISTATRT  EQU   ISTAVT+32
ISTARID  EQU   ISTAVT+30
ISTX1    EQU   ISTAVT+29
ISTPHNM  EQU   ISTAVT+24
ISTAPSEX EQU   ISTAVT+20
ISTVTTIK EQU   ISTAVT+18
AVTASID  EQU   ISTAVT+16
ISTAPSTA EQU   ISTAVT+12
ISTAS53  EQU   ISTAVT+8
ISTAHIP  EQU   ISTAS49
ISTACVT  EQU   ISTAVT
@NM00100 EQU   ACBVTEXT+8
@NM00099 EQU   ACBVTEXT+6
ACBRTN   EQU   ACBVTEXT
ACBAPID  EQU   ACBCOMN+72
ACBCBMWA EQU   ACBCOMN+68
ACBUAPTR EQU   ACBCOMN+64
ACBLRECL EQU   ACBCOMN+62
ACBMSGLN EQU   ACBBLKSZ
ACBBUFSP EQU   ACBCOMN+56
@NM00098 EQU   ACBUJFCB+1
ACBOPTN  EQU   ACBUJFCB
@NM00097 EQU   ACBINFLG+1
ACBBYPSS EQU   ACBINFLG
ACBSDS   EQU   ACBVVIC
ACBUCRA  EQU   ACBINFLG
ACBSCRA  EQU   ACBINFLG
ACBCAT   EQU   ACBINFLG
ACBIJRQE EQU   ACBINFLG
ACBJEPS  EQU   ACBINFLG
@NM00096 EQU   ACBINFLG
ACBLOCK  EQU   ACBEXFG
@NM00095 EQU   ACBOFLGS
ACBDSERR EQU   ACBOFLGS
ACBOPEN  EQU   ACBOFLGS
ACBEOV   EQU   ACBOFLGS
@NM00094 EQU   ACBOFLGS
ACBDEB   EQU   ACBDDNM+5
ACBERFL  EQU   ACBDDNM+4
ACBAM    EQU   ACBAMETH
ACBINFL  EQU   ACBDDNM+2
ACBTIOT  EQU   ACBDDNM
ACBUEL   EQU   ACBEXLST
ACBPASSW EQU   ACBCOMN+32
ACBMSGAR EQU   ACBCOMN+28
@NM00093 EQU   ACBDSORG+1
ACBDORGA EQU   ACBDSORG+1
@NM00092 EQU   ACBDSORG
ACBOPTJ  EQU   ACBDVIND
ACBCRNRE EQU   ACBCROPS
ACBCRNCK EQU   ACBCROPS
ACBASA   EQU   ACBCCTYP
@NM00091 EQU   ACBCCTYP
ACBTRCID EQU   ACBCCTYP
@NM00090 EQU   ACBRECFM
ACBRECAF EQU   ACBRECFM
ACBJBUF  EQU   ACBBUFPL+2
ACBMACR4 EQU   ACBBUFPL+1
@NM00089 EQU   ACBMACR3
ACBNCFX  EQU   ACBMACR3
ACBSIS   EQU   ACBMACR3
ACBDFR   EQU   ACBMACR3
ACBICI   EQU   ACBMACR3
ACBGSR   EQU   ACBMACR3
ACBLSR   EQU   ACBMACR3
@NM00088 EQU   ACBMACR3
ACBBUFNI EQU   ACBCOMN+18
ACBBUFND EQU   ACBCOMN+16
ACBSTRNO EQU   ACBCOMN+15
ACBBSTNO EQU   ACBCOMN+14
ACBAIX   EQU   ACBMACR2
ACBDSN   EQU   ACBMACR2
ACBRST   EQU   ACBMACR2
ACBLOGON EQU   ACBMACR2
ACBSKP   EQU   ACBMACR2
@NM00087 EQU   ACBMACR2
ACBUBF   EQU   ACBMACR1
ACBOUT   EQU   ACBMACR1
ACBIN    EQU   ACBMACR1
ACBDIR   EQU   ACBMACR1
ACBSEQ   EQU   ACBMACR1
ACBBLK   EQU   ACBCNV
ACBADD   EQU   ACBADR
ACBKEY   EQU   ACBMACR1
ACBINRTN EQU   ACBCOMN+8
ACBIBCT  EQU   ACBJWA
ACBLEN2  EQU   ACBLENG2
ACBSTYP  EQU   ACBCOMN+1
ACBID    EQU   ACBCOMN
DXATEXB2 EQU   DXATEXC2
DXATEXB1 EQU   DXATEXC1
DXATCOM4 EQU   FORCORE+600
DXATCOM3 EQU   FORCORE+596
@NM00086 EQU   DXATCOM2+3
@NM00085 EQU   DXATALL
DXATFC   EQU   DXATALL
@NM00084 EQU   DXATOPEN
DXATDFIN EQU   DXATOPEN
DXATDSIN EQU   DXATOPEN
DXATMODM EQU   DXATOPEN
DXATMODE EQU   DXATOPEN
DXATMODS EQU   DXATOPEN
DXATIGN  EQU   DXATOPEN
DXATVCAT EQU   DXATEOV
DXATDADM EQU   DXATEOV
DXATREMT EQU   DXATEOV
DXATDNEW EQU   DXATEOV
DXATDFRE EQU   DXATEOV
DXATDCHN EQU   DXATEOV
DXATNVOL EQU   DXATEOV
DXATCCAT EQU   DXATEOV
DXATRDDB EQU   DXATDACC
DXATEOF  EQU   DXATDACC
@NM00083 EQU   DXATDACC
DXATSMF  EQU   DXATDACC
DXATUPDB EQU   DXATDACC
DXATDRCT EQU   DXATDACC
DXATTRAK EQU   DXATDACC
DXATF1CE EQU   DXATDACC
DXATNSL  EQU   DXATOUTA
DXATTTM2 EQU   DXATOUTA
DXATTTM1 EQU   DXATOUTA
DXATTRL2 EQU   DXATOUTA
DXATTRL1 EQU   DXATOUTA
DXATDATM EQU   DXATOUTA
DXATHDTM EQU   DXATOUTA
DXATVLHD EQU   DXATOUTA
DXATCLOS EQU   DXATCOM1+1
DXATSRET EQU   DXATGENS
DXATVCIG EQU   DXATVGIV
DXATVTMG EQU   DXATVGIV
DXATVSMG EQU   DXATVGIV
DXATJFCB EQU   DXATGENS
DXATDISP EQU   DXATGENS
DXATREFR EQU   DXATGENS
DXATDMCT EQU   DXATGENS
DXMSGADR EQU   FORCORE+584
DXPRPARC EQU   FORCORE+580
DXPACBAD EQU   DXPDCBAD+1
@NM00082 EQU   DXPDCBAD
DXUACBAD EQU   DXUDCBAD+1
@NM00081 EQU   DXUDCBAD
DXUCBSVV EQU   DXUCBSAV+1
@NM00080 EQU   DXUCBSAV
DXUCBADR EQU   FORCORE+560
DXTIOTAD EQU   FORCORE+556
DXDSAB   EQU   FORCORE+548
DXDSABAD EQU   FORCORE+544
DXDSABQD EQU   FORCORE+540
DXJSCBAD EQU   FORCORE+536
DXTCBADR EQU   FORCORE+532
DXASCBAD EQU   FORCORE+528
DXEXTSW  EQU   FORCORE+527
DXWKEYSV EQU   FORCORE+525
DXUNITOF EQU   FORCORE+522
DXNOUNIT EQU   FORCORE+520
DXVOLSEQ EQU   FORCORE+518
DXVOLMT3 EQU   DXVOLSR3
DXVOLMT2 EQU   DXVOLSR2
DXVOLMT1 EQU   DXVOLSR1
DXWORK4  EQU   FORCORE+496
DXWORK3  EQU   FORCORE+492
DXWORK2  EQU   FORCORE+488
DXWORK1  EQU   FORCORE+484
DXWORK   EQU   FORCORE+480
@NM00079 EQU   FORCORE+464
DXCCW11  EQU   DXCCW+80
DXCCW10  EQU   DXCCW+72
DXCCW9   EQU   DXCCW+64
DXCCW7   EQU   DXCCW+48
DXCCW6   EQU   DXCCW+40
DXCCW4   EQU   DXCCW+24
DXCCW3   EQU   DXCCW+16
DXCCW2   EQU   DXCCW+8
DXCCW1   EQU   DXCCW
DXDCBDEB EQU   DXDCB+44
DXDEB    EQU   DXDCB
DXDAADDR EQU   FORCORE+312
DXIOB    EQU   FORCORE+280
DXECB    EQU   FORCORE+276
DXJBF    EQU   FORCORE+100
DSCCORE  EQU   FORCORE+96
DXLBL    EQU   DXDSCB
APPNAMID EQU   APPNMTBL+24
APPOFFST EQU   APPENTRY+2
APPCOUNT EQU   APPENTRY
APPSIZE  EQU   APPNMTBL+2
APPBAL   EQU   APPNMTBL
WTGCORE  EQU   WTGENTRY+5
WTGETTR  EQU   WTGIDTTR+2
WTGEID   EQU   WTGIDTTR
WTGOPD   EQU   WTGPATHS+1
WTGRECHK EQU   WTGPATHS+1
WTGTSENQ EQU   WTGPATHS+1
@NM00076 EQU   WTGPATHS+1
WTGTRACE EQU   WTGPATHS+1
@NM00075 EQU   WTGPATHS
WTGJFCBW EQU   WTGPATHS
WTGSMF   EQU   WTGPATHS
WTGTCOS  EQU   WTGPATHS
WTGNSL   EQU   WTGPATHS
WTGPRLSE EQU   WTGPATHS
WTGLNG   EQU   WTG+29
WTGTXTLN EQU   WTGAREA+27
WTGMODSZ EQU   WTGAREA+24
WTGATTRB EQU   WTGAREA+22
@NM00074 EQU   WTGAREA+20
@NM00073 EQU   WTGAREA+12
WTGMODEP EQU   WTGAREA+8
WTGMODID EQU   WTGMODNM+6
@NM00072 EQU   WTGMODNM
DSMADTW6 EQU   DSMADTRL+20
DSMADTW5 EQU   DSMADTRL+16
DSMADTW4 EQU   DSMADTRL+12
DSMADTW3 EQU   DSMADTRL+8
DSMADTW2 EQU   DSMADTRL+4
DSMADTB4 EQU   DSMADTW1+3
DSMADTB3 EQU   DSMADTW1+2
@NM00071 EQU   DSMADTB2
DSMDSNE  EQU   DSMADTB2
DSMTIOTE EQU   DSMADTB2
DSMSMCE  EQU   DSMADTB2
DSMVTOCR EQU   DSMADTB2
DSMASWAP EQU   DSMADTB1
DSMUCBAL EQU   DSMADTB1
DSMRPSAP EQU   DSMADTB1
DSMLOCK  EQU   DSMADTB1
@NM00070 EQU   DSMADTB1
DSMVIO   EQU   DSMADTB1
DSMISAM  EQU   DSMADTB1
RRFWORK  EQU   RRPLIST+20
RRMLRTRY EQU   RRPLIST+16
RRUCBPTR EQU   RRXRETRY
RR1RETRY EQU   RRPLIST+8
RR1WRKAR EQU   RRPLIST+4
@NM00069 EQU   RRFLAGS3
RRFTERM  EQU   RRFLAGS3
RRFFCEXC EQU   RRFLAGS3
RRFFINFC EQU   RRFLAGS3
RRFNRTCA EQU   RRFLAGS3
@NM00068 EQU   RRFLAGS3
RRFENQUL EQU   RRFLAGS2
RRFPRDET EQU   RRFLAGS2
@NM00067 EQU   RRFLAGS2
RRFQMNGR EQU   RRFLAGS2
RRFENQPW EQU   RRFLAGS2
@NM00066 EQU   RRFLAGS2
RRFFIN1  EQU   RRFLAGS2
RRFTRACE EQU   RRFLAGS1
RRFSMF   EQU   RRFLAGS1
RRFNSL   EQU   RRFLAGS1
RRFAMSTR EQU   RRFLAGS1
RRFAMEXR EQU   RRFLAGS1
RRFAMEXG EQU   RRFLAGS1
RRFUSREX EQU   RRFLAGS1
@NM00065 EQU   RRFLAGS1
RRFRJFCB EQU   RRFUNCTN
RRFDADSM EQU   RRFUNCTN
DXDCBLST EQU   USERPRML
RWALIST  EQU   RWARESWA+12
RWAPARM  EQU   RWAPREFX+8
RWATRBUF EQU   RWAPREFX+4
RWATRACE EQU   RWAPREFX
IECQMNGR EQU   IECEXTPR+92
IECMSGQA EQU   IECEXTPR+88
IECDCBNO EQU   IECUPRML
IECRRPRM EQU   IECEXTPR+76
IECWTGTB EQU   IECEXTPR+72
IECREGSV EQU   IECEXTPR
IECCORP2 EQU   IECPREFX+28
IECCORP1 EQU   IECPREFX+24
IECCORPS EQU   IECPREFX+20
IECCORSP EQU   IECPREFX+19
@NM00064 EQU   IECPREFX+17
IECCORKY EQU   IECPREFX+16
IECCORAD EQU   IECPREFX+12
IECCORLN EQU   IECPREFX+8
@NM00063 EQU   IECPREFX+4
IECCORID EQU   IECPREFX
ASXBEND  EQU   ASXB+232
ASXBRV25 EQU   ASXB+228
ASXBRV24 EQU   ASXB+224
ASXBPT0E EQU   ASXB+220
ASXBRV22 EQU   ASXB+216
ASXBCTDC EQU   ASXB+212
ASXBTDCB EQU   ASXB+208
ASXBRV19 EQU   ASXB+204
ASXBSENV EQU   ASXBSECR+1
ASXBRV34 EQU   ASXBSFLG
ASXBRV33 EQU   ASXBSFLG
ASXBRV32 EQU   ASXBSFLG
ASXBRV31 EQU   ASXBSFLG
ASXBRV30 EQU   ASXBSFLG
ASXBRV29 EQU   ASXBSFLG
ASXBRV28 EQU   ASXBSFLG
ASXBRV27 EQU   ASXBSFLG
ASXBUSER EQU   ASXB+192
ASXBLSRB EQU   ASXBAEQ+20
ASXBFSRB EQU   ASXBAEQ+16
ASXBLRQE EQU   ASXBAEQ+12
ASXBFRQE EQU   ASXBAEQ+8
ASXBLIQE EQU   ASXBAEQ+4
ASXBFIQE EQU   ASXBAEQ
ASXBETSK EQU   ASXB+164
ASXBSIRB EQU   ASXB+160
ASXBPSWD EQU   ASXB+152
ASXBPRG  EQU   ASXB+136
ASXBRV26 EQU   ASXB+132
ASXBOUSB EQU   ASXB+128
ASXBDDR  EQU   ASXB+124
ASXBRCTD EQU   ASXB+120
ASXBRSMD EQU   ASXB+116
ASXBSPSA EQU   ASXB+112
ASXBFRWA EQU   ASXB+108
ASXBFLSA EQU   ASXB+36
ASXBIHSA EQU   ASXB+32
ASXBRV15 EQU   ASXB+28
ASXBRV14 EQU   ASXB+24
ASXBLWA  EQU   ASXB+20
ASXBRS00 EQU   ASXB+14
ASXBTCBS EQU   ASXB+12
ASXBLTCB EQU   ASXB+8
ASXBFTCB EQU   ASXB+4
ASXBASXB EQU   ASXB
ASXBEGIN EQU   ASXB
ASCBEND  EQU   ASCB+208
ASCBSRBT EQU   ASCB+200
ASCBSWTL EQU   ASCB+196
ASCBRS14 EQU   ASCB+195
ASCBSMCT EQU   ASCB+194
ASCBRS12 EQU   ASCB+192
ASCBPCTT EQU   ASCB+188
ASCBVGTT EQU   ASCB+184
ASCBLGCB EQU   ASCB+180
ASCBJBNS EQU   ASCB+176
ASCBJBNI EQU   ASCB+172
ASCBMCC  EQU   ASCB+168
ASCBRTWA EQU   ASCB+164
ASCBIQEA EQU   ASCB+160
ASCBXMPQ EQU   ASCB+156
ASCBRS01 EQU   ASCB+154
ASCBFMCT EQU   ASCB+152
ASCBOUXB EQU   ASCB+148
ASCBOUCB EQU   ASCB+144
ASCBMECB EQU   ASCB+140
ASCBQECB EQU   ASCB+136
ASCBCMSB EQU   ASCB+132
ASCBCMSF EQU   ASCB+128
ASCBTCBS EQU   ASCB+124
ASCBNVSC EQU   ASCB+122
ASCBVSC  EQU   ASCB+120
ASCBSRBS EQU   ASCB+118
ASCBSSRB EQU   ASCB+116
ASCBRV06 EQU   ASCBFLG2
ASCBRV05 EQU   ASCBFLG2
ASCBRV04 EQU   ASCBFLG2
ASCBSNQS EQU   ASCBFLG2
ASCBS2S  EQU   ASCBFLG2
ASCBCEXT EQU   ASCBFLG2
ASCBPXMT EQU   ASCBFLG2
ASCBXMPT EQU   ASCBFLG2
ASCBRF07 EQU   ASCBDSP1
ASCBRF06 EQU   ASCBDSP1
ASCBRF05 EQU   ASCBDSP1
ASCBRF04 EQU   ASCBDSP1
ASCBRF03 EQU   ASCBDSP1
ASCBRF02 EQU   ASCBDSP1
ASCBFAIL EQU   ASCBDSP1
ASCBNOQ  EQU   ASCBDSP1
ASCBSWCT EQU   ASCB+112
ASCBTMCH EQU   ASCB+104
ASCBNSWP EQU   ASCBFLG1
ASCBTYP1 EQU   ASCBFLG1
ASCBSTND EQU   ASCBFLG1
ASCBABNT EQU   ASCBFLG1
ASCBTERM EQU   ASCBFLG1
ASCBS3S  EQU   ASCBFLG1
ASCBCMSH EQU   ASCBFLG1
ASCBTOFF EQU   ASCBFLG1
ASCBRF01 EQU   ASCBRCTF
ASCBTMLW EQU   ASCBRCTF
ASCBOUT  EQU   ASCBRCTF
ASCBWAIT EQU   ASCBRCTF
ASCBRV08 EQU   ASCBRCTF
ASCBFQU  EQU   ASCBRCTF
ASCBFRS  EQU   ASCBRCTF
ASCBTMNO EQU   ASCBRCTF
ASCBAFFN EQU   ASCBFW1
ASCBDUMP EQU   ASCB+96
ASCBQSVC EQU   ASCB+92
ASCBUBET EQU   ASCB+88
ASCBECB  EQU   ASCB+84
ASCBJSTL EQU   ASCB+80
ASCBEWST EQU   ASCB+72
ASCBEJST EQU   ASCB+64
ASCBTSB  EQU   ASCB+60
ASCBCSCB EQU   ASCB+56
ASCBRSM  EQU   ASCB+52
ASCBLDA  EQU   ASCB+48
ASCBSTOR EQU   ASCB+44
ASCBDP   EQU   ASCB+43
ASCBRV07 EQU   ASCB+42
ASCBIOSM EQU   ASCB+40
ASCBSEQN EQU   ASCB+38
ASCBASID EQU   ASCB+36
ASCBCPUS EQU   ASCB+32
ASCBSPL  EQU   ASCB+28
ASCBLSLQ EQU   ASCB+24
ASCBFSLQ EQU   ASCB+20
ASCBIOSP EQU   ASCB+16
ASCBLOCK EQU   ASCB+12
ASCBBWDP EQU   ASCB+8
ASCBFWDP EQU   ASCB+4
ASCBASCB EQU   ASCB
ASCBEGIN EQU   ASCB
@NM00035 EQU   SRBSECT+40
@NM00034 EQU   SRBSECT+38
SRBPRIOR EQU   SRBSECT+37
SRBPKF   EQU   SRBSECT+36
SRBSAVE  EQU   SRBSECT+32
SRBPARM  EQU   SRBSECT+28
SRBRMTR  EQU   SRBSECT+24
SRBEP    EQU   SRBSECT+20
SRBPTCB  EQU   SRBFLC+4
SRBPASID EQU   SRBFLC+2
SRBCPAFF EQU   SRBFLC
SRBASCB  EQU   SRBSECT+8
SRBFLNK  EQU   SRBSECT+4
SRBID    EQU   SRBSECT
SIRBEND  EQU   RBSECT+168
SVRBEND  EQU   RBSECT+168
RBRSV158 EQU   RBRSV150
RBRSV157 EQU   RBRSV150
RBRSV156 EQU   RBRSV150
RBRSV155 EQU   RBRSV150
RBRSV154 EQU   RBRSV150
RBRSV153 EQU   RBRSV150
RBRSV152 EQU   RBRSV150
RBRSV151 EQU   RBRSV150
RBRSV149 EQU   RBSECT+166
RBRSV148 EQU   RBSECT+164
RBSCBB   EQU   RBSECT+144
TIRBEND  EQU   @NM00032+8
PRBEND   EQU   @NM00032+8
RBRSV146 EQU   RBRSV138
RBRSV145 EQU   RBRSV138
RBRSV144 EQU   RBRSV138
RBRSV143 EQU   RBRSV138
RBRSV142 EQU   RBRSV138
RBRSV141 EQU   RBRSV138
RBRSV140 EQU   RBRSV138
RBRSV139 EQU   RBRSV138
RBRSV137 EQU   @NM00032+6
RBRSV136 EQU   @NM00032+4
RBRSV135 EQU   @NM00032
@NM00031 EQU   RBSECT+32
@NM00030 EQU   @NM00028+1
@NM00029 EQU   @NM00028
RBPGMQ1  EQU   RBPGMQ+1
@NM00027 EQU   RBPGMQ
@NM00026 EQU   RBSECT+16
@NM00025 EQU   @NM00021
@NM00024 EQU   @NM00021
RBIQETP  EQU   @NM00021
RBUSIQE  EQU   RBETXR
RBATTN   EQU   @NM00021
@NM00023 EQU   @NM00021
@NM00022 EQU   @NM00021
RBPMSVRB EQU   @NM00019
RBATNXIT EQU   @NM00019
@NM00020 EQU   @NM00019
RBWAITP  EQU   @NM00019
RBFNSVRB EQU   RBTRSVRB
RBFTP    EQU   @NM00019
RBSIZE   EQU   RBSECT+8
RBABOPSW EQU   RBSECT+4
RBPPSAV1 EQU   RBPPSAV+1
@NM00017 EQU   RBPPSAV
RBPRFXND EQU   RBPREFIX+64
RBINTCOD EQU   RBINTCDA+1
RBINLNTH EQU   RBINTCDA
RBWCSA   EQU   RBPREFIX+60
RBRSV004 EQU   RBPREFIX+57
RBSSSYN  EQU   RBFLAGS1
RBSCB    EQU   RBFLAGS1
RBLONGWT EQU   RBFLAGS1
RBASIR   EQU   RBFLAGS1
RBRSV159 EQU   RBFLAGS1
RBABEND  EQU   RBFLAGS1
RBXWAIT  EQU   RBFLAGS1
RBSLOCK  EQU   RBFLAGS1
RBRTRAN  EQU   RBRTPSW2+4
RBRTINCD EQU   RBRTICIL+2
RBRTILC  EQU   RBRTICIL+1
RBRSV160 EQU   RBRTICIL
RBRTPSW1 EQU   RBRTOPSW
RBRSV062 EQU   RBRSV054
RBRSV061 EQU   RBRSV054
RBRSV060 EQU   RBRSV054
RBRSV059 EQU   RBRSV054
RBRSV058 EQU   RBRSV054
RBRSV057 EQU   RBRSV054
RBRSV056 EQU   RBRSV054
RBRSV055 EQU   RBRSV054
RBRSV053 EQU   RBPREFIX+38
RBRSV052 EQU   RBPREFIX+36
RBRSV051 EQU   RBPREFIX+32
RBPRFXST EQU   RBPREFIX+32
RBRSV050 EQU   RBPREFIX+28
RBRSV049 EQU   RBRSV041
RBRSV048 EQU   RBRSV041
RBRSV047 EQU   RBRSV041
RBRSV046 EQU   RBRSV041
RBRSV045 EQU   RBRSV041
RBRSV044 EQU   RBRSV041
RBRSV043 EQU   RBRSV041
RBRSV042 EQU   RBRSV041
RBRSV040 EQU   RBPREFIX+26
RBRSV039 EQU   RBPREFIX+24
RBRSV038 EQU   RBPREFIX+20
RBRSV037 EQU   RBPREFIX+16
RBRSV036 EQU   RBRSV028
RBRSV035 EQU   RBRSV028
RBRSV034 EQU   RBRSV028
RBRSV033 EQU   RBRSV028
RBRSV032 EQU   RBRSV028
RBRSV031 EQU   RBRSV028
RBRSV030 EQU   RBRSV028
RBRSV029 EQU   RBRSV028
RBRSV027 EQU   RBRSV019
RBRSV026 EQU   RBRSV019
RBRSV025 EQU   RBRSV019
RBRSV024 EQU   RBRSV019
RBRSV023 EQU   RBRSV019
RBRSV022 EQU   RBRSV019
RBRSV021 EQU   RBRSV019
RBRSV020 EQU   RBRSV019
RBRSV018 EQU   RBPREFIX+13
RBRSV017 EQU   RBPREFIX+12
RBSRV016 EQU   RBPREFIX+11
RBRSV015 EQU   RBPREFIX+10
RBRSV014 EQU   RBPREFIX+8
RBRSV013 EQU   RBPREFIX+4
RBRSV012 EQU   RBPREFIX
RBEXSAVE EQU   XRBESA
XRBREG15 EQU   RBGRS15
XRBREG14 EQU   RBGRS14
XRBREG13 EQU   RBGRS13
XRBREG12 EQU   RBGRS12
XRBREG11 EQU   RBGRS11
XRBREG10 EQU   RBGRS10
XRBREG9  EQU   RBGRS9
XRBREG8  EQU   RBGRS8
XRBREG7  EQU   RBGRS7
XRBREG6  EQU   RBGRS6
XRBREG5  EQU   RBGRS5
XRBREG4  EQU   RBGRS4
XRBREG3  EQU   RBGRS3
XRBREG2  EQU   RBGRS2
XRBREG1  EQU   RBGRS1
XRBREG0  EQU   RBGRS0
XRBLNKA  EQU   RBLINKB
XRBWT    EQU   RBWCF
@NM00016 EQU   RBBASIC+24
RBOPSWPS EQU   RBOPSWB2
@NM00015 EQU   RBOPSWB2
@NM00014 EQU   XRBPSW
@NM00013 EQU   RBBASIC+12
XRBWAIT  EQU   RBECBWT
XRBFRRB  EQU   RBFDYN
@NM00012 EQU   XSTAB2
XRBACTV  EQU   RBFACTV
XRBTCBP  EQU   RBTCBNXT
@NM00011 EQU   XSTAB1
XRBCKPT  EQU   RBFTCKPT
@NM00010 EQU   XSTAB1
@NM00009 EQU   RBBASIC+8
@NM00008 EQU   RBEXRTNM+1
RBTMIND3 EQU   RBTMFLD
RBTMIND2 EQU   RBTMFLD
RBTMCMP  EQU   RBTMFLD
RBWLIM   EQU   RBTMFLD
RBRSV005 EQU   RBTMFLD
RBTMTOD  EQU   RBTMFLD
RBTMQUE  EQU   RBTMFLD
@NM00007 EQU   RBPRFX
@NM00006 EQU   TCBXTNT2+16
TCBRSV49 EQU   TCBXTNT2+12
TCBEVENT EQU   TCBXTNT2+8
TCBRCMP  EQU   TCBXTNT2+5
TCBRSVAB EQU   TCBXTNT2+4
TCBGTFA  EQU   TCBGTF+1
TCBRSV47 EQU   TCBTFLG
TCBRSV46 EQU   TCBTFLG
TCBRSV45 EQU   TCBTFLG
TCBRSV44 EQU   TCBTFLG
TCBRSV43 EQU   TCBTFLG
TCBDSPIT EQU   TCBTFLG
TCBERRTN EQU   TCBTFLG
TCBASYNC EQU   TCBTFLG
@NM00005 EQU   TCB+232
TCBRV190 EQU   TCB+229
TCBSVCA1 EQU   TCB+228
TCBJSONQ EQU   TCBTTQE
TCBARBA  EQU   TCBARB+1
TCBRSV85 EQU   TCBARB
TCBGQE   EQU   TCB+216
TCBPCB   EQU   TCB+212
TCBEXT2A EQU   TCBEXT2+1
TCBRSV39 EQU   TCBEXT2
TCBSTMCT EQU   TCB+207
TCBSYSCT EQU   TCB+206
TCBRSV37 EQU   TCB+205
TCBEXSVC EQU   TCBDAR
TCBDARMS EQU   TCBDAR
TCBDARWT EQU   TCBDAR
TCBDARO  EQU   TCBDAR
TCBDARMC EQU   TCBDARC
TCBDARD  EQU   TCBDAR
TCBDARS  EQU   TCBDAR
TCBDARP  EQU   TCBDAR
TCBGTOFM EQU   TCBFLGS7
TCBRSV84 EQU   TCBFLGS7
TCBRSV83 EQU   TCBFLGS7
TCBSVCS  EQU   TCBFLGS7
TCBFWDD  EQU   TCBFLGS7
TCBFDDEI EQU   TCBFLGS7
TCBFDDT  EQU   TCBFLGS7
TCBFDD   EQU   TCBFLGS7
TCBSTIJS EQU   TCBFLGS6
TCBDSINQ EQU   TCBFLGS6
TCBRUNJB EQU   TCBFLGS6
TCBRUNPN EQU   TCBFLGS6
TCBFPROT EQU   TCBFLGS6
TCBPANIC EQU   TCBFLGS6
TCBPIE17 EQU   TCBFLGS6
TCBRV    EQU   TCBFLGS6
TCBRSV79 EQU   TCBNDSP5
TCBRSV78 EQU   TCBNDSP5
TCBRSV77 EQU   TCBNDSP5
TCBRSV76 EQU   TCBNDSP5
TCBRSV75 EQU   TCBNDSP5
TCBRSV74 EQU   TCBNDSP5
TCBNDGTF EQU   TCBNDSP5
TCBNDSPL EQU   TCBNDSP5
TCBRSV93 EQU   TCBNDSP4
TCBRSV92 EQU   TCBNDSP4
TCBRSV91 EQU   TCBNDSP4
TCBRSV90 EQU   TCBNDSP4
TCBRSV89 EQU   TCBNDSP4
TCBRSV88 EQU   TCBNDSP4
TCBRSV87 EQU   TCBNDSP4
TCBRSV86 EQU   TCBNDSP4
TCBEXT1A EQU   TCBEXT1+1
TCBRSV32 EQU   TCBEXT1
TCBEXCPD EQU   TCB+192
TCBIOBRC EQU   TCB+188
TCBDDWTC EQU   TCB+186
TCBDDEXC EQU   TCB+184
TCBJSCBB EQU   TCBJSCB+1
@NM00004 EQU   TCBRECDE
TCBREC   EQU   TCBRECDE
TCBMDIDS EQU   TCB+176
TCBRSV28 EQU   TCBNDSP3
TCBRSV27 EQU   TCBNDSP3
TCBRSV26 EQU   TCBNDSP3
TCBRSV25 EQU   TCBNDSP3
TCBRSV24 EQU   TCBNDSP3
TCBNDSDA EQU   TCBNDSP3
TCBABTER EQU   TCBNDSP3
TCBTERM  EQU   TCBNDSP3
TCBABE   EQU   TCBNDSP2
TCBDSS   EQU   TCBNDSP2
TCBOWAIT EQU   TCBNDSP2
TCBIWAIT EQU   TCBNDSP2
TCBNDTS  EQU   TCBNDSP2
TCBNDSVC EQU   TCBNDSP2
TCBSTPP  EQU   TCBNDSP2
TCBABD   EQU   TCBNDSP2
TCBRSV22 EQU   TCBNDSP1
TCBPIEND EQU   TCBNDSP1
TCBTPSP  EQU   TCBNDSP1
TCBDDRND EQU   TCBNDSP1
TCBRSPND EQU   TCBNDSP1
TCBRSTND EQU   TCBNDSP1
TCBDARPN EQU   TCBNDSP1
TCBDARTN EQU   TCBNDSP1
TCBNDSP0 EQU   TCBNDSP
TCBUSER  EQU   TCB+168
TCBTCTB  EQU   TCBTCT+1
TCBRSV9C EQU   TCBTCTGF
TCBRSV9B EQU   TCBTCTGF
TCBRSV9A EQU   TCBTCTGF
TCBRSV99 EQU   TCBTCTGF
TCBRSV98 EQU   TCBTCTGF
TCBRSV97 EQU   TCBTCTGF
TCBRSV20 EQU   TCBTCTGF
TCBSMFGF EQU   TCBTCTGF
TCBSTABB EQU   TCBSTAB+1
TCBVALID EQU   TCBNSTAE
TCBRETRY EQU   TCBNSTAE
TCBSUPER EQU   TCBNSTAE
TCBHALT  EQU   TCBNSTAE
TCBSCAT  EQU   TCBNSTAE
TCBXCTL  EQU   TCBNSTAE
TCBQUIES EQU   TCBNSTAE
TCBSTABE EQU   TCBNSTAE
TCBDDRTI EQU   TCB+156
TCBRSV73 EQU   TCBFTFL3
TCBRSV72 EQU   TCBFTFL3
TCBFTDUM EQU   TCBFTFL3
TCBRSV71 EQU   TCBFTFL3
TCBRSV70 EQU   TCBFTFL3
TCBRSV69 EQU   TCBFTFL3
TCBRSV68 EQU   TCBFTFL3
TCBRSV67 EQU   TCBFTFL3
TCBRSV66 EQU   TCBFTFL2
TCBSYSAB EQU   TCBFTFL2
TCBFDSOP EQU   TCBFTFL2
TCBRSV65 EQU   TCBFTFL2
TCBLPAGE EQU   TCBFTFL2
TCBDDEN  EQU   TCBFTFL2
TCBRSV62 EQU   TCBFTFL2
TCBRSV61 EQU   TCBFTFL2
TCBENQ   EQU   TCBFTFL1
TCBFTCOM EQU   TCBFTFL1
TCBFTTOP EQU   TCBFTFL1
TCBRSV60 EQU   TCBFTFL1
TCBRSV59 EQU   TCBFTFL1
TCBRSV58 EQU   TCBFTFL1
TCBVTAM  EQU   TCBFTFL1
TCBTCAM  EQU   TCBFTFL1
TCBFTLMP EQU   TCB+152
TCBTSDP  EQU   TCB+151
TCBTSLP  EQU   TCB+150
TCBSTPCT EQU   TCB+149
TCBCPUBN EQU   TCBTSFLG
TCBDYDSP EQU   TCBTSFLG
TCBRSV18 EQU   TCBTSFLG
TCBRSV17 EQU   TCBTSFLG
TCBTIOTG EQU   TCBTSFLG
TCBATT   EQU   TCBTSFLG
TCBSTPPR EQU   TCBTSFLG
TCBRV300 EQU   TCBTSTSK
TCBECB   EQU   TCB+144
TCBIQE   EQU   TCB+140
TCBLTC   EQU   TCB+136
TCBOTC   EQU   TCB+132
TCBNTC   EQU   TCB+128
TCBPIBA  EQU   TCBPIB+1
TCBSCHED EQU   TCBPIBT
TCBWRITE EQU   TCBPIBT
TCBSCHTI EQU   TCBPIBT
TCBRSV54 EQU   TCBPIBT
TCBSTOP  EQU   TCBPIBT
TCBSIZE  EQU   TCBPIBT
TCBPART  EQU   TCBPIBT
TCBTQET  EQU   TCBTME
TCBTCB   EQU   TCB+116
TCBFSAB  EQU   TCBFSA+1
TCBIDF   EQU   TCBFSA
TCBGRS9  EQU   TCBGRS+60
TCBGRS8  EQU   TCBGRS+56
TCBGRS7  EQU   TCBGRS+52
TCBGRS6  EQU   TCBGRS+48
TCBGRS5  EQU   TCBGRS+44
TCBGRS4  EQU   TCBGRS+40
TCBGRS3  EQU   TCBGRS+36
TCBGRS2  EQU   TCBGRS+32
TCBGRS1  EQU   TCBGRS+28
TCBGRS0  EQU   TCBGRS+24
TCBGRS15 EQU   TCBGRS+20
TCBGRS14 EQU   TCBGRS+16
TCBGRS13 EQU   TCBGRS+12
TCBGRS12 EQU   TCBGRS+8
TCBGRS11 EQU   TCBGRS+4
TCBGRS10 EQU   TCBGRS
TCBFTJSA EQU   TCBFTJST+1
TCBRSV15 EQU   TCBPURGE
TCBRSV14 EQU   TCBPURGE
TCBRSV13 EQU   TCBPURGE
TCBRSV12 EQU   TCBPURGE
TCBRSV11 EQU   TCBPURGE
TCBRSV10 EQU   TCBPURGE
TCBRSV09 EQU   TCBPURGE
TCBJPQF  EQU   TCBPURGE
TCBJLB   EQU   TCB+40
TCBLLS   EQU   TCB+36
TCBDSP   EQU   TCB+35
TCBLMP   EQU   TCB+34
TCBPNDSP EQU   TCBFLGS5
TCBFCD1  EQU   TCBFLGS5
TCBSTP   EQU   TCBFLGS5
TCBSYS   EQU   TCBFLGS5
TCBANDSP EQU   TCBFLGS5
TCBPAGE  EQU   TCBFLGS5
TCBUXNDF EQU   TCBABWF
TCBFC    EQU   TCBFLGS5
TCBONDSP EQU   TCBFLGS4
TCBMPCND EQU   TCBFLGS4
TCBMPCVQ EQU   TCBFLGS4
TCBUXNDV EQU   TCBFLGS4
TCBHNDSP EQU   TCBFLGS4
TCBRQENA EQU   TCBFLGS4
TCBSER   EQU   TCBFLGS4
TCBNDUMP EQU   TCBFLGS4
TCBRSV53 EQU   TCBFLGS3
TCBPKCHG EQU   TCBFLGS3
TCBSCHAB EQU   TCBFLGS3
TCBFLREG EQU   TCBFLGS3
TCBRSV52 EQU   TCBFLGS3
TCBSYSER EQU   TCBFLGS3
TCBRSV51 EQU   TCBFLGS3
TCBFSM   EQU   TCBFLGS3
TCBFTS   EQU   TCBFLGS2
TCBFETXR EQU   TCBFLGS2
TCBRSV50 EQU   TCBFLGS2
TCBFJMC  EQU   TCBFLGS2
TCBFSMC  EQU   TCBFLGS2
TCBFABOP EQU   TCBFLGS2
TCBFSTI  EQU   TCBFLGS2
TCBSYSTK EQU   TCBFLGS2
TCBFX    EQU   TCBFLGS1
TCBFS    EQU   TCBFLGS1
TCBPOOL  EQU   TCBFLGS1
TCBDMPA  EQU   TCBFLGS1
TCBJSTE  EQU   TCBFLGS1
TCBABTRM EQU   TCBFLGS1
TCBFE    EQU   TCBFLGS1
TCBFA    EQU   TCBFLGS1
TCBZERO  EQU   TCBPKF
TCBFLAG  EQU   TCBPKF
TCBMSSB  EQU   TCBMSS+1
TCBRSV03 EQU   TCBMSS
TCBTRNB  EQU   TCBTRN+1
TCBRSV02 EQU   TCBABF
TCBOLTEP EQU   TCBABF
TCBTCP   EQU   TCBABF
TCBTCPP  EQU   TCBABF
TCBRSV01 EQU   TCBABF
TCBGRPH  EQU   TCBABF
TCBNOCHK EQU   TCBABF
TCBMOD91 EQU   TCBABF
TCBCMPC  EQU   TCBCMP+1
TCBRV318 EQU   TCBCMSG
TCBRV317 EQU   TCBCIND
TCBRV316 EQU   TCBCWTO
TCBCASID EQU   TCBCDBL
TCBNOCC  EQU   TCBSTCC
TCBDMPO  EQU   TCBCPP
TCBCSTEP EQU   TCBCMPF
TCBCREQ  EQU   TCBCMPF
TCBTIO   EQU   TCB+12
TCBDEB   EQU   TCB+8
TCBPIEA  EQU   TCBPIE+1
TCBPM    EQU   TCBPMASK
@NM00003 EQU   TCBPMASK
TCBFRS6  EQU   TCBFRS+24
TCBFRS4  EQU   TCBFRS+16
TCBFRS2  EQU   TCBFRS+8
TCBFRS0  EQU   TCBFRS
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00002 EQU   CVTFIX+248
@NM00001 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTSHSB  EQU   CVTSHS
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRSV37 EQU   CVTDMSR
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
@NM00059 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00058 EQU   PSA+1040
PSAUSEND EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSALITA  EQU   PSA+764
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00057 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00056 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSARV011 EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSAIPCRP EQU   PSASUP1
PSAIPCDR EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAANEW  EQU   PSA+544
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00055 EQU   FLCFSA
@NM00054 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00053 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00052 EQU   FLCIOA
@NM00051 EQU   FLCMCLA+15
@NM00050 EQU   FLCMCLA+14
@NM00049 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00048 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00047 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00046 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00045 EQU   FLCPER
@NM00044 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00043 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00042 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00041 EQU   FLCPIILC
@NM00040 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00039 EQU   FLCSVILC
@NM00038 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00037 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00036 EQU   FLCICCW2+4
FLCCVT   EQU   FLCICCW2
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@ENDDATA EQU   *
         END   ISTOCCOA,(C'PLS2214',0603,75189)
