         TITLE 'ISTOCCOE - OPNDST 2 GET FUNCTION SUPPORT               *
                        '
ISTOCCOE CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'ISTOCCOE  78.103'                                 0001
         DROP  @15
@PROLOG  BALR  @11,0                                               0001
@PSTART  LA    @12,4095(,@11)                                      0001
         USING @PSTART,@11                                         0001
         USING @PSTART+4095,@12                                    0001
*                                                                  0635
*/********************************************************************/
*/*  ROUTINE NAME:MAIN LINE                                          */
*/*  FUNCTION:                                                       */
*/*       THIS ROUTINE RECEIVES CONTROL FROM ISTOCCOD AND IS SENT A  */
*/*       LIST CONSISTING OF AN ENTRY FOR EACH DEST FOLLOWED BY      */
*/*       SORT RDTE PTRS. EACH ENTRY HAS AN RDTE PTR, A NIB PTR      */
*/*       AND A DATA PTR.                                            */
*/*       FOR EACH DESTINATION: A DETERMINATION IS MADE WHETHER TO   */
*/*       TURN ON THE BIT TO SEND BIND FAILURE IN CASE AN ERROR      */
*/*       OCCURS.                                                    */
*/*       NEXT FOR EACH DESTINATION: THE CONNECTION IS VERIFIED,     */
*/*       THE EPT/DVT STRUCTURE BUILT AND THE CONNECTION CONTROL     */
*/*       BLOCKS ARE BUILT. START CONTROL IS SENT IF REQUIRED.       */
*/*       THEN FOR EACH DESTINATION: THE SESSION IS BOUND AND        */
*/*       THE USER'S NIB IS UPDATED.                                 */
*/*       FINALLY FOR EACH DESTINATION: BIND FAILURE IS SENT IF      */
*/*       NECESSARY                                                  */
*/*  ROUTINES CALLED:                                                */
*/*       DOBNSET - SETS BIND FAILURE BIT IN EACH DEST OBTAINED      */
*/*       DOFNCOB - BLDS EPT/DVT AND FMCB/NCB                        */
*/*       DOIOLP -  PERFORMS BIND & START DATA TRAFFIC               */
*/*       DOBINFL - SENDS BIND FAILURE NCSPL IF NECESSARY            */
*/*       CLEANUP - RELEASES AND EXISTING NMLPBS                     */
*/*  MACROS USED:                                                    */
*/*       CRRMAINT - FOOTPRINT                                       */
*/*       TPUNLOCK - RELEASE THE VOC AND RDT LOCKS                   */
*/********************************************************************/
*                                                                  0635
*   DO;                                                            0635
*                                                                  0635
*/***  CRRMAINT  PROCNM(ISTOCCOE)COMP(OC)FUNC(SUB)  **               */
*                                                                  0636
*     DCL                                                          0636
*       CMZK0011 PTR(31) REG(1);                                   0636
*     RFY                                                          0637
*      (CMZK0011) RSTD;                                            0637
*                                                                  0637
*/* ATBUILD (ISTRPH,ISTCRA,ISTPFCRR,ISTOCCRR)                        */
*                                                                  0638
*     RFY                                                          0638
*       ISTZSAVE;                                                  0638
*     RFY                                                          0639
*       ISTPFCRR;                                                  0639
*     RFY                                                          0640
*       ISTCFCRR;                                                  0640
*     RFY                                                          0641
*       ISTZCRR;                                                   0641
*     RFY                                                          0642
*       ISTASCRR;                                                  0642
*     RFY                                                          0643
*       ISTAPCRR;                                                  0643
*     RFY                                                          0644
*       ISTCRA;                                                    0644
*     RFY                                                          0645
*       ISTCNSTA;                                                  0645
*     RFY                                                          0646
*       ISTOCCRR;                                                  0646
*                                                                  0646
*/* END OF ATBUILD                                                   */
*/*  ** SET ENTERED BIT FOR THIS PROCEDURE **                        */
*                                                                  0647
*     CMZK0011->RPHCRR->CRACRR->NOCCOE='1'B;                       0647
*                                                                  0647
         L     @10,RPHCRR(,CMZK0011)                               0647
         L     @10,CRACRR(,@10)                                    0647
         OI    NOCCOE(@10),B'00010000'                             0647
*/*  ** CLEAR AND SET CURRENT PROCEDURE BIT **                       */
*                                                                  0648
*     CMZK0011->RPHCRR->CRACRR->OCCCRT='0'B;                       0648
         XC    OCCCRT+1(2,@10),OCCCRT+1(@10)                       0648
         MVI   OCCCRT(@10),B'00000000'                             0648
*     CMZK0011->RPHCRR->CRACRR->COCCOE='1'B;                       0649
         OI    COCCOE(@10),B'00010000'                             0649
*   END;                                                           0650
*   IF CSPRSC2F=COFF                /* IF RESOURCE 2 NAME NOT IN     */
*     THEN                          /* CON SVCS PARM LIST    @D32CKMP*/
         LA    @10,224                                             0651
         ALR   @10,OCWPTR                                          0651
         TM    CSPRSC2F(@10),B'00000010'                           0651
         BNZ   @RF00651                                            0651
*     CSPRSC2B=OCWARDTE->RPRNAME;   /* COPY RDT NAME TO CSP  @D32CKMP*/
         L     @09,OCWARDTE(,OCWPTR)                               0652
         MVC   CSPRSC2B(8,@10),RPRNAME(@09)                        0652
*   ELSE                                                           0653
*     ;                             /* NO COPY NECESSARY     @D32CKMP*/
@RF00651 DS    0H                                                  0654
*/********************************************************************/
*/*  ROUTINE NAME: DOBNSET                                           */
*/*  FUNCTION:                                                       */
*/*       THIS ROUTINE IS INCLUDED BY THE MAINLINE TO TURN ON THE    */
*/*       BIT THAT INDICATES BIND FAILURE IS TO BE SENT. THIS BIT    */
*/*       IS TURNED ON FOR EACH ALLOCATED DEST                       */
*/*  ROUTINES CALLED:                                                */
*/*       NONE                                                       */
*/*  MACROS USED:                                                    */
*/*       NONE                                                       */
*/********************************************************************/
*                                                                  0654
*DOBNSET:                                                          0654
*   DO;                             /* NEW FOR BIND INTRLCK  @D32CKXY*/
DOBNSET  DS    0H                                                  0655
*     RFY                                                          0655
*       ISTCSL BASED(OCWODNAS);     /* CSL LOC AT LST ENTRY  @D32CKXY*/
*     OCWODCT1=0;                   /* INIT LOOP CTR         @D32CKXY*/
         SLR   @10,@10                                             0656
         STH   @10,OCWODCT1(,OCWPTR)                               0656
*     OCWODNAS=OCWODLST;            /* PT TO FIRST LST NTRY  @D32CKXY*/
         L     @10,OCWODLST(,OCWPTR)                               0657
         ST    @10,OCWODNAS(,OCWPTR)                               0657
*     RFY                                                          0658
*       SORTPTR RSTD;               /* PROCESS ALL DESTS     @D32CKXY*/
*     IF OCWDSTNO>1 THEN                                           0659
         LH    @09,OCWDSTNO(,OCWPTR)                               0659
         CH    @09,@CH00068                                        0659
         BNH   @RF00659                                            0659
*       DO;                         /* IF DEST OBTAINED      @D32CKXY*/
*         SORTPTR=OCWODLST+OCWDSTNO*LENGTH(ISTCSL);/* PT TO BEG OF 0661
*                                      SORT SLOT AREA FOR CLEAR    0661
*                                                            @D32CKXY*/
         MH    @09,@CH00033                                        0661
         ALR   @10,@09                                             0661
         LR    SORTPTR,@10                                         0661
*       END;                        /*                       @D32CKXY*/
*     ELSE                                                         0663
*       SORTPTR=ADDR(OCWCID);       /* PT TO SORT SLOT USED FOR SING
*                                      DEST REQUEST          @D32CKXY*/
         B     @RC00659                                            0663
@RF00659 LA    SORTPTR,OCWCID(,OCWPTR)                             0663
*     DO WHILE OCWODCT1<OCWDSTNO;   /* PROCESS ALL DESTS     @D32CKXY*/
@RC00659 B     @DE00664                                            0664
@DL00664 DS    0H                                                  0665
*       IF CSLRDTEF=CON THEN                                       0665
         L     @10,OCWODNAS(,OCWPTR)                               0665
         TM    CSLRDTEF(@10),B'10000000'                           0665
         BNO   @RF00665                                            0665
*         DO;                       /* IF DEST OBTAINED      @D32CKXY*/
*           CSLRDTEB=CON;           /* TURN ON BIT INDICATING BIND 0667
*                                      FAILURE NCSPL SHOULD BE SENT
*                                      IF BIND IS NOT SENT   @D32CKXY*/
         OI    CSLRDTEB(@10),B'01000000'                           0667
*         END;                      /*                       @D32CKXY*/
*       ELSE                                                       0669
*         ;                         /*                       @D32CKXY*/
@RF00665 DS    0H                                                  0670
*       SORTPTR->SORTCID=SORTPTR->SORTCID&&SORTPTR->SORTCID;/* CLEAR
*                                      SORT SLOT             @D32CKXY*/
         L     @10,SORTCID(,SORTPTR)                               0670
         LR    @09,@10                                             0670
         XR    @09,@10                                             0670
         ST    @09,SORTCID(,SORTPTR)                               0670
*       SORTPTR=SORTPTR+4;          /* PT TO NEXT SORT SLOT  @D32CKXY*/
         AH    SORTPTR,@CH00045                                    0671
*       OCWODNAS=OCWODNAS+LENGTH(ISTCSL);/* PT TO NXT LIST ENTRY   0672
*                                                            @D32CKXY*/
         LA    @10,12                                              0672
         AL    @10,OCWODNAS(,OCWPTR)                               0672
         ST    @10,OCWODNAS(,OCWPTR)                               0672
*       OCWODCT1=OCWODCT1+1;        /* INCREMENT LOOP CTR    @D32CKXY*/
         LA    @10,1                                               0673
         AH    @10,OCWODCT1(,OCWPTR)                               0673
         STH   @10,OCWODCT1(,OCWPTR)                               0673
*     END;                          /* END DO WHILE                  */
@DE00664 LH    @10,OCWDSTNO(,OCWPTR)                               0674
         CH    @10,OCWODCT1(,OCWPTR)                               0674
         BH    @DL00664                                            0674
*     RFY                                                          0675
*       SORTPTR UNRSTD;             /*                               */
*     RFY                                                          0676
*       ISTCSL BASED(ADDR(OCWDRDTE));/* RESTORE ORIG CSL LOC         */
*     IF OCWDSTNO=1 THEN                                           0677
         CH    @10,@CH00068                                        0677
         BNE   @RF00677                                            0677
*       OCWODNAS=ADDR(OCWCID);      /* PT TO SORT SLOT USED FOR SING
*                                      DEST REQUEST          @D32CKXY*/
         LA    @10,OCWCID(,OCWPTR)                                 0678
         ST    @10,OCWODNAS(,OCWPTR)                               0678
*     ELSE                                                         0679
*       ;                           /* PTR SETUP RT ALREADY  @D32CKXY*/
@RF00677 DS    0H                                                  0680
*   END DOBNSET;                    /*                       @D32CKXY*/
*                                                                  0681
*/********************************************************************/
*/* ROUTINE NAME: DOFNCOB                                            */
*/* FUNCTION:                                                        */
*/*      THIS ROUTINE PERFORMS THE FUNCTION OBTAIN FOR EACH DEST.    */
*/*      THE EPT & DVT STRUCTURE IS BUILT AND THE FMCB AND NCB IS    */
*/*      BUILT. IT IS INCLUDED BY MAINLINE                           */
*/* ROUTINES CALLED:                                                 */
*/*      DOVALINT - VALIDATES AND COPIES NIB                         */
*/*      DOENVTST - ENSURES THAT AN ACTIVE CONNECTION STILL EXISTS   */
*/*      DOPHYCON - VERIFIES THAT PHYSICAL CONNECTION EXISTS TO      */
*/*                 THE LU                                           */
*/*      ISTOCCFO - BUILDS EPT/DVT STRUCTURE                         */
*/*      ISTOCCFB - BUILDS FMCB & NCB                                */
*/*      ISTOCCRL - RELEASES EPT/DVT STRUCTURE IF ISTOCCFB FAILS     */
*/*      DOSTCTL  - DRIVES NETWORK SLICITOR OR PORT SOLICITOR        */
*/* MACROS USED:                                                     */
*/*      CRRMAINT - FOOTPRINT                                        */
*/*      TPUNLOCK - UNLOCK THE RDTE                                  */
*/********************************************************************/
*                                                                  0681
*DOFNCOB:                                                          0681
*   DO;                             /* NEW FOR BIND INTRLCK  @D32CKXY*/
DOFNCOB  DS    0H                                                  0682
*     OCWODCT1=0;                   /* INIT LOOP CTR         @D32CKXY*/
         SLR   @10,@10                                             0682
         STH   @10,OCWODCT1(,OCWPTR)                               0682
*     DO WHILE OCWODCT1<OCWDSTNO&OCWRC=0;/* LOOP UNTIL ALL RDTES ARE
*                                      PROCESSED OR AN ERROR OCCURS
*                                                            @D32CKXY*/
         B     @DE00683                                            0683
@DL00683 DS    0H                                                  0684
*       RFY                                                        0684
*         NTRYPTR RSTD;             /*                       @D32CKXY*/
*       NTRYPTR=OCWODLST+(OCWODCT1*LENGTH(ISTCSL));/* PT TO LIST   0685
*                                      ENTRY                 @D32CKXY*/
         LH    NTRYPTR,OCWODCT1(,OCWPTR)                           0685
         MH    NTRYPTR,@CH00033                                    0685
         AL    NTRYPTR,OCWODLST(,OCWPTR)                           0685
*       CSLRDEF=NTRYPTR->CSLRDEF;   /* COPY ENTRY'S RDTE PTR TO    0686
*                                      OCWDRDTE              @D32CKXY*/
         LA    @10,40                                              0686
         ALR   @10,OCWPTR                                          0686
         MVC   CSLRDEF(4,@10),CSLRDEF(NTRYPTR)                     0686
*       CSLNDEF=NTRYPTR->CSLNDEF;   /* COPY ENTRY'S NIB PTR TO OCWNIB
*                                                            @D32CKXY*/
         MVC   CSLNDEF(4,@10),CSLNDEF(NTRYPTR)                     0687
*       RFY                                                        0688
*         NTRYPTR UNRSTD;           /*                       @D32CKXY*/
*       IF OCWDSTNO=1 THEN                                         0689
         CLC   OCWDSTNO(2,OCWPTR),@CH00068                         0689
         BNE   @RF00689                                            0689
*         OCWNIB=OCWOENIB;          /* FOR SING REQST, GET NIB ADDR
*                                      FROM FLD ADDR NIB SAVE AREA 0690
*                                                            @D32CKXY*/
         MVC   OCWNIB(4,OCWPTR),OCWOENIB(OCWPTR)                   0690
*       ELSE                                                       0691
*         ;                         /*                       @D32CKXY*/
@RF00689 DS    0H                                                  0692
*       OCWFMCB=0;                  /* ZERO PTR BEF NEXT CALL TO   0692
*                                      ISTOCCFB              @D32CKXY*/
         SLR   @10,@10                                             0692
         ST    @10,OCWFMCB(,OCWPTR)                                0692
*       OCWNCB=0;                   /* ZERO PTR BEF FB CALL  @D32CKXY*/
         ST    @10,OCWNCB(,OCWPTR)                                 0693
*       IF CSLRDTEF=CON THEN                                       0694
         TM    CSLRDTEF+40(OCWPTR),B'10000000'                     0694
         BNO   @RF00694                                            0694
*         DO;                       /* IF DEST WAS OBT       @D32CKXY*/
*           CPARMRG0=1;             /* INDICATE COPY FUNCTN  @D32CKXY*/
         LA    CPARMRG0,1                                          0696
*           CALL DOVALINT;          /* VALIDATE & COPY NIB   @D32CKXY*/
         BAL   @14,DOVALINT                                        0697
*           IF OCWRC=0 THEN                                        0698
         CLI   OCWRC(OCWPTR),0                                     0698
         BNE   @RF00698                                            0698
*             DO;                   /* IF NIB IS VALID       @D32CKXY*/
*               CALL DOENVTST;      /* ENSURE DEST EXISTS    @D32CKXY*/
         BAL   @14,DOENVTST                                        0700
*               IF CSLRDTEF=CON&OCWRC=0 THEN                       0701
         TM    CSLRDTEF+40(OCWPTR),B'10000000'                     0701
         BNO   @RF00701                                            0701
         CLI   OCWRC(OCWPTR),0                                     0701
         BNE   @RF00701                                            0701
*                 DO;               /* IF DEST FOUND         @D32CKXY*/
*                   DO;             /* THIS BEGINS LOGICAL SEGMENT D
*                                      O P H Y C O N                 */
*/*  *****************************************************************/
*/*   ROUTINE NAME : DOPHYCON (SEGMENT)                              */
*/*   FUNCTION:                                                      */
*/*       INVOKED BY MAINLINE, THE DOPHYCON SEGMENT WILL TEST EACH   */
*/*       DESTINATION TO SEE IF IT IS A LOGICAL UNIT (LU).  IT THEN  */
*/*       TESTS TO SEE IF A PHYSICAL CONNECTION EXISTS TO THE LU     */
*/*       (RPRCONCT SET).  IF NOT, AND IF THE SSCP IS NOT THE CALLER,*/
*/*       THE SSCP IS INVOKED TO MAKE THE PHYSICAL CONNECTION.  A    */
*/*       NCSPL IS ALLOCATED AND FORMATTED WITH A VERB CODE OF DIAL  */
*/*       (START), AND QUEUED TO THE VPAB ASSOCIATED WITH THE HEADER */
*/*       RDT OF THE LU.  AFTER POSTING BY THE SSCP, THE OCW RETURN  */
*/*       CODES ARE CHECKED FOR SUCCESS.                             */
*/*   ROUTINES CALLED:                                               */
*/*       DOENVTST - TO RE-OBTAIN LOCKS                              */
*/*   MACROS USED:                                                   */
*/*       REQSTORE - FOR NCSPL                                       */
*/*       GETSTORE - FOR NCSPL WORK AREA                             */
*/*       TPWAIT - WAIT FOR DIAL                                     */
*/*       RELSTORE - RELEASE NCSPL                                   */
*/*       TPLOCK - GET VOCLOCK (SHARED)                              */
*/*       TPQUE - NCSPL TO VPAB ASSOC WITH HEADER RDTE               */
*/*       TPUNLOCK - REL. VOCLOCK AND RDT LOCK                       */
*/*  *****************************************************************/
*                                                                  0704
*                     RFY                                          0704
*                       CPARMR08 RSTD;                             0704
*                     RFY                                          0705
*                       ISTNCSPL BASED(CPARMR08);                  0705
*                     IF RPRENTRY=RPRENTLU&/* IF DEST. IS AN LU AND  */
*                         (RPRCONCT=COFF|/* PHYSICAL CONN. DOES NOT
*                                      EXIST,                        */
*                         RPRNSNEA->RCCRESET=CON)/* RESET IN PROGRESS
*                                                            @ZA19893*/
*                       THEN                                       0706
         L     @10,OCWDRDTE(,OCWPTR)                               0706
         CLI   RPRENTRY(@10),X'81'                                 0706
         BNE   @RF00706                                            0706
         TM    RPRCONCT(@10),B'01000000'                           0706
         BZ    @RT00706                                            0706
         L     @10,RPRNSNEA(,@10)                                  0706
         TM    RCCRESET(@10),B'00000100'                           0706
         BNO   @RF00706                                            0706
@RT00706 DS    0H                                                  0707
*                       DO;                                        0707
*                         IF RAPALLF^=CON|/* CHECK TO SEE IF SSCP IS
*                                      CALLER.                       */
*                             RPLVTUSE^=CON/* IF NOT, THEN HAVE TO 0708
*                                      REQUEST                       */
*                           THEN    /* THAT SSCP DO THE DIAL         */
         L     @10,OCWARDTE(,OCWPTR)                               0708
         TM    RAPALLF(@10),B'10000000'                            0708
         BNO   @RT00708                                            0708
         L     @10,OCWRPL(,OCWPTR)                                 0708
         TM    RPLVTUSE+16(@10),B'01000000'                        0708
         BO    @RF00708                                            0708
@RT00708 DS    0H                                                  0709
*                           DO;                                    0709
*                                                                  0709
*                             /***************************************/
*                             /*                                     */
*                             /* REQUEST A CLEARED STORAGE AREA FOR  */
*                             /* NCSPL TO SEND DIAL REQUEST TO SSCP. */
*                             /*                                     */
*                             /***************************************/
*                                                                  0710
*/*  REQSTORE CBID(NCSPL)CLEAR(YES)RPH(YES)                          */
*                                                                  0710
*                             DO;                                  0710
*                                                                  0710
*/* ATBUILD (ISTDYPAB,ISTATCVT,ISTRPH)                               */
*/* END OF ATBUILD                                                   */
*                                                                  0711
*                               RFY                                0711
*                                (GPR02P,                          0711
*                                 GPR03P,                          0711
*                                 GPR04P,                          0711
*                                 GPR15P) RSTD;                    0711
*                               RFY                                0712
*                                (GPR01P,                          0712
*                                 GPR13P) RSTD;                    0712
*                               GENERATE REFS(GPR01P,GPR02P,GPR13P)
*                                   SETS(RPHWORK);                 0713
           STM GPR02P,GPR13P,RPHWORK(GPR01P)
*                               RFY                                0714
*                                (GPR01P,                          0714
*                                 GPR13P) UNRSTD;                  0714
*                               DO; /* LISATCVT                    0715
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*                                 GPR15P=ATCLCPTR;/* SET UP ATCVT  0716
*                                      POINTER                       */
         L     GPR15P,ATCLCPTR                                     0716
*                               END;/* LISATCVT                      */
*                               GPR02P=GPR15P->ATCBPDA|'80000000'X;
         L     GPR02P,ATCBPDA(,GPR15P)                             0718
         O     GPR02P,@CF01465                                     0718
*                               DCL                                0719
*                                 1 FMZA0013 FIXED(31) STATIC LOCAL,
*                                  2 * FIXED(8) INIT(184),         0719
*                                  2 * PTR(24) INIT(0);            0719
*                               GPR03F=FMZA0013;                   0720
         L     GPR03F,FMZA0013                                     0720
*                               GPR04F=34;                         0721
         LA    GPR04F,34                                           0721
*                               GPR15P=GPR15P->ATCSMRQ;            0722
         L     GPR15P,ATCSMRQ(,GPR15P)                             0722
*                               DCL                                0723
*                                 FMZL0013 BASED(GPR15P) LABEL     0723
*                                     VALUERANGE(*);               0723
*                               CALL FMZL0013;                     0724
         BALR  @14,@15                                             0724
*                               RFY                                0725
*                                (GPR13P) RSTD;                    0725
*                               GENERATE REFS(GPR01P,RPHWORK) SETS(
*                                   GPR02P,GPR13P);                0726
           LM GPR02P,GPR13P,RPHWORK(GPR01P)
*                               RFY                                0727
*                                (GPR13P) UNRSTD;                  0727
*                               RFY                                0728
*                                (GPR02P,                          0728
*                                 GPR03P,                          0728
*                                 GPR04P,                          0728
*                                 GPR15P) UNRSTD;                  0728
*                             END;  /* ******** END OF REQSTORE    0729
*                                      EXPANSION             @DM14058*/
*                             IF CRETCODE=CEIGHT/* IF RTN CODE EQUALS
*                                      8, WAIT                       */
*                               THEN/* WAIT FOR STORAGE ALLOCATION.  */
         CH    CRETCODE,@CH00037                                   0730
         BNE   @RF00730                                            0730
*/*  TPWAIT                                                          */
*                                                                  0731
*                               DO; /* BEGIN TPWAIT GENERATION       */
*                                 RFY                              0732
*                                  (GPR01P,                        0732
*                                   GPR14P,                        0732
*                                   GPR15P) RSTD;                  0732
*                                 RFY                              0733
*                                  (GPR00P) RSTD;                  0733
*                                 GEN                              0734
*(STM   GPR00P,GPR15P,RPHWORK(GPR01P))                             0734
*                                 REFS(GPR00P,GPR01P,GPR15P) SETS( 0734
*                                     RPHWORK);                    0734
         STM   GPR00P,GPR15P,RPHWORK(GPR01P)
*                                 RFY                              0735
*                                  (GPR00P) UNRSTD;                0735
*                                 GPR15P=ADDR(LHAA0032);           0736
         LA    GPR15P,LHAA0032                                     0736
*                                 GPR14P=0;                        0737
         SLR   GPR14P,GPR14P                                       0737
*                                 GPR15P=GPR15P&'00FFFFFF'X;       0738
         N     GPR15P,@CF05091                                     0738
*                                 GPR15P=GPR15P|RPHWT1;            0739
         O     GPR15P,@CF01455                                     0739
*                                 CS(GPR14P,GPR15P,GPR01P->RPHRESMA);
         CS    GPR14P,@15,RPHRESMA(GPR01P)                         0740
*                                 BC(7,LHAB0032);                  0741
*                                                                  0741
         BC    7,LHAB0032                                          0741
*/* TPEXIT  NONE                                                     */
*                                                                  0742
*                                 DO;                              0742
*                                   RESPECIFY                      0743
*                                     GPR15P RSTD;                 0743
*                                                                  0743
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTATCVT)                               */
*/* END OF ATBUILD                                                   */
*                                                                  0744
*                                   DO;/* LISATCVT                 0744
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*                                    GPR15P=ATCLCPTR;/* SET UP ATCVT
*                                      POINTER                       */
         L     GPR15P,ATCLCPTR                                     0745
*                                   END;/* LISATCVT                  */
*                                   RESPECIFY                      0747
*                                     GPR00F RSTD;                 0747
*                                   GPR00F=0;/* SET PARAMETER      0748
*                                      REGISTER TO 0                 */
         SLR   GPR00F,GPR00F                                       0748
*                                   GPR15P=GPR15P->ATCAP31;        0749
         L     GPR15P,ATCAP31(,GPR15P)                             0749
*                                   DCL                            0750
*                                     FMZL0037 BASED(GPR15P) LABEL 0750
*                                         VALUERANGE(*);           0750
*                                   CALL FMZL0037;                 0751
         BALR  @14,@15                                             0751
*                                   RESPECIFY                      0752
*                                    (GPR00F,                      0752
*                                     GPR15P) UNRSTD;              0752
*                                 END;/* **** END OF TPEXIT          */
*LHAB0032:                                                         0754
*                                 ;                                0754
LHAB0032 DS    0H                                                  0755
*                                 GPR01P->RPHRESMA=0;              0755
         SLR   @10,@10                                             0755
         ST    @10,RPHRESMA(,GPR01P)                               0755
*                                 RFY                              0756
*                                  (GPR00P) RSTD;                  0756
*LHAA0032:                                                         0757
*                                 ;                                0757
LHAA0032 DS    0H                                                  0758
*                                 GEN                              0758
*(LM    GPR00P,GPR15P,RPHWORK(GPR01P))                             0758
*                                 REFS(RPHWORK,GPR01P) SETS(GPR00P,
*                                     GPR15P);                     0758
         LM    GPR00P,GPR15P,RPHWORK(GPR01P)
*                                 RFY                              0759
*                                  (GPR00P,                        0759
*                                   GPR01P,                        0759
*                                   GPR14P,                        0759
*                                   GPR15P) UNRSTD;                0759
*                               END;/* ****END OF TPWAIT             */
*                             ELSE                                 0761
*                               IF CRETCODE>CEIGHT/* IF RTRN CODE > 8
*                                      THEN                          */
*                                 THEN                             0761
         B     @RC00730                                            0761
@RF00730 CH    CRETCODE,@CH00037                                   0761
         BNH   @RF00761                                            0761
*                                 DO;/* SET ERROR CODES.             */
*                                   OCWRC='24'X;/* - SYSTEM ERROR    */
         MVI   OCWRC(OCWPTR),X'24'                                 0763
*                                   OCWEC='01'X;/* -UNEXPECTED RETURN
*                                      CODE                          */
         MVI   OCWEC(OCWPTR),X'01'                                 0764
*                                 END;                             0765
*                                                                  0765
*                             /***************************************/
*                             /*                                     */
*                             /* IF RTN CODE = 0 OR 4 WE FALL THRU TO*/
*                             /* HERE                                */
*                             /*                                     */
*                             /***************************************/
*                                                                  0766
*                             IF OCWRC=0/* OKAY SO FAR ?             */
*                               THEN                               0766
@RF00761 DS    0H                                                  0766
@RC00730 CLI   OCWRC(OCWPTR),0                                     0766
         BNE   @RF00766                                            0766
*                               DO; /* IF YES, SAVE NCSPL ADDRESS    */
*                                 CPARMR08=RPHSRPRM;/* AND GET STOR.
*                                      FOR NCSPL WORK AREA.          */
         L     CPARMR08,RPHSRPRM(,RPHPTR)                          0768
*/*  GETSTOR SIZE(NCSWASZ)TYPE(PAGEABLE)SAVE(YES)CLEAR(YES)FETCHP(NO)*/
*                                                                  0769
*                                 DO;                              0769
*                                                                  0769
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTATCVT,ISTRPH)                        */
*/* END OF ATBUILD                                                   */
*                                                                  0770
*                                   RFY                            0770
*                                    (GPR00P,                      0770
*                                     GPR01P,                      0770
*                                     GPR02P,                      0770
*                                     GPR03P) RSTD;                0770
*                                   RFY                            0771
*                                     ISTRPH BASED(GPR01P);        0771
*                                   GEN REFS(GPR02P,GPR03P,GPR04P, 0772
*                                       GPR05P,GPR06P,GPR07P,GPR08P,
*                                       GPR09P,GPR10P,GPR11P,GPR12P,
*                                       GPR13P) SETS(RPHWORK);     0772
         STM   GPR02P,GPR13P,RPHWORK(GPR01P)        SAVE REGISTERS
*                                   GPR00F=NCSWASZ;/* SIZE IN REG0   */
         LA    GPR00F,2032                                         0773
*                                   DCL                            0774
*                                     1 CMZA0047 FIXED(31) STATIC LOCAL
*                                         ,                        0774
*                                      2 * FIXED(8) INIT(96),/*    0774
*                                      OPTION FLAGS                  */
*                                      2 * FIXED(8) INIT(96),/*    0774
*                                      STORAGE KEY                   */
*                                      2 * FIXED(8) INIT(241),/*   0774
*                                      SUBPOOL NUMBER                */
*                                      2 * FIXED(8) INIT('00'X);/* 0774
*                                      REQUEST TYPE                  */
*                                   GPR03F=CMZA0047;               0775
         L     GPR03F,CMZA0047                                     0775
*                                   DO;/* LISATCVT                 0776
*                                      CVTBASE(PAGEABLE,(GPR02P))    */
*                                    GPR02P=ATCLCPTR;/* SET UP ATCVT
*                                      POINTER                       */
         L     GPR02P,ATCLCPTR                                     0777
*                                   END;/* LISATCVT                  */
*                                   CALL GPR02P->ATCGTSTR;/* CALL  0779
*                                      ISTORFSR                      */
         L     @15,ATCGTSTR(,GPR02P)                               0779
         BALR  @14,@15                                             0779
*                                   RFY                            0780
*                                    (GPR00P,                      0780
*                                     GPR01P,                      0780
*                                     GPR02P,                      0780
*                                     GPR03P) UNRSTD;              0780
*                                 END;/* END OF GETSTOR      @XM00675*/
*                                 IF CRETCODE=0/* IF GETSTOR OKAY, 0782
*                                      THEN INITIALIZE               */
*                                   THEN/* NCSPL FOR DIAL REQUEST.   */
         LTR   CRETCODE,CRETCODE                                   0782
         BNZ   @RF00782                                            0782
*                                   DO;                            0783
*                                    NCSPLWKA=RPHSRPRM;/* SET NCSPL
*                                      WORK AREA PTR                 */
         L     @10,RPHSRPRM(,GPR01P)                               0784
         ST    @10,NCSPLWKA(,CPARMR08)                             0784
*/*  *************************************************************   */
*/*   FORMAT FIRST PART OF THE NCSPL                                 */
*/*  *************************************************************   */
*                                                                  0785
*                                    NCSPLVCD=NCSPLVC8;/* SET VERB 0785
*                                      CODE = DIAL                   */
         MVI   NCSPLVCD(CPARMR08),X'08'                            0785
*                                    NCSPLVBF=NCSDSTRT;/* MODIFIER =
*                                      DIAL START                    */
         MVC   NCSPLVBF(2,CPARMR08),@CB03138                       0786
*                                    NCSPLWEL=OCWRPH;/* RPH ADDRESS  */
         MVC   NCSPLWEL(4,CPARMR08),OCWRPH(OCWPTR)                 0787
*                                    NCSPLRPT=OCWDRDTE;/* LU RDTE  0788
*                                      POINTER                       */
         MVC   NCSPLRPT(4,CPARMR08),OCWDRDTE(OCWPTR)               0788
*                                    NCSPLCVT=OCWACVT;/* SET VTAM CVT
*                                      POINTER                       */
         MVC   NCSPLCVT(4,CPARMR08),OCWACVT(OCWPTR)                0789
*                                    NCSPLREQ=CON;/* REQSTOR BIT ON
*                                                            @XM00439*/
         OI    NCSPLREQ(CPARMR08),B'00010000'                      0790
*                                    NCSVSTAT=COFF;/* STATIC-DYNAMIC
*                                      FLAG                          */
         NI    NCSVSTAT(CPARMR08),B'11011111'                      0791
*/*  *************************************************************   */
*/*   FORMAT FIRST PART OF THE NCSPL WORK AREA.                      */
*/*  *************************************************************   */
*                                                                  0792
*                                    RFY                           0792
*                                      NCSWKA BASED(NCSPLWKA);/* SET
*                                      WORK AREA MAP BASE            */
*                                    NCSWKAW1=ADDR(NCSWKAW3);/* SET
*                                      WRK AREA STRT PTR             */
         LA    @09,NCSWKAW3(,@10)                                  0793
         ST    @09,NCSWKAW1(,@10)                                  0793
*                                    NCSWKAW2=NCSWASZ;/* SET WK AREA
*                                      LNTH                  @XM00675*/
         MVC   NCSWKAW2(4,@10),@CF03126                            0794
*/*  *************************************************************   */
*/*   TPQUE NCSPL TO VPAB ASSOC WITH HEADER RDT                      */
*/*  *************************************************************   */
*/*  SEGMENT(QNCSPL)REQUEST                                          */
*                                                                  0795
*                                    DO;                           0795
*                                     GOTO QNCSPL;                 0796
         B     QNCSPL                                              0796
*QNCSPL#:                                                          0797
*                                    END;                          0797
*                                                                  0797
QNCSPL#  DS    0H                                                  0798
*/*** START -TPLOCK (VOCLOCK)TYPE(SHARE)- **                         */
*                                                                  0798
*                                    DO;                           0798
*                                     RFY                          0799
*                                      (GPR00P,                    0799
*                                       GPR01P,                    0799
*                                       GPR02P,                    0799
*                                       GPR03P,                    0799
*                                       GPR04P,                    0799
*                                       GPR15P) RSTD;              0799
*                                     GENERATE REFS(GPR00P,GPR01P, 0800
*                                         GPR15P,RPHWORK) SETS(RPHWORK)
*                                         ;                        0800
         STM GPR00P,GPR14P,RPHWORK(GPR01P)
*                                     GPR15P=ATCAP35;/* ADDRESS OF 0801
*                                      LOCK ROUTINE                  */
         L     @10,OCWACVT(,OCWPTR)                                0801
         L     GPR15P,ATCAP35(,@10)                                0801
*                                     GPR02P=ADDR(ATCVOCLK);/* SET 0802
*                                      PARAM - LOCKWORD PTR          */
         LA    GPR02P,ATCVOCLK(,@10)                               0802
*                                     GPR04P=GPR01P->RPHCRR;/* SET 0803
*                                      PARAM - ISTCRA PTR            */
         L     GPR04P,RPHCRR(,GPR01P)                              0803
*                                     GPR00P=CRALMS02;/* SET PARAM -
*                                      LOCK LEVEL FLAG               */
         LA    GPR00P,2                                            0804
*                                     GPR03P=ADDR(GPR04P->CRAL2PTR);
         LA    GPR03P,CRAL2PTR(,GPR04P)                            0805
*                                     /* SET PARAM - LOCK LEVEL PTR  */
*                                     DCL                          0806
*                                       FMZL0066 BASED(GPR15P) LABEL
*                                           VALUERANGE(*);         0806
*                                     CALL FMZL0066;               0807
         BALR  @14,@15                                             0807
*                                     GENERATE REFS(GPR00P,GPR01P, 0808
*                                         GPR14P,RPHWORK) SETS(GPR00P,
*                                         GPR01P,GPR02P,GPR03P,GPR04P,
*                                         GPR05P,GPR06P,GPR07P,GPR08P,
*                                         GPR09P,GPR10P,GPR11P,GPR12P,
*                                         GPR13P,GPR14P,GPR15P);   0808
         LM GPR00P,GPR15P,RPHWORK(GPR01P)
*                                     RFY                          0809
*                                      (GPR00P,                    0809
*                                       GPR01P,                    0809
*                                       GPR02P,                    0809
*                                       GPR03P,                    0809
*                                       GPR04P,                    0809
*                                       GPR15P) UNRSTD;            0809
*                                    END;                          0810
*                                                                  0810
*/*** END -TPLOCK (VOCLOCK)TYPE(SHARE)- **                           */
*                                                                  0811
*                                    IF CRETCODE=0/* IF VOCLOCK    0811
*                                      GOTTEN OKAY,                  */
*                                      THEN                        0811
         LTR   CRETCODE,CRETCODE                                   0811
         BNZ   @RF00811                                            0811
*                                     DO;                          0812
*                                      OCWVLOCK=CON;/* SHOW VOCLOCK
*                                      HELD, AND                     */
*                                                                  0813
         OI    OCWVLOCK(OCWPTR),B'10000000'                        0813
*                                      /******************************/
*                                      /*                            */
*                                      /* ACEVARY INDICATES DIAL     */
*                                      /* OPNDST IN          @ZA19893*/
*                                      /* PROGRESS- VARY DEACT SHOULD*/
*                                      /* NOT GO             @ZA19893*/
*                                      /* VARY PENDING IF ACEVARY IS */
*                                      /* ON.                @ZA19893*/
*                                      /* TURN OFF ACEVARY ON RETURN */
*                                      /* FROM               @ZA19893*/
*                                      /* SSCP POST          @ZA19893*/
*                                      /*                            */
*                                      /******************************/
*                                                                  0814
*                                      IF OCWDRDTE->RPRHDTYP=RPRENTSW
*                                      /*                    @ZA19893*/
*                                        THEN                      0814
         L     @10,OCWDRDTE(,OCWPTR)                               0814
         CLI   RPRHDTYP(@10),X'04'                                 0814
         BNE   @RF00814                                            0814
*                                       OCWDRDTE->RCPACETR->/*     0815
*                                                            @ZA19893*/
*                                           ACEVARY=COFF;/*  @ZA19893*/
         L     @10,RCPACETR(,@10)                                  0815
         NI    ACEVARY(@10),B'11110111'                            0815
*                                      IF OCWRC=0&/* IF NO ERROR FROM
*                                      SSCP,                         */
*                                          OCWEC=0 THEN/* THEN GO TO
*                                      DOENVTST                      */
@RF00814 CLI   OCWRC(OCWPTR),0                                     0816
         BNE   @RF00816                                            0816
         CLI   OCWEC(OCWPTR),0                                     0816
         BNE   @RF00816                                            0816
*                                       DO;/* TST MOVED AFT LOCK   0817
*                                                            @DM13780*/
*                                        CALL DOENVTST;/* GO TO    0818
*                                      DOENVTST TO                   */
         BAL   @14,DOENVTST                                        0818
*                                       END;/* RE-OBTAIN LOCKS.      */
*                                      ELSE                        0820
*                                       ;/*                  @DM13780*/
@RF00816 DS    0H                                                  0821
*                                     END;/*                 @DM13780*/
*                                    ELSE                          0822
*                                     DO;/* IF UNABLE TO GET VOCLOCK */
         B     @RC00811                                            0822
@RF00811 DS    0H                                                  0823
*                                      OCWRC='24'X;/* SET RC = SYS.
*                                      ERROR                         */
         MVI   OCWRC(OCWPTR),X'24'                                 0823
*                                      OCWEC='05'X;/* NO VOCLOCK.    */
         MVI   OCWEC(OCWPTR),X'05'                                 0824
*                                     END;                         0825
*                                   END;                           0826
*                                 ELSE                             0827
*                                   DO;/* IF GETSTOR NOT SUCCESSFUL, */
*                                                                  0827
         B     @RC00782                                            0827
@RF00782 DS    0H                                                  0828
*                                    /********************************/
*                                    /*                              */
*                                    /* RELEASE STORAGE GOTTEN FOR   */
*                                    /* NCSPL. RELSTORE              */
*                                    /* BUFADDR(RPHSRPRM)            */
*                                    /*                              */
*                                    /********************************/
*                                                                  0828
*                                    DO;                           0828
*                                                                  0828
*/* ATBUILD (ISTATCVT,ISTRPH)                                        */
*/* END OF ATBUILD                                                   */
*                                                                  0829
*                                     RFY                          0829
*                                      (GPR02P,                    0829
*                                       GPR03P,                    0829
*                                       GPR04P,                    0829
*                                       GPR15P) RSTD;              0829
*                                     RFY                          0830
*                                      (GPR01P,                    0830
*                                       GPR13P) RSTD;              0830
*                                     GENERATE REFS(GPR01P,GPR02P, 0831
*                                         GPR13P) SETS(RPHWORK);   0831
          STM GPR02P,GPR13P,RPHWORK(GPR01P)
*                                     RFY                          0832
*                                       GPR13P UNRSTD;             0832
*                                     GPR04P=RPHSRPRM;             0833
         L     GPR04P,RPHSRPRM(,GPR01P)                            0833
*                                     DCL                          0834
*                                       1 FMZA0071 FIXED(31) STATIC
*                                             LOCAL,               0834
*                                        2 * FIXED(8) INIT(64),    0834
*                                        2 * PTR(24) INIT(0);      0834
*                                     GPR03F=FMZA0071;             0835
         L     GPR03F,FMZA0071                                     0835
*                                     DO;/* LISATCVT               0836
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*                                      GPR15P=ATCLCPTR;/* SET UP   0837
*                                      ATCVT POINTER                 */
         L     GPR15P,ATCLCPTR                                     0837
*                                     END;/* LISATCVT                */
*                                     GPR02P=GPR15P->ATCBPDA;      0839
         L     GPR02P,ATCBPDA(,GPR15P)                             0839
*                                     GPR15P=GPR15P->ATCSMRS;      0840
         L     GPR15P,ATCSMRS(,GPR15P)                             0840
*                                     DCL                          0841
*                                       FMZL0071 BASED(GPR15P) LABEL
*                                           VALUERANGE(*);         0841
*                                     CALL FMZL0071;               0842
         BALR  @14,@15                                             0842
*                                     RFY                          0843
*                                       GPR13P RSTD;               0843
*                                     GENERATE REFS(GPR01P,RPHWORK)
*                                         SETS(GPR02P,GPR13P);     0844
          LM GPR02P,GPR13P,RPHWORK(GPR01P)
*                                     RFY                          0845
*                                      (GPR01P,                    0845
*                                       GPR13P) UNRSTD;            0845
*                                     RFY                          0846
*                                      (GPR02P,                    0846
*                                       GPR03P,                    0846
*                                       GPR04P,                    0846
*                                       GPR15P) UNRSTD;            0846
*                                    END;/* *********END OF RELSTORE
*                                      EXPANSION*********            */
*                                    OCWRC='14'X;/* SET ERROR CODES-
*                                      TEMP ERR                      */
         MVI   OCWRC(OCWPTR),X'14'                                 0848
*                                    OCWEC='01'X;/* AND NO STORAGE   */
         MVI   OCWEC(OCWPTR),X'01'                                 0849
*                                   END;                           0850
*                               END;                               0851
*                             ELSE                                 0852
*                               ;                                  0852
@RF00766 DS    0H                                                  0853
*                           END;                                   0853
*                         ELSE                                     0854
*                           ;                                      0854
@RF00708 DS    0H                                                  0855
*                       END;                                       0855
*                     ELSE                                         0856
*                       ;                                          0856
@RF00706 DS    0H                                                  0857
*                   END;            /* THIS ENDS LOGICAL SEGMENT D O
*                                      P H Y C O N                   */
@RC00706 DS    0H                                                  0858
*                   OCWNIB=ADDR(OCWDNIB);/* PT TO DUMMY NIB  @D32CKXY*/
         LA    @10,OCWDNIB(,OCWPTR)                                0858
         ST    @10,OCWNIB(,OCWPTR)                                 0858
*                   IF CSLRDTEF=CON&OCWRC=0 THEN                   0859
         TM    CSLRDTEF+40(OCWPTR),B'10000000'                     0859
         BNO   @RF00859                                            0859
         CLI   OCWRC(OCWPTR),0                                     0859
         BNE   @RF00859                                            0859
*                     DO;           /* IF DEST OBT & NO ERR  @D32CKXY*/
*                       CALL ISTOCCFO;/* GET EPT/DVT STRUCTURE BUILT
*                                                            @D32CKXY*/
         L     @15,@CV05116                                        0861
         BALR  @14,@15                                             0861
*                       DO;                                        0862
*                                                                  0862
*/***  CRRMAINT  PROCNM(ISTOCCOE)COMP(OC)FUNC(RET)  **               */
*                                                                  0863
*                         DCL                                      0863
*                           CMZK0087 PTR(31) REG(1);               0863
*                         RFY                                      0864
*                          (CMZK0087) RSTD;                        0864
*                                                                  0864
*/*  ** CLEAR AND SET CURRENT PROCEDURE BIT **                       */
*                                                                  0865
*                         CMZK0087->RPHCRR->CRACRR->OCCCRT='0'B;   0865
         L     @10,RPHCRR(,CMZK0087)                               0865
         L     @10,CRACRR(,@10)                                    0865
         XC    OCCCRT+1(2,@10),OCCCRT+1(@10)                       0865
         MVI   OCCCRT(@10),B'00000000'                             0865
*                         CMZK0087->RPHCRR->CRACRR->COCCOE='1'B;   0866
         OI    COCCOE(@10),B'00010000'                             0866
*                       END;        /*                       @D32CKXY*/
*                       IF CRETCODE=0 THEN                         0868
         LTR   CRETCODE,CRETCODE                                   0868
         BNZ   @RF00868                                            0868
*                         DO;       /* IF EPT/DVT BUILT OK   @D32CKXY*/
*                           CALL ISTOCCFB;/* BUILD CONN CONT BLKS  0870
*                                                            @D32CKXY*/
         L     @15,@CV05118                                        0870
         BALR  @14,@15                                             0870
*                           DO;                                    0871
*                                                                  0871
*/***  CRRMAINT  PROCNM(ISTOCCOE)COMP(OC)FUNC(RET)  **               */
*                                                                  0872
*                             DCL                                  0872
*                               CMZK0088 PTR(31) REG(1);           0872
*                             RFY                                  0873
*                              (CMZK0088) RSTD;                    0873
*                                                                  0873
*/*  ** CLEAR AND SET CURRENT PROCEDURE BIT **                       */
*                                                                  0874
*                             CMZK0088->RPHCRR->CRACRR->OCCCRT='0'B;
         L     @10,RPHCRR(,CMZK0088)                               0874
         L     @10,CRACRR(,@10)                                    0874
         XC    OCCCRT+1(2,@10),OCCCRT+1(@10)                       0874
         MVI   OCCCRT(@10),B'00000000'                             0874
*                             CMZK0088->RPHCRR->CRACRR->COCCOE='1'B;
         OI    COCCOE(@10),B'00010000'                             0875
*                           END;    /*                       @D32CKXY*/
*                           IF CRETCODE^=0 THEN                    0877
         LTR   CRETCODE,CRETCODE                                   0877
         BZ    @RF00877                                            0877
*                             DO;   /* IF FB NOT SUCCESSFUL  @ZA11974*/
*                               CALL ISTOCCRL;/* RELEASE EPT DVT   0879
*                                                            @ZA11974*/
         L     @15,@CV05120                                        0879
         BALR  @14,@15                                             0879
*                               DO;                                0880
*                                                                  0880
*/***  CRRMAINT  PROCNM(ISTOCCOE)COMP(OC)FUNC(RET)  **               */
*                                                                  0881
*                                 DCL                              0881
*                                   CMZK0089 PTR(31) REG(1);       0881
*                                 RFY                              0882
*                                  (CMZK0089) RSTD;                0882
*                                                                  0882
*/*  ** CLEAR AND SET CURRENT PROCEDURE BIT **                       */
*                                                                  0883
*                                 CMZK0089->RPHCRR->CRACRR->OCCCRT='0'B
*                                     ;                            0883
         L     @10,RPHCRR(,CMZK0089)                               0883
         L     @10,CRACRR(,@10)                                    0883
         XC    OCCCRT+1(2,@10),OCCCRT+1(@10)                       0883
         MVI   OCCCRT(@10),B'00000000'                             0883
*                                 CMZK0089->RPHCRR->CRACRR->COCCOE='1'B
*                                     ;                            0884
         OI    COCCOE(@10),B'00010000'                             0884
*                               END;/*                       @ZA11974*/
*                             END;  /* END FOR FB NOT SUCC   @ZA11974*/
*                           ELSE                                   0887
*                             DO;   /* GOOD RC FROM FB       @ZA11974*/
         B     @RC00877                                            0887
@RF00877 DS    0H                                                  0888
*                               OCWSAF=FMCSAF;/* SAVE SAF IN OCWCID
*                                                            @D32CKXY*/
         L     @10,OCWFMCB(,OCWPTR)                                0888
         MVC   OCWSAF(2,OCWPTR),FMCSAF(@10)                        0888
*                               OCWDAF=NCBDAF;/* SAVE DAF IN OCWCID
*                                                            @D32CKXY*/
         L     @10,OCWNCB(,OCWPTR)                                 0889
         MVC   OCWDAF(2,OCWPTR),NCBDAF(@10)                        0889
*                               IF OCWDSTNO>1 THEN                 0890
         LH    @10,OCWDSTNO(,OCWPTR)                               0890
         CH    @10,@CH00068                                        0890
         BNH   @RF00890                                            0890
*                                 OCWODNAS->SORTCID=OCWCID;/* SAVE 0891
*                                      CID IN SORT SLOT      @D32CKXY*/
         L     @10,OCWODNAS(,OCWPTR)                               0891
         MVC   SORTCID(4,@10),OCWCID(OCWPTR)                       0891
*                               ELSE                               0892
*                                 ; /*                       @D32CKXY*/
@RF00890 DS    0H                                                  0893
*                               CALL DOSTCTL;/* DRIVE NTWK MGT IF  0893
*                                      NEC@D32CKXY                   */
         BAL   @14,DOSTCTL                                         0893
*                             END;  /* END GOOD RC FROM FB   @ZA11974*/
*                         END;      /* END DO BEF W/FB CALL  @D32CKXY*/
*                       ELSE                                       0896
*                         ;         /* WHEN FO CALL UNSUCC   @D32CKXY*/
@RF00868 DS    0H                                                  0897
*                     END;          /* END DO BEG W/FO CALL  @D32CKXY*/
*                   ELSE                                           0898
*                     ;             /* WHEN DOPHYCON FAILS   @D32CKXY*/
@RF00859 DS    0H                                                  0899
*                 END;              /* END DO AFT DOENVTST   @D32CKXY*/
*               ELSE                                               0900
*                 ;                 /* WHEN DOENVTST FAILS   @D32CKXY*/
@RF00701 DS    0H                                                  0901
*             END;                  /* END DO FOR VALID NIB  @D32CKXY*/
*           ELSE                                                   0902
*             ;                     /* WHEN DOVALINT FAILS   @D32CKXY*/
@RF00698 DS    0H                                                  0903
*         END;                      /* END DO FOR DEST OBT   @D32CKXY*/
*       ELSE                                                       0904
*         ;                         /* IF DEST NEVER OBT     @D32CKXY*/
@RF00694 DS    0H                                                  0905
*       IF OCWELOCK=CON THEN                                       0905
@RC00694 TM    OCWELOCK(OCWPTR),B'00100000'                        0905
         BNO   @RF00905                                            0905
*         DO;                       /* IF RDTE ENTRY LOCK HELD     0906
*                                                            @D32CKXY*/
*/*** START -TPUNLOCK (OCLOCK)- **                                   */
*                                                                  0907
*           DO;                                                    0907
*                                                                  0907
*/* ATBUILD (ISTRPH,ISTLOK,ISTCRA)                                   */
*/* END OF ATBUILD                                                   */
*                                                                  0908
*             RFY                                                  0908
*              (GPR00P,                                            0908
*               GPR01P,                                            0908
*               GPR02P,                                            0908
*               GPR03P,                                            0908
*               GPR04P,                                            0908
*               GPR15P) RSTD;                                      0908
*             GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(RPHWORK)
*                 ;                                                0909
         STM GPR00P,GPR15P,RPHWORK(GPR01P)
*             GPR02P=ADDR(RPRRLOCK);/* SET PARAM - LOCKWORD PTR      */
         L     GPR02P,OCWDRDTE(,OCWPTR)                            0910
         LA    GPR02P,RPRRLOCK(,GPR02P)                            0910
*             GPR04P=GPR01P->RPHCRR;/* SET PARAM - ISTCRA PTR        */
         L     GPR04P,RPHCRR(,GPR01P)                              0911
*             GPR00P=CRALMS04;      /* SET PARAM - LOCK LEVEL FLAG   */
         LA    GPR00P,8                                            0912
*             GPR03P=ADDR(GPR04P->CRAL4PTR);/* SET PARAM - LOCK LEVEL
*                                      PTR                           */
         LA    GPR03P,CRAL4PTR(,GPR04P)                            0913
*             DO;                   /* LISATCVT                    0914
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*               GPR15P=ATCLCPTR;    /* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     0915
*             END;                  /* LISATCVT                      */
*             GPR15P=GPR15P->ATCAP33;                              0917
         L     GPR15P,ATCAP33(,GPR15P)                             0917
*             DCL                                                  0918
*               FMZL0090 BASED(GPR15P) LABEL VALUERANGE(*);        0918
*             CALL FMZL0090;                                       0919
         BALR  @14,@15                                             0919
*             GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(GPR00P,
*                 GPR01P,GPR02P,GPR03P,GPR04P,GPR05P,GPR06P,GPR07P,
*                 GPR08P,GPR09P,GPR10P,GPR11P,GPR12P,GPR13P,GPR14P,
*                 GPR15P);                                         0920
         LM GPR00P,GPR15P,RPHWORK(GPR01P)
*             RFY                                                  0921
*              (GPR00P,                                            0921
*               GPR01P,                                            0921
*               GPR02P,                                            0921
*               GPR03P,                                            0921
*               GPR04P,                                            0921
*               GPR15P) UNRSTD;                                    0921
*           END;                                                   0922
*                                                                  0922
*/*** END -TPUNLOCK (OCLOCK)- **                                     */
*                                                                  0923
*                                   /* REL RDTE LOCK         @D32CKXY*/
*           OCWELOCK=COFF;          /* INDIC LOCK NOT HELD   @D32CKXY*/
         NI    OCWELOCK(OCWPTR),B'11011111'                        0923
*         END;                      /* END DO FOR UNLOCK     @D32CKXY*/
*       ELSE                                                       0925
*         ;                         /*                       @D32CKXY*/
@RF00905 DS    0H                                                  0926
*       RFY                                                        0926
*         NTRYPTR RSTD;             /*                       @D32CKXY*/
*       NTRYPTR=OCWODLST+(OCWODCT1*LENGTH(ISTCSL));/* PT TO LIST   0927
*                                      ENTRY                 @D32CKXY*/
         LH    @10,OCWODCT1(,OCWPTR)                               0927
         LR    NTRYPTR,@10                                         0927
         MH    NTRYPTR,@CH00033                                    0927
         AL    NTRYPTR,OCWODLST(,OCWPTR)                           0927
*       NTRYPTR->CSLRDEF=CSLRDEF;   /* SAVE CHGS TO OCWDRDTE IN LIST
*                                      ENTRY'S RDTE          @D32CKXY*/
         MVC   CSLRDEF(4,NTRYPTR),CSLRDEF+40(OCWPTR)               0928
*       RFY                                                        0929
*         NTRYPTR UNRSTD;           /*                       @D32CKXY*/
*       OCWODCT1=OCWODCT1+1;        /* INCREMENT LOOP CTR    @D32CKXY*/
         AH    @10,@CH00068                                        0930
         STH   @10,OCWODCT1(,OCWPTR)                               0930
*       OCWODNAS=OCWODNAS+4;        /* PT TO NEXT SORT SLOT  @D32CKXY*/
         LA    @10,4                                               0931
         AL    @10,OCWODNAS(,OCWPTR)                               0931
         ST    @10,OCWODNAS(,OCWPTR)                               0931
*     END;                          /* END DO WHILE          @D32CKXY*/
@DE00683 LH    @10,OCWODCT1(,OCWPTR)                               0932
         CH    @10,OCWDSTNO(,OCWPTR)                               0932
         BNL   @DC00683                                            0932
         CLI   OCWRC(OCWPTR),0                                     0932
         BE    @DL00683                                            0932
@DC00683 DS    0H                                                  0933
*   END DOFNCOB;                    /*                       @D32CKXY*/
*   IF OCWRC=0 THEN                                                0934
         CLI   OCWRC(OCWPTR),0                                     0934
         BNE   @RF00934                                            0934
*     DO;                           /* IF OK SO FAR          @D32CKXY*/
*       IF OCWVLOCK=CON THEN                                       0936
         TM    OCWVLOCK(OCWPTR),B'10000000'                        0936
         BNO   @RF00936                                            0936
*         DO;                       /* IF VOC LOCK HELD      @D32CKXY*/
*/*** START -TPUNLOCK (VOCLOCK)- **                                  */
*                                                                  0938
*           DO;                                                    0938
*                                                                  0938
*/* ATBUILD (ISTRPH,ISTLOK,ISTCRA)                                   */
*/* END OF ATBUILD                                                   */
*                                                                  0939
*             RFY                                                  0939
*              (GPR00P,                                            0939
*               GPR01P,                                            0939
*               GPR02P,                                            0939
*               GPR03P,                                            0939
*               GPR04P,                                            0939
*               GPR15P) RSTD;                                      0939
*             GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(RPHWORK)
*                 ;                                                0940
         STM GPR00P,GPR15P,RPHWORK(GPR01P)
*             GPR02P=ADDR(ATCVOCLK);/* SET PARAM - LOCKWORD PTR      */
         L     GPR02P,OCWACVT(,OCWPTR)                             0941
         LA    GPR02P,ATCVOCLK(,GPR02P)                            0941
*             GPR04P=GPR01P->RPHCRR;/* SET PARAM - ISTCRA PTR        */
         L     GPR04P,RPHCRR(,GPR01P)                              0942
*             GPR00P=CRALMS02;      /* SET PARAM - LOCK LEVEL FLAG   */
         LA    GPR00P,2                                            0943
*             GPR03P=ADDR(GPR04P->CRAL2PTR);/* SET PARAM - LOCK LEVEL
*                                      PTR                           */
         LA    GPR03P,CRAL2PTR(,GPR04P)                            0944
*             DO;                   /* LISATCVT                    0945
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*               GPR15P=ATCLCPTR;    /* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     0946
*             END;                  /* LISATCVT                      */
*             GPR15P=GPR15P->ATCAP33;                              0948
         L     GPR15P,ATCAP33(,GPR15P)                             0948
*             DCL                                                  0949
*               FMZL0100 BASED(GPR15P) LABEL VALUERANGE(*);        0949
*             CALL FMZL0100;                                       0950
         BALR  @14,@15                                             0950
*             GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(GPR00P,
*                 GPR01P,GPR02P,GPR03P,GPR04P,GPR05P,GPR06P,GPR07P,
*                 GPR08P,GPR09P,GPR10P,GPR11P,GPR12P,GPR13P,GPR14P,
*                 GPR15P);                                         0951
         LM GPR00P,GPR15P,RPHWORK(GPR01P)
*             RFY                                                  0952
*              (GPR00P,                                            0952
*               GPR01P,                                            0952
*               GPR02P,                                            0952
*               GPR03P,                                            0952
*               GPR04P,                                            0952
*               GPR15P) UNRSTD;                                    0952
*           END;                                                   0953
*                                                                  0953
*/*** END -TPUNLOCK (VOCLOCK)- **                                    */
*                                                                  0954
*                                   /* UNLOCK VOC LOCK       @D32CKXY*/
*           OCWVLOCK=COFF;          /* SHOW VOCLOCK NOT HELD@D32CKXY */
         NI    OCWVLOCK(OCWPTR),B'01111111'                        0954
*         END;                      /*                       @D32CKXY*/
*       ELSE                                                       0956
*         ;                         /* VOC LOCK NOT OWNED    @D32CKXY*/
@RF00936 DS    0H                                                  0957
*       IF OCWRLOCK=CON THEN                                       0957
         TM    OCWRLOCK(OCWPTR),B'01000000'                        0957
         BNO   @RF00957                                            0957
*         DO;                       /* IF RDT LOCK HELD      @D32CKXY*/
*/*** START -TPUNLOCK (RDTLOCK)- **                                  */
*                                                                  0959
*           DO;                                                    0959
*                                                                  0959
*/* ATBUILD (ISTRPH,ISTLOK,ISTCRA)                                   */
*/* END OF ATBUILD                                                   */
*                                                                  0960
*             RFY                                                  0960
*              (GPR00P,                                            0960
*               GPR01P,                                            0960
*               GPR02P,                                            0960
*               GPR03P,                                            0960
*               GPR04P,                                            0960
*               GPR15P) RSTD;                                      0960
*             GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(RPHWORK)
*                 ;                                                0961
         STM GPR00P,GPR15P,RPHWORK(GPR01P)
*             GPR02P=ADDR(ATCRDTLK);/* SET PARAM - LOCKWORD PTR      */
         L     GPR02P,OCWACVT(,OCWPTR)                             0962
         LA    GPR02P,ATCRDTLK(,GPR02P)                            0962
*             GPR04P=GPR01P->RPHCRR;/* SET PARAM - ISTCRA PTR        */
         L     GPR04P,RPHCRR(,GPR01P)                              0963
*             GPR00P=CRALMS03;      /* SET PARAM - LOCK LEVEL FLAG   */
         LA    GPR00P,4                                            0964
*             GPR03P=ADDR(GPR04P->CRAL3PTR);/* SET PARAM - LOCK LEVEL
*                                      PTR                           */
         LA    GPR03P,CRAL3PTR(,GPR04P)                            0965
*             DO;                   /* LISATCVT                    0966
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*               GPR15P=ATCLCPTR;    /* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     0967
*             END;                  /* LISATCVT                      */
*             GPR15P=GPR15P->ATCAP33;                              0969
         L     GPR15P,ATCAP33(,GPR15P)                             0969
*             DCL                                                  0970
*               FMZL0110 BASED(GPR15P) LABEL VALUERANGE(*);        0970
*             CALL FMZL0110;                                       0971
         BALR  @14,@15                                             0971
*             GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(GPR00P,
*                 GPR01P,GPR02P,GPR03P,GPR04P,GPR05P,GPR06P,GPR07P,
*                 GPR08P,GPR09P,GPR10P,GPR11P,GPR12P,GPR13P,GPR14P,
*                 GPR15P);                                         0972
         LM GPR00P,GPR15P,RPHWORK(GPR01P)
*             RFY                                                  0973
*              (GPR00P,                                            0973
*               GPR01P,                                            0973
*               GPR02P,                                            0973
*               GPR03P,                                            0973
*               GPR04P,                                            0973
*               GPR15P) UNRSTD;                                    0973
*           END;                                                   0974
*                                                                  0974
*/*** END -TPUNLOCK (RDTLOCK)- **                                    */
*                                                                  0975
*                                   /* UNLOCK RDT LOCK       @D32CKXY*/
*           OCWRLOCK=COFF;          /* SHOW RDTLOCK NOT HELD@D32CKXY */
         NI    OCWRLOCK(OCWPTR),B'10111111'                        0975
*         END;                      /*                       @D32CKXY*/
*       ELSE                                                       0977
*         ;                         /* RDT LOCK NOT OWNED    @D32CKXY*/
@RF00957 DS    0H                                                  0978
*     END;                          /* END DO TO REL LOCKS   @D32CKXY*/
*   ELSE                                                           0979
*     ;                             /* BAD RC AFTER DOFNCOB  @D32CKXY*/
@RF00934 DS    0H                                                  0980
*   IF OCWRC=0 THEN                                                0980
         CLI   OCWRC(OCWPTR),0                                     0980
         BNE   @RF00980                                            0980
*     DO;                           /* IF SUCCESSFUL SO FAR  @D32CKXY*/
*/********************************************************************/
*/*  ROUTINE NAME: DOIOLP                                            */
*/*  FUNCTION:                                                       */
*/*       THIS ROUTINE IS INCLUDED BY THE MAINLINE TO PERFORM        */
*/*       ANY IO THAT IS REQUIRED WITHOUT ANY LOCKS                  */
*/*  ROUTINES CALLED:                                                */
*/*       DOVALINT - VALIDATES, COPIES & MERGES NIB                  */
*/*       DOCONCT  - DOES BIND, SDT FOR LU                           */
*/*       DONIBFIL - FILLS IN COPY OF USER'S NIB                     */
*/*  MACROS USED:                                                    */
*/*       TPLOCK   - OBTAINS VOC & RDT LOCKS                         */
*/********************************************************************/
*                                                                  0982
*DOIOLP:                                                           0982
*       DO;                         /* NEW FOR BIND INTRLCK  @D32CKXY*/
DOIOLP   DS    0H                                                  0983
*         OCWODCT1=0;               /* INITIALIZE LOOP CTR   @D32CKXY*/
         SLR   @10,@10                                             0983
         STH   @10,OCWODCT1(,OCWPTR)                               0983
*         OCWODNAS=OCWODLST;        /* PT TO FIRST LST NTRY  @D32CKXY*/
         MVC   OCWODNAS(4,OCWPTR),OCWODLST(OCWPTR)                 0984
*         DO WHILE OCWODCT1<OCWDSTNO&OCWRC=0;/* LOOP UNTIL ALL RDTES
*                                      ARE PROC OR AN ERR    @D32CKXY*/
         B     @DE00985                                            0985
@DL00985 DS    0H                                                  0986
*           CSLRDEF=OCWODNAS->CSLRDEF;/* COPY ENTRY'S RDTE PTR TO  0986
*                                      OCWDRDTE              @D32CKXY*/
         LA    @10,40                                              0986
         ALR   @10,OCWPTR                                          0986
         L     @09,OCWODNAS(,OCWPTR)                               0986
         MVC   CSLRDEF(4,@10),CSLRDEF(@09)                         0986
*           IF CSLRDTEF=CON THEN                                   0987
         TM    CSLRDTEF(@10),B'10000000'                           0987
         BNO   @RF00987                                            0987
*             DO;                   /* IF DEST EXISTS        @D32CKXY*/
*               CSLNDEF=OCWODNAS->CSLNDEF;/* COPY ENTRY'S NIB PTR  0989
*                                      INTO OCWNIB           @D32CKXY*/
         MVC   CSLNDEF(4,@10),CSLNDEF(@09)                         0989
*               CPARMRG0=1;         /* INDICATE COPY FUNCTN  @D32CKXY*/
         LA    CPARMRG0,1                                          0990
*               CALL DOVALINT;      /* VALIDATE & COPY NIB   @D32CKXY*/
         BAL   @14,DOVALINT                                        0991
*               IF OCWRC=0 THEN                                    0992
         CLI   OCWRC(OCWPTR),0                                     0992
         BNE   @RF00992                                            0992
*                 DO;               /* IF NIB VALID          @D32CKXY*/
*                                                                  0993
*                   /*************************************************/
*                   /*                                               */
*                   /* SEGMENT(DOCONCT)REQUEST                       */
*                   /*                                               */
*                   /*************************************************/
*                                                                  0994
*                   DO;                                            0994
*                     GOTO DOCONCT;                                0995
         B     DOCONCT                                             0995
*DOCONCT#:                                                         0996
*                   END;            /* BIND SESSION          @D32CKXY*/
DOCONCT# DS    0H                                                  0997
*                   IF OCWRC=0&CSLRDTEF=CON THEN                   0997
         CLI   OCWRC(OCWPTR),0                                     0997
         BNE   @RF00997                                            0997
         TM    CSLRDTEF+40(OCWPTR),B'10000000'                     0997
         BNO   @RF00997                                            0997
*                     DO;           /* IF DEST GOOD & NO ERR@D32CKXY */
*                       CALL DONIBFIL;/* FILL IN NIB COPY    @D32CKXY*/
         BAL   @14,DONIBFIL                                        0999
*                       CPARMRG0=-1;/* INDICATE MERGE FUNC   @D32CKXY*/
         SLR   CPARMRG0,CPARMRG0                                   1000
         BCTR  CPARMRG0,0                                          1000
*                       CALL DOVALINT;/* MERGE NIB           @D32CKXY*/
         BAL   @14,DOVALINT                                        1001
*                     END;          /* END DO TO MERGE NIB   @D32CKXY*/
*                   ELSE                                           1003
*                     ;             /* WHEN BIND UNSUCC      @D32CKXY*/
@RF00997 DS    0H                                                  1004
*                 END;              /* END DO TO BIND SESS   @D32CKXY*/
*               ELSE                                               1005
*                 ;                 /* WHEN NO CALL TO BIND  @D32CKXY*/
@RF00992 DS    0H                                                  1006
*             END;                  /* END DO FOR GOOD DEST  @D32CKXY*/
*           ELSE                                                   1007
*             ;                     /* WHEN DEST IS BAD      @D32CKXY*/
@RF00987 DS    0H                                                  1008
*           OCWODNAS->CSLRDEF=CSLRDEF;/* SAVE CHGS TO OCWDRDTE IN  1008
*                                      LIST ENTRY'S RDTE     @DM14304*/
         L     @10,OCWODNAS(,OCWPTR)                               1008
         MVC   CSLRDEF(4,@10),CSLRDEF+40(OCWPTR)                   1008
*           OCWODNAS=OCWODNAS+LENGTH(ISTCSL);/* PT TO NXT LST ENTRY
*                                                            @D32CKXY*/
         AH    @10,@CH00033                                        1009
         ST    @10,OCWODNAS(,OCWPTR)                               1009
*           OCWODCT1=OCWODCT1+1;    /* INCREMENT LOOP CTR    @D32CKXY*/
         LA    @10,1                                               1010
         AH    @10,OCWODCT1(,OCWPTR)                               1010
         STH   @10,OCWODCT1(,OCWPTR)                               1010
*         END;                      /* END DO WHILE          @D32CKXY*/
@DE00985 LH    @10,OCWODCT1(,OCWPTR)                               1011
         CH    @10,OCWDSTNO(,OCWPTR)                               1011
         BNL   @DC00985                                            1011
         CLI   OCWRC(OCWPTR),0                                     1011
         BE    @DL00985                                            1011
@DC00985 DS    0H                                                  1012
*         IF OCWVLOCK=CON THEN                                     1012
         TM    OCWVLOCK(OCWPTR),B'10000000'                        1012
         BO    @RT01012                                            1012
*           ;                       /* IF VOC LOCK HELD      @D32CKXY*/
*         ELSE                                                     1014
*           DO;                     /* OTHERWISE OBT LOCK    @D32CKXY*/
*/*** START -TPLOCK (VOCLOCK)TYPE(SHARE)- **                         */
*                                                                  1015
*             DO;                                                  1015
*               RFY                                                1016
*                (GPR00P,                                          1016
*                 GPR01P,                                          1016
*                 GPR02P,                                          1016
*                 GPR03P,                                          1016
*                 GPR04P,                                          1016
*                 GPR15P) RSTD;                                    1016
*               GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(  1017
*                   RPHWORK);                                      1017
         STM GPR00P,GPR14P,RPHWORK(GPR01P)
*               GPR15P=ATCAP35;     /* ADDRESS OF LOCK ROUTINE       */
         L     @10,OCWACVT(,OCWPTR)                                1018
         L     GPR15P,ATCAP35(,@10)                                1018
*               GPR02P=ADDR(ATCVOCLK);/* SET PARAM - LOCKWORD PTR    */
         LA    GPR02P,ATCVOCLK(,@10)                               1019
*               GPR04P=GPR01P->RPHCRR;/* SET PARAM - ISTCRA PTR      */
         L     GPR04P,RPHCRR(,GPR01P)                              1020
*               GPR00P=CRALMS02;    /* SET PARAM - LOCK LEVEL FLAG   */
         LA    GPR00P,2                                            1021
*               GPR03P=ADDR(GPR04P->CRAL2PTR);/* SET PARAM - LOCK  1022
*                                      LEVEL PTR                     */
         LA    GPR03P,CRAL2PTR(,GPR04P)                            1022
*               DCL                                                1023
*                 FMZL0121 BASED(GPR15P) LABEL VALUERANGE(*);      1023
*               CALL FMZL0121;                                     1024
         BALR  @14,@15                                             1024
*               GENERATE REFS(GPR00P,GPR01P,GPR14P,RPHWORK) SETS(GPR00P
*                   ,GPR01P,GPR02P,GPR03P,GPR04P,GPR05P,GPR06P,GPR07P,
*                   GPR08P,GPR09P,GPR10P,GPR11P,GPR12P,GPR13P,GPR14P,
*                   GPR15P);                                       1025
         LM GPR00P,GPR15P,RPHWORK(GPR01P)
*               RFY                                                1026
*                (GPR00P,                                          1026
*                 GPR01P,                                          1026
*                 GPR02P,                                          1026
*                 GPR03P,                                          1026
*                 GPR04P,                                          1026
*                 GPR15P) UNRSTD;                                  1026
*             END;                                                 1027
*                                                                  1027
*/*** END -TPLOCK (VOCLOCK)TYPE(SHARE)- **                           */
*                                                                  1028
*                                   /* OBT VOC LOCK SHARED   @D32CKXY*/
*             IF CRETCODE=0 THEN                                   1028
         LTR   CRETCODE,CRETCODE                                   1028
         BNZ   @RF01028                                            1028
*               OCWVLOCK=CON;       /* INDICATE LOCK HELD    @D32CKXY*/
         OI    OCWVLOCK(OCWPTR),B'10000000'                        1029
*             ELSE                                                 1030
*               DO;                 /*                       @D32CKXY*/
         B     @RC01028                                            1030
@RF01028 DS    0H                                                  1031
*                 OCWRC='24'X;      /* SYSTEM ERROR          @D32CKXY*/
         MVI   OCWRC(OCWPTR),X'24'                                 1031
*                 OCWEC='05'X;      /* PROC LOCK NOT HELD    @D32CKXY*/
         MVI   OCWEC(OCWPTR),X'05'                                 1032
*               END;                /*                       @D32CKXY*/
*           END;                    /* END DO FOR VOC LOCK   @D32CKXY*/
@RC01028 DS    0H                                                  1035
*         IF OCWRC='24'X THEN                                      1035
@RT01012 CLI   OCWRC(OCWPTR),X'24'                                 1035
         BE    @RT01035                                            1035
*           ;                       /* IF SYSTEM ERROR       @D32CKXY*/
*         ELSE                                                     1037
*           DO;                     /* OBT RDT LOCK          @D32CKXY*/
*             IF OCWRLOCK=CON THEN                                 1038
         TM    OCWRLOCK(OCWPTR),B'01000000'                        1038
         BO    @RT01038                                            1038
*               ;                   /* IF RDT LOCK HELD      @D32CKXY*/
*             ELSE                                                 1040
*               DO;                 /* OTHERWISE OBT LOCK    @D32CKXY*/
*/*** START -TPLOCK (RDTLOCK)TYPE(XCLSIVE)- **                       */
*                                                                  1041
*                 DO;                                              1041
*                   RFY                                            1042
*                    (GPR00P,                                      1042
*                     GPR01P,                                      1042
*                     GPR02P,                                      1042
*                     GPR03P,                                      1042
*                     GPR04P,                                      1042
*                     GPR15P) RSTD;                                1042
*                   GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(
*                       RPHWORK);                                  1043
         STM GPR00P,GPR14P,RPHWORK(GPR01P)
*                   GPR15P=ATCAP36; /* ADDRESS OF LOCK ROUTINE       */
         L     @10,OCWACVT(,OCWPTR)                                1044
         L     GPR15P,ATCAP36(,@10)                                1044
*                   GPR02P=ADDR(ATCRDTLK);/* SET PARAM - LOCKWORD PTR*/
         LA    GPR02P,ATCRDTLK(,@10)                               1045
*                   GPR04P=GPR01P->RPHCRR;/* SET PARAM - ISTCRA PTR  */
         L     GPR04P,RPHCRR(,GPR01P)                              1046
*                   GPR00P=CRALMS03;/* SET PARAM - LOCK LEVEL FLAG   */
         LA    GPR00P,4                                            1047
*                   GPR03P=ADDR(GPR04P->CRAL3PTR);/* SET PARAM - LOCK
*                                      LEVEL PTR                     */
         LA    GPR03P,CRAL3PTR(,GPR04P)                            1048
*                   DCL                                            1049
*                     FMZL0126 BASED(GPR15P) LABEL VALUERANGE(*);  1049
*                   CALL FMZL0126;                                 1050
         BALR  @14,@15                                             1050
*                   GENERATE REFS(GPR00P,GPR01P,GPR14P,RPHWORK) SETS(
*                       GPR00P,GPR01P,GPR02P,GPR03P,GPR04P,GPR05P, 1051
*                       GPR06P,GPR07P,GPR08P,GPR09P,GPR10P,GPR11P, 1051
*                       GPR12P,GPR13P,GPR14P,GPR15P);              1051
         LM GPR00P,GPR15P,RPHWORK(GPR01P)
*                   RFY                                            1052
*                    (GPR00P,                                      1052
*                     GPR01P,                                      1052
*                     GPR02P,                                      1052
*                     GPR03P,                                      1052
*                     GPR04P,                                      1052
*                     GPR15P) UNRSTD;                              1052
*                 END;                                             1053
*                                                                  1053
*/*** END -TPLOCK (RDTLOCK)TYPE(XCLSIVE)- **                         */
*                                                                  1054
*                                   /*                       @D32CKXY*/
*                 IF CRETCODE=0 THEN                               1054
         LTR   CRETCODE,CRETCODE                                   1054
         BNZ   @RF01054                                            1054
*                   OCWRLOCK=CON;   /* INDICATE LOCK HELD    @D32CKXY*/
         OI    OCWRLOCK(OCWPTR),B'01000000'                        1055
*                 ELSE                                             1056
*                   DO;                                            1056
         B     @RC01054                                            1056
@RF01054 DS    0H                                                  1057
*                     OCWRC='24'X;  /* SYSTEM ERROR          @D32CKXY*/
         MVI   OCWRC(OCWPTR),X'24'                                 1057
*                     OCWEC='06'X;  /* RDT LOCK NOT HELD     @D32CKXY*/
         MVI   OCWEC(OCWPTR),X'06'                                 1058
*                   END;            /*                       @D32CKXY*/
*               END;                /* END DO FOR RDT LOCK   @D32CKXY*/
@RC01054 DS    0H                                                  1061
*           END;                    /* END DO IF NO SYS ERR  @D32CKXY*/
@RT01038 DS    0H                                                  1062
*       END DOIOLP;                 /*                       @D32CKXY*/
@RT01035 DS    0H                                                  1063
*     END;                          /*                       @D32CKXY*/
*   ELSE                                                           1064
*     ;                             /* BAD RC AFTER DOIOLP   @D32CKXY*/
@RF00980 DS    0H                                                  1065
*                                                                  1065
*/********************************************************************/
*/*  ROUTINE NAME: DOBINFL                                           */
*/*  FUNCTION:                                                       */
*/*       THIS ROUTINE IS INCLUDED BY THE MAINLINE. IT SENDS A BIND  */
*/*       FAILURE NCSPL IF NECESSARY                                 */
*/*  ROUTINES CALLED:                                                */
*/*       CONERR  - BUILDS AND SENDS BIND FAILURE NCSPL              */
*/*  MACROS USED:                                                    */
*/*       CIDCTL  - FIND TO LOCATE RDTE                              */
*/********************************************************************/
*                                                                  1065
*DOBINFL:                                                          1065
*   DO;                             /* NEW FOR BIND INTRLCK  @D32CKXY*/
DOBINFL  DS    0H                                                  1066
*     RFY                                                          1066
*       ISTCSL BASED(OCWODNAS);     /* CSL LOC AT LST NTRY   @D32CKXY*/
*     IF OCWRC^='24'X THEN                                         1067
         CLI   OCWRC(OCWPTR),X'24'                                 1067
         BE    @RF01067                                            1067
*       DO;                         /* PROCEED IF THERE IS NOT A   1068
*                                      SYSTEM ERROR          @D32CKXY*/
*         OCWODCT1=0;               /* INIT LOOP CTR         @D32CKXY*/
         SLR   @10,@10                                             1069
         STH   @10,OCWODCT1(,OCWPTR)                               1069
*         OCWODNAS=OCWODLST;        /* PT TO FIRST LST NTRY  @D32CKXY*/
         L     @10,OCWODLST(,OCWPTR)                               1070
         ST    @10,OCWODNAS(,OCWPTR)                               1070
*         RFY                                                      1071
*           SORTPTR RSTD;           /*                       @D32CKXY*/
*         IF OCWDSTNO>1 THEN                                       1072
         LH    @09,OCWDSTNO(,OCWPTR)                               1072
         CH    @09,@CH00068                                        1072
         BNH   @RF01072                                            1072
*           SORTPTR=OCWODLST+(OCWDSTNO*LENGTH(ISTCSL));/* LOCATE   1073
*                                      FIRST SORT SLOT FOR LIST    1073
*                                      REQUEST               @D32CKXY*/
         MH    @09,@CH00033                                        1073
         ALR   @10,@09                                             1073
         LR    SORTPTR,@10                                         1073
*         ELSE                                                     1074
*           SORTPTR=ADDR(OCWCID);   /* PT TO SORT SLOT FOR SINGLE  1074
*                                      DEST REQUEST          @D32CKXY*/
         B     @RC01072                                            1074
@RF01072 LA    SORTPTR,OCWCID(,OCWPTR)                             1074
*         DO WHILE OCWODCT1<OCWDSTNO;/* INIT LOOP CTR        @D32CKXY*/
@RC01072 B     @DE01075                                            1075
@DL01075 DS    0H                                                  1076
*           OCWDRDTE=CSLRDEF;       /* SETUP RDTE PTR IN OCW BEFORE
*                                      CALL TO DORUTHER      @D32CKXY*/
         L     @10,OCWODNAS(,OCWPTR)                               1076
         MVC   OCWDRDTE(4,OCWPTR),CSLRDEF(@10)                     1076
*           IF CSLRDTEB=CON         /* IF BIND FAIL SET - NOT TURNED */
*             THEN                                                 1077
         TM    CSLRDTEB(@10),B'01000000'                           1077
         BNO   @RF01077                                            1077
*             DO;                   /* OFF BY DORUTHER       @D32CKXY*/
*               IF SORTPTR->SORTCID^=0 THEN                        1079
         ICM   @10,15,SORTCID(SORTPTR)                             1079
         BNZ   @RT01079                                            1079
*                 ;                 /* IF A CID EXISTS TO LOCATE THE
*                                      RDTE                  @D32CKXY*/
*               ELSE                                               1081
*                 DO;               /* GO TO DORUTHER        @D32CKXY*/
*                   OCWNIB=CSLNDEF; /* SETUP NIB PTR IN OCW  @D32CKXY*/
         L     @10,OCWODNAS(,OCWPTR)                               1082
         MVC   OCWNIB(4,OCWPTR),CSLNDEF(@10)                       1082
*                   CPARMRG0=1;     /* INDICATE COPY FUNCTN  @D32CKXY*/
         LA    CPARMRG0,1                                          1083
*                   OCWSVRC=OCWRC;  /* SAVE RC ACROSS CALL   @D32CKXY*/
         MVC   OCWSVRC(1,OCWPTR),OCWRC(OCWPTR)                     1084
*                   OCWSVEC=OCWEC;  /* SAVE EC ACROSS CALL   @D32CKXY*/
         MVC   OCWSVEC(1,OCWPTR),OCWEC(OCWPTR)                     1085
*                   CALL DOVALINT;  /* COPY USER'S NIB       @D32CKXY*/
         BAL   @14,DOVALINT                                        1086
*                   IF OCWRC=0 THEN                                1087
         CLI   OCWRC(OCWPTR),0                                     1087
         BNE   @RF01087                                            1087
*                     DO;           /* IF NIB VALID          @D32CKXY*/
*                       CALL DORUTHER;/* CK EXISTENCE OF DEST      1089
*                                                            @D32CKXY*/
         BAL   @14,DORUTHER                                        1089
*                       OCWODNAS->CSLRDEF=OCWDRDTE;/* SAVE ANY     1090
*                                      CHANGES TO THE HOBS IN NTRY'S
*                                      RDTE                  @D32CKXY*/
         L     @10,OCWODNAS(,OCWPTR)                               1090
         MVC   CSLRDEF(4,@10),OCWDRDTE(OCWPTR)                     1090
*                     END;          /*                       @D32CKXY*/
*                   ELSE                                           1092
*                     ;             /* IF NIB INVALID        @D32CKXY*/
@RF01087 DS    0H                                                  1093
*                   OCWRC=OCWSVRC;  /* RESTORE RET CODE      @D32CKXY*/
         MVC   OCWRC(1,OCWPTR),OCWSVRC(OCWPTR)                     1093
*                   OCWEC=OCWSVEC;  /* RESTORE ERR CODE      @D32CKXY*/
         MVC   OCWEC(1,OCWPTR),OCWSVEC(OCWPTR)                     1094
*                 END;              /* END LOGIC ESTAB CID & RDTE PTR
*                                      VIA DORUTHER          @D32CKXY*/
*               IF SORTPTR->SORTCID^=0 THEN                        1096
@RT01079 L     @10,SORTCID(,SORTPTR)                               1096
         LTR   @10,@10                                             1096
         BZ    @RF01096                                            1096
*                 DO;               /* IF CID HAS VALUE      @D32CKXY*/
*                   CPARMRG2=SORTPTR->SORTCID;/* SETUP CID FOR CIDCTL
*                                                            @D32CKXY*/
         LR    CPARMRG2,@10                                        1098
*                   DO;             /* CIDCTL(FIND)                  */
*                     RFY                                          1100
*                      (EMCR2,                                     1100
*                       EMCR3) RSTD;                               1100
*                     GEN SETS(RPHWORK)                            1101
*(STM EMCR0,EMCR15,RPHWORK(RPHPTR) SAVE REGS IN RPH);              1101
         STM EMCR0,EMCR15,RPHWORK(RPHPTR) SAVE REGS IN RPH
*                     EMCR3='00'X;  /* CLEAR EXTRA BITS              */
         SLR   EMCR3,EMCR3                                         1102
*                     EMCR3='01'X;  /* INDICATE SHARED LOCK          */
         LA    EMCR3,1                                             1103
*                     CALL ATCLCPTR->ATCCDFND->ISTSDCCF;/* PROCESS 1104
*                                      REQUEST                       */
         L     @10,ATCLCPTR                                        1104
         L     @15,ATCCDFND(,@10)                                  1104
         BALR  @14,@15                                             1104
*                     RFY                                          1105
*                      (EMCR2,                                     1105
*                       EMCR3) UNRSTD;                             1105
*                   END;            /* CIDCTL SEE IF RDTE EXISTS   1106
*                                                            @D32CKXY*/
*                   IF CRETCODE=0|CRETCODE=4|/* IF NCB FOUND OR      */
*                       CRETCODE=12 /* RDTE FOUND -                  */
*                     THEN                                         1107
         LTR   CRETCODE,CRETCODE                                   1107
         BZ    @RT01107                                            1107
         CH    CRETCODE,@CH00045                                   1107
         BE    @RT01107                                            1107
         CH    CRETCODE,@CH00033                                   1107
         BNE   @RF01107                                            1107
@RT01107 DS    0H                                                  1108
*                     DO;           /* RDTE EXISTS           @D32CKXY*/
*                       IF CRETCODE=0 THEN                         1109
         LTR   CRETCODE,CRETCODE                                   1109
         BNZ   @RF01109                                            1109
*                         DO;       /* IF DAF LOCK OBT       @D32CKXY*/
*                           CPARMRG2=SORTPTR->SORTCID;/*     @D32CKXY*/
         L     CPARMRG2,SORTCID(,SORTPTR)                          1111
*                           DO;     /* CIDCTL(FINISH)                */
*                             RFY                                  1113
*                              (EMCR2,                             1113
*                               EMCR3) RSTD;                       1113
*                             GEN SETS(RPHWORK)                    1114
*(STM EMCR0,EMCR15,RPHWORK(RPHPTR) SAVE REGS IN RPH);              1114
         STM EMCR0,EMCR15,RPHWORK(RPHPTR) SAVE REGS IN RPH
*                             EMCR3='00'X;/* CLEAR EXTRA BITS        */
         SLR   EMCR3,EMCR3                                         1115
*                             CALL ATCLCPTR->ATCCDFIN->ISTSDCCR;/* 1116
*                                      PROCESS REQUEST               */
         L     @10,ATCLCPTR                                        1116
         L     @15,ATCCDFIN(,@10)                                  1116
         BALR  @14,@15                                             1116
*                             RFY                                  1117
*                              (EMCR2,                             1117
*                               EMCR3) UNRSTD;                     1117
*                           END;    /* CIDCTL REL DAF LOCK   @D32CKXY*/
*                         END;      /*                       @D32CKXY*/
*                       ELSE                                       1120
*                         ;         /* DAF LOCK NOT OBT      @D32CKXY*/
@RF01109 DS    0H                                                  1121
*                       IF RPRENTRY=RPRENTLU&RPRNSNEA->RCCVPAB^=0/*
*                                      IF VPAB EXISTS AND    @DM14308*/
*                         THEN                                     1121
         L     @10,OCWDRDTE(,OCWPTR)                               1121
         CLI   RPRENTRY(@10),X'81'                                 1121
         BNE   @RF01121                                            1121
         L     @10,RPRNSNEA(,@10)                                  1121
         ICM   @09,15,RCCVPAB(@10)                                 1121
         BZ    @RF01121                                            1121
*                         DO;       /* IF DEST IS A LOG UNIT@D32CKXY */
*                                                                  1122
*                           /*****************************************/
*                           /*                                       */
*                           /* SEGMENT(CONERR)REQUEST                */
*                           /*                                       */
*                           /*****************************************/
*                                                                  1123
*                           DO;                                    1123
*                             GOTO CONERR;                         1124
         B     CONERR                                              1124
*CONERR#:                                                          1125
*                           END;    /* SEND BIND FAILURE NCSPL     1125
*                                                            @D32CKXY*/
CONERR#  DS    0H                                                  1126
*                         END;      /*                       @D32CKXY*/
*                       ELSE                                       1127
*                         ;         /* NOT A LOGICAL UNIT    @D32CKXY*/
@RF01121 DS    0H                                                  1128
*                     END;          /* END DO FOR FND RDTE   @D32CKXY*/
*                   ELSE                                           1129
*                     DO;           /* RDTE NOT FOUND        @D32CKXY*/
         B     @RC01107                                            1129
@RF01107 DS    0H                                                  1130
*                       OCWODNAS->CSLRDTEF=COFF;/* TURN OFF THE    1130
*                                      CONNECTED BIT IN NTRY RDTE PTR
*                                                            @D32CKXY*/
*                       OCWODNAS->CSLRDTEB=COFF;/* TURN OFF BIT TO 1131
*                                      SEND BIND FAIL SINCE RDTE BAD
*                                                            @D32CKXY*/
         L     @10,OCWODNAS(,OCWPTR)                               1131
         NI    CSLRDTEF(@10),B'00111111'                           1131
*                     END;          /*                       @D32CKXY*/
*                 END;              /* END DO FOR EXIST CID  @D32CKXY*/
*               ELSE                                               1134
*                 ;                 /* NO CID EXISTS         @D32CKXY*/
@RF01096 DS    0H                                                  1135
*             END;                  /* END DO TO SEND BIND FAILURE 1135
*                                                            @D32CKXY*/
*           ELSE                                                   1136
*             ;                     /* NO BIND FAILURE       @D32CKXY*/
@RF01077 DS    0H                                                  1137
*           SORTPTR=SORTPTR+4;      /* PT TO NEXT SORT SLOT  @D32CKXY*/
@RC01077 AH    SORTPTR,@CH00045                                    1137
*           OCWODNAS=OCWODNAS+LENGTH(ISTCSL);/* PT TO NEXT NTRY    1138
*                                                            @D32CKXY*/
         LA    @10,12                                              1138
         AL    @10,OCWODNAS(,OCWPTR)                               1138
         ST    @10,OCWODNAS(,OCWPTR)                               1138
*           OCWODCT1=OCWODCT1+1;    /* INCREMENT LOOP CTR    @D32CKXY*/
         LA    @10,1                                               1139
         AH    @10,OCWODCT1(,OCWPTR)                               1139
         STH   @10,OCWODCT1(,OCWPTR)                               1139
*         END;                      /* END DO WHILE          @D32CKXY*/
@DE01075 LH    @10,OCWODCT1(,OCWPTR)                               1140
         CH    @10,OCWDSTNO(,OCWPTR)                               1140
         BL    @DL01075                                            1140
*         RFY                                                      1141
*           SORTPTR UNRSTD;         /*                       @D32CKXY*/
*       END;                        /* END DO TO PROCESS     @D32CKXY*/
*     ELSE                                                         1143
*       ;                           /* SYSTEM ERROR          @D32CKXY*/
@RF01067 DS    0H                                                  1144
*     RFY                                                          1144
*       ISTCSL BASED(ADDR(OCWDRDTE));/* RESET BASE           @D32CKXY*/
*   END DOBINFL;                    /*                       @D32CKXY*/
*/*  SEGMENT(CLEANUP)REQUEST                                         */
*                                                                  1146
*   DO;                                                            1146
*     GOTO CLEANUP;                                                1147
         B     CLEANUP                                             1147
*CLEANUP#:                                                         1148
*   END;                            /* FREE CONT BLKS                */
CLEANUP# DS    0H                                                  1149
*   CALL ISTOCCOF;                  /* GO TO CLEAN UP                */
         L     @15,@CV05155                                        1149
         BALR  @14,@15                                             1149
*DOENVTST:                                                         1150
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1150
*                                                                  1150
         B     @PB00002                                            1150
DOENVTST DS    0H                                                  1151
*/********************************************************************/
*/*  ROUTINE NAME: DOENVTST                                          */
*/*  FUNCTION:                                                       */
*/*       THIS ROUTINE IS CALLED BY MAINLINE TO DETERMINE IF AN ACT- */
*/*       IVE CONNECTION STILL EXISTS BETWEEN A DEST AND THE APPL.   */
*/*       IF THE HIGH ORDER BIT IS ON IN THE ADDRRESS OF THE DEST,   */
*/*       A CONNECTION EXISTED AT ONE TIME. IF THIS OPEN DST WAS Q'D */
*/*       BY CONNECTION SERV ,THE CONN MAY HAVE BEEN LOST.DORUTHER   */
*/*       IS CALLED TO DETERMINE IF IT EXISTS.THE RDT LOCK IS GOTTEN */
*/*       UPON ENTRY TO DOENVTST IF NECESSARY. ON EXIT, THE RDT LOCK */
*/*       IS RELEASED.                                               */
*/*  ROUTINES CALLED:                                                */
*/*       DORUTHER - ENSURE THAT AN RDTE AND THE CONN EXISTS         */
*/*  MACROS USED:                                                    */
*/*       TPLOCK - RDT,OCLOCK                                        */
*/*       TPUNLOCK - RDT                                             */
*/********************************************************************/
*                                                                  1151
*   C14SAVE=CR14PTR;                /* SUBR RTURN                    */
         LA    @10,624                                             1151
         ALR   @10,OCWPTR                                          1151
         L     @09,C14SVPTR(,@10)                                  1151
         ST    CR14PTR,C14SAVE(,@09)                               1151
*   C14SVPTR=C14SVPTR+4;                                           1152
         AH    @09,@CH00045                                        1152
         ST    @09,C14SVPTR(,@10)                                  1152
*   IF OCWRLOCK=CON                 /* RDT LOCK HELD?                */
*     THEN                                                         1153
         TM    OCWRLOCK(OCWPTR),B'01000000'                        1153
         BO    @RT01153                                            1153
*     ;                                                            1154
*   ELSE                                                           1155
*     DO;                                                          1155
*                                                                  1155
*/*** START -TPLOCK (RDTLOCK)TYPE(SHARE)- **                         */
*                                                                  1156
*       DO;                                                        1156
*         RFY                                                      1157
*          (GPR00P,                                                1157
*           GPR01P,                                                1157
*           GPR02P,                                                1157
*           GPR03P,                                                1157
*           GPR04P,                                                1157
*           GPR15P) RSTD;                                          1157
*         GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(RPHWORK);
         STM GPR00P,GPR14P,RPHWORK(GPR01P)
*         GPR15P=ATCAP35;           /* ADDRESS OF LOCK ROUTINE       */
         L     @10,OCWACVT(,OCWPTR)                                1159
         L     GPR15P,ATCAP35(,@10)                                1159
*         GPR02P=ADDR(ATCRDTLK);    /* SET PARAM - LOCKWORD PTR      */
         LA    GPR02P,ATCRDTLK(,@10)                               1160
*         GPR04P=GPR01P->RPHCRR;    /* SET PARAM - ISTCRA PTR        */
         L     GPR04P,RPHCRR(,GPR01P)                              1161
*         GPR00P=CRALMS03;          /* SET PARAM - LOCK LEVEL FLAG   */
         LA    GPR00P,4                                            1162
*         GPR03P=ADDR(GPR04P->CRAL3PTR);/* SET PARAM - LOCK LEVEL PTR*/
         LA    GPR03P,CRAL3PTR(,GPR04P)                            1163
*         DCL                                                      1164
*           FMZL0141 BASED(GPR15P) LABEL VALUERANGE(*);            1164
*         CALL FMZL0141;                                           1165
         BALR  @14,@15                                             1165
*         GENERATE REFS(GPR00P,GPR01P,GPR14P,RPHWORK) SETS(GPR00P, 1166
*             GPR01P,GPR02P,GPR03P,GPR04P,GPR05P,GPR06P,GPR07P,GPR08P,
*             GPR09P,GPR10P,GPR11P,GPR12P,GPR13P,GPR14P,GPR15P);   1166
         LM GPR00P,GPR15P,RPHWORK(GPR01P)
*         RFY                                                      1167
*          (GPR00P,                                                1167
*           GPR01P,                                                1167
*           GPR02P,                                                1167
*           GPR03P,                                                1167
*           GPR04P,                                                1167
*           GPR15P) UNRSTD;                                        1167
*       END;                                                       1168
*                                                                  1168
*/*** END -TPLOCK (RDTLOCK)TYPE(SHARE)- **                           */
*                                                                  1169
*                                   /* OBTAIN LOCK                   */
*       IF CRETCODE=0               /* LOCK GOTTEN?                  */
*         THEN                                                     1169
         LTR   CRETCODE,CRETCODE                                   1169
         BNZ   @RF01169                                            1169
*         OCWRLOCK=CON;             /* INDICATE LOCK GOTTEN          */
         OI    OCWRLOCK(OCWPTR),B'01000000'                        1170
*       ELSE                                                       1171
*         DO;                                                      1171
         B     @RC01169                                            1171
@RF01169 DS    0H                                                  1172
*           OCWRC='24'X;            /* SYSTEM ERROR                  */
         MVI   OCWRC(OCWPTR),X'24'                                 1172
*           OCWEC='06'X;            /* NO RDT LOCK                   */
         MVI   OCWEC(OCWPTR),X'06'                                 1173
*         END;                                                     1174
*     END;                                                         1175
@RC01169 DS    0H                                                  1176
*   IF OCWRC=0 THEN                                                1176
@RT01153 CLI   OCWRC(OCWPTR),0                                     1176
         BNE   @RF01176                                            1176
*     IF CSLRDTEF=CON               /* HAS DESTINATION BEEN OBT?   1177
*                                                            @D32CKMP*/
*       THEN                                                       1177
         TM    CSLRDTEF+40(OCWPTR),B'10000000'                     1177
         BNO   @RF01177                                            1177
*       DO;                                                        1178
*         CALL DORUTHER;            /* SEE IF DEST AND ACE STILL   1179
*                                      EXIST                 @X50BHGF*/
         BAL   @14,DORUTHER                                        1179
*         IF CSLRDTEF=CON           /* IF DESTINATION STILL THERE  1180
*                                                            @D32CKMP*/
*           THEN                    /* AND ACE STILL AROUND  @D32CKMP*/
         TM    CSLRDTEF+40(OCWPTR),B'10000000'                     1180
         BNO   @RF01180                                            1180
*           DO;                                                    1181
*                                                                  1181
*/*** START -TPLOCK (OCLOCK)TYPE(XCLSIVE)- **                        */
*                                                                  1182
*             DO;                                                  1182
*               RFY                                                1183
*                (GPR00P,                                          1183
*                 GPR01P,                                          1183
*                 GPR02P,                                          1183
*                 GPR03P,                                          1183
*                 GPR04P,                                          1183
*                 GPR15P) RSTD;                                    1183
*               GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(  1184
*                   RPHWORK);                                      1184
         STM GPR00P,GPR14P,RPHWORK(GPR01P)
*               GPR02P=ADDR(RPRRLOCK);/* SET PARAM - LOCKWORD PTR    */
         L     GPR02P,OCWDRDTE(,OCWPTR)                            1185
         LA    GPR02P,RPRRLOCK(,GPR02P)                            1185
*               GPR04P=GPR01P->RPHCRR;/* SET PARAM - ISTCRA PTR      */
         L     GPR04P,RPHCRR(,GPR01P)                              1186
*               GPR00P=CRALMS04;    /* SET PARAM - LOCK LEVEL FLAG   */
         LA    GPR00P,8                                            1187
*               GPR03P=ADDR(GPR04P->CRAL4PTR);/* SET PARAM - LOCK  1188
*                                      LEVEL PTR                     */
         LA    GPR03P,CRAL4PTR(,GPR04P)                            1188
*               GPR15P=ATCLCPTR->ATCAP36;/* ADDRESS OF LOCK ROUTINE  */
         L     @10,ATCLCPTR                                        1189
         L     GPR15P,ATCAP36(,@10)                                1189
*               DCL                                                1190
*                 FMZL0146 BASED(GPR15P) LABEL VALUERANGE(*);      1190
*               CALL FMZL0146;                                     1191
         BALR  @14,@15                                             1191
*               GENERATE REFS(GPR00P,GPR01P,GPR14P,RPHWORK) SETS(GPR00P
*                   ,GPR01P,GPR02P,GPR03P,GPR04P,GPR05P,GPR06P,GPR07P,
*                   GPR08P,GPR09P,GPR10P,GPR11P,GPR12P,GPR13P,GPR14P,
*                   GPR15P);                                       1192
         LM GPR00P,GPR15P,RPHWORK(GPR01P)
*               RFY                                                1193
*                (GPR00P,                                          1193
*                 GPR01P,                                          1193
*                 GPR02P,                                          1193
*                 GPR03P,                                          1193
*                 GPR04P,                                          1193
*                 GPR15P) UNRSTD;                                  1193
*             END;                                                 1194
*                                                                  1194
*/*** END -TPLOCK (OCLOCK)TYPE(XCLSIVE)- **                          */
*                                                                  1195
*             IF CRETCODE=0         /* LOCK GOTTEN                   */
*               THEN                                               1195
         LTR   CRETCODE,CRETCODE                                   1195
         BNZ   @RF01195                                            1195
*               OCWELOCK=CON;       /* INDICATE ENTRY LOCK OBT       */
         OI    OCWELOCK(OCWPTR),B'00100000'                        1196
*             ELSE                                                 1197
*               DO;                                                1197
         B     @RC01195                                            1197
@RF01195 DS    0H                                                  1198
*                 OCWRC='24'X;      /* SYSTEM ERROR                  */
         MVI   OCWRC(OCWPTR),X'24'                                 1198
*                 OCWEC='07'X;      /* ENTRY LOCK NO OBTAINED        */
         MVI   OCWEC(OCWPTR),X'07'                                 1199
*               END;                                               1200
*                                                                  1200
*/*** START -TPUNLOCK (RDTLOCK)- **                                  */
*                                                                  1201
*             DO;                                                  1201
*                                                                  1201
@RC01195 DS    0H                                                  1202
*/* ATBUILD (ISTRPH,ISTLOK,ISTCRA)                                   */
*/* END OF ATBUILD                                                   */
*                                                                  1202
*               RFY                                                1202
*                (GPR00P,                                          1202
*                 GPR01P,                                          1202
*                 GPR02P,                                          1202
*                 GPR03P,                                          1202
*                 GPR04P,                                          1202
*                 GPR15P) RSTD;                                    1202
*               GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(  1203
*                   RPHWORK);                                      1203
         STM GPR00P,GPR15P,RPHWORK(GPR01P)
*               GPR02P=ADDR(ATCRDTLK);/* SET PARAM - LOCKWORD PTR    */
         L     GPR02P,OCWACVT(,OCWPTR)                             1204
         LA    GPR02P,ATCRDTLK(,GPR02P)                            1204
*               GPR04P=GPR01P->RPHCRR;/* SET PARAM - ISTCRA PTR      */
         L     GPR04P,RPHCRR(,GPR01P)                              1205
*               GPR00P=CRALMS03;    /* SET PARAM - LOCK LEVEL FLAG   */
         LA    GPR00P,4                                            1206
*               GPR03P=ADDR(GPR04P->CRAL3PTR);/* SET PARAM - LOCK  1207
*                                      LEVEL PTR                     */
         LA    GPR03P,CRAL3PTR(,GPR04P)                            1207
*               DO;                 /* LISATCVT                    1208
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*                 GPR15P=ATCLCPTR;  /* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     1209
*               END;                /* LISATCVT                      */
*               GPR15P=GPR15P->ATCAP33;                            1211
         L     GPR15P,ATCAP33(,GPR15P)                             1211
*               DCL                                                1212
*                 FMZL0151 BASED(GPR15P) LABEL VALUERANGE(*);      1212
*               CALL FMZL0151;                                     1213
         BALR  @14,@15                                             1213
*               GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(GPR00P
*                   ,GPR01P,GPR02P,GPR03P,GPR04P,GPR05P,GPR06P,GPR07P,
*                   GPR08P,GPR09P,GPR10P,GPR11P,GPR12P,GPR13P,GPR14P,
*                   GPR15P);                                       1214
         LM GPR00P,GPR15P,RPHWORK(GPR01P)
*               RFY                                                1215
*                (GPR00P,                                          1215
*                 GPR01P,                                          1215
*                 GPR02P,                                          1215
*                 GPR03P,                                          1215
*                 GPR04P,                                          1215
*                 GPR15P) UNRSTD;                                  1215
*             END;                                                 1216
*                                                                  1216
*/*** END -TPUNLOCK (RDTLOCK)- **                                    */
*                                                                  1217
*                                   /* NOT NEEDED ANYMORE            */
*             OCWRLOCK=COFF;        /* INDICATE LOCK OFF             */
         NI    OCWRLOCK(OCWPTR),B'10111111'                        1217
*           END;                                                   1218
*         ELSE                                                     1219
*           ;                                                      1219
@RF01180 DS    0H                                                  1220
*       END;                                                       1220
*     ELSE                                                         1221
*       ;                                                          1221
@RF01177 DS    0H                                                  1222
*   C14SVPTR=C14SVPTR-4;                                           1222
@RF01176 LA    @10,624                                             1222
         ALR   @10,OCWPTR                                          1222
         L     @09,C14SVPTR(,@10)                                  1222
         SH    @09,@CH00045                                        1222
         ST    @09,C14SVPTR(,@10)                                  1222
*   CR14PTR=C14SAVE;                                               1223
         L     CR14PTR,C14SAVE(,@09)                               1223
*   END DOENVTST;                                                  1224
@EL00002 DS    0H                                                  1224
@EF00002 DS    0H                                                  1224
@ER00002 BR    @14                                                 1224
*DORUTHER:                                                         1225
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1225
*                                                                  1225
DORUTHER DS    0H                                                  1226
*/********************************************************************/
*/*  ROUTINE NAME: DORUTHER                                          */
*/*  FUNCTION:                                                       */
*/*       CALLED BY DOENVTST, DORUTHER CALLS ISTOCCDF TO ENSURE THAT */
*/*       THE RDT STILL EXISTS AND OBTAIN THE CORRECT ADDRESS OF IT. */
*/*       THE ACE CHAIN OF THE RDT IS SEARCHED FOR THIS OPEN DST'S   */
*/*       RPH ADDRESS. IF FOUND, THE HIGH ORDER BIT IN THE RDT ADDR. */
*/*       IS SET TO '1'B. IF THE RIGHT RPH ADDR IS NOT FOUND,THE BIT */
*/*       IS SET TO ZERO.                                            */
*/*  ROUTINES CALLED:                                                */
*/*       ISTOCCDF - TO OBTAIN ADDRESS OF RDT                        */
*/*  MACROS USED:                                                    */
*/*       CRRMAINT - FOOT PRINT                                      */
*/********************************************************************/
*                                                                  1226
*   C14SAVE=CR14PTR;                /* SUBR RTURN                    */
         LA    @10,624                                             1226
         ALR   @10,OCWPTR                                          1226
         L     @09,C14SVPTR(,@10)                                  1226
         ST    CR14PTR,C14SAVE(,@09)                               1226
*   C14SVPTR=C14SVPTR+4;                                           1227
         AH    @09,@CH00045                                        1227
         ST    @09,C14SVPTR(,@10)                                  1227
*   CPARMRG2=0;                     /* SET REG FOR CALL TO ISTOCCDF  */
         SLR   CPARMRG2,CPARMRG2                                   1228
*   CPARMRG0=ADDR(NIBSYM)|CHIBIT;   /* @ OF RDTE NAME WITH HI ORD BIT
*                                      ON                            */
         LA    CPARMRG0,NIBSYM+112(,OCWPTR)                        1229
         O     CPARMRG0,CHIBIT                                     1229
*   RPHPTR=RPHPTR&CHIBTOFF;         /* ENSURE 0 BIT IN REG 1 ZERO    */
         N     RPHPTR,CHIBTOFF                                     1230
*   CALL ISTOCCDF;                  /* FIND IF RDTE STILL EXISTS   1231
*                                                            @D32CKMP*/
         L     @10,OCWACVT(,OCWPTR)                                1231
         L     @15,ATCSRTDF(,@10)                                  1231
         BALR  @14,@15                                             1231
*   DO;                                                            1232
*                                                                  1232
*/***  CRRMAINT  PROCNM(ISTOCCOE)COMP(OC)FUNC(RET)  **               */
*                                                                  1233
*     DCL                                                          1233
*       CMZK0161 PTR(31) REG(1);                                   1233
*     RFY                                                          1234
*      (CMZK0161) RSTD;                                            1234
*                                                                  1234
*/*  ** CLEAR AND SET CURRENT PROCEDURE BIT **                       */
*                                                                  1235
*     CMZK0161->RPHCRR->CRACRR->OCCCRT='0'B;                       1235
         L     @10,RPHCRR(,CMZK0161)                               1235
         L     @10,CRACRR(,@10)                                    1235
         XC    OCCCRT+1(2,@10),OCCCRT+1(@10)                       1235
         MVI   OCCCRT(@10),B'00000000'                             1235
*     CMZK0161->RPHCRR->CRACRR->COCCOE='1'B;                       1236
         OI    COCCOE(@10),B'00010000'                             1236
*   END;                                                           1237
*   IF CRETCODE^=0                  /* WAS RDTE FOUND?               */
*     THEN                                                         1238
         LTR   CRETCODE,CRETCODE                                   1238
         BZ    @RF01238                                            1238
*     DO;                           /* RDTE NOT FOUND        @D32CKXY*/
*       CSLRDTEF=COFF;              /* RDTE NOT THERE NO CONNECTION
*                                                            @D32CKXY*/
*       CSLRDTEB=COFF;              /* DO NOT TRY TO SEND BIND     1241
*                                      FAILURE               @D32CKXY*/
         NI    CSLRDTEF+40(OCWPTR),B'00111111'                     1241
*     END;                          /*                       @D32CKXY*/
*   ELSE                                                           1243
*     DO;                                                          1243
         B     @RC01238                                            1243
@RF01238 DS    0H                                                  1244
*       CSLRDTEF=CON;               /* INDICATE CONNECTION EXISTS  1244
*                                                            @D32CKMP*/
         OI    CSLRDTEF+40(OCWPTR),B'10000000'                     1244
*       RFY                                                        1245
*         SORTPTR RSTD;             /*                       @D32CKXY*/
*       IF OCWDSTNO=1 THEN                                         1246
         CLC   OCWDSTNO(2,OCWPTR),@CH00068                         1246
         BNE   @RF01246                                            1246
*         SORTPTR=ADDR(OCWCID);     /* PT TO SORT SLOT FOR A SINGLE  */
*                                                                  1247
         LA    SORTPTR,OCWCID(,OCWPTR)                             1247
*       /*************************************************************/
*       /*                                                           */
*       /* DEST REQUEST                                      @D32CKXY*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  1248
*       ELSE                                                       1248
*         DO;                                                      1248
         B     @RC01246                                            1248
@RF01246 DS    0H                                                  1249
*           SORTPTR=OCWODLST+(OCWDSTNO*LENGTH(ISTCSL))+OCWODCT1*4; 1249
*                                                                  1249
         LH    SORTPTR,OCWDSTNO(,OCWPTR)                           1249
         MH    SORTPTR,@CH00033                                    1249
         AL    SORTPTR,OCWODLST(,OCWPTR)                           1249
         LH    @10,OCWODCT1(,OCWPTR)                               1249
         SLA   @10,2                                               1249
         ALR   SORTPTR,@10                                         1249
*           /*********************************************************/
*           /*                                                       */
*           /* PT TO SORT SLOT FOR LIST ENTRY                @D32CKXY*/
*           /*                                                       */
*           /*********************************************************/
*                                                                  1250
*         END;                      /*                       @D32CKXY*/
*       SORTPTR->SORTDAF=RPRDAF;    /* SAVE DAF IN SORT SLOT @D32CKXY*/
@RC01246 L     @10,OCWDRDTE(,OCWPTR)                               1251
         MVC   SORTDAF(2,SORTPTR),RPRDAF(@10)                      1251
*       RFY                                                        1252
*         SORTPTR UNRSTD;           /*                       @D32CKXY*/
*       IF OCWNOCON=CON THEN                                       1253
         TM    OCWNOCON(OCWPTR),B'00100000'                        1253
         BO    @RT01253                                            1253
*         ;                         /* IF NO CONN- NO ACE    @D32CKXY*/
*       ELSE                                                       1255
*         DO;                       /* CK ACE FOR MATCHING RPH     1255
*                                                            @D32CKXY*/
*           RFY                                                    1256
*             ISTACE BASED(OCWACE);                                1256
*           OCWACE=RCPACETR;        /* PICK UP PTR TO ACE QUEUE      */
         L     @10,OCWDRDTE(,OCWPTR)                               1257
         MVC   OCWACE(4,OCWPTR),RCPACETR(@10)                      1257
*           DO WHILE OCWACE^=ADDR(RCPACETR)&OCWRPH^=ACERPHA;/* CK ACE
*                                      CHAIN FOR RPH MATCH           */
         B     @DE01258                                            1258
@DL01258 DS    0H                                                  1259
*             OCWACE=ACEOBJQ;       /* PICK UP NEXT PTR ON TERM CHAIN*/
         L     @10,OCWACE(,OCWPTR)                                 1259
         L     @10,ACEOBJQ(,@10)                                   1259
         ST    @10,OCWACE(,OCWPTR)                                 1259
*           END;                                                   1260
@DE01258 L     @10,OCWACE(,OCWPTR)                                 1260
         L     @09,OCWDRDTE(,OCWPTR)                               1260
         LA    @09,RCPACETR(,@09)                                  1260
         CR    @10,@09                                             1260
         BE    @DC01258                                            1260
         CLC   OCWRPH(4,OCWPTR),ACERPHA(@10)                       1260
         BNE   @DL01258                                            1260
@DC01258 DS    0H                                                  1261
*           IF ACERPHA=OCWRPH       /* WAS OUR RPH FOUND ?           */
*             THEN                                                 1261
         L     @10,OCWACE(,OCWPTR)                                 1261
         CLC   ACERPHA(4,@10),OCWRPH(OCWPTR)                       1261
         BE    @RT01261                                            1261
*             ;                                                    1262
*           ELSE                                                   1263
*             CSLRDTEF=COFF;        /* INDICATE ACE WAS LOST @D32CKMP*/
         NI    CSLRDTEF+40(OCWPTR),B'01111111'                     1263
*         END;                      /* END DO FOR NOCON BIT OFF    1264
*                                                            @D32CKXY*/
@RT01261 DS    0H                                                  1265
*     END;                                                         1265
@RT01253 DS    0H                                                  1266
*   C14SVPTR=C14SVPTR-4;                                           1266
@RC01238 LA    @10,624                                             1266
         ALR   @10,OCWPTR                                          1266
         L     @09,C14SVPTR(,@10)                                  1266
         SH    @09,@CH00045                                        1266
         ST    @09,C14SVPTR(,@10)                                  1266
*   CR14PTR=C14SAVE;                                               1267
         L     CR14PTR,C14SAVE(,@09)                               1267
*   END DORUTHER;                                                  1268
@EL00003 DS    0H                                                  1268
@EF00003 DS    0H                                                  1268
@ER00003 BR    @14                                                 1268
*GETLCPB:                                                          1269
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1269
*                                                                  1269
GETLCPB  DS    0H                                                  1270
*/********************************************************************/
*/*  ROUTINE NAME: GETLCPB                                           */
*/*  FUNCTION:                                                       */
*/*       CALLED BY  DOSTCTL                                         */
*/*       IF NECESSARY,THIS ROUTINE REQSTORES ANMLPB. IF NOT,THE     */
*/*       EXISTING ONE IS ZEROED.THE TYPE & LENGTH FIELDS ARE FILLED */
*/*       IN.                                                        */
*/*  ROUTINES CALLED:                                                */
*/*       NONE                                                       */
*/*  MACROS USED:                                                    */
*/*       REQSTORE - OBTAIN AN NMLPB                                 */
*/*       RELSTORE - RELEASE STORAGE OBTAINED IF RC=4 FROM REQSTORE  */
*/********************************************************************/
*                                                                  1270
*   C14SAVE=CR14PTR;                /* SUBR RTURN                    */
         LA    @10,624                                             1270
         ALR   @10,OCWPTR                                          1270
         L     @09,C14SVPTR(,@10)                                  1270
         ST    CR14PTR,C14SAVE(,@09)                               1270
*   C14SVPTR=C14SVPTR+4;                                           1271
         AH    @09,@CH00045                                        1271
         ST    @09,C14SVPTR(,@10)                                  1271
*   IF OCWLCPBA^=0                  /* LCPB ALREADY EXISTS?          */
*     THEN                                                         1272
         L     @10,OCWLCPBA(,OCWPTR)                               1272
         LTR   @10,@10                                             1272
         BZ    @RF01272                                            1272
*     DO;                                                          1273
*       ISTNMLPB=ISTNMLPB&&ISTNMLPB;/* ZERO OUT EXISTING ONE         */
         XC    ISTNMLPB(100,@10),ISTNMLPB(@10)                     1274
*       LCPTYPE=NMLPBTYP;           /* FILL IN TYPE FIELD FOR NMLCPB */
         MVI   LCPTYPE(@10),X'27'                                  1275
*       LCPLNGTH=LENGTH(ISTNMLPB);  /* FILL IN LENGTH FIELD          */
         MVI   LCPLNGTH(@10),X'64'                                 1276
*     END;                                                         1277
*   ELSE                                                           1278
*     DO;                                                          1278
*                                                                  1278
         B     @RC01272                                            1278
@RF01272 DS    0H                                                  1279
*       /*************************************************************/
*       /*                                                           */
*       /* REQSTORE CBID(NMLPB)CLEAR(YES)                            */
*       /*                                                           */
*       /*************************************************************/
*                                                                  1279
*       DO;                                                        1279
*                                                                  1279
*/* ATBUILD (ISTDYPAB,ISTATCVT,ISTRPH)                               */
*/* END OF ATBUILD                                                   */
*                                                                  1280
*         RFY                                                      1280
*          (GPR02P,                                                1280
*           GPR03P,                                                1280
*           GPR04P,                                                1280
*           GPR15P) RSTD;                                          1280
*         RFY                                                      1281
*          (GPR01P,                                                1281
*           GPR13P) RSTD;                                          1281
*         GENERATE REFS(GPR01P,GPR02P,GPR13P) SETS(RPHWORK);       1282
           STM GPR02P,GPR13P,RPHWORK(GPR01P)
*         RFY                                                      1283
*          (GPR01P,                                                1283
*           GPR13P) UNRSTD;                                        1283
*         DO;                       /* LISATCVT                    1284
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*           GPR15P=ATCLCPTR;        /* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     1285
*         END;                      /* LISATCVT                      */
*         GPR02P=GPR15P->ATCBPDA|'80000000'X;                      1287
         L     GPR02P,ATCBPDA(,GPR15P)                             1287
         O     GPR02P,@CF01465                                     1287
*         DCL                                                      1288
*           1 FMZA0162 FIXED(31) STATIC LOCAL,                     1288
*            2 * FIXED(8) INIT(152),                               1288
*            2 * PTR(24) INIT(0);                                  1288
*         GPR03F=FMZA0162;                                         1289
         L     GPR03F,FMZA0162                                     1289
*         GPR04F=19;                                               1290
         LA    GPR04F,19                                           1290
*         GPR15P=GPR15P->ATCSMRQ;                                  1291
         L     GPR15P,ATCSMRQ(,GPR15P)                             1291
*         DCL                                                      1292
*           FMZL0162 BASED(GPR15P) LABEL VALUERANGE(*);            1292
*         CALL FMZL0162;                                           1293
         BALR  @14,@15                                             1293
*         RFY                                                      1294
*          (GPR13P) RSTD;                                          1294
*         GENERATE REFS(GPR01P,RPHWORK) SETS(GPR02P,GPR13P);       1295
           LM GPR02P,GPR13P,RPHWORK(GPR01P)
*         RFY                                                      1296
*          (GPR13P) UNRSTD;                                        1296
*         RFY                                                      1297
*          (GPR02P,                                                1297
*           GPR03P,                                                1297
*           GPR04P,                                                1297
*           GPR15P) UNRSTD;                                        1297
*       END;                        /* ******** END OF REQSTORE    1298
*                                      EXPANSION GET STORAGE FOR   1298
*                                      NMLCPB                        */
*       IF CRETCODE=0               /* ANY TROUBLE ?                 */
*         THEN                                                     1299
         LTR   CRETCODE,CRETCODE                                   1299
         BNZ   @RF01299                                            1299
*         DO;                                                      1300
*           OCWLCPBA=RPHSRPRM;      /* @ OF CB IN OCW                */
         L     @10,RPHSRPRM(,GPR01P)                               1301
         ST    @10,OCWLCPBA(,OCWPTR)                               1301
*           LCPTYPE=NMLPBTYP;       /* FILL IN TYPE FIELD FOR NMLCPB */
         MVI   LCPTYPE(@10),X'27'                                  1302
*           LCPLNGTH=LENGTH(ISTNMLPB);/* FILL IN LENGTH FIELD        */
         MVI   LCPLNGTH(@10),X'64'                                 1303
*         END;                                                     1304
*       ELSE                                                       1305
*         DO;                       /* RC NOT ZERO FROM RQSTR      1305
*                                                            @ZA04073*/
         B     @RC01299                                            1305
@RF01299 DS    0H                                                  1306
*           IF CRETCODE=4 THEN                                     1306
         CH    CRETCODE,@CH00045                                   1306
         BNE   @RF01306                                            1306
*             DO;                   /*                       @ZA13617*/
*                                                                  1307
*               /*****************************************************/
*               /*                                                   */
*               /* RELSTORE BUFADDR(RPHSRPRM)                        */
*               /*                                                   */
*               /*****************************************************/
*                                                                  1308
*               DO;                                                1308
*                                                                  1308
*/* ATBUILD (ISTATCVT,ISTRPH)                                        */
*/* END OF ATBUILD                                                   */
*                                                                  1309
*                 RFY                                              1309
*                  (GPR02P,                                        1309
*                   GPR03P,                                        1309
*                   GPR04P,                                        1309
*                   GPR15P) RSTD;                                  1309
*                 RFY                                              1310
*                  (GPR01P,                                        1310
*                   GPR13P) RSTD;                                  1310
*                 GENERATE REFS(GPR01P,GPR02P,GPR13P) SETS(RPHWORK);
          STM GPR02P,GPR13P,RPHWORK(GPR01P)
*                 RFY                                              1312
*                   GPR13P UNRSTD;                                 1312
*                 GPR04P=RPHSRPRM;                                 1313
         L     GPR04P,RPHSRPRM(,GPR01P)                            1313
*                 DCL                                              1314
*                   1 FMZA0181 FIXED(31) STATIC LOCAL,             1314
*                    2 * FIXED(8) INIT(64),                        1314
*                    2 * PTR(24) INIT(0);                          1314
*                 GPR03F=FMZA0181;                                 1315
         L     GPR03F,FMZA0181                                     1315
*                 DO;               /* LISATCVT                    1316
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*                   GPR15P=ATCLCPTR;/* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     1317
*                 END;              /* LISATCVT                      */
*                 GPR02P=GPR15P->ATCBPDA;                          1319
         L     GPR02P,ATCBPDA(,GPR15P)                             1319
*                 GPR15P=GPR15P->ATCSMRS;                          1320
         L     GPR15P,ATCSMRS(,GPR15P)                             1320
*                 DCL                                              1321
*                   FMZL0181 BASED(GPR15P) LABEL VALUERANGE(*);    1321
*                 CALL FMZL0181;                                   1322
         BALR  @14,@15                                             1322
*                 RFY                                              1323
*                   GPR13P RSTD;                                   1323
*                 GENERATE REFS(GPR01P,RPHWORK) SETS(GPR02P,GPR13P);
          LM GPR02P,GPR13P,RPHWORK(GPR01P)
*                 RFY                                              1325
*                  (GPR01P,                                        1325
*                   GPR13P) UNRSTD;                                1325
*                 RFY                                              1326
*                  (GPR02P,                                        1326
*                   GPR03P,                                        1326
*                   GPR04P,                                        1326
*                   GPR15P) UNRSTD;                                1326
*               END;                /* *********END OF RELSTORE    1327
*                                      EXPANSION********* RELE GOTTEN
*                                      STOR                          */
*               OCWRC='14'X;        /* TEMP ERROR            @ZA13617*/
         MVI   OCWRC(OCWPTR),X'14'                                 1328
*               OCWEC='01'X;        /* OUT OF STORAGE        @ZA13617*/
         MVI   OCWEC(OCWPTR),X'01'                                 1329
*             END;                  /*                       @ZA13617*/
*           ELSE                                                   1331
*             DO;                   /* NO STORAGE TO RELEASE @ZA13617*/
         B     @RC01306                                            1331
@RF01306 DS    0H                                                  1332
*               IF CRETCODE>CEIGHT THEN                            1332
         CH    CRETCODE,@CH00037                                   1332
         BNH   @RF01332                                            1332
*                 DO;               /* IF STOR NOT OBTAINABLE      1333
*                                                            @ZA04073*/
*                   OCWRC='24'X;    /* SYSTEM ERROR                  */
         MVI   OCWRC(OCWPTR),X'24'                                 1334
*                   OCWEC='01'X;    /* UNEXPECTED ERROR              */
         MVI   OCWEC(OCWPTR),X'01'                                 1335
*                 END;                                             1336
*               ELSE                                               1337
*                 DO;               /* STOR TEMP NOT AVAIL   @ZA04073*/
         B     @RC01332                                            1337
@RF01332 DS    0H                                                  1338
*                   OCWRC='14'X;    /* TEMP ERROR            @ZA04073*/
         MVI   OCWRC(OCWPTR),X'14'                                 1338
*                   OCWEC='01'X;    /* OUT OF STORAGE        @ZA04073*/
         MVI   OCWEC(OCWPTR),X'01'                                 1339
*                 END;              /*                       @ZA04073*/
*             END;                  /* END FOR RC NOT ZERO   @ZA04073*/
@RC01332 DS    0H                                                  1342
*         END;                      /*                       @ZA13617*/
@RC01306 DS    0H                                                  1343
*     END;                          /* END FOR LCPB NOT EXISTING     */
@RC01299 DS    0H                                                  1344
*   C14SVPTR=C14SVPTR-4;                                           1344
@RC01272 LA    @10,624                                             1344
         ALR   @10,OCWPTR                                          1344
         L     @09,C14SVPTR(,@10)                                  1344
         SH    @09,@CH00045                                        1344
         ST    @09,C14SVPTR(,@10)                                  1344
*   CR14PTR=C14SAVE;                                               1345
         L     CR14PTR,C14SAVE(,@09)                               1345
*   END GETLCPB;                                                   1346
@EL00004 DS    0H                                                  1346
@EF00004 DS    0H                                                  1346
@ER00004 BR    @14                                                 1346
*DOSTCTL:                                                          1347
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1347
*                                                                  1347
DOSTCTL  DS    0H                                                  1348
*/********************************************************************/
*/*  ROUTINE NAME: DOSTCTL                                           */
*/*  FUNCTION:                                                       */
*/*       THIS ROUTINE IS CALLED BY MAIN LINE TO DETERMINE IF NETWORK*/
*/*       MANAGEMENT OR PORT SOLICITOR SHOULD BE DRIVEN IF EITHER. IF*/
*/*       THIS IS A PORT,THE TERM DAF IS PUT INTO THE OCW. IF THIS IS*/
*/*       A CLUSTER TERM,THE DAF OF THE CLUSTER IS USED. IN BOTH     */
*/*       CASES, AN NMLPB IS GOTTEN AND DOSTCTL2 IS CALLED TO DRIVE  */
*/*       THE PROPER FUNCTION.                                       */
*/*  ROUTINES CALLED:                                                */
*/*       GETLCPB - OBTAIN AN NMLCPB                                 */
*/*       DOSTCTL2 - DO START CONTROL I/O                            */
*/*  MACROS USED:                                                    */
*/*       NONE                                                       */
*/********************************************************************/
*                                                                  1348
*   C14SAVE=CR14PTR;                /* SUBR RTURN                    */
         LA    @10,624                                             1348
         ALR   @10,OCWPTR                                          1348
         L     @09,C14SVPTR(,@10)                                  1348
         ST    CR14PTR,C14SAVE(,@09)                               1348
*   C14SVPTR=C14SVPTR+4;                                           1349
         AH    @09,@CH00045                                        1349
         ST    @09,C14SVPTR(,@10)                                  1349
*   OCWSORTP=OCWODNAS->SORTCID;     /* SAVE SORTCID SINCE IT IS TEMP */
*                                                                  1350
         L     @10,OCWODNAS(,OCWPTR)                               1350
         MVC   OCWSORTP(4,OCWPTR),SORTCID(@10)                     1350
*   /*****************************************************************/
*   /*                                                               */
*   /* ALTERED FOR SING DEST REQUEST- OCWCID IS CHANGED      @D32CKXY*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1351
*   OCWSAF=ATCVTMID;                /* HOST MAJOR NODE ID D303080    */
         L     @10,OCWACVT(,OCWPTR)                                1351
         SLR   @09,@09                                             1351
         ICM   @09,3,ATCVTMID(@10)                                 1351
         STH   @09,OCWSAF(,OCWPTR)                                 1351
*   OCWSAF=OCWSAF|CONE;             /* TURN ON LOW ORD BIT D303080   */
         O     @09,@CF00068                                        1352
         STH   @09,OCWSAF(,OCWPTR)                                 1352
*   OCWSTCTL=COFF;                  /* INIT CLUST STRT CTL SW      1353
*                                                            @ZM00768*/
         NI    OCWSTCTL(OCWPTR),B'11011111'                        1353
*   SWITCH=CON;                     /* DM08468                       */
         LA    @10,176                                             1354
         ALR   @10,OCWPTR                                          1354
         OI    SWITCH(@10),B'10000000'                             1354
*   IF RPRENTRY=RPRENTLN&           /* RDTE A PORT ?                 */
*       RLNPORT=CON THEN                                           1355
         L     @09,OCWDRDTE(,OCWPTR)                               1355
         CLI   RPRENTRY(@09),X'50'                                 1355
         BNE   @RF01355                                            1355
         TM    RLNPORT(@09),B'00010000'                            1355
         BNO   @RF01355                                            1355
*     DO;                                                          1356
*       OCWDAF=CSLRDTE->RPRDAF;     /* DAF IS TRML DAF       @D32CKMP*/
         L     @09,CSLRDTE+40(,OCWPTR)                             1357
         MVC   OCWDAF(2,OCWPTR),RPRDAF(@09)                        1357
*       SWITCH=COFF;                /* DM08468                       */
         NI    SWITCH(@10),B'01111111'                             1358
*     END;                                                         1359
*   ELSE                                                           1360
*     IF RPRNSNEA->RPRENTRY=RPRENTCL/* IF TERM BELONGS TO CLUSTER    */
*       THEN                                                       1360
         B     @RC01355                                            1360
@RF01355 L     @10,OCWDRDTE(,OCWPTR)                               1360
         L     @10,RPRNSNEA(,@10)                                  1360
         CLI   RPRENTRY(@10),X'70'                                 1360
         BNE   @RF01360                                            1360
*       DO;                                                        1361
*         OCWDAF=RPRNSNEA->RPRDAF;  /* USE DAF OF CLUSTER            */
         MVC   OCWDAF(2,OCWPTR),RPRDAF(@10)                        1362
*         SWITCH=COFF;              /* DM08468                       */
         NI    SWITCH+176(OCWPTR),B'01111111'                      1363
*         OCWSTCTL=CON;             /* IND CLUSTR STRT CTL   @ZM00768*/
         OI    OCWSTCTL(OCWPTR),B'00100000'                        1364
*       END;                                                       1365
*     ELSE                                                         1366
*       ;                                                          1366
@RF01360 DS    0H                                                  1367
*   IF SWITCH=CON                   /* DM08468                       */
*     THEN                                                         1367
@RC01355 TM    SWITCH+176(OCWPTR),B'10000000'                      1367
         BO    @RT01367                                            1367
*     ;                                                            1368
*   ELSE                                                           1369
*     DO;                                                          1369
*       CALL GETLCPB;               /* GET STOR FOR NMLCPB           */
         BAL   @14,GETLCPB                                         1370
*       IF OCWRC=0                  /* O. K. ?                       */
*         THEN                                                     1371
         CLI   OCWRC(OCWPTR),0                                     1371
         BNE   @RF01371                                            1371
*         CALL DOSTCTL2;            /* DO START START CONTROL I/O    */
         BAL   @14,DOSTCTL2                                        1372
*       ELSE                                                       1373
*         ;                                                        1373
@RF01371 DS    0H                                                  1374
*     END;                                                         1374
*   OCWCID=OCWSORTP;                /* RESTORE OCWCID        @D32CKXY*/
@RT01367 MVC   OCWCID(4,OCWPTR),OCWSORTP(OCWPTR)                   1375
*   C14SVPTR=C14SVPTR-4;                                           1376
         LA    @10,624                                             1376
         ALR   @10,OCWPTR                                          1376
         L     @09,C14SVPTR(,@10)                                  1376
         SH    @09,@CH00045                                        1376
         ST    @09,C14SVPTR(,@10)                                  1376
*   CR14PTR=C14SAVE;                                               1377
         L     CR14PTR,C14SAVE(,@09)                               1377
*   END DOSTCTL;                                                   1378
@EL00005 DS    0H                                                  1378
@EF00005 DS    0H                                                  1378
@ER00005 BR    @14                                                 1378
*DOSTCTL2:                                                         1379
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1379
*                                                                  1379
DOSTCTL2 DS    0H                                                  1380
*/********************************************************************/
*/*  ROUTINE NAME: DOSTCTL2                                          */
*/*  FUNCTION:                                                       */
*/*       CALLED BY DOSTCTL TO ISSUE START CONTROL I/O. THE NMLPB IS */
*/*       INITIALIZED. THE DAF LOCK IS OBTAINED USING THE DAF IN OCW.*/
*/*       IF I/O IS PERMITTED AT THIS TIME,THE NMLPB IS TPQUE'D TO   */
*/*       THE CLIP.THE DAF LOCK IS RELEASED AND RETURN IS TO DOSTCTL */
*/*  ROUTINES CALLED:                                                */
*/*       NONE                                                       */
*/*  MACROS USED:                                                    */
*/*       CIDCTL(FIND)                                               */
*/*       CIDCTL(FINISH)                                             */
*/*       TPQUE                                                      */
*/********************************************************************/
*                                                                  1380
*   C14SAVE=CR14PTR;                /* SUBR RTURN                    */
         LA    @10,624                                             1380
         ALR   @10,OCWPTR                                          1380
         L     @09,C14SVPTR(,@10)                                  1380
         ST    CR14PTR,C14SAVE(,@09)                               1380
*   C14SVPTR=C14SVPTR+4;                                           1381
         AH    @09,@CH00045                                        1381
         ST    @09,C14SVPTR(,@10)                                  1381
*   LCPCID=OCWCID;                  /* CID INTO NMLCPB               */
         L     @10,OCWLCPBA(,OCWPTR)                               1382
         L     @09,OCWCID(,OCWPTR)                                 1382
         ST    @09,LCPCID(,@10)                                    1382
*   NMFNCTCD=NMFCD01;                                              1383
         MVI   NMFNCTCD(@10),X'01'                                 1383
*   CPARMRG2=OCWCID;                /* SET UP REG 2                  */
         LR    CPARMRG2,@09                                        1384
*   DO;                             /* CIDCTL(FIND)                  */
*     RFY                                                          1386
*      (EMCR2,                                                     1386
*       EMCR3) RSTD;                                               1386
*     GEN SETS(RPHWORK)                                            1387
*         (STM EMCR0,EMCR15,RPHWORK(RPHPTR) SAVE REGS IN RPH);     1387
         STM EMCR0,EMCR15,RPHWORK(RPHPTR) SAVE REGS IN RPH
*     EMCR3='00'X;                  /* CLEAR EXTRA BITS              */
         SLR   EMCR3,EMCR3                                         1388
*     EMCR3='01'X;                  /* INDICATE SHARED LOCK          */
         LA    EMCR3,1                                             1389
*     CALL ATCLCPTR->ATCCDFND->ISTSDCCF;/* PROCESS REQUEST           */
         L     @10,ATCLCPTR                                        1390
         L     @15,ATCCDFND(,@10)                                  1390
         BALR  @14,@15                                             1390
*     RFY                                                          1391
*      (EMCR2,                                                     1391
*       EMCR3) UNRSTD;                                             1391
*   END;                            /* CIDCTL GET DAF LOCK SHARED    */
*   RFY                                                            1393
*     ISTFMCB BASED(CPARMR08);                                     1393
*   IF CRETCODE=0                   /* LOCK GOTTEN                   */
*     THEN                                                         1394
         LTR   CRETCODE,CRETCODE                                   1394
         BNZ   @RF01394                                            1394
*     DO;                                                          1395
*       CPARMR08=CPARMRG2;          /* SAVE FMCB PTR                 */
         LR    CPARMR08,CPARMRG2                                   1396
*       OCWCLOCK=CON;               /* LOCK GOTTEN                   */
         OI    OCWCLOCK(OCWPTR),B'00010000'                        1397
*       IF FMCDEVOF=COFF            /* INHIBIT I/O ?                 */
*         THEN                                                     1398
         TM    FMCDEVOF(CPARMR08),B'00010000'                      1398
         BNZ   @RF01398                                            1398
*         DO;                                                      1399
*                                                                  1399
*/*  TPQUE (OCWLCPBA,FMCPAB1) NORM                                   */
*                                                                  1400
*           DO;                                                    1400
*             RFY                                                  1401
*              (GPR00P,                                            1401
*               GPR01P,                                            1401
*               GPR04P,                                            1401
*               GPR05P,                                            1401
*               GPR15P) RSTD;                                      1401
*             GEN REFS(GPR01P) SETS(RPHWORK)                       1402
*                 (STM GPR02P,GPR08P,RPHWORK(GPR01P));             1402
         STM GPR02P,GPR08P,RPHWORK(GPR01P)
*             GPR00P=0;                                            1403
         SLR   GPR00P,GPR00P                                       1403
*             GPR15P=ADDR(FMCPAB1); /* HOLD PAB PTR                  */
         LA    GPR15P,FMCPAB1(,CPARMR08)                           1404
*             GPR04P=OCWLCPBA;      /* WORK ELE PTR                  */
         L     GPR04P,OCWLCPBA(,OCWPTR)                            1405
*             GPR05P=GPR15P;        /* PASS PAB PTR                  */
         LR    GPR05P,GPR15P                                       1406
*             CALL ATCLCPTR->ATCAP37->ISTAPC37;                    1407
         L     @10,ATCLCPTR                                        1407
         L     @15,ATCAP37(,@10)                                   1407
         BALR  @14,@15                                             1407
*             GEN(NOPR  0)                                         1408
*             NOSETS NOREFS;                                       1408
         NOPR  0
*             RFY                                                  1409
*              (GPR00P,                                            1409
*               GPR01P,                                            1409
*               GPR04P,                                            1409
*               GPR05P,                                            1409
*               GPR15P) UNRSTD;                                    1409
*           END;                    /* *** END OF TPQUE GENERATION 1410
*                                      QUEUE ON                      */
*           RFY                                                    1411
*             ISTFMCB BASED(OCWFMCB);                              1411
*           OCWLCPBA=0;             /* GIVE LCPB AWAY                */
         SLR   @10,@10                                             1412
         ST    @10,OCWLCPBA(,OCWPTR)                               1412
*           IF OCWSTCTL=CON         /* WAS STRT TO CLUSTER   @ZM00768*/
*             THEN                  /*                       @ZM00768*/
         TM    OCWSTCTL(OCWPTR),B'00100000'                        1413
         BNO   @RF01413                                            1413
*             FMCSTCTL=CON;         /* IND START CTL FOR CLUS      1414
*                                                            @ZM00768*/
         L     @10,OCWFMCB(,OCWPTR)                                1414
         OI    FMCSTCTL(@10),B'00000001'                           1414
*           ELSE                                                   1415
*             ;                     /*                       @ZM00768*/
@RF01413 DS    0H                                                  1416
*         END;                                                     1416
*       ELSE                                                       1417
*         DO;                                                      1417
         B     @RC01398                                            1417
@RF01398 DS    0H                                                  1418
*           OCWRC='08'X;                                           1418
         MVI   OCWRC(OCWPTR),X'08'                                 1418
*           OCWEC='4A'X;                                           1419
         MVI   OCWEC(OCWPTR),X'4A'                                 1419
*         END;                                                     1420
*       CPARMRG2=OCWCID;            /* SET UP REG 2                  */
@RC01398 L     CPARMRG2,OCWCID(,OCWPTR)                            1421
*       DO;                         /* CIDCTL(FINISH)                */
*         RFY                                                      1423
*          (EMCR2,                                                 1423
*           EMCR3) RSTD;                                           1423
*         GEN SETS(RPHWORK)                                        1424
*             (STM EMCR0,EMCR15,RPHWORK(RPHPTR) SAVE REGS IN RPH); 1424
         STM EMCR0,EMCR15,RPHWORK(RPHPTR) SAVE REGS IN RPH
*         EMCR3='00'X;              /* CLEAR EXTRA BITS              */
         SLR   EMCR3,EMCR3                                         1425
*         CALL ATCLCPTR->ATCCDFIN->ISTSDCCR;/* PROCESS REQUEST       */
         L     @10,ATCLCPTR                                        1426
         L     @15,ATCCDFIN(,@10)                                  1426
         BALR  @14,@15                                             1426
*         RFY                                                      1427
*          (EMCR2,                                                 1427
*           EMCR3) UNRSTD;                                         1427
*       END;                        /* CIDCTL RELE DAF LOCK          */
*       OCWCLOCK=COFF;              /* LOCK RELEASED                 */
         NI    OCWCLOCK(OCWPTR),B'11101111'                        1429
*     END;                                                         1430
*   ELSE                                                           1431
*     DO;                                                          1431
         B     @RC01394                                            1431
@RF01394 DS    0H                                                  1432
*       OCWRC='24'X;                /* SYSTEM ERROR                  */
         MVI   OCWRC(OCWPTR),X'24'                                 1432
*       OCWEC='08'X;                /* LOCK NOT GOTTEN               */
         MVI   OCWEC(OCWPTR),X'08'                                 1433
*     END;                                                         1434
*   C14SVPTR=C14SVPTR-4;                                           1435
@RC01394 LA    @10,624                                             1435
         ALR   @10,OCWPTR                                          1435
         L     @09,C14SVPTR(,@10)                                  1435
         SH    @09,@CH00045                                        1435
         ST    @09,C14SVPTR(,@10)                                  1435
*   CR14PTR=C14SAVE;                                               1436
         L     CR14PTR,C14SAVE(,@09)                               1436
*   END DOSTCTL2;                                                  1437
@EL00006 DS    0H                                                  1437
@EF00006 DS    0H                                                  1437
@ER00006 BR    @14                                                 1437
*DONIBFIL:                                                         1438
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1438
*                                                                  1438
DONIBFIL DS    0H                                                  1439
*/********************************************************************/
*/*  ROUTINE NAME: DONIBFIL                                          */
*/*  FUNCTION:                                                       */
*/*       THIS ROUTINE IS CALLED BY MAIN LINE TO UPDATE THE USER'S   */
*/*       NIB.                                                       */
*/*  ROUTINES CALLED:                                                */
*/*       NONE                                                       */
*/*  MACROS USED:                                                    */
*/*       NONE                                                       */
*/********************************************************************/
*                                                                  1439
*   C14SAVE=CR14PTR;                /* SUBR RTURN                    */
         LA    @10,624                                             1439
         ALR   @10,OCWPTR                                          1439
         L     @09,C14SVPTR(,@10)                                  1439
         ST    CR14PTR,C14SAVE(,@09)                               1439
*   C14SVPTR=C14SVPTR+4;                                           1440
         AH    @09,@CH00045                                        1440
         ST    @09,C14SVPTR(,@10)                                  1440
*   IF CSLNIBF=CON                  /* IF SHOULDER TAPPERS, INFORM   */
*     THEN                                                         1441
         TM    CSLNIBF+40(OCWPTR),B'10000000'                      1441
         BNO   @RF01441                                            1441
*     NIBSHLTP=CON;                 /* USER IN NIB           @D32CKXY*/
         OI    NIBSHLTP+112(OCWPTR),B'00010000'                    1442
*   ELSE                                                           1443
*     ;                             /*                       @D32CKXY*/
@RF01441 DS    0H                                                  1444
*   RFY                                                            1444
*     SORTPTR RSTD;                 /*                       @D32CKXY*/
*   IF OCWDSTNO>1 THEN                                             1445
         LH    @10,OCWDSTNO(,OCWPTR)                               1445
         CH    @10,@CH00068                                        1445
         BNH   @RF01445                                            1445
*     DO;                           /* IF LIST REQUEST       @D32CKXY*/
*       SORTPTR=OCWODLST+(OCWDSTNO*LENGTH(ISTCSL))+OCWODCT1*4;/* PT
*                                      TO LIST NTRY SLOT     @D32CKXY*/
         MH    @10,@CH00033                                        1447
         AL    @10,OCWODLST(,OCWPTR)                               1447
         LH    SORTPTR,OCWODCT1(,OCWPTR)                           1447
         SLA   SORTPTR,2                                           1447
         ALR   @10,SORTPTR                                         1447
         LR    SORTPTR,@10                                         1447
*     END;                          /*                       @D32CKXY*/
*   ELSE                                                           1449
*     SORTPTR=ADDR(OCWCID);         /* PT TO SORT SLOT FOR A SINGLE
*                                      DEST REQUEST          @D32CKXY*/
         B     @RC01445                                            1449
@RF01445 LA    SORTPTR,OCWCID(,OCWPTR)                             1449
*   NIBCID=SORTPTR->SORTCID;        /* PUT CID INTO COPY OF USER'S 1450
*                                      NIB                   @D32CKXY*/
@RC01445 LA    @10,112                                             1450
         ALR   @10,OCWPTR                                          1450
         L     @09,SORTCID(,SORTPTR)                               1450
         ST    @09,NIBCID(,@10)                                    1450
*   RPLARG=SORTPTR->SORTCID;        /* PUT CID INTO RPL      @D32CKXY*/
         L     @07,OCWRPL(,OCWPTR)                                 1451
         ST    @09,RPLARG(,@07)                                    1451
*   RFY                                                            1452
*     SORTPTR UNRSTD;               /*                       @D32CKXY*/
*   RPLNIB=COFF;                    /* RPLARG NOW CONTAINS NIB       */
         NI    RPLNIB(@07),B'11111011'                             1453
*   NIBDEVCH=RPRDEVCH;              /* TERM DEVICE CHAR INTO NIB     */
         L     @09,OCWDRDTE(,OCWPTR)                               1454
         MVC   NIBDEVCH(8,@10),RPRDEVCH(@09)                       1454
*   NIBSYM=RPRNAME;                 /* SYM OF TERM INTO NIB          */
         MVC   NIBSYM(8,@10),RPRNAME(@09)                          1455
*   NIBCON=CON;                     /* INDICATE CONNECTION MADE IN 1456
*                                      NIB                           */
         OI    NIBCON(@10),B'01000000'                             1456
*   C14SVPTR=C14SVPTR-4;                                           1457
         LA    @10,624                                             1457
         ALR   @10,OCWPTR                                          1457
         L     @09,C14SVPTR(,@10)                                  1457
         SH    @09,@CH00045                                        1457
         ST    @09,C14SVPTR(,@10)                                  1457
*   CR14PTR=C14SAVE;                                               1458
         L     CR14PTR,C14SAVE(,@09)                               1458
*   END DONIBFIL;                                                  1459
@EL00007 DS    0H                                                  1459
@EF00007 DS    0H                                                  1459
@ER00007 BR    @14                                                 1459
*DOVALINT:                                                         1460
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1460
*                                                                  1460
DOVALINT DS    0H                                                  1461
*/********************************************************************/
*/*  ROUTINE NAME: DOVALINT                                          */
*/*  FUNCTION:                                                       */
*/*       CALLED BY MAIN LINE TO VALIDATE & COPY THE USER'S NIB INTO */
*/*       OCWDNIB OR TO MERGE OCWDNIB INTO THE USER'S NIB            */
*/*       R0 = POSITIVE - COPY & VALIDATE USER'S NIB                 */
*/*       R0 = NEGATIVE - MERGE OCWDNIB INTO THE NIB POINTED TO BY   */
*/*                       OCWNIB                                     */
*/*  ROUTINES CALLED:                                                */
*/*       ISTOCCNV - COPY OR MERGE USER'S NIB                        */
*/*  MACROS USED:                                                    */
*/*       VSETLCK - TO OBTAIN AND RELEASE THE LOCAL MEMORY LOCK      */
*/*       CRRMAINT - FOOT PRINT                                      */
*/********************************************************************/
*                                                                  1461
*   C14SAVE=CR14PTR;                /* SUBR RTURN                    */
         LA    @10,624                                             1461
         ALR   @10,OCWPTR                                          1461
         L     @09,C14SVPTR(,@10)                                  1461
         ST    CR14PTR,C14SAVE(,@09)                               1461
*   C14SVPTR=C14SVPTR+4;                                           1462
         AH    @09,@CH00045                                        1462
         ST    @09,C14SVPTR(,@10)                                  1462
*   IF OCWRC=0                      /*                       @ZA15100*/
*     THEN                                                         1463
         CLI   OCWRC(OCWPTR),0                                     1463
         BNE   @RF01463                                            1463
*     DO;                           /*                       @ZA15100*/
*       IF OCWMLOCK=CON             /* LOCAL MEMORY LOCK HELD?       */
*         THEN                                                     1465
         TM    OCWMLOCK(OCWPTR),B'00000010'                        1465
         BO    @RT01465                                            1465
*         ;                                                        1466
*       ELSE                                                       1467
*         DO;                                                      1467
*                                                                  1467
*/*VSETLCK  (CRETCODE,OBTAIN,LOCAL,ISTOCCOE,RESET)                   */
*                                                                  1468
*           DO;                     /* DECLARE AND RESTRICT REGS   1468
*                                      2,10,11,12,13,14, AND 15      */
*             RFY                                                  1469
*              (GPR02P,                                            1469
*               GPR10P,                                            1469
*               GPR11P,                                            1469
*               GPR12P,                                            1469
*               GPR13P,                                            1469
*               GPR14P,                                            1469
*               GPR15P) RSTD;       /* SAVE REGS 2 AND 10 THRU 14    */
*             GEN REFS(GPR02F,GPR10F,GPR11F,GPR12F,GPR14F,GPR13P); 1470
         STM   GPR10F,GPR12F,0(GPR13P)
         ST    GPR14F,12(GPR13P)
         ST    GPR02F,16(GPR13P)
*                                   /* INVOKE MODESET TO CHANGE PSW
*                                      PROTECTION KEY TO 0           */
*             GEN SETS(2);                                         1471
         MODESET EXTKEY=ZERO,SAVEKEY=(2),WORKREG=2
*             GPR10P=GPR13P;        /* PUT SAVE AREA ADDR IN R 10  1472
*                                      INVOKE OS/VS SETLOCK MACRO    */
         LR    GPR10P,GPR13P                                       1472
*             GEN REFS(GPR13P,PSALITA,FLC) SETS(GPR12F);           1473
         SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,                        *
               RELATED=ISTOCCOE
*             GPR15P=GPR13P;        /* PUT RETURN CODE IN R 15 INVOKE
*                                      MODESET MACRO TO              */
         LR    GPR15P,GPR13P                                       1474
*             DO;                   /* RESTORE PSW PROTECTION KEY    */
*               GEN SETS(2);                                       1476
         MODESET KEYADDR=(2),WORKREG=2
*             END;                  /* RESTORE REGISTERS             */
*             GEN REFS(GPR10F,GPR13P) SETS(GPR10F,GPR11F,GPR12F,GPR13F,
*                 GPR14F,GPR02F);                                  1478
         LR    GPR13F,GPR10F
         LM    GPR10F,GPR12F,0(GPR13P)
         L     GPR14F,12(GPR13P)
         L     GPR02F,16(GPR13P)
*             IF GPR15F=4 THEN                                     1479
         CH    GPR15F,@CH00045                                     1479
         BNE   @RF01479                                            1479
*               GPR15F=0;                                          1480
         SLR   GPR15F,GPR15F                                       1480
*             CRETCODE=GPR15F;      /* PUT RETURN CODE IN RCREG      */
@RF01479 DS    0H                                                  1482
*             RFY                                                  1482
*              (GPR02P,                                            1482
*               GPR10P,                                            1482
*               GPR11P,                                            1482
*               GPR12P,                                            1482
*               GPR13P,                                            1482
*               GPR14P,                                            1482
*               GPR15P) UNRSTD;                                    1482
*           END;                    /* VSETLCK OBT LOCK              */
*           IF CRETCODE=0           /* LOCK GOTTEN                   */
*             THEN                                                 1484
         LTR   CRETCODE,CRETCODE                                   1484
         BNZ   @RF01484                                            1484
*             OCWMLOCK=CON;         /* INDICATE LOCK GOTTEN          */
         OI    OCWMLOCK(OCWPTR),B'00000010'                        1485
*           ELSE                                                   1486
*             DO;                                                  1486
         B     @RC01484                                            1486
@RF01484 DS    0H                                                  1487
*               OCWRC='24'X;        /* SYSTEM ERROR                  */
         MVI   OCWRC(OCWPTR),X'24'                                 1487
*               OCWEC='01'X;        /* UNEXPECT. COND                */
         MVI   OCWEC(OCWPTR),X'01'                                 1488
*             END;                                                 1489
*         END;                                                     1490
@RC01484 DS    0H                                                  1491
*       IF OCWRC=0                  /* CONTINUE?                     */
*         THEN                                                     1491
@RT01465 CLI   OCWRC(OCWPTR),0                                     1491
         BNE   @RF01491                                            1491
*         DO;                                                      1492
*           CALL ISTOCCNV;          /* VAL &COPY OR MERGE NIBS       */
         L     @15,@CV05197                                        1493
         BALR  @14,@15                                             1493
*           DO;                                                    1494
*                                                                  1494
*/***  CRRMAINT  PROCNM(ISTOCCOE)COMP(OC)FUNC(RET)  **               */
*                                                                  1495
*             DCL                                                  1495
*               CMZK0214 PTR(31) REG(1);                           1495
*             RFY                                                  1496
*              (CMZK0214) RSTD;                                    1496
*                                                                  1496
*             /*******************************************************/
*             /*                                                     */
*             /* ** CLEAR AND SET CURRENT PROCEDURE BIT              */
*             /*                                                     */
*             /*******************************************************/
*                                                                  1497
*             CMZK0214->RPHCRR->CRACRR->OCCCRT='0'B;               1497
         L     @10,RPHCRR(,CMZK0214)                               1497
         L     @10,CRACRR(,@10)                                    1497
         XC    OCCCRT+1(2,@10),OCCCRT+1(@10)                       1497
         MVI   OCCCRT(@10),B'00000000'                             1497
*             CMZK0214->RPHCRR->CRACRR->COCCOE='1'B;               1498
         OI    COCCOE(@10),B'00010000'                             1498
*           END;                    /* FOOTPRINT                     */
*/*VSETLCK  (CRETCODE,RELEASE,LOCAL,ISTOCCOE,SET)                    */
*                                                                  1500
*           DO;                     /* DECLARE AND RESTRICT REGS   1500
*                                      2,10,11,12,13,14, AND 15      */
*             RFY                                                  1501
*              (GPR02P,                                            1501
*               GPR10P,                                            1501
*               GPR11P,                                            1501
*               GPR12P,                                            1501
*               GPR13P,                                            1501
*               GPR14P,                                            1501
*               GPR15P) RSTD;       /* SAVE REGS 2 AND 10 THRU 14    */
*             GEN REFS(GPR02F,GPR10F,GPR11F,GPR12F,GPR14F,GPR13P); 1502
         STM   GPR10F,GPR12F,0(GPR13P)
         ST    GPR14F,12(GPR13P)
         ST    GPR02F,16(GPR13P)
*                                   /* INVOKE MODESET TO CHANGE PSW
*                                      PROTECTION KEY TO 0           */
*             GEN SETS(2);                                         1503
         MODESET EXTKEY=ZERO,SAVEKEY=(2),WORKREG=2
*             GPR10P=GPR13P;        /* PUT SAVE AREA ADDR IN R 10  1504
*                                      INVOKE OS/VS SETLOCK MACRO    */
         LR    GPR10P,GPR13P                                       1504
*             GEN REFS(GPR13P,PSALITA,FLC) SETS(GPR12F);           1505
         SETLOCK RELEASE,TYPE=LOCAL,                                   *
               RELATED=ISTOCCOE
*             GPR15P=GPR13P;        /* PUT RETURN CODE IN R 15 INVOKE
*                                      MODESET MACRO TO              */
         LR    GPR15P,GPR13P                                       1506
*             DO;                   /* RESTORE PSW PROTECTION KEY    */
*               GEN SETS(2);                                       1508
         MODESET KEYADDR=(2),WORKREG=2
*             END;                  /* RESTORE REGISTERS             */
*             GEN REFS(GPR10F,GPR13P) SETS(GPR10F,GPR11F,GPR12F,GPR13F,
*                 GPR14F,GPR02F);                                  1510
         LR    GPR13F,GPR10F
         LM    GPR10F,GPR12F,0(GPR13P)
         L     GPR14F,12(GPR13P)
         L     GPR02F,16(GPR13P)
*             IF GPR15F=4 THEN                                     1511
         CH    GPR15F,@CH00045                                     1511
         BNE   @RF01511                                            1511
*               GPR15F=0;                                          1512
         SLR   GPR15F,GPR15F                                       1512
*             CRETCODE=GPR15F;      /* PUT RETURN CODE IN RCREG      */
@RF01511 DS    0H                                                  1514
*             RFY                                                  1514
*              (GPR02P,                                            1514
*               GPR10P,                                            1514
*               GPR11P,                                            1514
*               GPR12P,                                            1514
*               GPR13P,                                            1514
*               GPR14P,                                            1514
*               GPR15P) UNRSTD;                                    1514
*           END;                    /* VSETLCK RELEASE LOCK          */
*           IF CRETCODE=0           /* LOCK RELE OK?                 */
*             THEN                                                 1516
         LTR   CRETCODE,CRETCODE                                   1516
         BNZ   @RF01516                                            1516
*             OCWMLOCK=COFF;        /* INDICATE LOCK NOT HELD        */
         NI    OCWMLOCK(OCWPTR),B'11111101'                        1517
*           ELSE                                                   1518
*             DO;                                                  1518
         B     @RC01516                                            1518
@RF01516 DS    0H                                                  1519
*               OCWRC='24'X;        /* SYSTEM ERROR                  */
         MVI   OCWRC(OCWPTR),X'24'                                 1519
*               OCWEC='01'X;        /* UNEXPECT COND                 */
         MVI   OCWEC(OCWPTR),X'01'                                 1520
*             END;                                                 1521
*         END;                                                     1522
*       ELSE                                                       1523
*         ;                                                        1523
@RF01491 DS    0H                                                  1524
*     END;                          /*                       @ZA15100*/
*   ELSE                                                           1525
*     ;                             /*                       @ZA15100*/
@RF01463 DS    0H                                                  1526
*   C14SVPTR=C14SVPTR-4;                                           1526
@RC01463 LA    @10,624                                             1526
         ALR   @10,OCWPTR                                          1526
         L     @09,C14SVPTR(,@10)                                  1526
         SH    @09,@CH00045                                        1526
         ST    @09,C14SVPTR(,@10)                                  1526
*   CR14PTR=C14SAVE;                                               1527
         L     CR14PTR,C14SAVE(,@09)                               1527
*   END DOVALINT;                                                  1528
@EL00008 DS    0H                                                  1528
@EF00008 DS    0H                                                  1528
@ER00008 BR    @14                                                 1528
@PB00008 DS    0H                                                  1529
*                                                                  1529
*/*  SEGMENT(DOCONCT)START                                           */
*                                                                  1529
*   DO;                                                            1529
*     GOTO DOCONCT@;                                               1530
         B     DOCONCT@                                            1530
*DOCONCT:                                                          1531
*   END;                                                           1531
*                                                                  1531
DOCONCT  DS    0H                                                  1532
*/********************************************************************/
*/*  ROUTINE NAME: DOCONCT                                           */
*/*  FUNCTION:                                                       */
*/*       INVOKED BY MAIN LINE, THIS ROUTINE DETERMINES IF A BIND    */
*/*       AND/OR START DATA TRAFFIC SHOULD BE DONE FO A LOGICAL UNIT.*/
*/*       IF NOT AN LU OR IF VARY IS THE APPLICATION, NO PROCESSING  */
*/*       IS DONE. OTHERWISE, AN LCPB IS OBTAINED AND THE BIND/SDT IS*/
*/*       DONE. IF THE BIND FAILS, SSCP IS NOTIFIED.                 */
*/*  ROUTINES CALLED:                                                */
*/*       GETRUCB - OBTAIN AN NMLPB                                  */
*/*       SENDBS - ISSUE A BIND AND/OR SDT                           */
*/*       CONERR - NOTIFY SSCP OF AN ALLOC FAILURE                   */
*/*  MACROS USED:                                                    */
*/*       NONE                                                       */
*/********************************************************************/
*                                                                  1532
*   RFY                                                            1532
*     ISTNMLPB BASED(RUCBSTG);      /*                        XM06339*/
*   CALL DOCDFND;                   /* GET DAF LOCK XCLUSIVE @D32CKXY*/
         BAL   @14,DOCDFND                                         1533
*   IF OCWCLOCK=CON THEN                                           1534
         TM    OCWCLOCK(OCWPTR),B'00010000'                        1534
         BNO   @RF01534                                            1534
*     DO;                                                          1535
*       IF RPRENTRY^=RPRENTLU&      /* IS RDT A LOGICAL UNIT         */
*           RPRENTRY^=RPRENTTR      /* IS RDT A TERMINAL             */
*         THEN                                                     1536
         L     @10,OCWDRDTE(,OCWPTR)                               1536
         CLI   RPRENTRY(@10),X'81'                                 1536
         BE    @RF01536                                            1536
         CLI   RPRENTRY(@10),X'80'                                 1536
         BE    @RF01536                                            1536
*         CSLRDTEB=COFF;            /* BIND FAILURE SHOULD NOT BE  1537
*                                      SENT BECAUSE BIND WILL NOT BE
*                                      TRIED                 @D32CKXY*/
         NI    CSLRDTEB+40(OCWPTR),B'10111111'                     1537
*       ELSE                                                       1538
*         DO;                       /* CONTINUE              @D32CKXY*/
         B     @RC01536                                            1538
@RF01536 DS    0H                                                  1539
*           IF OCWNOCON=CON THEN                                   1539
         TM    OCWNOCON(OCWPTR),B'00100000'                        1539
         BO    @RT01539                                            1539
*             ;                     /* IF NO CONNECTION EXISTS- AN 1540
*                                      ACE DOES NOT EXIST    @D32CKXY*/
*           ELSE                                                   1541
*             CALL CKACE;           /* VERIFY ACE EXISTS AND THAT ITS
*                                      RPH MATCHES REG 1     @D32CKXY*/
         BAL   @14,CKACE                                           1541
*           IF CSLRDTEF=CON THEN                                   1542
@RT01539 LA    @10,40                                              1542
         ALR   @10,OCWPTR                                          1542
         TM    CSLRDTEF(@10),B'10000000'                           1542
         BNO   @RF01542                                            1542
*             DO;                   /* IF DEST IS GOOD       @D32CKXY*/
*               IF RPLVTUSE=CON&    /* VARY IS CALLER?               */
*                   RAPALLF=CON     /*                       @D32CKXY*/
*                 THEN                                             1544
         L     @09,OCWRPL(,OCWPTR)                                 1544
         TM    RPLVTUSE+16(@09),B'01000000'                        1544
         BNO   @RF01544                                            1544
         L     @09,OCWARDTE(,OCWPTR)                               1544
         TM    RAPALLF(@09),B'10000000'                            1544
         BNO   @RF01544                                            1544
*                 CSLRDTEB=COFF;    /* BIND WILL NOT BE TRIED@D32CKXY*/
         NI    CSLRDTEB(@10),B'10111111'                           1545
*               ELSE                /* USER APPL IS CALLER           */
*                 IF FMCMODE^='RECORD  '/* MODE = RECORD DM09115     */
*                     &FMCMODE^='ISTYTCM3'/* OR TCAM? DCR37590     1546
*                                                            @XL03HMP*/
*                   THEN                                           1546
         B     @RC01544                                            1546
@RF01544 L     @10,OCWFMCB(,OCWPTR)                                1546
         CLC   FMCMODE(8,@10),@CC04920                             1546
         BE    @RF01546                                            1546
         CLC   FMCMODE(8,@10),@CC05204                             1546
         BE    @RF01546                                            1546
*                   CSLRDTEB=COFF;  /* BIND WILL NOT BE TRIED@D32CKXY*/
         NI    CSLRDTEB+40(OCWPTR),B'10111111'                     1547
*                 ELSE                                             1548
*                   DO;                                            1548
*                                                                  1548
         B     @RC01546                                            1548
@RF01546 DS    0H                                                  1549
*/*START OF CODE FOR D703348                                         */
*                                                                  1549
*                     /***********************************************/
*                     /*                                             */
*                     /* SEGMENT(GETRUCB)REQUEST                     */
*                     /*                                             */
*                     /***********************************************/
*                                                                  1549
*                     DO;                                          1549
*                       GOTO GETRUCB;                              1550
         B     GETRUCB                                             1550
*GETRUCB#:                                                         1551
*                     END;          /* ALLOCATE NMLPB WITH BIND RU   */
GETRUCB# DS    0H                                                  1552
*/*END OF CODE FOR D703348                                           */
*                                                                  1552
*                     IF OCWRC=0    /* SUCCESS?                      */
*                       THEN                                       1552
*                                                                  1552
         CLI   OCWRC(OCWPTR),0                                     1552
         BNE   @RF01552                                            1552
*                       /*********************************************/
*                       /*                                           */
*                       /* SEGMENT(SENDBS)REQUEST                    */
*                       /*                                           */
*                       /*********************************************/
*                                                                  1553
*                       DO;                                        1553
*                         GOTO SENDBS;                             1554
         B     SENDBS                                              1554
*SENDBS#:                                                          1555
*                       END;        /* SEND BIND,SDT TO LU           */
*                     ELSE                                         1556
*                       ;                                          1556
@RF01552 DS    0H                                                  1557
*                   END;            /* END DO TO SEND BIND   @D32CKXY*/
*             END;                  /* END DO FOR GOOD DEST  @D32CKXY*/
*           ELSE                                                   1559
*             ;                     /* DEST IS NOT GOOD      @D32CKXY*/
@RF01542 DS    0H                                                  1560
*         END;                      /* END DO FOR LU OR TERM @D32CKXY*/
*     END;                          /* END DO IF DAF LOCK OBT@D32CKXY*/
*   ELSE                                                           1562
*     ;                             /* DAF LOCK NOT OBT      @D32CKXY*/
@RF01534 DS    0H                                                  1563
*   IF OCWCLOCK=CON THEN                                           1563
@RC01534 TM    OCWCLOCK(OCWPTR),B'00010000'                        1563
         BNO   @RF01563                                            1563
*     DO;                           /* IF DAF LOCK IS HELD   @D32CKXY*/
*       CPARMRG2=OCWCID;            /* SETUP CID             @D32CKXY*/
         L     CPARMRG2,OCWCID(,OCWPTR)                            1565
*       DO;                         /* CIDCTL(FINISH)                */
*         RFY                                                      1567
*          (EMCR2,                                                 1567
*           EMCR3) RSTD;                                           1567
*         GEN SETS(RPHWORK)                                        1568
*             (STM EMCR0,EMCR15,RPHWORK(RPHPTR) SAVE REGS IN RPH); 1568
         STM EMCR0,EMCR15,RPHWORK(RPHPTR) SAVE REGS IN RPH
*         EMCR3='00'X;              /* CLEAR EXTRA BITS              */
         SLR   EMCR3,EMCR3                                         1569
*         CALL ATCLCPTR->ATCCDFIN->ISTSDCCR;/* PROCESS REQUEST       */
         L     @10,ATCLCPTR                                        1570
         L     @15,ATCCDFIN(,@10)                                  1570
         BALR  @14,@15                                             1570
*         RFY                                                      1571
*          (EMCR2,                                                 1571
*           EMCR3) UNRSTD;                                         1571
*       END;                        /* CIDCTL RELEASE DAF LOCK     1572
*                                                            @D32CKXY*/
*       OCWCLOCK=COFF;              /* INDICATE DAF NOT HELD @D32CKXY*/
         NI    OCWCLOCK(OCWPTR),B'11101111'                        1573
*     END;                          /* END DAF RELEASE       @D32CKXY*/
*   ELSE                                                           1575
*     ;                             /* DAF LOCK NOT HELD     @D32CKXY*/
@RF01563 DS    0H                                                  1576
*/*  SEGMENT(DOCONCT)FINISH                                          */
*                                                                  1576
*   DO;                                                            1576
*     GOTO DOCONCT#;                                               1577
         B     DOCONCT#                                            1577
*DOCONCT@:                                                         1578
*   END;                                                           1578
DOCONCT@ DS    0H                                                  1579
*                                                                  1579
*/*  SEGMENT(SENDBS)START                                            */
*                                                                  1579
*   DO;                                                            1579
*     GOTO SENDBS@;                                                1580
         B     SENDBS@                                             1580
*SENDBS:                                                           1581
*   END;                            /* SEND BIND/SDT FOR SESSION     */
SENDBS   DS    0H                                                  1582
*/********************************************************************/
*/*  ROUTINE NAME: SENDBS                                            */
*/*  FUNCTION:                                                       */
*/*       SENBS IS INVOKED BY DOCONCT TO ISSUE A BIND AND/OR SDT. THE*/
*/*       DAF LOCK OF THE LU IS OBTAINED AND THE NMLPB IS TPUED TO   */
*/*       THE SCOP. THE DAF IS RELEASED AND THE ROUTINE TPWAITS FOR  */
*/*       THE BIND TO COMPLETE. UPON COMPLETION, THE FEEDBACK IS     */
*/*       CHECKED AND THE FSB IS RELEASED. IF THE BIND IS SUCCESSFUL,*/
*/*       AND IF THE APPL WANTS VTAM TO ISSUE THE SDT,THIS ROUTINE   */
*/*       REBUILDS THE LCCW IN THE NMLPB AND THE SDT RU. THE PROCESS */
*/*       IS THEN REPEATED.                                          */
*/*  ROUTINES CALLED:                                                */
*/*       NONE                                                       */
*/*  MACROS USED:                                                    */
*/*       CIDCTL - LOCKING AND UNLOCKING THE DAF                     */
*/*       TPQUE - ISSUE THE BIND /SDT I/O                            */
*/*       TPWAIT - WAIT FOR I/O COMPLETION                           */
*/*       RELSTORE - RELEASE THE FSB                                 */
*/*       FREESTOR - RELEASE THE BIND RU                             */
*/********************************************************************/
*                                                                  1582
*   OCWEXIT=COFF;                                                  1582
         NI    OCWEXIT(OCWPTR),B'01111111'                         1582
*   CBNDSDT=1;                      /* INIT LOOP COUNTER             */
         MVC   CBNDSDT+176(2,OCWPTR),@CH00068                      1583
*   DO WHILE(CBNDSDT<=2&OCWRC=0);                                  1584
         B     @DE01584                                            1584
@DL01584 DS    0H                                                  1585
*     IF OCWCLOCK=CON THEN                                         1585
         TM    OCWCLOCK(OCWPTR),B'00010000'                        1585
         BO    @RT01585                                            1585
*       ;                           /* IF DAF LOCK HELD      @D32CKXY*/
*     ELSE                                                         1587
*       DO;                         /* OBTAIN DAF LOCK       @D32CKXY*/
*         CALL DOCDFND;             /* GET DAF LOCK XCLUSIVE@D32CKXY */
         BAL   @14,DOCDFND                                         1588
*         IF OCWCLOCK=CON THEN                                     1589
         TM    OCWCLOCK(OCWPTR),B'00010000'                        1589
         BNO   @RF01589                                            1589
*           DO;                     /* IF DAF LOCK OBTAINED  @D32CKXY
*                                      DOCONCT ENSURES VARY IS NOT 1590
*                                      CALLER                @D32CKXY*/
*             CALL CKACE;           /* VERIFY ACE EXISTS AND THAT ITS
*                                      RPH MATCHES RG 1      @D32CKXY*/
         BAL   @14,CKACE                                           1591
*           END;                    /*                       @D32CKXY*/
*         ELSE                                                     1593
*           ;                       /* DAF LOCK NOT OBT      @D32CKXY*/
@RF01589 DS    0H                                                  1594
*       END;                        /*                       @D32CKXY*/
*     IF CSLRDTEF^=CON THEN         /* IF DEST IS NOT GOOD   @D32CKXY*/
@RT01585 TM    CSLRDTEF+40(OCWPTR),B'10000000'                     1595
         BO    @RF01595                                            1595
*       CBNDSDT=CBNDSDT+1;          /* END LOOP              @D32CKXY*/
         LA    @10,176                                             1596
         ALR   @10,OCWPTR                                          1596
         LA    @09,1                                               1596
         AH    @09,CBNDSDT(,@10)                                   1596
         STH   @09,CBNDSDT(,@10)                                   1596
*     ELSE                                                         1597
*       DO;                         /* DEST IS STILL GOOD    @D32CKXY*/
         B     @RC01595                                            1597
@RF01595 DS    0H                                                  1598
*         IF FMCDEVOF=CON           /* VARY IN PROGRESS              */
*           THEN                                                   1598
         L     @10,OCWFMCB(,OCWPTR)                                1598
         TM    FMCDEVOF(@10),B'00010000'                           1598
         BNO   @RF01598                                            1598
*           DO;                                                    1599
*             OCWRC='08'X;          /* LOGICAL ERROR                 */
         MVI   OCWRC(OCWPTR),X'08'                                 1600
*             OCWEC='4D'X;          /* VARY IN PROGRESS              */
         MVI   OCWEC(OCWPTR),X'4D'                                 1601
*           END;                                                   1602
*         ELSE                                                     1603
*           DO;                                                    1603
         B     @RC01598                                            1603
@RF01598 DS    0H                                                  1604
*             LCPASYN=CON;          /* ASYNCHRONOUS FLAG ON DM09009  */
         L     @10,RUCBSTG(,OCWPTR)                                1604
         OI    LCPASYN(@10),B'01000000'                            1604
*             LCPFTYPE=CON;         /* FDBK- POST RPH IN LCPRPHA   1605
*                                                            @XM00126*/
         OI    LCPFTYPE(@10),B'10000000'                           1605
*/*START OF CODE FOR D703348                                         */
*/*  TPQUE (RUCBSTG,FMCPAB5) NORM                                    */
*                                                                  1606
*             DO;                                                  1606
*               RFY                                                1607
*                (GPR00P,                                          1607
*                 GPR01P,                                          1607
*                 GPR04P,                                          1607
*                 GPR05P,                                          1607
*                 GPR15P) RSTD;                                    1607
*               GEN REFS(GPR01P) SETS(RPHWORK)                     1608
*                   (STM GPR02P,GPR08P,RPHWORK(GPR01P));           1608
         STM GPR02P,GPR08P,RPHWORK(GPR01P)
*               GPR00P=0;                                          1609
         SLR   GPR00P,GPR00P                                       1609
*               GPR15P=ADDR(FMCPAB5);/* HOLD PAB PTR                 */
         L     GPR15P,OCWFMCB(,OCWPTR)                             1610
         LA    GPR15P,FMCPAB5(,GPR15P)                             1610
*               GPR04P=RUCBSTG;     /* WORK ELE PTR                  */
         L     GPR04P,RUCBSTG(,OCWPTR)                             1611
*               GPR05P=GPR15P;      /* PASS PAB PTR                  */
         LR    GPR05P,GPR15P                                       1612
*               CALL ATCLCPTR->ATCAP37->ISTAPC37;                  1613
         L     @10,ATCLCPTR                                        1613
         L     @15,ATCAP37(,@10)                                   1613
         BALR  @14,@15                                             1613
*               GEN(NOPR  0)                                       1614
*               NOSETS NOREFS;                                     1614
         NOPR  0
*               RFY                                                1615
*                (GPR00P,                                          1615
*                 GPR01P,                                          1615
*                 GPR04P,                                          1615
*                 GPR05P,                                          1615
*                 GPR15P) UNRSTD;                                  1615
*             END;                  /* *** END OF TPQUE GENERATION   */
*/*END OF CODE FOR D703348                                           */
*                                                                  1617
*           END;                                                   1617
*         CPARMRG2=OCWCID;          /* CID INTO PARM REG             */
@RC01598 L     CPARMRG2,OCWCID(,OCWPTR)                            1618
*         DO;                       /* CIDCTL(FINISH)                */
*           RFY                                                    1620
*            (EMCR2,                                               1620
*             EMCR3) RSTD;                                         1620
*           GEN SETS(RPHWORK)                                      1621
*               (STM EMCR0,EMCR15,RPHWORK(RPHPTR) SAVE REGS IN RPH);
         STM EMCR0,EMCR15,RPHWORK(RPHPTR) SAVE REGS IN RPH
*           EMCR3='00'X;            /* CLEAR EXTRA BITS              */
         SLR   EMCR3,EMCR3                                         1622
*           CALL ATCLCPTR->ATCCDFIN->ISTSDCCR;/* PROCESS REQUEST     */
         L     @10,ATCLCPTR                                        1623
         L     @15,ATCCDFIN(,@10)                                  1623
         BALR  @14,@15                                             1623
*           RFY                                                    1624
*            (EMCR2,                                               1624
*             EMCR3) UNRSTD;                                       1624
*         END;                      /* CIDCTL RELE DAF LOCK          */
*         OCWCLOCK=COFF;            /* DAF LOCK RELE                 */
         NI    OCWCLOCK(OCWPTR),B'11101111'                        1626
*         IF OCWRC^=0               /* ANY ERRORS?                   */
*           THEN                                                   1627
         CLI   OCWRC(OCWPTR),0                                     1627
         BNE   @RT01627                                            1627
*           ;                                                      1628
*         ELSE                                                     1629
*           DO;                                                    1629
*                                                                  1629
*/*  TPWAIT                                                          */
*                                                                  1630
*             DO;                   /* BEGIN TPWAIT GENERATION       */
*               RFY                                                1631
*                (GPR01P,                                          1631
*                 GPR14P,                                          1631
*                 GPR15P) RSTD;                                    1631
*               RFY                                                1632
*                (GPR00P) RSTD;                                    1632
*               GEN(STM   GPR00P,GPR15P,RPHWORK(GPR01P))           1633
*               REFS(GPR00P,GPR01P,GPR15P) SETS(RPHWORK);          1633
         STM   GPR00P,GPR15P,RPHWORK(GPR01P)
*               RFY                                                1634
*                (GPR00P) UNRSTD;                                  1634
*               GPR15P=ADDR(LHAA0237);                             1635
         LA    GPR15P,LHAA0237                                     1635
*               GPR14P=0;                                          1636
         SLR   GPR14P,GPR14P                                       1636
*               GPR15P=GPR15P&'00FFFFFF'X;                         1637
         N     GPR15P,@CF05091                                     1637
*               GPR15P=GPR15P|RPHWT1;                              1638
         O     GPR15P,@CF01455                                     1638
*               CS(GPR14P,GPR15P,GPR01P->RPHRESMA);                1639
         CS    GPR14P,@15,RPHRESMA(GPR01P)                         1639
*               BC(7,LHAB0237);                                    1640
*                                                                  1640
         BC    7,LHAB0237                                          1640
*/* TPEXIT  NONE                                                     */
*                                                                  1641
*               DO;                                                1641
*                 RESPECIFY                                        1642
*                   GPR15P RSTD;                                   1642
*                                                                  1642
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTATCVT)                               */
*/* END OF ATBUILD                                                   */
*                                                                  1643
*                 DO;               /* LISATCVT                    1643
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*                   GPR15P=ATCLCPTR;/* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     1644
*                 END;              /* LISATCVT                      */
*                 RESPECIFY                                        1646
*                   GPR00F RSTD;                                   1646
*                 GPR00F=0;         /* SET PARAMETER REGISTER TO 0   */
         SLR   GPR00F,GPR00F                                       1647
*                 GPR15P=GPR15P->ATCAP31;                          1648
         L     GPR15P,ATCAP31(,GPR15P)                             1648
*                 DCL                                              1649
*                   FMZL0242 BASED(GPR15P) LABEL VALUERANGE(*);    1649
*                 CALL FMZL0242;                                   1650
         BALR  @14,@15                                             1650
*                 RESPECIFY                                        1651
*                  (GPR00F,                                        1651
*                   GPR15P) UNRSTD;                                1651
*               END;                /* **** END OF TPEXIT            */
*LHAB0237:                                                         1653
*               ;                                                  1653
LHAB0237 DS    0H                                                  1654
*               GPR01P->RPHRESMA=0;                                1654
         SLR   @10,@10                                             1654
         ST    @10,RPHRESMA(,GPR01P)                               1654
*               RFY                                                1655
*                (GPR00P) RSTD;                                    1655
*LHAA0237:                                                         1656
*               ;                                                  1656
LHAA0237 DS    0H                                                  1657
*               GEN(LM    GPR00P,GPR15P,RPHWORK(GPR01P))           1657
*               REFS(RPHWORK,GPR01P) SETS(GPR00P,GPR15P);          1657
         LM    GPR00P,GPR15P,RPHWORK(GPR01P)
*               RFY                                                1658
*                (GPR00P,                                          1658
*                 GPR01P,                                          1658
*                 GPR14P,                                          1658
*                 GPR15P) UNRSTD;                                  1658
*             END;                  /* ****END OF TPWAIT WAIT FOR  1659
*                                      BIND/SDT TO COMP              */
*/*START OF CODE FOR D703348                                         */
*                                                                  1660
*             IF FSBMJRCD=FRNORM&   /* SUCCESS?                      */
*                 ADDR(FSBRHFLD)->RHEXCEPT='0'B                    1660
*                                                                  1660
*/*END OF CODE FOR D703348                                           */
*                                                                  1660
*               THEN                                               1660
         L     @10,RPHWEA(,GPR01P)                                 1660
         CLI   FSBMJRCD(@10),X'00'                                 1660
         BNE   @RF01660                                            1660
         TM    RHEXCEPT+17(@10),B'00010000'                        1660
         BZ    @RT01660                                            1660
*               ;                                                  1661
*             ELSE                                                 1662
*               DO;                                                1662
@RF01660 DS    0H                                                  1663
*                 IF OCWEXIT=CON    /* IF ON SDT FAILED, OFF- BIND 1663
*                                      FAIL                          */
*                   THEN                                           1663
         TM    OCWEXIT(OCWPTR),B'10000000'                         1663
         BNO   @RF01663                                            1663
*                   DO;                                            1664
*                     OCWRC='08'X;  /* LOGIC ERROR           @OZ08433*/
         MVI   OCWRC(OCWPTR),X'08'                                 1665
*                     OCWEC='6B'X;  /* SDT FAILED            @OZ08433*/
         MVI   OCWEC(OCWPTR),X'6B'                                 1666
*                   END;                                           1667
*                 ELSE                                             1668
*                   DO;                                            1668
         B     @RC01663                                            1668
@RF01663 DS    0H                                                  1669
*                     OCWRC='08'X;  /* LOGIC ERROR                   */
         MVI   OCWRC(OCWPTR),X'08'                                 1669
*                     OCWEC='68'X;  /* BIND FAILED                   */
         MVI   OCWEC(OCWPTR),X'68'                                 1670
*                   END;                                           1671
*                 RFY                                              1672
*                   ISTFDB BASED(ADDR(FSBFDB));                    1672
@RC01663 DS    0H                                                  1673
*                 RFY                                              1673
*                   CRELREG RSTD;                                  1673
*                 OCWSENSE=FDBDATAA->RUSENSE;/* SENSE DATA INTO OCW  */
         L     @10,RPHWEA(,GPR01P)                                 1674
         L     @10,FDBDATAA+32(,@10)                               1674
         MVC   OCWSENSE(4,OCWPTR),RUSENSE(@10)                     1674
*               END;                                               1675
*             CRELREG=ADDR(FSBFDB)-FDBOFSET;/* RELE FSB              */
@RT01660 L     @10,RPHWEA(,GPR01P)                                 1676
         LA    CRELREG,FSBFDB(,@10)                                1676
         AH    @10,@CH00126                                        1676
         SH    CRELREG,FDBOFSET(,@10)                              1676
*             CRELREG->CWORD=FDBFDBA;/* FWD PTR INOT BLK             */
*                                                                  1677
         MVC   CWORD(4,CRELREG),FDBFDBA(@10)                       1677
*             /*******************************************************/
*             /*                                                     */
*             /* RELSTORE BUFADDR(CRELREG)                           */
*             /*                                                     */
*             /*******************************************************/
*                                                                  1678
*             DO;                                                  1678
*                                                                  1678
*/* ATBUILD (ISTATCVT,ISTRPH)                                        */
*/* END OF ATBUILD                                                   */
*                                                                  1679
*               RFY                                                1679
*                (GPR02P,                                          1679
*                 GPR03P,                                          1679
*                 GPR04P,                                          1679
*                 GPR15P) RSTD;                                    1679
*               RFY                                                1680
*                (GPR01P,                                          1680
*                 GPR13P) RSTD;                                    1680
*               GENERATE REFS(GPR01P,GPR02P,GPR13P) SETS(RPHWORK); 1681
          STM GPR02P,GPR13P,RPHWORK(GPR01P)
*               RFY                                                1682
*                 GPR13P UNRSTD;                                   1682
*               GPR04P=CRELREG;                                    1683
         LR    GPR04P,CRELREG                                      1683
*               DCL                                                1684
*                 1 FMZA0252 FIXED(31) STATIC LOCAL,               1684
*                  2 * FIXED(8) INIT(64),                          1684
*                  2 * PTR(24) INIT(0);                            1684
*               GPR03F=FMZA0252;                                   1685
         L     GPR03F,FMZA0252                                     1685
*               DO;                 /* LISATCVT                    1686
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*                 GPR15P=ATCLCPTR;  /* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     1687
*               END;                /* LISATCVT                      */
*               GPR02P=GPR15P->ATCBPDA;                            1689
         L     GPR02P,ATCBPDA(,GPR15P)                             1689
*               GPR15P=GPR15P->ATCSMRS;                            1690
         L     GPR15P,ATCSMRS(,GPR15P)                             1690
*               DCL                                                1691
*                 FMZL0252 BASED(GPR15P) LABEL VALUERANGE(*);      1691
*               CALL FMZL0252;                                     1692
         BALR  @14,@15                                             1692
*               RFY                                                1693
*                 GPR13P RSTD;                                     1693
*               GENERATE REFS(GPR01P,RPHWORK) SETS(GPR02P,GPR13P); 1694
          LM GPR02P,GPR13P,RPHWORK(GPR01P)
*               RFY                                                1695
*                (GPR01P,                                          1695
*                 GPR13P) UNRSTD;                                  1695
*               RFY                                                1696
*                (GPR02P,                                          1696
*                 GPR03P,                                          1696
*                 GPR04P,                                          1696
*                 GPR15P) UNRSTD;                                  1696
*             END;                  /* *********END OF RELSTORE    1697
*                                      EXPANSION*********            */
*             RPHWEA=OCWPTR;        /* RESTORE OCW @ IN RPH          */
         ST    OCWPTR,RPHWEA(,GPR01P)                              1698
*             RFY                                                  1699
*               CRELREG UNRSTD;                                    1699
*             IF OCWEXIT=CON        /* SECOND TIME THROUGH SENDBS?   */
*               THEN                                               1700
         TM    OCWEXIT(OCWPTR),B'10000000'                         1700
         BO    @RT01700                                            1700
*               ;                                                  1701
*             ELSE                                                 1702
*               DO;                                                1702
*                 IF OCWRC^=0 THEN                                 1703
         CLI   OCWRC(OCWPTR),0                                     1703
         BNE   @RT01703                                            1703
*                   ;               /* IF ANY ERRORS         @D32CKXY*/
*                 ELSE                                             1705
*                   DO;             /* CONTINUE              @D32CKXY*/
*                     CSLRDTEB=COFF;/* TURN OFF BIT TO SEND BIND   1706
*                                      FAILURE - BIND WENT   @ZA13640*/
         NI    CSLRDTEB+40(OCWPTR),B'10111111'                     1706
*                     RFY                                          1707
*                       CPARMRG2 RSTD;/*                     @ZA30737*/
*                     CPARMRG2=ATCLCPTR;/*                   @ZA30737*/
         L     CPARMRG2,ATCLCPTR                                   1708
*/*   GET SSCP ID                                            @ZA30737*/
*                                                                  1709
*                     GEN(ICM CPARMRG2,12,ATCVTMID(2) )/*    @ZA30737*/
*                     SETS(CPARMRG2) REFS(ATCVTMID);/*       @ZA30737*/
         ICM CPARMRG2,12,ATCVTMID(2)
*/*   GET LU ADDR                                            @ZA30737*/
*                                                                  1710
*                     GEN(ICM CPARMRG2,3,OCWDAF(4) )/*       @ZA30737*/
*                     SETS(CPARMRG2) REFS(OCWDAF);/*         @ZA30737*/
         ICM CPARMRG2,3,OCWDAF(4)
*/*   FIND FMCB FOR SSCP SESSION WITH LU                     @ZA30737*/
*                                                                  1711
*                     DO;           /* CIDCTL(FIND) LOCK(XCLUSIVE)   */
*                       RFY                                        1712
*                        (EMCR2,                                   1712
*                         EMCR3) RSTD;                             1712
*                       GEN SETS(RPHWORK)                          1713
*(STM EMCR0,EMCR15,RPHWORK(RPHPTR) SAVE REGS IN RPH);              1713
         STM EMCR0,EMCR15,RPHWORK(RPHPTR) SAVE REGS IN RPH
*                       EMCR3='00'X;/* CLEAR EXTRA BITS              */
         SLR   EMCR3,EMCR3                                         1714
*                       EMCR3='02'X;/* INDICATE EXCLUSIVE LOCK       */
         LA    EMCR3,2                                             1715
*                       CALL ATCLCPTR->ATCCDFND->ISTSDCCF;/* PROCESS
*                                      REQUEST                       */
         L     @10,ATCLCPTR                                        1716
         L     @15,ATCCDFND(,@10)                                  1716
         BALR  @14,@15                                             1716
*                       RFY                                        1717
*                        (EMCR2,                                   1717
*                         EMCR3) UNRSTD;                           1717
*                     END;          /* CIDCTL                @ZA30737*/
*                     RFY                                          1719
*                       CRETCODE RSTD;/*                     @ZA30737*/
*                     IF CRETCODE^=0/*                       @ZA30737*/
*                       THEN                                       1720
         LTR   CRETCODE,CRETCODE                                   1720
         BNZ   @RT01720                                            1720
*                       ;           /* DO NOTHING            @ZA30737*/
*                     ELSE                                         1722
*                       DO;         /*                       @ZA30737*/
*                         RFY                                      1723
*                           CRETCODE UNRSTD;/*               @ZA30737*/
*                         CPARMRG2->FMCCMDR=COFF;/* TURN OFF INIT  1724
*                                      SELF BIT              @ZA30737*/
*                                                                  1724
         NI    FMCCMDR(CPARMRG2),B'01111111'                       1724
*                         /*******************************************/
*                         /*                                         */
*                         /* BIT IN FMCB                     @ZA30737*/
*                         /*                                         */
*                         /*******************************************/
*                                                                  1725
*                         CPARMRG2=ATCLCPTR;/*               @ZA30737*/
*                                                                  1725
         L     CPARMRG2,ATCLCPTR                                   1725
*                         /*******************************************/
*                         /*                                         */
*                         /* GET SSCP ID                     @ZA30737*/
*                         /*                                         */
*                         /*******************************************/
*                                                                  1726
*                         GEN(ICM CPARMRG2,12,ATCVTMID(2) )/*      1726
*                                                            @ZA30737*/
*                         SETS(CPARMRG2) REFS(ATCVTMID);/*   @ZA30737*/
*                                                                  1726
         ICM CPARMRG2,12,ATCVTMID(2)
*                         /*******************************************/
*                         /*                                         */
*                         /* GET LU ADDR                     @ZA30737*/
*                         /*                                         */
*                         /*******************************************/
*                                                                  1727
*                         GEN(ICM CPARMRG2,3,OCWDAF(4) )/*   @ZA30737*/
*                         SETS(CPARMRG2) REFS(OCWDAF);/*     @ZA30737*/
         ICM CPARMRG2,3,OCWDAF(4)
*                         DO;       /* CIDCTL(FINISH)                */
*                           RFY                                    1729
*                            (EMCR2,                               1729
*                             EMCR3) RSTD;                         1729
*                           GEN SETS(RPHWORK)                      1730
*(STM EMCR0,EMCR15,RPHWORK(RPHPTR) SAVE REGS IN RPH);              1730
         STM EMCR0,EMCR15,RPHWORK(RPHPTR) SAVE REGS IN RPH
*                           EMCR3='00'X;/* CLEAR EXTRA BITS          */
         SLR   EMCR3,EMCR3                                         1731
*                           CALL ATCLCPTR->ATCCDFIN->ISTSDCCR;/*   1732
*                                      PROCESS REQUEST               */
         L     @10,ATCLCPTR                                        1732
         L     @15,ATCCDFIN(,@10)                                  1732
         BALR  @14,@15                                             1732
*                           RFY                                    1733
*                            (EMCR2,                               1733
*                             EMCR3) UNRSTD;                       1733
*                         END;      /* CIDCTL RELEASE DAF LOCK     1734
*                                                            @ZA30737*/
*                         RFY                                      1735
*                           CPARMRG2 UNRSTD;/*               @ZA30737*/
*                       END;        /*                       @ZA30737*/
*                     IF OCWBNDRU^=ADDR(OCWBIND)/* IF BIND RU      1737
*                                      ALLOCATED                     */
*                       THEN        /* BY SMS                        */
@RT01720 LA    @15,OCWBIND(,OCWPTR)                                1737
         C     @15,OCWBNDRU(,OCWPTR)                               1737
         BE    @RF01737                                            1737
*                       DO;         /*                       @D32CKMP*/
*                                                                  1738
*                         /*******************************************/
*                         /*                                         */
*                         /* FREESTOR AREA(OCWBNDRU)SIZE(OCWBNDSZ)SAV*/
*                         /* E(YES)CLEAR(YES)                        */
*                         /*                                         */
*                         /*******************************************/
*                                                                  1739
*                         DO;                                      1739
*                                                                  1739
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTATCVT,ISTRPH)                        */
*/* END OF ATBUILD                                                   */
*                                                                  1740
*                           RFY                                    1740
*                            (GPR00P,                              1740
*                             GPR01P,                              1740
*                             GPR02P,                              1740
*                             GPR03P) RSTD;                        1740
*                           RFY                                    1741
*                             ISTRPH BASED(GPR01P);                1741
*                           GEN REFS(GPR02P,GPR03P,GPR04P,GPR05P,GPR06P
*                               ,GPR07P,GPR08P,GPR09P,GPR10P,GPR11P,
*                               GPR12P,GPR13P) SETS(RPHWORK);      1742
         STM   GPR02P,GPR13P,RPHWORK(GPR01P)        SAVE REGISTERS
*                           GPR00F=OCWBNDSZ;/* SIZE IN REG0          */
         SLR   GPR00F,GPR00F                                       1743
         ICM   GPR00F,3,OCWBNDSZ(OCWPTR)                           1743
*                           DCL                                    1744
*                             1 CMZA0276 FIXED(31) STATIC LOCAL,   1744
*                              2 * FIXED(8) INIT(96),/* OPTION FLAGS */
*                              2 * FIXED(8) INIT(96),/* STORAGE KEY  */
*                              2 * FIXED(8) INIT(231),/* SUBPOOL   1744
*                                      NUMBER                        */
*                              2 * FIXED(8) INIT('01'X);/* REQUEST 1744
*                                      TYPE                          */
*                           GPR03F=CMZA0276;                       1745
         L     GPR03F,CMZA0276                                     1745
*                           RFY                                    1746
*                            (GPR04P) RSTD;                        1746
*                           GPR04P=OCWBNDRU;/* PUT FREEMAIN ADDR IN
*                                      REG4                          */
         L     GPR04P,OCWBNDRU(,OCWPTR)                            1747
*                           DO;     /* LISATCVT                    1748
*                                      CVTBASE(PAGEABLE,(GPR02P))    */
*                             GPR02P=ATCLCPTR;/* SET UP ATCVT POINTER*/
         L     GPR02P,ATCLCPTR                                     1749
*                           END;    /* LISATCVT                      */
*                           CALL GPR02P->ATCGTSTR;/* CALL ISTORFSR   */
         L     @15,ATCGTSTR(,GPR02P)                               1751
         BALR  @14,@15                                             1751
*                           RFY                                    1752
*                            (GPR00P,                              1752
*                             GPR01P,                              1752
*                             GPR02P,                              1752
*                             GPR03P,                              1752
*                             GPR04P) UNRSTD;                      1752
*                         END;      /* END OF FREESTOR               */
*                                                                  1753
*                         /*******************************************/
*                         /*                                         */
*                         /* FREE BIND RU AREA               @D32CKMP*/
*                         /*                                         */
*                         /*******************************************/
*                                                                  1754
*                       END;        /*                       @D32CKMP*/
*                     ELSE                                         1755
*                       ;           /*                       @D32CKMP*/
@RF01737 DS    0H                                                  1756
*                     OCWBNDRU=0;   /* IND NO BIND RU AREA   @D32CKMP*/
         SLR   @15,@15                                             1756
         ST    @15,OCWBNDRU(,OCWPTR)                               1756
*                     IF FMCSDTR^=CON|/* IF SDT NOT REQUIRED @XM00158*/
*                         NIBSDAPP=CON/* IF USER WILL DO SDT @XM00158*/
*                       THEN        /* YES                           */
         L     @15,OCWFMCB(,OCWPTR)                                1757
         TM    FMCSDTR(@15),B'00010000'                            1757
         BNO   @RT01757                                            1757
         TM    NIBSDAPP+112(OCWPTR),B'00100000'                    1757
         BNO   @RF01757                                            1757
@RT01757 DS    0H                                                  1758
*                       CBNDSDT=CBNDSDT+1;/* FORCE END OF LOOP       */
         LA    @15,176                                             1758
         ALR   @15,OCWPTR                                          1758
         LA    @10,1                                               1758
         AH    @10,CBNDSDT(,@15)                                   1758
         STH   @10,CBNDSDT(,@15)                                   1758
*                     ELSE                                         1759
*                       DO;         /* VTAM TO DO SDT                */
         B     @RC01757                                            1759
@RF01757 DS    0H                                                  1760
*                         ISTNMLPB=ISTNMLPB&&ISTNMLPB;/* ZERO LCPB 1760
*                                      FOR REUSE             @XM00126*/
         L     @15,RUCBSTG(,OCWPTR)                                1760
         XC    ISTNMLPB(100,@15),ISTNMLPB(@15)                     1760
*                         LCPRPHA=ADDR(ISTRPH);/* FILL IN RPH ADDRESS
*                                                            @XM00126*/
         ST    GPR01P,LCPRPHA(,@15)                                1761
*                         LCPTYPE=LCPETYPE;/* FILL IN TYPE   @XM00126*/
         MVI   LCPTYPE(@15),X'40'                                  1762
*                         LCPLNGTH=LENGTH(ISTNMLPB);/* FILL IN LENGTH
*                                                            @XM00126*/
         MVI   LCPLNGTH(@15),X'64'                                 1763
*                         LCPCID=OCWCID;/* FILL IN COMMUN ID @XM00126*/
         MVC   LCPCID(4,@15),OCWCID(OCWPTR)                        1764
*                         LCPNXLCW=ADDR(NMLCW2);/* FILL IN NXT LCCW
*                                      AD                    @XM00126*/
         LA    @10,NMLCW2(,@15)                                    1765
         ST    @10,LCPNXLCW(,@15)                                  1765
*                         RFY                                      1766
*                           ISTLCCW BASED(ADDR(NMLCW2));           1766
*                         RFY                                      1767
*                           ISTRH BASED(ADDR(LCCWDATA));/*   @D32CKMP*/
*                         ISTLCCW=ISTLCCW&&ISTLCCW;/* INSURE ZEROED
*                                      LCCW                  @D32CKMP*/
         LA    @10,56                                              1768
         ALR   @10,@15                                             1768
         XC    ISTLCCW(8,@10),ISTLCCW(@10)                         1768
*                         LCCWOP=LSEND;/* IND SEND LCCW              */
         MVI   LCCWOP(@10),X'F1'                                   1769
*                         LCCWIDAT=CON;/* IND IMMEDIATE DATA         */
         OI    LCCWIDAT(@10),B'00001000'                           1770
*                         LCCWCNT=CFOUR;/* IND DATA SIZE             */
         MVC   LCCWCNT(2,@10),@CH00045                             1771
*                         RHTYPE=CON;/* IND RESP TYPE RQST   @D32CKMP*/
*                         RHSCI=CON;/* IND SYS CNTRL RQST    @D32CKMP*/
*                         RHFORMAT=CON;/* IND FORMATTED RQST @D32CKMP*/
         LA    @10,60                                              1774
         ALR   @10,@15                                             1774
         OI    RHTYPE(@10),B'01101000'                             1774
*                         RHCHAIN=RHONLY;/* IND ONLY 1 RH    @D32CKMP*/
         OI    RHCHAIN(@10),B'00000011'                            1775
*                         RHFME=CON;/* IND FME REQUESTED     @D32CKMP*/
         OI    RHFME(@10),B'10000000'                              1776
*                         RFY                                      1777
*                           ISTNIR BASED(ADDR(LCCWDATA));/*  @D32CKMP*/
*                         SRUQSREQ=SRSDT;/* IND SDT RU       @D32CKMP*/
         MVI   SRUQSREQ+63(@15),X'A0'                              1778
*                         OCWEXIT=CON;/* 2ND TIME THROUGH            */
         OI    OCWEXIT(OCWPTR),B'10000000'                         1779
*                       END;                                       1780
*                   END;            /* END DO FOR NO ERR     @D32CKXY*/
@RC01757 DS    0H                                                  1782
*               END;                /* END DO FOR 1ST TIME   @D32CKXY*/
@RT01703 DS    0H                                                  1783
*           END;                    /* END ELSE FOR TPWAIT   @D32CKXY*/
@RT01700 DS    0H                                                  1784
*       END;                        /* END DO FOR GOOD DEST  @D32CKXY*/
@RT01627 DS    0H                                                  1785
*     CBNDSDT=CBNDSDT+1;            /* INCR LOOP CTR                 */
@RC01595 LA    @15,176                                             1785
         ALR   @15,OCWPTR                                          1785
         LA    @10,1                                               1785
         AH    @10,CBNDSDT(,@15)                                   1785
         STH   @10,CBNDSDT(,@15)                                   1785
*   END;                                                           1786
*                                                                  1786
@DE01584 LH    @10,CBNDSDT+176(,OCWPTR)                            1786
         CH    @10,@CH00109                                        1786
         BH    @DC01584                                            1786
         CLI   OCWRC(OCWPTR),0                                     1786
         BE    @DL01584                                            1786
@DC01584 DS    0H                                                  1787
*/*  SEGMENT(SENDBS)FINISH                                           */
*                                                                  1787
*   DO;                                                            1787
*     GOTO SENDBS#;                                                1788
         B     SENDBS#                                             1788
*SENDBS@:                                                          1789
*   END;                                                           1789
SENDBS@  DS    0H                                                  1790
*                                                                  1790
*/*START OF CODE FOR D703348                                         */
*/*  SEGMENT(GETRUCB)START                                           */
*                                                                  1790
*   DO;                                                            1790
*     GOTO GETRUCB@;                                               1791
         B     GETRUCB@                                            1791
*GETRUCB:                                                          1792
*   END;                            /* OBTAIN RUCB IF NEEDED & FORMAT*/
GETRUCB  DS    0H                                                  1793
*/********************************************************************/
*/*  ROUTINE NAME: GETRUCB                                           */
*/*  FUNCTION:                                                       */
*/*       THIS SEGMENT IS INVOKED BY DOCONCT TO INITIALIZE AN NMLPB  */
*/*       AND AN RU FOR A BIND. IF THE USER'S BIND AND DATA WILL NOT */
*/*       FIT IN THE OCW, A BIND RU IS GETSTORED                     */
*/*  ROUTINES CALLED:                                                */
*/*       GETLCPB  - OBTAIN AN NMLPB IF NECESSARY                    */
*/*       ISTINCSH - GET SESSION PARAMETERS                  @D32CKMP*/
*/*  MACROS USED:                                                    */
*/*       GETSTOR  - OBTAIN AN RU                                    */
*/*       VSETLCK  - OBTAIN AND RELEASE LOCAL MEMORY LOCK    @D32CKMP*/
*/*       VALCHEK  - VALIDITY CHECK USER BIND AREA           @D32CKMP*/
*/********************************************************************/
*                                                                  1793
*   IF NIBNDAR^=0                   /* IF USER BIND AREA             */
*     THEN                          /* IN NIB                        */
*                                                                  1793
         ICM   @15,15,NIBNDAR+112(OCWPTR)                          1793
         BZ    @RF01793                                            1793
*     /***************************************************************/
*     /*                                                             */
*     /* THE FUNCTION OF THIS LOGIC SEGMENT IS TO VALIDATE AND COPY  */
*     /* THE BIND RU.                                                */
*     /*                                                             */
*     /***************************************************************/
*                                                                  1794
*VALBNDRU:                                                         1794
*     DO;                           /*                       @D32CKMP*/
VALBNDRU DS    0H                                                  1795
*       IF OCWMLOCK=CON             /* IF LCL MEM LOCKED             */
*         THEN                                                     1795
         TM    OCWMLOCK(OCWPTR),B'00000010'                        1795
         BO    @RT01795                                            1795
*         ;                         /* SKIP LOCKING LCL MEM  @D32CKMP*/
*       ELSE                        /* LCL MEM NOT LOCKED,           */
*         DO;                       /* SO                    @D32CKMP*/
*                                                                  1797
*           /*********************************************************/
*           /*                                                       */
*           /* THE FUNCTION OF THIS LOGIC SEGMENT IS TO OBTAIN THE   */
*           /* LOCAL MEMORY LOCK.                                    */
*           /*                                                       */
*           /*********************************************************/
*                                                                  1798
*SETL:                                                             1798
*           DO;                     /*                       @D32CKMP*/
SETL     DS    0H                                                  1799
*/*VSETLCK  (CRETCODE,OBTAIN,LOCAL,ISTOCCOE,RESETL)                  */
*                                                                  1799
*             DO;                   /* DECLARE AND RESTRICT REGS   1799
*                                      2,10,11,12,13,14, AND 15      */
*               RFY                                                1800
*                (GPR02P,                                          1800
*                 GPR10P,                                          1800
*                 GPR11P,                                          1800
*                 GPR12P,                                          1800
*                 GPR13P,                                          1800
*                 GPR14P,                                          1800
*                 GPR15P) RSTD;     /* SAVE REGS 2 AND 10 THRU 14    */
*               GEN REFS(GPR02F,GPR10F,GPR11F,GPR12F,GPR14F,GPR13P);
         STM   GPR10F,GPR12F,0(GPR13P)
         ST    GPR14F,12(GPR13P)
         ST    GPR02F,16(GPR13P)
*                                   /* INVOKE MODESET TO CHANGE PSW
*                                      PROTECTION KEY TO 0           */
*               GEN SETS(2);                                       1802
         MODESET EXTKEY=ZERO,SAVEKEY=(2),WORKREG=2
*               GPR10P=GPR13P;      /* PUT SAVE AREA ADDR IN R 10  1803
*                                      INVOKE OS/VS SETLOCK MACRO    */
         LR    GPR10P,GPR13P                                       1803
*               GEN REFS(GPR13P,PSALITA,FLC) SETS(GPR12F);         1804
         SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,                        *
               RELATED=ISTOCCOE
*               GPR15P=GPR13P;      /* PUT RETURN CODE IN R 15 INVOKE
*                                      MODESET MACRO TO              */
         LR    GPR15P,GPR13P                                       1805
*               DO;                 /* RESTORE PSW PROTECTION KEY    */
*                 GEN SETS(2);                                     1807
         MODESET KEYADDR=(2),WORKREG=2
*               END;                /* RESTORE REGISTERS             */
*               GEN REFS(GPR10F,GPR13P) SETS(GPR10F,GPR11F,GPR12F, 1809
*                   GPR13F,GPR14F,GPR02F);                         1809
         LR    GPR13F,GPR10F
         LM    GPR10F,GPR12F,0(GPR13P)
         L     GPR14F,12(GPR13P)
         L     GPR02F,16(GPR13P)
*               IF GPR15F=4 THEN                                   1810
         CH    GPR15F,@CH00045                                     1810
         BNE   @RF01810                                            1810
*                 GPR15F=0;                                        1811
         SLR   GPR15F,GPR15F                                       1811
*               CRETCODE=GPR15F;    /* PUT RETURN CODE IN RCREG      */
@RF01810 DS    0H                                                  1813
*               RFY                                                1813
*                (GPR02P,                                          1813
*                 GPR10P,                                          1813
*                 GPR11P,                                          1813
*                 GPR12P,                                          1813
*                 GPR13P,                                          1813
*                 GPR14P,                                          1813
*                 GPR15P) UNRSTD;                                  1813
*             END;                  /* VSETLCK                       */
*           END SETL;               /*                       @D32CKMP*/
*           IF CRETCODE=0           /* IF LOCK OBTAINED              */
*             THEN                  /*                               */
         LTR   CRETCODE,CRETCODE                                   1816
         BNZ   @RF01816                                            1816
*             OCWMLOCK=CON;         /* REMEMBER HAVE LOCK    @D32CKMP*/
         OI    OCWMLOCK(OCWPTR),B'00000010'                        1817
*           ELSE                    /* LOCK NOT OBTAINED,            */
*             DO;                   /* SO                    @D32CKMP*/
         B     @RC01816                                            1818
@RF01816 DS    0H                                                  1819
*               OCWRC='24'X;        /* INDICATE UNEXPECTED   @D32CKMP*/
         MVI   OCWRC(OCWPTR),X'24'                                 1819
*               OCWEC='40'X;        /* SYSTEM ERROR IN OCW   @D32CKMP*/
         MVI   OCWEC(OCWPTR),X'40'                                 1820
*             END;                  /*                       @D32CKMP*/
*         END;                      /*                       @D32CKMP*/
@RC01816 DS    0H                                                  1823
*       IF OCWMLOCK=CON             /* IF LOCAL MEMORY LOCKED        */
*         THEN                      /*                               */
@RT01795 TM    OCWMLOCK(OCWPTR),B'00000010'                        1823
         BNO   @RF01823                                            1823
*         DO;                       /*                       @D32CKMP*/
*                                                                  1824
*           /*********************************************************/
*           /*                                                       */
*           /* THE FUNCTION OF THIS LOGIC SEGMENT IS TO VALIDATE THE */
*           /* BIND RU PROVIDED BY THE USER UP TO AND INCLUDING THE  */
*           /* DATA LENGTH FIELD.                                    */
*           /*                                                       */
*           /*********************************************************/
*                                                                  1825
*VALCKBRU:                                                         1825
*           DO;                     /*                       @D32CKMP*/
VALCKBRU DS    0H                                                  1826
*             RFY                                                  1826
*              (GPR09P,                                            1826
*               GPR11P) RSTD;       /*                       @D32CKMP*/
*             GPR09P=CSAVEPTR+12;   /* PROVIDE SAVE AREA     @D32CKMP*/
         LA    GPR09P,12                                           1827
         ALR   GPR09P,CSAVEPTR                                     1827
*             GPR08P=CSAVEPTR;      /* SAVE SAVE AREA PTR    @D32CKMP*/
         LR    GPR08P,CSAVEPTR                                     1828
*                                                                  1829
*/*VALCHEK  (CRETCODE,(GPR09P),(NIBNDAR),UA,LENGTH(ISTBIND))  RANGE  */
*                                                                  1829
*             DO;                                                  1829
*               RFY                                                1830
*                (GPR01P,                                          1830
*                 GPR02P,                                          1830
*                 GPR04P,                                          1830
*                 GPR06P,                                          1830
*                 GPR13P,                                          1830
*                 GPR14P,                                          1830
*                 GPR15P) RSTD;     /* DECLARE AND RESTRICT REGS 1,
*                                      2, 4, 6, 13,14, AND 15        */
*               CRETCODE=0;         /* SET RETURN CODE TO NO ERROR 1831
*                                      INVOKE XREGSET MACRO TO VERIFY
*                                      SAVEAREA OPERAND AND PUT IT IN
*                                      REG 13                        */
         SLR   CRETCODE,CRETCODE                                   1831
*/*XREGSET  PID('SAVEAREA')PPARM((GPR09P))RREG(13,GPR13P)            */
*                                                                  1832
*               DO;                                                1832
*                 GPR13P=GPR09P;    /* SET RREG SYMBOL TO VALUE OF 1833
*                                      PPARM OPERAND                 */
         LR    GPR13P,GPR09P                                       1833
*               END;                /* XREGSET                       */
*               DCL                                                1835
*                 1 SAV0300 CHAR(20) BASED(GPR13P),/* ESTABLISH SAVE
*                                      AREA MAP                      */
*                  2 SAV10300 CHAR(4),/* TO SAVE REGS 1,2,4,6, AND 14*/
*                  2 SAV20300 CHAR(4),                             1835
*                  2 SAV40300 CHAR(4),                             1835
*                  2 SAV60300 CHAR(4),                             1835
*                  2 SAVE0300 CHAR(4);                             1835
*               SAV10300=GPR01F;    /* SAVE REGS ONE,                */
         ST    GPR01F,SAV10300(,GPR13P)                            1836
*               SAV20300=GPR02F;    /* TWO,                          */
         ST    GPR02F,SAV20300(,GPR13P)                            1837
*               SAV40300=GPR04F;    /* FOUR,                         */
         ST    GPR04F,SAV40300(,GPR13P)                            1838
*               SAV60300=GPR06F;    /* SIX,                          */
         ST    GPR06F,SAV60300(,GPR13P)                            1839
*               SAVE0300=GPR14F;    /* AND FOURTEEN                  */
         ST    GPR14F,SAVE0300(,GPR13P)                            1840
*               GPR04P=GPR01P->RPHTSKID;/* PUT ADDR OF PROCESS SCHED-
*                                      ULING TABLE IN REG 4          */
         L     GPR04P,RPHTSKID(,GPR01P)                            1841
*/* ATBUILD (ISTPST)                                                 */
*                                                                  1842
*               RFY                                                1842
*                 ISTPST;                                          1842
*                                                                  1842
*/* END OF ATBUILD                                                   */
*                                                                  1843
*                                   /* INCLUDE PROCESS SCHEDULING  1843
*                                      TABLE (ISTPST)                */
*               GPR15P=GPR04P->PSTTCBA;/* PUT TASK CONTROL BLOCK   1843
*                                      ADDRESS IN REGISTER 15        */
         L     GPR15P,PSTTCBA(,GPR04P)                             1843
*               GPR04F=SAV40300;    /* RESTORE REG 4 INVOKE XREGSET
*                                      MACRO TO VERIFY USER AREA   1844
*                                      OPERAND AND PUT ADDR IN REG 1 */
         L     @10,SAV40300(,GPR13P)                               1844
         LR    GPR04F,@10                                          1844
*/*XREGSET  PID('USER AREA')PPARM((NIBNDAR))RREG(,GPR01P)            */
*                                                                  1845
*               DO;                                                1845
*                 GPR01P=NIBNDAR;   /* SET RREG SYMBOL TO VALUE OF 1846
*                                      PPARM OPERAND                 */
         L     GPR01P,NIBNDAR+112(,OCWPTR)                         1846
*               END;                /* XREGSET INVOKE XREGSET MACRO
*                                      TO VERIFY LENGTH OPERAND AND
*                                      PUT VALUE IN REG 14           */
*/*XREGSET  PID('LENGTH')PPARM(LENGTH(ISTBIND))RREG(,GPR14F)OUTPUT(PARM
*                                                                    */
*                                                                  1848
*               DO;                                                1848
*                 GPR14F=LENGTH(ISTBIND);/* SET RREG SYMBOL TO VALUE
*                                      OF PPARM OPERAND              */
         LA    GPR14F,36                                           1849
*               END;                /* XREGSET                       */
*               GEN SETS(2);                                       1851
         MODESET EXTKEY=ZERO,SAVEKEY=(2),WORKREG=2
*               GPR06P=GPR02P;                                     1852
         LR    GPR06P,GPR02P                                       1852
*               GPR04P=GPR15P;      /* RESTORE TCB ADDR              */
         LR    GPR04P,GPR15P                                       1853
*               GPR02F=GPR01F+GPR14F-1;/* PUT END ADDRESS IN REG 2   */
         LR    GPR02F,GPR01F                                       1854
         ALR   GPR02F,GPR14F                                       1854
         BCTR  GPR02F,0                                            1854
*               DCL                                                1855
*                 CZMP0300 PTR(31) LOCATION(16);/* ESTABLISH POINTER
*                                      TO CVT                        */
*               CALL CZMP0300->CVT0VL00;/* INVOKE TASK SUPERVISOR  1856
*                                      VALIDITY CHECKING ROUTINE UPON
*                                      RETURN, CHECK PSW CONDITION 1856
*                                      CODE SET BY THE VALIDITY    1856
*                                      CHECKING ROUTINE              */
         L     @10,CZMP0300                                        1856
         L     @15,CVT0VL00(,@10)                                  1856
         BALR  @14,@15                                             1856
*               BC(8,OKAY0300);     /* IF ADDR VALID, DON'T ALTER  1857
*                                      RETURN CODE VALUE FROM 0      */
         BC    8,OKAY0300                                          1857
*               CRETCODE=4;         /* SET RETURN CODE TO ERROR      */
         LA    CRETCODE,4                                          1858
*               GO TO VC30300;                                     1859
         B     VC30300                                             1859
*OKAY0300:                                                         1860
*               CRETCODE=0;         /* PUT RETURN CODE IN RCREG      */
OKAY0300 SLR   CRETCODE,CRETCODE                                   1860
*VC30300:                                                          1861
*               GPR02P=GPR06P;                                     1861
VC30300  LR    GPR02P,GPR06P                                       1861
*               GEN SETS(2);                                       1862
         MODESET KEYADDR=(2),WORKREG=2
*               GPR01F=SAV10300;    /* RESTORE REGS ONE,             */
         L     GPR01F,SAV10300(,GPR13P)                            1863
*               GPR02F=SAV20300;    /* TWO,                          */
         L     GPR02F,SAV20300(,GPR13P)                            1864
*               GPR04F=SAV40300;    /* FOUR,                         */
         L     GPR04F,SAV40300(,GPR13P)                            1865
*               GPR06F=SAV60300;    /* SIX,                          */
         L     GPR06F,SAV60300(,GPR13P)                            1866
*               GPR14F=SAVE0300;    /* AND FOURTEEN                  */
         L     GPR14F,SAVE0300(,GPR13P)                            1867
*               RFY                                                1868
*                (GPR01P,                                          1868
*                 GPR02P,                                          1868
*                 GPR04P,                                          1868
*                 GPR06P,                                          1868
*                 GPR13P,                                          1868
*                 GPR14P,                                          1868
*                 GPR15P) UNRSTD;   /* UNRESTRICT REGISTERS          */
*             END;                  /* VALCHEK VALID USER BIND AREA
*                                                            @D32CKMP*/
*                                                                  1869
*             /*******************************************************/
*             /*                                                     */
*             /* ABOVE LINE CHANGED FOR DCR 3899             @D32CKMP*/
*             /*                                                     */
*             /*******************************************************/
*                                                                  1870
*             CSAVEPTR=GPR08P;      /* REST SAVE AREA PTR    @D32CKMP*/
         LR    CSAVEPTR,GPR08P                                     1870
*             RFY                                                  1871
*              (GPR09P,                                            1871
*               GPR08P) UNRSTD;     /*                       @D32CKMP*/
*           END VALCKBRU;           /*                       @D32CKMP*/
*           DO;                     /* MODESET EXTKEY(ZERO)          */
*             SPKA(0);              /* SET PSW KEY                   */
         SLR   @15,@15                                             1874
         SPKA  0(@15)                                              1874
*           END;                    /* MODESET EXTKEY(ZERO) SET KEY
*                                      TO ALLOW REF OF USER DATA AREA
*                                      AND RET TO VTAM KEY IN RESETL
*                                      SUBRTN                @ZM00805*/
*           IF CRETCODE=0           /* IF AREA VALID                 */
*             THEN                  /*                               */
         SLR   @10,@10                                             1876
         CR    CRETCODE,@10                                        1876
         BNE   @RF01876                                            1876
*             IF NIBNDAR->BINUSEL^=BINUSERD/* IF USER DATA           */
*               THEN                /*                               */
         L     @15,NIBNDAR+112(,OCWPTR)                            1877
         CLI   BINUSEL(@15),0                                      1877
         BE    @RF01877                                            1877
*               DO;                 /*                       @D32CKMP*/
*                                                                  1878
*                 /***************************************************/
*                 /*                                                 */
*                 /* THE FUNCTION OF THIS LOGIC SEGMENT IS TO        */
*                 /* VALIDATE THE USER DATA PORTION OF THE BIND RU   */
*                 /* PROVIDED BY THE USER.                           */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  1879
*VALCKUDT:                                                         1879
*                 DO;               /*                       @D32CKMP*/
VALCKUDT DS    0H                                                  1880
*                   RFY                                            1880
*                    (GPR09P,                                      1880
*                     GPR08P) RSTD; /*                       @D32CKMP*/
*                   GPR09P=CSAVEPTR+12;/* PROVIDE SAVE AREA  @D32CKMP*/
         LA    GPR09P,12                                           1881
         ALR   GPR09P,CSAVEPTR                                     1881
*                   GPR08P=CSAVEPTR;/* SAVE SAVE AREA PTR    @D32CKMP*/
         LR    GPR08P,CSAVEPTR                                     1882
*/*VALCHEK  (CRETCODE,(GPR09P),NIBNDAR->BINUSE,UA,NIBNDAR->BINUSEL)  RA
*GE                                                                  */
*                                                                  1883
*                   DO;                                            1883
*                     RFY                                          1884
*                      (GPR01P,                                    1884
*                       GPR02P,                                    1884
*                       GPR04P,                                    1884
*                       GPR06P,                                    1884
*                       GPR13P,                                    1884
*                       GPR14P,                                    1884
*                       GPR15P) RSTD;/* DECLARE AND RESTRICT REGS 1,
*                                      2, 4, 6, 13,14, AND 15        */
*                     CRETCODE=0;   /* SET RETURN CODE TO NO ERROR 1885
*                                      INVOKE XREGSET MACRO TO VERIFY
*                                      SAVEAREA OPERAND AND PUT IT IN
*                                      REG 13                        */
         SLR   CRETCODE,CRETCODE                                   1885
*/*XREGSET  PID('SAVEAREA')PPARM((GPR09P))RREG(13,GPR13P)            */
*                                                                  1886
*                     DO;                                          1886
*                       GPR13P=GPR09P;/* SET RREG SYMBOL TO VALUE OF
*                                      PPARM OPERAND                 */
         LR    GPR13P,GPR09P                                       1887
*                     END;          /* XREGSET                       */
*                     DCL                                          1889
*                       1 SAV0309 CHAR(20) BASED(GPR13P),/* ESTABLISH
*                                      SAVE AREA MAP                 */
*                        2 SAV10309 CHAR(4),/* TO SAVE REGS 1,2,4,6,
*                                      AND 14                        */
*                        2 SAV20309 CHAR(4),                       1889
*                        2 SAV40309 CHAR(4),                       1889
*                        2 SAV60309 CHAR(4),                       1889
*                        2 SAVE0309 CHAR(4);                       1889
*                     SAV10309=GPR01F;/* SAVE REGS ONE,              */
         ST    GPR01F,SAV10309(,GPR13P)                            1890
*                     SAV20309=GPR02F;/* TWO,                        */
         ST    GPR02F,SAV20309(,GPR13P)                            1891
*                     SAV40309=GPR04F;/* FOUR,                       */
         ST    GPR04F,SAV40309(,GPR13P)                            1892
*                     SAV60309=GPR06F;/* SIX,                        */
         ST    GPR06F,SAV60309(,GPR13P)                            1893
*                     SAVE0309=GPR14F;/* AND FOURTEEN                */
         ST    GPR14F,SAVE0309(,GPR13P)                            1894
*                     GPR04P=GPR01P->RPHTSKID;/* PUT ADDR OF PROCESS
*                                                              SCHED-
*                                      ULING TABLE IN REG 4          */
         L     GPR04P,RPHTSKID(,GPR01P)                            1895
*/* ATBUILD (ISTPST)                                                 */
*/* END OF ATBUILD                                                   */
*                                                                  1896
*                                   /* INCLUDE PROCESS SCHEDULING  1896
*                                      TABLE (ISTPST)                */
*                     GPR15P=GPR04P->PSTTCBA;/* PUT TASK CONTROL   1896
*                                      BLOCK ADDRESS IN REGISTER 15  */
         L     GPR15P,PSTTCBA(,GPR04P)                             1896
*                     GPR04F=SAV40309;/* RESTORE REG 4 INVOKE XREGSET
*                                      MACRO TO VERIFY USER AREA   1897
*                                      OPERAND AND PUT ADDR IN REG 1 */
         L     @10,SAV40309(,GPR13P)                               1897
         LR    GPR04F,@10                                          1897
*/*XREGSET  PID('USER AREA')PPARM(NIBNDAR->BINUSE)RREG(,GPR01P)      */
*                                                                  1898
*                     DO;                                          1898
*                       GPR01P=ADDR(NIBNDAR->BINUSE);/* SET RREG   1899
*                                      SYMBOL TO ADDRESS OF PPARM  1899
*                                      OPERAND                       */
         L     @10,NIBNDAR+112(,OCWPTR)                            1899
         LA    GPR01P,BINUSE(,@10)                                 1899
*                     END;          /* XREGSET INVOKE XREGSET MACRO
*                                      TO VERIFY LENGTH OPERAND AND
*                                      PUT VALUE IN REG 14           */
*/*XREGSET  PID('LENGTH')PPARM(NIBNDAR->BINUSEL)RREG(,GPR14F)OUTPUT(PAR
*)                                                                   */
*                                                                  1901
*                     DO;                                          1901
*                       GPR14F=NIBNDAR->BINUSEL;/* SET RREG SYMBOL TO
*                                      VALUE OF PPARM OPERAND        */
         SLR   GPR14F,GPR14F                                       1902
         IC    GPR14F,BINUSEL(,@10)                                1902
*                     END;          /* XREGSET                       */
*                     GEN SETS(2);                                 1904
         MODESET EXTKEY=ZERO,SAVEKEY=(2),WORKREG=2
*                     GPR06P=GPR02P;                               1905
         LR    GPR06P,GPR02P                                       1905
*                     GPR04P=GPR15P;/* RESTORE TCB ADDR              */
         LR    GPR04P,GPR15P                                       1906
*                     GPR02F=GPR01F+GPR14F-1;/* PUT END ADDRESS IN 1907
*                                      REG 2                         */
         LR    GPR02F,GPR01F                                       1907
         ALR   GPR02F,GPR14F                                       1907
         BCTR  GPR02F,0                                            1907
*                     DCL                                          1908
*                       CZMP0309 PTR(31) LOCATION(16);/* ESTABLISH 1908
*                                      POINTER TO CVT                */
*                     CALL CZMP0309->CVT0VL00;/* INVOKE TASK       1909
*                                      SUPERVISOR VALIDITY CHECKING
*                                      ROUTINE UPON RETURN, CHECK PSW
*                                      CONDITION CODE SET BY THE   1909
*                                      VALIDITY CHECKING ROUTINE     */
         L     @10,CZMP0309                                        1909
         L     @15,CVT0VL00(,@10)                                  1909
         BALR  @14,@15                                             1909
*                     BC(8,OKAY0309);/* IF ADDR VALID, DON'T ALTER 1910
*                                      RETURN CODE VALUE FROM 0      */
         BC    8,OKAY0309                                          1910
*                     CRETCODE=4;   /* SET RETURN CODE TO ERROR      */
         LA    CRETCODE,4                                          1911
*                     GO TO VC30309;                               1912
         B     VC30309                                             1912
*OKAY0309:                                                         1913
*                     CRETCODE=0;   /* PUT RETURN CODE IN RCREG      */
OKAY0309 SLR   CRETCODE,CRETCODE                                   1913
*VC30309:                                                          1914
*                     GPR02P=GPR06P;                               1914
VC30309  LR    GPR02P,GPR06P                                       1914
*                     GEN SETS(2);                                 1915
         MODESET KEYADDR=(2),WORKREG=2
*                     GPR01F=SAV10309;/* RESTORE REGS ONE,           */
         L     GPR01F,SAV10309(,GPR13P)                            1916
*                     GPR02F=SAV20309;/* TWO,                        */
         L     GPR02F,SAV20309(,GPR13P)                            1917
*                     GPR04F=SAV40309;/* FOUR,                       */
         L     GPR04F,SAV40309(,GPR13P)                            1918
*                     GPR06F=SAV60309;/* SIX,                        */
         L     GPR06F,SAV60309(,GPR13P)                            1919
*                     GPR14F=SAVE0309;/* AND FOURTEEN                */
         L     GPR14F,SAVE0309(,GPR13P)                            1920
*                     RFY                                          1921
*                      (GPR01P,                                    1921
*                       GPR02P,                                    1921
*                       GPR04P,                                    1921
*                       GPR06P,                                    1921
*                       GPR13P,                                    1921
*                       GPR14P,                                    1921
*                       GPR15P) UNRSTD;/* UNRESTRICT REGISTERS       */
*                   END;            /* VALCHEK VALID USER DATA AREA
*                                                            @D32CKMP*/
*                   CSAVEPTR=GPR08P;/* REST SAVE AREA PTR    @D32CKMP*/
         LR    CSAVEPTR,GPR08P                                     1923
*                   RFY                                            1924
*                    (GPR09P,                                      1924
*                     GPR08P) UNRSTD;/*                      @D32CKMP*/
*                 END VALCKUDT;     /*                       @D32CKMP*/
*                 IF CRETCODE=0     /* IF AREA VALID                 */
*                   THEN            /*                               */
         LTR   CRETCODE,CRETCODE                                   1926
         BNZ   @RF01926                                            1926
*                   IF NIBNDAR->BINUSEL<=BINUSERN/* IF USER          */
*                     THEN          /* BIND WILL FIT IN OCW  @D32CKMP*/
         L     @15,NIBNDAR+112(,OCWPTR)                            1927
         CLI   BINUSEL(@15),8                                      1927
         BH    @RF01927                                            1927
*                     DO;           /*                       @D32CKMP*/
*                       RFY                                        1929
*                         GPR09P RSTD;/*                     @D32CKMP*/
*                       GPR09P=LENGTH(ISTBIND)+NIBNDAR->BINUSEL;/* 1930
*                                      CALC LENGTH TO COPY   @D32CKMP*/
         LA    GPR09P,36                                           1930
         SLR   @10,@10                                             1930
         IC    @10,BINUSEL(,@15)                                   1930
         ALR   GPR09P,@10                                          1930
*                       OCWBINDA(1:GPR09P)=NIBNDAR->ISTBIND(1:GPR09P);
         LR    @10,GPR09P                                          1931
         BCTR  @10,0                                               1931
         EX    @10,@SM06199                                        1931
*                                   /* COPY USER BIND AREA   @D32CKMP*/
*                       OCWBNDRU=ADDR(OCWBIND);/* POINT AT BIND RU 1932
*                                      AREA IN OCW           @D32CKMP*/
         LA    @15,OCWBIND(,OCWPTR)                                1932
         ST    @15,OCWBNDRU(,OCWPTR)                               1932
*                       OCWBNDSZ=GPR09P+1;/* SAVE BIND RU SIZE IN OCW
*                                                            @D32CKMP*/
         LA    @15,1                                               1933
         ALR   @15,GPR09P                                          1933
         STH   @15,OCWBNDSZ(,OCWPTR)                               1933
*                       RFY                                        1934
*                         GPR09P UNRSTD;/*                   @D32CKMP*/
*                     END;          /*                       @D32CKMP*/
*                   ELSE            /* USER BIND AND DATA            */
*                     DO;           /* NOT FIT IN OCW, SO    @D32CKMP*/
         B     @RC01927                                            1936
@RF01927 DS    0H                                                  1937
*                       RFY                                        1937
*                         GPR09P RSTD;/*                     @D32CKMP*/
*                       GPR09P=LENGTH(ISTBIND)+NIBNDAR->BINUSEL+1;/*
*                                      CALC LENGTH AREA NEEDED     1938
*                                                            @D32CKMP*/
*                                                                  1938
         L     @15,NIBNDAR+112(,OCWPTR)                            1938
         LA    GPR09P,37                                           1938
         SLR   @10,@10                                             1938
         IC    @10,BINUSEL(,@15)                                   1938
         ALR   GPR09P,@10                                          1938
*                       /*********************************************/
*                       /*                                           */
*                       /* THE FUNCTION OF THIS LOGIC SEGMENT OBTAIN */
*                       /* AN AREA LARGE ENOUGH TO CONTAIN THE BIND  */
*                       /* RU AND USER DATA.                         */
*                       /*                                           */
*                       /*********************************************/
*                                                                  1939
*GETBNDST:                                                         1939
*                       DO;         /*                       @D32CKMP*/
*                                                                  1939
GETBNDST DS    0H                                                  1940
*                         /*******************************************/
*                         /*                                         */
*                         /* GETSTOR SIZE(GPR09P)SAVE(YES)CLEAR(YES) */
*                         /*                                         */
*                         /*******************************************/
*                                                                  1940
*                         DO;                                      1940
*                                                                  1940
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTATCVT,ISTRPH)                        */
*/* END OF ATBUILD                                                   */
*                                                                  1941
*                           RFY                                    1941
*                            (GPR00P,                              1941
*                             GPR01P,                              1941
*                             GPR02P,                              1941
*                             GPR03P) RSTD;                        1941
*                           RFY                                    1942
*                             ISTRPH BASED(GPR01P);                1942
*                           GEN REFS(GPR02P,GPR03P,GPR04P,GPR05P,GPR06P
*                               ,GPR07P,GPR08P,GPR09P,GPR10P,GPR11P,
*                               GPR12P,GPR13P) SETS(RPHWORK);      1943
         STM   GPR02P,GPR13P,RPHWORK(GPR01P)        SAVE REGISTERS
*                           GPR00F=GPR09P;/* SIZE IN REG0            */
         LR    GPR00F,GPR09P                                       1944
*                           DCL                                    1945
*                             1 CMZA0316 FIXED(31) STATIC LOCAL,   1945
*                              2 * FIXED(8) INIT(96),/* OPTION FLAGS */
*                              2 * FIXED(8) INIT(96),/* STORAGE KEY  */
*                              2 * FIXED(8) INIT(231),/* SUBPOOL   1945
*                                      NUMBER                        */
*                              2 * FIXED(8) INIT('00'X);/* REQUEST 1945
*                                      TYPE                          */
*                           GPR03F=CMZA0316;                       1946
         L     GPR03F,CMZA0316                                     1946
*                           DO;     /* LISATCVT                    1947
*                                      CVTBASE(PAGEABLE,(GPR02P))    */
*                             GPR02P=ATCLCPTR;/* SET UP ATCVT POINTER*/
         L     GPR02P,ATCLCPTR                                     1948
*                           END;    /* LISATCVT                      */
*                           CALL GPR02P->ATCGTSTR;/* CALL ISTORFSR   */
         L     @15,ATCGTSTR(,GPR02P)                               1950
         BALR  @14,@15                                             1950
*                           RFY                                    1951
*                            (GPR00P,                              1951
*                             GPR01P,                              1951
*                             GPR02P,                              1951
*                             GPR03P) UNRSTD;                      1951
*                         END;      /* END OF GETSTOR                */
*                                                                  1952
*                         /*******************************************/
*                         /*                                         */
*                         /* GET BIND RU AREA                @D32CKMP*/
*                         /*                                         */
*                         /*******************************************/
*                                                                  1953
*                       END GETBNDST;/*                      @D32CKMP*/
*                       IF CRETCODE=0/* IF AREA OBTAINED             */
*                         THEN      /*                               */
         LTR   CRETCODE,CRETCODE                                   1954
         BNZ   @RF01954                                            1954
*                         DO;       /*                       @D32CKMP*/
*                           OCWBNDRU=RPHSRPRM;/* POINT AT AREA     1956
*                                                            @D32CKMP*/
         L     @15,RPHSRPRM(,GPR01P)                               1956
         ST    @15,OCWBNDRU(,OCWPTR)                               1956
*                           OCWBNDSZ=GPR09P;/* SAVE SIZE OF AREA   1957
*                                                            @D32CKMP*/
         STH   GPR09P,OCWBNDSZ(,OCWPTR)                            1957
*                           GPR09P=GPR09P-1;/* RECALC LEN TO COPY  1958
*                                                            @D32CKMP*/
         BCTR  GPR09P,0                                            1958
*                           RPHSRPRM=RPHSRPRM+1;/* SET COPY TO PTR 1959
*                                                            @D32CKMP*/
         AL    @15,@CF00068                                        1959
         ST    @15,RPHSRPRM(,GPR01P)                               1959
*                           RPHSRPRM->ISTBIND(1:GPR09P)=NIBNDAR->  1960
*                               ISTBIND(1:GPR09P);/* COPY USER BIND
*                                      AND DATA TO AREA      @D32CKMP*/
         LR    @10,GPR09P                                          1960
         BCTR  @10,0                                               1960
         L     @05,NIBNDAR+112(,OCWPTR)                            1960
         EX    @10,@SM06201                                        1960
*                         END;      /*                       @D32CKMP*/
*                       ELSE        /* AREA NOT OBTAINED,    @D32CKMP*/
*                         DO;       /* SO                    @D32CKMP*/
         B     @RC01954                                            1962
@RF01954 DS    0H                                                  1963
*                           OCWRC='14'X;/* INDICATE STRG     @D32CKMP*/
         MVI   OCWRC(OCWPTR),X'14'                                 1963
*                           OCWEC='01'X;/* TEMP ERROR IN OCW @D32CKMP*/
         MVI   OCWEC(OCWPTR),X'01'                                 1964
*                         END;      /*                       @D32CKMP*/
*                       RFY                                        1966
*                         GPR09P UNRSTD;/*                   @D32CKMP*/
@RC01954 DS    0H                                                  1967
*                     END;          /*                       @D32CKMP*/
*                 ELSE              /* AREA NOT VALID,               */
*                   DO;             /* SO                    @D32CKMP*/
         B     @RC01926                                            1968
@RF01926 DS    0H                                                  1969
*                     OCWRC='08'X;  /* INDICATE INVALID USR  @D32CKMP*/
         MVI   OCWRC(OCWPTR),X'08'                                 1969
*                     OCWEC='17'X;  /* DATA AREA LOGIC ERROR IN OCW
*                                                            @D32CKMP*/
         MVI   OCWEC(OCWPTR),X'17'                                 1970
*                   END;            /*                       @D32CKMP*/
*               END;                /*                       @D32CKMP*/
*             ELSE                  /* NO USER DATA,                 */
*               DO;                 /* SO                    @D32CKMP*/
         B     @RC01877                                            1973
@RF01877 DS    0H                                                  1974
*                 RFY                                              1974
*                   GPR09P RSTD;    /*                       @D32CKMP*/
*                 GPR09P=LENGTH(ISTBIND);/* CALC LEN TO COPY @D32CKMP*/
         LA    GPR09P,36                                           1975
*                 OCWBINDA(1:GPR09P)=NIBNDAR->ISTBIND(1:GPR09P);/* 1976
*                                      COPY USER BIND AREA   @D32CKMP*/
         LR    @15,GPR09P                                          1976
         BCTR  @15,0                                               1976
         L     @10,NIBNDAR+112(,OCWPTR)                            1976
         EX    @15,@SM06203                                        1976
*                 OCWBNDSZ=GPR09P+1;/* SAVE BIND RU SIZE IN OCW    1977
*                                                            @D32CKMP*/
         LA    @15,1                                               1977
         ALR   @15,GPR09P                                          1977
         STH   @15,OCWBNDSZ(,OCWPTR)                               1977
*                 RFY                                              1978
*                   GPR09P UNRSTD;  /*                       @D32CKMP*/
*                 OCWBNDRU=ADDR(OCWBIND);/* POINT AT BIND RU AREA IN
*                                      OCW                   @D32CKMP*/
         LA    @15,OCWBIND(,OCWPTR)                                1979
         ST    @15,OCWBNDRU(,OCWPTR)                               1979
*               END;                /*                       @D32CKMP*/
*           ELSE                    /* AREA NOT VALID,               */
*             DO;                   /* SO                    @D32CKMP*/
         B     @RC01876                                            1981
@RF01876 DS    0H                                                  1982
*               OCWRC='08'X;        /* INDCIATE INVALID USR  @D32CKMP*/
         MVI   OCWRC(OCWPTR),X'08'                                 1982
*               OCWEC='17'X;        /* DATA AREA LOGIC ERR IN OCW  1983
*                                                            @D32CKMP*/
         MVI   OCWEC(OCWPTR),X'17'                                 1983
*             END;                  /*                       @D32CKMP*/
*                                                                  1984
*           /*********************************************************/
*           /*                                                       */
*           /* THE FUNCTION OF THIS LOGIC SEGMENT IS TO RELEASE THE  */
*           /* LOCAL MEMORY LOCK OBTAINED BY THE SETL LOGIC SEGMENT  */
*           /*                                                       */
*           /*********************************************************/
*                                                                  1985
*RESETL:                                                           1985
*           DO;                     /*                       @D32CKMP*/
@RC01876 DS    0H                                                  1985
RESETL   DS    0H                                                  1986
*             DO;                   /* MODESET EXTKEY(VTAM)          */
*               SPKA(96);           /* SET PSW KEY                   */
         LA    @15,96                                              1987
         SPKA  0(@15)                                              1987
*             END;                  /* MODESET EXTKEY(VTAM) RESTORE
*                                      VTAM KEY- KEY WAS CHGED JUST
*                                      AFTER SETL GOT LCL MEM LOCK 1988
*                                                            @ZM00805*/
*/*VSETLCK  (CRETCODE,RELEASE,LOCAL,ISTOCCOE,SETL)                   */
*                                                                  1989
*             DO;                   /* DECLARE AND RESTRICT REGS   1989
*                                      2,10,11,12,13,14, AND 15      */
*               RFY                                                1990
*                (GPR02P,                                          1990
*                 GPR10P,                                          1990
*                 GPR11P,                                          1990
*                 GPR12P,                                          1990
*                 GPR13P,                                          1990
*                 GPR14P,                                          1990
*                 GPR15P) RSTD;     /* SAVE REGS 2 AND 10 THRU 14    */
*               GEN REFS(GPR02F,GPR10F,GPR11F,GPR12F,GPR14F,GPR13P);
         STM   GPR10F,GPR12F,0(GPR13P)
         ST    GPR14F,12(GPR13P)
         ST    GPR02F,16(GPR13P)
*                                   /* INVOKE MODESET TO CHANGE PSW
*                                      PROTECTION KEY TO 0           */
*               GEN SETS(2);                                       1992
         MODESET EXTKEY=ZERO,SAVEKEY=(2),WORKREG=2
*               GPR10P=GPR13P;      /* PUT SAVE AREA ADDR IN R 10  1993
*                                      INVOKE OS/VS SETLOCK MACRO    */
         LR    GPR10P,GPR13P                                       1993
*               GEN REFS(GPR13P,PSALITA,FLC) SETS(GPR12F);         1994
         SETLOCK RELEASE,TYPE=LOCAL,                                   *
               RELATED=ISTOCCOE
*               GPR15P=GPR13P;      /* PUT RETURN CODE IN R 15 INVOKE
*                                      MODESET MACRO TO              */
         LR    GPR15P,GPR13P                                       1995
*               DO;                 /* RESTORE PSW PROTECTION KEY    */
*                 GEN SETS(2);                                     1997
         MODESET KEYADDR=(2),WORKREG=2
*               END;                /* RESTORE REGISTERS             */
*               GEN REFS(GPR10F,GPR13P) SETS(GPR10F,GPR11F,GPR12F, 1999
*                   GPR13F,GPR14F,GPR02F);                         1999
         LR    GPR13F,GPR10F
         LM    GPR10F,GPR12F,0(GPR13P)
         L     GPR14F,12(GPR13P)
         L     GPR02F,16(GPR13P)
*               IF GPR15F=4 THEN                                   2000
         CH    GPR15F,@CH00045                                     2000
         BNE   @RF02000                                            2000
*                 GPR15F=0;                                        2001
         SLR   GPR15F,GPR15F                                       2001
*               CRETCODE=GPR15F;    /* PUT RETURN CODE IN RCREG      */
@RF02000 DS    0H                                                  2003
*               RFY                                                2003
*                (GPR02P,                                          2003
*                 GPR10P,                                          2003
*                 GPR11P,                                          2003
*                 GPR12P,                                          2003
*                 GPR13P,                                          2003
*                 GPR14P,                                          2003
*                 GPR15P) UNRSTD;                                  2003
*             END;                  /* VSETLCK                       */
*           END RESETL;             /*                       @D32CKMP*/
*           IF CRETCODE=0           /* IF LOCK RELEASED              */
*             THEN                  /*                               */
         LTR   CRETCODE,CRETCODE                                   2006
         BNZ   @RF02006                                            2006
*             OCWMLOCK=COFF;        /* REMEMBER LOCK RELEAS  @D32CKMP*/
         NI    OCWMLOCK(OCWPTR),B'11111101'                        2007
*           ELSE                    /* LOCK NOT RELEASED,            */
*             DO;                   /* SO                    @D32CKMP*/
         B     @RC02006                                            2008
@RF02006 DS    0H                                                  2009
*               OCWRC='24'X;        /* INDICATE UNEXPECTED   @D32CKMP*/
         MVI   OCWRC(OCWPTR),X'24'                                 2009
*               OCWEC='40'X;        /* SYSTEM ERROR IN OCW   @D32CKMP*/
         MVI   OCWEC(OCWPTR),X'40'                                 2010
*             END;                  /* LCL MEM NOT LOCKED    @D32CKMP*/
*         END;                      /*                       @D32CKMP*/
*       ELSE                                                       2013
*         ;                         /* LCL MEM NOT LOCKED    @D32CKMP*/
@RF01823 DS    0H                                                  2014
*     END VALBNDRU;                 /*                       @D32CKMP*/
*   ELSE                            /* NO USER BIND AREA,            */
*     DO;                           /* SO                            */
         B     @RC01793                                            2015
@RF01793 DS    0H                                                  2016
*       IF NIBLMODE='        '|     /* IF NO USER LOGMODE            */
*           NIBLMODE='0000000000000000'X/*                   @DM13319*/
*         THEN                      /* IN NIB                @D32CKMP*/
         LA    @15,112                                             2016
         ALR   @15,OCWPTR                                          2016
         CLC   NIBLMODE(8,@15),@CC05285                            2016
         BE    @RT02016                                            2016
         CLC   NIBLMODE(8,@15),@CB05286                            2016
         BNE   @RF02016                                            2016
@RT02016 DS    0H                                                  2017
*         IF RPLODACQ=CON           /* IF CALLER OPNDST ACQ          */
*           THEN                                                   2017
         L     @15,OCWRPL(,OCWPTR)                                 2017
         TM    RPLODACQ(@15),B'10000000'                           2017
         BNO   @RF02017                                            2017
*           DO;                     /* BIND RFYS ADDED       @DM13320*/
*             RFY                                                  2019
*               ISTBIND BASED(ADDR(OCWBINDA));/*             @DM13320*/
*             BINPRIM=' ';          /* USE BLANK LOGMODE     @D32CKMP*/
         MVI   BINPRIM+798(OCWPTR),C' '                            2020
         MVC   BINPRIM+799(6,OCWPTR),BINPRIM+798(OCWPTR)           2020
         MVI   BINPRIM+797(OCWPTR),C' '                            2020
*             RFY                                                  2021
*               ISTBIND BASED((OCWBNDRU)+1);/*               @DM13320*/
*           END;                    /*                       @DM13320*/
*         ELSE                      /*                               */
*           IF OCWODNAS->CSLDATA^=0 /* IF SESS PARMS RTRND           */
*             THEN                  /* BY CONN SVC                   */
         B     @RC02017                                            2023
@RF02017 L     @15,OCWODNAS(,OCWPTR)                               2023
         L     @15,CSLDATA(,@15)                                   2023
         LTR   @15,@15                                             2023
         BZ    @RF02023                                            2023
*             DO;                   /*                       @D32CKMP*/
*               OCWBNDRU=ADDR(OCWBIND);/* PT AT OCW BND RU   @D32CKMP*/
         LA    @10,OCWBIND(,OCWPTR)                                2025
         ST    @10,OCWBNDRU(,OCWPTR)                               2025
*               OCWBNDSZ=LENGTH(ISTBIND)+1;/* SAVE BIND RU SIZE IN 2026
*                                      OCW                    @D@CKMP*/
         MVC   OCWBNDSZ(2,OCWPTR),@CH06177                         2026
*               RFY                                                2027
*                 ISTLGPFX BASED(OCWODNAS->CSLDATA);/*       @D32CKMP*/
*               ISTBIND(1:LENGTH(ISTBIND))=LGPSESSP;/* COPY SESS   2028
*                                      PARMS FROM CON SVC TO OCW BIND
*                                      AREA                  @D32CKMP*/
         AH    @10,@CH00068                                        2028
         MVC   ISTBIND(36,@10),LGPSESSP(@15)                       2028
*               BINUSEL=BINUSERD;   /* SET DEFLT USER DATA LENGTH  2029
*                                                            @D32CKMP*/
         MVI   BINUSEL(@10),X'00'                                  2029
*             END;                  /*                       @D32CKMP*/
*           ELSE                    /* NO SESS PARMS, SO     @D32CKMP*/
*             IF CSLRDTE->RPRENTRY=RPRENTLU/* IF LU                  */
*               THEN                /*                       @D32CKMP*/
         B     @RC02023                                            2031
@RF02023 L     @15,CSLRDTE+40(,OCWPTR)                             2031
         CLI   RPRENTRY(@15),X'81'                                 2031
         BNE   @RF02031                                            2031
*               DO;                 /* BIND RFY ADDED        @DM13320*/
*                 RFY                                              2033
*                   ISTBIND BASED(ADDR(OCWBINDA));/*         @DM13320*/
*                 BINPRIM=CSLRDTE->RLULGMOD;/* GET LOGMODE FROM LU 2034
*                                      RDTE                  @D32CKMP*/
         MVC   BINPRIM+797(8,OCWPTR),RLULGMOD(@15)                 2034
*               END;                /*                       @DM13320*/
*             ELSE                  /* NOT LU RDTE, SO               */
*               BINPRIM=' ';        /* USE BLANK LOGMODE     @D32CKMP*/
         B     @RC02031                                            2036
@RF02031 MVI   BINPRIM+798(OCWPTR),C' '                            2036
         MVC   BINPRIM+799(6,OCWPTR),BINPRIM+798(OCWPTR)           2036
         MVI   BINPRIM+797(OCWPTR),C' '                            2036
*       ELSE                        /* LOGMODE SPEC IN NIB   @D32CKMP*/
*         DO;                       /* BIND RFY ADDED        @DM13320*/
         B     @RC02016                                            2037
@RF02016 DS    0H                                                  2038
*           BINPRIM=NIBLMODE;       /* SO COPY IT            @D32CKMP*/
         MVC   BINPRIM+797(8,OCWPTR),NIBLMODE+112(OCWPTR)          2038
*           RFY                                                    2039
*             ISTBIND BASED((OCWBNDRU)+1);/*                 @DM13320*/
*         END;                      /*                       @DM13320*/
*       IF OCWBNDRU^=ADDR(OCWBIND)  /* IF WE HAVE A BIND RU          */
*         THEN                      /* AREA                  @D32CKMP*/
*                                                                  2041
@RC02016 LA    @15,OCWBIND(,OCWPTR)                                2041
         C     @15,OCWBNDRU(,OCWPTR)                               2041
         BE    @RF02041                                            2041
*         /***********************************************************/
*         /*                                                         */
*         /* THE FUNCTION OF THIS LOGIC SEGMENT IS TO CALL THE       */
*         /* SESSION PARAMETERS SEARCH ROUTINE WHEN NO USER BIND IS  */
*         /* SPECIFIED.                                              */
*         /*                                                         */
*         /***********************************************************/
*                                                                  2042
*CALLSESS:                                                         2042
*         DO;                       /*                       @D32CKMP*/
CALLSESS DS    0H                                                  2043
*           RFY                                                    2043
*            (GPR01P,                                              2043
*             GPR15P) RSTD;         /*                       @D32CKMP*/
*           GPR01P=ADDR(OCWSHPL);   /* POINT AT SESS PARM SEARCH PARM
*                                      LIST                  @D32CKMP*/
         LA    GPR01P,OCWSHPL(,OCWPTR)                             2044
*           FNDLU=CSLRDTE;          /* PARM1 - LU RDTE       @D32CKMP*/
         LA    @10,784                                             2045
         ALR   @10,OCWPTR                                          2045
         MVC   FNDLU(4,@10),CSLRDTE+40(OCWPTR)                     2045
*           FNDAREA=ADDR(OCWBINDA); /* PARM2 - AREA          @D32CKMP*/
         LA    @09,OCWBINDA(,OCWPTR)                               2046
         ST    @09,FNDAREA(,@10)                                   2046
*           FNDMODE=ADDR(ADDR(OCWBINDA)->BINPRIM);/* PARM3 - MODE  2047
*                                      NAME                  @D32CKMP*/
         LA    @09,BINPRIM+797(,OCWPTR)                            2047
         ST    @09,FNDMODE(,@10)                                   2047
*           CALL ISTINCSH;          /* CALL SEARCH ROUTINE   @D32CKMP*/
         L     @10,OCWACVT(,OCWPTR)                                2048
         L     @15,ATCSRTAB(,@10)                                  2048
         BALR  @14,@15                                             2048
*           RFY                                                    2049
*            (GPR01P,                                              2049
*             GPR15P) UNRSTD;       /*                       @D32CKMP*/
*           RPHPTR=OCWRPH;          /* RE-ESTABLISH RPH PTR  @D32CKMP*/
         L     RPHPTR,OCWRPH(,OCWPTR)                              2050
*           IF CRETCODE=0           /* IF SEARCH SUCCESSFUL          */
*             THEN                  /*                               */
         LTR   CRETCODE,CRETCODE                                   2051
         BNZ   @RF02051                                            2051
*             DO;                   /*                       @D32CKMP*/
*               OCWBNDRU=ADDR(OCWBIND);/* POINT AT BIND RU AREA IN 2053
*                                      OCW                   @D32CKMP*/
         LA    @15,OCWBIND(,OCWPTR)                                2053
         ST    @15,OCWBNDRU(,OCWPTR)                               2053
*               OCWBNDSZ=LENGTH(ISTBIND)+1;/* SAVE BIND RU SIZE IN 2054
*                                      OCW                   @D32CKMP*/
         MVC   OCWBNDSZ(2,OCWPTR),@CH06177                         2054
*             END;                  /*                       @D32CKMP*/
*           ELSE                    /* SEARCH UNSUCCESSFUL,  @D32CKMP*/
*             DO;                   /* SO                    @D32CKMP*/
         B     @RC02051                                            2056
@RF02051 DS    0H                                                  2057
*               IF CRETCODE=4|      /* IF RDTE INVALID               */
*                   CRETCODE=12     /*                               */
*                 THEN              /*                               */
         CH    CRETCODE,@CH00045                                   2057
         BE    @RT02057                                            2057
         CH    CRETCODE,@CH00033                                   2057
         BNE   @RF02057                                            2057
@RT02057 DS    0H                                                  2058
*                 DO;               /*                       @D32CKMP*/
*                   OCWRC='08'X;    /* INDICATE LOGMODE NOT  @D32CKMP*/
         MVI   OCWRC(OCWPTR),X'08'                                 2059
*                   OCWEC='2E'X;    /* FOUND LOGIC ERROR IN OCW    2060
*                                                            @D32CKMP*/
         MVI   OCWEC(OCWPTR),X'2E'                                 2060
*                 END;              /*                       @D32CKMP*/
*               ELSE                /* LOGMODE NOT FOUND,            */
*                 DO;               /* SO                    @D32CKMP*/
         B     @RC02057                                            2062
@RF02057 DS    0H                                                  2063
*                   OCWRC='24'X;    /* INDICATE UNEXPECTED   @D32CKMP*/
         MVI   OCWRC(OCWPTR),X'24'                                 2063
*                   OCWEC='40'X;    /* SYSTEM ERROR IN OCW   @D32CKMP*/
         MVI   OCWEC(OCWPTR),X'40'                                 2064
*                 END;              /*                       @D32CKMP*/
*             END;                  /*                       @D32CKMP*/
*         END CALLSESS;             /*                       @D32CKMP*/
*       ELSE                                                       2068
*         ;                         /*                       @D32CKMP*/
@RF02041 DS    0H                                                  2069
*     END;                          /*                       @D32CKMP*/
@RC02041 DS    0H                                                  2070
*   IF OCWRC=0                      /* IF OK SO FAR                  */
*     THEN                          /*                               */
@RC01793 CLI   OCWRC(OCWPTR),0                                     2070
         BNE   @RF02070                                            2070
*     DO;                           /*                       @D32CKMP*/
*       CALL GETLCPB;               /* ALLOC NMLPB IF NEED   @D32CKMP*/
         BAL   @14,GETLCPB                                         2072
*       IF OCWRC=0                  /* IF NMLPB ALLOCATED            */
*         THEN                      /*                               */
         CLI   OCWRC(OCWPTR),0                                     2073
         BNE   @RF02073                                            2073
*         DO;                       /*                       @D32CKMP*/
*           BINPRIM=CSPRSC2B;       /* GET RESOURCE 2 NAME   @D32CKMP*/
         LA    @15,1                                               2075
         L     @10,OCWBNDRU(,OCWPTR)                               2075
         ALR   @10,@15                                             2075
         MVC   BINPRIM(8,@10),CSPRSC2B+224(OCWPTR)                 2075
*           DO BINPRIML=1 TO BINUSERN WHILE(BINPRIM(BINPRIML)^=' ');
         L     @10,OCWBNDRU(,OCWPTR)                               2076
         STC   @15,BINPRIML+1(,@10)                                2076
@DL02076 LA    @15,1                                               2076
         AL    @15,OCWBNDRU(,OCWPTR)                               2076
         SLR   @10,@10                                             2076
         IC    @10,BINPRIML(,@15)                                  2076
         ALR   @15,@10                                             2076
         CLI   BINPRIM-1(@15),C' '                                 2076
         BE    @DC02076                                            2076
*                                   /* COUNT NON-BLKS        @D32CKMP*/
*           END;                    /*                       @D32CKMP*/
         L     @10,OCWBNDRU(,OCWPTR)                               2077
         LA    @15,1                                               2077
         SLR   @09,@09                                             2077
         IC    @09,BINPRIML+1(,@10)                                2077
         ALR   @15,@09                                             2077
         L     @10,OCWBNDRU(,OCWPTR)                               2077
         STC   @15,BINPRIML+1(,@10)                                2077
         CH    @15,@CH01484                                        2077
         BNH   @DL02076                                            2077
@DC02076 DS    0H                                                  2078
*           BINPRIML=BINPRIML-1;    /* DECR USER DATA LEN    @D32CKMP*/
         LA    @15,1                                               2078
         AL    @15,OCWBNDRU(,OCWPTR)                               2078
         SLR   @10,@10                                             2078
         IC    @10,BINPRIML(,@15)                                  2078
         BCTR  @10,0                                               2078
         STC   @10,BINPRIML(,@15)                                  2078
*           RFY                                                    2079
*             SHFTUBND BASED(ADDR(BINPRIM)+BINPRIML);/*      @D32CKMP*/
*           IF BINPRIML<BINUSERN    /* IF NON-BLANKS FND     @D32CKMP*/
*             THEN                  /* MUST SHIFT USER DATA  @D32CKMP*/
         CLI   BINPRIML(@15),8                                     2080
         BNL   @RF02080                                            2080
*             DO;                   /* SO                    @D32CKMP*/
*               SHFULN=BINUSEL;     /* SHIFT DATA LENGTH     @D32CKMP*/
         LA    @09,BINPRIM(,@15)                                   2082
         ALR   @09,@10                                             2082
         SLR   @10,@10                                             2082
         IC    @10,BINUSEL(,@15)                                   2082
         STC   @10,SHFULN(,@09)                                    2082
*               IF BINUSEL>BINUSERD /* IF USER DATA PRESENT          */
*                 THEN              /*                       @D32CKMP*/
         CLI   BINUSEL(@15),0                                      2083
         BNH   @RF02083                                            2083
*                 SHFUDT(1:SHFULN)=BINUSE(1:SHFULN);/* SHIFT IT    2084
*                                                             @D@CKMP*/
         BCTR  @10,0                                               2084
         EX    @10,@SM06205                                        2084
*               ELSE                                               2085
*                 ;                 /* SHIFT NOT REQUIRED    @D32CKMP*/
@RF02083 DS    0H                                                  2086
*             END;                  /*                       @D32CKMP*/
*           ELSE                                                   2087
*             ;                     /* NO DATA SHIFT RQD     @D32CKMP*/
@RF02080 DS    0H                                                  2088
*           BINFMT=BINFMT0;         /* INIT FORMAT FIELD IN BIND   2088
*                                      DCR3896               @D32CKQM*/
         LA    @15,1                                               2088
         AL    @15,OCWBNDRU(,OCWPTR)                               2088
         NI    BINFMT(@15),B'00001111'                             2088
*           BINTYPE=BINCOLD;        /* INIT TYPE FIELD IN BIND     2089
*                                      DCR3896               @D32CKMP*/
         NI    BINTYPE(@15),B'11110001'                            2089
         OI    BINTYPE(@15),B'00000001'                            2089
*           IF CSLRDTE->RPRENTRY=RPRENTLU THEN/* IF 370X ATT LU    2090
*                                                            @ZA10425*/
         L     @10,CSLRDTE+40(,OCWPTR)                             2090
         CLI   RPRENTRY(@10),X'81'                                 2090
         BNE   @RF02090                                            2090
*             IF CSLRDTE->RPRHDTYP=RPRENTLS/* IN LOCAL SUBAREA     2091
*                                                            @ZA10425*/
*               THEN                                               2091
         CLI   RPRHDTYP(@10),X'05'                                 2091
         BNE   @RF02091                                            2091
*               BINRPACE=CSLRDTE->RLUPACEN;/* LU VPACING     @ZA10425*/
         MVC   BINRPACE(1,@15),RLUPACEN(@10)                       2092
*             ELSE                                                 2093
*               BINRPACE=CSLRDTE->RLUNCPPN;/* NCP PACING     @ZA10425*/
         B     @RC02091                                            2093
@RF02091 L     @15,OCWBNDRU(,OCWPTR)                               2093
         L     @10,CSLRDTE+40(,OCWPTR)                             2093
         MVC   BINRPACE+1(1,@15),RLUNCPPN(@10)                     2093
*           ELSE                                                   2094
*             ;                     /* DEST NOT AN LU        @ZA10425*/
@RF02090 DS    0H                                                  2095
*           ISTNMLPB=ISTNMLPB&&ISTNMLPB;/* CLEAR NMLPB AREA  @D32CKMP*/
@RC02090 L     @15,RUCBSTG(,OCWPTR)                                2095
         XC    ISTNMLPB(100,@15),ISTNMLPB(@15)                     2095
*           LCPRPHA=ADDR(ISTRPH);   /* POINT AT RPH          @D32CKMP*/
         ST    GPR01P,LCPRPHA(,@15)                                2096
*           LCPTYPE=LCPETYPE;       /* IND TYPE IS EXTENDED LCPB   2097
*                                                            @D32CKMP*/
         MVI   LCPTYPE(@15),X'40'                                  2097
*           LCPLNGTH=LENGTH(ISTNMLPB);/* LENGTH LCPB+LCCWS   @D32CKMP*/
         MVI   LCPLNGTH(@15),X'64'                                 2098
*           LCPCID=OCWCID;          /* CID TO LCPB           @D32CKMP*/
         MVC   LCPCID(4,@15),OCWCID(OCWPTR)                        2099
*           LCPNXLCW=ADDR(NMLCW2);  /* POINT AT FIRST LCCW TO BE   2100
*                                      PROCESSED             @D32CKMP*/
         LA    @10,NMLCW2(,@15)                                    2100
         ST    @10,LCPNXLCW(,@15)                                  2100
*           LCPNXLCW->LCCWOP=LSEND; /* IND SEND LCCW         @D32CKMP*/
         MVI   LCCWOP(@10),X'F1'                                   2101
*           LCPNXLCW->LCCWCD=CON;   /* INDIC DATA CHAINED    @D32CKMP*/
*           LCPNXLCW->LCCWNTVC=CON; /* INDIC VALIDITY CHECK BYPASS 2103
*                                                            @D32CKMP*/
*           LCPNXLCW->LCCWIDAT=CON; /* IND IMMEDIATE DATA    @D32CKMP*/
         OI    LCCWCD(@10),B'10011000'                             2104
*           LCPNXLCW->LCCWCNT=LENGTH(ISTRH);/* IND DATA SIZE @D32CKMP*/
         MVC   LCCWCNT(2,@10),@CH00073                             2105
*           RFY                                                    2106
*             ISTRH BASED(ADDR(LCPNXLCW->LCCWDATA));/*       @D32CKMP*/
*           RHTYPE=CON;             /* IND RESP TYPE RQST    @D32CKMP*/
*           RHSCI=CON;              /* IND SYS CNTRL RQST    @D32CKMP*/
*           RHFORMAT=CON;           /* IND FORMATTED RQST    @D32CKMP*/
         AH    @10,@CH00045                                        2109
         OI    RHTYPE(@10),B'01101000'                             2109
*           RHCHAIN=RHONLY;         /* IND ONLY 1 RH         @D32CKMP*/
         OI    RHCHAIN(@10),B'00000011'                            2110
*           RHFME=CON;              /* IND FME REQUESTED     @D32CKMP*/
         OI    RHFME(@10),B'10000000'                              2111
*           ADDR(NMLCW3)->LCCWCNT=OCWBNDSZ-BINUSERN+BINPRIML;/* PUT
*                                      BIND RU SIZE IN LCCW CNT FLD
*                                                            @D32CKMP*/
         AH    @15,@CH00215                                        2112
         SLR   @10,@10                                             2112
         ICM   @10,3,OCWBNDSZ(OCWPTR)                              2112
         SH    @10,@CH01484                                        2112
         L     @09,OCWBNDRU(,OCWPTR)                               2112
         SLR   @05,@05                                             2112
         IC    @05,BINPRIML+1(,@09)                                2112
         ALR   @10,@05                                             2112
         STH   @10,LCCWCNT(,@15)                                   2112
*           ADDR(NMLCW3)->LCCWDATA=OCWBNDRU;/* PT AT BIND RU @D32CKMP*/
         ST    @09,LCCWDATA(,@15)                                  2113
*           ADDR(NMLCW3)->LCCWNTVC=CON;/* BND LCCW VALCK BYPASS    2114
*                                                            @XM00126*/
         OI    LCCWNTVC(@15),B'00010000'                           2114
*           OCWBNDRU->SRUQSREQ=SRBIND;/* IND BIND RU         @D32CKMP*/
         MVI   SRUQSREQ(@09),X'31'                                 2115
*         END;                      /*                       @D32CKMP*/
*       ELSE                                                       2117
*         ;                         /* NMLPB NOT ALLOCATED   @D32CKMP*/
@RF02073 DS    0H                                                  2118
*     END;                          /*                       @D32CKMP*/
*   ELSE                                                           2119
*     ;                             /* ERROR - SKIP SEND     @D32CKMP*/
@RF02070 DS    0H                                                  2120
*/*  SEGMENT(GETRUCB)FINISH                                          */
*                                                                  2120
*   DO;                                                            2120
*     GOTO GETRUCB#;                                               2121
         B     GETRUCB#                                            2121
*GETRUCB@:                                                         2122
*   END;                                                           2122
*                                                                  2122
GETRUCB@ DS    0H                                                  2123
*/*END OF CODE FOR D703348                                           */
*                                                                  2123
*                                                                  2123
*/*  SEGMENT(CONERR)START                                            */
*                                                                  2123
*   DO;                                                            2123
*     GOTO CONERR@;                                                2124
         B     CONERR@                                             2124
*CONERR:                                                           2125
*   END;                            /* NOTIFY VARY THAT BIND FAILED  */
CONERR   DS    0H                                                  2126
*/********************************************************************/
*/*  ROUTINE NAME: CONERR                                            */
*/*  FUNCTION:                                                       */
*/*       THIS ROUTINE IS CALLED BY DOCONCT TO NOTIFY SSCP THAT A    */
*/*       BIND OR AN SDT HAS FAILED. IT BUILDS AND INITIALIZES AN    */
*/*       NCSCPL. THE NCSPL IS THEN TPQUE'D TO SSCP'S PAB. FEEDBACK  */
*/*       IS NOT WAITED ON. SSCP WILL RELEASE THE NCSPL              */
*/*  ROUTINES CALLED:                                                */
*/*       NONE                                                       */
*/*  MACROS USED:                                                    */
*/*       REQSTORE - OBTAIN STORAGE FOR NCSPL                        */
*/*       TPWAIT   - WAIT FOR STORAGE REQUEST TO COMPLETE, IF REQD   */
*/*       RELSTORE - RELEASE NCSPL STORAGE, IF REQD                  */
*/*       GETSTOR  - OBTAIN STORAGE FOR NCSPL WORK AREA              */
*/*       TPQUE    - DRIVE SSCP                                      */
*/********************************************************************/
*                                                                  2126
*                                                                  2126
*/*START OF CODE FOR D703297                                         */
*                                                                  2126
*   RFY                                                            2126
*     CPARMR08 RSTD;                                               2126
*   RFY                                                            2127
*     ISTNCSPL BASED(CPARMR08);                                    2127
*   IF RPRENTRY^=RPRENTLU           /* IF DEST IS NOT AN LU  @D32CKXY*/
*     THEN                                                         2128
         L     @15,OCWDRDTE(,OCWPTR)                               2128
         CLI   RPRENTRY(@15),X'81'                                 2128
         BNE   @RT02128                                            2128
*     ;                                                            2129
*   ELSE                                                           2130
*     DO;                                                          2130
*                                                                  2130
*       /*************************************************************/
*       /*                                                           */
*       /* ----------------------------------------------------------*/
*       /* -- REQUEST A CLEARED STORAGE AREA IN WHICH TO BUILD THE   */
*       /* END SESSION NETWORK CONFIGURATION SERVICES PARAMETER LIST */
*       /* FOR SENDING THE BIND FAILED. -----------------------------*/
*       /* ------------------------------- REQSTORE                  */
*       /* CBID(NCSPL)CLEAR(YES)RPH(YES)                             */
*       /*                                                           */
*       /*************************************************************/
*                                                                  2131
*       DO;                                                        2131
*                                                                  2131
*/* ATBUILD (ISTDYPAB,ISTATCVT,ISTRPH)                               */
*/* END OF ATBUILD                                                   */
*                                                                  2132
*         RFY                                                      2132
*          (GPR02P,                                                2132
*           GPR03P,                                                2132
*           GPR04P,                                                2132
*           GPR15P) RSTD;                                          2132
*         RFY                                                      2133
*          (GPR01P,                                                2133
*           GPR13P) RSTD;                                          2133
*         GENERATE REFS(GPR01P,GPR02P,GPR13P) SETS(RPHWORK);       2134
           STM GPR02P,GPR13P,RPHWORK(GPR01P)
*         RFY                                                      2135
*          (GPR01P,                                                2135
*           GPR13P) UNRSTD;                                        2135
*         DO;                       /* LISATCVT                    2136
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*           GPR15P=ATCLCPTR;        /* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     2137
*         END;                      /* LISATCVT                      */
*         GPR02P=GPR15P->ATCBPDA|'80000000'X;                      2139
         L     GPR02P,ATCBPDA(,GPR15P)                             2139
         O     GPR02P,@CF01465                                     2139
*         DCL                                                      2140
*           1 FMZA0341 FIXED(31) STATIC LOCAL,                     2140
*            2 * FIXED(8) INIT(184),                               2140
*            2 * PTR(24) INIT(0);                                  2140
*         GPR03F=FMZA0341;                                         2141
         L     GPR03F,FMZA0341                                     2141
*         GPR04F=34;                                               2142
         LA    GPR04F,34                                           2142
*         GPR15P=GPR15P->ATCSMRQ;                                  2143
         L     GPR15P,ATCSMRQ(,GPR15P)                             2143
*         DCL                                                      2144
*           FMZL0341 BASED(GPR15P) LABEL VALUERANGE(*);            2144
*         CALL FMZL0341;                                           2145
         BALR  @14,@15                                             2145
*         RFY                                                      2146
*          (GPR13P) RSTD;                                          2146
*         GENERATE REFS(GPR01P,RPHWORK) SETS(GPR02P,GPR13P);       2147
           LM GPR02P,GPR13P,RPHWORK(GPR01P)
*         RFY                                                      2148
*          (GPR13P) UNRSTD;                                        2148
*         RFY                                                      2149
*          (GPR02P,                                                2149
*           GPR03P,                                                2149
*           GPR04P,                                                2149
*           GPR15P) UNRSTD;                                        2149
*       END;                        /* ******** END OF REQSTORE    2150
*                                      EXPANSION                     */
*/* DM14028                                                          */
*                                                                  2151
*       IF CRETCODE>CEIGHT          /* DM09291                       */
*         THEN                                                     2151
         CH    CRETCODE,@CH00037                                   2151
         BH    @RT02151                                            2151
*         ;                         /* DM09291                       */
*       ELSE                                                       2153
*         DO;                       /* NCSPL IS AVAILABLE    @D32CKXY*/
*           IF CRETCODE=CEIGHT      /* IF STORAGE IS NOT             */
*             THEN                  /* AVAILABLE YET                 */
         CH    CRETCODE,@CH00037                                   2154
         BNE   @RF02154                                            2154
*/*  TPWAIT                                                          */
*                                                                  2155
*             DO;                   /* BEGIN TPWAIT GENERATION       */
*               RFY                                                2156
*                (GPR01P,                                          2156
*                 GPR14P,                                          2156
*                 GPR15P) RSTD;                                    2156
*               RFY                                                2157
*                (GPR00P) RSTD;                                    2157
*               GEN(STM   GPR00P,GPR15P,RPHWORK(GPR01P))           2158
*               REFS(GPR00P,GPR01P,GPR15P) SETS(RPHWORK);          2158
         STM   GPR00P,GPR15P,RPHWORK(GPR01P)
*               RFY                                                2159
*                (GPR00P) UNRSTD;                                  2159
*               GPR15P=ADDR(LHAA0360);                             2160
         LA    GPR15P,LHAA0360                                     2160
*               GPR14P=0;                                          2161
         SLR   GPR14P,GPR14P                                       2161
*               GPR15P=GPR15P&'00FFFFFF'X;                         2162
         N     GPR15P,@CF05091                                     2162
*               GPR15P=GPR15P|RPHWT1;                              2163
         O     GPR15P,@CF01455                                     2163
*               CS(GPR14P,GPR15P,GPR01P->RPHRESMA);                2164
         CS    GPR14P,@15,RPHRESMA(GPR01P)                         2164
*               BC(7,LHAB0360);                                    2165
*                                                                  2165
         BC    7,LHAB0360                                          2165
*/* TPEXIT  NONE                                                     */
*                                                                  2166
*               DO;                                                2166
*                 RESPECIFY                                        2167
*                   GPR15P RSTD;                                   2167
*                                                                  2167
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTATCVT)                               */
*/* END OF ATBUILD                                                   */
*                                                                  2168
*                 DO;               /* LISATCVT                    2168
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*                   GPR15P=ATCLCPTR;/* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     2169
*                 END;              /* LISATCVT                      */
*                 RESPECIFY                                        2171
*                   GPR00F RSTD;                                   2171
*                 GPR00F=0;         /* SET PARAMETER REGISTER TO 0   */
         SLR   GPR00F,GPR00F                                       2172
*                 GPR15P=GPR15P->ATCAP31;                          2173
         L     GPR15P,ATCAP31(,GPR15P)                             2173
*                 DCL                                              2174
*                   FMZL0365 BASED(GPR15P) LABEL VALUERANGE(*);    2174
*                 CALL FMZL0365;                                   2175
         BALR  @14,@15                                             2175
*                 RESPECIFY                                        2176
*                  (GPR00F,                                        2176
*                   GPR15P) UNRSTD;                                2176
*               END;                /* **** END OF TPEXIT            */
*LHAB0360:                                                         2178
*               ;                                                  2178
LHAB0360 DS    0H                                                  2179
*               GPR01P->RPHRESMA=0;                                2179
         SLR   @15,@15                                             2179
         ST    @15,RPHRESMA(,GPR01P)                               2179
*               RFY                                                2180
*                (GPR00P) RSTD;                                    2180
*LHAA0360:                                                         2181
*               ;                                                  2181
LHAA0360 DS    0H                                                  2182
*               GEN(LM    GPR00P,GPR15P,RPHWORK(GPR01P))           2182
*               REFS(RPHWORK,GPR01P) SETS(GPR00P,GPR15P);          2182
         LM    GPR00P,GPR15P,RPHWORK(GPR01P)
*               RFY                                                2183
*                (GPR00P,                                          2183
*                 GPR01P,                                          2183
*                 GPR14P,                                          2183
*                 GPR15P) UNRSTD;                                  2183
*             END;                  /* ****END OF TPWAIT WAIT FOR THE
*                                      NCSPL STORAGE AREA            */
*           ELSE                                                   2185
*             ;                     /* STORAGE WAS OBTAINED DM09291  */
@RF02154 DS    0H                                                  2186
*           CPARMR08=RPHSRPRM;      /* SET THE NCSPL MAPPING BASE    */
*                                                                  2186
         L     CPARMR08,RPHSRPRM(,GPR01P)                          2186
*           /*********************************************************/
*           /*                                                       */
*           /* ------------------------------------------------------*/
*           /* -- GET A CLEARED STORAGE AREA TO BE USED AS THE NCSPL */
*           /* WORK AREA. -------------------------------------------*/
*           /* ------------- GETSTOR SIZE(NCSWASZ)TYPE(PAGEABLE)SAVE(*/
*           /* YES)CLEAR(YES)FETCHP(NO)                              */
*           /*                                                       */
*           /*********************************************************/
*                                                                  2187
*           DO;                                                    2187
*                                                                  2187
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTATCVT,ISTRPH)                        */
*/* END OF ATBUILD                                                   */
*                                                                  2188
*             RFY                                                  2188
*              (GPR00P,                                            2188
*               GPR01P,                                            2188
*               GPR02P,                                            2188
*               GPR03P) RSTD;                                      2188
*             RFY                                                  2189
*               ISTRPH BASED(GPR01P);                              2189
*             GEN REFS(GPR02P,GPR03P,GPR04P,GPR05P,GPR06P,GPR07P,GPR08P
*                 ,GPR09P,GPR10P,GPR11P,GPR12P,GPR13P) SETS(RPHWORK);
         STM   GPR02P,GPR13P,RPHWORK(GPR01P)        SAVE REGISTERS
*             GPR00F=NCSWASZ;       /* SIZE IN REG0                  */
         LA    GPR00F,2032                                         2191
*             DCL                                                  2192
*               1 CMZA0375 FIXED(31) STATIC LOCAL,                 2192
*                2 * FIXED(8) INIT(96),/* OPTION FLAGS               */
*                2 * FIXED(8) INIT(96),/* STORAGE KEY                */
*                2 * FIXED(8) INIT(241),/* SUBPOOL NUMBER            */
*                2 * FIXED(8) INIT('00'X);/* REQUEST TYPE            */
*             GPR03F=CMZA0375;                                     2193
         L     GPR03F,CMZA0375                                     2193
*             DO;                   /* LISATCVT                    2194
*                                      CVTBASE(PAGEABLE,(GPR02P))    */
*               GPR02P=ATCLCPTR;    /* SET UP ATCVT POINTER          */
         L     GPR02P,ATCLCPTR                                     2195
*             END;                  /* LISATCVT                      */
*             CALL GPR02P->ATCGTSTR;/* CALL ISTORFSR                 */
         L     @15,ATCGTSTR(,GPR02P)                               2197
         BALR  @14,@15                                             2197
*             RFY                                                  2198
*              (GPR00P,                                            2198
*               GPR01P,                                            2198
*               GPR02P,                                            2198
*               GPR03P) UNRSTD;                                    2198
*           END;                    /* END OF GETSTOR                */
*                                                                  2199
*           /*********************************************************/
*           /*                                                       */
*           /*                                               @XM00675*/
*           /*                                                       */
*           /*********************************************************/
*                                                                  2200
*           IF CRETCODE=0           /* IF THE REQUESTED STORAGE AREA */
*             THEN                  /* TO BE USED AS THE NCSPL WORK  */
         LTR   CRETCODE,CRETCODE                                   2200
         BNZ   @RF02200                                            2200
*             DO;                   /* AREA WAS OBTAINED             */
*               NCSPLWKA=RPHSRPRM;  /* SET NCSPL WORK AREA POINTER   */
*                                                                  2202
         L     @15,RPHSRPRM(,GPR01P)                               2202
         ST    @15,NCSPLWKA(,CPARMR08)                             2202
*               /*****************************************************/
*               /*                                                   */
*               /* --------------------------------------------------*/
*               /* --- FORMAT THE FIRST PART OF THE NETWORK          */
*               /* CONFIGURATION SERVICES PARAMETER LIST. -----------*/
*               /* ------------------------------------------        */
*               /*                                                   */
*               /*****************************************************/
*                                                                  2203
*               NCSPLVCD=NCSPLVC5;  /* SET VERB CODE FOR SSCP        */
         MVI   NCSPLVCD(CPARMR08),X'05'                            2203
*               NCSPLVBF=NCSBF;     /* SET MOD FLGS BIND FAILED      */
         MVC   NCSPLVBF(2,CPARMR08),@CB03140                       2204
*               NCSPLRPT=OCWDRDTE;  /* SET LOGIC UNIT RDTE PTR       */
         L     @10,OCWDRDTE(,OCWPTR)                               2205
         ST    @10,NCSPLRPT(,CPARMR08)                             2205
*               NCSPLRID=OCWDRDTE->RPRNAME;/* SET LOGIC UNIT RDTE  2206
*                                      NAME                          */
         MVC   NCSPLRID(8,CPARMR08),RPRNAME(@10)                   2206
*               NCSPLNSN=OCWDRDTE->RPRNSNEA;/* SET NXT SCHED NODE PTR*/
         MVC   NCSPLNSN(4,CPARMR08),RPRNSNEA(@10)                  2207
*               NCSPLLPT=OCWARDTE;  /* SET APPLICATON RDTE PTR       */
         L     @10,OCWARDTE(,OCWPTR)                               2208
         ST    @10,NCSPLLPT(,CPARMR08)                             2208
*               NCSPLLID=OCWARDTE->RPRNAME;/* SET APPLICATON RDTE  2209
*                                      NAME                          */
*                                                                  2209
         MVC   NCSPLLID(8,CPARMR08),RPRNAME(@10)                   2209
*               /*****************************************************/
*               /*                                                   */
*               /* --------------------------------------------------*/
*               /* --- FORMAT THE SECOND PART OF THE NETWORK         */
*               /* CONFIGURATION SERVICES PARAMETER LIST. -----------*/
*               /* ------------------------------------------        */
*               /*                                                   */
*               /*****************************************************/
*                                                                  2210
*               NCSPLCVT=OCWACVT;   /* SET VTAM CVT POINTER          */
         MVC   NCSPLCVT(4,CPARMR08),OCWACVT(OCWPTR)                2210
*               NCSPLREQ=CON;       /* SET REQSTORE BY CBID FLAG ON  */
*                                                                  2211
         OI    NCSPLREQ(CPARMR08),B'00010000'                      2211
*               /*****************************************************/
*               /*                                                   */
*               /* --------------------------------------------------*/
*               /* --- FORMAT THE FIRST PART OF THE NETWORK          */
*               /* CONFIGURATION SERVICES PARAMETER LIST WORK AREA. -*/
*               /* --------------------------------------------------*/
*               /* --                                                */
*               /*                                                   */
*               /*****************************************************/
*                                                                  2212
*               RFY                                                2212
*                 NCSWKA BASED(NCSPLWKA);/* SET WORK AREA MAP BASE   */
*               NCSWKAW1=ADDR(NCSWKAW3);/* SET WORK AREA START PTR   */
         LA    @10,NCSWKAW3(,@15)                                  2213
         ST    @10,NCSWKAW1(,@15)                                  2213
*               NCSWKAW2=NCSWASZ;   /* SET WK AREA LNTH      @XM00675*/
*                                                                  2214
         MVC   NCSWKAW2(4,@15),@CF03126                            2214
*               /*****************************************************/
*               /*                                                   */
*               /* --------------------------------------------------*/
*               /* --- QUEUE THE NETWORK CONFIGURATION SERVICES      */
*               /* PARAMETER LIST ON TO THE VARY PAB OFF OF THE      */
*               /* LOGICAL UNIT CLUSTER RDT ENTRY. ------------------*/
*               /* -----------------------------------               */
*               /*                                                   */
*               /*****************************************************/
*                                                                  2215
*/*  TPQUE (CPARMR08,OCWDRDTE->RPRNSNEA->RCCVPAB->DYPPAB) NORM       */
*                                                                  2215
*               DO;                                                2215
*                 RFY                                              2216
*                  (GPR00P,                                        2216
*                   GPR01P,                                        2216
*                   GPR04P,                                        2216
*                   GPR05P,                                        2216
*                   GPR15P) RSTD;                                  2216
*                 GEN REFS(GPR01P) SETS(RPHWORK)                   2217
*                     (STM GPR02P,GPR08P,RPHWORK(GPR01P));         2217
         STM GPR02P,GPR08P,RPHWORK(GPR01P)
*                 GPR00P=0;                                        2218
         SLR   GPR00P,GPR00P                                       2218
*                 GPR15P=ADDR(OCWDRDTE->RPRNSNEA->RCCVPAB->DYPPAB);/*
*                                      HOLD PAB PTR                  */
         L     @10,OCWDRDTE(,OCWPTR)                               2219
         L     @10,RPRNSNEA(,@10)                                  2219
         L     GPR15P,RCCVPAB(,@10)                                2219
         LA    GPR15P,DYPPAB(,GPR15P)                              2219
*                 GPR04P=CPARMR08;  /* WORK ELE PTR                  */
         LR    GPR04P,CPARMR08                                     2220
*                 GPR05P=GPR15P;    /* PASS PAB PTR                  */
         LR    GPR05P,GPR15P                                       2221
*                 CALL ATCLCPTR->ATCAP37->ISTAPC37;                2222
         L     @10,ATCLCPTR                                        2222
         L     @15,ATCAP37(,@10)                                   2222
         BALR  @14,@15                                             2222
*                 GEN(NOPR  0)                                     2223
*                 NOSETS NOREFS;                                   2223
         NOPR  0
*                 RFY                                              2224
*                  (GPR00P,                                        2224
*                   GPR01P,                                        2224
*                   GPR04P,                                        2224
*                   GPR05P,                                        2224
*                   GPR15P) UNRSTD;                                2224
*               END;                /* *** END OF TPQUE GENERATION 2225
*                                      DM09602                       */
*             END;                                                 2226
*           ELSE                    /* FAILED TO GET NCSPL WORK AREA */
*             DO;                                                  2227
*                                                                  2227
         B     @RC02200                                            2227
@RF02200 DS    0H                                                  2228
*               /*****************************************************/
*               /*                                                   */
*               /* --------------------------------------------------*/
*               /* --- RELEASE THE STORAGE AREA OBTAINED FOR THE     */
*               /* NETWORK CONFIGURATION SERVICES PARAMETER LIST. ---*/
*               /* --------------------------------------------------*/
*               /* RELSTORE BUFADDR(CPARMR08)                        */
*               /*                                                   */
*               /*****************************************************/
*                                                                  2228
*               DO;                                                2228
*                                                                  2228
*/* ATBUILD (ISTATCVT,ISTRPH)                                        */
*/* END OF ATBUILD                                                   */
*                                                                  2229
*                 RFY                                              2229
*                  (GPR02P,                                        2229
*                   GPR03P,                                        2229
*                   GPR04P,                                        2229
*                   GPR15P) RSTD;                                  2229
*                 RFY                                              2230
*                  (GPR01P,                                        2230
*                   GPR13P) RSTD;                                  2230
*                 GENERATE REFS(GPR01P,GPR02P,GPR13P) SETS(RPHWORK);
          STM GPR02P,GPR13P,RPHWORK(GPR01P)
*                 RFY                                              2232
*                   GPR13P UNRSTD;                                 2232
*                 GPR04P=CPARMR08;                                 2233
         LR    GPR04P,CPARMR08                                     2233
*                 DCL                                              2234
*                   1 FMZA0399 FIXED(31) STATIC LOCAL,             2234
*                    2 * FIXED(8) INIT(64),                        2234
*                    2 * PTR(24) INIT(0);                          2234
*                 GPR03F=FMZA0399;                                 2235
         L     GPR03F,FMZA0399                                     2235
*                 DO;               /* LISATCVT                    2236
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*                   GPR15P=ATCLCPTR;/* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     2237
*                 END;              /* LISATCVT                      */
*                 GPR02P=GPR15P->ATCBPDA;                          2239
         L     GPR02P,ATCBPDA(,GPR15P)                             2239
*                 GPR15P=GPR15P->ATCSMRS;                          2240
         L     GPR15P,ATCSMRS(,GPR15P)                             2240
*                 DCL                                              2241
*                   FMZL0399 BASED(GPR15P) LABEL VALUERANGE(*);    2241
*                 CALL FMZL0399;                                   2242
         BALR  @14,@15                                             2242
*                 RFY                                              2243
*                   GPR13P RSTD;                                   2243
*                 GENERATE REFS(GPR01P,RPHWORK) SETS(GPR02P,GPR13P);
          LM GPR02P,GPR13P,RPHWORK(GPR01P)
*                 RFY                                              2245
*                  (GPR01P,                                        2245
*                   GPR13P) UNRSTD;                                2245
*                 RFY                                              2246
*                  (GPR02P,                                        2246
*                   GPR03P,                                        2246
*                   GPR04P,                                        2246
*                   GPR15P) UNRSTD;                                2246
*               END;                /* *********END OF RELSTORE    2247
*                                      EXPANSION*********            */
*             END;                                                 2248
*         END;                      /* END DO FOR AVAIL NCSPL@D32CKXY*/
@RC02200 DS    0H                                                  2250
*     END;                                                         2250
@RT02151 DS    0H                                                  2251
*   RFY                                                            2251
*     CPARMR08 UNRSTD;                                             2251
*                                                                  2251
@RT02128 DS    0H                                                  2252
*/*END OF CODE FOR D703297                                           */
*/* SEGMENT(CONERR)FINISH                                            */
*                                                                  2252
*   DO;                                                            2252
*     GOTO CONERR#;                                                2253
         B     CONERR#                                             2253
*CONERR@:                                                          2254
*   END;                                                           2254
CONERR@  DS    0H                                                  2255
*                                                                  2255
*/*  SEGMENT(CLEANUP)START                                           */
*                                                                  2255
*   DO;                                                            2255
*     GOTO CLEANUP@;                                               2256
         B     CLEANUP@                                            2256
*CLEANUP:                                                          2257
*   END;                            /* RELE CONTROL BLKS             */
CLEANUP  DS    0H                                                  2258
*/********************************************************************/
*/*  ROUTINE NAME: CLEANUP                                           */
*/*  FUNCTION:                                                       */
*/*       THIS SEGMENT IS INVOKED BY MAIN LINE TO RELEASE ANY NMLPB'S*/
*/*       OR RU'S THAT MIGHT STILL EXISTS.                           */
*/*  ROUTINES CALLED:                                                */
*/*       NONE                                                       */
*/*  MACROS USED:                                                    */
*/*       RELSTORE - RELEASE NMLPB                                   */
*/*       FREESTOR - RELEASE BIND RU                                 */
*/********************************************************************/
*                                                                  2258
*   IF OCWLCPBA=0                   /* IS THERE A NMLLN?             */
*     THEN                                                         2258
         ICM   @15,15,OCWLCPBA(OCWPTR)                             2258
         BZ    @RT02258                                            2258
*     ;                                                            2259
*   ELSE                                                           2260
*     DO;                                                          2260
*                                                                  2260
*       /*************************************************************/
*       /*                                                           */
*       /* RELSTORE BUFADDR(OCWLCPBA)                                */
*       /*                                                           */
*       /*************************************************************/
*                                                                  2261
*       DO;                                                        2261
*                                                                  2261
*/* ATBUILD (ISTATCVT,ISTRPH)                                        */
*/* END OF ATBUILD                                                   */
*                                                                  2262
*         RFY                                                      2262
*          (GPR02P,                                                2262
*           GPR03P,                                                2262
*           GPR04P,                                                2262
*           GPR15P) RSTD;                                          2262
*         RFY                                                      2263
*          (GPR01P,                                                2263
*           GPR13P) RSTD;                                          2263
*         GENERATE REFS(GPR01P,GPR02P,GPR13P) SETS(RPHWORK);       2264
          STM GPR02P,GPR13P,RPHWORK(GPR01P)
*         RFY                                                      2265
*           GPR13P UNRSTD;                                         2265
*         GPR04P=OCWLCPBA;                                         2266
         L     GPR04P,OCWLCPBA(,OCWPTR)                            2266
*         DCL                                                      2267
*           1 FMZA0417 FIXED(31) STATIC LOCAL,                     2267
*            2 * FIXED(8) INIT(64),                                2267
*            2 * PTR(24) INIT(0);                                  2267
*         GPR03F=FMZA0417;                                         2268
         L     GPR03F,FMZA0417                                     2268
*         DO;                       /* LISATCVT                    2269
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*           GPR15P=ATCLCPTR;        /* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     2270
*         END;                      /* LISATCVT                      */
*         GPR02P=GPR15P->ATCBPDA;                                  2272
         L     GPR02P,ATCBPDA(,GPR15P)                             2272
*         GPR15P=GPR15P->ATCSMRS;                                  2273
         L     GPR15P,ATCSMRS(,GPR15P)                             2273
*         DCL                                                      2274
*           FMZL0417 BASED(GPR15P) LABEL VALUERANGE(*);            2274
*         CALL FMZL0417;                                           2275
         BALR  @14,@15                                             2275
*         RFY                                                      2276
*           GPR13P RSTD;                                           2276
*         GENERATE REFS(GPR01P,RPHWORK) SETS(GPR02P,GPR13P);       2277
          LM GPR02P,GPR13P,RPHWORK(GPR01P)
*         RFY                                                      2278
*          (GPR01P,                                                2278
*           GPR13P) UNRSTD;                                        2278
*         RFY                                                      2279
*          (GPR02P,                                                2279
*           GPR03P,                                                2279
*           GPR04P,                                                2279
*           GPR15P) UNRSTD;                                        2279
*       END;                        /* *********END OF RELSTORE    2280
*                                      EXPANSION********* RELE NMLLN */
*       OCWLCPBA=0;                 /* NMLLN RELEASED                */
         SLR   @15,@15                                             2281
         ST    @15,OCWLCPBA(,OCWPTR)                               2281
*     END;                                                         2282
*   IF OCWBNDRU^=ADDR(OCWBIND)&     /* AND PUT IN            @DM13348*/
*       OCWBNDRU^=0                 /* DO NOT FREE IF NONE   @XM00126*/
*     THEN                          /*                               */
@RT02258 L     @15,OCWBNDRU(,OCWPTR)                               2283
         LA    @10,OCWBIND(,OCWPTR)                                2283
         CR    @15,@10                                             2283
         BE    @RF02283                                            2283
         LTR   @15,@15                                             2283
         BZ    @RF02283                                            2283
*     DO;                           /*                       @D32CKMP*/
*                                                                  2284
*       /*************************************************************/
*       /*                                                           */
*       /* FREESTOR AREA(OCWBNDRU)SIZE(OCWBNDSZ)SAVE(YES)CLEAR(YES)  */
*       /*                                                           */
*       /*************************************************************/
*                                                                  2285
*       DO;                                                        2285
*                                                                  2285
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTATCVT,ISTRPH)                        */
*/* END OF ATBUILD                                                   */
*                                                                  2286
*         RFY                                                      2286
*          (GPR00P,                                                2286
*           GPR01P,                                                2286
*           GPR02P,                                                2286
*           GPR03P) RSTD;                                          2286
*         RFY                                                      2287
*           ISTRPH BASED(GPR01P);                                  2287
*         GEN REFS(GPR02P,GPR03P,GPR04P,GPR05P,GPR06P,GPR07P,GPR08P,
*             GPR09P,GPR10P,GPR11P,GPR12P,GPR13P) SETS(RPHWORK);   2288
         STM   GPR02P,GPR13P,RPHWORK(GPR01P)        SAVE REGISTERS
*         GPR00F=OCWBNDSZ;          /* SIZE IN REG0                  */
         SLR   GPR00F,GPR00F                                       2289
         ICM   GPR00F,3,OCWBNDSZ(OCWPTR)                           2289
*         DCL                                                      2290
*           1 CMZA0433 FIXED(31) STATIC LOCAL,                     2290
*            2 * FIXED(8) INIT(96), /* OPTION FLAGS                  */
*            2 * FIXED(8) INIT(96), /* STORAGE KEY                   */
*            2 * FIXED(8) INIT(231),/* SUBPOOL NUMBER                */
*            2 * FIXED(8) INIT('01'X);/* REQUEST TYPE                */
*         GPR03F=CMZA0433;                                         2291
         L     GPR03F,CMZA0433                                     2291
*         RFY                                                      2292
*          (GPR04P) RSTD;                                          2292
*         GPR04P=OCWBNDRU;          /* PUT FREEMAIN ADDR IN REG4     */
         L     GPR04P,OCWBNDRU(,OCWPTR)                            2293
*         DO;                       /* LISATCVT                    2294
*                                      CVTBASE(PAGEABLE,(GPR02P))    */
*           GPR02P=ATCLCPTR;        /* SET UP ATCVT POINTER          */
         L     GPR02P,ATCLCPTR                                     2295
*         END;                      /* LISATCVT                      */
*         CALL GPR02P->ATCGTSTR;    /* CALL ISTORFSR                 */
         L     @15,ATCGTSTR(,GPR02P)                               2297
         BALR  @14,@15                                             2297
*         RFY                                                      2298
*          (GPR00P,                                                2298
*           GPR01P,                                                2298
*           GPR02P,                                                2298
*           GPR03P,                                                2298
*           GPR04P) UNRSTD;                                        2298
*       END;                        /* END OF FREESTOR               */
*                                                                  2299
*       /*************************************************************/
*       /*                                                           */
*       /* FREE BIND RU AREA                                 @D32CKMP*/
*       /*                                                           */
*       /*************************************************************/
*                                                                  2300
*     END;                          /*                       @D32CKMP*/
*   ELSE                                                           2301
*     ;                             /*                       @D32CKMP*/
@RF02283 DS    0H                                                  2302
*   OCWBNDRU=0;                     /* IND NO BIND RU AREA   @D32CKMP*/
         SLR   @15,@15                                             2302
         ST    @15,OCWBNDRU(,OCWPTR)                               2302
*/*  SEGMENT(CLEANUP)FINISH                                          */
*                                                                  2303
*   DO;                                                            2303
*     GOTO CLEANUP#;                                               2304
         B     CLEANUP#                                            2304
*CLEANUP@:                                                         2305
*   END;                                                           2305
CLEANUP@ DS    0H                                                  2306
*                                                                  2306
*/*  SEGMENT(QNCSPL)START                                            */
*                                                                  2306
*   DO;                                                            2306
*     GOTO QNCSPL@;                                                2307
         B     QNCSPL@                                             2307
*QNCSPL:                                                           2308
*   END;                                                           2308
*                                                                  2308
QNCSPL   DS    0H                                                  2309
*   /*****************************************************************/
*   /*                                                               */
*   /*                                                       @D32CKXY*/
*   /*                                                               */
*   /*****************************************************************/
*                                                                  2309
*/********************************************************************/
*/*  ROUTINE NAME: QNCSPL                                            */
*/*  FUNCTION:                                                       */
*/*       CALLED BY DOPHYCON, QNCSPL DOES A TPQUE OF THE NCSPL       */
*/*       TO VPAB ASSOCIATED WITH HEADER RDT. THIS SUBROUTINE        */
*/*       WAS CREATED TO AVOID A COMPILE PROBLEM CAUSED BY THE       */
*/*       NESTING OF DO STATEMENTS BEYOND THE LIMIT OF 15            */
*/*  ROUTINES CALLED:                                                */
*/*       NONE                                                       */
*/*  MACROS USED:                                                    */
*/*       TPQUE - NCSPL                                              */
*/*       TPUNLOCK - RELEASE RDT LOCK                                */
*/*       TPUNLOCK - RELEASE VOCLOCK                                 */
*/*       TPWAIT - WAIT FOR SSCP FEEDBACK                            */
*/********************************************************************/
*                                                                  2309
*   RFY                                                            2309
*     GPR05P RSTD;                  /*                       @XM00405*/
*   GPR05P=OCWDRDTE;                /* GET LU RDTE ADDR      @XM00405*/
         L     GPR05P,OCWDRDTE(,OCWPTR)                            2310
*   DO WHILE GPR05P->RPRENTRY^=GPR05P->RPRHDTYP;/* GET LOCAL HEADER
*                                                            @DM13782*/
         B     @DE02311                                            2311
@DL02311 DS    0H                                                  2312
*     GPR05P=GPR05P-GPR05P->RPRPELEN;/* GET NEXT RDTE        @XM00405*/
         SH    GPR05P,RPRPELEN(,GPR05P)                            2312
*   END;                            /*                       @XM00405*/
@DE02311 CLC   RPRENTRY(1,GPR05P),RPRHDTYP(GPR05P)                 2313
         BNE   @DL02311                                            2313
*/*  TPQUE (CPARMR08,GPR05P->RDTVPAB->DYPPAB) NORM                   */
*                                                                  2314
*   DO;                                                            2314
*     RFY                                                          2315
*      (GPR00P,                                                    2315
*       GPR01P,                                                    2315
*       GPR04P,                                                    2315
*       GPR05P,                                                    2315
*       GPR15P) RSTD;                                              2315
*     GEN REFS(GPR01P) SETS(RPHWORK)(STM GPR02P,GPR08P,RPHWORK(GPR01P))
*         ;                                                        2316
         STM GPR02P,GPR08P,RPHWORK(GPR01P)
*     GPR00P=0;                                                    2317
         SLR   GPR00P,GPR00P                                       2317
*     GPR15P=ADDR(GPR05P->RDTVPAB->DYPPAB);/* HOLD PAB PTR           */
         L     GPR15P,RDTVPAB(,GPR05P)                             2318
         LA    GPR15P,DYPPAB(,GPR15P)                              2318
*     GPR04P=CPARMR08;              /* WORK ELE PTR                  */
         LR    GPR04P,CPARMR08                                     2319
*     GPR05P=GPR15P;                /* PASS PAB PTR                  */
         LR    GPR05P,GPR15P                                       2320
*     CALL ATCLCPTR->ATCAP37->ISTAPC37;                            2321
         L     @10,ATCLCPTR                                        2321
         L     @15,ATCAP37(,@10)                                   2321
         BALR  @14,@15                                             2321
*     GEN(NOPR  0)                                                 2322
*     NOSETS NOREFS;                                               2322
         NOPR  0
*     RFY                                                          2323
*      (GPR00P,                                                    2323
*       GPR01P,                                                    2323
*       GPR04P,                                                    2323
*       GPR05P,                                                    2323
*       GPR15P) UNRSTD;                                            2323
*   END;                            /* *** END OF TPQUE GENERATION 2324
*                                                            @XM00405*/
*   RFY                                                            2325
*     GPR05P UNRSTD;                /*                       @XM00405*/
*/*** START -TPUNLOCK (OCLOCK)- **                                   */
*                                                                  2326
*   DO;                                                            2326
*                                                                  2326
*/* ATBUILD (ISTRPH,ISTLOK,ISTCRA)                                   */
*/* END OF ATBUILD                                                   */
*                                                                  2327
*     RFY                                                          2327
*      (GPR00P,                                                    2327
*       GPR01P,                                                    2327
*       GPR02P,                                                    2327
*       GPR03P,                                                    2327
*       GPR04P,                                                    2327
*       GPR15P) RSTD;                                              2327
*     GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(RPHWORK);   2328
         STM GPR00P,GPR15P,RPHWORK(GPR01P)
*     GPR02P=ADDR(RPRRLOCK);        /* SET PARAM - LOCKWORD PTR      */
         L     GPR02P,OCWDRDTE(,OCWPTR)                            2329
         LA    GPR02P,RPRRLOCK(,GPR02P)                            2329
*     GPR04P=GPR01P->RPHCRR;        /* SET PARAM - ISTCRA PTR        */
         L     GPR04P,RPHCRR(,GPR01P)                              2330
*     GPR00P=CRALMS04;              /* SET PARAM - LOCK LEVEL FLAG   */
         LA    GPR00P,8                                            2331
*     GPR03P=ADDR(GPR04P->CRAL4PTR);/* SET PARAM - LOCK LEVEL PTR    */
         LA    GPR03P,CRAL4PTR(,GPR04P)                            2332
*     DO;                           /* LISATCVT                    2333
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*       GPR15P=ATCLCPTR;            /* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     2334
*     END;                          /* LISATCVT                      */
*     GPR15P=GPR15P->ATCAP33;                                      2336
         L     GPR15P,ATCAP33(,GPR15P)                             2336
*     DCL                                                          2337
*       FMZL0460 BASED(GPR15P) LABEL VALUERANGE(*);                2337
*     CALL FMZL0460;                                               2338
         BALR  @14,@15                                             2338
*     GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(GPR00P,GPR01P,
*         GPR02P,GPR03P,GPR04P,GPR05P,GPR06P,GPR07P,GPR08P,GPR09P, 2339
*         GPR10P,GPR11P,GPR12P,GPR13P,GPR14P,GPR15P);              2339
         LM GPR00P,GPR15P,RPHWORK(GPR01P)
*     RFY                                                          2340
*      (GPR00P,                                                    2340
*       GPR01P,                                                    2340
*       GPR02P,                                                    2340
*       GPR03P,                                                    2340
*       GPR04P,                                                    2340
*       GPR15P) UNRSTD;                                            2340
*   END;                                                           2341
*                                                                  2341
*/*** END -TPUNLOCK (OCLOCK)- **                                     */
*                                                                  2342
*                                   /* RELEASE RDT LOCK              */
*   OCWELOCK=COFF;                  /* SHOW RDT LOCK NOT HELD.       */
         NI    OCWELOCK(OCWPTR),B'11011111'                        2342
*/*** START -TPUNLOCK (VOCLOCK)- **                                  */
*                                                                  2343
*   DO;                                                            2343
*                                                                  2343
*/* ATBUILD (ISTRPH,ISTLOK,ISTCRA)                                   */
*/* END OF ATBUILD                                                   */
*                                                                  2344
*     RFY                                                          2344
*      (GPR00P,                                                    2344
*       GPR01P,                                                    2344
*       GPR02P,                                                    2344
*       GPR03P,                                                    2344
*       GPR04P,                                                    2344
*       GPR15P) RSTD;                                              2344
*     GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(RPHWORK);   2345
         STM GPR00P,GPR15P,RPHWORK(GPR01P)
*     GPR02P=ADDR(ATCVOCLK);        /* SET PARAM - LOCKWORD PTR      */
         L     GPR02P,OCWACVT(,OCWPTR)                             2346
         LA    GPR02P,ATCVOCLK(,GPR02P)                            2346
*     GPR04P=GPR01P->RPHCRR;        /* SET PARAM - ISTCRA PTR        */
         L     GPR04P,RPHCRR(,GPR01P)                              2347
*     GPR00P=CRALMS02;              /* SET PARAM - LOCK LEVEL FLAG   */
         LA    GPR00P,2                                            2348
*     GPR03P=ADDR(GPR04P->CRAL2PTR);/* SET PARAM - LOCK LEVEL PTR    */
         LA    GPR03P,CRAL2PTR(,GPR04P)                            2349
*     DO;                           /* LISATCVT                    2350
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*       GPR15P=ATCLCPTR;            /* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     2351
*     END;                          /* LISATCVT                      */
*     GPR15P=GPR15P->ATCAP33;                                      2353
         L     GPR15P,ATCAP33(,GPR15P)                             2353
*     DCL                                                          2354
*       FMZL0470 BASED(GPR15P) LABEL VALUERANGE(*);                2354
*     CALL FMZL0470;                                               2355
         BALR  @14,@15                                             2355
*     GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(GPR00P,GPR01P,
*         GPR02P,GPR03P,GPR04P,GPR05P,GPR06P,GPR07P,GPR08P,GPR09P, 2356
*         GPR10P,GPR11P,GPR12P,GPR13P,GPR14P,GPR15P);              2356
         LM GPR00P,GPR15P,RPHWORK(GPR01P)
*     RFY                                                          2357
*      (GPR00P,                                                    2357
*       GPR01P,                                                    2357
*       GPR02P,                                                    2357
*       GPR03P,                                                    2357
*       GPR04P,                                                    2357
*       GPR15P) UNRSTD;                                            2357
*   END;                                                           2358
*                                                                  2358
*/*** END -TPUNLOCK (VOCLOCK)- **                                    */
*                                                                  2359
*                                   /* RELEASE VOCLOCK               */
*   OCWVLOCK=COFF;                  /* SHOW VOCLOCK NOT HELD         */
         NI    OCWVLOCK(OCWPTR),B'01111111'                        2359
*/*  TPWAIT                                                          */
*                                                                  2360
*   DO;                             /* BEGIN TPWAIT GENERATION       */
*     RFY                                                          2361
*      (GPR01P,                                                    2361
*       GPR14P,                                                    2361
*       GPR15P) RSTD;                                              2361
*     RFY                                                          2362
*      (GPR00P) RSTD;                                              2362
*     GEN(STM   GPR00P,GPR15P,RPHWORK(GPR01P))                     2363
*     REFS(GPR00P,GPR01P,GPR15P) SETS(RPHWORK);                    2363
         STM   GPR00P,GPR15P,RPHWORK(GPR01P)
*     RFY                                                          2364
*      (GPR00P) UNRSTD;                                            2364
*     GPR15P=ADDR(LHAA0480);                                       2365
         LA    GPR15P,LHAA0480                                     2365
*     GPR14P=0;                                                    2366
         SLR   GPR14P,GPR14P                                       2366
*     GPR15P=GPR15P&'00FFFFFF'X;                                   2367
         N     GPR15P,@CF05091                                     2367
*     GPR15P=GPR15P|RPHWT1;                                        2368
         O     GPR15P,@CF01455                                     2368
*     CS(GPR14P,GPR15P,GPR01P->RPHRESMA);                          2369
         CS    GPR14P,@15,RPHRESMA(GPR01P)                         2369
*     BC(7,LHAB0480);                                              2370
*                                                                  2370
         BC    7,LHAB0480                                          2370
*/* TPEXIT  NONE                                                     */
*                                                                  2371
*     DO;                                                          2371
*       RESPECIFY                                                  2372
*         GPR15P RSTD;                                             2372
*                                                                  2372
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTATCVT)                               */
*/* END OF ATBUILD                                                   */
*                                                                  2373
*       DO;                         /* LISATCVT                    2373
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*         GPR15P=ATCLCPTR;          /* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     2374
*       END;                        /* LISATCVT                      */
*       RESPECIFY                                                  2376
*         GPR00F RSTD;                                             2376
*       GPR00F=0;                   /* SET PARAMETER REGISTER TO 0   */
         SLR   GPR00F,GPR00F                                       2377
*       GPR15P=GPR15P->ATCAP31;                                    2378
         L     GPR15P,ATCAP31(,GPR15P)                             2378
*       DCL                                                        2379
*         FMZL0485 BASED(GPR15P) LABEL VALUERANGE(*);              2379
*       CALL FMZL0485;                                             2380
         BALR  @14,@15                                             2380
*       RESPECIFY                                                  2381
*        (GPR00F,                                                  2381
*         GPR15P) UNRSTD;                                          2381
*     END;                          /* **** END OF TPEXIT            */
*LHAB0480:                                                         2383
*     ;                                                            2383
LHAB0480 DS    0H                                                  2384
*     GPR01P->RPHRESMA=0;                                          2384
         SLR   @15,@15                                             2384
         ST    @15,RPHRESMA(,GPR01P)                               2384
*     RFY                                                          2385
*      (GPR00P) RSTD;                                              2385
*LHAA0480:                                                         2386
*     ;                                                            2386
LHAA0480 DS    0H                                                  2387
*     GEN(LM    GPR00P,GPR15P,RPHWORK(GPR01P))                     2387
*     REFS(RPHWORK,GPR01P) SETS(GPR00P,GPR15P);                    2387
         LM    GPR00P,GPR15P,RPHWORK(GPR01P)
*     RFY                                                          2388
*      (GPR00P,                                                    2388
*       GPR01P,                                                    2388
*       GPR14P,                                                    2388
*       GPR15P) UNRSTD;                                            2388
*   END;                            /* ****END OF TPWAIT WAIT FOR  2389
*                                      SSCP FEEDBACK.                */
*/*  SEGMENT(QNCSPL)FINISH                                           */
*                                                                  2390
*   DO;                                                            2390
*     GOTO QNCSPL#;                                                2391
         B     QNCSPL#                                             2391
*QNCSPL@:                                                          2392
*   END;                                                           2392
*DOCDFND:                                                          2393
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);/* NEW FOR BIND INTRLCK  @D32CKXY*/
         B     @PB00009                                            2393
DOCDFND  DS    0H                                                  2394
*/********************************************************************/
*/*  ROUTINE NAME: DOCDFND                                           */
*/*  FUNCTION:                                                       */
*/*       DOES A CIDCTL FIND TO OBTAIN THE DAF LOCK EXCLUSIVELY      */
*/*       AND SAVES THE FMCB AND DNCB PTRS IN THE OCW. IF THE        */
*/*       CIDCTL IS UNSUCCESSFUL THE DEST IS MARKED AS NOT           */
*/*       CONNECTED                                                  */
*/*  ROUTINES CALLED:                                                */
*/*       NONE                                                       */
*/*  MACROS USED:                                                    */
*/*       CIDCTL - OBTAIN DAF LOCK                                   */
*/********************************************************************/
*                                                                  2394
*   C14SAVE=CR14PTR;                /* SUBR RETURN           @D32CKXY*/
         LA    @15,624                                             2394
         ALR   @15,OCWPTR                                          2394
         L     @10,C14SVPTR(,@15)                                  2394
         ST    CR14PTR,C14SAVE(,@10)                               2394
*   C14SVPTR=C14SVPTR+4;            /*                       @D32CKXY*/
         AH    @10,@CH00045                                        2395
         ST    @10,C14SVPTR(,@15)                                  2395
*   IF OCWDSTNO>1 THEN                                             2396
         LH    @15,OCWDSTNO(,OCWPTR)                               2396
         CH    @15,@CH00068                                        2396
         BNH   @RF02396                                            2396
*     DO;                           /* IF A LIST REQUEST     @D32CKXY*/
*       RFY                                                        2398
*         SORTPTR RSTD;             /*                       @D32CKXY*/
*       SORTPTR=OCWODLST+(OCWDSTNO*LENGTH(ISTCSL))+OCWODCT1*4;/* PT
*                                      TO NTRY SORT SLOT     @D32CKXY*/
         MH    @15,@CH00033                                        2399
         AL    @15,OCWODLST(,OCWPTR)                               2399
         LH    SORTPTR,OCWODCT1(,OCWPTR)                           2399
         SLA   SORTPTR,2                                           2399
         ALR   @15,SORTPTR                                         2399
         LR    SORTPTR,@15                                         2399
*       OCWCID=SORTPTR->SORTCID;    /* ESTABLISH OCW'S CID   @D32CKXY*/
         MVC   OCWCID(4,OCWPTR),SORTCID(SORTPTR)                   2400
*       RFY                                                        2401
*         SORTPTR UNRSTD;           /*                       @D32CKXY*/
*     END;                                                         2402
*   ELSE                                                           2403
*     ;                             /* CID IS IN OCW         @D32CKXY*/
@RF02396 DS    0H                                                  2404
*   CPARMRG2=OCWCID;                /* SETUP PARM REG        @D32CKXY*/
         L     CPARMRG2,OCWCID(,OCWPTR)                            2404
*   DO;                             /* CIDCTL(FIND) LOCK(XCLUSIVE)   */
*     RFY                                                          2406
*      (EMCR2,                                                     2406
*       EMCR3) RSTD;                                               2406
*     GEN SETS(RPHWORK)                                            2407
*         (STM EMCR0,EMCR15,RPHWORK(RPHPTR) SAVE REGS IN RPH);     2407
         STM EMCR0,EMCR15,RPHWORK(RPHPTR) SAVE REGS IN RPH
*     EMCR3='00'X;                  /* CLEAR EXTRA BITS              */
         SLR   EMCR3,EMCR3                                         2408
*     EMCR3='02'X;                  /* INDICATE EXCLUSIVE LOCK       */
         LA    EMCR3,2                                             2409
*     CALL ATCLCPTR->ATCCDFND->ISTSDCCF;/* PROCESS REQUEST           */
         L     @10,ATCLCPTR                                        2410
         L     @15,ATCCDFND(,@10)                                  2410
         BALR  @14,@15                                             2410
*     RFY                                                          2411
*      (EMCR2,                                                     2411
*       EMCR3) UNRSTD;                                             2411
*   END;                            /* CIDCTL GET DAF LOCK         2412
*                                      XCLUSIVE@D32CKXY              */
*   IF CRETCODE=0 THEN                                             2413
         LTR   CRETCODE,CRETCODE                                   2413
         BNZ   @RF02413                                            2413
*     DO;                           /* IF DAF LOCK OBTAINED  @D32CKXY*/
*       OCWCLOCK=CON;               /* INDIC DAF LOCK HELD   @D32CKXY*/
         OI    OCWCLOCK(OCWPTR),B'00010000'                        2415
*       OCWFMCB=CPARMRG2;           /* SAVE FMCB ADDRESS     @D32CKXY*/
         ST    CPARMRG2,OCWFMCB(,OCWPTR)                           2416
*       OCWNCB=CPARMRG0;            /* SAVE NCB ADDRESS      @D32CKXY*/
         ST    CPARMRG0,OCWNCB(,OCWPTR)                            2417
*     END;                          /*                       @D32CKXY*/
*   ELSE                                                           2419
*     DO;                           /* DAF LOCK NOT OBT      @D32CKXY*/
         B     @RC02413                                            2419
@RF02413 DS    0H                                                  2420
*       OCWODNAS->CSLRDTEF=COFF;    /* INDICATE NO CONNECTION EXISTS
*                                      FOR DEST              @D32CKXY*/
         L     @15,OCWODNAS(,OCWPTR)                               2420
         NI    CSLRDTEF(@15),B'01111111'                           2420
*       IF CRETCODE=4               /* NCB POINTER FOUND             */
*         THEN                                                     2421
         CH    CRETCODE,@CH00045                                   2421
         BNE   @RF02421                                            2421
*         OCWNCB=CPARMRG0;          /* SAVE NCB ADDRESS      @D32CKXY*/
         ST    CPARMRG0,OCWNCB(,OCWPTR)                            2422
*       ELSE                                                       2423
*         OCWNCB=0;                 /* CLEAR NCB POINTER     @D32CKXY*/
         B     @RC02421                                            2423
@RF02421 SLR   @15,@15                                             2423
         ST    @15,OCWNCB(,OCWPTR)                                 2423
*       OCWFMCB=0;                  /* CLEAR FMCB POINTER    @D32CKXY*/
@RC02421 SLR   @15,@15                                             2424
         ST    @15,OCWFMCB(,OCWPTR)                                2424
*       IF CRETCODE=12              /* RDTE PTR FOUND                */
*         THEN                      /* MOVE ENTRY'S RDTE INTO OCW    */
         CH    CRETCODE,@CH00033                                   2425
         BNE   @RF02425                                            2425
*         OCWDRDTE=OCWODNAS->CSLRDEF;/* WITH HOBS SET        @D32CKXY*/
         L     @15,OCWODNAS(,OCWPTR)                               2426
         MVC   OCWDRDTE(4,OCWPTR),CSLRDEF(@15)                     2426
*       ELSE                                                       2427
*         ;                         /*                       @D32CKXY*/
@RF02425 DS    0H                                                  2428
*     END;                          /* END PROC FOR NO LOCK  @D32CKXY*/
*   C14SVPTR=C14SVPTR-4;            /*                       @D32CKXY*/
@RC02413 LA    @15,624                                             2429
         ALR   @15,OCWPTR                                          2429
         L     @10,C14SVPTR(,@15)                                  2429
         SH    @10,@CH00045                                        2429
         ST    @10,C14SVPTR(,@15)                                  2429
*   CR14PTR=C14SAVE;                /*                       @D32CKXY*/
         L     CR14PTR,C14SAVE(,@10)                               2430
*   END DOCDFND;                    /*                       @D32CKXY*/
@EL00009 DS    0H                                                  2431
@EF00009 DS    0H                                                  2431
@ER00009 BR    @14                                                 2431
*CKACE:                                                            2432
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);/* NEW FOR BIND INTRLCK  @D32CKXY*/
CKACE    DS    0H                                                  2433
*/********************************************************************/
*/*  ROUTINE NAME: CKACE                                             */
*/*  FUNCTION:                                                       */
*/*       VERIFY THAT AN ACTIVE CONNECTION ELEMENT(ACE) EXISTS       */
*/*       AND THAT ITS RPH PTR EQUALS THIS PROGRAMS RPH POINTER      */
*/*  ROUTINES CALLED:                                                */
*/*       NONE                                                       */
*/*  MACROS USED:                                                    */
*/*       NONE                                                       */
*/********************************************************************/
*                                                                  2433
*   C14SAVE=CR14PTR;                /* SUBR RETURN           @D32CKXY*/
         LA    @15,624                                             2433
         ALR   @15,OCWPTR                                          2433
         L     @10,C14SVPTR(,@15)                                  2433
         ST    CR14PTR,C14SAVE(,@10)                               2433
*   C14SVPTR=C14SVPTR+4;            /*                       @D32CKXY*/
         AH    @10,@CH00045                                        2434
         ST    @10,C14SVPTR(,@15)                                  2434
*   CPARMRG2=RCPACETR->ACERPHA;     /* GET ACE'S RPH PTR     @D32CKXY*/
         L     @15,OCWDRDTE(,OCWPTR)                               2435
         L     @15,RCPACETR(,@15)                                  2435
         L     CPARMRG2,ACERPHA(,@15)                              2435
*   IF CPARMRG2=RPHPTR&FMCCPIP=COFF THEN                           2436
         CR    CPARMRG2,RPHPTR                                     2436
         BNE   @RF02436                                            2436
         L     @15,OCWFMCB(,OCWPTR)                                2436
         TM    FMCCPIP(@15),B'00001000'                            2436
         BZ    @RT02436                                            2436
*     ;                             /* IF RPH PTR EQ OUR RPH PTR AND
*                                      NO PURGE              @D32CKXY*/
*   ELSE                                                           2438
*     CSLRDTEF=COFF;                /* NO CONNECTION         @D32CKXY*/
@RF02436 NI    CSLRDTEF+40(OCWPTR),B'01111111'                     2438
*   C14SVPTR=C14SVPTR-4;            /*                       @D32CKXY*/
@RT02436 LA    @15,624                                             2439
         ALR   @15,OCWPTR                                          2439
         L     @10,C14SVPTR(,@15)                                  2439
         SH    @10,@CH00045                                        2439
         ST    @10,C14SVPTR(,@15)                                  2439
*   CR14PTR=C14SAVE;                /*                       @D32CKXY*/
         L     CR14PTR,C14SAVE(,@10)                               2440
*   END CKACE;                      /*                       @D32CKXY*/
@EL00010 DS    0H                                                  2441
@EF00010 DS    0H                                                  2441
@ER00010 BR    @14                                                 2441
@PB00010 DS    0H                                                  2442
*                                                                  2442
*/* TPEPILOG                                                         */
*                                                                  2442
*   GEN(PRINT OFF);                                                2442
         PRINT OFF
*/* VS1, VS2 TPIOS SAVEAREA FORMAT */                              2443
*DCL  1  ISTZSAVE BDY(WORD) BASED,                                 2443
*        2   ZSAZSVBC PTR(31),         /* SAVEAREA BACK CHAIN        */
*            3   ZSAZSVMS CHAR(1),     /* MODULE TRACE CODE          */
*                4 ZSAZACTV BIT(1),    /* ACTIVE SAVE AREA FLAG      */
*        2   ZSAZSVFC PTR(31),         /* SAVEAREA FORWARD CHAIN     */
*        2   ZSAZSVRR PTR(31),         /* RETURN REGISTER            */
*        2   ZSAZSVVR (6) PTR(31),    /* VARIABLE REGS (7-12) SVEAREA*/
*        2   ZSAZTRAC CHAR(4);        /* EBCDIC NAME OF OWNER        */
*/*                                                                2444
*THE FOLLOWING EQUATES SHOULD READ ''FIXED(8) CONSTANT(LENGTH(X))'',
*WHERE X IS THE NAME OF THE VARIABLE CONTROL BLOCK OR FIELD OF WHICH
*LENGTH IS THE VALUE BEING EQUATED, SHOULD THE PLS COMPILER BE     2444
*BE ABLE TO TAKE IT.                                               2444
*                                                                    */
*DCL ZSAZSVVA FIXED(8) CONSTANT(8);  /* DISPLACEMENT TO VARIABLE REGS*/
*DCL ZSAZSVSZ FIXED(8) CONSTANT(40); /* LENGTH OF ISTZSAVE           */
*/* PREFIX FOR CRR                                                   */
*/*                                                                  */
*/* RELEASE 1 - JUNE 28, 1973                                        */
*/*                                                                  */
*DCL 1 ISTPFCRR BASED BDY(WORD),        /* PREFIX FOR CRR            */
*     2  PFCCRR   CHAR(4),              /* CRR HEADER                */
*        3  PFCCRRID CHAR(1),           /* CRR ID FIELD              */
*           4  CRRID CHAR(1),           /* BASIC CTL LAYER DEFINITION*/
*        3  PFCRSV10 CHAR(1),           /* RESERVED FOR ALIGNMENT    */
*        3  PFCCRRLN CHAR(2),           /* CRR LENGTH                */
*           4  CRRLEN CHAR(2),          /* BASIC CTL LAYER DEF       */
*     2  PFCHDR CHAR(8) BDY(WORD),      /* SAVE AREA FOR OLD CRR FRR */
*        3  PFCCRRO  PTR(31),           /* PTR TO OLD CRR            */
*           4  CRRCHAIN PTR(31),        /* BASIC CTL LAYER DEFINITION
*                                          FOR OLD CRR PTR           */
*        3  PFCFRRO  PTR(31),           /* PTR TO OLD FRR            */
*           4  CRRFRR   PTR(31),        /* BASIC CTL LAYER         2446
*                                          DEFINITION OF OLD FRR PTR */
*     2  PFCFTA BIT(8),                 /* ID OF LAST FUNCTION TRACED*/
*     2  PFCRSV01 CHAR(3);              /* ALIGNMENT                 */
*DCL PFIDPIE BIT(8) CONSTANT('80'X);    /* DOS/VS TPIOS              */
*DCL PFIDORE BIT(8) CONSTANT('81'X);    /* DOS/VS BMS                */
*DCL PFIDAPE BIT(8) CONSTANT('82'X);    /* DOS/VS PSS                */
*DCL PFCIDPSV BIT(8) CONSTANT('38'X); /* COMPONENT ID              2450
*                                          PSS - VS1 AND 2           */
*DCL PFCIDTPV BIT(8) CONSTANT('3C'X); /* COMPONENT ID              2451
*                                          TPIOS VS1 AND 2           */
*DCL PFCIDSME BIT(8) CONSTANT('3D'X); /* COMPONENT ID              2452
*                                          STORAGE MANAGEMENT DOS    */
*DCL PFCIDOC BIT(8) CONSTANT('31'X);    /* COMPONENT ID OPEN/CLOSE   */
*DCL PFCIDPS BIT(8) CONSTANT('32'X);    /* PORT SOLICITOR            */
*DCL PFCIDCS BIT(8) CONSTANT('34'X);    /* CLUSTER SOLICITOR         */
*DCL PFCIDIT BIT(8) CONSTANT('35'X);    /* INIT/TERM                 */
*DCL PFCIDVY BIT(8) CONSTANT('36'X);    /* VARY                      */
*DCL PFCIDNS  BIT(8) CONSTANT('37'X);   /* NET. STAT.SRV.            */
*DCL PFCIDTPE BIT(8) CONSTANT('38'X);   /* COMPONENT ID            2459
*                                          TPIOS - DOS               */
*DCL PFCIDCL BIT(8) CONSTANT('39'X);    /* COMPONENT ID            2460
*                                          CONTROL LAYER             */
*DCL PFCIDPSE BIT(8) CONSTANT('3A'X);   /* COMPONENT ID            2461
*                                          PSS - DOS                 */
*DCL PFCIDSMV BIT(8) CONSTANT('3F'X);   /* COMPONENT ID            2462
*                                          STORAGE MANAGEMENT        */
*DCL PFCIDTIO BIT(8) CONSTANT('40'X);   /* COMPONENT ID TIIO       2463
*                                          PROCESSING (VS2)          */
*DCL PFCIDRS  BIT(8) CONSTANT('41'X);   /* ID FOR REMOTE SOLICITOR   */
*/* CRR FOR COMMAND FACILITIES                                      */
*/*  REVISIONS                                         001 06/02/75 */
*DCL  1  ISTCFCRR BDY(WORD) BASED, /* CRR FOR COMMAND FACILITIES    */
*        2 CFCAUDIT,               /* AUDIT TRAIL FOR CMD FACILITIES*/
*          3 CFCNTRD  CHAR(1),     /* LIST OF MODULES IN COMMAND    */
*                                  /* FACILITIES ENTERED            */
*            4 NCFCS1   BIT(1),    /* IND MODULE ISTCFCS1 ENTERED   */
*            4 NCFCS2   BIT(1),    /* IND MODULE ISTCFCS2 ENTERED   */
*            4 NCFCR1   BIT(1),    /* IND MODULE ISTCFCR1 ENTERED   */
*            4 NCFCRP   BIT(1),    /* IND MODULE ISTCFCRP ENTERED   */
*            4 NCFCR2   BIT(1),    /* IND MODULE ISTCFCR2 ENTERED   */
*            4 NCFRSVD  BIT(3),    /* RESERVED                      */
*          3 CFCCRT   CHAR(1),     /* LIST OF MODULES IN COMMAND    */
*                                  /* FACILITIES RUNNING            */
*            4 CCFCS1   BIT(1),    /* IND MODULE ISTCFCS1 RUNNING   */
*            4 CCFCS2   BIT(1),    /* IND MODULE ISTCFCS2 RUNNING   */
*            4 CCFCR1   BIT(1),    /* IND MODULE ISTCFCR1 RUNNING   */
*            4 CCFCRP   BIT(1),    /* IND MODULE ISTCFCRP RUNNING   */
*            4 CCFCR2   BIT(1),    /* IND MODULE ISTCFCR2 RUNNING   */
*            4 CCFRSVD1 BIT(3);    /* RESERVED                      */
*DCL TIDCFCS1 BIT(8) CONSTANT('00'X); /* THREAD ID FOR ISTCFCS1     */
*DCL TIDCFCR1 BIT(8) CONSTANT('01'X); /* THREAD ID FOR ISTCFCR1     */
*DCL TIDCFCR2 BIT(8) CONSTANT('02'X); /* THREAD ID FOR ISTCFCR2     */
*/* COMPONENT RECOVERY RECORD FOR TPIOS */                         2469
*/*  DELTA                                             006 02/10/75  */
*DCL                                                               2469
*1  ISTZCRR BDY(WORD) BASED,     /* CONTROL WORD                     */
*   2  ZCRCRR CHAR(4),           /* CONTROL WORD                     */
*      3  ZCRID CHAR(1),         /* CONTROL BLOCK ID                 */
*      3  ZCRLEN CHAR(2),        /* LENGTH OF ZCR                    */
*      3  ZCRFLAG CHAR(1),       /* FLAGS                            */
*   2  ZCRCHAIN PTR(31),         /* POINTER TO PREVIOUS ZCR          */
*   2  ZCRFRRA PTR(31),          /* PTR TO FRR                       */
*   2  ZCRFLGS1 CHAR(1),         /* FLGS USED BY REQUEST COMPLETION  */
*      3  ZCREXSW BIT(1),        /* EXIT SWITCH                      */
*      3  ZCRQUESW BIT(1),       /* QUEUE SWITCH                     */
*      3  ZCRDEQSW BIT(1),       /* DEQUEUE SWITCH                   */
*      3  ZCRWAIT BIT(1),        /* WAIT Q ANALYSIS COMPLETE         */
*      3  ZCRNRMEX BIT(1),       /* NORMAL EXIT TO BE TAKEN          */
*      3  ZCRENDLP BIT(1),       /* END OF LOOP SWITCH               */
*      3  ZCRUNSOL BIT(1),       /* UNSOLICITED DATA                 */
*      3  ZCRFEXIT BIT(1),       /* FORCE EXIT SWITCH                */
*   2  ZCRFLGS2 CHAR(1),         /* FLAGS USED WITHIN TPIOS          */
*      3  ZCRLOCAL BIT(1),       /* LOCAL SUPPORT                    */
*      3  ZCRSHEDI BIT(1),       /* IMMEDIATE SCHEDULE               */
*      3  ZCRFMSED BIT(1),       /* FMCB SEARCH ENDED                */
*      3  ZCROB    BIT(1),       /* OUTBOUND PROC IN PROGRESS        */
*      3  ZCRIF0E1 BIT(1),       /* SWITCH FOR STRUCTURED PGM USED BY
*                                   INBOUND PROCESSING               */
*      3  ZCRIF0E2 BIT(1),       /* SWITCH FOR STRUCTURED PGM USED BY
*                                   INBOUND PROCESSING               */
*      3  ZCRIF0E3 BIT(1),       /* SWITCH FOR STRUCTURED PGM USED BY
*                                   INBOUND PROCESSING               */
*   2  ZCRSWFLD CHAR(1),         /* SWITCHES FOR TPIOS OUTBOUND      */
*      3  ZCRENDSH BIT(1),       /* EXIT FROM REMOTE DEV SCHEDULER   */
*         4  ZCRSLCP BIT(1),     /* SCHEDULE LCPB                    */
*      3  ZCREXTYP BIT(1),       /* TPEXIT TYPE                      */
*      3  ZCRENDPR BIT(1),       /* EXIT FROM INNER PROCESS          */
*      3  ZCRNDLCP BIT(1),       /* EXIT FROM LCPB PROCESSING        */
*         4  ZCROB1 BIT(1),      /* REMOTE DEV SCHED 1ST TIME SWITCH */
*      3  ZCRENDX BIT(1),        /* EXIT FROM LCCW/BTU XLATION       */
*      3  ZCRENDXL BIT(1),       /* EXIT FROM LCCW PROC              */
*      3  ZCRENDAN BIT(1),       /* EXIT FROM LCPB ANALYSIS          */
*      3  ZCRRESET BIT(1),                                         2469
*         4  ZCRCNLXL BIT(1),    /* CANCEL FURTHER XLATE             */
*   2  ZCRFLGS3 CHAR(1),         /* FLAGS FOR OUTBOUND PROCESSING    */
*      3  ZCRTIC BIT(1),         /* SELECT NOT TO BE SENT            */
*      3  ZCRTPCON BIT(1),       /* TPIOS CONTACT SENT               */
*      3  ZCRTPDIS BIT(1),       /* TPIOS DISCONNECT TO BE SENT      */
*      3  ZCRDISC  BIT(1),       /* DISCONNECT IN PROCESS            */
*      3  ZCREDRIV BIT(1),       /* DO DERIVE                        */
*      3  ZCRNOFRE BIT(1),       /* NO FREEING OF SIO QUEUE          */
*      3  ZCRWRPTR BIT(1),       /* WRITE TO PRINTER REQUEST         */
*      3  ZCRINLCP BIT(1),       /* ERROR OCCURED DURING OUTBND PROC */
*   2  ZCRGENSW CHAR(1),         /* GENERAL SWITCHES                 */
*      3  ZCRTSW1  BIT(1),       /* TEMP SW FOR STRUCTURED PGM       */
*      3  ZCRTSW2  BIT(1),       /* TEMP SW FOR STRUCTURED PGM       */
*      3  ZCRRT06  BIT(1),       /* CRITICAL TEXT OPTION             */
*      3  ZCRLCSYN BIT(1),       /* LCCW SYNC SPECIFIED              */
*      3  ZCREXRES BIT(1),       /* EXCEPTION RESPONSE SPECIFIED     */
*      3  ZCRCLRBD BIT(1),       /* FLAG INDICATING BIND WAS CLEARED */
*      3  ZCRBRIS  BIT(1),       /* BRACKET REJECTED DUE TO IN BRAC. */
*      3  ZCRF1RES BIT(1),       /* FID1 RESPONSE TO BE GENERATED    */
*   2  ZCRPFLGS CHAR(1),         /* UTILITIES PROC OPTION FLAGS      */
*      3  ZCRQAHED BIT(1),      /* QXFR RTN TO USE INSERT OPT'N ON TPQ*
*      3  *        BIT(7),      /* RESERVED                          */
*   2  ZCRIBPR CHAR(1),          /* INBOUND PROCESSING FLAGS         */
*         3  ZCRNOBUF BIT(1),    /* FSB WITH NO BUFFER               */
*         3  ZCRERR   BIT(1),    /* ERROR INDICATOR                  */
*         3  ZCRRELK  BIT(1),    /* RESET ERROR LOCK FUNCTION REQ.   */
*         3  ZCRLCPFR BIT(1),    /* FLAG IND. DEALLOCATE ATOP LCPB   */
*         3  ZCRLCPFD BIT(1),    /* FLAG IND. LCPB FOUND ON WAITQ    */
*         3  ZCR3270  BIT(1),    /* 3270 DEVICE                      */
*         3  ZCR3270R BIT(1),    /* 3270 DEVICE IN RECORD MODE       */
*         3  *        BIT(1),    /* RESERVED                         */
*   2  ZCRSCPSW CHAR(1),         /* SESSION CONTROL FLAGS            */
*         3  ZCRTPEX BIT(1),     /* TP EXIT                          */
*         3  ZCRTPINV BIT(1),    /* INVOKE TPIOS                     */
*         3  ZCRRJLCP BIT(1),    /* LCPB REJECTED                    */
*         3  ZCRLREQ BIT(1),     /* REQUEST                          */
*         3  ZCRPRCMP BIT(1),    /* PROCESSING COMPLETE              */
*         3  ZCRFSBWE BIT(1),    /* FSB IS WORK ELEMENT              */
*         3  ZCRSKIPT BIT(1),    /* SKIP TRACE FLAG                  */
*         3  *       BIT(1),     /* RESERVED                         */
*   2  ZCRCRLCP PTR(31),         /* CURRENT LCPB PTR                 */
*   2  ZCRPARMS BDY(WORD),       /* PARAMETERS PASSED TO UTILITIES */
*      3  ZCRFBPTR PTR(31),      /* PTR TO FROM BUFFER               */
*         4  ZCRCBPTR PTR(31),   /* PTR TO CURRENT BUFFER            */
*      3  ZCRTBPTR PTR(31),      /* PTR TO TO-OR-TRANSLATE BUFFER    */
*      3  ZCRMLNG FIXED(15),     /* LENGTH TO MOVE                   */
*      3  ZCRDFRDA FIXED(15),    /* OFFSET FROM DATA ADDR IN FROM BUF*/
*         4  ZCRDTODA FIXED(15), /* OFFSET FROM DATA ADDR XLATE BUF  */
*      3  ZCRPCOD1 CHAR(1),      /* CODE BYTE FOR ALLOC/DISALLOC     */
*         4  ZCRPPG BIT(1),      /* GET PAGEABLE BUFF                */
*         4  ZCRPLNG BIT(1),     /* LENGTH OF BUFFER SPECIFIED       */
*         4  ZCRPFSB BIT(1),     /* GET FSB                          */
*         4  ZCRPLSBF BIT(1),    /* GET LSCB AND BUFFER              */
*            5 ZCRPLSBQ BIT(1),  /* PURGE LSCB QUEUE                 */
*         4  ZCRPLSCB BIT(1),    /* GET OR RELEASE LSCB              */
*         4  ZCRPBUF BIT(1),     /* GET OR RELEASE BUFFER            */
*         4  ZCRPCFTX BIT(1),    /* CONFIDENTIAL TEXT                */
*         4  ZCRPRES BIT(1),     /* RESERVED                         */
*      3  ZCRPCOD2 CHAR(1),      /* CODE BYTE FOR MOVE               */
*         4  ZCRPPG2 BIT(1),     /* GET PAGEABLE BUFFER              */
*         4  ZCRPFHDR BIT(1),    /* FROM BUFFER FDB TO BE USED       */
*         4  ZCRPMFGF BIT(1),    /* MOVE STARTS WIHT 1ST BUFF IN BLOCK*
*         4  ZCRPRES2 BIT(5),    /* RESERVED                         */
*      3  ZCRPCHAR CHAR(1),      /* TRANSLATE & TEST SEARCH CHARACTER*/
*      3  ZCRPSW   CHAR(1),      /* SWITCH FIELD                     */
*   2  ZCRCCWA PTR(31),          /* PTR TO CURRENT CCW (CCW 1 OR 2)  */
*   2  ZCRBFPTR PTR(31),         /* SAVE 1ST BUFF PTR IN TO-BUFF CHN
*                                   OR LAST BUFFER IN CHANNEL PGM    */
*   2  ZCRZLB PTR(31),           /* PTR TO CURR BUFF IN CHANNEL PGM  */
*   2  ZCRPVZB PTR(31),          /* PTR TO PREVIOUS BUFF IN CHAN PGM */
*   2  ZCRSVRTN BDY(WORD),       /* REG 14 SAVE AREAS                */
*      3  ZCRSVF1 PTR(31),       /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF2 PTR(31),       /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF3 PTR(31),       /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF4 PTR(31),       /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF5 PTR(31),       /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF6 PTR(31),       /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF7 PTR(31),       /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF8 PTR(31),       /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF9 PTR(31),       /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF10 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF11 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF12 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF13 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF14 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF15 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF16 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF17 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF18 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF19 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF20 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF21 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF22 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF23 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF24 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF25 PTR(31),      /* SAVE REQUIRED REGISTER           */
*   2  ZCRWKARA BDY(WORD),       /* TEMPORARY REG SAVE AREA          */
*      3  ZCRSVWK1 PTR(31),      /* SAVE REQUIRED REG                */
*      3  ZCRSVWK2 PTR(31),      /* SAVE REQUIRED REG                */
*      3  ZCRSVWK3 PTR(31),      /* SAVE REQUIRED REG                */
*      3  ZCRSVWK4 PTR(31),      /* SAVE REQUIRED REG                */
*      3  ZCRSVWK5 PTR(31),      /* SAVE REQUIRED REG                */
*   2  ZCRFSBSV PTR(31),         /* FSB CHAIN PTR SAVEAREA           */
*   2  ZCRFBPRC BIT(1),          /* FSB PROCESS SW                   */
*   2  ZCRMOREL BIT(1),          /* MORE ELEMENTS SW                 */
*   2  ZCRSCANQ BIT(1),          /* SCAN QUEUE SW                    */
*   2  ZCRNXTEL BIT(1),          /* NEXT ELEMENT SW                  */
*   2  ZCRXSCHD BIT(1),          /* EXIT SCHEDULE SW                 */
*   2  ZCRLSTFB BIT(1),          /* INBOUND PROC LAST FSB FOR ELEM SW*/
*   2  ZCRTOPQ  BIT(1),          /* QUEUE ELEMENT TO TOP SW          */
*   2  ZCRAWQSW BIT(1),          /* CHECK AWAITQ FOR MORE WORK =1    */
*                                /* CHECK WAITQ =0                   */
*   2  ZCRRCDSV CHAR(1),         /* RETURN CODE SAVEAREA             */
*   2  ZCRPRMTC CHAR(1),         /* PREEMPT COMPLETION PARAMETER BYTE*/
*   2  ZCROPCDE CHAR(1),         /* OP CODE TO BE TRANSFORMED         *
*   2  ZCRR2SV PTR(31),          /* ISTZBFDI REG 2 SAVE EREA         */
*   2  ZCRR13SV PTR(31),         /* ISTSBFDI REG 13 SAVE EREA        */
*   2  ZCRCIDSV BDY(WORD),       /* ISTZBFDI CID SAVE AREA           */
*      3  ZCRSAFSV CHAR(2),      /* ISTZBFDI SAF SAVE AREA           */
*      3  ZCRDAFSV CHAR(2),      /* ISTZBFDI DAF SAVE AREA           */
*   2  ZCRSAVEZ (6) BDY(WORD) CHAR(LENGTH(ISTZSAVE)),              2469
*                                /* SAVE/TRACE AREAS FOR TPIOS MODS  */
*   2  ZCRREMIC PTR(31),        /* POINTER TO REMOTE RN ICNCB        */
*   2  ZCRAUDIT CHAR(36),        /* TPIOS AUDIT TRAIL AREA           */
*      3  ZCRTID CHAR(1),        /* THREAD I.D.                      */
*      3  ZCRTNAME CHAR(4),      /* LAST 4 CHARS OF THREAD NAME      */
*      3  ZCRENTER BIT(248),     /* BIT ARRAY FOR MODULES ENTERED    */
*         4  ZCREAC1A BIT(1),    /* ISTZAC1A ENTERED                 */
*         4  ZCREAC0A BIT(1),    /* ISTZAC0A ENTERED                 */
*         4  ZCREAC0B BIT(1),    /* ISTZAC0B ENTERED                 */
*         4  ZCREAC1B BIT(1),    /* ISTZAC1B ENTERED                 */
*         4  ZCREBCAA BIT(1),    /* ISTZBCAA ENTERED                 */
*         4  ZCREBCAB BIT(1),    /* ISTZBCAB ENTERED                 */
*         4  ZCREBCAE BIT(1),    /* ISTZBCAE ENTERED                 */
*         4  ZCREBCAG BIT(1),    /* ISTZBCAG ENTERED                 */
*         4  ZCREBCAI BIT(1),    /* ISTZBCAI ENTERED                 */
*         4  ZCREBCAM BIT(1),    /* ISTZBCAM ENTERED                 */
*         4  ZCREBCBA BIT(1),    /* ISTZBCBA ENTERED                 */
*         4  ZCREBCBB BIT(1),    /* ISTZBCBB ENTERED                 */
*         4  ZCREBCBI BIT(1),    /* ISTZBCBI ENTERED                 */
*         4  ZCREBCCB BIT(1),    /* ISTZBCCB ENTERED                 */
*         4  ZCREBCDI BIT(1),    /* ISTZBCDI ENTERED                 */
*         4  ZCREBCEB BIT(1),    /* ISTZBCEB ENTERED                 */
*         4  ZCREBCFA BIT(1),    /* ISTZBCFA ENTERED                 */
*         4  ZCREBCFB BIT(1),    /* ISTZBCFB ENTERED                 */
*         4  ZCREBCGA BIT(1),    /* ISTZBCGA ENTERED                 */
*         4  ZCREBCGB BIT(1),    /* ISTZBCGB ENTERED                 */
*         4  ZCREBCHA BIT(1),    /* ISTZBCHA ENTERED                 */
*         4  ZCREBCHB BIT(1),    /* ISTZBCHB ENTERED                 */
*         4  ZCREBCIA BIT(1),    /* ISTZBCIA ENTERED                 */
*         4  ZCREBCIB BIT(1),    /* ISTZBCIB ENTERED                 */
*         4  ZCREBCID BIT(1),    /* ISTZBCID ENTERED                 */
*         4  ZCREBCJA BIT(1),    /* ISTZBCJA ENTERED                 */
*         4  ZCREBCJB BIT(1),    /* ISTZBCJB ENTERED                 */
*         4  ZCREBCKA BIT(1),    /* ISTZBCKA ENTERED                 */
*         4  ZCREBCKB BIT(1),    /* ISTZBCKB ENTERED                 */
*         4  ZCREBCLA BIT(1),    /* ISTZBCLA ENTERED                 */
*         4  ZCREBCLB BIT(1),    /* ISTZBCLB ENTERED                 */
*         4  ZCREBCMB BIT(1),    /* ISTZBCMB ENTERED                 */
*         4  ZCREBCND BIT(1),    /* ISTZBCND ENTERED                 */
*         4  ZCREBCNE BIT(1),    /* ISTZBCNE ENTERED                 */
*         4  ZCREBCOB BIT(1),    /* ISTZBCOB ENTERED                 */
*         4  ZCREBCPB BIT(1),    /* ISTZBCPB ENTERED                 */
*         4  ZCREBCQB BIT(1),    /* ISTZBCQB ENTERED                 */
*         4  ZCREBCRA BIT(1),    /* ISTZBCRA ENTERED                 */
*         4  ZCREBCRB BIT(1),    /* ISTZBCRB ENTERED                 */
*         4  ZCREBCSC BIT(1),    /* ISTZBCSC ENTERED                 */
*         4  ZCREBCXA BIT(1),    /* ISTZBCXA ENTERED                 */
*         4  ZCREBCX0 BIT(1),    /* ISTZBCX0 ENTERED                 */
*         4  ZCREBCY0 BIT(1),    /* ISTZBCY0 ENTERED                 */
*         4  ZCREBCZ0 BIT(1),    /* ISTZBCZ0 ENTERED                 */
*         4  ZCREBC0A BIT(1),    /* ISTZBC0A ENTERED                 */
*         4  ZCREBC0B BIT(1),    /* ISTZBC0B ENTERED                 */
*         4  ZCRECC0A BIT(1),    /* ISTZCC0A ENTERED                 */
*         4  ZCRECC0B BIT(1),    /* ISTZCC0B ENTERED                 */
*         4  ZCRECC1A BIT(1),    /* ISTZCC1A ENTERED                 */
*         4  ZCRECC1B BIT(1),    /* ISTZCC1B ENTERED                 */
*         4  ZCRECC2B BIT(1),    /* ISTZCC2B ENTERED                 */
*         4  ZCREDCA0 BIT(1),    /* ISTZDCA0 ENTERED                 */
*         4  ZCREDCB0 BIT(1),    /* ISTZDCB0 ENTERED                 */
*         4  ZCREDCC0 BIT(1),    /* ISTZDCC0 ENTERED                 */
*         4  ZCREDCD0 BIT(1),    /* ISTZDCD0 ENTERED                 */
*         4  ZCREDCE0 BIT(1),    /* ISTZDCE0 ENTERED                 */
*         4  ZCREDCF0 BIT(1),    /* ISTZDCF0 ENTERED                 */
*         4  ZCREDCH0 BIT(1),    /* ISTZDCH0 ENTERED                 */
*         4  ZCREDCI0 BIT(1),    /* ISTZDCI0 ENTERED                 */
*         4  ZCREDCJ0 BIT(1),    /* ISTZDCJ0 ENTERED                 */
*         4  ZCREDCKA BIT(1),    /* ISTZDCKA ENTERED                 */
*         4  ZCREDCKB BIT(1),    /* ISTZDCKB ENTERED                 */
*         4  ZCREDCL0 BIT(1),    /* ISTZDCL0 ENTERED                 */
*         4  ZCREDCMB BIT(1),    /* ISTZDCMB ENTERED                 */
*         4  ZCREECBA BIT(1),    /* ISTZECBA ENTERED                 */
*         4  ZCREECBB BIT(1),    /* ISTZECBB ENTERED                 */
*         4  ZCREECCA BIT(1),    /* ISTZECCA ENTERED                 */
*         4  ZCREECCB BIT(1),    /* ISTZECCB ENTERED                 */
*         4  ZCREECDA BIT(1),    /* ISTZECDA ENTERED                 */
*         4  ZCREECEA BIT(1),    /* ISTZECEA ENTERED                 */
*         4  ZCREECTA BIT(1),    /* ISTZECTA ENTERED                 */
*         4  ZCREFCEA BIT(1),    /* ISTZFCEA ENTERED                 */
*         4  ZCREFCEB BIT(1),    /* ISTZFCEB ENTERED                 */
*         4  ZCREGCAB BIT(1),    /* ISTZGCAB ENTERED                 */
*         4  ZCREGCBB BIT(1),    /* ISTZGCBB ENTERED                 */
*         4  *        BIT(1),    /* NOT USED                         */
*         4  ZCREGCDB BIT(1),    /* ISTZGCDB ENTERED                 */
*         4  ZCREGCEB BIT(1),    /* ISTZGCEB ENTERED                 */
*         4  ZCREGCLA BIT(1),    /* ISTZGCLA ENTERED                 */
*         4  ZCREGC0A BIT(1),    /* ISTZGC0A ENTERED                 */
*         4  ZCREGC0B BIT(1),    /* ISTZGC0B ENTERED                 */
*         4  ZCREHCAN BIT(1),    /* ISTZHCAN ENTERED                 */
*         4  ZCREICAA BIT(1),    /* ISTZICAA ENTERED                 */
*         4  ZCREICAB BIT(1),    /* ISTZICAB ENTERED                 */
*         4  ZCREICBB BIT(1),    /* ISTZICBB ENTERED                 */
*         4  ZCREICBI BIT(1),    /* ISTZICBI ENTERED                 */
*         4  ZCREICCB BIT(1),    /* ISTZICCB ENTERED                 */
*         4  ZCREICCI BIT(1),    /* ISTZICCI ENTERED                 */
*         4  ZCREICDB BIT(1),    /* ISTZICDB ENTERED                 */
*         4  ZCREICEB BIT(1),    /* ISTZICEB ENTERED                 */
*         4  ZCREICGB BIT(1),    /* ISTZICGB ENTERED                 */
*         4  ZCREICHB BIT(1),    /* ISTZICHB ENTERED                 */
*         4  ZCREICIB BIT(1),    /* ISTZICIB ENTERED                 */
*         4  ZCREICID BIT(1),    /* ISTZICID ENTERED                 */
*         4  ZCREICJB BIT(1),    /* ISTZICJB ENTERED                 */
*         4  ZCREICKB BIT(1),    /* ISTZICKB ENTERED                 */
*         4  ZCREICKE BIT(1),    /* ISTZICKE ENTERED                 */
*         4  ZCREICKG BIT(1),    /* ISTZICKG ENTERED                 */
*         4  ZCREICLB BIT(1),    /* ISTZICLB ENTERED                 */
*         4  ZCREICMB BIT(1),    /* ISTZICMB ENTERED                 */
*         4  ZCREICNA BIT(1),    /* ISTZICNA ENTERED                 */
*         4  ZCREICNB BIT(1),    /* ISTZICNB ENTERED                 */
*         4  ZCREICOA BIT(1),    /* ISTZICOA ENTERED                 */
*         4  ZCREICOB BIT(1),    /* ISTZICOB ENTERED                 */
*         4  ZCREICQA BIT(1),    /* ISTZICQA ENTERED                 */
*         4  ZCREICQB BIT(1),    /* ISTZICQB ENTERED                 */
*         4  ZCREICRB BIT(1),    /* ISTZICRB ENTERED                 */
*         4  ZCREICSB BIT(1),    /* ISTZICSB ENTERED                 */
*         4  ZCREICSC BIT(1),    /* ISTZICSC ENTERED                 */
*         4  ZCREICTB BIT(1),    /* ISTZICTB ENTERED                 */
*         4  ZCREICUB BIT(1),    /* ISTZICUB ENTERED                 */
*         4  ZCREICVB BIT(1),    /* ISTZICVB ENTERED                 */
*         4  ZCREICWB BIT(1),    /* ISTZICWB ENTERED                 */
*         4  ZCREICX0 BIT(1),    /* ISTZICX0 ENTERED                 */
*         4  ZCREIC0B BIT(1),    /* ISTZIC0B ENTERED                 */
*         4  ZCREIC1B BIT(1),    /* ISTZIC1B ENTERED                 */
*         4  ZCREJCAB BIT(1),    /* ISTZJCAB ENTERED                 */
*         4  ZCREJCBB BIT(1),    /* ISTZJCBB ENTERED                 */
*         4  ZCREJCCB BIT(1),    /* ISTZJCCB ENTERED                 */
*         4  ZCREJCDB BIT(1),    /* ISTZJCDB ENTERED                 */
*         4  ZCREJC0B BIT(1),    /* ISTZJC0B ENTERED                 */
*         4  ZCREKCBB BIT(1),    /* ISTZKCBB ENTERED                 */
*         4  ZCREKCBN BIT(1),    /* ISTZKCBN ENTERED                 */
*         4  ZCREKCCN BIT(1),    /* ISTZKCCN ENTERED                 */
*         4  ZCREDCWR BIT(1),    /* ISTZDCWR ENTERED                 */
*         4  ZCREDCWB BIT(1),    /* ISTZDCWB ENTERED                 */
*         4  ZCREDCXR BIT(1),    /* ISTZDCXR ENTERED                 */
*         4  ZCREBCBR BIT(1),    /* ISTZBCBR ENTERED                 */
*         4  ZCREBCDR BIT(1),    /* ISTZBCDR ENTERED                 */
*         4  ZCREBCAR BIT(1),    /* ISTZBCAR ENTERED                 */
*         4  ZCRECCBI BIT(1),    /* ISTZCCBI ENTERED                 */
*         4  ZCRECCAI BIT(1),    /* ISTZCCAI ENTERED                 */
*         4  ZCRECCCI BIT(1),    /* ISTZCCCI ENTERED                 */
*         4  ZCREAC1R BIT(1),    /* ISTZAC1R ENTERED                 */
*         4  ZCREBCSB BIT(1),    /* ISTZBCSB ENTERED                 */
*         4  ZCREDCPR BIT(1),    /* ISTZDCPR ENTERED                 */
*         4  ZCREDCQR BIT(1),    /* ISTZDCQR ENTERED                 */
*         4  ZCREBCAL BIT(1),    /* ISTZBCAL ENTERED                 */
*         4  ZCREBC0L BIT(1),    /* ISTZBC0L ENTERED                 */
*         4  ZCREBCNB BIT(1),    /* ISTZBCNB ENTERED                 */
*         4  ZCREICOE BIT(1),    /* ISTZICOE ENTERED                 */
*         4  ZCREDCNB BIT(1),    /* ISTZDCNB ENTERED                 */
*         4  ZCREKCCB BIT(1),    /* ISTZKCCB ENTERED                 */
*         4  ZCRECFY0 BIT(1),    /* ISTZCFY0 ENTERED                 */
*         4  ZCREDCK0 BIT(1),    /* ISTZDFK0 ENTERED                 */
*         4  ZCREICSG BIT(1),    /* ISTZICSG ENTERED                 */
*         4  ZCREBCIF BIT(1),    /* ISTZBCIF ENTERED                 */
*         4  ZCREDCMF BIT(1),    /* ISTZDCMF ENTERED                 */
*         4  ZCRELCAB BIT(1),    /* ISTZLCAB ENTERED                 */
*         4  ZCREAC2B BIT(1),    /* ISTZAC2B ENTERED                 */
*         4  ZCREIC2B BIT(1),    /* ISTZIC2B ENTERED                 */
*         4  ZCRRSV97 BIT(97),   /* RESERVED                         */
*   2  ZCRCMNRC CHAR(1),                /* PURGE MWOR RETURN CODE    */
*   2  ZCRWORDA CHAR(3),                /* RESERVED FOR LATER USE    */
*   2  ZCRLCPB  CHAR(LENGTH(ISTLCPB)),  /* 3270 S/R LCPB             */
*      3 ZCRRHRU,                       /* SAVEAREA FOR RH AND RU    */
*        4 ZCRRH    CHAR(3),            /* RH                        */
*        4 ZCRRU    CHAR(*);            /* RU                        */
*DCL ZCTYPE BIT(8) CONSTANT('00'X);   /* ZCR TYPE                   */
*DCL ZCLNG FIXED(15) CONSTANT(172);   /* ZCRR LENGTH                */
*DCL ZCRSAVNO BIT(8) CONSTANT('06'X); /* NUMBER OF SAVEAREAS IN ZCRR */
*DCL ZCRLSVNO BIT(8) CONSTANT('04'X); /* NUMBER OF SAVE AREAS IN   2473
*                                         LOCAL SUPPORT              */
*/* *** EQUATES FOR ZCRRCDSV *** */                                2474
*                                                                  2474
*DCL ZCRMRFSB BIT(8) CONSTANT('0C'X);  /* REQUEST COMPLETION MOVE FSB
*                                         TO PROCESS                 */
*DCL ZCRSRCHQ BIT(8) CONSTANT('10'X);  /* REQUEST COMPLETION SEARCH
*                                         REQUEST QUEUE              */
*DCL ZCREXIT  BIT(8) CONSTANT('14'X);  /* REQUEST COMPLETION EXIT    */
*DCL ZCRSFSB  BIT(8) CONSTANT('18'X);  /* REQUEST COMPLETION SINGLE
*                                         FSB                        */
*DCL ZCRDLFSB BIT(8) CONSTANT('1C'X);  /* REQUEST COMPLETION DUAL FSB *
*DCL ZCRNOSCH BIT (8) CONSTANT('20'X); /* REQUEST COMPLETION, EXIT WITH
*                                         SCHED NONE                 */
*DCL ZCRNRSCH BIT (8) CONSTANT('24'X); /* REQUEST COMPLETION, EXIT WITH
*                                         SCHED NORM                 */
*DCL ZCRLGERR FIXED(8) CONSTANT(8);    /* LOGICAL ERROR              */
*DCL ZCPLSCB BIT(8) CONSTANT('08'X);   /* GET A RELEASE LSCB         */
*DCL ZCPBUF  BIT(8) CONSTANT('04'X);   /* GET A RELEASE BUFFER       */
*DCL ZCRTAC0A FIXED(8) CONSTANT(01);   /* LOCAL DEVICE SCHEDULER(OUT)*/
*DCL ZCRTAC0B FIXED(8) CONSTANT(02);   /* REMOTE DEVICE SCHEDLER(OUT)*/
*DCL ZCRTCC1A FIXED(8) CONSTANT(03);   /* LOCAL DIALOG SCHEDLER(IN)  */
*DCL ZCRTCC1B FIXED(8) CONSTANT(04);   /* REMOTE DIALOG SCHEDLER(IN) */
*DCL ZCRTDCE0 FIXED(8) CONSTANT(05);   /* NCP SLOWDOWN RECOVERY      */
*DCL ZCRTDCKA FIXED(8) CONSTANT(06);   /* LOCAL GENERAL FUNCTIONS    */
*DCL ZCRTDCKB FIXED(8) CONSTANT(07);   /* REMOTE GENERAL FUNCTIONS   */
*DCL ZCRTFCEB FIXED(8) CONSTANT(08);   /* REMOTE READ BUFFER ALLOC.  */
*DCL ZCRTGCLA FIXED(8) CONSTANT(09);   /* LCAL CTL & TEST FEEDBACK(IN)*
*DCL ZCRTGC0A FIXED(8) CONSTANT(10);   /* LOCAL REQ. COMPLETION(IN)  */
*DCL ZCRTGC0B FIXED(8) CONSTANT(11);   /* REMOTE REQ. COMPLETION(IN) */
*DCL ZCRTICWB FIXED(8) CONSTANT(12);   /* RESET CLEANUP (PHASE 5)    */
*DCL ZCRTIC0B FIXED(8) CONSTANT(13);   /* REMOTE REQ COMPLTION CTL(IN)*
*DCL ZCRTAC1B FIXED(8) CONSTANT(14);   /* ISTZAC1B THREAD ID         */
*DCL ZCRTIC1B FIXED(8) CONSTANT(15);   /* ISTZIC1B THREAD ID         */
*DCL ZCRTCCBI FIXED(8) CONSTANT(16);   /* ISTZCCBI THREAD ID         */
*DCL ZCRTAC1R FIXED(8) CONSTANT(17);   /* ISTZAC1R THREAD ID         */
*DCL ZCRTAC1A FIXED(8) CONSTANT(18);   /* ISTZAC1A THREAD ID         */
*DCL ZCRTLCAB FIXED(8) CONSTANT(19);   /* ISTZLCAB THREAD ID         */
*/* COMPONENT RECOVERY                                               */
*/*                                                                  */
*DCL 1 ISTASCRR BDY(WORD) BASED,        /* CRR FOR SMS               */
*     2  ASCPFCRR CHAR(LENGTH(ISTPFCRR)),                          2503
*     2  ASCFLAGS CHAR(7),              /* FLAGS                     */
*        3  ASCFLG1 CHAR(2),            /* MODULE TRACE FLAGS        */
*           4  ASCFBA BIT(1),           /* ALLOCATION IN PATH        */
*           4  ASCFBD BIT(1),           /* DE-ALLOCATION IN PATH     */
*           4  ASCFSR BIT(1),           /* FSR IN PATH               */
*           4  ASCPASTR BIT(13),        /* RESERVED PATH FLAGS       */
*        3  ASCFLG2 CHAR(2),            /* MODULE IN CONTROL FLAGS   */
*           4  ASCFBAIC BIT(1),         /* ALLOCATION IN CONTROL     */
*           4  ASCFBDIC BIT(1),         /* DE-ALLOCATION IN CONTROL  */
*           4  ASCFSRIC BIT(1),         /* FSR IN CONTROL            */
*           4  ASCICR BIT(13),          /* RESERVED IN CONTROL FLAGS */
*        3  ASCFLG3 CHAR(3),            /* AUDIT FLAGS               */
*           4  ASCFSRGT BIT(1),         /* FSR DOING GET PROCESSING  */
*           4  ASCFBDAL BIT(1),         /* FBD DOING ALLOCATION      */
*           4  ASCKEYF BIT(1),          /* KEY HAS BEEN ALTERED      */
*           4  ASCLLKF BIT(1),          /* LOCAL LOCK HELD           */
*           4  ASCFBDUD BIT(1),         /* FBD USING USER DATA       */
*           4  ASCAUDIT BIT(19),        /* RESERVED AUDIT BITS       */
*     2  ASCKEY CHAR(1),                /* ORIGINAL KEY              */
*     2  ASCETRYA PTR(31),              /* RETRY ADRS FOR CONTINUE 2503
*                                          OPTION                    */
*     2  ASCUSRGS CHAR(16),             /* SAVE AREA FOR USER REGS 2503
*                                          14 - 1                    */
*        3  ASCUSR14 CHAR(4),           /* REGISTER 14               */
*        3  ASCUSR15 CHAR(4),           /* REGISTER 15               */
*        3  ASCUSR00 CHAR(4),           /* REGISTER 0                */
*        3  ASCUSR01 CHAR(4),           /* REGISTER 1                */
*     2  ASCPSREG CHAR(16);             /* SAVE AREA FOR PSS       2503
*                                          REGS 1 - 4                */
*/*  INITIAL LEVEL                                      001 04/09/75 */
*DCL 1 ISTAPCRR BDY(WORD) BASED,                                   2504
*     2 APCHDRSV CHAR(LENGTH(ISTPFCRR)),  /* HEADER                  */
*     2  APCATFLG CHAR(2),              /* AUDIT TRACE FLAGS         */
*        3  APC51E BIT(1),              /* ISTAPC51 WAS ENTERED      */
*        3  APC52E BIT(1),              /* ISTAPC52  '     '         */
*        3  APC53E BIT(1),              /* ISTAPC53                  */
*        3  APC54E BIT(1),                                         2504
*        3  APC56E BIT(1),                                         2504
*        3  APC57E BIT(1),                                         2504
*        3  APC58E BIT(1),                                         2504
*        3  APC31E BIT(1),                                         2504
*        3 * BIT(8),                    /* RESERVED                  */
*     2  APCRFLG CHAR(2),               /* AUDIT TRACE FLAGS         */
*        3  APC51R BIT(1),              /* ISTAPCR1 IS RUNNING       */
*        3  APC52R BIT(1),              /* ISTAPC52 IS RUNNING       */
*        3  APC53R BIT(1),                                         2504
*        3  APC54R BIT(1),                                         2504
*        3  APC56R BIT(1),                                         2504
*        3  APC57R BIT(1),                                         2504
*        3  APC58R BIT(1),                                         2504
*        3  APC31R BIT(1),                                         2504
*        3  *      BIT(8),              /* RESERVED                  */
*     2  APCPSTA PTR(31),               /* PST@                      */
*     2  APCTCBA PTR(31),               /* TCB@                      */
*     2  APCRTRN PTR(31),               /*@ TO BR14 TO RTN TO SYSTEM */
*     2  APCPABSV PTR(31),              /*SAVED PAB@ TO REDISPATCH   */
*     2  APCQWFO PTR(31),               /* Q@ IN PST WORK AREA ON    */
*     2  APCFRRPM PTR(31),              /* WORKAREA@ RTN'D FROM SETFR*/
*     2  APCSAVE CHAR(72),                                         2504
*        3  APCESTAL CHAR(72),          /* ESTAE PARAMETER LIST AREA */
*     2  APCCOMF CHAR(4) BDY(HWORD),    /* FLAGS USED BY ALL PSS RTN */
*        3  APCCOMF1 CHAR(2),                                      2504
*           4  APCSSTSK BIT(1),         /* IRB TYPE WORK             */
*           4  APCUETSK BIT(1),         /* USER EXIT RUNNING UNDER IRB*
*           4  APCSMCR BIT(1),          /* SMA CRA BEING USED        */
*           4  APCIRB1 BIT(1),          /* IRB1 BEING USED           */
*           4  APCIRB2 BIT(1),          /* IRB2 BEING USED           */
*           4  APCRELR BIT(1),          /*CALL ISTAPC58 TO RLEASE CRA*/
*           4  APCEXIT BIT(1),          /* TELLS ISTAPC58 TO EXIT SYS*/
*           4  APCZLBER BIT(1),         /* ERR WHILE RUNNING ZLFAB PAB*
*           4  * BIT(8),                /* RESERVED                  */
*        3  APCRETCD FIXED(15),         /* RTN CODE FOR R15 FOR SYS  */
*     2  APCSAV1 PTR(31),               /* 1ST SAVE WORD             */
*     2  APCSAV2 PTR(31),               /* 2ND SAVE WORD             */
*     2  APCSWTWD CHAR(4),              /* SWITCH AREA FOR PSS RTN   */
*     2  APC31FLG CHAR(1),              /* ISTAPC31 FLAGS            */
*        3  APCTPXIT BIT(1),            /* TPEXIT IN PROGRESS        */
*        3  APCRESCH BIT(1),            /*PAB TPEXIT OCCURED  RESCHED*/
*        3  APCSORT BIT(1),       /* PAB SORTED TO PROPER PST/MPST   */
*        3  *       BIT(5),       /* RESERVED                        */
*     2  APC52FLG CHAR(1),        /* ISTAPC52 FLAGS                  */
*        3  APCCKRQ BIT(1),       /* CHECK RDY Q FOR WORK            */
*        3  APCSMSR BIT(1),       /* RETURNING SMS RPH               */
*        3  APCQENQ BIT(1),       /* ENQUEUEING PAB'S ON PST Q'S     */
*        3  APCRDQ BIT(1),        /* DEQUEING PAB'S FROM PST RDY Q   */
*        3  APCNWF BIT(1),        /* NO WORK FOUND                   */
*        3  APCWKF   BIT(1),      /* WORK FOUND                      */
*        3    *      BIT(2),      /* RESERVED                        */
*     2  APC53FLG CHAR(1),        /* ISTAPC53 FLAGS                  */
*        3  APCPR153 BIT(1),      /* USED PREALLOCATED CRA           */
*     2  APC54FLG CHAR(1),        /* ISTAPC54 FLAGS                  */
*        3  APCRLST BIT(1),       /* SMS BEING CALLED TO RELEASE UECB*/
*        3  * BIT(7),             /* RESERVED                        */
*     2  APC57FLG CHAR(1),        /* ISTAPC57 FLAGS                  */
*        3  APCRECRA BIT(1),      /* RELEASE CRA BEING DONE          */
*        3  APCNREL BIT(1),       /* DID NOT RELEASE CRA             */
*        3  *   BIT(6),           /* RESERVED                        */
*     2  * CHAR(15);              /* RESERVED                        */
*/*               COMPONENT RECOVERY AREA                            */
*/*  REVISIONS                                         005 04/09/75  */
*DCL 1  ISTCRA BASED BDY(DWORD),        /* COMPONENT RECOVERY AREA   */
*     2  CRABASIC BDY(WORD),            /* CRA WITHOUT PROCESS CRR   */
*      3 CRAHDR CHAR(8) BDY(WORD),      /* CRA HEADER                */
*        4  CRACRR PTR(31),             /* PTR TO ACTIVE CRR         */
*        4  CRAFRR PTR(31),             /* PTR TO ACTIVE FRR         */
*      3 CRALKACT BIT(32),              /* LOCK LEVEL AND          2505
*                                          OWNERSHIP FLAGS           */
*        4  CRALEV32 BIT(1),            /* 1 = LEVEL 32 LOCK HELD    */
*        4  CRALEV31 BIT(1),            /* 1 = LEVEL 31 LOCK HELD    */
*        4  CRALEV30 BIT(1),            /* 1 = LEVEL 30 LOCK HELD    */
*        4  CRALEV29 BIT(1),            /* 1 = LEVEL 29 LOCK HELD    */
*        4  CRALEV28 BIT(1),            /* 1 = LEVEL 28 LOCK HELD    */
*        4  CRALEV27 BIT(1),            /* 1 = LEVEL 27 LOCK HELD    */
*        4  CRALEV26 BIT(1),            /* 1 = LEVEL 26 LOCK HELD    */
*        4  CRALEV25 BIT(1),            /* 1 = LEVEL 25 LOCK HELD    */
*        4  CRALEV24 BIT(1),            /* 1 = LEVEL 24 LOCK HELD    */
*        4  CRALEV23 BIT(1),            /* 1 = LEVEL 23 LOCK HELD    */
*        4  CRALEV22 BIT(1),            /* 1 = LEVEL 22 LOCK HELD    */
*        4  CRALEV21 BIT(1),            /* 1 = LEVEL 21 LOCK HELD    */
*        4  CRALEV20 BIT(1),            /* 1 = LEVEL 20 LOCK HELD    */
*        4  CRALEV19 BIT(1),            /* 1 = LEVEL 19 LOCK HELD    */
*        4  CRALEV18 BIT(1),            /* 1 = LEVEL 18 LOCK HELD    */
*        4  CRALEV17 BIT(1),            /* 1 = LEVEL 17 LOCK HELD    */
*        4  CRALEV16 BIT(1),            /* 1 = LEVEL 16 LOCK HELD    */
*        4  CRALEV15 BIT(1),            /* 1 = LEVEL 15 LOCK HELD    */
*        4  CRALEV14 BIT(1),            /* 1 = LEVEL 14 LOCK HELD    */
*        4  CRALEV13 BIT(1),            /* 1 = LEVEL 13 LOCK HELD    */
*        4  CRALEV12 BIT(1),            /* 1 = LEVEL 12 LOCK HELD    */
*        4  CRALEV11 BIT(1),            /* 1 = LEVEL 11 LOCK HELD    */
*        4  CRALEV10 BIT(1),            /* 1 = LEVEL 10 LOCK HELD    */
*        4  CRALEV09 BIT(1),            /* 1 = LEVEL 9 LOCK HELD     */
*        4  CRALEV08 BIT(1),            /* 1 = LEVEL 8 LOCK HELD     */
*        4  CRALEV07 BIT(1),            /* 1 = LEVEL 7 LOCK HELD     */
*        4  CRALEV06 BIT(1),            /* 1 = LEVEL 6 LOCK HELD     */
*        4  CRALEV05 BIT(1),            /* 1 = LEVEL 5 LOCK HELD     */
*        4  CRALEV04 BIT(1),            /* 1 = LEVEL 4 LOCK HELD     */
*        4  CRALEV03 BIT(1),            /* 1 = LEVEL 3 LOCK HELD     */
*        4  CRALEV02 BIT(1),            /* 1 = LEVEL 2 LOCK HELD     */
*        4  CRALEV01 BIT(1),            /* 1 = LEVEL 1 LOCK HELD     */
*      3 CRAL1PTR PTR(31),              /* PTR TO LEVEL 1 LOCK       */
*      3 CRAL2PTR PTR(31),              /* PTR TO LEVEL 2 LOCK       */
*      3 CRAL3PTR PTR(31),              /* PTR TO LEVEL 3 LOCK       */
*      3 CRAL4PTR PTR(31),              /* PTR TO LEVEL 4 LOCK       */
*      3 CRAL5PTR PTR(31),              /* PTR TO LEVEL 5 LOCK       */
*      3 CRAL6PTR PTR(31),              /* PTR TO LEVEL 6 LOCK       */
*      3 CRAL7PTR PTR(31),              /* PTR TO LEVEL 7 LOCK       */
*      3 CRAL8PTR PTR(31),              /* PTR TO LEVEL 8 LOCK       */
*      3 CRAL9PTR PTR(31),              /* PTR TO LEVEL 9 LOCK       */
*      3 CRALAPTR PTR(31),              /* RESERVED                  */
*/*                                                                  */
*/*   VS1/VS2 EXTENSION                                              */
*/*                                                                  */
*     2  CRARPH CHAR(LENGTH(ISTRPH)),   /* RPH ASSOCIATED WITH     2505
*                                          THIS CRH                  */
*     2  CRAPSS CHAR(LENGTH(ISTAPCRR)), /* PSS CRR                   */
*     2  CRAPROCR CHAR(LENGTH(ISTZCRR)) BDY(DWORD), /* PROCESS CRR   */
*     2  CRASVC CHAR(72) BDY(WORD),     /* SERVICE RTN CRA           */
*        3  CRAASCRR CHAR(LENGTH(ISTASCRR)), /* CRR FOR SMS          */
*        3  CRAHSIZ  PTR(31),           /* HEADER SIZE QUED SMS REQ  */
*        3  CRAMASK  PTR(31),           /* PREFIX MASK QUED SMS REQ  */
*        3  CRABUFA  FIXED(31),         /* BUFF QUE FOR FBQ ALLOCATION*
*           4 CRABFTBA BIT(1),          /* NO BUFFERS ALLOCATED YET   *
*     2  CRARSV01 PTR(31),              /* RESERVED                  */
*     2  CRARSV02 PTR(31),              /* RESERVED                  */
*     2  CRACHAIN PTR(31);              /* CHAIN FIELD USED TO QUEUE
*                                          CRA TO PREALLOCATE QUEUE
*                                          WHEN NOT IN USE           */
*DCL CRALMS32 BIT(32) CONSTANT('80000000'X); /* 32ND LEVEL LOCK MASK */
*DCL CRALMS31 BIT(32) CONSTANT('40000000'X); /* 31ST LEVEL LOCK MASK */
*DCL CRALMS30 BIT(32) CONSTANT('20000000'X); /* 30TH LEVEL LOCK MASK */
*DCL CRALMS29 BIT(32) CONSTANT('10000000'X); /* 29TH LEVEL LOCK MASK */
*DCL CRALMS28 BIT(32) CONSTANT('08000000'X); /* 28TH LEVEL LOCK MASK */
*DCL CRALMS27 BIT(32) CONSTANT('04000000'X); /* 27TH LEVEL LOCK MASK */
*DCL CRALMS26 BIT(32) CONSTANT('02000000'X); /* 26TH LEVEL LOCK MASK */
*DCL CRALMS25 BIT(32) CONSTANT('01000000'X); /* 25TH LEVEL LOCK MASK */
*DCL CRALMS24 BIT(32) CONSTANT('00800000'X); /* 24TH LEVEL LOCK MASK */
*DCL CRALMS23 BIT(32) CONSTANT('00400000'X); /* 23RD LEVEL LOCK MASK */
*DCL CRALMS22 BIT(32) CONSTANT('00200000'X); /* 22ND LEVEL LOCK MASK */
*DCL CRALMS21 BIT(32) CONSTANT('00100000'X); /* 21ST LEVEL LOCK MASK */
*DCL CRALMS20 BIT(32) CONSTANT('00080000'X); /* 20TH LEVEL LOCK MASK */
*DCL CRALMS19 BIT(32) CONSTANT('00040000'X); /* 19TH LEVEL LOCK MASK */
*DCL CRALMS18 BIT(32) CONSTANT('00020000'X); /* 18TH LEVEL LOCK MASK */
*DCL CRALMS17 BIT(32) CONSTANT('00010000'X); /* 17TH LEVEL LOCK MASK */
*DCL CRALMS16 BIT(32) CONSTANT('00008000'X); /* 16TH LEVEL LOCK MASK */
*DCL CRALMS15 BIT(32) CONSTANT('00004000'X); /* 15TH LEVEL LOCK MASK */
*DCL CRALMS14 BIT(32) CONSTANT('00002000'X); /* 14TH LEVEL LOCK MASK */
*DCL CRALMS13 BIT(32) CONSTANT('00001000'X); /* 13TH LEVEL LOCK MASK */
*DCL CRALMS12 BIT(32) CONSTANT('00000800'X); /* 12TH LEVEL LOCK MASK */
*DCL CRALMS11 BIT(32) CONSTANT('00000400'X); /* 11TH LEVEL LOCK MASK */
*DCL CRALMS10 BIT(32) CONSTANT('00000200'X); /* 10TH LEVEL LOCK MASK */
*DCL CRALMS09 BIT(32) CONSTANT('00000100'X); /* 9TH LEVEL LOCK MASK  */
*DCL CRALMS08 BIT(32) CONSTANT('00000080'X); /* 8TH LEVEL LOCK MASK  */
*DCL CRALMS07 BIT(32) CONSTANT('00000040'X); /* 7TH LEVEL LOCK MASK  */
*DCL CRALMS06 BIT(32) CONSTANT('00000020'X); /* 6TH LEVEL LOCK MASK  */
*DCL CRALMS05 BIT(32) CONSTANT('00000010'X); /* 5TH LEVEL LOCK MASK  */
*DCL CRALMS04 BIT(32) CONSTANT('00000008'X); /* 4TH LEVEL LOCK MASK  */
*DCL CRALMS03 BIT(32) CONSTANT('00000004'X); /* 3RD LEVEL LOCK MASK  */
*DCL CRALMS02 BIT(32) CONSTANT('00000002'X); /* 2ND LEVEL LOCK MASK  */
*DCL CRALMS01 BIT(32) CONSTANT('00000001'X); /* 1ST LEVEL LOCK MASK  */
*DCL CRACRA   CHAR(4) CONSTANT('CRA ');      /* CHARACTER C.B. ID    */
* /*  CONNECTION SERVICES COMPONENT RECOVERY RECORD                  */
* /* COMPLETED DCR SOLUTIONS                                         */
* /* 1H0540 APRIL 28, 1973 MB                                        */
*/* ZTR4417 JUNE 20, 73 DNM */                                     2539
* DCL 1 ISTCNSTA BDY(WORD) BASED,       /* CONNECTION SERVICES     2539
*                                          COMPONENT RECOVERY RECORD */
*     2  CNSTPFX CHAR(LENGTH(ISTPFCRR)), /* STANDARD PREFIX        2539
*                                          FOR CRR                   */
*     2  CNSTFLDA CHAR(3),              /* TRACE FIELD A - HISTORY   */
*        3  CNSMRINA BIT(1),            /* MASTER ENTERED            */
*        3  CNSAUTHA BIT(1),            /* ABOUT TO CALL AUTHORI-  2539
*                                          SATION EXIT       ZTR4417 */
*        3  CNSAQINA BIT(1),            /* ACQUIRE ENTERED           */
*        3  CNSXREQA BIT(1),            /* ACQUIRE SATISFIED         */
*        3  CNSQREQA BIT(1),            /* ACQUIRE QUEUED            */
*        3  CNSRLINA BIT(1),            /* RELEASE ENTERED           */
*        3  CNSDORLA BIT(1),            /* DOREL REALLOCATION      2539
*                                          ENTERED                   */
*        3  CNSTRRLA BIT(1),            /* RELEASE OF ACTIVE       2539
*                                          CONNECTION                */
*        3  CNSRQRLA BIT(1),            /* RELEASE QUEUED REQUEST    */
*        3  CNSPSINA BIT(1),            /* PASS ENTERED              */
*        3  CNSACINA BIT(1),            /* ACCEPT ENTERED            */
*        3  CNSLGINA BIT(1),            /* LOGON ENTERED             */
*        3  CNSGBINA BIT(1),            /* PREEMPT ENTERED           */
*        3  CNSCLINA BIT(1),            /* CANCEL ENTERED            */
*        3  CNSCLAQA BIT(1),            /* CANCEL ACQUIRES           */
*        3  CNSTCONA BIT(1),            /* TCONNECT                  */
*        3  CNSACONA BIT(1),            /* ACONNECT                  */
*        3  CNSQUEUA BIT(1),            /* QUEUE                     */
*        3  CNSSEARA BIT(1),            /* SEARCH Q                  */
*        3  CNSGETSA BIT(1),            /* CONNECTION SERVICES     2539
*                                          GETSTORE                  */
*        3  CNSFREEA BIT(1),            /* CONNECTION SERVICES     2539
*                                          FREESTORE                 */
*        3  CNSACCTA BIT(1),            /* ABOUT TO CALL           2539
*                                          ACCOUNTING EXIT           */
*        3  CNSLOG0A BIT(1),            /* LOGON 0                   */
*        3  CNSRSV01 BIT(1),            /* RESERVED                  */
*     2  CNSTFLDB CHAR(3),              /* TRACE FIELD B -         2539
*                                          CURRENT ACTIVITY          */
*        3  CNSMRINB BIT(1),                                       2539
*        3  CNSAUTHB BIT(1),                                       2539
*        3  CNSAQINB BIT(1),                                       2539
*        3  CNSXREQB BIT(1),                                       2539
*        3  CNSQREQB BIT(1),                                       2539
*        3  CNSRLINB BIT(1),                                       2539
*        3  CNSDORLB BIT(1),                                       2539
*        3  CNSTRRLB BIT(1),                                       2539
*        3  CNSRQRLB BIT(1),                                       2539
*        3  CNSPSINB BIT(1),                                       2539
*        3  CNSACINB BIT(1),                                       2539
*        3  CNSLGINB BIT(1),                                       2539
*        3  CNSGBINB BIT(1),                                       2539
*        3  CNSCLINB BIT(1),                                       2539
*        3  CNSCLAQB BIT(1),                                       2539
*        3  CNSTCONB BIT(1),                                       2539
*        3  CNSACONB BIT(1),                                       2539
*        3  CNSQUEUB BIT(1),                                       2539
*        3  CNSSEARB BIT(1),                                       2539
*        3  CNSGETSB BIT(1),                                       2539
*        3  CNSFREEB BIT(1),                                       2539
*        3  CNSACCTB BIT(1),                                       2539
*        3  CNSLOG0B BIT(1),                                       2539
*        3  CNSRSV05 BIT(1);                                       2539
* /*     CRR FOR OPEN/CLOSE                                          */
*/*  REVISIONS                                         002 03/27/75  */
* DCL 1 ISTOCCRR BDY(WORD) BASED,       /* CRR FOR OPEN/CLOSE        */
*     2  OCCCNS   CHAR(LENGTH(ISTCNSTA)), /* RESERVE SPACE FOR     2540
*                                          CONN. SVC'S AUDIT         */
*     2  OCCAUDIT,                      /* AUDIT TRAIL FOR OPEN/CLOSE*/
*        3  OCCNTRD CHAR(3),            /* LIST OF MODULES IN OPEN/
*                                          CLOSE ENTERED             */
*           4  NOCCOC BIT(1),           /* INDICATES MODULE ISTOCCOC
*                                          ENTERED                   */
*           4  NOCCCL BIT(1),           /* INDICATES MODULE ISTOCCCL
*                                          ENTERED                   */
*           4  NOCCCH BIT(1),           /* INDICATES MODULE ISTOCCCH
*                                          ENTERED                   */
*           4  NOCCSL BIT(1),           /* INDICATES MODULE ISTOCCSL
*                                          ENTERED                   */
*           4  NOCCFO BIT(1),           /* INDICATES MODULE ISTOCCFO
*                                          ENTERED                   */
*           4  NOCCFR BIT(1),           /* INDICATES MODULE ISTOCCFR
*                                          ENTERED                   */
*           4  NOCCMD BIT(1),           /* INDICATES MODULE ISTOCCMD
*                                          ENTERED                   */
*           4  NOCCFD BIT(1),           /* INDICATES MODULE ISTOCCFD
*                                          ENTERED                   */
*           4  NOCCRD BIT(1),           /* INDICATES MODULE ISTOCCRD
*                                          ENTERED                   */
*           4  NOCCSD BIT(1),           /* INDICATES MODULE ISTOCCSD
*                                          ENTERED                   */
*           4  NOCCOD BIT(1),           /* INDICATES MODULE ISTOCCOD
*                                          ENTERED                   */
*           4  NOCCOE BIT(1),           /* INDICATES MODULE ISTOCCOE
*                                          ENTERED                   */
*           4  NOCCLD BIT(1),           /* INDICATES MODULE ISTOCCLD
*                                          ENTERED                   */
*           4  NOCCOF BIT(1),           /* INDICATES MODULE ISTOCCOF
*                                          ENTERED                   */
*           4  NOCCFB BIT(1),           /* INDICATES MODULE ISTOCCFB
*                                          ENTERED                   */
*           4  NOCCRT BIT(1),           /* INDICATES MODULE ISTOCCRT
*                                          ENTERED                   */
*           4  NOCCQU BIT(1),           /* INDICATES MODULE ISTOCCQU
*                                          ENTERED                   */
*           4  NOCCRL BIT(1),           /* INDICATES MODULE ISTOCCRL
*                                          ENTERED                   */
*           4  NOCCCC   BIT(1),         /* INDICATES MODULE ISTOCCCC
*                                          ENTERED                   */
*           4  NOCCNV BIT(1),           /* INDICATES MODULE ISTOCCNV
*                                          ENTERED                   */
*           4  NOCCCM BIT(1),           /* ISTOCCCM ENTERED          */
*           4  NOCCCN BIT(1),           /* ISTOCCCN ENTERED          */
*           4  NOCACX   BIT(1),                                    2540
*           4  NOCPOI BIT(1),           /* ISTCFCPO ENTERED OR       */
*                                       /* ISTCFCPC ENTERED          */
*        3  OCCCRT CHAR(3),             /* LIST OF OPEN/CLOSE      2540
*                                          MODULES RUNNING           */
*           4  COCCOC BIT(1),           /* INDICATES MODULE ISTOCCOC
*                                          RUNNING                   */
*           4  COCCCL BIT(1),           /* INDICATES MODULE ISTOCCCL
*                                          RUNNING                   */
*           4  COCCCH BIT(1),           /* INDICATES MODULE ISTOCCCH
*                                          RUNNING                   */
*           4  COCCSL BIT(1),           /* INDICATES MODULE ISTOCCSL
*                                          RUNNING                   */
*           4  COCCFO BIT(1),           /* INDICATES MODULE ISTOCCFO
*                                          RUNNING                   */
*           4  COCCFR BIT(1),           /* INDICATES MODULE ISTOCCFR
*                                          RUNNING                   */
*           4  COCCMD BIT(1),           /* INDICATES MODULE ISTOCCMD
*                                          RUNNING                   */
*           4  COCCFD BIT(1),           /* INDICATES  MODULE ISTOCCFD
*                                          RUNNING                   */
*           4  COCCRD BIT(1),           /* INDICATES MODULE ISTOCCRD
*                                          RUNNING                   */
*           4  COCCSD BIT(1),           /* INDICATES MODULE ISTOCCSD
*                                          RUNNING                   */
*           4  COCCOD BIT(1),           /* INDICATES MODULE ISTOCCOD
*                                          RUNNING                   */
*           4  COCCOE BIT(1),           /* INDICATES MODULE ISTOCCOE
*                                          RUNNING                   */
*           4  COCCLD BIT(1),           /* INDICATES MODULE ISTOCCLD
*                                          RUNNING                   */
*           4  COCCOF BIT(1),           /* INDICATES MODULE ISTOCCOF
*                                          RUNNING                   */
*           4  COCCFB BIT(1),           /* INDICATES MODULE ISTOCCFB
*                                          RUNNING                   */
*           4  COCCRT BIT(1),           /* INDICATES MODULE ISTOCCRT
*                                          RUNNING                   */
*           4  COCCQU BIT(1),           /* INDICATES MODULE ISTOCCQU
*                                          RUNNING                   */
*           4  COCCRL BIT(1),           /* INDICATES MODULE ISTOCCRL
*                                          RUNNING                   */
*           4  COCCCC   BIT(1),         /* INDICATES MOD ISTOCCCC  2540
*                                          RUNNING                   */
*           4  COCCNV BIT(1),           /* INDICATES MODULE ISTOCCNV
*                                          RUNNING                   */
*           4  COCCCM BIT(1),           /* ISTOCCCM RUNNING          */
*           4  COCCCN BIT(1),           /* ISTOCCCN RUNNING          */
*           4  COCACX   BIT(1),                                    2540
*           4  COCPOI BIT(1);           /* ISTCFCPO RUNNING OR       */
*                                       /* ISTCFCPC RUNNING          */
*DCL TIDOCCCC BIT(8) CONSTANT('00'X);   /* THREAD ID FOR           2541
*                                          ISTOCCCC                  */
*DCL TIDOCCCH BIT(8) CONSTANT('01'X);   /* THREAD ID FOR           2542
*                                          ISTOCCCH                  */
*DCL TIDOCCOD BIT(8) CONSTANT('02'X);   /* THREAD ID FOR           2543
*                                          ISTOCCOD                  */
*DCL TIDOCCCL BIT(8) CONSTANT('04'X);   /* THREAD ID FOR           2544
*                                          ISTOCCCL                  */
*DCL TIDOCCOC BIT(8) CONSTANT('08'X);   /* THREAD ID FOR           2545
*                                          ISTOCCOC                  */
*DCL TIDOCCRT BIT(8) CONSTANT('10'X);   /* THREAD ID FOR           2546
*                                          ISTOCCRT                  */
*DCL TIDOCCQU BIT(8) CONSTANT('20'X);   /* THREAD ID FOR           2547
*                                          ISTOCCQU                  */
*DCL TIDOCACX BIT(8) CONSTANT('30'X);   /* THREAD ID FOR           2548
*                                          ISTOCACX                  */
*/* ***** PROCESS SCHEDULING TABLE FOR VS/2       ****** */        2549
*/*  INITIAL LEVEL                                      001 04/09/75 */
*DCL  1  ISTPST BDY(DWORD) BASED,                                  2549
*        2  PSTTYPE  CHAR(1),          /* CONTROL BLOCK TYPE         */
*        2  PSTLNGTH PTR(8),           /* LENGTH IN BYTES            */
*        2  *        CHAR(2),          /* RESERVED                   */
*        2  PSTCHAIN PTR(31),          /* ADDRESS OF NEXT PST        */
*        2  PSTRQFGA CHAR(8) BDY(DWORD),  /* READY QUEUE AND FLAGS   */
*           3  PSTRQUE PTR(31),        /* READY QUEUE                */
*              4  PSTRQFLG BIT(1),     /* READY QUEUE GATE           */
*              4  PSTRSV01 BIT(1),     /* REVERVED                   */
*              4  PSTRSV02 BIT(1),     /* REVERVED                   */
*              4  PSTRSV03 BIT(1),     /* REVERVED                   */
*              4  PSTRSV04 BIT(1),     /* REVERVED                   */
*              4  PSTRSV05 BIT(1),     /* REVERVED                   */
*              4  PSTRSV06 BIT(1),     /* REVERVED                   */
*              4  PSTRSV07 BIT(1),     /* REVERVED                   */
*              4  PSTRQUEA PTR(24),    /* READY QUEUE                */
*           3  PSTFLGA PTR(32),        /* FLAG FIELD                 */
*              4  PSTSSRN BIT(1),      /* IRB RUNNING SYSTEM SERVICE
*                                         TYPE REQUESTS              */
*              4  PSTUERN BIT(1),      /* IRB RUNNING USER EXIT TYPE
*                                         REQUESTS                   */
*              4  PSTIRBU1 BIT(1),     /* IRB # 1 IN USE             */
*              4  PSTIRBU2 BIT(1),     /* IRB # 2 IN USE             */
*              4  PSTSMQR BIT(1),      /* SMS RPH QUEUED FOR STORAGE */
*              4  PSTSMCU BIT(1),      /* SMS CRA IN USE             */
*              4  PSTAUTH BIT(1),      /* THE TASK THIS PST IS OBTAINED
*                                         FOR IS AUTHORIZED          */
*              4  PSTABINP BIT(1),     /* ABEND IN PROGRESS ON THIS
*                                         TASK                       */
*                 5 PSTABEND BIT(1),   /* TASK ABEND IN PROGRESS     */
*              4  PSTDMPC BIT(1),      /* DUMP HAS BEEN REQUESTED    */
*              4  PSTRSV08 BIT(23),    /* RESERVED                   */
*        2  PSTTCBA PTR(31),           /* TCB POINTER                */
*        2  PSTMPSTP PTR(31),          /* MPST POINTER - PST 6TH WORD*/
*        2  PSTACBCT FIXED(31),        /* COUNT OF OPEN ACB'S USING
*                                         THIS PST                   */
*        2  PSTPSSQ PTR(31),           /* POSTED SYSTEM SERVICE QUEUE*/
*        2  PSTNSSQ PTR(31),           /* NORMAL SYSTEM SERVICE QUEUE*/
*        2  PSTUEQ  PTR(31),           /* USER EXIT QUEUE            */
*        2  PSTIQE11 PTR(31),          /* INACTIVE IQE FOR FIRST IRB */
*        2  PSTIQE12 PTR(31),          /* ACTIVE IQE FOR FIRST IRB   */
*        2  PSTIQE21 PTR(31),          /* INACTIVE IQE FOR 2ND IRB   */
*        2  PSTIQE22 PTR(31),          /* ACTIVE IQE FOR 2ND IRB     */
*        2  PSTCRR1 PTR(31),           /* PREALLOCATED CRA           */
*        2  PSTCRRS PTR(31),           /* SMS CRA                    */
*        2  PSTSMDYP CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* SMS PAB   */
*        2  PSTSAVE CHAR(32),          /* SAVE AREA                  */
*        2  PSTDEBP  PTR(31),          /* POINTER TO DEB CHAIN       */
*                                      /* WHEN TASK ABENDS           */
*        2  PSTDMPS  FIXED(31),        /* DUMMY MPST                 */
*           3 PSTDGATE BIT(1),         /* DUMMY MPST GATE BIT        */
*           3 *        BIT(7),         /* NOT TO BE USED             */
*           3 PSTDRDYQ PTR(24);        /* DUMMY MPST READY QUEUE     */
*DCL  PSTSSRN0 BIT(32) CONSTANT('7FFFFFFF'X); /* TURN PSTSSRN OFF    */
*DCL  PSTSSRN1 BIT(32) CONSTANT('80000000'X); /* TURN PSTSSRN ON     */
*DCL  PSTUERN0 BIT(32) CONSTANT('BFFFFFFF'X); /* TURN PSTUERN OFF    */
*DCL  PSTUERN1 BIT(32) CONSTANT('40000000'X); /* TURN PSTUERN ON     */
*DCL  PSTGATE0 BIT(32) CONSTANT('7FFFFFFF'X); /* TURN PST READY QUEUE
*                                                GATE OFF            */
*DCL  PSTGATE1 BIT(32) CONSTANT('80000000'X); /* TURN PST READY QUEUE
*                                                GATE ON             */
*DCL  PSTIRB10 BIT(32) CONSTANT('DFFFFFFF'X); /* TURN PSTIRBU1 OFF   */
*DCL  PSTIRB11 BIT(32) CONSTANT('20000000'X); /* TURN PSTIRBU1 ON    */
*DCL  PSTIRB20 BIT(32) CONSTANT('EFFFFFFF'X); /* TURN PSTIRBU2 OFF   */
*DCL  PSTIRB21 BIT(32) CONSTANT('10000000'X); /* TURN PSTIRBU2 ON    */
*DCL  PSTSMQR0 BIT(32) CONSTANT('F7FFFFFF'X); /* TURN PSTSMQR OFF    */
*DCL  PSTSMQR1 BIT(32) CONSTANT('08000000'X); /* TURN PSTSMQR ON     */
*DCL  PSTSMCU0 BIT(32) CONSTANT('FBFFFFFF'X); /* TURN PSTSMCU OFF    */
*DCL  PSTSMCU1 BIT(32) CONSTANT('04000000'X); /* TURN PSTSMCU ON     */
*DCL  PSTABIP1 BIT(32) CONSTANT('01000000'X); /* TURN PSTABINP ON    */
*DCL  PSTABIP0 BIT(32) CONSTANT('FEFFFFFF'X); /* TURN OFF PSTABINP   */
*DCL  PSTYPE   BIT(8) CONSTANT('61'X);        /* TYPE CODE FOR PST   */
*   DECLARE                                                        2567
*     EMCR0 PTR REG(0),                                            2567
*     EMCR1 PTR REG(1),                                            2567
*     EMCR2 PTR REG(2),                                            2567
*     EMCR3 PTR REG(3),                                            2567
*     EMCR4 PTR REG(4),                                            2567
*     EMCR5 PTR REG(5),                                            2567
*     EMCR6 PTR REG(6),                                            2567
*     EMCR7 PTR REG(7),                                            2567
*     EMCR8 PTR REG(8),                                            2567
*     EMCR9 PTR REG(9),                                            2567
*     EMCR10 PTR REG(10),                                          2567
*     EMCR11 PTR REG(11),                                          2567
*     EMCR12 PTR REG(12),                                          2567
*     EMCR13 PTR REG(13),                                          2567
*     EMCR14 PTR REG(14),                                          2567
*     EMCR15 PTR REG(15);                                          2567
*   DECLARE                                                        2568
*     ISTSDCCA ENTRY BASED(ATCCDADD) VALRG(*),/* CIDCTL ADD ROUTINE  */
*     ISTSDCCD ENTRY BASED(ATCCDDEL) VALRG(*),/* CIDCTL DELETE     2568
*                                      ROUTINE                       */
*     ISTSDCCF ENTRY BASED(ATCCDFND) VALRG(*),/* CIDCTL FIND ROUTINE */
*     ISTSDCCN ENTRY BASED(ATCCDFDN) VALRG(*),/* CIDCTL FIND NCB   2568
*                                      ROUTINE                       */
*     ISTSDCCR ENTRY BASED(ATCCDFIN) VALRG(*);/* CIDCTL FINISH     2568
*                                      ROUTINE                       */
*   DCL                                                            2569
*     CMZCIDM FIXED(15) DEFINED(ATCCIDM);/* CIDMASK ALIAS            */
*   DCL                                                            2570
*     ISTAPC34 ENTRY BASED(ATCAP34) VALRG(*);/* RESET ROUTINE        */
*   DCL                                                            2571
*     ISTAPC37 ENTRY BASED(ATCAP37) VALRG(*);/* TPQUE ROUTINE        */
*   GEN(PRINT ON);                                                 2572
*                                                                  2572
         PRINT ON
*/* END OF TPEPILOG                                                  */
*/* ATDSPLY   INVOKED.                                               */
*/********************************************************************/
*/* THE FOLLOWING ATBUILD INCLUSIONS HAVE BEEN MADE IN THIS          */
*/* COMPILATION:                                                     */
*/*             ISTCSL                                               */
*/*             ISTRH                                                */
*/*             ISTSRU                                               */
*/*             ISTFNDSP                                             */
*/*             ISTBIND                                              */
*/*             ISTBFHDR                                             */
*/*             ISTLGPFX                                             */
*/*             ISTCSP                                               */
*/*             ISTPROCD                                             */
*/*             ISTDEVCH                                             */
*/*             ISTNIB                                               */
*/*             ISTOCW                                               */
*/*             ISTLCCW                                              */
*/*             ISTLCPB                                              */
*/*             ISTPAB                                               */
*/*             ISTLOK                                               */
*/*             ISTDYPAB                                             */
*/*             ISTRPH                                               */
*/*             ISTATCVT                                             */
*/*             ISTNIR                                               */
*/*             ISTRUSEN                                             */
*/*             ISTPOHD                                              */
*/*             ISTPFX                                               */
*/*             ISTNCSPL                                             */
*/*             ISTNCB                                               */
*/*             ISTFDB                                               */
*/*             ISTFSB                                               */
*/*             ISTNMLPB                                             */
*/*             ISTRDT                                               */
*/*             ISTFMCB                                              */
*/*             ISTICE                                               */
*/*             ISTACE                                               */
*/*             ISTZSAVE                                             */
*/*             ISTPFCRR                                             */
*/*             ISTCFCRR                                             */
*/*             ISTZCRR                                              */
*/*             ISTASCRR                                             */
*/*             ISTAPCRR                                             */
*/*             ISTCRA                                               */
*/*             ISTCNSTA                                             */
*/*             ISTOCCRR                                             */
*/*             ISTPST                                               */
*/********************************************************************/
*/* END OF ATDSPLY.                                                  */
*                                                                  2573
*   END ISTOCCOE                                                   2573
*                                                                  2573
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IHAPSA  )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IFGRPL  )                                       */
*/*%INCLUDE SYSLIB  (IFGRPLVT)                                       */
*/*%INCLUDE SYSLIB  (ISTRPLFB)                                       */
*/*%INCLUDE SYSUT5  (DOBNSET )                                       */
*/*%INCLUDE SYSUT5  (DOFNCOB )                                       */
*/*%INCLUDE SYSUT5  (DOPHYCON)                                       */
*/*%INCLUDE SYSUT5  (DOIOLP  )                                       */
*/*%INCLUDE SYSUT5  (DOBINFL )                                       */
*/*%INCLUDE SYSUT5  (VALBNDRU)                                       */
*/*%INCLUDE SYSUT5  (SETL    )                                       */
*/*%INCLUDE SYSUT5  (VALCKBRU)                                       */
*/*%INCLUDE SYSUT5  (VALCKUDT)                                       */
*/*%INCLUDE SYSUT5  (GETBNDST)                                       */
*/*%INCLUDE SYSUT5  (RESETL  )                                       */
*/*%INCLUDE SYSUT5  (CALLSESS)                                       */
*                                                                  2573
*       ;                                                          2573
@EL00001 DS    0H                                                  2573
@EF00001 DS    0H                                                  2573
@ER00001 BR    @14                                                 2573
@DATA    DS    0H
@CH00109 DC    H'2'
@CH00073 DC    H'3'
@CH00045 DC    H'4'
@CH00037 DC    H'8'
@CH00033 DC    H'12'
@CH00126 DC    H'32'
@CH06177 DC    H'37'
@CH00215 DC    H'64'
@CH01484 DC    XL2'08'
@SM06199 MVC   OCWBINDA(0,OCWPTR),ISTBIND(@15)
@SM06201 MVC   ISTBIND(0,@15),ISTBIND(@05)
@SM06203 MVC   OCWBINDA(0,OCWPTR),ISTBIND(@10)
@SM06205 MVC   SHFUDT(0,@09),BINUSE(@15)
@DATD    DSECT
         DS    0F
ISTOCCOE CSECT
         DS    0F
@CF00068 DC    F'1'
@CH00068 EQU   @CF00068+2
@CF03126 DC    F'2032'
@CF01455 DC    XL4'08000000'
@CF01465 DC    XL4'80000000'
@CF05091 DC    XL4'00FFFFFF'
@DATD    DSECT
         DS    0D
CVTPTR   DS    A
LCPBPTR  DS    A
FSBPTR   DS    A
FMCBPTR  DS    A
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
ISTOCCOE CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV05116 DC    V(ISTOCCFO)
@CV05118 DC    V(ISTOCCFB)
@CV05120 DC    V(ISTOCCRL)
@CV05155 DC    V(ISTOCCOF)
@CV05197 DC    V(ISTOCCNV)
         DS    0D
CHIBIT   DC    XL4'80000000'
CHIBTOFF DC    XL4'7FFFFFFF'
FMZA0013 DS    FL4
         ORG   FMZA0013
@NM00109 DC    AL1(184)
@NM00110 DC    AL3(0)
         ORG   FMZA0013+4
CMZA0047 DS    FL4
         ORG   CMZA0047
@NM00111 DC    AL1(96)
@NM00112 DC    AL1(96)
@NM00113 DC    AL1(241)
@NM00114 DC    XL1'00'
         ORG   CMZA0047+4
FMZA0071 DS    FL4
         ORG   FMZA0071
@NM00115 DC    AL1(64)
@NM00116 DC    AL3(0)
         ORG   FMZA0071+4
FMZA0162 DS    FL4
         ORG   FMZA0162
@NM00117 DC    AL1(152)
@NM00118 DC    AL3(0)
         ORG   FMZA0162+4
FMZA0181 DS    FL4
         ORG   FMZA0181
@NM00119 DC    AL1(64)
@NM00120 DC    AL3(0)
         ORG   FMZA0181+4
FMZA0252 DS    FL4
         ORG   FMZA0252
@NM00121 DC    AL1(64)
@NM00122 DC    AL3(0)
         ORG   FMZA0252+4
CMZA0276 DS    FL4
         ORG   CMZA0276
@NM00123 DC    AL1(96)
@NM00124 DC    AL1(96)
@NM00125 DC    AL1(231)
@NM00126 DC    XL1'01'
         ORG   CMZA0276+4
CMZA0316 DS    FL4
         ORG   CMZA0316
@NM00127 DC    AL1(96)
@NM00128 DC    AL1(96)
@NM00129 DC    AL1(231)
@NM00130 DC    XL1'00'
         ORG   CMZA0316+4
FMZA0341 DS    FL4
         ORG   FMZA0341
@NM00131 DC    AL1(184)
@NM00132 DC    AL3(0)
         ORG   FMZA0341+4
CMZA0375 DS    FL4
         ORG   CMZA0375
@NM00133 DC    AL1(96)
@NM00134 DC    AL1(96)
@NM00135 DC    AL1(241)
@NM00136 DC    XL1'00'
         ORG   CMZA0375+4
FMZA0399 DS    FL4
         ORG   FMZA0399
@NM00137 DC    AL1(64)
@NM00138 DC    AL3(0)
         ORG   FMZA0399+4
FMZA0417 DS    FL4
         ORG   FMZA0417
@NM00139 DC    AL1(64)
@NM00140 DC    AL3(0)
         ORG   FMZA0417+4
CMZA0433 DS    FL4
         ORG   CMZA0433
@NM00141 DC    AL1(96)
@NM00142 DC    AL1(96)
@NM00143 DC    AL1(231)
@NM00144 DC    XL1'01'
         ORG   CMZA0433+4
@CC04920 DC    C'RECORD  '
@CC05204 DC    C'ISTYTCM3'
@CC05285 DC    C'        '
@CB05286 DC    X'0000000000000000'
@CB03138 DC    X'0001'
@CB03140 DC    X'0002'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
RPHPTR   EQU   @01
GPR00F   EQU   @00
GPR00P   EQU   @00
GPR01F   EQU   @01
GPR01P   EQU   @01
GPR02F   EQU   @02
GPR02P   EQU   @02
GPR03F   EQU   @03
GPR03P   EQU   @03
GPR04F   EQU   @04
GPR04P   EQU   @04
GPR05P   EQU   @05
GPR06F   EQU   @06
GPR06P   EQU   @06
GPR07P   EQU   @07
GPR08P   EQU   @08
GPR09P   EQU   @09
GPR10F   EQU   @10
GPR10P   EQU   @10
GPR11F   EQU   @11
GPR11P   EQU   @11
GPR12F   EQU   @12
GPR12P   EQU   @12
GPR13F   EQU   @13
GPR13P   EQU   @13
GPR14F   EQU   @14
GPR14P   EQU   @14
GPR15F   EQU   @15
GPR15P   EQU   @15
OCWPTR   EQU   @04
NTRYPTR  EQU   @05
SORTPTR  EQU   @06
CPARMRG0 EQU   @00
CPARMR08 EQU   @08
CRELREG  EQU   @08
CPARMRG2 EQU   @02
CSAVEPTR EQU   @13
CRETCODE EQU   @15
CR14PTR  EQU   @14
CMZK0011 EQU   @01
CMZK0087 EQU   @01
CMZK0088 EQU   @01
CMZK0089 EQU   @01
EMCR2    EQU   @02
EMCR3    EQU   @03
CMZK0161 EQU   @01
CMZK0214 EQU   @01
CBASEREG EQU   @12
EMCR0    EQU   @00
EMCR1    EQU   @01
EMCR10   EQU   @10
EMCR11   EQU   @11
EMCR12   EQU   @12
EMCR13   EQU   @13
EMCR14   EQU   @14
EMCR15   EQU   @15
EMCR4    EQU   @04
EMCR5    EQU   @05
EMCR6    EQU   @06
EMCR7    EQU   @07
EMCR8    EQU   @08
EMCR9    EQU   @09
GPR05F   EQU   @05
GPR07F   EQU   @07
GPR08F   EQU   @08
GPR09F   EQU   @09
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSALITA  EQU   PSA+764
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
ATCLCPTR EQU   1032
CZMP0300 EQU   16
CZMP0309 EQU   16
CVTMAP   EQU   0
CVT0VL00 EQU   CVTMAP+24
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTSHS   EQU   CVTXTNT2+40
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
IFGRPL   EQU   0
RPLCOMN  EQU   IFGRPL
RPLIDWD  EQU   RPLCOMN
RPLLEN   EQU   RPLIDWD+3
RPLECB   EQU   RPLCOMN+8
RPLFDBWD EQU   RPLCOMN+12
RPLFDBK  EQU   RPLFDBWD+1
RPLRTNCD EQU   RPLFDBK
RPLCNDCD EQU   RPLFDBK+1
RPLCMPON EQU   RPLCNDCD
RPLFDB2  EQU   RPLCMPON
RPLERRCD EQU   RPLCNDCD+1
RPLFDB3  EQU   RPLERRCD
RPLKEYLE EQU   RPLCOMN+16
RPLARG   EQU   RPLCOMN+36
RPLOPTCD EQU   RPLCOMN+40
RPLOPT1  EQU   RPLOPTCD
RPLECBSW EQU   RPLOPT1
RPLOPT2  EQU   RPLOPTCD+1
RPLADR   EQU   RPLOPT2
RPLOPT3  EQU   RPLOPTCD+2
RPLOPT4  EQU   RPLOPTCD+3
RPLNXTRP EQU   RPLCOMN+44
RPLOPTC2 EQU   RPLCOMN+56
RPLOPT5  EQU   RPLOPTC2
RPLWRTYP EQU   RPLOPT5
RPLOPT6  EQU   RPLOPTC2+1
RPLUNTYP EQU   RPLOPT6
RPLOPT7  EQU   RPLOPTC2+2
RPLCNOPT EQU   RPLOPT7
RPLOPT8  EQU   RPLOPTC2+3
RPLODACQ EQU   RPLOPT8
RPLRBAR  EQU   RPLCOMN+60
RPLAIXID EQU   RPLRBAR+2
RPLEXTDS EQU   RPLCOMN+68
RPLEXTD1 EQU   RPLEXTDS
RPLNIB   EQU   RPLEXTD1
RPLVTEXT EQU   IFGRPL+76
RPLFDBK2 EQU   RPLVTEXT+12
RPLSSNSI EQU   RPLFDBK2
RPLDSB   EQU   RPLSSNSI
RPLDSB1  EQU   RPLDSB
RPLSSEI  EQU   RPLDSB1
RPLDSB2  EQU   RPLDSB+1
RPLUSNSI EQU   RPLFDBK2+2
RPLOPTC3 EQU   RPLVTEXT+20
RPLOPT9  EQU   RPLOPTC3
RPLOPT10 EQU   RPLOPTC3+1
RPLOPT11 EQU   RPLOPTC3+2
RPLOPT12 EQU   RPLOPTC3+3
RPLOSENS EQU   RPLVTEXT+24
RPLSSNSO EQU   RPLOSENS
RPLSSEO  EQU   RPLSSNSO
RPLOF16  EQU   0
RPLRH3   EQU   RPLOF16
RPLSRTYP EQU   RPLOF16+1
RPLSTYPE EQU   RPLSRTYP
RPLRTYPE EQU   RPLSRTYP
RPLCHN   EQU   RPLOF16+2
RPLVTFL1 EQU   RPLOF16+3
RPLVTUSE EQU   RPLVTFL1
RPLVTFL2 EQU   RPLOF16+4
RPLPOSTV EQU   RPLVTFL2
RPLRESP  EQU   RPLVTFL2
RPLCNTRL EQU   RPLOF16+5
RPLCNTDF EQU   RPLCNTRL
RPLCNTDC EQU   RPLCNTRL+1
RPLCNTSC EQU   RPLCNTRL+2
RPLOF60  EQU   0
RPLOBSQ  EQU   RPLOF60+4
RPLIBSQ  EQU   RPLOF60+5
ISTCSL   EQU   0
CSLRDEF  EQU   ISTCSL
CSLRDTE  EQU   CSLRDEF
CSLRDTEF EQU   CSLRDTE
CSLNDEF  EQU   ISTCSL+4
CSLNIB   EQU   CSLNDEF
CSLNIBF  EQU   CSLNIB
CSLDDEF  EQU   ISTCSL+8
CSLDATA  EQU   CSLDDEF
ISTRH    EQU   0
RHFLAGS  EQU   ISTRH
RH1      EQU   RHFLAGS
RHTYPE   EQU   RH1
RHSCI    EQU   RH1
RHFORMAT EQU   RH1
RHCHAIN  EQU   RH1
RH2      EQU   RHFLAGS+1
RHFME    EQU   RH2
RHEXCEPT EQU   RH2
RHRETRY  EQU   RH2
RHRSVD1  EQU   RH2
RH3      EQU   RHFLAGS+2
ISTSRU   EQU   0
SRUQSREQ EQU   ISTSRU
SRUTYPE  EQU   ISTSRU+1
SRULDID  EQU   ISTSRU+2
SRUSPSN  EQU   SRULDID
ISTFNDSP EQU   0
FNDLU    EQU   ISTFNDSP
FNDAREA  EQU   ISTFNDSP+4
FNDMODE  EQU   ISTFNDSP+8
ISTBIND  EQU   0
BINFMTY  EQU   ISTBIND
BINFMT   EQU   BINFMTY
BINTYPE  EQU   BINFMTY
BINPRIP  EQU   ISTBIND+3
BINSECP  EQU   ISTBIND+4
BINCMNP  EQU   ISTBIND+5
BINCMNP2 EQU   ISTBIND+6
BINTSU   EQU   ISTBIND+7
BINRPACE EQU   BINTSU+1
BINRUSZ  EQU   BINTSU+2
BINSRUSZ EQU   BINRUSZ
BINPRUSZ EQU   BINRUSZ+1
BINPRSVC EQU   ISTBIND+13
BINLUP   EQU   BINPRSVC
BINPSCHR EQU   BINPRSVC+1
BINPRIML EQU   ISTBIND+26
BINPRIM  EQU   ISTBIND+27
BINUSEL  EQU   ISTBIND+35
BINUSE   EQU   ISTBIND+36
ISTBFHDR EQU   0
ISTLGPFX EQU   0
LGPSESSP EQU   ISTLGPFX+12
ISTCSP   EQU   0
CSPOPT   EQU   ISTCSP+2
CSPOPT1  EQU   CSPOPT
CSPOPT2  EQU   CSPOPT+1
CSPRSC2F EQU   CSPOPT2
CSPRSC2B EQU   ISTCSP+32
ISTPROCD EQU   0
PROPROC  EQU   ISTPROCD
PROPROC1 EQU   PROPROC
PROPROC2 EQU   PROPROC+1
PROPROC3 EQU   PROPROC+2
PROPROC4 EQU   PROPROC+3
PROPROCS EQU   0
PROSETMS EQU   PROPROCS+1
PROSETM2 EQU   PROSETMS
PROSETM3 EQU   PROSETMS+1
PROSETM4 EQU   PROSETMS+2
ISTDEVCH EQU   0
DEVSHCH  EQU   ISTDEVCH
DEVCHAR  EQU   DEVSHCH
DEVTCODE EQU   ISTDEVCH+1
DEVFLAGS EQU   ISTDEVCH+3
DEVFCCTL EQU   DEVFLAGS
DEVCHAR3 EQU   DEVFLAGS
ISTNIB   EQU   0
NIBCID   EQU   ISTNIB+4
NIBSYM   EQU   ISTNIB+12
NIBDEVCH EQU   ISTNIB+28
NIBFLGS  EQU   ISTNIB+40
NIBFLG1  EQU   NIBFLGS
NIBCON   EQU   NIBFLG1
NIBSDAPP EQU   NIBFLG1
NIBSHLTP EQU   NIBFLG1
NIBLMODE EQU   ISTNIB+48
NIBNDAR  EQU   ISTNIB+56
ISTOCW   EQU   0
OCWRPL   EQU   ISTOCW+12
OCWRPH   EQU   ISTOCW+16
OCWACVT  EQU   ISTOCW+24
OCWLRDTE EQU   ISTOCW+40
OCWDRDTE EQU   OCWLRDTE
OCWNIB   EQU   ISTOCW+44
OCWARDTE EQU   ISTOCW+48
OCWFMCB  EQU   ISTOCW+56
OCWNCB   EQU   ISTOCW+60
OCWODLST EQU   ISTOCW+80
OCWODNAS EQU   ISTOCW+84
OCWODRC  EQU   ISTOCW+92
OCWRC    EQU   OCWODRC
OCWEC    EQU   OCWODRC+1
OCWSVCOD EQU   ISTOCW+94
OCWSVRC  EQU   OCWSVCOD
OCWSVEC  EQU   OCWSVCOD+1
OCWODCT1 EQU   ISTOCW+104
OCWDSTNO EQU   ISTOCW+108
OCWDNIB  EQU   ISTOCW+112
OCWSCPAD EQU   ISTOCW+176
OCWSWTA  EQU   ISTOCW+204
OCWNOCON EQU   OCWSWTA
OCWSWTB  EQU   ISTOCW+205
OCWSWTC  EQU   ISTOCW+206
OCWSWTD  EQU   ISTOCW+207
OCWSTCTL EQU   OCWSWTD
OCWCSPL  EQU   ISTOCW+224
OCWR14SV EQU   ISTOCW+624
OCWLCPBA EQU   ISTOCW+696
OCWSORTP EQU   ISTOCW+712
OCWOENIB EQU   ISTOCW+716
OCWSWTRD EQU   ISTOCW+730
OCWSWTE  EQU   ISTOCW+731
OCWACE   EQU   ISTOCW+736
OCWLOCKS EQU   ISTOCW+740
OCWVLOCK EQU   OCWLOCKS
OCWRLOCK EQU   OCWLOCKS
OCWELOCK EQU   OCWLOCKS
OCWCLOCK EQU   OCWLOCKS
OCWMLOCK EQU   OCWLOCKS
OCWCID   EQU   ISTOCW+744
OCWSAF   EQU   OCWCID
OCWDAF   EQU   OCWCID+2
OCWIOCNT EQU   ISTOCW+760
OCWBNDRU EQU   ISTOCW+780
OCWSHPL  EQU   ISTOCW+784
OCWBIND  EQU   ISTOCW+796
OCWBINDA EQU   OCWBIND+1
OCWBNDSZ EQU   ISTOCW+841
OCWSENSE EQU   ISTOCW+843
OCWFLG1  EQU   ISTOCW+847
OCWEXIT  EQU   OCWFLG1
ISTLCCW  EQU   0
LCCWOP   EQU   ISTLCCW
LCCWRWOP EQU   LCCWOP
LCCWCTL  EQU   LCCWRWOP
LCCWFLAG EQU   ISTLCCW+1
LCCWCD   EQU   LCCWFLAG
LCCWNTVC EQU   LCCWFLAG
LCCWIDAT EQU   LCCWFLAG
LCCWLSI  EQU   LCCWFLAG
LCCWCNT  EQU   ISTLCCW+2
LCCWDATA EQU   ISTLCCW+4
ISTLCPB  EQU   0
LCPTYPE  EQU   ISTLCPB
LCPLNGTH EQU   ISTLCPB+1
LCPREQTG EQU   ISTLCPB+2
LCPFLAGS EQU   LCPREQTG
LCPZF001 EQU   LCPFLAGS
LCPZRT02 EQU   LCPZF001
LCPZF002 EQU   LCPFLAGS
LCPZRT03 EQU   LCPZF002
LCPZF003 EQU   LCPFLAGS
LCPZRT04 EQU   LCPZF003
LCPZF004 EQU   LCPFLAGS
LCPZRT05 EQU   LCPZF004
LCPZRT06 EQU   LCPFLAGS
LCPZRT07 EQU   LCPFLAGS
LCPMNRCD EQU   LCPREQTG+1
LCPZRT08 EQU   LCPMNRCD
LCPZRT09 EQU   LCPMNRCD
LCPCHAIN EQU   ISTLCPB+4
LCPCHAI1 EQU   LCPCHAIN
LCPRUCNT EQU   ISTLCPB+8
LCPFLAG2 EQU   ISTLCPB+9
LCPASYN  EQU   LCPFLAG2
LCPTLBPI EQU   LCPFLAG2
LCPFID0  EQU   LCPFLAG2
LCPSEQ   EQU   ISTLCPB+10
LCPCID   EQU   ISTLCPB+16
LCPNXLCW EQU   ISTLCPB+20
LCPFDBA  EQU   ISTLCPB+24
LCPFLG1  EQU   ISTLCPB+37
LCPFLCCW EQU   ISTLCPB+40
LCPLCCW  EQU   ISTLCPB+48
LCPPABA  EQU   LCPLCCW+4
LCPRPHA  EQU   LCPPABA
LCPFTYPE EQU   LCPRPHA
ISTPAB   EQU   0
PABWQCHN EQU   ISTPAB
PABWEQA  EQU   PABWQCHN
PABCHAIN EQU   PABWQCHN+4
PABRPHFG EQU   ISTPAB+12
PABFLAGS EQU   PABRPHFG
PABERLCK EQU   PABFLAGS
PABERRLK EQU   PABERLCK
ISTLOK   EQU   0
LOKCHN   EQU   ISTLOK+1
LOKCHNG  EQU   LOKCHN
@NM00064 EQU   LOKCHNG+2
ISTDYPAB EQU   0
DYPPAB   EQU   ISTDYPAB+16
ISTRPH   EQU   0
RPHCNTL  EQU   ISTRPH
RPHFLAGS EQU   RPHCNTL+2
RPHAPTYP EQU   RPHFLAGS
RPHFSTLC EQU   RPHFLAGS
RPHFLGB  EQU   RPHCNTL+3
RPHRPHA  EQU   ISTRPH+4
RPHTSKID EQU   ISTRPH+8
RPHRESMA EQU   ISTRPH+16
RPHWPFLG EQU   RPHRESMA
RPHWEA   EQU   ISTRPH+24
RPHCSPA  EQU   RPHWEA
RPHSRPRM EQU   ISTRPH+28
RPHCRR   EQU   ISTRPH+32
RPHPABQA EQU   ISTRPH+36
RPHWORK  EQU   ISTRPH+40
RPHSAVE1 EQU   RPHWORK
RPHSBITS EQU   RPHSAVE1+1
ISTATCVT EQU   0
ATCCOM   EQU   ISTATCVT
ATCSTAT  EQU   ATCCOM
ATCSTAT1 EQU   ATCSTAT
ATCSTFLG EQU   ATCSTAT+1
ATCPOFLG EQU   ATCSTAT+2
ATCSTAT4 EQU   ATCSTAT+3
ATCBPDA  EQU   ATCCOM+128
ATCIOTRC EQU   ATCCOM+140
ATCTHTRC EQU   ATCIOTRC
ATCGTSTR EQU   ATCCOM+164
ATCSMRQ  EQU   ATCCOM+180
ATCSMRS  EQU   ATCCOM+188
ATCSRTDF EQU   ATCCOM+208
ATCVTMID EQU   ATCCOM+240
ATCCIDM  EQU   ATCCOM+266
ATCCDADD EQU   ISTATCVT+276
ATCCDDEL EQU   ISTATCVT+280
ATCCDFND EQU   ISTATCVT+284
ATCCSMR  EQU   ISTATCVT+296
ATCSHRFG EQU   ISTATCVT+316
ATCHPGM  EQU   ISTATCVT+384
ATCAP33  EQU   ISTATCVT+444
ATCAP35  EQU   ISTATCVT+448
ATCAP36  EQU   ISTATCVT+452
ATCCDFIN EQU   ISTATCVT+460
ATCCDFDN EQU   ISTATCVT+464
ATCVOCLK EQU   ISTATCVT+468
ATCRDTLK EQU   ISTATCVT+472
ATCVLCNT EQU   ISTATCVT+772
ATCRNO   EQU   ISTATCVT+788
ATCSOPD  EQU   ISTATCVT+792
ATCSIPD  EQU   ISTATCVT+800
ATCSECST EQU   ISTATCVT+812
ATCSTAT2 EQU   ISTATCVT+818
ATCSRTAB EQU   ISTATCVT+820
ATCVTBAM EQU   ISTATCVT+908
@NM00075 EQU   ATCVTBAM+3
ATCAOSM  EQU   ISTATCVT+912
ATCGSRBQ EQU   ATCAOSM+4
ATCGSRBG EQU   ATCGSRBQ
ATCAP31  EQU   ATCAOSM+24
ATCAP34  EQU   ATCAOSM+32
ATCICAPP EQU   ATCAOSM+100
ATCLDAPP EQU   ATCAOSM+120
ATCDAPVT EQU   ATCAOSM+140
ATCAP37  EQU   ATCAOSM+264
ATCCRA   EQU   ATCAOSM+280
ATCCRACN EQU   ATCCRA+4
ATCSRB   EQU   ATCAOSM+288
ATCSRBCN EQU   ATCSRB+4
ATCCRPL  EQU   ATCAOSM+296
ATCRPLCN EQU   ATCCRPL+4
ATCSQAFR EQU   ATCAOSM+304
ATCORTBC EQU   ATCSQAFR+4
ATCORSRB EQU   ATCORTBC
@NM00077 EQU   ATCAOSM+332
ATCVTFLG EQU   ATCAOSM+392
ATCZFLAG EQU   ATCAOSM+588
ISTNIR   EQU   0
NIRRU    EQU   ISTNIR+3
ISTRUSEN EQU   0
RUSENSE  EQU   ISTRUSEN
ISTPOHD  EQU   0
POHSTAT  EQU   ISTPOHD+1
ISTPFX   EQU   0
PFXID    EQU   ISTPFX
ISTNCSPL EQU   0
@NM00081 EQU   ISTNCSPL
NCSPFX   EQU   @NM00081
NCSPLVCD EQU   ISTNCSPL+17
NCSPLVBF EQU   ISTNCSPL+18
NCSPLVFL EQU   ISTNCSPL+20
NCSVSTAT EQU   NCSPLVFL
NCSPLVF1 EQU   ISTNCSPL+21
NCSPLRID EQU   ISTNCSPL+28
NCSPLLID EQU   ISTNCSPL+36
NCSPLRPT EQU   ISTNCSPL+52
NCSPLLPT EQU   ISTNCSPL+56
NCSPLCMD EQU   ISTNCSPL+60
NCSCMDA  EQU   NCSPLCMD
NCSCRFLG EQU   ISTNCSPL+67
NCSPLRAD EQU   ISTNCSPL+144
NCSIOCID EQU   ISTNCSPL+148
NCSPLCID EQU   NCSIOCID
NCSPLWKA EQU   ISTNCSPL+152
NCSPLCVT EQU   ISTNCSPL+156
NCSPLFSB EQU   ISTNCSPL+168
NCSPLFL1 EQU   ISTNCSPL+176
NCSPLREQ EQU   NCSPLFL1
NCSPLFL2 EQU   ISTNCSPL+177
NCSPLFL3 EQU   ISTNCSPL+178
NCSPLFL4 EQU   ISTNCSPL+179
NCSPLFL5 EQU   ISTNCSPL+181
NCSPLWEL EQU   ISTNCSPL+200
NCSPLAPP EQU   ISTNCSPL+216
NCSPLNSN EQU   ISTNCSPL+240
NCSSENSE EQU   ISTNCSPL+244
NCSCRMSK EQU   ISTNCSPL+268
NCSCHKPT EQU   NCSCRMSK
NCSCRMOD EQU   NCSCRMSK+2
NCSPLSID EQU   ISTNCSPL+271
NCSPLSTA EQU   NCSPLSID
NCSPLPHD EQU   NCSPLSID+1
NCSAPP   EQU   0
NCSAPBUE EQU   NCSAPP+88
NCSUSSRU EQU   0
ISTNCB   EQU   0
NCBDAF   EQU   ISTNCB+2
NCBFLAGS EQU   ISTNCB+24
NCBFRAS  EQU   NCBFLAGS+1
NCBFTRIO EQU   NCBFRAS
NCBFLAG1 EQU   NCBFLAGS+2
ISTFDB   EQU   0
FDBFDBA  EQU   ISTFDB
FDBDATAA EQU   ISTFDB+4
FDBOFSET EQU   ISTFDB+10
ISTFSB   EQU   0
FSBFSB   EQU   ISTFSB
FSBMNRCD EQU   FSBFSB+2
FSBSFLGS EQU   FSBFSB+3
FSBFSBA  EQU   FSBFSB+4
FSBBTH   EQU   FSBFSB+8
FSBCID   EQU   FSBBTH
FSBRQTAG EQU   FSBBTH+4
FSBSEQID EQU   FSBRQTAG
FSBFLAGS EQU   FSBSEQID
FSBSEQ   EQU   FSBSEQID+1
FSBCSWST EQU   FSBBTH+6
FSBTHFLD EQU   FSBCSWST
FSBTH1   EQU   FSBTHFLD
FSBSYSRS EQU   FSBTH1
FSBTH2   EQU   FSBTHFLD+1
FSBEXTRS EQU   FSBTH2
FSBXFSTS EQU   FSBEXTRS
FSBXCODE EQU   FSBEXTRS
FSBNETRS EQU   FSBFSB+16
FSBSRCAT EQU   FSBNETRS
FSBMJRCD EQU   FSBSRCAT
FSBERC   EQU   FSBNETRS+1
FSBFBMI  EQU   FSBERC
FSBDMGRS EQU   FSBFSB+18
FSBSS1   EQU   FSBDMGRS
FSBSS2   EQU   FSBDMGRS+1
FSBLCPB  EQU   FSBFSB+20
FSBMSGID EQU   FSBLCPB
FSBLCCWA EQU   FSBFSB+24
FSBRLSTS EQU   FSBLCCWA
FSBFDB   EQU   ISTFSB+32
ISTNMLPB EQU   0
NMLCPB   EQU   ISTNMLPB
NMLCW2   EQU   ISTNMLPB+56
NMLCW3   EQU   ISTNMLPB+64
NMCONTRL EQU   ISTNMLPB+72
NMFNCTCD EQU   NMCONTRL
NMLCWCMD EQU   NMCONTRL+2
NMRDTEA  EQU   NMCONTRL+4
ISTRPRE  EQU   0
RPRNAME  EQU   ISTRPRE
RPRCOMID EQU   ISTRPRE+8
RPRDAF   EQU   RPRCOMID+2
RPRRLOCK EQU   ISTRPRE+12
RPRPELEN EQU   ISTRPRE+18
RPRENTRY EQU   ISTRPRE+20
RPRFLAGA EQU   ISTRPRE+21
RPRFLAGB EQU   ISTRPRE+22
RPRCAUSE EQU   ISTRPRE+23
RPRHDTYP EQU   ISTRPRE+27
RPRNSNEA EQU   ISTRPRE+36
RPRDEVCH EQU   ISTRPRE+44
RPRFLAGD EQU   ISTRPRE+61
RPRCONCT EQU   RPRFLAGD
RPRFLAGC EQU   ISTRPRE+62
ISTRCPRE EQU   0
RCPACETR EQU   ISTRCPRE+84
RCPPMODE EQU   ISTRCPRE+91
RCPLGNIN EQU   ISTRCPRE+92
ISTRDT   EQU   0
RDTPLEN  EQU   ISTRDT+72
RDTPRIOR EQU   RDTPLEN
RDTFLAGB EQU   ISTRDT+91
RDTVPAB  EQU   ISTRDT+92
RDTVYRPH EQU   ISTRDT+108
RDTSTCNT EQU   ISTRDT+112
ISTRAP   EQU   0
RAPFLG   EQU   ISTRAP+108
RAPFLGB  EQU   ISTRAP+109
RAPALLF  EQU   RAPFLGB
RAPFLGC  EQU   ISTRAP+110
ISTRLC   EQU   0
RLCADR   EQU   ISTRLC+72
RLCFLAG  EQU   RLCADR
ISTRRN   EQU   0
RRNADR   EQU   ISTRRN+136
RRNFLAG  EQU   RRNADR
RRNUCBAD EQU   RRNADR+1
RRNRDF   EQU   ISTRRN+172
RRNRDFA  EQU   RRNRDF
RRNRDFB  EQU   RRNRDF+1
RRNCMF   EQU   ISTRRN+176
RRNCMFA  EQU   RRNCMF
RRNCMFB  EQU   RRNCMF+1
RRNCMFC  EQU   RRNCMF+2
RRNCMFD  EQU   RRNCMF+3
RRNNMDPD EQU   ISTRRN+192
RRNHPRE  EQU   ISTRRN+216
ISTRGP   EQU   0
RGPFLG   EQU   ISTRGP+72
ISTRLN   EQU   0
RLNADR   EQU   ISTRLN+72
RLNFLAG  EQU   RLNADR
RLNUCBAD EQU   RLNADR+1
RLNSTAT1 EQU   ISTRLN+86
RLNSTAT2 EQU   ISTRLN+87
RLNRDF   EQU   ISTRLN+88
RLNRDFA  EQU   RLNRDF
RLNRACNT EQU   RLNRDFA
RLNPORT  EQU   RLNRDFA
RLNRDFB  EQU   RLNRDF+1
RLNCRFLG EQU   ISTRLN+102
RLNLSCMD EQU   RLNCRFLG
ISTRPT   EQU   0
RPTLNCID EQU   ISTRPT+116
RPTDITT  EQU   ISTRPT+128
RPTFLAG1 EQU   ISTRPT+140
ISTRCL   EQU   0
RCLADR   EQU   ISTRCL+72
RCLFLAG  EQU   RCLADR
ISTRTR   EQU   0
RTRADR   EQU   ISTRTR+124
RTRFLAG  EQU   RTRADR
RTRRDFA  EQU   ISTRTR+136
RTRRAALL EQU   RTRRDFA
RTRRDFB  EQU   ISTRTR+137
RTRRDFC  EQU   ISTRTR+138
RTRRDFD  EQU   ISTRTR+139
RTRRDFE  EQU   ISTRTR+140
RTRRDFF  EQU   ISTRTR+141
RTRCRFLG EQU   ISTRTR+143
RTRLSCMD EQU   RTRCRFLG
RTRBSCID EQU   ISTRTR+188
ISTRIN   EQU   0
RINDFD   EQU   ISTRIN+124
RINREMPO EQU   RINDFD
RINNODEF EQU   RINDFD
RINLDISC EQU   RINDFD
RINNODID EQU   ISTRIN+125
RINRLDAF EQU   ISTRIN+126
RINREMOT EQU   ISTRIN+128
RINVPAB  EQU   ISTRIN+132
RINRPHCN EQU   ISTRIN+136
RINNCSPL EQU   ISTRIN+140
RINCNCNT EQU   ISTRIN+144
ISTRDS   EQU   0
ISTDOT   EQU   0
ISTRCC   EQU   0
RCCFLAG  EQU   ISTRCC+73
RCCFLAGB EQU   ISTRCC+74
RCCRESET EQU   RCCFLAGB
RCCSTAID EQU   ISTRCC+78
RCCID48  EQU   RCCSTAID+2
RCCVPAB  EQU   ISTRCC+88
RCCCRFLG EQU   ISTRCC+108
ISTRLU   EQU   0
RLUFLAG  EQU   ISTRLU+125
RLUCRFLG EQU   ISTRLU+126
RLUPACE  EQU   ISTRLU+132
RLUPACEN EQU   RLUPACE
RLUNCPPC EQU   ISTRLU+134
RLUNCPPN EQU   RLUNCPPC
RLUUSSTB EQU   ISTRLU+140
RLUMODET EQU   ISTRLU+152
RLULGMOD EQU   ISTRLU+164
ISTRPX   EQU   0
ISTRLX   EQU   0
RLXFLAGA EQU   ISTRLX+76
ISTRSW   EQU   0
ISTRDA   EQU   0
RDAADR   EQU   ISTRDA+72
RDAFLAG  EQU   RDAADR
RDAUCBAD EQU   RDAADR+1
ISTRLS   EQU   0
ISTDNT   EQU   0
ISTGNT   EQU   0
ISTPAT   EQU   0
PATFLAGA EQU   ISTPAT+7
ISTFMCB  EQU   0
FMCSAF   EQU   ISTFMCB+2
FMCSTAT  EQU   ISTFMCB+28
FMCDEVOF EQU   FMCSTAT
FMCSTAT1 EQU   ISTFMCB+29
FMCCMDFL EQU   ISTFMCB+31
FMCCMDR  EQU   FMCCMDFL
FMCCMPS1 EQU   ISTFMCB+36
FMCMODE  EQU   ISTFMCB+52
FMCPAB1  EQU   ISTFMCB+64
FMCPAB5  EQU   ISTFMCB+128
FMCSIPA  EQU   ISTFMCB+148
FMCNXOSQ EQU   ISTFMCB+152
FMCNXCFM EQU   FMCNXOSQ
FMCNXOSC EQU   FMCNXOSQ+2
FMCSSTAT EQU   ISTFMCB+159
FMCSDTR  EQU   FMCSSTAT
FMCPACE  EQU   ISTFMCB+160
FMCPACEN EQU   FMCPACE
FMCPACEM EQU   FMCPACE+1
FMCPACPC EQU   FMCPACE+2
FMCCVAL  EQU   FMCPACE+3
FMCOBCE  EQU   FMCCVAL
FMCCLEXT EQU   ISTFMCB+164
FMCRPLA  EQU   FMCCLEXT
FMCFBA   EQU   FMCCLEXT+4
FMCCMPS2 EQU   FMCCLEXT+16
FMCFLGA  EQU   FMCCMPS2
FMCFLGCL EQU   FMCCMPS2+1
FMCPSCMD EQU   FMCCMPS2+2
FMCPSTAT EQU   FMCCMPS2+3
FMCSTAT2 EQU   ISTFMCB+186
FMCCPIP  EQU   FMCSTAT2
FMCMODEB EQU   ISTFMCB+189
FMCCLSEQ EQU   ISTFMCB+190
FMCRRESP EQU   ISTFMCB+195
FMCSSEGQ EQU   ISTFMCB+200
FMCFBAS  EQU   ISTFMCB+216
FMCZV002 EQU   FMCFBAS
FMCSNCTL EQU   ISTFMCB+224
FMCSCFLG EQU   FMCSNCTL
FMCSTCTL EQU   FMCSCFLG
FMCVS1   EQU   ISTFMCB+232
FMCZFLAG EQU   FMCVS1
FMCZF006 EQU   FMCZFLAG
FMCLBXM  EQU   FMCVS1+12
FMCSHEAQ EQU   FMCLBXM
FMCLCPBQ EQU   FMCVS1+16
FMCLCPAQ EQU   FMCVS1+20
FMCSEQ1  EQU   FMCVS1+34
FMCZFLG2 EQU   FMCVS1+35
FMCCVFLG EQU   FMCVS1+44
FMCFLAG  EQU   0
FMCFLGB  EQU   FMCFLAG
ISTICE   EQU   0
ICEFLAGS EQU   ISTICE+28
ISTACE   EQU   0
ACEOBJQ  EQU   ISTACE+12
ACERPHA  EQU   ISTACE+16
ACEFLAGS EQU   ISTACE+20
ACEVARY  EQU   ACEFLAGS
ISTINCSH EQU   0
C14SVPTR EQU   0
C14SAVE  EQU   0
SORTCID  EQU   0
SORTDAF  EQU   SORTCID+2
NCSWKA   EQU   0
NCSWKAW1 EQU   NCSWKA
NCSWKAW2 EQU   NCSWKA+4
NCSWKAW3 EQU   NCSWKA+8
CBNDSDT  EQU   0
SWITCH   EQU   2
CWORD    EQU   0
ISTOCCDF EQU   0
SHFTUBND EQU   0
SHFULN   EQU   SHFTUBND
SHFUDT   EQU   SHFTUBND+1
ISTZSAVE EQU   0
ZSAZSVBC EQU   ISTZSAVE
ZSAZSVMS EQU   ZSAZSVBC
ISTPFCRR EQU   0
PFCCRR   EQU   ISTPFCRR
PFCCRRID EQU   PFCCRR
PFCCRRLN EQU   PFCCRR+2
PFCHDR   EQU   ISTPFCRR+4
PFCCRRO  EQU   PFCHDR
PFCFRRO  EQU   PFCHDR+4
ISTCFCRR EQU   0
CFCAUDIT EQU   ISTCFCRR
CFCNTRD  EQU   CFCAUDIT
CFCCRT   EQU   CFCAUDIT+1
ISTZCRR  EQU   0
ZCRCRR   EQU   ISTZCRR
ZCRFLGS1 EQU   ISTZCRR+12
ZCRFLGS2 EQU   ISTZCRR+13
ZCRSWFLD EQU   ISTZCRR+14
ZCRENDSH EQU   ZCRSWFLD
ZCRNDLCP EQU   ZCRSWFLD
ZCRRESET EQU   ZCRSWFLD
ZCRFLGS3 EQU   ISTZCRR+15
ZCRGENSW EQU   ISTZCRR+16
ZCRPFLGS EQU   ISTZCRR+17
ZCRIBPR  EQU   ISTZCRR+18
ZCRSCPSW EQU   ISTZCRR+19
ZCRPARMS EQU   ISTZCRR+24
ZCRFBPTR EQU   ZCRPARMS
ZCRDFRDA EQU   ZCRPARMS+10
ZCRPCOD1 EQU   ZCRPARMS+12
ZCRPLSBF EQU   ZCRPCOD1
ZCRPCOD2 EQU   ZCRPARMS+13
ZCRSVRTN EQU   ISTZCRR+56
ZCRWKARA EQU   ISTZCRR+156
ZCRCIDSV EQU   ISTZCRR+192
ZCRAUDIT EQU   ISTZCRR+440
ZCRENTER EQU   ZCRAUDIT+5
ZCRLCPB  EQU   ISTZCRR+480
ZCRRHRU  EQU   ZCRLCPB
ISTASCRR EQU   0
ASCFLAGS EQU   ISTASCRR+16
ASCFLG1  EQU   ASCFLAGS
ASCFLG2  EQU   ASCFLAGS+2
ASCFLG3  EQU   ASCFLAGS+4
ASCUSRGS EQU   ISTASCRR+28
ISTAPCRR EQU   0
APCATFLG EQU   ISTAPCRR+16
APCRFLG  EQU   ISTAPCRR+18
APCSAVE  EQU   ISTAPCRR+44
APCCOMF  EQU   ISTAPCRR+116
APCCOMF1 EQU   APCCOMF
APC31FLG EQU   ISTAPCRR+132
APC52FLG EQU   ISTAPCRR+133
APC53FLG EQU   ISTAPCRR+134
APC54FLG EQU   ISTAPCRR+135
APC57FLG EQU   ISTAPCRR+136
ISTCRA   EQU   0
CRABASIC EQU   ISTCRA
CRAHDR   EQU   CRABASIC
CRACRR   EQU   CRAHDR
CRALKACT EQU   CRABASIC+8
CRAL2PTR EQU   CRABASIC+16
CRAL3PTR EQU   CRABASIC+20
CRAL4PTR EQU   CRABASIC+24
CRASVC   EQU   ISTCRA+848
CRABUFA  EQU   CRASVC+68
ISTCNSTA EQU   0
CNSTFLDA EQU   ISTCNSTA+16
CNSTFLDB EQU   ISTCNSTA+19
ISTOCCRR EQU   0
OCCAUDIT EQU   ISTOCCRR+22
OCCNTRD  EQU   OCCAUDIT
NOCCOE   EQU   OCCNTRD+1
OCCCRT   EQU   OCCAUDIT+3
COCCOE   EQU   OCCCRT+1
FMZL0013 EQU   0
FMZL0037 EQU   0
FMZL0066 EQU   0
FMZL0071 EQU   0
FMZL0090 EQU   0
FMZL0100 EQU   0
FMZL0110 EQU   0
FMZL0121 EQU   0
FMZL0126 EQU   0
ISTSDCCF EQU   0
ISTSDCCR EQU   0
FMZL0141 EQU   0
FMZL0146 EQU   0
FMZL0151 EQU   0
FMZL0162 EQU   0
FMZL0181 EQU   0
ISTAPC37 EQU   0
FMZL0242 EQU   0
FMZL0252 EQU   0
SAV0300  EQU   0
SAV10300 EQU   SAV0300
SAV20300 EQU   SAV0300+4
SAV40300 EQU   SAV0300+8
SAV60300 EQU   SAV0300+12
SAVE0300 EQU   SAV0300+16
ISTPST   EQU   0
PSTRQFGA EQU   ISTPST+8
PSTRQUE  EQU   PSTRQFGA
PSTFLGA  EQU   PSTRQFGA+4
PSTABINP EQU   PSTFLGA
PSTTCBA  EQU   ISTPST+16
PSTDMPS  EQU   ISTPST+132
SAV0309  EQU   0
SAV10309 EQU   SAV0309
SAV20309 EQU   SAV0309+4
SAV40309 EQU   SAV0309+8
SAV60309 EQU   SAV0309+12
SAVE0309 EQU   SAV0309+16
FMZL0341 EQU   0
FMZL0365 EQU   0
FMZL0399 EQU   0
FMZL0417 EQU   0
FMZL0460 EQU   0
FMZL0470 EQU   0
FMZL0485 EQU   0
FNDLOGMD EQU   0
ISTAPC34 EQU   0
ISTRPL   EQU   0
ISTSDCCA EQU   0
ISTSDCCD EQU   0
ISTSDCCN EQU   0
FLC      EQU   PSA
PSARSVTE EQU   PSARSVT
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
SRUSENSE EQU   ISTSRU
SRURMS   EQU   ISTSRU
SRUZIB   EQU   ISTSRU
SRUNETS  EQU   SRUZIB
ISTUNBRU EQU   SRUTYPE
BINLUP1  EQU   BINPSCHR
BINLUS   EQU   BINPSCHR
BINFMF1  EQU   BINLUS
BINRSV09 EQU   BINFMF1
BINDSPF1 EQU   BINLUS+2
BINMEDIA EQU   BINLUS+4
BINLUP2  EQU   BINPSCHR
BINLUP3  EQU   BINPSCHR
LCPZTIE  EQU   LCPCID
LCPZSNAM EQU   LCPZTIE+8
FSBCOMBN EQU   FSBNETRS
FSBRHFLD EQU   FSBCOMBN+1
FSBRH3   EQU   FSBRHFLD+2
FSBLDFLG EQU   FSBRH3
@NM00090 EQU   FSBRQTAG
CSLOVLY  EQU   CSLRDEF
@NM00107 EQU   CSLOVLY
CSLRDTEB EQU   @NM00107
RUCBSTG  EQU   OCWLCPBA
CMZCIDM  EQU   ATCCIDM
RTRDNCBA EQU   ISTRTR+40
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
@NM00108 EQU   @NM00107
FSBRT0B  EQU   @NM00090+1
FSBRT0A  EQU   @NM00090+1
FSBRT09  EQU   @NM00090+1
FSBRT08  EQU   @NM00090+1
FSBRT07  EQU   @NM00090
FSBRT06  EQU   @NM00090
FSBRT05  EQU   @NM00090
FSBRT04  EQU   @NM00090
FSBRT03  EQU   @NM00090
FSBRT02  EQU   @NM00090
FSBRT01  EQU   @NM00090
FSBRT00  EQU   @NM00090
FSBLDCUF EQU   FSBLDFLG
FSBLDSIF EQU   FSBLDFLG
FSBLDSOF EQU   FSBLDFLG
FSBLDEBF EQU   FSBLDFLG
FSBLDBBF EQU   FSBLDFLG
FSBLDFME EQU   FSBLDFLG
FSBLDSCF EQU   FSBLDFLG
FSBLDRMF EQU   FSBLDFLG
FSBRH2   EQU   FSBRHFLD+1
FSBRH1   EQU   FSBRHFLD
FSBALIGN EQU   FSBCOMBN
LCPZTRV4 EQU   LCPZSNAM+4
LCPZTRV1 EQU   LCPZSNAM
LCPZSNA  EQU   LCPZTIE+4
LCPZFMCA EQU   LCPZTIE
BINRSV26 EQU   BINLUP3
BINRSV15 EQU   BINLUP2+10
BINPRESZ EQU   BINLUP2+9
BINRSV14 EQU   BINLUP2
BINRSV13 EQU   BINMEDIA
BINDISK  EQU   BINMEDIA
BINXCHNG EQU   BINMEDIA
BINCARD  EQU   BINMEDIA
BINDOCMT EQU   BINMEDIA
BINRSV17 EQU   BINDSPF1+1
BINTRNDS EQU   BINDSPF1
BINRSV12 EQU   BINDSPF1
BINVSDS  EQU   BINDSPF1
BINVTDS  EQU   BINDSPF1
BINHFDS  EQU   BINDSPF1
BININTR  EQU   BINDSPF1
BINRSV11 EQU   BINRSV09+1
BINXFPD  EQU   BINRSV09+1
BINCSDS  EQU   BINRSV09+1
BINQDSI  EQU   BINRSV09+1
BINRSV16 EQU   BINRSV09+1
BINARRR  EQU   BINRSV09
BINSIDS  EQU   BINRSV09
BINSAI   EQU   BINRSV09
BINSDSI  EQU   BINRSV09
BINKDDSI EQU   BINRSV09
BINPDIR  EQU   BINFMF1
BINCMPCT EQU   BINFMF1
BINDESTS EQU   BINFMF1
BINSLUS1 EQU   BINLUP1+6
BINPLUS1 EQU   BINLUP1+1
BINDSP1  EQU   BINLUP1
BINFMHS1 EQU   BINLUP1
UNBTYPE  EQU   ISTUNBRU
SRUNAF   EQU   SRUZIB+3
SRUNSREQ EQU   SRUNETS+2
SRUNSUBC EQU   SRUNETS+1
SRUNSCAT EQU   SRUNETS
SRUREQRE EQU   SRURMS+2
SRUPFX2  EQU   SRURMS+1
SRUPFX1  EQU   SRURMS
SRUSENS2 EQU   SRUSENSE+2
SRUSNS2  EQU   SRUSENSE+1
SRUSNS1  EQU   SRUSENSE
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTRV620 EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTIRM   EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRV607 EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
PSTDRDYQ EQU   PSTDMPS+1
@NM00158 EQU   PSTDMPS
PSTDGATE EQU   PSTDMPS
PSTDEBP  EQU   ISTPST+128
PSTSAVE  EQU   ISTPST+96
PSTSMDYP EQU   ISTPST+64
PSTCRRS  EQU   ISTPST+60
PSTCRR1  EQU   ISTPST+56
PSTIQE22 EQU   ISTPST+52
PSTIQE21 EQU   ISTPST+48
PSTIQE12 EQU   ISTPST+44
PSTIQE11 EQU   ISTPST+40
PSTUEQ   EQU   ISTPST+36
PSTNSSQ  EQU   ISTPST+32
PSTPSSQ  EQU   ISTPST+28
PSTACBCT EQU   ISTPST+24
PSTMPSTP EQU   ISTPST+20
PSTRSV08 EQU   PSTFLGA+1
PSTDMPC  EQU   PSTFLGA+1
PSTABEND EQU   PSTABINP
PSTAUTH  EQU   PSTFLGA
PSTSMCU  EQU   PSTFLGA
PSTSMQR  EQU   PSTFLGA
PSTIRBU2 EQU   PSTFLGA
PSTIRBU1 EQU   PSTFLGA
PSTUERN  EQU   PSTFLGA
PSTSSRN  EQU   PSTFLGA
PSTRQUEA EQU   PSTRQUE+1
PSTRSV07 EQU   PSTRQUE
PSTRSV06 EQU   PSTRQUE
PSTRSV05 EQU   PSTRQUE
PSTRSV04 EQU   PSTRQUE
PSTRSV03 EQU   PSTRQUE
PSTRSV02 EQU   PSTRQUE
PSTRSV01 EQU   PSTRQUE
PSTRQFLG EQU   PSTRQUE
PSTCHAIN EQU   ISTPST+4
@NM00157 EQU   ISTPST+2
PSTLNGTH EQU   ISTPST+1
PSTTYPE  EQU   ISTPST
COCPOI   EQU   OCCCRT+2
COCACX   EQU   OCCCRT+2
COCCCN   EQU   OCCCRT+2
COCCCM   EQU   OCCCRT+2
COCCNV   EQU   OCCCRT+2
COCCCC   EQU   OCCCRT+2
COCCRL   EQU   OCCCRT+2
COCCQU   EQU   OCCCRT+2
COCCRT   EQU   OCCCRT+1
COCCFB   EQU   OCCCRT+1
COCCOF   EQU   OCCCRT+1
COCCLD   EQU   OCCCRT+1
COCCOD   EQU   OCCCRT+1
COCCSD   EQU   OCCCRT+1
COCCRD   EQU   OCCCRT+1
COCCFD   EQU   OCCCRT
COCCMD   EQU   OCCCRT
COCCFR   EQU   OCCCRT
COCCFO   EQU   OCCCRT
COCCSL   EQU   OCCCRT
COCCCH   EQU   OCCCRT
COCCCL   EQU   OCCCRT
COCCOC   EQU   OCCCRT
NOCPOI   EQU   OCCNTRD+2
NOCACX   EQU   OCCNTRD+2
NOCCCN   EQU   OCCNTRD+2
NOCCCM   EQU   OCCNTRD+2
NOCCNV   EQU   OCCNTRD+2
NOCCCC   EQU   OCCNTRD+2
NOCCRL   EQU   OCCNTRD+2
NOCCQU   EQU   OCCNTRD+2
NOCCRT   EQU   OCCNTRD+1
NOCCFB   EQU   OCCNTRD+1
NOCCOF   EQU   OCCNTRD+1
NOCCLD   EQU   OCCNTRD+1
NOCCOD   EQU   OCCNTRD+1
NOCCSD   EQU   OCCNTRD+1
NOCCRD   EQU   OCCNTRD+1
NOCCFD   EQU   OCCNTRD
NOCCMD   EQU   OCCNTRD
NOCCFR   EQU   OCCNTRD
NOCCFO   EQU   OCCNTRD
NOCCSL   EQU   OCCNTRD
NOCCCH   EQU   OCCNTRD
NOCCCL   EQU   OCCNTRD
NOCCOC   EQU   OCCNTRD
OCCCNS   EQU   ISTOCCRR
CNSRSV05 EQU   CNSTFLDB+2
CNSLOG0B EQU   CNSTFLDB+2
CNSACCTB EQU   CNSTFLDB+2
CNSFREEB EQU   CNSTFLDB+2
CNSGETSB EQU   CNSTFLDB+2
CNSSEARB EQU   CNSTFLDB+2
CNSQUEUB EQU   CNSTFLDB+2
CNSACONB EQU   CNSTFLDB+2
CNSTCONB EQU   CNSTFLDB+1
CNSCLAQB EQU   CNSTFLDB+1
CNSCLINB EQU   CNSTFLDB+1
CNSGBINB EQU   CNSTFLDB+1
CNSLGINB EQU   CNSTFLDB+1
CNSACINB EQU   CNSTFLDB+1
CNSPSINB EQU   CNSTFLDB+1
CNSRQRLB EQU   CNSTFLDB+1
CNSTRRLB EQU   CNSTFLDB
CNSDORLB EQU   CNSTFLDB
CNSRLINB EQU   CNSTFLDB
CNSQREQB EQU   CNSTFLDB
CNSXREQB EQU   CNSTFLDB
CNSAQINB EQU   CNSTFLDB
CNSAUTHB EQU   CNSTFLDB
CNSMRINB EQU   CNSTFLDB
CNSRSV01 EQU   CNSTFLDA+2
CNSLOG0A EQU   CNSTFLDA+2
CNSACCTA EQU   CNSTFLDA+2
CNSFREEA EQU   CNSTFLDA+2
CNSGETSA EQU   CNSTFLDA+2
CNSSEARA EQU   CNSTFLDA+2
CNSQUEUA EQU   CNSTFLDA+2
CNSACONA EQU   CNSTFLDA+2
CNSTCONA EQU   CNSTFLDA+1
CNSCLAQA EQU   CNSTFLDA+1
CNSCLINA EQU   CNSTFLDA+1
CNSGBINA EQU   CNSTFLDA+1
CNSLGINA EQU   CNSTFLDA+1
CNSACINA EQU   CNSTFLDA+1
CNSPSINA EQU   CNSTFLDA+1
CNSRQRLA EQU   CNSTFLDA+1
CNSTRRLA EQU   CNSTFLDA
CNSDORLA EQU   CNSTFLDA
CNSRLINA EQU   CNSTFLDA
CNSQREQA EQU   CNSTFLDA
CNSXREQA EQU   CNSTFLDA
CNSAQINA EQU   CNSTFLDA
CNSAUTHA EQU   CNSTFLDA
CNSMRINA EQU   CNSTFLDA
CNSTPFX  EQU   ISTCNSTA
CRACHAIN EQU   ISTCRA+928
CRARSV02 EQU   ISTCRA+924
CRARSV01 EQU   ISTCRA+920
CRABFTBA EQU   CRABUFA
CRAMASK  EQU   CRASVC+64
CRAHSIZ  EQU   CRASVC+60
CRAASCRR EQU   CRASVC
CRAPROCR EQU   ISTCRA+312
CRAPSS   EQU   ISTCRA+160
CRARPH   EQU   ISTCRA+52
CRALAPTR EQU   CRABASIC+48
CRAL9PTR EQU   CRABASIC+44
CRAL8PTR EQU   CRABASIC+40
CRAL7PTR EQU   CRABASIC+36
CRAL6PTR EQU   CRABASIC+32
CRAL5PTR EQU   CRABASIC+28
CRAL1PTR EQU   CRABASIC+12
CRALEV01 EQU   CRALKACT+3
CRALEV02 EQU   CRALKACT+3
CRALEV03 EQU   CRALKACT+3
CRALEV04 EQU   CRALKACT+3
CRALEV05 EQU   CRALKACT+3
CRALEV06 EQU   CRALKACT+3
CRALEV07 EQU   CRALKACT+3
CRALEV08 EQU   CRALKACT+3
CRALEV09 EQU   CRALKACT+2
CRALEV10 EQU   CRALKACT+2
CRALEV11 EQU   CRALKACT+2
CRALEV12 EQU   CRALKACT+2
CRALEV13 EQU   CRALKACT+2
CRALEV14 EQU   CRALKACT+2
CRALEV15 EQU   CRALKACT+2
CRALEV16 EQU   CRALKACT+2
CRALEV17 EQU   CRALKACT+1
CRALEV18 EQU   CRALKACT+1
CRALEV19 EQU   CRALKACT+1
CRALEV20 EQU   CRALKACT+1
CRALEV21 EQU   CRALKACT+1
CRALEV22 EQU   CRALKACT+1
CRALEV23 EQU   CRALKACT+1
CRALEV24 EQU   CRALKACT+1
CRALEV25 EQU   CRALKACT
CRALEV26 EQU   CRALKACT
CRALEV27 EQU   CRALKACT
CRALEV28 EQU   CRALKACT
CRALEV29 EQU   CRALKACT
CRALEV30 EQU   CRALKACT
CRALEV31 EQU   CRALKACT
CRALEV32 EQU   CRALKACT
CRAFRR   EQU   CRAHDR+4
@NM00156 EQU   ISTAPCRR+137
@NM00155 EQU   APC57FLG
APCNREL  EQU   APC57FLG
APCRECRA EQU   APC57FLG
@NM00154 EQU   APC54FLG
APCRLST  EQU   APC54FLG
APCPR153 EQU   APC53FLG
@NM00153 EQU   APC52FLG
APCWKF   EQU   APC52FLG
APCNWF   EQU   APC52FLG
APCRDQ   EQU   APC52FLG
APCQENQ  EQU   APC52FLG
APCSMSR  EQU   APC52FLG
APCCKRQ  EQU   APC52FLG
@NM00152 EQU   APC31FLG
APCSORT  EQU   APC31FLG
APCRESCH EQU   APC31FLG
APCTPXIT EQU   APC31FLG
APCSWTWD EQU   ISTAPCRR+128
APCSAV2  EQU   ISTAPCRR+124
APCSAV1  EQU   ISTAPCRR+120
APCRETCD EQU   APCCOMF+2
@NM00151 EQU   APCCOMF1+1
APCZLBER EQU   APCCOMF1
APCEXIT  EQU   APCCOMF1
APCRELR  EQU   APCCOMF1
APCIRB2  EQU   APCCOMF1
APCIRB1  EQU   APCCOMF1
APCSMCR  EQU   APCCOMF1
APCUETSK EQU   APCCOMF1
APCSSTSK EQU   APCCOMF1
APCESTAL EQU   APCSAVE
APCFRRPM EQU   ISTAPCRR+40
APCQWFO  EQU   ISTAPCRR+36
APCPABSV EQU   ISTAPCRR+32
APCRTRN  EQU   ISTAPCRR+28
APCTCBA  EQU   ISTAPCRR+24
APCPSTA  EQU   ISTAPCRR+20
@NM00150 EQU   APCRFLG+1
APC31R   EQU   APCRFLG
APC58R   EQU   APCRFLG
APC57R   EQU   APCRFLG
APC56R   EQU   APCRFLG
APC54R   EQU   APCRFLG
APC53R   EQU   APCRFLG
APC52R   EQU   APCRFLG
APC51R   EQU   APCRFLG
@NM00149 EQU   APCATFLG+1
APC31E   EQU   APCATFLG
APC58E   EQU   APCATFLG
APC57E   EQU   APCATFLG
APC56E   EQU   APCATFLG
APC54E   EQU   APCATFLG
APC53E   EQU   APCATFLG
APC52E   EQU   APCATFLG
APC51E   EQU   APCATFLG
APCHDRSV EQU   ISTAPCRR
ASCPSREG EQU   ISTASCRR+44
ASCUSR01 EQU   ASCUSRGS+12
ASCUSR00 EQU   ASCUSRGS+8
ASCUSR15 EQU   ASCUSRGS+4
ASCUSR14 EQU   ASCUSRGS
ASCETRYA EQU   ISTASCRR+24
ASCKEY   EQU   ISTASCRR+23
ASCAUDIT EQU   ASCFLG3
ASCFBDUD EQU   ASCFLG3
ASCLLKF  EQU   ASCFLG3
ASCKEYF  EQU   ASCFLG3
ASCFBDAL EQU   ASCFLG3
ASCFSRGT EQU   ASCFLG3
ASCICR   EQU   ASCFLG2
ASCFSRIC EQU   ASCFLG2
ASCFBDIC EQU   ASCFLG2
ASCFBAIC EQU   ASCFLG2
ASCPASTR EQU   ASCFLG1
ASCFSR   EQU   ASCFLG1
ASCFBD   EQU   ASCFLG1
ASCFBA   EQU   ASCFLG1
ASCPFCRR EQU   ISTASCRR
ZCRRU    EQU   ZCRRHRU+3
ZCRRH    EQU   ZCRRHRU
ZCRWORDA EQU   ISTZCRR+477
ZCRCMNRC EQU   ISTZCRR+476
ZCRRSV97 EQU   ZCRENTER+18
ZCREIC2B EQU   ZCRENTER+18
ZCREAC2B EQU   ZCRENTER+18
ZCRELCAB EQU   ZCRENTER+18
ZCREDCMF EQU   ZCRENTER+18
ZCREBCIF EQU   ZCRENTER+18
ZCREICSG EQU   ZCRENTER+18
ZCREDCK0 EQU   ZCRENTER+18
ZCRECFY0 EQU   ZCRENTER+17
ZCREKCCB EQU   ZCRENTER+17
ZCREDCNB EQU   ZCRENTER+17
ZCREICOE EQU   ZCRENTER+17
ZCREBCNB EQU   ZCRENTER+17
ZCREBC0L EQU   ZCRENTER+17
ZCREBCAL EQU   ZCRENTER+17
ZCREDCQR EQU   ZCRENTER+17
ZCREDCPR EQU   ZCRENTER+16
ZCREBCSB EQU   ZCRENTER+16
ZCREAC1R EQU   ZCRENTER+16
ZCRECCCI EQU   ZCRENTER+16
ZCRECCAI EQU   ZCRENTER+16
ZCRECCBI EQU   ZCRENTER+16
ZCREBCAR EQU   ZCRENTER+16
ZCREBCDR EQU   ZCRENTER+16
ZCREBCBR EQU   ZCRENTER+15
ZCREDCXR EQU   ZCRENTER+15
ZCREDCWB EQU   ZCRENTER+15
ZCREDCWR EQU   ZCRENTER+15
ZCREKCCN EQU   ZCRENTER+15
ZCREKCBN EQU   ZCRENTER+15
ZCREKCBB EQU   ZCRENTER+15
ZCREJC0B EQU   ZCRENTER+15
ZCREJCDB EQU   ZCRENTER+14
ZCREJCCB EQU   ZCRENTER+14
ZCREJCBB EQU   ZCRENTER+14
ZCREJCAB EQU   ZCRENTER+14
ZCREIC1B EQU   ZCRENTER+14
ZCREIC0B EQU   ZCRENTER+14
ZCREICX0 EQU   ZCRENTER+14
ZCREICWB EQU   ZCRENTER+14
ZCREICVB EQU   ZCRENTER+13
ZCREICUB EQU   ZCRENTER+13
ZCREICTB EQU   ZCRENTER+13
ZCREICSC EQU   ZCRENTER+13
ZCREICSB EQU   ZCRENTER+13
ZCREICRB EQU   ZCRENTER+13
ZCREICQB EQU   ZCRENTER+13
ZCREICQA EQU   ZCRENTER+13
ZCREICOB EQU   ZCRENTER+12
ZCREICOA EQU   ZCRENTER+12
ZCREICNB EQU   ZCRENTER+12
ZCREICNA EQU   ZCRENTER+12
ZCREICMB EQU   ZCRENTER+12
ZCREICLB EQU   ZCRENTER+12
ZCREICKG EQU   ZCRENTER+12
ZCREICKE EQU   ZCRENTER+12
ZCREICKB EQU   ZCRENTER+11
ZCREICJB EQU   ZCRENTER+11
ZCREICID EQU   ZCRENTER+11
ZCREICIB EQU   ZCRENTER+11
ZCREICHB EQU   ZCRENTER+11
ZCREICGB EQU   ZCRENTER+11
ZCREICEB EQU   ZCRENTER+11
ZCREICDB EQU   ZCRENTER+11
ZCREICCI EQU   ZCRENTER+10
ZCREICCB EQU   ZCRENTER+10
ZCREICBI EQU   ZCRENTER+10
ZCREICBB EQU   ZCRENTER+10
ZCREICAB EQU   ZCRENTER+10
ZCREICAA EQU   ZCRENTER+10
ZCREHCAN EQU   ZCRENTER+10
ZCREGC0B EQU   ZCRENTER+10
ZCREGC0A EQU   ZCRENTER+9
ZCREGCLA EQU   ZCRENTER+9
ZCREGCEB EQU   ZCRENTER+9
ZCREGCDB EQU   ZCRENTER+9
@NM00148 EQU   ZCRENTER+9
ZCREGCBB EQU   ZCRENTER+9
ZCREGCAB EQU   ZCRENTER+9
ZCREFCEB EQU   ZCRENTER+9
ZCREFCEA EQU   ZCRENTER+8
ZCREECTA EQU   ZCRENTER+8
ZCREECEA EQU   ZCRENTER+8
ZCREECDA EQU   ZCRENTER+8
ZCREECCB EQU   ZCRENTER+8
ZCREECCA EQU   ZCRENTER+8
ZCREECBB EQU   ZCRENTER+8
ZCREECBA EQU   ZCRENTER+8
ZCREDCMB EQU   ZCRENTER+7
ZCREDCL0 EQU   ZCRENTER+7
ZCREDCKB EQU   ZCRENTER+7
ZCREDCKA EQU   ZCRENTER+7
ZCREDCJ0 EQU   ZCRENTER+7
ZCREDCI0 EQU   ZCRENTER+7
ZCREDCH0 EQU   ZCRENTER+7
ZCREDCF0 EQU   ZCRENTER+7
ZCREDCE0 EQU   ZCRENTER+6
ZCREDCD0 EQU   ZCRENTER+6
ZCREDCC0 EQU   ZCRENTER+6
ZCREDCB0 EQU   ZCRENTER+6
ZCREDCA0 EQU   ZCRENTER+6
ZCRECC2B EQU   ZCRENTER+6
ZCRECC1B EQU   ZCRENTER+6
ZCRECC1A EQU   ZCRENTER+6
ZCRECC0B EQU   ZCRENTER+5
ZCRECC0A EQU   ZCRENTER+5
ZCREBC0B EQU   ZCRENTER+5
ZCREBC0A EQU   ZCRENTER+5
ZCREBCZ0 EQU   ZCRENTER+5
ZCREBCY0 EQU   ZCRENTER+5
ZCREBCX0 EQU   ZCRENTER+5
ZCREBCXA EQU   ZCRENTER+5
ZCREBCSC EQU   ZCRENTER+4
ZCREBCRB EQU   ZCRENTER+4
ZCREBCRA EQU   ZCRENTER+4
ZCREBCQB EQU   ZCRENTER+4
ZCREBCPB EQU   ZCRENTER+4
ZCREBCOB EQU   ZCRENTER+4
ZCREBCNE EQU   ZCRENTER+4
ZCREBCND EQU   ZCRENTER+4
ZCREBCMB EQU   ZCRENTER+3
ZCREBCLB EQU   ZCRENTER+3
ZCREBCLA EQU   ZCRENTER+3
ZCREBCKB EQU   ZCRENTER+3
ZCREBCKA EQU   ZCRENTER+3
ZCREBCJB EQU   ZCRENTER+3
ZCREBCJA EQU   ZCRENTER+3
ZCREBCID EQU   ZCRENTER+3
ZCREBCIB EQU   ZCRENTER+2
ZCREBCIA EQU   ZCRENTER+2
ZCREBCHB EQU   ZCRENTER+2
ZCREBCHA EQU   ZCRENTER+2
ZCREBCGB EQU   ZCRENTER+2
ZCREBCGA EQU   ZCRENTER+2
ZCREBCFB EQU   ZCRENTER+2
ZCREBCFA EQU   ZCRENTER+2
ZCREBCEB EQU   ZCRENTER+1
ZCREBCDI EQU   ZCRENTER+1
ZCREBCCB EQU   ZCRENTER+1
ZCREBCBI EQU   ZCRENTER+1
ZCREBCBB EQU   ZCRENTER+1
ZCREBCBA EQU   ZCRENTER+1
ZCREBCAM EQU   ZCRENTER+1
ZCREBCAI EQU   ZCRENTER+1
ZCREBCAG EQU   ZCRENTER
ZCREBCAE EQU   ZCRENTER
ZCREBCAB EQU   ZCRENTER
ZCREBCAA EQU   ZCRENTER
ZCREAC1B EQU   ZCRENTER
ZCREAC0B EQU   ZCRENTER
ZCREAC0A EQU   ZCRENTER
ZCREAC1A EQU   ZCRENTER
ZCRTNAME EQU   ZCRAUDIT+1
ZCRTID   EQU   ZCRAUDIT
ZCRREMIC EQU   ISTZCRR+436
ZCRSAVEZ EQU   ISTZCRR+196
ZCRDAFSV EQU   ZCRCIDSV+2
ZCRSAFSV EQU   ZCRCIDSV
ZCRR13SV EQU   ISTZCRR+188
ZCRR2SV  EQU   ISTZCRR+184
ZCROPCDE EQU   ISTZCRR+183
ZCRPRMTC EQU   ISTZCRR+182
ZCRRCDSV EQU   ISTZCRR+181
ZCRAWQSW EQU   ISTZCRR+180
ZCRTOPQ  EQU   ISTZCRR+180
ZCRLSTFB EQU   ISTZCRR+180
ZCRXSCHD EQU   ISTZCRR+180
ZCRNXTEL EQU   ISTZCRR+180
ZCRSCANQ EQU   ISTZCRR+180
ZCRMOREL EQU   ISTZCRR+180
ZCRFBPRC EQU   ISTZCRR+180
ZCRFSBSV EQU   ISTZCRR+176
ZCRSVWK5 EQU   ZCRWKARA+16
ZCRSVWK4 EQU   ZCRWKARA+12
ZCRSVWK3 EQU   ZCRWKARA+8
ZCRSVWK2 EQU   ZCRWKARA+4
ZCRSVWK1 EQU   ZCRWKARA
ZCRSVF25 EQU   ZCRSVRTN+96
ZCRSVF24 EQU   ZCRSVRTN+92
ZCRSVF23 EQU   ZCRSVRTN+88
ZCRSVF22 EQU   ZCRSVRTN+84
ZCRSVF21 EQU   ZCRSVRTN+80
ZCRSVF20 EQU   ZCRSVRTN+76
ZCRSVF19 EQU   ZCRSVRTN+72
ZCRSVF18 EQU   ZCRSVRTN+68
ZCRSVF17 EQU   ZCRSVRTN+64
ZCRSVF16 EQU   ZCRSVRTN+60
ZCRSVF15 EQU   ZCRSVRTN+56
ZCRSVF14 EQU   ZCRSVRTN+52
ZCRSVF13 EQU   ZCRSVRTN+48
ZCRSVF12 EQU   ZCRSVRTN+44
ZCRSVF11 EQU   ZCRSVRTN+40
ZCRSVF10 EQU   ZCRSVRTN+36
ZCRSVF9  EQU   ZCRSVRTN+32
ZCRSVF8  EQU   ZCRSVRTN+28
ZCRSVF7  EQU   ZCRSVRTN+24
ZCRSVF6  EQU   ZCRSVRTN+20
ZCRSVF5  EQU   ZCRSVRTN+16
ZCRSVF4  EQU   ZCRSVRTN+12
ZCRSVF3  EQU   ZCRSVRTN+8
ZCRSVF2  EQU   ZCRSVRTN+4
ZCRSVF1  EQU   ZCRSVRTN
ZCRPVZB  EQU   ISTZCRR+52
ZCRZLB   EQU   ISTZCRR+48
ZCRBFPTR EQU   ISTZCRR+44
ZCRCCWA  EQU   ISTZCRR+40
ZCRPSW   EQU   ZCRPARMS+15
ZCRPCHAR EQU   ZCRPARMS+14
ZCRPRES2 EQU   ZCRPCOD2
ZCRPMFGF EQU   ZCRPCOD2
ZCRPFHDR EQU   ZCRPCOD2
ZCRPPG2  EQU   ZCRPCOD2
ZCRPRES  EQU   ZCRPCOD1
ZCRPCFTX EQU   ZCRPCOD1
ZCRPBUF  EQU   ZCRPCOD1
ZCRPLSCB EQU   ZCRPCOD1
ZCRPLSBQ EQU   ZCRPLSBF
ZCRPFSB  EQU   ZCRPCOD1
ZCRPLNG  EQU   ZCRPCOD1
ZCRPPG   EQU   ZCRPCOD1
ZCRDTODA EQU   ZCRDFRDA
ZCRMLNG  EQU   ZCRPARMS+8
ZCRTBPTR EQU   ZCRPARMS+4
ZCRCBPTR EQU   ZCRFBPTR
ZCRCRLCP EQU   ISTZCRR+20
@NM00147 EQU   ZCRSCPSW
ZCRSKIPT EQU   ZCRSCPSW
ZCRFSBWE EQU   ZCRSCPSW
ZCRPRCMP EQU   ZCRSCPSW
ZCRLREQ  EQU   ZCRSCPSW
ZCRRJLCP EQU   ZCRSCPSW
ZCRTPINV EQU   ZCRSCPSW
ZCRTPEX  EQU   ZCRSCPSW
@NM00146 EQU   ZCRIBPR
ZCR3270R EQU   ZCRIBPR
ZCR3270  EQU   ZCRIBPR
ZCRLCPFD EQU   ZCRIBPR
ZCRLCPFR EQU   ZCRIBPR
ZCRRELK  EQU   ZCRIBPR
ZCRERR   EQU   ZCRIBPR
ZCRNOBUF EQU   ZCRIBPR
@NM00145 EQU   ZCRPFLGS
ZCRQAHED EQU   ZCRPFLGS
ZCRF1RES EQU   ZCRGENSW
ZCRBRIS  EQU   ZCRGENSW
ZCRCLRBD EQU   ZCRGENSW
ZCREXRES EQU   ZCRGENSW
ZCRLCSYN EQU   ZCRGENSW
ZCRRT06  EQU   ZCRGENSW
ZCRTSW2  EQU   ZCRGENSW
ZCRTSW1  EQU   ZCRGENSW
ZCRINLCP EQU   ZCRFLGS3
ZCRWRPTR EQU   ZCRFLGS3
ZCRNOFRE EQU   ZCRFLGS3
ZCREDRIV EQU   ZCRFLGS3
ZCRDISC  EQU   ZCRFLGS3
ZCRTPDIS EQU   ZCRFLGS3
ZCRTPCON EQU   ZCRFLGS3
ZCRTIC   EQU   ZCRFLGS3
ZCRCNLXL EQU   ZCRRESET
ZCRENDAN EQU   ZCRSWFLD
ZCRENDXL EQU   ZCRSWFLD
ZCRENDX  EQU   ZCRSWFLD
ZCROB1   EQU   ZCRNDLCP
ZCRENDPR EQU   ZCRSWFLD
ZCREXTYP EQU   ZCRSWFLD
ZCRSLCP  EQU   ZCRENDSH
ZCRIF0E3 EQU   ZCRFLGS2
ZCRIF0E2 EQU   ZCRFLGS2
ZCRIF0E1 EQU   ZCRFLGS2
ZCROB    EQU   ZCRFLGS2
ZCRFMSED EQU   ZCRFLGS2
ZCRSHEDI EQU   ZCRFLGS2
ZCRLOCAL EQU   ZCRFLGS2
ZCRFEXIT EQU   ZCRFLGS1
ZCRUNSOL EQU   ZCRFLGS1
ZCRENDLP EQU   ZCRFLGS1
ZCRNRMEX EQU   ZCRFLGS1
ZCRWAIT  EQU   ZCRFLGS1
ZCRDEQSW EQU   ZCRFLGS1
ZCRQUESW EQU   ZCRFLGS1
ZCREXSW  EQU   ZCRFLGS1
ZCRFRRA  EQU   ISTZCRR+8
ZCRCHAIN EQU   ISTZCRR+4
ZCRFLAG  EQU   ZCRCRR+3
ZCRLEN   EQU   ZCRCRR+1
ZCRID    EQU   ZCRCRR
CCFRSVD1 EQU   CFCCRT
CCFCR2   EQU   CFCCRT
CCFCRP   EQU   CFCCRT
CCFCR1   EQU   CFCCRT
CCFCS2   EQU   CFCCRT
CCFCS1   EQU   CFCCRT
NCFRSVD  EQU   CFCNTRD
NCFCR2   EQU   CFCNTRD
NCFCRP   EQU   CFCNTRD
NCFCR1   EQU   CFCNTRD
NCFCS2   EQU   CFCNTRD
NCFCS1   EQU   CFCNTRD
PFCRSV01 EQU   ISTPFCRR+13
PFCFTA   EQU   ISTPFCRR+12
CRRFRR   EQU   PFCFRRO
CRRCHAIN EQU   PFCCRRO
CRRLEN   EQU   PFCCRRLN
PFCRSV10 EQU   PFCCRR+1
CRRID    EQU   PFCCRRID
ZSAZTRAC EQU   ISTZSAVE+36
ZSAZSVVR EQU   ISTZSAVE+12
ZSAZSVRR EQU   ISTZSAVE+8
ZSAZSVFC EQU   ISTZSAVE+4
ZSAZACTV EQU   ZSAZSVMS
SORTSAF  EQU   SORTCID
@NM00106 EQU   ACEFLAGS
ACETAKER EQU   ACEFLAGS
ACEPREMR EQU   ACEFLAGS
ACETAKEN EQU   ACEFLAGS
ACEPREMD EQU   ACEFLAGS
ACESUBJQ EQU   ISTACE+8
ACEOBJ   EQU   ISTACE+4
ACESUBJ  EQU   ISTACE
ICERSC2B EQU   ISTICE+36
ICEUECBX EQU   ISTICE+32
@NM00105 EQU   ISTICE+29
@NM00104 EQU   ICEFLAGS
ICESTAPR EQU   ICEFLAGS
ICERSC2F EQU   ICEFLAGS
ICELGON  EQU   ICEFLAGS
ICEICX   EQU   ICEFLAGS
ICESPEC  EQU   ICEFLAGS
ICERPHA  EQU   ISTICE+24
ICEDATA  EQU   ISTICE+20
ICESIDE  EQU   ISTICE+16
ICEOBJQ  EQU   ISTICE+12
ICESUBJQ EQU   ISTICE+8
ICEOBJ   EQU   ISTICE+4
ICESUBJ  EQU   ISTICE
FMCFLRSV EQU   FMCFLGB
FMCFLGA8 EQU   FMCFLGB
FMCCLRPH EQU   FMCVS1+45
FMCRSV0X EQU   FMCCVFLG
FMCVYRPH EQU   FMCCVFLG
FMCZV004 EQU   FMCVS1+40
FMCLOCK2 EQU   FMCVS1+36
@NM00103 EQU   FMCZFLG2
FMCZF027 EQU   FMCZFLG2
FMCZF026 EQU   FMCZFLG2
FMCSEQ1B EQU   FMCSEQ1
FMCSEQ1T EQU   FMCSEQ1
FMCZX006 EQU   FMCVS1+33
FMCZX005 EQU   FMCVS1+32
FMCZX004 EQU   FMCVS1+31
FMCZX003 EQU   FMCVS1+30
FMCZX002 EQU   FMCVS1+29
FMCZX001 EQU   FMCVS1+28
FMCZV001 EQU   FMCVS1+24
FMCAWATQ EQU   FMCLCPAQ+1
@NM00102 EQU   FMCLCPAQ
FMCLCPB2 EQU   FMCLCPBQ+1
FMCLCPB1 EQU   FMCLCPBQ
FMCASCDQ EQU   FMCSHEAQ+1
@NM00101 EQU   FMCSHEAQ
FMCSHEDQ EQU   FMCVS1+8
FMCZFCSQ EQU   FMCVS1+6
FMCZH001 EQU   FMCVS1+4
FMCZF025 EQU   FMCZFLAG+3
FMCZF024 EQU   FMCZFLAG+3
FMCZF023 EQU   FMCZFLAG+3
FMCZF022 EQU   FMCZFLAG+3
FMCZF021 EQU   FMCZFLAG+3
FMCZF020 EQU   FMCZFLAG+3
FMCZF019 EQU   FMCZFLAG+3
FMCZF018 EQU   FMCZFLAG+3
FMCZF017 EQU   FMCZFLAG+2
FMCZF016 EQU   FMCZFLAG+2
FMCZF015 EQU   FMCZFLAG+2
FMCZF014 EQU   FMCZFLAG+2
FMCZF013 EQU   FMCZFLAG+2
FMCZF012 EQU   FMCZFLAG+2
FMCZF011 EQU   FMCZFLAG+2
FMCZF010 EQU   FMCZFLAG+2
FMCZF00F EQU   FMCZFLAG+1
FMCZF00E EQU   FMCZFLAG+1
FMCZF00D EQU   FMCZFLAG+1
FMCZF00C EQU   FMCZFLAG+1
FMCZF00B EQU   FMCZFLAG+1
FMCRSV10 EQU   FMCZFLAG+1
FMCZF009 EQU   FMCZFLAG+1
FMCZFD06 EQU   FMCZF006+1
FMCZFC06 EQU   FMCZF006
FMCZFB06 EQU   FMCZF006
FMCZFA06 EQU   FMCZF006
FMCZF005 EQU   FMCZFLAG
FMCZF004 EQU   FMCZFLAG
FMCZF003 EQU   FMCZFLAG
FMCZF002 EQU   FMCZFLAG
FMCZF001 EQU   FMCZFLAG
FMCFRESA EQU   ISTFMCB+228
FMCSCSQN EQU   FMCSNCTL+2
FMCSCCTL EQU   FMCSNCTL+1
FMCSCCLO EQU   FMCSCFLG
FMCAPRO  EQU   FMCSCFLG
FMCLURO  EQU   FMCSCFLG
FMCOBSAC EQU   FMCSCFLG
FMCIBSAC EQU   FMCSCFLG
FMCFBRE  EQU   ISTFMCB+220
FMCFBXM  EQU   FMCZV002
FMCASEGQ EQU   ISTFMCB+212
FMCRDTPT EQU   ISTFMCB+208
FMCLOCK  EQU   ISTFMCB+204
FMCSEGD  EQU   FMCSSEGQ
FMCRSPLM EQU   ISTFMCB+198
FMCPSTRS EQU   ISTFMCB+196
@NM00100 EQU   FMCRRESP
FMCTSLHA EQU   FMCRRESP
FMCFRRN  EQU   FMCRRESP
FMCFME   EQU   FMCRRESP
FMCFEX   EQU   FMCRRESP
FMCFPE   EQU   FMCRRESP
FMCCTLB  EQU   ISTFMCB+194
FMCBSQNO EQU   FMCCLSEQ+2
FMCTSQNO EQU   FMCCLSEQ
FMCOBPRG EQU   FMCMODEB
FMCIBPRG EQU   FMCMODEB
FMCRESOT EQU   FMCMODEB
FMCRSTSR EQU   FMCMODEB
FMCLUQ   EQU   FMCMODEB
FMCAPQ   EQU   FMCMODEB
FMCCLEAR EQU   FMCMODEB
FMCHOLD  EQU   FMCMODEB
FMCIPSEQ EQU   ISTFMCB+188
FMCLUSTR EQU   ISTFMCB+187
FMCRSV87 EQU   FMCSTAT2
FMCSEQI  EQU   FMCSTAT2
FMCALIPR EQU   FMCSTAT2
FMCIAIO  EQU   FMCSTAT2
FMCZF00A EQU   FMCSTAT2
FMCVPIP  EQU   FMCSTAT2
FMCBHSET EQU   ISTFMCB+185
FMCPRMRC EQU   FMCCLEXT+20
FMCRSV89 EQU   FMCPSTAT
FMCPCLSD EQU   FMCPSTAT
FMCDDOCD EQU   FMCPSTAT
FMCIDVFD EQU   FMCPSTAT
FMCELKST EQU   FMCPSTAT
FMCRSV88 EQU   FMCPSCMD
FMCRDBLK EQU   FMCPSCMD
FMCDSEOC EQU   FMCPSCMD
FMCPURGE EQU   FMCPSCMD
FMCRESTI EQU   FMCPSCMD
FMCCNTCT EQU   FMCPSCMD
FMCINVT  EQU   FMCPSCMD
FMCFLGB7 EQU   FMCFLGCL
FMCFLGB6 EQU   FMCFLGCL
FMCFLGB5 EQU   FMCFLGCL
FMCFLGB4 EQU   FMCFLGCL
FMCFLGB3 EQU   FMCFLGCL
FMCFLGB2 EQU   FMCFLGCL
FMCFLGB1 EQU   FMCFLGCL
FMCFLGB0 EQU   FMCFLGCL
FMCFLGA7 EQU   FMCFLGA
FMCFLGA6 EQU   FMCFLGA
FMCFLGA5 EQU   FMCFLGA
FMCFLGA4 EQU   FMCFLGA
FMCFLGA3 EQU   FMCFLGA
FMCFLGA2 EQU   FMCFLGA
FMCFLGA1 EQU   FMCFLGA
FMCFLGA0 EQU   FMCFLGA
FMCDCLOK EQU   FMCCLEXT+12
FMCRAFM  EQU   FMCCLEXT+8
FMCFBPTR EQU   FMCFBA+1
FMCFBRSV EQU   FMCFBA
FMCRPLPT EQU   FMCRPLA+1
FMCRPLRS EQU   FMCRPLA
FMCPRCLS EQU   FMCCVAL
FMCIBCE  EQU   FMCCVAL
FMCONLY  EQU   FMCOBCE
FMCLAST  EQU   FMCOBCE
FMCMIDLE EQU   FMCOBCE
FMCFIRST EQU   FMCOBCE
FMCCPCNT EQU   FMCPACPC
FMCMPCNT EQU   FMCPACEM
FMCNPCNT EQU   FMCPACEN
FMCCONF  EQU   FMCSSTAT
FMCPURCH EQU   FMCSSTAT
FMCNSALU EQU   FMCSSTAT
FMCBIP   EQU   FMCSSTAT
FMCUIPI  EQU   FMCSSTAT
FMCCIPI  EQU   FMCSSTAT
FMCSNBI  EQU   FMCSSTAT
FMCRVD01 EQU   ISTFMCB+158
FMCISSN  EQU   ISTFMCB+156
FMCOASN  EQU   FMCNXOSC
FMCOSSN  EQU   FMCNXCFM
FMCSIP   EQU   FMCSIPA
FMCEXLST EQU   ISTFMCB+144
FMCPAB4  EQU   ISTFMCB+112
FMCPAB3  EQU   ISTFMCB+96
FMCPAB2  EQU   ISTFMCB+80
FMCFASYA EQU   ISTFMCB+60
FMCPROCD EQU   ISTFMCB+48
FMCVWT   EQU   ISTFMCB+44
FMCRPLH  EQU   ISTFMCB+40
FMCBUFNB EQU   FMCCMPS1+2
FMCBUFLM EQU   FMCCMPS1
FMCDEBA  EQU   ISTFMCB+32
@NM00099 EQU   FMCCMDFL
FMCSNA   EQU   FMCCMDFL
FMCVSNA  EQU   FMCCMDFL
@NM00098 EQU   ISTFMCB+30
@NM00097 EQU   FMCSTAT1
FMCLTCLS EQU   FMCSTAT1
FMCHPURG EQU   FMCSTAT1
FMCVSP2  EQU   FMCSTAT1
FMCVSP1  EQU   FMCSTAT
FMCLTEAS EQU   FMCSTAT
FMCZF007 EQU   FMCSTAT
FMCDEDSC EQU   FMCSTAT
FMCDAPT  EQU   FMCSTAT
FMCPRMTE EQU   FMCSTAT
FMCPRMTR EQU   FMCSTAT
FMCUSFLD EQU   ISTFMCB+24
FMCFMCBA EQU   ISTFMCB+20
FMCDNCBA EQU   ISTFMCB+16
FMCDVTA  EQU   ISTFMCB+12
FMCTSKID EQU   ISTFMCB+8
FMCNXTCB EQU   ISTFMCB+4
FMCLNGTH EQU   ISTFMCB+1
FMCTYPE  EQU   ISTFMCB
PATRSV01 EQU   PATFLAGA
PATUSEFG EQU   PATFLAGA
PATRDCNT EQU   ISTPAT+6
PATGRPID EQU   ISTPAT+5
PATPTHID EQU   ISTPAT+4
PATDINDX EQU   ISTPAT+2
PATGINDX EQU   ISTPAT
GNTGRPNM EQU   ISTGNT
DNTTELNO EQU   ISTDNT+1
DNTCTDIG EQU   ISTDNT
RLSRSV02 EQU   ISTRLS+140
RLSRSV01 EQU   ISTRLS+138
RLSCTELU EQU   ISTRLS+136
RLSPRE   EQU   ISTRLS
RDARSVPT EQU   ISTRDA+84
RDAPUBI  EQU   ISTRDA+83
RDADFCUA EQU   ISTRDA+80
RDACTPCC EQU   ISTRDA+79
RDADACUA EQU   ISTRDA+76
RDALUBA  EQU   RDAUCBAD+1
RDACHQI  EQU   RDAUCBAD
RDARSV01 EQU   RDAFLAG
RDARBISA EQU   RDAFLAG
RDAPRE   EQU   ISTRDA
RSWRSV01 EQU   ISTRSW+152
RSWRSV02 EQU   ISTRSW+150
RSWCTELU EQU   ISTRSW+148
RSWGRUPZ EQU   ISTRSW+146
RSWDIALZ EQU   ISTRSW+144
RSWGRUPT EQU   ISTRSW+140
RSWDIALT EQU   ISTRSW+136
RSWPRE   EQU   ISTRSW
RLXRSV03 EQU   ISTRLX+80
RLXRSV02 EQU   ISTRLX+77
RLXRSV01 EQU   RLXFLAGA
RLXINUSE EQU   RLXFLAGA
RLXNLUX  EQU   ISTRLX+72
RLXPRE   EQU   ISTRLX
RPXRSV01 EQU   ISTRPX+80
RPXRSV02 EQU   ISTRPX+77
RPXMAXLU EQU   ISTRPX+76
RPXFLUX  EQU   ISTRPX+72
RPXPRE   EQU   ISTRPX
RLURSV02 EQU   ISTRLU+172
RLUMODEP EQU   RLUMODET+8
RLUMODEN EQU   RLUMODET
RLUUSSPT EQU   RLUUSSTB+8
RLUUSSNM EQU   RLUUSSTB
RLURSV01 EQU   ISTRLU+137
RLULOCAD EQU   ISTRLU+136
RLUNCPPM EQU   RLUNCPPC+1
RLUPACEM EQU   RLUPACE+1
RLUINTA  EQU   ISTRLU+128
RLUSSCFM EQU   ISTRLU+127
RLUCRRSV EQU   RLUCRFLG
RLUACTLU EQU   RLUCRFLG
RLURSV00 EQU   RLUFLAG
RLUNDSES EQU   RLUFLAG
RLUGSTAT EQU   RLUFLAG
RLUBATCH EQU   RLUFLAG
RLURBISA EQU   RLUFLAG
RLUTYPE  EQU   ISTRLU+124
RLUCRPR  EQU   ISTRLU
RCCRVPT2 EQU   ISTRCC+144
RCCXTOSW EQU   ISTRCC+140
RCCSWTOX EQU   ISTRCC+136
RCCRSPT2 EQU   ISTRCC+133
RCCADDR  EQU   ISTRCC+132
RCCPASSL EQU   ISTRCC+131
RCCMXOUT EQU   ISTRCC+130
RCCMXDAT EQU   ISTRCC+128
RCCINDEX EQU   ISTRCC+126
RCCPATHZ EQU   ISTRCC+124
RCCPATHT EQU   ISTRCC+120
RCCDPQ   EQU   ISTRCC+116
RCCTPAB  EQU   ISTRCC+112
RCCRSV02 EQU   ISTRCC+109
RCCCRRSV EQU   RCCCRFLG
RCCCTCFL EQU   RCCCRFLG
RCCACTPU EQU   RCCCRFLG
RCCNCSPL EQU   ISTRCC+104
RCCRPHCN EQU   ISTRCC+100
RCCEPAB  EQU   ISTRCC+96
RCCDPAB  EQU   ISTRCC+92
@NM00096 EQU   ISTRCC+87
RCCSESCT EQU   ISTRCC+86
RCCIDNUM EQU   RCCID48+3
RCCIDBLK EQU   RCCID48+2
RCCIDPA2 EQU   RCCID48+1
RCCIDPUT EQU   RCCID48
RCCIDPA1 EQU   RCCSTAID
RCCCTELU EQU   ISTRCC+76
RCCCNCNT EQU   ISTRCC+75
RCCRTGOH EQU   RCCFLAGB
RCCBRKCN EQU   RCCFLAGB
RCCFINAL EQU   RCCFLAGB
RCCBNNSP EQU   RCCFLAGB
RCCIRETR EQU   RCCFLAGB
RCCDIALP EQU   RCCFLAGB
RCCDSTCT EQU   RCCFLAGB
RCCCTPGD EQU   RCCFLAG
RCCPRGDN EQU   RCCFLAG
RCCOUERP EQU   RCCFLAG
RCCOHIMM EQU   RCCFLAG
RCCLDISC EQU   RCCFLAG
RCCERPIP EQU   RCCFLAG
RCCCUDIE EQU   RCCFLAG
RCCRBISA EQU   RCCFLAG
RCCTYPE  EQU   ISTRCC+72
RCCPRE   EQU   ISTRCC
DOTADTRM EQU   ISTDOT
RDSADDOT EQU   ISTRDS+76
RDSCTATR EQU   ISTRDS+74
RDSCTTRM EQU   ISTRDS+72
RDSPRE   EQU   ISTRDS
RINRSV05 EQU   ISTRIN+156
RINRSV04 EQU   ISTRIN+152
RINLOCRN EQU   ISTRIN+148
RINRSV02 EQU   ISTRIN+145
RTRCNCNT EQU   RINCNCNT
RTRNCSPL EQU   RINNCSPL
RTRRPHCN EQU   RINRPHCN
RTRVPAB  EQU   RINVPAB
RTRREMOT EQU   RINREMOT
RTRRLDAF EQU   RINRLDAF
RTRNODID EQU   RINNODID
RINRSV01 EQU   RINDFD
RTRLDISC EQU   RINLDISC
RTRNODEF EQU   RINNODEF
RTRREMPO EQU   RINREMPO
RINCRPRE EQU   ISTRIN
RTRRSV04 EQU   ISTRTR+210
RTRLCTI  EQU   ISTRTR+209
RTRIDCAS EQU   RTRBSCID+1
RTRIDLEN EQU   RTRBSCID
RTRRSVDD EQU   ISTRTR+181
RTRRDFG  EQU   ISTRTR+180
RTRDIAA  EQU   ISTRTR+176
RTRPOLA  EQU   ISTRTR+172
RTRCADDR EQU   ISTRTR+164
RTRCTADR EQU   ISTRTR+162
RTRCTPOL EQU   ISTRTR+160
RTRCTDIA EQU   ISTRTR+158
RTRRSV03 EQU   ISTRTR+156
RTRRVPT1 EQU   ISTRTR+152
RTRBHSN1 EQU   ISTRTR+144
RTRCRSV2 EQU   RTRCRFLG
RTRDTRLM EQU   RTRLSCMD
RTRCRSV1 EQU   RTRCRFLG
RTRTRMAX EQU   ISTRTR+142
RTRRSV24 EQU   RTRRDFF
RTRRFDEK EQU   RTRRDFF
RTRRFANK EQU   RTRRDFF
RTRRFPFK EQU   RTRRDFF
RTRRFPEN EQU   RTRRDFF
RTRRFXCT EQU   RTRRDFF
RTRRESCT EQU   RTRRDFE
RTRRESUP EQU   RTRRDFE
RTRREATT EQU   RTRRDFE
RTRRECHK EQU   RTRRDFE
RTRREACR EQU   RTRRDFE
RTRRSV0A EQU   RTRRDFE
RTRREBRK EQU   RTRRDFE
RTRRSV11 EQU   RTRRDFD
RTRRSV10 EQU   RTRRDFD
RTRRDBHI EQU   RTRRDFD
RTRRDBHD EQU   RTRRDFD
RTRRDBHN EQU   RTRRDFD
RTRRSV23 EQU   RTRRDFC
RTRRCXMS EQU   RTRRDFC
RTRRCMSG EQU   RTRRDFC
RTRRCBLK EQU   RTRRDFC
RTRRCPT3 EQU   RTRRDFC
RTRRCIT2 EQU   RTRRDFC
RTRRCIT1 EQU   RTRRDFC
RTRRSV32 EQU   RTRRDFB
RTRRBEND EQU   RTRRDFB
RTRRBECT EQU   RTRRDFB
RTRRSV02 EQU   RTRRDFA
RTRRACTR EQU   RTRRDFA
RTRRSV60 EQU   RTRRDFA
RTRRACDT EQU   RTRRDFA
RTRRAPT3 EQU   RTRRAALL
RTRRAPT2 EQU   RTRRAALL
RTRRAPT1 EQU   RTRRAALL
RTRRAATN EQU   RTRRDFA
RTRRSV45 EQU   ISTRTR+132
RTRRSV01 EQU   ISTRTR+130
RTRCTECM EQU   ISTRTR+128
RTRADRPT EQU   RTRADR+1
RTRRSV22 EQU   RTRFLAG
RTRVTERM EQU   RTRFLAG
RTRRSV51 EQU   RTRFLAG
RTRRBISA EQU   RTRFLAG
RTRRSV21 EQU   RTRFLAG
RTRCRPR  EQU   ISTRTR
RCLRVPT2 EQU   ISTRCL+92
RCLRVPT1 EQU   ISTRCL+88
RCLGPOLA EQU   ISTRCL+84
RCLCTNGP EQU   ISTRCL+82
RCLRSV01 EQU   ISTRCL+80
RCLCTECM EQU   ISTRCL+78
RCLCTETR EQU   ISTRCL+76
RCLGPADR EQU   RCLADR+1
RCLRSV33 EQU   RCLFLAG
RCLBATCH EQU   RCLFLAG
RCLRBISA EQU   RCLFLAG
RCLRSV22 EQU   RCLFLAG
RCLPRE   EQU   ISTRCL
RPTRSV03 EQU   ISTRPT+156
RPTRSV02 EQU   ISTRPT+152
RPTNSNSV EQU   ISTRPT+148
RPTPTHCT EQU   ISTRPT+146
RPTPEPCT EQU   ISTRPT+144
RPTDAFSV EQU   ISTRPT+142
RPTRSV01 EQU   ISTRPT+141
RPTISTAT EQU   RPTFLAG1
RPTDYNAM EQU   RPTFLAG1
RPTVYIMM EQU   RPTFLAG1
RPTVIODN EQU   RPTFLAG1
RPTONLIN EQU   RPTFLAG1
RPTHLVPD EQU   RPTFLAG1
RPTVRYPD EQU   RPTFLAG1
RPTASLEP EQU   RPTFLAG1
RPTUTERM EQU   ISTRPT+136
RPTATERM EQU   ISTRPT+132
RPTDIVT  EQU   RPTDITT
RPTCTNM  EQU   ISTRPT+120
RPTLNDAF EQU   RPTLNCID+2
RPTLNSAF EQU   RPTLNCID
RPTLN    EQU   ISTRPT
RLNRVPT2 EQU   ISTRLN+112
RLNNCSPL EQU   ISTRLN+108
RLNX2SW  EQU   ISTRLN+104
@NM00095 EQU   ISTRLN+103
RLNCRRSV EQU   RLNCRFLG
RLNSWEP  EQU   RLNCRFLG
RLNSVSKP EQU   RLNLSCMD
RLNSESLM EQU   RLNLSCMD
RLNNPRLM EQU   RLNLSCMD
RLNSWNCP EQU   RLNCRFLG
RLNACTLN EQU   RLNCRFLG
RLNPAUSE EQU   ISTRLN+101
RLNPOLMT EQU   ISTRLN+100
RLNACTSN EQU   ISTRLN+98
RLNRESV1 EQU   ISTRLN+97
RLNACTRM EQU   ISTRLN+96
RLNCTSES EQU   ISTRLN+95
RLNRDSLM EQU   ISTRLN+94
RLNAUTOA EQU   ISTRLN+92
RLNRDFD  EQU   RLNRDF+3
RLNRDFC  EQU   RLNRDF+2
RLNMULTP EQU   RLNRDFB
RLNRATRN EQU   RLNRDFB
RLNRAPOL EQU   RLNRDFB
RLNTTV   EQU   RLNRDFB
RLNRSV0B EQU   RLNRDFB
RLNAUTOD EQU   RLNRDFB
RLNANSWR EQU   RLNRDFB
RLNRBUSE EQU   RLNRDFB
RLNRAPEP EQU   RLNRDFA
RLNRANCP EQU   RLNRDFA
RLNRAEP  EQU   RLNRDFA
RLNIDV   EQU   RLNRDFA
RLNGANSW EQU   RLNRDFA
RLNRACAN EQU   RLNRACNT
RLNRACAT EQU   RLNRACNT
RLNRSV04 EQU   RLNSTAT2
RLNINUSE EQU   RLNSTAT2
RLNOHIN  EQU   RLNSTAT2
RLNRSV03 EQU   RLNSTAT1
RLNVD    EQU   RLNSTAT1
RLNINOPP EQU   RLNSTAT1
RLNINOPL EQU   RLNSTAT1
RLNLRST  EQU   RLNSTAT1
RLNTRAP  EQU   RLNSTAT1
RLNACTCT EQU   ISTRLN+84
RLNCTECM EQU   ISTRLN+82
RLNCTEIN EQU   ISTRLN+80
RLNCTETR EQU   ISTRLN+78
RLNCTECL EQU   ISTRLN+76
RLNCUA   EQU   RLNUCBAD
RLNRSV01 EQU   RLNFLAG
RLNRBISA EQU   RLNFLAG
RLNEAM   EQU   RLNFLAG
RLNPRE   EQU   ISTRLN
RGPRVPT2 EQU   ISTRGP+88
RGPRVPT1 EQU   ISTRGP+84
RGPCTECM EQU   ISTRGP+82
RGPCTEIN EQU   ISTRGP+80
RGPCTETR EQU   ISTRGP+78
RGPCTECL EQU   ISTRGP+76
RGPCTELN EQU   ISTRGP+74
RGPRSV03 EQU   ISTRGP+73
RGPRSV02 EQU   RGPFLG
RGPASDLC EQU   RGPFLG
RGPABSC  EQU   RGPFLG
RGPASS   EQU   RGPFLG
RGPADIL  EQU   RGPFLG
RGPPRE   EQU   ISTRGP
RRNRINNM EQU   ISTRRN+248
@NM00094 EQU   ISTRRN+247
RRNRDCUA EQU   ISTRRN+244
RRNLASTE EQU   ISTRRN+240
RRNNCSPL EQU   ISTRRN+236
RRNRPLPT EQU   ISTRRN+232
RRNMSIZE EQU   ISTRRN+228
RRNNCPNM EQU   ISTRRN+221
RRNCTPCC EQU   ISTRRN+220
RRNHBUFS EQU   ISTRRN+218
RRNHLENT EQU   RRNHPRE+1
RRNHLENH EQU   RRNHPRE
RRNNMNCP EQU   ISTRRN+208
RRNDELAY EQU   ISTRRN+206
RRNRSV04 EQU   ISTRRN+200
RRNRSV88 EQU   RRNNMDPD+7
RRNPUBI  EQU   RRNNMDPD+6
RRNDPLUB EQU   RRNNMDPD
RRNEPADR EQU   ISTRRN+190
RRNCPLUB EQU   ISTRRN+184
RRNFLUX  EQU   ISTRRN+180
RRNRSV05 EQU   RRNCMFD
RRNREMPO EQU   RRNCMFD
RRNCDREC EQU   RRNCMFD
RRNCDDSI EQU   RRNCMFD
RRNCDBCK EQU   RRNCMFD
RRNCDDTL EQU   RRNCMFD
RRNCDSTD EQU   RRNCMFD
RRNCDCSP EQU   RRNCMFD
RRNCCCSL EQU   RRNCMFC
RRNCCSIM EQU   RRNCMFC
RRNCCRCM EQU   RRNCMFC
RRNCCRIM EQU   RRNCMFC
RRNCCCRC EQU   RRNCMFC
RRNCCRST EQU   RRNCMFC
RRNCCRDQ EQU   RRNCMFC
RRNCCRCN EQU   RRNCMFC
RRNCBALT EQU   RRNCMFB
RRNCBMOD EQU   RRNCMFB
RRNCBNPL EQU   RRNCMFB
RRNCBRLS EQU   RRNCMFB
RRNCBRDS EQU   RRNCMFB
RRNCBDLR EQU   RRNCMFB
RRNCBDLH EQU   RRNCMFB
RRNCBDLO EQU   RRNCMFB
RRNCADGO EQU   RRNCMFA
RRNCADTD EQU   RRNCMFA
RRNCACDT EQU   RRNCMFA
RRNCAMBH EQU   RRNCMFA
RRNCAATI EQU   RRNCMFA
RRNCAATG EQU   RRNCMFA
RRNCAATD EQU   RRNCMFA
RRNCAALL EQU   RRNCMFA
RRNRSV55 EQU   RRNRDF+3
RRNPTASL EQU   RRNRDFB+1
RRNRSV01 EQU   RRNRDFB+1
RRNVYDON EQU   RRNRDFB+1
RRNRBBUP EQU   RRNRDFB+1
RRNRSV03 EQU   RRNRDFB
RRNRBCT2 EQU   RRNRDFB
RRNRBCT1 EQU   RRNRDFB
RRNRBSEC EQU   RRNRDFB
RRNRBCCT EQU   RRNRDFB
RRNRBCCL EQU   RRNRDFB
RRNRSV02 EQU   RRNRDFB
RRNRBMDL EQU   RRNRDFB
RRNRAPEP EQU   RRNRDFA
RRNRANCP EQU   RRNRDFA
RRNRBREM EQU   RRNRDFA
RRNRAOLT EQU   RRNRDFA
RRNRASYN EQU   RRNRDFA
RRNRADMP EQU   RRNRDFA
RRNRAIPL EQU   RRNRDFA
RRNRASHT EQU   RRNRDFA
RRNCTENT EQU   ISTRRN+170
RRNCTECM EQU   ISTRRN+168
RRNCTEIN EQU   ISTRRN+166
RRNCTETR EQU   ISTRRN+164
RRNCTECL EQU   ISTRRN+162
RRNCTELI EQU   ISTRRN+160
RRNCTEGP EQU   ISTRRN+158
RRNCTBHS EQU   ISTRRN+156
RRNBHSET EQU   ISTRRN+152
RRNTRENT EQU   ISTRRN+148
RRNRLDIP EQU   ISTRRN+147
RRNRNCUA EQU   ISTRRN+144
RRNGRPA  EQU   ISTRRN+140
RRNLUBA  EQU   RRNUCBAD+1
RRNCHQI  EQU   RRNUCBAD
RRNRSV11 EQU   RRNFLAG
RRNDSTCT EQU   RRNFLAG
RRNERPIP EQU   RRNFLAG
RRNLCDIP EQU   RRNFLAG
RRNLCDIE EQU   RRNFLAG
RRNLCSIP EQU   RRNFLAG
RRNRBISA EQU   RRNFLAG
RRNRSV89 EQU   RRNFLAG
RRNPRE   EQU   ISTRRN
RLCRVPT2 EQU   ISTRLC+80
RLCRVPT1 EQU   ISTRLC+79
RLCLCCUA EQU   ISTRLC+76
RLCUCBAD EQU   RLCADR+1
RLCRSVDE EQU   RLCFLAG
RLCACNT  EQU   RLCFLAG
RLCRSV14 EQU   RLCFLAG
RLCRBISA EQU   RLCFLAG
RLCRSV22 EQU   RLCFLAG
RLCPRE   EQU   ISTRLC
RAPRVPT2 EQU   ISTRAP+116
RAPRVPT1 EQU   ISTRAP+112
RAPBFACT EQU   ISTRAP+111
RAPRSV17 EQU   RAPFLGC
RAPRSV16 EQU   RAPFLGC
RAPRSV15 EQU   RAPFLGC
RAPRSV14 EQU   RAPFLGC
RAPRSV13 EQU   RAPFLGC
RAPRSV12 EQU   RAPFLGC
RAPRSV11 EQU   RAPFLGC
RAPRSV10 EQU   RAPFLGC
RAPANVPC EQU   RAPFLGB
RAPASPO  EQU   RAPFLGB
RAPAPPO  EQU   RAPFLGB
RAPAACQ  EQU   RAPFLGB
RAPAPRMT EQU   RAPFLGB
RAPAPASS EQU   RAPFLGB
RAPABLCK EQU   RAPFLGB
RAPRSV06 EQU   RAPFLG
RAPRSV05 EQU   RAPFLG
RAPRSV04 EQU   RAPFLG
RAPRSV03 EQU   RAPFLG
RAPATLGN EQU   RAPFLG
RAPASLGI EQU   RAPFLG
RAPAQUI  EQU   RAPFLG
RAPABLGN EQU   RAPFLG
RAPACEQD EQU   ISTRAP+106
RAPTRPRE EQU   ISTRAP+104
RAPACEAP EQU   ISTRAP+100
RAPICEAQ EQU   ISTRAP+96
RAPICEAC EQU   ISTRAP+92
RAPICELG EQU   ISTRAP+88
RAPAPPWD EQU   ISTRAP+80
RAPACDEB EQU   ISTRAP+76
RAPACBA  EQU   ISTRAP+72
RAPPRE   EQU   ISTRAP
RDTVSRPL EQU   ISTRDT+132
RDTCRSPW EQU   ISTRDT+124
RDTCRSDS EQU   ISTRDT+116
@NM00093 EQU   ISTRDT+113
RRNSTCNT EQU   RDTSTCNT
RRNVYRPH EQU   RDTVYRPH
RDTTPAB  EQU   ISTRDT+104
RDTDPAB  EQU   ISTRDT+100
RDTEPAB  EQU   ISTRDT+96
RDTRSV01 EQU   RDTFLAGB
RDTBHSET EQU   RDTFLAGB
RDTCTCFL EQU   RDTFLAGB
RDTCTPGD EQU   RDTFLAGB
RDTPRGDN EQU   RDTFLAGB
RDTOUERP EQU   RDTFLAGB
RDTLGCT  EQU   ISTRDT+90
RDTNODID EQU   ISTRDT+89
RDTMAXID EQU   ISTRDT+88
RDTCTSNT EQU   ISTRDT+86
RDTFLAGS EQU   ISTRDT+84
RDTBACK  EQU   ISTRDT+80
RDTFORW  EQU   ISTRDT+76
RDTLEN   EQU   RDTPLEN+1
RDTPRILS EQU   RDTPRIOR
RDTPRISW EQU   RDTPRIOR
RDTPRIRN EQU   RDTPRIOR
RDTPRILC EQU   RDTPRIOR
RDTPRIAP EQU   RDTPRIOR
@NM00092 EQU   RDTPRIOR
RDTPRE   EQU   ISTRDT
RCPRSV05 EQU   ISTRCPRE+120
RCPRSV04 EQU   ISTRCPRE+116
RCPRSV03 EQU   ISTRCPRE+112
RCPINTA  EQU   RCPLGNIN+16
RCPLGNCT EQU   RCPLGNIN+8
RCPLGNAP EQU   RCPLGNIN
@NM00091 EQU   RCPPMODE
RCPRRECD EQU   RCPPMODE
RCPRBASC EQU   RCPPMODE
RCPBFLIM EQU   ISTRCPRE+90
RCPBHSI2 EQU   ISTRCPRE+89
RCPBHSI1 EQU   ISTRCPRE+88
RCPICEAQ EQU   ISTRCPRE+80
RCPLNAPA EQU   ISTRCPRE+76
RCPICELN EQU   ISTRCPRE+72
RCPPRE   EQU   ISTRCPRE
RPRCONID EQU   ISTRPRE+63
RPRCLVPD EQU   RPRFLAGC
RPRINIMM EQU   RPRFLAGD
RPRRSV05 EQU   RPRFLAGD
RPRCONP  EQU   RPRFLAGD
RPRACTP  EQU   RPRFLAGD
RPRRSON  EQU   RPRFLAGD
RPRLTASN EQU   RPRFLAGD
RPRPTHCT EQU   ISTRPRE+60
RPRSWDAF EQU   ISTRPRE+58
RPRSTPCT EQU   ISTRPRE+56
RPRRVPT1 EQU   ISTRPRE+52
RPRNCBA  EQU   ISTRPRE+40
RPRLGONB EQU   ISTRPRE+32
RPRLGONF EQU   ISTRPRE+28
RPRTIOCT EQU   ISTRPRE+26
RPRPEPCT EQU   ISTRPRE+24
RPRRSV03 EQU   RPRCAUSE
RPRRSYNC EQU   RPRCAUSE
RPRCRCPT EQU   RPRCAUSE
RPRNOSRT EQU   RPRCAUSE
RPRINTST EQU   RPRFLAGB
RPRVYIMM EQU   RPRFLAGB
RPRHLVPD EQU   RPRFLAGB
RPRONLIN EQU   RPRFLAGB
RPRVIODN EQU   RPRFLAGB
RPRAOPN  EQU   RPRFLAGB
RPRENTVT EQU   RPRFLAGB
RPRENTVH EQU   RPRFLAGB
RPRLIVE  EQU   RPRFLAGA
RPRVRYPD EQU   RPRFLAGA
RPRENTED EQU   RPRFLAGA
RPRENTIO EQU   RPRFLAGA
RPRENTBF EQU   RPRFLAGA
RPRTIED  EQU   RPRFLAGA
RPRINV   EQU   RPRFLAGA
RPRACT   EQU   RPRFLAGA
RPRELEN  EQU   ISTRPRE+16
RPRSAF   EQU   RPRCOMID
NMLRSV05 EQU   ISTNMLPB+96
NMLRSV04 EQU   ISTNMLPB+92
NMLDRDTE EQU   ISTNMLPB+88
NMECBPTR EQU   ISTNMLPB+84
NMLRSV02 EQU   ISTNMLPB+82
NMLRSV06 EQU   ISTNMLPB+81
NMIPSEQ  EQU   ISTNMLPB+80
NMNCSPL  EQU   NMRDTEA
NMRSV01  EQU   NMLCWCMD+1
NMECRST  EQU   NMLCWCMD+1
NMVRYPRG EQU   NMLCWCMD+1
NMSTCTLF EQU   NMLCWCMD+1
NMSTCTLI EQU   NMLCWCMD+1
NMSTCTLR EQU   NMLCWCMD
NMFBDTA  EQU   NMLCWCMD
NMRDBLK  EQU   NMLCWCMD
NMDSEOC  EQU   NMLCWCMD
NMPURGE  EQU   NMLCWCMD
NMRESTI  EQU   NMLCWCMD
NMCNTCT  EQU   NMLCWCMD
NMINVT   EQU   NMLCWCMD
NMPSRTRY EQU   NMCONTRL+1
FSBRSV01 EQU   FSBFSB+30
FSBTHCNT EQU   FSBFSB+28
FSBRLRSV EQU   FSBRLSTS
FSBCFTX  EQU   FSBRLSTS
FSBICNCB EQU   FSBMSGID
FSBSSOC  EQU   FSBSS2
FSBSSCC  EQU   FSBSS2
FSBSSDC  EQU   FSBSS2
FSBSSEC  EQU   FSBSS2
FSBSSIR  EQU   FSBSS2
FSBSSCR  EQU   FSBSS2
@NM00089 EQU   FSBSS2
@NM00088 EQU   FSBSS1
FSBSSDE  EQU   FSBSS1
FSBSSUS  EQU   FSBSS1
@NM00087 EQU   FSBSS1
FSBSOHI  EQU   FSBERC
FSBLGI   EQU   FSBERC
FSBLMRI  EQU   FSBFBMI
FSBETI   EQU   FSBERC
FSBEMI   EQU   FSBERC
FSBEBI   EQU   FSBERC
FSBECI   EQU   FSBERC
FSBELI   EQU   FSBERC
FSBXLCI  EQU   FSBXCODE
FSBXFINS EQU   FSBXCODE
FSBXNORM EQU   FSBXFSTS
FSBSCODE EQU   FSBSYSRS
FSBSPHSE EQU   FSBSYSRS
FSBSERR  EQU   FSBSYSRS
FSBCMD   EQU   FSBSEQ
FSBDTRCE EQU   FSBFLAGS
FSBASBTU EQU   FSBFLAGS
FSBINPET EQU   FSBFLAGS
FSBNONCB EQU   FSBFLAGS
FSBLBIND EQU   FSBFLAGS
FSBFFIND EQU   FSBFLAGS
FSBACIND EQU   FSBFLAGS
FSBRFIND EQU   FSBFLAGS
FSBDAF   EQU   FSBCID+2
FSBSAF   EQU   FSBCID
FSBGATE  EQU   FSBFSBA
FSBLATOP EQU   FSBSFLGS
FSBRSV02 EQU   FSBSFLGS
FSBPGBUF EQU   FSBSFLGS
FSBMNSDA EQU   FSBMNRCD
FSBMNOA  EQU   FSBMNRCD
FSBMNDIF EQU   FSBMNRCD
FSBMNEOP EQU   FSBMNRCD
FSBMNDNU EQU   FSBMNRCD
FSBMNATN EQU   FSBMNRCD
FSBMNRVI EQU   FSBMNRCD
FSBMNELI EQU   FSBMNRCD
FSBLNGTH EQU   FSBFSB+1
FSBTYPE  EQU   FSBFSB
FDBDATCT EQU   ISTFDB+8
NCBRSV01 EQU   ISTNCB+46
NCBSWDAF EQU   ISTNCB+44
NCBDEVCH EQU   ISTNCB+36
NCBFMCBP EQU   ISTNCB+32
NCBLTRC  EQU   ISTNCB+30
NCBRVPT1 EQU   ISTNCB+28
NCBNMLLN EQU   NCBFLAGS+3
@NM00086 EQU   NCBFLAG1
NCBFORCE EQU   NCBFLAG1
NCBTTF   EQU   NCBFLAG1
NCBRSYNC EQU   NCBFLAG1
NCBRSTRT EQU   NCBFLAG1
NCBCONF  EQU   NCBFLAG1
NCBSNAI  EQU   NCBFLAG1
NCBFLTIO EQU   NCBFTRIO
NCBCSTAT EQU   NCBFLAGS
NCBNCSL  EQU   ISTNCB+22
NCBNCBA  EQU   ISTNCB+20
NCBFMCBA EQU   ISTNCB+16
NCBNSNA  EQU   ISTNCB+12
NCBTSKID EQU   ISTNCB+8
NCBRDTE  EQU   ISTNCB+4
NCBLNGTH EQU   ISTNCB+1
NCBTYPE  EQU   ISTNCB
NCSRUITS EQU   NCSUSSRU+2
NCSRULEN EQU   NCSUSSRU
NCSAPPAB EQU   NCSAPP+608
NCSAPDAT EQU   NCSAPBUE+8
NCSAPRU  EQU   NCSAPBUE+3
NCSRSV04 EQU   NCSAPBUE
NCSAPEND EQU   NCSAPP+84
NCSAPTXT EQU   NCSAPP+76
NCSAPECB EQU   NCSAPP+72
NCSAPSA  EQU   NCSAPP
NCSPLPDB EQU   NCSPLSID+5
NCSPLNID EQU   NCSPLPHD
NCSPLPO  EQU   NCSPLSTA
NCSRSVD4 EQU   NCSPLSTA
NCSRSVD2 EQU   NCSCRMOD
NCSPTMOD EQU   NCSCRMOD
NCSAIMOD EQU   NCSCRMOD
NCSRSVD1 EQU   NCSCHKPT+1
NCSPTUSE EQU   NCSCHKPT+1
NCSRNME  EQU   NCSCHKPT+1
NCSCUA   EQU   NCSCHKPT+1
NCSANSMD EQU   NCSCHKPT+1
NCSLGMOD EQU   NCSCHKPT
NCSLGAPL EQU   NCSCHKPT
NCSDTRLM EQU   NCSCHKPT
NCSESLM  EQU   NCSCHKPT
NCSNRPL  EQU   NCSCHKPT
NCSPOLD  EQU   NCSCHKPT
NCSPACTV EQU   NCSCHKPT
NCSACTV  EQU   NCSCHKPT
NCSCRDTE EQU   ISTNCSPL+264
NCSPLRTY EQU   ISTNCSPL+263
NCSPLRH  EQU   ISTNCSPL+260
NCSUFMCB EQU   ISTNCSPL+256
NCSMGLPT EQU   ISTNCSPL+252
NCSCPWPT EQU   ISTNCSPL+248
NCSSENS2 EQU   NCSSENSE+2
NCSSNS2  EQU   NCSSENSE+1
NCSSNS1  EQU   NCSSENSE
NCSPLMID EQU   ISTNCSPL+232
NCSPLPID EQU   ISTNCSPL+231
NCSPLGID EQU   ISTNCSPL+230
NCSPLSQN EQU   ISTNCSPL+228
NCSRNAME EQU   ISTNCSPL+220
NCSPLRUI EQU   ISTNCSPL+212
NCSPLRUO EQU   ISTNCSPL+208
NCSPLRRP EQU   ISTNCSPL+204
NCSPLSPL EQU   ISTNCSPL+196
NCSPLP3  EQU   ISTNCSPL+192
NCSPLP2  EQU   ISTNCSPL+188
NCSPLP1  EQU   ISTNCSPL+184
NCSPLOLN EQU   ISTNCSPL+182
@NM00085 EQU   NCSPLFL5
NCSFORCE EQU   NCSPLFL5
NCSSDLK  EQU   NCSPLFL5
NCSSCPPS EQU   NCSPLFL5
NCSDLRSN EQU   ISTNCSPL+180
NCSPL2AP EQU   NCSPLFL4
NCSDSPN  EQU   NCSPLFL4
NCSDSPI  EQU   NCSPLFL4
NCSDSPA  EQU   NCSPLFL4
NCSDSPE  EQU   NCSPLFL4
NCSPLVID EQU   NCSPLFL4
NCSPLRSO EQU   NCSPLFL4
NCSDLNID EQU   NCSPLFL4
NCSEND   EQU   NCSPLFL3
NCSFINAL EQU   NCSPLFL3
NCSANS   EQU   NCSPLFL3
NCSPID   EQU   NCSPLFL3
NCSGID   EQU   NCSPLFL3
NCSPLANS EQU   NCSPLFL3
NCSEPP   EQU   NCSPLFL3
NCSPLMOM EQU   NCSPLFL3
NCSPLVIT EQU   NCSPLFL2
NCSPLVIS EQU   NCSPLFL2
NCSREMPO EQU   NCSPLFL2
NCSPLDS  EQU   NCSPLFL2
NCSOUFMC EQU   NCSPLFL2
NCSPLRIO EQU   NCSPLFL2
NCSPLRSF EQU   NCSPLFL2
NCSPLVDP EQU   NCSPLFL2
NCSPLPOS EQU   NCSPLFL1
NCSPL2CN EQU   NCSPLFL1
NCSPLAPU EQU   NCSPLFL1
NCSPLNON EQU   NCSPLFL1
NCSPLEBN EQU   NCSPLFL1
NCSPLSOM EQU   NCSPLFL1
NCSPL2IN EQU   NCSPLFL1
NCSPLRCR EQU   ISTNCSPL+172
NCSPLECB EQU   ISTNCSPL+164
NCSPLRPH EQU   ISTNCSPL+160
NCSPLDAF EQU   NCSPLCID+2
NCSPLSAF EQU   NCSPLCID
NCSPLRCD EQU   NCSPLRAD+1
NCSLSCMD EQU   NCSPLRAD
NCSPLWRF EQU   ISTNCSPL+72
NCSPLWRE EQU   ISTNCSPL+68
NCSSTCMD EQU   NCSCRFLG
NCSUSRNF EQU   NCSCRFLG
NCSOPRQU EQU   NCSCRFLG
NCSCRDSE EQU   NCSCRFLG
NCSFMERP EQU   NCSCRFLG
NCSFMCLD EQU   NCSCRFLG
NCSPLCLD EQU   NCSCRFLG
NCSPLWRM EQU   NCSCRFLG
NCSPLUAD EQU   ISTNCSPL+64
NCSMSGSP EQU   ISTNCSPL+63
NCSNCPEP EQU   ISTNCSPL+62
NCSCMDB  EQU   NCSPLCMD+1
@NM00084 EQU   NCSCMDA
NCSPLUFM EQU   NCSCMDA
NCSPLFLO EQU   NCSCMDA
NCSPLSYN EQU   NCSCMDA
NCSPLCTL EQU   NCSCMDA
NCSPLSYS EQU   NCSCMDA
NCSCRPID EQU   ISTNCSPL+51
NCSCRCMD EQU   ISTNCSPL+50
NCSDLID  EQU   ISTNCSPL+44
NCSRRNPT EQU   ISTNCSPL+24
NCSIORC  EQU   ISTNCSPL+23
NCSPRMRC EQU   ISTNCSPL+22
NCSOVFMC EQU   NCSPLVF1
NCSRSV02 EQU   NCSPLVFL
NCSDACLK EQU   NCSPLVFL
NCSABCON EQU   NCSPLVFL
NCSDCONT EQU   NCSPLVFL
NCSVDEL  EQU   NCSPLVFL
NCSVNCSA EQU   NCSPLVFL
NCSVBF16 EQU   NCSPLVBF+1
NCSVBF15 EQU   NCSPLVBF+1
NCSVBF14 EQU   NCSPLVBF+1
NCSVBF13 EQU   NCSPLVBF+1
NCSVBF12 EQU   NCSPLVBF+1
NCSVBF11 EQU   NCSPLVBF+1
NCSVBF10 EQU   NCSPLVBF+1
NCSVBF09 EQU   NCSPLVBF+1
NCSVBF08 EQU   NCSPLVBF
NCSVBF07 EQU   NCSPLVBF
NCSVBF06 EQU   NCSPLVBF
NCSVBF05 EQU   NCSPLVBF
NCSVBF04 EQU   NCSPLVBF
NCSVBF03 EQU   NCSPLVBF
NCSVBF02 EQU   NCSPLVBF
NCSVBF01 EQU   NCSPLVBF
@NM00083 EQU   ISTNCSPL+16
NCSCRWKA EQU   NCSPFX+12
@NM00082 EQU   NCSPFX
PFXBCK   EQU   ISTPFX+12
PFXFWD   EQU   ISTPFX+8
PFXLNG   EQU   ISTPFX+5
PFXPRTY  EQU   ISTPFX+4
PFXCBID  EQU   PFXID
POHID    EQU   ISTPOHD+2
POHGEN   EQU   POHSTAT
POHRREQ  EQU   POHSTAT
POHRSVD2 EQU   POHSTAT
POHCNTRL EQU   POHSTAT
POHLBL   EQU   POHSTAT
POHDATA  EQU   POHSTAT
POHEND   EQU   POHSTAT
POHRSVD1 EQU   ISTPOHD
RUSSRU   EQU   ISTRUSEN+4
NIRRH    EQU   ISTNIR
ATCAOS   EQU   ISTATCVT+1584
ATCPOPAB EQU   ATCAOSM+640
ATCVIOPM EQU   ATCAOSM+636
ATCTPMMI EQU   ATCAOSM+632
ATCTPMPB EQU   ATCAOSM+600
ATCRSV88 EQU   ATCAOSM+596
ATCRPLCT EQU   ATCAOSM+594
ATCCRACT EQU   ATCAOSM+592
ATCSRBCT EQU   ATCAOSM+590
ATCRSV75 EQU   ATCAOSM+589
ATCRSV66 EQU   ATCZFLAG
ATCZF001 EQU   ATCZFLAG
ATCTPCP1 EQU   ATCAOSM+584
ATCTPCP0 EQU   ATCAOSM+580
ATCAICTN EQU   ATCAOSM+576
ATCZR01  EQU   ATCAOSM+572
ATCMPLTA EQU   ATCAOSM+568
ATCASCB  EQU   ATCAOSM+564
ATCAP86  EQU   ATCAOSM+560
ATCAP85  EQU   ATCAOSM+556
ATCAP84  EQU   ATCAOSM+552
ATCAP83  EQU   ATCAOSM+548
ATCAP82  EQU   ATCAOSM+544
ATCAP69  EQU   ATCAOSM+540
ATCAP66  EQU   ATCAOSM+536
ATCAP62  EQU   ATCAOSM+532
ATCAPC59 EQU   ATCAOSM+528
ATCAP56  EQU   ATCAOSM+524
ATCAP55  EQU   ATCAOSM+520
ATCRCFY0 EQU   ATCAOSM+516
ATCAP41  EQU   ATCAOSM+512
ATCAPC25 EQU   ATCAOSM+508
ATCAP23  EQU   ATCAOSM+504
ATCTPSPB EQU   ATCAOSM+472
ATCTRMPB EQU   ATCAOSM+440
ATCAPBE  EQU   ATCAOSM+436
ATCPSTA  EQU   ATCAOSM+432
ATCSMABF EQU   ATCAOSM+428
ATCSMAPR EQU   ATCAOSM+424
ATCTPWQA EQU   ATCAOSM+420
ATCSMAID EQU   ATCAOSM+416
ATCSMARA EQU   ATCAOSM+412
ATCCACXA EQU   ATCAOSM+408
ATCZLAAB EQU   ATCAOSM+404
ATCATA10 EQU   ATCAOSM+400
ATCHLTCB EQU   ATCAOSM+396
@NM00080 EQU   ATCVTFLG
ATCVTACT EQU   ATCVTFLG
ATCRPT40 EQU   ATCAOSM+388
ATCRPT39 EQU   ATCAOSM+384
ATCRPT38 EQU   ATCAOSM+380
ATCRPT37 EQU   ATCAOSM+376
ATCRPT36 EQU   ATCAOSM+372
ATCRPT35 EQU   ATCAOSM+368
ATCRPT34 EQU   ATCAOSM+364
ATCRPT33 EQU   ATCAOSM+360
ATCRPT32 EQU   ATCAOSM+356
ATCRPT31 EQU   ATCAOSM+352
ATCRPT30 EQU   ATCAOSM+348
ATCRPT29 EQU   ATCAOSM+344
ATCRPT28 EQU   ATCAOSM+340
ATCRPT27 EQU   ATCAOSM+336
@NM00079 EQU   ATCAOSM+333
@NM00078 EQU   @NM00077
ATCSNUF  EQU   @NM00077
ATCOPKL  EQU   @NM00077
ATCABEN  EQU   @NM00077
ATCAIWT  EQU   ATCAOSM+328
ATCINFDD EQU   ATCAOSM+324
ATCORFMG EQU   ATCAOSM+320
ATCORFRL EQU   ATCAOSM+316
ATCOROBT EQU   ATCAOSM+312
ATCORQG  EQU   ATCORSRB
ATCORTBF EQU   ATCSQAFR
ATCRPLAC EQU   ATCRPLCN+2
ATCRPLRC EQU   ATCRPLCN
ATCCRPLQ EQU   ATCCRPL
ATCSRBAC EQU   ATCSRBCN+2
ATCSRBRC EQU   ATCSRBCN
ATCSRBQ  EQU   ATCSRB
ATCCRAAC EQU   ATCCRACN+2
ATCCRARC EQU   ATCCRACN
ATCCRAQ  EQU   ATCCRA
ATCRPT12 EQU   ATCAOSM+276
ATCDMAPP EQU   ATCAOSM+272
ATCAP38  EQU   ATCAOSM+268
ATCZDFJ0 EQU   ATCAOSM+260
ATCAP51  EQU   ATCAOSM+256
ATCZPAB2 EQU   ATCAOSM+224
ATCZPAB1 EQU   ATCAOSM+192
ATCZLFVT EQU   ATCAOSM+188
ATCZLPVT EQU   ATCAOSM+184
ATCZDVTX EQU   ATCAOSM+180
ATCZDVTA EQU   ATCAOSM+176
ATCZDVT9 EQU   ATCAOSM+172
ATCZDVT8 EQU   ATCAOSM+168
ATCZDVT7 EQU   ATCAOSM+164
ATCRSV56 EQU   ATCDAPVT+22
ATCDAPDG EQU   ATCDAPVT+20
ATCDXCEA EQU   ATCDAPVT+16
ATCDCEA  EQU   ATCDAPVT+12
ATCDPCIA EQU   ATCDAPVT+8
ATCDSIOA EQU   ATCDAPVT+4
ATCDEOEA EQU   ATCDAPVT
ATCZLAEA EQU   ATCLDAPP+16
ATCZLCEA EQU   ATCLDAPP+12
ATCRSV17 EQU   ATCLDAPP+8
ATCSMFRR EQU   ATCLDAPP+4
ATCCDTID EQU   ATCLDAPP
ATCZAEA  EQU   ATCICAPP+16
ATCZCEA  EQU   ATCICAPP+12
ATCCDTCB EQU   ATCICAPP+8
ATCZSIOA EQU   ATCICAPP+4
ATCCDRPH EQU   ATCICAPP
ATCAP65  EQU   ATCAOSM+96
ATCZDVT6 EQU   ATCAOSM+92
ATCZDVT4 EQU   ATCAOSM+88
ATCZDVT3 EQU   ATCAOSM+84
ATCZDVT1 EQU   ATCAOSM+80
ATCICNCB EQU   ATCAOSM+76
ATCZPSVT EQU   ATCAOSM+72
ATCZFSVT EQU   ATCAOSM+68
ATCAP64  EQU   ATCAOSM+64
ATCAP63  EQU   ATCAOSM+60
ATCAP61  EQU   ATCAOSM+56
ATCAP58  EQU   ATCAOSM+52
ATCAP57  EQU   ATCAOSM+48
ATCAP54  EQU   ATCAOSM+44
ATCAP53  EQU   ATCAOSM+40
ATCAP52  EQU   ATCAOSM+36
ATCAP32  EQU   ATCAOSM+28
ATCAP12  EQU   ATCAOSM+20
ATCAP11  EQU   ATCAOSM+16
ATCCMTCB EQU   ATCAOSM+12
ATCPRPH  EQU   ATCAOSM+8
ATCGSRBF EQU   ATCGSRBG
ATCSRBRT EQU   ATCAOSM
@NM00076 EQU   @NM00075
ATCVTMAB EQU   @NM00075
@NM00074 EQU   ATCVTBAM
ATCVDLOK EQU   ISTATCVT+904
ATCVFPAB EQU   ISTATCVT+872
ATCVDPAB EQU   ISTATCVT+840
ATCIOECB EQU   ISTATCVT+836
ATCINCW3 EQU   ISTATCVT+832
ATCMODTB EQU   ISTATCVT+828
ATCUSSPT EQU   ISTATCVT+824
@NM00073 EQU   ISTATCVT+819
@NM00072 EQU   ATCSTAT2
ATCTRSMS EQU   ATCSTAT2
ATCTRLOK EQU   ATCSTAT2
ATCTRPSS EQU   ATCSTAT2
ATCTRESC EQU   ATCSTAT2
ATCTRAPI EQU   ATCSTAT2
ATCNMCTR EQU   ISTATCVT+816
ATCSEC51 EQU   ATCSECST
ATCSEC40 EQU   ATCSIPD+8
ATCSEC30 EQU   ATCSIPD+4
ATCSEC21 EQU   ATCSIPD
ATCSEC10 EQU   ATCSOPD+4
ATCSEC01 EQU   ATCSOPD
ATCPOIA  EQU   ATCRNO+1
@NM00071 EQU   ATCRNO
ATCPODVT EQU   ISTATCVT+784
ATCS49XL EQU   ISTATCVT+780
ATCS49XI EQU   ISTATCVT+776
ATCLCLCT EQU   ATCVLCNT+2
ATCRNCNT EQU   ATCVLCNT
ATCCFEAD EQU   ISTATCVT+768
ATCPTR00 EQU   ISTATCVT+736
ATCRSV10 EQU   ISTATCVT+704
ATCTACB  EQU   ISTATCVT+700
ATCVTINM EQU   ISTATCVT+696
ATCTCLIM EQU   ISTATCVT+692
ATCTCLOM EQU   ISTATCVT+688
ATCVTIPB EQU   ISTATCVT+656
ATCTCIPB EQU   ISTATCVT+624
ATCTIPAB EQU   ISTATCVT+592
ATCOCCCB EQU   ISTATCVT+588
ATCOCCOB EQU   ISTATCVT+584
ATCCDLAD EQU   ISTATCVT+580
ATCCCLAD EQU   ISTATCVT+576
ATCDLRPB EQU   ISTATCVT+544
ATCPGPAB EQU   ISTATCVT+512
ATCVPAB1 EQU   ISTATCVT+480
ATCRSV97 EQU   ISTATCVT+476
ATCDVTLK EQU   ISTATCVT+456
ATCRSV99 EQU   ISTATCVT+440
ATCONFIG EQU   ISTATCVT+432
ATCNODDS EQU   ISTATCVT+428
ATCNODEL EQU   ISTATCVT+420
ATCRSV69 EQU   ISTATCVT+416
ATCAPCR5 EQU   ISTATCVT+412
ATCLDECB EQU   ISTATCVT+408
ATCLDNCS EQU   ISTATCVT+404
ATCCDPTR EQU   ISTATCVT+400
ATCADEL  EQU   ISTATCVT+396
ATCTODVT EQU   ISTATCVT+392
ATCDEBCH EQU   ISTATCVT+388
ATCHBSIZ EQU   ATCHPGM+2
ATCHBFNO EQU   ATCHPGM
ATCCRME  EQU   ISTATCVT+380
ATCRVCHS EQU   ISTATCVT+372
ATCECTLP EQU   ISTATCVT+368
ATCZDVTB EQU   ISTATCVT+364
ATCECPRT EQU   ISTATCVT+360
ATCVTLOD EQU   ISTATCVT+356
ATCTRPAB EQU   ISTATCVT+352
ATCMSGM  EQU   ISTATCVT+348
ATCMSGP  EQU   ISTATCVT+344
ATCEPT   EQU   ISTATCVT+340
ATCDVT   EQU   ISTATCVT+336
ATCTRCPT EQU   ISTATCVT+332
ATCDVLOD EQU   ISTATCVT+328
ATCALERT EQU   ISTATCVT+324
ATCEPA   EQU   ISTATCVT+320
ATCSAF   EQU   ISTATCVT+318
ATCXRANG EQU   ISTATCVT+317
ATCLAST  EQU   ATCSHRFG
ATCSHRTN EQU   ISTATCVT+308
ATCUEP   EQU   ISTATCVT+304
ATCOCRT  EQU   ISTATCVT+300
ATCCSMA  EQU   ATCCSMR
ATCESC02 EQU   ISTATCVT+292
ATCESC01 EQU   ISTATCVT+288
ATCMNT   EQU   ISTATCVT+272
ATCRSV16 EQU   ISTATCVT+270
ATCMAXID EQU   ISTATCVT+269
ATCMSGSP EQU   ATCCOM+268
ATCACTRM EQU   ATCCOM+264
ATCNERAP EQU   ATCCOM+260
ATCNESAL EQU   ATCCOM+256
ATCRCC65 EQU   ATCCOM+252
ATCRCC26 EQU   ATCCOM+248
ATCRCC63 EQU   ATCCOM+244
ATCRSV11 EQU   ATCCOM+242
ATCAPOST EQU   ATCCOM+236
ATCNERFN EQU   ATCCOM+232
ATCNERNE EQU   ATCCOM+228
ATCNERCV EQU   ATCCOM+224
ATCNERST EQU   ATCCOM+220
ATCDCC61 EQU   ATCCOM+216
ATCDCC60 EQU   ATCCOM+212
ATCSRTAD EQU   ATCCOM+204
ATCFIRA  EQU   ATCCOM+200
ATCSMBQ  EQU   ATCCOM+196
ATCSMRC  EQU   ATCCOM+192
ATCSMQU  EQU   ATCCOM+184
ATCACDA  EQU   ATCCOM+176
ATCSTMA  EQU   ATCCOM+172
ATCFRSTR EQU   ATCCOM+168
ATCREADA EQU   ATCCOM+160
ATCALOAD EQU   ATCCOM+156
ATCBLDLA EQU   ATCCOM+152
ATCFBRPH EQU   ATCCOM+148
ATCBFTRC EQU   ATCCOM+144
ATCTPBUF EQU   ATCTHTRC
ATCREMOV EQU   ATCCOM+136
ATCADD   EQU   ATCCOM+132
ATCDVTPT EQU   ATCCOM+124
ATCFEPT  EQU   ATCCOM+120
ATCFDVT  EQU   ATCCOM+116
ATCCONFT EQU   ATCCOM+112
ATCPTCHA EQU   ATCCOM+108
ATCAUTHA EQU   ATCCOM+104
ATCACCTA EQU   ATCCOM+100
ATCRDTH  EQU   ATCCOM+96
ATCFRSCH EQU   ATCCOM+92
ATCFSB   EQU   ATCCOM+88
ATCHLTMS EQU   ATCCOM+84
ATCECPRM EQU   ATCCOM+80
ATCECNET EQU   ATCCOM+76
ATCECOPC EQU   ATCCOM+72
ATCVPARM EQU   ATCCOM+68
ATCECVRQ EQU   ATCCOM+64
ATCECSES EQU   ATCCOM+60
ATCOCHA  EQU   ATCCOM+56
ATCDSPLQ EQU   ATCCOM+52
ATCECDSP EQU   ATCCOM+48
ATCVARYQ EQU   ATCCOM+44
ATCECVRY EQU   ATCCOM+40
ATCHALTQ EQU   ATCCOM+36
ATCECHLT EQU   ATCCOM+32
ATCMODQ  EQU   ATCCOM+28
ATCECMOD EQU   ATCCOM+24
ATCASCHD EQU   ATCCOM+20
ATCSRT   EQU   ATCCOM+16
ATCRDT   EQU   ATCCOM+12
ATCDCFRR EQU   ATCCOM+8
ATCAPI   EQU   ATCCOM+4
ATCRSV04 EQU   ATCSTAT4
ATCVTTRC EQU   ATCSTAT4
ATCNCSD  EQU   ATCSTAT4
ATCMTST  EQU   ATCSTAT4
ATCTPRT  EQU   ATCSTAT4
ATCPRTAT EQU   ATCSTAT4
@NM00070 EQU   ATCPOFLG
ATCPOUNS EQU   ATCPOFLG
ATCHSDMF EQU   ATCSTFLG
@NM00069 EQU   ATCSTAT1
ATCMDHLT EQU   ATCSTAT1
ATCINHLT EQU   ATCSTAT1
ATCNETSL EQU   ATCSTAT1
ATCQKHLT EQU   ATCSTAT1
ATCSNHLT EQU   ATCSTAT1
ATCACTIV EQU   ATCSTAT1
ATCSTART EQU   ATCSTAT1
RPHNEXPO EQU   ISTRPH+104
RPHSAV16 EQU   RPHWORK+60
RPHSAV15 EQU   RPHWORK+56
RPHSAV14 EQU   RPHWORK+52
RPHSAV13 EQU   RPHWORK+48
RPHSAV12 EQU   RPHWORK+44
RPHSAV11 EQU   RPHWORK+40
RPHSAV10 EQU   RPHWORK+36
RPHSAVE9 EQU   RPHWORK+32
RPHSAVE8 EQU   RPHWORK+28
RPHSAVE7 EQU   RPHWORK+24
RPHSAVE6 EQU   RPHWORK+20
RPHSAVE5 EQU   RPHWORK+16
RPHSAVE4 EQU   RPHWORK+12
RPHSAVE3 EQU   RPHWORK+8
RPHSAVE2 EQU   RPHWORK+4
RPHSHALF EQU   RPHSAVE1+2
RPHSBIT8 EQU   RPHSBITS
RPHSBIT7 EQU   RPHSBITS
RPHSBIT6 EQU   RPHSBITS
RPHSBIT5 EQU   RPHSBITS
RPHSBIT4 EQU   RPHSBITS
RPHSBIT3 EQU   RPHSBITS
RPHSBIT2 EQU   RPHSBITS
RPHSBIT1 EQU   RPHSBITS
RPHSBYTE EQU   RPHSAVE1
RPHPABQP EQU   RPHPABQA+1
RPHPABFG EQU   RPHPABQA
RPHSRP34 EQU   RPHSRPRM+2
RPHSRP12 EQU   RPHSRPRM
RPHWEGT  EQU   RPHCSPA
RPHMAJCB EQU   ISTRPH+21
RPHPABOF EQU   ISTRPH+20
RPHRESUM EQU   RPHRESMA+1
RPHRSV01 EQU   RPHWPFLG
RPHPURGE EQU   RPHWPFLG
RPHPT    EQU   RPHWPFLG
RPHWT    EQU   RPHWPFLG
RPHRSKEY EQU   RPHWPFLG
RPHDVTA  EQU   ISTRPH+12
RPHTIK   EQU   RPHTSKID+3
@NM00068 EQU   RPHTSKID
RPHRPHAP EQU   RPHRPHA+1
@NM00067 EQU   RPHRPHA
RPHGATE  EQU   RPHRPHA
@NM00066 EQU   RPHFLGB
RPHRLCRA EQU   RPHFLGB
RPHNRSAV EQU   RPHFLGB
RPHPGCMP EQU   RPHFLGB
RPHFBAPS EQU   RPHFLGB
RPHBSSP  EQU   RPHFLGB
RPHLOCK  EQU   RPHFLGB
RPHFNFLG EQU   RPHFSTLC
RPHMLTCP EQU   RPHFLAGS
RPHSMCLR EQU   RPHFLAGS
RPHSMTYP EQU   RPHFLAGS
RPHSMQ   EQU   RPHFLAGS
RPHAUTEX EQU   RPHAPTYP
RPHSPGIN EQU   RPHFLAGS
RPHOGIND EQU   RPHFLAGS
RPHLNGTH EQU   RPHCNTL+1
RPHTYPE  EQU   RPHCNTL
DYPRSV01 EQU   ISTDYPAB+12
DYPTSKID EQU   ISTDYPAB+8
DYPCHAIN EQU   ISTDYPAB+4
DYPFLGS  EQU   ISTDYPAB+2
DYPLNGTH EQU   ISTDYPAB+1
DYPTYPE  EQU   ISTDYPAB
LOKXCL   EQU   @NM00064
LOKPRY   EQU   @NM00064
@NM00065 EQU   @NM00064
@NM00063 EQU   LOKCHNG
LOKCT    EQU   ISTLOK
PABRPHA  EQU   PABRPHFG+1
PABNODQ  EQU   PABFLAGS
PABINHBT EQU   PABFLAGS
PABERLOK EQU   PABERRLK
PABSSN   EQU   PABFLAGS
PABDYNAM EQU   PABFLAGS
PABNORPR EQU   PABFLAGS
PABPRIOR EQU   PABFLAGS
PABAPYP  EQU   PABFLAGS
PABDVTA  EQU   ISTPAB+9
PABOFFST EQU   ISTPAB+8
PABCHNGP EQU   PABCHAIN+1
PABRSV02 EQU   PABCHAIN
PABDELAY EQU   PABCHAIN
PABRUNNG EQU   PABCHAIN
PABRESET EQU   PABCHAIN
PABUNCON EQU   PABCHAIN
PABCDP   EQU   PABCHAIN
PABRESCH EQU   PABCHAIN
PABCHNG  EQU   PABCHAIN
PABWEQP  EQU   PABWEQA+1
PABRSV01 EQU   PABWEQA
PABWEQG  EQU   PABWEQA
LCPRSTQH EQU   LCPLCCW
LCPCLREP EQU   ISTLCPB+44
LCPUBFSB EQU   LCPFLCCW
LCPRSV77 EQU   ISTLCPB+39
LCPLCCWC EQU   ISTLCPB+38
LCPRSV78 EQU   LCPFLG1
LCPTRANS EQU   LCPFLG1
LCPSTLB  EQU   LCPFLG1
LCPREDRV EQU   LCPFLG1
LCPDIRPT EQU   LCPFLG1
LCPINTER EQU   LCPFLG1
LCPRESET EQU   LCPFLG1
LCPSTYPE EQU   ISTLCPB+36
LCPFSNCH EQU   ISTLCPB+34
LCPFOSN  EQU   ISTLCPB+32
LCPTLBAD EQU   ISTLCPB+28
LCPFDB2  EQU   LCPFDBA+1
LCPFDB1  EQU   LCPFDBA
LCPDAF   EQU   LCPCID+2
LCPSAF   EQU   LCPCID
LCPLCCW1 EQU   ISTLCPB+12
LCPRRCNT EQU   LCPSEQ+1
LCPRRCCT EQU   LCPSEQ
LCPATOP  EQU   LCPFLAG2
LCPFREE  EQU   LCPFLAG2
LCPDSTAT EQU   LCPFLAG2
LCPEXRES EQU   LCPFID0
LCPZRIMM EQU   LCPTLBPI
LCPRSTRT EQU   LCPFLAG2
LCPPRFLG EQU   LCPFLAG2
LCPZMIRC EQU   LCPRUCNT
LCPCHAI2 EQU   LCPCHAIN+1
LCPCHNG  EQU   LCPCHAI1
LCPZRT0B EQU   LCPMNRCD
LCPZRT0A EQU   LCPMNRCD
LCPZRTL9 EQU   LCPZRT09
LCPZRTL8 EQU   LCPZRT08
LCPZRTL7 EQU   LCPZRT07
LCPZRTL6 EQU   LCPZRT06
LCPZRTL5 EQU   LCPZRT05
LCPZRTL4 EQU   LCPZRT04
LCPZRTL3 EQU   LCPZRT03
LCPZRTL2 EQU   LCPZRT02
LCPZRT01 EQU   LCPFLAGS
LCPZRT00 EQU   LCPFLAGS
LCCWACI  EQU   LCCWFLAG
LCCWRFI  EQU   LCCWFLAG
LCCWPER  EQU   LCCWLSI
LCCWCKPT EQU   LCCWFLAG
LCCWCC   EQU   LCCWFLAG
LCCWTYPE EQU   LCCWCTL
LCCWMODE EQU   LCCWCTL
LCCWSOP  EQU   LCCWRWOP
@NM00062 EQU   LCCWRWOP
LCCWSD   EQU   LCCWOP
LCCWSI   EQU   LCCWOP
OCWEND   EQU   ISTOCW+848
@NM00061 EQU   OCWFLG1
OCWBINDD EQU   OCWBIND+37
OCWBINDC EQU   OCWBIND
OCWSHPLC EQU   OCWSHPL+8
OCWSHPLB EQU   OCWSHPL+4
OCWSHPLA EQU   OCWSHPL
OCWELCP  EQU   ISTOCW+776
OCWRSV12 EQU   ISTOCW+772
OCWRSV11 EQU   ISTOCW+768
OCWODOA  EQU   ISTOCW+764
OCWSCHIO EQU   OCWIOCNT
OCWPROCD EQU   ISTOCW+756
OCWCCRPH EQU   ISTOCW+752
OCWPABCT EQU   ISTOCW+748
OCWNMLLN EQU   ISTOCW+742
OCWRSV0A EQU   ISTOCW+741
OCWRSV82 EQU   OCWLOCKS
OCWALOCK EQU   OCWLOCKS
OCWDLOCK EQU   OCWLOCKS
OCWIOMIN EQU   ISTOCW+735
OCWIOMAJ EQU   ISTOCW+734
OCWBHSID EQU   ISTOCW+733
OCWRSV03 EQU   ISTOCW+732
OCWSWTE7 EQU   OCWSWTE
OCWSWTE6 EQU   OCWSWTE
OCWSWTE5 EQU   OCWSWTE
OCWSWTE4 EQU   OCWSWTE
OCWSWTE3 EQU   OCWSWTE
OCWSWTE2 EQU   OCWSWTE
OCWLCPBC EQU   OCWSWTE
OCWSKEL  EQU   OCWSWTE
OCWSWTR7 EQU   OCWSWTRD
OCWSWTR6 EQU   OCWSWTRD
OCWSWTR5 EQU   OCWSWTRD
OCWDPDVT EQU   OCWSWTRD
OCWEPTLP EQU   OCWSWTRD
OCWCPARE EQU   OCWSWTRD
OCWCLEN  EQU   OCWSWTRD
OCWSRDVT EQU   OCWSWTRD
OCWCLCD2 EQU   ISTOCW+728
OCWCLCD1 EQU   ISTOCW+726
OCWLALEN EQU   ISTOCW+724
OCWSDVTA EQU   ISTOCW+720
OCWMDVT  EQU   ISTOCW+708
OCWSDVT  EQU   ISTOCW+704
OCWPREV  EQU   ISTOCW+700
OCWSAVE5 EQU   ISTOCW+552
OCWSAVE4 EQU   ISTOCW+480
OCWSAVE3 EQU   ISTOCW+408
OCWSAVE2 EQU   ISTOCW+336
OCWSAVE1 EQU   ISTOCW+264
OCWRSVD  EQU   ISTOCW+212
OCWVPAB  EQU   ISTOCW+208
OCWSWTD7 EQU   OCWSWTD
OCWSWTD6 EQU   OCWSWTD
OCWSWTD5 EQU   OCWSWTD
OCWSWTD4 EQU   OCWSWTD
OCWPGDON EQU   OCWSWTD
OCWNPOST EQU   OCWSWTD
OCWCLDEB EQU   OCWSWTD
OCWVARY  EQU   OCWSWTC
OCWPRMTR EQU   OCWSWTC
OCWPBH   EQU   OCWSWTC
OCWRBH   EQU   OCWSWTC
OCWCKACE EQU   OCWSWTC
OCWODCLS EQU   OCWSWTC
OCWSWTC1 EQU   OCWSWTC
OCWSPCLS EQU   OCWSWTC
OCWCSCAL EQU   OCWSWTB
OCWPSREQ EQU   OCWSWTB
OCWOLOCK EQU   OCWSWTB
OCWCOREQ EQU   OCWSWTB
OCWDOPHY EQU   OCWSWTB
OCWCLOOP EQU   OCWSWTB
OCWRECL  EQU   OCWSWTB
OCWGOFUN EQU   OCWSWTB
OCWNODLT EQU   OCWSWTA
OCWODCL  EQU   OCWSWTA
OCWGODST EQU   OCWSWTA
OCWSORT  EQU   OCWSWTA
OCWGOCNT EQU   OCWSWTA
OCWSRT   EQU   OCWSWTA
OCWGTLST EQU   OCWSWTA
OCWBADNO EQU   ISTOCW+110
OCWODCT2 EQU   ISTOCW+106
OCWRSV02 EQU   ISTOCW+100
OCWRSV01 EQU   ISTOCW+96
OCWODFST EQU   ISTOCW+88
OCWLPOST EQU   ISTOCW+76
OCWCPOST EQU   ISTOCW+72
OCWFPOST EQU   ISTOCW+68
OCWACDEB EQU   ISTOCW+64
OCWEPTAB EQU   ISTOCW+52
OCWDRHOB EQU   OCWDRDTE
OCWCSL   EQU   ISTOCW+28
OCWPAB   EQU   ISTOCW+20
OCWCHAIN EQU   ISTOCW+8
OCWPBCHN EQU   ISTOCW+4
OCWTLEN  EQU   ISTOCW+2
OCWSLEN  EQU   ISTOCW+1
OCWID    EQU   ISTOCW
NIBRESV  EQU   ISTNIB+60
NIBEXLST EQU   ISTNIB+44
NIBLIMIT EQU   ISTNIB+42
@NM00060 EQU   ISTNIB+41
@NM00059 EQU   NIBFLG1
@NM00058 EQU   NIBFLG1
@NM00057 EQU   NIBFLG1
@NM00056 EQU   NIBFLG1
NIBLAST  EQU   NIBFLG1
NIBPROCD EQU   ISTNIB+36
NIBMODE  EQU   ISTNIB+20
NIBUSER  EQU   ISTNIB+8
NIBLEN   EQU   ISTNIB+3
NIBCONDN EQU   ISTNIB+2
NIBRSV01 EQU   ISTNIB+1
NIBID    EQU   ISTNIB
DEVRSV03 EQU   ISTDEVCH+5
DEVPHYSA EQU   ISTDEVCH+4
DEVCSLPN EQU   DEVCHAR3
DEVCSTCL EQU   DEVCHAR3
DEVCCHEK EQU   DEVCHAR3
DEVCATTN EQU   DEVCHAR3
DEVCSWL  EQU   DEVFCCTL
DEVCRVB  EQU   DEVFCCTL
DEVCSSL  EQU   DEVFCCTL
DEVCBSC  EQU   DEVFCCTL
DEVMCODE EQU   ISTDEVCH+2
DEVCHAR2 EQU   DEVTCODE
DEVRSV01 EQU   DEVCHAR
DEVCCTL  EQU   DEVCHAR
DEVNNSPT EQU   DEVCHAR
DEVSPS   EQU   DEVCHAR
DEVSUBND EQU   DEVCHAR
DEVCONVR EQU   DEVCHAR
DEVOTPUT EQU   DEVCHAR
DEVINPUT EQU   DEVCHAR
PROSRDEF EQU   PROSETM4
PRORSV47 EQU   PROSETM4
PROSCON  EQU   PROSETM4
PRORSV46 EQU   PROSETM3
PROSMONT EQU   PROSETM3
PRORSV45 EQU   PROSETM3
PROSNTO  EQU   PROSETM3
PRORSV44 EQU   PROSETM3
PRORSV43 EQU   PROSETM2
PROSNTFL EQU   PROSETM2
PRORSV42 EQU   PROSETM2
PRORSV41 EQU   PROPROCS
PROMODC  EQU   PROPROC4
PROMODT  EQU   PROPROC4
PROMODM  EQU   PROPROC4
PROMODB  EQU   PROPROC4
PRORSV14 EQU   PROPROC4
PRORSV13 EQU   PROPROC4
PRORSV12 EQU   PROPROC4
PROEIB   EQU   PROPROC4
PROMONT3 EQU   PROPROC3
PROMONT2 EQU   PROPROC3
PROMONIT EQU   PROPROC3
PROSUBLK EQU   PROPROC3
PRONTO   EQU   PROPROC3
PROLGIN  EQU   PROPROC3
PROERPI  EQU   PROPROC3
PRORSV07 EQU   PROPROC3
PROCFTX  EQU   PROPROC2
PROEMLC  EQU   PROPROC2
PRONTFL  EQU   PROPROC2
PRORSV05 EQU   PROPROC2
PRORSV04 EQU   PROPROC2
PROLGOT  EQU   PROPROC2
PROERPO  EQU   PROPROC2
PRORSV03 EQU   PROPROC2
PRORPLC  EQU   PROPROC1
PROCS    EQU   PROPROC1
PROCA    EQU   PROPROC1
PRORESPX EQU   PROPROC1
PRODFASY EQU   PROPROC1
PROXPOPT EQU   PROPROC1
PROTRUNC EQU   PROPROC1
PROASYIP EQU   PROPROC1
CSPUNUSD EQU   CSPRSC2B+4
CSPUECBA EQU   CSPRSC2B
CSPTRDTE EQU   ISTCSP+28
CSPRLRPH EQU   ISTCSP+24
CSPNO    EQU   ISTCSP+22
CSPCC    EQU   ISTCSP+20
CSPDATA  EQU   ISTCSP+16
CSPRSCE  EQU   ISTCSP+12
CSPDEST  EQU   ISTCSP+8
CSPSRC   EQU   ISTCSP+4
@NM00055 EQU   CSPOPT2
CSPWASQD EQU   CSPOPT2
CSPACQS  EQU   CSPOPT2
CSPACES  EQU   CSPOPT2
CSPNOREL EQU   CSPOPT2
CSPCOREQ EQU   CSPOPT2
CSPSTAP  EQU   CSPOPT2
@NM00054 EQU   CSPOPT1
CSPANY   EQU   CSPOPT1
CSPACT   EQU   CSPOPT1
CSPSESS  EQU   CSPOPT1
CSPPND   EQU   CSPOPT1
CSPLOGI  EQU   CSPOPT1
CSPQ     EQU   CSPOPT1
CSPRSC   EQU   CSPOPT1
CSPIDX   EQU   ISTCSP
LGPLOGNP EQU   ISTLGPFX+48
LGPUSECT EQU   ISTLGPFX+10
LGPDTLEN EQU   ISTLGPFX+8
LGPBFHDR EQU   ISTLGPFX
BFHDATA  EQU   ISTBFHDR+8
BFHUSED  EQU   ISTBFHDR+6
BFHSIZE  EQU   ISTBFHDR+4
BFHNXCHN EQU   ISTBFHDR
BINRSV05 EQU   ISTBIND+25
BINLUTYP EQU   BINLUP
BINRSV27 EQU   BINLUP
BINRSV08 EQU   BINTSU+4
BINPRUSE EQU   BINPRUSZ
BINPRUSM EQU   BINPRUSZ
BINSRUSE EQU   BINSRUSZ
BINSRUSM EQU   BINSRUSZ
BINRPACM EQU   BINRPACE
BINRSV07 EQU   BINRPACE
BINRSV06 EQU   BINTSU
BINCONR  EQU   BINCMNP2
BINRCHN  EQU   BINCMNP2
BINMDIBK EQU   BINCMNP2
BINBKFS  EQU   BINCMNP2
BINRCVR  EQU   BINCMNP2
BINFMTRM EQU   BINCMNP2
BINRSV04 EQU   BINCMNP
BINALT   EQU   BINCMNP
BINBKTR  EQU   BINCMNP
BINBRAK  EQU   BINCMNP
BINFMHD  EQU   BINCMNP
BINRSV03 EQU   BINCMNP
BINSSEB  EQU   BINSECP
BINSCMP  EQU   BINSECP
BINRSV02 EQU   BINSECP
BINSCHNR EQU   BINSECP
BINSMCH  EQU   BINSECP
BINSCHN  EQU   BINSECP
BINPSEB  EQU   BINPRIP
BINPCMP  EQU   BINPRIP
BINRSV01 EQU   BINPRIP
BINPCHNR EQU   BINPRIP
BINPMCH  EQU   BINPRIP
BINPCHN  EQU   BINPRIP
BINTS    EQU   ISTBIND+2
BINFM    EQU   ISTBIND+1
SRURSV01 EQU   SRULDID+4
SRUPSSN  EQU   SRULDID+2
SRUDFCLV EQU   SRUSPSN
@NM00053 EQU   SRUTYPE
SRUPSAC  EQU   SRUTYPE
SRUSPAC  EQU   SRUTYPE
RHRSVD5  EQU   RH3
RHRSVD4  EQU   RH3
RHLOG    EQU   RH3
RHRSVD3  EQU   RH3
RHRCDIR  EQU   RH3
RHCDIR   EQU   RH3
RHEB     EQU   RH3
RHBB     EQU   RH3
RHPACE   EQU   RH2
RHRSVD2  EQU   RH2
RHINOP   EQU   RHRSVD1
RHBUSY   EQU   RHRETRY
RHRRN    EQU   RH2
RHPE     EQU   RH2
RHSENSE  EQU   RH1
RHDIRI   EQU   RH1
RHQS     EQU   RH1
CSLDATAF EQU   CSLDATA
RPLSEQNO EQU   RPLOF60+6
@NM00052 EQU   RPLIBSQ
RPLIINV  EQU   RPLIBSQ
RPLINEG  EQU   RPLIBSQ
RPLIPOS  EQU   RPLIBSQ
RPLIIGN  EQU   RPLIBSQ
RPLIRSET EQU   RPLIBSQ
RPLITST  EQU   RPLIBSQ
RPLISET  EQU   RPLIBSQ
@NM00051 EQU   RPLOBSQ
RPLOINV  EQU   RPLOBSQ
RPLONEG  EQU   RPLOBSQ
RPLOPOS  EQU   RPLOBSQ
RPLOIGN  EQU   RPLOBSQ
RPLORSET EQU   RPLOBSQ
RPLOTST  EQU   RPLOBSQ
RPLOSET  EQU   RPLOBSQ
RPLIBSQV EQU   RPLOF60+2
RPLOBSQV EQU   RPLOF60
@NM00050 EQU   RPLCNTSC
RPLRSHUT EQU   RPLCNTSC
RPLRQR   EQU   RPLCNTSC
RPLSHUTC EQU   RPLCNTSC
RPLSHUTD EQU   RPLCNTSC
RPLSTSN  EQU   RPLCNTSC
RPLCLEAR EQU   RPLCNTSC
RPLSDT   EQU   RPLCNTSC
@NM00049 EQU   RPLCNTDC
RPLSIGNL EQU   RPLCNTDC
RPLLUS   EQU   RPLCNTDC
RPLRTR   EQU   RPLCNTDC
RPLBID   EQU   RPLCNTDC
@NM00048 EQU   RPLCNTDF
RPLQI    EQU   RPLCNTDF
RPLRELQ  EQU   RPLCNTDF
RPLCHASE EQU   RPLCNTDF
RPLQEC   EQU   RPLCNTDF
RPLQC    EQU   RPLCNTDF
RPLCNCEL EQU   RPLCNTDF
RPLDATA  EQU   RPLCNTDF
RPLRRN   EQU   RPLRESP
RPLNFME  EQU   RPLRESP
RPLEX    EQU   RPLRESP
@NM00047 EQU   RPLRESP
@NM00046 EQU   RPLPOSTV
RPLSCHED EQU   RPLPOSTV
@NM00045 EQU   RPLVTFL1
RPLAUTUS EQU   RPLVTFL1
@NM00044 EQU   RPLVTFL1
@NM00043 EQU   RPLCHN
RPLONLY  EQU   RPLCHN
RPLLAST  EQU   RPLCHN
RPLMIDLE EQU   RPLCHN
RPLFIRST EQU   RPLCHN
@NM00042 EQU   RPLRTYPE
RPLDFASY EQU   RPLRTYPE
RPLNFSYN EQU   RPLRTYPE
RPLRRESP EQU   RPLRTYPE
@NM00041 EQU   RPLSTYPE
RPLSRESP EQU   RPLSTYPE
@NM00040 EQU   RPLRH3
RPLCSI   EQU   RPLRH3
RPLCHREQ EQU   RPLRH3
RPLCMD   EQU   RPLRH3
RPLEB    EQU   RPLRH3
RPLBB    EQU   RPLRH3
RPLSIGDA EQU   RPLVTEXT+32
RPLSAV13 EQU   RPLVTEXT+28
RPLUSNSO EQU   RPLOSENS+2
RPLSSMO  EQU   RPLSSNSO+1
@NM00039 EQU   RPLSSEO
RPLRRO   EQU   RPLSSEO
RPLFIO   EQU   RPLSSEO
RPLSTATO EQU   RPLSSEO
RPLCPMO  EQU   RPLSSEO
@NM00038 EQU   RPLSSEO
RPLFMHDR EQU   RPLOPT12
@NM00037 EQU   RPLOPT12
@NM00036 EQU   RPLOPT12
@NM00035 EQU   RPLOPT12
RPLNIBTK EQU   RPLOPT12
RPLTRUNC EQU   RPLOPT12
RPLKEEP  EQU   RPLOPT12
@NM00034 EQU   RPLOPT12
RPLRSVE8 EQU   RPLOPT11
RPLRSVE7 EQU   RPLOPT11
RPLRSVE6 EQU   RPLOPT11
RPLRSVE5 EQU   RPLOPT11
RPLRSVE4 EQU   RPLOPT11
RPLSTOP  EQU   RPLOPT11
RPLSTART EQU   RPLOPT11
RPLQUIES EQU   RPLOPT11
RPLRSVI6 EQU   RPLOPT10
RPLRSVI5 EQU   RPLOPT10
RPLRSVI4 EQU   RPLOPT10
RPLRSVI3 EQU   RPLOPT10
RPLRSVI2 EQU   RPLOPT10
RPLSPARM EQU   RPLOPT10
RPLDSPLY EQU   RPLOPT10
RPLBSCID EQU   RPLOPT10
RPLTOPL  EQU   RPLOPT9
RPLCIDE  EQU   RPLOPT9
RPLRNNM  EQU   RPLOPT9
RPLAPPST EQU   RPLOPT9
RPLCOUNT EQU   RPLOPT9
RPLTERMS EQU   RPLOPT9
RPLDEVCH EQU   RPLOPT9
RPLLOGON EQU   RPLOPT9
RPLUSFLD EQU   RPLVTEXT+16
RPLESR2  EQU   RPLUSNSI+1
RPLESR1  EQU   RPLUSNSI
RPLSSMI  EQU   RPLDSB2
@NM00033 EQU   RPLSSEI
RPLRRI   EQU   RPLSSEI
RPLFII   EQU   RPLSSEI
RPLSTATI EQU   RPLSSEI
RPLCPMI  EQU   RPLSSEI
RPLPATHI EQU   RPLSSEI
RPLARCLN EQU   RPLVTEXT+8
RPLAARLN EQU   RPLVTEXT+4
RPLAAREA EQU   RPLVTEXT
RPLERMSA EQU   RPLCOMN+72
RPLEMLEN EQU   RPLCOMN+70
RPLACTIV EQU   RPLCOMN+69
RPLBRANC EQU   RPLEXTD1
@NM00032 EQU   RPLEXTD1
RPLEXIT  EQU   RPLEXTD1
RPLNEXIT EQU   RPLEXTD1
RPLEXSCH EQU   RPLEXTD1
RPLDDDD  EQU   RPLRBAR+4
@NM00031 EQU   RPLRBAR+3
@NM00030 EQU   RPLAIXID
RPLAXPKP EQU   RPLAIXID
RPLAIXPC EQU   RPLRBAR
RPLRSV88 EQU   RPLOPT8
RPLUNCON EQU   RPLOPT8
RPLACTV  EQU   RPLOPT8
RPLSESS  EQU   RPLOPT8
RPLPEND  EQU   RPLOPT8
RPLODPRM EQU   RPLOPT8
RPLODACP EQU   RPLOPT8
RPLRSV78 EQU   RPLOPT7
RPLTCRNO EQU   RPLOPT7
RPLRLSOP EQU   RPLOPT7
RPLTPOST EQU   RPLOPT7
RPLQOPT  EQU   RPLOPT7
RPLCNIMM EQU   RPLCNOPT
RPLCNANY EQU   RPLCNOPT
RPLCNALL EQU   RPLCNOPT
RPLRSV68 EQU   RPLOPT6
RPLRSV67 EQU   RPLOPT6
RPLLOCK  EQU   RPLOPT6
RPLNCOND EQU   RPLOPT6
RPLCOND  EQU   RPLOPT6
RPLEOT   EQU   RPLUNTYP
RPLEOM   EQU   RPLUNTYP
RPLEOB   EQU   RPLUNTYP
RPLWROPT EQU   RPLOPT5
RPLNODE  EQU   RPLOPT5
RPLERACE EQU   RPLWRTYP
RPLEAU   EQU   RPLWRTYP
RPLNERAS EQU   RPLWRTYP
RPLPSOPT EQU   RPLOPT5
@NM00029 EQU   RPLOPT5
RPLDLGIN EQU   RPLOPT5
RPLBUFL  EQU   RPLCOMN+52
RPLRLEN  EQU   RPLCOMN+48
RPLCHAIN EQU   RPLNXTRP
RPLBOP   EQU   RPLOPT4
@NM00028 EQU   RPLOPT4
RPLMKFRM EQU   RPLOPT4
RPLENDTR EQU   RPLOPT4
RPLALIGN EQU   RPLOPT3
RPLFMT   EQU   RPLOPT3
RPLFLD   EQU   RPLOPT3
RPLVFY   EQU   RPLOPT3
RPLBLK   EQU   RPLOPT3
RPLSFORM EQU   RPLOPT3
RPLEODS  EQU   RPLOPT3
RPLNSP   EQU   RPLOPT2
RPLUPD   EQU   RPLOPT2
@NM00027 EQU   RPLOPT2
RPLLRD   EQU   RPLOPT2
RPLBWD   EQU   RPLOPT2
RPLCNV   EQU   RPLOPT2
RPLADD   EQU   RPLADR
RPLKEY   EQU   RPLOPT2
RPLECBIN EQU   RPLECBSW
RPLGEN   EQU   RPLOPT1
RPLKGE   EQU   RPLOPT1
RPLASY   EQU   RPLOPT1
RPLSKP   EQU   RPLOPT1
RPLSEQ   EQU   RPLOPT1
RPLDIR   EQU   RPLOPT1
RPLLOC   EQU   RPLOPT1
RPLDAF   EQU   RPLARG+2
RPLSAF   EQU   RPLARG
RPLAREA  EQU   RPLCOMN+32
RPLTCBPT EQU   RPLCOMN+28
RPLDACB  EQU   RPLCOMN+24
RPLCCHAR EQU   RPLCOMN+20
RPLSTRID EQU   RPLCOMN+18
RPLKEYL  EQU   RPLKEYLE
RPLRDSOH EQU   RPLFDB3
RPLRLG   EQU   RPLFDB3
RPLLGFRC EQU   RPLFDB3
RPLREOT  EQU   RPLFDB3
RPLREOM  EQU   RPLFDB3
RPLREOB  EQU   RPLFDB3
RPLSV32  EQU   RPLFDB3
RPLUINPT EQU   RPLFDB3
RPLSTSAV EQU   RPLFDB2
RPLCUERR EQU   RPLFDB2
RPLDLGFL EQU   RPLFDB2
RPLIOERR EQU   RPLFDB2
RPLDVUNS EQU   RPLFDB2
RPLATND  EQU   RPLFDB2
RPLRVID  EQU   RPLFDB2
RPLERLK  EQU   RPLFDB2
RPLERREG EQU   RPLRTNCD
RPLSTAT  EQU   RPLFDBWD
RPLPOST  EQU   RPLECB
RPLWAIT  EQU   RPLECB
RPLPLHPT EQU   RPLCOMN+4
RPLLEN2  EQU   RPLLEN
RPLREQ   EQU   RPLIDWD+2
RPLSTYP  EQU   RPLIDWD+1
RPLID    EQU   RPLIDWD
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00026 EQU   CVTFIX+248
@NM00025 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTSHSB  EQU   CVTSHS
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
@NM00024 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00023 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00022 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00021 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSARV011 EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSARV063 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00020 EQU   FLCFSA
@NM00019 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00018 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00017 EQU   FLCIOA
@NM00016 EQU   FLCMCLA+15
@NM00015 EQU   FLCMCLA+14
@NM00014 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00013 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00012 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00011 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00010 EQU   FLCPER
@NM00009 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00008 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00007 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00006 EQU   FLCPIILC
@NM00005 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00004 EQU   FLCSVILC
@NM00003 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00002 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00001 EQU   FLCICCW2+4
FLCCVT   EQU   FLCICCW2
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00708 EQU   @RC00706
@RC00698 EQU   @RC00694
@RC01096 EQU   @RC01077
@PB00007 EQU   @PB00008
@RC01491 EQU   @RC01463
@RC01536 EQU   @RC01534
@RC01542 EQU   @RC01534
@RC01877 EQU   @RC01876
@RC01823 EQU   @RC01793
@RC02031 EQU   @RC02016
@RC02023 EQU   @RC02016
@RC02017 EQU   @RC02016
@RC02051 EQU   @RC02041
@RC02057 EQU   @RC02041
@RC02091 EQU   @RC02090
@PB00009 EQU   @PB00010
@RC00766 EQU   @RC00708
@RC00701 EQU   @RC00698
@RC01107 EQU   @RC01096
@PB00006 EQU   @PB00007
@RC01516 EQU   @RC01491
@RC01546 EQU   @RC01542
@RC01544 EQU   @RC01542
@RC01552 EQU   @RC01542
@RC01926 EQU   @RC01877
@RC02006 EQU   @RC01823
QNCSPL@  EQU   @PB00009
@RC00782 EQU   @RC00766
@RC00859 EQU   @RC00701
@PB00005 EQU   @PB00006
SENDBS#  EQU   @RC01552
@RC01927 EQU   @RC01926
@RC00811 EQU   @RC00782
@RC00868 EQU   @RC00859
@PB00004 EQU   @PB00005
@RC00877 EQU   @RC00868
@PB00003 EQU   @PB00004
@PB00002 EQU   @PB00003
@ENDDATA EQU   *
         END   ISTOCCOE,(C'PLS1851',0603,78103)
