SVTM     TITLE 'ISTOCCOF - OPNDST CLEANUP ROUTINES                     *
                        '
ISTOCCOF CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'ISTOCCOF  75.217'                                 0001
         DROP  @15
@PROLOG  BALR  @12,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@12                                         0001
         PRINT OFF
         PRINT ON
*/********************************************************************/
*/*                                                                  */
*/*   ROUTINE NAME: MAINLINE                                         */
*/*                                                                  */
*/*   FUNCTION: 1. RELEASE HELD LOCKS                                */
*/*             2. PUT RETURN CODE AND SENSE INFORMATION IN USER'S   */
*/*                RPL                                               */
*/*             3. IF A SYSTEM ERROR HAS NOT OCCURRED DO:            */
*/*                A. FREE LOGON BUFFER                              */
*/*                B. FREE RESOURCES SET UP BY OPNDST PARTS 1 & 2    */
*/*                C. FREE LIST AREA POINTED TO BY OCWODLST          */
*/*                                                                  */
*/*   INPUT: RPHPTR (R1) - POINTER TO CURRENT RPH                    */
*/*          OCWPTR (R4) - POINTER O/C WORK ELEMENT                  */
*/*                                                                  */
*/*   OUTPUT: (SEE FUNCTION)                                         */
*/*                                                                  */
*/*   ROUTINES CALLED: DOVALINT - COPY/MERGE USER'S NIB FROM LIST    */
*/*                    DCLENUP  - CLOSE ANY PARTIALLY OPENED         */
*/*                               DESTINATIONS                       */
*/*                    ISTOCCUR - EXIT                               */
*/*                                                                  */
*/*   MACROS USED: CRRMAINT, RELSTORE, TPLOCK, FREESTOR, TPUNLOCK    */
*/*                                                                  */
*/********************************************************************/
*                                                                  0434
*           DO;                                                    0434
*/***  CRRMAINT  PROCNM(ISTOCCOF)COMP(OC)FUNC(SUB)  ***/           0435
*           DCL CMZK0009 PTR(31) REG(1);                           0435
*           RFY (CMZK0009) RSTD;                                   0436
*                                                                  0436
*/* ATBUILD (ISTRPH,ISTCRA,ISTPFCRR,ISTOCCRR)  */                  0437
*/* END OF ATBUILD */                                              0437
*           /*** SET ENTERED BIT FOR THIS PROCEDURE ***/           0437
*CMZK0009->RPHCRR->CRACRR->NOCCOF = '1'B;                          0437
         L     @15,RPHCRR(,CMZK0009)                               0437
         L     @15,CRACRR(,@15)                                    0437
         OI    NOCCOF(@15),B'00000100'                             0437
*           /*** CLEAR AND SET CURRENT PROCEDURE BIT ***/          0438
*CMZK0009->RPHCRR->CRACRR->OCCCRT = '0'B;                          0438
         XC    OCCCRT+1(2,@15),OCCCRT+1(@15)                       0438
         MVI   OCCCRT(@15),B'00000000'                             0438
*CMZK0009->RPHCRR->CRACRR->COCCOF = '1'B;                          0439
         OI    COCCOF(@15),B'00000100'                             0439
*           END;/* TRACE    */                                     0440
*          C14SVPTR=ADDR(OCWR14SV)+4;/* SET UP REG 14 SAVE AREA ADDR */
         LA    @15,OCWR14SV(,OCWPTR)                               0441
         AL    @15,@CF00044                                        0441
         ST    @15,C14SVPTR+624(,OCWPTR)                           0441
*          IF OCWRC='24'X THEN;     /* SYSTEM ERROR? YES.            */
         CLI   OCWRC(OCWPTR),X'24'                                 0442
         BE    @RT00442                                            0442
*          ELSE                     /* NO,                           */
*            DO;                    /* DO THE FOLLOWING:             */
*              OCWSVRC=OCWRC;       /* SAVE RETURN CODE              */
         MVC   OCWSVRC(1,OCWPTR),OCWRC(OCWPTR)                     0445
*              OCWSVEC=OCWEC;       /* SAVE ERROR CODE               */
         MVC   OCWSVEC(1,OCWPTR),OCWEC(OCWPTR)                     0446
*              OCWODCT1=CZERO;      /* ZERO LOOP CONTROL COUNT       */
         SLR   @15,@15                                             0447
         STH   @15,OCWODCT1(,OCWPTR)                               0447
*              DO WHILE(OCWRC^='24'X &                             0448
*                       OCWODCT1^=(OCWDSTNO-OCWBADNO));            0448
         B     @DE00448                                            0448
@DL00448 DS    0H                                                  0449
*                                   /* DO THE FOLLOWING UNTIL EITHER
*                                      SYSTEM ERROR OR END OF DATA 0449
*                                      IS DETECTED:          @DM14174*/
*                RFY                                               0449
*                  RLEPTR RSTD;     /*                       @D32CKMP*/
*                RLEPTR=OCWODLST+(LENGTH(ISTCSL)*OCWODCT1);        0450
         LH    RLEPTR,OCWODCT1(,OCWPTR)                            0450
         MH    RLEPTR,@CH00032                                     0450
         AL    RLEPTR,OCWODLST(,OCWPTR)                            0450
*                                   /* POINT AT RSCE LIST            */
*                                   /* ENTRY TO BE WORKED    @D32CKMP*/
*                IF CSLDATA=CZERO   /* IF NO LOGON DATA BUFS         */
*                  THEN;            /*                       @D32CKMP*/
         L     @15,CSLDATA(,RLEPTR)                                0451
         LTR   @15,@15                                             0451
         BZ    @RT00451                                            0451
*                  ELSE             /* HAVE LOGON DATA BUFS          */
*                  DO;              /* TO FREE, SO           @D32CKMP*/
*                  IF RPLREQ='16'X&OCWSVRC=0                       0454
*                    THEN;          /* DO NOT FREE BUFS      @DM13317*/
         L     @15,OCWRPL(,OCWPTR)                                 0454
         CLI   RPLREQ(@15),22                                      0454
         BNE   @RF00454                                            0454
         CLI   OCWSVRC(OCWPTR),0                                   0454
         BE    @RT00454                                            0454
*                    ELSE DO;       /*                       @DM13317*/
@RF00454 DS    0H                                                  0457
*                    /*RELSTORE BUFADDR(CSLDATA)*/                 0457
*                     DO;                                          0457
*/* ATBUILD (ISTATCVT,ISTRPH)  */                                  0458
*/* END OF ATBUILD */RFY (GPR02P,GPR03P,GPR04P,GPR15P) RSTD;       0458
*         RFY (GPR01P,GPR13P) RSTD;                                0459
*         GENERATE REFS(GPR01P,GPR02P,GPR13P) SETS(RPHWORK);       0460
*                                                                  0460
          STM GPR02P,GPR13P,RPHWORK(GPR01P)
*         RFY GPR13P UNRSTD;                                       0461
*         GPR04P=CSLDATA;                                          0462
         L     GPR04P,CSLDATA(,RLEPTR)                             0462
*         DCL 1 FMZA0011 FIXED(31) STATIC LOCAL,                   0463
*             2 * FIXED(8) INIT(64),                               0463
*             2 * PTR(24) INIT(0);                                 0463
*         GPR03F = FMZA0011;                                       0464
*                                                                  0464
         L     GPR03F,FMZA0011                                     0464
*                    DO; /* LISATCVT CVTBASE(PAGEABLE,(GPR15P)) */ 0465
*                      GPR15P = ATCLCPTR; /*SET UP ATCVT POINTER*/ 0466
         L     GPR15P,ATCLCPTR                                     0466
*                    END; /*LISATCVT*/                             0467
*         GPR02P = GPR15P->ATCBPDA;                                0468
         L     GPR02P,ATCBPDA(,GPR15P)                             0468
*         GPR15P=GPR15P->ATCSMRS;                                  0469
         L     GPR15P,ATCSMRS(,GPR15P)                             0469
*         DCL FMZL0011 BASED(GPR15P) LABEL VALUERANGE(*);          0470
*         CALL FMZL0011;                                           0471
         BALR  @14,@15                                             0471
*         RFY GPR13P RSTD;                                         0472
*         GENERATE REFS(GPR01P,RPHWORK) SETS(GPR02P,GPR13P);       0473
*                                                                  0473
          LM GPR02P,GPR13P,RPHWORK(GPR01P)
*         RFY (GPR01P,GPR13P) UNRSTD;                              0474
*                    RFY (GPR02P,GPR03P,GPR04P,GPR15P) UNRSTD;     0475
*                    END ;/**********END OF RELSTORE EXPANSION*********
*/ /* FREE BUFS @D32CKMP*/                                         0476
*                    CSLDATA=CZERO; /* CLEAR LOGON DATA BUFS       0477
*                                      PTR IN RSCE LIST NTRY @D32CKMP*/
         SLR   @15,@15                                             0477
         ST    @15,CSLDATA(,RLEPTR)                                0477
*                    END;           /*                       @DM13317*/
*                  END;             /*                       @D32CKMP*/
@RT00454 DS    0H                                                  0480
*                OCWDRDTE=CSLRDEF;  /* COPY RSCE LIST NTRY         0480
*                                      RDTE PTR AND NDICATR  @D32CKMP*/
@RT00451 L     @15,CSLRDEF(,RLEPTR)                                0480
         ST    @15,OCWDRDTE(,OCWPTR)                               0480
*                IF OCWDSTNO>1                                     0481
*                  THEN             /* LIST DCR3934.1        @D32CKXY*/
         LH    @15,OCWDSTNO(,OCWPTR)                               0481
         C     @15,@CF00067                                        0481
         BNH   @RF00481                                            0481
*                OCWNIB=CSLNDEF;    /* COPY RSCE LIST ENTRY        0482
*                                      NIB PTR AND INDICATOR @D32CKMP*/
         L     @15,CSLNDEF(,RLEPTR)                                0482
         ST    @15,OCWNIB(,OCWPTR)                                 0482
*                  ELSE             /* SINGLE ELEMENT REQUEST        */
*                OCWNIB=OCWOENIB;   /* DCR3934.1             @D32CKXY*/
         B     @RC00481                                            0483
@RF00481 L     @15,OCWOENIB(,OCWPTR)                               0483
         ST    @15,OCWNIB(,OCWPTR)                                 0483
*                IF CSLRDTEF=CON    /* IF DEST OBTAINED              */
*                  THEN             /*                               */
@RC00481 TM    CSLRDTEF(RLEPTR),B'10000000'                        0484
         BNO   @RF00484                                            0484
*                  DO;              /*                       @D32CKMP*/
*                    IF OCWRLOCK=CON THEN;/* RDT LOCK HELD? YES.     */
         TM    OCWRLOCK(OCWPTR),B'01000000'                        0486
         BO    @RT00486                                            0486
*                    ELSE           /* NO,                           */
*                      DO;          /* DO THE FOLLOWING:             */
*                                                                  0488
*/*** START -TPLOCK (RDTLOCK)- ***/                                0489
*                       DO;                                        0489
*                       RFY (GPR00P,GPR01P,GPR02P,GPR03P,GPR04P,GPR15P)
*RSTD;   GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(RPHWORK);
         STM GPR00P,GPR14P,RPHWORK(GPR01P)
*        GPR15P = ATCAP35;              /*ADDRESS OF LOCK ROUTINE*/
         L     @08,OCWACVT(,OCWPTR)                                0492
         L     GPR15P,ATCAP35(,@08)                                0492
*        GPR02P = ADDR(ATCRDTLK);       /*SET PARAM - LOCKWORD PTR*/
         LA    GPR02P,ATCRDTLK(,@08)                               0493
*        GPR04P = GPR01P->RPHCRR;       /*SET PARAM - ISTCRA PTR*/ 0494
         L     GPR04P,RPHCRR(,GPR01P)                              0494
*        GPR00P = CRALMS03;             /*SET PARAM - LOCK LEVEL FLAG*/
         LA    GPR00P,4                                            0495
*        GPR03P = ADDR(GPR04P->CRAL3PTR);                          0496
         LA    GPR03P,CRAL3PTR(,GPR04P)                            0496
*                                       /*SET PARAM - LOCK LEVEL PTR*/
*        DCL FMZL0027 BASED(GPR15P) LABEL VALUERANGE(*);           0497
*        CALL FMZL0027;                                            0498
         BALR  @14,@15                                             0498
*        GENERATE REFS(GPR00P,GPR01P,GPR14P,RPHWORK) SETS(GPR00P,GPR01P
*GPR02P,GPR03P,GPR04P,GPR05P,GPR06P,GPR07P,GPR08P,GPR09P,GPR10P,GPR11P,
*PR12P,GPR13P,GPR14P,GPR15P);                                      0499
         LM GPR00P,GPR15P,RPHWORK(GPR01P)
*                       RFY (GPR00P,GPR01P,GPR02P,GPR03P,GPR04P,GPR15P)
*UNRSTD; END;                                                      0500
*/*** END -TPLOCK (RDTLOCK)- ***//* LOCK RDT                 */    0502
*                        RFY RCREG RSTD;                           0502
*                        IF RCREG=CZERO THEN /* SUCCESSFUL COMPLETE? */
         LTR   RCREG,RCREG                                         0503
         BNZ   @RF00503                                            0503
*                          OCWRLOCK=CON;/* YES, INDICATE LOCK OBTNED */
         OI    OCWRLOCK(OCWPTR),B'01000000'                        0504
*                        ELSE       /* NO,                           */
*                          DO;      /* DO THE FOLLOWING:             */
         B     @RC00503                                            0505
@RF00503 DS    0H                                                  0506
*                            OCWRC='24'X;   /* INDICATE SYSTEM ERROR */
         MVI   OCWRC(OCWPTR),X'24'                                 0506
*                            OCWEC='06'X;   /* IND RDT LOCK NOT OBTD */
         MVI   OCWEC(OCWPTR),X'06'                                 0507
*                          END;                                    0508
*                        RFY RCREG UNRSTD;                         0509
@RC00503 DS    0H                                                  0510
*                      END;                                        0510
*                    IF OCWRC='24'X THEN;    /* SYSTEM ERROR? YES,   */
@RT00486 CLI   OCWRC(OCWPTR),X'24'                                 0511
         BE    @RT00511                                            0511
*                    ELSE           /* NO,                           */
*                      DO;          /* DO THE FOLLOWING:             */
*                        CPRMRG0=1; /* SET UP PARAMETER REGISTER     */
         LA    CPRMRG0,1                                           0514
*                        CALL DOVALINT;/* COPY NIB                   */
         BAL   @14,DOVALINT                                        0515
*                        IF OCWRC='24'X THEN;   /* SYSTEM ERROR? YES.*/
         CLI   OCWRC(OCWPTR),X'24'                                 0516
         BE    @RT00516                                            0516
*                        ELSE       /* NO,                           */
*                          DO;      /* DO THE FOLLOWING:             */
*                             /*SEGMENT(DCLENUP)REQUEST*/DO;GOTO DCLENU
*;DCLENUP#:END;/* CLOSE ANY                                        0519
*   PARTIALLY OPENED DESTS  */                                     0519
         B     DCLENUP                                             0520
DCLENUP# DS    0H                                                  0522
*                            IF OCWRC='24'X THEN;   /* SYS ERR? YES. */
         CLI   OCWRC(OCWPTR),X'24'                                 0522
         BE    @RT00522                                            0522
*                            ELSE   /* NO,                           */
*                              DO;  /* DO THE FOLLOWING:             */
*                                IF OCWRC='08'X & OCWEC='01'X THEN 0525
         CLI   OCWRC(OCWPTR),X'08'                                 0525
         BNE   @RF00525                                            0525
         CLI   OCWEC(OCWPTR),X'01'                                 0525
         BNE   @RF00525                                            0525
*                                  DO;/* DO THE FOLLOWING:           */
*                                    OCWRC=CZERO;/* CLEAR RC         */
         MVI   OCWRC(OCWPTR),X'00'                                 0527
*                                    OCWEC=CZERO;/* CLEAR EC         */
         MVI   OCWEC(OCWPTR),X'00'                                 0528
*                                  END;                            0529
*                                ELSE /* NO,                         */
*                                  DO;/* DO THE FOLLOWING:           */
         B     @RC00525                                            0530
@RF00525 DS    0H                                                  0531
*                                    CPRMRG0='80000000'X;/* SET PARM */
         L     CPRMRG0,@CF02699                                    0531
*                                    IF OCWDSTNO>1                 0532
*                                      THEN /*LIST DCR3934.1 @D32CKXY*/
         LH    @15,OCWDSTNO(,OCWPTR)                               0532
         C     @15,@CF00067                                        0532
         BNH   @RF00532                                            0532
*                                        OCWNIB=CSLNDEF; /* GET    0533
*                                          RSCE LIST ENTRY NIB     0533
*                                          PTR AND INDICATOR       0533
*                                          AGAIN             @D32CKMP*/
         L     @15,CSLNDEF(,RLEPTR)                                0533
         ST    @15,OCWNIB(,OCWPTR)                                 0533
*                                      ELSE /*SING ELEMENT DCR3934.1 */
*                                        OCWNIB=OCWOENIB;  /*@D32CKXY*/
         B     @RC00532                                            0534
@RF00532 L     @15,OCWOENIB(,OCWPTR)                               0534
         ST    @15,OCWNIB(,OCWPTR)                                 0534
*                                    CALL DOVALINT;/* MERGE NIB      */
@RC00532 BAL   @14,DOVALINT                                        0535
*                                  END;                            0536
*                              END;                                0537
@RC00525 DS    0H                                                  0538
*                          END;                                    0538
@RT00522 DS    0H                                                  0539
*                      END;                                        0539
@RT00516 DS    0H                                                  0540
*                RFY                                               0540
*                  RLEPTR UNRSTD;   /*                       @D32CKMP*/
@RT00511 DS    0H                                                  0541
*                  END;                                            0541
*                ELSE;              /* NO.                           */
@RF00484 DS    0H                                                  0543
*                OCWODCT1=OCWODCT1+1;/* INCREMENT LOOP CONTROL COUNT */
         LA    @15,1                                               0543
         AH    @15,OCWODCT1(,OCWPTR)                               0543
         STH   @15,OCWODCT1(,OCWPTR)                               0543
*              END;                                                0544
@DE00448 CLI   OCWRC(OCWPTR),X'24'                                 0544
         BE    @DC00448                                            0544
         LH    @15,OCWDSTNO(,OCWPTR)                               0544
         SH    @15,OCWBADNO(,OCWPTR)                               0544
         CH    @15,OCWODCT1(,OCWPTR)                               0544
         BNE   @DL00448                                            0544
@DC00448 DS    0H                                                  0545
*            END;                                                  0545
*          IF OCWRC='24'X THEN;     /* SYSTEM ERROR? YES.            */
@RT00442 CLI   OCWRC(OCWPTR),X'24'                                 0546
         BE    @RT00546                                            0546
*          ELSE                     /* NO,                           */
*            DO;                    /* DO THE FOLLOWING:             */
*              OCWRC=OCWSVRC;       /* RESET ORIGINAL RETURN CODE    */
         MVC   OCWRC(1,OCWPTR),OCWSVRC(OCWPTR)                     0549
*              OCWEC=OCWSVEC;       /* RESET ORIGINAL ERROR CODE     */
         MVC   OCWEC(1,OCWPTR),OCWSVEC(OCWPTR)                     0550
*              IF OCWGTLST=CON &    /* IF LIST SPACE GOT             */
*                 OCWODLST^=ADDR(OCWCSL) /* VIA SMS                  */
*                THEN               /*                       @D32CKMP*/
         TM    OCWGTLST(OCWPTR),B'10000000'                        0551
         BNO   @RF00551                                            0551
         LA    @15,OCWCSL(,OCWPTR)                                 0551
         C     @15,OCWODLST(,OCWPTR)                               0551
         BE    @RF00551                                            0551
*                DO;                /*                       @D32CKMP*/
*                   /*FREESTOR AREA(OCWODLST)TYPE(PAGEABLE)FETCHP(NO)SI
*E(OCWLALEN)CLEAR(NO)SAVE(YES)*/                                   0553
*                    DO;                                           0553
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTATCVT,ISTRPH)  */                  0554
*/* END OF ATBUILD */                                              0554
*                   RFY (GPR00P,GPR01P,GPR02P,GPR03P) RSTD;        0554
*                   RFY ISTRPH BASED(GPR01P);                      0555
*                   GEN REFS(GPR02P,GPR03P,GPR04P,GPR05P,          0556
*                            GPR06P,GPR07P,GPR08P,GPR09P,          0556
*                            GPR10P,GPR11P,GPR12P,GPR13P)          0556
*                       SETS(RPHWORK);                             0556
*                                                                  0556
         STM   GPR02P,GPR13P,RPHWORK(GPR01P)        SAVE REGISTERS
*                   GPR00F = OCWLALEN;                 /*SIZE IN REG0*/
         LH    GPR00F,OCWLALEN(,OCWPTR)                            0557
*                   DCL 1 CMZA0033 FIXED(31) STATIC LOCAL,         0558
*                         2 * FIXED(8) INIT(64),     /* OPTION FLAGS */
*                         2 * FIXED(8) INIT(96),      /* STORAGE KEY */
*                         2 * FIXED(8) INIT(241),  /* SUBPOOL NUMBER */
*                         2 * FIXED(8) INIT('01'X);  /* REQUEST TYPE */
*                   GPR03F = CMZA0033;                             0559
         L     GPR03F,CMZA0033                                     0559
*                   RFY (GPR04P) RSTD;                             0560
*                   GPR04P = OCWODLST;    /*PUT FREEMAIN ADDR IN REG4*/
*                                                                  0561
         L     GPR04P,OCWODLST(,OCWPTR)                            0561
*                   DO; /* LISATCVT CVTBASE(PAGEABLE,(GPR02P)) */  0562
*                     GPR02P = ATCLCPTR; /*SET UP ATCVT POINTER*/  0563
         L     GPR02P,ATCLCPTR                                     0563
*                   END; /*LISATCVT*/                              0564
*                   CALL GPR02P -> ATCGTSTR;          /*CALL ISTORFSR*/
         L     @15,ATCGTSTR(,GPR02P)                               0565
         BALR  @14,@15                                             0565
*                   RFY (GPR00P,GPR01P,GPR02P,GPR03P,GPR04P) UNRSTD;
*                   END ;                           /*END OF FREESTOR*/
*                    /* FREE LIST AREA FETCHP ADDED FOR DCR 3661.4   */
*                  OCWODLST=CZERO;  /* INDICATE LIST FREED           */
         SLR   @15,@15                                             0568
         ST    @15,OCWODLST(,OCWPTR)                               0568
*                END;                                              0569
*              ELSE;                /* NO.                           */
@RF00551 DS    0H                                                  0571
*            END;                                                  0571
*          IF OCWRLOCK=CON THEN     /* RDT LOCK HELD? YES,           */
@RT00546 TM    OCWRLOCK(OCWPTR),B'01000000'                        0572
         BNO   @RF00572                                            0572
*            DO;                    /* DO THE FOLLOWING:             */
*                                                                  0573
*/*** START -TPUNLOCK (RDTLOCK)- ***/                              0574
*               DO;                                                0574
*                                                                  0574
*/* ATBUILD (ISTRPH,ISTLOK,ISTCRA)  */                             0575
*/* END OF ATBUILD */                                              0575
*               RFY (GPR00P,GPR01P,GPR02P,GPR03P,GPR04P,GPR15P) RSTD;
*        GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(RPHWORK);
         STM GPR00P,GPR15P,RPHWORK(GPR01P)
*        GPR02P = ADDR(ATCRDTLK);       /*SET PARAM - LOCKWORD PTR*/
         L     GPR02P,OCWACVT(,OCWPTR)                             0577
         LA    GPR02P,ATCRDTLK(,GPR02P)                            0577
*        GPR04P = GPR01P->RPHCRR;       /*SET PARAM - ISTCRA PTR*/ 0578
         L     GPR04P,RPHCRR(,GPR01P)                              0578
*        GPR00P = CRALMS03;             /*SET PARAM - LOCK LEVEL FLAG*/
         LA    GPR00P,4                                            0579
*        GPR03P = ADDR(GPR04P->CRAL3PTR);                          0580
         LA    GPR03P,CRAL3PTR(,GPR04P)                            0580
*                                       /*SET PARAM - LOCK LEVEL PTR*/
*                                                                  0581
*               DO; /* LISATCVT CVTBASE(PAGEABLE,(GPR15P)) */      0581
*                 GPR15P = ATCLCPTR; /*SET UP ATCVT POINTER*/      0582
         L     GPR15P,ATCLCPTR                                     0582
*               END; /*LISATCVT*/                                  0583
*        GPR15P=GPR15P->ATCAP33;                                   0584
         L     GPR15P,ATCAP33(,GPR15P)                             0584
*        DCL FMZL0052 BASED(GPR15P) LABEL VALUERANGE(*);           0585
*        CALL FMZL0052;                                            0586
         BALR  @14,@15                                             0586
*        GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(GPR00P,GPR01P
*GPR02P,GPR03P,GPR04P,GPR05P,GPR06P,GPR07P,GPR08P,GPR09P,GPR10P,GPR11P,
*PR12P,GPR13P,GPR14P,GPR15P);                                      0587
         LM GPR00P,GPR15P,RPHWORK(GPR01P)
*               RFY (GPR00P,GPR01P,GPR02P,GPR03P,GPR04P,GPR15P) UNRSTD;
*        END;                                                      0589
*/*** END -TPUNLOCK (RDTLOCK)- ***/ /* RELEASE RDT                   */
*              OCWRLOCK=COFF;       /* INDICATE RDT LOCK NOT HELD    */
         NI    OCWRLOCK(OCWPTR),B'10111111'                        0590
*            END;                                                  0591
*          ELSE;                    /* NO.                           */
@RF00572 DS    0H                                                  0593
*          IF OCWVLOCK=CON THEN     /* VOC LOCK HELD? YES,           */
         TM    OCWVLOCK(OCWPTR),B'10000000'                        0593
         BNO   @RF00593                                            0593
*            DO;                    /* DO THE FOLLOWING:             */
*                                                                  0594
*/*** START -TPUNLOCK (VOCLOCK)- ***/                              0595
*               DO;                                                0595
*                                                                  0595
*/* ATBUILD (ISTRPH,ISTLOK,ISTCRA)  */                             0596
*/* END OF ATBUILD */                                              0596
*               RFY (GPR00P,GPR01P,GPR02P,GPR03P,GPR04P,GPR15P) RSTD;
*        GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(RPHWORK);
         STM GPR00P,GPR15P,RPHWORK(GPR01P)
*        GPR02P = ADDR(ATCVOCLK);       /*SET PARAM - LOCKWORD PTR*/
         L     GPR02P,OCWACVT(,OCWPTR)                             0598
         LA    GPR02P,ATCVOCLK(,GPR02P)                            0598
*        GPR04P = GPR01P->RPHCRR;       /*SET PARAM - ISTCRA PTR*/ 0599
         L     GPR04P,RPHCRR(,GPR01P)                              0599
*        GPR00P = CRALMS02;             /*SET PARAM - LOCK LEVEL FLAG*/
         LA    GPR00P,2                                            0600
*        GPR03P = ADDR(GPR04P->CRAL2PTR);                          0601
         LA    GPR03P,CRAL2PTR(,GPR04P)                            0601
*                                       /*SET PARAM - LOCK LEVEL PTR*/
*                                                                  0602
*               DO; /* LISATCVT CVTBASE(PAGEABLE,(GPR15P)) */      0602
*                 GPR15P = ATCLCPTR; /*SET UP ATCVT POINTER*/      0603
         L     GPR15P,ATCLCPTR                                     0603
*               END; /*LISATCVT*/                                  0604
*        GPR15P=GPR15P->ATCAP33;                                   0605
         L     GPR15P,ATCAP33(,GPR15P)                             0605
*        DCL FMZL0062 BASED(GPR15P) LABEL VALUERANGE(*);           0606
*        CALL FMZL0062;                                            0607
         BALR  @14,@15                                             0607
*        GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(GPR00P,GPR01P
*GPR02P,GPR03P,GPR04P,GPR05P,GPR06P,GPR07P,GPR08P,GPR09P,GPR10P,GPR11P,
*PR12P,GPR13P,GPR14P,GPR15P);                                      0608
         LM GPR00P,GPR15P,RPHWORK(GPR01P)
*               RFY (GPR00P,GPR01P,GPR02P,GPR03P,GPR04P,GPR15P) UNRSTD;
*        END;                                                      0610
*/*** END -TPUNLOCK (VOCLOCK)- ***/ /* RELEASE VOC                   */
*              OCWVLOCK=COFF;       /* INDICATE VOC LOCK NOT HELD    */
         NI    OCWVLOCK(OCWPTR),B'01111111'                        0611
*            END;                                                  0612
*          ELSE;                    /* NO.                           */
@RF00593 DS    0H                                                  0614
*          RPLRTNCD=OCWRC;          /* PUT RETURN CODE IN RPL        */
         L     @15,OCWRPL(,OCWPTR)                                 0614
         MVC   RPLRTNCD(1,@15),OCWRC(OCWPTR)                       0614
*          RPLFDB2=OCWEC;           /* PUT ERROR CODE IN RPL         */
         MVC   RPLFDB2(1,@15),OCWEC(OCWPTR)                        0615
*          RPLSIGDA=OCWSENSE;       /* SENS INFO IN USER RPL @XM09392*/
         MVC   RPLSIGDA(4,@15),OCWSENSE(OCWPTR)                    0616
*          CALL ISTOCCUR;           /* EXIT TO THE UNROUTER          */
         L     @15,@CV04432                                        0617
         BALR  @14,@15                                             0617
* /*SEGMENT(DCLENUP)START*/DO;GOTO DCLENUP@;DCLENUP:END;           0618
         B     DCLENUP@                                            0619
DCLENUP  DS    0H                                                  0621
*/********************************************************************/
*/*                                                                  */
*/*   ROUTINE NAME: DCLENUP - CLOSE PARTIALLY OPENED DESTINATIONS    */
*/*                                                                  */
*/*   FUNCTION: 1. IF AN ACE IS ON THE RCPACETR QUEUE AND NO ERROR   */
*/*                HAS BEEN ENCOUNTERED CLEAR THE RPH POINTER IN IT  */
*/*                BECAUSE IT IS MEANINGLESS                         */
*/*             2. IF THE LAST ACE ON THE QUEUE DOESN'T POINT TO OUR */
*/*                RPH, CLEAR FLAGS IN THE USER'S NIB                */
*/*             3. IF AN ERROR HAS BEEN ENCOUNTERED BY OPNDST, GO TO */
*/*                CLOSDEST TO FREE CONNECTIONS AND CLEAR NIB        */
*/*                                                                  */
*/*   INPUT: OCWDRDTE - POINTER TO CURRENT RDTE                      */
*/*          OCWNIB   - POINTER TO CURRENT NIB                       */
*/*             (NOTE: THE ABOVE ARE SET UP BY MAIN LINE)            */
*/*                                                                  */
*/*   OUTPUT: (SEE FUNCTION)                                         */
*/*                                                                  */
*/*   ROUTINES CALLED: ISTOCCCL - FREE PARTIALLY OPENED CONNECTIONS  */
*/*                                                                  */
*/*   MACROS USED: CRRMAINT                                          */
*/*                                                                  */
*/********************************************************************/
*    RFY (RLEPTR,RCREG) RSTD;           /*                   @D32CKCK*/
*    IF OCWODCLS=COFF                   /* CONN NOT MADE     @D32CKCK*/
*       | OCWNOCON=CON                  /*  OR NO CALL CNSRV @D32CKCK*/
*     THEN;                             /*                   @D32CKCK*/
         TM    OCWODCLS(OCWPTR),B'00100000'                        0622
         BZ    @RT00622                                            0622
         TM    OCWNOCON(OCWPTR),B'00100000'                        0622
         BO    @RT00622                                            0622
*     ELSE DO;                          /*                   @D32CKCK*/
*      OCWFMCB=CZERO;                   /* CLR FMCB PTR      @DM14343*/
         SLR   @08,@08                                             0625
         ST    @08,OCWFMCB(,OCWPTR)                                0625
*      IF OCWDSTNO>1                    /* LIST REQUEST      @D32CKCK*/
*        THEN DO;                       /*                   @D32CKCK*/
         LH    @08,OCWDSTNO(,OCWPTR)                               0626
         C     @08,@CF00067                                        0626
         BNH   @RF00626                                            0626
*         OCWODNAS=OCWODLST+            /* SLOT PTR=LIST ADR @D32CKCK*/
*          (OCWDSTNO*LENGTH(ISTCSL))+   /*  + # DSTS*NTRYLEN @D32CKCK*/
*          (OCWODCT1*4);                /*   +LOOP CTR*LEN   @D32CKCK*/
         MH    @08,@CH00032                                        0628
         AL    @08,OCWODLST(,OCWPTR)                               0628
         LH    @07,OCWODCT1(,OCWPTR)                               0628
         SLA   @07,2                                               0628
         ALR   @08,@07                                             0628
         ST    @08,OCWODNAS(,OCWPTR)                               0628
*         NWKADR=OCWODNAS->SORTCID;     /* SET UP NETWK ADR  @D32CKCK*/
         L     NWKADR,SORTCID(,@08)                                0629
*         END;                          /*                   @D32CKCK*/
*        ELSE NWKADR=OCWCID;            /* SET UP NETWK ADR  @D32CKCK*/
         B     @RC00626                                            0631
@RF00626 L     NWKADR,OCWCID(,OCWPTR)                              0631
*        RFY NWKSAF RSTD;               /* NETWORK SAF       @D32CKCK*/
@RC00626 DS    0H                                                  0633
*        NWKSAF=NWKADR&'FFFF0000'X;     /* CLEAR DAF         @D32CKCK*/
         LR    NWKSAF,NWKADR                                       0633
         N     NWKSAF,@CF04435                                     0633
*       IF NWKSAF=CZERO                 /* NETWK ADR SAF 0   @D32CKCK*/
*        THEN DO;                       /*                   @D32CKCK*/
         LTR   NWKSAF,NWKSAF                                       0634
         BNZ   @RF00634                                            0634
*         RFY NWKSAF UNRSTD;            /*                   @D32CKCK*/
*           /*SEGMENT(CKACE)REQUEST*/DO;GOTO CKACE;CKACE#:END;    /* VE
*IFY RDTE & ACE @D32CKCK*/                                         0637
         B     CKACE                                               0638
CKACE#   DS    0H                                                  0640
*         IF RCREG^=CZERO               /* RC^=0?            @D32CKCK*/
*          THEN DO;                     /* ACE NOT FOUND     @D32CKCK*/
         SLR   @08,@08                                             0640
         CR    RCREG,@08                                           0640
         BE    @RF00640                                            0640
*           NIBCID=CZERO;               /* ZERO NIB CID      @D32CKCK*/
         L     @07,OCWNIB(,OCWPTR)                                 0642
         ST    @08,NIBCID(,@07)                                    0642
*           NIBCON=COFF;                /* NIB CONN BIT OFF  @D32CKCK*/
         NI    NIBCON(@07),B'10111111'                             0643
*           CSLRDTEF=COFF;              /* CLR HOB RDTE PTR  @D32CKCK*/
         NI    CSLRDTEF(RLEPTR),B'01111111'                        0644
*           END;                        /*                   @D32CKCK*/
*          ELSE;                        /*                   @D32CKCK*/
@RF00640 DS    0H                                                  0647
*         END;                          /*                   @D32CKCK*/
*        ELSE DO;                       /*                   @D32CKCK*/
         B     @RC00634                                            0648
@RF00634 DS    0H                                                  0649
*         OCWCID=NWKADR;                /* SAVE NETWK ADR    @D32CKCK*/
*                                                                  0649
         ST    NWKADR,OCWCID(,OCWPTR)                              0649
*          DO; /* CIDCTL(FIND) LOCK(XCLUSIVE) */                   0650
*                                                                  0650
*          RFY (EMCR2,EMCR3) RSTD;                                 0651
*            GEN SETS(RPHWORK)                                     0652
*        (STM EMCR0,EMCR15,RPHWORK(RPHPTR) SAVE REGS IN RPH);      0652
         STM EMCR0,EMCR15,RPHWORK(RPHPTR) SAVE REGS IN RPH
*            EMCR3 = '00'X; /*CLEAR EXTRA BITS*/                   0653
         SLR   EMCR3,EMCR3                                         0653
*            EMCR3 = '02'X; /*INDICATE EXCLUSIVE LOCK*/            0654
         LA    EMCR3,2                                             0654
*            CALL ATCLCPTR->ATCCDFND->ISTSDCCF; /*PROCESS REQUEST*/
*                                                                  0655
         L     @08,ATCLCPTR                                        0655
         L     @15,ATCCDFND(,@08)                                  0655
         BALR  @14,@15                                             0655
*          RFY (EMCR2,EMCR3) UNRSTD;                               0656
*          END; /*CIDCTL*/ /* GET DAF LOCK     @D32CKCK*/          0657
*         IF RCREG=CZERO                /* RC=0?             @D32CKCK*/
*          THEN DO;                     /*                   @D32CKCK*/
         SLR   @08,@08                                             0658
         CR    RCREG,@08                                           0658
         BNE   @RF00658                                            0658
*           OCWCLOCK=CON;               /* SET LOCK INDIC    @D32CKCK*/
         OI    OCWCLOCK(OCWPTR),B'00010000'                        0660
*           OCWFMCB=CPRMRG2;            /* SET FMCB ADDR     @D32CKCK*/
         ST    CPRMRG2,OCWFMCB(,OCWPTR)                            0661
*           IF FMCDEBA=OCWACDEB         /* MATCHING DEBS     @D32CKCK*/
*            THEN DO;                   /*                   @D32CKCK*/
         L     @07,OCWFMCB(,OCWPTR)                                0662
         CLC   FMCDEBA(4,@07),OCWACDEB(OCWPTR)                     0662
         BNE   @RF00662                                            0662
*             IF FMCCPIP=CON            /* PURGE IN PROG?    @D32CKCK*/
*              THEN DO;                 /*                   @D32CKCK*/
         TM    FMCCPIP(@07),B'00001000'                            0664
         BNO   @RF00664                                            0664
*               NIBCID=CZERO;           /* ZERO NIB CID      @D32CKCK*/
         L     @07,OCWNIB(,OCWPTR)                                 0666
         ST    @08,NIBCID(,@07)                                    0666
*               NIBCON=COFF;            /* NIB CONN BIT OFF  @D32CKCK*/
         NI    NIBCON(@07),B'10111111'                             0667
*               CSLRDTEF=COFF;          /* CLR HOB RDTE PTR  @D32CKCK*/
         NI    CSLRDTEF(RLEPTR),B'01111111'                        0668
*               END;                    /*                   @D32CKCK*/
*              ELSE;                    /*                   @D32CKCK*/
@RF00664 DS    0H                                                  0671
*             END;                      /*                   @D32CKCK*/
*            ELSE DO;                   /*                   @D32CKCK*/
         B     @RC00662                                            0672
@RF00662 DS    0H                                                  0673
*             NIBCID=CZERO;             /* ZERO NIB CID      @D32CKCK*/
         L     @08,OCWNIB(,OCWPTR)                                 0673
         SLR   @07,@07                                             0673
         ST    @07,NIBCID(,@08)                                    0673
*             NIBCON=COFF;              /* NIB CONN BIT OFF  @D32CKCK*/
         NI    NIBCON(@08),B'10111111'                             0674
*             CSLRDTEF=COFF;            /* CLR HOB RDTE PTR  @D32CKCK*/
         NI    CSLRDTEF(RLEPTR),B'01111111'                        0675
*             END;                      /*                   @D32CKCK*/
*           END;                        /*                   @D32CKCK*/
*          ELSE DO;                     /*                   @D32CKCK*/
         B     @RC00658                                            0678
@RF00658 DS    0H                                                  0679
*           NIBCID=CZERO;               /* ZERO NIB CID      @D32CKCK*/
         L     @08,OCWNIB(,OCWPTR)                                 0679
         SLR   @07,@07                                             0679
         ST    @07,NIBCID(,@08)                                    0679
*           NIBCON=COFF;                /* NIB CONN BIT OFF  @D32CKCK*/
         NI    NIBCON(@08),B'10111111'                             0680
*           CSLRDTEF=COFF;              /* CLR HOB RDTE PTR  @D32CKCK*/
         NI    CSLRDTEF(RLEPTR),B'01111111'                        0681
*           END;                        /*                   @D32CKCK*/
*         END;                          /*                   @D32CKCK*/
@RC00658 DS    0H                                                  0684
*       IF CSLRDTEF=COFF                /* HOB RDTE PTR?     @D32CKCK*/
*        THEN;                          /*                   @D32CKCK*/
@RC00634 TM    CSLRDTEF(RLEPTR),B'10000000'                        0684
         BZ    @RT00684                                            0684
*        ELSE DO;                       /*                   @D32CKCK*/
*         ACEPTR=RCPACETR;              /* FIRST ACE PTR     @D32CKCK*/
         L     @08,OCWDRDTE(,OCWPTR)                               0687
         L     ACEPTR,RCPACETR(,@08)                               0687
*         DO WHILE(ACEPTR^=ADDR(RCPACETR) /* FIND RIGHT ACE  @D32CKCK*/
*                   & ACERPHA^=RPHPTR); /* PTS TO OUR RPH    @D32CKCK*/
         B     @DE00688                                            0688
@DL00688 DS    0H                                                  0689
*          ACEPTR=ACEOBJQ;              /*  FROM RDTE ACE Q  @D32CKCK*/
         L     ACEPTR,ACEOBJQ(,ACEPTR)                             0689
*          END;                         /*                   @D32CKCK*/
@DE00688 L     @08,OCWDRDTE(,OCWPTR)                               0690
         LA    @08,RCPACETR(,@08)                                  0690
         CR    ACEPTR,@08                                          0690
         BE    @DC00688                                            0690
         C     RPHPTR,ACERPHA(,ACEPTR)                             0690
         BNE   @DL00688                                            0690
@DC00688 DS    0H                                                  0691
*         IF ACERPHA=RPHPTR             /* IF RT ACE FOUND           */
*          THEN DO;                     /*                   @DM14342*/
         C     RPHPTR,ACERPHA(,ACEPTR)                             0691
         BNE   @RF00691                                            0691
*           IF OCWFMCB=CZERO                                       0693
*            THEN DO;                   /* NO NETWORK ADDR   @DM14342*/
         SLR   @08,@08                                             0693
         C     @08,OCWFMCB(,OCWPTR)                                0693
         BNE   @RF00693                                            0693
*             IF OCWSVRC=CZERO          /* SAVED RC IS GOOD          */
*              THEN ACERPHA=CZERO;      /* ZERO ACE RPH PTR  @DM14342*/
         CLI   OCWSVRC(OCWPTR),0                                   0695
         BNE   @RF00695                                            0695
         ST    @08,ACERPHA(,ACEPTR)                                0696
*              ELSE;                    /*                   @DM14342*/
@RF00695 DS    0H                                                  0698
*             END;                      /* END FOR NO N. A.  @DM14342*/
*            ELSE DO;                   /* NETWK ADDR EXISTS @DM14342*/
         B     @RC00693                                            0699
@RF00693 DS    0H                                                  0700
*             IF FMCCPIP=COFF                                      0700
*              THEN DO;                 /* PURG NOT IN PROG  @DM14342*/
         L     @08,OCWFMCB(,OCWPTR)                                0700
         TM    FMCCPIP(@08),B'00001000'                            0700
         BNZ   @RF00700                                            0700
*               IF OCWSVRC=CZERO        /* SAVED RC IS GOOD          */
*                THEN ACERPHA=CZERO;    /* ZERO ACE RPH PTR  @DM14342*/
         CLI   OCWSVRC(OCWPTR),0                                   0702
         BNE   @RF00702                                            0702
         SLR   @08,@08                                             0703
         ST    @08,ACERPHA(,ACEPTR)                                0703
*                ELSE;                  /*                   @DM14342*/
@RF00702 DS    0H                                                  0705
*               END;                    /* END FOR NO PURGE  @DM14342*/
*              ELSE DO;                 /* PURGE IN PROGRESS @DM14342*/
         B     @RC00700                                            0706
@RF00700 DS    0H                                                  0707
*               NIBCID=CZERO;           /* CLEAR CID IN NIB  @DM14342*/
         L     @08,OCWNIB(,OCWPTR)                                 0707
         SLR   @07,@07                                             0707
         ST    @07,NIBCID(,@08)                                    0707
*               NIBCON=COFF;            /* TURN OFF CONN BIT @DM14342*/
         NI    NIBCON(@08),B'10111111'                             0708
*               CSLRDTEF=COFF;          /* RDTE NOT CONN     @DM14342*/
         NI    CSLRDTEF(RLEPTR),B'01111111'                        0709
*               END;                    /* END FOR PIP ON    @DM14342*/
*             END;                      /* END FOR GOOD N.A. @DM14342*/
*           END;                        /* END FOR ACE FOUND @DM14342*/
*          ELSE DO;                     /* ACE NOT FOUND     @DM14342*/
         B     @RC00691                                            0713
@RF00691 DS    0H                                                  0714
*           NIBCID=CZERO;               /* ZERO CID IN NIB   @DM14342*/
         L     @08,OCWNIB(,OCWPTR)                                 0714
         SLR   @07,@07                                             0714
         ST    @07,NIBCID(,@08)                                    0714
*           NIBCON=COFF;                /* TURN OFF CONN BIT @DM14342*/
         NI    NIBCON(@08),B'10111111'                             0715
*           CSLRDTEF=COFF;              /* RDTE NOT CONN     @DM14342*/
         NI    CSLRDTEF(RLEPTR),B'01111111'                        0716
*           END;                        /* END FOR NO ACE    @DM14342*/
*          END;                         /* END FOR HOB ON    @D32CKCK*/
@RC00691 DS    0H                                                  0719
*        IF OCWCLOCK=CON                /* DAF LOCK ON?      @D32CKCK*/
*         THEN DO;                      /*                   @D32CKCK*/
@RT00684 TM    OCWCLOCK(OCWPTR),B'00010000'                        0719
         BNO   @RF00719                                            0719
*          NWKADR=OCWCID;               /* NETWK ADR=OCW CID @D32CKCK*/
*                                                                  0721
         L     NWKADR,OCWCID(,OCWPTR)                              0721
*           DO; /* CIDCTL(FINISH)  */                              0722
*                                                                  0722
*           RFY (EMCR2,EMCR3) RSTD;                                0723
*             GEN SETS(RPHWORK)                                    0724
*        (STM EMCR0,EMCR15,RPHWORK(RPHPTR) SAVE REGS IN RPH);      0724
         STM EMCR0,EMCR15,RPHWORK(RPHPTR) SAVE REGS IN RPH
*             EMCR3 = '00'X; /*CLEAR EXTRA BITS*/                  0725
         SLR   EMCR3,EMCR3                                         0725
*             CALL ATCLCPTR->ATCCDFIN->ISTSDCCR; /*PROCESS REQUEST*/
*                                                                  0726
         L     @08,ATCLCPTR                                        0726
         L     @15,ATCCDFIN(,@08)                                  0726
         BALR  @14,@15                                             0726
*           RFY (EMCR2,EMCR3) UNRSTD;                              0727
*           END; /*CIDCTL*/            /* REL DAF LOCK      @D32CKCK*/
*          OCWCLOCK=COFF;               /* CLR LOCK INDIC    @D32CKCK*/
         NI    OCWCLOCK(OCWPTR),B'11101111'                        0729
*          END;                         /*                   @D32CKCK*/
*         ELSE;                         /*                   @D32CKCK*/
@RF00719 DS    0H                                                  0732
*        END;                           /*                   @D32CKCK*/
*      IF OCWSVRC^=0 &                  /* BAD SAVED RC      @D32CKCK*/
*         ADDR(OCWDRDTE)->CSLRDTEF=CON  /* & OPEN DST SUCC   @D32CKCK*/
*       THEN DO;                        /*                   @D32CKCK*/
@RT00622 CLI   OCWSVRC(OCWPTR),0                                   0733
         BE    @RF00733                                            0733
         TM    CSLRDTEF+40(OCWPTR),B'10000000'                     0733
         BNO   @RF00733                                            0733
*        OCWSPCLS=CON;                  /* SPCL CALL CLSDST  @D32CKCK*/
         OI    OCWSPCLS(OCWPTR),B'10000000'                        0735
*        CALL ISTOCCCL;                 /* CLSDST TAHT FAILD @D32CKCK*/
*                                                                  0736
         L     @15,@CV04443                                        0736
         BALR  @14,@15                                             0736
*         DO;                                                      0737
*/***  CRRMAINT  PROCNM(ISTOCCOF)COMP(OC)FUNC(RET)  ***/           0738
*         DCL CMZK0082 PTR(31) REG(1);                             0738
*         RFY (CMZK0082) RSTD;                                     0739
*         /*** CLEAR AND SET CURRENT PROCEDURE BIT ***/            0740
*CMZK0082->RPHCRR->CRACRR->OCCCRT = '0'B;                          0740
         L     @08,RPHCRR(,CMZK0082)                               0740
         L     @08,CRACRR(,@08)                                    0740
         XC    OCCCRT+1(2,@08),OCCCRT+1(@08)                       0740
         MVI   OCCCRT(@08),B'00000000'                             0740
*CMZK0082->RPHCRR->CRACRR->COCCOF = '1'B;                          0741
         OI    COCCOF(@08),B'00000100'                             0741
*         END; /*   @D32CKCK*/                                     0742
*        NIBCID=CZERO;                  /* ZERO NIB CID      @D32CKCK*/
         L     @08,OCWNIB(,OCWPTR)                                 0743
         SLR   @07,@07                                             0743
         ST    @07,NIBCID(,@08)                                    0743
*        NIBCON=COFF;                   /* NIB CONN BIT OFF  @D32CKCK*/
         NI    NIBCON(@08),B'10111111'                             0744
*        END;                           /*                   @D32CKCK*/
*       ELSE;                           /*                   @D32CKCK*/
@RF00733 DS    0H                                                  0747
*    RFY (RLEPTR,RCREG) UNRSTD;         /*                   @D32CKCK*/
*  /*SEGMENT(DCLENUP)FINISH*/DO;GOTO DCLENUP#;DCLENUP@:END;        0748
**                   @D32CKCK*/                                    0748
         B     DCLENUP#                                            0749
DCLENUP@ DS    0H                                                  0751
*  /*SEGMENT(CKACE)START*/DO;GOTO CKACE@;CKACE:END;                0751
         B     CKACE@                                              0752
CKACE    DS    0H                                                  0754
*             /*@D32CKCK*/                                         0754
*/********************************************************************/
*/*                                                                  */
*/*   ROUTINE NAME: CKACE -                                          */
*/*                                                                  */
*/*   FUNCTION: TO VALIDATE RDTE AND VERIFY THAT THE ASSOCIATED      */
*/*             ACE EXISTS.                                          */
*/*                                                                  */
*/*   INPUT: NONE                                                    */
*/*                                                                  */
*/*   OUTPUT: REG 15 RC                                              */
*/*                                                                  */
*/*   ROUTINES CALLED: ISTOCCDF - FIND RDTE PTR CORRES TO NIBSYM     */
*/*                                                                  */
*/*   MACROS USED: CRRMAINT                                          */
*/*                                                                  */
*/********************************************************************/
*  RFY (RLEPTR,RCREG) RSTD;             /*                   @D32CKCK*/
*  CPRMRG0=ADDR(NIBSYM);                /* RG0=ADR OF SYM NM @D32CKCK*/
         L     @08,OCWNIB(,OCWPTR)                                 0755
         LA    CPRMRG0,NIBSYM(,@08)                                0755
*  CPRMRG0=CPRMRG0|'80000000'X;         /* SET RG0 HOB       @D32CKCK*/
         O     CPRMRG0,@CF02699                                    0756
*  RPHPTR=RPHPTR&'7FFFFFFF'X;           /* CLR RPH PTR HOB   @D32CKCK*/
         N     RPHPTR,@CF02697                                     0757
*  NWKADR=0;                            /* CLR RG2           @D32CKCK*/
         SLR   NWKADR,NWKADR                                       0758
*  CALL ISTOCCDF;                       /* FIND RDTE PTR     @D32CKCK*/
*                                                                  0759
         L     @08,OCWACVT(,OCWPTR)                                0759
         L     @15,ATCSRTDF(,@08)                                  0759
         BALR  @14,@15                                             0759
*   DO;                                                            0760
*/***  CRRMAINT  PROCNM(ISTOCCOF)COMP(OC)FUNC(RET)  ***/           0761
*   DCL CMZK0085 PTR(31) REG(1);                                   0761
*   RFY (CMZK0085) RSTD;                                           0762
*   /*** CLEAR AND SET CURRENT PROCEDURE BIT ***/                  0763
*CMZK0085->RPHCRR->CRACRR->OCCCRT = '0'B;                          0763
         L     @08,RPHCRR(,CMZK0085)                               0763
         L     @08,CRACRR(,@08)                                    0763
         XC    OCCCRT+1(2,@08),OCCCRT+1(@08)                       0763
         MVI   OCCCRT(@08),B'00000000'                             0763
*CMZK0085->RPHCRR->CRACRR->COCCOF = '1'B;                          0764
         OI    COCCOF(@08),B'00000100'                             0764
*   END; /*         @D32CKCK*/                                     0765
*  IF RCREG=CZERO                       /* RC=0?             @D32CKCK*/
*   THEN DO;                            /*                   @D32CKCK*/
         SLR   @08,@08                                             0766
         CR    RCREG,@08                                           0766
         BNE   @RF00766                                            0766
*    IF RCPACETR^=0                     /* RDTE ACE PTR^=0   @D32CKCK*/
*       & RPHPTR=RCPACETR->ACERPHA      /* & ACE RPH=RPHPTR? @DM14343*/
*     THEN;                             /*                   @D32CKCK*/
         L     @07,OCWDRDTE(,OCWPTR)                               0768
         L     @07,RCPACETR(,@07)                                  0768
         CR    @07,@08                                             0768
         BE    @RF00768                                            0768
         C     RPHPTR,ACERPHA(,@07)                                0768
         BE    @RT00768                                            0768
*     ELSE RCREG=4;                     /* RC TO NOT ZERO    @D32CKCK*/
@RF00768 LA    RCREG,4                                             0770
*    END;                               /*                   @D32CKCK*/
*   ELSE;                               /*                   @D32CKCK*/
@RF00766 DS    0H                                                  0773
*  RFY (RLEPTR,RCREG) UNRSTD;           /*                   @D32CKCK*/
@RC00766 DS    0H                                                  0774
*  /*SEGMENT(CKACE)FINISH*/DO;GOTO CKACE#;CKACE@:END;              /*
*                @D32CKCK*/                                        0774
         B     CKACE#                                              0775
*DOVALINT: PROC OPTIONS(NOSAVE,NOSAVEAREA);                        0777
         B     @PB00002                                            0777
DOVALINT DS    0H                                                  0778
*/********************************************************************/
*/*                                                                  */
*/*   ROUTINE NAME: DOVALINT - VALIDATE AND MOVE USER'S NIB          */
*/*                                                                  */
*/*   FUNCTION: THIS ROUTINE COPIES OR MERGES THE USER'S NIB FROM/TO */
*/*             HIS STORAGE DEPENDING ON THE SETTING OF REGISTER 0   */
*/*                                                                  */
*/*   INPUT: CPRMRG0 (R0) - POSITIVE IF NIB IS TO BE COPIED          */
*/*                       - NEGATIVE IF NIB IS TO BE MERGED          */
*/*          OCWNIB       - ADDRESS OF THE NIB TO BE MERGED          */
*/*                                                                  */
*/*   OUTPUT: SUCCESSFUL   - NIB IS COPIED/MERGED                    */
*/*           UNSUCCESSFUL - SYSTEM ERROR IS SET IF THE LOCAL        */
*/*                          MEMORY LOCK CANNOT BE SET OR RELEASED   */
*/*                                                                  */
*/*   ROUTINES CALLED: ISTOCCNV - COPY/MERGE USER'S NIB              */
*/*                                                                  */
*/*   MACROS USED: VSETLCK, CRRMAINT                                 */
*/*                                                                  */
*/********************************************************************/
*          C14SAVE=CRTRNREG;        /* SAVE RETURN REGISTER          */
         LA    @15,624                                             0778
         ALR   @15,OCWPTR                                          0778
         L     @07,C14SVPTR(,@15)                                  0778
         ST    CRTRNREG,C14SAVE(,@07)                              0778
*          C14SVPTR=C14SVPTR+4;     /* SET NEW REG 14 SAVE AREA PTR  */
         AL    @07,@CF00044                                        0779
         ST    @07,C14SVPTR(,@15)                                  0779
*          IF OCWMLOCK=CON THEN;    /* LOCAL MEMORY LOCK HELD? YES.  */
         TM    OCWMLOCK(OCWPTR),B'00000010'                        0780
         BO    @RT00780                                            0780
*          ELSE                     /* NO,                           */
*            DO;                    /* DO THE FOLLOWING:             */
*              RFY RCREG RSTD;                                     0783
*                                                                  0783
*/*VSETLCK  (RCREG,OBTAIN,LOCAL,ISTOCCOF,RESET)*/                  0784
*               DO;                                                0784
*                                        /*DECLARE AND RESTRICT REGS */
*                                        /*   2,10,11,12,13,14, AND 15
**/                                                                0785
*               RFY (GPR02P,GPR10P,GPR11P,GPR12P,GPR13P,GPR14P,GPR15P)
*STD;                                                              0785
*                                        /*SAVE REGS 2 AND 10 THRU 14*/
*        GEN REFS(GPR02F,GPR10F,GPR11F,GPR12F,GPR14F,GPR13P);      0786
*                                                                  0786
         STM   GPR10F,GPR12F,0(GPR13P)
         ST    GPR14F,12(GPR13P)
         ST    GPR02F,16(GPR13P)
*                                        /*INVOKE MODESET TO CHANGE  */
*                                        /*PSW PROTECTION KEY TO 0   */
*        GEN SETS(2);                                              0787
*                                                                  0787
         MODESET EXTKEY=ZERO,SAVEKEY=(2),WORKREG=2
*                 GPR10P=GPR13P;         /*PUT SAVE AREA ADDR IN R 10*/
         LR    GPR10P,GPR13P                                       0788
*                                        /*INVOKE OS/VS SETLOCK MACRO*/
*                 GEN REFS(GPR13P,PSALITA,FLC) SETS(GPR12F);       0789
         SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,                        *
               RELATED=ISTOCCOF
*                 GPR15P=GPR13P;         /*PUT RETURN CODE IN R 15 */
         LR    GPR15P,GPR13P                                       0790
*                                        /*INVOKE MODESET MACRO TO   */
*                   DO;                  /*RESTORE PSW PROTECTION KEY*/
*        GEN SETS(2);                                              0792
         MODESET KEYADDR=(2),WORKREG=2
*                   END;                 /* RESTORE REGISTERS        */
*                 GEN REFS(GPR10F,GPR13P) SETS(GPR10F,GPR11F,      0794
*                 GPR12F,GPR13F,GPR14F,GPR02F);                    0794
         LR    GPR13F,GPR10F
         LM    GPR10F,GPR12F,0(GPR13P)
         L     GPR14F,12(GPR13P)
         L     GPR02F,16(GPR13P)
*                 IF GPR15F=4 THEN GPR15F=0;                       0795
         C     GPR15F,@CF00044                                     0795
         BNE   @RF00795                                            0795
         SLR   GPR15F,GPR15F                                       0796
*                 RCREG=GPR15F;          /*PUT RETURN CODE IN RCREG*/
*                                                                  0797
@RF00795 DS    0H                                                  0798
*               RFY (GPR02P,GPR10P,GPR11P,GPR12P,GPR13P,GPR14P,GPR15P)
*NRSTD;         END;  /*VSETLCK */                                 0798
*              IF RCREG=CZERO THEN  /* LOCK OBTAINED?                */
         LTR   RCREG,RCREG                                         0800
         BNZ   @RF00800                                            0800
*                OCWMLOCK=CON;      /* YES, INDICATE LM LOCK HELD    */
         OI    OCWMLOCK(OCWPTR),B'00000010'                        0801
*              ELSE                 /* NO,                           */
*                DO;                /* DO THE FOLLOWING:             */
         B     @RC00800                                            0802
@RF00800 DS    0H                                                  0803
*                  OCWRC='24'X;     /* INDICATE SYSTEM ERROR         */
         MVI   OCWRC(OCWPTR),X'24'                                 0803
*                  OCWEC='01'X;     /* INDICATE UNEXPECTED ERROR     */
         MVI   OCWEC(OCWPTR),X'01'                                 0804
*                END;                                              0805
*              RFY RCREG UNRSTD;                                   0806
@RC00800 DS    0H                                                  0807
*            END;                                                  0807
*          IF OCWRC^='24'X THEN     /* SYSTEM ERROR ?         XM06240*/
@RT00780 CLI   OCWRC(OCWPTR),X'24'                                 0808
         BE    @RF00808                                            0808
*            DO;                    /* NO, DO THE FOLLOWING:         */
*              CALL ISTOCCNV;       /* VALIDATE-COPY/MERGE USER NIB  */
*                                                                  0810
         L     @15,@CV04453                                        0810
         BALR  @14,@15                                             0810
*               DO;                                                0811
*/***  CRRMAINT  PROCNM(ISTOCCOF)COMP(OC)FUNC(RET)  ***/           0812
*               DCL CMZK0090 PTR(31) REG(1);                       0812
*               RFY (CMZK0090) RSTD;                               0813
*               /*** CLEAR AND SET CURRENT PROCEDURE BIT ***/      0814
*CMZK0090->RPHCRR->CRACRR->OCCCRT = '0'B;                          0814
         L     @15,RPHCRR(,CMZK0090)                               0814
         L     @15,CRACRR(,@15)                                    0814
         XC    OCCCRT+1(2,@15),OCCCRT+1(@15)                       0814
         MVI   OCCCRT(@15),B'00000000'                             0814
*CMZK0090->RPHCRR->CRACRR->COCCOF = '1'B;                          0815
         OI    COCCOF(@15),B'00000100'                             0815
*               END;/* TRACE*/                                     0816
*              RFY RCREG RSTD;                                     0817
*                                                                  0817
*/*VSETLCK  (RCREG,RELEASE,LOCAL,ISTOCCOF,SET)*/                   0818
*               DO;                                                0818
*                                        /*DECLARE AND RESTRICT REGS */
*                                        /*   2,10,11,12,13,14, AND 15
**/                                                                0819
*               RFY (GPR02P,GPR10P,GPR11P,GPR12P,GPR13P,GPR14P,GPR15P)
*STD;                                                              0819
*                                        /*SAVE REGS 2 AND 10 THRU 14*/
*        GEN REFS(GPR02F,GPR10F,GPR11F,GPR12F,GPR14F,GPR13P);      0820
*                                                                  0820
         STM   GPR10F,GPR12F,0(GPR13P)
         ST    GPR14F,12(GPR13P)
         ST    GPR02F,16(GPR13P)
*                                        /*INVOKE MODESET TO CHANGE  */
*                                        /*PSW PROTECTION KEY TO 0   */
*        GEN SETS(2);                                              0821
*                                                                  0821
         MODESET EXTKEY=ZERO,SAVEKEY=(2),WORKREG=2
*                 GPR10P=GPR13P;         /*PUT SAVE AREA ADDR IN R 10*/
         LR    GPR10P,GPR13P                                       0822
*                                        /*INVOKE OS/VS SETLOCK MACRO*/
*                 GEN REFS(GPR13P,PSALITA,FLC) SETS(GPR12F);       0823
         SETLOCK RELEASE,TYPE=LOCAL,                                   *
               RELATED=ISTOCCOF
*                 GPR15P=GPR13P;         /*PUT RETURN CODE IN R 15 */
         LR    GPR15P,GPR13P                                       0824
*                                        /*INVOKE MODESET MACRO TO   */
*                   DO;                  /*RESTORE PSW PROTECTION KEY*/
*        GEN SETS(2);                                              0826
         MODESET KEYADDR=(2),WORKREG=2
*                   END;                 /* RESTORE REGISTERS        */
*                 GEN REFS(GPR10F,GPR13P) SETS(GPR10F,GPR11F,      0828
*                 GPR12F,GPR13F,GPR14F,GPR02F);                    0828
         LR    GPR13F,GPR10F
         LM    GPR10F,GPR12F,0(GPR13P)
         L     GPR14F,12(GPR13P)
         L     GPR02F,16(GPR13P)
*                 IF GPR15F=4 THEN GPR15F=0;                       0829
         C     GPR15F,@CF00044                                     0829
         BNE   @RF00829                                            0829
         SLR   GPR15F,GPR15F                                       0830
*                 RCREG=GPR15F;          /*PUT RETURN CODE IN RCREG*/
*                                                                  0831
@RF00829 DS    0H                                                  0832
*               RFY (GPR02P,GPR10P,GPR11P,GPR12P,GPR13P,GPR14P,GPR15P)
*NRSTD;         END;  /*VSETLCK */                                 0832
*              IF RCREG=CZERO THEN  /* UNLOCK LM SUCESSFUL?          */
         LTR   RCREG,RCREG                                         0834
         BNZ   @RF00834                                            0834
*                OCWMLOCK=COFF;     /* YES, INDICATE LM UNLOCKED     */
         NI    OCWMLOCK(OCWPTR),B'11111101'                        0835
*              ELSE                 /* NO,                           */
*                DO;                /* DO THE FOLLOWING:             */
         B     @RC00834                                            0836
@RF00834 DS    0H                                                  0837
*                    OCWRC='24'X;    /* INDICATE SYSTEM ERROR        */
         MVI   OCWRC(OCWPTR),X'24'                                 0837
*                    OCWEC='01'X;    /* INDICATE UNEXPECTED ERROR    */
         MVI   OCWEC(OCWPTR),X'01'                                 0838
*                END;                                              0839
*              RFY RCREG UNRSTD;                                   0840
@RC00834 DS    0H                                                  0841
*                      END;                                        0841
*             ELSE;                  /* YES                          */
@RF00808 DS    0H                                                  0843
*             OCWNIB=ADDR(OCWDNIB);  /* RESET POINTER TO NIB         */
         LA    @15,OCWDNIB(,OCWPTR)                                0843
         ST    @15,OCWNIB(,OCWPTR)                                 0843
*             C14SVPTR=C14SVPTR-4;   /* RESET REG14 SAVE AREA PTR    */
         LA    @15,624                                             0844
         ALR   @15,OCWPTR                                          0844
         L     @07,C14SVPTR(,@15)                                  0844
         SL    @07,@CF00044                                        0844
         ST    @07,C14SVPTR(,@15)                                  0844
*             CRTRNREG=C14SAVE;      /* RESTORE RETURN REGISTER      */
         L     CRTRNREG,C14SAVE(,@07)                              0845
*             END DOVALINT;                                        0846
*                                                                  0846
@EL00002 DS    0H                                                  0846
@EF00002 DS    0H                                                  0846
@ER00002 BR    @14                                                 0846
@PB00002 DS    0H                                                  0846
*/* TPEPILOG   */                                                  0847
*              GEN (PRINT OFF);                                    0847
*                                                                  0847
*                                                                  0847
         PRINT OFF
*              DECLARE                                             0848
*                EMCR0 PTR REG(0),                                 0848
*                EMCR1 PTR REG(1),                                 0848
*                EMCR2 PTR REG(2),                                 0848
*                EMCR3 PTR REG(3),                                 0848
*                EMCR4 PTR REG(4),                                 0848
*                EMCR5 PTR REG(5),                                 0848
*                EMCR6 PTR REG(6),                                 0848
*                EMCR7 PTR REG(7),                                 0848
*                EMCR8 PTR REG(8),                                 0848
*                EMCR9 PTR REG(9),                                 0848
*                EMCR10 PTR REG(10),                               0848
*                EMCR11 PTR REG(11),                               0848
*                EMCR12 PTR REG(12),                               0848
*                EMCR13 PTR REG(13),                               0848
*                EMCR14 PTR REG(14),                               0848
*                EMCR15 PTR REG(15);                               0848
*                                                                  0848
*              DECLARE                                             0849
*                ISTSDCCA ENTRY BASED(ATCCDADD) VALRG(*), /*CIDCTL ADD
*OUTINE*/        ISTSDCCD ENTRY BASED(ATCCDDEL) VALRG(*), /*CIDCTL DELE
*E ROUTINE*/     ISTSDCCF ENTRY BASED(ATCCDFND) VALRG(*), /*CIDCTL FIND
*ROUTINE*/       ISTSDCCN ENTRY BASED(ATCCDFDN) VALRG(*), /*CIDCTL FIND
*NCB ROUTINE*/   ISTSDCCR ENTRY BASED(ATCCDFIN) VALRG(*); /*CIDCTL FINI
*H ROUTINE*/     DCL CMZCIDM FIXED(15) DEFINED(ATCCIDM); /*CIDMASK ALIA
**/                                                                0849
*              GEN (PRINT ON);                                     0851
         PRINT ON
*/* END OF TPEPILOG */                                             0852
*                                                                  0852
*/* ATDSPLY   INVOKED. */                                          0852
*/********************************************************************/
*/* THE FOLLOWING ATBUILD INCLUSIONS HAVE BEEN MADE IN THIS          */
*/* COMPILATION:                                                     */
*/*             ISTCSL                                               */
*/*             ISTBIND                                              */
*/*             ISTICE                                               */
*/*             ISTACE                                               */
*/*             ISTCSP                                               */
*/*             ISTPROCD                                             */
*/*             ISTDEVCH                                             */
*/*             ISTNIB                                               */
*/*             ISTOCW                                               */
*/*             ISTLOK                                               */
*/*             ISTRDT                                               */
*/*             ISTRPH                                               */
*/*             ISTPAB                                               */
*/*             ISTDYPAB                                             */
*/*             ISTATCVT                                             */
*/*             ISTAVT                                               */
*/*             ISTLCCW                                              */
*/*             ISTLCPB                                              */
*/*             ISTZSAVE                                             */
*/*             ISTPFCRR                                             */
*/*             ISTCFCRR                                             */
*/*             ISTZCRR                                              */
*/*             ISTASCRR                                             */
*/*             ISTAPCRR                                             */
*/*             ISTCRA                                               */
*/*             ISTCNSTA                                             */
*/*             ISTOCCRR                                             */
*/*             ISTFMCB                                              */
*/********************************************************************/
*/* END OF ATDSPLY. */                                             0852
*             END ISTOCCOF                                         0852
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (IHAPSA  )                                        *
*/*%INCLUDE SYSLIB  (CVT     )                                        *
*/*%INCLUDE SYSLIB  (IFGRPL  )                                        *
*/*%INCLUDE SYSLIB  (IFGRPLVT)                                        *
*/*%INCLUDE SYSLIB  (ISTRPLFB)                                        *
*;                                                                 0852
@DATA    DS    0H
@CH00032 DC    H'12'
@DATD    DSECT
         DS    0F
ISTOCCOF CSECT
         DS    0F
@CF00067 DC    F'1'
@CF00044 DC    F'4'
@CF02697 DC    XL4'7FFFFFFF'
@CF02699 DC    XL4'80000000'
@CF04435 DC    XL4'FFFF0000'
@DATD    DSECT
         DS    0D
CVTPTR   DS    A
LCPBPTR  DS    A
FMCBPTR  DS    A
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
ISTOCCOF CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV04432 DC    V(ISTOCCUR)
@CV04443 DC    V(ISTOCCCL)
@CV04453 DC    V(ISTOCCNV)
         DS    0D
FMZA0011 DS    FL4
         ORG   FMZA0011
@NM00101 DC    AL1(64)
@NM00102 DC    AL3(0)
         ORG   FMZA0011+4
CMZA0033 DS    FL4
         ORG   CMZA0033
@NM00103 DC    AL1(64)
@NM00104 DC    AL1(96)
@NM00105 DC    AL1(241)
@NM00106 DC    XL1'01'
         ORG   CMZA0033+4
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
RPHPTR   EQU   @01
GPR00F   EQU   @00
GPR00P   EQU   @00
GPR01P   EQU   @01
GPR02F   EQU   @02
GPR02P   EQU   @02
GPR03F   EQU   @03
GPR03P   EQU   @03
GPR04P   EQU   @04
GPR05P   EQU   @05
GPR06P   EQU   @06
GPR07P   EQU   @07
GPR08P   EQU   @08
GPR09P   EQU   @09
GPR10F   EQU   @10
GPR10P   EQU   @10
GPR11F   EQU   @11
GPR11P   EQU   @11
GPR12F   EQU   @12
GPR12P   EQU   @12
GPR13F   EQU   @13
GPR13P   EQU   @13
GPR14F   EQU   @14
GPR14P   EQU   @14
GPR15F   EQU   @15
GPR15P   EQU   @15
CPRMRG0  EQU   @00
CPRMRG2  EQU   @02
NWKADR   EQU   @02
NWKSAF   EQU   @03
OCWPTR   EQU   @04
ACEPTR   EQU   @06
RLEPTR   EQU   @09
SVEAREA  EQU   @13
CRTRNREG EQU   @14
RCREG    EQU   @15
CMZK0009 EQU   @01
EMCR2    EQU   @02
EMCR3    EQU   @03
CMZK0082 EQU   @01
CMZK0085 EQU   @01
CMZK0090 EQU   @01
EMCR0    EQU   @00
EMCR1    EQU   @01
EMCR10   EQU   @10
EMCR11   EQU   @11
EMCR12   EQU   @12
EMCR13   EQU   @13
EMCR14   EQU   @14
EMCR15   EQU   @15
EMCR4    EQU   @04
EMCR5    EQU   @05
EMCR6    EQU   @06
EMCR7    EQU   @07
EMCR8    EQU   @08
EMCR9    EQU   @09
GPR01F   EQU   @01
GPR04F   EQU   @04
GPR05F   EQU   @05
GPR06F   EQU   @06
GPR07F   EQU   @07
GPR08F   EQU   @08
GPR09F   EQU   @09
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSALITA  EQU   PSA+764
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
ATCLCPTR EQU   1032
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTSHS   EQU   CVTXTNT2+40
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
IFGRPL   EQU   0
RPLCOMN  EQU   IFGRPL
RPLIDWD  EQU   RPLCOMN
RPLREQ   EQU   RPLIDWD+2
RPLLEN   EQU   RPLIDWD+3
RPLECB   EQU   RPLCOMN+8
RPLFDBWD EQU   RPLCOMN+12
RPLFDBK  EQU   RPLFDBWD+1
RPLRTNCD EQU   RPLFDBK
RPLCNDCD EQU   RPLFDBK+1
RPLCMPON EQU   RPLCNDCD
RPLFDB2  EQU   RPLCMPON
RPLERRCD EQU   RPLCNDCD+1
RPLFDB3  EQU   RPLERRCD
RPLKEYLE EQU   RPLCOMN+16
RPLARG   EQU   RPLCOMN+36
RPLOPTCD EQU   RPLCOMN+40
RPLOPT1  EQU   RPLOPTCD
RPLECBSW EQU   RPLOPT1
RPLOPT2  EQU   RPLOPTCD+1
RPLADR   EQU   RPLOPT2
RPLOPT3  EQU   RPLOPTCD+2
RPLOPT4  EQU   RPLOPTCD+3
RPLNXTRP EQU   RPLCOMN+44
RPLOPTC2 EQU   RPLCOMN+56
RPLOPT5  EQU   RPLOPTC2
RPLWRTYP EQU   RPLOPT5
RPLOPT6  EQU   RPLOPTC2+1
RPLUNTYP EQU   RPLOPT6
RPLOPT7  EQU   RPLOPTC2+2
RPLCNOPT EQU   RPLOPT7
RPLOPT8  EQU   RPLOPTC2+3
RPLRBAR  EQU   RPLCOMN+60
RPLAIXID EQU   RPLRBAR+2
RPLEXTDS EQU   RPLCOMN+68
RPLEXTD1 EQU   RPLEXTDS
RPLVTEXT EQU   IFGRPL+76
RPLFDBK2 EQU   RPLVTEXT+12
RPLSSNSI EQU   RPLFDBK2
RPLDSB   EQU   RPLSSNSI
RPLDSB1  EQU   RPLDSB
RPLSSEI  EQU   RPLDSB1
RPLDSB2  EQU   RPLDSB+1
RPLUSNSI EQU   RPLFDBK2+2
RPLOPTC3 EQU   RPLVTEXT+20
RPLOPT9  EQU   RPLOPTC3
RPLOPT10 EQU   RPLOPTC3+1
RPLOPT11 EQU   RPLOPTC3+2
RPLOPT12 EQU   RPLOPTC3+3
RPLOSENS EQU   RPLVTEXT+24
RPLSSNSO EQU   RPLOSENS
RPLSSEO  EQU   RPLSSNSO
RPLSIGDA EQU   RPLVTEXT+32
RPLOF16  EQU   0
RPLRH3   EQU   RPLOF16
RPLSRTYP EQU   RPLOF16+1
RPLSTYPE EQU   RPLSRTYP
RPLRTYPE EQU   RPLSRTYP
RPLCHN   EQU   RPLOF16+2
RPLVTFL1 EQU   RPLOF16+3
RPLVTFL2 EQU   RPLOF16+4
RPLPOSTV EQU   RPLVTFL2
RPLRESP  EQU   RPLVTFL2
RPLCNTRL EQU   RPLOF16+5
RPLCNTDF EQU   RPLCNTRL
RPLCNTDC EQU   RPLCNTRL+1
RPLCNTSC EQU   RPLCNTRL+2
RPLOF60  EQU   0
RPLOBSQ  EQU   RPLOF60+4
RPLIBSQ  EQU   RPLOF60+5
ISTCSL   EQU   0
CSLRDEF  EQU   ISTCSL
CSLRDTE  EQU   CSLRDEF
CSLRDTEF EQU   CSLRDTE
CSLNDEF  EQU   ISTCSL+4
CSLNIB   EQU   CSLNDEF
CSLDDEF  EQU   ISTCSL+8
CSLDATA  EQU   CSLDDEF
ISTBIND  EQU   0
BINFMTY  EQU   ISTBIND
BINPRIP  EQU   ISTBIND+3
BINSECP  EQU   ISTBIND+4
BINCMNP  EQU   ISTBIND+5
BINCMNP2 EQU   ISTBIND+6
ISTICE   EQU   0
ICEFLAGS EQU   ISTICE+28
ISTACE   EQU   0
ACEOBJQ  EQU   ISTACE+12
ACERPHA  EQU   ISTACE+16
ACEFLAGS EQU   ISTACE+20
ISTCSP   EQU   0
CSPOPT   EQU   ISTCSP+2
CSPOPT1  EQU   CSPOPT
CSPOPT2  EQU   CSPOPT+1
CSPRSC2B EQU   ISTCSP+32
ISTPROCD EQU   0
PROPROC  EQU   ISTPROCD
PROPROC1 EQU   PROPROC
PROPROC2 EQU   PROPROC+1
PROPROC3 EQU   PROPROC+2
PROPROC4 EQU   PROPROC+3
PROPROCS EQU   0
PROSETMS EQU   PROPROCS+1
PROSETM2 EQU   PROSETMS
PROSETM3 EQU   PROSETMS+1
PROSETM4 EQU   PROSETMS+2
ISTDEVCH EQU   0
DEVSHCH  EQU   ISTDEVCH
DEVCHAR  EQU   DEVSHCH
DEVTCODE EQU   ISTDEVCH+1
DEVFLAGS EQU   ISTDEVCH+3
DEVFCCTL EQU   DEVFLAGS
DEVCHAR3 EQU   DEVFLAGS
ISTNIB   EQU   0
NIBCID   EQU   ISTNIB+4
NIBSYM   EQU   ISTNIB+12
NIBFLGS  EQU   ISTNIB+40
NIBFLG1  EQU   NIBFLGS
NIBCON   EQU   NIBFLG1
ISTOCW   EQU   0
OCWRPL   EQU   ISTOCW+12
OCWACVT  EQU   ISTOCW+24
OCWCSL   EQU   ISTOCW+28
OCWLRDTE EQU   ISTOCW+40
OCWDRDTE EQU   OCWLRDTE
OCWNIB   EQU   ISTOCW+44
OCWFMCB  EQU   ISTOCW+56
OCWACDEB EQU   ISTOCW+64
OCWODLST EQU   ISTOCW+80
OCWODNAS EQU   ISTOCW+84
OCWODRC  EQU   ISTOCW+92
OCWRC    EQU   OCWODRC
OCWEC    EQU   OCWODRC+1
OCWSVCOD EQU   ISTOCW+94
OCWSVRC  EQU   OCWSVCOD
OCWSVEC  EQU   OCWSVCOD+1
OCWODCT1 EQU   ISTOCW+104
OCWDSTNO EQU   ISTOCW+108
OCWBADNO EQU   ISTOCW+110
OCWDNIB  EQU   ISTOCW+112
OCWSWTA  EQU   ISTOCW+204
OCWGTLST EQU   OCWSWTA
OCWNOCON EQU   OCWSWTA
OCWSWTB  EQU   ISTOCW+205
OCWSWTC  EQU   ISTOCW+206
OCWSPCLS EQU   OCWSWTC
OCWODCLS EQU   OCWSWTC
OCWSWTD  EQU   ISTOCW+207
OCWCSPL  EQU   ISTOCW+224
OCWR14SV EQU   ISTOCW+624
OCWOENIB EQU   ISTOCW+716
OCWLALEN EQU   ISTOCW+724
OCWSWTRD EQU   ISTOCW+730
OCWSWTE  EQU   ISTOCW+731
OCWLOCKS EQU   ISTOCW+740
OCWVLOCK EQU   OCWLOCKS
OCWRLOCK EQU   OCWLOCKS
OCWCLOCK EQU   OCWLOCKS
OCWMLOCK EQU   OCWLOCKS
OCWCID   EQU   ISTOCW+744
OCWSHPL  EQU   ISTOCW+784
OCWBIND  EQU   ISTOCW+796
OCWSENSE EQU   ISTOCW+843
OCWFLG1  EQU   ISTOCW+847
ISTLOK   EQU   0
LOKCHN   EQU   ISTLOK+1
LOKCHNG  EQU   LOKCHN
@NM00065 EQU   LOKCHNG+2
ISTRPRE  EQU   0
RPRCOMID EQU   ISTRPRE+8
RPRFLAGA EQU   ISTRPRE+21
RPRFLAGB EQU   ISTRPRE+22
RPRCAUSE EQU   ISTRPRE+23
RPRFLAGD EQU   ISTRPRE+61
RPRFLAGC EQU   ISTRPRE+62
ISTRCPRE EQU   0
RCPACETR EQU   ISTRCPRE+84
RCPPMODE EQU   ISTRCPRE+91
RCPLGNIN EQU   ISTRCPRE+92
ISTRDT   EQU   0
RDTPLEN  EQU   ISTRDT+72
RDTPRIOR EQU   RDTPLEN
RDTFLAGB EQU   ISTRDT+91
RDTVYRPH EQU   ISTRDT+108
RDTSTCNT EQU   ISTRDT+112
ISTRAP   EQU   0
RAPFLG   EQU   ISTRAP+108
RAPFLGB  EQU   ISTRAP+109
RAPFLGC  EQU   ISTRAP+110
ISTRLC   EQU   0
RLCADR   EQU   ISTRLC+72
RLCFLAG  EQU   RLCADR
ISTRRN   EQU   0
RRNADR   EQU   ISTRRN+136
RRNFLAG  EQU   RRNADR
RRNUCBAD EQU   RRNADR+1
RRNRDF   EQU   ISTRRN+172
RRNRDFA  EQU   RRNRDF
RRNRDFB  EQU   RRNRDF+1
RRNCMF   EQU   ISTRRN+176
RRNCMFA  EQU   RRNCMF
RRNCMFB  EQU   RRNCMF+1
RRNCMFC  EQU   RRNCMF+2
RRNCMFD  EQU   RRNCMF+3
RRNNMDPD EQU   ISTRRN+192
RRNHPRE  EQU   ISTRRN+216
ISTRGP   EQU   0
RGPFLG   EQU   ISTRGP+72
ISTRLN   EQU   0
RLNADR   EQU   ISTRLN+72
RLNFLAG  EQU   RLNADR
RLNUCBAD EQU   RLNADR+1
RLNSTAT1 EQU   ISTRLN+86
RLNSTAT2 EQU   ISTRLN+87
RLNRDF   EQU   ISTRLN+88
RLNRDFA  EQU   RLNRDF
RLNRACNT EQU   RLNRDFA
RLNRDFB  EQU   RLNRDF+1
RLNCRFLG EQU   ISTRLN+102
RLNLSCMD EQU   RLNCRFLG
ISTRPT   EQU   0
RPTLNCID EQU   ISTRPT+116
RPTDITT  EQU   ISTRPT+128
RPTFLAG1 EQU   ISTRPT+140
ISTRCL   EQU   0
RCLADR   EQU   ISTRCL+72
RCLFLAG  EQU   RCLADR
ISTRTR   EQU   0
RTRADR   EQU   ISTRTR+124
RTRFLAG  EQU   RTRADR
RTRRDFA  EQU   ISTRTR+136
RTRRAALL EQU   RTRRDFA
RTRRDFB  EQU   ISTRTR+137
RTRRDFC  EQU   ISTRTR+138
RTRRDFD  EQU   ISTRTR+139
RTRRDFE  EQU   ISTRTR+140
RTRRDFF  EQU   ISTRTR+141
RTRCRFLG EQU   ISTRTR+143
RTRLSCMD EQU   RTRCRFLG
RTRBSCID EQU   ISTRTR+188
ISTRIN   EQU   0
RINDFD   EQU   ISTRIN+124
RINREMPO EQU   RINDFD
RINNODEF EQU   RINDFD
RINLDISC EQU   RINDFD
RINNODID EQU   ISTRIN+125
RINRLDAF EQU   ISTRIN+126
RINREMOT EQU   ISTRIN+128
RINVPAB  EQU   ISTRIN+132
RINRPHCN EQU   ISTRIN+136
RINNCSPL EQU   ISTRIN+140
RINCNCNT EQU   ISTRIN+144
ISTRDS   EQU   0
ISTDOT   EQU   0
ISTRCC   EQU   0
RCCFLAG  EQU   ISTRCC+73
RCCFLAGB EQU   ISTRCC+74
RCCSTAID EQU   ISTRCC+78
RCCID48  EQU   RCCSTAID+2
RCCCRFLG EQU   ISTRCC+108
ISTRLU   EQU   0
RLUFLAG  EQU   ISTRLU+125
RLUCRFLG EQU   ISTRLU+126
RLUPACE  EQU   ISTRLU+132
RLUNCPPC EQU   ISTRLU+134
RLUUSSTB EQU   ISTRLU+140
RLUMODET EQU   ISTRLU+152
ISTRPX   EQU   0
ISTRLX   EQU   0
RLXFLAGA EQU   ISTRLX+76
ISTRSW   EQU   0
ISTRDA   EQU   0
RDAADR   EQU   ISTRDA+72
RDAFLAG  EQU   RDAADR
RDAUCBAD EQU   RDAADR+1
ISTRLS   EQU   0
ISTDNT   EQU   0
ISTGNT   EQU   0
ISTPAT   EQU   0
PATFLAGA EQU   ISTPAT+7
ISTRPH   EQU   0
RPHCNTL  EQU   ISTRPH
RPHFLAGS EQU   RPHCNTL+2
RPHAPTYP EQU   RPHFLAGS
RPHFSTLC EQU   RPHFLAGS
RPHFLGB  EQU   RPHCNTL+3
RPHRPHA  EQU   ISTRPH+4
RPHTSKID EQU   ISTRPH+8
RPHRESMA EQU   ISTRPH+16
RPHWPFLG EQU   RPHRESMA
RPHWEA   EQU   ISTRPH+24
RPHCSPA  EQU   RPHWEA
RPHSRPRM EQU   ISTRPH+28
RPHCRR   EQU   ISTRPH+32
RPHPABQA EQU   ISTRPH+36
RPHWORK  EQU   ISTRPH+40
RPHSAVE1 EQU   RPHWORK
RPHSBITS EQU   RPHSAVE1+1
ISTPAB   EQU   0
PABWQCHN EQU   ISTPAB
PABWEQA  EQU   PABWQCHN
PABCHAIN EQU   PABWQCHN+4
PABRPHFG EQU   ISTPAB+12
PABFLAGS EQU   PABRPHFG
PABERLCK EQU   PABFLAGS
PABERRLK EQU   PABERLCK
ISTDYPAB EQU   0
ISTATCVT EQU   0
ATCCOM   EQU   ISTATCVT
ATCSTAT  EQU   ATCCOM
ATCSTAT1 EQU   ATCSTAT
ATCSTFLG EQU   ATCSTAT+1
ATCPOFLG EQU   ATCSTAT+2
ATCSTAT4 EQU   ATCSTAT+3
ATCBPDA  EQU   ATCCOM+128
ATCIOTRC EQU   ATCCOM+140
ATCTHTRC EQU   ATCIOTRC
ATCGTSTR EQU   ATCCOM+164
ATCSMRS  EQU   ATCCOM+188
ATCSRTDF EQU   ATCCOM+208
ATCCIDM  EQU   ATCCOM+266
ATCCDADD EQU   ISTATCVT+276
ATCCDDEL EQU   ISTATCVT+280
ATCCDFND EQU   ISTATCVT+284
ATCCSMR  EQU   ISTATCVT+296
ATCSHRFG EQU   ISTATCVT+316
ATCHPGM  EQU   ISTATCVT+384
ATCAP33  EQU   ISTATCVT+444
ATCAP35  EQU   ISTATCVT+448
ATCCDFIN EQU   ISTATCVT+460
ATCCDFDN EQU   ISTATCVT+464
ATCVOCLK EQU   ISTATCVT+468
ATCRDTLK EQU   ISTATCVT+472
ATCVLCNT EQU   ISTATCVT+772
ATCRNO   EQU   ISTATCVT+788
ATCSOPD  EQU   ISTATCVT+792
ATCSIPD  EQU   ISTATCVT+800
ATCSECST EQU   ISTATCVT+812
ATCAOSM  EQU   ISTATCVT+912
ATCGSRBQ EQU   ATCAOSM+4
ATCGSRBG EQU   ATCGSRBQ
ATCICAPP EQU   ATCAOSM+100
ATCLDAPP EQU   ATCAOSM+120
ATCDAPVT EQU   ATCAOSM+140
ATCVTFLG EQU   ATCAOSM+392
ATCZFLAG EQU   ATCAOSM+588
ISTAVT   EQU   0
ISTAS49  EQU   ISTAVT+4
ISTLCCW  EQU   0
LCCWOP   EQU   ISTLCCW
LCCWRWOP EQU   LCCWOP
LCCWCTL  EQU   LCCWRWOP
LCCWFLAG EQU   ISTLCCW+1
LCCWLSI  EQU   LCCWFLAG
ISTLCPB  EQU   0
LCPREQTG EQU   ISTLCPB+2
LCPFLAGS EQU   LCPREQTG
LCPZF001 EQU   LCPFLAGS
LCPZRT02 EQU   LCPZF001
LCPZF002 EQU   LCPFLAGS
LCPZRT03 EQU   LCPZF002
LCPZF003 EQU   LCPFLAGS
LCPZRT04 EQU   LCPZF003
LCPZF004 EQU   LCPFLAGS
LCPZRT05 EQU   LCPZF004
LCPZRT06 EQU   LCPFLAGS
LCPZRT07 EQU   LCPFLAGS
LCPMNRCD EQU   LCPREQTG+1
LCPZRT08 EQU   LCPMNRCD
LCPZRT09 EQU   LCPMNRCD
LCPCHAIN EQU   ISTLCPB+4
LCPCHAI1 EQU   LCPCHAIN
LCPRUCNT EQU   ISTLCPB+8
LCPFLAG2 EQU   ISTLCPB+9
LCPTLBPI EQU   LCPFLAG2
LCPFID0  EQU   LCPFLAG2
LCPSEQ   EQU   ISTLCPB+10
LCPCID   EQU   ISTLCPB+16
LCPFDBA  EQU   ISTLCPB+24
LCPFLG1  EQU   ISTLCPB+37
LCPFLCCW EQU   ISTLCPB+40
LCPLCCW  EQU   ISTLCPB+48
LCPPABA  EQU   LCPLCCW+4
LCPRPHA  EQU   LCPPABA
ISTZSAVE EQU   0
ZSAZSVBC EQU   ISTZSAVE
ZSAZSVMS EQU   ZSAZSVBC
ISTPFCRR EQU   0
PFCCRR   EQU   ISTPFCRR
PFCCRRID EQU   PFCCRR
PFCCRRLN EQU   PFCCRR+2
PFCHDR   EQU   ISTPFCRR+4
PFCCRRO  EQU   PFCHDR
PFCFRRO  EQU   PFCHDR+4
ISTCFCRR EQU   0
CFCAUDIT EQU   ISTCFCRR
CFCNTRD  EQU   CFCAUDIT
CFCCRT   EQU   CFCAUDIT+1
ISTZCRR  EQU   0
ZCRCRR   EQU   ISTZCRR
ZCRFLGS1 EQU   ISTZCRR+12
ZCRFLGS2 EQU   ISTZCRR+13
ZCRSWFLD EQU   ISTZCRR+14
ZCRENDSH EQU   ZCRSWFLD
ZCRNDLCP EQU   ZCRSWFLD
ZCRRESET EQU   ZCRSWFLD
ZCRFLGS3 EQU   ISTZCRR+15
ZCRGENSW EQU   ISTZCRR+16
ZCRPFLGS EQU   ISTZCRR+17
ZCRIBPR  EQU   ISTZCRR+18
ZCRSCPSW EQU   ISTZCRR+19
ZCRPARMS EQU   ISTZCRR+24
ZCRFBPTR EQU   ZCRPARMS
ZCRDFRDA EQU   ZCRPARMS+10
ZCRPCOD1 EQU   ZCRPARMS+12
ZCRPLSBF EQU   ZCRPCOD1
ZCRPCOD2 EQU   ZCRPARMS+13
ZCRSVRTN EQU   ISTZCRR+56
ZCRWKARA EQU   ISTZCRR+156
ZCRCIDSV EQU   ISTZCRR+192
ZCRAUDIT EQU   ISTZCRR+440
ZCRENTER EQU   ZCRAUDIT+5
ZCRLCPB  EQU   ISTZCRR+480
ZCRRHRU  EQU   ZCRLCPB
ISTASCRR EQU   0
ASCFLAGS EQU   ISTASCRR+16
ASCFLG1  EQU   ASCFLAGS
ASCFLG2  EQU   ASCFLAGS+2
ASCFLG3  EQU   ASCFLAGS+4
ASCUSRGS EQU   ISTASCRR+28
ISTAPCRR EQU   0
APCATFLG EQU   ISTAPCRR+16
APCRFLG  EQU   ISTAPCRR+18
APCSAVE  EQU   ISTAPCRR+44
APCCOMF  EQU   ISTAPCRR+116
APCCOMF1 EQU   APCCOMF
APC31FLG EQU   ISTAPCRR+132
APC52FLG EQU   ISTAPCRR+133
APC53FLG EQU   ISTAPCRR+134
APC54FLG EQU   ISTAPCRR+135
APC57FLG EQU   ISTAPCRR+136
ISTCRA   EQU   0
CRABASIC EQU   ISTCRA
CRAHDR   EQU   CRABASIC
CRACRR   EQU   CRAHDR
CRALKACT EQU   CRABASIC+8
CRAL2PTR EQU   CRABASIC+16
CRAL3PTR EQU   CRABASIC+20
CRASVC   EQU   ISTCRA+848
CRABUFA  EQU   CRASVC+68
ISTCNSTA EQU   0
CNSTFLDA EQU   ISTCNSTA+16
CNSTFLDB EQU   ISTCNSTA+19
ISTOCCRR EQU   0
OCCAUDIT EQU   ISTOCCRR+22
OCCNTRD  EQU   OCCAUDIT
NOCCOF   EQU   OCCNTRD+1
OCCCRT   EQU   OCCAUDIT+3
COCCOF   EQU   OCCCRT+1
ISTFMCB  EQU   0
FMCSTAT  EQU   ISTFMCB+28
FMCSTAT1 EQU   ISTFMCB+29
FMCCMDFL EQU   ISTFMCB+31
FMCDEBA  EQU   ISTFMCB+32
FMCCMPS1 EQU   ISTFMCB+36
FMCSIPA  EQU   ISTFMCB+148
FMCNXOSQ EQU   ISTFMCB+152
FMCNXCFM EQU   FMCNXOSQ
FMCNXOSC EQU   FMCNXOSQ+2
FMCSSTAT EQU   ISTFMCB+159
FMCPACE  EQU   ISTFMCB+160
FMCPACEN EQU   FMCPACE
FMCPACEM EQU   FMCPACE+1
FMCPACPC EQU   FMCPACE+2
FMCCVAL  EQU   FMCPACE+3
FMCOBCE  EQU   FMCCVAL
FMCCLEXT EQU   ISTFMCB+164
FMCRPLA  EQU   FMCCLEXT
FMCFBA   EQU   FMCCLEXT+4
FMCCMPS2 EQU   FMCCLEXT+16
FMCFLGA  EQU   FMCCMPS2
FMCFLGCL EQU   FMCCMPS2+1
FMCPSCMD EQU   FMCCMPS2+2
FMCPSTAT EQU   FMCCMPS2+3
FMCSTAT2 EQU   ISTFMCB+186
FMCCPIP  EQU   FMCSTAT2
FMCMODEB EQU   ISTFMCB+189
FMCCLSEQ EQU   ISTFMCB+190
FMCRRESP EQU   ISTFMCB+195
FMCSSEGQ EQU   ISTFMCB+200
FMCFBAS  EQU   ISTFMCB+216
FMCZV002 EQU   FMCFBAS
FMCSNCTL EQU   ISTFMCB+224
FMCSCFLG EQU   FMCSNCTL
FMCVS1   EQU   ISTFMCB+232
FMCZFLAG EQU   FMCVS1
FMCZF006 EQU   FMCZFLAG
FMCLBXM  EQU   FMCVS1+12
FMCSHEAQ EQU   FMCLBXM
FMCLCPBQ EQU   FMCVS1+16
FMCLCPAQ EQU   FMCVS1+20
FMCSEQ1  EQU   FMCVS1+34
FMCZFLG2 EQU   FMCVS1+35
FMCCVFLG EQU   FMCVS1+44
FMCFLAG  EQU   0
FMCFLGB  EQU   FMCFLAG
C14SVPTR EQU   0
C14SAVE  EQU   0
ISTOCCDF EQU   0
SORTCID  EQU   0
FMZL0011 EQU   0
FMZL0027 EQU   0
FMZL0052 EQU   0
FMZL0062 EQU   0
ISTSDCCF EQU   0
ISTSDCCR EQU   0
ISTRPL   EQU   0
ISTSDCCA EQU   0
ISTSDCCD EQU   0
ISTSDCCN EQU   0
FLC      EQU   PSA
PSARSVTE EQU   PSARSVT
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
LCPZTIE  EQU   LCPCID
LCPZSNAM EQU   LCPZTIE+8
CMZCIDM  EQU   ATCCIDM
RTRDNCBA EQU   ISTRTR+40
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
LCPZTRV4 EQU   LCPZSNAM+4
LCPZTRV1 EQU   LCPZSNAM
LCPZSNA  EQU   LCPZTIE+4
LCPZFMCA EQU   LCPZTIE
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTRV620 EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTIRM   EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRV607 EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
FMCFLRSV EQU   FMCFLGB
FMCFLGA8 EQU   FMCFLGB
FMCCLRPH EQU   FMCVS1+45
FMCRSV0X EQU   FMCCVFLG
FMCVYRPH EQU   FMCCVFLG
FMCZV004 EQU   FMCVS1+40
FMCLOCK2 EQU   FMCVS1+36
@NM00100 EQU   FMCZFLG2
FMCZF027 EQU   FMCZFLG2
FMCZF026 EQU   FMCZFLG2
FMCSEQ1B EQU   FMCSEQ1
FMCSEQ1T EQU   FMCSEQ1
FMCZX006 EQU   FMCVS1+33
FMCZX005 EQU   FMCVS1+32
FMCZX004 EQU   FMCVS1+31
FMCZX003 EQU   FMCVS1+30
FMCZX002 EQU   FMCVS1+29
FMCZX001 EQU   FMCVS1+28
FMCZV001 EQU   FMCVS1+24
FMCAWATQ EQU   FMCLCPAQ+1
@NM00099 EQU   FMCLCPAQ
FMCLCPB2 EQU   FMCLCPBQ+1
FMCLCPB1 EQU   FMCLCPBQ
FMCASCDQ EQU   FMCSHEAQ+1
@NM00098 EQU   FMCSHEAQ
FMCSHEDQ EQU   FMCVS1+8
FMCZFCSQ EQU   FMCVS1+6
FMCZH001 EQU   FMCVS1+4
FMCZF025 EQU   FMCZFLAG+3
FMCZF024 EQU   FMCZFLAG+3
FMCZF023 EQU   FMCZFLAG+3
FMCZF022 EQU   FMCZFLAG+3
FMCZF021 EQU   FMCZFLAG+3
FMCZF020 EQU   FMCZFLAG+3
FMCZF019 EQU   FMCZFLAG+3
FMCZF018 EQU   FMCZFLAG+3
FMCZF017 EQU   FMCZFLAG+2
FMCZF016 EQU   FMCZFLAG+2
FMCZF015 EQU   FMCZFLAG+2
FMCZF014 EQU   FMCZFLAG+2
FMCZF013 EQU   FMCZFLAG+2
FMCZF012 EQU   FMCZFLAG+2
FMCZF011 EQU   FMCZFLAG+2
FMCZF010 EQU   FMCZFLAG+2
FMCZF00F EQU   FMCZFLAG+1
FMCZF00E EQU   FMCZFLAG+1
FMCZF00D EQU   FMCZFLAG+1
FMCZF00C EQU   FMCZFLAG+1
FMCZF00B EQU   FMCZFLAG+1
FMCRSV10 EQU   FMCZFLAG+1
FMCZF009 EQU   FMCZFLAG+1
FMCZFD06 EQU   FMCZF006+1
FMCZFC06 EQU   FMCZF006
FMCZFB06 EQU   FMCZF006
FMCZFA06 EQU   FMCZF006
FMCZF005 EQU   FMCZFLAG
FMCZF004 EQU   FMCZFLAG
FMCZF003 EQU   FMCZFLAG
FMCZF002 EQU   FMCZFLAG
FMCZF001 EQU   FMCZFLAG
FMCFRESA EQU   ISTFMCB+228
FMCSCSQN EQU   FMCSNCTL+2
FMCSCCTL EQU   FMCSNCTL+1
FMCSTCTL EQU   FMCSCFLG
FMCSCCLO EQU   FMCSCFLG
FMCAPRO  EQU   FMCSCFLG
FMCLURO  EQU   FMCSCFLG
FMCOBSAC EQU   FMCSCFLG
FMCIBSAC EQU   FMCSCFLG
FMCFBRE  EQU   ISTFMCB+220
FMCFBXM  EQU   FMCZV002
FMCASEGQ EQU   ISTFMCB+212
FMCRDTPT EQU   ISTFMCB+208
FMCLOCK  EQU   ISTFMCB+204
FMCSEGD  EQU   FMCSSEGQ
FMCRSPLM EQU   ISTFMCB+198
FMCPSTRS EQU   ISTFMCB+196
@NM00097 EQU   FMCRRESP
FMCTSLHA EQU   FMCRRESP
FMCFRRN  EQU   FMCRRESP
FMCFME   EQU   FMCRRESP
FMCFEX   EQU   FMCRRESP
FMCFPE   EQU   FMCRRESP
FMCCTLB  EQU   ISTFMCB+194
FMCBSQNO EQU   FMCCLSEQ+2
FMCTSQNO EQU   FMCCLSEQ
FMCOBPRG EQU   FMCMODEB
FMCIBPRG EQU   FMCMODEB
FMCRESOT EQU   FMCMODEB
FMCRSTSR EQU   FMCMODEB
FMCLUQ   EQU   FMCMODEB
FMCAPQ   EQU   FMCMODEB
FMCCLEAR EQU   FMCMODEB
FMCHOLD  EQU   FMCMODEB
FMCIPSEQ EQU   ISTFMCB+188
FMCLUSTR EQU   ISTFMCB+187
FMCRSV87 EQU   FMCSTAT2
FMCSEQI  EQU   FMCSTAT2
FMCALIPR EQU   FMCSTAT2
FMCIAIO  EQU   FMCSTAT2
FMCZF00A EQU   FMCSTAT2
FMCVPIP  EQU   FMCSTAT2
FMCBHSET EQU   ISTFMCB+185
FMCPRMRC EQU   FMCCLEXT+20
FMCRSV89 EQU   FMCPSTAT
FMCPCLSD EQU   FMCPSTAT
FMCDDOCD EQU   FMCPSTAT
FMCIDVFD EQU   FMCPSTAT
FMCELKST EQU   FMCPSTAT
FMCRSV88 EQU   FMCPSCMD
FMCRDBLK EQU   FMCPSCMD
FMCDSEOC EQU   FMCPSCMD
FMCPURGE EQU   FMCPSCMD
FMCRESTI EQU   FMCPSCMD
FMCCNTCT EQU   FMCPSCMD
FMCINVT  EQU   FMCPSCMD
FMCFLGB7 EQU   FMCFLGCL
FMCFLGB6 EQU   FMCFLGCL
FMCFLGB5 EQU   FMCFLGCL
FMCFLGB4 EQU   FMCFLGCL
FMCFLGB3 EQU   FMCFLGCL
FMCFLGB2 EQU   FMCFLGCL
FMCFLGB1 EQU   FMCFLGCL
FMCFLGB0 EQU   FMCFLGCL
FMCFLGA7 EQU   FMCFLGA
FMCFLGA6 EQU   FMCFLGA
FMCFLGA5 EQU   FMCFLGA
FMCFLGA4 EQU   FMCFLGA
FMCFLGA3 EQU   FMCFLGA
FMCFLGA2 EQU   FMCFLGA
FMCFLGA1 EQU   FMCFLGA
FMCFLGA0 EQU   FMCFLGA
FMCDCLOK EQU   FMCCLEXT+12
FMCRAFM  EQU   FMCCLEXT+8
FMCFBPTR EQU   FMCFBA+1
FMCFBRSV EQU   FMCFBA
FMCRPLPT EQU   FMCRPLA+1
FMCRPLRS EQU   FMCRPLA
FMCPRCLS EQU   FMCCVAL
FMCIBCE  EQU   FMCCVAL
FMCONLY  EQU   FMCOBCE
FMCLAST  EQU   FMCOBCE
FMCMIDLE EQU   FMCOBCE
FMCFIRST EQU   FMCOBCE
FMCCPCNT EQU   FMCPACPC
FMCMPCNT EQU   FMCPACEM
FMCNPCNT EQU   FMCPACEN
FMCCONF  EQU   FMCSSTAT
FMCPURCH EQU   FMCSSTAT
FMCNSALU EQU   FMCSSTAT
FMCBIP   EQU   FMCSSTAT
FMCSDTR  EQU   FMCSSTAT
FMCUIPI  EQU   FMCSSTAT
FMCCIPI  EQU   FMCSSTAT
FMCSNBI  EQU   FMCSSTAT
FMCRVD01 EQU   ISTFMCB+158
FMCISSN  EQU   ISTFMCB+156
FMCOASN  EQU   FMCNXOSC
FMCOSSN  EQU   FMCNXCFM
FMCSIP   EQU   FMCSIPA
FMCEXLST EQU   ISTFMCB+144
FMCPAB5  EQU   ISTFMCB+128
FMCPAB4  EQU   ISTFMCB+112
FMCPAB3  EQU   ISTFMCB+96
FMCPAB2  EQU   ISTFMCB+80
FMCPAB1  EQU   ISTFMCB+64
FMCFASYA EQU   ISTFMCB+60
FMCMODE  EQU   ISTFMCB+52
FMCPROCD EQU   ISTFMCB+48
FMCVWT   EQU   ISTFMCB+44
FMCRPLH  EQU   ISTFMCB+40
FMCBUFNB EQU   FMCCMPS1+2
FMCBUFLM EQU   FMCCMPS1
@NM00096 EQU   FMCCMDFL
FMCSNA   EQU   FMCCMDFL
FMCVSNA  EQU   FMCCMDFL
FMCCMDR  EQU   FMCCMDFL
@NM00095 EQU   ISTFMCB+30
@NM00094 EQU   FMCSTAT1
FMCHPURG EQU   FMCSTAT1
FMCVSP2  EQU   FMCSTAT1
FMCVSP1  EQU   FMCSTAT
FMCLTEAS EQU   FMCSTAT
FMCZF007 EQU   FMCSTAT
FMCDEDSC EQU   FMCSTAT
FMCDEVOF EQU   FMCSTAT
FMCDAPT  EQU   FMCSTAT
FMCPRMTE EQU   FMCSTAT
FMCPRMTR EQU   FMCSTAT
FMCUSFLD EQU   ISTFMCB+24
FMCFMCBA EQU   ISTFMCB+20
FMCDNCBA EQU   ISTFMCB+16
FMCDVTA  EQU   ISTFMCB+12
FMCTSKID EQU   ISTFMCB+8
FMCNXTCB EQU   ISTFMCB+4
FMCSAF   EQU   ISTFMCB+2
FMCLNGTH EQU   ISTFMCB+1
FMCTYPE  EQU   ISTFMCB
COCPOI   EQU   OCCCRT+2
COCACX   EQU   OCCCRT+2
COCCCN   EQU   OCCCRT+2
COCCCM   EQU   OCCCRT+2
COCCNV   EQU   OCCCRT+2
COCCCC   EQU   OCCCRT+2
COCCRL   EQU   OCCCRT+2
COCCQU   EQU   OCCCRT+2
COCCRT   EQU   OCCCRT+1
COCCFB   EQU   OCCCRT+1
COCCLD   EQU   OCCCRT+1
COCCOE   EQU   OCCCRT+1
COCCOD   EQU   OCCCRT+1
COCCSD   EQU   OCCCRT+1
COCCRD   EQU   OCCCRT+1
COCCFD   EQU   OCCCRT
COCCMD   EQU   OCCCRT
COCCFR   EQU   OCCCRT
COCCFO   EQU   OCCCRT
COCCSL   EQU   OCCCRT
COCCCH   EQU   OCCCRT
COCCCL   EQU   OCCCRT
COCCOC   EQU   OCCCRT
NOCPOI   EQU   OCCNTRD+2
NOCACX   EQU   OCCNTRD+2
NOCCCN   EQU   OCCNTRD+2
NOCCCM   EQU   OCCNTRD+2
NOCCNV   EQU   OCCNTRD+2
NOCCCC   EQU   OCCNTRD+2
NOCCRL   EQU   OCCNTRD+2
NOCCQU   EQU   OCCNTRD+2
NOCCRT   EQU   OCCNTRD+1
NOCCFB   EQU   OCCNTRD+1
NOCCLD   EQU   OCCNTRD+1
NOCCOE   EQU   OCCNTRD+1
NOCCOD   EQU   OCCNTRD+1
NOCCSD   EQU   OCCNTRD+1
NOCCRD   EQU   OCCNTRD+1
NOCCFD   EQU   OCCNTRD
NOCCMD   EQU   OCCNTRD
NOCCFR   EQU   OCCNTRD
NOCCFO   EQU   OCCNTRD
NOCCSL   EQU   OCCNTRD
NOCCCH   EQU   OCCNTRD
NOCCCL   EQU   OCCNTRD
NOCCOC   EQU   OCCNTRD
OCCCNS   EQU   ISTOCCRR
CNSRSV05 EQU   CNSTFLDB+2
CNSLOG0B EQU   CNSTFLDB+2
CNSACCTB EQU   CNSTFLDB+2
CNSFREEB EQU   CNSTFLDB+2
CNSGETSB EQU   CNSTFLDB+2
CNSSEARB EQU   CNSTFLDB+2
CNSQUEUB EQU   CNSTFLDB+2
CNSACONB EQU   CNSTFLDB+2
CNSTCONB EQU   CNSTFLDB+1
CNSCLAQB EQU   CNSTFLDB+1
CNSCLINB EQU   CNSTFLDB+1
CNSGBINB EQU   CNSTFLDB+1
CNSLGINB EQU   CNSTFLDB+1
CNSACINB EQU   CNSTFLDB+1
CNSPSINB EQU   CNSTFLDB+1
CNSRQRLB EQU   CNSTFLDB+1
CNSTRRLB EQU   CNSTFLDB
CNSDORLB EQU   CNSTFLDB
CNSRLINB EQU   CNSTFLDB
CNSQREQB EQU   CNSTFLDB
CNSXREQB EQU   CNSTFLDB
CNSAQINB EQU   CNSTFLDB
CNSAUTHB EQU   CNSTFLDB
CNSMRINB EQU   CNSTFLDB
CNSRSV01 EQU   CNSTFLDA+2
CNSLOG0A EQU   CNSTFLDA+2
CNSACCTA EQU   CNSTFLDA+2
CNSFREEA EQU   CNSTFLDA+2
CNSGETSA EQU   CNSTFLDA+2
CNSSEARA EQU   CNSTFLDA+2
CNSQUEUA EQU   CNSTFLDA+2
CNSACONA EQU   CNSTFLDA+2
CNSTCONA EQU   CNSTFLDA+1
CNSCLAQA EQU   CNSTFLDA+1
CNSCLINA EQU   CNSTFLDA+1
CNSGBINA EQU   CNSTFLDA+1
CNSLGINA EQU   CNSTFLDA+1
CNSACINA EQU   CNSTFLDA+1
CNSPSINA EQU   CNSTFLDA+1
CNSRQRLA EQU   CNSTFLDA+1
CNSTRRLA EQU   CNSTFLDA
CNSDORLA EQU   CNSTFLDA
CNSRLINA EQU   CNSTFLDA
CNSQREQA EQU   CNSTFLDA
CNSXREQA EQU   CNSTFLDA
CNSAQINA EQU   CNSTFLDA
CNSAUTHA EQU   CNSTFLDA
CNSMRINA EQU   CNSTFLDA
CNSTPFX  EQU   ISTCNSTA
CRACHAIN EQU   ISTCRA+928
CRARSV02 EQU   ISTCRA+924
CRARSV01 EQU   ISTCRA+920
CRABFTBA EQU   CRABUFA
CRAMASK  EQU   CRASVC+64
CRAHSIZ  EQU   CRASVC+60
CRAASCRR EQU   CRASVC
CRAPROCR EQU   ISTCRA+312
CRAPSS   EQU   ISTCRA+160
CRARPH   EQU   ISTCRA+52
CRALAPTR EQU   CRABASIC+48
CRAL9PTR EQU   CRABASIC+44
CRAL8PTR EQU   CRABASIC+40
CRAL7PTR EQU   CRABASIC+36
CRAL6PTR EQU   CRABASIC+32
CRAL5PTR EQU   CRABASIC+28
CRAL4PTR EQU   CRABASIC+24
CRAL1PTR EQU   CRABASIC+12
CRALEV01 EQU   CRALKACT+3
CRALEV02 EQU   CRALKACT+3
CRALEV03 EQU   CRALKACT+3
CRALEV04 EQU   CRALKACT+3
CRALEV05 EQU   CRALKACT+3
CRALEV06 EQU   CRALKACT+3
CRALEV07 EQU   CRALKACT+3
CRALEV08 EQU   CRALKACT+3
CRALEV09 EQU   CRALKACT+2
CRALEV10 EQU   CRALKACT+2
CRALEV11 EQU   CRALKACT+2
CRALEV12 EQU   CRALKACT+2
CRALEV13 EQU   CRALKACT+2
CRALEV14 EQU   CRALKACT+2
CRALEV15 EQU   CRALKACT+2
CRALEV16 EQU   CRALKACT+2
CRALEV17 EQU   CRALKACT+1
CRALEV18 EQU   CRALKACT+1
CRALEV19 EQU   CRALKACT+1
CRALEV20 EQU   CRALKACT+1
CRALEV21 EQU   CRALKACT+1
CRALEV22 EQU   CRALKACT+1
CRALEV23 EQU   CRALKACT+1
CRALEV24 EQU   CRALKACT+1
CRALEV25 EQU   CRALKACT
CRALEV26 EQU   CRALKACT
CRALEV27 EQU   CRALKACT
CRALEV28 EQU   CRALKACT
CRALEV29 EQU   CRALKACT
CRALEV30 EQU   CRALKACT
CRALEV31 EQU   CRALKACT
CRALEV32 EQU   CRALKACT
CRAFRR   EQU   CRAHDR+4
@NM00093 EQU   ISTAPCRR+137
@NM00092 EQU   APC57FLG
APCNREL  EQU   APC57FLG
APCRECRA EQU   APC57FLG
@NM00091 EQU   APC54FLG
APCRLST  EQU   APC54FLG
APCPR153 EQU   APC53FLG
@NM00090 EQU   APC52FLG
APCWKF   EQU   APC52FLG
APCNWF   EQU   APC52FLG
APCRDQ   EQU   APC52FLG
APCQENQ  EQU   APC52FLG
APCSMSR  EQU   APC52FLG
APCCKRQ  EQU   APC52FLG
@NM00089 EQU   APC31FLG
APCSORT  EQU   APC31FLG
APCRESCH EQU   APC31FLG
APCTPXIT EQU   APC31FLG
APCSWTWD EQU   ISTAPCRR+128
APCSAV2  EQU   ISTAPCRR+124
APCSAV1  EQU   ISTAPCRR+120
APCRETCD EQU   APCCOMF+2
@NM00088 EQU   APCCOMF1+1
APCZLBER EQU   APCCOMF1
APCEXIT  EQU   APCCOMF1
APCRELR  EQU   APCCOMF1
APCIRB2  EQU   APCCOMF1
APCIRB1  EQU   APCCOMF1
APCSMCR  EQU   APCCOMF1
APCUETSK EQU   APCCOMF1
APCSSTSK EQU   APCCOMF1
APCESTAL EQU   APCSAVE
APCFRRPM EQU   ISTAPCRR+40
APCQWFO  EQU   ISTAPCRR+36
APCPABSV EQU   ISTAPCRR+32
APCRTRN  EQU   ISTAPCRR+28
APCTCBA  EQU   ISTAPCRR+24
APCPSTA  EQU   ISTAPCRR+20
@NM00087 EQU   APCRFLG+1
APC31R   EQU   APCRFLG
APC58R   EQU   APCRFLG
APC57R   EQU   APCRFLG
APC56R   EQU   APCRFLG
APC54R   EQU   APCRFLG
APC53R   EQU   APCRFLG
APC52R   EQU   APCRFLG
APC51R   EQU   APCRFLG
@NM00086 EQU   APCATFLG+1
APC31E   EQU   APCATFLG
APC58E   EQU   APCATFLG
APC57E   EQU   APCATFLG
APC56E   EQU   APCATFLG
APC54E   EQU   APCATFLG
APC53E   EQU   APCATFLG
APC52E   EQU   APCATFLG
APC51E   EQU   APCATFLG
APCHDRSV EQU   ISTAPCRR
ASCPSREG EQU   ISTASCRR+44
ASCUSR01 EQU   ASCUSRGS+12
ASCUSR00 EQU   ASCUSRGS+8
ASCUSR15 EQU   ASCUSRGS+4
ASCUSR14 EQU   ASCUSRGS
ASCETRYA EQU   ISTASCRR+24
ASCKEY   EQU   ISTASCRR+23
ASCAUDIT EQU   ASCFLG3
ASCFBDUD EQU   ASCFLG3
ASCLLKF  EQU   ASCFLG3
ASCKEYF  EQU   ASCFLG3
ASCFBDAL EQU   ASCFLG3
ASCFSRGT EQU   ASCFLG3
ASCICR   EQU   ASCFLG2
ASCFSRIC EQU   ASCFLG2
ASCFBDIC EQU   ASCFLG2
ASCFBAIC EQU   ASCFLG2
ASCPASTR EQU   ASCFLG1
ASCFSR   EQU   ASCFLG1
ASCFBD   EQU   ASCFLG1
ASCFBA   EQU   ASCFLG1
ASCPFCRR EQU   ISTASCRR
ZCRRU    EQU   ZCRRHRU+3
ZCRRH    EQU   ZCRRHRU
ZCRWORDA EQU   ISTZCRR+477
ZCRCMNRC EQU   ISTZCRR+476
ZCRRSV97 EQU   ZCRENTER+18
ZCREIC2B EQU   ZCRENTER+18
ZCREAC2B EQU   ZCRENTER+18
ZCRELCAB EQU   ZCRENTER+18
ZCREDCMF EQU   ZCRENTER+18
ZCREBCIF EQU   ZCRENTER+18
ZCREICSG EQU   ZCRENTER+18
ZCREDCK0 EQU   ZCRENTER+18
ZCRECFY0 EQU   ZCRENTER+17
ZCREKCCB EQU   ZCRENTER+17
ZCREDCNB EQU   ZCRENTER+17
ZCREICOE EQU   ZCRENTER+17
ZCREBCNB EQU   ZCRENTER+17
ZCREBC0L EQU   ZCRENTER+17
ZCREBCAL EQU   ZCRENTER+17
ZCREDCQR EQU   ZCRENTER+17
ZCREDCPR EQU   ZCRENTER+16
ZCREBCSB EQU   ZCRENTER+16
ZCREAC1R EQU   ZCRENTER+16
ZCRECCCI EQU   ZCRENTER+16
ZCRECCAI EQU   ZCRENTER+16
ZCRECCBI EQU   ZCRENTER+16
ZCREBCAR EQU   ZCRENTER+16
ZCREBCDR EQU   ZCRENTER+16
ZCREBCBR EQU   ZCRENTER+15
ZCREDCXR EQU   ZCRENTER+15
ZCREDCWB EQU   ZCRENTER+15
ZCREDCWR EQU   ZCRENTER+15
ZCREKCCN EQU   ZCRENTER+15
ZCREKCBN EQU   ZCRENTER+15
ZCREKCBB EQU   ZCRENTER+15
ZCREJC0B EQU   ZCRENTER+15
ZCREJCDB EQU   ZCRENTER+14
ZCREJCCB EQU   ZCRENTER+14
ZCREJCBB EQU   ZCRENTER+14
ZCREJCAB EQU   ZCRENTER+14
ZCREIC1B EQU   ZCRENTER+14
ZCREIC0B EQU   ZCRENTER+14
ZCREICX0 EQU   ZCRENTER+14
ZCREICWB EQU   ZCRENTER+14
ZCREICVB EQU   ZCRENTER+13
ZCREICUB EQU   ZCRENTER+13
ZCREICTB EQU   ZCRENTER+13
ZCREICSC EQU   ZCRENTER+13
ZCREICSB EQU   ZCRENTER+13
ZCREICRB EQU   ZCRENTER+13
ZCREICQB EQU   ZCRENTER+13
ZCREICQA EQU   ZCRENTER+13
ZCREICOB EQU   ZCRENTER+12
ZCREICOA EQU   ZCRENTER+12
ZCREICNB EQU   ZCRENTER+12
ZCREICNA EQU   ZCRENTER+12
ZCREICMB EQU   ZCRENTER+12
ZCREICLB EQU   ZCRENTER+12
ZCREICKG EQU   ZCRENTER+12
ZCREICKE EQU   ZCRENTER+12
ZCREICKB EQU   ZCRENTER+11
ZCREICJB EQU   ZCRENTER+11
ZCREICID EQU   ZCRENTER+11
ZCREICIB EQU   ZCRENTER+11
ZCREICHB EQU   ZCRENTER+11
ZCREICGB EQU   ZCRENTER+11
ZCREICEB EQU   ZCRENTER+11
ZCREICDB EQU   ZCRENTER+11
ZCREICCI EQU   ZCRENTER+10
ZCREICCB EQU   ZCRENTER+10
ZCREICBI EQU   ZCRENTER+10
ZCREICBB EQU   ZCRENTER+10
ZCREICAB EQU   ZCRENTER+10
ZCREICAA EQU   ZCRENTER+10
ZCREHCAN EQU   ZCRENTER+10
ZCREGC0B EQU   ZCRENTER+10
ZCREGC0A EQU   ZCRENTER+9
ZCREGCLA EQU   ZCRENTER+9
ZCREGCEB EQU   ZCRENTER+9
ZCREGCDB EQU   ZCRENTER+9
@NM00085 EQU   ZCRENTER+9
ZCREGCBB EQU   ZCRENTER+9
ZCREGCAB EQU   ZCRENTER+9
ZCREFCEB EQU   ZCRENTER+9
ZCREFCEA EQU   ZCRENTER+8
ZCREECTA EQU   ZCRENTER+8
ZCREECEA EQU   ZCRENTER+8
ZCREECDA EQU   ZCRENTER+8
ZCREECCB EQU   ZCRENTER+8
ZCREECCA EQU   ZCRENTER+8
ZCREECBB EQU   ZCRENTER+8
ZCREECBA EQU   ZCRENTER+8
ZCREDCMB EQU   ZCRENTER+7
ZCREDCL0 EQU   ZCRENTER+7
ZCREDCKB EQU   ZCRENTER+7
ZCREDCKA EQU   ZCRENTER+7
ZCREDCJ0 EQU   ZCRENTER+7
ZCREDCI0 EQU   ZCRENTER+7
ZCREDCH0 EQU   ZCRENTER+7
ZCREDCF0 EQU   ZCRENTER+7
ZCREDCE0 EQU   ZCRENTER+6
ZCREDCD0 EQU   ZCRENTER+6
ZCREDCC0 EQU   ZCRENTER+6
ZCREDCB0 EQU   ZCRENTER+6
ZCREDCA0 EQU   ZCRENTER+6
ZCRECC2B EQU   ZCRENTER+6
ZCRECC1B EQU   ZCRENTER+6
ZCRECC1A EQU   ZCRENTER+6
ZCRECC0B EQU   ZCRENTER+5
ZCRECC0A EQU   ZCRENTER+5
ZCREBC0B EQU   ZCRENTER+5
ZCREBC0A EQU   ZCRENTER+5
ZCREBCZ0 EQU   ZCRENTER+5
ZCREBCY0 EQU   ZCRENTER+5
ZCREBCX0 EQU   ZCRENTER+5
ZCREBCXA EQU   ZCRENTER+5
ZCREBCSC EQU   ZCRENTER+4
ZCREBCRB EQU   ZCRENTER+4
ZCREBCRA EQU   ZCRENTER+4
ZCREBCQB EQU   ZCRENTER+4
ZCREBCPB EQU   ZCRENTER+4
ZCREBCOB EQU   ZCRENTER+4
ZCREBCNE EQU   ZCRENTER+4
ZCREBCND EQU   ZCRENTER+4
ZCREBCMB EQU   ZCRENTER+3
ZCREBCLB EQU   ZCRENTER+3
ZCREBCLA EQU   ZCRENTER+3
ZCREBCKB EQU   ZCRENTER+3
ZCREBCKA EQU   ZCRENTER+3
ZCREBCJB EQU   ZCRENTER+3
ZCREBCJA EQU   ZCRENTER+3
ZCREBCID EQU   ZCRENTER+3
ZCREBCIB EQU   ZCRENTER+2
ZCREBCIA EQU   ZCRENTER+2
ZCREBCHB EQU   ZCRENTER+2
ZCREBCHA EQU   ZCRENTER+2
ZCREBCGB EQU   ZCRENTER+2
ZCREBCGA EQU   ZCRENTER+2
ZCREBCFB EQU   ZCRENTER+2
ZCREBCFA EQU   ZCRENTER+2
ZCREBCEB EQU   ZCRENTER+1
ZCREBCDI EQU   ZCRENTER+1
ZCREBCCB EQU   ZCRENTER+1
ZCREBCBI EQU   ZCRENTER+1
ZCREBCBB EQU   ZCRENTER+1
ZCREBCBA EQU   ZCRENTER+1
ZCREBCAM EQU   ZCRENTER+1
ZCREBCAI EQU   ZCRENTER+1
ZCREBCAG EQU   ZCRENTER
ZCREBCAE EQU   ZCRENTER
ZCREBCAB EQU   ZCRENTER
ZCREBCAA EQU   ZCRENTER
ZCREAC1B EQU   ZCRENTER
ZCREAC0B EQU   ZCRENTER
ZCREAC0A EQU   ZCRENTER
ZCREAC1A EQU   ZCRENTER
ZCRTNAME EQU   ZCRAUDIT+1
ZCRTID   EQU   ZCRAUDIT
ZCRREMIC EQU   ISTZCRR+436
ZCRSAVEZ EQU   ISTZCRR+196
ZCRDAFSV EQU   ZCRCIDSV+2
ZCRSAFSV EQU   ZCRCIDSV
ZCRR13SV EQU   ISTZCRR+188
ZCRR2SV  EQU   ISTZCRR+184
ZCROPCDE EQU   ISTZCRR+183
ZCRPRMTC EQU   ISTZCRR+182
ZCRRCDSV EQU   ISTZCRR+181
ZCRAWQSW EQU   ISTZCRR+180
ZCRTOPQ  EQU   ISTZCRR+180
ZCRLSTFB EQU   ISTZCRR+180
ZCRXSCHD EQU   ISTZCRR+180
ZCRNXTEL EQU   ISTZCRR+180
ZCRSCANQ EQU   ISTZCRR+180
ZCRMOREL EQU   ISTZCRR+180
ZCRFBPRC EQU   ISTZCRR+180
ZCRFSBSV EQU   ISTZCRR+176
ZCRSVWK5 EQU   ZCRWKARA+16
ZCRSVWK4 EQU   ZCRWKARA+12
ZCRSVWK3 EQU   ZCRWKARA+8
ZCRSVWK2 EQU   ZCRWKARA+4
ZCRSVWK1 EQU   ZCRWKARA
ZCRSVF25 EQU   ZCRSVRTN+96
ZCRSVF24 EQU   ZCRSVRTN+92
ZCRSVF23 EQU   ZCRSVRTN+88
ZCRSVF22 EQU   ZCRSVRTN+84
ZCRSVF21 EQU   ZCRSVRTN+80
ZCRSVF20 EQU   ZCRSVRTN+76
ZCRSVF19 EQU   ZCRSVRTN+72
ZCRSVF18 EQU   ZCRSVRTN+68
ZCRSVF17 EQU   ZCRSVRTN+64
ZCRSVF16 EQU   ZCRSVRTN+60
ZCRSVF15 EQU   ZCRSVRTN+56
ZCRSVF14 EQU   ZCRSVRTN+52
ZCRSVF13 EQU   ZCRSVRTN+48
ZCRSVF12 EQU   ZCRSVRTN+44
ZCRSVF11 EQU   ZCRSVRTN+40
ZCRSVF10 EQU   ZCRSVRTN+36
ZCRSVF9  EQU   ZCRSVRTN+32
ZCRSVF8  EQU   ZCRSVRTN+28
ZCRSVF7  EQU   ZCRSVRTN+24
ZCRSVF6  EQU   ZCRSVRTN+20
ZCRSVF5  EQU   ZCRSVRTN+16
ZCRSVF4  EQU   ZCRSVRTN+12
ZCRSVF3  EQU   ZCRSVRTN+8
ZCRSVF2  EQU   ZCRSVRTN+4
ZCRSVF1  EQU   ZCRSVRTN
ZCRPVZB  EQU   ISTZCRR+52
ZCRZLB   EQU   ISTZCRR+48
ZCRBFPTR EQU   ISTZCRR+44
ZCRCCWA  EQU   ISTZCRR+40
ZCRPSW   EQU   ZCRPARMS+15
ZCRPCHAR EQU   ZCRPARMS+14
ZCRPRES2 EQU   ZCRPCOD2
ZCRPMFGF EQU   ZCRPCOD2
ZCRPFHDR EQU   ZCRPCOD2
ZCRPPG2  EQU   ZCRPCOD2
ZCRPRES  EQU   ZCRPCOD1
ZCRPCFTX EQU   ZCRPCOD1
ZCRPBUF  EQU   ZCRPCOD1
ZCRPLSCB EQU   ZCRPCOD1
ZCRPLSBQ EQU   ZCRPLSBF
ZCRPFSB  EQU   ZCRPCOD1
ZCRPLNG  EQU   ZCRPCOD1
ZCRPPG   EQU   ZCRPCOD1
ZCRDTODA EQU   ZCRDFRDA
ZCRMLNG  EQU   ZCRPARMS+8
ZCRTBPTR EQU   ZCRPARMS+4
ZCRCBPTR EQU   ZCRFBPTR
ZCRCRLCP EQU   ISTZCRR+20
@NM00084 EQU   ZCRSCPSW
ZCRSKIPT EQU   ZCRSCPSW
ZCRFSBWE EQU   ZCRSCPSW
ZCRPRCMP EQU   ZCRSCPSW
ZCRLREQ  EQU   ZCRSCPSW
ZCRRJLCP EQU   ZCRSCPSW
ZCRTPINV EQU   ZCRSCPSW
ZCRTPEX  EQU   ZCRSCPSW
@NM00083 EQU   ZCRIBPR
ZCR3270R EQU   ZCRIBPR
ZCR3270  EQU   ZCRIBPR
ZCRLCPFD EQU   ZCRIBPR
ZCRLCPFR EQU   ZCRIBPR
ZCRRELK  EQU   ZCRIBPR
ZCRERR   EQU   ZCRIBPR
ZCRNOBUF EQU   ZCRIBPR
@NM00082 EQU   ZCRPFLGS
ZCRQAHED EQU   ZCRPFLGS
ZCRF1RES EQU   ZCRGENSW
ZCRBRIS  EQU   ZCRGENSW
ZCRCLRBD EQU   ZCRGENSW
ZCREXRES EQU   ZCRGENSW
ZCRLCSYN EQU   ZCRGENSW
ZCRRT06  EQU   ZCRGENSW
ZCRTSW2  EQU   ZCRGENSW
ZCRTSW1  EQU   ZCRGENSW
ZCRINLCP EQU   ZCRFLGS3
ZCRWRPTR EQU   ZCRFLGS3
ZCRNOFRE EQU   ZCRFLGS3
ZCREDRIV EQU   ZCRFLGS3
ZCRDISC  EQU   ZCRFLGS3
ZCRTPDIS EQU   ZCRFLGS3
ZCRTPCON EQU   ZCRFLGS3
ZCRTIC   EQU   ZCRFLGS3
ZCRCNLXL EQU   ZCRRESET
ZCRENDAN EQU   ZCRSWFLD
ZCRENDXL EQU   ZCRSWFLD
ZCRENDX  EQU   ZCRSWFLD
ZCROB1   EQU   ZCRNDLCP
ZCRENDPR EQU   ZCRSWFLD
ZCREXTYP EQU   ZCRSWFLD
ZCRSLCP  EQU   ZCRENDSH
ZCRIF0E3 EQU   ZCRFLGS2
ZCRIF0E2 EQU   ZCRFLGS2
ZCRIF0E1 EQU   ZCRFLGS2
ZCROB    EQU   ZCRFLGS2
ZCRFMSED EQU   ZCRFLGS2
ZCRSHEDI EQU   ZCRFLGS2
ZCRLOCAL EQU   ZCRFLGS2
ZCRFEXIT EQU   ZCRFLGS1
ZCRUNSOL EQU   ZCRFLGS1
ZCRENDLP EQU   ZCRFLGS1
ZCRNRMEX EQU   ZCRFLGS1
ZCRWAIT  EQU   ZCRFLGS1
ZCRDEQSW EQU   ZCRFLGS1
ZCRQUESW EQU   ZCRFLGS1
ZCREXSW  EQU   ZCRFLGS1
ZCRFRRA  EQU   ISTZCRR+8
ZCRCHAIN EQU   ISTZCRR+4
ZCRFLAG  EQU   ZCRCRR+3
ZCRLEN   EQU   ZCRCRR+1
ZCRID    EQU   ZCRCRR
CCFRSVD1 EQU   CFCCRT
CCFCR2   EQU   CFCCRT
CCFCRP   EQU   CFCCRT
CCFCR1   EQU   CFCCRT
CCFCS2   EQU   CFCCRT
CCFCS1   EQU   CFCCRT
NCFRSVD  EQU   CFCNTRD
NCFCR2   EQU   CFCNTRD
NCFCRP   EQU   CFCNTRD
NCFCR1   EQU   CFCNTRD
NCFCS2   EQU   CFCNTRD
NCFCS1   EQU   CFCNTRD
PFCRSV01 EQU   ISTPFCRR+13
PFCFTA   EQU   ISTPFCRR+12
CRRFRR   EQU   PFCFRRO
CRRCHAIN EQU   PFCCRRO
CRRLEN   EQU   PFCCRRLN
PFCRSV10 EQU   PFCCRR+1
CRRID    EQU   PFCCRRID
ZSAZTRAC EQU   ISTZSAVE+36
ZSAZSVVR EQU   ISTZSAVE+12
ZSAZSVRR EQU   ISTZSAVE+8
ZSAZSVFC EQU   ISTZSAVE+4
ZSAZACTV EQU   ZSAZSVMS
LCPFTYPE EQU   LCPRPHA
LCPRSTQH EQU   LCPLCCW
LCPCLREP EQU   ISTLCPB+44
LCPUBFSB EQU   LCPFLCCW
LCPRSV77 EQU   ISTLCPB+39
LCPLCCWC EQU   ISTLCPB+38
LCPRSV78 EQU   LCPFLG1
LCPTRANS EQU   LCPFLG1
LCPSTLB  EQU   LCPFLG1
LCPREDRV EQU   LCPFLG1
LCPDIRPT EQU   LCPFLG1
LCPINTER EQU   LCPFLG1
LCPRESET EQU   LCPFLG1
LCPSTYPE EQU   ISTLCPB+36
LCPFSNCH EQU   ISTLCPB+34
LCPFOSN  EQU   ISTLCPB+32
LCPTLBAD EQU   ISTLCPB+28
LCPFDB2  EQU   LCPFDBA+1
LCPFDB1  EQU   LCPFDBA
LCPNXLCW EQU   ISTLCPB+20
LCPDAF   EQU   LCPCID+2
LCPSAF   EQU   LCPCID
LCPLCCW1 EQU   ISTLCPB+12
LCPRRCNT EQU   LCPSEQ+1
LCPRRCCT EQU   LCPSEQ
LCPATOP  EQU   LCPFLAG2
LCPFREE  EQU   LCPFLAG2
LCPDSTAT EQU   LCPFLAG2
LCPEXRES EQU   LCPFID0
LCPZRIMM EQU   LCPTLBPI
LCPRSTRT EQU   LCPFLAG2
LCPASYN  EQU   LCPFLAG2
LCPPRFLG EQU   LCPFLAG2
LCPZMIRC EQU   LCPRUCNT
LCPCHAI2 EQU   LCPCHAIN+1
LCPCHNG  EQU   LCPCHAI1
LCPZRT0B EQU   LCPMNRCD
LCPZRT0A EQU   LCPMNRCD
LCPZRTL9 EQU   LCPZRT09
LCPZRTL8 EQU   LCPZRT08
LCPZRTL7 EQU   LCPZRT07
LCPZRTL6 EQU   LCPZRT06
LCPZRTL5 EQU   LCPZRT05
LCPZRTL4 EQU   LCPZRT04
LCPZRTL3 EQU   LCPZRT03
LCPZRTL2 EQU   LCPZRT02
LCPZRT01 EQU   LCPFLAGS
LCPZRT00 EQU   LCPFLAGS
LCPLNGTH EQU   ISTLCPB+1
LCPTYPE  EQU   ISTLCPB
LCCWDATA EQU   ISTLCCW+4
LCCWCNT  EQU   ISTLCCW+2
LCCWACI  EQU   LCCWFLAG
LCCWRFI  EQU   LCCWFLAG
LCCWPER  EQU   LCCWLSI
LCCWIDAT EQU   LCCWFLAG
LCCWNTVC EQU   LCCWFLAG
LCCWCKPT EQU   LCCWFLAG
LCCWCC   EQU   LCCWFLAG
LCCWCD   EQU   LCCWFLAG
LCCWTYPE EQU   LCCWCTL
LCCWMODE EQU   LCCWCTL
LCCWSOP  EQU   LCCWRWOP
@NM00081 EQU   LCCWRWOP
LCCWSD   EQU   LCCWOP
LCCWSI   EQU   LCCWOP
ISTPDAVP EQU   ISTAVT+40
ISTAVR01 EQU   ISTAVT+38
ISTVTTP  EQU   ISTAVT+36
ISTAGTWT EQU   ISTAVT+34
ISTATRT  EQU   ISTAVT+32
ISTARID  EQU   ISTAVT+30
ISTX1    EQU   ISTAVT+29
ISTPHNM  EQU   ISTAVT+24
ISTAPSEX EQU   ISTAVT+20
ISTVTTIK EQU   ISTAVT+18
AVTASID  EQU   ISTAVT+16
ISTAPSTA EQU   ISTAVT+12
ISTAS53  EQU   ISTAVT+8
ISTAHIP  EQU   ISTAS49
ISTACVT  EQU   ISTAVT
ATCAOS   EQU   ISTATCVT+1584
ATCPOPAB EQU   ATCAOSM+640
ATCVIOPM EQU   ATCAOSM+636
ATCTPMMI EQU   ATCAOSM+632
ATCTPMPB EQU   ATCAOSM+600
ATCRSV88 EQU   ATCAOSM+596
ATCRPLCT EQU   ATCAOSM+594
ATCCRACT EQU   ATCAOSM+592
ATCSRBCT EQU   ATCAOSM+590
ATCRSV75 EQU   ATCAOSM+589
ATCRSV66 EQU   ATCZFLAG
ATCZF001 EQU   ATCZFLAG
ATCTPCP1 EQU   ATCAOSM+584
ATCTPCP0 EQU   ATCAOSM+580
ATCAICTN EQU   ATCAOSM+576
ATCZR01  EQU   ATCAOSM+572
ATCMPLTA EQU   ATCAOSM+568
ATCASCB  EQU   ATCAOSM+564
ATCAP86  EQU   ATCAOSM+560
ATCAP85  EQU   ATCAOSM+556
ATCAP84  EQU   ATCAOSM+552
ATCAP83  EQU   ATCAOSM+548
ATCAP82  EQU   ATCAOSM+544
ATCAP69  EQU   ATCAOSM+540
ATCAP66  EQU   ATCAOSM+536
ATCAP62  EQU   ATCAOSM+532
ATCAPC59 EQU   ATCAOSM+528
ATCAP56  EQU   ATCAOSM+524
ATCAP55  EQU   ATCAOSM+520
ATCRCFY0 EQU   ATCAOSM+516
ATCAP41  EQU   ATCAOSM+512
ATCAPC25 EQU   ATCAOSM+508
ATCAP23  EQU   ATCAOSM+504
ATCTPSPB EQU   ATCAOSM+472
ATCTRMPB EQU   ATCAOSM+440
ATCAPBE  EQU   ATCAOSM+436
ATCPSTA  EQU   ATCAOSM+432
ATCSMABF EQU   ATCAOSM+428
ATCSMAPR EQU   ATCAOSM+424
ATCTPWQA EQU   ATCAOSM+420
ATCSMAID EQU   ATCAOSM+416
ATCSMARA EQU   ATCAOSM+412
ATCCACXA EQU   ATCAOSM+408
ATCZLAAB EQU   ATCAOSM+404
ATCATA10 EQU   ATCAOSM+400
ATCHLTCB EQU   ATCAOSM+396
@NM00080 EQU   ATCVTFLG
ATCVTACT EQU   ATCVTFLG
ATCRPT40 EQU   ATCAOSM+388
ATCRPT39 EQU   ATCAOSM+384
ATCRPT38 EQU   ATCAOSM+380
ATCRPT37 EQU   ATCAOSM+376
ATCRPT36 EQU   ATCAOSM+372
ATCRPT35 EQU   ATCAOSM+368
ATCRPT34 EQU   ATCAOSM+364
ATCRPT33 EQU   ATCAOSM+360
ATCRPT32 EQU   ATCAOSM+356
ATCRPT31 EQU   ATCAOSM+352
ATCRPT30 EQU   ATCAOSM+348
ATCRPT29 EQU   ATCAOSM+344
ATCRPT28 EQU   ATCAOSM+340
ATCRPT27 EQU   ATCAOSM+336
ATCRPT26 EQU   ATCAOSM+332
ATCRPT25 EQU   ATCAOSM+328
ATCRPT24 EQU   ATCAOSM+324
ATCRPT23 EQU   ATCAOSM+320
ATCRPT22 EQU   ATCAOSM+316
ATCRPT21 EQU   ATCAOSM+312
ATCRPT20 EQU   ATCAOSM+308
ATCRPT19 EQU   ATCAOSM+304
ATCRPT18 EQU   ATCAOSM+300
ATCRPT17 EQU   ATCAOSM+296
ATCRPT16 EQU   ATCAOSM+292
ATCRPT15 EQU   ATCAOSM+288
ATCRPT14 EQU   ATCAOSM+284
ATCRPT13 EQU   ATCAOSM+280
ATCRPT12 EQU   ATCAOSM+276
ATCRPT11 EQU   ATCAOSM+272
ATCAP38  EQU   ATCAOSM+268
ATCAP37  EQU   ATCAOSM+264
ATCZDFJ0 EQU   ATCAOSM+260
ATCAP51  EQU   ATCAOSM+256
ATCZPAB2 EQU   ATCAOSM+224
ATCZPAB1 EQU   ATCAOSM+192
ATCZLFVT EQU   ATCAOSM+188
ATCZLPVT EQU   ATCAOSM+184
ATCZDVTX EQU   ATCAOSM+180
ATCZDVTA EQU   ATCAOSM+176
ATCZDVT9 EQU   ATCAOSM+172
ATCZDVT8 EQU   ATCAOSM+168
ATCZDVT7 EQU   ATCAOSM+164
ATCRSV56 EQU   ATCDAPVT+22
ATCDAPDG EQU   ATCDAPVT+20
ATCDXCEA EQU   ATCDAPVT+16
ATCDCEA  EQU   ATCDAPVT+12
ATCDPCIA EQU   ATCDAPVT+8
ATCDSIOA EQU   ATCDAPVT+4
ATCDEOEA EQU   ATCDAPVT
ATCZLAEA EQU   ATCLDAPP+16
ATCZLCEA EQU   ATCLDAPP+12
ATCRSV17 EQU   ATCLDAPP+8
ATCSMFRR EQU   ATCLDAPP+4
ATCCDTID EQU   ATCLDAPP
ATCZAEA  EQU   ATCICAPP+16
ATCZCEA  EQU   ATCICAPP+12
ATCCDTCB EQU   ATCICAPP+8
ATCZSIOA EQU   ATCICAPP+4
ATCCDRPH EQU   ATCICAPP
ATCAP65  EQU   ATCAOSM+96
ATCZDVT6 EQU   ATCAOSM+92
ATCZDVT4 EQU   ATCAOSM+88
ATCZDVT3 EQU   ATCAOSM+84
ATCZDVT1 EQU   ATCAOSM+80
ATCICNCB EQU   ATCAOSM+76
ATCZPSVT EQU   ATCAOSM+72
ATCZFSVT EQU   ATCAOSM+68
ATCAP64  EQU   ATCAOSM+64
ATCAP63  EQU   ATCAOSM+60
ATCAP61  EQU   ATCAOSM+56
ATCAP58  EQU   ATCAOSM+52
ATCAP57  EQU   ATCAOSM+48
ATCAP54  EQU   ATCAOSM+44
ATCAP53  EQU   ATCAOSM+40
ATCAP52  EQU   ATCAOSM+36
ATCAP34  EQU   ATCAOSM+32
ATCAP32  EQU   ATCAOSM+28
ATCAP31  EQU   ATCAOSM+24
ATCAP12  EQU   ATCAOSM+20
ATCAP11  EQU   ATCAOSM+16
ATCCMTCB EQU   ATCAOSM+12
ATCPRPH  EQU   ATCAOSM+8
ATCGSRBF EQU   ATCGSRBG
ATCSRBRT EQU   ATCAOSM
ATCRSVBB EQU   ISTATCVT+908
ATCVDLOK EQU   ISTATCVT+904
ATCVFPAB EQU   ISTATCVT+872
ATCVDPAB EQU   ISTATCVT+840
ATCIOECB EQU   ISTATCVT+836
ATCINCW3 EQU   ISTATCVT+832
ATCMODTB EQU   ISTATCVT+828
ATCUSSPT EQU   ISTATCVT+824
ATCSRTAB EQU   ISTATCVT+820
@NM00079 EQU   ISTATCVT+819
ATCSTAT2 EQU   ISTATCVT+818
ATCNMCTR EQU   ISTATCVT+816
ATCSEC51 EQU   ATCSECST
ATCSEC40 EQU   ATCSIPD+8
ATCSEC30 EQU   ATCSIPD+4
ATCSEC21 EQU   ATCSIPD
ATCSEC10 EQU   ATCSOPD+4
ATCSEC01 EQU   ATCSOPD
ATCPOIA  EQU   ATCRNO+1
@NM00078 EQU   ATCRNO
ATCPODVT EQU   ISTATCVT+784
ATCS49XL EQU   ISTATCVT+780
ATCS49XI EQU   ISTATCVT+776
ATCLCLCT EQU   ATCVLCNT+2
ATCRNCNT EQU   ATCVLCNT
ATCCFEAD EQU   ISTATCVT+768
ATCPTR00 EQU   ISTATCVT+736
ATCRSV10 EQU   ISTATCVT+704
ATCTACB  EQU   ISTATCVT+700
ATCVTINM EQU   ISTATCVT+696
ATCTCLIM EQU   ISTATCVT+692
ATCTCLOM EQU   ISTATCVT+688
ATCVTIPB EQU   ISTATCVT+656
ATCTCIPB EQU   ISTATCVT+624
ATCTIPAB EQU   ISTATCVT+592
ATCOCCCB EQU   ISTATCVT+588
ATCOCCOB EQU   ISTATCVT+584
ATCCDLAD EQU   ISTATCVT+580
ATCCCLAD EQU   ISTATCVT+576
ATCDLRPB EQU   ISTATCVT+544
ATCPGPAB EQU   ISTATCVT+512
ATCVPAB1 EQU   ISTATCVT+480
ATCRSV97 EQU   ISTATCVT+476
ATCDVTLK EQU   ISTATCVT+456
ATCAP36  EQU   ISTATCVT+452
ATCRSV99 EQU   ISTATCVT+440
ATCONFIG EQU   ISTATCVT+432
ATCNODDS EQU   ISTATCVT+428
ATCNODEL EQU   ISTATCVT+420
ATCRSV69 EQU   ISTATCVT+416
ATCAPCR5 EQU   ISTATCVT+412
ATCLDECB EQU   ISTATCVT+408
ATCLDNCS EQU   ISTATCVT+404
ATCCDPTR EQU   ISTATCVT+400
ATCADEL  EQU   ISTATCVT+396
ATCTODVT EQU   ISTATCVT+392
ATCDEBCH EQU   ISTATCVT+388
ATCHBSIZ EQU   ATCHPGM+2
ATCHBFNO EQU   ATCHPGM
ATCCRME  EQU   ISTATCVT+380
ATCRVCHS EQU   ISTATCVT+372
ATCECTLP EQU   ISTATCVT+368
ATCZDVTB EQU   ISTATCVT+364
ATCECPRT EQU   ISTATCVT+360
ATCVTLOD EQU   ISTATCVT+356
ATCTRPAB EQU   ISTATCVT+352
ATCMSGM  EQU   ISTATCVT+348
ATCMSGP  EQU   ISTATCVT+344
ATCEPT   EQU   ISTATCVT+340
ATCDVT   EQU   ISTATCVT+336
ATCTRCPT EQU   ISTATCVT+332
ATCDVLOD EQU   ISTATCVT+328
ATCALERT EQU   ISTATCVT+324
ATCEPA   EQU   ISTATCVT+320
ATCSAF   EQU   ISTATCVT+318
ATCXRANG EQU   ISTATCVT+317
ATCLAST  EQU   ATCSHRFG
ATCSHRTN EQU   ISTATCVT+308
ATCUEP   EQU   ISTATCVT+304
ATCOCRT  EQU   ISTATCVT+300
ATCCSMA  EQU   ATCCSMR
ATCESC02 EQU   ISTATCVT+292
ATCESC01 EQU   ISTATCVT+288
ATCMNT   EQU   ISTATCVT+272
ATCRSV16 EQU   ISTATCVT+270
ATCMAXID EQU   ISTATCVT+269
ATCMSGSP EQU   ATCCOM+268
ATCACTRM EQU   ATCCOM+264
ATCNERAP EQU   ATCCOM+260
ATCNESAL EQU   ATCCOM+256
ATCRCC65 EQU   ATCCOM+252
ATCRCC26 EQU   ATCCOM+248
ATCRCC63 EQU   ATCCOM+244
ATCRSV11 EQU   ATCCOM+242
ATCVTMID EQU   ATCCOM+240
ATCAPOST EQU   ATCCOM+236
ATCNERFN EQU   ATCCOM+232
ATCNERNE EQU   ATCCOM+228
ATCNERCV EQU   ATCCOM+224
ATCNERST EQU   ATCCOM+220
ATCDCC61 EQU   ATCCOM+216
ATCDCC60 EQU   ATCCOM+212
ATCSRTAD EQU   ATCCOM+204
ATCFIRA  EQU   ATCCOM+200
ATCSMBQ  EQU   ATCCOM+196
ATCSMRC  EQU   ATCCOM+192
ATCSMQU  EQU   ATCCOM+184
ATCSMRQ  EQU   ATCCOM+180
ATCACDA  EQU   ATCCOM+176
ATCSTMA  EQU   ATCCOM+172
ATCFRSTR EQU   ATCCOM+168
ATCREADA EQU   ATCCOM+160
ATCALOAD EQU   ATCCOM+156
ATCBLDLA EQU   ATCCOM+152
ATCFBRPH EQU   ATCCOM+148
ATCBFTRC EQU   ATCCOM+144
ATCTPBUF EQU   ATCTHTRC
ATCREMOV EQU   ATCCOM+136
ATCADD   EQU   ATCCOM+132
ATCDVTPT EQU   ATCCOM+124
ATCFEPT  EQU   ATCCOM+120
ATCFDVT  EQU   ATCCOM+116
ATCCONFT EQU   ATCCOM+112
ATCPTCHA EQU   ATCCOM+108
ATCAUTHA EQU   ATCCOM+104
ATCACCTA EQU   ATCCOM+100
ATCRDTH  EQU   ATCCOM+96
ATCFRSCH EQU   ATCCOM+92
ATCFSB   EQU   ATCCOM+88
ATCHLTMS EQU   ATCCOM+84
ATCECPRM EQU   ATCCOM+80
ATCECNET EQU   ATCCOM+76
ATCECOPC EQU   ATCCOM+72
ATCVPARM EQU   ATCCOM+68
ATCECVRQ EQU   ATCCOM+64
ATCECSES EQU   ATCCOM+60
ATCOCHA  EQU   ATCCOM+56
ATCDSPLQ EQU   ATCCOM+52
ATCECDSP EQU   ATCCOM+48
ATCVARYQ EQU   ATCCOM+44
ATCECVRY EQU   ATCCOM+40
ATCHALTQ EQU   ATCCOM+36
ATCECHLT EQU   ATCCOM+32
ATCMODQ  EQU   ATCCOM+28
ATCECMOD EQU   ATCCOM+24
ATCASCHD EQU   ATCCOM+20
ATCSRT   EQU   ATCCOM+16
ATCRDT   EQU   ATCCOM+12
ATCDCFRR EQU   ATCCOM+8
ATCAPI   EQU   ATCCOM+4
ATCRSV04 EQU   ATCSTAT4
ATCNCSD  EQU   ATCSTAT4
ATCMTST  EQU   ATCSTAT4
ATCTPRT  EQU   ATCSTAT4
ATCPRTAT EQU   ATCSTAT4
@NM00077 EQU   ATCPOFLG
ATCPOUNS EQU   ATCPOFLG
ATCHSDMF EQU   ATCSTFLG
@NM00076 EQU   ATCSTAT1
ATCMDHLT EQU   ATCSTAT1
ATCINHLT EQU   ATCSTAT1
ATCNETSL EQU   ATCSTAT1
ATCQKHLT EQU   ATCSTAT1
ATCSNHLT EQU   ATCSTAT1
ATCACTIV EQU   ATCSTAT1
ATCSTART EQU   ATCSTAT1
DYPPAB   EQU   ISTDYPAB+16
DYPRSV01 EQU   ISTDYPAB+12
DYPTSKID EQU   ISTDYPAB+8
DYPCHAIN EQU   ISTDYPAB+4
DYPFLGS  EQU   ISTDYPAB+2
DYPLNGTH EQU   ISTDYPAB+1
DYPTYPE  EQU   ISTDYPAB
PABRPHA  EQU   PABRPHFG+1
PABNODQ  EQU   PABFLAGS
PABINHBT EQU   PABFLAGS
PABERLOK EQU   PABERRLK
PABSSN   EQU   PABFLAGS
PABDYNAM EQU   PABFLAGS
PABNORPR EQU   PABFLAGS
PABPRIOR EQU   PABFLAGS
PABAPYP  EQU   PABFLAGS
PABDVTA  EQU   ISTPAB+9
PABOFFST EQU   ISTPAB+8
PABCHNGP EQU   PABCHAIN+1
PABRSV02 EQU   PABCHAIN
PABRUNNG EQU   PABCHAIN
PABRESET EQU   PABCHAIN
PABUNCON EQU   PABCHAIN
PABCDP   EQU   PABCHAIN
PABRESCH EQU   PABCHAIN
PABCHNG  EQU   PABCHAIN
PABWEQP  EQU   PABWEQA+1
PABRSV01 EQU   PABWEQA
PABWEQG  EQU   PABWEQA
RPHNEXPO EQU   ISTRPH+104
RPHSAV16 EQU   RPHWORK+60
RPHSAV15 EQU   RPHWORK+56
RPHSAV14 EQU   RPHWORK+52
RPHSAV13 EQU   RPHWORK+48
RPHSAV12 EQU   RPHWORK+44
RPHSAV11 EQU   RPHWORK+40
RPHSAV10 EQU   RPHWORK+36
RPHSAVE9 EQU   RPHWORK+32
RPHSAVE8 EQU   RPHWORK+28
RPHSAVE7 EQU   RPHWORK+24
RPHSAVE6 EQU   RPHWORK+20
RPHSAVE5 EQU   RPHWORK+16
RPHSAVE4 EQU   RPHWORK+12
RPHSAVE3 EQU   RPHWORK+8
RPHSAVE2 EQU   RPHWORK+4
RPHSHALF EQU   RPHSAVE1+2
RPHSBIT8 EQU   RPHSBITS
RPHSBIT7 EQU   RPHSBITS
RPHSBIT6 EQU   RPHSBITS
RPHSBIT5 EQU   RPHSBITS
RPHSBIT4 EQU   RPHSBITS
RPHSBIT3 EQU   RPHSBITS
RPHSBIT2 EQU   RPHSBITS
RPHSBIT1 EQU   RPHSBITS
RPHSBYTE EQU   RPHSAVE1
RPHPABQP EQU   RPHPABQA+1
RPHPABFG EQU   RPHPABQA
RPHSRP34 EQU   RPHSRPRM+2
RPHSRP12 EQU   RPHSRPRM
RPHWEGT  EQU   RPHCSPA
RPHMAJCB EQU   ISTRPH+21
RPHPABOF EQU   ISTRPH+20
RPHRESUM EQU   RPHRESMA+1
RPHRSV01 EQU   RPHWPFLG
RPHPURGE EQU   RPHWPFLG
RPHPT    EQU   RPHWPFLG
RPHWT    EQU   RPHWPFLG
RPHRSKEY EQU   RPHWPFLG
RPHDVTA  EQU   ISTRPH+12
RPHTIK   EQU   RPHTSKID+3
@NM00075 EQU   RPHTSKID
RPHRPHAP EQU   RPHRPHA+1
@NM00074 EQU   RPHRPHA
RPHGATE  EQU   RPHRPHA
@NM00073 EQU   RPHFLGB
RPHRLCRA EQU   RPHFLGB
RPHNRSAV EQU   RPHFLGB
RPHPGCMP EQU   RPHFLGB
RPHFBAPS EQU   RPHFLGB
RPHBSSP  EQU   RPHFLGB
RPHLOCK  EQU   RPHFLGB
RPHFNFLG EQU   RPHFSTLC
RPHMLTCP EQU   RPHFLAGS
RPHSMCLR EQU   RPHFLAGS
RPHSMTYP EQU   RPHFLAGS
RPHSMQ   EQU   RPHFLAGS
RPHAUTEX EQU   RPHAPTYP
RPHSPGIN EQU   RPHFLAGS
RPHOGIND EQU   RPHFLAGS
RPHLNGTH EQU   RPHCNTL+1
RPHTYPE  EQU   RPHCNTL
PATRSV01 EQU   PATFLAGA
PATUSEFG EQU   PATFLAGA
PATRDCNT EQU   ISTPAT+6
PATGRPID EQU   ISTPAT+5
PATPTHID EQU   ISTPAT+4
PATDINDX EQU   ISTPAT+2
PATGINDX EQU   ISTPAT
GNTGRPNM EQU   ISTGNT
DNTTELNO EQU   ISTDNT+1
DNTCTDIG EQU   ISTDNT
RLSRSV02 EQU   ISTRLS+140
RLSRSV01 EQU   ISTRLS+138
RLSCTELU EQU   ISTRLS+136
RLSPRE   EQU   ISTRLS
RDARSVPT EQU   ISTRDA+84
RDAPUBI  EQU   ISTRDA+83
RDADFCUA EQU   ISTRDA+80
RDACTPCC EQU   ISTRDA+79
RDADACUA EQU   ISTRDA+76
RDALUBA  EQU   RDAUCBAD+1
RDACHQI  EQU   RDAUCBAD
RDARSV01 EQU   RDAFLAG
RDARBISA EQU   RDAFLAG
RDAPRE   EQU   ISTRDA
RSWRSV01 EQU   ISTRSW+152
RSWRSV02 EQU   ISTRSW+150
RSWCTELU EQU   ISTRSW+148
RSWGRUPZ EQU   ISTRSW+146
RSWDIALZ EQU   ISTRSW+144
RSWGRUPT EQU   ISTRSW+140
RSWDIALT EQU   ISTRSW+136
RSWPRE   EQU   ISTRSW
RLXRSV03 EQU   ISTRLX+80
RLXRSV02 EQU   ISTRLX+77
RLXRSV01 EQU   RLXFLAGA
RLXINUSE EQU   RLXFLAGA
RLXNLUX  EQU   ISTRLX+72
RLXPRE   EQU   ISTRLX
RPXRSV01 EQU   ISTRPX+80
RPXRSV02 EQU   ISTRPX+77
RPXMAXLU EQU   ISTRPX+76
RPXFLUX  EQU   ISTRPX+72
RPXPRE   EQU   ISTRPX
RLURSV02 EQU   ISTRLU+172
RLULGMOD EQU   ISTRLU+164
RLUMODEP EQU   RLUMODET+8
RLUMODEN EQU   RLUMODET
RLUUSSPT EQU   RLUUSSTB+8
RLUUSSNM EQU   RLUUSSTB
RLURSV01 EQU   ISTRLU+137
RLULOCAD EQU   ISTRLU+136
RLUNCPPM EQU   RLUNCPPC+1
RLUNCPPN EQU   RLUNCPPC
RLUPACEM EQU   RLUPACE+1
RLUPACEN EQU   RLUPACE
RLUINTA  EQU   ISTRLU+128
RLUSSCFM EQU   ISTRLU+127
RLUCRRSV EQU   RLUCRFLG
RLUACTLU EQU   RLUCRFLG
RLURSV00 EQU   RLUFLAG
RLUGSTAT EQU   RLUFLAG
RLUBATCH EQU   RLUFLAG
RLURBISA EQU   RLUFLAG
RLUTYPE  EQU   ISTRLU+124
RLUCRPR  EQU   ISTRLU
RCCRVPT2 EQU   ISTRCC+144
RCCXTOSW EQU   ISTRCC+140
RCCSWTOX EQU   ISTRCC+136
RCCRSPT2 EQU   ISTRCC+133
RCCADDR  EQU   ISTRCC+132
RCCPASSL EQU   ISTRCC+131
RCCMXOUT EQU   ISTRCC+130
RCCMXDAT EQU   ISTRCC+128
RCCINDEX EQU   ISTRCC+126
RCCPATHZ EQU   ISTRCC+124
RCCPATHT EQU   ISTRCC+120
RCCDPQ   EQU   ISTRCC+116
RCCTPAB  EQU   ISTRCC+112
RCCRSV02 EQU   ISTRCC+109
RCCCRRSV EQU   RCCCRFLG
RCCCTCFL EQU   RCCCRFLG
RCCACTPU EQU   RCCCRFLG
RCCNCSPL EQU   ISTRCC+104
RCCRPHCN EQU   ISTRCC+100
RCCEPAB  EQU   ISTRCC+96
RCCDPAB  EQU   ISTRCC+92
RCCVPAB  EQU   ISTRCC+88
@NM00072 EQU   ISTRCC+87
RCCSESCT EQU   ISTRCC+86
RCCIDNUM EQU   RCCID48+3
RCCIDBLK EQU   RCCID48+2
RCCIDPA2 EQU   RCCID48+1
RCCIDPUT EQU   RCCID48
RCCIDPA1 EQU   RCCSTAID
RCCCTELU EQU   ISTRCC+76
RCCCNCNT EQU   ISTRCC+75
RCCRTGOH EQU   RCCFLAGB
RCCBRKCN EQU   RCCFLAGB
RCCRESET EQU   RCCFLAGB
RCCFINAL EQU   RCCFLAGB
RCCBNNSP EQU   RCCFLAGB
RCCIRETR EQU   RCCFLAGB
RCCDIALP EQU   RCCFLAGB
RCCDSTCT EQU   RCCFLAGB
RCCCTPGD EQU   RCCFLAG
RCCPRGDN EQU   RCCFLAG
RCCOUERP EQU   RCCFLAG
RCCOHIMM EQU   RCCFLAG
RCCLDISC EQU   RCCFLAG
RCCERPIP EQU   RCCFLAG
RCCCUDIE EQU   RCCFLAG
RCCRBISA EQU   RCCFLAG
RCCTYPE  EQU   ISTRCC+72
RCCPRE   EQU   ISTRCC
DOTADTRM EQU   ISTDOT
RDSADDOT EQU   ISTRDS+76
RDSCTATR EQU   ISTRDS+74
RDSCTTRM EQU   ISTRDS+72
RDSPRE   EQU   ISTRDS
RINRSV05 EQU   ISTRIN+156
RINRSV04 EQU   ISTRIN+152
RINLOCRN EQU   ISTRIN+148
RINRSV02 EQU   ISTRIN+145
RTRCNCNT EQU   RINCNCNT
RTRNCSPL EQU   RINNCSPL
RTRRPHCN EQU   RINRPHCN
RTRVPAB  EQU   RINVPAB
RTRREMOT EQU   RINREMOT
RTRRLDAF EQU   RINRLDAF
RTRNODID EQU   RINNODID
RINRSV01 EQU   RINDFD
RTRLDISC EQU   RINLDISC
RTRNODEF EQU   RINNODEF
RTRREMPO EQU   RINREMPO
RINCRPRE EQU   ISTRIN
RTRRSV04 EQU   ISTRTR+210
RTRLCTI  EQU   ISTRTR+209
RTRIDCAS EQU   RTRBSCID+1
RTRIDLEN EQU   RTRBSCID
RTRRSVDD EQU   ISTRTR+181
RTRRDFG  EQU   ISTRTR+180
RTRDIAA  EQU   ISTRTR+176
RTRPOLA  EQU   ISTRTR+172
RTRCADDR EQU   ISTRTR+164
RTRCTADR EQU   ISTRTR+162
RTRCTPOL EQU   ISTRTR+160
RTRCTDIA EQU   ISTRTR+158
RTRRSV03 EQU   ISTRTR+156
RTRRVPT1 EQU   ISTRTR+152
RTRBHSN1 EQU   ISTRTR+144
RTRCRSV2 EQU   RTRCRFLG
RTRDTRLM EQU   RTRLSCMD
RTRCRSV1 EQU   RTRCRFLG
RTRTRMAX EQU   ISTRTR+142
RTRRSV24 EQU   RTRRDFF
RTRRFDEK EQU   RTRRDFF
RTRRFANK EQU   RTRRDFF
RTRRFPFK EQU   RTRRDFF
RTRRFPEN EQU   RTRRDFF
RTRRFXCT EQU   RTRRDFF
RTRRESCT EQU   RTRRDFE
RTRRESUP EQU   RTRRDFE
RTRREATT EQU   RTRRDFE
RTRRECHK EQU   RTRRDFE
RTRREACR EQU   RTRRDFE
RTRRSV0A EQU   RTRRDFE
RTRREBRK EQU   RTRRDFE
RTRRSV11 EQU   RTRRDFD
RTRRSV10 EQU   RTRRDFD
RTRRDBHI EQU   RTRRDFD
RTRRDBHD EQU   RTRRDFD
RTRRDBHN EQU   RTRRDFD
RTRRSV23 EQU   RTRRDFC
RTRRCXMS EQU   RTRRDFC
RTRRCMSG EQU   RTRRDFC
RTRRCBLK EQU   RTRRDFC
RTRRCPT3 EQU   RTRRDFC
RTRRCIT2 EQU   RTRRDFC
RTRRCIT1 EQU   RTRRDFC
RTRRSV32 EQU   RTRRDFB
RTRRBEND EQU   RTRRDFB
RTRRBECT EQU   RTRRDFB
RTRRSV02 EQU   RTRRDFA
RTRRACTR EQU   RTRRDFA
RTRRSV60 EQU   RTRRDFA
RTRRACDT EQU   RTRRDFA
RTRRAPT3 EQU   RTRRAALL
RTRRAPT2 EQU   RTRRAALL
RTRRAPT1 EQU   RTRRAALL
RTRRAATN EQU   RTRRDFA
RTRRSV45 EQU   ISTRTR+132
RTRRSV01 EQU   ISTRTR+130
RTRCTECM EQU   ISTRTR+128
RTRADRPT EQU   RTRADR+1
RTRRSV22 EQU   RTRFLAG
RTRVTERM EQU   RTRFLAG
RTRRSV51 EQU   RTRFLAG
RTRRBISA EQU   RTRFLAG
RTRRSV21 EQU   RTRFLAG
RTRCRPR  EQU   ISTRTR
RCLRVPT2 EQU   ISTRCL+92
RCLRVPT1 EQU   ISTRCL+88
RCLGPOLA EQU   ISTRCL+84
RCLCTNGP EQU   ISTRCL+82
RCLRSV01 EQU   ISTRCL+80
RCLCTECM EQU   ISTRCL+78
RCLCTETR EQU   ISTRCL+76
RCLGPADR EQU   RCLADR+1
RCLRSV33 EQU   RCLFLAG
RCLBATCH EQU   RCLFLAG
RCLRBISA EQU   RCLFLAG
RCLRSV22 EQU   RCLFLAG
RCLPRE   EQU   ISTRCL
RPTRSV03 EQU   ISTRPT+156
RPTRSV02 EQU   ISTRPT+152
RPTNSNSV EQU   ISTRPT+148
RPTPTHCT EQU   ISTRPT+146
RPTPEPCT EQU   ISTRPT+144
RPTDAFSV EQU   ISTRPT+142
RPTRSV01 EQU   ISTRPT+141
RPTISTAT EQU   RPTFLAG1
RPTDYNAM EQU   RPTFLAG1
RPTVYIMM EQU   RPTFLAG1
RPTVIODN EQU   RPTFLAG1
RPTONLIN EQU   RPTFLAG1
RPTHLVPD EQU   RPTFLAG1
RPTVRYPD EQU   RPTFLAG1
RPTASLEP EQU   RPTFLAG1
RPTUTERM EQU   ISTRPT+136
RPTATERM EQU   ISTRPT+132
RPTDIVT  EQU   RPTDITT
RPTCTNM  EQU   ISTRPT+120
RPTLNDAF EQU   RPTLNCID+2
RPTLNSAF EQU   RPTLNCID
RPTLN    EQU   ISTRPT
RLNRVPT2 EQU   ISTRLN+112
RLNNCSPL EQU   ISTRLN+108
RLNX2SW  EQU   ISTRLN+104
@NM00071 EQU   ISTRLN+103
RLNCRRSV EQU   RLNCRFLG
RLNSWEP  EQU   RLNCRFLG
RLNSVSKP EQU   RLNLSCMD
RLNSESLM EQU   RLNLSCMD
RLNNPRLM EQU   RLNLSCMD
RLNSWNCP EQU   RLNCRFLG
RLNACTLN EQU   RLNCRFLG
RLNPAUSE EQU   ISTRLN+101
RLNPOLMT EQU   ISTRLN+100
RLNACTSN EQU   ISTRLN+98
RLNRESV1 EQU   ISTRLN+97
RLNACTRM EQU   ISTRLN+96
RLNCTSES EQU   ISTRLN+95
RLNRDSLM EQU   ISTRLN+94
RLNAUTOA EQU   ISTRLN+92
RLNRDFD  EQU   RLNRDF+3
RLNRDFC  EQU   RLNRDF+2
RLNMULTP EQU   RLNRDFB
RLNRATRN EQU   RLNRDFB
RLNRAPOL EQU   RLNRDFB
RLNTTV   EQU   RLNRDFB
RLNRSV0B EQU   RLNRDFB
RLNAUTOD EQU   RLNRDFB
RLNANSWR EQU   RLNRDFB
RLNRBUSE EQU   RLNRDFB
RLNRAPEP EQU   RLNRDFA
RLNRANCP EQU   RLNRDFA
RLNRAEP  EQU   RLNRDFA
RLNIDV   EQU   RLNRDFA
RLNPORT  EQU   RLNRDFA
RLNGANSW EQU   RLNRDFA
RLNRACAN EQU   RLNRACNT
RLNRACAT EQU   RLNRACNT
RLNRSV04 EQU   RLNSTAT2
RLNINUSE EQU   RLNSTAT2
RLNOHIN  EQU   RLNSTAT2
RLNRSV03 EQU   RLNSTAT1
RLNVD    EQU   RLNSTAT1
RLNINOPP EQU   RLNSTAT1
RLNINOPL EQU   RLNSTAT1
RLNLRST  EQU   RLNSTAT1
RLNTRAP  EQU   RLNSTAT1
RLNACTCT EQU   ISTRLN+84
RLNCTECM EQU   ISTRLN+82
RLNCTEIN EQU   ISTRLN+80
RLNCTETR EQU   ISTRLN+78
RLNCTECL EQU   ISTRLN+76
RLNCUA   EQU   RLNUCBAD
RLNRSV01 EQU   RLNFLAG
RLNRBISA EQU   RLNFLAG
RLNEAM   EQU   RLNFLAG
RLNPRE   EQU   ISTRLN
RGPRVPT2 EQU   ISTRGP+88
RGPRVPT1 EQU   ISTRGP+84
RGPCTECM EQU   ISTRGP+82
RGPCTEIN EQU   ISTRGP+80
RGPCTETR EQU   ISTRGP+78
RGPCTECL EQU   ISTRGP+76
RGPCTELN EQU   ISTRGP+74
RGPRSV03 EQU   ISTRGP+73
RGPRSV02 EQU   RGPFLG
RGPASDLC EQU   RGPFLG
RGPABSC  EQU   RGPFLG
RGPASS   EQU   RGPFLG
RGPADIL  EQU   RGPFLG
RGPPRE   EQU   ISTRGP
RRNRINNM EQU   ISTRRN+248
@NM00070 EQU   ISTRRN+247
RRNRDCUA EQU   ISTRRN+244
RRNLASTE EQU   ISTRRN+240
RRNNCSPL EQU   ISTRRN+236
RRNRPLPT EQU   ISTRRN+232
RRNMSIZE EQU   ISTRRN+228
RRNNCPNM EQU   ISTRRN+221
RRNCTPCC EQU   ISTRRN+220
RRNHBUFS EQU   ISTRRN+218
RRNHLENT EQU   RRNHPRE+1
RRNHLENH EQU   RRNHPRE
RRNNMNCP EQU   ISTRRN+208
RRNDELAY EQU   ISTRRN+206
RRNRSV04 EQU   ISTRRN+200
RRNRSV88 EQU   RRNNMDPD+7
RRNPUBI  EQU   RRNNMDPD+6
RRNDPLUB EQU   RRNNMDPD
RRNEPADR EQU   ISTRRN+190
RRNCPLUB EQU   ISTRRN+184
RRNFLUX  EQU   ISTRRN+180
RRNRSV05 EQU   RRNCMFD
RRNREMPO EQU   RRNCMFD
RRNCDREC EQU   RRNCMFD
RRNCDDSI EQU   RRNCMFD
RRNCDBCK EQU   RRNCMFD
RRNCDDTL EQU   RRNCMFD
RRNCDSTD EQU   RRNCMFD
RRNCDCSP EQU   RRNCMFD
RRNCCCSL EQU   RRNCMFC
RRNCCSIM EQU   RRNCMFC
RRNCCRCM EQU   RRNCMFC
RRNCCRIM EQU   RRNCMFC
RRNCCCRC EQU   RRNCMFC
RRNCCRST EQU   RRNCMFC
RRNCCRDQ EQU   RRNCMFC
RRNCCRCN EQU   RRNCMFC
RRNCBALT EQU   RRNCMFB
RRNCBMOD EQU   RRNCMFB
RRNCBNPL EQU   RRNCMFB
RRNCBRLS EQU   RRNCMFB
RRNCBRDS EQU   RRNCMFB
RRNCBDLR EQU   RRNCMFB
RRNCBDLH EQU   RRNCMFB
RRNCBDLO EQU   RRNCMFB
RRNCADGO EQU   RRNCMFA
RRNCADTD EQU   RRNCMFA
RRNCACDT EQU   RRNCMFA
RRNCAMBH EQU   RRNCMFA
RRNCAATI EQU   RRNCMFA
RRNCAATG EQU   RRNCMFA
RRNCAATD EQU   RRNCMFA
RRNCAALL EQU   RRNCMFA
RRNRSV55 EQU   RRNRDF+3
RRNPTASL EQU   RRNRDFB+1
RRNRSV01 EQU   RRNRDFB+1
RRNVYDON EQU   RRNRDFB+1
RRNRBBUP EQU   RRNRDFB+1
RRNRSV03 EQU   RRNRDFB
RRNRBCT2 EQU   RRNRDFB
RRNRBCT1 EQU   RRNRDFB
RRNRBSEC EQU   RRNRDFB
RRNRBCCT EQU   RRNRDFB
RRNRBCCL EQU   RRNRDFB
RRNRSV02 EQU   RRNRDFB
RRNRBMDL EQU   RRNRDFB
RRNRAPEP EQU   RRNRDFA
RRNRANCP EQU   RRNRDFA
RRNRBREM EQU   RRNRDFA
RRNRAOLT EQU   RRNRDFA
RRNRASYN EQU   RRNRDFA
RRNRADMP EQU   RRNRDFA
RRNRAIPL EQU   RRNRDFA
RRNRASHT EQU   RRNRDFA
RRNCTENT EQU   ISTRRN+170
RRNCTECM EQU   ISTRRN+168
RRNCTEIN EQU   ISTRRN+166
RRNCTETR EQU   ISTRRN+164
RRNCTECL EQU   ISTRRN+162
RRNCTELI EQU   ISTRRN+160
RRNCTEGP EQU   ISTRRN+158
RRNCTBHS EQU   ISTRRN+156
RRNBHSET EQU   ISTRRN+152
RRNTRENT EQU   ISTRRN+148
RRNRSV22 EQU   ISTRRN+147
RRNRNCUA EQU   ISTRRN+144
RRNGRPA  EQU   ISTRRN+140
RRNLUBA  EQU   RRNUCBAD+1
RRNCHQI  EQU   RRNUCBAD
RRNRSV11 EQU   RRNFLAG
RRNDSTCT EQU   RRNFLAG
RRNERPIP EQU   RRNFLAG
RRNLCDIP EQU   RRNFLAG
RRNLCDIE EQU   RRNFLAG
RRNLCSIP EQU   RRNFLAG
RRNRBISA EQU   RRNFLAG
RRNRSV89 EQU   RRNFLAG
RRNPRE   EQU   ISTRRN
RLCRVPT2 EQU   ISTRLC+80
RLCRVPT1 EQU   ISTRLC+79
RLCLCCUA EQU   ISTRLC+76
RLCUCBAD EQU   RLCADR+1
RLCRSVDE EQU   RLCFLAG
RLCACNT  EQU   RLCFLAG
RLCRSV14 EQU   RLCFLAG
RLCRBISA EQU   RLCFLAG
RLCRSV22 EQU   RLCFLAG
RLCPRE   EQU   ISTRLC
RAPRVPT2 EQU   ISTRAP+116
RAPRVPT1 EQU   ISTRAP+112
RAPBFACT EQU   ISTRAP+111
RAPRSV17 EQU   RAPFLGC
RAPRSV16 EQU   RAPFLGC
RAPRSV15 EQU   RAPFLGC
RAPRSV14 EQU   RAPFLGC
RAPRSV13 EQU   RAPFLGC
RAPRSV12 EQU   RAPFLGC
RAPRSV11 EQU   RAPFLGC
RAPRSV10 EQU   RAPFLGC
RAPRSV09 EQU   RAPFLGB
RAPASPO  EQU   RAPFLGB
RAPAPPO  EQU   RAPFLGB
RAPAACQ  EQU   RAPFLGB
RAPAPRMT EQU   RAPFLGB
RAPAPASS EQU   RAPFLGB
RAPABLCK EQU   RAPFLGB
RAPALLF  EQU   RAPFLGB
RAPRSV06 EQU   RAPFLG
RAPRSV05 EQU   RAPFLG
RAPRSV04 EQU   RAPFLG
RAPRSV03 EQU   RAPFLG
RAPATLGN EQU   RAPFLG
RAPASLGI EQU   RAPFLG
RAPAQUI  EQU   RAPFLG
RAPABLGN EQU   RAPFLG
RAPACEQD EQU   ISTRAP+106
RAPTRPRE EQU   ISTRAP+104
RAPACEAP EQU   ISTRAP+100
RAPICEAQ EQU   ISTRAP+96
RAPICEAC EQU   ISTRAP+92
RAPICELG EQU   ISTRAP+88
RAPAPPWD EQU   ISTRAP+80
RAPACDEB EQU   ISTRAP+76
RAPACBA  EQU   ISTRAP+72
RAPPRE   EQU   ISTRAP
RDTVSRPL EQU   ISTRDT+132
RDTCRSPW EQU   ISTRDT+124
RDTCRSDS EQU   ISTRDT+116
@NM00069 EQU   ISTRDT+113
RRNSTCNT EQU   RDTSTCNT
RRNVYRPH EQU   RDTVYRPH
RDTTPAB  EQU   ISTRDT+104
RDTDPAB  EQU   ISTRDT+100
RDTEPAB  EQU   ISTRDT+96
RDTVPAB  EQU   ISTRDT+92
RDTRSV01 EQU   RDTFLAGB
RDTBHSET EQU   RDTFLAGB
RDTCTCFL EQU   RDTFLAGB
RDTCTPGD EQU   RDTFLAGB
RDTPRGDN EQU   RDTFLAGB
RDTOUERP EQU   RDTFLAGB
RDTLGCT  EQU   ISTRDT+90
RDTNODID EQU   ISTRDT+89
RDTMAXID EQU   ISTRDT+88
RDTCTSNT EQU   ISTRDT+86
RDTFLAGS EQU   ISTRDT+84
RDTBACK  EQU   ISTRDT+80
RDTFORW  EQU   ISTRDT+76
RDTLEN   EQU   RDTPLEN+1
RDTPRILS EQU   RDTPRIOR
RDTPRISW EQU   RDTPRIOR
RDTPRIRN EQU   RDTPRIOR
RDTPRILC EQU   RDTPRIOR
RDTPRIAP EQU   RDTPRIOR
@NM00068 EQU   RDTPRIOR
RDTPRE   EQU   ISTRDT
RCPRSV05 EQU   ISTRCPRE+120
RCPRSV04 EQU   ISTRCPRE+116
RCPRSV03 EQU   ISTRCPRE+112
RCPINTA  EQU   RCPLGNIN+16
RCPLGNCT EQU   RCPLGNIN+8
RCPLGNAP EQU   RCPLGNIN
@NM00067 EQU   RCPPMODE
RCPRRECD EQU   RCPPMODE
RCPRBASC EQU   RCPPMODE
RCPBFLIM EQU   ISTRCPRE+90
RCPBHSI2 EQU   ISTRCPRE+89
RCPBHSI1 EQU   ISTRCPRE+88
RCPICEAQ EQU   ISTRCPRE+80
RCPLNAPA EQU   ISTRCPRE+76
RCPICELN EQU   ISTRCPRE+72
RCPPRE   EQU   ISTRCPRE
RPRCONID EQU   ISTRPRE+63
RPRCLVPD EQU   RPRFLAGC
RPRINIMM EQU   RPRFLAGD
RPRRSV05 EQU   RPRFLAGD
RPRCONP  EQU   RPRFLAGD
RPRACTP  EQU   RPRFLAGD
RPRRSON  EQU   RPRFLAGD
RPRCONCT EQU   RPRFLAGD
RPRLTASN EQU   RPRFLAGD
RPRPTHCT EQU   ISTRPRE+60
RPRSWDAF EQU   ISTRPRE+58
RPRSTPCT EQU   ISTRPRE+56
RPRRVPT1 EQU   ISTRPRE+52
RPRDEVCH EQU   ISTRPRE+44
RPRNCBA  EQU   ISTRPRE+40
RPRNSNEA EQU   ISTRPRE+36
RPRLGONB EQU   ISTRPRE+32
RPRLGONF EQU   ISTRPRE+28
RPRHDTYP EQU   ISTRPRE+27
RPRTIOCT EQU   ISTRPRE+26
RPRPEPCT EQU   ISTRPRE+24
RPRRSV03 EQU   RPRCAUSE
RPRRSYNC EQU   RPRCAUSE
RPRCRCPT EQU   RPRCAUSE
RPRNOSRT EQU   RPRCAUSE
RPRINTST EQU   RPRFLAGB
RPRVYIMM EQU   RPRFLAGB
RPRHLVPD EQU   RPRFLAGB
RPRONLIN EQU   RPRFLAGB
RPRVIODN EQU   RPRFLAGB
RPRAOPN  EQU   RPRFLAGB
RPRENTVT EQU   RPRFLAGB
RPRENTVH EQU   RPRFLAGB
RPRLIVE  EQU   RPRFLAGA
RPRVRYPD EQU   RPRFLAGA
RPRENTED EQU   RPRFLAGA
RPRENTIO EQU   RPRFLAGA
RPRENTBF EQU   RPRFLAGA
RPRTIED  EQU   RPRFLAGA
RPRINV   EQU   RPRFLAGA
RPRACT   EQU   RPRFLAGA
RPRENTRY EQU   ISTRPRE+20
RPRPELEN EQU   ISTRPRE+18
RPRELEN  EQU   ISTRPRE+16
RPRRLOCK EQU   ISTRPRE+12
RPRDAF   EQU   RPRCOMID+2
RPRSAF   EQU   RPRCOMID
RPRNAME  EQU   ISTRPRE
LOKXCL   EQU   @NM00065
LOKPRY   EQU   @NM00065
@NM00066 EQU   @NM00065
@NM00064 EQU   LOKCHNG
LOKCT    EQU   ISTLOK
OCWEND   EQU   ISTOCW+848
@NM00063 EQU   OCWFLG1
OCWEXIT  EQU   OCWFLG1
OCWBNDSZ EQU   ISTOCW+841
OCWBINDD EQU   OCWBIND+37
OCWBINDA EQU   OCWBIND+1
OCWBINDC EQU   OCWBIND
OCWSHPLC EQU   OCWSHPL+8
OCWSHPLB EQU   OCWSHPL+4
OCWSHPLA EQU   OCWSHPL
OCWBNDRU EQU   ISTOCW+780
OCWELCP  EQU   ISTOCW+776
OCWRSV12 EQU   ISTOCW+772
OCWRSV11 EQU   ISTOCW+768
OCWRSV10 EQU   ISTOCW+764
OCWRSV09 EQU   ISTOCW+760
OCWPROCD EQU   ISTOCW+756
OCWCCRPH EQU   ISTOCW+752
OCWPABCT EQU   ISTOCW+748
OCWDAF   EQU   OCWCID+2
OCWSAF   EQU   OCWCID
OCWNMLLN EQU   ISTOCW+742
OCWRSV0A EQU   ISTOCW+741
OCWRSV82 EQU   OCWLOCKS
OCWALOCK EQU   OCWLOCKS
OCWDLOCK EQU   OCWLOCKS
OCWELOCK EQU   OCWLOCKS
OCWACE   EQU   ISTOCW+736
OCWIOMIN EQU   ISTOCW+735
OCWIOMAJ EQU   ISTOCW+734
OCWBHSID EQU   ISTOCW+733
OCWRSV03 EQU   ISTOCW+732
OCWSWTE7 EQU   OCWSWTE
OCWSWTE6 EQU   OCWSWTE
OCWSWTE5 EQU   OCWSWTE
OCWSWTE4 EQU   OCWSWTE
OCWSWTE3 EQU   OCWSWTE
OCWSWTE2 EQU   OCWSWTE
OCWLCPBC EQU   OCWSWTE
OCWSKEL  EQU   OCWSWTE
OCWSWTR7 EQU   OCWSWTRD
OCWSWTR6 EQU   OCWSWTRD
OCWSWTR5 EQU   OCWSWTRD
OCWDPDVT EQU   OCWSWTRD
OCWEPTLP EQU   OCWSWTRD
OCWCPARE EQU   OCWSWTRD
OCWCLEN  EQU   OCWSWTRD
OCWSRDVT EQU   OCWSWTRD
OCWCLCD2 EQU   ISTOCW+728
OCWCLCD1 EQU   ISTOCW+726
OCWSDVTA EQU   ISTOCW+720
OCWSORTP EQU   ISTOCW+712
OCWMDVT  EQU   ISTOCW+708
OCWSDVT  EQU   ISTOCW+704
OCWPREV  EQU   ISTOCW+700
OCWLCPBA EQU   ISTOCW+696
OCWSAVE5 EQU   ISTOCW+552
OCWSAVE4 EQU   ISTOCW+480
OCWSAVE3 EQU   ISTOCW+408
OCWSAVE2 EQU   ISTOCW+336
OCWSAVE1 EQU   ISTOCW+264
OCWRSVD  EQU   ISTOCW+212
OCWVPAB  EQU   ISTOCW+208
OCWSWTD7 EQU   OCWSWTD
OCWSWTD6 EQU   OCWSWTD
OCWSWTD5 EQU   OCWSWTD
OCWSWTD4 EQU   OCWSWTD
OCWPGDON EQU   OCWSWTD
OCWSTCTL EQU   OCWSWTD
OCWNPOST EQU   OCWSWTD
OCWCLDEB EQU   OCWSWTD
OCWVARY  EQU   OCWSWTC
OCWPRMTR EQU   OCWSWTC
OCWPBH   EQU   OCWSWTC
OCWRBH   EQU   OCWSWTC
OCWCKACE EQU   OCWSWTC
OCWSWTC1 EQU   OCWSWTC
OCWCSCAL EQU   OCWSWTB
OCWPSREQ EQU   OCWSWTB
OCWOLOCK EQU   OCWSWTB
OCWCOREQ EQU   OCWSWTB
OCWDOPHY EQU   OCWSWTB
OCWCLOOP EQU   OCWSWTB
OCWRECL  EQU   OCWSWTB
OCWGOFUN EQU   OCWSWTB
OCWNODLT EQU   OCWSWTA
OCWODCL  EQU   OCWSWTA
OCWGODST EQU   OCWSWTA
OCWSORT  EQU   OCWSWTA
OCWGOCNT EQU   OCWSWTA
OCWSRT   EQU   OCWSWTA
OCWSCPAD EQU   ISTOCW+176
OCWODCT2 EQU   ISTOCW+106
OCWRSV02 EQU   ISTOCW+100
OCWRSV01 EQU   ISTOCW+96
OCWODFST EQU   ISTOCW+88
OCWLPOST EQU   ISTOCW+76
OCWCPOST EQU   ISTOCW+72
OCWFPOST EQU   ISTOCW+68
OCWNCB   EQU   ISTOCW+60
OCWEPTAB EQU   ISTOCW+52
OCWARDTE EQU   ISTOCW+48
OCWDRHOB EQU   OCWDRDTE
OCWPAB   EQU   ISTOCW+20
OCWRPH   EQU   ISTOCW+16
OCWCHAIN EQU   ISTOCW+8
OCWPBCHN EQU   ISTOCW+4
OCWTLEN  EQU   ISTOCW+2
OCWSLEN  EQU   ISTOCW+1
OCWID    EQU   ISTOCW
NIBRESV  EQU   ISTNIB+60
NIBNDAR  EQU   ISTNIB+56
NIBLMODE EQU   ISTNIB+48
NIBEXLST EQU   ISTNIB+44
NIBLIMIT EQU   ISTNIB+42
@NM00062 EQU   ISTNIB+41
@NM00061 EQU   NIBFLG1
@NM00060 EQU   NIBFLG1
@NM00059 EQU   NIBFLG1
@NM00058 EQU   NIBFLG1
NIBSHLTP EQU   NIBFLG1
NIBSDAPP EQU   NIBFLG1
NIBLAST  EQU   NIBFLG1
NIBPROCD EQU   ISTNIB+36
NIBDEVCH EQU   ISTNIB+28
NIBMODE  EQU   ISTNIB+20
NIBUSER  EQU   ISTNIB+8
NIBLEN   EQU   ISTNIB+3
NIBCONDN EQU   ISTNIB+2
NIBRSV01 EQU   ISTNIB+1
NIBID    EQU   ISTNIB
DEVRSV03 EQU   ISTDEVCH+5
DEVPHYSA EQU   ISTDEVCH+4
DEVCSLPN EQU   DEVCHAR3
DEVCSTCL EQU   DEVCHAR3
DEVCCHEK EQU   DEVCHAR3
DEVCATTN EQU   DEVCHAR3
DEVCSWL  EQU   DEVFCCTL
DEVCRVB  EQU   DEVFCCTL
DEVCSSL  EQU   DEVFCCTL
DEVCBSC  EQU   DEVFCCTL
DEVMCODE EQU   ISTDEVCH+2
DEVCHAR2 EQU   DEVTCODE
DEVRSV01 EQU   DEVCHAR
DEVCCTL  EQU   DEVCHAR
DEVNNSPT EQU   DEVCHAR
DEVSPS   EQU   DEVCHAR
DEVSUBND EQU   DEVCHAR
DEVCONVR EQU   DEVCHAR
DEVOTPUT EQU   DEVCHAR
DEVINPUT EQU   DEVCHAR
PROSRDEF EQU   PROSETM4
PRORSV47 EQU   PROSETM4
PROSCON  EQU   PROSETM4
PRORSV46 EQU   PROSETM3
PROSMONT EQU   PROSETM3
PRORSV45 EQU   PROSETM3
PROSNTO  EQU   PROSETM3
PRORSV44 EQU   PROSETM3
PRORSV43 EQU   PROSETM2
PROSNTFL EQU   PROSETM2
PRORSV42 EQU   PROSETM2
PRORSV41 EQU   PROPROCS
PROMODC  EQU   PROPROC4
PROMODT  EQU   PROPROC4
PROMODM  EQU   PROPROC4
PROMODB  EQU   PROPROC4
PRORSV14 EQU   PROPROC4
PRORSV13 EQU   PROPROC4
PRORSV12 EQU   PROPROC4
PROEIB   EQU   PROPROC4
PRORSV11 EQU   PROPROC3
PROMONT2 EQU   PROPROC3
PROMONIT EQU   PROPROC3
PROSUBLK EQU   PROPROC3
PRONTO   EQU   PROPROC3
PROLGIN  EQU   PROPROC3
PROERPI  EQU   PROPROC3
PRORSV07 EQU   PROPROC3
PROCFTX  EQU   PROPROC2
PROEMLC  EQU   PROPROC2
PRONTFL  EQU   PROPROC2
PRORSV05 EQU   PROPROC2
PRORSV04 EQU   PROPROC2
PROLGOT  EQU   PROPROC2
PROERPO  EQU   PROPROC2
PRORSV03 EQU   PROPROC2
PRORPLC  EQU   PROPROC1
PROCS    EQU   PROPROC1
PROCA    EQU   PROPROC1
PRORESPX EQU   PROPROC1
PRODFASY EQU   PROPROC1
PROXPOPT EQU   PROPROC1
PROTRUNC EQU   PROPROC1
PROASYIP EQU   PROPROC1
CSPUNUSD EQU   CSPRSC2B+4
CSPUECBA EQU   CSPRSC2B
CSPTRDTE EQU   ISTCSP+28
CSPRLRPH EQU   ISTCSP+24
CSPNO    EQU   ISTCSP+22
CSPCC    EQU   ISTCSP+20
CSPDATA  EQU   ISTCSP+16
CSPRSCE  EQU   ISTCSP+12
CSPDEST  EQU   ISTCSP+8
CSPSRC   EQU   ISTCSP+4
@NM00057 EQU   CSPOPT2
CSPRSC2F EQU   CSPOPT2
CSPWASQD EQU   CSPOPT2
CSPACQS  EQU   CSPOPT2
CSPACES  EQU   CSPOPT2
CSPNOREL EQU   CSPOPT2
CSPCOREQ EQU   CSPOPT2
CSPSTAP  EQU   CSPOPT2
@NM00056 EQU   CSPOPT1
CSPANY   EQU   CSPOPT1
CSPACT   EQU   CSPOPT1
CSPSESS  EQU   CSPOPT1
CSPPND   EQU   CSPOPT1
CSPLOGI  EQU   CSPOPT1
CSPQ     EQU   CSPOPT1
CSPRSC   EQU   CSPOPT1
CSPIDX   EQU   ISTCSP
@NM00055 EQU   ACEFLAGS
ACETAKER EQU   ACEFLAGS
ACEPREMR EQU   ACEFLAGS
ACETAKEN EQU   ACEFLAGS
ACEPREMD EQU   ACEFLAGS
ACESUBJQ EQU   ISTACE+8
ACEOBJ   EQU   ISTACE+4
ACESUBJ  EQU   ISTACE
ICERSC2B EQU   ISTICE+36
ICEUECBX EQU   ISTICE+32
@NM00054 EQU   ISTICE+29
@NM00053 EQU   ICEFLAGS
ICESTAPR EQU   ICEFLAGS
ICERSC2F EQU   ICEFLAGS
ICELGON  EQU   ICEFLAGS
ICEICX   EQU   ICEFLAGS
ICESPEC  EQU   ICEFLAGS
ICERPHA  EQU   ISTICE+24
ICEDATA  EQU   ISTICE+20
ICESIDE  EQU   ISTICE+16
ICEOBJQ  EQU   ISTICE+12
ICESUBJQ EQU   ISTICE+8
ICEOBJ   EQU   ISTICE+4
ICESUBJ  EQU   ISTICE
BINUSE   EQU   ISTBIND+36
BINUSEL  EQU   ISTBIND+35
BINPRIM  EQU   ISTBIND+27
BINPRIML EQU   ISTBIND+26
BINPRSVC EQU   ISTBIND+7
BINCONR  EQU   BINCMNP2
BINRCHN  EQU   BINCMNP2
BINMDIBK EQU   BINCMNP2
BINBKFS  EQU   BINCMNP2
BINRCVR  EQU   BINCMNP2
BINFMTRM EQU   BINCMNP2
BINRSV04 EQU   BINCMNP
BINALT   EQU   BINCMNP
BINBKTR  EQU   BINCMNP
BINBRAK  EQU   BINCMNP
BINFMHD  EQU   BINCMNP
BINRSV03 EQU   BINCMNP
BINSSEB  EQU   BINSECP
BINSCMP  EQU   BINSECP
BINRSV02 EQU   BINSECP
BINSCHNR EQU   BINSECP
BINSMCH  EQU   BINSECP
BINSCHN  EQU   BINSECP
BINPSEB  EQU   BINPRIP
BINPCMP  EQU   BINPRIP
BINRSV01 EQU   BINPRIP
BINPCHNR EQU   BINPRIP
BINPMCH  EQU   BINPRIP
BINPCHN  EQU   BINPRIP
BINTS    EQU   ISTBIND+2
BINFM    EQU   ISTBIND+1
BINTYPE  EQU   BINFMTY
BINFMT   EQU   BINFMTY
CSLDATAF EQU   CSLDATA
CSLNIBF  EQU   CSLNIB
RPLSEQNO EQU   RPLOF60+6
@NM00052 EQU   RPLIBSQ
RPLIINV  EQU   RPLIBSQ
RPLINEG  EQU   RPLIBSQ
RPLIPOS  EQU   RPLIBSQ
RPLIIGN  EQU   RPLIBSQ
RPLIRSET EQU   RPLIBSQ
RPLITST  EQU   RPLIBSQ
RPLISET  EQU   RPLIBSQ
@NM00051 EQU   RPLOBSQ
RPLOINV  EQU   RPLOBSQ
RPLONEG  EQU   RPLOBSQ
RPLOPOS  EQU   RPLOBSQ
RPLOIGN  EQU   RPLOBSQ
RPLORSET EQU   RPLOBSQ
RPLOTST  EQU   RPLOBSQ
RPLOSET  EQU   RPLOBSQ
RPLIBSQV EQU   RPLOF60+2
RPLOBSQV EQU   RPLOF60
@NM00050 EQU   RPLCNTSC
RPLRSHUT EQU   RPLCNTSC
RPLRQR   EQU   RPLCNTSC
RPLSHUTC EQU   RPLCNTSC
RPLSHUTD EQU   RPLCNTSC
RPLSTSN  EQU   RPLCNTSC
RPLCLEAR EQU   RPLCNTSC
RPLSDT   EQU   RPLCNTSC
@NM00049 EQU   RPLCNTDC
RPLSIGNL EQU   RPLCNTDC
RPLLUS   EQU   RPLCNTDC
RPLRTR   EQU   RPLCNTDC
RPLBID   EQU   RPLCNTDC
@NM00048 EQU   RPLCNTDF
RPLQI    EQU   RPLCNTDF
RPLRELQ  EQU   RPLCNTDF
RPLCHASE EQU   RPLCNTDF
RPLQEC   EQU   RPLCNTDF
RPLQC    EQU   RPLCNTDF
RPLCNCEL EQU   RPLCNTDF
RPLDATA  EQU   RPLCNTDF
RPLRRN   EQU   RPLRESP
RPLNFME  EQU   RPLRESP
RPLEX    EQU   RPLRESP
@NM00047 EQU   RPLRESP
@NM00046 EQU   RPLPOSTV
RPLSCHED EQU   RPLPOSTV
@NM00045 EQU   RPLVTFL1
RPLAUTUS EQU   RPLVTFL1
RPLVTUSE EQU   RPLVTFL1
@NM00044 EQU   RPLVTFL1
@NM00043 EQU   RPLCHN
RPLONLY  EQU   RPLCHN
RPLLAST  EQU   RPLCHN
RPLMIDLE EQU   RPLCHN
RPLFIRST EQU   RPLCHN
@NM00042 EQU   RPLRTYPE
RPLDFASY EQU   RPLRTYPE
RPLNFSYN EQU   RPLRTYPE
RPLRRESP EQU   RPLRTYPE
@NM00041 EQU   RPLSTYPE
RPLSRESP EQU   RPLSTYPE
@NM00040 EQU   RPLRH3
RPLCSI   EQU   RPLRH3
RPLCHREQ EQU   RPLRH3
RPLCMD   EQU   RPLRH3
RPLEB    EQU   RPLRH3
RPLBB    EQU   RPLRH3
RPLSAV13 EQU   RPLVTEXT+28
RPLUSNSO EQU   RPLOSENS+2
RPLSSMO  EQU   RPLSSNSO+1
@NM00039 EQU   RPLSSEO
RPLRRO   EQU   RPLSSEO
RPLFIO   EQU   RPLSSEO
RPLSTATO EQU   RPLSSEO
RPLCPMO  EQU   RPLSSEO
@NM00038 EQU   RPLSSEO
RPLFMHDR EQU   RPLOPT12
@NM00037 EQU   RPLOPT12
@NM00036 EQU   RPLOPT12
@NM00035 EQU   RPLOPT12
RPLNIBTK EQU   RPLOPT12
RPLTRUNC EQU   RPLOPT12
RPLKEEP  EQU   RPLOPT12
@NM00034 EQU   RPLOPT12
RPLRSVE8 EQU   RPLOPT11
RPLRSVE7 EQU   RPLOPT11
RPLRSVE6 EQU   RPLOPT11
RPLRSVE5 EQU   RPLOPT11
RPLRSVE4 EQU   RPLOPT11
RPLSTOP  EQU   RPLOPT11
RPLSTART EQU   RPLOPT11
RPLQUIES EQU   RPLOPT11
RPLRSVI6 EQU   RPLOPT10
RPLRSVI5 EQU   RPLOPT10
RPLRSVI4 EQU   RPLOPT10
RPLRSVI3 EQU   RPLOPT10
RPLRSVI2 EQU   RPLOPT10
RPLSPARM EQU   RPLOPT10
RPLDSPLY EQU   RPLOPT10
RPLBSCID EQU   RPLOPT10
RPLTOPL  EQU   RPLOPT9
RPLCIDE  EQU   RPLOPT9
RPLRNNM  EQU   RPLOPT9
RPLAPPST EQU   RPLOPT9
RPLCOUNT EQU   RPLOPT9
RPLTERMS EQU   RPLOPT9
RPLDEVCH EQU   RPLOPT9
RPLLOGON EQU   RPLOPT9
RPLUSFLD EQU   RPLVTEXT+16
RPLESR2  EQU   RPLUSNSI+1
RPLESR1  EQU   RPLUSNSI
RPLSSMI  EQU   RPLDSB2
@NM00033 EQU   RPLSSEI
RPLRRI   EQU   RPLSSEI
RPLFII   EQU   RPLSSEI
RPLSTATI EQU   RPLSSEI
RPLCPMI  EQU   RPLSSEI
RPLPATHI EQU   RPLSSEI
RPLARCLN EQU   RPLVTEXT+8
RPLAARLN EQU   RPLVTEXT+4
RPLAAREA EQU   RPLVTEXT
RPLERMSA EQU   RPLCOMN+72
RPLEMLEN EQU   RPLCOMN+70
RPLACTIV EQU   RPLCOMN+69
RPLBRANC EQU   RPLEXTD1
RPLNIB   EQU   RPLEXTD1
@NM00032 EQU   RPLEXTD1
RPLEXIT  EQU   RPLEXTD1
RPLNEXIT EQU   RPLEXTD1
RPLEXSCH EQU   RPLEXTD1
RPLDDDD  EQU   RPLRBAR+4
@NM00031 EQU   RPLRBAR+3
@NM00030 EQU   RPLAIXID
RPLAXPKP EQU   RPLAIXID
RPLAIXPC EQU   RPLRBAR
RPLRSV88 EQU   RPLOPT8
RPLUNCON EQU   RPLOPT8
RPLACTV  EQU   RPLOPT8
RPLSESS  EQU   RPLOPT8
RPLPEND  EQU   RPLOPT8
RPLODPRM EQU   RPLOPT8
RPLODACP EQU   RPLOPT8
RPLODACQ EQU   RPLOPT8
RPLRSV78 EQU   RPLOPT7
RPLTCRNO EQU   RPLOPT7
RPLRLSOP EQU   RPLOPT7
RPLTPOST EQU   RPLOPT7
RPLQOPT  EQU   RPLOPT7
RPLCNIMM EQU   RPLCNOPT
RPLCNANY EQU   RPLCNOPT
RPLCNALL EQU   RPLCNOPT
RPLRSV68 EQU   RPLOPT6
RPLRSV67 EQU   RPLOPT6
RPLLOCK  EQU   RPLOPT6
RPLNCOND EQU   RPLOPT6
RPLCOND  EQU   RPLOPT6
RPLEOT   EQU   RPLUNTYP
RPLEOM   EQU   RPLUNTYP
RPLEOB   EQU   RPLUNTYP
RPLWROPT EQU   RPLOPT5
RPLNODE  EQU   RPLOPT5
RPLERACE EQU   RPLWRTYP
RPLEAU   EQU   RPLWRTYP
RPLNERAS EQU   RPLWRTYP
RPLPSOPT EQU   RPLOPT5
@NM00029 EQU   RPLOPT5
RPLDLGIN EQU   RPLOPT5
RPLBUFL  EQU   RPLCOMN+52
RPLRLEN  EQU   RPLCOMN+48
RPLCHAIN EQU   RPLNXTRP
RPLBOP   EQU   RPLOPT4
@NM00028 EQU   RPLOPT4
RPLMKFRM EQU   RPLOPT4
RPLENDTR EQU   RPLOPT4
RPLALIGN EQU   RPLOPT3
RPLFMT   EQU   RPLOPT3
RPLFLD   EQU   RPLOPT3
RPLVFY   EQU   RPLOPT3
RPLBLK   EQU   RPLOPT3
RPLSFORM EQU   RPLOPT3
RPLEODS  EQU   RPLOPT3
RPLNSP   EQU   RPLOPT2
RPLUPD   EQU   RPLOPT2
@NM00027 EQU   RPLOPT2
RPLLRD   EQU   RPLOPT2
RPLBWD   EQU   RPLOPT2
RPLCNV   EQU   RPLOPT2
RPLADD   EQU   RPLADR
RPLKEY   EQU   RPLOPT2
RPLECBIN EQU   RPLECBSW
RPLGEN   EQU   RPLOPT1
RPLKGE   EQU   RPLOPT1
RPLASY   EQU   RPLOPT1
RPLSKP   EQU   RPLOPT1
RPLSEQ   EQU   RPLOPT1
RPLDIR   EQU   RPLOPT1
RPLLOC   EQU   RPLOPT1
RPLDAF   EQU   RPLARG+2
RPLSAF   EQU   RPLARG
RPLAREA  EQU   RPLCOMN+32
RPLTCBPT EQU   RPLCOMN+28
RPLDACB  EQU   RPLCOMN+24
RPLCCHAR EQU   RPLCOMN+20
RPLSTRID EQU   RPLCOMN+18
RPLKEYL  EQU   RPLKEYLE
RPLRDSOH EQU   RPLFDB3
RPLRLG   EQU   RPLFDB3
RPLLGFRC EQU   RPLFDB3
RPLREOT  EQU   RPLFDB3
RPLREOM  EQU   RPLFDB3
RPLREOB  EQU   RPLFDB3
RPLSV32  EQU   RPLFDB3
RPLUINPT EQU   RPLFDB3
RPLSTSAV EQU   RPLFDB2
RPLCUERR EQU   RPLFDB2
RPLDLGFL EQU   RPLFDB2
RPLIOERR EQU   RPLFDB2
RPLDVUNS EQU   RPLFDB2
RPLATND  EQU   RPLFDB2
RPLRVID  EQU   RPLFDB2
RPLERLK  EQU   RPLFDB2
RPLERREG EQU   RPLRTNCD
RPLSTAT  EQU   RPLFDBWD
RPLPOST  EQU   RPLECB
RPLWAIT  EQU   RPLECB
RPLPLHPT EQU   RPLCOMN+4
RPLLEN2  EQU   RPLLEN
RPLSTYP  EQU   RPLIDWD+1
RPLID    EQU   RPLIDWD
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00026 EQU   CVTFIX+248
@NM00025 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTSHSB  EQU   CVTSHS
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRSV37 EQU   CVTDMSR
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
@NM00024 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00023 EQU   PSA+1040
PSAUSEND EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00022 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00021 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSARV011 EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSAIPCRP EQU   PSASUP1
PSAIPCDR EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00020 EQU   FLCFSA
@NM00019 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00018 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00017 EQU   FLCIOA
@NM00016 EQU   FLCMCLA+15
@NM00015 EQU   FLCMCLA+14
@NM00014 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00013 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00012 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00011 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00010 EQU   FLCPER
@NM00009 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00008 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00007 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00006 EQU   FLCPIILC
@NM00005 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00004 EQU   FLCSVILC
@NM00003 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00002 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00001 EQU   FLCICCW2+4
FLCCVT   EQU   FLCICCW2
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00662 EQU   @RC00658
@RC00693 EQU   @RC00691
@RC00700 EQU   @RC00691
@RT00768 EQU   @RC00766
CKACE@   EQU   @PB00002
@ENDDATA EQU   *
         END   ISTOCCOF,(C'PLS2139',0603,75217)
