         TITLE 'ISTSDCCB - SYSTEM DEFINITION CONTROL BLOCK BUILD       *
                        '
ISTSDCCB CSECT ,                                                01S0001
@MAINENT DS    0H                                               01S0001
         USING *,@15                                            01S0001
         B     @PROLOG                                          01S0001
         DC    AL1(16)                                          01S0001
         DC    C'ISTSDCCB  78.108'                              01S0001
         DROP  @15
@PROLOG  STM   @14,@12,12(@13)                                  01S0001
         BALR  @12,0                                            01S0001
@PSTART  DS    0H                                               01S0001
         USING @PSTART,@12                                      01S0001
         USING @DATD-(MLCDAT3-ISTMLCA),MLCAPTR   DATA ADDRESSABILITY
*   SVBACKWD=ADDR(SAVIN);                                       02S0111
         ST    SAVREG,SVBACKWD(,MLCAPTR)                        02S0111
*   SVFORWRD=ADDR(SAVOUT);                                      02S0112
         LA    @10,SAVOUT(,MLCAPTR)                             02S0112
         ST    @10,SVFORWRD(,SAVREG)                            02S0112
*   SAVREG=ADDR(SAVOUT);                                        02S0113
         LR    SAVREG,@10                                       02S0113
*RFY SAVIN BASED(SVBACKWD);                                     02S0114
*/********************************************************************/
*/*                                                                  */
*/*  * * * * * INTRODUCTION TO MAINLINE CBDEF PROCESSING * * * * *   */
*/*                                                                  */
*/*  MOST CBDEF PROCESSING IS INDIVIDUAL RDT-ENTRY RELATED AND IS    */
*/*  PERFORMED IN THE RDTLOOP ROUTINE.  ITS FUNCTIONS ARE:           */
*/*    (1) FOR CERTAIN 370X-SEGMENT ENTRIES, POINTERS ARE CONVERTED  */
*/*        FROM OFFSETS WITHIN THE SEGMENT TO ACTUAL ADDRESSES.      */
*/*    (2) THE POINTER TO THE NEXT SCHEDULABLE NODE IS INSERTED.     */
*/*    (3) SOME FIELDS ARE MADE POINTERS TO THE ENTRY.               */
*/*    (4) THE ACTIVE AND INACTIVE CONNECTION ELEMENT (ACE AND ICE)  */
*/*        QUEUES ARE WRAPPED.                                       */
*/*    (5) ENTRIES IN THE SPECIFIC NODE TABLE (SNT) ARE INITIALIZED. */
*/*        THE 'RID GAP' ENTRY IS LEFT UNINITIALIZED. (SEE NOTE 1    */
*/*        BELOW ABOUT THE RID GAP.)                                 */
*/*    (6) EACH SYMBOLIC NAME IS PLACED IN THE SYMBOLIC RESOLUTION   */
*/*        TABLE (SRT).                                              */
*/*                                                                  */
*/*  HOWEVER, BEFORE THESE BASIC CBDEF FUNCTIONS CAN BE PERFORMED BY */
*/*  RDTLOOP, THESE MUST BE DONE:                                    */
*/*    (1) THE SNT IS CREATED BY THE BLDSNT ROUTINE.                 */
*/*    (2) TPLOCK IS USED TO OBTAIN THE VOCLOCK (VARY/OPEN/CLOSE)    */
*/*        BEFORE SRTADDS CAN BE DONE.  THE LOCK IS HELD UNTIL VARY  */
*/*        RELEASES IT BECAUSE VARY MUST DO SOME SNT PROCESSING      */
*/*        BEFORE OPEN/CLOSE GETS TO IT.                             */
*/*                                                                  */
*/*  AFTER RDTLOOP, THE FOLLOWING ARE DONE:                          */
*/*    (1) FOR 370X SEGMENTS WITH BHSETS, THE BHSET NAMES ARE ADDED  */
*/*        TO THE SRT.                                               */
*/*    (2) FOR A LOCALLY ATTACHED 370X, THE UNIT ADDRESS IS FOUND.   */
*/*        FOR A REMOTE 370X, THE RNAME IS FOUND, THE MATCHING       */
*/*        INTERMEDIATE NODE (INNODE) IS LOCATED, AND THE REMOTE     */
*/*        370X AND THE INNODE ARE LINKED TOGETHER.                  */
*/*    (3) THE SEGMENT IS QUEUED TO THE CHAIN OF RDTS, AND FOR LOCAL */
*/*        AND 370X RDTS, THE MAJOR NODE TABLE (MNT) PRIORITY LOCK   */
*/*        IS RELEASED FOR THIS RDT.                                 */
*/*                                                                  */
*/*  IF UNRECOVERABLE ERRORS OCCUR, ERRSUB1 UNDOES WHAT              */
*/*  HAS BEEN DONE AND ISSUES A MESSAGE.                             */
*/*                                                                  */
*/*  NOTE 1: RID GAP.                                                */
*/*    THE NCP KEEPS SEPARATE STATE VECTOR TABLES FOR THE OLDER (S/S */
*/*    AND BSC) AND NEWER DEVICES. TO DISTINGUISH BETWEEN THEM, THE  */
*/*    RESOURCE ID'S OF EACH SET ARE GROUPED, OLDER FIRST. THE       */
*/*    BOUNDARY IS AN UNASSIGNED RID, OR RID GAP.                    */
*/*                                                                  */
*/********************************************************************/
*   TPMSGID=0;                                                  02S0115
         SLR   TPMSGID,TPMSGID                                  02S0115
*RFY ISTRRN BASED(MLCSKEL);                                /*@DM17931*/
*IF RDTPRIRN = '1'B                    /*IS THIS AN RN CALL? @DM11636*/
*   THEN DO;                    /*YES - RN CALL - PROCESS IT @DM11636*/
         L     @10,MLCSKEL(,MLCAPTR)                            03S0117
         TM    RDTPRIRN(@10),B'00000100'                        03S0117
         BNO   @RF00117                                         03S0117
*     IF CONUNITS = RRNHBUFS  /*CHECK UNITSZ SPECIFIED ON START VTAM
*                                     VRS. WHAT IS ON HOST  @DM17931*/
*        THEN;            /*YES - THEY MATCH EVERYTHING OK   @DM17931*/
         CLC   CONUNITS(2,CONFTPTR),RRNHBUFS(@10)               03S0119
         BE    @RT00119                                         03S0119
*        ELSE DO;   /*NO - THEY DO NOT MATCH - KILL BUILD    @DM17931*/
*        TPMSGID = ADDR(MSG341I);                          /*@DM17931*/
         LA    TPMSGID,MSG341I                                  03S0122
*        NMERRCD = '1';                                    /*@DM17931*/
         MVI   NMERRCD(MLCAPTR),C'1'                            03S0123
*             END;                                         /*@DM17931*/
*        END;                                              /*@DM11636*/
*ELSE;                    /*NO - NOT AN RN CALL - DO NOTHING @DM11636*/
@RF00117 DS    0H                                               03S0127
*RFY ISTRRN;                                               /*@DM17931*/
@RC00117 DS    0H                                               03S0128
*/***********************************************************@DM17931*/
*/*     END OF CKSUB SEGMENT                                 @DM17931*/
*/***********************************************************@DM17931*/
*IF TPMSGID ^= 0                                           /*@DM17931*/
*   THEN DO;                                               /*@XM10670*/
*                                                               02S0128
         SLR   @10,@10                                          02S0128
         CR    TPMSGID,@10                                      02S0128
         BE    @RF00128                                         02S0128
*/*TPMSG MSGID((TPMSGID))MSG((ADDR(MLCERBF1)))PLAREA(MLCTPMSG)OPTIONS(N
*SPLSID)*/                                                      02S0130
*                                                               02S0130
*      DO;                                                      02S0130
*        DCL REG1006  REG(1)  PTR;                              02S0131
*        RFY (REG1006) RSTD;                                    02S0132
*                                                               02S0132
*      RFY (EMCR13) RSTD;                                       02S0133
*        DCL 1 * BASED(REG1006),                                02S0134
*            2 CMZID006 PTR(31),                                02S0134
*            2 *,                                               02S0134
*              3 CMZRL006 PTR(8),                               02S0134
*              3 CMZRA006 PTR(24) BDY(BYTE),                    02S0134
*            2 CMZEA006 PTR(31),                                02S0134
*            2 CMZVP006 PTR(31);                                02S0134
*                                                               02S0134
*/*XREGSET  PID('PLAREA')PPARM(MLCTPMSG)RREG(,REG1006)*/        02S0135
*      DO;                                                      02S0135
*        REG1006=ADDR(MLCTPMSG);         /*SET RREG SYMBOL TO ADDRESS*/
         LA    REG1006,MLCTPMSG(,MLCAPTR)                       02S0136
*                                        /*OF PPARM OPERAND          */
*      END;  /* XREGSET */                                      02S0137
*        CMZID006 = 0;                                          02S0138
         ST    @10,CMZID006(,REG1006)                           02S0138
*        CMZRL006 = 0;                                          02S0139
         MVI   CMZRL006(REG1006),X'00'                          02S0139
*        CMZRA006 = 0;                                          02S0140
         STCM  @10,7,CMZRA006(REG1006)                          02S0140
*        CMZEA006 = 0;                                          02S0141
         ST    @10,CMZEA006(,REG1006)                           02S0141
*        CMZVP006 = 0;                                          02S0142
         ST    @10,CMZVP006(,REG1006)                           02S0142
*        CMZID006=TPMSGID;                                      02S0143
         ST    TPMSGID,CMZID006(,REG1006)                       02S0143
*        CMZVP006 = ADDR(MLCERBF1);                             02S0144
         LA    @02,MLCERBF1(,MLCAPTR)                           02S0144
         ST    @02,CMZVP006(,REG1006)                           02S0144
*        DCL CMZSA006 (18) PTR(31) BASED(EMCR13);               02S0145
*        CMZSA006(5) = ADDR(NCSPLSID);                          02S0146
*                                                               02S0146
         L     @02,MLCNCSPL(,MLCAPTR)                           02S0146
         LA    @02,NCSPLSID(,@02)                               02S0146
         ST    @02,CMZSA006+16(,EMCR13)                         02S0146
*        DCL REG15006 REG(15) PTR;                              02S0147
*        RFY REG15006 RSTD;                                     02S0148
*                                                               02S0148
*      DO; /* LISATCVT CVTBASE(PAGEABLE,(REG15006)) */          02S0149
*        REG15006 = ATCLCPTR; /*SET UP ATCVT POINTER*/          02S0150
         L     REG15006,ATCLCPTR                                02S0150
*      END; /*LISATCVT*/                                        02S0151
*        DCL CMTA006 BASED(REG15006) ENTRY VALUERANGE(*);       02S0152
*        REG15006 = REG15006->ATCMSGP;                          02S0153
         L     REG15006,ATCMSGP(,REG15006)                      02S0153
*        CALL CMTA006;                                          02S0154
         BALR  @14,@15                                          02S0154
*        RESPECIFY (REG1006,REG15006)  UNRESTRICTED;            02S0155
*                                                               02S0155
*      RFY (EMCR13) UNRSTD;                                     02S0156
*      END;                          /*@D32CKQH*/               02S0157
*                                                          /*@XM10670*/
*          GPR15F  = 8;                                    /*@XM10670*/
         LA    GPR15F,8                                         02S0158
*     END;                                                 /*@XM10670*/
*   ELSE DO;                                               /*@XM11636*/
         B     @RC00128                                         02S0160
@RF00128 DS    0H                                               02S0161
*/* COMPUTE ADDRESS OF MNT ENTRY FOR THIS NODE (NOT USED FOR APPL).  */
*   MNTEPTR=ATCMNT+RDTNODID*LENGTH(MNTENTRY);                   02S0161
         L     @10,MLCSKEL(,MLCAPTR)                            02S0161
         SLR   @02,@02                                          02S0161
         IC    @02,RDTNODID(,@10)                               02S0161
         SLA   @02,3                                            02S0161
         AL    @02,ATCMNT(,ATCVTPTR)                            02S0161
         ST    @02,MNTEPTR                                      02S0161
*/* CREATE THE STRUCTURE OF THE SNT FOR A 370X OR LOCAL SEGMENT.     */
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME: BLDSNT                                             */
*/*                                                                  */
*/* FUNCTION: PROCESSES 370X, LOCAL TERMINAL, SWITCHED SUBAREA AND   */
*/* THE LOCAL SUBAREA RDT SEGMENTS. FOR 370X AND LOCAL TERMINAL, IT  */
*/* CONFIRMS THAT THE MAXID FIELDS IN THE VTAM CVT AND THE RDT ARE   */
*/* EQUAL. FOR ALL FOUR RDT TYPES, IT CHECKS THAT SUBAREA SPECIFIECD */
*/* DOES NOT EXCEED THE MAXIMUM ALLOWED BY ATCVT, AND THAT THE       */
*/* PRIORITY BIT (LOKPRY) IS ON FOR THIS NODE IN THE MNT. THEN IT    */
*/* ISSUES A GETSTOR TO OBTAIN FIXED STORAGE FOR THE SNT FOR THE     */
*/* NUMBER OF NODES + 1 FOR THE RDT HEADER AND SETS EACH LOCK WORD   */
*/* TO ALL ONES SO THAT AFTER INITIALIZATION OF EACH ENTRY, THE RID  */
*/* GAP REMAINS ALL ONES.                                            */
*/*                                                                  */
*/* INPUT: ATCMAXID AND RDTMAXID - CHECKED FOR CONSISTENCY           */
*/*        MNTEPTR - ADDRESS OF MNT ENTRY FOR THIS MAJOR NODE        */
*/*        RDTCTSNT - COUNT OF SPECIFIC NODES                        */
*/*        MNT LOKPRY - MUST BE ON                                   */
*/*                                                                  */
*/* OUTPUT: SNT- HEADER INITIALIZED AND ENTRY LOCKWORDS ALL ONES     */
*/*         TPMSGID - ADDR OF TERMINATING ERROR MESSAGE ID, IF ANY   */
*/*                                                                  */
*/*ROUTINES CALLED: NONE                                             */
*/*                                                                  */
*/*MACROS USED: GETSTOR - OBTAIN STORAGE FOR SNT                     */
*/*                                                                  */
*/********************************************************************/
*/*APPL SEG DOES NOT REQUIRE AN SNT TO BE BUILT              @D32CKMX*/
*IF RDTPRIAP = '1'B             /*IS THIS AN APPL SEGMENT    @D32CKMX*/
*   THEN;                       /*DO NOTHING FOR AN APPL SEG @D32CKMX*/
         TM    RDTPRIAP(@10),B'00010000'                        03S0162
         BO    @RT00162                                         03S0162
*   ELSE            /*NO PROCESS 370X,LOCAL,SWITCHED SEGMENT @D32CKMX*/
*      IF RDTPRIRN = '1'B & RDTMAXID^=ATCMAXID /*DO AN 370X SEGMENT AND
*             MAXIMUM NODE ID IN RDT AND VTAM CVT MUST MATCH @D32CKMX*/
*       THEN TPMSGID=ADDR(MSG331I);                             03S0164
         L     @10,MLCSKEL(,MLCAPTR)                            03S0164
         TM    RDTPRIRN(@10),B'00000100'                        03S0164
         BNO   @RF00164                                         03S0164
         CLC   RDTMAXID(1,@10),ATCMAXID(ATCVTPTR)               03S0164
         BE    @RF00164                                         03S0164
         LA    TPMSGID,MSG331I                                  03S0165
*       ELSE                     /*CHECK SUBAREA <= ACTMAXID @D32CKMX*/
*           IF RDTNODID > ATCMAXID                         /*@D32CKMX*/
*              THEN TPMSGID = ADDR(MSG340I);   /*SET ERR MSG @D32CKMX*/
         B     @RC00164                                         03S0166
@RF00164 L     @10,MLCSKEL(,MLCAPTR)                            03S0166
         CLC   RDTNODID(1,@10),ATCMAXID(ATCVTPTR)               03S0166
         BNH   @RF00166                                         03S0166
         LA    TPMSGID,MSG340I                                  03S0167
*     ELSE                                                      03S0168
*/* LOCK PRIORITY IS NEEDED IN THE MNT ENTRY                         */
*       IF ADDR(MNTLOCK)->LOKPRY=OFF THEN                       03S0168
         B     @RC00166                                         03S0168
@RF00166 L     @10,MNTEPTR                                      03S0168
         TM    LOKPRY+4(@10),B'00000010'                        03S0168
         BNZ   @RF00168                                         03S0168
*         TPMSGID=ADDR(MSG332I);                                03S0169
         LA    TPMSGID,MSG332I                                  03S0169
*       ELSE                                                    03S0170
*/* GET SPACE FOR SNT HEADER + RDTCTSNT+1 (FOR RDT HDR) ENTRIES      */
*         DO;                                                   03S0170
         B     @RC00168                                         03S0170
@RF00168 DS    0H                                               03S0171
*           CTSNT=RDTCTSNT+1;                                   03S0171
         L     @10,MLCSKEL(,MLCAPTR)                            03S0171
         LA    CTSNT,1                                          03S0171
         AH    CTSNT,RDTCTSNT(,@10)                             03S0171
*RFY (RPHPTR,GPR15F) RSTD;                                      03S0172
*           RPHPTR=MLCRPH;                                      03S0173
         L     RPHPTR,MLCRPH(,MLCAPTR)                          03S0173
*            /*GETSTOR CLEAR(YES)TYPE(FIXED)SIZE(LENGTH(ISTSNT)-LENGTH(
*NTENTRY)+CTSNT*LENGTH(SNTENTRY))*/                             03S0174
*             DO;                                               03S0174
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTATCVT,ISTRPH)  */               03S0175
*/* END OF ATBUILD */                                           03S0175
*            RFY (GPR00P,GPR01P,GPR02P,GPR03P) RSTD;            03S0175
*            RFY ISTRPH BASED(GPR01P);                          03S0176
*            GEN REFS(GPR02P,GPR03P,GPR04P,GPR05P,              03S0177
*                     GPR06P,GPR07P,GPR08P,GPR09P,              03S0177
*                     GPR10P,GPR11P,GPR12P,GPR13P)              03S0177
*                SETS(RPHWORK);                                 03S0177
*                                                               03S0177
         STM   GPR02P,GPR13P,RPHWORK(GPR01P)        SAVE REGISTERS
*            GPR00F = LENGTH(ISTSNT)-LENGTH(SNTENTRY)+CTSNT*LENGTH(SNTE
*TRY);                                                 /*SIZE IN REG0*/
         LR    GPR00F,CTSNT                                     03S0178
         SLA   GPR00F,3                                         03S0178
         AH    GPR00F,@CH00102                                  03S0178
*            DCL 1 CMZA0015 FIXED(31) STATIC LOCAL,             03S0179
*                  2 * FIXED(8) INIT(96),            /* OPTION FLAGS */
*                  2 * FIXED(8) INIT(96),             /* STORAGE KEY */
*                  2 * FIXED(8) INIT(227),         /* SUBPOOL NUMBER */
*                  2 * FIXED(8) INIT('00'X);         /* REQUEST TYPE */
*            GPR03F = CMZA0015;                                 03S0180
*                                                               03S0180
         L     GPR03F,CMZA0015                                  03S0180
*            DO; /* LISATCVT CVTBASE(PAGEABLE,(GPR02P)) */      03S0181
*              GPR02P = ATCLCPTR; /*SET UP ATCVT POINTER*/      03S0182
         L     GPR02P,ATCLCPTR                                  03S0182
*            END; /*LISATCVT*/                                  03S0183
*            CALL GPR02P -> ATCGTSTR;                 /*CALL ISTORFSR*/
         L     @15,ATCGTSTR(,GPR02P)                            03S0184
         BALR  @14,@15                                          03S0184
*            RFY (GPR00P,GPR01P,GPR02P,GPR03P) UNRSTD;          03S0185
*            END ;                                   /*END OF GETSTOR*/
*           IF GPR15F^=0 THEN                                   03S0187
         LTR   GPR15F,GPR15F                                    03S0187
         BZ    @RF00187                                         03S0187
*             TPMSGID=ADDR(MSG303I);                            03S0188
         LA    TPMSGID,MSG303I                                  03S0188
*           ELSE                                                03S0189
*/* POINT MNT TO SNT, SET ENTRY COUNT IN SNT, SET LOCK WORDS TO ONES */
*             DO;                                               03S0189
         B     @RC00187                                         03S0189
@RF00187 DS    0H                                               03S0190
*               SNTPTR=RPHSRPRM;                                03S0190
         L     SNTPTR,RPHSRPRM(,GPR01P)                         03S0190
*RFY (RPHPTR,GPR15F) UNRSTD;                                    03S0191
*               MNTSNT=SNTPTR;                                  03S0192
         L     @10,MNTEPTR                                      03S0192
         ST    SNTPTR,MNTSNT(,@10)                              03S0192
*RFY ISTSNT BASED(SNTPTR);                                      03S0193
*               SNTNENTS=CTSNT;                                 03S0194
         ST    CTSNT,SNTNENTS(,SNTPTR)                          03S0194
*               DO CTSNT=CTSNT BY -1 TO 1;                      03S0195
         B     @DE00195                                         03S0195
@DL00195 DS    0H                                               03S0196
*                 SNTLOCK='FFFFFFFF'X;                          03S0196
         MVC   SNTLOCK(4,SNTPTR),@CB00908                       03S0196
*                 SNTPTR=SNTPTR+LENGTH(SNTENTRY);               03S0197
         AH    SNTPTR,@CH00102                                  03S0197
*               END;                                            03S0198
         BCTR  CTSNT,0                                          03S0198
@DE00195 LTR   CTSNT,CTSNT                                      03S0198
         BP    @DL00195                                         03S0198
*RFY ISTSNT;                                                    03S0199
*             END;                                              03S0200
*         END;                                                  03S0201
@RC00187 DS    0H                                               03S0202
*/********************************************************************/
*/*          END OF BLDSNT SEGMENT                                   */
*/********************************************************************/
*   IF TPMSGID^=0                  /* QUIT IF BLDSNT SET ERR MSG     */
*     THEN DO;                                             /*@XM10670*/
*                                                               02S0202
@RC00168 DS    0H                                               02S0202
@RC00166 DS    0H                                               02S0202
@RC00164 DS    0H                                               02S0202
@RT00162 SLR   @10,@10                                          02S0202
         CR    TPMSGID,@10                                      02S0202
         BE    @RF00202                                         02S0202
*/*TPMSG MSGID((TPMSGID))MSG((ADDR(MLCERBF1)))PLAREA(MLCTPMSG)OPTIONS(N
*SPLSID)*/                                                      02S0204
*                                                               02S0204
*        DO;                                                    02S0204
*          DCL REG1033  REG(1)  PTR;                            02S0205
*          RFY (REG1033) RSTD;                                  02S0206
*                                                               02S0206
*        RFY (EMCR13) RSTD;                                     02S0207
*          DCL 1 * BASED(REG1033),                              02S0208
*              2 CMZID033 PTR(31),                              02S0208
*              2 *,                                             02S0208
*                3 CMZRL033 PTR(8),                             02S0208
*                3 CMZRA033 PTR(24) BDY(BYTE),                  02S0208
*              2 CMZEA033 PTR(31),                              02S0208
*              2 CMZVP033 PTR(31);                              02S0208
*                                                               02S0208
*/*XREGSET  PID('PLAREA')PPARM(MLCTPMSG)RREG(,REG1033)*/        02S0209
*        DO;                                                    02S0209
*          REG1033=ADDR(MLCTPMSG);       /*SET RREG SYMBOL TO ADDRESS*/
         LA    REG1033,MLCTPMSG(,MLCAPTR)                       02S0210
*                                        /*OF PPARM OPERAND          */
*        END;  /* XREGSET */                                    02S0211
*          CMZID033 = 0;                                        02S0212
         ST    @10,CMZID033(,REG1033)                           02S0212
*          CMZRL033 = 0;                                        02S0213
         MVI   CMZRL033(REG1033),X'00'                          02S0213
*          CMZRA033 = 0;                                        02S0214
         STCM  @10,7,CMZRA033(REG1033)                          02S0214
*          CMZEA033 = 0;                                        02S0215
         ST    @10,CMZEA033(,REG1033)                           02S0215
*          CMZVP033 = 0;                                        02S0216
         ST    @10,CMZVP033(,REG1033)                           02S0216
*          CMZID033=TPMSGID;                                    02S0217
         ST    TPMSGID,CMZID033(,REG1033)                       02S0217
*          CMZVP033 = ADDR(MLCERBF1);                           02S0218
         LA    @02,MLCERBF1(,MLCAPTR)                           02S0218
         ST    @02,CMZVP033(,REG1033)                           02S0218
*          DCL CMZSA033 (18) PTR(31) BASED(EMCR13);             02S0219
*          CMZSA033(5) = ADDR(NCSPLSID);                        02S0220
*                                                               02S0220
         L     @02,MLCNCSPL(,MLCAPTR)                           02S0220
         LA    @02,NCSPLSID(,@02)                               02S0220
         ST    @02,CMZSA033+16(,EMCR13)                         02S0220
*          DCL REG15033 REG(15) PTR;                            02S0221
*          RFY REG15033 RSTD;                                   02S0222
*                                                               02S0222
*        DO; /* LISATCVT CVTBASE(PAGEABLE,(REG15033)) */        02S0223
*          REG15033 = ATCLCPTR; /*SET UP ATCVT POINTER*/        02S0224
         L     REG15033,ATCLCPTR                                02S0224
*        END; /*LISATCVT*/                                      02S0225
*          DCL CMTA033 BASED(REG15033) ENTRY VALUERANGE(*);     02S0226
*          REG15033 = REG15033->ATCMSGP;                        02S0227
         L     REG15033,ATCMSGP(,REG15033)                      02S0227
*          CALL CMTA033;                                        02S0228
         BALR  @14,@15                                          02S0228
*          RESPECIFY (REG1033,REG15033)  UNRESTRICTED;          02S0229
*                                                               02S0229
*        RFY (EMCR13) UNRSTD;                                   02S0230
*        END;                         /*@D32CKQH*/              02S0231
*                                                          /*@XM10670*/
*       GPR15F = 8;                                        /*@XM10670*/
         LA    GPR15F,8                                         02S0232
*     END;                                                 /*@XM10670*/
*   ELSE                                                        02S0234
*/* GET EXCLUSIVE CONTROL OF THE VOCLOCK                             */
*     DO;                                                       02S0234
         B     @RC00202                                         02S0234
@RF00202 DS    0H                                               02S0235
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME: GETLOCK                                            */
*/*                                                                  */
*/* FUNCTION: TPLOCK IS USED TO OBTAIN EXCLUSIVE CONTROL OF THE      */
*/* VOCLOCK (VARY/OPEN/CLOSE) GEFORE SRTADDS CAN BE DONE. THE LOCK   */
*/* IS HELD UNTIL VARY RELEASES IT BECAUSE VARY MUST DO SOME SNT     */
*/* PROCESSING BEFOR OPEN/CLOSE GETS TO IT.                          */
*/*                                                                  */
*/* INPUT: NONE                                                      */
*/*                                                                  */
*/* OUTPUT: VOCLOCK IS HELD BY THIS TASK OR SUBTASK                  */
*/*                                                                  */
*/* ROUTINES CALLED: NONE                                            */
*/*                                                                  */
*/* MACRO USED: TPLOCK                                               */
*/*                                                                  */
*/********************************************************************/
*RFY RPHPTR RSTD;                                               03S0235
*   RPHPTR=MLCRPH;                                              03S0236
*                                                               03S0236
         L     RPHPTR,MLCRPH(,MLCAPTR)                          03S0236
*/*** START -TPLOCK (VOCLOCK)TYPE(XCLSIVE)- ***/                03S0237
*    DO;                                                        03S0237
*    RFY ISTLCCW ;                                              03S0238
*    RFY ISTLCPB ;                                              03S0239
*    RFY ISTZSAVE;                                              03S0240
*    RFY ISTPFCRR;                                              03S0241
*    RFY ISTCFCRR;                                              03S0242
*    RFY ISTZCRR ;                                              03S0243
*    RFY ISTASCRR;                                              03S0244
*    RFY ISTAPCRR;                                              03S0245
*    RFY ISTCRA  ;                                              03S0246
*                                                               03S0246
*    RFY (GPR00P,GPR01P,GPR02P,GPR03P,GPR04P,GPR15P) RSTD;      03S0247
*        GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(RPHWORK);
         STM GPR00P,GPR14P,RPHWORK(GPR01P)
*        GPR15P = ATCAP36;              /*ADDRESS OF LOCK ROUTINE*/
         L     GPR15P,ATCAP36(,ATCVTPTR)                        03S0249
*        GPR02P = ADDR(ATCVOCLK);       /*SET PARAM - LOCKWORD PTR*/
         LA    GPR02P,ATCVOCLK(,ATCVTPTR)                       03S0250
*        GPR04P = GPR01P->RPHCRR;       /*SET PARAM - ISTCRA PTR*/
         L     GPR04P,RPHCRR(,GPR01P)                           03S0251
*        GPR00P = CRALMS02;             /*SET PARAM - LOCK LEVEL FLAG*/
         LA    GPR00P,2                                         03S0252
*        GPR03P = ADDR(GPR04P->CRAL2PTR);                       03S0253
         LA    GPR03P,CRAL2PTR(,GPR04P)                         03S0253
*                                       /*SET PARAM - LOCK LEVEL PTR*/
*        DCL FMZL0042 BASED(GPR15P) LABEL VALUERANGE(*);        03S0254
*        CALL FMZL0042;                                         03S0255
         BALR  @14,@15                                          03S0255
*        GENERATE REFS(GPR00P,GPR01P,GPR14P,RPHWORK) SETS(GPR00P,GPR01P
*GPR02P,GPR03P,GPR04P,GPR05P,GPR06P,GPR07P,GPR08P,GPR09P,GPR10P,GPR11P,
*PR12P,GPR13P,GPR14P,GPR15P);                                   03S0256
*                                                               03S0256
         LM GPR00P,GPR15P,RPHWORK(GPR01P)
*    RFY (GPR00P,GPR01P,GPR02P,GPR03P,GPR04P,GPR15P) UNRSTD;    03S0257
*        END;                                                   03S0258
*/*** END -TPLOCK (VOCLOCK)TYPE(XCLSIVE)- ***/                  03S0259
*RFY RPHPTR UNRSTD;                                             03S0259
*/********************************************************************/
*/*          END OF GETLOCK SEGMENT                                  */
*/********************************************************************/
*/* LOOP THROUGH RDT AND PROCESS EACH ENTRY ACCORDING TO ITS TYPE.   */
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME: RDTLOOP                                            */
*/*                                                                  */
*/* FUNCTION: EACH ENTRY IN THE RDT IS PROCESSED ACCORDING TO ITS    */
*/*           ENTRY TYPE. DETAILS OF PROCESSING FOR EACH TYPE ARE    */
*/*           SHOWN IN THE TABLE NEXT PAGE. FURTHER INFORMATION IS   */
*/*           GIVEN BELOW.                                           */
*/*           PROCESSING IS BY GROUPS OF ENTRY TYPES.                */
*/*             SEGMENT TYPES               PROCESSED BY SUBSEGMENT  */
*/*             UTERM,TERM,LU,COMP,INNODE                    @D32CKMX*/
*/*             INNODE, AND LUX             TERMS            @D32CKMX*/
*/*             LINE,APPL,CLUS,                              @D32CKMX*/
*/*             PU,PUX, AND DAN             APLCLSLN         @D32CKMX*/
*/*             DIALSET,GROUP,LOCAL         RDTLOOP                  */
*/*             HEADERS: 370X,AH,LH,                         @D32CKMX*/
*/*             SWITCHED SUBAREA, OR                         @D32CKMX*/
*/*             LOCAL SUBAREA               RDTLOOP          @D32CKMX*/
*/*                                                                  */
*/* INPUT: MLCSKEL - RDT ADDRESS.                                    */
*/*                                                                  */
*/* OUTPUT: EXPLANATIONS OF OUTPUT TABLE HEADINGS AND NOTES FOLLOW.  */
*/*         NOTE: IN SOME CASES ADDITIONAL RELATED WORK IS DONE.     */
*/*                                                                  */
*/*         ADD ADDRESS OF SKELETON: IN A 370X CONFIGURATION AND     */
*/*         A SWITCHED SUBAREA FIELDS THAT POINT TO TABLES  AND      */
*/*         STRINGS IN VARIOUS ENTRIES ARE CONVERTED FROM OFFSETS    */
*/*         PAST THE BEGINNING OF THE 370X ENTRY TO POINTERS BY      */
*/*         ADDING THE 370X ENTRY ADDRESS TO EACH OFFSET.            */
*/*         CONVERT THE FIELDS SHOWN.                                */
*/*           * ONLY IF ALREADY NON-ZERO                             */
*/*           ** FOR ALL DITT ENTRIES (RPTDITT NON-ZERO, RLNTTV ON)  */
*/*           *** FOR ALL DIVT ENTRIES (RPTDITT ^0, RLNTTV OFF)      */
*/*           **** ONLY FOR PU IN SWITCHED SUBAREA AND ONLY IF       */
*/*                RCCPATHT NONZERO.                                 */
*/*         POINT TO THIS ENTRY: CERTAIN FIELDS MUST BE MADE TO      */
*/*          POINT TO THE ENTRY ITSELF, INCLUDING THE MLCPTRS WHICH  */
*/*          ARE USED TO ALLOW A FIELD IN A LATER ENTRY TO POINT TO  */
*/*          A SPECIFIC HIGHER NODE.                                 */
*/*         WRAP QUEUES: THE ACTIVE/INACTIVE CONNECTION ELEMENTS     */
*/*          (ACES AND ICES) ARE MADE TO POINT TO THEMSELVES.        */
*/*         SNT: INDICATED IS WHETHER TO CALL SNTSUB TO INITIALIZE   */
*/*          THE SNT ENTRY FOR THE COMMUNICATION ID (CID) OF THE RDT */
*/*          ENTRY. IF SO, THE CID IS IN RPRCOMID, EXCEPT THAT -     */
*/*           * FOR A PORT, CALLS ARE FOR RPRCOMID AND RPTLNCID.     */
*/*           ** NO FOR UTERMS AND VTERMS. YES FOR TERMS THAT ARE    */
*/*            NOT VTERMS (RTRVTERM OFF).                            */
*/*         SRT: CALL SRTSUB TO ADD RPRNAME (ENTRY NAME) TO SRT.     */
*/*           * FOR PORT, CALL FOR RPRNAME AND RPTCTNM (CTERM NAME)  */
*/*           ** FOR PU IN SWITCHED SUBAREA, CALL FOR RPRNAME AND    */
*/*              RCCSTAIN (STATION ID).                              */
*/*         NEXT SCHEDUABLE NODE ENTRY ADDRESS: SET RPRNSNEA TO      */
*/*          VALUE SHOWN.                                            */
*/*                                                                  */
*/* ROUTINES CALLED: SRTSUB - ADD NAME TO SRT                        */
*/*                  SNTSUB - INITIALIZE SNT ENTRY                   */
*/*                                                                  */
*/* MACROS USED: NONE                                                */
*/*                                                                  */
*/* SUBSEGMENTS: SEE FUNCTION                                        */
*/*                                                                  */
*/********************************************************************/
*/*        RDTLOOP OUTPUT TABLE (EXPLANATION ON PREVIOUS PAGE)  03S0260
*                                                               03S0260
*ENTRY||ADD ADDRESS | POINT TO   | WRAP   |SNT|SRT|NEXT SCHEDUABLE
*TYPE || OF SKELETON| THIS ENTRY | QUEUES |   |   | NODE ENTRY ADDRESS
*-----++------------+------------+--------+---+---+--------------------
*-----++------------+------------+--------+---+---+--------------------
*370X ||RRNGRPA     |            |        |YES|YES|             03S0260
*HDR  ||RRNLASTE    |            |        |   |   |             03S0260
*     ||RRNBHSET*   |            |        |   |   |             03S0260
*     ||RRNFLUX*    |            |        |   |   |            @D32CKMX
*-----++------------+------------+--------+---+---+--------------------
*APLHD||            |            |        |NO |YES|             03S0260
*-----++------------+------------+--------+---+---+--------------------
*LCLHD||            |            |        |YES|YES|             03S0260
*-----++------------+------------+--------+---+---+--------------------
*SWDHD||RSWTLNTB*   |            |        |YES|YES|            @D32CKMX
*     ||RSWGPNTB*   |            |        |   |   |            @D32CKMX
*-----++------------+------------+--------+---+---+--------------------
*LCSHD||            |            |        |YES|YES|            @D32CKMX
*-----++------------+------------+--------+---+---+--------------------
*LUX  ||            |            |        |YES|NO |MLCSKEL     @D32CKMX
*-----++------------+------------+--------+---+---+--------------------
*DIAL-||RDSADDOT*   |            |        |NO |YES|MLCSKEL      03S0260
* SET ||RPRCOMID=0  |            |        |   |   |             03S0260
*-----++------------+------------+--------+---+---+--------------------
*GROUP||            |MLCPTR0     |        |NO |YES|MLCSKEL      03S0260
*-----++------------+------------+--------+---+---+--------------------
*LOCAL||            |MLCPTR2     |        |YES|YES|MLCSKEL      03S0260
*-----++------------+------------+--------+---+---+--------------------
*LINE ||            |MLCPTR1     |        | * | * |CALL OUT&RPRNSNEA^0:
*     ||            |MLCPTR2     |        |   |   |  RPRNSNEA+MLCSKEL
*     ||            |            |        |   |   |OTHERS: MLCPTR0
* PORT||RPTDITT*    |            |        | * | * |             03S0260
* ONLY||RPTUTERM*   |            |        |   |   |             03S0260
*     ||DTERDTEA**  |            |        |   |   |             03S0260
*     ||DVERDTEA*** |            |        |   |   |             03S0260
*-----++------------+------------+--------+---+---+--------------------
*DAN  ||            | MLCPTR1    |        |YES|YES| MLCSKEL    @D32CKMX
*-----++------------+------------+--------+---+---+--------------------
*APPL ||            |RPRLGONB    |RAPACEAP|NO |YES|MLCSKEL      03S0260
*     ||            |RPRLGONF    |RAPICEAC|   |   |             03S0260
*     ||            |            |RAPICEAQ|   |   |             03S0260
*     ||            |            |RAPICELG|   |   |             03S0260
*-----++------------+------------+--------+---+---+--------------------
*CLUS ||RCLGPOLA*   |MLCPTR2     |        |YES|YES|MLCPTR1      03S0260
*-----++------------+------------+--------+---+---+--------------------
*PU   ||RCCPATHT    |MLCPTR5     |        |YES|** |MLCPTR1     @D32CKMX
*     || ****       |MLCPTR5     |        |   |   |FOR SWAREA  @D32CKMX
*     ||            |            |        |   |   |PU-MLCSKEL  @D32CKMX
*PUX  ||            |            |        |YES|NO |MLCPTR1     @D32CKMX
*-----++------------+------------+--------+---+---+--------------------
*UTERM||RTRDIAA*    |RPRLGONB    |RCPICELN|** |YES|CLUSTER TRM: MLCPTR2
*&    ||RTRPOLA*    |RPRLGONF    |RCPICEAQ|   |   |DIAL-OUT:    03S0260
*TERM ||            |MLCPTR3     |RCPACETR|   |   |  RPRNSNEA+MLCSKEL
*     ||            |DIAL-OUT:   |        |   |   |DIAL-IN: MLCPTR0
*     ||            |  DOTADTRM  |        |   |   |OTHER: MLCPTR1
*     ||            |  ADD ONE TO|        |   |   |             03S0260
*     ||            |    RDSCTTRM|        |   |   |             03S0260
*-----++------------+------------+--------+---+---+--------------------
*LOGCL||            |RPRLGONB    |RCPACETR|YES|YES|MLCPTR5      03S0260
* UNIT||            |RPRLGONF    |RCPICEAQ|   |   |             03S0260
*     ||            |            |RCPICELN|   |   |             03S0260
*-----++------------+------------+--------+---+---+--------------------
*IN-  ||            |            |        |YES|YES|MLCPTR1      03S0260
* NODE||            |            |        |   |   |RINLOCRN=MLCSKEL
*-----++------------+------------+--------+---+---+--------------------
*COMP ||RTRDIAA*    |RPRLGONB    |RCPACETR|YES|YES|MLCPTR3      03S0260
*     ||RTRPOLA*    |RPRLGONF    |RCPICEAQ|   |   |             03S0260
*     ||            |            |RCPICELN|   |   |             03S0260
*------++------------+------------+--------+---+---+-----------------*/
*RFY (ISTRPRE, ISTRCPRE, ISTRAP, ISTRLC, ISTRRN, ISTRGP, ISTRLN,
*  ISTRPT, ISTRCL, ISTRTR, ISTRIN, ISTRCC, ISTRDS, ISTRLU,      03S0260
*  ISTRPX, ISTRLX, ISTRDA, ISTRSW) BASED(RDTEPTR);         /*@D32CKMX*/
*RFY ISTDEVCH BASED(ADDR(RPRDEVCH));                            03S0261
*   RDTEPTR=MLCSKEL;               /* INITIALIZE - RDT ENTRY PTR     */
         L     RDTEPTR,MLCSKEL(,MLCAPTR)                        03S0262
*   ERNODTYP=ERNODMAX;             /*   - ERROR TYPE FOR SRTSUB      */
         MVI   ERNODTYP,X'FF'                                   03S0263
*   COMPCIDM=ATCCIDM && 'FFFF'X;   /*   - COMPLEMENT OF CID MASK
*                                           FOR SNTSUB               */
         L     @02,@CF00957                                     03S0264
         SLR   @00,@00                                          03S0264
         ICM   @00,3,ATCCIDM(ATCVTPTR)                          03S0264
         XR    @02,@00                                          03S0264
         ST    @02,COMPCIDM                                     03S0264
*/*********************************************************************
*   FIRST ENTRY IS AN RDT HEADER. 370X: CONVERT OFFSETS TO POINTERS.
*   LOCAL/370X: INITIALIZE SNT ENTRY. ALL: INSERT NAME IN SRT.  03S0265
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
*   IF RPRENTRY=RPRENTRN THEN                                   03S0265
         CLI   RPRENTRY(RDTEPTR),X'01'                          03S0265
         BNE   @RF00265                                         03S0265
*     DO;                                                       03S0266
*       RRNGRPA=RRNGRPA+RDTEPTR;   /* POINTER TO FIRST GROUP ENTRY   */
         LR    @02,RDTEPTR                                      03S0267
         AL    @02,RRNGRPA(,RDTEPTR)                            03S0267
         ST    @02,RRNGRPA(,RDTEPTR)                            03S0267
*       RRNLASTE=RRNLASTE+RDTEPTR; /* POINTER TO LAST ENTRY          */
         LR    @02,RDTEPTR                                      03S0268
         AL    @02,RRNLASTE(,RDTEPTR)                           03S0268
         ST    @02,RRNLASTE(,RDTEPTR)                           03S0268
*       IF RRNBHSET^=0 THEN        /* POINTER TO BHSETS, IF ANY      */
         L     @02,RRNBHSET(,RDTEPTR)                           03S0269
         LTR   @02,@02                                          03S0269
         BZ    @RF00269                                         03S0269
*         RRNBHSET=RRNBHSET+RDTEPTR;                            03S0270
         ALR   @02,RDTEPTR                                      03S0270
         ST    @02,RRNBHSET(,RDTEPTR)                           03S0270
*          ELSE;                                           /*@D32CKMX*/
@RF00269 DS    0H                                               03S0272
*       IF RRNFLUX = 0                /*ARE THERE ANY LUXS?  @D32CKMX*/
*          THEN;                         /*NO. DO NOTHING.   @D32CKMX*/
         ICM   @02,15,RRNFLUX(RDTEPTR)                          03S0272
         BZ    @RT00272                                         03S0272
*          ELSE RRNFLUX = RRNFLUX + MLCSKEL;   /*YES. MAKE PTR AN
*                                                    ADDRESS @D32CKMX*/
         L     @02,RRNFLUX(,RDTEPTR)                            03S0274
         AL    @02,MLCSKEL(,MLCAPTR)                            03S0274
         ST    @02,RRNFLUX(,RDTEPTR)                            03S0274
*     END;                                                 /*@D32CKMX*/
*       ELSE IF RPRENTRY = RPRENTSW /*IS THIS ENTRY SW HEADR @D32CKMX*/
*            THEN DO;          /*YES IT IS. UPDATE PTRS ETC. @D32CKMX*/
         B     @RC00265                                         03S0276
@RF00265 CLI   RPRENTRY(RDTEPTR),X'04'                          03S0276
         BNE   @RF00276                                         03S0276
*               IF RSWDIALT = 0 & RSWGRUPT = 0 /*IS THERE A DIAL NUMBER
*                              TABLE AND A GROUP NAME TABLE? @D32CKMX*/
*               THEN;                       /*NO. DO NOTHING @D32CKMX*/
         SLR   @02,@02                                          03S0278
         C     @02,RSWDIALT(,RDTEPTR)                           03S0278
         BNE   @RF00278                                         03S0278
         C     @02,RSWGRUPT(,RDTEPTR)                           03S0278
         BE    @RT00278                                         03S0278
*               ELSE DO;   /*YES. MAKE OFFSETS INTO POINTERS @D32CKMX*/
@RF00278 DS    0H                                               03S0281
*               RSWDIALT = RSWDIALT + MLCSKEL;             /*@D32CKMX*/
         L     @02,MLCSKEL(,MLCAPTR)                            03S0281
         L     @00,RSWDIALT(,RDTEPTR)                           03S0281
         ALR   @00,@02                                          03S0281
         ST    @00,RSWDIALT(,RDTEPTR)                           03S0281
*               RSWGRUPT = RSWGRUPT + MLCSKEL;             /*@D32CKMX*/
         AL    @02,RSWGRUPT(,RDTEPTR)                           03S0282
         ST    @02,RSWGRUPT(,RDTEPTR)                           03S0282
*                    END;                                  /*@D32CKMX*/
*                 END;                                     /*@D32CKMX*/
*            ELSE;                                              03S0285
@RF00276 DS    0H                                               03S0286
*   IF RPRENTRY^=RPRENTAH THEN                                  03S0286
@RC00276 DS    0H                                               03S0286
@RC00265 CLI   RPRENTRY(RDTEPTR),X'02'                          03S0286
         BE    @RF00286                                         03S0286
*     DO;                                                       03S0287
*       CIDSNT=RPRCOMID;           /* SUPPLY CID TO SNTSUB           */
         L     CIDSNT,RPRCOMID(,RDTEPTR)                        03S0288
*       CALL SNTSUB;                                            03S0289
         BAL   @14,SNTSUB                                       03S0289
*     END;                                                      03S0290
*   ELSE;                                                       03S0291
@RF00286 DS    0H                                               03S0292
*RFY (GPR00P,GPR02P) RSTD;                                      03S0292
*   GPR02P=RDTEPTR;                /* PTR TO RDT ENTRY FOR SRTSUB    */
         LR    GPR02P,RDTEPTR                                   03S0293
*   GPR00P=RDTEPTR;                /*   AND PTR TO SYMBOLIC NAME     */
         LR    GPR00P,RDTEPTR                                   03S0294
*   CALL SRTSUB;                   /* ADD SRT NAME                   */
         BAL   @14,SRTSUB                                       03S0295
*RFY (GPR00P,GPR02P) UNRSTD;                                    03S0296
*/*********************************************************************
*   IN THIS LOOP, RDTEPTR STARTS EACH PASS POINTING TO THE ENTRY
*   JUST PROCESSED AND IS USED TO DETERMINE WHETHER IT WAS THE LAST
*   ENTRY (RPRENTED ON). THEN IT IS INCREMENTED TO THE NEXT ENTRY.
*   THE LOOP ALSO STOPS IF A MESSAGE ID ADDRESS IS IN TPMSGID, NOTING
*   FAILURE CAUSING CBDEF TERMINATION. (THIS CAN OCCUR ON THE CALL
*   TO SRTSUB BEFORE THE LOOP.)                                 03S0297
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
*   DO WHILE RPRENTED=OFF & TPMSGID=0;                          03S0297
         B     @DE00297                                         03S0297
@DL00297 DS    0H                                               03S0298
*     RDTEPTR=RDTEPTR+RPRELEN;     /* GET TO NEXT ENTRY              */
         AH    RDTEPTR,RPRELEN(,RDTEPTR)                        03S0298
*RFY (GPR00P,GPR02P,GPR15F) RSTD;                               03S0299
*     GPR02P=RDTEPTR;              /* PTR TO RDT ENTRY FOR SRTSUB    */
         LR    GPR02P,RDTEPTR                                   03S0300
*     GPR00P=RDTEPTR;              /*   AND PTR TO SYMBOLIC NAME     */
         LR    GPR00P,RDTEPTR                                   03S0301
*    GPR15F=0;                                              /*DM13707*/
         SLR   GPR15F,GPR15F                                    03S0302
*    IF RPRENTRY = RPRENTPX |     /*IF THE ENTRY IS A PUX OR @D32CKMX*/
*       RPRENTRY = RPRENTLX           /*OR A LUX THEN NO SRT @D32CKMX*/
*       THEN;                                   /*DO NOTHING @D32CKMX*/
         CLI   RPRENTRY(RDTEPTR),X'72'                          03S0303
         BE    @RT00303                                         03S0303
         CLI   RPRENTRY(RDTEPTR),X'10'                          03S0303
         BE    @RT00303                                         03S0303
*       ELSE CALL SRTSUB;     /*NO. CALL ROUTINE TO ADD SRTS @D32CKMX*/
         BAL   @14,SRTSUB                                       03S0305
*     IF GPR15F^=0 THEN            /* IF SRTADD FAILED, TPMSGID AND  */
@RT00303 LTR   GPR15F,GPR15F                                    03S0306
         BZ    @RF00306                                         03S0306
*       DO;                        /*   REG 15 ARE NON-ZERO. QUIT.   */
*RFY (GPR00P,GPR02P,GPR15F) UNRSTD;                             03S0308
*       END;                                                    03S0309
*/*********************************************************************
*   DIVIDE ENTRY PROCESSING INTO GROUPS, USING ENTRY-TYPE SEQUENCE.
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
*     ELSE                                                      03S0310
*       IF RPRENTRY>=RPRENTUT | RPRENTRY = RPRENTLX   /* UTERM,TERM,LU,
*          INNODE, COMP - LUX PROCESSED IN TERMS SUBSEGMENT  @D32CKMX*/
*         THEN DO;                                         /*@D32CKMX*/
         B     @RC00306                                         03S0310
@RF00306 CLI   RPRENTRY(RDTEPTR),X'75'                          03S0310
         BNL   @RT00310                                         03S0310
         CLI   RPRENTRY(RDTEPTR),X'10'                          03S0310
         BNE   @RF00310                                         03S0310
@RT00310 DS    0H                                               03S0311
*/********************************************************************/
*/*                                                                  */
*/* SUBSEGMENT NAME: TERMS                                           */
*/*                                                                  */
*/* FUNCTION: PROCESSES INNODE, TERM, UTERM, COMPONENT AND LOGICAL   */
*/*           UNIT RDT ENTRIES ENCOUNTERED BY SEGMENT RDTLOOP.       */
*/*                                                                  */
*/*           FOR ALL ADDITIONAL INFORMATION, SEE HEADER OF RDTLOOP. */
*/*                                                                  */
*/********************************************************************/
*   IF RPRENTRY=RPRENTUT           /* INITIALIZE THE SNT, EXCEPT FOR */
*    | (RPRENTRY=RPRENTTR          /*   UTERMS AND VTERMS - WHICH    */
*      & RTRVTERM=ON)    THEN;     /*   HAVE NO CID.                 */
         CLI   RPRENTRY(RDTEPTR),X'75'                          04S0312
         BE    @RT00312                                         04S0312
         CLI   RPRENTRY(RDTEPTR),X'80'                          04S0312
         BNE   @RF00312                                         04S0312
         TM    RTRVTERM(RDTEPTR),B'00000100'                    04S0312
         BO    @RT00312                                         04S0312
*   ELSE                                                        04S0314
*     DO;                                                       04S0314
@RF00312 DS    0H                                               04S0315
*       CIDSNT=RPRCOMID;                                        04S0315
         L     CIDSNT,RPRCOMID(,RDTEPTR)                        04S0315
*       CALL SNTSUB;                                            04S0316
         BAL   @14,SNTSUB                                       04S0316
*     END;                                                      04S0317
*   IF RPRENTRY=RPRENTIN THEN      /* INNODE'S NEXT SCHEDUABLE NODE  */
@RT00312 CLI   RPRENTRY(RDTEPTR),X'82'                          04S0318
         BNE   @RF00318                                         04S0318
*     DO;                          /*   IS THE LINE.     */     04S0319
*       RPRNSNEA=MLCPTR1;                                       04S0320
         MVC   RPRNSNEA(4,RDTEPTR),MLCPTR1(MLCAPTR)             04S0320
*       RINLOCRN=MLCSKEL;          /* LOCAL 370X IS REMOTE'S NSNEA.  */
         MVC   RINLOCRN(4,RDTEPTR),MLCSKEL(MLCAPTR)             04S0321
*     END;                                                      04S0322
*   ELSE                                                        04S0323
*     IF RPRENTRY = RPRENTLX  /*CHECK FOR ENTRY TYPE = LUX   @D32CKMX*/
*        THEN RPRNSNEA = MLCSKEL;    /*YES. SET NSNES TO HDR @D32CKMX*/
         B     @RC00318                                         04S0323
@RF00318 CLI   RPRENTRY(RDTEPTR),X'10'                          04S0323
         BNE   @RF00323                                         04S0323
         MVC   RPRNSNEA(4,RDTEPTR),MLCSKEL(MLCAPTR)             04S0324
*        ELSE DO;          /*NO NOT LUX. CONTINUE PROCESSING @D32CKMX*/
         B     @RC00323                                         04S0325
@RF00323 DS    0H                                               04S0326
*       RPRLGONF=RDTEPTR;          /* POINT SIM LOGON CHAIN FORWARD
*                                  AND BACKWARD PTRS TO THIS ENTRY.  */
         ST    RDTEPTR,RPRLGONF(,RDTEPTR)                       04S0326
*       RPRLGONB=RDTEPTR;                                       04S0327
         ST    RDTEPTR,RPRLGONB(,RDTEPTR)                       04S0327
*       RCPICELN=ADDR(RCPICELN);   /* WRAP THE ACE AND ICE QUEUES.   */
         LA    @02,RCPICELN(,RDTEPTR)                           04S0328
         ST    @02,RCPICELN(,RDTEPTR)                           04S0328
*       RCPICEAQ=ADDR(RCPICEAQ);                                04S0329
         LA    @02,RCPICEAQ(,RDTEPTR)                           04S0329
         ST    @02,RCPICEAQ(,RDTEPTR)                           04S0329
*       RCPACETR=ADDR(RCPACETR);                                04S0330
         LA    @02,RCPACETR(,RDTEPTR)                           04S0330
         ST    @02,RCPACETR(,RDTEPTR)                           04S0330
*       IF RPRENTRY=RPRENTLU THEN  /* LU'S NEXT SCHEDUABLE NODE IS   */
         CLI   RPRENTRY(RDTEPTR),X'81'                          04S0331
         BNE   @RF00331                                         04S0331
*         RPRNSNEA=MLCPTR5;        /*   THE CLUSTER CONTROLLER.      */
         MVC   RPRNSNEA(4,RDTEPTR),MLCPTR5(MLCAPTR)             04S0332
*       ELSE                                                    04S0333
*/*********************************************************************
*   PROCESSING FOR TERMS, UTERMS AND COMPONENTS                 04S0333
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
*         DO;                                                   04S0333
         B     @RC00331                                         04S0333
@RF00331 DS    0H                                               04S0334
*           IF RTRDIAA^=0 THEN     /* CHANGE THE OFFSETS TO DIAL AND
*                                  POLL CHARACTERS, IF ANY, TO ACTUAL
*                                  ADDRESSES. (NEVER FOR LOCAL TRS.) */
         L     @02,RTRDIAA(,RDTEPTR)                            04S0334
         LTR   @02,@02                                          04S0334
         BZ    @RF00334                                         04S0334
*             RTRDIAA=RTRDIAA+MLCSKEL;                          04S0335
         AL    @02,MLCSKEL(,MLCAPTR)                            04S0335
         ST    @02,RTRDIAA(,RDTEPTR)                            04S0335
*              ELSE;                                       /*@D32CKMX*/
@RF00334 DS    0H                                               04S0337
*           IF RTRPOLA^=0 THEN                                  04S0337
         L     @02,RTRPOLA(,RDTEPTR)                            04S0337
         LTR   @02,@02                                          04S0337
         BZ    @RF00337                                         04S0337
*             RTRPOLA=RTRPOLA+MLCSKEL;                          04S0338
         AL    @02,MLCSKEL(,MLCAPTR)                            04S0338
         ST    @02,RTRPOLA(,RDTEPTR)                            04S0338
*             ELSE;                                        /*@D32CKMX*/
@RF00337 DS    0H                                               04S0340
*/*********************************************************************
*   NEXT SCHEDUABLE NODE ADDRESS PROCESSING - COMP, THEN VARIOUS TERMS
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
*           IF RPRENTRY=RPRENTCM THEN                           04S0340
         CLI   RPRENTRY(RDTEPTR),X'90'                          04S0340
         BNE   @RF00340                                         04S0340
*             RPRNSNEA=MLCPTR3;    /* COMP NSNEA IS THE DUMMY TERM.  */
         MVC   RPRNSNEA(4,RDTEPTR),MLCPTR3(MLCAPTR)             04S0341
*           ELSE                                                04S0342
*             DO;                                               04S0342
         B     @RC00340                                         04S0342
@RF00340 DS    0H                                               04S0343
*               MLCPTR3=RDTEPTR;   /* SAVE TERM ADDR FOR COMP NSNEA. */
         ST    RDTEPTR,MLCPTR3(,MLCAPTR)                        04S0343
*               IF DEVTCODE >= DEV2980 /* FOR CLUS TERMS, NSNEA IS THE
*                                  CLUSTER. DEVICE TYPE CODES FOR CLUS
*                                  TERMS ARE GROUPED TOGETHER, I.E.,
*                                  2980, 3277, 3284, 3286, 3275.     */
*                & DEVTCODE <= DEV3275 THEN                     04S0344
         LA    @02,44                                           04S0344
         ALR   @02,RDTEPTR                                      04S0344
         CLI   DEVTCODE(@02),X'18'                              04S0344
         BL    @RF00344                                         04S0344
         CLI   DEVTCODE(@02),X'1C'                              04S0344
         BH    @RF00344                                         04S0344
*                 RPRNSNEA=MLCPTR2;                             04S0345
         MVC   RPRNSNEA(4,RDTEPTR),MLCPTR2(MLCAPTR)             04S0345
*               ELSE                                            04S0346
*                 IF RPRNSNEA^=0 THEN  /* DIAL-OUT TERM HAS OFFSET TO A
*                                  DIALSET IN NSNEA. CHANGE IT TO A
*                                  POINTER. POINT THE DIALSET'S NEXT
*                                  DOT SLOT TO THE TERM AND BUMP THE
*                                  COUNT OF TERM ADRS IN THE DOT.    */
         B     @RC00344                                         04S0346
@RF00344 L     @02,RPRNSNEA(,RDTEPTR)                           04S0346
         LTR   @02,@02                                          04S0346
         BZ    @RF00346                                         04S0346
*                   DO;                                         04S0347
*                     RPRNSNEA=RPRNSNEA+MLCSKEL;                04S0348
         AL    @02,MLCSKEL(,MLCAPTR)                            04S0348
         ST    @02,RPRNSNEA(,RDTEPTR)                           04S0348
*RFY ISTRDS BASED(RPRNSNEA);                                    04S0349
*                       EVAL(RDSADDOT+RDSCTTRM*LENGTH(ISTDOT)) ->
*                     DOTADTRM=RDTEPTR;                         04S0350
         LH    @15,RDSCTTRM(,@02)                               04S0350
         LR    @14,@15                                          04S0350
         SLA   @14,2                                            04S0350
         AL    @14,RDSADDOT(,@02)                               04S0350
         ST    RDTEPTR,DOTADTRM(,@14)                           04S0350
*                     RDSCTTRM=RDSCTTRM+1;                      04S0351
         AH    @15,@CH00104                                     04S0351
         STH   @15,RDSCTTRM(,@02)                               04S0351
*RFY ISTRDS BASED(RDTEPTR);                                     04S0352
*                   END;                                        04S0353
*                 ELSE             /* FOR DIAL-IN TERM, NSNEA IS THE
*                                  GROUP. FOR NON-DIAL, THE LINE.    */
*                   IF MLCPTR0 -> RGPADIL=ON THEN               04S0354
         B     @RC00346                                         04S0354
@RF00346 L     @02,MLCPTR0(,MLCAPTR)                            04S0354
         TM    RGPADIL(@02),B'10000000'                         04S0354
         BNO   @RF00354                                         04S0354
*                     RPRNSNEA=MLCPTR0;                         04S0355
         ST    @02,RPRNSNEA(,RDTEPTR)                           04S0355
*                   ELSE RPRNSNEA=MLCPTR1;                      04S0356
         B     @RC00354                                         04S0356
@RF00354 MVC   RPRNSNEA(4,RDTEPTR),MLCPTR1(MLCAPTR)             04S0356
*             END;                                              04S0357
*         END;                                                  04S0358
*     END;                                                      04S0359
*/********************************************************************/
*/*          END OF TERMS SUBSEGMENT                                 */
*/********************************************************************/
*         END;                                                  03S0360
*       ELSE                                                    03S0361
*         IF RPRENTRY>=RPRENTLN    /* LINE,APPL,CLUS,CC,DAN,PU, OR PUX
*                                                 PROCESSED @D32CKMX */
*            THEN                  /*   IN APLCLSLN SUBSEGMENT       */
         B     @RC00310                                         03S0361
@RF00310 CLI   RPRENTRY(RDTEPTR),X'50'                          03S0361
         BL    @RF00361                                         03S0361
*            DO;                   /*   INCLUDING PORT SUBSEGMENT    */
*/********************************************************************/
*/*                                                                  */
*/* SUBSEGMENT NAME: APLCLSLN                                        */
*/*                                                                  */
*/* FUNCTION: PROCESS APPLICATION, CLUSTER, CLUSTER CONTROLLER AND   */
*/*           LINE RDT ENTRIES ENCOUNTERED BY SEGMENT RDTLOOP.       */
*/*                                                                  */
*/* SUBSEGMENT USED: PORTS - DOES PORT-UNIQUE PROCESSING FOR LINES   */
*/*                  THAT ARE PORTS.                                 */
*/*                                                                  */
*/*           FOR ALL ADDITIONAL INFORMATION, SEE HEADER OF RDTLOOP. */
*/*                                                                  */
*/********************************************************************/
*   IF RPRENTRY=RPRENTAP THEN                                   04S0363
         CLI   RPRENTRY(RDTEPTR),X'55'                          04S0363
         BNE   @RF00363                                         04S0363
*     DO;                          /* FOR APPLS, NEXT SCHEDUABLE NODE
*                                  IS THE SKELETON, SIM. LOGON CHAINS
*                                  POINT TO THE ENTRY, AND APPL ACE
*                                  AND ICE QUEUES ARE WRAPPED.       */
*       RPRNSNEA=MLCSKEL;                                       04S0365
         MVC   RPRNSNEA(4,RDTEPTR),MLCSKEL(MLCAPTR)             04S0365
*       RPRLGONF=RDTEPTR;                                       04S0366
         ST    RDTEPTR,RPRLGONF(,RDTEPTR)                       04S0366
*       RPRLGONB=RDTEPTR;                                       04S0367
         ST    RDTEPTR,RPRLGONB(,RDTEPTR)                       04S0367
*       RAPICELG=ADDR(RAPICELG);                                04S0368
         LA    @02,RAPICELG(,RDTEPTR)                           04S0368
         ST    @02,RAPICELG(,RDTEPTR)                           04S0368
*       RAPICEAC=ADDR(RAPICEAC);                                04S0369
         LA    @02,RAPICEAC(,RDTEPTR)                           04S0369
         ST    @02,RAPICEAC(,RDTEPTR)                           04S0369
*       RAPICEAQ=ADDR(RAPICEAQ);                                04S0370
         LA    @02,RAPICEAQ(,RDTEPTR)                           04S0370
         ST    @02,RAPICEAQ(,RDTEPTR)                           04S0370
*       RAPACEAP=ADDR(RAPACEAP);                                04S0371
         LA    @02,RAPACEAP(,RDTEPTR)                           04S0371
         ST    @02,RAPACEAP(,RDTEPTR)                           04S0371
*     END;                                                      04S0372
*   ELSE                                                        04S0373
*     DO;                                                       04S0373
         B     @RC00363                                         04S0373
@RF00363 DS    0H                                               04S0374
*       CIDSNT=RPRCOMID;           /* LN, CL, CC: INITIALIZE SNT.    */
         L     CIDSNT,RPRCOMID(,RDTEPTR)                        04S0374
*       CALL SNTSUB;                                            04S0375
         BAL   @14,SNTSUB                                       04S0375
*       IF RPRENTRY=RPRENTLN THEN                               04S0376
         CLI   RPRENTRY(RDTEPTR),X'50'                          04S0376
         BNE   @RF00376                                         04S0376
*         DO;                                                   04S0377
*           MLCPTR1=RDTEPTR;       /* SAVE LN ADDR FOR LOWER NODES.  */
         ST    RDTEPTR,MLCPTR1(,MLCAPTR)                        04S0378
*           MLCPTR2=RDTEPTR;                                    04S0379
         ST    RDTEPTR,MLCPTR2(,MLCAPTR)                        04S0379
*           IF RLNRACAN=ON                                      04S0380
*            & RPRNSNEA^=0 THEN    /* FOR CALL-OUT LINE WITH NSNEA A
*                                  DIALSET OFFSET, CHANGE TO ADDRESS.
*                                  FOR OTHER LN, NSNEA IS THE GROUP. */
         TM    RLNRACAN(RDTEPTR),B'01000000'                    04S0380
         BNO   @RF00380                                         04S0380
         L     @02,RPRNSNEA(,RDTEPTR)                           04S0380
         LTR   @02,@02                                          04S0380
         BZ    @RF00380                                         04S0380
*             RPRNSNEA=RPRNSNEA+MLCSKEL;                        04S0381
         AL    @02,MLCSKEL(,MLCAPTR)                            04S0381
         ST    @02,RPRNSNEA(,RDTEPTR)                           04S0381
*           ELSE RPRNSNEA=MLCPTR0;                              04S0382
         B     @RC00380                                         04S0382
@RF00380 MVC   RPRNSNEA(4,RDTEPTR),MLCPTR0(MLCAPTR)             04S0382
*           IF RLNPORT=OFF THEN;                                04S0383
@RC00380 TM    RLNPORT(RDTEPTR),B'00010000'                     04S0383
         BZ    @RT00383                                         04S0383
*           ELSE                                                04S0385
*             DO;                  /* DO DIAL PROCESSING FOR A PORT. */
*/********************************************************************/
*/*                                                                  */
*/* SUBSEGMENT NAME: PORTS                                           */
*/*                                                                  */
*/* FUNCTION: INCLUDED IN SUBSEGMENT APLCLSLN TO:                    */
*/*           (1) CHANGE OFFSETS TO POINTERS FOR THE POINTER TO THE  */
*/*               UTERM ENTRY, THE DITT/DIVT POINTER AND THE TERM    */
*/*               ENTRY POINTERS IN THE DITTS AND DIVTS.             */
*/*           (2) INITIALIZE THE SNT ENTRY FOR THE CTERM             */
*/*           (3) ADD THE CTERM NAME TO THE SRT.                     */
*/*                                                                  */
*/*           FOR ALL ADDITIONAL INFORMATION, SEE HEADER OF RDTLOOP. */
*/*                                                                  */
*/********************************************************************/
*RFY (ISTDTE,ISTDIVTH,ISTDVE) BASED(DITTDIVT);                  05S0386
*   IF RPTDITT=0 THEN;             /* NOTE: RPTDIVT IS RPTDITT.      */
         ICM   @02,15,RPTDITT(RDTEPTR)                          05S0387
         BZ    @RT00387                                         05S0387
*   ELSE                                                        05S0389
*     DO;                                                       05S0389
*       DITTDIVT=RPTDITT+MLCSKEL;  /* CONV DITT/DIVT OFFSET TO PTR.  */
         L     DITTDIVT,RPTDITT(,RDTEPTR)                       05S0390
         AL    DITTDIVT,MLCSKEL(,MLCAPTR)                       05S0390
*       RPTDITT=DITTDIVT;                                       05S0391
         ST    DITTDIVT,RPTDITT(,RDTEPTR)                       05S0391
*       IF RLNTTV=ON THEN                                       05S0392
         TM    RLNTTV(RDTEPTR),B'00001000'                      05S0392
         BNO   @RF00392                                         05S0392
*/*********************************************************************
*   FOR TERM TYPE VERIFICATION PORT, CHANGE RDT ENTRY ADDRESSES IN
*   THE DITT FROM POINTERS TO OFFSETS.                          05S0393
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
*         DO DITTDIVT=DITTDIVT BY LENGTH(ISTDTE) WHILE DTELCTI^=DTEND;
         B     @DE00393                                         05S0393
@DL00393 DS    0H                                               05S0394
*           IF DTERDTEA^=0 THEN                                 05S0394
         L     @15,DTERDTEA(,DITTDIVT)                          05S0394
         LTR   @15,@15                                          05S0394
         BZ    @RF00394                                         05S0394
*             DTERDTEA=DTERDTEA+MLCSKEL;                        05S0395
         AL    @15,MLCSKEL(,MLCAPTR)                            05S0395
         ST    @15,DTERDTEA(,DITTDIVT)                          05S0395
*         END;                                                  05S0396
@RF00394 AH    DITTDIVT,@CH00873                                05S0396
@DE00393 CLI   DTELCTI(DITTDIVT),X'FF'                          05S0396
         BNE   @DL00393                                         05S0396
*       ELSE                                                    05S0397
*         DO;                                                   05S0397
         B     @RC00392                                         05S0397
@RF00392 DS    0H                                               05S0398
*/*********************************************************************
*   NOT A TTV, BUT DITT/DIVT EXISTS, SO MUST BE ID VERIFIED PORT.
*   THE DIVT OFFSETS ARE TO BE CHANGED TO POINTERS IF THIS HAS NOT
*   ALREADY BEEN DONE DURING PROCESSING OF ANOTHER PORT WHICH   05S0398
*   SHARES THESE DIVTS.                                         05S0398
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
*           CTDIVT=DIVNUME;        /* COUNT OF ENTRIES.              */
         LH    CTDIVT,DIVNUME(,DITTDIVT)                        05S0398
*           LENDIVT=DIVIDLEN+(ADDR(DVEBSCAR)-ADDR(ISTDVE));   /*
*                                  ENTRY LENGTH IS MAXIMUM LENGTH OF
*                                  ID + REST OF ENTRY.               */
         LA    LENDIVT,DVEBSCAR(,DITTDIVT)                      05S0399
         SLR   LENDIVT,DITTDIVT                                 05S0399
         AH    LENDIVT,DIVIDLEN(,DITTDIVT)                      05S0399
*           DITTDIVT=DITTDIVT+LENGTH(ISTDIVTH);   /* FIRST ENTRY.    */
         AH    DITTDIVT,@CH00102                                05S0400
*           IF DVEACIND=OFF THEN;                          /*@DL31HCK*/
         TM    DVEACIND(DITTDIVT),B'10000000'                   05S0401
         BZ    @RT00401                                         05S0401
*           ELSE                                                05S0403
*             DO;                  /* CONVERSIONS NOT DONE. DO THEM. */
*               DVEACIND = OFF;           /*NOW TURN IT OFF  @DM12193*/
         NI    DVEACIND(DITTDIVT),B'01111111'                   05S0404
*               DO CTDIVT=CTDIVT BY -1 TO 1;                    05S0405
         B     @DE00405                                         05S0405
@DL00405 DS    0H                                               05S0406
*                 DVERDTEA=DVERDTEA+MLCSKEL;                    05S0406
         L     @00,DVERDTEA(,DITTDIVT)                          05S0406
         AL    @00,MLCSKEL(,MLCAPTR)                            05S0406
         ST    @00,DVERDTEA(,DITTDIVT)                          05S0406
*                 DITTDIVT=DITTDIVT+LENDIVT;                    05S0407
         ALR   DITTDIVT,LENDIVT                                 05S0407
*               END;                                            05S0408
         BCTR  CTDIVT,0                                         05S0408
@DE00405 LTR   CTDIVT,CTDIVT                                    05S0408
         BP    @DL00405                                         05S0408
*             END;                                              05S0409
*         END;                                                  05S0410
@RT00401 DS    0H                                               05S0411
*     END;                                                      05S0411
@RC00392 DS    0H                                               05S0412
*RFY (ISTDTE,ISTDIVTH,ISTDVE);                                  05S0412
@RT00387 DS    0H                                               05S0413
*   IF RPTUTERM^=0 THEN            /* CONVERT UTERM POINTER.         */
         L     @02,RPTUTERM(,RDTEPTR)                           05S0413
         LTR   @02,@02                                          05S0413
         BZ    @RF00413                                         05S0413
*     RPTUTERM=RPTUTERM+MLCSKEL;                                05S0414
         AL    @02,MLCSKEL(,MLCAPTR)                            05S0414
         ST    @02,RPTUTERM(,RDTEPTR)                           05S0414
*     ELSE;                                                /*@D32CKMX*/
@RF00413 DS    0H                                               05S0416
*/*********************************************************************
*   CTERM PROCESSING: INITIALIZE THE SNT ENTRY FOR THE CTERM. ADD THE
*   CTERM NAME TO THE SRT. THIS IS THE LAST PROCESSING THIS TIME
*   THROUGH RDTLOOP, SO IF SRTSUB FAILS, IT WILL BE CHECKED AT THE
*   TOP OF RDTLOOP IMMEDIATELY.                                 05S0416
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
*   CIDSNT=RPTLNCID;               /* CTERM CID                      */
         L     CIDSNT,RPTLNCID(,RDTEPTR)                        05S0416
*   CALL SNTSUB;                                                05S0417
         BAL   @14,SNTSUB                                       05S0417
*   SRTSEC=ON; /* 2ND SRTADD FOR THIS ENTRY                  @ZA30444*/
         OI    SRTSEC,B'01000000'                               05S0418
*RFY (GPR00P,GPR02P) RSTD;                                      05S0419
*   GPR00P=ADDR(RPTCTNM);          /* CTERM NAME                     */
         LA    GPR00P,RPTCTNM(,RDTEPTR)                         05S0420
*   GPR02P=RDTEPTR;                /* RDT ENTRY                      */
         LR    GPR02P,RDTEPTR                                   05S0421
*   CALL SRTSUB;                                                05S0422
         BAL   @14,SRTSUB                                       05S0422
*RFY (GPR00P,GPR02P) UNRSTD;                                    05S0423
*SRTSEC=OFF; /* RESET 2ND SRTADD FOR THIS ENTRY              @ZA30444*/
         NI    SRTSEC,B'10111111'                               05S0424
*/********************************************************************/
*/*          END OF PORTS SUBSEGMENT                                 */
*/********************************************************************/
*             END;                                              04S0425
*         END;                                                  04S0426
*         ELSE IF RPRENTRY = RPRENTDA       /*IS ENTRY A DAN @D32CKMX*/
*              THEN DO;  /*YES. PROCESS PROINTERS ETC.       @D32CKMX*/
         B     @RC00376                                         04S0427
@RF00376 CLI   RPRENTRY(RDTEPTR),X'51'                          04S0427
         BNE   @RF00427                                         04S0427
*                 RPRNSNEA = MLCSKEL;  /*SET NSNEA TO ADDR OF HDR
*                                                            @D32CKMX*/
         MVC   RPRNSNEA(4,RDTEPTR),MLCSKEL(MLCAPTR)             04S0429
*                 MLCPTR1 = RDTEPTR;  /*SET UP SAVE ADDR OF DAN ENTRY
*                                                            @D32CKMX*/
         ST    RDTEPTR,MLCPTR1(,MLCAPTR)                        04S0430
*                   END;                                   /*@D32CKMX*/
*              ELSE DO;                                    /*@D32CKMX*/
         B     @RC00427                                         04S0432
@RF00427 DS    0H                                               04S0433
*                 IF RPRENTRY = RPRENTCC &                      04S0433
*                    RPRHDTYP = RPRENTSW           /*IS ENTRY A PU IN
*                                               SWITCHED SEG @D32CKMX*/
*                    THEN DO;            /*YES. SET PTRS ETC @D32CKMX*/
         CLI   RPRENTRY(RDTEPTR),X'71'                          04S0433
         BNE   @RF00433                                         04S0433
         CLI   RPRHDTYP(RDTEPTR),X'04'                          04S0433
         BNE   @RF00433                                         04S0433
*                       RPRNSNEA = MLCSKEL;   /*SET UP NSNEA TO ADDR
*                                                    RDT HDR @D32CKMX*/
         L     @02,MLCSKEL(,MLCAPTR)                            04S0435
         ST    @02,RPRNSNEA(,RDTEPTR)                           04S0435
*                       IF RCCPATHT ^= 0    /*CHECK FOR PATH TABLE
*                                                            @D32CKMX*/
*                          THEN RCCPATHT = RCCPATHT + MLCSKEL; /*SET
*                                           PATH TABLE  ADDR @D32CKMX*/
         L     @15,RCCPATHT(,RDTEPTR)                           04S0436
         LTR   @15,@15                                          04S0436
         BZ    @RF00436                                         04S0436
         ALR   @15,@02                                          04S0437
         ST    @15,RCCPATHT(,RDTEPTR)                           04S0437
*                            ELSE;          /*NO. DO NOTHING @D32CKMX*/
@RF00436 DS    0H                                               04S0439
*                        SRTSEC=ON; /* 2ND SRTADD FOR THIS ENTRY
*                                                            @ZA30444*/
         OI    SRTSEC,B'01000000'                               04S0439
*                         RFY (GPR00P,GPR02P,GPR15F) RSTD; /*@D32CKMX*/
*                         GPR02P = RDTEPTR; /*POINT TO RDTE  @D32CKMX*/
         LR    GPR02P,RDTEPTR                                   04S0441
*                         GPR00P = ADDR(RCCSTAID); /*POINT TO ENTRY
*                                                       NAME @D32CKMX*/
         LA    GPR00P,RCCSTAID(,RDTEPTR)                        04S0442
*                         CALL SRTSUB;          /*GO ADD SRT @D32CKMX*/
         BAL   @14,SRTSUB                                       04S0443
*                         RFY (GPR00P,GPR02P,GPR15F) UNRSTD;     /*
*                         SRTSEC=OFF; /*RESET 2ND SRTADD FOR    04S0444
*                                       THIS ENTRY           @ZA30444*/
*                           END;                           /*@D32CKMX*/
*                        ELSE                              /*@D32CKMX*/
*                           RPRNSNEA = MLCPTR1; /*SET NSNEA TO POINT TO
*                                                  LINE/DAN  @D32CKMX*/
         B     @RC00433                                         04S0446
@RF00433 MVC   RPRNSNEA(4,RDTEPTR),MLCPTR1(MLCAPTR)             04S0446
*                           IF RPRENTRY = RPRENTPX  /*IS ENTRY PUX?
*                                                            @D32CKMX*/
*                              THEN;  /*YES. BUT NO MORE PROCESSING
*                                                            @D32CKMX*/
@RC00433 CLI   RPRENTRY(RDTEPTR),X'72'                          04S0447
         BE    @RT00447                                         04S0447
*                              ELSE IF RPRENTRY = RPRENTCC /*IS ENTRY
*                                                         PU @D32CKMX*/
*                                      THEN MLCPTR5=RDTEPTR; /*SAVE
*                                              ADDR OF ENTRY @D32CKMX*/
         CLI   RPRENTRY(RDTEPTR),X'71'                          04S0449
         BNE   @RF00449                                         04S0449
         ST    RDTEPTR,MLCPTR5(,MLCAPTR)                        04S0450
*                                      ELSE DO;  /*NO. SET PTR FOR
*                                         CLUSTER AND GPOLL  @D32CKMX*/
         B     @RC00449                                         04S0451
@RF00449 DS    0H                                               04S0452
*                                         MLCPTR2 = RDTEPTR;  /*
*                                                            @D32CKMX*/
         ST    RDTEPTR,MLCPTR2(,MLCAPTR)                        04S0452
*                                         IF RCLGPOLA = 0 /*GPOLL
*                                                 SPECIFIED? @D32CKMX*/
*                                            THEN;  /*NO. DO NOTHING
*                                                            @D32CKMX*/
         ICM   @02,15,RCLGPOLA(RDTEPTR)                         04S0453
         BZ    @RT00453                                         04S0453
*                      ELSE RCLGPOLA = RCLGPOLA + MLCSKEL; /*@D32CKMX*/
         L     @02,RCLGPOLA(,RDTEPTR)                           04S0455
         AL    @02,MLCSKEL(,MLCAPTR)                            04S0455
         ST    @02,RCLGPOLA(,RDTEPTR)                           04S0455
*                                             END;         /*@D32CKMX*/
*                          END;                            /*@D32CKMX*/
*        END;                                              /*@D32CKMX*/
*/********************************************************************/
*/*          END OF APLCLSLN SUBSEGMENT                              */
*/********************************************************************/
*            END;                                               03S0459
*/*********************************************************************
*   DIALSETS, GROUPS AND LOCALS ARE LEFT. SPLIT THEM AND PROCESS.
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
*         ELSE                                                  03S0460
*           DO;                                                 03S0460
         B     @RC00361                                         03S0460
@RF00361 DS    0H                                               03S0461
*             RPRNSNEA=MLCSKEL;    /* NEXT SCHEDUABLE NODE IS RDT.   */
         L     @02,MLCSKEL(,MLCAPTR)                            03S0461
         ST    @02,RPRNSNEA(,RDTEPTR)                           03S0461
*             IF RPRENTRY=RPRENTDS THEN                         03S0462
         CLI   RPRENTRY(RDTEPTR),X'20'                          03S0462
         BNE   @RF00462                                         03S0462
*               DO;                /*        DIALSET                 */
*                 RPRCOMID=0;      /* NOT ADDRESSABLE, NO COMID      */
         SLR   @15,@15                                          03S0464
         ST    @15,RPRCOMID(,RDTEPTR)                           03S0464
*                 IF RDSADDOT^=0 THEN /* CONVERT PTR TO DOTS, IF ANY */
         L     @14,RDSADDOT(,RDTEPTR)                           03S0465
         CR    @14,@15                                          03S0465
         BE    @RF00465                                         03S0465
*                   RDSADDOT=RDSADDOT+MLCSKEL;                  03S0466
         ALR   @14,@02                                          03S0466
         ST    @14,RDSADDOT(,RDTEPTR)                           03S0466
*               END;                                            03S0467
*             ELSE                                              03S0468
*               IF RPRENTRY=RPRENTGP                            03S0468
*                 THEN MLCPTR0=RDTEPTR; /* SAVE ADR THIS GROUP FOR
*                                  NEXT SCHEDUABLE FOR LOWER NODES.  */
         B     @RC00462                                         03S0468
@RF00462 CLI   RPRENTRY(RDTEPTR),X'30'                          03S0468
         BNE   @RF00468                                         03S0468
         ST    RDTEPTR,MLCPTR0(,MLCAPTR)                        03S0469
*               ELSE                                            03S0470
*                 DO;              /* FOR LOCAL, SAVE ENTRY ADR AS
*                                  NEXT SCHEDUABLE IF TERM IS CLUSTER
*                                  TYPE. ALSO, INITIALIZE SNT ENTRY. */
         B     @RC00468                                         03S0470
@RF00468 DS    0H                                               03S0471
*                   MLCPTR2=RDTEPTR;                            03S0471
         ST    RDTEPTR,MLCPTR2(,MLCAPTR)                        03S0471
*                   CIDSNT=RPRCOMID;                            03S0472
         L     CIDSNT,RPRCOMID(,RDTEPTR)                        03S0472
*                   CALL SNTSUB;                                03S0473
         BAL   @14,SNTSUB                                       03S0473
*                 END;                                          03S0474
*           END;                                                03S0475
@RC00468 DS    0H                                               03S0475
@RC00462 DS    0H                                               03S0476
*   END;                           /* END OF LOOP                    */
@RC00361 DS    0H                                               03S0476
@RC00310 DS    0H                                               03S0476
@RC00306 DS    0H                                               03S0476
@DE00297 TM    RPRENTED(RDTEPTR),B'00000100'                    03S0476
         BNZ   @DC00297                                         03S0476
         LTR   TPMSGID,TPMSGID                                  03S0476
         BZ    @DL00297                                         03S0476
@DC00297 DS    0H                                               03S0477
*RFY (ISTRPRE, ISTRCPRE, ISTRAP, ISTRLC, ISTRRN, ISTRGP, ISTRLN,
*  ISTRPT, ISTRCL, ISTRTR, ISTRIN, ISTRDS, ISTRCC, ISTRLU,      03S0477
*  ISTRPX, ISTRLX, ISTRDA, ISTRSW, ISTDEVCH); /*RETURN ABOVE ITEMS TO
*                                             ORIGINAL STATE @D32CKMX*/
*/********************************************************************/
*/*          END OF RDTLOOP SEGMENT                                  */
*/********************************************************************/
*       IF TPMSGID^=0              /* QUIT IF RDTLOOP SET ERR MSG    */
*         THEN CALL ERRSUB1;                                    02S0478
         LTR   TPMSGID,TPMSGID                                  02S0478
         BZ    @RF00478                                         02S0478
         BAL   @14,ERRSUB1                                      02S0479
*       ELSE                                                    02S0480
*/* ADD BHSET NAMES TO SRT FOR 370X SEGMENT.                         */
*         DO;                                                   02S0480
         B     @RC00478                                         02S0480
@RF00478 DS    0H                                               02S0481
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME: BHSETSRT                                           */
*/*                                                                  */
*/* FUNCTION: CALLS STRADD OT BHSET NAMES TO THE SRT FOR 370X SEGMENT*/
*/* THE BHSET NAME IS ASSOCIATED WITH THE 370X ENTRY NAME AND THE BH */
*/* ID. WHETHER OR NOT ANY BHSETS EXIST, THE PLACE HOLDING NAME      */
*/* ISTNULL WITH BH ID OF 0 IS ADDED FOR THIS 370X SEGMENT.          */
*/*                                                                  */
*/* INPUT: MLCSKEL - RDT ADDRESS                                     */
*/*                                                                  */
*/* OUTPUT: TPMSGID - ADDR OF TERMINATING ERROR MESSAGE ID, IF ANY   */
*/*                                                                  */
*/* ROUTINE CALLED: SRTADD (ISTOCCSA) - ADD NAMES TO SRT             */
*/*                                                                  */
*/* MACROS USED: NONE                                                */
*/*                                                                  */
*/********************************************************************/
*RFY (GPR00P,RPHPTR,GPR02P,GPR03P) RSTD;                        03S0481
*RFY (ISTRRN) BASED(GPR02P);                                    03S0482
*RFY ISTBHSAT BASED(BHSEPTR);                                   03S0483
*   GPR02P=MLCSKEL | SRTBHFLG;     /* FOR BHSETS, SRTADD NEEDS 370X
*                                  NAME AND HIGH ORDER BIT ON.       */
         L     @10,MLCSKEL(,MLCAPTR)                            03S0484
         LR    GPR02P,@10                                       03S0484
         O     GPR02P,@CF00836                                  03S0484
*   IF RDTPRIRN=OFF THEN;          /* PROCEED ONLY FOR 370X RDT.     */
         TM    RDTPRIRN(@10),B'00000100'                        03S0485
         BZ    @RT00485                                         03S0485
*   ELSE                                                        03S0487
*     DO;                                                       03S0487
*       BHSATC=GPR03P;             /* SAVE VTAM CVT ADDRESS.         */
         ST    GPR03P,BHSATC                                    03S0488
*       GPR00P=ADDR(ISTNULL);      /* FIRST ENTRY ISTNULL WITH ID=0. */
         LA    GPR00P,ISTNULL                                   03S0489
*       GPR03P=0;                                               03S0490
         SLR   GPR03P,GPR03P                                    03S0490
*       RPHPTR=MLCRPH;                                          03S0491
         L     RPHPTR,MLCRPH(,MLCAPTR)                          03S0491
*RFY GPR15F RSTD;                                               03S0492
*       GPR15P=BHSATC->ATCSRTAD;   /* GET SRTADD (ISTOCCSA) ADDRESS. */
         L     @10,BHSATC                                       03S0493
         L     GPR15P,ATCSRTAD(,@10)                            03S0493
*       CALL SRTADDBH;                                          03S0494
         BALR  @14,@15                                          03S0494
*       IF GPR15F^=0 THEN          /* SRTADD FAILURE CAUSES OURS.    */
         LTR   GPR15F,GPR15F                                    03S0495
         BZ    @RF00495                                         03S0495
*         TPMSGID=ADDR(MSG303I);                                03S0496
         LA    TPMSGID,MSG303I                                  03S0496
*       ELSE                                                    03S0497
*         DO;                                                   03S0497
         B     @RC00495                                         03S0497
@RF00495 DS    0H                                               03S0498
*RFY GPR15F UNRSTD;                                             03S0498
*/*********************************************************************
*   FOR THIS LOOP, BHSEPTR HAS THE ADDRESS OF THE CURRENT ENTRY AND
*   CTBHS IS THE NUMBER OF ENTRIES REMAINING INCLUDING THE CURRENT
*   ONE. IN THE EVENT OF ERROR, CTBHS IS MODIFIED TO SUGGEST THAT
*   THE CURRENT ENTRY IS LAST. BHSET NAMES ARE ADDED TO THE SRT.
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
*           BHSEPTR=RRNBHSET;                                   03S0499
         L     BHSEPTR,RRNBHSET(,GPR02P)                        03S0499
*           DO CTBHS=RRNCTBHS BY -1 TO 1;                       03S0500
         LH    @15,RRNCTBHS(,GPR02P)                            03S0500
         ST    @15,CTBHS                                        03S0500
         B     @DE00500                                         03S0500
@DL00500 DS    0H                                               03S0501
*             GPR00P=BHSEPTR;      /* SUPPLY BHSET NAME AND ID       */
         LR    GPR00P,BHSEPTR                                   03S0501
*             GPR03P=BHSINDEX;                                  03S0502
         SLR   GPR03P,GPR03P                                    03S0502
         IC    GPR03P,BHSINDEX(,BHSEPTR)                        03S0502
*RFY GPR15F RSTD;                                               03S0503
*             GPR15P=BHSATC->ATCSRTAD;                          03S0504
         L     @14,BHSATC                                       03S0504
         L     GPR15P,ATCSRTAD(,@14)                            03S0504
*             CALL SRTADDBH;       /* ADD BHSET NAME.                */
         BALR  @14,@15                                          03S0505
*             IF GPR15F=0 THEN                             /*@XA12166*/
         LTR   GPR15F,GPR15F                                    03S0506
         BNZ   @RF00506                                         03S0506
*             BHSEPTR=BHSEPTR+LENGTH(ISTBHSAT);   /* NEXT    @XA12166*/
         AH    BHSEPTR,@CH02275                                 03S0507
*             ELSE                 /* SRTADD FAILURE - STOP WORK.    */
*               DO;                                             03S0508
         B     @RC00506                                         03S0508
@RF00506 DS    0H                                               03S0509
*                 IF GPR15F=4 THEN                         /*@XA12166*/
         CH    GPR15F,@CH00096                                  03S0509
         BNE   @RF00509                                         03S0509
*                   DO;                                    /*@XA12166*/
*                     TPMSGID=ADDR(MSG333I);               /*@XA12166*/
         LA    TPMSGID,MSG333I                                  03S0511
*                     SRTERRCD='3';                        /*@XA12166*/
         MVI   SRTERRCD(MLCAPTR),C'3'                           03S0512
*                     SRTERRNM=BHSNAME;                    /*@XA12166*/
         MVC   SRTERRNM(8,MLCAPTR),BHSNAME(BHSEPTR)             03S0513
*                   END;                                   /*@XA12166*/
*                   ELSE                                   /*@XA12166*/
*                   TPMSGID=ADDR(MSG303I);                      03S0515
         B     @RC00509                                         03S0515
@RF00509 LA    TPMSGID,MSG303I                                  03S0515
*                 CTBHS=1;                                      03S0516
@RC00509 MVC   CTBHS(4),@CF00104                                03S0516
*               END;                                            03S0517
*RFY GPR15F UNRSTD;                                             03S0518
@RC00506 DS    0H                                               03S0519
*           END;                   /* LOOP END.                      */
         SLR   @15,@15                                          03S0519
         BCTR  @15,0                                            03S0519
         AL    @15,CTBHS                                        03S0519
         ST    @15,CTBHS                                        03S0519
@DE00500 LTR   @15,@15                                          03S0519
         BP    @DL00500                                         03S0519
*         END;                                                  03S0520
*         GPR03P=BHSATC;           /* RESTORE VTAM CVT PTR.          */
@RC00495 L     GPR03P,BHSATC                                    03S0521
*     END;                                                      03S0522
*RFY (GPR00P,RPHPTR,GPR02P,GPR03P) UNRSTD;                      03S0523
@RT00485 DS    0H                                               03S0524
*RFY (ISTRRN,ISTBHSAT);                                         03S0524
*/********************************************************************/
*/*          END OF BHSETSRT SEGMENT                                 */
*/********************************************************************/
*           IF TPMSGID^=0          /* QUIT IF BHSETSRT SET ERR MSG   */
*             THEN CALL ERRSUB1;                                02S0525
         LTR   TPMSGID,TPMSGID                                  02S0525
         BZ    @RF00525                                         02S0525
         BAL   @14,ERRSUB1                                      02S0526
*           ELSE                                                02S0527
*                 DO;                                           02S0527
         B     @RC00525                                         02S0527
@RF00525 DS    0H                                               02S0528
*/* QUEUE THIS SEGMENT TO RDT CHAIN.                                 */
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT NAME: ADDRDT                                             */
*/*                                                                  */
*/* FUNCTION: ADDS THE RDT SEGMENT TO THE RDT QUEUE                  */
*/*                                                                  */
*/* INPUT: ATCRDT - ADDRESS OF RDT QUEUE ANCHOR BLOCK                */
*/*        MLCSKEL - ADDRESS OF RDT SEGMENT BEING PROCESSED          */
*/*                                                                  */
*/* OUTPUT: RDT SEGMENT QUEUED TO RDT QAB                            */
*/*                                                                  */
*/* ROUTINES CALLED: NONE                                            */
*/*                                                                  */
*/* MACRO USED: ADD                                                  */
*/*                                                                  */
*/********************************************************************/
*                                                               03S0528
*/* ADD QAB(ATCRDT)CBAD(MLCSKEL)*/                              03S0528
*DCL CMZR0047 REG(1);                                           03S0528
*DCL CMZF0047 PTR;                                              03S0529
*DO;                                                            03S0530
*DCL CMZA0047 (2) PTR;                                          03S0531
*     CMZA0047(1)=ATCRDT;                                       03S0532
         MVC   CMZA0047(4),ATCRDT(ATCVTPTR)                     03S0532
*     CMZA0047(2)=MLCSKEL;                                      03S0533
         MVC   CMZA0047+4(4),MLCSKEL(MLCAPTR)                   03S0533
*DCL ISTRACCA LABEL BASED;                                      03S0534
*     RFY CMZR0047 RSTD;                                        03S0535
*     CMZR0047=ADDR(CMZA0047(1));                               03S0536
         LA    CMZR0047,CMZA0047                                03S0536
*/*PUT ARG LIST ADDR IN REG 1, CALL ADD PROC*/                  03S0537
*                                                               03S0537
*                    DO; /* LISATCVT CVTBASE(PAGEABLE,(CMZF0047)) */
*                      CMZF0047 = ATCLCPTR; /*SET UP ATCVT POINTER*/
         L     CMZF0047,ATCLCPTR                                03S0538
*                    END; /*LISATCVT*/                          03S0539
*     CALL CMZF0047->ATCADD->ISTRACCA;                          03S0540
         L     @15,ATCADD(,CMZF0047)                            03S0540
         BALR  @14,@15                                          03S0540
*     RFY CMZR0047 UNRSTD;                                      03S0541
*END;                                                           03S0542
*/* END OF ADD MACRO EXPANSION */                               03S0543
*/********************************************************************/
*/*          END OF ADDRDT SEGMENT                                   */
*/********************************************************************/
*/* CLEAR MNT LOCK PRIORITY FOR 370X/LOCAL SEGMENT.                  */
*                   IF RDTPRIAP=ON /* IF NOT APPL SEGMENT, MUST BE
*                                  370X OR LOCAL, TURN OFF LOCK.     */
*                     THEN;                                     02S0543
         L     @02,MLCSKEL(,MLCAPTR)                            02S0543
         TM    RDTPRIAP(@02),B'00010000'                        02S0543
         BO    @RT00543                                         02S0543
*                   ELSE ADDR(MNTLOCK)->LOKPRY=OFF;             02S0545
         L     @02,MNTEPTR                                      02S0545
         NI    LOKPRY+4(@02),B'11111101'                        02S0545
*RFY GPR15F RSTD;                                               02S0546
@RT00543 DS    0H                                               02S0547
*                   GPR15F=0;      /* SET GOOD RETURN CODE           */
         SLR   GPR15F,GPR15F                                    02S0547
*                 END;                                          02S0548
*         END;                                                  02S0549
@RC00525 DS    0H                                               02S0550
*     END;                                                      02S0550
@RC00478 DS    0H                                               02S0551
*   END;             /*END THE 'ELSE DO' AFTER CKSUB SEGMENT @DM11636*/
@RC00202 DS    0H                                               02S0552
*   SAVREG=ADDR(SAVIN);                                         02S0552
@RC00128 L     SAVREG,SVBACKWD(,MLCAPTR)                        02S0552
*   RETURN CODE(GPR15F);                                        02S0553
         L     @14,12(,@13)                                     02S0553
         LM    @00,@12,20(@13)                                  02S0553
         BR    @14                                              02S0553
*RFY GPR15F UNRSTD;                                             02S0554
*/********************************************************************/
*/*                                                                  */
*/* ROUTINE NAME: SNTSUB                                             */
*/*                                                                  */
*/* FUNCTION: CALLED BY RDTLOOP TO INITIALIZE AN SNT ENTRY FOR A     */
*/*           PARTICULAR CID. THE DAF IS USED TO INDEX TO THE ENTRY, */
*/*           THE RDT ENTRY ADDRESS IS INSERTED, AND THE LOCKWORD IS */
*/*           CLEARED, EXCEPT THE PRIORITY BIT WHICH IS LEFT ON.     */
*/*           THE DUMMY ENTRY FLAG IS SET FOR AN LUX OR PUX.         */
*/*                                                                  */
*/* INPUT: MNTSNT - ADDRESS OF SNT                                   */
*/*        COMPCIDM - COMPLEMENT OF ATCCIDM                          */
*/*        CIDSNT - CID TO BE USED                                   */
*/*        RDTEPTR - ADDRESS OF RDT ENTRY                            */
*/*                                                                  */
*/* OUTPUT: INITIALIZED SNT ENTRY                                    */
*/*                                                                  */
*/* ROUTINES CALLED: NONE                                            */
*/*                                                                  */
*/* MACROS USED: NONE                                                */
*/*                                                                  */
*/********************************************************************/
*SNTSUB: PROC OPTIONS(NOSAVE,NOSAVEAREA);                       02S0555
SNTSUB   DS    0H                                               02S0556
*DCL SNTEPTR PTR;                                               02S0556
*RFY ISTRPRE BASED(RDTEPTR);                               /*@X50CKZA*/
*RFY GPR14P RSTD;                                               02S0558
*RFY ISTSNT BASED(SNTEPTR);                                     02S0559
*   SNTEPTR=(CIDSNT&COMPCIDM)*LENGTH(SNTENTRY)+MNTSNT;   /* REMOVE
*                                  MAJOR NODEID FROM CID, INDEX INTO
*                                  SNT. HEADER IS COVER BY BASING.   */
         LR    SNTEPTR,CIDSNT                                   02S0560
         N     SNTEPTR,COMPCIDM                                 02S0560
         SLA   SNTEPTR,3                                        02S0560
         L     @15,MNTEPTR                                      02S0560
         AL    SNTEPTR,MNTSNT(,@15)                             02S0560
*   SNTRDTFG = ON;                  /*TURN ON HIGH ORDER BIT @DM12404*/
         OI    SNTRDTFG(SNTEPTR),B'10000000'                    02S0561
*   SNTCBPTR=RDTEPTR;                                      /*@D31JKMQ*/
         STCM  RDTEPTR,7,SNTCBPTR(SNTEPTR)                      02S0562
*   SNTLOCK=LOKPRY1;               /* CLEAR LOCK LEAVING LOKPRY ON   */
         MVC   SNTLOCK(4,SNTEPTR),@CB01665                      02S0563
*IF RPRENTRY = RPRENTPX |  /* IS THIS AN LUX OR PUX          @X50CKZA*/
*   RPRENTRY = RPRENTLX                                    /*@X50CKZA*/
*  THEN SNTDUMFG = '1'B;  /* YES  SET DUMMY ENTRY FLAG       @X50CKZA*/
         CLI   RPRENTRY(RDTEPTR),X'72'                          02S0564
         BE    @RT00564                                         02S0564
         CLI   RPRENTRY(RDTEPTR),X'10'                          02S0564
         BNE   @RF00564                                         02S0564
@RT00564 DS    0H                                               02S0565
         OI    SNTDUMFG(SNTEPTR),B'00100000'                    02S0565
*  ELSE;                                                        02S0566
@RF00564 DS    0H                                               02S0567
*RFY GPR14P UNRSTD;                                             02S0567
*RFY ISTSNT;                                                    02S0568
*END SNTSUB;                                                    02S0569
@EL00002 DS    0H                                               02S0569
@EF00002 DS    0H                                               02S0569
@ER00002 BR    @14                                              02S0569
*/********************************************************************/
*/*                                                                  */
*/* ROUTINE NAME: SRTSUB                                             */
*/*                                                                  */
*/* FUNCTION: CALLED BY RDTLOOP TO ADD A NAME TO THE SRT. ANALYZES   */
*/*           RETURN CODE FROM SRTADD AND TAKES ERROR ACTIONS.       */
*/*           IF A NODE NAME (EXCEPT GROUP AND LINE) IS A DUPLICATE, */
*/*           THE NODE IS IGNORED AND ITS TYPE IS SAVED SO ALL NODES */
*/*           BELOW IT CAN BE IGNORED. (FOR EXAMPLE, IF A CLUSTER IS */
*/*           A DUPLICATE, ALL TERMS, ETC., ARE SKIPPED UNTIL A      */
*/*           GROUP OR A LINE OR ANOTHER CLUSTER IS ENCOUNTERED.     */
*/*           ANY OTHER ERROR RETURN FROM SRTADD, AS WELL AS A       */
*/*           DUPLICATE GROUP OR LINE NAME, IS UNRECOVERABLE.        */
*/*                                                                  */
*/*           NOTE: BHSET NAMES PROCESSED BY BHSETSRT, NOT SRTSUB.   */
*/*                                                                  */
*/* INPUT: REG 0 - ADDRESS OF SYMBOLIC NAME                          */
*/*        REG 2 - ADDRESS OF RDT ENTRY                              */
*/*        ERNODTYP - ENTRY TYPE OF FAILING NODE. IF THIS ENTRY IS   */
*/*                   GREATER, IT WILL NOT BE PROCESSED. OTHERWISE,  */
*/*                   NODE WILL BE PROCESSED AND ERNODTYP SET TO     */
*/*                   INITIAL SETTING OF 255. (ORIGINALLY SET BEFORE */
*/*                   FIRST ENTRY IN RDTLOOP INITIALIZATION.)        */
*/*                                                                  */
*/* OUTPUT: REG 15 - RETURN CODE FROM SRTADD - ZERO/NON-ZERO         */
*/*         TPMSGID - ADDR OF TERMINATING ERROR MESSAGE ID, IF ANY   */
*/*         ERNODTYP - SEE INPUT                                     */
*/*         RPRNOSRT - OFF FOR SUCCESSFUL SRTADD                     */
*/*         RPRINV - ON FOR NODE SKIPPED FOR DUPLICATE NAME          */
*/*                                                                  */
*/* ROUTINES CALLED: SRTADD (ISTOCCSA) - ADD NAMES TO SRT            */
*/*                                                                  */
*/* MACROS USED: TPMSG                                               */
*/*                                                                  */
*/********************************************************************/
*SRTSUB: PROC OPTIONS(NOSAVE,NOSAVEAREA);                       02S0570
SRTSUB   DS    0H                                               02S0571
*DCL SRTSAV PTR;                   /* TO SAVE RETURN ADDRESS         */
*RFY (GPR00P,GPR02P,GPR14P,GPR15F) RSTD;                        02S0572
*RFY ISTRPRE BASED(GPR02P);                                     02S0573
*RFY ISTRCC  BASED(GPR02P);                                /*@DM13842*/
*RFY ISTNCSPL BASED(MLCNCSPL);                             /*@D32CKZA*/
*   SRTSAV=GPR14P;                                              02S0576
         ST    GPR14P,SRTSAV                                    02S0576
*   IF RPRENTRY>ERNODTYP THEN      /* CHECK IF THIS NODE IS BELOW
*                                  AN ERROR NODE.                    */
         CLC   RPRENTRY(1,GPR02P),ERNODTYP                      02S0577
         BNH   @RF00577                                         02S0577
*     DO;                          /* ERROR. SET NODE INVALID, BUT
*                                  GIVE RETURN CODE TO CONTINUE.     */
*       RPRINV=ON;                                              02S0579
         OI    RPRINV(GPR02P),B'01000000'                       02S0579
*       GPR15F=0;                                               02S0580
         SLR   GPR15F,GPR15F                                    02S0580
*     END;                                                      02S0581
*   ELSE                           /* NO BAD UPPER NODE. ADD NAME.   */
*     DO;                                                       02S0582
         B     @RC00577                                         02S0582
@RF00577 DS    0H                                               02S0583
*       IF RPRINV = ON  /*TEST RDTE ALREADY INVALID          @ZA11978*/
*          THEN GPR15F = 0; /*YES INVALID SKIP SRT ADD PROCSS@ZA11978*/
         TM    RPRINV(GPR02P),B'01000000'                       02S0583
         BNO   @RF00583                                         02S0583
         SLR   GPR15F,GPR15F                                    02S0584
*          ELSE DO;  /*RDTE OK CONTINUE PROCESSING SRTADD    @ZA11978*/
         B     @RC00583                                         02S0585
@RF00583 DS    0H                                               02S0586
*RFY RPHPTR RSTD;                                               02S0586
*       IF RPRNAME = '0000000000000000'X                   /*@D32CKQH*/
*         THEN DO;                                         /*D32CKQH*/
         CLC   RPRNAME(8,GPR02P),@CB01070                       02S0587
         BNE   @RF00587                                         02S0587
*           ATCNMCTR = ATCNMCTR + 1;   /*INCREMENT NAME CNTR @D32CKQH*/
         LA    @09,1                                            02S0589
         AH    @09,ATCNMCTR(,ATCVTPTR)                          02S0589
         STH   @09,ATCNMCTR(,ATCVTPTR)                          02S0589
*           RPRNAME(1:2)=ATCNMCTR;     /*AND USE IT FOR NAME @D32CKQH*/
         STH   @09,RPRNAME(,GPR02P)                             02S0590
*         END;                                             /*@D32CKQH*/
*         ELSE;                                            /*@D32CKQH*/
@RF00587 DS    0H                                               02S0593
*       RPHPTR=MLCRPH;                                          02S0593
         L     RPHPTR,MLCRPH(,MLCAPTR)                          02S0593
*       GPR15P=ATCSRTAD;                                        02S0594
         L     GPR15P,ATCSRTAD(,ATCVTPTR)                       02S0594
*       CALL SRTADD;                                            02S0595
         BALR  @14,@15                                          02S0595
*RFY RPHPTR UNRSTD;                                             02S0596
*       IF GPR15F=0 THEN          /* ADD SUCCESSFUL. SET ERROR NODE
*                                  TYPE TO ALLOW ALL NODES. SHOW SRT
*                                  OK FOR THIS ENTRY.                */
         LTR   GPR15F,GPR15F                                    02S0597
         BNZ   @RF00597                                         02S0597
*         DO;                                                   02S0598
*           ERNODTYP=ERNODMAX;                                  02S0599
         MVI   ERNODTYP,X'FF'                                   02S0599
*           RPRNOSRT=OFF;                                       02S0600
         NI    RPRNOSRT(GPR02P),B'01111111'                     02S0600
*         END;                                                  02S0601
*       ELSE DO;      /* ADD UNSUCCESSFUL- RC>4 IS LACK OF SPACE
*                               UNRECOVERABLE ERROR          @ZA30444*/
         B     @RC00597                                         02S0602
@RF00597 DS    0H                                               02S0603
*         IF GPR15F>4 THEN                                      02S0603
         CH    GPR15F,@CH00096                                  02S0603
         BNH   @RF00603                                         02S0603
*           TPMSGID=ADDR(MSG303I);                              02S0604
         LA    TPMSGID,MSG303I                                  02S0604
*         ELSE                     /* RC=4, DUPLICATE NAME. PREPARE
*                                  MESSAGE TEXT IN MLCA.             */
*           DO;                                                 02S0605
         B     @RC00603                                         02S0605
@RF00603 DS    0H                                               02S0606
*             IF RPRENTRY = RPRENTCC & GPR00P=ADDR(RCCSTAID)    02S0606
*               THEN SRTERRNM = 'STAT.ID.';               /*@DM13842*/
         CLI   RPRENTRY(GPR02P),X'71'                           02S0606
         BNE   @RF00606                                         02S0606
         LA    @11,RCCSTAID(,GPR02P)                            02S0606
         CR    GPR00P,@11                                       02S0606
         BNE   @RF00606                                         02S0606
         MVC   SRTERRNM(8,MLCAPTR),@CC01074                     02S0607
*               ELSE SRTERRNM = GPR00P->RPRNAME;          /*@DM13842*/
         B     @RC00606                                         02S0608
@RF00606 LR    @11,GPR00P                                       02S0608
         MVC   SRTERRNM(8,MLCAPTR),RPRNAME(@11)                 02S0608
*             TPMSGID=ADDR(MSG333I);                            02S0609
@RC00606 LA    TPMSGID,MSG333I                                  02S0609
*             IF RPRENTRY=RPRENTGP /* DUPLICATE NAME ON GROUP/LINE   */
*              | RPRENTRY=RPRENTLN /*   IS LOST CAUSE. SET MESSAGE   */
*               THEN SRTERRCD='2'; /*   INSERT, LEAVE NON-ZERO RC.   */
         CLI   RPRENTRY(GPR02P),X'30'                           02S0610
         BE    @RT00610                                         02S0610
         CLI   RPRENTRY(GPR02P),X'50'                           02S0610
         BNE   @RF00610                                         02S0610
@RT00610 DS    0H                                               02S0611
         MVI   SRTERRCD(MLCAPTR),C'2'                           02S0611
*             ELSE                 /* OTHER DUPLICATE NODE NAMES ARE
*                                  OK BUT MUST BE IGNORED WITH MSG.  */
*               DO;                                             02S0612
         B     @RC00610                                         02S0612
@RF00610 DS    0H                                               02S0613
*                 RPRINV=ON;                                    02S0613
         OI    RPRINV(GPR02P),B'01000000'                       02S0613
*                 SRTERRCD='1';                                 02S0614
*                                                               02S0614
         MVI   SRTERRCD(MLCAPTR),C'1'                           02S0614
*/*TPMSG MSGID((TPMSGID))MSG((ADDR(MLCERBF1)))PLAREA(MLCTPMSG)OPTIONS(N
*SPLSID)*/                                                      02S0615
*                                                               02S0615
*  DO;                                                          02S0615
*    DCL REG1053  REG(1)  PTR;                                  02S0616
*    RFY (REG1053) RSTD;                                        02S0617
*                                                               02S0617
*  RFY (EMCR13) RSTD;                                           02S0618
*    DCL 1 * BASED(REG1053),                                    02S0619
*        2 CMZID053 PTR(31),                                    02S0619
*        2 *,                                                   02S0619
*          3 CMZRL053 PTR(8),                                   02S0619
*          3 CMZRA053 PTR(24) BDY(BYTE),                        02S0619
*        2 CMZEA053 PTR(31),                                    02S0619
*        2 CMZVP053 PTR(31);                                    02S0619
*                                                               02S0619
*/*XREGSET  PID('PLAREA')PPARM(MLCTPMSG)RREG(,REG1053)*/        02S0620
*  DO;                                                          02S0620
*    REG1053=ADDR(MLCTPMSG);             /*SET RREG SYMBOL TO ADDRESS*/
         LA    REG1053,MLCTPMSG(,MLCAPTR)                       02S0621
*                                        /*OF PPARM OPERAND          */
*  END;  /* XREGSET */                                          02S0622
*    CMZID053 = 0;                                              02S0623
         SLR   @09,@09                                          02S0623
         ST    @09,CMZID053(,REG1053)                           02S0623
*    CMZRL053 = 0;                                              02S0624
         MVI   CMZRL053(REG1053),X'00'                          02S0624
*    CMZRA053 = 0;                                              02S0625
         STCM  @09,7,CMZRA053(REG1053)                          02S0625
*    CMZEA053 = 0;                                              02S0626
         ST    @09,CMZEA053(,REG1053)                           02S0626
*    CMZVP053 = 0;                                              02S0627
         ST    @09,CMZVP053(,REG1053)                           02S0627
*    CMZID053=TPMSGID;                                          02S0628
         ST    TPMSGID,CMZID053(,REG1053)                       02S0628
*    CMZVP053 = ADDR(MLCERBF1);                                 02S0629
         LA    @11,MLCERBF1(,MLCAPTR)                           02S0629
         ST    @11,CMZVP053(,REG1053)                           02S0629
*    DCL CMZSA053 (18) PTR(31) BASED(EMCR13);                   02S0630
*    CMZSA053(5) = ADDR(NCSPLSID);                              02S0631
*                                                               02S0631
         L     @11,MLCNCSPL(,MLCAPTR)                           02S0631
         LA    @11,NCSPLSID(,@11)                               02S0631
         ST    @11,CMZSA053+16(,EMCR13)                         02S0631
*    DCL REG15053 REG(15) PTR;                                  02S0632
*    RFY REG15053 RSTD;                                         02S0633
*                                                               02S0633
*  DO; /* LISATCVT CVTBASE(PAGEABLE,(REG15053)) */              02S0634
*    REG15053 = ATCLCPTR; /*SET UP ATCVT POINTER*/              02S0635
         L     REG15053,ATCLCPTR                                02S0635
*  END; /*LISATCVT*/                                            02S0636
*    DCL CMTA053 BASED(REG15053) ENTRY VALUERANGE(*);           02S0637
*    REG15053 = REG15053->ATCMSGP;                              02S0638
         L     REG15053,ATCMSGP(,REG15053)                      02S0638
*    CALL CMTA053;                                              02S0639
         BALR  @14,@15                                          02S0639
*    RESPECIFY (REG1053,REG15053)  UNRESTRICTED;                02S0640
*                                                               02S0640
*  RFY (EMCR13) UNRSTD;                                         02S0641
*  END;                   /*@D32CKQH*/                          02S0642
*                 GPR15F=0;        /* PREPARE TO IGNORE LOWER NODES. */
         SLR   @09,@09                                          02S0643
         LR    GPR15F,@09                                       02S0643
*                 TPMSGID=0;                                    02S0644
         LR    TPMSGID,@09                                      02S0644
*                 ERNODTYP=RPRENTRY;                            02S0645
         MVC   ERNODTYP(1),RPRENTRY(GPR02P)                     02S0645
*               END;                                            02S0646
*           END;                                                02S0647
@RC00610 DS    0H                                               02S0648
*           IF GPR15F<=4 /* NOT A KILLBLD SITUATION AND      @ZA30444*/
*            & SRTSEC=ON THEN /* 2ND NAME BEING ADDED FOR THIS  02S0648
*                           RDTE FAILED---BACK OUT 1ST       @ZA30444*/
@RC00603 CH    GPR15F,@CH00096                                  02S0648
         BH    @RF00648                                         02S0648
         TM    SRTSEC,B'01000000'                               02S0648
         BNO   @RF00648                                         02S0648
*               DO; /*                                       @ZA30444*/
*                GPR00P=RDTEPTR&'7FFFFFFF'X; /*POINT AT NAME    02S0650
*                       TO DELETE,PLUS CLEAR HI BIT          @ZA30444*/
         LR    GPR00P,RDTEPTR                                   02S0650
         N     GPR00P,@CF01087                                  02S0650
*                GPR01P=MLCRPH; /* SETUP RPH FOR INTERFACE WITH 02S0651
*                                 SRT ENTRY DELETE ROUTINE   @ZA30444*/
         L     GPR01P,MLCRPH(,MLCAPTR)                          02S0651
*                RFY GPR00P UNRSTD; /*                       @ZA30444*/
*                CALL ISTOCCDF; /*                           @ZA30444*/
         L     @15,ATCSRTDF(,ATCVTPTR)                          02S0653
         BALR  @14,@15                                          02S0653
*                GPR15F=0; /* IND PROCESSING SHOULD CONT     @ZA30444*/
         SLR   GPR15F,GPR15F                                    02S0654
*                RPRNOSRT=ON; /*INDICATE NO SRTE             @ZA30444*/
         OI    RPRNOSRT(GPR02P),B'10000000'                     02S0655
*                RPRINV=ON; /* INVALIDATE RDTE               @ZA30444*/
         OI    RPRINV(GPR02P),B'01000000'                       02S0656
*                END; /*                                     @ZA30444*/
*          END; /*END OF TEST FOR INVALID RDTE TO SKIP SRTADD@ZA11978*/
@RF00648 DS    0H                                               02S0659
*     END;                                                      02S0659
@RC00597 DS    0H                                               02S0660
*    END;                                                  /*@ZA30444*/
@RC00583 DS    0H                                               02S0661
*   GPR14P=SRTSAV;                                              02S0661
@RC00577 L     GPR14P,SRTSAV                                    02S0661
*RFY (GPR00P,GPR02P,GPR14P,GPR15F) UNRSTD;                      02S0662
*RFY ISTRPRE;                                                   02S0663
*END SRTSUB;                                                    02S0664
@EL00003 DS    0H                                               02S0664
@EF00003 DS    0H                                               02S0664
@ER00003 BR    @14                                              02S0664
*/********************************************************************/
*/*                                                                  */
*/* ROUTINE NAME: ERRSUB1                                            */
*/*                                                                  */
*/* FUNCTION: CALLED BY MAINLINE AFTER AN UNRECOVERABLE ERROR WHILE  */
*/*             (1)SPACE FOR THE SNT HAS BEEN OBTAINED.              */
*/*             (2)THE VOCLOCK IS BEING HELD.                        */
*/*             (3)ENTRIES MAY HAVE BEEN MADE TO THE SRT.            */
*/*           ERRSUB1 UNDOES THESE CONDITIONS BY CALLING THE MACROS  */
*/*           AND ROUTINES BELOW.                                    */
*/*                                                                  */
*/* INPUT: TPMSGID - ADDR OF ADDR OF ID OF MESSAGE TO BE ISSUED      */
*/*                                                                  */
*/* OUTPUT: RETURN CODE PASSED FROM ERRSUB2                          */
*/*                                                                  */
*/* ROUTINES CALLED: ISTSDCD1 - REMOVE ANY SRT ENTRIES               */
*/*                  ISTSDCD2 - DELETE THE SNT                       */
*/*                  ERRSUB2 - DO ERROR PROCESSING WHICH IS          */
*/*                            INDEPENDENT OF WHEN ERROR OCCURRED    */
*/*                                                                  */
*/* MACRO USED: TPUNLOCK - RELEASE THE VOCLOCK                       */
*/*                                                                  */
*/********************************************************************/
*ERRSUB1: PROC OPTIONS(NOSAVE,NOSAVEAREA);                      02S0665
ERRSUB1  DS    0H                                               02S0666
*DCL ERRSAV1 PTR;                  /* TO SAVE RETURN ADDRESS         */
*RFY (RPHPTR,ATCVTPTR,CONFTPTR,GPR14P) RSTD;                    02S0667
*   ERRSAV1=GPR14P;                                             02S0668
         LR    ERRSAV1,GPR14P                                   02S0668
*   CONFTPTR=ATCCONFT;                                          02S0669
         L     CONFTPTR,ATCCONFT(,ATCVTPTR)                     02S0669
*   CALL ISTSDCD1;                                              02S0670
         L     @15,@CV00788                                     02S0670
         BALR  @14,@15                                          02S0670
*   IF RDTNODID^=ZERO THEN /* SNT NEEDS DELETING             @ZA30391*/
         L     @15,MLCSKEL(,MLCAPTR)                            02S0671
         CLI   RDTNODID(@15),0                                  02S0671
         BE    @RF00671                                         02S0671
*   CALL ISTSDCD2;                                              02S0672
         L     @15,@CV00789                                     02S0672
         BALR  @14,@15                                          02S0672
*   RPHPTR=MLCRPH;                                              02S0673
*                                                               02S0673
@RF00671 L     RPHPTR,MLCRPH(,MLCAPTR)                          02S0673
*/*** START -TPUNLOCK (VOCLOCK)- ***/                           02S0674
*    DO;                                                        02S0674
*/* ATBUILD (ISTRPH,ISTLOK,ISTCRA)  */                          02S0675
*/* END OF ATBUILD */                                           02S0675
*                                                               02S0675
*    RFY (GPR00P,GPR01P,GPR02P,GPR03P,GPR04P,GPR15P) RSTD;      02S0675
*        GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(RPHWORK);
         STM GPR00P,GPR15P,RPHWORK(GPR01P)
*        GPR02P = ADDR(ATCVOCLK);       /*SET PARAM - LOCKWORD PTR*/
         LA    GPR02P,ATCVOCLK(,ATCVTPTR)                       02S0677
*        GPR04P = GPR01P->RPHCRR;       /*SET PARAM - ISTCRA PTR*/
         L     GPR04P,RPHCRR(,GPR01P)                           02S0678
*        GPR00P = CRALMS02;             /*SET PARAM - LOCK LEVEL FLAG*/
         LA    GPR00P,2                                         02S0679
*        GPR03P = ADDR(GPR04P->CRAL2PTR);                       02S0680
         LA    GPR03P,CRAL2PTR(,GPR04P)                         02S0680
*                                       /*SET PARAM - LOCK LEVEL PTR*/
*                                                               02S0681
*    DO; /* LISATCVT CVTBASE(PAGEABLE,(GPR15P)) */              02S0681
*      GPR15P = ATCLCPTR; /*SET UP ATCVT POINTER*/              02S0682
         L     GPR15P,ATCLCPTR                                  02S0682
*    END; /*LISATCVT*/                                          02S0683
*        GPR15P=GPR15P->ATCAP33;                                02S0684
         L     GPR15P,ATCAP33(,GPR15P)                          02S0684
*        DCL FMZL0062 BASED(GPR15P) LABEL VALUERANGE(*);        02S0685
*        CALL FMZL0062;                                         02S0686
         BALR  @14,@15                                          02S0686
*        GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(GPR00P,GPR01P
*GPR02P,GPR03P,GPR04P,GPR05P,GPR06P,GPR07P,GPR08P,GPR09P,GPR10P,GPR11P,
*PR12P,GPR13P,GPR14P,GPR15P);                                   02S0687
*                                                               02S0687
         LM GPR00P,GPR15P,RPHWORK(GPR01P)
*    RFY (GPR00P,GPR01P,GPR02P,GPR03P,GPR04P,GPR15P) UNRSTD;    02S0688
*        END;                                                   02S0689
*/*** END -TPUNLOCK (VOCLOCK)- ***/                             02S0690
*RFY GPR15F RSTD;                                               02S0690
*                                                               02S0690
*/*TPMSG MSGID((TPMSGID))MSG((ADDR(MLCERBF1)))PLAREA(MLCTPMSG)OPTIONS(N
*SPLSID)*/                                                      02S0691
*                                                               02S0691
*  DO;                                                          02S0691
*    DCL REG1072  REG(1)  PTR;                                  02S0692
*    RFY (REG1072) RSTD;                                        02S0693
*                                                               02S0693
*  RFY (EMCR13) RSTD;                                           02S0694
*    DCL 1 * BASED(REG1072),                                    02S0695
*        2 CMZID072 PTR(31),                                    02S0695
*        2 *,                                                   02S0695
*          3 CMZRL072 PTR(8),                                   02S0695
*          3 CMZRA072 PTR(24) BDY(BYTE),                        02S0695
*        2 CMZEA072 PTR(31),                                    02S0695
*        2 CMZVP072 PTR(31);                                    02S0695
*                                                               02S0695
*/*XREGSET  PID('PLAREA')PPARM(MLCTPMSG)RREG(,REG1072)*/        02S0696
*  DO;                                                          02S0696
*    REG1072=ADDR(MLCTPMSG);             /*SET RREG SYMBOL TO ADDRESS*/
         LA    REG1072,MLCTPMSG(,MLCAPTR)                       02S0697
*                                        /*OF PPARM OPERAND          */
*  END;  /* XREGSET */                                          02S0698
*    CMZID072 = 0;                                              02S0699
         SLR   @02,@02                                          02S0699
         ST    @02,CMZID072(,REG1072)                           02S0699
*    CMZRL072 = 0;                                              02S0700
         MVI   CMZRL072(REG1072),X'00'                          02S0700
*    CMZRA072 = 0;                                              02S0701
         STCM  @02,7,CMZRA072(REG1072)                          02S0701
*    CMZEA072 = 0;                                              02S0702
         ST    @02,CMZEA072(,REG1072)                           02S0702
*    CMZVP072 = 0;                                              02S0703
         ST    @02,CMZVP072(,REG1072)                           02S0703
*    CMZID072=TPMSGID;                                          02S0704
         ST    TPMSGID,CMZID072(,REG1072)                       02S0704
*    CMZVP072 = ADDR(MLCERBF1);                                 02S0705
         LA    @11,MLCERBF1(,MLCAPTR)                           02S0705
         ST    @11,CMZVP072(,REG1072)                           02S0705
*    DCL CMZSA072 (18) PTR(31) BASED(EMCR13);                   02S0706
*    CMZSA072(5) = ADDR(NCSPLSID);                              02S0707
*                                                               02S0707
         L     @11,MLCNCSPL(,MLCAPTR)                           02S0707
         LA    @11,NCSPLSID(,@11)                               02S0707
         ST    @11,CMZSA072+16(,EMCR13)                         02S0707
*    DCL REG15072 REG(15) PTR;                                  02S0708
*    RFY REG15072 RSTD;                                         02S0709
*                                                               02S0709
*  DO; /* LISATCVT CVTBASE(PAGEABLE,(REG15072)) */              02S0710
*    REG15072 = ATCLCPTR; /*SET UP ATCVT POINTER*/              02S0711
         L     REG15072,ATCLCPTR                                02S0711
*  END; /*LISATCVT*/                                            02S0712
*    DCL CMTA072 BASED(REG15072) ENTRY VALUERANGE(*);           02S0713
*    REG15072 = REG15072->ATCMSGP;                              02S0714
         L     REG15072,ATCMSGP(,REG15072)                      02S0714
*    CALL CMTA072;                                              02S0715
         BALR  @14,@15                                          02S0715
*    RESPECIFY (REG1072,REG15072)  UNRESTRICTED;                02S0716
*                                                               02S0716
*  RFY (EMCR13) UNRSTD;                                         02S0717
*  END;                         /*@D32CKQH*/                    02S0718
*   GPR14P=ERRSAV1;                                             02S0719
         LR    GPR14P,ERRSAV1                                   02S0719
*   RETURN CODE(8);                                       /*@XM10670*/
         LA    @15,8                                            02S0720
@EL00004 DS    0H                                               02S0720
@EF00004 DS    0H                                               02S0720
@ER00004 BR    @14                                              02S0720
*RFY (RPHPTR,ATCVTPTR,CONFTPTR,GPR14P,GPR15F) UNRSTD;           02S0721
*END ERRSUB1;                                                   02S0722
*/********************************************************************/
*/*      END OF CBDEF MAINLINE AND INTERNAL PROCEDURES SEGMENT       */
*/********************************************************************/
*                                                               01S0723
*/* TPEPILOG   */                                               01S0723
* GEN (PRINT OFF);                                              01S0723
*                                                               01S0723
         PRINT OFF
*/*   PROGRAM OPERATOR MESSAGE HEADER                                */
*DCL  1  ISTPOHD  BDY(WORD) BASED,                              01S0724
*        2 POHRSVD1 CHAR(1),       /* RESERVED                       */
*        2 POHSTAT,                /* HEADER STATUS BITS             */
*          3 POHEND   BIT(1),      /* END LINE 1=YES                 */
*          3 POHDATA  BIT(1),      /* DATA LINE 1=YES                */
*          3 POHLBL   BIT(1),      /* LABEL LINE 1=YES               */
*          3 POHCNTRL BIT(1),      /* CONTROL LINE 1=YES             */
*          3 POHRSVD2 BIT(2),      /* RESERVED                       */
*          3 POHRREQ  BIT(1),      /* REPLY REQUESTED 1=YES          */
*          3 POHGEN   BIT(1),      /* ID ORIGIN  0=GENERATED BY VTAM */
*                                  /*            1=GENERATED BY POA  */
*        2 POHID    FIXED(16);     /* MESSAGE IDENTIFIER             */
*/*            VTAM PREFIX FOR QUEUE ELEMENTS                         *
*/*  INITIAL LEVEL                                     001 03/04/75  */
*DECLARE                                                        01S0725
*  1 ISTPFX  BDY(WORD)  BASED,                                  01S0725
*   2 PFXID        CHAR(4),             /* QUEUE ACRONYM (SAME AS
*                                          QABID)                     *
*     3 PFXCBID    BIT(8),              /* CONTROL BLOCK ID           *
*   2 PFXPRTY      CHAR(1),             /* PRIORITY OF ELEMENT        *
*   2 PFXLNG       CHAR(3),             /* ELEMENT LENGTH,      01S0725
*                                          INCLUDING PREFIX           *
*   2 PFXFWD       PTR(31),   /* POINTER TO NEXT QUEUE          01S0725
*                                          ELEMENT (IF LAST     01S0725
*                                          POINTER TO QAB)            *
*   2 PFXBCK       PTR(31) ;   /* POINTER TO PREVIOUS           01S0725
*                                          QUEUE ELEMENT (IF    01S0725
*                                          FIRST, POINTER TO QAB)     *
*DCL NCSPLTYP BIT(8) CONSTANT('60'X);   /* NCSPL CONTROL BLOCK ID     *
*   /* NETWORK CONFIGURATION SERVICES CONTROL BLOCK  */         01S0727
*/*  REVISIONS                                         14 07/01/75  */
*DECLARE                                                        01S0727
*  1 ISTNCSPL BASED BDY(DWORD),                                 01S0727
*   2 *      CHAR(16) BDY(WORD),                                01S0727
*     3 NCSPFX CHAR(LENGTH(ISTPFX)), /* QUE ELEMENT PREFIX           */
*       4 *        CHAR(12),                                    01S0727
*       4 NCSCRWKA PTR(31),       /* PTR TO WORK AREA FOR C/R I/O    */
*   2 *           BIT(8),         /*RESERVED                         */
*   2 NCSPLVCD    BIT(8),         /*VERB CODE                        */
*   2 NCSPLVBF    CHAR(2),        /*VERB MODIFIER FLAGS              */
*      3 NCSVBF01 BIT(1),         /* UNUSED                          */
*      3 NCSVBF02 BIT(1),         /* UNUSED                          */
*      3 NCSVBF03 BIT(1),         /* MODIFY MSG SUP                  */
*      3 NCSVBF04 BIT(1),         /* TYPE=VTAM                       */
*      3 NCSVBF05 BIT(1),         /* LINETRACE=1                     */
*      3 NCSVBF06 BIT(1),         /* I/O TRACE=1                     */
*      3 NCSVBF07 BIT(1),         /* BUFFER TRACE=1                  */
*      3 NCSVBF08 BIT(1),         /* MODIFY TPRINT                   */
*      3 NCSVBF09 BIT(1),         /* MODIFY TEST                     */
*      3 NCSVBF10 BIT(1),         /* MODIFY TRACE=NO                 */
*      3 NCSVBF11 BIT(1),         /* VARY INTERNAL ONLY & MODIFY     */
*                                 /*  TRACE = YES                    */
*      3 NCSVBF12 BIT(1),         /* VARY IMMEDIATE  & MODIFY        */
*                                 /*  NETSOL=NO                      */
*      3 NCSVBF13 BIT(1),         /* MODIFY NETSOL=YES               */
*      3 NCSVBF14 BIT(1),         /* VARY LOGON & MODIFY             */
*                                 /*  CHANGE                         */
*      3 NCSVBF15 BIT(1),         /* VARY DEACTIVATE & VARY NORMAL   */
*                                 /*  CLOSE(ERP)                     */
*      3 NCSVBF16 BIT(1),         /* VARY ACTIVATE & ERP REQUEST     */
*                                 /*   & MODIFY DUMP                 */
*   2 NCSPLVFL    CHAR(1),        /*COMMAND FLAGS                    */
*    3 NCSVNCSA   BIT(1),         /*NCSPL IS ACTIVE                  */
*    3 NCSVDEL    BIT(1),         /*DELETE NCSPL                     */
*    3 NCSVSTAT   BIT(1),         /*INDICATE NCSPL WAS NOT GETMAINED */
*    3 NCSDCONT   BIT(1),         /* DO DISCONACT                    */
*    3 NCSABCON   BIT(1),         /* DO ABANDON CONNECTION           */
*    3 NCSDACLK   BIT(1),         /* DO ACTIVATE LINE                */
*    3 NCSRSV02   BIT(2),         /* RESERVED                        */
*   2 NCSPLVF1    CHAR(1),        /* SPECIAL PROC FLAGS              */
*    3 NCSOVFMC   BIT(1),         /* PURGE ONLY VARY'S FMCB          */
*   2 NCSPRMRC    CHAR(1),        /* PURGE MINOR RETURN CODE FIELD   */
*   2 NCSIORC     CHAR(1),        /* I/O OR RESTART RETURN CODE      */
*   2 NCSRRNPT    CHAR(4),        /* ADDR RN ENTRY FOR LINE TRACE    */
*   2 NCSPLRID    CHAR(8),        /*ID = 'NODENAME'                  */
*   2 NCSPLLID    CHAR(8),        /*LOGON = 'NODENAME'               */
*   2 NCSDLID     CHAR(6),        /* OFFHOOK ID                      */
*   2 NCSCRCMD    FIXED(8),       /* C/R I/O COMMAND CODE            */
*   2 NCSCRPID    PTR(8),         /* C/R PATH ID (PID)               */
*   2 NCSPLRPT    PTR(31),        /*ID='NODENAME' RDTE ADDRESS       */
*   2 NCSPLLPT    PTR(31),        /*LOGON/LOGOFF='NODENAME' RDTE ADDR*/
*   2 NCSPLCMD    CHAR(2),        /*3705 CONTROL COMMAND CODES       */
*     3 NCSCMDA  BIT(8),          /*RH FLAGS                         */
*       4 NCSPLSYS BIT(1),        /*ON-SYSTEM OFF-FM                 */
*       4 NCSPLCTL BIT(1),        /*ON-CONTROL OFF-DATA              */
*       4 NCSPLSYN BIT(1),        /*ON=SYNCHR OFF-ASYNCHR            */
*       4 NCSPLFLO BIT(1),        /*ON-WITH FLOW  OFF-AGAINST FLOW   */
*       4 NCSPLUFM BIT(1),        /*ON=UNFORMATTED RU,OFF=FORMATTED  */
*       4 *        BIT(3),        /*RESERVED                         */
*     3 NCSCMDB  BIT(8),          /*COMMAND FIELD                    */
*   2 NCSNCPEP    BIT(8),         /* EP SUBCHANNEL ADDR              */
*   2 NCSMSGSP    CHAR(1),        /* RESERVED FOR MESSAGE SURPRESSION*/
*   2 NCSPLUAD    CHAR(3),        /*U = 'UNIT ADDRESS'               */
*   2 NCSCRFLG    CHAR(1),        /* MISCELLANEOUS C/R FLAGS         */
*     3 NCSPLWRM    BIT(1),       /* COMMAND SPECIFIED WARM PARAM,   */
*                                 /* 1 = YES                         */
*     3 NCSPLCLD    BIT(1),       /* COMMAND SPECIFIED COLD PARAM,   */
*                                 /* 1 = YES                         */
*     3 NCSFMCLD    BIT(1),       /* 370X RESPONDED COLD TO ACTPU    */
*                                 /* (ERP), 1 = YES                  */
*     3 NCSFMERP    BIT(1),       /* 370X RESPONDED ERP TO ACTPU     */
*                                 /* (ERP), 1 = YES                  */
*     3 NCSCRDSE    BIT(1),       /* 0=C/R DATA SET DOES NOT EXIST   */
*                                 /* OR IS NULL                      */
*                                 /* 1=C/R DATA SET EXISTS           */
*                                 /* AND IS NOT NULL                 */
*     3 NCSOPRQU    BIT(1),       /* OPERATOR REQUESTS REIPL, 1 = YES*/
*     3 NCSUSRNF    BIT(1),       /* EARLY WARNING PURGE HAS ALREADY */
*                                 /* OCCURED, 1 = YES                */
*     3 NCSSTCMD    BIT(1),       /* ACTIVATE IS A RESULT OF         */
*                                 /* START VTAM COMMAND, 1 = YES     */
*   2 NCSPLWRE    BIT(32),        /* WTOR ECB                        */
*   2 NCSPLWRF    CHAR(72),       /* WTOR REPLY AREA                 */
*   2 NCSPLRAD    PTR(31),        /* RDTE PTR FOR ALLOCATE/DEALLOCATE*/
*     3 NCSLSCMD BIT(8),          /* LINE SCHED COMMAND TYPE         */
*     3 NCSPLRCD BIT(8),          /* HEX VALUE FOR LINE SCHED PARAM  */
*   2 NCSIOCID    CHAR(4),        /* CURRENT CID FOR DAF LOCK HELD   */
*     3  NCSPLCID CHAR(4),        /* ALIAS FOR ABOVE                 */
*        4  NCSPLSAF  CHAR(2),    /* SOURCE ADDRESS                  */
*        4  NCSPLDAF  CHAR(2),    /* DESTINATION ADDRESS             */
*   2 NCSPLWKA    PTR(31),        /* NCS WORK AREA ADDRESS           */
*   2 NCSPLCVT    PTR(31),        /* POINTER TO VTAM CVT             */
*   2 NCSPLRPH    PTR(31),        /* POINTER TO RPH                  */
*   2 NCSPLECB    BIT(32),        /* ECB FOR VARY PGS                */
*   2 NCSPLFSB    PTR(31),        /* ADDRESS OF USS-FSS FSB OR RU    */
*   2 NCSPLRCR    PTR(31),        /* ADDRESS RDTE FOR CR             */
*   2 NCSPLFL1    CHAR(1),        /* VARY FLAGS                      */
*     3 NCSPL2IN  BIT(1),         /* SECOND ENTRY                    */
*     3 NCSPLSOM  BIT(1),         /* SUPRESS OP. MESSAGE             */
*     3 NCSPLEBN  BIT(1),         /* ENTRY FROM BNN SSCP             */
*     3 NCSPLREQ  BIT(1),         /* NCSPL FROM RESTORE              */
*     3 NCSPLNON  BIT(1),         /* DO NOT ADDR RDT SEGMENT         */
*     3 NCSPLAPU  BIT(1),         /* ACTIVATE PHYSICAL DONE BY LOAD  */
*     3 NCSPL2CN  BIT(1),         /* SECOND CONTACT REQUEST          */
*     3 NCSPLPOS  BIT(1),         /* BNN POSTED                      */
*   2 NCSPLFL2    CHAR(1),        /* VARY FLAGS                      */
*     3 NCSPLVDP  BIT(1),         /* NCSPL ON VARDEF PAB             */
*     3 NCSPLRSF  BIT(1),         /* NO SICK CLEAR BEFORE I/O        */
*     3 NCSPLRIO  BIT(1),         /* I/O = RESTART I/O               */
*     3 NCSOUFMC  BIT(1),         /* PURGE ONLY USER FMCB            */
*     3 NCSPLDS   BIT(1),         /* 1=CIO SAVED RESPONSE DATA       */
*     3 NCSREMPO  BIT(1),         /* REMOTE POWER OFF SPEC BY OPER   */
*     3 NCSPLVIS  BIT(1),         /* VARY IMM START CALLER OF CVP    */
*     3 NCSPLVIT  BIT(1),         /* VARY IMM TERM CALLER OF CVP     */
*   2 NCSPLFL3    CHAR(1),        /* FLAG BYTE                       */
*     3 NCSPLMOM  BIT(1),         /* ERP CAUSED BY FAILURE OF   01S0727
*                                    HIGHER NODE                     */
*     3 NCSEPP    BIT(1),         /* 1=EP SUBCHANNEL PRESENT         */
*     3 NCSPLANS  BIT(1),         /* ON FOR ACT IN ANSWER MODE       */
*                                 /* OFF FOR ACT IN NON-ANSWER MODE  */
*     3 NCSGID    BIT(1),         /* ON FOR PATH WITH GID PARM       */
*     3 NCSPID    BIT(1),         /* ON FOR PATH WITH PID PARM       */
*     3 NCSANS    BIT(1),         /* ON FOR ACTIVATE WITH ANS PARM   */
*     3 NCSFINAL  BIT(1),         /* FINAL PARM EXISTS               */
*     3 NCSEND    BIT(1),         /* END PARM EXISTS                 */
*   2 NCSPLFL4    CHAR(1),        /* FLAG BYTE                       */
*     3 NCSDLNID  BIT(1),         /* ID PRESENT IN NCSPL - OFF       */
*     3 NCSPLRSO  BIT(1),         /* RESET ONLY                      */
*     3 NCSPLVID  BIT(1),         /* ORIG CMD WAS MODIFY DUMP        */
*     3 NCSDSPE   BIT(1),         /* DISPLAY EVERY                   */
*     3 NCSDSPA   BIT(1),         /* DISPLAY ACT                     */
*     3 NCSDSPI   BIT(1),         /* DISPLAY INACT                   */
*     3 NCSDSPN   BIT(1),         /* DISPLAY NONE                    */
*     3 NCSPL2AP  BIT(1),         /* SECOND ACTPU TO 320X            */
*   2 NCSDLRSN    CHAR(1),        /* DIAL REASON CODES               */
*   2 NCSPLFL5    CHAR(1),        /* FLAG BYTE                       */
*     3 NCSSCPPS  BIT(1),         /* SSCP WORK AREA IN PVT STORAGE   */
*     3 NCSSDLK   BIT(1),         /* ON-SDLC LINK PROCESSED          */
*     3 NCSFORCE  BIT(1),         /* FORCED DEACT IN PROGRESS        */
*     3 *         BIT(5),         /* RESERVED                        */
*   2 NCSPLOLN    FIXED(15),      /* LENGTH O/B RU                   */
*   2 NCSPLP1     PTR(31),        /* ADDR VARY PAB                   */
*   2 NCSPLP2     PTR(31),        /* ADDR D/L/R PAB                  */
*   2 NCSPLP3     PTR(31),        /* ADDR ERP PAB                    */
*   2 NCSPLSPL    PTR(31),        /* ADDR ASSOC. NCSPL               */
*   2 NCSPLWEL    PTR(31),        /* ADDR POST RPH                   */
*   2 NCSPLRRP    PTR(31),        /* ADDR REMOTE RN RDTE IN LOCAL RDT*/
*   2 NCSPLRUO    PTR(31),        /* ADDR O/B RU                     */
*   2 NCSPLRUI    PTR(31),        /* ADDR BUFFER FOR I/B RU          */
*   2 NCSPLAPP    PTR(31),        /* ADDR NCSPL APPENDAGE            */
*   2 NCSRNAME    CHAR(8),        /* RNAME=FROM VARY ACTIVATE        */
*   2 NCSPLSQN    FIXED(15),      /* SEQUENCE=NR. FOR RESPONSE       */
*   2 NCSPLGID    BIT(8),         /* BINARY REP OF GID VALUE         */
*   2 NCSPLPID    BIT(8),         /* BINARY REP OF PID VALUE         */
*   2 NCSPLMID    CHAR(8),        /* LOGMODE = 'MODENAME'            */
*   2 NCSPLNSN    PTR(31),        /* RDTE NSNEA AT CLSDST            */
*   2 NCSSENSE    CHAR(4),        /* SENSE                           */
*     3 NCSSNS1  CHAR(1),         /* SENSE DATA MAJOR CODE           */
*     3 NCSSNS2  CHAR(1),         /* SENSE MODIFIER BYTE             */
*     3 NCSSENS2 CHAR(2),         /* USER SENSE DATA                 */
*   2 NCSCPWPT    PTR(31),        /* ADDRESS OF CPWA                 */
*   2 NCSMGLPT    PTR(31),        /* PTR TO USS/FSS MSG PARAM LIST   */
*   2 NCSUFMCB    PTR(31),        /* POINTER TO SSCP-LU FMCB         */
*   2 NCSPLRH     CHAR(3),        /* REQUEST RH                      */
*   2 NCSPLRTY    CHAR(1),        /* TYPE FROM RTGOH RU              */
*   2 NCSCRDTE    PTR(31),        /* PTR TO RDTE BEING PROCESSED     */
*                                 /* FOR C/R I/O                     */
*   2 NCSCRMSK,                   /* FLAGS FOR C/R CHECK POINTING    */
*     3 NCSCHKPT    CHAR(2),      /* FLAGS FOR ITEMS CHECK POINTED   */
*       4 NCSACTV     BIT(1),     /* ACTICE/INACTIVE STATUS CHANGED  */
*                                 /* 1 = YES                         */
*       4 NCSPACTV    BIT(1),     /* PORT ACT/INACTIVE STATUS CHANGED*/
*                                 /* 1 = YES                         */
*       4 NCSPOLD     BIT(1),     /* POLL DELAY VALUE CHANGED, 1=YES */
*       4 NCSNRPL     BIT(1),     /* NEGATIVE RESPONSE TO POLL       */
*                                 /* LIMIT VALUE CHANGED, 1 = YES    */
*       4 NCSESLM     BIT(1),     /* SESSION LIMIT VALUE CHANGED,1=YES*
*       4 NCSDTRLM    BIT(1),     /* DEVICE TRANSMISSION LIMIT       */
*                                 /* VALUE CHANGED, 1 = YES          */
*       4 NCSLGAPL    BIT(1),     /* APPLICATION CONTROLLER NAME     */
*                                 /* (LOGAPPL) CHANGED, 1 = YES      */
*       4 NCSLGMOD    BIT(1),     /* LOGON MODE (LOGMODE)            */
*                                 /* CHANGED, 1 = YES                */
*       4 NCSANSMD    BIT(1),     /* ANSWER MODE STATUS CHANGED,1=YES*/
*       4 NCSCUA      BIT(1),     /* CUA VALUE CHANGED, 1 = YES      */
*       4 NCSRNME     BIT(1),     /* RNAME VALUE CHANGED, 1 = YES    */
*       4 NCSPTUSE    BIT(1),     /* PATH USE/NOUSE STATUS CHANGED   */
*                                 /* 1 = YES                         */
*       4 NCSRSVD1    BIT(4),     /* RESERVED                        */
*     3 NCSCRMOD    CHAR(1),      /* NEW VALUES FOR ITEMS CHECKPOINTED*
*                                 /* NOT OBTAINED FROM RDTE          */
*       4 NCSAIMOD    BIT(1),     /* ACTIVE/INACTIVE STATUS, 1=ACTIVE*/
*       4 NCSPTMOD    BIT(1),     /* PORT ACT/INACT STATUS, 1=ACTIVE */
*       4 NCSRSVD2    BIT(6),     /* RESERVED                        */
*   2 NCSPLSID BDY(BYTE),         /* MESSAGE ROUTING INFORMATION     */
*     3 NCSPLSTA    CHAR(1),      /* STATUS FLAG BYTE                */
*       4 NCSRSVD4    BIT(7),     /* RESERVED                        */
*       4 NCSPLPO     BIT(1),     /* 0 = CONSOLE ID FOLLOWS, 1 =     */
*                                 /* PROGRAM OPERATOR HEADER FOLLOWS */
*     3 NCSPLPHD CHAR(LENGTH(ISTPOHD)), /* PO HEADER IF NCSPLPO = 01 */
*       4 NCSPLNID    FIXED(8),   /* CONSOLE ID IF NCSPLPO = 0       */
*     3 NCSPLPDB    PTR(31);      /* PTR TO PO ACDEB PREFIX          */
*/*   COMMAND VALUES FOR C/R FIELD NCSCRCMD                          */
*DCL NCSCRWR  FIXED(8) CONSTANT(0);  /* WRITE TO C/R DATA SET        */
*DCL NCSCROPN FIXED(8) CONSTANT(1);  /* OPEN C/R DATA SET            */
*DCL NCSCRCLS FIXED(8) CONSTANT(2);  /* CLOSE C/R DATA SET           */
*DCL NCSCRDEL FIXED(8) CONSTANT(3);  /* DELETE C/R DATA SET RECORD   */
*DCL NCSCROPQ FIXED(8) CONSTANT(4);  /* OPERATOR QUERY               */
*DCL NCSDCID  FIXED(8) CONSTANT(1);  /* CONSOLE ID INDICATOR         */
*DCL NCSCRIO  BIT(16) CONSTANT('0800'X); /* INDICATES REQUESTS       */
*                                        /* FOR VSAM I/O FOR C/R     */
*DCL NCSCRVIO BIT(16) CONSTANT('0C00'X); /* VSAM I/O OPERATION       */
*/* NCSPL APPENDAGE DEFINATION                                       */
*DCL  1  NCSAPP BASED(NCSPLAPP),                                01S0736
*        2 NCSAPSA  CHAR(72),     /* SAVE AREA                       */
*        2 NCSAPECB CHAR(4),      /* ECB                             */
*        2 NCSAPTXT CHAR(8),      /* DUMP DATA                       */
*        2 NCSAPEND PTR(31),      /* HIGH STORAGE ADDRESS            */
*        2 NCSAPBUE CHAR(520),                                  01S0736
*          3 NCSRSV04 CHAR(3),    /* RESERVED                        */
*          3 NCSAPRU  CHAR(5),    /* IPL CMD RU PREFIX               */
*          3 NCSAPDAT CHAR(512),  /* RESP FOR DUMP, O/B LOAD         */
*        2 NCSAPPAB PTR(31);      /* BNN VARY PAB ADDR               */
*/*    USS/FSS RU AREA MAP                                           */
*DCL  1  NCSUSSRU BASED(NCSPLFSB),                              01S0737
*        2 NCSRULEN FIXED(15),    /* LENGTH OF RU                    */
*        2 NCSRUITS CHAR(*);      /* START OF RU                     */
*/*    GENERAL CONSTANTS                                             */
*DCL NCSWASZ  FIXED(15) CONSTANT(2032);   /* NCSPL WORK AREA SIZE    */
*DCL NCSRTGOH BIT(16) CONSTANT('1000'X);  /* VBF VALUE FOR INTERNAL  */
*                                         /* COMMAND-RTGOH RECVD.    */
*/*    CONSTANTS FOR VERB CODES                                      */
*DCL NCSPLVC0 BIT(08) CONSTANT('00'X);    /* ERROR                   */
*DCL NCSPLVC1 BIT(08) CONSTANT('01'X);    /* VARY                    */
*DCL NCSPLVC2 BIT(08) CONSTANT('02'X);    /* MODIFY                  */
*DCL NCSPLVC3 BIT(08) CONSTANT('03'X);    /* ERP                     */
*DCL NCSPLVC4 BIT(08) CONSTANT('04'X);    /* DISPLAY                 */
*DCL NCSPLVC5 BIT(08) CONSTANT('05'X);    /* STATUS TO SM            */
*DCL NCSPLVC6 BIT(08) CONSTANT('06'X);    /* INTERNAL CMD            */
*DCL NCSPLVC7 BIT(08) CONSTANT('07'X);    /* INIT/TERM TUSM          */
*DCL NCSPLVC8 BIT(08) CONSTANT('08'X);    /* DIAL                    */
*/*    CONSTANTS FOR VARY COMMAND MODIFIERS                          */
*DCL NCSVACT BIT(16) CONSTANT('0001'X);   /*ACTIVATE                 */
*DCL NCSVDEA BIT(16) CONSTANT('0002'X);   /* DEACTIVATE              */
*DCL NCSVLON BIT(16) CONSTANT('0004'X);   /* LOGON                   */
*DCL NCSVVPP BIT(16) CONSTANT('0080'X);   /* VARY NORMAL CLEANUP REQST*
*DCL NCSVIMM BIT(16) CONSTANT('0010'X);   /* IMMEDIATE               */
*DCL NCSVINT BIT(16) CONSTANT('0020'X);   /* INTERNAL ONLY           */
*DCL NCSVALO BIT(16) CONSTANT('0005'X);   /* ACTIVATE WITH LOGON     */
*DCL NCSVDEI BIT(16) CONSTANT('0012'X);   /* DEACTIVATE IMMEDIATE    */
*DCL NCSVDII BIT(16) CONSTANT('0032'X);   /* DEACTIV. IMMEDIATE INTERNA
*                                            ONLY*/             01S0757
*DCL NCSCNOTF BIT(16) CONSTANT('FFF8'X);  /* NOTIFY REQUEST          */
*DCL NCSVANON BIT(16) CONSTANT('0008'X);  /* ANSWER = ON             */
*DCL NCSVANOF BIT(16) CONSTANT('0040'X);  /* ANSWER = OFF            */
*DCL NCSVPUSE BIT(16) CONSTANT('0100'X);  /* PATH = USABLE           */
*DCL NCSVPNUS BIT(16) CONSTANT('0200'X);  /* PATH = NOT USABLE       */
*DCL NCSVINOP BIT(16) CONSTANT('0400'X);  /* INOPERATIVE             */
*/*    CONSTANTS FOR MODIFY COMMAND MODIFIERS                        */
*DCL NCSMDUM BIT(16) CONSTANT('0001'X);   /* DUMP 3705               */
*DCL NCSMCHA BIT(16) CONSTANT('0004'X);   /* CHANGE                  */
*DCL NCSMNSY BIT(16) CONSTANT('0008'X);   /* NETSOL = YES            */
*DCL NCSMNSN BIT(16) CONSTANT('0010'X);   /* NETSOL = NO             */
*DCL NCSMTRY BIT(16) CONSTANT('0020'X);   /* TRACE = YES             */
*DCL NCSMVTRY BIT(16) CONSTANT('1020'X);                        01S0769
*DCL NCSMVTRN BIT(16) CONSTANT('1040'X);                        01S0770
*DCL NCSMTRN BIT(16) CONSTANT('0040'X);   /* TRACE = NO              */
*DCL NCSMTPR BIT(16) CONSTANT('0100'X);   /* TRACE PRINT             */
*DCL NCSMTST BIT(16) CONSTANT('0080'X);   /* MODIFY TEST             */
*DCL NCSDPF   BIT(16) CONSTANT('0000'X);  /* POTENTIAL FAIL          */
*DCL NCSDSTRT BIT(16) CONSTANT('0001'X);  /* DIAL START              */
*DCL NCSDOH1  BIT(16) CONSTANT('0002'X);  /* OFFHOOK 1               */
*DCL NCSDOH2  BIT(16) CONSTANT('0004'X);  /* OFFHOOK 2               */
*DCL NCSDDF   BIT(16) CONSTANT('0010'X);  /* DIAL FAILED             */
*DCL NCSDLKS  BIT(16) CONSTANT('0008'X);  /* LINK START              */
*DCL NCSDLKC  BIT(16) CONSTANT('0020'X);  /* LINK COMPLETION         */
*DCL NCSDHU   BIT(16) CONSTANT('0040'X);  /* HANGUP                  */
*DCL NCSDLK   BIT(16) CONSTANT('0080'X);  /* DEALLOCATE              */
*DCL NCSDGIVE BIT(16) CONSTANT('0100'X);  /* GIVE                    */
*DCL NCSDINOP BIT(16) CONSTANT('0200'X);  /* INOP                    */
*DCL NCSDLRST BIT(16) CONSTANT('0400'X);  /* RECOVERY SW LINKS       */
*                                         /* AFTER RN FAILURE        */
*/*    CONSTANTS FOR ERP COMMAND MODIFIERS                           */
*DCL NCSEERRA BIT(16) CONSTANT('0001'X);  /* ERP REQUEST          */
*DCL NCSECLOR BIT(16) CONSTANT('0002'X);  /* VARY NORMAL CLOSE REQUEST*
*DCL NCSEDACT BIT(16) CONSTANT('0004'X);  /* ERP DEACTIVATE REQUEST   *
*DCL NCSERSTR BIT(16) CONSTANT('0008'X);/* RSTRT ENTRY FROM DLR PROC */
*DCL NCSVFORC BIT(16) CONSTANT('0802'X);/* FORCED DEACT              */
*DCL NCSVRACT BIT(16) CONSTANT('1002'X);/* DEACT AND REACT           */
*/*   PURGE MINOR RETURN CODES CONSTANTS                             */
*DCL NCSAPABN BIT(8) CONSTANT('05'X),    /* APPLICATION ABEND        */
*    NCSCLDST BIT(8) CONSTANT('06'X),    /* CLOSE DEST OCCURED       */
*    NCSDDISC BIT(8) CONSTANT('08'X),    /* DIAL DISCONNECT OCCURED
*                                           - CONN NO LONGER AVAILABL*/
*    NCSBTHEX BIT(8) CONSTANT('09'X);    /* BUFFER THRESHOLD EXCEEDED*/
*/*   I/O OR RESTART RETURN CODES CONSTANTS                          */
*DCL NCSIOSUC BIT(8) CONSTANT('00'X),    /* I/O SUCCESSFUL           */
*    NCSIOERR BIT(8) CONSTANT('04'X),    /* I/O ERROR                */
*    NCSIOPRG BIT(8) CONSTANT('08'X),    /* I/O PURGED               */
*    NCSRSSUC BIT(8) CONSTANT('00'X),    /* RESTART SUCCESSFUL       */
*    NCSRSERR BIT(8) CONSTANT('04'X),    /* RESTART ERROR            */
*    NCSVAIPL BIT(8) CONSTANT('00'X),  /* IPL NO RESTART ON VARY ACTV*/
*    NCSVANRA BIT(8) CONSTANT('10'X),    /* IPL SUCCESSFUL, NO RESTART
*                                           AVAILABLE ON VARY ACTIVE  *
*    NCSVAWMF BIT(8) CONSTANT('08'X),    /* WARM START FAILURE FOR
*                                           VARY ACTIVATE            */
*    NCSVAIPF BIT(8) CONSTANT('0C'X),   /* IPL FAILED ON VARY ACTIVATE*
*    NCSDSIA  BIT(8) CONSTANT('14'X),   /* INVALID ADDRESS SPECIFIED
*                                          ON DISPLAY STORAGE CMND    *
*    NCSVAISZ BIT(8) CONSTANT('08'X),   /* NCP SIZE TOO LARGE         *
*    NCSIPLSC BIT(8) CONSTANT('00'X),   /* IPL SUCCESSFUL             *
*    NCSIOER  BIT(8) CONSTANT('0C'X),   /* I/O ERROR ON REMOTE IPL    *
*    NCSNCPAC BIT(8) CONSTANT('04'X),   /* REMOTE NCP ALREADY ACTIVE  *
*    NCSNCRPF BIT(8) CONSTANT('70'X),   /* REMOTE POWER OFF           *
*    NCSCRIOS BIT(8) CONSTANT('30'X),   /* SUCCESSFUL I/O             *
*    NCSCRION BIT(8) CONSTANT('34'X),   /* NULL D.S. OPENED           *
*    NCSCRIOF BIT(8) CONSTANT('38'X);   /* FAILURE ON I/O             *
*/*           CONSTANTS FOR LIBERTY SUPPORT                           *
*DCL  NCSES   BIT(16) CONSTANT('0001'X),/* END SESSION                *
*     NCSBF   BIT(16) CONSTANT('0002'X),/* BIND FAILURE               *
*     NCSUF   BIT(16) CONSTANT('0004'X),/* UNBIND FAILURE             *
*     NCSINIT BIT(16) CONSTANT('0001'X),                        01S0794
*     NCSTERM BIT(16) CONSTANT('0002'X);                        01S0794
*DCL NCSTPPST BIT(16) CONSTANT('0001'X);/* TPPST COMMAND              *
*DCL NCSII    BIT(16) CONSTANT('0002'X);/* IPL INIT COMMAND           *
*DCL NCSIT    BIT(16) CONSTANT('0004'X);/* IPL COMMAND                *
*DCL NCSIF    BIT(16) CONSTANT('0008'X);/* IPL FINAL COMMAND          *
*DCL NCSDI    BIT(16) CONSTANT('0010'X);/* DUMP INIT COMMAND          *
*DCL NCSDT    BIT(16) CONSTANT('0020'X);/* DUMP TEXT COMMAND          *
*DCL NCSDF    BIT(16) CONSTANT('0040'X);/* DUMP FINAL COMMAND         *
*DCL NCSCON   BIT(16) CONSTANT('0080'X);/* CONTACT COMMAND            *
*DCL NCSDICON BIT(16) CONSTANT('0100'X);/* DISCONTACT COMMAND         *
*DCL NCSMSFMD BIT(16) CONSTANT('0200'X);/* SEND FMD                   *
*DCL NCSSEND  BIT(16) CONSTANT('0400'X);/* SEND                       *
*DCL NCSPURGE BIT(16) CONSTANT('0800'X);/* PAB PURGE                  *
*DCL NCSMSSUP BIT(16) CONSTANT('2000'X);/* CONSTANT FOR MSG SUP       *
*DCL NCSCRDS  BIT(16) CONSTANT('3023'X);/* RECORD DEV STATS COMMAND   *
*DCL NCSCQUIS BIT(16) CONSTANT('F01A'X);/* QUIESCE COMMAND            *
*DCL NCSSNUSS BIT(16) CONSTANT('381F'X);/* SEND USS MESSAGE           *
*/*                                                                   *
*DCL NCSNC    BIT(8)  CONSTANT('04'X);  /* NOT CONTACTED              *
*DCL NCSLD    BIT(8)  CONSTANT('00'X);  /* CONTACTED LOADED           *
*DCL NCSNLD   BIT(8)  CONSTANT('0C'X);  /* CONTACTED NEEDS LOAD       *
*DCL NCSNCD   BIT(8)  CONSTANT('08'X);  /* NOT CONTACTED DUE TO DEACT *
*DCL NCSNCE   BIT(8)  CONSTANT('10'X);  /* NOT CONTACTED DUE TO ERP   *
*DCL NCSNFME  BIT(8)  CONSTANT('24'X);  /* NEGATIVE FME               *
*/*  CONSTANTS FOR IORC FOR DISPLAY STORAGE                          */
*DCL NCSDSDEA BIT(8)  CONSTANT('0C'X);  /* PRIOR DEACT                *
*DCL NCSDSFAL BIT(8)  CONSTANT('04'X);  /* FAIL OTHER THAN PRIOR DEACT*
*/* TYPE CODES FOR CONFIGURATION RESTART                              *
*DCL NCSCTRLM BIT(8) CONSTANT('01'X);   /* CHANGE DEV TRANS LIMIT     *
*DCL NCSCNPOL BIT(8) CONSTANT('02'X);   /* CHANGE NEG POLL RESP LIMIT *
*DCL NCSCSESS BIT(8) CONSTANT('03'X);   /* CHANGE SESSION LIMIT       *
*DCL NCSCPOLL BIT(8) CONSTANT('04'X);   /* CHANGE LINE SERV SEEK PAUSE*
*/*  FM DATA COMMAND CODES                                            *
*DCL NCSCAPU  BIT(16) CONSTANT('D001'X);   /* ACT PHYS                *
*DCL NCSCDPU  BIT(16) CONSTANT('D002'X);   /* DEACT PHYS              *
*DCL NCSCALU  BIT(16) CONSTANT('D003'X);   /* ACT LOG                 *
*DCL NCSCDLU  BIT(16) CONSTANT('D004'X);   /* DEACT LOG               *
*DCL NCSCSDT  BIT(16) CONSTANT('D005'X);   /* SDT                     *
*DCL NCSCFME  BIT(16) CONSTANT('2006'X);   /* SEND POS RESP           *
*DCL NCSCEXCP BIT(16) CONSTANT('2007'X);   /* SEND NEG RESP           *
*DCL NCSCCON  BIT(16) CONSTANT('3008'X);   /* CONTACT                 *
*DCL NCSCDCON BIT(16) CONSTANT('3009'X);   /* DISCONTACT              *
*DCL NCSCIPLI BIT(16) CONSTANT('300A'X);   /* IPL INIT                *
*DCL NCSCIPLT BIT(16) CONSTANT('300B'X);   /* IPL                     *
*DCL NCSCIPLF BIT(16) CONSTANT('300C'X);   /* IPL FINAL               *
*DCL NCSCDUMI BIT(16) CONSTANT('300D'X);   /* DUMP INIT               *
*DCL NCSCDUMP BIT(16) CONSTANT('300E'X);   /* DUMP                    *
*DCL NCSCDUMF BIT(16) CONSTANT('300F'X);   /* DUMP FINAL              *
*DCL NCSCACTL BIT(16) CONSTANT('3010'X);   /* ACT LINK                *
*DCL NCSCDACL BIT(16) CONSTANT('3011'X);   /* DEACT LINK              *
*DCL NCSCSSV  BIT(16) CONSTANT('3012'X);   /* SET STATE VECTOR        *
*DCL NCSCNSP  BIT(16) CONSTANT('3013'X);   /* NS PROC ERROR           *
*DCL NCSCSTD  BIT(16) CONSTANT('3019'X);   /* SET TIME & DATE         *
*DCL NCSCSEP  BIT(16) CONSTANT('9014'X);   /* SWITCH TO EP            *
*DCL NCSCSNC  BIT(16) CONSTANT('9015'X);   /* SWITCH TO NCP           *
*DCL NCSCLSD  BIT(16) CONSTANT('3016'X);   /* LINE SCHED PARM         *
*DCL NCSCDS   BIT(16) CONSTANT('3017'X);   /* DISPLAY STORAGE         *
*DCL NCSCPWO  BIT(16) CONSTANT('3018'X);   /* REMOTE POWER OFF        *
*DCL NCSSNFMD BIT(16) CONSTANT('301C'X);   /* SEND FMD                *
*DCL NCSCDIAL BIT(16) CONSTANT('301A'X);   /* DIAL                    *
*DCL NCSCADIL BIT(16) CONSTANT('301B'X);   /* ABANDON DIAL            *
*DCL NCSCEANS BIT(16) CONSTANT('301D'X);   /* ENABLE ANS MODE         *
*DCL NCSCAANS BIT(16) CONSTANT('301E'X);   /* ABANDON ANS MODE        *
*DCL NCSCANA  BIT(16) CONSTANT('301F'X);   /* ASSIGN NET ADDRESS      *
*DCL NCSCFNA  BIT(16) CONSTANT('3020'X);   /* FREE NET ADDRESS        *
*DCL NCSCACON BIT(16) CONSTANT('3021'X);   /* ABANDON CONNECTION      *
*DCL NCSCSCV  BIT(16) CONSTANT('3022'X);   /* SET CONTROL VECTOR      *
*DCL NCSNCPPG BIT(16) CONSTANT('FFFF'X);   /* PURGE                   *
*/* NEW VALUES FOR NCSPLCMD   */                                01S0858
*DCL NCSCLCND BIT(16) CONSTANT('0041'X);  /* LOAD CONDITIONALLY  */
*DCL NCSCUCND BIT(16) CONSTANT('0042'X); /* LOAD UNCONDITIONALLY */
*DCL NCSCRSRT BIT(16) CONSTANT('0043'X); /* RESTART 370X OR CLUS  */
*DCL NCSDUCMD BIT(16) CONSTANT('0044'X); /* DUMP 370X  */       01S0861
*DCL NCSCERPP BIT(16) CONSTANT('0045'X); /* PERFORM ERP DUMP AND
*                                           RELOAD OF 370X  */  01S0862
*DCL NCSDOUT  BIT(16) CONSTANT('0046'X); /* DIAL OUT                 */
*DCL NCSDCNT  BIT(16) CONSTANT('0047'X); /* DIAL CONTACT             */
*DCL NCSDABDN BIT(16) CONSTANT('0048'X); /* DIAL ABANDON             */
*DCL NCSDENAS BIT(16) CONSTANT('0049'X); /* DIAL ENABLE ANSWER       */
*/*  VALUES FOR NCSCMDB                                              */
*DCL NCSBFME BIT(8) CONSTANT('06'X);     /* SEND POS RESP COMMAND    */
*DCL NCSBEXC BIT(8) CONSTANT('07'X);     /* SEND NEG RESP COMMAND    */
*/*  CONSTANTS FOR DIAL REASON CODES                                 */
*DCL NCSDLRRD BIT(8) CONSTANT('01'X);    /* REDIAL                   */
*DCL NCSDLRQT BIT(8) CONSTANT('02'X);    /* QUIT                     */
*/* NEW VALUES FOR NCSIORC   */                                 01S0871
*DCL NCSLDAOK BIT(8) CONSTANT('00'X);  /* COMMAND PROCESSED SUCESS */
*DCL NCSLDACT BIT(8) CONSTANT('04'X);  /* NCP ACTIVE-LOAD NOT PERF */
*DCL NCSLDCAN BIT(8) CONSTANT('04'X);  /* RELOAD DECLINED BY OPER  */
*DCL NCSLDIOP BIT(8) CONSTANT('08'X);  /* I/O PURGED               */
*DCL NCSLDNOG BIT(8) CONSTANT('0C'X);  /* COMMAND FAILED           */
*DCL NCSDUCOM BIT(8) CONSTANT('14'X);  /* DUMP COMPLETE            */
*DCL NCSHALTD BIT(8) CONSTANT('18'X);  /* CMD REJECTED,HALT IN PROG*/
*DCL NCSUNREC BIT(8) CONSTANT('1C'X);  /* COMMAND UNRECOGNIZED     */
*DCL NCSNOSTG BIT(8) CONSTANT('20'X);  /* CMD REJ,INSUFF STORAGE   */
*DCL NCSDOS   BIT(8) CONSTANT('00'X);  /* DIAL-OUT SUCCESSFUL      */
*DCL NCSDOF   BIT(8) CONSTANT('04'X);  /* DIAL-OUT UNSUCCESSFUL    */
*DCL NCSDOP   BIT(8) CONSTANT('08'X);  /* DIAL-OUT PENDING         */
*DCL NCSDCS   BIT(8) CONSTANT('00'X);  /* DIAL-CONTACT LOADED      */
*DCL NCSDCF   BIT(8) CONSTANT('0C'X);  /* DIAL-CONTACT FAILED      */
*DCL NCSDAS   BIT(8) CONSTANT('00'X);  /* DIAL-ABANDON CONN COMPLETE*/
*DCL NCSDENSO BIT(8) CONSTANT('00'X);  /* ENABLE ANSWER SUCCESSFUL  */
*DCL NCSDOFHR BIT(8) CONSTANT('04'X);  /* OFFHOOK REQUIRED          */
*DCL NCSDENSF BIT(8) CONSTANT('08'X);  /* ENABLE ANSWER FAIL        */
*/*  NEW VALUES FOR NCSPRMRC    */                              01S0889
*DCL NCSFIRM  BIT(8) CONSTANT('10'X);  /* RESTART SUCC,OPENDST REQ */
*DCL NCSEWRN  BIT(8) CONSTANT('11'X);  /* CON LOST,RECOV IN  PROG  */
*/* CONSTANTS FOR TRACE                                            */
*DCL NCSACTLT BIT(16) CONSTANT('0820'X); /* ACTIVATE LINE TRACE    */
*DCL NCSDACLT BIT(16) CONSTANT('0840'X); /* DEACTIVATE LINE TRACE  */
*DCL NCSCACLT BIT(16) CONSTANT('301D'X); /* SSCP ACT LINE TRACE    */
*DCL NCSCDCLT BIT(16) CONSTANT('301E'X); /* SSCP DEACT LINE TRACE  */
*/* DISPLAY COMMAND MODIFIER CONSTANTS                             */
*DCL NCSDPATH BIT(16) CONSTANT('0001'X); /* PATHS                  */
*/* PROCESS ANCHOR BLOCK                                              *
*/*  REVISIONS                                         002 11/16/75  */
*/*       APAR      OZ19540    DCL PABSSN ABNORMAL           @ZA19540*/
*DCL  1  ISTPAB BDY(DWORD) BASED,                               01S0896
*       2  PABWQCHN CHAR(8) BDY(DWORD), /* CPS SWAP FIELD FOR NEQ&CHN *
*        3  PABWEQA PTR(31) BDY(WORD), /* WORK ELEMENT QUEUE ADDRESS  *
*           4  PABWEQG BIT(1),         /* GATING BIT                  *
*           4  PABRSV01 BIT(7),        /* RESERVED                    *
*           4  PABWEQP PTR(24),        /* WKEL PTR                    *
*        3  PABCHAIN PTR(31) BDY(WORD), /* APS CHAIN                  *
*           4  PABCHNG BIT(1),         /* GATING BIT                  *
*           4  PABRESCH BIT(1),        /* RESCHEDULE PAB AT     01S0896
*                                         TPEXIT                      *
*           4  PABCDP BIT(1),          /* CLOSE DST/CHANGE IN PROGRESS*
*           4  PABUNCON BIT(1),        /* UNCONDITIONALLY RESCHEDULE
*                                         PAB AT TPEXIT               *
*           4  PABRESET BIT(1),        /* RESET ISSUED ON THIS PAB    *
*           4  PABRUNNG BIT(1),        /* PAB RUNNING                 *
*           4  PABDELAY BIT(1),        /* DELAY OPTION USED           *
*           4  PABRSV02 BIT(1),        /* RESERVED                    *
*           4  PABCHNGP PTR(24),       /* PSS CHAIN PTR               *
*        2  PABOFFST PTR(8),           /* OFFSET FROM CONTROL BLOCK   *
*        2  PABDVTA PTR(24),           /* DVT ADDRESS                 *
*        2  PABRPHFG PTR(31),          /* SCHED FLAGS AND RPH         *
*           3  PABFLAGS BIT(8),        /* SCHEDULING FLAGS            *
*              4  PABAPYP BIT(1),      /* APPLICATION IS A USER EXIT  *
*              4  PABPRIOR BIT(1),     /* IMMEDIATE PRIORITY          *
*              4  PABNORPR BIT(1),     /* NORMAL PRIORITY -           *
*                                      /* RESCHEDUALABLE              *
*              4  PABDYNAM BIT(1),     /* DYNAMIC                     *
*              4  PABSSN BIT(1) ABNL,  /* SYSTEM SERVICES    @ZA19540 *
*              4  PABERLCK BIT(1),     /* PAB ERROR LOCK FLAG         *
*                 5  PABERRLK BIT(1),  /* ERROR LOCK                  *
*                    6  PABERLOK BIT(1), /* ERROR LOCK                *
*/*    ABNORMAL TO ALLOW VARY COMPARE AND SWAP                        *
*              4  PABINHBT BIT(1) ABNL,/* 1=INHIBIT TRAFFIC,0=NO      *
*              4  PABNODQ BIT(1),      /* DO NOT DEQ WORK ELEMENT     *
*           3  PABRPHA PTR(24);        /* RPL HEADER ADDRESS          *
*DCL PABWEQG0 BIT(32) CONSTANT('7FFFFFFF'X),  /* TURN PABWEQG OFF     *
*    PABWEQG1 BIT(32) CONSTANT('80000000'X),  /* TURN PABWEQG ON      *
*    PABCHNG0 BIT(32) CONSTANT('7FFFFFFF'X),  /* TURN PABCHNG OFF     *
*    PABCHNG1 BIT(32) CONSTANT('80000000'X),  /* TURN PABCHNG ON      *
*    PABRESC0 BIT(32) CONSTANT('BFFFFFFF'X),  /* TURN PABRESCH OFF    *
*    PABRESC1 BIT(32) CONSTANT('40000000'X),  /* TURN PABRESCH ON     *
*    PABCDP0  BIT(32) CONSTANT ('DFFFFFFF'X), /* TURN PABCDP OFF      *
*    PABCDP1  BIT(32) CONSTANT ('20000000'X), /* TURN PABCDP ON       *
*    PABERLK0 BIT(32) CONSTANT('FBFFFFFF'X),  /* TURN PABERRLK ON     *
*    PABERLK1 BIT(32) CONSTANT('04000000'X),  /* TURN PABERRLK OFF    *
*    PABUNCO0 BIT(32) CONSTANT('EFFFFFFF'X),  /* TURN PABUNCON OFF    *
*    PABUNCO1 BIT(32) CONSTANT('10000000'X),  /* TURN PABUNCON ON     *
*    PABPRIR0 BIT(32) CONSTANT('BFFFFFFF'X),  /* TURN PAB PRIOR OFF   *
*    PABPRIR1 BIT(32) CONSTANT('40000000'X),  /* TURN PAB PRIOR ON    *
*    PABRST0  BIT(32) CONSTANT('F7FFFFFF'X),  /* TURN PABRESET OFF    *
*    PABRST1  BIT(32) CONSTANT('08000000'X),  /* TURN PABRESET ON     *
*    PABDLAY0 BIT(32) CONSTANT('FDFFFFFF'X),  /* TURN PAB DELAY OFF   *
*    PABDLAY1 BIT(32) CONSTANT('02000000'X);  /* TURN PAB DELAY ON    *
*/* LOCKWORD FORMAT DSECT                                            */
*/*  INITIAL LEVEL                                     001 05/24/74  */
*DCL 1 ISTLOK BDY(WORD) BASED,                                  01S0898
*     2  LOKCT CHAR(1) BDY(WORD),       /* COUNT OF LOCK OWNERS      */
*     2  LOKCHN PTR(24),                /* ADDR OF NEXT RPH WAITING
*                                          ON LOCK                   */
*        3  LOKCHNG CHAR(3),            /* CHAIN/FLAGS               */
*           4 *        CHAR(2),                                 01S0898
*           4 *        BIT(8),                                  01S0898
*             5 *        BIT(6),                                01S0898
*             5  LOKPRY BIT(1),         /* PRIORITY FLAG, 1 = ON     */
*             5  LOKXCL BIT(1);         /* EXCLUSIVE FLAG, 1 = ON    */
*DCL LOKXCL1  BIT(32) CONSTANT('00000001'X); /* CONSTANT TO TURN LOKXCL
*                                          ON                        */
*DCL LOKPRY1  BIT(32) CONSTANT('00000002'X); /* CONSTANT TO TURN LOKPRY
*                                          ON                        */
*DCL LOKCHN1  BIT(32) CONSTANT('00FFFFFC'X); /* CONSTANT TO TURN LOKXCL
*                                          AND LOKPRY OFF            */
*DCL LOKCT1   BIT(32) CONSTANT('01000000'X); /* CONSTANT TO MAKE LOKCT
*                                          = 1                       */
*DCL LOKCT255 BIT(32) CONSTANT('FF000000'X); /* CONSTANT TO CHECK FOR
*                                          MAX LOKCT (255)           */
*              /* DYNAMIC PAB 1K633 */                          01S0904
* /* 1K0997 JAN 20, 1973  MB   */                               01S0904
* /* 1K1142 MAR 03, 1973  MB   */                               01S0904
* DCL 1 ISTDYPAB BDY(DWORD) BASED, /* LEVEL 1 DECLARE 1K633 */  01S0904
*       2  DYPTYPE CHAR(1), /* CONTROL BLOCK TYPE CODE 1K633 */ 01S0904
*       2  DYPLNGTH PTR(8), /* CONTROL BLOCK LENGTH (BYTES)  1K633 */
*       2 DYPFLGS CHAR(2),     /* FLAGS 1K633 */                01S0904
*       2 DYPCHAIN PTR(31),    /* CHAIN POINTER 1K633 */        01S0904
*       2 DYPTSKID PTR(31),    /* TASKID OR PTR TO PSS TABLES 1K633 */
*       2  DYPRSV01 PTR(31),   /* RESERVED TO PRESERVE ALIGNMENT
*                                                             1K0997 */
*       2 DYPPAB CHAR(LENGTH(ISTPAB)) BDY(DWORD); /* LENGTH OF 1K0997
*                                                    PAB         */
*DCL DYTYP   BIT(8) CONSTANT ('11'X);   /* TYPE           1K1142 */
*/* RPL HEADER                                                        *
*/*  REVISIONS                                         006 04/09/75   *
*DCL RPHPTR PTR(31) REGISTER(1) RESTRICTED;                     01S0906
*DCL  1  ISTRPH BDY(WORD) BASED(RPHPTR),                        01S0907
*       2  RPHCNTL FIXED(32),          /* CONTROL INFORMATION         *
*       3  RPHTYPE CHAR(1),            /* CONTROL BLOCK TYPE          *
*       3  RPHLNGTH PTR(8),            /* LENGTH IN BYTES             *
*       3  RPHFLAGS BIT(8),            /* SYSTEM DEPENDENT FLAGS      *
*         4  RPHOGIND BIT(1),          /* OPEN GATE INDICATOR         *
*         4  RPHSPGIN BIT(1),          /* SPECIAL GATE OPEN IND.      *
*         4  RPHAPTYP BIT(1),          /* APS IS A USER EXIT          *
*            5  RPHAUTEX BIT(1),        /*EXIT TO AUTHORIZED USER VS2 *
*         4  RPHSMQ BIT(1),            /* INDICATOR IF RPH IS TO BE   *
*                                      /* QUEUED                      *
*         4  RPHSMTYP BIT(1),          /* REQUEST TYPE IS BUFFER OR   *
*                                      /* DOUBLE-WORD                 *
*         4  RPHSMCLR BIT(1),          /* INDICATOR IF BUFFER TO BE   *
*                                      /* CLEARED                     *
*           4  RPHMLTCP BIT(1),        /* USED BY LOCAL 3270  SUPPORT *
*                                      /* WHEN BUILDING MULTIPLE CHAN *
*                                      /* PROGRAM                     *
*           4  RPHFSTLC BIT(1),        /* USED BY LOCAL 3270 SUPPORT  *
*                                      /* TO INDICATE FIRST LCCW      *
*              5  RPHFNFLG BIT(1),     /* LCCW SET FUNCTION FLAGS     *
*        3  RPHFLGB BIT(8),            /* SECOND FLAG BYTE            *
*           4  RPHLOCK BIT(1),         /* LOCKING OPTION              *
*           4  RPHBSSP BIT(1),         /* SYSTEM SERVICES PROGRESS    *
*           4  RPHFBAPS BIT(1),        /* STG. OBTAINED BY APS        *
*           4  RPHPGCMP BIT(1),        /* BIT ON INDICATES RESOURCE   *
*                                      /* MGR HAS COMPLETED UNLOCK    *
*           4  RPHNRSAV BIT(1),        /* DO NOT SAVE ON ACTIVATE     *
*           4  RPHRLCRA BIT(1),        /* RPH CAN BE RELEASED         *
*                                      /* WHEN PURGE COMPLETE         *
*           4  *        BIT(2),        /* RESERVED                    *
*       2  RPHRPHA PTR(31),            /* ADDR.OF NEXT RPL HEADER     *
*         3  RPHGATE BIT(1),           /* GATING FLAG                 *
*         3  *       BIT(7),           /* RESERVED                    *
*         3  RPHRPHAP PTR(24),                                  01S0907
*       2  RPHTSKID PTR(31),           /* TASK IDENTIFICATION         *
*                                      /* OR ADDR.OF APS TABLE        *
*          3  *     CHAR(3),           /* RPH TSK ID                  *
*          3  RPHTIK PTR(8),           /* TIK                         *
*       2  RPHDVTA PTR(31),            /* ADDR.OF  CURRENT DVT        *
*       2  RPHRESMA PTR(31) BDY(WORD), /* TPWAIT-POST INFO */   01S0907
*         3 RPHWPFLG CHAR(1),          /* WAIT-POST FLAGS */    01S0907
*           4 RPHRSKEY BIT(4),         /* STORAGE PROTECT KEY TO RESUME
*                                         PROCESSING                  *
*           4 RPHWT BIT(1),            /* WAIT BIT */           01S0907
*           4 RPHPT BIT(1),            /* POST BIT */           01S0907
*           4 RPHPURGE BIT(1),         /* RPH FLAGGED BY RECOVERY    */
*                                      /* TO BE PURGED BY PSS        */
*                                      /* VS/2 ONLY                  */
*           4 RPHRSV01 BIT(1),        /* RESERVED                    */
*         3 RPHRESUM PTR(24),          /* RESUME ADDRESS */     01S0907
*       2  RPHPABOF PTR(8),            /* OFFSET OF PAB IN CONTROL BLK*
*       2  RPHMAJCB PTR(24),           /* ADDR.OF MAJOR CONTROL BLOCK *
*       2  RPHWEA PTR(31),             /* ADDR.OF WORK ELEMENT        *
*         3  RPHCSPA PTR(31),          /* ADDR OF ISTCSP              *
*           4  RPHWEGT BIT(1),         /* GATE FOR WORK ELEMENT PROC. *
*       2  RPHSRPRM PTR(31),           /* SERVICE ROUTINE PARM.FIELD  *
*         3 RPHSRP12 FIXED(15),        /* COUNT OF Q'ED SMS REQUESTS  *
*         3 RPHSRP34 FIXED(15),        /* SIZE OF Q'ED SMS REQUESTS   *
*       2  RPHCRR PTR(31),             /* ADDR.OF COMPONENT RECOVERY  *
*                                      /* RECORD                      *
*       2  RPHPABQA PTR(31),           /* PAB QUEUE ADDRESS           *
*          3 RPHPABFG CHAR(1),         /* FLAG BYTE CARRIED FROM PAB  *
*          3 RPHPABQP PTR(24),         /* POINTER TO QUEUE OF PAB'S   *
*       2  RPHWORK CHAR(64) BDY(WORD), /* 16 WORD WORK AREA           *
*         3  RPHSAVE1 FIXED(31),       /*                             *
*           4  RPHSBYTE CHAR(1),       /* 1-BYTE SAVE FIELD           *
*           4  RPHSBITS BIT(8),        /* SAVE FIELD FOR FLAG BYTE    *
*              5  RPHSBIT1 BIT(1),     /* 1ST SAVE FIELD              *
*              5  RPHSBIT2 BIT(1),     /* 2ND SAVE FIELD              *
*              5  RPHSBIT3 BIT(1),     /* 3RD SAVE FIELD              *
*              5  RPHSBIT4 BIT(1),     /* 4TH SAVE FIELD              *
*              5  RPHSBIT5 BIT(1),     /* 5TH SAVE FIELD              *
*              5  RPHSBIT6 BIT(1),     /* 6TH SAVE FIELD              *
*              5  RPHSBIT7 BIT(1),     /* 7TH SAVE FIELD              *
*              5  RPHSBIT8 BIT(1),     /* 8TH SAVE FIELD              *
*           4  RPHSHALF FIXED(15),     /* HALF WORD SAVE AREA         *
*         3  RPHSAVE2 FIXED(31),       /*                             *
*         3  RPHSAVE3 FIXED(31),       /*                             *
*         3  RPHSAVE4 FIXED(31),       /*                             *
*         3  RPHSAVE5 FIXED(31),       /*                             *
*         3  RPHSAVE6 FIXED(31),       /*                             *
*         3  RPHSAVE7 FIXED(31),       /*                             *
*         3  RPHSAVE8 FIXED(31),       /*                             *
*         3  RPHSAVE9 FIXED(31),       /*                             *
*         3  RPHSAV10 FIXED(31),       /*                             *
*         3  RPHSAV11 FIXED(31),       /*                             *
*         3  RPHSAV12 FIXED(31),       /*                             *
*         3  RPHSAV13 FIXED(31),       /*                             *
*         3  RPHSAV14 FIXED(31),       /*                             *
*         3  RPHSAV15 FIXED(31),       /*                             *
*         3  RPHSAV16 FIXED(31),       /*                             *
*       2  RPHNEXPO PTR(31);           /* ADDR.NEXT RPH TO BE POSTED  *
* DCL RPTYPE BIT(8) CONSTANT('01'X);   /* TYPE CODE FOR RPH           *
* DCL RPHWT0 BIT(32) CONSTANT('F7FFFFFF'X);   /* TURN RPHWT OFF */
* DCL RPHWT1 BIT(32) CONSTANT('08000000'X);   /* TURN RPHWT ON */
* DCL RPHPT0 BIT(32) CONSTANT('FBFFFFFF'X);   /* TURN RPHPT OFF */
* DCL RPHPT1 BIT(32) CONSTANT('04000000'X);   /* TURN RPHPT ON */
* DCL RPHPABQ1 BIT(24) CONSTANT('000000'X); /* TURN RPHPBQ GATE */
*/*  REVISIONS                                             03/04/77   *
*DCL ATCLCPTR PTR LOCATION(1032);      /* POINTER TO ATCVT            *
*DCL  1  ISTATCVT BDY(DWORD) BASED,                             01S0915
*        2  ATCCOM BDY(WORD),          /* SYSTEM INDEPENDENT FIELDS   *
*           3  ATCSTAT CHAR(4),        /* VTAM  STATUS INDICATORS     *
*              4  ATCSTAT1 CHAR(1),    /* VTAM  STATUS BYTE 1         *
*                 5  ATCSTART BIT(1),  /* VTAM  IS STARTING           *
*                 5  ATCACTIV BIT(1),  /* VTAM  IS ACTIVE             *
*                 5  ATCSNHLT BIT(1),  /* VTAM  SESSION HALT          *
*                 5  ATCQKHLT BIT(1),  /* VTAM  QUICK HALT            *
*                 5  ATCNETSL BIT(1),  /* NETSOL=YES SPECIFIED ON CMD *
*                 5  ATCINHLT BIT(1),  /* INTERNAL VTAM HALT QUICK    *
*                 5  ATCMDHLT BIT(1),  /* VTAM CMD PROC HALTED        *
*                 5 * BIT(1),          /* RESERVED                    *
*              4  ATCSTFLG BIT(8),     /* STORAGE MANAGEMENT FLAGS    *
*                 5  ATCHSDMF BIT(1),  /* SYSTEM SLOW DOWN FLAG       *
*              4  ATCPOFLG BIT(8),     /* PROGRAM OPERATOR            *
*                                      /* INTERFACE FLAGS             *
*                 5 ATCPOUNS BIT(1),   /* APPLICATION AUTHORIZED TO   *
*                                      /* RECEIVE UNSOLICITED MESSAGES*
*                                      /* 1 = YES                     *
*                 5 *        BIT(7),   /* RESERVED                    *
*              4  ATCSTAT4 CHAR(1),    /* VTAM  STATUS BYTE 4         *
*                 5  ATCPRTAT BIT(1),  /* 1 = TRACE PRINT ACTIVE,
*                                         0 = NOT ACTIVE              *
*                 5  ATCTPRT BIT(1),   /* WHEN 1, TPRINT IN PROCESS   *
*                 5  ATCMTST BIT(1),   /* WHEN 1, MODIFY TEST IN
*                                         PROCESS                     *
*                 5  ATCNCSD BIT(1),   /* NCS QUIESCED DURING HALT    *
*                 5  ATCVTTRC BIT(1),  /* VTAM TRACE, 1=ACTIVE        *
*                 5  ATCRSV04 BIT(3),  /* RESERVED                    *
*           3  ATCAPI PTR(31),         /* ADDR OF API ROUTINE         *
*           3  ATCDCFRR PTR(31),       /* POINTER TO FRR OF CONTROL
*                                         LAYER,INITIALIZED BY OPENDST*
*           3  ATCRDT PTR(31),         /* POINTER TO FIRST RDT        *
*           3  ATCSRT PTR(31),         /* POINTER TO SRT DIRECTORY    *
*           3  ATCASCHD PTR(31),       /* POINTER TO AP SCHEDULER     *
*           3  ATCECMOD CHAR(4),       /* ECB FOR MODIFY COMMAND PROC.*
*           3  ATCMODQ PTR(31),        /* POINTER FOR OUTPUT QUEUE    *
*                                      /* FOR MODIFY COMMAND          *
*           3  ATCECHLT CHAR(4),       /* ECB FOR HALT COMMAND        *
*           3  ATCHALTQ PTR(31),       /* POINTER TO OUTPUT QUEUE     *
*                                      /* FOR HALT COMMAND            *
*           3  ATCECVRY CHAR(4),       /* ECB FOR VARY COMMAND PROC.  *
*           3  ATCVARYQ PTR(31),       /* POINTER TO OUTPUT QUEUE     *
*                                      /* FOR VARY COMMAND            *
*           3  ATCECDSP CHAR(4),       /* ECB FOR DISPLAY COMMAND     *
*           3  ATCDSPLQ PTR(31),       /*  POINTER TO OUTPUT QUEUE    *
*                                      /* FOR DISPLAY COMMAND         *
*           3  ATCOCHA PTR(31),        /* POINTER TO OCT HEADER       *
*           3  ATCECSES CHAR(4),       /* ECB TO HALT SESSION MODE    *
*           3  ATCECVRQ CHAR(4),       /* ERP ECB FOR VARY REQ. INFO. *
*                                      /* REQUEST NOTIFICATION        *
*           3  ATCVPARM PTR(31),       /* ADDR OF VARY PARAMETERS     *
*           3  ATCECOPC CHAR(4),       /* ECB TOINDICATE OPERATOR     *
*                                      /* CONTROL PROCESSING COMPLETE *
*           3  ATCECNET CHAR(4),       /* ERP ECB FOR NETWORK         *
*                                      /* CONFIGURATION REQUEST       *
*           3  ATCECPRM PTR(31),       /* POINTER TO QAB FOR ERP'S    *
*                                      /* ECB PARAMETERS              *
*           3  ATCHLTMS PTR(31),       /* POINTER TO HALT COMMAND     *
*                                      /* OR HALT RETURN MESSAGE      *
*           3  ATCFSB PTR(31),         /* PTR TO FEEDBACK STATUS      *
*                                      /* BLOCK                       *
*           3  ATCFRSCH PTR(31),       /* POINTER TO FEEDBACK         *
*                                      /* ROUTINE SCHEDULER           *
*           3  ATCRDTH PTR(31),        /*  POINTER RDT HEADER         *
*           3  ATCACCTA PTR(31),       /* POINTER TO INSTALLATION     *
*                                      /* ACCOUNTING ROUTINE          *
*           3  ATCAUTHA PTR(31),       /* POINTER TO INSTALLATION     *
*                                      /* AUTHORISATION ROUTINE       *
*           3  ATCPTCHA PTR(31),       /* PTR TO VTAM PATCH AREA      *
*           3  ATCCONFT PTR(31),       /* POINTER TO VTAM             *
*                                      /* CONFIGURATION TABLE         *
*           3  ATCFDVT PTR(31),        /* PTR TO FIRST DVT FOR O/C    *
*           3  ATCFEPT PTR(31),        /* PTR TO FIRST EPT FOR O/C    *
*           3  ATCDVTPT PTR(31),       /* ADDR OF LOAD MOD FOR        *
*                                      /* TYPE=VTAM TRACING           *
*           3  ATCBPDA PTR(31),        /* PTR TO BUFFER POOL DIRECTORY*
*           3  ATCADD PTR(31),         /* POINTER TO ADD PROCEDURE    *
*           3  ATCREMOV PTR(31),       /* POINTER TO REMOVE PROCEDURE *
*           3  ATCIOTRC PTR(31),       /*  POINTER TO I/O TRACE       *
*                                      /* PROCEDURE                   *
*              4 ATCTHTRC PTR(31),     /* ADDR OF TH TRACE ROUTINE    *
*                5 ATCTPBUF PTR(31),   /* TPIOS BUFFER TRACE(ISTRARTP)*
*           3  ATCBFTRC PTR(31),       /* PTR TO BUFFER TRACE         *
*                                      /* PROCEDURE                   *
*           3  ATCFBRPH PTR(31),       /* ADDR OF FEEDBACK PROC RPH   *
*           3  ATCBLDLA PTR(31),       /* ADDR OF BLDL ROUTINE        *
*           3  ATCALOAD PTR(31),       /* ADDR OF ALOAD ROUTINE       *
*           3  ATCREADA PTR(31),       /* ADDR OF SOURCE READ ROUTINE *
*           3  ATCGTSTR PTR(31),       /* ADDR OF GETSTOR ROUTINE     *
*           3  ATCFRSTR PTR(31),       /* ADDR OF FREESTOR ROUTINE    *
*           3  ATCSTMA PTR(31),        /* ADDR OF SM INITIALIZATION   *
*                                      /* ROUTINE                     *
*           3  ATCACDA PTR(31),        /* ADDR OF FIRST ACDEB         *
*           3  ATCSMRQ PTR(31),        /* ADDR OF REQUEST STORAGE     *
*                                      /* ROUTINE                     *
*           3  ATCSMQU PTR(31),        /* ADDR OF QUEUE REQUEST RTNE
*                                         - DOS ONLY                  *
*           3  ATCSMRS PTR(31),        /* ADDR OF RELEASE STORAGE     *
*                                      /* ROUTINE                     *
*           3  ATCSMRC PTR(31),        /* ADDR OF RECOVER STORAGE     *
*                                      /* ROUTINE  - DOS ONLY         *
*           3  ATCSMBQ PTR(31),        /* PTR TO Q'ED REQ. SMS RTN.   *
*           3  ATCFIRA PTR(31),        /* ADDR OF FEEDBACK INITIATION *
*                                      /* RPH                         *
*           3  ATCSRTAD PTR(31),       /* PTR TO SRTADD ROUTINE       *
*           3  ATCSRTDF PTR(31),       /* PTR TO SRTDELE ROUTN        *
*           3  ATCDCC60 PTR(31),       /* PTR TO ISTDCC60 - CTL. LAYER
*                                         MOVE TO USER AREA           *
*           3  ATCDCC61 PTR(31),       /* PTR TO ISTDCC61 - CTL. LAYER
*                                         MOVE FIXED TO PAGABLE       *
*/*  BEGIN 'ANY' DVT                                                  *
*           3  ATCNERST PTR(31),       /* PTR TO ISTDCC00 - REQUEST-ST*
*           3  ATCNERCV PTR(31),       /* PTR TO ISTRCC21-RECEIVE OB  *
*           3  ATCNERNE PTR(31),      /* PTR TO ISTDCC25 - READ-ANY   *
*           3  ATCNERFN PTR(31),      /* PTR TO ISTDCC02 - REQUEST-FN *
*/*  END 'ANY' DVT                                                    *
*           3  ATCAPOST PTR(31),      /* PTR TO VTAM  POST ROUTINE    *
*           3  ATCVTMID CHAR(2),      /* HOST MAJOR NODE I.D.         *
*           3  ATCRSV11 CHAR(2),      /* RESERVED                     *
*           3 ATCRCC63 PTR(31),  /* HSKPANYQ POINTER                  *
*           3 ATCRCC26 PTR(31),  /* SEND RESPONSE POINTER             *
*           3 ATCRCC65 PTR(31),  /* SET RPL POINTER                   *
*           3  ATCNESAL PTR(31),      /* PTR TO ISTDCC24 - SOLICIT-ALL*
*           3  ATCNERAP PTR(31),       /* PTR TO ISTDCC85 - READ ANY
*                                         PURGE                       *
*           3 ATCACTRM FIXED(15),     /* COUNT OF ACTIVE TERMINALS    *
*           3 ATCCIDM BIT(16),        /* CID MASK                     *
*           3 ATCMSGSP BIT(8), /* RESERVED FOR MESAGE SURPRESSION     *
*         2 ATCMAXID PTR(8),   /* MAXIMUM NUMBER OF MAJOR NODES, 0 =
*                                 NUMBER OF ENTRIES IN THE MNT        *
*         2 ATCRSV16 CHAR(2),  /* NOT USED                            *
*         2 ATCMNT PTR(31),    /*PTR TO MAJOR NODE TABLE -SET BY SYS.
*                                DEF. REF. BY ISTSDCCB (CBDEF), 01S0915
*                                ISTSDCCI (CINDEXY)                   *
*         2 ATCCDADD PTR(31),  /*PTR TO CIDADD ROUTINE ISTSDCCA 01S0915
*                                 REF. BY CIDCTL MACRO                *
*         2 ATCCDDEL PTR(31),  /*PTR TO CIDDEL ROUTINE ISTSDCCD 01S0915
*                                 REF. BY CIDCTL MACRO                *
*         2 ATCCDFND PTR(31),  /*PTR TO CIDFND ROUTINE IATSDCCF 01S0915
*                                 REF. BY CIDCTL MACRO                *
*         2 ATCESC01 PTR(31),  /*PTR TO ESC01                         *
*         2 ATCESC02 PTR(31),  /*PTR TO ESC02                         *
*         2 ATCCSMR PTR(31),        /* PTR TO CONNECTION SERVICES     *
*                                   /*  MASTER ROUTINE                *
*           3 ATCCSMA PTR(31),      /* PTR TO CONNECTION SERVICES
*                                      MASTER ROUTINE                 *
*         2 ATCOCRT PTR(31),        /* PTR TO OPEN/CLOSE ROUTINE      *
*         2 ATCUEP  PTR(31),        /* POINTER TO USER EXIT           *
*         2 ATCSHRTN CHAR(8),       /* NAME OF VTAM  SHARED RTN       *
*                                   /*  TO BE LOADED                  *
*         2 ATCSHRFG BIT(8),        /* ATTRIBUTE FLAGS                *
*           3 ATCLAST BIT(1),       /* INDICATE HTIS IS LAST MODULE   *
*         2 ATCXRANG CHAR(1),       /* NUMBER OT BITS IN X-VALUE
*                                       PORTION   OF CID              *
*         2 ATCSAF   CHAR(2),       /* SUB AREA ADDRESS FIELD         *
*         2 ATCEPA PTR(31),         /* ENTRY POINT ADDR OF LOADED     *
*         2 ATCALERT PTR(31),       /* POINTER TO ALERT-ROUTINE 01S0915
*                                      ISTSDCAL                       *
*         2 ATCDVLOD PTR(31),       /* PTR TO ISTSDCOD                *
*         2 ATCTRCPT PTR(31),       /* POINTER TO TRACE PARM LIST     *
*         2 ATCDVT   PTR(31),       /* POINTER TO FIRST DVT ON CHAIN  *
*         2 ATCEPT   PTR(31),       /* POINTER TO FIRST EPT ON CHAIN  *
*         2 ATCMSGP PTR(31),        /* POINTER TO TPMSG PROCESSOR     *
*         2 ATCMSGM PTR(31),        /* POINTER TO TPMSG - MESSAGE
*                                      CSECT                          *
*         2 ATCTRPAB  PTR(31),      /* ADDRESS OF TRACE WRITER PAB    *
*         2 ATCVTLOD PTR(31),       /* ADDR OF VTAM LOAD LIST         *
*         2 ATCECPRT CHAR(4),       /* ECB FOR TRACE FILE PRINT       *
*         2 ATCZDVTB PTR(31),       /* ADDRESS OF ISTZCFBI            *
*         2 ATCECTLP CHAR(4),       /* TOLTEP ECB                     *
*         2 ATCRVCHS CHAR(8),       /* RESERVED                       *
*         2 ATCCRME  PTR(31),       /* VARY PSS CONTROL MECHANISM     *
*         2 ATCHPGM,                /* BUFFER INFORMATION            */
*           3 ATCHBFNO FIXED(15),   /* NUMBER OF BUFFS FOR CHANNEL   */
*           3 ATCHBSIZ FIXED(15),   /* BUFFER SIZE IN BYTES          */
*         2 ATCDEBCH PTR(31),       /* CLOSE DEB CHAIN PTR           */
*         2 ATCTODVT PTR(31),       /* THE TOLTEP DVT PTR POINTED
*                                      TO BY 3RD WORD OF PAB         */
*         2 ATCADEL  PTR(31),       /* A DELETE ROUTINE ADDRESS      */
*         2 ATCCDPTR PTR(31),       /* PTR TO ISTOCCCD - DOS ONLY    */
*         2 ATCLDNCS PTR(31),       /* PTR TO NCSPL FOR LOAD/DUMP    */
*         2 ATCLDECB BIT(32),       /* ECB FOR LOAD/DUMP SUBTASK     */
*         2 ATCAPCR5 PTR(31),       /* POINTER TO ISTINCR5           */
*         2 ATCRSV69 PTR(31),       /* RESERVED TO SYNCH WITH DOS    */
*         2 ATCNODEL CHAR(8),       /* VSAM DATA SET NAME            */
*         2 ATCNODDS PTR(31),       /* POINTER TO RPL                */
*         2 ATCONFIG CHAR(8),       /* START VTAM CONFIG = PARAMETER */
*         2 ATCRSV99 CHAR(4),       /* RESERVED FOR LATER POINTERS   */
*         2 ATCAP33 PTR(31),        /* PTR TO ISTAPC33               */
*         2 ATCAP35 PTR(31),        /* PTR TO ISTAPC35               */
*         2 ATCAP36 PTR(31),        /* PTR TO ISTAPC36               */
*         2 ATCDVTLK CHAR(LENGTH(ISTLOK)), /* LOCK WORD FOR DVT LOCK */
*         2 ATCCDFIN PTR(31),       /* POINTER TO ISTSDCRR           */
*         2 ATCCDFDN PTR(31),       /* POINTER TO ISTSDCCN           */
*         2 ATCVOCLK CHAR(LENGTH(ISTLOK)), /* VOCLOCK LOCK           */
*         2 ATCRDTLK CHAR(LENGTH(ISTLOK)), /* RDTLOCK LOCK           */
*         2 ATCRSV97 PTR(31),              /* DWORD ALIGNMENT        */
*         2 ATCVPAB1 CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* PAB FOR VARY
*                                           UNDER PSS CONTROL        */
*         2 ATCPGPAB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* ERP PAB FOR
*                                      PURGE                         */
*         2 ATCDLRPB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* DUMP LOAD &
*                                           RESTART PAB              */
*         2 ATCCCLAD PTR(31),       /* ADDRESS OF VARY ERP (ISTINCCL)*/
*         2 ATCCDLAD PTR(31),       /* ADDRESS OF VARY DUMP,LD RSTRT
*                                      (ISTINCDL)                    */
*         2 ATCOCCOB PTR(31),       /* ADDRESS ISTOCCOB              */
*         2 ATCOCCCB PTR(31),       /* ADDRESS ISTOCCCB              */
*         2 ATCTIPAB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* A PAB
*                                           FOR ISTOLTP              */
*         2 ATCTCIPB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* A PAB
*                                           FOR TOLTEP CLIP          */
*         2 ATCVTIPB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* A PAB
*                                           FOR TOLTEP-VTAM INTERFACE*/
*         2 ATCTCLOM PTR(31),      /* ADDR TOLTEP CLOP PROC          */
*         2 ATCTCLIM PTR(31),      /* ADDR TOLTEP CLIP PROC          */
*         2 ATCVTINM PTR(31),      /* ADDR TOLTEP-VTAM INTF PROC     */
*         2 ATCTACB  PTR(31),      /* TOLTEP ACB                     */
*         2 ATCRSV10 CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* RESERVED  */
*         2 ATCPTR00 CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* A PAB     */
*         2 ATCCFEAD PTR(31),          /* ADDR OF ISTINCFE           */
*         2 ATCVLCNT CHAR(4) BDY(HWORD), /* VARY DEVICE ONLINE COUNTS*/
*           3 ATCRNCNT PTR(16),        /* 370X COUNT                 */
*           3 ATCLCLCT PTR(16),        /* 3270 COUNT                 */
*         2 ATCS49XI PTR(31),          /* ADDRESS OF ISTPICXI        */
*         2 ATCS49XL PTR(31),          /* ADDRESS OF ISTPICXL        */
*         2 ATCPODVT PTR(31),          /* PTR TO PROGRAM OPERATOR DVT*/
*         2 ATCRNO,                                             01S0915
*           3 *        CHAR(1),                                 01S0915
*           3 ATCPOIA  PTR(24),        /* PTR TO PROGRAM OPERATOR    */
*                                      /* INTERFACE AREA             */
*         2 ATCSOPD CHAR(8) BDY(WORD), /* SESSION CONTROL            */
*           3 ATCSEC01 PTR(31),        /* OUTBOUND PROCESSING        */
*           3 ATCSEC10 PTR(31),        /* DVT                        */
*         2 ATCSIPD CHAR(12) BDY(WORD),/* SESSION CONTROL            */
*           3 ATCSEC21 PTR(31),        /* INBOUND PROCESSING         */
*           3 ATCSEC30 PTR(31),        /* FEEDBACK                   */
*           3 ATCSEC40 PTR(31),        /* DVT                        */
*         2 ATCSECST CHAR(4) BDY(WORD),/* SESSION CONTROLSESS TERM   */
*           3 ATCSEC51 PTR(31),        /* RECOVERY DVT               */
*         2 ATCNMCTR FIXED(15),        /* NAME COUNTER               */
*         2 ATCSTAT2 BIT(8),           /* TRACE FLAGS                */
*           3 ATCTRAPI BIT(1),         /* API                        */
*           3 ATCTRESC BIT(1),         /* ESC                        */
*           3 ATCTRPSS BIT(1),         /* PSS                        */
*           3 ATCTRLOK BIT(1),         /* LOCKS                      */
*           3 ATCTRSMS BIT(1),         /* SMS                        */
*           3 *        BIT(3),         /* RESERVED                   */
*         2 *        BIT(8),           /* RESERVED                   */
*         2 ATCSRTAB PTR(31),          /* SEARCH LOGON MODE TABLE    */
*                                      /* RTN ADDRESS (ISTINCSH)     */
*         2 ATCUSSPT PTR(31),          /* DEFAULT USS DEFINITION     */
*                                      /* TABLE ADDRESS (ISTINCDT)   */
*         2 ATCMODTB PTR(31),          /* DEFAULT SYSTEM LOGON MODE  */
*                                      /* TABLE ADDRESS (ISTINCLM)   */
*         2 ATCINCW3 PTR(31),          /* ADDRESS OF ISTINCW3        */
*         2 ATCIOECB PTR(31),          /* ECB USED BY IOS -          */
*                                      /* POINTED TO BY IOBECBPT     */
* 2 ATCVDPAB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD),                 01S0915
*                                    /* SSCP COMMAND PROCESSING PAB  */
* 2 ATCVFPAB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD),                 01S0915
*                                    /* SSCP FRONT END PAB           */
* 2 ATCVDLOK CHAR(LENGTH(ISTLOK)),   /* SSCP SERIALIZATION LOCK      */
*/* END OF COMMON AREA                                               */
*/* VS1/VS2 COMMON CODE.                                             */
*        2  ATCVTBAM CHAR(4),                                   01S0915
*           3  *     CHAR(3),          /* RESERVED                    *
*           3  *     CHAR(1),          /* FLAGS                       *
*              4 ATCVTMAB BIT(1) ABNL, /* ABEND IN VTAM JOBSTEP       *
*              4 *        BIT(7),      /* RESERVED                    *
*        2  ATCAOSM BDY(DWORD),                                 01S0915
*/*                                                                   *
*           3  ATCSRBRT PTR(31),       /* POINTER TO ROUTINE UNDER    *
*                                      /* SRB CONTROL                 *
*           3  ATCGSRBQ PTR(31),       /* READY QUEUE FOR GLOBAL SRB'S*
*              4  ATCGSRBG BIT(8),     /* READY QUEUE GATE BYTE       *
*                 5  ATCGSRBF BIT(1),  /* READY QUEUE GATE BIT        *
*           3  ATCPRPH PTR(31),        /* PTR TO PREALLOCATED RPH     *
*           3  ATCCMTCB PTR(31),       /* PTR TO COMMUNICATIONS TASK  *
*                                      /* TCB                         *
*           3  ATCAP11 PTR(31),        /* PTR TO ISTAPC11             *
*           3  ATCAP12 PTR(31),        /* PTR TO ISTAPC12             *
*           3  ATCAP31 PTR(31),        /* PTR TO ISTAPC31             *
*           3  ATCAP32 PTR(31),        /* PTR TO ISTAPC32             *
*           3  ATCAP34 PTR(31),        /* PTR TO ISTAPC34             *
*           3  ATCAP52 PTR(31),        /* PTR TO ISTAPC52             *
*           3  ATCAP53 PTR(31),        /* PTR TO ISTAPC53             *
*           3  ATCAP54 PTR(31),        /* PTR TO ISTAPC54             *
*           3  ATCAP57 PTR(31),        /* PTR TO ISTAPC57             *
*           3  ATCAP58 PTR(31),        /* PTR TO ISTAPC58             *
*           3  ATCAP61 PTR(31),        /* PTR TO ISTAPC61             *
*           3  ATCAP63 PTR(31),        /* PTR TO ISTAPC63             *
*           3  ATCAP64 PTR(31),        /* PTR TO ISTAPC64             *
*           3  ATCZFSVT PTR(31),       /* TPIOS FIXED SRVICES VCTR TAB*
*           3  ATCZPSVT PTR(31),       /* TPIOS PAGBL SRVCES VCTR TABL*
*           3  ATCICNCB PTR(31),       /* HEAD OF ICNCB QUEUE         *
*           3  ATCZDVT1 PTR(31),       /* TPIOS SLODWN RECOVRY PRCSR  *
*           3  ATCZDVT3 PTR(31),       /* 370X FEEDBACK STAT CNTRL RTR*
*           3  ATCZDVT4 PTR(31),       /* OPERATOR MESSAGE SCHEDULER  *
*           3  ATCZDVT6 PTR(31),       /* DIALOGUE SCHEDULER (INBOUND)*
*           3  ATCAP65 PTR(31),        /* PTR TO ISTAPC65            */
*           3  ATCICAPP CHAR(20) BDY(WORD), /* 3705 APPENDAGE VECTOR  *
*              4  ATCCDRPH PTR(31),    /* ADDR CLOSE DEB RPH    01S0915
*                                         (DUMMY EOA APP.)           */
*              4  ATCZSIOA PTR(31),    /* ADDR 3705 SIO APPENDAGE    */
*              4  ATCCDTCB PTR(31),    /* VTAM TCB (DUMMY PCI APP.)  */
*              4  ATCZCEA PTR(31),     /* ADDR 3705 CHANNEL END 01S0915
*                                         APPENDAGE                  */
*              4  ATCZAEA PTR(31),     /* ADDR 3705 CHANNEL END 01S0915
*                                         APPENDAGE                  */
*           3  ATCLDAPP CHAR(20) BDY(WORD), /* LOCAL 3270 APPENDAGE
*                                         VECTOR                     */
*              4  ATCCDTID PTR(31),    /* TASK ID OF VTAM       01S0915
*                                         (DUMP EOE)                 */
*              4  ATCSMFRR PTR(31),    /* ADDR OF SMS FRR       01S0915
*                                         (DUMMY SIOA)               */
*              4  ATCRSV17 PTR(31),    /* RESERVED FOR ALIGNMENT     */
*              4  ATCZLCEA PTR(31),    /* ADDR 3270 CHANNEL END 01S0915
*                                         APPENDAGE                  */
*              4  ATCZLAEA PTR(31),    /* ADDR 3270 CHANNEL END 01S0915
*                                         APPENDAGE                  */
*           3  ATCDAPVT CHAR(24) BDY(WORD),  /* DUMMY APPENDAGE 01S0915
*                                         VECTOR TABLE FOR LOAD/DVMMY*/
*              4  ATCDEOEA PTR(31),    /* ADDRESS OF DUMMY END  01S0915
*                                         OF EXTENT APPENDAGE        */
*              4  ATCDSIOA PTR(31),    /* ADDRESS OF DUMMY END  01S0915
*                                         OF SIO APPENDAGE           */
*              4  ATCDPCIA PTR(31),    /* ADDRESS OF DUMMY PCI  01S0915
*                                         APPENDAGE                  */
*              4  ATCDCEA PTR(31),     /* ADDRESS OF CHANNEL END
*                                         APPENDAGE                  */
*              4  ATCDXCEA PTR(31),    /* ADDRESS OF ABNORMAL   01S0915
*                                         END APPENDAGE              */
*              4  ATCDAPDG CHAR(2),    /* DUMMY APPENDAGE            */
*              4  ATCRSV56 CHAR(2),    /* RESERVED                   */
*           3  ATCZDVT7 PTR(31),       /* ADDR OF RESET CLEANUP 01S0915
*                                         (PHASE 1)                   *
*           3  ATCZDVT8 PTR(31),       /* 3270 LOCAL TEST AND CTL
*                                         FEEDBACK ROUTER            */
*           3  ATCZDVT9 PTR(31),       /* ADDRESS OF ISTZDFKA        */
*           3  ATCZDVTA PTR(31),       /* ADDRESS OF ISTZCFIA        */
*           3  ATCZDVTX PTR(31),       /* ADDRESS OF TRUNK LINE 01S0915
*                                         DEACTIVATE ROUTINE         */
*           3  ATCZLPVT PTR(31),       /* ADDRESS OF ISTZPSVA        */
*           3  ATCZLFVT PTR(31),       /* TPIOS 3270 LOCAL FIXED
*                                         SERVICES VECTOR TABLE      */
*           3  ATCZPAB1 CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* PAB FOR
*                                         TEST AND CTL FEEDBACK ROUTER*
*           3  ATCZPAB2 CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* 370X
*                                         STATUS AND FEEDBACK ROUTER
*                                         DYNAMIC PAB                */
*           3  ATCAP51  PTR(31),       /* PTR TO ISTAPC51            */
*           3  ATCZDFJ0 PTR(31),       /* ADDR OF ISTZDFJ0           */
*           3  ATCAP37  PTR(31),       /* PTR TO ISTAPC37            */
*           3  ATCAP38  PTR(31),       /* PTR TO ISTAPC38            */
*           3  ATCDMAPP PTR(31),       /* DUMMY APPENDAGE ROUTINE    */
*                                      /* FOR ABEND                  */
*           3  ATCRPT12 PTR(31),       /* RESERVED                   */
*        3  ATCCRA   CHAR(8) BDY(DWORD), /* AVAILABLE CRA             *
*           4 ATCCRAQ  PTR(31),          /* QUEUE OF AVAILABLE CRAS   *
*           4 ATCCRACN FIXED(31),        /* COUNTS                    *
*             5 ATCCRARC FIXED(16),      /* ENQUEUE COUNT TO ALLOW    *
*                                        /* MULTIPLE SIMUALTANIOUS    *
*                                        /* ENQUEUES AND DEQUEUES     *
*             5 ATCCRAAC FIXED(16),      /* COUNT OF CRAS ON AVAIL Q  *
*        3  ATCSRB   CHAR(8) BDY(DWORD), /* AVAILABLE SRBS            *
*             4 ATCSRBQ  PTR(31),        /* QUE OF AVAILABLE SRBS     *
*             4 ATCSRBCN FIXED(31),      /* COUNTS                    *
*               5 ATCSRBRC FIXED(16),    /* ENQUEUE COUNT TO ALLOW    *
*                                        /* MULTIPLE SIMUALTANIOUS    *
*                                        /* ENQUEUES AND DEQUEUES     *
*               5 ATCSRBAC FIXED(16),    /* COUNT OF SRBS ON AVAIL Q  *
*        3  ATCCRPL  CHAR(8) BDY(DWORD), /* AVAILABLE CRPLS           *
*             4 ATCCRPLQ PTR(31),        /* QUE OF AVAILABLE CRPLS    *
*             4 ATCRPLCN FIXED(31),      /* COUNTS                    *
*               5 ATCRPLRC FIXED(16),    /* ENQUEUE COUNT TO ALLOW    *
*                                        /* MULTIPLE SIMUALTANIOUS    *
*                                        /* ENQUEUES AND DEQUEUES     *
*               5 ATCRPLAC FIXED(16),    /* COUNT OF CRPLS ON AVAIL Q *
*           3  ATCSQAFR BDY(DWORD),    /* DOUBLE WORD FOR CDS   01S0915
*                                          SQA RELEASE       @VSRIUBL*/
*             4 ATCORTBF PTR(31),      /* ANCHOR FOR TO-BE-     01S0915
*                                          FREED STG Q       @VSRIUBL*/
*             4 ATCORTBC PTR(31),      /* PTR TO TCB OF TASK    01S0915
*                                          OWNING STG Q      @VSRIUBL*/
*               5 ATCORSRB PTR(31),    /* PTR TO SMS SRB     @VSRIUBL*/
*                 6 ATCORQG  BIT(1)ABNL, /* SRB GATE FOR SMS @VSRIUBL*/
*           3  ATCOROBT PTR(31),      /* ANCHOR FOR OBTAINED    01S0915
*                                         STAGE              @VSRIUBL*/
*           3  ATCORFRL PTR(31),      /* ADDR OF ISTORFRL    @VSRIUBL*/
*           3  ATCORFMG PTR(31),      /* ADDR OF ISTORFMG    @VSRIUBL*/
*           3  ATCINFDD PTR(31),      /* ADDR OF ISTINFDD    @VSRIUBL*/
*           3  ATCAIWT  PTR(31),      /* ADDRESS OF BYTE        01S0915
*                                         FOLLOWING WAIT IN     01S0915
*                                         ISTAICCK           @VSRIUBL*/
*           3  *        BIT(8),       /* RESERVED            @VSRIUBL*/
*             4 ATCABEN BIT(1)ABNL,   /* VTAM IS ABNORMALLY     01S0915
*                                         ENDING             @VSRIUBL*/
*             4 ATCOPKL BIT(1)ABNL,   /* OPERATOR IS ENDING     01S0915
*                                         VTAM               @VSRIUBL*/
*             4 ATCSNUF BIT(1)ABNL,   /* RECURSIVE VTAM ABEND   01S0915
*                                         DURING RSCE MGR       01S0915
*                                         OPERATION          @VSRIUBL*/
*             4 *       BIT(5),       /* RESERVED            @VSRIUBL*/
*           3  *        BIT(24),      /* RESERVED            @VSRIUBL*/
*           3  ATCRPT27 PTR(31),       /* RESERVED                   */
*           3  ATCRPT28 PTR(31),       /* RESERVED                   */
*           3  ATCRPT29 PTR(31),       /* RESERVED                   */
*           3  ATCRPT30 PTR(31),       /* RESERVED                   */
*           3  ATCRPT31 PTR(31),       /* RESERVED                   */
*           3  ATCRPT32 PTR(31),       /* RESERVED                   */
*           3  ATCRPT33 PTR(31),       /* RESERVED                   */
*           3  ATCRPT34 PTR(31),       /* RESERVED                   */
*           3  ATCRPT35 PTR(31),       /* RESERVED                   */
*           3  ATCRPT36 PTR(31),       /* RESERVED                   */
*           3  ATCRPT37 PTR(31),       /* RESERVED                   */
*           3  ATCRPT38 PTR(31),       /* RESERVED                   */
*           3  ATCRPT39 PTR(31),       /* RESERVED                   */
*           3  ATCRPT40 PTR(31),       /* RESERVED                   */
*/* END OF VS1/VS2 COMMON CODE.                                      */
*/* START OF VS2 UNIQUE CODE.                                        */
*           3  ATCVTFLG BIT(32),                                01S0915
*              4 ATCVTACT BIT(1),      /* VTT ACTIVE                 */
*              4 *        BIT(31),     /* RESERVED                   */
*           3  ATCHLTCB PTR(31),       /* ECB FOR HALTING VTAM       */
*           3  ATCATA10 PTR(31),       /* PTR TO ISTATM10            */
*           3  ATCZLAAB PTR(31),       /* PTR TO ISTZLFAB            */
*           3  ATCCACXA PTR(31),       /* PTR TO ISTCFCXA            */
*           3  ATCSMARA PTR(31),       /* PTR TO ISTORFRA            */
*           3  ATCSMAID PTR(31),       /* PTR TO ISTORFID            */
*           3  ATCTPWQA PTR(31),       /* WAIT Q ANCHOR FOR TPIOS    */
*           3  ATCSMAPR PTR(31),       /* PTR TO ISTORFPR            */
*           3  ATCSMABF PTR(31),       /* PTR TO ISTORFBF            */
*           3  ATCPSTA  PTR(31),       /* ACTIVE PST QUEUE           */
*           3  ATCAPBE  PTR(31),       /* POINTER TO ISTAICBE        */
*           3  ATCTRMPB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD),      01S0915
*                                      /* PAB FOR VTAM TERM TASK     */
*           3  ATCTPSPB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD),      01S0915
*                                      /* PAB FOR TPIOS              */
*           3  ATCAP23  PTR(31),       /* PTR TO ISTAPC23            */
*           3  ATCAPC25 PTR(31),       /* PTR TO ISTAPC25            */
*           3  ATCAP41  PTR(31),       /* PTR TO ISTAPC41            */
*           3  ATCRCFY0 PTR(31),       /* PTR TO ISTRCFY0            */
*           3  ATCAP55  PTR(31),       /* PTR TO ISTAPC55            */
*           3  ATCAP56  PTR(31),       /* PTR TO ISTAPC56            */
*           3  ATCAPC59 PTR(31),       /* PTR TO ISTAPC59            */
*           3  ATCAP62  PTR(31),       /* PTR TO ISTAPC62            */
*           3  ATCAP66  PTR(31),       /* PTR TO ISTAPC66            */
*           3  ATCAP69  PTR(31),       /* PTR TO ISTAPM69            */
*           3  ATCAP82  PTR(31),       /* PTR TO ISTAPC82            */
*           3  ATCAP83  PTR(31),       /* PTR TO ISTAPC83            */
*           3  ATCAP84  PTR(31),       /* PTR TO ISTAPC84            */
*           3  ATCAP85  PTR(31),       /* PTR TO ISTAPC85            */
*           3  ATCAP86  PTR(31),       /* PTR TO ISTAPC86            */
*           3  ATCASCB  PTR(31),       /* PTR TO VTAM ASCB           */
*           3  ATCMPLTA  PTR(31),      /* PTR TO MPST LIST TABLE     */
*           3  ATCZR01  PTR(31),       /* PTR TO ISTZRM01            */
*           3  ATCAICTN PTR(31),       /* PTR TO ISTAICTN            */
*           3  ATCTPCP0 PTR(31),       /* PTR TO ISTZFSAV            */
*           3  ATCTPCP1 PTR(31),       /* PTR TO ISTZ19SV            */
*           3  ATCZFLAG BIT(8),        /* FLAG BYTE                  */
*              4 ATCZF001 BIT(1),      /* MDR RECORDING SUSPENDED    */
*              4 ATCRSV66 BIT(7),      /* RESERVED                   */
*           3  ATCRSV75 BIT(8),        /* RESERVED                   */
*           3  ATCSRBCT FIXED(16),     /* COUNT OF PREALLOCATED SRB'S*/
*           3  ATCCRACT FIXED(16),     /* COUNT OF PREALLOCATED CRA'S*/
*           3  ATCRPLCT FIXED(16),     /* COUNT OF PREALLOCATED CRPL */
*           3  ATCRSV88 PTR(31),       /* RESERVED                   */
*           3  ATCTPMPB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /*TP MSG PAB
*                                                         FOR VS2    */
*           3  ATCTPMMI PTR(31),        /* PTR TO ISTCFMMI - MSG ISSUER
*                                          FOR SRB MODE ROUTINES     */
*           3  ATCVIOPM PTR(31),       /* PTR TO ISTVIOPM            */
*           3  ATCPOPAB CHAR(LENGTH(ISTDYPAB)) BDY(DWORD),      01S0915
*                   /* POPAB FOR REPLY PROCESSING, POI TERMINATION,  */
*                   /* AND VTAM MESSAGE PROCESSOR                    */
*        2  ATCAOS CHAR(0) BDY(WORD);  /* VS2 ONLY FIELDS            */
*/*   DEVICE CHARACTERISTICS TABLE - ORIGINATES IN RDT USED TO DEFINE
*    DEVICE CHARACTERISTICS IN DNCB,FMCB AND NIB  */            01S0916
*/*  INITIAL LEVEL                                     001 08/07/74  */
*DCL  1  ISTDEVCH  BDY(WORD)BASED,                              01S0916
*        2  DEVSHCH BIT(8),            /* DEV SCHED CHARACTERISTICS  */
*           3  DEVCHAR  BIT(8),        /* COMPATIBILITY EXISTING CODE*/
*              4  DEVINPUT  BIT(1),    /* DEVICE IS FOR INPUT        */
*              4  DEVOTPUT  BIT(1),    /* DEVICE IS FOR OUTPUT       */
*              4  DEVCONVR  BIT(1),    /* DEVICE IS CONVERSATION     */
*                                      /* RN DEFINITION              */
*              4  DEVSUBND  BIT(1),    /* DEVICE HAS SCHEDULABLE     */
*                                      /*   SUB-NODES                */
*              4  DEVSPS BIT(1),       /* DEV IS START PRINT SENSITIVE*
*              4  DEVNNSPT BIT(1),     /* NODE HAS NETWRK MNGMNT SPRT*/
*              4  DEVCCTL BIT(1),      /* NODE HAS CONN CNTRL DEPENDCS*
*              4  DEVRSV01  BIT(1),    /* RESERVED                   */
*        2  DEVTCODE BIT(8),           /* DEVICE TYPE CODES          */
*           3  DEVCHAR2  BIT(8),       /* COMPATIBILITY EXISTING CODE*/
*        2  DEVMCODE BIT(8),           /* DEVICE MODEL CODE           *
*        2  DEVFLAGS BIT(8),           /*USE DEPENDS ON DEVSHCH VALUES*
*           3  DEVFCCTL BIT(4),        /* USED IF DEVICE REQ CONN CTRL*
*              4  DEVCBSC BIT(1),      /* RESET ORDERLY, BI-SYNCH
*                                         TERMINALS EXCEPT 3270'S    */
*              4  DEVCSSL BIT(1),      /*RESET AT END OF COMMAND. 3270'
*                                         AND START/STOP EXCEPT TERMS
*                                         WITH REVERSE BREAK FEATURE */
*                                                               01S0916
*              4  DEVCRVB BIT(1),      /* RESET IMMEDIATE. START/STOP
*                                         TERMS WITH REVERSE BREAK
*                                         FEATURE                    */
*              4  DEVCSWL BIT(1),      /* 1=HIGHER NODE IS SWITCH CON-
*                                         NECTION, 0=LEASED CONNECTION*
*           3  DEVCHAR3 BIT(4),        /* COMPATIBILITY EXISTING CODE*/
*              4  DEVCATTN BIT(1),     /* TERMINAL CAN INTERRUPT WITH
*                                         ATTENTION                  */
*              4  DEVCCHEK BIT(1),     /* TERMINAL HAS CHECKING      */
*              4  DEVCSTCL BIT(1),     /* TERMINAL HAS STATION  01S0916
*                                         CONTROL                    */
*              4  DEVCSLPN BIT(1),     /* TERMINAL HAS SELECTOR PEN  */
*        2  DEVPHYSA CHAR(1),          /* PHYSICAL DEVICE ADDRESS    */
*        2  DEVRSV03 CHAR(3);          /* RESERVED                   */
*/* DEVICE TYPE CODES */                                        01S0917
*DCL DEV2740 BIT(8) CONSTANT ('01'X);  /* DEVICE IS A 2740           */
*DCL DEV2741 BIT(8) CONSTANT ('02'X);  /* DEVICE IS A 2741           */
*DCL DEV1050 BIT(8) CONSTANT ('03'X);  /* DEVICE IS A 1050           */
*DCL DEVTWX  BIT(8) CONSTANT ('04'X);  /* DEVICE IS A TWX            */
*DCL DEVWTTY BIT(8) CONSTANT ('05'X);  /* DEVICE IS A WTTY           */
*DCL DEV115A BIT(8) CONSTANT ('06'X);  /* DEVICE IS A 115A           */
*DCL DEV83B3 BIT(8) CONSTANT ('07'X);  /* DEVICE IS AN 83B3          */
*DCL DEV2715 BIT(8) CONSTANT ('08'X);  /* DEVICE IS A 2715           */
*DCL DEV2770 BIT(8) CONSTANT ('09'X);  /* DEVICE IS A 2770           */
*DCL DEV2780 BIT(8) CONSTANT ('0A'X);  /* DEVICE IS A 2780           */
*DCL DEV3735 BIT(8) CONSTANT ('0B'X);  /* DEVICE IS A 3735           */
*DCL DEV3780 BIT(8) CONSTANT ('0C'X);  /* DEVICE IS A 3780           */
*DCL DEV1130 BIT(8) CONSTANT ('0D'X);  /* DEVICE IS AN 1130          */
*DCL DEV1800 BIT(8) CONSTANT ('0E'X);  /* DEVICE IS AN 1800          */
*DCL DEV3125 BIT(8) CONSTANT ('11'X);  /* DEVICE IS A 3125           */
*DCL DEV3135 BIT(8) CONSTANT ('12'X);  /* DEVICE IS A 3135           */
*DCL DEVSYS3 BIT(8) CONSTANT ('13'X);  /* DEVICE IS SYS 3            */
*DCL DEV2701 BIT(8) CONSTANT ('14'X);  /* DEVICE IS A 2701 OZ05270   */
*DCL DEV2703 BIT(8) CONSTANT ('15'X);  /* DEVICE IS A 2703 OZ05270   */
*DCL DEV3704 BIT(8) CONSTANT ('16'X);  /* DEVICE IS A 3704           */
*DCL DEV3705 BIT(8) CONSTANT ('17'X);  /* DEVICE IS A 3705           */
*DCL DEV2980 BIT(8) CONSTANT ('18'X);  /* DEVICE IS A 2980           */
*DCL DEV3277 BIT(8) CONSTANT ('19'X);  /* DEVICE IS A 3277           */
*DCL DEV3284 BIT(8) CONSTANT ('1A'X);  /* DEVICE IS A 3284           */
*DCL DEV3286 BIT(8) CONSTANT ('1B'X);  /* DEVICE IS A 3286           */
*DCL DEV3275 BIT(8) CONSTANT ('1C'X);  /* DEVICE IS A 3275           */
*DCL DEV3741 BIT(8) CONSTANT ('1D'X);  /* DEVICE IS A 3741           */
*DCL DEV3747 BIT(8) CONSTANT ('1E'X);  /* DEVICE IS A 3747           */
*DCL DEVMTA  BIT(8) CONSTANT ('28'X);  /* DEVICE IS AN MTA           */
*DCL DEV2972 BIT(8) CONSTANT ('33'X);  /* DEVICE IS A 2972           */
*DCL DEV3271 BIT(8) CONSTANT ('34'X);  /* DEVICE IS A 3271           */
*DCL DEV3272 BIT(8) CONSTANT ('36'X);  /* DEVICE IS A 3272           */
*DCL DEVCC   BIT(8) CONSTANT ('35'X);  /* DEVICE IS A PHYSICAL UNIT  */
*DCL DEV1052 BIT(8) CONSTANT ('64'X);  /* DEVICE IS A 1052           */
*DCL DEV1053 BIT(8) CONSTANT ('65'X);  /* DEVICE IS A 1053           */
*DCL DEV1054 BIT(8) CONSTANT ('66'X);  /* DEVICE IS A 1054           */
*DCL DEV1055 BIT(8) CONSTANT ('67'X);  /* DEVICE IS A 1055           */
*DCL DEV1056 BIT(8) CONSTANT ('68'X);  /* DEVICE IS A 1056           */
*DCL DEV1057 BIT(8) CONSTANT ('69'X);  /* DEVICE IS A 1057           */
*DCL DEV1058 BIT(8) CONSTANT ('6A'X);  /* DEVICE IS A 1058           */
*DCL DEV1092 BIT(8) CONSTANT ('6B'X);  /* DEVICE IS A 1092           */
*DCL DEV1093 BIT(8) CONSTANT ('6C'X);  /* DEVICE IS A 1093           */
*DCL DEVLU   BIT(8) CONSTANT ('6D'X);  /* DEVICE IS A LOGICAL UNIT   */
*DCL DEV545  BIT(8) CONSTANT ('78'X);  /* DEVICE IS A 545            */
*DCL DEV1017 BIT(8) CONSTANT ('79'X);  /* DEVICE IS A 1017           */
*DCL DEV1018 BIT(8) CONSTANT ('7A'X);  /* DEVICE IS A 1018           */
*DCL DEV2203 BIT(8) CONSTANT ('7B'X);  /* DEVICE IS A 2203           */
*DCL DEV2213 BIT(8) CONSTANT ('7C'X);  /* DEVICE IS A 2213           */
*DCL DEV2265 BIT(8) CONSTANT ('7D'X);  /* DEVICE IS A 2265           */
*DCL DEV2502 BIT(8) CONSTANT ('7E'X);  /* DEVICE IS A 2502           */
*DCL DEV50   BIT(8) CONSTANT ('7F'X);  /* DEVICE IS A 50             */
*DCL DEV1255 BIT(8) CONSTANT ('80'X);  /* DEVICE IS A 1255           */
*DCL DEV5496 BIT(8) CONSTANT ('81'X);  /* DEVICE IS A 5496           */
*/* MODEL CODES */                                              01S0970
*DCL DEVMOD1 BIT(8) CONSTANT ('00'X);  /* MODEL 1                    */
*DCL DEVMOD2 BIT(8) CONSTANT ('01'X);  /* MODEL 2                    */
*/*              RESOURCE DEFINITION TABLE                           */
*/*  REVISIONS                                         013 07/01/75  */
*DCL                                                            01S0972
*1  ISTRPRE BDY(WORD) BASED,     /* COMMON PREFIX                    */
*   2  RPRNAME  CHAR(8),         /* RESOURCE NAME                    */
*   2  RPRCOMID FIXED(31),       /* COMMUNICATION ID                 */
*      3  RPRSAF BIT(16),        /* SOURCE ADDRESS FIELD             */
*      3  RPRDAF BIT(16),        /* DESTINATION ADDRESS FIELD-       */
*                             /* CONTAINS DAF OF CTERM IN PORT ENTRY */
*   2  RPRRLOCK CHAR(LENGTH(ISTLOK)),  /* RESOURCE LOCK              */
*   2  RPRELEN  FIXED(15),       /* CURRENT ENTRY LENGTH             */
*   2  RPRPELEN FIXED(15),       /* PREVIOUS ENTRY LENGTH            */
*   2  RPRENTRY BIT(8),          /* FLAG FIELD 1 (ENTRY TYPE)        */
*   2  RPRFLAGA BIT(8),                                         01S0972
*      3  RPRACT BIT(1),         /* ACTIVE                           */
*      3  RPRINV BIT(1),         /* INVALID                          */
*      3  RPRTIED BIT(1),        /* TIED                             */
*      3  RPRENTBF BIT(1),       /* BUFFER TRACE THIS NODE           */
*      3  RPRENTIO BIT(1),       /* RESERVED                         */
*      3  RPRENTED BIT(1),       /* LAST ENTRY IN RDT SEGMENT        */
*      3  RPRVRYPD BIT(1),       /* VARY PENDING ON ENTRY            */
*      3  RPRLIVE  BIT(1),       /* RESOURCE IS LIVE                 */
*   2  RPRFLAGB BIT(8),          /* FLAG FIELD                       */
*      3  RPRENTVH BIT(1),       /* WHEN 1, ENTRY IS A VTAM HEADER   */
*      3  RPRENTVT BIT(1),       /* WHEN 1, ENTRY IS VTAM            */
*      3  RPRAOPN BIT(1),        /* NODE OPENABLE BY APPLICATION     */
*      3  RPRVIODN BIT(1),       /* VARY I/O HAS BEEN DONE           */
*      3  RPRONLIN BIT(1),       /* NODE VARIED ONLINE               */
*      3  RPRHLVPD BIT(1),       /* VARY PENDING IN HIGHEST     01S0972
*                                   LEVEL NODE                       */
*      3  RPRVYIMM BIT(1),       /* VARY IMMEDAITE ISSUED FOR NODE   */
*      3  RPRINTST BIT(1),       /* DEVICE IN TEST MODE              */
*   2  RPRCAUSE BIT(8),          /* FLAGS INDICATING CAUSE OF ENTRY
*                                                      INVALIDATION  */
*      3  RPRNOSRT BIT(1),       /* RPRINV SET BECAUSE NO SRTE BUILT */
*      3  RPRCRCPT BIT(1),       /* C/R CHECKPOINT ACTIVE 1=ACTIVE   */
*      3  RPRRSYNC BIT(1),       /* C/R RE-SYNC ON FIRST I/O         */
*                                /* REQUIRED: 1=YES                  */
*      3  RPRRSV03 BIT(5),       /* RESERVED                         */
*   2  RPRPEPCT FIXED(15),       /* VARY PENDING COUNTER             */
*   2  RPRTIOCT FIXED(8),        /* I/O TRACE COUNT                  */
*   2  RPRHDTYP BIT(8),          /* HEADER TYPE                      */
*   2  RPRLGONF PTR(31),         /* SIM. LOGON CHAIN FORWARD PTR     */
*   2  RPRLGONB PTR(31),         /* SIM. LOGON CHAIN BACKWARD PTR    */
*   2  RPRNSNEA PTR(31),         /* NEXT SCHEDULABLE NODE ENTRY ADDR */
*   2  RPRNCBA PTR(31),          /* ADDR OF ASSOCIATED NCB FOR  01S0972
*                                    OPENED NODES                    */
*   2  RPRDEVCH CHAR(LENGTH(ISTDEVCH)),  /* DEVICE CHARACTERISTICS   */
*   2  RPRRVPT1 PTR(31),         /* RESERVED                         */
*   2  RPRSTPCT FIXED(15),       /* COUNT OF SHOULDER TAPS           */
*   2  RPRSWDAF BIT(16),         /* SWITCHED DAF                     */
*   2  RPRPTHCT FIXED(8),        /* COUNT OF AVAILABLE PATHS    01S0972
*                                   TO THIS DEVICE                   */
*   2  RPRFLAGD CHAR(1),         /* FLAG BYTE                        */
*      3 RPRLTASN BIT(1),        /* LINE TRACE ACTIVE = 1            */
*      3 RPRCONCT BIT(1),        /* PHYSICAL CONNECTION EXISTS       */
*      3 RPRRSON  BIT(1),        /* RESET ONLINE                     */
*      3 RPRACTP  BIT(1),        /* ACTIVATE IN PROGRESS             */
*      3 RPRCONP  BIT(1),        /* CONTACT IN PROGRESS              */
*      3 RPRRSV05 BIT(2),        /* RESERVED                         */
*      3 RPRINIMM BIT(1),        /* ON=INACTIVATE IMMED. IN PROGRESS */
*   2  RPRFLAGC BIT(8),          /* FLAG FIELD                       */
*      3  RPRCLVPD BIT(1),       /* THIS ENTRY HAS BEEN CLOSED       */
*   2  RPRCONID CHAR(9);         /* CONTROL BLOCK ID                 */
*                                                               01S0972
*                                                               01S0972
*/* RPRENTRY - FOLLOWING EQUATES ARE FOR THE VARIOUS ENTRY TYPES     */
*DCL RPRENTCM BIT(8) CONSTANT('90'X);  /* ENTRY IS A COMPONENT       */
*DCL RPRENTIN BIT(8) CONSTANT('82'X);  /* ENTRY IS INTERMEDIATE NODE */
*DCL RPRENTTR BIT(8) CONSTANT('80'X);  /* ENTRY IS A TERMINAL        */
*DCL RPRENTUT BIT(8) CONSTANT('75'X);  /* ENTRY IS UTERM             */
*DCL RPRENTCL BIT(8) CONSTANT('70'X);  /* ENTRY IS A CLUSTER         */
*DCL RPRENTLN BIT(8) CONSTANT('50'X);  /* ENTRY IS A LINE            */
*DCL RPRENTLH BIT(8) CONSTANT('03'X);  /* ENTRY IS A LOCAL HEADER    */
*DCL RPRENTGP BIT(8) CONSTANT('30'X);  /* ENTRY IS A GROUP           */
*DCL RPRENTLC BIT(8) CONSTANT('45'X);  /* ENTRY IS A LOCAL DEVICE    */
*DCL RPRENTAH BIT(8) CONSTANT('02'X);  /* ENTRY IS APPLICATION HEADER*/
*DCL RPRENTAP BIT(8) CONSTANT('55'X);  /* ENTRY IS APPLICATION       */
*DCL RPRENTDS BIT(8) CONSTANT('20'X);  /* ENTRY IS LCDO         01S0984
*                                         (DIALSET)                  */
*DCL RPRENTRN BIT(8) CONSTANT('01'X);  /* ENTRY IS THE RN            */
*DCL RPRENTCC BIT(8) CONSTANT('71'X);  /* ENTRY IS A PU              */
*DCL RPRENTLU BIT(8) CONSTANT('81'X);  /* ENTRY IS LOGICAL UNIT      */
*DCL RPRENTSW BIT(8) CONSTANT('04'X);  /* ENTRY IS SWITCHED          */
*                                      /* SUBAREA HEADER             */
*DCL RPRENTLS BIT(8) CONSTANT('05'X);  /* ENTRY IS LOCAL             */
*                                      /* SUBAREA HEADER             */
*DCL RPRENTPX BIT(8) CONSTANT('72'X);  /* ENTRY IS A PUX             */
*DCL RPRENTLX BIT(8) CONSTANT('10'X);  /* ENTRY IS A LUX             */
*DCL RPRENTDA BIT(8) CONSTANT('51'X);  /* ENTRY IS A DAN             */
*                                                               01S0992
*                                                               01S0992
*/* THE FOLLOWING IS A PREFIX FOR ALOCATION ENTRIES                  */
*/*   ISTRCL-CLUSTER,ISTRTR-TERMINAL,ISTRCM-COMPONENT                */
*                                                               01S0993
*DCL                                                            01S0993
*1  ISTRCPRE BDY(WORD) BASED,    /* LEVEL 1 DECLARE                  */
*   2  RCPPRE  CHAR(LENGTH(ISTRPRE)),      /* COMMON PREFIX          */
*   2  RCPICELN PTR(31),         /* PTR LOGON ICE QUEUE              */
*   2  RCPLNAPA PTR(31),         /* PTR APLICATION ENTRY FOR SIMLOGON*/
*   2  RCPICEAQ PTR(31),         /* PTR ACQUIRE ICE QUEUE            */
*   2  RCPACETR PTR(31),         /* PTR ACE QUEUE                    */
*   2  RCPBHSI1 CHAR(1),         /* GEN'D BHSET ID                   */
*   2  RCPBHSI2 CHAR(1),         /* OVERRIDING BHSET ID SPECIFIED
*                                   BY USER                          */
*   2  RCPBFLIM PTR(8),          /* BUFFER LIMIT                     */
*   2  RCPPMODE CHAR(1),         /* PERMISSABLE MODES                */
*      3 RCPRBASC BIT(1),        /* 1= BASIC OK                      */
*      3 RCPRRECD BIT(1),        /* 1= RECORD OK                     */
*      3 *        BIT(6),        /* RESERVED                         */
*   2  RCPLGNIN CHAR(20) BDY(WORD), /* INIT LOGON DATA               */
*      3 RCPLGNAP CHAR(8),       /* APPL FOR VTAM SIMLOGON           */
*      3 RCPLGNCT CHAR(8),       /* NAME OF LOGON CHAR TABLE         */
*      3 RCPINTA  PTR(31),       /* ADDR OF INTERPRET TABLE          */
*   2  RCPRSV03 PTR(31),         /* RESERVED FOR C/R                 */
*   2  RCPRSV04 PTR(31),         /* RESERVED FOR C/R                 */
*   2  RCPRSV05 PTR(31);         /* RESERVED FOR C/R                 */
*                                                               01S0993
*                                                               01S0993
*DCL                                                            01S0994
*1  ISTRDT BDY(WORD) BASED,      /* LEVEL 1 DECLARE                  */
*   2  RDTPRE CHAR(LENGTH(ISTRPRE)), /* ENTRY PREFIX                 */
*   2  RDTPLEN CHAR(4)BDY(WORD), /* PRIORITY AND LENGTH FIELD        */
*      3  RDTPRIOR,              /* DETERMINES SEGMENT TYPE          */
*         4  * BIT(3),           /*    NOT USED                      */
*         4  RDTPRIAP BIT(1),    /*    APPLICATION SEGMENT           */
*         4  RDTPRILC BIT(1),    /*    LOCAL SEGMENT                 */
*         4  RDTPRIRN BIT(1),    /*    RN SEGMENT                    */
*         4  RDTPRISW BIT(1),    /*    SWITCHED SEGMENT              */
*         4  RDTPRILS BIT(1),    /*    LOCAL SUBAREA SEGMENT         */
*      3  RDTLEN FIXED(24),      /* LENGTH OF RDT                    */
*   2  RDTFORW PTR(31),          /* FOREWARD POINTER                 */
*   2  RDTBACK PTR(31),          /* BACKWARD POINTER                 */
*   2  RDTFLAGS BIT(16),         /* SEGMENT FLAGS,UNUSED/REUSED      */
*   2  RDTCTSNT FIXED(15),       /* COUNT OF SNT ENTRIES FOR    01S0994
*                                   SEGMENT                          */
*   2  RDTMAXID PTR(8),          /* MAXIMUM NODE ID FOR         01S0994
*                                   NETWORK                          */
*   2  RDTNODID PTR(8),          /* NODE ID FOR THIS SEGMENT         */
*   2  RDTLGCT  PTR(8),          /* COUNT OF LOGONS OUTSTANDING      */
*   2  RDTFLAGB BIT(8),          /* FLAG BYTE                        */
*      3 RDTOUERP BIT(1),        /* 1 = REPEAT ERP                   */
*      3 RDTPRGDN BIT(1),        /* 1 = PURGE ISSUED                 */
*      3 RDTCTPGD BIT(1),        /* 1 = CONTACT PURGED               */
*      3 RDTCTCFL BIT(1),        /* HIGHER FAILURE-CONTACT FLUSHED   */
*      3 RDTBHSET BIT(1),        /* BHSET REQUIRED                   */
*      3 RDTRSV01 BIT(3),        /* RESERVED                         */
*   2  RDTVPAB  PTR(31),         /* ADDR OF VARY PAB                 */
*   2  RDTEPAB  PTR(31),         /* ADDR OF ERP PAB                  */
*   2  RDTDPAB  PTR(31),         /* ADDR OF DUMP/LOAD/RESTART PAB    */
*   2  RDTTPAB  PTR(31),         /* TOLTEP SSCP PAB                  */
*   2  RDTVYRPH PTR(31),         /* @ OF VARY RPH WAITING            */
*                                /* FOR RESTART COMPLETION           */
*      3 RRNVYRPH PTR(31),       /* DELETE ALIAS IN NEXT             */
*                                /* FIRST SNA/2 BUILD                */
*   2  RDTSTCNT PTR(8),          /* ACTIVE SUBNODE COUNT             */
*      3 RRNSTCNT PTR(8),        /* DELETE ALIAS IN NEXT             */
*                                /* FIRST SNA/2 BUILD                */
*   2  *        CHAR(3),         /* RESERVED                         */
*   2  RDTCRSDS CHAR(8),         /* C/R DATA SET IDENTIFIER          */
*                                /* BLANK IMPLIES NOT SPECIFIED      */
*   2  RDTCRSPW CHAR(8),         /* C/R DATASET PASSWORD             */
*                                /* BLANK IMPLIES NOT SPECIFIED      */
*   2  RDTVSRPL PTR(31);         /* C/R PTR TO VSAM RPL              */
*                                                               01S0994
*                                                               01S0994
*DCL                                                            01S0995
*1  ISTRAP BDY(WORD) BASED,      /* APPLICATION ENTRY                */
*   2  RAPPRE CHAR(LENGTH(ISTRPRE)), /*  USE ISTRPRE DSECT           */
*   2  RAPACBA PTR(31),          /*   POINTER TO ACB                 */
*   2  RAPACDEB PTR(31),         /*  POINTER TO ACBDEB               */
*   2  RAPAPPWD CHAR(8),         /* APPLICATION PASSWORD             */
*   2  RAPICELG PTR(31),         /* ANCHOR FOR LOGON ICE TO APLICATION*
*   2  RAPICEAC PTR(31),         /* ANCHOR ACEPT ICE FOR APPLICATION */
*   2  RAPICEAQ PTR(31),         /*  ANCHOR ACQUIRE ICE BY APPLI     */
*   2  RAPACEAP PTR(31),         /* ANCHOR FOR APPLICATION ACES      */
*   2  RAPTRPRE FIXED(15),       /* COUNT OF PREMPTED TERMINALS      */
*   2  RAPACEQD FIXED(15),       /* COUNT OF ACES QUEUED             */
*   2  RAPFLG BIT(8),            /*  FLAG FIELD                      */
*      3 RAPABLGN BIT(1),        /*  PERMANENTLY BLOCK LOGONS BIT    */
*      3 RAPAQUI BIT(1),         /* QUIESCE IN PROCESS               */
*      3 RAPASLGI BIT(1),        /*  APPLICATION FIRST TIME LOGON
*                                    ISSUED FLAG                     */
*      3 RAPATLGN BIT(1),        /*  TEMPORARILY BLOCK LOGONS BIT    */
*      3 RAPRSV03 BIT(1),        /*  RESERVED                        */
*      3 RAPRSV04 BIT(1),        /*  RESERVED                        */
*      3 RAPRSV05 BIT(1),        /*  RESERVED                        */
*      3 RAPRSV06 BIT(1),        /*  RESERVED                        */
*   2  RAPFLGB BIT(8),           /* AUTHORIZATION FLAGS              */
*      3 RAPALLF BIT(1),         /* ALL FUNCTIONS AUTH.              */
*      3 RAPABLCK BIT(1),        /* BLOCK I/O AUTH.                  */
*      3 RAPAPASS BIT(1),        /* PASS AUTH.                       */
*      3 RAPAPRMT BIT(1),        /* PREEMPT AUTH.                    */
*      3 RAPAACQ BIT(1),         /* ACQUIRE AUTH.                    */
*      3 RAPAPPO  BIT(1),        /* RNO PPO (PRIMARY PROGRAM AUTH    */
*      3 RAPASPO  BIT(1),        /* RNO SPO (SECONDARY PROGRAM AUTH  */
*      3 RAPANVPC BIT(1),        /* NO VSPACE AUTHORIZED             */
*   2  RAPFLGC BIT(8),           /* AUTHORIZATION FLAGS RESERVED     */
*      3 RAPRSV10 BIT(1),        /*  RESERVED                        */
*      3 RAPRSV11 BIT(1),        /*  RESERVED                        */
*      3 RAPRSV12 BIT(1),        /*  RESERVED                        */
*      3 RAPRSV13 BIT(1),        /*  RESERVED                        */
*      3 RAPRSV14 BIT(1),        /*  RESERVED                        */
*      3 RAPRSV15 BIT(1),        /*  RESERVED                        */
*      3 RAPRSV16 BIT(1),        /*  RESERVED                        */
*      3 RAPRSV17 BIT(1),        /*  RESERVED                        */
*   2  RAPBFACT PTR(8),          /* BUFFER LIMIT FACTOR              */
*   2  RAPRVPT1 PTR(31),         /*  RESERVED                        */
*   2  RAPRVPT2 PTR(31);         /*  RESERVED                        */
*                                                               01S0995
*                                                               01S0995
*DCL                                                            01S0996
*1  ISTRLC BDY(WORD) BASED,      /* LOCAL ENTRY                      */
*   2  RLCPRE CHAR(LENGTH(ISTRPRE)),  /* COMMON PREFIX               */
*   2  RLCADR PTR(31),                                          01S0996
*      3  RLCFLAG BIT(8),        /* FLAG BYTE                        */
*         4  RLCRSV22 BIT(1),    /* RESERVED                         */
*         4  RLCRBISA BIT(1),    /* INITIAL STATUS - 1 = ACTIVE      */
*         4  RLCRSV14 BIT(3),    /* UNUSED/RESERVED                  */
*         4  RLCACNT BIT(1),     /* MESSAGE BLOCK ACCEPTED           */
*         4  RLCRSVDE BIT(2),    /* RESERVED                         */
*      3  RLCUCBAD PTR(24),      /* UCB /PUB ADDRESS                 */
*   2 RLCLCCUA CHAR(3),          /* DEVICE CHANNEL UNIT ADDR         */
*   2 RLCRVPT1 CHAR(1),          /* RESERVED                         */
*   2 RLCRVPT2 PTR(31);          /* RESERVED                         */
*                                                               01S0996
*                                                               01S0996
*DCL                                                            01S0997
*1  ISTRRN BDY(WORD) BASED,      /* RN ENTRY                         */
*   2  RRNPRE CHAR(LENGTH(ISTRDT)),  /*  USE ISTRDT DSECT            */
*   2  RRNADR PTR(31),                                          01S0997
*      3  RRNFLAG BIT(8),                                       01S0997
*         4  RRNRSV89 BIT(1),    /* RESERVED                         */
*         4  RRNRBISA BIT(1),    /* INITIAL STATUS 1 = ACTIVE        */
*         4  RRNLCSIP BIT(1),    /* NODE BEING ACTIVATED             */
*         4  RRNLCDIE BIT(1),    /* HIGHER NODE NOT SUCCESFULLY      */
*                                /*             ACTIVATED            */
*         4  RRNLCDIP BIT(1),    /* NODE BEING DEACTIVATED           */
*         4  RRNERPIP BIT(1),    /* ERP IN PROCESS                   */
*         4  RRNDSTCT BIT(1),    /* DEACT TO DECREMENT STCNT         */
*         4  RRNRSV11 BIT(1),    /* UNUSED/RESERVED                  */
*      3  RRNUCBAD PTR(24),      /* UCB/PUB ADDR                     */
*         4 RRNCHQI  BIT(8),     /* CHANNEL QUEUE INDEX              */
*         4 RRNLUBA  PTR(16),    /* DESCRIBE ENTRY IN PUB            */
*                                /* OWNERSHIP TABLE                  */
*   2  RRNGRPA PTR(31),          /* POINTER TO FIRST GROUP ENTRY     */
*   2  RRNRNCUA CHAR(3),         /* CHANNEL UNIT ADDR                */
*   2  RRNRLDIP FIXED(8),        /* REMOTE LOAD/DUMP IN PROG. COUNT  */
*   2  RRNTRENT PTR(31),         /* ADDR TERM ENTRY IN LOCAL         */
*   2  RRNBHSET PTR(31),         /* POINTER TO TABLE OF BHSET NAMES  */
*   2  RRNCTBHS FIXED(15),       /* COUNT OF BHSET NAMES IN RRNBHSET */
*   2  RRNCTEGP FIXED(15),       /* COUNT OF GROUP ENTRIES FOR RN    */
*   2  RRNCTELI FIXED(15),       /* COUNT OF LINE ENTRIES FOR RN     */
*   2  RRNCTECL FIXED(15),       /* COUNT OF CLUSTER ENTRIES FOR RN  */
*   2  RRNCTETR FIXED(15),       /* COUNT OF TERMINAL ENTRIES FOR RN */
*   2  RRNCTEIN FIXED(15),       /* COUNT OF INT. NODE ENTRIES FOR RN*/
*   2  RRNCTECM FIXED(15),       /* CNT OF COMPONENT ENTRIES FOR RN  */
*   2  RRNCTENT FIXED(15),       /* # ALL ENTRIES IN 370X RDT SEGMENT*/
*   2  RRNRDF CHAR(4),           /*  RESOURCE DEFINITION FLAG        */
*      3  RRNRDFA  BIT(8),       /* FLAGS (WORD 1 BYTE 1)            */
*         4  RRNRASHT BIT(1),    /* AUTO NETWORK SHUTDOWN            */
*         4  RRNRAIPL BIT(1),    /* AUTO IPL ON RN FAILURE           */
*         4  RRNRADMP BIT(1),    /* AUTO DUMP ON RN FAILURE          */
*         4  RRNRASYN BIT(1),    /* C/R AUTOMATICALLY RESYNCHRONIZED */
*                                /* IF ALREADY LOADED NCP            */
*                                /* 0=NO, 1=YES                      */
*         4  RRNRAOLT BIT(1),    /* ON-LINE TERMINAL TEST            */
*         4  RRNRBREM  BIT(1),   /* REMOTE RN FLAG                   */
*         4  RRNRANCP BIT(1),    /* GENERATION TYPE NCP              */
*         4  RRNRAPEP BIT(1),    /* GENERATION TYPE PEP              */
*      3  RRNRDFB BIT(16),       /* FLAG FIELD B (RDF)               */
*         4  RRNRBMDL BIT(1),    /* (=1 IF 3705) ELSE 3704           */
*         4  RRNRSV02 BIT(1),    /* RESERVED                         */
*         4  RRNRBCCL BIT(1),    /* LOOSELY COUPLED CHANNEL          */
*         4  RRNRBCCT BIT(1),    /* TIGHTLY COUPLED CHANNEL          */
*         4  RRNRBSEC BIT(1),    /* SECONDARY CHANNEL EXIST          */
*         4  RRNRBCT1 BIT(1),    /* PRIM CHAN TYPE (0=TYPE1,1=TYPE2) */
*         4  RRNRBCT2 BIT(1),    /* SEC CHAN TYPE (0=TYPE1,1=TYPE2)  */
*         4  RRNRSV03 BIT(1),    /* RESERVED                         */
*         4  RRNRBBUP BIT(1),    /* BRINGUP IS TO BE EXERCISED  01S0997
*                                         FOR THIS RN DURING IPL     */
*         4  RRNVYDON BIT(1),    /* RDT SEG IS BEING FREED           */
*         4  RRNRSV01 BIT(5),    /* RESERVED                         */
*         4  RRNPTASL BIT(1),    /* SOME PORT SOLICITOR IS WAITING
*                                   TO BE REDRIVEN BY CLSDST         */
*      3  RRNRSV55 CHAR(1),      /*  RESERVED                        */
*   2  RRNCMF CHAR(4),           /*  FLAG FIELDS FOR COMMANDS        */
*      3  RRNCMFA  BIT(8),       /* FLAG FIELD A -COMMANDS           */
*         4  RRNCAALL BIT(1),    /* PHYSICAL DISCONNECT              */
*         4  RRNCAATD BIT(1),    /* ACTIVATE DEVICE                  */
*         4  RRNCAATG BIT(1),    /* ACTIVATE GROUP                   */
*         4  RRNCAATI BIT(1),    /* ACTIVATE INVITES                 */
*         4  RRNCAMBH BIT(1),    /* MODIFY BLOCK HANDLER SET         */
*         4  RRNCACDT BIT(1),    /* CHANGE DATE AND TIME             */
*         4  RRNCADTD BIT(1),    /* DEACTIVATE DEVICE                */
*         4  RRNCADGO BIT(1),    /* DEACTIVATE GROUP ORDERLY         */
*      3  RRNCMFB  BIT(8),       /* FLAG FIELD B - COMMANDS          */
*         4  RRNCBDLO BIT(1),    /* DEACTIVATE LINE ORDERLY          */
*         4  RRNCBDLH BIT(1),    /* DEACTIVATE LINE HALT             */
*         4  RRNCBDLR BIT(1),    /* DISPLAY LINE RESOURCE ID         */
*         4  RRNCBRDS BIT(1),    /* REQUEST DEVICE STATUS            */
*         4  RRNCBRLS BIT(1),    /* REQUEST LINE STATUS              */
*         4  RRNCBNPL BIT(1),    /* CHANGE LINE NEG POLL RESPONSE LIM*/
*         4  RRNCBMOD BIT(1),    /* COPY/SET DESTINATION NODE        */
*         4  RRNCBALT BIT(1),    /*  ACTIVATE LINE TRACE             */
*      3  RRNCMFC  BIT(8),       /* FLAG FIELD C - COMMANDS          */
*         4  RRNCCRCN BIT(1),    /* RESET CONDITIONAL                */
*         4  RRNCCRDQ BIT(1),    /* RESET DEVICE QUEUE               */
*         4  RRNCCRST BIT(1),    /* REQUEST DEVICE STATISTICS        */
*         4  RRNCCCRC BIT(1),    /* CHANGE RETRY COUNTS              */
*         4  RRNCCRIM BIT(1),    /* RESET IMMEDIATE                  */
*         4  RRNCCRCM BIT(1),    /* RESET CONTROL MODE               */
*         4  RRNCCSIM BIT(1),    /* COPY/REPLACE SESSION INIT INFO   */
*         4  RRNCCCSL BIT(1),    /* CHANGE SESSION LIMIT             */
*      3  RRNCMFD  BIT(8),       /* FLAG FIELD D - COMMANDS          */
*         4  RRNCDCSP BIT(1),    /* CHANGE SERIVCE PAUSE             */
*         4  RRNCDSTD BIT(1),    /* DISPLAY STORAGE                  */
*         4  RRNCDDTL BIT(1),    /* CHANGE DEVICE TRANSMIT LIMIT     */
*         4  RRNCDBCK BIT(1),    /* SWITCHED NETWORK BACKUP          */
*         4  RRNCDDSI BIT(1),    /* COPY/REPLACE DEV SESSION INIT INFO*
*         4  RRNCDREC BIT(1),    /* RESET AT END OF COMMAND          */
*         4  RRNREMPO BIT(1),    /* REMOTE POWER OFF                 */
*         4 RRNRSV05  BIT(1),    /*       NOT  USED                  */
*   2  RRNFLUX  PTR(31),         /* POINTER TO FIRST LUX             */
*   2  RRNCPLUB CHAR(6),         /* SYMBOLIC UNIT NAME OF NCP DATASET*/
*   2  RRNEPADR PTR(15),         /* EP SUBCHANNEL ADDRESS            */
*   2  RRNNMDPD  CHAR(8),        /* FILENAME FOR DUMP DATA SET       */
*      3  RRNDPLUB CHAR(6),      /* LUB NAME FOR DUMP DATASET        */
*      3  RRNPUBI  BIT(8),       /* PUB INDEX                        */
*      3  RRNRSV88 CHAR(1),      /* RESERVED-DOS ONLY                */
*   2  RRNRSV04  CHAR(6),        /* RESERVED                         */
*   2  RRNDELAY  CHAR(2),        /* INITIAL VALUE FROM DELAY         */
*   2  RRNNMNCP  CHAR(8),        /* DSNAME FOR NCP LOAD MODULE       */
*   2  RRNHPRE PTR(16),          /* HOST PREFIX INFORMATION          */
*      3  RRNHLENH PTR(8),       /* LENGTH OF HOST HEADER PREFIX     */
*      3  RRNHLENT PTR(8),       /* LENGTH OF HOST TEXT PREFIX       */
*   2  RRNHBUFS FIXED(15),       /* SIZE OF BUFFER UNITS FOR HOST    */
*   2  RRNCTPCC PTR(8),          /* CNT OF BUFFERS RECEIVING PCCU DATA*
*   2  RRNNCPNM CHAR(7),         /* NAME OF NCP LOAD MOD 7 CHAR MAX  */
*   2  RRNMSIZE PTR(31),         /* MAX SIZE OF SEND                 */
*   2  RRNRPLPT PTR(31),         /* C/R POINTER TO RPL               */
*   2  RRNNCSPL PTR(31),         /* POINTER TO NCSPL                 */
*   2  RRNLASTE PTR(31),         /* PTR TO LAST ENTRY IN RN SEGMENT  */
*   2  RRNRDCUA CHAR(3),         /* DEFAULT CUA                      */
*   2  *        PTR(8),          /* RESERVED                         */
*   2  RRNRINNM CHAR(8);         /* DEFAULT INNODE NAME IN LOCAL
*                                   RDT TO CONNECT REMOTE RN         */
*                                                               01S0997
*DCL                                                            01S0998
*1  ISTRGP BDY(WORD) BASED,      /* GROUP ENTRY                      */
*   2  RGPPRE CHAR(LENGTH(ISTRPRE)),        /*  USE ISTRPRE DSECT    */
*   2  RGPFLG BIT(8),            /*  FLAG FIELD                      */
*      3  RGPADIL BIT(1),        /* =1 SWITCHED, =0 NON-SWIT         */
*      3  RGPASS  BIT(1),        /* START/STOP                       */
*      3  RGPABSC  BIT(1),       /* BINARY SYNCHRONOUS               */
*      3  RGPASDLC BIT(1),       /* DATA LINK CONTROL                */
*      3 RGPRSV02  BIT(4),       /*     NOT USED                     */
*   2  RGPRSV03 FIXED(8),        /* USED TO FORCE ALINEMENT          */
*   2  RGPCTELN FIXED(15),       /* COUNT OF LINE ENTRIES FOR GROUP  */
*   2  RGPCTECL FIXED(15),       /* CNT OF CLUSTER ENTRIES FOR GROUP */
*   2  RGPCTETR FIXED(15),       /* CNT TERMINAL ENTRIES FOR GROUP   */
*   2  RGPCTEIN FIXED(15),       /* COUNT OF INNODE ENTRIES FOR GROUP*/
*   2  RGPCTECM FIXED(15),       /* CNT COMPONENT ENTRIES FOR GROUP  */
*   2  RGPRVPT1 PTR(31),         /* RESERVED                         */
*   2  RGPRVPT2 PTR(31);         /* RESERVED                         */
*                                                               01S0998
*                                                               01S0998
*DCL                                                            01S0999
*1  ISTRLN BDY(WORD) BASED,      /* LINE ENTRY                       */
*   2  RLNPRE CHAR(LENGTH(ISTRPRE)), /* USE COMMON PREFIX            */
*   2  RLNADR PTR(31),                                          01S0999
*      3  RLNFLAG BIT(8),                                       01S0999
*         4  RLNEAM   BIT(1),    /* ENABLE ANSWER MODE DONE          */
*         4  RLNRBISA BIT(1),    /* INITIAL STATUS 1=ACTIVE          */
*         4  RLNRSV01 BIT(6),    /* RESERVED                         */
*      3  RLNUCBAD PTR(24),      /* UCB/PUB ADDRESS                  */
*         4  RLNCUA CHAR(3),     /* NOT USED                         */
*   2  RLNCTECL FIXED(15),       /* CNT OF CLUSTER ENTRIES FOR LINE  */
*   2  RLNCTETR FIXED(15),       /* CNT OF TERMINAL ENTRIES FOR LINE */
*   2  RLNCTEIN FIXED(15),       /* COUNT OF INNODE ENTRIES FOR LINE */
*   2  RLNCTECM FIXED(15),       /* CNT OF COMPONENT ENTRIES FOR LINE*/
*   2  RLNACTCT FIXED(15),       /* COUNT OF COMPONENTS, CLUSTERS
*                                             AND TERMINALS ON LINE  */
*   2  RLNSTAT1 BIT(8),          /* LINK TRAP STATUS                 */
*      3 RLNTRAP  BIT(1),        /* INTERCEPT NEXT LINK OPERATION    */
*      3 RLNLRST  BIT(1),        /* LINK RESTART COND CAUSED TRAP    */
*      3 RLNINOPL BIT(1),        /* LINK INOP CONDITION CAUSED TRAP  */
*      3 RLNINOPP BIT(1),        /* PU INOP CONDITION CAUSED TRAP    */
*      3 RLNVD    BIT(1),        /* VARY INACT CONDITION CAUSED TRAP */
*      3 RLNRSV03 BIT(3),        /* RESERVED                         */
*    2 RLNSTAT2 BIT(8),          /* LINK NORMAL STATUS               */
*      3 RLNOHIN  BIT(1),        /* OFFHOOK REPORTED TO SW SUBAREA-  */
*                                /* REPLY DUE                        */
*      3 RLNINUSE BIT(1),        /* LINK RESOURCES ALLOCATED TO PU   */
*      3 RLNRSV04 BIT(6),        /* RESERVED                         */
*   2  RLNRDF CHAR(4),           /*  RESOURCE DEFINITION FLAG        */
*      3  RLNRDFA  BIT(8),       /* FLAGS FIELD A                    */
*         4  RLNRACNT BIT(2),    /*  NEXT TWO FIELDS                 */
*            5  RLNRACAT BIT(1), /* CALL INITIATOR-TERMINAL          */
*            5  RLNRACAN BIT(1), /* CALL INITIATOR-NCP               */
*         4  RLNGANSW BIT(1),    /* C/R GENNED IN ANSWER MODE, 1=YES */
*         4  RLNPORT  BIT(1),    /* THIS IS A PORT ENTRY             */
*         4  RLNIDV   BIT(1),    /* THIS IS AN ID VERIFIED PORT      */
*         4  RLNRAEP  BIT(1),    /* TYPE IS EP                       */
*         4  RLNRANCP BIT(1),    /* TYPE IS NCP                      */
*         4  RLNRAPEP BIT(1),    /* TYPE IS PEP                      */
*      3  RLNRDFB  BIT(8),       /* FLAGS FIELD B                    */
*         4  RLNRBUSE BIT(1),    /* EP/NCP USE  1=NCP                */
*         4  RLNANSWR BIT(1),    /* ON = SEND ENABLE ANSWER          */
*                                /* AT ACTIVATE                      */
*         4  RLNAUTOD BIT(1),    /* ON=AUTODIAL, OFF=MANUAL          */
*         4  RLNRSV0B BIT(1),    /* RESERVED                         */
*         4  RLNTTV   BIT(1),    /* THIS IS TERM TYPE VERIFICATION
*                                   PORT                             */
*         4  RLNRAPOL BIT(1),    /* POLLED LINE                      */
*         4  RLNRATRN BIT(1),    /* SDLC LINE                        */
*         4  RLNMULTP BIT(1),    /* 0 = POINT TO POINT,         01S0999
*                                   1 = MULTI POINT                  */
*      3  RLNRDFC  BIT(8),       /* FLAGS FIELD C - LINE CODES       */
*                                /* SEE CONSTANTS FOR DEFINITION     */
*      3  RLNRDFD  BIT(8),       /* FLAGS FIELD D - RESERVED         */
*   2  RLNAUTOA FIXED(15),       /* AUTOCALL ADDRESS                 */
*   2  RLNRDSLM FIXED(8),        /* SCHED. LIM BASED ON LINE SPEED 2-4*
*   2  RLNCTSES FIXED(8),        /* COUNT OF CONCURRENT SESSIONS     */
*   2  RLNACTRM PTR(8),          /* COUNT OF ACTIVE REMOTES FOR THIS
*                                   TRUNK                            */
*   2  RLNRESV1 BIT(8),          /* RESERVED/UNUSED                  */
*   2  RLNACTSN FIXED(15),       /* COUNT ACTIVE NODES ON LINK       */
*   2  RLNPOLMT FIXED(8),        /* NEG POLL RESPONSE LIMIT          */
*   2  RLNPAUSE FIXED(8),        /* POLL DELAY/PAUSE                 */
*   2  RLNCRFLG BIT(8),          /* FLAG-CONFIGURATION RESTART       */
*      3 RLNACTLN BIT(1),        /* ACTIVATE LINK OK                 */
*      3 RLNSWNCP BIT(1),        /* SWITCH PEP LINE TO NCP OK        */
*      3 RLNLSCMD BIT(3),        /* LINE SCHEDULING COMMANDS    01S0999
*                                   ISSUED OK                        */
*        4 RLNNPRLM BIT(1),      /* CHNG NEG POLL RESP LIMIT OK      */
*        4 RLNSESLM BIT(1),      /* CHNG SESSION LIMIT OK            */
*        4 RLNSVSKP BIT(1),      /* CHNG SERVICE SEEK PAUSE OK       */
*      3 RLNSWEP  BIT(1),        /* SWITCH TO EP                     */
*      3 RLNCRRSV BIT(2),        /* RESERVED FOR CONFIG RESTART      */
*   2  *        CHAR(1),         /* RESERVED                         */
*   2  RLNX2SW  PTR(31),         /* ADDRESS OF 370X TO SWITCH        */
*                                /* COMMUNICATION NCSPL              */
*   2  RLNNCSPL PTR(31),         /* ADDRESS OF SPIN-OFF NCSPL        */
*                                /* FOR VARY DEACTIVATE              */
*   2  RLNRVPT2 PTR(31);         /* RESERVED                         */
*                                                               01S0999
*                                                               01S0999
*DCL RLNRCEDC BIT(8) CONSTANT('01'X);  /* EBCDIC (CONSTANTS)         */
*DCL RLNRCUSA BIT(8) CONSTANT('02'X);  /* USASCII                    */
*DCL RLNRCBCD BIT(8) CONSTANT('03'X);  /* BCD                        */
*DCL RLNRCEBC BIT(8) CONSTANT('04'X);  /* EBCD                       */
*DCL RLNRCCOR BIT(8) CONSTANT('05'X);  /* COR                        */
*DCL RLNRCKAT BIT(8) CONSTANT('06'X);  /* KATAKANA                   */
*DCL RLNRCIT2 BIT(8) CONSTANT('08'X);  /* ITA2                       */
*DCL RLNRCZS3 BIT(8) CONSTANT('09'X);  /* ZSC3                       */
*                                                               01S1007
*                                                               01S1007
*DCL                                                            01S1008
*1  ISTRPT BDY(WORD) BASED,        /* PORT ENTRY                     */
*   2 RPTLN CHAR(LENGTH(ISTRLN)),  /* INCLUDE LINE ENTRY             */
*   2 RPTLNCID BDY(WORD) CHAR(4),  /* COMM ID OF LINE                */
*     3 RPTLNSAF CHAR(2),          /* SAF                            */
*     3 RPTLNDAF CHAR(2),          /* DAF                            */
*   2 RPTCTNM CHAR(8),             /* CTERM NAME                     */
*   2 RPTDITT PTR(31),             /* POINTER TO DITT TABLE          */
*     3 RPTDIVT PTR(31),           /* POINTER TO DIVT TABLE          */
*   2 RPTATERM PTR(31),            /* POINTER TO ASSOCIATED ENTRY    */
*   2 RPTUTERM PTR(31),            /* POINTER TO UTERM ENTRY         */
*   2 RPTFLAG1 CHAR(1),            /* PORT SOLICITOR FLAGS           */
*     3  RPTASLEP BIT(1),          /* THIS PORT SOLICITOR IS WAITING
*                                     TO BE REDRIVEN BY CLSDST       */
*     3 RPTVRYPD BIT(1),           /* VARY PENDING IN THIS CTERM     */
*     3 RPTHLVPD BIT(1),           /* VARY PENDING IN HIGHER LEVEL
*                                     NODE                           */
*     3 RPTONLIN BIT(1),           /* ONLINE/OFFLINE(VARY)           */
*     3 RPTVIODN BIT(1),           /* I/O DONE FOR THIS NODE         */
*     3 RPTVYIMM BIT(1),           /* VARY IMM ISSUED FOR PORT       */
*     3 RPTDYNAM BIT(1),           /* BHSET = DYNAMIC                */
*     3 RPTISTAT BIT(1),           /* CTERM(PORT) IS INITIALLY ACTIVE*/
*                                  /* 1 = YES                        */
*   2 RPTRSV01 CHAR(1),            /* RESERVED                       */
*   2 RPTDAFSV BIT(16),            /* SAVE TERMINAL DAF              */
*   2 RPTPEPCT FIXED(15),          /* PEP COUNT FOR CTERM            */
*   2 RPTPTHCT FIXED(15),          /* PATH COUNT FOR CTERM           */
*   2 RPTNSNSV PTR(31),            /* SAVE TERMINAL NEXT SCHED NODE
*                                     POINTER                        */
*   2  RPTRSV02 PTR(31),           /* RESERVED                       */
*   2  RPTRSV03 PTR(31);           /* RESERVED                       */
*                                                               01S1008
*                                                               01S1008
*DCL                                                            01S1009
*1  ISTRCL BDY(WORD) BASED,      /* CLUSTER ENTRY                    */
*   2  RCLPRE CHAR(LENGTH(ISTRPRE)),    /* USE COMMON PREFIX         */
*   2  RCLADR PTR(31),                                          01S1009
*      3  RCLFLAG BIT(8),                                       01S1009
*         4  RCLRSV22 BIT(1),    /* RESERVED                         */
*         4  RCLRBISA BIT(1),    /* INITIAL STATUS 1=ACTIVE          */
*         4  RCLBATCH BIT(1),    /* BATCHED MESSAGE INPUT       01S1009
*                                   FEATURE                          */
*         4  RCLRSV33 BIT(5),    /* RESERVED                         */
*      3  RCLGPADR PTR(24),      /* ADDRESSING INFORMATION POINTER
*                                                  (ADDR RCLCNGP)    */
*   2  RCLCTETR FIXED(15),       /* CNT TERMINAL ENTRIES FOR CLUSTER */
*   2  RCLCTECM FIXED(15),       /* CNT COMPONENT ENTRIES FOR CLUSTER*/
*   2  RCLRSV01 FIXED(15),       /* FILLER TO FORCE ALIGNMENT        */
*   2  RCLCTNGP FIXED(15),       /* GPOLL CHARACTER COUNT            */
*   2  RCLGPOLA PTR(31),         /* GPOLL CHARACTER STRING POINTER   */
*   2  RCLRVPT1 PTR(31),         /* RESERVED                         */
*   2  RCLRVPT2 PTR(31);         /* RESERVED                         */
*                                                               01S1009
*                                                               01S1009
*DCL                                                            01S1010
*1  ISTRTR BDY(WORD) BASED,      /* TERMINAL AND/OR COMPONENT ENTRY  */
*   2  RTRCRPR CHAR(LENGTH(ISTRCPRE)),     /* USE ISTRCPRE DSECT     */
*   2  RTRADR PTR(31),                                          01S1010
*      3  RTRFLAG BIT(8),                                       01S1010
*         4  RTRRSV21 BIT (1),   /* RESERVED */                 01S1010
*         4  RTRRBISA BIT(1),    /* INITIAL STATUS 1 = ACITVE        */
*         4  RTRRSV51 BIT(3),    /* RESERVED                         */
*         4  RTRVTERM BIT(1),    /* VTERM TERMINAL ENTRY             */
*         4 RTRRSV22 BIT(2),     /* UNUSED                           */
*      3  RTRADRPT PTR(24),      /* TO BE USED FOR POINTER TO   01S1010
*                                            ADDRESSING INFORMATION  */
*   2  RTRCTECM FIXED(15),       /* COUNT OF COMPONENT          01S1010
*                                               ENTRIES FOR TERMINAL */
*   2  RTRRSV01 FIXED(15),       /*  FILLER TO FORCE ALINEMENT       */
*   2  RTRRSV45 CHAR(4),         /* RESERVED                         */
*   2  RTRRDFA  BIT(8),          /* FLAG FIELD A                     */
*      3  RTRRAATN BIT(1),       /* TERMINAL CAN INTERRUPT PCCU      */
*      3  RTRRAALL BIT(3),       /* 3 FLAG FIELD                     */
*         4  RTRRAPT1 BIT(1),    /* PT1 BLOCK HANDLER FLAGS          */
*         4  RTRRAPT2 BIT(1),    /* PT2                              */
*         4  RTRRAPT3 BIT(1),    /* PT3                              */
*      3  RTRRACDT BIT(1),       /* CRITICAL DATA FLAG               */
*      3  RTRRSV60 BIT(1),       /* RESERVED                         */
*      3  RTRRACTR BIT(1),       /* LOGICAL DEVICE FLAG              */
*      3  RTRRSV02 BIT(1),       /* UNUSED                           */
*   2  RTRRDFB  BIT(8),          /* FLAG FIELD B - RESOURCE DEF      */
*      3  RTRRBECT BIT(1),       /* EMBEDDED LINE CONTROL            */
*      3  RTRRBEND BIT(1),       /* EOT/EOB                          */
*      3  RTRRSV32 BIT(6),       /* RESERVED                         */
*   2  RTRRDFC  BIT(8),          /* FLAG FIELD C - RESOURCE DEF      */
*      3  RTRRCIT1 BIT(1),       /* EIB CHAR AFTER ITB ON RECV       */
*      3  RTRRCIT2 BIT(1),       /* EIB CHAR AFTER ITB ON SEND       */
*      3  RTRRCPT3 BIT(1),       /* DEVICE HAS PT3 BHSET             */
*      3  RTRRCBLK BIT(1),       /* RECORD DATA - BLOCK              */
*      3  RTRRCMSG BIT(1),       /* RECORD DATA - MESSAGE            */
*      3  RTRRCXMS BIT(1),       /* RECORD DATA - XMISSION           */
*      3  RTRRSV23 BIT(2),       /* RESERVED/UNUSED                  */
*   2  RTRRDFD  BIT(8),          /* FLAG FIELD D - RESERVED          */
*      3  RTRRDBHN  BIT(1),      /* BHSET = NONE                     */
*      3  RTRRDBHD  BIT(1),      /* BHSET = DYNAMIC                  */
*      3  RTRRDBHI  BIT(1),      /* BHSET = SETNAME AND EXECUTR      */
*      3  RTRRSV10 BIT(2),       /* RESERVED                         */
*      3  RTRRSV11 BIT(3),       /* RESERVED                         */
*   2  RTRRDFE  BIT(8),          /* FLAG FIELD E - RESOURCE DEF      */
*/*                RTRREFT1  FEATURE FLAGS  (9 BITS)                 */
*      3  RTRREBRK BIT(1),       /* TRANSMIT INTERRUPT               */
*      3  RTRRSV0A BIT(1),       /* RESERVED                         */
*      3  RTRREACR BIT(1),       /* ACCELERATED CARRIAGE RETURN      */
*      3  RTRRECHK BIT(1),       /* CHECKING FEATURE                 */
*      3  RTRREATT BIT(1),       /*  TERMINAL INTERRUPT              */
*      3  RTRRESUP BIT(1),       /*  TIMEOUT SUPPRESSION             */
*      3  RTRRESCT BIT(1),       /*  STATION CONTROL                 */
*   2  RTRRDFF  BIT(8),          /* FLAG FIELD F - RESOURCE DEF      */
*      3  RTRRFXCT BIT(1),       /* TRANSMIT CONTROL                 */
*/*                      RTRRFFT2 FEATURE 2 FLAGS (NEXT 5 BITS)      */
*      3  RTRRFPEN BIT(1),       /* SELECTOR PEN                     */
*      3  RTRRFPFK BIT(1),       /* PROGRAM FUNCTION DEYBOARD        */
*      3  RTRRFANK BIT(1),       /* STANDARD ALPHA-NUMERIC KEYBOARD  */
*      3  RTRRFDEK BIT(1),       /* DATA ENTRY KEYBOARD              */
*      3  RTRRSV24 BIT(3),       /* UNUSED/RESERVED                  */
*   2  RTRTRMAX CHAR(1),         /* MAX # TRANSMISSIONS TERM TO PCCU */
*   2  RTRCRFLG PTR(8),          /* FLAG-CONFIGURATION RESTART       */
*      3 RTRCRSV1 BIT(2),        /* RESERVED FOR CONFIG RESTART      */
*      3 RTRLSCMD BIT(1),        /* LINE SCHEDULING CMD ISSUED OK    */
*        4 RTRDTRLM BIT(1),      /* CHNG DEV TRANSMISSION LIMIT OK   */
*      3 RTRCRSV2 BIT(5),        /* RESERVED FOR CONFIG. RESTART     */
*   2  RTRBHSN1 CHAR(8),         /* DEFAULT BHSET NAME IS BHF IS ON  */
*   2  RTRRVPT1 PTR(31),         /* RESERVED                         */
*   2  RTRRSV03 FIXED(15),       /* FILLER TO FORCE ALIGNMENT        */
*   2  RTRCTDIA FIXED(15),       /* CNT OF CHARS. IN TERM DIAL NUMBER*/
*   2  RTRCTPOL FIXED(15),       /* # CHARS. IN TERM POLL STRING     */
*   2  RTRCTADR FIXED(15),       /* COUNT OF ADDRESSING CHARACTERS   */
*   2  RTRCADDR  CHAR(8),        /* COMPONENT ADDRESSING CHARS       */
*   2  RTRPOLA PTR(31),          /* POINTER TO POLLING CHARACTERS    */
*   2  RTRDIAA PTR(31),          /* POINTING TO DIAL CHARACTERS      */
*   2  RTRRDFG  BIT(8),          /* CORRESPONDENCE CODE USED BY THIS
*                                   TERM LINE. SEE CONSTANTS.        */
*   2  RTRRSVDD CHAR(7),         /* RESERVED                         */
*   2  RTRBSCID CHAR(21),        /* BSC ID FIELD                     */
*      3  RTRIDLEN FIXED(8),     /* LENGTH OF ID                     */
*      3  RTRIDCAS CHAR(20),     /* ID CHARACTER                     */
*   2  RTRLCTI BIT(8),           /* LINE CONTROL TYPE ID             */
*   2  RTRRSV04 CHAR(2);         /* RESERVED                         */
*                                                               01S1010
* DCL RTRDNCBA PTR(31) DEF(ISTRTR) POS(41);  /* SCAFFOLDING          */
*/* CONSTANTS FOR FIELD RTRRDFG                                      */
*DCL RTRRCBCD BIT(8) CONSTANT('03'X); /* BCD                         */
*DCL RTRRCEBC BIT(8) CONSTANT('04'X); /* EBCD                        */
*DCL RTRRCCOR BIT(8) CONSTANT('05'X); /* COR                         */
*                                                               01S1014
*/*     CONSTANTS FOR FIELD RTRLCTI                                  */
*DCL RTR2741  BIT(8) CONSTANT('00'X);  /* 2741                       */
*DCL RTR2740A BIT(8) CONSTANT('02'X);  /* 2740-1 A (BASIC)           */
*DCL RTR2740D BIT(8) CONSTANT('06'X);  /* 2740-1 D (TRANS CONTROL)   */
*DCL RTR2740E BIT(8) CONSTANT('0A'X);  /* 2740-1 E (TRANS       01S1018
*                                   CONTROL WITH CHECKING            */
*DCL RTR2740F BIT(8) CONSTANT('0C'X);  /* 2740-1 F (CHECKING)        */
*DCL RTR1050  BIT(8) CONSTANT('1C'X);  /* 1050                       */
*DCL RTRTWX   BIT(8) CONSTANT('22'X);  /* TWX                        */
*/*                                                                  */
*/*   ENTRY IN LOCAL RN FOR REMOTE SEGMENT                           */
*/*                                                                  */
*DCL  1  ISTRIN   BDY(WORD) BASED,   /* INNODE REMOTE ENT IN LOCAL RN*/
*        2 RINCRPRE CHAR(LENGTH(ISTRCPRE)),  /* PREFIX               */
*        2 RINDFD   BIT(8),          /* FLAG FIELD                   */
*          3 RINREMPO BIT(1),        /* REMOTE POWER OFF             */
*            4 RTRREMPO BIT(1),      /* ALIAS                        */
*          3 RINNODEF BIT(1),        /* REMOTE TERM ENTRY INV AS ENT */
*            4 RTRNODEF BIT(1),      /* ALIAS                        */
*          3 RINLDISC BIT(1),        /* DISCONNECT REMOTE REQUIRED   */
*            4 RTRLDISC BIT(1),      /* ALIAS                        */
*          3 RINRSV01 BIT(5),        /* RESERVED                     */
*        2 RINNODID PTR(8),          /* NODE ID OF REMOTE            */
*          3 RTRNODID PTR(8),        /* ALIAS                        */
*        2 RINRLDAF CHAR(2),         /* DAF OF REMOTE WHEN ACTIVE    */
*          3 RTRRLDAF CHAR(2),       /* ALIAS                        */
*        2 RINREMOT PTR(31),         /* PTR TO RN ENTRY FOR REMOTE   */
*          3 RTRREMOT PTR(31),       /* ALIAS                        */
*        2 RINVPAB  PTR(31),         /* ADDR VARY PAB FOR REMOTE     */
*          3 RTRVPAB  PTR(31),       /* ALIAS                        */
*        2 RINRPHCN PTR(31),         /* ADDR RPH WAITING FOR CONTACT */
*          3 RTRRPHCN PTR(31),       /* ALIAS                        */
*        2 RINNCSPL PTR(31),         /* ADDR FOR NCSPL FOR DEACTIVATE*/
*          3 RTRNCSPL PTR(31),       /* ALIAS                        */
*        2 RINCNCNT PTR(8),          /* CONTACT COUNT FOR REMOTE     */
*          3 RTRCNCNT PTR(8),        /* ALIAS                        */
*        2 RINRSV02 CHAR(3),         /* RESERVED                     */
*        2 RINLOCRN PTR(31),         /* PTR TO RN ENTRY OF LOCAL     */
*        2 RINRSV04 CHAR(4),         /* RESERVED                     */
*        2 RINRSV05 CHAR(4);         /* RESERVED                     */
*/*                                                                  */
*DCL                                                            01S1023
*1   ISTRDS BDY(WORD) BASED,       /* LCDO ENTRY                     */
*           2  RDSPRE CHAR(LENGTH(ISTRPRE)), /* ENTRY PREFIX         */
*           2  RDSCTTRM FIXED(15), /* COUNT OF ENTRY POINTERS   01S1023
*                                     IN DIAL OUT TABLE              */
*           2  RDSCTATR FIXED(15), /*                                */
*           2  RDSADDOT PTR(31);   /* ADDRESS OF DIAL OUT TABLE      */
*/*                                                                  */
*DCL                                                            01S1024
*1   ISTDOT BDY(WORD) BASED,       /* DIAL OUT TABLE                 */
*           2  DOTADTRM PTR(31);   /* PTR TO DIAL OUT OR DIAL IN/
*                                     OUT TERMINAL RDTE              */
*/*                                                                  */
*DCL                                                            01S1025
*1 ISTRCC BDY(WORD) BASED,             /* PU ENTRY                   */
*  2 RCCPRE   CHAR(LENGTH(ISTRPRE)),   /* COMMON PREFIX              */
*  2 RCCTYPE  CHAR(1),                 /* PU TYPE                    */
*  2 RCCFLAG  BIT(8),                  /* FLAG FIELD                 */
*    3 RCCRBISA BIT(1),                /* I STATUS 1=ACTIVE          */
*    3 RCCCUDIE BIT(1),                /* CLUSTER DEACTIVATING       */
*    3 RCCERPIP BIT(1),                /* ERP IN PROCESS             */
*    3 RCCLDISC BIT(1),                /* DISCONNECT REQUEST         */
*    3 RCCOHIMM BIT(1),                /* RTGOH RECEIVED AND WAS     */
*                                      /* AN IMMEDIATE TYPE          */
*    3 RCCOUERP BIT(1),                /* REPEAT ERP                 */
*    3 RCCPRGDN BIT(1),                /* PURGE ISSUED               */
*    3 RCCCTPGD BIT(1),                /* CONTACT PURGED             */
*  2 RCCFLAGB BIT(8),                  /* FLAG FIELD                 */
*    3 RCCDSTCT BIT(1),                /* DEACT TO DECR STCNT IN HDR */
*    3 RCCDIALP BIT(1),                /* DIAL IN PROGRESS           */
*    3 RCCIRETR BIT(1),                /* IRETRY 1 = YES             */
*    3 RCCBNNSP BIT(1),                /* BNNSUP FOR 3270            */
*    3 RCCFINAL BIT(1),                /* ON = DEACT PU FINAL REQD   */
*    3 RCCRESET BIT(1),                /* ON = RESET DEACT IN PROCESS*/
*    3 RCCBRKCN BIT(1),                /* ON-DISCOUNT=YES SPECIFIED  */
*                                      /* OFF-DISCOUNT=NO SPECIFIED  */
*    3 RCCRTGOH BIT(1),                /* ON=RTGOH RECEIVED          */
*  2 RCCCNCNT  PTR(8),                 /* CONTACT COUNT              */
*  2 RCCCTELU FIXED(15),               /* COUNT OF PU LU ENTRIES     */
*  2 RCCSTAID CHAR(8),                 /* 64 BIT PU STATION ID       */
*    3 RCCIDPA1 BIT(16),               /* FILLER OF 2 BYTES OF 0     */
*    3 RCCID48,                                                 01S1025
*      4 RCCIDPUT BIT(8),              /* PU TYPE                    */
*      4 RCCIDPA2 BIT(8),              /* FILLER OF 1 BYTE OF 0      */
*      4 RCCIDBLK BIT(12),             /* IDBLK VALUE                */
*      4 RCCIDNUM BIT(20),             /* IDNUM VALUE                */
*  2 RCCSESCT PTR(8),                  /* SESSION COUNT              */
*  2 *        CHAR(1),                 /* RESERVED                   */
*  2  RCCVPAB PTR(31),                 /* ADDRESS OF VARY PAB        */
*  2 RCCDPAB  PTR(31),                 /* ADDR RESTART PAB           */
*  2 RCCEPAB  PTR(31),                 /* ADDR OF ERP PAB            */
*  2 RCCRPHCN PTR(31),                 /* ADDR RPH WAIT FOR CONTACT  */
*  2 RCCNCSPL PTR(31),                 /* ADDR NCSPL FOR DEACTIVATE  */
*  2 RCCCRFLG BIT(8),                  /* FLAG-CONFIGURATION RESTART */
*    3 RCCACTPU BIT(1),                /* ACTIVATE PHYSICAL          */
*    3 RCCCTCFL BIT(1),          /* HIGHER FAILURE-CONTACT FLUSHED   */
*    3 RCCCRRSV BIT(6),                /* RES. FOR CONFIG. RESTART   */
*  2 RCCRSV02 PTR(24),                 /* RESERVED                   */
*  2 RCCTPAB  PTR(31),                 /* TOLTEP SSCP PAB            */
*  2 RCCDPQ   PTR(31),                 /* DIAL PENDING NCSPL QUE PTR */
*  2 RCCPATHT PTR(31),                 /* PTR TO PATH TABLE          */
*  2 RCCPATHZ FIXED(15),               /* # ENTRIES IN PATH TABLE    */
*  2 RCCINDEX FIXED(15),               /* INDEX TO PATH TABLE        */
*  2 RCCMXDAT FIXED(15),               /* MAXDATA SIZE               */
*  2 RCCMXOUT FIXED(8),                /* MAXOUT VALUE               */
*  2 RCCPASSL FIXED(8),                /* PASSLIM VALUE              */
*  2 RCCADDR  FIXED(8),                /* STATION ADDRESS            */
*  2 RCCRSPT2 PTR(24),                 /* RESERVED                   */
*  2 RCCSWTOX PTR(31),                 /* SWITCHED TO 370X           */
*                                      /* COMMUNICATIONS NCSPL       */
*  2 RCCXTOSW PTR(31),                 /* 370X TO SWITCHED           */
*                                      /* COMMUNICATIONS NCSPL       */
*  2 RCCRVPT2 PTR(31);                 /* RESERVED                   */
*/* RCCTYPE - PU TYPE CODES                                          */
*DCL RCCPU01  BIT(8) CONSTANT('01'X);  /* PU TYPE 1                  */
*DCL RCCPU02  BIT(8) CONSTANT('02'X);  /* PU TYPE 2                  */
*DCL RCCPU03  BIT(8) CONSTANT('03'X);  /* PU TYPE 3                  */
*DCL RCCPU04  BIT(8) CONSTANT('04'X);  /* PU TYPE 4                  */
*/*                                                                  */
*DCL                                                            01S1030
*1 ISTRLU BDY(WORD) BASED,             /* LU ENTRY                   */
*  2 RLUCRPR CHAR(LENGTH(ISTRCPRE)),   /* COMMON PREFIX              */
*  2 RLUTYPE  CHAR(1),                 /* LU TYPE                    */
*  2 RLUFLAG  CHAR(1),                 /* RLU FLAGS                  */
*    3 RLURBISA BIT(1),                /* I STATUS 1=ACTIVE          */
*    3 RLUBATCH BIT(1),                /* 1 IF BATCH = YES           */
*    3 RLUGSTAT BIT(1),                /* C/R GENNED ISTATUS VALUE   */
*                                      /* 1 = ACTIVE                 */
*    3 RLUNDSES BIT(1),                /* SPECIAL END SESSION        */
*    3 RLURSV00 BIT(4),                /* RESERVED                   */
*  2 RLUCRFLG BIT(8),                  /* FLAG-CONFIGURATION RESTART */
*    3 RLUACTLU BIT(1),                /* ACTIVATE LOGICAL UNIT OK   */
*    3 RLUCRRSV BIT(7),                /* RESERVED FOR CONFIG RESTART*/
*  2 RLUSSCFM BIT(8),                  /* FUNCTION MANAGER TYPE      */
*  2 RLUINTA PTR(31),                  /* RESERVED                   */
*  2 RLUPACE CHAR(2),                  /* VPACING COUNTS             */
*    3 RLUPACEN CHAR(1),               /* N COUNT                    */
*    3 RLUPACEM CHAR(1),               /* M COUNT                    */
*  2 RLUNCPPC CHAR(2),                 /* NCP PACING COUNTS          */
*    3 RLUNCPPN CHAR(1),               /* N COUNT                    */
*    3 RLUNCPPM CHAR(1),               /* M COUNT                    */
*  2 RLULOCAD CHAR(1),                 /* LOCAL ADDRESS OF LU        */
*  2 RLURSV01 CHAR(3),                 /* RESERVED                   */
*  2 RLUUSSTB CHAR(12) BDY(WORD),      /* USSTAB                     */
*    3 RLUUSSNM CHAR(8),               /* USSTAB NAME                */
*    3 RLUUSSPT PTR(31),               /* USSTAB ADDRESS             */
*  2 RLUMODET CHAR(12) BDY(WORD),      /* MODETAB                    */
*    3 RLUMODEN CHAR(8),               /* MODETAB NAME               */
*    3 RLUMODEP PTR(31),               /* MODETAB ADDRESS            */
*  2 RLULGMOD CHAR(8),                 /* LOGMODE                    */
*  2 RLURSV02 PTR(31);                 /* RESERVED                   */
*/*  RLUSSCFM - FOLLOWING EQUATES ARE FOR THE VARIOUS                */
*/*             FUNCTION MANAGER TYPES                               */
*DCL RLUFSS   BIT(8) CONSTANT('01'X);  /* FORMATTED SYS SERVICES     */
*DCL RLUUSS   BIT(8) CONSTANT('02'X);  /* UNFORMATTED SYS SERVICES   */
*DCL RLUU3270 BIT(8) CONSTANT('04'X);  /* UNFORMATTED SYS SVCS 3270  */
*/*  RLUTYPE - EQUATES FOR LU TYPE                                   */
*DCL RLUTYP04 BIT(8) CONSTANT('04'X);  /* LU TYPE IS 4               */
*/*                                                                  */
*DCL 1 ISTRPX BDY(WORD) BASED,     /* SKELETON PUX ENTRY             */
*      2 RPXPRE CHAR(LENGTH(ISTRPRE)),  /* COMMON PREFIX             */
*      2 RPXFLUX  PTR(31),         /* PTR TO FIRST LUX IN CHAIN      */
*      2 RPXMAXLU PTR(8),          /* MAX NUMBER OF LU'S             */
*                                  /* FOR THIS LINK                  */
*      2 RPXRSV02 PTR(24),         /* RESERVED                       */
*      2 RPXRSV01 PTR(31);         /* RESERVED                       */
*/*                                                                  */
*DCL 1 ISTRLX BDY(WORD) BASED,     /* SKELETON LUX ENTRY             */
*      2 RLXPRE CHAR(LENGTH(ISTRPRE)),  /* COMMON PREFIX             */
*      2 RLXNLUX  PTR(31),         /* PTR TO NEXT LUX IN CHAIN       */
*      2 RLXFLAGA CHAR(1),         /* FLAG BYTE                      */
*        3 RLXINUSE BIT(1),        /* ON = LUX IS IN USE             */
*        3 RLXRSV01 BIT(7),        /* RESERVED                       */
*      2 RLXRSV02 CHAR(3),         /* RESERVED                       */
*      2 RLXRSV03 PTR(31);         /* RESERVED                       */
*/*                                                                  */
*DCL 1 ISTRSW BDY(WORD) BASED,     /* SWITCHED SUBAREA HDR ENTRY     */
*      2 RSWPRE CHAR(LENGTH(ISTRDT)),   /* USE ISTRDT DSECT          */
*      2 RSWDIALT PTR(31),         /* PTR TO DIAL #'S TABLE          */
*      2 RSWGRUPT PTR(31),         /* PTR TO GROUP NAMES TABLE       */
*      2 RSWDIALZ FIXED(15),       /* # ENTRIES IN DIAL NO. TABLE    */
*      2 RSWGRUPZ FIXED(15),       /* # ENTRIES IN GRP NAME TABLE    */
*      2 RSWCTELU FIXED(15),       /* COUNT OF LU ENTRIES IN THIS SEG*/
*      2 RSWRSV02 CHAR(2),         /* RESERVED                       */
*      2 RSWRSV01 PTR(31);         /* RESERVED                       */
*/*                                                                  */
*DCL 1 ISTRDA BDY(WORD) BASED,     /* DAN ENTRY                      */
*      2 RDAPRE CHAR(LENGTH(ISTRPRE)),  /* COMMON PREFIX             */
*      2 RDAADR   PTR(31),                                      01S1038
*        3 RDAFLAG  BIT(8),        /* FLAG BYTE                      */
*          4 RDARBISA BIT(1),      /* INITIAL STATUS, 1 = ACTIVE     */
*          4 RDARSV01 BIT(7),      /* RESERVED                       */
*        3 RDAUCBAD PTR(24),       /* UCB.PUB ADDRESS                */
*          4 RDACHQI  BIT(8),      /* CHANNEL QUEUE INDEX            */
*          4 RDALUBA  BIT(16),     /* @ OF LOGICAL UNIT BLOCK        */
*      2 RDADACUA CHAR(3),         /* CHANNEL UNIT ADDRESS           */
*      2 RDACTPCC PTR(8),          /* CNT OF BUFFERS RECEIVING DATA  */
*      2 RDADFCUA CHAR(3),         /* DEFAULT CUA                    */
*      2 RDAPUBI  BIT(8),          /* PUB INDEX                      */
*      2 RDARSVPT PTR(31);         /* RESERVED                       */
*/*                                                                  */
*DCL 1 ISTRLS BDY(WORD) BASED,     /* LOCAL SUBAREA HEADER ENTRY     */
*      2 RLSPRE CHAR(LENGTH(ISTRDT)),   /* USE ISTRDT DSECT          */
*      2 RLSCTELU FIXED(15),       /* COUNT OF LU ENTRIES IN THIS SEG*/
*      2 RLSRSV01 FIXED(15),       /* RESERVED                       */
*      2 RLSRSV02 PTR(31);         /* RESERVED                       */
*/*                                                                  */
*DCL  1  ISTDNT BDY(WORD) BASED,  /* DIAL NUMBER TABLE               */
*        2 DNTCTDIG FIXED(8),     /* NUMBER OF DIGITS IN TEL. NUM.   */
*        2 DNTTELNO CHAR(32);     /* TELEPHONE NUMBER                */
*/*                                                                  */
* DCL  1  ISTGNT BDY(WORD) BASED, /* GROUP NAMES TABLE               */
*         2 GNTGRPNM CHAR(8);     /* GROUP NAME ENTRY                */
*/*                                                                  */
*DCL  1  ISTPAT BDY(WORD) BASED,  /* PATH TABLE                      */
*        2 PATGINDX FIXED(15),    /* INDEX TO GROUP NAME TABLE       */
*        2 PATDINDX FIXED(15),    /* INDEX TO DIAL NUMBER TABLE      */
*        2 PATPTHID PTR(8),       /* PATH ID                         */
*        2 PATGRPID PTR(8),       /* GROUP PATH ID                   */
*        2 PATRDCNT PTR(8),       /* REDIAL COUNT                    */
*        2 PATFLAGA BIT(8),       /* FLAG BYTE                       */
*          3 PATUSEFG BIT(1),     /* ON = PATH INITIALLY USABLE      */
*          3 PATRSV01 BIT(7);     /* RESERVED                        */
*             /*  MAJOR NODE TABLE        */                    01S1043
*/* THE FOLLOWING DCR HAS BEEN APPLIED TO THIS CONTROL BLOCK    01S1043
*   IK370 - 10/18/72                                                  *
*/* 1K1245 - APRIL 27, 73 - DM */                               01S1043
*   DCL                                                         01S1043
*  1  ISTMNT BASED BDY(WORD),    /* EACH ENTRY CONTAINS A            */
*    2  MNTENTRY BDY(WORD),      /* MNT ENTRY                        */
*      3  MNTSNT    PTR(31),     /*  SNT ENTRY                       */
*      3  MNTLOCK CHAR(LENGTH(ISTLOK));   /* MNT ENTRY LOCK WORD     */
*/*         SPECIFIC NODE TABLE                                       *
*/*  REVISIONS                                         002 03/14/75   *
*DECLARE                                                        01S1044
*  1 ISTSNT  BDY(DWORD) BASED,                                  01S1044
*/*  ENTIRE SNTENTRY IS MODIFIED BY A COMPARE                         *
*/*  AND SWAP DOUBLE IN CIDADD - ISTSDCCA.                            *
*    2 SNTNENTS FIXED(31),             /* NUMBR OF ENTRIES IN THIS SNT*
*    2 SNTRSRVD FIXED(31),             /* RESERVED TO FORCE DWORD BDY *
*    2 SNTENTRY BDY(DWORD),            /* SNT ENTRY                   *
*       3 SNTWORD1 PTR(31),            /* FLAG AND POINTER FIELD      *
*         4 SNTFLAG  BIT(8),           /* FLAG BYTE                   *
*           5 SNTRDTFG BIT(1),         /* RDT ENTRY FLAG,1=RDTE,0=NCB *
*           5 SNTSNTFG BIT(1),         /* THIS SNT ENTRY CONTAINS A   *
*                                      /* POINTER TO AN SNT ENTRY     *
*           5 SNTDUMFG BIT(1),         /* THIS IS SNT FOR A DUMMY RDTE*
*                                      /* IT IS NEVER LOCKED          *
*           5 SNTRSVFG BIT(5),         /* RESERVED                    *
*         4 SNTCBPTR PTR(24),          /* PTR TO DNCB,ICNCB,LDNCB,ETC *
*       3 SNTLOCK CHAR(LENGTH(ISTLOK));     /* THIS WILL BE SNT ADDR  *
*                                           /* WHEN ADD IS DONE BY    *
*                                           /* SSCP FOR DUMMY RDTE    *
*DCL  1  ISTBHSAT BDY(WORD) BASED,                              01S1045
*        2 BHSNAME  CHAR(8),        /* BLOCK HANDLER SET NAME        */
*        2 BHSINDEX PTR(8);         /* BLOCK HANDLER SET INDEX       */
*  /***   MAIN LINE COMMUNICATION AREA   ***/                   01S1046
*/*  REVISIONS                                         003 04/25/75   *
*DCL                                                            01S1046
* 1  ISTMLCA BDY(DWORD) BASED,                                  01S1046
*   2  MLCSECCA PTR(31),               /* PTR OT SECONDARY COMM. AREA *
*   2  MLCRPH  PTR(31),                /* PTR TO RPH FOR GETSTORS AND
*                                                       SRTADDS       *
*   2  MLCSKEL PTR(31),                /* PTR TO SKELETON RDT         *
*   2  MLCSKDCB PTR(31),               /* PTR TO DCB FOR READ/WRITING
*                                          SKELETONS FROM/TO    01S1046
*                                          SYS1.VTAMOEJ              */
*   2  MLCFLAGS CHAR(4),               /* FLAGS WORD                 */
*     3  MLCINT BIT(1),                /* 0 = LOAD, 1 = DELETE  01S1046
*                                         INTERPRET TABLE             *
*   2  MLCENT   PTR(31),               /* PTR TO CURRENT ENTRY        *
*   2  MLCKWD   PTR(31),               /* PTR OT CURRENT KEYWORD      *
*   2  MLCERBF  CHAR(64),                                       01S1046
*    3 MLCERBF1 CHAR(8),               /* MESSAGE INSERT USED BY ERRFMT
*                                          AND MOST SYS DEF TPMSG'S   *
*     4  MLCCONFG CHAR(8),             /* CONFIGURATION NAME SET BY
*                                         MAIN LINE - ISTSDRC         *
*    3 MLCERBF2 CHAR(24),              /*MESSAGE INSERT USED BY ERRFMT*
*     4  MLCNAME   CHAR(8),            /* NAME ON MACRO SET BY MHR    *
*     4  MLCMACRO CHAR(8),             /* MACRO TYPE SET BY MHR       *
*     4  MLCFII CHAR(8),               /* KEYWORD SET BY ERRFMT       *
*    3 MLCERBF3 CHAR(32),              /* MESSAGE INSERT USED BY SOME
*                                         SYS DEFINITION TPMSG'S      *
*     4  MLCCNFG2 CHAR(8),             /* CONFIG NAME-SET BY MAIN LINE*
*     4  MLCFIII   CHAR(24),           /* VAR TEXT SET BY TPMSG ISSUER*
*   2  MLCGETSZ FIXED(31),             /* OPTIMUM GETSTOR SIZE        *
*  /***   ADDBITS FIELD - THE MLCPTRS FIELDS ARE USED BY ADDBITS
*         TO BASE APPROPRIATE MODELS OR SIFT ENTRIES        ***/
*   2  MLCPTRS  CHAR(40) BDY(WORD),    /* MLC POINTERS                *
*      3  MLCPTR0  PTR(31),            /* BASE FOR APPL, LOCAL, RN,
*                                         LINELIST, GROUP, OR DIALSET
*                                         MODELS             @DL29HDM *
*      3  MLCPTR1  PTR(31),            /* BASE FOR LINE MODEL OR SIFT
*                                                             ENTRY   *
*      3  MLCPTR2  PTR(31),            /* BASE FOR CLUSTER MODEL OR
*                                                         SIFT ENTRY */
*      3  MLCPTR3  PTR(31),            /* BASE FOR TERMINAL OR COMP
*                                         MODEL OR TERMINAL SIFT ENTRIE
*                                                            @DL29HDM *
*      3  MLCPTR4 PTR(31),             /* BASE FOR DEVCH AREA IN
*                                       TERMINAL MODEL OR SIFT ENTRIES*
*      3  MLCPTR5 PTR(31),             /* BASE FOR PHYSICAL UNIT(PU)
*                                       MODEL OR SIFT ENTRY           *
*      3  MLCPTR6 PTR(31),             /* BASE FOR LOGICAL UNIT MODEL
*                                       OR SIFT ENTRY                 *
*      3  MLCPTR7 PTR(31),             /* BASE FOR DUMMY PU MODEL     *
*                                      /* OR SIFT ENTRY               *
*      3  MLCLENT PTR(31),             /* PTR TO (CURRENT-1) ENTRY    *
*      3  MLCNCSPL PTR(31),            /* POINTER TO NCSPL            *
*/***   GENERAL PURPOSE SAVE AND DATA AREAS   ***/              01S1046
*   2  * BDY(DWORD),                                            01S1046
*   2  MLCSAV1  (18) PTR(31) BDY(WORD),                         01S1046
*   2  MLCDAT1  CHAR(56),                                       01S1046
*   2  MLCSAV2  (18) PTR(31) BDY(WORD),                         01S1046
*   2  MLCDAT2  CHAR(56),                                       01S1046
*   2  MLCSAV3  (18) PTR(31) BDY(WORD),                         01S1046
*   2  MLCDAT3  CHAR(56),                                       01S1046
*   2  MLCSAV4  (18) PTR(31) BDY(WORD),                         01S1046
*   2  MLCDAT4 CHAR(56),                                        01S1046
*  /***   WORK AREAS - OVERLAYED BY PARMLISTS, DCB'S ETC. ***/  01S1046
*   2  MLCADSAV (18) PTR(31) BDY(WORD),    /* SAVE AREA FOR ADDBITS */
*     3  MLCARSAV   PTR(31) , /* SAVE AREA FOR AREAHDLR*/       01S1046
*   2  MLCADDAT CHAR (56),             /* DATA AREA FOR ADDBITS      */
*     3  MLCARDAT  CHAR(56),           /* DATA AREA FOR AREAHDLR  */
*   2  MLCERSAV (18) PTR(31) BDY(WORD),  /* SAVE AREA FOR ERRFMT     */
*   2  MLCERDAT CHAR(56),              /* DATA AREA FOR ERRFMT        *
*   2  MLCMHDAT CHAR(56)BDY(WORD),    /* DATA AREA USED BY MHR       */
*   2  MLCWRK1  CHAR(256),                                      01S1046
*     3  MLCDCB  CHAR(256),         /* BASE DCB DSECT */        01S1046
*   2  MLCWRK2  CHAR(64) BDY(WORD),                             01S1046
*     3  MLCOCPRM  CHAR(64) BDY(WORD),                          01S1046
*                                   /* BASE LDPRM FOR OPEN/CLOSE */
*       4  MLCACPRM  (2) PTR(31),    /* PARM LIST FOR ADD/REMOVE MAC. *
*   2  MLCWRK3  CHAR(64),                                       01S1046
*     3  MLCRDPRM  CHAR(64),         /* BASE LDPRM FOR PARMREAD */
*       4  MLCLDPRM  CHAR(64),       /* BASE LDPRM FOR ALOAD + DELETE *
*   2  MLCWRK4  CHAR(64),                                       01S1046
*     3  MLCTPMSG CHAR(64),          /* BASE TPMSG PARAMETER LIST    */
*       4  MLCDECB1  CHAR(32),       /* BASE FOR DECB USED BY ISTSDCSS
*                                                             AND SU */
*       4  MLCDECB2  CHAR(32),       /* BASE FOR DECB USED BY   01S1046
*                                                           ISTSDCSS */
*          5  MLCSTOWL  CHAR(32);    /* BASE FOR STOW PARAMETER LIST
*                                                  USED BY ISTSDCSU  */
*/* COMPLETED DCR SOLUTIONS                                          */
*/* 1K1120 MARCH 27, 1973 MB                                         */
*/*        JUNE 7, 1973 MB                                           */
*/*           DIAL-IN TYPE TABLE ENTRY                               */
*DCL 1 ISTDTE BASED BDY(WORD),          /* DIAL-IN TYPE TABLE ENTRY  */
*     2  DTELCTI BIT(8),                /* LINE CONTROL TYPE ID      */
*     2  DTERDTEA PTR(31) BDY(BYTE);    /* RDTE ADDRESS              */
*DCL DITTEND BIT(8) CONSTANT('FF'X);    /* END OF TABLE INDICATION   */
*DCL DTEND   BIT(8) CONSTANT('FF'X);    /* END OF TABLE INDICATION   */
*/****** DIAL-IN VERIFICATION TABLE ENTRY ******/               01S1050
*/* APPLIED DCR'S */                                            01S1050
*/* 1K1396 - MAR 27, 73 - DM */                                 01S1050
*DCL  1  ISTDVE BDY(WORD) BASED,                                01S1050
*        2  DVERDTEA PTR(31),           /* RDTE ADDRESS              */
*           3  DVEACIND BIT(1),         /* ACTVE ENTRY INDIC, 0=ACTIVE*
*        2  DVEBSCID,                   /* BSCID FIELD               */
*           3  DVEBSCLN FIXED(8),       /* BSCID LENGTH              */
*           3  DVEBSCAR CHAR(*);        /* BSCID CHARACTERS          */
*/* COMPLETED DCR SOLUTIONS                                          */
*/* 1K1120 MARCH 27, 1973 MB                                         */
*/* DIAL-IN VERIFICATION TABLE HEADER                                */
*DCL 1  ISTDIVTH BASED BDY(WORD),       /* DIAL-IN VERIFICATION TABLE
*                                          HEADER                    */
*     2  DIVNUME FIXED(15),             /* NO. OF ENTRIES            */
*     2  DIVNUMFE FIXED(15),            /* NO. OF FREE ENTRIES       */
*     2  DIVIDLEN FIXED(15),            /* LENGTH OF BSCID FIELD
*                                          (MAX BSCID LEN)           */
*     2  DIVRSV01 CHAR(2);              /* UNUSED                    */
*/* PARAMETER FOR ALOAD */                                      01S1052
*DCL  LDPRMPTR PTR(31) REGISTER(1) RESTRICTED;                  01S1052
*DCL  1  ISTLDPRM BDY(WORD) BASED(LDPRMPTR),                    01S1053
*        2  LDPMBR  CHAR(8),           /* MODULE NAME                */
*        2  LDPPDS  CHAR(8),           /* LIBRARY NAME               */
*        2  LDPDCBA PTR(31),           /* DCB POINTER                */
*        2  LDPFG   CHAR(1),           /* LOAD PARAMETER LIST FLAG
*                                         BYTE                       */
*          3  LDPFX  BIT(1),           /* FLAG TO FIX LOADED CODE
*                                                                    */
*          3  LDPPB  BIT(1),           /* FLAG TO LOAD CODE ON 2K BDY
*                                                                    */
*          3  LDPRSV03  BIT(6),        /* RESERVED                   */
*        2  LDPFB2  CHAR(1),           /* LOAD FLAG BYTE 2 (USED
*                                         BY ATTACH)                 */
*         3  LDPFLAST BIT(1),          /* LAST ENTRY IN LIST         */
*         3  LDPATACH BIT(1),          /* ATTACH THIS ROUTINE AFTER
*                                         LOADING IT                 */
*         3  LDPACTIF BIT(1),          /* THIS TASK IS ATTACHED      */
*         3  LDPRSV01 BIT(5),          /* RESERVED                   */
*        2  LDPRSV02 CHAR(2),          /* RESERVED                   */
*        2  LDPTCEP PTR(31);           /* TCB OF ATTACHED ROUTINE    */
*/*     VTAM CONFIGURATION TABLE                                    */
*/*                                                                 */
*/*  DELTA                                             004 02/10/75 */
*/*                                                                 */
*       DECLARE                                                 01S1054
*       1 ISTCONFT BASED BDY(WORD),                             01S1054
*         2 CONCONFG CHAR(8),         /*NAME OF CONFIGURATION TABLE */
*         2 CONAPINM CHAR(8),         /*API MODULE NAME             */
*         2 CONAPSNM CHAR(8),         /*APS MODULE NAME             */
*         2 CONDMNM CHAR(8),          /*DEVICE MANAGEMENT CONTROL
*                                       LAYER MODULE NAME           */
*         2 CONFBPNM CHAR(8),         /*FEEDBACK PROCESSING     01S1054
*                                       ROUTINE MODULE NAME         */
*         2 CONACB PTR(31),           /*POINTER TO VTAM ACB         */
*         2 CONCIBAD PTR(31),         /*POINTER TO COMMAND INPUT
*                                       BUFFER                      */
*         2 CONDISLA PTR(31),         /*DISPLAY COMMAND         01S1054
*                                       PARAMETER LIST ADDRESS      */
*         2 CONNCSLA PTR(31),         /*NCS PARAMETER LIST      01S1054
*                                       ADDRESS                     */
*         2 CONHLTLA PTR(31),         /*HALT COMMAND PARAMETER  01S1054
*                                       LIST ADDRESS                */
*         2 CONMODLA PTR(31),         /*MODIFY COMMAND PARAMETER
*                                       LIST ADDRESS                */
*         2 CONVARLA PTR(31),         /*VARY COMMAND PARAMETER  01S1054
*                                       LIST ADDRESS                */
*         2 CONENDLA PTR(31),         /*THE LAST COMMAND PROCESSED
*                                       PARAMETER LIST ADDRESS      */
*         2 CONSTCIB PTR(31),         /*START COMMAND CIB ADDRESS   */
*         2 CONRDBUF PTR(31),         /*BUFFER ADDRESS USED BY  01S1054
*                                       READ ROUTINE                */
*         2 CONLDPRM PTR(31),         /*POINTER TO ISTLDPRM         */
*         2 CONDCBOA PTR(31),         /*ADDRESS OF VTAMLIBDCB       */
*         2 CONDCBLA PTR(31),         /*ADDRESS OF VTAMLIBDCB       */
*         2 CONDCBBA PTR(31),         /*ADDRESS OF VTAMLIBDCB       */
*         2 CONRSV02 PTR(31),         /* RESERVED                   */
*         2 CONBUFSZ FIXED(15),       /*SIZE OF BUFFER USED BY  01S1054
*                                       READ ROUTINE                */
*         2 CONCID PTR(16),           /*OPERATOR TERMINAL CID       */
*         2 CONRES2 CHAR(1),          /*RESERVED                    */
*         2 CONLAST CHAR(1),          /*LAST COMMAND CODE           */
*         2 CONHALT BIT(8),           /*HALT FLAGS                  */
*             3 CONHLTQ BIT(1),       /* QUICK FLAG                 */
*             3 CONHLTS BIT(1),       /* SESSION FLAG               */
*         2 CONVARY CHAR(1),          /*VARY CODE                   */
*         2 CONDISPL CHAR(1),         /*DISPLAY CODE                */
*         2 CONMODFY CHAR(1),         /*MODIFY CODE                 */
*         2 CONFLAGS CHAR(5),         /*FLAGS                       */
*           3 CONDSFLG CHAR(1),       /*DATA SET FLAGS:             */
*             4 * BIT(1),             /*RESERVED                    */
*             4 * BIT(1),             /*RESERVED                    */
*             4 * BIT(1),             /*RESERVED                    */
*             4 CONSYOBJ BIT(1),      /*SYS1.VTAMOBJ IS OPEN        */
*             4 CONSYLIB BIT(1),      /*SYS1.VTAMLIB IS OPEN        */
*             4 CONSYLST BIT(1),      /*SYS1.VTAMLST IS OPEN        */
*           3 CONOPTFL CHAR(1),       /*OPTIONAL SERVICES FLAGS:    */
*             4 CONWRMST BIT(1),      /* WARM SPECIFIED ON VTAM     */
*                                     /* START COMMAND, 1=YES       */
*             4 * BIT(1),             /*RESERVED                    */
*             4 * BIT(1),             /*RESERVED                    */
*             4 * BIT(1),             /*RESERVED                    */
*             4 CONBUFTR BIT(1),      /*BUFFER TRACE REQUESTED      */
*             4 CONBTUTR BIT(1),      /*BTU TRACE REQUESTED         */
*             4 CONMODTR BIT(1),      /*MODULE TRACE REQUESTED      */
*             4 CONIOTR BIT(1),       /*I/O TRACE REQUESTED         */
*           3 CONSTAT CHAR(1),        /*RESOURCE STATUS FLAGS:      */
*             4 * BIT(1),             /*RESERVED                    */
*             4 * BIT(1),             /*RESERVED                    */
*             4 * BIT(1),             /*RESERVED                    */
*             4 CONSTOR BIT(1),       /*VTAM HAS STORAGE            */
*             4 CONDSOPN BIT(1),      /*DATA SETS OPEN              */
*             4 CONLODED BIT(1),      /*VTAM ROUTINES LOADED        */
*             4 CONVRYIN BIT(1),      /*NETWORK VARIED IN           */
*             4 CONACTV BIT(1),       /*OPERATOR ACTIVE             */
*           3 CONBUFF  CHAR(2),       /*BUFFER STATUS FLAGS          */
*             4 CONSFEX BIT(1),       /*SMALL FIXED POOL EXIST       */
*             4 CONSPEX BIT(1),       /*SMALL PAGED POOL EXIST       */
*             4 CONLFEX BIT(1),       /*LARGE FIXED POOL EXIST       */
*             4 CONLPEX BIT(1),       /*LARGE PAGED POOL EXIST       */
*             4 CONVFEX BIT(1),       /* VARIABLE FIXED BFR POOL (DOS)
*                                        EXISTS                      */
*             4 CONVPEX BIT(1),       /* VARIABLE PG BFR POOL EXISTS
*                                        (DOS)                       */
*             4  CONUECB BIT(1),      /* UECB POOL EXISTS (VS1 & VS2)*/
*             4  CONIOEX BIT(1),      /* I/O FIXED POOL EXISTS       */
*             4  CONWPEX BIT(1),      /* WORKING SET POOL EXISTS     */
*             4  CONAPEX BIT(1),      /* ACE/ICE POOL EXISTS         */
*             4  CONNPEX BIT(1),      /* NON-WORKING SET POOL EXISTS */
*             4  CONPPEX BIT(1),      /* PAGEABLE DATA POOL EXISTS   */
*             4  CONCRPL BIT(1),      /* CRPL POOL EXISTS            */
*         2 CONRSV17 CHAR(1),         /* RESERVED FOR ALIGNMENT      */
*   /***    START BUFFERS           ***/                        01S1054
*         2 CONSFSBF CHAR(12),        /* SMALL FIXED LIST            */
*         2 CONSPSBF CHAR(12),        /* SMALL PAGEABLE LIST         */
*         2 CONLFSBF CHAR(12) BDY(HWORD), /* LARGE FIXED LIST        */
*         2 CONLPSBF CHAR(12),        /* LARGE PAGEABLE LIST         */
*         2 CONVFSBF CHAR(12),        /* VARIABLE LENGTH FIXED LIST  */
*         2 CONVPSBF CHAR(12),        /* VARIABLE-LENGTH PAGEABLE    */
*         2 CONIOSBF CHAR(12),        /* I/O FIXED LIST              */
*         2 CONWPSBF CHAR(12),        /* WORKING SET POOL LIST       */
*         2 CONAPSBF CHAR(12),        /* ACE/ICE POOL LIST           */
*         2 CONNPSBF CHAR(12),        /* NON-WORKING SET LIST        */
*         2 CONPPSBF CHAR(12),        /* PAGEABLE DATA POOL LIST     */
*         2 CONCRPLS CHAR(12),        /* CRPL POOL LIST              */
*   /***    DEFAULT BUFFERS         ***/                        01S1054
*         2 CONSFDBF CHAR(12),        /* SMALL FIXED LIST            */
*         2 CONSPDBF CHAR(12),        /* SMALL PAGEABLE LIST         */
*         2 CONLFDBF CHAR(12),        /* LARGE FIXED LIST            */
*         2 CONLPDBF CHAR(12),        /* LARGE PAGEABLE LIST         */
*         2 CONVFDBF CHAR(12),        /* VARIABLE-LENGTH FIXED LIST  */
*         2 CONVPDBF CHAR(12),        /* VARIABLE-LENGTH PAGEABLE    */
*         2 CONUEDBF CHAR(12),        /* UECB LIST                   */
*         2 CONIODBF CHAR(12),        /* I/O FIXED LIST              */
*         2 CONWPDBF CHAR(12),        /* WORKING SET POOL LIST       */
*         2 CONAPDBF CHAR(12),        /* ACE/ICE POOL LIST           */
*         2 CONNPDBF CHAR(12),        /* NON-WORKING SET POOL LIST   */
*         2 CONPPDBF CHAR(12),        /* PAGEABLE DATA POOL LIST     */
*         2 CONCRPLD CHAR(12),        /* CRPL POOL LIST              */
*         2 CONFLG01 CHAR (1),        /* INIT/TERM FLAGS             */
*           3 CONFTSTM BIT(1),        /* BIT TO INDICATE SET TIMER   */
*           3 CONFTTMR BIT(1),        /* BIT TO INDICATE TIMER IS
*                                        RUNNING                     */
*           3 CONFTEXS BIT(1),        /* EXITS SCHEDULED FLAG        */
*           3 CONFTNAC BIT(1),        /* NO ACTIVE CONNECTIONS FLAG  */
*           3 CONFTNSA BIT(1),        /* BIT TO INDICATE NETWORK
*                                        SOLICITOR ACTIVE            */
*           3 CONFTTA BIT(1),         /* TO INDICATE TOLTEP ACTIVE   */
*           3 CONFTPSA BIT(1),        /* BIT TO INDICATE PORT SOLICITOR
*                                        ACTIVE                      */
*           3 CONNSNEC BIT(1),        /* INDICATE NETWORK SOLICITOR
*                                         IS NECESSARY               */
*          2 CONRSV01 CHAR(3),        /* RESERVED - FOR ALIGNMENT    */
*          2 CONVTHDR CHAR(LENGTH(ISTRDT)) BDY(WORD),  /* VTAM RDT
*                                        HEADER                      */
*          2 CONVVTAM CHAR(LENGTH(ISTRAP)) BDY(WORD), /* APPLICATION
*                                         ENTRY FOR VTAM             */
*          2 CONTOLTP CHAR(LENGTH(ISTRAP)) BDY(WORD), /* APPLICATION
*                                         ENTRY FOR TOLTEP           */
*          2 CONTRACE CHAR(LENGTH(ISTRAP)) BDY(WORD), /* APPLICATION
*                                         ENTRY FOR TRACE            */
*          2 CONNTSOL CHAR(LENGTH(ISTRAP)) BDY(WORD),  /* APPLICATION
*                                         ENTRY FOR NETSOL           */
*          2 CONRECON CHAR(LENGTH(ISTRAP)) BDY(WORD), /* APPLICATION */
*                                              /* ENTRY FOR RECOVERY */
*          2 CONECDET FIXED(31),      /* ECB TO BE POSTED UPON  01S1054
*                                        SUBTASK COMPLETION          */
*          2 CONSTAFP PTR(31),        /* FOOTPRINT FOR NON-PSS STAE
*                                        RTN. FOR VTAM TASK          */
*          2 CONLIST CHAR(2),         /* TWO CHARACTER STORAGE AREA
*                                        FOR THE 'LIST=ID' OPERAND
*                                        ON A START COMMAND. SET AND
*                                        REFERENCED BY THE CONF CTL
*                                        MODULE OF INITIALIZATION
*                                        (ISTINCCC)                  */
*          2  CONRSV50 FIXED(15),      /* RESERVED PRESERVE ALIGNMENT*/
*          2  CONCSCB PTR(31),         /* PTR FOR CSCB               */
*          2  CONFNSAT CHAR(LENGTH(ISTLDPRM)),  /* ATTACH PARAMETER
*                                      LIST FOR NETWORK SOLICTOR     */
*          2  CONFTRAT CHAR(LENGTH(ISTLDPRM)),  /* ATTACH PARAMETER
*                                      LIST FOR TRACE                */
*          2  CONFLDAT CHAR(LENGTH(ISTLDPRM)),  /* ATTACH PARAMETER
*                                      LIST FOR LOAD/DUMP            */
*          2  CONFXXAT CHAR(LENGTH(ISTLDPRM)),  /* ATTACH PARAMETER
*                                         LIST FOR SYS DEF           */
*          2  CONFTTAT CHAR(LENGTH(ISTLDPRM)),  /* ATTACH PARAMETER
*                                      LIST FOR TOLTEP               */
*          2  CONRSV24 CHAR(LENGTH(ISTLDPRM)),  /* RESERVED          */
*          2  CONGLBBH FIXED(8),       /*                            */
*          2  CONRVPT1 CHAR(1),        /* RESERVED                   */
*          2  CONUNITS FIXED(15),      /* RN HOST BUFFERSIZE, LBUF
*                                         DOS/VS, IOBUF IN VS/1,2    */
*          2  CONSDECB PTR(31),        /* ECB USED TO POST ISTSDCLM
*                                         TO RUN SYS DEF IO CODE     */
*          2  CONSDMLC PTR(31),        /* PTR TO SYS DEF PARAMETER LIST
*                                         ISTMLCA                    */
*          2  CONF01SV PTR(31),        /* HOST ATTACH SAVE AREA PTR  */
*          2  CONSCPID BIT(48),        /* SSCPID                     */
*            3 CONFCNL  BIT(8),        /* FUNCTION LEVEL             */
*            3 CONFILL  BIT(8),        /* FILLER                     */
*            3 CONBLKNO BIT(12),       /* BLOCK NUMBER               */
*            3 CONSTAID BIT(20),       /* STATION ID                 */
*              4 CONSTFIL BIT(4),      /* STATION ID FILLER          */
*              4 CONSTVAR BIT(16),     /* VARIABLE PORTION OF ID     */
*          2  CONUESBF CHAR(12);       /* UECB LIST                  */
*/* LOGICAL CHANNEL COMMAND WORD                                      *
*/* ADD A DECLARE                                      003 10/18/74   *
*DCL  1  ISTLCCW BDY(WORD) BASED,                               01S1055
*        2  LCCWOP    CHAR(1),         /* OPERATION CODE -CONTROL     *
*           3  LCCWSI BIT(1),          /* SESS INIT / START DIALOG FLG*
*           3  LCCWSD BIT(1),          /* SESS DISCON/END DIALOG FLG  *
*           3  LCCWRWOP BIT(6),        /* READ/WRITE OPERATION CODE   *
*              4  * BIT(1),            /* RESERVED                    *
*              4  LCCWSOP BIT(1),      /* SPECIAL OPERATION LIKE
*                                         ERASE OR READ CONT          *
*              4  LCCWCTL BIT(4),      /* CONTROL TYPE                *
*                 5  LCCWMODE BIT(2),  /* MODE TYPE                   *
*                 5  LCCWTYPE BIT(2),  /* OPERATION TYPE              *
*        2  LCCWFLAG  CHAR(1),         /* FLAG BYTE                   *
*           3  LCCWCD BIT(1),          /* CHAIN DATA                  *
*           3  LCCWCC BIT(1),          /* CHAIN COMMAND               *
*           3  LCCWCKPT BIT(1),        /* SUPPRESS 3705 CHECK POINT
*                                         RECORD                      *
*           3  LCCWNTVC BIT(1),        /* DO NOT PERFORM VALCHEK      *
*           3  LCCWIDAT BIT(1),        /* LCCWDATA CONTAINS DATA      *
*           3  LCCWLSI BIT(1),         /* LCCW SYNCH INDICATOR        *
*              4  LCCWPER BIT(1),      /* POST=RESP                   *
*           3  LCCWRFI BIT(1),         /* REQUEST FEEDBACK INDICATOR  *
*           3  LCCWACI BIT(1),         /* ADDITION COMMAND INDICATOR  *
*        2  LCCWCNT FIXED(16),         /* DATA COUNT                  *
*        2  LCCWDATA PTR(31);          /* DATA ADDRESS OR IMMED. DATA *
*/* LOGICAL COMMAND CODES */                                    01S1056
*DCL  LXDQ     BIT(8) CONSTANT('3B'X), /* RESET DEVICE QUEUE          *
*     LXEC     BIT(8) CONSTANT('4B'X), /* RESET AT END OF COMMAND     *
*     LXO      BIT(8) CONSTANT('5B'X), /* RESET ORDERLY               *
*     LCCWPRGE BIT(8) CONSTANT('6B'X), /* PURGE                       *
*     LWH      BIT(8) CONSTANT('0F'X), /* WRITE HEADER INDI. 1ST BLOCK*
*     LWRVI    BIT(8) CONSTANT('1F'X), /* WRITE RVI                   *
*     LWNA     BIT(8) CONSTANT('2F'X), /* WRITE NEGATIVE ACK          *
*     LWAA     BIT(8) CONSTANT('3F'X), /* WRITE ALTERNATE ACK         *
*     LWPLG    BIT(8) CONSTANT('5F'X), /* WRITE ACK LEADING GRAPHICS  *
*     LWNLG    BIT(8) CONSTANT('6F'X), /* WRITE NACK LEADING GRAPHICS *
*     LSMDE    BIT(8) CONSTANT('4F'X), /* SET MODE                    *
*     LIFBM    BIT(8) CONSTANT('7F'X), /* INDIC 1ST BLOCK OF MESSAGE  *
*     LTEST    BIT(8) CONSTANT('FE'X), /* TEST LCCW                   *
*     LPRMPT   BIT(8) CONSTANT('13'X), /* PREEMPT LCCW                *
*     LRSTR    BIT(8) CONSTANT('43'X), /* RESTORE LCCW                *
*     LEXEC    BIT(8) CONSTANT('FF'X), /* SPECIAL CONTROL OPERATION   *
*     LREAD    BIT(2) CONSTANT('10'B),  /* READ TYPE LCCW             *
*     LWRITE   BIT(2) CONSTANT('01'B),  /* WRITE TYPE LCCW            *
*     LCNTRL   BIT(2) CONSTANT('11'B),  /* CONTROL TYPE LCCW          *
*     LRESET   BIT(4) CONSTANT('1011'B),/* RESET COMMANDS             *
*     LTIC     BIT(8) CONSTANT('08'X),  /* LOGICAL TIC                *
*     LWR      BIT(6) CONSTANT('000001'B),  /* WRITE CONVERSATIONAL   *
*     LWB      BIT(6) CONSTANT('000101'B),  /* WRITE BLOCK            *
*     LWM      BIT(6) CONSTANT('001001'B),  /* WRITE MESSAGE          *
*     LWT      BIT(6) CONSTANT('001101'B),  /* WRITE TRANSMISSION     *
*     LEWM     BIT(6) CONSTANT('011001'B),  /* ERASE/WRITE MESSAGE    *
*     LEWT     BIT(6) CONSTANT('011101'B),  /* ERASE/WRITE TRNSMSSN   *
*     LEAU     BIT(6) CONSTANT('010001'B),  /* ERASE ALL UNPROTECTED  *
*     LRB      BIT(6) CONSTANT('000110'B),  /* READ BLOCK             *
*     LRM      BIT(6) CONSTANT('001010'B),  /* READ MESSAGE           *
*     LRT      BIT(6) CONSTANT('001110'B),  /* READ TRANSMISSION      *
*     LRMOD    BIT(6) CONSTANT('010010'B),  /* READ MODIFIED          *
*     LRBUF    BIT(6) CONSTANT('010110'B),  /* READ BUFFER            *
*     LRCONT   BIT(6) CONSTANT('011010'B),  /* READ CONTINUOUS        *
*     LRPEP    BIT(6) CONSTANT('011110'B),  /* READ PERPETUAL         *
*     LCPYM    BIT(6) CONSTANT('101001'B),  /* COPY MESSAGE           *
*     LCPYT    BIT(6) CONSTANT('101101'B),  /* COPY TRANSMISSION      *
*     LD       BIT(8) CONSTANT('23'X),  /* DISCONNECT                 *
*     LDEC     BIT(8) CONSTANT('33'X),  /* DISCONNECT WITH END OF CALL*
*     LEOC     BIT(8) CONSTANT('53'X),  /* END OF CALL COMMAND        *
*     LXEL     BIT(8) CONSTANT('0B'X),  /* RESET ERROR LOCK           *
*     LXC      BIT(8) CONSTANT('1B'X),  /* RESET CONDITIONAL          *
*     LXI      BIT(8) CONSTANT('2B'X),  /* RESET IMMEDIATE            *
*     LC       BIT(8) CONSTANT('03'X),  /* CONTACT                    *
*     LWPA     BIT(8) CONSTANT('FD'X); /* WRITE POSITIVE ACK          *
*DCL  LMT      BIT(2) CONSTANT('11'B), /* TRANSMISSION MODE           *
*     LMS      BIT(2) CONSTANT('00'B), /* SPECIAL MODE LIKE CONV, EAU *
*     LMB      BIT(2) CONSTANT('01'B), /* BLOCK MODE                  *
*     LMM      BIT(2) CONSTANT('10'B); /* MSG OR CONTINUOUS MODE      *
*/* FOLLOWING EQUATES FOR  - PORT SOLICITOR (DIAL)                    *
*/* PORT SOLICITOR COMMAND CODES                                      *
*DCL PSOL    BIT(8) CONSTANT('FE'X), /* SPECIAL PORT SOLICITOR  01S1058
*                                       COMMAND                       *
*    STCTL    BIT(8) CONSTANT('01'X), /* START CONTROL                *
*    RESTCTL  BIT(8) CONSTANT('02'X), /* RESET & CONTROL - REDRIVE    *
*    STIPUT   BIT(8) CONSTANT('03'X); /* START INPUT                  *
*/*   FOLLOWING EQUATES FOR SDLC SUPPORT                              *
*DCL  LCCHOLD  BIT(8) CONSTANT('01'X),  /* HOLD                       *
*     LCCRHOLD BIT(8) CONSTANT('02'X),  /* RELEASE HOLD               *
*     LSEND    BIT(8) CONSTANT ('F1'X), /* SEND                       *
*     LCLEAR   BIT(8) CONSTANT ('F2'X), /* CLEAR                      *
*     LCRUD    BIT(8) CONSTANT ('F3'X), /* CLEAR, UNBIND              *
*     LCRUDNFY BIT(8) CONSTANT ('F4'X), /* CLEAR, UNBIND, NOTIFY      *
*     LNFY     BIT(8) CONSTANT ('F5'X), /* NOTIFY                     *
*     LRELCB   BIT(8) CONSTANT ('F6'X), /* RELEASE CB                 *
*     LRESTSR  BIT(8) CONSTANT ('F7'X), /* RESETSR                    *
*     LCLRNFY  BIT(8) CONSTANT('F8'X),  /* CLEAR/NOTIFY               *
*     LCHPUR   BIT(8) CONSTANT('F9'X);  /* PURGE                      *
*DCL  LCCWSIZE FIXED(8) CONSTANT(8);    /* LCCW SIZE                  *
*DCL  LRDS     BIT(8) CONSTANT('FF'X);  /* RECORD DEV STATS COMMAND   *
*DCL  LQUIS    BIT(8) CONSTANT('FE'X);  /* QUIESCE COMMAND            *
*/*              LOGICAL CHANNEL PROGRAM BLOCK                       */
*/*                                                                  */
*/*  REVISIONS                                         007 05/19/75  */
*/*                                                                  */
*DCL  1  ISTLCPB BDY(WORD) BASED(LCPBPTR),                      01S1063
*        2 LCPTYPE CHAR(1),            /* TYPE CODE                  */
*        2 LCPLNGTH  PTR(8),           /* LENGTH IN BYTES            */
*        2 LCPREQTG CHAR(2),           /* LCPB REQ. TAG FIELD        */
*          3 LCPFLAGS BIT(8),          /* FLAG BYTE                  */
*            4 LCPZRT00 BIT(1),        /* LOGICAL ERROR FLAG         */
*            4 LCPZRT01 BIT(1),        /* CONTROL BLOCK ERROR        */
*            4 LCPZF001 BIT(1),        /* LCP START PROCESS FLAG     */
*              5 LCPZRT02 BIT(1),      /* I/O INITIATION DISABLED    */
*                6 LCPZRTL2 BIT(1),    /* END OF SCHEDULABLE BLOCK   */
*            4 LCPZF002 BIT(1),        /* LCP IN PROCESSING FLAG     */
*              5 LCPZRT03 BIT(1),      /* GO LOOK AT FMCB LINE STATE */
*                                      /* FIELD (REQ. TAG OVERLAY)   */
*                6 LCPZRTL3 BIT(1),    /* WRITE/READ REQUEST         */
*            4 LCPZF003 BIT(1),        /* LCP PROCESSING COMPLETE FLAG*
*              5 LCPZRT04 BIT(1),      /* STPR SET IN BDU FLAG       */
*                                      /* (REQ. TAG OVERLAY)         */
*                6 LCPZRTL4 BIT(1),    /* FEEDBACK REQUESTED         */
*            4 LCPZF004 BIT(1),        /* SINGLE LCCW/LCP FLAG       */
*              5 LCPZRT05 BIT(1),      /* FEEDBACK TO BE ROUTED TO   */
*                                      /* ICNCB FMCB (REQ. TAG       */
*                                      /* OVERLAY)                   */
*                6 LCPZRTL5 BIT(1),    /* DECREMENT SCHED COUNT ON DEQ*
*            4 LCPZRT06 BIT(1),        /* CRITICAL TEXT BLOCK        */
*                                      /* FLAG (REQ. TAG OVERLAY)    */
*              5 LCPZRTL6 BIT(1),      /* WRITE REQUEST              */
*            4 LCPZRT07 BIT(1),        /* BUFFER TRACE ACTIVE        */
*                                      /* FLAG (REQ. TAG OVERLAY)    */
*              5 LCPZRTL7 BIT(1),      /* SCHEDULING FLAG            */
*          3 LCPMNRCD CHAR(1),         /* LCP MINOR REJECTION CODE   */
*            4 LCPZRT08 BIT(1),        /* I/O TRACE ACTIVE FLAG      */
*                                      /* (REQ. TAG OVERLAY)         */
*              5 LCPZRTL8 BIT(1),      /* DEVICE END NOTIFICATION    */
*            4 LCPZRT09 BIT(1),        /* DIALOGUE SCHED DISABLED    */
*              5 LCPZRTL9 BIT(1),      /* CRITICAL TEXT FLAG         */
*            4 LCPZRT0A BIT(1),        /* SIMULATED CONTACT FLAG     */
*            4 LCPZRT0B BIT(1),        /* SIMULATED DISCONNECT FLAG  */
*        2 LCPCHAIN PTR(31),           /* APS CHAIN                  */
*          3 LCPCHAI1 PTR(8),                                   01S1063
*            4 LCPCHNG BIT(1),         /* GATE BIT                   */
*          3 LCPCHAI2 PTR(24),         /* ADDRESS FIELD              */
*        2 LCPRUCNT PTR(8),            /* NUMBER OF RU FOR THIS LCPB */
*          3 LCPZMIRC CHAR(1),         /* MINOR RETURN CODE          */
*        2 LCPFLAG2 CHAR(1),           /* SECOND FLAG BYTE           */
*          3 LCPPRFLG BIT(1),          /* PACING REQUIRED            */
*          3 LCPASYN  BIT(1),          /* ASYNCHRONOUS LCPB          */
*          3 LCPRSTRT BIT(1),          /* RESTART LCPB               */
*          3 LCPTLBPI BIT(1),          /* TPIOS BLOCK LCCW           */
*            4 LCPZRIMM BIT(1),        /* RESET IMMED REQUIRED ON ERR*/
*          3 LCPFID0  BIT(1),          /* FID0 TH INDICATOR FOR RECORD*
*            4 LCPEXRES BIT(1),        /* EXCEP. RESPONSE SPEC. 3270R*/
*          3 LCPDSTAT BIT(1),          /* DIALOGUE STATE BIT, 3270R  */
*                                      /* 0=REQ. REJECT,1=STATE ERROR*/
*          3 LCPFREE  BIT(1),          /* DEALLOCATE LCPB 3270R      */
*          3 LCPATOP  BIT(1),          /* ATOP LCPB  3270R           */
*        2 LCPSEQ   FIXED(16),         /* OUTBOUND SEQUENCE NUMBER   */
*          3 LCPRRCCT PTR(8),          /* COUNT OF RESPONSES RECEIVED*/
*          3 LCPRRCNT PTR(8),          /* COUNT OF RESPONSES REQUESTED*
*        2 LCPLCCW1 PTR(31),           /* ADDR FIRST LCCW FOR FID1   */
*        2 LCPCID CHAR(4) BDY(WORD),   /* COMMUNICATION ID           */
*          3 LCPSAF BIT(16),           /* SOURCE IDENTIFICATION      */
*          3 LCPDAF BIT(16),           /* DESTINATION IDENTIFICATION */
*        2 LCPNXLCW PTR(31),           /* ADDR NEXT LCCW             */
*        2 LCPFDBA PTR(31),            /* BTU ADDRESS                */
*          3 LCPFDB1 PTR(8),                                    01S1063
*          3 LCPFDB2 PTR(24),          /* ADDRESS FIELD              */
*        2 LCPTLBAD PTR(31),           /* ADDRESS OF TLB             */
*        2 LCPFOSN  BIT(16),           /* SEQUENCE NUMBER FIRST RU   */
*        2 LCPFSNCH FIXED(16),         /* 1ST SEQ NUMBER IN RU CHAIN */
*        2 LCPSTYPE FIXED(8),          /* LCPB SUB-TYPE X'FF' = RESET,*
*                                      /* X'00' = NON-RESET          */
*        2 LCPFLG1 CHAR(1),            /* FLAGS                      */
*          3 LCPRESET BIT(1),          /* A TPQUE WITH RESET QUEUED  */
*                                      /* THIS ELEMENT               */
*          3 LCPINTER BIT(1),          /* INTERNAL LCPB              */
*          3 LCPDIRPT BIT(1),          /* NOT SEND W/POST=SCHED=0    */
*          3 LCPREDRV BIT(1),          /* LCPB IS FOR REDRIVE        */
*          3 LCPSTLB  BIT(1),          /* TLB NOT TO BE FREED        */
*          3 LCPTRANS BIT(1),          /* DATA INCLUDES CONTROL CHARS*/
*          3 LCPRSV78 BIT(2),          /* RESERVED                   */
*        2 LCPLCCWC BIT(8),            /* COUNT OF LCCWS             */
*        2 LCPRSV77 CHAR(1),           /* RESERVED                   */
*        2 LCPFLCCW PTR(31),           /* ADDR OF FIRST LCCW         */
*          3 LCPUBFSB PTR(31),         /* UNBIND FSB ADDRESS         */
*        2 LCPCLREP PTR(31),           /* PTR TO CLEAR LCPB IN UCB   */
*/*  NOTE:  THE FOLLOWING FIELD - LCPLCCW MUST BE THE LAST FIELD     */
*/*         IN THIS CONTROL BLOCK.  THE CONTROL BLOCK ISTDCLCP HAS   */
*/*         FIELDS IN IT WHICH MUST BE CONTIGUOUS WITH LCPLCCW       */
*        2 LCPLCCW  CHAR(LENGTH(ISTLCCW)) BDY(WORD), /* FIRST LCCW   */
*          3 LCPRSTQH PTR(31),         /* RESET LCPB QUEUE HEADER    */
*          3 LCPPABA  PTR(31),         /* PAB POINTER                */
*            4 LCPRPHA  PTR(31),       /* RPH POINTER                */
*              5 LCPFTYPE BIT(1);      /* FEEDBACK TYPE              */
*/*     CONSTANTS FOR LCPTYPE                                         *
*DCL  LCRPHFT  BIT(1) CONSTANT('1'B);                           01S1064
*DCL  LCPABFT  BIT(1) CONSTANT('0'B);                           01S1065
*DCL LCPBFIRM BIT(8) CONSTANT('10'X);  /* LU FAILED, CLSDST, SCHED LOST
*                                         TERM, OPNDST MAY BE TRIED   *
*DCL LCPBTERM BIT(8) CONSTANT('11'X);  /* TERM RECEIVED,CLSDST, 01S1067
*                                         SCHED LOST TERM             *
*/*                                                                   *
*                                                               01S1068
*DCL 1 LCPZTIE BDY(WORD) DEFINED(LCPCID), /* TOLTEP INTERFACE   01S1068
*                                         ELEMENT OVERLAY            */
*       2  LCPZFMCA PTR(31),           /* ACTIVE FMCB ADDRESS        */
*       2  LCPZSNA PTR(31),            /* SYMBOLIC NAME ADDRESS      */
*       2  LCPZSNAM CHAR(8) BDY(WORD), /* SYMBOLIC NAME              */
*          3  LCPZTRV1 PTR(31),        /* RESERVED FOR RESTORE LCP   */
*          3  LCPZTRV4 PTR(31);        /* RESERVED FOR RESTORE LCP   */
*DCL LCTYPE BIT(8) CONSTANT('04'X);                             01S1069
*DCL PLCPTYPE BIT(8) CONSTANT('28'X);  /* PURGE LCPB TYPE ID         */
*DCL LCPCLACB BIT(8) CONSTANT('04'X);  /* LCPB FROM CLOSE ACB        */
*DCL LSRSTYPE BIT(8) CONSTANT('FF'X);  /* RESET SUBTYPE              */
*DCL LCPETYPE BIT(8) CONSTANT('40'X);  /* EXTENDED LCPB TYPE ID      */
*/*                                                                  */
*/*  MINOR RETURN CODES                                              */
*/*                                                                  */
*DCL LCMCRSTR BIT(8) CONSTANT('F7'X),  /* MINOR RC FOR RESETSR       */
*    LCPMNEW  BIT(8) CONSTANT('02'X),  /* EARLY WARNING,             */
*                                      /* RECOVERY IN PROGRESS       */
*    LCPMNPF  BIT(8) CONSTANT('03'X),  /* PERM. I/O FAILURE          */
*    LCPMNAS  BIT(8) CONSTANT('04'X),  /* AUTO NETWORK SHUTDOWN      */
*    LCPMNCL  BIT(8) CONSTANT('06'X),  /* CLOSE/CLSDST OCCURED       */
*    LCPMNVD  BIT(8) CONSTANT('07'X),  /* VARY DEACTIVATE            */
*    LCPMNTF  BIT(8) CONSTANT('10'X),  /* TEMP RECORD DEVICE FAILURE */
*    LCPMNSF  BIT(8) CONSTANT('01'X),  /* TEMP BASIC FAILURE /       */
*    LCPMNTS  BIT(8) CONSTANT('11'X),  /* TERMINATE SELF             */
*    LCPMNAP  BIT(8) CONSTANT('0A'X),  /* APPL. ISSUED CLEAR         */
*    LCPMNPR  BIT(8) CONSTANT('0B'X),  /* PREEMPT                    */
*    LCPMNRE  BIT(8) CONSTANT('0C'X);  /* RESTORE                    */
*/* VS1, VS2 TPIOS SAVEAREA FORMAT */                           01S1075
*DCL  1  ISTZSAVE BDY(WORD) BASED,                              01S1075
*        2   ZSAZSVBC PTR(31),         /* SAVEAREA BACK CHAIN        */
*            3   ZSAZSVMS CHAR(1),     /* MODULE TRACE CODE          */
*                4 ZSAZACTV BIT(1),    /* ACTIVE SAVE AREA FLAG      */
*        2   ZSAZSVFC PTR(31),         /* SAVEAREA FORWARD CHAIN     */
*        2   ZSAZSVRR PTR(31),         /* RETURN REGISTER            */
*        2   ZSAZSVVR (6) PTR(31),    /* VARIABLE REGS (7-12) SVEAREA*/
*        2   ZSAZTRAC CHAR(4);        /* EBCDIC NAME OF OWNER        */
*/*                                                             01S1076
*THE FOLLOWING EQUATES SHOULD READ ''FIXED(8) CONSTANT(LENGTH(X))'',
*WHERE X IS THE NAME OF THE VARIABLE CONTROL BLOCK OR FIELD OF WHICH
*LENGTH IS THE VALUE BEING EQUATED, SHOULD THE PLS COMPILER BE  01S1076
*BE ABLE TO TAKE IT.                                            01S1076
*                                                                    */
*DCL ZSAZSVVA FIXED(8) CONSTANT(8);  /* DISPLACEMENT TO VARIABLE REGS*/
*DCL ZSAZSVSZ FIXED(8) CONSTANT(40); /* LENGTH OF ISTZSAVE           */
*/* PREFIX FOR CRR                                                   */
*/*                                                                  */
*/* RELEASE 1 - JUNE 28, 1973                                        */
*/*                                                                  */
*DCL 1 ISTPFCRR BASED BDY(WORD),        /* PREFIX FOR CRR            */
*     2  PFCCRR   CHAR(4),              /* CRR HEADER                */
*        3  PFCCRRID CHAR(1),           /* CRR ID FIELD              */
*           4  CRRID CHAR(1),           /* BASIC CTL LAYER DEFINITION*/
*        3  PFCRSV10 CHAR(1),           /* RESERVED FOR ALIGNMENT    */
*        3  PFCCRRLN CHAR(2),           /* CRR LENGTH                */
*           4  CRRLEN CHAR(2),          /* BASIC CTL LAYER DEF       */
*     2  PFCHDR CHAR(8) BDY(WORD),      /* SAVE AREA FOR OLD CRR FRR */
*        3  PFCCRRO  PTR(31),           /* PTR TO OLD CRR            */
*           4  CRRCHAIN PTR(31),        /* BASIC CTL LAYER DEFINITION
*                                          FOR OLD CRR PTR           */
*        3  PFCFRRO  PTR(31),           /* PTR TO OLD FRR            */
*           4  CRRFRR   PTR(31),        /* BASIC CTL LAYER      01S1078
*                                          DEFINITION OF OLD FRR PTR */
*     2  PFCFTA BIT(8),                 /* ID OF LAST FUNCTION TRACED*/
*     2  PFCRSV01 CHAR(3);              /* ALIGNMENT                 */
*DCL PFIDPIE BIT(8) CONSTANT('80'X);    /* DOS/VS TPIOS              */
*DCL PFIDORE BIT(8) CONSTANT('81'X);    /* DOS/VS BMS                */
*DCL PFIDAPE BIT(8) CONSTANT('82'X);    /* DOS/VS PSS                */
*DCL PFCIDPSV BIT(8) CONSTANT('38'X); /* COMPONENT ID           01S1082
*                                          PSS - VS1 AND 2           */
*DCL PFCIDTPV BIT(8) CONSTANT('3C'X); /* COMPONENT ID           01S1083
*                                          TPIOS VS1 AND 2           */
*DCL PFCIDSME BIT(8) CONSTANT('3D'X); /* COMPONENT ID           01S1084
*                                          STORAGE MANAGEMENT DOS    */
*DCL PFCIDOC BIT(8) CONSTANT('31'X);    /* COMPONENT ID OPEN/CLOSE   */
*DCL PFCIDPS BIT(8) CONSTANT('32'X);    /* PORT SOLICITOR            */
*DCL PFCIDCS BIT(8) CONSTANT('34'X);    /* CLUSTER SOLICITOR         */
*DCL PFCIDIT BIT(8) CONSTANT('35'X);    /* INIT/TERM                 */
*DCL PFCIDVY BIT(8) CONSTANT('36'X);    /* VARY                      */
*DCL PFCIDNS  BIT(8) CONSTANT('37'X);   /* NET. STAT.SRV.            */
*DCL PFCIDTPE BIT(8) CONSTANT('38'X);   /* COMPONENT ID         01S1091
*                                          TPIOS - DOS               */
*DCL PFCIDCL BIT(8) CONSTANT('39'X);    /* COMPONENT ID         01S1092
*                                          CONTROL LAYER             */
*DCL PFCIDPSE BIT(8) CONSTANT('3A'X);   /* COMPONENT ID         01S1093
*                                          PSS - DOS                 */
*DCL PFCIDSMV BIT(8) CONSTANT('3F'X);   /* COMPONENT ID         01S1094
*                                          STORAGE MANAGEMENT        */
*DCL PFCIDTIO BIT(8) CONSTANT('40'X);   /* COMPONENT ID TIIO    01S1095
*                                          PROCESSING (VS2)          */
*DCL PFCIDRS  BIT(8) CONSTANT('41'X);   /* ID FOR REMOTE SOLICITOR   */
*/* CRR FOR COMMAND FACILITIES                                      */
*/*  REVISIONS                                         001 06/02/75 */
*DCL  1  ISTCFCRR BDY(WORD) BASED, /* CRR FOR COMMAND FACILITIES    */
*        2 CFCAUDIT,               /* AUDIT TRAIL FOR CMD FACILITIES*/
*          3 CFCNTRD  CHAR(1),     /* LIST OF MODULES IN COMMAND    */
*                                  /* FACILITIES ENTERED            */
*            4 NCFCS1   BIT(1),    /* IND MODULE ISTCFCS1 ENTERED   */
*            4 NCFCS2   BIT(1),    /* IND MODULE ISTCFCS2 ENTERED   */
*            4 NCFCR1   BIT(1),    /* IND MODULE ISTCFCR1 ENTERED   */
*            4 NCFCRP   BIT(1),    /* IND MODULE ISTCFCRP ENTERED   */
*            4 NCFCR2   BIT(1),    /* IND MODULE ISTCFCR2 ENTERED   */
*            4 NCFRSVD  BIT(3),    /* RESERVED                      */
*          3 CFCCRT   CHAR(1),     /* LIST OF MODULES IN COMMAND    */
*                                  /* FACILITIES RUNNING            */
*            4 CCFCS1   BIT(1),    /* IND MODULE ISTCFCS1 RUNNING   */
*            4 CCFCS2   BIT(1),    /* IND MODULE ISTCFCS2 RUNNING   */
*            4 CCFCR1   BIT(1),    /* IND MODULE ISTCFCR1 RUNNING   */
*            4 CCFCRP   BIT(1),    /* IND MODULE ISTCFCRP RUNNING   */
*            4 CCFCR2   BIT(1),    /* IND MODULE ISTCFCR2 RUNNING   */
*            4 CCFRSVD1 BIT(3);    /* RESERVED                      */
*DCL TIDCFCS1 BIT(8) CONSTANT('00'X); /* THREAD ID FOR ISTCFCS1     */
*DCL TIDCFCR1 BIT(8) CONSTANT('01'X); /* THREAD ID FOR ISTCFCR1     */
*DCL TIDCFCR2 BIT(8) CONSTANT('02'X); /* THREAD ID FOR ISTCFCR2     */
*/* COMPONENT RECOVERY RECORD FOR TPIOS */                      01S1101
*/*  DELTA                                             006 02/10/75  */
*DCL                                                            01S1101
*1  ISTZCRR BDY(WORD) BASED,     /* CONTROL WORD                     */
*   2  ZCRCRR CHAR(4),           /* CONTROL WORD                     */
*      3  ZCRID CHAR(1),         /* CONTROL BLOCK ID                 */
*      3  ZCRLEN CHAR(2),        /* LENGTH OF ZCR                    */
*      3  ZCRFLAG CHAR(1),       /* FLAGS                            */
*   2  ZCRCHAIN PTR(31),         /* POINTER TO PREVIOUS ZCR          */
*   2  ZCRFRRA PTR(31),          /* PTR TO FRR                       */
*   2  ZCRFLGS1 CHAR(1),         /* FLGS USED BY REQUEST COMPLETION  */
*      3  ZCREXSW BIT(1),        /* EXIT SWITCH                      */
*      3  ZCRQUESW BIT(1),       /* QUEUE SWITCH                     */
*      3  ZCRDEQSW BIT(1),       /* DEQUEUE SWITCH                   */
*      3  ZCRWAIT BIT(1),        /* WAIT Q ANALYSIS COMPLETE         */
*      3  ZCRNRMEX BIT(1),       /* NORMAL EXIT TO BE TAKEN          */
*      3  ZCRENDLP BIT(1),       /* END OF LOOP SWITCH               */
*      3  ZCRUNSOL BIT(1),       /* UNSOLICITED DATA                 */
*      3  ZCRFEXIT BIT(1),       /* FORCE EXIT SWITCH                */
*   2  ZCRFLGS2 CHAR(1),         /* FLAGS USED WITHIN TPIOS          */
*      3  ZCRLOCAL BIT(1),       /* LOCAL SUPPORT                    */
*      3  ZCRSHEDI BIT(1),       /* IMMEDIATE SCHEDULE               */
*      3  ZCRFMSED BIT(1),       /* FMCB SEARCH ENDED                */
*      3  ZCROB    BIT(1),       /* OUTBOUND PROC IN PROGRESS        */
*      3  ZCRIF0E1 BIT(1),       /* SWITCH FOR STRUCTURED PGM USED BY
*                                   INBOUND PROCESSING               */
*      3  ZCRIF0E2 BIT(1),       /* SWITCH FOR STRUCTURED PGM USED BY
*                                   INBOUND PROCESSING               */
*      3  ZCRIF0E3 BIT(1),       /* SWITCH FOR STRUCTURED PGM USED BY
*                                   INBOUND PROCESSING               */
*   2  ZCRSWFLD CHAR(1),         /* SWITCHES FOR TPIOS OUTBOUND      */
*      3  ZCRENDSH BIT(1),       /* EXIT FROM REMOTE DEV SCHEDULER   */
*         4  ZCRSLCP BIT(1),     /* SCHEDULE LCPB                    */
*      3  ZCREXTYP BIT(1),       /* TPEXIT TYPE                      */
*      3  ZCRENDPR BIT(1),       /* EXIT FROM INNER PROCESS          */
*      3  ZCRNDLCP BIT(1),       /* EXIT FROM LCPB PROCESSING        */
*         4  ZCROB1 BIT(1),      /* REMOTE DEV SCHED 1ST TIME SWITCH */
*      3  ZCRENDX BIT(1),        /* EXIT FROM LCCW/BTU XLATION       */
*      3  ZCRENDXL BIT(1),       /* EXIT FROM LCCW PROC              */
*      3  ZCRENDAN BIT(1),       /* EXIT FROM LCPB ANALYSIS          */
*      3  ZCRRESET BIT(1),                                      01S1101
*         4  ZCRCNLXL BIT(1),    /* CANCEL FURTHER XLATE             */
*   2  ZCRFLGS3 CHAR(1),         /* FLAGS FOR OUTBOUND PROCESSING    */
*      3  ZCRTIC BIT(1),         /* SELECT NOT TO BE SENT            */
*      3  ZCRTPCON BIT(1),       /* TPIOS CONTACT SENT               */
*      3  ZCRTPDIS BIT(1),       /* TPIOS DISCONNECT TO BE SENT      */
*      3  ZCRDISC  BIT(1),       /* DISCONNECT IN PROCESS            */
*      3  ZCREDRIV BIT(1),       /* DO DERIVE                        */
*      3  ZCRNOFRE BIT(1),       /* NO FREEING OF SIO QUEUE          */
*      3  ZCRWRPTR BIT(1),       /* WRITE TO PRINTER REQUEST         */
*      3  ZCRINLCP BIT(1),       /* ERROR OCCURED DURING OUTBND PROC */
*   2  ZCRGENSW CHAR(1),         /* GENERAL SWITCHES                 */
*      3  ZCRTSW1  BIT(1),       /* TEMP SW FOR STRUCTURED PGM       */
*      3  ZCRTSW2  BIT(1),       /* TEMP SW FOR STRUCTURED PGM       */
*      3  ZCRRT06  BIT(1),       /* CRITICAL TEXT OPTION             */
*      3  ZCRLCSYN BIT(1),       /* LCCW SYNC SPECIFIED              */
*      3  ZCREXRES BIT(1),       /* EXCEPTION RESPONSE SPECIFIED     */
*      3  ZCRCLRBD BIT(1),       /* FLAG INDICATING BIND WAS CLEARED */
*      3  ZCRBRIS  BIT(1),       /* BRACKET REJECTED DUE TO IN BRAC. */
*      3  ZCRF1RES BIT(1),       /* FID1 RESPONSE TO BE GENERATED    */
*   2  ZCRPFLGS CHAR(1),         /* UTILITIES PROC OPTION FLAGS      */
*      3  ZCRQAHED BIT(1),      /* QXFR RTN TO USE INSERT OPT'N ON TPQ*
*      3  *        BIT(7),      /* RESERVED                          */
*   2  ZCRIBPR CHAR(1),          /* INBOUND PROCESSING FLAGS         */
*         3  ZCRNOBUF BIT(1),    /* FSB WITH NO BUFFER               */
*         3  ZCRERR   BIT(1),    /* ERROR INDICATOR                  */
*         3  ZCRRELK  BIT(1),    /* RESET ERROR LOCK FUNCTION REQ.   */
*         3  ZCRLCPFR BIT(1),    /* FLAG IND. DEALLOCATE ATOP LCPB   */
*         3  ZCRLCPFD BIT(1),    /* FLAG IND. LCPB FOUND ON WAITQ    */
*         3  ZCR3270  BIT(1),    /* 3270 DEVICE                      */
*         3  ZCR3270R BIT(1),    /* 3270 DEVICE IN RECORD MODE       */
*         3  *        BIT(1),    /* RESERVED                         */
*   2  ZCRSCPSW CHAR(1),         /* SESSION CONTROL FLAGS            */
*         3  ZCRTPEX BIT(1),     /* TP EXIT                          */
*         3  ZCRTPINV BIT(1),    /* INVOKE TPIOS                     */
*         3  ZCRRJLCP BIT(1),    /* LCPB REJECTED                    */
*         3  ZCRLREQ BIT(1),     /* REQUEST                          */
*         3  ZCRPRCMP BIT(1),    /* PROCESSING COMPLETE              */
*         3  ZCRFSBWE BIT(1),    /* FSB IS WORK ELEMENT              */
*         3  ZCRSKIPT BIT(1),    /* SKIP TRACE FLAG                  */
*         3  *       BIT(1),     /* RESERVED                         */
*   2  ZCRCRLCP PTR(31),         /* CURRENT LCPB PTR                 */
*   2  ZCRPARMS BDY(WORD),       /* PARAMETERS PASSED TO UTILITIES */
*      3  ZCRFBPTR PTR(31),      /* PTR TO FROM BUFFER               */
*         4  ZCRCBPTR PTR(31),   /* PTR TO CURRENT BUFFER            */
*      3  ZCRTBPTR PTR(31),      /* PTR TO TO-OR-TRANSLATE BUFFER    */
*      3  ZCRMLNG FIXED(15),     /* LENGTH TO MOVE                   */
*      3  ZCRDFRDA FIXED(15),    /* OFFSET FROM DATA ADDR IN FROM BUF*/
*         4  ZCRDTODA FIXED(15), /* OFFSET FROM DATA ADDR XLATE BUF  */
*      3  ZCRPCOD1 CHAR(1),      /* CODE BYTE FOR ALLOC/DISALLOC     */
*         4  ZCRPPG BIT(1),      /* GET PAGEABLE BUFF                */
*         4  ZCRPLNG BIT(1),     /* LENGTH OF BUFFER SPECIFIED       */
*         4  ZCRPFSB BIT(1),     /* GET FSB                          */
*         4  ZCRPLSBF BIT(1),    /* GET LSCB AND BUFFER              */
*            5 ZCRPLSBQ BIT(1),  /* PURGE LSCB QUEUE                 */
*         4  ZCRPLSCB BIT(1),    /* GET OR RELEASE LSCB              */
*         4  ZCRPBUF BIT(1),     /* GET OR RELEASE BUFFER            */
*         4  ZCRPCFTX BIT(1),    /* CONFIDENTIAL TEXT                */
*         4  ZCRPRES BIT(1),     /* RESERVED                         */
*      3  ZCRPCOD2 CHAR(1),      /* CODE BYTE FOR MOVE               */
*         4  ZCRPPG2 BIT(1),     /* GET PAGEABLE BUFFER              */
*         4  ZCRPFHDR BIT(1),    /* FROM BUFFER FDB TO BE USED       */
*         4  ZCRPMFGF BIT(1),    /* MOVE STARTS WIHT 1ST BUFF IN BLOCK*
*         4  ZCRPRES2 BIT(5),    /* RESERVED                         */
*      3  ZCRPCHAR CHAR(1),      /* TRANSLATE & TEST SEARCH CHARACTER*/
*      3  ZCRPSW   CHAR(1),      /* SWITCH FIELD                     */
*   2  ZCRCCWA PTR(31),          /* PTR TO CURRENT CCW (CCW 1 OR 2)  */
*   2  ZCRBFPTR PTR(31),         /* SAVE 1ST BUFF PTR IN TO-BUFF CHN
*                                   OR LAST BUFFER IN CHANNEL PGM    */
*   2  ZCRZLB PTR(31),           /* PTR TO CURR BUFF IN CHANNEL PGM  */
*   2  ZCRPVZB PTR(31),          /* PTR TO PREVIOUS BUFF IN CHAN PGM */
*   2  ZCRSVRTN BDY(WORD),       /* REG 14 SAVE AREAS                */
*      3  ZCRSVF1 PTR(31),       /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF2 PTR(31),       /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF3 PTR(31),       /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF4 PTR(31),       /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF5 PTR(31),       /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF6 PTR(31),       /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF7 PTR(31),       /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF8 PTR(31),       /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF9 PTR(31),       /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF10 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF11 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF12 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF13 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF14 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF15 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF16 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF17 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF18 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF19 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF20 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF21 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF22 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF23 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF24 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF25 PTR(31),      /* SAVE REQUIRED REGISTER           */
*   2  ZCRWKARA BDY(WORD),       /* TEMPORARY REG SAVE AREA          */
*      3  ZCRSVWK1 PTR(31),      /* SAVE REQUIRED REG                */
*      3  ZCRSVWK2 PTR(31),      /* SAVE REQUIRED REG                */
*      3  ZCRSVWK3 PTR(31),      /* SAVE REQUIRED REG                */
*      3  ZCRSVWK4 PTR(31),      /* SAVE REQUIRED REG                */
*      3  ZCRSVWK5 PTR(31),      /* SAVE REQUIRED REG                */
*   2  ZCRFSBSV PTR(31),         /* FSB CHAIN PTR SAVEAREA           */
*   2  ZCRFBPRC BIT(1),          /* FSB PROCESS SW                   */
*   2  ZCRMOREL BIT(1),          /* MORE ELEMENTS SW                 */
*   2  ZCRSCANQ BIT(1),          /* SCAN QUEUE SW                    */
*   2  ZCRNXTEL BIT(1),          /* NEXT ELEMENT SW                  */
*   2  ZCRXSCHD BIT(1),          /* EXIT SCHEDULE SW                 */
*   2  ZCRLSTFB BIT(1),          /* INBOUND PROC LAST FSB FOR ELEM SW*/
*   2  ZCRTOPQ  BIT(1),          /* QUEUE ELEMENT TO TOP SW          */
*   2  ZCRAWQSW BIT(1),          /* CHECK AWAITQ FOR MORE WORK =1    */
*                                /* CHECK WAITQ =0                   */
*   2  ZCRRCDSV CHAR(1),         /* RETURN CODE SAVEAREA             */
*   2  ZCRPRMTC CHAR(1),         /* PREEMPT COMPLETION PARAMETER BYTE*/
*   2  ZCROPCDE CHAR(1),         /* OP CODE TO BE TRANSFORMED         *
*   2  ZCRR2SV PTR(31),          /* ISTZBFDI REG 2 SAVE EREA         */
*   2  ZCRR13SV PTR(31),         /* ISTSBFDI REG 13 SAVE EREA        */
*   2  ZCRCIDSV BDY(WORD),       /* ISTZBFDI CID SAVE AREA           */
*      3  ZCRSAFSV CHAR(2),      /* ISTZBFDI SAF SAVE AREA           */
*      3  ZCRDAFSV CHAR(2),      /* ISTZBFDI DAF SAVE AREA           */
*   2  ZCRSAVEZ (6) BDY(WORD) CHAR(LENGTH(ISTZSAVE)),           01S1101
*                                /* SAVE/TRACE AREAS FOR TPIOS MODS  */
*   2  ZCRREMIC PTR(31),        /* POINTER TO REMOTE RN ICNCB        */
*   2  ZCRAUDIT CHAR(36),        /* TPIOS AUDIT TRAIL AREA           */
*      3  ZCRTID CHAR(1),        /* THREAD I.D.                      */
*      3  ZCRTNAME CHAR(4),      /* LAST 4 CHARS OF THREAD NAME      */
*      3  ZCRENTER BIT(248),     /* BIT ARRAY FOR MODULES ENTERED    */
*         4  ZCREAC1A BIT(1),    /* ISTZAC1A ENTERED                 */
*         4  ZCREAC0A BIT(1),    /* ISTZAC0A ENTERED                 */
*         4  ZCREAC0B BIT(1),    /* ISTZAC0B ENTERED                 */
*         4  ZCREAC1B BIT(1),    /* ISTZAC1B ENTERED                 */
*         4  ZCREBCAA BIT(1),    /* ISTZBCAA ENTERED                 */
*         4  ZCREBCAB BIT(1),    /* ISTZBCAB ENTERED                 */
*         4  ZCREBCAE BIT(1),    /* ISTZBCAE ENTERED                 */
*         4  ZCREBCAG BIT(1),    /* ISTZBCAG ENTERED                 */
*         4  ZCREBCAI BIT(1),    /* ISTZBCAI ENTERED                 */
*         4  ZCREBCAM BIT(1),    /* ISTZBCAM ENTERED                 */
*         4  ZCREBCBA BIT(1),    /* ISTZBCBA ENTERED                 */
*         4  ZCREBCBB BIT(1),    /* ISTZBCBB ENTERED                 */
*         4  ZCREBCBI BIT(1),    /* ISTZBCBI ENTERED                 */
*         4  ZCREBCCB BIT(1),    /* ISTZBCCB ENTERED                 */
*         4  ZCREBCDI BIT(1),    /* ISTZBCDI ENTERED                 */
*         4  ZCREBCEB BIT(1),    /* ISTZBCEB ENTERED                 */
*         4  ZCREBCFA BIT(1),    /* ISTZBCFA ENTERED                 */
*         4  ZCREBCFB BIT(1),    /* ISTZBCFB ENTERED                 */
*         4  ZCREBCGA BIT(1),    /* ISTZBCGA ENTERED                 */
*         4  ZCREBCGB BIT(1),    /* ISTZBCGB ENTERED                 */
*         4  ZCREBCHA BIT(1),    /* ISTZBCHA ENTERED                 */
*         4  ZCREBCHB BIT(1),    /* ISTZBCHB ENTERED                 */
*         4  ZCREBCIA BIT(1),    /* ISTZBCIA ENTERED                 */
*         4  ZCREBCIB BIT(1),    /* ISTZBCIB ENTERED                 */
*         4  ZCREBCID BIT(1),    /* ISTZBCID ENTERED                 */
*         4  ZCREBCJA BIT(1),    /* ISTZBCJA ENTERED                 */
*         4  ZCREBCJB BIT(1),    /* ISTZBCJB ENTERED                 */
*         4  ZCREBCKA BIT(1),    /* ISTZBCKA ENTERED                 */
*         4  ZCREBCKB BIT(1),    /* ISTZBCKB ENTERED                 */
*         4  ZCREBCLA BIT(1),    /* ISTZBCLA ENTERED                 */
*         4  ZCREBCLB BIT(1),    /* ISTZBCLB ENTERED                 */
*         4  ZCREBCMB BIT(1),    /* ISTZBCMB ENTERED                 */
*         4  ZCREBCND BIT(1),    /* ISTZBCND ENTERED                 */
*         4  ZCREBCNE BIT(1),    /* ISTZBCNE ENTERED                 */
*         4  ZCREBCOB BIT(1),    /* ISTZBCOB ENTERED                 */
*         4  ZCREBCPB BIT(1),    /* ISTZBCPB ENTERED                 */
*         4  ZCREBCQB BIT(1),    /* ISTZBCQB ENTERED                 */
*         4  ZCREBCRA BIT(1),    /* ISTZBCRA ENTERED                 */
*         4  ZCREBCRB BIT(1),    /* ISTZBCRB ENTERED                 */
*         4  ZCREBCSC BIT(1),    /* ISTZBCSC ENTERED                 */
*         4  ZCREBCXA BIT(1),    /* ISTZBCXA ENTERED                 */
*         4  ZCREBCX0 BIT(1),    /* ISTZBCX0 ENTERED                 */
*         4  ZCREBCY0 BIT(1),    /* ISTZBCY0 ENTERED                 */
*         4  ZCREBCZ0 BIT(1),    /* ISTZBCZ0 ENTERED                 */
*         4  ZCREBC0A BIT(1),    /* ISTZBC0A ENTERED                 */
*         4  ZCREBC0B BIT(1),    /* ISTZBC0B ENTERED                 */
*         4  ZCRECC0A BIT(1),    /* ISTZCC0A ENTERED                 */
*         4  ZCRECC0B BIT(1),    /* ISTZCC0B ENTERED                 */
*         4  ZCRECC1A BIT(1),    /* ISTZCC1A ENTERED                 */
*         4  ZCRECC1B BIT(1),    /* ISTZCC1B ENTERED                 */
*         4  ZCRECC2B BIT(1),    /* ISTZCC2B ENTERED                 */
*         4  ZCREDCA0 BIT(1),    /* ISTZDCA0 ENTERED                 */
*         4  ZCREDCB0 BIT(1),    /* ISTZDCB0 ENTERED                 */
*         4  ZCREDCC0 BIT(1),    /* ISTZDCC0 ENTERED                 */
*         4  ZCREDCD0 BIT(1),    /* ISTZDCD0 ENTERED                 */
*         4  ZCREDCE0 BIT(1),    /* ISTZDCE0 ENTERED                 */
*         4  ZCREDCF0 BIT(1),    /* ISTZDCF0 ENTERED                 */
*         4  ZCREDCH0 BIT(1),    /* ISTZDCH0 ENTERED                 */
*         4  ZCREDCI0 BIT(1),    /* ISTZDCI0 ENTERED                 */
*         4  ZCREDCJ0 BIT(1),    /* ISTZDCJ0 ENTERED                 */
*         4  ZCREDCKA BIT(1),    /* ISTZDCKA ENTERED                 */
*         4  ZCREDCKB BIT(1),    /* ISTZDCKB ENTERED                 */
*         4  ZCREDCL0 BIT(1),    /* ISTZDCL0 ENTERED                 */
*         4  ZCREDCMB BIT(1),    /* ISTZDCMB ENTERED                 */
*         4  ZCREECBA BIT(1),    /* ISTZECBA ENTERED                 */
*         4  ZCREECBB BIT(1),    /* ISTZECBB ENTERED                 */
*         4  ZCREECCA BIT(1),    /* ISTZECCA ENTERED                 */
*         4  ZCREECCB BIT(1),    /* ISTZECCB ENTERED                 */
*         4  ZCREECDA BIT(1),    /* ISTZECDA ENTERED                 */
*         4  ZCREECEA BIT(1),    /* ISTZECEA ENTERED                 */
*         4  ZCREECTA BIT(1),    /* ISTZECTA ENTERED                 */
*         4  ZCREFCEA BIT(1),    /* ISTZFCEA ENTERED                 */
*         4  ZCREFCEB BIT(1),    /* ISTZFCEB ENTERED                 */
*         4  ZCREGCAB BIT(1),    /* ISTZGCAB ENTERED                 */
*         4  ZCREGCBB BIT(1),    /* ISTZGCBB ENTERED                 */
*         4  *        BIT(1),    /* NOT USED                         */
*         4  ZCREGCDB BIT(1),    /* ISTZGCDB ENTERED                 */
*         4  ZCREGCEB BIT(1),    /* ISTZGCEB ENTERED                 */
*         4  ZCREGCLA BIT(1),    /* ISTZGCLA ENTERED                 */
*         4  ZCREGC0A BIT(1),    /* ISTZGC0A ENTERED                 */
*         4  ZCREGC0B BIT(1),    /* ISTZGC0B ENTERED                 */
*         4  ZCREHCAN BIT(1),    /* ISTZHCAN ENTERED                 */
*         4  ZCREICAA BIT(1),    /* ISTZICAA ENTERED                 */
*         4  ZCREICAB BIT(1),    /* ISTZICAB ENTERED                 */
*         4  ZCREICBB BIT(1),    /* ISTZICBB ENTERED                 */
*         4  ZCREICBI BIT(1),    /* ISTZICBI ENTERED                 */
*         4  ZCREICCB BIT(1),    /* ISTZICCB ENTERED                 */
*         4  ZCREICCI BIT(1),    /* ISTZICCI ENTERED                 */
*         4  ZCREICDB BIT(1),    /* ISTZICDB ENTERED                 */
*         4  ZCREICEB BIT(1),    /* ISTZICEB ENTERED                 */
*         4  ZCREICGB BIT(1),    /* ISTZICGB ENTERED                 */
*         4  ZCREICHB BIT(1),    /* ISTZICHB ENTERED                 */
*         4  ZCREICIB BIT(1),    /* ISTZICIB ENTERED                 */
*         4  ZCREICID BIT(1),    /* ISTZICID ENTERED                 */
*         4  ZCREICJB BIT(1),    /* ISTZICJB ENTERED                 */
*         4  ZCREICKB BIT(1),    /* ISTZICKB ENTERED                 */
*         4  ZCREICKE BIT(1),    /* ISTZICKE ENTERED                 */
*         4  ZCREICKG BIT(1),    /* ISTZICKG ENTERED                 */
*         4  ZCREICLB BIT(1),    /* ISTZICLB ENTERED                 */
*         4  ZCREICMB BIT(1),    /* ISTZICMB ENTERED                 */
*         4  ZCREICNA BIT(1),    /* ISTZICNA ENTERED                 */
*         4  ZCREICNB BIT(1),    /* ISTZICNB ENTERED                 */
*         4  ZCREICOA BIT(1),    /* ISTZICOA ENTERED                 */
*         4  ZCREICOB BIT(1),    /* ISTZICOB ENTERED                 */
*         4  ZCREICQA BIT(1),    /* ISTZICQA ENTERED                 */
*         4  ZCREICQB BIT(1),    /* ISTZICQB ENTERED                 */
*         4  ZCREICRB BIT(1),    /* ISTZICRB ENTERED                 */
*         4  ZCREICSB BIT(1),    /* ISTZICSB ENTERED                 */
*         4  ZCREICSC BIT(1),    /* ISTZICSC ENTERED                 */
*         4  ZCREICTB BIT(1),    /* ISTZICTB ENTERED                 */
*         4  ZCREICUB BIT(1),    /* ISTZICUB ENTERED                 */
*         4  ZCREICVB BIT(1),    /* ISTZICVB ENTERED                 */
*         4  ZCREICWB BIT(1),    /* ISTZICWB ENTERED                 */
*         4  ZCREICX0 BIT(1),    /* ISTZICX0 ENTERED                 */
*         4  ZCREIC0B BIT(1),    /* ISTZIC0B ENTERED                 */
*         4  ZCREIC1B BIT(1),    /* ISTZIC1B ENTERED                 */
*         4  ZCREJCAB BIT(1),    /* ISTZJCAB ENTERED                 */
*         4  ZCREJCBB BIT(1),    /* ISTZJCBB ENTERED                 */
*         4  ZCREJCCB BIT(1),    /* ISTZJCCB ENTERED                 */
*         4  ZCREJCDB BIT(1),    /* ISTZJCDB ENTERED                 */
*         4  ZCREJC0B BIT(1),    /* ISTZJC0B ENTERED                 */
*         4  ZCREKCBB BIT(1),    /* ISTZKCBB ENTERED                 */
*         4  ZCREKCBN BIT(1),    /* ISTZKCBN ENTERED                 */
*         4  ZCREKCCN BIT(1),    /* ISTZKCCN ENTERED                 */
*         4  ZCREDCWR BIT(1),    /* ISTZDCWR ENTERED                 */
*         4  ZCREDCWB BIT(1),    /* ISTZDCWB ENTERED                 */
*         4  ZCREDCXR BIT(1),    /* ISTZDCXR ENTERED                 */
*         4  ZCREBCBR BIT(1),    /* ISTZBCBR ENTERED                 */
*         4  ZCREBCDR BIT(1),    /* ISTZBCDR ENTERED                 */
*         4  ZCREBCAR BIT(1),    /* ISTZBCAR ENTERED                 */
*         4  ZCRECCBI BIT(1),    /* ISTZCCBI ENTERED                 */
*         4  ZCRECCAI BIT(1),    /* ISTZCCAI ENTERED                 */
*         4  ZCRECCCI BIT(1),    /* ISTZCCCI ENTERED                 */
*         4  ZCREAC1R BIT(1),    /* ISTZAC1R ENTERED                 */
*         4  ZCREBCSB BIT(1),    /* ISTZBCSB ENTERED                 */
*         4  ZCREDCPR BIT(1),    /* ISTZDCPR ENTERED                 */
*         4  ZCREDCQR BIT(1),    /* ISTZDCQR ENTERED                 */
*         4  ZCREBCAL BIT(1),    /* ISTZBCAL ENTERED                 */
*         4  ZCREBC0L BIT(1),    /* ISTZBC0L ENTERED                 */
*         4  ZCREBCNB BIT(1),    /* ISTZBCNB ENTERED                 */
*         4  ZCREICOE BIT(1),    /* ISTZICOE ENTERED                 */
*         4  ZCREDCNB BIT(1),    /* ISTZDCNB ENTERED                 */
*         4  ZCREKCCB BIT(1),    /* ISTZKCCB ENTERED                 */
*         4  ZCRECFY0 BIT(1),    /* ISTZCFY0 ENTERED                 */
*         4  ZCREDCK0 BIT(1),    /* ISTZDFK0 ENTERED                 */
*         4  ZCREICSG BIT(1),    /* ISTZICSG ENTERED                 */
*         4  ZCREBCIF BIT(1),    /* ISTZBCIF ENTERED                 */
*         4  ZCREDCMF BIT(1),    /* ISTZDCMF ENTERED                 */
*         4  ZCRELCAB BIT(1),    /* ISTZLCAB ENTERED                 */
*         4  ZCREAC2B BIT(1),    /* ISTZAC2B ENTERED                 */
*         4  ZCREIC2B BIT(1),    /* ISTZIC2B ENTERED                 */
*         4  ZCRRSV97 BIT(97),   /* RESERVED                         */
*   2  ZCRCMNRC CHAR(1),                /* PURGE MWOR RETURN CODE    */
*   2  ZCRWORDA CHAR(3),                /* RESERVED FOR LATER USE    */
*   2  ZCRLCPB  CHAR(LENGTH(ISTLCPB)),  /* 3270 S/R LCPB             */
*      3 ZCRRHRU,                       /* SAVEAREA FOR RH AND RU    */
*        4 ZCRRH    CHAR(3),            /* RH                        */
*        4 ZCRRU    CHAR(*);            /* RU                        */
*DCL ZCTYPE BIT(8) CONSTANT('00'X);   /* ZCR TYPE                   */
*DCL ZCLNG FIXED(15) CONSTANT(172);   /* ZCRR LENGTH                */
*DCL ZCRSAVNO BIT(8) CONSTANT('06'X); /* NUMBER OF SAVEAREAS IN ZCRR */
*DCL ZCRLSVNO BIT(8) CONSTANT('04'X); /* NUMBER OF SAVE AREAS IN
*                                         LOCAL SUPPORT              */
*/* *** EQUATES FOR ZCRRCDSV *** */                             01S1106
*                                                               01S1106
*DCL ZCRMRFSB BIT(8) CONSTANT('0C'X);  /* REQUEST COMPLETION MOVE FSB
*                                         TO PROCESS                 */
*DCL ZCRSRCHQ BIT(8) CONSTANT('10'X);  /* REQUEST COMPLETION SEARCH
*                                         REQUEST QUEUE              */
*DCL ZCREXIT  BIT(8) CONSTANT('14'X);  /* REQUEST COMPLETION EXIT    */
*DCL ZCRSFSB  BIT(8) CONSTANT('18'X);  /* REQUEST COMPLETION SINGLE
*                                         FSB                        */
*DCL ZCRDLFSB BIT(8) CONSTANT('1C'X);  /* REQUEST COMPLETION DUAL FSB *
*DCL ZCRNOSCH BIT (8) CONSTANT('20'X); /* REQUEST COMPLETION, EXIT WITH
*                                         SCHED NONE                 */
*DCL ZCRNRSCH BIT (8) CONSTANT('24'X); /* REQUEST COMPLETION, EXIT WITH
*                                         SCHED NORM                 */
*DCL ZCRLGERR FIXED(8) CONSTANT(8);    /* LOGICAL ERROR              */
*DCL ZCPLSCB BIT(8) CONSTANT('08'X);   /* GET A RELEASE LSCB         */
*DCL ZCPBUF  BIT(8) CONSTANT('04'X);   /* GET A RELEASE BUFFER       */
*DCL ZCRTAC0A FIXED(8) CONSTANT(01);   /* LOCAL DEVICE SCHEDULER(OUT)*/
*DCL ZCRTAC0B FIXED(8) CONSTANT(02);   /* REMOTE DEVICE SCHEDLER(OUT)*/
*DCL ZCRTCC1A FIXED(8) CONSTANT(03);   /* LOCAL DIALOG SCHEDLER(IN)  */
*DCL ZCRTCC1B FIXED(8) CONSTANT(04);   /* REMOTE DIALOG SCHEDLER(IN) */
*DCL ZCRTDCE0 FIXED(8) CONSTANT(05);   /* NCP SLOWDOWN RECOVERY      */
*DCL ZCRTDCKA FIXED(8) CONSTANT(06);   /* LOCAL GENERAL FUNCTIONS    */
*DCL ZCRTDCKB FIXED(8) CONSTANT(07);   /* REMOTE GENERAL FUNCTIONS   */
*DCL ZCRTFCEB FIXED(8) CONSTANT(08);   /* REMOTE READ BUFFER ALLOC.  */
*DCL ZCRTGCLA FIXED(8) CONSTANT(09);   /* LCAL CTL & TEST FEEDBACK(IN)*
*DCL ZCRTGC0A FIXED(8) CONSTANT(10);   /* LOCAL REQ. COMPLETION(IN)  */
*DCL ZCRTGC0B FIXED(8) CONSTANT(11);   /* REMOTE REQ. COMPLETION(IN) */
*DCL ZCRTICWB FIXED(8) CONSTANT(12);   /* RESET CLEANUP (PHASE 5)    */
*DCL ZCRTIC0B FIXED(8) CONSTANT(13);   /* REMOTE REQ COMPLTION CTL(IN)*
*DCL ZCRTAC1B FIXED(8) CONSTANT(14);   /* ISTZAC1B THREAD ID         */
*DCL ZCRTIC1B FIXED(8) CONSTANT(15);   /* ISTZIC1B THREAD ID         */
*DCL ZCRTCCBI FIXED(8) CONSTANT(16);   /* ISTZCCBI THREAD ID         */
*DCL ZCRTAC1R FIXED(8) CONSTANT(17);   /* ISTZAC1R THREAD ID         */
*DCL ZCRTAC1A FIXED(8) CONSTANT(18);   /* ISTZAC1A THREAD ID         */
*DCL ZCRTLCAB FIXED(8) CONSTANT(19);   /* ISTZLCAB THREAD ID         */
*/* COMPONENT RECOVERY                                               */
*/*                                                                  */
*DCL 1 ISTASCRR BDY(WORD) BASED,        /* CRR FOR SMS               */
*     2  ASCPFCRR CHAR(LENGTH(ISTPFCRR)),                       01S1135
*     2  ASCFLAGS CHAR(7),              /* FLAGS                     */
*        3  ASCFLG1 CHAR(2),            /* MODULE TRACE FLAGS        */
*           4  ASCFBA BIT(1),           /* ALLOCATION IN PATH        */
*           4  ASCFBD BIT(1),           /* DE-ALLOCATION IN PATH     */
*           4  ASCFSR BIT(1),           /* FSR IN PATH               */
*           4  ASCPASTR BIT(13),        /* RESERVED PATH FLAGS       */
*        3  ASCFLG2 CHAR(2),            /* MODULE IN CONTROL FLAGS   */
*           4  ASCFBAIC BIT(1),         /* ALLOCATION IN CONTROL     */
*           4  ASCFBDIC BIT(1),         /* DE-ALLOCATION IN CONTROL  */
*           4  ASCFSRIC BIT(1),         /* FSR IN CONTROL            */
*           4  ASCICR BIT(13),          /* RESERVED IN CONTROL FLAGS */
*        3  ASCFLG3 CHAR(3),            /* AUDIT FLAGS               */
*           4  ASCFSRGT BIT(1),         /* FSR DOING GET PROCESSING  */
*           4  ASCFBDAL BIT(1),         /* FBD DOING ALLOCATION      */
*           4  ASCKEYF BIT(1),          /* KEY HAS BEEN ALTERED      */
*           4  ASCLLKF BIT(1),          /* LOCAL LOCK HELD           */
*           4  ASCFBDUD BIT(1),         /* FBD USING USER DATA       */
*           4  ASCAUDIT BIT(19),        /* RESERVED AUDIT BITS       */
*     2  ASCKEY CHAR(1),                /* ORIGINAL KEY              */
*     2  ASCETRYA PTR(31),              /* RETRY ADRS FOR CONTINUE
*                                          OPTION                    */
*     2  ASCUSRGS CHAR(16),             /* SAVE AREA FOR USER REGS
*                                          14 - 1                    */
*        3  ASCUSR14 CHAR(4),           /* REGISTER 14               */
*        3  ASCUSR15 CHAR(4),           /* REGISTER 15               */
*        3  ASCUSR00 CHAR(4),           /* REGISTER 0                */
*        3  ASCUSR01 CHAR(4),           /* REGISTER 1                */
*     2  ASCPSREG CHAR(16);             /* SAVE AREA FOR PSS    01S1135
*                                          REGS 1 - 4                */
*/*  INITIAL LEVEL                                      001 04/09/75 */
*DCL 1 ISTAPCRR BDY(WORD) BASED,                                01S1136
*     2 APCHDRSV CHAR(LENGTH(ISTPFCRR)),  /* HEADER                  */
*     2  APCATFLG CHAR(2),              /* AUDIT TRACE FLAGS         */
*        3  APC51E BIT(1),              /* ISTAPC51 WAS ENTERED      */
*        3  APC52E BIT(1),              /* ISTAPC52  '     '         */
*        3  APC53E BIT(1),              /* ISTAPC53                  */
*        3  APC54E BIT(1),                                      01S1136
*        3  APC56E BIT(1),                                      01S1136
*        3  APC57E BIT(1),                                      01S1136
*        3  APC58E BIT(1),                                      01S1136
*        3  APC31E BIT(1),                                      01S1136
*        3 * BIT(8),                    /* RESERVED                  */
*     2  APCRFLG CHAR(2),               /* AUDIT TRACE FLAGS         */
*        3  APC51R BIT(1),              /* ISTAPCR1 IS RUNNING       */
*        3  APC52R BIT(1),              /* ISTAPC52 IS RUNNING       */
*        3  APC53R BIT(1),                                      01S1136
*        3  APC54R BIT(1),                                      01S1136
*        3  APC56R BIT(1),                                      01S1136
*        3  APC57R BIT(1),                                      01S1136
*        3  APC58R BIT(1),                                      01S1136
*        3  APC31R BIT(1),                                      01S1136
*        3  *      BIT(8),              /* RESERVED                  */
*     2  APCPSTA PTR(31),               /* PST@                      */
*     2  APCTCBA PTR(31),               /* TCB@                      */
*     2  APCRTRN PTR(31),               /*@ TO BR14 TO RTN TO SYSTEM */
*     2  APCPABSV PTR(31),              /*SAVED PAB@ TO REDISPATCH   */
*     2  APCQWFO PTR(31),               /* Q@ IN PST WORK AREA ON    */
*     2  APCFRRPM PTR(31),              /* WORKAREA@ RTN'D FROM SETFR*/
*     2  APCSAVE CHAR(72),                                      01S1136
*        3  APCESTAL CHAR(72),          /* ESTAE PARAMETER LIST AREA */
*     2  APCCOMF CHAR(4) BDY(HWORD),    /* FLAGS USED BY ALL PSS RTN */
*        3  APCCOMF1 CHAR(2),                                   01S1136
*           4  APCSSTSK BIT(1),         /* IRB TYPE WORK             */
*           4  APCUETSK BIT(1),         /* USER EXIT RUNNING UNDER IRB*
*           4  APCSMCR BIT(1),          /* SMA CRA BEING USED        */
*           4  APCIRB1 BIT(1),          /* IRB1 BEING USED           */
*           4  APCIRB2 BIT(1),          /* IRB2 BEING USED           */
*           4  APCRELR BIT(1),          /*CALL ISTAPC58 TO RLEASE CRA*/
*           4  APCEXIT BIT(1),          /* TELLS ISTAPC58 TO EXIT SYS*/
*           4  APCZLBER BIT(1),         /* ERR WHILE RUNNING ZLFAB PAB*
*           4  * BIT(8),                /* RESERVED                  */
*        3  APCRETCD FIXED(15),         /* RTN CODE FOR R15 FOR SYS  */
*     2  APCSAV1 PTR(31),               /* 1ST SAVE WORD             */
*     2  APCSAV2 PTR(31),               /* 2ND SAVE WORD             */
*     2  APCSWTWD CHAR(4),              /* SWITCH AREA FOR PSS RTN   */
*     2  APC31FLG CHAR(1),              /* ISTAPC31 FLAGS            */
*        3  APCTPXIT BIT(1),            /* TPEXIT IN PROGRESS        */
*        3  APCRESCH BIT(1),            /*PAB TPEXIT OCCURED  RESCHED*/
*        3  APCSORT BIT(1),       /* PAB SORTED TO PROPER PST/MPST   */
*        3  *       BIT(5),       /* RESERVED                        */
*     2  APC52FLG CHAR(1),        /* ISTAPC52 FLAGS                  */
*        3  APCCKRQ BIT(1),       /* CHECK RDY Q FOR WORK            */
*        3  APCSMSR BIT(1),       /* RETURNING SMS RPH               */
*        3  APCQENQ BIT(1),       /* ENQUEUEING PAB'S ON PST Q'S     */
*        3  APCRDQ BIT(1),        /* DEQUEING PAB'S FROM PST RDY Q   */
*        3  APCNWF BIT(1),        /* NO WORK FOUND                   */
*        3  APCWKF   BIT(1),      /* WORK FOUND                      */
*        3    *      BIT(2),      /* RESERVED                        */
*     2  APC53FLG CHAR(1),        /* ISTAPC53 FLAGS                  */
*        3  APCPR153 BIT(1),      /* USED PREALLOCATED CRA           */
*     2  APC54FLG CHAR(1),        /* ISTAPC54 FLAGS                  */
*        3  APCRLST BIT(1),       /* SMS BEING CALLED TO RELEASE UECB*/
*        3  * BIT(7),             /* RESERVED                        */
*     2  APC57FLG CHAR(1),        /* ISTAPC57 FLAGS                  */
*        3  APCRECRA BIT(1),      /* RELEASE CRA BEING DONE          */
*        3  APCNREL BIT(1),       /* DID NOT RELEASE CRA             */
*        3  *   BIT(6),           /* RESERVED                        */
*     2  * CHAR(15);              /* RESERVED                        */
*/*               COMPONENT RECOVERY AREA                            */
*/*  REVISIONS                                         005 04/09/75  */
*DCL 1  ISTCRA BASED BDY(DWORD),        /* COMPONENT RECOVERY AREA   */
*     2  CRABASIC BDY(WORD),            /* CRA WITHOUT PROCESS CRR   */
*      3 CRAHDR CHAR(8) BDY(WORD),      /* CRA HEADER                */
*        4  CRACRR PTR(31),             /* PTR TO ACTIVE CRR         */
*        4  CRAFRR PTR(31),             /* PTR TO ACTIVE FRR         */
*      3 CRALKACT BIT(32),              /* LOCK LEVEL AND       01S1137
*                                          OWNERSHIP FLAGS           */
*        4  CRALEV32 BIT(1),            /* 1 = LEVEL 32 LOCK HELD    */
*        4  CRALEV31 BIT(1),            /* 1 = LEVEL 31 LOCK HELD    */
*        4  CRALEV30 BIT(1),            /* 1 = LEVEL 30 LOCK HELD    */
*        4  CRALEV29 BIT(1),            /* 1 = LEVEL 29 LOCK HELD    */
*        4  CRALEV28 BIT(1),            /* 1 = LEVEL 28 LOCK HELD    */
*        4  CRALEV27 BIT(1),            /* 1 = LEVEL 27 LOCK HELD    */
*        4  CRALEV26 BIT(1),            /* 1 = LEVEL 26 LOCK HELD    */
*        4  CRALEV25 BIT(1),            /* 1 = LEVEL 25 LOCK HELD    */
*        4  CRALEV24 BIT(1),            /* 1 = LEVEL 24 LOCK HELD    */
*        4  CRALEV23 BIT(1),            /* 1 = LEVEL 23 LOCK HELD    */
*        4  CRALEV22 BIT(1),            /* 1 = LEVEL 22 LOCK HELD    */
*        4  CRALEV21 BIT(1),            /* 1 = LEVEL 21 LOCK HELD    */
*        4  CRALEV20 BIT(1),            /* 1 = LEVEL 20 LOCK HELD    */
*        4  CRALEV19 BIT(1),            /* 1 = LEVEL 19 LOCK HELD    */
*        4  CRALEV18 BIT(1),            /* 1 = LEVEL 18 LOCK HELD    */
*        4  CRALEV17 BIT(1),            /* 1 = LEVEL 17 LOCK HELD    */
*        4  CRALEV16 BIT(1),            /* 1 = LEVEL 16 LOCK HELD    */
*        4  CRALEV15 BIT(1),            /* 1 = LEVEL 15 LOCK HELD    */
*        4  CRALEV14 BIT(1),            /* 1 = LEVEL 14 LOCK HELD    */
*        4  CRALEV13 BIT(1),            /* 1 = LEVEL 13 LOCK HELD    */
*        4  CRALEV12 BIT(1),            /* 1 = LEVEL 12 LOCK HELD    */
*        4  CRALEV11 BIT(1),            /* 1 = LEVEL 11 LOCK HELD    */
*        4  CRALEV10 BIT(1),            /* 1 = LEVEL 10 LOCK HELD    */
*        4  CRALEV09 BIT(1),            /* 1 = LEVEL 9 LOCK HELD     */
*        4  CRALEV08 BIT(1),            /* 1 = LEVEL 8 LOCK HELD     */
*        4  CRALEV07 BIT(1),            /* 1 = LEVEL 7 LOCK HELD     */
*        4  CRALEV06 BIT(1),            /* 1 = LEVEL 6 LOCK HELD     */
*        4  CRALEV05 BIT(1),            /* 1 = LEVEL 5 LOCK HELD     */
*        4  CRALEV04 BIT(1),            /* 1 = LEVEL 4 LOCK HELD     */
*        4  CRALEV03 BIT(1),            /* 1 = LEVEL 3 LOCK HELD     */
*        4  CRALEV02 BIT(1),            /* 1 = LEVEL 2 LOCK HELD     */
*        4  CRALEV01 BIT(1),            /* 1 = LEVEL 1 LOCK HELD     */
*      3 CRAL1PTR PTR(31),              /* PTR TO LEVEL 1 LOCK       */
*      3 CRAL2PTR PTR(31),              /* PTR TO LEVEL 2 LOCK       */
*      3 CRAL3PTR PTR(31),              /* PTR TO LEVEL 3 LOCK       */
*      3 CRAL4PTR PTR(31),              /* PTR TO LEVEL 4 LOCK       */
*      3 CRAL5PTR PTR(31),              /* PTR TO LEVEL 5 LOCK       */
*      3 CRAL6PTR PTR(31),              /* PTR TO LEVEL 6 LOCK       */
*      3 CRAL7PTR PTR(31),              /* PTR TO LEVEL 7 LOCK       */
*      3 CRAL8PTR PTR(31),              /* PTR TO LEVEL 8 LOCK       */
*      3 CRAL9PTR PTR(31),              /* PTR TO LEVEL 9 LOCK       */
*      3 CRALAPTR PTR(31),              /* RESERVED                  */
*/*                                                                  */
*/*   VS1/VS2 EXTENSION                                              */
*/*                                                                  */
*     2  CRARPH CHAR(LENGTH(ISTRPH)),   /* RPH ASSOCIATED WITH  01S1137
*                                          THIS CRH                  */
*     2  CRAPSS CHAR(LENGTH(ISTAPCRR)), /* PSS CRR                   */
*     2  CRAPROCR CHAR(LENGTH(ISTZCRR)) BDY(DWORD), /* PROCESS CRR   */
*     2  CRASVC CHAR(72) BDY(WORD),     /* SERVICE RTN CRA           */
*        3  CRAASCRR CHAR(LENGTH(ISTASCRR)), /* CRR FOR SMS          */
*        3  CRAHSIZ  PTR(31),           /* HEADER SIZE QUED SMS REQ  */
*        3  CRAMASK  PTR(31),           /* PREFIX MASK QUED SMS REQ  */
*        3  CRABUFA  FIXED(31),         /* BUFF QUE FOR FBQ ALLOCATION*
*           4 CRABFTBA BIT(1),          /* NO BUFFERS ALLOCATED YET   *
*     2  CRARSV01 PTR(31),              /* RESERVED                  */
*     2  CRARSV02 PTR(31),              /* RESERVED                  */
*     2  CRACHAIN PTR(31);              /* CHAIN FIELD USED TO QUEUE
*                                          CRA TO PREALLOCATE QUEUE
*                                          WHEN NOT IN USE           */
*DCL CRALMS32 BIT(32) CONSTANT('80000000'X); /* 32ND LEVEL LOCK MASK */
*DCL CRALMS31 BIT(32) CONSTANT('40000000'X); /* 31ST LEVEL LOCK MASK */
*DCL CRALMS30 BIT(32) CONSTANT('20000000'X); /* 30TH LEVEL LOCK MASK */
*DCL CRALMS29 BIT(32) CONSTANT('10000000'X); /* 29TH LEVEL LOCK MASK */
*DCL CRALMS28 BIT(32) CONSTANT('08000000'X); /* 28TH LEVEL LOCK MASK */
*DCL CRALMS27 BIT(32) CONSTANT('04000000'X); /* 27TH LEVEL LOCK MASK */
*DCL CRALMS26 BIT(32) CONSTANT('02000000'X); /* 26TH LEVEL LOCK MASK */
*DCL CRALMS25 BIT(32) CONSTANT('01000000'X); /* 25TH LEVEL LOCK MASK */
*DCL CRALMS24 BIT(32) CONSTANT('00800000'X); /* 24TH LEVEL LOCK MASK */
*DCL CRALMS23 BIT(32) CONSTANT('00400000'X); /* 23RD LEVEL LOCK MASK */
*DCL CRALMS22 BIT(32) CONSTANT('00200000'X); /* 22ND LEVEL LOCK MASK */
*DCL CRALMS21 BIT(32) CONSTANT('00100000'X); /* 21ST LEVEL LOCK MASK */
*DCL CRALMS20 BIT(32) CONSTANT('00080000'X); /* 20TH LEVEL LOCK MASK */
*DCL CRALMS19 BIT(32) CONSTANT('00040000'X); /* 19TH LEVEL LOCK MASK */
*DCL CRALMS18 BIT(32) CONSTANT('00020000'X); /* 18TH LEVEL LOCK MASK */
*DCL CRALMS17 BIT(32) CONSTANT('00010000'X); /* 17TH LEVEL LOCK MASK */
*DCL CRALMS16 BIT(32) CONSTANT('00008000'X); /* 16TH LEVEL LOCK MASK */
*DCL CRALMS15 BIT(32) CONSTANT('00004000'X); /* 15TH LEVEL LOCK MASK */
*DCL CRALMS14 BIT(32) CONSTANT('00002000'X); /* 14TH LEVEL LOCK MASK */
*DCL CRALMS13 BIT(32) CONSTANT('00001000'X); /* 13TH LEVEL LOCK MASK */
*DCL CRALMS12 BIT(32) CONSTANT('00000800'X); /* 12TH LEVEL LOCK MASK */
*DCL CRALMS11 BIT(32) CONSTANT('00000400'X); /* 11TH LEVEL LOCK MASK */
*DCL CRALMS10 BIT(32) CONSTANT('00000200'X); /* 10TH LEVEL LOCK MASK */
*DCL CRALMS09 BIT(32) CONSTANT('00000100'X); /* 9TH LEVEL LOCK MASK  */
*DCL CRALMS08 BIT(32) CONSTANT('00000080'X); /* 8TH LEVEL LOCK MASK  */
*DCL CRALMS07 BIT(32) CONSTANT('00000040'X); /* 7TH LEVEL LOCK MASK  */
*DCL CRALMS06 BIT(32) CONSTANT('00000020'X); /* 6TH LEVEL LOCK MASK  */
*DCL CRALMS05 BIT(32) CONSTANT('00000010'X); /* 5TH LEVEL LOCK MASK  */
*DCL CRALMS04 BIT(32) CONSTANT('00000008'X); /* 4TH LEVEL LOCK MASK  */
*DCL CRALMS03 BIT(32) CONSTANT('00000004'X); /* 3RD LEVEL LOCK MASK  */
*DCL CRALMS02 BIT(32) CONSTANT('00000002'X); /* 2ND LEVEL LOCK MASK  */
*DCL CRALMS01 BIT(32) CONSTANT('00000001'X); /* 1ST LEVEL LOCK MASK  */
*DCL CRACRA   CHAR(4) CONSTANT('CRA ');      /* CHARACTER C.B. ID    */
*                                                               01S1171
* DECLARE                                                       01S1171
*   EMCR0 PTR REG(0),                                           01S1171
*   EMCR1 PTR REG(1),                                           01S1171
*   EMCR2 PTR REG(2),                                           01S1171
*   EMCR3 PTR REG(3),                                           01S1171
*   EMCR4 PTR REG(4),                                           01S1171
*   EMCR5 PTR REG(5),                                           01S1171
*   EMCR6 PTR REG(6),                                           01S1171
*   EMCR7 PTR REG(7),                                           01S1171
*   EMCR8 PTR REG(8),                                           01S1171
*   EMCR9 PTR REG(9),                                           01S1171
*   EMCR10 PTR REG(10),                                         01S1171
*   EMCR11 PTR REG(11),                                         01S1171
*   EMCR12 PTR REG(12),                                         01S1171
*   EMCR13 PTR REG(13),                                         01S1171
*   EMCR14 PTR REG(14),                                         01S1171
*   EMCR15 PTR REG(15);                                         01S1171
* GEN (PRINT ON);                                               01S1172
         PRINT ON
*/* END OF TPEPILOG */                                          01S1173
*END ISTSDCCB                                                   01S1173
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (CVT     )                                        *
*/*%INCLUDE SYSUT5  (CBDEF   )                                        *
*/*%INCLUDE SYSUT5  (CKSUB   )                                        *
*/*%INCLUDE SYSUT5  (BLDSNT  )                                        *
*/*%INCLUDE SYSUT5  (GETLOCK )                                        *
*/*%INCLUDE SYSUT5  (RDTLOOP )                                        *
*/*%INCLUDE SYSUT5  (TERMS   )                                        *
*/*%INCLUDE SYSUT5  (APLCLSLN)                                        *
*/*%INCLUDE SYSUT5  (PORTS   )                                        *
*/*%INCLUDE SYSUT5  (BHSETSRT)                                        *
*/*%INCLUDE SYSUT5  (ADDRDT  )                                        *
*;                                                              01S1173
@EL00001 DS    0H                                               01S1173
@EF00001 DS    0H                                               01S1173
@ER00001 LM    @14,@12,12(@13)                                  01S1173
         BR    @14                                              01S1173
@DATA    DS    0H
@CH00096 DC    H'4'
@CH00873 DC    H'5'
@CH00102 DC    H'8'
@CH02275 DC    H'9'
@DATD    DSECT
         DS    0F
ISTSDCCB CSECT
         DS    0F
@CF00104 DC    F'1'
@CH00104 EQU   @CF00104+2
@CF00836 DC    XL4'80000000'
@CF01087 DC    XL4'7FFFFFFF'
@CF00957 DC    XL4'FFFF'
@DATD    DSECT
         DS    0D
CVTPTR   DS    A
MNTEPTR  DS    A
COMPCIDM DS    F
BHSATC   DS    A
CTBHS    DS    F
SRTSAV   DS    A
LCPBPTR  DS    A
ERNODTYP DS    FL1
CBFLGS   DS    FL1
         ORG   CBFLGS
PTHERRFP DS    BL1
SRTSEC   EQU   CBFLGS+0
@NM00009 EQU   CBFLGS+0
         ORG   CBFLGS+1
         DS    CL2
CMZA0047 DS    2A
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
ISTSDCCB CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
@CV00788 DC    V(ISTSDCD1)
@CV00789 DC    V(ISTSDCD2)
@CV00790 DC    V(ISTSDCD3)
         DS    0D
CMZA0015 DS    FL4
         ORG   CMZA0015
@NM00012 DC    AL1(96)
@NM00013 DC    AL1(96)
@NM00014 DC    AL1(227)
@NM00015 DC    XL1'00'
         ORG   CMZA0015+4
@CC01074 DC    C'STAT.ID.'
@CB01070 DC    X'0000000000000000'
@CB00908 DC    X'FFFFFFFF'
@CB01665 DC    X'00000002'
ISTNULL  DC    CL8'ISTNULL'
MSG303I  DC    CL4'303I'
MSG331I  DC    CL4'331I'
MSG332I  DC    CL4'332I'
MSG333I  DC    CL4'333I'
MSG340I  DC    CL4'340I'
MSG341I  DC    CL4'341I'
MSG660I  DC    CL4'660I'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
ERRSAV1  EQU   @10
SNTEPTR  EQU   @08
CMZF0047 EQU   @02
TPMSGID  EQU   @11
BHSEPTR  EQU   @10
LENDIVT  EQU   @07
CTDIVT   EQU   @06
DITTDIVT EQU   @02
CIDSNT   EQU   @02
CTSNT    EQU   @08
SNTPTR   EQU   @02
RDTEPTR  EQU   @10
ATCVTPTR EQU   @03
CONFTPTR EQU   @04
MLCAPTR  EQU   @05
SAVREG   EQU   @13
GPR00F   EQU   @00
GPR00P   EQU   @00
GPR01P   EQU   @01
GPR02P   EQU   @02
GPR03F   EQU   @03
GPR03P   EQU   @03
GPR04P   EQU   @04
GPR05P   EQU   @05
GPR06P   EQU   @06
GPR07P   EQU   @07
GPR08P   EQU   @08
GPR09P   EQU   @09
GPR10P   EQU   @10
GPR11P   EQU   @11
GPR12P   EQU   @12
GPR13P   EQU   @13
GPR14P   EQU   @14
GPR15F   EQU   @15
GPR15P   EQU   @15
RPHPTR   EQU   @01
REG1006  EQU   @01
EMCR13   EQU   @13
REG15006 EQU   @15
REG1033  EQU   @01
REG15033 EQU   @15
CMZR0047 EQU   @01
REG1053  EQU   @01
REG15053 EQU   @15
REG1072  EQU   @01
REG15072 EQU   @15
LDPRMPTR EQU   @01
EMCR0    EQU   @00
EMCR1    EQU   @01
EMCR10   EQU   @10
EMCR11   EQU   @11
EMCR12   EQU   @12
EMCR14   EQU   @14
EMCR15   EQU   @15
EMCR2    EQU   @02
EMCR3    EQU   @03
EMCR4    EQU   @04
EMCR5    EQU   @05
EMCR6    EQU   @06
EMCR7    EQU   @07
EMCR8    EQU   @08
EMCR9    EQU   @09
GPR01F   EQU   @01
GPR02F   EQU   @02
GPR04F   EQU   @04
GPR05F   EQU   @05
GPR06F   EQU   @06
GPR07F   EQU   @07
GPR08F   EQU   @08
GPR09F   EQU   @09
GPR10F   EQU   @10
GPR11F   EQU   @11
GPR12F   EQU   @12
GPR13F   EQU   @13
GPR14F   EQU   @14
ATCLCPTR EQU   1032
ISTPOHD  EQU   0
POHSTAT  EQU   ISTPOHD+1
ISTPFX   EQU   0
PFXID    EQU   ISTPFX
ISTNCSPL EQU   0
@NM00022 EQU   ISTNCSPL
NCSPFX   EQU   @NM00022
NCSPLVBF EQU   ISTNCSPL+18
NCSPLVFL EQU   ISTNCSPL+20
NCSPLVF1 EQU   ISTNCSPL+21
NCSPLCMD EQU   ISTNCSPL+60
NCSCMDA  EQU   NCSPLCMD
NCSCRFLG EQU   ISTNCSPL+67
NCSPLRAD EQU   ISTNCSPL+144
NCSIOCID EQU   ISTNCSPL+148
NCSPLCID EQU   NCSIOCID
NCSPLFSB EQU   ISTNCSPL+168
NCSPLFL1 EQU   ISTNCSPL+176
NCSPLFL2 EQU   ISTNCSPL+177
NCSPLFL3 EQU   ISTNCSPL+178
NCSPLFL4 EQU   ISTNCSPL+179
NCSPLFL5 EQU   ISTNCSPL+181
NCSPLAPP EQU   ISTNCSPL+216
NCSSENSE EQU   ISTNCSPL+244
NCSCRMSK EQU   ISTNCSPL+268
NCSCHKPT EQU   NCSCRMSK
NCSCRMOD EQU   NCSCRMSK+2
NCSPLSID EQU   ISTNCSPL+271
NCSPLSTA EQU   NCSPLSID
NCSPLPHD EQU   NCSPLSID+1
NCSAPP   EQU   0
NCSAPBUE EQU   NCSAPP+88
ISTPAB   EQU   0
PABWQCHN EQU   ISTPAB
PABWEQA  EQU   PABWQCHN
PABCHAIN EQU   PABWQCHN+4
PABRPHFG EQU   ISTPAB+12
PABFLAGS EQU   PABRPHFG
PABERLCK EQU   PABFLAGS
PABERRLK EQU   PABERLCK
ISTLOK   EQU   0
LOKCHN   EQU   ISTLOK+1
LOKCHNG  EQU   LOKCHN
@NM00028 EQU   LOKCHNG+2
LOKPRY   EQU   @NM00028
ISTDYPAB EQU   0
ISTRPH   EQU   0
RPHCNTL  EQU   ISTRPH
RPHFLAGS EQU   RPHCNTL+2
RPHAPTYP EQU   RPHFLAGS
RPHFSTLC EQU   RPHFLAGS
RPHFLGB  EQU   RPHCNTL+3
RPHRPHA  EQU   ISTRPH+4
RPHTSKID EQU   ISTRPH+8
RPHRESMA EQU   ISTRPH+16
RPHWPFLG EQU   RPHRESMA
RPHWEA   EQU   ISTRPH+24
RPHCSPA  EQU   RPHWEA
RPHSRPRM EQU   ISTRPH+28
RPHCRR   EQU   ISTRPH+32
RPHPABQA EQU   ISTRPH+36
RPHWORK  EQU   ISTRPH+40
RPHSAVE1 EQU   RPHWORK
RPHSBITS EQU   RPHSAVE1+1
ISTATCVT EQU   0
ATCCOM   EQU   ISTATCVT
ATCSTAT  EQU   ATCCOM
ATCSTAT1 EQU   ATCSTAT
ATCSTFLG EQU   ATCSTAT+1
ATCPOFLG EQU   ATCSTAT+2
ATCSTAT4 EQU   ATCSTAT+3
ATCRDT   EQU   ATCCOM+12
ATCCONFT EQU   ATCCOM+112
ATCADD   EQU   ATCCOM+132
ATCIOTRC EQU   ATCCOM+140
ATCTHTRC EQU   ATCIOTRC
ATCGTSTR EQU   ATCCOM+164
ATCSRTAD EQU   ATCCOM+204
ATCSRTDF EQU   ATCCOM+208
ATCCIDM  EQU   ATCCOM+266
ATCMAXID EQU   ISTATCVT+269
ATCMNT   EQU   ISTATCVT+272
ATCCSMR  EQU   ISTATCVT+296
ATCSHRFG EQU   ISTATCVT+316
ATCMSGP  EQU   ISTATCVT+344
ATCHPGM  EQU   ISTATCVT+384
ATCAP33  EQU   ISTATCVT+444
ATCAP36  EQU   ISTATCVT+452
ATCVOCLK EQU   ISTATCVT+468
ATCVLCNT EQU   ISTATCVT+772
ATCRNO   EQU   ISTATCVT+788
ATCSOPD  EQU   ISTATCVT+792
ATCSIPD  EQU   ISTATCVT+800
ATCSECST EQU   ISTATCVT+812
ATCNMCTR EQU   ISTATCVT+816
ATCSTAT2 EQU   ISTATCVT+818
ATCVTBAM EQU   ISTATCVT+908
@NM00039 EQU   ATCVTBAM+3
ATCAOSM  EQU   ISTATCVT+912
ATCGSRBQ EQU   ATCAOSM+4
ATCGSRBG EQU   ATCGSRBQ
ATCICAPP EQU   ATCAOSM+100
ATCLDAPP EQU   ATCAOSM+120
ATCDAPVT EQU   ATCAOSM+140
ATCCRA   EQU   ATCAOSM+280
ATCCRACN EQU   ATCCRA+4
ATCSRB   EQU   ATCAOSM+288
ATCSRBCN EQU   ATCSRB+4
ATCCRPL  EQU   ATCAOSM+296
ATCRPLCN EQU   ATCCRPL+4
ATCSQAFR EQU   ATCAOSM+304
ATCORTBC EQU   ATCSQAFR+4
ATCORSRB EQU   ATCORTBC
@NM00041 EQU   ATCAOSM+332
ATCVTFLG EQU   ATCAOSM+392
ATCZFLAG EQU   ATCAOSM+588
ISTDEVCH EQU   0
DEVSHCH  EQU   ISTDEVCH
DEVCHAR  EQU   DEVSHCH
DEVTCODE EQU   ISTDEVCH+1
DEVFLAGS EQU   ISTDEVCH+3
DEVFCCTL EQU   DEVFLAGS
DEVCHAR3 EQU   DEVFLAGS
ISTRPRE  EQU   0
RPRNAME  EQU   ISTRPRE
RPRCOMID EQU   ISTRPRE+8
RPRELEN  EQU   ISTRPRE+16
RPRENTRY EQU   ISTRPRE+20
RPRFLAGA EQU   ISTRPRE+21
RPRINV   EQU   RPRFLAGA
RPRENTED EQU   RPRFLAGA
RPRFLAGB EQU   ISTRPRE+22
RPRCAUSE EQU   ISTRPRE+23
RPRNOSRT EQU   RPRCAUSE
RPRHDTYP EQU   ISTRPRE+27
RPRLGONF EQU   ISTRPRE+28
RPRLGONB EQU   ISTRPRE+32
RPRNSNEA EQU   ISTRPRE+36
RPRDEVCH EQU   ISTRPRE+44
RPRFLAGD EQU   ISTRPRE+61
RPRFLAGC EQU   ISTRPRE+62
ISTRCPRE EQU   0
RCPICELN EQU   ISTRCPRE+72
RCPICEAQ EQU   ISTRCPRE+80
RCPACETR EQU   ISTRCPRE+84
RCPPMODE EQU   ISTRCPRE+91
RCPLGNIN EQU   ISTRCPRE+92
ISTRDT   EQU   0
RDTPLEN  EQU   ISTRDT+72
RDTPRIOR EQU   RDTPLEN
RDTPRIAP EQU   RDTPRIOR
RDTPRIRN EQU   RDTPRIOR
RDTCTSNT EQU   ISTRDT+86
RDTMAXID EQU   ISTRDT+88
RDTNODID EQU   ISTRDT+89
RDTFLAGB EQU   ISTRDT+91
RDTVYRPH EQU   ISTRDT+108
RDTSTCNT EQU   ISTRDT+112
ISTRAP   EQU   0
RAPICELG EQU   ISTRAP+88
RAPICEAC EQU   ISTRAP+92
RAPICEAQ EQU   ISTRAP+96
RAPACEAP EQU   ISTRAP+100
RAPFLG   EQU   ISTRAP+108
RAPFLGB  EQU   ISTRAP+109
RAPFLGC  EQU   ISTRAP+110
ISTRLC   EQU   0
RLCADR   EQU   ISTRLC+72
RLCFLAG  EQU   RLCADR
ISTRRN   EQU   0
RRNADR   EQU   ISTRRN+136
RRNFLAG  EQU   RRNADR
RRNUCBAD EQU   RRNADR+1
RRNGRPA  EQU   ISTRRN+140
RRNBHSET EQU   ISTRRN+152
RRNCTBHS EQU   ISTRRN+156
RRNRDF   EQU   ISTRRN+172
RRNRDFA  EQU   RRNRDF
RRNRDFB  EQU   RRNRDF+1
RRNCMF   EQU   ISTRRN+176
RRNCMFA  EQU   RRNCMF
RRNCMFB  EQU   RRNCMF+1
RRNCMFC  EQU   RRNCMF+2
RRNCMFD  EQU   RRNCMF+3
RRNFLUX  EQU   ISTRRN+180
RRNNMDPD EQU   ISTRRN+192
RRNHPRE  EQU   ISTRRN+216
RRNHBUFS EQU   ISTRRN+218
RRNLASTE EQU   ISTRRN+240
ISTRGP   EQU   0
RGPFLG   EQU   ISTRGP+72
RGPADIL  EQU   RGPFLG
ISTRLN   EQU   0
RLNADR   EQU   ISTRLN+72
RLNFLAG  EQU   RLNADR
RLNUCBAD EQU   RLNADR+1
RLNSTAT1 EQU   ISTRLN+86
RLNSTAT2 EQU   ISTRLN+87
RLNRDF   EQU   ISTRLN+88
RLNRDFA  EQU   RLNRDF
RLNRACNT EQU   RLNRDFA
RLNRACAN EQU   RLNRACNT
RLNPORT  EQU   RLNRDFA
RLNRDFB  EQU   RLNRDF+1
RLNTTV   EQU   RLNRDFB
RLNCRFLG EQU   ISTRLN+102
RLNLSCMD EQU   RLNCRFLG
ISTRPT   EQU   0
RPTLNCID EQU   ISTRPT+116
RPTCTNM  EQU   ISTRPT+120
RPTDITT  EQU   ISTRPT+128
RPTUTERM EQU   ISTRPT+136
RPTFLAG1 EQU   ISTRPT+140
ISTRCL   EQU   0
RCLADR   EQU   ISTRCL+72
RCLFLAG  EQU   RCLADR
RCLGPOLA EQU   ISTRCL+84
ISTRTR   EQU   0
RTRADR   EQU   ISTRTR+124
RTRFLAG  EQU   RTRADR
RTRVTERM EQU   RTRFLAG
RTRRDFA  EQU   ISTRTR+136
RTRRAALL EQU   RTRRDFA
RTRRDFB  EQU   ISTRTR+137
RTRRDFC  EQU   ISTRTR+138
RTRRDFD  EQU   ISTRTR+139
RTRRDFE  EQU   ISTRTR+140
RTRRDFF  EQU   ISTRTR+141
RTRCRFLG EQU   ISTRTR+143
RTRLSCMD EQU   RTRCRFLG
RTRPOLA  EQU   ISTRTR+172
RTRDIAA  EQU   ISTRTR+176
RTRBSCID EQU   ISTRTR+188
ISTRIN   EQU   0
RINDFD   EQU   ISTRIN+124
RINREMPO EQU   RINDFD
RINNODEF EQU   RINDFD
RINLDISC EQU   RINDFD
RINNODID EQU   ISTRIN+125
RINRLDAF EQU   ISTRIN+126
RINREMOT EQU   ISTRIN+128
RINVPAB  EQU   ISTRIN+132
RINRPHCN EQU   ISTRIN+136
RINNCSPL EQU   ISTRIN+140
RINCNCNT EQU   ISTRIN+144
RINLOCRN EQU   ISTRIN+148
ISTRDS   EQU   0
RDSCTTRM EQU   ISTRDS+72
RDSADDOT EQU   ISTRDS+76
ISTDOT   EQU   0
DOTADTRM EQU   ISTDOT
ISTRCC   EQU   0
RCCFLAG  EQU   ISTRCC+73
RCCFLAGB EQU   ISTRCC+74
RCCSTAID EQU   ISTRCC+78
RCCID48  EQU   RCCSTAID+2
RCCCRFLG EQU   ISTRCC+108
RCCPATHT EQU   ISTRCC+120
ISTRLU   EQU   0
RLUFLAG  EQU   ISTRLU+125
RLUCRFLG EQU   ISTRLU+126
RLUPACE  EQU   ISTRLU+132
RLUNCPPC EQU   ISTRLU+134
RLUUSSTB EQU   ISTRLU+140
RLUMODET EQU   ISTRLU+152
ISTRPX   EQU   0
ISTRLX   EQU   0
RLXFLAGA EQU   ISTRLX+76
ISTRSW   EQU   0
RSWDIALT EQU   ISTRSW+136
RSWGRUPT EQU   ISTRSW+140
ISTRDA   EQU   0
RDAADR   EQU   ISTRDA+72
RDAFLAG  EQU   RDAADR
RDAUCBAD EQU   RDAADR+1
ISTRLS   EQU   0
ISTDNT   EQU   0
ISTGNT   EQU   0
ISTPAT   EQU   0
PATFLAGA EQU   ISTPAT+7
ISTMNT   EQU   0
MNTENTRY EQU   ISTMNT
MNTSNT   EQU   MNTENTRY
MNTLOCK  EQU   MNTENTRY+4
ISTSNT   EQU   0
SNTNENTS EQU   ISTSNT
SNTENTRY EQU   ISTSNT+8
SNTWORD1 EQU   SNTENTRY
SNTFLAG  EQU   SNTWORD1
SNTRDTFG EQU   SNTFLAG
SNTDUMFG EQU   SNTFLAG
SNTCBPTR EQU   SNTWORD1+1
SNTLOCK  EQU   SNTENTRY+4
ISTBHSAT EQU   0
BHSNAME  EQU   ISTBHSAT
BHSINDEX EQU   ISTBHSAT+8
ISTMLCA  EQU   0
MLCRPH   EQU   ISTMLCA+4
MLCSKEL  EQU   ISTMLCA+8
MLCFLAGS EQU   ISTMLCA+16
MLCINT   EQU   MLCFLAGS
MLCERBF  EQU   ISTMLCA+28
MLCERBF1 EQU   MLCERBF
MLCERBF2 EQU   MLCERBF+8
MLCNAME  EQU   MLCERBF2
MLCERBF3 EQU   MLCERBF+32
MLCPTRS  EQU   ISTMLCA+96
MLCPTR0  EQU   MLCPTRS
MLCPTR1  EQU   MLCPTRS+4
MLCPTR2  EQU   MLCPTRS+8
MLCPTR3  EQU   MLCPTRS+12
MLCPTR5  EQU   MLCPTRS+20
MLCNCSPL EQU   MLCPTRS+36
MLCSAV3  EQU   ISTMLCA+396
MLCDAT3  EQU   ISTMLCA+468
MLCADSAV EQU   ISTMLCA+652
MLCADDAT EQU   ISTMLCA+724
MLCWRK1  EQU   ISTMLCA+964
MLCWRK2  EQU   ISTMLCA+1220
MLCOCPRM EQU   MLCWRK2
MLCWRK3  EQU   ISTMLCA+1284
MLCRDPRM EQU   MLCWRK3
MLCWRK4  EQU   ISTMLCA+1348
MLCTPMSG EQU   MLCWRK4
MLCDECB2 EQU   MLCTPMSG+32
ISTDTE   EQU   0
DTELCTI  EQU   ISTDTE
DTERDTEA EQU   ISTDTE+1
ISTDVE   EQU   0
DVERDTEA EQU   ISTDVE
DVEACIND EQU   DVERDTEA
DVEBSCID EQU   ISTDVE+4
DVEBSCAR EQU   DVEBSCID+1
ISTDIVTH EQU   0
DIVNUME  EQU   ISTDIVTH
DIVIDLEN EQU   ISTDIVTH+4
ISTLDPRM EQU   0
LDPFG    EQU   ISTLDPRM+20
LDPFB2   EQU   ISTLDPRM+21
ISTCONFT EQU   0
CONHALT  EQU   ISTCONFT+106
CONFLAGS EQU   ISTCONFT+110
CONDSFLG EQU   CONFLAGS
CONOPTFL EQU   CONFLAGS+1
CONSTAT  EQU   CONFLAGS+2
CONBUFF  EQU   CONFLAGS+3
CONFLG01 EQU   ISTCONFT+416
CONUNITS EQU   ISTCONFT+1342
CONSCPID EQU   ISTCONFT+1356
CONSTAID EQU   CONSCPID+3
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTSHS   EQU   CVTXTNT2+40
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
SRTADD   EQU   0
SRTADDBH EQU   0
ISTOCCDF EQU   0
SAVIN    EQU   0
SVFORWRD EQU   SAVIN+8
@NM00010 EQU   0
CMZID006 EQU   @NM00010
@NM00011 EQU   @NM00010+4
CMZRL006 EQU   @NM00011
CMZRA006 EQU   @NM00011+1
CMZEA006 EQU   @NM00010+8
CMZVP006 EQU   @NM00010+12
CMZSA006 EQU   0
CMTA006  EQU   0
@NM00016 EQU   0
CMZID033 EQU   @NM00016
@NM00017 EQU   @NM00016+4
CMZRL033 EQU   @NM00017
CMZRA033 EQU   @NM00017+1
CMZEA033 EQU   @NM00016+8
CMZVP033 EQU   @NM00016+12
CMZSA033 EQU   0
CMTA033  EQU   0
ISTLCCW  EQU   0
LCCWOP   EQU   ISTLCCW
LCCWRWOP EQU   LCCWOP
LCCWCTL  EQU   LCCWRWOP
LCCWFLAG EQU   ISTLCCW+1
LCCWLSI  EQU   LCCWFLAG
ISTLCPB  EQU   0
LCPREQTG EQU   ISTLCPB+2
LCPFLAGS EQU   LCPREQTG
LCPZF001 EQU   LCPFLAGS
LCPZRT02 EQU   LCPZF001
LCPZF002 EQU   LCPFLAGS
LCPZRT03 EQU   LCPZF002
LCPZF003 EQU   LCPFLAGS
LCPZRT04 EQU   LCPZF003
LCPZF004 EQU   LCPFLAGS
LCPZRT05 EQU   LCPZF004
LCPZRT06 EQU   LCPFLAGS
LCPZRT07 EQU   LCPFLAGS
LCPMNRCD EQU   LCPREQTG+1
LCPZRT08 EQU   LCPMNRCD
LCPZRT09 EQU   LCPMNRCD
LCPCHAIN EQU   ISTLCPB+4
LCPCHAI1 EQU   LCPCHAIN
LCPRUCNT EQU   ISTLCPB+8
LCPFLAG2 EQU   ISTLCPB+9
LCPTLBPI EQU   LCPFLAG2
LCPFID0  EQU   LCPFLAG2
LCPSEQ   EQU   ISTLCPB+10
LCPCID   EQU   ISTLCPB+16
LCPFDBA  EQU   ISTLCPB+24
LCPFLG1  EQU   ISTLCPB+37
LCPFLCCW EQU   ISTLCPB+40
LCPLCCW  EQU   ISTLCPB+48
LCPPABA  EQU   LCPLCCW+4
LCPRPHA  EQU   LCPPABA
ISTZSAVE EQU   0
ZSAZSVBC EQU   ISTZSAVE
ZSAZSVMS EQU   ZSAZSVBC
ISTPFCRR EQU   0
PFCCRR   EQU   ISTPFCRR
PFCCRRID EQU   PFCCRR
PFCCRRLN EQU   PFCCRR+2
PFCHDR   EQU   ISTPFCRR+4
PFCCRRO  EQU   PFCHDR
PFCFRRO  EQU   PFCHDR+4
ISTCFCRR EQU   0
CFCAUDIT EQU   ISTCFCRR
CFCNTRD  EQU   CFCAUDIT
CFCCRT   EQU   CFCAUDIT+1
ISTZCRR  EQU   0
ZCRCRR   EQU   ISTZCRR
ZCRFLGS1 EQU   ISTZCRR+12
ZCRFLGS2 EQU   ISTZCRR+13
ZCRSWFLD EQU   ISTZCRR+14
ZCRENDSH EQU   ZCRSWFLD
ZCRNDLCP EQU   ZCRSWFLD
ZCRRESET EQU   ZCRSWFLD
ZCRFLGS3 EQU   ISTZCRR+15
ZCRGENSW EQU   ISTZCRR+16
ZCRPFLGS EQU   ISTZCRR+17
ZCRIBPR  EQU   ISTZCRR+18
ZCRSCPSW EQU   ISTZCRR+19
ZCRPARMS EQU   ISTZCRR+24
ZCRFBPTR EQU   ZCRPARMS
ZCRDFRDA EQU   ZCRPARMS+10
ZCRPCOD1 EQU   ZCRPARMS+12
ZCRPLSBF EQU   ZCRPCOD1
ZCRPCOD2 EQU   ZCRPARMS+13
ZCRSVRTN EQU   ISTZCRR+56
ZCRWKARA EQU   ISTZCRR+156
ZCRCIDSV EQU   ISTZCRR+192
ZCRAUDIT EQU   ISTZCRR+440
ZCRENTER EQU   ZCRAUDIT+5
ZCRLCPB  EQU   ISTZCRR+480
ZCRRHRU  EQU   ZCRLCPB
ISTASCRR EQU   0
ASCFLAGS EQU   ISTASCRR+16
ASCFLG1  EQU   ASCFLAGS
ASCFLG2  EQU   ASCFLAGS+2
ASCFLG3  EQU   ASCFLAGS+4
ASCUSRGS EQU   ISTASCRR+28
ISTAPCRR EQU   0
APCATFLG EQU   ISTAPCRR+16
APCRFLG  EQU   ISTAPCRR+18
APCSAVE  EQU   ISTAPCRR+44
APCCOMF  EQU   ISTAPCRR+116
APCCOMF1 EQU   APCCOMF
APC31FLG EQU   ISTAPCRR+132
APC52FLG EQU   ISTAPCRR+133
APC53FLG EQU   ISTAPCRR+134
APC54FLG EQU   ISTAPCRR+135
APC57FLG EQU   ISTAPCRR+136
ISTCRA   EQU   0
CRABASIC EQU   ISTCRA
CRAHDR   EQU   CRABASIC
CRALKACT EQU   CRABASIC+8
CRAL2PTR EQU   CRABASIC+16
CRASVC   EQU   ISTCRA+848
CRABUFA  EQU   CRASVC+68
FMZL0042 EQU   0
ISTRACCA EQU   0
@NM00018 EQU   0
CMZID053 EQU   @NM00018
@NM00019 EQU   @NM00018+4
CMZRL053 EQU   @NM00019
CMZRA053 EQU   @NM00019+1
CMZEA053 EQU   @NM00018+8
CMZVP053 EQU   @NM00018+12
CMZSA053 EQU   0
CMTA053  EQU   0
FMZL0062 EQU   0
@NM00020 EQU   0
CMZID072 EQU   @NM00020
@NM00021 EQU   @NM00020+4
CMZRL072 EQU   @NM00021
CMZRA072 EQU   @NM00021+1
CMZEA072 EQU   @NM00020+8
CMZVP072 EQU   @NM00020+12
CMZSA072 EQU   0
CMTA072  EQU   0
NCSUSSRU EQU   0
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
NMERRCD  EQU   MLCNAME
@NM00003 EQU   MLCNAME
SRTERRNM EQU   @NM00003
SRTERRCD EQU   @NM00003+8
SAVOUT   EQU   MLCSAV3
SVBACKWD EQU   SAVOUT+4
LCPZTIE  EQU   LCPCID
LCPZSNAM EQU   LCPZTIE+8
RTRDNCBA EQU   ISTRTR+40
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
LCPZTRV4 EQU   LCPZSNAM+4
LCPZTRV1 EQU   LCPZSNAM
LCPZSNA  EQU   LCPZTIE+4
LCPZFMCA EQU   LCPZTIE
@NM00008 EQU   SAVOUT+8
@NM00007 EQU   SAVOUT
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTRV620 EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTIRM   EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRV607 EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
NCSRUITS EQU   NCSUSSRU+2
NCSRULEN EQU   NCSUSSRU
CRACHAIN EQU   ISTCRA+928
CRARSV02 EQU   ISTCRA+924
CRARSV01 EQU   ISTCRA+920
CRABFTBA EQU   CRABUFA
CRAMASK  EQU   CRASVC+64
CRAHSIZ  EQU   CRASVC+60
CRAASCRR EQU   CRASVC
CRAPROCR EQU   ISTCRA+312
CRAPSS   EQU   ISTCRA+160
CRARPH   EQU   ISTCRA+52
CRALAPTR EQU   CRABASIC+48
CRAL9PTR EQU   CRABASIC+44
CRAL8PTR EQU   CRABASIC+40
CRAL7PTR EQU   CRABASIC+36
CRAL6PTR EQU   CRABASIC+32
CRAL5PTR EQU   CRABASIC+28
CRAL4PTR EQU   CRABASIC+24
CRAL3PTR EQU   CRABASIC+20
CRAL1PTR EQU   CRABASIC+12
CRALEV01 EQU   CRALKACT+3
CRALEV02 EQU   CRALKACT+3
CRALEV03 EQU   CRALKACT+3
CRALEV04 EQU   CRALKACT+3
CRALEV05 EQU   CRALKACT+3
CRALEV06 EQU   CRALKACT+3
CRALEV07 EQU   CRALKACT+3
CRALEV08 EQU   CRALKACT+3
CRALEV09 EQU   CRALKACT+2
CRALEV10 EQU   CRALKACT+2
CRALEV11 EQU   CRALKACT+2
CRALEV12 EQU   CRALKACT+2
CRALEV13 EQU   CRALKACT+2
CRALEV14 EQU   CRALKACT+2
CRALEV15 EQU   CRALKACT+2
CRALEV16 EQU   CRALKACT+2
CRALEV17 EQU   CRALKACT+1
CRALEV18 EQU   CRALKACT+1
CRALEV19 EQU   CRALKACT+1
CRALEV20 EQU   CRALKACT+1
CRALEV21 EQU   CRALKACT+1
CRALEV22 EQU   CRALKACT+1
CRALEV23 EQU   CRALKACT+1
CRALEV24 EQU   CRALKACT+1
CRALEV25 EQU   CRALKACT
CRALEV26 EQU   CRALKACT
CRALEV27 EQU   CRALKACT
CRALEV28 EQU   CRALKACT
CRALEV29 EQU   CRALKACT
CRALEV30 EQU   CRALKACT
CRALEV31 EQU   CRALKACT
CRALEV32 EQU   CRALKACT
CRAFRR   EQU   CRAHDR+4
CRACRR   EQU   CRAHDR
@NM00073 EQU   ISTAPCRR+137
@NM00072 EQU   APC57FLG
APCNREL  EQU   APC57FLG
APCRECRA EQU   APC57FLG
@NM00071 EQU   APC54FLG
APCRLST  EQU   APC54FLG
APCPR153 EQU   APC53FLG
@NM00070 EQU   APC52FLG
APCWKF   EQU   APC52FLG
APCNWF   EQU   APC52FLG
APCRDQ   EQU   APC52FLG
APCQENQ  EQU   APC52FLG
APCSMSR  EQU   APC52FLG
APCCKRQ  EQU   APC52FLG
@NM00069 EQU   APC31FLG
APCSORT  EQU   APC31FLG
APCRESCH EQU   APC31FLG
APCTPXIT EQU   APC31FLG
APCSWTWD EQU   ISTAPCRR+128
APCSAV2  EQU   ISTAPCRR+124
APCSAV1  EQU   ISTAPCRR+120
APCRETCD EQU   APCCOMF+2
@NM00068 EQU   APCCOMF1+1
APCZLBER EQU   APCCOMF1
APCEXIT  EQU   APCCOMF1
APCRELR  EQU   APCCOMF1
APCIRB2  EQU   APCCOMF1
APCIRB1  EQU   APCCOMF1
APCSMCR  EQU   APCCOMF1
APCUETSK EQU   APCCOMF1
APCSSTSK EQU   APCCOMF1
APCESTAL EQU   APCSAVE
APCFRRPM EQU   ISTAPCRR+40
APCQWFO  EQU   ISTAPCRR+36
APCPABSV EQU   ISTAPCRR+32
APCRTRN  EQU   ISTAPCRR+28
APCTCBA  EQU   ISTAPCRR+24
APCPSTA  EQU   ISTAPCRR+20
@NM00067 EQU   APCRFLG+1
APC31R   EQU   APCRFLG
APC58R   EQU   APCRFLG
APC57R   EQU   APCRFLG
APC56R   EQU   APCRFLG
APC54R   EQU   APCRFLG
APC53R   EQU   APCRFLG
APC52R   EQU   APCRFLG
APC51R   EQU   APCRFLG
@NM00066 EQU   APCATFLG+1
APC31E   EQU   APCATFLG
APC58E   EQU   APCATFLG
APC57E   EQU   APCATFLG
APC56E   EQU   APCATFLG
APC54E   EQU   APCATFLG
APC53E   EQU   APCATFLG
APC52E   EQU   APCATFLG
APC51E   EQU   APCATFLG
APCHDRSV EQU   ISTAPCRR
ASCPSREG EQU   ISTASCRR+44
ASCUSR01 EQU   ASCUSRGS+12
ASCUSR00 EQU   ASCUSRGS+8
ASCUSR15 EQU   ASCUSRGS+4
ASCUSR14 EQU   ASCUSRGS
ASCETRYA EQU   ISTASCRR+24
ASCKEY   EQU   ISTASCRR+23
ASCAUDIT EQU   ASCFLG3
ASCFBDUD EQU   ASCFLG3
ASCLLKF  EQU   ASCFLG3
ASCKEYF  EQU   ASCFLG3
ASCFBDAL EQU   ASCFLG3
ASCFSRGT EQU   ASCFLG3
ASCICR   EQU   ASCFLG2
ASCFSRIC EQU   ASCFLG2
ASCFBDIC EQU   ASCFLG2
ASCFBAIC EQU   ASCFLG2
ASCPASTR EQU   ASCFLG1
ASCFSR   EQU   ASCFLG1
ASCFBD   EQU   ASCFLG1
ASCFBA   EQU   ASCFLG1
ASCPFCRR EQU   ISTASCRR
ZCRRU    EQU   ZCRRHRU+3
ZCRRH    EQU   ZCRRHRU
ZCRWORDA EQU   ISTZCRR+477
ZCRCMNRC EQU   ISTZCRR+476
ZCRRSV97 EQU   ZCRENTER+18
ZCREIC2B EQU   ZCRENTER+18
ZCREAC2B EQU   ZCRENTER+18
ZCRELCAB EQU   ZCRENTER+18
ZCREDCMF EQU   ZCRENTER+18
ZCREBCIF EQU   ZCRENTER+18
ZCREICSG EQU   ZCRENTER+18
ZCREDCK0 EQU   ZCRENTER+18
ZCRECFY0 EQU   ZCRENTER+17
ZCREKCCB EQU   ZCRENTER+17
ZCREDCNB EQU   ZCRENTER+17
ZCREICOE EQU   ZCRENTER+17
ZCREBCNB EQU   ZCRENTER+17
ZCREBC0L EQU   ZCRENTER+17
ZCREBCAL EQU   ZCRENTER+17
ZCREDCQR EQU   ZCRENTER+17
ZCREDCPR EQU   ZCRENTER+16
ZCREBCSB EQU   ZCRENTER+16
ZCREAC1R EQU   ZCRENTER+16
ZCRECCCI EQU   ZCRENTER+16
ZCRECCAI EQU   ZCRENTER+16
ZCRECCBI EQU   ZCRENTER+16
ZCREBCAR EQU   ZCRENTER+16
ZCREBCDR EQU   ZCRENTER+16
ZCREBCBR EQU   ZCRENTER+15
ZCREDCXR EQU   ZCRENTER+15
ZCREDCWB EQU   ZCRENTER+15
ZCREDCWR EQU   ZCRENTER+15
ZCREKCCN EQU   ZCRENTER+15
ZCREKCBN EQU   ZCRENTER+15
ZCREKCBB EQU   ZCRENTER+15
ZCREJC0B EQU   ZCRENTER+15
ZCREJCDB EQU   ZCRENTER+14
ZCREJCCB EQU   ZCRENTER+14
ZCREJCBB EQU   ZCRENTER+14
ZCREJCAB EQU   ZCRENTER+14
ZCREIC1B EQU   ZCRENTER+14
ZCREIC0B EQU   ZCRENTER+14
ZCREICX0 EQU   ZCRENTER+14
ZCREICWB EQU   ZCRENTER+14
ZCREICVB EQU   ZCRENTER+13
ZCREICUB EQU   ZCRENTER+13
ZCREICTB EQU   ZCRENTER+13
ZCREICSC EQU   ZCRENTER+13
ZCREICSB EQU   ZCRENTER+13
ZCREICRB EQU   ZCRENTER+13
ZCREICQB EQU   ZCRENTER+13
ZCREICQA EQU   ZCRENTER+13
ZCREICOB EQU   ZCRENTER+12
ZCREICOA EQU   ZCRENTER+12
ZCREICNB EQU   ZCRENTER+12
ZCREICNA EQU   ZCRENTER+12
ZCREICMB EQU   ZCRENTER+12
ZCREICLB EQU   ZCRENTER+12
ZCREICKG EQU   ZCRENTER+12
ZCREICKE EQU   ZCRENTER+12
ZCREICKB EQU   ZCRENTER+11
ZCREICJB EQU   ZCRENTER+11
ZCREICID EQU   ZCRENTER+11
ZCREICIB EQU   ZCRENTER+11
ZCREICHB EQU   ZCRENTER+11
ZCREICGB EQU   ZCRENTER+11
ZCREICEB EQU   ZCRENTER+11
ZCREICDB EQU   ZCRENTER+11
ZCREICCI EQU   ZCRENTER+10
ZCREICCB EQU   ZCRENTER+10
ZCREICBI EQU   ZCRENTER+10
ZCREICBB EQU   ZCRENTER+10
ZCREICAB EQU   ZCRENTER+10
ZCREICAA EQU   ZCRENTER+10
ZCREHCAN EQU   ZCRENTER+10
ZCREGC0B EQU   ZCRENTER+10
ZCREGC0A EQU   ZCRENTER+9
ZCREGCLA EQU   ZCRENTER+9
ZCREGCEB EQU   ZCRENTER+9
ZCREGCDB EQU   ZCRENTER+9
@NM00065 EQU   ZCRENTER+9
ZCREGCBB EQU   ZCRENTER+9
ZCREGCAB EQU   ZCRENTER+9
ZCREFCEB EQU   ZCRENTER+9
ZCREFCEA EQU   ZCRENTER+8
ZCREECTA EQU   ZCRENTER+8
ZCREECEA EQU   ZCRENTER+8
ZCREECDA EQU   ZCRENTER+8
ZCREECCB EQU   ZCRENTER+8
ZCREECCA EQU   ZCRENTER+8
ZCREECBB EQU   ZCRENTER+8
ZCREECBA EQU   ZCRENTER+8
ZCREDCMB EQU   ZCRENTER+7
ZCREDCL0 EQU   ZCRENTER+7
ZCREDCKB EQU   ZCRENTER+7
ZCREDCKA EQU   ZCRENTER+7
ZCREDCJ0 EQU   ZCRENTER+7
ZCREDCI0 EQU   ZCRENTER+7
ZCREDCH0 EQU   ZCRENTER+7
ZCREDCF0 EQU   ZCRENTER+7
ZCREDCE0 EQU   ZCRENTER+6
ZCREDCD0 EQU   ZCRENTER+6
ZCREDCC0 EQU   ZCRENTER+6
ZCREDCB0 EQU   ZCRENTER+6
ZCREDCA0 EQU   ZCRENTER+6
ZCRECC2B EQU   ZCRENTER+6
ZCRECC1B EQU   ZCRENTER+6
ZCRECC1A EQU   ZCRENTER+6
ZCRECC0B EQU   ZCRENTER+5
ZCRECC0A EQU   ZCRENTER+5
ZCREBC0B EQU   ZCRENTER+5
ZCREBC0A EQU   ZCRENTER+5
ZCREBCZ0 EQU   ZCRENTER+5
ZCREBCY0 EQU   ZCRENTER+5
ZCREBCX0 EQU   ZCRENTER+5
ZCREBCXA EQU   ZCRENTER+5
ZCREBCSC EQU   ZCRENTER+4
ZCREBCRB EQU   ZCRENTER+4
ZCREBCRA EQU   ZCRENTER+4
ZCREBCQB EQU   ZCRENTER+4
ZCREBCPB EQU   ZCRENTER+4
ZCREBCOB EQU   ZCRENTER+4
ZCREBCNE EQU   ZCRENTER+4
ZCREBCND EQU   ZCRENTER+4
ZCREBCMB EQU   ZCRENTER+3
ZCREBCLB EQU   ZCRENTER+3
ZCREBCLA EQU   ZCRENTER+3
ZCREBCKB EQU   ZCRENTER+3
ZCREBCKA EQU   ZCRENTER+3
ZCREBCJB EQU   ZCRENTER+3
ZCREBCJA EQU   ZCRENTER+3
ZCREBCID EQU   ZCRENTER+3
ZCREBCIB EQU   ZCRENTER+2
ZCREBCIA EQU   ZCRENTER+2
ZCREBCHB EQU   ZCRENTER+2
ZCREBCHA EQU   ZCRENTER+2
ZCREBCGB EQU   ZCRENTER+2
ZCREBCGA EQU   ZCRENTER+2
ZCREBCFB EQU   ZCRENTER+2
ZCREBCFA EQU   ZCRENTER+2
ZCREBCEB EQU   ZCRENTER+1
ZCREBCDI EQU   ZCRENTER+1
ZCREBCCB EQU   ZCRENTER+1
ZCREBCBI EQU   ZCRENTER+1
ZCREBCBB EQU   ZCRENTER+1
ZCREBCBA EQU   ZCRENTER+1
ZCREBCAM EQU   ZCRENTER+1
ZCREBCAI EQU   ZCRENTER+1
ZCREBCAG EQU   ZCRENTER
ZCREBCAE EQU   ZCRENTER
ZCREBCAB EQU   ZCRENTER
ZCREBCAA EQU   ZCRENTER
ZCREAC1B EQU   ZCRENTER
ZCREAC0B EQU   ZCRENTER
ZCREAC0A EQU   ZCRENTER
ZCREAC1A EQU   ZCRENTER
ZCRTNAME EQU   ZCRAUDIT+1
ZCRTID   EQU   ZCRAUDIT
ZCRREMIC EQU   ISTZCRR+436
ZCRSAVEZ EQU   ISTZCRR+196
ZCRDAFSV EQU   ZCRCIDSV+2
ZCRSAFSV EQU   ZCRCIDSV
ZCRR13SV EQU   ISTZCRR+188
ZCRR2SV  EQU   ISTZCRR+184
ZCROPCDE EQU   ISTZCRR+183
ZCRPRMTC EQU   ISTZCRR+182
ZCRRCDSV EQU   ISTZCRR+181
ZCRAWQSW EQU   ISTZCRR+180
ZCRTOPQ  EQU   ISTZCRR+180
ZCRLSTFB EQU   ISTZCRR+180
ZCRXSCHD EQU   ISTZCRR+180
ZCRNXTEL EQU   ISTZCRR+180
ZCRSCANQ EQU   ISTZCRR+180
ZCRMOREL EQU   ISTZCRR+180
ZCRFBPRC EQU   ISTZCRR+180
ZCRFSBSV EQU   ISTZCRR+176
ZCRSVWK5 EQU   ZCRWKARA+16
ZCRSVWK4 EQU   ZCRWKARA+12
ZCRSVWK3 EQU   ZCRWKARA+8
ZCRSVWK2 EQU   ZCRWKARA+4
ZCRSVWK1 EQU   ZCRWKARA
ZCRSVF25 EQU   ZCRSVRTN+96
ZCRSVF24 EQU   ZCRSVRTN+92
ZCRSVF23 EQU   ZCRSVRTN+88
ZCRSVF22 EQU   ZCRSVRTN+84
ZCRSVF21 EQU   ZCRSVRTN+80
ZCRSVF20 EQU   ZCRSVRTN+76
ZCRSVF19 EQU   ZCRSVRTN+72
ZCRSVF18 EQU   ZCRSVRTN+68
ZCRSVF17 EQU   ZCRSVRTN+64
ZCRSVF16 EQU   ZCRSVRTN+60
ZCRSVF15 EQU   ZCRSVRTN+56
ZCRSVF14 EQU   ZCRSVRTN+52
ZCRSVF13 EQU   ZCRSVRTN+48
ZCRSVF12 EQU   ZCRSVRTN+44
ZCRSVF11 EQU   ZCRSVRTN+40
ZCRSVF10 EQU   ZCRSVRTN+36
ZCRSVF9  EQU   ZCRSVRTN+32
ZCRSVF8  EQU   ZCRSVRTN+28
ZCRSVF7  EQU   ZCRSVRTN+24
ZCRSVF6  EQU   ZCRSVRTN+20
ZCRSVF5  EQU   ZCRSVRTN+16
ZCRSVF4  EQU   ZCRSVRTN+12
ZCRSVF3  EQU   ZCRSVRTN+8
ZCRSVF2  EQU   ZCRSVRTN+4
ZCRSVF1  EQU   ZCRSVRTN
ZCRPVZB  EQU   ISTZCRR+52
ZCRZLB   EQU   ISTZCRR+48
ZCRBFPTR EQU   ISTZCRR+44
ZCRCCWA  EQU   ISTZCRR+40
ZCRPSW   EQU   ZCRPARMS+15
ZCRPCHAR EQU   ZCRPARMS+14
ZCRPRES2 EQU   ZCRPCOD2
ZCRPMFGF EQU   ZCRPCOD2
ZCRPFHDR EQU   ZCRPCOD2
ZCRPPG2  EQU   ZCRPCOD2
ZCRPRES  EQU   ZCRPCOD1
ZCRPCFTX EQU   ZCRPCOD1
ZCRPBUF  EQU   ZCRPCOD1
ZCRPLSCB EQU   ZCRPCOD1
ZCRPLSBQ EQU   ZCRPLSBF
ZCRPFSB  EQU   ZCRPCOD1
ZCRPLNG  EQU   ZCRPCOD1
ZCRPPG   EQU   ZCRPCOD1
ZCRDTODA EQU   ZCRDFRDA
ZCRMLNG  EQU   ZCRPARMS+8
ZCRTBPTR EQU   ZCRPARMS+4
ZCRCBPTR EQU   ZCRFBPTR
ZCRCRLCP EQU   ISTZCRR+20
@NM00064 EQU   ZCRSCPSW
ZCRSKIPT EQU   ZCRSCPSW
ZCRFSBWE EQU   ZCRSCPSW
ZCRPRCMP EQU   ZCRSCPSW
ZCRLREQ  EQU   ZCRSCPSW
ZCRRJLCP EQU   ZCRSCPSW
ZCRTPINV EQU   ZCRSCPSW
ZCRTPEX  EQU   ZCRSCPSW
@NM00063 EQU   ZCRIBPR
ZCR3270R EQU   ZCRIBPR
ZCR3270  EQU   ZCRIBPR
ZCRLCPFD EQU   ZCRIBPR
ZCRLCPFR EQU   ZCRIBPR
ZCRRELK  EQU   ZCRIBPR
ZCRERR   EQU   ZCRIBPR
ZCRNOBUF EQU   ZCRIBPR
@NM00062 EQU   ZCRPFLGS
ZCRQAHED EQU   ZCRPFLGS
ZCRF1RES EQU   ZCRGENSW
ZCRBRIS  EQU   ZCRGENSW
ZCRCLRBD EQU   ZCRGENSW
ZCREXRES EQU   ZCRGENSW
ZCRLCSYN EQU   ZCRGENSW
ZCRRT06  EQU   ZCRGENSW
ZCRTSW2  EQU   ZCRGENSW
ZCRTSW1  EQU   ZCRGENSW
ZCRINLCP EQU   ZCRFLGS3
ZCRWRPTR EQU   ZCRFLGS3
ZCRNOFRE EQU   ZCRFLGS3
ZCREDRIV EQU   ZCRFLGS3
ZCRDISC  EQU   ZCRFLGS3
ZCRTPDIS EQU   ZCRFLGS3
ZCRTPCON EQU   ZCRFLGS3
ZCRTIC   EQU   ZCRFLGS3
ZCRCNLXL EQU   ZCRRESET
ZCRENDAN EQU   ZCRSWFLD
ZCRENDXL EQU   ZCRSWFLD
ZCRENDX  EQU   ZCRSWFLD
ZCROB1   EQU   ZCRNDLCP
ZCRENDPR EQU   ZCRSWFLD
ZCREXTYP EQU   ZCRSWFLD
ZCRSLCP  EQU   ZCRENDSH
ZCRIF0E3 EQU   ZCRFLGS2
ZCRIF0E2 EQU   ZCRFLGS2
ZCRIF0E1 EQU   ZCRFLGS2
ZCROB    EQU   ZCRFLGS2
ZCRFMSED EQU   ZCRFLGS2
ZCRSHEDI EQU   ZCRFLGS2
ZCRLOCAL EQU   ZCRFLGS2
ZCRFEXIT EQU   ZCRFLGS1
ZCRUNSOL EQU   ZCRFLGS1
ZCRENDLP EQU   ZCRFLGS1
ZCRNRMEX EQU   ZCRFLGS1
ZCRWAIT  EQU   ZCRFLGS1
ZCRDEQSW EQU   ZCRFLGS1
ZCRQUESW EQU   ZCRFLGS1
ZCREXSW  EQU   ZCRFLGS1
ZCRFRRA  EQU   ISTZCRR+8
ZCRCHAIN EQU   ISTZCRR+4
ZCRFLAG  EQU   ZCRCRR+3
ZCRLEN   EQU   ZCRCRR+1
ZCRID    EQU   ZCRCRR
CCFRSVD1 EQU   CFCCRT
CCFCR2   EQU   CFCCRT
CCFCRP   EQU   CFCCRT
CCFCR1   EQU   CFCCRT
CCFCS2   EQU   CFCCRT
CCFCS1   EQU   CFCCRT
NCFRSVD  EQU   CFCNTRD
NCFCR2   EQU   CFCNTRD
NCFCRP   EQU   CFCNTRD
NCFCR1   EQU   CFCNTRD
NCFCS2   EQU   CFCNTRD
NCFCS1   EQU   CFCNTRD
PFCRSV01 EQU   ISTPFCRR+13
PFCFTA   EQU   ISTPFCRR+12
CRRFRR   EQU   PFCFRRO
CRRCHAIN EQU   PFCCRRO
CRRLEN   EQU   PFCCRRLN
PFCRSV10 EQU   PFCCRR+1
CRRID    EQU   PFCCRRID
ZSAZTRAC EQU   ISTZSAVE+36
ZSAZSVVR EQU   ISTZSAVE+12
ZSAZSVRR EQU   ISTZSAVE+8
ZSAZSVFC EQU   ISTZSAVE+4
ZSAZACTV EQU   ZSAZSVMS
LCPFTYPE EQU   LCPRPHA
LCPRSTQH EQU   LCPLCCW
LCPCLREP EQU   ISTLCPB+44
LCPUBFSB EQU   LCPFLCCW
LCPRSV77 EQU   ISTLCPB+39
LCPLCCWC EQU   ISTLCPB+38
LCPRSV78 EQU   LCPFLG1
LCPTRANS EQU   LCPFLG1
LCPSTLB  EQU   LCPFLG1
LCPREDRV EQU   LCPFLG1
LCPDIRPT EQU   LCPFLG1
LCPINTER EQU   LCPFLG1
LCPRESET EQU   LCPFLG1
LCPSTYPE EQU   ISTLCPB+36
LCPFSNCH EQU   ISTLCPB+34
LCPFOSN  EQU   ISTLCPB+32
LCPTLBAD EQU   ISTLCPB+28
LCPFDB2  EQU   LCPFDBA+1
LCPFDB1  EQU   LCPFDBA
LCPNXLCW EQU   ISTLCPB+20
LCPDAF   EQU   LCPCID+2
LCPSAF   EQU   LCPCID
LCPLCCW1 EQU   ISTLCPB+12
LCPRRCNT EQU   LCPSEQ+1
LCPRRCCT EQU   LCPSEQ
LCPATOP  EQU   LCPFLAG2
LCPFREE  EQU   LCPFLAG2
LCPDSTAT EQU   LCPFLAG2
LCPEXRES EQU   LCPFID0
LCPZRIMM EQU   LCPTLBPI
LCPRSTRT EQU   LCPFLAG2
LCPASYN  EQU   LCPFLAG2
LCPPRFLG EQU   LCPFLAG2
LCPZMIRC EQU   LCPRUCNT
LCPCHAI2 EQU   LCPCHAIN+1
LCPCHNG  EQU   LCPCHAI1
LCPZRT0B EQU   LCPMNRCD
LCPZRT0A EQU   LCPMNRCD
LCPZRTL9 EQU   LCPZRT09
LCPZRTL8 EQU   LCPZRT08
LCPZRTL7 EQU   LCPZRT07
LCPZRTL6 EQU   LCPZRT06
LCPZRTL5 EQU   LCPZRT05
LCPZRTL4 EQU   LCPZRT04
LCPZRTL3 EQU   LCPZRT03
LCPZRTL2 EQU   LCPZRT02
LCPZRT01 EQU   LCPFLAGS
LCPZRT00 EQU   LCPFLAGS
LCPLNGTH EQU   ISTLCPB+1
LCPTYPE  EQU   ISTLCPB
LCCWDATA EQU   ISTLCCW+4
LCCWCNT  EQU   ISTLCCW+2
LCCWACI  EQU   LCCWFLAG
LCCWRFI  EQU   LCCWFLAG
LCCWPER  EQU   LCCWLSI
LCCWIDAT EQU   LCCWFLAG
LCCWNTVC EQU   LCCWFLAG
LCCWCKPT EQU   LCCWFLAG
LCCWCC   EQU   LCCWFLAG
LCCWCD   EQU   LCCWFLAG
LCCWTYPE EQU   LCCWCTL
LCCWMODE EQU   LCCWCTL
LCCWSOP  EQU   LCCWRWOP
@NM00061 EQU   LCCWRWOP
LCCWSD   EQU   LCCWOP
LCCWSI   EQU   LCCWOP
MLCASAV  EQU   SAVIN+40
CONFTSAV EQU   SAVIN+36
ATCVTSAV EQU   SAVIN+32
@NM00006 EQU   SAVIN+28
NCSPLSAV EQU   SAVIN+24
@NM00005 EQU   SAVIN+12
@NM00004 EQU   SAVIN
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00002 EQU   CVTFIX+248
@NM00001 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTSHSB  EQU   CVTSHS
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
CONUESBF EQU   ISTCONFT+1362
CONSTVAR EQU   CONSTAID+1
CONSTFIL EQU   CONSTAID
CONBLKNO EQU   CONSCPID+2
CONFILL  EQU   CONSCPID+1
CONFCNL  EQU   CONSCPID
CONF01SV EQU   ISTCONFT+1352
CONSDMLC EQU   ISTCONFT+1348
CONSDECB EQU   ISTCONFT+1344
CONRVPT1 EQU   ISTCONFT+1341
CONGLBBH EQU   ISTCONFT+1340
CONRSV24 EQU   ISTCONFT+1312
CONFTTAT EQU   ISTCONFT+1284
CONFXXAT EQU   ISTCONFT+1256
CONFLDAT EQU   ISTCONFT+1228
CONFTRAT EQU   ISTCONFT+1200
CONFNSAT EQU   ISTCONFT+1172
CONCSCB  EQU   ISTCONFT+1168
CONRSV50 EQU   ISTCONFT+1166
CONLIST  EQU   ISTCONFT+1164
CONSTAFP EQU   ISTCONFT+1160
CONECDET EQU   ISTCONFT+1156
CONRECON EQU   ISTCONFT+1036
CONNTSOL EQU   ISTCONFT+916
CONTRACE EQU   ISTCONFT+796
CONTOLTP EQU   ISTCONFT+676
CONVVTAM EQU   ISTCONFT+556
CONVTHDR EQU   ISTCONFT+420
CONRSV01 EQU   ISTCONFT+417
CONNSNEC EQU   CONFLG01
CONFTPSA EQU   CONFLG01
CONFTTA  EQU   CONFLG01
CONFTNSA EQU   CONFLG01
CONFTNAC EQU   CONFLG01
CONFTEXS EQU   CONFLG01
CONFTTMR EQU   CONFLG01
CONFTSTM EQU   CONFLG01
CONCRPLD EQU   ISTCONFT+404
CONPPDBF EQU   ISTCONFT+392
CONNPDBF EQU   ISTCONFT+380
CONAPDBF EQU   ISTCONFT+368
CONWPDBF EQU   ISTCONFT+356
CONIODBF EQU   ISTCONFT+344
CONUEDBF EQU   ISTCONFT+332
CONVPDBF EQU   ISTCONFT+320
CONVFDBF EQU   ISTCONFT+308
CONLPDBF EQU   ISTCONFT+296
CONLFDBF EQU   ISTCONFT+284
CONSPDBF EQU   ISTCONFT+272
CONSFDBF EQU   ISTCONFT+260
CONCRPLS EQU   ISTCONFT+248
CONPPSBF EQU   ISTCONFT+236
CONNPSBF EQU   ISTCONFT+224
CONAPSBF EQU   ISTCONFT+212
CONWPSBF EQU   ISTCONFT+200
CONIOSBF EQU   ISTCONFT+188
CONVPSBF EQU   ISTCONFT+176
CONVFSBF EQU   ISTCONFT+164
CONLPSBF EQU   ISTCONFT+152
CONLFSBF EQU   ISTCONFT+140
CONSPSBF EQU   ISTCONFT+128
CONSFSBF EQU   ISTCONFT+116
CONRSV17 EQU   ISTCONFT+115
CONCRPL  EQU   CONBUFF+1
CONPPEX  EQU   CONBUFF+1
CONNPEX  EQU   CONBUFF+1
CONAPEX  EQU   CONBUFF+1
CONWPEX  EQU   CONBUFF+1
CONIOEX  EQU   CONBUFF
CONUECB  EQU   CONBUFF
CONVPEX  EQU   CONBUFF
CONVFEX  EQU   CONBUFF
CONLPEX  EQU   CONBUFF
CONLFEX  EQU   CONBUFF
CONSPEX  EQU   CONBUFF
CONSFEX  EQU   CONBUFF
CONACTV  EQU   CONSTAT
CONVRYIN EQU   CONSTAT
CONLODED EQU   CONSTAT
CONDSOPN EQU   CONSTAT
CONSTOR  EQU   CONSTAT
@NM00060 EQU   CONSTAT
@NM00059 EQU   CONSTAT
@NM00058 EQU   CONSTAT
CONIOTR  EQU   CONOPTFL
CONMODTR EQU   CONOPTFL
CONBTUTR EQU   CONOPTFL
CONBUFTR EQU   CONOPTFL
@NM00057 EQU   CONOPTFL
@NM00056 EQU   CONOPTFL
@NM00055 EQU   CONOPTFL
CONWRMST EQU   CONOPTFL
CONSYLST EQU   CONDSFLG
CONSYLIB EQU   CONDSFLG
CONSYOBJ EQU   CONDSFLG
@NM00054 EQU   CONDSFLG
@NM00053 EQU   CONDSFLG
@NM00052 EQU   CONDSFLG
CONMODFY EQU   ISTCONFT+109
CONDISPL EQU   ISTCONFT+108
CONVARY  EQU   ISTCONFT+107
CONHLTS  EQU   CONHALT
CONHLTQ  EQU   CONHALT
CONLAST  EQU   ISTCONFT+105
CONRES2  EQU   ISTCONFT+104
CONCID   EQU   ISTCONFT+102
CONBUFSZ EQU   ISTCONFT+100
CONRSV02 EQU   ISTCONFT+96
CONDCBBA EQU   ISTCONFT+92
CONDCBLA EQU   ISTCONFT+88
CONDCBOA EQU   ISTCONFT+84
CONLDPRM EQU   ISTCONFT+80
CONRDBUF EQU   ISTCONFT+76
CONSTCIB EQU   ISTCONFT+72
CONENDLA EQU   ISTCONFT+68
CONVARLA EQU   ISTCONFT+64
CONMODLA EQU   ISTCONFT+60
CONHLTLA EQU   ISTCONFT+56
CONNCSLA EQU   ISTCONFT+52
CONDISLA EQU   ISTCONFT+48
CONCIBAD EQU   ISTCONFT+44
CONACB   EQU   ISTCONFT+40
CONFBPNM EQU   ISTCONFT+32
CONDMNM  EQU   ISTCONFT+24
CONAPSNM EQU   ISTCONFT+16
CONAPINM EQU   ISTCONFT+8
CONCONFG EQU   ISTCONFT
LDPTCEP  EQU   ISTLDPRM+24
LDPRSV02 EQU   ISTLDPRM+22
LDPRSV01 EQU   LDPFB2
LDPACTIF EQU   LDPFB2
LDPATACH EQU   LDPFB2
LDPFLAST EQU   LDPFB2
LDPRSV03 EQU   LDPFG
LDPPB    EQU   LDPFG
LDPFX    EQU   LDPFG
LDPDCBA  EQU   ISTLDPRM+16
LDPPDS   EQU   ISTLDPRM+8
LDPMBR   EQU   ISTLDPRM
DIVRSV01 EQU   ISTDIVTH+6
DIVNUMFE EQU   ISTDIVTH+2
DVEBSCLN EQU   DVEBSCID
MLCSTOWL EQU   MLCDECB2
MLCDECB1 EQU   MLCTPMSG
MLCLDPRM EQU   MLCRDPRM
MLCACPRM EQU   MLCOCPRM
MLCDCB   EQU   MLCWRK1
MLCMHDAT EQU   ISTMLCA+908
MLCERDAT EQU   ISTMLCA+852
MLCERSAV EQU   ISTMLCA+780
MLCARDAT EQU   MLCADDAT
MLCARSAV EQU   MLCADSAV
MLCDAT4  EQU   ISTMLCA+596
MLCSAV4  EQU   ISTMLCA+524
MLCDAT2  EQU   ISTMLCA+340
MLCSAV2  EQU   ISTMLCA+268
MLCDAT1  EQU   ISTMLCA+212
MLCSAV1  EQU   ISTMLCA+140
@NM00051 EQU   ISTMLCA+136
MLCLENT  EQU   MLCPTRS+32
MLCPTR7  EQU   MLCPTRS+28
MLCPTR6  EQU   MLCPTRS+24
MLCPTR4  EQU   MLCPTRS+16
MLCGETSZ EQU   ISTMLCA+92
MLCFIII  EQU   MLCERBF3+8
MLCCNFG2 EQU   MLCERBF3
MLCFII   EQU   MLCERBF2+16
MLCMACRO EQU   MLCERBF2+8
MLCCONFG EQU   MLCERBF1
MLCKWD   EQU   ISTMLCA+24
MLCENT   EQU   ISTMLCA+20
MLCSKDCB EQU   ISTMLCA+12
MLCSECCA EQU   ISTMLCA
SNTRSVFG EQU   SNTFLAG
SNTSNTFG EQU   SNTFLAG
SNTRSRVD EQU   ISTSNT+4
PATRSV01 EQU   PATFLAGA
PATUSEFG EQU   PATFLAGA
PATRDCNT EQU   ISTPAT+6
PATGRPID EQU   ISTPAT+5
PATPTHID EQU   ISTPAT+4
PATDINDX EQU   ISTPAT+2
PATGINDX EQU   ISTPAT
GNTGRPNM EQU   ISTGNT
DNTTELNO EQU   ISTDNT+1
DNTCTDIG EQU   ISTDNT
RLSRSV02 EQU   ISTRLS+140
RLSRSV01 EQU   ISTRLS+138
RLSCTELU EQU   ISTRLS+136
RLSPRE   EQU   ISTRLS
RDARSVPT EQU   ISTRDA+84
RDAPUBI  EQU   ISTRDA+83
RDADFCUA EQU   ISTRDA+80
RDACTPCC EQU   ISTRDA+79
RDADACUA EQU   ISTRDA+76
RDALUBA  EQU   RDAUCBAD+1
RDACHQI  EQU   RDAUCBAD
RDARSV01 EQU   RDAFLAG
RDARBISA EQU   RDAFLAG
RDAPRE   EQU   ISTRDA
RSWRSV01 EQU   ISTRSW+152
RSWRSV02 EQU   ISTRSW+150
RSWCTELU EQU   ISTRSW+148
RSWGRUPZ EQU   ISTRSW+146
RSWDIALZ EQU   ISTRSW+144
RSWPRE   EQU   ISTRSW
RLXRSV03 EQU   ISTRLX+80
RLXRSV02 EQU   ISTRLX+77
RLXRSV01 EQU   RLXFLAGA
RLXINUSE EQU   RLXFLAGA
RLXNLUX  EQU   ISTRLX+72
RLXPRE   EQU   ISTRLX
RPXRSV01 EQU   ISTRPX+80
RPXRSV02 EQU   ISTRPX+77
RPXMAXLU EQU   ISTRPX+76
RPXFLUX  EQU   ISTRPX+72
RPXPRE   EQU   ISTRPX
RLURSV02 EQU   ISTRLU+172
RLULGMOD EQU   ISTRLU+164
RLUMODEP EQU   RLUMODET+8
RLUMODEN EQU   RLUMODET
RLUUSSPT EQU   RLUUSSTB+8
RLUUSSNM EQU   RLUUSSTB
RLURSV01 EQU   ISTRLU+137
RLULOCAD EQU   ISTRLU+136
RLUNCPPM EQU   RLUNCPPC+1
RLUNCPPN EQU   RLUNCPPC
RLUPACEM EQU   RLUPACE+1
RLUPACEN EQU   RLUPACE
RLUINTA  EQU   ISTRLU+128
RLUSSCFM EQU   ISTRLU+127
RLUCRRSV EQU   RLUCRFLG
RLUACTLU EQU   RLUCRFLG
RLURSV00 EQU   RLUFLAG
RLUNDSES EQU   RLUFLAG
RLUGSTAT EQU   RLUFLAG
RLUBATCH EQU   RLUFLAG
RLURBISA EQU   RLUFLAG
RLUTYPE  EQU   ISTRLU+124
RLUCRPR  EQU   ISTRLU
RCCRVPT2 EQU   ISTRCC+144
RCCXTOSW EQU   ISTRCC+140
RCCSWTOX EQU   ISTRCC+136
RCCRSPT2 EQU   ISTRCC+133
RCCADDR  EQU   ISTRCC+132
RCCPASSL EQU   ISTRCC+131
RCCMXOUT EQU   ISTRCC+130
RCCMXDAT EQU   ISTRCC+128
RCCINDEX EQU   ISTRCC+126
RCCPATHZ EQU   ISTRCC+124
RCCDPQ   EQU   ISTRCC+116
RCCTPAB  EQU   ISTRCC+112
RCCRSV02 EQU   ISTRCC+109
RCCCRRSV EQU   RCCCRFLG
RCCCTCFL EQU   RCCCRFLG
RCCACTPU EQU   RCCCRFLG
RCCNCSPL EQU   ISTRCC+104
RCCRPHCN EQU   ISTRCC+100
RCCEPAB  EQU   ISTRCC+96
RCCDPAB  EQU   ISTRCC+92
RCCVPAB  EQU   ISTRCC+88
@NM00050 EQU   ISTRCC+87
RCCSESCT EQU   ISTRCC+86
RCCIDNUM EQU   RCCID48+3
RCCIDBLK EQU   RCCID48+2
RCCIDPA2 EQU   RCCID48+1
RCCIDPUT EQU   RCCID48
RCCIDPA1 EQU   RCCSTAID
RCCCTELU EQU   ISTRCC+76
RCCCNCNT EQU   ISTRCC+75
RCCRTGOH EQU   RCCFLAGB
RCCBRKCN EQU   RCCFLAGB
RCCRESET EQU   RCCFLAGB
RCCFINAL EQU   RCCFLAGB
RCCBNNSP EQU   RCCFLAGB
RCCIRETR EQU   RCCFLAGB
RCCDIALP EQU   RCCFLAGB
RCCDSTCT EQU   RCCFLAGB
RCCCTPGD EQU   RCCFLAG
RCCPRGDN EQU   RCCFLAG
RCCOUERP EQU   RCCFLAG
RCCOHIMM EQU   RCCFLAG
RCCLDISC EQU   RCCFLAG
RCCERPIP EQU   RCCFLAG
RCCCUDIE EQU   RCCFLAG
RCCRBISA EQU   RCCFLAG
RCCTYPE  EQU   ISTRCC+72
RCCPRE   EQU   ISTRCC
RDSCTATR EQU   ISTRDS+74
RDSPRE   EQU   ISTRDS
RINRSV05 EQU   ISTRIN+156
RINRSV04 EQU   ISTRIN+152
RINRSV02 EQU   ISTRIN+145
RTRCNCNT EQU   RINCNCNT
RTRNCSPL EQU   RINNCSPL
RTRRPHCN EQU   RINRPHCN
RTRVPAB  EQU   RINVPAB
RTRREMOT EQU   RINREMOT
RTRRLDAF EQU   RINRLDAF
RTRNODID EQU   RINNODID
RINRSV01 EQU   RINDFD
RTRLDISC EQU   RINLDISC
RTRNODEF EQU   RINNODEF
RTRREMPO EQU   RINREMPO
RINCRPRE EQU   ISTRIN
RTRRSV04 EQU   ISTRTR+210
RTRLCTI  EQU   ISTRTR+209
RTRIDCAS EQU   RTRBSCID+1
RTRIDLEN EQU   RTRBSCID
RTRRSVDD EQU   ISTRTR+181
RTRRDFG  EQU   ISTRTR+180
RTRCADDR EQU   ISTRTR+164
RTRCTADR EQU   ISTRTR+162
RTRCTPOL EQU   ISTRTR+160
RTRCTDIA EQU   ISTRTR+158
RTRRSV03 EQU   ISTRTR+156
RTRRVPT1 EQU   ISTRTR+152
RTRBHSN1 EQU   ISTRTR+144
RTRCRSV2 EQU   RTRCRFLG
RTRDTRLM EQU   RTRLSCMD
RTRCRSV1 EQU   RTRCRFLG
RTRTRMAX EQU   ISTRTR+142
RTRRSV24 EQU   RTRRDFF
RTRRFDEK EQU   RTRRDFF
RTRRFANK EQU   RTRRDFF
RTRRFPFK EQU   RTRRDFF
RTRRFPEN EQU   RTRRDFF
RTRRFXCT EQU   RTRRDFF
RTRRESCT EQU   RTRRDFE
RTRRESUP EQU   RTRRDFE
RTRREATT EQU   RTRRDFE
RTRRECHK EQU   RTRRDFE
RTRREACR EQU   RTRRDFE
RTRRSV0A EQU   RTRRDFE
RTRREBRK EQU   RTRRDFE
RTRRSV11 EQU   RTRRDFD
RTRRSV10 EQU   RTRRDFD
RTRRDBHI EQU   RTRRDFD
RTRRDBHD EQU   RTRRDFD
RTRRDBHN EQU   RTRRDFD
RTRRSV23 EQU   RTRRDFC
RTRRCXMS EQU   RTRRDFC
RTRRCMSG EQU   RTRRDFC
RTRRCBLK EQU   RTRRDFC
RTRRCPT3 EQU   RTRRDFC
RTRRCIT2 EQU   RTRRDFC
RTRRCIT1 EQU   RTRRDFC
RTRRSV32 EQU   RTRRDFB
RTRRBEND EQU   RTRRDFB
RTRRBECT EQU   RTRRDFB
RTRRSV02 EQU   RTRRDFA
RTRRACTR EQU   RTRRDFA
RTRRSV60 EQU   RTRRDFA
RTRRACDT EQU   RTRRDFA
RTRRAPT3 EQU   RTRRAALL
RTRRAPT2 EQU   RTRRAALL
RTRRAPT1 EQU   RTRRAALL
RTRRAATN EQU   RTRRDFA
RTRRSV45 EQU   ISTRTR+132
RTRRSV01 EQU   ISTRTR+130
RTRCTECM EQU   ISTRTR+128
RTRADRPT EQU   RTRADR+1
RTRRSV22 EQU   RTRFLAG
RTRRSV51 EQU   RTRFLAG
RTRRBISA EQU   RTRFLAG
RTRRSV21 EQU   RTRFLAG
RTRCRPR  EQU   ISTRTR
RCLRVPT2 EQU   ISTRCL+92
RCLRVPT1 EQU   ISTRCL+88
RCLCTNGP EQU   ISTRCL+82
RCLRSV01 EQU   ISTRCL+80
RCLCTECM EQU   ISTRCL+78
RCLCTETR EQU   ISTRCL+76
RCLGPADR EQU   RCLADR+1
RCLRSV33 EQU   RCLFLAG
RCLBATCH EQU   RCLFLAG
RCLRBISA EQU   RCLFLAG
RCLRSV22 EQU   RCLFLAG
RCLPRE   EQU   ISTRCL
RPTRSV03 EQU   ISTRPT+156
RPTRSV02 EQU   ISTRPT+152
RPTNSNSV EQU   ISTRPT+148
RPTPTHCT EQU   ISTRPT+146
RPTPEPCT EQU   ISTRPT+144
RPTDAFSV EQU   ISTRPT+142
RPTRSV01 EQU   ISTRPT+141
RPTISTAT EQU   RPTFLAG1
RPTDYNAM EQU   RPTFLAG1
RPTVYIMM EQU   RPTFLAG1
RPTVIODN EQU   RPTFLAG1
RPTONLIN EQU   RPTFLAG1
RPTHLVPD EQU   RPTFLAG1
RPTVRYPD EQU   RPTFLAG1
RPTASLEP EQU   RPTFLAG1
RPTATERM EQU   ISTRPT+132
RPTDIVT  EQU   RPTDITT
RPTLNDAF EQU   RPTLNCID+2
RPTLNSAF EQU   RPTLNCID
RPTLN    EQU   ISTRPT
RLNRVPT2 EQU   ISTRLN+112
RLNNCSPL EQU   ISTRLN+108
RLNX2SW  EQU   ISTRLN+104
@NM00049 EQU   ISTRLN+103
RLNCRRSV EQU   RLNCRFLG
RLNSWEP  EQU   RLNCRFLG
RLNSVSKP EQU   RLNLSCMD
RLNSESLM EQU   RLNLSCMD
RLNNPRLM EQU   RLNLSCMD
RLNSWNCP EQU   RLNCRFLG
RLNACTLN EQU   RLNCRFLG
RLNPAUSE EQU   ISTRLN+101
RLNPOLMT EQU   ISTRLN+100
RLNACTSN EQU   ISTRLN+98
RLNRESV1 EQU   ISTRLN+97
RLNACTRM EQU   ISTRLN+96
RLNCTSES EQU   ISTRLN+95
RLNRDSLM EQU   ISTRLN+94
RLNAUTOA EQU   ISTRLN+92
RLNRDFD  EQU   RLNRDF+3
RLNRDFC  EQU   RLNRDF+2
RLNMULTP EQU   RLNRDFB
RLNRATRN EQU   RLNRDFB
RLNRAPOL EQU   RLNRDFB
RLNRSV0B EQU   RLNRDFB
RLNAUTOD EQU   RLNRDFB
RLNANSWR EQU   RLNRDFB
RLNRBUSE EQU   RLNRDFB
RLNRAPEP EQU   RLNRDFA
RLNRANCP EQU   RLNRDFA
RLNRAEP  EQU   RLNRDFA
RLNIDV   EQU   RLNRDFA
RLNGANSW EQU   RLNRDFA
RLNRACAT EQU   RLNRACNT
RLNRSV04 EQU   RLNSTAT2
RLNINUSE EQU   RLNSTAT2
RLNOHIN  EQU   RLNSTAT2
RLNRSV03 EQU   RLNSTAT1
RLNVD    EQU   RLNSTAT1
RLNINOPP EQU   RLNSTAT1
RLNINOPL EQU   RLNSTAT1
RLNLRST  EQU   RLNSTAT1
RLNTRAP  EQU   RLNSTAT1
RLNACTCT EQU   ISTRLN+84
RLNCTECM EQU   ISTRLN+82
RLNCTEIN EQU   ISTRLN+80
RLNCTETR EQU   ISTRLN+78
RLNCTECL EQU   ISTRLN+76
RLNCUA   EQU   RLNUCBAD
RLNRSV01 EQU   RLNFLAG
RLNRBISA EQU   RLNFLAG
RLNEAM   EQU   RLNFLAG
RLNPRE   EQU   ISTRLN
RGPRVPT2 EQU   ISTRGP+88
RGPRVPT1 EQU   ISTRGP+84
RGPCTECM EQU   ISTRGP+82
RGPCTEIN EQU   ISTRGP+80
RGPCTETR EQU   ISTRGP+78
RGPCTECL EQU   ISTRGP+76
RGPCTELN EQU   ISTRGP+74
RGPRSV03 EQU   ISTRGP+73
RGPRSV02 EQU   RGPFLG
RGPASDLC EQU   RGPFLG
RGPABSC  EQU   RGPFLG
RGPASS   EQU   RGPFLG
RGPPRE   EQU   ISTRGP
RRNRINNM EQU   ISTRRN+248
@NM00048 EQU   ISTRRN+247
RRNRDCUA EQU   ISTRRN+244
RRNNCSPL EQU   ISTRRN+236
RRNRPLPT EQU   ISTRRN+232
RRNMSIZE EQU   ISTRRN+228
RRNNCPNM EQU   ISTRRN+221
RRNCTPCC EQU   ISTRRN+220
RRNHLENT EQU   RRNHPRE+1
RRNHLENH EQU   RRNHPRE
RRNNMNCP EQU   ISTRRN+208
RRNDELAY EQU   ISTRRN+206
RRNRSV04 EQU   ISTRRN+200
RRNRSV88 EQU   RRNNMDPD+7
RRNPUBI  EQU   RRNNMDPD+6
RRNDPLUB EQU   RRNNMDPD
RRNEPADR EQU   ISTRRN+190
RRNCPLUB EQU   ISTRRN+184
RRNRSV05 EQU   RRNCMFD
RRNREMPO EQU   RRNCMFD
RRNCDREC EQU   RRNCMFD
RRNCDDSI EQU   RRNCMFD
RRNCDBCK EQU   RRNCMFD
RRNCDDTL EQU   RRNCMFD
RRNCDSTD EQU   RRNCMFD
RRNCDCSP EQU   RRNCMFD
RRNCCCSL EQU   RRNCMFC
RRNCCSIM EQU   RRNCMFC
RRNCCRCM EQU   RRNCMFC
RRNCCRIM EQU   RRNCMFC
RRNCCCRC EQU   RRNCMFC
RRNCCRST EQU   RRNCMFC
RRNCCRDQ EQU   RRNCMFC
RRNCCRCN EQU   RRNCMFC
RRNCBALT EQU   RRNCMFB
RRNCBMOD EQU   RRNCMFB
RRNCBNPL EQU   RRNCMFB
RRNCBRLS EQU   RRNCMFB
RRNCBRDS EQU   RRNCMFB
RRNCBDLR EQU   RRNCMFB
RRNCBDLH EQU   RRNCMFB
RRNCBDLO EQU   RRNCMFB
RRNCADGO EQU   RRNCMFA
RRNCADTD EQU   RRNCMFA
RRNCACDT EQU   RRNCMFA
RRNCAMBH EQU   RRNCMFA
RRNCAATI EQU   RRNCMFA
RRNCAATG EQU   RRNCMFA
RRNCAATD EQU   RRNCMFA
RRNCAALL EQU   RRNCMFA
RRNRSV55 EQU   RRNRDF+3
RRNPTASL EQU   RRNRDFB+1
RRNRSV01 EQU   RRNRDFB+1
RRNVYDON EQU   RRNRDFB+1
RRNRBBUP EQU   RRNRDFB+1
RRNRSV03 EQU   RRNRDFB
RRNRBCT2 EQU   RRNRDFB
RRNRBCT1 EQU   RRNRDFB
RRNRBSEC EQU   RRNRDFB
RRNRBCCT EQU   RRNRDFB
RRNRBCCL EQU   RRNRDFB
RRNRSV02 EQU   RRNRDFB
RRNRBMDL EQU   RRNRDFB
RRNRAPEP EQU   RRNRDFA
RRNRANCP EQU   RRNRDFA
RRNRBREM EQU   RRNRDFA
RRNRAOLT EQU   RRNRDFA
RRNRASYN EQU   RRNRDFA
RRNRADMP EQU   RRNRDFA
RRNRAIPL EQU   RRNRDFA
RRNRASHT EQU   RRNRDFA
RRNCTENT EQU   ISTRRN+170
RRNCTECM EQU   ISTRRN+168
RRNCTEIN EQU   ISTRRN+166
RRNCTETR EQU   ISTRRN+164
RRNCTECL EQU   ISTRRN+162
RRNCTELI EQU   ISTRRN+160
RRNCTEGP EQU   ISTRRN+158
RRNTRENT EQU   ISTRRN+148
RRNRLDIP EQU   ISTRRN+147
RRNRNCUA EQU   ISTRRN+144
RRNLUBA  EQU   RRNUCBAD+1
RRNCHQI  EQU   RRNUCBAD
RRNRSV11 EQU   RRNFLAG
RRNDSTCT EQU   RRNFLAG
RRNERPIP EQU   RRNFLAG
RRNLCDIP EQU   RRNFLAG
RRNLCDIE EQU   RRNFLAG
RRNLCSIP EQU   RRNFLAG
RRNRBISA EQU   RRNFLAG
RRNRSV89 EQU   RRNFLAG
RRNPRE   EQU   ISTRRN
RLCRVPT2 EQU   ISTRLC+80
RLCRVPT1 EQU   ISTRLC+79
RLCLCCUA EQU   ISTRLC+76
RLCUCBAD EQU   RLCADR+1
RLCRSVDE EQU   RLCFLAG
RLCACNT  EQU   RLCFLAG
RLCRSV14 EQU   RLCFLAG
RLCRBISA EQU   RLCFLAG
RLCRSV22 EQU   RLCFLAG
RLCPRE   EQU   ISTRLC
RAPRVPT2 EQU   ISTRAP+116
RAPRVPT1 EQU   ISTRAP+112
RAPBFACT EQU   ISTRAP+111
RAPRSV17 EQU   RAPFLGC
RAPRSV16 EQU   RAPFLGC
RAPRSV15 EQU   RAPFLGC
RAPRSV14 EQU   RAPFLGC
RAPRSV13 EQU   RAPFLGC
RAPRSV12 EQU   RAPFLGC
RAPRSV11 EQU   RAPFLGC
RAPRSV10 EQU   RAPFLGC
RAPANVPC EQU   RAPFLGB
RAPASPO  EQU   RAPFLGB
RAPAPPO  EQU   RAPFLGB
RAPAACQ  EQU   RAPFLGB
RAPAPRMT EQU   RAPFLGB
RAPAPASS EQU   RAPFLGB
RAPABLCK EQU   RAPFLGB
RAPALLF  EQU   RAPFLGB
RAPRSV06 EQU   RAPFLG
RAPRSV05 EQU   RAPFLG
RAPRSV04 EQU   RAPFLG
RAPRSV03 EQU   RAPFLG
RAPATLGN EQU   RAPFLG
RAPASLGI EQU   RAPFLG
RAPAQUI  EQU   RAPFLG
RAPABLGN EQU   RAPFLG
RAPACEQD EQU   ISTRAP+106
RAPTRPRE EQU   ISTRAP+104
RAPAPPWD EQU   ISTRAP+80
RAPACDEB EQU   ISTRAP+76
RAPACBA  EQU   ISTRAP+72
RAPPRE   EQU   ISTRAP
RDTVSRPL EQU   ISTRDT+132
RDTCRSPW EQU   ISTRDT+124
RDTCRSDS EQU   ISTRDT+116
@NM00047 EQU   ISTRDT+113
RRNSTCNT EQU   RDTSTCNT
RRNVYRPH EQU   RDTVYRPH
RDTTPAB  EQU   ISTRDT+104
RDTDPAB  EQU   ISTRDT+100
RDTEPAB  EQU   ISTRDT+96
RDTVPAB  EQU   ISTRDT+92
RDTRSV01 EQU   RDTFLAGB
RDTBHSET EQU   RDTFLAGB
RDTCTCFL EQU   RDTFLAGB
RDTCTPGD EQU   RDTFLAGB
RDTPRGDN EQU   RDTFLAGB
RDTOUERP EQU   RDTFLAGB
RDTLGCT  EQU   ISTRDT+90
RDTFLAGS EQU   ISTRDT+84
RDTBACK  EQU   ISTRDT+80
RDTFORW  EQU   ISTRDT+76
RDTLEN   EQU   RDTPLEN+1
RDTPRILS EQU   RDTPRIOR
RDTPRISW EQU   RDTPRIOR
RDTPRILC EQU   RDTPRIOR
@NM00046 EQU   RDTPRIOR
RDTPRE   EQU   ISTRDT
RCPRSV05 EQU   ISTRCPRE+120
RCPRSV04 EQU   ISTRCPRE+116
RCPRSV03 EQU   ISTRCPRE+112
RCPINTA  EQU   RCPLGNIN+16
RCPLGNCT EQU   RCPLGNIN+8
RCPLGNAP EQU   RCPLGNIN
@NM00045 EQU   RCPPMODE
RCPRRECD EQU   RCPPMODE
RCPRBASC EQU   RCPPMODE
RCPBFLIM EQU   ISTRCPRE+90
RCPBHSI2 EQU   ISTRCPRE+89
RCPBHSI1 EQU   ISTRCPRE+88
RCPLNAPA EQU   ISTRCPRE+76
RCPPRE   EQU   ISTRCPRE
RPRCONID EQU   ISTRPRE+63
RPRCLVPD EQU   RPRFLAGC
RPRINIMM EQU   RPRFLAGD
RPRRSV05 EQU   RPRFLAGD
RPRCONP  EQU   RPRFLAGD
RPRACTP  EQU   RPRFLAGD
RPRRSON  EQU   RPRFLAGD
RPRCONCT EQU   RPRFLAGD
RPRLTASN EQU   RPRFLAGD
RPRPTHCT EQU   ISTRPRE+60
RPRSWDAF EQU   ISTRPRE+58
RPRSTPCT EQU   ISTRPRE+56
RPRRVPT1 EQU   ISTRPRE+52
RPRNCBA  EQU   ISTRPRE+40
RPRTIOCT EQU   ISTRPRE+26
RPRPEPCT EQU   ISTRPRE+24
RPRRSV03 EQU   RPRCAUSE
RPRRSYNC EQU   RPRCAUSE
RPRCRCPT EQU   RPRCAUSE
RPRINTST EQU   RPRFLAGB
RPRVYIMM EQU   RPRFLAGB
RPRHLVPD EQU   RPRFLAGB
RPRONLIN EQU   RPRFLAGB
RPRVIODN EQU   RPRFLAGB
RPRAOPN  EQU   RPRFLAGB
RPRENTVT EQU   RPRFLAGB
RPRENTVH EQU   RPRFLAGB
RPRLIVE  EQU   RPRFLAGA
RPRVRYPD EQU   RPRFLAGA
RPRENTIO EQU   RPRFLAGA
RPRENTBF EQU   RPRFLAGA
RPRTIED  EQU   RPRFLAGA
RPRACT   EQU   RPRFLAGA
RPRPELEN EQU   ISTRPRE+18
RPRRLOCK EQU   ISTRPRE+12
RPRDAF   EQU   RPRCOMID+2
RPRSAF   EQU   RPRCOMID
DEVRSV03 EQU   ISTDEVCH+5
DEVPHYSA EQU   ISTDEVCH+4
DEVCSLPN EQU   DEVCHAR3
DEVCSTCL EQU   DEVCHAR3
DEVCCHEK EQU   DEVCHAR3
DEVCATTN EQU   DEVCHAR3
DEVCSWL  EQU   DEVFCCTL
DEVCRVB  EQU   DEVFCCTL
DEVCSSL  EQU   DEVFCCTL
DEVCBSC  EQU   DEVFCCTL
DEVMCODE EQU   ISTDEVCH+2
DEVCHAR2 EQU   DEVTCODE
DEVRSV01 EQU   DEVCHAR
DEVCCTL  EQU   DEVCHAR
DEVNNSPT EQU   DEVCHAR
DEVSPS   EQU   DEVCHAR
DEVSUBND EQU   DEVCHAR
DEVCONVR EQU   DEVCHAR
DEVOTPUT EQU   DEVCHAR
DEVINPUT EQU   DEVCHAR
ATCAOS   EQU   ISTATCVT+1584
ATCPOPAB EQU   ATCAOSM+640
ATCVIOPM EQU   ATCAOSM+636
ATCTPMMI EQU   ATCAOSM+632
ATCTPMPB EQU   ATCAOSM+600
ATCRSV88 EQU   ATCAOSM+596
ATCRPLCT EQU   ATCAOSM+594
ATCCRACT EQU   ATCAOSM+592
ATCSRBCT EQU   ATCAOSM+590
ATCRSV75 EQU   ATCAOSM+589
ATCRSV66 EQU   ATCZFLAG
ATCZF001 EQU   ATCZFLAG
ATCTPCP1 EQU   ATCAOSM+584
ATCTPCP0 EQU   ATCAOSM+580
ATCAICTN EQU   ATCAOSM+576
ATCZR01  EQU   ATCAOSM+572
ATCMPLTA EQU   ATCAOSM+568
ATCASCB  EQU   ATCAOSM+564
ATCAP86  EQU   ATCAOSM+560
ATCAP85  EQU   ATCAOSM+556
ATCAP84  EQU   ATCAOSM+552
ATCAP83  EQU   ATCAOSM+548
ATCAP82  EQU   ATCAOSM+544
ATCAP69  EQU   ATCAOSM+540
ATCAP66  EQU   ATCAOSM+536
ATCAP62  EQU   ATCAOSM+532
ATCAPC59 EQU   ATCAOSM+528
ATCAP56  EQU   ATCAOSM+524
ATCAP55  EQU   ATCAOSM+520
ATCRCFY0 EQU   ATCAOSM+516
ATCAP41  EQU   ATCAOSM+512
ATCAPC25 EQU   ATCAOSM+508
ATCAP23  EQU   ATCAOSM+504
ATCTPSPB EQU   ATCAOSM+472
ATCTRMPB EQU   ATCAOSM+440
ATCAPBE  EQU   ATCAOSM+436
ATCPSTA  EQU   ATCAOSM+432
ATCSMABF EQU   ATCAOSM+428
ATCSMAPR EQU   ATCAOSM+424
ATCTPWQA EQU   ATCAOSM+420
ATCSMAID EQU   ATCAOSM+416
ATCSMARA EQU   ATCAOSM+412
ATCCACXA EQU   ATCAOSM+408
ATCZLAAB EQU   ATCAOSM+404
ATCATA10 EQU   ATCAOSM+400
ATCHLTCB EQU   ATCAOSM+396
@NM00044 EQU   ATCVTFLG
ATCVTACT EQU   ATCVTFLG
ATCRPT40 EQU   ATCAOSM+388
ATCRPT39 EQU   ATCAOSM+384
ATCRPT38 EQU   ATCAOSM+380
ATCRPT37 EQU   ATCAOSM+376
ATCRPT36 EQU   ATCAOSM+372
ATCRPT35 EQU   ATCAOSM+368
ATCRPT34 EQU   ATCAOSM+364
ATCRPT33 EQU   ATCAOSM+360
ATCRPT32 EQU   ATCAOSM+356
ATCRPT31 EQU   ATCAOSM+352
ATCRPT30 EQU   ATCAOSM+348
ATCRPT29 EQU   ATCAOSM+344
ATCRPT28 EQU   ATCAOSM+340
ATCRPT27 EQU   ATCAOSM+336
@NM00043 EQU   ATCAOSM+333
@NM00042 EQU   @NM00041
ATCSNUF  EQU   @NM00041
ATCOPKL  EQU   @NM00041
ATCABEN  EQU   @NM00041
ATCAIWT  EQU   ATCAOSM+328
ATCINFDD EQU   ATCAOSM+324
ATCORFMG EQU   ATCAOSM+320
ATCORFRL EQU   ATCAOSM+316
ATCOROBT EQU   ATCAOSM+312
ATCORQG  EQU   ATCORSRB
ATCORTBF EQU   ATCSQAFR
ATCRPLAC EQU   ATCRPLCN+2
ATCRPLRC EQU   ATCRPLCN
ATCCRPLQ EQU   ATCCRPL
ATCSRBAC EQU   ATCSRBCN+2
ATCSRBRC EQU   ATCSRBCN
ATCSRBQ  EQU   ATCSRB
ATCCRAAC EQU   ATCCRACN+2
ATCCRARC EQU   ATCCRACN
ATCCRAQ  EQU   ATCCRA
ATCRPT12 EQU   ATCAOSM+276
ATCDMAPP EQU   ATCAOSM+272
ATCAP38  EQU   ATCAOSM+268
ATCAP37  EQU   ATCAOSM+264
ATCZDFJ0 EQU   ATCAOSM+260
ATCAP51  EQU   ATCAOSM+256
ATCZPAB2 EQU   ATCAOSM+224
ATCZPAB1 EQU   ATCAOSM+192
ATCZLFVT EQU   ATCAOSM+188
ATCZLPVT EQU   ATCAOSM+184
ATCZDVTX EQU   ATCAOSM+180
ATCZDVTA EQU   ATCAOSM+176
ATCZDVT9 EQU   ATCAOSM+172
ATCZDVT8 EQU   ATCAOSM+168
ATCZDVT7 EQU   ATCAOSM+164
ATCRSV56 EQU   ATCDAPVT+22
ATCDAPDG EQU   ATCDAPVT+20
ATCDXCEA EQU   ATCDAPVT+16
ATCDCEA  EQU   ATCDAPVT+12
ATCDPCIA EQU   ATCDAPVT+8
ATCDSIOA EQU   ATCDAPVT+4
ATCDEOEA EQU   ATCDAPVT
ATCZLAEA EQU   ATCLDAPP+16
ATCZLCEA EQU   ATCLDAPP+12
ATCRSV17 EQU   ATCLDAPP+8
ATCSMFRR EQU   ATCLDAPP+4
ATCCDTID EQU   ATCLDAPP
ATCZAEA  EQU   ATCICAPP+16
ATCZCEA  EQU   ATCICAPP+12
ATCCDTCB EQU   ATCICAPP+8
ATCZSIOA EQU   ATCICAPP+4
ATCCDRPH EQU   ATCICAPP
ATCAP65  EQU   ATCAOSM+96
ATCZDVT6 EQU   ATCAOSM+92
ATCZDVT4 EQU   ATCAOSM+88
ATCZDVT3 EQU   ATCAOSM+84
ATCZDVT1 EQU   ATCAOSM+80
ATCICNCB EQU   ATCAOSM+76
ATCZPSVT EQU   ATCAOSM+72
ATCZFSVT EQU   ATCAOSM+68
ATCAP64  EQU   ATCAOSM+64
ATCAP63  EQU   ATCAOSM+60
ATCAP61  EQU   ATCAOSM+56
ATCAP58  EQU   ATCAOSM+52
ATCAP57  EQU   ATCAOSM+48
ATCAP54  EQU   ATCAOSM+44
ATCAP53  EQU   ATCAOSM+40
ATCAP52  EQU   ATCAOSM+36
ATCAP34  EQU   ATCAOSM+32
ATCAP32  EQU   ATCAOSM+28
ATCAP31  EQU   ATCAOSM+24
ATCAP12  EQU   ATCAOSM+20
ATCAP11  EQU   ATCAOSM+16
ATCCMTCB EQU   ATCAOSM+12
ATCPRPH  EQU   ATCAOSM+8
ATCGSRBF EQU   ATCGSRBG
ATCSRBRT EQU   ATCAOSM
@NM00040 EQU   @NM00039
ATCVTMAB EQU   @NM00039
@NM00038 EQU   ATCVTBAM
ATCVDLOK EQU   ISTATCVT+904
ATCVFPAB EQU   ISTATCVT+872
ATCVDPAB EQU   ISTATCVT+840
ATCIOECB EQU   ISTATCVT+836
ATCINCW3 EQU   ISTATCVT+832
ATCMODTB EQU   ISTATCVT+828
ATCUSSPT EQU   ISTATCVT+824
ATCSRTAB EQU   ISTATCVT+820
@NM00037 EQU   ISTATCVT+819
@NM00036 EQU   ATCSTAT2
ATCTRSMS EQU   ATCSTAT2
ATCTRLOK EQU   ATCSTAT2
ATCTRPSS EQU   ATCSTAT2
ATCTRESC EQU   ATCSTAT2
ATCTRAPI EQU   ATCSTAT2
ATCSEC51 EQU   ATCSECST
ATCSEC40 EQU   ATCSIPD+8
ATCSEC30 EQU   ATCSIPD+4
ATCSEC21 EQU   ATCSIPD
ATCSEC10 EQU   ATCSOPD+4
ATCSEC01 EQU   ATCSOPD
ATCPOIA  EQU   ATCRNO+1
@NM00035 EQU   ATCRNO
ATCPODVT EQU   ISTATCVT+784
ATCS49XL EQU   ISTATCVT+780
ATCS49XI EQU   ISTATCVT+776
ATCLCLCT EQU   ATCVLCNT+2
ATCRNCNT EQU   ATCVLCNT
ATCCFEAD EQU   ISTATCVT+768
ATCPTR00 EQU   ISTATCVT+736
ATCRSV10 EQU   ISTATCVT+704
ATCTACB  EQU   ISTATCVT+700
ATCVTINM EQU   ISTATCVT+696
ATCTCLIM EQU   ISTATCVT+692
ATCTCLOM EQU   ISTATCVT+688
ATCVTIPB EQU   ISTATCVT+656
ATCTCIPB EQU   ISTATCVT+624
ATCTIPAB EQU   ISTATCVT+592
ATCOCCCB EQU   ISTATCVT+588
ATCOCCOB EQU   ISTATCVT+584
ATCCDLAD EQU   ISTATCVT+580
ATCCCLAD EQU   ISTATCVT+576
ATCDLRPB EQU   ISTATCVT+544
ATCPGPAB EQU   ISTATCVT+512
ATCVPAB1 EQU   ISTATCVT+480
ATCRSV97 EQU   ISTATCVT+476
ATCRDTLK EQU   ISTATCVT+472
ATCCDFDN EQU   ISTATCVT+464
ATCCDFIN EQU   ISTATCVT+460
ATCDVTLK EQU   ISTATCVT+456
ATCAP35  EQU   ISTATCVT+448
ATCRSV99 EQU   ISTATCVT+440
ATCONFIG EQU   ISTATCVT+432
ATCNODDS EQU   ISTATCVT+428
ATCNODEL EQU   ISTATCVT+420
ATCRSV69 EQU   ISTATCVT+416
ATCAPCR5 EQU   ISTATCVT+412
ATCLDECB EQU   ISTATCVT+408
ATCLDNCS EQU   ISTATCVT+404
ATCCDPTR EQU   ISTATCVT+400
ATCADEL  EQU   ISTATCVT+396
ATCTODVT EQU   ISTATCVT+392
ATCDEBCH EQU   ISTATCVT+388
ATCHBSIZ EQU   ATCHPGM+2
ATCHBFNO EQU   ATCHPGM
ATCCRME  EQU   ISTATCVT+380
ATCRVCHS EQU   ISTATCVT+372
ATCECTLP EQU   ISTATCVT+368
ATCZDVTB EQU   ISTATCVT+364
ATCECPRT EQU   ISTATCVT+360
ATCVTLOD EQU   ISTATCVT+356
ATCTRPAB EQU   ISTATCVT+352
ATCMSGM  EQU   ISTATCVT+348
ATCEPT   EQU   ISTATCVT+340
ATCDVT   EQU   ISTATCVT+336
ATCTRCPT EQU   ISTATCVT+332
ATCDVLOD EQU   ISTATCVT+328
ATCALERT EQU   ISTATCVT+324
ATCEPA   EQU   ISTATCVT+320
ATCSAF   EQU   ISTATCVT+318
ATCXRANG EQU   ISTATCVT+317
ATCLAST  EQU   ATCSHRFG
ATCSHRTN EQU   ISTATCVT+308
ATCUEP   EQU   ISTATCVT+304
ATCOCRT  EQU   ISTATCVT+300
ATCCSMA  EQU   ATCCSMR
ATCESC02 EQU   ISTATCVT+292
ATCESC01 EQU   ISTATCVT+288
ATCCDFND EQU   ISTATCVT+284
ATCCDDEL EQU   ISTATCVT+280
ATCCDADD EQU   ISTATCVT+276
ATCRSV16 EQU   ISTATCVT+270
ATCMSGSP EQU   ATCCOM+268
ATCACTRM EQU   ATCCOM+264
ATCNERAP EQU   ATCCOM+260
ATCNESAL EQU   ATCCOM+256
ATCRCC65 EQU   ATCCOM+252
ATCRCC26 EQU   ATCCOM+248
ATCRCC63 EQU   ATCCOM+244
ATCRSV11 EQU   ATCCOM+242
ATCVTMID EQU   ATCCOM+240
ATCAPOST EQU   ATCCOM+236
ATCNERFN EQU   ATCCOM+232
ATCNERNE EQU   ATCCOM+228
ATCNERCV EQU   ATCCOM+224
ATCNERST EQU   ATCCOM+220
ATCDCC61 EQU   ATCCOM+216
ATCDCC60 EQU   ATCCOM+212
ATCFIRA  EQU   ATCCOM+200
ATCSMBQ  EQU   ATCCOM+196
ATCSMRC  EQU   ATCCOM+192
ATCSMRS  EQU   ATCCOM+188
ATCSMQU  EQU   ATCCOM+184
ATCSMRQ  EQU   ATCCOM+180
ATCACDA  EQU   ATCCOM+176
ATCSTMA  EQU   ATCCOM+172
ATCFRSTR EQU   ATCCOM+168
ATCREADA EQU   ATCCOM+160
ATCALOAD EQU   ATCCOM+156
ATCBLDLA EQU   ATCCOM+152
ATCFBRPH EQU   ATCCOM+148
ATCBFTRC EQU   ATCCOM+144
ATCTPBUF EQU   ATCTHTRC
ATCREMOV EQU   ATCCOM+136
ATCBPDA  EQU   ATCCOM+128
ATCDVTPT EQU   ATCCOM+124
ATCFEPT  EQU   ATCCOM+120
ATCFDVT  EQU   ATCCOM+116
ATCPTCHA EQU   ATCCOM+108
ATCAUTHA EQU   ATCCOM+104
ATCACCTA EQU   ATCCOM+100
ATCRDTH  EQU   ATCCOM+96
ATCFRSCH EQU   ATCCOM+92
ATCFSB   EQU   ATCCOM+88
ATCHLTMS EQU   ATCCOM+84
ATCECPRM EQU   ATCCOM+80
ATCECNET EQU   ATCCOM+76
ATCECOPC EQU   ATCCOM+72
ATCVPARM EQU   ATCCOM+68
ATCECVRQ EQU   ATCCOM+64
ATCECSES EQU   ATCCOM+60
ATCOCHA  EQU   ATCCOM+56
ATCDSPLQ EQU   ATCCOM+52
ATCECDSP EQU   ATCCOM+48
ATCVARYQ EQU   ATCCOM+44
ATCECVRY EQU   ATCCOM+40
ATCHALTQ EQU   ATCCOM+36
ATCECHLT EQU   ATCCOM+32
ATCMODQ  EQU   ATCCOM+28
ATCECMOD EQU   ATCCOM+24
ATCASCHD EQU   ATCCOM+20
ATCSRT   EQU   ATCCOM+16
ATCDCFRR EQU   ATCCOM+8
ATCAPI   EQU   ATCCOM+4
ATCRSV04 EQU   ATCSTAT4
ATCVTTRC EQU   ATCSTAT4
ATCNCSD  EQU   ATCSTAT4
ATCMTST  EQU   ATCSTAT4
ATCTPRT  EQU   ATCSTAT4
ATCPRTAT EQU   ATCSTAT4
@NM00034 EQU   ATCPOFLG
ATCPOUNS EQU   ATCPOFLG
ATCHSDMF EQU   ATCSTFLG
@NM00033 EQU   ATCSTAT1
ATCMDHLT EQU   ATCSTAT1
ATCINHLT EQU   ATCSTAT1
ATCNETSL EQU   ATCSTAT1
ATCQKHLT EQU   ATCSTAT1
ATCSNHLT EQU   ATCSTAT1
ATCACTIV EQU   ATCSTAT1
ATCSTART EQU   ATCSTAT1
RPHNEXPO EQU   ISTRPH+104
RPHSAV16 EQU   RPHWORK+60
RPHSAV15 EQU   RPHWORK+56
RPHSAV14 EQU   RPHWORK+52
RPHSAV13 EQU   RPHWORK+48
RPHSAV12 EQU   RPHWORK+44
RPHSAV11 EQU   RPHWORK+40
RPHSAV10 EQU   RPHWORK+36
RPHSAVE9 EQU   RPHWORK+32
RPHSAVE8 EQU   RPHWORK+28
RPHSAVE7 EQU   RPHWORK+24
RPHSAVE6 EQU   RPHWORK+20
RPHSAVE5 EQU   RPHWORK+16
RPHSAVE4 EQU   RPHWORK+12
RPHSAVE3 EQU   RPHWORK+8
RPHSAVE2 EQU   RPHWORK+4
RPHSHALF EQU   RPHSAVE1+2
RPHSBIT8 EQU   RPHSBITS
RPHSBIT7 EQU   RPHSBITS
RPHSBIT6 EQU   RPHSBITS
RPHSBIT5 EQU   RPHSBITS
RPHSBIT4 EQU   RPHSBITS
RPHSBIT3 EQU   RPHSBITS
RPHSBIT2 EQU   RPHSBITS
RPHSBIT1 EQU   RPHSBITS
RPHSBYTE EQU   RPHSAVE1
RPHPABQP EQU   RPHPABQA+1
RPHPABFG EQU   RPHPABQA
RPHSRP34 EQU   RPHSRPRM+2
RPHSRP12 EQU   RPHSRPRM
RPHWEGT  EQU   RPHCSPA
RPHMAJCB EQU   ISTRPH+21
RPHPABOF EQU   ISTRPH+20
RPHRESUM EQU   RPHRESMA+1
RPHRSV01 EQU   RPHWPFLG
RPHPURGE EQU   RPHWPFLG
RPHPT    EQU   RPHWPFLG
RPHWT    EQU   RPHWPFLG
RPHRSKEY EQU   RPHWPFLG
RPHDVTA  EQU   ISTRPH+12
RPHTIK   EQU   RPHTSKID+3
@NM00032 EQU   RPHTSKID
RPHRPHAP EQU   RPHRPHA+1
@NM00031 EQU   RPHRPHA
RPHGATE  EQU   RPHRPHA
@NM00030 EQU   RPHFLGB
RPHRLCRA EQU   RPHFLGB
RPHNRSAV EQU   RPHFLGB
RPHPGCMP EQU   RPHFLGB
RPHFBAPS EQU   RPHFLGB
RPHBSSP  EQU   RPHFLGB
RPHLOCK  EQU   RPHFLGB
RPHFNFLG EQU   RPHFSTLC
RPHMLTCP EQU   RPHFLAGS
RPHSMCLR EQU   RPHFLAGS
RPHSMTYP EQU   RPHFLAGS
RPHSMQ   EQU   RPHFLAGS
RPHAUTEX EQU   RPHAPTYP
RPHSPGIN EQU   RPHFLAGS
RPHOGIND EQU   RPHFLAGS
RPHLNGTH EQU   RPHCNTL+1
RPHTYPE  EQU   RPHCNTL
DYPPAB   EQU   ISTDYPAB+16
DYPRSV01 EQU   ISTDYPAB+12
DYPTSKID EQU   ISTDYPAB+8
DYPCHAIN EQU   ISTDYPAB+4
DYPFLGS  EQU   ISTDYPAB+2
DYPLNGTH EQU   ISTDYPAB+1
DYPTYPE  EQU   ISTDYPAB
LOKXCL   EQU   @NM00028
@NM00029 EQU   @NM00028
@NM00027 EQU   LOKCHNG
LOKCT    EQU   ISTLOK
PABRPHA  EQU   PABRPHFG+1
PABNODQ  EQU   PABFLAGS
PABINHBT EQU   PABFLAGS
PABERLOK EQU   PABERRLK
PABSSN   EQU   PABFLAGS
PABDYNAM EQU   PABFLAGS
PABNORPR EQU   PABFLAGS
PABPRIOR EQU   PABFLAGS
PABAPYP  EQU   PABFLAGS
PABDVTA  EQU   ISTPAB+9
PABOFFST EQU   ISTPAB+8
PABCHNGP EQU   PABCHAIN+1
PABRSV02 EQU   PABCHAIN
PABDELAY EQU   PABCHAIN
PABRUNNG EQU   PABCHAIN
PABRESET EQU   PABCHAIN
PABUNCON EQU   PABCHAIN
PABCDP   EQU   PABCHAIN
PABRESCH EQU   PABCHAIN
PABCHNG  EQU   PABCHAIN
PABWEQP  EQU   PABWEQA+1
PABRSV01 EQU   PABWEQA
PABWEQG  EQU   PABWEQA
NCSAPPAB EQU   NCSAPP+608
NCSAPDAT EQU   NCSAPBUE+8
NCSAPRU  EQU   NCSAPBUE+3
NCSRSV04 EQU   NCSAPBUE
NCSAPEND EQU   NCSAPP+84
NCSAPTXT EQU   NCSAPP+76
NCSAPECB EQU   NCSAPP+72
NCSAPSA  EQU   NCSAPP
NCSPLPDB EQU   NCSPLSID+5
NCSPLNID EQU   NCSPLPHD
NCSPLPO  EQU   NCSPLSTA
NCSRSVD4 EQU   NCSPLSTA
NCSRSVD2 EQU   NCSCRMOD
NCSPTMOD EQU   NCSCRMOD
NCSAIMOD EQU   NCSCRMOD
NCSRSVD1 EQU   NCSCHKPT+1
NCSPTUSE EQU   NCSCHKPT+1
NCSRNME  EQU   NCSCHKPT+1
NCSCUA   EQU   NCSCHKPT+1
NCSANSMD EQU   NCSCHKPT+1
NCSLGMOD EQU   NCSCHKPT
NCSLGAPL EQU   NCSCHKPT
NCSDTRLM EQU   NCSCHKPT
NCSESLM  EQU   NCSCHKPT
NCSNRPL  EQU   NCSCHKPT
NCSPOLD  EQU   NCSCHKPT
NCSPACTV EQU   NCSCHKPT
NCSACTV  EQU   NCSCHKPT
NCSCRDTE EQU   ISTNCSPL+264
NCSPLRTY EQU   ISTNCSPL+263
NCSPLRH  EQU   ISTNCSPL+260
NCSUFMCB EQU   ISTNCSPL+256
NCSMGLPT EQU   ISTNCSPL+252
NCSCPWPT EQU   ISTNCSPL+248
NCSSENS2 EQU   NCSSENSE+2
NCSSNS2  EQU   NCSSENSE+1
NCSSNS1  EQU   NCSSENSE
NCSPLNSN EQU   ISTNCSPL+240
NCSPLMID EQU   ISTNCSPL+232
NCSPLPID EQU   ISTNCSPL+231
NCSPLGID EQU   ISTNCSPL+230
NCSPLSQN EQU   ISTNCSPL+228
NCSRNAME EQU   ISTNCSPL+220
NCSPLRUI EQU   ISTNCSPL+212
NCSPLRUO EQU   ISTNCSPL+208
NCSPLRRP EQU   ISTNCSPL+204
NCSPLWEL EQU   ISTNCSPL+200
NCSPLSPL EQU   ISTNCSPL+196
NCSPLP3  EQU   ISTNCSPL+192
NCSPLP2  EQU   ISTNCSPL+188
NCSPLP1  EQU   ISTNCSPL+184
NCSPLOLN EQU   ISTNCSPL+182
@NM00026 EQU   NCSPLFL5
NCSFORCE EQU   NCSPLFL5
NCSSDLK  EQU   NCSPLFL5
NCSSCPPS EQU   NCSPLFL5
NCSDLRSN EQU   ISTNCSPL+180
NCSPL2AP EQU   NCSPLFL4
NCSDSPN  EQU   NCSPLFL4
NCSDSPI  EQU   NCSPLFL4
NCSDSPA  EQU   NCSPLFL4
NCSDSPE  EQU   NCSPLFL4
NCSPLVID EQU   NCSPLFL4
NCSPLRSO EQU   NCSPLFL4
NCSDLNID EQU   NCSPLFL4
NCSEND   EQU   NCSPLFL3
NCSFINAL EQU   NCSPLFL3
NCSANS   EQU   NCSPLFL3
NCSPID   EQU   NCSPLFL3
NCSGID   EQU   NCSPLFL3
NCSPLANS EQU   NCSPLFL3
NCSEPP   EQU   NCSPLFL3
NCSPLMOM EQU   NCSPLFL3
NCSPLVIT EQU   NCSPLFL2
NCSPLVIS EQU   NCSPLFL2
NCSREMPO EQU   NCSPLFL2
NCSPLDS  EQU   NCSPLFL2
NCSOUFMC EQU   NCSPLFL2
NCSPLRIO EQU   NCSPLFL2
NCSPLRSF EQU   NCSPLFL2
NCSPLVDP EQU   NCSPLFL2
NCSPLPOS EQU   NCSPLFL1
NCSPL2CN EQU   NCSPLFL1
NCSPLAPU EQU   NCSPLFL1
NCSPLNON EQU   NCSPLFL1
NCSPLREQ EQU   NCSPLFL1
NCSPLEBN EQU   NCSPLFL1
NCSPLSOM EQU   NCSPLFL1
NCSPL2IN EQU   NCSPLFL1
NCSPLRCR EQU   ISTNCSPL+172
NCSPLECB EQU   ISTNCSPL+164
NCSPLRPH EQU   ISTNCSPL+160
NCSPLCVT EQU   ISTNCSPL+156
NCSPLWKA EQU   ISTNCSPL+152
NCSPLDAF EQU   NCSPLCID+2
NCSPLSAF EQU   NCSPLCID
NCSPLRCD EQU   NCSPLRAD+1
NCSLSCMD EQU   NCSPLRAD
NCSPLWRF EQU   ISTNCSPL+72
NCSPLWRE EQU   ISTNCSPL+68
NCSSTCMD EQU   NCSCRFLG
NCSUSRNF EQU   NCSCRFLG
NCSOPRQU EQU   NCSCRFLG
NCSCRDSE EQU   NCSCRFLG
NCSFMERP EQU   NCSCRFLG
NCSFMCLD EQU   NCSCRFLG
NCSPLCLD EQU   NCSCRFLG
NCSPLWRM EQU   NCSCRFLG
NCSPLUAD EQU   ISTNCSPL+64
NCSMSGSP EQU   ISTNCSPL+63
NCSNCPEP EQU   ISTNCSPL+62
NCSCMDB  EQU   NCSPLCMD+1
@NM00025 EQU   NCSCMDA
NCSPLUFM EQU   NCSCMDA
NCSPLFLO EQU   NCSCMDA
NCSPLSYN EQU   NCSCMDA
NCSPLCTL EQU   NCSCMDA
NCSPLSYS EQU   NCSCMDA
NCSPLLPT EQU   ISTNCSPL+56
NCSPLRPT EQU   ISTNCSPL+52
NCSCRPID EQU   ISTNCSPL+51
NCSCRCMD EQU   ISTNCSPL+50
NCSDLID  EQU   ISTNCSPL+44
NCSPLLID EQU   ISTNCSPL+36
NCSPLRID EQU   ISTNCSPL+28
NCSRRNPT EQU   ISTNCSPL+24
NCSIORC  EQU   ISTNCSPL+23
NCSPRMRC EQU   ISTNCSPL+22
NCSOVFMC EQU   NCSPLVF1
NCSRSV02 EQU   NCSPLVFL
NCSDACLK EQU   NCSPLVFL
NCSABCON EQU   NCSPLVFL
NCSDCONT EQU   NCSPLVFL
NCSVSTAT EQU   NCSPLVFL
NCSVDEL  EQU   NCSPLVFL
NCSVNCSA EQU   NCSPLVFL
NCSVBF16 EQU   NCSPLVBF+1
NCSVBF15 EQU   NCSPLVBF+1
NCSVBF14 EQU   NCSPLVBF+1
NCSVBF13 EQU   NCSPLVBF+1
NCSVBF12 EQU   NCSPLVBF+1
NCSVBF11 EQU   NCSPLVBF+1
NCSVBF10 EQU   NCSPLVBF+1
NCSVBF09 EQU   NCSPLVBF+1
NCSVBF08 EQU   NCSPLVBF
NCSVBF07 EQU   NCSPLVBF
NCSVBF06 EQU   NCSPLVBF
NCSVBF05 EQU   NCSPLVBF
NCSVBF04 EQU   NCSPLVBF
NCSVBF03 EQU   NCSPLVBF
NCSVBF02 EQU   NCSPLVBF
NCSVBF01 EQU   NCSPLVBF
NCSPLVCD EQU   ISTNCSPL+17
@NM00024 EQU   ISTNCSPL+16
NCSCRWKA EQU   NCSPFX+12
@NM00023 EQU   NCSPFX
PFXBCK   EQU   ISTPFX+12
PFXFWD   EQU   ISTPFX+8
PFXLNG   EQU   ISTPFX+5
PFXPRTY  EQU   ISTPFX+4
PFXCBID  EQU   PFXID
POHID    EQU   ISTPOHD+2
POHGEN   EQU   POHSTAT
POHRREQ  EQU   POHSTAT
POHRSVD2 EQU   POHSTAT
POHCNTRL EQU   POHSTAT
POHLBL   EQU   POHSTAT
POHDATA  EQU   POHSTAT
POHEND   EQU   POHSTAT
POHRSVD1 EQU   ISTPOHD
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RT00119 EQU   @RC00117
@RT00272 EQU   @RC00265
@RT00278 EQU   @RC00276
@RC00323 EQU   @RC00310
@RC00318 EQU   @RC00310
@RC00331 EQU   @RC00310
@RC00340 EQU   @RC00310
@RC00354 EQU   @RC00310
@RC00346 EQU   @RC00310
@RC00344 EQU   @RC00310
@RC00363 EQU   @RC00361
@RC00427 EQU   @RC00361
@RC00376 EQU   @RC00361
@RC00449 EQU   @RC00361
@RT00447 EQU   @RC00361
@RT00453 EQU   @RC00361
@RF00465 EQU   @RC00462
@RT00383 EQU   @RC00376
@ENDDATA EQU   *
         END   ISTSDCCB,(C'PLS1837',0603,78108)
