         TITLE 'INQUIRE TERMINAL NAMES - ISTSQC04                      *
                        '
ISTSQC04 CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'ISTSQC04  77.059'                                 0001
         DROP  @15
@PROLOG  ST    @14,12(,@13)                                        0001
         STM   @01,@12,24(@13)                                     0001
         BALR  @03,0                                               0001
@PSTART  DS    0H                                                  0001
         USING @PSTART,@03                                         0001
*                                                                  0273
*/********************************************************************/
*/* THIS IS THE MAIN LINE ROUTINE. IT INITALIZES THE BASE AND        */
*/* CALLS CTERMN1 TO DETERMINE THE TYPE OF RDTE AND GIVE CONTROL     */
*/* TO THE APPROPRIATE ROUTINE TO PROCESS SWITCHED, DIAL-IN, AND     */
*/* DIAL-OUT LINES.  FOR ALL OTHER VALID RDT ENTRIES, CTERMN1        */
*/* RETURNS A COUNT GREATER THAN 1 AND C04NIBP IS CALLED TO          */
*/* PROVIDE THE REQUIRED INFORMATION.                                */
*/*                                                                  */
*/* INPUT:  C04R1  (R1)  - POINTER TO RPL HEADER (ISTRPH)            */
*/*         C04R13 (R13) - POINTER TO O/C SAVE AREA                  */
*/*                                                                  */
*/* OUTPUT: C04R15 (R15) - ERROR RETURN CODE (4=APPLICATION RDTE,    */
*/*                        X'0B'=COULD NOT OBTAIN LOCAL MEMORY LOCK) */
*/*                                                                  */
*/* ROUTINES CALLED: CTERMN1 - TO VALIDATE RDT ENTRY TYPE AND,       */
*/*                            FOR LINES, PROVIDE NECESSARY DATA     */
*/*                  C04NIBP - TO PROVIDE NECESSARY DATA FOR         */
*/*                            REMAINING RDTE ENTRY TYPES            */
*/*                                                                  */
*/* MACROS USED: CRRMAINT - TO PROVIDE COMPONENT RECOVERY RECORD     */
*/*                         TRACE                                    */
*/*              VSETLCK  - TO OBTAIN AND RELEASE LOCAL MEMORY LOCK  */
*/********************************************************************/
*                                                                  0273
*                                                                  0273
*    DO;                                                           0273
*/***  CRRMAINT  PROCNM(ISTSQC04)FUNC(SUB)COMP(NS)  ***/           0274
*    DCL CMZK0006 PTR(31) REG(1);                                  0274
*    RFY (CMZK0006) RSTD;                                          0275
*                                                                  0275
*/* ATBUILD (ISTRPH,ISTCRA,ISTPFCRR,ISTNSCRR)  */                  0276
*/* LOGICAL CHANNEL COMMAND WORD                                      *
*/* ADD A DECLARE                                      003 10/18/74   *
*DCL  1  ISTLCCW BDY(WORD) BASED,                                  0276
*        2  LCCWOP    CHAR(1),         /* OPERATION CODE -CONTROL     *
*           3  LCCWSI BIT(1),          /* SESS INIT / START DIALOG FLG*
*           3  LCCWSD BIT(1),          /* SESS DISCON/END DIALOG FLG  *
*           3  LCCWRWOP BIT(6),        /* READ/WRITE OPERATION CODE   *
*              4  * BIT(1),            /* RESERVED                    *
*              4  LCCWSOP BIT(1),      /* SPECIAL OPERATION LIKE   0276
*                                         ERASE OR READ CONT          *
*              4  LCCWCTL BIT(4),      /* CONTROL TYPE                *
*                 5  LCCWMODE BIT(2),  /* MODE TYPE                   *
*                 5  LCCWTYPE BIT(2),  /* OPERATION TYPE              *
*        2  LCCWFLAG  CHAR(1),         /* FLAG BYTE                   *
*           3  LCCWCD BIT(1),          /* CHAIN DATA                  *
*           3  LCCWCC BIT(1),          /* CHAIN COMMAND               *
*           3  LCCWCKPT BIT(1),        /* SUPPRESS 3705 CHECK POINT
*                                         RECORD                      *
*           3  LCCWNTVC BIT(1),        /* DO NOT PERFORM VALCHEK      *
*           3  LCCWIDAT BIT(1),        /* LCCWDATA CONTAINS DATA      *
*           3  LCCWLSI BIT(1),         /* LCCW SYNCH INDICATOR        *
*              4  LCCWPER BIT(1),      /* POST=RESP                   *
*           3  LCCWRFI BIT(1),         /* REQUEST FEEDBACK INDICATOR  *
*           3  LCCWACI BIT(1),         /* ADDITION COMMAND INDICATOR  *
*        2  LCCWCNT FIXED(16),         /* DATA COUNT                  *
*        2  LCCWDATA PTR(31);          /* DATA ADDRESS OR IMMED. DATA *
*/* LOGICAL COMMAND CODES */                                       0277
*DCL  LXDQ     BIT(8) CONSTANT('3B'X), /* RESET DEVICE QUEUE          *
*     LXEC     BIT(8) CONSTANT('4B'X), /* RESET AT END OF COMMAND     *
*     LXO      BIT(8) CONSTANT('5B'X), /* RESET ORDERLY               *
*     LCCWPRGE BIT(8) CONSTANT('6B'X), /* PURGE                       *
*     LWH      BIT(8) CONSTANT('0F'X), /* WRITE HEADER INDI. 1ST BLOCK*
*     LWRVI    BIT(8) CONSTANT('1F'X), /* WRITE RVI                   *
*     LWNA     BIT(8) CONSTANT('2F'X), /* WRITE NEGATIVE ACK          *
*     LWAA     BIT(8) CONSTANT('3F'X), /* WRITE ALTERNATE ACK         *
*     LWPLG    BIT(8) CONSTANT('5F'X), /* WRITE ACK LEADING GRAPHICS  *
*     LWNLG    BIT(8) CONSTANT('6F'X), /* WRITE NACK LEADING GRAPHICS *
*     LSMDE    BIT(8) CONSTANT('4F'X), /* SET MODE                    *
*     LIFBM    BIT(8) CONSTANT('7F'X), /* INDIC 1ST BLOCK OF MESSAGE  *
*     LTEST    BIT(8) CONSTANT('FE'X), /* TEST LCCW                   *
*     LPRMPT   BIT(8) CONSTANT('13'X), /* PREEMPT LCCW                *
*     LRSTR    BIT(8) CONSTANT('43'X), /* RESTORE LCCW                *
*     LEXEC    BIT(8) CONSTANT('FF'X), /* SPECIAL CONTROL OPERATION   *
*     LREAD    BIT(2) CONSTANT('10'B),  /* READ TYPE LCCW             *
*     LWRITE   BIT(2) CONSTANT('01'B),  /* WRITE TYPE LCCW            *
*     LCNTRL   BIT(2) CONSTANT('11'B),  /* CONTROL TYPE LCCW          *
*     LRESET   BIT(4) CONSTANT('1011'B),/* RESET COMMANDS             *
*     LTIC     BIT(8) CONSTANT('08'X),  /* LOGICAL TIC                *
*     LWR      BIT(6) CONSTANT('000001'B),  /* WRITE CONVERSATIONAL   *
*     LWB      BIT(6) CONSTANT('000101'B),  /* WRITE BLOCK            *
*     LWM      BIT(6) CONSTANT('001001'B),  /* WRITE MESSAGE          *
*     LWT      BIT(6) CONSTANT('001101'B),  /* WRITE TRANSMISSION     *
*     LEWM     BIT(6) CONSTANT('011001'B),  /* ERASE/WRITE MESSAGE    *
*     LEWT     BIT(6) CONSTANT('011101'B),  /* ERASE/WRITE TRNSMSSN   *
*     LEAU     BIT(6) CONSTANT('010001'B),  /* ERASE ALL UNPROTECTED  *
*     LRB      BIT(6) CONSTANT('000110'B),  /* READ BLOCK             *
*     LRM      BIT(6) CONSTANT('001010'B),  /* READ MESSAGE           *
*     LRT      BIT(6) CONSTANT('001110'B),  /* READ TRANSMISSION      *
*     LRMOD    BIT(6) CONSTANT('010010'B),  /* READ MODIFIED          *
*     LRBUF    BIT(6) CONSTANT('010110'B),  /* READ BUFFER            *
*     LRCONT   BIT(6) CONSTANT('011010'B),  /* READ CONTINUOUS        *
*     LRPEP    BIT(6) CONSTANT('011110'B),  /* READ PERPETUAL         *
*     LCPYM    BIT(6) CONSTANT('101001'B),  /* COPY MESSAGE           *
*     LCPYT    BIT(6) CONSTANT('101101'B),  /* COPY TRANSMISSION      *
*     LD       BIT(8) CONSTANT('23'X),  /* DISCONNECT                 *
*     LDEC     BIT(8) CONSTANT('33'X),  /* DISCONNECT WITH END OF CALL*
*     LEOC     BIT(8) CONSTANT('53'X),  /* END OF CALL COMMAND        *
*     LXEL     BIT(8) CONSTANT('0B'X),  /* RESET ERROR LOCK           *
*     LXC      BIT(8) CONSTANT('1B'X),  /* RESET CONDITIONAL          *
*     LXI      BIT(8) CONSTANT('2B'X),  /* RESET IMMEDIATE            *
*     LC       BIT(8) CONSTANT('03'X),  /* CONTACT                    *
*     LWPA     BIT(8) CONSTANT('FD'X); /* WRITE POSITIVE ACK          *
*DCL  LMT      BIT(2) CONSTANT('11'B), /* TRANSMISSION MODE           *
*     LMS      BIT(2) CONSTANT('00'B), /* SPECIAL MODE LIKE CONV, EAU *
*     LMB      BIT(2) CONSTANT('01'B), /* BLOCK MODE                  *
*     LMM      BIT(2) CONSTANT('10'B); /* MSG OR CONTINUOUS MODE      *
*/* FOLLOWING EQUATES FOR  - PORT SOLICITOR (DIAL)                    *
*/* PORT SOLICITOR COMMAND CODES                                      *
*DCL PSOL    BIT(8) CONSTANT('FE'X), /* SPECIAL PORT SOLICITOR     0279
*                                       COMMAND                       *
*    STCTL    BIT(8) CONSTANT('01'X), /* START CONTROL                *
*    RESTCTL  BIT(8) CONSTANT('02'X), /* RESET & CONTROL - REDRIVE    *
*    STIPUT   BIT(8) CONSTANT('03'X); /* START INPUT                  *
*/*   FOLLOWING EQUATES FOR SDLC SUPPORT                              *
*DCL  LCCHOLD  BIT(8) CONSTANT('01'X),  /* HOLD                       *
*     LCCRHOLD BIT(8) CONSTANT('02'X),  /* RELEASE HOLD               *
*     LSEND    BIT(8) CONSTANT ('F1'X), /* SEND                       *
*     LCLEAR   BIT(8) CONSTANT ('F2'X), /* CLEAR                      *
*     LCRUD    BIT(8) CONSTANT ('F3'X), /* CLEAR, UNBIND              *
*     LCRUDNFY BIT(8) CONSTANT ('F4'X), /* CLEAR, UNBIND, NOTIFY      *
*     LNFY     BIT(8) CONSTANT ('F5'X), /* NOTIFY                     *
*     LRELCB   BIT(8) CONSTANT ('F6'X), /* RELEASE CB                 *
*     LRESTSR  BIT(8) CONSTANT ('F7'X), /* RESETSR                    *
*     LCLRNFY  BIT(8) CONSTANT('F8'X),  /* CLEAR/NOTIFY               *
*     LCHPUR   BIT(8) CONSTANT('F9'X);  /* PURGE                      *
*DCL  LCCWSIZE FIXED(8) CONSTANT(8);    /* LCCW SIZE                  *
*DCL  LRDS     BIT(8) CONSTANT('FF'X);  /* RECORD DEV STATS COMMAND   *
*DCL  LQUIS    BIT(8) CONSTANT('FE'X);  /* QUIESCE COMMAND            *
*/*              LOGICAL CHANNEL PROGRAM BLOCK                       */
*/*                                                                  */
*/*  REVISIONS                                         007 05/19/75  */
*/*                                                                  */
*DCL  1  ISTLCPB BDY(WORD) BASED(LCPBPTR),                         0284
*        2 LCPTYPE CHAR(1),            /* TYPE CODE                  */
*        2 LCPLNGTH  PTR(8),           /* LENGTH IN BYTES            */
*        2 LCPREQTG CHAR(2),           /* LCPB REQ. TAG FIELD        */
*          3 LCPFLAGS BIT(8),          /* FLAG BYTE                  */
*            4 LCPZRT00 BIT(1),        /* LOGICAL ERROR FLAG         */
*            4 LCPZRT01 BIT(1),        /* CONTROL BLOCK ERROR        */
*            4 LCPZF001 BIT(1),        /* LCP START PROCESS FLAG     */
*              5 LCPZRT02 BIT(1),      /* I/O INITIATION DISABLED    */
*                6 LCPZRTL2 BIT(1),    /* END OF SCHEDULABLE BLOCK   */
*            4 LCPZF002 BIT(1),        /* LCP IN PROCESSING FLAG     */
*              5 LCPZRT03 BIT(1),      /* GO LOOK AT FMCB LINE STATE */
*                                      /* FIELD (REQ. TAG OVERLAY)   */
*                6 LCPZRTL3 BIT(1),    /* WRITE/READ REQUEST         */
*            4 LCPZF003 BIT(1),        /* LCP PROCESSING COMPLETE FLAG*
*              5 LCPZRT04 BIT(1),      /* STPR SET IN BDU FLAG       */
*                                      /* (REQ. TAG OVERLAY)         */
*                6 LCPZRTL4 BIT(1),    /* FEEDBACK REQUESTED         */
*            4 LCPZF004 BIT(1),        /* SINGLE LCCW/LCP FLAG       */
*              5 LCPZRT05 BIT(1),      /* FEEDBACK TO BE ROUTED TO   */
*                                      /* ICNCB FMCB (REQ. TAG       */
*                                      /* OVERLAY)                   */
*                6 LCPZRTL5 BIT(1),    /* DECREMENT SCHED COUNT ON DEQ*
*            4 LCPZRT06 BIT(1),        /* CRITICAL TEXT BLOCK        */
*                                      /* FLAG (REQ. TAG OVERLAY)    */
*              5 LCPZRTL6 BIT(1),      /* WRITE REQUEST              */
*            4 LCPZRT07 BIT(1),        /* BUFFER TRACE ACTIVE        */
*                                      /* FLAG (REQ. TAG OVERLAY)    */
*              5 LCPZRTL7 BIT(1),      /* SCHEDULING FLAG            */
*          3 LCPMNRCD CHAR(1),         /* LCP MINOR REJECTION CODE   */
*            4 LCPZRT08 BIT(1),        /* I/O TRACE ACTIVE FLAG      */
*                                      /* (REQ. TAG OVERLAY)         */
*              5 LCPZRTL8 BIT(1),      /* DEVICE END NOTIFICATION    */
*            4 LCPZRT09 BIT(1),        /* DIALOGUE SCHED DISABLED    */
*              5 LCPZRTL9 BIT(1),      /* CRITICAL TEXT FLAG         */
*            4 LCPZRT0A BIT(1),        /* SIMULATED CONTACT FLAG     */
*            4 LCPZRT0B BIT(1),        /* SIMULATED DISCONNECT FLAG  */
*        2 LCPCHAIN PTR(31),           /* APS CHAIN                  */
*          3 LCPCHAI1 PTR(8),                                      0284
*            4 LCPCHNG BIT(1),         /* GATE BIT                   */
*          3 LCPCHAI2 PTR(24),         /* ADDRESS FIELD              */
*        2 LCPRUCNT PTR(8),            /* NUMBER OF RU FOR THIS LCPB */
*          3 LCPZMIRC CHAR(1),         /* MINOR RETURN CODE          */
*        2 LCPFLAG2 CHAR(1),           /* SECOND FLAG BYTE           */
*          3 LCPPRFLG BIT(1),          /* PACING REQUIRED            */
*          3 LCPASYN  BIT(1),          /* ASYNCHRONOUS LCPB          */
*          3 LCPRSTRT BIT(1),          /* RESTART LCPB               */
*          3 LCPTLBPI BIT(1),          /* TPIOS BLOCK LCCW           */
*            4 LCPZRIMM BIT(1),        /* RESET IMMED REQUIRED ON ERR*/
*          3 LCPFID0  BIT(1),          /* FID0 TH INDICATOR FOR RECORD*
*            4 LCPEXRES BIT(1),        /* EXCEP. RESPONSE SPEC. 3270R*/
*          3 LCPDSTAT BIT(1),          /* DIALOGUE STATE BIT, 3270R  */
*                                      /* 0=REQ. REJECT,1=STATE ERROR*/
*          3 LCPFREE  BIT(1),          /* DEALLOCATE LCPB 3270R      */
*          3 LCPATOP  BIT(1),          /* ATOP LCPB  3270R           */
*        2 LCPSEQ   FIXED(16),         /* OUTBOUND SEQUENCE NUMBER   */
*          3 LCPRRCCT PTR(8),          /* COUNT OF RESPONSES RECEIVED*/
*          3 LCPRRCNT PTR(8),          /* COUNT OF RESPONSES REQUESTED*
*        2 LCPLCCW1 PTR(31),           /* ADDR FIRST LCCW FOR FID1   */
*        2 LCPCID CHAR(4) BDY(WORD),   /* COMMUNICATION ID           */
*          3 LCPSAF BIT(16),           /* SOURCE IDENTIFICATION      */
*          3 LCPDAF BIT(16),           /* DESTINATION IDENTIFICATION */
*        2 LCPNXLCW PTR(31),           /* ADDR NEXT LCCW             */
*        2 LCPFDBA PTR(31),            /* BTU ADDRESS                */
*          3 LCPFDB1 PTR(8),                                       0284
*          3 LCPFDB2 PTR(24),          /* ADDRESS FIELD              */
*        2 LCPTLBAD PTR(31),           /* ADDRESS OF TLB             */
*        2 LCPFOSN  BIT(16),           /* SEQUENCE NUMBER FIRST RU   */
*        2 LCPFSNCH FIXED(16),         /* 1ST SEQ NUMBER IN RU CHAIN */
*        2 LCPSTYPE FIXED(8),          /* LCPB SUB-TYPE X'FF' = RESET,*
*                                      /* X'00' = NON-RESET          */
*        2 LCPFLG1 CHAR(1),            /* FLAGS                      */
*          3 LCPRESET BIT(1),          /* A TPQUE WITH RESET QUEUED  */
*                                      /* THIS ELEMENT               */
*          3 LCPINTER BIT(1),          /* INTERNAL LCPB              */
*          3 LCPDIRPT BIT(1),          /* NOT SEND W/POST=SCHED=0    */
*          3 LCPREDRV BIT(1),          /* LCPB IS FOR REDRIVE        */
*          3 LCPSTLB  BIT(1),          /* TLB NOT TO BE FREED        */
*          3 LCPTRANS BIT(1),          /* DATA INCLUDES CONTROL CHARS*/
*          3 LCPRSV78 BIT(2),          /* RESERVED                   */
*        2 LCPLCCWC BIT(8),            /* COUNT OF LCCWS             */
*        2 LCPRSV77 CHAR(1),           /* RESERVED                   */
*        2 LCPFLCCW PTR(31),           /* ADDR OF FIRST LCCW         */
*          3 LCPUBFSB PTR(31),         /* UNBIND FSB ADDRESS         */
*        2 LCPCLREP PTR(31),           /* PTR TO CLEAR LCPB IN UCB   */
*/*  NOTE:  THE FOLLOWING FIELD - LCPLCCW MUST BE THE LAST FIELD     */
*/*         IN THIS CONTROL BLOCK.  THE CONTROL BLOCK ISTDCLCP HAS   */
*/*         FIELDS IN IT WHICH MUST BE CONTIGUOUS WITH LCPLCCW       */
*        2 LCPLCCW  CHAR(LENGTH(ISTLCCW)) BDY(WORD), /* FIRST LCCW   */
*          3 LCPRSTQH PTR(31),         /* RESET LCPB QUEUE HEADER    */
*          3 LCPPABA  PTR(31),         /* PAB POINTER                */
*            4 LCPRPHA  PTR(31),       /* RPH POINTER                */
*              5 LCPFTYPE BIT(1);      /* FEEDBACK TYPE              */
*/*     CONSTANTS FOR LCPTYPE                                         *
*DCL  LCRPHFT  BIT(1) CONSTANT('1'B);                              0285
*DCL  LCPABFT  BIT(1) CONSTANT('0'B);                              0286
*DCL LCPBFIRM BIT(8) CONSTANT('10'X);  /* LU FAILED, CLSDST, SCHED LOST
*                                         TERM, OPNDST MAY BE TRIED   *
*DCL LCPBTERM BIT(8) CONSTANT('11'X);  /* TERM RECEIVED,CLSDST,    0288
*                                         SCHED LOST TERM             *
*/*                                                                   *
*                                                                  0289
*DCL 1 LCPZTIE BDY(WORD) DEFINED(LCPCID), /* TOLTEP INTERFACE      0289
*                                         ELEMENT OVERLAY            */
*       2  LCPZFMCA PTR(31),           /* ACTIVE FMCB ADDRESS        */
*       2  LCPZSNA PTR(31),            /* SYMBOLIC NAME ADDRESS      */
*       2  LCPZSNAM CHAR(8) BDY(WORD), /* SYMBOLIC NAME              */
*          3  LCPZTRV1 PTR(31),        /* RESERVED FOR RESTORE LCP   */
*          3  LCPZTRV4 PTR(31);        /* RESERVED FOR RESTORE LCP   */
*DCL LCTYPE BIT(8) CONSTANT('04'X);                                0290
*DCL PLCPTYPE BIT(8) CONSTANT('28'X);  /* PURGE LCPB TYPE ID         */
*DCL LCPCLACB BIT(8) CONSTANT('04'X);  /* LCPB FROM CLOSE ACB        */
*DCL LSRSTYPE BIT(8) CONSTANT('FF'X);  /* RESET SUBTYPE              */
*DCL LCPETYPE BIT(8) CONSTANT('40'X);  /* EXTENDED LCPB TYPE ID      */
*/*                                                                  */
*/*  MINOR RETURN CODES                                              */
*/*                                                                  */
*DCL LCMCRSTR BIT(8) CONSTANT('F7'X),  /* MINOR RC FOR RESETSR       */
*    LCPMNEW  BIT(8) CONSTANT('02'X),  /* EARLY WARNING,             */
*                                      /* RECOVERY IN PROGRESS       */
*    LCPMNPF  BIT(8) CONSTANT('03'X),  /* PERM. I/O FAILURE          */
*    LCPMNAS  BIT(8) CONSTANT('04'X),  /* AUTO NETWORK SHUTDOWN      */
*    LCPMNCL  BIT(8) CONSTANT('06'X),  /* CLOSE/CLSDST OCCURED       */
*    LCPMNVD  BIT(8) CONSTANT('07'X),  /* VARY DEACTIVATE            */
*    LCPMNTF  BIT(8) CONSTANT('10'X),  /* TEMP RECORD DEVICE FAILURE */
*    LCPMNSF  BIT(8) CONSTANT('01'X),  /* TEMP BASIC FAILURE /       */
*    LCPMNTS  BIT(8) CONSTANT('11'X),  /* TERMINATE SELF             */
*    LCPMNAP  BIT(8) CONSTANT('0A'X),  /* APPL. ISSUED CLEAR         */
*    LCPMNPR  BIT(8) CONSTANT('0B'X),  /* PREEMPT                    */
*    LCPMNRE  BIT(8) CONSTANT('0C'X);  /* RESTORE                    */
*/* VS1, VS2 TPIOS SAVEAREA FORMAT */                              0296
*DCL  1  ISTZSAVE BDY(WORD) BASED,                                 0296
*        2   ZSAZSVBC PTR(31),         /* SAVEAREA BACK CHAIN        */
*            3   ZSAZSVMS CHAR(1),     /* MODULE TRACE CODE          */
*                4 ZSAZACTV BIT(1),    /* ACTIVE SAVE AREA FLAG      */
*        2   ZSAZSVFC PTR(31),         /* SAVEAREA FORWARD CHAIN     */
*        2   ZSAZSVRR PTR(31),         /* RETURN REGISTER            */
*        2   ZSAZSVVR (6) PTR(31),    /* VARIABLE REGS (7-12) SVEAREA*/
*        2   ZSAZTRAC CHAR(4);        /* EBCDIC NAME OF OWNER        */
*/*                                                                0297
*THE FOLLOWING EQUATES SHOULD READ ''FIXED(8) CONSTANT(LENGTH(X))'',
*WHERE X IS THE NAME OF THE VARIABLE CONTROL BLOCK OR FIELD OF WHICH
*LENGTH IS THE VALUE BEING EQUATED, SHOULD THE PLS COMPILER BE     0297
*BE ABLE TO TAKE IT.                                               0297
*                                                                    */
*DCL ZSAZSVVA FIXED(8) CONSTANT(8);  /* DISPLACEMENT TO VARIABLE REGS*/
*DCL ZSAZSVSZ FIXED(8) CONSTANT(40); /* LENGTH OF ISTZSAVE           */
*/* PREFIX FOR CRR                                                   */
*/*                                                                  */
*/* RELEASE 1 - JUNE 28, 1973                                        */
*/*                                                                  */
*DCL 1 ISTPFCRR BASED BDY(WORD),        /* PREFIX FOR CRR            */
*     2  PFCCRR   CHAR(4),              /* CRR HEADER                */
*        3  PFCCRRID CHAR(1),           /* CRR ID FIELD              */
*           4  CRRID CHAR(1),           /* BASIC CTL LAYER DEFINITION*/
*        3  PFCRSV10 CHAR(1),           /* RESERVED FOR ALIGNMENT    */
*        3  PFCCRRLN CHAR(2),           /* CRR LENGTH                */
*           4  CRRLEN CHAR(2),          /* BASIC CTL LAYER DEF       */
*     2  PFCHDR CHAR(8) BDY(WORD),      /* SAVE AREA FOR OLD CRR FRR */
*        3  PFCCRRO  PTR(31),           /* PTR TO OLD CRR            */
*           4  CRRCHAIN PTR(31),        /* BASIC CTL LAYER DEFINITION
*                                          FOR OLD CRR PTR           */
*        3  PFCFRRO  PTR(31),           /* PTR TO OLD FRR            */
*           4  CRRFRR   PTR(31),        /* BASIC CTL LAYER         0299
*                                          DEFINITION OF OLD FRR PTR */
*     2  PFCFTA BIT(8),                 /* ID OF LAST FUNCTION TRACED*/
*     2  PFCRSV01 CHAR(3);              /* ALIGNMENT                 */
*DCL PFIDPIE BIT(8) CONSTANT('80'X);    /* DOS/VS TPIOS              */
*DCL PFIDORE BIT(8) CONSTANT('81'X);    /* DOS/VS BMS                */
*DCL PFIDAPE BIT(8) CONSTANT('82'X);    /* DOS/VS PSS                */
*DCL PFCIDPSV BIT(8) CONSTANT('38'X); /* COMPONENT ID              0303
*                                          PSS - VS1 AND 2           */
*DCL PFCIDTPV BIT(8) CONSTANT('3C'X); /* COMPONENT ID              0304
*                                          TPIOS VS1 AND 2           */
*DCL PFCIDSME BIT(8) CONSTANT('3D'X); /* COMPONENT ID              0305
*                                          STORAGE MANAGEMENT DOS    */
*DCL PFCIDOC BIT(8) CONSTANT('31'X);    /* COMPONENT ID OPEN/CLOSE   */
*DCL PFCIDPS BIT(8) CONSTANT('32'X);    /* PORT SOLICITOR            */
*DCL PFCIDCS BIT(8) CONSTANT('34'X);    /* CLUSTER SOLICITOR         */
*DCL PFCIDIT BIT(8) CONSTANT('35'X);    /* INIT/TERM                 */
*DCL PFCIDVY BIT(8) CONSTANT('36'X);    /* VARY                      */
*DCL PFCIDNS  BIT(8) CONSTANT('37'X);   /* NET. STAT.SRV.            */
*DCL PFCIDTPE BIT(8) CONSTANT('38'X);   /* COMPONENT ID            0312
*                                          TPIOS - DOS               */
*DCL PFCIDCL BIT(8) CONSTANT('39'X);    /* COMPONENT ID            0313
*                                          CONTROL LAYER             */
*DCL PFCIDPSE BIT(8) CONSTANT('3A'X);   /* COMPONENT ID            0314
*                                          PSS - DOS                 */
*DCL PFCIDSMV BIT(8) CONSTANT('3F'X);   /* COMPONENT ID            0315
*                                          STORAGE MANAGEMENT        */
*DCL PFCIDTIO BIT(8) CONSTANT('40'X);   /* COMPONENT ID TIIO       0316
*                                          PROCESSING (VS2)          */
*DCL PFCIDRS  BIT(8) CONSTANT('41'X);   /* ID FOR REMOTE SOLICITOR   */
*/* CRR FOR COMMAND FACILITIES                                      */
*/*  REVISIONS                                         001 06/02/75 */
*DCL  1  ISTCFCRR BDY(WORD) BASED, /* CRR FOR COMMAND FACILITIES    */
*        2 CFCAUDIT,               /* AUDIT TRAIL FOR CMD FACILITIES*/
*          3 CFCNTRD  CHAR(1),     /* LIST OF MODULES IN COMMAND    */
*                                  /* FACILITIES ENTERED            */
*            4 NCFCS1   BIT(1),    /* IND MODULE ISTCFCS1 ENTERED   */
*            4 NCFCS2   BIT(1),    /* IND MODULE ISTCFCS2 ENTERED   */
*            4 NCFCR1   BIT(1),    /* IND MODULE ISTCFCR1 ENTERED   */
*            4 NCFCRP   BIT(1),    /* IND MODULE ISTCFCRP ENTERED   */
*            4 NCFCR2   BIT(1),    /* IND MODULE ISTCFCR2 ENTERED   */
*            4 NCFRSVD  BIT(3),    /* RESERVED                      */
*          3 CFCCRT   CHAR(1),     /* LIST OF MODULES IN COMMAND    */
*                                  /* FACILITIES RUNNING            */
*            4 CCFCS1   BIT(1),    /* IND MODULE ISTCFCS1 RUNNING   */
*            4 CCFCS2   BIT(1),    /* IND MODULE ISTCFCS2 RUNNING   */
*            4 CCFCR1   BIT(1),    /* IND MODULE ISTCFCR1 RUNNING   */
*            4 CCFCRP   BIT(1),    /* IND MODULE ISTCFCRP RUNNING   */
*            4 CCFCR2   BIT(1),    /* IND MODULE ISTCFCR2 RUNNING   */
*            4 CCFRSVD1 BIT(3);    /* RESERVED                      */
*DCL TIDCFCS1 BIT(8) CONSTANT('00'X); /* THREAD ID FOR ISTCFCS1     */
*DCL TIDCFCR1 BIT(8) CONSTANT('01'X); /* THREAD ID FOR ISTCFCR1     */
*DCL TIDCFCR2 BIT(8) CONSTANT('02'X); /* THREAD ID FOR ISTCFCR2     */
*/* COMPONENT RECOVERY RECORD FOR TPIOS */                         0322
*/*  DELTA                                             006 02/10/75  */
*DCL                                                               0322
*1  ISTZCRR BDY(WORD) BASED,     /* CONTROL WORD                     */
*   2  ZCRCRR CHAR(4),           /* CONTROL WORD                     */
*      3  ZCRID CHAR(1),         /* CONTROL BLOCK ID                 */
*      3  ZCRLEN CHAR(2),        /* LENGTH OF ZCR                    */
*      3  ZCRFLAG CHAR(1),       /* FLAGS                            */
*   2  ZCRCHAIN PTR(31),         /* POINTER TO PREVIOUS ZCR          */
*   2  ZCRFRRA PTR(31),          /* PTR TO FRR                       */
*   2  ZCRFLGS1 CHAR(1),         /* FLGS USED BY REQUEST COMPLETION  */
*      3  ZCREXSW BIT(1),        /* EXIT SWITCH                      */
*      3  ZCRQUESW BIT(1),       /* QUEUE SWITCH                     */
*      3  ZCRDEQSW BIT(1),       /* DEQUEUE SWITCH                   */
*      3  ZCRWAIT BIT(1),        /* WAIT Q ANALYSIS COMPLETE         */
*      3  ZCRNRMEX BIT(1),       /* NORMAL EXIT TO BE TAKEN          */
*      3  ZCRENDLP BIT(1),       /* END OF LOOP SWITCH               */
*      3  ZCRUNSOL BIT(1),       /* UNSOLICITED DATA                 */
*      3  ZCRFEXIT BIT(1),       /* FORCE EXIT SWITCH                */
*   2  ZCRFLGS2 CHAR(1),         /* FLAGS USED WITHIN TPIOS          */
*      3  ZCRLOCAL BIT(1),       /* LOCAL SUPPORT                    */
*      3  ZCRSHEDI BIT(1),       /* IMMEDIATE SCHEDULE               */
*      3  ZCRFMSED BIT(1),       /* FMCB SEARCH ENDED                */
*      3  ZCROB    BIT(1),       /* OUTBOUND PROC IN PROGRESS        */
*      3  ZCRIF0E1 BIT(1),       /* SWITCH FOR STRUCTURED PGM USED BY
*                                   INBOUND PROCESSING               */
*      3  ZCRIF0E2 BIT(1),       /* SWITCH FOR STRUCTURED PGM USED BY
*                                   INBOUND PROCESSING               */
*      3  ZCRIF0E3 BIT(1),       /* SWITCH FOR STRUCTURED PGM USED BY
*                                   INBOUND PROCESSING               */
*   2  ZCRSWFLD CHAR(1),         /* SWITCHES FOR TPIOS OUTBOUND      */
*      3  ZCRENDSH BIT(1),       /* EXIT FROM REMOTE DEV SCHEDULER   */
*         4  ZCRSLCP BIT(1),     /* SCHEDULE LCPB                    */
*      3  ZCREXTYP BIT(1),       /* TPEXIT TYPE                      */
*      3  ZCRENDPR BIT(1),       /* EXIT FROM INNER PROCESS          */
*      3  ZCRNDLCP BIT(1),       /* EXIT FROM LCPB PROCESSING        */
*         4  ZCROB1 BIT(1),      /* REMOTE DEV SCHED 1ST TIME SWITCH */
*      3  ZCRENDX BIT(1),        /* EXIT FROM LCCW/BTU XLATION       */
*      3  ZCRENDXL BIT(1),       /* EXIT FROM LCCW PROC              */
*      3  ZCRENDAN BIT(1),       /* EXIT FROM LCPB ANALYSIS          */
*      3  ZCRRESET BIT(1),                                         0322
*         4  ZCRCNLXL BIT(1),    /* CANCEL FURTHER XLATE             */
*   2  ZCRFLGS3 CHAR(1),         /* FLAGS FOR OUTBOUND PROCESSING    */
*      3  ZCRTIC BIT(1),         /* SELECT NOT TO BE SENT            */
*      3  ZCRTPCON BIT(1),       /* TPIOS CONTACT SENT               */
*      3  ZCRTPDIS BIT(1),       /* TPIOS DISCONNECT TO BE SENT      */
*      3  ZCRDISC  BIT(1),       /* DISCONNECT IN PROCESS            */
*      3  ZCREDRIV BIT(1),       /* DO DERIVE                        */
*      3  ZCRNOFRE BIT(1),       /* NO FREEING OF SIO QUEUE          */
*      3  ZCRWRPTR BIT(1),       /* WRITE TO PRINTER REQUEST         */
*      3  ZCRINLCP BIT(1),       /* ERROR OCCURED DURING OUTBND PROC */
*   2  ZCRGENSW CHAR(1),         /* GENERAL SWITCHES                 */
*      3  ZCRTSW1  BIT(1),       /* TEMP SW FOR STRUCTURED PGM       */
*      3  ZCRTSW2  BIT(1),       /* TEMP SW FOR STRUCTURED PGM       */
*      3  ZCRRT06  BIT(1),       /* CRITICAL TEXT OPTION             */
*      3  ZCRLCSYN BIT(1),       /* LCCW SYNC SPECIFIED              */
*      3  ZCREXRES BIT(1),       /* EXCEPTION RESPONSE SPECIFIED     */
*      3  ZCRCLRBD BIT(1),       /* FLAG INDICATING BIND WAS CLEARED */
*      3  ZCRBRIS  BIT(1),       /* BRACKET REJECTED DUE TO IN BRAC. */
*      3  ZCRF1RES BIT(1),       /* FID1 RESPONSE TO BE GENERATED    */
*   2  ZCRPFLGS CHAR(1),         /* UTILITIES PROC OPTION FLAGS      */
*      3  ZCRQAHED BIT(1),      /* QXFR RTN TO USE INSERT OPT'N ON TPQ*
*      3  *        BIT(7),      /* RESERVED                          */
*   2  ZCRIBPR CHAR(1),          /* INBOUND PROCESSING FLAGS         */
*         3  ZCRNOBUF BIT(1),    /* FSB WITH NO BUFFER               */
*         3  ZCRERR   BIT(1),    /* ERROR INDICATOR                  */
*         3  ZCRRELK  BIT(1),    /* RESET ERROR LOCK FUNCTION REQ.   */
*         3  ZCRLCPFR BIT(1),    /* FLAG IND. DEALLOCATE ATOP LCPB   */
*         3  ZCRLCPFD BIT(1),    /* FLAG IND. LCPB FOUND ON WAITQ    */
*         3  ZCR3270  BIT(1),    /* 3270 DEVICE                      */
*         3  ZCR3270R BIT(1),    /* 3270 DEVICE IN RECORD MODE       */
*         3  *        BIT(1),    /* RESERVED                         */
*   2  ZCRSCPSW CHAR(1),         /* SESSION CONTROL FLAGS            */
*         3  ZCRTPEX BIT(1),     /* TP EXIT                          */
*         3  ZCRTPINV BIT(1),    /* INVOKE TPIOS                     */
*         3  ZCRRJLCP BIT(1),    /* LCPB REJECTED                    */
*         3  ZCRLREQ BIT(1),     /* REQUEST                          */
*         3  ZCRPRCMP BIT(1),    /* PROCESSING COMPLETE              */
*         3  ZCRFSBWE BIT(1),    /* FSB IS WORK ELEMENT              */
*         3  ZCRSKIPT BIT(1),    /* SKIP TRACE FLAG                  */
*         3  *       BIT(1),     /* RESERVED                         */
*   2  ZCRCRLCP PTR(31),         /* CURRENT LCPB PTR                 */
*   2  ZCRPARMS BDY(WORD),       /* PARAMETERS PASSED TO UTILITIES */
*      3  ZCRFBPTR PTR(31),      /* PTR TO FROM BUFFER               */
*         4  ZCRCBPTR PTR(31),   /* PTR TO CURRENT BUFFER            */
*      3  ZCRTBPTR PTR(31),      /* PTR TO TO-OR-TRANSLATE BUFFER    */
*      3  ZCRMLNG FIXED(15),     /* LENGTH TO MOVE                   */
*      3  ZCRDFRDA FIXED(15),    /* OFFSET FROM DATA ADDR IN FROM BUF*/
*         4  ZCRDTODA FIXED(15), /* OFFSET FROM DATA ADDR XLATE BUF  */
*      3  ZCRPCOD1 CHAR(1),      /* CODE BYTE FOR ALLOC/DISALLOC     */
*         4  ZCRPPG BIT(1),      /* GET PAGEABLE BUFF                */
*         4  ZCRPLNG BIT(1),     /* LENGTH OF BUFFER SPECIFIED       */
*         4  ZCRPFSB BIT(1),     /* GET FSB                          */
*         4  ZCRPLSBF BIT(1),    /* GET LSCB AND BUFFER              */
*            5 ZCRPLSBQ BIT(1),  /* PURGE LSCB QUEUE                 */
*         4  ZCRPLSCB BIT(1),    /* GET OR RELEASE LSCB              */
*         4  ZCRPBUF BIT(1),     /* GET OR RELEASE BUFFER            */
*         4  ZCRPCFTX BIT(1),    /* CONFIDENTIAL TEXT                */
*         4  ZCRPRES BIT(1),     /* RESERVED                         */
*      3  ZCRPCOD2 CHAR(1),      /* CODE BYTE FOR MOVE               */
*         4  ZCRPPG2 BIT(1),     /* GET PAGEABLE BUFFER              */
*         4  ZCRPFHDR BIT(1),    /* FROM BUFFER FDB TO BE USED       */
*         4  ZCRPMFGF BIT(1),    /* MOVE STARTS WIHT 1ST BUFF IN BLOCK*
*         4  ZCRPRES2 BIT(5),    /* RESERVED                         */
*      3  ZCRPCHAR CHAR(1),      /* TRANSLATE & TEST SEARCH CHARACTER*/
*      3  ZCRPSW   CHAR(1),      /* SWITCH FIELD                     */
*   2  ZCRCCWA PTR(31),          /* PTR TO CURRENT CCW (CCW 1 OR 2)  */
*   2  ZCRBFPTR PTR(31),         /* SAVE 1ST BUFF PTR IN TO-BUFF CHN
*                                   OR LAST BUFFER IN CHANNEL PGM    */
*   2  ZCRZLB PTR(31),           /* PTR TO CURR BUFF IN CHANNEL PGM  */
*   2  ZCRPVZB PTR(31),          /* PTR TO PREVIOUS BUFF IN CHAN PGM */
*   2  ZCRSVRTN BDY(WORD),       /* REG 14 SAVE AREAS                */
*      3  ZCRSVF1 PTR(31),       /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF2 PTR(31),       /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF3 PTR(31),       /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF4 PTR(31),       /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF5 PTR(31),       /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF6 PTR(31),       /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF7 PTR(31),       /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF8 PTR(31),       /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF9 PTR(31),       /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF10 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF11 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF12 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF13 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF14 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF15 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF16 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF17 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF18 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF19 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF20 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF21 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF22 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF23 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF24 PTR(31),      /* SAVE REQUIRED REGISTER           */
*      3  ZCRSVF25 PTR(31),      /* SAVE REQUIRED REGISTER           */
*   2  ZCRWKARA BDY(WORD),       /* TEMPORARY REG SAVE AREA          */
*      3  ZCRSVWK1 PTR(31),      /* SAVE REQUIRED REG                */
*      3  ZCRSVWK2 PTR(31),      /* SAVE REQUIRED REG                */
*      3  ZCRSVWK3 PTR(31),      /* SAVE REQUIRED REG                */
*      3  ZCRSVWK4 PTR(31),      /* SAVE REQUIRED REG                */
*      3  ZCRSVWK5 PTR(31),      /* SAVE REQUIRED REG                */
*   2  ZCRFSBSV PTR(31),         /* FSB CHAIN PTR SAVEAREA           */
*   2  ZCRFBPRC BIT(1),          /* FSB PROCESS SW                   */
*   2  ZCRMOREL BIT(1),          /* MORE ELEMENTS SW                 */
*   2  ZCRSCANQ BIT(1),          /* SCAN QUEUE SW                    */
*   2  ZCRNXTEL BIT(1),          /* NEXT ELEMENT SW                  */
*   2  ZCRXSCHD BIT(1),          /* EXIT SCHEDULE SW                 */
*   2  ZCRLSTFB BIT(1),          /* INBOUND PROC LAST FSB FOR ELEM SW*/
*   2  ZCRTOPQ  BIT(1),          /* QUEUE ELEMENT TO TOP SW          */
*   2  ZCRAWQSW BIT(1),          /* CHECK AWAITQ FOR MORE WORK =1    */
*                                /* CHECK WAITQ =0                   */
*   2  ZCRRCDSV CHAR(1),         /* RETURN CODE SAVEAREA             */
*   2  ZCRPRMTC CHAR(1),         /* PREEMPT COMPLETION PARAMETER BYTE*/
*   2  ZCROPCDE CHAR(1),         /* OP CODE TO BE TRANSFORMED         *
*   2  ZCRR2SV PTR(31),          /* ISTZBFDI REG 2 SAVE EREA         */
*   2  ZCRR13SV PTR(31),         /* ISTSBFDI REG 13 SAVE EREA        */
*   2  ZCRCIDSV BDY(WORD),       /* ISTZBFDI CID SAVE AREA           */
*      3  ZCRSAFSV CHAR(2),      /* ISTZBFDI SAF SAVE AREA           */
*      3  ZCRDAFSV CHAR(2),      /* ISTZBFDI DAF SAVE AREA           */
*   2  ZCRSAVEZ (6) BDY(WORD) CHAR(LENGTH(ISTZSAVE)),              0322
*                                /* SAVE/TRACE AREAS FOR TPIOS MODS  */
*   2  ZCRREMIC PTR(31),        /* POINTER TO REMOTE RN ICNCB        */
*   2  ZCRAUDIT CHAR(36),        /* TPIOS AUDIT TRAIL AREA           */
*      3  ZCRTID CHAR(1),        /* THREAD I.D.                      */
*      3  ZCRTNAME CHAR(4),      /* LAST 4 CHARS OF THREAD NAME      */
*      3  ZCRENTER BIT(248),     /* BIT ARRAY FOR MODULES ENTERED    */
*         4  ZCREAC1A BIT(1),    /* ISTZAC1A ENTERED                 */
*         4  ZCREAC0A BIT(1),    /* ISTZAC0A ENTERED                 */
*         4  ZCREAC0B BIT(1),    /* ISTZAC0B ENTERED                 */
*         4  ZCREAC1B BIT(1),    /* ISTZAC1B ENTERED                 */
*         4  ZCREBCAA BIT(1),    /* ISTZBCAA ENTERED                 */
*         4  ZCREBCAB BIT(1),    /* ISTZBCAB ENTERED                 */
*         4  ZCREBCAE BIT(1),    /* ISTZBCAE ENTERED                 */
*         4  ZCREBCAG BIT(1),    /* ISTZBCAG ENTERED                 */
*         4  ZCREBCAI BIT(1),    /* ISTZBCAI ENTERED                 */
*         4  ZCREBCAM BIT(1),    /* ISTZBCAM ENTERED                 */
*         4  ZCREBCBA BIT(1),    /* ISTZBCBA ENTERED                 */
*         4  ZCREBCBB BIT(1),    /* ISTZBCBB ENTERED                 */
*         4  ZCREBCBI BIT(1),    /* ISTZBCBI ENTERED                 */
*         4  ZCREBCCB BIT(1),    /* ISTZBCCB ENTERED                 */
*         4  ZCREBCDI BIT(1),    /* ISTZBCDI ENTERED                 */
*         4  ZCREBCEB BIT(1),    /* ISTZBCEB ENTERED                 */
*         4  ZCREBCFA BIT(1),    /* ISTZBCFA ENTERED                 */
*         4  ZCREBCFB BIT(1),    /* ISTZBCFB ENTERED                 */
*         4  ZCREBCGA BIT(1),    /* ISTZBCGA ENTERED                 */
*         4  ZCREBCGB BIT(1),    /* ISTZBCGB ENTERED                 */
*         4  ZCREBCHA BIT(1),    /* ISTZBCHA ENTERED                 */
*         4  ZCREBCHB BIT(1),    /* ISTZBCHB ENTERED                 */
*         4  ZCREBCIA BIT(1),    /* ISTZBCIA ENTERED                 */
*         4  ZCREBCIB BIT(1),    /* ISTZBCIB ENTERED                 */
*         4  ZCREBCID BIT(1),    /* ISTZBCID ENTERED                 */
*         4  ZCREBCJA BIT(1),    /* ISTZBCJA ENTERED                 */
*         4  ZCREBCJB BIT(1),    /* ISTZBCJB ENTERED                 */
*         4  ZCREBCKA BIT(1),    /* ISTZBCKA ENTERED                 */
*         4  ZCREBCKB BIT(1),    /* ISTZBCKB ENTERED                 */
*         4  ZCREBCLA BIT(1),    /* ISTZBCLA ENTERED                 */
*         4  ZCREBCLB BIT(1),    /* ISTZBCLB ENTERED                 */
*         4  ZCREBCMB BIT(1),    /* ISTZBCMB ENTERED                 */
*         4  ZCREBCND BIT(1),    /* ISTZBCND ENTERED                 */
*         4  ZCREBCNE BIT(1),    /* ISTZBCNE ENTERED                 */
*         4  ZCREBCOB BIT(1),    /* ISTZBCOB ENTERED                 */
*         4  ZCREBCPB BIT(1),    /* ISTZBCPB ENTERED                 */
*         4  ZCREBCQB BIT(1),    /* ISTZBCQB ENTERED                 */
*         4  ZCREBCRA BIT(1),    /* ISTZBCRA ENTERED                 */
*         4  ZCREBCRB BIT(1),    /* ISTZBCRB ENTERED                 */
*         4  ZCREBCSC BIT(1),    /* ISTZBCSC ENTERED                 */
*         4  ZCREBCXA BIT(1),    /* ISTZBCXA ENTERED                 */
*         4  ZCREBCX0 BIT(1),    /* ISTZBCX0 ENTERED                 */
*         4  ZCREBCY0 BIT(1),    /* ISTZBCY0 ENTERED                 */
*         4  ZCREBCZ0 BIT(1),    /* ISTZBCZ0 ENTERED                 */
*         4  ZCREBC0A BIT(1),    /* ISTZBC0A ENTERED                 */
*         4  ZCREBC0B BIT(1),    /* ISTZBC0B ENTERED                 */
*         4  ZCRECC0A BIT(1),    /* ISTZCC0A ENTERED                 */
*         4  ZCRECC0B BIT(1),    /* ISTZCC0B ENTERED                 */
*         4  ZCRECC1A BIT(1),    /* ISTZCC1A ENTERED                 */
*         4  ZCRECC1B BIT(1),    /* ISTZCC1B ENTERED                 */
*         4  ZCRECC2B BIT(1),    /* ISTZCC2B ENTERED                 */
*         4  ZCREDCA0 BIT(1),    /* ISTZDCA0 ENTERED                 */
*         4  ZCREDCB0 BIT(1),    /* ISTZDCB0 ENTERED                 */
*         4  ZCREDCC0 BIT(1),    /* ISTZDCC0 ENTERED                 */
*         4  ZCREDCD0 BIT(1),    /* ISTZDCD0 ENTERED                 */
*         4  ZCREDCE0 BIT(1),    /* ISTZDCE0 ENTERED                 */
*         4  ZCREDCF0 BIT(1),    /* ISTZDCF0 ENTERED                 */
*         4  ZCREDCH0 BIT(1),    /* ISTZDCH0 ENTERED                 */
*         4  ZCREDCI0 BIT(1),    /* ISTZDCI0 ENTERED                 */
*         4  ZCREDCJ0 BIT(1),    /* ISTZDCJ0 ENTERED                 */
*         4  ZCREDCKA BIT(1),    /* ISTZDCKA ENTERED                 */
*         4  ZCREDCKB BIT(1),    /* ISTZDCKB ENTERED                 */
*         4  ZCREDCL0 BIT(1),    /* ISTZDCL0 ENTERED                 */
*         4  ZCREDCMB BIT(1),    /* ISTZDCMB ENTERED                 */
*         4  ZCREECBA BIT(1),    /* ISTZECBA ENTERED                 */
*         4  ZCREECBB BIT(1),    /* ISTZECBB ENTERED                 */
*         4  ZCREECCA BIT(1),    /* ISTZECCA ENTERED                 */
*         4  ZCREECCB BIT(1),    /* ISTZECCB ENTERED                 */
*         4  ZCREECDA BIT(1),    /* ISTZECDA ENTERED                 */
*         4  ZCREECEA BIT(1),    /* ISTZECEA ENTERED                 */
*         4  ZCREECTA BIT(1),    /* ISTZECTA ENTERED                 */
*         4  ZCREFCEA BIT(1),    /* ISTZFCEA ENTERED                 */
*         4  ZCREFCEB BIT(1),    /* ISTZFCEB ENTERED                 */
*         4  ZCREGCAB BIT(1),    /* ISTZGCAB ENTERED                 */
*         4  ZCREGCBB BIT(1),    /* ISTZGCBB ENTERED                 */
*         4  *        BIT(1),    /* NOT USED                         */
*         4  ZCREGCDB BIT(1),    /* ISTZGCDB ENTERED                 */
*         4  ZCREGCEB BIT(1),    /* ISTZGCEB ENTERED                 */
*         4  ZCREGCLA BIT(1),    /* ISTZGCLA ENTERED                 */
*         4  ZCREGC0A BIT(1),    /* ISTZGC0A ENTERED                 */
*         4  ZCREGC0B BIT(1),    /* ISTZGC0B ENTERED                 */
*         4  ZCREHCAN BIT(1),    /* ISTZHCAN ENTERED                 */
*         4  ZCREICAA BIT(1),    /* ISTZICAA ENTERED                 */
*         4  ZCREICAB BIT(1),    /* ISTZICAB ENTERED                 */
*         4  ZCREICBB BIT(1),    /* ISTZICBB ENTERED                 */
*         4  ZCREICBI BIT(1),    /* ISTZICBI ENTERED                 */
*         4  ZCREICCB BIT(1),    /* ISTZICCB ENTERED                 */
*         4  ZCREICCI BIT(1),    /* ISTZICCI ENTERED                 */
*         4  ZCREICDB BIT(1),    /* ISTZICDB ENTERED                 */
*         4  ZCREICEB BIT(1),    /* ISTZICEB ENTERED                 */
*         4  ZCREICGB BIT(1),    /* ISTZICGB ENTERED                 */
*         4  ZCREICHB BIT(1),    /* ISTZICHB ENTERED                 */
*         4  ZCREICIB BIT(1),    /* ISTZICIB ENTERED                 */
*         4  ZCREICID BIT(1),    /* ISTZICID ENTERED                 */
*         4  ZCREICJB BIT(1),    /* ISTZICJB ENTERED                 */
*         4  ZCREICKB BIT(1),    /* ISTZICKB ENTERED                 */
*         4  ZCREICKE BIT(1),    /* ISTZICKE ENTERED                 */
*         4  ZCREICKG BIT(1),    /* ISTZICKG ENTERED                 */
*         4  ZCREICLB BIT(1),    /* ISTZICLB ENTERED                 */
*         4  ZCREICMB BIT(1),    /* ISTZICMB ENTERED                 */
*         4  ZCREICNA BIT(1),    /* ISTZICNA ENTERED                 */
*         4  ZCREICNB BIT(1),    /* ISTZICNB ENTERED                 */
*         4  ZCREICOA BIT(1),    /* ISTZICOA ENTERED                 */
*         4  ZCREICOB BIT(1),    /* ISTZICOB ENTERED                 */
*         4  ZCREICQA BIT(1),    /* ISTZICQA ENTERED                 */
*         4  ZCREICQB BIT(1),    /* ISTZICQB ENTERED                 */
*         4  ZCREICRB BIT(1),    /* ISTZICRB ENTERED                 */
*         4  ZCREICSB BIT(1),    /* ISTZICSB ENTERED                 */
*         4  ZCREICSC BIT(1),    /* ISTZICSC ENTERED                 */
*         4  ZCREICTB BIT(1),    /* ISTZICTB ENTERED                 */
*         4  ZCREICUB BIT(1),    /* ISTZICUB ENTERED                 */
*         4  ZCREICVB BIT(1),    /* ISTZICVB ENTERED                 */
*         4  ZCREICWB BIT(1),    /* ISTZICWB ENTERED                 */
*         4  ZCREICX0 BIT(1),    /* ISTZICX0 ENTERED                 */
*         4  ZCREIC0B BIT(1),    /* ISTZIC0B ENTERED                 */
*         4  ZCREIC1B BIT(1),    /* ISTZIC1B ENTERED                 */
*         4  ZCREJCAB BIT(1),    /* ISTZJCAB ENTERED                 */
*         4  ZCREJCBB BIT(1),    /* ISTZJCBB ENTERED                 */
*         4  ZCREJCCB BIT(1),    /* ISTZJCCB ENTERED                 */
*         4  ZCREJCDB BIT(1),    /* ISTZJCDB ENTERED                 */
*         4  ZCREJC0B BIT(1),    /* ISTZJC0B ENTERED                 */
*         4  ZCREKCBB BIT(1),    /* ISTZKCBB ENTERED                 */
*         4  ZCREKCBN BIT(1),    /* ISTZKCBN ENTERED                 */
*         4  ZCREKCCN BIT(1),    /* ISTZKCCN ENTERED                 */
*         4  ZCREDCWR BIT(1),    /* ISTZDCWR ENTERED                 */
*         4  ZCREDCWB BIT(1),    /* ISTZDCWB ENTERED                 */
*         4  ZCREDCXR BIT(1),    /* ISTZDCXR ENTERED                 */
*         4  ZCREBCBR BIT(1),    /* ISTZBCBR ENTERED                 */
*         4  ZCREBCDR BIT(1),    /* ISTZBCDR ENTERED                 */
*         4  ZCREBCAR BIT(1),    /* ISTZBCAR ENTERED                 */
*         4  ZCRECCBI BIT(1),    /* ISTZCCBI ENTERED                 */
*         4  ZCRECCAI BIT(1),    /* ISTZCCAI ENTERED                 */
*         4  ZCRECCCI BIT(1),    /* ISTZCCCI ENTERED                 */
*         4  ZCREAC1R BIT(1),    /* ISTZAC1R ENTERED                 */
*         4  ZCREBCSB BIT(1),    /* ISTZBCSB ENTERED                 */
*         4  ZCREDCPR BIT(1),    /* ISTZDCPR ENTERED                 */
*         4  ZCREDCQR BIT(1),    /* ISTZDCQR ENTERED                 */
*         4  ZCREBCAL BIT(1),    /* ISTZBCAL ENTERED                 */
*         4  ZCREBC0L BIT(1),    /* ISTZBC0L ENTERED                 */
*         4  ZCREBCNB BIT(1),    /* ISTZBCNB ENTERED                 */
*         4  ZCREICOE BIT(1),    /* ISTZICOE ENTERED                 */
*         4  ZCREDCNB BIT(1),    /* ISTZDCNB ENTERED                 */
*         4  ZCREKCCB BIT(1),    /* ISTZKCCB ENTERED                 */
*         4  ZCRECFY0 BIT(1),    /* ISTZCFY0 ENTERED                 */
*         4  ZCREDCK0 BIT(1),    /* ISTZDFK0 ENTERED                 */
*         4  ZCREICSG BIT(1),    /* ISTZICSG ENTERED                 */
*         4  ZCREBCIF BIT(1),    /* ISTZBCIF ENTERED                 */
*         4  ZCREDCMF BIT(1),    /* ISTZDCMF ENTERED                 */
*         4  ZCRELCAB BIT(1),    /* ISTZLCAB ENTERED                 */
*         4  ZCREAC2B BIT(1),    /* ISTZAC2B ENTERED                 */
*         4  ZCREIC2B BIT(1),    /* ISTZIC2B ENTERED                 */
*         4  ZCRRSV97 BIT(97),   /* RESERVED                         */
*   2  ZCRCMNRC CHAR(1),                /* PURGE MWOR RETURN CODE    */
*   2  ZCRWORDA CHAR(3),                /* RESERVED FOR LATER USE    */
*   2  ZCRLCPB  CHAR(LENGTH(ISTLCPB)),  /* 3270 S/R LCPB             */
*      3 ZCRRHRU,                       /* SAVEAREA FOR RH AND RU    */
*        4 ZCRRH    CHAR(3),            /* RH                        */
*        4 ZCRRU    CHAR(*);            /* RU                        */
*DCL ZCTYPE BIT(8) CONSTANT('00'X);   /* ZCR TYPE                   */
*DCL ZCLNG FIXED(15) CONSTANT(172);   /* ZCRR LENGTH                */
*DCL ZCRSAVNO BIT(8) CONSTANT('06'X); /* NUMBER OF SAVEAREAS IN ZCRR */
*DCL ZCRLSVNO BIT(8) CONSTANT('04'X); /* NUMBER OF SAVE AREAS IN   0326
*                                         LOCAL SUPPORT              */
*/* *** EQUATES FOR ZCRRCDSV *** */                                0327
*                                                                  0327
*DCL ZCRMRFSB BIT(8) CONSTANT('0C'X);  /* REQUEST COMPLETION MOVE FSB
*                                         TO PROCESS                 */
*DCL ZCRSRCHQ BIT(8) CONSTANT('10'X);  /* REQUEST COMPLETION SEARCH
*                                         REQUEST QUEUE              */
*DCL ZCREXIT  BIT(8) CONSTANT('14'X);  /* REQUEST COMPLETION EXIT    */
*DCL ZCRSFSB  BIT(8) CONSTANT('18'X);  /* REQUEST COMPLETION SINGLE
*                                         FSB                        */
*DCL ZCRDLFSB BIT(8) CONSTANT('1C'X);  /* REQUEST COMPLETION DUAL FSB *
*DCL ZCRNOSCH BIT (8) CONSTANT('20'X); /* REQUEST COMPLETION, EXIT WITH
*                                         SCHED NONE                 */
*DCL ZCRNRSCH BIT (8) CONSTANT('24'X); /* REQUEST COMPLETION, EXIT WITH
*                                         SCHED NORM                 */
*DCL ZCRLGERR FIXED(8) CONSTANT(8);    /* LOGICAL ERROR              */
*DCL ZCPLSCB BIT(8) CONSTANT('08'X);   /* GET A RELEASE LSCB         */
*DCL ZCPBUF  BIT(8) CONSTANT('04'X);   /* GET A RELEASE BUFFER       */
*DCL ZCRTAC0A FIXED(8) CONSTANT(01);   /* LOCAL DEVICE SCHEDULER(OUT)*/
*DCL ZCRTAC0B FIXED(8) CONSTANT(02);   /* REMOTE DEVICE SCHEDLER(OUT)*/
*DCL ZCRTCC1A FIXED(8) CONSTANT(03);   /* LOCAL DIALOG SCHEDLER(IN)  */
*DCL ZCRTCC1B FIXED(8) CONSTANT(04);   /* REMOTE DIALOG SCHEDLER(IN) */
*DCL ZCRTDCE0 FIXED(8) CONSTANT(05);   /* NCP SLOWDOWN RECOVERY      */
*DCL ZCRTDCKA FIXED(8) CONSTANT(06);   /* LOCAL GENERAL FUNCTIONS    */
*DCL ZCRTDCKB FIXED(8) CONSTANT(07);   /* REMOTE GENERAL FUNCTIONS   */
*DCL ZCRTFCEB FIXED(8) CONSTANT(08);   /* REMOTE READ BUFFER ALLOC.  */
*DCL ZCRTGCLA FIXED(8) CONSTANT(09);   /* LCAL CTL & TEST FEEDBACK(IN)*
*DCL ZCRTGC0A FIXED(8) CONSTANT(10);   /* LOCAL REQ. COMPLETION(IN)  */
*DCL ZCRTGC0B FIXED(8) CONSTANT(11);   /* REMOTE REQ. COMPLETION(IN) */
*DCL ZCRTICWB FIXED(8) CONSTANT(12);   /* RESET CLEANUP (PHASE 5)    */
*DCL ZCRTIC0B FIXED(8) CONSTANT(13);   /* REMOTE REQ COMPLTION CTL(IN)*
*DCL ZCRTAC1B FIXED(8) CONSTANT(14);   /* ISTZAC1B THREAD ID         */
*DCL ZCRTIC1B FIXED(8) CONSTANT(15);   /* ISTZIC1B THREAD ID         */
*DCL ZCRTCCBI FIXED(8) CONSTANT(16);   /* ISTZCCBI THREAD ID         */
*DCL ZCRTAC1R FIXED(8) CONSTANT(17);   /* ISTZAC1R THREAD ID         */
*DCL ZCRTAC1A FIXED(8) CONSTANT(18);   /* ISTZAC1A THREAD ID         */
*DCL ZCRTLCAB FIXED(8) CONSTANT(19);   /* ISTZLCAB THREAD ID         */
*/* COMPONENT RECOVERY                                               */
*/*                                                                  */
*DCL 1 ISTASCRR BDY(WORD) BASED,        /* CRR FOR SMS               */
*     2  ASCPFCRR CHAR(LENGTH(ISTPFCRR)),                          0356
*     2  ASCFLAGS CHAR(7),              /* FLAGS                     */
*        3  ASCFLG1 CHAR(2),            /* MODULE TRACE FLAGS        */
*           4  ASCFBA BIT(1),           /* ALLOCATION IN PATH        */
*           4  ASCFBD BIT(1),           /* DE-ALLOCATION IN PATH     */
*           4  ASCFSR BIT(1),           /* FSR IN PATH               */
*           4  ASCPASTR BIT(13),        /* RESERVED PATH FLAGS       */
*        3  ASCFLG2 CHAR(2),            /* MODULE IN CONTROL FLAGS   */
*           4  ASCFBAIC BIT(1),         /* ALLOCATION IN CONTROL     */
*           4  ASCFBDIC BIT(1),         /* DE-ALLOCATION IN CONTROL  */
*           4  ASCFSRIC BIT(1),         /* FSR IN CONTROL            */
*           4  ASCICR BIT(13),          /* RESERVED IN CONTROL FLAGS */
*        3  ASCFLG3 CHAR(3),            /* AUDIT FLAGS               */
*           4  ASCFSRGT BIT(1),         /* FSR DOING GET PROCESSING  */
*           4  ASCFBDAL BIT(1),         /* FBD DOING ALLOCATION      */
*           4  ASCKEYF BIT(1),          /* KEY HAS BEEN ALTERED      */
*           4  ASCLLKF BIT(1),          /* LOCAL LOCK HELD           */
*           4  ASCFBDUD BIT(1),         /* FBD USING USER DATA       */
*           4  ASCAUDIT BIT(19),        /* RESERVED AUDIT BITS       */
*     2  ASCKEY CHAR(1),                /* ORIGINAL KEY              */
*     2  ASCETRYA PTR(31),              /* RETRY ADRS FOR CONTINUE 0356
*                                          OPTION                    */
*     2  ASCUSRGS CHAR(16),             /* SAVE AREA FOR USER REGS 0356
*                                          14 - 1                    */
*        3  ASCUSR14 CHAR(4),           /* REGISTER 14               */
*        3  ASCUSR15 CHAR(4),           /* REGISTER 15               */
*        3  ASCUSR00 CHAR(4),           /* REGISTER 0                */
*        3  ASCUSR01 CHAR(4),           /* REGISTER 1                */
*     2  ASCPSREG CHAR(16);             /* SAVE AREA FOR PSS       0356
*                                          REGS 1 - 4                */
*/*  INITIAL LEVEL                                      001 04/09/75 */
*DCL 1 ISTAPCRR BDY(WORD) BASED,                                   0357
*     2 APCHDRSV CHAR(LENGTH(ISTPFCRR)),  /* HEADER                  */
*     2  APCATFLG CHAR(2),              /* AUDIT TRACE FLAGS         */
*        3  APC51E BIT(1),              /* ISTAPC51 WAS ENTERED      */
*        3  APC52E BIT(1),              /* ISTAPC52  '     '         */
*        3  APC53E BIT(1),              /* ISTAPC53                  */
*        3  APC54E BIT(1),                                         0357
*        3  APC56E BIT(1),                                         0357
*        3  APC57E BIT(1),                                         0357
*        3  APC58E BIT(1),                                         0357
*        3  APC31E BIT(1),                                         0357
*        3 * BIT(8),                    /* RESERVED                  */
*     2  APCRFLG CHAR(2),               /* AUDIT TRACE FLAGS         */
*        3  APC51R BIT(1),              /* ISTAPCR1 IS RUNNING       */
*        3  APC52R BIT(1),              /* ISTAPC52 IS RUNNING       */
*        3  APC53R BIT(1),                                         0357
*        3  APC54R BIT(1),                                         0357
*        3  APC56R BIT(1),                                         0357
*        3  APC57R BIT(1),                                         0357
*        3  APC58R BIT(1),                                         0357
*        3  APC31R BIT(1),                                         0357
*        3  *      BIT(8),              /* RESERVED                  */
*     2  APCPSTA PTR(31),               /* PST@                      */
*     2  APCTCBA PTR(31),               /* TCB@                      */
*     2  APCRTRN PTR(31),               /*@ TO BR14 TO RTN TO SYSTEM */
*     2  APCPABSV PTR(31),              /*SAVED PAB@ TO REDISPATCH   */
*     2  APCQWFO PTR(31),               /* Q@ IN PST WORK AREA ON    */
*     2  APCFRRPM PTR(31),              /* WORKAREA@ RTN'D FROM SETFR*/
*     2  APCSAVE CHAR(72),                                         0357
*        3  APCESTAL CHAR(72),          /* ESTAE PARAMETER LIST AREA */
*     2  APCCOMF CHAR(4) BDY(HWORD),    /* FLAGS USED BY ALL PSS RTN */
*        3  APCCOMF1 CHAR(2),                                      0357
*           4  APCSSTSK BIT(1),         /* IRB TYPE WORK             */
*           4  APCUETSK BIT(1),         /* USER EXIT RUNNING UNDER IRB*
*           4  APCSMCR BIT(1),          /* SMA CRA BEING USED        */
*           4  APCIRB1 BIT(1),          /* IRB1 BEING USED           */
*           4  APCIRB2 BIT(1),          /* IRB2 BEING USED           */
*           4  APCRELR BIT(1),          /*CALL ISTAPC58 TO RLEASE CRA*/
*           4  APCEXIT BIT(1),          /* TELLS ISTAPC58 TO EXIT SYS*/
*           4  APCZLBER BIT(1),         /* ERR WHILE RUNNING ZLFAB PAB*
*           4  * BIT(8),                /* RESERVED                  */
*        3  APCRETCD FIXED(15),         /* RTN CODE FOR R15 FOR SYS  */
*     2  APCSAV1 PTR(31),               /* 1ST SAVE WORD             */
*     2  APCSAV2 PTR(31),               /* 2ND SAVE WORD             */
*     2  APCSWTWD CHAR(4),              /* SWITCH AREA FOR PSS RTN   */
*     2  APC31FLG CHAR(1),              /* ISTAPC31 FLAGS            */
*        3  APCTPXIT BIT(1),            /* TPEXIT IN PROGRESS        */
*        3  APCRESCH BIT(1),            /*PAB TPEXIT OCCURED  RESCHED*/
*        3  APCSORT BIT(1),       /* PAB SORTED TO PROPER PST/MPST   */
*        3  *       BIT(5),       /* RESERVED                        */
*     2  APC52FLG CHAR(1),        /* ISTAPC52 FLAGS                  */
*        3  APCCKRQ BIT(1),       /* CHECK RDY Q FOR WORK            */
*        3  APCSMSR BIT(1),       /* RETURNING SMS RPH               */
*        3  APCQENQ BIT(1),       /* ENQUEUEING PAB'S ON PST Q'S     */
*        3  APCRDQ BIT(1),        /* DEQUEING PAB'S FROM PST RDY Q   */
*        3  APCNWF BIT(1),        /* NO WORK FOUND                   */
*        3  APCWKF   BIT(1),      /* WORK FOUND                      */
*        3    *      BIT(2),      /* RESERVED                        */
*     2  APC53FLG CHAR(1),        /* ISTAPC53 FLAGS                  */
*        3  APCPR153 BIT(1),      /* USED PREALLOCATED CRA           */
*     2  APC54FLG CHAR(1),        /* ISTAPC54 FLAGS                  */
*        3  APCRLST BIT(1),       /* SMS BEING CALLED TO RELEASE UECB*/
*        3  * BIT(7),             /* RESERVED                        */
*     2  APC57FLG CHAR(1),        /* ISTAPC57 FLAGS                  */
*        3  APCRECRA BIT(1),      /* RELEASE CRA BEING DONE          */
*        3  APCNREL BIT(1),       /* DID NOT RELEASE CRA             */
*        3  *   BIT(6),           /* RESERVED                        */
*     2  * CHAR(15);              /* RESERVED                        */
*/*               COMPONENT RECOVERY AREA                            */
*/*  REVISIONS                                         005 04/09/75  */
*DCL 1  ISTCRA BASED BDY(DWORD),        /* COMPONENT RECOVERY AREA   */
*     2  CRABASIC BDY(WORD),            /* CRA WITHOUT PROCESS CRR   */
*      3 CRAHDR CHAR(8) BDY(WORD),      /* CRA HEADER                */
*        4  CRACRR PTR(31),             /* PTR TO ACTIVE CRR         */
*        4  CRAFRR PTR(31),             /* PTR TO ACTIVE FRR         */
*      3 CRALKACT BIT(32),              /* LOCK LEVEL AND          0358
*                                          OWNERSHIP FLAGS           */
*        4  CRALEV32 BIT(1),            /* 1 = LEVEL 32 LOCK HELD    */
*        4  CRALEV31 BIT(1),            /* 1 = LEVEL 31 LOCK HELD    */
*        4  CRALEV30 BIT(1),            /* 1 = LEVEL 30 LOCK HELD    */
*        4  CRALEV29 BIT(1),            /* 1 = LEVEL 29 LOCK HELD    */
*        4  CRALEV28 BIT(1),            /* 1 = LEVEL 28 LOCK HELD    */
*        4  CRALEV27 BIT(1),            /* 1 = LEVEL 27 LOCK HELD    */
*        4  CRALEV26 BIT(1),            /* 1 = LEVEL 26 LOCK HELD    */
*        4  CRALEV25 BIT(1),            /* 1 = LEVEL 25 LOCK HELD    */
*        4  CRALEV24 BIT(1),            /* 1 = LEVEL 24 LOCK HELD    */
*        4  CRALEV23 BIT(1),            /* 1 = LEVEL 23 LOCK HELD    */
*        4  CRALEV22 BIT(1),            /* 1 = LEVEL 22 LOCK HELD    */
*        4  CRALEV21 BIT(1),            /* 1 = LEVEL 21 LOCK HELD    */
*        4  CRALEV20 BIT(1),            /* 1 = LEVEL 20 LOCK HELD    */
*        4  CRALEV19 BIT(1),            /* 1 = LEVEL 19 LOCK HELD    */
*        4  CRALEV18 BIT(1),            /* 1 = LEVEL 18 LOCK HELD    */
*        4  CRALEV17 BIT(1),            /* 1 = LEVEL 17 LOCK HELD    */
*        4  CRALEV16 BIT(1),            /* 1 = LEVEL 16 LOCK HELD    */
*        4  CRALEV15 BIT(1),            /* 1 = LEVEL 15 LOCK HELD    */
*        4  CRALEV14 BIT(1),            /* 1 = LEVEL 14 LOCK HELD    */
*        4  CRALEV13 BIT(1),            /* 1 = LEVEL 13 LOCK HELD    */
*        4  CRALEV12 BIT(1),            /* 1 = LEVEL 12 LOCK HELD    */
*        4  CRALEV11 BIT(1),            /* 1 = LEVEL 11 LOCK HELD    */
*        4  CRALEV10 BIT(1),            /* 1 = LEVEL 10 LOCK HELD    */
*        4  CRALEV09 BIT(1),            /* 1 = LEVEL 9 LOCK HELD     */
*        4  CRALEV08 BIT(1),            /* 1 = LEVEL 8 LOCK HELD     */
*        4  CRALEV07 BIT(1),            /* 1 = LEVEL 7 LOCK HELD     */
*        4  CRALEV06 BIT(1),            /* 1 = LEVEL 6 LOCK HELD     */
*        4  CRALEV05 BIT(1),            /* 1 = LEVEL 5 LOCK HELD     */
*        4  CRALEV04 BIT(1),            /* 1 = LEVEL 4 LOCK HELD     */
*        4  CRALEV03 BIT(1),            /* 1 = LEVEL 3 LOCK HELD     */
*        4  CRALEV02 BIT(1),            /* 1 = LEVEL 2 LOCK HELD     */
*        4  CRALEV01 BIT(1),            /* 1 = LEVEL 1 LOCK HELD     */
*      3 CRAL1PTR PTR(31),              /* PTR TO LEVEL 1 LOCK       */
*      3 CRAL2PTR PTR(31),              /* PTR TO LEVEL 2 LOCK       */
*      3 CRAL3PTR PTR(31),              /* PTR TO LEVEL 3 LOCK       */
*      3 CRAL4PTR PTR(31),              /* PTR TO LEVEL 4 LOCK       */
*      3 CRAL5PTR PTR(31),              /* PTR TO LEVEL 5 LOCK       */
*      3 CRAL6PTR PTR(31),              /* PTR TO LEVEL 6 LOCK       */
*      3 CRAL7PTR PTR(31),              /* PTR TO LEVEL 7 LOCK       */
*      3 CRAL8PTR PTR(31),              /* PTR TO LEVEL 8 LOCK       */
*      3 CRAL9PTR PTR(31),              /* PTR TO LEVEL 9 LOCK       */
*      3 CRALAPTR PTR(31),              /* RESERVED                  */
*/*                                                                  */
*/*   VS1/VS2 EXTENSION                                              */
*/*                                                                  */
*     2  CRARPH CHAR(LENGTH(ISTRPH)),   /* RPH ASSOCIATED WITH     0358
*                                          THIS CRH                  */
*     2  CRAPSS CHAR(LENGTH(ISTAPCRR)), /* PSS CRR                   */
*     2  CRAPROCR CHAR(LENGTH(ISTZCRR)) BDY(DWORD), /* PROCESS CRR   */
*     2  CRASVC CHAR(72) BDY(WORD),     /* SERVICE RTN CRA           */
*        3  CRAASCRR CHAR(LENGTH(ISTASCRR)), /* CRR FOR SMS          */
*        3  CRAHSIZ  PTR(31),           /* HEADER SIZE QUED SMS REQ  */
*        3  CRAMASK  PTR(31),           /* PREFIX MASK QUED SMS REQ  */
*        3  CRABUFA  FIXED(31),         /* BUFF QUE FOR FBQ ALLOCATION*
*           4 CRABFTBA BIT(1),          /* NO BUFFERS ALLOCATED YET   *
*     2  CRARSV01 PTR(31),              /* RESERVED                  */
*     2  CRARSV02 PTR(31),              /* RESERVED                  */
*     2  CRACHAIN PTR(31);              /* CHAIN FIELD USED TO QUEUE
*                                          CRA TO PREALLOCATE QUEUE
*                                          WHEN NOT IN USE           */
*DCL CRALMS32 BIT(32) CONSTANT('80000000'X); /* 32ND LEVEL LOCK MASK */
*DCL CRALMS31 BIT(32) CONSTANT('40000000'X); /* 31ST LEVEL LOCK MASK */
*DCL CRALMS30 BIT(32) CONSTANT('20000000'X); /* 30TH LEVEL LOCK MASK */
*DCL CRALMS29 BIT(32) CONSTANT('10000000'X); /* 29TH LEVEL LOCK MASK */
*DCL CRALMS28 BIT(32) CONSTANT('08000000'X); /* 28TH LEVEL LOCK MASK */
*DCL CRALMS27 BIT(32) CONSTANT('04000000'X); /* 27TH LEVEL LOCK MASK */
*DCL CRALMS26 BIT(32) CONSTANT('02000000'X); /* 26TH LEVEL LOCK MASK */
*DCL CRALMS25 BIT(32) CONSTANT('01000000'X); /* 25TH LEVEL LOCK MASK */
*DCL CRALMS24 BIT(32) CONSTANT('00800000'X); /* 24TH LEVEL LOCK MASK */
*DCL CRALMS23 BIT(32) CONSTANT('00400000'X); /* 23RD LEVEL LOCK MASK */
*DCL CRALMS22 BIT(32) CONSTANT('00200000'X); /* 22ND LEVEL LOCK MASK */
*DCL CRALMS21 BIT(32) CONSTANT('00100000'X); /* 21ST LEVEL LOCK MASK */
*DCL CRALMS20 BIT(32) CONSTANT('00080000'X); /* 20TH LEVEL LOCK MASK */
*DCL CRALMS19 BIT(32) CONSTANT('00040000'X); /* 19TH LEVEL LOCK MASK */
*DCL CRALMS18 BIT(32) CONSTANT('00020000'X); /* 18TH LEVEL LOCK MASK */
*DCL CRALMS17 BIT(32) CONSTANT('00010000'X); /* 17TH LEVEL LOCK MASK */
*DCL CRALMS16 BIT(32) CONSTANT('00008000'X); /* 16TH LEVEL LOCK MASK */
*DCL CRALMS15 BIT(32) CONSTANT('00004000'X); /* 15TH LEVEL LOCK MASK */
*DCL CRALMS14 BIT(32) CONSTANT('00002000'X); /* 14TH LEVEL LOCK MASK */
*DCL CRALMS13 BIT(32) CONSTANT('00001000'X); /* 13TH LEVEL LOCK MASK */
*DCL CRALMS12 BIT(32) CONSTANT('00000800'X); /* 12TH LEVEL LOCK MASK */
*DCL CRALMS11 BIT(32) CONSTANT('00000400'X); /* 11TH LEVEL LOCK MASK */
*DCL CRALMS10 BIT(32) CONSTANT('00000200'X); /* 10TH LEVEL LOCK MASK */
*DCL CRALMS09 BIT(32) CONSTANT('00000100'X); /* 9TH LEVEL LOCK MASK  */
*DCL CRALMS08 BIT(32) CONSTANT('00000080'X); /* 8TH LEVEL LOCK MASK  */
*DCL CRALMS07 BIT(32) CONSTANT('00000040'X); /* 7TH LEVEL LOCK MASK  */
*DCL CRALMS06 BIT(32) CONSTANT('00000020'X); /* 6TH LEVEL LOCK MASK  */
*DCL CRALMS05 BIT(32) CONSTANT('00000010'X); /* 5TH LEVEL LOCK MASK  */
*DCL CRALMS04 BIT(32) CONSTANT('00000008'X); /* 4TH LEVEL LOCK MASK  */
*DCL CRALMS03 BIT(32) CONSTANT('00000004'X); /* 3RD LEVEL LOCK MASK  */
*DCL CRALMS02 BIT(32) CONSTANT('00000002'X); /* 2ND LEVEL LOCK MASK  */
*DCL CRALMS01 BIT(32) CONSTANT('00000001'X); /* 1ST LEVEL LOCK MASK  */
*DCL CRACRA   CHAR(4) CONSTANT('CRA ');      /* CHARACTER C.B. ID    */
* /*   CRR FOR NETWORK STATUS SERVICES                               */
*/*  INITIAL LEVEL                                     001 10/18/74  */
* /*                                                                 */
* DCL 1 ISTNSCRR BDY(WORD) BASED,/* CRR FOR NETWORK                0392
*                                          STATUS SERVICES           */
*     2  NSCPRFX  CHAR(LENGTH(ISTPFCRR)), /* AUDIT TRAIL FOR       0392
*                                          NETWORK STATUS SERVICES   */
*     2  NSCAUDIT,                        /* MODULE INDICATORS       */
*        3  NSCNTRD CHAR(2),            /* LIST OF MODULES ENTERED FOR
*                                          NSS                       */
*           4  NSTC00 BIT(1),           /* INDICATES MODULE ISTSTC00
*                                          ENTERED                   */
*           4  NSQC00 BIT(1),           /* INDICATES MODULE ISTSQC00
*                                          ENTERED                   */
*           4  NSQC01 BIT(1),           /* INDICATES MODULE ISTSQC01
*                                          ENTERED                   */
*           4  NSQC02 BIT(1),           /* INDICATES MODULE ISTSQC02
*                                          ENTERED                   */
*           4  NSQC03 BIT(1),           /* INDICATES MODULE ISTSQC03
*                                          ENTERED                   */
*           4  NSQC04 BIT(1),           /* INDICATES MODULE ISTSQC04
*                                          ENTERED                   */
*           4  NSQC05 BIT(1),           /* INDICATES MODULE ISTSQC05
*                                          ENTERED                   */
*           4  NSQC06 BIT(1),           /* INDICATES MODULE ISTSQC06
*                                          ENTERED                   */
*           4  NSQC07 BIT(1),           /* INDICATES MODULE ISTSQC07
*                                          ENTERED                   */
*           4  NSQC09 BIT(1),           /* INDICATES MODULE ISTSQC09
*                                          ENTERED                   */
*           4  NSQC08 BIT(1),           /* INDICATES MODULE ISTSQC08
*                                          ENTERED                   */
*           4  NSQC0A BIT(1),           /* INDICATES MODULE ISTSQC0A
*                                          ENTERED                   */
*           4  NSQC0B BIT(1),           /* INDICATES MODULE ISTSQC0B
*                                          ENTERED                   */
*           4  NNSRSVRD BIT(3),         /* RESERVED                  */
*        3  NSCCRT CHAR(2),             /* LIST OF MODULES CURRENTLY
*                                          RUNNING                   */
*           4  CSTC00 BIT(1),           /* INDICATES MODULE ISTSTC00
*                                          RUNNING                   */
*           4  CSQC00 BIT(1),           /* INDICATES MODULE ISTSQC00
*                                          RUNNING                   */
*           4  CSQC01 BIT(1),           /* INDICATES MODULE ISTSQC01
*                                          RUNNING                   */
*           4  CSQC02 BIT(1),           /* INDICATES MODULE ISTSQC02
*                                          RUNNING                   */
*           4  CSQC03 BIT(1),           /* INDICATES MODULE ISTSQC03
*                                          RUNNING                   */
*           4  CSQC04 BIT(1),           /* INDICATES MODULE ISTSQC04
*                                          RUNNING                   */
*           4  CSQC05 BIT(1),           /* INDICATES MODULE ISTSQC05
*                                          RUNNING                   */
*           4  CSQC06 BIT(1),           /* INDICATES MODULE ISTSQC06
*                                          RUNNING                   */
*           4  CSQC07 BIT(1),           /* INDICATES MODULE ISTSQC07
*                                          RUNNING                   */
*           4  CSQC09 BIT(1),           /* INDICATES MODULE ISTSQC09
*                                          RUNNING                   */
*           4  CSQC08 BIT(1),           /* INDICATES MODULE ISTSQC08
*                                          RUNNING                   */
*           4  CSQC0A BIT(1),           /* INDICATES MODULE ISTSQC0A
*                                          RUNNING                   */
*           4  CSQC0B BIT(1),           /* INDICATES MODULE ISTSQC0B
*                                          RUNNING                   */
*           4  CNSRSVRD BIT(3);         /* RESERVED                  */
*DCL TIDSTC00 BIT(8) CONSTANT('00'X);   /* THREAD ID FOR           0393
*                                          ISTSTC00                  */
*DCL TIDSQC00 BIT(8) CONSTANT('01'X);   /* THREAD ID FOR           0394
*                                          ISTSQC00                  */
*/* END OF ATBUILD */                                              0395
*    /*** SET ENTERED BIT FOR THIS PROCEDURE ***/                  0395
*CMZK0006->RPHCRR->CRACRR->NSQC04 = '1'B;                          0395
         L     @15,RPHCRR(,CMZK0006)                               0395
         L     @15,CRACRR(,@15)                                    0395
         OI    NSQC04(@15),B'00000100'                             0395
*    /*** CLEAR AND SET CURRENT PROCEDURE BIT ***/                 0396
*CMZK0006->RPHCRR->CRACRR->NSCCRT = '0'B;                          0396
         MVI   NSCCRT+1(@15),X'00'                                 0396
         MVI   NSCCRT(@15),B'00000000'                             0396
*CMZK0006->RPHCRR->CRACRR->CSQC04 = '1'B;                          0397
         OI    CSQC04(@15),B'00000100'                             0397
*    END;                                                          0398
*   PTRRPH=C04R1;                   /* SAVE RPH POINTER              */
         LR    PTRRPH,C04R1                                        0399
*   RDTPTR=OCWDRDTE;                /* INIT BASE FOR RDTE            */
         L     @15,RPHWEA(,PTRRPH)                                 0400
         L     RDTPTR,OCWDRDTE(,@15)                               0400
*   C04R0=C04R13;                   /* SAVE CALLER SAVE ADDR         */
         LR    C04R0,C04R13                                        0401
*   C04R13=C04R13+C04SAVEL;         /* OUR SAVE ADDR                 */
         AL    C04R13,@CF02800                                     0402
*   C04CLR13=C04R0;                 /* SET FORWARD PTR               */
         ST    C04R0,C04CLR13(,C04R13)                             0403
*   C04R0->C04OUR13=C04R13;         /* SET BACKWARD PTR              */
         LR    @15,C04R0                                           0404
         ST    C04R13,C04OUR13(,@15)                               0404
*   C04RC8=C04ZERO;                 /* INITIALIZE RET CODE   @DM12421*/
         SLR   C04RC8,C04RC8                                       0405
*   IF RPRENTRY=RPRENTAP            /* IF IT IS AN APPL.RDTE         */
*     THEN                                                         0406
         CLI   RPRENTRY(RDTPTR),X'55'                              0406
         BNE   @RF00406                                            0406
*     C04RC8=C04FOUR;               /* SET RETURN CODE = 4           */
         LA    C04RC8,4                                            0407
*   ELSE                                                           0408
*     DO;                                                          0408
         B     @RC00406                                            0408
@RF00406 DS    0H                                                  0409
*     RFY C04R15 RSTD;             /* PROTECT FOR VSETLCK    @DM12421*/
*       C04R13 = C04R13 + C04TWEL;                         /*@XM08755*/
         AL    C04R13,@CF01010                                     0410
*/*VSETLCK  (C04R15,OBTAIN,LOCAL,(LOCAL,ISTSQC04(CREL1)))*/        0411
*COBT1: DO;                                                        0411
COBT1    DS    0H                                                  0412
*                                        /*DECLARE AND RESTRICT REGS */
*                                        /*   2,10,11,12,13,14, AND 15
**/                                                                0412
*       DCL GPR02F FIXED(31) REG(02);                              0412
*       DCL GPR02P PTR(31)   REG(02);                              0413
*       DCL GPR11F FIXED(31) REG(11);                              0414
*       DCL GPR11P PTR(31)   REG(11);                              0415
*       DCL GPR12F FIXED(31) REG(12);                              0416
*       DCL GPR12P PTR(31)   REG(12);                              0417
*       DCL GPR14F FIXED(31) REG(14);                              0418
*       DCL GPR14P PTR(31)   REG(14);                              0419
*       RFY (GPR02P,GPR10P,GPR11P,GPR12P,GPR13P,GPR14P,GPR15P) RSTD;
*                                        /*SAVE REGS 2 AND 10 THRU 14*/
*        GEN REFS(GPR02F,GPR10F,GPR11F,GPR12F,GPR14F,GPR13P);      0421
*                                                                  0421
         STM   GPR10F,GPR12F,0(GPR13P)
         ST    GPR14F,12(GPR13P)
         ST    GPR02F,16(GPR13P)
*                                        /*INVOKE MODESET TO CHANGE  */
*                                        /*PSW PROTECTION KEY TO 0   */
*        GEN SETS(2);                                              0422
*                                                                  0422
         MODESET EXTKEY=ZERO,SAVEKEY=(2),WORKREG=2
*         GPR10P=GPR13P;                 /*PUT SAVE AREA ADDR IN R 10*/
         LR    GPR10P,GPR13P                                       0423
*                                        /*INVOKE OS/VS SETLOCK MACRO*/
*         GEN REFS(GPR13P,PSALITA,FLC) SETS(GPR12F);               0424
         SETLOCK OBTAIN,TYPE=LOCAL,MODE=UNCOND,                        *
               RELATED=(LOCAL,ISTSQC04(CREL1))
*         GPR15P=GPR13P;                 /*PUT RETURN CODE IN R 15 */
         LR    GPR15P,GPR13P                                       0425
*                                        /*INVOKE MODESET MACRO TO   */
*           DO;                          /*RESTORE PSW PROTECTION KEY*/
*        GEN SETS(2);                                              0427
         MODESET KEYADDR=(2),WORKREG=2
*           END;                         /* RESTORE REGISTERS        */
*         GEN REFS(GPR10F,GPR13P) SETS(GPR10F,GPR11F,              0429
*         GPR12F,GPR13F,GPR14F,GPR02F);                            0429
         LR    GPR13F,GPR10F
         LM    GPR10F,GPR12F,0(GPR13P)
         L     GPR14F,12(GPR13P)
         L     GPR02F,16(GPR13P)
*         IF GPR15F=4 THEN GPR15F=0;                               0430
         C     GPR15F,@CF00053                                     0430
         BNE   @RF00430                                            0430
         SLR   GPR15F,GPR15F                                       0431
*         C04R15=GPR15F;                 /*PUT RETURN CODE IN RCREG*/
*                                                                  0432
@RF00430 DS    0H                                                  0433
*       RFY (GPR02P,GPR10P,GPR11P,GPR12P,GPR13P,GPR14P,GPR15P) UNRSTD;
*       END;  /*COBT1:VSETLCK */                                   0434
*                                   /*                        @DM7338*/
*       C04R13 = C04R13 - C04TWEL;                         /*@XM08755*/
         SL    C04R13,@CF01010                                     0435
*       IF C04R15=C04ZERO THEN                                     0436
         LTR   C04R15,C04R15                                       0436
         BNZ   @RF00436                                            0436
*         DO;                                                      0437
*    RFY C04R15 UNRSTD;             /* FREE REG 15           @DM12421*/
*           CALL CTERMN1;           /* VALIDATE RDTE TYPE            */
         BAL   @14,CTERMN1                                         0439
*           IF C04COUNT>C04ZERO     /* ANY THING TO DO?              */
*             THEN                                                 0440
         LTR   C04COUNT,C04COUNT                                   0440
         BNP   @RF00440                                            0440
*             CALL C04NIBP;         /* YES, GO TO C04NIBP            */
         BAL   @14,C04NIBP                                         0441
*           ELSE                                                   0442
*             ;                     /* NO, NO-OP                     */
@RF00440 DS    0H                                                  0443
*           C04R13 = C04R13 + C04TWEL;                     /*@XM08755*/
         AL    C04R13,@CF01010                                     0443
*           RFY C04R15 RSTD;                               /*@XM08852*/
*/*VSETLCK  (C04R15,RELEASE,LOCAL,(LOCAL,ISTSQC04(COBT1)))*/       0445
*CREL1:     DO;                                                    0445
CREL1    DS    0H                                                  0446
*                                        /*DECLARE AND RESTRICT REGS */
*                                        /*   2,10,11,12,13,14, AND 15
**/                                                                0446
*           RFY (GPR02P,GPR10P,GPR11P,GPR12P,GPR13P,GPR14P,GPR15P) RSTD
*                                                                  0446
*                                        /*SAVE REGS 2 AND 10 THRU 14*/
*        GEN REFS(GPR02F,GPR10F,GPR11F,GPR12F,GPR14F,GPR13P);      0447
*                                                                  0447
         STM   GPR10F,GPR12F,0(GPR13P)
         ST    GPR14F,12(GPR13P)
         ST    GPR02F,16(GPR13P)
*                                        /*INVOKE MODESET TO CHANGE  */
*                                        /*PSW PROTECTION KEY TO 0   */
*        GEN SETS(2);                                              0448
*                                                                  0448
         MODESET EXTKEY=ZERO,SAVEKEY=(2),WORKREG=2
*             GPR10P=GPR13P;             /*PUT SAVE AREA ADDR IN R 10*/
         LR    GPR10P,GPR13P                                       0449
*                                        /*INVOKE OS/VS SETLOCK MACRO*/
*             GEN REFS(GPR13P,PSALITA,FLC) SETS(GPR12F);           0450
         SETLOCK RELEASE,TYPE=LOCAL,                                   *
               RELATED=(LOCAL,ISTSQC04(COBT1))
*             GPR15P=GPR13P;             /*PUT RETURN CODE IN R 15 */
         LR    GPR15P,GPR13P                                       0451
*                                        /*INVOKE MODESET MACRO TO   */
*               DO;                      /*RESTORE PSW PROTECTION KEY*/
*        GEN SETS(2);                                              0453
         MODESET KEYADDR=(2),WORKREG=2
*               END;                     /* RESTORE REGISTERS        */
*             GEN REFS(GPR10F,GPR13P) SETS(GPR10F,GPR11F,          0455
*             GPR12F,GPR13F,GPR14F,GPR02F);                        0455
         LR    GPR13F,GPR10F
         LM    GPR10F,GPR12F,0(GPR13P)
         L     GPR14F,12(GPR13P)
         L     GPR02F,16(GPR13P)
*             IF GPR15F=4 THEN GPR15F=0;                           0456
         C     GPR15F,@CF00053                                     0456
         BNE   @RF00456                                            0456
         SLR   GPR15F,GPR15F                                       0457
*             C04R15=GPR15F;             /*PUT RETURN CODE IN RCREG*/
*                                                                  0458
@RF00456 DS    0H                                                  0459
*           RFY (GPR02P,GPR10P,GPR11P,GPR12P,GPR13P,GPR14P,GPR15P) UNRS
*D;         END;  /*CREL1:VSETLCK */                               0459
*                                   /*                       @DM7338 */
*           C04R13 = C04R13 - C04TWEL;                     /*@XM08755*/
         SL    C04R13,@CF01010                                     0461
*         END;                                                     0462
*       ELSE                                                       0463
*         C04RC8=C040B;             /* SET ERROR CODE                */
         B     @RC00436                                            0463
@RF00436 LA    C04RC8,11                                           0463
*     END;                                                         0464
@RC00436 DS    0H                                                  0465
*   C04R15=C04RC8;                  /* R15 IS EXTERNAL R.C.  @XM08852*/
@RC00406 LR    C04R15,C04RC8                                       0465
*   C04R13=C04CLR13;                /* CALLER SAVE ADDRESS           */
         L     C04R13,C04CLR13(,C04R13)                            0466
*   RETURN;                                                        0467
@EL00001 DS    0H                                                  0467
@EF00001 DS    0H                                                  0467
@ER00001 L     @14,12(,@13)                                        0467
         LM    @01,@12,24(@13)                                     0467
         BR    @14                                                 0467
*   RFY C04R15 UNRSTD;                                     /*@XM08852*/
*/********************************************************************/
*/* ROUTINE: C04NIBP - NIB PROCESSOR                                 */
*/*                                                                  */
*/* FUNCTION: CALLED BY MAINLINE TO PROVIDE DATA FOR A TERMINAL,     */
*/*           COMPONENT, UTERM, OR LOGICAL TERMINAL IN THE FORM      */
*/*           OF NIB CONTROL BLOCKS IN THE USER AREA.                */
*/*                                                                  */
*/* INPUT:  RDTPTR   (R6) - POINTER TO TOPMOST RDTE IN SEGMENT       */
*/*         C04COUNT (R4) - COUNT OF RDTES IN SEGMENT                */
*/*         C04R14  (R14) - POINTER TO NSI IN MAINLINE               */
*/*                                                                  */
*/* OUTPUT: C06RC8  (R15) - CONTAINS A RETURN CODE, AS FOLLOWS:      */
*/*                         0   USER AREA HAS DATA                   */
*/*                      X'17'  AREA NOT VALID                       */
*/*                      X'2B'  NOT ENOUGH AREA                      */
*/*         C04R14  (R14) - POINTER TO NSI IN MAINLINE               */
*/*         TERMINAL NAME AND DEVICE CHARACTERISTICS MOVED TO USER-  */
*/*           DESIGNATED AREA FOR EACH UNIT WITHOUT A SCHEDULABLE    */
*/*           SUBNODE                                                */
*/*                                                                  */
*/* ROUTINES CALLED: C04NIBIN - TO INITIALIZE NIBS            @XM8904*/
*/*                                                                  */
*/* MACROS USED: VALCHEK - TO VALIDATE USER SUPPLIED AREA            */
*/********************************************************************/
*                                                                  0469
*C04NIBP:                                                          0469
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0469
C04NIBP  DS    0H                                                  0470
*   C04SAVE1=C04R14;                /* SAVE RETURN ADDRESS           */
         L     @15,RPHWEA(,PTRRPH)                                 0470
         ST    C04R14,C04SAVE1+552(,@15)                           0470
*   C04SIZE=C04COUNT*C04NIBL;       /* GET SIZE NEEDED               */
         LR    @11,C04COUNT                                        0471
         M     @10,C04NIBL                                         0471
         LR    C04SIZE,@11                                         0471
*   IF RPLBUFL<C04SIZE              /* IF USER WORKAREA TOO SMALL    */
*     THEN                                                         0472
         L     @15,OCWRPL(,@15)                                    0472
         C     C04SIZE,RPLBUFL(,@15)                               0472
         BNH   @RF00472                                            0472
*     C04RC8=C042B;                 /* THEN SET RETURN CODE = 2B     */
         LA    C04RC8,43                                           0473
*   ELSE                                                           0474
*     DO;                           /* ELSE, DO FOLLOWS              */
         B     @RC00472                                            0474
@RF00472 DS    0H                                                  0475
*       C04SZE=C04SIZE;             /* SAVE NEEDED SIZE              */
         L     @15,RPHWEA(,PTRRPH)                                 0475
         ST    C04SIZE,C04SZE+552(,@15)                            0475
*       RFY                                                        0476
*         C04SIZE UNRSTD;                                          0476
*       C04R13=C04R13+12;           /* SAVE ADDR FOR VALCHEK         */
         AL    C04R13,@CF01010                                     0477
*       C04R1=PTRRPH;               /* RESTORE RPH POINTER TO REG 1  */
         LR    C04R1,PTRRPH                                        0478
*       RFY C04R15 RSTD;            /* RESTRICT ACROSS MACRO @DM12421*/
*                                                                  0479
*/*VALCHEK  (C04R15,(C04R13),(RPLAREA),UA,RPLBUFL)  RANGE*/        0480
*        DO;                                                       0480
*                                                                  0480
*        DCL GPR01F FIXED(31) REG(01);                             0481
*        DCL GPR01P PTR(31)   REG(01);                             0482
*        RFY (GPR01P,GPR02P,GPR04P,GPR06P,GPR13P,GPR14P,GPR15P) RSTD;
*                                        /*DECLARE AND RESTRICT REGS*/
*                                        /*  1, 2, 4, 6, 13,14, AND 15
*/         C04R15=0;                    /*SET RETURN CODE TO NO ERROR*/
         SLR   C04R15,C04R15                                       0484
*                                        /*INVOKE XREGSET MACRO TO */
*                                        /*VERIFY SAVEAREA OPERAND */
*                                        /*AND PUT IT IN REG 13    */
*                                                                  0485
*/*XREGSET  PID('SAVEAREA')PPARM((C04R13))RREG(13,GPR13P)*/        0485
*        DO;                                                       0485
*          GPR13P=C04R13;                /*SET RREG SYMBOL TO VALUE*/
*                                        /*OF PPARM OPERAND        */
*        END;  /* XREGSET */                                       0487
*          DCL 1 SAV0014 CHAR(20) BASED(GPR13P),                   0488
*                                        /*ESTABLISH SAVE AREA MAP   */
*                2 SAV10014 CHAR(4),     /*TO SAVE REGS 1,2,4,6, AND 14
*/               2 SAV20014 CHAR(4),                               0488
*                2 SAV40014 CHAR(4),                               0488
*                2 SAV60014 CHAR(4),                               0488
*                2 SAVE0014 CHAR(4);                               0488
*          SAV10014=GPR01F;              /* SAVE REGS ONE,     */  0489
         STCM  GPR01F,15,SAV10014(GPR13P)                          0489
*          SAV20014=GPR02F;              /*           TWO,     */  0490
         STCM  GPR02F,15,SAV20014(GPR13P)                          0490
*          SAV40014=GPR04F;              /*          FOUR,     */  0491
         STCM  GPR04F,15,SAV40014(GPR13P)                          0491
*          SAV60014=GPR06F;              /*          SIX,      */  0492
         STCM  GPR06F,15,SAV60014(GPR13P)                          0492
*          SAVE0014=GPR14F;              /*     AND FOURTEEN   */  0493
         STCM  GPR14F,15,SAVE0014(GPR13P)                          0493
*          GPR04P=GPR01P->RPHTSKID;      /*PUT ADDR OF PROCESS SCHED-*/
         L     GPR04P,RPHTSKID(,GPR01P)                            0494
*                                        /*ULING TABLE IN REG 4      */
*                                                                  0495
*/* ATBUILD (ISTPST)  */                                           0495
*/* PROCESS ANCHOR BLOCK                                              *
*/*  REVISIONS                                         002 11/16/75  */
*DCL  1  ISTPAB BDY(DWORD) BASED,                                  0495
*       2  PABWQCHN CHAR(8) BDY(DWORD), /* CPS SWAP FIELD FOR NEQ&CHN *
*        3  PABWEQA PTR(31) BDY(WORD), /* WORK ELEMENT QUEUE ADDRESS  *
*           4  PABWEQG BIT(1),         /* GATING BIT                  *
*           4  PABRSV01 BIT(7),        /* RESERVED                    *
*           4  PABWEQP PTR(24),        /* WKEL PTR                    *
*        3  PABCHAIN PTR(31) BDY(WORD), /* APS CHAIN                  *
*           4  PABCHNG BIT(1),         /* GATING BIT                  *
*           4  PABRESCH BIT(1),        /* RESCHEDULE PAB AT        0495
*                                         TPEXIT                      *
*           4  PABCDP BIT(1),          /* CLOSE DST/CHANGE IN PROGRESS*
*           4  PABUNCON BIT(1),        /* UNCONDITIONALLY RESCHEDULE
*                                         PAB AT TPEXIT               *
*           4  PABRESET BIT(1),        /* RESET ISSUED ON THIS PAB    *
*           4  PABRUNNG BIT(1),        /* PAB RUNNING                 *
*           4  PABDELAY BIT(1),        /* DELAY OPTION USED           *
*           4  PABRSV02 BIT(1),        /* RESERVED                    *
*           4  PABCHNGP PTR(24),       /* PSS CHAIN PTR               *
*        2  PABOFFST PTR(8),           /* OFFSET FROM CONTROL BLOCK   *
*        2  PABDVTA PTR(24),           /* DVT ADDRESS                 *
*        2  PABRPHFG PTR(31),          /* SCHED FLAGS AND RPH         *
*           3  PABFLAGS BIT(8),        /* SCHEDULING FLAGS            *
*              4  PABAPYP BIT(1),      /* APPLICATION IS A USER EXIT  *
*              4  PABPRIOR BIT(1),     /* IMMEDIATE PRIORITY          *
*              4  PABNORPR BIT(1),     /* NORMAL PRIORITY -           *
*                                      /* RESCHEDUALABLE              *
*              4  PABDYNAM BIT(1),     /* DYNAMIC                     *
*              4  PABSSN BIT(1),       /* SYSTEM SERVICES             *
*              4  PABERLCK BIT(1),     /* PAB ERROR LOCK FLAG         *
*                 5  PABERRLK BIT(1),  /* ERROR LOCK                  *
*                    6  PABERLOK BIT(1), /* ERROR LOCK                *
*/*    ABNORMAL TO ALLOW VARY COMPARE AND SWAP                        *
*              4  PABINHBT BIT(1) ABNL,/* 1=INHIBIT TRAFFIC,0=NO      *
*              4  PABNODQ BIT(1),      /* DO NOT DEQ WORK ELEMENT     *
*           3  PABRPHA PTR(24);        /* RPL HEADER ADDRESS          *
*DCL PABWEQG0 BIT(32) CONSTANT('7FFFFFFF'X),  /* TURN PABWEQG OFF     *
*    PABWEQG1 BIT(32) CONSTANT('80000000'X),  /* TURN PABWEQG ON      *
*    PABCHNG0 BIT(32) CONSTANT('7FFFFFFF'X),  /* TURN PABCHNG OFF     *
*    PABCHNG1 BIT(32) CONSTANT('80000000'X),  /* TURN PABCHNG ON      *
*    PABRESC0 BIT(32) CONSTANT('BFFFFFFF'X),  /* TURN PABRESCH OFF    *
*    PABRESC1 BIT(32) CONSTANT('40000000'X),  /* TURN PABRESCH ON     *
*    PABCDP0  BIT(32) CONSTANT ('DFFFFFFF'X), /* TURN PABCDP OFF      *
*    PABCDP1  BIT(32) CONSTANT ('20000000'X), /* TURN PABCDP ON       *
*    PABERLK0 BIT(32) CONSTANT('FBFFFFFF'X),  /* TURN PABERRLK ON     *
*    PABERLK1 BIT(32) CONSTANT('04000000'X),  /* TURN PABERRLK OFF    *
*    PABUNCO0 BIT(32) CONSTANT('EFFFFFFF'X),  /* TURN PABUNCON OFF    *
*    PABUNCO1 BIT(32) CONSTANT('10000000'X),  /* TURN PABUNCON ON     *
*    PABPRIR0 BIT(32) CONSTANT('BFFFFFFF'X),  /* TURN PAB PRIOR OFF   *
*    PABPRIR1 BIT(32) CONSTANT('40000000'X),  /* TURN PAB PRIOR ON    *
*    PABRST0  BIT(32) CONSTANT('F7FFFFFF'X),  /* TURN PABRESET OFF    *
*    PABRST1  BIT(32) CONSTANT('08000000'X),  /* TURN PABRESET ON     *
*    PABDLAY0 BIT(32) CONSTANT('FDFFFFFF'X),  /* TURN PAB DELAY OFF   *
*    PABDLAY1 BIT(32) CONSTANT('02000000'X);  /* TURN PAB DELAY ON    *
*              /* DYNAMIC PAB 1K633 */                             0497
* /* 1K0997 JAN 20, 1973  MB   */                                  0497
* /* 1K1142 MAR 03, 1973  MB   */                                  0497
* DCL 1 ISTDYPAB BDY(DWORD) BASED, /* LEVEL 1 DECLARE 1K633 */     0497
*       2  DYPTYPE CHAR(1), /* CONTROL BLOCK TYPE CODE 1K633 */    0497
*       2  DYPLNGTH PTR(8), /* CONTROL BLOCK LENGTH (BYTES)  1K633 */
*       2 DYPFLGS CHAR(2),     /* FLAGS 1K633 */                   0497
*       2 DYPCHAIN PTR(31),    /* CHAIN POINTER 1K633 */           0497
*       2 DYPTSKID PTR(31),    /* TASKID OR PTR TO PSS TABLES 1K633 */
*       2  DYPRSV01 PTR(31),   /* RESERVED TO PRESERVE ALIGNMENT   0497
*                                                             1K0997 */
*       2 DYPPAB CHAR(LENGTH(ISTPAB)) BDY(DWORD); /* LENGTH OF 1K0997
*                                                    PAB         */
*DCL DYTYP   BIT(8) CONSTANT ('11'X);   /* TYPE           1K1142 */
*/* ***** PROCESS SCHEDULING TABLE FOR VS/2       ****** */        0499
*/*  INITIAL LEVEL                                      001 04/09/75 */
*DCL  1  ISTPST BDY(DWORD) BASED,                                  0499
*        2  PSTTYPE  CHAR(1),          /* CONTROL BLOCK TYPE         */
*        2  PSTLNGTH PTR(8),           /* LENGTH IN BYTES            */
*        2  *        CHAR(2),          /* RESERVED                   */
*        2  PSTCHAIN PTR(31),          /* ADDRESS OF NEXT PST        */
*        2  PSTRQFGA CHAR(8) BDY(DWORD),  /* READY QUEUE AND FLAGS   */
*           3  PSTRQUE PTR(31),        /* READY QUEUE                */
*              4  PSTRQFLG BIT(1),     /* READY QUEUE GATE           */
*              4  PSTRSV01 BIT(1),     /* REVERVED                   */
*              4  PSTRSV02 BIT(1),     /* REVERVED                   */
*              4  PSTRSV03 BIT(1),     /* REVERVED                   */
*              4  PSTRSV04 BIT(1),     /* REVERVED                   */
*              4  PSTRSV05 BIT(1),     /* REVERVED                   */
*              4  PSTRSV06 BIT(1),     /* REVERVED                   */
*              4  PSTRSV07 BIT(1),     /* REVERVED                   */
*              4  PSTRQUEA PTR(24),    /* READY QUEUE                */
*           3  PSTFLGA PTR(32),        /* FLAG FIELD                 */
*              4  PSTSSRN BIT(1),      /* IRB RUNNING SYSTEM SERVICE
*                                         TYPE REQUESTS              */
*              4  PSTUERN BIT(1),      /* IRB RUNNING USER EXIT TYPE
*                                         REQUESTS                   */
*              4  PSTIRBU1 BIT(1),     /* IRB # 1 IN USE             */
*              4  PSTIRBU2 BIT(1),     /* IRB # 2 IN USE             */
*              4  PSTSMQR BIT(1),      /* SMS RPH QUEUED FOR STORAGE */
*              4  PSTSMCU BIT(1),      /* SMS CRA IN USE             */
*              4  PSTAUTH BIT(1),      /* THE TASK THIS PST IS OBTAINED
*                                         FOR IS AUTHORIZED          */
*              4  PSTABINP BIT(1),     /* ABEND IN PROGRESS ON THIS
*                                         TASK                       */
*                 5 PSTABEND BIT(1),   /* TASK ABEND IN PROGRESS     */
*              4  PSTDMPC BIT(1),      /* DUMP HAS BEEN REQUESTED    */
*              4  PSTRSV08 BIT(23),    /* RESERVED                   */
*        2  PSTTCBA PTR(31),           /* TCB POINTER                */
*        2  PSTMPSTP PTR(31),          /* MPST POINTER - PST 6TH WORD*/
*        2  PSTACBCT FIXED(31),        /* COUNT OF OPEN ACB'S USING
*                                         THIS PST                   */
*        2  PSTPSSQ PTR(31),           /* POSTED SYSTEM SERVICE QUEUE*/
*        2  PSTNSSQ PTR(31),           /* NORMAL SYSTEM SERVICE QUEUE*/
*        2  PSTUEQ  PTR(31),           /* USER EXIT QUEUE            */
*        2  PSTIQE11 PTR(31),          /* INACTIVE IQE FOR FIRST IRB */
*        2  PSTIQE12 PTR(31),          /* ACTIVE IQE FOR FIRST IRB   */
*        2  PSTIQE21 PTR(31),          /* INACTIVE IQE FOR 2ND IRB   */
*        2  PSTIQE22 PTR(31),          /* ACTIVE IQE FOR 2ND IRB     */
*        2  PSTCRR1 PTR(31),           /* PREALLOCATED CRA           */
*        2  PSTCRRS PTR(31),           /* SMS CRA                    */
*        2  PSTSMDYP CHAR(LENGTH(ISTDYPAB)) BDY(DWORD), /* SMS PAB   */
*        2  PSTSAVE CHAR(32),          /* SAVE AREA                  */
*        2  PSTDEBP  PTR(31),          /* POINTER TO DEB CHAIN       */
*                                      /* WHEN TASK ABENDS           */
*        2  PSTDMPS  FIXED(31),        /* DUMMY MPST                 */
*           3 PSTDGATE BIT(1),         /* DUMMY MPST GATE BIT        */
*           3 *        BIT(7),         /* NOT TO BE USED             */
*           3 PSTDRDYQ PTR(24);        /* DUMMY MPST READY QUEUE     */
*DCL  PSTSSRN0 BIT(32) CONSTANT('7FFFFFFF'X); /* TURN PSTSSRN OFF    */
*DCL  PSTSSRN1 BIT(32) CONSTANT('80000000'X); /* TURN PSTSSRN ON     */
*DCL  PSTUERN0 BIT(32) CONSTANT('BFFFFFFF'X); /* TURN PSTUERN OFF    */
*DCL  PSTUERN1 BIT(32) CONSTANT('40000000'X); /* TURN PSTUERN ON     */
*DCL  PSTGATE0 BIT(32) CONSTANT('7FFFFFFF'X); /* TURN PST READY QUEUE
*                                                GATE OFF            */
*DCL  PSTGATE1 BIT(32) CONSTANT('80000000'X); /* TURN PST READY QUEUE
*                                                GATE ON             */
*DCL  PSTIRB10 BIT(32) CONSTANT('DFFFFFFF'X); /* TURN PSTIRBU1 OFF   */
*DCL  PSTIRB11 BIT(32) CONSTANT('20000000'X); /* TURN PSTIRBU1 ON    */
*DCL  PSTIRB20 BIT(32) CONSTANT('EFFFFFFF'X); /* TURN PSTIRBU2 OFF   */
*DCL  PSTIRB21 BIT(32) CONSTANT('10000000'X); /* TURN PSTIRBU2 ON    */
*DCL  PSTSMQR0 BIT(32) CONSTANT('F7FFFFFF'X); /* TURN PSTSMQR OFF    */
*DCL  PSTSMQR1 BIT(32) CONSTANT('08000000'X); /* TURN PSTSMQR ON     */
*DCL  PSTSMCU0 BIT(32) CONSTANT('FBFFFFFF'X); /* TURN PSTSMCU OFF    */
*DCL  PSTSMCU1 BIT(32) CONSTANT('04000000'X); /* TURN PSTSMCU ON     */
*DCL  PSTABIP1 BIT(32) CONSTANT('01000000'X); /* TURN PSTABINP ON    */
*DCL  PSTABIP0 BIT(32) CONSTANT('FEFFFFFF'X); /* TURN OFF PSTABINP   */
*DCL  PSTYPE   BIT(8) CONSTANT('61'X);        /* TYPE CODE FOR PST   */
*/* END OF ATBUILD */                    /*INCLUDE PROCESS SCHEDULING *
*                                        /*   TABLE (ISTPST)         */
*          GPR15P=GPR04P->PSTTCBA;       /*PUT TASK CONTROL BLOCK    */
         L     GPR15P,PSTTCBA(,GPR04P)                             0517
*                                        /*ADDRESS IN REGISTER 15    */
*          GPR04F=SAV40014;              /*RESTORE REG 4*/         0518
         ICM   @12,15,SAV40014(GPR13P)                             0518
         LR    GPR04F,@12                                          0518
*                                        /*INVOKE XREGSET MACRO TO */
*                                        /*VERIFY USER AREA OPERAND*/
*                                        /*AND PUT ADDR IN REG 1   */
*                                                                  0519
*/*XREGSET  PID('USER AREA')PPARM((RPLAREA))RREG(,GPR01P)*/        0519
*        DO;                                                       0519
*          GPR01P=RPLAREA;               /*SET RREG SYMBOL TO VALUE*/
         L     @12,RPHWEA(,PTRRPH)                                 0520
         L     @12,OCWRPL(,@12)                                    0520
         L     GPR01P,RPLAREA(,@12)                                0520
*                                        /*OF PPARM OPERAND        */
*        END;  /* XREGSET */                                       0521
*                                        /*INVOKE XREGSET MACRO TO */
*                                        /*VERIFY LENGTH OPERAND   */
*                                        /*AND PUT VALUE IN REG 14 */
*                                                                  0522
*/*XREGSET  PID('LENGTH')PPARM(RPLBUFL)RREG(,GPR14F)OUTPUT(PARM)*/ 0522
*        DO;                                                       0522
*          GPR14F=RPLBUFL;               /*SET RREG SYMBOL TO VALUE*/
         L     GPR14F,RPLBUFL(,@12)                                0523
*                                        /*OF PPARM OPERAND        */
*        END;  /* XREGSET */                                       0524
*        GEN SETS(2);                                              0525
         MODESET EXTKEY=ZERO,SAVEKEY=(2),WORKREG=2
*          GPR06P=GPR02P;                                          0526
         LR    GPR06P,GPR02P                                       0526
*          GPR04P=GPR15P;                /*RESTORE TCB ADDR*/      0527
         LR    GPR04P,GPR15P                                       0527
*          GPR02F=GPR01F+GPR14F-1;       /*PUT END ADDRESS IN REG 2  */
         LR    GPR02F,GPR01F                                       0528
         ALR   GPR02F,GPR14F                                       0528
         BCTR  GPR02F,0                                            0528
*          DCL CZMP0014 PTR(31) LOCATION(16);                      0529
*                                        /*ESTABLISH POINTER TO CVT  */
*          CALL CZMP0014->CVT0VL00;      /*INVOKE TASK SUPERVISOR    */
         L     @12,CZMP0014                                        0530
         L     @15,CVT0VL00(,@12)                                  0530
         BALR  @14,@15                                             0530
*                                        /*VALIDITY CHECKING ROUTINE */
*                                        /*UPON RETURN, CHECK PSW    */
*                                        /*CONDITION CODE SET BY THE */
*                                        /*VALIDITY CHECKING ROUTINE */
*          BC (8,OKAY0014);              /*IF ADDR VALID, DON'T ALTER*/
         BC    8,OKAY0014                                          0531
*                                        /*RETURN CODE VALUE FROM 0  */
*          C04R15=4;                     /*SET RETURN CODE TO ERROR  */
         LA    C04R15,4                                            0532
*          GO TO VC30014;                                          0533
         B     VC30014                                             0533
*OKAY0014: C04R15=0;                     /*PUT RETURN CODE IN RCREG  */
OKAY0014 SLR   C04R15,C04R15                                       0534
*VC30014:  GPR02P=GPR06P;                                          0535
VC30014  LR    GPR02P,GPR06P                                       0535
*        GEN SETS(2);                                              0536
         MODESET KEYADDR=(2),WORKREG=2
*          GPR01F=SAV10014;              /*RESTORE REGS ONE,         */
         ICM   GPR01F,15,SAV10014(GPR13P)                          0537
*          GPR02F=SAV20014;              /*            TWO,         */
         ICM   GPR02F,15,SAV20014(GPR13P)                          0538
*          GPR04F=SAV40014;              /*           FOUR,         */
         ICM   GPR04F,15,SAV40014(GPR13P)                          0539
*          GPR06F=SAV60014;              /*           SIX,          */
         ICM   GPR06F,15,SAV60014(GPR13P)                          0540
*          GPR14F=SAVE0014;              /*    AND FOURTEEN         */
*                                                                  0541
         ICM   GPR14F,15,SAVE0014(GPR13P)                          0541
*        RFY (GPR01P,GPR02P,GPR04P,GPR06P,GPR13P,GPR14P,GPR15P) UNRSTD;
*                                        /*UNRESTRICT REGISTERS    */
*        END;  /* VALCHEK */                                       0543
*       C04R13=C04R13-12;           /* RESET SAVE ADDRESS            */
         SL    C04R13,@CF01010                                     0544
*       IF C04R15^=C04ZERO          /* IF VALIDITY CHECK NOT OK      */
*         THEN                                                     0545
         LTR   C04R15,C04R15                                       0545
         BZ    @RF00545                                            0545
*         C04RC8=C04VC;             /* THEN SET INVALID RETURN CODE  */
         LA    C04RC8,23                                           0546
*       ELSE                                                       0547
*         DO;                                                      0547
         B     @RC00545                                            0547
@RF00545 DS    0H                                                  0548
*       RFY C04R15 UNRSTD;          /* FREE REG 15           @DM12421*/
*           RFY                                                    0549
*             NIBPTR RSTD;                                         0549
*           NIBPTR=RPLAREA;         /* INITIALIZE NIB BASE POINTER  */
         L     @15,RPHWEA(,PTRRPH)                                 0550
         L     @15,OCWRPL(,@15)                                    0550
         L     NIBPTR,RPLAREA(,@15)                                0550
*           DO WHILE C04COUNT>C04ZERO;  /* TO FIND RDTE             */
         B     @DE00551                                            0551
@DL00551 DS    0H                                                  0552
*             IF RPRENTRY=RPRENTTR|RPRENTRY=RPRENTCM|RPRENTRY=RPRENTUT|
*                 RPRENTRY=RPRENTLU THEN                           0552
         CLI   RPRENTRY(RDTPTR),X'80'                              0552
         BE    @RT00552                                            0552
         CLI   RPRENTRY(RDTPTR),X'90'                              0552
         BE    @RT00552                                            0552
         CLI   RPRENTRY(RDTPTR),X'75'                              0552
         BE    @RT00552                                            0552
         CLI   RPRENTRY(RDTPTR),X'81'                              0552
         BNE   @RF00552                                            0552
@RT00552 DS    0H                                                  0553
*               DO;                                                0553
*                 IF DEVSUBND=C04ON    /* DEVICE HAS SCHEDULABLE     */
*                   THEN DO;           /*   SUBNODES         @ZA17878*/
         TM    DEVSUBND+44(RDTPTR),B'00010000'                     0554
         BNO   @RF00554                                            0554
*                   C04COUNT=C04COUNT-C04ONE;/* DECREMENT COUNT BY 1 */
         BCTR  C04COUNT,0                                          0556
*                    C04SZE=C04SZE-C04NIBL; /* DECR REQ SZE  @ZA17878*/
         LA    @15,552                                             0557
         AL    @15,RPHWEA(,PTRRPH)                                 0557
         L     @12,C04SZE(,@15)                                    0557
         SL    @12,C04NIBL                                         0557
         ST    @12,C04SZE(,@15)                                    0557
*                   END;                                   /*@ZA17878*/
*                 ELSE                                             0559
*                   DO;             /* NO SCHEDULABLE SUBNODES       */
         B     @RC00554                                            0559
@RF00554 DS    0H                                                  0560
*                     C04COUNT=C04COUNT-C04ONE;/* DECREMENT COUNT    */
         BCTR  C04COUNT,0                                          0560
*                     RFY C04RDTE9 RSTD; /* FOR C04NIBIN     @XM08904*/
*                     C04RDTE9=RDTPTR;  /* LOAD PARM REG     @XM08904*/
         LR    C04RDTE9,RDTPTR                                     0562
*                     CALL C04NIBIN;  /* INITIALIZE NIB      @XM08904*/
         BAL   @14,C04NIBIN                                        0563
*                     RFY C04RDTE9 UNRSTD;  /* RELEASE REG   @XM08904*/
*                     IF C04COUNT=0 THEN                           0565
         LTR   C04COUNT,C04COUNT                                   0565
         BNZ   @RF00565                                            0565
*                       NIBLAST=C04OFF;/* SET LAST NIB BIT OFF       */
         LR    @15,NIBPTR                                          0566
         NI    NIBLAST(@15),B'01111111'                            0566
*                     ELSE                                         0567
*                       DO;                                        0567
         B     @RC00565                                            0567
@RF00565 DS    0H                                                  0568
*                         NIBPTR=NIBPTR+C04NIBL;/* INCREMENT NIB   0568
*                                                            POINTER */
         AL    NIBPTR,C04NIBL                                      0568
*                       END;                                       0569
*                   END;                                           0570
*               END;                                               0571
*             ELSE                                                 0572
*               ;                                                  0572
@RF00552 DS    0H                                                  0573
*             RDTPTR=RDTPTR+RPRELEN;/* GET NEXT RDTE ADDRESS         */
@RC00552 AH    RDTPTR,RPRELEN(,RDTPTR)                             0573
*           END;                    /* END OF DO WHILE LOOP          */
@DE00551 LTR   C04COUNT,C04COUNT                                   0574
         BP    @DL00551                                            0574
*           RFY                                                    0575
*             NIBPTR UNRSTD;                                       0575
*         END;                                                     0576
*       RFY                                                        0577
*         C04SIZE RSTD;                                            0577
@RC00545 DS    0H                                                  0578
*       C04SIZE=C04SZE;             /* RESTORE NEEDED SIZE           */
         L     @15,RPHWEA(,PTRRPH)                                 0578
         L     C04SIZE,C04SZE+552(,@15)                            0578
*     END;                          /* END OF ELSE LEG               */
*   C04R14=C04SAVE1;                /* RESTORE RETURN ADDRESS        */
@RC00472 L     @12,RPHWEA(,PTRRPH)                                 0580
         L     C04R14,C04SAVE1+552(,@12)                           0580
*   END C04NIBP;                                                   0581
@EL00002 DS    0H                                                  0581
@EF00002 DS    0H                                                  0581
@ER00002 BR    @14                                                 0581
*/********************************************************************/
*/* ROUTINE: C04SWL - SWITCHED LINE HANDLER                          */
*/*                                                                  */
*/* FUNCTION: CALLED BY CTERMN1 TO PROVIDE DATA FOR A TERMINAL       */
*/*           ON A SWITCHED LINE IN THE FORM OF NIB CONTROL          */
*/*           BLOCKS IN THE USER AREA                                */
*/*                                                                  */
*/* INPUT:  RDTPTR   (R6) - POINTER TO PORT RDT ENTRY                */
*/*         C04COUNT (R4) - CONTAINS A ZERO                          */
*/*         C04R14  (R14) - POINTER TO NSI IN CTERMN1                */
*/*                                                                  */
*/* OUTPUT: C06RC8  (R15) - CONTAINS A RETURN CODE, AS FOLLOWS:      */
*/*                         0   USER AREA HAS DATA                   */
*/*                      X'17'  AREA NOT VALID                       */
*/*                      X'2B'  NOT ENOUGH AREA                      */
*/*                      X'2C'  DATA NOT AVAILABLE                   */
*/*         C04R14  (R14) - POINTER TO NSI IN CTERMN1                */
*/*         TERMINAL NAME AND DEVICE CHARACTERISTICS MOVED TO USER-  */
*/*           DESIGNATED AREA FOR EACH UTERM                         */
*/*                                                                  */
*/* ROUTINES CALLED: C04DITT - TO PROVIDE DATA FOR MTA/SS TERMINALS  */
*/*                  C04DIVT - TO PROVIDE DATA FOR BSC TERMINALS     */
*/*                  C04NIBIN - TO INITIALIZE NIBS           @XM08904*/
*/*                                                                  */
*/* MACROS USED: NONE                                                */
*/********************************************************************/
*                                                                  0582
*C04SWL:                                                           0582
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0582
C04SWL   DS    0H                                                  0583
*   C04SAVE2=C04R14;                /* SAVE RETURN REG               */
         L     @15,RPHWEA(,PTRRPH)                                 0583
         ST    C04R14,C04SAVE2+552(,@15)                           0583
*   C04RC8=C04ZERO;                 /* INIT RC TO GOOD               */
         SLR   C04RC8,C04RC8                                       0584
*   RFY                                                            0585
*     TABPTR RSTD;                                                 0585
*   IF RLNTTV=C04ON                 /* IS DIAL-IN-TYPE (MTA/SS)      */
*     THEN                                                         0586
         TM    RLNTTV(RDTPTR),B'00001000'                          0586
         BNO   @RF00586                                            0586
*     DO;                           /* TABLE PRESENT ?               */
*       TABPTR=RPTDITT;             /* YES - GET ADDRESS             */
         L     TABPTR,RPTDITT(,RDTPTR)                             0588
*                                   /* OF FIRST ENTRY                */
*       DO WHILE DTELCTI^=DITTEND;  /* COUNT # OF ENTRIES IN TABLE 0589
*                                      @DM7262                       */
         B     @DE00589                                            0589
@DL00589 DS    0H                                                  0590
*         C04COUNT=C04COUNT+C04ONE; /* INCR BY ONE                   */
         AL    C04COUNT,@CF00061                                   0590
*         TABPTR=TABPTR+            /* GET NEXT DIAL-IN-TYPE ENT.    */
*             LENGTH(ISTDTE);       /*                               */
         AL    TABPTR,@CF00771                                     0591
*       END;                        /*                               */
@DE00589 CLI   DTELCTI(TABPTR),X'FF'                               0592
         BNE   @DL00589                                            0592
*       C04COUNT=C04COUNT+C04ONE;   /* ADJUST COUNT                  */
         LA    @15,1                                               0593
         ALR   C04COUNT,@15                                        0593
*       IF RPTUTERM^=C04ZERO        /* IF THERE IS AN UNIDENTIFED    */
*         THEN                                                     0594
         L     @12,RPTUTERM(,RDTPTR)                               0594
         LTR   @12,@12                                             0594
         BZ    @RF00594                                            0594
*         C04COUNT=                 /* TERMINAL - ADD ONE            */
*             C04COUNT+C04ONE;                                     0595
         ALR   C04COUNT,@15                                        0595
*       ELSE                                                       0596
*         ;                                                        0596
@RF00594 DS    0H                                                  0597
*     END;                                                         0597
*   ELSE                                                           0598
*     IF RLNIDV=C04ON               /* IS DIAL-IN-VERIFICATION       */
*       THEN                                                       0598
         B     @RC00586                                            0598
@RF00586 TM    RLNIDV(RDTPTR),B'00001000'                          0598
         BNO   @RF00598                                            0598
*       DO;                         /* (BYSNC) TABLE PRESENT ?       */
*         TABPTR=RPTDIVT;           /* GET ADDR OF HEADER ENTRY      */
         L     TABPTR,RPTDIVT(,RDTPTR)                             0600
*         C04COUNT=DIVNUME;         /* GET NUMBER OF ENTRIES         */
         LH    C04COUNT,DIVNUME(,TABPTR)                           0601
*         IF RPTUTERM^=C04ZERO      /* IF UNIDENTIFIED TERMINAL IS   */
*           THEN                                                   0602
         L     @15,RPTUTERM(,RDTPTR)                               0602
         LTR   @15,@15                                             0602
         BZ    @RF00602                                            0602
*           C04COUNT=               /* PRESENT -ADD ONE              */
*               C04COUNT+C04ONE;                                   0603
         AL    C04COUNT,@CF00061                                   0603
*         ELSE                                                     0604
*           ;                                                      0604
@RF00602 DS    0H                                                  0605
*       END;                                                       0605
*     ELSE                                                         0606
*       IF RPTUTERM^=C04ZERO        /* IF THERE IS AN UNIDENTIFD     */
*         THEN                                                     0606
         B     @RC00598                                            0606
@RF00598 L     @15,RPTUTERM(,RDTPTR)                               0606
         LTR   @15,@15                                             0606
         BZ    @RF00606                                            0606
*         C04COUNT=C04ONE;          /* TERMINAL COUNT IS ONE         */
         LA    C04COUNT,1                                          0607
*       ELSE                                                       0608
*         C04RC8=C042C;             /* OTHERWISE NO INFORMATION      */
         B     @RC00606                                            0608
@RF00606 LA    C04RC8,44                                           0608
*   IF C04RC8^=C04ZERO              /* IF RC IS NOT GOOD RETURN      */
*     THEN                                                         0609
@RC00606 DS    0H                                                  0609
@RC00598 DS    0H                                                  0609
@RC00586 LTR   C04RC8,C04RC8                                       0609
         BNZ   @RT00609                                            0609
*     ;                                                            0610
*   ELSE                                                           0611
*     DO;                                                          0611
*       C04SIZE=C04COUNT*LENGTH(ISTNIB);/* CALC. NEED AREA SIZE      */
         LR    C04SIZE,C04COUNT                                    0612
         SLA   C04SIZE,6                                           0612
*       IF RPLBUFL<C04SIZE          /* ENOUGH AREA ?                 */
*         THEN                                                     0613
         L     @15,RPHWEA(,PTRRPH)                                 0613
         L     @15,OCWRPL(,@15)                                    0613
         C     C04SIZE,RPLBUFL(,@15)                               0613
         BNH   @RF00613                                            0613
*         DO;                                                      0614
*           C04RC8=C042B;           /* NO - RETURN CODE 2B- RETURN   */
         LA    C04RC8,43                                           0615
*           C04COUNT=C04ZERO;       /* SET WORK COUNTER              */
         SLR   C04COUNT,C04COUNT                                   0616
*         END;                                                     0617
*       ELSE                                                       0618
*         DO;                       /* YES - IS IT VALID             */
         B     @RC00613                                            0618
@RF00613 DS    0H                                                  0619
*           C04SZE=C04SIZE;         /* SAVE NEEDED SIZE              */
         L     @15,RPHWEA(,PTRRPH)                                 0619
         ST    C04SIZE,C04SZE+552(,@15)                            0619
*           RFY                                                    0620
*             C04SIZE UNRSTD;                                      0620
*           C04R13=C04R13+C04TWEL;  /* 6 WORD SAVE AREA              */
         AL    C04R13,@CF01010                                     0621
*           C04R1=PTRRPH;           /* RESTORE RPH POINTER TO REG 1  */
         LR    C04R1,PTRRPH                                        0622
*           RFY C04R15 RSTD;        /* RESTRICT ACROSS MACRO @DM12421*/
*                                                                  0623
*/*VALCHEK  (C04R15,(C04R13),(RPLAREA),UA,RPLBUFL)  RANGE*/        0624
*            DO;                                                   0624
*                                                                  0624
*            RFY (GPR01P,GPR02P,GPR04P,GPR06P,GPR13P,GPR14P,GPR15P) RST
*;                                       /*DECLARE AND RESTRICT REGS*/
*                                        /*  1, 2, 4, 6, 13,14, AND 15
*/             C04R15=0;                /*SET RETURN CODE TO NO ERROR*/
         SLR   C04R15,C04R15                                       0626
*                                        /*INVOKE XREGSET MACRO TO */
*                                        /*VERIFY SAVEAREA OPERAND */
*                                        /*AND PUT IT IN REG 13    */
*                                                                  0627
*/*XREGSET  PID('SAVEAREA')PPARM((C04R13))RREG(13,GPR13P)*/        0627
*            DO;                                                   0627
*              GPR13P=C04R13;            /*SET RREG SYMBOL TO VALUE*/
*                                        /*OF PPARM OPERAND        */
*            END;  /* XREGSET */                                   0629
*              DCL 1 SAV0021 CHAR(20) BASED(GPR13P),               0630
*                                        /*ESTABLISH SAVE AREA MAP   */
*                    2 SAV10021 CHAR(4), /*TO SAVE REGS 1,2,4,6, AND 14
*/                   2 SAV20021 CHAR(4),                           0630
*                    2 SAV40021 CHAR(4),                           0630
*                    2 SAV60021 CHAR(4),                           0630
*                    2 SAVE0021 CHAR(4);                           0630
*              SAV10021=GPR01F;          /* SAVE REGS ONE,     */  0631
         STCM  GPR01F,15,SAV10021(GPR13P)                          0631
*              SAV20021=GPR02F;          /*           TWO,     */  0632
         STCM  GPR02F,15,SAV20021(GPR13P)                          0632
*              SAV40021=GPR04F;          /*          FOUR,     */  0633
         STCM  GPR04F,15,SAV40021(GPR13P)                          0633
*              SAV60021=GPR06F;          /*          SIX,      */  0634
         STCM  GPR06F,15,SAV60021(GPR13P)                          0634
*              SAVE0021=GPR14F;          /*     AND FOURTEEN   */  0635
         STCM  GPR14F,15,SAVE0021(GPR13P)                          0635
*              GPR04P=GPR01P->RPHTSKID;  /*PUT ADDR OF PROCESS SCHED-*/
         L     GPR04P,RPHTSKID(,GPR01P)                            0636
*                                        /*ULING TABLE IN REG 4      */
*                                                                  0637
*/* ATBUILD (ISTPST)  */                                           0637
*/* END OF ATBUILD */                    /*INCLUDE PROCESS SCHEDULING *
*                                        /*   TABLE (ISTPST)         */
*              GPR15P=GPR04P->PSTTCBA;   /*PUT TASK CONTROL BLOCK    */
         L     GPR15P,PSTTCBA(,GPR04P)                             0637
*                                        /*ADDRESS IN REGISTER 15    */
*              GPR04F=SAV40021;          /*RESTORE REG 4*/         0638
         ICM   @12,15,SAV40021(GPR13P)                             0638
         LR    GPR04F,@12                                          0638
*                                        /*INVOKE XREGSET MACRO TO */
*                                        /*VERIFY USER AREA OPERAND*/
*                                        /*AND PUT ADDR IN REG 1   */
*                                                                  0639
*/*XREGSET  PID('USER AREA')PPARM((RPLAREA))RREG(,GPR01P)*/        0639
*            DO;                                                   0639
*              GPR01P=RPLAREA;           /*SET RREG SYMBOL TO VALUE*/
         L     @12,RPHWEA(,PTRRPH)                                 0640
         L     @12,OCWRPL(,@12)                                    0640
         L     GPR01P,RPLAREA(,@12)                                0640
*                                        /*OF PPARM OPERAND        */
*            END;  /* XREGSET */                                   0641
*                                        /*INVOKE XREGSET MACRO TO */
*                                        /*VERIFY LENGTH OPERAND   */
*                                        /*AND PUT VALUE IN REG 14 */
*                                                                  0642
*/*XREGSET  PID('LENGTH')PPARM(RPLBUFL)RREG(,GPR14F)OUTPUT(PARM)*/ 0642
*            DO;                                                   0642
*              GPR14F=RPLBUFL;           /*SET RREG SYMBOL TO VALUE*/
         L     GPR14F,RPLBUFL(,@12)                                0643
*                                        /*OF PPARM OPERAND        */
*            END;  /* XREGSET */                                   0644
*        GEN SETS(2);                                              0645
         MODESET EXTKEY=ZERO,SAVEKEY=(2),WORKREG=2
*              GPR06P=GPR02P;                                      0646
         LR    GPR06P,GPR02P                                       0646
*              GPR04P=GPR15P;            /*RESTORE TCB ADDR*/      0647
         LR    GPR04P,GPR15P                                       0647
*              GPR02F=GPR01F+GPR14F-1;   /*PUT END ADDRESS IN REG 2  */
         LR    GPR02F,GPR01F                                       0648
         ALR   GPR02F,GPR14F                                       0648
         BCTR  GPR02F,0                                            0648
*              DCL CZMP0021 PTR(31) LOCATION(16);                  0649
*                                        /*ESTABLISH POINTER TO CVT  */
*              CALL CZMP0021->CVT0VL00;  /*INVOKE TASK SUPERVISOR    */
         L     @12,CZMP0021                                        0650
         L     @15,CVT0VL00(,@12)                                  0650
         BALR  @14,@15                                             0650
*                                        /*VALIDITY CHECKING ROUTINE */
*                                        /*UPON RETURN, CHECK PSW    */
*                                        /*CONDITION CODE SET BY THE */
*                                        /*VALIDITY CHECKING ROUTINE */
*              BC (8,OKAY0021);          /*IF ADDR VALID, DON'T ALTER*/
         BC    8,OKAY0021                                          0651
*                                        /*RETURN CODE VALUE FROM 0  */
*              C04R15=4;                 /*SET RETURN CODE TO ERROR  */
         LA    C04R15,4                                            0652
*              GO TO VC30021;                                      0653
         B     VC30021                                             0653
*OKAY0021:     C04R15=0;                 /*PUT RETURN CODE IN RCREG  */
OKAY0021 SLR   C04R15,C04R15                                       0654
*VC30021:      GPR02P=GPR06P;                                      0655
VC30021  LR    GPR02P,GPR06P                                       0655
*        GEN SETS(2);                                              0656
         MODESET KEYADDR=(2),WORKREG=2
*              GPR01F=SAV10021;          /*RESTORE REGS ONE,         */
         ICM   GPR01F,15,SAV10021(GPR13P)                          0657
*              GPR02F=SAV20021;          /*            TWO,         */
         ICM   GPR02F,15,SAV20021(GPR13P)                          0658
*              GPR04F=SAV40021;          /*           FOUR,         */
         ICM   GPR04F,15,SAV40021(GPR13P)                          0659
*              GPR06F=SAV60021;          /*           SIX,          */
         ICM   GPR06F,15,SAV60021(GPR13P)                          0660
*              GPR14F=SAVE0021;          /*    AND FOURTEEN         */
*                                                                  0661
         ICM   GPR14F,15,SAVE0021(GPR13P)                          0661
*            RFY (GPR01P,GPR02P,GPR04P,GPR06P,GPR13P,GPR14P,GPR15P) UNR
*TD;                                     /*UNRESTRICT REGISTERS    */
*            END;  /* VALCHEK */                                   0663
*           C04R13=C04R13-C04TWEL;                                 0664
         SL    C04R13,@CF01010                                     0664
*           IF C04R15^=C04ZERO THEN    /* VALCHEK FAILED             */
         LTR   C04R15,C04R15                                       0665
         BZ    @RF00665                                            0665
*             C04RC8=C04VC;          /* SET INVALID RETURN CODE      */
         LA    C04RC8,23                                           0666
*           ELSE                                                   0667
*             DO;                                                  0667
         B     @RC00665                                            0667
@RF00665 DS    0H                                                  0668
*           RFY C04R15 UNRSTD;      /* FREE REG 15           @DM12421*/
*               RFY                                                0669
*                 NIBPTR RSTD;                                     0669
*               NIBPTR=RPLAREA;     /* GET USER AREAS ADDR           */
         L     @15,RPHWEA(,PTRRPH)                                 0670
         L     @15,OCWRPL(,@15)                                    0670
         L     NIBPTR,RPLAREA(,@15)                                0670
*               IF RLNTTV=C04ON     /* IF DIAL-IN-TYPE               */
*                 THEN                                             0671
         TM    RLNTTV(RDTPTR),B'00001000'                          0671
         BNO   @RF00671                                            0671
*                 CALL C04DITT;     /* EXIST (MTA/SS) GOTO           */
         BAL   @14,C04DITT                                         0672
*                                   /* DIAL-IN SUBRTN                */
*               ELSE                                               0673
*                 IF RLNIDV=C04ON   /* IF DIAL-IN-VERIFICATN         */
*                   THEN                                           0673
         B     @RC00671                                            0673
@RF00671 TM    RLNIDV(RDTPTR),B'00001000'                          0673
         BNO   @RF00673                                            0673
*                   CALL C04DIVT;   /* (BSC) EXIST GOTO              */
         BAL   @14,C04DIVT                                         0674
*                                   /* VERIFICATION SUBRTN           */
*                 ELSE                                             0675
*                   DO;             /* MOVE UTERM INFORMATION        */
         B     @RC00673                                            0675
@RF00673 DS    0H                                                  0676
*                     RFY C04RDTE9 RSTD;  /* FOR C04NIBIN    @XM08904*/
*                     C04RDTE9=RPTUTERM;  /* UTERM RDTE      @XM08904*/
         L     C04RDTE9,RPTUTERM(,RDTPTR)                          0677
*                     CALL C04NIBIN;  /* INITIALIZE THE NIB  @XM08904*/
         BAL   @14,C04NIBIN                                        0678
*                     RFY C04RDTE9 UNRSTD;  /* RELEASE REG   @XM08904*/
*                     C04COUNT=C04ZERO;                            0680
         SLR   C04COUNT,C04COUNT                                   0680
*                     NIBLAST=C04OFF;                              0681
         LR    @15,NIBPTR                                          0681
         NI    NIBLAST(@15),B'01111111'                            0681
*                   END;                                           0682
*             END;                                                 0683
@RC00673 DS    0H                                                  0683
@RC00671 DS    0H                                                  0684
*           RFY                                                    0684
*             C04SIZE RSTD;                                        0684
@RC00665 DS    0H                                                  0685
*           C04SIZE=C04SZE;         /* RESTORE NEEDED SIZE           */
         L     @15,RPHWEA(,PTRRPH)                                 0685
         L     C04SIZE,C04SZE+552(,@15)                            0685
*         END;                                                     0686
*     END;                                                         0687
@RC00613 DS    0H                                                  0688
*   C04R14=C04SAVE2;                /* RESTORE RETURN REG            */
@RT00609 L     @12,RPHWEA(,PTRRPH)                                 0688
         L     C04R14,C04SAVE2+552(,@12)                           0688
*   END C04SWL;                                                    0689
@EL00003 DS    0H                                                  0689
@EF00003 DS    0H                                                  0689
@ER00003 BR    @14                                                 0689
*/********************************************************************/
*/* ROUTINE NAME: C04DITT - DIAL-IN-TYPE-TABLE (DITT) PROCESSOR      */
*/*                                                                  */
*/* FUNCTION: CALLED BY C04SWL TO PROVIDE TERMINAL INFORMATION       */
*/*           FROM TERMINALS IN DIAL-IN-TYPE TABLE (IE. MTA/SS)      */
*/*                                                                  */
*/* INPUT:  NIBPTR   (R0) - ADDRESS OF USER AREA                     */
*/*         RDTPTR   (R6) - ADDRESS OF MTA/SS PORT ENTRY             */
*/*         C04COUNT (R4) - NUMBER OF TERMINALS                      */
*/*         C04R14  (R14) - POINTER TO NSI IN C04SWL                 */
*/*                                                                  */
*/* OUTPUT: C04COUNT (R4) - CONTAINS ZERO                            */
*/*         C04RC8   (R8) - CONTAINS ZERO                            */
*/*         C04R14  (R14) - POINTER TO NSI IN C04SWL                 */
*/*         TERMINAL NAME AND DEVICE CHARACTERISTICS MOVED TO        */
*/*           USER-DESIGNATED AREA FOR EACH TERMINAL                 */
*/*                                                                  */
*/* ROUTINES CALLED: C04NIBIN - TO INITIALIZE NIBS           @XM08904*/
*/*                                                                  */
*/* MACROS USED: NONE                                                */
*/********************************************************************/
*                                                                  0690
*                                                                  0690
*C04DITT:                                                          0690
*   PROC OPTIONS(NOSAVEAREA,NOSAVE);                               0690
C04DITT  DS    0H                                                  0691
*   C04SAVE3=C04R14;                                       /*@XM08904*/
         L     @15,RPHWEA(,PTRRPH)                                 0691
         ST    C04R14,C04SAVE3+552(,@15)                           0691
*   TABPTR=RPTDITT;                 /* GET ADDRESS OF FIRST ENTRY  0692
*                                      @DM6299                       */
         L     TABPTR,RPTDITT(,RDTPTR)                             0692
*   DO WHILE DTELCTI^=DITTEND;      /* SEARCH TO LAST ENTRY @DM7262  */
         B     @DE00693                                            0693
@DL00693 DS    0H                                                  0694
*     RFY C04RDTE9 RSTD;            /* FOR C04NIBIN          @XM08904*/
*     C04RDTE9=DTERDTEA;            /* RDTE PTR FROM DITT    @XM08904*/
         ICM   C04RDTE9,15,DTERDTEA(TABPTR)                        0695
*     CALL C04NIBIN;                /* INITIALIZE NIBS       @XM08904*/
         BAL   @14,C04NIBIN                                        0696
*     RFY C04RDTE9 UNRSTD;          /* RELESE REG9           @XM08904*/
*     TABPTR=TABPTR+LENGTH(ISTDTE); /* INCR. TO NEXT ENTRY           */
         AL    TABPTR,@CF00771                                     0698
*     NIBPTR=NIBPTR+LENGTH(ISTNIB); /* UPDATE TO NEXT NIB            */
         AL    NIBPTR,@CF01184                                     0699
*   END;                                                           0700
*                                                                  0700
@DE00693 CLI   DTELCTI(TABPTR),X'FF'                               0700
         BNE   @DL00693                                            0700
*/* MOVE LAST ENTRY IN TABLE                                         */
*                                                                  0701
*   RFY C04RDTE9 RSTD;              /* FOR C04NIBIN          @XM08904*/
*   C04RDTE9=DTERDTEA;              /* RDTE PTR FROM DITT    @XM08904*/
         ICM   C04RDTE9,15,DTERDTEA(TABPTR)                        0702
*   CALL C04NIBIN;                  /* INITIALIZE NIBS       @XM08904*/
         BAL   @14,C04NIBIN                                        0703
*   RFY C04RDTE9 UNRSTD;            /* RELESE REG9           @XM08904*/
*   IF RPTUTERM^=C04ZERO THEN                                      0705
         L     @15,RPTUTERM(,RDTPTR)                               0705
         LTR   @15,@15                                             0705
         BZ    @RF00705                                            0705
*     DO;                                                          0706
*       RFY C04RDTE9 RSTD;          /* FOR C04NIBIN          @XM08904*/
*       C04RDTE9=RPTUTERM;          /* POINT TO UTERM RDTE   @XM08904*/
         LR    C04RDTE9,@15                                        0708
*       CALL C04NIBIN;              /* INITIALIZE UTERM NIB  @XM08904*/
         BAL   @14,C04NIBIN                                        0709
*       RFY C04RDTE9 UNRSTD;        /* RELEASE REG 9         @XM08904*/
*     END;                                                         0711
*   ELSE                                                           0712
*     ;                                                            0712
@RF00705 DS    0H                                                  0713
*   NIBLAST=C04OFF;                 /* FLAG NIB AS LAST IN CHAIN     */
         LR    @15,NIBPTR                                          0713
         NI    NIBLAST(@15),B'01111111'                            0713
*   RFY                                                            0714
*     C04COUNT RSTD;                                               0714
*   C04COUNT=C04ZERO;               /* ZERO COUNT                    */
         SLR   C04COUNT,C04COUNT                                   0715
*   C04RC8=C04ZERO;                 /* GOOD RETURN                   */
         SLR   C04RC8,C04RC8                                       0716
*   END C04DITT;                                                   0717
@EL00004 DS    0H                                                  0717
@EF00004 DS    0H                                                  0717
@ER00004 BR    @14                                                 0717
*/********************************************************************/
*/* ROUTINE NAME: C04DIVT - DIAL-IN VERIFICATION                     */
*/*                                                                  */
*/* FUNCTION: CALLED BY C04SWL TO PROVIDE TERMINAL INFORMATION FROM  */
*/*           TERMINALS IN DIAL-IN-VERIFICATION (I.E., BSC) TABLE    */
*/*                                                                  */
*/* INPUT:  TABPTR   (R5) - ADDR OF DIVTH (HEADER ENTRY)             */
*/*         NIBPTR   (R0) - ADDR OF FIRST NIB IN USER AREA           */
*/*         OWCDRDTE - ADDR OF BYSNC PORT ENTRY                      */
*/*         C04R14  (R14) - NSI ADDR IN CALLING ROUTINE (C04SWL)     */
*/*                                                                  */
*/* OUTPUT: C04COUNT (R4) - SET TO ZERO                              */
*/*         C04R14  (R14) - NSI ADDR IN CALLING ROUTINE (C04SWL)     */
*/*         C04RC8  (R8)  - SET TO ZERO                              */
*/*         TERMINAL NAME AND DEVICE CHARACTERISTICS MOVED TO USER-  */
*/*           DESIGNATED AREA FOR EACH DIVT ENTRY                    */
*/*                                                                  */
*/* ROUTINES CALLED: C04NIBIN - TO INITIALIZE NIBS           @XM08904*/
*/*                                                                  */
*/* MACROS USED: NONE                                                */
*/********************************************************************/
*                                                                  0718
*C04DIVT:                                                          0718
*   PROC OPTIONS(NOSAVEAREA,NOSAVE);                               0718
C04DIVT  DS    0H                                                  0719
*   C04SAVE3=C04R14;                                       /*@XM08904*/
         L     @15,RPHWEA(,PTRRPH)                                 0719
         ST    C04R14,C04SAVE3+552(,@15)                           0719
*   C04COUNT=DIVNUME;               /* RESET COUNT TO AGREE WITH     */
         LH    C04COUNT,DIVNUME(,TABPTR)                           0720
*                                   /* TABLE                         */
*   RFY C04R10 RSTD;                /* FOR DOWHILE           @XM08371*/
*   C04R10=DIVIDLEN;                /* GET BSCID FLD LENGTH  @XM08371*/
         LH    C04R10,DIVIDLEN(,TABPTR)                            0722
*   TABPTR=TABPTR+LENGTH(ISTDIVTH); /* GET ADDR OF FIRST ENTRY       */
         AL    TABPTR,@CF00059                                     0723
*   DO WHILE C04COUNT>C04ZERO;      /* SEARCH DIVT TABLE             */
         B     @DE00724                                            0724
@DL00724 DS    0H                                                  0725
*     RFY C04RDTE9 RSTD;            /* FOR C04NIBIN          @XM08904*/
*     C04RDTE9=DTERDTEA;            /* RDTE PTR FROM DITT    @XM08904*/
         ICM   C04RDTE9,15,DTERDTEA(TABPTR)                        0726
*     CALL C04NIBIN;                /* INITIALIZE NIBS       @XM08904*/
         BAL   @14,C04NIBIN                                        0727
*     RFY C04RDTE9 UNRSTD;          /* RELESE REG9           @XM08904*/
*     NIBPTR=NIBPTR+LENGTH(ISTNIB); /* GET NEXT NIB                  */
         AL    NIBPTR,@CF01184                                     0729
*     TABPTR=TABPTR+                /* GET NEXT DVE- INCREMENT BY LEN*/
*         C04FIVE+C04R10;           /* OF PTR+LEN FLD+ID FLD @XM08371*/
         LA    @15,5                                               0730
         ALR   @15,TABPTR                                          0730
         ALR   @15,C04R10                                          0730
         LR    TABPTR,@15                                          0730
*     C04COUNT=C04COUNT-C04ONE;     /* DECR. COUNT                   */
         BCTR  C04COUNT,0                                          0731
*   END;                                                           0732
@DE00724 SLR   @15,@15                                             0732
         CR    C04COUNT,@15                                        0732
         BH    @DL00724                                            0732
*   RFY C04R10 UNRSTD;              /*                       @XM08371*/
*   IF RPTUTERM^=C04ZERO            /* IF UTERM EXIST                */
*     THEN                                                         0734
         L     @12,RPTUTERM(,RDTPTR)                               0734
         CR    @12,@15                                             0734
         BE    @RF00734                                            0734
*     DO;                           /* MOVE UTERM INFO.              */
*       RFY C04RDTE9 RSTD;          /* FOR C04NIBIN          @XM08904*/
*       C04RDTE9=RPTUTERM;          /* POINT TO UTERM RDTE   @XM08904*/
         LR    C04RDTE9,@12                                        0737
*       CALL C04NIBIN;              /* INITIALIZE UTERM NIB  @XM08904*/
         BAL   @14,C04NIBIN                                        0738
*       RFY C04RDTE9 UNRSTD;        /* RELEASE REG 9         @XM08904*/
*     END;                                                         0740
*   ELSE                                                           0741
*     NIBPTR=NIBPTR-LENGTH(ISTNIB); /* DECR. UNNEEDED NIB            */
         B     @RC00734                                            0741
@RF00734 SL    NIBPTR,@CF01184                                     0741
*   NIBLAST=C04OFF;                 /* FLAG NIB AS LAST              */
@RC00734 LR    @15,NIBPTR                                          0742
         NI    NIBLAST(@15),B'01111111'                            0742
*   RFY                                                            0743
*    (TABPTR,                                                      0743
*     NIBPTR)UNRSTD;                                               0743
*   C04RC8=C04ZERO;                 /* SET GOOD RETURN               */
         SLR   C04RC8,C04RC8                                       0744
*   END C04DIVT;                                                   0745
@EL00005 DS    0H                                                  0745
@EF00005 DS    0H                                                  0745
@ER00005 BR    @14                                                 0745
*/********************************************************************/
*/* ROUTINE NAME: C04DLOUT - DIAL OUT PROCESSOR                      */
*/*                                                                  */
*/* FUNCTION: CALLED BY CTERMN1 TO GET COUNT OF TERMINALS ON         */
*/*           LCDO LINE GROUP (DIAL OUT OR DIAL IN-OUT LINES)        */
*/*                                                                  */
*/* INPUT:  RDTPTR   (R6) - POINTER TO DIAL-OUT RDT ENTRY            */
*/*         C04COUNT (R4) - CONTAINS A ZERO                          */
*/*         C04R14  (R14) - POINTER TO NSI IN CTERMN1                */
*/*                                                                  */
*/* OUTPUT: C06RC8  (R15) - CONTAINS A RETURN CODE, AS FOLLOWS:      */
*/*                         0   USER AREA HAS DATA                   */
*/*                      X'17'  AREA NOT VALID                       */
*/*                      X'2B'  NOT ENOUGH AREA                      */
*/*                      X'2C'  DATA NOT AVAILABLE                   */
*/*         C04R14  (R14) - POINTER TO NSI IN CTERMN1                */
*/*         TERMINAL NAME AND DEVICE CHARACTERISTICS MOVED TO USER-  */
*/*           DESIGNATED AREA FOR EACH DIAL-OUT TERMINAL IN TABLE    */
*/*                                                                  */
*/* ROUTINES CALLED: C04NIBIN - TO INITIALIZE NIBS           @XM08904*/
*/*                                                                  */
*/* MACROS USED: VALCHEK - TO VALIDATE USER SUPPLIED AREA            */
*/********************************************************************/
*                                                                  0746
*C04DLOUT:                                                         0746
*   PROC OPTIONS(NOSAVEAREA,NOSAVE);                               0746
C04DLOUT DS    0H                                                  0747
*   C04SAVE2=C04R14;                /* SAVE RETURN ADDR              */
         L     @15,RPHWEA(,PTRRPH)                                 0747
         ST    C04R14,C04SAVE2+552(,@15)                           0747
*   C04COUNT=RDSCTTRM;              /* COUNT OF ENTRIES IN DIAL      */
         LH    C04COUNT,RDSCTTRM(,RDTPTR)                          0748
*   RFY                             /* OUT TABLE                     */
*     C04SIZE RSTD;                                                0749
*   C04SIZE=C04COUNT*C04NIBL;                                      0750
         LR    @11,C04COUNT                                        0750
         M     @10,C04NIBL                                         0750
         LR    C04SIZE,@11                                         0750
*   IF RPLBUFL<C04SIZE              /* ENOUGH AREA IN BUFFER TO      */
*     THEN                          /*   BUILD NIBS?                 */
         L     @15,OCWRPL(,@15)                                    0751
         C     C04SIZE,RPLBUFL(,@15)                               0751
         BNH   @RF00751                                            0751
*     DO;                                                          0752
*       C04COUNT=C04ZERO;                                          0753
         SLR   C04COUNT,C04COUNT                                   0753
*       C04RC8=C042B;               /* NO - 2B RC AND RETURN         */
         LA    C04RC8,43                                           0754
*     END;                                                         0755
*   ELSE                                                           0756
*     DO;                                                          0756
         B     @RC00751                                            0756
@RF00751 DS    0H                                                  0757
*       C04SZE=C04SIZE;             /* SAVE NEEDED SIZE              */
         L     @15,RPHWEA(,PTRRPH)                                 0757
         ST    C04SIZE,C04SZE+552(,@15)                            0757
*       RFY                                                        0758
*         C04SIZE UNRSTD;                                          0758
*       C04R13=C04R13+C04TWEL;      /* 6 WORD SAVE AREA              */
         AL    C04R13,@CF01010                                     0759
*       C04R1=PTRRPH;               /* RESTORE RPH POINTER TO REG 1  */
         LR    C04R1,PTRRPH                                        0760
*       RFY C04R15 RSTD;            /* RESTRICT ACROSS MACRO @DM12421*/
*                                                                  0761
*/*VALCHEK  (C04R15,(C04R13),(RPLAREA),UA,RPLBUFL)  RANGE*/        0762
*        DO;                                                       0762
*                                                                  0762
*        RFY (GPR01P,GPR02P,GPR04P,GPR06P,GPR13P,GPR14P,GPR15P) RSTD;
*                                        /*DECLARE AND RESTRICT REGS*/
*                                        /*  1, 2, 4, 6, 13,14, AND 15
*/         C04R15=0;                    /*SET RETURN CODE TO NO ERROR*/
         SLR   C04R15,C04R15                                       0764
*                                        /*INVOKE XREGSET MACRO TO */
*                                        /*VERIFY SAVEAREA OPERAND */
*                                        /*AND PUT IT IN REG 13    */
*                                                                  0765
*/*XREGSET  PID('SAVEAREA')PPARM((C04R13))RREG(13,GPR13P)*/        0765
*        DO;                                                       0765
*          GPR13P=C04R13;                /*SET RREG SYMBOL TO VALUE*/
*                                        /*OF PPARM OPERAND        */
*        END;  /* XREGSET */                                       0767
*          DCL 1 SAV0028 CHAR(20) BASED(GPR13P),                   0768
*                                        /*ESTABLISH SAVE AREA MAP   */
*                2 SAV10028 CHAR(4),     /*TO SAVE REGS 1,2,4,6, AND 14
*/               2 SAV20028 CHAR(4),                               0768
*                2 SAV40028 CHAR(4),                               0768
*                2 SAV60028 CHAR(4),                               0768
*                2 SAVE0028 CHAR(4);                               0768
*          SAV10028=GPR01F;              /* SAVE REGS ONE,     */  0769
         STCM  GPR01F,15,SAV10028(GPR13P)                          0769
*          SAV20028=GPR02F;              /*           TWO,     */  0770
         STCM  GPR02F,15,SAV20028(GPR13P)                          0770
*          SAV40028=GPR04F;              /*          FOUR,     */  0771
         STCM  GPR04F,15,SAV40028(GPR13P)                          0771
*          SAV60028=GPR06F;              /*          SIX,      */  0772
         STCM  GPR06F,15,SAV60028(GPR13P)                          0772
*          SAVE0028=GPR14F;              /*     AND FOURTEEN   */  0773
         STCM  GPR14F,15,SAVE0028(GPR13P)                          0773
*          GPR04P=GPR01P->RPHTSKID;      /*PUT ADDR OF PROCESS SCHED-*/
         L     GPR04P,RPHTSKID(,GPR01P)                            0774
*                                        /*ULING TABLE IN REG 4      */
*                                                                  0775
*/* ATBUILD (ISTPST)  */                                           0775
*/* END OF ATBUILD */                    /*INCLUDE PROCESS SCHEDULING *
*                                        /*   TABLE (ISTPST)         */
*          GPR15P=GPR04P->PSTTCBA;       /*PUT TASK CONTROL BLOCK    */
         L     GPR15P,PSTTCBA(,GPR04P)                             0775
*                                        /*ADDRESS IN REGISTER 15    */
*          GPR04F=SAV40028;              /*RESTORE REG 4*/         0776
         ICM   @12,15,SAV40028(GPR13P)                             0776
         LR    GPR04F,@12                                          0776
*                                        /*INVOKE XREGSET MACRO TO */
*                                        /*VERIFY USER AREA OPERAND*/
*                                        /*AND PUT ADDR IN REG 1   */
*                                                                  0777
*/*XREGSET  PID('USER AREA')PPARM((RPLAREA))RREG(,GPR01P)*/        0777
*        DO;                                                       0777
*          GPR01P=RPLAREA;               /*SET RREG SYMBOL TO VALUE*/
         L     @12,RPHWEA(,PTRRPH)                                 0778
         L     @12,OCWRPL(,@12)                                    0778
         L     GPR01P,RPLAREA(,@12)                                0778
*                                        /*OF PPARM OPERAND        */
*        END;  /* XREGSET */                                       0779
*                                        /*INVOKE XREGSET MACRO TO */
*                                        /*VERIFY LENGTH OPERAND   */
*                                        /*AND PUT VALUE IN REG 14 */
*                                                                  0780
*/*XREGSET  PID('LENGTH')PPARM(RPLBUFL)RREG(,GPR14F)OUTPUT(PARM)*/ 0780
*        DO;                                                       0780
*          GPR14F=RPLBUFL;               /*SET RREG SYMBOL TO VALUE*/
         L     GPR14F,RPLBUFL(,@12)                                0781
*                                        /*OF PPARM OPERAND        */
*        END;  /* XREGSET */                                       0782
*        GEN SETS(2);                                              0783
         MODESET EXTKEY=ZERO,SAVEKEY=(2),WORKREG=2
*          GPR06P=GPR02P;                                          0784
         LR    GPR06P,GPR02P                                       0784
*          GPR04P=GPR15P;                /*RESTORE TCB ADDR*/      0785
         LR    GPR04P,GPR15P                                       0785
*          GPR02F=GPR01F+GPR14F-1;       /*PUT END ADDRESS IN REG 2  */
         LR    GPR02F,GPR01F                                       0786
         ALR   GPR02F,GPR14F                                       0786
         BCTR  GPR02F,0                                            0786
*          DCL CZMP0028 PTR(31) LOCATION(16);                      0787
*                                        /*ESTABLISH POINTER TO CVT  */
*          CALL CZMP0028->CVT0VL00;      /*INVOKE TASK SUPERVISOR    */
         L     @12,CZMP0028                                        0788
         L     @15,CVT0VL00(,@12)                                  0788
         BALR  @14,@15                                             0788
*                                        /*VALIDITY CHECKING ROUTINE */
*                                        /*UPON RETURN, CHECK PSW    */
*                                        /*CONDITION CODE SET BY THE */
*                                        /*VALIDITY CHECKING ROUTINE */
*          BC (8,OKAY0028);              /*IF ADDR VALID, DON'T ALTER*/
         BC    8,OKAY0028                                          0789
*                                        /*RETURN CODE VALUE FROM 0  */
*          C04R15=4;                     /*SET RETURN CODE TO ERROR  */
         LA    C04R15,4                                            0790
*          GO TO VC30028;                                          0791
         B     VC30028                                             0791
*OKAY0028: C04R15=0;                     /*PUT RETURN CODE IN RCREG  */
OKAY0028 SLR   C04R15,C04R15                                       0792
*VC30028:  GPR02P=GPR06P;                                          0793
VC30028  LR    GPR02P,GPR06P                                       0793
*        GEN SETS(2);                                              0794
         MODESET KEYADDR=(2),WORKREG=2
*          GPR01F=SAV10028;              /*RESTORE REGS ONE,         */
         ICM   GPR01F,15,SAV10028(GPR13P)                          0795
*          GPR02F=SAV20028;              /*            TWO,         */
         ICM   GPR02F,15,SAV20028(GPR13P)                          0796
*          GPR04F=SAV40028;              /*           FOUR,         */
         ICM   GPR04F,15,SAV40028(GPR13P)                          0797
*          GPR06F=SAV60028;              /*           SIX,          */
         ICM   GPR06F,15,SAV60028(GPR13P)                          0798
*          GPR14F=SAVE0028;              /*    AND FOURTEEN         */
*                                                                  0799
         ICM   GPR14F,15,SAVE0028(GPR13P)                          0799
*        RFY (GPR01P,GPR02P,GPR04P,GPR06P,GPR13P,GPR14P,GPR15P) UNRSTD;
*                                        /*UNRESTRICT REGISTERS    */
*        END;  /* VALCHEK */                                       0801
*       C04R13=C04R13-C04TWEL;                                     0802
         SL    C04R13,@CF01010                                     0802
*       IF C04R15^=C04ZERO THEN     /* USER AREA NOT VALID           */
         LTR   C04R15,C04R15                                       0803
         BZ    @RF00803                                            0803
*         DO;                                                      0804
*       RFY C04R15 UNRSTD;          /* FREE REG 15           @DM12421*/
*           C04COUNT=C04ZERO;                                      0806
         SLR   C04COUNT,C04COUNT                                   0806
*           C04RC8=C04VC;           /* SET RC TO INVALID AREA        */
         LA    C04RC8,23                                           0807
*         END;                                                     0808
*       ELSE                                                       0809
*         DO;                                                      0809
         B     @RC00803                                            0809
@RF00803 DS    0H                                                  0810
*           RFY                                                    0810
*            (NIBPTR,                                              0810
*             TABPTR)RSTD;                                         0810
*           TABPTR=RDSADDOT;        /* SET UP DOT TAB POINTER        */
         L     TABPTR,RDSADDOT(,RDTPTR)                            0811
*           NIBPTR=RPLAREA;         /* SET UP NIB POINTER            */
         L     @15,RPHWEA(,PTRRPH)                                 0812
         L     @15,OCWRPL(,@15)                                    0812
         L     NIBPTR,RPLAREA(,@15)                                0812
*           DO WHILE C04COUNT>C04ZERO;/* SEARCH DOT ENTRIES          */
         B     @DE00813                                            0813
@DL00813 DS    0H                                                  0814
*             RFY C04RDTE9 RSTD;    /* FOR C04NIBIN          @XM08904*/
*             C04RDTE9=DOTADTRM;    /* GET RDTE PTR FROM DOT @XM08904*/
         L     C04RDTE9,DOTADTRM(,TABPTR)                          0815
*             CALL C04NIBIN;        /* INITIALIZE NIB        @XM08904*/
         BAL   @14,C04NIBIN                                        0816
*             RFY C04RDTE9 UNRSTD;  /* RELEASE REG 9         @XM08904*/
*             C04COUNT=C04COUNT-    /* DEC. COUNT BY ONE             */
*                 C04ONE;                                          0818
         BCTR  C04COUNT,0                                          0818
*             NIBPTR=NIBPTR         /* UPDATE NIB POINTER            */
*                 +C04NIBL;                                        0819
         AL    NIBPTR,C04NIBL                                      0819
*             TABPTR=TABPTR+        /* UPDATE DOT POINTER            */
*                 LENGTH(ISTDOT);                                  0820
         AL    TABPTR,@CF00053                                     0820
*           END;                    /* DO WHILE                      */
@DE00813 LTR   C04COUNT,C04COUNT                                   0821
         BP    @DL00813                                            0821
*           NIBPTR=NIBPTR-C04NIBL;  /* BACK UP TO LAST NIB           */
         SL    NIBPTR,C04NIBL                                      0822
*           NIBLAST=C04OFF;         /* FLAG NIB AS LAST              */
         LR    @15,NIBPTR                                          0823
         NI    NIBLAST(@15),B'01111111'                            0823
*           RFY                                                    0824
*            (NIBPTR,                                              0824
*             TABPTR)UNRSTD;                                       0824
*         END;                                                     0825
*       RFY                                                        0826
*         C04SIZE RSTD;                                            0826
@RC00803 DS    0H                                                  0827
*       C04SIZE=C04SZE;             /* RESTORE NEEDED SIZE           */
         L     @15,RPHWEA(,PTRRPH)                                 0827
         L     C04SIZE,C04SZE+552(,@15)                            0827
*     END;                                                         0828
*   C04R14=C04SAVE2;                                               0829
@RC00751 L     @12,RPHWEA(,PTRRPH)                                 0829
         L     C04R14,C04SAVE2+552(,@12)                           0829
*   END C04DLOUT;                                                  0830
@EL00006 DS    0H                                                  0830
@EF00006 DS    0H                                                  0830
@ER00006 BR    @14                                                 0830
*                                                                  0831
*/********************************************************************/
*/* ROUTINE NAME: CTERMN1 - CHECK RDT ENTRY                          */
*/*                                                                  */
*/* FUNCTION: CALLED BY MAIN LINE ROUTINE TO CHECK RDT ENTRY TYPE    */
*/*           AND EITHER PROVIDE COUNT OF UNITS ASSOCIATED WITH THE  */
*/*           ENTRY OR CALL A ROUTINE TO HANDLE SWITCHED OR DIAL-    */
*/*           OUT LINE-TYPE ENTRIES                                  */
*/*                                                                  */
*/* INPUT:  RDTPTR   (R6) _ POINTER TO RDT ENTRY                     */
*/*         C04R14  (R14) - NSI ADDR IN CALLING ROUTINE (MAINLINE)   */
*/*                                                                  */
*/* OUTPUT: C04COUNT (R4) - >0 IF C04NIBP IS TO BE CALLED            */
*/*                         =0 IF SWITCHED OR DIAL-OUT LINE RDTE     */
*/*                             HAS BEEN PROCESSED                   */
*/*         C04R14  (R14) - NSI ADDR IN CALLING ROUTINE (MAINLINE)   */
*/*         C04RC8   (R8) - SET TO 4 IF INVALID RDTE TYPE IS FOUND   */
*/*                                                                  */
*/* ROUTINES CALLED: C04SWL    - TO OBTAIN DATA FOR SWITCHED LINES   */
*/*                  C04DLOUT  - TO OBTAIN DATA FOR DIAL-OUT LINES   */
*/*                                                                  */
*/* MACROS USED: NONE                                                */
*/********************************************************************/
*                                                                  0831
*CTERMN1:                                                          0831
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0831
CTERMN1  DS    0H                                                  0832
*   C04SAVE1=C04R14;                /* SAVE RETURN ADDR              */
         L     @15,RPHWEA(,PTRRPH)                                 0832
         ST    C04R14,C04SAVE1+552(,@15)                           0832
*   C04COUNT=C04ZERO;               /* INIT COUNT TO ZERO            */
         SLR   C04COUNT,C04COUNT                                   0833
*   IF RPRENTRY=RPRENTRN            /* IF IT IS AN RN RDTE           */
*     THEN                                                         0834
         CLI   RPRENTRY(RDTPTR),X'01'                              0834
         BNE   @RF00834                                            0834
*     C04COUNT=RRNCTETR+            /* THEN SET COUNT = TERM NO      */
*         RRNCTECM;                 /* PLUS COMPONENT NUMBER         */
         LH    C04COUNT,RRNCTETR(,RDTPTR)                          0835
         AH    C04COUNT,RRNCTECM(,RDTPTR)                          0835
*   ELSE                                                           0836
*     IF RPRENTRY=RPRENTCC          /* IF RDTE IS FOR COMP CLUSTER   */
*       THEN                                                       0836
         B     @RC00834                                            0836
@RF00834 CLI   RPRENTRY(RDTPTR),X'71'                              0836
         BNE   @RF00836                                            0836
*       C04COUNT=RCCCTELU;          /* SET COUNT TO NUMBER OF LOGICAL
*                                      UNITS IN CLUSTER              */
         LH    C04COUNT,RCCCTELU(,RDTPTR)                          0837
*     ELSE                                                         0838
*       IF RPRENTRY=RPRENTLC|       /* IF IT IS A LOCAL RDTE         */
*           RPRENTRY=RPRENTLU       /* OR A LOGICAL UNIT RDTE        */
*         THEN                                                     0838
         B     @RC00836                                            0838
@RF00836 CLI   RPRENTRY(RDTPTR),X'45'                              0838
         BE    @RT00838                                            0838
         CLI   RPRENTRY(RDTPTR),X'81'                              0838
         BNE   @RF00838                                            0838
@RT00838 DS    0H                                                  0839
*         C04COUNT=C04ONE;          /* SET COUNT = ONE               */
         LA    C04COUNT,1                                          0839
*       ELSE                                                       0840
*         IF RPRENTRY=RPRENTGP      /* IF IT IS AN GROUP RDTE        */
*           THEN                                                   0840
         B     @RC00838                                            0840
@RF00838 CLI   RPRENTRY(RDTPTR),X'30'                              0840
         BNE   @RF00840                                            0840
*           C04COUNT=RGPCTETR;      /* SET COUNT = RGPCTETR          */
         LH    C04COUNT,RGPCTETR(,RDTPTR)                          0841
*         ELSE                                                     0842
*           IF RPRENTRY=RPRENTLN    /* IF IT IS A LINE RDTE          */
*             THEN                                                 0842
         B     @RC00840                                            0842
@RF00840 CLI   RPRENTRY(RDTPTR),X'50'                              0842
         BNE   @RF00842                                            0842
*             DO;                                                  0843
*               IF DEVCSWL=C04ON    /* SW SDLC LINK?         @D32CKTQ*/
*                      &RLNRATRN=C04ON                     /*@D32CKTQ*/
*                 THEN              /* TOO DYNAMIC FOR US TO @D32CKTQ*/
         TM    DEVCSWL+44(RDTPTR),B'00010000'                      0844
         BNO   @RF00844                                            0844
         TM    RLNRATRN(RDTPTR),B'00000010'                        0844
         BNO   @RF00844                                            0844
*                   C04RC8=4;       /*   HANDLE FOR THE USER @D32CKTQ*/
         LA    C04RC8,4                                            0845
*                 ELSE                                             0846
*                 DO;                                      /*@D32CKTQ*/
         B     @RC00844                                            0846
@RF00844 DS    0H                                                  0847
*                   IF RLNPORT=C04ON    /* IF IT IS A SW LINE@D32CKTQ*/
*                     THEN                                         0847
         TM    RLNPORT(RDTPTR),B'00010000'                         0847
         BNO   @RF00847                                            0847
*                       CALL C04SWL;                       /*@D32CKTQ*/
         BAL   @14,C04SWL                                          0848
*                     ELSE                                         0849
*                       C04COUNT=RLNCTETR+RLNCTECM;        /*@D32CKTQ*/
         B     @RC00847                                            0849
@RF00847 LH    C04COUNT,RLNCTETR(,RDTPTR)                          0849
         AH    C04COUNT,RLNCTECM(,RDTPTR)                          0849
*                   END;                                   /*@D32CKTQ*/
*             END;                                                 0851
*           ELSE                                                   0852
*             IF RPRENTRY=RPRENTDS  /* IF LINE IS DIAL-OUT           */
*               THEN                                               0852
         B     @RC00842                                            0852
@RF00842 CLI   RPRENTRY(RDTPTR),X'20'                              0852
         BNE   @RF00852                                            0852
*               CALL C04DLOUT;                                     0853
         BAL   @14,C04DLOUT                                        0853
*             ELSE                                                 0854
*               IF RPRENTRY=RPRENTCL/* IF IT IS CLUSTER RDTE         */
*                 THEN                                             0854
         B     @RC00852                                            0854
@RF00852 CLI   RPRENTRY(RDTPTR),X'70'                              0854
         BNE   @RF00854                                            0854
*                 C04COUNT=RCLCTETR+RCLCTECM;/* GET COUNT OF       0855
*                                      TERMINALS AND COMPONENTS IN 0855
*                                      CLUSTER                       */
         LH    C04COUNT,RCLCTETR(,RDTPTR)                          0855
         AH    C04COUNT,RCLCTECM(,RDTPTR)                          0855
*               ELSE                                               0856
*                 IF RPRENTRY=RPRENTCM/* COMPONENT RDTE ?            */
*                   THEN                                           0856
         B     @RC00854                                            0856
@RF00854 CLI   RPRENTRY(RDTPTR),X'90'                              0856
         BNE   @RF00856                                            0856
*                     IF (RDTPTR-RPRPELEN)->RPRENTRY=      /*@ZA17845*/
*                         RPRENTTR  /* FIRST COMPONENT UNDER TERMINAL
*                                      HAS NAME ASSOCIATED WITH TERM
*                                      MACRO, SO WE PROVIDE ALL    0857
*                                      COMPONENT NAMES       @ZA17845*/
*                        THEN       /* COUNT OF COMPONENTS   @ZA17845*/
         LR    @15,RDTPTR                                          0857
         SH    @15,RPRPELEN(,RDTPTR)                               0857
         CLI   RPRENTRY(@15),X'80'                                 0857
         BNE   @RF00857                                            0857
*                          C04COUNT=(RDTPTR-RPRPELEN)->    /*@ZA17845*/
*                            RTRCTECM; /* IS IN DUMMY TERM   @ZA17845*/
         LH    C04COUNT,RTRCTECM(,@15)                             0858
*                        ELSE C04COUNT=1; /* OTHERWISE WE PROVIDE ONLY
*                                            A NIB FOR COMP. @ZA17845*/
         B     @RC00857                                            0859
@RF00857 LA    C04COUNT,1                                          0859
*                 ELSE                                             0860
*                   IF RPRENTRY=RPRENTTR| /* IF ENTRY IS TERM RDTE OR*/
*                      RPRENTRY=RPRENTUT  /* UNIDENT TERMNL  @XM08381*/
*                     THEN                                         0860
         B     @RC00856                                            0860
@RF00856 CLI   RPRENTRY(RDTPTR),X'80'                              0860
         BE    @RT00860                                            0860
         CLI   RPRENTRY(RDTPTR),X'75'                              0860
         BNE   @RF00860                                            0860
@RT00860 DS    0H                                                  0861
*                     DO;           /* YES DO FOLLOWS                */
*                       IF DEVTCODE=DEV2980/* 2980 ? @DM6414         */
*                         THEN                                     0862
         CLI   DEVTCODE+44(RDTPTR),X'18'                           0862
         BNE   @RF00862                                            0862
*                         DO;       /* YES DO FOLLOWS                */
*                           C04N1=C04DS;/* MOVE $ IN WORKAREA        */
         LA    @15,552                                             0864
         AL    @15,RPHWEA(,PTRRPH)                                 0864
         MVI   C04N1(@15),C'$'                                     0864
*                           C04N28=RPRNAME(1:7);/* RPRNAME 1-7       */
         MVC   C04N28(7,@15),RPRNAME(RDTPTR)                       0865
*                           C04PNTR=RDTPTR+RPRELEN;/* NET ENTRY ADDR */
         LR    C04PNTR,RDTPTR                                      0866
         AH    C04PNTR,RPRELEN(,RDTPTR)                            0866
*                           IF C04PNTR->RPRNAME=C04SNAME THEN      0867
         CLC   RPRNAME(8,C04PNTR),C04SNAME(@15)                    0867
         BNE   @RF00867                                            0867
*                             C04COUNT=C04TWO;                     0868
         LA    C04COUNT,2                                          0868
*                           ELSE                                   0869
*                             C04COUNT=C04ONE;                     0869
         B     @RC00867                                            0869
@RF00867 LA    C04COUNT,1                                          0869
*                         END;                                     0870
*                       ELSE                                       0871
*                         C04COUNT=C04ONE;                         0871
         B     @RC00862                                            0871
@RF00862 LA    C04COUNT,1                                          0871
*                     END;                                         0872
*                   ELSE                                           0873
*                     DO;           /* ALSO ALLOW SW,LS,DA   @D32CKTQ*/
         B     @RC00860                                            0873
@RF00860 DS    0H                                                  0874
*                       IF RPRENTRY=RPRENTSW /* SW S/A?      @D32CKTQ*/
*                         THEN      /* HIS RDTE HAS COUNT    @D32CKTQ*/
         CLI   RPRENTRY(RDTPTR),X'04'                              0874
         BNE   @RF00874                                            0874
*                           C04COUNT=RSWCTELU; /* OF LU'S    @D32CKTQ*/
         LH    C04COUNT,RSWCTELU(,RDTPTR)                          0875
*                         ELSE      /* KEEP CHECKING....     @D32CKTQ*/
*                           IF RPRENTRY=RPRENTLS /* LOCAL S/A HDR?   */
*                             THEN                                 0876
         B     @RC00874                                            0876
@RF00874 CLI   RPRENTRY(RDTPTR),X'05'                              0876
         BNE   @RF00876                                            0876
*                               C04COUNT=RLSCTELU;         /*@D32CKTQ*/
         LH    C04COUNT,RLSCTELU(,RDTPTR)                          0877
*                                 ELSE  /* DIRECT ATTACH IS LAST CHNC*/
*                                   IF RPRENTRY=RPRENTDA           0878
*                                     THEN  /* DA?           @D32CKTQ*/
         B     @RC00876                                            0878
@RF00876 CLI   RPRENTRY(RDTPTR),X'51'                              0878
         BNE   @RF00878                                            0878
*                                     DO; /* NEXT RDTE(PU) HAS COUNT */
*                                      RFY ISTRCC BASED(ADDR(ISTRDA)+
*                                              RPRELEN);   /*@D32CKTQ*/
*                                      C04COUNT=RCCCTELU;  /*@D32CKTQ*/
         LR    @15,RDTPTR                                          0881
         AH    @15,RPRELEN(,RDTPTR)                                0881
         LH    C04COUNT,RCCCTELU(,@15)                             0881
*                                      RFY ISTRCC BASED(RDTPTR);   0882
*                                      END;                /*@D32CKTQ*/
*                                     ELSE  /* VALID TYPES EXHAUSTED */
*                                      C04RC8=4;           /*@D32CKTQ*/
         B     @RC00878                                            0884
@RF00878 LA    C04RC8,4                                            0884
*                        END;                              /*@D32CKTQ*/
@RC00878 DS    0H                                                  0885
@RC00876 DS    0H                                                  0885
@RC00874 DS    0H                                                  0886
*   C04R14=C04SAVE1;                /* RESTORE RTN ADDR              */
@RC00860 DS    0H                                                  0886
@RC00856 DS    0H                                                  0886
@RC00854 DS    0H                                                  0886
@RC00852 DS    0H                                                  0886
@RC00842 DS    0H                                                  0886
@RC00840 DS    0H                                                  0886
@RC00838 DS    0H                                                  0886
@RC00836 DS    0H                                                  0886
@RC00834 L     @12,RPHWEA(,PTRRPH)                                 0886
         L     C04R14,C04SAVE1+552(,@12)                           0886
*   END CTERMN1;                                                   0887
@EL00007 DS    0H                                                  0887
@EF00007 DS    0H                                                  0887
@ER00007 BR    @14                                                 0887
*/********************************************************************/
*/* ROUTINE NAME: C04NIBIN - NIB INITIALIZATION              @XM08904*/
*/*                                                                  */
*/* FUNCTION:  CALLED THROUGHOUT ISTSQC04 TO INITIALIZE      @XM08904*/
*/*            FIELDS IN NIBS TO BE PROVIDED TO USER.        @XM08904*/
*/*                                                                  */
*/* INPUT:  C04RDTE9 (R9) - POINTER TO RDTE CONTAINING       @XM08904*/
*/*                         INFORMATION USED IN INITIALIZING @XM08904*/
*/*                         NIB                              @XM08904*/
*/*         NIBPTR  (R6)  - POINTER TO NIB                   @XM08904*/
*/*                                                                  */
*/* OUTPUT:  NIB INITIALIZED WITH DEVICE NAME, CHARACTERISTICS,      */
*/*          CONTROL BLOCK ID AND LENGTH, AND NIBLAST BIT    @XM08904*/
*/*          SET ON.                                         @XM08904*/
*/*                                                                  */
*/* ROUTINES CALLED:  NONE                                   @XM08904*/
*/*                                                                  */
*/* MACROS USED:  NONE                                       @XM08904*/
*/*                                                                  */
*/********************************************************************/
*                                                                  0888
*C04NIBIN:                                                 /*@XM08904*/
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                       /*@XM08904*/
C04NIBIN DS    0H                                                  0889
*   RFY (NIBPTR,C04RDTE9,C04R10) RSTD;                     /*@XM08371*/
*   RFY ISTRPRE BASED(C04RDTE9);    /* USE PARM REG FOR BASE @XM08904*/
*   NIBSYM = RPRNAME;                                      /*@XM08904*/
         LR    @15,NIBPTR                                          0891
         MVC   NIBSYM(8,@15),RPRNAME(C04RDTE9)                     0891
*   NIBDEVCH = RPRDEVCH;                                   /*@XM08904*/
         LR    @15,NIBPTR                                          0892
         MVC   NIBDEVCH(8,@15),RPRDEVCH(C04RDTE9)                  0892
*   NIBLEN = C04NIBL;                                      /*@XM08904*/
         L     @15,C04NIBL                                         0893
         LR    @12,NIBPTR                                          0893
         STC   @15,NIBLEN(,@12)                                    0893
*   NIBID = NIBIDD;                                        /*@XM08904*/
         LR    @15,NIBPTR                                          0894
         MVI   NIBID(@15),X'D0'                                    0894
*   NIBLAST = C04ON;                /* CALLER MAY TURN OFF   @XM08904*/
         LR    @15,NIBPTR                                          0895
         OI    NIBLAST(@15),B'10000000'                            0895
*   END C04NIBIN;                                          /*@XM08904*/
*                                                                  0896
@EL00008 DS    0H                                                  0896
@EF00008 DS    0H                                                  0896
@ER00008 BR    @14                                                 0896
*/* TPEPILOG   */                                                  0897
* GEN (PRINT OFF);                                                 0897
*                                                                  0897
         PRINT OFF
* GEN (PRINT ON);                                                  0898
         PRINT ON
*/* END OF TPEPILOG */                                             0899
*/* ATDSPLY   INVOKED. */                                          0899
*/********************************************************************/
*/* THE FOLLOWING ATBUILD INCLUSIONS HAVE BEEN MADE IN THIS          */
*/* COMPILATION:                                                     */
*/*             ISTRPH                                               */
*/*             ISTLOK                                               */
*/*             ISTDEVCH                                             */
*/*             ISTRDT                                               */
*/*             ISTPROCD                                             */
*/*             ISTNIB                                               */
*/*             ISTBIND                                              */
*/*             ISTCSL                                               */
*/*             ISTCSP                                               */
*/*             ISTOCW                                               */
*/*             ISTDVE                                               */
*/*             ISTDTE                                               */
*/*             ISTDIVTH                                             */
*/*             ISTLCCW                                              */
*/*             ISTLCPB                                              */
*/*             ISTZSAVE                                             */
*/*             ISTPFCRR                                             */
*/*             ISTCFCRR                                             */
*/*             ISTZCRR                                              */
*/*             ISTASCRR                                             */
*/*             ISTAPCRR                                             */
*/*             ISTCRA                                               */
*/*             ISTNSCRR                                             */
*/*             ISTPAB                                               */
*/*             ISTDYPAB                                             */
*/*             ISTPST                                               */
*/********************************************************************/
*/* END OF ATDSPLY. */                                             0899
*   END ISTSQC04                                                   0899
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.      *
*/*%INCLUDE SYSLIB  (CVT     )                                        *
*/*%INCLUDE SYSLIB  (IFGRPL  )                                        *
*/*%INCLUDE SYSLIB  (IFGRPLVT)                                        *
*/*%INCLUDE SYSLIB  (ISTRPLFB)                                        *
*/*%INCLUDE SYSLIB  (IHAPSA  )                                        *
*;                                                                 0899
         B     @EL00001                                            0899
@DATA    DS    0H
@DATD    DSECT
         DS    0F
ISTSQC04 CSECT
         DS    0F
@CF00061 DC    F'1'
@CF00053 DC    F'4'
@CF00771 DC    F'5'
@CF00059 DC    F'8'
@CF01010 DC    F'12'
@CF01184 DC    F'64'
@CF02800 DC    F'72'
@DATD    DSECT
         DS    0D
CVTPTR   DS    A
LCPBPTR  DS    A
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
ISTSQC04 CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
C04NIBL  DC    AL4(64)
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
RPHPTR   EQU   @01
C04R0    EQU   @00
C04R1    EQU   @01
C04R13   EQU   @13
C04R14   EQU   @14
C04R15   EQU   @15
NIBPTR   EQU   @00
C04SIZE  EQU   @00
C04COUNT EQU   @04
C04PNTR  EQU   @04
TABPTR   EQU   @05
RDTPTR   EQU   @06
PTRRPH   EQU   @07
C04RC8   EQU   @08
C04RDTE9 EQU   @09
C04R10   EQU   @10
GPR04F   EQU   @04
GPR04P   EQU   @04
GPR06F   EQU   @06
GPR06P   EQU   @06
GPR10F   EQU   @10
GPR10P   EQU   @10
GPR13F   EQU   @13
GPR13P   EQU   @13
GPR15F   EQU   @15
GPR15P   EQU   @15
CMZK0006 EQU   @01
GPR02F   EQU   @02
GPR02P   EQU   @02
GPR11F   EQU   @11
GPR11P   EQU   @11
GPR12F   EQU   @12
GPR12P   EQU   @12
GPR14F   EQU   @14
GPR14P   EQU   @14
GPR01F   EQU   @01
GPR01P   EQU   @01
GPR05F   EQU   @05
GPR05P   EQU   @05
GPR07F   EQU   @07
GPR07P   EQU   @07
GPR08F   EQU   @08
GPR08P   EQU   @08
GPR09F   EQU   @09
GPR09P   EQU   @09
PSA      EQU   0
FLCRNPSW EQU   PSA
FLCROPSW EQU   PSA+8
FLCICCW2 EQU   PSA+16
PSAEEPSW EQU   PSA+132
PSAESPSW EQU   PSA+136
FLCSVILC EQU   PSAESPSW+1
PSAEPPSW EQU   PSA+140
FLCPIILC EQU   PSAEPPSW+1
FLCPICOD EQU   PSAEPPSW+2
PSAPICOD EQU   FLCPICOD+1
FLCTEA   EQU   PSAEPPSW+4
FLCPER   EQU   PSA+152
FLCMCLA  EQU   PSA+168
FLCIOEL  EQU   FLCMCLA+4
FLCIOA   EQU   FLCMCLA+16
FLCFSA   EQU   FLCMCLA+80
PSASUPER EQU   PSA+552
PSASUP1  EQU   PSASUPER
PSASUP2  EQU   PSASUPER+1
PSASUP3  EQU   PSASUPER+2
PSASUP4  EQU   PSASUPER+3
PSACLHT  EQU   PSA+640
PSALKSA  EQU   PSA+696
PSAHLHI  EQU   PSA+760
PSALITA  EQU   PSA+764
PSADSSFL EQU   PSA+836
PSADSSF1 EQU   PSADSSFL
PSADSSF3 EQU   PSADSSFL+2
PSADSSF4 EQU   PSADSSFL+3
PSARSVT  EQU   PSA+896
CZMP0014 EQU   16
CZMP0021 EQU   16
CZMP0028 EQU   16
CVTMAP   EQU   0
CVT0VL00 EQU   CVTMAP+24
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTSHS   EQU   CVTXTNT2+40
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
IFGRPL   EQU   0
RPLCOMN  EQU   IFGRPL
RPLIDWD  EQU   RPLCOMN
RPLLEN   EQU   RPLIDWD+3
RPLECB   EQU   RPLCOMN+8
RPLFDBWD EQU   RPLCOMN+12
RPLFDBK  EQU   RPLFDBWD+1
RPLRTNCD EQU   RPLFDBK
RPLCNDCD EQU   RPLFDBK+1
RPLCMPON EQU   RPLCNDCD
RPLFDB2  EQU   RPLCMPON
RPLERRCD EQU   RPLCNDCD+1
RPLFDB3  EQU   RPLERRCD
RPLKEYLE EQU   RPLCOMN+16
RPLAREA  EQU   RPLCOMN+32
RPLARG   EQU   RPLCOMN+36
RPLOPTCD EQU   RPLCOMN+40
RPLOPT1  EQU   RPLOPTCD
RPLECBSW EQU   RPLOPT1
RPLOPT2  EQU   RPLOPTCD+1
RPLADR   EQU   RPLOPT2
RPLOPT3  EQU   RPLOPTCD+2
RPLOPT4  EQU   RPLOPTCD+3
RPLNXTRP EQU   RPLCOMN+44
RPLBUFL  EQU   RPLCOMN+52
RPLOPTC2 EQU   RPLCOMN+56
RPLOPT5  EQU   RPLOPTC2
RPLWRTYP EQU   RPLOPT5
RPLOPT6  EQU   RPLOPTC2+1
RPLUNTYP EQU   RPLOPT6
RPLOPT7  EQU   RPLOPTC2+2
RPLCNOPT EQU   RPLOPT7
RPLOPT8  EQU   RPLOPTC2+3
RPLRBAR  EQU   RPLCOMN+60
RPLAIXID EQU   RPLRBAR+2
RPLEXTDS EQU   RPLCOMN+68
RPLEXTD1 EQU   RPLEXTDS
RPLVTEXT EQU   IFGRPL+76
RPLFDBK2 EQU   RPLVTEXT+12
RPLSSNSI EQU   RPLFDBK2
RPLDSB   EQU   RPLSSNSI
RPLDSB1  EQU   RPLDSB
RPLSSEI  EQU   RPLDSB1
RPLDSB2  EQU   RPLDSB+1
RPLUSNSI EQU   RPLFDBK2+2
RPLOPTC3 EQU   RPLVTEXT+20
RPLOPT9  EQU   RPLOPTC3
RPLOPT10 EQU   RPLOPTC3+1
RPLOPT11 EQU   RPLOPTC3+2
RPLOPT12 EQU   RPLOPTC3+3
RPLOSENS EQU   RPLVTEXT+24
RPLSSNSO EQU   RPLOSENS
RPLSSEO  EQU   RPLSSNSO
RPLOF16  EQU   0
RPLRH3   EQU   RPLOF16
RPLSRTYP EQU   RPLOF16+1
RPLSTYPE EQU   RPLSRTYP
RPLRTYPE EQU   RPLSRTYP
RPLCHN   EQU   RPLOF16+2
RPLVTFL1 EQU   RPLOF16+3
RPLVTFL2 EQU   RPLOF16+4
RPLPOSTV EQU   RPLVTFL2
RPLRESP  EQU   RPLVTFL2
RPLCNTRL EQU   RPLOF16+5
RPLCNTDF EQU   RPLCNTRL
RPLCNTDC EQU   RPLCNTRL+1
RPLCNTSC EQU   RPLCNTRL+2
RPLOF60  EQU   0
RPLOBSQ  EQU   RPLOF60+4
RPLIBSQ  EQU   RPLOF60+5
ISTRPH   EQU   0
RPHCNTL  EQU   ISTRPH
RPHFLAGS EQU   RPHCNTL+2
RPHAPTYP EQU   RPHFLAGS
RPHFSTLC EQU   RPHFLAGS
RPHFLGB  EQU   RPHCNTL+3
RPHRPHA  EQU   ISTRPH+4
RPHTSKID EQU   ISTRPH+8
RPHRESMA EQU   ISTRPH+16
RPHWPFLG EQU   RPHRESMA
RPHWEA   EQU   ISTRPH+24
RPHCSPA  EQU   RPHWEA
RPHSRPRM EQU   ISTRPH+28
RPHCRR   EQU   ISTRPH+32
RPHPABQA EQU   ISTRPH+36
RPHWORK  EQU   ISTRPH+40
RPHSAVE1 EQU   RPHWORK
RPHSBITS EQU   RPHSAVE1+1
ISTLOK   EQU   0
LOKCHN   EQU   ISTLOK+1
LOKCHNG  EQU   LOKCHN
@NM00057 EQU   LOKCHNG+2
ISTDEVCH EQU   0
DEVSHCH  EQU   ISTDEVCH
DEVCHAR  EQU   DEVSHCH
DEVSUBND EQU   DEVCHAR
DEVTCODE EQU   ISTDEVCH+1
DEVFLAGS EQU   ISTDEVCH+3
DEVFCCTL EQU   DEVFLAGS
DEVCSWL  EQU   DEVFCCTL
DEVCHAR3 EQU   DEVFLAGS
ISTRPRE  EQU   0
RPRNAME  EQU   ISTRPRE
RPRCOMID EQU   ISTRPRE+8
RPRELEN  EQU   ISTRPRE+16
RPRPELEN EQU   ISTRPRE+18
RPRENTRY EQU   ISTRPRE+20
RPRFLAGA EQU   ISTRPRE+21
RPRFLAGB EQU   ISTRPRE+22
RPRCAUSE EQU   ISTRPRE+23
RPRDEVCH EQU   ISTRPRE+44
RPRFLAGD EQU   ISTRPRE+61
RPRFLAGC EQU   ISTRPRE+62
ISTRCPRE EQU   0
RCPPMODE EQU   ISTRCPRE+91
RCPLGNIN EQU   ISTRCPRE+92
ISTRDT   EQU   0
RDTPLEN  EQU   ISTRDT+72
RDTPRIOR EQU   RDTPLEN
RDTFLAGB EQU   ISTRDT+91
RDTVYRPH EQU   ISTRDT+108
RDTSTCNT EQU   ISTRDT+112
ISTRAP   EQU   0
RAPFLG   EQU   ISTRAP+108
RAPFLGB  EQU   ISTRAP+109
RAPFLGC  EQU   ISTRAP+110
ISTRLC   EQU   0
RLCADR   EQU   ISTRLC+72
RLCFLAG  EQU   RLCADR
ISTRRN   EQU   0
RRNADR   EQU   ISTRRN+136
RRNFLAG  EQU   RRNADR
RRNUCBAD EQU   RRNADR+1
RRNCTETR EQU   ISTRRN+164
RRNCTECM EQU   ISTRRN+168
RRNRDF   EQU   ISTRRN+172
RRNRDFA  EQU   RRNRDF
RRNRDFB  EQU   RRNRDF+1
RRNCMF   EQU   ISTRRN+176
RRNCMFA  EQU   RRNCMF
RRNCMFB  EQU   RRNCMF+1
RRNCMFC  EQU   RRNCMF+2
RRNCMFD  EQU   RRNCMF+3
RRNNMDPD EQU   ISTRRN+192
RRNHPRE  EQU   ISTRRN+216
ISTRGP   EQU   0
RGPFLG   EQU   ISTRGP+72
RGPCTETR EQU   ISTRGP+78
ISTRLN   EQU   0
RLNADR   EQU   ISTRLN+72
RLNFLAG  EQU   RLNADR
RLNUCBAD EQU   RLNADR+1
RLNCTETR EQU   ISTRLN+78
RLNCTECM EQU   ISTRLN+82
RLNSTAT1 EQU   ISTRLN+86
RLNSTAT2 EQU   ISTRLN+87
RLNRDF   EQU   ISTRLN+88
RLNRDFA  EQU   RLNRDF
RLNRACNT EQU   RLNRDFA
RLNPORT  EQU   RLNRDFA
RLNIDV   EQU   RLNRDFA
RLNRDFB  EQU   RLNRDF+1
RLNTTV   EQU   RLNRDFB
RLNRATRN EQU   RLNRDFB
RLNCRFLG EQU   ISTRLN+102
RLNLSCMD EQU   RLNCRFLG
ISTRPT   EQU   0
RPTLNCID EQU   ISTRPT+116
RPTDITT  EQU   ISTRPT+128
RPTDIVT  EQU   RPTDITT
RPTUTERM EQU   ISTRPT+136
RPTFLAG1 EQU   ISTRPT+140
ISTRCL   EQU   0
RCLADR   EQU   ISTRCL+72
RCLFLAG  EQU   RCLADR
RCLCTETR EQU   ISTRCL+76
RCLCTECM EQU   ISTRCL+78
ISTRTR   EQU   0
RTRADR   EQU   ISTRTR+124
RTRFLAG  EQU   RTRADR
RTRCTECM EQU   ISTRTR+128
RTRRDFA  EQU   ISTRTR+136
RTRRAALL EQU   RTRRDFA
RTRRDFB  EQU   ISTRTR+137
RTRRDFC  EQU   ISTRTR+138
RTRRDFD  EQU   ISTRTR+139
RTRRDFE  EQU   ISTRTR+140
RTRRDFF  EQU   ISTRTR+141
RTRCRFLG EQU   ISTRTR+143
RTRLSCMD EQU   RTRCRFLG
RTRBSCID EQU   ISTRTR+188
ISTRIN   EQU   0
RINDFD   EQU   ISTRIN+124
RINREMPO EQU   RINDFD
RINNODEF EQU   RINDFD
RINLDISC EQU   RINDFD
RINNODID EQU   ISTRIN+125
RINRLDAF EQU   ISTRIN+126
RINREMOT EQU   ISTRIN+128
RINVPAB  EQU   ISTRIN+132
RINRPHCN EQU   ISTRIN+136
RINNCSPL EQU   ISTRIN+140
RINCNCNT EQU   ISTRIN+144
ISTRDS   EQU   0
RDSCTTRM EQU   ISTRDS+72
RDSADDOT EQU   ISTRDS+76
ISTDOT   EQU   0
DOTADTRM EQU   ISTDOT
ISTRCC   EQU   0
RCCFLAG  EQU   ISTRCC+73
RCCFLAGB EQU   ISTRCC+74
RCCCTELU EQU   ISTRCC+76
RCCSTAID EQU   ISTRCC+78
RCCID48  EQU   RCCSTAID+2
RCCCRFLG EQU   ISTRCC+108
ISTRLU   EQU   0
RLUFLAG  EQU   ISTRLU+125
RLUCRFLG EQU   ISTRLU+126
RLUPACE  EQU   ISTRLU+132
RLUNCPPC EQU   ISTRLU+134
RLUUSSTB EQU   ISTRLU+140
RLUMODET EQU   ISTRLU+152
ISTRPX   EQU   0
ISTRLX   EQU   0
RLXFLAGA EQU   ISTRLX+76
ISTRSW   EQU   0
RSWCTELU EQU   ISTRSW+148
ISTRDA   EQU   0
RDAADR   EQU   ISTRDA+72
RDAFLAG  EQU   RDAADR
RDAUCBAD EQU   RDAADR+1
ISTRLS   EQU   0
RLSCTELU EQU   ISTRLS+136
ISTDNT   EQU   0
ISTGNT   EQU   0
ISTPAT   EQU   0
PATFLAGA EQU   ISTPAT+7
ISTPROCD EQU   0
PROPROC  EQU   ISTPROCD
PROPROC1 EQU   PROPROC
PROPROC2 EQU   PROPROC+1
PROPROC3 EQU   PROPROC+2
PROPROC4 EQU   PROPROC+3
PROPROCS EQU   0
PROSETMS EQU   PROPROCS+1
PROSETM2 EQU   PROSETMS
PROSETM3 EQU   PROSETMS+1
PROSETM4 EQU   PROSETMS+2
ISTNIB   EQU   0
NIBID    EQU   ISTNIB
NIBLEN   EQU   ISTNIB+3
NIBSYM   EQU   ISTNIB+12
NIBDEVCH EQU   ISTNIB+28
NIBFLGS  EQU   ISTNIB+40
NIBFLG1  EQU   NIBFLGS
NIBLAST  EQU   NIBFLG1
ISTBIND  EQU   0
BINFMTY  EQU   ISTBIND
BINPRIP  EQU   ISTBIND+3
BINSECP  EQU   ISTBIND+4
BINCMNP  EQU   ISTBIND+5
BINCMNP2 EQU   ISTBIND+6
BINTSU   EQU   ISTBIND+7
BINRPACE EQU   BINTSU+1
BINRUSZ  EQU   BINTSU+2
BINSRUSZ EQU   BINRUSZ
BINPRUSZ EQU   BINRUSZ+1
BINPRSVC EQU   ISTBIND+13
BINLUP   EQU   BINPRSVC
BINPSCHR EQU   BINPRSVC+1
ISTCSL   EQU   0
CSLRDEF  EQU   ISTCSL
CSLRDTE  EQU   CSLRDEF
CSLNDEF  EQU   ISTCSL+4
CSLNIB   EQU   CSLNDEF
CSLDDEF  EQU   ISTCSL+8
CSLDATA  EQU   CSLDDEF
ISTCSP   EQU   0
CSPOPT   EQU   ISTCSP+2
CSPOPT1  EQU   CSPOPT
CSPOPT2  EQU   CSPOPT+1
CSPRSC2B EQU   ISTCSP+32
ISTOCW   EQU   0
OCWRPL   EQU   ISTOCW+12
OCWLRDTE EQU   ISTOCW+40
OCWDRDTE EQU   OCWLRDTE
OCWODRC  EQU   ISTOCW+92
OCWSVCOD EQU   ISTOCW+94
OCWSWTA  EQU   ISTOCW+204
OCWSWTB  EQU   ISTOCW+205
OCWSWTC  EQU   ISTOCW+206
OCWSWTD  EQU   ISTOCW+207
OCWSAVE5 EQU   ISTOCW+552
OCWSWTRD EQU   ISTOCW+730
OCWSWTE  EQU   ISTOCW+731
OCWLOCKS EQU   ISTOCW+740
OCWCID   EQU   ISTOCW+744
OCWIOCNT EQU   ISTOCW+760
OCWSHPL  EQU   ISTOCW+784
OCWBIND  EQU   ISTOCW+796
OCWFLG1  EQU   ISTOCW+847
ISTDVE   EQU   0
DVERDTEA EQU   ISTDVE
DVEBSCID EQU   ISTDVE+4
ISTDTE   EQU   0
DTELCTI  EQU   ISTDTE
DTERDTEA EQU   ISTDTE+1
ISTDIVTH EQU   0
DIVNUME  EQU   ISTDIVTH
DIVIDLEN EQU   ISTDIVTH+4
C04SAVE  EQU   0
C04CLR13 EQU   C04SAVE+4
C04OUR13 EQU   C04SAVE+8
C04AREA  EQU   0
C04SNAME EQU   C04AREA
C04N1    EQU   C04SNAME
C04N28   EQU   C04SNAME+1
C04SZE   EQU   C04AREA+8
C04SAVE1 EQU   C04AREA+12
C04SAVE2 EQU   C04AREA+16
C04SAVE3 EQU   C04AREA+20
ISTLCCW  EQU   0
LCCWOP   EQU   ISTLCCW
LCCWRWOP EQU   LCCWOP
LCCWCTL  EQU   LCCWRWOP
LCCWFLAG EQU   ISTLCCW+1
LCCWLSI  EQU   LCCWFLAG
ISTLCPB  EQU   0
LCPREQTG EQU   ISTLCPB+2
LCPFLAGS EQU   LCPREQTG
LCPZF001 EQU   LCPFLAGS
LCPZRT02 EQU   LCPZF001
LCPZF002 EQU   LCPFLAGS
LCPZRT03 EQU   LCPZF002
LCPZF003 EQU   LCPFLAGS
LCPZRT04 EQU   LCPZF003
LCPZF004 EQU   LCPFLAGS
LCPZRT05 EQU   LCPZF004
LCPZRT06 EQU   LCPFLAGS
LCPZRT07 EQU   LCPFLAGS
LCPMNRCD EQU   LCPREQTG+1
LCPZRT08 EQU   LCPMNRCD
LCPZRT09 EQU   LCPMNRCD
LCPCHAIN EQU   ISTLCPB+4
LCPCHAI1 EQU   LCPCHAIN
LCPRUCNT EQU   ISTLCPB+8
LCPFLAG2 EQU   ISTLCPB+9
LCPTLBPI EQU   LCPFLAG2
LCPFID0  EQU   LCPFLAG2
LCPSEQ   EQU   ISTLCPB+10
LCPCID   EQU   ISTLCPB+16
LCPFDBA  EQU   ISTLCPB+24
LCPFLG1  EQU   ISTLCPB+37
LCPFLCCW EQU   ISTLCPB+40
LCPLCCW  EQU   ISTLCPB+48
LCPPABA  EQU   LCPLCCW+4
LCPRPHA  EQU   LCPPABA
ISTZSAVE EQU   0
ZSAZSVBC EQU   ISTZSAVE
ZSAZSVMS EQU   ZSAZSVBC
ISTPFCRR EQU   0
PFCCRR   EQU   ISTPFCRR
PFCCRRID EQU   PFCCRR
PFCCRRLN EQU   PFCCRR+2
PFCHDR   EQU   ISTPFCRR+4
PFCCRRO  EQU   PFCHDR
PFCFRRO  EQU   PFCHDR+4
ISTCFCRR EQU   0
CFCAUDIT EQU   ISTCFCRR
CFCNTRD  EQU   CFCAUDIT
CFCCRT   EQU   CFCAUDIT+1
ISTZCRR  EQU   0
ZCRCRR   EQU   ISTZCRR
ZCRFLGS1 EQU   ISTZCRR+12
ZCRFLGS2 EQU   ISTZCRR+13
ZCRSWFLD EQU   ISTZCRR+14
ZCRENDSH EQU   ZCRSWFLD
ZCRNDLCP EQU   ZCRSWFLD
ZCRRESET EQU   ZCRSWFLD
ZCRFLGS3 EQU   ISTZCRR+15
ZCRGENSW EQU   ISTZCRR+16
ZCRPFLGS EQU   ISTZCRR+17
ZCRIBPR  EQU   ISTZCRR+18
ZCRSCPSW EQU   ISTZCRR+19
ZCRPARMS EQU   ISTZCRR+24
ZCRFBPTR EQU   ZCRPARMS
ZCRDFRDA EQU   ZCRPARMS+10
ZCRPCOD1 EQU   ZCRPARMS+12
ZCRPLSBF EQU   ZCRPCOD1
ZCRPCOD2 EQU   ZCRPARMS+13
ZCRSVRTN EQU   ISTZCRR+56
ZCRWKARA EQU   ISTZCRR+156
ZCRCIDSV EQU   ISTZCRR+192
ZCRAUDIT EQU   ISTZCRR+440
ZCRENTER EQU   ZCRAUDIT+5
ZCRLCPB  EQU   ISTZCRR+480
ZCRRHRU  EQU   ZCRLCPB
ISTASCRR EQU   0
ASCFLAGS EQU   ISTASCRR+16
ASCFLG1  EQU   ASCFLAGS
ASCFLG2  EQU   ASCFLAGS+2
ASCFLG3  EQU   ASCFLAGS+4
ASCUSRGS EQU   ISTASCRR+28
ISTAPCRR EQU   0
APCATFLG EQU   ISTAPCRR+16
APCRFLG  EQU   ISTAPCRR+18
APCSAVE  EQU   ISTAPCRR+44
APCCOMF  EQU   ISTAPCRR+116
APCCOMF1 EQU   APCCOMF
APC31FLG EQU   ISTAPCRR+132
APC52FLG EQU   ISTAPCRR+133
APC53FLG EQU   ISTAPCRR+134
APC54FLG EQU   ISTAPCRR+135
APC57FLG EQU   ISTAPCRR+136
ISTCRA   EQU   0
CRABASIC EQU   ISTCRA
CRAHDR   EQU   CRABASIC
CRACRR   EQU   CRAHDR
CRALKACT EQU   CRABASIC+8
CRASVC   EQU   ISTCRA+848
CRABUFA  EQU   CRASVC+68
ISTNSCRR EQU   0
NSCAUDIT EQU   ISTNSCRR+16
NSCNTRD  EQU   NSCAUDIT
NSQC04   EQU   NSCNTRD
NSCCRT   EQU   NSCAUDIT+2
CSQC04   EQU   NSCCRT
SAV0014  EQU   0
SAV10014 EQU   SAV0014
SAV20014 EQU   SAV0014+4
SAV40014 EQU   SAV0014+8
SAV60014 EQU   SAV0014+12
SAVE0014 EQU   SAV0014+16
ISTPAB   EQU   0
PABWQCHN EQU   ISTPAB
PABWEQA  EQU   PABWQCHN
PABCHAIN EQU   PABWQCHN+4
PABRPHFG EQU   ISTPAB+12
PABFLAGS EQU   PABRPHFG
PABERLCK EQU   PABFLAGS
PABERRLK EQU   PABERLCK
ISTDYPAB EQU   0
ISTPST   EQU   0
PSTRQFGA EQU   ISTPST+8
PSTRQUE  EQU   PSTRQFGA
PSTFLGA  EQU   PSTRQFGA+4
PSTABINP EQU   PSTFLGA
PSTTCBA  EQU   ISTPST+16
PSTDMPS  EQU   ISTPST+132
SAV0021  EQU   0
SAV10021 EQU   SAV0021
SAV20021 EQU   SAV0021+4
SAV40021 EQU   SAV0021+8
SAV60021 EQU   SAV0021+12
SAVE0021 EQU   SAV0021+16
SAV0028  EQU   0
SAV10028 EQU   SAV0028
SAV20028 EQU   SAV0028+4
SAV40028 EQU   SAV0028+8
SAV60028 EQU   SAV0028+12
SAVE0028 EQU   SAV0028+16
ISTRPL   EQU   0
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
FLC      EQU   PSA
PSARSVTE EQU   PSARSVT
BINLUP1  EQU   BINPSCHR
BINLUS   EQU   BINPSCHR
BINFMF1  EQU   BINLUS
BINRSV09 EQU   BINFMF1
BINDSPF1 EQU   BINLUS+2
BINMEDIA EQU   BINLUS+4
BINLUP2  EQU   BINPSCHR
BINLUP3  EQU   BINPSCHR
LCPZTIE  EQU   LCPCID
LCPZSNAM EQU   LCPZTIE+8
RTRDNCBA EQU   ISTRTR+40
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
LCPZTRV4 EQU   LCPZSNAM+4
LCPZTRV1 EQU   LCPZSNAM
LCPZSNA  EQU   LCPZTIE+4
LCPZFMCA EQU   LCPZTIE
BINRSV26 EQU   BINLUP3
BINRSV15 EQU   BINLUP2+10
BINPRESZ EQU   BINLUP2+9
BINRSV14 EQU   BINLUP2
BINRSV13 EQU   BINMEDIA
BINDISK  EQU   BINMEDIA
BINXCHNG EQU   BINMEDIA
BINCARD  EQU   BINMEDIA
BINDOCMT EQU   BINMEDIA
BINRSV17 EQU   BINDSPF1+1
BINTRNDS EQU   BINDSPF1
BINRSV12 EQU   BINDSPF1
BINVSDS  EQU   BINDSPF1
BINVTDS  EQU   BINDSPF1
BINHFDS  EQU   BINDSPF1
BININTR  EQU   BINDSPF1
BINRSV11 EQU   BINRSV09+1
BINXFPD  EQU   BINRSV09+1
BINCSDS  EQU   BINRSV09+1
BINQDSI  EQU   BINRSV09+1
BINRSV16 EQU   BINRSV09+1
BINARRR  EQU   BINRSV09
BINSIDS  EQU   BINRSV09
BINSAI   EQU   BINRSV09
BINSDSI  EQU   BINRSV09
BINKDDSI EQU   BINRSV09
BINPDIR  EQU   BINFMF1
BINCMPCT EQU   BINFMF1
BINDESTS EQU   BINFMF1
BINSLUS1 EQU   BINLUP1+6
BINPLUS1 EQU   BINLUP1+1
BINDSP1  EQU   BINLUP1
BINFMHS1 EQU   BINLUP1
PSARSAV  EQU   PSARSVTE+60
PSARSTK  EQU   PSARSVTE+56
PSAESAV3 EQU   PSARSVTE+52
PSAESTK3 EQU   PSARSVTE+48
PSAESAV2 EQU   PSARSVTE+44
PSAESTK2 EQU   PSARSVTE+40
PSAESAV1 EQU   PSARSVTE+36
PSAESTK1 EQU   PSARSVTE+32
PSAPSAV  EQU   PSARSVTE+28
PSAPSTK  EQU   PSARSVTE+24
PSAMSAV  EQU   PSARSVTE+20
PSAMSTK  EQU   PSARSVTE+16
PSASSAV  EQU   PSARSVTE+12
PSASSTK  EQU   PSARSVTE+8
PSANSTK  EQU   PSARSVTE+4
PSACSTK  EQU   PSARSVTE
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTRV620 EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTIRM   EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRV607 EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
PSTDRDYQ EQU   PSTDMPS+1
@NM00087 EQU   PSTDMPS
PSTDGATE EQU   PSTDMPS
PSTDEBP  EQU   ISTPST+128
PSTSAVE  EQU   ISTPST+96
PSTSMDYP EQU   ISTPST+64
PSTCRRS  EQU   ISTPST+60
PSTCRR1  EQU   ISTPST+56
PSTIQE22 EQU   ISTPST+52
PSTIQE21 EQU   ISTPST+48
PSTIQE12 EQU   ISTPST+44
PSTIQE11 EQU   ISTPST+40
PSTUEQ   EQU   ISTPST+36
PSTNSSQ  EQU   ISTPST+32
PSTPSSQ  EQU   ISTPST+28
PSTACBCT EQU   ISTPST+24
PSTMPSTP EQU   ISTPST+20
PSTRSV08 EQU   PSTFLGA+1
PSTDMPC  EQU   PSTFLGA+1
PSTABEND EQU   PSTABINP
PSTAUTH  EQU   PSTFLGA
PSTSMCU  EQU   PSTFLGA
PSTSMQR  EQU   PSTFLGA
PSTIRBU2 EQU   PSTFLGA
PSTIRBU1 EQU   PSTFLGA
PSTUERN  EQU   PSTFLGA
PSTSSRN  EQU   PSTFLGA
PSTRQUEA EQU   PSTRQUE+1
PSTRSV07 EQU   PSTRQUE
PSTRSV06 EQU   PSTRQUE
PSTRSV05 EQU   PSTRQUE
PSTRSV04 EQU   PSTRQUE
PSTRSV03 EQU   PSTRQUE
PSTRSV02 EQU   PSTRQUE
PSTRSV01 EQU   PSTRQUE
PSTRQFLG EQU   PSTRQUE
PSTCHAIN EQU   ISTPST+4
@NM00086 EQU   ISTPST+2
PSTLNGTH EQU   ISTPST+1
PSTTYPE  EQU   ISTPST
DYPPAB   EQU   ISTDYPAB+16
DYPRSV01 EQU   ISTDYPAB+12
DYPTSKID EQU   ISTDYPAB+8
DYPCHAIN EQU   ISTDYPAB+4
DYPFLGS  EQU   ISTDYPAB+2
DYPLNGTH EQU   ISTDYPAB+1
DYPTYPE  EQU   ISTDYPAB
PABRPHA  EQU   PABRPHFG+1
PABNODQ  EQU   PABFLAGS
PABINHBT EQU   PABFLAGS
PABERLOK EQU   PABERRLK
PABSSN   EQU   PABFLAGS
PABDYNAM EQU   PABFLAGS
PABNORPR EQU   PABFLAGS
PABPRIOR EQU   PABFLAGS
PABAPYP  EQU   PABFLAGS
PABDVTA  EQU   ISTPAB+9
PABOFFST EQU   ISTPAB+8
PABCHNGP EQU   PABCHAIN+1
PABRSV02 EQU   PABCHAIN
PABDELAY EQU   PABCHAIN
PABRUNNG EQU   PABCHAIN
PABRESET EQU   PABCHAIN
PABUNCON EQU   PABCHAIN
PABCDP   EQU   PABCHAIN
PABRESCH EQU   PABCHAIN
PABCHNG  EQU   PABCHAIN
PABWEQP  EQU   PABWEQA+1
PABRSV01 EQU   PABWEQA
PABWEQG  EQU   PABWEQA
CNSRSVRD EQU   NSCCRT+1
CSQC0B   EQU   NSCCRT+1
CSQC0A   EQU   NSCCRT+1
CSQC08   EQU   NSCCRT+1
CSQC09   EQU   NSCCRT+1
CSQC07   EQU   NSCCRT+1
CSQC06   EQU   NSCCRT
CSQC05   EQU   NSCCRT
CSQC03   EQU   NSCCRT
CSQC02   EQU   NSCCRT
CSQC01   EQU   NSCCRT
CSQC00   EQU   NSCCRT
CSTC00   EQU   NSCCRT
NNSRSVRD EQU   NSCNTRD+1
NSQC0B   EQU   NSCNTRD+1
NSQC0A   EQU   NSCNTRD+1
NSQC08   EQU   NSCNTRD+1
NSQC09   EQU   NSCNTRD+1
NSQC07   EQU   NSCNTRD+1
NSQC06   EQU   NSCNTRD
NSQC05   EQU   NSCNTRD
NSQC03   EQU   NSCNTRD
NSQC02   EQU   NSCNTRD
NSQC01   EQU   NSCNTRD
NSQC00   EQU   NSCNTRD
NSTC00   EQU   NSCNTRD
NSCPRFX  EQU   ISTNSCRR
CRACHAIN EQU   ISTCRA+928
CRARSV02 EQU   ISTCRA+924
CRARSV01 EQU   ISTCRA+920
CRABFTBA EQU   CRABUFA
CRAMASK  EQU   CRASVC+64
CRAHSIZ  EQU   CRASVC+60
CRAASCRR EQU   CRASVC
CRAPROCR EQU   ISTCRA+312
CRAPSS   EQU   ISTCRA+160
CRARPH   EQU   ISTCRA+52
CRALAPTR EQU   CRABASIC+48
CRAL9PTR EQU   CRABASIC+44
CRAL8PTR EQU   CRABASIC+40
CRAL7PTR EQU   CRABASIC+36
CRAL6PTR EQU   CRABASIC+32
CRAL5PTR EQU   CRABASIC+28
CRAL4PTR EQU   CRABASIC+24
CRAL3PTR EQU   CRABASIC+20
CRAL2PTR EQU   CRABASIC+16
CRAL1PTR EQU   CRABASIC+12
CRALEV01 EQU   CRALKACT+3
CRALEV02 EQU   CRALKACT+3
CRALEV03 EQU   CRALKACT+3
CRALEV04 EQU   CRALKACT+3
CRALEV05 EQU   CRALKACT+3
CRALEV06 EQU   CRALKACT+3
CRALEV07 EQU   CRALKACT+3
CRALEV08 EQU   CRALKACT+3
CRALEV09 EQU   CRALKACT+2
CRALEV10 EQU   CRALKACT+2
CRALEV11 EQU   CRALKACT+2
CRALEV12 EQU   CRALKACT+2
CRALEV13 EQU   CRALKACT+2
CRALEV14 EQU   CRALKACT+2
CRALEV15 EQU   CRALKACT+2
CRALEV16 EQU   CRALKACT+2
CRALEV17 EQU   CRALKACT+1
CRALEV18 EQU   CRALKACT+1
CRALEV19 EQU   CRALKACT+1
CRALEV20 EQU   CRALKACT+1
CRALEV21 EQU   CRALKACT+1
CRALEV22 EQU   CRALKACT+1
CRALEV23 EQU   CRALKACT+1
CRALEV24 EQU   CRALKACT+1
CRALEV25 EQU   CRALKACT
CRALEV26 EQU   CRALKACT
CRALEV27 EQU   CRALKACT
CRALEV28 EQU   CRALKACT
CRALEV29 EQU   CRALKACT
CRALEV30 EQU   CRALKACT
CRALEV31 EQU   CRALKACT
CRALEV32 EQU   CRALKACT
CRAFRR   EQU   CRAHDR+4
@NM00085 EQU   ISTAPCRR+137
@NM00084 EQU   APC57FLG
APCNREL  EQU   APC57FLG
APCRECRA EQU   APC57FLG
@NM00083 EQU   APC54FLG
APCRLST  EQU   APC54FLG
APCPR153 EQU   APC53FLG
@NM00082 EQU   APC52FLG
APCWKF   EQU   APC52FLG
APCNWF   EQU   APC52FLG
APCRDQ   EQU   APC52FLG
APCQENQ  EQU   APC52FLG
APCSMSR  EQU   APC52FLG
APCCKRQ  EQU   APC52FLG
@NM00081 EQU   APC31FLG
APCSORT  EQU   APC31FLG
APCRESCH EQU   APC31FLG
APCTPXIT EQU   APC31FLG
APCSWTWD EQU   ISTAPCRR+128
APCSAV2  EQU   ISTAPCRR+124
APCSAV1  EQU   ISTAPCRR+120
APCRETCD EQU   APCCOMF+2
@NM00080 EQU   APCCOMF1+1
APCZLBER EQU   APCCOMF1
APCEXIT  EQU   APCCOMF1
APCRELR  EQU   APCCOMF1
APCIRB2  EQU   APCCOMF1
APCIRB1  EQU   APCCOMF1
APCSMCR  EQU   APCCOMF1
APCUETSK EQU   APCCOMF1
APCSSTSK EQU   APCCOMF1
APCESTAL EQU   APCSAVE
APCFRRPM EQU   ISTAPCRR+40
APCQWFO  EQU   ISTAPCRR+36
APCPABSV EQU   ISTAPCRR+32
APCRTRN  EQU   ISTAPCRR+28
APCTCBA  EQU   ISTAPCRR+24
APCPSTA  EQU   ISTAPCRR+20
@NM00079 EQU   APCRFLG+1
APC31R   EQU   APCRFLG
APC58R   EQU   APCRFLG
APC57R   EQU   APCRFLG
APC56R   EQU   APCRFLG
APC54R   EQU   APCRFLG
APC53R   EQU   APCRFLG
APC52R   EQU   APCRFLG
APC51R   EQU   APCRFLG
@NM00078 EQU   APCATFLG+1
APC31E   EQU   APCATFLG
APC58E   EQU   APCATFLG
APC57E   EQU   APCATFLG
APC56E   EQU   APCATFLG
APC54E   EQU   APCATFLG
APC53E   EQU   APCATFLG
APC52E   EQU   APCATFLG
APC51E   EQU   APCATFLG
APCHDRSV EQU   ISTAPCRR
ASCPSREG EQU   ISTASCRR+44
ASCUSR01 EQU   ASCUSRGS+12
ASCUSR00 EQU   ASCUSRGS+8
ASCUSR15 EQU   ASCUSRGS+4
ASCUSR14 EQU   ASCUSRGS
ASCETRYA EQU   ISTASCRR+24
ASCKEY   EQU   ISTASCRR+23
ASCAUDIT EQU   ASCFLG3
ASCFBDUD EQU   ASCFLG3
ASCLLKF  EQU   ASCFLG3
ASCKEYF  EQU   ASCFLG3
ASCFBDAL EQU   ASCFLG3
ASCFSRGT EQU   ASCFLG3
ASCICR   EQU   ASCFLG2
ASCFSRIC EQU   ASCFLG2
ASCFBDIC EQU   ASCFLG2
ASCFBAIC EQU   ASCFLG2
ASCPASTR EQU   ASCFLG1
ASCFSR   EQU   ASCFLG1
ASCFBD   EQU   ASCFLG1
ASCFBA   EQU   ASCFLG1
ASCPFCRR EQU   ISTASCRR
ZCRRU    EQU   ZCRRHRU+3
ZCRRH    EQU   ZCRRHRU
ZCRWORDA EQU   ISTZCRR+477
ZCRCMNRC EQU   ISTZCRR+476
ZCRRSV97 EQU   ZCRENTER+18
ZCREIC2B EQU   ZCRENTER+18
ZCREAC2B EQU   ZCRENTER+18
ZCRELCAB EQU   ZCRENTER+18
ZCREDCMF EQU   ZCRENTER+18
ZCREBCIF EQU   ZCRENTER+18
ZCREICSG EQU   ZCRENTER+18
ZCREDCK0 EQU   ZCRENTER+18
ZCRECFY0 EQU   ZCRENTER+17
ZCREKCCB EQU   ZCRENTER+17
ZCREDCNB EQU   ZCRENTER+17
ZCREICOE EQU   ZCRENTER+17
ZCREBCNB EQU   ZCRENTER+17
ZCREBC0L EQU   ZCRENTER+17
ZCREBCAL EQU   ZCRENTER+17
ZCREDCQR EQU   ZCRENTER+17
ZCREDCPR EQU   ZCRENTER+16
ZCREBCSB EQU   ZCRENTER+16
ZCREAC1R EQU   ZCRENTER+16
ZCRECCCI EQU   ZCRENTER+16
ZCRECCAI EQU   ZCRENTER+16
ZCRECCBI EQU   ZCRENTER+16
ZCREBCAR EQU   ZCRENTER+16
ZCREBCDR EQU   ZCRENTER+16
ZCREBCBR EQU   ZCRENTER+15
ZCREDCXR EQU   ZCRENTER+15
ZCREDCWB EQU   ZCRENTER+15
ZCREDCWR EQU   ZCRENTER+15
ZCREKCCN EQU   ZCRENTER+15
ZCREKCBN EQU   ZCRENTER+15
ZCREKCBB EQU   ZCRENTER+15
ZCREJC0B EQU   ZCRENTER+15
ZCREJCDB EQU   ZCRENTER+14
ZCREJCCB EQU   ZCRENTER+14
ZCREJCBB EQU   ZCRENTER+14
ZCREJCAB EQU   ZCRENTER+14
ZCREIC1B EQU   ZCRENTER+14
ZCREIC0B EQU   ZCRENTER+14
ZCREICX0 EQU   ZCRENTER+14
ZCREICWB EQU   ZCRENTER+14
ZCREICVB EQU   ZCRENTER+13
ZCREICUB EQU   ZCRENTER+13
ZCREICTB EQU   ZCRENTER+13
ZCREICSC EQU   ZCRENTER+13
ZCREICSB EQU   ZCRENTER+13
ZCREICRB EQU   ZCRENTER+13
ZCREICQB EQU   ZCRENTER+13
ZCREICQA EQU   ZCRENTER+13
ZCREICOB EQU   ZCRENTER+12
ZCREICOA EQU   ZCRENTER+12
ZCREICNB EQU   ZCRENTER+12
ZCREICNA EQU   ZCRENTER+12
ZCREICMB EQU   ZCRENTER+12
ZCREICLB EQU   ZCRENTER+12
ZCREICKG EQU   ZCRENTER+12
ZCREICKE EQU   ZCRENTER+12
ZCREICKB EQU   ZCRENTER+11
ZCREICJB EQU   ZCRENTER+11
ZCREICID EQU   ZCRENTER+11
ZCREICIB EQU   ZCRENTER+11
ZCREICHB EQU   ZCRENTER+11
ZCREICGB EQU   ZCRENTER+11
ZCREICEB EQU   ZCRENTER+11
ZCREICDB EQU   ZCRENTER+11
ZCREICCI EQU   ZCRENTER+10
ZCREICCB EQU   ZCRENTER+10
ZCREICBI EQU   ZCRENTER+10
ZCREICBB EQU   ZCRENTER+10
ZCREICAB EQU   ZCRENTER+10
ZCREICAA EQU   ZCRENTER+10
ZCREHCAN EQU   ZCRENTER+10
ZCREGC0B EQU   ZCRENTER+10
ZCREGC0A EQU   ZCRENTER+9
ZCREGCLA EQU   ZCRENTER+9
ZCREGCEB EQU   ZCRENTER+9
ZCREGCDB EQU   ZCRENTER+9
@NM00077 EQU   ZCRENTER+9
ZCREGCBB EQU   ZCRENTER+9
ZCREGCAB EQU   ZCRENTER+9
ZCREFCEB EQU   ZCRENTER+9
ZCREFCEA EQU   ZCRENTER+8
ZCREECTA EQU   ZCRENTER+8
ZCREECEA EQU   ZCRENTER+8
ZCREECDA EQU   ZCRENTER+8
ZCREECCB EQU   ZCRENTER+8
ZCREECCA EQU   ZCRENTER+8
ZCREECBB EQU   ZCRENTER+8
ZCREECBA EQU   ZCRENTER+8
ZCREDCMB EQU   ZCRENTER+7
ZCREDCL0 EQU   ZCRENTER+7
ZCREDCKB EQU   ZCRENTER+7
ZCREDCKA EQU   ZCRENTER+7
ZCREDCJ0 EQU   ZCRENTER+7
ZCREDCI0 EQU   ZCRENTER+7
ZCREDCH0 EQU   ZCRENTER+7
ZCREDCF0 EQU   ZCRENTER+7
ZCREDCE0 EQU   ZCRENTER+6
ZCREDCD0 EQU   ZCRENTER+6
ZCREDCC0 EQU   ZCRENTER+6
ZCREDCB0 EQU   ZCRENTER+6
ZCREDCA0 EQU   ZCRENTER+6
ZCRECC2B EQU   ZCRENTER+6
ZCRECC1B EQU   ZCRENTER+6
ZCRECC1A EQU   ZCRENTER+6
ZCRECC0B EQU   ZCRENTER+5
ZCRECC0A EQU   ZCRENTER+5
ZCREBC0B EQU   ZCRENTER+5
ZCREBC0A EQU   ZCRENTER+5
ZCREBCZ0 EQU   ZCRENTER+5
ZCREBCY0 EQU   ZCRENTER+5
ZCREBCX0 EQU   ZCRENTER+5
ZCREBCXA EQU   ZCRENTER+5
ZCREBCSC EQU   ZCRENTER+4
ZCREBCRB EQU   ZCRENTER+4
ZCREBCRA EQU   ZCRENTER+4
ZCREBCQB EQU   ZCRENTER+4
ZCREBCPB EQU   ZCRENTER+4
ZCREBCOB EQU   ZCRENTER+4
ZCREBCNE EQU   ZCRENTER+4
ZCREBCND EQU   ZCRENTER+4
ZCREBCMB EQU   ZCRENTER+3
ZCREBCLB EQU   ZCRENTER+3
ZCREBCLA EQU   ZCRENTER+3
ZCREBCKB EQU   ZCRENTER+3
ZCREBCKA EQU   ZCRENTER+3
ZCREBCJB EQU   ZCRENTER+3
ZCREBCJA EQU   ZCRENTER+3
ZCREBCID EQU   ZCRENTER+3
ZCREBCIB EQU   ZCRENTER+2
ZCREBCIA EQU   ZCRENTER+2
ZCREBCHB EQU   ZCRENTER+2
ZCREBCHA EQU   ZCRENTER+2
ZCREBCGB EQU   ZCRENTER+2
ZCREBCGA EQU   ZCRENTER+2
ZCREBCFB EQU   ZCRENTER+2
ZCREBCFA EQU   ZCRENTER+2
ZCREBCEB EQU   ZCRENTER+1
ZCREBCDI EQU   ZCRENTER+1
ZCREBCCB EQU   ZCRENTER+1
ZCREBCBI EQU   ZCRENTER+1
ZCREBCBB EQU   ZCRENTER+1
ZCREBCBA EQU   ZCRENTER+1
ZCREBCAM EQU   ZCRENTER+1
ZCREBCAI EQU   ZCRENTER+1
ZCREBCAG EQU   ZCRENTER
ZCREBCAE EQU   ZCRENTER
ZCREBCAB EQU   ZCRENTER
ZCREBCAA EQU   ZCRENTER
ZCREAC1B EQU   ZCRENTER
ZCREAC0B EQU   ZCRENTER
ZCREAC0A EQU   ZCRENTER
ZCREAC1A EQU   ZCRENTER
ZCRTNAME EQU   ZCRAUDIT+1
ZCRTID   EQU   ZCRAUDIT
ZCRREMIC EQU   ISTZCRR+436
ZCRSAVEZ EQU   ISTZCRR+196
ZCRDAFSV EQU   ZCRCIDSV+2
ZCRSAFSV EQU   ZCRCIDSV
ZCRR13SV EQU   ISTZCRR+188
ZCRR2SV  EQU   ISTZCRR+184
ZCROPCDE EQU   ISTZCRR+183
ZCRPRMTC EQU   ISTZCRR+182
ZCRRCDSV EQU   ISTZCRR+181
ZCRAWQSW EQU   ISTZCRR+180
ZCRTOPQ  EQU   ISTZCRR+180
ZCRLSTFB EQU   ISTZCRR+180
ZCRXSCHD EQU   ISTZCRR+180
ZCRNXTEL EQU   ISTZCRR+180
ZCRSCANQ EQU   ISTZCRR+180
ZCRMOREL EQU   ISTZCRR+180
ZCRFBPRC EQU   ISTZCRR+180
ZCRFSBSV EQU   ISTZCRR+176
ZCRSVWK5 EQU   ZCRWKARA+16
ZCRSVWK4 EQU   ZCRWKARA+12
ZCRSVWK3 EQU   ZCRWKARA+8
ZCRSVWK2 EQU   ZCRWKARA+4
ZCRSVWK1 EQU   ZCRWKARA
ZCRSVF25 EQU   ZCRSVRTN+96
ZCRSVF24 EQU   ZCRSVRTN+92
ZCRSVF23 EQU   ZCRSVRTN+88
ZCRSVF22 EQU   ZCRSVRTN+84
ZCRSVF21 EQU   ZCRSVRTN+80
ZCRSVF20 EQU   ZCRSVRTN+76
ZCRSVF19 EQU   ZCRSVRTN+72
ZCRSVF18 EQU   ZCRSVRTN+68
ZCRSVF17 EQU   ZCRSVRTN+64
ZCRSVF16 EQU   ZCRSVRTN+60
ZCRSVF15 EQU   ZCRSVRTN+56
ZCRSVF14 EQU   ZCRSVRTN+52
ZCRSVF13 EQU   ZCRSVRTN+48
ZCRSVF12 EQU   ZCRSVRTN+44
ZCRSVF11 EQU   ZCRSVRTN+40
ZCRSVF10 EQU   ZCRSVRTN+36
ZCRSVF9  EQU   ZCRSVRTN+32
ZCRSVF8  EQU   ZCRSVRTN+28
ZCRSVF7  EQU   ZCRSVRTN+24
ZCRSVF6  EQU   ZCRSVRTN+20
ZCRSVF5  EQU   ZCRSVRTN+16
ZCRSVF4  EQU   ZCRSVRTN+12
ZCRSVF3  EQU   ZCRSVRTN+8
ZCRSVF2  EQU   ZCRSVRTN+4
ZCRSVF1  EQU   ZCRSVRTN
ZCRPVZB  EQU   ISTZCRR+52
ZCRZLB   EQU   ISTZCRR+48
ZCRBFPTR EQU   ISTZCRR+44
ZCRCCWA  EQU   ISTZCRR+40
ZCRPSW   EQU   ZCRPARMS+15
ZCRPCHAR EQU   ZCRPARMS+14
ZCRPRES2 EQU   ZCRPCOD2
ZCRPMFGF EQU   ZCRPCOD2
ZCRPFHDR EQU   ZCRPCOD2
ZCRPPG2  EQU   ZCRPCOD2
ZCRPRES  EQU   ZCRPCOD1
ZCRPCFTX EQU   ZCRPCOD1
ZCRPBUF  EQU   ZCRPCOD1
ZCRPLSCB EQU   ZCRPCOD1
ZCRPLSBQ EQU   ZCRPLSBF
ZCRPFSB  EQU   ZCRPCOD1
ZCRPLNG  EQU   ZCRPCOD1
ZCRPPG   EQU   ZCRPCOD1
ZCRDTODA EQU   ZCRDFRDA
ZCRMLNG  EQU   ZCRPARMS+8
ZCRTBPTR EQU   ZCRPARMS+4
ZCRCBPTR EQU   ZCRFBPTR
ZCRCRLCP EQU   ISTZCRR+20
@NM00076 EQU   ZCRSCPSW
ZCRSKIPT EQU   ZCRSCPSW
ZCRFSBWE EQU   ZCRSCPSW
ZCRPRCMP EQU   ZCRSCPSW
ZCRLREQ  EQU   ZCRSCPSW
ZCRRJLCP EQU   ZCRSCPSW
ZCRTPINV EQU   ZCRSCPSW
ZCRTPEX  EQU   ZCRSCPSW
@NM00075 EQU   ZCRIBPR
ZCR3270R EQU   ZCRIBPR
ZCR3270  EQU   ZCRIBPR
ZCRLCPFD EQU   ZCRIBPR
ZCRLCPFR EQU   ZCRIBPR
ZCRRELK  EQU   ZCRIBPR
ZCRERR   EQU   ZCRIBPR
ZCRNOBUF EQU   ZCRIBPR
@NM00074 EQU   ZCRPFLGS
ZCRQAHED EQU   ZCRPFLGS
ZCRF1RES EQU   ZCRGENSW
ZCRBRIS  EQU   ZCRGENSW
ZCRCLRBD EQU   ZCRGENSW
ZCREXRES EQU   ZCRGENSW
ZCRLCSYN EQU   ZCRGENSW
ZCRRT06  EQU   ZCRGENSW
ZCRTSW2  EQU   ZCRGENSW
ZCRTSW1  EQU   ZCRGENSW
ZCRINLCP EQU   ZCRFLGS3
ZCRWRPTR EQU   ZCRFLGS3
ZCRNOFRE EQU   ZCRFLGS3
ZCREDRIV EQU   ZCRFLGS3
ZCRDISC  EQU   ZCRFLGS3
ZCRTPDIS EQU   ZCRFLGS3
ZCRTPCON EQU   ZCRFLGS3
ZCRTIC   EQU   ZCRFLGS3
ZCRCNLXL EQU   ZCRRESET
ZCRENDAN EQU   ZCRSWFLD
ZCRENDXL EQU   ZCRSWFLD
ZCRENDX  EQU   ZCRSWFLD
ZCROB1   EQU   ZCRNDLCP
ZCRENDPR EQU   ZCRSWFLD
ZCREXTYP EQU   ZCRSWFLD
ZCRSLCP  EQU   ZCRENDSH
ZCRIF0E3 EQU   ZCRFLGS2
ZCRIF0E2 EQU   ZCRFLGS2
ZCRIF0E1 EQU   ZCRFLGS2
ZCROB    EQU   ZCRFLGS2
ZCRFMSED EQU   ZCRFLGS2
ZCRSHEDI EQU   ZCRFLGS2
ZCRLOCAL EQU   ZCRFLGS2
ZCRFEXIT EQU   ZCRFLGS1
ZCRUNSOL EQU   ZCRFLGS1
ZCRENDLP EQU   ZCRFLGS1
ZCRNRMEX EQU   ZCRFLGS1
ZCRWAIT  EQU   ZCRFLGS1
ZCRDEQSW EQU   ZCRFLGS1
ZCRQUESW EQU   ZCRFLGS1
ZCREXSW  EQU   ZCRFLGS1
ZCRFRRA  EQU   ISTZCRR+8
ZCRCHAIN EQU   ISTZCRR+4
ZCRFLAG  EQU   ZCRCRR+3
ZCRLEN   EQU   ZCRCRR+1
ZCRID    EQU   ZCRCRR
CCFRSVD1 EQU   CFCCRT
CCFCR2   EQU   CFCCRT
CCFCRP   EQU   CFCCRT
CCFCR1   EQU   CFCCRT
CCFCS2   EQU   CFCCRT
CCFCS1   EQU   CFCCRT
NCFRSVD  EQU   CFCNTRD
NCFCR2   EQU   CFCNTRD
NCFCRP   EQU   CFCNTRD
NCFCR1   EQU   CFCNTRD
NCFCS2   EQU   CFCNTRD
NCFCS1   EQU   CFCNTRD
PFCRSV01 EQU   ISTPFCRR+13
PFCFTA   EQU   ISTPFCRR+12
CRRFRR   EQU   PFCFRRO
CRRCHAIN EQU   PFCCRRO
CRRLEN   EQU   PFCCRRLN
PFCRSV10 EQU   PFCCRR+1
CRRID    EQU   PFCCRRID
ZSAZTRAC EQU   ISTZSAVE+36
ZSAZSVVR EQU   ISTZSAVE+12
ZSAZSVRR EQU   ISTZSAVE+8
ZSAZSVFC EQU   ISTZSAVE+4
ZSAZACTV EQU   ZSAZSVMS
LCPFTYPE EQU   LCPRPHA
LCPRSTQH EQU   LCPLCCW
LCPCLREP EQU   ISTLCPB+44
LCPUBFSB EQU   LCPFLCCW
LCPRSV77 EQU   ISTLCPB+39
LCPLCCWC EQU   ISTLCPB+38
LCPRSV78 EQU   LCPFLG1
LCPTRANS EQU   LCPFLG1
LCPSTLB  EQU   LCPFLG1
LCPREDRV EQU   LCPFLG1
LCPDIRPT EQU   LCPFLG1
LCPINTER EQU   LCPFLG1
LCPRESET EQU   LCPFLG1
LCPSTYPE EQU   ISTLCPB+36
LCPFSNCH EQU   ISTLCPB+34
LCPFOSN  EQU   ISTLCPB+32
LCPTLBAD EQU   ISTLCPB+28
LCPFDB2  EQU   LCPFDBA+1
LCPFDB1  EQU   LCPFDBA
LCPNXLCW EQU   ISTLCPB+20
LCPDAF   EQU   LCPCID+2
LCPSAF   EQU   LCPCID
LCPLCCW1 EQU   ISTLCPB+12
LCPRRCNT EQU   LCPSEQ+1
LCPRRCCT EQU   LCPSEQ
LCPATOP  EQU   LCPFLAG2
LCPFREE  EQU   LCPFLAG2
LCPDSTAT EQU   LCPFLAG2
LCPEXRES EQU   LCPFID0
LCPZRIMM EQU   LCPTLBPI
LCPRSTRT EQU   LCPFLAG2
LCPASYN  EQU   LCPFLAG2
LCPPRFLG EQU   LCPFLAG2
LCPZMIRC EQU   LCPRUCNT
LCPCHAI2 EQU   LCPCHAIN+1
LCPCHNG  EQU   LCPCHAI1
LCPZRT0B EQU   LCPMNRCD
LCPZRT0A EQU   LCPMNRCD
LCPZRTL9 EQU   LCPZRT09
LCPZRTL8 EQU   LCPZRT08
LCPZRTL7 EQU   LCPZRT07
LCPZRTL6 EQU   LCPZRT06
LCPZRTL5 EQU   LCPZRT05
LCPZRTL4 EQU   LCPZRT04
LCPZRTL3 EQU   LCPZRT03
LCPZRTL2 EQU   LCPZRT02
LCPZRT01 EQU   LCPFLAGS
LCPZRT00 EQU   LCPFLAGS
LCPLNGTH EQU   ISTLCPB+1
LCPTYPE  EQU   ISTLCPB
LCCWDATA EQU   ISTLCCW+4
LCCWCNT  EQU   ISTLCCW+2
LCCWACI  EQU   LCCWFLAG
LCCWRFI  EQU   LCCWFLAG
LCCWPER  EQU   LCCWLSI
LCCWIDAT EQU   LCCWFLAG
LCCWNTVC EQU   LCCWFLAG
LCCWCKPT EQU   LCCWFLAG
LCCWCC   EQU   LCCWFLAG
LCCWCD   EQU   LCCWFLAG
LCCWTYPE EQU   LCCWCTL
LCCWMODE EQU   LCCWCTL
LCCWSOP  EQU   LCCWRWOP
@NM00073 EQU   LCCWRWOP
LCCWSD   EQU   LCCWOP
LCCWSI   EQU   LCCWOP
C0414T12 EQU   C04SAVE+12
C04SYSU  EQU   C04SAVE
DIVRSV01 EQU   ISTDIVTH+6
DIVNUMFE EQU   ISTDIVTH+2
DVEBSCAR EQU   DVEBSCID+1
DVEBSCLN EQU   DVEBSCID
DVEACIND EQU   DVERDTEA
OCWEND   EQU   ISTOCW+848
@NM00072 EQU   OCWFLG1
OCWEXIT  EQU   OCWFLG1
OCWSENSE EQU   ISTOCW+843
OCWBNDSZ EQU   ISTOCW+841
OCWBINDD EQU   OCWBIND+37
OCWBINDA EQU   OCWBIND+1
OCWBINDC EQU   OCWBIND
OCWSHPLC EQU   OCWSHPL+8
OCWSHPLB EQU   OCWSHPL+4
OCWSHPLA EQU   OCWSHPL
OCWBNDRU EQU   ISTOCW+780
OCWELCP  EQU   ISTOCW+776
OCWRSV12 EQU   ISTOCW+772
OCWRSV11 EQU   ISTOCW+768
OCWODOA  EQU   ISTOCW+764
OCWSCHIO EQU   OCWIOCNT
OCWPROCD EQU   ISTOCW+756
OCWCCRPH EQU   ISTOCW+752
OCWPABCT EQU   ISTOCW+748
OCWDAF   EQU   OCWCID+2
OCWSAF   EQU   OCWCID
OCWNMLLN EQU   ISTOCW+742
OCWRSV0A EQU   ISTOCW+741
OCWRSV82 EQU   OCWLOCKS
OCWMLOCK EQU   OCWLOCKS
OCWALOCK EQU   OCWLOCKS
OCWDLOCK EQU   OCWLOCKS
OCWCLOCK EQU   OCWLOCKS
OCWELOCK EQU   OCWLOCKS
OCWRLOCK EQU   OCWLOCKS
OCWVLOCK EQU   OCWLOCKS
OCWACE   EQU   ISTOCW+736
OCWIOMIN EQU   ISTOCW+735
OCWIOMAJ EQU   ISTOCW+734
OCWBHSID EQU   ISTOCW+733
OCWRSV03 EQU   ISTOCW+732
OCWSWTE7 EQU   OCWSWTE
OCWSWTE6 EQU   OCWSWTE
OCWSWTE5 EQU   OCWSWTE
OCWSWTE4 EQU   OCWSWTE
OCWSWTE3 EQU   OCWSWTE
OCWSWTE2 EQU   OCWSWTE
OCWLCPBC EQU   OCWSWTE
OCWSKEL  EQU   OCWSWTE
OCWSWTR7 EQU   OCWSWTRD
OCWSWTR6 EQU   OCWSWTRD
OCWSWTR5 EQU   OCWSWTRD
OCWDPDVT EQU   OCWSWTRD
OCWEPTLP EQU   OCWSWTRD
OCWCPARE EQU   OCWSWTRD
OCWCLEN  EQU   OCWSWTRD
OCWSRDVT EQU   OCWSWTRD
OCWCLCD2 EQU   ISTOCW+728
OCWCLCD1 EQU   ISTOCW+726
OCWLALEN EQU   ISTOCW+724
OCWSDVTA EQU   ISTOCW+720
OCWOENIB EQU   ISTOCW+716
OCWSORTP EQU   ISTOCW+712
OCWMDVT  EQU   ISTOCW+708
OCWSDVT  EQU   ISTOCW+704
OCWPREV  EQU   ISTOCW+700
OCWLCPBA EQU   ISTOCW+696
OCWR14SV EQU   ISTOCW+624
OCWSAVE4 EQU   ISTOCW+480
OCWSAVE3 EQU   ISTOCW+408
OCWSAVE2 EQU   ISTOCW+336
OCWSAVE1 EQU   ISTOCW+264
OCWCSPL  EQU   ISTOCW+224
OCWRSVD  EQU   ISTOCW+212
OCWVPAB  EQU   ISTOCW+208
OCWSWTD7 EQU   OCWSWTD
OCWSWTD6 EQU   OCWSWTD
OCWSWTD5 EQU   OCWSWTD
OCWSWTD4 EQU   OCWSWTD
OCWPGDON EQU   OCWSWTD
OCWSTCTL EQU   OCWSWTD
OCWNPOST EQU   OCWSWTD
OCWCLDEB EQU   OCWSWTD
OCWVARY  EQU   OCWSWTC
OCWPRMTR EQU   OCWSWTC
OCWPBH   EQU   OCWSWTC
OCWRBH   EQU   OCWSWTC
OCWCKACE EQU   OCWSWTC
OCWODCLS EQU   OCWSWTC
OCWSWTC1 EQU   OCWSWTC
OCWSPCLS EQU   OCWSWTC
OCWCSCAL EQU   OCWSWTB
OCWPSREQ EQU   OCWSWTB
OCWOLOCK EQU   OCWSWTB
OCWCOREQ EQU   OCWSWTB
OCWDOPHY EQU   OCWSWTB
OCWCLOOP EQU   OCWSWTB
OCWRECL  EQU   OCWSWTB
OCWGOFUN EQU   OCWSWTB
OCWNODLT EQU   OCWSWTA
OCWODCL  EQU   OCWSWTA
OCWGODST EQU   OCWSWTA
OCWSORT  EQU   OCWSWTA
OCWGOCNT EQU   OCWSWTA
OCWNOCON EQU   OCWSWTA
OCWSRT   EQU   OCWSWTA
OCWGTLST EQU   OCWSWTA
OCWSCPAD EQU   ISTOCW+176
OCWDNIB  EQU   ISTOCW+112
OCWBADNO EQU   ISTOCW+110
OCWDSTNO EQU   ISTOCW+108
OCWODCT2 EQU   ISTOCW+106
OCWODCT1 EQU   ISTOCW+104
OCWRSV02 EQU   ISTOCW+100
OCWRSV01 EQU   ISTOCW+96
OCWSVEC  EQU   OCWSVCOD+1
OCWSVRC  EQU   OCWSVCOD
OCWEC    EQU   OCWODRC+1
OCWRC    EQU   OCWODRC
OCWODFST EQU   ISTOCW+88
OCWODNAS EQU   ISTOCW+84
OCWODLST EQU   ISTOCW+80
OCWLPOST EQU   ISTOCW+76
OCWCPOST EQU   ISTOCW+72
OCWFPOST EQU   ISTOCW+68
OCWACDEB EQU   ISTOCW+64
OCWNCB   EQU   ISTOCW+60
OCWFMCB  EQU   ISTOCW+56
OCWEPTAB EQU   ISTOCW+52
OCWARDTE EQU   ISTOCW+48
OCWNIB   EQU   ISTOCW+44
OCWDRHOB EQU   OCWDRDTE
OCWCSL   EQU   ISTOCW+28
OCWACVT  EQU   ISTOCW+24
OCWPAB   EQU   ISTOCW+20
OCWRPH   EQU   ISTOCW+16
OCWCHAIN EQU   ISTOCW+8
OCWPBCHN EQU   ISTOCW+4
OCWTLEN  EQU   ISTOCW+2
OCWSLEN  EQU   ISTOCW+1
OCWID    EQU   ISTOCW
CSPUNUSD EQU   CSPRSC2B+4
CSPUECBA EQU   CSPRSC2B
CSPTRDTE EQU   ISTCSP+28
CSPRLRPH EQU   ISTCSP+24
CSPNO    EQU   ISTCSP+22
CSPCC    EQU   ISTCSP+20
CSPDATA  EQU   ISTCSP+16
CSPRSCE  EQU   ISTCSP+12
CSPDEST  EQU   ISTCSP+8
CSPSRC   EQU   ISTCSP+4
@NM00071 EQU   CSPOPT2
CSPRSC2F EQU   CSPOPT2
CSPWASQD EQU   CSPOPT2
CSPACQS  EQU   CSPOPT2
CSPACES  EQU   CSPOPT2
CSPNOREL EQU   CSPOPT2
CSPCOREQ EQU   CSPOPT2
CSPSTAP  EQU   CSPOPT2
@NM00070 EQU   CSPOPT1
CSPANY   EQU   CSPOPT1
CSPACT   EQU   CSPOPT1
CSPSESS  EQU   CSPOPT1
CSPPND   EQU   CSPOPT1
CSPLOGI  EQU   CSPOPT1
CSPQ     EQU   CSPOPT1
CSPRSC   EQU   CSPOPT1
CSPIDX   EQU   ISTCSP
CSLDATAF EQU   CSLDATA
CSLNIBF  EQU   CSLNIB
CSLRDTEF EQU   CSLRDTE
BINUSE   EQU   ISTBIND+36
BINUSEL  EQU   ISTBIND+35
BINPRIM  EQU   ISTBIND+27
BINPRIML EQU   ISTBIND+26
BINRSV05 EQU   ISTBIND+25
BINLUTYP EQU   BINLUP
BINRSV27 EQU   BINLUP
BINRSV08 EQU   BINTSU+4
BINPRUSE EQU   BINPRUSZ
BINPRUSM EQU   BINPRUSZ
BINSRUSE EQU   BINSRUSZ
BINSRUSM EQU   BINSRUSZ
BINRPACM EQU   BINRPACE
BINRSV07 EQU   BINRPACE
BINRSV06 EQU   BINTSU
BINCONR  EQU   BINCMNP2
BINRCHN  EQU   BINCMNP2
BINMDIBK EQU   BINCMNP2
BINBKFS  EQU   BINCMNP2
BINRCVR  EQU   BINCMNP2
BINFMTRM EQU   BINCMNP2
BINRSV04 EQU   BINCMNP
BINALT   EQU   BINCMNP
BINBKTR  EQU   BINCMNP
BINBRAK  EQU   BINCMNP
BINFMHD  EQU   BINCMNP
BINRSV03 EQU   BINCMNP
BINSSEB  EQU   BINSECP
BINSCMP  EQU   BINSECP
BINRSV02 EQU   BINSECP
BINSCHNR EQU   BINSECP
BINSMCH  EQU   BINSECP
BINSCHN  EQU   BINSECP
BINPSEB  EQU   BINPRIP
BINPCMP  EQU   BINPRIP
BINRSV01 EQU   BINPRIP
BINPCHNR EQU   BINPRIP
BINPMCH  EQU   BINPRIP
BINPCHN  EQU   BINPRIP
BINTS    EQU   ISTBIND+2
BINFM    EQU   ISTBIND+1
BINTYPE  EQU   BINFMTY
BINFMT   EQU   BINFMTY
NIBRESV  EQU   ISTNIB+60
NIBNDAR  EQU   ISTNIB+56
NIBLMODE EQU   ISTNIB+48
NIBEXLST EQU   ISTNIB+44
NIBLIMIT EQU   ISTNIB+42
@NM00069 EQU   ISTNIB+41
@NM00068 EQU   NIBFLG1
@NM00067 EQU   NIBFLG1
@NM00066 EQU   NIBFLG1
@NM00065 EQU   NIBFLG1
NIBSHLTP EQU   NIBFLG1
NIBSDAPP EQU   NIBFLG1
NIBCON   EQU   NIBFLG1
NIBPROCD EQU   ISTNIB+36
NIBMODE  EQU   ISTNIB+20
NIBUSER  EQU   ISTNIB+8
NIBCID   EQU   ISTNIB+4
NIBCONDN EQU   ISTNIB+2
NIBRSV01 EQU   ISTNIB+1
PROSRDEF EQU   PROSETM4
PRORSV47 EQU   PROSETM4
PROSCON  EQU   PROSETM4
PRORSV46 EQU   PROSETM3
PROSMONT EQU   PROSETM3
PRORSV45 EQU   PROSETM3
PROSNTO  EQU   PROSETM3
PRORSV44 EQU   PROSETM3
PRORSV43 EQU   PROSETM2
PROSNTFL EQU   PROSETM2
PRORSV42 EQU   PROSETM2
PRORSV41 EQU   PROPROCS
PROMODC  EQU   PROPROC4
PROMODT  EQU   PROPROC4
PROMODM  EQU   PROPROC4
PROMODB  EQU   PROPROC4
PRORSV14 EQU   PROPROC4
PRORSV13 EQU   PROPROC4
PRORSV12 EQU   PROPROC4
PROEIB   EQU   PROPROC4
PRORSV11 EQU   PROPROC3
PROMONT2 EQU   PROPROC3
PROMONIT EQU   PROPROC3
PROSUBLK EQU   PROPROC3
PRONTO   EQU   PROPROC3
PROLGIN  EQU   PROPROC3
PROERPI  EQU   PROPROC3
PRORSV07 EQU   PROPROC3
PROCFTX  EQU   PROPROC2
PROEMLC  EQU   PROPROC2
PRONTFL  EQU   PROPROC2
PRORSV05 EQU   PROPROC2
PRORSV04 EQU   PROPROC2
PROLGOT  EQU   PROPROC2
PROERPO  EQU   PROPROC2
PRORSV03 EQU   PROPROC2
PRORPLC  EQU   PROPROC1
PROCS    EQU   PROPROC1
PROCA    EQU   PROPROC1
PRORESPX EQU   PROPROC1
PRODFASY EQU   PROPROC1
PROXPOPT EQU   PROPROC1
PROTRUNC EQU   PROPROC1
PROASYIP EQU   PROPROC1
PATRSV01 EQU   PATFLAGA
PATUSEFG EQU   PATFLAGA
PATRDCNT EQU   ISTPAT+6
PATGRPID EQU   ISTPAT+5
PATPTHID EQU   ISTPAT+4
PATDINDX EQU   ISTPAT+2
PATGINDX EQU   ISTPAT
GNTGRPNM EQU   ISTGNT
DNTTELNO EQU   ISTDNT+1
DNTCTDIG EQU   ISTDNT
RLSRSV02 EQU   ISTRLS+140
RLSRSV01 EQU   ISTRLS+138
RLSPRE   EQU   ISTRLS
RDARSVPT EQU   ISTRDA+84
RDAPUBI  EQU   ISTRDA+83
RDADFCUA EQU   ISTRDA+80
RDACTPCC EQU   ISTRDA+79
RDADACUA EQU   ISTRDA+76
RDALUBA  EQU   RDAUCBAD+1
RDACHQI  EQU   RDAUCBAD
RDARSV01 EQU   RDAFLAG
RDARBISA EQU   RDAFLAG
RDAPRE   EQU   ISTRDA
RSWRSV01 EQU   ISTRSW+152
RSWRSV02 EQU   ISTRSW+150
RSWGRUPZ EQU   ISTRSW+146
RSWDIALZ EQU   ISTRSW+144
RSWGRUPT EQU   ISTRSW+140
RSWDIALT EQU   ISTRSW+136
RSWPRE   EQU   ISTRSW
RLXRSV03 EQU   ISTRLX+80
RLXRSV02 EQU   ISTRLX+77
RLXRSV01 EQU   RLXFLAGA
RLXINUSE EQU   RLXFLAGA
RLXNLUX  EQU   ISTRLX+72
RLXPRE   EQU   ISTRLX
RPXRSV01 EQU   ISTRPX+80
RPXRSV02 EQU   ISTRPX+77
RPXMAXLU EQU   ISTRPX+76
RPXFLUX  EQU   ISTRPX+72
RPXPRE   EQU   ISTRPX
RLURSV02 EQU   ISTRLU+172
RLULGMOD EQU   ISTRLU+164
RLUMODEP EQU   RLUMODET+8
RLUMODEN EQU   RLUMODET
RLUUSSPT EQU   RLUUSSTB+8
RLUUSSNM EQU   RLUUSSTB
RLURSV01 EQU   ISTRLU+137
RLULOCAD EQU   ISTRLU+136
RLUNCPPM EQU   RLUNCPPC+1
RLUNCPPN EQU   RLUNCPPC
RLUPACEM EQU   RLUPACE+1
RLUPACEN EQU   RLUPACE
RLUINTA  EQU   ISTRLU+128
RLUSSCFM EQU   ISTRLU+127
RLUCRRSV EQU   RLUCRFLG
RLUACTLU EQU   RLUCRFLG
RLURSV00 EQU   RLUFLAG
RLUNDSES EQU   RLUFLAG
RLUGSTAT EQU   RLUFLAG
RLUBATCH EQU   RLUFLAG
RLURBISA EQU   RLUFLAG
RLUTYPE  EQU   ISTRLU+124
RLUCRPR  EQU   ISTRLU
RCCRVPT2 EQU   ISTRCC+144
RCCXTOSW EQU   ISTRCC+140
RCCSWTOX EQU   ISTRCC+136
RCCRSPT2 EQU   ISTRCC+133
RCCADDR  EQU   ISTRCC+132
RCCPASSL EQU   ISTRCC+131
RCCMXOUT EQU   ISTRCC+130
RCCMXDAT EQU   ISTRCC+128
RCCINDEX EQU   ISTRCC+126
RCCPATHZ EQU   ISTRCC+124
RCCPATHT EQU   ISTRCC+120
RCCDPQ   EQU   ISTRCC+116
RCCTPAB  EQU   ISTRCC+112
RCCRSV02 EQU   ISTRCC+109
RCCCRRSV EQU   RCCCRFLG
RCCCTCFL EQU   RCCCRFLG
RCCACTPU EQU   RCCCRFLG
RCCNCSPL EQU   ISTRCC+104
RCCRPHCN EQU   ISTRCC+100
RCCEPAB  EQU   ISTRCC+96
RCCDPAB  EQU   ISTRCC+92
RCCVPAB  EQU   ISTRCC+88
@NM00064 EQU   ISTRCC+87
RCCSESCT EQU   ISTRCC+86
RCCIDNUM EQU   RCCID48+3
RCCIDBLK EQU   RCCID48+2
RCCIDPA2 EQU   RCCID48+1
RCCIDPUT EQU   RCCID48
RCCIDPA1 EQU   RCCSTAID
RCCCNCNT EQU   ISTRCC+75
RCCRTGOH EQU   RCCFLAGB
RCCBRKCN EQU   RCCFLAGB
RCCRESET EQU   RCCFLAGB
RCCFINAL EQU   RCCFLAGB
RCCBNNSP EQU   RCCFLAGB
RCCIRETR EQU   RCCFLAGB
RCCDIALP EQU   RCCFLAGB
RCCDSTCT EQU   RCCFLAGB
RCCCTPGD EQU   RCCFLAG
RCCPRGDN EQU   RCCFLAG
RCCOUERP EQU   RCCFLAG
RCCOHIMM EQU   RCCFLAG
RCCLDISC EQU   RCCFLAG
RCCERPIP EQU   RCCFLAG
RCCCUDIE EQU   RCCFLAG
RCCRBISA EQU   RCCFLAG
RCCTYPE  EQU   ISTRCC+72
RCCPRE   EQU   ISTRCC
RDSCTATR EQU   ISTRDS+74
RDSPRE   EQU   ISTRDS
RINRSV05 EQU   ISTRIN+156
RINRSV04 EQU   ISTRIN+152
RINLOCRN EQU   ISTRIN+148
RINRSV02 EQU   ISTRIN+145
RTRCNCNT EQU   RINCNCNT
RTRNCSPL EQU   RINNCSPL
RTRRPHCN EQU   RINRPHCN
RTRVPAB  EQU   RINVPAB
RTRREMOT EQU   RINREMOT
RTRRLDAF EQU   RINRLDAF
RTRNODID EQU   RINNODID
RINRSV01 EQU   RINDFD
RTRLDISC EQU   RINLDISC
RTRNODEF EQU   RINNODEF
RTRREMPO EQU   RINREMPO
RINCRPRE EQU   ISTRIN
RTRRSV04 EQU   ISTRTR+210
RTRLCTI  EQU   ISTRTR+209
RTRIDCAS EQU   RTRBSCID+1
RTRIDLEN EQU   RTRBSCID
RTRRSVDD EQU   ISTRTR+181
RTRRDFG  EQU   ISTRTR+180
RTRDIAA  EQU   ISTRTR+176
RTRPOLA  EQU   ISTRTR+172
RTRCADDR EQU   ISTRTR+164
RTRCTADR EQU   ISTRTR+162
RTRCTPOL EQU   ISTRTR+160
RTRCTDIA EQU   ISTRTR+158
RTRRSV03 EQU   ISTRTR+156
RTRRVPT1 EQU   ISTRTR+152
RTRBHSN1 EQU   ISTRTR+144
RTRCRSV2 EQU   RTRCRFLG
RTRDTRLM EQU   RTRLSCMD
RTRCRSV1 EQU   RTRCRFLG
RTRTRMAX EQU   ISTRTR+142
RTRRSV24 EQU   RTRRDFF
RTRRFDEK EQU   RTRRDFF
RTRRFANK EQU   RTRRDFF
RTRRFPFK EQU   RTRRDFF
RTRRFPEN EQU   RTRRDFF
RTRRFXCT EQU   RTRRDFF
RTRRESCT EQU   RTRRDFE
RTRRESUP EQU   RTRRDFE
RTRREATT EQU   RTRRDFE
RTRRECHK EQU   RTRRDFE
RTRREACR EQU   RTRRDFE
RTRRSV0A EQU   RTRRDFE
RTRREBRK EQU   RTRRDFE
RTRRSV11 EQU   RTRRDFD
RTRRSV10 EQU   RTRRDFD
RTRRDBHI EQU   RTRRDFD
RTRRDBHD EQU   RTRRDFD
RTRRDBHN EQU   RTRRDFD
RTRRSV23 EQU   RTRRDFC
RTRRCXMS EQU   RTRRDFC
RTRRCMSG EQU   RTRRDFC
RTRRCBLK EQU   RTRRDFC
RTRRCPT3 EQU   RTRRDFC
RTRRCIT2 EQU   RTRRDFC
RTRRCIT1 EQU   RTRRDFC
RTRRSV32 EQU   RTRRDFB
RTRRBEND EQU   RTRRDFB
RTRRBECT EQU   RTRRDFB
RTRRSV02 EQU   RTRRDFA
RTRRACTR EQU   RTRRDFA
RTRRSV60 EQU   RTRRDFA
RTRRACDT EQU   RTRRDFA
RTRRAPT3 EQU   RTRRAALL
RTRRAPT2 EQU   RTRRAALL
RTRRAPT1 EQU   RTRRAALL
RTRRAATN EQU   RTRRDFA
RTRRSV45 EQU   ISTRTR+132
RTRRSV01 EQU   ISTRTR+130
RTRADRPT EQU   RTRADR+1
RTRRSV22 EQU   RTRFLAG
RTRVTERM EQU   RTRFLAG
RTRRSV51 EQU   RTRFLAG
RTRRBISA EQU   RTRFLAG
RTRRSV21 EQU   RTRFLAG
RTRCRPR  EQU   ISTRTR
RCLRVPT2 EQU   ISTRCL+92
RCLRVPT1 EQU   ISTRCL+88
RCLGPOLA EQU   ISTRCL+84
RCLCTNGP EQU   ISTRCL+82
RCLRSV01 EQU   ISTRCL+80
RCLGPADR EQU   RCLADR+1
RCLRSV33 EQU   RCLFLAG
RCLBATCH EQU   RCLFLAG
RCLRBISA EQU   RCLFLAG
RCLRSV22 EQU   RCLFLAG
RCLPRE   EQU   ISTRCL
RPTRSV03 EQU   ISTRPT+156
RPTRSV02 EQU   ISTRPT+152
RPTNSNSV EQU   ISTRPT+148
RPTPTHCT EQU   ISTRPT+146
RPTPEPCT EQU   ISTRPT+144
RPTDAFSV EQU   ISTRPT+142
RPTRSV01 EQU   ISTRPT+141
RPTISTAT EQU   RPTFLAG1
RPTDYNAM EQU   RPTFLAG1
RPTVYIMM EQU   RPTFLAG1
RPTVIODN EQU   RPTFLAG1
RPTONLIN EQU   RPTFLAG1
RPTHLVPD EQU   RPTFLAG1
RPTVRYPD EQU   RPTFLAG1
RPTASLEP EQU   RPTFLAG1
RPTATERM EQU   ISTRPT+132
RPTCTNM  EQU   ISTRPT+120
RPTLNDAF EQU   RPTLNCID+2
RPTLNSAF EQU   RPTLNCID
RPTLN    EQU   ISTRPT
RLNRVPT2 EQU   ISTRLN+112
RLNNCSPL EQU   ISTRLN+108
RLNX2SW  EQU   ISTRLN+104
@NM00063 EQU   ISTRLN+103
RLNCRRSV EQU   RLNCRFLG
RLNSWEP  EQU   RLNCRFLG
RLNSVSKP EQU   RLNLSCMD
RLNSESLM EQU   RLNLSCMD
RLNNPRLM EQU   RLNLSCMD
RLNSWNCP EQU   RLNCRFLG
RLNACTLN EQU   RLNCRFLG
RLNPAUSE EQU   ISTRLN+101
RLNPOLMT EQU   ISTRLN+100
RLNACTSN EQU   ISTRLN+98
RLNRESV1 EQU   ISTRLN+97
RLNACTRM EQU   ISTRLN+96
RLNCTSES EQU   ISTRLN+95
RLNRDSLM EQU   ISTRLN+94
RLNAUTOA EQU   ISTRLN+92
RLNRDFD  EQU   RLNRDF+3
RLNRDFC  EQU   RLNRDF+2
RLNMULTP EQU   RLNRDFB
RLNRAPOL EQU   RLNRDFB
RLNRSV0B EQU   RLNRDFB
RLNAUTOD EQU   RLNRDFB
RLNANSWR EQU   RLNRDFB
RLNRBUSE EQU   RLNRDFB
RLNRAPEP EQU   RLNRDFA
RLNRANCP EQU   RLNRDFA
RLNRAEP  EQU   RLNRDFA
RLNGANSW EQU   RLNRDFA
RLNRACAN EQU   RLNRACNT
RLNRACAT EQU   RLNRACNT
RLNRSV04 EQU   RLNSTAT2
RLNINUSE EQU   RLNSTAT2
RLNOHIN  EQU   RLNSTAT2
RLNRSV03 EQU   RLNSTAT1
RLNVD    EQU   RLNSTAT1
RLNINOPP EQU   RLNSTAT1
RLNINOPL EQU   RLNSTAT1
RLNLRST  EQU   RLNSTAT1
RLNTRAP  EQU   RLNSTAT1
RLNACTCT EQU   ISTRLN+84
RLNCTEIN EQU   ISTRLN+80
RLNCTECL EQU   ISTRLN+76
RLNCUA   EQU   RLNUCBAD
RLNRSV01 EQU   RLNFLAG
RLNRBISA EQU   RLNFLAG
RLNEAM   EQU   RLNFLAG
RLNPRE   EQU   ISTRLN
RGPRVPT2 EQU   ISTRGP+88
RGPRVPT1 EQU   ISTRGP+84
RGPCTECM EQU   ISTRGP+82
RGPCTEIN EQU   ISTRGP+80
RGPCTECL EQU   ISTRGP+76
RGPCTELN EQU   ISTRGP+74
RGPRSV03 EQU   ISTRGP+73
RGPRSV02 EQU   RGPFLG
RGPASDLC EQU   RGPFLG
RGPABSC  EQU   RGPFLG
RGPASS   EQU   RGPFLG
RGPADIL  EQU   RGPFLG
RGPPRE   EQU   ISTRGP
RRNRINNM EQU   ISTRRN+248
@NM00062 EQU   ISTRRN+247
RRNRDCUA EQU   ISTRRN+244
RRNLASTE EQU   ISTRRN+240
RRNNCSPL EQU   ISTRRN+236
RRNRPLPT EQU   ISTRRN+232
RRNMSIZE EQU   ISTRRN+228
RRNNCPNM EQU   ISTRRN+221
RRNCTPCC EQU   ISTRRN+220
RRNHBUFS EQU   ISTRRN+218
RRNHLENT EQU   RRNHPRE+1
RRNHLENH EQU   RRNHPRE
RRNNMNCP EQU   ISTRRN+208
RRNDELAY EQU   ISTRRN+206
RRNRSV04 EQU   ISTRRN+200
RRNRSV88 EQU   RRNNMDPD+7
RRNPUBI  EQU   RRNNMDPD+6
RRNDPLUB EQU   RRNNMDPD
RRNEPADR EQU   ISTRRN+190
RRNCPLUB EQU   ISTRRN+184
RRNFLUX  EQU   ISTRRN+180
RRNRSV05 EQU   RRNCMFD
RRNREMPO EQU   RRNCMFD
RRNCDREC EQU   RRNCMFD
RRNCDDSI EQU   RRNCMFD
RRNCDBCK EQU   RRNCMFD
RRNCDDTL EQU   RRNCMFD
RRNCDSTD EQU   RRNCMFD
RRNCDCSP EQU   RRNCMFD
RRNCCCSL EQU   RRNCMFC
RRNCCSIM EQU   RRNCMFC
RRNCCRCM EQU   RRNCMFC
RRNCCRIM EQU   RRNCMFC
RRNCCCRC EQU   RRNCMFC
RRNCCRST EQU   RRNCMFC
RRNCCRDQ EQU   RRNCMFC
RRNCCRCN EQU   RRNCMFC
RRNCBALT EQU   RRNCMFB
RRNCBMOD EQU   RRNCMFB
RRNCBNPL EQU   RRNCMFB
RRNCBRLS EQU   RRNCMFB
RRNCBRDS EQU   RRNCMFB
RRNCBDLR EQU   RRNCMFB
RRNCBDLH EQU   RRNCMFB
RRNCBDLO EQU   RRNCMFB
RRNCADGO EQU   RRNCMFA
RRNCADTD EQU   RRNCMFA
RRNCACDT EQU   RRNCMFA
RRNCAMBH EQU   RRNCMFA
RRNCAATI EQU   RRNCMFA
RRNCAATG EQU   RRNCMFA
RRNCAATD EQU   RRNCMFA
RRNCAALL EQU   RRNCMFA
RRNRSV55 EQU   RRNRDF+3
RRNPTASL EQU   RRNRDFB+1
RRNRSV01 EQU   RRNRDFB+1
RRNVYDON EQU   RRNRDFB+1
RRNRBBUP EQU   RRNRDFB+1
RRNRSV03 EQU   RRNRDFB
RRNRBCT2 EQU   RRNRDFB
RRNRBCT1 EQU   RRNRDFB
RRNRBSEC EQU   RRNRDFB
RRNRBCCT EQU   RRNRDFB
RRNRBCCL EQU   RRNRDFB
RRNRSV02 EQU   RRNRDFB
RRNRBMDL EQU   RRNRDFB
RRNRAPEP EQU   RRNRDFA
RRNRANCP EQU   RRNRDFA
RRNRBREM EQU   RRNRDFA
RRNRAOLT EQU   RRNRDFA
RRNRASYN EQU   RRNRDFA
RRNRADMP EQU   RRNRDFA
RRNRAIPL EQU   RRNRDFA
RRNRASHT EQU   RRNRDFA
RRNCTENT EQU   ISTRRN+170
RRNCTEIN EQU   ISTRRN+166
RRNCTECL EQU   ISTRRN+162
RRNCTELI EQU   ISTRRN+160
RRNCTEGP EQU   ISTRRN+158
RRNCTBHS EQU   ISTRRN+156
RRNBHSET EQU   ISTRRN+152
RRNTRENT EQU   ISTRRN+148
RRNRLDIP EQU   ISTRRN+147
RRNRNCUA EQU   ISTRRN+144
RRNGRPA  EQU   ISTRRN+140
RRNLUBA  EQU   RRNUCBAD+1
RRNCHQI  EQU   RRNUCBAD
RRNRSV11 EQU   RRNFLAG
RRNDSTCT EQU   RRNFLAG
RRNERPIP EQU   RRNFLAG
RRNLCDIP EQU   RRNFLAG
RRNLCDIE EQU   RRNFLAG
RRNLCSIP EQU   RRNFLAG
RRNRBISA EQU   RRNFLAG
RRNRSV89 EQU   RRNFLAG
RRNPRE   EQU   ISTRRN
RLCRVPT2 EQU   ISTRLC+80
RLCRVPT1 EQU   ISTRLC+79
RLCLCCUA EQU   ISTRLC+76
RLCUCBAD EQU   RLCADR+1
RLCRSVDE EQU   RLCFLAG
RLCACNT  EQU   RLCFLAG
RLCRSV14 EQU   RLCFLAG
RLCRBISA EQU   RLCFLAG
RLCRSV22 EQU   RLCFLAG
RLCPRE   EQU   ISTRLC
RAPRVPT2 EQU   ISTRAP+116
RAPRVPT1 EQU   ISTRAP+112
RAPBFACT EQU   ISTRAP+111
RAPRSV17 EQU   RAPFLGC
RAPRSV16 EQU   RAPFLGC
RAPRSV15 EQU   RAPFLGC
RAPRSV14 EQU   RAPFLGC
RAPRSV13 EQU   RAPFLGC
RAPRSV12 EQU   RAPFLGC
RAPRSV11 EQU   RAPFLGC
RAPRSV10 EQU   RAPFLGC
RAPANVPC EQU   RAPFLGB
RAPASPO  EQU   RAPFLGB
RAPAPPO  EQU   RAPFLGB
RAPAACQ  EQU   RAPFLGB
RAPAPRMT EQU   RAPFLGB
RAPAPASS EQU   RAPFLGB
RAPABLCK EQU   RAPFLGB
RAPALLF  EQU   RAPFLGB
RAPRSV06 EQU   RAPFLG
RAPRSV05 EQU   RAPFLG
RAPRSV04 EQU   RAPFLG
RAPRSV03 EQU   RAPFLG
RAPATLGN EQU   RAPFLG
RAPASLGI EQU   RAPFLG
RAPAQUI  EQU   RAPFLG
RAPABLGN EQU   RAPFLG
RAPACEQD EQU   ISTRAP+106
RAPTRPRE EQU   ISTRAP+104
RAPACEAP EQU   ISTRAP+100
RAPICEAQ EQU   ISTRAP+96
RAPICEAC EQU   ISTRAP+92
RAPICELG EQU   ISTRAP+88
RAPAPPWD EQU   ISTRAP+80
RAPACDEB EQU   ISTRAP+76
RAPACBA  EQU   ISTRAP+72
RAPPRE   EQU   ISTRAP
RDTVSRPL EQU   ISTRDT+132
RDTCRSPW EQU   ISTRDT+124
RDTCRSDS EQU   ISTRDT+116
@NM00061 EQU   ISTRDT+113
RRNSTCNT EQU   RDTSTCNT
RRNVYRPH EQU   RDTVYRPH
RDTTPAB  EQU   ISTRDT+104
RDTDPAB  EQU   ISTRDT+100
RDTEPAB  EQU   ISTRDT+96
RDTVPAB  EQU   ISTRDT+92
RDTRSV01 EQU   RDTFLAGB
RDTBHSET EQU   RDTFLAGB
RDTCTCFL EQU   RDTFLAGB
RDTCTPGD EQU   RDTFLAGB
RDTPRGDN EQU   RDTFLAGB
RDTOUERP EQU   RDTFLAGB
RDTLGCT  EQU   ISTRDT+90
RDTNODID EQU   ISTRDT+89
RDTMAXID EQU   ISTRDT+88
RDTCTSNT EQU   ISTRDT+86
RDTFLAGS EQU   ISTRDT+84
RDTBACK  EQU   ISTRDT+80
RDTFORW  EQU   ISTRDT+76
RDTLEN   EQU   RDTPLEN+1
RDTPRILS EQU   RDTPRIOR
RDTPRISW EQU   RDTPRIOR
RDTPRIRN EQU   RDTPRIOR
RDTPRILC EQU   RDTPRIOR
RDTPRIAP EQU   RDTPRIOR
@NM00060 EQU   RDTPRIOR
RDTPRE   EQU   ISTRDT
RCPRSV05 EQU   ISTRCPRE+120
RCPRSV04 EQU   ISTRCPRE+116
RCPRSV03 EQU   ISTRCPRE+112
RCPINTA  EQU   RCPLGNIN+16
RCPLGNCT EQU   RCPLGNIN+8
RCPLGNAP EQU   RCPLGNIN
@NM00059 EQU   RCPPMODE
RCPRRECD EQU   RCPPMODE
RCPRBASC EQU   RCPPMODE
RCPBFLIM EQU   ISTRCPRE+90
RCPBHSI2 EQU   ISTRCPRE+89
RCPBHSI1 EQU   ISTRCPRE+88
RCPACETR EQU   ISTRCPRE+84
RCPICEAQ EQU   ISTRCPRE+80
RCPLNAPA EQU   ISTRCPRE+76
RCPICELN EQU   ISTRCPRE+72
RCPPRE   EQU   ISTRCPRE
RPRCONID EQU   ISTRPRE+63
RPRCLVPD EQU   RPRFLAGC
RPRINIMM EQU   RPRFLAGD
RPRRSV05 EQU   RPRFLAGD
RPRCONP  EQU   RPRFLAGD
RPRACTP  EQU   RPRFLAGD
RPRRSON  EQU   RPRFLAGD
RPRCONCT EQU   RPRFLAGD
RPRLTASN EQU   RPRFLAGD
RPRPTHCT EQU   ISTRPRE+60
RPRSWDAF EQU   ISTRPRE+58
RPRSTPCT EQU   ISTRPRE+56
RPRRVPT1 EQU   ISTRPRE+52
RPRNCBA  EQU   ISTRPRE+40
RPRNSNEA EQU   ISTRPRE+36
RPRLGONB EQU   ISTRPRE+32
RPRLGONF EQU   ISTRPRE+28
RPRHDTYP EQU   ISTRPRE+27
RPRTIOCT EQU   ISTRPRE+26
RPRPEPCT EQU   ISTRPRE+24
RPRRSV03 EQU   RPRCAUSE
RPRRSYNC EQU   RPRCAUSE
RPRCRCPT EQU   RPRCAUSE
RPRNOSRT EQU   RPRCAUSE
RPRINTST EQU   RPRFLAGB
RPRVYIMM EQU   RPRFLAGB
RPRHLVPD EQU   RPRFLAGB
RPRONLIN EQU   RPRFLAGB
RPRVIODN EQU   RPRFLAGB
RPRAOPN  EQU   RPRFLAGB
RPRENTVT EQU   RPRFLAGB
RPRENTVH EQU   RPRFLAGB
RPRLIVE  EQU   RPRFLAGA
RPRVRYPD EQU   RPRFLAGA
RPRENTED EQU   RPRFLAGA
RPRENTIO EQU   RPRFLAGA
RPRENTBF EQU   RPRFLAGA
RPRTIED  EQU   RPRFLAGA
RPRINV   EQU   RPRFLAGA
RPRACT   EQU   RPRFLAGA
RPRRLOCK EQU   ISTRPRE+12
RPRDAF   EQU   RPRCOMID+2
RPRSAF   EQU   RPRCOMID
DEVRSV03 EQU   ISTDEVCH+5
DEVPHYSA EQU   ISTDEVCH+4
DEVCSLPN EQU   DEVCHAR3
DEVCSTCL EQU   DEVCHAR3
DEVCCHEK EQU   DEVCHAR3
DEVCATTN EQU   DEVCHAR3
DEVCRVB  EQU   DEVFCCTL
DEVCSSL  EQU   DEVFCCTL
DEVCBSC  EQU   DEVFCCTL
DEVMCODE EQU   ISTDEVCH+2
DEVCHAR2 EQU   DEVTCODE
DEVRSV01 EQU   DEVCHAR
DEVCCTL  EQU   DEVCHAR
DEVNNSPT EQU   DEVCHAR
DEVSPS   EQU   DEVCHAR
DEVCONVR EQU   DEVCHAR
DEVOTPUT EQU   DEVCHAR
DEVINPUT EQU   DEVCHAR
LOKXCL   EQU   @NM00057
LOKPRY   EQU   @NM00057
@NM00058 EQU   @NM00057
@NM00056 EQU   LOKCHNG
LOKCT    EQU   ISTLOK
RPHNEXPO EQU   ISTRPH+104
RPHSAV16 EQU   RPHWORK+60
RPHSAV15 EQU   RPHWORK+56
RPHSAV14 EQU   RPHWORK+52
RPHSAV13 EQU   RPHWORK+48
RPHSAV12 EQU   RPHWORK+44
RPHSAV11 EQU   RPHWORK+40
RPHSAV10 EQU   RPHWORK+36
RPHSAVE9 EQU   RPHWORK+32
RPHSAVE8 EQU   RPHWORK+28
RPHSAVE7 EQU   RPHWORK+24
RPHSAVE6 EQU   RPHWORK+20
RPHSAVE5 EQU   RPHWORK+16
RPHSAVE4 EQU   RPHWORK+12
RPHSAVE3 EQU   RPHWORK+8
RPHSAVE2 EQU   RPHWORK+4
RPHSHALF EQU   RPHSAVE1+2
RPHSBIT8 EQU   RPHSBITS
RPHSBIT7 EQU   RPHSBITS
RPHSBIT6 EQU   RPHSBITS
RPHSBIT5 EQU   RPHSBITS
RPHSBIT4 EQU   RPHSBITS
RPHSBIT3 EQU   RPHSBITS
RPHSBIT2 EQU   RPHSBITS
RPHSBIT1 EQU   RPHSBITS
RPHSBYTE EQU   RPHSAVE1
RPHPABQP EQU   RPHPABQA+1
RPHPABFG EQU   RPHPABQA
RPHSRP34 EQU   RPHSRPRM+2
RPHSRP12 EQU   RPHSRPRM
RPHWEGT  EQU   RPHCSPA
RPHMAJCB EQU   ISTRPH+21
RPHPABOF EQU   ISTRPH+20
RPHRESUM EQU   RPHRESMA+1
RPHRSV01 EQU   RPHWPFLG
RPHPURGE EQU   RPHWPFLG
RPHPT    EQU   RPHWPFLG
RPHWT    EQU   RPHWPFLG
RPHRSKEY EQU   RPHWPFLG
RPHDVTA  EQU   ISTRPH+12
RPHTIK   EQU   RPHTSKID+3
@NM00055 EQU   RPHTSKID
RPHRPHAP EQU   RPHRPHA+1
@NM00054 EQU   RPHRPHA
RPHGATE  EQU   RPHRPHA
@NM00053 EQU   RPHFLGB
RPHRLCRA EQU   RPHFLGB
RPHNRSAV EQU   RPHFLGB
RPHPGCMP EQU   RPHFLGB
RPHFBAPS EQU   RPHFLGB
RPHBSSP  EQU   RPHFLGB
RPHLOCK  EQU   RPHFLGB
RPHFNFLG EQU   RPHFSTLC
RPHMLTCP EQU   RPHFLAGS
RPHSMCLR EQU   RPHFLAGS
RPHSMTYP EQU   RPHFLAGS
RPHSMQ   EQU   RPHFLAGS
RPHAUTEX EQU   RPHAPTYP
RPHSPGIN EQU   RPHFLAGS
RPHOGIND EQU   RPHFLAGS
RPHLNGTH EQU   RPHCNTL+1
RPHTYPE  EQU   RPHCNTL
RPLSEQNO EQU   RPLOF60+6
@NM00028 EQU   RPLIBSQ
RPLIINV  EQU   RPLIBSQ
RPLINEG  EQU   RPLIBSQ
RPLIPOS  EQU   RPLIBSQ
RPLIIGN  EQU   RPLIBSQ
RPLIRSET EQU   RPLIBSQ
RPLITST  EQU   RPLIBSQ
RPLISET  EQU   RPLIBSQ
@NM00027 EQU   RPLOBSQ
RPLOINV  EQU   RPLOBSQ
RPLONEG  EQU   RPLOBSQ
RPLOPOS  EQU   RPLOBSQ
RPLOIGN  EQU   RPLOBSQ
RPLORSET EQU   RPLOBSQ
RPLOTST  EQU   RPLOBSQ
RPLOSET  EQU   RPLOBSQ
RPLIBSQV EQU   RPLOF60+2
RPLOBSQV EQU   RPLOF60
@NM00026 EQU   RPLCNTSC
RPLRSHUT EQU   RPLCNTSC
RPLRQR   EQU   RPLCNTSC
RPLSHUTC EQU   RPLCNTSC
RPLSHUTD EQU   RPLCNTSC
RPLSTSN  EQU   RPLCNTSC
RPLCLEAR EQU   RPLCNTSC
RPLSDT   EQU   RPLCNTSC
@NM00025 EQU   RPLCNTDC
RPLSIGNL EQU   RPLCNTDC
RPLLUS   EQU   RPLCNTDC
RPLRTR   EQU   RPLCNTDC
RPLBID   EQU   RPLCNTDC
@NM00024 EQU   RPLCNTDF
RPLQI    EQU   RPLCNTDF
RPLRELQ  EQU   RPLCNTDF
RPLCHASE EQU   RPLCNTDF
RPLQEC   EQU   RPLCNTDF
RPLQC    EQU   RPLCNTDF
RPLCNCEL EQU   RPLCNTDF
RPLDATA  EQU   RPLCNTDF
RPLRRN   EQU   RPLRESP
RPLNFME  EQU   RPLRESP
RPLEX    EQU   RPLRESP
@NM00023 EQU   RPLRESP
@NM00022 EQU   RPLPOSTV
RPLSCHED EQU   RPLPOSTV
@NM00021 EQU   RPLVTFL1
RPLAUTUS EQU   RPLVTFL1
RPLVTUSE EQU   RPLVTFL1
@NM00020 EQU   RPLVTFL1
@NM00019 EQU   RPLCHN
RPLONLY  EQU   RPLCHN
RPLLAST  EQU   RPLCHN
RPLMIDLE EQU   RPLCHN
RPLFIRST EQU   RPLCHN
@NM00018 EQU   RPLRTYPE
RPLDFASY EQU   RPLRTYPE
RPLNFSYN EQU   RPLRTYPE
RPLRRESP EQU   RPLRTYPE
@NM00017 EQU   RPLSTYPE
RPLSRESP EQU   RPLSTYPE
@NM00016 EQU   RPLRH3
RPLCSI   EQU   RPLRH3
RPLCHREQ EQU   RPLRH3
RPLCMD   EQU   RPLRH3
RPLEB    EQU   RPLRH3
RPLBB    EQU   RPLRH3
RPLSIGDA EQU   RPLVTEXT+32
RPLSAV13 EQU   RPLVTEXT+28
RPLUSNSO EQU   RPLOSENS+2
RPLSSMO  EQU   RPLSSNSO+1
@NM00015 EQU   RPLSSEO
RPLRRO   EQU   RPLSSEO
RPLFIO   EQU   RPLSSEO
RPLSTATO EQU   RPLSSEO
RPLCPMO  EQU   RPLSSEO
@NM00014 EQU   RPLSSEO
RPLFMHDR EQU   RPLOPT12
@NM00013 EQU   RPLOPT12
@NM00012 EQU   RPLOPT12
@NM00011 EQU   RPLOPT12
RPLNIBTK EQU   RPLOPT12
RPLTRUNC EQU   RPLOPT12
RPLKEEP  EQU   RPLOPT12
@NM00010 EQU   RPLOPT12
RPLRSVE8 EQU   RPLOPT11
RPLRSVE7 EQU   RPLOPT11
RPLRSVE6 EQU   RPLOPT11
RPLRSVE5 EQU   RPLOPT11
RPLRSVE4 EQU   RPLOPT11
RPLSTOP  EQU   RPLOPT11
RPLSTART EQU   RPLOPT11
RPLQUIES EQU   RPLOPT11
RPLRSVI6 EQU   RPLOPT10
RPLRSVI5 EQU   RPLOPT10
RPLRSVI4 EQU   RPLOPT10
RPLRSVI3 EQU   RPLOPT10
RPLRSVI2 EQU   RPLOPT10
RPLSPARM EQU   RPLOPT10
RPLDSPLY EQU   RPLOPT10
RPLBSCID EQU   RPLOPT10
RPLTOPL  EQU   RPLOPT9
RPLCIDE  EQU   RPLOPT9
RPLRNNM  EQU   RPLOPT9
RPLAPPST EQU   RPLOPT9
RPLCOUNT EQU   RPLOPT9
RPLTERMS EQU   RPLOPT9
RPLDEVCH EQU   RPLOPT9
RPLLOGON EQU   RPLOPT9
RPLUSFLD EQU   RPLVTEXT+16
RPLESR2  EQU   RPLUSNSI+1
RPLESR1  EQU   RPLUSNSI
RPLSSMI  EQU   RPLDSB2
@NM00009 EQU   RPLSSEI
RPLRRI   EQU   RPLSSEI
RPLFII   EQU   RPLSSEI
RPLSTATI EQU   RPLSSEI
RPLCPMI  EQU   RPLSSEI
RPLPATHI EQU   RPLSSEI
RPLARCLN EQU   RPLVTEXT+8
RPLAARLN EQU   RPLVTEXT+4
RPLAAREA EQU   RPLVTEXT
RPLERMSA EQU   RPLCOMN+72
RPLEMLEN EQU   RPLCOMN+70
RPLACTIV EQU   RPLCOMN+69
RPLBRANC EQU   RPLEXTD1
RPLNIB   EQU   RPLEXTD1
@NM00008 EQU   RPLEXTD1
RPLEXIT  EQU   RPLEXTD1
RPLNEXIT EQU   RPLEXTD1
RPLEXSCH EQU   RPLEXTD1
RPLDDDD  EQU   RPLRBAR+4
@NM00007 EQU   RPLRBAR+3
@NM00006 EQU   RPLAIXID
RPLAXPKP EQU   RPLAIXID
RPLAIXPC EQU   RPLRBAR
RPLRSV88 EQU   RPLOPT8
RPLUNCON EQU   RPLOPT8
RPLACTV  EQU   RPLOPT8
RPLSESS  EQU   RPLOPT8
RPLPEND  EQU   RPLOPT8
RPLODPRM EQU   RPLOPT8
RPLODACP EQU   RPLOPT8
RPLODACQ EQU   RPLOPT8
RPLRSV78 EQU   RPLOPT7
RPLTCRNO EQU   RPLOPT7
RPLRLSOP EQU   RPLOPT7
RPLTPOST EQU   RPLOPT7
RPLQOPT  EQU   RPLOPT7
RPLCNIMM EQU   RPLCNOPT
RPLCNANY EQU   RPLCNOPT
RPLCNALL EQU   RPLCNOPT
RPLRSV68 EQU   RPLOPT6
RPLRSV67 EQU   RPLOPT6
RPLLOCK  EQU   RPLOPT6
RPLNCOND EQU   RPLOPT6
RPLCOND  EQU   RPLOPT6
RPLEOT   EQU   RPLUNTYP
RPLEOM   EQU   RPLUNTYP
RPLEOB   EQU   RPLUNTYP
RPLWROPT EQU   RPLOPT5
RPLNODE  EQU   RPLOPT5
RPLERACE EQU   RPLWRTYP
RPLEAU   EQU   RPLWRTYP
RPLNERAS EQU   RPLWRTYP
RPLPSOPT EQU   RPLOPT5
@NM00005 EQU   RPLOPT5
RPLDLGIN EQU   RPLOPT5
RPLRLEN  EQU   RPLCOMN+48
RPLCHAIN EQU   RPLNXTRP
RPLBOP   EQU   RPLOPT4
@NM00004 EQU   RPLOPT4
RPLMKFRM EQU   RPLOPT4
RPLENDTR EQU   RPLOPT4
RPLALIGN EQU   RPLOPT3
RPLFMT   EQU   RPLOPT3
RPLFLD   EQU   RPLOPT3
RPLVFY   EQU   RPLOPT3
RPLBLK   EQU   RPLOPT3
RPLSFORM EQU   RPLOPT3
RPLEODS  EQU   RPLOPT3
RPLNSP   EQU   RPLOPT2
RPLUPD   EQU   RPLOPT2
@NM00003 EQU   RPLOPT2
RPLLRD   EQU   RPLOPT2
RPLBWD   EQU   RPLOPT2
RPLCNV   EQU   RPLOPT2
RPLADD   EQU   RPLADR
RPLKEY   EQU   RPLOPT2
RPLECBIN EQU   RPLECBSW
RPLGEN   EQU   RPLOPT1
RPLKGE   EQU   RPLOPT1
RPLASY   EQU   RPLOPT1
RPLSKP   EQU   RPLOPT1
RPLSEQ   EQU   RPLOPT1
RPLDIR   EQU   RPLOPT1
RPLLOC   EQU   RPLOPT1
RPLDAF   EQU   RPLARG+2
RPLSAF   EQU   RPLARG
RPLTCBPT EQU   RPLCOMN+28
RPLDACB  EQU   RPLCOMN+24
RPLCCHAR EQU   RPLCOMN+20
RPLSTRID EQU   RPLCOMN+18
RPLKEYL  EQU   RPLKEYLE
RPLRDSOH EQU   RPLFDB3
RPLRLG   EQU   RPLFDB3
RPLLGFRC EQU   RPLFDB3
RPLREOT  EQU   RPLFDB3
RPLREOM  EQU   RPLFDB3
RPLREOB  EQU   RPLFDB3
RPLSV32  EQU   RPLFDB3
RPLUINPT EQU   RPLFDB3
RPLSTSAV EQU   RPLFDB2
RPLCUERR EQU   RPLFDB2
RPLDLGFL EQU   RPLFDB2
RPLIOERR EQU   RPLFDB2
RPLDVUNS EQU   RPLFDB2
RPLATND  EQU   RPLFDB2
RPLRVID  EQU   RPLFDB2
RPLERLK  EQU   RPLFDB2
RPLERREG EQU   RPLRTNCD
RPLSTAT  EQU   RPLFDBWD
RPLPOST  EQU   RPLECB
RPLWAIT  EQU   RPLECB
RPLPLHPT EQU   RPLCOMN+4
RPLLEN2  EQU   RPLLEN
RPLREQ   EQU   RPLIDWD+2
RPLSTYP  EQU   RPLIDWD+1
RPLID    EQU   RPLIDWD
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00002 EQU   CVTFIX+248
@NM00001 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTSHSB  EQU   CVTSHS
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
@NM00052 EQU   PSA+3668
PSASTAK  EQU   PSA+3072
@NM00051 EQU   PSA+1048
PSAUSEND EQU   PSA+1048
PSARV062 EQU   PSA+1044
PSACDAL  EQU   PSA+1040
PSAWTCOD EQU   PSA+1036
PSAATCVT EQU   PSA+1032
PSAPCPSW EQU   PSA+1024
PSAPIR2  EQU   PSA+1020
PSARV059 EQU   PSA+1018
PSASVC13 EQU   PSA+1016
PSALSFCC EQU   PSA+1012
PSASFACC EQU   PSA+1008
PSASTOP  EQU   PSA+992
PSASTART EQU   PSA+976
PSARSPSW EQU   PSA+968
PSASRPSW EQU   PSA+960
PSARV045 EQU   PSA+892
PSARV044 EQU   PSA+888
PSARV043 EQU   PSA+884
PSARV042 EQU   PSA+880
PSARV041 EQU   PSA+876
PSARV040 EQU   PSA+872
PSARV025 EQU   PSA+868
PSADSSED EQU   PSA+868
PSADSSPR EQU   PSA+864
PSADSSFW EQU   PSA+860
PSADSS14 EQU   PSA+856
PSADSSPP EQU   PSA+848
PSADSSRP EQU   PSA+840
PSADSS05 EQU   PSADSSF4
PSADSS10 EQU   PSADSSF4
PSADSSVE EQU   PSADSSF4
PSADSSDE EQU   PSADSSF4
PSADSSC0 EQU   PSADSSF4
PSADSSIE EQU   PSADSSF4
PSADSS12 EQU   PSADSSF4
PSADSSRC EQU   PSADSSF4
PSARV057 EQU   PSADSSF3
PSARV056 EQU   PSADSSF3
PSARV055 EQU   PSADSSF3
PSADSSMC EQU   PSADSSF3
PSADSSRW EQU   PSADSSF3
PSADSSNM EQU   PSADSSF3
PSADSSES EQU   PSADSSF3
PSADSSGP EQU   PSADSSF3
PSADSSF2 EQU   PSADSSFL+1
PSADSSPI EQU   PSADSSF1
PSADSSOI EQU   PSADSSF1
PSADSSSP EQU   PSADSSF1
PSADSSTP EQU   PSADSSF1
PSADSSDW EQU   PSADSSF1
PSADSSDD EQU   PSADSSF1
PSADSSDM EQU   PSADSSF1
PSADSSMV EQU   PSADSSF1
PSADSSTS EQU   PSA+816
PSADSSWK EQU   PSA+812
PSADSSR3 EQU   PSA+808
PSADSSR2 EQU   PSA+804
PSADSSRS EQU   PSA+800
PSASTOR  EQU   PSA+796
PSACPUSA EQU   PSA+794
PSAVSTAP EQU   PSA+792
PSAWKVAP EQU   PSA+788
PSAWKRAP EQU   PSA+784
PSAMCHIC EQU   PSA+783
PSARV061 EQU   PSA+782
PSASYMSK EQU   PSA+781
PSAMCHFL EQU   PSA+780
PSACR0   EQU   PSA+776
PSAPSWSV EQU   PSA+768
PSACLHS  EQU   PSAHLHI
PSALKR15 EQU   PSALKSA+60
PSALKR14 EQU   PSALKSA+56
PSALKR13 EQU   PSALKSA+52
PSALKR12 EQU   PSALKSA+48
PSALKR11 EQU   PSALKSA+44
PSALKR10 EQU   PSALKSA+40
PSALKR9  EQU   PSALKSA+36
PSALKR8  EQU   PSALKSA+32
PSALKR7  EQU   PSALKSA+28
PSALKR6  EQU   PSALKSA+24
PSALKR5  EQU   PSALKSA+20
PSALKR4  EQU   PSALKSA+16
PSALKR3  EQU   PSALKSA+12
PSALKR2  EQU   PSALKSA+8
PSALKR1  EQU   PSALKSA+4
PSALKR0  EQU   PSALKSA
PSARV023 EQU   PSACLHT+52
PSALOCAL EQU   PSACLHT+48
PSACMSL  EQU   PSACLHT+44
PSAOPTL  EQU   PSACLHT+40
PSATPACL EQU   PSACLHT+36
PSATPDNL EQU   PSACLHT+32
PSATPNCL EQU   PSACLHT+28
PSAIOSLL EQU   PSACLHT+24
PSAIOSUL EQU   PSACLHT+20
PSAIOSCL EQU   PSACLHT+16
PSAIOSSL EQU   PSACLHT+12
PSASALCL EQU   PSACLHT+8
PSAASML  EQU   PSACLHT+4
PSADISPL EQU   PSACLHT
PSASRSA  EQU   PSA+636
PSARV050 EQU   PSA+634
PSADSSGO EQU   PSA+633
PSARECUR EQU   PSA+632
PSAHLHIS EQU   PSA+628
PSAIPCSA EQU   PSA+624
@NM00050 EQU   PSA+621
PSAIPCDM EQU   PSA+620
PSAIPCD  EQU   PSA+616
@NM00049 EQU   PSA+613
PSAIPCRM EQU   PSA+612
PSAIPCR  EQU   PSA+608
PSAMCHEX EQU   PSA+600
PSAMPSW  EQU   PSA+592
PSAEXPS2 EQU   PSA+584
PSAEXPS1 EQU   PSA+576
PSAPIREG EQU   PSA+572
PSARSREG EQU   PSA+568
PSAGPREG EQU   PSA+556
PSARV022 EQU   PSASUP4
PSARV021 EQU   PSASUP4
PSARV020 EQU   PSASUP4
PSARV019 EQU   PSASUP4
PSARV018 EQU   PSASUP4
PSARV017 EQU   PSASUP4
PSARV016 EQU   PSASUP4
PSARV015 EQU   PSASUP4
PSARV014 EQU   PSASUP3
PSARV013 EQU   PSASUP3
PSARV012 EQU   PSASUP3
PSARV011 EQU   PSASUP3
PSASPR   EQU   PSASUP3
PSAPSREG EQU   PSASUP3
PSAPI2   EQU   PSASUP3
PSAIOSUP EQU   PSASUP3
PSALCR   EQU   PSASUP2
PSARTM   EQU   PSASUP2
PSAACR   EQU   PSASUP2
PSAIPCE2 EQU   PSASUP2
PSAIPCES EQU   PSASUP2
PSAIPCEC EQU   PSASUP2
PSAGTF   EQU   PSASUP2
PSAIPCRI EQU   PSASUP2
PSARV063 EQU   PSASUP1
PSATCTL  EQU   PSASUP1
PSADISP  EQU   PSASUP1
PSALOCK  EQU   PSASUP1
PSAPI    EQU   PSASUP1
PSAEXT   EQU   PSASUP1
PSASVC   EQU   PSASUP1
PSAIO    EQU   PSASUP1
PSAAOLD  EQU   PSA+548
PSAANEW  EQU   PSA+544
PSATOLD  EQU   PSA+540
PSATNEW  EQU   PSA+536
PSALCCAR EQU   PSA+532
PSALCCAV EQU   PSA+528
PSAPCCAR EQU   PSA+524
PSAPCCAV EQU   PSA+520
PSACPULA EQU   PSA+518
PSACPUPA EQU   PSA+516
PSAPSA   EQU   PSA+512
FLCHDEND EQU   PSA+512
FLCCRSAV EQU   FLCMCLA+280
FLCGRSAV EQU   FLCMCLA+216
FLCFPSAV EQU   FLCMCLA+184
FLCFLA   EQU   FLCMCLA+88
FLCRGNCD EQU   FLCMCLA+84
FLCFSAA  EQU   FLCFSA+1
@NM00048 EQU   FLCFSA
@NM00047 EQU   FLCMCLA+72
FLCMCIC  EQU   FLCMCLA+64
@NM00046 EQU   FLCMCLA+20
FLCIOAA  EQU   FLCIOA+1
@NM00045 EQU   FLCIOA
@NM00044 EQU   FLCMCLA+15
@NM00043 EQU   FLCMCLA+14
@NM00042 EQU   FLCMCLA+12
FLCLCL   EQU   FLCMCLA+8
FLCIOELA EQU   FLCIOEL+1
@NM00041 EQU   FLCIOEL
FLCCHNID EQU   FLCMCLA
@NM00040 EQU   PSA+160
FLCMTRCD EQU   PSA+157
@NM00039 EQU   PSA+156
FLCPERA  EQU   FLCPER+1
@NM00038 EQU   FLCPER
@NM00037 EQU   PSA+151
FLCPERCD EQU   PSA+150
FLCMCNUM EQU   PSA+149
@NM00036 EQU   PSA+148
FLCTEAA  EQU   FLCTEA+1
@NM00035 EQU   FLCTEA
PSAPIPC  EQU   PSAPICOD
PSAPIMC  EQU   PSAPICOD
PSAPIPER EQU   PSAPICOD
PSARV049 EQU   FLCPICOD
FLCPILCB EQU   FLCPIILC
@NM00034 EQU   FLCPIILC
@NM00033 EQU   PSAEPPSW
FLCSVCN  EQU   PSAESPSW+2
FLCSILCB EQU   FLCSVILC
@NM00032 EQU   FLCSVILC
@NM00031 EQU   PSAESPSW
FLCEICOD EQU   PSAEEPSW+2
PSASPAD  EQU   PSAEEPSW
@NM00030 EQU   PSA+128
FLCINPSW EQU   PSA+120
FLCMNPSW EQU   PSA+112
FLCPNPSW EQU   PSA+104
FLCSNPSW EQU   PSA+96
FLCENPSW EQU   PSA+88
FLCTRACE EQU   PSA+84
FLCTIMER EQU   PSA+80
FLCCVT2  EQU   PSA+76
FLCCAW   EQU   PSA+72
FLCCSW   EQU   PSA+64
FLCIOPSW EQU   PSA+56
FLCMOPSW EQU   PSA+48
FLCPOPSW EQU   PSA+40
FLCSOPSW EQU   PSA+32
FLCEOPSW EQU   PSA+24
@NM00029 EQU   FLCICCW2+4
FLCCVT   EQU   FLCICCW2
FLCICCW1 EQU   FLCROPSW
FLCIPPSW EQU   FLCRNPSW
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00554 EQU   @RC00552
@RC00565 EQU   @RC00552
@RC00844 EQU   @RC00842
@RC00847 EQU   @RC00842
@RC00857 EQU   @RC00856
@RC00862 EQU   @RC00860
@RC00867 EQU   @RC00862
@ENDDATA EQU   *
         END   ISTSQC04,(C'PLS2244',0701,77059)
