         TITLE 'ISTZAF1B/A1B-VS1/M1B-VS2: TPIOS LOGICAL UNIT SCHEDULER *
                        '
ISTZAF1B CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'ISTZAF1B  77.297'                                 0001
         DROP  @15
@PROLOG  DS    0H                                                  0002
         EJECT
*                                                                  0490
*/* THIS IS THE MAIN LINE OF THIS MODULE. IF SCHEDULING WAS ON THE 0490
*   ASYNCHRONOUS TPIOS PAB (ATOP) ALL LCPB'S ON THAT PAB WILL BE   0490
*   PROCESSED AND THEIR ASSOCIATED BUFFERS SHIPPED OUT TO THE NCP. 0490
*   IF SCHEDULING WAS ON THE SYNCHRONOUS PAB AND THE ASYNCRONOUS   0490
*   PAB IS EMPTY THE ELEMENTS WILL BE PROCESSED FROM THAT PAB.     0490
*   OTHERWISE THE MODULE WILL EXIT IMMEDIATELY.  IF THE PACING     0490
*   LIMIT IS REACHED NO FURTHER PSS SCHEDULING WILL BE REQUESTED   0490
*   UNTIL THE PACING RESPONSE FOR THAT UNIT IS RECEIVED.             */
*/* TPZENTER  FRR(OUT)AC(AC1B)SAVES(6)ZCR(ZCRREG)                    */
*                                                                  0490
*   DO;                                                            0490
*                                                                  0490
*/* ATBUILD (ISTZSAVE,ISTZCRR)                                       */
*/* END OF ATBUILD                                                   */
*/* ATBUILD (ISTRPH,ISTCRA)                                          */
*/* END OF ATBUILD                                                   */
*                                                                  0491
*     DCL                                                          0491
*       GPR00F FIXED(31) REG(00);                                  0491
*     DCL                                                          0492
*       GPR00P PTR(31) REG(00);                                    0492
*     DCL                                                          0493
*       GPR01F FIXED(31) REG(01);                                  0493
*     DCL                                                          0494
*       GPR01P PTR(31) REG(01);                                    0494
*     DCL                                                          0495
*       GPR02F FIXED(31) REG(02);                                  0495
*     DCL                                                          0496
*       GPR02P PTR(31) REG(02);                                    0496
*     DCL                                                          0497
*       GPR03F FIXED(31) REG(03);                                  0497
*     DCL                                                          0498
*       GPR03P PTR(31) REG(03);                                    0498
*     DCL                                                          0499
*       GPR04F FIXED(31) REG(04);                                  0499
*     DCL                                                          0500
*       GPR04P PTR(31) REG(04);                                    0500
*     DCL                                                          0501
*       GPR05F FIXED(31) REG(05);                                  0501
*     DCL                                                          0502
*       GPR05P PTR(31) REG(05);                                    0502
*     DCL                                                          0503
*       GPR06F FIXED(31) REG(06);                                  0503
*     DCL                                                          0504
*       GPR06P PTR(31) REG(06);                                    0504
*     DCL                                                          0505
*       GPR07F FIXED(31) REG(07);                                  0505
*     DCL                                                          0506
*       GPR07P PTR(31) REG(07);                                    0506
*     DCL                                                          0507
*       GPR12F FIXED(31) REG(12);                                  0507
*     DCL                                                          0508
*       GPR12P PTR(31) REG(12);                                    0508
*     DCL                                                          0509
*       GPR13F FIXED(31) REG(13);                                  0509
*     DCL                                                          0510
*       GPR13P PTR(31) REG(13);                                    0510
*     DCL                                                          0511
*       GPR15F FIXED(31) REG(15);                                  0511
*     DCL                                                          0512
*       GPR15P PTR(31) REG(15);                                    0512
*     RFY                                                          0513
*      (GPR00P,                                                    0513
*       GPR01P,                                                    0513
*       GPR02P,                                                    0513
*       GPR03P,                                                    0513
*       GPR04P,                                                    0513
*       GPR05P,                                                    0513
*       GPR06P,                                                    0513
*       GPR07P,                                                    0513
*       GPR12P,                                                    0513
*       GPR13P,                                                    0513
*       GPR15P) RSTD;                                              0513
*     GEN SETS(GPR12P);                                            0514
*                     /* ESTABLISH BASE */
          BALR  GPR12P,0
          USING *,GPR12P
*     DO;                           /* LISATCVT                    0515
*                                      CVTBASE(PAGEABLE,(GPR02P))    */
*       GPR02P=ATCLCPTR;            /* SET UP ATCVT POINTER          */
         L     GPR02P,ATCLCPTR                                     0516
*     END;                          /* LISATCVT                      */
*     GPR03P=GPR01P->RPHCRR;        /* ADDRESS CRA                   */
         L     GPR03P,RPHCRR(,GPR01P)                              0518
*     GPR04P=ADDR(GPR03P->CRAPROCR);/* ADDRESS ZCRR                  */
         LA    GPR04P,CRAPROCR(,GPR03P)                            0519
*     GPR06P=GPR04P;                /* INITIALIZE ZCR POINTER        */
         LR    GPR06P,GPR04P                                       0520
*     GPR05P=LENGTH(ISTZCRR);       /* SETUP ZCRR LENGTH             */
         LA    GPR05P,536                                          0521
*     GPR07P=0;                     /* ZERO REG 7                    */
         SLR   GPR07P,GPR07P                                       0522
*     MVCL(GPR04P,GPR06P);          /* CLEAR ZCRR                    */
         MVCL  GPR04P,GPR06P                                       0523
*     GPR04P=ADDR(GPR03P->CRAPROCR);/* ADDRESS ZCRR                  */
         LA    GPR04P,CRAPROCR(,GPR03P)                            0524
*     GPR04P->ZCRFRRA=GPR03P->CRAFRR;/* SAVE CURRENT FRR POINTER     */
         L     @14,CRAFRR(,GPR03P)                                 0525
         ST    @14,ZCRFRRA(,GPR04P)                                0525
*     GPR03P->CRAFRR=0;             /* CLEAR FRR POINTER             */
         SLR   @14,@14                                             0526
         ST    @14,CRAFRR(,GPR03P)                                 0526
*     GPR04P->ZCROB='1'B;           /* SET OUTBOUND FLAG             */
         OI    ZCROB(GPR04P),B'00010000'                           0527
*     GPR04P->ZCRCHAIN=GPR03P->CRACRR;/* SAVE CURRENT CRR            */
         L     @11,CRACRR(,GPR03P)                                 0528
         ST    @11,ZCRCHAIN(,GPR04P)                               0528
*     GPR03P->CRACRR=GPR04P;        /* SET ZCRR AS CURRENT CRR       */
         ST    GPR04P,CRACRR(,GPR03P)                              0529
*     GPR04P->ZCRID=ZCTYPE;         /* INDICATE CRR AS ZCRR          */
         MVI   ZCRID(GPR04P),X'00'                                 0530
*     GPR04P->ZCRLEN=ZCLNG;         /* SET ZCRR LENGTH               */
         MVC   ZCRLEN(2,GPR04P),@CH02124                           0531
*     GPR04P->ZCRTID=ZCRTAC1B;      /* SET THREAD ID                 */
         MVI   ZCRTID(GPR04P),X'0E'                                0532
*     GPR04P->ZCREAC1B='1'B;        /* SET MODULE ENTERED            */
         OI    ZCREAC1B(GPR04P),B'00010000'                        0533
*     GPR04P->ZCRTNAME='AC1B';      /* SET THREAD NAME               */
         MVC   ZCRTNAME(4,GPR04P),@CC04195                         0534
*     GPR05P=ADDR(GPR04P->ZCRSAVEZ);/* ADDR 1ST BUFF                 */
         LA    GPR05P,ZCRSAVEZ(,GPR04P)                            0535
*     GPR06P=0;                     /* ADDRESS PREVIOUS BUFFER       */
         LR    GPR06P,@14                                          0536
*     DO GPR00P=6 TO 1 BY-1;        /* INITIALIZE SAVE AREAS         */
         LA    GPR00P,6                                            0537
@DL00537 DS    0H                                                  0538
*       GPR05P->ZSAZSVBC=GPR06P;    /* SET BACK POINTER              */
         ST    GPR06P,ZSAZSVBC(,GPR05P)                            0538
*       GPR05P->ZSAZSVFC=GPR05P+ZSAZSVSZ;/* SET FWRD PTR             */
         LA    @14,40                                              0539
         LR    @11,GPR05P                                          0539
         ALR   @11,@14                                             0539
         ST    @11,ZSAZSVFC(,GPR05P)                               0539
*       GPR06P=GPR05P;              /* PREV. BUFF = CURRENT BUFF     */
         LR    GPR06P,GPR05P                                       0540
*       GPR05P=GPR05P+ZSAZSVSZ;     /* POINT TO NEXT BUFF            */
         ALR   GPR05P,@14                                          0541
*     END;                          /* END SAVE AREA INITIALIZING    */
         BCTR  GPR00P,0                                            0542
         LTR   GPR00P,GPR00P                                       0542
         BP    @DL00537                                            0542
*     GPR06P->ZSAZSVFC=0;           /* SET LAST FWRD POINTER         */
         SLR   @14,@14                                             0543
         ST    @14,ZSAZSVFC(,GPR06P)                               0543
*     GPR13P=ADDR(GPR04P->ZCRSAVEZ);/* ADDRESS SAVE AREA CHAIN       */
         LA    GPR13P,ZCRSAVEZ(,GPR04P)                            0544
*     ZCRREG=GPR04P;                /* ADDRESS ZCRR                  */
         LR    ZCRREG,GPR04P                                       0545
*     RFY                                                          0546
*      (GPR00P,                                                    0546
*       GPR01P,                                                    0546
*       GPR02P,                                                    0546
*       GPR03P,                                                    0546
*       GPR04P,                                                    0546
*       GPR05P,                                                    0546
*       GPR06P,                                                    0546
*       GPR07P,                                                    0546
*       GPR12P,                                                    0546
*       GPR13P,                                                    0546
*       GPR15P) UNRSTD;                                            0546
*   END;                            /* END TPZENTER GENERATION       */
*   PTRFMC=RPHMAJCB;                /* ADDRESS FMCB                  */
         L     PTRFMC,RPHMAJCB-1(,PTRRPH)                          0548
         LA    PTRFMC,0(,PTRFMC)                                   0548
*   PTRLUN=FMCDNCBA;                /* GETTING & RELEASING OF LUNCB
*                                      LK REMOVED BY DCR 4207      0549
*                                                            @Z40GKD7*/
         L     PTRLUN,FMCDNCBA(,PTRFMC)                            0549
*/*** START -TPLOCK (FMCLOCK)TYPE(XCLSIVE)- **                       */
*                                                                  0550
*   DO;                                                            0550
*     DCL                                                          0551
*       GPR08F FIXED(31) REG(08);                                  0551
*     DCL                                                          0552
*       GPR08P PTR(31) REG(08);                                    0552
*     DCL                                                          0553
*       GPR09F FIXED(31) REG(09);                                  0553
*     DCL                                                          0554
*       GPR09P PTR(31) REG(09);                                    0554
*     DCL                                                          0555
*       GPR10F FIXED(31) REG(10);                                  0555
*     DCL                                                          0556
*       GPR10P PTR(31) REG(10);                                    0556
*     DCL                                                          0557
*       GPR11F FIXED(31) REG(11);                                  0557
*     DCL                                                          0558
*       GPR11P PTR(31) REG(11);                                    0558
*     DCL                                                          0559
*       GPR14F FIXED(31) REG(14);                                  0559
*     DCL                                                          0560
*       GPR14P PTR(31) REG(14);                                    0560
*     RFY                                                          0561
*      (GPR00P,                                                    0561
*       GPR01P,                                                    0561
*       GPR02P,                                                    0561
*       GPR03P,                                                    0561
*       GPR04P,                                                    0561
*       GPR15P) RSTD;                                              0561
*     GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(RPHWORK);   0562
         STM GPR00P,GPR14P,RPHWORK(GPR01P)
*     GPR02P=ADDR(FMCLOCK);         /* SET PARAM - LOCKWORD PTR      */
         LA    GPR02P,FMCLOCK(,PTRFMC)                             0563
*     GPR04P=GPR01P->RPHCRR;        /* SET PARAM - ISTCRA PTR        */
         L     GPR04P,RPHCRR(,GPR01P)                              0564
*     GPR00P=CRALMS04;              /* SET PARAM - LOCK LEVEL FLAG   */
         LA    GPR00P,8                                            0565
*     GPR03P=ADDR(GPR04P->CRAL4PTR);/* SET PARAM - LOCK LEVEL PTR    */
         LA    GPR03P,CRAL4PTR(,GPR04P)                            0566
*     GPR15P=ATCLCPTR->ATCAP36;     /* ADDRESS OF LOCK ROUTINE       */
         L     @11,ATCLCPTR                                        0567
         L     GPR15P,ATCAP36(,@11)                                0567
*     DCL                                                          0568
*       FMZL0026 BASED(GPR15P) LABEL VALUERANGE(*);                0568
*     CALL FMZL0026;                                               0569
         BALR  @14,@15                                             0569
*     GENERATE REFS(GPR00P,GPR01P,GPR14P,RPHWORK) SETS(GPR00P,GPR01P,
*         GPR02P,GPR03P,GPR04P,GPR05P,GPR06P,GPR07P,GPR08P,GPR09P, 0570
*         GPR10P,GPR11P,GPR12P,GPR13P,GPR14P,GPR15P);              0570
         LM GPR00P,GPR15P,RPHWORK(GPR01P)
*     RFY                                                          0571
*      (GPR00P,                                                    0571
*       GPR01P,                                                    0571
*       GPR02P,                                                    0571
*       GPR03P,                                                    0571
*       GPR04P,                                                    0571
*       GPR15P) UNRSTD;                                            0571
*   END;                                                           0572
*                                                                  0572
*/*** END -TPLOCK (FMCLOCK)TYPE(XCLSIVE)- **                         */
*                                                                  0573
*   /*****************************************************************/
*   /*                                                               */
*   /* SEGMENT(AF1B010)REQUEST                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0573
*   DO;                                                            0573
*     GOTO AF1B010;                                                0574
         B     AF1B010                                             0574
*AF1B010#:                                                         0575
*   END;                                                           0575
AF1B010# DS    0H                                                  0576
*LOOP1:                                                            0576
*   DO WHILE(ZCRENDSH='0'B);        /* PROCESS DATA                  */
LOOP1    B     @DE00576                                            0576
@DL00576 DS    0H                                                  0577
*     IF RPHPABOF=ATOP THEN         /* IF SCHEDULED FROM ATOP        */
         CLC   RPHPABOF(1,PTRRPH),ATOP                             0577
         BNE   @RF00577                                            0577
*       IF FMCASCDQ^=0 THEN         /* IF ANYTHING ON ASCHED QUEUE   */
         L     @14,FMCASCDQ-1(,PTRFMC)                             0578
         LA    @14,0(,@14)                                         0578
         LTR   @14,@14                                             0578
         BZ    @RF00578                                            0578
*         CALL AF1B020;             /* PROCESS ASCHED QUEUE          */
         BAL   @14,AF1B020                                         0579
*       ELSE                        /* ASYNCH SCHED QUEUE IS EMPTY   */
*         IF ADDR(FMCPAB5)->PABWEQP^=0 THEN/* ANYTHING ON ASY. TOP ? */
*                                                                  0580
         B     @RC00578                                            0580
@RF00578 L     @14,PABWEQP+127(,PTRFMC)                            0580
         LA    @14,0(,@14)                                         0580
         LTR   @14,@14                                             0580
         BZ    @RF00580                                            0580
*           /*********************************************************/
*           /*                                                       */
*           /* SEGMENT(AF1B030)REQUEST                               */
*           /*                                                       */
*           /*********************************************************/
*                                                                  0581
*           DO;                                                    0581
*             GOTO AF1B030;                                        0582
         B     AF1B030                                             0582
*AF1B030#:                                                         0583
*           END;                    /* PROCESS ATOP ELEMENTS         */
*         ELSE                      /* IF NOTHING ON ATOP            */
*           DO;                                                    0584
         B     @RC00580                                            0584
@RF00580 DS    0H                                                  0585
*             ZCRENDSH='1'B;        /* EXIT LOOP                     */
*             ZCREXTYP='1'B;        /* REQUEST PSS SCHEDULING        */
         OI    ZCRENDSH(ZCRREG),B'11000000'                        0586
*             IF ADDR(FMCPAB3)->PABWEQA^=0/* IF WORK WAITING@ZA26900
*                                      ON THE FMCB TOP       @ZA26900*/
*                 |(FMCSHEDQ&GATEOFF)^=0 THEN/* OR WORK      @ZA26900
*                                      WAITING ON SCHEDULE Q @ZA26900*/
         SLR   @14,@14                                             0587
         C     @14,PABWEQA+96(,PTRFMC)                             0587
         BNE   @RT00587                                            0587
         L     @11,FMCSHEDQ(,PTRFMC)                               0587
         N     @11,@CF04161                                        0587
         CR    @11,@14                                             0587
         BE    @RF00587                                            0587
@RT00587 DS    0H                                                  0588
*/* TPSCHED (ADDR(FMCPAB3)) UNCOND                                   */
*                                                                  0588
*               DO;                                                0588
*                 RFY                                              0589
*                  (GPR00P,                                        0589
*                   GPR01P,                                        0589
*                   GPR05P) RSTD;                                  0589
*                 GEN REFS(GPR01P) SETS(RPHWORK)                   0590
*                     (STM   GPR02P,GPR08P,RPHWORK(GPR01P));       0590
         STM   GPR02P,GPR08P,RPHWORK(GPR01P)
*                 GPR00P=0;                                        0591
         SLR   GPR00P,GPR00P                                       0591
*                 GPR05P=ADDR(FMCPAB3);                            0592
         LA    @14,FMCPAB3(,PTRFMC)                                0592
         LR    GPR05P,@14                                          0592
*                 CALL ATCLCPTR->ATCAP38->ISTAPC38;                0593
         L     @11,ATCLCPTR                                        0593
         L     @15,ATCAP38(,@11)                                   0593
         BALR  @14,@15                                             0593
*                 GEN(NOPR 1)                                      0594
*                 NOSETS NOREFS;                                   0594
         NOPR 1
*                 RFY                                              0595
*                  (GPR00P,                                        0595
*                   GPR01P,                                        0595
*                   GPR05P) UNRSTD;                                0595
*               END;                /* **** END TPSCHED SCHEDULE   0596
*                                                            @ZA26900
*                                      THE FMCB TOP          @ZA26900*/
*           END;                                                   0597
*     ELSE                          /* NOT SCHEDULED FROM ATOP       */
*       IF ADDR(FMCPAB5)->PABWEQP^=0&(FMCSHEDQ&GATEOFF)=0 THEN/* IF
*                                      ANYTHING ON ATOP      @XM09494*/
         B     @RC00577                                            0598
@RF00577 L     @14,PABWEQP+127(,PTRFMC)                            0598
         LA    @14,0(,@14)                                         0598
         LTR   @14,@14                                             0598
         BZ    @RF00598                                            0598
         L     @14,FMCSHEDQ(,PTRFMC)                               0598
         N     @14,@CF04161                                        0598
         LTR   @14,@14                                             0598
         BNZ   @RF00598                                            0598
*         ZCRENDSH='1'B;            /* FLAG EXIT FROM LOOP           */
         OI    ZCRENDSH(ZCRREG),B'10000000'                        0599
*       ELSE                        /* ATOP AND SCHED QUEUE EMPTY    */
*         IF(FMCSHEDQ&GATEOFF)^=0 THEN/* ANYTHING ON SYNCH. SCHED Q  */
         B     @RC00598                                            0600
@RF00598 L     @14,FMCSHEDQ(,PTRFMC)                               0600
         N     @14,@CF04161                                        0600
         LTR   @14,@14                                             0600
         BZ    @RF00600                                            0600
*           CALL AF1B020;                                          0601
         BAL   @14,AF1B020                                         0601
*         ELSE                      /* SCHEDQ IS EMPTY               */
*           IF ADDR(FMCPAB3)->PABWEQP^=0 THEN/* ANYTHING ON SYNCH. 0602
*                                      TOP ?                         */
*                                                                  0602
         B     @RC00600                                            0602
@RF00600 L     @14,PABWEQP+95(,PTRFMC)                             0602
         LA    @14,0(,@14)                                         0602
         LTR   @14,@14                                             0602
         BZ    @RF00602                                            0602
*             /*******************************************************/
*             /*                                                     */
*             /* SEGMENT(AF1B035)REQUEST                             */
*             /*                                                     */
*             /*******************************************************/
*                                                                  0603
*             DO;                                                  0603
*               GOTO AF1B035;                                      0604
         B     AF1B035                                             0604
*AF1B035#:                                                         0605
*             END;                                                 0605
*           ELSE                    /* IF TOP IS EMPTY               */
*             DO;                                                  0606
         B     @RC00602                                            0606
@RF00602 DS    0H                                                  0607
*               ZCRENDSH='1'B;      /* TOP EMPTY SO EXIT             */
*               ZCREXTYP='1'B;      /* REQUEST PSS SCHEDULING        */
         OI    ZCRENDSH(ZCRREG),B'11000000'                        0608
*             END;                                                 0609
*   END LOOP1;                                                     0610
*                                                                  0610
@RC00602 DS    0H                                                  0610
@RC00600 DS    0H                                                  0610
@RC00598 DS    0H                                                  0610
@RC00577 DS    0H                                                  0610
@DE00576 TM    ZCRENDSH(ZCRREG),B'10000000'                        0610
         BZ    @DL00576                                            0610
*/*** START -TPUNLOCK (FMCLOCK)- **                                  */
*                                                                  0611
*   DO;                                                            0611
*                                                                  0611
*/* ATBUILD (ISTRPH,ISTLOK,ISTCRA)                                   */
*/* END OF ATBUILD                                                   */
*                                                                  0612
*     RFY                                                          0612
*      (GPR00P,                                                    0612
*       GPR01P,                                                    0612
*       GPR02P,                                                    0612
*       GPR03P,                                                    0612
*       GPR04P,                                                    0612
*       GPR15P) RSTD;                                              0612
*     GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(RPHWORK);   0613
         STM GPR00P,GPR15P,RPHWORK(GPR01P)
*     GPR02P=ADDR(FMCLOCK);         /* SET PARAM - LOCKWORD PTR      */
         LA    GPR02P,FMCLOCK(,PTRFMC)                             0614
*     GPR04P=GPR01P->RPHCRR;        /* SET PARAM - ISTCRA PTR        */
         L     GPR04P,RPHCRR(,GPR01P)                              0615
*     GPR00P=CRALMS04;              /* SET PARAM - LOCK LEVEL FLAG   */
         LA    GPR00P,8                                            0616
*     GPR03P=ADDR(GPR04P->CRAL4PTR);/* SET PARAM - LOCK LEVEL PTR    */
         LA    GPR03P,CRAL4PTR(,GPR04P)                            0617
*     DO;                           /* LISATCVT                    0618
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*       GPR15P=ATCLCPTR;            /* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     0619
*     END;                          /* LISATCVT                      */
*     GPR15P=GPR15P->ATCAP33;                                      0621
         L     GPR15P,ATCAP33(,GPR15P)                             0621
*     DCL                                                          0622
*       FMZL0040 BASED(GPR15P) LABEL VALUERANGE(*);                0622
*     CALL FMZL0040;                                               0623
         BALR  @14,@15                                             0623
*     GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(GPR00P,GPR01P,
*         GPR02P,GPR03P,GPR04P,GPR05P,GPR06P,GPR07P,GPR08P,GPR09P, 0624
*         GPR10P,GPR11P,GPR12P,GPR13P,GPR14P,GPR15P);              0624
         LM GPR00P,GPR15P,RPHWORK(GPR01P)
*     RFY                                                          0625
*      (GPR00P,                                                    0625
*       GPR01P,                                                    0625
*       GPR02P,                                                    0625
*       GPR03P,                                                    0625
*       GPR04P,                                                    0625
*       GPR15P) UNRSTD;                                            0625
*   END;                                                           0626
*                                                                  0626
*/*** END -TPUNLOCK (FMCLOCK)- **                                    */
*                                                                  0627
*   IF ZCREXTYP='1'B THEN           /* IF EXIT WITH SCHEDULING       */
         TM    ZCREXTYP(ZCRREG),B'01000000'                        0627
         BNO   @RF00627                                            0627
*/* TPEXIT  NORM                                                     */
*                                                                  0628
*     DO;                                                          0628
*       RESPECIFY                                                  0629
*         GPR15P RSTD;                                             0629
*                                                                  0629
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTATCVT)                               */
*/* END OF ATBUILD                                                   */
*                                                                  0630
*       DO;                         /* LISATCVT                    0630
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*         GPR15P=ATCLCPTR;          /* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     0631
*       END;                        /* LISATCVT                      */
*       RESPECIFY                                                  0633
*         GPR00F RSTD;                                             0633
*       GPR00F=4;                   /* SET PARAMETER REGISTER TO 4   */
         LA    GPR00F,4                                            0634
*       GPR15P=GPR15P->ATCAP31;                                    0635
         L     GPR15P,ATCAP31(,GPR15P)                             0635
*       DCL                                                        0636
*         FMZL0050 BASED(GPR15P) LABEL VALUERANGE(*);              0636
*       CALL FMZL0050;                                             0637
         BALR  @14,@15                                             0637
*       RESPECIFY                                                  0638
*        (GPR00F,                                                  0638
*         GPR15P) UNRSTD;                                          0638
*     END;                          /* **** END OF TPEXIT EXIT WITH
*                                      SCHEDULING                    */
*   ELSE                            /* OTHERWISE                     */
*/* TPEXIT  NONE                                                     */
*                                                                  0640
*     DO;                                                          0640
         B     @RC00627                                            0640
@RF00627 DS    0H                                                  0641
*       RESPECIFY                                                  0641
*         GPR15P RSTD;                                             0641
*                                                                  0641
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTATCVT)                               */
*/* END OF ATBUILD                                                   */
*                                                                  0642
*       DO;                         /* LISATCVT                    0642
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*         GPR15P=ATCLCPTR;          /* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     0643
*       END;                        /* LISATCVT                      */
*       RESPECIFY                                                  0645
*         GPR00F RSTD;                                             0645
*       GPR00F=0;                   /* SET PARAMETER REGISTER TO 0   */
         SLR   GPR00F,GPR00F                                       0646
*       GPR15P=GPR15P->ATCAP31;                                    0647
         L     GPR15P,ATCAP31(,GPR15P)                             0647
*       DCL                                                        0648
*         FMZL0058 BASED(GPR15P) LABEL VALUERANGE(*);              0648
*       CALL FMZL0058;                                             0649
         BALR  @14,@15                                             0649
*       RESPECIFY                                                  0650
*        (GPR00F,                                                  0650
*         GPR15P) UNRSTD;                                          0650
*     END;                          /* **** END OF TPEXIT EXIT     0651
*                                      WITHOUT SCHEDULING            */
         EJECT
*                                                                  0652
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT-                                                         */
*/*      SEG0010                                                     */
*/*                                                                  */
*/* FUNCTION-                                                        */
*/*      THIS SEGMENT PROVIDES INITIALIZATION FOR OTHER ROUTINES     */
*/*      AND SUBROUTINES WHICH ARE CALLED BY THIS MODULE.            */
*/*      SWITCHES IN THE ZCR ARE INITIALIZED FOR THIS MODULE,        */
*/*      REGISTERS ARE ALSO INITIALIZED WHICH ARE USED               */
*/*      THROUGHOUT TPIOS OUTBOUND PROCESSING.                       */
*/*                                                                  */
*/********************************************************************/
*                                                                  0652
*   /*****************************************************************/
*   /*                                                               */
*   /* SEGMENT(AF1B010)START                                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0652
*   DO;                                                            0652
@RC00627 DS    0H                                                  0653
*     GOTO AF1B010@;                                               0653
         B     AF1B010@                                            0653
*AF1B010:                                                          0654
*   END;                                                           0654
AF1B010  DS    0H                                                  0655
*   PTRICN=PTRLUN;                  /* ADDRESS ICNCB                 */
         LR    PTRICN,PTRLUN                                       0655
*   DO WHILE(PTRICN->NCBTYPE^=ICTYPE);                             0656
         B     @DE00656                                            0656
@DL00656 DS    0H                                                  0657
*     PTRICN=PTRICN->NCBNSNA;       /* LOOP UNTIL ICNCB FOUND        */
         L     PTRICN,NCBNSNA(,PTRICN)                             0657
*   END;                            /* ICNCB FOUND                   */
@DE00656 CLI   NCBTYPE(PTRICN),X'06'                               0658
         BNE   @DL00656                                            0658
*   ZCRSHEDI='1'B;                  /* NO DIALOG SCHEDULING          */
*                                                                  0659
         OI    ZCRSHEDI(ZCRREG),B'01000000'                        0659
*   /*****************************************************************/
*   /*                                                               */
*   /* SEGMENT(AF1B010)FINISH                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0660
*   DO;                                                            0660
*     GOTO AF1B010#;                                               0661
         B     AF1B010#                                            0661
*AF1B010@:                                                         0662
*   END;                                                           0662
         EJECT
*                                                                  0663
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT-                                                         */
*/*      AF1B020                                                     */
*/*                                                                  */
*/* FUNCTION-                                                        */
*/*      THIS ROUTINE TRANSFERS ELEMENTS FROM THE SCHEDULE Q TO THE  */
*/*      THE WAITQ IF A RESPONSE FROM THE NCP IS EXPECTED. FOR FM    */
*/*      DATA REQUESTS PACING IS CHECKED. AND SHIPOUT IS CALLED      */
*/*      TO SEND ANY BUFFERS TO THE NCP.                             */
*/*                                                                  */
*/********************************************************************/
*                                                                  0663
*AF1B020:                                                          0663
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0663
         B     @PB00002                                            0663
AF1B020  DS    0H                                                  0664
*   RFY                                                            0664
*     LNKREG RSTD;                                                 0664
*   ZCRSVF1=LNKREG;                 /* SAVE RETURN ADDRESS           */
         ST    LNKREG,ZCRSVF1(,ZCRREG)                             0665
*   RFY                                                            0666
*     LNKREG UNRSTD;                                               0666
*   RFY                                                            0667
*    (WKREG8,                                                      0667
*     WKREG9) RSTD;                                                0667
*   IF RPHPABOF=ATOP THEN           /* IF SCHEDULED FROM ATOP        */
         CLC   RPHPABOF(1,PTRRPH),ATOP                             0668
         BNE   @RF00668                                            0668
*     DO;                           /* IF SCHEDULED FROM ATOP        */
*       WKREG8=ADDR(FMCSHEAQ);      /* SET UP PARAMS FOR Q XFER TO   */
         LA    WKREG8,FMCSHEAQ(,PTRFMC)                            0670
*       WKREG9=ADDR(FMCLCPAQ);      /* XFER FROM SCHEDQ TO WAITQ     */
         LA    WKREG9,FMCLCPAQ(,PTRFMC)                            0671
*     END;                                                         0672
*   ELSE                            /* NOT SCHEDULED FROM ATOP       */
*     DO;                                                          0673
         B     @RC00668                                            0673
@RF00668 DS    0H                                                  0674
*       WKREG8=ADDR(FMCSHEDQ);      /* SET UP PARAMS FOR Q XFER TO   */
         LA    WKREG8,FMCSHEDQ(,PTRFMC)                            0674
*       WKREG9=ADDR(FMCLCPBQ);      /* XFER FROM SCHEDQ TO WAITQ     */
         LA    WKREG9,FMCLCPBQ(,PTRFMC)                            0675
*     END;                                                         0676
*                                                                  0676
*/* TPFEL (,WKREG8->QUEHDR) RETPTR(PTRLCP)                           */
*                                                                  0677
*   DO;                             /* BEGIN TPFEL CODE GENERATION   */
@RC00668 DS    0H                                                  0678
*     DCL                                                          0678
*       FMZCA068 BIT(32) CONSTANT('80000000'X);                    0678
*     DCL                                                          0679
*       FMZCB068 BIT(32) CONSTANT('7FFFFFFF'X);                    0679
*     RFY                                                          0680
*      (GPR00P,                                                    0680
*       GPR01P,                                                    0680
*       GPR14P,                                                    0680
*       GPR15P) RSTD;                                              0680
*     GPR15P=ADDR(WKREG8->QUEHDR);  /* ADDRESS QUEUE POINTER         */
         LR    GPR15P,WKREG8                                       0681
*     GPR14P=GPR15P->PABWEQA|FMZCA068;                             0682
         L     @11,@CF02384                                        0682
         L     GPR14P,PABWEQA(,GPR15P)                             0682
         OR    GPR14P,@11                                          0682
*     IF GPR14P=FMZCA068 THEN                                      0683
         CLR   GPR14P,@11                                          0683
         BE    @RT00683                                            0683
*       ;                                                          0684
*     ELSE                                                         0685
*       DO;                                                        0685
*         GPR00P=FMZCA068;          /* INITIALIZE QUIT FLAG          */
         L     GPR00P,@CF02384                                     0686
*         DO WHILE(GPR00P^=GPR14P->WKECHAIN);                      0687
         B     @DE00687                                            0687
@DL00687 DS    0H                                                  0688
*           GPR14P=GPR14P->WKECHAIN;/* SEARCH FOR END OF CHAIN       */
         L     GPR14P,WKECHAIN(,GPR14P)                            0688
*         END;                                                     0689
@DE00687 C     GPR00P,WKECHAIN(,GPR14P)                            0689
         BNE   @DL00687                                            0689
*       END;                                                       0690
*     GPR14P=GPR14P&FMZCB068;                                      0691
@RT00683 N     GPR14P,@CF02476                                     0691
*     PTRLCP=GPR14P;                                               0692
         LR    PTRLCP,GPR14P                                       0692
*     RFY                                                          0693
*      (GPR00P,                                                    0693
*       GPR01P,                                                    0693
*       GPR14P,                                                    0693
*       GPR15P) UNRSTD;                                            0693
*   END;                            /* END TPFEL GENERATION ADDRESS
*                                      WORK ELEMENT          @XM18976*/
*   PTRZOB=LSCFDBA;                 /* ADDRESS ELEMENT BUFFER        */
         L     PTRZOB,LSCFDBA(,PTRLSC)                             0695
*   IF RHQS='0'B                    /* BUFFER FOR REQUEST            */
*       &RPHPABOF=TOP               /* SCHEDULED FROM TOP            */
*       &(FMCPURCH='0'B|RHCHAIN^='00'B)/* & NOT PURGING CHAIN STATE
*                                                            @ZA03704*/
*       &FMCNPCNT^=0                /* PACING                        */
*       &FMCMPCNT^=0 THEN                                          0696
         LA    @14,38                                              0696
         ALR   @14,PTRZOB                                          0696
         TM    RHQS(@14),B'10000000'                               0696
         BNZ   @RF00696                                            0696
         CLC   RPHPABOF(1,PTRRPH),TOP                              0696
         BNE   @RF00696                                            0696
         TM    FMCPURCH(PTRFMC),B'00000010'                        0696
         BZ    @GL00004                                            0696
         TM    RHCHAIN(@14),B'00000011'                            0696
         BZ    @RF00696                                            0696
@GL00004 CLI   FMCNPCNT(PTRFMC),0                                  0696
         BE    @RF00696                                            0696
         CLI   FMCMPCNT(PTRFMC),0                                  0696
         BE    @RF00696                                            0696
*     DO;                           /* REQUESTED                     */
*       FMCCPCNT=FMCCPCNT+1;        /* BUMP PACING COUNT             */
         LA    @14,1                                               0698
         SLR   @11,@11                                             0698
         IC    @11,FMCCPCNT(,PTRFMC)                               0698
         ALR   @14,@11                                             0698
         STC   @14,FMCCPCNT(,PTRFMC)                               0698
*       IF FMCCPCNT=FMCMPCNT THEN   /* PACING RESPONSE NEEDED ?      */
         CLC   FMCCPCNT(1,PTRFMC),FMCMPCNT(PTRFMC)                 0699
         BNE   @RF00699                                            0699
*         RHPACE='1'B;                                             0700
         OI    RHPACE+38(PTRZOB),B'00000001'                       0700
*       ELSE                                                       0701
*         ;                                                        0701
@RF00699 DS    0H                                                  0702
*       IF FMCCPCNT>FMCNPCNT THEN   /* PREVIOUSLY REQUESTED PACING 0702
*                                      RESPONSE NOT RECEIVED ?       */
         CLC   FMCCPCNT(1,PTRFMC),FMCNPCNT(PTRFMC)                 0702
         BNH   @RF00702                                            0702
*         ZCRENDSH='1'B;            /* EXIT WITH NO PSS SCHEDULING   */
         OI    ZCRENDSH(ZCRREG),B'10000000'                        0703
*       ELSE                                                       0704
*         ;                                                        0704
@RF00702 DS    0H                                                  0705
*     END;                                                         0705
*   ELSE                                                           0706
*     ;                                                            0706
@RF00696 DS    0H                                                  0707
*   IF ZCRENDSH='1'B THEN                                          0707
         TM    ZCRENDSH(ZCRREG),B'10000000'                        0707
         BO    @RT00707                                            0707
*     ;                             /* EXIT IF REQUIRED              */
*   ELSE                                                           0709
*     DO;                                                          0709
*       LSCFDBA=0;                  /* NO BUFFER THIS ELEMENT        */
         SLR   @14,@14                                             0710
         ST    @14,LSCFDBA(,PTRLSC)                                0710
*       IF(RPHPABOF=TOP&            /* SCHEDULED FROM TOP            */
*           FMCPURCH='1'B&          /* PURGING CHAIN                 */
*           (RHCHAIN='01'B|         /* LAST IN CHAIN         @XM09765*/
*           RHCHAIN='00'B)) THEN    /* MIDDLE OF CHAIN       @XM09765*/
         CLC   RPHPABOF(1,PTRRPH),TOP                              0711
         BNE   @RF00711                                            0711
         TM    FMCPURCH(PTRFMC),B'00000010'                        0711
         BNO   @RF00711                                            0711
         TM    RHCHAIN+38(PTRZOB),B'00000001'                      0711
         BNO   @GL00010                                            0711
         TM    RHCHAIN+38(PTRZOB),B'00000010'                      0711
         BZ    @RT00711                                            0711
@GL00010 TM    RHCHAIN+38(PTRZOB),B'00000011'                      0711
         BNZ   @RF00711                                            0711
@RT00711 DS    0H                                                  0712
*         DO;                                                      0712
*           CALL AF1B025;           /* DQ ELEMENT FROM SCHED Q       */
         BAL   @14,AF1B025                                         0713
*           CALL ISTZBFY0;          /* BUILD FSB AND SCHED. TIP      */
         L     @11,ATCZPSVT(,PTRCVT)                               0714
         L     @15,ZPSZBFY0(,@11)                                  0714
         BALR  @14,@15                                             0714
*           IF RHCHAIN='01'B THEN   /* SHIP OUT LAST IN CHAIN        */
         TM    RHCHAIN+38(PTRZOB),B'00000001'                      0715
         BNO   @RF00715                                            0715
         TM    RHCHAIN+38(PTRZOB),B'00000010'                      0715
         BZ    @RT00715                                            0715
*             GO TO AF1BOUT;        /*                       @XM01901*/
*           ELSE                                                   0717
*             DO;                   /*                       @XM01901*/
@RF00715 DS    0H                                                  0718
*               FMCOSSN=FMCOSSN-1;  /* RESET SEQ NO. NO BUFFER     0718
*                                      SHIPPED OUT           @XM01901*/
         LH    @14,FMCOSSN(,PTRFMC)                                0718
         N     @14,@CF04285                                        0718
         BCTR  @14,0                                               0718
         STH   @14,FMCOSSN(,PTRFMC)                                0718
*               RFY                                                0719
*                 WKREG7 RSTD;      /*                       @XM01638*/
*               WKREG7=PTRZOB;      /* PREPARE TO RELEASE BUFFER     */
         LR    WKREG7,PTRZOB                                       0720
*               ZCRPCOD1='00'X;     /* INITIALIZE DFB0 PARM          */
         MVI   ZCRPCOD1(ZCRREG),X'00'                              0721
*               ZCRPBUF='1'B;       /* RELEASE BUFFER        @XM01638*/
         OI    ZCRPBUF(ZCRREG),B'00000100'                         0722
*               CALL ISTZDFB0;      /* TPIOS UTILITY         @XM01638*/
         L     @11,ATCZPSVT(,PTRCVT)                               0723
         L     @15,ZPSZDFB0(,@11)                                  0723
         BALR  @14,@15                                             0723
*             END;                  /*                       @XM01901*/
*         END;                                                     0725
*       ELSE                                                       0726
*         DO;                                                      0726
         B     @RC00711                                            0726
@RF00711 DS    0H                                                  0727
*           IF RPHPABOF=TOP&        /* SCHEDULED FROM TOP            */
*               FMCPURCH='1'B THEN  /* PURGING CHAIN                 */
         CLC   RPHPABOF(1,PTRRPH),TOP                              0727
         BNE   @RF00727                                            0727
         TM    FMCPURCH(PTRFMC),B'00000010'                        0727
         BNO   @RF00727                                            0727
*             FMCPURCH='0'B;        /* RESET PURGING FLAG            */
         NI    FMCPURCH(PTRFMC),B'11111101'                        0728
*           ELSE                                                   0729
*             ;                                                    0729
@RF00727 DS    0H                                                  0730
*           IF LCCWLSI='1'B THEN    /* IF POST = SCHED       @XM01638*/
         L     @14,LCPNXLCW(,PTRLCP)                               0730
         TM    LCCWLSI(@14),B'00000100'                            0730
         BNO   @RF00730                                            0730
*             DO;                   /*                       @XM01638*/
*               CALL AF1B025;       /* DQ SCHED Q EL.        @XM01638*/
         BAL   @14,AF1B025                                         0732
*               CALL ISTZBFY0;      /* POST REQUESTOR IMMEDIATELY    */
         L     @11,ATCZPSVT(,PTRCVT)                               0733
         L     @15,ZPSZBFY0(,@11)                                  0733
         BALR  @14,@15                                             0733
*             END;                  /*                       @XM01638*/
*           ELSE                    /* NOT LCCW SYNCH        @XM01638*/
*             IF RHQS='0'B&         /* IF BUFFER CONTAINS REQ. AND   */
*                 (RHRRN='1'B       /* REACHED RECOVERY NODE OR      */
*                 |RHFME='1'B)      /* FUNCTION MANAGEMENT END AND   */
*                 &RHEXCEPT='0'B THEN/* NOT EXCEPTION RESPONSE     0735
*                                                            @XL50HFZ*/
         B     @RC00730                                            0735
@RF00730 LA    @14,38                                              0735
         ALR   @14,PTRZOB                                          0735
         TM    RHQS(@14),B'10000000'                               0735
         BNZ   @RF00735                                            0735
         TM    RHRRN(@14),B'10100000'                              0735
         BZ    @RF00735                                            0735
         TM    RHEXCEPT(@14),B'00010000'                           0735
         BNZ   @RF00735                                            0735
*               IF ZOBCPTCC='FF'X THEN/* IF QUIESCE FUNCTION @XM17572*/
         CLI   ZOBCPTCC(PTRZOB),X'FF'                              0736
         BNE   @RF00736                                            0736
*                 DO;               /* PROCESS QUIESCE       @XM17572*/
*                   ZCRQAHED='1'B;  /* SET QUEUE FIRST FLAG  @XM17572*/
         OI    ZCRQAHED(ZCRREG),B'10000000'                        0738
*                   CALL ISTZDFH0;  /* QUEUE TRANSFER        @XM17572*/
         L     @11,ATCZPSVT(,PTRCVT)                               0739
         L     @15,ZPSZDFH0(,@11)                                  0739
         BALR  @14,@15                                             0739
*                 END;              /* END QUIESCE FUNCTION  @XM17572*/
*               ELSE                /* NOT QUIESCE           @XM17572*/
*                 IF(WKREG8->QUEHDR->LSCCHAIN&GATEOFF)=0 THEN      0741
         B     @RC00736                                            0741
@RF00736 SLR   @14,@14                                             0741
         L     @11,QUEHDR(,WKREG8)                                 0741
         L     @11,LSCCHAIN(,@11)                                  0741
         N     @11,@CF04161                                        0741
         CR    @11,@14                                             0741
         BNE   @RF00741                                            0741
*                   DO;             /* IF SINGLE ELEMENT ON SCHEDULE
*                                      QUEUE                 @XM18965*/
*                     WKREG8->QUEHDR=0;/* REMOVE ELEMENT FROM      0743
*                                      SCHEDULE QUEUE        @XL50HFZ*/
         ST    @14,QUEHDR(,WKREG8)                                 0743
*/*  TPQUE (PTRLCP,WKREG9->QUEHDR)                                   */
*                                                                  0744
*                     DO;                                          0744
*                       RFY                                        0745
*                        (GPR00P,                                  0745
*                         GPR01P,                                  0745
*                         GPR02P,                                  0745
*                         GPR14P,                                  0745
*                         GPR15P) RSTD;                            0745
*                       GEN REFS(GPR01P) SETS(RPHWORK)             0746
*                           (STM GPR02P,GPR08P,RPHWORK(GPR01P));   0746
         STM GPR02P,GPR08P,RPHWORK(GPR01P)
*                       GPR15P=PTRLCP;/* GET WORK ELEM POINTER       */
         LR    GPR15P,PTRLCP                                       0747
*                       GPR14P=ADDR(WKREG9->QUEHDR);/* ADDRESS     0748
*                                      PAB/QUEUE POINTER             */
         LR    GPR14P,WKREG9                                       0748
*                       GPR15P=GPR15P|PABWEQG1;                    0749
         O     GPR15P,@CF02384                                     0749
*                       GPR02P=GPR14P->PABWEQA;/* INITIALIZE WITH  0750
*                                      QUEUE HEADER                  */
         L     GPR02P,PABWEQA(,GPR14P)                             0750
*CMZA0072:                                                         0751
*                       ;           /* CS FAIL TARGET                */
CMZA0072 DS    0H                                                  0752
*                       GPR00P=GPR02P;/* SAVE QUEUE CONTENTS         */
         LR    GPR00P,GPR02P                                       0752
*                       GPR15P->PABCHAIN=GPR02P|PABWEQG1;/* FORWARD
*                                      CHAIN WORK ELEMENT            */
         LR    @11,GPR02P                                          0753
         O     @11,@CF02384                                        0753
         ST    @11,PABCHAIN(,GPR15P)                               0753
*                       CS(GPR02P,GPR15P,GPR14P->PABWEQA);/* CHECK 0754
*                                      FOR END OF QUEUE              */
         CS    GPR02P,@15,PABWEQA(GPR14P)                          0754
*                       BC(7,CMZA0072);                            0755
         BC    7,CMZA0072                                          0755
*                       GEN REFS(RPHWORK,GPR01P) NOSETS            0756
*                           (LM    GPR02P,GPR08P,RPHWORK(GPR01P)); 0756
         LM    GPR02P,GPR08P,RPHWORK(GPR01P)
*                       RFY                                        0757
*                        (GPR00P,                                  0757
*                         GPR01P,                                  0757
*                         GPR02P,                                  0757
*                         GPR14P,                                  0757
*                         GPR15P) UNRSTD;                          0757
*                     END;          /* *** END OF TPQUE GENERATION 0758
*                                      ADD ELEMENT TO WAIT QUEUE   0758
*                                                            @XL50HFZ*/
*                   END;            /* END SINGLE WAITQ ELEMENT    0759
*                                                            @XM19773*/
*                 ELSE              /* IF MULTIPLE ELEMENTS ON     0760
*                                      SCHEDULE QUEUE        @XM19773*/
*                   CALL ISTZDFH0;  /* TRANSFER FROM SCHEDULE QUEUE
*                                      TO THE WAIT QUEUE     @XM19773*/
         B     @RC00741                                            0760
@RF00741 L     @11,ATCZPSVT(,PTRCVT)                               0760
         L     @15,ZPSZDFH0(,@11)                                  0760
         BALR  @14,@15                                             0760
*             ELSE                                                 0761
*               CALL AF1B025;       /* DQ SCHED Q ELEMENT            */
         B     @RC00735                                            0761
@RF00735 BAL   @14,AF1B025                                         0761
*AF1BOUT:                                                          0762
*           IF NCBFTRIO='1'B THEN   /* IF I/O TRACE REQUESTED      0762
*                                                            @XL03HEN*/
@RC00735 DS    0H                                                  0762
@RC00730 DS    0H                                                  0762
AF1BOUT  CLI   NCBFTRIO(PTRLUN),1                                  0762
         BNE   @RF00762                                            0762
*             ZOBRT08='1'B;         /* SET TRACE BITS        @XL03HEN*/
         OI    ZOBRT08(PTRZOB),B'01000000'                         0763
*           ELSE                                                   0764
*             ;                                                    0764
@RF00762 DS    0H                                                  0765
*           IF PROCFTX='1'B THEN    /* CONFIDENTIAL TEXT     @XL03HEN*/
         TM    PROCFTX+48(PTRFMC),B'00000001'                      0765
         BNO   @RF00765                                            0765
*             ZOBRT06='1'B;         /* FLAG CONFIDENTIAL TEXT BUFFER
*                                                            @XL03HEN*/
         OI    ZOBRT06(PTRZOB),B'10000000'                         0766
*           ELSE                                                   0767
*             ;                                                    0767
@RF00765 DS    0H                                                  0768
*           CALL ISTZEFBB;          /* SHIPOUT BUFFER                */
         L     @11,ATCZFSVT(,PTRCVT)                               0768
         L     @15,ZFSZEFBB(,@11)                                  0768
         BALR  @14,@15                                             0768
*         END;                                                     0769
*     END;                          /*                       @XM01638*/
@RC00711 DS    0H                                                  0771
*   RFY                                                            0771
*    (WKREG8,                                                      0771
*     WKREG9) UNRSTD;                                              0771
@RT00707 DS    0H                                                  0772
*   RFY                                                            0772
*     LNKREG RSTD;                                                 0772
*   LNKREG=ZCRSVF1;                                                0773
         L     LNKREG,ZCRSVF1(,ZCRREG)                             0773
*   RFY                                                            0774
*     LNKREG UNRSTD;                                               0774
*   END AF1B020;                                                   0775
@EL00002 DS    0H                                                  0775
@EF00002 DS    0H                                                  0775
@ER00002 BR    @14                                                 0775
@PB00002 DS    0H                                                  0776
         EJECT
*                                                                  0776
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT-                                                         */
*/*      AF1B030                                                     */
*/*                                                                  */
*/* FUNCTION-                                                        */
*/*      THIS ROUTINE FINDS THE NEXT PROCESSABLE ELEMENT ON THE      */
*/*      PAB QUEUE. (FMCPAB5)  IF ELEMENT IS A FSB IT IS DEQUED.     */
*/*      THE LCCW/BTU TRANSLATION CONTROLLER IS CALLED TO PROCESS    */
*/*      THE LCCW.  IF THE ELEMENT WAS A SESSION CONTROL LCPB THE    */
*/*      SESSION CONTROLLER IS CALLED.                               */
*/********************************************************************/
*                                                                  0776
*   /*****************************************************************/
*   /*                                                               */
*   /* SEGMENT(AF1B030)START                                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0776
*   DO;                                                            0776
*     GOTO AF1B030@;                                               0777
         B     AF1B030@                                            0777
*AF1B030:                                                          0778
*   END;                                                           0778
*                                                                  0778
AF1B030  DS    0H                                                  0779
*/* TPFEL (,FMCPAB5) RETPTR(PTRLCP)                                  */
*                                                                  0779
*   DO;                             /* BEGIN TPFEL CODE GENERATION   */
*     RFY                                                          0780
*      (GPR00P,                                                    0780
*       GPR01P,                                                    0780
*       GPR14P,                                                    0780
*       GPR15P) RSTD;                                              0780
*     GPR15P=ADDR(FMCPAB5);         /* ADDRESS QUEUE POINTER         */
         LA    GPR15P,FMCPAB5(,PTRFMC)                             0781
*     GPR14P=GPR15P->PABWEQA|FMZCA068;                             0782
         L     @11,@CF02384                                        0782
         L     GPR14P,PABWEQA(,GPR15P)                             0782
         OR    GPR14P,@11                                          0782
*     IF GPR14P=FMZCA068 THEN                                      0783
         CLR   GPR14P,@11                                          0783
         BE    @RT00783                                            0783
*       ;                                                          0784
*     ELSE                                                         0785
*       DO;                                                        0785
*         GPR00P=FMZCA068;          /* INITIALIZE QUIT FLAG          */
         L     GPR00P,@CF02384                                     0786
*         DO WHILE(GPR00P^=GPR14P->WKECHAIN);                      0787
         B     @DE00787                                            0787
@DL00787 DS    0H                                                  0788
*           GPR14P=GPR14P->WKECHAIN;/* SEARCH FOR END OF CHAIN       */
         L     GPR14P,WKECHAIN(,GPR14P)                            0788
*         END;                                                     0789
@DE00787 C     GPR00P,WKECHAIN(,GPR14P)                            0789
         BNE   @DL00787                                            0789
*       END;                                                       0790
*     GPR14P=GPR14P&FMZCB068;                                      0791
@RT00783 N     GPR14P,@CF02476                                     0791
*     PTRLCP=GPR14P;                                               0792
         LR    PTRLCP,GPR14P                                       0792
*     RFY                                                          0793
*      (GPR00P,                                                    0793
*       GPR01P,                                                    0793
*       GPR14P,                                                    0793
*       GPR15P) UNRSTD;                                            0793
*   END;                            /* END TPFEL GENERATION          */
*   IF LCPTYPE=FSTYPE THEN          /* IF PAB ELEMENT A FSB          */
         CLI   LCPTYPE(PTRLCP),X'02'                               0795
         BNE   @RF00795                                            0795
*     DO;                                                          0796
*                                                                  0796
*/* TPDEQ (PTRLCP,FMCPAB5)                                           */
*                                                                  0797
*       DO;                         /* BEGIN TPDEQ CODE GENERATION   */
*         RFY                                                      0798
*          (GPR00P,                                                0798
*           GPR01P,                                                0798
*           GPR14P,                                                0798
*           GPR15P) RSTD;                                          0798
*         GPR15P=ADDR(FMCPAB5);     /* ADDRESS QUEUE POINTER         */
         LA    GPR15P,FMCPAB5(,PTRFMC)                             0799
*         RFY                                                      0800
*          (GPR02P,                                                0800
*           GPR03P) RSTD;                                          0800
*         STM(GPR02P,GPR03P,GPR01P->RPHWORK(5:12));                0801
         STM   GPR02P,GPR03P,RPHWORK+4(GPR01P)                     0801
*         GPR03P=PTRLCP|FMZCA068;                                  0802
         L     @11,@CF02384                                        0802
         LR    GPR03P,PTRLCP                                       0802
         OR    GPR03P,@11                                          0802
*         GPR14P=FMZCA068;                                         0803
         LR    GPR14P,@11                                          0803
*         GPR15P=ADDR(GPR15P->PABWEQA);                            0804
*         GPR02P=GPR15P->PABWEQA|FMZCA068;                         0805
         O     @11,PABWEQA(,GPR15P)                                0805
         LR    GPR02P,@11                                          0805
*         DO WHILE(GPR02P^=GPR14P);                                0806
         B     @DE00806                                            0806
@DL00806 DS    0H                                                  0807
*FMZL2083:                                                         0807
*           ;                                                      0807
FMZL2083 DS    0H                                                  0808
*           IF GPR02P=GPR03P THEN                                  0808
         CR    GPR02P,GPR03P                                       0808
         BNE   @RF00808                                            0808
*             DO;                                                  0809
*               GPR00P=GPR02P->WKECHAIN;                           0810
         L     GPR00P,WKECHAIN(,GPR02P)                            0810
*               CS(GPR02P,GPR00P,GPR15P->PABWEQA);                 0811
         CS    GPR02P,@00,PABWEQA(GPR15P)                          0811
*               BC(7,FMZL3083);                                    0812
         BC    7,FMZL3083                                          0812
*               GPR14P=GPR02P;                                     0813
         LR    GPR14P,GPR02P                                       0813
*               GPR14P->WKECHAIN=0;                                0814
         SLR   @11,@11                                             0814
         ST    @11,WKECHAIN(,GPR14P)                               0814
*             END;                                                 0815
*           ELSE                                                   0816
*             DO;                                                  0816
         B     @RC00808                                            0816
@RF00808 DS    0H                                                  0817
*               IF(GPR02P->WKECHAIN)=GPR14P THEN                   0817
         L     @11,WKECHAIN(,GPR02P)                               0817
         CR    @11,GPR14P                                          0817
         BE    @RT00817                                            0817
*                 GOTO ISTA0083;                                   0818
*               ELSE                                               0819
*                 DO;                                              0819
*                   GPR15P=ADDR(GPR02P->WKECHAIN);                 0820
         LA    GPR15P,WKECHAIN(,GPR02P)                            0820
*                   GPR02P=GPR02P->WKECHAIN;                       0821
         LR    GPR02P,@11                                          0821
*                   GOTO FMZL2083;                                 0822
         B     FMZL2083                                            0822
*                 END;                                             0823
*             END;                                                 0824
*FMZL3083:                                                         0825
*           ;                                                      0825
@RC00808 DS    0H                                                  0825
FMZL3083 DS    0H                                                  0826
*         END;                                                     0826
@DE00806 CR    GPR02P,GPR14P                                       0826
         BNE   @DL00806                                            0826
*ISTA0083:                                                         0827
*         ;                                                        0827
ISTA0083 DS    0H                                                  0828
*         LM(GPR02P,GPR03P,GPR01P->RPHWORK(5:12));                 0828
         LM    GPR02P,GPR03P,RPHWORK+4(GPR01P)                     0828
*         RFY                                                      0829
*          (GPR02P,                                                0829
*           GPR03P) UNRSTD;                                        0829
*         GPR14P=GPR14P&FMZCB068;                                  0830
         N     GPR14P,@CF02476                                     0830
*         GPR01P->RPHWEA=GPR14P;                                   0831
         ST    GPR14P,RPHWEA(,GPR01P)                              0831
*         RFY                                                      0832
*          (GPR00P,                                                0832
*           GPR01P,                                                0832
*           GPR14P,                                                0832
*           GPR15P) UNRSTD;                                        0832
*       END;                        /* END TPDEQ GENERATION          */
*       CALL ISTZBFSC;              /* SESSION CONTROL OUTBOUND      */
         L     @11,PABDVTA+95(,PTRFMC)                             0834
         LA    @11,0(,@11)                                         0834
         L     @15,ZLBZBFSC(,@11)                                  0834
         BALR  @14,@15                                             0834
*     END;                                                         0835
*   ELSE                                                           0836
*     DO;                                                          0836
         B     @RC00795                                            0836
@RF00795 DS    0H                                                  0837
*       CALL AF1B040;               /* CHECK CONFIGURATION RESTART   */
         BAL   @14,AF1B040                                         0837
*       IF ZCRENDSH='1'B THEN                                      0838
         TM    ZCRENDSH(ZCRREG),B'10000000'                        0838
         BO    @RT00838                                            0838
*         ;                         /* EXIT IF FMCB SICK             */
*       ELSE                                                       0840
*         DO;                                                      0840
*           RCDREG=0;               /* INITIALIZE RETURN CODE        */
         SLR   RCDREG,RCDREG                                       0841
*           IF(LCPTYPE=LCPETYPE|    /* ELEMENT FOR SESION CONTROL?   */
*               LCCWOP=LCLEAR|      /* OPERATION FOR         @X50BHEN*/
*               LCCWOP=LCRUD|       /* SESSION CONTROL ?     @X50BHEN*/
*               LCCWOP=LCRUDNFY|LCCWOP=LNFY|LCCWOP=LCLRNFY)&LCPTLBPI=
*               '0'B THEN                                          0842
         CLI   LCPTYPE(PTRLCP),X'40'                               0842
         BE    @GL00014                                            0842
         L     @14,LCPNXLCW(,PTRLCP)                               0842
         CLI   LCCWOP(@14),X'F2'                                   0842
         BE    @GL00014                                            0842
         CLI   LCCWOP(@14),X'F3'                                   0842
         BE    @GL00014                                            0842
         CLI   LCCWOP(@14),X'F4'                                   0842
         BE    @GL00014                                            0842
         CLI   LCCWOP(@14),X'F5'                                   0842
         BE    @GL00014                                            0842
         CLI   LCCWOP(@14),X'F8'                                   0842
         BNE   @RF00842                                            0842
@GL00014 TM    LCPTLBPI(PTRLCP),B'00010000'                        0842
         BNZ   @RF00842                                            0842
*             CALL ISTZBFSC;        /* SESSION CONTROL OUTBOUND      */
         L     @11,PABDVTA+95(,PTRFMC)                             0843
         LA    @11,0(,@11)                                         0843
         L     @15,ZLBZBFSC(,@11)                                  0843
         BALR  @14,@15                                             0843
*           ELSE                                                   0844
*             IF LCPTLBPI='1'B THEN /* IF CLEAR/UNBIND IN PROGRESS   */
         B     @RC00842                                            0844
@RF00842 TM    LCPTLBPI(PTRLCP),B'00010000'                        0844
         BNO   @RF00844                                            0844
*               FMCUIPI='1'B;       /* UNBIND BEGINS NOW     @XM09431*/
         OI    FMCUIPI(PTRFMC),B'00100000'                         0845
*             ELSE                                                 0846
*               ;                   /*                       @XM09431*/
@RF00844 DS    0H                                                  0847
*           IF RCDREG=0 THEN                                       0847
@RC00842 LTR   RCDREG,RCDREG                                       0847
         BNZ   @RF00847                                            0847
*             CALL ISTZBF0B;        /* LCCW TO PIU TRANSLATION       */
         L     @11,PABDVTA+95(,PTRFMC)                             0848
         LA    @11,0(,@11)                                         0848
         L     @15,ZLBZBF0B(,@11)                                  0848
         BALR  @14,@15                                             0848
*           ELSE                                                   0849
*             ;                     /*                       @ZA09592*/
*                                                                  0849
@RF00847 DS    0H                                                  0850
*           /*********************************************************/
*           /*                                                       */
*           /* IF RCDREG=4 THEN ?TPDEQ(PTRLCP,FMCPAB5); ELSE         */
*           /* ?TPDEQ(PTRLCP,FMCPAB5) RESET(RECON); ********** ABOVE */
*           /* FOUR LINES DELETED BY ...                     @ZA09592*/
*           /*                                                       */
*           /*********************************************************/
*                                                                  0850
*         END;                                                     0850
*     END;                                                         0851
*                                                                  0851
@RT00838 DS    0H                                                  0852
*   /*****************************************************************/
*   /*                                                               */
*   /* SEGMENT(AF1B030)FINISH                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0852
*   DO;                                                            0852
@RC00795 DS    0H                                                  0853
*     GOTO AF1B030#;                                               0853
         B     AF1B030#                                            0853
*AF1B030@:                                                         0854
*   END;                                                           0854
AF1B030@ DS    0H                                                  0855
         EJECT
*                                                                  0855
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT-                                                         */
*/*      AF1B035                                                     */
*/*                                                                  */
*/* FUNCTION-                                                        */
*/*      THIS ROUTINE FINDS THE NEXT PROCESSABLE ELEMENT ON THE      */
*/*      PAB QUEUE. (FMCPAB3)                                        */
*/*      THE LCCW/PIU TRANSLATION CONTROLLER IS CALLED TO PROCESS    */
*/*      THE LCCW.                                                   */
*/*                                                                  */
*/********************************************************************/
*                                                                  0855
*   /*****************************************************************/
*   /*                                                               */
*   /* SEGMENT(AF1B035)START                                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0855
*   DO;                                                            0855
*     GOTO AF1B035@;                                               0856
         B     AF1B035@                                            0856
*AF1B035:                                                          0857
*   END;                                                           0857
*                                                                  0857
AF1B035  DS    0H                                                  0858
*/* TPFEL (,FMCPAB3) RETPTR(PTRLCP)                                  */
*                                                                  0858
*   DO;                             /* BEGIN TPFEL CODE GENERATION   */
*     RFY                                                          0859
*      (GPR00P,                                                    0859
*       GPR01P,                                                    0859
*       GPR14P,                                                    0859
*       GPR15P) RSTD;                                              0859
*     GPR15P=ADDR(FMCPAB3);         /* ADDRESS QUEUE POINTER         */
         LA    GPR15P,FMCPAB3(,PTRFMC)                             0860
*     GPR14P=GPR15P->PABWEQA|FMZCA068;                             0861
         L     @11,@CF02384                                        0861
         L     GPR14P,PABWEQA(,GPR15P)                             0861
         OR    GPR14P,@11                                          0861
*     IF GPR14P=FMZCA068 THEN                                      0862
         CLR   GPR14P,@11                                          0862
         BE    @RT00862                                            0862
*       ;                                                          0863
*     ELSE                                                         0864
*       DO;                                                        0864
*         GPR00P=FMZCA068;          /* INITIALIZE QUIT FLAG          */
         L     GPR00P,@CF02384                                     0865
*         DO WHILE(GPR00P^=GPR14P->WKECHAIN);                      0866
         B     @DE00866                                            0866
@DL00866 DS    0H                                                  0867
*           GPR14P=GPR14P->WKECHAIN;/* SEARCH FOR END OF CHAIN       */
         L     GPR14P,WKECHAIN(,GPR14P)                            0867
*         END;                                                     0868
@DE00866 C     GPR00P,WKECHAIN(,GPR14P)                            0868
         BNE   @DL00866                                            0868
*       END;                                                       0869
*     GPR14P=GPR14P&FMZCB068;                                      0870
@RT00862 N     GPR14P,@CF02476                                     0870
*     PTRLCP=GPR14P;                                               0871
         LR    PTRLCP,GPR14P                                       0871
*     RFY                                                          0872
*      (GPR00P,                                                    0872
*       GPR01P,                                                    0872
*       GPR14P,                                                    0872
*       GPR15P) UNRSTD;                                            0872
*   END;                            /* END TPFEL GENERATION          */
*   CALL AF1B040;                   /* CHECK CONFIGURATION RESTART   */
         BAL   @14,AF1B040                                         0874
*   IF ZCRENDSH='0'B THEN           /* FMCB NOT SICK                 */
         TM    ZCRENDSH(ZCRREG),B'10000000'                        0875
         BNZ   @RF00875                                            0875
*     IF LCCWOP=LRESTSR THEN        /* RESET SEND / RECEIVE          */
         L     @14,LCPNXLCW(,PTRLCP)                               0876
         CLI   LCCWOP(@14),X'F7'                                   0876
         BNE   @RF00876                                            0876
*       DO;                                                        0877
*                                                                  0877
*/* TPDEQ (,FMCPAB3)                                                 */
*                                                                  0878
*         DO;                       /* BEGIN TPDEQ CODE GENERATION   */
*           RFY                                                    0879
*            (GPR00P,                                              0879
*             GPR01P,                                              0879
*             GPR14P,                                              0879
*             GPR15P) RSTD;                                        0879
*           GPR15P=ADDR(FMCPAB3);   /* ADDRESS QUEUE POINTER         */
         LA    GPR15P,FMCPAB3(,PTRFMC)                             0880
*           GPR14P=GPR15P->PABWEQA|FMZCA068;                       0881
         L     @11,@CF02384                                        0881
         L     GPR14P,PABWEQA(,GPR15P)                             0881
         OR    GPR14P,@11                                          0881
*           IF GPR14P=FMZCA068 THEN                                0882
         CLR   GPR14P,@11                                          0882
         BE    @RT00882                                            0882
*             ;                                                    0883
*           ELSE                                                   0884
*             DO;                                                  0884
*FMZL1095:                                                         0885
*               ;                                                  0885
FMZL1095 DS    0H                                                  0886
*               DO WHILE(GPR14P->WKECHAIN^=FMZCA068);              0886
         B     @DE00886                                            0886
@DL00886 DS    0H                                                  0887
*                 GPR15P=ADDR(GPR14P->WKECHAIN);                   0887
         LA    GPR15P,WKECHAIN(,GPR14P)                            0887
*                 GPR14P=GPR15P->PABWEQA;                          0888
         L     GPR14P,PABWEQA(,GPR15P)                             0888
*               END;                                               0889
@DE00886 L     @11,@CF02384                                        0889
         CL    @11,WKECHAIN(,GPR14P)                               0889
         BNE   @DL00886                                            0889
*               GPR00P=FMZCA068;                                   0890
         LR    GPR00P,@11                                          0890
*               CS(GPR14P,GPR00P,GPR15P->PABWEQA);                 0891
         CS    GPR14P,@00,PABWEQA(GPR15P)                          0891
*               BC(7,FMZL1095);                                    0892
         BC    7,FMZL1095                                          0892
*               GPR14P->WKECHAIN=0;                                0893
         SLR   @11,@11                                             0893
         ST    @11,WKECHAIN(,GPR14P)                               0893
*             END;                                                 0894
*ISTA0095:                                                         0895
*           ;                                                      0895
@RT00882 DS    0H                                                  0895
ISTA0095 DS    0H                                                  0896
*           GPR14P=GPR14P&FMZCB068;                                0896
         N     GPR14P,@CF02476                                     0896
*           GPR01P->RPHWEA=GPR14P;                                 0897
         ST    GPR14P,RPHWEA(,GPR01P)                              0897
*           RFY                                                    0898
*            (GPR00P,                                              0898
*             GPR01P,                                              0898
*             GPR14P,                                              0898
*             GPR15P) UNRSTD;                                      0898
*         END;                      /* END TPDEQ GENERATION          */
*         CALL ISTZBFY0;            /* GENERATE A FSB                */
         L     @11,ATCZPSVT(,PTRCVT)                               0900
         L     @15,ZPSZBFY0(,@11)                                  0900
         BALR  @14,@15                                             0900
*       END;                                                       0901
*     ELSE                                                         0902
*       CALL ISTZBF0B;              /* CONTINUE REQUEST NORMALLY     */
         B     @RC00876                                            0902
@RF00876 L     @11,PABDVTA+95(,PTRFMC)                             0902
         LA    @11,0(,@11)                                         0902
         L     @15,ZLBZBF0B(,@11)                                  0902
         BALR  @14,@15                                             0902
*   ELSE                                                           0903
*     ;                             /* EXIT MODULE                   */
*                                                                  0903
@RF00875 DS    0H                                                  0904
*   /*****************************************************************/
*   /*                                                               */
*   /* SEGMENT(AF1B035)FINISH                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  0904
*   DO;                                                            0904
@RC00875 DS    0H                                                  0905
*     GOTO AF1B035#;                                               0905
         B     AF1B035#                                            0905
*AF1B035@:                                                         0906
*   END;                                                           0906
         EJECT
*                                                                  0907
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT-                                                         */
*/*      AF1B040                                                     */
*/*                                                                  */
*/* FUNCTION-                                                        */
*/*      THIS ROUTINE CHECKS FOR CONFIGURATION RESTART.              */
*/*                                                                  */
*/********************************************************************/
*                                                                  0907
*AF1B040:                                                          0907
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0907
         B     @PB00003                                            0907
AF1B040  DS    0H                                                  0908
*   RFY                                                            0908
*     LNKREG RSTD;                                                 0908
*   RFY                                                            0909
*     WKREG9 RSTD;                                                 0909
*   IF FMCCIPI='1'B|                /* CLEAR IN PROGRESS     @XM09431*/
*       FMCUIPI='1'B THEN           /* OR UNBIND IN PROGRESS         */
         TM    FMCCIPI(PTRFMC),B'01100000'                         0910
         BZ    @RF00910                                            0910
*     DO;                                                          0911
*       IF LCPINTER='1'B THEN                                      0912
         TM    LCPINTER(PTRLCP),B'01000000'                        0912
         BO    @RT00912                                            0912
*         ;                         /* INTERNALLY GENERATED LCPB     */
*       ELSE                                                       0914
*         ZCRENDSH='1'B;            /* EXIT NO SCHED                 */
         OI    ZCRENDSH(ZCRREG),B'10000000'                        0914
*       GO TO AF1B0402;             /* EXIT SUBROUTINE               */
         B     AF1B0402                                            0915
*     END;                                                         0916
*   ELSE                                                           0917
*     ;                                                            0917
@RF00910 DS    0H                                                  0918
*   IF FMCCONF='1'B THEN            /* FMCB SICK                     */
         TM    FMCCONF(PTRFMC),B'00000001'                         0918
         BO    @RT00918                                            0918
*     GO TO AF1B0401;               /* CHECK LCCW OP CODE            */
*   ELSE                                                           0920
*     DO;                                                          0920
*       WKREG9=PTRICN;                                             0921
         LR    WKREG9,PTRICN                                       0921
*AF1B0400:                                                         0922
*       IF WKREG9->ICNZF010='1'B THEN/* CHECK FOR AUTO NETWORK     0922
*                                      SHUTDOWN                      */
AF1B0400 TM    ICNZF010(WKREG9),B'00010000'                        0922
         BO    @RT00922                                            0922
*         GO TO AF1B0401;                                          0923
*       ELSE                                                       0924
*         DO;                                                      0924
*           WKREG9=WKREG9->NCBNSNA; /* ADDRESS NEXT NODE BLOCK       */
         L     WKREG9,NCBNSNA(,WKREG9)                             0925
*           IF WKREG9=0 THEN        /* END OF CHAIN ?                */
         LTR   WKREG9,WKREG9                                       0926
         BZ    @RT00926                                            0926
*             GO TO AF1B0402;       /* YES, EXIT                     */
*           ELSE                                                   0928
*             GO TO AF1B0400;       /* NO CONTINUE TO LOOP           */
         B     AF1B0400                                            0928
*         END;                                                     0929
*     END;                                                         0930
*   RFY                                                            0931
*     WKREG9 UNRSTD;                                               0931
*AF1B0401:                                                         0932
*   IF LCCWOP=LCLEAR|               /* IF OPERATION IS A CLEAR       */
*       LCCWOP=LCLRNFY|             /* IF OPERATION CLEAR NOTIFY     */
*       LCCWOP=LCRUD|               /* IF OPERATION CLEAR/UNBIND     */
*       LCCWOP=LCRUDNFY|            /* IF OPERATION CL/UNBND/NOT     */
*       LCCWOP=LNFY THEN                                           0932
AF1B0401 L     @11,LCPNXLCW(,PTRLCP)                               0932
         CLI   LCCWOP(@11),X'F2'                                   0932
         BE    @RT00932                                            0932
         CLI   LCCWOP(@11),X'F8'                                   0932
         BE    @RT00932                                            0932
         CLI   LCCWOP(@11),X'F3'                                   0932
         BE    @RT00932                                            0932
         CLI   LCCWOP(@11),X'F4'                                   0932
         BE    @RT00932                                            0932
         CLI   LCCWOP(@11),X'F5'                                   0932
         BE    @RT00932                                            0932
*     ;                             /* IF OPERATION IS A NOTIFY      */
*   ELSE                                                           0934
*     IF LCPRSTRT='1'B THEN                                        0934
         TM    LCPRSTRT(PTRLCP),B'00100000'                        0934
         BO    @RT00934                                            0934
*       ;                           /* IGNORE SICK DURING RESTART    */
*     ELSE                                                         0936
*       ZCRENDSH='1'B;              /* EXIT FOR FMCB SICK            */
         OI    ZCRENDSH(ZCRREG),B'10000000'                        0936
*AF1B0402:                                                         0937
*   END AF1B040;                                                   0937
@EL00003 DS    0H                                                  0937
@EF00003 DS    0H                                                  0937
@ER00003 BR    @14                                                 0937
*   RFY                                                            0938
*     LNKREG UNRSTD;                                               0938
         EJECT
*                                                                  0939
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT-                                                         */
*/*      AF1B025                                                     */
*/*                                                                  */
*/* FUNCTION-                                                        */
*/*      THIS ROUTINE DEQUES THE CORRECT SCHEDULE Q  ELEMENT.        */
*/*      AND RELEASES IT IF ITS IS AN LSCB.                          */
*/********************************************************************/
*                                                                  0939
*AF1B025:                                                          0939
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               0939
AF1B025  DS    0H                                                  0940
*   RFY                                                            0940
*    (WKREG8,                                                      0940
*     WKREG9) RSTD;                 /* PARAMETER REGISTERS   @XL50HFZ*/
*   RFY                                                            0941
*     LNKREG RSTD;                                                 0941
*   ZCRSVF2=LNKREG;                 /* SAVE RETURN ADDRESS           */
         ST    LNKREG,ZCRSVF2(,ZCRREG)                             0942
*   RFY                                                            0943
*     LNKREG UNRSTD;                                               0943
*                                                                  0943
*/* TPDEQ (,WKREG8->QUEHDR)                                          */
*                                                                  0944
*   DO;                             /* BEGIN TPDEQ CODE GENERATION   */
*     RFY                                                          0945
*      (GPR00P,                                                    0945
*       GPR01P,                                                    0945
*       GPR14P,                                                    0945
*       GPR15P) RSTD;                                              0945
*     GPR15P=ADDR(WKREG8->QUEHDR);  /* ADDRESS QUEUE POINTER         */
         LR    GPR15P,WKREG8                                       0946
*     GPR14P=GPR15P->PABWEQA|FMZCA068;                             0947
         L     @11,@CF02384                                        0947
         L     GPR14P,PABWEQA(,GPR15P)                             0947
         OR    GPR14P,@11                                          0947
*     IF GPR14P=FMZCA068 THEN                                      0948
         CLR   GPR14P,@11                                          0948
         BE    @RT00948                                            0948
*       ;                                                          0949
*     ELSE                                                         0950
*       DO;                                                        0950
*FMZL1100:                                                         0951
*         ;                                                        0951
FMZL1100 DS    0H                                                  0952
*         DO WHILE(GPR14P->WKECHAIN^=FMZCA068);                    0952
         B     @DE00952                                            0952
@DL00952 DS    0H                                                  0953
*           GPR15P=ADDR(GPR14P->WKECHAIN);                         0953
         LA    GPR15P,WKECHAIN(,GPR14P)                            0953
*           GPR14P=GPR15P->PABWEQA;                                0954
         L     GPR14P,PABWEQA(,GPR15P)                             0954
*         END;                                                     0955
@DE00952 L     @11,@CF02384                                        0955
         CL    @11,WKECHAIN(,GPR14P)                               0955
         BNE   @DL00952                                            0955
*         GPR00P=FMZCA068;                                         0956
         LR    GPR00P,@11                                          0956
*         CS(GPR14P,GPR00P,GPR15P->PABWEQA);                       0957
         CS    GPR14P,@00,PABWEQA(GPR15P)                          0957
*         BC(7,FMZL1100);                                          0958
         BC    7,FMZL1100                                          0958
*         GPR14P->WKECHAIN=0;                                      0959
         SLR   @11,@11                                             0959
         ST    @11,WKECHAIN(,GPR14P)                               0959
*       END;                                                       0960
*ISTA0100:                                                         0961
*     ;                                                            0961
@RT00948 DS    0H                                                  0961
ISTA0100 DS    0H                                                  0962
*     GPR14P=GPR14P&FMZCB068;                                      0962
         N     GPR14P,@CF02476                                     0962
*     GPR01P->RPHWEA=GPR14P;                                       0963
         ST    GPR14P,RPHWEA(,GPR01P)                              0963
*     RFY                                                          0964
*      (GPR00P,                                                    0964
*       GPR01P,                                                    0964
*       GPR14P,                                                    0964
*       GPR15P) UNRSTD;                                            0964
*   END;                            /* END TPDEQ GENERATION REMOVE 0965
*                                      ELEMENT FROM SCHEDULE QUEUE 0965
*                                                            @XM19773*/
*   IF LSCTYPE=LSTYPE THEN                                         0966
         CLI   LSCTYPE(PTRLSC),X'DF'                               0966
         BNE   @RF00966                                            0966
*     DO;                           /* RELEASE ELEMENT IF LSCB       */
*       ZCRPCOD1='0'X;              /* CLEAR PARAMATER BYTE          */
         MVI   ZCRPCOD1(ZCRREG),X'00'                              0968
*       ZCRPLSCB='1'B;              /* RELEASE LSCB                  */
         OI    ZCRPLSCB(ZCRREG),B'00001000'                        0969
*       CALL ISTZDFB0;                                             0970
         L     @11,ATCZPSVT(,PTRCVT)                               0970
         L     @15,ZPSZDFB0(,@11)                                  0970
         BALR  @14,@15                                             0970
*     END;                                                         0971
*   ELSE                                                           0972
*     ;                                                            0972
@RF00966 DS    0H                                                  0973
*   RFY                                                            0973
*     LNKREG RSTD;                                                 0973
*   LNKREG=ZCRSVF2;                 /* RESTORE RETURN ADDRESS        */
         L     LNKREG,ZCRSVF2(,ZCRREG)                             0974
*   RFY                                                            0975
*     LNKREG UNRSTD;                                               0975
*   RFY                                                            0976
*    (WKREG8,                                                      0976
*     WKREG9) UNRSTD;               /* PARAMETER REGISTERS   @XL50HFZ*/
*   END AF1B025;                                                   0977
*                                                                  0977
@EL00004 DS    0H                                                  0977
@EF00004 DS    0H                                                  0977
@ER00004 BR    @14                                                 0977
@PB00004 DS    0H                                                  0978
*/* TPEPILOG                                                         */
*                                                                  0978
*   GEN(PRINT OFF);                                                0978
         PRINT OFF
*   DCL                                                            0979
*     ISTAPC38 ENTRY BASED(ATCAP38) VALRG(*);/* TPSCHED ROUTINE      */
*   GEN(PRINT ON);                                                 0980
*                                                                  0980
         PRINT ON
*/* END OF TPEPILOG                                                  */
*                                                                  0981
*   END ISTZAF1B                                                   0981
*                                                                  0981
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSLIB  (IECDIOSB)                                       */
*/*%INCLUDE SYSLIB  (IHASRB  )                                       */
*                                                                  0981
*       ;                                                          0981
@EL00001 DS    0H                                                  0981
@EF00001 DS    0H                                                  0981
@ER00001 BR    @14                                                 0981
@DATA    DS    0H
@CH02124 DC    H'172'
@DATD    DSECT
         DS    0F
ISTZAF1B CSECT
         DS    0F
@CF02384 DC    XL4'80000000'
@CF02476 DC    XL4'7FFFFFFF'
@CF04161 DC    XL4'00FFFFFF'
@CF04285 DC    XL4'0000FFFF'
@DATD    DSECT
         DS    0D
IOSBPTR  DS    A
SRBPTR   DS    A
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
ISTZAF1B CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
ATOP     DC    AL1(FMCPAB5-ISTFMCB)
TOP      DC    AL1(FMCPAB3-ISTFMCB)
@CC04195 DC    C'AC1B'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
RPHPTR   EQU   @01
PTRRPH   EQU   @01
PTRCVT   EQU   @02
PTRICN   EQU   @03
PTRLUN   EQU   @04
PTRFMC   EQU   @05
PTRZOB   EQU   @06
PTRLSC   EQU   @07
PTRLCP   EQU   @07
WKREG7   EQU   @07
WKREG8   EQU   @08
WKREG9   EQU   @09
ZCRREG   EQU   @10
R12      EQU   @12
SAVREG   EQU   @13
LNKREG   EQU   @14
RCDREG   EQU   @15
GPR00F   EQU   @00
GPR00P   EQU   @00
GPR01P   EQU   @01
GPR02P   EQU   @02
GPR03P   EQU   @03
GPR04P   EQU   @04
GPR05P   EQU   @05
GPR06P   EQU   @06
GPR07P   EQU   @07
GPR12P   EQU   @12
GPR13P   EQU   @13
GPR15P   EQU   @15
GPR08P   EQU   @08
GPR09P   EQU   @09
GPR10P   EQU   @10
GPR11P   EQU   @11
GPR14P   EQU   @14
GPR01F   EQU   @01
GPR02F   EQU   @02
GPR03F   EQU   @03
GPR04F   EQU   @04
GPR05F   EQU   @05
GPR06F   EQU   @06
GPR07F   EQU   @07
GPR08F   EQU   @08
GPR09F   EQU   @09
GPR10F   EQU   @10
GPR11F   EQU   @11
GPR12F   EQU   @12
GPR13F   EQU   @13
GPR14F   EQU   @14
GPR15F   EQU   @15
WKREG0   EQU   @00
ATCLCPTR EQU   1032
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTPTR   EQU   0
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTSHS   EQU   CVTXTNT2+40
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
IOSB     EQU   0
IOSFLA   EQU   IOSB
IOSACHN  EQU   IOSFLA
IOSFLB   EQU   IOSB+1
IOSFLC   EQU   IOSB+2
IOSDVALT EQU   IOSFLC
IOSPKEY  EQU   IOSB+12
IOSOPT   EQU   IOSB+14
IOSOPT2  EQU   IOSB+15
@NM00004 EQU   IOSB+20
IOSCSW   EQU   @NM00004+1
IOSTATUS EQU   IOSCSW+3
IOSIPIB  EQU   IOSB+44
IOSPATH  EQU   IOSB+86
IOSCHN   EQU   IOSPATH
IOSCKEY  EQU   IOSB+89
IOSEEKA  EQU   IOSB+100
IOSCCHH  EQU   IOSEEKA+3
IOSSKHH  EQU   IOSCCHH+2
SRBSECT  EQU   0
SRBFLC   EQU   SRBSECT+12
ISTRPH   EQU   0
RPHCNTL  EQU   ISTRPH
RPHFLAGS EQU   RPHCNTL+2
RPHAPTYP EQU   RPHFLAGS
RPHFSTLC EQU   RPHFLAGS
RPHFLGB  EQU   RPHCNTL+3
RPHRPHA  EQU   ISTRPH+4
RPHTSKID EQU   ISTRPH+8
RPHRESMA EQU   ISTRPH+16
RPHWPFLG EQU   RPHRESMA
RPHPABOF EQU   ISTRPH+20
RPHMAJCB EQU   ISTRPH+21
RPHWEA   EQU   ISTRPH+24
RPHCSPA  EQU   RPHWEA
RPHSRPRM EQU   ISTRPH+28
RPHCRR   EQU   ISTRPH+32
RPHPABQA EQU   ISTRPH+36
RPHWORK  EQU   ISTRPH+40
RPHSAVE1 EQU   RPHWORK
RPHSBITS EQU   RPHSAVE1+1
ISTLOK   EQU   0
LOKCHN   EQU   ISTLOK+1
LOKCHNG  EQU   LOKCHN
@NM00016 EQU   LOKCHNG+2
ISTFDB   EQU   0
ISTFSB   EQU   0
FSBFSB   EQU   ISTFSB
FSBMNRCD EQU   FSBFSB+2
FSBSFLGS EQU   FSBFSB+3
FSBFSBA  EQU   FSBFSB+4
FSBBTH   EQU   FSBFSB+8
FSBCID   EQU   FSBBTH
FSBRQTAG EQU   FSBBTH+4
FSBSEQID EQU   FSBRQTAG
FSBFLAGS EQU   FSBSEQID
FSBSEQ   EQU   FSBSEQID+1
FSBCSWST EQU   FSBBTH+6
FSBTHFLD EQU   FSBCSWST
FSBTH1   EQU   FSBTHFLD
FSBSYSRS EQU   FSBTH1
FSBTH2   EQU   FSBTHFLD+1
FSBEXTRS EQU   FSBTH2
FSBXFSTS EQU   FSBEXTRS
FSBXCODE EQU   FSBEXTRS
FSBNETRS EQU   FSBFSB+16
FSBSRCAT EQU   FSBNETRS
FSBERC   EQU   FSBNETRS+1
FSBFBMI  EQU   FSBERC
FSBDMGRS EQU   FSBFSB+18
FSBSS1   EQU   FSBDMGRS
FSBSS2   EQU   FSBDMGRS+1
FSBLCPB  EQU   FSBFSB+20
FSBMSGID EQU   FSBLCPB
FSBLCCWA EQU   FSBFSB+24
FSBRLSTS EQU   FSBLCCWA
FSBPTR   EQU   0
ISTZSAVE EQU   0
ZSAZSVBC EQU   ISTZSAVE
ZSAZSVMS EQU   ZSAZSVBC
ZSAZSVFC EQU   ISTZSAVE+4
ISTLCCW  EQU   0
LCCWOP   EQU   ISTLCCW
LCCWRWOP EQU   LCCWOP
LCCWCTL  EQU   LCCWRWOP
LCCWFLAG EQU   ISTLCCW+1
LCCWLSI  EQU   LCCWFLAG
ISTLCPB  EQU   0
LCPTYPE  EQU   ISTLCPB
LCPREQTG EQU   ISTLCPB+2
LCPFLAGS EQU   LCPREQTG
LCPZF001 EQU   LCPFLAGS
LCPZRT02 EQU   LCPZF001
LCPZF002 EQU   LCPFLAGS
LCPZRT03 EQU   LCPZF002
LCPZF003 EQU   LCPFLAGS
LCPZRT04 EQU   LCPZF003
LCPZF004 EQU   LCPFLAGS
LCPZRT05 EQU   LCPZF004
LCPZRT06 EQU   LCPFLAGS
LCPZRT07 EQU   LCPFLAGS
LCPMNRCD EQU   LCPREQTG+1
LCPZRT08 EQU   LCPMNRCD
LCPZRT09 EQU   LCPMNRCD
LCPCHAIN EQU   ISTLCPB+4
LCPCHAI1 EQU   LCPCHAIN
LCPRUCNT EQU   ISTLCPB+8
LCPFLAG2 EQU   ISTLCPB+9
LCPRSTRT EQU   LCPFLAG2
LCPTLBPI EQU   LCPFLAG2
LCPFID0  EQU   LCPFLAG2
LCPSEQ   EQU   ISTLCPB+10
LCPCID   EQU   ISTLCPB+16
LCPNXLCW EQU   ISTLCPB+20
LCPFDBA  EQU   ISTLCPB+24
LCPFLG1  EQU   ISTLCPB+37
LCPINTER EQU   LCPFLG1
LCPFLCCW EQU   ISTLCPB+40
LCPLCCW  EQU   ISTLCPB+48
LCPPABA  EQU   LCPLCCW+4
LCPRPHA  EQU   LCPPABA
LCPBPTR  EQU   0
ISTZCRR  EQU   0
ZCRCRR   EQU   ISTZCRR
ZCRID    EQU   ZCRCRR
ZCRLEN   EQU   ZCRCRR+1
ZCRCHAIN EQU   ISTZCRR+4
ZCRFRRA  EQU   ISTZCRR+8
ZCRFLGS1 EQU   ISTZCRR+12
ZCRFLGS2 EQU   ISTZCRR+13
ZCRSHEDI EQU   ZCRFLGS2
ZCROB    EQU   ZCRFLGS2
ZCRSWFLD EQU   ISTZCRR+14
ZCRENDSH EQU   ZCRSWFLD
ZCREXTYP EQU   ZCRSWFLD
ZCRNDLCP EQU   ZCRSWFLD
ZCRRESET EQU   ZCRSWFLD
ZCRFLGS3 EQU   ISTZCRR+15
ZCRGENSW EQU   ISTZCRR+16
ZCRPFLGS EQU   ISTZCRR+17
ZCRQAHED EQU   ZCRPFLGS
ZCRIBPR  EQU   ISTZCRR+18
ZCRSCPSW EQU   ISTZCRR+19
ZCRPARMS EQU   ISTZCRR+24
ZCRFBPTR EQU   ZCRPARMS
ZCRDFRDA EQU   ZCRPARMS+10
ZCRPCOD1 EQU   ZCRPARMS+12
ZCRPLSBF EQU   ZCRPCOD1
ZCRPLSCB EQU   ZCRPCOD1
ZCRPBUF  EQU   ZCRPCOD1
ZCRPCOD2 EQU   ZCRPARMS+13
ZCRSVRTN EQU   ISTZCRR+56
ZCRSVF1  EQU   ZCRSVRTN
ZCRSVF2  EQU   ZCRSVRTN+4
ZCRWKARA EQU   ISTZCRR+156
ZCRCIDSV EQU   ISTZCRR+192
ZCRSAVEZ EQU   ISTZCRR+196
ZCRAUDIT EQU   ISTZCRR+440
ZCRTID   EQU   ZCRAUDIT
ZCRTNAME EQU   ZCRAUDIT+1
ZCRENTER EQU   ZCRAUDIT+5
ZCREAC1B EQU   ZCRENTER
ZCRLCPB  EQU   ISTZCRR+480
ZCRRHRU  EQU   ZCRLCPB
ISTPFCRR EQU   0
PFCCRR   EQU   ISTPFCRR
PFCCRRID EQU   PFCCRR
PFCCRRLN EQU   PFCCRR+2
PFCHDR   EQU   ISTPFCRR+4
PFCCRRO  EQU   PFCHDR
PFCFRRO  EQU   PFCHDR+4
ISTCFCRR EQU   0
CFCAUDIT EQU   ISTCFCRR
CFCNTRD  EQU   CFCAUDIT
CFCCRT   EQU   CFCAUDIT+1
ISTASCRR EQU   0
ASCFLAGS EQU   ISTASCRR+16
ASCFLG1  EQU   ASCFLAGS
ASCFLG2  EQU   ASCFLAGS+2
ASCFLG3  EQU   ASCFLAGS+4
ASCUSRGS EQU   ISTASCRR+28
ISTAPCRR EQU   0
APCATFLG EQU   ISTAPCRR+16
APCRFLG  EQU   ISTAPCRR+18
APCSAVE  EQU   ISTAPCRR+44
APCCOMF  EQU   ISTAPCRR+116
APCCOMF1 EQU   APCCOMF
APC31FLG EQU   ISTAPCRR+132
APC52FLG EQU   ISTAPCRR+133
APC53FLG EQU   ISTAPCRR+134
APC54FLG EQU   ISTAPCRR+135
APC57FLG EQU   ISTAPCRR+136
ISTCRA   EQU   0
CRABASIC EQU   ISTCRA
CRAHDR   EQU   CRABASIC
CRACRR   EQU   CRAHDR
CRAFRR   EQU   CRAHDR+4
CRALKACT EQU   CRABASIC+8
CRAL4PTR EQU   CRABASIC+24
CRAPROCR EQU   ISTCRA+312
CRASVC   EQU   ISTCRA+848
CRABUFA  EQU   CRASVC+68
ISTPAB   EQU   0
PABWQCHN EQU   ISTPAB
PABWEQA  EQU   PABWQCHN
PABWEQP  EQU   PABWEQA+1
PABCHAIN EQU   PABWQCHN+4
PABDVTA  EQU   ISTPAB+9
PABRPHFG EQU   ISTPAB+12
PABFLAGS EQU   PABRPHFG
PABERLCK EQU   PABFLAGS
PABERRLK EQU   PABERLCK
ISTDEVCH EQU   0
DEVSHCH  EQU   ISTDEVCH
DEVCHAR  EQU   DEVSHCH
DEVTCODE EQU   ISTDEVCH+1
DEVFLAGS EQU   ISTDEVCH+3
DEVFCCTL EQU   DEVFLAGS
DEVCHAR3 EQU   DEVFLAGS
ISTNCB   EQU   0
NCBTYPE  EQU   ISTNCB
NCBNSNA  EQU   ISTNCB+12
NCBFLAGS EQU   ISTNCB+24
NCBFRAS  EQU   NCBFLAGS+1
NCBFTRIO EQU   NCBFRAS
NCBFLAG1 EQU   NCBFLAGS+2
ISTLUNCB EQU   0
LUNCB    EQU   ISTLUNCB
LUNZOS   EQU   ISTLUNCB+48
ISTPROCD EQU   0
PROPROC  EQU   ISTPROCD
PROPROC1 EQU   PROPROC
PROPROC2 EQU   PROPROC+1
PROCFTX  EQU   PROPROC2
PROPROC3 EQU   PROPROC+2
PROPROC4 EQU   PROPROC+3
PROPROCS EQU   0
PROSETMS EQU   PROPROCS+1
PROSETM2 EQU   PROSETMS
PROSETM3 EQU   PROSETMS+1
PROSETM4 EQU   PROSETMS+2
ISTFMCB  EQU   0
FMCDNCBA EQU   ISTFMCB+16
FMCSTAT  EQU   ISTFMCB+28
FMCSTAT1 EQU   ISTFMCB+29
FMCCMDFL EQU   ISTFMCB+31
FMCCMPS1 EQU   ISTFMCB+36
FMCPROCD EQU   ISTFMCB+48
FMCPAB3  EQU   ISTFMCB+96
FMCPAB5  EQU   ISTFMCB+128
FMCSIPA  EQU   ISTFMCB+148
FMCNXOSQ EQU   ISTFMCB+152
FMCNXCFM EQU   FMCNXOSQ
FMCOSSN  EQU   FMCNXCFM
FMCNXOSC EQU   FMCNXOSQ+2
FMCSSTAT EQU   ISTFMCB+159
FMCCIPI  EQU   FMCSSTAT
FMCUIPI  EQU   FMCSSTAT
FMCPURCH EQU   FMCSSTAT
FMCCONF  EQU   FMCSSTAT
FMCPACE  EQU   ISTFMCB+160
FMCPACEN EQU   FMCPACE
FMCNPCNT EQU   FMCPACEN
FMCPACEM EQU   FMCPACE+1
FMCMPCNT EQU   FMCPACEM
FMCPACPC EQU   FMCPACE+2
FMCCPCNT EQU   FMCPACPC
FMCCVAL  EQU   FMCPACE+3
FMCOBCE  EQU   FMCCVAL
FMCCLEXT EQU   ISTFMCB+164
FMCRPLA  EQU   FMCCLEXT
FMCFBA   EQU   FMCCLEXT+4
FMCCMPS2 EQU   FMCCLEXT+16
FMCFLGA  EQU   FMCCMPS2
FMCFLGCL EQU   FMCCMPS2+1
FMCPSCMD EQU   FMCCMPS2+2
FMCPSTAT EQU   FMCCMPS2+3
FMCSTAT2 EQU   ISTFMCB+186
FMCMODEB EQU   ISTFMCB+189
FMCCLSEQ EQU   ISTFMCB+190
FMCRRESP EQU   ISTFMCB+195
FMCSSEGQ EQU   ISTFMCB+200
FMCLOCK  EQU   ISTFMCB+204
FMCFBAS  EQU   ISTFMCB+216
FMCZV002 EQU   FMCFBAS
FMCSNCTL EQU   ISTFMCB+224
FMCSCFLG EQU   FMCSNCTL
FMCVS1   EQU   ISTFMCB+232
FMCZFLAG EQU   FMCVS1
FMCZF006 EQU   FMCZFLAG
FMCSHEDQ EQU   FMCVS1+8
FMCLBXM  EQU   FMCVS1+12
FMCSHEAQ EQU   FMCLBXM
FMCASCDQ EQU   FMCSHEAQ+1
FMCLCPBQ EQU   FMCVS1+16
FMCLCPAQ EQU   FMCVS1+20
FMCSEQ1  EQU   FMCVS1+34
FMCZFLG2 EQU   FMCVS1+35
FMCCVFLG EQU   FMCVS1+44
FMCBPTR  EQU   0
FMCFLAG  EQU   0
FMCFLGB  EQU   FMCFLAG
ISTICNCB EQU   0
@NM00043 EQU   ISTICNCB+53
ICNCKFLD EQU   ISTICNCB+96
ICNFLAG  EQU   ISTICNCB+100
ICNZF006 EQU   ICNFLAG
ICNZF010 EQU   ICNFLAG
ICNFFLAG EQU   ISTICNCB+101
ICNZSWS  EQU   ISTICNCB+102
ICNFLAG2 EQU   ISTICNCB+236
ICNZD001 EQU   ISTICNCB+288
ICNWSCCW EQU   ICNZD001
ICNZD002 EQU   ISTICNCB+296
ICNZD003 EQU   ISTICNCB+320
ICNRSCCW EQU   ICNZD003
ICNZD004 EQU   ISTICNCB+328
ICNZS1VR EQU   ISTICNCB+348
ICNSRV02 EQU   ICNZS1VR
ICNDIEWA EQU   ICNSRV02
ICNDCDEB EQU   ISTICNCB+480
ICNDIDEB EQU   ICNDCDEB+12
ICNZFLAG EQU   ISTICNCB+508
ICNZH002 EQU   ISTICNCB+509
ICNZS002 EQU   ICNZH002
ICNZS003 EQU   ICNZH002
ICNZS004 EQU   ICNZH002
ICNZS006 EQU   ICNZH002
ICNZS007 EQU   ICNZH002
ICNZS008 EQU   ICNZH002
ICNZS009 EQU   ICNZH002+1
ICNZS00A EQU   ICNZH002+1
ICNZCONS EQU   ISTICNCB+680
ISTDYPAB EQU   0
ISTATCVT EQU   0
ATCCOM   EQU   ISTATCVT
ATCSTAT  EQU   ATCCOM
ATCSTAT1 EQU   ATCSTAT
ATCSTFLG EQU   ATCSTAT+1
ATCPOFLG EQU   ATCSTAT+2
ATCSTAT4 EQU   ATCSTAT+3
ATCIOTRC EQU   ATCCOM+140
ATCTHTRC EQU   ATCIOTRC
ATCCSMR  EQU   ISTATCVT+296
ATCSHRFG EQU   ISTATCVT+316
ATCHPGM  EQU   ISTATCVT+384
ATCAP33  EQU   ISTATCVT+444
ATCAP36  EQU   ISTATCVT+452
ATCVLCNT EQU   ISTATCVT+772
ATCRNO   EQU   ISTATCVT+788
ATCSOPD  EQU   ISTATCVT+792
ATCSIPD  EQU   ISTATCVT+800
ATCSECST EQU   ISTATCVT+812
ATCSTAT2 EQU   ISTATCVT+818
ATCVTBAM EQU   ISTATCVT+908
@NM00057 EQU   ATCVTBAM+3
ATCAOSM  EQU   ISTATCVT+912
ATCGSRBQ EQU   ATCAOSM+4
ATCGSRBG EQU   ATCGSRBQ
ATCAP31  EQU   ATCAOSM+24
ATCZFSVT EQU   ATCAOSM+68
ATCZPSVT EQU   ATCAOSM+72
ATCICAPP EQU   ATCAOSM+100
ATCLDAPP EQU   ATCAOSM+120
ATCDAPVT EQU   ATCAOSM+140
ATCAP38  EQU   ATCAOSM+268
ATCCRA   EQU   ATCAOSM+280
ATCCRACN EQU   ATCCRA+4
ATCSRB   EQU   ATCAOSM+288
ATCSRBCN EQU   ATCSRB+4
ATCCRPL  EQU   ATCAOSM+296
ATCRPLCN EQU   ATCCRPL+4
ATCSQAFR EQU   ATCAOSM+304
ATCORTBC EQU   ATCSQAFR+4
ATCORSRB EQU   ATCORTBC
@NM00059 EQU   ATCAOSM+332
ATCVTFLG EQU   ATCAOSM+392
ATCZFLAG EQU   ATCAOSM+588
ISTLSCB  EQU   0
LSC1WORD EQU   ISTLSCB
LSCTYPE  EQU   LSC1WORD
LSCREQTG EQU   LSC1WORD+2
LSCZRT02 EQU   LSCREQTG
LSCZRT03 EQU   LSCREQTG
LSCZRT04 EQU   LSCREQTG
LSCZRT05 EQU   LSCREQTG
LSCZRT06 EQU   LSCREQTG
LSCZRT07 EQU   LSCREQTG
LSCZMNRC EQU   LSCREQTG+1
LSCZRT08 EQU   LSCZMNRC
LSCZRT09 EQU   LSCZMNRC
LSCCHAIN EQU   ISTLSCB+4
LSCCHAI1 EQU   LSCCHAIN
LSCRUCNT EQU   ISTLSCB+8
LSCFLGS  EQU   ISTLSCB+9
LSCSEQ   EQU   ISTLSCB+10
LSCFDBA  EQU   ISTLSCB+24
ISTBDU   EQU   0
BDUMODIF EQU   ISTBDU+1
BDUMOD1  EQU   BDUMODIF
BDUDAF   EQU   ISTBDU+2
BDUFUNC  EQU   BDUDAF
BDUCHECK EQU   BDUFUNC
BDUFLAGS EQU   BDUDAF+1
BDUPTR   EQU   0
ISTBTU   EQU   0
BTUBTH   EQU   ISTBTU
BTUFID   EQU   BTUBTH
BTUREQ   EQU   BTUBTH+6
BTURQFLG EQU   BTUREQ
BTURH    EQU   BTUBTH+10
BTUSYSTR EQU   ISTBTU+18
BTUPTR   EQU   0
ISTLH    EQU   0
ISTTH    EQU   0
THFLAG1  EQU   ISTTH
THFLGA   EQU   THFLAG1
THMPF    EQU   THFLGA
THFLGB   EQU   THFLAG1+1
ISTTH2   EQU   0
TH2FLAG1 EQU   ISTTH2
TH2MPF   EQU   TH2FLAG1
ISTZOBUF EQU   0
ZOBFSM   EQU   ISTZOBUF+4
ISTZPSVT EQU   0
ZPSZDFH0 EQU   ISTZPSVT+12
ZPSZDFB0 EQU   ISTZPSVT+16
ZPSZBFY0 EQU   ISTZPSVT+24
ISTZFSVT EQU   0
ZFSZEFBB EQU   ISTZFSVT
ZFSZEABB EQU   ZFSZEFBB
ZFSZEFAB EQU   ISTZFSVT+4
ZFSZEAAB EQU   ZFSZEFAB
ISTZLBVT EQU   0
ZLBZBF0B EQU   ISTZLBVT+4
ZLBZBFSC EQU   ISTZLBVT+88
ISTZIBUF EQU   0
ZIBFSM   EQU   ISTZIBUF+4
ISTRH    EQU   0
RHFLAGS  EQU   ISTRH
RH1      EQU   RHFLAGS
RHQS     EQU   RH1
RHCHAIN  EQU   RH1
RH2      EQU   RHFLAGS+1
RHFME    EQU   RH2
RHRRN    EQU   RH2
RHEXCEPT EQU   RH2
RHRETRY  EQU   RH2
RHRSVD1  EQU   RH2
RHPACE   EQU   RH2
RH3      EQU   RHFLAGS+2
ISTWKE   EQU   0
WKECHAIN EQU   ISTWKE+4
WKEFLAGS EQU   WKECHAIN
WKEPTR   EQU   0
QUEHDR   EQU   0
ISTZBF0B EQU   0
ISTZDFH0 EQU   0
ISTZBFSC EQU   0
ISTZBFY0 EQU   0
ISTZDFB0 EQU   0
ISTZEFBB EQU   0
FMZL0026 EQU   0
ISTAPC38 EQU   0
FMZL0040 EQU   0
FMZL0050 EQU   0
FMZL0058 EQU   0
AVTPTR   EQU   0
IOBPRPTR EQU   0
IOBSTPTR EQU   0
ZIBSRB   EQU   0
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
IOSATTSC EQU   IOSIPIB
IOSWTOWA EQU   IOSIPIB
IOSPCISC EQU   IOSIPIB
FSBCOMBN EQU   FSBNETRS
FSBRHFLD EQU   FSBCOMBN+1
FSBRH3   EQU   FSBRHFLD+2
FSBLDFLG EQU   FSBRH3
@NM00021 EQU   FSBRQTAG
LCPZTIE  EQU   LCPCID
LCPZSNAM EQU   LCPZTIE+8
ZOBDLBT  EQU   ISTZOBUF
ZOBDLBCM EQU   ZOBDLBT
@NM00064 EQU   ZOBDLBCM+25
ZOBBTU   EQU   ZOBDLBT+28
ZOBWCC   EQU   ZOBDLBT+48
ZOBECCC  EQU   ZOBDLBT+50
ZOBDIO   EQU   ZOBFSM
ZOBCCW2  EQU   ZOBDIO+8
ZOBCPTCC EQU   ZOBCCW2
ZOBFLAGS EQU   ZOBCCW2+5
ZOBRT06  EQU   ZOBFLAGS
ZOBRT08  EQU   ZOBFLAGS
ZOBCCW3  EQU   ZOBDIO+16
ZOBCPTRC EQU   ZOBCCW3
ZOBCPN2C EQU   ZOBCPTRC
ZOBCPTRA EQU   ZOBCCW3+1
@NM00068 EQU   ZOBBTU
ZIBDIO   EQU   ZIBFSM
ZIBCCW2  EQU   ZIBDIO+8
ZIBCPTCC EQU   ZIBCCW2
ZIBAIO   EQU   ISTZIBUF
ZIBAIOCM EQU   ZIBAIO
ZIBFIB   EQU   ZIBAIO+16
ZIBFSB   EQU   ZIBFIB
ZIBMDREC EQU   ZIBFSB+4
ZIBMDRIN EQU   ZIBFSB+28
ZIBBTU   EQU   ZIBFIB+32
@NM00072 EQU   ZIBBTU+12
ZIBFID1  EQU   @NM00072+1
ZIBFITXT EQU   ZIBFID1
ZIBSIB   EQU   ZIBFIB
ZIBREC   EQU   ZIBMDRIN
ZIBRECPL EQU   ZIBREC
ZIBRECHD EQU   ZIBRECPL
ZIBRECRS EQU   ZIBREC+8
ZIBRECDT EQU   ZIBREC+10
ZIBMDRRC EQU   ZIBMDREC
ZIBRCPL  EQU   ZIBMDRRC
ZIBRCDT  EQU   ZIBMDRRC+24
@NM00074 EQU   ZIBBTU
SRB      EQU   SRBSECT
ZOBTEXT  EQU   ZOBBTU
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
ZIBTH2   EQU   @NM00074+4
ZIBLH    EQU   @NM00074
ZIBRCTXT EQU   ZIBMDRRC+36
ZIBRCRID EQU   ZIBRCDT+10
ZIBRCNAM EQU   ZIBRCDT+2
ZIBRCUA  EQU   ZIBRCDT
ZIBRCPUI EQU   ZIBRCPL+20
ZIBRCPUN EQU   ZIBRCPL+16
ZIBRCTIM EQU   ZIBRCPL+12
ZIBRCDAT EQU   ZIBRCPL+8
ZIBRCRS1 EQU   ZIBRCPL+6
ZIBRCSID EQU   ZIBRCPL+5
ZIBRCID  EQU   ZIBRCPL+4
ZIBRCSW  EQU   ZIBRCPL+2
ZIBRCSYR EQU   ZIBRCPL+1
ZIBRCL   EQU   ZIBRCPL
ZIBRECTX EQU   ZIBREC+22
ZIBRECID EQU   ZIBRECDT+10
ZIBRECNA EQU   ZIBRECDT+2
ZIBRECUA EQU   ZIBRECDT
ZIBRECSV EQU   ZIBRECRS
ZIBRECDA EQU   ZIBRECPL+4
ZIBRECSI EQU   ZIBRECHD+3
ZIBRECDV EQU   ZIBRECHD+2
ZIBRECFL EQU   ZIBRECHD+1
ZIBRECTY EQU   ZIBRECHD
ZIBTEXT  EQU   ZIBSIB+4
ZIBRSV04 EQU   ZIBSIB
ZIBTEXT2 EQU   ZIBFITXT
ZIBTEXT1 EQU   ZIBFIB+52
@NM00073 EQU   @NM00072
ZIBFDBS  EQU   ZIBBTU
@NM00071 EQU   ZIBMDREC
@NM00070 EQU   ZIBFSB
ZIBLNG2  EQU   ZIBAIOCM+14
ZIBRSV03 EQU   ZIBAIOCM+13
ZIBWKBYT EQU   ZIBAIOCM+12
ZIBFDBZ  EQU   ZIBAIOCM
ZIBCPNPK EQU   ZIBCCW2+6
ZIBRSV02 EQU   ZIBCCW2+5
ZIBCPTPF EQU   ZIBCCW2+4
ZIBCPTCA EQU   ZIBCCW2+1
ZIBCPNPC EQU   ZIBCPTCC
ZIBCPRDK EQU   ZIBDIO+6
ZIBRSV01 EQU   ZIBDIO+5
ZIBCPRDF EQU   ZIBDIO+4
ZIBCPTXA EQU   ZIBDIO+1
ZIBCPRDC EQU   ZIBDIO
ZOBTH2   EQU   @NM00068+4
ZOBLH    EQU   @NM00068
ZOBCPN2K EQU   ZOBCCW3+6
ZOBRSV99 EQU   ZOBCCW3+5
ZOBCPN2F EQU   ZOBCCW3+4
ZOBCPTC2 EQU   ZOBCPTRA
ZOBCPTC1 EQU   ZOBCPN2C
ZOBCPNPK EQU   ZOBCCW2+6
ZOBRSV03 EQU   ZOBFLAGS
ZOBCPNPF EQU   ZOBCCW2+4
ZOBCPTCA EQU   ZOBCCW2+1
ZOBCPNPC EQU   ZOBCPTCC
ZOBCPWTK EQU   ZOBDIO+6
ZOBRSV02 EQU   ZOBDIO+5
ZOBCPWTF EQU   ZOBDIO+4
ZOBCPTXA EQU   ZOBDIO+1
ZOBCPWTC EQU   ZOBDIO
ZOBRSV09 EQU   ZOBECCC
ZOBECSP  EQU   ZOBECCC
ZOBRSV08 EQU   ZOBECCC
ZOBRSV07 EQU   ZOBDLBT+49
ZOBRSV06 EQU   ZOBWCC
ZOBWCSP  EQU   ZOBWCC
ZOBRSV05 EQU   ZOBWCC
ZOBRSV10 EQU   ZOBDLBCM+26
@NM00067 EQU   @NM00064
@NM00066 EQU   @NM00064
@NM00065 EQU   @NM00064
ZOBRSV04 EQU   ZOBDLBCM+16
ZOBLNG2  EQU   ZOBDLBCM+14
ZOBRSV01 EQU   ZOBDLBCM+12
ZOBFDB   EQU   ZOBDLBCM
LCPZTRV4 EQU   LCPZSNAM+4
LCPZTRV1 EQU   LCPZSNAM
LCPZSNA  EQU   LCPZTIE+4
LCPZFMCA EQU   LCPZTIE
FSBRT0B  EQU   @NM00021+1
FSBRT0A  EQU   @NM00021+1
FSBRT09  EQU   @NM00021+1
FSBRT08  EQU   @NM00021+1
FSBRT07  EQU   @NM00021
FSBRT06  EQU   @NM00021
FSBRT05  EQU   @NM00021
FSBRT04  EQU   @NM00021
FSBRT03  EQU   @NM00021
FSBRT02  EQU   @NM00021
FSBRT01  EQU   @NM00021
FSBRT00  EQU   @NM00021
FSBLDCUF EQU   FSBLDFLG
FSBLDSIF EQU   FSBLDFLG
FSBLDSOF EQU   FSBLDFLG
FSBLDEBF EQU   FSBLDFLG
FSBLDBBF EQU   FSBLDFLG
FSBLDFME EQU   FSBLDFLG
FSBLDSCF EQU   FSBLDFLG
FSBLDRMF EQU   FSBLDFLG
FSBRH2   EQU   FSBRHFLD+1
FSBRH1   EQU   FSBRHFLD
FSBALIGN EQU   FSBCOMBN
IOSPCIWA EQU   IOSPCISC+44
IOSPCIRS EQU   IOSPCISC+8
@NM00009 EQU   IOSPCISC+4
@NM00008 EQU   IOSPCISC
IOSWRNDR EQU   IOSWTOWA+4
IOSWTOPT EQU   IOSWTOWA+3
IOSWTOCP EQU   IOSWTOWA+2
IOSWTOCH EQU   IOSWTOWA
IOSATTWA EQU   IOSATTSC+40
@NM00007 EQU   IOSATTSC+24
IOSATTSN EQU   IOSATTSC
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTRV620 EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTIRM   EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRV607 EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
WKECHNGP EQU   WKECHAIN+1
@NM00076 EQU   WKEFLAGS
WKEGATE  EQU   WKEFLAGS
@NM00075 EQU   ISTWKE
RHRSVD5  EQU   RH3
RHRSVD4  EQU   RH3
RHLOG    EQU   RH3
RHRSVD3  EQU   RH3
RHRCDIR  EQU   RH3
RHCDIR   EQU   RH3
RHEB     EQU   RH3
RHBB     EQU   RH3
RHRSVD2  EQU   RH2
RHINOP   EQU   RHRSVD1
RHBUSY   EQU   RHRETRY
RHPE     EQU   RH2
RHSENSE  EQU   RH1
RHFORMAT EQU   RH1
RHDIRI   EQU   RH1
RHSCI    EQU   RH1
RHTYPE   EQU   RH1
ZIBLNG1  EQU   ZIBFSM
ZIBCHAIN EQU   ISTZIBUF
ZLBZIFVB EQU   ISTZLBVT+84
ZLBZIFUB EQU   ISTZLBVT+80
ZLBZIFSB EQU   ISTZLBVT+76
ZLBRSV22 EQU   ISTZLBVT+72
ZLBZBFID EQU   ISTZLBVT+68
ZLBZBFX0 EQU   ISTZLBVT+64
ZLBRSV02 EQU   ISTZLBVT+60
ZLBRSV21 EQU   ISTZLBVT+56
ZLBZBFJB EQU   ISTZLBVT+52
ZLBZBFIB EQU   ISTZLBVT+48
ZLBZBFHB EQU   ISTZLBVT+44
ZLBZBFGB EQU   ISTZLBVT+40
ZLBZBFFB EQU   ISTZLBVT+36
ZLBZBFEB EQU   ISTZLBVT+32
ZLBZBFDB EQU   ISTZLBVT+28
ZLBZBFCB EQU   ISTZLBVT+24
ZLBZBFBB EQU   ISTZLBVT+20
ZLBZBFAB EQU   ISTZLBVT+16
ZLBZBFNB EQU   ISTZLBVT+12
ZLBZCFAI EQU   ISTZLBVT+8
ZLBZAF0B EQU   ISTZLBVT
ZFSZWRD4 EQU   ISTZFSVT+36
ZFSZWRD3 EQU   ISTZFSVT+32
ZFSZEFCB EQU   ISTZFSVT+28
ZFSZFFEB EQU   ISTZFSVT+24
ZFSZDFJ0 EQU   ISTZFSVT+20
ZFSZFFFB EQU   ISTZFSVT+16
ZFSZFFDB EQU   ISTZFSVT+12
ZFSZFFCB EQU   ISTZFSVT+8
ZFSZEMAB EQU   ZFSZEAAB
ZFSZEMBB EQU   ZFSZEABB
ZPSZDFQR EQU   ISTZPSVT+80
ZPSZDFPR EQU   ISTZPSVT+76
ZPSZDFXR EQU   ISTZPSVT+72
ZPSZWRD5 EQU   ISTZPSVT+68
ZPSZWRD4 EQU   ISTZPSVT+64
ZPSZDFMB EQU   ISTZPSVT+60
ZPSZDFMF EQU   ISTZPSVT+56
ZPSZDFNB EQU   ISTZPSVT+52
@NM00069 EQU   ISTZPSVT+48
ZPSZDFF0 EQU   ISTZPSVT+44
ZPSZTRTT EQU   ISTZPSVT+40
ZPSZBFOB EQU   ISTZPSVT+36
ZPSZBFMB EQU   ISTZPSVT+32
ZPSZBFZ0 EQU   ISTZPSVT+28
ZPSZDFI0 EQU   ISTZPSVT+20
ZPSZDFD0 EQU   ISTZPSVT+8
ZPSZDFC0 EQU   ISTZPSVT+4
ZPSZDFA0 EQU   ISTZPSVT
ZOBLNG1  EQU   ZOBFSM
ZOBCHAIN EQU   ISTZOBUF
TH2SNF   EQU   ISTTH2+4
TH2OAF   EQU   ISTTH2+3
TH2DAF   EQU   ISTTH2+2
TH2CDF   EQU   TH2FLAG1+1
TH2SEF   EQU   TH2FLAG1+1
TH2PYF   EQU   TH2FLAG1+1
TH2AFI   EQU   TH2FLAG1
TH2PSI   EQU   TH2FLAG1
TH2CMPLI EQU   TH2MPF
TH2RHI   EQU   TH2MPF
TH2FID   EQU   TH2FLAG1
THDCF    EQU   ISTTH+8
THSNF    EQU   ISTTH+6
THOAF    EQU   ISTTH+4
THDAF    EQU   ISTTH+2
THCDF    EQU   THFLGB
THSEF    EQU   THFLGB
THPYF    EQU   THFLGB
THAFI    EQU   THFLGA
THPSI    EQU   THFLGA
THCMPLI  EQU   THMPF
THRHI    EQU   THMPF
THFID    EQU   THFLAG1
LHVDATA  EQU   ISTLH+4
LHFUNCT  EQU   ISTLH+3
@NM00063 EQU   ISTLH+2
LHLEN    EQU   ISTLH
BTUTEXT  EQU   ISTBTU+20
BTUEXTR  EQU   ISTBTU+19
BTURSV02 EQU   BTUSYSTR
BTUPHASE EQU   BTUSYSTR
BTURSV01 EQU   BTUSYSTR
BTUBDU   EQU   ISTBTU+14
BTUPAD   EQU   BTURH+3
BTURH3   EQU   BTURH+2
BTURH2   EQU   BTURH+1
BTURH1   EQU   BTURH
BTUDCF   EQU   BTUBTH+8
BTUZRTSC EQU   BTURQFLG+1
BTUZRT0B EQU   BTURQFLG+1
BTUZRT0A EQU   BTURQFLG+1
BTUZRT09 EQU   BTURQFLG+1
BTUZRT08 EQU   BTURQFLG+1
BTUZRT07 EQU   BTURQFLG
BTUZRT06 EQU   BTURQFLG
BTUZRT05 EQU   BTURQFLG
BTUZRT04 EQU   BTURQFLG
BTUZRT03 EQU   BTURQFLG
BTUZRT02 EQU   BTURQFLG
BTUZRT01 EQU   BTURQFLG
BTUZRT00 EQU   BTURQFLG
BTUSORCE EQU   BTUBTH+4
BTUDEST  EQU   BTUBTH+2
BTUCDF   EQU   BTUFID+1
BTUSCF   EQU   BTUFID+1
BTUPRY   EQU   BTUFID+1
BTUASFL  EQU   BTUFID
BTUPSFL  EQU   BTUFID
BTUMPF   EQU   BTUFID
BTUFIDNO EQU   BTUFID
BDURSV04 EQU   BDUFLAGS
BDURTOE  EQU   BDUFLAGS
BDUSTPR  EQU   BDUFLAGS
BDURSV03 EQU   BDUFLAGS
BDUALT   EQU   BDUFUNC
BDUNACK  EQU   BDUFUNC
BDUACK   EQU   BDUFUNC
BDUTRPM  EQU   BDUFUNC
BDUFBMI  EQU   BDUFUNC
BDULDGPH EQU   BDUFUNC
BDUHEADP EQU   BDUFUNC
BDUSOH   EQU   BDUCHECK
BDURSV01 EQU   BDUMODIF
BDUMOD0  EQU   BDUMOD1
BDUCOMND EQU   ISTBDU
LSCTLBAD EQU   ISTLSCB+28
LSCFDB2  EQU   LSCFDBA+1
LSCFDB1  EQU   LSCFDBA
LSCLCCWA EQU   ISTLSCB+20
LSCLCPBA EQU   ISTLSCB+16
LSCLCCW1 EQU   ISTLSCB+12
LSCRRCNT EQU   LSCSEQ+1
LSCRRCCT EQU   LSCSEQ
LSCATOP  EQU   LSCFLGS
LSCFREE  EQU   LSCFLGS
LSCDSTAT EQU   LSCFLGS
LSCEXRES EQU   LSCFLGS
LSCZRIMM EQU   LSCFLGS
LSCRSV01 EQU   LSCFLGS
LSCSMODE EQU   LSCFLGS
LSCZMIRC EQU   LSCRUCNT
LSCCHAI2 EQU   LSCCHAIN+1
LSCCHNG  EQU   LSCCHAI1
LSCZRTSC EQU   LSCZMNRC
LSCZRT0B EQU   LSCZMNRC
LSCZRT0A EQU   LSCZMNRC
LSCZRTL9 EQU   LSCZRT09
LSCZRTL8 EQU   LSCZRT08
LSCZRTL7 EQU   LSCZRT07
LSCZRTL6 EQU   LSCZRT06
LSCZRTL5 EQU   LSCZRT05
LSCZRTL4 EQU   LSCZRT04
LSCZRTL3 EQU   LSCZRT03
LSCZRTL2 EQU   LSCZRT02
LSCZRT01 EQU   LSCREQTG
LSCZRT00 EQU   LSCREQTG
LSCLNGTH EQU   LSC1WORD+1
ATCAOS   EQU   ISTATCVT+1584
ATCPOPAB EQU   ATCAOSM+640
ATCVIOPM EQU   ATCAOSM+636
ATCTPMMI EQU   ATCAOSM+632
ATCTPMPB EQU   ATCAOSM+600
ATCRSV88 EQU   ATCAOSM+596
ATCRPLCT EQU   ATCAOSM+594
ATCCRACT EQU   ATCAOSM+592
ATCSRBCT EQU   ATCAOSM+590
ATCRSV75 EQU   ATCAOSM+589
ATCRSV66 EQU   ATCZFLAG
ATCZF001 EQU   ATCZFLAG
ATCTPCP1 EQU   ATCAOSM+584
ATCTPCP0 EQU   ATCAOSM+580
ATCAICTN EQU   ATCAOSM+576
ATCZR01  EQU   ATCAOSM+572
ATCMPLTA EQU   ATCAOSM+568
ATCASCB  EQU   ATCAOSM+564
ATCAP86  EQU   ATCAOSM+560
ATCAP85  EQU   ATCAOSM+556
ATCAP84  EQU   ATCAOSM+552
ATCAP83  EQU   ATCAOSM+548
ATCAP82  EQU   ATCAOSM+544
ATCAP69  EQU   ATCAOSM+540
ATCAP66  EQU   ATCAOSM+536
ATCAP62  EQU   ATCAOSM+532
ATCAPC59 EQU   ATCAOSM+528
ATCAP56  EQU   ATCAOSM+524
ATCAP55  EQU   ATCAOSM+520
ATCRCFY0 EQU   ATCAOSM+516
ATCAP41  EQU   ATCAOSM+512
ATCAPC25 EQU   ATCAOSM+508
ATCAP23  EQU   ATCAOSM+504
ATCTPSPB EQU   ATCAOSM+472
ATCTRMPB EQU   ATCAOSM+440
ATCAPBE  EQU   ATCAOSM+436
ATCPSTA  EQU   ATCAOSM+432
ATCSMABF EQU   ATCAOSM+428
ATCSMAPR EQU   ATCAOSM+424
ATCTPWQA EQU   ATCAOSM+420
ATCSMAID EQU   ATCAOSM+416
ATCSMARA EQU   ATCAOSM+412
ATCCACXA EQU   ATCAOSM+408
ATCZLAAB EQU   ATCAOSM+404
ATCATA10 EQU   ATCAOSM+400
ATCHLTCB EQU   ATCAOSM+396
@NM00062 EQU   ATCVTFLG
ATCVTACT EQU   ATCVTFLG
ATCRPT40 EQU   ATCAOSM+388
ATCRPT39 EQU   ATCAOSM+384
ATCRPT38 EQU   ATCAOSM+380
ATCRPT37 EQU   ATCAOSM+376
ATCRPT36 EQU   ATCAOSM+372
ATCRPT35 EQU   ATCAOSM+368
ATCRPT34 EQU   ATCAOSM+364
ATCRPT33 EQU   ATCAOSM+360
ATCRPT32 EQU   ATCAOSM+356
ATCRPT31 EQU   ATCAOSM+352
ATCRPT30 EQU   ATCAOSM+348
ATCRPT29 EQU   ATCAOSM+344
ATCRPT28 EQU   ATCAOSM+340
ATCRPT27 EQU   ATCAOSM+336
@NM00061 EQU   ATCAOSM+333
@NM00060 EQU   @NM00059
ATCSNUF  EQU   @NM00059
ATCOPKL  EQU   @NM00059
ATCABEN  EQU   @NM00059
ATCAIWT  EQU   ATCAOSM+328
ATCINFDD EQU   ATCAOSM+324
ATCORFMG EQU   ATCAOSM+320
ATCORFRL EQU   ATCAOSM+316
ATCOROBT EQU   ATCAOSM+312
ATCORQG  EQU   ATCORSRB
ATCORTBF EQU   ATCSQAFR
ATCRPLAC EQU   ATCRPLCN+2
ATCRPLRC EQU   ATCRPLCN
ATCCRPLQ EQU   ATCCRPL
ATCSRBAC EQU   ATCSRBCN+2
ATCSRBRC EQU   ATCSRBCN
ATCSRBQ  EQU   ATCSRB
ATCCRAAC EQU   ATCCRACN+2
ATCCRARC EQU   ATCCRACN
ATCCRAQ  EQU   ATCCRA
ATCRPT12 EQU   ATCAOSM+276
ATCDMAPP EQU   ATCAOSM+272
ATCAP37  EQU   ATCAOSM+264
ATCZDFJ0 EQU   ATCAOSM+260
ATCAP51  EQU   ATCAOSM+256
ATCZPAB2 EQU   ATCAOSM+224
ATCZPAB1 EQU   ATCAOSM+192
ATCZLFVT EQU   ATCAOSM+188
ATCZLPVT EQU   ATCAOSM+184
ATCZDVTX EQU   ATCAOSM+180
ATCZDVTA EQU   ATCAOSM+176
ATCZDVT9 EQU   ATCAOSM+172
ATCZDVT8 EQU   ATCAOSM+168
ATCZDVT7 EQU   ATCAOSM+164
ATCRSV56 EQU   ATCDAPVT+22
ATCDAPDG EQU   ATCDAPVT+20
ATCDXCEA EQU   ATCDAPVT+16
ATCDCEA  EQU   ATCDAPVT+12
ATCDPCIA EQU   ATCDAPVT+8
ATCDSIOA EQU   ATCDAPVT+4
ATCDEOEA EQU   ATCDAPVT
ATCZLAEA EQU   ATCLDAPP+16
ATCZLCEA EQU   ATCLDAPP+12
ATCRSV17 EQU   ATCLDAPP+8
ATCSMFRR EQU   ATCLDAPP+4
ATCCDTID EQU   ATCLDAPP
ATCZAEA  EQU   ATCICAPP+16
ATCZCEA  EQU   ATCICAPP+12
ATCCDTCB EQU   ATCICAPP+8
ATCZSIOA EQU   ATCICAPP+4
ATCCDRPH EQU   ATCICAPP
ATCAP65  EQU   ATCAOSM+96
ATCZDVT6 EQU   ATCAOSM+92
ATCZDVT4 EQU   ATCAOSM+88
ATCZDVT3 EQU   ATCAOSM+84
ATCZDVT1 EQU   ATCAOSM+80
ATCICNCB EQU   ATCAOSM+76
ATCAP64  EQU   ATCAOSM+64
ATCAP63  EQU   ATCAOSM+60
ATCAP61  EQU   ATCAOSM+56
ATCAP58  EQU   ATCAOSM+52
ATCAP57  EQU   ATCAOSM+48
ATCAP54  EQU   ATCAOSM+44
ATCAP53  EQU   ATCAOSM+40
ATCAP52  EQU   ATCAOSM+36
ATCAP34  EQU   ATCAOSM+32
ATCAP32  EQU   ATCAOSM+28
ATCAP12  EQU   ATCAOSM+20
ATCAP11  EQU   ATCAOSM+16
ATCCMTCB EQU   ATCAOSM+12
ATCPRPH  EQU   ATCAOSM+8
ATCGSRBF EQU   ATCGSRBG
ATCSRBRT EQU   ATCAOSM
@NM00058 EQU   @NM00057
ATCVTMAB EQU   @NM00057
@NM00056 EQU   ATCVTBAM
ATCVDLOK EQU   ISTATCVT+904
ATCVFPAB EQU   ISTATCVT+872
ATCVDPAB EQU   ISTATCVT+840
ATCIOECB EQU   ISTATCVT+836
ATCINCW3 EQU   ISTATCVT+832
ATCMODTB EQU   ISTATCVT+828
ATCUSSPT EQU   ISTATCVT+824
ATCSRTAB EQU   ISTATCVT+820
@NM00055 EQU   ISTATCVT+819
@NM00054 EQU   ATCSTAT2
ATCTRSMS EQU   ATCSTAT2
ATCTRLOK EQU   ATCSTAT2
ATCTRPSS EQU   ATCSTAT2
ATCTRESC EQU   ATCSTAT2
ATCTRAPI EQU   ATCSTAT2
ATCNMCTR EQU   ISTATCVT+816
ATCSEC51 EQU   ATCSECST
ATCSEC40 EQU   ATCSIPD+8
ATCSEC30 EQU   ATCSIPD+4
ATCSEC21 EQU   ATCSIPD
ATCSEC10 EQU   ATCSOPD+4
ATCSEC01 EQU   ATCSOPD
ATCPOIA  EQU   ATCRNO+1
@NM00053 EQU   ATCRNO
ATCPODVT EQU   ISTATCVT+784
ATCS49XL EQU   ISTATCVT+780
ATCS49XI EQU   ISTATCVT+776
ATCLCLCT EQU   ATCVLCNT+2
ATCRNCNT EQU   ATCVLCNT
ATCCFEAD EQU   ISTATCVT+768
ATCPTR00 EQU   ISTATCVT+736
ATCRSV10 EQU   ISTATCVT+704
ATCTACB  EQU   ISTATCVT+700
ATCVTINM EQU   ISTATCVT+696
ATCTCLIM EQU   ISTATCVT+692
ATCTCLOM EQU   ISTATCVT+688
ATCVTIPB EQU   ISTATCVT+656
ATCTCIPB EQU   ISTATCVT+624
ATCTIPAB EQU   ISTATCVT+592
ATCOCCCB EQU   ISTATCVT+588
ATCOCCOB EQU   ISTATCVT+584
ATCCDLAD EQU   ISTATCVT+580
ATCCCLAD EQU   ISTATCVT+576
ATCDLRPB EQU   ISTATCVT+544
ATCPGPAB EQU   ISTATCVT+512
ATCVPAB1 EQU   ISTATCVT+480
ATCRSV97 EQU   ISTATCVT+476
ATCRDTLK EQU   ISTATCVT+472
ATCVOCLK EQU   ISTATCVT+468
ATCCDFDN EQU   ISTATCVT+464
ATCCDFIN EQU   ISTATCVT+460
ATCDVTLK EQU   ISTATCVT+456
ATCAP35  EQU   ISTATCVT+448
ATCRSV99 EQU   ISTATCVT+440
ATCONFIG EQU   ISTATCVT+432
ATCNODDS EQU   ISTATCVT+428
ATCNODEL EQU   ISTATCVT+420
ATCRSV69 EQU   ISTATCVT+416
ATCAPCR5 EQU   ISTATCVT+412
ATCLDECB EQU   ISTATCVT+408
ATCLDNCS EQU   ISTATCVT+404
ATCCDPTR EQU   ISTATCVT+400
ATCADEL  EQU   ISTATCVT+396
ATCTODVT EQU   ISTATCVT+392
ATCDEBCH EQU   ISTATCVT+388
ATCHBSIZ EQU   ATCHPGM+2
ATCHBFNO EQU   ATCHPGM
ATCCRME  EQU   ISTATCVT+380
ATCRVCHS EQU   ISTATCVT+372
ATCECTLP EQU   ISTATCVT+368
ATCZDVTB EQU   ISTATCVT+364
ATCECPRT EQU   ISTATCVT+360
ATCVTLOD EQU   ISTATCVT+356
ATCTRPAB EQU   ISTATCVT+352
ATCMSGM  EQU   ISTATCVT+348
ATCMSGP  EQU   ISTATCVT+344
ATCEPT   EQU   ISTATCVT+340
ATCDVT   EQU   ISTATCVT+336
ATCTRCPT EQU   ISTATCVT+332
ATCDVLOD EQU   ISTATCVT+328
ATCALERT EQU   ISTATCVT+324
ATCEPA   EQU   ISTATCVT+320
ATCSAF   EQU   ISTATCVT+318
ATCXRANG EQU   ISTATCVT+317
ATCLAST  EQU   ATCSHRFG
ATCSHRTN EQU   ISTATCVT+308
ATCUEP   EQU   ISTATCVT+304
ATCOCRT  EQU   ISTATCVT+300
ATCCSMA  EQU   ATCCSMR
ATCESC02 EQU   ISTATCVT+292
ATCESC01 EQU   ISTATCVT+288
ATCCDFND EQU   ISTATCVT+284
ATCCDDEL EQU   ISTATCVT+280
ATCCDADD EQU   ISTATCVT+276
ATCMNT   EQU   ISTATCVT+272
ATCRSV16 EQU   ISTATCVT+270
ATCMAXID EQU   ISTATCVT+269
ATCMSGSP EQU   ATCCOM+268
ATCCIDM  EQU   ATCCOM+266
ATCACTRM EQU   ATCCOM+264
ATCNERAP EQU   ATCCOM+260
ATCNESAL EQU   ATCCOM+256
ATCRCC65 EQU   ATCCOM+252
ATCRCC26 EQU   ATCCOM+248
ATCRCC63 EQU   ATCCOM+244
ATCRSV11 EQU   ATCCOM+242
ATCVTMID EQU   ATCCOM+240
ATCAPOST EQU   ATCCOM+236
ATCNERFN EQU   ATCCOM+232
ATCNERNE EQU   ATCCOM+228
ATCNERCV EQU   ATCCOM+224
ATCNERST EQU   ATCCOM+220
ATCDCC61 EQU   ATCCOM+216
ATCDCC60 EQU   ATCCOM+212
ATCSRTDF EQU   ATCCOM+208
ATCSRTAD EQU   ATCCOM+204
ATCFIRA  EQU   ATCCOM+200
ATCSMBQ  EQU   ATCCOM+196
ATCSMRC  EQU   ATCCOM+192
ATCSMRS  EQU   ATCCOM+188
ATCSMQU  EQU   ATCCOM+184
ATCSMRQ  EQU   ATCCOM+180
ATCACDA  EQU   ATCCOM+176
ATCSTMA  EQU   ATCCOM+172
ATCFRSTR EQU   ATCCOM+168
ATCGTSTR EQU   ATCCOM+164
ATCREADA EQU   ATCCOM+160
ATCALOAD EQU   ATCCOM+156
ATCBLDLA EQU   ATCCOM+152
ATCFBRPH EQU   ATCCOM+148
ATCBFTRC EQU   ATCCOM+144
ATCTPBUF EQU   ATCTHTRC
ATCREMOV EQU   ATCCOM+136
ATCADD   EQU   ATCCOM+132
ATCBPDA  EQU   ATCCOM+128
ATCDVTPT EQU   ATCCOM+124
ATCFEPT  EQU   ATCCOM+120
ATCFDVT  EQU   ATCCOM+116
ATCCONFT EQU   ATCCOM+112
ATCPTCHA EQU   ATCCOM+108
ATCAUTHA EQU   ATCCOM+104
ATCACCTA EQU   ATCCOM+100
ATCRDTH  EQU   ATCCOM+96
ATCFRSCH EQU   ATCCOM+92
ATCFSB   EQU   ATCCOM+88
ATCHLTMS EQU   ATCCOM+84
ATCECPRM EQU   ATCCOM+80
ATCECNET EQU   ATCCOM+76
ATCECOPC EQU   ATCCOM+72
ATCVPARM EQU   ATCCOM+68
ATCECVRQ EQU   ATCCOM+64
ATCECSES EQU   ATCCOM+60
ATCOCHA  EQU   ATCCOM+56
ATCDSPLQ EQU   ATCCOM+52
ATCECDSP EQU   ATCCOM+48
ATCVARYQ EQU   ATCCOM+44
ATCECVRY EQU   ATCCOM+40
ATCHALTQ EQU   ATCCOM+36
ATCECHLT EQU   ATCCOM+32
ATCMODQ  EQU   ATCCOM+28
ATCECMOD EQU   ATCCOM+24
ATCASCHD EQU   ATCCOM+20
ATCSRT   EQU   ATCCOM+16
ATCRDT   EQU   ATCCOM+12
ATCDCFRR EQU   ATCCOM+8
ATCAPI   EQU   ATCCOM+4
ATCRSV04 EQU   ATCSTAT4
ATCVTTRC EQU   ATCSTAT4
ATCNCSD  EQU   ATCSTAT4
ATCMTST  EQU   ATCSTAT4
ATCTPRT  EQU   ATCSTAT4
ATCPRTAT EQU   ATCSTAT4
@NM00052 EQU   ATCPOFLG
ATCPOUNS EQU   ATCPOFLG
ATCHSDMF EQU   ATCSTFLG
@NM00051 EQU   ATCSTAT1
ATCMDHLT EQU   ATCSTAT1
ATCINHLT EQU   ATCSTAT1
ATCNETSL EQU   ATCSTAT1
ATCQKHLT EQU   ATCSTAT1
ATCSNHLT EQU   ATCSTAT1
ATCACTIV EQU   ATCSTAT1
ATCSTART EQU   ATCSTAT1
DYPPAB   EQU   ISTDYPAB+16
DYPRSV01 EQU   ISTDYPAB+12
DYPTSKID EQU   ISTDYPAB+8
DYPCHAIN EQU   ISTDYPAB+4
DYPFLGS  EQU   ISTDYPAB+2
DYPLNGTH EQU   ISTDYPAB+1
DYPTYPE  EQU   ISTDYPAB
ICNZCON6 EQU   ICNZCONS+10
ICNZCON5 EQU   ICNZCONS+8
ICNZCON4 EQU   ICNZCONS+6
ICNZCON3 EQU   ICNZCONS+4
ICNZCON2 EQU   ICNZCONS+2
ICNZCON1 EQU   ICNZCONS
ICNZATSA EQU   ISTICNCB+676
ICNZX012 EQU   ISTICNCB+675
ICNZX011 EQU   ISTICNCB+674
ICNZX010 EQU   ISTICNCB+672
ICNSRB   EQU   ISTICNCB+628
ICNIOSB  EQU   ISTICNCB+520
ICNZC001 EQU   ISTICNCB+512
ICNZX013 EQU   ISTICNCB+511
ICNZS010 EQU   ICNZH002+1
ICNZS00F EQU   ICNZH002+1
ICNZS00E EQU   ICNZH002+1
ICNZS00D EQU   ICNZH002+1
ICNZS00C EQU   ICNZH002+1
ICNZS00B EQU   ICNZH002+1
ICNZS01A EQU   ICNZS00A
ICNZS019 EQU   ICNZS009
ICNZS018 EQU   ICNZS008
ICNZS017 EQU   ICNZS007
ICNZS016 EQU   ICNZS006
ICNZS005 EQU   ICNZH002
ICNZS014 EQU   ICNZS004
ICNZS013 EQU   ICNZS003
ICNZS012 EQU   ICNZS002
ICNZS001 EQU   ICNZH002
ICNZF028 EQU   ICNZFLAG
ICNZF027 EQU   ICNZFLAG
ICNZF026 EQU   ICNZFLAG
ICNZF025 EQU   ICNZFLAG
ICNZF024 EQU   ICNZFLAG
ICNZF023 EQU   ICNZFLAG
ICNZF022 EQU   ICNZFLAG
ICNZF021 EQU   ICNZFLAG
ICNWORD5 EQU   ISTICNCB+504
ICNMSIZE EQU   ISTICNCB+500
ICNLCVTA EQU   ISTICNCB+496
ICNDEBAD EQU   ICNDIDEB+1
ICNDCBIF EQU   ICNDIDEB
ICNUCBAD EQU   ICNDCDEB+8
ICNAPPAD EQU   ICNDCDEB+5
ICNEXSCL EQU   ICNDCDEB+4
ICNDCBAD EQU   ICNDCDEB+1
ICNDEBID EQU   ICNDCDEB
@NM00050 EQU   ISTICNCB+477
ICNERCNT EQU   ISTICNCB+476
ICNZX002 EQU   ISTICNCB+475
ICNZX001 EQU   ISTICNCB+474
ICNZH001 EQU   ISTICNCB+472
ICNZSW3R EQU   ISTICNCB+468
ICNZSW2R EQU   ISTICNCB+464
ICNZSW1R EQU   ISTICNCB+460
ICNZS4VR EQU   ISTICNCB+436
ICNZS4RR EQU   ISTICNCB+432
ICNZS4FC EQU   ISTICNCB+428
ICNZS4BC EQU   ISTICNCB+424
ICNZS3VR EQU   ISTICNCB+400
ICNZS3RR EQU   ISTICNCB+396
ICNZS3FC EQU   ISTICNCB+392
ICNZS3BC EQU   ISTICNCB+388
ICNZS1RC EQU   ICNZS1VR+36
ICNDIEW3 EQU   ICNDIEWA+8
ICNDIEW2 EQU   ICNDIEWA+4
ICNDIEW1 EQU   ICNDIEWA
ICNZS1RR EQU   ISTICNCB+344
ICNZS1FC EQU   ISTICNCB+340
ICNZS1BC EQU   ISTICNCB+336
ICNRSTIC EQU   ICNZD004
ICNRDCOD EQU   ICNRSCCW
ICNZD006 EQU   ISTICNCB+312
ICNZD005 EQU   ISTICNCB+304
ICNWSTIC EQU   ICNZD002
ICNWRCOD EQU   ICNWSCCW
ICNZV008 EQU   ISTICNCB+284
ICNZV007 EQU   ISTICNCB+280
ICNZV006 EQU   ISTICNCB+276
ICNZV005 EQU   ISTICNCB+272
ICNZV004 EQU   ISTICNCB+268
ICNLSTIT EQU   ISTICNCB+264
ICNLSTIF EQU   ISTICNCB+260
ICNZV002 EQU   ISTICNCB+256
ICNZV001 EQU   ISTICNCB+252
ICNZV00A EQU   ISTICNCB+249
ICNBUFF  EQU   ISTICNCB+248
ICNCPQ   EQU   ISTICNCB+244
ICNNICNA EQU   ISTICNCB+240
@NM00049 EQU   ICNFLAG2+2
ICNZF019 EQU   ICNFLAG2+2
ICNZF018 EQU   ICNFLAG2+2
ICNZF017 EQU   ICNFLAG2+2
ICNZF016 EQU   ICNFLAG2+2
ICNZF015 EQU   ICNFLAG2+2
ICNMSG   EQU   ICNFLAG2+1
ICNCLOSE EQU   ICNFLAG2+1
ICNZF014 EQU   ICNFLAG2+1
ICNZF013 EQU   ICNFLAG2+1
ICNZF012 EQU   ICNFLAG2+1
ICNZF011 EQU   ICNFLAG2+1
ICNZF00D EQU   ICNFLAG2+1
ICNZF00B EQU   ICNFLAG2+1
ICNZF00A EQU   ICNFLAG2
ICNZF008 EQU   ICNFLAG2
ICNZF007 EQU   ICNFLAG2
ICNZF005 EQU   ICNFLAG2
ICNZF004 EQU   ICNFLAG2
ICNZF003 EQU   ICNFLAG2
ICNZF002 EQU   ICNFLAG2
ICNZF001 EQU   ICNFLAG2
ICNLOCK  EQU   ISTICNCB+232
ICNLICNA EQU   ISTICNCB+228
ICNRPH   EQU   ISTICNCB+120
ICNZV003 EQU   ISTICNCB+116
ICNLAST  EQU   ISTICNCB+112
ICNLSTBT EQU   ISTICNCB+108
ICNSIOQ  EQU   ISTICNCB+104
ICNFLAG1 EQU   ISTICNCB+103
ICNZSW08 EQU   ICNZSWS
ICNZSW07 EQU   ICNZSWS
ICNZSW06 EQU   ICNZSWS
ICNZSW05 EQU   ICNZSWS
ICNZSW04 EQU   ICNZSWS
ICNZSW03 EQU   ICNZSWS
ICNZSW02 EQU   ICNZSWS
ICNZSW01 EQU   ICNZSWS
ICNZFF69 EQU   ICNFFLAG
@NM00048 EQU   ICNFFLAG
ICNZFF05 EQU   ICNFFLAG
ICNZFF04 EQU   ICNFFLAG
ICNZFF03 EQU   ICNFFLAG
ICNZFF02 EQU   ICNFFLAG
ICNZFF01 EQU   ICNFFLAG
ICNZFF00 EQU   ICNFFLAG
@NM00047 EQU   ICNFLAG
ICNZCRIT EQU   ICNFLAG
ICNSTART EQU   ICNFLAG
ICNSLOW  EQU   ICNFLAG
ICNZF00F EQU   ICNFLAG
ICNZF00E EQU   ICNFLAG
ICNCONF  EQU   ICNZF006
ICNCKPAB EQU   ICNCKFLD+1
ICNRSV07 EQU   ICNCKFLD
ICNCKBIT EQU   ICNCKFLD
ICNZPAB4 EQU   ISTICNCB+80
ICNZPAB1 EQU   ISTICNCB+64
ICNRSV01 EQU   ISTICNCB+60
@NM00046 EQU   ISTICNCB+56
@NM00045 EQU   ISTICNCB+54
@NM00044 EQU   @NM00043
ICNRRY   EQU   @NM00043
ICNLCLUS EQU   @NM00043
ICNROLN  EQU   @NM00043
ICNRNRY  EQU   @NM00043
ICNLNKMD EQU   ISTICNCB+52
ICNCUUA  EQU   ISTICNCB+48
ICNCB    EQU   ISTICNCB
FMCFLRSV EQU   FMCFLGB
FMCFLGA8 EQU   FMCFLGB
FMCCLRPH EQU   FMCVS1+45
FMCRSV0X EQU   FMCCVFLG
FMCVYRPH EQU   FMCCVFLG
FMCZV004 EQU   FMCVS1+40
FMCLOCK2 EQU   FMCVS1+36
@NM00042 EQU   FMCZFLG2
FMCZF027 EQU   FMCZFLG2
FMCZF026 EQU   FMCZFLG2
FMCSEQ1B EQU   FMCSEQ1
FMCSEQ1T EQU   FMCSEQ1
FMCZX006 EQU   FMCVS1+33
FMCZX005 EQU   FMCVS1+32
FMCZX004 EQU   FMCVS1+31
FMCZX003 EQU   FMCVS1+30
FMCZX002 EQU   FMCVS1+29
FMCZX001 EQU   FMCVS1+28
FMCZV001 EQU   FMCVS1+24
FMCAWATQ EQU   FMCLCPAQ+1
@NM00041 EQU   FMCLCPAQ
FMCLCPB2 EQU   FMCLCPBQ+1
FMCLCPB1 EQU   FMCLCPBQ
@NM00040 EQU   FMCSHEAQ
FMCZFCSQ EQU   FMCVS1+6
FMCZH001 EQU   FMCVS1+4
FMCZF025 EQU   FMCZFLAG+3
FMCZF024 EQU   FMCZFLAG+3
FMCZF023 EQU   FMCZFLAG+3
FMCZF022 EQU   FMCZFLAG+3
FMCZF021 EQU   FMCZFLAG+3
FMCZF020 EQU   FMCZFLAG+3
FMCZF019 EQU   FMCZFLAG+3
FMCZF018 EQU   FMCZFLAG+3
FMCZF017 EQU   FMCZFLAG+2
FMCZF016 EQU   FMCZFLAG+2
FMCZF015 EQU   FMCZFLAG+2
FMCZF014 EQU   FMCZFLAG+2
FMCZF013 EQU   FMCZFLAG+2
FMCZF012 EQU   FMCZFLAG+2
FMCZF011 EQU   FMCZFLAG+2
FMCZF010 EQU   FMCZFLAG+2
FMCZF00F EQU   FMCZFLAG+1
FMCZF00E EQU   FMCZFLAG+1
FMCZF00D EQU   FMCZFLAG+1
FMCZF00C EQU   FMCZFLAG+1
FMCZF00B EQU   FMCZFLAG+1
FMCRSV10 EQU   FMCZFLAG+1
FMCZF009 EQU   FMCZFLAG+1
FMCZFD06 EQU   FMCZF006+1
FMCZFC06 EQU   FMCZF006
FMCZFB06 EQU   FMCZF006
FMCZFA06 EQU   FMCZF006
FMCZF005 EQU   FMCZFLAG
FMCZF004 EQU   FMCZFLAG
FMCZF003 EQU   FMCZFLAG
FMCZF002 EQU   FMCZFLAG
FMCZF001 EQU   FMCZFLAG
FMCFRESA EQU   ISTFMCB+228
FMCSCSQN EQU   FMCSNCTL+2
FMCSCCTL EQU   FMCSNCTL+1
FMCSTCTL EQU   FMCSCFLG
FMCSCCLO EQU   FMCSCFLG
FMCAPRO  EQU   FMCSCFLG
FMCLURO  EQU   FMCSCFLG
FMCOBSAC EQU   FMCSCFLG
FMCIBSAC EQU   FMCSCFLG
FMCFBRE  EQU   ISTFMCB+220
FMCFBXM  EQU   FMCZV002
FMCASEGQ EQU   ISTFMCB+212
FMCRDTPT EQU   ISTFMCB+208
FMCSEGD  EQU   FMCSSEGQ
FMCRSPLM EQU   ISTFMCB+198
FMCPSTRS EQU   ISTFMCB+196
@NM00039 EQU   FMCRRESP
FMCTSLHA EQU   FMCRRESP
FMCFRRN  EQU   FMCRRESP
FMCFME   EQU   FMCRRESP
FMCFEX   EQU   FMCRRESP
FMCFPE   EQU   FMCRRESP
FMCCTLB  EQU   ISTFMCB+194
FMCBSQNO EQU   FMCCLSEQ+2
FMCTSQNO EQU   FMCCLSEQ
FMCOBPRG EQU   FMCMODEB
FMCIBPRG EQU   FMCMODEB
FMCRESOT EQU   FMCMODEB
FMCRSTSR EQU   FMCMODEB
FMCLUQ   EQU   FMCMODEB
FMCAPQ   EQU   FMCMODEB
FMCCLEAR EQU   FMCMODEB
FMCHOLD  EQU   FMCMODEB
FMCIPSEQ EQU   ISTFMCB+188
FMCLUSTR EQU   ISTFMCB+187
FMCRSV87 EQU   FMCSTAT2
FMCSEQI  EQU   FMCSTAT2
FMCCPIP  EQU   FMCSTAT2
FMCALIPR EQU   FMCSTAT2
FMCIAIO  EQU   FMCSTAT2
FMCZF00A EQU   FMCSTAT2
FMCVPIP  EQU   FMCSTAT2
FMCBHSET EQU   ISTFMCB+185
FMCPRMRC EQU   FMCCLEXT+20
FMCRSV89 EQU   FMCPSTAT
FMCPCLSD EQU   FMCPSTAT
FMCDDOCD EQU   FMCPSTAT
FMCIDVFD EQU   FMCPSTAT
FMCELKST EQU   FMCPSTAT
FMCRSV88 EQU   FMCPSCMD
FMCRDBLK EQU   FMCPSCMD
FMCDSEOC EQU   FMCPSCMD
FMCPURGE EQU   FMCPSCMD
FMCRESTI EQU   FMCPSCMD
FMCCNTCT EQU   FMCPSCMD
FMCINVT  EQU   FMCPSCMD
FMCFLGB7 EQU   FMCFLGCL
FMCFLGB6 EQU   FMCFLGCL
FMCFLGB5 EQU   FMCFLGCL
FMCFLGB4 EQU   FMCFLGCL
FMCFLGB3 EQU   FMCFLGCL
FMCFLGB2 EQU   FMCFLGCL
FMCFLGB1 EQU   FMCFLGCL
FMCFLGB0 EQU   FMCFLGCL
FMCFLGA7 EQU   FMCFLGA
FMCFLGA6 EQU   FMCFLGA
FMCFLGA5 EQU   FMCFLGA
FMCFLGA4 EQU   FMCFLGA
FMCFLGA3 EQU   FMCFLGA
FMCFLGA2 EQU   FMCFLGA
FMCFLGA1 EQU   FMCFLGA
FMCFLGA0 EQU   FMCFLGA
FMCDCLOK EQU   FMCCLEXT+12
FMCRAFM  EQU   FMCCLEXT+8
FMCFBPTR EQU   FMCFBA+1
FMCFBRSV EQU   FMCFBA
FMCRPLPT EQU   FMCRPLA+1
FMCRPLRS EQU   FMCRPLA
FMCPRCLS EQU   FMCCVAL
FMCIBCE  EQU   FMCCVAL
FMCONLY  EQU   FMCOBCE
FMCLAST  EQU   FMCOBCE
FMCMIDLE EQU   FMCOBCE
FMCFIRST EQU   FMCOBCE
FMCNSALU EQU   FMCSSTAT
FMCBIP   EQU   FMCSSTAT
FMCSDTR  EQU   FMCSSTAT
FMCSNBI  EQU   FMCSSTAT
FMCRVD01 EQU   ISTFMCB+158
FMCISSN  EQU   ISTFMCB+156
FMCOASN  EQU   FMCNXOSC
FMCSIP   EQU   FMCSIPA
FMCEXLST EQU   ISTFMCB+144
FMCPAB4  EQU   ISTFMCB+112
FMCPAB2  EQU   ISTFMCB+80
FMCPAB1  EQU   ISTFMCB+64
FMCFASYA EQU   ISTFMCB+60
FMCMODE  EQU   ISTFMCB+52
FMCVWT   EQU   ISTFMCB+44
FMCRPLH  EQU   ISTFMCB+40
FMCBUFNB EQU   FMCCMPS1+2
FMCBUFLM EQU   FMCCMPS1
FMCDEBA  EQU   ISTFMCB+32
@NM00038 EQU   FMCCMDFL
FMCSNA   EQU   FMCCMDFL
FMCVSNA  EQU   FMCCMDFL
FMCCMDR  EQU   FMCCMDFL
@NM00037 EQU   ISTFMCB+30
@NM00036 EQU   FMCSTAT1
FMCLTCLS EQU   FMCSTAT1
FMCHPURG EQU   FMCSTAT1
FMCVSP2  EQU   FMCSTAT1
FMCVSP1  EQU   FMCSTAT
FMCLTEAS EQU   FMCSTAT
FMCZF007 EQU   FMCSTAT
FMCDEDSC EQU   FMCSTAT
FMCDEVOF EQU   FMCSTAT
FMCDAPT  EQU   FMCSTAT
FMCPRMTE EQU   FMCSTAT
FMCPRMTR EQU   FMCSTAT
FMCUSFLD EQU   ISTFMCB+24
FMCFMCBA EQU   ISTFMCB+20
FMCDVTA  EQU   ISTFMCB+12
FMCTSKID EQU   ISTFMCB+8
FMCNXTCB EQU   ISTFMCB+4
FMCSAF   EQU   ISTFMCB+2
FMCLNGTH EQU   ISTFMCB+1
FMCTYPE  EQU   ISTFMCB
PROSRDEF EQU   PROSETM4
PRORSV47 EQU   PROSETM4
PROSCON  EQU   PROSETM4
PRORSV46 EQU   PROSETM3
PROSMONT EQU   PROSETM3
PRORSV45 EQU   PROSETM3
PROSNTO  EQU   PROSETM3
PRORSV44 EQU   PROSETM3
PRORSV43 EQU   PROSETM2
PROSNTFL EQU   PROSETM2
PRORSV42 EQU   PROSETM2
PRORSV41 EQU   PROPROCS
PROMODC  EQU   PROPROC4
PROMODT  EQU   PROPROC4
PROMODM  EQU   PROPROC4
PROMODB  EQU   PROPROC4
PRORSV14 EQU   PROPROC4
PRORSV13 EQU   PROPROC4
PRORSV12 EQU   PROPROC4
PROEIB   EQU   PROPROC4
PROMONT3 EQU   PROPROC3
PROMONT2 EQU   PROPROC3
PROMONIT EQU   PROPROC3
PROSUBLK EQU   PROPROC3
PRONTO   EQU   PROPROC3
PROLGIN  EQU   PROPROC3
PROERPI  EQU   PROPROC3
PRORSV07 EQU   PROPROC3
PROEMLC  EQU   PROPROC2
PRONTFL  EQU   PROPROC2
PRORSV05 EQU   PROPROC2
PRORSV04 EQU   PROPROC2
PROLGOT  EQU   PROPROC2
PROERPO  EQU   PROPROC2
PRORSV03 EQU   PROPROC2
PRORPLC  EQU   PROPROC1
PROCS    EQU   PROPROC1
PROCA    EQU   PROPROC1
PRORESPX EQU   PROPROC1
PRODFASY EQU   PROPROC1
PROXPOPT EQU   PROPROC1
PROTRUNC EQU   PROPROC1
PROASYIP EQU   PROPROC1
LUNZC001 EQU   LUNZOS+8
LUNLOCK  EQU   LUNZOS
NCBRSV01 EQU   ISTNCB+46
NCBSWDAF EQU   ISTNCB+44
NCBDEVCH EQU   ISTNCB+36
NCBFMCBP EQU   ISTNCB+32
NCBLTRC  EQU   ISTNCB+30
NCBRVPT1 EQU   ISTNCB+28
NCBNMLLN EQU   NCBFLAGS+3
@NM00035 EQU   NCBFLAG1
NCBFORCE EQU   NCBFLAG1
NCBTTF   EQU   NCBFLAG1
NCBRSYNC EQU   NCBFLAG1
NCBRSTRT EQU   NCBFLAG1
NCBCONF  EQU   NCBFLAG1
NCBSNAI  EQU   NCBFLAG1
NCBFLTIO EQU   NCBFTRIO
NCBCSTAT EQU   NCBFLAGS
NCBNCSL  EQU   ISTNCB+22
NCBNCBA  EQU   ISTNCB+20
NCBFMCBA EQU   ISTNCB+16
NCBTSKID EQU   ISTNCB+8
NCBRDTE  EQU   ISTNCB+4
NCBDAF   EQU   ISTNCB+2
NCBLNGTH EQU   ISTNCB+1
DEVRSV03 EQU   ISTDEVCH+5
DEVPHYSA EQU   ISTDEVCH+4
DEVCSLPN EQU   DEVCHAR3
DEVCSTCL EQU   DEVCHAR3
DEVCCHEK EQU   DEVCHAR3
DEVCATTN EQU   DEVCHAR3
DEVCSWL  EQU   DEVFCCTL
DEVCRVB  EQU   DEVFCCTL
DEVCSSL  EQU   DEVFCCTL
DEVCBSC  EQU   DEVFCCTL
DEVMCODE EQU   ISTDEVCH+2
DEVCHAR2 EQU   DEVTCODE
DEVRSV01 EQU   DEVCHAR
DEVCCTL  EQU   DEVCHAR
DEVNNSPT EQU   DEVCHAR
DEVSPS   EQU   DEVCHAR
DEVSUBND EQU   DEVCHAR
DEVCONVR EQU   DEVCHAR
DEVOTPUT EQU   DEVCHAR
DEVINPUT EQU   DEVCHAR
PABRPHA  EQU   PABRPHFG+1
PABNODQ  EQU   PABFLAGS
PABINHBT EQU   PABFLAGS
PABERLOK EQU   PABERRLK
PABSSN   EQU   PABFLAGS
PABDYNAM EQU   PABFLAGS
PABNORPR EQU   PABFLAGS
PABPRIOR EQU   PABFLAGS
PABAPYP  EQU   PABFLAGS
PABOFFST EQU   ISTPAB+8
PABCHNGP EQU   PABCHAIN+1
PABRSV02 EQU   PABCHAIN
PABDELAY EQU   PABCHAIN
PABRUNNG EQU   PABCHAIN
PABRESET EQU   PABCHAIN
PABUNCON EQU   PABCHAIN
PABCDP   EQU   PABCHAIN
PABRESCH EQU   PABCHAIN
PABCHNG  EQU   PABCHAIN
PABRSV01 EQU   PABWEQA
PABWEQG  EQU   PABWEQA
CRACHAIN EQU   ISTCRA+928
CRARSV02 EQU   ISTCRA+924
CRARSV01 EQU   ISTCRA+920
CRABFTBA EQU   CRABUFA
CRAMASK  EQU   CRASVC+64
CRAHSIZ  EQU   CRASVC+60
CRAASCRR EQU   CRASVC
CRAPSS   EQU   ISTCRA+160
CRARPH   EQU   ISTCRA+52
CRALAPTR EQU   CRABASIC+48
CRAL9PTR EQU   CRABASIC+44
CRAL8PTR EQU   CRABASIC+40
CRAL7PTR EQU   CRABASIC+36
CRAL6PTR EQU   CRABASIC+32
CRAL5PTR EQU   CRABASIC+28
CRAL3PTR EQU   CRABASIC+20
CRAL2PTR EQU   CRABASIC+16
CRAL1PTR EQU   CRABASIC+12
CRALEV01 EQU   CRALKACT+3
CRALEV02 EQU   CRALKACT+3
CRALEV03 EQU   CRALKACT+3
CRALEV04 EQU   CRALKACT+3
CRALEV05 EQU   CRALKACT+3
CRALEV06 EQU   CRALKACT+3
CRALEV07 EQU   CRALKACT+3
CRALEV08 EQU   CRALKACT+3
CRALEV09 EQU   CRALKACT+2
CRALEV10 EQU   CRALKACT+2
CRALEV11 EQU   CRALKACT+2
CRALEV12 EQU   CRALKACT+2
CRALEV13 EQU   CRALKACT+2
CRALEV14 EQU   CRALKACT+2
CRALEV15 EQU   CRALKACT+2
CRALEV16 EQU   CRALKACT+2
CRALEV17 EQU   CRALKACT+1
CRALEV18 EQU   CRALKACT+1
CRALEV19 EQU   CRALKACT+1
CRALEV20 EQU   CRALKACT+1
CRALEV21 EQU   CRALKACT+1
CRALEV22 EQU   CRALKACT+1
CRALEV23 EQU   CRALKACT+1
CRALEV24 EQU   CRALKACT+1
CRALEV25 EQU   CRALKACT
CRALEV26 EQU   CRALKACT
CRALEV27 EQU   CRALKACT
CRALEV28 EQU   CRALKACT
CRALEV29 EQU   CRALKACT
CRALEV30 EQU   CRALKACT
CRALEV31 EQU   CRALKACT
CRALEV32 EQU   CRALKACT
@NM00034 EQU   ISTAPCRR+137
@NM00033 EQU   APC57FLG
APCNREL  EQU   APC57FLG
APCRECRA EQU   APC57FLG
@NM00032 EQU   APC54FLG
APCRLST  EQU   APC54FLG
APCPR153 EQU   APC53FLG
@NM00031 EQU   APC52FLG
APCWKF   EQU   APC52FLG
APCNWF   EQU   APC52FLG
APCRDQ   EQU   APC52FLG
APCQENQ  EQU   APC52FLG
APCSMSR  EQU   APC52FLG
APCCKRQ  EQU   APC52FLG
@NM00030 EQU   APC31FLG
APCSORT  EQU   APC31FLG
APCRESCH EQU   APC31FLG
APCTPXIT EQU   APC31FLG
APCSWTWD EQU   ISTAPCRR+128
APCSAV2  EQU   ISTAPCRR+124
APCSAV1  EQU   ISTAPCRR+120
APCRETCD EQU   APCCOMF+2
@NM00029 EQU   APCCOMF1+1
APCZLBER EQU   APCCOMF1
APCEXIT  EQU   APCCOMF1
APCRELR  EQU   APCCOMF1
APCIRB2  EQU   APCCOMF1
APCIRB1  EQU   APCCOMF1
APCSMCR  EQU   APCCOMF1
APCUETSK EQU   APCCOMF1
APCSSTSK EQU   APCCOMF1
APCESTAL EQU   APCSAVE
APCFRRPM EQU   ISTAPCRR+40
APCQWFO  EQU   ISTAPCRR+36
APCPABSV EQU   ISTAPCRR+32
APCRTRN  EQU   ISTAPCRR+28
APCTCBA  EQU   ISTAPCRR+24
APCPSTA  EQU   ISTAPCRR+20
@NM00028 EQU   APCRFLG+1
APC31R   EQU   APCRFLG
APC58R   EQU   APCRFLG
APC57R   EQU   APCRFLG
APC56R   EQU   APCRFLG
APC54R   EQU   APCRFLG
APC53R   EQU   APCRFLG
APC52R   EQU   APCRFLG
APC51R   EQU   APCRFLG
@NM00027 EQU   APCATFLG+1
APC31E   EQU   APCATFLG
APC58E   EQU   APCATFLG
APC57E   EQU   APCATFLG
APC56E   EQU   APCATFLG
APC54E   EQU   APCATFLG
APC53E   EQU   APCATFLG
APC52E   EQU   APCATFLG
APC51E   EQU   APCATFLG
APCHDRSV EQU   ISTAPCRR
ASCPSREG EQU   ISTASCRR+44
ASCUSR01 EQU   ASCUSRGS+12
ASCUSR00 EQU   ASCUSRGS+8
ASCUSR15 EQU   ASCUSRGS+4
ASCUSR14 EQU   ASCUSRGS
ASCETRYA EQU   ISTASCRR+24
ASCKEY   EQU   ISTASCRR+23
ASCAUDIT EQU   ASCFLG3
ASCFBDUD EQU   ASCFLG3
ASCLLKF  EQU   ASCFLG3
ASCKEYF  EQU   ASCFLG3
ASCFBDAL EQU   ASCFLG3
ASCFSRGT EQU   ASCFLG3
ASCICR   EQU   ASCFLG2
ASCFSRIC EQU   ASCFLG2
ASCFBDIC EQU   ASCFLG2
ASCFBAIC EQU   ASCFLG2
ASCPASTR EQU   ASCFLG1
ASCFSR   EQU   ASCFLG1
ASCFBD   EQU   ASCFLG1
ASCFBA   EQU   ASCFLG1
ASCPFCRR EQU   ISTASCRR
CCFRSVD1 EQU   CFCCRT
CCFCR2   EQU   CFCCRT
CCFCRP   EQU   CFCCRT
CCFCR1   EQU   CFCCRT
CCFCS2   EQU   CFCCRT
CCFCS1   EQU   CFCCRT
NCFRSVD  EQU   CFCNTRD
NCFCR2   EQU   CFCNTRD
NCFCRP   EQU   CFCNTRD
NCFCR1   EQU   CFCNTRD
NCFCS2   EQU   CFCNTRD
NCFCS1   EQU   CFCNTRD
PFCRSV01 EQU   ISTPFCRR+13
PFCFTA   EQU   ISTPFCRR+12
CRRFRR   EQU   PFCFRRO
CRRCHAIN EQU   PFCCRRO
CRRLEN   EQU   PFCCRRLN
PFCRSV10 EQU   PFCCRR+1
CRRID    EQU   PFCCRRID
ZCRRU    EQU   ZCRRHRU+3
ZCRRH    EQU   ZCRRHRU
ZCRWORDA EQU   ISTZCRR+477
ZCRCMNRC EQU   ISTZCRR+476
ZCRRSV97 EQU   ZCRENTER+18
ZCREIC2B EQU   ZCRENTER+18
ZCREAC2B EQU   ZCRENTER+18
ZCRELCAB EQU   ZCRENTER+18
ZCREDCMF EQU   ZCRENTER+18
ZCREBCIF EQU   ZCRENTER+18
ZCREICSG EQU   ZCRENTER+18
ZCREDCK0 EQU   ZCRENTER+18
ZCRECFY0 EQU   ZCRENTER+17
ZCREKCCB EQU   ZCRENTER+17
ZCREDCNB EQU   ZCRENTER+17
ZCREICOE EQU   ZCRENTER+17
ZCREBCNB EQU   ZCRENTER+17
ZCREBC0L EQU   ZCRENTER+17
ZCREBCAL EQU   ZCRENTER+17
ZCREDCQR EQU   ZCRENTER+17
ZCREDCPR EQU   ZCRENTER+16
ZCREBCSB EQU   ZCRENTER+16
ZCREAC1R EQU   ZCRENTER+16
ZCRECCCI EQU   ZCRENTER+16
ZCRECCAI EQU   ZCRENTER+16
ZCRECCBI EQU   ZCRENTER+16
ZCREBCAR EQU   ZCRENTER+16
ZCREBCDR EQU   ZCRENTER+16
ZCREBCBR EQU   ZCRENTER+15
ZCREDCXR EQU   ZCRENTER+15
ZCREDCWB EQU   ZCRENTER+15
ZCREDCWR EQU   ZCRENTER+15
ZCREKCCN EQU   ZCRENTER+15
ZCREKCBN EQU   ZCRENTER+15
ZCREKCBB EQU   ZCRENTER+15
ZCREJC0B EQU   ZCRENTER+15
ZCREJCDB EQU   ZCRENTER+14
ZCREJCCB EQU   ZCRENTER+14
ZCREJCBB EQU   ZCRENTER+14
ZCREJCAB EQU   ZCRENTER+14
ZCREIC1B EQU   ZCRENTER+14
ZCREIC0B EQU   ZCRENTER+14
ZCREICX0 EQU   ZCRENTER+14
ZCREICWB EQU   ZCRENTER+14
ZCREICVB EQU   ZCRENTER+13
ZCREICUB EQU   ZCRENTER+13
ZCREICTB EQU   ZCRENTER+13
ZCREICSC EQU   ZCRENTER+13
ZCREICSB EQU   ZCRENTER+13
ZCREICRB EQU   ZCRENTER+13
ZCREICQB EQU   ZCRENTER+13
ZCREICQA EQU   ZCRENTER+13
ZCREICOB EQU   ZCRENTER+12
ZCREICOA EQU   ZCRENTER+12
ZCREICNB EQU   ZCRENTER+12
ZCREICNA EQU   ZCRENTER+12
ZCREICMB EQU   ZCRENTER+12
ZCREICLB EQU   ZCRENTER+12
ZCREICKG EQU   ZCRENTER+12
ZCREICKE EQU   ZCRENTER+12
ZCREICKB EQU   ZCRENTER+11
ZCREICJB EQU   ZCRENTER+11
ZCREICID EQU   ZCRENTER+11
ZCREICIB EQU   ZCRENTER+11
ZCREICHB EQU   ZCRENTER+11
ZCREICGB EQU   ZCRENTER+11
ZCREICEB EQU   ZCRENTER+11
ZCREICDB EQU   ZCRENTER+11
ZCREICCI EQU   ZCRENTER+10
ZCREICCB EQU   ZCRENTER+10
ZCREICBI EQU   ZCRENTER+10
ZCREICBB EQU   ZCRENTER+10
ZCREICAB EQU   ZCRENTER+10
ZCREICAA EQU   ZCRENTER+10
ZCREHCAN EQU   ZCRENTER+10
ZCREGC0B EQU   ZCRENTER+10
ZCREGC0A EQU   ZCRENTER+9
ZCREGCLA EQU   ZCRENTER+9
ZCREGCEB EQU   ZCRENTER+9
ZCREGCDB EQU   ZCRENTER+9
@NM00026 EQU   ZCRENTER+9
ZCREGCBB EQU   ZCRENTER+9
ZCREGCAB EQU   ZCRENTER+9
ZCREFCEB EQU   ZCRENTER+9
ZCREFCEA EQU   ZCRENTER+8
ZCREECTA EQU   ZCRENTER+8
ZCREECEA EQU   ZCRENTER+8
ZCREECDA EQU   ZCRENTER+8
ZCREECCB EQU   ZCRENTER+8
ZCREECCA EQU   ZCRENTER+8
ZCREECBB EQU   ZCRENTER+8
ZCREECBA EQU   ZCRENTER+8
ZCREDCMB EQU   ZCRENTER+7
ZCREDCL0 EQU   ZCRENTER+7
ZCREDCKB EQU   ZCRENTER+7
ZCREDCKA EQU   ZCRENTER+7
ZCREDCJ0 EQU   ZCRENTER+7
ZCREDCI0 EQU   ZCRENTER+7
ZCREDCH0 EQU   ZCRENTER+7
ZCREDCF0 EQU   ZCRENTER+7
ZCREDCE0 EQU   ZCRENTER+6
ZCREDCD0 EQU   ZCRENTER+6
ZCREDCC0 EQU   ZCRENTER+6
ZCREDCB0 EQU   ZCRENTER+6
ZCREDCA0 EQU   ZCRENTER+6
ZCRECC2B EQU   ZCRENTER+6
ZCRECC1B EQU   ZCRENTER+6
ZCRECC1A EQU   ZCRENTER+6
ZCRECC0B EQU   ZCRENTER+5
ZCRECC0A EQU   ZCRENTER+5
ZCREBC0B EQU   ZCRENTER+5
ZCREBC0A EQU   ZCRENTER+5
ZCREBCZ0 EQU   ZCRENTER+5
ZCREBCY0 EQU   ZCRENTER+5
ZCREBCX0 EQU   ZCRENTER+5
ZCREBCXA EQU   ZCRENTER+5
ZCREBCSC EQU   ZCRENTER+4
ZCREBCRB EQU   ZCRENTER+4
ZCREBCRA EQU   ZCRENTER+4
ZCREBCQB EQU   ZCRENTER+4
ZCREBCPB EQU   ZCRENTER+4
ZCREBCOB EQU   ZCRENTER+4
ZCREBCNE EQU   ZCRENTER+4
ZCREBCND EQU   ZCRENTER+4
ZCREBCMB EQU   ZCRENTER+3
ZCREBCLB EQU   ZCRENTER+3
ZCREBCLA EQU   ZCRENTER+3
ZCREBCKB EQU   ZCRENTER+3
ZCREBCKA EQU   ZCRENTER+3
ZCREBCJB EQU   ZCRENTER+3
ZCREBCJA EQU   ZCRENTER+3
ZCREBCID EQU   ZCRENTER+3
ZCREBCIB EQU   ZCRENTER+2
ZCREBCIA EQU   ZCRENTER+2
ZCREBCHB EQU   ZCRENTER+2
ZCREBCHA EQU   ZCRENTER+2
ZCREBCGB EQU   ZCRENTER+2
ZCREBCGA EQU   ZCRENTER+2
ZCREBCFB EQU   ZCRENTER+2
ZCREBCFA EQU   ZCRENTER+2
ZCREBCEB EQU   ZCRENTER+1
ZCREBCDI EQU   ZCRENTER+1
ZCREBCCB EQU   ZCRENTER+1
ZCREBCBI EQU   ZCRENTER+1
ZCREBCBB EQU   ZCRENTER+1
ZCREBCBA EQU   ZCRENTER+1
ZCREBCAM EQU   ZCRENTER+1
ZCREBCAI EQU   ZCRENTER+1
ZCREBCAG EQU   ZCRENTER
ZCREBCAE EQU   ZCRENTER
ZCREBCAB EQU   ZCRENTER
ZCREBCAA EQU   ZCRENTER
ZCREAC0B EQU   ZCRENTER
ZCREAC0A EQU   ZCRENTER
ZCREAC1A EQU   ZCRENTER
ZCRREMIC EQU   ISTZCRR+436
ZCRDAFSV EQU   ZCRCIDSV+2
ZCRSAFSV EQU   ZCRCIDSV
ZCRR13SV EQU   ISTZCRR+188
ZCRR2SV  EQU   ISTZCRR+184
ZCROPCDE EQU   ISTZCRR+183
ZCRPRMTC EQU   ISTZCRR+182
ZCRRCDSV EQU   ISTZCRR+181
ZCRAWQSW EQU   ISTZCRR+180
ZCRTOPQ  EQU   ISTZCRR+180
ZCRLSTFB EQU   ISTZCRR+180
ZCRXSCHD EQU   ISTZCRR+180
ZCRNXTEL EQU   ISTZCRR+180
ZCRSCANQ EQU   ISTZCRR+180
ZCRMOREL EQU   ISTZCRR+180
ZCRFBPRC EQU   ISTZCRR+180
ZCRFSBSV EQU   ISTZCRR+176
ZCRSVWK5 EQU   ZCRWKARA+16
ZCRSVWK4 EQU   ZCRWKARA+12
ZCRSVWK3 EQU   ZCRWKARA+8
ZCRSVWK2 EQU   ZCRWKARA+4
ZCRSVWK1 EQU   ZCRWKARA
ZCRSVF25 EQU   ZCRSVRTN+96
ZCRSVF24 EQU   ZCRSVRTN+92
ZCRSVF23 EQU   ZCRSVRTN+88
ZCRSVF22 EQU   ZCRSVRTN+84
ZCRSVF21 EQU   ZCRSVRTN+80
ZCRSVF20 EQU   ZCRSVRTN+76
ZCRSVF19 EQU   ZCRSVRTN+72
ZCRSVF18 EQU   ZCRSVRTN+68
ZCRSVF17 EQU   ZCRSVRTN+64
ZCRSVF16 EQU   ZCRSVRTN+60
ZCRSVF15 EQU   ZCRSVRTN+56
ZCRSVF14 EQU   ZCRSVRTN+52
ZCRSVF13 EQU   ZCRSVRTN+48
ZCRSVF12 EQU   ZCRSVRTN+44
ZCRSVF11 EQU   ZCRSVRTN+40
ZCRSVF10 EQU   ZCRSVRTN+36
ZCRSVF9  EQU   ZCRSVRTN+32
ZCRSVF8  EQU   ZCRSVRTN+28
ZCRSVF7  EQU   ZCRSVRTN+24
ZCRSVF6  EQU   ZCRSVRTN+20
ZCRSVF5  EQU   ZCRSVRTN+16
ZCRSVF4  EQU   ZCRSVRTN+12
ZCRSVF3  EQU   ZCRSVRTN+8
ZCRPVZB  EQU   ISTZCRR+52
ZCRZLB   EQU   ISTZCRR+48
ZCRBFPTR EQU   ISTZCRR+44
ZCRCCWA  EQU   ISTZCRR+40
ZCRPSW   EQU   ZCRPARMS+15
ZCRPCHAR EQU   ZCRPARMS+14
ZCRPRES2 EQU   ZCRPCOD2
ZCRPMFGF EQU   ZCRPCOD2
ZCRPFHDR EQU   ZCRPCOD2
ZCRPPG2  EQU   ZCRPCOD2
ZCRPRES  EQU   ZCRPCOD1
ZCRPCFTX EQU   ZCRPCOD1
ZCRPLSBQ EQU   ZCRPLSBF
ZCRPFSB  EQU   ZCRPCOD1
ZCRPLNG  EQU   ZCRPCOD1
ZCRPPG   EQU   ZCRPCOD1
ZCRDTODA EQU   ZCRDFRDA
ZCRMLNG  EQU   ZCRPARMS+8
ZCRTBPTR EQU   ZCRPARMS+4
ZCRCBPTR EQU   ZCRFBPTR
ZCRCRLCP EQU   ISTZCRR+20
@NM00025 EQU   ZCRSCPSW
ZCRSKIPT EQU   ZCRSCPSW
ZCRFSBWE EQU   ZCRSCPSW
ZCRPRCMP EQU   ZCRSCPSW
ZCRLREQ  EQU   ZCRSCPSW
ZCRRJLCP EQU   ZCRSCPSW
ZCRTPINV EQU   ZCRSCPSW
ZCRTPEX  EQU   ZCRSCPSW
@NM00024 EQU   ZCRIBPR
ZCR3270R EQU   ZCRIBPR
ZCR3270  EQU   ZCRIBPR
ZCRLCPFD EQU   ZCRIBPR
ZCRLCPFR EQU   ZCRIBPR
ZCRRELK  EQU   ZCRIBPR
ZCRERR   EQU   ZCRIBPR
ZCRNOBUF EQU   ZCRIBPR
@NM00023 EQU   ZCRPFLGS
ZCRF1RES EQU   ZCRGENSW
ZCRBRIS  EQU   ZCRGENSW
ZCRCLRBD EQU   ZCRGENSW
ZCREXRES EQU   ZCRGENSW
ZCRLCSYN EQU   ZCRGENSW
ZCRRT06  EQU   ZCRGENSW
ZCRTSW2  EQU   ZCRGENSW
ZCRTSW1  EQU   ZCRGENSW
ZCRINLCP EQU   ZCRFLGS3
ZCRWRPTR EQU   ZCRFLGS3
ZCRNOFRE EQU   ZCRFLGS3
ZCREDRIV EQU   ZCRFLGS3
ZCRDISC  EQU   ZCRFLGS3
ZCRTPDIS EQU   ZCRFLGS3
ZCRTPCON EQU   ZCRFLGS3
ZCRTIC   EQU   ZCRFLGS3
ZCRCNLXL EQU   ZCRRESET
ZCRENDAN EQU   ZCRSWFLD
ZCRENDXL EQU   ZCRSWFLD
ZCRENDX  EQU   ZCRSWFLD
ZCROB1   EQU   ZCRNDLCP
ZCRENDPR EQU   ZCRSWFLD
ZCRSLCP  EQU   ZCRENDSH
ZCRIF0E3 EQU   ZCRFLGS2
ZCRIF0E2 EQU   ZCRFLGS2
ZCRIF0E1 EQU   ZCRFLGS2
ZCRFMSED EQU   ZCRFLGS2
ZCRLOCAL EQU   ZCRFLGS2
ZCRFEXIT EQU   ZCRFLGS1
ZCRUNSOL EQU   ZCRFLGS1
ZCRENDLP EQU   ZCRFLGS1
ZCRNRMEX EQU   ZCRFLGS1
ZCRWAIT  EQU   ZCRFLGS1
ZCRDEQSW EQU   ZCRFLGS1
ZCRQUESW EQU   ZCRFLGS1
ZCREXSW  EQU   ZCRFLGS1
ZCRFLAG  EQU   ZCRCRR+3
LCPFTYPE EQU   LCPRPHA
LCPRSTQH EQU   LCPLCCW
LCPCLREP EQU   ISTLCPB+44
LCPUBFSB EQU   LCPFLCCW
LCPRSV77 EQU   ISTLCPB+39
LCPLCCWC EQU   ISTLCPB+38
LCPRSV78 EQU   LCPFLG1
LCPTRANS EQU   LCPFLG1
LCPSTLB  EQU   LCPFLG1
LCPREDRV EQU   LCPFLG1
LCPDIRPT EQU   LCPFLG1
LCPRESET EQU   LCPFLG1
LCPSTYPE EQU   ISTLCPB+36
LCPFSNCH EQU   ISTLCPB+34
LCPFOSN  EQU   ISTLCPB+32
LCPTLBAD EQU   ISTLCPB+28
LCPFDB2  EQU   LCPFDBA+1
LCPFDB1  EQU   LCPFDBA
LCPDAF   EQU   LCPCID+2
LCPSAF   EQU   LCPCID
LCPLCCW1 EQU   ISTLCPB+12
LCPRRCNT EQU   LCPSEQ+1
LCPRRCCT EQU   LCPSEQ
LCPATOP  EQU   LCPFLAG2
LCPFREE  EQU   LCPFLAG2
LCPDSTAT EQU   LCPFLAG2
LCPEXRES EQU   LCPFID0
LCPZRIMM EQU   LCPTLBPI
LCPASYN  EQU   LCPFLAG2
LCPPRFLG EQU   LCPFLAG2
LCPZMIRC EQU   LCPRUCNT
LCPCHAI2 EQU   LCPCHAIN+1
LCPCHNG  EQU   LCPCHAI1
LCPZRT0B EQU   LCPMNRCD
LCPZRT0A EQU   LCPMNRCD
LCPZRTL9 EQU   LCPZRT09
LCPZRTL8 EQU   LCPZRT08
LCPZRTL7 EQU   LCPZRT07
LCPZRTL6 EQU   LCPZRT06
LCPZRTL5 EQU   LCPZRT05
LCPZRTL4 EQU   LCPZRT04
LCPZRTL3 EQU   LCPZRT03
LCPZRTL2 EQU   LCPZRT02
LCPZRT01 EQU   LCPFLAGS
LCPZRT00 EQU   LCPFLAGS
LCPLNGTH EQU   ISTLCPB+1
LCCWDATA EQU   ISTLCCW+4
LCCWCNT  EQU   ISTLCCW+2
LCCWACI  EQU   LCCWFLAG
LCCWRFI  EQU   LCCWFLAG
LCCWPER  EQU   LCCWLSI
LCCWIDAT EQU   LCCWFLAG
LCCWNTVC EQU   LCCWFLAG
LCCWCKPT EQU   LCCWFLAG
LCCWCC   EQU   LCCWFLAG
LCCWCD   EQU   LCCWFLAG
LCCWTYPE EQU   LCCWCTL
LCCWMODE EQU   LCCWCTL
LCCWSOP  EQU   LCCWRWOP
@NM00022 EQU   LCCWRWOP
LCCWSD   EQU   LCCWOP
LCCWSI   EQU   LCCWOP
ZSAZTRAC EQU   ISTZSAVE+36
ZSAZSVVR EQU   ISTZSAVE+12
ZSAZSVRR EQU   ISTZSAVE+8
ZSAZACTV EQU   ZSAZSVMS
FSBFDB   EQU   ISTFSB+32
FSBRSV01 EQU   FSBFSB+30
FSBTHCNT EQU   FSBFSB+28
FSBRLRSV EQU   FSBRLSTS
FSBCFTX  EQU   FSBRLSTS
FSBICNCB EQU   FSBMSGID
FSBSSOC  EQU   FSBSS2
FSBSSCC  EQU   FSBSS2
FSBSSDC  EQU   FSBSS2
FSBSSEC  EQU   FSBSS2
FSBSSIR  EQU   FSBSS2
FSBSSCR  EQU   FSBSS2
@NM00020 EQU   FSBSS2
@NM00019 EQU   FSBSS1
FSBSSDE  EQU   FSBSS1
FSBSSUS  EQU   FSBSS1
@NM00018 EQU   FSBSS1
FSBSOHI  EQU   FSBERC
FSBLGI   EQU   FSBERC
FSBLMRI  EQU   FSBFBMI
FSBETI   EQU   FSBERC
FSBEMI   EQU   FSBERC
FSBEBI   EQU   FSBERC
FSBECI   EQU   FSBERC
FSBELI   EQU   FSBERC
FSBMJRCD EQU   FSBSRCAT
FSBXLCI  EQU   FSBXCODE
FSBXFINS EQU   FSBXCODE
FSBXNORM EQU   FSBXFSTS
FSBSCODE EQU   FSBSYSRS
FSBSPHSE EQU   FSBSYSRS
FSBSERR  EQU   FSBSYSRS
FSBCMD   EQU   FSBSEQ
FSBDTRCE EQU   FSBFLAGS
FSBASBTU EQU   FSBFLAGS
FSBINPET EQU   FSBFLAGS
FSBNONCB EQU   FSBFLAGS
FSBLBIND EQU   FSBFLAGS
FSBFFIND EQU   FSBFLAGS
FSBACIND EQU   FSBFLAGS
FSBRFIND EQU   FSBFLAGS
FSBDAF   EQU   FSBCID+2
FSBSAF   EQU   FSBCID
FSBGATE  EQU   FSBFSBA
FSBLATOP EQU   FSBSFLGS
FSBRSV02 EQU   FSBSFLGS
FSBPGBUF EQU   FSBSFLGS
FSBMNSDA EQU   FSBMNRCD
FSBMNOA  EQU   FSBMNRCD
FSBMNDIF EQU   FSBMNRCD
FSBMNEOP EQU   FSBMNRCD
FSBMNDNU EQU   FSBMNRCD
FSBMNATN EQU   FSBMNRCD
FSBMNRVI EQU   FSBMNRCD
FSBMNELI EQU   FSBMNRCD
FSBLNGTH EQU   FSBFSB+1
FSBTYPE  EQU   FSBFSB
FDBOFSET EQU   ISTFDB+10
FDBDATCT EQU   ISTFDB+8
FDBDATAA EQU   ISTFDB+4
FDBFDBA  EQU   ISTFDB
LOKXCL   EQU   @NM00016
LOKPRY   EQU   @NM00016
@NM00017 EQU   @NM00016
@NM00015 EQU   LOKCHNG
LOKCT    EQU   ISTLOK
RPHNEXPO EQU   ISTRPH+104
RPHSAV16 EQU   RPHWORK+60
RPHSAV15 EQU   RPHWORK+56
RPHSAV14 EQU   RPHWORK+52
RPHSAV13 EQU   RPHWORK+48
RPHSAV12 EQU   RPHWORK+44
RPHSAV11 EQU   RPHWORK+40
RPHSAV10 EQU   RPHWORK+36
RPHSAVE9 EQU   RPHWORK+32
RPHSAVE8 EQU   RPHWORK+28
RPHSAVE7 EQU   RPHWORK+24
RPHSAVE6 EQU   RPHWORK+20
RPHSAVE5 EQU   RPHWORK+16
RPHSAVE4 EQU   RPHWORK+12
RPHSAVE3 EQU   RPHWORK+8
RPHSAVE2 EQU   RPHWORK+4
RPHSHALF EQU   RPHSAVE1+2
RPHSBIT8 EQU   RPHSBITS
RPHSBIT7 EQU   RPHSBITS
RPHSBIT6 EQU   RPHSBITS
RPHSBIT5 EQU   RPHSBITS
RPHSBIT4 EQU   RPHSBITS
RPHSBIT3 EQU   RPHSBITS
RPHSBIT2 EQU   RPHSBITS
RPHSBIT1 EQU   RPHSBITS
RPHSBYTE EQU   RPHSAVE1
RPHPABQP EQU   RPHPABQA+1
RPHPABFG EQU   RPHPABQA
RPHSRP34 EQU   RPHSRPRM+2
RPHSRP12 EQU   RPHSRPRM
RPHWEGT  EQU   RPHCSPA
RPHRESUM EQU   RPHRESMA+1
RPHRSV01 EQU   RPHWPFLG
RPHPURGE EQU   RPHWPFLG
RPHPT    EQU   RPHWPFLG
RPHWT    EQU   RPHWPFLG
RPHRSKEY EQU   RPHWPFLG
RPHDVTA  EQU   ISTRPH+12
RPHTIK   EQU   RPHTSKID+3
@NM00014 EQU   RPHTSKID
RPHRPHAP EQU   RPHRPHA+1
@NM00013 EQU   RPHRPHA
RPHGATE  EQU   RPHRPHA
@NM00012 EQU   RPHFLGB
RPHRLCRA EQU   RPHFLGB
RPHNRSAV EQU   RPHFLGB
RPHPGCMP EQU   RPHFLGB
RPHFBAPS EQU   RPHFLGB
RPHBSSP  EQU   RPHFLGB
RPHLOCK  EQU   RPHFLGB
RPHFNFLG EQU   RPHFSTLC
RPHMLTCP EQU   RPHFLAGS
RPHSMCLR EQU   RPHFLAGS
RPHSMTYP EQU   RPHFLAGS
RPHSMQ   EQU   RPHFLAGS
RPHAUTEX EQU   RPHAPTYP
RPHSPGIN EQU   RPHFLAGS
RPHOGIND EQU   RPHFLAGS
RPHLNGTH EQU   RPHCNTL+1
RPHTYPE  EQU   RPHCNTL
@NM00011 EQU   SRBSECT+40
@NM00010 EQU   SRBSECT+38
SRBPRIOR EQU   SRBSECT+37
SRBPKF   EQU   SRBSECT+36
SRBSAVE  EQU   SRBSECT+32
SRBPARM  EQU   SRBSECT+28
SRBRMTR  EQU   SRBSECT+24
SRBEP    EQU   SRBSECT+20
SRBPTCB  EQU   SRBFLC+4
SRBPASID EQU   SRBFLC+2
SRBCPAFF EQU   SRBFLC
SRBASCB  EQU   SRBSECT+8
SRBFLNK  EQU   SRBSECT+4
SRBID    EQU   SRBSECT
IOSEND   EQU   IOSB+108
IOSSKR   EQU   IOSEEKA+7
IOSSKH2  EQU   IOSSKHH+1
IOSSKH1  EQU   IOSSKHH
IOSSKCC  EQU   IOSCCHH
IOSSKBB  EQU   IOSEEKA+1
IOSSKM   EQU   IOSEEKA
IOSEEK   EQU   IOSB+92
IOSMDM   EQU   IOSB+91
IOSMDB   EQU   IOSB+90
IOSCKEY7 EQU   IOSCKEY
IOSCKEY6 EQU   IOSCKEY
IOSCKEY5 EQU   IOSCKEY
IOSCKEY4 EQU   IOSCKEY
@NM00006 EQU   IOSCKEY
IOSFMSK  EQU   IOSB+88
IOSCUDEV EQU   IOSPATH+1
@NM00005 EQU   IOSCHN
IOSPATH3 EQU   IOSCHN
IOSPATH2 EQU   IOSCHN
IOSEXP   EQU   IOSCHN
IOSGDP   EQU   IOSCHN
IOSAFF   EQU   IOSB+85
IOSRSS1B EQU   IOSB+84
IOSDSID  EQU   IOSB+80
IOSVST   EQU   IOSB+76
IOSRST   EQU   IOSB+72
IOSDIE   EQU   IOSB+68
IOSABN   EQU   IOSB+64
IOSNRM   EQU   IOSB+60
IOSPCI   EQU   IOSB+56
IOSERP   EQU   IOSB+52
IOSPCHN  EQU   IOSB+48
IOSSNS   EQU   IOSB+42
IOSAPMSK EQU   IOSB+40
IOSRES4A EQU   IOSB+36
IOSUSE   EQU   IOSB+32
IOSSRB   EQU   IOSB+28
IOSCSWRC EQU   IOSCSW+5
IOSTSB   EQU   IOSTATUS+1
IOSTSA   EQU   IOSTATUS
IOSCSWCA EQU   IOSCSW
IOSCC    EQU   @NM00004
IOSUCB   EQU   IOSB+16
IOSOPT2X EQU   IOSOPT2
IOSHTP   EQU   IOSOPT2
IOSRELSE EQU   IOSOPT
IOSAPR   EQU   IOSOPT
IOSTSLL  EQU   IOSOPT
IOSNERP  EQU   IOSOPT
IOSPSLL  EQU   IOSOPT
IOSQISCE EQU   IOSOPT
IOSDEP   EQU   IOSOPT
IOSBYP   EQU   IOSOPT
IOSCOD   EQU   IOSB+13
IOSPKY7  EQU   IOSPKEY
IOSPGDPX EQU   IOSPKEY
IOSIDR   EQU   IOSPKEY
IOSLCL   EQU   IOSPKEY
@NM00003 EQU   IOSPKEY
IOSPGAD  EQU   IOSB+8
IOSASID  EQU   IOSB+6
IOSPRLVL EQU   IOSB+5
IOSDVRID EQU   IOSB+4
IOSPROC  EQU   IOSB+3
IOSFLC7  EQU   IOSFLC
IOSFLC6  EQU   IOSFLC
IOSRWAIT EQU   IOSFLC
IOSTP    EQU   IOSFLC
IOSCC3WE EQU   IOSFLC
IOSVERIF EQU   IOSDVALT
IOSDVMNT EQU   IOSFLC
IOSLOG   EQU   IOSFLB
IOSBDCST EQU   IOSFLB
IOSMSG   EQU   IOSFLB
IOSFLB4  EQU   IOSFLB
IOSFLB3  EQU   IOSFLB
IOSFLB2  EQU   IOSFLB
IOSSDR   EQU   IOSFLB
IOSDIESE EQU   IOSFLB
IOSIOSB  EQU   IOSFLA
IOSDOM   EQU   IOSFLA
IOSEX    EQU   IOSFLA
IOSSMDB  EQU   IOSFLA
IOSSMDA  EQU   IOSFLA
IOSERR   EQU   IOSFLA
IOSCCHN  EQU   IOSACHN
IOSDCHN  EQU   IOSACHN
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00002 EQU   CVTFIX+248
@NM00001 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTSHSB  EQU   CVTSHS
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00580 EQU   @RC00577
@RC00578 EQU   @RC00577
@RF00587 EQU   @RC00577
AF1B035# EQU   @RC00602
AF1B010@ EQU   @PB00002
@RT00715 EQU   AF1BOUT
@RC00741 EQU   @RC00735
@RC00736 EQU   @RC00735
@RT00817 EQU   ISTA0083
@RC00876 EQU   @RC00875
@RT00918 EQU   AF1B0401
@RT00922 EQU   AF1B0401
@RF00926 EQU   AF1B0400
@RT00934 EQU   @EL00003
@RT00932 EQU   @EL00003
AF1B0402 EQU   @EL00003
@PB00003 EQU   @PB00004
AF1B030# EQU   @RC00580
AF1B035@ EQU   @PB00003
@RT00912 EQU   AF1B0402
@RT00926 EQU   AF1B0402
@ENDDATA EQU   *
         END   ISTZAF1B,(C'PLS2222',0603,77297)
