         TITLE 'ISTZBFSC/ASC-VS1/MSC-VS2-SESSION CONTROL OUTBOUND      *
                        '
ISTZBFSC CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'ISTZBFSC  78.052'                                 0001
         DROP  @15
@PROLOG  DS    0H                                                  0002
*                                                                  0508
*/********************************************************************/
*/*                                                                  */
*/* SECTION-                                                         */
*/*      MAINLINE                                                    */
*/*                                                                  */
*/* FUNCTION-                                                        */
*/*      SESSION CONTROL OUTBOUND PROCESSOR.                         */
*/*                                                                  */
*/*      THIS ROUTINE HANDLES CONTROL ROUTING FOR LCCWS AND          */
*/*      OUTBOUND FSBS.                                              */
*/*                                                                  */
*/*      THE FOLLOWING LCCW OPERATION CODES ARE HANDLED:             */
*/*            SEND                                                  */
*/*            CLEAR (,UNBIND (,NOTIFY))                             */
*/*            NOTIFY                                                */
*/*                                                                  */
*/*      THIS ROUTINE ALSO HANDLES CONTROL ROUTING FOR A             */
*/*      CLEAR OR SESSION TERMINATION FSB.                           */
*/*                                                                  */
*/********************************************************************/
*/* TPZSAVE (7,12,14) AC(BCSC)BASE                                   */
*                                                                  0508
*   DO;                                                            0508
*     DCL                                                          0509
*       GPR01F FIXED(31) REG(01);                                  0509
*     DCL                                                          0510
*       GPR01P PTR(31) REG(01);                                    0510
*     DCL                                                          0511
*       GPR12F FIXED(31) REG(12);                                  0511
*     DCL                                                          0512
*       GPR12P PTR(31) REG(12);                                    0512
*     DCL                                                          0513
*       GPR13F FIXED(31) REG(13);                                  0513
*     DCL                                                          0514
*       GPR13P PTR(31) REG(13);                                    0514
*     DCL                                                          0515
*       GPR14F FIXED(31) REG(14);                                  0515
*     DCL                                                          0516
*       GPR14P PTR(31) REG(14);                                    0516
*     RFY                                                          0517
*      (GPR01P,                                                    0517
*       GPR12P,                                                    0517
*       GPR13P,                                                    0517
*       GPR14P) RSTD;                                              0517
*     GEN(PRINT OFF);                                              0518
*                                                                  0518
         PRINT OFF
*/* ATBUILD (ISTZSAVE)                                               */
*/* END OF ATBUILD                                                   */
*                                                                  0519
*     GEN(PRINT ON);                                               0519
         PRINT ON
*     RFY                                                          0520
*       ISTZSAVE BASED(GPR13P);                                    0520
*     GEN SETS(ZSAZSVVR)(STM   7,12,ZSAZSVVR+0(13));               0521
         STM   7,12,ZSAZSVVR+0(13)
*     GEN SETS(GPR12P);                                            0522
         BALR  GPR12P,0
@TSTART  DS    0H
         USING @TSTART,GPR12P
*     GEN(PRINT OFF);                                              0523
*                                                                  0523
         PRINT OFF
*/* ATBUILD (ISTZCRR,ISTRPH,ISTCRA) EJECT(NO)                        */
*/* END OF ATBUILD                                                   */
*                                                                  0524
*     GEN(PRINT ON);                                               0524
         PRINT ON
*     GPR01P->RPHCRR->CRACRR->ZCREBCSC='1'B;                       0525
         L     @15,RPHCRR(,GPR01P)                                 0525
         L     @15,CRACRR(,@15)                                    0525
         OI    ZCREBCSC(@15),B'00000001'                           0525
*     ZSAZACTV='1'B;                                               0526
         OI    ZSAZACTV(GPR13P),B'10000000'                        0526
*     ZSAZTRAC='BCSC';                                             0527
         MVC   ZSAZTRAC(4,GPR13P),@CC04064                         0527
*     ZSAZSVRR=GPR14P;                                             0528
         ST    GPR14P,ZSAZSVRR(,GPR13P)                            0528
*     GPR13P=ZSAZSVFC;                                             0529
         L     GPR13P,ZSAZSVFC(,GPR13P)                            0529
*     RFY                                                          0530
*      (GPR01P) UNRSTD;                                            0530
*     RFY                                                          0531
*      (GPR14P) UNRSTD;                                            0531
*   END;                                                           0532
*                                                                  0532
*/* END TPZSAVE                                                      */
*                                                                  0533
*                                   /* TPIOS ENTRY LINKAGE           */
*   ZCRRPTR=CRACRR;                 /* ADDRESS ZCRR                  */
         L     @15,RPHCRR(,RPHPTR)                                 0533
         L     ZCRRPTR,CRACRR(,@15)                                0533
*   ZCRSCPSW=0;                     /* CLEAR BYTE OF INTERNAL FLAGS  */
         MVI   ZCRSCPSW(ZCRRPTR),X'00'                             0534
*   IF R7->FSBTYPE=FSTYPE THEN                                     0535
         CLI   FSBTYPE(R7),X'02'                                   0535
         BNE   @RF00535                                            0535
*     DO;                           /* IF ELEMENT IS A FSB           */
*       FSBPTR=R7;                  /* INITIALIZE PTR TO FSB         */
         ST    R7,FSBPTR(,ZCRRPTR)                                 0537
*       LCPBPTR=FSBLCPB;            /* INITIALIZE PTR TO LCPB        */
         L     @09,FSBPTR(,ZCRRPTR)                                0538
         L     @09,FSBLCPB(,@09)                                   0538
         ST    @09,LCPBPTR(,ZCRRPTR)                               0538
*       ZCRFSBWE=ON;                /* SET SWITCH INDICATING FSB     */
         OI    ZCRFSBWE(ZCRRPTR),B'00000100'                       0539
*     END;                          /* END FSB PROCESSING            */
*   ELSE                                                           0541
*     DO;                           /* NOT FSB, MUST BE LCPB         */
         B     @RC00535                                            0541
@RF00535 DS    0H                                                  0542
*       LCPBPTR=R7;                 /* INITIALIZE LCPB PTR           */
         ST    R7,LCPBPTR(,ZCRRPTR)                                0542
*       RFY                                                        0543
*        (R7) UNRSTD;               /* NOT REQUIRED                  */
*       LCCWPTR=LCPNXLCW;           /* INITIALIZE LCCW POINTER       */
         L     @09,LCPBPTR(,ZCRRPTR)                               0544
         L     @09,LCPNXLCW(,@09)                                  0544
         ST    @09,LCCWPTR(,ZCRRPTR)                               0544
         EJECT
*                                                                  0545
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT-                                                         */
*/*      ISTZNSES                                                    */
*/*                                                                  */
*/* FUNCTION-                                                        */
*/*      IF A SESSION REJECT REQUEST IS DETECTED,                    */
*/*            ALLOCATE A FSB,                                       */
*/*            SET MAJOR AND MINOR RETURN CODES TO                   */
*/*              LOGIN ERROR - NO SESSION,                           */
*/*            POST THE FSB BACK TO THE REQUESTOR,                   */
*/*            SET UP FLAGS FOR EXIT.                                */
*/*                                                                  */
*/********************************************************************/
*                                                                  0545
*ISTZNSES:                                                         0545
*       DO;                         /* SEGMENT ISTZNSES              */
ISTZNSES DS    0H                                                  0546
*         IF FMCNSALU=ON THEN                                      0546
         TM    FMCNSALU(FMCBPTR),B'00000100'                       0546
         BNO   @RF00546                                            0546
*           DO;                     /* IF SESSION REJECT REQUEST     */
*             ZCRPCOD1=0;           /* ZDFA0 PARAMETER               */
         MVI   ZCRPCOD1(ZCRRPTR),X'00'                             0548
*             ZCRPFSB=ON;           /* ZDFA0 PARAMETER               */
         OI    ZCRPFSB(ZCRRPTR),B'00100000'                        0549
*             CALL ISTZDFA0;        /* BUFFER ALLOCATION UTILITY     */
         L     @09,ATCZPSVT(,ATCVTPTR)                             0550
         L     @15,ZPSZDFA0(,@09)                                  0550
         BALR  @14,@15                                             0550
*             FSBPTR=RPHSRPRM;      /* ADDRESS NEWLY OBTAINED FSB    */
         L     @09,RPHSRPRM(,RPHPTR)                               0551
         ST    @09,FSBPTR(,ZCRRPTR)                                0551
*             FSBMJRCD=FRLOGICE;    /* MAJOR = LOGIC ERROR           */
         MVI   FSBMJRCD(@09),X'08'                                 0552
*             FSBMNRCD=FRMUSELE;    /* MINOR = NO SESSION            */
         MVI   FSBMNRCD(@09),X'A3'                                 0553
*             FSBLCPB=LCPBPTR;      /* SET LCPB POINTER IN FSB       */
         L     @15,LCPBPTR(,ZCRRPTR)                               0554
         ST    @15,FSBLCPB(,@09)                                   0554
*             FSBLCCWA=LCPNXLCW;    /* SET LCCW POINTER IN FSB       */
         L     @00,LCPNXLCW(,@15)                                  0555
         ST    @00,FSBLCCWA(,@09)                                  0555
*             CALL ISTZFDB;         /* FEEDBACK FSB TO REQUESTOR     */
         BAL   @14,ISTZFDB                                         0556
*             ZCRTPEX='1'B;         /* SET TPEXIT FLAG FOR CALLER    */
         OI    ZCRTPEX(ZCRRPTR),B'10000000'                        0557
*           END;                    /* END SESSION REJECT            */
*         ELSE                                                     0559
*           ;                       /* NOT SESSION REJECT            */
@RF00546 DS    0H                                                  0560
*       END ISTZNSES;               /* END OF SEGMENT                */
*/********************************************************************/
*/*      SEGMENT ISTZNSES END                                        */
*/********************************************************************/
*                                                                  0561
*     END;                          /* END LCPB PROCESSING   @XM00921*/
*   IF ZCRTPEX=ON THEN                                             0562
@RC00535 TM    ZCRTPEX(ZCRRPTR),B'10000000'                        0562
         BO    @RT00562                                            0562
*     ;                             /* IF TPEXIT REQUIRED            */
*   ELSE                            /* TPEXIT NOT REQUIRED           */
*     IF ZCRFSBWE=OFF               /* IF INPUT WAS NOT FSB  @XM00921*/
*         &LCCWOP=LSEND THEN        /* OPERATION CODE = SEND         */
         TM    ZCRFSBWE(ZCRRPTR),B'00000100'                       0564
         BNZ   @RF00564                                            0564
         L     @09,LCCWPTR(,ZCRRPTR)                               0564
         CLI   LCCWOP(@09),X'F1'                                   0564
         BNE   @RF00564                                            0564
         EJECT
*                                                                  0565
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT-                                                         */
*/*      ISTZSND                                                     */
*/*                                                                  */
*/* FUNCTION-                                                        */
*/*      HANDLE SESSION CONTROL SEND LCCW OPERATION CODE.            */
*/*                                                                  */
*/*      FOR RESPONSES, NO ACTION IS TAKEN BY THIS SEGMENT.          */
*/*                                                                  */
*/*      SESSION INITIATION REQUESTS, (BIND, ACTPU, OR ACTLU)        */
*/*            CAUSE THE PABINHBT FLAG SETTING TO BE MADE            */
*/*            ACCORDING TO THE DATA FLOW CONTROL LEVEL SPECIFIED.   */
*/*                                                                  */
*/*      FOR SET AND TEST SEQUENCE NUMBERS,                          */
*/*            THE FMCB SEQUENCE NUMBERS ARE UPDATED.                */
*/*                                                                  */
*/*      IF THE SESSION IS NOT BOUND,                                */
*/*      OR IF IN 'PROCESSING CLEAR' STATE,                          */
*/*      OR IF IN 'PROCESSING UNBIND' STATE,                         */
*/*            THE REQUEST IS REJECTED.                              */
*/*                                                                  */
*/********************************************************************/
*                                                                  0565
*ISTZSND:                                                          0565
*       DO;                         /* SEGMENT ISTZSND               */
ISTZSND  DS    0H                                                  0566
*         IF LCCWIDAT=ON THEN       /* IF IMMEDIATE DATA FLAG ON     */
         L     @09,LCCWPTR(,ZCRRPTR)                               0566
         TM    LCCWIDAT(@09),B'00001000'                           0566
         BNO   @RF00566                                            0566
*           RHPTR=ADDR(LCCWDATA);   /* LCCW CONTAINS RH DATA         */
         LA    @09,LCCWDATA(,@09)                                  0567
         ST    @09,RHPTR(,ZCRRPTR)                                 0567
*         ELSE                      /* IF IMMEDIATE DATA FLAG OFF    */
*           RHPTR=LCCWDATA;         /* LCCW ADDRESSES RH DATA        */
         B     @RC00566                                            0568
@RF00566 L     @09,LCCWPTR(,ZCRRPTR)                               0568
         L     @09,LCCWDATA(,@09)                                  0568
         ST    @09,RHPTR(,ZCRRPTR)                                 0568
*         IF LCCWCD=OFF THEN        /* IF NOT DATA CHAINED           */
@RC00566 L     @09,LCCWPTR(,ZCRRPTR)                               0569
         TM    LCCWCD(@09),B'10000000'                             0569
         BNZ   @RF00569                                            0569
*           SRUPTR=RHPTR+3;         /* SRU IS IMMEDIATELY ADDRESSABLE*/
         LA    @09,3                                               0570
         AL    @09,RHPTR(,ZCRRPTR)                                 0570
         ST    @09,SRUPTR(,ZCRRPTR)                                0570
*         ELSE                                                     0571
*           DO;                     /* IF DATA CHAINED               */
         B     @RC00569                                            0571
@RF00569 DS    0H                                                  0572
*             K=1;                  /* START AT BEGIN OF SRUCOPY     */
         LA    @09,1                                               0572
         LR    K,@09                                               0572
*             SRUPTR=ADDR(SRUCOPY); /* SET RUPOINTER TO POINT TO   0573
*                                      COPIED RU                     */
         LA    @00,SRUCOPY(,ZCRRPTR)                               0573
         ST    @00,SRUPTR(,ZCRRPTR)                                0573
*             IF LCCWIDAT=ON        /* IF IMMEDIATE DATA             */
*                 &LCCWCNT=4 THEN                                  0574
         L     @15,LCCWPTR(,ZCRRPTR)                               0574
         TM    LCCWIDAT(@15),B'00001000'                           0574
         BNO   @RF00574                                            0574
         CLC   LCCWCNT(2,@15),@CH00052                             0574
         BNE   @RF00574                                            0574
*               DO;                 /* & LENGTH = 4                  */
*                 RUPTRC=ADDR(LCCWDATA);/* SET RUPTR = FIRST RU BYTE */
         LA    @00,LCCWDATA(,@15)                                  0576
         ST    @00,RUPTRC(,ZCRRPTR)                                0576
*                 SRUCOPY(K)=DATALCCW(4);/* COPY 1 BYTE OF RU        */
         LR    @15,ZCRRPTR                                         0577
         ALR   @15,K                                               0577
         LR    @14,@00                                             0577
         MVC   SRUCOPY-1(1,@15),DATALCCW+3(@14)                    0577
*                 K=K+1;            /* UPDATE INDEX INTO SRUCOPY     */
         ALR   K,@09                                               0578
*               END;                /* END IMMEDIATE 4 BYTE DATA     */
*             ELSE                  /* NOT IMMEDIATE 4 BYTE DATA     */
*               IF LCCWCNT>3 THEN                                  0580
         B     @RC00574                                            0580
@RF00574 L     @09,LCCWPTR(,ZCRRPTR)                               0580
         LH    @15,LCCWCNT(,@09)                                   0580
         N     @15,@CF04247                                        0580
         C     @15,@CF00287                                        0580
         BNH   @RF00580                                            0580
*                 DO;               /* IF LENGTH .GT. 3              */
*                   RUPTRC=ADDR(LCCWDATA)+3;/* POINT TO PART OF RU IN
*                                      DATA AREA             @XM08890*/
         LA    @14,3                                               0582
         LA    @09,LCCWDATA(,@09)                                  0582
         ALR   @09,@14                                             0582
         ST    @09,RUPTRC(,ZCRRPTR)                                0582
*                   SRUCOPY(1:MIN((LCCWCNT-3),6))=DATALCCW(1:(LCCWCNT-3
*                       ));         /* COPY LCCW DATA TO SRU         */
         SLR   @15,@14                                             0583
         LA    @14,6                                               0583
         CR    @14,@15                                             0583
         BNH   *+6
         LR    @14,@15                                             0583
         BCTR  @14,0                                               0583
         EX    @14,@SM04248                                        0583
*                   K=K+(LCCWCNT-3);/* DECREMENT DATA COUNTER        */
         ALR   K,@15                                               0584
*                 END;              /* END LENGTH .GT. 3             */
*               ELSE                                               0586
*                 ;                 /* IF LENGTH NOT .GT. 3          */
@RF00580 DS    0H                                                  0587
*             DO WHILE(LCCWPTR^=0&K<7);/* COPY 6 BYTES OF RU DATA    */
@RC00574 B     @DE00587                                            0587
@DL00587 DS    0H                                                  0588
*               LCCWPTR=LCCWPTR+LENGTH(ISTLCCW);/* INCREMENT TO NEXT
*                                      LCCW IN CHAIN                 */
         LA    @09,8                                               0588
         AL    @09,LCCWPTR(,ZCRRPTR)                               0588
         ST    @09,LCCWPTR(,ZCRRPTR)                               0588
*               IF LCCWOP=LTIC THEN /* IF OPCODE = LTIC              */
         CLI   LCCWOP(@09),X'08'                                   0589
         BNE   @RF00589                                            0589
*                 LCCWPTR=LCCWDATA; /* GET NEXT LCCW ADDRESS         */
         L     @09,LCCWDATA(,@09)                                  0590
         ST    @09,LCCWPTR(,ZCRRPTR)                               0590
*               ELSE                                               0591
*                 ;                 /* OPCODE .NE. LTIC              */
@RF00589 DS    0H                                                  0592
*               IF LCCWIDAT=ON THEN /* IF IMMEDIATE DATA             */
         L     @09,LCCWPTR(,ZCRRPTR)                               0592
         TM    LCCWIDAT(@09),B'00001000'                           0592
         BNO   @RF00592                                            0592
*                 RUPTRC=ADDR(LCCWDATA);/* ADDRESS DATA IN LCCW      */
         LA    @09,LCCWDATA(,@09)                                  0593
         ST    @09,RUPTRC(,ZCRRPTR)                                0593
*               ELSE                /* IF NOT IMMEDIATE DATA         */
*                 RUPTRC=LCCWDATA;  /* ADDRESS DATA FROM LCCW        */
         B     @RC00592                                            0594
@RF00592 L     @09,LCCWPTR(,ZCRRPTR)                               0594
         L     @09,LCCWDATA(,@09)                                  0594
         ST    @09,RUPTRC(,ZCRRPTR)                                0594
*               IF LCCWCNT>0        /* IF ANY ASSOCIATED DATA        */
*                   &K<7 THEN                                      0595
@RC00592 L     @09,LCCWPTR(,ZCRRPTR)                               0595
         LH    @09,LCCWCNT(,@09)                                   0595
         N     @09,@CF04247                                        0595
         LTR   @09,@09                                             0595
         BNP   @RF00595                                            0595
         C     K,@CF00714                                          0595
         BNL   @RF00595                                            0595
*                 DO;               /* & STILL MOVING DATA           */
*                   SRUCOPY(K:MIN((K+(LCCWCNT-1)),6))=DATALCCW(1:  0597
*                       LCCWCNT);   /* COPY NUMBER OF RU BYTES     0597
*                                      INDICATED BY COUNT            */
         LR    @15,ZCRRPTR                                         0597
         ALR   @15,K                                               0597
         LR    @14,@09                                             0597
         BCTR  @14,0                                               0597
         ALR   @14,K                                               0597
         LA    @11,6                                               0597
         CR    @14,@11                                             0597
         BNH   *+6
         LR    @14,@11                                             0597
         SLR   @14,K                                               0597
         L     @11,RUPTRC(,ZCRRPTR)                                0597
         EX    @14,@SM04250                                        0597
*                   K=K+LCCWCNT;    /* UPDATE INDEX INTO COPY FIELD  */
         ALR   K,@09                                               0598
*                 END;              /* END DATA MOVE                 */
*               ELSE                                               0600
*                 ;                 /* IF NOT MOVING DATA            */
@RF00595 DS    0H                                                  0601
*               IF LCCWCD=OFF THEN  /* IF NOT DATA CHAINED           */
         L     @09,LCCWPTR(,ZCRRPTR)                               0601
         TM    LCCWCD(@09),B'10000000'                             0601
         BNZ   @RF00601                                            0601
*                 LCCWPTR=0;        /* CLEAR LCCW POINTER            */
         SLR   @09,@09                                             0602
         ST    @09,LCCWPTR(,ZCRRPTR)                               0602
*               ELSE                                               0603
*                 ;                 /* IF DATA CHAINED               */
@RF00601 DS    0H                                                  0604
*             END;                  /* END DATA COPY LOOP            */
@DE00587 L     @09,LCCWPTR(,ZCRRPTR)                               0604
         LTR   @09,@09                                             0604
         BZ    @DC00587                                            0604
         C     K,@CF00714                                          0604
         BL    @DL00587                                            0604
@DC00587 DS    0H                                                  0605
*             LCCWPTR=LCPNXLCW;     /* RESTORE LCCW POINTER          */
         L     @09,LCPBPTR(,ZCRRPTR)                               0605
         L     @09,LCPNXLCW(,@09)                                  0605
         ST    @09,LCCWPTR(,ZCRRPTR)                               0605
*           END;                    /* END DATA CHAINING             */
*         RFY                                                      0607
*           K UNRSTD;                                              0607
@RC00569 DS    0H                                                  0608
*         IF RHQS=OFF THEN          /* IF REQUEST                    */
         L     @09,RHPTR(,ZCRRPTR)                                 0608
         TM    RHQS(@09),B'10000000'                               0608
         BNZ   @RF00608                                            0608
*           ZCRLREQ=ON;             /* SET REQUEST PROCESS FLAG      */
         OI    ZCRLREQ(ZCRRPTR),B'00010000'                        0609
*         ELSE                                                     0610
*           ;                       /* IF RESPONSE                   */
@RF00608 DS    0H                                                  0611
*         IF(SRUQSREQ=SRACTPU       /* IF ACTIVATE PHYSICAL          */
*             |SRUQSREQ=SRBIND)     /* | BIND                        */
*             &ZCRLREQ=ON THEN                                     0611
         L     @09,SRUPTR(,ZCRRPTR)                                0611
         CLI   SRUQSREQ(@09),X'11'                                 0611
         BE    @GL00005                                            0611
         CLI   SRUQSREQ(@09),X'31'                                 0611
         BNE   @RF00611                                            0611
@GL00005 TM    ZCRLREQ(ZCRRPTR),B'00010000'                        0611
         BNO   @RF00611                                            0611
*           DO;                     /* REQUEST                       */
*             FMCOSSN=0;            /* ZERO OUTBOUND SYNCH COUNTER   */
         SLR   @09,@09                                             0613
         STH   @09,FMCOSSN(,FMCBPTR)                               0613
*             FMCISSN=0;            /* ZERO INBOUND SYNCH COUNTER    */
         STH   @09,FMCISSN(,FMCBPTR)                               0614
*             FMCOASN=0;            /* ZERO ASYNCHRONOUS COUNTER     */
         STH   @09,FMCOASN(,FMCBPTR)                               0615
*           END;                    /* END ACTPU OR BIND REQUEST     */
*         ELSE                                                     0617
*           ;                       /* NOT ACTPU OR BIND REQUEST     */
@RF00611 DS    0H                                                  0618
*         IF SRUQSREQ=SRBIND        /* IF BIND REQUEST       @XM08711*/
*             &ZCRLREQ=ON THEN                                     0618
         L     @09,SRUPTR(,ZCRRPTR)                                0618
         CLI   SRUQSREQ(@09),X'31'                                 0618
         BNE   @RF00618                                            0618
         TM    ZCRLREQ(ZCRRPTR),B'00010000'                        0618
         BNO   @RF00618                                            0618
*           DO;                                                    0619
*             IF FMCSNBI=OFF        /* IF SESSION BOUND              */
*                 |FMCBIP=ON THEN                                  0620
         TM    FMCBIP(FMCBPTR),B'00001000'                         0620
         BNZ   @RT00620                                            0620
         TM    FMCSNBI(FMCBPTR),B'10000000'                        0620
         BO    @RF00620                                            0620
@RT00620 DS    0H                                                  0621
*               DO;                 /* | PROCESSING BIND             */
*                 ZCRPCOD1=0;       /* ZDFBO PARAMETER               */
         MVI   ZCRPCOD1(ZCRRPTR),X'00'                             0622
*                 ZCRPFSB=ON;       /* ZDFBO PARAMETER               */
         OI    ZCRPFSB(ZCRRPTR),B'00100000'                        0623
*                 CALL ISTZDFA0;    /* BUFFER ALLOCATION UTILITY     */
         L     @09,ATCZPSVT(,ATCVTPTR)                             0624
         L     @15,ZPSZDFA0(,@09)                                  0624
         BALR  @14,@15                                             0624
*                 FSBPTR=RPHSRPRM;  /* ADDRESS NEWLY OBTAINED FSB    */
         L     @09,RPHSRPRM(,RPHPTR)                               0625
         ST    @09,FSBPTR(,ZCRRPTR)                                0625
*                 FSBMJRCD=FRLOGICE;/* LOGIC ERROR                   */
         MVI   FSBMJRCD(@09),X'08'                                 0626
*                 FSBMNRCD=FRMUSELE;/* NO SESSION            @XM02224*/
         MVI   FSBMNRCD(@09),X'A3'                                 0627
*                 FSBLCPB=LCPBPTR;  /* SET LCPB ADDRESS IN FSB       */
         L     @07,LCPBPTR(,ZCRRPTR)                               0628
         ST    @07,FSBLCPB(,@09)                                   0628
*                 FSBLCCWA=LCPNXLCW;/* SET LCCW ADDRESS IN FSB       */
         L     @07,LCPNXLCW(,@07)                                  0629
         ST    @07,FSBLCCWA(,@09)                                  0629
*                 CALL ISTZFDB;     /* FEEDBACK STATUS               */
         BAL   @14,ISTZFDB                                         0630
*                 ZCRTPEX=ON;       /* SET EXIT FLAG                 */
         OI    ZCRTPEX(ZCRRPTR),B'10000000'                        0631
*               END;                /* END BIND WHILE BOUND          */
*             ELSE                                                 0633
*               DO;                 /* IF NOT INVALID BIND           */
         B     @RC00620                                            0633
@RF00620 DS    0H                                                  0634
*SND001:                                                           0634
*                 FMCBIP=ON;        /* FLAG BIND IN PROGRESS         */
SND001   OI    FMCBIP(FMCBPTR),B'00001000'                         0634
*                 IF SRUDFCLV=SRDFCL1/* IF DATA FLOW CNTRL LEVEL 1   */
*                     |SRUDFCLV=SRDFCL2 THEN/* | DATA FLOW CNTRL   0635
*                                      LEVEL 2                       */
         L     @09,SRUPTR(,ZCRRPTR)                                0635
         CLI   SRUDFCLV(@09),X'01'                                 0635
         BE    @RT00635                                            0635
         CLI   SRUDFCLV(@09),X'02'                                 0635
         BNE   @RF00635                                            0635
@RT00635 DS    0H                                                  0636
*                   CALL ISTZPBST;  /* PROHIBIT DATA FLOW    @X50BHEN*/
         BAL   @14,ISTZPBST                                        0636
*                 ELSE                                             0637
*                   ;               /* IF TSL NOT 1 OR 2             */
@RF00635 DS    0H                                                  0638
*                 IF BINTS>2 THEN   /* IF TSL NOT 0,1, OR 2  @X50BHEN*/
         L     @09,SRUPTR(,ZCRRPTR)                                0638
         CLI   BINTS+1(@09),2                                      0638
         BNH   @RF00638                                            0638
*                   FMCSDTR=ON;     /* SDT REQUIRED          @X50BHEN*/
         OI    FMCSDTR(FMCBPTR),B'00010000'                        0639
*                 ELSE                                             0640
*                   ;               /* IF TSL IS 0,1, OR 2   @X50BHEN*/
@RF00638 DS    0H                                                  0641
*                 IF BINTS>1 THEN   /* IF TSL NOT 0 OR 1     @X50BHEN*/
         L     @09,SRUPTR(,ZCRRPTR)                                0641
         CLI   BINTS+1(@09),1                                      0641
         BNH   @RF00641                                            0641
*                   FMCSEQI=ON;     /* SEQ CHECK REQUIRED    @X50BHEN*/
         OI    FMCSEQI(FMCBPTR),B'00000100'                        0642
*                 ELSE                                             0643
*                   DO;             /* IF TSL IS 0 OR 1              */
         B     @RC00641                                            0643
@RF00641 DS    0H                                                  0644
*                     FMCPACEM=0;   /* NO PACING REQUIRED    @XA07973*/
         MVI   FMCPACEM(FMCBPTR),X'00'                             0644
*                     FMCPACEN=0;   /* NO PACING REQUIRED    @XA07973*/
         MVI   FMCPACEN(FMCBPTR),X'00'                             0645
*                   END;            /* END TSL IS 0 OR 1     @XA07973*/
*                 ZCRTPINV=ON;      /* SET INVOKE TPIOS FLAG ON      */
@RC00641 OI    ZCRTPINV(ZCRRPTR),B'01000000'                       0647
*               END;                /* END NOT INVALID BIND          */
*           END;                    /* END BIND PROCESSING           */
*         ELSE                      /* NOT BIND PROCESS      @XL0BHEN*/
*           IF(SRUQSREQ=SRACTPU     /* IF ACT PHYSICAL       @XM08711*/
*               |SRUQSREQ=SRACTLU)  /* | ACT LOGICAL         @XM08711*/
*               &ZCRLREQ=ON THEN                                   0650
         B     @RC00618                                            0650
@RF00618 L     @09,SRUPTR(,ZCRRPTR)                                0650
         CLI   SRUQSREQ(@09),X'11'                                 0650
         BE    @GL00009                                            0650
         CLI   SRUQSREQ(@09),X'0D'                                 0650
         BNE   @RF00650                                            0650
@GL00009 TM    ZCRLREQ(ZCRRPTR),B'00010000'                        0650
         BNO   @RF00650                                            0650
*             DO;                   /* REQUEST               @XM08711*/
*               IF BINTS<=1 THEN                                   0652
         L     @09,SRUPTR(,ZCRRPTR)                                0652
         CLI   BINTS+1(@09),1                                      0652
         BH    @RF00652                                            0652
*                 DO;               /* IF TSL IS 0 OR 1      @XM10617*/
*                   FMCPACEM=0;     /* NO PACING REQUIRED    @XM10617*/
         MVI   FMCPACEM(FMCBPTR),X'00'                             0654
*                   FMCPACEN=0;     /* NO PACING REQUIRED    @XM10617*/
         MVI   FMCPACEN(FMCBPTR),X'00'                             0655
*                 END;              /* END TSL IS 0 OR 1     @XM10617*/
*               ELSE                                               0657
*                 ;                 /* TSL NOT 0 OR 1        @XM10617*/
@RF00652 DS    0H                                                  0658
*               FMCBIP=ON;          /* FLAG BIND IN PROGRESS         */
         OI    FMCBIP(FMCBPTR),B'00001000'                         0658
*               CALL ISTZPBST;      /* PROHIBIT DATA FLOW    @X50BHEN*/
         BAL   @14,ISTZPBST                                        0659
*               IF SRUTSPRO=SRUTSP3 THEN/* IF TSL IS 3       @X50BHEN*/
         L     @09,SRUPTR(,ZCRRPTR)                                0660
         TM    SRUTSPRO(@09),B'00000011'                           0660
         BNO   @RF00660                                            0660
         TM    SRUTSPRO(@09),B'00001100'                           0660
         BNZ   @RF00660                                            0660
*                 FMCSDTR=ON;       /* START DATA TRAFFIC REQUIRED 0661
*                                                            @X50BHEN*/
         OI    FMCSDTR(FMCBPTR),B'00010000'                        0661
*               ELSE                                               0662
*                 ;                 /* IF TSL IS NOT 3       @X50BHEN*/
@RF00660 DS    0H                                                  0663
*               IF SRUTSPRO^=SRUTSP0/* IF TSL NOT 0          @X50BHEN*/
*                   &SRUTSPRO^=SRUTSP1 THEN/* & TSL NOT 1    @X50BHEN*/
         L     @09,SRUPTR(,ZCRRPTR)                                0663
         TM    SRUTSPRO(@09),B'00001111'                           0663
         BZ    @RF00663                                            0663
         TM    SRUTSPRO(@09),B'00000001'                           0663
         BNO   @RT00663                                            0663
         TM    SRUTSPRO(@09),B'00001110'                           0663
         BZ    @RF00663                                            0663
@RT00663 DS    0H                                                  0664
*                 FMCSEQI=ON;       /* SEQUENCE NUMBER CHECK REQUIRED
*                                                            @X50BHEN*/
         OI    FMCSEQI(FMCBPTR),B'00000100'                        0664
*               ELSE                                               0665
*                 ;                 /* IF TSL NOT 0 OR 1     @X50BHEN*/
@RF00663 DS    0H                                                  0666
*               ZCRTPINV=ON;        /* SET INVOKE TPIOS FLAG ON      */
         OI    ZCRTPINV(ZCRRPTR),B'01000000'                       0666
*             END;                  /* END ACTIVATE REQUEST          */
*           ELSE                    /* IF NOT SESSION INITIATION   0668
*                                                            @X50BHEN*/
*             IF FMCSNBI=ON         /* IF SESSION NOT BOUND          */
*                 |(FMCCIPI=ON      /* | CLEAR IN PROGRESS           */
*                 |FMCUIPI=ON) THEN                                0668
         B     @RC00650                                            0668
@RF00650 TM    FMCSNBI(FMCBPTR),B'11100000'                        0668
         BZ    @RF00668                                            0668
*               DO;                 /* | UNBIND IN PROGRESS          */
*                 ZCRPCOD1=0;       /* ZDFA0 PARAMETER               */
         MVI   ZCRPCOD1(ZCRRPTR),X'00'                             0670
*                 ZCRPFSB=ON;       /* ZDFA0 PARAMETER               */
         OI    ZCRPFSB(ZCRRPTR),B'00100000'                        0671
*                 CALL ISTZDFA0;    /* BUFFER ALLOCATION UTILITY     */
         L     @09,ATCZPSVT(,ATCVTPTR)                             0672
         L     @15,ZPSZDFA0(,@09)                                  0672
         BALR  @14,@15                                             0672
*                 FSBPTR=RPHSRPRM;  /* ADDRESS OBTAINED FSB          */
         L     @09,RPHSRPRM(,RPHPTR)                               0673
         ST    @09,FSBPTR(,ZCRRPTR)                                0673
*                 FSBMJRCD=FRLOGICE;/* MAJOR=LOGIC ERROR             */
         MVI   FSBMJRCD(@09),X'08'                                 0674
*                 IF FMCSNBI=ON THEN/* IF SESSION NOT BOUND          */
         TM    FMCSNBI(FMCBPTR),B'10000000'                        0675
         BNO   @RF00675                                            0675
*                   FSBMNRCD=FRMUSELE;/* MINOR=USER LOGIC ERROR      */
         MVI   FSBMNRCD(@09),X'A3'                                 0676
*                 ELSE              /* IF SESSION IS BOUND           */
*                   FSBMNRCD=FRMRDIP;/* MINOR=DEACTIVATE IN PROCESS  */
         B     @RC00675                                            0677
@RF00675 L     @09,FSBPTR(,ZCRRPTR)                                0677
         MVI   FSBMNRCD(@09),X'A2'                                 0677
*                 FSBLCPB=LCPBPTR;  /* SET LCPB PONITER IN FSB       */
@RC00675 L     @09,FSBPTR(,ZCRRPTR)                                0678
         L     @07,LCPBPTR(,ZCRRPTR)                               0678
         ST    @07,FSBLCPB(,@09)                                   0678
*                 FSBLCCWA=LCPNXLCW;/* SET LCCW ADDRESS IN FSB       */
         L     @07,LCPNXLCW(,@07)                                  0679
         ST    @07,FSBLCCWA(,@09)                                  0679
*                 CALL ISTZFDB;     /* CALL FEEDBACK ROUTINE         */
         BAL   @14,ISTZFDB                                         0680
*                 ZCRTPEX=ON;       /* INDICATE TPEXIT               */
         OI    ZCRTPEX(ZCRRPTR),B'10000000'                        0681
*               END;                /* END SESSION NOT BOUND         */
*             ELSE                                                 0683
*               DO;                 /* NOT SESSION NOT BOUND         */
         B     @RC00668                                            0683
@RF00668 DS    0H                                                  0684
*                 IF SRUQSREQ=SRSTSN/* IF SET AND TEST SEQ NUMBER    */
*                     &ZCRLREQ=ON THEN                             0684
         L     @09,SRUPTR(,ZCRRPTR)                                0684
         CLI   SRUQSREQ(@09),X'A2'                                 0684
         BNE   @RF00684                                            0684
         TM    ZCRLREQ(ZCRRPTR),B'00010000'                        0684
         BNO   @RF00684                                            0684
*                   DO;             /* REQUEST                       */
*                     IF SRUPSAC=SRSETAC/* IF PRIMARY TO SECONDARY 0686
*                                      SET                           */
*                         |SRUPSAC=SRSTSAC THEN                    0686
         TM    SRUPSAC(@09),B'00010000'                            0686
         BNO   @GL00013                                            0686
         TM    SRUPSAC(@09),B'00100000'                            0686
         BZ    @RT00686                                            0686
@GL00013 L     @09,SRUPTR(,ZCRRPTR)                                0686
         TM    SRUPSAC(@09),B'00110000'                            0686
         BNO   @RF00686                                            0686
@RT00686 DS    0H                                                  0687
*                       FMCOSSN=SRUPSSN;/* SET PRIMARY TO SECONDARY  */
         L     @09,SRUPTR(,ZCRRPTR)                                0687
         MVC   FMCOSSN(2,FMCBPTR),SRUPSSN(@09)                     0687
*                     ELSE                                         0688
*                       ;           /* NOT PRIMARY TO SECONDARY      */
@RF00686 DS    0H                                                  0689
*                     IF SRUSPAC=SRSETAC/* IF SECONDARY TO PRIMARY   */
*                         |SRUPSAC=SRSTSAC THEN                    0689
         L     @09,SRUPTR(,ZCRRPTR)                                0689
         TM    SRUSPAC(@09),B'01000000'                            0689
         BNO   @GL00014                                            0689
         TM    SRUSPAC(@09),B'10000000'                            0689
         BZ    @RT00689                                            0689
@GL00014 L     @09,SRUPTR(,ZCRRPTR)                                0689
         TM    SRUPSAC(@09),B'00110000'                            0689
         BNO   @RF00689                                            0689
@RT00689 DS    0H                                                  0690
*                       FMCISSN=SRUSPSN;/* SET INBOUND SEQUENCE ID 0690
*                                                            @XM10611*/
         L     @09,SRUPTR(,ZCRRPTR)                                0690
         MVC   FMCISSN(2,FMCBPTR),SRUSPSN(@09)                     0690
*                     ELSE                                         0691
*                       ;           /* NOT SECONDARY TO PRIMARY      */
@RF00689 DS    0H                                                  0692
*                   END;            /* END STSN REQUEST              */
*                 ELSE                                             0693
*                   ;               /* NOT STSN REQUEST              */
@RF00684 DS    0H                                                  0694
*                 ZCRTPINV=ON;      /* SET INVOKE TPIOS FLAG         */
         OI    ZCRTPINV(ZCRRPTR),B'01000000'                       0694
*               END;                /* END NOT INVALID TERMINATION   */
*       END ISTZSND;                /* END OF SEGMENT ISTZSND        */
*/********************************************************************/
*/*      SEGMENT ISTZSND END                                         */
*/********************************************************************/
*                                                                  0697
*     ELSE                          /* IF NOT SEND OPERATION CODE    */
         EJECT
*                                                                  0697
*/********************************************************************/
*/*                                                                  */
*/* SEGMENT-                                                         */
*/*      ISTZTRM                                                     */
*/*                                                                  */
*/* FUNCTION-                                                        */
*/*      THIS SEGMENT HANDLES REQUESTS OTHER THAN NORMAL SENDS.      */
*/*                                                                  */
*/*      IF THE WORK ELEMENT IS A FSB AND THE OPCODE IS CLEAR,       */
*/*            THE FSB IS PASSED TO THE REQUESTOR.                   */
*/*                                                                  */
*/*            IF IT WAS A MULTIPLE REQUEST,                         */
*/*            THE UNBIND FSB IS RETURNED,                           */
*/*            NOTIFY IS DRIVEN (IF REQUIRED),               @XM19747*/
*/*            AND THE CLEAR FSB IS FREED.                           */
*/*                                                                  */
*/*            OTHERWISE,                                            */
*/*            NOTIFY IS DRIVEN (IF REQUIRED), AND           @XM19747*/
*/*            THE CLEAR FSB IS PASSED BACK TO THE REQUESTOR.        */
*/*                                                                  */
*/*      IF IT WAS NOT A CLEAR FSB,                                  */
*/*            A CHECK IS MADE TO SEE IF IT IS A CLSDEST FINISH      */
*/*            REQUEST.                                              */
*/*            IF IT IS A CLSDEST FINISH REQUEST,                    */
*/*            A FSB IS OBTAINED AND FORMATTED BACK TO THE REQUESTOR.*/
*/*                                                                  */
*/*      IF IT IS NONE OF THE ABOVE CONDITIONS,                      */
*/*            IF THE SESSION IS BOUND                               */
*/*            AND NOT PROCESSING CLEAR OR UNBIND,                   */
*/*            SEGMENT ISTZCLR IS INVOKED.                           */
*/*                                                                  */
*/********************************************************************/
*                                                                  0697
*ISTZTRM:                                                          0697
*       DO;                         /* SEGMENT ISTZTRM               */
         B     @RC00564                                            0697
@RF00564 DS    0H                                                  0697
ISTZTRM  DS    0H                                                  0698
*         IF ZCRFSBWE=ON THEN                                      0698
         TM    ZCRFSBWE(ZCRRPTR),B'00000100'                       0698
         BNO   @RF00698                                            0698
*           DO;                     /* IF FSB IS PRESENT             */
*             IF LCPTLBPI=ON THEN                                  0700
         L     @09,LCPBPTR(,ZCRRPTR)                               0700
         TM    LCPTLBPI(@09),B'00010000'                           0700
         BNO   @RF00700                                            0700
*               DO;                 /* IF TLB IS PRESENT IT IS A   0701
*                                      MULTIPLE REQUEST              */
*                 ZCRPCOD1=0;       /* ZDFB0 PARAMETER               */
         MVI   ZCRPCOD1(ZCRRPTR),X'00'                             0702
*                 ZCRPBUF=ON;       /* ZDFB0 PARAMETER               */
         OI    ZCRPBUF(ZCRRPTR),B'00000100'                        0703
*                 RFY                                              0704
*                  (R7) RSTD;       /* ZDFB0 PARAMETER REGISTER      */
*                 R7=ADDR(FSBFDB)-FDBOFSET;/* ZDFB0 PARAMETER -    0705
*                                      ADDRESS                       */
         L     @09,FSBPTR(,ZCRRPTR)                                0705
         LA    R7,FSBFDB(,@09)                                     0705
         SH    R7,FDBOFSET+32(,@09)                                0705
*                 R7->ZIBCHAIN=0;   /* ZERO BUFFER CHAIN POINTER     */
         SLR   @09,@09                                             0706
         ST    @09,ZIBCHAIN(,R7)                                   0706
*                 CALL ISTZDFB0;    /* BUFFER RELEASE UTILITY        */
         L     @09,ATCZPSVT(,ATCVTPTR)                             0707
         L     @15,ZPSZDFB0(,@09)                                  0707
         BALR  @14,@15                                             0707
*                 RFY                                              0708
*                  (R7) UNRSTD;     /* ZDFB0 PARAMETER REGISTER      */
*                 TLBPTR=LCPTLBAD;  /* POINT TO BEGINNING OF TLB   0709
*                                                            @XM00921*/
         L     @09,LCPBPTR(,ZCRRPTR)                               0709
         L     @07,LCPTLBAD(,@09)                                  0709
         ST    @07,TLBPTR(,ZCRRPTR)                                0709
*                 LCPNXLCW=TLBLCPA; /* RESTORE LCCW ADDRESS          */
         L     @00,TLBLCPA(,@07)                                   0710
         ST    @00,LCPNXLCW(,@09)                                  0710
*                 FSBPTR=TLBFSBA;   /* POINT TO UNBIND FSB           */
         L     @00,TLBFSBA(,@07)                                   0711
         ST    @00,FSBPTR(,ZCRRPTR)                                0711
*                 LCPTLBAD=0;       /* CLEAR TLB POINTER             */
         SLR   @00,@00                                             0712
         ST    @00,LCPTLBAD(,@09)                                  0712
*                 LCPTLBPI=OFF;     /* CLEAR TLB FLAG                */
         NI    LCPTLBPI(@09),B'11101111'                           0713
*                 TLBPTR=TLBPTR-LENGTH(ISTBFHDR);/* POINT BACK TO  0714
*                                      BUFFER ORIGIN                 */
*                                                                  0714
         SL    @07,@CF00058                                        0714
         ST    @07,TLBPTR(,ZCRRPTR)                                0714
*                 /***************************************************/
*                 /*                                                 */
*                 /* RELSTORE BUFADDR(TLBPTR)                        */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0715
*                 DO;                                              0715
*                                                                  0715
*/* ATBUILD (ISTATCVT,ISTRPH)                                        */
*/* END OF ATBUILD                                                   */
*                                                                  0716
*                   DCL                                            0716
*                     GPR00F FIXED(31) REG(00);                    0716
*                   DCL                                            0717
*                     GPR00P PTR(31) REG(00);                      0717
*                   DCL                                            0718
*                     GPR02F FIXED(31) REG(02);                    0718
*                   DCL                                            0719
*                     GPR02P PTR(31) REG(02);                      0719
*                   DCL                                            0720
*                     GPR03F FIXED(31) REG(03);                    0720
*                   DCL                                            0721
*                     GPR03P PTR(31) REG(03);                      0721
*                   DCL                                            0722
*                     GPR04F FIXED(31) REG(04);                    0722
*                   DCL                                            0723
*                     GPR04P PTR(31) REG(04);                      0723
*                   DCL                                            0724
*                     GPR05F FIXED(31) REG(05);                    0724
*                   DCL                                            0725
*                     GPR05P PTR(31) REG(05);                      0725
*                   DCL                                            0726
*                     GPR06F FIXED(31) REG(06);                    0726
*                   DCL                                            0727
*                     GPR06P PTR(31) REG(06);                      0727
*                   DCL                                            0728
*                     GPR07F FIXED(31) REG(07);                    0728
*                   DCL                                            0729
*                     GPR07P PTR(31) REG(07);                      0729
*                   DCL                                            0730
*                     GPR08F FIXED(31) REG(08);                    0730
*                   DCL                                            0731
*                     GPR08P PTR(31) REG(08);                      0731
*                   DCL                                            0732
*                     GPR09F FIXED(31) REG(09);                    0732
*                   DCL                                            0733
*                     GPR09P PTR(31) REG(09);                      0733
*                   DCL                                            0734
*                     GPR10F FIXED(31) REG(10);                    0734
*                   DCL                                            0735
*                     GPR10P PTR(31) REG(10);                      0735
*                   DCL                                            0736
*                     GPR11F FIXED(31) REG(11);                    0736
*                   DCL                                            0737
*                     GPR11P PTR(31) REG(11);                      0737
*                   DCL                                            0738
*                     GPR15F FIXED(31) REG(15);                    0738
*                   DCL                                            0739
*                     GPR15P PTR(31) REG(15);                      0739
*                   RFY                                            0740
*                    (GPR02P,                                      0740
*                     GPR03P,                                      0740
*                     GPR04P,                                      0740
*                     GPR15P) RSTD;                                0740
*                   RFY                                            0741
*                    (GPR01P,                                      0741
*                     GPR13P) RSTD;                                0741
*                   GENERATE REFS(GPR01P,GPR02P,GPR13P) SETS(RPHWORK);
          STM GPR02P,GPR13P,RPHWORK(GPR01P)
*                   RFY                                            0743
*                     GPR13P UNRSTD;                               0743
*                   GPR04P=TLBPTR;                                 0744
         L     GPR04P,TLBPTR(,ZCRRPTR)                             0744
*                   DCL                                            0745
*                     1 FMZA0016 FIXED(31) STATIC LOCAL,           0745
*                      2 * FIXED(8) INIT(64),                      0745
*                      2 * PTR(24) INIT(0);                        0745
*                   GPR03F=FMZA0016;                               0746
         L     GPR03F,FMZA0016                                     0746
*                   DO;             /* LISATCVT                    0747
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*                     GPR15P=ATCLCPTR;/* SET UP ATCVT POINTER        */
         L     GPR15P,ATCLCPTR                                     0748
*                   END;            /* LISATCVT                      */
*                   GPR02P=GPR15P->ATCBPDA;                        0750
         L     GPR02P,ATCBPDA(,GPR15P)                             0750
*                   GPR15P=GPR15P->ATCSMRS;                        0751
         L     GPR15P,ATCSMRS(,GPR15P)                             0751
*                   DCL                                            0752
*                     FMZL0016 BASED(GPR15P) LABEL VALUERANGE(*);  0752
*                   CALL FMZL0016;                                 0753
         BALR  @14,@15                                             0753
*                   RFY                                            0754
*                     GPR13P RSTD;                                 0754
*                   GENERATE REFS(GPR01P,RPHWORK) SETS(GPR02P,GPR13P);
          LM GPR02P,GPR13P,RPHWORK(GPR01P)
*                   RFY                                            0756
*                    (GPR01P,                                      0756
*                     GPR13P) UNRSTD;                              0756
*                   RFY                                            0757
*                    (GPR02P,                                      0757
*                     GPR03P,                                      0757
*                     GPR04P,                                      0757
*                     GPR15P) UNRSTD;                              0757
*                 END;              /* *********END OF RELSTORE    0758
*                                      EXPANSION********* FREE TLB   */
*               END;                /* END TLB PRESENT               */
*             ELSE                                                 0760
*               ;                   /* IF TLB NOT PRESENT            */
@RF00700 DS    0H                                                  0761
*             GO TO CHECKFLG;       /* CONTINUE PROCESSING           */
         B     CHECKFLG                                            0761
*           END;                    /* END FSB PRESENT               */
*         ELSE                                                     0763
*           DO;                     /* IF FSB IS NOT PRESENT         */
@RF00698 DS    0H                                                  0764
*             LCPRUCNT=LCPMNRCD;    /* SAVE CLEAR REASON CODE      0764
*                                                            @XM19747*/
         L     @09,LCPBPTR(,ZCRRPTR)                               0764
         MVC   LCPRUCNT(1,@09),LCPMNRCD(@09)                       0764
*             IF LCCWIDAT=ON THEN   /* IF IMMEDIATE DATA             */
         L     @09,LCCWPTR(,ZCRRPTR)                               0765
         TM    LCCWIDAT(@09),B'00001000'                           0765
         BNO   @RF00765                                            0765
*               RHPTR=ADDR(LCCWDATA);/* ADDRESS RH IN LCCW           */
         LA    @09,LCCWDATA(,@09)                                  0766
         ST    @09,RHPTR(,ZCRRPTR)                                 0766
*             ELSE                  /* IF NOT IMMEDIATE DATA         */
*               RHPTR=LCCWDATA;     /* ADDRESS RH FROM LCCW          */
         B     @RC00765                                            0767
@RF00765 L     @09,LCCWPTR(,ZCRRPTR)                               0767
         L     @09,LCCWDATA(,@09)                                  0767
         ST    @09,RHPTR(,ZCRRPTR)                                 0767
*             IF FMCSNBI=ON         /* IF SESSION NOT BOUND          */
*                 &FMCBIP=OFF THEN                                 0768
@RC00765 TM    FMCSNBI(FMCBPTR),B'10000000'                        0768
         BNO   @RF00768                                            0768
         TM    FMCBIP(FMCBPTR),B'00001000'                         0768
         BNZ   @RF00768                                            0768
*               DO;                 /* & NOT BIND IN PROGRESS        */
*                 IF LCCWOP=LCRUDNFY THEN                          0770
         L     @09,LCCWPTR(,ZCRRPTR)                               0770
         CLI   LCCWOP(@09),X'F4'                                   0770
         BNE   @RF00770                                            0770
*                   DO;             /* IF CLEAR UNBIND NOTIFY        */
*                     CALL NOTIFY;  /* NOTIFY APPLICATION    @XM19747*/
         BAL   @14,NOTIFY                                          0772
*                     FMCNSALU=ON;  /* NO SESSION EXISTS             */
         OI    FMCNSALU(FMCBPTR),B'00000100'                       0773
*                   END;            /* END CLEAR UNBIND NOTIFY       */
*                 ELSE                                             0775
*                   ;               /* NOT CLEAR UNBIND NOTIFY       */
@RF00770 DS    0H                                                  0776
*                 GO TO GETFSB;     /* CONTINUE PROCESSING           */
         B     GETFSB                                              0776
*               END;                /* END NOT IN SESSION            */
*             ELSE                                                 0778
*               DO;                 /* IF BOUND OR BIND UP           */
@RF00768 DS    0H                                                  0779
*                 IF FMCSNBI=ON THEN/* IF SESSION NOT BOUND          */
         TM    FMCSNBI(FMCBPTR),B'10000000'                        0779
         BNO   @RF00779                                            0779
*                   IF LCCWOP=LCLEAR/* IF CLEAR              @XM10462*/
*                       |LCCWOP=LCRUD/* | CLEAR UNBIND               */
*                       |LCCWOP=LCRUDNFY/* | CLEAR UNBIND NOTIFY     */
*                       |LCCWOP=LNFY/* | NOTIFY                      */
*                       |LCCWOP=LCLRNFY THEN                       0780
         L     @09,LCCWPTR(,ZCRRPTR)                               0780
         CLI   LCCWOP(@09),X'F2'                                   0780
         BE    @RT00780                                            0780
         CLI   LCCWOP(@09),X'F3'                                   0780
         BE    @RT00780                                            0780
         CLI   LCCWOP(@09),X'F4'                                   0780
         BE    @RT00780                                            0780
         CLI   LCCWOP(@09),X'F5'                                   0780
         BE    @RT00780                                            0780
         CLI   LCCWOP(@09),X'F8'                                   0780
         BNE   @RF00780                                            0780
@RT00780 DS    0H                                                  0781
*                     ;             /* | CLEAR NOTIFY                */
*                   ELSE            /* NONE OF THE ABOVE             */
*                     GO TO GETFSB; /* CONTINUE FROM GETFSB          */
*                 IF(FMCCIPI=ON     /* IF CLEAR IN PROGRESS          */
*                     |FMCUIPI=ON)  /* | UNBIND IN PROGRESS          */
*                     &LCCWOP=LCLEAR THEN/* & OPERATION CODE = CLEAR */
@RF00779 TM    FMCCIPI(FMCBPTR),B'01100000'                        0783
         BZ    @RF00783                                            0783
         L     @09,LCCWPTR(,ZCRRPTR)                               0783
         CLI   LCCWOP(@09),X'F2'                                   0783
         BE    @RT00783                                            0783
*                   GO TO GETFSB;   /* CONTINUE FROM GETFSB          */
*                 ELSE              /* OTHERWISE                     */
*                   CALL ISTZCLR;   /* PROCESS OTHER POSSIBIITIES    */
@RF00783 BAL   @14,ISTZCLR                                         0785
*                 GO TO CHECKFLG;   /* CONTINUE IN ANY CASE          */
         B     CHECKFLG                                            0786
*               END;                /* END BOUND OR BIND UP          */
*GETFSB:                                                           0788
*             ;                     /* BRANCH POINT                  */
GETFSB   DS    0H                                                  0789
*             ZCRPCOD1=0;           /* ZDFA0 PARAMETER               */
         MVI   ZCRPCOD1(ZCRRPTR),X'00'                             0789
*             ZCRPFSB=ON;           /* ZDFA0 PARAMETER               */
         OI    ZCRPFSB(ZCRRPTR),B'00100000'                        0790
*             CALL ISTZDFA0;        /* BUFFER ALLOCATION UTILITY     */
         L     @09,ATCZPSVT(,ATCVTPTR)                             0791
         L     @15,ZPSZDFA0(,@09)                                  0791
         BALR  @14,@15                                             0791
*             FSBPTR=RPHSRPRM;      /* ADDRESS ALLOCATED FSB         */
         L     @09,RPHSRPRM(,RPHPTR)                               0792
         ST    @09,FSBPTR(,ZCRRPTR)                                0792
*             FSBMJRCD=FRLOGICE;    /* MAJOR=LOGIC ERROR             */
         MVI   FSBMJRCD(@09),X'08'                                 0793
*             FSBMNRCD=FRMUSELE;    /* MINOR=USER LOGIC ERROR        */
         MVI   FSBMNRCD(@09),X'A3'                                 0794
*             FSBLCPB=LCPBPTR;      /* SET ADDRESS OF LCPB IN FSB    */
         L     @07,LCPBPTR(,ZCRRPTR)                               0795
         ST    @07,FSBLCPB(,@09)                                   0795
*             FSBLCCWA=LCPNXLCW;    /* ADDRESS FAILING LCCW          */
         L     @07,LCPNXLCW(,@07)                                  0796
         ST    @07,FSBLCCWA(,@09)                                  0796
*             ZCRRJLCP=ON;          /* FLAG LCPB REJECTED            */
         OI    ZCRRJLCP(ZCRRPTR),B'00100000'                       0797
*CHECKFLG:                                                         0798
*             ;                     /* BRANCH POINT                  */
CHECKFLG DS    0H                                                  0799
*             IF ZCRTPINV=OFF       /* IF INVOKE TPIOS FLAG OFF      */
*                 &ZCRTPEX=OFF THEN                                0799
         TM    ZCRTPINV(ZCRRPTR),B'11000000'                       0799
         BNZ   @RF00799                                            0799
*               DO;                 /* & EXIT FLAG OFF               */
*                 CALL ISTZFDB;     /* FEED FSB BACK TO REQUESTOR    */
         BAL   @14,ISTZFDB                                         0801
*                 ZCRTPEX=ON;       /* SET TPEXIT INDICATOR          */
         OI    ZCRTPEX(ZCRRPTR),B'10000000'                        0802
*               END;                /* END FEEDBACK PROCESSING       */
*             ELSE                                                 0804
*               ;                   /* NOT FEEDBACK PROCESSING       */
@RF00799 DS    0H                                                  0805
*           END;                    /* END FSB NOT PRESENT           */
*       END ISTZTRM;                /* END OF SEGMENT                */
*/********************************************************************/
*/*      ISTZTRM SEGMENT END                                         */
*/********************************************************************/
*                                                                  0807
*   RFY                                                            0807
*    (R15) RSTD;                    /* RETURN CODE REGISTER          */
@RC00564 DS    0H                                                  0807
@RT00562 DS    0H                                                  0808
*   IF ZCRTPINV=ON THEN             /* IF INVOKE TPIOS FLAG ON       */
         TM    ZCRTPINV(ZCRRPTR),B'01000000'                       0808
         BNO   @RF00808                                            0808
*     R15=00;                       /* SET RETURN CODE = 00          */
         SLR   R15,R15                                             0809
*   ELSE                            /* IF INVOKE TPIOS FLAG OFF      */
*     IF ZCRRJLCP=ON THEN           /* IF REJECT LCPB INDICATED      */
         B     @RC00808                                            0810
@RF00808 TM    ZCRRJLCP(ZCRRPTR),B'00100000'                       0810
         BNO   @RF00810                                            0810
*       R15=08;                     /* SET RETURN CODE = 08          */
         LA    R15,8                                               0811
*     ELSE                          /* IF LCPB REJECT OFF            */
*       R15=04;                     /* SET RETURN CODE = 04          */
         B     @RC00810                                            0812
@RF00810 LA    R15,4                                               0812
*/* TPZRETN                                                          */
*                                                                  0813
*   DO;                                                            0813
@RC00810 DS    0H                                                  0813
@RC00808 DS    0H                                                  0814
*     RFY                                                          0814
*      (GPR07P,                                                    0814
*       GPR14P,                                                    0814
*       GPR15P) RSTD;                                              0814
*     GPR13P=ZSAZSVBC;                                             0815
         L     GPR13P,ZSAZSVBC(,GPR13P)                            0815
*     IF GPR13P=0 THEN                                             0816
         LTR   GPR13P,GPR13P                                       0816
         BZ    @RT00816                                            0816
*       ;                           /* TPDVTS ISTZFARR               */
*     ELSE                                                         0818
*       GPR14P=ZSAZSVRR;                                           0818
         L     GPR14P,ZSAZSVRR(,GPR13P)                            0818
*     GEN REFS(ZSAZSVVR)(LM    7,12,ZSAZSVVR+0(13));               0819
@RT00816 DS    0H                                                  0819
         LM    7,12,ZSAZSVVR+0(13)
*     GEN REFS(GPR14P) EXIT NOSEQFLOW(BR    GPR14P);               0820
         BR    GPR14P
*     RFY                                                          0821
*      (GPR07P,                                                    0821
*       GPR14P,                                                    0821
*       GPR15P) UNRSTD;                                            0821
*   END;                                                           0822
*                                                                  0822
*/* END TPZRETN                                                      */
*                                                                  0823
*                                   /* RETURN LINKAGE                */
         EJECT
*                                                                  0823
*/********************************************************************/
*/*                                                                  */
*/* SUBROUTINE-                                                      */
*/*      ISTZCLR                                                     */
*/*                                                                  */
*/* FUNCTION-                                                        */
*/*      PROCESS CLEAR (UNBIND,(NOTIFY)) OR NOTIFY ALONE REQUESTS.   */
*/*                                                                  */
*/*      UPON ENTRY, THE PROCESSING CLEAR FLAG IS SET UNLESS         */
*/*      ENTERED TO PROCESS A NOTIFY ALONE.                          */
*/*                                                                  */
*/*      FOR A CLEAR TYPE REQUEST,                                   */
*/*            TRAFFIC IS PROHIBITED ON THE TOP, ATOP, AND CLIP.     */
*/*                                                                  */
*/*      FOR CLEAR/UNBIND/NOTIFIY AND NOTIFY,                        */
*/*            A FSB IS OBTAINED, FORMATTED, AND QUEUED TO THE SIP.  */
*/*            FOR NOTIFY,                                           */
*/*                THE RPH (ADDRESSED FROM THE LCPB) IS POSTED.      */
*/*                                                                  */
*/*      FOR MULTIPLE REQUESTS, (CLEAR/UNBIND OR CLEAR/UNBIND/NOTIFY)*/
*/*            A TLB IS BUILT AND A POINTER TO IT IS SET IN THE LCPB.*/
*/*            DATA TRAFFIC IS PROHIBITED ON THE TOP, ATOP, AND CLIP.*/
*/*                                                                  */
*/********************************************************************/
*                                                                  0823
*ISTZCLR:                                                          0823
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);/* ISTZCLR SUBROUTINE            */
ISTZCLR  DS    0H                                                  0824
*   RFY                                                            0824
*     R14 RSTD;                     /* TO SAVE RETURN POINTER        */
*   R14SAVE=R14;                    /* SAVE RETURN POINTER           */
         ST    R14,R14SAVE(,ZCRRPTR)                               0825
*   RFY                                                            0826
*     R14 UNRSTD;                   /* SAVED                         */
*   IF LCCWOP^=LNFY THEN            /* IF NOT NOTIFY OPERATION       */
         L     @14,LCCWPTR(,ZCRRPTR)                               0827
         CLI   LCCWOP(@14),X'F5'                                   0827
         BE    @RF00827                                            0827
*     FMCCIPI=ON;                   /* FLAG CLEAR IN PROCESS         */
         OI    FMCCIPI(FMCBPTR),B'01000000'                        0828
*   ELSE                                                           0829
*     ;                             /* IF NOTIFY OPERATION CODE      */
@RF00827 DS    0H                                                  0830
*   IF LCCWOP=LCLEAR THEN                                          0830
         L     @14,LCCWPTR(,ZCRRPTR)                               0830
         CLI   LCCWOP(@14),X'F2'                                   0830
         BNE   @RF00830                                            0830
*     DO;                           /* IF HANDLING A CLEAR           */
*       ZCRTPINV=ON;                /* SET INVOKE TPIOS BIT ON TO  0832
*                                      CAUSE RETURN CODE 0           */
         OI    ZCRTPINV(ZCRRPTR),B'01000000'                       0832
*       CALL ISTZPBST;              /* INHIBIT DATA TRAFFIC          */
         BAL   @14,ISTZPBST                                        0833
*     END;                          /* END CLEAR PROCESSING          */
*   ELSE                                                           0835
*     DO;                           /* NOT CLEAR ALONE               */
         B     @RC00830                                            0835
@RF00830 DS    0H                                                  0836
*       IF LCCWOP=LNFY THEN                                        0836
         L     @14,LCCWPTR(,ZCRRPTR)                               0836
         CLI   LCCWOP(@14),X'F5'                                   0836
         BNE   @RF00836                                            0836
*         DO;                       /* IF NOTIFY ALONE               */
*           CALL NOTIFY;            /* PROCESS NOFIFY        @XM19747*/
         BAL   @14,NOTIFY                                          0838
*/* TPDEQ (LCPBPTR,FMCPAB5) RESET(YES)                               */
*                                                                  0839
*           DO;                     /* BEGIN TPDEQ CODE GENERATION   */
*             DCL                                                  0840
*               FMZCA035 BIT(32) CONSTANT('80000000'X);            0840
*             DCL                                                  0841
*               FMZCB035 BIT(32) CONSTANT('7FFFFFFF'X);            0841
*             RFY                                                  0842
*              (GPR00P,                                            0842
*               GPR01P,                                            0842
*               GPR14P,                                            0842
*               GPR15P) RSTD;                                      0842
*             RFY                                                  0843
*               ISTWKE;                                            0843
*             GPR15P=ADDR(FMCPAB5); /* ADDRESS QUEUE POINTER         */
         LA    GPR15P,FMCPAB5(,FMCBPTR)                            0844
*             RFY                                                  0845
*              (GPR02P,                                            0845
*               GPR03P) RSTD;                                      0845
*             STM(GPR02P,GPR03P,GPR01P->RPHWORK(5:12));            0846
         STM   GPR02P,GPR03P,RPHWORK+4(GPR01P)                     0846
*             GPR03P=LCPBPTR|FMZCA035;                             0847
         L     @09,@CF00744                                        0847
         L     GPR03P,LCPBPTR(,ZCRRPTR)                            0847
         OR    GPR03P,@09                                          0847
*             GPR14P=FMZCA035;                                     0848
         LR    GPR14P,@09                                          0848
*             GPR15P=ADDR(GPR15P->PABWEQA);                        0849
*FMZL1035:                                                         0850
*             ;                                                    0850
FMZL1035 DS    0H                                                  0851
*             GPR02P=GPR15P->PABWEQA|FMZCA035;                     0851
         L     GPR02P,PABWEQA(,GPR15P)                             0851
         O     GPR02P,@CF00744                                     0851
*             DO WHILE(GPR02P^=GPR14P);                            0852
         B     @DE00852                                            0852
@DL00852 DS    0H                                                  0853
*FMZL2035:                                                         0853
*               ;                                                  0853
FMZL2035 DS    0H                                                  0854
*               IF GPR02P=GPR03P THEN                              0854
         CR    GPR02P,GPR03P                                       0854
         BNE   @RF00854                                            0854
*                 DO;                                              0855
*                   GPR00P=GPR02P->WKECHAIN;                       0856
         L     GPR00P,WKECHAIN(,GPR02P)                            0856
*                   CS(GPR02P,GPR00P,GPR15P->PABWEQA);             0857
         CS    GPR02P,@00,PABWEQA(GPR15P)                          0857
*                   BC(7,FMZL3035);                                0858
         BC    7,FMZL3035                                          0858
*                   GPR14P=GPR02P;                                 0859
         LR    GPR14P,GPR02P                                       0859
*                   GPR14P->WKECHAIN=0;                            0860
         SLR   @09,@09                                             0860
         ST    @09,WKECHAIN(,GPR14P)                               0860
*                 END;                                             0861
*               ELSE                                               0862
*                 DO;                                              0862
         B     @RC00854                                            0862
@RF00854 DS    0H                                                  0863
*                   IF(GPR02P->WKECHAIN)=GPR14P THEN               0863
         C     GPR14P,WKECHAIN(,GPR02P)                            0863
         BNE   @RF00863                                            0863
*                     DO;                                          0864
*                       IF GPR02P->FSBTYPE=FSTYPE THEN             0865
         CLI   FSBTYPE(GPR02P),X'02'                               0865
         BNE   @RF00865                                            0865
*                         DO;                                      0866
*                           GPR02P=GPR14P;                         0867
         LR    GPR02P,GPR14P                                       0867
*                           GOTO FMZL3035;                         0868
         B     FMZL3035                                            0868
*                         END;                                     0869
*                       GPR15P=ADDR(GPR02P->LCPRSTQH);             0870
@RF00865 LA    GPR15P,LCPRSTQH(,GPR02P)                            0870
*                       GOTO FMZL1035;                             0871
         B     FMZL1035                                            0871
*                     END;                                         0872
*                   ELSE                                           0873
*                     DO;                                          0873
@RF00863 DS    0H                                                  0874
*                       GPR15P=ADDR(GPR02P->WKECHAIN);             0874
         LA    GPR15P,WKECHAIN(,GPR02P)                            0874
*                       GPR02P=GPR02P->WKECHAIN;                   0875
         L     GPR02P,WKECHAIN(,GPR02P)                            0875
*                       GOTO FMZL2035;                             0876
         B     FMZL2035                                            0876
*                     END;                                         0877
*                 END;                                             0878
*FMZL3035:                                                         0879
*               ;                                                  0879
@RC00854 DS    0H                                                  0879
FMZL3035 DS    0H                                                  0880
*             END;                                                 0880
@DE00852 CR    GPR02P,GPR14P                                       0880
         BNE   @DL00852                                            0880
*ISTA0035:                                                         0881
*             ;                                                    0881
ISTA0035 DS    0H                                                  0882
*             LM(GPR02P,GPR03P,GPR01P->RPHWORK(5:12));             0882
         LM    GPR02P,GPR03P,RPHWORK+4(GPR01P)                     0882
*             RFY                                                  0883
*              (GPR02P,                                            0883
*               GPR03P) UNRSTD;                                    0883
*             GPR14P=GPR14P&FMZCB035;                              0884
         N     GPR14P,@CF00742                                     0884
*             GPR01P->RPHWEA=GPR14P;                               0885
         ST    GPR14P,RPHWEA(,GPR01P)                              0885
*             RFY                                                  0886
*              (GPR00P,                                            0886
*               GPR01P,                                            0886
*               GPR14P,                                            0886
*               GPR15P) UNRSTD;                                    0886
*           END;                    /* END TPDEQ GENERATION DEQUE  0887
*                                      LCPB                  @ZA19522*/
*/*TPPOST  (LCPRPHA)                                                 */
*                                                                  0888
*           DO;                     /* DECLARE AND RESTRICT REGS     */
*             RESPECIFY                                            0889
*              (GPR00F,                                            0889
*               GPR01F,                                            0889
*               GPR04F,                                            0889
*               GPR05F,                                            0889
*               GPR06F,                                            0889
*               GPR14F,                                            0889
*               GPR15F) RSTD;       /* 0,1,4,5,6,14, AND 15          */
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTRPH)                                 */
*/* END OF ATBUILD                                                   */
*                                                                  0890
*             GEN REFS(GPR01P,GPR02F,GPR06F) SETS(RPHWORK);        0890
        STM GPR02F,GPR06F,RPHWORK(GPR01P)
*             GPR04F=LCPRPHA;       /* LOAD RPH PNTR INTO REG 4      */
         L     @09,LCPBPTR(,ZCRRPTR)                               0891
         L     GPR04F,LCPRPHA(,@09)                                0891
*             RFY                                                  0892
*               GPR03F RSTD;                                       0892
*             GPR03F=0;                                            0893
         SLR   @09,@09                                             0893
         LR    GPR03F,@09                                          0893
*             DO;                   /* MODESET SAVEKEY(GPR06F)     0894
*                                      KEYADDR(GPR03F)             0894
*                                      WORKREG(GPR05F)               */
*               RESPECIFY                                          0895
*                (GPR02F) RESTRICTED;                              0895
*               GPR05F=GPR02F;      /* SAVE REGISTER 2               */
         LR    GPR05F,GPR02F                                       0896
*               IPK;                /* SAVE CURRENT PSW KEY          */
         IPK                                                       0897
*               GPR06F=GPR02F;                                     0898
         LR    GPR06F,GPR02F                                       0898
*               GPR02F=GPR05F;      /* RESTORE REGISTER 2            */
         LR    GPR02F,GPR05F                                       0899
*               SPKA(GPR03F);       /* SET PSW KEY                   */
         SPKA  0(GPR03F)                                           0900
*               RESPECIFY                                          0901
*                (GPR02F) UNRESTRICTED;                            0901
*             END;                  /* MODESET SAVEKEY(GPR06F)     0902
*                                      KEYADDR(GPR03F)             0902
*                                      WORKREG(GPR05F)               */
*             RFY                                                  0903
*               GPR03F UNRSTD;                                     0903
*             GPR05P=GPR04P->RPHMAJCB+GPR04P->RPHPABOF;/* LOAD REG 5
*                                      WITH ADDR OF MAJOR CONTROL  0904
*                                      BLOCK PLUS OFFSET OF PAB IN 0904
*                                      BLOCK                         */
         L     GPR05P,RPHMAJCB-1(,GPR04P)                          0904
         LA    GPR05P,0(,GPR05P)                                   0904
         SLR   @07,@07                                             0904
         IC    @07,RPHPABOF(,GPR04P)                               0904
         ALR   GPR05P,@07                                          0904
*             GPR14P=0;             /* LOAD 0 INTO REG 14            */
         LR    GPR14P,@09                                          0905
*             GPR15P='FFFFFFFF'X;   /* LOAD REG 15 WITH DUMMY ADDRESS*/
         SLR   GPR15P,GPR15P                                       0906
         BCTR  GPR15P,0                                            0906
*             CS(GPR14P,GPR15P,GPR04P->RPHRESMA);/* COMPARE RESUME 0907
*                                      ADDRESS WITH 0 AND,IF EQUAL,
*                                      PUT DUMMY ADDRESS IN CONTROL
*                                      BLOCK RESUME ADDRESS          */
         CS    GPR14P,@15,RPHRESMA(GPR04P)                         0907
*             BC(8,FMZT0042);       /* IF EQUAL, BYPASS REMAINDER OF
*                                      EXPANSION                     */
         BC    8,FMZT0042                                          0908
*FMZL0042:                                                         0909
*             IF GPR04P->RPHWT='1'B THEN/* WT/EXT CONTENTION FLAG ON */
FMZL0042 TM    RPHWT(GPR04P),B'00001000'                           0909
         BNO   @RF00909                                            0909
*               DO;                 /* IN RPH                        */
*                 GPR14P=GPR04P->RPHRESMA|RPHWT1;/* LOAD REG 14 WITH
*                                      FLAG FIELD AND MAKE CERTAIN 0911
*                                      WT/EXT CONTENTION FLAG STILL
*                                      ON                            */
         L     GPR14P,RPHRESMA(,GPR04P)                            0911
         O     GPR14P,@CF00768                                     0911
*                 GPR15P=GPR14P|RPHPT1;/* LOAD REG 15 WITH FLAG FIELD
*                                      AND TURN POST FLAG ON         */
         LR    GPR15P,GPR14P                                       0912
         O     GPR15P,@CF00758                                     0912
*                 CS(GPR14P,GPR15P,GPR04P->RPHRESMA);/* COMPARE REG
*                                      14 WITH FLAG FIELD--IF WT/EXT
*                                      BIT ON, TURN ON POST FLAG     */
         CS    GPR14P,@15,RPHRESMA(GPR04P)                         0913
*                 BC(4,FMZL0042);   /* IF WT/EXT BIT WAS OFF, LOOP TO
*                                      TEST CONTENTION FLAG          */
         BC    4,FMZL0042                                          0914
*                 BC(8,FMZT0042);   /* IF WT/EXT BIT WAS OFF, BRANCH
*                                      TO BYPASS CODE GEN            */
         BC    8,FMZT0042                                          0915
*               END;                /* IF POST FLAG IS ON, FALL THRU
*                                      BOTTOM OF LOOP                */
*             ELSE                                                 0917
*               ;                   /* WT/EXT CONTENTION FLAG OFF    */
@RF00909 DS    0H                                                  0918
*             IF GPR04P->RPHTSKID=GPR01P->RPHTSKID THEN            0918
         CLC   RPHTSKID(4,GPR04P),RPHTSKID(GPR01P)                 0918
         BNE   @RF00918                                            0918
*               DO;                                                0919
*                 GPR05P->PABCHNGP=GPR01P->RPHPABQP;/* PUT PAB QUEUE
*                                      ADDRESS IN SECOND WORD OF PAB */
         MVC   PABCHNGP(3,GPR05P),RPHPABQP(GPR01P)                 0920
*                 GPR01P->RPHPABQP=GPR05P;/* PUT PAB ADDRESS (IN   0921
*                                      MAJOR CONTROL BLOCK) IN PAB 0921
*                                      QUEUE ADRESS IN RPH           */
         STCM  GPR05P,7,RPHPABQP(GPR01P)                           0921
*               END;                                               0922
*             ELSE                                                 0923
*               DO;                                                0923
         B     @RC00918                                            0923
@RF00918 DS    0H                                                  0924
*                 GPR00F=0;         /* SET REG 0 TO INDICATE ENA     */
         SLR   GPR00F,GPR00F                                       0924
*                 DO;               /* LISATCVT                    0925
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*                   GPR15P=ATCLCPTR;/* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     0926
*                 END;              /* LISATCVT PUT POINTER TO ATCVT
*                                      IN IN REG 15                  */
*                 CALL GPR15P->ATCAP32;/* CALL ISTAPC32: TPSCHED     */
         L     @09,ATCAP32(,GPR15P)                                0928
         LR    @15,@09                                             0928
         BALR  @14,@15                                             0928
*               END;                                               0929
*FMZT0042:                                                         0930
*             DO;                   /* MODESET KEYADDR(GPR06F)     0930
*                                      WORKREG(GPR05F)               */
@RC00918 DS    0H                                                  0930
FMZT0042 DS    0H                                                  0931
*               GPR05F=GPR06F;      /* GET KEY FORM SAVE LOCATION    */
         LR    GPR05F,GPR06F                                       0931
*               SPKA(GPR05F);       /* SET PSW KEY                   */
         SPKA  0(GPR05F)                                           0932
*             END;                  /* MODESET KEYADDR(GPR06F)     0933
*                                      WORKREG(GPR05F)               */
*             GEN REFS(GPR04P,RPHWORK) SETS(GPR02F,GPR03F,GPR04F,GPR05F
*                 ,GPR06F);                                        0934
        LM GPR02F,GPR06F,RPHWORK(GPR01P)
*             RESPECIFY                                            0935
*              (GPR00F,                                            0935
*               GPR01F,                                            0935
*               GPR04F,                                            0935
*               GPR05F,                                            0935
*               GPR06F,                                            0935
*               GPR14F,                                            0935
*               GPR15F) UNRSTD;     /* UNRESTRICT REGS 0,1, 4,5,14,
*                                      AND 15                        */
*           END;                    /* ***END OF TPPOST GENERATION***
*                                      POST THE RPH (FROM LCPB)      */
*           ZCRTPEX=ON;             /* TURN ON TPEXIT FLAG           */
         OI    ZCRTPEX(ZCRRPTR),B'10000000'                        0937
*         END;                      /* END NOTIFY ALONE              */
*       ELSE                                                       0939
*         DO;                       /* NOT NOTIFY ALONE              */
         B     @RC00836                                            0939
@RF00836 DS    0H                                                  0940
*/********************************************************************/
*/*                                                                  */
*/*      THIS CODE IS FOR GETTING AND FORMATTING A TLB TO HANDLE     */
*/*      MULTIPLE REQUESTS . THIS IS NECESSARY FOR CLEAR/UNBIND      */
*/*      AND CLEAR/UNBIND/NOTIFY. THE TLB IS OBTAINED AND THE        */
*/*      LCCWS ARE BUILT BY PUTTING IN A CLEAR LCCW AND COPYING      */
*/*      THE LCCWS POINTED TO BY LCPNXLCW IN THE LCPB INTO THE TLB.  */
*/*                                                                  */
*/********************************************************************/
*                                                                  0940
*           IF LCCWOP=LCLRNFY THEN                                 0940
         L     @14,LCCWPTR(,ZCRRPTR)                               0940
         CLI   LCCWOP(@14),X'F8'                                   0940
         BE    @RT00940                                            0940
*             ;                     /* IF CLEAR/NOTIFY               */
*           ELSE                                                   0942
*             DO;                   /* NOT CLEAR/NOTIFY              */
*               RFY                                                0943
*                 COUNT RSTD;       /* WORK REGISTER         @XM08890*/
*               COUNT=1;            /* INITIALIZE COUNT              */
         LA    COUNT,1                                             0944
*ZCRL01:                                                           0945
*               DO WHILE LCCWOP=LTIC;/* IGNORE TICS          @XM08890*/
ZCRL01   B     @DE00945                                            0945
@DL00945 DS    0H                                                  0946
*                 LCCWPTR=LCCWDATA; /* BYPASS TIC            @XM08890*/
         L     @14,LCCWPTR(,ZCRRPTR)                               0946
         L     @14,LCCWDATA(,@14)                                  0946
         ST    @14,LCCWPTR(,ZCRRPTR)                               0946
*               END;                /* END TIC SLUFF         @XM08890*/
@DE00945 L     @14,LCCWPTR(,ZCRRPTR)                               0947
         CLI   LCCWOP(@14),X'08'                                   0947
         BE    @DL00945                                            0947
*               COUNT=COUNT+1;      /* BUMP LCCW COUNT       @XM08890*/
         AL    COUNT,@CF00060                                      0948
*               IF LCCWCD=ON        /* IF DATA CHAINED       @XM08890*/
*                   |LCCWCC=ON THEN                                0949
         TM    LCCWCD(@14),B'11000000'                             0949
         BZ    @RF00949                                            0949
*                 DO;               /* | COMMAND CHAINED     @XM08890*/
*                   LCCWPTR=LCCWPTR+LENGTH(ISTLCCW);/* ADDRESS NEXT
*                                      LCCW                  @XM08890*/
         AL    @14,@CF00058                                        0951
         ST    @14,LCCWPTR(,ZCRRPTR)                               0951
*                   GO TO ZCRL01;   /* CONTINUE TIC SCAN     @XM08890*/
         B     ZCRL01                                              0952
*                 END;              /* END CHAINING          @XM08890*/
*               ELSE                                               0954
*                 ;                 /* IF NOT CHAINED        @XM08890*/
@RF00949 DS    0H                                                  0955
*               LENTLB=LENGTH(ISTTLB)+(COUNT*8);/* TLB REQSTORE LNGTH
*                                                            @XM08890*/
         LR    @14,COUNT                                           0955
         SLA   @14,3                                               0955
         AL    @14,@CF00058                                        0955
         ST    @14,LENTLB(,ZCRRPTR)                                0955
*               RFY                                                0956
*                 COUNT UNRSTD;     /* END USAGE             @XM08890*/
*               LCCWPTR=LCPNXLCW;   /* RESTORE LCCW POINTER          */
*                                                                  0957
         L     @14,LCPBPTR(,ZCRRPTR)                               0957
         L     @14,LCPNXLCW(,@14)                                  0957
         ST    @14,LCCWPTR(,ZCRRPTR)                               0957
*               /*****************************************************/
*               /*                                                   */
*               /* REQSTORE PGBUF(LENTLB)CLEAR(YES)RPH(RPHPTR)       */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0958
*               DO;                                                0958
*                                                                  0958
*/* ATBUILD (ISTDYPAB,ISTATCVT,ISTRPH)                               */
*/* END OF ATBUILD                                                   */
*                                                                  0959
*                 RFY                                              0959
*                  (GPR02P,                                        0959
*                   GPR03P,                                        0959
*                   GPR04P,                                        0959
*                   GPR15P) RSTD;                                  0959
*                 RFY                                              0960
*                  (GPR01P) RSTD;                                  0960
*                 GENERATE REFS(GPR01P,GPR02P,GPR13P) SETS(RPHWORK);
           STM GPR02P,GPR13P,RPHWORK(GPR01P)
*                 RFY                                              0962
*                  (GPR01P) UNRSTD;                                0962
*                 DO;               /* LISATCVT                    0963
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*                   GPR15P=ATCLCPTR;/* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     0964
*                 END;              /* LISATCVT                      */
*                 RFY                                              0966
*                   ISTBPENT;                                      0966
*                 RFY                                              0967
*                   ISTBPDTY;                                      0967
*                 GPR02P=GPR15P->ATCBPDA->BPDPGPCB;                0968
         L     @14,ATCBPDA(,GPR15P)                                0968
         L     GPR02P,BPDPGPCB(,@14)                               0968
*                 DCL                                              0969
*                   1 FMZA0054 FIXED(31) STATIC LOCAL,             0969
*                    2 * FIXED(8) INIT(168),                       0969
*                    2 * PTR(24) INIT(0);                          0969
*                 GPR03F=FMZA0054;                                 0970
         L     GPR03F,FMZA0054                                     0970
*                 GPR04F=LENTLB;                                   0971
         L     GPR04F,LENTLB(,ZCRRPTR)                             0971
*                 GPR15P=GPR15P->ATCSMRQ;                          0972
         L     GPR15P,ATCSMRQ(,GPR15P)                             0972
*                 DCL                                              0973
*                   FMZL0054 BASED(GPR15P) LABEL VALUERANGE(*);    0973
*                 CALL FMZL0054;                                   0974
         BALR  @14,@15                                             0974
*                 GENERATE REFS(GPR01P,RPHWORK) SETS(GPR02P,GPR13P);
           LM GPR02P,GPR13P,RPHWORK(GPR01P)
*                 RFY                                              0976
*                  (GPR02P,                                        0976
*                   GPR03P,                                        0976
*                   GPR04P,                                        0976
*                   GPR15P) UNRSTD;                                0976
*               END;                                               0977
*                                                                  0977
*               /*****************************************************/
*               /*                                                   */
*               /* ******** END OF REQSTORE EXPANSION                */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0978
*                                   /* ALLOCATE TLB BUFFER           */
*               RFY                                                0978
*                (R15) RSTD;        /* RETURN CODE REGISTER          */
*               IF R15=8 THEN                                      0979
         C     R15,@CF00058                                        0979
         BNE   @RF00979                                            0979
*                 DO;               /* IF TPWAIT REQUIRED            */
*                   RFY                                            0981
*                    (R15) UNRSTD;  /* NO LONGER REQUIRED            */
*/*  TPWAIT                                                          */
*                                                                  0982
*                   DO;             /* BEGIN TPWAIT GENERATION       */
*                     RFY                                          0983
*                      (GPR01P,                                    0983
*                       GPR14P,                                    0983
*                       GPR15P) RSTD;                              0983
*                     RFY                                          0984
*                      (GPR00P) RSTD;                              0984
*                     GEN(STM   GPR00P,GPR15P,RPHWORK(GPR01P))     0985
*                     REFS(GPR00P,GPR01P,GPR15P) SETS(RPHWORK);    0985
         STM   GPR00P,GPR15P,RPHWORK(GPR01P)
*                     RFY                                          0986
*                      (GPR00P) UNRSTD;                            0986
*                     GPR15P=ADDR(LHAA0074);                       0987
         LA    GPR15P,LHAA0074                                     0987
*                     GPR14P=0;                                    0988
         SLR   GPR14P,GPR14P                                       0988
*                     GPR15P=GPR15P&'00FFFFFF'X;                   0989
         N     GPR15P,@CF04147                                     0989
*                     GPR15P=GPR15P|RPHWT1;                        0990
         O     GPR15P,@CF00768                                     0990
*                     CS(GPR14P,GPR15P,GPR01P->RPHRESMA);          0991
         CS    GPR14P,@15,RPHRESMA(GPR01P)                         0991
*                     BC(7,LHAB0074);                              0992
*                                                                  0992
         BC    7,LHAB0074                                          0992
*/* TPEXIT  NONE                                                     */
*                                                                  0993
*                     DO;                                          0993
*                       RESPECIFY                                  0994
*                         GPR15P RSTD;                             0994
*                                                                  0994
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTATCVT)                               */
*/* END OF ATBUILD                                                   */
*                                                                  0995
*                       DO;         /* LISATCVT                    0995
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*                         GPR15P=ATCLCPTR;/* SET UP ATCVT POINTER    */
         L     GPR15P,ATCLCPTR                                     0996
*                       END;        /* LISATCVT                      */
*                       RESPECIFY                                  0998
*                         GPR00F RSTD;                             0998
*                       GPR00F=0;   /* SET PARAMETER REGISTER TO 0   */
         SLR   GPR00F,GPR00F                                       0999
*                       GPR15P=GPR15P->ATCAP31;                    1000
         L     GPR15P,ATCAP31(,GPR15P)                             1000
*                       DCL                                        1001
*                         FMZL0079 BASED(GPR15P) LABEL VALUERANGE(*);
*                       CALL FMZL0079;                             1002
         BALR  @14,@15                                             1002
*                       RESPECIFY                                  1003
*                        (GPR00F,                                  1003
*                         GPR15P) UNRSTD;                          1003
*                     END;          /* **** END OF TPEXIT            */
*LHAB0074:                                                         1005
*                     ;                                            1005
LHAB0074 DS    0H                                                  1006
*                     GPR01P->RPHRESMA=0;                          1006
         SLR   @15,@15                                             1006
         ST    @15,RPHRESMA(,GPR01P)                               1006
*                     RFY                                          1007
*                      (GPR00P) RSTD;                              1007
*LHAA0074:                                                         1008
*                     ;                                            1008
LHAA0074 DS    0H                                                  1009
*                     GEN(LM    GPR00P,GPR15P,RPHWORK(GPR01P))     1009
*                     REFS(RPHWORK,GPR01P) SETS(GPR00P,GPR15P);    1009
         LM    GPR00P,GPR15P,RPHWORK(GPR01P)
*                     RFY                                          1010
*                      (GPR00P,                                    1010
*                       GPR01P,                                    1010
*                       GPR14P,                                    1010
*                       GPR15P) UNRSTD;                            1010
*                   END;            /* ****END OF TPWAIT WAIT FOR  1011
*                                      STORAGE                       */
*                 END;              /* END STORAGE WAIT              */
*               ELSE                                               1013
*                 ;                 /* WAIT NOT REQUIRED             */
@RF00979 DS    0H                                                  1014
*               TLBPTR=RPHSRPRM+LENGTH(ISTBFHDR);/* ADDRESS TLB      */
         LA    @09,8                                               1014
         AL    @09,RPHSRPRM(,RPHPTR)                               1014
         ST    @09,TLBPTR(,ZCRRPTR)                                1014
*               TLBLCCWS(1:8)=TLCLRLCW;/* PUT CLEAR LCCW IN TLB      */
         MVC   TLBLCCWS(8,@09),@CB03023                            1015
*               IF LCCWOP=LCRUDNFY THEN/* IF CLEAR/UNBIND/NOTIFY   1016
*                                                            @XM19747*/
         L     @07,LCCWPTR(,ZCRRPTR)                               1016
         CLI   LCCWOP(@07),X'F4'                                   1016
         BNE   @RF01016                                            1016
*                 TLBLCCWS(1)=LCLRNFY;/* MAKE LCCW=CLEAR/NOTIFY    1017
*                                                            @XM19747*/
         MVI   TLBLCCWS(@09),X'F8'                                 1017
*               ELSE                                               1018
*                 ;                 /* NOT CLEAR/UNBIND/NOTIFY     1018
*                                                            @XM19747*/
@RF01016 DS    0H                                                  1019
*               TLBLCPA=LCPNXLCW;   /* SAVE LCCW PTR FROM LCPB       */
         L     @09,TLBPTR(,ZCRRPTR)                                1019
         L     @07,LCPBPTR(,ZCRRPTR)                               1019
         L     @07,LCPNXLCW(,@07)                                  1019
         ST    @07,TLBLCPA(,@09)                                   1019
*ZCRL00:                                                           1020
*               ;                   /* LOOP UNTIL ALL LCCWS COPIED   */
ZCRL00   DS    0H                                                  1021
*               TLBPTR=TLBPTR+8;    /* UPDATE TLBLCCW POINTER        */
         LA    @09,8                                               1021
         AL    @09,TLBPTR(,ZCRRPTR)                                1021
         ST    @09,TLBPTR(,ZCRRPTR)                                1021
*               DO WHILE LCCWOP=LTIC;/* IGNORE TICS                  */
         B     @DE01022                                            1022
@DL01022 DS    0H                                                  1023
*                 LCCWPTR=LCCWDATA; /* ADDRESS NEXT LCCW FROM TIC    */
         L     @09,LCCWPTR(,ZCRRPTR)                               1023
         L     @09,LCCWDATA(,@09)                                  1023
         ST    @09,LCCWPTR(,ZCRRPTR)                               1023
*               END;                /* TICS IGNORED                  */
@DE01022 L     @09,LCCWPTR(,ZCRRPTR)                               1024
         CLI   LCCWOP(@09),X'08'                                   1024
         BE    @DL01022                                            1024
*               TLBLCCWS(1:8)=ISTLCCW;/* COPY THE LCCW               */
         L     @07,TLBPTR(,ZCRRPTR)                                1025
         MVC   TLBLCCWS(8,@07),ISTLCCW(@09)                        1025
*               IF LCCWCD=ON        /* IF DATA CHAINED               */
*                   |LCCWCC=ON THEN                                1026
         TM    LCCWCD(@09),B'11000000'                             1026
         BZ    @RF01026                                            1026
*                 DO;               /* | COMMAND CHAINED             */
*                   LCCWPTR=LCCWPTR+LENGTH(ISTLCCW);               1028
         AL    @09,@CF00058                                        1028
         ST    @09,LCCWPTR(,ZCRRPTR)                               1028
*                   GO TO ZCRL00;   /* PROCESS NEXT LCCW             */
         B     ZCRL00                                              1029
*                 END;              /* END LCCW LOOP                 */
*               ELSE                                               1031
*                 DO;               /* NOT CHAINED LCCW              */
@RF01026 DS    0H                                                  1032
*                   TLBPTR=RPHSRPRM+LENGTH(ISTBFHDR);/* RE-ADDRESS 1032
*                                      TLB BUFFER                    */
         LA    @09,8                                               1032
         AL    @09,RPHSRPRM(,RPHPTR)                               1032
         ST    @09,TLBPTR(,ZCRRPTR)                                1032
*                   LCPNXLCW=ADDR(TLBLCCWS);/* ADDRESS LCCW FROM TLB */
         L     @07,LCPBPTR(,ZCRRPTR)                               1033
         LA    @00,TLBLCCWS(,@09)                                  1033
         ST    @00,LCPNXLCW(,@07)                                  1033
*                   LCPTLBAD=TLBPTR;/* SAVE TLB POINTER              */
         ST    @09,LCPTLBAD(,@07)                                  1034
*                   LCPTLBPI=ON;    /* FLAG TLB PRESENT              */
         OI    LCPTLBPI(@07),B'00010000'                           1035
*                   LCCWPTR=LCPNXLCW;/* ADDRESS FIRST LCCW IN TLB  1036
*                                                            @XM08990*/
         ST    @00,LCCWPTR(,ZCRRPTR)                               1036
*                 END;              /* END UNCHAINED LCCW            */
*             END;                  /* END NOT CLEAR/NOTIFY          */
*           ZCRTPINV=ON;            /* SET EXIT FLAG FOR RETURN CODE
*                                      ZERO                          */
@RT00940 OI    ZCRTPINV(ZCRRPTR),B'01000000'                       1039
*           CALL ISTZPBST;          /* PROHIBIT DATA TRAFFIC         */
         BAL   @14,ISTZPBST                                        1040
*         END;                      /* NOT NOTIFY ALONE              */
*     END;                          /* NOT CLEAR ALONE               */
@RC00836 DS    0H                                                  1043
*   RFY                                                            1043
*     R14 RSTD;                     /* TO RESTORE RETURN ADDRESS     */
@RC00830 DS    0H                                                  1044
*   R14=R14SAVE;                    /* RESTORE RETURN ADDRESS        */
         L     R14,R14SAVE(,ZCRRPTR)                               1044
*   RFY                                                            1045
*     R14 UNRSTD;                   /* RESTORED                      */
*   END ISTZCLR;                    /* END OF SUBROUTINE             */
@EL00002 DS    0H                                                  1046
@EF00002 DS    0H                                                  1046
@ER00002 BR    @14                                                 1046
*/********************************************************************/
*/*      ISTZCLR SUBROUTINE END                                      */
*/********************************************************************/
*                                                                  1047
         EJECT
*                                                                  1047
*/***********************************************************@XM19747*/
*/*                                                          @XM19747*/
*/* SUBROUTINE-                                              @XM19747*/
*/*      NOTIFY                                              @XM19747*/
*/*                                                          @XM19747*/
*/* FUNCTION-                                                @XM19747*/
*/*      PROCESS NOTIFY FUNCTION OF LCCW.                    @XM19747*/
*/*                                                          @XM19747*/
*/***********************************************************@XM19747*/
*                                                                  1047
*   RFY                                                            1047
*     R14 RSTD;                     /* TO SAVE RETURN REG    @XM19747*/
*NOTIFY:                                                           1048
*   PROCEDURE OPTIONS(NOSAVE,NOSAVEAREA);/* NOTIFY: SUBROUTINE     1048
*                                                            @XM19747*/
NOTIFY   DS    0H                                                  1049
*   NFYSAVE=R14;                    /* SAVE RETURN REG       @XM19747*/
         ST    R14,NFYSAVE(,ZCRRPTR)                               1049
*   RFY                                                            1050
*     R14 UNRSTD;                   /* SAVED                 @XM19747*/
*   ZCRPCOD1=0;                     /* ZDFA0 PARAMETER       @XM19747*/
         MVI   ZCRPCOD1(ZCRRPTR),X'00'                             1051
*   ZCRPFSB=ON;                     /* ZDFA0 PARAMETER       @XM19747*/
         OI    ZCRPFSB(ZCRRPTR),B'00100000'                        1052
*   CALL ISTZDFA0;                  /* BUFFER ALLOCATION UTILITY   1053
*                                                            @XM19747*/
         L     @09,ATCZPSVT(,ATCVTPTR)                             1053
         L     @15,ZPSZDFA0(,@09)                                  1053
         BALR  @14,@15                                             1053
*   RPHSRPRM->FSBSAF=FMCSAF;        /* SET SOURCE ADDRESS IN FSB   1054
*                                                            @XM19747*/
         L     @09,RPHSRPRM(,RPHPTR)                               1054
         MVC   FSBSAF(2,@09),FMCSAF(FMCBPTR)                       1054
*   RPHSRPRM->FSBDAF=ADDR(FMCDNCBA->LUNCB)->NCBDAF;/* SET DESCINATION
*                                      ADDR IN FSB           @XM19747*/
         L     @07,FMCDNCBA(,FMCBPTR)                              1055
         MVC   FSBDAF(2,@09),NCBDAF(@07)                           1055
*   RPHSRPRM->FSBMJRCD=FRNOTIFY;    /* MAJOR=NOTIFY          @XM19747*/
         MVI   FSBMJRCD(@09),X'30'                                 1056
*   RPHSRPRM->FSBMNRCD=LCPRUCNT;    /* MINOR=LCPB CODE       @XM19747*/
         L     @07,LCPBPTR(,ZCRRPTR)                               1057
         MVC   FSBMNRCD(1,@09),LCPRUCNT(@07)                       1057
*/*  TPQUE (RPHSRPRM,FMCSIPA->PABWEQA) NORM                          */
*                                                                  1058
*   DO;                                                            1058
*     RFY                                                          1059
*      (GPR00P,                                                    1059
*       GPR01P,                                                    1059
*       GPR04P,                                                    1059
*       GPR05P,                                                    1059
*       GPR15P) RSTD;                                              1059
*     GEN REFS(GPR01P) SETS(RPHWORK)(STM GPR02P,GPR08P,RPHWORK(GPR01P))
*         ;                                                        1060
         STM GPR02P,GPR08P,RPHWORK(GPR01P)
*     GPR00P=0;                                                    1061
         SLR   GPR00P,GPR00P                                       1061
*     GPR15P=ADDR(FMCSIPA->PABWEQA);/* HOLD PAB PTR                  */
         L     GPR15P,FMCSIPA(,FMCBPTR)                            1062
*     GPR04P=RPHSRPRM;              /* WORK ELE PTR                  */
         L     GPR04P,RPHSRPRM(,RPHPTR)                            1063
*     GPR05P=GPR15P;                /* PASS PAB PTR                  */
         LR    GPR05P,GPR15P                                       1064
*     CALL ATCLCPTR->ATCAP37->ISTAPC37;                            1065
         L     @09,ATCLCPTR                                        1065
         L     @15,ATCAP37(,@09)                                   1065
         BALR  @14,@15                                             1065
*     GEN(NOPR  0)                                                 1066
*     NOSETS NOREFS;                                               1066
         NOPR  0
*     RFY                                                          1067
*      (GPR00P,                                                    1067
*       GPR01P,                                                    1067
*       GPR04P,                                                    1067
*       GPR05P,                                                    1067
*       GPR15P) UNRSTD;                                            1067
*   END;                            /* *** END OF TPQUE GENERATION 1068
*                                      QUEUE FSB TO SSCP PAB @XM19747*/
*   RFY                                                            1069
*     R14 RSTD;                     /* TO RESTORE RETURN REG @XM19747*/
*   R14=NFYSAVE;                    /* RESTORE RETURN REG    @XM19747*/
         L     R14,NFYSAVE(,ZCRRPTR)                               1070
*   RFY                                                            1071
*     R14 UNRSTD;                   /* RESTORED              @XM19747*/
*   END NOTIFY;                     /* END NOTIFY            @XM19747*/
@EL00003 DS    0H                                                  1072
@EF00003 DS    0H                                                  1072
@ER00003 BR    @14                                                 1072
*/***********************************************************@XM19747*/
*/*      NOTIFY SUBROUTINE END                               @XM19747*/
*/***********************************************************@XM19747*/
*                                                                  1073
         EJECT
*                                                                  1073
*/********************************************************************/
*/*                                                                  */
*/* SUBROUTINE-                                                      */
*/*      ISTFDB                                                      */
*/*                                                                  */
*/* FUNCTION-                                                        */
*/*      RETURN STATUS TO REQUESTOR.                                 */
*/*                                                                  */
*/********************************************************************/
*                                                                  1073
*   RFY                                                            1073
*    (R14) RSTD;                    /* TO SAVE RETURN REGISTER       */
*ISTZFDB:                                                          1074
*   PROCEDURE OPTIONS(NOSAVE,NOSAVEAREA);/* ISTZFDB: SUBROUTINE      */
ISTZFDB  DS    0H                                                  1075
*   R14SAVE=R14;                    /* SAVE RETURN ADDRESS           */
         ST    R14,R14SAVE(,ZCRRPTR)                               1075
*   IF ZCRFSBWE=OFF THEN            /* IF INPUT WAS AN LCPB  @ZA09592*/
         TM    ZCRFSBWE(ZCRRPTR),B'00000100'                       1076
         BNZ   @RF01076                                            1076
*     IF ZCRRJLCP=ON THEN           /* IF INPUT HAS BEEN REJECTED  1077
*                                                            @ZA09592*/
         TM    ZCRRJLCP(ZCRRPTR),B'00100000'                       1077
         BNO   @RF01077                                            1077
*/* TPDEQ (LCPBPTR,FMCPAB5) RESET(RECON)                             */
*                                                                  1078
*       DO;                         /* BEGIN TPDEQ CODE GENERATION   */
*         RFY                                                      1079
*          (GPR00P,                                                1079
*           GPR01P,                                                1079
*           GPR14P,                                                1079
*           GPR15P) RSTD;                                          1079
*         GPR15P=ADDR(FMCPAB5);     /* ADDRESS QUEUE POINTER         */
         LA    GPR15P,FMCPAB5(,FMCBPTR)                            1080
*         RFY                                                      1081
*          (GPR02P,                                                1081
*           GPR03P) RSTD;                                          1081
*         STM(GPR02P,GPR03P,GPR01P->RPHWORK(5:12));                1082
         STM   GPR02P,GPR03P,RPHWORK+4(GPR01P)                     1082
*         GPR03P=LCPBPTR|FMZCA035;                                 1083
         L     @09,@CF00744                                        1083
         L     GPR03P,LCPBPTR(,ZCRRPTR)                            1083
         OR    GPR03P,@09                                          1083
*         GPR14P=FMZCA035;                                         1084
         LR    GPR14P,@09                                          1084
*         GPR15P=ADDR(GPR15P->PABWEQA);                            1085
*FMZL1095:                                                         1086
*         ;                                                        1086
FMZL1095 DS    0H                                                  1087
*         GPR02P=GPR15P->PABWEQA|FMZCA035;                         1087
         L     GPR02P,PABWEQA(,GPR15P)                             1087
         O     GPR02P,@CF00744                                     1087
*         DO WHILE(GPR02P^=GPR14P);                                1088
         B     @DE01088                                            1088
@DL01088 DS    0H                                                  1089
*           DO WHILE((GPR02P->WKECHAIN)^=GPR14P);                  1089
         B     @DE01089                                            1089
@DL01089 DS    0H                                                  1090
*             GPR15P=ADDR(GPR02P->WKECHAIN);                       1090
         LA    GPR15P,WKECHAIN(,GPR02P)                            1090
*             GPR02P=GPR02P->WKECHAIN;                             1091
         L     GPR02P,WKECHAIN(,GPR02P)                            1091
*           END;                                                   1092
@DE01089 C     GPR14P,WKECHAIN(,GPR02P)                            1092
         BNE   @DL01089                                            1092
*           IF GPR02P=GPR03P THEN                                  1093
         CR    GPR02P,GPR03P                                       1093
         BNE   @RF01093                                            1093
*             DO;                                                  1094
*               GPR00P=GPR02P->LCPRSTQH;                           1095
         L     GPR00P,LCPRSTQH(,GPR02P)                            1095
*               CS(GPR02P,GPR00P,GPR15P->PABWEQA);                 1096
         CS    GPR02P,@00,PABWEQA(GPR15P)                          1096
*               BC(7,FMZL3095);                                    1097
         BC    7,FMZL3095                                          1097
*               GPR02P->LCPRSTQH='80000000'X;                      1098
         MVC   LCPRSTQH(4,GPR02P),@CF00744                         1098
*               GPR14P=GPR02P;                                     1099
         LR    GPR14P,GPR02P                                       1099
*               GPR14P->WKECHAIN=0;                                1100
         SLR   @09,@09                                             1100
         ST    @09,WKECHAIN(,GPR14P)                               1100
*             END;                                                 1101
*           ELSE                                                   1102
*             DO;                                                  1102
         B     @RC01093                                            1102
@RF01093 DS    0H                                                  1103
*               IF GPR02P->FSBTYPE=FSTYPE THEN                     1103
         CLI   FSBTYPE(GPR02P),X'02'                               1103
         BNE   @RF01103                                            1103
*                 DO;                                              1104
*                   GPR02P=GPR14P;                                 1105
         LR    GPR02P,GPR14P                                       1105
*                   GOTO FMZL3095;                                 1106
         B     FMZL3095                                            1106
*                 END;                                             1107
*               GPR15P=ADDR(GPR02P->LCPRSTQH);                     1108
@RF01103 LA    GPR15P,LCPRSTQH(,GPR02P)                            1108
*               GOTO FMZL1095;                                     1109
         B     FMZL1095                                            1109
*             END;                                                 1110
*FMZL3095:                                                         1111
*           ;                                                      1111
@RC01093 DS    0H                                                  1111
FMZL3095 DS    0H                                                  1112
*         END;                                                     1112
@DE01088 CR    GPR02P,GPR14P                                       1112
         BNE   @DL01088                                            1112
*ISTA0095:                                                         1113
*         ;                                                        1113
ISTA0095 DS    0H                                                  1114
*         LM(GPR02P,GPR03P,GPR01P->RPHWORK(5:12));                 1114
         LM    GPR02P,GPR03P,RPHWORK+4(GPR01P)                     1114
*         RFY                                                      1115
*          (GPR02P,                                                1115
*           GPR03P) UNRSTD;                                        1115
*         GPR14P=GPR14P&FMZCB035;                                  1116
         N     GPR14P,@CF00742                                     1116
*         GPR01P->RPHWEA=GPR14P;                                   1117
         ST    GPR14P,RPHWEA(,GPR01P)                              1117
*         RFY                                                      1118
*          (GPR00P,                                                1118
*           GPR01P,                                                1118
*           GPR14P,                                                1118
*           GPR15P) UNRSTD;                                        1118
*       END;                        /* END TPDEQ GENERATION        1119
*                                      RECONSTRUCT THE PAB   @ZA09592*/
*     ELSE                          /* INPUT HAS NOT BEEN REJECTED 1120
*                                                            @ZA09592*/
*/* TPDEQ (LCPBPTR,FMCPAB5)                                          */
*                                                                  1120
*       DO;                         /* BEGIN TPDEQ CODE GENERATION   */
         B     @RC01077                                            1120
@RF01077 DS    0H                                                  1121
*         RFY                                                      1121
*          (GPR00P,                                                1121
*           GPR01P,                                                1121
*           GPR14P,                                                1121
*           GPR15P) RSTD;                                          1121
*         GPR15P=ADDR(FMCPAB5);     /* ADDRESS QUEUE POINTER         */
         LA    GPR15P,FMCPAB5(,FMCBPTR)                            1122
*         RFY                                                      1123
*          (GPR02P,                                                1123
*           GPR03P) RSTD;                                          1123
*         STM(GPR02P,GPR03P,GPR01P->RPHWORK(5:12));                1124
         STM   GPR02P,GPR03P,RPHWORK+4(GPR01P)                     1124
*         GPR03P=LCPBPTR|FMZCA035;                                 1125
         L     @09,@CF00744                                        1125
         L     GPR03P,LCPBPTR(,ZCRRPTR)                            1125
         OR    GPR03P,@09                                          1125
*         GPR14P=FMZCA035;                                         1126
         LR    GPR14P,@09                                          1126
*         GPR15P=ADDR(GPR15P->PABWEQA);                            1127
*         GPR02P=GPR15P->PABWEQA|FMZCA035;                         1128
         O     @09,PABWEQA(,GPR15P)                                1128
         LR    GPR02P,@09                                          1128
*         DO WHILE(GPR02P^=GPR14P);                                1129
         B     @DE01129                                            1129
@DL01129 DS    0H                                                  1130
*FMZL2102:                                                         1130
*           ;                                                      1130
FMZL2102 DS    0H                                                  1131
*           IF GPR02P=GPR03P THEN                                  1131
         CR    GPR02P,GPR03P                                       1131
         BNE   @RF01131                                            1131
*             DO;                                                  1132
*               GPR00P=GPR02P->WKECHAIN;                           1133
         L     GPR00P,WKECHAIN(,GPR02P)                            1133
*               CS(GPR02P,GPR00P,GPR15P->PABWEQA);                 1134
         CS    GPR02P,@00,PABWEQA(GPR15P)                          1134
*               BC(7,FMZL3102);                                    1135
         BC    7,FMZL3102                                          1135
*               GPR14P=GPR02P;                                     1136
         LR    GPR14P,GPR02P                                       1136
*               GPR14P->WKECHAIN=0;                                1137
         SLR   @09,@09                                             1137
         ST    @09,WKECHAIN(,GPR14P)                               1137
*             END;                                                 1138
*           ELSE                                                   1139
*             DO;                                                  1139
         B     @RC01131                                            1139
@RF01131 DS    0H                                                  1140
*               IF(GPR02P->WKECHAIN)=GPR14P THEN                   1140
         L     @09,WKECHAIN(,GPR02P)                               1140
         CR    @09,GPR14P                                          1140
         BE    @RT01140                                            1140
*                 GOTO ISTA0102;                                   1141
*               ELSE                                               1142
*                 DO;                                              1142
*                   GPR15P=ADDR(GPR02P->WKECHAIN);                 1143
         LA    GPR15P,WKECHAIN(,GPR02P)                            1143
*                   GPR02P=GPR02P->WKECHAIN;                       1144
         LR    GPR02P,@09                                          1144
*                   GOTO FMZL2102;                                 1145
         B     FMZL2102                                            1145
*                 END;                                             1146
*             END;                                                 1147
*FMZL3102:                                                         1148
*           ;                                                      1148
@RC01131 DS    0H                                                  1148
FMZL3102 DS    0H                                                  1149
*         END;                                                     1149
@DE01129 CR    GPR02P,GPR14P                                       1149
         BNE   @DL01129                                            1149
*ISTA0102:                                                         1150
*         ;                                                        1150
ISTA0102 DS    0H                                                  1151
*         LM(GPR02P,GPR03P,GPR01P->RPHWORK(5:12));                 1151
         LM    GPR02P,GPR03P,RPHWORK+4(GPR01P)                     1151
*         RFY                                                      1152
*          (GPR02P,                                                1152
*           GPR03P) UNRSTD;                                        1152
*         GPR14P=GPR14P&FMZCB035;                                  1153
         N     GPR14P,@CF00742                                     1153
*         GPR01P->RPHWEA=GPR14P;                                   1154
         ST    GPR14P,RPHWEA(,GPR01P)                              1154
*         RFY                                                      1155
*          (GPR00P,                                                1155
*           GPR01P,                                                1155
*           GPR14P,                                                1155
*           GPR15P) UNRSTD;                                        1155
*       END;                        /* END TPDEQ GENERATION DEQUEUE
*                                      WORK ELEMENT          @ZA09592*/
*   ELSE                                                           1157
*     ;                             /* INPUT NOT AN LCPB     @ZA09592*/
@RF01076 DS    0H                                                  1158
*   IF FSBMJRCD=FRCLRRSP THEN                                      1158
@RC01076 L     @15,FSBPTR(,ZCRRPTR)                                1158
         CLI   FSBMJRCD(@15),X'31'                                 1158
         BNE   @RF01158                                            1158
*     DO;                           /* IF CLEAR RESPONSE FSB @XM17957*/
*       FSBMJRCD=FRNORM;            /* MAJOR=NORMAL                  */
         MVI   FSBMJRCD(@15),X'00'                                 1160
*       FSBMNRCD=FRMOK;             /* MINOR=NORMAL          @XM17957*/
         MVI   FSBMNRCD(@15),X'00'                                 1161
*     END;                          /* END CLEAR RESPONSE    @XM17957*/
*   ELSE                                                           1163
*     ;                             /* IF NOT CLEAR RESPONSE FSB     */
@RF01158 DS    0H                                                  1164
*   IF LCPFTYPE=LCRPHFT THEN                                       1164
         L     @15,LCPBPTR(,ZCRRPTR)                               1164
         TM    LCPFTYPE(@15),B'10000000'                           1164
         BNO   @RF01164                                            1164
*     DO;                           /* IF TPPOST REQUIRED            */
*       LCPRPHA->RPHWEA=FSBPTR;     /* PUT FSB ADDR IN RPH           */
         L     @15,LCPRPHA(,@15)                                   1166
         L     @09,FSBPTR(,ZCRRPTR)                                1166
         ST    @09,RPHWEA(,@15)                                    1166
*/*TPPOST  (LCPRPHA)                                                 */
*                                                                  1167
*       DO;                         /* DECLARE AND RESTRICT REGS     */
*         RESPECIFY                                                1168
*          (GPR00F,                                                1168
*           GPR01F,                                                1168
*           GPR04F,                                                1168
*           GPR05F,                                                1168
*           GPR06F,                                                1168
*           GPR14F,                                                1168
*           GPR15F) RSTD;           /* 0,1,4,5,6,14, AND 15          */
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTRPH)                                 */
*/* END OF ATBUILD                                                   */
*                                                                  1169
*         GEN REFS(GPR01P,GPR02F,GPR06F) SETS(RPHWORK);            1169
        STM GPR02F,GPR06F,RPHWORK(GPR01P)
*         GPR04F=LCPRPHA;           /* LOAD RPH PNTR INTO REG 4      */
         L     @09,LCPBPTR(,ZCRRPTR)                               1170
         L     GPR04F,LCPRPHA(,@09)                                1170
*         RFY                                                      1171
*           GPR03F RSTD;                                           1171
*         GPR03F=0;                                                1172
         SLR   @09,@09                                             1172
         LR    GPR03F,@09                                          1172
*         DO;                       /* MODESET SAVEKEY(GPR06F)     1173
*                                      KEYADDR(GPR03F)             1173
*                                      WORKREG(GPR05F)               */
*           RESPECIFY                                              1174
*            (GPR02F) RESTRICTED;                                  1174
*           GPR05F=GPR02F;          /* SAVE REGISTER 2               */
         LR    GPR05F,GPR02F                                       1175
*           IPK;                    /* SAVE CURRENT PSW KEY          */
         IPK                                                       1176
*           GPR06F=GPR02F;                                         1177
         LR    GPR06F,GPR02F                                       1177
*           GPR02F=GPR05F;          /* RESTORE REGISTER 2            */
         LR    GPR02F,GPR05F                                       1178
*           SPKA(GPR03F);           /* SET PSW KEY                   */
         SPKA  0(GPR03F)                                           1179
*           RESPECIFY                                              1180
*            (GPR02F) UNRESTRICTED;                                1180
*         END;                      /* MODESET SAVEKEY(GPR06F)     1181
*                                      KEYADDR(GPR03F)             1181
*                                      WORKREG(GPR05F)               */
*         RFY                                                      1182
*           GPR03F UNRSTD;                                         1182
*         GPR05P=GPR04P->RPHMAJCB+GPR04P->RPHPABOF;/* LOAD REG 5 WITH
*                                      ADDR OF MAJOR CONTROL BLOCK 1183
*                                      PLUS OFFSET OF PAB IN BLOCK   */
         L     GPR05P,RPHMAJCB-1(,GPR04P)                          1183
         LA    GPR05P,0(,GPR05P)                                   1183
         SLR   @07,@07                                             1183
         IC    @07,RPHPABOF(,GPR04P)                               1183
         ALR   GPR05P,@07                                          1183
*         GPR14P=0;                 /* LOAD 0 INTO REG 14            */
         LR    GPR14P,@09                                          1184
*         GPR15P='FFFFFFFF'X;       /* LOAD REG 15 WITH DUMMY ADDRESS*/
         SLR   GPR15P,GPR15P                                       1185
         BCTR  GPR15P,0                                            1185
*         CS(GPR14P,GPR15P,GPR04P->RPHRESMA);/* COMPARE RESUME     1186
*                                      ADDRESS WITH 0 AND,IF EQUAL,
*                                      PUT DUMMY ADDRESS IN CONTROL
*                                      BLOCK RESUME ADDRESS          */
         CS    GPR14P,@15,RPHRESMA(GPR04P)                         1186
*         BC(8,FMZT0108);           /* IF EQUAL, BYPASS REMAINDER OF
*                                      EXPANSION                     */
         BC    8,FMZT0108                                          1187
*FMZL0108:                                                         1188
*         IF GPR04P->RPHWT='1'B THEN/* WT/EXT CONTENTION FLAG ON     */
FMZL0108 TM    RPHWT(GPR04P),B'00001000'                           1188
         BNO   @RF01188                                            1188
*           DO;                     /* IN RPH                        */
*             GPR14P=GPR04P->RPHRESMA|RPHWT1;/* LOAD REG 14 WITH FLAG
*                                      FIELD AND MAKE CERTAIN WT/EXT
*                                      CONTENTION FLAG STILL ON      */
         L     GPR14P,RPHRESMA(,GPR04P)                            1190
         O     GPR14P,@CF00768                                     1190
*             GPR15P=GPR14P|RPHPT1; /* LOAD REG 15 WITH FLAG FIELD 1191
*                                      AND TURN POST FLAG ON         */
         LR    GPR15P,GPR14P                                       1191
         O     GPR15P,@CF00758                                     1191
*             CS(GPR14P,GPR15P,GPR04P->RPHRESMA);/* COMPARE REG 14 1192
*                                      WITH FLAG FIELD--IF WT/EXT BIT
*                                      ON, TURN ON POST FLAG         */
         CS    GPR14P,@15,RPHRESMA(GPR04P)                         1192
*             BC(4,FMZL0108);       /* IF WT/EXT BIT WAS OFF, LOOP TO
*                                      TEST CONTENTION FLAG          */
         BC    4,FMZL0108                                          1193
*             BC(8,FMZT0108);       /* IF WT/EXT BIT WAS OFF, BRANCH
*                                      TO BYPASS CODE GEN            */
         BC    8,FMZT0108                                          1194
*           END;                    /* IF POST FLAG IS ON, FALL THRU
*                                      BOTTOM OF LOOP                */
*         ELSE                                                     1196
*           ;                       /* WT/EXT CONTENTION FLAG OFF    */
@RF01188 DS    0H                                                  1197
*         IF GPR04P->RPHTSKID=GPR01P->RPHTSKID THEN                1197
         CLC   RPHTSKID(4,GPR04P),RPHTSKID(GPR01P)                 1197
         BNE   @RF01197                                            1197
*           DO;                                                    1198
*             GPR05P->PABCHNGP=GPR01P->RPHPABQP;/* PUT PAB QUEUE   1199
*                                      ADDRESS IN SECOND WORD OF PAB */
         MVC   PABCHNGP(3,GPR05P),RPHPABQP(GPR01P)                 1199
*             GPR01P->RPHPABQP=GPR05P;/* PUT PAB ADDRESS (IN MAJOR 1200
*                                      CONTROL BLOCK) IN PAB QUEUE 1200
*                                      ADRESS IN RPH                 */
         STCM  GPR05P,7,RPHPABQP(GPR01P)                           1200
*           END;                                                   1201
*         ELSE                                                     1202
*           DO;                                                    1202
         B     @RC01197                                            1202
@RF01197 DS    0H                                                  1203
*             GPR00F=0;             /* SET REG 0 TO INDICATE ENA     */
         SLR   GPR00F,GPR00F                                       1203
*             DO;                   /* LISATCVT                    1204
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*               GPR15P=ATCLCPTR;    /* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     1205
*             END;                  /* LISATCVT PUT POINTER TO ATCVT
*                                      IN IN REG 15                  */
*             CALL GPR15P->ATCAP32; /* CALL ISTAPC32: TPSCHED        */
         L     @09,ATCAP32(,GPR15P)                                1207
         LR    @15,@09                                             1207
         BALR  @14,@15                                             1207
*           END;                                                   1208
*FMZT0108:                                                         1209
*         DO;                       /* MODESET KEYADDR(GPR06F)     1209
*                                      WORKREG(GPR05F)               */
@RC01197 DS    0H                                                  1209
FMZT0108 DS    0H                                                  1210
*           GPR05F=GPR06F;          /* GET KEY FORM SAVE LOCATION    */
         LR    GPR05F,GPR06F                                       1210
*           SPKA(GPR05F);           /* SET PSW KEY                   */
         SPKA  0(GPR05F)                                           1211
*         END;                      /* MODESET KEYADDR(GPR06F)     1212
*                                      WORKREG(GPR05F)               */
*         GEN REFS(GPR04P,RPHWORK) SETS(GPR02F,GPR03F,GPR04F,GPR05F,
*             GPR06F);                                             1213
        LM GPR02F,GPR06F,RPHWORK(GPR01P)
*         RESPECIFY                                                1214
*          (GPR00F,                                                1214
*           GPR01F,                                                1214
*           GPR04F,                                                1214
*           GPR05F,                                                1214
*           GPR06F,                                                1214
*           GPR14F,                                                1214
*           GPR15F) UNRSTD;         /* UNRESTRICT REGS 0,1, 4,5,14,
*                                      AND 15                        */
*       END;                        /* ***END OF TPPOST GENERATION***
*                                      TPPOST THE RPH                */
*     END;                          /* END TPPOST REQUIRED           */
*   ELSE                                                           1217
*     DO;                           /* TPPOST NOT REQUIRED           */
         B     @RC01164                                            1217
@RF01164 DS    0H                                                  1218
*       RFY                                                        1218
*         R7 RSTD;                  /* TPQUE PARAMETER               */
*       R7=LCPPABA;                 /* ADDRESS PAB                   */
         L     @15,LCPBPTR(,ZCRRPTR)                               1219
         L     R7,LCPPABA(,@15)                                    1219
*/*  TPQUE (FSBPTR,R7->PABWEQA) NORM                                 */
*                                                                  1220
*       DO;                                                        1220
*         RFY                                                      1221
*          (GPR00P,                                                1221
*           GPR01P,                                                1221
*           GPR04P,                                                1221
*           GPR05P,                                                1221
*           GPR15P) RSTD;                                          1221
*         GEN REFS(GPR01P) SETS(RPHWORK)                           1222
*             (STM GPR02P,GPR08P,RPHWORK(GPR01P));                 1222
         STM GPR02P,GPR08P,RPHWORK(GPR01P)
*         GPR00P=0;                                                1223
         SLR   GPR00P,GPR00P                                       1223
*         GPR15P=ADDR(R7->PABWEQA); /* HOLD PAB PTR                  */
         LR    GPR15P,R7                                           1224
*         GPR04P=FSBPTR;            /* WORK ELE PTR                  */
         L     GPR04P,FSBPTR(,ZCRRPTR)                             1225
*         GPR05P=GPR15P;            /* PASS PAB PTR                  */
         LR    GPR05P,GPR15P                                       1226
*         CALL ATCLCPTR->ATCAP37->ISTAPC37;                        1227
         L     @09,ATCLCPTR                                        1227
         L     @15,ATCAP37(,@09)                                   1227
         BALR  @14,@15                                             1227
*         GEN(NOPR  0)                                             1228
*         NOSETS NOREFS;                                           1228
         NOPR  0
*         RFY                                                      1229
*          (GPR00P,                                                1229
*           GPR01P,                                                1229
*           GPR04P,                                                1229
*           GPR05P,                                                1229
*           GPR15P) UNRSTD;                                        1229
*       END;                        /* *** END OF TPQUE GENERATION 1230
*                                      QUEUE FSB TO REQUESTOR        */
*       RFY                                                        1231
*         R7 UNRSTD;                /* NO LONGER REQUIRED            */
*     END;                          /* END TPQUE PROCESSING          */
*   R14=R14SAVE;                    /* RESTORE RETURN REGISTER       */
@RC01164 L     R14,R14SAVE(,ZCRRPTR)                               1233
*   END ISTZFDB;                    /* END OF SUBROUTINE             */
@EL00004 DS    0H                                                  1234
@EF00004 DS    0H                                                  1234
@ER00004 BR    @14                                                 1234
*   RFY                                                            1235
*    (R14) UNRSTD;                  /* RESTORED                      */
         EJECT
*                                                                  1236
*/********************************************************************/
*/*                                                                  */
*/* SUBROUTINE-                                                      */
*/*      ISTZPBST                                                    */
*/*                                                                  */
*/* FUNCTION-                                                        */
*/*      INHIBIT DATA TRAFFIC ON THE CLIP, TOP, AND ATOP.            */
*/*                                                                  */
*/********************************************************************/
*                                                                  1236
*   RFY                                                            1236
*    (R14) RSTD;                    /* TO SAVE RETURN REGISTER       */
*ISTZPBST:                                                         1237
*   PROCEDURE OPTIONS(NOSAVE,NOSAVEAREA);/* ISTZPBST SUBROUTINE      */
ISTZPBST DS    0H                                                  1238
*   IF FMCCIPI=ON&FMCMODE^='ISTYTCM3'&FMCSDTR=ON THEN/* IF CLEAR IN
*                                      PROGRESS              @ZA29843
*                                      AND NOT TCAM OPERATION@ZA29843
*                                      AND SDT FLAG IS ON    @ZA29963*/
         TM    FMCCIPI(FMCBPTR),B'01000000'                        1238
         BNO   @RF01238                                            1238
         CLC   FMCMODE(8,FMCBPTR),@CC04180                         1238
         BE    @RF01238                                            1238
         TM    FMCSDTR(FMCBPTR),B'00010000'                        1238
         BNO   @RF01238                                            1238
*     ADDR(FMCPAB1)->PABINHBT=ON;   /* PROHIBIT CLOP TRAFFIC @ZA29843*/
         L     @15,PABINHBT+64(,FMCBPTR)                           1239
@GL00022 LR    @09,@15                                             1239
         O     @09,@CF04256                                        1239
         CS    @15,@09,PABINHBT+64(FMCBPTR)                        1239
         BNE   @GL00022                                            1239
*   ELSE                                                           1240
*     ;                             /*                       @ZA29843*/
@RF01238 DS    0H                                                  1241
*   ADDR(FMCPAB2)->PABINHBT=ON;     /* PROHIBIT TRAFFIC ON CLIP      */
         L     @15,PABINHBT+80(,FMCBPTR)                           1241
@GL00023 LR    @09,@15                                             1241
         O     @09,@CF04256                                        1241
         CS    @15,@09,PABINHBT+80(FMCBPTR)                        1241
         BNE   @GL00023                                            1241
*   ADDR(FMCPAB3)->PABINHBT=ON;     /* PROHIBIT TRAFFIC ON TOP       */
         L     @15,PABINHBT+96(,FMCBPTR)                           1242
@GL00024 LR    @09,@15                                             1242
         O     @09,@CF04256                                        1242
         CS    @15,@09,PABINHBT+96(FMCBPTR)                        1242
         BNE   @GL00024                                            1242
*   ADDR(FMCPAB5)->PABINHBT=ON;     /* PROHIBIT TRAFFIC ON ATOP      */
         L     @15,PABINHBT+128(,FMCBPTR)                          1243
@GL00025 LR    @09,@15                                             1243
         O     @09,@CF04256                                        1243
         CS    @15,@09,PABINHBT+128(FMCBPTR)                       1243
         BNE   @GL00025                                            1243
*   END ISTZPBST;                   /* END OF SUBROUTINE             */
@EL00005 DS    0H                                                  1244
@EF00005 DS    0H                                                  1244
@ER00005 BR    @14                                                 1244
*   RFY                                                            1245
*    (R14) UNRSTD;                  /* RETURN ADDRESS REGISTER       */
*/* TPEPILOG                                                         */
*                                                                  1246
*   GEN(PRINT OFF);                                                1246
         PRINT OFF
*/* TEMPLATE FOR CHAIN FIELD OF WORK ELEMENT */                    1247
*DCL  1  ISTWKE BDY(WORD) BASED(WKEPTR),                           1247
*        2  * CHAR(4),                 /* SPACE                       *
*        2  WKECHAIN PTR(31),          /* CHAIN POINTER               *
*           3 WKEFLAGS BIT(8),         /* FLAGS                       *
*             4 WKEGATE  BIT(1),       /* GATE BIT                    *
*             4 *        BIT(7),       /* RESERVED                    *
*           3 WKECHNGP PTR(24);        /* PTR ADDRESS                 *
*/* ***** POOL ENTRY  ***** */                                     1248
*/*  INITIAL LEVEL                                     001 12/20/74  */
*DCL   1  ISTBPENT BDY(DWORD) BASED(BPEPTR),                       1248
*         2  BPEPID   CHAR(4),         /* POOL ID                    */
*         2  BPEFLAGS BIT(16),         /* POOL FLAGS ZUP0589 @Z40GKDS*/
*            3  BPEFM    BIT(1),       /* POOL FORMAT                */
*            3  BPEDISP  BIT(1),       /* SHARED OR PRIVATE          */
*            3  BPEFIXED BIT(1),       /* FIXED OR PAGEABLE          */
*            3  BPENFCHP BIT(1),       /* NON-FETCH PROTECTION       */
*            3  BPEAL48  BIT(1),       /* 4,8 ALIGNEMENT OF BUFFERS  */
*            3  BPECBID  BIT(1),       /* CBID POOL                  */
*            3  BPENWS   BIT(1),       /* NON-WORKING SET POOL       */
*            3  BPERSV01 BIT(1),       /* RESERVED   ZUP0589 @Z40GKDS*/
*            3  BPEUSRF  BIT(1),       /* USER REQUIRES FIXED BUF    */
*            3  BPERSV02 BIT(7),       /* RESERVED   ZUP0589 @Z40GKDS*/
*         2  BPEBFSIZ FIXED(15),       /* BUFFER SIZE IN BYTES       */
*         2  BPEBPCB  PTR(31),         /* ADDRESS OF BPCB            */
*         2  BPERSV03 CHAR(4);         /* RESERVED                   */
*/* ***** POOL DIRECTORY  ***** */                                 1249
*/*  REVISIONS                                         002 03/20/75  */
*DCL   1  ISTBPDTY BDY(DWORD) BASED(BPDPTR),                       1249
*         2  BPDHDR CHAR(144) BDY(WORD),/* DIRECTORY HEADER          */
*            3  BPDBPENT FIXED(15),    /* CURRENT NUMBER OF ENTRIES  */
*            3  BPDBPMAX FIXED(15),    /* MAXIMUN NUMBER OF ENTRIES  */
*            3  BPDCHBNO FIXED(15),    /* NO. BUFFERS FOR CHPGM      */
*            3  BPDCHBSZ FIXED(15),    /* BUFFER SIZE FOR CH PGM     */
*            3  BPDCHPCB PTR(31),      /* BPCB ADDR FOR CHPGM        */
*            3  BPDPGPCB PTR(31),      /* BPCB ADDR FOR PGBUF        */
*            3  BPDADRS1 PTR(31),      /* BEGINNIG ADDR FOR POOLS    */
*            3  BPDADRS2 PTR(31),      /* END ADDR FOR POOLS         */
*            3  BPDFEXT  PTR(31),      /* ADDR OF 1ST FREE EXTENT    */
*            3  BPDSMPCB PTR(31),      /* SMS WE BPCB ADDRESS        */
*            3  BPDFBPE  PTR(31),      /* FIRST POOL ENTRY           */
*            3  BPDATCVT PTR(31),      /* PTR BACK TO ATCVT          */
*            3  BPDFLAG  FIXED(32),    /* FLAGS FIELD                */
*               4 BPDGTR   BIT(1),     /* GTRACE REQUESTED           */
*               4 BPDRSV01 BIT(31),    /* RESERVED                   */
*            3  BPDREQCT FIXED(15),    /* COUNT OF REQSTORES         */
*            3  BPDREQMX FIXED(15),    /* GTRACE REQ INTRVAL         */
*            3  BPDPARM  CHAR(8) BDY(WORD),/* GTRACE PARM            */
*               4 BPDTRLEN FIXED(15),  /* GTRACE DATA LENGTH         */
*               4 *        CHAR(1),    /* RESERVED                   */
*               4 BPDTRID  CHAR(1),    /* GTRACE FORMAT ID           */
*               4 BPDTRADR PTR(31),    /* GTRACE DATA ADDR           */
*            3  BPDTRACE (11) CHAR(8) BDY(WORD),/* GTRACE DATA       */
*               4 BPDMUSE  FIXED(15),  /* MAX BUFFERS IN USE         */
*               4 BPDMQUE  FIXED(15),  /* MAX REQUESTS QUEUED        */
*               4 BPDAVNO  FIXED(15),  /* AVAIL NUMBER OF BUFFRS     */
*               4 *        CHAR(2),    /* RESERVED                   */
*         2  BPDENTRY (12)CHAR(LENGTH(ISTBPENT)), /* BEGIN POOL ENTRY*/
*         2  BPDCBID  CHAR(*);         /* CBID TABLE SECTION         */
*   DCL                                                            1250
*     ISTAPC34 ENTRY BASED(ATCAP34) VALRG(*);/* RESET ROUTINE        */
*   DCL                                                            1251
*     ISTAPC37 ENTRY BASED(ATCAP37) VALRG(*);/* TPQUE ROUTINE        */
*   GEN(PRINT ON);                                                 1252
*                                                                  1252
         PRINT ON
*/* END OF TPEPILOG                                                  */
*                                                                  1253
*   END ISTZBFSC                    /* END OF MODULE                 */
*                                                                  1253
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSUT5  (PROLOGUE)                                       */
*/*%INCLUDE SYSUT5  (DECLARES)                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*/*%INCLUDE SYSUT5  (MAINLINE)                                       */
*/*%INCLUDE SYSUT5  (ISTZNSES)                                       */
*/*%INCLUDE SYSUT5  (ISTZSND )                                       */
*/*%INCLUDE SYSUT5  (ISTZTRM )                                       */
*/*%INCLUDE SYSUT5  (ISTZCLR )                                       */
*/*%INCLUDE SYSUT5  (NOTIFY  )                                       */
*/*%INCLUDE SYSUT5  (ISTZFDB )                                       */
*/*%INCLUDE SYSUT5  (ISTZPBST)                                       */
*                                                                  1253
*       ;                                                          1253
@EL00001 DS    0H                                                  1253
@EF00001 DS    0H                                                  1253
@ER00001 BR    @14                                                 1253
@DATA    DS    0H
@CH00052 DC    H'4'
@SM04248 MVC   SRUCOPY(0,ZCRRPTR),DATALCCW(@09)
@SM04250 MVC   SRUCOPY-1(0,@15),DATALCCW(@11)
@DATD    DSECT
         DS    0F
ISTZBFSC CSECT
         DS    0F
@CF00060 DC    F'1'
@CF00287 DC    F'3'
@CF00714 DC    F'7'
@CF00058 DC    F'8'
@CF00742 DC    XL4'7FFFFFFF'
@CF00744 DC    XL4'80000000'
@CF00758 DC    XL4'04000000'
@CF00768 DC    XL4'08000000'
@CF04147 DC    XL4'00FFFFFF'
@CF04247 DC    XL4'0000FFFF'
@CF04256 DC    BL4'00000010000000000000000000000000'
@DATD    DSECT
         DS    0D
WKEPTR   DS    A
BPEPTR   DS    A
BPDPTR   DS    A
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
ISTZBFSC CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
FMZA0016 DS    FL4
         ORG   FMZA0016
@NM00059 DC    AL1(64)
@NM00060 DC    AL3(0)
         ORG   FMZA0016+4
FMZA0054 DS    FL4
         ORG   FMZA0054
@NM00061 DC    AL1(168)
@NM00062 DC    AL3(0)
         ORG   FMZA0054+4
@CC04180 DC    C'ISTYTCM3'
@CC04064 DC    C'BCSC'
@CB03023 DC    X'F24800046B8000A1'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
FMCBPTR  EQU   @05
RPHPTR   EQU   @01
COUNT    EQU   @00
ATCVTPTR EQU   @02
R3       EQU   @03
LUNCBPTR EQU   @04
R6       EQU   @06
K        EQU   @07
R7       EQU   @07
ZCRRPTR  EQU   @08
R12      EQU   @12
R13      EQU   @13
R14      EQU   @14
R15      EQU   @15
GPR01F   EQU   @01
GPR01P   EQU   @01
GPR12P   EQU   @12
GPR13P   EQU   @13
GPR14F   EQU   @14
GPR14P   EQU   @14
GPR00F   EQU   @00
GPR00P   EQU   @00
GPR02F   EQU   @02
GPR02P   EQU   @02
GPR03F   EQU   @03
GPR03P   EQU   @03
GPR04F   EQU   @04
GPR04P   EQU   @04
GPR05F   EQU   @05
GPR05P   EQU   @05
GPR06F   EQU   @06
GPR07P   EQU   @07
GPR15F   EQU   @15
GPR15P   EQU   @15
GPR06P   EQU   @06
GPR07F   EQU   @07
GPR08F   EQU   @08
GPR08P   EQU   @08
GPR09F   EQU   @09
GPR09P   EQU   @09
GPR10F   EQU   @10
GPR10P   EQU   @10
GPR11F   EQU   @11
GPR11P   EQU   @11
GPR12F   EQU   @12
GPR13F   EQU   @13
ATCLCPTR EQU   1032
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTSHS   EQU   CVTXTNT2+40
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
ISTLOK   EQU   0
LOKCHN   EQU   ISTLOK+1
LOKCHNG  EQU   LOKCHN
@NM00004 EQU   LOKCHNG+2
ISTPAB   EQU   0
PABWQCHN EQU   ISTPAB
PABWEQA  EQU   PABWQCHN
PABCHAIN EQU   PABWQCHN+4
PABCHNGP EQU   PABCHAIN+1
PABRPHFG EQU   ISTPAB+12
PABFLAGS EQU   PABRPHFG
PABERLCK EQU   PABFLAGS
PABERRLK EQU   PABERLCK
PABINHBT EQU   PABFLAGS
ISTDEVCH EQU   0
DEVSHCH  EQU   ISTDEVCH
DEVCHAR  EQU   DEVSHCH
DEVTCODE EQU   ISTDEVCH+1
DEVFLAGS EQU   ISTDEVCH+3
DEVFCCTL EQU   DEVFLAGS
DEVCHAR3 EQU   DEVFLAGS
ISTPROCD EQU   0
PROPROC  EQU   ISTPROCD
PROPROC1 EQU   PROPROC
PROPROC2 EQU   PROPROC+1
PROPROC3 EQU   PROPROC+2
PROPROC4 EQU   PROPROC+3
PROPROCS EQU   0
PROSETMS EQU   PROPROCS+1
PROSETM2 EQU   PROSETMS
PROSETM3 EQU   PROSETMS+1
PROSETM4 EQU   PROSETMS+2
ISTFMCB  EQU   0
FMCSAF   EQU   ISTFMCB+2
FMCDNCBA EQU   ISTFMCB+16
FMCSTAT  EQU   ISTFMCB+28
FMCSTAT1 EQU   ISTFMCB+29
FMCCMDFL EQU   ISTFMCB+31
FMCCMPS1 EQU   ISTFMCB+36
FMCMODE  EQU   ISTFMCB+52
FMCPAB1  EQU   ISTFMCB+64
FMCPAB2  EQU   ISTFMCB+80
FMCPAB3  EQU   ISTFMCB+96
FMCPAB5  EQU   ISTFMCB+128
FMCSIPA  EQU   ISTFMCB+148
FMCNXOSQ EQU   ISTFMCB+152
FMCNXCFM EQU   FMCNXOSQ
FMCOSSN  EQU   FMCNXCFM
FMCNXOSC EQU   FMCNXOSQ+2
FMCOASN  EQU   FMCNXOSC
FMCISSN  EQU   ISTFMCB+156
FMCSSTAT EQU   ISTFMCB+159
FMCSNBI  EQU   FMCSSTAT
FMCCIPI  EQU   FMCSSTAT
FMCUIPI  EQU   FMCSSTAT
FMCSDTR  EQU   FMCSSTAT
FMCBIP   EQU   FMCSSTAT
FMCNSALU EQU   FMCSSTAT
FMCPACE  EQU   ISTFMCB+160
FMCPACEN EQU   FMCPACE
FMCPACEM EQU   FMCPACE+1
FMCPACPC EQU   FMCPACE+2
FMCCVAL  EQU   FMCPACE+3
FMCOBCE  EQU   FMCCVAL
FMCCLEXT EQU   ISTFMCB+164
FMCRPLA  EQU   FMCCLEXT
FMCFBA   EQU   FMCCLEXT+4
FMCCMPS2 EQU   FMCCLEXT+16
FMCFLGA  EQU   FMCCMPS2
FMCFLGCL EQU   FMCCMPS2+1
FMCPSCMD EQU   FMCCMPS2+2
FMCPSTAT EQU   FMCCMPS2+3
FMCSTAT2 EQU   ISTFMCB+186
FMCSEQI  EQU   FMCSTAT2
FMCMODEB EQU   ISTFMCB+189
FMCCLSEQ EQU   ISTFMCB+190
FMCRRESP EQU   ISTFMCB+195
FMCSSEGQ EQU   ISTFMCB+200
FMCFBAS  EQU   ISTFMCB+216
FMCZV002 EQU   FMCFBAS
FMCSNCTL EQU   ISTFMCB+224
FMCSCFLG EQU   FMCSNCTL
FMCVS1   EQU   ISTFMCB+232
FMCZFLAG EQU   FMCVS1
FMCZF006 EQU   FMCZFLAG
FMCLBXM  EQU   FMCVS1+12
FMCSHEAQ EQU   FMCLBXM
FMCLCPBQ EQU   FMCVS1+16
FMCLCPAQ EQU   FMCVS1+20
FMCSEQ1  EQU   FMCVS1+34
FMCZFLG2 EQU   FMCVS1+35
FMCCVFLG EQU   FMCVS1+44
FMCFLAG  EQU   0
FMCFLGB  EQU   FMCFLAG
ISTLCCW  EQU   0
LCCWOP   EQU   ISTLCCW
LCCWRWOP EQU   LCCWOP
LCCWCTL  EQU   LCCWRWOP
LCCWFLAG EQU   ISTLCCW+1
LCCWCD   EQU   LCCWFLAG
LCCWCC   EQU   LCCWFLAG
LCCWIDAT EQU   LCCWFLAG
LCCWLSI  EQU   LCCWFLAG
LCCWCNT  EQU   ISTLCCW+2
LCCWDATA EQU   ISTLCCW+4
ISTDYPAB EQU   0
ISTRPH   EQU   0
RPHCNTL  EQU   ISTRPH
RPHFLAGS EQU   RPHCNTL+2
RPHAPTYP EQU   RPHFLAGS
RPHFSTLC EQU   RPHFLAGS
RPHFLGB  EQU   RPHCNTL+3
RPHRPHA  EQU   ISTRPH+4
RPHTSKID EQU   ISTRPH+8
RPHRESMA EQU   ISTRPH+16
RPHWPFLG EQU   RPHRESMA
RPHWT    EQU   RPHWPFLG
RPHPABOF EQU   ISTRPH+20
RPHMAJCB EQU   ISTRPH+21
RPHWEA   EQU   ISTRPH+24
RPHCSPA  EQU   RPHWEA
RPHSRPRM EQU   ISTRPH+28
RPHCRR   EQU   ISTRPH+32
RPHPABQA EQU   ISTRPH+36
RPHPABQP EQU   RPHPABQA+1
RPHWORK  EQU   ISTRPH+40
RPHSAVE1 EQU   RPHWORK
RPHSBITS EQU   RPHSAVE1+1
ISTATCVT EQU   0
ATCCOM   EQU   ISTATCVT
ATCSTAT  EQU   ATCCOM
ATCSTAT1 EQU   ATCSTAT
ATCSTFLG EQU   ATCSTAT+1
ATCPOFLG EQU   ATCSTAT+2
ATCSTAT4 EQU   ATCSTAT+3
ATCBPDA  EQU   ATCCOM+128
ATCIOTRC EQU   ATCCOM+140
ATCTHTRC EQU   ATCIOTRC
ATCSMRQ  EQU   ATCCOM+180
ATCSMRS  EQU   ATCCOM+188
ATCCSMR  EQU   ISTATCVT+296
ATCSHRFG EQU   ISTATCVT+316
ATCHPGM  EQU   ISTATCVT+384
ATCVLCNT EQU   ISTATCVT+772
ATCRNO   EQU   ISTATCVT+788
ATCSOPD  EQU   ISTATCVT+792
ATCSIPD  EQU   ISTATCVT+800
ATCSECST EQU   ISTATCVT+812
ATCSTAT2 EQU   ISTATCVT+818
ATCVTBAM EQU   ISTATCVT+908
@NM00023 EQU   ATCVTBAM+3
ATCAOSM  EQU   ISTATCVT+912
ATCGSRBQ EQU   ATCAOSM+4
ATCGSRBG EQU   ATCGSRBQ
ATCAP31  EQU   ATCAOSM+24
ATCAP32  EQU   ATCAOSM+28
ATCAP34  EQU   ATCAOSM+32
ATCZPSVT EQU   ATCAOSM+72
ATCICAPP EQU   ATCAOSM+100
ATCLDAPP EQU   ATCAOSM+120
ATCDAPVT EQU   ATCAOSM+140
ATCAP37  EQU   ATCAOSM+264
ATCCRA   EQU   ATCAOSM+280
ATCCRACN EQU   ATCCRA+4
ATCSRB   EQU   ATCAOSM+288
ATCSRBCN EQU   ATCSRB+4
ATCCRPL  EQU   ATCAOSM+296
ATCRPLCN EQU   ATCCRPL+4
ATCSQAFR EQU   ATCAOSM+304
ATCORTBC EQU   ATCSQAFR+4
ATCORSRB EQU   ATCORTBC
@NM00025 EQU   ATCAOSM+332
ATCVTFLG EQU   ATCAOSM+392
ATCZFLAG EQU   ATCAOSM+588
ISTRH    EQU   0
RHFLAGS  EQU   ISTRH
RH1      EQU   RHFLAGS
RHQS     EQU   RH1
RH2      EQU   RHFLAGS+1
RHRETRY  EQU   RH2
RHRSVD1  EQU   RH2
RH3      EQU   RHFLAGS+2
ISTZSAVE EQU   0
ZSAZSVBC EQU   ISTZSAVE
ZSAZSVMS EQU   ZSAZSVBC
ZSAZACTV EQU   ZSAZSVMS
ZSAZSVFC EQU   ISTZSAVE+4
ZSAZSVRR EQU   ISTZSAVE+8
ZSAZSVVR EQU   ISTZSAVE+12
ZSAZTRAC EQU   ISTZSAVE+36
ISTLCPB  EQU   0
LCPREQTG EQU   ISTLCPB+2
LCPFLAGS EQU   LCPREQTG
LCPZF001 EQU   LCPFLAGS
LCPZRT02 EQU   LCPZF001
LCPZF002 EQU   LCPFLAGS
LCPZRT03 EQU   LCPZF002
LCPZF003 EQU   LCPFLAGS
LCPZRT04 EQU   LCPZF003
LCPZF004 EQU   LCPFLAGS
LCPZRT05 EQU   LCPZF004
LCPZRT06 EQU   LCPFLAGS
LCPZRT07 EQU   LCPFLAGS
LCPMNRCD EQU   LCPREQTG+1
LCPZRT08 EQU   LCPMNRCD
LCPZRT09 EQU   LCPMNRCD
LCPCHAIN EQU   ISTLCPB+4
LCPCHAI1 EQU   LCPCHAIN
LCPRUCNT EQU   ISTLCPB+8
LCPFLAG2 EQU   ISTLCPB+9
LCPTLBPI EQU   LCPFLAG2
LCPFID0  EQU   LCPFLAG2
LCPSEQ   EQU   ISTLCPB+10
LCPCID   EQU   ISTLCPB+16
LCPNXLCW EQU   ISTLCPB+20
LCPFDBA  EQU   ISTLCPB+24
LCPTLBAD EQU   ISTLCPB+28
LCPFLG1  EQU   ISTLCPB+37
LCPFLCCW EQU   ISTLCPB+40
LCPLCCW  EQU   ISTLCPB+48
LCPRSTQH EQU   LCPLCCW
LCPPABA  EQU   LCPLCCW+4
LCPRPHA  EQU   LCPPABA
LCPFTYPE EQU   LCPRPHA
ISTZCRR  EQU   0
ZCRCRR   EQU   ISTZCRR
ZCRFLGS1 EQU   ISTZCRR+12
ZCRFLGS2 EQU   ISTZCRR+13
ZCRSWFLD EQU   ISTZCRR+14
ZCRENDSH EQU   ZCRSWFLD
ZCRNDLCP EQU   ZCRSWFLD
ZCRRESET EQU   ZCRSWFLD
ZCRFLGS3 EQU   ISTZCRR+15
ZCRGENSW EQU   ISTZCRR+16
ZCRPFLGS EQU   ISTZCRR+17
ZCRIBPR  EQU   ISTZCRR+18
ZCRSCPSW EQU   ISTZCRR+19
ZCRTPEX  EQU   ZCRSCPSW
ZCRTPINV EQU   ZCRSCPSW
ZCRRJLCP EQU   ZCRSCPSW
ZCRLREQ  EQU   ZCRSCPSW
ZCRFSBWE EQU   ZCRSCPSW
ZCRPARMS EQU   ISTZCRR+24
ZCRFBPTR EQU   ZCRPARMS
ZCRDFRDA EQU   ZCRPARMS+10
ZCRPCOD1 EQU   ZCRPARMS+12
ZCRPFSB  EQU   ZCRPCOD1
ZCRPLSBF EQU   ZCRPCOD1
ZCRPBUF  EQU   ZCRPCOD1
ZCRPCOD2 EQU   ZCRPARMS+13
ZCRSVRTN EQU   ISTZCRR+56
ZCRSVF5  EQU   ZCRSVRTN+16
ZCRSVF9  EQU   ZCRSVRTN+32
ZCRSVF10 EQU   ZCRSVRTN+36
ZCRSVF11 EQU   ZCRSVRTN+40
ZCRSVF19 EQU   ZCRSVRTN+72
ZCRSVF21 EQU   ZCRSVRTN+80
ZCRSVF22 EQU   ZCRSVRTN+84
ZCRSVF23 EQU   ZCRSVRTN+88
ZCRSVF24 EQU   ZCRSVRTN+92
ZCRSVF25 EQU   ZCRSVRTN+96
ZCRWKARA EQU   ISTZCRR+156
ZCRCIDSV EQU   ISTZCRR+192
ZCRAUDIT EQU   ISTZCRR+440
ZCRENTER EQU   ZCRAUDIT+5
ZCREBCSC EQU   ZCRENTER+4
ZCRLCPB  EQU   ISTZCRR+480
ZCRRHRU  EQU   ZCRLCPB
ZCRRU    EQU   ZCRRHRU+3
ISTPFCRR EQU   0
PFCCRR   EQU   ISTPFCRR
PFCCRRID EQU   PFCCRR
PFCCRRLN EQU   PFCCRR+2
PFCHDR   EQU   ISTPFCRR+4
PFCCRRO  EQU   PFCHDR
PFCFRRO  EQU   PFCHDR+4
ISTCFCRR EQU   0
CFCAUDIT EQU   ISTCFCRR
CFCNTRD  EQU   CFCAUDIT
CFCCRT   EQU   CFCAUDIT+1
ISTASCRR EQU   0
ASCFLAGS EQU   ISTASCRR+16
ASCFLG1  EQU   ASCFLAGS
ASCFLG2  EQU   ASCFLAGS+2
ASCFLG3  EQU   ASCFLAGS+4
ASCUSRGS EQU   ISTASCRR+28
ISTAPCRR EQU   0
APCATFLG EQU   ISTAPCRR+16
APCRFLG  EQU   ISTAPCRR+18
APCSAVE  EQU   ISTAPCRR+44
APCCOMF  EQU   ISTAPCRR+116
APCCOMF1 EQU   APCCOMF
APC31FLG EQU   ISTAPCRR+132
APC52FLG EQU   ISTAPCRR+133
APC53FLG EQU   ISTAPCRR+134
APC54FLG EQU   ISTAPCRR+135
APC57FLG EQU   ISTAPCRR+136
ISTCRA   EQU   0
CRABASIC EQU   ISTCRA
CRAHDR   EQU   CRABASIC
CRACRR   EQU   CRAHDR
CRALKACT EQU   CRABASIC+8
CRASVC   EQU   ISTCRA+848
CRABUFA  EQU   CRASVC+68
ISTZPSVT EQU   0
ZPSZDFA0 EQU   ISTZPSVT
ZPSZDFB0 EQU   ISTZPSVT+16
ISTRU    EQU   0
RUDATA   EQU   ISTRU
ISTRUB   EQU   0
NSRUNA5  EQU   0
ISTTLB   EQU   0
TLBLCPA  EQU   ISTTLB
TLBFSBA  EQU   ISTTLB+4
TLBLCCWS EQU   ISTTLB+8
ISTFDB   EQU   0
FDBOFSET EQU   ISTFDB+10
ISTFSB   EQU   0
FSBFSB   EQU   ISTFSB
FSBTYPE  EQU   FSBFSB
FSBMNRCD EQU   FSBFSB+2
FSBSFLGS EQU   FSBFSB+3
FSBFSBA  EQU   FSBFSB+4
FSBBTH   EQU   FSBFSB+8
FSBCID   EQU   FSBBTH
FSBSAF   EQU   FSBCID
FSBDAF   EQU   FSBCID+2
FSBRQTAG EQU   FSBBTH+4
FSBSEQID EQU   FSBRQTAG
FSBFLAGS EQU   FSBSEQID
FSBSEQ   EQU   FSBSEQID+1
FSBCSWST EQU   FSBBTH+6
FSBTHFLD EQU   FSBCSWST
FSBTH1   EQU   FSBTHFLD
FSBSYSRS EQU   FSBTH1
FSBTH2   EQU   FSBTHFLD+1
FSBEXTRS EQU   FSBTH2
FSBXFSTS EQU   FSBEXTRS
FSBXCODE EQU   FSBEXTRS
FSBNETRS EQU   FSBFSB+16
FSBSRCAT EQU   FSBNETRS
FSBMJRCD EQU   FSBSRCAT
FSBERC   EQU   FSBNETRS+1
FSBFBMI  EQU   FSBERC
FSBDMGRS EQU   FSBFSB+18
FSBSS1   EQU   FSBDMGRS
FSBSS2   EQU   FSBDMGRS+1
FSBLCPB  EQU   FSBFSB+20
FSBMSGID EQU   FSBLCPB
FSBLCCWA EQU   FSBFSB+24
FSBRLSTS EQU   FSBLCCWA
FSBFDB   EQU   ISTFSB+32
ISTNCB   EQU   0
NCBDAF   EQU   ISTNCB+2
NCBFLAGS EQU   ISTNCB+24
NCBFRAS  EQU   NCBFLAGS+1
NCBFTRIO EQU   NCBFRAS
NCBFLAG1 EQU   NCBFLAGS+2
ISTNIR   EQU   0
ISTTH    EQU   0
THFLAG1  EQU   ISTTH
THFLGA   EQU   THFLAG1
THMPF    EQU   THFLGA
THFLGB   EQU   THFLAG1+1
ISTTH2   EQU   0
TH2FLAG1 EQU   ISTTH2
TH2MPF   EQU   TH2FLAG1
ISTPIU   EQU   0
PIUTH    EQU   ISTPIU
ISTBDU   EQU   0
BDUMODIF EQU   ISTBDU+1
BDUMOD1  EQU   BDUMODIF
BDUDAF   EQU   ISTBDU+2
BDUFUNC  EQU   BDUDAF
BDUCHECK EQU   BDUFUNC
BDUFLAGS EQU   BDUDAF+1
ISTLH    EQU   0
ISTBTU   EQU   0
BTUBTH   EQU   ISTBTU
BTUFID   EQU   BTUBTH
BTUREQ   EQU   BTUBTH+6
BTURQFLG EQU   BTUREQ
BTURH    EQU   BTUBTH+10
BTUSYSTR EQU   ISTBTU+18
ISTZIBUF EQU   0
ZIBCHAIN EQU   ISTZIBUF
ZIBFSM   EQU   ISTZIBUF+4
ISTLUNCB EQU   0
LUNCB    EQU   ISTLUNCB
LUNZOS   EQU   ISTLUNCB+48
ISTBFHDR EQU   0
ISTBIND  EQU   0
BINFMTY  EQU   ISTBIND
BINTS    EQU   ISTBIND+2
BINPRIP  EQU   ISTBIND+3
BINSECP  EQU   ISTBIND+4
BINCMNP  EQU   ISTBIND+5
BINCMNP2 EQU   ISTBIND+6
BINTSU   EQU   ISTBIND+7
BINRPACE EQU   BINTSU+1
BINRUSZ  EQU   BINTSU+2
BINSRUSZ EQU   BINRUSZ
BINPRUSZ EQU   BINRUSZ+1
BINPRSVC EQU   ISTBIND+13
BINLUP   EQU   BINPRSVC
BINPSCHR EQU   BINPRSVC+1
DATALCCW EQU   0
ISTZDFA0 EQU   0
ISTZDFB0 EQU   0
FMZL0016 EQU   0
ISTWKE   EQU   0
WKECHAIN EQU   ISTWKE+4
WKEFLAGS EQU   WKECHAIN
ISTBPENT EQU   0
BPEFLAGS EQU   ISTBPENT+4
ISTBPDTY EQU   0
BPDHDR   EQU   ISTBPDTY
BPDPGPCB EQU   BPDHDR+12
BPDFLAG  EQU   BPDHDR+40
BPDPARM  EQU   BPDHDR+48
BPDTRACE EQU   BPDHDR+56
FMZL0054 EQU   0
FMZL0079 EQU   0
ISTAPC37 EQU   0
ISTAPC34 EQU   0
ZIBSRB   EQU   0
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
LCPBPTR  EQU   ZCRSVF10
LCPZTIE  EQU   LCPCID
LCPZSNAM EQU   LCPZTIE+8
ISTSENRU EQU   RUDATA
SRUSENSE EQU   ISTSENRU
SRUSENS1 EQU   SRUSENSE
SRUSENS2 EQU   SRUSENSE+2
ISTSRU   EQU   ISTRUB
SRUQSREQ EQU   ISTSRU
SRUDATA  EQU   ISTSRU+1
SRUTYPE  EQU   SRUDATA
SRUSPAC  EQU   SRUTYPE
SRUPSAC  EQU   SRUTYPE
SRULDID  EQU   SRUDATA+1
SRUSPSN  EQU   SRULDID
SRUDFCLV EQU   SRUSPSN
SRUPSSN  EQU   SRULDID+2
ISTNSRU  EQU   ISTRUB
NSRUNETS EQU   ISTNSRU
NSRUDATA EQU   ISTNSRU+3
NSRUHOOK EQU   NSRUDATA
NSSSVRU  EQU   NSRUDATA
NSSSVNOD EQU   NSSSVRU+3
NSSSVT3  EQU   NSSSVNOD
NSSSVT3C EQU   NSSSVT3+2
NSSSVT3G EQU   NSSSVT3+5
NSSSVT4  EQU   NSSSVNOD
NSSSVT5  EQU   NSSSVNOD
NSRUDAT1 EQU   NSRUDATA
NSRUDAT2 EQU   NSRUDAT1+2
ISTTRRU  EQU   NSRUDAT2
TRRTYPE  EQU   ISTTRRU
ISTCTDRU EQU   NSRUDAT2
ISTINORU EQU   NSRUDAT2
SRUDAT1  EQU   SRUDATA
SRUDAT1L EQU   SRUDAT1+1
SRUTSPRO EQU   SRUDAT1L
SRUDAT2  EQU   SRUDATA
ISTMRU   EQU   ISTRUB
SRUDATA3 EQU   SRUDATA
SRUDATA4 EQU   SRUDATA
NSRUDAT3 EQU   NSRUDAT2
NSRUDAT4 EQU   NSRUDAT2
NSRUDAT5 EQU   NSRUDAT2
NSRUDAT6 EQU   NSRUDAT2
NSRUDAT7 EQU   NSRUDAT2
NSRUDIL  EQU   NSRUDAT2
NSRUDILB EQU   NSRUDIL+1
NSRUNA   EQU   NSRUDAT2
NSRUNA2  EQU   NSRUNA+1
NSRUCLSP EQU   NSRUDAT2
NSRUOH1  EQU   NSRUDAT2
NSRUDAT8 EQU   NSRUDATA
ISTUNBRU EQU   SRUTYPE
FSBPTR   EQU   ZCRSVF9
FSBCOMBN EQU   FSBNETRS
FSBRHFLD EQU   FSBCOMBN+1
FSBRH3   EQU   FSBRHFLD+2
FSBLDFLG EQU   FSBRH3
@NM00051 EQU   FSBRQTAG
ZIBDIO   EQU   ZIBFSM
ZIBCCW2  EQU   ZIBDIO+8
ZIBCPTCC EQU   ZIBCCW2
ZIBAIO   EQU   ISTZIBUF
ZIBAIOCM EQU   ZIBAIO
ZIBFIB   EQU   ZIBAIO+16
ZIBFSB   EQU   ZIBFIB
ZIBMDREC EQU   ZIBFSB+4
ZIBMDRIN EQU   ZIBFSB+28
ZIBBTU   EQU   ZIBFIB+32
@NM00056 EQU   ZIBBTU+12
ZIBFID1  EQU   @NM00056+1
ZIBFITXT EQU   ZIBFID1
ZIBSIB   EQU   ZIBFIB
ZIBREC   EQU   ZIBMDRIN
ZIBRECPL EQU   ZIBREC
ZIBRECHD EQU   ZIBRECPL
ZIBRECRS EQU   ZIBREC+8
ZIBRECDT EQU   ZIBREC+10
ZIBMDRRC EQU   ZIBMDREC
ZIBRCPL  EQU   ZIBMDRRC
ZIBRCDT  EQU   ZIBMDRRC+24
@NM00058 EQU   ZIBBTU
BINLUP1  EQU   BINPSCHR
BINLUS   EQU   BINPSCHR
BINFMF1  EQU   BINLUS
BINRSV09 EQU   BINFMF1
BINDSPF1 EQU   BINLUS+2
BINMEDIA EQU   BINLUS+4
BINLUP2  EQU   BINPSCHR
BINLUP3  EQU   BINPSCHR
R14SAVE  EQU   ZCRSVF19
NFYSAVE  EQU   ZCRSVF11
TLBPTR   EQU   ZCRSVF5
LCCWPTR  EQU   ZCRSVF21
SRUPTR   EQU   ZCRSVF22
RHPTR    EQU   ZCRSVF23
LENTLB   EQU   ZCRSVF24
RUPTRC   EQU   ZCRSVF25
SRUCOPY  EQU   ZCRRU
ZIBPTR   EQU   RPHSRPRM
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
BINRSV26 EQU   BINLUP3
BINRSV15 EQU   BINLUP2+10
BINPRESZ EQU   BINLUP2+9
BINRSV14 EQU   BINLUP2
BINRSV13 EQU   BINMEDIA
BINDISK  EQU   BINMEDIA
BINXCHNG EQU   BINMEDIA
BINCARD  EQU   BINMEDIA
BINDOCMT EQU   BINMEDIA
BINRSV17 EQU   BINDSPF1+1
BINTRNDS EQU   BINDSPF1
BINRSV12 EQU   BINDSPF1
BINVSDS  EQU   BINDSPF1
BINVTDS  EQU   BINDSPF1
BINHFDS  EQU   BINDSPF1
BININTR  EQU   BINDSPF1
BINRSV11 EQU   BINRSV09+1
BINXFPD  EQU   BINRSV09+1
BINCSDS  EQU   BINRSV09+1
BINQDSI  EQU   BINRSV09+1
BINRSV16 EQU   BINRSV09+1
BINARRR  EQU   BINRSV09
BINSIDS  EQU   BINRSV09
BINSAI   EQU   BINRSV09
BINSDSI  EQU   BINRSV09
BINKDDSI EQU   BINRSV09
BINPDIR  EQU   BINFMF1
BINCMPCT EQU   BINFMF1
BINDESTS EQU   BINFMF1
BINSLUS1 EQU   BINLUP1+6
BINPLUS1 EQU   BINLUP1+1
BINDSP1  EQU   BINLUP1
BINFMHS1 EQU   BINLUP1
ZIBTH2   EQU   @NM00058+4
ZIBLH    EQU   @NM00058
ZIBRCTXT EQU   ZIBMDRRC+36
ZIBRCRID EQU   ZIBRCDT+10
ZIBRCNAM EQU   ZIBRCDT+2
ZIBRCUA  EQU   ZIBRCDT
ZIBRCPUI EQU   ZIBRCPL+20
ZIBRCPUN EQU   ZIBRCPL+16
ZIBRCTIM EQU   ZIBRCPL+12
ZIBRCDAT EQU   ZIBRCPL+8
ZIBRCRS1 EQU   ZIBRCPL+6
ZIBRCSID EQU   ZIBRCPL+5
ZIBRCID  EQU   ZIBRCPL+4
ZIBRCSW  EQU   ZIBRCPL+2
ZIBRCSYR EQU   ZIBRCPL+1
ZIBRCL   EQU   ZIBRCPL
ZIBRECTX EQU   ZIBREC+22
ZIBRECID EQU   ZIBRECDT+10
ZIBRECNA EQU   ZIBRECDT+2
ZIBRECUA EQU   ZIBRECDT
ZIBRECSV EQU   ZIBRECRS
ZIBRECDA EQU   ZIBRECPL+4
ZIBRECSI EQU   ZIBRECHD+3
ZIBRECDV EQU   ZIBRECHD+2
ZIBRECFL EQU   ZIBRECHD+1
ZIBRECTY EQU   ZIBRECHD
ZIBTEXT  EQU   ZIBSIB+4
ZIBRSV04 EQU   ZIBSIB
ZIBTEXT2 EQU   ZIBFITXT
ZIBTEXT1 EQU   ZIBFIB+52
@NM00057 EQU   @NM00056
ZIBFDBS  EQU   ZIBBTU
@NM00055 EQU   ZIBMDREC
@NM00054 EQU   ZIBFSB
ZIBLNG2  EQU   ZIBAIOCM+14
ZIBRSV03 EQU   ZIBAIOCM+13
ZIBWKBYT EQU   ZIBAIOCM+12
ZIBFDBZ  EQU   ZIBAIOCM
ZIBCPNPK EQU   ZIBCCW2+6
ZIBRSV02 EQU   ZIBCCW2+5
ZIBCPTPF EQU   ZIBCCW2+4
ZIBCPTCA EQU   ZIBCCW2+1
ZIBCPNPC EQU   ZIBCPTCC
ZIBCPRDK EQU   ZIBDIO+6
ZIBRSV01 EQU   ZIBDIO+5
ZIBCPRDF EQU   ZIBDIO+4
ZIBCPTXA EQU   ZIBDIO+1
ZIBCPRDC EQU   ZIBDIO
FSBRT0B  EQU   @NM00051+1
FSBRT0A  EQU   @NM00051+1
FSBRT09  EQU   @NM00051+1
FSBRT08  EQU   @NM00051+1
FSBRT07  EQU   @NM00051
FSBRT06  EQU   @NM00051
FSBRT05  EQU   @NM00051
FSBRT04  EQU   @NM00051
FSBRT03  EQU   @NM00051
FSBRT02  EQU   @NM00051
FSBRT01  EQU   @NM00051
FSBRT00  EQU   @NM00051
FSBLDCUF EQU   FSBLDFLG
FSBLDSIF EQU   FSBLDFLG
FSBLDSOF EQU   FSBLDFLG
FSBLDEBF EQU   FSBLDFLG
FSBLDBBF EQU   FSBLDFLG
FSBLDFME EQU   FSBLDFLG
FSBLDSCF EQU   FSBLDFLG
FSBLDRMF EQU   FSBLDFLG
FSBRH2   EQU   FSBRHFLD+1
FSBRH1   EQU   FSBRHFLD
FSBALIGN EQU   FSBCOMBN
UNBTYPE  EQU   ISTUNBRU
NSRUDA8T EQU   NSRUDAT8
NSRUOHID EQU   NSRUOH1
NSRULSV  EQU   NSRUCLSP
NSRUNA4  EQU   NSRUNA+2
NSRUNA3  EQU   NSRUNA2
NSRUNA1  EQU   NSRUNA
NSRUDILF EQU   NSRUDIL+4
NSRUDILE EQU   NSRUDIL+3
NSRUDILD EQU   NSRUDIL+2
NSRUDILC EQU   NSRUDILB
@NM00047 EQU   NSRUDILB
NSRUDILA EQU   NSRUDIL
NSRUDA7T EQU   NSRUDAT7
NSRUDA6L EQU   NSRUDAT6+4
NSRUDA6S EQU   NSRUDAT6
NSRUDA5E EQU   NSRUDAT5
NSRUDA4T EQU   NSRUDAT4
NSRUDA3S EQU   NSRUDAT3
SRUDAT4D EQU   SRUDATA4
SRUDAT3I EQU   SRUDATA3
MRUDATA  EQU   ISTMRU+9
MRURESP  EQU   ISTMRU+7
MRUMODIF EQU   ISTMRU+6
MRUCMND  EQU   ISTMRU+5
MRUDAF   EQU   ISTMRU+3
MRUREQ   EQU   ISTMRU+2
MRUPREF  EQU   ISTMRU
SRUDAT2N EQU   SRUDAT2+1
SRUDAT2T EQU   SRUDAT2
SRUDAT1I EQU   SRUDAT1+2
SRUFMPRO EQU   SRUDAT1L
SRUDAT1T EQU   SRUDAT1
INORUET  EQU   ISTINORU
CTDRUSTA EQU   ISTCTDRU
TRRDATA  EQU   ISTTRRU+4
TRRSTAT  EQU   ISTTRRU+3
TRRPEP   EQU   ISTTRRU+2
TRRTIME  EQU   ISTTRRU+1
@NM00046 EQU   TRRTYPE
TRRFMT2  EQU   TRRTYPE
@NM00045 EQU   TRRTYPE
NSRUDAF  EQU   NSRUDAT1
NSSSVT5A EQU   NSSSVT5
NSSSVT4D EQU   NSSSVT4+3
NSSSVT4C EQU   NSSSVT4+2
NSSSVT4B EQU   NSSSVT4+1
NSSSVT4A EQU   NSSSVT4
NSSSVT3K EQU   NSSSVT3+8
NSSSVT3J EQU   NSSSVT3+7
NSSSVT3I EQU   NSSSVT3+6
@NM00044 EQU   NSSSVT3G
NSSSVT3H EQU   NSSSVT3G
NSSSVT3F EQU   NSSSVT3+4
NSSSVT3E EQU   NSSSVT3+3
@NM00043 EQU   NSSSVT3C
NSSSVT3D EQU   NSSSVT3C
NSSSVT3B EQU   NSSSVT3+1
NSSSVT3A EQU   NSSSVT3
NSSSVT   EQU   NSSSVRU+2
NSSSVDAF EQU   NSSSVRU
NSRUHKTY EQU   NSRUHOOK
NSRURCD  EQU   NSRUNETS+2
NSRUSUB  EQU   NSRUNETS+1
NSRUID   EQU   NSRUNETS
SRURSV01 EQU   SRULDID+4
@NM00042 EQU   SRUTYPE
SENRU    EQU   ISTSENRU+4
SRUSNS4  EQU   SRUSENS2+1
SRUSNS3  EQU   SRUSENS2
SRUSNST  EQU   SRUSENS1+1
SRUSNS1  EQU   SRUSENS1
LCPZTRV4 EQU   LCPZSNAM+4
LCPZTRV1 EQU   LCPZSNAM
LCPZSNA  EQU   LCPZTIE+4
LCPZFMCA EQU   LCPZTIE
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTRV620 EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTIRM   EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRV607 EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
BPDCBID  EQU   ISTBPDTY+336
BPDENTRY EQU   ISTBPDTY+144
@NM00066 EQU   BPDTRACE+6
BPDAVNO  EQU   BPDTRACE+4
BPDMQUE  EQU   BPDTRACE+2
BPDMUSE  EQU   BPDTRACE
BPDTRADR EQU   BPDPARM+4
BPDTRID  EQU   BPDPARM+3
@NM00065 EQU   BPDPARM+2
BPDTRLEN EQU   BPDPARM
BPDREQMX EQU   BPDHDR+46
BPDREQCT EQU   BPDHDR+44
BPDRSV01 EQU   BPDFLAG
BPDGTR   EQU   BPDFLAG
BPDATCVT EQU   BPDHDR+36
BPDFBPE  EQU   BPDHDR+32
BPDSMPCB EQU   BPDHDR+28
BPDFEXT  EQU   BPDHDR+24
BPDADRS2 EQU   BPDHDR+20
BPDADRS1 EQU   BPDHDR+16
BPDCHPCB EQU   BPDHDR+8
BPDCHBSZ EQU   BPDHDR+6
BPDCHBNO EQU   BPDHDR+4
BPDBPMAX EQU   BPDHDR+2
BPDBPENT EQU   BPDHDR
BPERSV03 EQU   ISTBPENT+12
BPEBPCB  EQU   ISTBPENT+8
BPEBFSIZ EQU   ISTBPENT+6
BPERSV02 EQU   BPEFLAGS+1
BPEUSRF  EQU   BPEFLAGS+1
BPERSV01 EQU   BPEFLAGS
BPENWS   EQU   BPEFLAGS
BPECBID  EQU   BPEFLAGS
BPEAL48  EQU   BPEFLAGS
BPENFCHP EQU   BPEFLAGS
BPEFIXED EQU   BPEFLAGS
BPEDISP  EQU   BPEFLAGS
BPEFM    EQU   BPEFLAGS
BPEPID   EQU   ISTBPENT
WKECHNGP EQU   WKECHAIN+1
@NM00064 EQU   WKEFLAGS
WKEGATE  EQU   WKEFLAGS
@NM00063 EQU   ISTWKE
BINUSE   EQU   ISTBIND+36
BINUSEL  EQU   ISTBIND+35
BINPRIM  EQU   ISTBIND+27
BINPRIML EQU   ISTBIND+26
BINRSV05 EQU   ISTBIND+25
BINLUTYP EQU   BINLUP
BINRSV27 EQU   BINLUP
BINRSV08 EQU   BINTSU+4
BINPRUSE EQU   BINPRUSZ
BINPRUSM EQU   BINPRUSZ
BINSRUSE EQU   BINSRUSZ
BINSRUSM EQU   BINSRUSZ
BINRPACM EQU   BINRPACE
BINRSV07 EQU   BINRPACE
BINRSV06 EQU   BINTSU
BINCONR  EQU   BINCMNP2
BINRCHN  EQU   BINCMNP2
BINMDIBK EQU   BINCMNP2
BINBKFS  EQU   BINCMNP2
BINRCVR  EQU   BINCMNP2
BINFMTRM EQU   BINCMNP2
BINRSV04 EQU   BINCMNP
BINALT   EQU   BINCMNP
BINBKTR  EQU   BINCMNP
BINBRAK  EQU   BINCMNP
BINFMHD  EQU   BINCMNP
BINRSV03 EQU   BINCMNP
BINSSEB  EQU   BINSECP
BINSCMP  EQU   BINSECP
BINRSV02 EQU   BINSECP
BINSCHNR EQU   BINSECP
BINSMCH  EQU   BINSECP
BINSCHN  EQU   BINSECP
BINPSEB  EQU   BINPRIP
BINPCMP  EQU   BINPRIP
BINRSV01 EQU   BINPRIP
BINPCHNR EQU   BINPRIP
BINPMCH  EQU   BINPRIP
BINPCHN  EQU   BINPRIP
BINFM    EQU   ISTBIND+1
BINTYPE  EQU   BINFMTY
BINFMT   EQU   BINFMTY
BFHDATA  EQU   ISTBFHDR+8
BFHUSED  EQU   ISTBFHDR+6
BFHSIZE  EQU   ISTBFHDR+4
BFHNXCHN EQU   ISTBFHDR
LUNZC001 EQU   LUNZOS+8
LUNLOCK  EQU   LUNZOS
ZIBLNG1  EQU   ZIBFSM
BTUTEXT  EQU   ISTBTU+20
BTUEXTR  EQU   ISTBTU+19
BTURSV02 EQU   BTUSYSTR
BTUPHASE EQU   BTUSYSTR
BTURSV01 EQU   BTUSYSTR
BTUBDU   EQU   ISTBTU+14
BTUPAD   EQU   BTURH+3
BTURH3   EQU   BTURH+2
BTURH2   EQU   BTURH+1
BTURH1   EQU   BTURH
BTUDCF   EQU   BTUBTH+8
BTUZRTSC EQU   BTURQFLG+1
BTUZRT0B EQU   BTURQFLG+1
BTUZRT0A EQU   BTURQFLG+1
BTUZRT09 EQU   BTURQFLG+1
BTUZRT08 EQU   BTURQFLG+1
BTUZRT07 EQU   BTURQFLG
BTUZRT06 EQU   BTURQFLG
BTUZRT05 EQU   BTURQFLG
BTUZRT04 EQU   BTURQFLG
BTUZRT03 EQU   BTURQFLG
BTUZRT02 EQU   BTURQFLG
BTUZRT01 EQU   BTURQFLG
BTUZRT00 EQU   BTURQFLG
BTUSORCE EQU   BTUBTH+4
BTUDEST  EQU   BTUBTH+2
BTUCDF   EQU   BTUFID+1
BTUSCF   EQU   BTUFID+1
BTUPRY   EQU   BTUFID+1
BTUASFL  EQU   BTUFID
BTUPSFL  EQU   BTUFID
BTUMPF   EQU   BTUFID
BTUFIDNO EQU   BTUFID
LHVDATA  EQU   ISTLH+4
LHFUNCT  EQU   ISTLH+3
@NM00053 EQU   ISTLH+2
LHLEN    EQU   ISTLH
BDURSV04 EQU   BDUFLAGS
BDURTOE  EQU   BDUFLAGS
BDUSTPR  EQU   BDUFLAGS
BDURSV03 EQU   BDUFLAGS
BDUALT   EQU   BDUFUNC
BDUNACK  EQU   BDUFUNC
BDUACK   EQU   BDUFUNC
BDUTRPM  EQU   BDUFUNC
BDUFBMI  EQU   BDUFUNC
BDULDGPH EQU   BDUFUNC
BDUHEADP EQU   BDUFUNC
BDUSOH   EQU   BDUCHECK
BDURSV01 EQU   BDUMODIF
BDUMOD0  EQU   BDUMOD1
BDUCOMND EQU   ISTBDU
PIUNIR   EQU   ISTPIU+10
TH2SNF   EQU   ISTTH2+4
TH2OAF   EQU   ISTTH2+3
TH2DAF   EQU   ISTTH2+2
TH2CDF   EQU   TH2FLAG1+1
TH2SEF   EQU   TH2FLAG1+1
TH2PYF   EQU   TH2FLAG1+1
TH2AFI   EQU   TH2FLAG1
TH2PSI   EQU   TH2FLAG1
TH2CMPLI EQU   TH2MPF
TH2RHI   EQU   TH2MPF
TH2FID   EQU   TH2FLAG1
THDCF    EQU   ISTTH+8
THSNF    EQU   ISTTH+6
THOAF    EQU   ISTTH+4
THDAF    EQU   ISTTH+2
THCDF    EQU   THFLGB
THSEF    EQU   THFLGB
THPYF    EQU   THFLGB
THAFI    EQU   THFLGA
THPSI    EQU   THFLGA
THCMPLI  EQU   THMPF
THRHI    EQU   THMPF
THFID    EQU   THFLAG1
NIRRU    EQU   ISTNIR+3
NIRRH    EQU   ISTNIR
NCBRSV01 EQU   ISTNCB+46
NCBSWDAF EQU   ISTNCB+44
NCBDEVCH EQU   ISTNCB+36
NCBFMCBP EQU   ISTNCB+32
NCBLTRC  EQU   ISTNCB+30
NCBRVPT1 EQU   ISTNCB+28
NCBNMLLN EQU   NCBFLAGS+3
@NM00052 EQU   NCBFLAG1
NCBFORCE EQU   NCBFLAG1
NCBTTF   EQU   NCBFLAG1
NCBRSYNC EQU   NCBFLAG1
NCBRSTRT EQU   NCBFLAG1
NCBCONF  EQU   NCBFLAG1
NCBSNAI  EQU   NCBFLAG1
NCBFLTIO EQU   NCBFTRIO
NCBCSTAT EQU   NCBFLAGS
NCBNCSL  EQU   ISTNCB+22
NCBNCBA  EQU   ISTNCB+20
NCBFMCBA EQU   ISTNCB+16
NCBNSNA  EQU   ISTNCB+12
NCBTSKID EQU   ISTNCB+8
NCBRDTE  EQU   ISTNCB+4
NCBLNGTH EQU   ISTNCB+1
NCBTYPE  EQU   ISTNCB
FSBRSV01 EQU   FSBFSB+30
FSBTHCNT EQU   FSBFSB+28
FSBRLRSV EQU   FSBRLSTS
FSBCFTX  EQU   FSBRLSTS
FSBICNCB EQU   FSBMSGID
FSBSSOC  EQU   FSBSS2
FSBSSCC  EQU   FSBSS2
FSBSSDC  EQU   FSBSS2
FSBSSEC  EQU   FSBSS2
FSBSSIR  EQU   FSBSS2
FSBSSCR  EQU   FSBSS2
@NM00050 EQU   FSBSS2
@NM00049 EQU   FSBSS1
FSBSSDE  EQU   FSBSS1
FSBSSUS  EQU   FSBSS1
@NM00048 EQU   FSBSS1
FSBSOHI  EQU   FSBERC
FSBLGI   EQU   FSBERC
FSBLMRI  EQU   FSBFBMI
FSBETI   EQU   FSBERC
FSBEMI   EQU   FSBERC
FSBEBI   EQU   FSBERC
FSBECI   EQU   FSBERC
FSBELI   EQU   FSBERC
FSBXLCI  EQU   FSBXCODE
FSBXFINS EQU   FSBXCODE
FSBXNORM EQU   FSBXFSTS
FSBSCODE EQU   FSBSYSRS
FSBSPHSE EQU   FSBSYSRS
FSBSERR  EQU   FSBSYSRS
FSBCMD   EQU   FSBSEQ
FSBDTRCE EQU   FSBFLAGS
FSBASBTU EQU   FSBFLAGS
FSBINPET EQU   FSBFLAGS
FSBNONCB EQU   FSBFLAGS
FSBLBIND EQU   FSBFLAGS
FSBFFIND EQU   FSBFLAGS
FSBACIND EQU   FSBFLAGS
FSBRFIND EQU   FSBFLAGS
FSBGATE  EQU   FSBFSBA
FSBLATOP EQU   FSBSFLGS
FSBRSV02 EQU   FSBSFLGS
FSBPGBUF EQU   FSBSFLGS
FSBMNSDA EQU   FSBMNRCD
FSBMNOA  EQU   FSBMNRCD
FSBMNDIF EQU   FSBMNRCD
FSBMNEOP EQU   FSBMNRCD
FSBMNDNU EQU   FSBMNRCD
FSBMNATN EQU   FSBMNRCD
FSBMNRVI EQU   FSBMNRCD
FSBMNELI EQU   FSBMNRCD
FSBLNGTH EQU   FSBFSB+1
FDBDATCT EQU   ISTFDB+8
FDBDATAA EQU   ISTFDB+4
FDBFDBA  EQU   ISTFDB
NSRUNA6  EQU   NSRUNA5
RUBDATA  EQU   ISTRUB
ZPSZDFQR EQU   ISTZPSVT+80
ZPSZDFPR EQU   ISTZPSVT+76
ZPSZDFXR EQU   ISTZPSVT+72
ZPSZWRD5 EQU   ISTZPSVT+68
ZPSZWRD4 EQU   ISTZPSVT+64
ZPSZDFMB EQU   ISTZPSVT+60
ZPSZDFMF EQU   ISTZPSVT+56
ZPSZDFNB EQU   ISTZPSVT+52
@NM00041 EQU   ISTZPSVT+48
ZPSZDFF0 EQU   ISTZPSVT+44
ZPSZTRTT EQU   ISTZPSVT+40
ZPSZBFOB EQU   ISTZPSVT+36
ZPSZBFMB EQU   ISTZPSVT+32
ZPSZBFZ0 EQU   ISTZPSVT+28
ZPSZBFY0 EQU   ISTZPSVT+24
ZPSZDFI0 EQU   ISTZPSVT+20
ZPSZDFH0 EQU   ISTZPSVT+12
ZPSZDFD0 EQU   ISTZPSVT+8
ZPSZDFC0 EQU   ISTZPSVT+4
CRACHAIN EQU   ISTCRA+928
CRARSV02 EQU   ISTCRA+924
CRARSV01 EQU   ISTCRA+920
CRABFTBA EQU   CRABUFA
CRAMASK  EQU   CRASVC+64
CRAHSIZ  EQU   CRASVC+60
CRAASCRR EQU   CRASVC
CRAPROCR EQU   ISTCRA+312
CRAPSS   EQU   ISTCRA+160
CRARPH   EQU   ISTCRA+52
CRALAPTR EQU   CRABASIC+48
CRAL9PTR EQU   CRABASIC+44
CRAL8PTR EQU   CRABASIC+40
CRAL7PTR EQU   CRABASIC+36
CRAL6PTR EQU   CRABASIC+32
CRAL5PTR EQU   CRABASIC+28
CRAL4PTR EQU   CRABASIC+24
CRAL3PTR EQU   CRABASIC+20
CRAL2PTR EQU   CRABASIC+16
CRAL1PTR EQU   CRABASIC+12
CRALEV01 EQU   CRALKACT+3
CRALEV02 EQU   CRALKACT+3
CRALEV03 EQU   CRALKACT+3
CRALEV04 EQU   CRALKACT+3
CRALEV05 EQU   CRALKACT+3
CRALEV06 EQU   CRALKACT+3
CRALEV07 EQU   CRALKACT+3
CRALEV08 EQU   CRALKACT+3
CRALEV09 EQU   CRALKACT+2
CRALEV10 EQU   CRALKACT+2
CRALEV11 EQU   CRALKACT+2
CRALEV12 EQU   CRALKACT+2
CRALEV13 EQU   CRALKACT+2
CRALEV14 EQU   CRALKACT+2
CRALEV15 EQU   CRALKACT+2
CRALEV16 EQU   CRALKACT+2
CRALEV17 EQU   CRALKACT+1
CRALEV18 EQU   CRALKACT+1
CRALEV19 EQU   CRALKACT+1
CRALEV20 EQU   CRALKACT+1
CRALEV21 EQU   CRALKACT+1
CRALEV22 EQU   CRALKACT+1
CRALEV23 EQU   CRALKACT+1
CRALEV24 EQU   CRALKACT+1
CRALEV25 EQU   CRALKACT
CRALEV26 EQU   CRALKACT
CRALEV27 EQU   CRALKACT
CRALEV28 EQU   CRALKACT
CRALEV29 EQU   CRALKACT
CRALEV30 EQU   CRALKACT
CRALEV31 EQU   CRALKACT
CRALEV32 EQU   CRALKACT
CRAFRR   EQU   CRAHDR+4
@NM00040 EQU   ISTAPCRR+137
@NM00039 EQU   APC57FLG
APCNREL  EQU   APC57FLG
APCRECRA EQU   APC57FLG
@NM00038 EQU   APC54FLG
APCRLST  EQU   APC54FLG
APCPR153 EQU   APC53FLG
@NM00037 EQU   APC52FLG
APCWKF   EQU   APC52FLG
APCNWF   EQU   APC52FLG
APCRDQ   EQU   APC52FLG
APCQENQ  EQU   APC52FLG
APCSMSR  EQU   APC52FLG
APCCKRQ  EQU   APC52FLG
@NM00036 EQU   APC31FLG
APCSORT  EQU   APC31FLG
APCRESCH EQU   APC31FLG
APCTPXIT EQU   APC31FLG
APCSWTWD EQU   ISTAPCRR+128
APCSAV2  EQU   ISTAPCRR+124
APCSAV1  EQU   ISTAPCRR+120
APCRETCD EQU   APCCOMF+2
@NM00035 EQU   APCCOMF1+1
APCZLBER EQU   APCCOMF1
APCEXIT  EQU   APCCOMF1
APCRELR  EQU   APCCOMF1
APCIRB2  EQU   APCCOMF1
APCIRB1  EQU   APCCOMF1
APCSMCR  EQU   APCCOMF1
APCUETSK EQU   APCCOMF1
APCSSTSK EQU   APCCOMF1
APCESTAL EQU   APCSAVE
APCFRRPM EQU   ISTAPCRR+40
APCQWFO  EQU   ISTAPCRR+36
APCPABSV EQU   ISTAPCRR+32
APCRTRN  EQU   ISTAPCRR+28
APCTCBA  EQU   ISTAPCRR+24
APCPSTA  EQU   ISTAPCRR+20
@NM00034 EQU   APCRFLG+1
APC31R   EQU   APCRFLG
APC58R   EQU   APCRFLG
APC57R   EQU   APCRFLG
APC56R   EQU   APCRFLG
APC54R   EQU   APCRFLG
APC53R   EQU   APCRFLG
APC52R   EQU   APCRFLG
APC51R   EQU   APCRFLG
@NM00033 EQU   APCATFLG+1
APC31E   EQU   APCATFLG
APC58E   EQU   APCATFLG
APC57E   EQU   APCATFLG
APC56E   EQU   APCATFLG
APC54E   EQU   APCATFLG
APC53E   EQU   APCATFLG
APC52E   EQU   APCATFLG
APC51E   EQU   APCATFLG
APCHDRSV EQU   ISTAPCRR
ASCPSREG EQU   ISTASCRR+44
ASCUSR01 EQU   ASCUSRGS+12
ASCUSR00 EQU   ASCUSRGS+8
ASCUSR15 EQU   ASCUSRGS+4
ASCUSR14 EQU   ASCUSRGS
ASCETRYA EQU   ISTASCRR+24
ASCKEY   EQU   ISTASCRR+23
ASCAUDIT EQU   ASCFLG3
ASCFBDUD EQU   ASCFLG3
ASCLLKF  EQU   ASCFLG3
ASCKEYF  EQU   ASCFLG3
ASCFBDAL EQU   ASCFLG3
ASCFSRGT EQU   ASCFLG3
ASCICR   EQU   ASCFLG2
ASCFSRIC EQU   ASCFLG2
ASCFBDIC EQU   ASCFLG2
ASCFBAIC EQU   ASCFLG2
ASCPASTR EQU   ASCFLG1
ASCFSR   EQU   ASCFLG1
ASCFBD   EQU   ASCFLG1
ASCFBA   EQU   ASCFLG1
ASCPFCRR EQU   ISTASCRR
CCFRSVD1 EQU   CFCCRT
CCFCR2   EQU   CFCCRT
CCFCRP   EQU   CFCCRT
CCFCR1   EQU   CFCCRT
CCFCS2   EQU   CFCCRT
CCFCS1   EQU   CFCCRT
NCFRSVD  EQU   CFCNTRD
NCFCR2   EQU   CFCNTRD
NCFCRP   EQU   CFCNTRD
NCFCR1   EQU   CFCNTRD
NCFCS2   EQU   CFCNTRD
NCFCS1   EQU   CFCNTRD
PFCRSV01 EQU   ISTPFCRR+13
PFCFTA   EQU   ISTPFCRR+12
CRRFRR   EQU   PFCFRRO
CRRCHAIN EQU   PFCCRRO
CRRLEN   EQU   PFCCRRLN
PFCRSV10 EQU   PFCCRR+1
CRRID    EQU   PFCCRRID
ZCRRH    EQU   ZCRRHRU
ZCRWORDA EQU   ISTZCRR+477
ZCRCMNRC EQU   ISTZCRR+476
ZCRRSV97 EQU   ZCRENTER+18
ZCREIC2B EQU   ZCRENTER+18
ZCREAC2B EQU   ZCRENTER+18
ZCRELCAB EQU   ZCRENTER+18
ZCREDCMF EQU   ZCRENTER+18
ZCREBCIF EQU   ZCRENTER+18
ZCREICSG EQU   ZCRENTER+18
ZCREDCK0 EQU   ZCRENTER+18
ZCRECFY0 EQU   ZCRENTER+17
ZCREKCCB EQU   ZCRENTER+17
ZCREDCNB EQU   ZCRENTER+17
ZCREICOE EQU   ZCRENTER+17
ZCREBCNB EQU   ZCRENTER+17
ZCREBC0L EQU   ZCRENTER+17
ZCREBCAL EQU   ZCRENTER+17
ZCREDCQR EQU   ZCRENTER+17
ZCREDCPR EQU   ZCRENTER+16
ZCREBCSB EQU   ZCRENTER+16
ZCREAC1R EQU   ZCRENTER+16
ZCRECCCI EQU   ZCRENTER+16
ZCRECCAI EQU   ZCRENTER+16
ZCRECCBI EQU   ZCRENTER+16
ZCREBCAR EQU   ZCRENTER+16
ZCREBCDR EQU   ZCRENTER+16
ZCREBCBR EQU   ZCRENTER+15
ZCREDCXR EQU   ZCRENTER+15
ZCREDCWB EQU   ZCRENTER+15
ZCREDCWR EQU   ZCRENTER+15
ZCREKCCN EQU   ZCRENTER+15
ZCREKCBN EQU   ZCRENTER+15
ZCREKCBB EQU   ZCRENTER+15
ZCREJC0B EQU   ZCRENTER+15
ZCREJCDB EQU   ZCRENTER+14
ZCREJCCB EQU   ZCRENTER+14
ZCREJCBB EQU   ZCRENTER+14
ZCREJCAB EQU   ZCRENTER+14
ZCREIC1B EQU   ZCRENTER+14
ZCREIC0B EQU   ZCRENTER+14
ZCREICX0 EQU   ZCRENTER+14
ZCREICWB EQU   ZCRENTER+14
ZCREICVB EQU   ZCRENTER+13
ZCREICUB EQU   ZCRENTER+13
ZCREICTB EQU   ZCRENTER+13
ZCREICSC EQU   ZCRENTER+13
ZCREICSB EQU   ZCRENTER+13
ZCREICRB EQU   ZCRENTER+13
ZCREICQB EQU   ZCRENTER+13
ZCREICQA EQU   ZCRENTER+13
ZCREICOB EQU   ZCRENTER+12
ZCREICOA EQU   ZCRENTER+12
ZCREICNB EQU   ZCRENTER+12
ZCREICNA EQU   ZCRENTER+12
ZCREICMB EQU   ZCRENTER+12
ZCREICLB EQU   ZCRENTER+12
ZCREICKG EQU   ZCRENTER+12
ZCREICKE EQU   ZCRENTER+12
ZCREICKB EQU   ZCRENTER+11
ZCREICJB EQU   ZCRENTER+11
ZCREICID EQU   ZCRENTER+11
ZCREICIB EQU   ZCRENTER+11
ZCREICHB EQU   ZCRENTER+11
ZCREICGB EQU   ZCRENTER+11
ZCREICEB EQU   ZCRENTER+11
ZCREICDB EQU   ZCRENTER+11
ZCREICCI EQU   ZCRENTER+10
ZCREICCB EQU   ZCRENTER+10
ZCREICBI EQU   ZCRENTER+10
ZCREICBB EQU   ZCRENTER+10
ZCREICAB EQU   ZCRENTER+10
ZCREICAA EQU   ZCRENTER+10
ZCREHCAN EQU   ZCRENTER+10
ZCREGC0B EQU   ZCRENTER+10
ZCREGC0A EQU   ZCRENTER+9
ZCREGCLA EQU   ZCRENTER+9
ZCREGCEB EQU   ZCRENTER+9
ZCREGCDB EQU   ZCRENTER+9
@NM00032 EQU   ZCRENTER+9
ZCREGCBB EQU   ZCRENTER+9
ZCREGCAB EQU   ZCRENTER+9
ZCREFCEB EQU   ZCRENTER+9
ZCREFCEA EQU   ZCRENTER+8
ZCREECTA EQU   ZCRENTER+8
ZCREECEA EQU   ZCRENTER+8
ZCREECDA EQU   ZCRENTER+8
ZCREECCB EQU   ZCRENTER+8
ZCREECCA EQU   ZCRENTER+8
ZCREECBB EQU   ZCRENTER+8
ZCREECBA EQU   ZCRENTER+8
ZCREDCMB EQU   ZCRENTER+7
ZCREDCL0 EQU   ZCRENTER+7
ZCREDCKB EQU   ZCRENTER+7
ZCREDCKA EQU   ZCRENTER+7
ZCREDCJ0 EQU   ZCRENTER+7
ZCREDCI0 EQU   ZCRENTER+7
ZCREDCH0 EQU   ZCRENTER+7
ZCREDCF0 EQU   ZCRENTER+7
ZCREDCE0 EQU   ZCRENTER+6
ZCREDCD0 EQU   ZCRENTER+6
ZCREDCC0 EQU   ZCRENTER+6
ZCREDCB0 EQU   ZCRENTER+6
ZCREDCA0 EQU   ZCRENTER+6
ZCRECC2B EQU   ZCRENTER+6
ZCRECC1B EQU   ZCRENTER+6
ZCRECC1A EQU   ZCRENTER+6
ZCRECC0B EQU   ZCRENTER+5
ZCRECC0A EQU   ZCRENTER+5
ZCREBC0B EQU   ZCRENTER+5
ZCREBC0A EQU   ZCRENTER+5
ZCREBCZ0 EQU   ZCRENTER+5
ZCREBCY0 EQU   ZCRENTER+5
ZCREBCX0 EQU   ZCRENTER+5
ZCREBCXA EQU   ZCRENTER+5
ZCREBCRB EQU   ZCRENTER+4
ZCREBCRA EQU   ZCRENTER+4
ZCREBCQB EQU   ZCRENTER+4
ZCREBCPB EQU   ZCRENTER+4
ZCREBCOB EQU   ZCRENTER+4
ZCREBCNE EQU   ZCRENTER+4
ZCREBCND EQU   ZCRENTER+4
ZCREBCMB EQU   ZCRENTER+3
ZCREBCLB EQU   ZCRENTER+3
ZCREBCLA EQU   ZCRENTER+3
ZCREBCKB EQU   ZCRENTER+3
ZCREBCKA EQU   ZCRENTER+3
ZCREBCJB EQU   ZCRENTER+3
ZCREBCJA EQU   ZCRENTER+3
ZCREBCID EQU   ZCRENTER+3
ZCREBCIB EQU   ZCRENTER+2
ZCREBCIA EQU   ZCRENTER+2
ZCREBCHB EQU   ZCRENTER+2
ZCREBCHA EQU   ZCRENTER+2
ZCREBCGB EQU   ZCRENTER+2
ZCREBCGA EQU   ZCRENTER+2
ZCREBCFB EQU   ZCRENTER+2
ZCREBCFA EQU   ZCRENTER+2
ZCREBCEB EQU   ZCRENTER+1
ZCREBCDI EQU   ZCRENTER+1
ZCREBCCB EQU   ZCRENTER+1
ZCREBCBI EQU   ZCRENTER+1
ZCREBCBB EQU   ZCRENTER+1
ZCREBCBA EQU   ZCRENTER+1
ZCREBCAM EQU   ZCRENTER+1
ZCREBCAI EQU   ZCRENTER+1
ZCREBCAG EQU   ZCRENTER
ZCREBCAE EQU   ZCRENTER
ZCREBCAB EQU   ZCRENTER
ZCREBCAA EQU   ZCRENTER
ZCREAC1B EQU   ZCRENTER
ZCREAC0B EQU   ZCRENTER
ZCREAC0A EQU   ZCRENTER
ZCREAC1A EQU   ZCRENTER
ZCRTNAME EQU   ZCRAUDIT+1
ZCRTID   EQU   ZCRAUDIT
ZCRREMIC EQU   ISTZCRR+436
ZCRSAVEZ EQU   ISTZCRR+196
ZCRDAFSV EQU   ZCRCIDSV+2
ZCRSAFSV EQU   ZCRCIDSV
ZCRR13SV EQU   ISTZCRR+188
ZCRR2SV  EQU   ISTZCRR+184
ZCROPCDE EQU   ISTZCRR+183
ZCRPRMTC EQU   ISTZCRR+182
ZCRRCDSV EQU   ISTZCRR+181
ZCRAWQSW EQU   ISTZCRR+180
ZCRTOPQ  EQU   ISTZCRR+180
ZCRLSTFB EQU   ISTZCRR+180
ZCRXSCHD EQU   ISTZCRR+180
ZCRNXTEL EQU   ISTZCRR+180
ZCRSCANQ EQU   ISTZCRR+180
ZCRMOREL EQU   ISTZCRR+180
ZCRFBPRC EQU   ISTZCRR+180
ZCRFSBSV EQU   ISTZCRR+176
ZCRSVWK5 EQU   ZCRWKARA+16
ZCRSVWK4 EQU   ZCRWKARA+12
ZCRSVWK3 EQU   ZCRWKARA+8
ZCRSVWK2 EQU   ZCRWKARA+4
ZCRSVWK1 EQU   ZCRWKARA
ZCRSVF20 EQU   ZCRSVRTN+76
ZCRSVF18 EQU   ZCRSVRTN+68
ZCRSVF17 EQU   ZCRSVRTN+64
ZCRSVF16 EQU   ZCRSVRTN+60
ZCRSVF15 EQU   ZCRSVRTN+56
ZCRSVF14 EQU   ZCRSVRTN+52
ZCRSVF13 EQU   ZCRSVRTN+48
ZCRSVF12 EQU   ZCRSVRTN+44
ZCRSVF8  EQU   ZCRSVRTN+28
ZCRSVF7  EQU   ZCRSVRTN+24
ZCRSVF6  EQU   ZCRSVRTN+20
ZCRSVF4  EQU   ZCRSVRTN+12
ZCRSVF3  EQU   ZCRSVRTN+8
ZCRSVF2  EQU   ZCRSVRTN+4
ZCRSVF1  EQU   ZCRSVRTN
ZCRPVZB  EQU   ISTZCRR+52
ZCRZLB   EQU   ISTZCRR+48
ZCRBFPTR EQU   ISTZCRR+44
ZCRCCWA  EQU   ISTZCRR+40
ZCRPSW   EQU   ZCRPARMS+15
ZCRPCHAR EQU   ZCRPARMS+14
ZCRPRES2 EQU   ZCRPCOD2
ZCRPMFGF EQU   ZCRPCOD2
ZCRPFHDR EQU   ZCRPCOD2
ZCRPPG2  EQU   ZCRPCOD2
ZCRPRES  EQU   ZCRPCOD1
ZCRPCFTX EQU   ZCRPCOD1
ZCRPLSCB EQU   ZCRPCOD1
ZCRPLSBQ EQU   ZCRPLSBF
ZCRPLNG  EQU   ZCRPCOD1
ZCRPPG   EQU   ZCRPCOD1
ZCRDTODA EQU   ZCRDFRDA
ZCRMLNG  EQU   ZCRPARMS+8
ZCRTBPTR EQU   ZCRPARMS+4
ZCRCBPTR EQU   ZCRFBPTR
ZCRCRLCP EQU   ISTZCRR+20
@NM00031 EQU   ZCRSCPSW
ZCRSKIPT EQU   ZCRSCPSW
ZCRPRCMP EQU   ZCRSCPSW
@NM00030 EQU   ZCRIBPR
ZCR3270R EQU   ZCRIBPR
ZCR3270  EQU   ZCRIBPR
ZCRLCPFD EQU   ZCRIBPR
ZCRLCPFR EQU   ZCRIBPR
ZCRRELK  EQU   ZCRIBPR
ZCRERR   EQU   ZCRIBPR
ZCRNOBUF EQU   ZCRIBPR
@NM00029 EQU   ZCRPFLGS
ZCRQAHED EQU   ZCRPFLGS
ZCRF1RES EQU   ZCRGENSW
ZCRBRIS  EQU   ZCRGENSW
ZCRCLRBD EQU   ZCRGENSW
ZCREXRES EQU   ZCRGENSW
ZCRLCSYN EQU   ZCRGENSW
ZCRRT06  EQU   ZCRGENSW
ZCRTSW2  EQU   ZCRGENSW
ZCRTSW1  EQU   ZCRGENSW
ZCRINLCP EQU   ZCRFLGS3
ZCRWRPTR EQU   ZCRFLGS3
ZCRNOFRE EQU   ZCRFLGS3
ZCREDRIV EQU   ZCRFLGS3
ZCRDISC  EQU   ZCRFLGS3
ZCRTPDIS EQU   ZCRFLGS3
ZCRTPCON EQU   ZCRFLGS3
ZCRTIC   EQU   ZCRFLGS3
ZCRCNLXL EQU   ZCRRESET
ZCRENDAN EQU   ZCRSWFLD
ZCRENDXL EQU   ZCRSWFLD
ZCRENDX  EQU   ZCRSWFLD
ZCROB1   EQU   ZCRNDLCP
ZCRENDPR EQU   ZCRSWFLD
ZCREXTYP EQU   ZCRSWFLD
ZCRSLCP  EQU   ZCRENDSH
ZCRIF0E3 EQU   ZCRFLGS2
ZCRIF0E2 EQU   ZCRFLGS2
ZCRIF0E1 EQU   ZCRFLGS2
ZCROB    EQU   ZCRFLGS2
ZCRFMSED EQU   ZCRFLGS2
ZCRSHEDI EQU   ZCRFLGS2
ZCRLOCAL EQU   ZCRFLGS2
ZCRFEXIT EQU   ZCRFLGS1
ZCRUNSOL EQU   ZCRFLGS1
ZCRENDLP EQU   ZCRFLGS1
ZCRNRMEX EQU   ZCRFLGS1
ZCRWAIT  EQU   ZCRFLGS1
ZCRDEQSW EQU   ZCRFLGS1
ZCRQUESW EQU   ZCRFLGS1
ZCREXSW  EQU   ZCRFLGS1
ZCRFRRA  EQU   ISTZCRR+8
ZCRCHAIN EQU   ISTZCRR+4
ZCRFLAG  EQU   ZCRCRR+3
ZCRLEN   EQU   ZCRCRR+1
ZCRID    EQU   ZCRCRR
LCPCLREP EQU   ISTLCPB+44
LCPUBFSB EQU   LCPFLCCW
LCPRSV77 EQU   ISTLCPB+39
LCPLCCWC EQU   ISTLCPB+38
LCPRSV78 EQU   LCPFLG1
LCPTRANS EQU   LCPFLG1
LCPSTLB  EQU   LCPFLG1
LCPREDRV EQU   LCPFLG1
LCPDIRPT EQU   LCPFLG1
LCPINTER EQU   LCPFLG1
LCPRESET EQU   LCPFLG1
LCPSTYPE EQU   ISTLCPB+36
LCPFSNCH EQU   ISTLCPB+34
LCPFOSN  EQU   ISTLCPB+32
LCPFDB2  EQU   LCPFDBA+1
LCPFDB1  EQU   LCPFDBA
LCPDAF   EQU   LCPCID+2
LCPSAF   EQU   LCPCID
LCPLCCW1 EQU   ISTLCPB+12
LCPRRCNT EQU   LCPSEQ+1
LCPRRCCT EQU   LCPSEQ
LCPATOP  EQU   LCPFLAG2
LCPFREE  EQU   LCPFLAG2
LCPDSTAT EQU   LCPFLAG2
LCPEXRES EQU   LCPFID0
LCPZRIMM EQU   LCPTLBPI
LCPRSTRT EQU   LCPFLAG2
LCPASYN  EQU   LCPFLAG2
LCPPRFLG EQU   LCPFLAG2
LCPZMIRC EQU   LCPRUCNT
LCPCHAI2 EQU   LCPCHAIN+1
LCPCHNG  EQU   LCPCHAI1
LCPZRT0B EQU   LCPMNRCD
LCPZRT0A EQU   LCPMNRCD
LCPZRTL9 EQU   LCPZRT09
LCPZRTL8 EQU   LCPZRT08
LCPZRTL7 EQU   LCPZRT07
LCPZRTL6 EQU   LCPZRT06
LCPZRTL5 EQU   LCPZRT05
LCPZRTL4 EQU   LCPZRT04
LCPZRTL3 EQU   LCPZRT03
LCPZRTL2 EQU   LCPZRT02
LCPZRT01 EQU   LCPFLAGS
LCPZRT00 EQU   LCPFLAGS
LCPLNGTH EQU   ISTLCPB+1
LCPTYPE  EQU   ISTLCPB
RHRSVD5  EQU   RH3
RHRSVD4  EQU   RH3
RHLOG    EQU   RH3
RHRSVD3  EQU   RH3
RHRCDIR  EQU   RH3
RHCDIR   EQU   RH3
RHEB     EQU   RH3
RHBB     EQU   RH3
RHPACE   EQU   RH2
RHRSVD2  EQU   RH2
RHINOP   EQU   RHRSVD1
RHBUSY   EQU   RHRETRY
RHEXCEPT EQU   RH2
RHRRN    EQU   RH2
RHPE     EQU   RH2
RHFME    EQU   RH2
RHCHAIN  EQU   RH1
RHSENSE  EQU   RH1
RHFORMAT EQU   RH1
RHDIRI   EQU   RH1
RHSCI    EQU   RH1
RHTYPE   EQU   RH1
ATCAOS   EQU   ISTATCVT+1584
ATCPOPAB EQU   ATCAOSM+640
ATCVIOPM EQU   ATCAOSM+636
ATCTPMMI EQU   ATCAOSM+632
ATCTPMPB EQU   ATCAOSM+600
ATCRSV88 EQU   ATCAOSM+596
ATCRPLCT EQU   ATCAOSM+594
ATCCRACT EQU   ATCAOSM+592
ATCSRBCT EQU   ATCAOSM+590
ATCRSV75 EQU   ATCAOSM+589
ATCRSV66 EQU   ATCZFLAG
ATCZF001 EQU   ATCZFLAG
ATCTPCP1 EQU   ATCAOSM+584
ATCTPCP0 EQU   ATCAOSM+580
ATCAICTN EQU   ATCAOSM+576
ATCZR01  EQU   ATCAOSM+572
ATCMPLTA EQU   ATCAOSM+568
ATCASCB  EQU   ATCAOSM+564
ATCAP86  EQU   ATCAOSM+560
ATCAP85  EQU   ATCAOSM+556
ATCAP84  EQU   ATCAOSM+552
ATCAP83  EQU   ATCAOSM+548
ATCAP82  EQU   ATCAOSM+544
ATCAP69  EQU   ATCAOSM+540
ATCAP66  EQU   ATCAOSM+536
ATCAP62  EQU   ATCAOSM+532
ATCAPC59 EQU   ATCAOSM+528
ATCAP56  EQU   ATCAOSM+524
ATCAP55  EQU   ATCAOSM+520
ATCRCFY0 EQU   ATCAOSM+516
ATCAP41  EQU   ATCAOSM+512
ATCAPC25 EQU   ATCAOSM+508
ATCAP23  EQU   ATCAOSM+504
ATCTPSPB EQU   ATCAOSM+472
ATCTRMPB EQU   ATCAOSM+440
ATCAPBE  EQU   ATCAOSM+436
ATCPSTA  EQU   ATCAOSM+432
ATCSMABF EQU   ATCAOSM+428
ATCSMAPR EQU   ATCAOSM+424
ATCTPWQA EQU   ATCAOSM+420
ATCSMAID EQU   ATCAOSM+416
ATCSMARA EQU   ATCAOSM+412
ATCCACXA EQU   ATCAOSM+408
ATCZLAAB EQU   ATCAOSM+404
ATCATA10 EQU   ATCAOSM+400
ATCHLTCB EQU   ATCAOSM+396
@NM00028 EQU   ATCVTFLG
ATCVTACT EQU   ATCVTFLG
ATCRPT40 EQU   ATCAOSM+388
ATCRPT39 EQU   ATCAOSM+384
ATCRPT38 EQU   ATCAOSM+380
ATCRPT37 EQU   ATCAOSM+376
ATCRPT36 EQU   ATCAOSM+372
ATCRPT35 EQU   ATCAOSM+368
ATCRPT34 EQU   ATCAOSM+364
ATCRPT33 EQU   ATCAOSM+360
ATCRPT32 EQU   ATCAOSM+356
ATCRPT31 EQU   ATCAOSM+352
ATCRPT30 EQU   ATCAOSM+348
ATCRPT29 EQU   ATCAOSM+344
ATCRPT28 EQU   ATCAOSM+340
ATCRPT27 EQU   ATCAOSM+336
@NM00027 EQU   ATCAOSM+333
@NM00026 EQU   @NM00025
ATCSNUF  EQU   @NM00025
ATCOPKL  EQU   @NM00025
ATCABEN  EQU   @NM00025
ATCAIWT  EQU   ATCAOSM+328
ATCINFDD EQU   ATCAOSM+324
ATCORFMG EQU   ATCAOSM+320
ATCORFRL EQU   ATCAOSM+316
ATCOROBT EQU   ATCAOSM+312
ATCORQG  EQU   ATCORSRB
ATCORTBF EQU   ATCSQAFR
ATCRPLAC EQU   ATCRPLCN+2
ATCRPLRC EQU   ATCRPLCN
ATCCRPLQ EQU   ATCCRPL
ATCSRBAC EQU   ATCSRBCN+2
ATCSRBRC EQU   ATCSRBCN
ATCSRBQ  EQU   ATCSRB
ATCCRAAC EQU   ATCCRACN+2
ATCCRARC EQU   ATCCRACN
ATCCRAQ  EQU   ATCCRA
ATCRPT12 EQU   ATCAOSM+276
ATCDMAPP EQU   ATCAOSM+272
ATCAP38  EQU   ATCAOSM+268
ATCZDFJ0 EQU   ATCAOSM+260
ATCAP51  EQU   ATCAOSM+256
ATCZPAB2 EQU   ATCAOSM+224
ATCZPAB1 EQU   ATCAOSM+192
ATCZLFVT EQU   ATCAOSM+188
ATCZLPVT EQU   ATCAOSM+184
ATCZDVTX EQU   ATCAOSM+180
ATCZDVTA EQU   ATCAOSM+176
ATCZDVT9 EQU   ATCAOSM+172
ATCZDVT8 EQU   ATCAOSM+168
ATCZDVT7 EQU   ATCAOSM+164
ATCRSV56 EQU   ATCDAPVT+22
ATCDAPDG EQU   ATCDAPVT+20
ATCDXCEA EQU   ATCDAPVT+16
ATCDCEA  EQU   ATCDAPVT+12
ATCDPCIA EQU   ATCDAPVT+8
ATCDSIOA EQU   ATCDAPVT+4
ATCDEOEA EQU   ATCDAPVT
ATCZLAEA EQU   ATCLDAPP+16
ATCZLCEA EQU   ATCLDAPP+12
ATCRSV17 EQU   ATCLDAPP+8
ATCSMFRR EQU   ATCLDAPP+4
ATCCDTID EQU   ATCLDAPP
ATCZAEA  EQU   ATCICAPP+16
ATCZCEA  EQU   ATCICAPP+12
ATCCDTCB EQU   ATCICAPP+8
ATCZSIOA EQU   ATCICAPP+4
ATCCDRPH EQU   ATCICAPP
ATCAP65  EQU   ATCAOSM+96
ATCZDVT6 EQU   ATCAOSM+92
ATCZDVT4 EQU   ATCAOSM+88
ATCZDVT3 EQU   ATCAOSM+84
ATCZDVT1 EQU   ATCAOSM+80
ATCICNCB EQU   ATCAOSM+76
ATCZFSVT EQU   ATCAOSM+68
ATCAP64  EQU   ATCAOSM+64
ATCAP63  EQU   ATCAOSM+60
ATCAP61  EQU   ATCAOSM+56
ATCAP58  EQU   ATCAOSM+52
ATCAP57  EQU   ATCAOSM+48
ATCAP54  EQU   ATCAOSM+44
ATCAP53  EQU   ATCAOSM+40
ATCAP52  EQU   ATCAOSM+36
ATCAP12  EQU   ATCAOSM+20
ATCAP11  EQU   ATCAOSM+16
ATCCMTCB EQU   ATCAOSM+12
ATCPRPH  EQU   ATCAOSM+8
ATCGSRBF EQU   ATCGSRBG
ATCSRBRT EQU   ATCAOSM
@NM00024 EQU   @NM00023
ATCVTMAB EQU   @NM00023
@NM00022 EQU   ATCVTBAM
ATCVDLOK EQU   ISTATCVT+904
ATCVFPAB EQU   ISTATCVT+872
ATCVDPAB EQU   ISTATCVT+840
ATCIOECB EQU   ISTATCVT+836
ATCINCW3 EQU   ISTATCVT+832
ATCMODTB EQU   ISTATCVT+828
ATCUSSPT EQU   ISTATCVT+824
ATCSRTAB EQU   ISTATCVT+820
@NM00021 EQU   ISTATCVT+819
@NM00020 EQU   ATCSTAT2
ATCTRSMS EQU   ATCSTAT2
ATCTRLOK EQU   ATCSTAT2
ATCTRPSS EQU   ATCSTAT2
ATCTRESC EQU   ATCSTAT2
ATCTRAPI EQU   ATCSTAT2
ATCNMCTR EQU   ISTATCVT+816
ATCSEC51 EQU   ATCSECST
ATCSEC40 EQU   ATCSIPD+8
ATCSEC30 EQU   ATCSIPD+4
ATCSEC21 EQU   ATCSIPD
ATCSEC10 EQU   ATCSOPD+4
ATCSEC01 EQU   ATCSOPD
ATCPOIA  EQU   ATCRNO+1
@NM00019 EQU   ATCRNO
ATCPODVT EQU   ISTATCVT+784
ATCS49XL EQU   ISTATCVT+780
ATCS49XI EQU   ISTATCVT+776
ATCLCLCT EQU   ATCVLCNT+2
ATCRNCNT EQU   ATCVLCNT
ATCCFEAD EQU   ISTATCVT+768
ATCPTR00 EQU   ISTATCVT+736
ATCRSV10 EQU   ISTATCVT+704
ATCTACB  EQU   ISTATCVT+700
ATCVTINM EQU   ISTATCVT+696
ATCTCLIM EQU   ISTATCVT+692
ATCTCLOM EQU   ISTATCVT+688
ATCVTIPB EQU   ISTATCVT+656
ATCTCIPB EQU   ISTATCVT+624
ATCTIPAB EQU   ISTATCVT+592
ATCOCCCB EQU   ISTATCVT+588
ATCOCCOB EQU   ISTATCVT+584
ATCCDLAD EQU   ISTATCVT+580
ATCCCLAD EQU   ISTATCVT+576
ATCDLRPB EQU   ISTATCVT+544
ATCPGPAB EQU   ISTATCVT+512
ATCVPAB1 EQU   ISTATCVT+480
ATCRSV97 EQU   ISTATCVT+476
ATCRDTLK EQU   ISTATCVT+472
ATCVOCLK EQU   ISTATCVT+468
ATCCDFDN EQU   ISTATCVT+464
ATCCDFIN EQU   ISTATCVT+460
ATCDVTLK EQU   ISTATCVT+456
ATCAP36  EQU   ISTATCVT+452
ATCAP35  EQU   ISTATCVT+448
ATCAP33  EQU   ISTATCVT+444
ATCRSV99 EQU   ISTATCVT+440
ATCONFIG EQU   ISTATCVT+432
ATCNODDS EQU   ISTATCVT+428
ATCNODEL EQU   ISTATCVT+420
ATCRSV69 EQU   ISTATCVT+416
ATCAPCR5 EQU   ISTATCVT+412
ATCLDECB EQU   ISTATCVT+408
ATCLDNCS EQU   ISTATCVT+404
ATCCDPTR EQU   ISTATCVT+400
ATCADEL  EQU   ISTATCVT+396
ATCTODVT EQU   ISTATCVT+392
ATCDEBCH EQU   ISTATCVT+388
ATCHBSIZ EQU   ATCHPGM+2
ATCHBFNO EQU   ATCHPGM
ATCCRME  EQU   ISTATCVT+380
ATCRVCHS EQU   ISTATCVT+372
ATCECTLP EQU   ISTATCVT+368
ATCZDVTB EQU   ISTATCVT+364
ATCECPRT EQU   ISTATCVT+360
ATCVTLOD EQU   ISTATCVT+356
ATCTRPAB EQU   ISTATCVT+352
ATCMSGM  EQU   ISTATCVT+348
ATCMSGP  EQU   ISTATCVT+344
ATCEPT   EQU   ISTATCVT+340
ATCDVT   EQU   ISTATCVT+336
ATCTRCPT EQU   ISTATCVT+332
ATCDVLOD EQU   ISTATCVT+328
ATCALERT EQU   ISTATCVT+324
ATCEPA   EQU   ISTATCVT+320
ATCSAF   EQU   ISTATCVT+318
ATCXRANG EQU   ISTATCVT+317
ATCLAST  EQU   ATCSHRFG
ATCSHRTN EQU   ISTATCVT+308
ATCUEP   EQU   ISTATCVT+304
ATCOCRT  EQU   ISTATCVT+300
ATCCSMA  EQU   ATCCSMR
ATCESC02 EQU   ISTATCVT+292
ATCESC01 EQU   ISTATCVT+288
ATCCDFND EQU   ISTATCVT+284
ATCCDDEL EQU   ISTATCVT+280
ATCCDADD EQU   ISTATCVT+276
ATCMNT   EQU   ISTATCVT+272
ATCRSV16 EQU   ISTATCVT+270
ATCMAXID EQU   ISTATCVT+269
ATCMSGSP EQU   ATCCOM+268
ATCCIDM  EQU   ATCCOM+266
ATCACTRM EQU   ATCCOM+264
ATCNERAP EQU   ATCCOM+260
ATCNESAL EQU   ATCCOM+256
ATCRCC65 EQU   ATCCOM+252
ATCRCC26 EQU   ATCCOM+248
ATCRCC63 EQU   ATCCOM+244
ATCRSV11 EQU   ATCCOM+242
ATCVTMID EQU   ATCCOM+240
ATCAPOST EQU   ATCCOM+236
ATCNERFN EQU   ATCCOM+232
ATCNERNE EQU   ATCCOM+228
ATCNERCV EQU   ATCCOM+224
ATCNERST EQU   ATCCOM+220
ATCDCC61 EQU   ATCCOM+216
ATCDCC60 EQU   ATCCOM+212
ATCSRTDF EQU   ATCCOM+208
ATCSRTAD EQU   ATCCOM+204
ATCFIRA  EQU   ATCCOM+200
ATCSMBQ  EQU   ATCCOM+196
ATCSMRC  EQU   ATCCOM+192
ATCSMQU  EQU   ATCCOM+184
ATCACDA  EQU   ATCCOM+176
ATCSTMA  EQU   ATCCOM+172
ATCFRSTR EQU   ATCCOM+168
ATCGTSTR EQU   ATCCOM+164
ATCREADA EQU   ATCCOM+160
ATCALOAD EQU   ATCCOM+156
ATCBLDLA EQU   ATCCOM+152
ATCFBRPH EQU   ATCCOM+148
ATCBFTRC EQU   ATCCOM+144
ATCTPBUF EQU   ATCTHTRC
ATCREMOV EQU   ATCCOM+136
ATCADD   EQU   ATCCOM+132
ATCDVTPT EQU   ATCCOM+124
ATCFEPT  EQU   ATCCOM+120
ATCFDVT  EQU   ATCCOM+116
ATCCONFT EQU   ATCCOM+112
ATCPTCHA EQU   ATCCOM+108
ATCAUTHA EQU   ATCCOM+104
ATCACCTA EQU   ATCCOM+100
ATCRDTH  EQU   ATCCOM+96
ATCFRSCH EQU   ATCCOM+92
ATCFSB   EQU   ATCCOM+88
ATCHLTMS EQU   ATCCOM+84
ATCECPRM EQU   ATCCOM+80
ATCECNET EQU   ATCCOM+76
ATCECOPC EQU   ATCCOM+72
ATCVPARM EQU   ATCCOM+68
ATCECVRQ EQU   ATCCOM+64
ATCECSES EQU   ATCCOM+60
ATCOCHA  EQU   ATCCOM+56
ATCDSPLQ EQU   ATCCOM+52
ATCECDSP EQU   ATCCOM+48
ATCVARYQ EQU   ATCCOM+44
ATCECVRY EQU   ATCCOM+40
ATCHALTQ EQU   ATCCOM+36
ATCECHLT EQU   ATCCOM+32
ATCMODQ  EQU   ATCCOM+28
ATCECMOD EQU   ATCCOM+24
ATCASCHD EQU   ATCCOM+20
ATCSRT   EQU   ATCCOM+16
ATCRDT   EQU   ATCCOM+12
ATCDCFRR EQU   ATCCOM+8
ATCAPI   EQU   ATCCOM+4
ATCRSV04 EQU   ATCSTAT4
ATCVTTRC EQU   ATCSTAT4
ATCNCSD  EQU   ATCSTAT4
ATCMTST  EQU   ATCSTAT4
ATCTPRT  EQU   ATCSTAT4
ATCPRTAT EQU   ATCSTAT4
@NM00018 EQU   ATCPOFLG
ATCPOUNS EQU   ATCPOFLG
ATCHSDMF EQU   ATCSTFLG
@NM00017 EQU   ATCSTAT1
ATCMDHLT EQU   ATCSTAT1
ATCINHLT EQU   ATCSTAT1
ATCNETSL EQU   ATCSTAT1
ATCQKHLT EQU   ATCSTAT1
ATCSNHLT EQU   ATCSTAT1
ATCACTIV EQU   ATCSTAT1
ATCSTART EQU   ATCSTAT1
RPHNEXPO EQU   ISTRPH+104
RPHSAV16 EQU   RPHWORK+60
RPHSAV15 EQU   RPHWORK+56
RPHSAV14 EQU   RPHWORK+52
RPHSAV13 EQU   RPHWORK+48
RPHSAV12 EQU   RPHWORK+44
RPHSAV11 EQU   RPHWORK+40
RPHSAV10 EQU   RPHWORK+36
RPHSAVE9 EQU   RPHWORK+32
RPHSAVE8 EQU   RPHWORK+28
RPHSAVE7 EQU   RPHWORK+24
RPHSAVE6 EQU   RPHWORK+20
RPHSAVE5 EQU   RPHWORK+16
RPHSAVE4 EQU   RPHWORK+12
RPHSAVE3 EQU   RPHWORK+8
RPHSAVE2 EQU   RPHWORK+4
RPHSHALF EQU   RPHSAVE1+2
RPHSBIT8 EQU   RPHSBITS
RPHSBIT7 EQU   RPHSBITS
RPHSBIT6 EQU   RPHSBITS
RPHSBIT5 EQU   RPHSBITS
RPHSBIT4 EQU   RPHSBITS
RPHSBIT3 EQU   RPHSBITS
RPHSBIT2 EQU   RPHSBITS
RPHSBIT1 EQU   RPHSBITS
RPHSBYTE EQU   RPHSAVE1
RPHPABFG EQU   RPHPABQA
RPHSRP34 EQU   RPHSRPRM+2
RPHSRP12 EQU   RPHSRPRM
RPHWEGT  EQU   RPHCSPA
RPHRESUM EQU   RPHRESMA+1
RPHRSV01 EQU   RPHWPFLG
RPHPURGE EQU   RPHWPFLG
RPHPT    EQU   RPHWPFLG
RPHRSKEY EQU   RPHWPFLG
RPHDVTA  EQU   ISTRPH+12
RPHTIK   EQU   RPHTSKID+3
@NM00016 EQU   RPHTSKID
RPHRPHAP EQU   RPHRPHA+1
@NM00015 EQU   RPHRPHA
RPHGATE  EQU   RPHRPHA
@NM00014 EQU   RPHFLGB
RPHRLCRA EQU   RPHFLGB
RPHNRSAV EQU   RPHFLGB
RPHPGCMP EQU   RPHFLGB
RPHFBAPS EQU   RPHFLGB
RPHBSSP  EQU   RPHFLGB
RPHLOCK  EQU   RPHFLGB
RPHFNFLG EQU   RPHFSTLC
RPHMLTCP EQU   RPHFLAGS
RPHSMCLR EQU   RPHFLAGS
RPHSMTYP EQU   RPHFLAGS
RPHSMQ   EQU   RPHFLAGS
RPHAUTEX EQU   RPHAPTYP
RPHSPGIN EQU   RPHFLAGS
RPHOGIND EQU   RPHFLAGS
RPHLNGTH EQU   RPHCNTL+1
RPHTYPE  EQU   RPHCNTL
DYPPAB   EQU   ISTDYPAB+16
DYPRSV01 EQU   ISTDYPAB+12
DYPTSKID EQU   ISTDYPAB+8
DYPCHAIN EQU   ISTDYPAB+4
DYPFLGS  EQU   ISTDYPAB+2
DYPLNGTH EQU   ISTDYPAB+1
DYPTYPE  EQU   ISTDYPAB
LCCWACI  EQU   LCCWFLAG
LCCWRFI  EQU   LCCWFLAG
LCCWPER  EQU   LCCWLSI
LCCWNTVC EQU   LCCWFLAG
LCCWCKPT EQU   LCCWFLAG
LCCWTYPE EQU   LCCWCTL
LCCWMODE EQU   LCCWCTL
LCCWSOP  EQU   LCCWRWOP
@NM00013 EQU   LCCWRWOP
LCCWSD   EQU   LCCWOP
LCCWSI   EQU   LCCWOP
FMCFLRSV EQU   FMCFLGB
FMCFLGA8 EQU   FMCFLGB
FMCCLRPH EQU   FMCVS1+45
FMCRSV0X EQU   FMCCVFLG
FMCVYRPH EQU   FMCCVFLG
FMCZV004 EQU   FMCVS1+40
FMCLOCK2 EQU   FMCVS1+36
@NM00012 EQU   FMCZFLG2
FMCZF027 EQU   FMCZFLG2
FMCZF026 EQU   FMCZFLG2
FMCSEQ1B EQU   FMCSEQ1
FMCSEQ1T EQU   FMCSEQ1
FMCZX006 EQU   FMCVS1+33
FMCZX005 EQU   FMCVS1+32
FMCZX004 EQU   FMCVS1+31
FMCZX003 EQU   FMCVS1+30
FMCZX002 EQU   FMCVS1+29
FMCZX001 EQU   FMCVS1+28
FMCZV001 EQU   FMCVS1+24
FMCAWATQ EQU   FMCLCPAQ+1
@NM00011 EQU   FMCLCPAQ
FMCLCPB2 EQU   FMCLCPBQ+1
FMCLCPB1 EQU   FMCLCPBQ
FMCASCDQ EQU   FMCSHEAQ+1
@NM00010 EQU   FMCSHEAQ
FMCSHEDQ EQU   FMCVS1+8
FMCZFCSQ EQU   FMCVS1+6
FMCZH001 EQU   FMCVS1+4
FMCZF025 EQU   FMCZFLAG+3
FMCZF024 EQU   FMCZFLAG+3
FMCZF023 EQU   FMCZFLAG+3
FMCZF022 EQU   FMCZFLAG+3
FMCZF021 EQU   FMCZFLAG+3
FMCZF020 EQU   FMCZFLAG+3
FMCZF019 EQU   FMCZFLAG+3
FMCZF018 EQU   FMCZFLAG+3
FMCZF017 EQU   FMCZFLAG+2
FMCZF016 EQU   FMCZFLAG+2
FMCZF015 EQU   FMCZFLAG+2
FMCZF014 EQU   FMCZFLAG+2
FMCZF013 EQU   FMCZFLAG+2
FMCZF012 EQU   FMCZFLAG+2
FMCZF011 EQU   FMCZFLAG+2
FMCZF010 EQU   FMCZFLAG+2
FMCZF00F EQU   FMCZFLAG+1
FMCZF00E EQU   FMCZFLAG+1
FMCZF00D EQU   FMCZFLAG+1
FMCZF00C EQU   FMCZFLAG+1
FMCZF00B EQU   FMCZFLAG+1
FMCRSV10 EQU   FMCZFLAG+1
FMCZF009 EQU   FMCZFLAG+1
FMCZFD06 EQU   FMCZF006+1
FMCZFC06 EQU   FMCZF006
FMCZFB06 EQU   FMCZF006
FMCZFA06 EQU   FMCZF006
FMCZF005 EQU   FMCZFLAG
FMCZF004 EQU   FMCZFLAG
FMCZF003 EQU   FMCZFLAG
FMCZF002 EQU   FMCZFLAG
FMCZF001 EQU   FMCZFLAG
FMCFRESA EQU   ISTFMCB+228
FMCSCSQN EQU   FMCSNCTL+2
FMCSCCTL EQU   FMCSNCTL+1
FMCSTCTL EQU   FMCSCFLG
FMCSCCLO EQU   FMCSCFLG
FMCAPRO  EQU   FMCSCFLG
FMCLURO  EQU   FMCSCFLG
FMCOBSAC EQU   FMCSCFLG
FMCIBSAC EQU   FMCSCFLG
FMCFBRE  EQU   ISTFMCB+220
FMCFBXM  EQU   FMCZV002
FMCASEGQ EQU   ISTFMCB+212
FMCRDTPT EQU   ISTFMCB+208
FMCLOCK  EQU   ISTFMCB+204
FMCSEGD  EQU   FMCSSEGQ
FMCRSPLM EQU   ISTFMCB+198
FMCPSTRS EQU   ISTFMCB+196
@NM00009 EQU   FMCRRESP
FMCTSLHA EQU   FMCRRESP
FMCFRRN  EQU   FMCRRESP
FMCFME   EQU   FMCRRESP
FMCFEX   EQU   FMCRRESP
FMCFPE   EQU   FMCRRESP
FMCCTLB  EQU   ISTFMCB+194
FMCBSQNO EQU   FMCCLSEQ+2
FMCTSQNO EQU   FMCCLSEQ
FMCOBPRG EQU   FMCMODEB
FMCIBPRG EQU   FMCMODEB
FMCRESOT EQU   FMCMODEB
FMCRSTSR EQU   FMCMODEB
FMCLUQ   EQU   FMCMODEB
FMCAPQ   EQU   FMCMODEB
FMCCLEAR EQU   FMCMODEB
FMCHOLD  EQU   FMCMODEB
FMCIPSEQ EQU   ISTFMCB+188
FMCLUSTR EQU   ISTFMCB+187
FMCRSV87 EQU   FMCSTAT2
FMCCPIP  EQU   FMCSTAT2
FMCALIPR EQU   FMCSTAT2
FMCIAIO  EQU   FMCSTAT2
FMCZF00A EQU   FMCSTAT2
FMCVPIP  EQU   FMCSTAT2
FMCBHSET EQU   ISTFMCB+185
FMCPRMRC EQU   FMCCLEXT+20
FMCRSV89 EQU   FMCPSTAT
FMCPCLSD EQU   FMCPSTAT
FMCDDOCD EQU   FMCPSTAT
FMCIDVFD EQU   FMCPSTAT
FMCELKST EQU   FMCPSTAT
FMCRSV88 EQU   FMCPSCMD
FMCRDBLK EQU   FMCPSCMD
FMCDSEOC EQU   FMCPSCMD
FMCPURGE EQU   FMCPSCMD
FMCRESTI EQU   FMCPSCMD
FMCCNTCT EQU   FMCPSCMD
FMCINVT  EQU   FMCPSCMD
FMCFLGB7 EQU   FMCFLGCL
FMCFLGB6 EQU   FMCFLGCL
FMCFLGB5 EQU   FMCFLGCL
FMCFLGB4 EQU   FMCFLGCL
FMCFLGB3 EQU   FMCFLGCL
FMCFLGB2 EQU   FMCFLGCL
FMCFLGB1 EQU   FMCFLGCL
FMCFLGB0 EQU   FMCFLGCL
FMCFLGA7 EQU   FMCFLGA
FMCFLGA6 EQU   FMCFLGA
FMCFLGA5 EQU   FMCFLGA
FMCFLGA4 EQU   FMCFLGA
FMCFLGA3 EQU   FMCFLGA
FMCFLGA2 EQU   FMCFLGA
FMCFLGA1 EQU   FMCFLGA
FMCFLGA0 EQU   FMCFLGA
FMCDCLOK EQU   FMCCLEXT+12
FMCRAFM  EQU   FMCCLEXT+8
FMCFBPTR EQU   FMCFBA+1
FMCFBRSV EQU   FMCFBA
FMCRPLPT EQU   FMCRPLA+1
FMCRPLRS EQU   FMCRPLA
FMCPRCLS EQU   FMCCVAL
FMCIBCE  EQU   FMCCVAL
FMCONLY  EQU   FMCOBCE
FMCLAST  EQU   FMCOBCE
FMCMIDLE EQU   FMCOBCE
FMCFIRST EQU   FMCOBCE
FMCCPCNT EQU   FMCPACPC
FMCMPCNT EQU   FMCPACEM
FMCNPCNT EQU   FMCPACEN
FMCCONF  EQU   FMCSSTAT
FMCPURCH EQU   FMCSSTAT
FMCRVD01 EQU   ISTFMCB+158
FMCSIP   EQU   FMCSIPA
FMCEXLST EQU   ISTFMCB+144
FMCPAB4  EQU   ISTFMCB+112
FMCFASYA EQU   ISTFMCB+60
FMCPROCD EQU   ISTFMCB+48
FMCVWT   EQU   ISTFMCB+44
FMCRPLH  EQU   ISTFMCB+40
FMCBUFNB EQU   FMCCMPS1+2
FMCBUFLM EQU   FMCCMPS1
FMCDEBA  EQU   ISTFMCB+32
@NM00008 EQU   FMCCMDFL
FMCSNA   EQU   FMCCMDFL
FMCVSNA  EQU   FMCCMDFL
FMCCMDR  EQU   FMCCMDFL
@NM00007 EQU   ISTFMCB+30
@NM00006 EQU   FMCSTAT1
FMCLTCLS EQU   FMCSTAT1
FMCHPURG EQU   FMCSTAT1
FMCVSP2  EQU   FMCSTAT1
FMCVSP1  EQU   FMCSTAT
FMCLTEAS EQU   FMCSTAT
FMCZF007 EQU   FMCSTAT
FMCDEDSC EQU   FMCSTAT
FMCDEVOF EQU   FMCSTAT
FMCDAPT  EQU   FMCSTAT
FMCPRMTE EQU   FMCSTAT
FMCPRMTR EQU   FMCSTAT
FMCUSFLD EQU   ISTFMCB+24
FMCFMCBA EQU   ISTFMCB+20
FMCDVTA  EQU   ISTFMCB+12
FMCTSKID EQU   ISTFMCB+8
FMCNXTCB EQU   ISTFMCB+4
FMCLNGTH EQU   ISTFMCB+1
FMCTYPE  EQU   ISTFMCB
PROSRDEF EQU   PROSETM4
PRORSV47 EQU   PROSETM4
PROSCON  EQU   PROSETM4
PRORSV46 EQU   PROSETM3
PROSMONT EQU   PROSETM3
PRORSV45 EQU   PROSETM3
PROSNTO  EQU   PROSETM3
PRORSV44 EQU   PROSETM3
PRORSV43 EQU   PROSETM2
PROSNTFL EQU   PROSETM2
PRORSV42 EQU   PROSETM2
PRORSV41 EQU   PROPROCS
PROMODC  EQU   PROPROC4
PROMODT  EQU   PROPROC4
PROMODM  EQU   PROPROC4
PROMODB  EQU   PROPROC4
PRORSV14 EQU   PROPROC4
PRORSV13 EQU   PROPROC4
PRORSV12 EQU   PROPROC4
PROEIB   EQU   PROPROC4
PROMONT3 EQU   PROPROC3
PROMONT2 EQU   PROPROC3
PROMONIT EQU   PROPROC3
PROSUBLK EQU   PROPROC3
PRONTO   EQU   PROPROC3
PROLGIN  EQU   PROPROC3
PROERPI  EQU   PROPROC3
PRORSV07 EQU   PROPROC3
PROCFTX  EQU   PROPROC2
PROEMLC  EQU   PROPROC2
PRONTFL  EQU   PROPROC2
PRORSV05 EQU   PROPROC2
PRORSV04 EQU   PROPROC2
PROLGOT  EQU   PROPROC2
PROERPO  EQU   PROPROC2
PRORSV03 EQU   PROPROC2
PRORPLC  EQU   PROPROC1
PROCS    EQU   PROPROC1
PROCA    EQU   PROPROC1
PRORESPX EQU   PROPROC1
PRODFASY EQU   PROPROC1
PROXPOPT EQU   PROPROC1
PROTRUNC EQU   PROPROC1
PROASYIP EQU   PROPROC1
DEVRSV03 EQU   ISTDEVCH+5
DEVPHYSA EQU   ISTDEVCH+4
DEVCSLPN EQU   DEVCHAR3
DEVCSTCL EQU   DEVCHAR3
DEVCCHEK EQU   DEVCHAR3
DEVCATTN EQU   DEVCHAR3
DEVCSWL  EQU   DEVFCCTL
DEVCRVB  EQU   DEVFCCTL
DEVCSSL  EQU   DEVFCCTL
DEVCBSC  EQU   DEVFCCTL
DEVMCODE EQU   ISTDEVCH+2
DEVCHAR2 EQU   DEVTCODE
DEVRSV01 EQU   DEVCHAR
DEVCCTL  EQU   DEVCHAR
DEVNNSPT EQU   DEVCHAR
DEVSPS   EQU   DEVCHAR
DEVSUBND EQU   DEVCHAR
DEVCONVR EQU   DEVCHAR
DEVOTPUT EQU   DEVCHAR
DEVINPUT EQU   DEVCHAR
PABRPHA  EQU   PABRPHFG+1
PABNODQ  EQU   PABFLAGS
PABERLOK EQU   PABERRLK
PABSSN   EQU   PABFLAGS
PABDYNAM EQU   PABFLAGS
PABNORPR EQU   PABFLAGS
PABPRIOR EQU   PABFLAGS
PABAPYP  EQU   PABFLAGS
PABDVTA  EQU   ISTPAB+9
PABOFFST EQU   ISTPAB+8
PABRSV02 EQU   PABCHAIN
PABDELAY EQU   PABCHAIN
PABRUNNG EQU   PABCHAIN
PABRESET EQU   PABCHAIN
PABUNCON EQU   PABCHAIN
PABCDP   EQU   PABCHAIN
PABRESCH EQU   PABCHAIN
PABCHNG  EQU   PABCHAIN
PABWEQP  EQU   PABWEQA+1
PABRSV01 EQU   PABWEQA
PABWEQG  EQU   PABWEQA
LOKXCL   EQU   @NM00004
LOKPRY   EQU   @NM00004
@NM00005 EQU   @NM00004
@NM00003 EQU   LOKCHNG
LOKCT    EQU   ISTLOK
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00002 EQU   CVTFIX+248
@NM00001 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTSHSB  EQU   CVTSHS
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00668 EQU   @RC00564
@RC00650 EQU   @RC00564
@RC00618 EQU   @RC00564
@RF00780 EQU   GETFSB
@RT00783 EQU   GETFSB
@RT01140 EQU   ISTA0102
@RC01077 EQU   @RC01076
@RC00620 EQU   @RC00618
@ENDDATA EQU   *
         END   ISTZBFSC,(C'PLS0103',0603,78052)
