         TITLE 'ISTZLFAB/AAB-VS1/MAB-VS2 - ABEND SESSION TERMINATOR    *
                        '
ISTZLFAB CSECT ,                                                   0001
@MAINENT DS    0H                                                  0001
         USING *,@15                                               0001
         B     @PROLOG                                             0001
         DC    AL1(16)                                             0001
         DC    C'ISTZLFAB  78.110'                                 0001
         DROP  @15
@PROLOG  DS    0H                                                  0002
         EJECT
*                                                                  0858
*/********************************************************************/
*/*                                                                  */
*/*ISTZLFAB: BGNSEGMENT (MAIN,VS1/VS2/SVS).                          */
*/*                                                                  */
*/*FUNCTION - WHEN A TASK CONNECTED TO A TERMINAL ABENDS AND THE VTAM*/
*/*    TERMINATION TASK DOES CLOSE DESTINATION PROCESSING TO         */
*/*    DISCONNECT THE SESSION, ISTZLFAB IS GIVEN CONTROL TO INITIATE */
*/*    THE I/O (RESET/DISCONNECT FOR FID0 DEVICES - CLEAR/UNBIND FOR */
*/*    FID1/FID2 (SNA) DEVICES) AND THEN POST THE VTAM TERMINATION   */
*/*    TASK ON THE COMPLETION OF THE I/O.                            */
*/*                                                                  */
*/*  NOTE - THIS MODULE ALSO GETS CONTROL WHEN A QUIESCE IS ISSUED   */
*/*      FOR THE INTELLIGENT CONTROLLER OR AN INOPERATIVE IS RECEIVED*/
*/*      FOR AN LU OR A PU SO THAT ISTZLFAB WILL NOT WAIT FOR        */
*/*      RESPONSES TO ANY I/O WHICH IT MAY HAVE INITIATED.           */
*/*                                                                  */
*/*  DO WHILE THERE ARE ELEMENTS FOR ISTZLFAB TO PROCESS.            */
*/*                                                                  */
*/*    NOTE - THE WORK ELEMENTS FOR ISTZLFAB ARE QUEUED TO A SPECIAL */
*/*        PAB IN THE ATCVT (ATCTPSPB) AND MAY BE LCPB(S) FROM CLOSE */
*/*        DESTINATION PROCESSING, FSB(S) FROM CHANNEL END OR QUIESCE*/
*/*        PROCESSING, OR NCSPL(S) FROM INOPERATIVE PROCESSING-      */
*/*        THERE WILL ALWAYS BE AN ELEMENT FOR ISTZLFAB TO PROCESS   */
*/*        UPON ENTRY.                                               */
*/*                                                                  */
*/*    IF THE WORK ELEMENT IS AN LCPB                                */
*/*      THEN (PROCESS LCPB)                                         */
*/*        CALL CIDRTN TO FIND THE POINTERS TO THE NCB (DNCB OR      */
*/*            LUNCB) AND THE FMCB.                                  */
*/*                                                                  */
*/*        IF AN NCB POINTER WAS FOUND                               */
*/*          THEN                                                    */
*/*            CALL SUB370X TO CHECK FOR THE DEVICE BEING SICK OR TO */
*/*                HANDLE SLOWDOWN CONDITIONS.                       */
*/*            NOTE - IF THE SNA DEVICE IS NOT IN SESSION, THE CALL  */
*/*                TO SUB370X IS NOT MADE.                           */
*/*            IF THE DEVICE IS SICK,THE RECORD MODE DEVICE IS NOT   */
*/*                IN SESSION WITH THE ABENDING APPLICATION OR THE   */
*/*                BASIC MODE DEVICE'S SESSION HAS ALREADY BEEN      */
*/*                PURGED.                                   @ZA29327*/
*/*              THEN (DEVICE SICK OR NOT IN SESSION...DO NOT        */
*/*                  INITIATE I/O)                                   */
*/*                CALL TPQUERTN TO QUEUE THE FSB FOR THE CLOSE      */
*/*                    DESTINATION PROCESSING THUS INDICATING THE    */
*/*                    SESSION NO LONGER EXISTS.             @AS33958*/
*/*              ELSE (DEVICE IS NOT SICK AND IS IN                  */
*/*                  SESSION...INITIATE I/O FOR VTAM TERMINATION     */
*/*                  TASK)                                           */
*/*                CALL BUFFSEG TO DEQUEUE AND FREE THE ELEMENTS ON  */
*/*                    THE FMCB AND DNCB TIPS AND OBTAIN A BUFFER IN */
*/*                    WHICH TO FORMAT THE I/O REQUEST.              */
*/*                CALL PIURTN TO BUILD A PIU FOR THE RESET          */
*/*                    (FID0) OR CLEAR (FID1/FID2).                  */
*/*                ISSUE TPQUE TO QUEUE THE LCPB TO THE ATCVT WAIT   */
*/*                    QUEUE (ATCTPWQA).                             */
*/*                CALL ISTZEFBB (EXTERNAL), THE SHIPOUT ROUTINE,    */
*/*                    TO INITIATE THE I/O.                          */
*/*           NOTE- ISTZEFBA IS CALLED FOR L/3270.                   */
*/*            ENDIF (DEVICE SICK OR NOT IN SESSION).                */
*/*          ELSE (NO NCB POINTER ).                                 */
*/*            CALL TPQUERTN TO QUEUE THE FSB FOR THE CLOSE          */
*/*                DESTINATION PROCESSING THUS INDICATING THAT THE   */
*/*                SESSION NO LONGER EXISTS.                         */
*/*        ENDIF (NCB POINTER FOUND).                                */
*/*                                                                  */
*/*      ELSE (ELEMENT IS NOT AN LCPB)                               */
*/*        IF THE WORK ELEMENT IS A FSB                              */
*/*          THEN (PROCESS FSB)                                      */
*/*            INSET FSBPROC TO PROCESS THE FSB.                     */
*/*                                                                  */
*/*          ELSE (NOT A FSB OR LCPB THUS ELEMENT MUST BE A NCSPL)   */
*/*            CALL INOPRTN TO FIND THE LCPB ASSOCIATED WITH         */
*/*                THE INOPERATIVE BOX FSB AND FREE THE LCPB AND FSB.*/
*/*        ENDIF (WORK ELEMENT IS A FSB).                            */
*/*    ENDIF (WORK ELEMENT IS AN LCPB).                              */
*/*                                                                  */
*/*    IF MORE WORK FOR ISTZLFAB TO DO                               */
*/*      THEN                                                        */
*/*        CALL DEQRTNA TO OBTAIN NEXT WORK ELEMENT.                 */
*/*      ELSE                                                        */
*/*        INDICATE THAT THERE ARE NO ELEMENTS FOR ISTZLFAB TO       */
*/*            PROCESS.                                              */
*/*    ENDIF (MORE WORK FOR ISTZLFAB).                               */
*/*  ENDDO (WHILE ELEMENTS FOR ISTZLFAB TO PROCESS).                 */
*/*                                                                  */
*/*ENDSEGMENT(ISTZLFAB).                                             */
*/*                                                                  */
*/********************************************************************/
*/********************************************************************/
*/*                                                                  */
*/*FSBPROC:BGNSEGMENT(BLOCK).                                        */
*/*                                                                  */
*/*FUNCTION IS TO PROCESS ANY FSB(S) THAT ARE QUEUED TO THE SPECIAL  */
*/*    ABEND 'PAB' IN THE ATCVT.                                     */
*/*                                                                  */
*/*  IF ELEMENT IS A QUIESCE FSB                                     */
*/*    THEN (QUIESCE FSB)                                            */
*/*      CALL INOPRTN TO FIND THE LCPB ASSOCIATED WITH THE           */
*/*          INOPERATIVE BOX AND, IF FOUND, POST THE LCPB.           */
*/*    ELSE (FSB IS IN RESPONSE TO I/O INITIATED BY ISTZLFAB)        */
*/*      INCLUDE WAITQSG TO MATCH THE FSB TO THE ASSOCIATED LCPB ON  */
*/*          THE WAIT QUEUE.                                         */
*/*  ENDIF(ELEMENT IS A QUIESCE FSB).                                */
*/*                                                                  */
*/*ENDSEGMENT(FSBPROC).                                              */
*/********************************************************************/
*/* TPZENTER  AC(LCAB)ZCR(ZCRRPTR)SAVES(ZCRSAVNO)                    */
*                                                                  0858
*   DO;                                                            0858
*                                                                  0858
*/* ATBUILD (ISTZSAVE,ISTZCRR)                                       */
*/* END OF ATBUILD                                                   */
*/* ATBUILD (ISTRPH,ISTCRA)                                          */
*/* END OF ATBUILD                                                   */
*                                                                  0859
*     RFY                                                          0859
*      (GPR00P,                                                    0859
*       GPR01P,                                                    0859
*       GPR02P,                                                    0859
*       GPR03P,                                                    0859
*       GPR04P,                                                    0859
*       GPR05P,                                                    0859
*       GPR06P,                                                    0859
*       GPR07P,                                                    0859
*       GPR12P,                                                    0859
*       GPR13P,                                                    0859
*       GPR15P) RSTD;                                              0859
*     GEN SETS(GPR12P);                                            0860
*                     /* ESTABLISH BASE */
          BALR  GPR12P,0
          USING *,GPR12P
*     DO;                           /* LISATCVT                    0861
*                                      CVTBASE(PAGEABLE,(GPR02P))    */
*       GPR02P=ATCLCPTR;            /* SET UP ATCVT POINTER          */
         L     GPR02P,ATCLCPTR                                     0862
*     END;                          /* LISATCVT                      */
*     GPR03P=GPR01P->RPHCRR;        /* ADDRESS CRA                   */
         L     GPR03P,RPHCRR(,GPR01P)                              0864
*     GPR04P=ADDR(GPR03P->CRAPROCR);/* ADDRESS ZCRR                  */
         LA    GPR04P,CRAPROCR(,GPR03P)                            0865
*     GPR06P=GPR04P;                /* INITIALIZE ZCR POINTER        */
         LR    GPR06P,GPR04P                                       0866
*     GPR05P=LENGTH(ISTZCRR);       /* SETUP ZCRR LENGTH             */
         LA    GPR05P,536                                          0867
*     GPR07P=0;                     /* ZERO REG 7                    */
         SLR   GPR07P,GPR07P                                       0868
*     MVCL(GPR04P,GPR06P);          /* CLEAR ZCRR                    */
         MVCL  GPR04P,GPR06P                                       0869
*     GPR04P=ADDR(GPR03P->CRAPROCR);/* ADDRESS ZCRR                  */
         LA    GPR04P,CRAPROCR(,GPR03P)                            0870
*     GPR04P->ZCRFRRA=GPR03P->CRAFRR;/* SAVE CURRENT FRR POINTER     */
         L     @14,CRAFRR(,GPR03P)                                 0871
         ST    @14,ZCRFRRA(,GPR04P)                                0871
*     GPR03P->CRAFRR=0;             /* CLEAR FRR POINTER             */
         SLR   @14,@14                                             0872
         ST    @14,CRAFRR(,GPR03P)                                 0872
*     GPR04P->ZCRCHAIN=GPR03P->CRACRR;/* SAVE CURRENT CRR            */
         L     @11,CRACRR(,GPR03P)                                 0873
         ST    @11,ZCRCHAIN(,GPR04P)                               0873
*     GPR03P->CRACRR=GPR04P;        /* SET ZCRR AS CURRENT CRR       */
         ST    GPR04P,CRACRR(,GPR03P)                              0874
*     GPR04P->ZCRID=ZCTYPE;         /* INDICATE CRR AS ZCRR          */
         MVI   ZCRID(GPR04P),X'00'                                 0875
*     GPR04P->ZCRLEN=ZCLNG;         /* SET ZCRR LENGTH               */
         MVC   ZCRLEN(2,GPR04P),@CH01547                           0876
*     GPR04P->ZCRTID=ZCRTLCAB;      /* SET THREAD ID                 */
         MVI   ZCRTID(GPR04P),X'13'                                0877
*     GPR04P->ZCRELCAB='1'B;        /* SET MODULE ENTERED            */
         OI    ZCRELCAB(GPR04P),B'00001000'                        0878
*     GPR04P->ZCRTNAME='LCAB';      /* SET THREAD NAME               */
         MVC   ZCRTNAME(4,GPR04P),@CC05359                         0879
*     GPR05P=ADDR(GPR04P->ZCRSAVEZ);/* ADDR 1ST BUFF                 */
         LA    GPR05P,ZCRSAVEZ(,GPR04P)                            0880
*     GPR06P=0;                     /* ADDRESS PREVIOUS BUFFER       */
         LR    GPR06P,@14                                          0881
*     DO GPR00P=ZCRSAVNO TO 1 BY-1; /* INITIALIZE SAVE AREAS         */
         LA    GPR00P,6                                            0882
@DL00882 DS    0H                                                  0883
*       GPR05P->ZSAZSVBC=GPR06P;    /* SET BACK POINTER              */
         ST    GPR06P,ZSAZSVBC(,GPR05P)                            0883
*       GPR05P->ZSAZSVFC=GPR05P+ZSAZSVSZ;/* SET FWRD PTR             */
         LA    @14,40                                              0884
         LR    @11,GPR05P                                          0884
         ALR   @11,@14                                             0884
         ST    @11,ZSAZSVFC(,GPR05P)                               0884
*       GPR06P=GPR05P;              /* PREV. BUFF = CURRENT BUFF     */
         LR    GPR06P,GPR05P                                       0885
*       GPR05P=GPR05P+ZSAZSVSZ;     /* POINT TO NEXT BUFF            */
         ALR   GPR05P,@14                                          0886
*     END;                          /* END SAVE AREA INITIALIZING    */
         BCTR  GPR00P,0                                            0887
         LTR   GPR00P,GPR00P                                       0887
         BP    @DL00882                                            0887
*     GPR06P->ZSAZSVFC=0;           /* SET LAST FWRD POINTER         */
         SLR   @14,@14                                             0888
         ST    @14,ZSAZSVFC(,GPR06P)                               0888
*     GPR13P=ADDR(GPR04P->ZCRSAVEZ);/* ADDRESS SAVE AREA CHAIN       */
         LA    GPR13P,ZCRSAVEZ(,GPR04P)                            0889
*     ZCRRPTR=GPR04P;               /* ADDRESS ZCRR                  */
         LR    ZCRRPTR,GPR04P                                      0890
*     RFY                                                          0891
*      (GPR00P,                                                    0891
*       GPR01P,                                                    0891
*       GPR02P,                                                    0891
*       GPR03P,                                                    0891
*       GPR04P,                                                    0891
*       GPR05P,                                                    0891
*       GPR06P,                                                    0891
*       GPR07P,                                                    0891
*       GPR12P,                                                    0891
*       GPR13P,                                                    0891
*       GPR15P) UNRSTD;                                            0891
*   END;                            /* END TPZENTER GENERATION       */
*   DO WHILE(RPHWEA^=0);            /* LOOP WHILE THERE ARE ELEMENTS
*                                      ON THE PAB FOR ISTZLFAB.      */
         B     @DE00893                                            0893
@DL00893 DS    0H                                                  0894
*     ZCRTSW1=OFF;                  /* INITIALIZE SWITCH TO INDICATE
*                                      FSB HAS NOT BEEN QUEUED.    0894
*                                                            @AS33958*/
         NI    ZCRTSW1(ZCRRPTR),B'01111111'                        0894
*     LCPBPTR=RPHWEA;               /* OBTAIN POINTER TO LCPB.       */
         L     @15,RPHWEA(,RPHAPTR)                                0895
         LR    LCPBPTR,@15                                         0895
*     BFRPTR=RPHWEA;                /* POINT TO THE WORK ELEMENT.    */
         LR    BFRPTR,@15                                          0896
*     IF LCPTYPE=NMLPBTYP THEN      /* IF WORK ELEMENT IS AN LCPB    */
         CLI   LCPTYPE(LCPBPTR),X'27'                              0897
         BNE   @RF00897                                            0897
*       DO;                         /* THEN                          */
*         BFRPTR=0;                 /* ZERO PTR TO WORK ELEMENT.     */
         SLR   BFRPTR,BFRPTR                                       0899
*         ICNCBPTR=LCCWDATA;        /* OBTAIN POINTER TO THE ICNCB.  */
         L     @15,LCPNXLCW(,LCPBPTR)                              0900
         L     ICNCBPTR,LCCWDATA(,@15)                             0900
*         CIDPARM=LCPCID;           /* SET UP PARAMETER FOR CIDCTL.  */
         L     CIDPARM,LCPCID(,LCPBPTR)                            0901
*         CALL CIDRTN;              /* FIND PTRS TO NCB AND FMCB.    */
         BAL   @14,CIDRTN                                          0902
*         IF ICNCBPTR^=NCBPTR THEN  /* IF NCB PTR WAS FOUND  @ZA26631*/
*                                                                  0903
         CR    ICNCBPTR,NCBPTR                                     0903
         BE    @RF00903                                            0903
*           /*********************************************************/
*           /*                                                       */
*           /* &ICNCBPTR->NCBTYPE ^=LDTYPE REMOVED           @ZA26631*/
*           /*                                                       */
*           /*********************************************************/
*                                                                  0904
*           DO;                     /* THEN                          */
*             IF NCBTYPE^=DNTYPE    /* IF SNA DEVICE         @AS33958*/
*                 &FMCSNBI='1'B     /* & NOT IN SESSION              */
*                 &FMCBIP='0'B THEN /* & BIND NOT IN PROGRESS THEN   */
         CLI   NCBTYPE(NCBPTR),X'05'                               0905
         BE    @RF00905                                            0905
         TM    FMCSNBI(FMCBPTR),B'10000000'                        0905
         BNO   @RF00905                                            0905
         TM    FMCBIP(FMCBPTR),B'00001000'                         0905
         BNZ   @RF00905                                            0905
*               ZCRTSW1=ON;         /* INDICATE FSB IS TO BE QUEUED.
*                                                            @AS33958*/
         OI    ZCRTSW1(ZCRRPTR),B'10000000'                        0906
*             ELSE                  /* IF IN SESSION OR SNA DEVICE   */
*               CALL SUB370X;       /* THEN CHECK FOR SICK/SLOWDOWN. */
         B     @RC00905                                            0907
@RF00905 BAL   @14,SUB370X                                         0907
*             IF ZCRTSW1=ON THEN    /* IF FSB IS TO BE QUEUED THEN   */
@RC00905 TM    ZCRTSW1(ZCRRPTR),B'10000000'                        0908
         BNO   @RF00908                                            0908
*               CALL TPQUERTN;      /* QUEUE THE FSB FOR CLSDST.   0909
*                                                            @AS33958*/
         BAL   @14,TPQUERTN                                        0909
*             ELSE                                                 0910
*               DO;                 /* INITIATE I/O FOR CLSDST.      */
*                                                                  0910
         B     @RC00908                                            0910
@RF00908 DS    0H                                                  0911
*                 /***************************************************/
*                 /*                                                 */
*                 /* SEGMENT(BUFFSEG)REQUEST                         */
*                 /*                                                 */
*                 /***************************************************/
*                                                                  0911
*                 DO;                                              0911
*                   GOTO BUFFSEG;                                  0912
         B     BUFFSEG                                             0912
*BUFFSEG#:                                                         0913
*                 END;              /* CLEAN-UP FMCB & DNCB TIPS.    */
BUFFSEG# DS    0H                                                  0914
*                 CALL PIURTN;      /* BUILD RESET/CLEAR PIU.        */
         BAL   @14,PIURTN                                          0914
*                 LCPRSTRT=ON;      /* SET PARTIALLY PROC FLAG ON.   */
         OI    LCPRSTRT(LCPBPTR),B'00100000'                       0915
*/*  TPQUE (LCPBPTR,ATCTPWQA)                                        */
*                                                                  0916
*                 DO;                                              0916
*                   RFY                                            0917
*                    (GPR00P,                                      0917
*                     GPR01P,                                      0917
*                     GPR02P,                                      0917
*                     GPR14P,                                      0917
*                     GPR15P) RSTD;                                0917
*                   GEN REFS(GPR01P) SETS(RPHWORK)                 0918
*                       (STM GPR02P,GPR08P,RPHWORK(GPR01P));       0918
         STM GPR02P,GPR08P,RPHWORK(GPR01P)
*                   GPR15P=LCPBPTR; /* GET WORK ELEM POINTER         */
         LR    GPR15P,LCPBPTR                                      0919
*                   GPR14P=ADDR(ATCTPWQA);/* ADDRESS PAB/QUEUE     0920
*                                      POINTER                       */
         LA    GPR14P,ATCTPWQA(,VTCVTPTR)                          0920
*                   GPR15P=GPR15P|PABWEQG1;                        0921
         O     GPR15P,@CF01716                                     0921
*                   GPR02P=GPR14P->PABWEQA;/* INITIALIZE WITH QUEUE
*                                      HEADER                        */
         L     GPR02P,PABWEQA(,GPR14P)                             0922
*CMZA0026:                                                         0923
*                   ;               /* CS FAIL TARGET                */
CMZA0026 DS    0H                                                  0924
*                   GPR00P=GPR02P;  /* SAVE QUEUE CONTENTS           */
         LR    GPR00P,GPR02P                                       0924
*                   GPR15P->PABCHAIN=GPR02P|PABWEQG1;/* FORWARD CHAIN
*                                      WORK ELEMENT                  */
         LR    @11,GPR02P                                          0925
         O     @11,@CF01716                                        0925
         ST    @11,PABCHAIN(,GPR15P)                               0925
*                   CS(GPR02P,GPR15P,GPR14P->PABWEQA);/* CHECK FOR 0926
*                                      END OF QUEUE                  */
         CS    GPR02P,@15,PABWEQA(GPR14P)                          0926
*                   BC(7,CMZA0026);                                0927
         BC    7,CMZA0026                                          0927
*                   GEN REFS(RPHWORK,GPR01P) NOSETS                0928
*                       (LM    GPR02P,GPR08P,RPHWORK(GPR01P));     0928
         LM    GPR02P,GPR08P,RPHWORK(GPR01P)
*                   RFY                                            0929
*                    (GPR00P,                                      0929
*                     GPR01P,                                      0929
*                     GPR02P,                                      0929
*                     GPR14P,                                      0929
*                     GPR15P) UNRSTD;                              0929
*                 END;              /* *** END OF TPQUE GENERATION 0930
*                                      QUEUE LCPB TO ATCVT WAIT    0930
*                                      QUEUE.                        */
*                 IF ICNCBPTR->NCBTYPE^=LDTYPE THEN/*        @ZA26631
*                                      IF NOT L/3270         @ZA26631*/
         CLI   NCBTYPE(ICNCBPTR),X'07'                             0931
         BE    @RF00931                                            0931
*                   CALL ISTZEFBB;  /* SHIPOUT THE PIU.              */
         L     @14,ATCZFSVT(,VTCVTPTR)                             0932
         L     @15,ZFSZEFBB(,@14)                                  0932
         BALR  @14,@15                                             0932
*                 ELSE              /* ELSE                  @ZA26631*/
*                   CALL ISTZEFBA;  /* SHIPOUT FOR L/3270    @ZA26631*/
         B     @RC00931                                            0933
@RF00931 L     @14,ATCZLFVT(,VTCVTPTR)                             0933
         L     @15,ZLFZEFBA(,@14)                                  0933
         BALR  @14,@15                                             0933
*                 IF NCBTYPE=DNTYPE THEN/* IF A NON-SNA DEVICE THEN  */
@RC00931 CLI   NCBTYPE(NCBPTR),X'05'                               0934
         BNE   @RF00934                                            0934
*/*** START -TPUNLOCK (DNCBLOCK)- **                                 */
*                                                                  0935
*                   DO;                                            0935
*                                                                  0935
*/* ATBUILD (ISTRPH,ISTLOK,ISTCRA)                                   */
*/* END OF ATBUILD                                                   */
*                                                                  0936
*                     RFY                                          0936
*                      (GPR00P,                                    0936
*                       GPR01P,                                    0936
*                       GPR02P,                                    0936
*                       GPR03P,                                    0936
*                       GPR04P,                                    0936
*                       GPR15P) RSTD;                              0936
*                     GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(
*                         RPHWORK);                                0937
         STM GPR00P,GPR15P,RPHWORK(GPR01P)
*                     GPR02P=ADDR(DNCLOCK);/* SET PARAM - LOCKWORD 0938
*                                      PTR                           */
         LA    GPR02P,DNCLOCK(,NCBPTR)                             0938
*                     GPR04P=GPR01P->RPHCRR;/* SET PARAM - ISTCRA PTR*/
         L     GPR04P,RPHCRR(,GPR01P)                              0939
*                     GPR00P=CRALMS05;/* SET PARAM - LOCK LEVEL FLAG */
         LA    GPR00P,16                                           0940
*                     GPR03P=ADDR(GPR04P->CRAL5PTR);/* SET PARAM - 0941
*                                      LOCK LEVEL PTR                */
         LA    GPR03P,CRAL5PTR(,GPR04P)                            0941
*                     DO;           /* LISATCVT                    0942
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*                       GPR15P=ATCLCPTR;/* SET UP ATCVT POINTER      */
         L     GPR15P,ATCLCPTR                                     0943
*                     END;          /* LISATCVT                      */
*                     GPR15P=GPR15P->ATCAP33;                      0945
         L     GPR15P,ATCAP33(,GPR15P)                             0945
*                     DCL                                          0946
*                       FMZL0032 BASED(GPR15P) LABEL VALUERANGE(*);
*                     CALL FMZL0032;                               0947
         BALR  @14,@15                                             0947
*                     GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(
*                         GPR00P,GPR01P,GPR02P,GPR03P,GPR04P,GPR05P,
*                         GPR06P,GPR07P,GPR08P,GPR09P,GPR10P,GPR11P,
*                         GPR12P,GPR13P,GPR14P,GPR15P);            0948
         LM GPR00P,GPR15P,RPHWORK(GPR01P)
*                     RFY                                          0949
*                      (GPR00P,                                    0949
*                       GPR01P,                                    0949
*                       GPR02P,                                    0949
*                       GPR03P,                                    0949
*                       GPR04P,                                    0949
*                       GPR15P) UNRSTD;                            0949
*                   END;                                           0950
*                                                                  0950
*/*** END -TPUNLOCK (DNCBLOCK)- **                                   */
*                                                                  0951
*                                   /* RELEASE THE DNCB LOCK.        */
*                 ELSE                                             0951
*                   ;               /* IT IS A SNA DEVICE.           */
@RF00934 DS    0H                                                  0952
*               END;                /* END INITIATE I/O FOR CLSDST.  */
*           END;                    /* END NCB PTR FOUND AND NOT   0953
*                                      LOCAL 3270.                   */
*         ELSE                      /* IF NO NCB PTR FOUND           */
*           DO;                                                    0954
*                                                                  0954
         B     @RC00903                                            0954
@RF00903 DS    0H                                                  0955
*             /*******************************************************/
*             /*                                                     */
*             /* SEGMENT LCLRTN(REQUEST) DELETED ************        */
*             /*                                             @ZA26631*/
*             /*                                                     */
*             /*******************************************************/
*                                                                  0955
*             CALL TPQUERTN;        /* QUEUE THE FSB FOR CLSDST.     */
         BAL   @14,TPQUERTN                                        0955
*           END;                    /* NO NCB FOUND                  */
*       END;                        /* END LCPB AS WORK ELEMENT.     */
*     ELSE                          /* FSB OR NCSPL AS WORK ELEMENT. */
*       IF RPHWEA->FSBTYPE=FSTYPE THEN/* IF WORK ELEMENT IS A FSB    */
         B     @RC00897                                            0958
@RF00897 L     @15,RPHWEA(,RPHAPTR)                                0958
         CLI   FSBTYPE(@15),X'02'                                  0958
         BNE   @RF00958                                            0958
*         DO;                       /* THEN                          */
*           BFRPTR=RPHWEA-(ADDR(ZIBFSB)-ADDR(ISTZIBUF));/* POINT TO
*                                      THE BEGINNING OF THE BUFFER.  */
         LA    @00,ZIBFSB(,BFRPTR)                                 0960
         SLR   @00,BFRPTR                                          0960
         SLR   @15,@00                                             0960
         LR    BFRPTR,@15                                          0960
*           RFY                                                    0961
*             ISTPIU BASED(ADDR(ZIBBTU));                          0961
*           IF ZIBCPTCC='FF'X THEN  /* IF IT IS A QUIESCE FSB THEN   */
         CLI   ZIBCPTCC(BFRPTR),X'FF'                              0962
         BNE   @RF00962                                            0962
*             CALL INOPRTN;         /* FREE THE LCPB.                */
         BAL   @14,INOPRTN                                         0963
*           ELSE                    /* FSB MUST BE IN RESPONSE TO    */
*             DO;                   /* I/O INITIATED BY ISTZLFAB.    */
         B     @RC00962                                            0964
@RF00962 DS    0H                                                  0965
*               RFY                                                0965
*                 ISTPIU BASED(ADDR(ZOBBTU));                      0965
*               CIDPARM=FSBCID;     /* SET UP PARAMETER FOR CIDCTL.  */
         L     CIDPARM,FSBCID+16(,BFRPTR)                          0966
*               CALL CIDRTN;        /* FIND PTRS TO NCB AND FMCB.    */
*                                                                  0967
         BAL   @14,CIDRTN                                          0967
*               /*****************************************************/
*               /*                                                   */
*               /* SEGMENT(WAITQSG)REQUEST                           */
*               /*                                                   */
*               /*****************************************************/
*                                                                  0968
*               DO;                                                0968
*                 GOTO WAITQSG;                                    0969
         B     WAITQSG                                             0969
*WAITQSG#:                                                         0970
*               END;                /* MATCH THE FSB TO LCPB ON THE
*                                      WAIT QUEUE.                   */
WAITQSG# DS    0H                                                  0971
*             END;                  /* END FSB IN RESPONSE TO I/O  0971
*                                      INITIATED BY ISTZLFAB.        */
*         END;                      /* END WORK ELEMENT IS A FSB.    */
*       ELSE                                                       0973
*         DO;                       /* WORK ELEMENT IS NCSPL @ZA26159*/
         B     @RC00958                                            0973
@RF00958 DS    0H                                                  0974
*           CIDPARM=NCSPLCID;       /* GET NCB ADDRESS       @ZA26159*/
         L     CIDPARM,NCSPLCID(,BFRPTR)                           0974
*           CALL CIDRTN;            /*                       @ZA26159*/
         BAL   @14,CIDRTN                                          0975
*           CALL INOPRTN;           /* FREE THE LCPB.                */
         BAL   @14,INOPRTN                                         0976
*         END;                      /* WORK ELEM IS NCSPL    @ZA26159*/
*     WKREG=ADDR(ADDR(ATCTPSPB)->DYPPAB);/* POINT TO THE TPIOS     0978
*                                      TERMINATION PAB.              */
*                                                                  0978
@RC00958 DS    0H                                                  0978
@RC00897 LA    WKREG,DYPPAB+1384(,VTCVTPTR)                        0978
*     /***************************************************************/
*     /*                                                             */
*     /* THE 4 LINES OF CODE HAVE BEEN DELETED BY OZ29098    @ZA29098*/
*     /* IF WKREG->PABWEQP^=0 THEN IF MORE ELEMENTS FOR ISTZLFAB TO  */
*     /* PROCESS THEN CALL DEQRTNA DEQUEUE THE ELEMENT. ELSE IF MORE */
*     /* ELEMENTS THEN RPHWEA=0 EXIT THE LOOP AND END PROCESSING.    */
*     /*                                                             */
*     /***************************************************************/
*                                                                  0979
*     RPHWEA=0;                     /* INIT WORK ELE PTR     @ZA29098*/
         SLR   @00,@00                                             0979
         ST    @00,RPHWEA(,RPHAPTR)                                0979
*     BFRPTR=WKREG->PABWEQP;        /* GET IST PAB ELEMENT   @ZA29098*/
         L     BFRPTR,PABWEQP-1(,WKREG)                            0980
         LA    BFRPTR,0(,BFRPTR)                                   0980
*     LCPBPTR=BFRPTR;               /* INIT FOR LOOP         @ZA29098*/
         LR    LCPBPTR,BFRPTR                                      0981
*     DO WHILE                      /* CHECK UNTIL FSB FOUND @ZA29098*/
*           LCPBPTR^=0;             /* OR END WORK ELE CHAIN @ZA29098*/
         B     @DE00982                                            0982
@DL00982 DS    0H                                                  0983
*       IF BFRPTR->FSBTYPE=FSTYPE THEN/* IF FSB FOUND        @ZA29098*/
         CLI   FSBTYPE(BFRPTR),X'02'                               0983
         BNE   @RF00983                                            0983
*         DO;                                                      0984
*                                                                  0984
*/* TPDEQ (BFRPTR,WKREG->ISTPAB)                                     */
*                                                                  0985
*           DO;                     /* BEGIN TPDEQ CODE GENERATION   */
*             DCL                                                  0986
*               FMZCA043 BIT(32) CONSTANT('80000000'X);            0986
*             DCL                                                  0987
*               FMZCB043 BIT(32) CONSTANT('7FFFFFFF'X);            0987
*             RFY                                                  0988
*              (GPR00P,                                            0988
*               GPR01P,                                            0988
*               GPR14P,                                            0988
*               GPR15P) RSTD;                                      0988
*             RFY                                                  0989
*               ISTWKE;                                            0989
*             GPR15P=ADDR(WKREG->ISTPAB);/* ADDRESS QUEUE POINTER    */
         LR    GPR15P,WKREG                                        0990
*             RFY                                                  0991
*              (GPR02P,                                            0991
*               GPR03P) RSTD;                                      0991
*             STM(GPR02P,GPR03P,GPR01P->RPHWORK(5:12));            0992
         STM   GPR02P,GPR03P,RPHWORK+4(GPR01P)                     0992
*             GPR03P=BFRPTR|FMZCA043;                              0993
         L     @11,@CF01716                                        0993
         LR    GPR03P,BFRPTR                                       0993
         OR    GPR03P,@11                                          0993
*             GPR14P=FMZCA043;                                     0994
         LR    GPR14P,@11                                          0994
*             GPR15P=ADDR(GPR15P->PABWEQA);                        0995
*             GPR02P=GPR15P->PABWEQA|FMZCA043;                     0996
         O     @11,PABWEQA(,GPR15P)                                0996
         LR    GPR02P,@11                                          0996
*             DO WHILE(GPR02P^=GPR14P);                            0997
         B     @DE00997                                            0997
@DL00997 DS    0H                                                  0998
*FMZL2043:                                                         0998
*               ;                                                  0998
FMZL2043 DS    0H                                                  0999
*               IF GPR02P=GPR03P THEN                              0999
         CR    GPR02P,GPR03P                                       0999
         BNE   @RF00999                                            0999
*                 DO;                                              1000
*                   GPR00P=GPR02P->WKECHAIN;                       1001
         L     GPR00P,WKECHAIN(,GPR02P)                            1001
*                   CS(GPR02P,GPR00P,GPR15P->PABWEQA);             1002
         CS    GPR02P,@00,PABWEQA(GPR15P)                          1002
*                   BC(7,FMZL3043);                                1003
         BC    7,FMZL3043                                          1003
*                   GPR14P=GPR02P;                                 1004
         LR    GPR14P,GPR02P                                       1004
*                   GPR14P->WKECHAIN=0;                            1005
         SLR   @11,@11                                             1005
         ST    @11,WKECHAIN(,GPR14P)                               1005
*                 END;                                             1006
*               ELSE                                               1007
*                 DO;                                              1007
         B     @RC00999                                            1007
@RF00999 DS    0H                                                  1008
*                   IF(GPR02P->WKECHAIN)=GPR14P THEN               1008
         L     @11,WKECHAIN(,GPR02P)                               1008
         CR    @11,GPR14P                                          1008
         BE    @RT01008                                            1008
*                     GOTO ISTA0043;                               1009
*                   ELSE                                           1010
*                     DO;                                          1010
*                       GPR15P=ADDR(GPR02P->WKECHAIN);             1011
         LA    GPR15P,WKECHAIN(,GPR02P)                            1011
*                       GPR02P=GPR02P->WKECHAIN;                   1012
         LR    GPR02P,@11                                          1012
*                       GOTO FMZL2043;                             1013
         B     FMZL2043                                            1013
*                     END;                                         1014
*                 END;                                             1015
*FMZL3043:                                                         1016
*               ;                                                  1016
@RC00999 DS    0H                                                  1016
FMZL3043 DS    0H                                                  1017
*             END;                                                 1017
@DE00997 CR    GPR02P,GPR14P                                       1017
         BNE   @DL00997                                            1017
*ISTA0043:                                                         1018
*             ;                                                    1018
ISTA0043 DS    0H                                                  1019
*             LM(GPR02P,GPR03P,GPR01P->RPHWORK(5:12));             1019
         LM    GPR02P,GPR03P,RPHWORK+4(GPR01P)                     1019
*             RFY                                                  1020
*              (GPR02P,                                            1020
*               GPR03P) UNRSTD;                                    1020
*             GPR14P=GPR14P&FMZCB043;                              1021
         N     GPR14P,@CF01714                                     1021
*             GPR01P->RPHWEA=GPR14P;                               1022
         ST    GPR14P,RPHWEA(,GPR01P)                              1022
*             RFY                                                  1023
*              (GPR00P,                                            1023
*               GPR01P,                                            1023
*               GPR14P,                                            1023
*               GPR15P) UNRSTD;                                    1023
*           END;                    /* END TPDEQ GENERATION DEQ FSB
*                                      FORM PAB              @ZA29098*/
*           LCPBPTR=0;              /* GET OUT OF LOOP       @ZA29098*/
         SLR   LCPBPTR,LCPBPTR                                     1025
*         END;                      /*                       @ZA29098*/
*       ELSE                        /*                       @ZA29098*/
*         DO;                       /* FSB NOT FOUND         @ZA29098*/
         B     @RC00983                                            1027
@RF00983 DS    0H                                                  1028
*           BFRPTR=BFRPTR->FSBFSBA& /* GET NEXT WORK ELE     @ZA29098*/
*               MASKWRD;            /* ZERO HIGH ORDER BYTE  @ZA29098*/
         L     @00,FSBFSBA(,BFRPTR)                                1028
         N     @00,@CF05307                                        1028
         LR    BFRPTR,@00                                          1028
*           LCPBPTR=BFRPTR;         /* SET UP TO CHECK FOR   @ZA29098*/
         LR    LCPBPTR,BFRPTR                                      1029
*         END;                      /* WORK ELEMENT          @ZA29098*/
*     END;                          /* END CHECKING FOR FSB  @ZA29098*/
@RC00983 DS    0H                                                  1031
@DE00982 SLR   @15,@15                                             1031
         CR    LCPBPTR,@15                                         1031
         BNE   @DL00982                                            1031
*     IF RPHWEA=0 THEN              /* IF FSB NOT FOUND      @ZA29098*/
         C     @15,RPHWEA(,RPHAPTR)                                1032
         BNE   @RF01032                                            1032
*       CALL DEQRTNA;               /* DEQ LCPB,IF ANY       @ZA29098*/
         BAL   @14,DEQRTNA                                         1033
*   END;                            /* END LOOP.                     */
@RF01032 DS    0H                                                  1034
@DE00893 L     @00,RPHWEA(,RPHAPTR)                                1034
         LTR   @00,@00                                             1034
         BNZ   @DL00893                                            1034
*/* TPEXIT  NORM                                                     */
*                                                                  1035
*   DO;                                                            1035
*     RESPECIFY                                                    1036
*       GPR15P RSTD;                                               1036
*                                                                  1036
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTATCVT)                               */
*/* END OF ATBUILD                                                   */
*                                                                  1037
*     DO;                           /* LISATCVT                    1037
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*       GPR15P=ATCLCPTR;            /* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     1038
*     END;                          /* LISATCVT                      */
*     RESPECIFY                                                    1040
*       GPR00F RSTD;                                               1040
*     GPR00F=4;                     /* SET PARAMETER REGISTER TO 4   */
         LA    GPR00F,4                                            1041
*     GPR15P=GPR15P->ATCAP31;                                      1042
         L     GPR15P,ATCAP31(,GPR15P)                             1042
*     DCL                                                          1043
*       FMZL0049 BASED(GPR15P) LABEL VALUERANGE(*);                1043
*     CALL FMZL0049;                                               1044
         BALR  @14,@15                                             1044
*     RESPECIFY                                                    1045
*      (GPR00F,                                                    1045
*       GPR15P) UNRSTD;                                            1045
*   END;                            /* **** END OF TPEXIT EXIT     1046
*                                      ISTZLFAB.                     */
         EJECT
*                                                                  1047
*/********************************************************************/
*/*                                                                  */
*/*SUB370X: BGNSEGMENT (SUBROUTINE).                                 */
*/*                                                                  */
*/*FUNCTION IS TO CHECK                                              */
*/*    1) IF THE DEVICE (LU OR PU) IS SICK  OR                       */
*/*    IF PURGE HAS ALREADY COMPLETED FOR A BASIC DEVICE.    @ZA29327*/
*/*    2) IF ANY COMMUNICATIONS CONTROLLER IS SICK OR IN AUTO NETWORK*/
*/*    SHUTDOWN                                                      */
*/*    3) IF THE NCP IS IN SLOWDOWN MODE AND, IF SO, WAIT UNTIL THE  */
*/*    NCP IS OUT OF SLOWDOWN.                                       */
*/*                                                                  */
*/*  IF THE DEVICE (PU OR LU) IS SICK OR IT'S SESSION HAS ALREADY    */
*/*    BEEN PURGED     THEN                                          */
*/*      INDICATE THAT ISTZLFAB IS TO QUEUE A FSB FOR THE CLOSE      */
*/*          DESTINATION PROCESSING TO INDICATE THE SESSION IS       */
*/*          TERMINATED (NO I/O WILL BE INITIATED).          @AS33958*/
*/*    ELSE (PU OR LU NOT SICK)                                      */
*/*      DO WHILE THERE ARE COMMUNICATIONS CONTROLLER(S) IN THE      */
*/*          PATH.                                                   */
*/*        IF THE COMMUNICATIONS CONTROLLER IS SICK OR IN AUTO       */
*/*             NETWORK SHUTDOWN                                     */
*/*          THEN                                                    */
*/*            INDICATE THAT ISTZLFAB IS TO QUEUE A FSB FOR THE      */
*/*                CLOSE DESTINATION PROCESSING TO INDICATE THE      */
*/*                SESSION IS TERMINATED (NO I/O WILL BE             */
*/*                INITIATED).                               @AS33958*/
*/*          ELSE (CHECK FOR SLOWDOWN)                               */
*/*            IF ANY COMMUNICATIONS CONTROLLER IN THE PATH IS IN    */
*/*                SLOWDOWN MODE                                     */
*/*              THEN                                                */
*/*                ISSUE TPQUE TO QUEUE THE ACTIVE RPH TO THE        */
*/*                    SLOWDOWN PAB IN THE ICNCB TO WAIT FOR         */
*/*                    SLOWDOWN EXIT.                                */
*/*                NOTE - THE RPH WILL AGAIN BECOME ACTIVE AFTER     */
*/*                    EXIT.                                         */
*/*                ISSUE TPWAIT TO WAIT FOR THE TERMINATION OF       */
*/*                    SLOWDOWN.                                     */
*/*                RESUME PROCESSING WITH THE FIRST COMMUNICATION    */
*/*                    CONTROLLER IN THE PATH.                       */
*/*            ENDIF (CMMUNICATIONS CONTROLLER IN SLOWDOWN MODE).    */
*/*        ENDIF (COMMUNICATIONS CONTROLLER IS SICK OR IN SHUTDOWN). */
*/*      ENDDO (WHILE THERE ARE COMMUNICATION CONTROLLER(S) IN PATH).*/
*/*  ENDIF (DEVICE (PU OR LU) IS SICK).                              */
*/*                                                                  */
*/*ENDSEGMENT (SUB370X).                                             */
*/*                                                                  */
*/********************************************************************/
*                                                                  1047
*SUB370X:                                                          1047
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1047
         B     @PB00002                                            1047
SUB370X  DS    0H                                                  1048
*   RFY                                                            1048
*     REG14 RSTD;                                                  1048
*   ZCRSVF2=REG14;                  /* SAVE THE RETURN ADDRESS.      */
         ST    REG14,ZCRSVF2(,ZCRRPTR)                             1049
*   RFY                                                            1050
*     REG14 UNRSTD;                                                1050
*   IF FMCCONF=ON|(LCPFDBA^=0&LCPFDBA->NCBCONF=ON)|/* IF DEVICE      */
*       FMCDEVOF=ON THEN            /* (PU OR LU) SICK OR SESSION IS
*                                      DEAD                  @ZA29327*/
         TM    FMCCONF(FMCBPTR),B'00000001'                        1051
         BO    @RT01051                                            1051
         L     @15,LCPFDBA(,LCPBPTR)                               1051
         LTR   @15,@15                                             1051
         BZ    @GL00002                                            1051
         TM    NCBCONF(@15),B'01000000'                            1051
         BO    @RT01051                                            1051
@GL00002 TM    FMCDEVOF(FMCBPTR),B'00010000'                       1051
         BNO   @RF01051                                            1051
@RT01051 DS    0H                                                  1052
*     ZCRTSW1=ON;                   /* INDICATE FSB IS TO BE QUEUED.
*                                                            @AS33958*/
         OI    ZCRTSW1(ZCRRPTR),B'10000000'                        1052
*   ELSE                            /* IF DEVICE (PU OR LU) NOT SICK */
*     IF ICNCBPTR->NCBTYPE^=LDTYPE THEN/*                    @ZA26631
*                                      IF NOT L/3270         @ZA26631*/
         B     @RC01051                                            1053
@RF01051 CLI   NCBTYPE(ICNCBPTR),X'07'                             1053
         BE    @RF01053                                            1053
*       DO;                         /* THEN                          */
*         WKREG=ADDR(ISTICNCB);     /* INIT PTR TO ICNCB FOR LOOP.   */
         LR    WKREG,ICNCBPTR                                      1055
*         DO WHILE(WKREG^=0);       /* CHECK EACH COMMUNICATIONS   1056
*                                      CONTROLLER IN THE PATH TO SEE
*                                      IF IT IS SICK OR IN AUTO    1056
*                                      NETWORK SHUTDOWN.             */
         B     @DE01056                                            1056
@DL01056 DS    0H                                                  1057
*           RFY                                                    1057
*             ISTICNCB BASED(WKREG);                               1057
*           RFY                                                    1058
*             ISTNCB BASED(WKREG);                                 1058
*           IF NCBCONF=ON|ICNZF010=ON THEN/* IF THE COMMUNICATIONS 1059
*                                      CONTROLLER IS SICK OR IN AUTO
*                                      NETWORK SHUTDOWN THEN         */
         TM    NCBCONF(WKREG),B'01000000'                          1059
         BO    @RT01059                                            1059
         TM    ICNZF010(WKREG),B'00010000'                         1059
         BNO   @RF01059                                            1059
@RT01059 DS    0H                                                  1060
*             DO;                                                  1060
*               ZCRTSW1=ON;         /* INDICATE FSB IS TO BE QUEUED.
*                                                            @AS33958*/
         OI    ZCRTSW1(ZCRRPTR),B'10000000'                        1061
*               WKREG=0;            /* EXIT LOOP.                    */
         SLR   WKREG,WKREG                                         1062
*             END;                                                 1063
*           ELSE                    /* IF NOT SICK OR IN AUTO NETWORK
*                                      SHUTDOWN THEN                 */
*             IF ICNSLOW=ON THEN    /* IF COMMUNICATIONS CONTROLLER
*                                      IS IN SLOWDOWN THEN           */
         B     @RC01059                                            1064
@RF01059 TM    ICNSLOW(WKREG),B'00001000'                          1064
         BNO   @RF01064                                            1064
*               DO;                                                1065
*                 FMCZF003=ON;      /* TURN ON THE TPIOS WAIT FLAG.  */
         OI    FMCZF003(FMCBPTR),B'00100000'                       1066
*/*  TPQUE (RPHAPTR,ICNZPAB1)                                        */
*                                                                  1067
*                 DO;                                              1067
*                   RFY                                            1068
*                    (GPR00P,                                      1068
*                     GPR01P,                                      1068
*                     GPR02P,                                      1068
*                     GPR14P,                                      1068
*                     GPR15P) RSTD;                                1068
*                   GEN REFS(GPR01P) SETS(RPHWORK)                 1069
*                       (STM GPR02P,GPR08P,RPHWORK(GPR01P));       1069
         STM GPR02P,GPR08P,RPHWORK(GPR01P)
*                   GPR15P=RPHAPTR; /* GET WORK ELEM POINTER         */
         LR    GPR15P,RPHAPTR                                      1070
*                   GPR14P=ADDR(ICNZPAB1);/* ADDRESS PAB/QUEUE     1071
*                                      POINTER                       */
         LA    GPR14P,ICNZPAB1(,WKREG)                             1071
*                   GPR15P=GPR15P|PABWEQG1;                        1072
         O     GPR15P,@CF01716                                     1072
*                   GPR02P=GPR14P->PABWEQA;/* INITIALIZE WITH QUEUE
*                                      HEADER                        */
         L     GPR02P,PABWEQA(,GPR14P)                             1073
*CMZA0057:                                                         1074
*                   ;               /* CS FAIL TARGET                */
CMZA0057 DS    0H                                                  1075
*                   GPR00P=GPR02P;  /* SAVE QUEUE CONTENTS           */
         LR    GPR00P,GPR02P                                       1075
*                   GPR15P->PABCHAIN=GPR02P|PABWEQG1;/* FORWARD CHAIN
*                                      WORK ELEMENT                  */
         LR    @11,GPR02P                                          1076
         O     @11,@CF01716                                        1076
         ST    @11,PABCHAIN(,GPR15P)                               1076
*                   CS(GPR02P,GPR15P,GPR14P->PABWEQA);/* CHECK FOR 1077
*                                      END OF QUEUE                  */
         CS    GPR02P,@15,PABWEQA(GPR14P)                          1077
*                   BC(7,CMZA0057);                                1078
         BC    7,CMZA0057                                          1078
*                   GEN REFS(RPHWORK,GPR01P) NOSETS                1079
*                       (LM    GPR02P,GPR08P,RPHWORK(GPR01P));     1079
         LM    GPR02P,GPR08P,RPHWORK(GPR01P)
*                   RFY                                            1080
*                    (GPR00P,                                      1080
*                     GPR01P,                                      1080
*                     GPR02P,                                      1080
*                     GPR14P,                                      1080
*                     GPR15P) UNRSTD;                              1080
*                 END;              /* *** END OF TPQUE GENERATION 1081
*                                      QUEUE THE RPH TO THE SLOWDOWN
*                                      PAB.                          */
*/*  TPWAIT                                                          */
*                                                                  1082
*                 DO;               /* BEGIN TPWAIT GENERATION       */
*                   RFY                                            1083
*                    (GPR01P,                                      1083
*                     GPR14P,                                      1083
*                     GPR15P) RSTD;                                1083
*                   RFY                                            1084
*                    (GPR00P) RSTD;                                1084
*                   GEN(STM   GPR00P,GPR15P,RPHWORK(GPR01P))       1085
*                   REFS(GPR00P,GPR01P,GPR15P) SETS(RPHWORK);      1085
         STM   GPR00P,GPR15P,RPHWORK(GPR01P)
*                   RFY                                            1086
*                    (GPR00P) UNRSTD;                              1086
*                   GPR15P=ADDR(LHAA0063);                         1087
         LA    GPR15P,LHAA0063                                     1087
*                   GPR14P=0;                                      1088
         SLR   GPR14P,GPR14P                                       1088
*                   GPR15P=GPR15P&'00FFFFFF'X;                     1089
         N     GPR15P,@CF05307                                     1089
*                   GPR15P=GPR15P|RPHWT1;                          1090
         O     GPR15P,@CF01675                                     1090
*                   CS(GPR14P,GPR15P,GPR01P->RPHRESMA);            1091
         CS    GPR14P,@15,RPHRESMA(GPR01P)                         1091
*                   BC(7,LHAB0063);                                1092
*                                                                  1092
         BC    7,LHAB0063                                          1092
*/* TPEXIT  NONE                                                     */
*                                                                  1093
*                   DO;                                            1093
*                     RESPECIFY                                    1094
*                       GPR15P RSTD;                               1094
*                                                                  1094
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTATCVT)                               */
*/* END OF ATBUILD                                                   */
*                                                                  1095
*                     DO;           /* LISATCVT                    1095
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*                       GPR15P=ATCLCPTR;/* SET UP ATCVT POINTER      */
         L     GPR15P,ATCLCPTR                                     1096
*                     END;          /* LISATCVT                      */
*                     RESPECIFY                                    1098
*                       GPR00F RSTD;                               1098
*                     GPR00F=0;     /* SET PARAMETER REGISTER TO 0   */
         SLR   GPR00F,GPR00F                                       1099
*                     GPR15P=GPR15P->ATCAP31;                      1100
         L     GPR15P,ATCAP31(,GPR15P)                             1100
*                     DCL                                          1101
*                       FMZL0068 BASED(GPR15P) LABEL VALUERANGE(*);
*                     CALL FMZL0068;                               1102
         BALR  @14,@15                                             1102
*                     RESPECIFY                                    1103
*                      (GPR00F,                                    1103
*                       GPR15P) UNRSTD;                            1103
*                   END;            /* **** END OF TPEXIT            */
*LHAB0063:                                                         1105
*                   ;                                              1105
LHAB0063 DS    0H                                                  1106
*                   GPR01P->RPHRESMA=0;                            1106
         SLR   @15,@15                                             1106
         ST    @15,RPHRESMA(,GPR01P)                               1106
*                   RFY                                            1107
*                    (GPR00P) RSTD;                                1107
*LHAA0063:                                                         1108
*                   ;                                              1108
LHAA0063 DS    0H                                                  1109
*                   GEN(LM    GPR00P,GPR15P,RPHWORK(GPR01P))       1109
*                   REFS(RPHWORK,GPR01P) SETS(GPR00P,GPR15P);      1109
         LM    GPR00P,GPR15P,RPHWORK(GPR01P)
*                   RFY                                            1110
*                    (GPR00P,                                      1110
*                     GPR01P,                                      1110
*                     GPR14P,                                      1110
*                     GPR15P) UNRSTD;                              1110
*                 END;              /* ****END OF TPWAIT WAIT UNTIL
*                                      OUT OF SLOWDOWN.              */
*                 WKREG=ICNCBPTR;   /* REINITIALIZE THE POINTER TO 1112
*                                      THE FIRST ICNCB.      @AS33958*/
         LR    WKREG,ICNCBPTR                                      1112
*                 FMCZF003=OFF;     /* TURN OFF THE TPIOS WAIT FLAG. */
         NI    FMCZF003(FMCBPTR),B'11011111'                       1113
*               END;                /* END SLOWDOWN                  */
*             ELSE                  /* NOT IN SLOWDOWN MODE. @AS33958*/
*               WKREG=ADDR(ICNCB)->NCBNSNA;/* POINT TO THE NEXT NODE
*                                      TO BE CHECKED.                */
         B     @RC01064                                            1115
@RF01064 L     WKREG,NCBNSNA(,WKREG)                               1115
*         END;                      /* END CHECK OF NODES IN PATH.   */
@RC01064 DS    0H                                                  1116
@RC01059 DS    0H                                                  1116
@DE01056 LTR   WKREG,WKREG                                         1116
         BNZ   @DL01056                                            1116
*       END;                        /* END DEVICE (LU/PU) NOT SICK.  */
*   RFY                                                            1118
*     ISTICNCB BASED(ICNCBPTR);     /* RESTORE ORIGINAL BASING.      */
@RF01053 DS    0H                                                  1118
@RC01051 DS    0H                                                  1119
*   RFY                                                            1119
*     ISTNCB BASED(NCBPTR);                                        1119
*   RFY                                                            1120
*     REG14 RSTD;                                                  1120
*   REG14=ZCRSVF2;                  /* RESTORE RETURN ADDRESS.       */
         L     REG14,ZCRSVF2(,ZCRRPTR)                             1121
*   RFY                                                            1122
*     REG14 UNRSTD;                                                1122
*   RETURN;                                                        1123
@EL00002 DS    0H                                                  1123
@EF00002 DS    0H                                                  1123
@ER00002 BR    @14                                                 1123
*   END SUB370X;                                                   1124
         EJECT
*                                                                  1125
*/********************************************************************/
*/*                                                                  */
*/*CIDRTN: BGNSEGMENT (SUBROUTINE).                                  */
*/*                                                                  */
*/*FUNCTION IS TO FIND THE POINTERS TO THE NCB (DNCB OR LUNCB) AND   */
*/*    FMCB.                                                         */
*/*                                                                  */
*/*  ISSUE CIDCTL (FIND) TO FIND THE NCB (DNCB OR LUNCB) AND FMCB.   */
*/*                                                                  */
*/*ENDSEGMENT (CIDRTN).                                              */
*/*                                                                  */
*/********************************************************************/
*                                                                  1125
*CIDRTN:                                                           1125
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1125
CIDRTN   DS    0H                                                  1126
*   RFY                                                            1126
*     REG14 RSTD;                                                  1126
*   ZCRSVF3=REG14;                  /* SAVE RETURN ADDRESS.  @ZA30934*/
         ST    REG14,ZCRSVF3(,ZCRRPTR)                             1127
*   RFY                                                            1128
*     REG14 UNRSTD;                                                1128
*   ZCRCIDSV=CIDPARM;               /* SAVE CIDCTL PARAMETER FOR   1129
*                                      CIDCTL (FINISH).              */
         ST    CIDPARM,ZCRCIDSV(,ZCRRPTR)                          1129
*   DO;                             /* CIDCTL(FIND)                  */
*     RFY                                                          1131
*      (EMCR2,                                                     1131
*       EMCR3) RSTD;                                               1131
*     GEN SETS(RPHWORK)                                            1132
*         (STM EMCR0,EMCR15,RPHWORK(RPHPTR) SAVE REGS IN RPH);     1132
         STM EMCR0,EMCR15,RPHWORK(RPHPTR) SAVE REGS IN RPH
*     EMCR3='00'X;                  /* CLEAR EXTRA BITS              */
         SLR   EMCR3,EMCR3                                         1133
*     EMCR3='01'X;                  /* INDICATE SHARED LOCK          */
         LA    EMCR3,1                                             1134
*     CALL ATCLCPTR->ATCCDFND->ISTSDCCF;/* PROCESS REQUEST           */
         L     @14,ATCLCPTR                                        1135
         L     @15,ATCCDFND(,@14)                                  1135
         BALR  @14,@15                                             1135
*     RFY                                                          1136
*      (EMCR2,                                                     1136
*       EMCR3) UNRSTD;                                             1136
*   END;                            /* CIDCTL FIND PTRS TO NCB AND 1137
*                                      FMCB.                         */
*   RFY                                                            1138
*     RCREG RSTD;                                                  1138
*   IF RCREG=0 THEN                 /* IF PTRS TO THE FMCB AND THE   */
         LTR   RCREG,RCREG                                         1139
         BNZ   @RF01139                                            1139
*     DO;                           /* NCB ARE FOUND THEN            */
*       RFY                                                        1141
*         REG0 RSTD;                                               1141
*       NCBPTR=REG0;                /* POINT TO THE DNCB/LUNCB.      */
         LR    NCBPTR,REG0                                         1142
*       RFY                                                        1143
*         REG0 UNRSTD;                                             1143
*       FMCBPTR=CIDPARM;            /* POINT TO THE FMCB.            */
         LR    FMCBPTR,CIDPARM                                     1144
*       CIDPARM=ZCRCIDSV;           /* RESTORE CIDCTL PARAMETER FOR
*                                      CIDCTL FINISH.                */
         L     CIDPARM,ZCRCIDSV(,ZCRRPTR)                          1145
*       DO;                         /* CIDCTL(FINISH)                */
*         RFY                                                      1147
*          (EMCR2,                                                 1147
*           EMCR3) RSTD;                                           1147
*         GEN SETS(RPHWORK)                                        1148
*             (STM EMCR0,EMCR15,RPHWORK(RPHPTR) SAVE REGS IN RPH); 1148
         STM EMCR0,EMCR15,RPHWORK(RPHPTR) SAVE REGS IN RPH
*         EMCR3='00'X;              /* CLEAR EXTRA BITS              */
         SLR   EMCR3,EMCR3                                         1149
*         CALL ATCLCPTR->ATCCDFIN->ISTSDCCR;/* PROCESS REQUEST       */
         L     @14,ATCLCPTR                                        1150
         L     @15,ATCCDFIN(,@14)                                  1150
         BALR  @14,@15                                             1150
*         RFY                                                      1151
*          (EMCR2,                                                 1151
*           EMCR3) UNRSTD;                                         1151
*       END;                        /* CIDCTL RELEASE FMCB AND NCB 1152
*                                      LOCKS.                        */
*     END;                          /* END NCB AND FMCB PTRS FOUND.  */
*   ELSE                            /* IF PTRS ARE NOT FOUND THEN    */
*     NCBPTR=ICNCBPTR;              /* INDICATE NCB NOT FOUND.       */
         B     @RC01139                                            1154
@RF01139 LR    NCBPTR,ICNCBPTR                                     1154
*   RFY                                                            1155
*     RCREG UNRSTD;                                                1155
@RC01139 DS    0H                                                  1156
*   CIDPARM=ATCLCPTR;               /* RESTORE ATCVT ADDRESS.        */
         L     CIDPARM,ATCLCPTR                                    1156
*   RFY                                                            1157
*     REG14 RSTD;                                                  1157
*   REG14=ZCRSVF3;                  /* RESTORE RETURN ADDRESS@ZA30934*/
         L     REG14,ZCRSVF3(,ZCRRPTR)                             1158
*   RFY                                                            1159
*     REG14 UNRSTD;                                                1159
*   RETURN;                                                        1160
@EL00003 DS    0H                                                  1160
@EF00003 DS    0H                                                  1160
@ER00003 BR    @14                                                 1160
*   END CIDRTN;                                                    1161
@PB00003 DS    0H                                                  1162
         EJECT
*                                                                  1162
*   /*****************************************************************/
*   /*                                                               */
*   /* SEGMENT(BUFFSEG)START                                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1162
*   DO;                                                            1162
*     GOTO BUFFSEG@;                                               1163
         B     BUFFSEG@                                            1163
*BUFFSEG:                                                          1164
*   END;                                                           1164
*                                                                  1164
BUFFSEG  DS    0H                                                  1165
*/********************************************************************/
*/*                                                                  */
*/*BUFFSEG:BGNSEGMENT(BLOCK).                                        */
*/*                                                                  */
*/*FUNCTION IS TO                                                    */
*/*    1) CLEAN UP THE FMCB TIP IF REQUIRED                          */
*/*    2) CLEAN UP THE LUNCB OR DNCB TIP IF REQUIRED                 */
*/*    3) OBTAIN A BUFFER TO BE USED FOR BUILDING A PIU OR A FSB.    */
*/*                                                                  */
*/*  IF NON-SNA DEVICE                                               */
*/*    THEN                                                          */
*/*      ISSUE TPLOCK TO OBTAIN THE DNCB LOCK.                       */
*/*      CLEAR THE SESSION FLAGS IN THE DNCB.                        */
*/*  ENDIF (DEVICE IS NON-SNA).                                      */
*/*  PUT THE FMCB'S TASK ID INTO THE NCB.                            */
*/*  DO WHILE THERE ARE ELEMENTS (FSB(S)) ON THE FMCB                */
*/*      TPIOS INBOUND PAB (TIP) OR THE NCB (DNCB OR LUNCB) TIP.     */
*/*    CALL DEQRTNA TO DEQUEUE THE FSB                               */
*/*        FROM THE TIP.                                             */
*/*    CALL RELBUFF TO FREE ALL OF THE FSB(S)                        */
*/*        EXCEPT ONE.                                               */
*/*    NOTE - IN CLEANING UP THE NCB AND FMCB TIPS, ISTZLFAB WILL    */
*/*        SAVE ONE BUFFER IN WHICH IT CAN BUILD A PIU OR A FSB.     */
*/*  ENDDO (ELEMENTS ON THE TIPS).                                   */
*/*  IF THE DEVICE IS IN SESSION                                     */
*/*    THEN                                                          */
*/*      CLEANUP THE REMAINING FIELDS IN THE DNCB OR LUNCB TIP.      */
*/*  ENDIF.                                                          */
*/*  IF NO BUFFER WAS FOUND ON ONE OF THE TPIOS INBOUND PABS         */
*/*    THEN                                                          */
*/*      ISSUE REQSTORE (PRIORITY=YES) TO OBTAIN ONE FIXED BUFFER    */
*/*          IN WHICH ISTZLFAB CAN BUILD A PIU OR A FSB.             */
*/*      NOTE - TPWAIT IS DONE IF REQSTORE CANNOT RETURN A BUFFER.   */
*/*  ENDIF (NO BUFFER WAS FOUND).                                    */
*/*                                                                  */
*/*ENDSEGMENT(BUFFSEG).                                              */
*/*                                                                  */
*/********************************************************************/
*                                                                  1165
*   IF NCBTYPE=DNTYPE THEN          /* IF NON-SNA DEVICE THEN        */
         CLI   NCBTYPE(NCBPTR),X'05'                               1165
         BNE   @RF01165                                            1165
*     DO;                           /*                               */
*/*** START -TPLOCK (DNCBLOCK)TYPE(XCLSIVE)- **                      */
*                                                                  1167
*       DO;                                                        1167
*         RFY                                                      1168
*          (GPR00P,                                                1168
*           GPR01P,                                                1168
*           GPR02P,                                                1168
*           GPR03P,                                                1168
*           GPR04P,                                                1168
*           GPR15P) RSTD;                                          1168
*         GENERATE REFS(GPR00P,GPR01P,GPR15P,RPHWORK) SETS(RPHWORK);
         STM GPR00P,GPR14P,RPHWORK(GPR01P)
*         GPR02P=ADDR(DNCLOCK);     /* SET PARAM - LOCKWORD PTR      */
         LA    GPR02P,DNCLOCK(,NCBPTR)                             1170
*         GPR04P=GPR01P->RPHCRR;    /* SET PARAM - ISTCRA PTR        */
         L     GPR04P,RPHCRR(,GPR01P)                              1171
*         GPR00P=CRALMS05;          /* SET PARAM - LOCK LEVEL FLAG   */
         LA    GPR00P,16                                           1172
*         GPR03P=ADDR(GPR04P->CRAL5PTR);/* SET PARAM - LOCK LEVEL PTR*/
         LA    GPR03P,CRAL5PTR(,GPR04P)                            1173
*         GPR15P=ATCLCPTR->ATCAP36; /* ADDRESS OF LOCK ROUTINE       */
         L     @14,ATCLCPTR                                        1174
         L     GPR15P,ATCAP36(,@14)                                1174
*         DCL                                                      1175
*           FMZL0087 BASED(GPR15P) LABEL VALUERANGE(*);            1175
*         CALL FMZL0087;                                           1176
         BALR  @14,@15                                             1176
*         GENERATE REFS(GPR00P,GPR01P,GPR14P,RPHWORK) SETS(GPR00P, 1177
*             GPR01P,GPR02P,GPR03P,GPR04P,GPR05P,GPR06P,GPR07P,GPR08P,
*             GPR09P,GPR10P,GPR11P,GPR12P,GPR13P,GPR14P,GPR15P);   1177
         LM GPR00P,GPR15P,RPHWORK(GPR01P)
*         RFY                                                      1178
*          (GPR00P,                                                1178
*           GPR01P,                                                1178
*           GPR02P,                                                1178
*           GPR03P,                                                1178
*           GPR04P,                                                1178
*           GPR15P) UNRSTD;                                        1178
*       END;                                                       1179
*                                                                  1179
*/*** END -TPLOCK (DNCBLOCK)TYPE(XCLSIVE)- **                        */
*                                                                  1180
*                                   /* OBTAIN DNCB LOCK.             */
*       FMCZF006='0000'B;           /* CLEAR SESSION FLAGS.          */
         NC    FMCZF006(2,FMCBPTR),@CB05606                        1180
*       DNCSESS=OFF;                /* FLAG DEVICE AS NOT IN SESSION.*/
*       DNCDISC=OFF;                /* CLR DISCONNECT OUTSTANDING FLG*/
*       DNCINVIT=OFF;               /* CLEAR INVITE UP FLAG.         */
*       DNCCONT=OFF;                /* CLEAR CONTACT FLAG.           */
         NI    DNCSESS(NCBPTR),B'10000111'                         1184
*     END;                          /* END NON-SNA DEVICE.           */
*   ELSE                                                           1186
*     ;                             /* SNA DEVICE.                   */
@RF01165 DS    0H                                                  1187
*   BFRPTR=0;                       /* INIT CHK FOR BUFFER SAVED.    */
         SLR   BFRPTR,BFRPTR                                       1187
*/*  DOINF                                                           */
*                                                                  1188
*   DO UNTIL(1=2);                                                 1188
@DL01188 DS    0H                                                  1189
*     WKREG=ADDR(FMCPAB4);          /* POINT TO FMCB TIP.    @AS33958*/
         LA    WKREG,FMCPAB4(,FMCBPTR)                             1189
*     CALL DEQRTNA;                 /* DEQUEUE EACH FSB ON THE FMCB  */
         BAL   @14,DEQRTNA                                         1190
*/*    LEAVE ON(RPHWEA=0)                                            */
*                                                                  1191
*     IF(RPHWEA=0) THEN                                            1191
         L     @00,RPHWEA(,RPHAPTR)                                1191
         LTR   @00,@00                                             1191
         BZ    @RT01191                                            1191
*       GOTO #DC00093;              /* TIP.                          */
*     CALL RELBUFF;                 /* KEEP ONE BUFFER AND FREE ALL
*                                      REMAINING BUFFERS.            */
         BAL   @14,RELBUFF                                         1193
*   END;                            /* END                           */
@DE01188 B     @DL01188                                            1194
*#DC00093:                                                         1195
*   ;                               /* FMCB TIP EMPTY.               */
#DC00093 DS    0H                                                  1196
*   LCPFLCCW=NCBTSKID;              /* SAVE NCB PST POINTER.         */
         L     @00,NCBTSKID(,NCBPTR)                               1196
         ST    @00,LCPFLCCW(,LCPBPTR)                              1196
*   NCBTSKID=FMCTSKID;              /* POINT TO USER'S PST.          */
         L     @00,FMCTSKID(,FMCBPTR)                              1197
         ST    @00,NCBTSKID(,NCBPTR)                               1197
*/*  DOINF                                                           */
*                                                                  1198
*   DO UNTIL(1=2);                                                 1198
@DL01198 DS    0H                                                  1199
*     WKREG=ADDR(LUNZC001);         /* POINT TO LUNCB TIP.   @AS33958*/
         LA    WKREG,LUNZC001(,NCBPTR)                             1199
*     IF NCBTYPE=DNTYPE THEN        /* IF DNCB PRESENT THEN  @AS33958*/
         CLI   NCBTYPE(NCBPTR),X'05'                               1200
         BNE   @RF01200                                            1200
*       WKREG=ADDR(DNCZC001);       /* POINT TO DNCB TIP.    @AS33958*/
         LA    WKREG,DNCZC001(,NCBPTR)                             1201
*     ELSE                                                         1202
*       ;                                                          1202
@RF01200 DS    0H                                                  1203
*     CALL DEQRTNA;                 /* DEQUEUE EACH FSB FROM THE     */
         BAL   @14,DEQRTNA                                         1203
*/*    LEAVE ON(RPHWEA=0)                                            */
*                                                                  1204
*     IF(RPHWEA=0) THEN                                            1204
         L     @00,RPHWEA(,RPHAPTR)                                1204
         LTR   @00,@00                                             1204
         BZ    @RT01204                                            1204
*       GOTO #DC00097;              /* DNCB/LUNCB TIP.               */
*     CALL RELBUFF;                 /* KEEP ONE BUFFER IF NEEDED AND
*                                      FREE ALL REMAINING BUFFERS.   */
         BAL   @14,RELBUFF                                         1206
*   END;                            /* END                           */
@DE01198 B     @DL01198                                            1207
*#DC00097:                                                         1208
*   ;                               /* DNCB/LUNCB TIP EMPTY.         */
#DC00097 DS    0H                                                  1209
*   IF FMCTSKID=LCPFLCCW THEN       /* IF DEVICE IS IN SESSION THEN
*                                                            @AS33958*/
         CLC   FMCTSKID(4,FMCBPTR),LCPFLCCW(LCPBPTR)               1209
         BNE   @RF01209                                            1209
*     DO;                                                          1210
*       PABWQCHN=PABWQCHN&&PABWQCHN;/* ZERO WORK ELEMENT ADDRESS AND
*                                      CHAIN POINTER.                */
         XC    PABWQCHN(8,WKREG),PABWQCHN(WKREG)                   1211
*       PABERRLK=OFF;               /* CLEAR THE ERROR LOCK.         */
*       PABINHBT=OFF;               /* CLEAR THE INHIBIT FLAG.       */
         L     @00,PABINHBT(,WKREG)                                1213
@GL00006 LR    @15,@00                                             1213
         N     @15,@CF05608                                        1213
         CS    @00,@15,PABINHBT(WKREG)                             1213
         BNE   @GL00006                                            1213
*       PABRPHA=PABRPHA&&PABRPHA;   /* ZERO RPH POINTER.             */
         L     @15,PABRPHA-1(,WKREG)                               1214
         LA    @15,0(,@15)                                         1214
         LR    @00,@15                                             1214
         XR    @00,@15                                             1214
         STCM  @00,7,PABRPHA(WKREG)                                1214
*     END;                          /* END DEVICE IN SESSION.        */
*   ELSE                                                           1216
*     ;                             /* DEVICE NOT IN SESSION.        */
@RF01209 DS    0H                                                  1217
*   IF BFRPTR=0 THEN                /* IF NO BUFFER WAS FOUND ON ANY */
         LTR   BFRPTR,BFRPTR                                       1217
         BNZ   @RF01217                                            1217
*     DO;                           /* TIP THEN              @AS33958*/
*                                                                  1218
*       /*************************************************************/
*       /*                                                           */
*       /* REQSTORE BUFNO(1)RPH(RPHPTR)PRIORITY(YES)                 */
*       /*                                                           */
*       /*************************************************************/
*                                                                  1219
*       DO;                                                        1219
*                                                                  1219
*/* ATBUILD (ISTDYPAB,ISTATCVT,ISTRPH)                               */
*/* END OF ATBUILD                                                   */
*                                                                  1220
*         RFY                                                      1220
*          (GPR02P,                                                1220
*           GPR03P,                                                1220
*           GPR04P,                                                1220
*           GPR15P) RSTD;                                          1220
*         RFY                                                      1221
*          (GPR01P,                                                1221
*           GPR13P) RSTD;                                          1221
*         GENERATE REFS(GPR01P,GPR02P,GPR13P) SETS(RPHWORK);       1222
           STM GPR02P,GPR13P,RPHWORK(GPR01P)
*         RFY                                                      1223
*          (GPR01P,                                                1223
*           GPR13P) UNRSTD;                                        1223
*         DO;                       /* LISATCVT                    1224
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*           GPR15P=ATCLCPTR;        /* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     1225
*         END;                      /* LISATCVT                      */
*         RFY                                                      1227
*           ISTBPENT;                                              1227
*         RFY                                                      1228
*           ISTBPDTY;                                              1228
*         GPR02P=GPR15P->ATCBPDA->BPDCHPCB;                        1229
         L     @14,ATCBPDA(,GPR15P)                                1229
         L     GPR02P,BPDCHPCB(,@14)                               1229
*         DCL                                                      1230
*           1 FMZA0100 FIXED(31) STATIC LOCAL,                     1230
*            2 * FIXED(8) INIT(108),                               1230
*            2 * PTR(24) INIT(0);                                  1230
*         GPR03F=FMZA0100;                                         1231
         L     GPR03F,FMZA0100                                     1231
*         GPR04F=1;                                                1232
         LA    GPR04F,1                                            1232
*         GPR15P=GPR15P->ATCSMRQ;                                  1233
         L     GPR15P,ATCSMRQ(,GPR15P)                             1233
*         DCL                                                      1234
*           FMZL0100 BASED(GPR15P) LABEL VALUERANGE(*);            1234
*         CALL FMZL0100;                                           1235
         BALR  @14,@15                                             1235
*         RFY                                                      1236
*          (GPR13P) RSTD;                                          1236
*         GENERATE REFS(GPR01P,RPHWORK) SETS(GPR02P,GPR13P);       1237
           LM GPR02P,GPR13P,RPHWORK(GPR01P)
*         RFY                                                      1238
*          (GPR13P) UNRSTD;                                        1238
*         RFY                                                      1239
*          (GPR02P,                                                1239
*           GPR03P,                                                1239
*           GPR04P,                                                1239
*           GPR15P) UNRSTD;                                        1239
*       END;                                                       1240
*                                                                  1240
*       /*************************************************************/
*       /*                                                           */
*       /* ******** END OF REQSTORE EXPANSION                        */
*       /*                                                           */
*       /*************************************************************/
*                                                                  1241
*                                   /* GET A BUFFER.         @AS33958*/
*       RFY                                                        1241
*         RCREG RSTD;                                              1241
*       IF RCREG>4 THEN             /* IF BUFFER WAS NOT OBTAINED  1242
*                                      THEN                  @AS33958*/
         C     RCREG,@CF00073                                      1242
         BNH   @RF01242                                            1242
*/*  TPWAIT                                                          */
*                                                                  1243
*         DO;                       /* BEGIN TPWAIT GENERATION       */
*           RFY                                                    1244
*            (GPR01P,                                              1244
*             GPR14P,                                              1244
*             GPR15P) RSTD;                                        1244
*           RFY                                                    1245
*            (GPR00P) RSTD;                                        1245
*           GEN(STM   GPR00P,GPR15P,RPHWORK(GPR01P))               1246
*           REFS(GPR00P,GPR01P,GPR15P) SETS(RPHWORK);              1246
         STM   GPR00P,GPR15P,RPHWORK(GPR01P)
*           RFY                                                    1247
*            (GPR00P) UNRSTD;                                      1247
*           GPR15P=ADDR(LHAA0120);                                 1248
         LA    GPR15P,LHAA0120                                     1248
*           GPR14P=0;                                              1249
         SLR   GPR14P,GPR14P                                       1249
*           GPR15P=GPR15P&'00FFFFFF'X;                             1250
         N     GPR15P,@CF05307                                     1250
*           GPR15P=GPR15P|RPHWT1;                                  1251
         O     GPR15P,@CF01675                                     1251
*           CS(GPR14P,GPR15P,GPR01P->RPHRESMA);                    1252
         CS    GPR14P,@15,RPHRESMA(GPR01P)                         1252
*           BC(7,LHAB0120);                                        1253
*                                                                  1253
         BC    7,LHAB0120                                          1253
*/* TPEXIT  NONE                                                     */
*                                                                  1254
*           DO;                                                    1254
*             RESPECIFY                                            1255
*               GPR15P RSTD;                                       1255
*                                                                  1255
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTATCVT)                               */
*/* END OF ATBUILD                                                   */
*                                                                  1256
*             DO;                   /* LISATCVT                    1256
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*               GPR15P=ATCLCPTR;    /* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     1257
*             END;                  /* LISATCVT                      */
*             RESPECIFY                                            1259
*               GPR00F RSTD;                                       1259
*             GPR00F=0;             /* SET PARAMETER REGISTER TO 0   */
         SLR   GPR00F,GPR00F                                       1260
*             GPR15P=GPR15P->ATCAP31;                              1261
         L     GPR15P,ATCAP31(,GPR15P)                             1261
*             DCL                                                  1262
*               FMZL0125 BASED(GPR15P) LABEL VALUERANGE(*);        1262
*             CALL FMZL0125;                                       1263
         BALR  @14,@15                                             1263
*             RESPECIFY                                            1264
*              (GPR00F,                                            1264
*               GPR15P) UNRSTD;                                    1264
*           END;                    /* **** END OF TPEXIT            */
*LHAB0120:                                                         1266
*           ;                                                      1266
LHAB0120 DS    0H                                                  1267
*           GPR01P->RPHRESMA=0;                                    1267
         SLR   @00,@00                                             1267
         ST    @00,RPHRESMA(,GPR01P)                               1267
*           RFY                                                    1268
*            (GPR00P) RSTD;                                        1268
*LHAA0120:                                                         1269
*           ;                                                      1269
LHAA0120 DS    0H                                                  1270
*           GEN(LM    GPR00P,GPR15P,RPHWORK(GPR01P))               1270
*           REFS(RPHWORK,GPR01P) SETS(GPR00P,GPR15P);              1270
         LM    GPR00P,GPR15P,RPHWORK(GPR01P)
*           RFY                                                    1271
*            (GPR00P,                                              1271
*             GPR01P,                                              1271
*             GPR14P,                                              1271
*             GPR15P) UNRSTD;                                      1271
*         END;                      /* ****END OF TPWAIT WAIT FOR THE
*                                      BUFFER.                       */
*       ELSE                                                       1273
*         ;                         /* BUFFER WAS OBTAINED.          */
@RF01242 DS    0H                                                  1274
*       BFRPTR=RPHSRPRM;            /* POINT TO THE BUFFER OBTAINED. */
         L     BFRPTR,RPHSRPRM(,RPHAPTR)                           1274
*     END;                          /* END NO BUFFER FOUND ON TIP.   */
*   ELSE                                                           1276
*     ;                             /* BUFFER FOUND ON TIP.  @AS33958*/
@RF01217 DS    0H                                                  1277
*   RFY                                                            1277
*     RCREG UNRSTD;                                                1277
*                                                                  1277
*   /*****************************************************************/
*   /*                                                               */
*   /* SEGMENT(BUFFSEG)FINISH                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1278
*   DO;                                                            1278
*     GOTO BUFFSEG#;                                               1279
         B     BUFFSEG#                                            1279
*BUFFSEG@:                                                         1280
*   END;                                                           1280
         EJECT
*                                                                  1281
*/********************************************************************/
*/*                                                                  */
*/*RELBUFF:BGNSEGMENT(SUBROUTINE).                                   */
*/*                                                                  */
*/*FUNCTION IS TO SAVE ONE BUFFER FOR ISTZLFAB'S OWN USE             */
*/*    AND FREE ALL OTHERS PASSED TO IT BY BUFFSEG.                  */
*/*                                                                  */
*/*  IF A BUFFER HAS ALREADY BEEN SAVED FOR ISTZLFAB'S USE           */
*/*    THEN                                                          */
*/*      CALL FREERTN TO RELEASE THE CHAIN OF BUFFERS PASSED.@AS33958*/
*/*    ELSE                                                          */
*/*      SAVE THIS BUFFER FOR ISTZLFAB.                              */
*/*      CALL ISTORFID (EXTERNAL) TO ZERO THE TASK ID IN THE BUFFER. */
*/*      IF THIS BUFFER HAS ANY OTHER BUFFERS CHAINED OFF OF IT      */
*/*        THEN                                                      */
*/*          CALL FREERTN TO RELEASE THESE CHAINED BUFFERS.  @AS33958*/
*/*      ENDIF (BUFFER IS CHAINED).                                  */
*/*  ENDIF (A BUFFER HAS ALREADY BEEN SAVED).                        */
*/*                                                                  */
*/*ENDSEGMENT(RELBUFF).                                              */
*/*                                                                  */
*/********************************************************************/
*                                                                  1281
*RELBUFF:                                                          1281
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1281
         B     @PB00004                                            1281
RELBUFF  DS    0H                                                  1282
*   RFY                                                            1282
*     REG14 RSTD;                                                  1282
*   ZCRSVF2=REG14;                  /* SAVE RETURN ADDRESS.          */
         ST    REG14,ZCRSVF2(,ZCRRPTR)                             1283
*   RFY                                                            1284
*     REG14 UNRSTD;                                                1284
*   IF BFRPTR^=0 THEN               /* IF BUFFER ALREADY SAVED THEN  */
         LTR   BFRPTR,BFRPTR                                       1285
         BZ    @RF01285                                            1285
*     DO;                                                          1286
*       WKREG=RPHWEA-(ADDR(ZIBFSB)-ADDR(ISTZIBUF));/* POINT TO THE 1287
*                                      BUFFER TO BE FREED.   @AS33958*/
         LA    WKREG,ZIBFSB(,BFRPTR)                               1287
         SLR   WKREG,BFRPTR                                        1287
         LCR   WKREG,WKREG                                         1287
         AL    WKREG,RPHWEA(,RPHAPTR)                              1287
*       CALL FREERTN;               /* FREE THE BUFFER.      @AS33958*/
         BAL   @14,FREERTN                                         1288
*     END;                          /* END BUFFER ALREADY SAVED.     */
*   ELSE                                                           1290
*     DO;                           /* MUST SAVE THIS BUFFER FOR I/O.*/
         B     @RC01285                                            1290
@RF01285 DS    0H                                                  1291
*       BFRPTR=RPHWEA;              /* POINT TO THE FSB.             */
         L     BFRPTR,RPHWEA(,RPHAPTR)                             1291
*       BFRPTR=BFRPTR-(ADDR(ZIBFSB)-ADDR(ISTZIBUF));/* POINT TO THE
*                                      BEGINNING OF THE BUFFER.      */
         LA    @00,ZIBFSB(,BFRPTR)                                 1292
         LCR   @00,@00                                             1292
         ALR   @00,BFRPTR                                          1292
         ALR   BFRPTR,@00                                          1292
*       GEN SETS(RPHWORK)(STM   2,10,RPHWORK+4(1));/* SAVE REGISTERS.*/
         STM   2,10,RPHWORK+4(1)
*       RFY                                                        1294
*         REG0 RSTD;                                               1294
*       RFY                                                        1295
*         ATCVTREG RSTD;                                           1295
*       REG0=0;                     /* SET TASK ID TO ZERO.          */
         SLR   REG0,REG0                                           1296
*       ATCVTREG=VTCVTPTR;          /* POINT TO ATCVT.               */
         LR    ATCVTREG,VTCVTPTR                                   1297
*       BFRPARM=BFRPTR;             /* POINT TO THE BUFFER.          */
         LR    BFRPARM,BFRPTR                                      1298
*       CALL ATCVTREG->ATCSMAID;    /* SET THE TASK ID.              */
         L     @15,ATCSMAID(,ATCVTREG)                             1299
         BALR  @14,@15                                             1299
*       GEN REFS(RPHWORK)(LM    2,10,RPHWORK+4(1));/* RESTORE REGS   */
         LM    2,10,RPHWORK+4(1)
*       RFY                                                        1301
*         REG0 UNRSTD;                                             1301
*       RFY                                                        1302
*         ATCVTREG UNRSTD;                                         1302
*       IF ZIBCHAIN^=0 THEN         /* IF BUFFER(S) CHAINED OFF OF   */
         SLR   @15,@15                                             1303
         L     @14,ZIBCHAIN(,BFRPTR)                               1303
         CR    @14,@15                                             1303
         BE    @RF01303                                            1303
*         DO;                       /* THIS BUFFER THEN              */
*           WKREG=ZIBCHAIN;         /* POINT TO THE BUFFER(S) TO BE
*                                      FREED.                @AS33958*/
         LR    WKREG,@14                                           1305
*           ZIBCHAIN=0;             /* ZERO THE CHAIN POINTER.       */
         ST    @15,ZIBCHAIN(,BFRPTR)                               1306
*           CALL FREERTN;           /* FREE THE BUFFER(S).   @AS33958*/
         BAL   @14,FREERTN                                         1307
*         END;                      /* END BUFFER(S) CHAINED.        */
*       ELSE                                                       1309
*         ;                         /* NO BUFFER(S) CHAINED.         */
@RF01303 DS    0H                                                  1310
*     END;                                                         1310
*   RFY                                                            1311
*     REG14 RSTD;                                                  1311
@RC01285 DS    0H                                                  1312
*   REG14=ZCRSVF2;                  /* RESTORE RETURN ADDRESS.       */
         L     REG14,ZCRSVF2(,ZCRRPTR)                             1312
*   RFY                                                            1313
*     REG14 UNRSTD;                                                1313
*   RETURN;                                                        1314
@EL00004 DS    0H                                                  1314
@EF00004 DS    0H                                                  1314
@ER00004 BR    @14                                                 1314
*   END RELBUFF;                                                   1315
         EJECT
*                                                                  1316
*/********************************************************************/
*/*                                                                  */
*/*DEQRTNA:BGNSEGMENT(SUBROUTINE).                                   */
*/*                                                                  */
*/*FUNCTION IS TO DEQUEUE AN ELEMENT FROM A SPECIFIED PAB.           */
*/*                                                                  */
*/*  ISSUE TPDEQ TO DEQUEUE AN ELEMENT FROM THE SPECIFIED PAB.       */
*/*                                                                  */
*/*ENDSEGMENT(DEQRTNA).                                              */
*/*                                                                  */
*/********************************************************************/
*                                                                  1316
*DEQRTNA:                                                          1316
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1316
DEQRTNA  DS    0H                                                  1317
*   RFY                                                            1317
*     REG14 RSTD;                                                  1317
*   ZCRSVF2=REG14;                  /* SAVE RETURN ADDRESS.          */
         ST    REG14,ZCRSVF2(,ZCRRPTR)                             1318
*   RFY                                                            1319
*     REG14 UNRSTD;                                                1319
*                                                                  1319
*/* TPDEQ (,WKREG->ISTPAB)                                           */
*                                                                  1320
*   DO;                             /* BEGIN TPDEQ CODE GENERATION   */
*     RFY                                                          1321
*      (GPR00P,                                                    1321
*       GPR01P,                                                    1321
*       GPR14P,                                                    1321
*       GPR15P) RSTD;                                              1321
*     GPR15P=ADDR(WKREG->ISTPAB);   /* ADDRESS QUEUE POINTER         */
         LR    GPR15P,WKREG                                        1322
*     GPR14P=GPR15P->PABWEQA|FMZCA043;                             1323
         L     @11,@CF01716                                        1323
         L     GPR14P,PABWEQA(,GPR15P)                             1323
         OR    GPR14P,@11                                          1323
*     IF GPR14P=FMZCA043 THEN                                      1324
         CLR   GPR14P,@11                                          1324
         BE    @RT01324                                            1324
*       ;                                                          1325
*     ELSE                                                         1326
*       DO;                                                        1326
*FMZL1136:                                                         1327
*         ;                                                        1327
FMZL1136 DS    0H                                                  1328
*         DO WHILE(GPR14P->WKECHAIN^=FMZCA043);                    1328
         B     @DE01328                                            1328
@DL01328 DS    0H                                                  1329
*           GPR15P=ADDR(GPR14P->WKECHAIN);                         1329
         LA    GPR15P,WKECHAIN(,GPR14P)                            1329
*           GPR14P=GPR15P->PABWEQA;                                1330
         L     GPR14P,PABWEQA(,GPR15P)                             1330
*         END;                                                     1331
@DE01328 L     @11,@CF01716                                        1331
         CL    @11,WKECHAIN(,GPR14P)                               1331
         BNE   @DL01328                                            1331
*         GPR00P=FMZCA043;                                         1332
         LR    GPR00P,@11                                          1332
*         CS(GPR14P,GPR00P,GPR15P->PABWEQA);                       1333
         CS    GPR14P,@00,PABWEQA(GPR15P)                          1333
*         BC(7,FMZL1136);                                          1334
         BC    7,FMZL1136                                          1334
*         GPR14P->WKECHAIN=0;                                      1335
         SLR   @11,@11                                             1335
         ST    @11,WKECHAIN(,GPR14P)                               1335
*       END;                                                       1336
*ISTA0136:                                                         1337
*     ;                                                            1337
@RT01324 DS    0H                                                  1337
ISTA0136 DS    0H                                                  1338
*     GPR14P=GPR14P&FMZCB043;                                      1338
         N     GPR14P,@CF01714                                     1338
*     GPR01P->RPHWEA=GPR14P;                                       1339
         ST    GPR14P,RPHWEA(,GPR01P)                              1339
*     RFY                                                          1340
*      (GPR00P,                                                    1340
*       GPR01P,                                                    1340
*       GPR14P,                                                    1340
*       GPR15P) UNRSTD;                                            1340
*   END;                            /* END TPDEQ GENERATION DEQUEUE
*                                      ELEMENT FROM SPECIFIED PAB.   */
*   RFY                                                            1342
*     REG14 RSTD;                                                  1342
*   REG14=ZCRSVF2;                  /* RESTORE RETURN ADDRESS.       */
         L     REG14,ZCRSVF2(,ZCRRPTR)                             1343
*   RFY                                                            1344
*     REG14 UNRSTD;                                                1344
*   RETURN;                                                        1345
@EL00005 DS    0H                                                  1345
@EF00005 DS    0H                                                  1345
@ER00005 BR    @14                                                 1345
*   END DEQRTNA;                                                   1346
         EJECT
*                                                                  1347
*/********************************************************************/
*/*                                                                  */
*/*PIURTN: BGNSEGMENT(SUBROUTINE).                                   */
*/*                                                                  */
*/*FUNCTION IS TO FORMAT A PIU FOR A RESET OR DISCONNECT (NON-SNA),  */
*/*     OR A CLEAR OR UNBIND  (SNA DEVICES).                         */
*/*                                                                  */
*/*  IF THE LCCW IS A RESET IMMEDIATE                                */
*/*    THEN (FORMAT FID0 PIU)                                        */
*/*      IF THE RESET HAS BEEN PROCESSED                             */
*/*        THEN                                                      */
*/*          FORMAT A DISCONNECT PIU IN THE OUTBOUND BUFFER.         */
*/*        ELSE                                                      */
*/*          FORMAT A RESET IMMEDIATE PIU IN THE OUTBOUND BUFFER.    */
*/*      ENDIF (RESET HAS BEEN PROCESSED).                           */
*/*    ELSE (NOT RESET IMMEDIATE)                                    */
*/*      TURN OFF THE CLEAR AND UNBIND IN PROGRESS FLAGS IN THE      */
*/*          FMCB.                                           @AS33958*/
*/*      IF THE DEVICE IS FID2                                       */
*/*        THEN (FORMAT FID2 PIU)                                    */
*/*          IF THE CLEAR HAS BEEN PROCESSED                         */
*/*            THEN                                                  */
*/*              FORMAT A FID2 UNBIND PIU IN THE OUTBOUND BUFFER.    */
*/*            ELSE                                                  */
*/*              FORMAT A FID2 CLEAR PIU IN THE OUTBOUND BUFFER.     */
*/*          ENDIF (CLEAR HAS BEEN PROCESSED).                       */
*/*        ELSE (FORMAT FID1 PIU)                                    */
*/*          IF THE CLEAR HAS BEEN PROCESSED                         */
*/*            THEN                                                  */
*/*              FORMAT A FID1 UNBIND PIU IN THE OUTBOUND BUFFER.    */
*/*            ELSE                                                  */
*/*              FORMAT A FID1 CLEAR PIU IN THE OUTBOUND BUFFER.     */
*/*          ENDIF (CLEAR HAS BEEN PROCESSED).                       */
*/*      ENDIF (FID2 DEVICE).                                        */
*/*  ENDIF (RESET IMMEDIATE).                                        */
*/*  TURN ON THE TRACE FLAG IF TRACE IS INDICATED IN THE NCB.        */
*/*                                                                  */
*/*ENDSEGMENT(PIURTN).                                               */
*/*                                                                  */
*/********************************************************************/
*                                                                  1347
*PIURTN:                                                           1347
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1347
PIURTN   DS    0H                                                  1348
*   RFY                                                            1348
*     REG14 RSTD;                                                  1348
*   ZCRSVF1=REG14;                  /* SAVE RETURN ADDRESS.          */
         ST    REG14,ZCRSVF1(,ZCRRPTR)                             1349
*   RFY                                                            1350
*     REG14 UNRSTD;                                                1350
*   ZOBFDB(1:BUFFLNG)=ZOBFDB(1:BUFFLNG)&&ZOBFDB(1:BUFFLNG);/* CLEAR
*                                      THE BUFFER            @AS33958*/
         LH    @15,BUFFLNG                                         1351
         BCTR  @15,0                                               1351
         EX    @15,@SX05611                                        1351
*   IF ICNCBPTR->NCBTYPE=LDTYPE THEN/* IF L/3270             @ZA26631*/
*                                                                  1352
         CLI   NCBTYPE(ICNCBPTR),X'07'                             1352
         BNE   @RF01352                                            1352
*     /***************************************************************/
*     /*                                                             */
*     /* SEGMENT(LOCLRTN)REQUEST                                     */
*     /*                                                             */
*     /***************************************************************/
*                                                                  1353
*     DO;                                                          1353
*       GOTO LOCLRTN;                                              1354
         B     LOCLRTN                                             1354
*LOCLRTN#:                                                         1355
*     END;                          /* BUILD RESET EOC       @ZA26631*/
*   ELSE                            /*                       @ZA26631*/
*     DO;                           /* IF NOT L/3270         @ZA26631*/
         B     @RC01352                                            1356
@RF01352 DS    0H                                                  1357
*       IF LCCWOP=LXI THEN          /* IF RESET IMMEDIATE LCCW THEN  */
         L     @15,LCPNXLCW(,LCPBPTR)                              1357
         CLI   LCCWOP(@15),X'2B'                                   1357
         BNE   @RF01357                                            1357
*         DO;                                                      1358
*           FDBDATAA=ADDR(ZOBBTU);  /* INIT FDB DATA ADDRESS.        */
         LA    @00,ZOBBTU(,BFRPTR)                                 1359
         ST    @00,FDBDATAA(,BFRPTR)                               1359
*           FDBDATCT=LENGTH(ISTBTU);/* INIT FDB DATA COUNT.          */
         MVC   FDBDATCT(2,BFRPTR),@CH00166                         1360
*           BTUFID=FIDRSPNS;        /* INIT TRANSMISSION HEADER.     */
         LA    @15,28                                              1361
         ALR   @15,BFRPTR                                          1361
         MVC   BTUFID(2,@15),@CB05302                              1361
*           BTUDEST=LCPDAF;         /* SET DESTINATION FIELD OF CID. */
         MVC   BTUDEST(2,@15),LCPDAF(LCPBPTR)                      1362
*           BTUSORCE=LCPSAF;        /* SET SOURCE FIELD OF CID.      */
         MVC   BTUSORCE(2,@15),LCPSAF(LCPBPTR)                     1363
*           BTUDCF=LENGTH(BTURH)+LENGTH(BTUSYSTR)+LENGTH(BTUEXTR)+ 1364
*               LENGTH(ISTBDU);     /* SET DATA COUNT FIELD TO 10.   */
         MVC   BTUDCF(2,@15),@CH01572                              1364
*           IF LCPRSTRT=ON THEN     /* IF THE RESET HAS BEEN         */
         TM    LCPRSTRT(LCPBPTR),B'00100000'                       1365
         BNO   @RF01365                                            1365
*             DO;                   /* PROCESSED THEN                */
*               DNCZF001=OFF;       /* CLEAR THE ERROR LOCK.         */
         NI    DNCZF001(NCBPTR),B'01111111'                        1367
*               BDUCOMND=BCMDD;     /* FORMAT A DISCONNECT           */
         LA    @15,42                                              1368
         ALR   @15,BFRPTR                                          1368
         MVI   BDUCOMND(@15),X'07'                                 1368
*               BDUMODIF=BMODD;     /* PIU IN THE OUTBOUND BUFFER.   */
         MVI   BDUMODIF(@15),X'00'                                 1369
*             END;                  /* END RESET HAS BEEN PROCESSED. */
*           ELSE                    /* CLEAR HAS NOT BEEN PROCESSED. */
*             DO;                                                  1371
         B     @RC01365                                            1371
@RF01365 DS    0H                                                  1372
*               BDUCOMND=BCMDZ;     /* FORMAT A RESET IMMEDIATE PIU  */
         LA    @15,42                                              1372
         ALR   @15,BFRPTR                                          1372
         MVI   BDUCOMND(@15),X'08'                                 1372
*               BDUMODIF=BMODZIM;   /* IN THE OUTBOUND BUFFER.       */
         MVI   BDUMODIF(@15),X'44'                                 1373
*             END;                  /* END RESET NOT PROCESSED.      */
*         END;                      /* END FID0 PROCESSING.          */
*       ELSE                                                       1376
*         DO;                       /* MUST BE FID1 OR FID2.         */
         B     @RC01357                                            1376
@RF01357 DS    0H                                                  1377
*           FMCCIPI=OFF;            /* TURN OFF CLEAR IN PROGRESS  1377
*                                      FLAG.                 @AS33958*/
*           FMCUIPI=OFF;            /* TURN OFF UNBIND IN PROGRESS 1378
*                                      FLAG.                 @AS33958*/
         NI    FMCCIPI(FMCBPTR),B'10011111'                        1378
*           IF ICNLCLUS^=ON THEN    /* IF FID1 PROCESSING REQUIRED   */
         TM    ICNLCLUS(ICNCBPTR),B'00100000'                      1379
         BO    @RF01379                                            1379
*             DO;                   /* THEN                          */
*               FDBDATAA=ADDR(ZOBTEXT);/* INIT FDB DATA ADDRESS.     */
         LA    @00,ZOBTEXT(,BFRPTR)                                1381
         ST    @00,FDBDATAA(,BFRPTR)                               1381
*               FDBDATCT=LENGTH(ISTTH)+LENGTH(ISTRH)+LENGTH(SRUQSREQ);
         LA    @00,14                                              1382
         STH   @00,FDBDATCT(,BFRPTR)                               1382
*                                   /* SET DATA COUNT TO 14.         */
*               THFID=THFID1;       /* INDICATE FID1.                */
         LA    @15,28                                              1383
         ALR   @15,BFRPTR                                          1383
         NI    THFID(@15),B'00011111'                              1383
         OI    THFID(@15),B'00010000'                              1383
*               THMPF=THCNOSEG;     /* INDICATE NO SEGMENTING.       */
         OI    THMPF(@15),B'00001100'                              1384
*               THPSI=ON;           /* INDICATE PRIMARY-SECONDARY.   */
*               THAFI=ON;           /* TURN ON ASYCH FLOW INDICATOR. */
         OI    THPSI(@15),B'00000011'                              1386
*               THOAF=LCPSAF;       /* SET SOURCE FIELD OF CID.      */
         MVC   THOAF(2,@15),LCPSAF(LCPBPTR)                        1387
*               THDAF=NCBSWDAF;     /* SET DESTINATION FIELD OF CID. */
         MVC   THDAF(2,@15),NCBSWDAF(NCBPTR)                       1388
*               NIRRH=CLRRH;        /* INITIALIZE THE REQUEST HEADER.*/
         MVC   NIRRH+38(3,BFRPTR),@CB05298                         1389
*               THDCF=LENGTH(ISTRH)+LENGTH(SRUQSREQ);/* SET DATA   1390
*                                      COUNT TO 4                    */
         LA    @14,4                                               1390
         STH   @14,THDCF(,@15)                                     1390
*               SRUQSREQ=SRCLEAR;   /* INDICATE CLEAR RU.            */
         LA    @11,41                                              1391
         ALR   @11,BFRPTR                                          1391
         MVI   SRUQSREQ(@11),X'A1'                                 1391
*               IF LCPRSTRT=ON THEN /* IF THE CLEAR HAS BEEN         */
         TM    LCPRSTRT(LCPBPTR),B'00100000'                       1392
         BNO   @RF01392                                            1392
*                 DO;               /* PROCESSED THEN                */
*                   SRUQSREQ=SRUNBIND;/* FORMAT AN UNBIND PIU.       */
         MVI   SRUQSREQ(@11),X'32'                                 1394
*                   UNBTYPE=SRUNORM;/* INDICATE NORM END OF SESSION. */
         MVI   UNBTYPE(@11),X'01'                                  1395
*                   FDBDATCT=FDBDATCT+LENGTH(SRUTYPE);/* INCREMENT 1396
*                                      FDB DATA COUNT BY ONE.        */
         LA    @11,1                                               1396
         ALR   @00,@11                                             1396
         STH   @00,FDBDATCT(,BFRPTR)                               1396
*                   THDCF=THDCF+LENGTH(SRUTYPE);/* INCREMENT DATA  1397
*                                      COUNT FIELD BY ONE.           */
         ALR   @14,@11                                             1397
         STH   @14,THDCF(,@15)                                     1397
*                   FMCUIPI=ON;     /* INDICATE UNBIND IN PROGRESS.  */
         OI    FMCUIPI(FMCBPTR),B'00100000'                        1398
*                 END;              /* END CLEAR HAS BEEN PROCESSED. */
*               ELSE                /* IF CLEAR NOT PROCESSED THEN   */
*                 FMCCIPI=ON;       /* INDICATE CLEAR IN PROGRESS.   */
         B     @RC01392                                            1400
@RF01392 OI    FMCCIPI(FMCBPTR),B'01000000'                        1400
*             END;                  /* END FID1 PROCESSING.          */
*           ELSE                    /* LOCAL CHANNEL ATTACHED FOR    */
*             DO;                   /* 3791 (FID2 PROCESSING).       */
         B     @RC01379                                            1402
@RF01379 DS    0H                                                  1403
*               FDBDATAA=ADDR(ZOBTEXT);/* INIT FDB DATA ADDRESS.     */
         LA    @00,ZOBTEXT(,BFRPTR)                                1403
         ST    @00,FDBDATAA(,BFRPTR)                               1403
*               FDBDATCT=LENGTH(ISTTH2)+LENGTH(ISTLH)+LENGTH(ISTRH)+
*                   LENGTH(SRUQSREQ);/* INIT FDB DATA LENGTH FOR   1404
*                                      CLEAR (RU IS ONE BYTE)      1404
*                                                            @ZA16215*/
         LA    @00,14                                              1404
         STH   @00,FDBDATCT(,BFRPTR)                               1404
*               TH2FID=THFID2;      /* INDICATE FID2.                */
         LA    @15,32                                              1405
         ALR   @15,BFRPTR                                          1405
         NI    TH2FID(@15),B'00101111'                             1405
         OI    TH2FID(@15),B'00100000'                             1405
*               TH2PSI=ON;          /* INDICATE PRIMARY-SECONDARY.   */
*               TH2AFI=ON;          /* INDICATE ASYNCH FLOW.         */
         OI    TH2PSI(@15),B'00000011'                             1407
*               TH2MPF=MAPVAL;      /* INDICATE RH INCLUDED AND RU IS
*                                      COMPLETE.                     */
         OI    TH2MPF(@15),B'00001100'                             1408
*               TH2PYF=THCNOPYF;    /* INDICATE NO PRIORITY.         */
         NI    TH2PYF(@15),B'00001111'                             1409
*               TH2SEF=THCNOSEF;    /* INDICATE NO SECURITY.         */
         NI    TH2SEF(@15),B'11110011'                             1410
*               TH2CDF=THCNOCDF;    /* INDICATE NO CODE DEFINITION.  */
         NI    TH2CDF(@15),B'11111100'                             1411
*               TH2DAF=(NCBPTR->NCBDAF)-(ICNCBPTR->NCBNCBA);/* SET 1412
*                                      LOCAL DESTINATION FIELD OF  1412
*                                      CID.                          */
         LH    @14,NCBDAF(,NCBPTR)                                 1412
         N     @14,@CF05621                                        1412
         LH    @11,NCBNCBA(,ICNCBPTR)                              1412
         N     @11,@CF05621                                        1412
         SLR   @14,@11                                             1412
         STC   @14,TH2DAF(,@15)                                    1412
*               TH2OAF=FMCSAF-ATCVTMID;/* SET LOCAL SOURCE FIELD OF
*                                      CID.                          */
         LH    @14,FMCSAF(,FMCBPTR)                                1413
         N     @14,@CF05621                                        1413
         LH    @11,ATCVTMID(,VTCVTPTR)                             1413
         N     @11,@CF05621                                        1413
         SLR   @14,@11                                             1413
         STC   @14,TH2OAF(,@15)                                    1413
*               LHLEN=FDBDATCT;     /* SET LOCAL HEADER LENGTH.      */
         LA    @15,28                                              1414
         ALR   @15,BFRPTR                                          1414
         STH   @00,LHLEN(,@15)                                     1414
*               NIRRH=CLRRH;        /* SET REQ HEADER FOR CLEAR.     */
         MVC   NIRRH+38(3,BFRPTR),@CB05298                         1415
*               SRUQSREQ=SRCLEAR;   /* INDICATE CLEAR PIU.           */
         LA    @14,41                                              1416
         ALR   @14,BFRPTR                                          1416
         MVI   SRUQSREQ(@14),X'A1'                                 1416
*               IF LCPRSTRT=ON THEN /* IF CLEAR HAS ALREADY BEEN     */
         TM    LCPRSTRT(LCPBPTR),B'00100000'                       1417
         BNO   @RF01417                                            1417
*                 DO;               /* PROCESSED THEN                */
*                   SRUQSREQ=SRUNBIND;/* FORMAT UNBIND PIU.          */
         MVI   SRUQSREQ(@14),X'32'                                 1419
*                   UNBTYPE=SRUNORM;/* INDICATE NORM END OF SESSION. */
         MVI   UNBTYPE(@14),X'01'                                  1420
*                   FMCUIPI=ON;     /* INDICATE UNBIND IN PROGRESS.  */
         OI    FMCUIPI(FMCBPTR),B'00100000'                        1421
*                   FDBDATCT=FDBDATCT+LENGTH(SRUTYPE);/* INCREMENT 1422
*                                      DATA COUNT BY ONE FOR UNBIND
*                                      (RU IS TWO BYTES)     @ZA16215*/
         AL    @00,@CF00035                                        1422
         STH   @00,FDBDATCT(,BFRPTR)                               1422
*                   LHLEN=FDBDATCT; /* CORRECT LH LENGTH     @ZA16215*/
         STH   @00,LHLEN(,@15)                                     1423
*                 END;              /* END CLEAR ALREADY PROCESSED.  */
*               ELSE                /* FORMAT CLEAR PIU.             */
*                 FMCCIPI=ON;       /* INDICATE CLEAR IN PROGRESS.   */
         B     @RC01417                                            1425
@RF01417 OI    FMCCIPI(FMCBPTR),B'01000000'                        1425
*             END;                  /* END FID2 PROCESSING.          */
@RC01417 DS    0H                                                  1427
*         END;                      /* END FID1/FID2 PROCESSING.   1427
*                                                            @AS33958*/
@RC01379 DS    0H                                                  1428
*       LCPRSTRT=OFF;               /* SET OFF PARTIALLY PROC FLAG.  */
@RC01357 NI    LCPRSTRT(LCPBPTR),B'11011111'                       1428
*       IF NCBFTRIO=ON THEN         /* IF I/O TRACE IS REQUIRED THEN */
         CLI   NCBFTRIO(NCBPTR),1                                  1429
         BNE   @RF01429                                            1429
*         ZOBRT08=ON;               /* INDICATE IN THE OUTBOUND    1430
*                                      BUFFER TRACE IS REQUIRED.     */
         OI    ZOBRT08(BFRPTR),B'01000000'                         1430
*       ELSE                                                       1431
*         ;                         /* NO I/O TRACE REQUIRED.@AS33958*/
@RF01429 DS    0H                                                  1432
*     END;                          /* END NOT L/3270        @ZA26631*/
*   ZCRTSW2=ON;                     /* INDICATE BUFFER USED. @AS33958*/
@RC01352 OI    ZCRTSW2(ZCRRPTR),B'01000000'                        1433
*   RFY                                                            1434
*     REG14 RSTD;                                                  1434
*   REG14=ZCRSVF1;                  /* RESTORE RETURN ADDRESS.       */
         L     REG14,ZCRSVF1(,ZCRRPTR)                             1435
*   RFY                                                            1436
*     REG14 UNRSTD;                                                1436
*   RETURN;                                                        1437
@EL00006 DS    0H                                                  1437
@EF00006 DS    0H                                                  1437
@ER00006 BR    @14                                                 1437
*   END PIURTN;                                                    1438
@PB00006 DS    0H                                                  1439
         EJECT
*                                                                  1439
*   /*****************************************************************/
*   /*                                                               */
*   /* SEGMENT(WAITQSG)START                                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1439
*   DO;                                                            1439
*     GOTO WAITQSG@;                                               1440
         B     WAITQSG@                                            1440
*WAITQSG:                                                          1441
*   END;                                                           1441
*                                                                  1441
WAITQSG  DS    0H                                                  1442
*/********************************************************************/
*/*                                                                  */
*/*WAITQSG:BGNSEGMENT (BLOCK).                                       */
*/*                                                                  */
*/*FUNCTION IS TO                                                    */
*/*    1) MATCH THE FSB RECEIVED BY ISTZLFAB TO THE LCPB(S) ON THE   */
*/*    WAIT QUEUE IN THE ATCVT                                       */
*/*    2) CALL PIURTN TO PROCESS AN UNBIND OR A DISCONNECT IF A      */
*/*    CLEAR OR A RESET HAS BEEN PROCESSED                           */
*/*    3) CALL TPQUE ROUTINE WHEN TERMINATION PROCESSING IS COMPLETE */
*/*    4) FREE ALL LCPB(S) SUBJECT OR RECURSION.                     */
*/*                                                                  */
*/*  DO WHILE THERE ARE LCPB(S) ON THE WAIT QUEUE IN THE ATCVT.      */
*/*    IF THE LCPB IS SUBJECT TO RECURSION (THE LCPB ORIGINATED FROM */
*/*        A TERMINATION TASK WHICH HAS ABENDED)                     */
*/*      THEN                                                        */
*/*        CALL DEQRTN TO DEQUEUE THE LCPB FROM THE WAIT QUEUE.      */
*/*        CALL FREERTN TO RELEASE THE LCPB.                         */
*/*      ELSE (NOT RECURSIVE LCPB)                                   */
*/*        IF THE LCPB IS ASSOCIATED WITH THE FSB (THE COMMUNICATION */
*/*            ID(S) MATCH)                                          */
*/*          THEN                                                    */
*/*            TURN OFF THE CLEAR AND UNBIND IN PROGRESS FLAGS IN    */
*/*                THE FMCB.                                         */
*/*            IF NCB AVAILABLE AND A CLEAR COMPLETED SUCCESSFULLY   */
*/*                OR A RESET IMMEDIATE HAS BEEN PROCESSED           */
*/*              THEN (CLEAR OR RESET IMMEDIATE COMPLETED)           */
*/*                CALL SUB370X TO CHECK FOR THE PATH BEING SICK OR  */
*/*                    TO HANDLE SLOWDOWN CONDITIONS.                */
*/*                IF THE PATH IS SICK                               */
*/*                  THEN (PATH SICK...DO NOT INITIATE FURTHER I/O)  */
*/*                    CALL DEQRTN TO DEQUEUE THE LCPB FROM THE WAIT */
*/*                        QUEUE.                                    */
*/*                    CALL TPQUERTN TO QUEUE THE FSB FOR THE CLOSE  */
*/*                        DESTINATION PROCESSING THUS INDICATING    */
*/*                        THAT THE SESSION NO LONGER EXISTS (NO     */
*/*                        FURTHER I/O WILL BE DONE BY               */
*/*                        ISTZLFAB).                        @AS33958*/
*/*                  ELSE (PATH NOT SICK...INITIATE I/O)             */
*/*                    CALL PIURTN TO BUILD A PIU FOR THE DISCONNECT */
*/*                        (FID0) OR THE UNBIND (FID1/FID2).         */
*/*                    CALL ISTZEFBB (EXTERNAL), THE SHIPOUT         */
*/*                        ROUTINE, TO INITIATE THE I/O).            */
*/*                ENDIF (THE PATH IS SICK).                         */
*/*                                                                  */
*/*              ELSE (UNBIND, DISCONNECT, OR RESET ERROR LOCK       */
*/*                  COMPLETED OR NO NCB)                            */
*/*                IF DISCONNECT WAS DONE BUT IT WAS NOT SUCCESSFUL  */
*/*                  THEN (UNSUCCESSFUL DISCONNECT)                  */
*/*                    CALL SUB370X TO CHECK FOR THE PATH BEING SICK */
*/*                        OR TO HANDLE SLOWDOWN CONDITIONS.         */
*/*                    IF THE PATH IS SICK                           */
*/*                      THEN (PATH SICK...DO NOT INITIATE FURTHER   */
*/*                          I/O)                                    */
*/*                        CALL DEQRTN TO DEQUEUE THE LCPB FROM THE  */
*/*                            WAIT QUEUE.                           */
*/*                        CALL TPQUERTN TO QUEUE THE FSB FOR THE    */
*/*                            CLOSE DESTINATION PROCESSING THUS     */
*/*                            INDICATING THAT THE SESSION NO LONGER */
*/*                            EXISTS (NO FURTHER I/O WILL BE DONE   */
*/*                            BY ISTZLFAB).                 @AS33958*/
*/*                      ELSE (PATH NOT SICK...INITIATE I/O)         */
*/*                        CALL PIURTN TO BUILD A PIU FOR A RESET.   */
*/*                        MAKE THE PIU A RESET ERROR LOCK PIU.      */
*/*                        CALL ISTZEFBB (EXTERNAL), THE SHIPOUT     */
*/*                            ROUTINE, TO INITIATE THE I/O.         */
*/*                    ENDIF (THE PATH IS SICK).                     */
*/*                  ELSE (NOT AN UNSUCCESSFUL DISCONNECT...ALL I/O  */
*/*                      IS COMPLETE)                                */
*/*                    CALL DEQRTN TO DEQUEUE THE LCPB FROM THE WAIT */
*/*                        QUEUE.                                    */
*/*                    IF THE NCB IS AVAILABLE                       */
*/*                      THEN                                        */
*/*                        RESTORE NCB TASK ID (PST POINTER).        */
*/*                    ENDIF (NCB AVAILABLE).                        */
*/*                    CALL TPQUERTN TO QUEUE THE FSB FOR THE CLOSE  */
*/*                        DESTINATION PROCESSING THUS INDICATING    */
*/*                        THAT THE SESSION NO LONGER EXISTS.        */
*/*                    RESTORE THE NCB TASK ID.              @AS33958*/
*/*                ENDIF (UNSUCCESSFUL DISCONNECT).                  */
*/*            ENDIF (CLEAR OR RESET IMMEDIATE PROCESSED).           */
*/*            INDICATE THAT THERE ARE NO MORE LCPB(S) TO PROCESS.   */
*/*          ELSE (THE LCPB IS NOT ASSOCIATED WITH THE FSB)          */
*/*            POINT TO THE NEXT LCPB ON THE WAIT QUEUE IF THERE IS  */
*/*                ONE.                                              */
*/*        ENDIF (THE LCPB IS ASSOCIATED WITH THE FSB).              */
*/*    ENDIF (THE LCPB IS RECURSIVE).                                */
*/*  ENDDO (WHILE THERE ARE LCPB(S) ON THE WAIT QUEUE).              */
*/* IF THE BUFFER CONTAINING THE FSB WAS NOT QUEUED FOR CLOSE        */
*/*     DESTINATION PROCESSING OR USED FOR I/O                       */
*/*   THEN                                                   @AS33958*/
*/*     CALL FREERTN TO RELEASE THE FSB.                     @AS33958*/
*/* ENDIF.                                                   @AS33958*/
*/*                                                                  */
*/*ENDSEGMENT(WAITQSG).                                              */
*/*                                                                  */
*/********************************************************************/
*                                                                  1442
*   LCPBPTR=ATCTPWQA;               /* POINT TO FIRST LCPB ON THE  1442
*                                      WAIT QUEUE.                   */
         L     LCPBPTR,ATCTPWQA(,VTCVTPTR)                         1442
*   ZCRTSW2=OFF;                    /* INITIALIZE SWITCH TO INDICATE
*                                      THAT THE BUFFER CONTAINING THE
*                                      FSB HAS NOT BEEN REUSED AND 1443
*                                      CAN THEREFORE BE FREED.     1443
*                                                            @AS33958*/
         NI    ZCRTSW2(ZCRRPTR),B'10111111'                        1443
*   DO WHILE((LCPBPTR&MASK)^=0);    /* LOOP THROUGH THE LCPB LOOKING
*                                      FOR A MATCH/LDNCB     @ZA26631*/
         B     @DE01444                                            1444
@DL01444 DS    0H                                                  1445
*     ICNCBPTR=LCCWDATA;            /* INIT PTR TO ICNCB FROM LCPB.  */
         L     @15,LCPNXLCW(,LCPBPTR)                              1445
         L     ICNCBPTR,LCCWDATA(,@15)                             1445
*     IF LCPZRT00=ON THEN           /* IF THE LCPB IS RECURSIVE THEN */
         TM    LCPZRT00(LCPBPTR),B'10000000'                       1446
         BNO   @RF01446                                            1446
*       DO;                                                        1447
*         CALL DEQRTN;              /* DEQUEUE THE LCPB.             */
         BAL   @14,DEQRTN                                          1448
*         WKREG=LCPBPTR;            /* POINT TO THE LCPB.            */
         LR    WKREG,LCPBPTR                                       1449
*         CALL FREERTN;             /* FREE THE LCPB.                */
         BAL   @14,FREERTN                                         1450
*         LCPBPTR=ATCTPWQA;         /* POINT TO NEXT LCPB ON WAIT  1451
*                                      QUEUE.                        */
         L     LCPBPTR,ATCTPWQA(,VTCVTPTR)                         1451
*         RFY                                                      1452
*           ISTPIU BASED(ADDR(ZIBBTU));/*                            */
*       END;                        /* END LCPB RECURSIVE.           */
*     ELSE                          /* IF LCPB NOT RECURSIVE THEN    */
*       IF FSBCID=LCPCID THEN       /* IF FSB MATCHES THE LCPB       */
         B     @RC01446                                            1454
@RF01446 CLC   FSBCID+16(4,BFRPTR),LCPCID(LCPBPTR)                 1454
         BNE   @RF01454                                            1454
*         DO;                       /*                       @ZA26631*/
*           IF ICNCBPTR->NCBTYPE=LDTYPE THEN/* IF L/3270     @ZA26631*/
         CLI   NCBTYPE(ICNCBPTR),X'07'                             1456
         BNE   @RF01456                                            1456
*             DO;                   /*                       @ZA26631*/
*               CALL DEQRTN;        /* DEQUE THE LCPB        @ZA26631*/
         BAL   @14,DEQRTN                                          1458
*               NCBTSKID=LCPFLCCW;  /* RESTORE TASK ID       @ZA26631*/
         L     @00,LCPFLCCW(,LCPBPTR)                              1459
         ST    @00,NCBTSKID(,NCBPTR)                               1459
*               CALL TPQUERTN;      /* POST CALLERS REQUEST  @ZA26631*/
         BAL   @14,TPQUERTN                                        1460
*             END;                  /* END FSB FOR L/3270    @ZA26631*/
*           ELSE                                                   1462
*             IF                    /* NOT L/3270            @ZA26631*/
*                 (THFID=THFID0|    /* FID0 OR                       */
*                 (RHSENSE=OFF&(SRUQSREQ=SRCLEAR|SRUQSREQ=SRUNBIND))|
*                                   /* RESPONSE TO CLEAR OR UNBIND OR*/
*                 (RHSENSE=ON&(SENRU(1)=SRCLEAR|SENRU(1)=SRUNBIND)))
*               THEN                /* AN ERROR ON A CLEAR/UNBIND    */
         B     @RC01456                                            1462
@RF01456 TM    THFID+48(BFRPTR),B'11110000'                        1462
         BZ    @RT01462                                            1462
         TM    RHSENSE+58(BFRPTR),B'00000100'                      1462
         BNZ   @GL00007                                            1462
         LA    @15,61                                              1462
         ALR   @15,BFRPTR                                          1462
         CLI   SRUQSREQ(@15),X'A1'                                 1462
         BE    @RT01462                                            1462
         CLI   SRUQSREQ(@15),X'32'                                 1462
         BE    @RT01462                                            1462
@GL00007 TM    RHSENSE+58(BFRPTR),B'00000100'                      1462
         BNO   @RF01462                                            1462
         LA    @15,61                                              1462
         ALR   @15,BFRPTR                                          1462
         CLI   SENRU(@15),X'A1'                                    1462
         BE    @RT01462                                            1462
         CLI   SENRU(@15),X'32'                                    1462
         BNE   @RF01462                                            1462
@RT01462 DS    0H                                                  1463
*               DO;                 /* THEN                  @AS33958*/
*                 IF ICNCBPTR^=NCBPTR&/* IF DNCB/LUNCB IS AVAILABLE
*                                      AND                           */
*                     LCPRSTRT=ON&  /* IT IS A CLEAR OR A RESET AND  */
*                     (LCCWOP^=LCLEAR|RHSENSE=OFF) THEN/* NO ERROR ON
*                                      CLEAR                         */
         CR    ICNCBPTR,NCBPTR                                     1464
         BE    @RF01464                                            1464
         TM    LCPRSTRT(LCPBPTR),B'00100000'                       1464
         BNO   @RF01464                                            1464
         L     @15,LCPNXLCW(,LCPBPTR)                              1464
         CLI   LCCWOP(@15),X'F2'                                   1464
         BNE   @RT01464                                            1464
         TM    RHSENSE+58(BFRPTR),B'00000100'                      1464
         BNZ   @RF01464                                            1464
@RT01464 DS    0H                                                  1465
*                   DO;             /* THEN                          */
*                     RFY                                          1466
*                       ISTPIU BASED(ADDR(ZOBBTU));/*                */
*                     CALL SUB370X; /* CHECK SICK/SHUTDOWN STATE.    */
         BAL   @14,SUB370X                                         1467
*                     IF ZCRTSW1=ON THEN/* IF FSB TO BE QUEUED     1468
*                                      (DEVICE                       */
         TM    ZCRTSW1(ZCRRPTR),B'10000000'                        1468
         BNO   @RF01468                                            1468
*                       DO;         /* IS SICK) THEN         @AS33958*/
*                         CALL DEQRTN;/* DEQUEUE THE LCPB.           */
         BAL   @14,DEQRTN                                          1470
*                         CALL TPQUERTN;/* QUEUE THE FSB FOR CLSDST.
*                                                            @AS33958*/
         BAL   @14,TPQUERTN                                        1471
*                       END;        /* END FSB TO BE QUEUED. @AS33958*/
*                     ELSE          /* DEVICE NOT SICK THEREFORE     */
*                       DO;         /* INITIATE I/O.                 */
         B     @RC01468                                            1473
@RF01468 DS    0H                                                  1474
*                         CALL PIURTN;/* BUILD UNBIND/DISCONNECT PIU.*/
         BAL   @14,PIURTN                                          1474
*                         CALL ISTZEFBB;/* SHIPOUT THE PIU.          */
         L     @14,ATCZFSVT(,VTCVTPTR)                             1475
         L     @15,ZFSZEFBB(,@14)                                  1475
         BALR  @14,@15                                             1475
*                       END;        /* END DEVICE NOT SICK.          */
*                   END;            /* END CLEAR OR RESET PROCESSED. */
*                 ELSE              /* DISCONNECT, UNBIND, OR RESET  */
*                   DO;             /* ERROR LOCK PROCESSED.         */
         B     @RC01464                                            1478
@RF01464 DS    0H                                                  1479
*                     IF NCBTYPE=DNTYPE&/* IF A DISCONNECT WAS       */
*                         DNCZF001=OFF&/* COMPLETED                  */
*                         FSBSERR=ON THEN/* BUT WAS NOT SUCCESSFUL   */
         CLI   NCBTYPE(NCBPTR),X'05'                               1479
         BNE   @RF01479                                            1479
         TM    DNCZF001(NCBPTR),B'10000000'                        1479
         BNZ   @RF01479                                            1479
         TM    FSBSERR+16(BFRPTR),B'10000000'                      1479
         BNO   @RF01479                                            1479
*                       DO;         /* THEN                          */
*                         CALL SUB370X;/* CHECK FOR SICK/SHUTDOWN  1481
*                                                              STATE.*/
         BAL   @14,SUB370X                                         1481
*                         IF ZCRTSW1=ON THEN/* IF FSB IS NOT TO BE 1482
*                                      QUEUED                        */
         TM    ZCRTSW1(ZCRRPTR),B'10000000'                        1482
         BNO   @RF01482                                            1482
*                           DO;     /* (DEVICE IS SICK) THEN         */
*                             CALL DEQRTN;/* DEQUEUE THE LCPB.       */
         BAL   @14,DEQRTN                                          1484
*                             CALL TPQUERTN;/* QUEUE THE FSB FOR   1485
*                                      CLSDST.               @AS33958*/
         BAL   @14,TPQUERTN                                        1485
*                           END;    /* END FSB NOT TO BE QUEUED.     */
*                         ELSE      /* DEVICE NOT SICK THEREFORE     */
*                           DO;     /* INITIATE I/O.                 */
         B     @RC01482                                            1487
@RF01482 DS    0H                                                  1488
*                             CALL PIURTN;/* BUILD RESET PIU.        */
         BAL   @14,PIURTN                                          1488
*                             BDUMODIF=BMODZEM;/* MAKE PIU RESET   1489
*                                      ERROR LCK.                    */
         MVI   BDUMODIF+42(BFRPTR),X'41'                           1489
*                             CALL ISTZEFBB;/* SHIPOUT THE PIU.      */
         L     @14,ATCZFSVT(,VTCVTPTR)                             1490
         L     @15,ZFSZEFBB(,@14)                                  1490
         BALR  @14,@15                                             1490
*                             DNCZF001=ON;/* INDICATE RESET ERROR  1491
*                                      LOCK IS SENT.                 */
         OI    DNCZF001(NCBPTR),B'10000000'                        1491
*                           END;    /* END DEVICE NOT SICK.          */
*                       END;        /* END UNSUCCESSFUL DISCONNECT.  */
*                     ELSE                                         1494
*                       DO;         /* TERMINATION COMPLETE.         */
         B     @RC01479                                            1494
@RF01479 DS    0H                                                  1495
*                         CALL DEQRTN;/* DEQUEUE LCPB.               */
         BAL   @14,DEQRTN                                          1495
*                         NCBTSKID=LCPFLCCW;/* RESTORE THE NCB TASK
*                                      ID.                   @AS33958*/
         L     @00,LCPFLCCW(,LCPBPTR)                              1496
         ST    @00,NCBTSKID(,NCBPTR)                               1496
*                         CALL TPQUERTN;/* QUEUE THE FSB FOR CLSDST. */
         BAL   @14,TPQUERTN                                        1497
*                       END;        /* END TERMINATION COMPLETE.     */
*                   END;            /* END DISCONNECT, UNBIND, OR  1499
*                                      RESET ERROR LOCK COMPLETED.   */
@RC01479 DS    0H                                                  1500
*               END;                /* END FSB MATCH FOR     @ZA26631
*                                      NOT L/3270            @ZA26631*/
@RC01464 DS    0H                                                  1501
*           LCPBPTR=0;              /* EXIT THE LOOP.                */
@RF01462 DS    0H                                                  1501
@RC01456 SLR   LCPBPTR,LCPBPTR                                     1501
*         END;                      /* END LCPB-FSB MATCH FOUND.     */
*       ELSE                        /* LCPB DOES NOT MATCH THE FSB.  */
*         LCPBPTR=LCPCHAIN;         /* PTR TO NEXT LCPB ON THE WAIT
*                                      QUEUE.                        */
         B     @RC01454                                            1503
@RF01454 L     LCPBPTR,LCPCHAIN(,LCPBPTR)                          1503
*   END;                            /* END LOOP FOR LCPB-FSB MATCH.  */
@RC01454 DS    0H                                                  1504
@RC01446 DS    0H                                                  1504
@DE01444 LR    @00,LCPBPTR                                         1504
         N     @00,@CF01714                                        1504
         LTR   @00,@00                                             1504
         BNZ   @DL01444                                            1504
*   IF ZCRTSW2=OFF THEN             /* IF THE FSB HAS NOT BEEN QUEUED
*                                      FOR CLSDST OR USED FOR I/O  1505
*                                      THEN                  @AS33958*/
         TM    ZCRTSW2(ZCRRPTR),B'01000000'                        1505
         BNZ   @RF01505                                            1505
*     DO;                           /*                       @AS33958*/
*       WKREG=BFRPTR;               /* POINT TO FSB TO BE FREED    1507
*                                                            @AS33958*/
         LR    WKREG,BFRPTR                                        1507
*       CALL FREERTN;               /* FREE THE BUFFER.      @AS33958*/
         BAL   @14,FREERTN                                         1508
*     END;                          /* END FREE FSB.         @AS33958*/
*   ELSE                                                           1510
*     ;                             /* FSB STILL IN USE.     @AS33958*/
*                                                                  1510
@RF01505 DS    0H                                                  1511
*   /*****************************************************************/
*   /*                                                               */
*   /* SEGMENT(WAITQSG)FINISH                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1511
*   DO;                                                            1511
*     GOTO WAITQSG#;                                               1512
         B     WAITQSG#                                            1512
*WAITQSG@:                                                         1513
*   END;                                                           1513
         EJECT
*                                                                  1514
*/********************************************************************/
*/*                                                                  */
*/*INOPRTN: BGNSEGMENT (SUBROUTINE).                                 */
*/*                                                                  */
*/*FUNCTION IS                                                       */
*/*    1) FOR QUIESCE FSB(S), POST THE ASSOCIATED LCPB, IF ANY, AND  */
*/*    FREE THE FSB.                                                 */
*/*    2) FOR NCSPL(S), POST THE ASSOCIATED LCPB AND POST VARY'S RPH */
*/*    (IN NCSPL)                                                    */
*/*    3) CHECK FOR RECURSIVE LCPB(S) (LCPB(S) ORIGINATING FROM A    */
*/*    TERMINATION TASK WHICH HAS ABENDED) AND FREE THEM.            */
*/*  DO WHILE THERE ARE LCPB(S) ON THE WAIT QUEUE IN THE ATCVT.      */
*/*    IF THE LCPB IS RECURSIVE                                      */
*/*      THEN                                                        */
*/*        CALL DEQRTN TO DEQUEUE THE LCPB FROM THE WAIT QUEUE.      */
*/*        CALL FREERTN TO RELEASE THE LCPB.                         */
*/*      ELSE                                                        */
*/*        IF THE LCPB IS ASSOCIATED WITH THE QUIESCE FSB OR THE     */
*/*            NCSPL                                                 */
*/*          THEN                                                    */
*/*            NOTE - FOR THE QUIESCE FSB, THE LCPB IS ASSOCIATED    */
*/*                IF THE ICNCB POINTER IN THE FSB MATCHES THE       */
*/*                POINTER TO THE ICNCB (LOCAL ICNCB)                */
*/*                IN THE LCPB --------- FOR THE NCSPL, THE LCPB     */
*/*                IS ASSOCIATED IF ITS COMMUNICATIONS ID (CID)      */
*/*                MATCHES THE CID IN THE NCSPL.                     */
*/*            CALL DEQRTN TO DEQUEUE THE LCPB FROM THE WAIT QUEUE.  */
*/*            CALL TPQUERTN TO QUEUE THE FSB FOR THE CLOSE          */
*/*                DESTINATION PROCESSING THUS INDICATING THAT       */
*/*                THE SESSION NO LONGER EXISTS (ISTZLFAB WILL       */
*/*                NOT WAIT FOR THE I/O TO COMPLETE).                */
*/*        ENDIF (LCPB ASSOCIATED WITH THE QUIESCE FSB OR THE NCSPL).*/
*/*    ENDIF (LCPB IS RECURSIVE).                                    */
*/*    LOOK AT THE NEXT LCPB (IF THERE IS ONE) ON THE WAIT QUEUE.    */
*/*  ENDDO (LCPB(S)) ON THE WAIT QUEUE).                             */
*/*  IF ISTZLFAB RECEIVED A QUIESCE FSB                              */
*/*    THEN                                                          */
*/*      CALL FREERTN TO RELEASE THE BUFFER CONTAINING THE QUIESCE   */
*/*          FSB.                                            @AS33958*/
*/*    ELSE (RECEIVED A NCSPL)                                       */
*/*      POST VARY'S RPH IN THE NCSPL.                               */
*/*  ENDIF (ISTZLFAB RECEIVED A QUIESCE FSB).                        */
*/*                                                                  */
*/*ENDSEGMENT (INOPRTN).                                             */
*/*                                                                  */
*/********************************************************************/
*                                                                  1514
*INOPRTN:                                                          1514
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1514
         B     @PB00007                                            1514
INOPRTN  DS    0H                                                  1515
*   RFY                                                            1515
*     REG14 RSTD;                                                  1515
*   ZCRSVF2=REG14;                  /* SAVE RETURN ADDRESS.          */
         ST    REG14,ZCRSVF2(,ZCRRPTR)                             1516
*   RFY                                                            1517
*     REG14 UNRSTD;                                                1517
*   LCPBPTR=ATCTPWQA;               /* POINT TO THE FIRST LCPB ON THE
*                                      WAIT QUEUE.                   */
         L     LCPBPTR,ATCTPWQA(,VTCVTPTR)                         1518
*   RFY                                                            1519
*     ISTFSB BASED(BFRPTR);         /* REBASE THE FSB.               */
*   BFRPTR=RPHWEA;                  /* POINT TO THE WORK ELEMENT.    */
         L     BFRPTR,RPHWEA(,RPHAPTR)                             1520
*   ZCRSVWK5=BFRPTR;                /* SAVE POINTER TO THE BUFFER.   */
         ST    BFRPTR,ZCRSVWK5(,ZCRRPTR)                           1521
*   DO WHILE((LCPBPTR&MASK)^=0);    /* LOOP THROUGH THE LCPB(S) ON 1522
*                                      THE WAIT QUEUE.               */
         B     @DE01522                                            1522
@DL01522 DS    0H                                                  1523
*     ICNCBPTR=LCCWDATA;            /* GET PTR TO ICNCB FROM LCPB.   */
         L     @15,LCPNXLCW(,LCPBPTR)                              1523
         L     ICNCBPTR,LCCWDATA(,@15)                             1523
*     DO WHILE ICNCBPTR->NCBNSNA^=0;/* IF A REMOTE ICNCB THEN        */
         B     @DE01524                                            1524
@DL01524 DS    0H                                                  1525
*       ICNCBPTR=ICNCBPTR->NCBNSNA; /* GET PTR TO THE LOCAL ICNCB.   */
         L     ICNCBPTR,NCBNSNA(,ICNCBPTR)                         1525
*     END;                          /* END SEARCH FOR LOCAL ICNCB.   */
@DE01524 L     @00,NCBNSNA(,ICNCBPTR)                              1526
         LTR   @00,@00                                             1526
         BNZ   @DL01524                                            1526
*     IF LCPZRT00=ON|(FSBTYPE=FSTYPE&FSBICNCB=ICNCBPTR)/* LCPB     1527
*                                      RECURSIVE OR QUIESCE ICNCB  1527
*                                      MATCHES WAIT QUEUE LCPB OR    */
*         |(FSBTYPE^=FSTYPE&        /* AN INOPERATIVE IS RECEIVED    */
*         LCPCID=NCSPLCID) THEN     /* FOR THE WAIT QUEUE LCPB THEN  */
         TM    LCPZRT00(LCPBPTR),B'10000000'                       1527
         BO    @RT01527                                            1527
         CLI   FSBTYPE(BFRPTR),X'02'                               1527
         BNE   @GL00018                                            1527
         C     ICNCBPTR,FSBICNCB(,BFRPTR)                          1527
         BE    @RT01527                                            1527
@GL00018 CLI   FSBTYPE(BFRPTR),X'02'                               1527
         BE    @RF01527                                            1527
         CLC   LCPCID(4,LCPBPTR),NCSPLCID(BFRPTR)                  1527
         BNE   @RF01527                                            1527
@RT01527 DS    0H                                                  1528
*       DO;                                                        1528
*         CIDPARM=LCPCID;           /* GET CID               @ZA30934*/
         L     CIDPARM,LCPCID(,LCPBPTR)                            1529
*         CALL CIDRTN;              /* LOCATE THE NCB        @ZA30934*/
         BAL   @14,CIDRTN                                          1530
*         CALL DEQRTN;              /* DEQUEUE THE LCPB.             */
         BAL   @14,DEQRTN                                          1531
*         IF LCPZRT00=ON THEN       /* IF LCPB IS RECURSIVE THEN     */
         TM    LCPZRT00(LCPBPTR),B'10000000'                       1532
         BNO   @RF01532                                            1532
*           DO;                                                    1533
*             WKREG=LCPBPTR;        /* POINT TO THE LCPB.            */
         LR    WKREG,LCPBPTR                                       1534
*             CALL FREERTN;         /* RELEASE THE LCPB.             */
         BAL   @14,FREERTN                                         1535
*           END;                    /* END RECURSIVE LCPB.           */
*         ELSE                                                     1537
*           DO;                     /* NOT RECURSIVE LCPB.           */
         B     @RC01532                                            1537
@RF01532 DS    0H                                                  1538
*             BFRPTR=0;             /* ZERO PTR TO BUFFER.           */
         SLR   BFRPTR,BFRPTR                                       1538
*             CALL TPQUERTN;        /* QUEUE THE FSB FOR CLSDST.     */
         BAL   @14,TPQUERTN                                        1539
*             BFRPTR=ZCRSVWK5;      /* RESTORE THE POINTER TO THE  1540
*                                      WORK ELEMENT.                 */
         L     BFRPTR,ZCRSVWK5(,ZCRRPTR)                           1540
*           END;                    /* END NOT RECURSIVE.            */
*         LCPBPTR=ATCTPWQA;         /* POINT TO THE NEXT LCPB.       */
@RC01532 L     LCPBPTR,ATCTPWQA(,VTCVTPTR)                         1542
*       END;                        /* END RECURSIVE LCPB OR LCPB IS
*                                      ASSOCIATED WITH QUIESCE FSB OR
*                                      INOPERATIVE BOX.              */
*     ELSE                          /* LCPB IS NOT RECURSIVE AND IS
*                                      NOT ASSOCIATED WITH QUIESCE 1544
*                                      FSB OR INOPERATIVE BOX.       */
*       LCPBPTR=LCPCHAIN;           /* POINT TO THE NEXT LCPB.       */
         B     @RC01527                                            1544
@RF01527 L     LCPBPTR,LCPCHAIN(,LCPBPTR)                          1544
*   END;                            /* END LOOP THROUGH LCPB(S).     */
@RC01527 DS    0H                                                  1545
@DE01522 LR    @00,LCPBPTR                                         1545
         N     @00,@CF01714                                        1545
         LTR   @00,@00                                             1545
         BNZ   @DL01522                                            1545
*   IF FSBTYPE=FSTYPE THEN          /* IF WORK ELEMENT IS A FSB      */
         CLI   FSBTYPE(BFRPTR),X'02'                               1546
         BNE   @RF01546                                            1546
*     DO;                           /* (QUIESCE) THEN                */
*       RFY                                                        1548
*         ISTFSB BASED(ADDR(ZIBFSB));/* REBASE FSB.                  */
*       BFRPTR=BFRPTR-(ADDR(ZIBFSB)-ADDR(ISTZIBUF));/* POINT TO    1549
*                                      BEGINNING OF BUFFER.          */
         LA    @00,ZIBFSB(,BFRPTR)                                 1549
         LCR   @00,@00                                             1549
         ALR   @00,BFRPTR                                          1549
         ALR   BFRPTR,@00                                          1549
*       WKREG=BFRPTR;               /* POINT TO BUFFER TO BE FREED.  */
         LR    WKREG,BFRPTR                                        1550
*       CALL FREERTN;               /* FREE THE BUFFER.      @AS33958*/
         BAL   @14,FREERTN                                         1551
*     END;                          /* END WORK ELEMENT IS A FSB.    */
*   ELSE                            /* WORK ELEMENT IS A NCSPL.      */
*/*TPPOST  (NCSPLRPH)                                                */
*                                                                  1553
*     DO;                           /* DECLARE AND RESTRICT REGS     */
         B     @RC01546                                            1553
@RF01546 DS    0H                                                  1554
*       RESPECIFY                                                  1554
*        (GPR00F,                                                  1554
*         GPR01F,                                                  1554
*         GPR04F,                                                  1554
*         GPR05F,                                                  1554
*         GPR06F,                                                  1554
*         GPR14F,                                                  1554
*         GPR15F) RSTD;             /* 0,1,4,5,6,14, AND 15          */
*/* ATBUILD (ISTPAB,ISTDYPAB,ISTRPH)                                 */
*/* END OF ATBUILD                                                   */
*                                                                  1555
*       GEN REFS(GPR01P,GPR02F,GPR06F) SETS(RPHWORK);              1555
        STM GPR02F,GPR06F,RPHWORK(GPR01P)
*       GPR04F=NCSPLRPH;            /* LOAD RPH PNTR INTO REG 4      */
         L     GPR04F,NCSPLRPH(,BFRPTR)                            1556
*       RFY                                                        1557
*         GPR03F RSTD;                                             1557
*       GPR03F=0;                                                  1558
         SLR   @11,@11                                             1558
         LR    GPR03F,@11                                          1558
*       DO;                         /* MODESET SAVEKEY(GPR06F)     1559
*                                      KEYADDR(GPR03F)             1559
*                                      WORKREG(GPR05F)               */
*         RESPECIFY                                                1560
*          (GPR02F) RESTRICTED;                                    1560
*         GPR05F=GPR02F;            /* SAVE REGISTER 2               */
         LR    GPR05F,GPR02F                                       1561
*         IPK;                      /* SAVE CURRENT PSW KEY          */
         IPK                                                       1562
*         GPR06F=GPR02F;                                           1563
         LR    GPR06F,GPR02F                                       1563
*         GPR02F=GPR05F;            /* RESTORE REGISTER 2            */
         LR    GPR02F,GPR05F                                       1564
*         SPKA(GPR03F);             /* SET PSW KEY                   */
         SPKA  0(GPR03F)                                           1565
*         RESPECIFY                                                1566
*          (GPR02F) UNRESTRICTED;                                  1566
*       END;                        /* MODESET SAVEKEY(GPR06F)     1567
*                                      KEYADDR(GPR03F)             1567
*                                      WORKREG(GPR05F)               */
*       RFY                                                        1568
*         GPR03F UNRSTD;                                           1568
*       GPR05P=GPR04P->RPHMAJCB+GPR04P->RPHPABOF;/* LOAD REG 5 WITH
*                                      ADDR OF MAJOR CONTROL BLOCK 1569
*                                      PLUS OFFSET OF PAB IN BLOCK   */
         L     GPR05P,RPHMAJCB-1(,GPR04P)                          1569
         LA    GPR05P,0(,GPR05P)                                   1569
         SLR   @10,@10                                             1569
         IC    @10,RPHPABOF(,GPR04P)                               1569
         ALR   GPR05P,@10                                          1569
*       GPR14P=0;                   /* LOAD 0 INTO REG 14            */
         LR    GPR14P,@11                                          1570
*       GPR15P='FFFFFFFF'X;         /* LOAD REG 15 WITH DUMMY ADDRESS*/
         SLR   GPR15P,GPR15P                                       1571
         BCTR  GPR15P,0                                            1571
*       CS(GPR14P,GPR15P,GPR04P->RPHRESMA);/* COMPARE RESUME ADDRESS
*                                      WITH 0 AND,IF EQUAL, PUT DUMMY
*                                      ADDRESS IN CONTROL BLOCK    1572
*                                      RESUME ADDRESS                */
         CS    GPR14P,@15,RPHRESMA(GPR04P)                         1572
*       BC(8,FMZT0143);             /* IF EQUAL, BYPASS REMAINDER OF
*                                      EXPANSION                     */
         BC    8,FMZT0143                                          1573
*FMZL0143:                                                         1574
*       IF GPR04P->RPHWT='1'B THEN  /* WT/EXT CONTENTION FLAG ON     */
FMZL0143 TM    RPHWT(GPR04P),B'00001000'                           1574
         BNO   @RF01574                                            1574
*         DO;                       /* IN RPH                        */
*           GPR14P=GPR04P->RPHRESMA|RPHWT1;/* LOAD REG 14 WITH FLAG
*                                      FIELD AND MAKE CERTAIN WT/EXT
*                                      CONTENTION FLAG STILL ON      */
         L     GPR14P,RPHRESMA(,GPR04P)                            1576
         O     GPR14P,@CF01675                                     1576
*           GPR15P=GPR14P|RPHPT1;   /* LOAD REG 15 WITH FLAG FIELD 1577
*                                      AND TURN POST FLAG ON         */
         LR    GPR15P,GPR14P                                       1577
         O     GPR15P,@CF01679                                     1577
*           CS(GPR14P,GPR15P,GPR04P->RPHRESMA);/* COMPARE REG 14 WITH
*                                      FLAG FIELD--IF WT/EXT BIT ON,
*                                      TURN ON POST FLAG             */
         CS    GPR14P,@15,RPHRESMA(GPR04P)                         1578
*           BC(4,FMZL0143);         /* IF WT/EXT BIT WAS OFF, LOOP TO
*                                      TEST CONTENTION FLAG          */
         BC    4,FMZL0143                                          1579
*           BC(8,FMZT0143);         /* IF WT/EXT BIT WAS OFF, BRANCH
*                                      TO BYPASS CODE GEN            */
         BC    8,FMZT0143                                          1580
*         END;                      /* IF POST FLAG IS ON, FALL THRU
*                                      BOTTOM OF LOOP                */
*       ELSE                                                       1582
*         ;                         /* WT/EXT CONTENTION FLAG OFF    */
@RF01574 DS    0H                                                  1583
*       IF GPR04P->RPHTSKID=GPR01P->RPHTSKID THEN                  1583
         CLC   RPHTSKID(4,GPR04P),RPHTSKID(GPR01P)                 1583
         BNE   @RF01583                                            1583
*         DO;                                                      1584
*           GPR05P->PABCHNGP=GPR01P->RPHPABQP;/* PUT PAB QUEUE     1585
*                                      ADDRESS IN SECOND WORD OF PAB */
         MVC   PABCHNGP(3,GPR05P),RPHPABQP(GPR01P)                 1585
*           GPR01P->RPHPABQP=GPR05P;/* PUT PAB ADDRESS (IN MAJOR   1586
*                                      CONTROL BLOCK) IN PAB QUEUE 1586
*                                      ADRESS IN RPH                 */
         STCM  GPR05P,7,RPHPABQP(GPR01P)                           1586
*         END;                                                     1587
*       ELSE                                                       1588
*         DO;                                                      1588
         B     @RC01583                                            1588
@RF01583 DS    0H                                                  1589
*           GPR00F=0;               /* SET REG 0 TO INDICATE ENA     */
         SLR   GPR00F,GPR00F                                       1589
*           DO;                     /* LISATCVT                    1590
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*             GPR15P=ATCLCPTR;      /* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     1591
*           END;                    /* LISATCVT PUT POINTER TO ATCVT
*                                      IN IN REG 15                  */
*           CALL GPR15P->ATCAP32;   /* CALL ISTAPC32: TPSCHED        */
         L     @11,ATCAP32(,GPR15P)                                1593
         LR    @15,@11                                             1593
         BALR  @14,@15                                             1593
*         END;                                                     1594
*FMZT0143:                                                         1595
*       DO;                         /* MODESET KEYADDR(GPR06F)     1595
*                                      WORKREG(GPR05F)               */
@RC01583 DS    0H                                                  1595
FMZT0143 DS    0H                                                  1596
*         GPR05F=GPR06F;            /* GET KEY FORM SAVE LOCATION    */
         LR    GPR05F,GPR06F                                       1596
*         SPKA(GPR05F);             /* SET PSW KEY                   */
         SPKA  0(GPR05F)                                           1597
*       END;                        /* MODESET KEYADDR(GPR06F)     1598
*                                      WORKREG(GPR05F)               */
*       GEN REFS(GPR04P,RPHWORK) SETS(GPR02F,GPR03F,GPR04F,GPR05F, 1599
*           GPR06F);                                               1599
        LM GPR02F,GPR06F,RPHWORK(GPR01P)
*       RESPECIFY                                                  1600
*        (GPR00F,                                                  1600
*         GPR01F,                                                  1600
*         GPR04F,                                                  1600
*         GPR05F,                                                  1600
*         GPR06F,                                                  1600
*         GPR14F,                                                  1600
*         GPR15F) UNRSTD;           /* UNRESTRICT REGS 0,1, 4,5,14,
*                                      AND 15                        */
*     END;                          /* ***END OF TPPOST GENERATION***
*                                      POST VARY'S RPH IN THE NCSPL. */
*   RFY                                                            1602
*     REG14 RSTD;                                                  1602
@RC01546 DS    0H                                                  1603
*   REG14=ZCRSVF2;                  /* RESTORE RETURN REGISTER.      */
         L     REG14,ZCRSVF2(,ZCRRPTR)                             1603
*   RFY                                                            1604
*     REG14 UNRSTD;                                                1604
*   RETURN;                                                        1605
@EL00007 DS    0H                                                  1605
@EF00007 DS    0H                                                  1605
@ER00007 BR    @14                                                 1605
*   END INOPRTN;                                                   1606
         EJECT
*                                                                  1607
*/********************************************************************/
*/*                                                                  */
*/*TPQUERTN: BGNSEGMENT (SUBROUTINE).                                */
*/*                                                                  */
*/*FUNCTION IS TO QUEUE THE FSB FOR CLOSE DESTINATION PROCESSING TO  */
*/*    INDICATE THAT THE SESSION NO LONGER EXISTS.                   */
*/*                                                                  */
*/*  INCLUDE DNCBPRC TO CLEAN UP THE DNCB.                   @AS33958*/
*/*  IF THERE IS NO FSB                                              */
*/*    THEN                                                          */
*/*      CALL ISTZDFA0 (EXTERNAL), THE TPIOS ALLOCATION ROUTINE,     */
*/*          TO ALLOCATE A FSB.                                      */
*/*  ENDIF (THERE IS NO FSB).                                        */
*/*  INITIALIZE THE REQUIRED FSB FIELDS TO INDICATE THAT THE SESSION */
*/*      NO LONGER EXISTS.                                           */
*/*  ISSUE TPQUE(NORM) TO QUEUE THE FSB TO THE PAB POINTED TO BY THE */
*/*      LCPB ON THE WAIT QUEUE TO INDICATE THAT THE SESSION HAS     */
*/*      BEEN TERMINATED.                                            */
*/*                                                                  */
*/*ENDSEGMENT (TPQUERTN).                                            */
*/*                                                                  */
*/********************************************************************/
*                                                                  1607
*TPQUERTN:                                                         1607
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1607
TPQUERTN DS    0H                                                  1608
*   RFY                                                            1608
*     REG14 RSTD;                                                  1608
*   ZCRSVF3=REG14;                  /* SAVE RETURN ADDRESS.          */
         ST    REG14,ZCRSVF3(,ZCRRPTR)                             1609
*   RFY                                                            1610
*     REG14 UNRSTD;                                                1610
*   RFY                                                            1611
*     ISTFSB BASED(BFRPTR);         /* BASE THE FSB.                 */
*   RFY                                                            1612
*     ISTFDB BASED(ADDR(FSBFDB));   /* BASE THE FDB.                 */
*                                                                  1612
*   /*****************************************************************/
*   /*                                                               */
*   /* SEGMENT(DNCBPRC)REQUEST                                       */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1613
*   DO;                                                            1613
*     GOTO DNCBPRC;                                                1614
         B     DNCBPRC                                             1614
*DNCBPRC#:                                                         1615
*   END;                            /* CLEANUP DNCB IF REQUIRED.   1615
*                                                            @AS33958*/
DNCBPRC# DS    0H                                                  1616
*   IF BFRPTR=0 THEN                /* IF NO FSB                     */
         LTR   BFRPTR,BFRPTR                                       1616
         BNZ   @RF01616                                            1616
*     DO;                           /* THEN                          */
*       ZCRPCOD1=0;                 /* ZERO PARAMETER FLAGS.         */
         MVI   ZCRPCOD1(ZCRRPTR),X'00'                             1618
*       ZCRPFSB=ON;                 /* INDICATE OBTAIN FSB.          */
         OI    ZCRPFSB(ZCRRPTR),B'00100000'                        1619
*       CALL ATCZPSVT->ZPSZDFA0;    /* CALL BUFFER ALLOCATION.       */
         L     @14,ATCZPSVT(,VTCVTPTR)                             1620
         L     @15,ZPSZDFA0(,@14)                                  1620
         BALR  @14,@15                                             1620
*       BFRPTR=RPHSRPRM;            /* POINT TO THE FSB.             */
         L     BFRPTR,RPHSRPRM(,RPHAPTR)                           1621
*     END;                          /* END NO FSB.                   */
*   ELSE                                                           1623
*     DO;                           /* IF FSB EXISTS THEN            */
         B     @RC01616                                            1623
@RF01616 DS    0H                                                  1624
*       ISTFSB=ISTFSB&&ISTFSB;      /* ZERO THE FSB.         @AS33958*/
         XC    ISTFSB(44,BFRPTR),ISTFSB(BFRPTR)                    1624
*       FSBTYPE=FSTYPE;             /* SET UP FSB TYPE.              */
         MVI   FSBTYPE(BFRPTR),X'02'                               1625
*       FSBLNGTH=LENGTH(ISTFSB);    /* SET UP FSB LENGTH.            */
         MVI   FSBLNGTH(BFRPTR),X'2C'                              1626
*       FSBFSBA=0;                  /* ZERO PTR TO THE NEXT FSB.     */
         SLR   @00,@00                                             1627
         ST    @00,FSBFSBA(,BFRPTR)                                1627
*     END;                          /* END FSB EXISTS.               */
*   FSBMJRCD=FRNORM;                /* SET MAJOR RC TO INDICATE    1629
*                                      NORMAL FEEDBACK.              */
@RC01616 MVI   FSBMJRCD(BFRPTR),X'00'                              1629
*   FSBMNRCD=FRMOK;                 /* SET MINOR RC FOR OK SO FAR.   */
         MVI   FSBMNRCD(BFRPTR),X'00'                              1630
*   FSBLCPB=LCPBPTR;                /* SET POINTER TO THE LCPB.      */
         ST    LCPBPTR,FSBLCPB(,BFRPTR)                            1631
*   FDBOFSET=ADDR(FSBFDB)-BFRPTR;   /* SET FDB OFFSET.               */
         LA    @00,FSBFDB(,BFRPTR)                                 1632
         SLR   @00,BFRPTR                                          1632
         STH   @00,FDBOFSET+32(,BFRPTR)                            1632
*/*  TPQUE (BFRPTR,LCPRPHA->PABWEQA) NORM                            */
*                                                                  1633
*   DO;                                                            1633
*     RFY                                                          1634
*      (GPR00P,                                                    1634
*       GPR01P,                                                    1634
*       GPR04P,                                                    1634
*       GPR05P,                                                    1634
*       GPR15P) RSTD;                                              1634
*     GEN REFS(GPR01P) SETS(RPHWORK)(STM GPR02P,GPR08P,RPHWORK(GPR01P))
*         ;                                                        1635
         STM GPR02P,GPR08P,RPHWORK(GPR01P)
*     GPR00P=0;                                                    1636
         SLR   GPR00P,GPR00P                                       1636
*     GPR15P=ADDR(LCPRPHA->PABWEQA);/* HOLD PAB PTR                  */
         L     GPR15P,LCPRPHA(,LCPBPTR)                            1637
*     GPR04P=BFRPTR;                /* WORK ELE PTR                  */
         LR    GPR04P,BFRPTR                                       1638
*     GPR05P=GPR15P;                /* PASS PAB PTR                  */
         LR    GPR05P,GPR15P                                       1639
*     CALL ATCLCPTR->ATCAP37->ISTAPC37;                            1640
         L     @14,ATCLCPTR                                        1640
         L     @15,ATCAP37(,@14)                                   1640
         BALR  @14,@15                                             1640
*     GEN(NOPR  0)                                                 1641
*     NOSETS NOREFS;                                               1641
         NOPR  0
*     RFY                                                          1642
*      (GPR00P,                                                    1642
*       GPR01P,                                                    1642
*       GPR04P,                                                    1642
*       GPR05P,                                                    1642
*       GPR15P) UNRSTD;                                            1642
*   END;                            /* *** END OF TPQUE GENERATION 1643
*                                      QUEUE THE FSB FOR CLSDST.     */
*   ZCRTSW2=ON;                     /* INDICATE THE FSB IS QUEUED FOR
*                                      CLSDST (BUFFER IS BEING USED).
*                                                            @AS33958*/
         OI    ZCRTSW2(ZCRRPTR),B'01000000'                        1644
*   RFY                                                            1645
*     REG14 RSTD;                                                  1645
*   REG14=ZCRSVF3;                  /* RESTORE RETURN ADDRESS.       */
         L     REG14,ZCRSVF3(,ZCRRPTR)                             1646
*   RFY                                                            1647
*     REG14 UNRSTD;                                                1647
*   RETURN;                                                        1648
@EL00008 DS    0H                                                  1648
@EF00008 DS    0H                                                  1648
@ER00008 BR    @14                                                 1648
         EJECT
*                                                                  1649
*   /*****************************************************************/
*   /*                                                               */
*   /* SEGMENT(DNCBPRC)START                                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1649
*   DO;                                                            1649
*     GOTO DNCBPRC@;                                               1650
*DNCBPRC:                                                          1651
*   END;                                                           1651
*                                                                  1651
DNCBPRC  DS    0H                                                  1652
*/********************************************************************/
*/*                                                                  */
*/*DNCBPRC:BGNSEGMENT (BLOCK).                               @AS33958*/
*/*                                                                  */
*/*FUNCTION IS TO DO ANY REQUIRED CLEANUP PROCESSING FOR THE DNCB.   */
*/*                                                                  */
*/*  IF THE DNCB IS AVAILABLE AND THE DEVICE IS NON-SNA              */
*/*    THEN                                                          */
*/*      CALL ISTZDFB0 (EXTERNAL), THE BUFFER DEALLOCATION           */
*/*          ROUTINE, TO PURGE THE FREE LSCB QUEUE, IF               */
*/*          NECESSARY.                                              */
*/*      IF IT IS A MULTI-COMPONENT DEVICE                           */
*/*        THEN                                                      */
*/*          DECREMENT THE SESSION COUNT IN THE DNCB BY ONE          */
*/*              IF MORE THAN ONE COMPONENT IS ACTIVE.               */
*/*          TURN OFF THE DISCONNECT OUTSTANDING FLAG IN THE DNCB.   */
*/*          CLEAR THE I/O SCHEDULED COUNT IN THE DNCB.              */
*/*      ENDIF (MULTI-COMPONENT DEVICE).                             */
*/*      IF THERE ARE MULTIPLE FMCB(S)                               */
*/*        THEN                                                      */
*/*          NOTE - THIS WILL BE TRUE ONLY FOR PORT SOLICITOR OR     */
*/*              CLUSTER SOLICITOR.                                  */
*/*          CLEAN UP THE SESSION FLAGS IN THE DNCB.                 */
*/*          ZERO THE POINTER IN THE DNCB TO THE ACTIVE FMCB.        */
*/*          SET THE TASK ID IN THE NCB TO THE VTAM TASK ID.         */
*/*      ENDIF (MULTIPLE FMCB(S).                                    */
*/*  ENDIF (DNCB IS AVAILABLE AND NON-SNA DEVICE).                   */
*/*ENDSEGMENT (DNCBPRC).                                             */
*/*                                                                  */
*/********************************************************************/
*                                                                  1652
*   IF ICNCBPTR^=NCBPTR THEN        /* IF THE NCB IS AVAILABLE THEN  */
         CR    ICNCBPTR,NCBPTR                                     1652
         BE    @RF01652                                            1652
*     IF NCBTYPE=DNTYPE THEN        /* IF THE DEVICE IS NON-SNA THEN */
         CLI   NCBTYPE(NCBPTR),X'05'                               1653
         BNE   @RF01653                                            1653
*       DO;                         /* THEN CLEAN UP DNCB.           */
*         WKREG=ADDR(DNCZC001);     /*                       @ZA26159*/
         LA    WKREG,DNCZC001(,NCBPTR)                             1655
*         PABWQCHN=PABWQCHN&&PABWQCHN;/* ZERO WORK ELEMENT @ AND   1656
*                                      CHAIN POINTER.        @ZA26159*/
         XC    PABWQCHN(8,WKREG),PABWQCHN(WKREG)                   1656
*         PABERRLK=OFF;             /* CLEAR THE ERROR LOCK. @ZA26159*/
*         PABINHBT=OFF;             /* CLEAR THE INHIBIT FLG @ZA26159*/
         L     @00,PABINHBT(,WKREG)                                1658
@GL00022 LR    @15,@00                                             1658
         N     @15,@CF05608                                        1658
         CS    @00,@15,PABINHBT(WKREG)                             1658
         BNE   @GL00022                                            1658
*         PABRPHA=PABRPHA&&PABRPHA; /* ZERO RPH POINTER.     @ZA26159*/
         L     @15,PABRPHA-1(,WKREG)                               1659
         LA    @15,0(,@15)                                         1659
         LR    @00,@15                                             1659
         XR    @00,@15                                             1659
         STCM  @00,7,PABRPHA(WKREG)                                1659
*         IF DNCZX001^=0 THEN       /* IF THE FREE LSCB QUEUE IS TO  */
         CLI   DNCZX001(NCBPTR),0                                  1660
         BE    @RF01660                                            1660
*           DO;                     /* BE PURGED THEN                */
*             ZCRPCOD1=0;           /* CLEAR THE PARAMETER FLAGS.    */
         MVI   ZCRPCOD1(ZCRRPTR),X'00'                             1662
*             ZCRPLSBQ=ON;          /* INDICATE PURGE LSCB QUEUE.    */
         OI    ZCRPLSBQ(ZCRRPTR),B'00010000'                       1663
*             CALL ISTZDFB0;        /* CALL BUFFER DEALLOCATION RTN. */
         L     @14,ATCZPSVT(,VTCVTPTR)                             1664
         L     @15,ZPSZDFB0(,@14)                                  1664
         BALR  @14,@15                                             1664
*           END;                    /* END FREE LSCB QUEUE PURGED.   */
*         ELSE                                                     1666
*           ;                       /* FREE LSCB Q DOES NOT NEED TO
*                                      BE PURGED.                    */
@RF01660 DS    0H                                                  1667
*         IF NCBNSNA->NCBTYPE=DNTYPE THEN/* IF MULTI-COMPONENT       */
         L     @15,NCBNSNA(,NCBPTR)                                1667
         CLI   NCBTYPE(@15),X'05'                                  1667
         BNE   @RF01667                                            1667
*           DO;                     /* DEVICE THEN                   */
*             IF NCBNSNA->DNCZX003^=0 THEN/* IF MORE THAN ONE      1669
*                                      COMPONENT IS ACTIVE THEN      */
         CLI   DNCZX003(@15),0                                     1669
         BE    @RF01669                                            1669
*               NCBNSNA->DNCZX003=NCBNSNA->DNCZX003-1;/* DECREMENT 1670
*                                      THE SESSION COUNT BY ONE.     */
         SLR   @00,@00                                             1670
         IC    @00,DNCZX003(,@15)                                  1670
         BCTR  @00,0                                               1670
         STC   @00,DNCZX003(,@15)                                  1670
*             ELSE                                                 1671
*               ;                   /* NOT MORE THAN ONE COMPONENT 1671
*                                      ACTIVE.                       */
@RF01669 DS    0H                                                  1672
*             NCBNSNA->DNCDISC=OFF; /* TURN OFF DISCONNECT         1672
*                                      OUTSTANDING FLAG.             */
         L     @15,NCBNSNA(,NCBPTR)                                1672
         NI    DNCDISC(@15),B'11110111'                            1672
*             NCBNSNA->DNCACIP=0;   /* CLEAR THE SCHEDULE COUNT.     */
         MVI   DNCACIP(@15),X'00'                                  1673
*           END;                    /* END MULTI-COMP PROCESSING.    */
*         IF NCBFMCBA->FMCFMCBA^=0 THEN/* IF ANOTHER FMCB ACTIVE   1675
*                                      (PORT SOLICITOR OR CLUSTER    */
@RF01667 SLR   @15,@15                                             1675
         L     @14,NCBFMCBA(,NCBPTR)                               1675
         C     @15,FMCFMCBA(,@14)                                  1675
         BE    @RF01675                                            1675
*           DO;                     /* SOLICITOR) THEN               */
*             DNCACIP=0;            /* CLEAR THE SCHEDULE COUNT.     */
         MVI   DNCACIP(NCBPTR),X'00'                               1677
*             DNCZF001=OFF;         /* TURN OFF ERROR LCK INDICATOR. */
*             DNCZRSCH=ON;          /* INDICATE DEVICE RESCHEDULED.  */
*             DNCZF002=OFF;         /* TURN OFF DIALOGUE SCHEDULING
*                                      IS IN PROGRESS.               */
         OI    DNCZRSCH(NCBPTR),B'00000100'                        1680
         NI    DNCZF001(NCBPTR),B'01111101'                        1680
*             DNCZV001=0;           /* CLEAR ACTIVE FMCB POINTER.    */
         STCM  @15,7,DNCZV001(NCBPTR)                              1681
*             ADDR(DNCZC001)->PABWEQG=OFF;/* TURN OFF THE GATE BIT IN
*                                      THE TIP                       */
         LA    @15,96                                              1682
         ALR   @15,NCBPTR                                          1682
         NI    PABWEQG(@15),B'01111111'                            1682
*             ADDR(DNCZC001)->PABDVTA=DNCZV004;/* SET PAB DVT PTR TO
*                                      DIALOGUE SCHEDULER DVT.       */
         MVC   PABDVTA(3,@15),DNCZV004+1(NCBPTR)                   1683
*             NCBTSKID=ATCCDTID;    /* SET TASK ID TO VTAM TASK ID.  */
         L     @00,ATCCDTID(,VTCVTPTR)                             1684
         ST    @00,NCBTSKID(,NCBPTR)                               1684
*           END;                    /* END MULTIPLE FMCB(S).         */
*         ELSE                                                     1686
*           ;                       /* SINGLE FMCB.                  */
@RF01675 DS    0H                                                  1687
*       END;                        /* END NON-SNA DEVICE.           */
*     ELSE                                                         1688
*       DO;                         /* SNA DEVICE.                   */
         B     @RC01653                                            1688
@RF01653 DS    0H                                                  1689
*         IF NCBTYPE=LUTYPE THEN                                   1689
         CLI   NCBTYPE(NCBPTR),X'25'                               1689
         BNE   @RF01689                                            1689
*           DO;                     /* IS NCB LUNCB ?        @ZA26159*/
*             WKREG=ADDR(LUNZC001); /*                       @ZA26159*/
         LA    WKREG,LUNZC001(,NCBPTR)                             1691
*             PABWQCHN=PABWQCHN&&PABWQCHN;/* ZERO WORK ELEMENT @ AND
*                                      CHAIN POINTER.        @ZA26159*/
         XC    PABWQCHN(8,WKREG),PABWQCHN(WKREG)                   1692
*             PABERRLK=OFF;         /* CLEAR THE ERROR LOCK. @ZA26159*/
*             PABINHBT=OFF;         /* CLEAR THE INHIBIT FLG @ZA26159*/
         L     @00,PABINHBT(,WKREG)                                1694
@GL00023 LR    @15,@00                                             1694
         N     @15,@CF05608                                        1694
         CS    @00,@15,PABINHBT(WKREG)                             1694
         BNE   @GL00023                                            1694
*             PABRPHA=PABRPHA&&PABRPHA;/* ZERO RPH POINTER.  @ZA26159*/
         L     @15,PABRPHA-1(,WKREG)                               1695
         LA    @15,0(,@15)                                         1695
         LR    @00,@15                                             1695
         XR    @00,@15                                             1695
         STCM  @00,7,PABRPHA(WKREG)                                1695
*           END;                    /* NCB IS LUNCB          @ZA26159*/
*         FMCSNBI=OFF;              /* TURN OFF SESSION NOT BOUND  1697
*                                      FLAG.                 @AS33958*/
@RF01689 DS    0H                                                  1698
*         FMCCIPI=OFF;              /* TURN OFF CLEAR IN PROGRESS  1698
*                                      FLAG.                 @AS33958*/
*         FMCUIPI=OFF;              /* TURN OFF UNBIND IN PROGRESS 1699
*                                      FLAG.                 @AS33958*/
         NI    FMCSNBI(FMCBPTR),B'00011111'                        1699
*       END;                        /* END SNA DEVICE.               */
*   ELSE                                                           1701
*     ;                             /* NCB IS NOT AVAILABLE.         */
*                                                                  1701
@RF01652 DS    0H                                                  1702
*   /*****************************************************************/
*   /*                                                               */
*   /* SEGMENT(DNCBPRC)FINISH                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1702
*   DO;                                                            1702
@RC01652 DS    0H                                                  1703
*     GOTO DNCBPRC#;                                               1703
         B     DNCBPRC#                                            1703
*DNCBPRC@:                                                         1704
*   END;                                                           1704
*   END TPQUERTN;                                                  1705
         B     @EL00008                                            1705
         EJECT
*                                                                  1706
*/********************************************************************/
*/*                                                                  */
*/*DEQRTN:BGNSEGMENT (SUBROUTINE).                                   */
*/*                                                                  */
*/*FUNCTION IS TO DEQUEUE THE SPECIFIED LCPB FROM THE WAIT QUEUE     */
*/*    IN THE ATCVT.                                                 */
*/*                                                                  */
*/*  ISSUE TPDEQ TO DEQUEUE THE SPECIFIED LCPB FROM THE WAIT QUEUE   */
*/*      IN THE ATCVT.                                               */
*/*                                                                  */
*/*ENDSEGMENT(DEQRTN).                                               */
*/*                                                                  */
*/********************************************************************/
*                                                                  1706
*DEQRTN:                                                           1706
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1706
DEQRTN   DS    0H                                                  1707
*   RFY                                                            1707
*     REG14 RSTD;                                                  1707
*   ZCRSVF4=REG14;                  /* SAVE RETURN ADDRESS.          */
         ST    REG14,ZCRSVF4(,ZCRRPTR)                             1708
*   RFY                                                            1709
*     REG14 UNRSTD;                                                1709
*                                                                  1709
*/* TPDEQ (LCPBPTR,ATCTPWQA)                                         */
*                                                                  1710
*   DO;                             /* BEGIN TPDEQ CODE GENERATION   */
*     RFY                                                          1711
*      (GPR00P,                                                    1711
*       GPR01P,                                                    1711
*       GPR14P,                                                    1711
*       GPR15P) RSTD;                                              1711
*     GPR15P=ADDR(ATCTPWQA);        /* ADDRESS QUEUE POINTER         */
         LA    GPR15P,ATCTPWQA(,VTCVTPTR)                          1712
*     RFY                                                          1713
*      (GPR02P,                                                    1713
*       GPR03P) RSTD;                                              1713
*     STM(GPR02P,GPR03P,GPR01P->RPHWORK(5:12));                    1714
         STM   GPR02P,GPR03P,RPHWORK+4(GPR01P)                     1714
*     GPR03P=LCPBPTR|FMZCA043;                                     1715
         L     @11,@CF01716                                        1715
         LR    GPR03P,LCPBPTR                                      1715
         OR    GPR03P,@11                                          1715
*     GPR14P=FMZCA043;                                             1716
         LR    GPR14P,@11                                          1716
*     GPR15P=ADDR(GPR15P->PABWEQA);                                1717
*     GPR02P=GPR15P->PABWEQA|FMZCA043;                             1718
         O     @11,PABWEQA(,GPR15P)                                1718
         LR    GPR02P,@11                                          1718
*     DO WHILE(GPR02P^=GPR14P);                                    1719
         B     @DE01719                                            1719
@DL01719 DS    0H                                                  1720
*FMZL2164:                                                         1720
*       ;                                                          1720
FMZL2164 DS    0H                                                  1721
*       IF GPR02P=GPR03P THEN                                      1721
         CR    GPR02P,GPR03P                                       1721
         BNE   @RF01721                                            1721
*         DO;                                                      1722
*           GPR00P=GPR02P->WKECHAIN;                               1723
         L     GPR00P,WKECHAIN(,GPR02P)                            1723
*           CS(GPR02P,GPR00P,GPR15P->PABWEQA);                     1724
         CS    GPR02P,@00,PABWEQA(GPR15P)                          1724
*           BC(7,FMZL3164);                                        1725
         BC    7,FMZL3164                                          1725
*           GPR14P=GPR02P;                                         1726
         LR    GPR14P,GPR02P                                       1726
*           GPR14P->WKECHAIN=0;                                    1727
         SLR   @11,@11                                             1727
         ST    @11,WKECHAIN(,GPR14P)                               1727
*         END;                                                     1728
*       ELSE                                                       1729
*         DO;                                                      1729
         B     @RC01721                                            1729
@RF01721 DS    0H                                                  1730
*           IF(GPR02P->WKECHAIN)=GPR14P THEN                       1730
         L     @11,WKECHAIN(,GPR02P)                               1730
         CR    @11,GPR14P                                          1730
         BE    @RT01730                                            1730
*             GOTO ISTA0164;                                       1731
*           ELSE                                                   1732
*             DO;                                                  1732
*               GPR15P=ADDR(GPR02P->WKECHAIN);                     1733
         LA    GPR15P,WKECHAIN(,GPR02P)                            1733
*               GPR02P=GPR02P->WKECHAIN;                           1734
         LR    GPR02P,@11                                          1734
*               GOTO FMZL2164;                                     1735
         B     FMZL2164                                            1735
*             END;                                                 1736
*         END;                                                     1737
*FMZL3164:                                                         1738
*       ;                                                          1738
@RC01721 DS    0H                                                  1738
FMZL3164 DS    0H                                                  1739
*     END;                                                         1739
@DE01719 CR    GPR02P,GPR14P                                       1739
         BNE   @DL01719                                            1739
*ISTA0164:                                                         1740
*     ;                                                            1740
ISTA0164 DS    0H                                                  1741
*     LM(GPR02P,GPR03P,GPR01P->RPHWORK(5:12));                     1741
         LM    GPR02P,GPR03P,RPHWORK+4(GPR01P)                     1741
*     RFY                                                          1742
*      (GPR02P,                                                    1742
*       GPR03P) UNRSTD;                                            1742
*     GPR14P=GPR14P&FMZCB043;                                      1743
         N     GPR14P,@CF01714                                     1743
*     GPR01P->RPHWEA=GPR14P;                                       1744
         ST    GPR14P,RPHWEA(,GPR01P)                              1744
*     RFY                                                          1745
*      (GPR00P,                                                    1745
*       GPR01P,                                                    1745
*       GPR14P,                                                    1745
*       GPR15P) UNRSTD;                                            1745
*   END;                            /* END TPDEQ GENERATION DEQUEUE
*                                      THE SPECIFIED LCPB.           */
*   RFY                                                            1747
*     REG14 RSTD;                                                  1747
*   REG14=ZCRSVF4;                  /* RESTORE RETURN ADDRESS.       */
         L     REG14,ZCRSVF4(,ZCRRPTR)                             1748
*   RFY                                                            1749
*     REG14 UNRSTD;                                                1749
*   RETURN;                                                        1750
@EL00009 DS    0H                                                  1750
@EF00009 DS    0H                                                  1750
@ER00009 BR    @14                                                 1750
*   END DEQRTN;                                                    1751
         EJECT
*                                                                  1752
*/********************************************************************/
*/*                                                                  */
*/*FREERTN: BGNSEGMENT (SUBROUTINE).                                 */
*/*                                                                  */
*/*FUNCTION IS TO RELEASE THE STORAGE THAT WAS USED FOR THE LCPB,    */
*/*    OR THE BUFFERS ON THE START I/O QUEUES.                       */
*/*                                                                  */
*/*  ISSUE RELSTORE TO RELEASE THE SPECIFIED STORAGE.                */
*/*                                                                  */
*/*ENDSEGMENT(FREERTN).                                              */
*/*                                                                  */
*/********************************************************************/
*                                                                  1752
*FREERTN:                                                          1752
*   PROC OPTIONS(NOSAVE,NOSAVEAREA);                               1752
FREERTN  DS    0H                                                  1753
*   RFY                                                            1753
*     REG14 RSTD;                                                  1753
*   ZCRSVF3=REG14;                  /* SAVE RETURN ADDRESS.          */
         ST    REG14,ZCRSVF3(,ZCRRPTR)                             1754
*   RFY                                                            1755
*     REG14 UNRSTD;                                                1755
*                                                                  1755
*   /*****************************************************************/
*   /*                                                               */
*   /* RELSTORE BUFADDR(WKREG)CLEAR(YES)                             */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1756
*   DO;                                                            1756
*                                                                  1756
*/* ATBUILD (ISTATCVT,ISTRPH)                                        */
*/* END OF ATBUILD                                                   */
*                                                                  1757
*     RFY                                                          1757
*      (GPR02P,                                                    1757
*       GPR03P,                                                    1757
*       GPR04P,                                                    1757
*       GPR15P) RSTD;                                              1757
*     RFY                                                          1758
*      (GPR01P,                                                    1758
*       GPR13P) RSTD;                                              1758
*     GENERATE REFS(GPR01P,GPR02P,GPR13P) SETS(RPHWORK);           1759
          STM GPR02P,GPR13P,RPHWORK(GPR01P)
*     RFY                                                          1760
*       GPR13P UNRSTD;                                             1760
*     GPR04P=WKREG|'80000000'X;                                    1761
         LR    GPR04P,WKREG                                        1761
         O     GPR04P,@CF01716                                     1761
*     DCL                                                          1762
*       1 FMZA0170 FIXED(31) STATIC LOCAL,                         1762
*        2 * FIXED(8) INIT(64),                                    1762
*        2 * PTR(24) INIT(0);                                      1762
*     GPR03F=FMZA0170;                                             1763
         L     GPR03F,FMZA0170                                     1763
*     DO;                           /* LISATCVT                    1764
*                                      CVTBASE(PAGEABLE,(GPR15P))    */
*       GPR15P=ATCLCPTR;            /* SET UP ATCVT POINTER          */
         L     GPR15P,ATCLCPTR                                     1765
*     END;                          /* LISATCVT                      */
*     GPR02P=GPR15P->ATCBPDA;                                      1767
         L     GPR02P,ATCBPDA(,GPR15P)                             1767
*     GPR15P=GPR15P->ATCSMRS;                                      1768
         L     GPR15P,ATCSMRS(,GPR15P)                             1768
*     DCL                                                          1769
*       FMZL0170 BASED(GPR15P) LABEL VALUERANGE(*);                1769
*     CALL FMZL0170;                                               1770
         BALR  @14,@15                                             1770
*     RFY                                                          1771
*       GPR13P RSTD;                                               1771
*     GENERATE REFS(GPR01P,RPHWORK) SETS(GPR02P,GPR13P);           1772
          LM GPR02P,GPR13P,RPHWORK(GPR01P)
*     RFY                                                          1773
*      (GPR01P,                                                    1773
*       GPR13P) UNRSTD;                                            1773
*     RFY                                                          1774
*      (GPR02P,                                                    1774
*       GPR03P,                                                    1774
*       GPR04P,                                                    1774
*       GPR15P) UNRSTD;                                            1774
*   END;                            /* *********END OF RELSTORE    1775
*                                      EXPANSION********* RELEASE  1775
*                                      STORAGE.              @AS33958*/
*   RFY                                                            1776
*     REG14 RSTD;                                                  1776
*   REG14=ZCRSVF3;                  /* RESTORE RETURN ADDRESS.       */
         L     REG14,ZCRSVF3(,ZCRRPTR)                             1777
*   RFY                                                            1778
*     REG14 UNRSTD;                                                1778
*   RETURN;                                                        1779
@EL00010 DS    0H                                                  1779
@EF00010 DS    0H                                                  1779
@ER00010 BR    @14                                                 1779
*   END FREERTN;                                                   1780
@PB00010 DS    0H                                                  1781
         EJECT
*                                                                  1781
*   /*****************************************************************/
*   /*                                                               */
*   /* SEGMENT(LOCLRTN)START                                         */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1781
*   DO;                                                            1781
*     GOTO LOCLRTN@;                                               1782
         B     LOCLRTN@                                            1782
*LOCLRTN:                                                          1783
*   END;                                                           1783
*                                                                  1783
LOCLRTN  DS    0H                                                  1784
*/********************************************************************/
*/*                                                                  */
*/*LOCLRTN: BGNSEGMENT (BLOCK).                                      */
*/*                                                                  */
*/*FUNCTION IS TO PERFORM THE CLEANUP PROCESSING FOR THE             */
*/*    LOCAL 3270.                                                   */
*/*  FORMAT THE BUFFER TO INITIATE RESET END OF COMMAND      @ZA26631*/
*/*                                                                  */
*/*ENDSEGMENT (LOCLRTN).                                             */
*/*                                                                  */
*/********************************************************************/
*/*                                                                  */
*/* LDNCPQ SHOULD NOT BE ZEROED OR FREED BECAUSE:                    */
*/*   (1) IT MAY BE POINTING TO A C.P. ALREADY FREED.                */
*/*   (2) THE WRITE C.P. SHOULD FINISH BEFORE ZLAAB GETS CONTROL.    */
*/*   (3) THE READ C.P. IS FREED BY ZFA0A (CHANNEL END).             */
*/*                                                                  */
*/********************************************************************/
*/********************************************************************/
*                                                                  1784
*   RFY                                                            1784
*     ISTFSB BASED(ADDR(ZLBFSB));   /* REBASE FSB            @ZA26631*/
*   ZLBCPCF1=ZLBTPIOS;              /* CCW OP CODE TO CONTROL      1785
*                                                            @ZA26631*/
         MVI   ZLBCPCF1(BFRPTR),X'FF'                              1785
*   ZLBCMOD=ZLBREOF;                /* DO RESET END OF COMMAND     1786
*                                                            @ZA26631*/
         MVI   ZLBCMOD(BFRPTR),X'0C'                               1786
*   ZLBRQTG='0000'X;                /* ZERO REQUEST TAG TO INDICATE
*                                      ABEND PROCESS         @ZA26631*/
         MVC   ZLBRQTG(2,BFRPTR),@CB02556                          1787
*   ZLBLCPBA=LCPBPTR;               /* INIT POINTER TO LCPB IN ZLBUF
*                                                            @ZA26631*/
         ST    LCPBPTR,ZLBLCPBA(,BFRPTR)                           1788
*   ZLBSAF=LCPSAF;                  /* INIT SOURCE N.A.      @ZA26631*/
         MVC   ZLBSAF(2,BFRPTR),LCPSAF(LCPBPTR)                    1789
*   FSBSAF=LCPSAF;                  /* SOURCE N.A. IN FSB OVERLAY IN
*                                      ZLBUF                 @ZA26631*/
         LA    @15,16                                              1790
         ALR   @15,BFRPTR                                          1790
         MVC   FSBSAF(2,@15),LCPSAF(LCPBPTR)                       1790
*   FSBDAF=LCPDAF;                  /* DESTINATION N.A. IN FSB     1791
*                                      OVERLAY IN ZLBUF      @ZA26631*/
         MVC   FSBDAF(2,@15),LCPDAF(LCPBPTR)                       1791
*   LDNZF007=OFF;                   /* CLEAR THE ATTN RECEIVED FLAG. */
         L     @00,LDNZF007-3(,ICNCBPTR)                           1792
@GL00024 LR    @15,@00                                             1792
         N     @15,@CF05624                                        1792
         CS    @00,@15,LDNZF007-3(ICNCBPTR)                        1792
         BNE   @GL00024                                            1792
*/************FOLLOWING LINES DELETED BY APAR ************** @ZA26631*/
*/*     WKREG=LDNSIOQ                  GET ADDRESS OF FIRST ELEMENT  */
*/*                                    ON SIOQ.                      */
*/*     RFY                                                          */
*/*       REG0 RSTD                                                  */
*/*     REG0=0                         ZERO SIOQ POINTER.            */
*/* NOSIOQ:                                                  @AS33958*/
*/*     CS(WKREG,REG0,LDNSIOQ)                                       */
*/*     RFY                                                          */
*/*       REG0 UNRSTD                                                */
*/*     BC(7,NOSIOQ)                                                 */
*/*     IF(WKREG&MASK)^=0 THEN         IF BUFFER(S) EXISTED ON SIOQ  */
*/*       DO                           THEN                          */
*/*         CALL FREERTN               FREE THE BUFFER(S) ON SIOQ.   */
*/*         LDNZLAST=0                 CLEAR ADDRESS OF LAST BUFFER  */
*/*                                    ON THE SIOQ                   */
*/*         LDNZATTP=OFF               CLEAR ATTENTION IN PROGRESS   */
*/*                                    FLAG.                         */
*/*       END                          END BUFFER(S) ON SIOQ.        */
*/*     ELSE                                                         */
*/*                                    NO BUFFER(S) ON SIOQ.         */
*/*                                                                  */
*/*     LDNZF003=OFF                   CLEAR RESET AT EOF COMMAND.   */
*/*     LDNZV001=0                     CLEAR ADDRESS OF RESET BUFFER.*/
*/*     IF ICNCBPTR^=NCBPTR THEN       IF AN NCB WAS FOUND           */
*/*       DO                           THEN                          */
*/*         FMCZFA06=OFF               CLEAR THE SESSION FLAGS       */
*/*         FMCZFB06=OFF               IN THE DNCB.                  */
*/*         FMCZFC06=OFF                                             */
*/*         FMCZFD06=OFF                                             */
*/*         DNCSESS=OFF                CLR SESSION FLAG IN DNCB.     */
*/*       END                          END NCB FOUND.                */
*/*     ELSE                                                         */
*/*                                    NCB PTR NOT FOUND.            */
*/*   END                              END DEVICE IS LOCAL 3270.     */
*/* ELSE                                                             */
*/*                                    DEVICE NOT LOCAL 3270.        */
*/********************************************************** @ZA26631*/
*                                                                  1793
*   /*****************************************************************/
*   /*                                                               */
*   /* SEGMENT(LOCLRTN)FINISH                                        */
*   /*                                                               */
*   /*****************************************************************/
*                                                                  1793
*   DO;                                                            1793
*     GOTO LOCLRTN#;                                               1794
         B     LOCLRTN#                                            1794
*LOCLRTN@:                                                         1795
*   END;                                                           1795
*                                                                  1795
LOCLRTN@ DS    0H                                                  1796
*/* TPEPILOG                                                         */
*                                                                  1796
*   GEN(PRINT OFF);                                                1796
         PRINT OFF
*/* TEMPLATE FOR CHAIN FIELD OF WORK ELEMENT */                    1797
*DCL  1  ISTWKE BDY(WORD) BASED(WKEPTR),                           1797
*        2  * CHAR(4),                 /* SPACE                       *
*        2  WKECHAIN PTR(31),          /* CHAIN POINTER               *
*           3 WKEFLAGS BIT(8),         /* FLAGS                       *
*             4 WKEGATE  BIT(1),       /* GATE BIT                    *
*             4 *        BIT(7),       /* RESERVED                    *
*           3 WKECHNGP PTR(24);        /* PTR ADDRESS                 *
*/* ***** POOL ENTRY  ***** */                                     1798
*/*  INITIAL LEVEL                                     001 12/20/74  */
*DCL   1  ISTBPENT BDY(DWORD) BASED(BPEPTR),                       1798
*         2  BPEPID   CHAR(4),         /* POOL ID                    */
*         2  BPEFLAGS BIT(16),         /* POOL FLAGS ZUP0589 @Z40GKDS*/
*            3  BPEFM    BIT(1),       /* POOL FORMAT                */
*            3  BPEDISP  BIT(1),       /* SHARED OR PRIVATE          */
*            3  BPEFIXED BIT(1),       /* FIXED OR PAGEABLE          */
*            3  BPENFCHP BIT(1),       /* NON-FETCH PROTECTION       */
*            3  BPEAL48  BIT(1),       /* 4,8 ALIGNEMENT OF BUFFERS  */
*            3  BPECBID  BIT(1),       /* CBID POOL                  */
*            3  BPENWS   BIT(1),       /* NON-WORKING SET POOL       */
*            3  BPERSV01 BIT(1),       /* RESERVED   ZUP0589 @Z40GKDS*/
*            3  BPEUSRF  BIT(1),       /* USER REQUIRES FIXED BUF    */
*            3  BPERSV02 BIT(7),       /* RESERVED   ZUP0589 @Z40GKDS*/
*         2  BPEBFSIZ FIXED(15),       /* BUFFER SIZE IN BYTES       */
*         2  BPEBPCB  PTR(31),         /* ADDRESS OF BPCB            */
*         2  BPERSV03 CHAR(4);         /* RESERVED                   */
*/* ***** POOL DIRECTORY  ***** */                                 1799
*/*  REVISIONS                                         002 03/20/75  */
*DCL   1  ISTBPDTY BDY(DWORD) BASED(BPDPTR),                       1799
*         2  BPDHDR CHAR(144) BDY(WORD),/* DIRECTORY HEADER          */
*            3  BPDBPENT FIXED(15),    /* CURRENT NUMBER OF ENTRIES  */
*            3  BPDBPMAX FIXED(15),    /* MAXIMUN NUMBER OF ENTRIES  */
*            3  BPDCHBNO FIXED(15),    /* NO. BUFFERS FOR CHPGM      */
*            3  BPDCHBSZ FIXED(15),    /* BUFFER SIZE FOR CH PGM     */
*            3  BPDCHPCB PTR(31),      /* BPCB ADDR FOR CHPGM        */
*            3  BPDPGPCB PTR(31),      /* BPCB ADDR FOR PGBUF        */
*            3  BPDADRS1 PTR(31),      /* BEGINNIG ADDR FOR POOLS    */
*            3  BPDADRS2 PTR(31),      /* END ADDR FOR POOLS         */
*            3  BPDFEXT  PTR(31),      /* ADDR OF 1ST FREE EXTENT    */
*            3  BPDSMPCB PTR(31),      /* SMS WE BPCB ADDRESS        */
*            3  BPDFBPE  PTR(31),      /* FIRST POOL ENTRY           */
*            3  BPDATCVT PTR(31),      /* PTR BACK TO ATCVT          */
*            3  BPDFLAG  FIXED(32),    /* FLAGS FIELD                */
*               4 BPDGTR   BIT(1),     /* GTRACE REQUESTED           */
*               4 BPDRSV01 BIT(31),    /* RESERVED                   */
*            3  BPDREQCT FIXED(15),    /* COUNT OF REQSTORES         */
*            3  BPDREQMX FIXED(15),    /* GTRACE REQ INTRVAL         */
*            3  BPDPARM  CHAR(8) BDY(WORD),/* GTRACE PARM            */
*               4 BPDTRLEN FIXED(15),  /* GTRACE DATA LENGTH         */
*               4 *        CHAR(1),    /* RESERVED                   */
*               4 BPDTRID  CHAR(1),    /* GTRACE FORMAT ID           */
*               4 BPDTRADR PTR(31),    /* GTRACE DATA ADDR           */
*            3  BPDTRACE (11) CHAR(8) BDY(WORD),/* GTRACE DATA       */
*               4 BPDMUSE  FIXED(15),  /* MAX BUFFERS IN USE         */
*               4 BPDMQUE  FIXED(15),  /* MAX REQUESTS QUEUED        */
*               4 BPDAVNO  FIXED(15),  /* AVAIL NUMBER OF BUFFRS     */
*               4 *        CHAR(2),    /* RESERVED                   */
*         2  BPDENTRY (12)CHAR(LENGTH(ISTBPENT)), /* BEGIN POOL ENTRY*/
*         2  BPDCBID  CHAR(*);         /* CBID TABLE SECTION         */
*   DECLARE                                                        1800
*     EMCR0 PTR REG(0),                                            1800
*     EMCR1 PTR REG(1),                                            1800
*     EMCR2 PTR REG(2),                                            1800
*     EMCR3 PTR REG(3),                                            1800
*     EMCR4 PTR REG(4),                                            1800
*     EMCR5 PTR REG(5),                                            1800
*     EMCR6 PTR REG(6),                                            1800
*     EMCR7 PTR REG(7),                                            1800
*     EMCR8 PTR REG(8),                                            1800
*     EMCR9 PTR REG(9),                                            1800
*     EMCR10 PTR REG(10),                                          1800
*     EMCR11 PTR REG(11),                                          1800
*     EMCR12 PTR REG(12),                                          1800
*     EMCR13 PTR REG(13),                                          1800
*     EMCR14 PTR REG(14),                                          1800
*     EMCR15 PTR REG(15);                                          1800
*   DECLARE                                                        1801
*     ISTSDCCA ENTRY BASED(ATCCDADD) VALRG(*),/* CIDCTL ADD ROUTINE  */
*     ISTSDCCD ENTRY BASED(ATCCDDEL) VALRG(*),/* CIDCTL DELETE     1801
*                                      ROUTINE                       */
*     ISTSDCCF ENTRY BASED(ATCCDFND) VALRG(*),/* CIDCTL FIND ROUTINE */
*     ISTSDCCN ENTRY BASED(ATCCDFDN) VALRG(*),/* CIDCTL FIND NCB   1801
*                                      ROUTINE                       */
*     ISTSDCCR ENTRY BASED(ATCCDFIN) VALRG(*);/* CIDCTL FINISH     1801
*                                      ROUTINE                       */
*   DCL                                                            1802
*     CMZCIDM FIXED(15) DEFINED(ATCCIDM);/* CIDMASK ALIAS            */
*   DCL                                                            1803
*     ISTAPC34 ENTRY BASED(ATCAP34) VALRG(*);/* RESET ROUTINE        */
*   DCL                                                            1804
*     ISTAPC37 ENTRY BASED(ATCAP37) VALRG(*);/* TPQUE ROUTINE        */
*   GEN(PRINT ON);                                                 1805
*                                                                  1805
         PRINT ON
*/* END OF TPEPILOG                                                  */
*                                                                  1806
*   END ISTZLFAB                                                   1806
*                                                                  1806
*/* THE FOLLOWING INCLUDE STATEMENTS WERE FOUND IN THIS PROGRAM.     */
*/*%INCLUDE SYSLIB  (IECDIOSB)                                       */
*/*%INCLUDE SYSLIB  (IHASRB  )                                       */
*/*%INCLUDE SYSLIB  (CVT     )                                       */
*                                                                  1806
*       ;                                                          1806
@EL00001 DS    0H                                                  1806
@EF00001 DS    0H                                                  1806
@ER00001 BR    @14                                                 1806
@DATA    DS    0H
@CH01572 DC    H'10'
@CH00166 DC    H'20'
@CH01547 DC    H'172'
@SX05611 XC    ZOBFDB(0,BFRPTR),ZOBFDB(BFRPTR)
@DATD    DSECT
         DS    0F
ISTZLFAB CSECT
         DS    0F
@CF00035 DC    F'1'
@CF00073 DC    F'4'
@CF01675 DC    XL4'08000000'
@CF01679 DC    XL4'04000000'
@CF01714 DC    XL4'7FFFFFFF'
@CF01716 DC    XL4'80000000'
@CF05307 DC    XL4'00FFFFFF'
@CF05621 DC    XL4'0000FFFF'
@CF05608 DC    BL4'11111001111111111111111111111111'
@CF05624 DC    BL4'11111111111111111111111111111011'
@DATD    DSECT
         DS    0D
IOSBPTR  DS    A
SRBPTR   DS    A
CVTPTR   DS    A
DNCBPTR  DS    A
LDNCBPTR DS    A
BDUPTR   DS    A
BTUPTR   DS    A
FSBPTR   DS    A
WKEPTR   DS    A
BPEPTR   DS    A
BPDPTR   DS    A
         ORG   *+1-(*-@DATD)/(*-@DATD) INSURE DSECT DATA
@ENDDATD EQU   *
ISTZLFAB CSECT
         DS    0F
@SIZDATD DC    AL1(0)
         DC    AL3(@ENDDATD-@DATD)
         DS    0D
FMZA0100 DS    FL4
         ORG   FMZA0100
@NM00090 DC    AL1(108)
@NM00091 DC    AL3(0)
         ORG   FMZA0100+4
FMZA0170 DS    FL4
         ORG   FMZA0170
@NM00092 DC    AL1(64)
@NM00093 DC    AL3(0)
         ORG   FMZA0170+4
BUFFLNG  DC    AL2(44+12)
@CC05359 DC    C'LCAB'
@CB05298 DC    X'6B8000'
@CB02556 DC    X'0000'
@CB05302 DC    X'0E00'
@CB05606 DC    B'1111100001111111'
@00      EQU   00                      EQUATES FOR REGISTERS 0-15
@01      EQU   01
@02      EQU   02
@03      EQU   03
@04      EQU   04
@05      EQU   05
@06      EQU   06
@07      EQU   07
@08      EQU   08
@09      EQU   09
@10      EQU   10
@11      EQU   11
@12      EQU   12
@13      EQU   13
@14      EQU   14
@15      EQU   15
LCPBPTR  EQU   @07
RPHPTR   EQU   @01
FMCBPTR  EQU   @05
GPR00F   EQU   @00
GPR00P   EQU   @00
GPR01F   EQU   @01
GPR01P   EQU   @01
GPR02F   EQU   @02
GPR02P   EQU   @02
GPR03F   EQU   @03
GPR03P   EQU   @03
GPR04F   EQU   @04
GPR04P   EQU   @04
GPR05F   EQU   @05
GPR05P   EQU   @05
GPR06F   EQU   @06
GPR06P   EQU   @06
GPR07P   EQU   @07
GPR08P   EQU   @08
GPR09P   EQU   @09
GPR10P   EQU   @10
GPR11P   EQU   @11
GPR12P   EQU   @12
GPR13P   EQU   @13
GPR14F   EQU   @14
GPR14P   EQU   @14
GPR15F   EQU   @15
GPR15P   EQU   @15
REG0     EQU   @00
RPHAPTR  EQU   @01
VTCVTPTR EQU   @02
BFRPARM  EQU   @02
CIDPARM  EQU   @02
ICNCBPTR EQU   @03
NCBPTR   EQU   @04
BFRPTR   EQU   @06
ZCRRPTR  EQU   @08
WKREG    EQU   @09
ATCVTREG EQU   @09
BASEREG  EQU   @12
SVARPTR  EQU   @13
REG14    EQU   @14
RCREG    EQU   @15
EMCR2    EQU   @02
EMCR3    EQU   @03
EMCR0    EQU   @00
EMCR1    EQU   @01
EMCR10   EQU   @10
EMCR11   EQU   @11
EMCR12   EQU   @12
EMCR13   EQU   @13
EMCR14   EQU   @14
EMCR15   EQU   @15
EMCR4    EQU   @04
EMCR5    EQU   @05
EMCR6    EQU   @06
EMCR7    EQU   @07
EMCR8    EQU   @08
EMCR9    EQU   @09
GPR07F   EQU   @07
GPR08F   EQU   @08
GPR09F   EQU   @09
GPR10F   EQU   @10
GPR11F   EQU   @11
GPR12F   EQU   @12
GPR13F   EQU   @13
ATCLCPTR EQU   1032
IOSB     EQU   0
IOSFLA   EQU   IOSB
IOSACHN  EQU   IOSFLA
IOSFLB   EQU   IOSB+1
IOSFLC   EQU   IOSB+2
IOSDVALT EQU   IOSFLC
IOSPKEY  EQU   IOSB+12
IOSOPT   EQU   IOSB+14
IOSOPT2  EQU   IOSB+15
@NM00002 EQU   IOSB+20
IOSCSW   EQU   @NM00002+1
IOSTATUS EQU   IOSCSW+3
IOSIPIB  EQU   IOSB+44
IOSPATH  EQU   IOSB+86
IOSCHN   EQU   IOSPATH
IOSCKEY  EQU   IOSB+89
IOSEEKA  EQU   IOSB+100
IOSCCHH  EQU   IOSEEKA+3
IOSSKHH  EQU   IOSCCHH+2
SRBSECT  EQU   0
SRBFLC   EQU   SRBSECT+12
CVTMAP   EQU   0
CVTDAR   EQU   CVTMAP+72
CVTFLGS1 EQU   CVTDAR
CVTDCB   EQU   CVTMAP+116
CVTIERLC EQU   CVTMAP+144
CVTOPTA  EQU   CVTMAP+182
CVTOPTB  EQU   CVTMAP+183
CVTGTF   EQU   CVTMAP+236
CVTGTFST EQU   CVTGTF
CVTGTFS  EQU   CVTGTFST
CVTSTATE EQU   CVTGTFST
CVTTMODE EQU   CVTGTFST
CVTFORM  EQU   CVTGTFST
CVTAQAVT EQU   CVTMAP+240
CVTTCMFG EQU   CVTAQAVT
CVTVOLM2 EQU   CVTMAP+244
CVTTATA  EQU   CVTVOLM2
CVTTSKS  EQU   CVTTATA
CVTVOLF2 EQU   CVTTSKS
CVTTAT   EQU   CVTTATA+1
CVTATER  EQU   CVTMAP+248
CVTEXT1  EQU   CVTMAP+252
CVTPURG  EQU   CVTMAP+260
CVTQMSG  EQU   CVTMAP+268
CVTDMSR  EQU   CVTMAP+272
CVTRSV37 EQU   CVTDMSR
CVTDMSRF EQU   CVTRSV37
CVTERPV  EQU   CVTMAP+316
CVTINTLA EQU   CVTMAP+320
CVTAPF   EQU   CVTMAP+324
CVTEXT2  EQU   CVTMAP+328
CVTHJES  EQU   CVTMAP+332
CVTPGSIA EQU   CVTMAP+348
CVTA1F1  EQU   CVTMAP+356
CVTSYSK  EQU   CVTMAP+357
CVTVOLM1 EQU   CVTMAP+380
CVTVOLF1 EQU   CVTVOLM1
CVTATMCT EQU   CVTMAP+388
CVTXTNT1 EQU   0
CVTXTNT2 EQU   0
CVTDSSV  EQU   CVTXTNT2
CVTFLGBT EQU   CVTXTNT2+5
CVTQID   EQU   CVTXTNT2+24
CVTSHS   EQU   CVTXTNT2+40
CVTRV400 EQU   CVTXTNT2+52
CVTRV409 EQU   CVTXTNT2+53
CVTATCVT EQU   CVTXTNT2+64
CVTRV429 EQU   CVTXTNT2+84
CVTRV438 EQU   CVTXTNT2+85
CVTRV457 EQU   CVTXTNT2+112
CVTRV466 EQU   CVTXTNT2+113
CVTFIX   EQU   0
CVTRELNO EQU   CVTFIX+252
ISTZPSVT EQU   0
ZPSZDFA0 EQU   ISTZPSVT
ZPSZDFB0 EQU   ISTZPSVT+16
ISTZFSVT EQU   0
ZFSZEFBB EQU   ISTZFSVT
ZFSZEABB EQU   ZFSZEFBB
ZFSZEFAB EQU   ISTZFSVT+4
ZFSZEAAB EQU   ZFSZEFAB
ISTZSAVE EQU   0
ZSAZSVBC EQU   ISTZSAVE
ZSAZSVMS EQU   ZSAZSVBC
ZSAZSVFC EQU   ISTZSAVE+4
ISTLCCW  EQU   0
LCCWOP   EQU   ISTLCCW
LCCWRWOP EQU   LCCWOP
LCCWCTL  EQU   LCCWRWOP
LCCWFLAG EQU   ISTLCCW+1
LCCWLSI  EQU   LCCWFLAG
LCCWDATA EQU   ISTLCCW+4
ISTLCPB  EQU   0
LCPTYPE  EQU   ISTLCPB
LCPREQTG EQU   ISTLCPB+2
LCPFLAGS EQU   LCPREQTG
LCPZRT00 EQU   LCPFLAGS
LCPZF001 EQU   LCPFLAGS
LCPZRT02 EQU   LCPZF001
LCPZF002 EQU   LCPFLAGS
LCPZRT03 EQU   LCPZF002
LCPZF003 EQU   LCPFLAGS
LCPZRT04 EQU   LCPZF003
LCPZF004 EQU   LCPFLAGS
LCPZRT05 EQU   LCPZF004
LCPZRT06 EQU   LCPFLAGS
LCPZRT07 EQU   LCPFLAGS
LCPMNRCD EQU   LCPREQTG+1
LCPZRT08 EQU   LCPMNRCD
LCPZRT09 EQU   LCPMNRCD
LCPCHAIN EQU   ISTLCPB+4
LCPCHAI1 EQU   LCPCHAIN
LCPRUCNT EQU   ISTLCPB+8
LCPFLAG2 EQU   ISTLCPB+9
LCPRSTRT EQU   LCPFLAG2
LCPTLBPI EQU   LCPFLAG2
LCPFID0  EQU   LCPFLAG2
LCPSEQ   EQU   ISTLCPB+10
LCPCID   EQU   ISTLCPB+16
LCPSAF   EQU   LCPCID
LCPDAF   EQU   LCPCID+2
LCPNXLCW EQU   ISTLCPB+20
LCPFDBA  EQU   ISTLCPB+24
LCPFLG1  EQU   ISTLCPB+37
LCPFLCCW EQU   ISTLCPB+40
LCPLCCW  EQU   ISTLCPB+48
LCPPABA  EQU   LCPLCCW+4
LCPRPHA  EQU   LCPPABA
ISTZCRR  EQU   0
ZCRCRR   EQU   ISTZCRR
ZCRID    EQU   ZCRCRR
ZCRLEN   EQU   ZCRCRR+1
ZCRCHAIN EQU   ISTZCRR+4
ZCRFRRA  EQU   ISTZCRR+8
ZCRFLGS1 EQU   ISTZCRR+12
ZCRFLGS2 EQU   ISTZCRR+13
ZCRSWFLD EQU   ISTZCRR+14
ZCRENDSH EQU   ZCRSWFLD
ZCRNDLCP EQU   ZCRSWFLD
ZCRRESET EQU   ZCRSWFLD
ZCRFLGS3 EQU   ISTZCRR+15
ZCRGENSW EQU   ISTZCRR+16
ZCRTSW1  EQU   ZCRGENSW
ZCRTSW2  EQU   ZCRGENSW
ZCRPFLGS EQU   ISTZCRR+17
ZCRIBPR  EQU   ISTZCRR+18
ZCRSCPSW EQU   ISTZCRR+19
ZCRPARMS EQU   ISTZCRR+24
ZCRFBPTR EQU   ZCRPARMS
ZCRDFRDA EQU   ZCRPARMS+10
ZCRPCOD1 EQU   ZCRPARMS+12
ZCRPFSB  EQU   ZCRPCOD1
ZCRPLSBF EQU   ZCRPCOD1
ZCRPLSBQ EQU   ZCRPLSBF
ZCRPCOD2 EQU   ZCRPARMS+13
ZCRSVRTN EQU   ISTZCRR+56
ZCRSVF1  EQU   ZCRSVRTN
ZCRSVF2  EQU   ZCRSVRTN+4
ZCRSVF3  EQU   ZCRSVRTN+8
ZCRSVF4  EQU   ZCRSVRTN+12
ZCRWKARA EQU   ISTZCRR+156
ZCRSVWK5 EQU   ZCRWKARA+16
ZCRCIDSV EQU   ISTZCRR+192
ZCRSAVEZ EQU   ISTZCRR+196
ZCRAUDIT EQU   ISTZCRR+440
ZCRTID   EQU   ZCRAUDIT
ZCRTNAME EQU   ZCRAUDIT+1
ZCRENTER EQU   ZCRAUDIT+5
ZCRELCAB EQU   ZCRENTER+18
ZCRLCPB  EQU   ISTZCRR+480
ZCRRHRU  EQU   ZCRLCPB
ISTRPH   EQU   0
RPHCNTL  EQU   ISTRPH
RPHFLAGS EQU   RPHCNTL+2
RPHAPTYP EQU   RPHFLAGS
RPHFSTLC EQU   RPHFLAGS
RPHFLGB  EQU   RPHCNTL+3
RPHRPHA  EQU   ISTRPH+4
RPHTSKID EQU   ISTRPH+8
RPHRESMA EQU   ISTRPH+16
RPHWPFLG EQU   RPHRESMA
RPHWT    EQU   RPHWPFLG
RPHPABOF EQU   ISTRPH+20
RPHMAJCB EQU   ISTRPH+21
RPHWEA   EQU   ISTRPH+24
RPHCSPA  EQU   RPHWEA
RPHSRPRM EQU   ISTRPH+28
RPHCRR   EQU   ISTRPH+32
RPHPABQA EQU   ISTRPH+36
RPHPABQP EQU   RPHPABQA+1
RPHWORK  EQU   ISTRPH+40
RPHSAVE1 EQU   RPHWORK
RPHSBITS EQU   RPHSAVE1+1
ISTPAB   EQU   0
PABWQCHN EQU   ISTPAB
PABWEQA  EQU   PABWQCHN
PABWEQG  EQU   PABWEQA
PABWEQP  EQU   PABWEQA+1
PABCHAIN EQU   PABWQCHN+4
PABCHNGP EQU   PABCHAIN+1
PABDVTA  EQU   ISTPAB+9
PABRPHFG EQU   ISTPAB+12
PABFLAGS EQU   PABRPHFG
PABERLCK EQU   PABFLAGS
PABERRLK EQU   PABERLCK
PABINHBT EQU   PABFLAGS
PABRPHA  EQU   PABRPHFG+1
ISTDYPAB EQU   0
DYPPAB   EQU   ISTDYPAB+16
ISTPFCRR EQU   0
PFCCRR   EQU   ISTPFCRR
PFCCRRID EQU   PFCCRR
PFCCRRLN EQU   PFCCRR+2
PFCHDR   EQU   ISTPFCRR+4
PFCCRRO  EQU   PFCHDR
PFCFRRO  EQU   PFCHDR+4
ISTCFCRR EQU   0
CFCAUDIT EQU   ISTCFCRR
CFCNTRD  EQU   CFCAUDIT
CFCCRT   EQU   CFCAUDIT+1
ISTASCRR EQU   0
ASCFLAGS EQU   ISTASCRR+16
ASCFLG1  EQU   ASCFLAGS
ASCFLG2  EQU   ASCFLAGS+2
ASCFLG3  EQU   ASCFLAGS+4
ASCUSRGS EQU   ISTASCRR+28
ISTAPCRR EQU   0
APCATFLG EQU   ISTAPCRR+16
APCRFLG  EQU   ISTAPCRR+18
APCSAVE  EQU   ISTAPCRR+44
APCCOMF  EQU   ISTAPCRR+116
APCCOMF1 EQU   APCCOMF
APC31FLG EQU   ISTAPCRR+132
APC52FLG EQU   ISTAPCRR+133
APC53FLG EQU   ISTAPCRR+134
APC54FLG EQU   ISTAPCRR+135
APC57FLG EQU   ISTAPCRR+136
ISTCRA   EQU   0
CRABASIC EQU   ISTCRA
CRAHDR   EQU   CRABASIC
CRACRR   EQU   CRAHDR
CRAFRR   EQU   CRAHDR+4
CRALKACT EQU   CRABASIC+8
CRAL5PTR EQU   CRABASIC+28
CRAPROCR EQU   ISTCRA+312
CRASVC   EQU   ISTCRA+848
CRABUFA  EQU   CRASVC+68
ISTLOK   EQU   0
LOKCHN   EQU   ISTLOK+1
LOKCHNG  EQU   LOKCHN
@NM00030 EQU   LOKCHNG+2
ISTATCVT EQU   0
ATCCOM   EQU   ISTATCVT
ATCSTAT  EQU   ATCCOM
ATCSTAT1 EQU   ATCSTAT
ATCSTFLG EQU   ATCSTAT+1
ATCPOFLG EQU   ATCSTAT+2
ATCSTAT4 EQU   ATCSTAT+3
ATCBPDA  EQU   ATCCOM+128
ATCIOTRC EQU   ATCCOM+140
ATCTHTRC EQU   ATCIOTRC
ATCSMRQ  EQU   ATCCOM+180
ATCSMRS  EQU   ATCCOM+188
ATCVTMID EQU   ATCCOM+240
ATCCIDM  EQU   ATCCOM+266
ATCCDADD EQU   ISTATCVT+276
ATCCDDEL EQU   ISTATCVT+280
ATCCDFND EQU   ISTATCVT+284
ATCCSMR  EQU   ISTATCVT+296
ATCSHRFG EQU   ISTATCVT+316
ATCHPGM  EQU   ISTATCVT+384
ATCAP33  EQU   ISTATCVT+444
ATCAP36  EQU   ISTATCVT+452
ATCCDFIN EQU   ISTATCVT+460
ATCCDFDN EQU   ISTATCVT+464
ATCVLCNT EQU   ISTATCVT+772
ATCRNO   EQU   ISTATCVT+788
ATCSOPD  EQU   ISTATCVT+792
ATCSIPD  EQU   ISTATCVT+800
ATCSECST EQU   ISTATCVT+812
ATCSTAT2 EQU   ISTATCVT+818
ATCVTBAM EQU   ISTATCVT+908
@NM00038 EQU   ATCVTBAM+3
ATCAOSM  EQU   ISTATCVT+912
ATCGSRBQ EQU   ATCAOSM+4
ATCGSRBG EQU   ATCGSRBQ
ATCAP31  EQU   ATCAOSM+24
ATCAP32  EQU   ATCAOSM+28
ATCAP34  EQU   ATCAOSM+32
ATCZFSVT EQU   ATCAOSM+68
ATCZPSVT EQU   ATCAOSM+72
ATCICAPP EQU   ATCAOSM+100
ATCLDAPP EQU   ATCAOSM+120
ATCCDTID EQU   ATCLDAPP
ATCDAPVT EQU   ATCAOSM+140
ATCZLFVT EQU   ATCAOSM+188
ATCAP37  EQU   ATCAOSM+264
ATCCRA   EQU   ATCAOSM+280
ATCCRACN EQU   ATCCRA+4
ATCSRB   EQU   ATCAOSM+288
ATCSRBCN EQU   ATCSRB+4
ATCCRPL  EQU   ATCAOSM+296
ATCRPLCN EQU   ATCCRPL+4
ATCSQAFR EQU   ATCAOSM+304
ATCORTBC EQU   ATCSQAFR+4
ATCORSRB EQU   ATCORTBC
@NM00040 EQU   ATCAOSM+332
ATCVTFLG EQU   ATCAOSM+392
ATCSMAID EQU   ATCAOSM+416
ATCTPWQA EQU   ATCAOSM+420
ATCTPSPB EQU   ATCAOSM+472
ATCZFLAG EQU   ATCAOSM+588
ISTNMLPB EQU   0
NMCONTRL EQU   ISTNMLPB+72
NMLCWCMD EQU   NMCONTRL+2
NMRDTEA  EQU   NMCONTRL+4
ISTRH    EQU   0
RHFLAGS  EQU   ISTRH
RH1      EQU   RHFLAGS
RHSENSE  EQU   RH1
RH2      EQU   RHFLAGS+1
RHRETRY  EQU   RH2
RHRSVD1  EQU   RH2
RH3      EQU   RHFLAGS+2
ISTRU    EQU   0
RUDATA   EQU   ISTRU
ISTRUB   EQU   0
NSRUNA5  EQU   0
ISTTH    EQU   0
THFLAG1  EQU   ISTTH
THFID    EQU   THFLAG1
THFLGA   EQU   THFLAG1
THMPF    EQU   THFLGA
THPSI    EQU   THFLGA
THAFI    EQU   THFLGA
THFLGB   EQU   THFLAG1+1
THDAF    EQU   ISTTH+2
THOAF    EQU   ISTTH+4
THDCF    EQU   ISTTH+8
ISTTH2   EQU   0
TH2FLAG1 EQU   ISTTH2
TH2FID   EQU   TH2FLAG1
TH2MPF   EQU   TH2FLAG1
TH2PSI   EQU   TH2FLAG1
TH2AFI   EQU   TH2FLAG1
TH2PYF   EQU   TH2FLAG1+1
TH2SEF   EQU   TH2FLAG1+1
TH2CDF   EQU   TH2FLAG1+1
TH2DAF   EQU   ISTTH2+2
TH2OAF   EQU   ISTTH2+3
ISTNIR   EQU   0
NIRRH    EQU   ISTNIR
NIRRU    EQU   ISTNIR+3
ISTPIU   EQU   0
PIUTH    EQU   ISTPIU
PIUNIR   EQU   ISTPIU+10
ISTLH    EQU   0
LHLEN    EQU   ISTLH
ISTDEVCH EQU   0
DEVSHCH  EQU   ISTDEVCH
DEVCHAR  EQU   DEVSHCH
DEVTCODE EQU   ISTDEVCH+1
DEVFLAGS EQU   ISTDEVCH+3
DEVFCCTL EQU   DEVFLAGS
DEVCHAR3 EQU   DEVFLAGS
ISTNCB   EQU   0
NCBTYPE  EQU   ISTNCB
NCBDAF   EQU   ISTNCB+2
NCBTSKID EQU   ISTNCB+8
NCBNSNA  EQU   ISTNCB+12
NCBFMCBA EQU   ISTNCB+16
NCBNCBA  EQU   ISTNCB+20
NCBFLAGS EQU   ISTNCB+24
NCBFRAS  EQU   NCBFLAGS+1
NCBFTRIO EQU   NCBFRAS
NCBFLAG1 EQU   NCBFLAGS+2
NCBCONF  EQU   NCBFLAG1
NCBSWDAF EQU   ISTNCB+44
ISTPROCD EQU   0
PROPROC  EQU   ISTPROCD
PROPROC1 EQU   PROPROC
PROPROC2 EQU   PROPROC+1
PROPROC3 EQU   PROPROC+2
PROPROC4 EQU   PROPROC+3
PROPROCS EQU   0
PROSETMS EQU   PROPROCS+1
PROSETM2 EQU   PROSETMS
PROSETM3 EQU   PROSETMS+1
PROSETM4 EQU   PROSETMS+2
ISTFMCB  EQU   0
FMCSAF   EQU   ISTFMCB+2
FMCTSKID EQU   ISTFMCB+8
FMCFMCBA EQU   ISTFMCB+20
FMCSTAT  EQU   ISTFMCB+28
FMCDEVOF EQU   FMCSTAT
FMCSTAT1 EQU   ISTFMCB+29
FMCCMDFL EQU   ISTFMCB+31
FMCCMPS1 EQU   ISTFMCB+36
FMCPAB4  EQU   ISTFMCB+112
FMCSIPA  EQU   ISTFMCB+148
FMCNXOSQ EQU   ISTFMCB+152
FMCNXCFM EQU   FMCNXOSQ
FMCNXOSC EQU   FMCNXOSQ+2
FMCSSTAT EQU   ISTFMCB+159
FMCSNBI  EQU   FMCSSTAT
FMCCIPI  EQU   FMCSSTAT
FMCUIPI  EQU   FMCSSTAT
FMCBIP   EQU   FMCSSTAT
FMCCONF  EQU   FMCSSTAT
FMCPACE  EQU   ISTFMCB+160
FMCPACEN EQU   FMCPACE
FMCPACEM EQU   FMCPACE+1
FMCPACPC EQU   FMCPACE+2
FMCCVAL  EQU   FMCPACE+3
FMCOBCE  EQU   FMCCVAL
FMCCLEXT EQU   ISTFMCB+164
FMCRPLA  EQU   FMCCLEXT
FMCFBA   EQU   FMCCLEXT+4
FMCCMPS2 EQU   FMCCLEXT+16
FMCFLGA  EQU   FMCCMPS2
FMCFLGCL EQU   FMCCMPS2+1
FMCPSCMD EQU   FMCCMPS2+2
FMCPSTAT EQU   FMCCMPS2+3
FMCSTAT2 EQU   ISTFMCB+186
FMCMODEB EQU   ISTFMCB+189
FMCCLSEQ EQU   ISTFMCB+190
FMCRRESP EQU   ISTFMCB+195
FMCSSEGQ EQU   ISTFMCB+200
FMCFBAS  EQU   ISTFMCB+216
FMCZV002 EQU   FMCFBAS
FMCSNCTL EQU   ISTFMCB+224
FMCSCFLG EQU   FMCSNCTL
FMCVS1   EQU   ISTFMCB+232
FMCZFLAG EQU   FMCVS1
FMCZF003 EQU   FMCZFLAG
FMCZF006 EQU   FMCZFLAG
FMCLBXM  EQU   FMCVS1+12
FMCSHEAQ EQU   FMCLBXM
FMCLCPBQ EQU   FMCVS1+16
FMCLCPAQ EQU   FMCVS1+20
FMCSEQ1  EQU   FMCVS1+34
FMCZFLG2 EQU   FMCVS1+35
FMCCVFLG EQU   FMCVS1+44
FMCFLAG  EQU   0
FMCFLGB  EQU   FMCFLAG
ISTDNCB  EQU   0
DNCOS    EQU   ISTDNCB+56
DNCZFLGS EQU   DNCOS
DNCZF001 EQU   DNCZFLGS
DNCSESS  EQU   DNCZFLGS
DNCINVIT EQU   DNCZFLGS
DNCCONT  EQU   DNCZFLGS
DNCDISC  EQU   DNCZFLGS
DNCZRSCH EQU   DNCZFLGS
DNCZF002 EQU   DNCZFLGS
DNCBSCED EQU   DNCOS+2
DNCACIP  EQU   DNCBSCED+1
DNCZX003 EQU   DNCOS+16
DNCZV001 EQU   DNCOS+17
DNCZX001 EQU   DNCOS+20
DNCZV004 EQU   DNCOS+28
DNCLOCK  EQU   DNCOS+36
DNCZC001 EQU   DNCOS+40
ISTICNCB EQU   0
ICNCB    EQU   ISTICNCB
@NM00059 EQU   ISTICNCB+53
ICNLCLUS EQU   @NM00059
ICNZPAB1 EQU   ISTICNCB+64
ICNCKFLD EQU   ISTICNCB+96
ICNFLAG  EQU   ISTICNCB+100
ICNZF006 EQU   ICNFLAG
ICNZF010 EQU   ICNFLAG
ICNSLOW  EQU   ICNFLAG
ICNFFLAG EQU   ISTICNCB+101
ICNZSWS  EQU   ISTICNCB+102
ICNFLAG2 EQU   ISTICNCB+236
ICNZD001 EQU   ISTICNCB+288
ICNWSCCW EQU   ICNZD001
ICNZD002 EQU   ISTICNCB+296
ICNZD003 EQU   ISTICNCB+320
ICNRSCCW EQU   ICNZD003
ICNZD004 EQU   ISTICNCB+328
ICNZS1VR EQU   ISTICNCB+348
ICNSRV02 EQU   ICNZS1VR
ICNDIEWA EQU   ICNSRV02
ICNDCDEB EQU   ISTICNCB+480
ICNDIDEB EQU   ICNDCDEB+12
ICNZFLAG EQU   ISTICNCB+508
ICNZH002 EQU   ISTICNCB+509
ICNZS002 EQU   ICNZH002
ICNZS003 EQU   ICNZH002
ICNZS004 EQU   ICNZH002
ICNZS006 EQU   ICNZH002
ICNZS007 EQU   ICNZH002
ICNZS008 EQU   ICNZH002
ICNZS009 EQU   ICNZH002+1
ICNZS00A EQU   ICNZH002+1
ICNZCONS EQU   ISTICNCB+680
ISTCCNCB EQU   0
CCNFLGA  EQU   ISTCCNCB+48
ISTLUNCB EQU   0
LUNZOS   EQU   ISTLUNCB+48
LUNZC001 EQU   LUNZOS+8
ISTLDNCB EQU   0
LDNCFLAG EQU   ISTLDNCB+54
LDNFLAGS EQU   ISTLDNCB+107
LDNZF007 EQU   LDNFLAGS
LDNFLAG2 EQU   ISTLDNCB+110
LDNZIOLK EQU   ISTLDNCB+184
LDNZERPF EQU   ISTLDNCB+185
LDNZCPAN EQU   LDNZERPF
LDNZEPIN EQU   LDNZERPF
LDNZLPC  EQU   ISTLDNCB+186
LDNDCDEB EQU   ISTLDNCB+304
LDNZSAV3 EQU   ISTLDNCB+376
LDNZSAV4 EQU   LDNZSAV3+8
LDNZH003 EQU   ISTLDNCB+577
ISTBDU   EQU   0
BDUCOMND EQU   ISTBDU
BDUMODIF EQU   ISTBDU+1
BDUMOD1  EQU   BDUMODIF
BDUDAF   EQU   ISTBDU+2
BDUFUNC  EQU   BDUDAF
BDUCHECK EQU   BDUFUNC
BDUFLAGS EQU   BDUDAF+1
ISTFDB   EQU   0
FDBDATAA EQU   ISTFDB+4
FDBDATCT EQU   ISTFDB+8
FDBOFSET EQU   ISTFDB+10
ISTBTU   EQU   0
BTUBTH   EQU   ISTBTU
BTUFID   EQU   BTUBTH
BTUDEST  EQU   BTUBTH+2
BTUSORCE EQU   BTUBTH+4
BTUREQ   EQU   BTUBTH+6
BTURQFLG EQU   BTUREQ
BTUDCF   EQU   BTUBTH+8
BTURH    EQU   BTUBTH+10
BTUBDU   EQU   ISTBTU+14
BTUSYSTR EQU   ISTBTU+18
BTUEXTR  EQU   ISTBTU+19
ISTFSB   EQU   0
FSBFSB   EQU   ISTFSB
FSBTYPE  EQU   FSBFSB
FSBLNGTH EQU   FSBFSB+1
FSBMNRCD EQU   FSBFSB+2
FSBSFLGS EQU   FSBFSB+3
FSBFSBA  EQU   FSBFSB+4
FSBBTH   EQU   FSBFSB+8
FSBCID   EQU   FSBBTH
FSBSAF   EQU   FSBCID
FSBDAF   EQU   FSBCID+2
FSBRQTAG EQU   FSBBTH+4
FSBSEQID EQU   FSBRQTAG
FSBFLAGS EQU   FSBSEQID
FSBSEQ   EQU   FSBSEQID+1
FSBCSWST EQU   FSBBTH+6
FSBTHFLD EQU   FSBCSWST
FSBTH1   EQU   FSBTHFLD
FSBSYSRS EQU   FSBTH1
FSBSERR  EQU   FSBSYSRS
FSBTH2   EQU   FSBTHFLD+1
FSBEXTRS EQU   FSBTH2
FSBXFSTS EQU   FSBEXTRS
FSBXCODE EQU   FSBEXTRS
FSBNETRS EQU   FSBFSB+16
FSBSRCAT EQU   FSBNETRS
FSBMJRCD EQU   FSBSRCAT
FSBERC   EQU   FSBNETRS+1
FSBFBMI  EQU   FSBERC
FSBDMGRS EQU   FSBFSB+18
FSBSS1   EQU   FSBDMGRS
FSBSS2   EQU   FSBDMGRS+1
FSBLCPB  EQU   FSBFSB+20
FSBMSGID EQU   FSBLCPB
FSBICNCB EQU   FSBMSGID
FSBLCCWA EQU   FSBFSB+24
FSBRLSTS EQU   FSBLCCWA
FSBFDB   EQU   ISTFSB+32
ISTZIBUF EQU   0
ZIBCHAIN EQU   ISTZIBUF
ZIBFSM   EQU   ISTZIBUF+4
ISTZOBUF EQU   0
ZOBFSM   EQU   ISTZOBUF+4
ISTPOHD  EQU   0
POHSTAT  EQU   ISTPOHD+1
ISTPFX   EQU   0
PFXID    EQU   ISTPFX
ISTNCSPL EQU   0
@NM00085 EQU   ISTNCSPL
NCSPFX   EQU   @NM00085
NCSPLVBF EQU   ISTNCSPL+18
NCSPLVFL EQU   ISTNCSPL+20
NCSPLVF1 EQU   ISTNCSPL+21
NCSPLCMD EQU   ISTNCSPL+60
NCSCMDA  EQU   NCSPLCMD
NCSCRFLG EQU   ISTNCSPL+67
NCSPLRAD EQU   ISTNCSPL+144
NCSIOCID EQU   ISTNCSPL+148
NCSPLCID EQU   NCSIOCID
NCSPLRPH EQU   ISTNCSPL+160
NCSPLFSB EQU   ISTNCSPL+168
NCSPLFL1 EQU   ISTNCSPL+176
NCSPLFL2 EQU   ISTNCSPL+177
NCSPLFL3 EQU   ISTNCSPL+178
NCSPLFL4 EQU   ISTNCSPL+179
NCSPLFL5 EQU   ISTNCSPL+181
NCSPLAPP EQU   ISTNCSPL+216
NCSSENSE EQU   ISTNCSPL+244
NCSCRMSK EQU   ISTNCSPL+268
NCSCHKPT EQU   NCSCRMSK
NCSCRMOD EQU   NCSCRMSK+2
NCSPLSID EQU   ISTNCSPL+271
NCSPLSTA EQU   NCSPLSID
NCSPLPHD EQU   NCSPLSID+1
NCSAPP   EQU   0
NCSAPBUE EQU   NCSAPP+88
NCSUSSRU EQU   0
ISTZLBUF EQU   0
ZLBFSM   EQU   ISTZLBUF+4
ISTZLFVT EQU   0
ZLFZEFBA EQU   ISTZLFVT
ZLFZEFAA EQU   ISTZLFVT+4
ZLFZEAAA EQU   ZLFZEFAA
ZLFZFFFA EQU   ISTZLFVT+8
ZLFZFAFA EQU   ZLFZFFFA
ZLFZEFTA EQU   ISTZLFVT+12
ZLFZEATA EQU   ZLFZEFTA
ZLFZFFTA EQU   ISTZLFVT+16
ZLFZFATA EQU   ZLFZFFTA
ZLFZEFFA EQU   ISTZLFVT+24
ZLFZEAFA EQU   ZLFZEFFA
ZLFZEFCA EQU   ISTZLFVT+28
ZLFZEACA EQU   ZLFZEFCA
ISTZDFB0 EQU   0
ISTZEFBB EQU   0
ISTZEFBA EQU   0
FMZL0032 EQU   0
ISTWKE   EQU   0
WKECHAIN EQU   ISTWKE+4
WKEFLAGS EQU   WKECHAIN
FMZL0049 EQU   0
FMZL0068 EQU   0
ISTSDCCF EQU   0
ISTSDCCR EQU   0
FMZL0087 EQU   0
ISTBPENT EQU   0
BPEFLAGS EQU   ISTBPENT+4
ISTBPDTY EQU   0
BPDHDR   EQU   ISTBPDTY
BPDCHPCB EQU   BPDHDR+8
BPDFLAG  EQU   BPDHDR+40
BPDPARM  EQU   BPDHDR+48
BPDTRACE EQU   BPDHDR+56
FMZL0100 EQU   0
FMZL0125 EQU   0
ISTAPC37 EQU   0
FMZL0170 EQU   0
ISTAPC34 EQU   0
ISTSDCCA EQU   0
ISTSDCCD EQU   0
ISTSDCCN EQU   0
ZIBSRB   EQU   0
IOSATTSC EQU   IOSIPIB
IOSWTOWA EQU   IOSIPIB
IOSPCISC EQU   IOSIPIB
CVTS01   EQU   CVTPGSIA
CVTLPDIA EQU   CVTS01+12
CVTDIRST EQU   CVTLPDIA
CVTSLIDA EQU   CVTS01+24
CVTCTLFG EQU   CVTS01+50
CVTRV210 EQU   CVTS01+424
CVTRV219 EQU   CVTS01+425
CVTRV228 EQU   CVTS01+426
CVTRV237 EQU   CVTS01+427
CVTMFRTR EQU   CVTS01+452
CVTRV262 EQU   CVTS01+468
CVTRV271 EQU   CVTS01+469
CVTRV280 EQU   CVTS01+470
CVTRV289 EQU   CVTS01+471
CVTGSDA  EQU   CVTS01+600
LCPZTIE  EQU   LCPCID
LCPZSNAM EQU   LCPZTIE+8
ISTSENRU EQU   RUDATA
SRUSENSE EQU   ISTSENRU
SRUSENS1 EQU   SRUSENSE
SRUSENS2 EQU   SRUSENSE+2
SENRU    EQU   ISTSENRU+4
ISTSRU   EQU   ISTRUB
SRUQSREQ EQU   ISTSRU
SRUDATA  EQU   ISTSRU+1
SRUTYPE  EQU   SRUDATA
SRULDID  EQU   SRUDATA+1
SRUSPSN  EQU   SRULDID
ISTNSRU  EQU   ISTRUB
NSRUNETS EQU   ISTNSRU
NSRUDATA EQU   ISTNSRU+3
NSRUHOOK EQU   NSRUDATA
NSSSVRU  EQU   NSRUDATA
NSSSVNOD EQU   NSSSVRU+3
NSSSVT3  EQU   NSSSVNOD
NSSSVT3C EQU   NSSSVT3+2
NSSSVT3G EQU   NSSSVT3+5
NSSSVT4  EQU   NSSSVNOD
NSSSVT5  EQU   NSSSVNOD
NSRUDAT1 EQU   NSRUDATA
NSRUDAT2 EQU   NSRUDAT1+2
ISTTRRU  EQU   NSRUDAT2
TRRTYPE  EQU   ISTTRRU
ISTCTDRU EQU   NSRUDAT2
ISTINORU EQU   NSRUDAT2
SRUDAT1  EQU   SRUDATA
SRUDAT1L EQU   SRUDAT1+1
SRUDAT2  EQU   SRUDATA
ISTMRU   EQU   ISTRUB
SRUDATA3 EQU   SRUDATA
SRUDATA4 EQU   SRUDATA
NSRUDAT3 EQU   NSRUDAT2
NSRUDAT4 EQU   NSRUDAT2
NSRUDAT5 EQU   NSRUDAT2
NSRUDAT6 EQU   NSRUDAT2
NSRUDAT7 EQU   NSRUDAT2
NSRUDIL  EQU   NSRUDAT2
NSRUDILB EQU   NSRUDIL+1
NSRUNA   EQU   NSRUDAT2
NSRUNA2  EQU   NSRUNA+1
NSRUCLSP EQU   NSRUDAT2
NSRUOH1  EQU   NSRUDAT2
NSRUDAT8 EQU   NSRUDATA
ISTUNBRU EQU   SRUTYPE
UNBTYPE  EQU   ISTUNBRU
FSBCOMBN EQU   FSBNETRS
FSBRHFLD EQU   FSBCOMBN+1
FSBRH3   EQU   FSBRHFLD+2
FSBLDFLG EQU   FSBRH3
@NM00074 EQU   FSBRQTAG
ZIBDIO   EQU   ZIBFSM
ZIBCCW2  EQU   ZIBDIO+8
ZIBCPTCC EQU   ZIBCCW2
ZIBAIO   EQU   ISTZIBUF
ZIBAIOCM EQU   ZIBAIO
ZIBFIB   EQU   ZIBAIO+16
ZIBFSB   EQU   ZIBFIB
ZIBMDREC EQU   ZIBFSB+4
ZIBMDRIN EQU   ZIBFSB+28
ZIBBTU   EQU   ZIBFIB+32
@NM00077 EQU   ZIBBTU+12
ZIBFID1  EQU   @NM00077+1
ZIBFITXT EQU   ZIBFID1
ZIBSIB   EQU   ZIBFIB
ZIBREC   EQU   ZIBMDRIN
ZIBRECPL EQU   ZIBREC
ZIBRECHD EQU   ZIBRECPL
ZIBRECRS EQU   ZIBREC+8
ZIBRECDT EQU   ZIBREC+10
ZIBMDRRC EQU   ZIBMDREC
ZIBRCPL  EQU   ZIBMDRRC
ZIBRCDT  EQU   ZIBMDRRC+24
@NM00079 EQU   ZIBBTU
ZOBDLBT  EQU   ISTZOBUF
ZOBDLBCM EQU   ZOBDLBT
ZOBFDB   EQU   ZOBDLBCM
@NM00080 EQU   ZOBDLBCM+25
ZOBBTU   EQU   ZOBDLBT+28
ZOBWCC   EQU   ZOBDLBT+48
ZOBECCC  EQU   ZOBDLBT+50
ZOBTEXT  EQU   ZOBBTU
ZOBDIO   EQU   ZOBFSM
ZOBCCW2  EQU   ZOBDIO+8
ZOBCPTCC EQU   ZOBCCW2
ZOBFLAGS EQU   ZOBCCW2+5
ZOBRT08  EQU   ZOBFLAGS
ZOBCCW3  EQU   ZOBDIO+16
ZOBCPTRC EQU   ZOBCCW3
ZOBCPN2C EQU   ZOBCPTRC
ZOBCPTRA EQU   ZOBCCW3+1
@NM00084 EQU   ZOBBTU
ZOBTH2   EQU   @NM00084+4
ZLBBTRAN EQU   ISTZLBUF
ZLBAIO   EQU   ZLBBTRAN+16
ZLBDTIO  EQU   ZLBFSM
ZLBCCW1  EQU   ZLBDTIO
ZLBCPCF1 EQU   ZLBCCW1
ZLBCMOD  EQU   ZLBCCW1+5
ZLBCCW2  EQU   ZLBDTIO+8
ZLBCCW3  EQU   ZLBDTIO+16
ZLBSNS   EQU   ZLBDTIO+28
ZLBERC   EQU   ZLBDTIO+29
ZLBLCPBA EQU   ZLBDTIO+32
ZLBSAF   EQU   ZLBDTIO+48
ZLBSTAT  EQU   ZLBSAF
ZLBDEVST EQU   ZLBSTAT
ZLBRQTG  EQU   ZLBDTIO+50
ZLBRQFLG EQU   ZLBRQTG
ZLBFLAGS EQU   ZLBDTIO+56
ZLBTEXTA EQU   ZLBCCW3
ZLBTEXTB EQU   ZLBFLAGS
ZLBTEXTC EQU   ZLBFLAGS
ZLBPPL   EQU   ZLBTEXTC
ZLBFAIO  EQU   ZLBAIO
ZLBFSB   EQU   ZLBFAIO
CMZCIDM  EQU   ATCCIDM
SRB      EQU   SRBSECT
         AGO   .@UNREFD                START UNREFERENCED COMPONENTS
ZLBFDBS  EQU   ZLBFAIO+32
ZLBPPCSC EQU   ZLBPPL+14
ZLBPPRS1 EQU   ZLBPPL+13
ZLBPPRSV EQU   ZLBPPL+12
ZLBPPCLG EQU   ZLBPPL+12
ZLBPPCC  EQU   ZLBPPL+12
ZLBPPINT EQU   ZLBPPL+12
ZLBPPHIO EQU   ZLBPPL+12
ZLBPP    EQU   ZLBPPL+4
ZLBPPLDB EQU   ZLBPPL+1
ZLBPPLF  EQU   ZLBPPL
ZLBTEXT1 EQU   ZLBTEXTB
ZLBTEXT  EQU   ZLBTEXTA+8
ZLBRSV0A EQU   ZLBTEXTA
ZLBTCP   EQU   ZLBFLAGS+8
ZLBTCSW  EQU   ZLBFLAGS+1
ZLBRSV09 EQU   ZLBFLAGS
ZLBWCCSP EQU   ZLBFLAGS
ZLBRSV07 EQU   ZLBFLAGS
ZLBLSTST EQU   ZLBDTIO+52
ZLBRQSEQ EQU   ZLBRQTG+1
ZLBRT0B  EQU   ZLBRQFLG+1
ZLBRT0A  EQU   ZLBRQFLG+1
ZLBRT09  EQU   ZLBRQFLG+1
ZLBRT08  EQU   ZLBRQFLG+1
ZLBRT07  EQU   ZLBRQFLG
ZLBRT06  EQU   ZLBRQFLG
ZLBRT05  EQU   ZLBRQFLG
ZLBRT04  EQU   ZLBRQFLG
ZLBRT03  EQU   ZLBRQFLG
ZLBRT02  EQU   ZLBRQFLG
ZLBRT01  EQU   ZLBRQFLG
ZLBRT00  EQU   ZLBRQFLG
ZLBCHNST EQU   ZLBSTAT+1
ZLBUCST  EQU   ZLBDEVST
ZLBDEST  EQU   ZLBDEVST
ZLBRSV10 EQU   ZLBDEVST
ZLBLSTBF EQU   ZLBDTIO+44
ZLBRSV11 EQU   ZLBDTIO+40
ZLBLCCWA EQU   ZLBDTIO+36
ZLBCOMP  EQU   ZLBDTIO+31
ZLBRSV08 EQU   ZLBDTIO+30
ZLBRSV05 EQU   ZLBERC
ZLBFBMI  EQU   ZLBERC
ZLBETI   EQU   ZLBERC
ZLBEMI   EQU   ZLBERC
ZLBEBI   EQU   ZLBERC
ZLBECI   EQU   ZLBERC
ZLBELI   EQU   ZLBERC
ZLBSOC   EQU   ZLBSNS
ZLBSCC   EQU   ZLBSNS
ZLBSUS   EQU   ZLBSNS
ZLBSDC   EQU   ZLBSNS
ZLBSEQCK EQU   ZLBSNS
ZLBSBOL  EQU   ZLBSNS
ZLBSIR   EQU   ZLBSNS
ZLBSCR   EQU   ZLBSNS
ZLBRSV12 EQU   ZLBDTIO+24
ZLBCPTC3 EQU   ZLBCCW3+6
ZLBRSV04 EQU   ZLBCCW3+5
ZLBCPFL3 EQU   ZLBCCW3+4
ZLBCPAD3 EQU   ZLBCCW3+1
ZLBCPCF3 EQU   ZLBCCW3
ZLBCPTC2 EQU   ZLBCCW2+6
ZLBRSV03 EQU   ZLBCCW2+5
ZLBCPFL2 EQU   ZLBCCW2+4
ZLBCPAD2 EQU   ZLBCCW2+1
ZLBCPCF2 EQU   ZLBCCW2
ZLBCPTC1 EQU   ZLBCCW1+6
ZLBCPFL1 EQU   ZLBCCW1+4
ZLBCPAD1 EQU   ZLBCCW1+1
ZLBLNG2  EQU   ZLBBTRAN+14
ZLBRSV01 EQU   ZLBBTRAN+12
ZLBFDBZ  EQU   ZLBBTRAN
ZOBLH    EQU   @NM00084
ZOBCPN2K EQU   ZOBCCW3+6
ZOBRSV99 EQU   ZOBCCW3+5
ZOBCPN2F EQU   ZOBCCW3+4
ZOBCPTC2 EQU   ZOBCPTRA
ZOBCPTC1 EQU   ZOBCPN2C
ZOBCPNPK EQU   ZOBCCW2+6
ZOBRSV03 EQU   ZOBFLAGS
ZOBRT06  EQU   ZOBFLAGS
ZOBCPNPF EQU   ZOBCCW2+4
ZOBCPTCA EQU   ZOBCCW2+1
ZOBCPNPC EQU   ZOBCPTCC
ZOBCPWTK EQU   ZOBDIO+6
ZOBRSV02 EQU   ZOBDIO+5
ZOBCPWTF EQU   ZOBDIO+4
ZOBCPTXA EQU   ZOBDIO+1
ZOBCPWTC EQU   ZOBDIO
ZOBRSV09 EQU   ZOBECCC
ZOBECSP  EQU   ZOBECCC
ZOBRSV08 EQU   ZOBECCC
ZOBRSV07 EQU   ZOBDLBT+49
ZOBRSV06 EQU   ZOBWCC
ZOBWCSP  EQU   ZOBWCC
ZOBRSV05 EQU   ZOBWCC
ZOBRSV10 EQU   ZOBDLBCM+26
@NM00083 EQU   @NM00080
@NM00082 EQU   @NM00080
@NM00081 EQU   @NM00080
ZOBRSV04 EQU   ZOBDLBCM+16
ZOBLNG2  EQU   ZOBDLBCM+14
ZOBRSV01 EQU   ZOBDLBCM+12
ZIBTH2   EQU   @NM00079+4
ZIBLH    EQU   @NM00079
ZIBRCTXT EQU   ZIBMDRRC+36
ZIBRCRID EQU   ZIBRCDT+10
ZIBRCNAM EQU   ZIBRCDT+2
ZIBRCUA  EQU   ZIBRCDT
ZIBRCPUI EQU   ZIBRCPL+20
ZIBRCPUN EQU   ZIBRCPL+16
ZIBRCTIM EQU   ZIBRCPL+12
ZIBRCDAT EQU   ZIBRCPL+8
ZIBRCRS1 EQU   ZIBRCPL+6
ZIBRCSID EQU   ZIBRCPL+5
ZIBRCID  EQU   ZIBRCPL+4
ZIBRCSW  EQU   ZIBRCPL+2
ZIBRCSYR EQU   ZIBRCPL+1
ZIBRCL   EQU   ZIBRCPL
ZIBRECTX EQU   ZIBREC+22
ZIBRECID EQU   ZIBRECDT+10
ZIBRECNA EQU   ZIBRECDT+2
ZIBRECUA EQU   ZIBRECDT
ZIBRECSV EQU   ZIBRECRS
ZIBRECDA EQU   ZIBRECPL+4
ZIBRECSI EQU   ZIBRECHD+3
ZIBRECDV EQU   ZIBRECHD+2
ZIBRECFL EQU   ZIBRECHD+1
ZIBRECTY EQU   ZIBRECHD
ZIBTEXT  EQU   ZIBSIB+4
ZIBRSV04 EQU   ZIBSIB
ZIBTEXT2 EQU   ZIBFITXT
ZIBTEXT1 EQU   ZIBFIB+52
@NM00078 EQU   @NM00077
ZIBFDBS  EQU   ZIBBTU
@NM00076 EQU   ZIBMDREC
@NM00075 EQU   ZIBFSB
ZIBLNG2  EQU   ZIBAIOCM+14
ZIBRSV03 EQU   ZIBAIOCM+13
ZIBWKBYT EQU   ZIBAIOCM+12
ZIBFDBZ  EQU   ZIBAIOCM
ZIBCPNPK EQU   ZIBCCW2+6
ZIBRSV02 EQU   ZIBCCW2+5
ZIBCPTPF EQU   ZIBCCW2+4
ZIBCPTCA EQU   ZIBCCW2+1
ZIBCPNPC EQU   ZIBCPTCC
ZIBCPRDK EQU   ZIBDIO+6
ZIBRSV01 EQU   ZIBDIO+5
ZIBCPRDF EQU   ZIBDIO+4
ZIBCPTXA EQU   ZIBDIO+1
ZIBCPRDC EQU   ZIBDIO
FSBRT0B  EQU   @NM00074+1
FSBRT0A  EQU   @NM00074+1
FSBRT09  EQU   @NM00074+1
FSBRT08  EQU   @NM00074+1
FSBRT07  EQU   @NM00074
FSBRT06  EQU   @NM00074
FSBRT05  EQU   @NM00074
FSBRT04  EQU   @NM00074
FSBRT03  EQU   @NM00074
FSBRT02  EQU   @NM00074
FSBRT01  EQU   @NM00074
FSBRT00  EQU   @NM00074
FSBLDCUF EQU   FSBLDFLG
FSBLDSIF EQU   FSBLDFLG
FSBLDSOF EQU   FSBLDFLG
FSBLDEBF EQU   FSBLDFLG
FSBLDBBF EQU   FSBLDFLG
FSBLDFME EQU   FSBLDFLG
FSBLDSCF EQU   FSBLDFLG
FSBLDRMF EQU   FSBLDFLG
FSBRH2   EQU   FSBRHFLD+1
FSBRH1   EQU   FSBRHFLD
FSBALIGN EQU   FSBCOMBN
NSRUDA8T EQU   NSRUDAT8
NSRUOHID EQU   NSRUOH1
NSRULSV  EQU   NSRUCLSP
NSRUNA4  EQU   NSRUNA+2
NSRUNA3  EQU   NSRUNA2
NSRUNA1  EQU   NSRUNA
NSRUDILF EQU   NSRUDIL+4
NSRUDILE EQU   NSRUDIL+3
NSRUDILD EQU   NSRUDIL+2
NSRUDILC EQU   NSRUDILB
@NM00049 EQU   NSRUDILB
NSRUDILA EQU   NSRUDIL
NSRUDA7T EQU   NSRUDAT7
NSRUDA6L EQU   NSRUDAT6+4
NSRUDA6S EQU   NSRUDAT6
NSRUDA5E EQU   NSRUDAT5
NSRUDA4T EQU   NSRUDAT4
NSRUDA3S EQU   NSRUDAT3
SRUDAT4D EQU   SRUDATA4
SRUDAT3I EQU   SRUDATA3
MRUDATA  EQU   ISTMRU+9
MRURESP  EQU   ISTMRU+7
MRUMODIF EQU   ISTMRU+6
MRUCMND  EQU   ISTMRU+5
MRUDAF   EQU   ISTMRU+3
MRUREQ   EQU   ISTMRU+2
MRUPREF  EQU   ISTMRU
SRUDAT2N EQU   SRUDAT2+1
SRUDAT2T EQU   SRUDAT2
SRUDAT1I EQU   SRUDAT1+2
SRUTSPRO EQU   SRUDAT1L
SRUFMPRO EQU   SRUDAT1L
SRUDAT1T EQU   SRUDAT1
INORUET  EQU   ISTINORU
CTDRUSTA EQU   ISTCTDRU
TRRDATA  EQU   ISTTRRU+4
TRRSTAT  EQU   ISTTRRU+3
TRRPEP   EQU   ISTTRRU+2
TRRTIME  EQU   ISTTRRU+1
@NM00048 EQU   TRRTYPE
TRRFMT2  EQU   TRRTYPE
@NM00047 EQU   TRRTYPE
NSRUDAF  EQU   NSRUDAT1
NSSSVT5A EQU   NSSSVT5
NSSSVT4D EQU   NSSSVT4+3
NSSSVT4C EQU   NSSSVT4+2
NSSSVT4B EQU   NSSSVT4+1
NSSSVT4A EQU   NSSSVT4
NSSSVT3K EQU   NSSSVT3+8
NSSSVT3J EQU   NSSSVT3+7
NSSSVT3I EQU   NSSSVT3+6
@NM00046 EQU   NSSSVT3G
NSSSVT3H EQU   NSSSVT3G
NSSSVT3F EQU   NSSSVT3+4
NSSSVT3E EQU   NSSSVT3+3
@NM00045 EQU   NSSSVT3C
NSSSVT3D EQU   NSSSVT3C
NSSSVT3B EQU   NSSSVT3+1
NSSSVT3A EQU   NSSSVT3
NSSSVT   EQU   NSSSVRU+2
NSSSVDAF EQU   NSSSVRU
NSRUHKTY EQU   NSRUHOOK
NSRURCD  EQU   NSRUNETS+2
NSRUSUB  EQU   NSRUNETS+1
NSRUID   EQU   NSRUNETS
SRURSV01 EQU   SRULDID+4
SRUPSSN  EQU   SRULDID+2
SRUDFCLV EQU   SRUSPSN
@NM00044 EQU   SRUTYPE
SRUPSAC  EQU   SRUTYPE
SRUSPAC  EQU   SRUTYPE
SRUSNS4  EQU   SRUSENS2+1
SRUSNS3  EQU   SRUSENS2
SRUSNST  EQU   SRUSENS1+1
SRUSNS1  EQU   SRUSENS1
LCPZTRV4 EQU   LCPZSNAM+4
LCPZTRV1 EQU   LCPZSNAM
LCPZSNA  EQU   LCPZTIE+4
LCPZFMCA EQU   LCPZTIE
CVTRV628 EQU   CVTS01+728
CVTRV627 EQU   CVTS01+724
CVTRV626 EQU   CVTS01+720
CVTRV625 EQU   CVTS01+716
CVTRV624 EQU   CVTS01+712
CVTRV623 EQU   CVTS01+708
CVTRV622 EQU   CVTS01+704
CVTRV621 EQU   CVTS01+700
CVTRV620 EQU   CVTS01+696
CVTRV619 EQU   CVTS01+692
CVTRV618 EQU   CVTS01+688
CVTRV617 EQU   CVTS01+684
CVTRV616 EQU   CVTS01+680
CVTRV615 EQU   CVTS01+676
CVTRV614 EQU   CVTS01+672
CVTRV613 EQU   CVTS01+668
CVTTCASP EQU   CVTS01+664
CVT0PT03 EQU   CVTS01+660
CVT0PT0E EQU   CVTS01+656
CVTIRM   EQU   CVTS01+652
CVTCGK   EQU   CVTS01+648
CVTRV607 EQU   CVTS01+644
CVTRV606 EQU   CVTS01+640
CVTRV605 EQU   CVTS01+636
CVTRV604 EQU   CVTS01+632
CVTEFF02 EQU   CVTS01+628
CVTCBBR  EQU   CVTS01+624
CVTSSCR  EQU   CVTS01+620
CVTEVENT EQU   CVTS01+616
CVTCRCA  EQU   CVTS01+612
CVTTPIO  EQU   CVTS01+608
CVTADV   EQU   CVTS01+604
CVTGSDAB EQU   CVTGSDA
CVTQV3   EQU   CVTS01+596
CVTQV2   EQU   CVTS01+592
CVTQV1   EQU   CVTS01+588
CVTRPT   EQU   CVTS01+584
CVTSSRB  EQU   CVTS01+580
CVTCSDRL EQU   CVTS01+576
CVTEXP1  EQU   CVTS01+572
CVTRMPMT EQU   CVTS01+568
CVTRMPTT EQU   CVTS01+564
CVTVPSA  EQU   CVTS01+560
CVTVSTOP EQU   CVTS01+556
CVTGTFR8 EQU   CVTS01+552
CVTQUIT  EQU   CVTS01+548
CVTVACR  EQU   CVTS01+544
CVTWTCB  EQU   CVTS01+540
CVTSTPRS EQU   CVTS01+536
CVT0PT02 EQU   CVTS01+532
CVTDARCM EQU   CVTS01+528
CVTIRECM EQU   CVTS01+524
CVTJRECM EQU   CVTS01+520
CVTVEMS0 EQU   CVTS01+516
CVTSPFRR EQU   CVTS01+512
CVTRLSTG EQU   CVTS01+508
CVT0TC0A EQU   CVTS01+504
CVTGMBR  EQU   CVTS01+500
CVTLFRM  EQU   CVTS01+496
CVTRMBR  EQU   CVTS01+492
CVTVIOP  EQU   CVTS01+488
CVTRV307 EQU   CVTS01+486
CVTRV306 EQU   CVTS01+484
CVTRV305 EQU   CVTS01+482
CVTRV304 EQU   CVTS01+480
CVTRV303 EQU   CVTS01+478
CVTRV302 EQU   CVTS01+476
CVTTRCA  EQU   CVTS01+472
CVTRV297 EQU   CVTRV289
CVTRV296 EQU   CVTRV289
CVTRV295 EQU   CVTRV289
CVTRV294 EQU   CVTRV289
CVTRV293 EQU   CVTRV289
CVTRV292 EQU   CVTRV289
CVTRV291 EQU   CVTRV289
CVTRV290 EQU   CVTRV289
CVTRV288 EQU   CVTRV280
CVTRV287 EQU   CVTRV280
CVTRV286 EQU   CVTRV280
CVTRV285 EQU   CVTRV280
CVTRV284 EQU   CVTRV280
CVTRV283 EQU   CVTRV280
CVTRV282 EQU   CVTRV280
CVTRV281 EQU   CVTRV280
CVTRV279 EQU   CVTRV271
CVTRV278 EQU   CVTRV271
CVTRV277 EQU   CVTRV271
CVTRV276 EQU   CVTRV271
CVTRV275 EQU   CVTRV271
CVTRV274 EQU   CVTRV271
CVTRV273 EQU   CVTRV271
CVTRV272 EQU   CVTRV271
CVTRV270 EQU   CVTRV262
CVTRV269 EQU   CVTRV262
CVTRV268 EQU   CVTRV262
CVTRV267 EQU   CVTRV262
CVTRV266 EQU   CVTRV262
CVTRV265 EQU   CVTRV262
CVTRV264 EQU   CVTRV262
CVTRV263 EQU   CVTRV262
CVTVFP   EQU   CVTS01+464
CVTVSI   EQU   CVTS01+460
CVTVPSIB EQU   CVTS01+456
CVTMFACT EQU   CVTMFRTR
CVTMFCTL EQU   CVTS01+448
CVTPVBP  EQU   CVTS01+444
CVTPWI   EQU   CVTS01+440
CVTRV254 EQU   CVTS01+438
CVTRV253 EQU   CVTS01+436
CVTRV252 EQU   CVTS01+434
CVTRV251 EQU   CVTS01+433
CVTRV250 EQU   CVTS01+432
CVTRV249 EQU   CVTS01+431
CVTRV248 EQU   CVTS01+430
CVTRV247 EQU   CVTS01+429
CVTRV246 EQU   CVTS01+428
CVTRV245 EQU   CVTRV237
CVTRV244 EQU   CVTRV237
CVTRV243 EQU   CVTRV237
CVTRV242 EQU   CVTRV237
CVTRV241 EQU   CVTRV237
CVTRV240 EQU   CVTRV237
CVTRV239 EQU   CVTRV237
CVTRV238 EQU   CVTRV237
CVTRV236 EQU   CVTRV228
CVTRV235 EQU   CVTRV228
CVTRV234 EQU   CVTRV228
CVTRV233 EQU   CVTRV228
CVTRV232 EQU   CVTRV228
CVTRV231 EQU   CVTRV228
CVTRV230 EQU   CVTRV228
CVTRV229 EQU   CVTRV228
CVTRV227 EQU   CVTRV219
CVTRV226 EQU   CVTRV219
CVTRV225 EQU   CVTRV219
CVTRV224 EQU   CVTRV219
CVTRV223 EQU   CVTRV219
CVTRV222 EQU   CVTRV219
CVTRV221 EQU   CVTRV219
CVTRV220 EQU   CVTRV219
CVTRV218 EQU   CVTRV210
CVTRV217 EQU   CVTRV210
CVTRV216 EQU   CVTRV210
CVTRV215 EQU   CVTRV210
CVTRV214 EQU   CVTRV210
CVTRV213 EQU   CVTRV210
CVTRV212 EQU   CVTRV210
CVTRV211 EQU   CVTRV210
CVTLCCAT EQU   CVTS01+420
CVTPCCAT EQU   CVTS01+416
CVTIPCRP EQU   CVTS01+412
CVTIPCRI EQU   CVTS01+408
CVTIPCDS EQU   CVTS01+404
CVTAIDVT EQU   CVTS01+400
CVTSSAP  EQU   CVTS01+396
CVTEHCIR EQU   CVTS01+392
CVTEHDEF EQU   CVTS01+388
CVTDAIR  EQU   CVTS01+384
CVTPERFM EQU   CVTS01+380
CVT044R2 EQU   CVTS01+376
CVTFETCH EQU   CVTS01+372
CVTRSTWD EQU   CVTS01+368
CVTSPOST EQU   CVTS01+364
CVTIOBP  EQU   CVTS01+360
CVTASMVT EQU   CVTS01+356
CVTRECRQ EQU   CVTS01+352
CVTWSAC  EQU   CVTS01+348
CVTRV149 EQU   CVTS01+344
CVTWSAL  EQU   CVTS01+340
CVTSPSA  EQU   CVTS01+336
CVTGLMN  EQU   CVTS01+332
CVTVEAC0 EQU   CVTS01+328
CVT062R1 EQU   CVTS01+324
CVTRPOST EQU   CVTS01+320
CVTDQIQE EQU   CVTS01+316
CVTCSD   EQU   CVTS01+312
CVTLKRMA EQU   CVTS01+308
CVTRSPIE EQU   CVTS01+304
CVTRENQ  EQU   CVTS01+300
CVTLQCB  EQU   CVTS01+296
CVTFQCB  EQU   CVTS01+292
CVTQCS01 EQU   CVTS01+288
CVTAPFT  EQU   CVTS01+284
CVTPARRL EQU   CVTS01+280
CVTVWAIT EQU   CVTS01+276
CVTGSPL  EQU   CVTS01+272
CVTLSMQ  EQU   CVTS01+268
CVTGSMQ  EQU   CVTS01+264
CVTEXPRO EQU   CVTS01+260
CVTOPCTP EQU   CVTS01+256
CVTSIC   EQU   CVTS01+252
CVTTPIOS EQU   CVTS01+248
CVTRTMS  EQU   CVTS01+244
CVTSDBF  EQU   CVTS01+240
CVTSCBP  EQU   CVTS01+236
CVTSDMP  EQU   CVTS01+232
CVTSV60  EQU   CVTS01+228
CVTRTMCT EQU   CVTS01+224
CVTASCBL EQU   CVTS01+220
CVTASCBH EQU   CVTS01+216
CVTGDA   EQU   CVTS01+212
CVTASVT  EQU   CVTS01+208
CVTVVMDI EQU   CVTS01+204
CVTAQTOP EQU   CVTS01+200
CVTIOSCS EQU   CVTS01+196
CVTSDRM  EQU   CVTS01+192
CVTOPTE  EQU   CVTS01+188
CVTSTXU  EQU   CVTS01+184
CVTQUIS  EQU   CVTS01+180
CVTPARS  EQU   CVTS01+176
CVTS1EE  EQU   CVTS01+172
CVTFRAS  EQU   CVTS01+168
CVTQSAS  EQU   CVTS01+164
CVTCRAS  EQU   CVTS01+160
CVTCRMN  EQU   CVTS01+156
CVTDELCP EQU   CVTS01+152
CVTFRECL EQU   CVTS01+148
CVTGETCL EQU   CVTS01+144
CVTBLDCP EQU   CVTS01+140
CVTAUTHL EQU   CVTS01+136
CVTSCAN  EQU   CVTS01+132
CVTRV144 EQU   CVTS01+130
CVTMAXMP EQU   CVTS01+128
CVTSTCK  EQU   CVTS01+124
CVTRV139 EQU   CVTS01+123
CVTDSSAC EQU   CVTS01+122
CVTRV513 EQU   CVTS01+121
CVTIOSPL EQU   CVTS01+120
CVTPTGT  EQU   CVTS01+116
CVTCSPIE EQU   CVTS01+112
CVTSMFEX EQU   CVTS01+108
CVTOLT0A EQU   CVTS01+104
CVTSRBRT EQU   CVTS01+100
CVTPUTL  EQU   CVTS01+96
CVTASCRL EQU   CVTS01+92
CVTASCRF EQU   CVTS01+88
CVTRV326 EQU   CVTS01+84
CVTRV325 EQU   CVTS01+80
CVTRV324 EQU   CVTS01+76
CVT0VL01 EQU   CVTS01+72
CVTSHRVM EQU   CVTS01+68
CVTRV332 EQU   CVTS01+64
CVTTAS   EQU   CVTS01+60
CVTRSCN  EQU   CVTS01+56
CVTTRAC2 EQU   CVTS01+54
CVTTRACE EQU   CVTS01+52
CVTAPG   EQU   CVTS01+51
CVTSDTRC EQU   CVTCTLFG
CVTGTRCE EQU   CVTCTLFG
CVTNOMP  EQU   CVTCTLFG
CVTRSV79 EQU   CVTCTLFG
CVTDSTAT EQU   CVTCTLFG
CVTRSV78 EQU   CVTCTLFG
CVTRV333 EQU   CVTCTLFG
CVTRV323 EQU   CVTCTLFG
CVTSPVLK EQU   CVTS01+49
CVTRSV77 EQU   CVTS01+48
CVTRV331 EQU   CVTS01+44
CVTRV330 EQU   CVTS01+40
CVTRV329 EQU   CVTS01+36
CVTRV328 EQU   CVTS01+32
CVTRV322 EQU   CVTS01+28
CVTSLID  EQU   CVTSLIDA+1
CVTSYLK  EQU   CVTSLIDA
CVTRV321 EQU   CVTS01+20
CVTRV320 EQU   CVTS01+16
CVTLPDIR EQU   CVTLPDIA+1
CVTRSV69 EQU   CVTDIRST
CVTRSV68 EQU   CVTDIRST
CVTRSV67 EQU   CVTDIRST
CVTRSV66 EQU   CVTDIRST
CVTRSV65 EQU   CVTDIRST
CVTRSV64 EQU   CVTDIRST
CVTRSV63 EQU   CVTDIRST
CVTDICOM EQU   CVTDIRST
CVTPVTP  EQU   CVTS01+8
CVTLPDSR EQU   CVTS01+4
CVTGETL  EQU   CVTS01
IOSPCIWA EQU   IOSPCISC+44
IOSPCIRS EQU   IOSPCISC+8
@NM00007 EQU   IOSPCISC+4
@NM00006 EQU   IOSPCISC
IOSWRNDR EQU   IOSWTOWA+4
IOSWTOPT EQU   IOSWTOWA+3
IOSWTOCP EQU   IOSWTOWA+2
IOSWTOCH EQU   IOSWTOWA
IOSATTWA EQU   IOSATTSC+40
@NM00005 EQU   IOSATTSC+24
IOSATTSN EQU   IOSATTSC
BPDCBID  EQU   ISTBPDTY+336
BPDENTRY EQU   ISTBPDTY+144
@NM00097 EQU   BPDTRACE+6
BPDAVNO  EQU   BPDTRACE+4
BPDMQUE  EQU   BPDTRACE+2
BPDMUSE  EQU   BPDTRACE
BPDTRADR EQU   BPDPARM+4
BPDTRID  EQU   BPDPARM+3
@NM00096 EQU   BPDPARM+2
BPDTRLEN EQU   BPDPARM
BPDREQMX EQU   BPDHDR+46
BPDREQCT EQU   BPDHDR+44
BPDRSV01 EQU   BPDFLAG
BPDGTR   EQU   BPDFLAG
BPDATCVT EQU   BPDHDR+36
BPDFBPE  EQU   BPDHDR+32
BPDSMPCB EQU   BPDHDR+28
BPDFEXT  EQU   BPDHDR+24
BPDADRS2 EQU   BPDHDR+20
BPDADRS1 EQU   BPDHDR+16
BPDPGPCB EQU   BPDHDR+12
BPDCHBSZ EQU   BPDHDR+6
BPDCHBNO EQU   BPDHDR+4
BPDBPMAX EQU   BPDHDR+2
BPDBPENT EQU   BPDHDR
BPERSV03 EQU   ISTBPENT+12
BPEBPCB  EQU   ISTBPENT+8
BPEBFSIZ EQU   ISTBPENT+6
BPERSV02 EQU   BPEFLAGS+1
BPEUSRF  EQU   BPEFLAGS+1
BPERSV01 EQU   BPEFLAGS
BPENWS   EQU   BPEFLAGS
BPECBID  EQU   BPEFLAGS
BPEAL48  EQU   BPEFLAGS
BPENFCHP EQU   BPEFLAGS
BPEFIXED EQU   BPEFLAGS
BPEDISP  EQU   BPEFLAGS
BPEFM    EQU   BPEFLAGS
BPEPID   EQU   ISTBPENT
WKECHNGP EQU   WKECHAIN+1
@NM00095 EQU   WKEFLAGS
WKEGATE  EQU   WKEFLAGS
@NM00094 EQU   ISTWKE
ZLFZWRD5 EQU   ISTZLFVT+48
ZLFZWRD4 EQU   ISTZLFVT+44
ZLFZDFK0 EQU   ISTZLFVT+40
ZLFZEMEA EQU   ISTZLFVT+36
ZLFZFFEA EQU   ISTZLFVT+32
ZLFZEMCA EQU   ZLFZEACA
ZLFZEMFA EQU   ZLFZEAFA
ZLFZFFXA EQU   ISTZLFVT+20
ZLFZFMTA EQU   ZLFZFATA
ZLFZEMTA EQU   ZLFZEATA
ZLFZFMFA EQU   ZLFZFAFA
ZLFZEMAA EQU   ZLFZEAAA
ZLBLNG1  EQU   ZLBFSM
ZLBCHAIN EQU   ISTZLBUF
NCSRUITS EQU   NCSUSSRU+2
NCSRULEN EQU   NCSUSSRU
NCSAPPAB EQU   NCSAPP+608
NCSAPDAT EQU   NCSAPBUE+8
NCSAPRU  EQU   NCSAPBUE+3
NCSRSV04 EQU   NCSAPBUE
NCSAPEND EQU   NCSAPP+84
NCSAPTXT EQU   NCSAPP+76
NCSAPECB EQU   NCSAPP+72
NCSAPSA  EQU   NCSAPP
NCSPLPDB EQU   NCSPLSID+5
NCSPLNID EQU   NCSPLPHD
NCSPLPO  EQU   NCSPLSTA
NCSRSVD4 EQU   NCSPLSTA
NCSRSVD2 EQU   NCSCRMOD
NCSPTMOD EQU   NCSCRMOD
NCSAIMOD EQU   NCSCRMOD
NCSRSVD1 EQU   NCSCHKPT+1
NCSPTUSE EQU   NCSCHKPT+1
NCSRNME  EQU   NCSCHKPT+1
NCSCUA   EQU   NCSCHKPT+1
NCSANSMD EQU   NCSCHKPT+1
NCSLGMOD EQU   NCSCHKPT
NCSLGAPL EQU   NCSCHKPT
NCSDTRLM EQU   NCSCHKPT
NCSESLM  EQU   NCSCHKPT
NCSNRPL  EQU   NCSCHKPT
NCSPOLD  EQU   NCSCHKPT
NCSPACTV EQU   NCSCHKPT
NCSACTV  EQU   NCSCHKPT
NCSCRDTE EQU   ISTNCSPL+264
NCSPLRTY EQU   ISTNCSPL+263
NCSPLRH  EQU   ISTNCSPL+260
NCSUFMCB EQU   ISTNCSPL+256
NCSMGLPT EQU   ISTNCSPL+252
NCSCPWPT EQU   ISTNCSPL+248
NCSSENS2 EQU   NCSSENSE+2
NCSSNS2  EQU   NCSSENSE+1
NCSSNS1  EQU   NCSSENSE
NCSPLNSN EQU   ISTNCSPL+240
NCSPLMID EQU   ISTNCSPL+232
NCSPLPID EQU   ISTNCSPL+231
NCSPLGID EQU   ISTNCSPL+230
NCSPLSQN EQU   ISTNCSPL+228
NCSRNAME EQU   ISTNCSPL+220
NCSPLRUI EQU   ISTNCSPL+212
NCSPLRUO EQU   ISTNCSPL+208
NCSPLRRP EQU   ISTNCSPL+204
NCSPLWEL EQU   ISTNCSPL+200
NCSPLSPL EQU   ISTNCSPL+196
NCSPLP3  EQU   ISTNCSPL+192
NCSPLP2  EQU   ISTNCSPL+188
NCSPLP1  EQU   ISTNCSPL+184
NCSPLOLN EQU   ISTNCSPL+182
@NM00089 EQU   NCSPLFL5
NCSFORCE EQU   NCSPLFL5
NCSSDLK  EQU   NCSPLFL5
NCSSCPPS EQU   NCSPLFL5
NCSDLRSN EQU   ISTNCSPL+180
NCSPL2AP EQU   NCSPLFL4
NCSDSPN  EQU   NCSPLFL4
NCSDSPI  EQU   NCSPLFL4
NCSDSPA  EQU   NCSPLFL4
NCSDSPE  EQU   NCSPLFL4
NCSPLVID EQU   NCSPLFL4
NCSPLRSO EQU   NCSPLFL4
NCSDLNID EQU   NCSPLFL4
NCSEND   EQU   NCSPLFL3
NCSFINAL EQU   NCSPLFL3
NCSANS   EQU   NCSPLFL3
NCSPID   EQU   NCSPLFL3
NCSGID   EQU   NCSPLFL3
NCSPLANS EQU   NCSPLFL3
NCSEPP   EQU   NCSPLFL3
NCSPLMOM EQU   NCSPLFL3
NCSPLVIT EQU   NCSPLFL2
NCSPLVIS EQU   NCSPLFL2
NCSREMPO EQU   NCSPLFL2
NCSPLDS  EQU   NCSPLFL2
NCSOUFMC EQU   NCSPLFL2
NCSPLRIO EQU   NCSPLFL2
NCSPLRSF EQU   NCSPLFL2
NCSPLVDP EQU   NCSPLFL2
NCSPLPOS EQU   NCSPLFL1
NCSPL2CN EQU   NCSPLFL1
NCSPLAPU EQU   NCSPLFL1
NCSPLNON EQU   NCSPLFL1
NCSPLREQ EQU   NCSPLFL1
NCSPLEBN EQU   NCSPLFL1
NCSPLSOM EQU   NCSPLFL1
NCSPL2IN EQU   NCSPLFL1
NCSPLRCR EQU   ISTNCSPL+172
NCSPLECB EQU   ISTNCSPL+164
NCSPLCVT EQU   ISTNCSPL+156
NCSPLWKA EQU   ISTNCSPL+152
NCSPLDAF EQU   NCSPLCID+2
NCSPLSAF EQU   NCSPLCID
NCSPLRCD EQU   NCSPLRAD+1
NCSLSCMD EQU   NCSPLRAD
NCSPLWRF EQU   ISTNCSPL+72
NCSPLWRE EQU   ISTNCSPL+68
NCSSTCMD EQU   NCSCRFLG
NCSUSRNF EQU   NCSCRFLG
NCSOPRQU EQU   NCSCRFLG
NCSCRDSE EQU   NCSCRFLG
NCSFMERP EQU   NCSCRFLG
NCSFMCLD EQU   NCSCRFLG
NCSPLCLD EQU   NCSCRFLG
NCSPLWRM EQU   NCSCRFLG
NCSPLUAD EQU   ISTNCSPL+64
NCSMSGSP EQU   ISTNCSPL+63
NCSNCPEP EQU   ISTNCSPL+62
NCSCMDB  EQU   NCSPLCMD+1
@NM00088 EQU   NCSCMDA
NCSPLUFM EQU   NCSCMDA
NCSPLFLO EQU   NCSCMDA
NCSPLSYN EQU   NCSCMDA
NCSPLCTL EQU   NCSCMDA
NCSPLSYS EQU   NCSCMDA
NCSPLLPT EQU   ISTNCSPL+56
NCSPLRPT EQU   ISTNCSPL+52
NCSCRPID EQU   ISTNCSPL+51
NCSCRCMD EQU   ISTNCSPL+50
NCSDLID  EQU   ISTNCSPL+44
NCSPLLID EQU   ISTNCSPL+36
NCSPLRID EQU   ISTNCSPL+28
NCSRRNPT EQU   ISTNCSPL+24
NCSIORC  EQU   ISTNCSPL+23
NCSPRMRC EQU   ISTNCSPL+22
NCSOVFMC EQU   NCSPLVF1
NCSRSV02 EQU   NCSPLVFL
NCSDACLK EQU   NCSPLVFL
NCSABCON EQU   NCSPLVFL
NCSDCONT EQU   NCSPLVFL
NCSVSTAT EQU   NCSPLVFL
NCSVDEL  EQU   NCSPLVFL
NCSVNCSA EQU   NCSPLVFL
NCSVBF16 EQU   NCSPLVBF+1
NCSVBF15 EQU   NCSPLVBF+1
NCSVBF14 EQU   NCSPLVBF+1
NCSVBF13 EQU   NCSPLVBF+1
NCSVBF12 EQU   NCSPLVBF+1
NCSVBF11 EQU   NCSPLVBF+1
NCSVBF10 EQU   NCSPLVBF+1
NCSVBF09 EQU   NCSPLVBF+1
NCSVBF08 EQU   NCSPLVBF
NCSVBF07 EQU   NCSPLVBF
NCSVBF06 EQU   NCSPLVBF
NCSVBF05 EQU   NCSPLVBF
NCSVBF04 EQU   NCSPLVBF
NCSVBF03 EQU   NCSPLVBF
NCSVBF02 EQU   NCSPLVBF
NCSVBF01 EQU   NCSPLVBF
NCSPLVCD EQU   ISTNCSPL+17
@NM00087 EQU   ISTNCSPL+16
NCSCRWKA EQU   NCSPFX+12
@NM00086 EQU   NCSPFX
PFXBCK   EQU   ISTPFX+12
PFXFWD   EQU   ISTPFX+8
PFXLNG   EQU   ISTPFX+5
PFXPRTY  EQU   ISTPFX+4
PFXCBID  EQU   PFXID
POHID    EQU   ISTPOHD+2
POHGEN   EQU   POHSTAT
POHRREQ  EQU   POHSTAT
POHRSVD2 EQU   POHSTAT
POHCNTRL EQU   POHSTAT
POHLBL   EQU   POHSTAT
POHDATA  EQU   POHSTAT
POHEND   EQU   POHSTAT
POHRSVD1 EQU   ISTPOHD
ZOBLNG1  EQU   ZOBFSM
ZOBCHAIN EQU   ISTZOBUF
ZIBLNG1  EQU   ZIBFSM
FSBRSV01 EQU   FSBFSB+30
FSBTHCNT EQU   FSBFSB+28
FSBRLRSV EQU   FSBRLSTS
FSBCFTX  EQU   FSBRLSTS
FSBSSOC  EQU   FSBSS2
FSBSSCC  EQU   FSBSS2
FSBSSDC  EQU   FSBSS2
FSBSSEC  EQU   FSBSS2
FSBSSIR  EQU   FSBSS2
FSBSSCR  EQU   FSBSS2
@NM00073 EQU   FSBSS2
@NM00072 EQU   FSBSS1
FSBSSDE  EQU   FSBSS1
FSBSSUS  EQU   FSBSS1
@NM00071 EQU   FSBSS1
FSBSOHI  EQU   FSBERC
FSBLGI   EQU   FSBERC
FSBLMRI  EQU   FSBFBMI
FSBETI   EQU   FSBERC
FSBEMI   EQU   FSBERC
FSBEBI   EQU   FSBERC
FSBECI   EQU   FSBERC
FSBELI   EQU   FSBERC
FSBXLCI  EQU   FSBXCODE
FSBXFINS EQU   FSBXCODE
FSBXNORM EQU   FSBXFSTS
FSBSCODE EQU   FSBSYSRS
FSBSPHSE EQU   FSBSYSRS
FSBCMD   EQU   FSBSEQ
FSBDTRCE EQU   FSBFLAGS
FSBASBTU EQU   FSBFLAGS
FSBINPET EQU   FSBFLAGS
FSBNONCB EQU   FSBFLAGS
FSBLBIND EQU   FSBFLAGS
FSBFFIND EQU   FSBFLAGS
FSBACIND EQU   FSBFLAGS
FSBRFIND EQU   FSBFLAGS
FSBGATE  EQU   FSBFSBA
FSBLATOP EQU   FSBSFLGS
FSBRSV02 EQU   FSBSFLGS
FSBPGBUF EQU   FSBSFLGS
FSBMNSDA EQU   FSBMNRCD
FSBMNOA  EQU   FSBMNRCD
FSBMNDIF EQU   FSBMNRCD
FSBMNEOP EQU   FSBMNRCD
FSBMNDNU EQU   FSBMNRCD
FSBMNATN EQU   FSBMNRCD
FSBMNRVI EQU   FSBMNRCD
FSBMNELI EQU   FSBMNRCD
BTUTEXT  EQU   ISTBTU+20
BTURSV02 EQU   BTUSYSTR
BTUPHASE EQU   BTUSYSTR
BTURSV01 EQU   BTUSYSTR
BTUPAD   EQU   BTURH+3
BTURH3   EQU   BTURH+2
BTURH2   EQU   BTURH+1
BTURH1   EQU   BTURH
BTUZRTSC EQU   BTURQFLG+1
BTUZRT0B EQU   BTURQFLG+1
BTUZRT0A EQU   BTURQFLG+1
BTUZRT09 EQU   BTURQFLG+1
BTUZRT08 EQU   BTURQFLG+1
BTUZRT07 EQU   BTURQFLG
BTUZRT06 EQU   BTURQFLG
BTUZRT05 EQU   BTURQFLG
BTUZRT04 EQU   BTURQFLG
BTUZRT03 EQU   BTURQFLG
BTUZRT02 EQU   BTURQFLG
BTUZRT01 EQU   BTURQFLG
BTUZRT00 EQU   BTURQFLG
BTUCDF   EQU   BTUFID+1
BTUSCF   EQU   BTUFID+1
BTUPRY   EQU   BTUFID+1
BTUASFL  EQU   BTUFID
BTUPSFL  EQU   BTUFID
BTUMPF   EQU   BTUFID
BTUFIDNO EQU   BTUFID
FDBFDBA  EQU   ISTFDB
BDURSV04 EQU   BDUFLAGS
BDURTOE  EQU   BDUFLAGS
BDUSTPR  EQU   BDUFLAGS
BDURSV03 EQU   BDUFLAGS
BDUALT   EQU   BDUFUNC
BDUNACK  EQU   BDUFUNC
BDUACK   EQU   BDUFUNC
BDUTRPM  EQU   BDUFUNC
BDUFBMI  EQU   BDUFUNC
BDULDGPH EQU   BDUFUNC
BDUHEADP EQU   BDUFUNC
BDUSOH   EQU   BDUCHECK
BDURSV01 EQU   BDUMODIF
BDUMOD0  EQU   BDUMOD1
LDNZS00F EQU   LDNZH003+1
LDNZS00E EQU   LDNZH003+1
LDNZS00D EQU   LDNZH003+1
LDNZS00C EQU   LDNZH003+1
LDNZS00B EQU   LDNZH003+1
LDNZS007 EQU   LDNZH003
LDNZS006 EQU   LDNZH003
LDNZS005 EQU   LDNZH003
LDNZS004 EQU   LDNZH003
LDNZS003 EQU   LDNZH003
LDNZS002 EQU   LDNZH003
LDNZS001 EQU   LDNZH003
LDNZS000 EQU   LDNZH003
LDNZX006 EQU   ISTLDNCB+576
LDNZC001 EQU   ISTLDNCB+569
LDNZX005 EQU   ISTLDNCB+568
LDNZV006 EQU   ISTLDNCB+564
LDNSRB   EQU   ISTLDNCB+520
LDNIOSB  EQU   ISTLDNCB+412
@NM00070 EQU   LDNZSAV3+28
LDNRSV06 EQU   LDNZSAV4+16
LDNZSAV6 EQU   LDNZSAV4+12
LDNZSAV5 EQU   LDNZSAV4
LDNZSAVE EQU   LDNZSAV3
LDNZSAV2 EQU   ISTLDNCB+368
LDNZSAV1 EQU   ISTLDNCB+352
LDNZ3RR  EQU   ISTLDNCB+348
LDNZ2RR  EQU   ISTLDNCB+344
LDNZ1RR  EQU   ISTLDNCB+340
LDNRSV0B EQU   ISTLDNCB+336
LDNRSV0A EQU   ISTLDNCB+332
LDNRSV09 EQU   ISTLDNCB+328
LDNRSV08 EQU   ISTLDNCB+324
LDNRSV07 EQU   ISTLDNCB+320
LDNDEAD  EQU   LDNDCDEB+12
LDNUCBAD EQU   LDNDCDEB+8
LDNAPPAD EQU   LDNDCDEB+5
LDNEXSCL EQU   LDNDCDEB+4
LDNDCBAD EQU   LDNDCDEB+1
LDNDEBID EQU   LDNDCDEB
LDNZRIND EQU   ISTLDNCB+300
LDNRPH   EQU   ISTLDNCB+192
LDNZTCP  EQU   ISTLDNCB+188
LDNZCHNC EQU   ISTLDNCB+187
LDNZLPC7 EQU   LDNZLPC
LDNZLPC6 EQU   LDNZLPC
LDNZLPC5 EQU   LDNZLPC
LDNZLPC4 EQU   LDNZLPC
LDNZLPC3 EQU   LDNZLPC
LDNZLPC2 EQU   LDNZLPC
LDNZLPC1 EQU   LDNZLPC
LDNZLPC0 EQU   LDNZLPC
LDNRSV05 EQU   LDNZERPF
LDNZCTOV EQU   LDNZEPIN
LDNZF001 EQU   LDNZEPIN
LDNZFRDW EQU   LDNZCPAN
LDNZFRD  EQU   LDNZCPAN
LDNZNARD EQU   LDNZCPAN
LDNRSV04 EQU   LDNZIOLK
LDNZATBF EQU   LDNZIOLK
LDNZERLK EQU   LDNZIOLK
LDNZDSIC EQU   LDNZIOLK
LDNZPAB1 EQU   ISTLDNCB+168
LDNZV005 EQU   ISTLDNCB+160
LDNZS1VR EQU   ISTLDNCB+136
LDNZS1RR EQU   ISTLDNCB+132
LDNZS1FC EQU   ISTLDNCB+128
LDNZS1BC EQU   ISTLDNCB+124
LDNZLOCK EQU   ISTLDNCB+120
LDNZFBUF EQU   ISTLDNCB+116
LDNZLAST EQU   ISTLDNCB+112
LDNRSV02 EQU   LDNFLAG2
LDNZFF04 EQU   LDNFLAG2
LDNZFF69 EQU   LDNFLAGS+2
LDNTPBIO EQU   LDNFLAGS+2
LDNZFF03 EQU   LDNFLAGS+2
LDNZFF02 EQU   LDNFLAGS+2
LDNZFF01 EQU   LDNFLAGS+2
LDNZFF00 EQU   LDNFLAGS+2
LDNCLOSD EQU   LDNFLAGS+2
LDNZENTR EQU   LDNFLAGS+2
LDNZICCW EQU   LDNFLAGS+1
LDNZREC  EQU   LDNFLAGS+1
LDNZCTXT EQU   LDNFLAGS+1
LDNZATLK EQU   LDNFLAGS+1
LDNZCHNE EQU   LDNFLAGS+1
LDNZATTP EQU   LDNFLAGS+1
LDNZIOBY EQU   LDNFLAGS+1
LDNZF00A EQU   LDNFLAGS+1
LDNZF009 EQU   LDNFLAGS
LDNZF008 EQU   LDNFLAGS
LDNZF006 EQU   LDNFLAGS
LDNZF005 EQU   LDNFLAGS
LDNZF004 EQU   LDNFLAGS
LDNZF003 EQU   LDNFLAGS
LDNZF002 EQU   LDNFLAGS
LDNZHDCC EQU   ISTLDNCB+106
LDNZARM  EQU   ISTLDNCB+104
LDNZRM   EQU   ISTLDNCB+102
LDNZRB   EQU   ISTLDNCB+100
LDNCPQ   EQU   ISTLDNCB+96
LDNSIOQ  EQU   ISTLDNCB+92
LDNZX002 EQU   ISTLDNCB+91
LDNZX001 EQU   ISTLDNCB+90
LDNZH002 EQU   ISTLDNCB+88
LDNZV001 EQU   ISTLDNCB+84
LDNZACSW EQU   ISTLDNCB+76
LDNZC002 EQU   ISTLDNCB+68
LDNCSWSV EQU   ISTLDNCB+60
LDNCHFLD EQU   ISTLDNCB+56
LDNRESRV EQU   ISTLDNCB+55
@NM00069 EQU   LDNCFLAG
LDNRMF   EQU   LDNCFLAG
LDNIBI   EQU   LDNCFLAG
LDNTSAF  EQU   ISTLDNCB+52
LDNCUUA  EQU   ISTLDNCB+48
LDNCB    EQU   ISTLDNCB
LUNLOCK  EQU   LUNZOS
LUNCB    EQU   ISTLUNCB
@NM00068 EQU   CCNFLGA
CCNSTART EQU   CCNFLGA
@NM00067 EQU   CCNFLGA
CCNCB    EQU   ISTCCNCB
ICNZCON6 EQU   ICNZCONS+10
ICNZCON5 EQU   ICNZCONS+8
ICNZCON4 EQU   ICNZCONS+6
ICNZCON3 EQU   ICNZCONS+4
ICNZCON2 EQU   ICNZCONS+2
ICNZCON1 EQU   ICNZCONS
ICNZATSA EQU   ISTICNCB+676
ICNZX012 EQU   ISTICNCB+675
ICNZX011 EQU   ISTICNCB+674
ICNZX010 EQU   ISTICNCB+672
ICNSRB   EQU   ISTICNCB+628
ICNIOSB  EQU   ISTICNCB+520
ICNZC001 EQU   ISTICNCB+512
ICNZX013 EQU   ISTICNCB+511
ICNZS010 EQU   ICNZH002+1
ICNZS00F EQU   ICNZH002+1
ICNZS00E EQU   ICNZH002+1
ICNZS00D EQU   ICNZH002+1
ICNZS00C EQU   ICNZH002+1
ICNZS00B EQU   ICNZH002+1
ICNZS01A EQU   ICNZS00A
ICNZS019 EQU   ICNZS009
ICNZS018 EQU   ICNZS008
ICNZS017 EQU   ICNZS007
ICNZS016 EQU   ICNZS006
ICNZS005 EQU   ICNZH002
ICNZS014 EQU   ICNZS004
ICNZS013 EQU   ICNZS003
ICNZS012 EQU   ICNZS002
ICNZS001 EQU   ICNZH002
ICNZF028 EQU   ICNZFLAG
ICNZF027 EQU   ICNZFLAG
ICNZF026 EQU   ICNZFLAG
ICNZF025 EQU   ICNZFLAG
ICNZF024 EQU   ICNZFLAG
ICNZF023 EQU   ICNZFLAG
ICNZF022 EQU   ICNZFLAG
ICNZF021 EQU   ICNZFLAG
ICNWORD5 EQU   ISTICNCB+504
ICNMSIZE EQU   ISTICNCB+500
ICNLCVTA EQU   ISTICNCB+496
ICNDEBAD EQU   ICNDIDEB+1
ICNDCBIF EQU   ICNDIDEB
ICNUCBAD EQU   ICNDCDEB+8
ICNAPPAD EQU   ICNDCDEB+5
ICNEXSCL EQU   ICNDCDEB+4
ICNDCBAD EQU   ICNDCDEB+1
ICNDEBID EQU   ICNDCDEB
@NM00066 EQU   ISTICNCB+477
ICNERCNT EQU   ISTICNCB+476
ICNZX002 EQU   ISTICNCB+475
ICNZX001 EQU   ISTICNCB+474
ICNZH001 EQU   ISTICNCB+472
ICNZSW3R EQU   ISTICNCB+468
ICNZSW2R EQU   ISTICNCB+464
ICNZSW1R EQU   ISTICNCB+460
ICNZS4VR EQU   ISTICNCB+436
ICNZS4RR EQU   ISTICNCB+432
ICNZS4FC EQU   ISTICNCB+428
ICNZS4BC EQU   ISTICNCB+424
ICNZS3VR EQU   ISTICNCB+400
ICNZS3RR EQU   ISTICNCB+396
ICNZS3FC EQU   ISTICNCB+392
ICNZS3BC EQU   ISTICNCB+388
ICNZS1RC EQU   ICNZS1VR+36
ICNDIEW3 EQU   ICNDIEWA+8
ICNDIEW2 EQU   ICNDIEWA+4
ICNDIEW1 EQU   ICNDIEWA
ICNZS1RR EQU   ISTICNCB+344
ICNZS1FC EQU   ISTICNCB+340
ICNZS1BC EQU   ISTICNCB+336
ICNRSTIC EQU   ICNZD004
ICNRDCOD EQU   ICNRSCCW
ICNZD006 EQU   ISTICNCB+312
ICNZD005 EQU   ISTICNCB+304
ICNWSTIC EQU   ICNZD002
ICNWRCOD EQU   ICNWSCCW
ICNZV008 EQU   ISTICNCB+284
ICNZV007 EQU   ISTICNCB+280
ICNZV006 EQU   ISTICNCB+276
ICNZV005 EQU   ISTICNCB+272
ICNZV004 EQU   ISTICNCB+268
ICNLSTIT EQU   ISTICNCB+264
ICNLSTIF EQU   ISTICNCB+260
ICNZV002 EQU   ISTICNCB+256
ICNZV001 EQU   ISTICNCB+252
ICNZV00A EQU   ISTICNCB+249
ICNBUFF  EQU   ISTICNCB+248
ICNCPQ   EQU   ISTICNCB+244
ICNNICNA EQU   ISTICNCB+240
@NM00065 EQU   ICNFLAG2+2
ICNZF019 EQU   ICNFLAG2+2
ICNZF018 EQU   ICNFLAG2+2
ICNZF017 EQU   ICNFLAG2+2
ICNZF016 EQU   ICNFLAG2+2
ICNZF015 EQU   ICNFLAG2+2
ICNMSG   EQU   ICNFLAG2+1
ICNCLOSE EQU   ICNFLAG2+1
ICNZF014 EQU   ICNFLAG2+1
ICNZF013 EQU   ICNFLAG2+1
ICNZF012 EQU   ICNFLAG2+1
ICNZF011 EQU   ICNFLAG2+1
ICNZF00D EQU   ICNFLAG2+1
ICNZF00B EQU   ICNFLAG2+1
ICNZF00A EQU   ICNFLAG2
ICNZF008 EQU   ICNFLAG2
ICNZF007 EQU   ICNFLAG2
ICNZF005 EQU   ICNFLAG2
ICNZF004 EQU   ICNFLAG2
ICNZF003 EQU   ICNFLAG2
ICNZF002 EQU   ICNFLAG2
ICNZF001 EQU   ICNFLAG2
ICNLOCK  EQU   ISTICNCB+232
ICNLICNA EQU   ISTICNCB+228
ICNRPH   EQU   ISTICNCB+120
ICNZV003 EQU   ISTICNCB+116
ICNLAST  EQU   ISTICNCB+112
ICNLSTBT EQU   ISTICNCB+108
ICNSIOQ  EQU   ISTICNCB+104
ICNFLAG1 EQU   ISTICNCB+103
ICNZSW08 EQU   ICNZSWS
ICNZSW07 EQU   ICNZSWS
ICNZSW06 EQU   ICNZSWS
ICNZSW05 EQU   ICNZSWS
ICNZSW04 EQU   ICNZSWS
ICNZSW03 EQU   ICNZSWS
ICNZSW02 EQU   ICNZSWS
ICNZSW01 EQU   ICNZSWS
ICNZFF69 EQU   ICNFFLAG
@NM00064 EQU   ICNFFLAG
ICNZFF05 EQU   ICNFFLAG
ICNZFF04 EQU   ICNFFLAG
ICNZFF03 EQU   ICNFFLAG
ICNZFF02 EQU   ICNFFLAG
ICNZFF01 EQU   ICNFFLAG
ICNZFF00 EQU   ICNFFLAG
@NM00063 EQU   ICNFLAG
ICNZCRIT EQU   ICNFLAG
ICNSTART EQU   ICNFLAG
ICNZF00F EQU   ICNFLAG
ICNZF00E EQU   ICNFLAG
ICNCONF  EQU   ICNZF006
ICNCKPAB EQU   ICNCKFLD+1
ICNRSV07 EQU   ICNCKFLD
ICNCKBIT EQU   ICNCKFLD
ICNZPAB4 EQU   ISTICNCB+80
ICNRSV01 EQU   ISTICNCB+60
@NM00062 EQU   ISTICNCB+56
@NM00061 EQU   ISTICNCB+54
@NM00060 EQU   @NM00059
ICNRRY   EQU   @NM00059
ICNROLN  EQU   @NM00059
ICNRNRY  EQU   @NM00059
ICNLNKMD EQU   ISTICNCB+52
ICNCUUA  EQU   ISTICNCB+48
DNCZV005 EQU   DNCOS+32
DNCZV003 EQU   DNCOS+24
DNCZV002 EQU   DNCOS+21
DNCZV000 EQU   DNCOS+12
DNCSESCQ EQU   DNCOS+8
DNCSESIQ EQU   DNCOS+4
DNCLICP  EQU   DNCBSCED
DNCZF008 EQU   DNCZFLGS+1
DNCZPSRD EQU   DNCZFLGS+1
DNCPSOL  EQU   DNCZFLGS+1
DNCZF007 EQU   DNCZFLGS+1
DNCZF006 EQU   DNCZFLGS+1
DNCZF005 EQU   DNCZFLGS+1
DNCZF004 EQU   DNCZFLGS+1
DNCZF003 EQU   DNCZFLGS
DNCMODE  EQU   ISTDNCB+49
DNCBHSET EQU   ISTDNCB+48
DNCNCB   EQU   ISTDNCB
FMCFLRSV EQU   FMCFLGB
FMCFLGA8 EQU   FMCFLGB
FMCCLRPH EQU   FMCVS1+45
FMCRSV0X EQU   FMCCVFLG
FMCVYRPH EQU   FMCCVFLG
FMCZV004 EQU   FMCVS1+40
FMCLOCK2 EQU   FMCVS1+36
@NM00058 EQU   FMCZFLG2
FMCZF027 EQU   FMCZFLG2
FMCZF026 EQU   FMCZFLG2
FMCSEQ1B EQU   FMCSEQ1
FMCSEQ1T EQU   FMCSEQ1
FMCZX006 EQU   FMCVS1+33
FMCZX005 EQU   FMCVS1+32
FMCZX004 EQU   FMCVS1+31
FMCZX003 EQU   FMCVS1+30
FMCZX002 EQU   FMCVS1+29
FMCZX001 EQU   FMCVS1+28
FMCZV001 EQU   FMCVS1+24
FMCAWATQ EQU   FMCLCPAQ+1
@NM00057 EQU   FMCLCPAQ
FMCLCPB2 EQU   FMCLCPBQ+1
FMCLCPB1 EQU   FMCLCPBQ
FMCASCDQ EQU   FMCSHEAQ+1
@NM00056 EQU   FMCSHEAQ
FMCSHEDQ EQU   FMCVS1+8
FMCZFCSQ EQU   FMCVS1+6
FMCZH001 EQU   FMCVS1+4
FMCZF025 EQU   FMCZFLAG+3
FMCZF024 EQU   FMCZFLAG+3
FMCZF023 EQU   FMCZFLAG+3
FMCZF022 EQU   FMCZFLAG+3
FMCZF021 EQU   FMCZFLAG+3
FMCZF020 EQU   FMCZFLAG+3
FMCZF019 EQU   FMCZFLAG+3
FMCZF018 EQU   FMCZFLAG+3
FMCZF017 EQU   FMCZFLAG+2
FMCZF016 EQU   FMCZFLAG+2
FMCZF015 EQU   FMCZFLAG+2
FMCZF014 EQU   FMCZFLAG+2
FMCZF013 EQU   FMCZFLAG+2
FMCZF012 EQU   FMCZFLAG+2
FMCZF011 EQU   FMCZFLAG+2
FMCZF010 EQU   FMCZFLAG+2
FMCZF00F EQU   FMCZFLAG+1
FMCZF00E EQU   FMCZFLAG+1
FMCZF00D EQU   FMCZFLAG+1
FMCZF00C EQU   FMCZFLAG+1
FMCZF00B EQU   FMCZFLAG+1
FMCRSV10 EQU   FMCZFLAG+1
FMCZF009 EQU   FMCZFLAG+1
FMCZFD06 EQU   FMCZF006+1
FMCZFC06 EQU   FMCZF006
FMCZFB06 EQU   FMCZF006
FMCZFA06 EQU   FMCZF006
FMCZF005 EQU   FMCZFLAG
FMCZF004 EQU   FMCZFLAG
FMCZF002 EQU   FMCZFLAG
FMCZF001 EQU   FMCZFLAG
FMCFRESA EQU   ISTFMCB+228
FMCSCSQN EQU   FMCSNCTL+2
FMCSCCTL EQU   FMCSNCTL+1
FMCSTCTL EQU   FMCSCFLG
FMCSCCLO EQU   FMCSCFLG
FMCAPRO  EQU   FMCSCFLG
FMCLURO  EQU   FMCSCFLG
FMCOBSAC EQU   FMCSCFLG
FMCIBSAC EQU   FMCSCFLG
FMCFBRE  EQU   ISTFMCB+220
FMCFBXM  EQU   FMCZV002
FMCASEGQ EQU   ISTFMCB+212
FMCRDTPT EQU   ISTFMCB+208
FMCLOCK  EQU   ISTFMCB+204
FMCSEGD  EQU   FMCSSEGQ
FMCRSPLM EQU   ISTFMCB+198
FMCPSTRS EQU   ISTFMCB+196
@NM00055 EQU   FMCRRESP
FMCTSLHA EQU   FMCRRESP
FMCFRRN  EQU   FMCRRESP
FMCFME   EQU   FMCRRESP
FMCFEX   EQU   FMCRRESP
FMCFPE   EQU   FMCRRESP
FMCCTLB  EQU   ISTFMCB+194
FMCBSQNO EQU   FMCCLSEQ+2
FMCTSQNO EQU   FMCCLSEQ
FMCOBPRG EQU   FMCMODEB
FMCIBPRG EQU   FMCMODEB
FMCRESOT EQU   FMCMODEB
FMCRSTSR EQU   FMCMODEB
FMCLUQ   EQU   FMCMODEB
FMCAPQ   EQU   FMCMODEB
FMCCLEAR EQU   FMCMODEB
FMCHOLD  EQU   FMCMODEB
FMCIPSEQ EQU   ISTFMCB+188
FMCLUSTR EQU   ISTFMCB+187
FMCRSV87 EQU   FMCSTAT2
FMCSEQI  EQU   FMCSTAT2
FMCCPIP  EQU   FMCSTAT2
FMCALIPR EQU   FMCSTAT2
FMCIAIO  EQU   FMCSTAT2
FMCZF00A EQU   FMCSTAT2
FMCVPIP  EQU   FMCSTAT2
FMCBHSET EQU   ISTFMCB+185
FMCPRMRC EQU   FMCCLEXT+20
FMCRSV89 EQU   FMCPSTAT
FMCPCLSD EQU   FMCPSTAT
FMCDDOCD EQU   FMCPSTAT
FMCIDVFD EQU   FMCPSTAT
FMCELKST EQU   FMCPSTAT
FMCRSV88 EQU   FMCPSCMD
FMCRDBLK EQU   FMCPSCMD
FMCDSEOC EQU   FMCPSCMD
FMCPURGE EQU   FMCPSCMD
FMCRESTI EQU   FMCPSCMD
FMCCNTCT EQU   FMCPSCMD
FMCINVT  EQU   FMCPSCMD
FMCFLGB7 EQU   FMCFLGCL
FMCFLGB6 EQU   FMCFLGCL
FMCFLGB5 EQU   FMCFLGCL
FMCFLGB4 EQU   FMCFLGCL
FMCFLGB3 EQU   FMCFLGCL
FMCFLGB2 EQU   FMCFLGCL
FMCFLGB1 EQU   FMCFLGCL
FMCFLGB0 EQU   FMCFLGCL
FMCFLGA7 EQU   FMCFLGA
FMCFLGA6 EQU   FMCFLGA
FMCFLGA5 EQU   FMCFLGA
FMCFLGA4 EQU   FMCFLGA
FMCFLGA3 EQU   FMCFLGA
FMCFLGA2 EQU   FMCFLGA
FMCFLGA1 EQU   FMCFLGA
FMCFLGA0 EQU   FMCFLGA
FMCDCLOK EQU   FMCCLEXT+12
FMCRAFM  EQU   FMCCLEXT+8
FMCFBPTR EQU   FMCFBA+1
FMCFBRSV EQU   FMCFBA
FMCRPLPT EQU   FMCRPLA+1
FMCRPLRS EQU   FMCRPLA
FMCPRCLS EQU   FMCCVAL
FMCIBCE  EQU   FMCCVAL
FMCONLY  EQU   FMCOBCE
FMCLAST  EQU   FMCOBCE
FMCMIDLE EQU   FMCOBCE
FMCFIRST EQU   FMCOBCE
FMCCPCNT EQU   FMCPACPC
FMCMPCNT EQU   FMCPACEM
FMCNPCNT EQU   FMCPACEN
FMCPURCH EQU   FMCSSTAT
FMCNSALU EQU   FMCSSTAT
FMCSDTR  EQU   FMCSSTAT
FMCRVD01 EQU   ISTFMCB+158
FMCISSN  EQU   ISTFMCB+156
FMCOASN  EQU   FMCNXOSC
FMCOSSN  EQU   FMCNXCFM
FMCSIP   EQU   FMCSIPA
FMCEXLST EQU   ISTFMCB+144
FMCPAB5  EQU   ISTFMCB+128
FMCPAB3  EQU   ISTFMCB+96
FMCPAB2  EQU   ISTFMCB+80
FMCPAB1  EQU   ISTFMCB+64
FMCFASYA EQU   ISTFMCB+60
FMCMODE  EQU   ISTFMCB+52
FMCPROCD EQU   ISTFMCB+48
FMCVWT   EQU   ISTFMCB+44
FMCRPLH  EQU   ISTFMCB+40
FMCBUFNB EQU   FMCCMPS1+2
FMCBUFLM EQU   FMCCMPS1
FMCDEBA  EQU   ISTFMCB+32
@NM00054 EQU   FMCCMDFL
FMCSNA   EQU   FMCCMDFL
FMCVSNA  EQU   FMCCMDFL
FMCCMDR  EQU   FMCCMDFL
@NM00053 EQU   ISTFMCB+30
@NM00052 EQU   FMCSTAT1
FMCLTCLS EQU   FMCSTAT1
FMCHPURG EQU   FMCSTAT1
FMCVSP2  EQU   FMCSTAT1
FMCVSP1  EQU   FMCSTAT
FMCLTEAS EQU   FMCSTAT
FMCZF007 EQU   FMCSTAT
FMCDEDSC EQU   FMCSTAT
FMCDAPT  EQU   FMCSTAT
FMCPRMTE EQU   FMCSTAT
FMCPRMTR EQU   FMCSTAT
FMCUSFLD EQU   ISTFMCB+24
FMCDNCBA EQU   ISTFMCB+16
FMCDVTA  EQU   ISTFMCB+12
FMCNXTCB EQU   ISTFMCB+4
FMCLNGTH EQU   ISTFMCB+1
FMCTYPE  EQU   ISTFMCB
PROSRDEF EQU   PROSETM4
PRORSV47 EQU   PROSETM4
PROSCON  EQU   PROSETM4
PRORSV46 EQU   PROSETM3
PROSMONT EQU   PROSETM3
PRORSV45 EQU   PROSETM3
PROSNTO  EQU   PROSETM3
PRORSV44 EQU   PROSETM3
PRORSV43 EQU   PROSETM2
PROSNTFL EQU   PROSETM2
PRORSV42 EQU   PROSETM2
PRORSV41 EQU   PROPROCS
PROMODC  EQU   PROPROC4
PROMODT  EQU   PROPROC4
PROMODM  EQU   PROPROC4
PROMODB  EQU   PROPROC4
PRORSV14 EQU   PROPROC4
PRORSV13 EQU   PROPROC4
PRORSV12 EQU   PROPROC4
PROEIB   EQU   PROPROC4
PROMONT3 EQU   PROPROC3
PROMONT2 EQU   PROPROC3
PROMONIT EQU   PROPROC3
PROSUBLK EQU   PROPROC3
PRONTO   EQU   PROPROC3
PROLGIN  EQU   PROPROC3
PROERPI  EQU   PROPROC3
PRORSV07 EQU   PROPROC3
PROCFTX  EQU   PROPROC2
PROEMLC  EQU   PROPROC2
PRONTFL  EQU   PROPROC2
PRORSV05 EQU   PROPROC2
PRORSV04 EQU   PROPROC2
PROLGOT  EQU   PROPROC2
PROERPO  EQU   PROPROC2
PRORSV03 EQU   PROPROC2
PRORPLC  EQU   PROPROC1
PROCS    EQU   PROPROC1
PROCA    EQU   PROPROC1
PRORESPX EQU   PROPROC1
PRODFASY EQU   PROPROC1
PROXPOPT EQU   PROPROC1
PROTRUNC EQU   PROPROC1
PROASYIP EQU   PROPROC1
NCBRSV01 EQU   ISTNCB+46
NCBDEVCH EQU   ISTNCB+36
NCBFMCBP EQU   ISTNCB+32
NCBLTRC  EQU   ISTNCB+30
NCBRVPT1 EQU   ISTNCB+28
NCBNMLLN EQU   NCBFLAGS+3
@NM00051 EQU   NCBFLAG1
NCBFORCE EQU   NCBFLAG1
NCBTTF   EQU   NCBFLAG1
NCBRSYNC EQU   NCBFLAG1
NCBRSTRT EQU   NCBFLAG1
NCBSNAI  EQU   NCBFLAG1
NCBFLTIO EQU   NCBFTRIO
NCBCSTAT EQU   NCBFLAGS
NCBNCSL  EQU   ISTNCB+22
NCBRDTE  EQU   ISTNCB+4
NCBLNGTH EQU   ISTNCB+1
DEVRSV03 EQU   ISTDEVCH+5
DEVPHYSA EQU   ISTDEVCH+4
DEVCSLPN EQU   DEVCHAR3
DEVCSTCL EQU   DEVCHAR3
DEVCCHEK EQU   DEVCHAR3
DEVCATTN EQU   DEVCHAR3
DEVCSWL  EQU   DEVFCCTL
DEVCRVB  EQU   DEVFCCTL
DEVCSSL  EQU   DEVFCCTL
DEVCBSC  EQU   DEVFCCTL
DEVMCODE EQU   ISTDEVCH+2
DEVCHAR2 EQU   DEVTCODE
DEVRSV01 EQU   DEVCHAR
DEVCCTL  EQU   DEVCHAR
DEVNNSPT EQU   DEVCHAR
DEVSPS   EQU   DEVCHAR
DEVSUBND EQU   DEVCHAR
DEVCONVR EQU   DEVCHAR
DEVOTPUT EQU   DEVCHAR
DEVINPUT EQU   DEVCHAR
LHVDATA  EQU   ISTLH+4
LHFUNCT  EQU   ISTLH+3
@NM00050 EQU   ISTLH+2
TH2SNF   EQU   ISTTH2+4
TH2CMPLI EQU   TH2MPF
TH2RHI   EQU   TH2MPF
THSNF    EQU   ISTTH+6
THCDF    EQU   THFLGB
THSEF    EQU   THFLGB
THPYF    EQU   THFLGB
THCMPLI  EQU   THMPF
THRHI    EQU   THMPF
NSRUNA6  EQU   NSRUNA5
RUBDATA  EQU   ISTRUB
RHRSVD5  EQU   RH3
RHRSVD4  EQU   RH3
RHLOG    EQU   RH3
RHRSVD3  EQU   RH3
RHRCDIR  EQU   RH3
RHCDIR   EQU   RH3
RHEB     EQU   RH3
RHBB     EQU   RH3
RHPACE   EQU   RH2
RHRSVD2  EQU   RH2
RHINOP   EQU   RHRSVD1
RHBUSY   EQU   RHRETRY
RHEXCEPT EQU   RH2
RHRRN    EQU   RH2
RHPE     EQU   RH2
RHFME    EQU   RH2
RHCHAIN  EQU   RH1
RHFORMAT EQU   RH1
RHDIRI   EQU   RH1
RHSCI    EQU   RH1
RHTYPE   EQU   RH1
RHQS     EQU   RH1
NMLRSV05 EQU   ISTNMLPB+96
NMLRSV04 EQU   ISTNMLPB+92
NMLDRDTE EQU   ISTNMLPB+88
NMECBPTR EQU   ISTNMLPB+84
NMLRSV02 EQU   ISTNMLPB+82
NMLRSV06 EQU   ISTNMLPB+81
NMIPSEQ  EQU   ISTNMLPB+80
NMNCSPL  EQU   NMRDTEA
NMRSV01  EQU   NMLCWCMD+1
NMECRST  EQU   NMLCWCMD+1
NMVRYPRG EQU   NMLCWCMD+1
NMSTCTLF EQU   NMLCWCMD+1
NMSTCTLI EQU   NMLCWCMD+1
NMSTCTLR EQU   NMLCWCMD
NMFBDTA  EQU   NMLCWCMD
NMRDBLK  EQU   NMLCWCMD
NMDSEOC  EQU   NMLCWCMD
NMPURGE  EQU   NMLCWCMD
NMRESTI  EQU   NMLCWCMD
NMCNTCT  EQU   NMLCWCMD
NMINVT   EQU   NMLCWCMD
NMPSRTRY EQU   NMCONTRL+1
NMFNCTCD EQU   NMCONTRL
NMLCW3   EQU   ISTNMLPB+64
NMLCW2   EQU   ISTNMLPB+56
NMLCPB   EQU   ISTNMLPB
ATCAOS   EQU   ISTATCVT+1584
ATCPOPAB EQU   ATCAOSM+640
ATCVIOPM EQU   ATCAOSM+636
ATCTPMMI EQU   ATCAOSM+632
ATCTPMPB EQU   ATCAOSM+600
ATCRSV88 EQU   ATCAOSM+596
ATCRPLCT EQU   ATCAOSM+594
ATCCRACT EQU   ATCAOSM+592
ATCSRBCT EQU   ATCAOSM+590
ATCRSV75 EQU   ATCAOSM+589
ATCRSV66 EQU   ATCZFLAG
ATCZF001 EQU   ATCZFLAG
ATCTPCP1 EQU   ATCAOSM+584
ATCTPCP0 EQU   ATCAOSM+580
ATCAICTN EQU   ATCAOSM+576
ATCZR01  EQU   ATCAOSM+572
ATCMPLTA EQU   ATCAOSM+568
ATCASCB  EQU   ATCAOSM+564
ATCAP86  EQU   ATCAOSM+560
ATCAP85  EQU   ATCAOSM+556
ATCAP84  EQU   ATCAOSM+552
ATCAP83  EQU   ATCAOSM+548
ATCAP82  EQU   ATCAOSM+544
ATCAP69  EQU   ATCAOSM+540
ATCAP66  EQU   ATCAOSM+536
ATCAP62  EQU   ATCAOSM+532
ATCAPC59 EQU   ATCAOSM+528
ATCAP56  EQU   ATCAOSM+524
ATCAP55  EQU   ATCAOSM+520
ATCRCFY0 EQU   ATCAOSM+516
ATCAP41  EQU   ATCAOSM+512
ATCAPC25 EQU   ATCAOSM+508
ATCAP23  EQU   ATCAOSM+504
ATCTRMPB EQU   ATCAOSM+440
ATCAPBE  EQU   ATCAOSM+436
ATCPSTA  EQU   ATCAOSM+432
ATCSMABF EQU   ATCAOSM+428
ATCSMAPR EQU   ATCAOSM+424
ATCSMARA EQU   ATCAOSM+412
ATCCACXA EQU   ATCAOSM+408
ATCZLAAB EQU   ATCAOSM+404
ATCATA10 EQU   ATCAOSM+400
ATCHLTCB EQU   ATCAOSM+396
@NM00043 EQU   ATCVTFLG
ATCVTACT EQU   ATCVTFLG
ATCRPT40 EQU   ATCAOSM+388
ATCRPT39 EQU   ATCAOSM+384
ATCRPT38 EQU   ATCAOSM+380
ATCRPT37 EQU   ATCAOSM+376
ATCRPT36 EQU   ATCAOSM+372
ATCRPT35 EQU   ATCAOSM+368
ATCRPT34 EQU   ATCAOSM+364
ATCRPT33 EQU   ATCAOSM+360
ATCRPT32 EQU   ATCAOSM+356
ATCRPT31 EQU   ATCAOSM+352
ATCRPT30 EQU   ATCAOSM+348
ATCRPT29 EQU   ATCAOSM+344
ATCRPT28 EQU   ATCAOSM+340
ATCRPT27 EQU   ATCAOSM+336
@NM00042 EQU   ATCAOSM+333
@NM00041 EQU   @NM00040
ATCSNUF  EQU   @NM00040
ATCOPKL  EQU   @NM00040
ATCABEN  EQU   @NM00040
ATCAIWT  EQU   ATCAOSM+328
ATCINFDD EQU   ATCAOSM+324
ATCORFMG EQU   ATCAOSM+320
ATCORFRL EQU   ATCAOSM+316
ATCOROBT EQU   ATCAOSM+312
ATCORQG  EQU   ATCORSRB
ATCORTBF EQU   ATCSQAFR
ATCRPLAC EQU   ATCRPLCN+2
ATCRPLRC EQU   ATCRPLCN
ATCCRPLQ EQU   ATCCRPL
ATCSRBAC EQU   ATCSRBCN+2
ATCSRBRC EQU   ATCSRBCN
ATCSRBQ  EQU   ATCSRB
ATCCRAAC EQU   ATCCRACN+2
ATCCRARC EQU   ATCCRACN
ATCCRAQ  EQU   ATCCRA
ATCRPT12 EQU   ATCAOSM+276
ATCDMAPP EQU   ATCAOSM+272
ATCAP38  EQU   ATCAOSM+268
ATCZDFJ0 EQU   ATCAOSM+260
ATCAP51  EQU   ATCAOSM+256
ATCZPAB2 EQU   ATCAOSM+224
ATCZPAB1 EQU   ATCAOSM+192
ATCZLPVT EQU   ATCAOSM+184
ATCZDVTX EQU   ATCAOSM+180
ATCZDVTA EQU   ATCAOSM+176
ATCZDVT9 EQU   ATCAOSM+172
ATCZDVT8 EQU   ATCAOSM+168
ATCZDVT7 EQU   ATCAOSM+164
ATCRSV56 EQU   ATCDAPVT+22
ATCDAPDG EQU   ATCDAPVT+20
ATCDXCEA EQU   ATCDAPVT+16
ATCDCEA  EQU   ATCDAPVT+12
ATCDPCIA EQU   ATCDAPVT+8
ATCDSIOA EQU   ATCDAPVT+4
ATCDEOEA EQU   ATCDAPVT
ATCZLAEA EQU   ATCLDAPP+16
ATCZLCEA EQU   ATCLDAPP+12
ATCRSV17 EQU   ATCLDAPP+8
ATCSMFRR EQU   ATCLDAPP+4
ATCZAEA  EQU   ATCICAPP+16
ATCZCEA  EQU   ATCICAPP+12
ATCCDTCB EQU   ATCICAPP+8
ATCZSIOA EQU   ATCICAPP+4
ATCCDRPH EQU   ATCICAPP
ATCAP65  EQU   ATCAOSM+96
ATCZDVT6 EQU   ATCAOSM+92
ATCZDVT4 EQU   ATCAOSM+88
ATCZDVT3 EQU   ATCAOSM+84
ATCZDVT1 EQU   ATCAOSM+80
ATCICNCB EQU   ATCAOSM+76
ATCAP64  EQU   ATCAOSM+64
ATCAP63  EQU   ATCAOSM+60
ATCAP61  EQU   ATCAOSM+56
ATCAP58  EQU   ATCAOSM+52
ATCAP57  EQU   ATCAOSM+48
ATCAP54  EQU   ATCAOSM+44
ATCAP53  EQU   ATCAOSM+40
ATCAP52  EQU   ATCAOSM+36
ATCAP12  EQU   ATCAOSM+20
ATCAP11  EQU   ATCAOSM+16
ATCCMTCB EQU   ATCAOSM+12
ATCPRPH  EQU   ATCAOSM+8
ATCGSRBF EQU   ATCGSRBG
ATCSRBRT EQU   ATCAOSM
@NM00039 EQU   @NM00038
ATCVTMAB EQU   @NM00038
@NM00037 EQU   ATCVTBAM
ATCVDLOK EQU   ISTATCVT+904
ATCVFPAB EQU   ISTATCVT+872
ATCVDPAB EQU   ISTATCVT+840
ATCIOECB EQU   ISTATCVT+836
ATCINCW3 EQU   ISTATCVT+832
ATCMODTB EQU   ISTATCVT+828
ATCUSSPT EQU   ISTATCVT+824
ATCSRTAB EQU   ISTATCVT+820
@NM00036 EQU   ISTATCVT+819
@NM00035 EQU   ATCSTAT2
ATCTRSMS EQU   ATCSTAT2
ATCTRLOK EQU   ATCSTAT2
ATCTRPSS EQU   ATCSTAT2
ATCTRESC EQU   ATCSTAT2
ATCTRAPI EQU   ATCSTAT2
ATCNMCTR EQU   ISTATCVT+816
ATCSEC51 EQU   ATCSECST
ATCSEC40 EQU   ATCSIPD+8
ATCSEC30 EQU   ATCSIPD+4
ATCSEC21 EQU   ATCSIPD
ATCSEC10 EQU   ATCSOPD+4
ATCSEC01 EQU   ATCSOPD
ATCPOIA  EQU   ATCRNO+1
@NM00034 EQU   ATCRNO
ATCPODVT EQU   ISTATCVT+784
ATCS49XL EQU   ISTATCVT+780
ATCS49XI EQU   ISTATCVT+776
ATCLCLCT EQU   ATCVLCNT+2
ATCRNCNT EQU   ATCVLCNT
ATCCFEAD EQU   ISTATCVT+768
ATCPTR00 EQU   ISTATCVT+736
ATCRSV10 EQU   ISTATCVT+704
ATCTACB  EQU   ISTATCVT+700
ATCVTINM EQU   ISTATCVT+696
ATCTCLIM EQU   ISTATCVT+692
ATCTCLOM EQU   ISTATCVT+688
ATCVTIPB EQU   ISTATCVT+656
ATCTCIPB EQU   ISTATCVT+624
ATCTIPAB EQU   ISTATCVT+592
ATCOCCCB EQU   ISTATCVT+588
ATCOCCOB EQU   ISTATCVT+584
ATCCDLAD EQU   ISTATCVT+580
ATCCCLAD EQU   ISTATCVT+576
ATCDLRPB EQU   ISTATCVT+544
ATCPGPAB EQU   ISTATCVT+512
ATCVPAB1 EQU   ISTATCVT+480
ATCRSV97 EQU   ISTATCVT+476
ATCRDTLK EQU   ISTATCVT+472
ATCVOCLK EQU   ISTATCVT+468
ATCDVTLK EQU   ISTATCVT+456
ATCAP35  EQU   ISTATCVT+448
ATCRSV99 EQU   ISTATCVT+440
ATCONFIG EQU   ISTATCVT+432
ATCNODDS EQU   ISTATCVT+428
ATCNODEL EQU   ISTATCVT+420
ATCRSV69 EQU   ISTATCVT+416
ATCAPCR5 EQU   ISTATCVT+412
ATCLDECB EQU   ISTATCVT+408
ATCLDNCS EQU   ISTATCVT+404
ATCCDPTR EQU   ISTATCVT+400
ATCADEL  EQU   ISTATCVT+396
ATCTODVT EQU   ISTATCVT+392
ATCDEBCH EQU   ISTATCVT+388
ATCHBSIZ EQU   ATCHPGM+2
ATCHBFNO EQU   ATCHPGM
ATCCRME  EQU   ISTATCVT+380
ATCRVCHS EQU   ISTATCVT+372
ATCECTLP EQU   ISTATCVT+368
ATCZDVTB EQU   ISTATCVT+364
ATCECPRT EQU   ISTATCVT+360
ATCVTLOD EQU   ISTATCVT+356
ATCTRPAB EQU   ISTATCVT+352
ATCMSGM  EQU   ISTATCVT+348
ATCMSGP  EQU   ISTATCVT+344
ATCEPT   EQU   ISTATCVT+340
ATCDVT   EQU   ISTATCVT+336
ATCTRCPT EQU   ISTATCVT+332
ATCDVLOD EQU   ISTATCVT+328
ATCALERT EQU   ISTATCVT+324
ATCEPA   EQU   ISTATCVT+320
ATCSAF   EQU   ISTATCVT+318
ATCXRANG EQU   ISTATCVT+317
ATCLAST  EQU   ATCSHRFG
ATCSHRTN EQU   ISTATCVT+308
ATCUEP   EQU   ISTATCVT+304
ATCOCRT  EQU   ISTATCVT+300
ATCCSMA  EQU   ATCCSMR
ATCESC02 EQU   ISTATCVT+292
ATCESC01 EQU   ISTATCVT+288
ATCMNT   EQU   ISTATCVT+272
ATCRSV16 EQU   ISTATCVT+270
ATCMAXID EQU   ISTATCVT+269
ATCMSGSP EQU   ATCCOM+268
ATCACTRM EQU   ATCCOM+264
ATCNERAP EQU   ATCCOM+260
ATCNESAL EQU   ATCCOM+256
ATCRCC65 EQU   ATCCOM+252
ATCRCC26 EQU   ATCCOM+248
ATCRCC63 EQU   ATCCOM+244
ATCRSV11 EQU   ATCCOM+242
ATCAPOST EQU   ATCCOM+236
ATCNERFN EQU   ATCCOM+232
ATCNERNE EQU   ATCCOM+228
ATCNERCV EQU   ATCCOM+224
ATCNERST EQU   ATCCOM+220
ATCDCC61 EQU   ATCCOM+216
ATCDCC60 EQU   ATCCOM+212
ATCSRTDF EQU   ATCCOM+208
ATCSRTAD EQU   ATCCOM+204
ATCFIRA  EQU   ATCCOM+200
ATCSMBQ  EQU   ATCCOM+196
ATCSMRC  EQU   ATCCOM+192
ATCSMQU  EQU   ATCCOM+184
ATCACDA  EQU   ATCCOM+176
ATCSTMA  EQU   ATCCOM+172
ATCFRSTR EQU   ATCCOM+168
ATCGTSTR EQU   ATCCOM+164
ATCREADA EQU   ATCCOM+160
ATCALOAD EQU   ATCCOM+156
ATCBLDLA EQU   ATCCOM+152
ATCFBRPH EQU   ATCCOM+148
ATCBFTRC EQU   ATCCOM+144
ATCTPBUF EQU   ATCTHTRC
ATCREMOV EQU   ATCCOM+136
ATCADD   EQU   ATCCOM+132
ATCDVTPT EQU   ATCCOM+124
ATCFEPT  EQU   ATCCOM+120
ATCFDVT  EQU   ATCCOM+116
ATCCONFT EQU   ATCCOM+112
ATCPTCHA EQU   ATCCOM+108
ATCAUTHA EQU   ATCCOM+104
ATCACCTA EQU   ATCCOM+100
ATCRDTH  EQU   ATCCOM+96
ATCFRSCH EQU   ATCCOM+92
ATCFSB   EQU   ATCCOM+88
ATCHLTMS EQU   ATCCOM+84
ATCECPRM EQU   ATCCOM+80
ATCECNET EQU   ATCCOM+76
ATCECOPC EQU   ATCCOM+72
ATCVPARM EQU   ATCCOM+68
ATCECVRQ EQU   ATCCOM+64
ATCECSES EQU   ATCCOM+60
ATCOCHA  EQU   ATCCOM+56
ATCDSPLQ EQU   ATCCOM+52
ATCECDSP EQU   ATCCOM+48
ATCVARYQ EQU   ATCCOM+44
ATCECVRY EQU   ATCCOM+40
ATCHALTQ EQU   ATCCOM+36
ATCECHLT EQU   ATCCOM+32
ATCMODQ  EQU   ATCCOM+28
ATCECMOD EQU   ATCCOM+24
ATCASCHD EQU   ATCCOM+20
ATCSRT   EQU   ATCCOM+16
ATCRDT   EQU   ATCCOM+12
ATCDCFRR EQU   ATCCOM+8
ATCAPI   EQU   ATCCOM+4
ATCRSV04 EQU   ATCSTAT4
ATCVTTRC EQU   ATCSTAT4
ATCNCSD  EQU   ATCSTAT4
ATCMTST  EQU   ATCSTAT4
ATCTPRT  EQU   ATCSTAT4
ATCPRTAT EQU   ATCSTAT4
@NM00033 EQU   ATCPOFLG
ATCPOUNS EQU   ATCPOFLG
ATCHSDMF EQU   ATCSTFLG
@NM00032 EQU   ATCSTAT1
ATCMDHLT EQU   ATCSTAT1
ATCINHLT EQU   ATCSTAT1
ATCNETSL EQU   ATCSTAT1
ATCQKHLT EQU   ATCSTAT1
ATCSNHLT EQU   ATCSTAT1
ATCACTIV EQU   ATCSTAT1
ATCSTART EQU   ATCSTAT1
LOKXCL   EQU   @NM00030
LOKPRY   EQU   @NM00030
@NM00031 EQU   @NM00030
@NM00029 EQU   LOKCHNG
LOKCT    EQU   ISTLOK
CRACHAIN EQU   ISTCRA+928
CRARSV02 EQU   ISTCRA+924
CRARSV01 EQU   ISTCRA+920
CRABFTBA EQU   CRABUFA
CRAMASK  EQU   CRASVC+64
CRAHSIZ  EQU   CRASVC+60
CRAASCRR EQU   CRASVC
CRAPSS   EQU   ISTCRA+160
CRARPH   EQU   ISTCRA+52
CRALAPTR EQU   CRABASIC+48
CRAL9PTR EQU   CRABASIC+44
CRAL8PTR EQU   CRABASIC+40
CRAL7PTR EQU   CRABASIC+36
CRAL6PTR EQU   CRABASIC+32
CRAL4PTR EQU   CRABASIC+24
CRAL3PTR EQU   CRABASIC+20
CRAL2PTR EQU   CRABASIC+16
CRAL1PTR EQU   CRABASIC+12
CRALEV01 EQU   CRALKACT+3
CRALEV02 EQU   CRALKACT+3
CRALEV03 EQU   CRALKACT+3
CRALEV04 EQU   CRALKACT+3
CRALEV05 EQU   CRALKACT+3
CRALEV06 EQU   CRALKACT+3
CRALEV07 EQU   CRALKACT+3
CRALEV08 EQU   CRALKACT+3
CRALEV09 EQU   CRALKACT+2
CRALEV10 EQU   CRALKACT+2
CRALEV11 EQU   CRALKACT+2
CRALEV12 EQU   CRALKACT+2
CRALEV13 EQU   CRALKACT+2
CRALEV14 EQU   CRALKACT+2
CRALEV15 EQU   CRALKACT+2
CRALEV16 EQU   CRALKACT+2
CRALEV17 EQU   CRALKACT+1
CRALEV18 EQU   CRALKACT+1
CRALEV19 EQU   CRALKACT+1
CRALEV20 EQU   CRALKACT+1
CRALEV21 EQU   CRALKACT+1
CRALEV22 EQU   CRALKACT+1
CRALEV23 EQU   CRALKACT+1
CRALEV24 EQU   CRALKACT+1
CRALEV25 EQU   CRALKACT
CRALEV26 EQU   CRALKACT
CRALEV27 EQU   CRALKACT
CRALEV28 EQU   CRALKACT
CRALEV29 EQU   CRALKACT
CRALEV30 EQU   CRALKACT
CRALEV31 EQU   CRALKACT
CRALEV32 EQU   CRALKACT
@NM00028 EQU   ISTAPCRR+137
@NM00027 EQU   APC57FLG
APCNREL  EQU   APC57FLG
APCRECRA EQU   APC57FLG
@NM00026 EQU   APC54FLG
APCRLST  EQU   APC54FLG
APCPR153 EQU   APC53FLG
@NM00025 EQU   APC52FLG
APCWKF   EQU   APC52FLG
APCNWF   EQU   APC52FLG
APCRDQ   EQU   APC52FLG
APCQENQ  EQU   APC52FLG
APCSMSR  EQU   APC52FLG
APCCKRQ  EQU   APC52FLG
@NM00024 EQU   APC31FLG
APCSORT  EQU   APC31FLG
APCRESCH EQU   APC31FLG
APCTPXIT EQU   APC31FLG
APCSWTWD EQU   ISTAPCRR+128
APCSAV2  EQU   ISTAPCRR+124
APCSAV1  EQU   ISTAPCRR+120
APCRETCD EQU   APCCOMF+2
@NM00023 EQU   APCCOMF1+1
APCZLBER EQU   APCCOMF1
APCEXIT  EQU   APCCOMF1
APCRELR  EQU   APCCOMF1
APCIRB2  EQU   APCCOMF1
APCIRB1  EQU   APCCOMF1
APCSMCR  EQU   APCCOMF1
APCUETSK EQU   APCCOMF1
APCSSTSK EQU   APCCOMF1
APCESTAL EQU   APCSAVE
APCFRRPM EQU   ISTAPCRR+40
APCQWFO  EQU   ISTAPCRR+36
APCPABSV EQU   ISTAPCRR+32
APCRTRN  EQU   ISTAPCRR+28
APCTCBA  EQU   ISTAPCRR+24
APCPSTA  EQU   ISTAPCRR+20
@NM00022 EQU   APCRFLG+1
APC31R   EQU   APCRFLG
APC58R   EQU   APCRFLG
APC57R   EQU   APCRFLG
APC56R   EQU   APCRFLG
APC54R   EQU   APCRFLG
APC53R   EQU   APCRFLG
APC52R   EQU   APCRFLG
APC51R   EQU   APCRFLG
@NM00021 EQU   APCATFLG+1
APC31E   EQU   APCATFLG
APC58E   EQU   APCATFLG
APC57E   EQU   APCATFLG
APC56E   EQU   APCATFLG
APC54E   EQU   APCATFLG
APC53E   EQU   APCATFLG
APC52E   EQU   APCATFLG
APC51E   EQU   APCATFLG
APCHDRSV EQU   ISTAPCRR
ASCPSREG EQU   ISTASCRR+44
ASCUSR01 EQU   ASCUSRGS+12
ASCUSR00 EQU   ASCUSRGS+8
ASCUSR15 EQU   ASCUSRGS+4
ASCUSR14 EQU   ASCUSRGS
ASCETRYA EQU   ISTASCRR+24
ASCKEY   EQU   ISTASCRR+23
ASCAUDIT EQU   ASCFLG3
ASCFBDUD EQU   ASCFLG3
ASCLLKF  EQU   ASCFLG3
ASCKEYF  EQU   ASCFLG3
ASCFBDAL EQU   ASCFLG3
ASCFSRGT EQU   ASCFLG3
ASCICR   EQU   ASCFLG2
ASCFSRIC EQU   ASCFLG2
ASCFBDIC EQU   ASCFLG2
ASCFBAIC EQU   ASCFLG2
ASCPASTR EQU   ASCFLG1
ASCFSR   EQU   ASCFLG1
ASCFBD   EQU   ASCFLG1
ASCFBA   EQU   ASCFLG1
ASCPFCRR EQU   ISTASCRR
CCFRSVD1 EQU   CFCCRT
CCFCR2   EQU   CFCCRT
CCFCRP   EQU   CFCCRT
CCFCR1   EQU   CFCCRT
CCFCS2   EQU   CFCCRT
CCFCS1   EQU   CFCCRT
NCFRSVD  EQU   CFCNTRD
NCFCR2   EQU   CFCNTRD
NCFCRP   EQU   CFCNTRD
NCFCR1   EQU   CFCNTRD
NCFCS2   EQU   CFCNTRD
NCFCS1   EQU   CFCNTRD
PFCRSV01 EQU   ISTPFCRR+13
PFCFTA   EQU   ISTPFCRR+12
CRRFRR   EQU   PFCFRRO
CRRCHAIN EQU   PFCCRRO
CRRLEN   EQU   PFCCRRLN
PFCRSV10 EQU   PFCCRR+1
CRRID    EQU   PFCCRRID
DYPRSV01 EQU   ISTDYPAB+12
DYPTSKID EQU   ISTDYPAB+8
DYPCHAIN EQU   ISTDYPAB+4
DYPFLGS  EQU   ISTDYPAB+2
DYPLNGTH EQU   ISTDYPAB+1
DYPTYPE  EQU   ISTDYPAB
PABNODQ  EQU   PABFLAGS
PABERLOK EQU   PABERRLK
PABSSN   EQU   PABFLAGS
PABDYNAM EQU   PABFLAGS
PABNORPR EQU   PABFLAGS
PABPRIOR EQU   PABFLAGS
PABAPYP  EQU   PABFLAGS
PABOFFST EQU   ISTPAB+8
PABRSV02 EQU   PABCHAIN
PABDELAY EQU   PABCHAIN
PABRUNNG EQU   PABCHAIN
PABRESET EQU   PABCHAIN
PABUNCON EQU   PABCHAIN
PABCDP   EQU   PABCHAIN
PABRESCH EQU   PABCHAIN
PABCHNG  EQU   PABCHAIN
PABRSV01 EQU   PABWEQA
RPHNEXPO EQU   ISTRPH+104
RPHSAV16 EQU   RPHWORK+60
RPHSAV15 EQU   RPHWORK+56
RPHSAV14 EQU   RPHWORK+52
RPHSAV13 EQU   RPHWORK+48
RPHSAV12 EQU   RPHWORK+44
RPHSAV11 EQU   RPHWORK+40
RPHSAV10 EQU   RPHWORK+36
RPHSAVE9 EQU   RPHWORK+32
RPHSAVE8 EQU   RPHWORK+28
RPHSAVE7 EQU   RPHWORK+24
RPHSAVE6 EQU   RPHWORK+20
RPHSAVE5 EQU   RPHWORK+16
RPHSAVE4 EQU   RPHWORK+12
RPHSAVE3 EQU   RPHWORK+8
RPHSAVE2 EQU   RPHWORK+4
RPHSHALF EQU   RPHSAVE1+2
RPHSBIT8 EQU   RPHSBITS
RPHSBIT7 EQU   RPHSBITS
RPHSBIT6 EQU   RPHSBITS
RPHSBIT5 EQU   RPHSBITS
RPHSBIT4 EQU   RPHSBITS
RPHSBIT3 EQU   RPHSBITS
RPHSBIT2 EQU   RPHSBITS
RPHSBIT1 EQU   RPHSBITS
RPHSBYTE EQU   RPHSAVE1
RPHPABFG EQU   RPHPABQA
RPHSRP34 EQU   RPHSRPRM+2
RPHSRP12 EQU   RPHSRPRM
RPHWEGT  EQU   RPHCSPA
RPHRESUM EQU   RPHRESMA+1
RPHRSV01 EQU   RPHWPFLG
RPHPURGE EQU   RPHWPFLG
RPHPT    EQU   RPHWPFLG
RPHRSKEY EQU   RPHWPFLG
RPHDVTA  EQU   ISTRPH+12
RPHTIK   EQU   RPHTSKID+3
@NM00020 EQU   RPHTSKID
RPHRPHAP EQU   RPHRPHA+1
@NM00019 EQU   RPHRPHA
RPHGATE  EQU   RPHRPHA
@NM00018 EQU   RPHFLGB
RPHRLCRA EQU   RPHFLGB
RPHNRSAV EQU   RPHFLGB
RPHPGCMP EQU   RPHFLGB
RPHFBAPS EQU   RPHFLGB
RPHBSSP  EQU   RPHFLGB
RPHLOCK  EQU   RPHFLGB
RPHFNFLG EQU   RPHFSTLC
RPHMLTCP EQU   RPHFLAGS
RPHSMCLR EQU   RPHFLAGS
RPHSMTYP EQU   RPHFLAGS
RPHSMQ   EQU   RPHFLAGS
RPHAUTEX EQU   RPHAPTYP
RPHSPGIN EQU   RPHFLAGS
RPHOGIND EQU   RPHFLAGS
RPHLNGTH EQU   RPHCNTL+1
RPHTYPE  EQU   RPHCNTL
ZCRRU    EQU   ZCRRHRU+3
ZCRRH    EQU   ZCRRHRU
ZCRWORDA EQU   ISTZCRR+477
ZCRCMNRC EQU   ISTZCRR+476
ZCRRSV97 EQU   ZCRENTER+18
ZCREIC2B EQU   ZCRENTER+18
ZCREAC2B EQU   ZCRENTER+18
ZCREDCMF EQU   ZCRENTER+18
ZCREBCIF EQU   ZCRENTER+18
ZCREICSG EQU   ZCRENTER+18
ZCREDCK0 EQU   ZCRENTER+18
ZCRECFY0 EQU   ZCRENTER+17
ZCREKCCB EQU   ZCRENTER+17
ZCREDCNB EQU   ZCRENTER+17
ZCREICOE EQU   ZCRENTER+17
ZCREBCNB EQU   ZCRENTER+17
ZCREBC0L EQU   ZCRENTER+17
ZCREBCAL EQU   ZCRENTER+17
ZCREDCQR EQU   ZCRENTER+17
ZCREDCPR EQU   ZCRENTER+16
ZCREBCSB EQU   ZCRENTER+16
ZCREAC1R EQU   ZCRENTER+16
ZCRECCCI EQU   ZCRENTER+16
ZCRECCAI EQU   ZCRENTER+16
ZCRECCBI EQU   ZCRENTER+16
ZCREBCAR EQU   ZCRENTER+16
ZCREBCDR EQU   ZCRENTER+16
ZCREBCBR EQU   ZCRENTER+15
ZCREDCXR EQU   ZCRENTER+15
ZCREDCWB EQU   ZCRENTER+15
ZCREDCWR EQU   ZCRENTER+15
ZCREKCCN EQU   ZCRENTER+15
ZCREKCBN EQU   ZCRENTER+15
ZCREKCBB EQU   ZCRENTER+15
ZCREJC0B EQU   ZCRENTER+15
ZCREJCDB EQU   ZCRENTER+14
ZCREJCCB EQU   ZCRENTER+14
ZCREJCBB EQU   ZCRENTER+14
ZCREJCAB EQU   ZCRENTER+14
ZCREIC1B EQU   ZCRENTER+14
ZCREIC0B EQU   ZCRENTER+14
ZCREICX0 EQU   ZCRENTER+14
ZCREICWB EQU   ZCRENTER+14
ZCREICVB EQU   ZCRENTER+13
ZCREICUB EQU   ZCRENTER+13
ZCREICTB EQU   ZCRENTER+13
ZCREICSC EQU   ZCRENTER+13
ZCREICSB EQU   ZCRENTER+13
ZCREICRB EQU   ZCRENTER+13
ZCREICQB EQU   ZCRENTER+13
ZCREICQA EQU   ZCRENTER+13
ZCREICOB EQU   ZCRENTER+12
ZCREICOA EQU   ZCRENTER+12
ZCREICNB EQU   ZCRENTER+12
ZCREICNA EQU   ZCRENTER+12
ZCREICMB EQU   ZCRENTER+12
ZCREICLB EQU   ZCRENTER+12
ZCREICKG EQU   ZCRENTER+12
ZCREICKE EQU   ZCRENTER+12
ZCREICKB EQU   ZCRENTER+11
ZCREICJB EQU   ZCRENTER+11
ZCREICID EQU   ZCRENTER+11
ZCREICIB EQU   ZCRENTER+11
ZCREICHB EQU   ZCRENTER+11
ZCREICGB EQU   ZCRENTER+11
ZCREICEB EQU   ZCRENTER+11
ZCREICDB EQU   ZCRENTER+11
ZCREICCI EQU   ZCRENTER+10
ZCREICCB EQU   ZCRENTER+10
ZCREICBI EQU   ZCRENTER+10
ZCREICBB EQU   ZCRENTER+10
ZCREICAB EQU   ZCRENTER+10
ZCREICAA EQU   ZCRENTER+10
ZCREHCAN EQU   ZCRENTER+10
ZCREGC0B EQU   ZCRENTER+10
ZCREGC0A EQU   ZCRENTER+9
ZCREGCLA EQU   ZCRENTER+9
ZCREGCEB EQU   ZCRENTER+9
ZCREGCDB EQU   ZCRENTER+9
@NM00017 EQU   ZCRENTER+9
ZCREGCBB EQU   ZCRENTER+9
ZCREGCAB EQU   ZCRENTER+9
ZCREFCEB EQU   ZCRENTER+9
ZCREFCEA EQU   ZCRENTER+8
ZCREECTA EQU   ZCRENTER+8
ZCREECEA EQU   ZCRENTER+8
ZCREECDA EQU   ZCRENTER+8
ZCREECCB EQU   ZCRENTER+8
ZCREECCA EQU   ZCRENTER+8
ZCREECBB EQU   ZCRENTER+8
ZCREECBA EQU   ZCRENTER+8
ZCREDCMB EQU   ZCRENTER+7
ZCREDCL0 EQU   ZCRENTER+7
ZCREDCKB EQU   ZCRENTER+7
ZCREDCKA EQU   ZCRENTER+7
ZCREDCJ0 EQU   ZCRENTER+7
ZCREDCI0 EQU   ZCRENTER+7
ZCREDCH0 EQU   ZCRENTER+7
ZCREDCF0 EQU   ZCRENTER+7
ZCREDCE0 EQU   ZCRENTER+6
ZCREDCD0 EQU   ZCRENTER+6
ZCREDCC0 EQU   ZCRENTER+6
ZCREDCB0 EQU   ZCRENTER+6
ZCREDCA0 EQU   ZCRENTER+6
ZCRECC2B EQU   ZCRENTER+6
ZCRECC1B EQU   ZCRENTER+6
ZCRECC1A EQU   ZCRENTER+6
ZCRECC0B EQU   ZCRENTER+5
ZCRECC0A EQU   ZCRENTER+5
ZCREBC0B EQU   ZCRENTER+5
ZCREBC0A EQU   ZCRENTER+5
ZCREBCZ0 EQU   ZCRENTER+5
ZCREBCY0 EQU   ZCRENTER+5
ZCREBCX0 EQU   ZCRENTER+5
ZCREBCXA EQU   ZCRENTER+5
ZCREBCSC EQU   ZCRENTER+4
ZCREBCRB EQU   ZCRENTER+4
ZCREBCRA EQU   ZCRENTER+4
ZCREBCQB EQU   ZCRENTER+4
ZCREBCPB EQU   ZCRENTER+4
ZCREBCOB EQU   ZCRENTER+4
ZCREBCNE EQU   ZCRENTER+4
ZCREBCND EQU   ZCRENTER+4
ZCREBCMB EQU   ZCRENTER+3
ZCREBCLB EQU   ZCRENTER+3
ZCREBCLA EQU   ZCRENTER+3
ZCREBCKB EQU   ZCRENTER+3
ZCREBCKA EQU   ZCRENTER+3
ZCREBCJB EQU   ZCRENTER+3
ZCREBCJA EQU   ZCRENTER+3
ZCREBCID EQU   ZCRENTER+3
ZCREBCIB EQU   ZCRENTER+2
ZCREBCIA EQU   ZCRENTER+2
ZCREBCHB EQU   ZCRENTER+2
ZCREBCHA EQU   ZCRENTER+2
ZCREBCGB EQU   ZCRENTER+2
ZCREBCGA EQU   ZCRENTER+2
ZCREBCFB EQU   ZCRENTER+2
ZCREBCFA EQU   ZCRENTER+2
ZCREBCEB EQU   ZCRENTER+1
ZCREBCDI EQU   ZCRENTER+1
ZCREBCCB EQU   ZCRENTER+1
ZCREBCBI EQU   ZCRENTER+1
ZCREBCBB EQU   ZCRENTER+1
ZCREBCBA EQU   ZCRENTER+1
ZCREBCAM EQU   ZCRENTER+1
ZCREBCAI EQU   ZCRENTER+1
ZCREBCAG EQU   ZCRENTER
ZCREBCAE EQU   ZCRENTER
ZCREBCAB EQU   ZCRENTER
ZCREBCAA EQU   ZCRENTER
ZCREAC1B EQU   ZCRENTER
ZCREAC0B EQU   ZCRENTER
ZCREAC0A EQU   ZCRENTER
ZCREAC1A EQU   ZCRENTER
ZCRREMIC EQU   ISTZCRR+436
ZCRDAFSV EQU   ZCRCIDSV+2
ZCRSAFSV EQU   ZCRCIDSV
ZCRR13SV EQU   ISTZCRR+188
ZCRR2SV  EQU   ISTZCRR+184
ZCROPCDE EQU   ISTZCRR+183
ZCRPRMTC EQU   ISTZCRR+182
ZCRRCDSV EQU   ISTZCRR+181
ZCRAWQSW EQU   ISTZCRR+180
ZCRTOPQ  EQU   ISTZCRR+180
ZCRLSTFB EQU   ISTZCRR+180
ZCRXSCHD EQU   ISTZCRR+180
ZCRNXTEL EQU   ISTZCRR+180
ZCRSCANQ EQU   ISTZCRR+180
ZCRMOREL EQU   ISTZCRR+180
ZCRFBPRC EQU   ISTZCRR+180
ZCRFSBSV EQU   ISTZCRR+176
ZCRSVWK4 EQU   ZCRWKARA+12
ZCRSVWK3 EQU   ZCRWKARA+8
ZCRSVWK2 EQU   ZCRWKARA+4
ZCRSVWK1 EQU   ZCRWKARA
ZCRSVF25 EQU   ZCRSVRTN+96
ZCRSVF24 EQU   ZCRSVRTN+92
ZCRSVF23 EQU   ZCRSVRTN+88
ZCRSVF22 EQU   ZCRSVRTN+84
ZCRSVF21 EQU   ZCRSVRTN+80
ZCRSVF20 EQU   ZCRSVRTN+76
ZCRSVF19 EQU   ZCRSVRTN+72
ZCRSVF18 EQU   ZCRSVRTN+68
ZCRSVF17 EQU   ZCRSVRTN+64
ZCRSVF16 EQU   ZCRSVRTN+60
ZCRSVF15 EQU   ZCRSVRTN+56
ZCRSVF14 EQU   ZCRSVRTN+52
ZCRSVF13 EQU   ZCRSVRTN+48
ZCRSVF12 EQU   ZCRSVRTN+44
ZCRSVF11 EQU   ZCRSVRTN+40
ZCRSVF10 EQU   ZCRSVRTN+36
ZCRSVF9  EQU   ZCRSVRTN+32
ZCRSVF8  EQU   ZCRSVRTN+28
ZCRSVF7  EQU   ZCRSVRTN+24
ZCRSVF6  EQU   ZCRSVRTN+20
ZCRSVF5  EQU   ZCRSVRTN+16
ZCRPVZB  EQU   ISTZCRR+52
ZCRZLB   EQU   ISTZCRR+48
ZCRBFPTR EQU   ISTZCRR+44
ZCRCCWA  EQU   ISTZCRR+40
ZCRPSW   EQU   ZCRPARMS+15
ZCRPCHAR EQU   ZCRPARMS+14
ZCRPRES2 EQU   ZCRPCOD2
ZCRPMFGF EQU   ZCRPCOD2
ZCRPFHDR EQU   ZCRPCOD2
ZCRPPG2  EQU   ZCRPCOD2
ZCRPRES  EQU   ZCRPCOD1
ZCRPCFTX EQU   ZCRPCOD1
ZCRPBUF  EQU   ZCRPCOD1
ZCRPLSCB EQU   ZCRPCOD1
ZCRPLNG  EQU   ZCRPCOD1
ZCRPPG   EQU   ZCRPCOD1
ZCRDTODA EQU   ZCRDFRDA
ZCRMLNG  EQU   ZCRPARMS+8
ZCRTBPTR EQU   ZCRPARMS+4
ZCRCBPTR EQU   ZCRFBPTR
ZCRCRLCP EQU   ISTZCRR+20
@NM00016 EQU   ZCRSCPSW
ZCRSKIPT EQU   ZCRSCPSW
ZCRFSBWE EQU   ZCRSCPSW
ZCRPRCMP EQU   ZCRSCPSW
ZCRLREQ  EQU   ZCRSCPSW
ZCRRJLCP EQU   ZCRSCPSW
ZCRTPINV EQU   ZCRSCPSW
ZCRTPEX  EQU   ZCRSCPSW
@NM00015 EQU   ZCRIBPR
ZCR3270R EQU   ZCRIBPR
ZCR3270  EQU   ZCRIBPR
ZCRLCPFD EQU   ZCRIBPR
ZCRLCPFR EQU   ZCRIBPR
ZCRRELK  EQU   ZCRIBPR
ZCRERR   EQU   ZCRIBPR
ZCRNOBUF EQU   ZCRIBPR
@NM00014 EQU   ZCRPFLGS
ZCRQAHED EQU   ZCRPFLGS
ZCRF1RES EQU   ZCRGENSW
ZCRBRIS  EQU   ZCRGENSW
ZCRCLRBD EQU   ZCRGENSW
ZCREXRES EQU   ZCRGENSW
ZCRLCSYN EQU   ZCRGENSW
ZCRRT06  EQU   ZCRGENSW
ZCRINLCP EQU   ZCRFLGS3
ZCRWRPTR EQU   ZCRFLGS3
ZCRNOFRE EQU   ZCRFLGS3
ZCREDRIV EQU   ZCRFLGS3
ZCRDISC  EQU   ZCRFLGS3
ZCRTPDIS EQU   ZCRFLGS3
ZCRTPCON EQU   ZCRFLGS3
ZCRTIC   EQU   ZCRFLGS3
ZCRCNLXL EQU   ZCRRESET
ZCRENDAN EQU   ZCRSWFLD
ZCRENDXL EQU   ZCRSWFLD
ZCRENDX  EQU   ZCRSWFLD
ZCROB1   EQU   ZCRNDLCP
ZCRENDPR EQU   ZCRSWFLD
ZCREXTYP EQU   ZCRSWFLD
ZCRSLCP  EQU   ZCRENDSH
ZCRIF0E3 EQU   ZCRFLGS2
ZCRIF0E2 EQU   ZCRFLGS2
ZCRIF0E1 EQU   ZCRFLGS2
ZCROB    EQU   ZCRFLGS2
ZCRFMSED EQU   ZCRFLGS2
ZCRSHEDI EQU   ZCRFLGS2
ZCRLOCAL EQU   ZCRFLGS2
ZCRFEXIT EQU   ZCRFLGS1
ZCRUNSOL EQU   ZCRFLGS1
ZCRENDLP EQU   ZCRFLGS1
ZCRNRMEX EQU   ZCRFLGS1
ZCRWAIT  EQU   ZCRFLGS1
ZCRDEQSW EQU   ZCRFLGS1
ZCRQUESW EQU   ZCRFLGS1
ZCREXSW  EQU   ZCRFLGS1
ZCRFLAG  EQU   ZCRCRR+3
LCPFTYPE EQU   LCPRPHA
LCPRSTQH EQU   LCPLCCW
LCPCLREP EQU   ISTLCPB+44
LCPUBFSB EQU   LCPFLCCW
LCPRSV77 EQU   ISTLCPB+39
LCPLCCWC EQU   ISTLCPB+38
LCPRSV78 EQU   LCPFLG1
LCPTRANS EQU   LCPFLG1
LCPSTLB  EQU   LCPFLG1
LCPREDRV EQU   LCPFLG1
LCPDIRPT EQU   LCPFLG1
LCPINTER EQU   LCPFLG1
LCPRESET EQU   LCPFLG1
LCPSTYPE EQU   ISTLCPB+36
LCPFSNCH EQU   ISTLCPB+34
LCPFOSN  EQU   ISTLCPB+32
LCPTLBAD EQU   ISTLCPB+28
LCPFDB2  EQU   LCPFDBA+1
LCPFDB1  EQU   LCPFDBA
LCPLCCW1 EQU   ISTLCPB+12
LCPRRCNT EQU   LCPSEQ+1
LCPRRCCT EQU   LCPSEQ
LCPATOP  EQU   LCPFLAG2
LCPFREE  EQU   LCPFLAG2
LCPDSTAT EQU   LCPFLAG2
LCPEXRES EQU   LCPFID0
LCPZRIMM EQU   LCPTLBPI
LCPASYN  EQU   LCPFLAG2
LCPPRFLG EQU   LCPFLAG2
LCPZMIRC EQU   LCPRUCNT
LCPCHAI2 EQU   LCPCHAIN+1
LCPCHNG  EQU   LCPCHAI1
LCPZRT0B EQU   LCPMNRCD
LCPZRT0A EQU   LCPMNRCD
LCPZRTL9 EQU   LCPZRT09
LCPZRTL8 EQU   LCPZRT08
LCPZRTL7 EQU   LCPZRT07
LCPZRTL6 EQU   LCPZRT06
LCPZRTL5 EQU   LCPZRT05
LCPZRTL4 EQU   LCPZRT04
LCPZRTL3 EQU   LCPZRT03
LCPZRTL2 EQU   LCPZRT02
LCPZRT01 EQU   LCPFLAGS
LCPLNGTH EQU   ISTLCPB+1
LCCWCNT  EQU   ISTLCCW+2
LCCWACI  EQU   LCCWFLAG
LCCWRFI  EQU   LCCWFLAG
LCCWPER  EQU   LCCWLSI
LCCWIDAT EQU   LCCWFLAG
LCCWNTVC EQU   LCCWFLAG
LCCWCKPT EQU   LCCWFLAG
LCCWCC   EQU   LCCWFLAG
LCCWCD   EQU   LCCWFLAG
LCCWTYPE EQU   LCCWCTL
LCCWMODE EQU   LCCWCTL
LCCWSOP  EQU   LCCWRWOP
@NM00013 EQU   LCCWRWOP
LCCWSD   EQU   LCCWOP
LCCWSI   EQU   LCCWOP
ZSAZTRAC EQU   ISTZSAVE+36
ZSAZSVVR EQU   ISTZSAVE+12
ZSAZSVRR EQU   ISTZSAVE+8
ZSAZACTV EQU   ZSAZSVMS
ZFSZWRD4 EQU   ISTZFSVT+36
ZFSZWRD3 EQU   ISTZFSVT+32
ZFSZEFCB EQU   ISTZFSVT+28
ZFSZFFEB EQU   ISTZFSVT+24
ZFSZDFJ0 EQU   ISTZFSVT+20
ZFSZFFFB EQU   ISTZFSVT+16
ZFSZFFDB EQU   ISTZFSVT+12
ZFSZFFCB EQU   ISTZFSVT+8
ZFSZEMAB EQU   ZFSZEAAB
ZFSZEMBB EQU   ZFSZEABB
ZPSZDFQR EQU   ISTZPSVT+80
ZPSZDFPR EQU   ISTZPSVT+76
ZPSZDFXR EQU   ISTZPSVT+72
ZPSZWRD5 EQU   ISTZPSVT+68
ZPSZWRD4 EQU   ISTZPSVT+64
ZPSZDFMB EQU   ISTZPSVT+60
ZPSZDFMF EQU   ISTZPSVT+56
ZPSZDFNB EQU   ISTZPSVT+52
@NM00012 EQU   ISTZPSVT+48
ZPSZDFF0 EQU   ISTZPSVT+44
ZPSZTRTT EQU   ISTZPSVT+40
ZPSZBFOB EQU   ISTZPSVT+36
ZPSZBFMB EQU   ISTZPSVT+32
ZPSZBFZ0 EQU   ISTZPSVT+28
ZPSZBFY0 EQU   ISTZPSVT+24
ZPSZDFI0 EQU   ISTZPSVT+20
ZPSZDFH0 EQU   ISTZPSVT+12
ZPSZDFD0 EQU   ISTZPSVT+8
ZPSZDFC0 EQU   ISTZPSVT+4
CVTLEVL  EQU   CVTRELNO+2
CVTNUMB  EQU   CVTRELNO
CVTMDL   EQU   CVTFIX+250
@NM00011 EQU   CVTFIX+248
@NM00010 EQU   CVTFIX
CVTRV482 EQU   CVTXTNT2+128
CVTRV481 EQU   CVTXTNT2+124
CVTRV480 EQU   CVTXTNT2+120
CVTRV479 EQU   CVTXTNT2+118
CVTRV478 EQU   CVTXTNT2+117
CVTRV477 EQU   CVTXTNT2+116
CVTRV476 EQU   CVTXTNT2+115
CVTRV475 EQU   CVTXTNT2+114
CVTRV474 EQU   CVTRV466
CVTRV473 EQU   CVTRV466
CVTRV472 EQU   CVTRV466
CVTRV471 EQU   CVTRV466
CVTRV470 EQU   CVTRV466
CVTRV469 EQU   CVTRV466
CVTRV468 EQU   CVTRV466
CVTRV467 EQU   CVTRV466
CVTRV465 EQU   CVTRV457
CVTRV464 EQU   CVTRV457
CVTRV463 EQU   CVTRV457
CVTRV462 EQU   CVTRV457
CVTRV461 EQU   CVTRV457
CVTRV460 EQU   CVTRV457
CVTRV459 EQU   CVTRV457
CVTRV458 EQU   CVTRV457
CVTRV456 EQU   CVTXTNT2+108
CVTRV455 EQU   CVTXTNT2+104
CVTRV454 EQU   CVTXTNT2+100
CVTRV453 EQU   CVTXTNT2+96
CVTRV452 EQU   CVTXTNT2+94
CVTRV451 EQU   CVTXTNT2+92
CVTRV450 EQU   CVTXTNT2+90
CVTRV449 EQU   CVTXTNT2+88
CVTRV448 EQU   CVTXTNT2+87
CVTRV447 EQU   CVTXTNT2+86
CVTRV446 EQU   CVTRV438
CVTRV445 EQU   CVTRV438
CVTRV444 EQU   CVTRV438
CVTRV443 EQU   CVTRV438
CVTRV442 EQU   CVTRV438
CVTRV441 EQU   CVTRV438
CVTRV440 EQU   CVTRV438
CVTRV439 EQU   CVTRV438
CVTRV437 EQU   CVTRV429
CVTRV436 EQU   CVTRV429
CVTRV435 EQU   CVTRV429
CVTRV434 EQU   CVTRV429
CVTRV433 EQU   CVTRV429
CVTRV432 EQU   CVTRV429
CVTRV431 EQU   CVTRV429
CVTRV430 EQU   CVTRV429
CVTRV428 EQU   CVTXTNT2+80
CVTRV427 EQU   CVTXTNT2+76
CVTRV426 EQU   CVTXTNT2+72
CVTRV425 EQU   CVTXTNT2+68
CVTATACT EQU   CVTATCVT
CVTRV423 EQU   CVTXTNT2+62
CVTRV422 EQU   CVTXTNT2+60
CVTRV421 EQU   CVTXTNT2+58
CVTRV420 EQU   CVTXTNT2+56
CVTRV419 EQU   CVTXTNT2+55
CVTRV418 EQU   CVTXTNT2+54
CVTRV417 EQU   CVTRV409
CVTRV416 EQU   CVTRV409
CVTRV415 EQU   CVTRV409
CVTRV414 EQU   CVTRV409
CVTRV413 EQU   CVTRV409
CVTRV412 EQU   CVTRV409
CVTRV411 EQU   CVTRV409
CVTRV410 EQU   CVTRV409
CVTRV408 EQU   CVTRV400
CVTRV407 EQU   CVTRV400
CVTRV406 EQU   CVTRV400
CVTRV405 EQU   CVTRV400
CVTRV404 EQU   CVTRV400
CVTRV403 EQU   CVTRV400
CVTRV402 EQU   CVTRV400
CVTRV401 EQU   CVTRV400
CVTICB   EQU   CVTXTNT2+48
CVTSKTA  EQU   CVTXTNT2+44
CVTSHSB  EQU   CVTSHS
CVTRSV98 EQU   CVTXTNT2+36
CVTRSV97 EQU   CVTXTNT2+34
CVTRSV96 EQU   CVTXTNT2+32
CVTOLTEP EQU   CVTXTNT2+28
CVTQIDA  EQU   CVTQID+1
CVTRSV95 EQU   CVTQID
CVTRSV94 EQU   CVTXTNT2+20
CVTRSV93 EQU   CVTXTNT2+16
CVTRSV92 EQU   CVTXTNT2+12
CVTDEBVR EQU   CVTXTNT2+8
CVTRSV91 EQU   CVTXTNT2+6
CVTRSV9H EQU   CVTFLGBT
CVTRSV9G EQU   CVTFLGBT
CVTRSV9F EQU   CVTFLGBT
CVTRSV9E EQU   CVTFLGBT
CVTRSV9D EQU   CVTFLGBT
CVTRSV9C EQU   CVTFLGBT
CVTVME   EQU   CVTFLGBT
CVTNPE   EQU   CVTFLGBT
CVTNUCLS EQU   CVTXTNT2+4
CVTDSSVA EQU   CVTDSSV+1
CVTRSV89 EQU   CVTDSSV
CVTRSV88 EQU   CVTXTNT1+8
CVTRSV87 EQU   CVTXTNT1+4
CVTFACHN EQU   CVTXTNT1
CVTRV488 EQU   CVTMAP+412
CVTRV487 EQU   CVTMAP+408
CVTRV486 EQU   CVTMAP+404
CVTRV485 EQU   CVTMAP+400
CVTACTAP EQU   CVTMAP+396
CVTAUTH  EQU   CVTMAP+392
CVTATMCA EQU   CVTATMCT+1
CVTATMST EQU   CVTATMCT
CVTRSV61 EQU   CVTMAP+384
CVTVOLT1 EQU   CVTVOLM1+1
CVTVOLI1 EQU   CVTVOLF1
CVTSTOA  EQU   CVTMAP+376
CVTRSV58 EQU   CVTMAP+374
CVTRSV57 EQU   CVTMAP+372
CVTDDCE  EQU   CVTMAP+368
CVTPNWFR EQU   CVTMAP+364
CVTSMF   EQU   CVTMAP+360
CVTSULK  EQU   CVTMAP+358
CVTSLKO  EQU   CVTSYSK
CVTSLKP  EQU   CVTSYSK
CVTSLKQ  EQU   CVTSYSK
CVTSLKR  EQU   CVTSYSK
CVTRSV56 EQU   CVTSYSK
CVTRSV55 EQU   CVTSYSK
CVTRSV54 EQU   CVTSYSK
CVTRSV53 EQU   CVTSYSK
CVTRSV52 EQU   CVTA1F1
CVTRSV51 EQU   CVTA1F1
CVTRSV50 EQU   CVTA1F1
CVTRSV49 EQU   CVTA1F1
CVTRSV48 EQU   CVTA1F1
CVTRSV47 EQU   CVTA1F1
CVTSRSW  EQU   CVTA1F1
CVTPFSW  EQU   CVTA1F1
CVTPCVT  EQU   CVTMAP+352
CVTRSV46 EQU   CVTMAP+344
CVTRSV45 EQU   CVTMAP+340
CVTRSV44 EQU   CVTMAP+338
CVTRSV43 EQU   CVTMAP+336
CVTHJESA EQU   CVTHJES+1
CVTRSV42 EQU   CVTHJES
CVTEXT2A EQU   CVTEXT2+1
CVTRSV41 EQU   CVTEXT2
CVTAPFA  EQU   CVTAPF+1
CVTRSV40 EQU   CVTAPF
CVTRV518 EQU   CVTINTLA
CVTRV517 EQU   CVTERPV
CVTEORM  EQU   CVTMAP+312
CVTMCHPR EQU   CVTMAP+308
CVTTZ    EQU   CVTMAP+304
CVTJEPS  EQU   CVTMAP+300
CVTJESCT EQU   CVTMAP+296
CVTMODE  EQU   CVTMAP+292
CVTPTRV  EQU   CVTMAP+288
CVTREAL  EQU   CVTMAP+284
CVTRSV39 EQU   CVTMAP+280
CVTRSV38 EQU   CVTMAP+276
CVTDMSRA EQU   CVTDMSR+1
CVTRV634 EQU   CVTDMSRF
CVTRV633 EQU   CVTDMSRF
CVTRV632 EQU   CVTDMSRF
CVTRV631 EQU   CVTDMSRF
CVTRV630 EQU   CVTDMSRF
CVTRV629 EQU   CVTDMSRF
CVTUDUMP EQU   CVTDMSRF
CVTSDUMP EQU   CVTDMSRF
CVTQMSGA EQU   CVTQMSG+1
CVTRSV36 EQU   CVTQMSG
CVTAMFF  EQU   CVTMAP+264
CVTPURGA EQU   CVTPURG+1
CVTRSV35 EQU   CVTPURG
CVTCBSP  EQU   CVTMAP+256
CVTATERA EQU   CVTATER+1
CVTSYST  EQU   CVTATER
CVTVOLT2 EQU   CVTTAT
CVTVOLI2 EQU   CVTVOLF2
CVTAQAVB EQU   CVTAQAVT+1
CVTRSV34 EQU   CVTTCMFG
CVTRSV33 EQU   CVTTCMFG
CVTRSV32 EQU   CVTTCMFG
CVTRSV31 EQU   CVTTCMFG
CVTRSV30 EQU   CVTTCMFG
CVTRSV29 EQU   CVTTCMFG
CVTRSV28 EQU   CVTTCMFG
CVTTCRDY EQU   CVTTCMFG
CVTGTFA  EQU   CVTGTF+1
CVTRSV27 EQU   CVTGTFST
CVTRNIO  EQU   CVTGTFST
CVTUSR   EQU   CVTGTFST
CVTRV318 EQU   CVTFORM
CVTRV317 EQU   CVTTMODE
CVTRV316 EQU   CVTSTATE
CVTRV315 EQU   CVTGTFS
CVTGTFAV EQU   CVTGTFS
CVT0SCR1 EQU   CVTMAP+232
CVTRV515 EQU   CVTMAP+228
CVTRMS   EQU   CVTMAP+224
CVTPATCH EQU   CVTMAP+220
CVTTSCE  EQU   CVTMAP+216
CVTLNKSC EQU   CVTMAP+214
CVTQABST EQU   CVTMAP+212
CVTMDLDS EQU   CVTMAP+208
CVTUSER  EQU   CVTMAP+204
CVTABEND EQU   CVTMAP+200
CVTSMCA  EQU   CVTMAP+196
CVTRSV18 EQU   CVTMAP+192
CVTQLPAQ EQU   CVTMAP+188
CVTQCDSR EQU   CVTMAP+184
CVTRSV17 EQU   CVTOPTB
CVTRSV16 EQU   CVTOPTB
CVTFP    EQU   CVTOPTB
CVTAPTHR EQU   CVTOPTB
CVTNLOG  EQU   CVTOPTB
CVTTOD   EQU   CVTOPTB
CVTCTIMS EQU   CVTOPTB
CVTPROT  EQU   CVTOPTB
CVTXPFP  EQU   CVTOPTA
CVTASCII EQU   CVTOPTA
CVTRSV13 EQU   CVTOPTA
CVTRSV12 EQU   CVTOPTA
CVTNIP   EQU   CVTOPTA
CVTDDR   EQU   CVTOPTA
CVTAPR   EQU   CVTOPTA
CVTCCH   EQU   CVTOPTA
CVTSNCTR EQU   CVTMAP+180
CVTQMWR  EQU   CVTMAP+176
CVTQOCR  EQU   CVTMAP+172
CVT1EF00 EQU   CVTMAP+168
CVTMZ00  EQU   CVTMAP+164
CVTHEAD  EQU   CVTMAP+160
CVTRSV11 EQU   CVTMAP+156
CVT0PT01 EQU   CVTMAP+152
CVTMSER  EQU   CVTMAP+148
CVTRV516 EQU   CVTIERLC
CVTILCH  EQU   CVTMAP+140
CVT0DS   EQU   CVTMAP+136
CVTFBOSV EQU   CVTMAP+132
CVTNUCB  EQU   CVTMAP+128
CVTIXAVL EQU   CVTMAP+124
CVTIOQET EQU   CVTMAP+120
CVTDCBA  EQU   CVTMAP+117
CVTMVS2  EQU   CVTDCB
CVT6DAT  EQU   CVTDCB
CVT4MPS  EQU   CVTDCB
CVTRSV09 EQU   CVTDCB
CVT4MS1  EQU   CVTDCB
CVT2SPS  EQU   CVTDCB
CVT1SSS  EQU   CVTDCB
CVTRSV08 EQU   CVTDCB
CVTSTB   EQU   CVTMAP+112
CVTQTD00 EQU   CVTMAP+108
CVTQTE00 EQU   CVTMAP+104
CVTCUCB  EQU   CVTMAP+100
CVTSJQ   EQU   CVTMAP+96
CVTPBLDL EQU   CVTMAP+92
CVTTPC   EQU   CVTMAP+88
CVTSVDCB EQU   CVTMAP+84
CVTBRET  EQU   CVTMAP+82
CVTEXIT  EQU   CVTMAP+80
CVT0FN00 EQU   CVTMAP+76
CVTDARA  EQU   CVTDAR+1
CVTRSV07 EQU   CVTFLGS1
CVTRSV06 EQU   CVTFLGS1
CVTRSV05 EQU   CVTFLGS1
CVTRSV04 EQU   CVTFLGS1
CVTRSV03 EQU   CVTFLGS1
CVTRSV02 EQU   CVTFLGS1
CVTRSV01 EQU   CVTFLGS1
CVTDMPLK EQU   CVTFLGS1
CVTXITP  EQU   CVTMAP+68
CVTZDTAB EQU   CVTMAP+64
CVTMSLT  EQU   CVTMAP+60
CVTDATE  EQU   CVTMAP+56
CVTBTERM EQU   CVTMAP+52
CVTSYSAD EQU   CVTMAP+48
CVTXTLER EQU   CVTMAP+44
CVTILK2  EQU   CVTMAP+40
CVTILK1  EQU   CVTMAP+36
CVTPRLTV EQU   CVTMAP+32
CVTPCNVT EQU   CVTMAP+28
CVT0VL00 EQU   CVTMAP+24
CVTXAPG  EQU   CVTMAP+20
CVTBUF   EQU   CVTMAP+16
CVTJOB   EQU   CVTMAP+12
CVTLINK  EQU   CVTMAP+8
CVT0EF00 EQU   CVTMAP+4
CVTTCBP  EQU   CVTMAP
CVT      EQU   CVTMAP
@NM00009 EQU   SRBSECT+40
@NM00008 EQU   SRBSECT+38
SRBPRIOR EQU   SRBSECT+37
SRBPKF   EQU   SRBSECT+36
SRBSAVE  EQU   SRBSECT+32
SRBPARM  EQU   SRBSECT+28
SRBRMTR  EQU   SRBSECT+24
SRBEP    EQU   SRBSECT+20
SRBPTCB  EQU   SRBFLC+4
SRBPASID EQU   SRBFLC+2
SRBCPAFF EQU   SRBFLC
SRBASCB  EQU   SRBSECT+8
SRBFLNK  EQU   SRBSECT+4
SRBID    EQU   SRBSECT
IOSEND   EQU   IOSB+108
IOSSKR   EQU   IOSEEKA+7
IOSSKH2  EQU   IOSSKHH+1
IOSSKH1  EQU   IOSSKHH
IOSSKCC  EQU   IOSCCHH
IOSSKBB  EQU   IOSEEKA+1
IOSSKM   EQU   IOSEEKA
IOSEEK   EQU   IOSB+92
IOSMDM   EQU   IOSB+91
IOSMDB   EQU   IOSB+90
IOSCKEY7 EQU   IOSCKEY
IOSCKEY6 EQU   IOSCKEY
IOSCKEY5 EQU   IOSCKEY
IOSCKEY4 EQU   IOSCKEY
@NM00004 EQU   IOSCKEY
IOSFMSK  EQU   IOSB+88
IOSCUDEV EQU   IOSPATH+1
@NM00003 EQU   IOSCHN
IOSPATH3 EQU   IOSCHN
IOSPATH2 EQU   IOSCHN
IOSEXP   EQU   IOSCHN
IOSGDP   EQU   IOSCHN
IOSAFF   EQU   IOSB+85
IOSRSS1B EQU   IOSB+84
IOSDSID  EQU   IOSB+80
IOSVST   EQU   IOSB+76
IOSRST   EQU   IOSB+72
IOSDIE   EQU   IOSB+68
IOSABN   EQU   IOSB+64
IOSNRM   EQU   IOSB+60
IOSPCI   EQU   IOSB+56
IOSERP   EQU   IOSB+52
IOSPCHN  EQU   IOSB+48
IOSSNS   EQU   IOSB+42
IOSAPMSK EQU   IOSB+40
IOSRES4A EQU   IOSB+36
IOSUSE   EQU   IOSB+32
IOSSRB   EQU   IOSB+28
IOSCSWRC EQU   IOSCSW+5
IOSTSB   EQU   IOSTATUS+1
IOSTSA   EQU   IOSTATUS
IOSCSWCA EQU   IOSCSW
IOSCC    EQU   @NM00002
IOSUCB   EQU   IOSB+16
IOSOPT2X EQU   IOSOPT2
IOSHTP   EQU   IOSOPT2
IOSRELSE EQU   IOSOPT
IOSAPR   EQU   IOSOPT
IOSTSLL  EQU   IOSOPT
IOSNERP  EQU   IOSOPT
IOSPSLL  EQU   IOSOPT
IOSQISCE EQU   IOSOPT
IOSDEP   EQU   IOSOPT
IOSBYP   EQU   IOSOPT
IOSCOD   EQU   IOSB+13
IOSPKY7  EQU   IOSPKEY
IOSPGDPX EQU   IOSPKEY
IOSIDR   EQU   IOSPKEY
IOSLCL   EQU   IOSPKEY
@NM00001 EQU   IOSPKEY
IOSPGAD  EQU   IOSB+8
IOSASID  EQU   IOSB+6
IOSPRLVL EQU   IOSB+5
IOSDVRID EQU   IOSB+4
IOSPROC  EQU   IOSB+3
IOSFLC7  EQU   IOSFLC
IOSFLC6  EQU   IOSFLC
IOSRWAIT EQU   IOSFLC
IOSTP    EQU   IOSFLC
IOSCC3WE EQU   IOSFLC
IOSVERIF EQU   IOSDVALT
IOSDVMNT EQU   IOSFLC
IOSLOG   EQU   IOSFLB
IOSBDCST EQU   IOSFLB
IOSMSG   EQU   IOSFLB
IOSFLB4  EQU   IOSFLB
IOSFLB3  EQU   IOSFLB
IOSFLB2  EQU   IOSFLB
IOSSDR   EQU   IOSFLB
IOSDIESE EQU   IOSFLB
IOSIOSB  EQU   IOSFLA
IOSDOM   EQU   IOSFLA
IOSEX    EQU   IOSFLA
IOSSMDB  EQU   IOSFLA
IOSSMDA  EQU   IOSFLA
IOSERR   EQU   IOSFLA
IOSCCHN  EQU   IOSACHN
IOSDCHN  EQU   IOSACHN
.@UNREFD ANOP                          END UNREFERENCED COMPONENTS
@RC00903 EQU   @RC00897
@RC00962 EQU   @RC00958
@RT01008 EQU   ISTA0043
@PB00002 EQU   @PB00003
@RT01191 EQU   #DC00093
@RT01204 EQU   #DC00097
@PB00005 EQU   @PB00006
LOCLRTN# EQU   @RC01352
@RC01365 EQU   @RC01357
@RC01392 EQU   @RC01379
@RC01468 EQU   @RC01464
@RC01482 EQU   @RC01479
@RC01653 EQU   @RC01652
DNCBPRC@ EQU   @EL00008
@RT01730 EQU   ISTA0164
@PB00009 EQU   @PB00010
@RC00908 EQU   @RC00903
@PB00004 EQU   @PB00005
@PB00008 EQU   @PB00009
BUFFSEG@ EQU   @PB00004
@PB00007 EQU   @PB00008
WAITQSG@ EQU   @PB00007
@ENDDATA EQU   *
         END   ISTZLFAB,(C'PLS1022',0603,78110)
